!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_CO2CLIM


!**   CARBON DIOXIDE FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_CO2CLIM* FROM *SUECRAD*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG1

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLCO2(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG1(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG1(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLCO2(:,:,:)=ZGHG1(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG1(:, 1, 1) = (/ &
  & 0.36381913E-03_JPRB, 0.36372303E-03_JPRB, 0.36353589E-03_JPRB, 0.36335381E-03_JPRB, 0.36316903E-03_JPRB, 0.36298469E-03_JPRB, &
  & 0.36281801E-03_JPRB, 0.36263795E-03_JPRB, 0.36247238E-03_JPRB, 0.36232919E-03_JPRB, 0.36221457E-03_JPRB, 0.36213413E-03_JPRB, &
  & 0.36209155E-03_JPRB, 0.36208364E-03_JPRB, 0.36210503E-03_JPRB, 0.36214656E-03_JPRB, 0.36219665E-03_JPRB, 0.36224350E-03_JPRB, &
  & 0.36227566E-03_JPRB, 0.36228544E-03_JPRB, 0.36226999E-03_JPRB, 0.36223291E-03_JPRB, 0.36218148E-03_JPRB, 0.36212167E-03_JPRB, &
  & 0.36205671E-03_JPRB, 0.36198774E-03_JPRB, 0.36190683E-03_JPRB, 0.36180668E-03_JPRB, 0.36169818E-03_JPRB, 0.36158485E-03_JPRB, &
  & 0.36146975E-03_JPRB, 0.36135447E-03_JPRB, 0.36124079E-03_JPRB, 0.36113113E-03_JPRB, 0.36102833E-03_JPRB, 0.36093569E-03_JPRB, &
  & 0.36085767E-03_JPRB, 0.36079658E-03_JPRB, 0.36075403E-03_JPRB, 0.36073153E-03_JPRB, 0.36072131E-03_JPRB, 0.36071357E-03_JPRB, &
  & 0.36069957E-03_JPRB, 0.36067312E-03_JPRB, 0.36062888E-03_JPRB, 0.36056095E-03_JPRB, 0.36046497E-03_JPRB, 0.36034055E-03_JPRB, &
  & 0.36019349E-03_JPRB, 0.36003627E-03_JPRB, 0.35988441E-03_JPRB, 0.35975222E-03_JPRB, 0.35964994E-03_JPRB, 0.35958167E-03_JPRB, &
  & 0.35954453E-03_JPRB, 0.35953001E-03_JPRB, 0.35952849E-03_JPRB, 0.35953274E-03_JPRB, 0.35953900E-03_JPRB, 0.35954523E-03_JPRB, &
  & 0.35955140E-03_JPRB, 0.35955856E-03_JPRB, 0.35956613E-03_JPRB, 0.35957369E-03_JPRB /)

RGHG1(:, 2, 1) = (/ &
  & 0.36406869E-03_JPRB, 0.36400493E-03_JPRB, 0.36393883E-03_JPRB, 0.36387521E-03_JPRB, 0.36381028E-03_JPRB, 0.36374573E-03_JPRB, &
  & 0.36368240E-03_JPRB, 0.36362259E-03_JPRB, 0.36357006E-03_JPRB, 0.36352911E-03_JPRB, 0.36350399E-03_JPRB, 0.36349849E-03_JPRB, &
  & 0.36351517E-03_JPRB, 0.36355242E-03_JPRB, 0.36360335E-03_JPRB, 0.36365987E-03_JPRB, 0.36371217E-03_JPRB, 0.36375161E-03_JPRB, &
  & 0.36377116E-03_JPRB, 0.36376747E-03_JPRB, 0.36374090E-03_JPRB, 0.36369590E-03_JPRB, 0.36363810E-03_JPRB, 0.36357148E-03_JPRB, &
  & 0.36349767E-03_JPRB, 0.36341586E-03_JPRB, 0.36332291E-03_JPRB, 0.36321874E-03_JPRB, 0.36310893E-03_JPRB, 0.36299884E-03_JPRB, &
  & 0.36289057E-03_JPRB, 0.36278425E-03_JPRB, 0.36267948E-03_JPRB, 0.36257727E-03_JPRB, 0.36248009E-03_JPRB, 0.36239234E-03_JPRB, &
  & 0.36231952E-03_JPRB, 0.36226664E-03_JPRB, 0.36223754E-03_JPRB, 0.36222916E-03_JPRB, 0.36222895E-03_JPRB, 0.36222179E-03_JPRB, &
  & 0.36219464E-03_JPRB, 0.36214021E-03_JPRB, 0.36205657E-03_JPRB, 0.36194795E-03_JPRB, 0.36182278E-03_JPRB, 0.36169006E-03_JPRB, &
  & 0.36155432E-03_JPRB, 0.36141352E-03_JPRB, 0.36126157E-03_JPRB, 0.36109617E-03_JPRB, 0.36092338E-03_JPRB, 0.36075671E-03_JPRB, &
  & 0.36060959E-03_JPRB, 0.36049017E-03_JPRB, 0.36040059E-03_JPRB, 0.36033883E-03_JPRB, 0.36030059E-03_JPRB, 0.36028173E-03_JPRB, &
  & 0.36027763E-03_JPRB, 0.36028129E-03_JPRB, 0.36029163E-03_JPRB, 0.36031136E-03_JPRB /)

RGHG1(:, 3, 1) = (/ &
  & 0.36412000E-03_JPRB, 0.36408319E-03_JPRB, 0.36406360E-03_JPRB, 0.36404782E-03_JPRB, 0.36403368E-03_JPRB, 0.36402157E-03_JPRB, &
  & 0.36401241E-03_JPRB, 0.36400565E-03_JPRB, 0.36400315E-03_JPRB, 0.36400656E-03_JPRB, 0.36401706E-03_JPRB, 0.36403741E-03_JPRB, &
  & 0.36406872E-03_JPRB, 0.36410848E-03_JPRB, 0.36415356E-03_JPRB, 0.36419815E-03_JPRB, 0.36423802E-03_JPRB, 0.36426878E-03_JPRB, &
  & 0.36428764E-03_JPRB, 0.36429323E-03_JPRB, 0.36428618E-03_JPRB, 0.36426823E-03_JPRB, 0.36424218E-03_JPRB, 0.36421022E-03_JPRB, &
  & 0.36417341E-03_JPRB, 0.36413100E-03_JPRB, 0.36408097E-03_JPRB, 0.36402183E-03_JPRB, 0.36395641E-03_JPRB, 0.36388758E-03_JPRB, &
  & 0.36381642E-03_JPRB, 0.36374238E-03_JPRB, 0.36366540E-03_JPRB, 0.36358775E-03_JPRB, 0.36351557E-03_JPRB, 0.36345841E-03_JPRB, &
  & 0.36342465E-03_JPRB, 0.36341720E-03_JPRB, 0.36343210E-03_JPRB, 0.36345702E-03_JPRB, 0.36347515E-03_JPRB, 0.36347026E-03_JPRB, &
  & 0.36343074E-03_JPRB, 0.36335087E-03_JPRB, 0.36323050E-03_JPRB, 0.36307191E-03_JPRB, 0.36287939E-03_JPRB, 0.36265969E-03_JPRB, &
  & 0.36242098E-03_JPRB, 0.36217371E-03_JPRB, 0.36193186E-03_JPRB, 0.36170945E-03_JPRB, 0.36151407E-03_JPRB, 0.36134664E-03_JPRB, &
  & 0.36120787E-03_JPRB, 0.36110025E-03_JPRB, 0.36102399E-03_JPRB, 0.36097469E-03_JPRB, 0.36094530E-03_JPRB, 0.36092888E-03_JPRB, &
  & 0.36092079E-03_JPRB, 0.36092114E-03_JPRB, 0.36092816E-03_JPRB, 0.36094774E-03_JPRB /)

RGHG1(:, 4, 1) = (/ &
  & 0.36415132E-03_JPRB, 0.36413386E-03_JPRB, 0.36412769E-03_JPRB, 0.36412640E-03_JPRB, 0.36412835E-03_JPRB, 0.36413284E-03_JPRB, &
  & 0.36414014E-03_JPRB, 0.36415053E-03_JPRB, 0.36416471E-03_JPRB, 0.36418374E-03_JPRB, 0.36420918E-03_JPRB, 0.36424163E-03_JPRB, &
  & 0.36428066E-03_JPRB, 0.36432341E-03_JPRB, 0.36436637E-03_JPRB, 0.36440758E-03_JPRB, 0.36444399E-03_JPRB, 0.36447446E-03_JPRB, &
  & 0.36449736E-03_JPRB, 0.36451229E-03_JPRB, 0.36451963E-03_JPRB, 0.36451998E-03_JPRB, 0.36451497E-03_JPRB, 0.36450604E-03_JPRB, &
  & 0.36449410E-03_JPRB, 0.36447964E-03_JPRB, 0.36446220E-03_JPRB, 0.36444087E-03_JPRB, 0.36441514E-03_JPRB, 0.36438415E-03_JPRB, &
  & 0.36434829E-03_JPRB, 0.36430807E-03_JPRB, 0.36426497E-03_JPRB, 0.36422207E-03_JPRB, 0.36418467E-03_JPRB, 0.36415854E-03_JPRB, &
  & 0.36414858E-03_JPRB, 0.36415498E-03_JPRB, 0.36417251E-03_JPRB, 0.36419023E-03_JPRB, 0.36419381E-03_JPRB, 0.36417032E-03_JPRB, &
  & 0.36411348E-03_JPRB, 0.36402335E-03_JPRB, 0.36390338E-03_JPRB, 0.36375731E-03_JPRB, 0.36358798E-03_JPRB, 0.36339762E-03_JPRB, &
  & 0.36318909E-03_JPRB, 0.36296697E-03_JPRB, 0.36273623E-03_JPRB, 0.36250069E-03_JPRB, 0.36226609E-03_JPRB, 0.36204464E-03_JPRB, &
  & 0.36185095E-03_JPRB, 0.36169367E-03_JPRB, 0.36157374E-03_JPRB, 0.36148803E-03_JPRB, 0.36143148E-03_JPRB, 0.36139897E-03_JPRB, &
  & 0.36138570E-03_JPRB, 0.36138284E-03_JPRB, 0.36138934E-03_JPRB, 0.36140968E-03_JPRB /)

RGHG1(:, 5, 1) = (/ &
  & 0.36418802E-03_JPRB, 0.36418176E-03_JPRB, 0.36418356E-03_JPRB, 0.36418886E-03_JPRB, 0.36419724E-03_JPRB, 0.36420900E-03_JPRB, &
  & 0.36422437E-03_JPRB, 0.36424358E-03_JPRB, 0.36426727E-03_JPRB, 0.36429722E-03_JPRB, 0.36433325E-03_JPRB, 0.36437411E-03_JPRB, &
  & 0.36441846E-03_JPRB, 0.36446337E-03_JPRB, 0.36450697E-03_JPRB, 0.36454826E-03_JPRB, 0.36458601E-03_JPRB, 0.36461945E-03_JPRB, &
  & 0.36464800E-03_JPRB, 0.36467161E-03_JPRB, 0.36469047E-03_JPRB, 0.36470487E-03_JPRB, 0.36471558E-03_JPRB, 0.36472332E-03_JPRB, &
  & 0.36472923E-03_JPRB, 0.36473293E-03_JPRB, 0.36473473E-03_JPRB, 0.36473380E-03_JPRB, 0.36472897E-03_JPRB, 0.36471957E-03_JPRB, &
  & 0.36470545E-03_JPRB, 0.36468712E-03_JPRB, 0.36466605E-03_JPRB, 0.36464527E-03_JPRB, 0.36462871E-03_JPRB, 0.36461980E-03_JPRB, &
  & 0.36462053E-03_JPRB, 0.36462967E-03_JPRB, 0.36464172E-03_JPRB, 0.36464585E-03_JPRB, 0.36462789E-03_JPRB, 0.36457821E-03_JPRB, &
  & 0.36449771E-03_JPRB, 0.36439399E-03_JPRB, 0.36427425E-03_JPRB, 0.36414317E-03_JPRB, 0.36400210E-03_JPRB, 0.36385044E-03_JPRB, &
  & 0.36368630E-03_JPRB, 0.36350772E-03_JPRB, 0.36331342E-03_JPRB, 0.36310533E-03_JPRB, 0.36289037E-03_JPRB, 0.36267738E-03_JPRB, &
  & 0.36247532E-03_JPRB, 0.36229467E-03_JPRB, 0.36214595E-03_JPRB, 0.36203436E-03_JPRB, 0.36195858E-03_JPRB, 0.36191178E-03_JPRB, &
  & 0.36188425E-03_JPRB, 0.36187220E-03_JPRB, 0.36187033E-03_JPRB, 0.36188553E-03_JPRB /)

RGHG1(:, 6, 1) = (/ &
  & 0.36423624E-03_JPRB, 0.36423904E-03_JPRB, 0.36424611E-03_JPRB, 0.36425691E-03_JPRB, 0.36427117E-03_JPRB, 0.36428915E-03_JPRB, &
  & 0.36431142E-03_JPRB, 0.36433811E-03_JPRB, 0.36437108E-03_JPRB, 0.36440947E-03_JPRB, 0.36445359E-03_JPRB, 0.36450179E-03_JPRB, &
  & 0.36455132E-03_JPRB, 0.36460054E-03_JPRB, 0.36464789E-03_JPRB, 0.36469311E-03_JPRB, 0.36473569E-03_JPRB, 0.36477530E-03_JPRB, &
  & 0.36481197E-03_JPRB, 0.36484620E-03_JPRB, 0.36487824E-03_JPRB, 0.36490828E-03_JPRB, 0.36493651E-03_JPRB, 0.36496253E-03_JPRB, &
  & 0.36498610E-03_JPRB, 0.36500744E-03_JPRB, 0.36502627E-03_JPRB, 0.36504239E-03_JPRB, 0.36505435E-03_JPRB, 0.36506139E-03_JPRB, &
  & 0.36506343E-03_JPRB, 0.36506093E-03_JPRB, 0.36505552E-03_JPRB, 0.36504937E-03_JPRB, 0.36504504E-03_JPRB, 0.36504446E-03_JPRB, &
  & 0.36504763E-03_JPRB, 0.36505231E-03_JPRB, 0.36505188E-03_JPRB, 0.36503404E-03_JPRB, 0.36498523E-03_JPRB, 0.36490150E-03_JPRB, &
  & 0.36479268E-03_JPRB, 0.36467210E-03_JPRB, 0.36454841E-03_JPRB, 0.36442454E-03_JPRB, 0.36429975E-03_JPRB, 0.36417111E-03_JPRB, &
  & 0.36403447E-03_JPRB, 0.36388647E-03_JPRB, 0.36372506E-03_JPRB, 0.36355085E-03_JPRB, 0.36336592E-03_JPRB, 0.36317512E-03_JPRB, &
  & 0.36298786E-03_JPRB, 0.36281580E-03_JPRB, 0.36266842E-03_JPRB, 0.36255177E-03_JPRB, 0.36246749E-03_JPRB, 0.36241149E-03_JPRB, &
  & 0.36237756E-03_JPRB, 0.36235843E-03_JPRB, 0.36234877E-03_JPRB, 0.36234770E-03_JPRB /)

RGHG1(:, 7, 1) = (/ &
  & 0.36429428E-03_JPRB, 0.36430784E-03_JPRB, 0.36432219E-03_JPRB, 0.36433956E-03_JPRB, 0.36436034E-03_JPRB, 0.36438525E-03_JPRB, &
  & 0.36441462E-03_JPRB, 0.36444934E-03_JPRB, 0.36448997E-03_JPRB, 0.36453738E-03_JPRB, 0.36458997E-03_JPRB, 0.36464617E-03_JPRB, &
  & 0.36470388E-03_JPRB, 0.36476174E-03_JPRB, 0.36481820E-03_JPRB, 0.36487295E-03_JPRB, 0.36492530E-03_JPRB, 0.36497525E-03_JPRB, &
  & 0.36502330E-03_JPRB, 0.36506981E-03_JPRB, 0.36511576E-03_JPRB, 0.36516140E-03_JPRB, 0.36520656E-03_JPRB, 0.36525051E-03_JPRB, &
  & 0.36529242E-03_JPRB, 0.36533200E-03_JPRB, 0.36536917E-03_JPRB, 0.36540395E-03_JPRB, 0.36543619E-03_JPRB, 0.36546466E-03_JPRB, &
  & 0.36548873E-03_JPRB, 0.36550767E-03_JPRB, 0.36552129E-03_JPRB, 0.36552985E-03_JPRB, 0.36553355E-03_JPRB, 0.36553238E-03_JPRB, &
  & 0.36552551E-03_JPRB, 0.36551032E-03_JPRB, 0.36548005E-03_JPRB, 0.36542286E-03_JPRB, 0.36532857E-03_JPRB, 0.36520034E-03_JPRB, &
  & 0.36505616E-03_JPRB, 0.36491366E-03_JPRB, 0.36478107E-03_JPRB, 0.36465839E-03_JPRB, 0.36454166E-03_JPRB, 0.36442536E-03_JPRB, &
  & 0.36430437E-03_JPRB, 0.36417507E-03_JPRB, 0.36403455E-03_JPRB, 0.36388147E-03_JPRB, 0.36371738E-03_JPRB, 0.36354768E-03_JPRB, &
  & 0.36337992E-03_JPRB, 0.36322229E-03_JPRB, 0.36308420E-03_JPRB, 0.36297296E-03_JPRB, 0.36289083E-03_JPRB, 0.36283419E-03_JPRB, &
  & 0.36279554E-03_JPRB, 0.36277046E-03_JPRB, 0.36275270E-03_JPRB, 0.36274039E-03_JPRB /)

RGHG1(:, 8, 1) = (/ &
  & 0.36438706E-03_JPRB, 0.36440237E-03_JPRB, 0.36442408E-03_JPRB, 0.36444791E-03_JPRB, 0.36447600E-03_JPRB, 0.36450845E-03_JPRB, &
  & 0.36454594E-03_JPRB, 0.36458878E-03_JPRB, 0.36463863E-03_JPRB, 0.36469512E-03_JPRB, 0.36475906E-03_JPRB, 0.36482839E-03_JPRB, &
  & 0.36490124E-03_JPRB, 0.36497522E-03_JPRB, 0.36504873E-03_JPRB, 0.36512106E-03_JPRB, 0.36519143E-03_JPRB, 0.36525959E-03_JPRB, &
  & 0.36532601E-03_JPRB, 0.36539161E-03_JPRB, 0.36545715E-03_JPRB, 0.36552193E-03_JPRB, 0.36558619E-03_JPRB, 0.36564871E-03_JPRB, &
  & 0.36570858E-03_JPRB, 0.36576530E-03_JPRB, 0.36581958E-03_JPRB, 0.36587229E-03_JPRB, 0.36592322E-03_JPRB, 0.36597170E-03_JPRB, &
  & 0.36601577E-03_JPRB, 0.36605273E-03_JPRB, 0.36607869E-03_JPRB, 0.36609112E-03_JPRB, 0.36608742E-03_JPRB, 0.36606644E-03_JPRB, &
  & 0.36602886E-03_JPRB, 0.36597374E-03_JPRB, 0.36589609E-03_JPRB, 0.36578730E-03_JPRB, 0.36563937E-03_JPRB, 0.36546143E-03_JPRB, &
  & 0.36527932E-03_JPRB, 0.36511431E-03_JPRB, 0.36497199E-03_JPRB, 0.36484777E-03_JPRB, 0.36473421E-03_JPRB, 0.36462458E-03_JPRB, &
  & 0.36451366E-03_JPRB, 0.36439643E-03_JPRB, 0.36426884E-03_JPRB, 0.36412949E-03_JPRB, 0.36397978E-03_JPRB, 0.36382355E-03_JPRB, &
  & 0.36366621E-03_JPRB, 0.36351656E-03_JPRB, 0.36338335E-03_JPRB, 0.36327387E-03_JPRB, 0.36319083E-03_JPRB, 0.36313158E-03_JPRB, &
  & 0.36308976E-03_JPRB, 0.36305928E-03_JPRB, 0.36303414E-03_JPRB, 0.36300969E-03_JPRB /)

RGHG1(:, 9, 1) = (/ &
  & 0.36452216E-03_JPRB, 0.36455024E-03_JPRB, 0.36457623E-03_JPRB, 0.36460426E-03_JPRB, 0.36463776E-03_JPRB, 0.36467717E-03_JPRB, &
  & 0.36472263E-03_JPRB, 0.36477501E-03_JPRB, 0.36483517E-03_JPRB, 0.36490423E-03_JPRB, 0.36498209E-03_JPRB, 0.36506800E-03_JPRB, &
  & 0.36516035E-03_JPRB, 0.36525654E-03_JPRB, 0.36535415E-03_JPRB, 0.36545139E-03_JPRB, 0.36554708E-03_JPRB, 0.36564059E-03_JPRB, &
  & 0.36573177E-03_JPRB, 0.36582063E-03_JPRB, 0.36590788E-03_JPRB, 0.36599275E-03_JPRB, 0.36607427E-03_JPRB, 0.36615142E-03_JPRB, &
  & 0.36622351E-03_JPRB, 0.36628987E-03_JPRB, 0.36635235E-03_JPRB, 0.36641216E-03_JPRB, 0.36646987E-03_JPRB, 0.36652357E-03_JPRB, &
  & 0.36657011E-03_JPRB, 0.36660416E-03_JPRB, 0.36661990E-03_JPRB, 0.36661208E-03_JPRB, 0.36657776E-03_JPRB, 0.36651865E-03_JPRB, &
  & 0.36643777E-03_JPRB, 0.36633780E-03_JPRB, 0.36621594E-03_JPRB, 0.36606292E-03_JPRB, 0.36587249E-03_JPRB, 0.36565590E-03_JPRB, &
  & 0.36544318E-03_JPRB, 0.36525872E-03_JPRB, 0.36510557E-03_JPRB, 0.36497673E-03_JPRB, 0.36486366E-03_JPRB, 0.36475906E-03_JPRB, &
  & 0.36465537E-03_JPRB, 0.36454611E-03_JPRB, 0.36442780E-03_JPRB, 0.36429864E-03_JPRB, 0.36415851E-03_JPRB, 0.36400976E-03_JPRB, &
  & 0.36385824E-03_JPRB, 0.36371118E-03_JPRB, 0.36357838E-03_JPRB, 0.36346831E-03_JPRB, 0.36338595E-03_JPRB, 0.36332657E-03_JPRB, &
  & 0.36328484E-03_JPRB, 0.36325437E-03_JPRB, 0.36322896E-03_JPRB, 0.36319817E-03_JPRB /)

RGHG1(:,10, 1) = (/ &
  & 0.36479314E-03_JPRB, 0.36481899E-03_JPRB, 0.36483235E-03_JPRB, 0.36485799E-03_JPRB, 0.36488744E-03_JPRB, 0.36492635E-03_JPRB, &
  & 0.36497414E-03_JPRB, 0.36503165E-03_JPRB, 0.36509996E-03_JPRB, 0.36518023E-03_JPRB, 0.36527280E-03_JPRB, 0.36537639E-03_JPRB, &
  & 0.36548858E-03_JPRB, 0.36560712E-03_JPRB, 0.36572979E-03_JPRB, 0.36585398E-03_JPRB, 0.36597773E-03_JPRB, 0.36609898E-03_JPRB, &
  & 0.36621725E-03_JPRB, 0.36633093E-03_JPRB, 0.36643934E-03_JPRB, 0.36654147E-03_JPRB, 0.36663635E-03_JPRB, 0.36672177E-03_JPRB, &
  & 0.36679817E-03_JPRB, 0.36686496E-03_JPRB, 0.36692384E-03_JPRB, 0.36697625E-03_JPRB, 0.36702218E-03_JPRB, 0.36705958E-03_JPRB, &
  & 0.36708335E-03_JPRB, 0.36708801E-03_JPRB, 0.36706691E-03_JPRB, 0.36701528E-03_JPRB, 0.36693280E-03_JPRB, 0.36682453E-03_JPRB, &
  & 0.36669878E-03_JPRB, 0.36655954E-03_JPRB, 0.36640422E-03_JPRB, 0.36622459E-03_JPRB, 0.36601440E-03_JPRB, 0.36578014E-03_JPRB, &
  & 0.36554688E-03_JPRB, 0.36534149E-03_JPRB, 0.36517496E-03_JPRB, 0.36504091E-03_JPRB, 0.36492839E-03_JPRB, 0.36482600E-03_JPRB, &
  & 0.36472542E-03_JPRB, 0.36462158E-03_JPRB, 0.36451014E-03_JPRB, 0.36438793E-03_JPRB, 0.36425432E-03_JPRB, 0.36411162E-03_JPRB, &
  & 0.36396424E-03_JPRB, 0.36382099E-03_JPRB, 0.36369241E-03_JPRB, 0.36358900E-03_JPRB, 0.36351179E-03_JPRB, 0.36345905E-03_JPRB, &
  & 0.36342145E-03_JPRB, 0.36339299E-03_JPRB, 0.36337017E-03_JPRB, 0.36334395E-03_JPRB /)

RGHG1(:,11, 1) = (/ &
  & 0.36525136E-03_JPRB, 0.36524280E-03_JPRB, 0.36522941E-03_JPRB, 0.36524000E-03_JPRB, 0.36525514E-03_JPRB, 0.36528346E-03_JPRB, &
  & 0.36532394E-03_JPRB, 0.36537781E-03_JPRB, 0.36544597E-03_JPRB, 0.36552924E-03_JPRB, 0.36562863E-03_JPRB, 0.36574338E-03_JPRB, &
  & 0.36587118E-03_JPRB, 0.36600910E-03_JPRB, 0.36615360E-03_JPRB, 0.36630192E-03_JPRB, 0.36645064E-03_JPRB, 0.36659636E-03_JPRB, &
  & 0.36673699E-03_JPRB, 0.36687060E-03_JPRB, 0.36699517E-03_JPRB, 0.36710844E-03_JPRB, 0.36721019E-03_JPRB, 0.36729820E-03_JPRB, &
  & 0.36737203E-03_JPRB, 0.36743213E-03_JPRB, 0.36747864E-03_JPRB, 0.36751258E-03_JPRB, 0.36753269E-03_JPRB, 0.36753726E-03_JPRB, &
  & 0.36752177E-03_JPRB, 0.36748132E-03_JPRB, 0.36741048E-03_JPRB, 0.36730641E-03_JPRB, 0.36717183E-03_JPRB, 0.36701633E-03_JPRB, &
  & 0.36685198E-03_JPRB, 0.36668469E-03_JPRB, 0.36651050E-03_JPRB, 0.36632392E-03_JPRB, 0.36611472E-03_JPRB, 0.36587924E-03_JPRB, &
  & 0.36563765E-03_JPRB, 0.36542106E-03_JPRB, 0.36524280E-03_JPRB, 0.36509789E-03_JPRB, 0.36497507E-03_JPRB, 0.36486474E-03_JPRB, &
  & 0.36475988E-03_JPRB, 0.36465377E-03_JPRB, 0.36454128E-03_JPRB, 0.36442009E-03_JPRB, 0.36428939E-03_JPRB, 0.36415044E-03_JPRB, &
  & 0.36400917E-03_JPRB, 0.36387442E-03_JPRB, 0.36375775E-03_JPRB, 0.36366569E-03_JPRB, 0.36360178E-03_JPRB, 0.36355687E-03_JPRB, &
  & 0.36352623E-03_JPRB, 0.36350358E-03_JPRB, 0.36348327E-03_JPRB, 0.36346016E-03_JPRB /)

RGHG1(:,12, 1) = (/ &
  & 0.36577295E-03_JPRB, 0.36572615E-03_JPRB, 0.36569417E-03_JPRB, 0.36568640E-03_JPRB, 0.36568989E-03_JPRB, 0.36570700E-03_JPRB, &
  & 0.36573908E-03_JPRB, 0.36578681E-03_JPRB, 0.36585145E-03_JPRB, 0.36593425E-03_JPRB, 0.36603594E-03_JPRB, 0.36615523E-03_JPRB, &
  & 0.36629083E-03_JPRB, 0.36644013E-03_JPRB, 0.36659892E-03_JPRB, 0.36676260E-03_JPRB, 0.36692712E-03_JPRB, 0.36708804E-03_JPRB, &
  & 0.36724185E-03_JPRB, 0.36738545E-03_JPRB, 0.36751715E-03_JPRB, 0.36763365E-03_JPRB, 0.36773490E-03_JPRB, 0.36781991E-03_JPRB, &
  & 0.36788668E-03_JPRB, 0.36793592E-03_JPRB, 0.36796572E-03_JPRB, 0.36797696E-03_JPRB, 0.36796706E-03_JPRB, 0.36793493E-03_JPRB, &
  & 0.36787719E-03_JPRB, 0.36779087E-03_JPRB, 0.36767314E-03_JPRB, 0.36752407E-03_JPRB, 0.36734974E-03_JPRB, 0.36716353E-03_JPRB, &
  & 0.36697873E-03_JPRB, 0.36680157E-03_JPRB, 0.36662997E-03_JPRB, 0.36645433E-03_JPRB, 0.36626574E-03_JPRB, 0.36606233E-03_JPRB, &
  & 0.36585005E-03_JPRB, 0.36564353E-03_JPRB, 0.36545802E-03_JPRB, 0.36529588E-03_JPRB, 0.36515269E-03_JPRB, 0.36502053E-03_JPRB, &
  & 0.36489204E-03_JPRB, 0.36476256E-03_JPRB, 0.36462984E-03_JPRB, 0.36449209E-03_JPRB, 0.36434934E-03_JPRB, 0.36420533E-03_JPRB, &
  & 0.36406587E-03_JPRB, 0.36393979E-03_JPRB, 0.36383499E-03_JPRB, 0.36375748E-03_JPRB, 0.36370283E-03_JPRB, 0.36366770E-03_JPRB, &
  & 0.36364325E-03_JPRB, 0.36362495E-03_JPRB, 0.36360999E-03_JPRB, 0.36358921E-03_JPRB /)

RGHG1(:,13, 1) = (/ &
  & 0.36625954E-03_JPRB, 0.36619091E-03_JPRB, 0.36615954E-03_JPRB, 0.36614554E-03_JPRB, 0.36614598E-03_JPRB, 0.36616015E-03_JPRB, &
  & 0.36618911E-03_JPRB, 0.36623358E-03_JPRB, 0.36629487E-03_JPRB, 0.36637502E-03_JPRB, 0.36647508E-03_JPRB, 0.36659467E-03_JPRB, &
  & 0.36673131E-03_JPRB, 0.36688230E-03_JPRB, 0.36704383E-03_JPRB, 0.36721124E-03_JPRB, 0.36737914E-03_JPRB, 0.36754287E-03_JPRB, &
  & 0.36769800E-03_JPRB, 0.36784133E-03_JPRB, 0.36797056E-03_JPRB, 0.36808325E-03_JPRB, 0.36817830E-03_JPRB, 0.36825548E-03_JPRB, &
  & 0.36831226E-03_JPRB, 0.36834861E-03_JPRB, 0.36836154E-03_JPRB, 0.36835080E-03_JPRB, 0.36831401E-03_JPRB, 0.36825021E-03_JPRB, &
  & 0.36815781E-03_JPRB, 0.36803618E-03_JPRB, 0.36788610E-03_JPRB, 0.36771141E-03_JPRB, 0.36752279E-03_JPRB, 0.36733467E-03_JPRB, &
  & 0.36715987E-03_JPRB, 0.36700288E-03_JPRB, 0.36685920E-03_JPRB, 0.36672113E-03_JPRB, 0.36658187E-03_JPRB, 0.36643652E-03_JPRB, &
  & 0.36628352E-03_JPRB, 0.36612482E-03_JPRB, 0.36596454E-03_JPRB, 0.36580549E-03_JPRB, 0.36564725E-03_JPRB, 0.36548736E-03_JPRB, &
  & 0.36532310E-03_JPRB, 0.36515255E-03_JPRB, 0.36497548E-03_JPRB, 0.36479521E-03_JPRB, 0.36461733E-03_JPRB, 0.36444823E-03_JPRB, &
  & 0.36429588E-03_JPRB, 0.36416715E-03_JPRB, 0.36406703E-03_JPRB, 0.36399433E-03_JPRB, 0.36394648E-03_JPRB, 0.36391377E-03_JPRB, &
  & 0.36389110E-03_JPRB, 0.36387279E-03_JPRB, 0.36385370E-03_JPRB, 0.36382419E-03_JPRB /)

RGHG1(:,14, 1) = (/ &
  & 0.36668300E-03_JPRB, 0.36661592E-03_JPRB, 0.36659339E-03_JPRB, 0.36658676E-03_JPRB, 0.36659255E-03_JPRB, 0.36661097E-03_JPRB, &
  & 0.36664240E-03_JPRB, 0.36668795E-03_JPRB, 0.36674910E-03_JPRB, 0.36682736E-03_JPRB, 0.36692404E-03_JPRB, 0.36703906E-03_JPRB, &
  & 0.36717093E-03_JPRB, 0.36731636E-03_JPRB, 0.36747157E-03_JPRB, 0.36763205E-03_JPRB, 0.36779276E-03_JPRB, 0.36794887E-03_JPRB, &
  & 0.36809620E-03_JPRB, 0.36823101E-03_JPRB, 0.36835080E-03_JPRB, 0.36845385E-03_JPRB, 0.36853930E-03_JPRB, 0.36860534E-03_JPRB, &
  & 0.36865065E-03_JPRB, 0.36867318E-03_JPRB, 0.36867082E-03_JPRB, 0.36864157E-03_JPRB, 0.36858371E-03_JPRB, 0.36849678E-03_JPRB, &
  & 0.36838138E-03_JPRB, 0.36824049E-03_JPRB, 0.36807903E-03_JPRB, 0.36790554E-03_JPRB, 0.36773190E-03_JPRB, 0.36757137E-03_JPRB, &
  & 0.36743359E-03_JPRB, 0.36731787E-03_JPRB, 0.36721973E-03_JPRB, 0.36713196E-03_JPRB, 0.36704695E-03_JPRB, 0.36695844E-03_JPRB, &
  & 0.36686205E-03_JPRB, 0.36675535E-03_JPRB, 0.36663725E-03_JPRB, 0.36650777E-03_JPRB, 0.36636638E-03_JPRB, 0.36621134E-03_JPRB, &
  & 0.36604100E-03_JPRB, 0.36585517E-03_JPRB, 0.36565593E-03_JPRB, 0.36544848E-03_JPRB, 0.36524126E-03_JPRB, 0.36504553E-03_JPRB, &
  & 0.36487210E-03_JPRB, 0.36472813E-03_JPRB, 0.36461634E-03_JPRB, 0.36453467E-03_JPRB, 0.36447699E-03_JPRB, 0.36443683E-03_JPRB, &
  & 0.36440516E-03_JPRB, 0.36437716E-03_JPRB, 0.36434591E-03_JPRB, 0.36428912E-03_JPRB /)

RGHG1(:,15, 1) = (/ &
  & 0.36704220E-03_JPRB, 0.36699986E-03_JPRB, 0.36698970E-03_JPRB, 0.36699366E-03_JPRB, 0.36700966E-03_JPRB, 0.36703743E-03_JPRB, &
  & 0.36707695E-03_JPRB, 0.36712899E-03_JPRB, 0.36719418E-03_JPRB, 0.36727378E-03_JPRB, 0.36736834E-03_JPRB, 0.36747783E-03_JPRB, &
  & 0.36760065E-03_JPRB, 0.36773464E-03_JPRB, 0.36787652E-03_JPRB, 0.36802265E-03_JPRB, 0.36816858E-03_JPRB, 0.36831023E-03_JPRB, &
  & 0.36844332E-03_JPRB, 0.36856448E-03_JPRB, 0.36867138E-03_JPRB, 0.36876186E-03_JPRB, 0.36883517E-03_JPRB, 0.36888896E-03_JPRB, &
  & 0.36892193E-03_JPRB, 0.36893127E-03_JPRB, 0.36891486E-03_JPRB, 0.36887047E-03_JPRB, 0.36879731E-03_JPRB, 0.36869635E-03_JPRB, &
  & 0.36857059E-03_JPRB, 0.36842612E-03_JPRB, 0.36827225E-03_JPRB, 0.36811933E-03_JPRB, 0.36798048E-03_JPRB, 0.36786555E-03_JPRB, &
  & 0.36777751E-03_JPRB, 0.36771220E-03_JPRB, 0.36766008E-03_JPRB, 0.36761380E-03_JPRB, 0.36756697E-03_JPRB, 0.36751380E-03_JPRB, &
  & 0.36745059E-03_JPRB, 0.36737521E-03_JPRB, 0.36728638E-03_JPRB, 0.36718324E-03_JPRB, 0.36706461E-03_JPRB, 0.36692887E-03_JPRB, &
  & 0.36677480E-03_JPRB, 0.36660235E-03_JPRB, 0.36641399E-03_JPRB, 0.36621589E-03_JPRB, 0.36601574E-03_JPRB, 0.36582342E-03_JPRB, &
  & 0.36564728E-03_JPRB, 0.36549417E-03_JPRB, 0.36536728E-03_JPRB, 0.36526748E-03_JPRB, 0.36519193E-03_JPRB, 0.36513465E-03_JPRB, &
  & 0.36509024E-03_JPRB, 0.36504859E-03_JPRB, 0.36500365E-03_JPRB, 0.36491721E-03_JPRB /)

RGHG1(:,16, 1) = (/ &
  & 0.36735000E-03_JPRB, 0.36733554E-03_JPRB, 0.36734252E-03_JPRB, 0.36736124E-03_JPRB, 0.36739089E-03_JPRB, 0.36743149E-03_JPRB, &
  & 0.36748211E-03_JPRB, 0.36754267E-03_JPRB, 0.36761365E-03_JPRB, 0.36769564E-03_JPRB, 0.36778845E-03_JPRB, 0.36789195E-03_JPRB, &
  & 0.36800522E-03_JPRB, 0.36812638E-03_JPRB, 0.36825312E-03_JPRB, 0.36838255E-03_JPRB, 0.36851101E-03_JPRB, 0.36863523E-03_JPRB, &
  & 0.36875144E-03_JPRB, 0.36885712E-03_JPRB, 0.36894903E-03_JPRB, 0.36902592E-03_JPRB, 0.36908581E-03_JPRB, 0.36912682E-03_JPRB, &
  & 0.36914708E-03_JPRB, 0.36914382E-03_JPRB, 0.36911506E-03_JPRB, 0.36905933E-03_JPRB, 0.36897694E-03_JPRB, 0.36887085E-03_JPRB, &
  & 0.36874734E-03_JPRB, 0.36861483E-03_JPRB, 0.36848325E-03_JPRB, 0.36836532E-03_JPRB, 0.36827041E-03_JPRB, 0.36820490E-03_JPRB, &
  & 0.36816450E-03_JPRB, 0.36814131E-03_JPRB, 0.36812527E-03_JPRB, 0.36810798E-03_JPRB, 0.36808310E-03_JPRB, 0.36804762E-03_JPRB, &
  & 0.36799975E-03_JPRB, 0.36793866E-03_JPRB, 0.36786392E-03_JPRB, 0.36777536E-03_JPRB, 0.36767148E-03_JPRB, 0.36755027E-03_JPRB, &
  & 0.36740996E-03_JPRB, 0.36725047E-03_JPRB, 0.36707439E-03_JPRB, 0.36688626E-03_JPRB, 0.36669354E-03_JPRB, 0.36650401E-03_JPRB, &
  & 0.36632671E-03_JPRB, 0.36616824E-03_JPRB, 0.36603253E-03_JPRB, 0.36592028E-03_JPRB, 0.36583139E-03_JPRB, 0.36576248E-03_JPRB, &
  & 0.36570546E-03_JPRB, 0.36565721E-03_JPRB, 0.36560139E-03_JPRB, 0.36551213E-03_JPRB /)

RGHG1(:,17, 1) = (/ &
  & 0.36761988E-03_JPRB, 0.36763315E-03_JPRB, 0.36765484E-03_JPRB, 0.36768580E-03_JPRB, 0.36772710E-03_JPRB, 0.36777847E-03_JPRB, &
  & 0.36783953E-03_JPRB, 0.36790894E-03_JPRB, 0.36798656E-03_JPRB, 0.36807245E-03_JPRB, 0.36816584E-03_JPRB, 0.36826602E-03_JPRB, &
  & 0.36837196E-03_JPRB, 0.36848235E-03_JPRB, 0.36859565E-03_JPRB, 0.36870973E-03_JPRB, 0.36882190E-03_JPRB, 0.36892935E-03_JPRB, &
  & 0.36902927E-03_JPRB, 0.36911905E-03_JPRB, 0.36919629E-03_JPRB, 0.36925907E-03_JPRB, 0.36930511E-03_JPRB, 0.36933285E-03_JPRB, &
  & 0.36934041E-03_JPRB, 0.36932551E-03_JPRB, 0.36928745E-03_JPRB, 0.36922525E-03_JPRB, 0.36914187E-03_JPRB, 0.36904178E-03_JPRB, &
  & 0.36893249E-03_JPRB, 0.36882368E-03_JPRB, 0.36872528E-03_JPRB, 0.36864725E-03_JPRB, 0.36859640E-03_JPRB, 0.36857164E-03_JPRB, &
  & 0.36856873E-03_JPRB, 0.36857577E-03_JPRB, 0.36858200E-03_JPRB, 0.36857976E-03_JPRB, 0.36856541E-03_JPRB, 0.36853680E-03_JPRB, &
  & 0.36849349E-03_JPRB, 0.36843680E-03_JPRB, 0.36836741E-03_JPRB, 0.36828563E-03_JPRB, 0.36819000E-03_JPRB, 0.36807830E-03_JPRB, &
  & 0.36794867E-03_JPRB, 0.36780076E-03_JPRB, 0.36763641E-03_JPRB, 0.36745996E-03_JPRB, 0.36727742E-03_JPRB, 0.36709625E-03_JPRB, &
  & 0.36692392E-03_JPRB, 0.36676717E-03_JPRB, 0.36662916E-03_JPRB, 0.36651106E-03_JPRB, 0.36641251E-03_JPRB, 0.36633140E-03_JPRB, &
  & 0.36626565E-03_JPRB, 0.36620378E-03_JPRB, 0.36614129E-03_JPRB, 0.36602761E-03_JPRB /)

RGHG1(:,18, 1) = (/ &
  & 0.36785327E-03_JPRB, 0.36788720E-03_JPRB, 0.36792114E-03_JPRB, 0.36796290E-03_JPRB, 0.36801412E-03_JPRB, 0.36807521E-03_JPRB, &
  & 0.36814544E-03_JPRB, 0.36822329E-03_JPRB, 0.36830743E-03_JPRB, 0.36839707E-03_JPRB, 0.36849163E-03_JPRB, 0.36859009E-03_JPRB, &
  & 0.36869099E-03_JPRB, 0.36879376E-03_JPRB, 0.36889687E-03_JPRB, 0.36899879E-03_JPRB, 0.36909801E-03_JPRB, 0.36919158E-03_JPRB, &
  & 0.36927761E-03_JPRB, 0.36935383E-03_JPRB, 0.36941742E-03_JPRB, 0.36946658E-03_JPRB, 0.36949944E-03_JPRB, 0.36951448E-03_JPRB, &
  & 0.36951035E-03_JPRB, 0.36948614E-03_JPRB, 0.36944213E-03_JPRB, 0.36938040E-03_JPRB, 0.36930403E-03_JPRB, 0.36922059E-03_JPRB, &
  & 0.36913590E-03_JPRB, 0.36905918E-03_JPRB, 0.36899879E-03_JPRB, 0.36895930E-03_JPRB, 0.36894280E-03_JPRB, 0.36894868E-03_JPRB, &
  & 0.36896727E-03_JPRB, 0.36898919E-03_JPRB, 0.36900403E-03_JPRB, 0.36900636E-03_JPRB, 0.36899286E-03_JPRB, 0.36896308E-03_JPRB, &
  & 0.36891899E-03_JPRB, 0.36886233E-03_JPRB, 0.36879451E-03_JPRB, 0.36871579E-03_JPRB, 0.36862513E-03_JPRB, 0.36852030E-03_JPRB, &
  & 0.36839966E-03_JPRB, 0.36826273E-03_JPRB, 0.36811107E-03_JPRB, 0.36794826E-03_JPRB, 0.36777911E-03_JPRB, 0.36760961E-03_JPRB, &
  & 0.36744698E-03_JPRB, 0.36729718E-03_JPRB, 0.36716289E-03_JPRB, 0.36704453E-03_JPRB, 0.36694179E-03_JPRB, 0.36685454E-03_JPRB, &
  & 0.36677805E-03_JPRB, 0.36670946E-03_JPRB, 0.36663376E-03_JPRB, 0.36650791E-03_JPRB /)

RGHG1(:,19, 1) = (/ &
  & 0.36806715E-03_JPRB, 0.36811538E-03_JPRB, 0.36815746E-03_JPRB, 0.36820577E-03_JPRB, 0.36826322E-03_JPRB, 0.36833016E-03_JPRB, &
  & 0.36840586E-03_JPRB, 0.36848863E-03_JPRB, 0.36857688E-03_JPRB, 0.36866925E-03_JPRB, 0.36876457E-03_JPRB, 0.36886174E-03_JPRB, &
  & 0.36895950E-03_JPRB, 0.36905718E-03_JPRB, 0.36915339E-03_JPRB, 0.36924693E-03_JPRB, 0.36933657E-03_JPRB, 0.36942025E-03_JPRB, &
  & 0.36949554E-03_JPRB, 0.36956044E-03_JPRB, 0.36961248E-03_JPRB, 0.36964979E-03_JPRB, 0.36967118E-03_JPRB, 0.36967522E-03_JPRB, &
  & 0.36966169E-03_JPRB, 0.36963157E-03_JPRB, 0.36958692E-03_JPRB, 0.36953136E-03_JPRB, 0.36947092E-03_JPRB, 0.36940986E-03_JPRB, &
  & 0.36935735E-03_JPRB, 0.36931637E-03_JPRB, 0.36929059E-03_JPRB, 0.36928267E-03_JPRB, 0.36929105E-03_JPRB, 0.36931163E-03_JPRB, &
  & 0.36933838E-03_JPRB, 0.36936178E-03_JPRB, 0.36937423E-03_JPRB, 0.36937185E-03_JPRB, 0.36935383E-03_JPRB, 0.36932062E-03_JPRB, &
  & 0.36927394E-03_JPRB, 0.36921579E-03_JPRB, 0.36914804E-03_JPRB, 0.36907080E-03_JPRB, 0.36898328E-03_JPRB, 0.36888401E-03_JPRB, &
  & 0.36877146E-03_JPRB, 0.36864541E-03_JPRB, 0.36850735E-03_JPRB, 0.36836014E-03_JPRB, 0.36820740E-03_JPRB, 0.36805478E-03_JPRB, &
  & 0.36790775E-03_JPRB, 0.36777125E-03_JPRB, 0.36764704E-03_JPRB, 0.36753525E-03_JPRB, 0.36743507E-03_JPRB, 0.36734549E-03_JPRB, &
  & 0.36726499E-03_JPRB, 0.36718883E-03_JPRB, 0.36710314E-03_JPRB, 0.36696377E-03_JPRB /)

RGHG1(:,20, 1) = (/ &
  & 0.36825027E-03_JPRB, 0.36830918E-03_JPRB, 0.36835624E-03_JPRB, 0.36840848E-03_JPRB, 0.36846971E-03_JPRB, 0.36854058E-03_JPRB, &
  & 0.36861986E-03_JPRB, 0.36870601E-03_JPRB, 0.36879673E-03_JPRB, 0.36889056E-03_JPRB, 0.36898640E-03_JPRB, 0.36908287E-03_JPRB, &
  & 0.36917880E-03_JPRB, 0.36927316E-03_JPRB, 0.36936521E-03_JPRB, 0.36945345E-03_JPRB, 0.36953681E-03_JPRB, 0.36961358E-03_JPRB, &
  & 0.36968139E-03_JPRB, 0.36973815E-03_JPRB, 0.36978186E-03_JPRB, 0.36981038E-03_JPRB, 0.36982301E-03_JPRB, 0.36981932E-03_JPRB, &
  & 0.36980037E-03_JPRB, 0.36976865E-03_JPRB, 0.36972816E-03_JPRB, 0.36968425E-03_JPRB, 0.36964178E-03_JPRB, 0.36960855E-03_JPRB, &
  & 0.36958541E-03_JPRB, 0.36957551E-03_JPRB, 0.36957848E-03_JPRB, 0.36959173E-03_JPRB, 0.36961379E-03_JPRB, 0.36964015E-03_JPRB, &
  & 0.36966483E-03_JPRB, 0.36968224E-03_JPRB, 0.36968771E-03_JPRB, 0.36967767E-03_JPRB, 0.36965244E-03_JPRB, 0.36961344E-03_JPRB, &
  & 0.36956347E-03_JPRB, 0.36950380E-03_JPRB, 0.36943585E-03_JPRB, 0.36935962E-03_JPRB, 0.36927479E-03_JPRB, 0.36918043E-03_JPRB, &
  & 0.36907571E-03_JPRB, 0.36896090E-03_JPRB, 0.36883703E-03_JPRB, 0.36870650E-03_JPRB, 0.36857266E-03_JPRB, 0.36843956E-03_JPRB, &
  & 0.36831183E-03_JPRB, 0.36819253E-03_JPRB, 0.36808301E-03_JPRB, 0.36798240E-03_JPRB, 0.36788976E-03_JPRB, 0.36780414E-03_JPRB, &
  & 0.36772437E-03_JPRB, 0.36764372E-03_JPRB, 0.36755833E-03_JPRB, 0.36739817E-03_JPRB /)

RGHG1(:,21, 1) = (/ &
  & 0.36841116E-03_JPRB, 0.36848043E-03_JPRB, 0.36853075E-03_JPRB, 0.36858447E-03_JPRB, 0.36864638E-03_JPRB, 0.36871748E-03_JPRB, &
  & 0.36879757E-03_JPRB, 0.36888430E-03_JPRB, 0.36897557E-03_JPRB, 0.36907016E-03_JPRB, 0.36916582E-03_JPRB, 0.36926151E-03_JPRB, &
  & 0.36935610E-03_JPRB, 0.36944842E-03_JPRB, 0.36953768E-03_JPRB, 0.36962290E-03_JPRB, 0.36970255E-03_JPRB, 0.36977488E-03_JPRB, &
  & 0.36983797E-03_JPRB, 0.36988957E-03_JPRB, 0.36992773E-03_JPRB, 0.36995101E-03_JPRB, 0.36995878E-03_JPRB, 0.36995125E-03_JPRB, &
  & 0.36993113E-03_JPRB, 0.36990215E-03_JPRB, 0.36986929E-03_JPRB, 0.36983832E-03_JPRB, 0.36981577E-03_JPRB, 0.36980421E-03_JPRB, &
  & 0.36980549E-03_JPRB, 0.36981757E-03_JPRB, 0.36983803E-03_JPRB, 0.36986347E-03_JPRB, 0.36989039E-03_JPRB, 0.36991498E-03_JPRB, &
  & 0.36993378E-03_JPRB, 0.36994260E-03_JPRB, 0.36993847E-03_JPRB, 0.36992066E-03_JPRB, 0.36989001E-03_JPRB, 0.36984793E-03_JPRB, &
  & 0.36979624E-03_JPRB, 0.36973588E-03_JPRB, 0.36966812E-03_JPRB, 0.36959306E-03_JPRB, 0.36951143E-03_JPRB, 0.36942243E-03_JPRB, &
  & 0.36932604E-03_JPRB, 0.36922251E-03_JPRB, 0.36911314E-03_JPRB, 0.36899975E-03_JPRB, 0.36888506E-03_JPRB, 0.36877225E-03_JPRB, &
  & 0.36866419E-03_JPRB, 0.36856308E-03_JPRB, 0.36846896E-03_JPRB, 0.36838136E-03_JPRB, 0.36829885E-03_JPRB, 0.36822041E-03_JPRB, &
  & 0.36814372E-03_JPRB, 0.36806826E-03_JPRB, 0.36797419E-03_JPRB, 0.36782175E-03_JPRB /)

RGHG1(:,22, 1) = (/ &
  & 0.36856311E-03_JPRB, 0.36863153E-03_JPRB, 0.36868255E-03_JPRB, 0.36873654E-03_JPRB, 0.36879809E-03_JPRB, 0.36886841E-03_JPRB, &
  & 0.36894708E-03_JPRB, 0.36903267E-03_JPRB, 0.36912330E-03_JPRB, 0.36921666E-03_JPRB, 0.36931166E-03_JPRB, 0.36940622E-03_JPRB, &
  & 0.36949932E-03_JPRB, 0.36959001E-03_JPRB, 0.36967773E-03_JPRB, 0.36976102E-03_JPRB, 0.36983844E-03_JPRB, 0.36990823E-03_JPRB, &
  & 0.36996865E-03_JPRB, 0.37001801E-03_JPRB, 0.37005392E-03_JPRB, 0.37007546E-03_JPRB, 0.37008215E-03_JPRB, 0.37007558E-03_JPRB, &
  & 0.37005846E-03_JPRB, 0.37003591E-03_JPRB, 0.37001260E-03_JPRB, 0.36999484E-03_JPRB, 0.36998666E-03_JPRB, 0.36999106E-03_JPRB, &
  & 0.37000678E-03_JPRB, 0.37003070E-03_JPRB, 0.37005873E-03_JPRB, 0.37008733E-03_JPRB, 0.37011315E-03_JPRB, 0.37013349E-03_JPRB, &
  & 0.37014551E-03_JPRB, 0.37014653E-03_JPRB, 0.37013547E-03_JPRB, 0.37011207E-03_JPRB, 0.37007732E-03_JPRB, 0.37003297E-03_JPRB, &
  & 0.36998061E-03_JPRB, 0.36992089E-03_JPRB, 0.36985465E-03_JPRB, 0.36978236E-03_JPRB, 0.36970474E-03_JPRB, 0.36962214E-03_JPRB, &
  & 0.36953436E-03_JPRB, 0.36944216E-03_JPRB, 0.36934688E-03_JPRB, 0.36925034E-03_JPRB, 0.36915427E-03_JPRB, 0.36906017E-03_JPRB, &
  & 0.36897027E-03_JPRB, 0.36888543E-03_JPRB, 0.36880581E-03_JPRB, 0.36873022E-03_JPRB, 0.36865764E-03_JPRB, 0.36858689E-03_JPRB, &
  & 0.36851695E-03_JPRB, 0.36844192E-03_JPRB, 0.36835941E-03_JPRB, 0.36820085E-03_JPRB /)

RGHG1(:,23, 1) = (/ &
  & 0.36869734E-03_JPRB, 0.36876640E-03_JPRB, 0.36881640E-03_JPRB, 0.36886879E-03_JPRB, 0.36892897E-03_JPRB, 0.36899809E-03_JPRB, &
  & 0.36907487E-03_JPRB, 0.36915831E-03_JPRB, 0.36924670E-03_JPRB, 0.36933844E-03_JPRB, 0.36943151E-03_JPRB, 0.36952455E-03_JPRB, &
  & 0.36961606E-03_JPRB, 0.36970526E-03_JPRB, 0.36979117E-03_JPRB, 0.36987299E-03_JPRB, 0.36994941E-03_JPRB, 0.37001877E-03_JPRB, &
  & 0.37007863E-03_JPRB, 0.37012764E-03_JPRB, 0.37016431E-03_JPRB, 0.37018745E-03_JPRB, 0.37019732E-03_JPRB, 0.37019528E-03_JPRB, &
  & 0.37018498E-03_JPRB, 0.37017086E-03_JPRB, 0.37015730E-03_JPRB, 0.37014941E-03_JPRB, 0.37015154E-03_JPRB, 0.37016379E-03_JPRB, &
  & 0.37018498E-03_JPRB, 0.37021114E-03_JPRB, 0.37023932E-03_JPRB, 0.37026574E-03_JPRB, 0.37028719E-03_JPRB, 0.37030160E-03_JPRB, &
  & 0.37030721E-03_JPRB, 0.37030203E-03_JPRB, 0.37028611E-03_JPRB, 0.37025916E-03_JPRB, 0.37022290E-03_JPRB, 0.37017855E-03_JPRB, &
  & 0.37012709E-03_JPRB, 0.37006926E-03_JPRB, 0.37000573E-03_JPRB, 0.36993719E-03_JPRB, 0.36986460E-03_JPRB, 0.36978873E-03_JPRB, &
  & 0.36970974E-03_JPRB, 0.36962880E-03_JPRB, 0.36954691E-03_JPRB, 0.36946527E-03_JPRB, 0.36938512E-03_JPRB, 0.36930747E-03_JPRB, &
  & 0.36923308E-03_JPRB, 0.36916242E-03_JPRB, 0.36909472E-03_JPRB, 0.36902935E-03_JPRB, 0.36896535E-03_JPRB, 0.36890153E-03_JPRB, &
  & 0.36883648E-03_JPRB, 0.36876922E-03_JPRB, 0.36868607E-03_JPRB, 0.36854102E-03_JPRB /)

RGHG1(:,24, 1) = (/ &
  & 0.36882257E-03_JPRB, 0.36888936E-03_JPRB, 0.36893738E-03_JPRB, 0.36898782E-03_JPRB, 0.36904545E-03_JPRB, 0.36911177E-03_JPRB, &
  & 0.36918590E-03_JPRB, 0.36926655E-03_JPRB, 0.36935229E-03_JPRB, 0.36944120E-03_JPRB, 0.36953189E-03_JPRB, 0.36962266E-03_JPRB, &
  & 0.36971236E-03_JPRB, 0.36979999E-03_JPRB, 0.36988471E-03_JPRB, 0.36996530E-03_JPRB, 0.37004054E-03_JPRB, 0.37010934E-03_JPRB, &
  & 0.37016999E-03_JPRB, 0.37022069E-03_JPRB, 0.37026056E-03_JPRB, 0.37028801E-03_JPRB, 0.37030358E-03_JPRB, 0.37030951E-03_JPRB, &
  & 0.37030800E-03_JPRB, 0.37030291E-03_JPRB, 0.37029845E-03_JPRB, 0.37029793E-03_JPRB, 0.37030451E-03_JPRB, 0.37031822E-03_JPRB, &
  & 0.37033801E-03_JPRB, 0.37036126E-03_JPRB, 0.37038475E-03_JPRB, 0.37040564E-03_JPRB, 0.37042110E-03_JPRB, 0.37042965E-03_JPRB, &
  & 0.37042980E-03_JPRB, 0.37042014E-03_JPRB, 0.37040116E-03_JPRB, 0.37037299E-03_JPRB, 0.37033664E-03_JPRB, 0.37029351E-03_JPRB, &
  & 0.37024406E-03_JPRB, 0.37018902E-03_JPRB, 0.37012881E-03_JPRB, 0.37006452E-03_JPRB, 0.36999737E-03_JPRB, 0.36992860E-03_JPRB, &
  & 0.36985823E-03_JPRB, 0.36978768E-03_JPRB, 0.36971760E-03_JPRB, 0.36964889E-03_JPRB, 0.36958224E-03_JPRB, 0.36951795E-03_JPRB, &
  & 0.36945625E-03_JPRB, 0.36939670E-03_JPRB, 0.36933908E-03_JPRB, 0.36928206E-03_JPRB, 0.36922499E-03_JPRB, 0.36916696E-03_JPRB, &
  & 0.36910706E-03_JPRB, 0.36904274E-03_JPRB, 0.36896707E-03_JPRB, 0.36882915E-03_JPRB /)

RGHG1(:,25, 1) = (/ &
  & 0.36893872E-03_JPRB, 0.36900298E-03_JPRB, 0.36904908E-03_JPRB, 0.36909696E-03_JPRB, 0.36915170E-03_JPRB, 0.36921460E-03_JPRB, &
  & 0.36928518E-03_JPRB, 0.36936239E-03_JPRB, 0.36944463E-03_JPRB, 0.36953023E-03_JPRB, 0.36961780E-03_JPRB, 0.36970555E-03_JPRB, &
  & 0.36979234E-03_JPRB, 0.36987732E-03_JPRB, 0.36995974E-03_JPRB, 0.37003917E-03_JPRB, 0.37011431E-03_JPRB, 0.37018361E-03_JPRB, &
  & 0.37024598E-03_JPRB, 0.37029950E-03_JPRB, 0.37034295E-03_JPRB, 0.37037590E-03_JPRB, 0.37039898E-03_JPRB, 0.37041339E-03_JPRB, &
  & 0.37042107E-03_JPRB, 0.37042511E-03_JPRB, 0.37042788E-03_JPRB, 0.37043216E-03_JPRB, 0.37044013E-03_JPRB, 0.37045195E-03_JPRB, &
  & 0.37046752E-03_JPRB, 0.37048484E-03_JPRB, 0.37050180E-03_JPRB, 0.37051592E-03_JPRB, 0.37052535E-03_JPRB, 0.37052858E-03_JPRB, &
  & 0.37052413E-03_JPRB, 0.37051129E-03_JPRB, 0.37049036E-03_JPRB, 0.37046199E-03_JPRB, 0.37042686E-03_JPRB, 0.37038562E-03_JPRB, &
  & 0.37033923E-03_JPRB, 0.37028766E-03_JPRB, 0.37023146E-03_JPRB, 0.37017179E-03_JPRB, 0.37011021E-03_JPRB, 0.37004767E-03_JPRB, &
  & 0.36998518E-03_JPRB, 0.36992336E-03_JPRB, 0.36986324E-03_JPRB, 0.36980503E-03_JPRB, 0.36974929E-03_JPRB, 0.36969571E-03_JPRB, &
  & 0.36964397E-03_JPRB, 0.36959368E-03_JPRB, 0.36954382E-03_JPRB, 0.36949385E-03_JPRB, 0.36944257E-03_JPRB, 0.36938922E-03_JPRB, &
  & 0.36933349E-03_JPRB, 0.36927333E-03_JPRB, 0.36920342E-03_JPRB, 0.36907228E-03_JPRB /)

RGHG1(:,26, 1) = (/ &
  & 0.36904859E-03_JPRB, 0.36910994E-03_JPRB, 0.36915392E-03_JPRB, 0.36919946E-03_JPRB, 0.36925130E-03_JPRB, 0.36931096E-03_JPRB, &
  & 0.36937799E-03_JPRB, 0.36945104E-03_JPRB, 0.36952889E-03_JPRB, 0.36961035E-03_JPRB, 0.36969397E-03_JPRB, 0.36977822E-03_JPRB, &
  & 0.36986210E-03_JPRB, 0.36994502E-03_JPRB, 0.37002563E-03_JPRB, 0.37010325E-03_JPRB, 0.37017706E-03_JPRB, 0.37024604E-03_JPRB, &
  & 0.37030890E-03_JPRB, 0.37036437E-03_JPRB, 0.37041149E-03_JPRB, 0.37045003E-03_JPRB, 0.37047977E-03_JPRB, 0.37050221E-03_JPRB, &
  & 0.37051833E-03_JPRB, 0.37052989E-03_JPRB, 0.37053859E-03_JPRB, 0.37054642E-03_JPRB, 0.37055442E-03_JPRB, 0.37056391E-03_JPRB, &
  & 0.37057445E-03_JPRB, 0.37058539E-03_JPRB, 0.37059569E-03_JPRB, 0.37060358E-03_JPRB, 0.37060748E-03_JPRB, 0.37060614E-03_JPRB, &
  & 0.37059799E-03_JPRB, 0.37058324E-03_JPRB, 0.37056176E-03_JPRB, 0.37053402E-03_JPRB, 0.37050084E-03_JPRB, 0.37046240E-03_JPRB, &
  & 0.37041921E-03_JPRB, 0.37037110E-03_JPRB, 0.37031909E-03_JPRB, 0.37026397E-03_JPRB, 0.37020739E-03_JPRB, 0.37015032E-03_JPRB, &
  & 0.37009429E-03_JPRB, 0.37003981E-03_JPRB, 0.36998763E-03_JPRB, 0.36993771E-03_JPRB, 0.36989019E-03_JPRB, 0.36984467E-03_JPRB, &
  & 0.36980089E-03_JPRB, 0.36975805E-03_JPRB, 0.36971533E-03_JPRB, 0.36967135E-03_JPRB, 0.36962546E-03_JPRB, 0.36957685E-03_JPRB, &
  & 0.36952476E-03_JPRB, 0.36946975E-03_JPRB, 0.36940127E-03_JPRB, 0.36928177E-03_JPRB /)

RGHG1(:,27, 1) = (/ &
  & 0.36915435E-03_JPRB, 0.36921387E-03_JPRB, 0.36925543E-03_JPRB, 0.36929856E-03_JPRB, 0.36934734E-03_JPRB, 0.36940334E-03_JPRB, &
  & 0.36946626E-03_JPRB, 0.36953497E-03_JPRB, 0.36960799E-03_JPRB, 0.36968442E-03_JPRB, 0.36976303E-03_JPRB, 0.36984275E-03_JPRB, &
  & 0.36992243E-03_JPRB, 0.37000119E-03_JPRB, 0.37007872E-03_JPRB, 0.37015436E-03_JPRB, 0.37022692E-03_JPRB, 0.37029534E-03_JPRB, &
  & 0.37035873E-03_JPRB, 0.37041615E-03_JPRB, 0.37046659E-03_JPRB, 0.37050943E-03_JPRB, 0.37054493E-03_JPRB, 0.37057360E-03_JPRB, &
  & 0.37059636E-03_JPRB, 0.37061397E-03_JPRB, 0.37062741E-03_JPRB, 0.37063789E-03_JPRB, 0.37064622E-03_JPRB, 0.37065361E-03_JPRB, &
  & 0.37066048E-03_JPRB, 0.37066644E-03_JPRB, 0.37067162E-03_JPRB, 0.37067418E-03_JPRB, 0.37067352E-03_JPRB, 0.37066854E-03_JPRB, &
  & 0.37065800E-03_JPRB, 0.37064214E-03_JPRB, 0.37062090E-03_JPRB, 0.37059467E-03_JPRB, 0.37056374E-03_JPRB, 0.37052820E-03_JPRB, &
  & 0.37048827E-03_JPRB, 0.37044409E-03_JPRB, 0.37039589E-03_JPRB, 0.37034490E-03_JPRB, 0.37029234E-03_JPRB, 0.37023990E-03_JPRB, &
  & 0.37018908E-03_JPRB, 0.37014042E-03_JPRB, 0.37009423E-03_JPRB, 0.37005078E-03_JPRB, 0.37000969E-03_JPRB, 0.36997063E-03_JPRB, &
  & 0.36993303E-03_JPRB, 0.36989633E-03_JPRB, 0.36985922E-03_JPRB, 0.36982092E-03_JPRB, 0.36978006E-03_JPRB, 0.36973611E-03_JPRB, &
  & 0.36968908E-03_JPRB, 0.36963692E-03_JPRB, 0.36957770E-03_JPRB, 0.36946323E-03_JPRB /)

RGHG1(:,28, 1) = (/ &
  & 0.36925892E-03_JPRB, 0.36931635E-03_JPRB, 0.36935601E-03_JPRB, 0.36939653E-03_JPRB, 0.36944228E-03_JPRB, 0.36949458E-03_JPRB, &
  & 0.36955328E-03_JPRB, 0.36961693E-03_JPRB, 0.36968448E-03_JPRB, 0.36975543E-03_JPRB, 0.36982854E-03_JPRB, 0.36990319E-03_JPRB, &
  & 0.36997837E-03_JPRB, 0.37005352E-03_JPRB, 0.37012776E-03_JPRB, 0.37020072E-03_JPRB, 0.37027098E-03_JPRB, 0.37033815E-03_JPRB, &
  & 0.37040102E-03_JPRB, 0.37045882E-03_JPRB, 0.37051071E-03_JPRB, 0.37055628E-03_JPRB, 0.37059555E-03_JPRB, 0.37062896E-03_JPRB, &
  & 0.37065678E-03_JPRB, 0.37067907E-03_JPRB, 0.37069642E-03_JPRB, 0.37070934E-03_JPRB, 0.37071842E-03_JPRB, 0.37072480E-03_JPRB, &
  & 0.37072928E-03_JPRB, 0.37073184E-03_JPRB, 0.37073309E-03_JPRB, 0.37073184E-03_JPRB, 0.37072785E-03_JPRB, 0.37072017E-03_JPRB, &
  & 0.37070824E-03_JPRB, 0.37069200E-03_JPRB, 0.37067148E-03_JPRB, 0.37064700E-03_JPRB, 0.37061851E-03_JPRB, 0.37058612E-03_JPRB, &
  & 0.37054956E-03_JPRB, 0.37050902E-03_JPRB, 0.37046432E-03_JPRB, 0.37041676E-03_JPRB, 0.37036792E-03_JPRB, 0.37031944E-03_JPRB, &
  & 0.37027276E-03_JPRB, 0.37022852E-03_JPRB, 0.37018699E-03_JPRB, 0.37014831E-03_JPRB, 0.37011204E-03_JPRB, 0.37007785E-03_JPRB, &
  & 0.37004508E-03_JPRB, 0.37001306E-03_JPRB, 0.36998087E-03_JPRB, 0.36994717E-03_JPRB, 0.36991120E-03_JPRB, 0.36987226E-03_JPRB, &
  & 0.36983009E-03_JPRB, 0.36978500E-03_JPRB, 0.36972910E-03_JPRB, 0.36962764E-03_JPRB /)

RGHG1(:,29, 1) = (/ &
  & 0.36936387E-03_JPRB, 0.36941943E-03_JPRB, 0.36945677E-03_JPRB, 0.36949466E-03_JPRB, 0.36953719E-03_JPRB, 0.36958582E-03_JPRB, &
  & 0.36963981E-03_JPRB, 0.36969813E-03_JPRB, 0.36975998E-03_JPRB, 0.36982482E-03_JPRB, 0.36989196E-03_JPRB, 0.36996102E-03_JPRB, &
  & 0.37003128E-03_JPRB, 0.37010192E-03_JPRB, 0.37017249E-03_JPRB, 0.37024214E-03_JPRB, 0.37031021E-03_JPRB, 0.37037564E-03_JPRB, &
  & 0.37043725E-03_JPRB, 0.37049453E-03_JPRB, 0.37054677E-03_JPRB, 0.37059392E-03_JPRB, 0.37063553E-03_JPRB, 0.37067203E-03_JPRB, &
  & 0.37070338E-03_JPRB, 0.37072907E-03_JPRB, 0.37074936E-03_JPRB, 0.37076432E-03_JPRB, 0.37077448E-03_JPRB, 0.37078076E-03_JPRB, &
  & 0.37078396E-03_JPRB, 0.37078466E-03_JPRB, 0.37078318E-03_JPRB, 0.37077931E-03_JPRB, 0.37077288E-03_JPRB, 0.37076380E-03_JPRB, &
  & 0.37075108E-03_JPRB, 0.37073516E-03_JPRB, 0.37071592E-03_JPRB, 0.37069360E-03_JPRB, 0.37066781E-03_JPRB, 0.37063845E-03_JPRB, &
  & 0.37060515E-03_JPRB, 0.37056778E-03_JPRB, 0.37052640E-03_JPRB, 0.37048204E-03_JPRB, 0.37043612E-03_JPRB, 0.37039080E-03_JPRB, &
  & 0.37034726E-03_JPRB, 0.37030654E-03_JPRB, 0.37026856E-03_JPRB, 0.37023352E-03_JPRB, 0.37020099E-03_JPRB, 0.37017028E-03_JPRB, &
  & 0.37014115E-03_JPRB, 0.37011283E-03_JPRB, 0.37008422E-03_JPRB, 0.37005445E-03_JPRB, 0.37002240E-03_JPRB, 0.36998803E-03_JPRB, &
  & 0.36995119E-03_JPRB, 0.36991129E-03_JPRB, 0.36986390E-03_JPRB, 0.36977517E-03_JPRB /)

RGHG1(:,30, 1) = (/ &
  & 0.36947036E-03_JPRB, 0.36952336E-03_JPRB, 0.36955858E-03_JPRB, 0.36959336E-03_JPRB, 0.36963256E-03_JPRB, 0.36967680E-03_JPRB, &
  & 0.36972607E-03_JPRB, 0.36977901E-03_JPRB, 0.36983503E-03_JPRB, 0.36989345E-03_JPRB, 0.36995456E-03_JPRB, 0.37001786E-03_JPRB, &
  & 0.37008274E-03_JPRB, 0.37014877E-03_JPRB, 0.37021568E-03_JPRB, 0.37028198E-03_JPRB, 0.37034746E-03_JPRB, 0.37041074E-03_JPRB, &
  & 0.37047072E-03_JPRB, 0.37052683E-03_JPRB, 0.37057872E-03_JPRB, 0.37062622E-03_JPRB, 0.37066909E-03_JPRB, 0.37070736E-03_JPRB, &
  & 0.37074057E-03_JPRB, 0.37076825E-03_JPRB, 0.37079057E-03_JPRB, 0.37080713E-03_JPRB, 0.37081836E-03_JPRB, 0.37082500E-03_JPRB, &
  & 0.37082794E-03_JPRB, 0.37082753E-03_JPRB, 0.37082468E-03_JPRB, 0.37081918E-03_JPRB, 0.37081158E-03_JPRB, 0.37080151E-03_JPRB, &
  & 0.37078880E-03_JPRB, 0.37077372E-03_JPRB, 0.37075614E-03_JPRB, 0.37073606E-03_JPRB, 0.37071286E-03_JPRB, 0.37068638E-03_JPRB, &
  & 0.37065611E-03_JPRB, 0.37062145E-03_JPRB, 0.37058303E-03_JPRB, 0.37054141E-03_JPRB, 0.37049828E-03_JPRB, 0.37045547E-03_JPRB, &
  & 0.37041461E-03_JPRB, 0.37037654E-03_JPRB, 0.37034153E-03_JPRB, 0.37030934E-03_JPRB, 0.37027939E-03_JPRB, 0.37025148E-03_JPRB, &
  & 0.37022485E-03_JPRB, 0.37019904E-03_JPRB, 0.37017313E-03_JPRB, 0.37014612E-03_JPRB, 0.37011746E-03_JPRB, 0.37008687E-03_JPRB, &
  & 0.37005471E-03_JPRB, 0.37002066E-03_JPRB, 0.36998061E-03_JPRB, 0.36990471E-03_JPRB /)

RGHG1(:,31, 1) = (/ &
  & 0.36957799E-03_JPRB, 0.36962799E-03_JPRB, 0.36966053E-03_JPRB, 0.36969245E-03_JPRB, 0.36972752E-03_JPRB, 0.36976766E-03_JPRB, &
  & 0.36981201E-03_JPRB, 0.36985974E-03_JPRB, 0.36990986E-03_JPRB, 0.36996230E-03_JPRB, 0.37001722E-03_JPRB, 0.37007459E-03_JPRB, &
  & 0.37013437E-03_JPRB, 0.37019595E-03_JPRB, 0.37025876E-03_JPRB, 0.37032197E-03_JPRB, 0.37038466E-03_JPRB, 0.37044557E-03_JPRB, &
  & 0.37050372E-03_JPRB, 0.37055856E-03_JPRB, 0.37060969E-03_JPRB, 0.37065678E-03_JPRB, 0.37069977E-03_JPRB, 0.37073847E-03_JPRB, &
  & 0.37077241E-03_JPRB, 0.37080108E-03_JPRB, 0.37082421E-03_JPRB, 0.37084159E-03_JPRB, 0.37085358E-03_JPRB, 0.37086057E-03_JPRB, &
  & 0.37086359E-03_JPRB, 0.37086304E-03_JPRB, 0.37085934E-03_JPRB, 0.37085341E-03_JPRB, 0.37084505E-03_JPRB, 0.37083495E-03_JPRB, &
  & 0.37082282E-03_JPRB, 0.37080891E-03_JPRB, 0.37079299E-03_JPRB, 0.37077497E-03_JPRB, 0.37075437E-03_JPRB, 0.37073030E-03_JPRB, &
  & 0.37070244E-03_JPRB, 0.37067026E-03_JPRB, 0.37063449E-03_JPRB, 0.37059546E-03_JPRB, 0.37055477E-03_JPRB, 0.37051452E-03_JPRB, &
  & 0.37047581E-03_JPRB, 0.37044013E-03_JPRB, 0.37040739E-03_JPRB, 0.37037709E-03_JPRB, 0.37034921E-03_JPRB, 0.37032305E-03_JPRB, &
  & 0.37029834E-03_JPRB, 0.37027424E-03_JPRB, 0.37025017E-03_JPRB, 0.37022526E-03_JPRB, 0.37019904E-03_JPRB, 0.37017168E-03_JPRB, &
  & 0.37014339E-03_JPRB, 0.37011437E-03_JPRB, 0.37007977E-03_JPRB, 0.37001743E-03_JPRB /)

RGHG1(:,32, 1) = (/ &
  & 0.36968512E-03_JPRB, 0.36973180E-03_JPRB, 0.36976152E-03_JPRB, 0.36979018E-03_JPRB, 0.36982185E-03_JPRB, 0.36985753E-03_JPRB, &
  & 0.36989737E-03_JPRB, 0.36994013E-03_JPRB, 0.36998457E-03_JPRB, 0.37003125E-03_JPRB, 0.37008041E-03_JPRB, 0.37013213E-03_JPRB, &
  & 0.37018667E-03_JPRB, 0.37024409E-03_JPRB, 0.37030331E-03_JPRB, 0.37036353E-03_JPRB, 0.37042372E-03_JPRB, 0.37048248E-03_JPRB, &
  & 0.37053882E-03_JPRB, 0.37059220E-03_JPRB, 0.37064214E-03_JPRB, 0.37068827E-03_JPRB, 0.37073050E-03_JPRB, 0.37076854E-03_JPRB, &
  & 0.37080180E-03_JPRB, 0.37082992E-03_JPRB, 0.37085288E-03_JPRB, 0.37087032E-03_JPRB, 0.37088251E-03_JPRB, 0.37088981E-03_JPRB, &
  & 0.37089302E-03_JPRB, 0.37089267E-03_JPRB, 0.37088909E-03_JPRB, 0.37088303E-03_JPRB, 0.37087486E-03_JPRB, 0.37086522E-03_JPRB, &
  & 0.37085413E-03_JPRB, 0.37084162E-03_JPRB, 0.37082739E-03_JPRB, 0.37081126E-03_JPRB, 0.37079246E-03_JPRB, 0.37077052E-03_JPRB, &
  & 0.37074473E-03_JPRB, 0.37071487E-03_JPRB, 0.37068111E-03_JPRB, 0.37064438E-03_JPRB, 0.37060608E-03_JPRB, 0.37056787E-03_JPRB, &
  & 0.37053160E-03_JPRB, 0.37049779E-03_JPRB, 0.37046673E-03_JPRB, 0.37043809E-03_JPRB, 0.37041158E-03_JPRB, 0.37038681E-03_JPRB, &
  & 0.37036318E-03_JPRB, 0.37034039E-03_JPRB, 0.37031775E-03_JPRB, 0.37029450E-03_JPRB, 0.37027037E-03_JPRB, 0.37024543E-03_JPRB, &
  & 0.37022034E-03_JPRB, 0.37019447E-03_JPRB, 0.37016568E-03_JPRB, 0.37011146E-03_JPRB /)

RGHG1(:,33, 1) = (/ &
  & 0.36979074E-03_JPRB, 0.36983305E-03_JPRB, 0.36985986E-03_JPRB, 0.36988559E-03_JPRB, 0.36991364E-03_JPRB, 0.36994577E-03_JPRB, &
  & 0.36998137E-03_JPRB, 0.37001958E-03_JPRB, 0.37005934E-03_JPRB, 0.37010075E-03_JPRB, 0.37014417E-03_JPRB, 0.37019036E-03_JPRB, &
  & 0.37023969E-03_JPRB, 0.37029249E-03_JPRB, 0.37034828E-03_JPRB, 0.37040620E-03_JPRB, 0.37046429E-03_JPRB, 0.37052159E-03_JPRB, &
  & 0.37057669E-03_JPRB, 0.37062867E-03_JPRB, 0.37067721E-03_JPRB, 0.37072183E-03_JPRB, 0.37076272E-03_JPRB, 0.37079881E-03_JPRB, &
  & 0.37083027E-03_JPRB, 0.37085678E-03_JPRB, 0.37087832E-03_JPRB, 0.37089497E-03_JPRB, 0.37090690E-03_JPRB, 0.37091432E-03_JPRB, &
  & 0.37091770E-03_JPRB, 0.37091761E-03_JPRB, 0.37091452E-03_JPRB, 0.37090905E-03_JPRB, 0.37090178E-03_JPRB, 0.37089307E-03_JPRB, &
  & 0.37088321E-03_JPRB, 0.37087197E-03_JPRB, 0.37085952E-03_JPRB, 0.37084505E-03_JPRB, 0.37082809E-03_JPRB, 0.37080780E-03_JPRB, &
  & 0.37078356E-03_JPRB, 0.37075527E-03_JPRB, 0.37072331E-03_JPRB, 0.37068850E-03_JPRB, 0.37065236E-03_JPRB, 0.37061650E-03_JPRB, &
  & 0.37058225E-03_JPRB, 0.37055020E-03_JPRB, 0.37052066E-03_JPRB, 0.37049333E-03_JPRB, 0.37046801E-03_JPRB, 0.37044426E-03_JPRB, &
  & 0.37042156E-03_JPRB, 0.37039968E-03_JPRB, 0.37037791E-03_JPRB, 0.37035582E-03_JPRB, 0.37033312E-03_JPRB, 0.37031012E-03_JPRB, &
  & 0.37028713E-03_JPRB, 0.37026426E-03_JPRB, 0.37023739E-03_JPRB, 0.37019103E-03_JPRB /)

RGHG1(:,34, 1) = (/ &
  & 0.36989216E-03_JPRB, 0.36993079E-03_JPRB, 0.36995474E-03_JPRB, 0.36997773E-03_JPRB, 0.37000293E-03_JPRB, 0.37003154E-03_JPRB, &
  & 0.37006341E-03_JPRB, 0.37009758E-03_JPRB, 0.37013274E-03_JPRB, 0.37016929E-03_JPRB, 0.37020759E-03_JPRB, 0.37024860E-03_JPRB, &
  & 0.37029307E-03_JPRB, 0.37034170E-03_JPRB, 0.37039444E-03_JPRB, 0.37045003E-03_JPRB, 0.37050675E-03_JPRB, 0.37056298E-03_JPRB, &
  & 0.37061705E-03_JPRB, 0.37066781E-03_JPRB, 0.37071493E-03_JPRB, 0.37075806E-03_JPRB, 0.37079657E-03_JPRB, 0.37083018E-03_JPRB, &
  & 0.37085853E-03_JPRB, 0.37088239E-03_JPRB, 0.37090166E-03_JPRB, 0.37091674E-03_JPRB, 0.37092762E-03_JPRB, 0.37093455E-03_JPRB, &
  & 0.37093810E-03_JPRB, 0.37093851E-03_JPRB, 0.37093626E-03_JPRB, 0.37093187E-03_JPRB, 0.37092567E-03_JPRB, 0.37091839E-03_JPRB, &
  & 0.37090993E-03_JPRB, 0.37090029E-03_JPRB, 0.37088949E-03_JPRB, 0.37087672E-03_JPRB, 0.37086121E-03_JPRB, 0.37084220E-03_JPRB, &
  & 0.37081912E-03_JPRB, 0.37079206E-03_JPRB, 0.37076135E-03_JPRB, 0.37072838E-03_JPRB, 0.37069430E-03_JPRB, 0.37066036E-03_JPRB, &
  & 0.37062800E-03_JPRB, 0.37059758E-03_JPRB, 0.37056932E-03_JPRB, 0.37054322E-03_JPRB, 0.37051865E-03_JPRB, 0.37049569E-03_JPRB, &
  & 0.37047375E-03_JPRB, 0.37045250E-03_JPRB, 0.37043152E-03_JPRB, 0.37041030E-03_JPRB, 0.37038873E-03_JPRB, 0.37036705E-03_JPRB, &
  & 0.37034563E-03_JPRB, 0.37032375E-03_JPRB, 0.37029994E-03_JPRB, 0.37025689E-03_JPRB /)

RGHG1(:,35, 1) = (/ &
  & 0.36998940E-03_JPRB, 0.37002400E-03_JPRB, 0.37004548E-03_JPRB, 0.37006591E-03_JPRB, 0.37008841E-03_JPRB, 0.37011426E-03_JPRB, &
  & 0.37014281E-03_JPRB, 0.37017337E-03_JPRB, 0.37020465E-03_JPRB, 0.37023684E-03_JPRB, 0.37027034E-03_JPRB, 0.37030643E-03_JPRB, &
  & 0.37034636E-03_JPRB, 0.37039109E-03_JPRB, 0.37044086E-03_JPRB, 0.37049450E-03_JPRB, 0.37055011E-03_JPRB, 0.37060562E-03_JPRB, &
  & 0.37065893E-03_JPRB, 0.37070870E-03_JPRB, 0.37075448E-03_JPRB, 0.37079543E-03_JPRB, 0.37083117E-03_JPRB, 0.37086126E-03_JPRB, &
  & 0.37088618E-03_JPRB, 0.37090652E-03_JPRB, 0.37092261E-03_JPRB, 0.37093533E-03_JPRB, 0.37094444E-03_JPRB, 0.37095073E-03_JPRB, &
  & 0.37095402E-03_JPRB, 0.37095498E-03_JPRB, 0.37095364E-03_JPRB, 0.37095044E-03_JPRB, 0.37094567E-03_JPRB, 0.37093990E-03_JPRB, &
  & 0.37093318E-03_JPRB, 0.37092538E-03_JPRB, 0.37091621E-03_JPRB, 0.37090504E-03_JPRB, 0.37089107E-03_JPRB, 0.37087328E-03_JPRB, &
  & 0.37085128E-03_JPRB, 0.37082512E-03_JPRB, 0.37079575E-03_JPRB, 0.37076426E-03_JPRB, 0.37073175E-03_JPRB, 0.37069988E-03_JPRB, &
  & 0.37066909E-03_JPRB, 0.37064005E-03_JPRB, 0.37061289E-03_JPRB, 0.37058754E-03_JPRB, 0.37056379E-03_JPRB, 0.37054138E-03_JPRB, &
  & 0.37052005E-03_JPRB, 0.37049930E-03_JPRB, 0.37047896E-03_JPRB, 0.37045832E-03_JPRB, 0.37043780E-03_JPRB, 0.37041714E-03_JPRB, &
  & 0.37039659E-03_JPRB, 0.37037628E-03_JPRB, 0.37035294E-03_JPRB, 0.37031344E-03_JPRB /)

RGHG1(:,36, 1) = (/ &
  & 0.37008175E-03_JPRB, 0.37011292E-03_JPRB, 0.37013186E-03_JPRB, 0.37015005E-03_JPRB, 0.37017014E-03_JPRB, 0.37019319E-03_JPRB, &
  & 0.37021906E-03_JPRB, 0.37024642E-03_JPRB, 0.37027430E-03_JPRB, 0.37030241E-03_JPRB, 0.37033160E-03_JPRB, 0.37036301E-03_JPRB, &
  & 0.37039828E-03_JPRB, 0.37043905E-03_JPRB, 0.37048582E-03_JPRB, 0.37053748E-03_JPRB, 0.37059223E-03_JPRB, 0.37064738E-03_JPRB, &
  & 0.37070061E-03_JPRB, 0.37075000E-03_JPRB, 0.37079424E-03_JPRB, 0.37083274E-03_JPRB, 0.37086505E-03_JPRB, 0.37089104E-03_JPRB, &
  & 0.37091138E-03_JPRB, 0.37092748E-03_JPRB, 0.37093996E-03_JPRB, 0.37094977E-03_JPRB, 0.37095710E-03_JPRB, 0.37096220E-03_JPRB, &
  & 0.37096516E-03_JPRB, 0.37096627E-03_JPRB, 0.37096557E-03_JPRB, 0.37096353E-03_JPRB, 0.37096016E-03_JPRB, 0.37095576E-03_JPRB, &
  & 0.37095053E-03_JPRB, 0.37094444E-03_JPRB, 0.37093705E-03_JPRB, 0.37092791E-03_JPRB, 0.37091569E-03_JPRB, 0.37089974E-03_JPRB, &
  & 0.37087916E-03_JPRB, 0.37085442E-03_JPRB, 0.37082628E-03_JPRB, 0.37079613E-03_JPRB, 0.37076543E-03_JPRB, 0.37073507E-03_JPRB, &
  & 0.37070585E-03_JPRB, 0.37067791E-03_JPRB, 0.37065163E-03_JPRB, 0.37062683E-03_JPRB, 0.37060364E-03_JPRB, 0.37058175E-03_JPRB, &
  & 0.37056088E-03_JPRB, 0.37054069E-03_JPRB, 0.37052072E-03_JPRB, 0.37050096E-03_JPRB, 0.37048096E-03_JPRB, 0.37046103E-03_JPRB, &
  & 0.37044147E-03_JPRB, 0.37042171E-03_JPRB, 0.37040014E-03_JPRB, 0.37036228E-03_JPRB /)

RGHG1(:,37, 1) = (/ &
  & 0.37016990E-03_JPRB, 0.37019726E-03_JPRB, 0.37021394E-03_JPRB, 0.37023003E-03_JPRB, 0.37024816E-03_JPRB, 0.37026906E-03_JPRB, &
  & 0.37029237E-03_JPRB, 0.37031685E-03_JPRB, 0.37034153E-03_JPRB, 0.37036609E-03_JPRB, 0.37039115E-03_JPRB, 0.37041804E-03_JPRB, &
  & 0.37044898E-03_JPRB, 0.37048553E-03_JPRB, 0.37052931E-03_JPRB, 0.37057936E-03_JPRB, 0.37063315E-03_JPRB, 0.37068804E-03_JPRB, &
  & 0.37074107E-03_JPRB, 0.37078978E-03_JPRB, 0.37083213E-03_JPRB, 0.37086740E-03_JPRB, 0.37089502E-03_JPRB, 0.37091607E-03_JPRB, &
  & 0.37093167E-03_JPRB, 0.37094360E-03_JPRB, 0.37095268E-03_JPRB, 0.37095987E-03_JPRB, 0.37096537E-03_JPRB, 0.37096944E-03_JPRB, &
  & 0.37097200E-03_JPRB, 0.37097323E-03_JPRB, 0.37097308E-03_JPRB, 0.37097168E-03_JPRB, 0.37096921E-03_JPRB, 0.37096604E-03_JPRB, &
  & 0.37096202E-03_JPRB, 0.37095725E-03_JPRB, 0.37095137E-03_JPRB, 0.37094398E-03_JPRB, 0.37093385E-03_JPRB, 0.37092011E-03_JPRB, &
  & 0.37090210E-03_JPRB, 0.37087934E-03_JPRB, 0.37085285E-03_JPRB, 0.37082430E-03_JPRB, 0.37079511E-03_JPRB, 0.37076633E-03_JPRB, &
  & 0.37073821E-03_JPRB, 0.37071123E-03_JPRB, 0.37068562E-03_JPRB, 0.37066126E-03_JPRB, 0.37063839E-03_JPRB, 0.37061691E-03_JPRB, &
  & 0.37059662E-03_JPRB, 0.37057701E-03_JPRB, 0.37055765E-03_JPRB, 0.37053844E-03_JPRB, 0.37051918E-03_JPRB, 0.37049997E-03_JPRB, &
  & 0.37048108E-03_JPRB, 0.37046243E-03_JPRB, 0.37044156E-03_JPRB, 0.37040617E-03_JPRB /)

RGHG1(:,38, 1) = (/ &
  & 0.37025305E-03_JPRB, 0.37027671E-03_JPRB, 0.37029124E-03_JPRB, 0.37030573E-03_JPRB, 0.37032203E-03_JPRB, 0.37034115E-03_JPRB, &
  & 0.37036225E-03_JPRB, 0.37038431E-03_JPRB, 0.37040596E-03_JPRB, 0.37042721E-03_JPRB, 0.37044840E-03_JPRB, 0.37047145E-03_JPRB, &
  & 0.37049773E-03_JPRB, 0.37053030E-03_JPRB, 0.37057049E-03_JPRB, 0.37061854E-03_JPRB, 0.37067165E-03_JPRB, 0.37072622E-03_JPRB, &
  & 0.37077867E-03_JPRB, 0.37082576E-03_JPRB, 0.37086505E-03_JPRB, 0.37089555E-03_JPRB, 0.37091807E-03_JPRB, 0.37093408E-03_JPRB, &
  & 0.37094561E-03_JPRB, 0.37095443E-03_JPRB, 0.37096097E-03_JPRB, 0.37096636E-03_JPRB, 0.37097058E-03_JPRB, 0.37097401E-03_JPRB, &
  & 0.37097625E-03_JPRB, 0.37097736E-03_JPRB, 0.37097756E-03_JPRB, 0.37097652E-03_JPRB, 0.37097474E-03_JPRB, 0.37097224E-03_JPRB, &
  & 0.37096906E-03_JPRB, 0.37096531E-03_JPRB, 0.37096054E-03_JPRB, 0.37095448E-03_JPRB, 0.37094610E-03_JPRB, 0.37093463E-03_JPRB, &
  & 0.37091906E-03_JPRB, 0.37089890E-03_JPRB, 0.37087497E-03_JPRB, 0.37084837E-03_JPRB, 0.37082107E-03_JPRB, 0.37079348E-03_JPRB, &
  & 0.37076650E-03_JPRB, 0.37074031E-03_JPRB, 0.37071522E-03_JPRB, 0.37069130E-03_JPRB, 0.37066886E-03_JPRB, 0.37064793E-03_JPRB, &
  & 0.37062832E-03_JPRB, 0.37060952E-03_JPRB, 0.37059109E-03_JPRB, 0.37057267E-03_JPRB, 0.37055393E-03_JPRB, 0.37053521E-03_JPRB, &
  & 0.37051699E-03_JPRB, 0.37049886E-03_JPRB, 0.37047931E-03_JPRB, 0.37044613E-03_JPRB /)

RGHG1(:,39, 1) = (/ &
  & 0.37033088E-03_JPRB, 0.37035084E-03_JPRB, 0.37036359E-03_JPRB, 0.37037631E-03_JPRB, 0.37039135E-03_JPRB, 0.37040890E-03_JPRB, &
  & 0.37042826E-03_JPRB, 0.37044793E-03_JPRB, 0.37046702E-03_JPRB, 0.37048513E-03_JPRB, 0.37050320E-03_JPRB, 0.37052226E-03_JPRB, &
  & 0.37054488E-03_JPRB, 0.37057293E-03_JPRB, 0.37060963E-03_JPRB, 0.37065503E-03_JPRB, 0.37070678E-03_JPRB, 0.37076062E-03_JPRB, &
  & 0.37081176E-03_JPRB, 0.37085591E-03_JPRB, 0.37089063E-03_JPRB, 0.37091610E-03_JPRB, 0.37093379E-03_JPRB, 0.37094601E-03_JPRB, &
  & 0.37095469E-03_JPRB, 0.37096121E-03_JPRB, 0.37096633E-03_JPRB, 0.37097058E-03_JPRB, 0.37097410E-03_JPRB, 0.37097695E-03_JPRB, &
  & 0.37097908E-03_JPRB, 0.37098018E-03_JPRB, 0.37098047E-03_JPRB, 0.37097972E-03_JPRB, 0.37097829E-03_JPRB, 0.37097622E-03_JPRB, &
  & 0.37097360E-03_JPRB, 0.37097052E-03_JPRB, 0.37096659E-03_JPRB, 0.37096141E-03_JPRB, 0.37095448E-03_JPRB, 0.37094485E-03_JPRB, &
  & 0.37093155E-03_JPRB, 0.37091403E-03_JPRB, 0.37089264E-03_JPRB, 0.37086842E-03_JPRB, 0.37084284E-03_JPRB, 0.37081676E-03_JPRB, &
  & 0.37079092E-03_JPRB, 0.37076540E-03_JPRB, 0.37074066E-03_JPRB, 0.37071720E-03_JPRB, 0.37069526E-03_JPRB, 0.37067517E-03_JPRB, &
  & 0.37065661E-03_JPRB, 0.37063909E-03_JPRB, 0.37062183E-03_JPRB, 0.37060431E-03_JPRB, 0.37058623E-03_JPRB, 0.37056801E-03_JPRB, &
  & 0.37055017E-03_JPRB, 0.37053280E-03_JPRB, 0.37051417E-03_JPRB, 0.37048312E-03_JPRB /)

RGHG1(:,40, 1) = (/ &
  & 0.37040206E-03_JPRB, 0.37041918E-03_JPRB, 0.37043024E-03_JPRB, 0.37044179E-03_JPRB, 0.37045535E-03_JPRB, 0.37047162E-03_JPRB, &
  & 0.37048917E-03_JPRB, 0.37050681E-03_JPRB, 0.37052354E-03_JPRB, 0.37053926E-03_JPRB, 0.37055431E-03_JPRB, 0.37057060E-03_JPRB, &
  & 0.37058935E-03_JPRB, 0.37061394E-03_JPRB, 0.37064654E-03_JPRB, 0.37068909E-03_JPRB, 0.37073906E-03_JPRB, 0.37079115E-03_JPRB, &
  & 0.37083949E-03_JPRB, 0.37087937E-03_JPRB, 0.37090911E-03_JPRB, 0.37092992E-03_JPRB, 0.37094398E-03_JPRB, 0.37095370E-03_JPRB, &
  & 0.37096060E-03_JPRB, 0.37096578E-03_JPRB, 0.37097005E-03_JPRB, 0.37097360E-03_JPRB, 0.37097660E-03_JPRB, 0.37097911E-03_JPRB, &
  & 0.37098100E-03_JPRB, 0.37098216E-03_JPRB, 0.37098248E-03_JPRB, 0.37098184E-03_JPRB, 0.37098071E-03_JPRB, 0.37097896E-03_JPRB, &
  & 0.37097672E-03_JPRB, 0.37097407E-03_JPRB, 0.37097067E-03_JPRB, 0.37096627E-03_JPRB, 0.37096042E-03_JPRB, 0.37095213E-03_JPRB, &
  & 0.37094072E-03_JPRB, 0.37092538E-03_JPRB, 0.37090652E-03_JPRB, 0.37088461E-03_JPRB, 0.37086097E-03_JPRB, 0.37083641E-03_JPRB, &
  & 0.37081161E-03_JPRB, 0.37078705E-03_JPRB, 0.37076289E-03_JPRB, 0.37073993E-03_JPRB, 0.37071874E-03_JPRB, 0.37069950E-03_JPRB, &
  & 0.37068225E-03_JPRB, 0.37066604E-03_JPRB, 0.37065017E-03_JPRB, 0.37063390E-03_JPRB, 0.37061685E-03_JPRB, 0.37059913E-03_JPRB, &
  & 0.37058175E-03_JPRB, 0.37056502E-03_JPRB, 0.37054747E-03_JPRB, 0.37051836E-03_JPRB /)

RGHG1(:,41, 1) = (/ &
  & 0.37046606E-03_JPRB, 0.37048076E-03_JPRB, 0.37049048E-03_JPRB, 0.37050099E-03_JPRB, 0.37051379E-03_JPRB, 0.37052887E-03_JPRB, &
  & 0.37054502E-03_JPRB, 0.37056074E-03_JPRB, 0.37057535E-03_JPRB, 0.37058882E-03_JPRB, 0.37060189E-03_JPRB, 0.37061539E-03_JPRB, &
  & 0.37063166E-03_JPRB, 0.37065244E-03_JPRB, 0.37068158E-03_JPRB, 0.37072072E-03_JPRB, 0.37076836E-03_JPRB, 0.37081790E-03_JPRB, &
  & 0.37086220E-03_JPRB, 0.37089735E-03_JPRB, 0.37092250E-03_JPRB, 0.37093958E-03_JPRB, 0.37095108E-03_JPRB, 0.37095902E-03_JPRB, &
  & 0.37096470E-03_JPRB, 0.37096906E-03_JPRB, 0.37097273E-03_JPRB, 0.37097585E-03_JPRB, 0.37097847E-03_JPRB, 0.37098085E-03_JPRB, &
  & 0.37098269E-03_JPRB, 0.37098376E-03_JPRB, 0.37098399E-03_JPRB, 0.37098350E-03_JPRB, 0.37098254E-03_JPRB, 0.37098100E-03_JPRB, &
  & 0.37097908E-03_JPRB, 0.37097681E-03_JPRB, 0.37097384E-03_JPRB, 0.37096991E-03_JPRB, 0.37096476E-03_JPRB, 0.37095754E-03_JPRB, &
  & 0.37094759E-03_JPRB, 0.37093426E-03_JPRB, 0.37091743E-03_JPRB, 0.37089767E-03_JPRB, 0.37087593E-03_JPRB, 0.37085294E-03_JPRB, &
  & 0.37082957E-03_JPRB, 0.37080588E-03_JPRB, 0.37078233E-03_JPRB, 0.37076001E-03_JPRB, 0.37073938E-03_JPRB, 0.37072136E-03_JPRB, &
  & 0.37070530E-03_JPRB, 0.37069066E-03_JPRB, 0.37067634E-03_JPRB, 0.37066164E-03_JPRB, 0.37064584E-03_JPRB, 0.37062919E-03_JPRB, &
  & 0.37061254E-03_JPRB, 0.37059677E-03_JPRB, 0.37058024E-03_JPRB, 0.37055300E-03_JPRB /)

RGHG1(:,42, 1) = (/ &
  & 0.37052314E-03_JPRB, 0.37053588E-03_JPRB, 0.37054470E-03_JPRB, 0.37055428E-03_JPRB, 0.37056638E-03_JPRB, 0.37058062E-03_JPRB, &
  & 0.37059543E-03_JPRB, 0.37060957E-03_JPRB, 0.37062238E-03_JPRB, 0.37063420E-03_JPRB, 0.37064537E-03_JPRB, 0.37065722E-03_JPRB, &
  & 0.37067092E-03_JPRB, 0.37068932E-03_JPRB, 0.37071487E-03_JPRB, 0.37075087E-03_JPRB, 0.37079529E-03_JPRB, 0.37084130E-03_JPRB, &
  & 0.37088129E-03_JPRB, 0.37091135E-03_JPRB, 0.37093248E-03_JPRB, 0.37094671E-03_JPRB, 0.37095626E-03_JPRB, 0.37096289E-03_JPRB, &
  & 0.37096781E-03_JPRB, 0.37097163E-03_JPRB, 0.37097489E-03_JPRB, 0.37097777E-03_JPRB, 0.37098021E-03_JPRB, 0.37098234E-03_JPRB, &
  & 0.37098408E-03_JPRB, 0.37098507E-03_JPRB, 0.37098533E-03_JPRB, 0.37098490E-03_JPRB, 0.37098391E-03_JPRB, 0.37098254E-03_JPRB, &
  & 0.37098085E-03_JPRB, 0.37097884E-03_JPRB, 0.37097622E-03_JPRB, 0.37097273E-03_JPRB, 0.37096819E-03_JPRB, 0.37096190E-03_JPRB, &
  & 0.37095323E-03_JPRB, 0.37094156E-03_JPRB, 0.37092654E-03_JPRB, 0.37090853E-03_JPRB, 0.37088865E-03_JPRB, 0.37086755E-03_JPRB, &
  & 0.37084546E-03_JPRB, 0.37082270E-03_JPRB, 0.37079988E-03_JPRB, 0.37077803E-03_JPRB, 0.37075829E-03_JPRB, 0.37074118E-03_JPRB, &
  & 0.37072672E-03_JPRB, 0.37071377E-03_JPRB, 0.37070113E-03_JPRB, 0.37068795E-03_JPRB, 0.37067372E-03_JPRB, 0.37065847E-03_JPRB, &
  & 0.37064310E-03_JPRB, 0.37062835E-03_JPRB, 0.37061278E-03_JPRB, 0.37058708E-03_JPRB /)

RGHG1(:,43, 1) = (/ &
  & 0.37057404E-03_JPRB, 0.37058551E-03_JPRB, 0.37059339E-03_JPRB, 0.37060259E-03_JPRB, 0.37061406E-03_JPRB, 0.37062759E-03_JPRB, &
  & 0.37064124E-03_JPRB, 0.37065390E-03_JPRB, 0.37066542E-03_JPRB, 0.37067579E-03_JPRB, 0.37068577E-03_JPRB, 0.37069601E-03_JPRB, &
  & 0.37070806E-03_JPRB, 0.37072375E-03_JPRB, 0.37074680E-03_JPRB, 0.37077922E-03_JPRB, 0.37082017E-03_JPRB, 0.37086179E-03_JPRB, &
  & 0.37089674E-03_JPRB, 0.37092267E-03_JPRB, 0.37094025E-03_JPRB, 0.37095213E-03_JPRB, 0.37096022E-03_JPRB, 0.37096598E-03_JPRB, &
  & 0.37097037E-03_JPRB, 0.37097384E-03_JPRB, 0.37097684E-03_JPRB, 0.37097954E-03_JPRB, 0.37098178E-03_JPRB, 0.37098376E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098621E-03_JPRB, 0.37098653E-03_JPRB, 0.37098609E-03_JPRB, 0.37098513E-03_JPRB, 0.37098394E-03_JPRB, &
  & 0.37098236E-03_JPRB, 0.37098050E-03_JPRB, 0.37097817E-03_JPRB, 0.37097512E-03_JPRB, 0.37097110E-03_JPRB, 0.37096560E-03_JPRB, &
  & 0.37095798E-03_JPRB, 0.37094759E-03_JPRB, 0.37093417E-03_JPRB, 0.37091796E-03_JPRB, 0.37089977E-03_JPRB, 0.37088027E-03_JPRB, &
  & 0.37085963E-03_JPRB, 0.37083813E-03_JPRB, 0.37081618E-03_JPRB, 0.37079526E-03_JPRB, 0.37077628E-03_JPRB, 0.37076068E-03_JPRB, &
  & 0.37074767E-03_JPRB, 0.37073623E-03_JPRB, 0.37072526E-03_JPRB, 0.37071377E-03_JPRB, 0.37070125E-03_JPRB, 0.37068772E-03_JPRB, &
  & 0.37067389E-03_JPRB, 0.37066051E-03_JPRB, 0.37064616E-03_JPRB, 0.37062209E-03_JPRB /)

RGHG1(:,44, 1) = (/ &
  & 0.37062020E-03_JPRB, 0.37063053E-03_JPRB, 0.37063786E-03_JPRB, 0.37064639E-03_JPRB, 0.37065739E-03_JPRB, 0.37067026E-03_JPRB, &
  & 0.37068315E-03_JPRB, 0.37069479E-03_JPRB, 0.37070518E-03_JPRB, 0.37071458E-03_JPRB, 0.37072340E-03_JPRB, 0.37073248E-03_JPRB, &
  & 0.37074296E-03_JPRB, 0.37075693E-03_JPRB, 0.37077680E-03_JPRB, 0.37080646E-03_JPRB, 0.37084342E-03_JPRB, 0.37088041E-03_JPRB, &
  & 0.37091033E-03_JPRB, 0.37093175E-03_JPRB, 0.37094639E-03_JPRB, 0.37095643E-03_JPRB, 0.37096345E-03_JPRB, 0.37096854E-03_JPRB, &
  & 0.37097253E-03_JPRB, 0.37097576E-03_JPRB, 0.37097852E-03_JPRB, 0.37098108E-03_JPRB, 0.37098327E-03_JPRB, 0.37098510E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098734E-03_JPRB, 0.37098755E-03_JPRB, 0.37098711E-03_JPRB, 0.37098626E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098367E-03_JPRB, 0.37098199E-03_JPRB, 0.37097983E-03_JPRB, 0.37097713E-03_JPRB, 0.37097355E-03_JPRB, 0.37096883E-03_JPRB, &
  & 0.37096205E-03_JPRB, 0.37095288E-03_JPRB, 0.37094089E-03_JPRB, 0.37092628E-03_JPRB, 0.37090966E-03_JPRB, 0.37089168E-03_JPRB, &
  & 0.37087267E-03_JPRB, 0.37085250E-03_JPRB, 0.37083193E-03_JPRB, 0.37081196E-03_JPRB, 0.37079444E-03_JPRB, 0.37078027E-03_JPRB, &
  & 0.37076866E-03_JPRB, 0.37075870E-03_JPRB, 0.37074916E-03_JPRB, 0.37073932E-03_JPRB, 0.37072858E-03_JPRB, 0.37071691E-03_JPRB, &
  & 0.37070495E-03_JPRB, 0.37069307E-03_JPRB, 0.37068012E-03_JPRB, 0.37065797E-03_JPRB /)

RGHG1(:,45, 1) = (/ &
  & 0.37066228E-03_JPRB, 0.37067203E-03_JPRB, 0.37067887E-03_JPRB, 0.37068696E-03_JPRB, 0.37069761E-03_JPRB, 0.37071001E-03_JPRB, &
  & 0.37072215E-03_JPRB, 0.37073309E-03_JPRB, 0.37074272E-03_JPRB, 0.37075131E-03_JPRB, 0.37075923E-03_JPRB, 0.37076720E-03_JPRB, &
  & 0.37077628E-03_JPRB, 0.37078827E-03_JPRB, 0.37080591E-03_JPRB, 0.37083178E-03_JPRB, 0.37086473E-03_JPRB, 0.37089654E-03_JPRB, &
  & 0.37092151E-03_JPRB, 0.37093920E-03_JPRB, 0.37095137E-03_JPRB, 0.37095996E-03_JPRB, 0.37096610E-03_JPRB, 0.37097075E-03_JPRB, &
  & 0.37097439E-03_JPRB, 0.37097745E-03_JPRB, 0.37098009E-03_JPRB, 0.37098260E-03_JPRB, 0.37098466E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098763E-03_JPRB, 0.37098833E-03_JPRB, 0.37098845E-03_JPRB, 0.37098807E-03_JPRB, 0.37098725E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098472E-03_JPRB, 0.37098315E-03_JPRB, 0.37098120E-03_JPRB, 0.37097879E-03_JPRB, 0.37097561E-03_JPRB, 0.37097142E-03_JPRB, &
  & 0.37096557E-03_JPRB, 0.37095757E-03_JPRB, 0.37094700E-03_JPRB, 0.37093391E-03_JPRB, 0.37091889E-03_JPRB, 0.37090236E-03_JPRB, &
  & 0.37088472E-03_JPRB, 0.37086630E-03_JPRB, 0.37084712E-03_JPRB, 0.37082881E-03_JPRB, 0.37081281E-03_JPRB, 0.37080026E-03_JPRB, &
  & 0.37079019E-03_JPRB, 0.37078158E-03_JPRB, 0.37077343E-03_JPRB, 0.37076502E-03_JPRB, 0.37075591E-03_JPRB, 0.37074616E-03_JPRB, &
  & 0.37073606E-03_JPRB, 0.37072596E-03_JPRB, 0.37071452E-03_JPRB, 0.37069470E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART2',0,ZHOOK_HANDLE)



RGHG1(:,46, 1) = (/ &
  & 0.37070140E-03_JPRB, 0.37071080E-03_JPRB, 0.37071740E-03_JPRB, 0.37072520E-03_JPRB, 0.37073545E-03_JPRB, 0.37074747E-03_JPRB, &
  & 0.37075917E-03_JPRB, 0.37076970E-03_JPRB, 0.37077875E-03_JPRB, 0.37078670E-03_JPRB, 0.37079374E-03_JPRB, 0.37080061E-03_JPRB, &
  & 0.37080847E-03_JPRB, 0.37081842E-03_JPRB, 0.37083362E-03_JPRB, 0.37085594E-03_JPRB, 0.37088405E-03_JPRB, 0.37091048E-03_JPRB, &
  & 0.37093085E-03_JPRB, 0.37094534E-03_JPRB, 0.37095550E-03_JPRB, 0.37096289E-03_JPRB, 0.37096840E-03_JPRB, 0.37097262E-03_JPRB, &
  & 0.37097599E-03_JPRB, 0.37097902E-03_JPRB, 0.37098158E-03_JPRB, 0.37098399E-03_JPRB, 0.37098597E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098868E-03_JPRB, 0.37098926E-03_JPRB, 0.37098935E-03_JPRB, 0.37098891E-03_JPRB, 0.37098807E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098560E-03_JPRB, 0.37098414E-03_JPRB, 0.37098239E-03_JPRB, 0.37098024E-03_JPRB, 0.37097745E-03_JPRB, 0.37097381E-03_JPRB, &
  & 0.37096866E-03_JPRB, 0.37096173E-03_JPRB, 0.37095253E-03_JPRB, 0.37094107E-03_JPRB, 0.37092750E-03_JPRB, 0.37091260E-03_JPRB, &
  & 0.37089680E-03_JPRB, 0.37087995E-03_JPRB, 0.37086249E-03_JPRB, 0.37084575E-03_JPRB, 0.37083207E-03_JPRB, 0.37082104E-03_JPRB, &
  & 0.37081257E-03_JPRB, 0.37080527E-03_JPRB, 0.37079828E-03_JPRB, 0.37079118E-03_JPRB, 0.37078353E-03_JPRB, 0.37077535E-03_JPRB, &
  & 0.37076708E-03_JPRB, 0.37075864E-03_JPRB, 0.37074907E-03_JPRB, 0.37073210E-03_JPRB /)

RGHG1(:,47, 1) = (/ &
  & 0.37073853E-03_JPRB, 0.37074764E-03_JPRB, 0.37075402E-03_JPRB, 0.37076144E-03_JPRB, 0.37077145E-03_JPRB, 0.37078332E-03_JPRB, &
  & 0.37079479E-03_JPRB, 0.37080498E-03_JPRB, 0.37081356E-03_JPRB, 0.37082069E-03_JPRB, 0.37082686E-03_JPRB, 0.37083292E-03_JPRB, &
  & 0.37083935E-03_JPRB, 0.37084796E-03_JPRB, 0.37085984E-03_JPRB, 0.37087861E-03_JPRB, 0.37090119E-03_JPRB, 0.37092241E-03_JPRB, &
  & 0.37093856E-03_JPRB, 0.37095026E-03_JPRB, 0.37095882E-03_JPRB, 0.37096528E-03_JPRB, 0.37097020E-03_JPRB, 0.37097425E-03_JPRB, &
  & 0.37097756E-03_JPRB, 0.37098044E-03_JPRB, 0.37098303E-03_JPRB, 0.37098536E-03_JPRB, 0.37098717E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37098973E-03_JPRB, 0.37099014E-03_JPRB, 0.37099019E-03_JPRB, 0.37098964E-03_JPRB, 0.37098874E-03_JPRB, 0.37098769E-03_JPRB, &
  & 0.37098644E-03_JPRB, 0.37098507E-03_JPRB, 0.37098347E-03_JPRB, 0.37098149E-03_JPRB, 0.37097893E-03_JPRB, 0.37097570E-03_JPRB, &
  & 0.37097128E-03_JPRB, 0.37096531E-03_JPRB, 0.37095751E-03_JPRB, 0.37094773E-03_JPRB, 0.37093600E-03_JPRB, 0.37092293E-03_JPRB, &
  & 0.37090879E-03_JPRB, 0.37089380E-03_JPRB, 0.37087806E-03_JPRB, 0.37086388E-03_JPRB, 0.37085172E-03_JPRB, 0.37084275E-03_JPRB, &
  & 0.37083557E-03_JPRB, 0.37082948E-03_JPRB, 0.37082363E-03_JPRB, 0.37081764E-03_JPRB, 0.37081121E-03_JPRB, 0.37080451E-03_JPRB, &
  & 0.37079785E-03_JPRB, 0.37079098E-03_JPRB, 0.37078309E-03_JPRB, 0.37076898E-03_JPRB /)

RGHG1(:,48, 1) = (/ &
  & 0.37077369E-03_JPRB, 0.37078271E-03_JPRB, 0.37078885E-03_JPRB, 0.37079625E-03_JPRB, 0.37080597E-03_JPRB, 0.37081755E-03_JPRB, &
  & 0.37082902E-03_JPRB, 0.37083903E-03_JPRB, 0.37084715E-03_JPRB, 0.37085352E-03_JPRB, 0.37085894E-03_JPRB, 0.37086371E-03_JPRB, &
  & 0.37086895E-03_JPRB, 0.37087541E-03_JPRB, 0.37088519E-03_JPRB, 0.37089878E-03_JPRB, 0.37091621E-03_JPRB, 0.37093228E-03_JPRB, &
  & 0.37094494E-03_JPRB, 0.37095437E-03_JPRB, 0.37096167E-03_JPRB, 0.37096738E-03_JPRB, 0.37097192E-03_JPRB, 0.37097567E-03_JPRB, &
  & 0.37097884E-03_JPRB, 0.37098175E-03_JPRB, 0.37098437E-03_JPRB, 0.37098667E-03_JPRB, 0.37098839E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37099069E-03_JPRB, 0.37099095E-03_JPRB, 0.37099086E-03_JPRB, 0.37099031E-03_JPRB, 0.37098944E-03_JPRB, 0.37098836E-03_JPRB, &
  & 0.37098717E-03_JPRB, 0.37098586E-03_JPRB, 0.37098437E-03_JPRB, 0.37098257E-03_JPRB, 0.37098018E-03_JPRB, 0.37097727E-03_JPRB, &
  & 0.37097343E-03_JPRB, 0.37096845E-03_JPRB, 0.37096205E-03_JPRB, 0.37095408E-03_JPRB, 0.37094450E-03_JPRB, 0.37093356E-03_JPRB, &
  & 0.37092151E-03_JPRB, 0.37090850E-03_JPRB, 0.37089520E-03_JPRB, 0.37088257E-03_JPRB, 0.37087273E-03_JPRB, 0.37086516E-03_JPRB, &
  & 0.37085923E-03_JPRB, 0.37085413E-03_JPRB, 0.37084933E-03_JPRB, 0.37084435E-03_JPRB, 0.37083906E-03_JPRB, 0.37083356E-03_JPRB, &
  & 0.37082811E-03_JPRB, 0.37082256E-03_JPRB, 0.37081612E-03_JPRB, 0.37080469E-03_JPRB /)

RGHG1(:,49, 1) = (/ &
  & 0.37080736E-03_JPRB, 0.37081601E-03_JPRB, 0.37082226E-03_JPRB, 0.37082951E-03_JPRB, 0.37083917E-03_JPRB, 0.37085067E-03_JPRB, &
  & 0.37086208E-03_JPRB, 0.37087195E-03_JPRB, 0.37087925E-03_JPRB, 0.37088472E-03_JPRB, 0.37088903E-03_JPRB, 0.37089287E-03_JPRB, &
  & 0.37089665E-03_JPRB, 0.37090134E-03_JPRB, 0.37090777E-03_JPRB, 0.37091706E-03_JPRB, 0.37092887E-03_JPRB, 0.37094054E-03_JPRB, &
  & 0.37095009E-03_JPRB, 0.37095774E-03_JPRB, 0.37096394E-03_JPRB, 0.37096906E-03_JPRB, 0.37097337E-03_JPRB, 0.37097704E-03_JPRB, &
  & 0.37098015E-03_JPRB, 0.37098309E-03_JPRB, 0.37098565E-03_JPRB, 0.37098789E-03_JPRB, 0.37098947E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099177E-03_JPRB, 0.37099159E-03_JPRB, 0.37099092E-03_JPRB, 0.37099002E-03_JPRB, 0.37098894E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098653E-03_JPRB, 0.37098513E-03_JPRB, 0.37098347E-03_JPRB, 0.37098129E-03_JPRB, 0.37097870E-03_JPRB, &
  & 0.37097541E-03_JPRB, 0.37097125E-03_JPRB, 0.37096610E-03_JPRB, 0.37095998E-03_JPRB, 0.37095265E-03_JPRB, 0.37094433E-03_JPRB, &
  & 0.37093487E-03_JPRB, 0.37092424E-03_JPRB, 0.37091313E-03_JPRB, 0.37090294E-03_JPRB, 0.37089482E-03_JPRB, 0.37088880E-03_JPRB, &
  & 0.37088411E-03_JPRB, 0.37088004E-03_JPRB, 0.37087599E-03_JPRB, 0.37087171E-03_JPRB, 0.37086726E-03_JPRB, 0.37086269E-03_JPRB, &
  & 0.37085812E-03_JPRB, 0.37085349E-03_JPRB, 0.37084828E-03_JPRB, 0.37083891E-03_JPRB /)

RGHG1(:,50, 1) = (/ &
  & 0.37083894E-03_JPRB, 0.37084779E-03_JPRB, 0.37085376E-03_JPRB, 0.37086112E-03_JPRB, 0.37087058E-03_JPRB, 0.37088231E-03_JPRB, &
  & 0.37089348E-03_JPRB, 0.37090259E-03_JPRB, 0.37090882E-03_JPRB, 0.37091298E-03_JPRB, 0.37091604E-03_JPRB, 0.37091848E-03_JPRB, &
  & 0.37092078E-03_JPRB, 0.37092360E-03_JPRB, 0.37092701E-03_JPRB, 0.37093234E-03_JPRB, 0.37093935E-03_JPRB, 0.37094729E-03_JPRB, &
  & 0.37095440E-03_JPRB, 0.37096051E-03_JPRB, 0.37096580E-03_JPRB, 0.37097055E-03_JPRB, 0.37097465E-03_JPRB, 0.37097832E-03_JPRB, &
  & 0.37098146E-03_JPRB, 0.37098443E-03_JPRB, 0.37098693E-03_JPRB, 0.37098909E-03_JPRB, 0.37099057E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099246E-03_JPRB, 0.37099220E-03_JPRB, 0.37099159E-03_JPRB, 0.37099063E-03_JPRB, 0.37098952E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098711E-03_JPRB, 0.37098583E-03_JPRB, 0.37098423E-03_JPRB, 0.37098216E-03_JPRB, 0.37097980E-03_JPRB, &
  & 0.37097701E-03_JPRB, 0.37097360E-03_JPRB, 0.37096962E-03_JPRB, 0.37096540E-03_JPRB, 0.37096039E-03_JPRB, 0.37095475E-03_JPRB, &
  & 0.37094814E-03_JPRB, 0.37094054E-03_JPRB, 0.37093216E-03_JPRB, 0.37092448E-03_JPRB, 0.37091825E-03_JPRB, 0.37091383E-03_JPRB, &
  & 0.37091016E-03_JPRB, 0.37090690E-03_JPRB, 0.37090364E-03_JPRB, 0.37090006E-03_JPRB, 0.37089625E-03_JPRB, 0.37089235E-03_JPRB, &
  & 0.37088848E-03_JPRB, 0.37088463E-03_JPRB, 0.37088015E-03_JPRB, 0.37087200E-03_JPRB /)

RGHG1(:,51, 1) = (/ &
  & 0.37086866E-03_JPRB, 0.37087675E-03_JPRB, 0.37088300E-03_JPRB, 0.37088999E-03_JPRB, 0.37089988E-03_JPRB, 0.37091112E-03_JPRB, &
  & 0.37092183E-03_JPRB, 0.37092902E-03_JPRB, 0.37093327E-03_JPRB, 0.37093571E-03_JPRB, 0.37093728E-03_JPRB, 0.37093839E-03_JPRB, &
  & 0.37093944E-03_JPRB, 0.37094037E-03_JPRB, 0.37094182E-03_JPRB, 0.37094386E-03_JPRB, 0.37094773E-03_JPRB, 0.37095271E-03_JPRB, &
  & 0.37095795E-03_JPRB, 0.37096289E-03_JPRB, 0.37096755E-03_JPRB, 0.37097192E-03_JPRB, 0.37097590E-03_JPRB, 0.37097951E-03_JPRB, &
  & 0.37098263E-03_JPRB, 0.37098562E-03_JPRB, 0.37098804E-03_JPRB, 0.37099002E-03_JPRB, 0.37099153E-03_JPRB, 0.37099258E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099305E-03_JPRB, 0.37099276E-03_JPRB, 0.37099214E-03_JPRB, 0.37099118E-03_JPRB, 0.37099005E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098760E-03_JPRB, 0.37098629E-03_JPRB, 0.37098481E-03_JPRB, 0.37098292E-03_JPRB, 0.37098082E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37097567E-03_JPRB, 0.37097276E-03_JPRB, 0.37097000E-03_JPRB, 0.37096709E-03_JPRB, 0.37096388E-03_JPRB, &
  & 0.37096016E-03_JPRB, 0.37095559E-03_JPRB, 0.37095047E-03_JPRB, 0.37094543E-03_JPRB, 0.37094150E-03_JPRB, 0.37093833E-03_JPRB, &
  & 0.37093589E-03_JPRB, 0.37093356E-03_JPRB, 0.37093100E-03_JPRB, 0.37092832E-03_JPRB, 0.37092529E-03_JPRB, 0.37092206E-03_JPRB, &
  & 0.37091880E-03_JPRB, 0.37091546E-03_JPRB, 0.37091150E-03_JPRB, 0.37090419E-03_JPRB /)

RGHG1(:,52, 1) = (/ &
  & 0.37089456E-03_JPRB, 0.37090309E-03_JPRB, 0.37090827E-03_JPRB, 0.37091569E-03_JPRB, 0.37092439E-03_JPRB, 0.37093504E-03_JPRB, &
  & 0.37094284E-03_JPRB, 0.37094738E-03_JPRB, 0.37094959E-03_JPRB, 0.37095067E-03_JPRB, 0.37095125E-03_JPRB, 0.37095160E-03_JPRB, &
  & 0.37095178E-03_JPRB, 0.37095189E-03_JPRB, 0.37095201E-03_JPRB, 0.37095256E-03_JPRB, 0.37095408E-03_JPRB, 0.37095716E-03_JPRB, &
  & 0.37096097E-03_JPRB, 0.37096499E-03_JPRB, 0.37096912E-03_JPRB, 0.37097326E-03_JPRB, 0.37097710E-03_JPRB, 0.37098071E-03_JPRB, &
  & 0.37098388E-03_JPRB, 0.37098673E-03_JPRB, 0.37098920E-03_JPRB, 0.37099104E-03_JPRB, 0.37099235E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099366E-03_JPRB, 0.37099363E-03_JPRB, 0.37099328E-03_JPRB, 0.37099258E-03_JPRB, 0.37099165E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098804E-03_JPRB, 0.37098682E-03_JPRB, 0.37098536E-03_JPRB, 0.37098362E-03_JPRB, 0.37098172E-03_JPRB, &
  & 0.37097954E-03_JPRB, 0.37097739E-03_JPRB, 0.37097541E-03_JPRB, 0.37097384E-03_JPRB, 0.37097247E-03_JPRB, 0.37097101E-03_JPRB, &
  & 0.37096927E-03_JPRB, 0.37096706E-03_JPRB, 0.37096447E-03_JPRB, 0.37096214E-03_JPRB, 0.37095990E-03_JPRB, 0.37095824E-03_JPRB, &
  & 0.37095670E-03_JPRB, 0.37095524E-03_JPRB, 0.37095370E-03_JPRB, 0.37095172E-03_JPRB, 0.37094951E-03_JPRB, 0.37094712E-03_JPRB, &
  & 0.37094473E-03_JPRB, 0.37094223E-03_JPRB, 0.37093912E-03_JPRB, 0.37093315E-03_JPRB /)

RGHG1(:,53, 1) = (/ &
  & 0.37091743E-03_JPRB, 0.37092424E-03_JPRB, 0.37093012E-03_JPRB, 0.37093580E-03_JPRB, 0.37094389E-03_JPRB, 0.37095096E-03_JPRB, &
  & 0.37095603E-03_JPRB, 0.37095824E-03_JPRB, 0.37095917E-03_JPRB, 0.37095958E-03_JPRB, 0.37095969E-03_JPRB, 0.37095969E-03_JPRB, &
  & 0.37095958E-03_JPRB, 0.37095940E-03_JPRB, 0.37095905E-03_JPRB, 0.37095879E-03_JPRB, 0.37095917E-03_JPRB, 0.37096086E-03_JPRB, &
  & 0.37096362E-03_JPRB, 0.37096697E-03_JPRB, 0.37097058E-03_JPRB, 0.37097454E-03_JPRB, 0.37097826E-03_JPRB, 0.37098184E-03_JPRB, &
  & 0.37098490E-03_JPRB, 0.37098781E-03_JPRB, 0.37099016E-03_JPRB, 0.37099191E-03_JPRB, 0.37099310E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099406E-03_JPRB, 0.37099372E-03_JPRB, 0.37099302E-03_JPRB, 0.37099211E-03_JPRB, 0.37099092E-03_JPRB, &
  & 0.37098973E-03_JPRB, 0.37098853E-03_JPRB, 0.37098734E-03_JPRB, 0.37098592E-03_JPRB, 0.37098426E-03_JPRB, 0.37098254E-03_JPRB, &
  & 0.37098062E-03_JPRB, 0.37097896E-03_JPRB, 0.37097771E-03_JPRB, 0.37097692E-03_JPRB, 0.37097640E-03_JPRB, 0.37097590E-03_JPRB, &
  & 0.37097521E-03_JPRB, 0.37097430E-03_JPRB, 0.37097314E-03_JPRB, 0.37097189E-03_JPRB, 0.37097087E-03_JPRB, 0.37097000E-03_JPRB, &
  & 0.37096924E-03_JPRB, 0.37096842E-03_JPRB, 0.37096752E-03_JPRB, 0.37096645E-03_JPRB, 0.37096511E-03_JPRB, 0.37096371E-03_JPRB, &
  & 0.37096231E-03_JPRB, 0.37096086E-03_JPRB, 0.37095902E-03_JPRB, 0.37095504E-03_JPRB /)

RGHG1(:,54, 1) = (/ &
  & 0.37093493E-03_JPRB, 0.37094217E-03_JPRB, 0.37094604E-03_JPRB, 0.37095146E-03_JPRB, 0.37095646E-03_JPRB, 0.37096126E-03_JPRB, &
  & 0.37096359E-03_JPRB, 0.37096455E-03_JPRB, 0.37096487E-03_JPRB, 0.37096490E-03_JPRB, 0.37096487E-03_JPRB, 0.37096473E-03_JPRB, &
  & 0.37096458E-03_JPRB, 0.37096429E-03_JPRB, 0.37096397E-03_JPRB, 0.37096336E-03_JPRB, 0.37096310E-03_JPRB, 0.37096394E-03_JPRB, &
  & 0.37096592E-03_JPRB, 0.37096869E-03_JPRB, 0.37097206E-03_JPRB, 0.37097576E-03_JPRB, 0.37097945E-03_JPRB, 0.37098295E-03_JPRB, &
  & 0.37098592E-03_JPRB, 0.37098874E-03_JPRB, 0.37099107E-03_JPRB, 0.37099270E-03_JPRB, 0.37099380E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099450E-03_JPRB, 0.37099412E-03_JPRB, 0.37099345E-03_JPRB, 0.37099246E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098894E-03_JPRB, 0.37098778E-03_JPRB, 0.37098638E-03_JPRB, 0.37098487E-03_JPRB, 0.37098330E-03_JPRB, &
  & 0.37098172E-03_JPRB, 0.37098044E-03_JPRB, 0.37097977E-03_JPRB, 0.37097945E-03_JPRB, 0.37097937E-03_JPRB, 0.37097931E-03_JPRB, &
  & 0.37097911E-03_JPRB, 0.37097873E-03_JPRB, 0.37097817E-03_JPRB, 0.37097753E-03_JPRB, 0.37097686E-03_JPRB, 0.37097640E-03_JPRB, &
  & 0.37097596E-03_JPRB, 0.37097553E-03_JPRB, 0.37097506E-03_JPRB, 0.37097442E-03_JPRB, 0.37097372E-03_JPRB, 0.37097291E-03_JPRB, &
  & 0.37097221E-03_JPRB, 0.37097154E-03_JPRB, 0.37097087E-03_JPRB, 0.37096997E-03_JPRB /)

RGHG1(:,55, 1) = (/ &
  & 0.37094924E-03_JPRB, 0.37095434E-03_JPRB, 0.37095847E-03_JPRB, 0.37096150E-03_JPRB, 0.37096493E-03_JPRB, 0.37096729E-03_JPRB, &
  & 0.37096831E-03_JPRB, 0.37096860E-03_JPRB, 0.37096872E-03_JPRB, 0.37096866E-03_JPRB, 0.37096851E-03_JPRB, 0.37096831E-03_JPRB, &
  & 0.37096808E-03_JPRB, 0.37096784E-03_JPRB, 0.37096743E-03_JPRB, 0.37096700E-03_JPRB, 0.37096639E-03_JPRB, 0.37096665E-03_JPRB, &
  & 0.37096805E-03_JPRB, 0.37097046E-03_JPRB, 0.37097358E-03_JPRB, 0.37097710E-03_JPRB, 0.37098059E-03_JPRB, 0.37098399E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098961E-03_JPRB, 0.37099182E-03_JPRB, 0.37099345E-03_JPRB, 0.37099444E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099500E-03_JPRB, 0.37099453E-03_JPRB, 0.37099380E-03_JPRB, 0.37099278E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37098935E-03_JPRB, 0.37098819E-03_JPRB, 0.37098685E-03_JPRB, 0.37098548E-03_JPRB, 0.37098399E-03_JPRB, &
  & 0.37098271E-03_JPRB, 0.37098175E-03_JPRB, 0.37098138E-03_JPRB, 0.37098135E-03_JPRB, 0.37098152E-03_JPRB, 0.37098170E-03_JPRB, &
  & 0.37098170E-03_JPRB, 0.37098146E-03_JPRB, 0.37098117E-03_JPRB, 0.37098088E-03_JPRB, 0.37098053E-03_JPRB, 0.37098018E-03_JPRB, &
  & 0.37097995E-03_JPRB, 0.37097969E-03_JPRB, 0.37097931E-03_JPRB, 0.37097896E-03_JPRB, 0.37097849E-03_JPRB, 0.37097809E-03_JPRB, &
  & 0.37097765E-03_JPRB, 0.37097718E-03_JPRB, 0.37097663E-03_JPRB, 0.37097567E-03_JPRB /)

RGHG1(:,56, 1) = (/ &
  & 0.37095902E-03_JPRB, 0.37096388E-03_JPRB, 0.37096624E-03_JPRB, 0.37096842E-03_JPRB, 0.37097011E-03_JPRB, 0.37097119E-03_JPRB, &
  & 0.37097145E-03_JPRB, 0.37097145E-03_JPRB, 0.37097139E-03_JPRB, 0.37097131E-03_JPRB, 0.37097119E-03_JPRB, 0.37097104E-03_JPRB, &
  & 0.37097093E-03_JPRB, 0.37097069E-03_JPRB, 0.37097046E-03_JPRB, 0.37096982E-03_JPRB, 0.37096924E-03_JPRB, 0.37096906E-03_JPRB, &
  & 0.37097005E-03_JPRB, 0.37097212E-03_JPRB, 0.37097506E-03_JPRB, 0.37097841E-03_JPRB, 0.37098175E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098789E-03_JPRB, 0.37099043E-03_JPRB, 0.37099267E-03_JPRB, 0.37099409E-03_JPRB, 0.37099503E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099543E-03_JPRB, 0.37099497E-03_JPRB, 0.37099409E-03_JPRB, 0.37099299E-03_JPRB, 0.37099191E-03_JPRB, &
  & 0.37099081E-03_JPRB, 0.37098973E-03_JPRB, 0.37098862E-03_JPRB, 0.37098731E-03_JPRB, 0.37098603E-03_JPRB, 0.37098478E-03_JPRB, &
  & 0.37098367E-03_JPRB, 0.37098298E-03_JPRB, 0.37098286E-03_JPRB, 0.37098312E-03_JPRB, 0.37098338E-03_JPRB, 0.37098356E-03_JPRB, &
  & 0.37098365E-03_JPRB, 0.37098356E-03_JPRB, 0.37098338E-03_JPRB, 0.37098315E-03_JPRB, 0.37098289E-03_JPRB, 0.37098274E-03_JPRB, &
  & 0.37098254E-03_JPRB, 0.37098234E-03_JPRB, 0.37098216E-03_JPRB, 0.37098193E-03_JPRB, 0.37098164E-03_JPRB, 0.37098135E-03_JPRB, &
  & 0.37098106E-03_JPRB, 0.37098079E-03_JPRB, 0.37098047E-03_JPRB, 0.37097992E-03_JPRB /)

RGHG1(:,57, 1) = (/ &
  & 0.37096639E-03_JPRB, 0.37096985E-03_JPRB, 0.37097165E-03_JPRB, 0.37097282E-03_JPRB, 0.37097363E-03_JPRB, 0.37097392E-03_JPRB, &
  & 0.37097390E-03_JPRB, 0.37097372E-03_JPRB, 0.37097358E-03_JPRB, 0.37097349E-03_JPRB, 0.37097334E-03_JPRB, 0.37097326E-03_JPRB, &
  & 0.37097317E-03_JPRB, 0.37097302E-03_JPRB, 0.37097276E-03_JPRB, 0.37097238E-03_JPRB, 0.37097163E-03_JPRB, 0.37097133E-03_JPRB, &
  & 0.37097203E-03_JPRB, 0.37097387E-03_JPRB, 0.37097649E-03_JPRB, 0.37097960E-03_JPRB, 0.37098274E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37099127E-03_JPRB, 0.37099334E-03_JPRB, 0.37099473E-03_JPRB, 0.37099561E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099590E-03_JPRB, 0.37099526E-03_JPRB, 0.37099444E-03_JPRB, 0.37099340E-03_JPRB, 0.37099232E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099014E-03_JPRB, 0.37098903E-03_JPRB, 0.37098781E-03_JPRB, 0.37098659E-03_JPRB, 0.37098542E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098420E-03_JPRB, 0.37098417E-03_JPRB, 0.37098452E-03_JPRB, 0.37098496E-03_JPRB, 0.37098513E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098519E-03_JPRB, 0.37098501E-03_JPRB, 0.37098484E-03_JPRB, 0.37098466E-03_JPRB, 0.37098449E-03_JPRB, &
  & 0.37098437E-03_JPRB, 0.37098426E-03_JPRB, 0.37098411E-03_JPRB, 0.37098394E-03_JPRB, 0.37098373E-03_JPRB, 0.37098350E-03_JPRB, &
  & 0.37098327E-03_JPRB, 0.37098301E-03_JPRB, 0.37098274E-03_JPRB, 0.37098231E-03_JPRB /)

RGHG1(:,58, 1) = (/ &
  & 0.37097171E-03_JPRB, 0.37097427E-03_JPRB, 0.37097532E-03_JPRB, 0.37097596E-03_JPRB, 0.37097634E-03_JPRB, 0.37097628E-03_JPRB, &
  & 0.37097605E-03_JPRB, 0.37097593E-03_JPRB, 0.37097585E-03_JPRB, 0.37097579E-03_JPRB, 0.37097570E-03_JPRB, 0.37097561E-03_JPRB, &
  & 0.37097550E-03_JPRB, 0.37097532E-03_JPRB, 0.37097506E-03_JPRB, 0.37097459E-03_JPRB, 0.37097398E-03_JPRB, 0.37097349E-03_JPRB, &
  & 0.37097401E-03_JPRB, 0.37097555E-03_JPRB, 0.37097797E-03_JPRB, 0.37098085E-03_JPRB, 0.37098391E-03_JPRB, 0.37098702E-03_JPRB, &
  & 0.37098970E-03_JPRB, 0.37099203E-03_JPRB, 0.37099398E-03_JPRB, 0.37099526E-03_JPRB, 0.37099613E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099625E-03_JPRB, 0.37099569E-03_JPRB, 0.37099485E-03_JPRB, 0.37099377E-03_JPRB, 0.37099261E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099054E-03_JPRB, 0.37098941E-03_JPRB, 0.37098824E-03_JPRB, 0.37098717E-03_JPRB, 0.37098615E-03_JPRB, &
  & 0.37098562E-03_JPRB, 0.37098530E-03_JPRB, 0.37098533E-03_JPRB, 0.37098568E-03_JPRB, 0.37098621E-03_JPRB, 0.37098650E-03_JPRB, &
  & 0.37098659E-03_JPRB, 0.37098650E-03_JPRB, 0.37098635E-03_JPRB, 0.37098618E-03_JPRB, 0.37098600E-03_JPRB, 0.37098589E-03_JPRB, &
  & 0.37098580E-03_JPRB, 0.37098571E-03_JPRB, 0.37098562E-03_JPRB, 0.37098548E-03_JPRB, 0.37098530E-03_JPRB, 0.37098513E-03_JPRB, &
  & 0.37098501E-03_JPRB, 0.37098475E-03_JPRB, 0.37098455E-03_JPRB, 0.37098417E-03_JPRB /)

RGHG1(:,59, 1) = (/ &
  & 0.37097558E-03_JPRB, 0.37097739E-03_JPRB, 0.37097794E-03_JPRB, 0.37097826E-03_JPRB, 0.37097835E-03_JPRB, 0.37097814E-03_JPRB, &
  & 0.37097788E-03_JPRB, 0.37097774E-03_JPRB, 0.37097762E-03_JPRB, 0.37097756E-03_JPRB, 0.37097756E-03_JPRB, 0.37097750E-03_JPRB, &
  & 0.37097739E-03_JPRB, 0.37097721E-03_JPRB, 0.37097692E-03_JPRB, 0.37097657E-03_JPRB, 0.37097590E-03_JPRB, 0.37097544E-03_JPRB, &
  & 0.37097587E-03_JPRB, 0.37097721E-03_JPRB, 0.37097937E-03_JPRB, 0.37098210E-03_JPRB, 0.37098498E-03_JPRB, 0.37098792E-03_JPRB, &
  & 0.37099051E-03_JPRB, 0.37099278E-03_JPRB, 0.37099459E-03_JPRB, 0.37099578E-03_JPRB, 0.37099648E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099660E-03_JPRB, 0.37099593E-03_JPRB, 0.37099517E-03_JPRB, 0.37099412E-03_JPRB, 0.37099308E-03_JPRB, &
  & 0.37099188E-03_JPRB, 0.37099092E-03_JPRB, 0.37098996E-03_JPRB, 0.37098883E-03_JPRB, 0.37098784E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098656E-03_JPRB, 0.37098632E-03_JPRB, 0.37098653E-03_JPRB, 0.37098685E-03_JPRB, 0.37098740E-03_JPRB, 0.37098763E-03_JPRB, &
  & 0.37098772E-03_JPRB, 0.37098763E-03_JPRB, 0.37098755E-03_JPRB, 0.37098743E-03_JPRB, 0.37098728E-03_JPRB, 0.37098711E-03_JPRB, &
  & 0.37098699E-03_JPRB, 0.37098693E-03_JPRB, 0.37098682E-03_JPRB, 0.37098667E-03_JPRB, 0.37098656E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098618E-03_JPRB, 0.37098603E-03_JPRB, 0.37098568E-03_JPRB /)

RGHG1(:,60, 1) = (/ &
  & 0.37097963E-03_JPRB, 0.37098001E-03_JPRB, 0.37098018E-03_JPRB, 0.37098024E-03_JPRB, 0.37098015E-03_JPRB, 0.37097989E-03_JPRB, &
  & 0.37097960E-03_JPRB, 0.37097937E-03_JPRB, 0.37097922E-03_JPRB, 0.37097913E-03_JPRB, 0.37097905E-03_JPRB, 0.37097902E-03_JPRB, &
  & 0.37097899E-03_JPRB, 0.37097887E-03_JPRB, 0.37097867E-03_JPRB, 0.37097832E-03_JPRB, 0.37097768E-03_JPRB, 0.37097736E-03_JPRB, &
  & 0.37097768E-03_JPRB, 0.37097890E-03_JPRB, 0.37098088E-03_JPRB, 0.37098333E-03_JPRB, 0.37098609E-03_JPRB, 0.37098886E-03_JPRB, &
  & 0.37099139E-03_JPRB, 0.37099351E-03_JPRB, 0.37099508E-03_JPRB, 0.37099625E-03_JPRB, 0.37099695E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099718E-03_JPRB, 0.37099695E-03_JPRB, 0.37099636E-03_JPRB, 0.37099555E-03_JPRB, 0.37099447E-03_JPRB, 0.37099340E-03_JPRB, &
  & 0.37099235E-03_JPRB, 0.37099136E-03_JPRB, 0.37099040E-03_JPRB, 0.37098938E-03_JPRB, 0.37098851E-03_JPRB, 0.37098769E-03_JPRB, &
  & 0.37098743E-03_JPRB, 0.37098734E-03_JPRB, 0.37098763E-03_JPRB, 0.37098792E-03_JPRB, 0.37098851E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098880E-03_JPRB, 0.37098862E-03_JPRB, 0.37098848E-03_JPRB, 0.37098830E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098787E-03_JPRB, 0.37098781E-03_JPRB, 0.37098775E-03_JPRB, 0.37098769E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098749E-03_JPRB, 0.37098731E-03_JPRB, 0.37098717E-03_JPRB, 0.37098691E-03_JPRB /)

RGHG1(:,61, 1) = (/ &
  & 0.37098146E-03_JPRB, 0.37098181E-03_JPRB, 0.37098187E-03_JPRB, 0.37098184E-03_JPRB, 0.37098167E-03_JPRB, 0.37098140E-03_JPRB, &
  & 0.37098111E-03_JPRB, 0.37098094E-03_JPRB, 0.37098085E-03_JPRB, 0.37098082E-03_JPRB, 0.37098079E-03_JPRB, 0.37098076E-03_JPRB, &
  & 0.37098071E-03_JPRB, 0.37098059E-03_JPRB, 0.37098039E-03_JPRB, 0.37098012E-03_JPRB, 0.37097948E-03_JPRB, 0.37097916E-03_JPRB, &
  & 0.37097934E-03_JPRB, 0.37098042E-03_JPRB, 0.37098234E-03_JPRB, 0.37098461E-03_JPRB, 0.37098717E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099223E-03_JPRB, 0.37099421E-03_JPRB, 0.37099558E-03_JPRB, 0.37099680E-03_JPRB, 0.37099738E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099730E-03_JPRB, 0.37099668E-03_JPRB, 0.37099593E-03_JPRB, 0.37099488E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099188E-03_JPRB, 0.37099095E-03_JPRB, 0.37098990E-03_JPRB, 0.37098918E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37098827E-03_JPRB, 0.37098830E-03_JPRB, 0.37098862E-03_JPRB, 0.37098897E-03_JPRB, 0.37098952E-03_JPRB, 0.37098976E-03_JPRB, &
  & 0.37098984E-03_JPRB, 0.37098979E-03_JPRB, 0.37098964E-03_JPRB, 0.37098950E-03_JPRB, 0.37098929E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098909E-03_JPRB, 0.37098897E-03_JPRB, 0.37098883E-03_JPRB, 0.37098871E-03_JPRB, 0.37098862E-03_JPRB, 0.37098851E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098821E-03_JPRB, 0.37098810E-03_JPRB, 0.37098781E-03_JPRB /)

RGHG1(:,62, 1) = (/ &
  & 0.37098306E-03_JPRB, 0.37098327E-03_JPRB, 0.37098333E-03_JPRB, 0.37098327E-03_JPRB, 0.37098312E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098269E-03_JPRB, 0.37098251E-03_JPRB, 0.37098239E-03_JPRB, 0.37098242E-03_JPRB, 0.37098239E-03_JPRB, 0.37098236E-03_JPRB, &
  & 0.37098228E-03_JPRB, 0.37098222E-03_JPRB, 0.37098207E-03_JPRB, 0.37098190E-03_JPRB, 0.37098120E-03_JPRB, 0.37098091E-03_JPRB, &
  & 0.37098111E-03_JPRB, 0.37098202E-03_JPRB, 0.37098385E-03_JPRB, 0.37098594E-03_JPRB, 0.37098830E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099482E-03_JPRB, 0.37099622E-03_JPRB, 0.37099724E-03_JPRB, 0.37099776E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099759E-03_JPRB, 0.37099698E-03_JPRB, 0.37099631E-03_JPRB, 0.37099532E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099241E-03_JPRB, 0.37099147E-03_JPRB, 0.37099057E-03_JPRB, 0.37098987E-03_JPRB, 0.37098935E-03_JPRB, &
  & 0.37098912E-03_JPRB, 0.37098929E-03_JPRB, 0.37098955E-03_JPRB, 0.37098996E-03_JPRB, 0.37099057E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099072E-03_JPRB, 0.37099054E-03_JPRB, 0.37099037E-03_JPRB, 0.37099022E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098984E-03_JPRB, 0.37098976E-03_JPRB, 0.37098967E-03_JPRB, 0.37098958E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098915E-03_JPRB, 0.37098900E-03_JPRB, 0.37098871E-03_JPRB /)

RGHG1(:,63, 1) = (/ &
  & 0.37098452E-03_JPRB, 0.37098466E-03_JPRB, 0.37098464E-03_JPRB, 0.37098461E-03_JPRB, 0.37098449E-03_JPRB, 0.37098437E-03_JPRB, &
  & 0.37098414E-03_JPRB, 0.37098399E-03_JPRB, 0.37098397E-03_JPRB, 0.37098397E-03_JPRB, 0.37098397E-03_JPRB, 0.37098397E-03_JPRB, &
  & 0.37098394E-03_JPRB, 0.37098399E-03_JPRB, 0.37098373E-03_JPRB, 0.37098362E-03_JPRB, 0.37098289E-03_JPRB, 0.37098269E-03_JPRB, &
  & 0.37098292E-03_JPRB, 0.37098365E-03_JPRB, 0.37098528E-03_JPRB, 0.37098725E-03_JPRB, 0.37098938E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099546E-03_JPRB, 0.37099680E-03_JPRB, 0.37099767E-03_JPRB, 0.37099823E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099799E-03_JPRB, 0.37099741E-03_JPRB, 0.37099665E-03_JPRB, 0.37099572E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37099290E-03_JPRB, 0.37099203E-03_JPRB, 0.37099118E-03_JPRB, 0.37099054E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37098993E-03_JPRB, 0.37099008E-03_JPRB, 0.37099043E-03_JPRB, 0.37099089E-03_JPRB, 0.37099150E-03_JPRB, 0.37099174E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099162E-03_JPRB, 0.37099147E-03_JPRB, 0.37099124E-03_JPRB, 0.37099110E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37099083E-03_JPRB, 0.37099069E-03_JPRB, 0.37099054E-03_JPRB, 0.37099043E-03_JPRB, 0.37099025E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098982E-03_JPRB, 0.37098967E-03_JPRB, 0.37098944E-03_JPRB /)

RGHG1(:,64, 1) = (/ &
  & 0.37098577E-03_JPRB, 0.37098589E-03_JPRB, 0.37098589E-03_JPRB, 0.37098583E-03_JPRB, 0.37098571E-03_JPRB, 0.37098562E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098530E-03_JPRB, 0.37098522E-03_JPRB, 0.37098530E-03_JPRB, 0.37098542E-03_JPRB, 0.37098548E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098545E-03_JPRB, 0.37098522E-03_JPRB, 0.37098510E-03_JPRB, 0.37098443E-03_JPRB, 0.37098420E-03_JPRB, &
  & 0.37098449E-03_JPRB, 0.37098530E-03_JPRB, 0.37098673E-03_JPRB, 0.37098859E-03_JPRB, 0.37099054E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099447E-03_JPRB, 0.37099610E-03_JPRB, 0.37099732E-03_JPRB, 0.37099808E-03_JPRB, 0.37099852E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099837E-03_JPRB, 0.37099770E-03_JPRB, 0.37099703E-03_JPRB, 0.37099619E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099351E-03_JPRB, 0.37099267E-03_JPRB, 0.37099182E-03_JPRB, 0.37099124E-03_JPRB, 0.37099092E-03_JPRB, &
  & 0.37099083E-03_JPRB, 0.37099098E-03_JPRB, 0.37099127E-03_JPRB, 0.37099179E-03_JPRB, 0.37099238E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099255E-03_JPRB, 0.37099229E-03_JPRB, 0.37099206E-03_JPRB, 0.37099191E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099147E-03_JPRB, 0.37099136E-03_JPRB, 0.37099124E-03_JPRB, 0.37099107E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099043E-03_JPRB, 0.37099019E-03_JPRB, 0.37098990E-03_JPRB /)

RGHG1(:,65, 1) = (/ &
  & 0.37098693E-03_JPRB, 0.37098702E-03_JPRB, 0.37098705E-03_JPRB, 0.37098702E-03_JPRB, 0.37098693E-03_JPRB, 0.37098682E-03_JPRB, &
  & 0.37098676E-03_JPRB, 0.37098664E-03_JPRB, 0.37098659E-03_JPRB, 0.37098664E-03_JPRB, 0.37098676E-03_JPRB, 0.37098691E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098699E-03_JPRB, 0.37098682E-03_JPRB, 0.37098676E-03_JPRB, 0.37098592E-03_JPRB, 0.37098606E-03_JPRB, &
  & 0.37098629E-03_JPRB, 0.37098688E-03_JPRB, 0.37098824E-03_JPRB, 0.37098984E-03_JPRB, 0.37099174E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099665E-03_JPRB, 0.37099779E-03_JPRB, 0.37099840E-03_JPRB, 0.37099881E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099869E-03_JPRB, 0.37099814E-03_JPRB, 0.37099747E-03_JPRB, 0.37099665E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099401E-03_JPRB, 0.37099328E-03_JPRB, 0.37099249E-03_JPRB, 0.37099203E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099168E-03_JPRB, 0.37099182E-03_JPRB, 0.37099214E-03_JPRB, 0.37099258E-03_JPRB, 0.37099316E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099366E-03_JPRB, 0.37099340E-03_JPRB, 0.37099316E-03_JPRB, 0.37099281E-03_JPRB, 0.37099264E-03_JPRB, 0.37099243E-03_JPRB, &
  & 0.37099223E-03_JPRB, 0.37099206E-03_JPRB, 0.37099194E-03_JPRB, 0.37099182E-03_JPRB, 0.37099168E-03_JPRB, 0.37099147E-03_JPRB, &
  & 0.37099127E-03_JPRB, 0.37099104E-03_JPRB, 0.37099083E-03_JPRB, 0.37099051E-03_JPRB /)

RGHG1(:,66, 1) = (/ &
  & 0.37098801E-03_JPRB, 0.37098821E-03_JPRB, 0.37098819E-03_JPRB, 0.37098816E-03_JPRB, 0.37098810E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098787E-03_JPRB, 0.37098789E-03_JPRB, 0.37098795E-03_JPRB, 0.37098810E-03_JPRB, 0.37098827E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098836E-03_JPRB, 0.37098836E-03_JPRB, 0.37098827E-03_JPRB, 0.37098737E-03_JPRB, 0.37098752E-03_JPRB, &
  & 0.37098772E-03_JPRB, 0.37098836E-03_JPRB, 0.37098964E-03_JPRB, 0.37099110E-03_JPRB, 0.37099273E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099715E-03_JPRB, 0.37099817E-03_JPRB, 0.37099863E-03_JPRB, 0.37099901E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099904E-03_JPRB, 0.37099858E-03_JPRB, 0.37099796E-03_JPRB, 0.37099712E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099462E-03_JPRB, 0.37099389E-03_JPRB, 0.37099319E-03_JPRB, 0.37099276E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099243E-03_JPRB, 0.37099267E-03_JPRB, 0.37099305E-03_JPRB, 0.37099354E-03_JPRB, 0.37099401E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099427E-03_JPRB, 0.37099392E-03_JPRB, 0.37099357E-03_JPRB, 0.37099334E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099270E-03_JPRB, 0.37099246E-03_JPRB, 0.37099232E-03_JPRB, 0.37099217E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099171E-03_JPRB, 0.37099153E-03_JPRB, 0.37099124E-03_JPRB, 0.37099089E-03_JPRB /)

RGHG1(:,67, 1) = (/ &
  & 0.37098897E-03_JPRB, 0.37098920E-03_JPRB, 0.37098920E-03_JPRB, 0.37098926E-03_JPRB, 0.37098923E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098915E-03_JPRB, 0.37098912E-03_JPRB, 0.37098926E-03_JPRB, 0.37098944E-03_JPRB, 0.37098964E-03_JPRB, &
  & 0.37098970E-03_JPRB, 0.37098976E-03_JPRB, 0.37098984E-03_JPRB, 0.37098996E-03_JPRB, 0.37098856E-03_JPRB, 0.37098938E-03_JPRB, &
  & 0.37098952E-03_JPRB, 0.37098993E-03_JPRB, 0.37099089E-03_JPRB, 0.37099220E-03_JPRB, 0.37099374E-03_JPRB, 0.37099529E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099767E-03_JPRB, 0.37099846E-03_JPRB, 0.37099901E-03_JPRB, 0.37099930E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099933E-03_JPRB, 0.37099901E-03_JPRB, 0.37099837E-03_JPRB, 0.37099767E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099523E-03_JPRB, 0.37099459E-03_JPRB, 0.37099392E-03_JPRB, 0.37099360E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099331E-03_JPRB, 0.37099351E-03_JPRB, 0.37099389E-03_JPRB, 0.37099430E-03_JPRB, 0.37099479E-03_JPRB, 0.37099505E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099505E-03_JPRB, 0.37099465E-03_JPRB, 0.37099430E-03_JPRB, 0.37099398E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099328E-03_JPRB, 0.37099305E-03_JPRB, 0.37099281E-03_JPRB, 0.37099270E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099206E-03_JPRB, 0.37099174E-03_JPRB, 0.37099127E-03_JPRB /)

RGHG1(:,68, 1) = (/ &
  & 0.37098990E-03_JPRB, 0.37099016E-03_JPRB, 0.37099022E-03_JPRB, 0.37099025E-03_JPRB, 0.37099025E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37099025E-03_JPRB, 0.37099028E-03_JPRB, 0.37099031E-03_JPRB, 0.37099054E-03_JPRB, 0.37099066E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099104E-03_JPRB, 0.37099118E-03_JPRB, 0.37099165E-03_JPRB, 0.37098950E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099063E-03_JPRB, 0.37099113E-03_JPRB, 0.37099214E-03_JPRB, 0.37099331E-03_JPRB, 0.37099468E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099718E-03_JPRB, 0.37099811E-03_JPRB, 0.37099878E-03_JPRB, 0.37099925E-03_JPRB, 0.37099954E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099962E-03_JPRB, 0.37099933E-03_JPRB, 0.37099878E-03_JPRB, 0.37099811E-03_JPRB, 0.37099724E-03_JPRB, &
  & 0.37099657E-03_JPRB, 0.37099593E-03_JPRB, 0.37099529E-03_JPRB, 0.37099462E-03_JPRB, 0.37099427E-03_JPRB, 0.37099418E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099418E-03_JPRB, 0.37099456E-03_JPRB, 0.37099503E-03_JPRB, 0.37099543E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099604E-03_JPRB, 0.37099593E-03_JPRB, 0.37099543E-03_JPRB, 0.37099508E-03_JPRB, 0.37099462E-03_JPRB, 0.37099447E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099395E-03_JPRB, 0.37099369E-03_JPRB, 0.37099340E-03_JPRB, 0.37099334E-03_JPRB, 0.37099313E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099267E-03_JPRB, 0.37099226E-03_JPRB, 0.37099165E-03_JPRB /)

RGHG1(:,69, 1) = (/ &
  & 0.37099089E-03_JPRB, 0.37099113E-03_JPRB, 0.37099113E-03_JPRB, 0.37099127E-03_JPRB, 0.37099130E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099145E-03_JPRB, 0.37099153E-03_JPRB, 0.37099188E-03_JPRB, 0.37099188E-03_JPRB, 0.37099220E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099235E-03_JPRB, 0.37099238E-03_JPRB, 0.37099322E-03_JPRB, 0.37099034E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099261E-03_JPRB, 0.37099331E-03_JPRB, 0.37099433E-03_JPRB, 0.37099549E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099846E-03_JPRB, 0.37099904E-03_JPRB, 0.37099951E-03_JPRB, 0.37099986E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37099983E-03_JPRB, 0.37099965E-03_JPRB, 0.37099913E-03_JPRB, 0.37099855E-03_JPRB, 0.37099779E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099660E-03_JPRB, 0.37099593E-03_JPRB, 0.37099543E-03_JPRB, 0.37099505E-03_JPRB, 0.37099488E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099485E-03_JPRB, 0.37099520E-03_JPRB, 0.37099569E-03_JPRB, 0.37099613E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099663E-03_JPRB, 0.37099613E-03_JPRB, 0.37099584E-03_JPRB, 0.37099526E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099456E-03_JPRB, 0.37099427E-03_JPRB, 0.37099409E-03_JPRB, 0.37099398E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099351E-03_JPRB, 0.37099322E-03_JPRB, 0.37099276E-03_JPRB, 0.37099197E-03_JPRB /)

RGHG1(:,70, 1) = (/ &
  & 0.37099177E-03_JPRB, 0.37099200E-03_JPRB, 0.37099209E-03_JPRB, 0.37099223E-03_JPRB, 0.37099226E-03_JPRB, 0.37099229E-03_JPRB, &
  & 0.37099255E-03_JPRB, 0.37099264E-03_JPRB, 0.37099273E-03_JPRB, 0.37099313E-03_JPRB, 0.37099310E-03_JPRB, 0.37099342E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099357E-03_JPRB, 0.37099357E-03_JPRB, 0.37099473E-03_JPRB, 0.37099153E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099313E-03_JPRB, 0.37099351E-03_JPRB, 0.37099433E-03_JPRB, 0.37099523E-03_JPRB, 0.37099625E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099887E-03_JPRB, 0.37099927E-03_JPRB, 0.37099977E-03_JPRB, 0.37099994E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100006E-03_JPRB, 0.37099989E-03_JPRB, 0.37099939E-03_JPRB, 0.37099898E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099721E-03_JPRB, 0.37099657E-03_JPRB, 0.37099619E-03_JPRB, 0.37099578E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099558E-03_JPRB, 0.37099590E-03_JPRB, 0.37099642E-03_JPRB, 0.37099689E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099732E-03_JPRB, 0.37099683E-03_JPRB, 0.37099657E-03_JPRB, 0.37099587E-03_JPRB, 0.37099581E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099520E-03_JPRB, 0.37099491E-03_JPRB, 0.37099485E-03_JPRB, 0.37099476E-03_JPRB, 0.37099447E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099398E-03_JPRB, 0.37099337E-03_JPRB, 0.37099246E-03_JPRB /)

RGHG1(:,71, 1) = (/ &
  & 0.37099267E-03_JPRB, 0.37099293E-03_JPRB, 0.37099299E-03_JPRB, 0.37099319E-03_JPRB, 0.37099322E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099366E-03_JPRB, 0.37099374E-03_JPRB, 0.37099392E-03_JPRB, 0.37099430E-03_JPRB, 0.37099433E-03_JPRB, 0.37099459E-03_JPRB, &
  & 0.37099491E-03_JPRB, 0.37099485E-03_JPRB, 0.37099479E-03_JPRB, 0.37099564E-03_JPRB, 0.37099305E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099476E-03_JPRB, 0.37099532E-03_JPRB, 0.37099601E-03_JPRB, 0.37099677E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099907E-03_JPRB, 0.37099951E-03_JPRB, 0.37100009E-03_JPRB, 0.37100021E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100021E-03_JPRB, 0.37100009E-03_JPRB, 0.37099968E-03_JPRB, 0.37099942E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099782E-03_JPRB, 0.37099718E-03_JPRB, 0.37099689E-03_JPRB, 0.37099645E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099613E-03_JPRB, 0.37099657E-03_JPRB, 0.37099712E-03_JPRB, 0.37099750E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099794E-03_JPRB, 0.37099744E-03_JPRB, 0.37099732E-03_JPRB, 0.37099654E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099584E-03_JPRB, 0.37099561E-03_JPRB, 0.37099561E-03_JPRB, 0.37099561E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099505E-03_JPRB, 0.37099473E-03_JPRB, 0.37099409E-03_JPRB, 0.37099305E-03_JPRB /)

RGHG1(:,72, 1) = (/ &
  & 0.37099348E-03_JPRB, 0.37099380E-03_JPRB, 0.37099386E-03_JPRB, 0.37099418E-03_JPRB, 0.37099424E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099468E-03_JPRB, 0.37099482E-03_JPRB, 0.37099514E-03_JPRB, 0.37099549E-03_JPRB, 0.37099561E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099613E-03_JPRB, 0.37099590E-03_JPRB, 0.37099631E-03_JPRB, 0.37099465E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099555E-03_JPRB, 0.37099607E-03_JPRB, 0.37099674E-03_JPRB, 0.37099732E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099927E-03_JPRB, 0.37099965E-03_JPRB, 0.37100038E-03_JPRB, 0.37100041E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100038E-03_JPRB, 0.37100021E-03_JPRB, 0.37099994E-03_JPRB, 0.37099977E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099843E-03_JPRB, 0.37099767E-03_JPRB, 0.37099756E-03_JPRB, 0.37099730E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099668E-03_JPRB, 0.37099718E-03_JPRB, 0.37099782E-03_JPRB, 0.37099811E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099855E-03_JPRB, 0.37099808E-03_JPRB, 0.37099794E-03_JPRB, 0.37099706E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099642E-03_JPRB, 0.37099622E-03_JPRB, 0.37099625E-03_JPRB, 0.37099645E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099555E-03_JPRB, 0.37099485E-03_JPRB, 0.37099372E-03_JPRB /)

RGHG1(:,73, 1) = (/ &
  & 0.37099444E-03_JPRB, 0.37099476E-03_JPRB, 0.37099479E-03_JPRB, 0.37099517E-03_JPRB, 0.37099529E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099596E-03_JPRB, 0.37099631E-03_JPRB, 0.37099665E-03_JPRB, 0.37099674E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099735E-03_JPRB, 0.37099741E-03_JPRB, 0.37099706E-03_JPRB, 0.37099703E-03_JPRB, 0.37099596E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099645E-03_JPRB, 0.37099692E-03_JPRB, 0.37099738E-03_JPRB, 0.37099773E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099948E-03_JPRB, 0.37099983E-03_JPRB, 0.37100067E-03_JPRB, 0.37100058E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100041E-03_JPRB, 0.37100026E-03_JPRB, 0.37100023E-03_JPRB, 0.37100012E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099907E-03_JPRB, 0.37099817E-03_JPRB, 0.37099823E-03_JPRB, 0.37099791E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099718E-03_JPRB, 0.37099770E-03_JPRB, 0.37099840E-03_JPRB, 0.37099875E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099916E-03_JPRB, 0.37099863E-03_JPRB, 0.37099852E-03_JPRB, 0.37099756E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099689E-03_JPRB, 0.37099680E-03_JPRB, 0.37099709E-03_JPRB, 0.37099732E-03_JPRB, 0.37099703E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099642E-03_JPRB, 0.37099561E-03_JPRB, 0.37099433E-03_JPRB /)

RGHG1(:,74, 1) = (/ &
  & 0.37099543E-03_JPRB, 0.37099578E-03_JPRB, 0.37099567E-03_JPRB, 0.37099619E-03_JPRB, 0.37099625E-03_JPRB, 0.37099616E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099695E-03_JPRB, 0.37099730E-03_JPRB, 0.37099770E-03_JPRB, 0.37099776E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099863E-03_JPRB, 0.37099814E-03_JPRB, 0.37099773E-03_JPRB, 0.37099706E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099730E-03_JPRB, 0.37099759E-03_JPRB, 0.37099788E-03_JPRB, 0.37099802E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099968E-03_JPRB, 0.37099991E-03_JPRB, 0.37100102E-03_JPRB, 0.37100067E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100047E-03_JPRB, 0.37100023E-03_JPRB, 0.37100032E-03_JPRB, 0.37100044E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099968E-03_JPRB, 0.37099855E-03_JPRB, 0.37099893E-03_JPRB, 0.37099858E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099753E-03_JPRB, 0.37099817E-03_JPRB, 0.37099901E-03_JPRB, 0.37099930E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099968E-03_JPRB, 0.37099916E-03_JPRB, 0.37099910E-03_JPRB, 0.37099796E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099732E-03_JPRB, 0.37099724E-03_JPRB, 0.37099779E-03_JPRB, 0.37099823E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099727E-03_JPRB, 0.37099625E-03_JPRB, 0.37099500E-03_JPRB /)

RGHG1(:,75, 1) = (/ &
  & 0.37099648E-03_JPRB, 0.37099677E-03_JPRB, 0.37099642E-03_JPRB, 0.37099715E-03_JPRB, 0.37099709E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099794E-03_JPRB, 0.37099834E-03_JPRB, 0.37099875E-03_JPRB, 0.37099875E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099983E-03_JPRB, 0.37099907E-03_JPRB, 0.37099846E-03_JPRB, 0.37099808E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099811E-03_JPRB, 0.37099823E-03_JPRB, 0.37099837E-03_JPRB, 0.37099826E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099980E-03_JPRB, 0.37100009E-03_JPRB, 0.37100149E-03_JPRB, 0.37100082E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100050E-03_JPRB, 0.37100015E-03_JPRB, 0.37100047E-03_JPRB, 0.37100076E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100035E-03_JPRB, 0.37099890E-03_JPRB, 0.37099962E-03_JPRB, 0.37099916E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099764E-03_JPRB, 0.37099852E-03_JPRB, 0.37099948E-03_JPRB, 0.37099986E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100018E-03_JPRB, 0.37099959E-03_JPRB, 0.37099962E-03_JPRB, 0.37099817E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099759E-03_JPRB, 0.37099759E-03_JPRB, 0.37099840E-03_JPRB, 0.37099916E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099811E-03_JPRB, 0.37099703E-03_JPRB, 0.37099555E-03_JPRB /)

RGHG1(:,76, 1) = (/ &
  & 0.37099747E-03_JPRB, 0.37099776E-03_JPRB, 0.37099712E-03_JPRB, 0.37099808E-03_JPRB, 0.37099779E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099881E-03_JPRB, 0.37099910E-03_JPRB, 0.37099962E-03_JPRB, 0.37099954E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100108E-03_JPRB, 0.37100000E-03_JPRB, 0.37099901E-03_JPRB, 0.37099895E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099791E-03_JPRB, 0.37099878E-03_JPRB, 0.37099878E-03_JPRB, 0.37099869E-03_JPRB, 0.37099837E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099997E-03_JPRB, 0.37100021E-03_JPRB, 0.37100184E-03_JPRB, 0.37100096E-03_JPRB, 0.37100169E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100044E-03_JPRB, 0.37099997E-03_JPRB, 0.37100050E-03_JPRB, 0.37100099E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100102E-03_JPRB, 0.37099907E-03_JPRB, 0.37100015E-03_JPRB, 0.37099962E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099770E-03_JPRB, 0.37099875E-03_JPRB, 0.37099997E-03_JPRB, 0.37100035E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100061E-03_JPRB, 0.37099991E-03_JPRB, 0.37100015E-03_JPRB, 0.37099826E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099779E-03_JPRB, 0.37099779E-03_JPRB, 0.37099910E-03_JPRB, 0.37100023E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099890E-03_JPRB, 0.37099770E-03_JPRB, 0.37099607E-03_JPRB /)

RGHG1(:,77, 1) = (/ &
  & 0.37099858E-03_JPRB, 0.37099887E-03_JPRB, 0.37099782E-03_JPRB, 0.37099904E-03_JPRB, 0.37099860E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099957E-03_JPRB, 0.37099986E-03_JPRB, 0.37100055E-03_JPRB, 0.37100029E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100236E-03_JPRB, 0.37100085E-03_JPRB, 0.37099954E-03_JPRB, 0.37099971E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099948E-03_JPRB, 0.37099925E-03_JPRB, 0.37099895E-03_JPRB, 0.37099837E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37100023E-03_JPRB, 0.37100026E-03_JPRB, 0.37100224E-03_JPRB, 0.37100105E-03_JPRB, 0.37100192E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100041E-03_JPRB, 0.37099971E-03_JPRB, 0.37100053E-03_JPRB, 0.37100131E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100175E-03_JPRB, 0.37099925E-03_JPRB, 0.37100082E-03_JPRB, 0.37100009E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099759E-03_JPRB, 0.37099898E-03_JPRB, 0.37100044E-03_JPRB, 0.37100088E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100120E-03_JPRB, 0.37100023E-03_JPRB, 0.37100076E-03_JPRB, 0.37099814E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099791E-03_JPRB, 0.37099782E-03_JPRB, 0.37099962E-03_JPRB, 0.37100128E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37099971E-03_JPRB, 0.37099828E-03_JPRB, 0.37099657E-03_JPRB /)

RGHG1(:,78, 1) = (/ &
  & 0.37099968E-03_JPRB, 0.37099994E-03_JPRB, 0.37099843E-03_JPRB, 0.37100006E-03_JPRB, 0.37099930E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100021E-03_JPRB, 0.37100044E-03_JPRB, 0.37100137E-03_JPRB, 0.37100079E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100358E-03_JPRB, 0.37100160E-03_JPRB, 0.37099989E-03_JPRB, 0.37100038E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37100015E-03_JPRB, 0.37099968E-03_JPRB, 0.37099910E-03_JPRB, 0.37099814E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37100038E-03_JPRB, 0.37100044E-03_JPRB, 0.37100256E-03_JPRB, 0.37100111E-03_JPRB, 0.37100216E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100035E-03_JPRB, 0.37099939E-03_JPRB, 0.37100050E-03_JPRB, 0.37100154E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100239E-03_JPRB, 0.37099927E-03_JPRB, 0.37100146E-03_JPRB, 0.37100050E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099744E-03_JPRB, 0.37099910E-03_JPRB, 0.37100088E-03_JPRB, 0.37100131E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100163E-03_JPRB, 0.37100160E-03_JPRB, 0.37100038E-03_JPRB, 0.37100131E-03_JPRB, 0.37099785E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099805E-03_JPRB, 0.37099782E-03_JPRB, 0.37100015E-03_JPRB, 0.37100221E-03_JPRB, 0.37100181E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100044E-03_JPRB, 0.37099890E-03_JPRB, 0.37099689E-03_JPRB /)

RGHG1(:,79, 1) = (/ &
  & 0.37100070E-03_JPRB, 0.37100073E-03_JPRB, 0.37099872E-03_JPRB, 0.37100061E-03_JPRB, 0.37099965E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100067E-03_JPRB, 0.37100085E-03_JPRB, 0.37100210E-03_JPRB, 0.37100125E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37100355E-03_JPRB, 0.37100463E-03_JPRB, 0.37100218E-03_JPRB, 0.37100009E-03_JPRB, 0.37100085E-03_JPRB, 0.37100140E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37100064E-03_JPRB, 0.37099989E-03_JPRB, 0.37099916E-03_JPRB, 0.37099791E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37100053E-03_JPRB, 0.37100050E-03_JPRB, 0.37100300E-03_JPRB, 0.37100128E-03_JPRB, 0.37100248E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100038E-03_JPRB, 0.37099907E-03_JPRB, 0.37100041E-03_JPRB, 0.37100175E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100309E-03_JPRB, 0.37099930E-03_JPRB, 0.37100192E-03_JPRB, 0.37100076E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099715E-03_JPRB, 0.37099919E-03_JPRB, 0.37100125E-03_JPRB, 0.37100175E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100207E-03_JPRB, 0.37100201E-03_JPRB, 0.37100061E-03_JPRB, 0.37100181E-03_JPRB, 0.37099753E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099794E-03_JPRB, 0.37099762E-03_JPRB, 0.37100047E-03_JPRB, 0.37100294E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37100370E-03_JPRB, 0.37100090E-03_JPRB, 0.37099925E-03_JPRB, 0.37099695E-03_JPRB /)

RGHG1(:,80, 1) = (/ &
  & 0.37100166E-03_JPRB, 0.37100125E-03_JPRB, 0.37099890E-03_JPRB, 0.37100102E-03_JPRB, 0.37099991E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100096E-03_JPRB, 0.37100120E-03_JPRB, 0.37100253E-03_JPRB, 0.37100149E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100419E-03_JPRB, 0.37100547E-03_JPRB, 0.37100265E-03_JPRB, 0.37100021E-03_JPRB, 0.37100108E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37100090E-03_JPRB, 0.37100006E-03_JPRB, 0.37099910E-03_JPRB, 0.37099770E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100070E-03_JPRB, 0.37100061E-03_JPRB, 0.37100335E-03_JPRB, 0.37100134E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100041E-03_JPRB, 0.37099887E-03_JPRB, 0.37100044E-03_JPRB, 0.37100192E-03_JPRB, 0.37100326E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100364E-03_JPRB, 0.37099927E-03_JPRB, 0.37100230E-03_JPRB, 0.37100096E-03_JPRB, 0.37100393E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099689E-03_JPRB, 0.37099913E-03_JPRB, 0.37100154E-03_JPRB, 0.37100201E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100239E-03_JPRB, 0.37100230E-03_JPRB, 0.37100079E-03_JPRB, 0.37100210E-03_JPRB, 0.37099724E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099779E-03_JPRB, 0.37099741E-03_JPRB, 0.37100067E-03_JPRB, 0.37100347E-03_JPRB, 0.37100306E-03_JPRB, &
  & 0.37100440E-03_JPRB, 0.37100122E-03_JPRB, 0.37099936E-03_JPRB, 0.37099657E-03_JPRB /)

RGHG1(:,81, 1) = (/ &
  & 0.37100259E-03_JPRB, 0.37100160E-03_JPRB, 0.37099893E-03_JPRB, 0.37100117E-03_JPRB, 0.37100003E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100105E-03_JPRB, 0.37100122E-03_JPRB, 0.37100288E-03_JPRB, 0.37100172E-03_JPRB, 0.37100186E-03_JPRB, &
  & 0.37100460E-03_JPRB, 0.37100600E-03_JPRB, 0.37100280E-03_JPRB, 0.37100026E-03_JPRB, 0.37100125E-03_JPRB, 0.37100192E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37100105E-03_JPRB, 0.37100009E-03_JPRB, 0.37099910E-03_JPRB, 0.37099750E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37100076E-03_JPRB, 0.37100067E-03_JPRB, 0.37100364E-03_JPRB, 0.37100149E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100041E-03_JPRB, 0.37099875E-03_JPRB, 0.37100044E-03_JPRB, 0.37100216E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100387E-03_JPRB, 0.37099936E-03_JPRB, 0.37100253E-03_JPRB, 0.37100120E-03_JPRB, 0.37100431E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099663E-03_JPRB, 0.37099910E-03_JPRB, 0.37100166E-03_JPRB, 0.37100218E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100248E-03_JPRB, 0.37100082E-03_JPRB, 0.37100227E-03_JPRB, 0.37099706E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099773E-03_JPRB, 0.37099727E-03_JPRB, 0.37100076E-03_JPRB, 0.37100381E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100146E-03_JPRB, 0.37099939E-03_JPRB, 0.37099599E-03_JPRB /)

RGHG1(:,82, 1) = (/ &
  & 0.37100265E-03_JPRB, 0.37100166E-03_JPRB, 0.37099887E-03_JPRB, 0.37100131E-03_JPRB, 0.37100012E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100120E-03_JPRB, 0.37100149E-03_JPRB, 0.37100297E-03_JPRB, 0.37100172E-03_JPRB, 0.37100186E-03_JPRB, &
  & 0.37100483E-03_JPRB, 0.37100638E-03_JPRB, 0.37100294E-03_JPRB, 0.37100023E-03_JPRB, 0.37100134E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37100117E-03_JPRB, 0.37100012E-03_JPRB, 0.37099898E-03_JPRB, 0.37099744E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37100085E-03_JPRB, 0.37100073E-03_JPRB, 0.37100381E-03_JPRB, 0.37100152E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100038E-03_JPRB, 0.37099866E-03_JPRB, 0.37100044E-03_JPRB, 0.37100218E-03_JPRB, 0.37100364E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100399E-03_JPRB, 0.37099954E-03_JPRB, 0.37100271E-03_JPRB, 0.37100131E-03_JPRB, 0.37100454E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099633E-03_JPRB, 0.37099901E-03_JPRB, 0.37100172E-03_JPRB, 0.37100227E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100268E-03_JPRB, 0.37100085E-03_JPRB, 0.37100242E-03_JPRB, 0.37099692E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099773E-03_JPRB, 0.37099721E-03_JPRB, 0.37100085E-03_JPRB, 0.37100405E-03_JPRB, 0.37100373E-03_JPRB, &
  & 0.37100521E-03_JPRB, 0.37100154E-03_JPRB, 0.37099942E-03_JPRB, 0.37099590E-03_JPRB /)

RGHG1(:,83, 1) = (/ &
  & 0.37100277E-03_JPRB, 0.37100172E-03_JPRB, 0.37099887E-03_JPRB, 0.37100137E-03_JPRB, 0.37100018E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100125E-03_JPRB, 0.37100140E-03_JPRB, 0.37100315E-03_JPRB, 0.37100189E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37100492E-03_JPRB, 0.37100658E-03_JPRB, 0.37100312E-03_JPRB, 0.37100023E-03_JPRB, 0.37100143E-03_JPRB, 0.37100221E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37100117E-03_JPRB, 0.37100015E-03_JPRB, 0.37099895E-03_JPRB, 0.37099735E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37100090E-03_JPRB, 0.37100079E-03_JPRB, 0.37100390E-03_JPRB, 0.37100154E-03_JPRB, 0.37100320E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100041E-03_JPRB, 0.37099863E-03_JPRB, 0.37100050E-03_JPRB, 0.37100230E-03_JPRB, 0.37100364E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100402E-03_JPRB, 0.37099968E-03_JPRB, 0.37100277E-03_JPRB, 0.37100149E-03_JPRB, 0.37100469E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099616E-03_JPRB, 0.37099904E-03_JPRB, 0.37100178E-03_JPRB, 0.37100236E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100277E-03_JPRB, 0.37100088E-03_JPRB, 0.37100245E-03_JPRB, 0.37099683E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37099680E-03_JPRB, 0.37099764E-03_JPRB, 0.37099709E-03_JPRB, 0.37100085E-03_JPRB, 0.37100419E-03_JPRB, 0.37100387E-03_JPRB, &
  & 0.37100547E-03_JPRB, 0.37100166E-03_JPRB, 0.37099939E-03_JPRB, 0.37099578E-03_JPRB /)

RGHG1(:,84, 1) = (/ &
  & 0.37100285E-03_JPRB, 0.37100178E-03_JPRB, 0.37099890E-03_JPRB, 0.37100146E-03_JPRB, 0.37100021E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100128E-03_JPRB, 0.37100166E-03_JPRB, 0.37100312E-03_JPRB, 0.37100192E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100518E-03_JPRB, 0.37100664E-03_JPRB, 0.37100323E-03_JPRB, 0.37100026E-03_JPRB, 0.37100146E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37100134E-03_JPRB, 0.37100018E-03_JPRB, 0.37099887E-03_JPRB, 0.37099724E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37100090E-03_JPRB, 0.37100082E-03_JPRB, 0.37100405E-03_JPRB, 0.37100154E-03_JPRB, 0.37100335E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100038E-03_JPRB, 0.37099858E-03_JPRB, 0.37100053E-03_JPRB, 0.37100236E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100402E-03_JPRB, 0.37099986E-03_JPRB, 0.37100282E-03_JPRB, 0.37100157E-03_JPRB, 0.37100483E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099593E-03_JPRB, 0.37099887E-03_JPRB, 0.37100184E-03_JPRB, 0.37100248E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100291E-03_JPRB, 0.37100282E-03_JPRB, 0.37100090E-03_JPRB, 0.37100248E-03_JPRB, 0.37099671E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099759E-03_JPRB, 0.37099698E-03_JPRB, 0.37100082E-03_JPRB, 0.37100428E-03_JPRB, 0.37100405E-03_JPRB, &
  & 0.37100571E-03_JPRB, 0.37100169E-03_JPRB, 0.37099933E-03_JPRB, 0.37099564E-03_JPRB /)

RGHG1(:,85, 1) = (/ &
  & 0.37100294E-03_JPRB, 0.37100178E-03_JPRB, 0.37099884E-03_JPRB, 0.37100154E-03_JPRB, 0.37100032E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100131E-03_JPRB, 0.37100169E-03_JPRB, 0.37100303E-03_JPRB, 0.37100230E-03_JPRB, 0.37100268E-03_JPRB, &
  & 0.37100510E-03_JPRB, 0.37100655E-03_JPRB, 0.37100344E-03_JPRB, 0.37100035E-03_JPRB, 0.37100152E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37100131E-03_JPRB, 0.37100009E-03_JPRB, 0.37099887E-03_JPRB, 0.37099715E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37100099E-03_JPRB, 0.37100079E-03_JPRB, 0.37100416E-03_JPRB, 0.37100154E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100038E-03_JPRB, 0.37099849E-03_JPRB, 0.37100053E-03_JPRB, 0.37100233E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100411E-03_JPRB, 0.37099997E-03_JPRB, 0.37100294E-03_JPRB, 0.37100166E-03_JPRB, 0.37100510E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099575E-03_JPRB, 0.37099884E-03_JPRB, 0.37100181E-03_JPRB, 0.37100256E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100291E-03_JPRB, 0.37100090E-03_JPRB, 0.37100253E-03_JPRB, 0.37099657E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099753E-03_JPRB, 0.37099686E-03_JPRB, 0.37100082E-03_JPRB, 0.37100443E-03_JPRB, 0.37100413E-03_JPRB, &
  & 0.37100591E-03_JPRB, 0.37100175E-03_JPRB, 0.37099930E-03_JPRB, 0.37099552E-03_JPRB /)

RGHG1(:,86, 1) = (/ &
  & 0.37100306E-03_JPRB, 0.37100181E-03_JPRB, 0.37099887E-03_JPRB, 0.37100169E-03_JPRB, 0.37100032E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100149E-03_JPRB, 0.37100189E-03_JPRB, 0.37100277E-03_JPRB, 0.37100248E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100492E-03_JPRB, 0.37100614E-03_JPRB, 0.37100347E-03_JPRB, 0.37100058E-03_JPRB, 0.37100154E-03_JPRB, 0.37100216E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37100140E-03_JPRB, 0.37100018E-03_JPRB, 0.37099881E-03_JPRB, 0.37099698E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37100105E-03_JPRB, 0.37100073E-03_JPRB, 0.37100428E-03_JPRB, 0.37100152E-03_JPRB, 0.37100355E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100044E-03_JPRB, 0.37099852E-03_JPRB, 0.37100053E-03_JPRB, 0.37100242E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100428E-03_JPRB, 0.37099980E-03_JPRB, 0.37100306E-03_JPRB, 0.37100152E-03_JPRB, 0.37100539E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099555E-03_JPRB, 0.37099872E-03_JPRB, 0.37100184E-03_JPRB, 0.37100265E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37100315E-03_JPRB, 0.37100288E-03_JPRB, 0.37100085E-03_JPRB, 0.37100253E-03_JPRB, 0.37099648E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099744E-03_JPRB, 0.37099677E-03_JPRB, 0.37100082E-03_JPRB, 0.37100457E-03_JPRB, 0.37100431E-03_JPRB, &
  & 0.37100611E-03_JPRB, 0.37100184E-03_JPRB, 0.37099922E-03_JPRB, 0.37099535E-03_JPRB /)

RGHG1(:,87, 1) = (/ &
  & 0.37100309E-03_JPRB, 0.37100186E-03_JPRB, 0.37099881E-03_JPRB, 0.37100169E-03_JPRB, 0.37100041E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100157E-03_JPRB, 0.37100201E-03_JPRB, 0.37100280E-03_JPRB, 0.37100271E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100576E-03_JPRB, 0.37100347E-03_JPRB, 0.37100079E-03_JPRB, 0.37100154E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37100140E-03_JPRB, 0.37100018E-03_JPRB, 0.37099875E-03_JPRB, 0.37099674E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37100114E-03_JPRB, 0.37100058E-03_JPRB, 0.37100443E-03_JPRB, 0.37100146E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100047E-03_JPRB, 0.37099846E-03_JPRB, 0.37100044E-03_JPRB, 0.37100248E-03_JPRB, 0.37100396E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100466E-03_JPRB, 0.37099954E-03_JPRB, 0.37100335E-03_JPRB, 0.37100137E-03_JPRB, 0.37100582E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099529E-03_JPRB, 0.37099866E-03_JPRB, 0.37100181E-03_JPRB, 0.37100268E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37100320E-03_JPRB, 0.37100291E-03_JPRB, 0.37100085E-03_JPRB, 0.37100259E-03_JPRB, 0.37099639E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099727E-03_JPRB, 0.37099663E-03_JPRB, 0.37100076E-03_JPRB, 0.37100460E-03_JPRB, 0.37100445E-03_JPRB, &
  & 0.37100623E-03_JPRB, 0.37100184E-03_JPRB, 0.37099913E-03_JPRB, 0.37099529E-03_JPRB /)

RGHG1(:,88, 1) = (/ &
  & 0.37100315E-03_JPRB, 0.37100186E-03_JPRB, 0.37099884E-03_JPRB, 0.37100184E-03_JPRB, 0.37100038E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100163E-03_JPRB, 0.37100207E-03_JPRB, 0.37100282E-03_JPRB, 0.37100280E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100483E-03_JPRB, 0.37100571E-03_JPRB, 0.37100358E-03_JPRB, 0.37100093E-03_JPRB, 0.37100166E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37100140E-03_JPRB, 0.37100023E-03_JPRB, 0.37099875E-03_JPRB, 0.37099665E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37100114E-03_JPRB, 0.37100053E-03_JPRB, 0.37100463E-03_JPRB, 0.37100143E-03_JPRB, 0.37100364E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100053E-03_JPRB, 0.37099837E-03_JPRB, 0.37100038E-03_JPRB, 0.37100242E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100495E-03_JPRB, 0.37099913E-03_JPRB, 0.37100367E-03_JPRB, 0.37100114E-03_JPRB, 0.37100620E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099511E-03_JPRB, 0.37099866E-03_JPRB, 0.37100181E-03_JPRB, 0.37100277E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100297E-03_JPRB, 0.37100090E-03_JPRB, 0.37100268E-03_JPRB, 0.37099636E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099721E-03_JPRB, 0.37099657E-03_JPRB, 0.37100079E-03_JPRB, 0.37100472E-03_JPRB, 0.37100451E-03_JPRB, &
  & 0.37100635E-03_JPRB, 0.37100181E-03_JPRB, 0.37099913E-03_JPRB, 0.37099529E-03_JPRB /)

RGHG1(:,89, 1) = (/ &
  & 0.37100312E-03_JPRB, 0.37100192E-03_JPRB, 0.37099887E-03_JPRB, 0.37100186E-03_JPRB, 0.37100061E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100154E-03_JPRB, 0.37100201E-03_JPRB, 0.37100277E-03_JPRB, 0.37100271E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100504E-03_JPRB, 0.37100597E-03_JPRB, 0.37100358E-03_JPRB, 0.37100082E-03_JPRB, 0.37100163E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37100157E-03_JPRB, 0.37100023E-03_JPRB, 0.37099872E-03_JPRB, 0.37099654E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37100125E-03_JPRB, 0.37100044E-03_JPRB, 0.37100475E-03_JPRB, 0.37100140E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100055E-03_JPRB, 0.37099826E-03_JPRB, 0.37100035E-03_JPRB, 0.37100253E-03_JPRB, 0.37100422E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100527E-03_JPRB, 0.37099884E-03_JPRB, 0.37100387E-03_JPRB, 0.37100096E-03_JPRB, 0.37100652E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099494E-03_JPRB, 0.37099858E-03_JPRB, 0.37100181E-03_JPRB, 0.37100282E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100335E-03_JPRB, 0.37100300E-03_JPRB, 0.37100096E-03_JPRB, 0.37100274E-03_JPRB, 0.37099631E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099721E-03_JPRB, 0.37099648E-03_JPRB, 0.37100085E-03_JPRB, 0.37100483E-03_JPRB, 0.37100460E-03_JPRB, &
  & 0.37100652E-03_JPRB, 0.37100184E-03_JPRB, 0.37099904E-03_JPRB, 0.37099520E-03_JPRB /)

RGHG1(:,90, 1) = (/ &
  & 0.37100309E-03_JPRB, 0.37100195E-03_JPRB, 0.37099881E-03_JPRB, 0.37100207E-03_JPRB, 0.37100050E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100149E-03_JPRB, 0.37100178E-03_JPRB, 0.37100282E-03_JPRB, 0.37100248E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100533E-03_JPRB, 0.37100661E-03_JPRB, 0.37100358E-03_JPRB, 0.37100044E-03_JPRB, 0.37100172E-03_JPRB, 0.37100227E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37100175E-03_JPRB, 0.37100026E-03_JPRB, 0.37099881E-03_JPRB, 0.37099645E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37100137E-03_JPRB, 0.37100026E-03_JPRB, 0.37100498E-03_JPRB, 0.37100122E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100061E-03_JPRB, 0.37099811E-03_JPRB, 0.37100038E-03_JPRB, 0.37100259E-03_JPRB, 0.37100440E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100571E-03_JPRB, 0.37099846E-03_JPRB, 0.37100419E-03_JPRB, 0.37100079E-03_JPRB, 0.37100702E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099473E-03_JPRB, 0.37099855E-03_JPRB, 0.37100184E-03_JPRB, 0.37100288E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100349E-03_JPRB, 0.37100306E-03_JPRB, 0.37100090E-03_JPRB, 0.37100300E-03_JPRB, 0.37099607E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099718E-03_JPRB, 0.37099636E-03_JPRB, 0.37100093E-03_JPRB, 0.37100501E-03_JPRB, 0.37100460E-03_JPRB, &
  & 0.37100667E-03_JPRB, 0.37100181E-03_JPRB, 0.37099901E-03_JPRB, 0.37099514E-03_JPRB /)

RGHG1(:,91, 1) = (/ &
  & 0.37100309E-03_JPRB, 0.37100230E-03_JPRB, 0.37099834E-03_JPRB, 0.37100242E-03_JPRB, 0.37100090E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100122E-03_JPRB, 0.37100120E-03_JPRB, 0.37100405E-03_JPRB, 0.37100175E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100632E-03_JPRB, 0.37100818E-03_JPRB, 0.37100332E-03_JPRB, 0.37099962E-03_JPRB, 0.37100184E-03_JPRB, 0.37100274E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37100216E-03_JPRB, 0.37100029E-03_JPRB, 0.37099884E-03_JPRB, 0.37099604E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37100163E-03_JPRB, 0.37099989E-03_JPRB, 0.37100559E-03_JPRB, 0.37100073E-03_JPRB, 0.37100443E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100085E-03_JPRB, 0.37099753E-03_JPRB, 0.37100029E-03_JPRB, 0.37100271E-03_JPRB, 0.37100489E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37100655E-03_JPRB, 0.37099753E-03_JPRB, 0.37100477E-03_JPRB, 0.37100018E-03_JPRB, 0.37100798E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099418E-03_JPRB, 0.37099858E-03_JPRB, 0.37100195E-03_JPRB, 0.37100309E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37100367E-03_JPRB, 0.37100317E-03_JPRB, 0.37100061E-03_JPRB, 0.37100352E-03_JPRB, 0.37099532E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099735E-03_JPRB, 0.37099601E-03_JPRB, 0.37100096E-03_JPRB, 0.37100530E-03_JPRB, 0.37100448E-03_JPRB, &
  & 0.37100719E-03_JPRB, 0.37100149E-03_JPRB, 0.37099887E-03_JPRB, 0.37099500E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG1(:, 1, 2) = (/ &
  & 0.36384840E-03_JPRB, 0.36368545E-03_JPRB, 0.36350725E-03_JPRB, 0.36336193E-03_JPRB, 0.36323015E-03_JPRB, 0.36310958E-03_JPRB, &
  & 0.36298542E-03_JPRB, 0.36282049E-03_JPRB, 0.36264048E-03_JPRB, 0.36247721E-03_JPRB, 0.36233381E-03_JPRB, 0.36222150E-03_JPRB, &
  & 0.36214845E-03_JPRB, 0.36211827E-03_JPRB, 0.36212639E-03_JPRB, 0.36216175E-03_JPRB, 0.36220986E-03_JPRB, 0.36225349E-03_JPRB, &
  & 0.36227042E-03_JPRB, 0.36224909E-03_JPRB, 0.36219382E-03_JPRB, 0.36211888E-03_JPRB, 0.36203596E-03_JPRB, 0.36194967E-03_JPRB, &
  & 0.36185939E-03_JPRB, 0.36175537E-03_JPRB, 0.36162266E-03_JPRB, 0.36146285E-03_JPRB, 0.36129382E-03_JPRB, 0.36112685E-03_JPRB, &
  & 0.36096637E-03_JPRB, 0.36081643E-03_JPRB, 0.36068057E-03_JPRB, 0.36056218E-03_JPRB, 0.36046494E-03_JPRB, 0.36039317E-03_JPRB, &
  & 0.36035079E-03_JPRB, 0.36034061E-03_JPRB, 0.36035897E-03_JPRB, 0.36038837E-03_JPRB, 0.36041174E-03_JPRB, 0.36042274E-03_JPRB, &
  & 0.36041881E-03_JPRB, 0.36039806E-03_JPRB, 0.36035752E-03_JPRB, 0.36029110E-03_JPRB, 0.36019355E-03_JPRB, 0.36006561E-03_JPRB, &
  & 0.35991747E-03_JPRB, 0.35976866E-03_JPRB, 0.35964098E-03_JPRB, 0.35955093E-03_JPRB, 0.35950498E-03_JPRB, 0.35949860E-03_JPRB, &
  & 0.35951970E-03_JPRB, 0.35955419E-03_JPRB, 0.35959145E-03_JPRB, 0.35962509E-03_JPRB, 0.35965431E-03_JPRB, 0.35967873E-03_JPRB, &
  & 0.35969878E-03_JPRB, 0.35971470E-03_JPRB, 0.35972570E-03_JPRB, 0.35973301E-03_JPRB /)

RGHG1(:, 2, 2) = (/ &
  & 0.36415784E-03_JPRB, 0.36408342E-03_JPRB, 0.36401988E-03_JPRB, 0.36396028E-03_JPRB, 0.36390041E-03_JPRB, 0.36383819E-03_JPRB, &
  & 0.36376968E-03_JPRB, 0.36369031E-03_JPRB, 0.36361016E-03_JPRB, 0.36354372E-03_JPRB, 0.36350181E-03_JPRB, 0.36349130E-03_JPRB, &
  & 0.36351325E-03_JPRB, 0.36356261E-03_JPRB, 0.36362864E-03_JPRB, 0.36369753E-03_JPRB, 0.36375591E-03_JPRB, 0.36378871E-03_JPRB, &
  & 0.36378385E-03_JPRB, 0.36374017E-03_JPRB, 0.36366680E-03_JPRB, 0.36357512E-03_JPRB, 0.36347361E-03_JPRB, 0.36336519E-03_JPRB, &
  & 0.36324924E-03_JPRB, 0.36312192E-03_JPRB, 0.36298027E-03_JPRB, 0.36283035E-03_JPRB, 0.36268361E-03_JPRB, 0.36254560E-03_JPRB, &
  & 0.36241667E-03_JPRB, 0.36229505E-03_JPRB, 0.36218180E-03_JPRB, 0.36207982E-03_JPRB, 0.36199679E-03_JPRB, 0.36194240E-03_JPRB, &
  & 0.36192569E-03_JPRB, 0.36195185E-03_JPRB, 0.36201175E-03_JPRB, 0.36208157E-03_JPRB, 0.36213573E-03_JPRB, 0.36215706E-03_JPRB, &
  & 0.36213614E-03_JPRB, 0.36206946E-03_JPRB, 0.36195869E-03_JPRB, 0.36181067E-03_JPRB, 0.36164088E-03_JPRB, 0.36146797E-03_JPRB, &
  & 0.36130464E-03_JPRB, 0.36115269E-03_JPRB, 0.36100624E-03_JPRB, 0.36086270E-03_JPRB, 0.36072743E-03_JPRB, 0.36060956E-03_JPRB, &
  & 0.36051503E-03_JPRB, 0.36044500E-03_JPRB, 0.36039727E-03_JPRB, 0.36036817E-03_JPRB, 0.36035402E-03_JPRB, 0.36035181E-03_JPRB, &
  & 0.36035624E-03_JPRB, 0.36036345E-03_JPRB, 0.36037280E-03_JPRB, 0.36038566E-03_JPRB /)

RGHG1(:, 3, 2) = (/ &
  & 0.36425283E-03_JPRB, 0.36421994E-03_JPRB, 0.36419905E-03_JPRB, 0.36418001E-03_JPRB, 0.36416209E-03_JPRB, 0.36414454E-03_JPRB, &
  & 0.36412731E-03_JPRB, 0.36411276E-03_JPRB, 0.36410458E-03_JPRB, 0.36410731E-03_JPRB, 0.36412352E-03_JPRB, 0.36415309E-03_JPRB, &
  & 0.36419465E-03_JPRB, 0.36424404E-03_JPRB, 0.36429521E-03_JPRB, 0.36434209E-03_JPRB, 0.36437871E-03_JPRB, 0.36439844E-03_JPRB, &
  & 0.36439663E-03_JPRB, 0.36437382E-03_JPRB, 0.36433415E-03_JPRB, 0.36428348E-03_JPRB, 0.36422579E-03_JPRB, 0.36416313E-03_JPRB, &
  & 0.36409454E-03_JPRB, 0.36401878E-03_JPRB, 0.36393575E-03_JPRB, 0.36385015E-03_JPRB, 0.36376622E-03_JPRB, 0.36368522E-03_JPRB, &
  & 0.36360574E-03_JPRB, 0.36352788E-03_JPRB, 0.36345419E-03_JPRB, 0.36339398E-03_JPRB, 0.36335847E-03_JPRB, 0.36335585E-03_JPRB, &
  & 0.36338787E-03_JPRB, 0.36344727E-03_JPRB, 0.36351976E-03_JPRB, 0.36358426E-03_JPRB, 0.36362105E-03_JPRB, 0.36361604E-03_JPRB, &
  & 0.36356156E-03_JPRB, 0.36345620E-03_JPRB, 0.36330387E-03_JPRB, 0.36311225E-03_JPRB, 0.36288850E-03_JPRB, 0.36264068E-03_JPRB, &
  & 0.36237692E-03_JPRB, 0.36210872E-03_JPRB, 0.36185459E-03_JPRB, 0.36163343E-03_JPRB, 0.36145435E-03_JPRB, 0.36131602E-03_JPRB, &
  & 0.36121422E-03_JPRB, 0.36114478E-03_JPRB, 0.36110188E-03_JPRB, 0.36107819E-03_JPRB, 0.36106692E-03_JPRB, 0.36106273E-03_JPRB, &
  & 0.36106410E-03_JPRB, 0.36106934E-03_JPRB, 0.36107685E-03_JPRB, 0.36109029E-03_JPRB /)

RGHG1(:, 4, 2) = (/ &
  & 0.36429527E-03_JPRB, 0.36427990E-03_JPRB, 0.36427248E-03_JPRB, 0.36426834E-03_JPRB, 0.36426727E-03_JPRB, 0.36426942E-03_JPRB, &
  & 0.36427606E-03_JPRB, 0.36428892E-03_JPRB, 0.36430874E-03_JPRB, 0.36433665E-03_JPRB, 0.36437123E-03_JPRB, 0.36441133E-03_JPRB, &
  & 0.36445493E-03_JPRB, 0.36449978E-03_JPRB, 0.36454335E-03_JPRB, 0.36458293E-03_JPRB, 0.36461596E-03_JPRB, 0.36463985E-03_JPRB, &
  & 0.36465237E-03_JPRB, 0.36465374E-03_JPRB, 0.36464568E-03_JPRB, 0.36463130E-03_JPRB, 0.36461343E-03_JPRB, 0.36459448E-03_JPRB, &
  & 0.36457583E-03_JPRB, 0.36455775E-03_JPRB, 0.36453965E-03_JPRB, 0.36451971E-03_JPRB, 0.36449643E-03_JPRB, 0.36446782E-03_JPRB, &
  & 0.36443304E-03_JPRB, 0.36439349E-03_JPRB, 0.36435359E-03_JPRB, 0.36432088E-03_JPRB, 0.36430289E-03_JPRB, 0.36430405E-03_JPRB, &
  & 0.36432422E-03_JPRB, 0.36435865E-03_JPRB, 0.36439762E-03_JPRB, 0.36442673E-03_JPRB, 0.36442868E-03_JPRB, 0.36438950E-03_JPRB, &
  & 0.36430449E-03_JPRB, 0.36417812E-03_JPRB, 0.36402003E-03_JPRB, 0.36383880E-03_JPRB, 0.36363996E-03_JPRB, 0.36342707E-03_JPRB, &
  & 0.36320477E-03_JPRB, 0.36298041E-03_JPRB, 0.36276068E-03_JPRB, 0.36254802E-03_JPRB, 0.36234560E-03_JPRB, 0.36216283E-03_JPRB, &
  & 0.36200997E-03_JPRB, 0.36189158E-03_JPRB, 0.36180572E-03_JPRB, 0.36174781E-03_JPRB, 0.36171282E-03_JPRB, 0.36169600E-03_JPRB, &
  & 0.36169152E-03_JPRB, 0.36169396E-03_JPRB, 0.36169964E-03_JPRB, 0.36171274E-03_JPRB /)

RGHG1(:, 5, 2) = (/ &
  & 0.36433496E-03_JPRB, 0.36433211E-03_JPRB, 0.36433397E-03_JPRB, 0.36433875E-03_JPRB, 0.36434751E-03_JPRB, 0.36436063E-03_JPRB, &
  & 0.36437920E-03_JPRB, 0.36440426E-03_JPRB, 0.36443572E-03_JPRB, 0.36447414E-03_JPRB, 0.36451680E-03_JPRB, 0.36456186E-03_JPRB, &
  & 0.36460767E-03_JPRB, 0.36465266E-03_JPRB, 0.36469568E-03_JPRB, 0.36473543E-03_JPRB, 0.36477114E-03_JPRB, 0.36480176E-03_JPRB, &
  & 0.36482699E-03_JPRB, 0.36484745E-03_JPRB, 0.36486436E-03_JPRB, 0.36487944E-03_JPRB, 0.36489451E-03_JPRB, 0.36491072E-03_JPRB, &
  & 0.36492839E-03_JPRB, 0.36494652E-03_JPRB, 0.36496343E-03_JPRB, 0.36497644E-03_JPRB, 0.36498343E-03_JPRB, 0.36498241E-03_JPRB, &
  & 0.36497321E-03_JPRB, 0.36495764E-03_JPRB, 0.36493942E-03_JPRB, 0.36492402E-03_JPRB, 0.36491611E-03_JPRB, 0.36491844E-03_JPRB, &
  & 0.36493130E-03_JPRB, 0.36495106E-03_JPRB, 0.36496943E-03_JPRB, 0.36497149E-03_JPRB, 0.36493866E-03_JPRB, 0.36485930E-03_JPRB, &
  & 0.36473817E-03_JPRB, 0.36459166E-03_JPRB, 0.36443374E-03_JPRB, 0.36427201E-03_JPRB, 0.36410851E-03_JPRB, 0.36394285E-03_JPRB, &
  & 0.36377402E-03_JPRB, 0.36360050E-03_JPRB, 0.36342093E-03_JPRB, 0.36323749E-03_JPRB, 0.36305841E-03_JPRB, 0.36289237E-03_JPRB, &
  & 0.36274520E-03_JPRB, 0.36262197E-03_JPRB, 0.36252657E-03_JPRB, 0.36245934E-03_JPRB, 0.36241626E-03_JPRB, 0.36239077E-03_JPRB, &
  & 0.36237662E-03_JPRB, 0.36237013E-03_JPRB, 0.36236926E-03_JPRB, 0.36237121E-03_JPRB /)

RGHG1(:, 6, 2) = (/ &
  & 0.36438150E-03_JPRB, 0.36439154E-03_JPRB, 0.36440254E-03_JPRB, 0.36441625E-03_JPRB, 0.36443394E-03_JPRB, 0.36445609E-03_JPRB, &
  & 0.36448389E-03_JPRB, 0.36451838E-03_JPRB, 0.36455912E-03_JPRB, 0.36460615E-03_JPRB, 0.36465743E-03_JPRB, 0.36470991E-03_JPRB, &
  & 0.36476160E-03_JPRB, 0.36481189E-03_JPRB, 0.36485956E-03_JPRB, 0.36490418E-03_JPRB, 0.36494556E-03_JPRB, 0.36498421E-03_JPRB, &
  & 0.36502056E-03_JPRB, 0.36505639E-03_JPRB, 0.36509271E-03_JPRB, 0.36513165E-03_JPRB, 0.36517385E-03_JPRB, 0.36521943E-03_JPRB, &
  & 0.36526713E-03_JPRB, 0.36531483E-03_JPRB, 0.36536047E-03_JPRB, 0.36540275E-03_JPRB, 0.36543884E-03_JPRB, 0.36546719E-03_JPRB, &
  & 0.36548660E-03_JPRB, 0.36549763E-03_JPRB, 0.36550339E-03_JPRB, 0.36550747E-03_JPRB, 0.36551297E-03_JPRB, 0.36552106E-03_JPRB, &
  & 0.36553078E-03_JPRB, 0.36553747E-03_JPRB, 0.36553049E-03_JPRB, 0.36549350E-03_JPRB, 0.36540953E-03_JPRB, 0.36527641E-03_JPRB, &
  & 0.36511372E-03_JPRB, 0.36494440E-03_JPRB, 0.36478185E-03_JPRB, 0.36462914E-03_JPRB, 0.36448473E-03_JPRB, 0.36434497E-03_JPRB, &
  & 0.36420597E-03_JPRB, 0.36406412E-03_JPRB, 0.36391805E-03_JPRB, 0.36377000E-03_JPRB, 0.36362300E-03_JPRB, 0.36348100E-03_JPRB, &
  & 0.36335105E-03_JPRB, 0.36324025E-03_JPRB, 0.36315195E-03_JPRB, 0.36308618E-03_JPRB, 0.36304054E-03_JPRB, 0.36301120E-03_JPRB, &
  & 0.36299360E-03_JPRB, 0.36298262E-03_JPRB, 0.36297482E-03_JPRB, 0.36296964E-03_JPRB /)

RGHG1(:, 7, 2) = (/ &
  & 0.36444113E-03_JPRB, 0.36446386E-03_JPRB, 0.36448383E-03_JPRB, 0.36450659E-03_JPRB, 0.36453386E-03_JPRB, 0.36456611E-03_JPRB, &
  & 0.36460441E-03_JPRB, 0.36464969E-03_JPRB, 0.36470214E-03_JPRB, 0.36476197E-03_JPRB, 0.36482586E-03_JPRB, 0.36489102E-03_JPRB, &
  & 0.36495566E-03_JPRB, 0.36501812E-03_JPRB, 0.36507717E-03_JPRB, 0.36513212E-03_JPRB, 0.36518366E-03_JPRB, 0.36523261E-03_JPRB, &
  & 0.36528087E-03_JPRB, 0.36532953E-03_JPRB, 0.36538130E-03_JPRB, 0.36543817E-03_JPRB, 0.36550057E-03_JPRB, 0.36556832E-03_JPRB, &
  & 0.36563948E-03_JPRB, 0.36571184E-03_JPRB, 0.36578387E-03_JPRB, 0.36585430E-03_JPRB, 0.36592211E-03_JPRB, 0.36598468E-03_JPRB, &
  & 0.36604004E-03_JPRB, 0.36608646E-03_JPRB, 0.36612281E-03_JPRB, 0.36614900E-03_JPRB, 0.36616510E-03_JPRB, 0.36617092E-03_JPRB, &
  & 0.36616440E-03_JPRB, 0.36614019E-03_JPRB, 0.36608867E-03_JPRB, 0.36599571E-03_JPRB, 0.36585072E-03_JPRB, 0.36566390E-03_JPRB, &
  & 0.36546378E-03_JPRB, 0.36527519E-03_JPRB, 0.36510703E-03_JPRB, 0.36495813E-03_JPRB, 0.36482356E-03_JPRB, 0.36469736E-03_JPRB, &
  & 0.36457399E-03_JPRB, 0.36444969E-03_JPRB, 0.36432262E-03_JPRB, 0.36419288E-03_JPRB, 0.36406299E-03_JPRB, 0.36393874E-03_JPRB, &
  & 0.36382611E-03_JPRB, 0.36372911E-03_JPRB, 0.36365024E-03_JPRB, 0.36359060E-03_JPRB, 0.36354869E-03_JPRB, 0.36352075E-03_JPRB, &
  & 0.36350207E-03_JPRB, 0.36348903E-03_JPRB, 0.36347899E-03_JPRB, 0.36347014E-03_JPRB /)

RGHG1(:, 8, 2) = (/ &
  & 0.36450601E-03_JPRB, 0.36454914E-03_JPRB, 0.36458176E-03_JPRB, 0.36461599E-03_JPRB, 0.36465525E-03_JPRB, 0.36470007E-03_JPRB, &
  & 0.36475185E-03_JPRB, 0.36481145E-03_JPRB, 0.36488002E-03_JPRB, 0.36495630E-03_JPRB, 0.36503808E-03_JPRB, 0.36512231E-03_JPRB, &
  & 0.36520668E-03_JPRB, 0.36528887E-03_JPRB, 0.36536681E-03_JPRB, 0.36543986E-03_JPRB, 0.36550808E-03_JPRB, 0.36557269E-03_JPRB, &
  & 0.36563521E-03_JPRB, 0.36569795E-03_JPRB, 0.36576262E-03_JPRB, 0.36583113E-03_JPRB, 0.36590497E-03_JPRB, 0.36598364E-03_JPRB, &
  & 0.36606623E-03_JPRB, 0.36615058E-03_JPRB, 0.36623620E-03_JPRB, 0.36632258E-03_JPRB, 0.36640841E-03_JPRB, 0.36649129E-03_JPRB, &
  & 0.36656688E-03_JPRB, 0.36663035E-03_JPRB, 0.36667706E-03_JPRB, 0.36670419E-03_JPRB, 0.36671001E-03_JPRB, 0.36669403E-03_JPRB, &
  & 0.36665573E-03_JPRB, 0.36659156E-03_JPRB, 0.36649415E-03_JPRB, 0.36635384E-03_JPRB, 0.36616536E-03_JPRB, 0.36594426E-03_JPRB, &
  & 0.36572304E-03_JPRB, 0.36552586E-03_JPRB, 0.36535878E-03_JPRB, 0.36521754E-03_JPRB, 0.36509376E-03_JPRB, 0.36497973E-03_JPRB, &
  & 0.36486943E-03_JPRB, 0.36475866E-03_JPRB, 0.36464466E-03_JPRB, 0.36452734E-03_JPRB, 0.36440967E-03_JPRB, 0.36429614E-03_JPRB, &
  & 0.36419131E-03_JPRB, 0.36409957E-03_JPRB, 0.36402428E-03_JPRB, 0.36396636E-03_JPRB, 0.36392425E-03_JPRB, 0.36389497E-03_JPRB, &
  & 0.36387428E-03_JPRB, 0.36385845E-03_JPRB, 0.36384378E-03_JPRB, 0.36382032E-03_JPRB /)

RGHG1(:, 9, 2) = (/ &
  & 0.36460426E-03_JPRB, 0.36466334E-03_JPRB, 0.36470985E-03_JPRB, 0.36475822E-03_JPRB, 0.36481160E-03_JPRB, 0.36487187E-03_JPRB, &
  & 0.36493957E-03_JPRB, 0.36501637E-03_JPRB, 0.36510281E-03_JPRB, 0.36519868E-03_JPRB, 0.36530194E-03_JPRB, 0.36540988E-03_JPRB, &
  & 0.36551952E-03_JPRB, 0.36562749E-03_JPRB, 0.36573139E-03_JPRB, 0.36582971E-03_JPRB, 0.36592176E-03_JPRB, 0.36600832E-03_JPRB, &
  & 0.36609013E-03_JPRB, 0.36616885E-03_JPRB, 0.36624662E-03_JPRB, 0.36632456E-03_JPRB, 0.36640334E-03_JPRB, 0.36648338E-03_JPRB, &
  & 0.36656373E-03_JPRB, 0.36664403E-03_JPRB, 0.36672517E-03_JPRB, 0.36680716E-03_JPRB, 0.36688891E-03_JPRB, 0.36696671E-03_JPRB, &
  & 0.36703434E-03_JPRB, 0.36708504E-03_JPRB, 0.36711185E-03_JPRB, 0.36711118E-03_JPRB, 0.36708187E-03_JPRB, 0.36702625E-03_JPRB, &
  & 0.36694610E-03_JPRB, 0.36684168E-03_JPRB, 0.36670902E-03_JPRB, 0.36653999E-03_JPRB, 0.36633108E-03_JPRB, 0.36609563E-03_JPRB, &
  & 0.36586646E-03_JPRB, 0.36566923E-03_JPRB, 0.36550922E-03_JPRB, 0.36537828E-03_JPRB, 0.36526629E-03_JPRB, 0.36516506E-03_JPRB, &
  & 0.36506826E-03_JPRB, 0.36497100E-03_JPRB, 0.36487001E-03_JPRB, 0.36476500E-03_JPRB, 0.36465761E-03_JPRB, 0.36455141E-03_JPRB, &
  & 0.36445161E-03_JPRB, 0.36436287E-03_JPRB, 0.36428875E-03_JPRB, 0.36423118E-03_JPRB, 0.36419020E-03_JPRB, 0.36416162E-03_JPRB, &
  & 0.36414174E-03_JPRB, 0.36412646E-03_JPRB, 0.36411313E-03_JPRB, 0.36409733E-03_JPRB /)

RGHG1(:,10, 2) = (/ &
  & 0.36476579E-03_JPRB, 0.36484702E-03_JPRB, 0.36491119E-03_JPRB, 0.36496978E-03_JPRB, 0.36503637E-03_JPRB, 0.36510974E-03_JPRB, &
  & 0.36519210E-03_JPRB, 0.36528407E-03_JPRB, 0.36538692E-03_JPRB, 0.36550005E-03_JPRB, 0.36562263E-03_JPRB, 0.36575142E-03_JPRB, &
  & 0.36588375E-03_JPRB, 0.36601661E-03_JPRB, 0.36614743E-03_JPRB, 0.36627334E-03_JPRB, 0.36639307E-03_JPRB, 0.36650515E-03_JPRB, &
  & 0.36660989E-03_JPRB, 0.36670742E-03_JPRB, 0.36679875E-03_JPRB, 0.36688457E-03_JPRB, 0.36696499E-03_JPRB, 0.36703976E-03_JPRB, &
  & 0.36710963E-03_JPRB, 0.36717480E-03_JPRB, 0.36723740E-03_JPRB, 0.36729808E-03_JPRB, 0.36735559E-03_JPRB, 0.36740568E-03_JPRB, &
  & 0.36744185E-03_JPRB, 0.36745542E-03_JPRB, 0.36743921E-03_JPRB, 0.36738961E-03_JPRB, 0.36730795E-03_JPRB, 0.36720053E-03_JPRB, &
  & 0.36707471E-03_JPRB, 0.36693370E-03_JPRB, 0.36677418E-03_JPRB, 0.36659004E-03_JPRB, 0.36637453E-03_JPRB, 0.36613739E-03_JPRB, &
  & 0.36590875E-03_JPRB, 0.36571347E-03_JPRB, 0.36555721E-03_JPRB, 0.36543343E-03_JPRB, 0.36533177E-03_JPRB, 0.36524321E-03_JPRB, &
  & 0.36515977E-03_JPRB, 0.36507598E-03_JPRB, 0.36498869E-03_JPRB, 0.36489643E-03_JPRB, 0.36479981E-03_JPRB, 0.36470211E-03_JPRB, &
  & 0.36460775E-03_JPRB, 0.36452225E-03_JPRB, 0.36445039E-03_JPRB, 0.36439591E-03_JPRB, 0.36435688E-03_JPRB, 0.36433083E-03_JPRB, &
  & 0.36431197E-03_JPRB, 0.36429765E-03_JPRB, 0.36428490E-03_JPRB, 0.36426712E-03_JPRB /)

RGHG1(:,11, 2) = (/ &
  & 0.36505415E-03_JPRB, 0.36517574E-03_JPRB, 0.36524684E-03_JPRB, 0.36531096E-03_JPRB, 0.36537851E-03_JPRB, 0.36545389E-03_JPRB, &
  & 0.36553844E-03_JPRB, 0.36563392E-03_JPRB, 0.36574106E-03_JPRB, 0.36586053E-03_JPRB, 0.36599176E-03_JPRB, 0.36613256E-03_JPRB, &
  & 0.36628026E-03_JPRB, 0.36643146E-03_JPRB, 0.36658306E-03_JPRB, 0.36673204E-03_JPRB, 0.36687520E-03_JPRB, 0.36701027E-03_JPRB, &
  & 0.36713519E-03_JPRB, 0.36724930E-03_JPRB, 0.36735227E-03_JPRB, 0.36744360E-03_JPRB, 0.36752372E-03_JPRB, 0.36759209E-03_JPRB, &
  & 0.36764983E-03_JPRB, 0.36769765E-03_JPRB, 0.36773732E-03_JPRB, 0.36776936E-03_JPRB, 0.36779270E-03_JPRB, 0.36780309E-03_JPRB, &
  & 0.36779439E-03_JPRB, 0.36775897E-03_JPRB, 0.36768979E-03_JPRB, 0.36758374E-03_JPRB, 0.36744413E-03_JPRB, 0.36728231E-03_JPRB, &
  & 0.36711100E-03_JPRB, 0.36693746E-03_JPRB, 0.36675922E-03_JPRB, 0.36656705E-03_JPRB, 0.36635445E-03_JPRB, 0.36612459E-03_JPRB, &
  & 0.36589490E-03_JPRB, 0.36569397E-03_JPRB, 0.36553649E-03_JPRB, 0.36541626E-03_JPRB, 0.36532059E-03_JPRB, 0.36523840E-03_JPRB, &
  & 0.36516241E-03_JPRB, 0.36508782E-03_JPRB, 0.36501070E-03_JPRB, 0.36492880E-03_JPRB, 0.36484230E-03_JPRB, 0.36475286E-03_JPRB, &
  & 0.36466506E-03_JPRB, 0.36458491E-03_JPRB, 0.36451867E-03_JPRB, 0.36446852E-03_JPRB, 0.36443502E-03_JPRB, 0.36441200E-03_JPRB, &
  & 0.36439666E-03_JPRB, 0.36438479E-03_JPRB, 0.36437437E-03_JPRB, 0.36436119E-03_JPRB /)

RGHG1(:,12, 2) = (/ &
  & 0.36556172E-03_JPRB, 0.36567161E-03_JPRB, 0.36572490E-03_JPRB, 0.36577540E-03_JPRB, 0.36582854E-03_JPRB, 0.36589080E-03_JPRB, &
  & 0.36596428E-03_JPRB, 0.36605023E-03_JPRB, 0.36615020E-03_JPRB, 0.36626466E-03_JPRB, 0.36639371E-03_JPRB, 0.36653547E-03_JPRB, &
  & 0.36668812E-03_JPRB, 0.36684779E-03_JPRB, 0.36701080E-03_JPRB, 0.36717302E-03_JPRB, 0.36733036E-03_JPRB, 0.36747876E-03_JPRB, &
  & 0.36761581E-03_JPRB, 0.36773924E-03_JPRB, 0.36784800E-03_JPRB, 0.36794093E-03_JPRB, 0.36801872E-03_JPRB, 0.36808054E-03_JPRB, &
  & 0.36812772E-03_JPRB, 0.36816034E-03_JPRB, 0.36817938E-03_JPRB, 0.36818421E-03_JPRB, 0.36817364E-03_JPRB, 0.36814422E-03_JPRB, &
  & 0.36809104E-03_JPRB, 0.36800830E-03_JPRB, 0.36789046E-03_JPRB, 0.36773586E-03_JPRB, 0.36755079E-03_JPRB, 0.36734840E-03_JPRB, &
  & 0.36714593E-03_JPRB, 0.36695122E-03_JPRB, 0.36676216E-03_JPRB, 0.36657118E-03_JPRB, 0.36636737E-03_JPRB, 0.36614767E-03_JPRB, &
  & 0.36592613E-03_JPRB, 0.36572432E-03_JPRB, 0.36555767E-03_JPRB, 0.36542607E-03_JPRB, 0.36532021E-03_JPRB, 0.36523092E-03_JPRB, &
  & 0.36515010E-03_JPRB, 0.36507190E-03_JPRB, 0.36499265E-03_JPRB, 0.36491069E-03_JPRB, 0.36482536E-03_JPRB, 0.36473817E-03_JPRB, &
  & 0.36465342E-03_JPRB, 0.36457728E-03_JPRB, 0.36451480E-03_JPRB, 0.36447000E-03_JPRB, 0.36443921E-03_JPRB, 0.36442024E-03_JPRB, &
  & 0.36440694E-03_JPRB, 0.36439762E-03_JPRB, 0.36439011E-03_JPRB, 0.36438220E-03_JPRB /)

RGHG1(:,13, 2) = (/ &
  & 0.36614481E-03_JPRB, 0.36621056E-03_JPRB, 0.36624284E-03_JPRB, 0.36627546E-03_JPRB, 0.36631458E-03_JPRB, 0.36636321E-03_JPRB, &
  & 0.36642360E-03_JPRB, 0.36649770E-03_JPRB, 0.36658623E-03_JPRB, 0.36669045E-03_JPRB, 0.36681068E-03_JPRB, 0.36694555E-03_JPRB, &
  & 0.36709322E-03_JPRB, 0.36725018E-03_JPRB, 0.36741272E-03_JPRB, 0.36757623E-03_JPRB, 0.36773621E-03_JPRB, 0.36788770E-03_JPRB, &
  & 0.36802641E-03_JPRB, 0.36815100E-03_JPRB, 0.36825830E-03_JPRB, 0.36834867E-03_JPRB, 0.36842100E-03_JPRB, 0.36847600E-03_JPRB, &
  & 0.36851363E-03_JPRB, 0.36853369E-03_JPRB, 0.36853578E-03_JPRB, 0.36851873E-03_JPRB, 0.36848104E-03_JPRB, 0.36841992E-03_JPRB, &
  & 0.36833191E-03_JPRB, 0.36821337E-03_JPRB, 0.36806171E-03_JPRB, 0.36787771E-03_JPRB, 0.36766924E-03_JPRB, 0.36745323E-03_JPRB, &
  & 0.36724703E-03_JPRB, 0.36705856E-03_JPRB, 0.36688475E-03_JPRB, 0.36671720E-03_JPRB, 0.36654717E-03_JPRB, 0.36636813E-03_JPRB, &
  & 0.36618006E-03_JPRB, 0.36599283E-03_JPRB, 0.36581964E-03_JPRB, 0.36566670E-03_JPRB, 0.36553227E-03_JPRB, 0.36541064E-03_JPRB, &
  & 0.36529658E-03_JPRB, 0.36518631E-03_JPRB, 0.36507723E-03_JPRB, 0.36496797E-03_JPRB, 0.36485895E-03_JPRB, 0.36475286E-03_JPRB, &
  & 0.36465388E-03_JPRB, 0.36456768E-03_JPRB, 0.36449940E-03_JPRB, 0.36444986E-03_JPRB, 0.36441832E-03_JPRB, 0.36439765E-03_JPRB, &
  & 0.36438485E-03_JPRB, 0.36437571E-03_JPRB, 0.36436878E-03_JPRB, 0.36436206E-03_JPRB /)

RGHG1(:,14, 2) = (/ &
  & 0.36666269E-03_JPRB, 0.36669982E-03_JPRB, 0.36672316E-03_JPRB, 0.36674819E-03_JPRB, 0.36678056E-03_JPRB, 0.36682276E-03_JPRB, &
  & 0.36687596E-03_JPRB, 0.36694165E-03_JPRB, 0.36702064E-03_JPRB, 0.36711450E-03_JPRB, 0.36722369E-03_JPRB, 0.36734750E-03_JPRB, &
  & 0.36748411E-03_JPRB, 0.36763068E-03_JPRB, 0.36778350E-03_JPRB, 0.36793851E-03_JPRB, 0.36809139E-03_JPRB, 0.36823659E-03_JPRB, &
  & 0.36836971E-03_JPRB, 0.36848820E-03_JPRB, 0.36858916E-03_JPRB, 0.36867277E-03_JPRB, 0.36873788E-03_JPRB, 0.36878488E-03_JPRB, &
  & 0.36881323E-03_JPRB, 0.36882216E-03_JPRB, 0.36881081E-03_JPRB, 0.36877734E-03_JPRB, 0.36872001E-03_JPRB, 0.36863729E-03_JPRB, &
  & 0.36852749E-03_JPRB, 0.36839023E-03_JPRB, 0.36822658E-03_JPRB, 0.36804116E-03_JPRB, 0.36784422E-03_JPRB, 0.36765114E-03_JPRB, &
  & 0.36747652E-03_JPRB, 0.36732625E-03_JPRB, 0.36719759E-03_JPRB, 0.36708068E-03_JPRB, 0.36696496E-03_JPRB, 0.36684293E-03_JPRB, &
  & 0.36670960E-03_JPRB, 0.36656205E-03_JPRB, 0.36640491E-03_JPRB, 0.36624516E-03_JPRB, 0.36608643E-03_JPRB, 0.36592846E-03_JPRB, &
  & 0.36576932E-03_JPRB, 0.36560776E-03_JPRB, 0.36544344E-03_JPRB, 0.36527787E-03_JPRB, 0.36511451E-03_JPRB, 0.36495781E-03_JPRB, &
  & 0.36481480E-03_JPRB, 0.36469195E-03_JPRB, 0.36459405E-03_JPRB, 0.36452294E-03_JPRB, 0.36447484E-03_JPRB, 0.36444463E-03_JPRB, &
  & 0.36442390E-03_JPRB, 0.36440909E-03_JPRB, 0.36439626E-03_JPRB, 0.36438089E-03_JPRB /)

RGHG1(:,15, 2) = (/ &
  & 0.36708920E-03_JPRB, 0.36712168E-03_JPRB, 0.36714537E-03_JPRB, 0.36717209E-03_JPRB, 0.36720594E-03_JPRB, 0.36724861E-03_JPRB, &
  & 0.36730117E-03_JPRB, 0.36736377E-03_JPRB, 0.36743743E-03_JPRB, 0.36752320E-03_JPRB, 0.36762212E-03_JPRB, 0.36773368E-03_JPRB, &
  & 0.36785644E-03_JPRB, 0.36798813E-03_JPRB, 0.36812594E-03_JPRB, 0.36826631E-03_JPRB, 0.36840569E-03_JPRB, 0.36853837E-03_JPRB, &
  & 0.36866078E-03_JPRB, 0.36876896E-03_JPRB, 0.36886134E-03_JPRB, 0.36893599E-03_JPRB, 0.36899274E-03_JPRB, 0.36903116E-03_JPRB, &
  & 0.36905031E-03_JPRB, 0.36904914E-03_JPRB, 0.36902618E-03_JPRB, 0.36897967E-03_JPRB, 0.36890880E-03_JPRB, 0.36881311E-03_JPRB, &
  & 0.36869364E-03_JPRB, 0.36855266E-03_JPRB, 0.36839509E-03_JPRB, 0.36822801E-03_JPRB, 0.36806334E-03_JPRB, 0.36791549E-03_JPRB, &
  & 0.36779421E-03_JPRB, 0.36770053E-03_JPRB, 0.36762719E-03_JPRB, 0.36756368E-03_JPRB, 0.36750000E-03_JPRB, 0.36742951E-03_JPRB, &
  & 0.36734412E-03_JPRB, 0.36723824E-03_JPRB, 0.36711220E-03_JPRB, 0.36697046E-03_JPRB, 0.36681641E-03_JPRB, 0.36665174E-03_JPRB, &
  & 0.36647575E-03_JPRB, 0.36628809E-03_JPRB, 0.36608946E-03_JPRB, 0.36588189E-03_JPRB, 0.36566996E-03_JPRB, 0.36546186E-03_JPRB, &
  & 0.36526655E-03_JPRB, 0.36509358E-03_JPRB, 0.36494905E-03_JPRB, 0.36483741E-03_JPRB, 0.36475726E-03_JPRB, 0.36470115E-03_JPRB, &
  & 0.36466192E-03_JPRB, 0.36462955E-03_JPRB, 0.36459940E-03_JPRB, 0.36455356E-03_JPRB /)

RGHG1(:,16, 2) = (/ &
  & 0.36744264E-03_JPRB, 0.36748371E-03_JPRB, 0.36751351E-03_JPRB, 0.36754631E-03_JPRB, 0.36758572E-03_JPRB, 0.36763295E-03_JPRB, &
  & 0.36768825E-03_JPRB, 0.36775193E-03_JPRB, 0.36782384E-03_JPRB, 0.36790554E-03_JPRB, 0.36799686E-03_JPRB, 0.36809768E-03_JPRB, &
  & 0.36820697E-03_JPRB, 0.36832335E-03_JPRB, 0.36844489E-03_JPRB, 0.36856876E-03_JPRB, 0.36869140E-03_JPRB, 0.36880927E-03_JPRB, &
  & 0.36891835E-03_JPRB, 0.36901480E-03_JPRB, 0.36909629E-03_JPRB, 0.36916128E-03_JPRB, 0.36920884E-03_JPRB, 0.36923823E-03_JPRB, &
  & 0.36924842E-03_JPRB, 0.36923759E-03_JPRB, 0.36920476E-03_JPRB, 0.36914879E-03_JPRB, 0.36906984E-03_JPRB, 0.36896922E-03_JPRB, &
  & 0.36885068E-03_JPRB, 0.36871884E-03_JPRB, 0.36858089E-03_JPRB, 0.36844614E-03_JPRB, 0.36832644E-03_JPRB, 0.36822964E-03_JPRB, &
  & 0.36816148E-03_JPRB, 0.36811869E-03_JPRB, 0.36809099E-03_JPRB, 0.36806797E-03_JPRB, 0.36804145E-03_JPRB, 0.36800286E-03_JPRB, &
  & 0.36794558E-03_JPRB, 0.36786660E-03_JPRB, 0.36776607E-03_JPRB, 0.36764695E-03_JPRB, 0.36751179E-03_JPRB, 0.36736159E-03_JPRB, &
  & 0.36719628E-03_JPRB, 0.36701554E-03_JPRB, 0.36682005E-03_JPRB, 0.36661164E-03_JPRB, 0.36639447E-03_JPRB, 0.36617479E-03_JPRB, &
  & 0.36596158E-03_JPRB, 0.36576414E-03_JPRB, 0.36559004E-03_JPRB, 0.36544405E-03_JPRB, 0.36532991E-03_JPRB, 0.36524460E-03_JPRB, &
  & 0.36517705E-03_JPRB, 0.36512106E-03_JPRB, 0.36506070E-03_JPRB, 0.36496704E-03_JPRB /)

RGHG1(:,17, 2) = (/ &
  & 0.36774031E-03_JPRB, 0.36779183E-03_JPRB, 0.36782931E-03_JPRB, 0.36786951E-03_JPRB, 0.36791622E-03_JPRB, 0.36797038E-03_JPRB, &
  & 0.36803170E-03_JPRB, 0.36809934E-03_JPRB, 0.36817318E-03_JPRB, 0.36825350E-03_JPRB, 0.36834058E-03_JPRB, 0.36843380E-03_JPRB, &
  & 0.36853220E-03_JPRB, 0.36863505E-03_JPRB, 0.36874169E-03_JPRB, 0.36884969E-03_JPRB, 0.36895674E-03_JPRB, 0.36905980E-03_JPRB, &
  & 0.36915491E-03_JPRB, 0.36923881E-03_JPRB, 0.36930895E-03_JPRB, 0.36936341E-03_JPRB, 0.36940095E-03_JPRB, 0.36942103E-03_JPRB, &
  & 0.36942182E-03_JPRB, 0.36940273E-03_JPRB, 0.36936271E-03_JPRB, 0.36930165E-03_JPRB, 0.36922190E-03_JPRB, 0.36912650E-03_JPRB, &
  & 0.36901870E-03_JPRB, 0.36890659E-03_JPRB, 0.36879728E-03_JPRB, 0.36870036E-03_JPRB, 0.36862312E-03_JPRB, 0.36857225E-03_JPRB, &
  & 0.36854795E-03_JPRB, 0.36854230E-03_JPRB, 0.36854451E-03_JPRB, 0.36854469E-03_JPRB, 0.36853569E-03_JPRB, 0.36851168E-03_JPRB, &
  & 0.36846835E-03_JPRB, 0.36840310E-03_JPRB, 0.36831730E-03_JPRB, 0.36821380E-03_JPRB, 0.36809483E-03_JPRB, 0.36796075E-03_JPRB, &
  & 0.36781150E-03_JPRB, 0.36764707E-03_JPRB, 0.36746848E-03_JPRB, 0.36727768E-03_JPRB, 0.36707829E-03_JPRB, 0.36687584E-03_JPRB, &
  & 0.36667756E-03_JPRB, 0.36649092E-03_JPRB, 0.36632121E-03_JPRB, 0.36617264E-03_JPRB, 0.36604819E-03_JPRB, 0.36594662E-03_JPRB, &
  & 0.36586498E-03_JPRB, 0.36578858E-03_JPRB, 0.36570895E-03_JPRB, 0.36556995E-03_JPRB /)

RGHG1(:,18, 2) = (/ &
  & 0.36798808E-03_JPRB, 0.36805702E-03_JPRB, 0.36810304E-03_JPRB, 0.36815024E-03_JPRB, 0.36820353E-03_JPRB, 0.36826386E-03_JPRB, &
  & 0.36833039E-03_JPRB, 0.36840283E-03_JPRB, 0.36847993E-03_JPRB, 0.36856128E-03_JPRB, 0.36864678E-03_JPRB, 0.36873599E-03_JPRB, &
  & 0.36882763E-03_JPRB, 0.36892080E-03_JPRB, 0.36901553E-03_JPRB, 0.36911078E-03_JPRB, 0.36920398E-03_JPRB, 0.36929324E-03_JPRB, &
  & 0.36937502E-03_JPRB, 0.36944638E-03_JPRB, 0.36950456E-03_JPRB, 0.36954801E-03_JPRB, 0.36957537E-03_JPRB, 0.36958567E-03_JPRB, &
  & 0.36957831E-03_JPRB, 0.36955293E-03_JPRB, 0.36950980E-03_JPRB, 0.36945110E-03_JPRB, 0.36937822E-03_JPRB, 0.36929539E-03_JPRB, &
  & 0.36920956E-03_JPRB, 0.36912516E-03_JPRB, 0.36904961E-03_JPRB, 0.36898901E-03_JPRB, 0.36894940E-03_JPRB, 0.36893279E-03_JPRB, &
  & 0.36893605E-03_JPRB, 0.36895095E-03_JPRB, 0.36896690E-03_JPRB, 0.36897598E-03_JPRB, 0.36897225E-03_JPRB, 0.36895080E-03_JPRB, &
  & 0.36890974E-03_JPRB, 0.36884873E-03_JPRB, 0.36876998E-03_JPRB, 0.36867560E-03_JPRB, 0.36856730E-03_JPRB, 0.36844515E-03_JPRB, &
  & 0.36830906E-03_JPRB, 0.36815961E-03_JPRB, 0.36799815E-03_JPRB, 0.36782667E-03_JPRB, 0.36764858E-03_JPRB, 0.36746848E-03_JPRB, &
  & 0.36729252E-03_JPRB, 0.36712631E-03_JPRB, 0.36697328E-03_JPRB, 0.36683562E-03_JPRB, 0.36671548E-03_JPRB, 0.36661478E-03_JPRB, &
  & 0.36652712E-03_JPRB, 0.36644773E-03_JPRB, 0.36635884E-03_JPRB, 0.36620631E-03_JPRB /)

RGHG1(:,19, 2) = (/ &
  & 0.36819768E-03_JPRB, 0.36827486E-03_JPRB, 0.36832859E-03_JPRB, 0.36838296E-03_JPRB, 0.36844300E-03_JPRB, 0.36850979E-03_JPRB, &
  & 0.36858240E-03_JPRB, 0.36865947E-03_JPRB, 0.36873994E-03_JPRB, 0.36882344E-03_JPRB, 0.36890901E-03_JPRB, 0.36899620E-03_JPRB, &
  & 0.36908404E-03_JPRB, 0.36917094E-03_JPRB, 0.36925767E-03_JPRB, 0.36934341E-03_JPRB, 0.36942627E-03_JPRB, 0.36950439E-03_JPRB, &
  & 0.36957461E-03_JPRB, 0.36963477E-03_JPRB, 0.36968247E-03_JPRB, 0.36971585E-03_JPRB, 0.36973367E-03_JPRB, 0.36973564E-03_JPRB, &
  & 0.36972170E-03_JPRB, 0.36969298E-03_JPRB, 0.36965113E-03_JPRB, 0.36959851E-03_JPRB, 0.36953983E-03_JPRB, 0.36947956E-03_JPRB, &
  & 0.36942164E-03_JPRB, 0.36936972E-03_JPRB, 0.36932851E-03_JPRB, 0.36930191E-03_JPRB, 0.36929155E-03_JPRB, 0.36929644E-03_JPRB, &
  & 0.36931329E-03_JPRB, 0.36933369E-03_JPRB, 0.36934958E-03_JPRB, 0.36935497E-03_JPRB, 0.36934571E-03_JPRB, 0.36931990E-03_JPRB, &
  & 0.36927644E-03_JPRB, 0.36921582E-03_JPRB, 0.36913951E-03_JPRB, 0.36904955E-03_JPRB, 0.36894745E-03_JPRB, 0.36883348E-03_JPRB, &
  & 0.36870743E-03_JPRB, 0.36857012E-03_JPRB, 0.36842359E-03_JPRB, 0.36826995E-03_JPRB, 0.36811229E-03_JPRB, 0.36795458E-03_JPRB, &
  & 0.36780172E-03_JPRB, 0.36765763E-03_JPRB, 0.36752451E-03_JPRB, 0.36740315E-03_JPRB, 0.36729447E-03_JPRB, 0.36719820E-03_JPRB, &
  & 0.36711292E-03_JPRB, 0.36703105E-03_JPRB, 0.36693830E-03_JPRB, 0.36678283E-03_JPRB /)

RGHG1(:,20, 2) = (/ &
  & 0.36839209E-03_JPRB, 0.36847117E-03_JPRB, 0.36852612E-03_JPRB, 0.36858217E-03_JPRB, 0.36864431E-03_JPRB, 0.36871422E-03_JPRB, &
  & 0.36879024E-03_JPRB, 0.36887085E-03_JPRB, 0.36895453E-03_JPRB, 0.36903989E-03_JPRB, 0.36912636E-03_JPRB, 0.36921271E-03_JPRB, &
  & 0.36929856E-03_JPRB, 0.36938227E-03_JPRB, 0.36946381E-03_JPRB, 0.36954309E-03_JPRB, 0.36961827E-03_JPRB, 0.36968777E-03_JPRB, &
  & 0.36974935E-03_JPRB, 0.36980069E-03_JPRB, 0.36983981E-03_JPRB, 0.36986507E-03_JPRB, 0.36987590E-03_JPRB, 0.36987197E-03_JPRB, &
  & 0.36985480E-03_JPRB, 0.36982592E-03_JPRB, 0.36978885E-03_JPRB, 0.36974839E-03_JPRB, 0.36970823E-03_JPRB, 0.36967173E-03_JPRB, &
  & 0.36964245E-03_JPRB, 0.36962202E-03_JPRB, 0.36961192E-03_JPRB, 0.36961219E-03_JPRB, 0.36962173E-03_JPRB, 0.36963823E-03_JPRB, &
  & 0.36965779E-03_JPRB, 0.36967488E-03_JPRB, 0.36968337E-03_JPRB, 0.36967912E-03_JPRB, 0.36966027E-03_JPRB, 0.36962627E-03_JPRB, &
  & 0.36957726E-03_JPRB, 0.36951413E-03_JPRB, 0.36943814E-03_JPRB, 0.36935072E-03_JPRB, 0.36925299E-03_JPRB, 0.36914466E-03_JPRB, &
  & 0.36902667E-03_JPRB, 0.36890036E-03_JPRB, 0.36876759E-03_JPRB, 0.36863069E-03_JPRB, 0.36849230E-03_JPRB, 0.36835577E-03_JPRB, &
  & 0.36822466E-03_JPRB, 0.36810176E-03_JPRB, 0.36798802E-03_JPRB, 0.36788301E-03_JPRB, 0.36778685E-03_JPRB, 0.36769919E-03_JPRB, &
  & 0.36761817E-03_JPRB, 0.36753700E-03_JPRB, 0.36744794E-03_JPRB, 0.36728519E-03_JPRB /)

RGHG1(:,21, 2) = (/ &
  & 0.36855217E-03_JPRB, 0.36863910E-03_JPRB, 0.36869792E-03_JPRB, 0.36875601E-03_JPRB, 0.36881943E-03_JPRB, 0.36888919E-03_JPRB, &
  & 0.36896544E-03_JPRB, 0.36904655E-03_JPRB, 0.36913087E-03_JPRB, 0.36921681E-03_JPRB, 0.36930334E-03_JPRB, 0.36938908E-03_JPRB, &
  & 0.36947342E-03_JPRB, 0.36955520E-03_JPRB, 0.36963375E-03_JPRB, 0.36970864E-03_JPRB, 0.36977895E-03_JPRB, 0.36984280E-03_JPRB, &
  & 0.36989833E-03_JPRB, 0.36994374E-03_JPRB, 0.36997706E-03_JPRB, 0.36999743E-03_JPRB, 0.37000421E-03_JPRB, 0.36999790E-03_JPRB, &
  & 0.36998058E-03_JPRB, 0.36995503E-03_JPRB, 0.36992610E-03_JPRB, 0.36989799E-03_JPRB, 0.36987438E-03_JPRB, 0.36985963E-03_JPRB, &
  & 0.36985459E-03_JPRB, 0.36985904E-03_JPRB, 0.36987144E-03_JPRB, 0.36988905E-03_JPRB, 0.36990989E-03_JPRB, 0.36993145E-03_JPRB, &
  & 0.36994938E-03_JPRB, 0.36995899E-03_JPRB, 0.36995695E-03_JPRB, 0.36994176E-03_JPRB, 0.36991306E-03_JPRB, 0.36987147E-03_JPRB, &
  & 0.36981757E-03_JPRB, 0.36975244E-03_JPRB, 0.36967685E-03_JPRB, 0.36959178E-03_JPRB, 0.36949737E-03_JPRB, 0.36939466E-03_JPRB, &
  & 0.36928488E-03_JPRB, 0.36916934E-03_JPRB, 0.36905007E-03_JPRB, 0.36892941E-03_JPRB, 0.36880944E-03_JPRB, 0.36869253E-03_JPRB, &
  & 0.36858124E-03_JPRB, 0.36847708E-03_JPRB, 0.36838010E-03_JPRB, 0.36828974E-03_JPRB, 0.36820536E-03_JPRB, 0.36812626E-03_JPRB, &
  & 0.36805001E-03_JPRB, 0.36797428E-03_JPRB, 0.36788190E-03_JPRB, 0.36772786E-03_JPRB /)

RGHG1(:,22, 2) = (/ &
  & 0.36870022E-03_JPRB, 0.36878424E-03_JPRB, 0.36884088E-03_JPRB, 0.36889923E-03_JPRB, 0.36896320E-03_JPRB, 0.36903433E-03_JPRB, &
  & 0.36911087E-03_JPRB, 0.36919172E-03_JPRB, 0.36927569E-03_JPRB, 0.36936131E-03_JPRB, 0.36944705E-03_JPRB, 0.36953200E-03_JPRB, &
  & 0.36961498E-03_JPRB, 0.36969539E-03_JPRB, 0.36977211E-03_JPRB, 0.36984452E-03_JPRB, 0.36991149E-03_JPRB, 0.36997159E-03_JPRB, &
  & 0.37002360E-03_JPRB, 0.37006562E-03_JPRB, 0.37009639E-03_JPRB, 0.37011501E-03_JPRB, 0.37012139E-03_JPRB, 0.37011641E-03_JPRB, &
  & 0.37010200E-03_JPRB, 0.37008221E-03_JPRB, 0.37006135E-03_JPRB, 0.37004420E-03_JPRB, 0.37003448E-03_JPRB, 0.37003530E-03_JPRB, &
  & 0.37004644E-03_JPRB, 0.37006644E-03_JPRB, 0.37009071E-03_JPRB, 0.37011746E-03_JPRB, 0.37014278E-03_JPRB, 0.37016335E-03_JPRB, &
  & 0.37017601E-03_JPRB, 0.37017776E-03_JPRB, 0.37016696E-03_JPRB, 0.37014359E-03_JPRB, 0.37010797E-03_JPRB, 0.37006143E-03_JPRB, &
  & 0.37000515E-03_JPRB, 0.36993966E-03_JPRB, 0.36986551E-03_JPRB, 0.36978303E-03_JPRB, 0.36969304E-03_JPRB, 0.36959723E-03_JPRB, &
  & 0.36949612E-03_JPRB, 0.36939172E-03_JPRB, 0.36928602E-03_JPRB, 0.36918081E-03_JPRB, 0.36907778E-03_JPRB, 0.36897848E-03_JPRB, &
  & 0.36888433E-03_JPRB, 0.36879603E-03_JPRB, 0.36871323E-03_JPRB, 0.36863494E-03_JPRB, 0.36856034E-03_JPRB, 0.36848843E-03_JPRB, &
  & 0.36841800E-03_JPRB, 0.36834311E-03_JPRB, 0.36825833E-03_JPRB, 0.36810161E-03_JPRB /)

RGHG1(:,23, 2) = (/ &
  & 0.36883005E-03_JPRB, 0.36891439E-03_JPRB, 0.36897097E-03_JPRB, 0.36902650E-03_JPRB, 0.36908823E-03_JPRB, 0.36915741E-03_JPRB, &
  & 0.36923325E-03_JPRB, 0.36931303E-03_JPRB, 0.36939571E-03_JPRB, 0.36947979E-03_JPRB, 0.36956440E-03_JPRB, 0.36964784E-03_JPRB, &
  & 0.36972950E-03_JPRB, 0.36980832E-03_JPRB, 0.36988343E-03_JPRB, 0.36995424E-03_JPRB, 0.37001946E-03_JPRB, 0.37007814E-03_JPRB, &
  & 0.37012892E-03_JPRB, 0.37017046E-03_JPRB, 0.37020151E-03_JPRB, 0.37022136E-03_JPRB, 0.37023032E-03_JPRB, 0.37022884E-03_JPRB, &
  & 0.37021996E-03_JPRB, 0.37020704E-03_JPRB, 0.37019420E-03_JPRB, 0.37018568E-03_JPRB, 0.37018536E-03_JPRB, 0.37019496E-03_JPRB, &
  & 0.37021411E-03_JPRB, 0.37023981E-03_JPRB, 0.37026862E-03_JPRB, 0.37029677E-03_JPRB, 0.37032057E-03_JPRB, 0.37033728E-03_JPRB, &
  & 0.37034415E-03_JPRB, 0.37033949E-03_JPRB, 0.37032241E-03_JPRB, 0.37029359E-03_JPRB, 0.37025436E-03_JPRB, 0.37020602E-03_JPRB, &
  & 0.37014941E-03_JPRB, 0.37008518E-03_JPRB, 0.37001347E-03_JPRB, 0.36993483E-03_JPRB, 0.36985075E-03_JPRB, 0.36976225E-03_JPRB, &
  & 0.36967051E-03_JPRB, 0.36957767E-03_JPRB, 0.36948529E-03_JPRB, 0.36939472E-03_JPRB, 0.36930709E-03_JPRB, 0.36922313E-03_JPRB, &
  & 0.36914347E-03_JPRB, 0.36906812E-03_JPRB, 0.36899644E-03_JPRB, 0.36892769E-03_JPRB, 0.36886078E-03_JPRB, 0.36879460E-03_JPRB, &
  & 0.36872737E-03_JPRB, 0.36865723E-03_JPRB, 0.36857103E-03_JPRB, 0.36842137E-03_JPRB /)

RGHG1(:,24, 2) = (/ &
  & 0.36894952E-03_JPRB, 0.36903057E-03_JPRB, 0.36908578E-03_JPRB, 0.36914088E-03_JPRB, 0.36920066E-03_JPRB, 0.36926716E-03_JPRB, &
  & 0.36933992E-03_JPRB, 0.36941728E-03_JPRB, 0.36949757E-03_JPRB, 0.36957933E-03_JPRB, 0.36966187E-03_JPRB, 0.36974356E-03_JPRB, &
  & 0.36982371E-03_JPRB, 0.36990122E-03_JPRB, 0.36997496E-03_JPRB, 0.37004464E-03_JPRB, 0.37010887E-03_JPRB, 0.37016702E-03_JPRB, &
  & 0.37021781E-03_JPRB, 0.37026033E-03_JPRB, 0.37029342E-03_JPRB, 0.37031682E-03_JPRB, 0.37033003E-03_JPRB, 0.37033469E-03_JPRB, &
  & 0.37033274E-03_JPRB, 0.37032721E-03_JPRB, 0.37032148E-03_JPRB, 0.37031941E-03_JPRB, 0.37032401E-03_JPRB, 0.37033722E-03_JPRB, &
  & 0.37035783E-03_JPRB, 0.37038320E-03_JPRB, 0.37041021E-03_JPRB, 0.37043513E-03_JPRB, 0.37045451E-03_JPRB, 0.37046592E-03_JPRB, &
  & 0.37046729E-03_JPRB, 0.37045742E-03_JPRB, 0.37043617E-03_JPRB, 0.37040471E-03_JPRB, 0.37036414E-03_JPRB, 0.37031600E-03_JPRB, &
  & 0.37026091E-03_JPRB, 0.37019930E-03_JPRB, 0.37013122E-03_JPRB, 0.37005759E-03_JPRB, 0.36997983E-03_JPRB, 0.36989912E-03_JPRB, &
  & 0.36981708E-03_JPRB, 0.36973559E-03_JPRB, 0.36965578E-03_JPRB, 0.36957854E-03_JPRB, 0.36950433E-03_JPRB, 0.36943343E-03_JPRB, &
  & 0.36936556E-03_JPRB, 0.36930048E-03_JPRB, 0.36923776E-03_JPRB, 0.36917624E-03_JPRB, 0.36911492E-03_JPRB, 0.36905278E-03_JPRB, &
  & 0.36898867E-03_JPRB, 0.36891879E-03_JPRB, 0.36883639E-03_JPRB, 0.36868785E-03_JPRB /)

RGHG1(:,25, 2) = (/ &
  & 0.36905968E-03_JPRB, 0.36913875E-03_JPRB, 0.36919111E-03_JPRB, 0.36924370E-03_JPRB, 0.36930188E-03_JPRB, 0.36936588E-03_JPRB, &
  & 0.36943535E-03_JPRB, 0.36950939E-03_JPRB, 0.36958631E-03_JPRB, 0.36966504E-03_JPRB, 0.36974455E-03_JPRB, 0.36982397E-03_JPRB, &
  & 0.36990200E-03_JPRB, 0.36997744E-03_JPRB, 0.37004997E-03_JPRB, 0.37011851E-03_JPRB, 0.37018242E-03_JPRB, 0.37024060E-03_JPRB, &
  & 0.37029234E-03_JPRB, 0.37033690E-03_JPRB, 0.37037325E-03_JPRB, 0.37040090E-03_JPRB, 0.37041973E-03_JPRB, 0.37043111E-03_JPRB, &
  & 0.37043638E-03_JPRB, 0.37043792E-03_JPRB, 0.37043859E-03_JPRB, 0.37044115E-03_JPRB, 0.37044851E-03_JPRB, 0.37046155E-03_JPRB, &
  & 0.37047980E-03_JPRB, 0.37050140E-03_JPRB, 0.37052351E-03_JPRB, 0.37054264E-03_JPRB, 0.37055631E-03_JPRB, 0.37056216E-03_JPRB, &
  & 0.37055844E-03_JPRB, 0.37054444E-03_JPRB, 0.37052072E-03_JPRB, 0.37048801E-03_JPRB, 0.37044808E-03_JPRB, 0.37040169E-03_JPRB, &
  & 0.37034930E-03_JPRB, 0.37029100E-03_JPRB, 0.37022732E-03_JPRB, 0.37015910E-03_JPRB, 0.37008757E-03_JPRB, 0.37001469E-03_JPRB, &
  & 0.36994205E-03_JPRB, 0.36987098E-03_JPRB, 0.36980235E-03_JPRB, 0.36973678E-03_JPRB, 0.36967412E-03_JPRB, 0.36961402E-03_JPRB, &
  & 0.36955587E-03_JPRB, 0.36949926E-03_JPRB, 0.36944344E-03_JPRB, 0.36938750E-03_JPRB, 0.36933040E-03_JPRB, 0.36927112E-03_JPRB, &
  & 0.36920849E-03_JPRB, 0.36914059E-03_JPRB, 0.36905872E-03_JPRB, 0.36891282E-03_JPRB /)

RGHG1(:,26, 2) = (/ &
  & 0.36916402E-03_JPRB, 0.36923986E-03_JPRB, 0.36929041E-03_JPRB, 0.36934047E-03_JPRB, 0.36939551E-03_JPRB, 0.36945660E-03_JPRB, &
  & 0.36952292E-03_JPRB, 0.36959330E-03_JPRB, 0.36966623E-03_JPRB, 0.36974132E-03_JPRB, 0.36981748E-03_JPRB, 0.36989385E-03_JPRB, &
  & 0.36996929E-03_JPRB, 0.37004304E-03_JPRB, 0.37011399E-03_JPRB, 0.37018128E-03_JPRB, 0.37024458E-03_JPRB, 0.37030291E-03_JPRB, &
  & 0.37035564E-03_JPRB, 0.37040195E-03_JPRB, 0.37044127E-03_JPRB, 0.37047316E-03_JPRB, 0.37049758E-03_JPRB, 0.37051531E-03_JPRB, &
  & 0.37052733E-03_JPRB, 0.37053516E-03_JPRB, 0.37054124E-03_JPRB, 0.37054741E-03_JPRB, 0.37055582E-03_JPRB, 0.37056737E-03_JPRB, &
  & 0.37058201E-03_JPRB, 0.37059846E-03_JPRB, 0.37061441E-03_JPRB, 0.37062753E-03_JPRB, 0.37063548E-03_JPRB, 0.37063594E-03_JPRB, &
  & 0.37062814E-03_JPRB, 0.37061141E-03_JPRB, 0.37058620E-03_JPRB, 0.37055410E-03_JPRB, 0.37051560E-03_JPRB, 0.37047162E-03_JPRB, &
  & 0.37042235E-03_JPRB, 0.37036813E-03_JPRB, 0.37030899E-03_JPRB, 0.37024581E-03_JPRB, 0.37018058E-03_JPRB, 0.37011507E-03_JPRB, &
  & 0.37005072E-03_JPRB, 0.36998867E-03_JPRB, 0.36992965E-03_JPRB, 0.36987374E-03_JPRB, 0.36982057E-03_JPRB, 0.36976940E-03_JPRB, &
  & 0.36971929E-03_JPRB, 0.36966949E-03_JPRB, 0.36961935E-03_JPRB, 0.36956777E-03_JPRB, 0.36951379E-03_JPRB, 0.36945657E-03_JPRB, &
  & 0.36939530E-03_JPRB, 0.36932819E-03_JPRB, 0.36924754E-03_JPRB, 0.36910467E-03_JPRB /)

RGHG1(:,27, 2) = (/ &
  & 0.36926422E-03_JPRB, 0.36933701E-03_JPRB, 0.36938561E-03_JPRB, 0.36943355E-03_JPRB, 0.36948544E-03_JPRB, 0.36954289E-03_JPRB, &
  & 0.36960543E-03_JPRB, 0.36967167E-03_JPRB, 0.36974036E-03_JPRB, 0.36981108E-03_JPRB, 0.36988317E-03_JPRB, 0.36995590E-03_JPRB, &
  & 0.37002852E-03_JPRB, 0.37009976E-03_JPRB, 0.37016883E-03_JPRB, 0.37023495E-03_JPRB, 0.37029749E-03_JPRB, 0.37035561E-03_JPRB, &
  & 0.37040873E-03_JPRB, 0.37045634E-03_JPRB, 0.37049796E-03_JPRB, 0.37053350E-03_JPRB, 0.37056251E-03_JPRB, 0.37058571E-03_JPRB, &
  & 0.37060340E-03_JPRB, 0.37061685E-03_JPRB, 0.37062724E-03_JPRB, 0.37063629E-03_JPRB, 0.37064505E-03_JPRB, 0.37065509E-03_JPRB, &
  & 0.37066621E-03_JPRB, 0.37067771E-03_JPRB, 0.37068798E-03_JPRB, 0.37069540E-03_JPRB, 0.37069831E-03_JPRB, 0.37069456E-03_JPRB, &
  & 0.37068367E-03_JPRB, 0.37066522E-03_JPRB, 0.37063993E-03_JPRB, 0.37060890E-03_JPRB, 0.37057273E-03_JPRB, 0.37053172E-03_JPRB, &
  & 0.37048614E-03_JPRB, 0.37043577E-03_JPRB, 0.37038111E-03_JPRB, 0.37032308E-03_JPRB, 0.37026330E-03_JPRB, 0.37020413E-03_JPRB, &
  & 0.37014688E-03_JPRB, 0.37009240E-03_JPRB, 0.37004132E-03_JPRB, 0.36999339E-03_JPRB, 0.36994787E-03_JPRB, 0.36990378E-03_JPRB, &
  & 0.36986012E-03_JPRB, 0.36981606E-03_JPRB, 0.36977045E-03_JPRB, 0.36972261E-03_JPRB, 0.36967130E-03_JPRB, 0.36961591E-03_JPRB, &
  & 0.36955599E-03_JPRB, 0.36949033E-03_JPRB, 0.36941213E-03_JPRB, 0.36927275E-03_JPRB /)

RGHG1(:,28, 2) = (/ &
  & 0.36936192E-03_JPRB, 0.36943215E-03_JPRB, 0.36947819E-03_JPRB, 0.36952336E-03_JPRB, 0.36957231E-03_JPRB, 0.36962601E-03_JPRB, &
  & 0.36968454E-03_JPRB, 0.36974630E-03_JPRB, 0.36981027E-03_JPRB, 0.36987642E-03_JPRB, 0.36994406E-03_JPRB, 0.37001283E-03_JPRB, &
  & 0.37008178E-03_JPRB, 0.37015037E-03_JPRB, 0.37021723E-03_JPRB, 0.37028189E-03_JPRB, 0.37034322E-03_JPRB, 0.37040093E-03_JPRB, &
  & 0.37045431E-03_JPRB, 0.37050270E-03_JPRB, 0.37054592E-03_JPRB, 0.37058373E-03_JPRB, 0.37061612E-03_JPRB, 0.37064336E-03_JPRB, &
  & 0.37066569E-03_JPRB, 0.37068350E-03_JPRB, 0.37069747E-03_JPRB, 0.37070861E-03_JPRB, 0.37071799E-03_JPRB, 0.37072654E-03_JPRB, &
  & 0.37073460E-03_JPRB, 0.37074208E-03_JPRB, 0.37074782E-03_JPRB, 0.37075052E-03_JPRB, 0.37074921E-03_JPRB, 0.37074229E-03_JPRB, &
  & 0.37072939E-03_JPRB, 0.37071056E-03_JPRB, 0.37068609E-03_JPRB, 0.37065707E-03_JPRB, 0.37062372E-03_JPRB, 0.37058597E-03_JPRB, &
  & 0.37054403E-03_JPRB, 0.37049758E-03_JPRB, 0.37044700E-03_JPRB, 0.37039351E-03_JPRB, 0.37033897E-03_JPRB, 0.37028510E-03_JPRB, &
  & 0.37023367E-03_JPRB, 0.37018530E-03_JPRB, 0.37014048E-03_JPRB, 0.37009863E-03_JPRB, 0.37005881E-03_JPRB, 0.37002022E-03_JPRB, &
  & 0.36998178E-03_JPRB, 0.36994214E-03_JPRB, 0.36990063E-03_JPRB, 0.36985596E-03_JPRB, 0.36980741E-03_JPRB, 0.36975413E-03_JPRB, &
  & 0.36969632E-03_JPRB, 0.36963326E-03_JPRB, 0.36955893E-03_JPRB, 0.36942519E-03_JPRB /)

RGHG1(:,29, 2) = (/ &
  & 0.36945846E-03_JPRB, 0.36952575E-03_JPRB, 0.36956940E-03_JPRB, 0.36961181E-03_JPRB, 0.36965709E-03_JPRB, 0.36970712E-03_JPRB, &
  & 0.36976140E-03_JPRB, 0.36981862E-03_JPRB, 0.36987790E-03_JPRB, 0.36993914E-03_JPRB, 0.37000206E-03_JPRB, 0.37006647E-03_JPRB, &
  & 0.37013201E-03_JPRB, 0.37019743E-03_JPRB, 0.37026213E-03_JPRB, 0.37032500E-03_JPRB, 0.37038527E-03_JPRB, 0.37044220E-03_JPRB, &
  & 0.37049523E-03_JPRB, 0.37054365E-03_JPRB, 0.37058746E-03_JPRB, 0.37062654E-03_JPRB, 0.37066103E-03_JPRB, 0.37069092E-03_JPRB, &
  & 0.37071639E-03_JPRB, 0.37073719E-03_JPRB, 0.37075367E-03_JPRB, 0.37076656E-03_JPRB, 0.37077646E-03_JPRB, 0.37078396E-03_JPRB, &
  & 0.37079002E-03_JPRB, 0.37079427E-03_JPRB, 0.37079645E-03_JPRB, 0.37079575E-03_JPRB, 0.37079133E-03_JPRB, 0.37078242E-03_JPRB, &
  & 0.37076860E-03_JPRB, 0.37075015E-03_JPRB, 0.37072750E-03_JPRB, 0.37070102E-03_JPRB, 0.37067066E-03_JPRB, 0.37063638E-03_JPRB, &
  & 0.37059799E-03_JPRB, 0.37055535E-03_JPRB, 0.37050882E-03_JPRB, 0.37045960E-03_JPRB, 0.37040925E-03_JPRB, 0.37035995E-03_JPRB, &
  & 0.37031301E-03_JPRB, 0.37026958E-03_JPRB, 0.37022945E-03_JPRB, 0.37019214E-03_JPRB, 0.37015678E-03_JPRB, 0.37012232E-03_JPRB, &
  & 0.37008760E-03_JPRB, 0.37005168E-03_JPRB, 0.37001329E-03_JPRB, 0.36997156E-03_JPRB, 0.36992549E-03_JPRB, 0.36987476E-03_JPRB, &
  & 0.36981981E-03_JPRB, 0.36976149E-03_JPRB, 0.36969187E-03_JPRB, 0.36956932E-03_JPRB /)

RGHG1(:,30, 2) = (/ &
  & 0.36955401E-03_JPRB, 0.36961885E-03_JPRB, 0.36965962E-03_JPRB, 0.36969868E-03_JPRB, 0.36974056E-03_JPRB, 0.36978658E-03_JPRB, &
  & 0.36983658E-03_JPRB, 0.36988931E-03_JPRB, 0.36994391E-03_JPRB, 0.37000014E-03_JPRB, 0.37005817E-03_JPRB, 0.37011784E-03_JPRB, &
  & 0.37017933E-03_JPRB, 0.37024196E-03_JPRB, 0.37030439E-03_JPRB, 0.37036589E-03_JPRB, 0.37042508E-03_JPRB, 0.37048126E-03_JPRB, &
  & 0.37053353E-03_JPRB, 0.37058143E-03_JPRB, 0.37062514E-03_JPRB, 0.37066458E-03_JPRB, 0.37070006E-03_JPRB, 0.37073143E-03_JPRB, &
  & 0.37075856E-03_JPRB, 0.37078091E-03_JPRB, 0.37079907E-03_JPRB, 0.37081289E-03_JPRB, 0.37082308E-03_JPRB, 0.37083012E-03_JPRB, &
  & 0.37083492E-03_JPRB, 0.37083693E-03_JPRB, 0.37083679E-03_JPRB, 0.37083362E-03_JPRB, 0.37082733E-03_JPRB, 0.37081720E-03_JPRB, &
  & 0.37080349E-03_JPRB, 0.37078621E-03_JPRB, 0.37076551E-03_JPRB, 0.37074173E-03_JPRB, 0.37071458E-03_JPRB, 0.37068361E-03_JPRB, &
  & 0.37064869E-03_JPRB, 0.37060966E-03_JPRB, 0.37056700E-03_JPRB, 0.37052148E-03_JPRB, 0.37047511E-03_JPRB, 0.37042942E-03_JPRB, &
  & 0.37038643E-03_JPRB, 0.37034656E-03_JPRB, 0.37030998E-03_JPRB, 0.37027602E-03_JPRB, 0.37024368E-03_JPRB, 0.37021228E-03_JPRB, &
  & 0.37018041E-03_JPRB, 0.37014717E-03_JPRB, 0.37011137E-03_JPRB, 0.37007211E-03_JPRB, 0.37002860E-03_JPRB, 0.36998044E-03_JPRB, &
  & 0.36992985E-03_JPRB, 0.36987636E-03_JPRB, 0.36981603E-03_JPRB, 0.36970471E-03_JPRB /)

RGHG1(:,31, 2) = (/ &
  & 0.36964926E-03_JPRB, 0.36971035E-03_JPRB, 0.36974822E-03_JPRB, 0.36978413E-03_JPRB, 0.36982237E-03_JPRB, 0.36986457E-03_JPRB, &
  & 0.36991044E-03_JPRB, 0.36995881E-03_JPRB, 0.37000893E-03_JPRB, 0.37006033E-03_JPRB, 0.37011353E-03_JPRB, 0.37016894E-03_JPRB, &
  & 0.37022645E-03_JPRB, 0.37028571E-03_JPRB, 0.37034595E-03_JPRB, 0.37040593E-03_JPRB, 0.37046414E-03_JPRB, 0.37051918E-03_JPRB, &
  & 0.37057066E-03_JPRB, 0.37061793E-03_JPRB, 0.37066126E-03_JPRB, 0.37070052E-03_JPRB, 0.37073600E-03_JPRB, 0.37076743E-03_JPRB, &
  & 0.37079485E-03_JPRB, 0.37081764E-03_JPRB, 0.37083623E-03_JPRB, 0.37085032E-03_JPRB, 0.37086039E-03_JPRB, 0.37086714E-03_JPRB, &
  & 0.37087084E-03_JPRB, 0.37087168E-03_JPRB, 0.37087020E-03_JPRB, 0.37086563E-03_JPRB, 0.37085830E-03_JPRB, 0.37084808E-03_JPRB, &
  & 0.37083492E-03_JPRB, 0.37081906E-03_JPRB, 0.37080070E-03_JPRB, 0.37077972E-03_JPRB, 0.37075565E-03_JPRB, 0.37072806E-03_JPRB, &
  & 0.37069642E-03_JPRB, 0.37066065E-03_JPRB, 0.37062139E-03_JPRB, 0.37057931E-03_JPRB, 0.37053617E-03_JPRB, 0.37049400E-03_JPRB, &
  & 0.37045398E-03_JPRB, 0.37041714E-03_JPRB, 0.37038312E-03_JPRB, 0.37035166E-03_JPRB, 0.37032174E-03_JPRB, 0.37029234E-03_JPRB, &
  & 0.37026269E-03_JPRB, 0.37023154E-03_JPRB, 0.37019784E-03_JPRB, 0.37016065E-03_JPRB, 0.37011915E-03_JPRB, 0.37007450E-03_JPRB, &
  & 0.37002817E-03_JPRB, 0.36998183E-03_JPRB, 0.36992828E-03_JPRB, 0.36983343E-03_JPRB /)

RGHG1(:,32, 2) = (/ &
  & 0.36974275E-03_JPRB, 0.36980031E-03_JPRB, 0.36983527E-03_JPRB, 0.36986789E-03_JPRB, 0.36990273E-03_JPRB, 0.36994112E-03_JPRB, &
  & 0.36998314E-03_JPRB, 0.37002741E-03_JPRB, 0.37007316E-03_JPRB, 0.37011996E-03_JPRB, 0.37016845E-03_JPRB, 0.37021941E-03_JPRB, &
  & 0.37027328E-03_JPRB, 0.37032960E-03_JPRB, 0.37038757E-03_JPRB, 0.37044589E-03_JPRB, 0.37050302E-03_JPRB, 0.37055745E-03_JPRB, &
  & 0.37060812E-03_JPRB, 0.37065466E-03_JPRB, 0.37069706E-03_JPRB, 0.37073545E-03_JPRB, 0.37077014E-03_JPRB, 0.37080096E-03_JPRB, &
  & 0.37082745E-03_JPRB, 0.37084968E-03_JPRB, 0.37086755E-03_JPRB, 0.37088111E-03_JPRB, 0.37089092E-03_JPRB, 0.37089724E-03_JPRB, &
  & 0.37090038E-03_JPRB, 0.37090061E-03_JPRB, 0.37089828E-03_JPRB, 0.37089328E-03_JPRB, 0.37088577E-03_JPRB, 0.37087582E-03_JPRB, &
  & 0.37086383E-03_JPRB, 0.37084977E-03_JPRB, 0.37083388E-03_JPRB, 0.37081554E-03_JPRB, 0.37079435E-03_JPRB, 0.37076950E-03_JPRB, &
  & 0.37074060E-03_JPRB, 0.37070786E-03_JPRB, 0.37067116E-03_JPRB, 0.37063233E-03_JPRB, 0.37059243E-03_JPRB, 0.37055300E-03_JPRB, &
  & 0.37051595E-03_JPRB, 0.37048134E-03_JPRB, 0.37044950E-03_JPRB, 0.37041999E-03_JPRB, 0.37039179E-03_JPRB, 0.37036411E-03_JPRB, &
  & 0.37033606E-03_JPRB, 0.37030657E-03_JPRB, 0.37027462E-03_JPRB, 0.37023929E-03_JPRB, 0.37020035E-03_JPRB, 0.37015887E-03_JPRB, &
  & 0.37011763E-03_JPRB, 0.37007657E-03_JPRB, 0.37003175E-03_JPRB, 0.36994956E-03_JPRB /)

RGHG1(:,33, 2) = (/ &
  & 0.36983381E-03_JPRB, 0.36988736E-03_JPRB, 0.36991973E-03_JPRB, 0.36994956E-03_JPRB, 0.36998114E-03_JPRB, 0.37001621E-03_JPRB, &
  & 0.37005451E-03_JPRB, 0.37009496E-03_JPRB, 0.37013652E-03_JPRB, 0.37017890E-03_JPRB, 0.37022316E-03_JPRB, 0.37026979E-03_JPRB, &
  & 0.37031967E-03_JPRB, 0.37037305E-03_JPRB, 0.37042907E-03_JPRB, 0.37048609E-03_JPRB, 0.37054240E-03_JPRB, 0.37059613E-03_JPRB, &
  & 0.37064619E-03_JPRB, 0.37069194E-03_JPRB, 0.37073344E-03_JPRB, 0.37077043E-03_JPRB, 0.37080358E-03_JPRB, 0.37083251E-03_JPRB, &
  & 0.37085733E-03_JPRB, 0.37087794E-03_JPRB, 0.37089438E-03_JPRB, 0.37090690E-03_JPRB, 0.37091598E-03_JPRB, 0.37092192E-03_JPRB, &
  & 0.37092456E-03_JPRB, 0.37092474E-03_JPRB, 0.37092221E-03_JPRB, 0.37091743E-03_JPRB, 0.37091045E-03_JPRB, 0.37090157E-03_JPRB, &
  & 0.37089104E-03_JPRB, 0.37087893E-03_JPRB, 0.37086513E-03_JPRB, 0.37084916E-03_JPRB, 0.37083033E-03_JPRB, 0.37080797E-03_JPRB, &
  & 0.37078155E-03_JPRB, 0.37075081E-03_JPRB, 0.37071662E-03_JPRB, 0.37068030E-03_JPRB, 0.37064296E-03_JPRB, 0.37060652E-03_JPRB, &
  & 0.37057171E-03_JPRB, 0.37053938E-03_JPRB, 0.37050946E-03_JPRB, 0.37048140E-03_JPRB, 0.37045463E-03_JPRB, 0.37042820E-03_JPRB, &
  & 0.37040157E-03_JPRB, 0.37037363E-03_JPRB, 0.37034336E-03_JPRB, 0.37031004E-03_JPRB, 0.37027357E-03_JPRB, 0.37023547E-03_JPRB, &
  & 0.37019819E-03_JPRB, 0.37016274E-03_JPRB, 0.37012319E-03_JPRB, 0.37005366E-03_JPRB /)

RGHG1(:,34, 2) = (/ &
  & 0.36992138E-03_JPRB, 0.36997185E-03_JPRB, 0.37000133E-03_JPRB, 0.37002863E-03_JPRB, 0.37005759E-03_JPRB, 0.37008963E-03_JPRB, &
  & 0.37012470E-03_JPRB, 0.37016146E-03_JPRB, 0.37019909E-03_JPRB, 0.37023734E-03_JPRB, 0.37027730E-03_JPRB, 0.37031987E-03_JPRB, &
  & 0.37036630E-03_JPRB, 0.37041673E-03_JPRB, 0.37047063E-03_JPRB, 0.37052631E-03_JPRB, 0.37058187E-03_JPRB, 0.37063519E-03_JPRB, &
  & 0.37068460E-03_JPRB, 0.37072954E-03_JPRB, 0.37076970E-03_JPRB, 0.37080518E-03_JPRB, 0.37083597E-03_JPRB, 0.37086254E-03_JPRB, &
  & 0.37088469E-03_JPRB, 0.37090314E-03_JPRB, 0.37091758E-03_JPRB, 0.37092858E-03_JPRB, 0.37093656E-03_JPRB, 0.37094182E-03_JPRB, &
  & 0.37094430E-03_JPRB, 0.37094465E-03_JPRB, 0.37094246E-03_JPRB, 0.37093836E-03_JPRB, 0.37093245E-03_JPRB, 0.37092497E-03_JPRB, &
  & 0.37091612E-03_JPRB, 0.37090597E-03_JPRB, 0.37089436E-03_JPRB, 0.37088071E-03_JPRB, 0.37086391E-03_JPRB, 0.37084348E-03_JPRB, &
  & 0.37081869E-03_JPRB, 0.37078984E-03_JPRB, 0.37075745E-03_JPRB, 0.37072325E-03_JPRB, 0.37068839E-03_JPRB, 0.37065419E-03_JPRB, &
  & 0.37062165E-03_JPRB, 0.37059118E-03_JPRB, 0.37056292E-03_JPRB, 0.37053638E-03_JPRB, 0.37051077E-03_JPRB, 0.37048559E-03_JPRB, &
  & 0.37046010E-03_JPRB, 0.37043338E-03_JPRB, 0.37040468E-03_JPRB, 0.37037348E-03_JPRB, 0.37033955E-03_JPRB, 0.37030468E-03_JPRB, &
  & 0.37027133E-03_JPRB, 0.37023934E-03_JPRB, 0.37020515E-03_JPRB, 0.37014374E-03_JPRB /)

RGHG1(:,35, 2) = (/ &
  & 0.37000549E-03_JPRB, 0.37005253E-03_JPRB, 0.37008018E-03_JPRB, 0.37010526E-03_JPRB, 0.37013175E-03_JPRB, 0.37016111E-03_JPRB, &
  & 0.37019316E-03_JPRB, 0.37022660E-03_JPRB, 0.37026050E-03_JPRB, 0.37029490E-03_JPRB, 0.37033058E-03_JPRB, 0.37036915E-03_JPRB, &
  & 0.37041173E-03_JPRB, 0.37045925E-03_JPRB, 0.37051112E-03_JPRB, 0.37056569E-03_JPRB, 0.37062072E-03_JPRB, 0.37067360E-03_JPRB, &
  & 0.37072258E-03_JPRB, 0.37076682E-03_JPRB, 0.37080553E-03_JPRB, 0.37083900E-03_JPRB, 0.37086723E-03_JPRB, 0.37089086E-03_JPRB, &
  & 0.37090984E-03_JPRB, 0.37092518E-03_JPRB, 0.37093693E-03_JPRB, 0.37094604E-03_JPRB, 0.37095259E-03_JPRB, 0.37095687E-03_JPRB, &
  & 0.37095908E-03_JPRB, 0.37095961E-03_JPRB, 0.37095821E-03_JPRB, 0.37095521E-03_JPRB, 0.37095070E-03_JPRB, 0.37094468E-03_JPRB, &
  & 0.37093755E-03_JPRB, 0.37092945E-03_JPRB, 0.37091994E-03_JPRB, 0.37090830E-03_JPRB, 0.37089369E-03_JPRB, 0.37087515E-03_JPRB, &
  & 0.37085215E-03_JPRB, 0.37082459E-03_JPRB, 0.37079389E-03_JPRB, 0.37076129E-03_JPRB, 0.37072826E-03_JPRB, 0.37069627E-03_JPRB, &
  & 0.37066574E-03_JPRB, 0.37063711E-03_JPRB, 0.37061021E-03_JPRB, 0.37058484E-03_JPRB, 0.37056030E-03_JPRB, 0.37053612E-03_JPRB, &
  & 0.37051161E-03_JPRB, 0.37048620E-03_JPRB, 0.37045902E-03_JPRB, 0.37042965E-03_JPRB, 0.37039828E-03_JPRB, 0.37036664E-03_JPRB, &
  & 0.37033635E-03_JPRB, 0.37030788E-03_JPRB, 0.37027680E-03_JPRB, 0.37022264E-03_JPRB /)

RGHG1(:,36, 2) = (/ &
  & 0.37008605E-03_JPRB, 0.37013035E-03_JPRB, 0.37015558E-03_JPRB, 0.37017887E-03_JPRB, 0.37020343E-03_JPRB, 0.37023050E-03_JPRB, &
  & 0.37025978E-03_JPRB, 0.37029004E-03_JPRB, 0.37032046E-03_JPRB, 0.37035113E-03_JPRB, 0.37038297E-03_JPRB, 0.37041746E-03_JPRB, &
  & 0.37045634E-03_JPRB, 0.37050067E-03_JPRB, 0.37055020E-03_JPRB, 0.37060378E-03_JPRB, 0.37065844E-03_JPRB, 0.37071115E-03_JPRB, &
  & 0.37075955E-03_JPRB, 0.37080268E-03_JPRB, 0.37083996E-03_JPRB, 0.37087093E-03_JPRB, 0.37089596E-03_JPRB, 0.37091580E-03_JPRB, &
  & 0.37093103E-03_JPRB, 0.37094293E-03_JPRB, 0.37095181E-03_JPRB, 0.37095876E-03_JPRB, 0.37096388E-03_JPRB, 0.37096729E-03_JPRB, &
  & 0.37096921E-03_JPRB, 0.37096982E-03_JPRB, 0.37096895E-03_JPRB, 0.37096679E-03_JPRB, 0.37096342E-03_JPRB, 0.37095888E-03_JPRB, &
  & 0.37095352E-03_JPRB, 0.37094715E-03_JPRB, 0.37093947E-03_JPRB, 0.37092989E-03_JPRB, 0.37091738E-03_JPRB, 0.37090105E-03_JPRB, &
  & 0.37088004E-03_JPRB, 0.37085445E-03_JPRB, 0.37082538E-03_JPRB, 0.37079453E-03_JPRB, 0.37076339E-03_JPRB, 0.37073300E-03_JPRB, &
  & 0.37070413E-03_JPRB, 0.37067704E-03_JPRB, 0.37065128E-03_JPRB, 0.37062698E-03_JPRB, 0.37060340E-03_JPRB, 0.37058003E-03_JPRB, &
  & 0.37055649E-03_JPRB, 0.37053222E-03_JPRB, 0.37050655E-03_JPRB, 0.37047925E-03_JPRB, 0.37045046E-03_JPRB, 0.37042165E-03_JPRB, &
  & 0.37039444E-03_JPRB, 0.37036851E-03_JPRB, 0.37034060E-03_JPRB, 0.37029147E-03_JPRB /)

RGHG1(:,37, 2) = (/ &
  & 0.37016370E-03_JPRB, 0.37020486E-03_JPRB, 0.37022866E-03_JPRB, 0.37025020E-03_JPRB, 0.37027302E-03_JPRB, 0.37029793E-03_JPRB, &
  & 0.37032459E-03_JPRB, 0.37035209E-03_JPRB, 0.37037916E-03_JPRB, 0.37040614E-03_JPRB, 0.37043402E-03_JPRB, 0.37046449E-03_JPRB, &
  & 0.37049956E-03_JPRB, 0.37054054E-03_JPRB, 0.37058804E-03_JPRB, 0.37064025E-03_JPRB, 0.37069415E-03_JPRB, 0.37074639E-03_JPRB, &
  & 0.37079441E-03_JPRB, 0.37083629E-03_JPRB, 0.37087110E-03_JPRB, 0.37089898E-03_JPRB, 0.37091991E-03_JPRB, 0.37093565E-03_JPRB, &
  & 0.37094706E-03_JPRB, 0.37095576E-03_JPRB, 0.37096208E-03_JPRB, 0.37096714E-03_JPRB, 0.37097101E-03_JPRB, 0.37097375E-03_JPRB, &
  & 0.37097550E-03_JPRB, 0.37097605E-03_JPRB, 0.37097555E-03_JPRB, 0.37097392E-03_JPRB, 0.37097148E-03_JPRB, 0.37096790E-03_JPRB, &
  & 0.37096371E-03_JPRB, 0.37095853E-03_JPRB, 0.37095239E-03_JPRB, 0.37094465E-03_JPRB, 0.37093423E-03_JPRB, 0.37092032E-03_JPRB, &
  & 0.37090207E-03_JPRB, 0.37087873E-03_JPRB, 0.37085189E-03_JPRB, 0.37082279E-03_JPRB, 0.37079316E-03_JPRB, 0.37076446E-03_JPRB, &
  & 0.37073699E-03_JPRB, 0.37071097E-03_JPRB, 0.37068641E-03_JPRB, 0.37066289E-03_JPRB, 0.37064031E-03_JPRB, 0.37061796E-03_JPRB, &
  & 0.37059531E-03_JPRB, 0.37057232E-03_JPRB, 0.37054819E-03_JPRB, 0.37052282E-03_JPRB, 0.37049668E-03_JPRB, 0.37047069E-03_JPRB, &
  & 0.37044604E-03_JPRB, 0.37042258E-03_JPRB, 0.37039726E-03_JPRB, 0.37035314E-03_JPRB /)

RGHG1(:,38, 2) = (/ &
  & 0.37023838E-03_JPRB, 0.37027654E-03_JPRB, 0.37029825E-03_JPRB, 0.37031839E-03_JPRB, 0.37033964E-03_JPRB, 0.37036283E-03_JPRB, &
  & 0.37038751E-03_JPRB, 0.37041213E-03_JPRB, 0.37043612E-03_JPRB, 0.37045963E-03_JPRB, 0.37048379E-03_JPRB, 0.37051033E-03_JPRB, &
  & 0.37054121E-03_JPRB, 0.37057878E-03_JPRB, 0.37062349E-03_JPRB, 0.37067424E-03_JPRB, 0.37072710E-03_JPRB, 0.37077873E-03_JPRB, &
  & 0.37082579E-03_JPRB, 0.37086563E-03_JPRB, 0.37089729E-03_JPRB, 0.37092101E-03_JPRB, 0.37093781E-03_JPRB, 0.37094956E-03_JPRB, &
  & 0.37095789E-03_JPRB, 0.37096412E-03_JPRB, 0.37096874E-03_JPRB, 0.37097250E-03_JPRB, 0.37097550E-03_JPRB, 0.37097780E-03_JPRB, &
  & 0.37097922E-03_JPRB, 0.37097983E-03_JPRB, 0.37097963E-03_JPRB, 0.37097835E-03_JPRB, 0.37097634E-03_JPRB, 0.37097346E-03_JPRB, &
  & 0.37097008E-03_JPRB, 0.37096580E-03_JPRB, 0.37096080E-03_JPRB, 0.37095434E-03_JPRB, 0.37094558E-03_JPRB, 0.37093385E-03_JPRB, &
  & 0.37091805E-03_JPRB, 0.37089761E-03_JPRB, 0.37087320E-03_JPRB, 0.37084628E-03_JPRB, 0.37081845E-03_JPRB, 0.37079118E-03_JPRB, &
  & 0.37076481E-03_JPRB, 0.37073993E-03_JPRB, 0.37071609E-03_JPRB, 0.37069345E-03_JPRB, 0.37067159E-03_JPRB, 0.37065026E-03_JPRB, &
  & 0.37062890E-03_JPRB, 0.37060727E-03_JPRB, 0.37058495E-03_JPRB, 0.37056176E-03_JPRB, 0.37053789E-03_JPRB, 0.37051446E-03_JPRB, &
  & 0.37049214E-03_JPRB, 0.37047098E-03_JPRB, 0.37044802E-03_JPRB, 0.37040847E-03_JPRB /)

RGHG1(:,39, 2) = (/ &
  & 0.37031036E-03_JPRB, 0.37034464E-03_JPRB, 0.37036493E-03_JPRB, 0.37038358E-03_JPRB, 0.37040387E-03_JPRB, 0.37042552E-03_JPRB, &
  & 0.37044808E-03_JPRB, 0.37047011E-03_JPRB, 0.37049103E-03_JPRB, 0.37051126E-03_JPRB, 0.37053195E-03_JPRB, 0.37055445E-03_JPRB, &
  & 0.37058152E-03_JPRB, 0.37061510E-03_JPRB, 0.37065693E-03_JPRB, 0.37070559E-03_JPRB, 0.37075742E-03_JPRB, 0.37080777E-03_JPRB, &
  & 0.37085259E-03_JPRB, 0.37088947E-03_JPRB, 0.37091694E-03_JPRB, 0.37093644E-03_JPRB, 0.37094959E-03_JPRB, 0.37095847E-03_JPRB, &
  & 0.37096476E-03_JPRB, 0.37096944E-03_JPRB, 0.37097302E-03_JPRB, 0.37097605E-03_JPRB, 0.37097849E-03_JPRB, 0.37098047E-03_JPRB, &
  & 0.37098175E-03_JPRB, 0.37098239E-03_JPRB, 0.37098225E-03_JPRB, 0.37098126E-03_JPRB, 0.37097954E-03_JPRB, 0.37097713E-03_JPRB, &
  & 0.37097425E-03_JPRB, 0.37097064E-03_JPRB, 0.37096636E-03_JPRB, 0.37096083E-03_JPRB, 0.37095346E-03_JPRB, 0.37094334E-03_JPRB, &
  & 0.37092977E-03_JPRB, 0.37091182E-03_JPRB, 0.37089008E-03_JPRB, 0.37086545E-03_JPRB, 0.37083947E-03_JPRB, 0.37081365E-03_JPRB, &
  & 0.37078859E-03_JPRB, 0.37076441E-03_JPRB, 0.37074141E-03_JPRB, 0.37071932E-03_JPRB, 0.37069822E-03_JPRB, 0.37067782E-03_JPRB, &
  & 0.37065780E-03_JPRB, 0.37063801E-03_JPRB, 0.37061775E-03_JPRB, 0.37059677E-03_JPRB, 0.37057535E-03_JPRB, 0.37055410E-03_JPRB, &
  & 0.37053402E-03_JPRB, 0.37051481E-03_JPRB, 0.37049432E-03_JPRB, 0.37045858E-03_JPRB /)

RGHG1(:,40, 2) = (/ &
  & 0.37037767E-03_JPRB, 0.37040867E-03_JPRB, 0.37042698E-03_JPRB, 0.37044488E-03_JPRB, 0.37046391E-03_JPRB, 0.37048443E-03_JPRB, &
  & 0.37050509E-03_JPRB, 0.37052477E-03_JPRB, 0.37054304E-03_JPRB, 0.37056039E-03_JPRB, 0.37057782E-03_JPRB, 0.37059712E-03_JPRB, &
  & 0.37062014E-03_JPRB, 0.37064980E-03_JPRB, 0.37068804E-03_JPRB, 0.37073440E-03_JPRB, 0.37078446E-03_JPRB, 0.37083295E-03_JPRB, &
  & 0.37087500E-03_JPRB, 0.37090754E-03_JPRB, 0.37093091E-03_JPRB, 0.37094665E-03_JPRB, 0.37095725E-03_JPRB, 0.37096423E-03_JPRB, &
  & 0.37096924E-03_JPRB, 0.37097294E-03_JPRB, 0.37097593E-03_JPRB, 0.37097849E-03_JPRB, 0.37098062E-03_JPRB, 0.37098234E-03_JPRB, &
  & 0.37098365E-03_JPRB, 0.37098420E-03_JPRB, 0.37098408E-03_JPRB, 0.37098327E-03_JPRB, 0.37098172E-03_JPRB, 0.37097963E-03_JPRB, &
  & 0.37097718E-03_JPRB, 0.37097407E-03_JPRB, 0.37097035E-03_JPRB, 0.37096554E-03_JPRB, 0.37095917E-03_JPRB, 0.37095035E-03_JPRB, &
  & 0.37093851E-03_JPRB, 0.37092276E-03_JPRB, 0.37090329E-03_JPRB, 0.37088085E-03_JPRB, 0.37085693E-03_JPRB, 0.37083274E-03_JPRB, &
  & 0.37080870E-03_JPRB, 0.37078524E-03_JPRB, 0.37076278E-03_JPRB, 0.37074118E-03_JPRB, 0.37072069E-03_JPRB, 0.37070134E-03_JPRB, &
  & 0.37068280E-03_JPRB, 0.37066470E-03_JPRB, 0.37064671E-03_JPRB, 0.37062811E-03_JPRB, 0.37060911E-03_JPRB, 0.37059028E-03_JPRB, &
  & 0.37057220E-03_JPRB, 0.37055495E-03_JPRB, 0.37053620E-03_JPRB, 0.37050436E-03_JPRB /)

RGHG1(:,41, 2) = (/ &
  & 0.37043975E-03_JPRB, 0.37046749E-03_JPRB, 0.37048443E-03_JPRB, 0.37050116E-03_JPRB, 0.37051970E-03_JPRB, 0.37053917E-03_JPRB, &
  & 0.37055821E-03_JPRB, 0.37057570E-03_JPRB, 0.37059138E-03_JPRB, 0.37060611E-03_JPRB, 0.37062092E-03_JPRB, 0.37063719E-03_JPRB, &
  & 0.37065701E-03_JPRB, 0.37068306E-03_JPRB, 0.37071775E-03_JPRB, 0.37076115E-03_JPRB, 0.37080876E-03_JPRB, 0.37085466E-03_JPRB, &
  & 0.37089275E-03_JPRB, 0.37092113E-03_JPRB, 0.37094069E-03_JPRB, 0.37095370E-03_JPRB, 0.37096234E-03_JPRB, 0.37096813E-03_JPRB, &
  & 0.37097238E-03_JPRB, 0.37097553E-03_JPRB, 0.37097817E-03_JPRB, 0.37098042E-03_JPRB, 0.37098236E-03_JPRB, 0.37098397E-03_JPRB, &
  & 0.37098507E-03_JPRB, 0.37098562E-03_JPRB, 0.37098560E-03_JPRB, 0.37098478E-03_JPRB, 0.37098338E-03_JPRB, 0.37098158E-03_JPRB, &
  & 0.37097934E-03_JPRB, 0.37097663E-03_JPRB, 0.37097331E-03_JPRB, 0.37096909E-03_JPRB, 0.37096348E-03_JPRB, 0.37095571E-03_JPRB, &
  & 0.37094517E-03_JPRB, 0.37093123E-03_JPRB, 0.37091385E-03_JPRB, 0.37089363E-03_JPRB, 0.37087162E-03_JPRB, 0.37084898E-03_JPRB, &
  & 0.37082625E-03_JPRB, 0.37080361E-03_JPRB, 0.37078140E-03_JPRB, 0.37076016E-03_JPRB, 0.37074002E-03_JPRB, 0.37072165E-03_JPRB, &
  & 0.37070460E-03_JPRB, 0.37068845E-03_JPRB, 0.37067258E-03_JPRB, 0.37065649E-03_JPRB, 0.37063993E-03_JPRB, 0.37062354E-03_JPRB, &
  & 0.37060759E-03_JPRB, 0.37059205E-03_JPRB, 0.37057535E-03_JPRB, 0.37054651E-03_JPRB /)

RGHG1(:,42, 2) = (/ &
  & 0.37049624E-03_JPRB, 0.37052130E-03_JPRB, 0.37053687E-03_JPRB, 0.37055276E-03_JPRB, 0.37057069E-03_JPRB, 0.37058914E-03_JPRB, &
  & 0.37060663E-03_JPRB, 0.37062209E-03_JPRB, 0.37063577E-03_JPRB, 0.37064837E-03_JPRB, 0.37066097E-03_JPRB, 0.37067488E-03_JPRB, &
  & 0.37069188E-03_JPRB, 0.37071470E-03_JPRB, 0.37074584E-03_JPRB, 0.37078606E-03_JPRB, 0.37083094E-03_JPRB, 0.37087308E-03_JPRB, &
  & 0.37090734E-03_JPRB, 0.37093155E-03_JPRB, 0.37094799E-03_JPRB, 0.37095885E-03_JPRB, 0.37096613E-03_JPRB, 0.37097110E-03_JPRB, &
  & 0.37097474E-03_JPRB, 0.37097756E-03_JPRB, 0.37097995E-03_JPRB, 0.37098199E-03_JPRB, 0.37098379E-03_JPRB, 0.37098530E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098685E-03_JPRB, 0.37098679E-03_JPRB, 0.37098600E-03_JPRB, 0.37098478E-03_JPRB, 0.37098312E-03_JPRB, &
  & 0.37098106E-03_JPRB, 0.37097861E-03_JPRB, 0.37097570E-03_JPRB, 0.37097206E-03_JPRB, 0.37096706E-03_JPRB, 0.37096004E-03_JPRB, &
  & 0.37095082E-03_JPRB, 0.37093845E-03_JPRB, 0.37092279E-03_JPRB, 0.37090431E-03_JPRB, 0.37088426E-03_JPRB, 0.37086316E-03_JPRB, &
  & 0.37084171E-03_JPRB, 0.37081973E-03_JPRB, 0.37079796E-03_JPRB, 0.37077686E-03_JPRB, 0.37075739E-03_JPRB, 0.37073996E-03_JPRB, &
  & 0.37072436E-03_JPRB, 0.37071001E-03_JPRB, 0.37069645E-03_JPRB, 0.37068268E-03_JPRB, 0.37066868E-03_JPRB, 0.37065463E-03_JPRB, &
  & 0.37064083E-03_JPRB, 0.37062715E-03_JPRB, 0.37061196E-03_JPRB, 0.37058600E-03_JPRB /)

RGHG1(:,43, 2) = (/ &
  & 0.37054793E-03_JPRB, 0.37057057E-03_JPRB, 0.37058501E-03_JPRB, 0.37060003E-03_JPRB, 0.37061702E-03_JPRB, 0.37063449E-03_JPRB, &
  & 0.37065041E-03_JPRB, 0.37066411E-03_JPRB, 0.37067616E-03_JPRB, 0.37068711E-03_JPRB, 0.37069802E-03_JPRB, 0.37070995E-03_JPRB, &
  & 0.37072468E-03_JPRB, 0.37074450E-03_JPRB, 0.37077256E-03_JPRB, 0.37080955E-03_JPRB, 0.37085111E-03_JPRB, 0.37088944E-03_JPRB, &
  & 0.37091904E-03_JPRB, 0.37093973E-03_JPRB, 0.37095349E-03_JPRB, 0.37096266E-03_JPRB, 0.37096904E-03_JPRB, 0.37097346E-03_JPRB, &
  & 0.37097675E-03_JPRB, 0.37097928E-03_JPRB, 0.37098146E-03_JPRB, 0.37098344E-03_JPRB, 0.37098513E-03_JPRB, 0.37098659E-03_JPRB, &
  & 0.37098746E-03_JPRB, 0.37098789E-03_JPRB, 0.37098781E-03_JPRB, 0.37098711E-03_JPRB, 0.37098600E-03_JPRB, 0.37098446E-03_JPRB, &
  & 0.37098251E-03_JPRB, 0.37098030E-03_JPRB, 0.37097762E-03_JPRB, 0.37097436E-03_JPRB, 0.37096994E-03_JPRB, 0.37096374E-03_JPRB, &
  & 0.37095556E-03_JPRB, 0.37094450E-03_JPRB, 0.37093047E-03_JPRB, 0.37091388E-03_JPRB, 0.37089532E-03_JPRB, 0.37087582E-03_JPRB, &
  & 0.37085579E-03_JPRB, 0.37083492E-03_JPRB, 0.37081359E-03_JPRB, 0.37079284E-03_JPRB, 0.37077375E-03_JPRB, 0.37075754E-03_JPRB, &
  & 0.37074351E-03_JPRB, 0.37073091E-03_JPRB, 0.37071906E-03_JPRB, 0.37070748E-03_JPRB, 0.37069546E-03_JPRB, 0.37068359E-03_JPRB, &
  & 0.37067186E-03_JPRB, 0.37065998E-03_JPRB, 0.37064665E-03_JPRB, 0.37062334E-03_JPRB /)

RGHG1(:,44, 2) = (/ &
  & 0.37059491E-03_JPRB, 0.37061574E-03_JPRB, 0.37062884E-03_JPRB, 0.37064293E-03_JPRB, 0.37065917E-03_JPRB, 0.37067573E-03_JPRB, &
  & 0.37069042E-03_JPRB, 0.37070291E-03_JPRB, 0.37071347E-03_JPRB, 0.37072314E-03_JPRB, 0.37073254E-03_JPRB, 0.37074302E-03_JPRB, &
  & 0.37075579E-03_JPRB, 0.37077325E-03_JPRB, 0.37079831E-03_JPRB, 0.37083210E-03_JPRB, 0.37086976E-03_JPRB, 0.37090344E-03_JPRB, &
  & 0.37092890E-03_JPRB, 0.37094631E-03_JPRB, 0.37095795E-03_JPRB, 0.37096586E-03_JPRB, 0.37097151E-03_JPRB, 0.37097541E-03_JPRB, &
  & 0.37097844E-03_JPRB, 0.37098082E-03_JPRB, 0.37098292E-03_JPRB, 0.37098478E-03_JPRB, 0.37098644E-03_JPRB, 0.37098772E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37098888E-03_JPRB, 0.37098868E-03_JPRB, 0.37098804E-03_JPRB, 0.37098699E-03_JPRB, 0.37098554E-03_JPRB, &
  & 0.37098376E-03_JPRB, 0.37098170E-03_JPRB, 0.37097928E-03_JPRB, 0.37097628E-03_JPRB, 0.37097238E-03_JPRB, 0.37096691E-03_JPRB, &
  & 0.37095963E-03_JPRB, 0.37094989E-03_JPRB, 0.37093717E-03_JPRB, 0.37092200E-03_JPRB, 0.37090521E-03_JPRB, 0.37088731E-03_JPRB, &
  & 0.37086860E-03_JPRB, 0.37084887E-03_JPRB, 0.37082852E-03_JPRB, 0.37080841E-03_JPRB, 0.37079043E-03_JPRB, 0.37077526E-03_JPRB, &
  & 0.37076266E-03_JPRB, 0.37075172E-03_JPRB, 0.37074156E-03_JPRB, 0.37073166E-03_JPRB, 0.37072162E-03_JPRB, 0.37071158E-03_JPRB, &
  & 0.37070169E-03_JPRB, 0.37069150E-03_JPRB, 0.37067983E-03_JPRB, 0.37065905E-03_JPRB /)

RGHG1(:,45, 2) = (/ &
  & 0.37063856E-03_JPRB, 0.37065719E-03_JPRB, 0.37066982E-03_JPRB, 0.37068262E-03_JPRB, 0.37069788E-03_JPRB, 0.37071336E-03_JPRB, &
  & 0.37072744E-03_JPRB, 0.37073880E-03_JPRB, 0.37074863E-03_JPRB, 0.37075722E-03_JPRB, 0.37076557E-03_JPRB, 0.37077471E-03_JPRB, &
  & 0.37078571E-03_JPRB, 0.37080114E-03_JPRB, 0.37082323E-03_JPRB, 0.37085341E-03_JPRB, 0.37088685E-03_JPRB, 0.37091575E-03_JPRB, &
  & 0.37093702E-03_JPRB, 0.37095154E-03_JPRB, 0.37096141E-03_JPRB, 0.37096837E-03_JPRB, 0.37097337E-03_JPRB, 0.37097704E-03_JPRB, &
  & 0.37097986E-03_JPRB, 0.37098219E-03_JPRB, 0.37098420E-03_JPRB, 0.37098606E-03_JPRB, 0.37098763E-03_JPRB, 0.37098877E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098982E-03_JPRB, 0.37098955E-03_JPRB, 0.37098888E-03_JPRB, 0.37098787E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098484E-03_JPRB, 0.37098292E-03_JPRB, 0.37098068E-03_JPRB, 0.37097794E-03_JPRB, 0.37097439E-03_JPRB, 0.37096959E-03_JPRB, &
  & 0.37096319E-03_JPRB, 0.37095457E-03_JPRB, 0.37094328E-03_JPRB, 0.37092963E-03_JPRB, 0.37091438E-03_JPRB, 0.37089808E-03_JPRB, &
  & 0.37088082E-03_JPRB, 0.37086249E-03_JPRB, 0.37084316E-03_JPRB, 0.37082442E-03_JPRB, 0.37080760E-03_JPRB, 0.37079389E-03_JPRB, &
  & 0.37078274E-03_JPRB, 0.37077317E-03_JPRB, 0.37076444E-03_JPRB, 0.37075605E-03_JPRB, 0.37074767E-03_JPRB, 0.37073920E-03_JPRB, &
  & 0.37073085E-03_JPRB, 0.37072218E-03_JPRB, 0.37071202E-03_JPRB, 0.37069360E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART4',0,ZHOOK_HANDLE)



RGHG1(:,46, 2) = (/ &
  & 0.37067875E-03_JPRB, 0.37069662E-03_JPRB, 0.37070760E-03_JPRB, 0.37072011E-03_JPRB, 0.37073414E-03_JPRB, 0.37074907E-03_JPRB, &
  & 0.37076231E-03_JPRB, 0.37077337E-03_JPRB, 0.37078239E-03_JPRB, 0.37079022E-03_JPRB, 0.37079764E-03_JPRB, 0.37080544E-03_JPRB, &
  & 0.37081511E-03_JPRB, 0.37082809E-03_JPRB, 0.37084761E-03_JPRB, 0.37087363E-03_JPRB, 0.37090227E-03_JPRB, 0.37092628E-03_JPRB, &
  & 0.37094369E-03_JPRB, 0.37095579E-03_JPRB, 0.37096435E-03_JPRB, 0.37097052E-03_JPRB, 0.37097509E-03_JPRB, 0.37097847E-03_JPRB, &
  & 0.37098111E-03_JPRB, 0.37098338E-03_JPRB, 0.37098536E-03_JPRB, 0.37098717E-03_JPRB, 0.37098880E-03_JPRB, 0.37098982E-03_JPRB, &
  & 0.37099043E-03_JPRB, 0.37099063E-03_JPRB, 0.37099034E-03_JPRB, 0.37098976E-03_JPRB, 0.37098874E-03_JPRB, 0.37098740E-03_JPRB, &
  & 0.37098583E-03_JPRB, 0.37098402E-03_JPRB, 0.37098184E-03_JPRB, 0.37097937E-03_JPRB, 0.37097622E-03_JPRB, 0.37097192E-03_JPRB, &
  & 0.37096633E-03_JPRB, 0.37095876E-03_JPRB, 0.37094884E-03_JPRB, 0.37093670E-03_JPRB, 0.37092308E-03_JPRB, 0.37090830E-03_JPRB, &
  & 0.37089278E-03_JPRB, 0.37087593E-03_JPRB, 0.37085830E-03_JPRB, 0.37084080E-03_JPRB, 0.37082599E-03_JPRB, 0.37081371E-03_JPRB, &
  & 0.37080410E-03_JPRB, 0.37079584E-03_JPRB, 0.37078833E-03_JPRB, 0.37078117E-03_JPRB, 0.37077401E-03_JPRB, 0.37076697E-03_JPRB, &
  & 0.37076001E-03_JPRB, 0.37075268E-03_JPRB, 0.37074383E-03_JPRB, 0.37072768E-03_JPRB /)

RGHG1(:,47, 2) = (/ &
  & 0.37071737E-03_JPRB, 0.37073344E-03_JPRB, 0.37074432E-03_JPRB, 0.37075553E-03_JPRB, 0.37076898E-03_JPRB, 0.37078327E-03_JPRB, &
  & 0.37079628E-03_JPRB, 0.37080678E-03_JPRB, 0.37081528E-03_JPRB, 0.37082244E-03_JPRB, 0.37082887E-03_JPRB, 0.37083565E-03_JPRB, &
  & 0.37084345E-03_JPRB, 0.37085474E-03_JPRB, 0.37087032E-03_JPRB, 0.37089243E-03_JPRB, 0.37091563E-03_JPRB, 0.37093504E-03_JPRB, &
  & 0.37094922E-03_JPRB, 0.37095934E-03_JPRB, 0.37096662E-03_JPRB, 0.37097218E-03_JPRB, 0.37097637E-03_JPRB, 0.37097972E-03_JPRB, &
  & 0.37098231E-03_JPRB, 0.37098455E-03_JPRB, 0.37098653E-03_JPRB, 0.37098827E-03_JPRB, 0.37098982E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099127E-03_JPRB, 0.37099136E-03_JPRB, 0.37099104E-03_JPRB, 0.37099031E-03_JPRB, 0.37098935E-03_JPRB, 0.37098801E-03_JPRB, &
  & 0.37098656E-03_JPRB, 0.37098490E-03_JPRB, 0.37098292E-03_JPRB, 0.37098059E-03_JPRB, 0.37097774E-03_JPRB, 0.37097392E-03_JPRB, &
  & 0.37096904E-03_JPRB, 0.37096263E-03_JPRB, 0.37095411E-03_JPRB, 0.37094374E-03_JPRB, 0.37093187E-03_JPRB, 0.37091892E-03_JPRB, &
  & 0.37090501E-03_JPRB, 0.37088993E-03_JPRB, 0.37087390E-03_JPRB, 0.37085862E-03_JPRB, 0.37084497E-03_JPRB, 0.37083472E-03_JPRB, &
  & 0.37082628E-03_JPRB, 0.37081924E-03_JPRB, 0.37081278E-03_JPRB, 0.37080661E-03_JPRB, 0.37080055E-03_JPRB, 0.37079467E-03_JPRB, &
  & 0.37078885E-03_JPRB, 0.37078265E-03_JPRB, 0.37077517E-03_JPRB, 0.37076115E-03_JPRB /)

RGHG1(:,48, 2) = (/ &
  & 0.37075364E-03_JPRB, 0.37076898E-03_JPRB, 0.37077881E-03_JPRB, 0.37078955E-03_JPRB, 0.37080233E-03_JPRB, 0.37081615E-03_JPRB, &
  & 0.37082887E-03_JPRB, 0.37083917E-03_JPRB, 0.37084718E-03_JPRB, 0.37085341E-03_JPRB, 0.37085891E-03_JPRB, 0.37086441E-03_JPRB, &
  & 0.37087107E-03_JPRB, 0.37087972E-03_JPRB, 0.37089264E-03_JPRB, 0.37090914E-03_JPRB, 0.37092739E-03_JPRB, 0.37094241E-03_JPRB, &
  & 0.37095364E-03_JPRB, 0.37096205E-03_JPRB, 0.37096848E-03_JPRB, 0.37097352E-03_JPRB, 0.37097756E-03_JPRB, 0.37098076E-03_JPRB, &
  & 0.37098333E-03_JPRB, 0.37098551E-03_JPRB, 0.37098752E-03_JPRB, 0.37098929E-03_JPRB, 0.37099072E-03_JPRB, 0.37099150E-03_JPRB, &
  & 0.37099209E-03_JPRB, 0.37099209E-03_JPRB, 0.37099165E-03_JPRB, 0.37099089E-03_JPRB, 0.37098990E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098560E-03_JPRB, 0.37098370E-03_JPRB, 0.37098164E-03_JPRB, 0.37097899E-03_JPRB, 0.37097553E-03_JPRB, &
  & 0.37097131E-03_JPRB, 0.37096586E-03_JPRB, 0.37095899E-03_JPRB, 0.37095061E-03_JPRB, 0.37094101E-03_JPRB, 0.37093024E-03_JPRB, &
  & 0.37091825E-03_JPRB, 0.37090504E-03_JPRB, 0.37089104E-03_JPRB, 0.37087727E-03_JPRB, 0.37086589E-03_JPRB, 0.37085678E-03_JPRB, &
  & 0.37084977E-03_JPRB, 0.37084369E-03_JPRB, 0.37083813E-03_JPRB, 0.37083280E-03_JPRB, 0.37082762E-03_JPRB, 0.37082261E-03_JPRB, &
  & 0.37081767E-03_JPRB, 0.37081240E-03_JPRB, 0.37080608E-03_JPRB, 0.37079403E-03_JPRB /)

RGHG1(:,49, 2) = (/ &
  & 0.37078801E-03_JPRB, 0.37080247E-03_JPRB, 0.37081196E-03_JPRB, 0.37082224E-03_JPRB, 0.37083466E-03_JPRB, 0.37084828E-03_JPRB, &
  & 0.37086068E-03_JPRB, 0.37087052E-03_JPRB, 0.37087768E-03_JPRB, 0.37088315E-03_JPRB, 0.37088772E-03_JPRB, 0.37089223E-03_JPRB, &
  & 0.37089715E-03_JPRB, 0.37090370E-03_JPRB, 0.37091243E-03_JPRB, 0.37092419E-03_JPRB, 0.37093699E-03_JPRB, 0.37094834E-03_JPRB, &
  & 0.37095728E-03_JPRB, 0.37096420E-03_JPRB, 0.37096991E-03_JPRB, 0.37097459E-03_JPRB, 0.37097849E-03_JPRB, 0.37098170E-03_JPRB, &
  & 0.37098434E-03_JPRB, 0.37098659E-03_JPRB, 0.37098859E-03_JPRB, 0.37099025E-03_JPRB, 0.37099159E-03_JPRB, 0.37099226E-03_JPRB, &
  & 0.37099273E-03_JPRB, 0.37099270E-03_JPRB, 0.37099226E-03_JPRB, 0.37099142E-03_JPRB, 0.37099040E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098626E-03_JPRB, 0.37098443E-03_JPRB, 0.37098248E-03_JPRB, 0.37098009E-03_JPRB, 0.37097704E-03_JPRB, &
  & 0.37097340E-03_JPRB, 0.37096892E-03_JPRB, 0.37096356E-03_JPRB, 0.37095734E-03_JPRB, 0.37095021E-03_JPRB, 0.37094211E-03_JPRB, &
  & 0.37093254E-03_JPRB, 0.37092171E-03_JPRB, 0.37090966E-03_JPRB, 0.37089802E-03_JPRB, 0.37088827E-03_JPRB, 0.37088065E-03_JPRB, &
  & 0.37087465E-03_JPRB, 0.37086956E-03_JPRB, 0.37086479E-03_JPRB, 0.37086016E-03_JPRB, 0.37085556E-03_JPRB, 0.37085119E-03_JPRB, &
  & 0.37084692E-03_JPRB, 0.37084238E-03_JPRB, 0.37083679E-03_JPRB, 0.37082616E-03_JPRB /)

RGHG1(:,50, 2) = (/ &
  & 0.37082081E-03_JPRB, 0.37083458E-03_JPRB, 0.37084354E-03_JPRB, 0.37085346E-03_JPRB, 0.37086575E-03_JPRB, 0.37087925E-03_JPRB, &
  & 0.37089118E-03_JPRB, 0.37090018E-03_JPRB, 0.37090626E-03_JPRB, 0.37091062E-03_JPRB, 0.37091397E-03_JPRB, 0.37091706E-03_JPRB, &
  & 0.37092023E-03_JPRB, 0.37092419E-03_JPRB, 0.37092919E-03_JPRB, 0.37093653E-03_JPRB, 0.37094500E-03_JPRB, 0.37095323E-03_JPRB, &
  & 0.37096022E-03_JPRB, 0.37096604E-03_JPRB, 0.37097125E-03_JPRB, 0.37097564E-03_JPRB, 0.37097948E-03_JPRB, 0.37098266E-03_JPRB, &
  & 0.37098536E-03_JPRB, 0.37098763E-03_JPRB, 0.37098967E-03_JPRB, 0.37099118E-03_JPRB, 0.37099246E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099337E-03_JPRB, 0.37099328E-03_JPRB, 0.37099276E-03_JPRB, 0.37099188E-03_JPRB, 0.37099086E-03_JPRB, 0.37098961E-03_JPRB, &
  & 0.37098830E-03_JPRB, 0.37098691E-03_JPRB, 0.37098510E-03_JPRB, 0.37098324E-03_JPRB, 0.37098100E-03_JPRB, 0.37097817E-03_JPRB, &
  & 0.37097509E-03_JPRB, 0.37097154E-03_JPRB, 0.37096755E-03_JPRB, 0.37096333E-03_JPRB, 0.37095879E-03_JPRB, 0.37095358E-03_JPRB, &
  & 0.37094700E-03_JPRB, 0.37093894E-03_JPRB, 0.37092972E-03_JPRB, 0.37092069E-03_JPRB, 0.37091266E-03_JPRB, 0.37090678E-03_JPRB, &
  & 0.37090169E-03_JPRB, 0.37089735E-03_JPRB, 0.37089319E-03_JPRB, 0.37088903E-03_JPRB, 0.37088495E-03_JPRB, 0.37088100E-03_JPRB, &
  & 0.37087710E-03_JPRB, 0.37087285E-03_JPRB, 0.37086770E-03_JPRB, 0.37085809E-03_JPRB /)

RGHG1(:,51, 2) = (/ &
  & 0.37085157E-03_JPRB, 0.37086423E-03_JPRB, 0.37087320E-03_JPRB, 0.37088271E-03_JPRB, 0.37089502E-03_JPRB, 0.37090803E-03_JPRB, &
  & 0.37091918E-03_JPRB, 0.37092628E-03_JPRB, 0.37093073E-03_JPRB, 0.37093350E-03_JPRB, 0.37093536E-03_JPRB, 0.37093688E-03_JPRB, &
  & 0.37093842E-03_JPRB, 0.37094002E-03_JPRB, 0.37094258E-03_JPRB, 0.37094613E-03_JPRB, 0.37095154E-03_JPRB, 0.37095719E-03_JPRB, &
  & 0.37096272E-03_JPRB, 0.37096764E-03_JPRB, 0.37097221E-03_JPRB, 0.37097646E-03_JPRB, 0.37098024E-03_JPRB, 0.37098353E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098871E-03_JPRB, 0.37099060E-03_JPRB, 0.37099211E-03_JPRB, 0.37099322E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099395E-03_JPRB, 0.37099380E-03_JPRB, 0.37099325E-03_JPRB, 0.37099238E-03_JPRB, 0.37099124E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37098734E-03_JPRB, 0.37098560E-03_JPRB, 0.37098391E-03_JPRB, 0.37098175E-03_JPRB, 0.37097922E-03_JPRB, &
  & 0.37097660E-03_JPRB, 0.37097378E-03_JPRB, 0.37097113E-03_JPRB, 0.37096848E-03_JPRB, 0.37096607E-03_JPRB, 0.37096321E-03_JPRB, &
  & 0.37095949E-03_JPRB, 0.37095457E-03_JPRB, 0.37094884E-03_JPRB, 0.37094270E-03_JPRB, 0.37093757E-03_JPRB, 0.37093309E-03_JPRB, &
  & 0.37092954E-03_JPRB, 0.37092617E-03_JPRB, 0.37092273E-03_JPRB, 0.37091912E-03_JPRB, 0.37091540E-03_JPRB, 0.37091167E-03_JPRB, &
  & 0.37090792E-03_JPRB, 0.37090402E-03_JPRB, 0.37089916E-03_JPRB, 0.37089005E-03_JPRB /)

RGHG1(:,52, 2) = (/ &
  & 0.37087899E-03_JPRB, 0.37089168E-03_JPRB, 0.37089922E-03_JPRB, 0.37090908E-03_JPRB, 0.37092029E-03_JPRB, 0.37093239E-03_JPRB, &
  & 0.37094057E-03_JPRB, 0.37094517E-03_JPRB, 0.37094753E-03_JPRB, 0.37094892E-03_JPRB, 0.37094971E-03_JPRB, 0.37095023E-03_JPRB, &
  & 0.37095061E-03_JPRB, 0.37095114E-03_JPRB, 0.37095178E-03_JPRB, 0.37095364E-03_JPRB, 0.37095649E-03_JPRB, 0.37096048E-03_JPRB, &
  & 0.37096476E-03_JPRB, 0.37096906E-03_JPRB, 0.37097331E-03_JPRB, 0.37097739E-03_JPRB, 0.37098117E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098973E-03_JPRB, 0.37099159E-03_JPRB, 0.37099290E-03_JPRB, 0.37099383E-03_JPRB, 0.37099421E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099424E-03_JPRB, 0.37099366E-03_JPRB, 0.37099276E-03_JPRB, 0.37099162E-03_JPRB, 0.37099040E-03_JPRB, &
  & 0.37098912E-03_JPRB, 0.37098784E-03_JPRB, 0.37098618E-03_JPRB, 0.37098443E-03_JPRB, 0.37098242E-03_JPRB, 0.37098015E-03_JPRB, &
  & 0.37097788E-03_JPRB, 0.37097579E-03_JPRB, 0.37097410E-03_JPRB, 0.37097279E-03_JPRB, 0.37097165E-03_JPRB, 0.37097043E-03_JPRB, &
  & 0.37096851E-03_JPRB, 0.37096607E-03_JPRB, 0.37096298E-03_JPRB, 0.37095981E-03_JPRB, 0.37095684E-03_JPRB, 0.37095443E-03_JPRB, &
  & 0.37095207E-03_JPRB, 0.37094991E-03_JPRB, 0.37094759E-03_JPRB, 0.37094491E-03_JPRB, 0.37094203E-03_JPRB, 0.37093909E-03_JPRB, &
  & 0.37093603E-03_JPRB, 0.37093274E-03_JPRB, 0.37092844E-03_JPRB, 0.37092023E-03_JPRB /)

RGHG1(:,53, 2) = (/ &
  & 0.37090370E-03_JPRB, 0.37091417E-03_JPRB, 0.37092256E-03_JPRB, 0.37093039E-03_JPRB, 0.37094048E-03_JPRB, 0.37094892E-03_JPRB, &
  & 0.37095411E-03_JPRB, 0.37095643E-03_JPRB, 0.37095760E-03_JPRB, 0.37095815E-03_JPRB, 0.37095841E-03_JPRB, 0.37095853E-03_JPRB, &
  & 0.37095853E-03_JPRB, 0.37095847E-03_JPRB, 0.37095847E-03_JPRB, 0.37095894E-03_JPRB, 0.37096057E-03_JPRB, 0.37096324E-03_JPRB, &
  & 0.37096668E-03_JPRB, 0.37097040E-03_JPRB, 0.37097430E-03_JPRB, 0.37097820E-03_JPRB, 0.37098196E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37099051E-03_JPRB, 0.37099232E-03_JPRB, 0.37099357E-03_JPRB, 0.37099450E-03_JPRB, 0.37099482E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099465E-03_JPRB, 0.37099404E-03_JPRB, 0.37099310E-03_JPRB, 0.37099197E-03_JPRB, 0.37099075E-03_JPRB, &
  & 0.37098950E-03_JPRB, 0.37098821E-03_JPRB, 0.37098661E-03_JPRB, 0.37098496E-03_JPRB, 0.37098306E-03_JPRB, 0.37098106E-03_JPRB, &
  & 0.37097913E-03_JPRB, 0.37097750E-03_JPRB, 0.37097657E-03_JPRB, 0.37097602E-03_JPRB, 0.37097564E-03_JPRB, 0.37097515E-03_JPRB, &
  & 0.37097430E-03_JPRB, 0.37097311E-03_JPRB, 0.37097163E-03_JPRB, 0.37097002E-03_JPRB, 0.37096854E-03_JPRB, 0.37096723E-03_JPRB, &
  & 0.37096610E-03_JPRB, 0.37096487E-03_JPRB, 0.37096353E-03_JPRB, 0.37096196E-03_JPRB, 0.37096010E-03_JPRB, 0.37095824E-03_JPRB, &
  & 0.37095626E-03_JPRB, 0.37095396E-03_JPRB, 0.37095099E-03_JPRB, 0.37094488E-03_JPRB /)

RGHG1(:,54, 2) = (/ &
  & 0.37092317E-03_JPRB, 0.37093397E-03_JPRB, 0.37093987E-03_JPRB, 0.37094718E-03_JPRB, 0.37095387E-03_JPRB, 0.37095943E-03_JPRB, &
  & 0.37096193E-03_JPRB, 0.37096304E-03_JPRB, 0.37096348E-03_JPRB, 0.37096362E-03_JPRB, 0.37096365E-03_JPRB, 0.37096362E-03_JPRB, &
  & 0.37096353E-03_JPRB, 0.37096327E-03_JPRB, 0.37096316E-03_JPRB, 0.37096313E-03_JPRB, 0.37096383E-03_JPRB, 0.37096569E-03_JPRB, &
  & 0.37096840E-03_JPRB, 0.37097171E-03_JPRB, 0.37097541E-03_JPRB, 0.37097916E-03_JPRB, 0.37098286E-03_JPRB, 0.37098618E-03_JPRB, &
  & 0.37098906E-03_JPRB, 0.37099139E-03_JPRB, 0.37099319E-03_JPRB, 0.37099427E-03_JPRB, 0.37099503E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099555E-03_JPRB, 0.37099497E-03_JPRB, 0.37099438E-03_JPRB, 0.37099342E-03_JPRB, 0.37099229E-03_JPRB, 0.37099110E-03_JPRB, &
  & 0.37098982E-03_JPRB, 0.37098851E-03_JPRB, 0.37098705E-03_JPRB, 0.37098536E-03_JPRB, 0.37098362E-03_JPRB, 0.37098187E-03_JPRB, &
  & 0.37098027E-03_JPRB, 0.37097919E-03_JPRB, 0.37097879E-03_JPRB, 0.37097867E-03_JPRB, 0.37097861E-03_JPRB, 0.37097849E-03_JPRB, &
  & 0.37097809E-03_JPRB, 0.37097745E-03_JPRB, 0.37097663E-03_JPRB, 0.37097582E-03_JPRB, 0.37097500E-03_JPRB, 0.37097439E-03_JPRB, &
  & 0.37097378E-03_JPRB, 0.37097311E-03_JPRB, 0.37097232E-03_JPRB, 0.37097133E-03_JPRB, 0.37097032E-03_JPRB, 0.37096918E-03_JPRB, &
  & 0.37096808E-03_JPRB, 0.37096691E-03_JPRB, 0.37096540E-03_JPRB, 0.37096263E-03_JPRB /)

RGHG1(:,55, 2) = (/ &
  & 0.37093984E-03_JPRB, 0.37094788E-03_JPRB, 0.37095364E-03_JPRB, 0.37095818E-03_JPRB, 0.37096266E-03_JPRB, 0.37096557E-03_JPRB, &
  & 0.37096685E-03_JPRB, 0.37096726E-03_JPRB, 0.37096738E-03_JPRB, 0.37096738E-03_JPRB, 0.37096735E-03_JPRB, 0.37096726E-03_JPRB, &
  & 0.37096720E-03_JPRB, 0.37096703E-03_JPRB, 0.37096674E-03_JPRB, 0.37096650E-03_JPRB, 0.37096668E-03_JPRB, 0.37096784E-03_JPRB, &
  & 0.37097011E-03_JPRB, 0.37097302E-03_JPRB, 0.37097654E-03_JPRB, 0.37098007E-03_JPRB, 0.37098376E-03_JPRB, 0.37098702E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37099211E-03_JPRB, 0.37099386E-03_JPRB, 0.37099488E-03_JPRB, 0.37099561E-03_JPRB, 0.37099593E-03_JPRB, &
  & 0.37099604E-03_JPRB, 0.37099540E-03_JPRB, 0.37099476E-03_JPRB, 0.37099366E-03_JPRB, 0.37099255E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098883E-03_JPRB, 0.37098740E-03_JPRB, 0.37098586E-03_JPRB, 0.37098431E-03_JPRB, 0.37098283E-03_JPRB, &
  & 0.37098143E-03_JPRB, 0.37098071E-03_JPRB, 0.37098068E-03_JPRB, 0.37098076E-03_JPRB, 0.37098094E-03_JPRB, 0.37098097E-03_JPRB, &
  & 0.37098082E-03_JPRB, 0.37098042E-03_JPRB, 0.37097998E-03_JPRB, 0.37097948E-03_JPRB, 0.37097902E-03_JPRB, 0.37097858E-03_JPRB, &
  & 0.37097814E-03_JPRB, 0.37097774E-03_JPRB, 0.37097724E-03_JPRB, 0.37097669E-03_JPRB, 0.37097605E-03_JPRB, 0.37097544E-03_JPRB, &
  & 0.37097477E-03_JPRB, 0.37097401E-03_JPRB, 0.37097305E-03_JPRB, 0.37097107E-03_JPRB /)

RGHG1(:,56, 2) = (/ &
  & 0.37095184E-03_JPRB, 0.37095905E-03_JPRB, 0.37096246E-03_JPRB, 0.37096557E-03_JPRB, 0.37096808E-03_JPRB, 0.37096965E-03_JPRB, &
  & 0.37097026E-03_JPRB, 0.37097049E-03_JPRB, 0.37097052E-03_JPRB, 0.37097046E-03_JPRB, 0.37097037E-03_JPRB, 0.37097026E-03_JPRB, &
  & 0.37097014E-03_JPRB, 0.37096988E-03_JPRB, 0.37096962E-03_JPRB, 0.37096927E-03_JPRB, 0.37096918E-03_JPRB, 0.37096991E-03_JPRB, &
  & 0.37097174E-03_JPRB, 0.37097436E-03_JPRB, 0.37097756E-03_JPRB, 0.37098108E-03_JPRB, 0.37098461E-03_JPRB, 0.37098778E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099281E-03_JPRB, 0.37099441E-03_JPRB, 0.37099552E-03_JPRB, 0.37099616E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099581E-03_JPRB, 0.37099503E-03_JPRB, 0.37099401E-03_JPRB, 0.37099290E-03_JPRB, 0.37099174E-03_JPRB, &
  & 0.37099046E-03_JPRB, 0.37098920E-03_JPRB, 0.37098781E-03_JPRB, 0.37098635E-03_JPRB, 0.37098490E-03_JPRB, 0.37098362E-03_JPRB, &
  & 0.37098257E-03_JPRB, 0.37098204E-03_JPRB, 0.37098231E-03_JPRB, 0.37098251E-03_JPRB, 0.37098277E-03_JPRB, 0.37098289E-03_JPRB, &
  & 0.37098280E-03_JPRB, 0.37098251E-03_JPRB, 0.37098222E-03_JPRB, 0.37098187E-03_JPRB, 0.37098155E-03_JPRB, 0.37098135E-03_JPRB, &
  & 0.37098111E-03_JPRB, 0.37098085E-03_JPRB, 0.37098053E-03_JPRB, 0.37098012E-03_JPRB, 0.37097966E-03_JPRB, 0.37097919E-03_JPRB, &
  & 0.37097879E-03_JPRB, 0.37097832E-03_JPRB, 0.37097785E-03_JPRB, 0.37097716E-03_JPRB /)

RGHG1(:,57, 2) = (/ &
  & 0.37096126E-03_JPRB, 0.37096621E-03_JPRB, 0.37096863E-03_JPRB, 0.37097046E-03_JPRB, 0.37097174E-03_JPRB, 0.37097250E-03_JPRB, &
  & 0.37097282E-03_JPRB, 0.37097288E-03_JPRB, 0.37097285E-03_JPRB, 0.37097276E-03_JPRB, 0.37097267E-03_JPRB, 0.37097259E-03_JPRB, &
  & 0.37097250E-03_JPRB, 0.37097232E-03_JPRB, 0.37097209E-03_JPRB, 0.37097180E-03_JPRB, 0.37097142E-03_JPRB, 0.37097186E-03_JPRB, &
  & 0.37097331E-03_JPRB, 0.37097564E-03_JPRB, 0.37097873E-03_JPRB, 0.37098207E-03_JPRB, 0.37098545E-03_JPRB, 0.37098851E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099340E-03_JPRB, 0.37099508E-03_JPRB, 0.37099604E-03_JPRB, 0.37099660E-03_JPRB, 0.37099686E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099607E-03_JPRB, 0.37099532E-03_JPRB, 0.37099430E-03_JPRB, 0.37099322E-03_JPRB, 0.37099203E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37098950E-03_JPRB, 0.37098819E-03_JPRB, 0.37098682E-03_JPRB, 0.37098554E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098359E-03_JPRB, 0.37098327E-03_JPRB, 0.37098365E-03_JPRB, 0.37098399E-03_JPRB, 0.37098431E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098437E-03_JPRB, 0.37098420E-03_JPRB, 0.37098394E-03_JPRB, 0.37098370E-03_JPRB, 0.37098350E-03_JPRB, 0.37098330E-03_JPRB, &
  & 0.37098309E-03_JPRB, 0.37098289E-03_JPRB, 0.37098263E-03_JPRB, 0.37098239E-03_JPRB, 0.37098210E-03_JPRB, 0.37098181E-03_JPRB, &
  & 0.37098149E-03_JPRB, 0.37098111E-03_JPRB, 0.37098079E-03_JPRB, 0.37098015E-03_JPRB /)

RGHG1(:,58, 2) = (/ &
  & 0.37096784E-03_JPRB, 0.37097133E-03_JPRB, 0.37097279E-03_JPRB, 0.37097375E-03_JPRB, 0.37097442E-03_JPRB, 0.37097471E-03_JPRB, &
  & 0.37097483E-03_JPRB, 0.37097477E-03_JPRB, 0.37097471E-03_JPRB, 0.37097468E-03_JPRB, 0.37097462E-03_JPRB, 0.37097457E-03_JPRB, &
  & 0.37097454E-03_JPRB, 0.37097448E-03_JPRB, 0.37097430E-03_JPRB, 0.37097395E-03_JPRB, 0.37097355E-03_JPRB, 0.37097372E-03_JPRB, &
  & 0.37097491E-03_JPRB, 0.37097710E-03_JPRB, 0.37097986E-03_JPRB, 0.37098318E-03_JPRB, 0.37098632E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37099185E-03_JPRB, 0.37099398E-03_JPRB, 0.37099558E-03_JPRB, 0.37099654E-03_JPRB, 0.37099706E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099648E-03_JPRB, 0.37099564E-03_JPRB, 0.37099462E-03_JPRB, 0.37099351E-03_JPRB, 0.37099235E-03_JPRB, &
  & 0.37099115E-03_JPRB, 0.37098984E-03_JPRB, 0.37098862E-03_JPRB, 0.37098737E-03_JPRB, 0.37098629E-03_JPRB, 0.37098525E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098449E-03_JPRB, 0.37098487E-03_JPRB, 0.37098530E-03_JPRB, 0.37098562E-03_JPRB, 0.37098571E-03_JPRB, &
  & 0.37098565E-03_JPRB, 0.37098548E-03_JPRB, 0.37098522E-03_JPRB, 0.37098501E-03_JPRB, 0.37098484E-03_JPRB, 0.37098472E-03_JPRB, &
  & 0.37098464E-03_JPRB, 0.37098449E-03_JPRB, 0.37098431E-03_JPRB, 0.37098414E-03_JPRB, 0.37098388E-03_JPRB, 0.37098362E-03_JPRB, &
  & 0.37098335E-03_JPRB, 0.37098312E-03_JPRB, 0.37098280E-03_JPRB, 0.37098239E-03_JPRB /)

RGHG1(:,59, 2) = (/ &
  & 0.37097279E-03_JPRB, 0.37097500E-03_JPRB, 0.37097582E-03_JPRB, 0.37097628E-03_JPRB, 0.37097657E-03_JPRB, 0.37097669E-03_JPRB, &
  & 0.37097675E-03_JPRB, 0.37097669E-03_JPRB, 0.37097663E-03_JPRB, 0.37097660E-03_JPRB, 0.37097657E-03_JPRB, 0.37097652E-03_JPRB, &
  & 0.37097643E-03_JPRB, 0.37097634E-03_JPRB, 0.37097617E-03_JPRB, 0.37097587E-03_JPRB, 0.37097547E-03_JPRB, 0.37097555E-03_JPRB, &
  & 0.37097649E-03_JPRB, 0.37097847E-03_JPRB, 0.37098108E-03_JPRB, 0.37098417E-03_JPRB, 0.37098717E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37099249E-03_JPRB, 0.37099456E-03_JPRB, 0.37099610E-03_JPRB, 0.37099703E-03_JPRB, 0.37099753E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099680E-03_JPRB, 0.37099599E-03_JPRB, 0.37099488E-03_JPRB, 0.37099374E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099147E-03_JPRB, 0.37099025E-03_JPRB, 0.37098903E-03_JPRB, 0.37098787E-03_JPRB, 0.37098693E-03_JPRB, 0.37098612E-03_JPRB, &
  & 0.37098565E-03_JPRB, 0.37098568E-03_JPRB, 0.37098606E-03_JPRB, 0.37098653E-03_JPRB, 0.37098688E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098679E-03_JPRB, 0.37098664E-03_JPRB, 0.37098647E-03_JPRB, 0.37098624E-03_JPRB, 0.37098603E-03_JPRB, 0.37098586E-03_JPRB, &
  & 0.37098580E-03_JPRB, 0.37098571E-03_JPRB, 0.37098554E-03_JPRB, 0.37098539E-03_JPRB, 0.37098519E-03_JPRB, 0.37098498E-03_JPRB, &
  & 0.37098481E-03_JPRB, 0.37098461E-03_JPRB, 0.37098437E-03_JPRB, 0.37098394E-03_JPRB /)

RGHG1(:,60, 2) = (/ &
  & 0.37097716E-03_JPRB, 0.37097780E-03_JPRB, 0.37097806E-03_JPRB, 0.37097826E-03_JPRB, 0.37097838E-03_JPRB, 0.37097832E-03_JPRB, &
  & 0.37097826E-03_JPRB, 0.37097820E-03_JPRB, 0.37097814E-03_JPRB, 0.37097812E-03_JPRB, 0.37097814E-03_JPRB, 0.37097820E-03_JPRB, &
  & 0.37097817E-03_JPRB, 0.37097812E-03_JPRB, 0.37097791E-03_JPRB, 0.37097759E-03_JPRB, 0.37097718E-03_JPRB, 0.37097730E-03_JPRB, &
  & 0.37097809E-03_JPRB, 0.37097995E-03_JPRB, 0.37098242E-03_JPRB, 0.37098519E-03_JPRB, 0.37098810E-03_JPRB, 0.37099086E-03_JPRB, &
  & 0.37099325E-03_JPRB, 0.37099514E-03_JPRB, 0.37099665E-03_JPRB, 0.37099747E-03_JPRB, 0.37099794E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099709E-03_JPRB, 0.37099636E-03_JPRB, 0.37099523E-03_JPRB, 0.37099409E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099066E-03_JPRB, 0.37098958E-03_JPRB, 0.37098848E-03_JPRB, 0.37098763E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098673E-03_JPRB, 0.37098720E-03_JPRB, 0.37098769E-03_JPRB, 0.37098801E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098781E-03_JPRB, 0.37098763E-03_JPRB, 0.37098743E-03_JPRB, 0.37098728E-03_JPRB, 0.37098720E-03_JPRB, &
  & 0.37098711E-03_JPRB, 0.37098699E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, 0.37098647E-03_JPRB, 0.37098629E-03_JPRB, &
  & 0.37098612E-03_JPRB, 0.37098594E-03_JPRB, 0.37098571E-03_JPRB, 0.37098539E-03_JPRB /)

RGHG1(:,61, 2) = (/ &
  & 0.37097937E-03_JPRB, 0.37097983E-03_JPRB, 0.37097995E-03_JPRB, 0.37098004E-03_JPRB, 0.37098007E-03_JPRB, 0.37098004E-03_JPRB, &
  & 0.37097995E-03_JPRB, 0.37097992E-03_JPRB, 0.37097992E-03_JPRB, 0.37097992E-03_JPRB, 0.37097992E-03_JPRB, 0.37097995E-03_JPRB, &
  & 0.37097986E-03_JPRB, 0.37097977E-03_JPRB, 0.37097960E-03_JPRB, 0.37097937E-03_JPRB, 0.37097896E-03_JPRB, 0.37097905E-03_JPRB, &
  & 0.37097980E-03_JPRB, 0.37098146E-03_JPRB, 0.37098373E-03_JPRB, 0.37098635E-03_JPRB, 0.37098900E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099575E-03_JPRB, 0.37099721E-03_JPRB, 0.37099796E-03_JPRB, 0.37099840E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099744E-03_JPRB, 0.37099674E-03_JPRB, 0.37099567E-03_JPRB, 0.37099444E-03_JPRB, 0.37099337E-03_JPRB, &
  & 0.37099223E-03_JPRB, 0.37099115E-03_JPRB, 0.37099014E-03_JPRB, 0.37098915E-03_JPRB, 0.37098836E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098752E-03_JPRB, 0.37098772E-03_JPRB, 0.37098821E-03_JPRB, 0.37098874E-03_JPRB, 0.37098918E-03_JPRB, 0.37098918E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098891E-03_JPRB, 0.37098868E-03_JPRB, 0.37098845E-03_JPRB, 0.37098827E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098804E-03_JPRB, 0.37098787E-03_JPRB, 0.37098775E-03_JPRB, 0.37098752E-03_JPRB, 0.37098734E-03_JPRB, 0.37098723E-03_JPRB, &
  & 0.37098702E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, 0.37098632E-03_JPRB /)

RGHG1(:,62, 2) = (/ &
  & 0.37098117E-03_JPRB, 0.37098146E-03_JPRB, 0.37098155E-03_JPRB, 0.37098161E-03_JPRB, 0.37098161E-03_JPRB, 0.37098152E-03_JPRB, &
  & 0.37098152E-03_JPRB, 0.37098143E-03_JPRB, 0.37098143E-03_JPRB, 0.37098140E-03_JPRB, 0.37098143E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098146E-03_JPRB, 0.37098146E-03_JPRB, 0.37098123E-03_JPRB, 0.37098094E-03_JPRB, 0.37098062E-03_JPRB, 0.37098082E-03_JPRB, &
  & 0.37098143E-03_JPRB, 0.37098292E-03_JPRB, 0.37098504E-03_JPRB, 0.37098752E-03_JPRB, 0.37098996E-03_JPRB, 0.37099238E-03_JPRB, &
  & 0.37099459E-03_JPRB, 0.37099631E-03_JPRB, 0.37099762E-03_JPRB, 0.37099831E-03_JPRB, 0.37099869E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099785E-03_JPRB, 0.37099712E-03_JPRB, 0.37099607E-03_JPRB, 0.37099491E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099270E-03_JPRB, 0.37099162E-03_JPRB, 0.37099066E-03_JPRB, 0.37098976E-03_JPRB, 0.37098906E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37098874E-03_JPRB, 0.37098929E-03_JPRB, 0.37098987E-03_JPRB, 0.37099019E-03_JPRB, 0.37099016E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098990E-03_JPRB, 0.37098964E-03_JPRB, 0.37098938E-03_JPRB, 0.37098920E-03_JPRB, 0.37098906E-03_JPRB, &
  & 0.37098894E-03_JPRB, 0.37098886E-03_JPRB, 0.37098868E-03_JPRB, 0.37098853E-03_JPRB, 0.37098839E-03_JPRB, 0.37098821E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098781E-03_JPRB, 0.37098763E-03_JPRB, 0.37098734E-03_JPRB /)

RGHG1(:,63, 2) = (/ &
  & 0.37098269E-03_JPRB, 0.37098292E-03_JPRB, 0.37098303E-03_JPRB, 0.37098303E-03_JPRB, 0.37098301E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098286E-03_JPRB, 0.37098277E-03_JPRB, 0.37098277E-03_JPRB, 0.37098280E-03_JPRB, 0.37098286E-03_JPRB, 0.37098303E-03_JPRB, &
  & 0.37098306E-03_JPRB, 0.37098309E-03_JPRB, 0.37098292E-03_JPRB, 0.37098260E-03_JPRB, 0.37098231E-03_JPRB, 0.37098251E-03_JPRB, &
  & 0.37098306E-03_JPRB, 0.37098437E-03_JPRB, 0.37098638E-03_JPRB, 0.37098853E-03_JPRB, 0.37099092E-03_JPRB, 0.37099325E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099686E-03_JPRB, 0.37099808E-03_JPRB, 0.37099869E-03_JPRB, 0.37099904E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099820E-03_JPRB, 0.37099753E-03_JPRB, 0.37099651E-03_JPRB, 0.37099537E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099217E-03_JPRB, 0.37099130E-03_JPRB, 0.37099046E-03_JPRB, 0.37098979E-03_JPRB, 0.37098947E-03_JPRB, &
  & 0.37098935E-03_JPRB, 0.37098961E-03_JPRB, 0.37099022E-03_JPRB, 0.37099083E-03_JPRB, 0.37099110E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099083E-03_JPRB, 0.37099057E-03_JPRB, 0.37099031E-03_JPRB, 0.37099008E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37098979E-03_JPRB, 0.37098970E-03_JPRB, 0.37098955E-03_JPRB, 0.37098938E-03_JPRB, 0.37098920E-03_JPRB, 0.37098909E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098874E-03_JPRB, 0.37098856E-03_JPRB, 0.37098824E-03_JPRB /)

RGHG1(:,64, 2) = (/ &
  & 0.37098414E-03_JPRB, 0.37098440E-03_JPRB, 0.37098443E-03_JPRB, 0.37098437E-03_JPRB, 0.37098434E-03_JPRB, 0.37098431E-03_JPRB, &
  & 0.37098431E-03_JPRB, 0.37098426E-03_JPRB, 0.37098420E-03_JPRB, 0.37098426E-03_JPRB, 0.37098440E-03_JPRB, 0.37098461E-03_JPRB, &
  & 0.37098469E-03_JPRB, 0.37098469E-03_JPRB, 0.37098455E-03_JPRB, 0.37098420E-03_JPRB, 0.37098402E-03_JPRB, 0.37098423E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098589E-03_JPRB, 0.37098769E-03_JPRB, 0.37098973E-03_JPRB, 0.37099179E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099590E-03_JPRB, 0.37099730E-03_JPRB, 0.37099846E-03_JPRB, 0.37099904E-03_JPRB, 0.37099939E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099855E-03_JPRB, 0.37099791E-03_JPRB, 0.37099698E-03_JPRB, 0.37099584E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099276E-03_JPRB, 0.37099185E-03_JPRB, 0.37099115E-03_JPRB, 0.37099060E-03_JPRB, 0.37099034E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099066E-03_JPRB, 0.37099113E-03_JPRB, 0.37099174E-03_JPRB, 0.37099200E-03_JPRB, 0.37099203E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099177E-03_JPRB, 0.37099142E-03_JPRB, 0.37099113E-03_JPRB, 0.37099092E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099046E-03_JPRB, 0.37099031E-03_JPRB, 0.37099014E-03_JPRB, 0.37098990E-03_JPRB, 0.37098973E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098938E-03_JPRB, 0.37098920E-03_JPRB, 0.37098891E-03_JPRB /)

RGHG1(:,65, 2) = (/ &
  & 0.37098536E-03_JPRB, 0.37098565E-03_JPRB, 0.37098568E-03_JPRB, 0.37098565E-03_JPRB, 0.37098565E-03_JPRB, 0.37098565E-03_JPRB, &
  & 0.37098562E-03_JPRB, 0.37098560E-03_JPRB, 0.37098560E-03_JPRB, 0.37098562E-03_JPRB, 0.37098586E-03_JPRB, 0.37098597E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098626E-03_JPRB, 0.37098618E-03_JPRB, 0.37098583E-03_JPRB, 0.37098568E-03_JPRB, 0.37098583E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098740E-03_JPRB, 0.37098897E-03_JPRB, 0.37099089E-03_JPRB, 0.37099287E-03_JPRB, 0.37099482E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099773E-03_JPRB, 0.37099881E-03_JPRB, 0.37099933E-03_JPRB, 0.37099968E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099884E-03_JPRB, 0.37099828E-03_JPRB, 0.37099753E-03_JPRB, 0.37099631E-03_JPRB, 0.37099535E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099331E-03_JPRB, 0.37099249E-03_JPRB, 0.37099188E-03_JPRB, 0.37099142E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099156E-03_JPRB, 0.37099206E-03_JPRB, 0.37099258E-03_JPRB, 0.37099284E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099290E-03_JPRB, 0.37099261E-03_JPRB, 0.37099223E-03_JPRB, 0.37099185E-03_JPRB, 0.37099168E-03_JPRB, 0.37099147E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099118E-03_JPRB, 0.37099101E-03_JPRB, 0.37099083E-03_JPRB, 0.37099066E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099002E-03_JPRB, 0.37098979E-03_JPRB, 0.37098944E-03_JPRB /)

RGHG1(:,66, 2) = (/ &
  & 0.37098650E-03_JPRB, 0.37098682E-03_JPRB, 0.37098682E-03_JPRB, 0.37098688E-03_JPRB, 0.37098685E-03_JPRB, 0.37098685E-03_JPRB, &
  & 0.37098682E-03_JPRB, 0.37098693E-03_JPRB, 0.37098693E-03_JPRB, 0.37098699E-03_JPRB, 0.37098723E-03_JPRB, 0.37098743E-03_JPRB, &
  & 0.37098763E-03_JPRB, 0.37098775E-03_JPRB, 0.37098763E-03_JPRB, 0.37098723E-03_JPRB, 0.37098720E-03_JPRB, 0.37098743E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098891E-03_JPRB, 0.37099034E-03_JPRB, 0.37099194E-03_JPRB, 0.37099377E-03_JPRB, 0.37099555E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099820E-03_JPRB, 0.37099907E-03_JPRB, 0.37099957E-03_JPRB, 0.37099989E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099927E-03_JPRB, 0.37099872E-03_JPRB, 0.37099794E-03_JPRB, 0.37099692E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099386E-03_JPRB, 0.37099308E-03_JPRB, 0.37099255E-03_JPRB, 0.37099211E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099238E-03_JPRB, 0.37099293E-03_JPRB, 0.37099345E-03_JPRB, 0.37099369E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099348E-03_JPRB, 0.37099305E-03_JPRB, 0.37099267E-03_JPRB, 0.37099246E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099191E-03_JPRB, 0.37099177E-03_JPRB, 0.37099153E-03_JPRB, 0.37099136E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099101E-03_JPRB, 0.37099069E-03_JPRB, 0.37099040E-03_JPRB, 0.37098999E-03_JPRB /)

RGHG1(:,67, 2) = (/ &
  & 0.37098757E-03_JPRB, 0.37098795E-03_JPRB, 0.37098804E-03_JPRB, 0.37098810E-03_JPRB, 0.37098810E-03_JPRB, 0.37098813E-03_JPRB, &
  & 0.37098807E-03_JPRB, 0.37098816E-03_JPRB, 0.37098821E-03_JPRB, 0.37098827E-03_JPRB, 0.37098853E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098903E-03_JPRB, 0.37098920E-03_JPRB, 0.37098906E-03_JPRB, 0.37098871E-03_JPRB, 0.37098880E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37099028E-03_JPRB, 0.37099156E-03_JPRB, 0.37099308E-03_JPRB, 0.37099473E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099855E-03_JPRB, 0.37099927E-03_JPRB, 0.37099983E-03_JPRB, 0.37100003E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099957E-03_JPRB, 0.37099910E-03_JPRB, 0.37099840E-03_JPRB, 0.37099741E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099447E-03_JPRB, 0.37099380E-03_JPRB, 0.37099325E-03_JPRB, 0.37099293E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099331E-03_JPRB, 0.37099383E-03_JPRB, 0.37099430E-03_JPRB, 0.37099444E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099459E-03_JPRB, 0.37099438E-03_JPRB, 0.37099383E-03_JPRB, 0.37099340E-03_JPRB, 0.37099325E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099270E-03_JPRB, 0.37099252E-03_JPRB, 0.37099223E-03_JPRB, 0.37099197E-03_JPRB, 0.37099182E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099121E-03_JPRB, 0.37099092E-03_JPRB, 0.37099037E-03_JPRB /)

RGHG1(:,68, 2) = (/ &
  & 0.37098856E-03_JPRB, 0.37098900E-03_JPRB, 0.37098909E-03_JPRB, 0.37098923E-03_JPRB, 0.37098929E-03_JPRB, 0.37098938E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098941E-03_JPRB, 0.37098950E-03_JPRB, 0.37098961E-03_JPRB, 0.37098990E-03_JPRB, 0.37099022E-03_JPRB, &
  & 0.37099037E-03_JPRB, 0.37099054E-03_JPRB, 0.37099043E-03_JPRB, 0.37099011E-03_JPRB, 0.37099034E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099098E-03_JPRB, 0.37099165E-03_JPRB, 0.37099273E-03_JPRB, 0.37099398E-03_JPRB, 0.37099552E-03_JPRB, 0.37099686E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099884E-03_JPRB, 0.37099951E-03_JPRB, 0.37100000E-03_JPRB, 0.37100018E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099968E-03_JPRB, 0.37099936E-03_JPRB, 0.37099875E-03_JPRB, 0.37099782E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099505E-03_JPRB, 0.37099438E-03_JPRB, 0.37099392E-03_JPRB, 0.37099366E-03_JPRB, 0.37099383E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099424E-03_JPRB, 0.37099465E-03_JPRB, 0.37099517E-03_JPRB, 0.37099526E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099540E-03_JPRB, 0.37099511E-03_JPRB, 0.37099462E-03_JPRB, 0.37099409E-03_JPRB, 0.37099398E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099357E-03_JPRB, 0.37099345E-03_JPRB, 0.37099331E-03_JPRB, 0.37099296E-03_JPRB, 0.37099281E-03_JPRB, 0.37099255E-03_JPRB, &
  & 0.37099226E-03_JPRB, 0.37099177E-03_JPRB, 0.37099147E-03_JPRB, 0.37099083E-03_JPRB /)

RGHG1(:,69, 2) = (/ &
  & 0.37098950E-03_JPRB, 0.37099002E-03_JPRB, 0.37099014E-03_JPRB, 0.37099025E-03_JPRB, 0.37099034E-03_JPRB, 0.37099046E-03_JPRB, &
  & 0.37099051E-03_JPRB, 0.37099063E-03_JPRB, 0.37099063E-03_JPRB, 0.37099078E-03_JPRB, 0.37099101E-03_JPRB, 0.37099147E-03_JPRB, &
  & 0.37099168E-03_JPRB, 0.37099194E-03_JPRB, 0.37099182E-03_JPRB, 0.37099145E-03_JPRB, 0.37099174E-03_JPRB, 0.37099209E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099293E-03_JPRB, 0.37099386E-03_JPRB, 0.37099503E-03_JPRB, 0.37099636E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099907E-03_JPRB, 0.37099959E-03_JPRB, 0.37100021E-03_JPRB, 0.37100038E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099991E-03_JPRB, 0.37099965E-03_JPRB, 0.37099913E-03_JPRB, 0.37099828E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099567E-03_JPRB, 0.37099508E-03_JPRB, 0.37099468E-03_JPRB, 0.37099450E-03_JPRB, 0.37099465E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099508E-03_JPRB, 0.37099543E-03_JPRB, 0.37099584E-03_JPRB, 0.37099596E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099578E-03_JPRB, 0.37099526E-03_JPRB, 0.37099473E-03_JPRB, 0.37099468E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099404E-03_JPRB, 0.37099401E-03_JPRB, 0.37099374E-03_JPRB, 0.37099357E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099249E-03_JPRB, 0.37099209E-03_JPRB, 0.37099124E-03_JPRB /)

RGHG1(:,70, 2) = (/ &
  & 0.37099051E-03_JPRB, 0.37099107E-03_JPRB, 0.37099118E-03_JPRB, 0.37099139E-03_JPRB, 0.37099153E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099174E-03_JPRB, 0.37099179E-03_JPRB, 0.37099177E-03_JPRB, 0.37099200E-03_JPRB, 0.37099226E-03_JPRB, 0.37099267E-03_JPRB, &
  & 0.37099290E-03_JPRB, 0.37099316E-03_JPRB, 0.37099319E-03_JPRB, 0.37099276E-03_JPRB, 0.37099290E-03_JPRB, 0.37099351E-03_JPRB, &
  & 0.37099354E-03_JPRB, 0.37099404E-03_JPRB, 0.37099491E-03_JPRB, 0.37099596E-03_JPRB, 0.37099706E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099922E-03_JPRB, 0.37099974E-03_JPRB, 0.37100032E-03_JPRB, 0.37100050E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100000E-03_JPRB, 0.37100000E-03_JPRB, 0.37099951E-03_JPRB, 0.37099878E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099625E-03_JPRB, 0.37099575E-03_JPRB, 0.37099543E-03_JPRB, 0.37099532E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099578E-03_JPRB, 0.37099610E-03_JPRB, 0.37099648E-03_JPRB, 0.37099665E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099651E-03_JPRB, 0.37099593E-03_JPRB, 0.37099540E-03_JPRB, 0.37099543E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099471E-03_JPRB, 0.37099468E-03_JPRB, 0.37099444E-03_JPRB, 0.37099427E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099319E-03_JPRB, 0.37099273E-03_JPRB, 0.37099182E-03_JPRB /)

RGHG1(:,71, 2) = (/ &
  & 0.37099139E-03_JPRB, 0.37099206E-03_JPRB, 0.37099217E-03_JPRB, 0.37099243E-03_JPRB, 0.37099270E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099296E-03_JPRB, 0.37099293E-03_JPRB, 0.37099310E-03_JPRB, 0.37099337E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099406E-03_JPRB, 0.37099438E-03_JPRB, 0.37099444E-03_JPRB, 0.37099406E-03_JPRB, 0.37099409E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099517E-03_JPRB, 0.37099596E-03_JPRB, 0.37099680E-03_JPRB, 0.37099767E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099939E-03_JPRB, 0.37099980E-03_JPRB, 0.37100035E-03_JPRB, 0.37100055E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100009E-03_JPRB, 0.37100035E-03_JPRB, 0.37099983E-03_JPRB, 0.37099910E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099738E-03_JPRB, 0.37099686E-03_JPRB, 0.37099628E-03_JPRB, 0.37099613E-03_JPRB, 0.37099607E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099642E-03_JPRB, 0.37099671E-03_JPRB, 0.37099712E-03_JPRB, 0.37099730E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099735E-03_JPRB, 0.37099712E-03_JPRB, 0.37099654E-03_JPRB, 0.37099610E-03_JPRB, 0.37099616E-03_JPRB, 0.37099575E-03_JPRB, &
  & 0.37099555E-03_JPRB, 0.37099537E-03_JPRB, 0.37099552E-03_JPRB, 0.37099520E-03_JPRB, 0.37099508E-03_JPRB, 0.37099500E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099392E-03_JPRB, 0.37099345E-03_JPRB, 0.37099264E-03_JPRB /)

RGHG1(:,72, 2) = (/ &
  & 0.37099241E-03_JPRB, 0.37099322E-03_JPRB, 0.37099322E-03_JPRB, 0.37099360E-03_JPRB, 0.37099383E-03_JPRB, 0.37099412E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099409E-03_JPRB, 0.37099401E-03_JPRB, 0.37099427E-03_JPRB, 0.37099444E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099511E-03_JPRB, 0.37099555E-03_JPRB, 0.37099561E-03_JPRB, 0.37099523E-03_JPRB, 0.37099535E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099587E-03_JPRB, 0.37099619E-03_JPRB, 0.37099680E-03_JPRB, 0.37099753E-03_JPRB, 0.37099823E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099951E-03_JPRB, 0.37099974E-03_JPRB, 0.37100032E-03_JPRB, 0.37100064E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100012E-03_JPRB, 0.37100055E-03_JPRB, 0.37100009E-03_JPRB, 0.37099945E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099732E-03_JPRB, 0.37099683E-03_JPRB, 0.37099677E-03_JPRB, 0.37099689E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099700E-03_JPRB, 0.37099709E-03_JPRB, 0.37099764E-03_JPRB, 0.37099794E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099779E-03_JPRB, 0.37099721E-03_JPRB, 0.37099671E-03_JPRB, 0.37099686E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099593E-03_JPRB, 0.37099625E-03_JPRB, 0.37099596E-03_JPRB, 0.37099587E-03_JPRB, 0.37099575E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099476E-03_JPRB, 0.37099415E-03_JPRB, 0.37099351E-03_JPRB /)

RGHG1(:,73, 2) = (/ &
  & 0.37099348E-03_JPRB, 0.37099438E-03_JPRB, 0.37099418E-03_JPRB, 0.37099479E-03_JPRB, 0.37099497E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099514E-03_JPRB, 0.37099500E-03_JPRB, 0.37099523E-03_JPRB, 0.37099537E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099665E-03_JPRB, 0.37099671E-03_JPRB, 0.37099633E-03_JPRB, 0.37099648E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37099712E-03_JPRB, 0.37099764E-03_JPRB, 0.37099826E-03_JPRB, 0.37099869E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099962E-03_JPRB, 0.37099965E-03_JPRB, 0.37100032E-03_JPRB, 0.37100073E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100000E-03_JPRB, 0.37100082E-03_JPRB, 0.37100026E-03_JPRB, 0.37099968E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099779E-03_JPRB, 0.37099741E-03_JPRB, 0.37099747E-03_JPRB, 0.37099759E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099735E-03_JPRB, 0.37099744E-03_JPRB, 0.37099796E-03_JPRB, 0.37099840E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099837E-03_JPRB, 0.37099782E-03_JPRB, 0.37099727E-03_JPRB, 0.37099747E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099639E-03_JPRB, 0.37099700E-03_JPRB, 0.37099671E-03_JPRB, 0.37099663E-03_JPRB, 0.37099651E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099555E-03_JPRB, 0.37099482E-03_JPRB, 0.37099447E-03_JPRB /)

RGHG1(:,74, 2) = (/ &
  & 0.37099465E-03_JPRB, 0.37099546E-03_JPRB, 0.37099514E-03_JPRB, 0.37099601E-03_JPRB, 0.37099622E-03_JPRB, 0.37099639E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099596E-03_JPRB, 0.37099572E-03_JPRB, 0.37099601E-03_JPRB, 0.37099613E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099767E-03_JPRB, 0.37099785E-03_JPRB, 0.37099750E-03_JPRB, 0.37099756E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099808E-03_JPRB, 0.37099843E-03_JPRB, 0.37099875E-03_JPRB, 0.37099898E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099965E-03_JPRB, 0.37099945E-03_JPRB, 0.37100018E-03_JPRB, 0.37100076E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099991E-03_JPRB, 0.37100099E-03_JPRB, 0.37100032E-03_JPRB, 0.37100000E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099823E-03_JPRB, 0.37099805E-03_JPRB, 0.37099828E-03_JPRB, 0.37099837E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099779E-03_JPRB, 0.37099767E-03_JPRB, 0.37099826E-03_JPRB, 0.37099884E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099898E-03_JPRB, 0.37099834E-03_JPRB, 0.37099779E-03_JPRB, 0.37099805E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099689E-03_JPRB, 0.37099767E-03_JPRB, 0.37099738E-03_JPRB, 0.37099738E-03_JPRB, 0.37099724E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099631E-03_JPRB, 0.37099537E-03_JPRB, 0.37099543E-03_JPRB /)

RGHG1(:,75, 2) = (/ &
  & 0.37099584E-03_JPRB, 0.37099677E-03_JPRB, 0.37099616E-03_JPRB, 0.37099730E-03_JPRB, 0.37099738E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099692E-03_JPRB, 0.37099654E-03_JPRB, 0.37099671E-03_JPRB, 0.37099680E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099855E-03_JPRB, 0.37099878E-03_JPRB, 0.37099843E-03_JPRB, 0.37099858E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099898E-03_JPRB, 0.37099907E-03_JPRB, 0.37099927E-03_JPRB, 0.37099922E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099974E-03_JPRB, 0.37099930E-03_JPRB, 0.37099991E-03_JPRB, 0.37100082E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099959E-03_JPRB, 0.37100114E-03_JPRB, 0.37100035E-03_JPRB, 0.37100009E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099860E-03_JPRB, 0.37099858E-03_JPRB, 0.37099901E-03_JPRB, 0.37099904E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099799E-03_JPRB, 0.37099776E-03_JPRB, 0.37099834E-03_JPRB, 0.37099933E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099962E-03_JPRB, 0.37099884E-03_JPRB, 0.37099826E-03_JPRB, 0.37099875E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099715E-03_JPRB, 0.37099828E-03_JPRB, 0.37099805E-03_JPRB, 0.37099805E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099706E-03_JPRB, 0.37099587E-03_JPRB, 0.37099648E-03_JPRB /)

RGHG1(:,76, 2) = (/ &
  & 0.37099695E-03_JPRB, 0.37099791E-03_JPRB, 0.37099692E-03_JPRB, 0.37099852E-03_JPRB, 0.37099863E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099773E-03_JPRB, 0.37099712E-03_JPRB, 0.37099721E-03_JPRB, 0.37099724E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099933E-03_JPRB, 0.37099974E-03_JPRB, 0.37099927E-03_JPRB, 0.37099951E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099983E-03_JPRB, 0.37099957E-03_JPRB, 0.37099957E-03_JPRB, 0.37099933E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099983E-03_JPRB, 0.37099916E-03_JPRB, 0.37099962E-03_JPRB, 0.37100096E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099927E-03_JPRB, 0.37100131E-03_JPRB, 0.37100026E-03_JPRB, 0.37100018E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099901E-03_JPRB, 0.37099907E-03_JPRB, 0.37099980E-03_JPRB, 0.37099980E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37099808E-03_JPRB, 0.37099776E-03_JPRB, 0.37099840E-03_JPRB, 0.37099974E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37100026E-03_JPRB, 0.37099925E-03_JPRB, 0.37099852E-03_JPRB, 0.37099948E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099738E-03_JPRB, 0.37099907E-03_JPRB, 0.37099878E-03_JPRB, 0.37099869E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099776E-03_JPRB, 0.37099622E-03_JPRB, 0.37099764E-03_JPRB /)

RGHG1(:,77, 2) = (/ &
  & 0.37099808E-03_JPRB, 0.37099913E-03_JPRB, 0.37099767E-03_JPRB, 0.37099980E-03_JPRB, 0.37099986E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099843E-03_JPRB, 0.37099747E-03_JPRB, 0.37099753E-03_JPRB, 0.37099741E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37100000E-03_JPRB, 0.37100061E-03_JPRB, 0.37100009E-03_JPRB, 0.37100023E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100058E-03_JPRB, 0.37099997E-03_JPRB, 0.37099983E-03_JPRB, 0.37099942E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099991E-03_JPRB, 0.37099898E-03_JPRB, 0.37099930E-03_JPRB, 0.37100120E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37099872E-03_JPRB, 0.37100146E-03_JPRB, 0.37100006E-03_JPRB, 0.37100032E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099939E-03_JPRB, 0.37099948E-03_JPRB, 0.37100070E-03_JPRB, 0.37100055E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099814E-03_JPRB, 0.37099767E-03_JPRB, 0.37099826E-03_JPRB, 0.37100015E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100093E-03_JPRB, 0.37099962E-03_JPRB, 0.37099872E-03_JPRB, 0.37100026E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099750E-03_JPRB, 0.37100000E-03_JPRB, 0.37099948E-03_JPRB, 0.37099939E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099834E-03_JPRB, 0.37099636E-03_JPRB, 0.37099887E-03_JPRB /)

RGHG1(:,78, 2) = (/ &
  & 0.37099919E-03_JPRB, 0.37100026E-03_JPRB, 0.37099808E-03_JPRB, 0.37100102E-03_JPRB, 0.37100096E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37099907E-03_JPRB, 0.37099770E-03_JPRB, 0.37099776E-03_JPRB, 0.37099750E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100050E-03_JPRB, 0.37100122E-03_JPRB, 0.37100064E-03_JPRB, 0.37100088E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37100122E-03_JPRB, 0.37100026E-03_JPRB, 0.37100000E-03_JPRB, 0.37099933E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37100006E-03_JPRB, 0.37099887E-03_JPRB, 0.37099890E-03_JPRB, 0.37100143E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099823E-03_JPRB, 0.37100166E-03_JPRB, 0.37099983E-03_JPRB, 0.37100038E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099977E-03_JPRB, 0.37099997E-03_JPRB, 0.37100157E-03_JPRB, 0.37100125E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37099805E-03_JPRB, 0.37099747E-03_JPRB, 0.37099814E-03_JPRB, 0.37100061E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100172E-03_JPRB, 0.37099991E-03_JPRB, 0.37099884E-03_JPRB, 0.37100111E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099759E-03_JPRB, 0.37100082E-03_JPRB, 0.37100006E-03_JPRB, 0.37099991E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37099884E-03_JPRB, 0.37099639E-03_JPRB, 0.37100021E-03_JPRB /)

RGHG1(:,79, 2) = (/ &
  & 0.37100009E-03_JPRB, 0.37100125E-03_JPRB, 0.37099828E-03_JPRB, 0.37100195E-03_JPRB, 0.37100189E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37099930E-03_JPRB, 0.37099759E-03_JPRB, 0.37099770E-03_JPRB, 0.37099724E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100096E-03_JPRB, 0.37100184E-03_JPRB, 0.37100117E-03_JPRB, 0.37100140E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100172E-03_JPRB, 0.37100038E-03_JPRB, 0.37100009E-03_JPRB, 0.37099927E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37100009E-03_JPRB, 0.37099866E-03_JPRB, 0.37099858E-03_JPRB, 0.37100175E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099770E-03_JPRB, 0.37100189E-03_JPRB, 0.37099965E-03_JPRB, 0.37100044E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099994E-03_JPRB, 0.37100021E-03_JPRB, 0.37100230E-03_JPRB, 0.37100178E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37099788E-03_JPRB, 0.37099718E-03_JPRB, 0.37099788E-03_JPRB, 0.37100093E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100236E-03_JPRB, 0.37100015E-03_JPRB, 0.37099884E-03_JPRB, 0.37100172E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099741E-03_JPRB, 0.37100152E-03_JPRB, 0.37100050E-03_JPRB, 0.37100026E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37099910E-03_JPRB, 0.37099610E-03_JPRB, 0.37100149E-03_JPRB /)

RGHG1(:,80, 2) = (/ &
  & 0.37100085E-03_JPRB, 0.37100178E-03_JPRB, 0.37099834E-03_JPRB, 0.37100253E-03_JPRB, 0.37100242E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37099959E-03_JPRB, 0.37099747E-03_JPRB, 0.37099759E-03_JPRB, 0.37099698E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100125E-03_JPRB, 0.37100224E-03_JPRB, 0.37100146E-03_JPRB, 0.37100172E-03_JPRB, 0.37100122E-03_JPRB, &
  & 0.37100303E-03_JPRB, 0.37100207E-03_JPRB, 0.37100061E-03_JPRB, 0.37100015E-03_JPRB, 0.37099922E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37100015E-03_JPRB, 0.37099849E-03_JPRB, 0.37099837E-03_JPRB, 0.37100192E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099730E-03_JPRB, 0.37100207E-03_JPRB, 0.37099968E-03_JPRB, 0.37100044E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100009E-03_JPRB, 0.37100038E-03_JPRB, 0.37100274E-03_JPRB, 0.37100216E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37099776E-03_JPRB, 0.37099692E-03_JPRB, 0.37099762E-03_JPRB, 0.37100120E-03_JPRB, 0.37099727E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100288E-03_JPRB, 0.37100021E-03_JPRB, 0.37099869E-03_JPRB, 0.37100213E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099727E-03_JPRB, 0.37100192E-03_JPRB, 0.37100079E-03_JPRB, 0.37100044E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37099927E-03_JPRB, 0.37099575E-03_JPRB, 0.37100277E-03_JPRB /)

RGHG1(:,81, 2) = (/ &
  & 0.37100157E-03_JPRB, 0.37100213E-03_JPRB, 0.37099837E-03_JPRB, 0.37100288E-03_JPRB, 0.37100268E-03_JPRB, 0.37100140E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37099945E-03_JPRB, 0.37099744E-03_JPRB, 0.37099747E-03_JPRB, 0.37099677E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100143E-03_JPRB, 0.37100242E-03_JPRB, 0.37100169E-03_JPRB, 0.37100189E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100338E-03_JPRB, 0.37100236E-03_JPRB, 0.37100061E-03_JPRB, 0.37100009E-03_JPRB, 0.37099910E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37100015E-03_JPRB, 0.37099837E-03_JPRB, 0.37099817E-03_JPRB, 0.37100213E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099712E-03_JPRB, 0.37100210E-03_JPRB, 0.37099962E-03_JPRB, 0.37100041E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100012E-03_JPRB, 0.37100047E-03_JPRB, 0.37100294E-03_JPRB, 0.37100233E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37099764E-03_JPRB, 0.37099674E-03_JPRB, 0.37099741E-03_JPRB, 0.37100131E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100317E-03_JPRB, 0.37100026E-03_JPRB, 0.37099869E-03_JPRB, 0.37100236E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099712E-03_JPRB, 0.37100221E-03_JPRB, 0.37100093E-03_JPRB, 0.37100064E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37099927E-03_JPRB, 0.37099546E-03_JPRB, 0.37100416E-03_JPRB /)

RGHG1(:,82, 2) = (/ &
  & 0.37100172E-03_JPRB, 0.37100227E-03_JPRB, 0.37099843E-03_JPRB, 0.37100320E-03_JPRB, 0.37100291E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37099977E-03_JPRB, 0.37099721E-03_JPRB, 0.37099747E-03_JPRB, 0.37099671E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100152E-03_JPRB, 0.37100259E-03_JPRB, 0.37100181E-03_JPRB, 0.37100195E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37100364E-03_JPRB, 0.37100239E-03_JPRB, 0.37100061E-03_JPRB, 0.37100003E-03_JPRB, 0.37099907E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37100012E-03_JPRB, 0.37099823E-03_JPRB, 0.37099794E-03_JPRB, 0.37100216E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099689E-03_JPRB, 0.37100213E-03_JPRB, 0.37099962E-03_JPRB, 0.37100035E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100015E-03_JPRB, 0.37100053E-03_JPRB, 0.37100309E-03_JPRB, 0.37100248E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100160E-03_JPRB, 0.37099747E-03_JPRB, 0.37099654E-03_JPRB, 0.37099732E-03_JPRB, 0.37100146E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37100338E-03_JPRB, 0.37100032E-03_JPRB, 0.37099863E-03_JPRB, 0.37100250E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099709E-03_JPRB, 0.37100239E-03_JPRB, 0.37100105E-03_JPRB, 0.37100076E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37099930E-03_JPRB, 0.37099532E-03_JPRB, 0.37100422E-03_JPRB /)

RGHG1(:,83, 2) = (/ &
  & 0.37100181E-03_JPRB, 0.37100236E-03_JPRB, 0.37099837E-03_JPRB, 0.37100338E-03_JPRB, 0.37100309E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37099933E-03_JPRB, 0.37099724E-03_JPRB, 0.37099735E-03_JPRB, 0.37099660E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100160E-03_JPRB, 0.37100274E-03_JPRB, 0.37100198E-03_JPRB, 0.37100210E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37100376E-03_JPRB, 0.37100256E-03_JPRB, 0.37100067E-03_JPRB, 0.37100006E-03_JPRB, 0.37099907E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37100012E-03_JPRB, 0.37099808E-03_JPRB, 0.37099779E-03_JPRB, 0.37100224E-03_JPRB, 0.37099907E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099677E-03_JPRB, 0.37100210E-03_JPRB, 0.37099968E-03_JPRB, 0.37100038E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100021E-03_JPRB, 0.37100061E-03_JPRB, 0.37100323E-03_JPRB, 0.37100265E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37099735E-03_JPRB, 0.37099639E-03_JPRB, 0.37099718E-03_JPRB, 0.37100154E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37100355E-03_JPRB, 0.37100035E-03_JPRB, 0.37099852E-03_JPRB, 0.37100268E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099700E-03_JPRB, 0.37100253E-03_JPRB, 0.37100111E-03_JPRB, 0.37100082E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37099925E-03_JPRB, 0.37099517E-03_JPRB, 0.37100437E-03_JPRB /)

RGHG1(:,84, 2) = (/ &
  & 0.37100186E-03_JPRB, 0.37100242E-03_JPRB, 0.37099837E-03_JPRB, 0.37100347E-03_JPRB, 0.37100317E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100227E-03_JPRB, 0.37099986E-03_JPRB, 0.37099718E-03_JPRB, 0.37099730E-03_JPRB, 0.37099680E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100152E-03_JPRB, 0.37100277E-03_JPRB, 0.37100204E-03_JPRB, 0.37100216E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100402E-03_JPRB, 0.37100253E-03_JPRB, 0.37100055E-03_JPRB, 0.37099994E-03_JPRB, 0.37099893E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37100009E-03_JPRB, 0.37099794E-03_JPRB, 0.37099764E-03_JPRB, 0.37100236E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099660E-03_JPRB, 0.37100204E-03_JPRB, 0.37099974E-03_JPRB, 0.37100029E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100021E-03_JPRB, 0.37100064E-03_JPRB, 0.37100329E-03_JPRB, 0.37100268E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37099715E-03_JPRB, 0.37099619E-03_JPRB, 0.37099706E-03_JPRB, 0.37100157E-03_JPRB, 0.37099665E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37100361E-03_JPRB, 0.37100026E-03_JPRB, 0.37099846E-03_JPRB, 0.37100282E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099689E-03_JPRB, 0.37100262E-03_JPRB, 0.37100120E-03_JPRB, 0.37100085E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37099916E-03_JPRB, 0.37099503E-03_JPRB, 0.37100445E-03_JPRB /)

RGHG1(:,85, 2) = (/ &
  & 0.37100198E-03_JPRB, 0.37100253E-03_JPRB, 0.37099831E-03_JPRB, 0.37100358E-03_JPRB, 0.37100320E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37099916E-03_JPRB, 0.37099741E-03_JPRB, 0.37099724E-03_JPRB, 0.37099698E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100149E-03_JPRB, 0.37100277E-03_JPRB, 0.37100216E-03_JPRB, 0.37100216E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100411E-03_JPRB, 0.37100268E-03_JPRB, 0.37100047E-03_JPRB, 0.37099989E-03_JPRB, 0.37099884E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099791E-03_JPRB, 0.37100021E-03_JPRB, 0.37099785E-03_JPRB, 0.37099750E-03_JPRB, 0.37100242E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099657E-03_JPRB, 0.37100204E-03_JPRB, 0.37099977E-03_JPRB, 0.37100026E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100021E-03_JPRB, 0.37100073E-03_JPRB, 0.37100335E-03_JPRB, 0.37100271E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37099700E-03_JPRB, 0.37099610E-03_JPRB, 0.37099692E-03_JPRB, 0.37100169E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37100370E-03_JPRB, 0.37100026E-03_JPRB, 0.37099834E-03_JPRB, 0.37100291E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099683E-03_JPRB, 0.37100277E-03_JPRB, 0.37100125E-03_JPRB, 0.37100090E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099916E-03_JPRB, 0.37099491E-03_JPRB, 0.37100457E-03_JPRB /)

RGHG1(:,86, 2) = (/ &
  & 0.37100198E-03_JPRB, 0.37100265E-03_JPRB, 0.37099820E-03_JPRB, 0.37100370E-03_JPRB, 0.37100315E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37099945E-03_JPRB, 0.37099753E-03_JPRB, 0.37099741E-03_JPRB, 0.37099735E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100122E-03_JPRB, 0.37100259E-03_JPRB, 0.37100224E-03_JPRB, 0.37100218E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100268E-03_JPRB, 0.37100050E-03_JPRB, 0.37099983E-03_JPRB, 0.37099875E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37100021E-03_JPRB, 0.37099767E-03_JPRB, 0.37099738E-03_JPRB, 0.37100248E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099642E-03_JPRB, 0.37100195E-03_JPRB, 0.37099974E-03_JPRB, 0.37100026E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100021E-03_JPRB, 0.37100073E-03_JPRB, 0.37100358E-03_JPRB, 0.37100288E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099680E-03_JPRB, 0.37099596E-03_JPRB, 0.37099683E-03_JPRB, 0.37100172E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37100373E-03_JPRB, 0.37100029E-03_JPRB, 0.37099828E-03_JPRB, 0.37100297E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099674E-03_JPRB, 0.37100280E-03_JPRB, 0.37100137E-03_JPRB, 0.37100102E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37099913E-03_JPRB, 0.37099473E-03_JPRB, 0.37100463E-03_JPRB /)

RGHG1(:,87, 2) = (/ &
  & 0.37100201E-03_JPRB, 0.37100262E-03_JPRB, 0.37099802E-03_JPRB, 0.37100373E-03_JPRB, 0.37100317E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37099907E-03_JPRB, 0.37099785E-03_JPRB, 0.37099764E-03_JPRB, 0.37099770E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37100114E-03_JPRB, 0.37100248E-03_JPRB, 0.37100230E-03_JPRB, 0.37100221E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100428E-03_JPRB, 0.37100271E-03_JPRB, 0.37100044E-03_JPRB, 0.37099980E-03_JPRB, 0.37099872E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37100026E-03_JPRB, 0.37099759E-03_JPRB, 0.37099724E-03_JPRB, 0.37100259E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099628E-03_JPRB, 0.37100192E-03_JPRB, 0.37099974E-03_JPRB, 0.37100038E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100026E-03_JPRB, 0.37100076E-03_JPRB, 0.37100384E-03_JPRB, 0.37100294E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37099654E-03_JPRB, 0.37099584E-03_JPRB, 0.37099677E-03_JPRB, 0.37100181E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37100384E-03_JPRB, 0.37100038E-03_JPRB, 0.37099820E-03_JPRB, 0.37100300E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099665E-03_JPRB, 0.37100280E-03_JPRB, 0.37100143E-03_JPRB, 0.37100099E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099910E-03_JPRB, 0.37099459E-03_JPRB, 0.37100469E-03_JPRB /)

RGHG1(:,88, 2) = (/ &
  & 0.37100204E-03_JPRB, 0.37100262E-03_JPRB, 0.37099805E-03_JPRB, 0.37100370E-03_JPRB, 0.37100300E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37099939E-03_JPRB, 0.37099788E-03_JPRB, 0.37099770E-03_JPRB, 0.37099776E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100102E-03_JPRB, 0.37100236E-03_JPRB, 0.37100233E-03_JPRB, 0.37100221E-03_JPRB, 0.37100169E-03_JPRB, &
  & 0.37100434E-03_JPRB, 0.37100277E-03_JPRB, 0.37100041E-03_JPRB, 0.37099974E-03_JPRB, 0.37099863E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37100038E-03_JPRB, 0.37099756E-03_JPRB, 0.37099718E-03_JPRB, 0.37100268E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099607E-03_JPRB, 0.37100201E-03_JPRB, 0.37099974E-03_JPRB, 0.37100038E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100032E-03_JPRB, 0.37100061E-03_JPRB, 0.37100411E-03_JPRB, 0.37100317E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099636E-03_JPRB, 0.37099569E-03_JPRB, 0.37099663E-03_JPRB, 0.37100189E-03_JPRB, 0.37099633E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100384E-03_JPRB, 0.37100038E-03_JPRB, 0.37099817E-03_JPRB, 0.37100303E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099665E-03_JPRB, 0.37100282E-03_JPRB, 0.37100146E-03_JPRB, 0.37100102E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099907E-03_JPRB, 0.37099453E-03_JPRB, 0.37100472E-03_JPRB /)

RGHG1(:,89, 2) = (/ &
  & 0.37100204E-03_JPRB, 0.37100253E-03_JPRB, 0.37099808E-03_JPRB, 0.37100384E-03_JPRB, 0.37100329E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37099898E-03_JPRB, 0.37099770E-03_JPRB, 0.37099750E-03_JPRB, 0.37099753E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37100111E-03_JPRB, 0.37100242E-03_JPRB, 0.37100236E-03_JPRB, 0.37100218E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100448E-03_JPRB, 0.37100282E-03_JPRB, 0.37100038E-03_JPRB, 0.37099965E-03_JPRB, 0.37099858E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37100044E-03_JPRB, 0.37099747E-03_JPRB, 0.37099700E-03_JPRB, 0.37100277E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099587E-03_JPRB, 0.37100213E-03_JPRB, 0.37099962E-03_JPRB, 0.37100050E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100038E-03_JPRB, 0.37100055E-03_JPRB, 0.37100437E-03_JPRB, 0.37100320E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37099616E-03_JPRB, 0.37099569E-03_JPRB, 0.37099657E-03_JPRB, 0.37100198E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37100390E-03_JPRB, 0.37100041E-03_JPRB, 0.37099811E-03_JPRB, 0.37100315E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099660E-03_JPRB, 0.37100288E-03_JPRB, 0.37100146E-03_JPRB, 0.37100111E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37099910E-03_JPRB, 0.37099438E-03_JPRB, 0.37100480E-03_JPRB /)

RGHG1(:,90, 2) = (/ &
  & 0.37100204E-03_JPRB, 0.37100242E-03_JPRB, 0.37099791E-03_JPRB, 0.37100402E-03_JPRB, 0.37100332E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37099933E-03_JPRB, 0.37099718E-03_JPRB, 0.37099712E-03_JPRB, 0.37099706E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100137E-03_JPRB, 0.37100277E-03_JPRB, 0.37100248E-03_JPRB, 0.37100221E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100466E-03_JPRB, 0.37100282E-03_JPRB, 0.37100035E-03_JPRB, 0.37099971E-03_JPRB, 0.37099840E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37100055E-03_JPRB, 0.37099735E-03_JPRB, 0.37099677E-03_JPRB, 0.37100306E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099549E-03_JPRB, 0.37100256E-03_JPRB, 0.37099948E-03_JPRB, 0.37100073E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100047E-03_JPRB, 0.37100044E-03_JPRB, 0.37100466E-03_JPRB, 0.37100332E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37099604E-03_JPRB, 0.37099561E-03_JPRB, 0.37099648E-03_JPRB, 0.37100233E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37100419E-03_JPRB, 0.37100047E-03_JPRB, 0.37099794E-03_JPRB, 0.37100341E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099636E-03_JPRB, 0.37100306E-03_JPRB, 0.37100149E-03_JPRB, 0.37100114E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37099910E-03_JPRB, 0.37099421E-03_JPRB, 0.37100495E-03_JPRB /)

RGHG1(:,91, 2) = (/ &
  & 0.37100224E-03_JPRB, 0.37100285E-03_JPRB, 0.37099689E-03_JPRB, 0.37100454E-03_JPRB, 0.37100361E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100373E-03_JPRB, 0.37099954E-03_JPRB, 0.37099593E-03_JPRB, 0.37099698E-03_JPRB, 0.37099537E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100178E-03_JPRB, 0.37100332E-03_JPRB, 0.37100245E-03_JPRB, 0.37100221E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100515E-03_JPRB, 0.37100288E-03_JPRB, 0.37100021E-03_JPRB, 0.37099977E-03_JPRB, 0.37099828E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37100102E-03_JPRB, 0.37099718E-03_JPRB, 0.37099625E-03_JPRB, 0.37100396E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37099436E-03_JPRB, 0.37100381E-03_JPRB, 0.37099910E-03_JPRB, 0.37100134E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37100061E-03_JPRB, 0.37100018E-03_JPRB, 0.37100507E-03_JPRB, 0.37100349E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37099564E-03_JPRB, 0.37099546E-03_JPRB, 0.37099610E-03_JPRB, 0.37100315E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37100480E-03_JPRB, 0.37100038E-03_JPRB, 0.37099738E-03_JPRB, 0.37100408E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099590E-03_JPRB, 0.37100370E-03_JPRB, 0.37100140E-03_JPRB, 0.37100125E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37099904E-03_JPRB, 0.37099380E-03_JPRB, 0.37100518E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG1(:, 1, 3) = (/ &
  & 0.36209080E-03_JPRB, 0.36203524E-03_JPRB, 0.36195479E-03_JPRB, 0.36185022E-03_JPRB, 0.36174533E-03_JPRB, 0.36165753E-03_JPRB, &
  & 0.36160127E-03_JPRB, 0.36158247E-03_JPRB, 0.36159810E-03_JPRB, 0.36164091E-03_JPRB, 0.36169932E-03_JPRB, 0.36176443E-03_JPRB, &
  & 0.36182613E-03_JPRB, 0.36187275E-03_JPRB, 0.36188454E-03_JPRB, 0.36185904E-03_JPRB, 0.36177653E-03_JPRB, 0.36166864E-03_JPRB, &
  & 0.36154318E-03_JPRB, 0.36140956E-03_JPRB, 0.36127772E-03_JPRB, 0.36114952E-03_JPRB, 0.36102059E-03_JPRB, 0.36087824E-03_JPRB, &
  & 0.36068764E-03_JPRB, 0.36030234E-03_JPRB, 0.35978464E-03_JPRB, 0.35937937E-03_JPRB, 0.35910931E-03_JPRB, 0.35896248E-03_JPRB, &
  & 0.35892235E-03_JPRB, 0.35897785E-03_JPRB, 0.35911924E-03_JPRB, 0.35930416E-03_JPRB, 0.35950114E-03_JPRB, 0.35972937E-03_JPRB, &
  & 0.35998668E-03_JPRB, 0.36026587E-03_JPRB, 0.36046834E-03_JPRB, 0.36057676E-03_JPRB, 0.36061765E-03_JPRB, 0.36061666E-03_JPRB, &
  & 0.36058400E-03_JPRB, 0.36052294E-03_JPRB, 0.36043479E-03_JPRB, 0.36031959E-03_JPRB, 0.36017573E-03_JPRB, 0.35999675E-03_JPRB, &
  & 0.35977818E-03_JPRB, 0.35952483E-03_JPRB, 0.35925707E-03_JPRB, 0.35901007E-03_JPRB, 0.35882121E-03_JPRB, 0.35870963E-03_JPRB, &
  & 0.35866877E-03_JPRB, 0.35867741E-03_JPRB, 0.35871379E-03_JPRB, 0.35876193E-03_JPRB, 0.35881132E-03_JPRB, 0.35885512E-03_JPRB, &
  & 0.35889406E-03_JPRB, 0.35892715E-03_JPRB, 0.35894971E-03_JPRB, 0.35896231E-03_JPRB /)

RGHG1(:, 2, 3) = (/ &
  & 0.36232063E-03_JPRB, 0.36239275E-03_JPRB, 0.36241952E-03_JPRB, 0.36243442E-03_JPRB, 0.36245136E-03_JPRB, 0.36247741E-03_JPRB, &
  & 0.36251754E-03_JPRB, 0.36257762E-03_JPRB, 0.36266143E-03_JPRB, 0.36276673E-03_JPRB, 0.36288527E-03_JPRB, 0.36300614E-03_JPRB, &
  & 0.36311729E-03_JPRB, 0.36320370E-03_JPRB, 0.36325221E-03_JPRB, 0.36325073E-03_JPRB, 0.36319878E-03_JPRB, 0.36310236E-03_JPRB, &
  & 0.36297221E-03_JPRB, 0.36282174E-03_JPRB, 0.36265998E-03_JPRB, 0.36248224E-03_JPRB, 0.36228527E-03_JPRB, 0.36206830E-03_JPRB, &
  & 0.36182557E-03_JPRB, 0.36154070E-03_JPRB, 0.36126017E-03_JPRB, 0.36104093E-03_JPRB, 0.36090336E-03_JPRB, 0.36084204E-03_JPRB, &
  & 0.36085717E-03_JPRB, 0.36095266E-03_JPRB, 0.36113465E-03_JPRB, 0.36139492E-03_JPRB, 0.36170345E-03_JPRB, 0.36202927E-03_JPRB, &
  & 0.36233602E-03_JPRB, 0.36260468E-03_JPRB, 0.36279939E-03_JPRB, 0.36290879E-03_JPRB, 0.36294089E-03_JPRB, 0.36291097E-03_JPRB, &
  & 0.36282762E-03_JPRB, 0.36269391E-03_JPRB, 0.36251082E-03_JPRB, 0.36227956E-03_JPRB, 0.36200488E-03_JPRB, 0.36169830E-03_JPRB, &
  & 0.36137830E-03_JPRB, 0.36106742E-03_JPRB, 0.36078106E-03_JPRB, 0.36052140E-03_JPRB, 0.36028842E-03_JPRB, 0.36008819E-03_JPRB, &
  & 0.35992751E-03_JPRB, 0.35980760E-03_JPRB, 0.35972393E-03_JPRB, 0.35966982E-03_JPRB, 0.35963810E-03_JPRB, 0.35962177E-03_JPRB, &
  & 0.35961528E-03_JPRB, 0.35961496E-03_JPRB, 0.35961383E-03_JPRB, 0.35960873E-03_JPRB /)

RGHG1(:, 3, 3) = (/ &
  & 0.36260203E-03_JPRB, 0.36276126E-03_JPRB, 0.36285855E-03_JPRB, 0.36294697E-03_JPRB, 0.36304322E-03_JPRB, 0.36316278E-03_JPRB, &
  & 0.36331010E-03_JPRB, 0.36347006E-03_JPRB, 0.36362212E-03_JPRB, 0.36375501E-03_JPRB, 0.36386796E-03_JPRB, 0.36396229E-03_JPRB, &
  & 0.36403834E-03_JPRB, 0.36409419E-03_JPRB, 0.36412585E-03_JPRB, 0.36412856E-03_JPRB, 0.36409858E-03_JPRB, 0.36403583E-03_JPRB, &
  & 0.36394404E-03_JPRB, 0.36382777E-03_JPRB, 0.36369264E-03_JPRB, 0.36354642E-03_JPRB, 0.36339395E-03_JPRB, 0.36323248E-03_JPRB, &
  & 0.36307011E-03_JPRB, 0.36293967E-03_JPRB, 0.36286554E-03_JPRB, 0.36284720E-03_JPRB, 0.36287284E-03_JPRB, 0.36292963E-03_JPRB, &
  & 0.36301001E-03_JPRB, 0.36311604E-03_JPRB, 0.36325151E-03_JPRB, 0.36341429E-03_JPRB, 0.36359753E-03_JPRB, 0.36378071E-03_JPRB, &
  & 0.36395487E-03_JPRB, 0.36410429E-03_JPRB, 0.36421634E-03_JPRB, 0.36427658E-03_JPRB, 0.36428106E-03_JPRB, 0.36423263E-03_JPRB, &
  & 0.36413502E-03_JPRB, 0.36399061E-03_JPRB, 0.36380111E-03_JPRB, 0.36356843E-03_JPRB, 0.36329628E-03_JPRB, 0.36299054E-03_JPRB, &
  & 0.36265838E-03_JPRB, 0.36230730E-03_JPRB, 0.36194862E-03_JPRB, 0.36160508E-03_JPRB, 0.36130342E-03_JPRB, 0.36105781E-03_JPRB, &
  & 0.36086710E-03_JPRB, 0.36072361E-03_JPRB, 0.36061916E-03_JPRB, 0.36054599E-03_JPRB, 0.36049599E-03_JPRB, 0.36046180E-03_JPRB, &
  & 0.36043645E-03_JPRB, 0.36041444E-03_JPRB, 0.36039506E-03_JPRB, 0.36037280E-03_JPRB /)

RGHG1(:, 4, 3) = (/ &
  & 0.36299057E-03_JPRB, 0.36330274E-03_JPRB, 0.36349049E-03_JPRB, 0.36364753E-03_JPRB, 0.36378732E-03_JPRB, 0.36390685E-03_JPRB, &
  & 0.36400807E-03_JPRB, 0.36410254E-03_JPRB, 0.36419497E-03_JPRB, 0.36428130E-03_JPRB, 0.36435729E-03_JPRB, 0.36442111E-03_JPRB, &
  & 0.36447262E-03_JPRB, 0.36451203E-03_JPRB, 0.36453956E-03_JPRB, 0.36455493E-03_JPRB, 0.36455743E-03_JPRB, 0.36454599E-03_JPRB, &
  & 0.36452193E-03_JPRB, 0.36448936E-03_JPRB, 0.36445464E-03_JPRB, 0.36442128E-03_JPRB, 0.36439311E-03_JPRB, 0.36437769E-03_JPRB, &
  & 0.36438234E-03_JPRB, 0.36440531E-03_JPRB, 0.36443950E-03_JPRB, 0.36447795E-03_JPRB, 0.36451581E-03_JPRB, 0.36454905E-03_JPRB, &
  & 0.36457551E-03_JPRB, 0.36460036E-03_JPRB, 0.36463197E-03_JPRB, 0.36467690E-03_JPRB, 0.36473552E-03_JPRB, 0.36480412E-03_JPRB, &
  & 0.36487402E-03_JPRB, 0.36493677E-03_JPRB, 0.36498046E-03_JPRB, 0.36499181E-03_JPRB, 0.36495851E-03_JPRB, 0.36487510E-03_JPRB, &
  & 0.36474469E-03_JPRB, 0.36457583E-03_JPRB, 0.36437818E-03_JPRB, 0.36415854E-03_JPRB, 0.36392082E-03_JPRB, 0.36366802E-03_JPRB, &
  & 0.36340274E-03_JPRB, 0.36312939E-03_JPRB, 0.36285844E-03_JPRB, 0.36260005E-03_JPRB, 0.36235628E-03_JPRB, 0.36212642E-03_JPRB, &
  & 0.36191419E-03_JPRB, 0.36172650E-03_JPRB, 0.36156824E-03_JPRB, 0.36144038E-03_JPRB, 0.36134207E-03_JPRB, 0.36126922E-03_JPRB, &
  & 0.36121751E-03_JPRB, 0.36118255E-03_JPRB, 0.36115514E-03_JPRB, 0.36111331E-03_JPRB /)

RGHG1(:, 5, 3) = (/ &
  & 0.36348318E-03_JPRB, 0.36387870E-03_JPRB, 0.36404419E-03_JPRB, 0.36414718E-03_JPRB, 0.36422914E-03_JPRB, 0.36430469E-03_JPRB, &
  & 0.36437422E-03_JPRB, 0.36443514E-03_JPRB, 0.36449073E-03_JPRB, 0.36454407E-03_JPRB, 0.36459538E-03_JPRB, 0.36464393E-03_JPRB, &
  & 0.36468895E-03_JPRB, 0.36473013E-03_JPRB, 0.36476750E-03_JPRB, 0.36480205E-03_JPRB, 0.36483430E-03_JPRB, 0.36486515E-03_JPRB, &
  & 0.36489597E-03_JPRB, 0.36492801E-03_JPRB, 0.36496372E-03_JPRB, 0.36500613E-03_JPRB, 0.36505781E-03_JPRB, 0.36511754E-03_JPRB, &
  & 0.36518148E-03_JPRB, 0.36524431E-03_JPRB, 0.36530214E-03_JPRB, 0.36535284E-03_JPRB, 0.36539443E-03_JPRB, 0.36542426E-03_JPRB, &
  & 0.36544181E-03_JPRB, 0.36544877E-03_JPRB, 0.36545133E-03_JPRB, 0.36545709E-03_JPRB, 0.36547059E-03_JPRB, 0.36549100E-03_JPRB, &
  & 0.36551387E-03_JPRB, 0.36553046E-03_JPRB, 0.36552898E-03_JPRB, 0.36549414E-03_JPRB, 0.36541163E-03_JPRB, 0.36527737E-03_JPRB, &
  & 0.36510159E-03_JPRB, 0.36490505E-03_JPRB, 0.36470286E-03_JPRB, 0.36450170E-03_JPRB, 0.36430333E-03_JPRB, 0.36410647E-03_JPRB, &
  & 0.36390970E-03_JPRB, 0.36371351E-03_JPRB, 0.36351802E-03_JPRB, 0.36332168E-03_JPRB, 0.36312558E-03_JPRB, 0.36293594E-03_JPRB, &
  & 0.36275788E-03_JPRB, 0.36259321E-03_JPRB, 0.36244304E-03_JPRB, 0.36231073E-03_JPRB, 0.36219903E-03_JPRB, 0.36210855E-03_JPRB, &
  & 0.36203547E-03_JPRB, 0.36197252E-03_JPRB, 0.36191315E-03_JPRB, 0.36182781E-03_JPRB /)

RGHG1(:, 6, 3) = (/ &
  & 0.36396037E-03_JPRB, 0.36423429E-03_JPRB, 0.36433080E-03_JPRB, 0.36439401E-03_JPRB, 0.36444661E-03_JPRB, 0.36449768E-03_JPRB, &
  & 0.36455062E-03_JPRB, 0.36460449E-03_JPRB, 0.36465746E-03_JPRB, 0.36470965E-03_JPRB, 0.36476116E-03_JPRB, 0.36481113E-03_JPRB, &
  & 0.36485930E-03_JPRB, 0.36490534E-03_JPRB, 0.36495028E-03_JPRB, 0.36499504E-03_JPRB, 0.36504108E-03_JPRB, 0.36509073E-03_JPRB, &
  & 0.36514585E-03_JPRB, 0.36520924E-03_JPRB, 0.36528223E-03_JPRB, 0.36536652E-03_JPRB, 0.36546041E-03_JPRB, 0.36555898E-03_JPRB, &
  & 0.36565631E-03_JPRB, 0.36574659E-03_JPRB, 0.36582901E-03_JPRB, 0.36590284E-03_JPRB, 0.36596667E-03_JPRB, 0.36601856E-03_JPRB, &
  & 0.36605675E-03_JPRB, 0.36607977E-03_JPRB, 0.36608989E-03_JPRB, 0.36609205E-03_JPRB, 0.36608975E-03_JPRB, 0.36608378E-03_JPRB, &
  & 0.36607112E-03_JPRB, 0.36604475E-03_JPRB, 0.36599441E-03_JPRB, 0.36590695E-03_JPRB, 0.36577278E-03_JPRB, 0.36559481E-03_JPRB, &
  & 0.36539577E-03_JPRB, 0.36519635E-03_JPRB, 0.36500825E-03_JPRB, 0.36483284E-03_JPRB, 0.36466736E-03_JPRB, 0.36450854E-03_JPRB, &
  & 0.36435376E-03_JPRB, 0.36420077E-03_JPRB, 0.36404771E-03_JPRB, 0.36389509E-03_JPRB, 0.36374538E-03_JPRB, 0.36359869E-03_JPRB, &
  & 0.36345469E-03_JPRB, 0.36331604E-03_JPRB, 0.36318711E-03_JPRB, 0.36307104E-03_JPRB, 0.36297017E-03_JPRB, 0.36288457E-03_JPRB, &
  & 0.36281301E-03_JPRB, 0.36275256E-03_JPRB, 0.36269115E-03_JPRB, 0.36259613E-03_JPRB /)

RGHG1(:, 7, 3) = (/ &
  & 0.36428374E-03_JPRB, 0.36442408E-03_JPRB, 0.36448508E-03_JPRB, 0.36453627E-03_JPRB, 0.36458718E-03_JPRB, 0.36464111E-03_JPRB, &
  & 0.36469862E-03_JPRB, 0.36475912E-03_JPRB, 0.36482120E-03_JPRB, 0.36488369E-03_JPRB, 0.36494600E-03_JPRB, 0.36500616E-03_JPRB, &
  & 0.36506343E-03_JPRB, 0.36511768E-03_JPRB, 0.36516925E-03_JPRB, 0.36521969E-03_JPRB, 0.36527132E-03_JPRB, 0.36532676E-03_JPRB, &
  & 0.36538919E-03_JPRB, 0.36546143E-03_JPRB, 0.36554545E-03_JPRB, 0.36564260E-03_JPRB, 0.36575220E-03_JPRB, 0.36587074E-03_JPRB, &
  & 0.36598949E-03_JPRB, 0.36610360E-03_JPRB, 0.36620928E-03_JPRB, 0.36630625E-03_JPRB, 0.36639324E-03_JPRB, 0.36646781E-03_JPRB, &
  & 0.36652628E-03_JPRB, 0.36656598E-03_JPRB, 0.36658609E-03_JPRB, 0.36658871E-03_JPRB, 0.36657599E-03_JPRB, 0.36654909E-03_JPRB, &
  & 0.36650593E-03_JPRB, 0.36644167E-03_JPRB, 0.36634851E-03_JPRB, 0.36621859E-03_JPRB, 0.36604863E-03_JPRB, 0.36585270E-03_JPRB, &
  & 0.36565296E-03_JPRB, 0.36546704E-03_JPRB, 0.36529996E-03_JPRB, 0.36514952E-03_JPRB, 0.36501142E-03_JPRB, 0.36488075E-03_JPRB, &
  & 0.36475377E-03_JPRB, 0.36462821E-03_JPRB, 0.36450289E-03_JPRB, 0.36437786E-03_JPRB, 0.36425277E-03_JPRB, 0.36412873E-03_JPRB, &
  & 0.36400894E-03_JPRB, 0.36389611E-03_JPRB, 0.36379116E-03_JPRB, 0.36369552E-03_JPRB, 0.36361141E-03_JPRB, 0.36353990E-03_JPRB, &
  & 0.36347943E-03_JPRB, 0.36342489E-03_JPRB, 0.36337067E-03_JPRB, 0.36327998E-03_JPRB /)

RGHG1(:, 8, 3) = (/ &
  & 0.36446133E-03_JPRB, 0.36455900E-03_JPRB, 0.36461832E-03_JPRB, 0.36467405E-03_JPRB, 0.36473351E-03_JPRB, 0.36479832E-03_JPRB, &
  & 0.36486890E-03_JPRB, 0.36494405E-03_JPRB, 0.36502269E-03_JPRB, 0.36510333E-03_JPRB, 0.36518410E-03_JPRB, 0.36526262E-03_JPRB, &
  & 0.36533747E-03_JPRB, 0.36540700E-03_JPRB, 0.36547112E-03_JPRB, 0.36553101E-03_JPRB, 0.36558893E-03_JPRB, 0.36564798E-03_JPRB, &
  & 0.36571137E-03_JPRB, 0.36578267E-03_JPRB, 0.36586478E-03_JPRB, 0.36595960E-03_JPRB, 0.36606757E-03_JPRB, 0.36618518E-03_JPRB, &
  & 0.36630858E-03_JPRB, 0.36642913E-03_JPRB, 0.36654479E-03_JPRB, 0.36665110E-03_JPRB, 0.36674654E-03_JPRB, 0.36682712E-03_JPRB, &
  & 0.36688911E-03_JPRB, 0.36692817E-03_JPRB, 0.36694313E-03_JPRB, 0.36693492E-03_JPRB, 0.36690559E-03_JPRB, 0.36685664E-03_JPRB, &
  & 0.36678743E-03_JPRB, 0.36669461E-03_JPRB, 0.36657302E-03_JPRB, 0.36641883E-03_JPRB, 0.36623477E-03_JPRB, 0.36603562E-03_JPRB, &
  & 0.36584274E-03_JPRB, 0.36567176E-03_JPRB, 0.36552447E-03_JPRB, 0.36539644E-03_JPRB, 0.36528008E-03_JPRB, 0.36517062E-03_JPRB, &
  & 0.36506471E-03_JPRB, 0.36495965E-03_JPRB, 0.36485444E-03_JPRB, 0.36474847E-03_JPRB, 0.36464265E-03_JPRB, 0.36453898E-03_JPRB, &
  & 0.36443840E-03_JPRB, 0.36434177E-03_JPRB, 0.36425161E-03_JPRB, 0.36417018E-03_JPRB, 0.36409893E-03_JPRB, 0.36403822E-03_JPRB, &
  & 0.36398682E-03_JPRB, 0.36394253E-03_JPRB, 0.36389663E-03_JPRB, 0.36382666E-03_JPRB /)

RGHG1(:, 9, 3) = (/ &
  & 0.36458991E-03_JPRB, 0.36469765E-03_JPRB, 0.36476611E-03_JPRB, 0.36483267E-03_JPRB, 0.36490458E-03_JPRB, 0.36498468E-03_JPRB, &
  & 0.36507274E-03_JPRB, 0.36516838E-03_JPRB, 0.36526966E-03_JPRB, 0.36537452E-03_JPRB, 0.36548090E-03_JPRB, 0.36558602E-03_JPRB, &
  & 0.36568742E-03_JPRB, 0.36578233E-03_JPRB, 0.36586999E-03_JPRB, 0.36595057E-03_JPRB, 0.36602505E-03_JPRB, 0.36609595E-03_JPRB, &
  & 0.36616612E-03_JPRB, 0.36623917E-03_JPRB, 0.36631786E-03_JPRB, 0.36640410E-03_JPRB, 0.36649796E-03_JPRB, 0.36659883E-03_JPRB, &
  & 0.36670198E-03_JPRB, 0.36680492E-03_JPRB, 0.36690323E-03_JPRB, 0.36699523E-03_JPRB, 0.36707651E-03_JPRB, 0.36714232E-03_JPRB, &
  & 0.36718691E-03_JPRB, 0.36720594E-03_JPRB, 0.36719759E-03_JPRB, 0.36716304E-03_JPRB, 0.36710573E-03_JPRB, 0.36702838E-03_JPRB, &
  & 0.36693231E-03_JPRB, 0.36681633E-03_JPRB, 0.36667931E-03_JPRB, 0.36651845E-03_JPRB, 0.36633603E-03_JPRB, 0.36614513E-03_JPRB, &
  & 0.36596518E-03_JPRB, 0.36580587E-03_JPRB, 0.36566949E-03_JPRB, 0.36555089E-03_JPRB, 0.36544638E-03_JPRB, 0.36535106E-03_JPRB, &
  & 0.36526064E-03_JPRB, 0.36517222E-03_JPRB, 0.36508415E-03_JPRB, 0.36499571E-03_JPRB, 0.36490709E-03_JPRB, 0.36481873E-03_JPRB, &
  & 0.36473223E-03_JPRB, 0.36465007E-03_JPRB, 0.36457347E-03_JPRB, 0.36450362E-03_JPRB, 0.36444247E-03_JPRB, 0.36439107E-03_JPRB, &
  & 0.36434864E-03_JPRB, 0.36431118E-03_JPRB, 0.36427498E-03_JPRB, 0.36421709E-03_JPRB /)

RGHG1(:,10, 3) = (/ &
  & 0.36473729E-03_JPRB, 0.36486372E-03_JPRB, 0.36494661E-03_JPRB, 0.36502650E-03_JPRB, 0.36511343E-03_JPRB, 0.36521049E-03_JPRB, &
  & 0.36531786E-03_JPRB, 0.36543421E-03_JPRB, 0.36555846E-03_JPRB, 0.36568838E-03_JPRB, 0.36582196E-03_JPRB, 0.36595552E-03_JPRB, &
  & 0.36608588E-03_JPRB, 0.36621056E-03_JPRB, 0.36632791E-03_JPRB, 0.36643705E-03_JPRB, 0.36653777E-03_JPRB, 0.36663096E-03_JPRB, &
  & 0.36671729E-03_JPRB, 0.36679913E-03_JPRB, 0.36687768E-03_JPRB, 0.36695460E-03_JPRB, 0.36703012E-03_JPRB, 0.36710399E-03_JPRB, &
  & 0.36717564E-03_JPRB, 0.36724377E-03_JPRB, 0.36730772E-03_JPRB, 0.36736514E-03_JPRB, 0.36741266E-03_JPRB, 0.36744482E-03_JPRB, &
  & 0.36745527E-03_JPRB, 0.36743865E-03_JPRB, 0.36739270E-03_JPRB, 0.36731959E-03_JPRB, 0.36722410E-03_JPRB, 0.36711208E-03_JPRB, &
  & 0.36698752E-03_JPRB, 0.36685230E-03_JPRB, 0.36670361E-03_JPRB, 0.36654243E-03_JPRB, 0.36636961E-03_JPRB, 0.36618931E-03_JPRB, &
  & 0.36601140E-03_JPRB, 0.36585075E-03_JPRB, 0.36571352E-03_JPRB, 0.36560025E-03_JPRB, 0.36550398E-03_JPRB, 0.36541885E-03_JPRB, &
  & 0.36534047E-03_JPRB, 0.36526585E-03_JPRB, 0.36519283E-03_JPRB, 0.36511975E-03_JPRB, 0.36504626E-03_JPRB, 0.36497315E-03_JPRB, &
  & 0.36490144E-03_JPRB, 0.36483235E-03_JPRB, 0.36476753E-03_JPRB, 0.36470941E-03_JPRB, 0.36465912E-03_JPRB, 0.36461774E-03_JPRB, &
  & 0.36458354E-03_JPRB, 0.36455542E-03_JPRB, 0.36452725E-03_JPRB, 0.36448587E-03_JPRB /)

RGHG1(:,11, 3) = (/ &
  & 0.36492647E-03_JPRB, 0.36508421E-03_JPRB, 0.36518590E-03_JPRB, 0.36528235E-03_JPRB, 0.36538474E-03_JPRB, 0.36549728E-03_JPRB, &
  & 0.36562060E-03_JPRB, 0.36575392E-03_JPRB, 0.36589574E-03_JPRB, 0.36604379E-03_JPRB, 0.36619604E-03_JPRB, 0.36634953E-03_JPRB, &
  & 0.36650244E-03_JPRB, 0.36665142E-03_JPRB, 0.36679424E-03_JPRB, 0.36692960E-03_JPRB, 0.36705608E-03_JPRB, 0.36717195E-03_JPRB, &
  & 0.36727631E-03_JPRB, 0.36736878E-03_JPRB, 0.36744939E-03_JPRB, 0.36751898E-03_JPRB, 0.36757858E-03_JPRB, 0.36762856E-03_JPRB, &
  & 0.36766983E-03_JPRB, 0.36770327E-03_JPRB, 0.36772928E-03_JPRB, 0.36774704E-03_JPRB, 0.36775391E-03_JPRB, 0.36774459E-03_JPRB, &
  & 0.36771342E-03_JPRB, 0.36765545E-03_JPRB, 0.36756779E-03_JPRB, 0.36745219E-03_JPRB, 0.36731400E-03_JPRB, 0.36716333E-03_JPRB, &
  & 0.36700757E-03_JPRB, 0.36685154E-03_JPRB, 0.36669828E-03_JPRB, 0.36653897E-03_JPRB, 0.36636944E-03_JPRB, 0.36619266E-03_JPRB, &
  & 0.36601792E-03_JPRB, 0.36585543E-03_JPRB, 0.36571414E-03_JPRB, 0.36559484E-03_JPRB, 0.36549623E-03_JPRB, 0.36541323E-03_JPRB, &
  & 0.36534021E-03_JPRB, 0.36527324E-03_JPRB, 0.36520962E-03_JPRB, 0.36514754E-03_JPRB, 0.36508610E-03_JPRB, 0.36502528E-03_JPRB, &
  & 0.36496576E-03_JPRB, 0.36490915E-03_JPRB, 0.36485732E-03_JPRB, 0.36481145E-03_JPRB, 0.36477286E-03_JPRB, 0.36474154E-03_JPRB, &
  & 0.36471742E-03_JPRB, 0.36469652E-03_JPRB, 0.36467792E-03_JPRB, 0.36465030E-03_JPRB /)

RGHG1(:,12, 3) = (/ &
  & 0.36519940E-03_JPRB, 0.36539894E-03_JPRB, 0.36552924E-03_JPRB, 0.36563945E-03_JPRB, 0.36575476E-03_JPRB, 0.36587549E-03_JPRB, &
  & 0.36600436E-03_JPRB, 0.36614138E-03_JPRB, 0.36628623E-03_JPRB, 0.36643803E-03_JPRB, 0.36659543E-03_JPRB, 0.36675620E-03_JPRB, &
  & 0.36691772E-03_JPRB, 0.36707780E-03_JPRB, 0.36723437E-03_JPRB, 0.36738437E-03_JPRB, 0.36752541E-03_JPRB, 0.36765559E-03_JPRB, &
  & 0.36777058E-03_JPRB, 0.36786991E-03_JPRB, 0.36795155E-03_JPRB, 0.36801683E-03_JPRB, 0.36806546E-03_JPRB, 0.36809966E-03_JPRB, &
  & 0.36812003E-03_JPRB, 0.36812807E-03_JPRB, 0.36812446E-03_JPRB, 0.36810900E-03_JPRB, 0.36807969E-03_JPRB, 0.36803295E-03_JPRB, &
  & 0.36796462E-03_JPRB, 0.36787073E-03_JPRB, 0.36774980E-03_JPRB, 0.36760239E-03_JPRB, 0.36743557E-03_JPRB, 0.36725792E-03_JPRB, &
  & 0.36708027E-03_JPRB, 0.36691039E-03_JPRB, 0.36674677E-03_JPRB, 0.36658806E-03_JPRB, 0.36642671E-03_JPRB, 0.36625852E-03_JPRB, &
  & 0.36608570E-03_JPRB, 0.36591737E-03_JPRB, 0.36576332E-03_JPRB, 0.36563104E-03_JPRB, 0.36551943E-03_JPRB, 0.36542502E-03_JPRB, &
  & 0.36534280E-03_JPRB, 0.36526931E-03_JPRB, 0.36520162E-03_JPRB, 0.36513797E-03_JPRB, 0.36507731E-03_JPRB, 0.36501943E-03_JPRB, &
  & 0.36496500E-03_JPRB, 0.36491532E-03_JPRB, 0.36487126E-03_JPRB, 0.36483404E-03_JPRB, 0.36480383E-03_JPRB, 0.36478060E-03_JPRB, &
  & 0.36476238E-03_JPRB, 0.36474882E-03_JPRB, 0.36473639E-03_JPRB, 0.36472143E-03_JPRB /)

RGHG1(:,13, 3) = (/ &
  & 0.36560048E-03_JPRB, 0.36584510E-03_JPRB, 0.36598934E-03_JPRB, 0.36610500E-03_JPRB, 0.36621821E-03_JPRB, 0.36633338E-03_JPRB, &
  & 0.36645349E-03_JPRB, 0.36658003E-03_JPRB, 0.36671400E-03_JPRB, 0.36685521E-03_JPRB, 0.36700410E-03_JPRB, 0.36715862E-03_JPRB, &
  & 0.36731668E-03_JPRB, 0.36747492E-03_JPRB, 0.36763141E-03_JPRB, 0.36778318E-03_JPRB, 0.36792611E-03_JPRB, 0.36805798E-03_JPRB, &
  & 0.36817443E-03_JPRB, 0.36827376E-03_JPRB, 0.36835403E-03_JPRB, 0.36841509E-03_JPRB, 0.36845749E-03_JPRB, 0.36848214E-03_JPRB, &
  & 0.36849029E-03_JPRB, 0.36848307E-03_JPRB, 0.36846084E-03_JPRB, 0.36842321E-03_JPRB, 0.36836881E-03_JPRB, 0.36829599E-03_JPRB, &
  & 0.36820234E-03_JPRB, 0.36808554E-03_JPRB, 0.36794561E-03_JPRB, 0.36778455E-03_JPRB, 0.36760763E-03_JPRB, 0.36742663E-03_JPRB, &
  & 0.36725245E-03_JPRB, 0.36709209E-03_JPRB, 0.36694508E-03_JPRB, 0.36680483E-03_JPRB, 0.36666519E-03_JPRB, 0.36652019E-03_JPRB, &
  & 0.36636487E-03_JPRB, 0.36620162E-03_JPRB, 0.36603847E-03_JPRB, 0.36588189E-03_JPRB, 0.36573922E-03_JPRB, 0.36561157E-03_JPRB, &
  & 0.36549749E-03_JPRB, 0.36539399E-03_JPRB, 0.36529879E-03_JPRB, 0.36521067E-03_JPRB, 0.36512900E-03_JPRB, 0.36505377E-03_JPRB, &
  & 0.36498584E-03_JPRB, 0.36492650E-03_JPRB, 0.36487626E-03_JPRB, 0.36483529E-03_JPRB, 0.36480342E-03_JPRB, 0.36477932E-03_JPRB, &
  & 0.36476227E-03_JPRB, 0.36474899E-03_JPRB, 0.36473927E-03_JPRB, 0.36472909E-03_JPRB /)

RGHG1(:,14, 3) = (/ &
  & 0.36611620E-03_JPRB, 0.36636903E-03_JPRB, 0.36650430E-03_JPRB, 0.36661088E-03_JPRB, 0.36671059E-03_JPRB, 0.36681109E-03_JPRB, &
  & 0.36691572E-03_JPRB, 0.36702593E-03_JPRB, 0.36714307E-03_JPRB, 0.36726805E-03_JPRB, 0.36740085E-03_JPRB, 0.36754014E-03_JPRB, &
  & 0.36768473E-03_JPRB, 0.36783190E-03_JPRB, 0.36797888E-03_JPRB, 0.36812236E-03_JPRB, 0.36825862E-03_JPRB, 0.36838441E-03_JPRB, &
  & 0.36849617E-03_JPRB, 0.36859122E-03_JPRB, 0.36866721E-03_JPRB, 0.36872400E-03_JPRB, 0.36876113E-03_JPRB, 0.36877970E-03_JPRB, &
  & 0.36878049E-03_JPRB, 0.36876468E-03_JPRB, 0.36873249E-03_JPRB, 0.36868328E-03_JPRB, 0.36861666E-03_JPRB, 0.36853162E-03_JPRB, &
  & 0.36842749E-03_JPRB, 0.36830441E-03_JPRB, 0.36816410E-03_JPRB, 0.36800973E-03_JPRB, 0.36784861E-03_JPRB, 0.36769122E-03_JPRB, &
  & 0.36754739E-03_JPRB, 0.36742204E-03_JPRB, 0.36731231E-03_JPRB, 0.36721068E-03_JPRB, 0.36711062E-03_JPRB, 0.36700442E-03_JPRB, &
  & 0.36688196E-03_JPRB, 0.36674022E-03_JPRB, 0.36658143E-03_JPRB, 0.36641140E-03_JPRB, 0.36623902E-03_JPRB, 0.36607269E-03_JPRB, &
  & 0.36591646E-03_JPRB, 0.36577060E-03_JPRB, 0.36563366E-03_JPRB, 0.36550447E-03_JPRB, 0.36538264E-03_JPRB, 0.36526925E-03_JPRB, &
  & 0.36516594E-03_JPRB, 0.36507449E-03_JPRB, 0.36499632E-03_JPRB, 0.36493147E-03_JPRB, 0.36488014E-03_JPRB, 0.36484140E-03_JPRB, &
  & 0.36481183E-03_JPRB, 0.36479003E-03_JPRB, 0.36477120E-03_JPRB, 0.36475065E-03_JPRB /)

RGHG1(:,15, 3) = (/ &
  & 0.36665826E-03_JPRB, 0.36688009E-03_JPRB, 0.36699278E-03_JPRB, 0.36708379E-03_JPRB, 0.36716973E-03_JPRB, 0.36725658E-03_JPRB, &
  & 0.36734695E-03_JPRB, 0.36744244E-03_JPRB, 0.36754401E-03_JPRB, 0.36765277E-03_JPRB, 0.36776892E-03_JPRB, 0.36789160E-03_JPRB, &
  & 0.36801910E-03_JPRB, 0.36814949E-03_JPRB, 0.36828153E-03_JPRB, 0.36841162E-03_JPRB, 0.36853686E-03_JPRB, 0.36865330E-03_JPRB, &
  & 0.36875746E-03_JPRB, 0.36884611E-03_JPRB, 0.36891692E-03_JPRB, 0.36896879E-03_JPRB, 0.36900165E-03_JPRB, 0.36901628E-03_JPRB, &
  & 0.36901297E-03_JPRB, 0.36899259E-03_JPRB, 0.36895552E-03_JPRB, 0.36890220E-03_JPRB, 0.36883214E-03_JPRB, 0.36874527E-03_JPRB, &
  & 0.36864256E-03_JPRB, 0.36852557E-03_JPRB, 0.36839821E-03_JPRB, 0.36826567E-03_JPRB, 0.36813444E-03_JPRB, 0.36801380E-03_JPRB, &
  & 0.36791110E-03_JPRB, 0.36782859E-03_JPRB, 0.36776165E-03_JPRB, 0.36770239E-03_JPRB, 0.36764340E-03_JPRB, 0.36757480E-03_JPRB, &
  & 0.36748746E-03_JPRB, 0.36737538E-03_JPRB, 0.36723589E-03_JPRB, 0.36707253E-03_JPRB, 0.36689517E-03_JPRB, 0.36671423E-03_JPRB, &
  & 0.36653655E-03_JPRB, 0.36636530E-03_JPRB, 0.36620055E-03_JPRB, 0.36604074E-03_JPRB, 0.36588527E-03_JPRB, 0.36573454E-03_JPRB, &
  & 0.36559135E-03_JPRB, 0.36545936E-03_JPRB, 0.36534117E-03_JPRB, 0.36523893E-03_JPRB, 0.36515406E-03_JPRB, 0.36508578E-03_JPRB, &
  & 0.36503287E-03_JPRB, 0.36498884E-03_JPRB, 0.36495001E-03_JPRB, 0.36489713E-03_JPRB /)

RGHG1(:,16, 3) = (/ &
  & 0.36713385E-03_JPRB, 0.36732035E-03_JPRB, 0.36741694E-03_JPRB, 0.36749590E-03_JPRB, 0.36757189E-03_JPRB, 0.36764951E-03_JPRB, &
  & 0.36773056E-03_JPRB, 0.36781671E-03_JPRB, 0.36790842E-03_JPRB, 0.36800577E-03_JPRB, 0.36810842E-03_JPRB, 0.36821587E-03_JPRB, &
  & 0.36832676E-03_JPRB, 0.36843971E-03_JPRB, 0.36855432E-03_JPRB, 0.36866855E-03_JPRB, 0.36878022E-03_JPRB, 0.36888567E-03_JPRB, &
  & 0.36898133E-03_JPRB, 0.36906297E-03_JPRB, 0.36912828E-03_JPRB, 0.36917554E-03_JPRB, 0.36920491E-03_JPRB, 0.36921672E-03_JPRB, &
  & 0.36921131E-03_JPRB, 0.36918966E-03_JPRB, 0.36915287E-03_JPRB, 0.36910025E-03_JPRB, 0.36903209E-03_JPRB, 0.36895002E-03_JPRB, &
  & 0.36885610E-03_JPRB, 0.36875246E-03_JPRB, 0.36864416E-03_JPRB, 0.36853735E-03_JPRB, 0.36843916E-03_JPRB, 0.36835633E-03_JPRB, &
  & 0.36829332E-03_JPRB, 0.36824957E-03_JPRB, 0.36821951E-03_JPRB, 0.36819463E-03_JPRB, 0.36816567E-03_JPRB, 0.36812478E-03_JPRB, &
  & 0.36806407E-03_JPRB, 0.36797696E-03_JPRB, 0.36785999E-03_JPRB, 0.36771566E-03_JPRB, 0.36755242E-03_JPRB, 0.36738033E-03_JPRB, &
  & 0.36720734E-03_JPRB, 0.36703696E-03_JPRB, 0.36686947E-03_JPRB, 0.36670303E-03_JPRB, 0.36653620E-03_JPRB, 0.36636950E-03_JPRB, &
  & 0.36620532E-03_JPRB, 0.36604729E-03_JPRB, 0.36590011E-03_JPRB, 0.36576737E-03_JPRB, 0.36565232E-03_JPRB, 0.36555727E-03_JPRB, &
  & 0.36547845E-03_JPRB, 0.36541227E-03_JPRB, 0.36534757E-03_JPRB, 0.36525592E-03_JPRB /)

RGHG1(:,17, 3) = (/ &
  & 0.36752879E-03_JPRB, 0.36769180E-03_JPRB, 0.36777838E-03_JPRB, 0.36785175E-03_JPRB, 0.36792326E-03_JPRB, 0.36799748E-03_JPRB, &
  & 0.36807486E-03_JPRB, 0.36815574E-03_JPRB, 0.36824046E-03_JPRB, 0.36832932E-03_JPRB, 0.36842146E-03_JPRB, 0.36851634E-03_JPRB, &
  & 0.36861314E-03_JPRB, 0.36871148E-03_JPRB, 0.36881011E-03_JPRB, 0.36890895E-03_JPRB, 0.36900621E-03_JPRB, 0.36909961E-03_JPRB, &
  & 0.36918549E-03_JPRB, 0.36925945E-03_JPRB, 0.36931882E-03_JPRB, 0.36936163E-03_JPRB, 0.36938774E-03_JPRB, 0.36939772E-03_JPRB, &
  & 0.36939219E-03_JPRB, 0.36937237E-03_JPRB, 0.36933742E-03_JPRB, 0.36929012E-03_JPRB, 0.36923157E-03_JPRB, 0.36916154E-03_JPRB, &
  & 0.36908139E-03_JPRB, 0.36899603E-03_JPRB, 0.36891006E-03_JPRB, 0.36882950E-03_JPRB, 0.36876072E-03_JPRB, 0.36870941E-03_JPRB, &
  & 0.36867708E-03_JPRB, 0.36866078E-03_JPRB, 0.36865385E-03_JPRB, 0.36864792E-03_JPRB, 0.36863540E-03_JPRB, 0.36860991E-03_JPRB, &
  & 0.36856480E-03_JPRB, 0.36849407E-03_JPRB, 0.36839506E-03_JPRB, 0.36827015E-03_JPRB, 0.36812635E-03_JPRB, 0.36797268E-03_JPRB, &
  & 0.36781619E-03_JPRB, 0.36766005E-03_JPRB, 0.36750498E-03_JPRB, 0.36734913E-03_JPRB, 0.36719081E-03_JPRB, 0.36702969E-03_JPRB, &
  & 0.36686746E-03_JPRB, 0.36670777E-03_JPRB, 0.36655448E-03_JPRB, 0.36641292E-03_JPRB, 0.36628760E-03_JPRB, 0.36618041E-03_JPRB, &
  & 0.36609065E-03_JPRB, 0.36601137E-03_JPRB, 0.36593215E-03_JPRB, 0.36581379E-03_JPRB /)

RGHG1(:,18, 3) = (/ &
  & 0.36785656E-03_JPRB, 0.36800560E-03_JPRB, 0.36808869E-03_JPRB, 0.36815935E-03_JPRB, 0.36822871E-03_JPRB, 0.36830036E-03_JPRB, &
  & 0.36837542E-03_JPRB, 0.36845374E-03_JPRB, 0.36853491E-03_JPRB, 0.36861870E-03_JPRB, 0.36870473E-03_JPRB, 0.36879125E-03_JPRB, &
  & 0.36887784E-03_JPRB, 0.36896480E-03_JPRB, 0.36905109E-03_JPRB, 0.36913698E-03_JPRB, 0.36922138E-03_JPRB, 0.36930258E-03_JPRB, &
  & 0.36937787E-03_JPRB, 0.36944350E-03_JPRB, 0.36949656E-03_JPRB, 0.36953486E-03_JPRB, 0.36955826E-03_JPRB, 0.36956710E-03_JPRB, &
  & 0.36956248E-03_JPRB, 0.36954533E-03_JPRB, 0.36951748E-03_JPRB, 0.36948128E-03_JPRB, 0.36943352E-03_JPRB, 0.36937842E-03_JPRB, &
  & 0.36931827E-03_JPRB, 0.36925587E-03_JPRB, 0.36919513E-03_JPRB, 0.36914091E-03_JPRB, 0.36909842E-03_JPRB, 0.36907097E-03_JPRB, &
  & 0.36905802E-03_JPRB, 0.36905671E-03_JPRB, 0.36905953E-03_JPRB, 0.36906029E-03_JPRB, 0.36905202E-03_JPRB, 0.36902976E-03_JPRB, &
  & 0.36898829E-03_JPRB, 0.36892373E-03_JPRB, 0.36883444E-03_JPRB, 0.36872271E-03_JPRB, 0.36859495E-03_JPRB, 0.36845845E-03_JPRB, &
  & 0.36831893E-03_JPRB, 0.36817967E-03_JPRB, 0.36804070E-03_JPRB, 0.36790082E-03_JPRB, 0.36775850E-03_JPRB, 0.36761328E-03_JPRB, &
  & 0.36746598E-03_JPRB, 0.36731982E-03_JPRB, 0.36717844E-03_JPRB, 0.36704619E-03_JPRB, 0.36692797E-03_JPRB, 0.36682648E-03_JPRB, &
  & 0.36673993E-03_JPRB, 0.36666216E-03_JPRB, 0.36658419E-03_JPRB, 0.36646068E-03_JPRB /)

RGHG1(:,19, 3) = (/ &
  & 0.36813383E-03_JPRB, 0.36827472E-03_JPRB, 0.36835417E-03_JPRB, 0.36842315E-03_JPRB, 0.36849128E-03_JPRB, 0.36856177E-03_JPRB, &
  & 0.36863549E-03_JPRB, 0.36871285E-03_JPRB, 0.36879280E-03_JPRB, 0.36887461E-03_JPRB, 0.36895779E-03_JPRB, 0.36903971E-03_JPRB, &
  & 0.36911981E-03_JPRB, 0.36919862E-03_JPRB, 0.36927548E-03_JPRB, 0.36935110E-03_JPRB, 0.36942470E-03_JPRB, 0.36949490E-03_JPRB, &
  & 0.36956003E-03_JPRB, 0.36961708E-03_JPRB, 0.36966323E-03_JPRB, 0.36969699E-03_JPRB, 0.36971754E-03_JPRB, 0.36972587E-03_JPRB, &
  & 0.36972322E-03_JPRB, 0.36971099E-03_JPRB, 0.36969251E-03_JPRB, 0.36966451E-03_JPRB, 0.36963299E-03_JPRB, 0.36959711E-03_JPRB, &
  & 0.36955913E-03_JPRB, 0.36952191E-03_JPRB, 0.36948713E-03_JPRB, 0.36945808E-03_JPRB, 0.36943797E-03_JPRB, 0.36942723E-03_JPRB, &
  & 0.36942479E-03_JPRB, 0.36942758E-03_JPRB, 0.36943058E-03_JPRB, 0.36942743E-03_JPRB, 0.36941422E-03_JPRB, 0.36938695E-03_JPRB, &
  & 0.36934231E-03_JPRB, 0.36927749E-03_JPRB, 0.36919204E-03_JPRB, 0.36908797E-03_JPRB, 0.36897120E-03_JPRB, 0.36884783E-03_JPRB, &
  & 0.36872274E-03_JPRB, 0.36859798E-03_JPRB, 0.36847370E-03_JPRB, 0.36834911E-03_JPRB, 0.36822338E-03_JPRB, 0.36809631E-03_JPRB, &
  & 0.36796828E-03_JPRB, 0.36784128E-03_JPRB, 0.36771808E-03_JPRB, 0.36760262E-03_JPRB, 0.36749904E-03_JPRB, 0.36740955E-03_JPRB, &
  & 0.36733237E-03_JPRB, 0.36726429E-03_JPRB, 0.36719209E-03_JPRB, 0.36708466E-03_JPRB /)

RGHG1(:,20, 3) = (/ &
  & 0.36836913E-03_JPRB, 0.36850307E-03_JPRB, 0.36857999E-03_JPRB, 0.36864821E-03_JPRB, 0.36871602E-03_JPRB, 0.36878607E-03_JPRB, &
  & 0.36885907E-03_JPRB, 0.36893549E-03_JPRB, 0.36901468E-03_JPRB, 0.36909513E-03_JPRB, 0.36917627E-03_JPRB, 0.36925561E-03_JPRB, &
  & 0.36933192E-03_JPRB, 0.36940558E-03_JPRB, 0.36947615E-03_JPRB, 0.36954405E-03_JPRB, 0.36960936E-03_JPRB, 0.36967089E-03_JPRB, &
  & 0.36972747E-03_JPRB, 0.36977691E-03_JPRB, 0.36981713E-03_JPRB, 0.36984682E-03_JPRB, 0.36986551E-03_JPRB, 0.36987368E-03_JPRB, &
  & 0.36987287E-03_JPRB, 0.36986577E-03_JPRB, 0.36985247E-03_JPRB, 0.36983736E-03_JPRB, 0.36982098E-03_JPRB, 0.36980477E-03_JPRB, &
  & 0.36978914E-03_JPRB, 0.36977491E-03_JPRB, 0.36976344E-03_JPRB, 0.36975573E-03_JPRB, 0.36975220E-03_JPRB, 0.36975279E-03_JPRB, &
  & 0.36975590E-03_JPRB, 0.36975773E-03_JPRB, 0.36975450E-03_JPRB, 0.36974272E-03_JPRB, 0.36971987E-03_JPRB, 0.36968378E-03_JPRB, &
  & 0.36963256E-03_JPRB, 0.36956434E-03_JPRB, 0.36947938E-03_JPRB, 0.36938032E-03_JPRB, 0.36927196E-03_JPRB, 0.36915918E-03_JPRB, &
  & 0.36904510E-03_JPRB, 0.36893180E-03_JPRB, 0.36881975E-03_JPRB, 0.36870909E-03_JPRB, 0.36859896E-03_JPRB, 0.36848924E-03_JPRB, &
  & 0.36838005E-03_JPRB, 0.36827248E-03_JPRB, 0.36816840E-03_JPRB, 0.36807047E-03_JPRB, 0.36798202E-03_JPRB, 0.36790513E-03_JPRB, &
  & 0.36783950E-03_JPRB, 0.36777850E-03_JPRB, 0.36771872E-03_JPRB, 0.36762041E-03_JPRB /)

RGHG1(:,21, 3) = (/ &
  & 0.36857164E-03_JPRB, 0.36870010E-03_JPRB, 0.36877379E-03_JPRB, 0.36883916E-03_JPRB, 0.36890505E-03_JPRB, 0.36897394E-03_JPRB, &
  & 0.36904644E-03_JPRB, 0.36912216E-03_JPRB, 0.36920042E-03_JPRB, 0.36927988E-03_JPRB, 0.36935939E-03_JPRB, 0.36943718E-03_JPRB, &
  & 0.36951122E-03_JPRB, 0.36958166E-03_JPRB, 0.36964868E-03_JPRB, 0.36971160E-03_JPRB, 0.36977083E-03_JPRB, 0.36982610E-03_JPRB, &
  & 0.36987651E-03_JPRB, 0.36992051E-03_JPRB, 0.36995663E-03_JPRB, 0.36998390E-03_JPRB, 0.37000186E-03_JPRB, 0.37001117E-03_JPRB, &
  & 0.37001341E-03_JPRB, 0.37000980E-03_JPRB, 0.37000416E-03_JPRB, 0.36999898E-03_JPRB, 0.36999513E-03_JPRB, 0.36999385E-03_JPRB, &
  & 0.36999583E-03_JPRB, 0.37000008E-03_JPRB, 0.37000672E-03_JPRB, 0.37001405E-03_JPRB, 0.37002165E-03_JPRB, 0.37002799E-03_JPRB, &
  & 0.37003105E-03_JPRB, 0.37002788E-03_JPRB, 0.37001676E-03_JPRB, 0.36999577E-03_JPRB, 0.36996361E-03_JPRB, 0.36991938E-03_JPRB, &
  & 0.36986216E-03_JPRB, 0.36979126E-03_JPRB, 0.36970712E-03_JPRB, 0.36961262E-03_JPRB, 0.36951125E-03_JPRB, 0.36940663E-03_JPRB, &
  & 0.36930203E-03_JPRB, 0.36919935E-03_JPRB, 0.36909891E-03_JPRB, 0.36900095E-03_JPRB, 0.36890508E-03_JPRB, 0.36881096E-03_JPRB, &
  & 0.36871864E-03_JPRB, 0.36862827E-03_JPRB, 0.36854087E-03_JPRB, 0.36845799E-03_JPRB, 0.36838237E-03_JPRB, 0.36831587E-03_JPRB, &
  & 0.36825702E-03_JPRB, 0.36820507E-03_JPRB, 0.36814855E-03_JPRB, 0.36806567E-03_JPRB /)

RGHG1(:,22, 3) = (/ &
  & 0.36874652E-03_JPRB, 0.36886689E-03_JPRB, 0.36893872E-03_JPRB, 0.36900226E-03_JPRB, 0.36906591E-03_JPRB, 0.36913258E-03_JPRB, &
  & 0.36920316E-03_JPRB, 0.36927735E-03_JPRB, 0.36935421E-03_JPRB, 0.36943209E-03_JPRB, 0.36950994E-03_JPRB, 0.36958596E-03_JPRB, &
  & 0.36965834E-03_JPRB, 0.36972685E-03_JPRB, 0.36979120E-03_JPRB, 0.36985145E-03_JPRB, 0.36990765E-03_JPRB, 0.36995937E-03_JPRB, &
  & 0.37000616E-03_JPRB, 0.37004720E-03_JPRB, 0.37008122E-03_JPRB, 0.37010765E-03_JPRB, 0.37012639E-03_JPRB, 0.37013798E-03_JPRB, &
  & 0.37014284E-03_JPRB, 0.37014406E-03_JPRB, 0.37014441E-03_JPRB, 0.37014575E-03_JPRB, 0.37015026E-03_JPRB, 0.37015881E-03_JPRB, &
  & 0.37017127E-03_JPRB, 0.37018684E-03_JPRB, 0.37020337E-03_JPRB, 0.37021874E-03_JPRB, 0.37023131E-03_JPRB, 0.37023897E-03_JPRB, &
  & 0.37023961E-03_JPRB, 0.37023160E-03_JPRB, 0.37021391E-03_JPRB, 0.37018582E-03_JPRB, 0.37014732E-03_JPRB, 0.37009781E-03_JPRB, &
  & 0.37003742E-03_JPRB, 0.36996606E-03_JPRB, 0.36988474E-03_JPRB, 0.36979542E-03_JPRB, 0.36970089E-03_JPRB, 0.36960491E-03_JPRB, &
  & 0.36951009E-03_JPRB, 0.36941745E-03_JPRB, 0.36932790E-03_JPRB, 0.36924166E-03_JPRB, 0.36915828E-03_JPRB, 0.36907761E-03_JPRB, &
  & 0.36899911E-03_JPRB, 0.36892266E-03_JPRB, 0.36884850E-03_JPRB, 0.36877760E-03_JPRB, 0.36871168E-03_JPRB, 0.36865234E-03_JPRB, &
  & 0.36860001E-03_JPRB, 0.36855042E-03_JPRB, 0.36850135E-03_JPRB, 0.36842108E-03_JPRB /)

RGHG1(:,23, 3) = (/ &
  & 0.36889751E-03_JPRB, 0.36901186E-03_JPRB, 0.36907895E-03_JPRB, 0.36913966E-03_JPRB, 0.36920124E-03_JPRB, 0.36926585E-03_JPRB, &
  & 0.36933427E-03_JPRB, 0.36940654E-03_JPRB, 0.36948128E-03_JPRB, 0.36955727E-03_JPRB, 0.36963314E-03_JPRB, 0.36970738E-03_JPRB, &
  & 0.36977866E-03_JPRB, 0.36984586E-03_JPRB, 0.36990867E-03_JPRB, 0.36996728E-03_JPRB, 0.37002171E-03_JPRB, 0.37007179E-03_JPRB, &
  & 0.37011708E-03_JPRB, 0.37015707E-03_JPRB, 0.37019083E-03_JPRB, 0.37021801E-03_JPRB, 0.37023853E-03_JPRB, 0.37025273E-03_JPRB, &
  & 0.37026129E-03_JPRB, 0.37026656E-03_JPRB, 0.37027098E-03_JPRB, 0.37027663E-03_JPRB, 0.37028606E-03_JPRB, 0.37029941E-03_JPRB, &
  & 0.37031726E-03_JPRB, 0.37033757E-03_JPRB, 0.37035765E-03_JPRB, 0.37037529E-03_JPRB, 0.37038792E-03_JPRB, 0.37039336E-03_JPRB, &
  & 0.37039033E-03_JPRB, 0.37037765E-03_JPRB, 0.37035509E-03_JPRB, 0.37032261E-03_JPRB, 0.37028035E-03_JPRB, 0.37022884E-03_JPRB, &
  & 0.37016862E-03_JPRB, 0.37009967E-03_JPRB, 0.37002287E-03_JPRB, 0.36993963E-03_JPRB, 0.36985299E-03_JPRB, 0.36976609E-03_JPRB, &
  & 0.36968046E-03_JPRB, 0.36959731E-03_JPRB, 0.36951801E-03_JPRB, 0.36944219E-03_JPRB, 0.36936987E-03_JPRB, 0.36930040E-03_JPRB, &
  & 0.36923314E-03_JPRB, 0.36916760E-03_JPRB, 0.36910336E-03_JPRB, 0.36904111E-03_JPRB, 0.36898238E-03_JPRB, 0.36892836E-03_JPRB, &
  & 0.36887871E-03_JPRB, 0.36883313E-03_JPRB, 0.36878331E-03_JPRB, 0.36870845E-03_JPRB /)

RGHG1(:,24, 3) = (/ &
  & 0.36903089E-03_JPRB, 0.36913785E-03_JPRB, 0.36920200E-03_JPRB, 0.36925927E-03_JPRB, 0.36931768E-03_JPRB, 0.36937959E-03_JPRB, &
  & 0.36944557E-03_JPRB, 0.36951518E-03_JPRB, 0.36958733E-03_JPRB, 0.36966070E-03_JPRB, 0.36973419E-03_JPRB, 0.36980654E-03_JPRB, &
  & 0.36987624E-03_JPRB, 0.36994246E-03_JPRB, 0.37000474E-03_JPRB, 0.37006289E-03_JPRB, 0.37011653E-03_JPRB, 0.37016606E-03_JPRB, &
  & 0.37021129E-03_JPRB, 0.37025151E-03_JPRB, 0.37028626E-03_JPRB, 0.37031519E-03_JPRB, 0.37033792E-03_JPRB, 0.37035509E-03_JPRB, &
  & 0.37036708E-03_JPRB, 0.37037575E-03_JPRB, 0.37038323E-03_JPRB, 0.37039202E-03_JPRB, 0.37040364E-03_JPRB, 0.37041909E-03_JPRB, &
  & 0.37043824E-03_JPRB, 0.37045876E-03_JPRB, 0.37047826E-03_JPRB, 0.37049429E-03_JPRB, 0.37050422E-03_JPRB, 0.37050611E-03_JPRB, &
  & 0.37049907E-03_JPRB, 0.37048227E-03_JPRB, 0.37045596E-03_JPRB, 0.37042075E-03_JPRB, 0.37037750E-03_JPRB, 0.37032645E-03_JPRB, &
  & 0.37026848E-03_JPRB, 0.37020363E-03_JPRB, 0.37013262E-03_JPRB, 0.37005680E-03_JPRB, 0.36997843E-03_JPRB, 0.36989982E-03_JPRB, &
  & 0.36982269E-03_JPRB, 0.36974877E-03_JPRB, 0.36967860E-03_JPRB, 0.36961224E-03_JPRB, 0.36954932E-03_JPRB, 0.36948893E-03_JPRB, &
  & 0.36943014E-03_JPRB, 0.36937252E-03_JPRB, 0.36931568E-03_JPRB, 0.36925980E-03_JPRB, 0.36920587E-03_JPRB, 0.36915514E-03_JPRB, &
  & 0.36910817E-03_JPRB, 0.36906253E-03_JPRB, 0.36901532E-03_JPRB, 0.36893974E-03_JPRB /)

RGHG1(:,25, 3) = (/ &
  & 0.36914941E-03_JPRB, 0.36924973E-03_JPRB, 0.36930980E-03_JPRB, 0.36936457E-03_JPRB, 0.36941998E-03_JPRB, 0.36947880E-03_JPRB, &
  & 0.36954167E-03_JPRB, 0.36960829E-03_JPRB, 0.36967738E-03_JPRB, 0.36974801E-03_JPRB, 0.36981900E-03_JPRB, 0.36988940E-03_JPRB, &
  & 0.36995800E-03_JPRB, 0.37002342E-03_JPRB, 0.37008501E-03_JPRB, 0.37014260E-03_JPRB, 0.37019615E-03_JPRB, 0.37024572E-03_JPRB, &
  & 0.37029083E-03_JPRB, 0.37033163E-03_JPRB, 0.37036784E-03_JPRB, 0.37039860E-03_JPRB, 0.37042383E-03_JPRB, 0.37044380E-03_JPRB, &
  & 0.37045911E-03_JPRB, 0.37047098E-03_JPRB, 0.37048137E-03_JPRB, 0.37049211E-03_JPRB, 0.37050468E-03_JPRB, 0.37052017E-03_JPRB, &
  & 0.37053798E-03_JPRB, 0.37055666E-03_JPRB, 0.37057334E-03_JPRB, 0.37058577E-03_JPRB, 0.37059179E-03_JPRB, 0.37058984E-03_JPRB, &
  & 0.37057887E-03_JPRB, 0.37055876E-03_JPRB, 0.37053024E-03_JPRB, 0.37049418E-03_JPRB, 0.37045145E-03_JPRB, 0.37040259E-03_JPRB, &
  & 0.37034819E-03_JPRB, 0.37028844E-03_JPRB, 0.37022360E-03_JPRB, 0.37015500E-03_JPRB, 0.37008405E-03_JPRB, 0.37001309E-03_JPRB, &
  & 0.36994429E-03_JPRB, 0.36987869E-03_JPRB, 0.36981676E-03_JPRB, 0.36975849E-03_JPRB, 0.36970316E-03_JPRB, 0.36965008E-03_JPRB, &
  & 0.36959807E-03_JPRB, 0.36954653E-03_JPRB, 0.36949484E-03_JPRB, 0.36944327E-03_JPRB, 0.36939298E-03_JPRB, 0.36934469E-03_JPRB, &
  & 0.36929891E-03_JPRB, 0.36925465E-03_JPRB, 0.36920671E-03_JPRB, 0.36913087E-03_JPRB /)

RGHG1(:,26, 3) = (/ &
  & 0.36925703E-03_JPRB, 0.36935162E-03_JPRB, 0.36940788E-03_JPRB, 0.36945913E-03_JPRB, 0.36951166E-03_JPRB, 0.36956742E-03_JPRB, &
  & 0.36962726E-03_JPRB, 0.36969053E-03_JPRB, 0.36975631E-03_JPRB, 0.36982363E-03_JPRB, 0.36989184E-03_JPRB, 0.36995977E-03_JPRB, &
  & 0.37002657E-03_JPRB, 0.37009115E-03_JPRB, 0.37015253E-03_JPRB, 0.37021004E-03_JPRB, 0.37026367E-03_JPRB, 0.37031324E-03_JPRB, &
  & 0.37035876E-03_JPRB, 0.37040032E-03_JPRB, 0.37043748E-03_JPRB, 0.37047005E-03_JPRB, 0.37049744E-03_JPRB, 0.37051993E-03_JPRB, &
  & 0.37053804E-03_JPRB, 0.37055282E-03_JPRB, 0.37056548E-03_JPRB, 0.37057776E-03_JPRB, 0.37059092E-03_JPRB, 0.37060547E-03_JPRB, &
  & 0.37062119E-03_JPRB, 0.37063658E-03_JPRB, 0.37064962E-03_JPRB, 0.37065803E-03_JPRB, 0.37066007E-03_JPRB, 0.37065434E-03_JPRB, &
  & 0.37064031E-03_JPRB, 0.37061819E-03_JPRB, 0.37058868E-03_JPRB, 0.37055317E-03_JPRB, 0.37051225E-03_JPRB, 0.37046656E-03_JPRB, &
  & 0.37041638E-03_JPRB, 0.37036205E-03_JPRB, 0.37030314E-03_JPRB, 0.37024094E-03_JPRB, 0.37017680E-03_JPRB, 0.37011327E-03_JPRB, &
  & 0.37005162E-03_JPRB, 0.36999315E-03_JPRB, 0.36993818E-03_JPRB, 0.36988661E-03_JPRB, 0.36983759E-03_JPRB, 0.36979010E-03_JPRB, &
  & 0.36974304E-03_JPRB, 0.36969583E-03_JPRB, 0.36964813E-03_JPRB, 0.36959985E-03_JPRB, 0.36955206E-03_JPRB, 0.36950564E-03_JPRB, &
  & 0.36946105E-03_JPRB, 0.36941719E-03_JPRB, 0.36936975E-03_JPRB, 0.36929434E-03_JPRB /)

RGHG1(:,27, 3) = (/ &
  & 0.36935732E-03_JPRB, 0.36944504E-03_JPRB, 0.36949854E-03_JPRB, 0.36954667E-03_JPRB, 0.36959595E-03_JPRB, 0.36964883E-03_JPRB, &
  & 0.36970514E-03_JPRB, 0.36976516E-03_JPRB, 0.36982738E-03_JPRB, 0.36989135E-03_JPRB, 0.36995669E-03_JPRB, 0.37002261E-03_JPRB, &
  & 0.37008789E-03_JPRB, 0.37015122E-03_JPRB, 0.37021170E-03_JPRB, 0.37026883E-03_JPRB, 0.37032235E-03_JPRB, 0.37037191E-03_JPRB, &
  & 0.37041793E-03_JPRB, 0.37045986E-03_JPRB, 0.37049779E-03_JPRB, 0.37053140E-03_JPRB, 0.37056045E-03_JPRB, 0.37058501E-03_JPRB, &
  & 0.37060565E-03_JPRB, 0.37062279E-03_JPRB, 0.37063746E-03_JPRB, 0.37065090E-03_JPRB, 0.37066391E-03_JPRB, 0.37067736E-03_JPRB, &
  & 0.37069057E-03_JPRB, 0.37070253E-03_JPRB, 0.37071187E-03_JPRB, 0.37071644E-03_JPRB, 0.37071499E-03_JPRB, 0.37070649E-03_JPRB, &
  & 0.37069025E-03_JPRB, 0.37066705E-03_JPRB, 0.37063801E-03_JPRB, 0.37060434E-03_JPRB, 0.37056621E-03_JPRB, 0.37052413E-03_JPRB, &
  & 0.37047843E-03_JPRB, 0.37042890E-03_JPRB, 0.37037564E-03_JPRB, 0.37031929E-03_JPRB, 0.37026155E-03_JPRB, 0.37020430E-03_JPRB, &
  & 0.37014883E-03_JPRB, 0.37009621E-03_JPRB, 0.37004700E-03_JPRB, 0.37000084E-03_JPRB, 0.36995672E-03_JPRB, 0.36991359E-03_JPRB, &
  & 0.36987051E-03_JPRB, 0.36982665E-03_JPRB, 0.36978166E-03_JPRB, 0.36973582E-03_JPRB, 0.36969001E-03_JPRB, 0.36964501E-03_JPRB, &
  & 0.36960162E-03_JPRB, 0.36955863E-03_JPRB, 0.36951224E-03_JPRB, 0.36943649E-03_JPRB /)

RGHG1(:,28, 3) = (/ &
  & 0.36945054E-03_JPRB, 0.36953384E-03_JPRB, 0.36958320E-03_JPRB, 0.36962883E-03_JPRB, 0.36967537E-03_JPRB, 0.36972476E-03_JPRB, &
  & 0.36977811E-03_JPRB, 0.36983436E-03_JPRB, 0.36989304E-03_JPRB, 0.36995369E-03_JPRB, 0.37001577E-03_JPRB, 0.37007887E-03_JPRB, &
  & 0.37014225E-03_JPRB, 0.37020468E-03_JPRB, 0.37026490E-03_JPRB, 0.37032191E-03_JPRB, 0.37037540E-03_JPRB, 0.37042517E-03_JPRB, &
  & 0.37047110E-03_JPRB, 0.37051312E-03_JPRB, 0.37055119E-03_JPRB, 0.37058519E-03_JPRB, 0.37061516E-03_JPRB, 0.37064115E-03_JPRB, &
  & 0.37066339E-03_JPRB, 0.37068225E-03_JPRB, 0.37069837E-03_JPRB, 0.37071266E-03_JPRB, 0.37072549E-03_JPRB, 0.37073746E-03_JPRB, &
  & 0.37074825E-03_JPRB, 0.37075713E-03_JPRB, 0.37076298E-03_JPRB, 0.37076455E-03_JPRB, 0.37076024E-03_JPRB, 0.37074968E-03_JPRB, &
  & 0.37073251E-03_JPRB, 0.37070978E-03_JPRB, 0.37068230E-03_JPRB, 0.37065093E-03_JPRB, 0.37061633E-03_JPRB, 0.37057823E-03_JPRB, &
  & 0.37053693E-03_JPRB, 0.37049229E-03_JPRB, 0.37044403E-03_JPRB, 0.37039319E-03_JPRB, 0.37034071E-03_JPRB, 0.37028868E-03_JPRB, &
  & 0.37023844E-03_JPRB, 0.37019071E-03_JPRB, 0.37014612E-03_JPRB, 0.37010404E-03_JPRB, 0.37006364E-03_JPRB, 0.37002371E-03_JPRB, &
  & 0.36998349E-03_JPRB, 0.36994219E-03_JPRB, 0.36989956E-03_JPRB, 0.36985549E-03_JPRB, 0.36981111E-03_JPRB, 0.36976737E-03_JPRB, &
  & 0.36972482E-03_JPRB, 0.36968297E-03_JPRB, 0.36963698E-03_JPRB, 0.36956376E-03_JPRB /)

RGHG1(:,29, 3) = (/ &
  & 0.36953919E-03_JPRB, 0.36961696E-03_JPRB, 0.36966460E-03_JPRB, 0.36970709E-03_JPRB, 0.36975087E-03_JPRB, 0.36979764E-03_JPRB, &
  & 0.36984720E-03_JPRB, 0.36990011E-03_JPRB, 0.36995515E-03_JPRB, 0.37001242E-03_JPRB, 0.37007168E-03_JPRB, 0.37013271E-03_JPRB, &
  & 0.37019420E-03_JPRB, 0.37025509E-03_JPRB, 0.37031452E-03_JPRB, 0.37037098E-03_JPRB, 0.37042433E-03_JPRB, 0.37047410E-03_JPRB, &
  & 0.37051988E-03_JPRB, 0.37056173E-03_JPRB, 0.37059953E-03_JPRB, 0.37063356E-03_JPRB, 0.37066382E-03_JPRB, 0.37069037E-03_JPRB, &
  & 0.37071359E-03_JPRB, 0.37073335E-03_JPRB, 0.37075020E-03_JPRB, 0.37076467E-03_JPRB, 0.37077707E-03_JPRB, 0.37078775E-03_JPRB, &
  & 0.37079639E-03_JPRB, 0.37080256E-03_JPRB, 0.37080573E-03_JPRB, 0.37080483E-03_JPRB, 0.37079866E-03_JPRB, 0.37078708E-03_JPRB, &
  & 0.37077005E-03_JPRB, 0.37074820E-03_JPRB, 0.37072302E-03_JPRB, 0.37069499E-03_JPRB, 0.37066414E-03_JPRB, 0.37063018E-03_JPRB, &
  & 0.37059333E-03_JPRB, 0.37055308E-03_JPRB, 0.37050969E-03_JPRB, 0.37046330E-03_JPRB, 0.37041557E-03_JPRB, 0.37036804E-03_JPRB, &
  & 0.37032203E-03_JPRB, 0.37027826E-03_JPRB, 0.37023693E-03_JPRB, 0.37019781E-03_JPRB, 0.37016004E-03_JPRB, 0.37012267E-03_JPRB, &
  & 0.37008486E-03_JPRB, 0.37004572E-03_JPRB, 0.37000477E-03_JPRB, 0.36996230E-03_JPRB, 0.36991891E-03_JPRB, 0.36987592E-03_JPRB, &
  & 0.36983402E-03_JPRB, 0.36979286E-03_JPRB, 0.36974889E-03_JPRB, 0.36967677E-03_JPRB /)

RGHG1(:,30, 3) = (/ &
  & 0.36962269E-03_JPRB, 0.36969743E-03_JPRB, 0.36974149E-03_JPRB, 0.36978215E-03_JPRB, 0.36982345E-03_JPRB, 0.36986719E-03_JPRB, &
  & 0.36991402E-03_JPRB, 0.36996335E-03_JPRB, 0.37001495E-03_JPRB, 0.37006882E-03_JPRB, 0.37012494E-03_JPRB, 0.37018282E-03_JPRB, &
  & 0.37024223E-03_JPRB, 0.37030195E-03_JPRB, 0.37036056E-03_JPRB, 0.37041717E-03_JPRB, 0.37047060E-03_JPRB, 0.37052028E-03_JPRB, &
  & 0.37056598E-03_JPRB, 0.37060754E-03_JPRB, 0.37064488E-03_JPRB, 0.37067843E-03_JPRB, 0.37070838E-03_JPRB, 0.37073478E-03_JPRB, &
  & 0.37075786E-03_JPRB, 0.37077771E-03_JPRB, 0.37079467E-03_JPRB, 0.37080891E-03_JPRB, 0.37082049E-03_JPRB, 0.37082972E-03_JPRB, &
  & 0.37083650E-03_JPRB, 0.37084066E-03_JPRB, 0.37084171E-03_JPRB, 0.37083906E-03_JPRB, 0.37083181E-03_JPRB, 0.37081994E-03_JPRB, &
  & 0.37080370E-03_JPRB, 0.37078411E-03_JPRB, 0.37076173E-03_JPRB, 0.37073693E-03_JPRB, 0.37070969E-03_JPRB, 0.37067986E-03_JPRB, &
  & 0.37064700E-03_JPRB, 0.37061106E-03_JPRB, 0.37057171E-03_JPRB, 0.37052963E-03_JPRB, 0.37048597E-03_JPRB, 0.37044217E-03_JPRB, &
  & 0.37039965E-03_JPRB, 0.37035876E-03_JPRB, 0.37032008E-03_JPRB, 0.37028320E-03_JPRB, 0.37024746E-03_JPRB, 0.37021202E-03_JPRB, &
  & 0.37017616E-03_JPRB, 0.37013873E-03_JPRB, 0.37009950E-03_JPRB, 0.37005817E-03_JPRB, 0.37001556E-03_JPRB, 0.36997307E-03_JPRB, &
  & 0.36993180E-03_JPRB, 0.36989161E-03_JPRB, 0.36984816E-03_JPRB, 0.36977846E-03_JPRB /)

RGHG1(:,31, 3) = (/ &
  & 0.36970305E-03_JPRB, 0.36977333E-03_JPRB, 0.36981609E-03_JPRB, 0.36985442E-03_JPRB, 0.36989333E-03_JPRB, 0.36993460E-03_JPRB, &
  & 0.36997843E-03_JPRB, 0.37002470E-03_JPRB, 0.37007313E-03_JPRB, 0.37012383E-03_JPRB, 0.37017709E-03_JPRB, 0.37023288E-03_JPRB, &
  & 0.37029042E-03_JPRB, 0.37034840E-03_JPRB, 0.37040582E-03_JPRB, 0.37046178E-03_JPRB, 0.37051493E-03_JPRB, 0.37056449E-03_JPRB, &
  & 0.37060989E-03_JPRB, 0.37065093E-03_JPRB, 0.37068781E-03_JPRB, 0.37072066E-03_JPRB, 0.37074962E-03_JPRB, 0.37077512E-03_JPRB, &
  & 0.37079747E-03_JPRB, 0.37081656E-03_JPRB, 0.37083298E-03_JPRB, 0.37084625E-03_JPRB, 0.37085687E-03_JPRB, 0.37086487E-03_JPRB, &
  & 0.37087020E-03_JPRB, 0.37087270E-03_JPRB, 0.37087227E-03_JPRB, 0.37086863E-03_JPRB, 0.37086109E-03_JPRB, 0.37084974E-03_JPRB, &
  & 0.37083516E-03_JPRB, 0.37081761E-03_JPRB, 0.37079799E-03_JPRB, 0.37077651E-03_JPRB, 0.37075282E-03_JPRB, 0.37072660E-03_JPRB, &
  & 0.37069747E-03_JPRB, 0.37066508E-03_JPRB, 0.37062948E-03_JPRB, 0.37059109E-03_JPRB, 0.37055099E-03_JPRB, 0.37051050E-03_JPRB, &
  & 0.37047072E-03_JPRB, 0.37043248E-03_JPRB, 0.37039584E-03_JPRB, 0.37036068E-03_JPRB, 0.37032654E-03_JPRB, 0.37029284E-03_JPRB, &
  & 0.37025847E-03_JPRB, 0.37022276E-03_JPRB, 0.37018504E-03_JPRB, 0.37014490E-03_JPRB, 0.37010311E-03_JPRB, 0.37006111E-03_JPRB, &
  & 0.37002025E-03_JPRB, 0.36998079E-03_JPRB, 0.36993856E-03_JPRB, 0.36987045E-03_JPRB /)

RGHG1(:,32, 3) = (/ &
  & 0.36977950E-03_JPRB, 0.36984793E-03_JPRB, 0.36988789E-03_JPRB, 0.36992459E-03_JPRB, 0.36996155E-03_JPRB, 0.37000031E-03_JPRB, &
  & 0.37004170E-03_JPRB, 0.37008498E-03_JPRB, 0.37013032E-03_JPRB, 0.37017796E-03_JPRB, 0.37022808E-03_JPRB, 0.37028102E-03_JPRB, &
  & 0.37033638E-03_JPRB, 0.37039310E-03_JPRB, 0.37044974E-03_JPRB, 0.37050503E-03_JPRB, 0.37055774E-03_JPRB, 0.37060693E-03_JPRB, &
  & 0.37065198E-03_JPRB, 0.37069249E-03_JPRB, 0.37072849E-03_JPRB, 0.37076027E-03_JPRB, 0.37078804E-03_JPRB, 0.37081231E-03_JPRB, &
  & 0.37083324E-03_JPRB, 0.37085096E-03_JPRB, 0.37086610E-03_JPRB, 0.37087817E-03_JPRB, 0.37088784E-03_JPRB, 0.37089444E-03_JPRB, &
  & 0.37089852E-03_JPRB, 0.37090000E-03_JPRB, 0.37089860E-03_JPRB, 0.37089444E-03_JPRB, 0.37088708E-03_JPRB, 0.37087681E-03_JPRB, &
  & 0.37086377E-03_JPRB, 0.37084849E-03_JPRB, 0.37083175E-03_JPRB, 0.37081342E-03_JPRB, 0.37079296E-03_JPRB, 0.37076982E-03_JPRB, &
  & 0.37074368E-03_JPRB, 0.37071429E-03_JPRB, 0.37068184E-03_JPRB, 0.37064674E-03_JPRB, 0.37060981E-03_JPRB, 0.37057206E-03_JPRB, &
  & 0.37053501E-03_JPRB, 0.37049875E-03_JPRB, 0.37046405E-03_JPRB, 0.37043041E-03_JPRB, 0.37039773E-03_JPRB, 0.37036542E-03_JPRB, &
  & 0.37033271E-03_JPRB, 0.37029854E-03_JPRB, 0.37026242E-03_JPRB, 0.37022377E-03_JPRB, 0.37018309E-03_JPRB, 0.37014176E-03_JPRB, &
  & 0.37010168E-03_JPRB, 0.37006289E-03_JPRB, 0.37002150E-03_JPRB, 0.36995506E-03_JPRB /)

RGHG1(:,33, 3) = (/ &
  & 0.36985436E-03_JPRB, 0.36991926E-03_JPRB, 0.36995817E-03_JPRB, 0.36999257E-03_JPRB, 0.37002779E-03_JPRB, 0.37006463E-03_JPRB, &
  & 0.37010349E-03_JPRB, 0.37014415E-03_JPRB, 0.37018652E-03_JPRB, 0.37023111E-03_JPRB, 0.37027843E-03_JPRB, 0.37032866E-03_JPRB, &
  & 0.37038149E-03_JPRB, 0.37043629E-03_JPRB, 0.37049173E-03_JPRB, 0.37054639E-03_JPRB, 0.37059872E-03_JPRB, 0.37064738E-03_JPRB, &
  & 0.37069191E-03_JPRB, 0.37073164E-03_JPRB, 0.37076644E-03_JPRB, 0.37079712E-03_JPRB, 0.37082328E-03_JPRB, 0.37084601E-03_JPRB, &
  & 0.37086519E-03_JPRB, 0.37088137E-03_JPRB, 0.37089479E-03_JPRB, 0.37090536E-03_JPRB, 0.37091371E-03_JPRB, 0.37091936E-03_JPRB, &
  & 0.37092247E-03_JPRB, 0.37092317E-03_JPRB, 0.37092145E-03_JPRB, 0.37091726E-03_JPRB, 0.37091057E-03_JPRB, 0.37090149E-03_JPRB, &
  & 0.37089043E-03_JPRB, 0.37087777E-03_JPRB, 0.37086356E-03_JPRB, 0.37084776E-03_JPRB, 0.37082974E-03_JPRB, 0.37080914E-03_JPRB, &
  & 0.37078554E-03_JPRB, 0.37075861E-03_JPRB, 0.37072852E-03_JPRB, 0.37069590E-03_JPRB, 0.37066158E-03_JPRB, 0.37062675E-03_JPRB, &
  & 0.37059159E-03_JPRB, 0.37055748E-03_JPRB, 0.37052453E-03_JPRB, 0.37049234E-03_JPRB, 0.37046112E-03_JPRB, 0.37043029E-03_JPRB, &
  & 0.37039907E-03_JPRB, 0.37036670E-03_JPRB, 0.37033242E-03_JPRB, 0.37029549E-03_JPRB, 0.37025625E-03_JPRB, 0.37021641E-03_JPRB, &
  & 0.37017727E-03_JPRB, 0.37013955E-03_JPRB, 0.37009930E-03_JPRB, 0.37003416E-03_JPRB /)

RGHG1(:,34, 3) = (/ &
  & 0.36992697E-03_JPRB, 0.36999010E-03_JPRB, 0.37002660E-03_JPRB, 0.37005980E-03_JPRB, 0.37009292E-03_JPRB, 0.37012761E-03_JPRB, &
  & 0.37016431E-03_JPRB, 0.37020235E-03_JPRB, 0.37024199E-03_JPRB, 0.37028344E-03_JPRB, 0.37032762E-03_JPRB, 0.37037500E-03_JPRB, &
  & 0.37042555E-03_JPRB, 0.37047846E-03_JPRB, 0.37053257E-03_JPRB, 0.37058609E-03_JPRB, 0.37063763E-03_JPRB, 0.37068568E-03_JPRB, &
  & 0.37072928E-03_JPRB, 0.37076799E-03_JPRB, 0.37080166E-03_JPRB, 0.37083076E-03_JPRB, 0.37085536E-03_JPRB, 0.37087643E-03_JPRB, &
  & 0.37089366E-03_JPRB, 0.37090798E-03_JPRB, 0.37091968E-03_JPRB, 0.37092870E-03_JPRB, 0.37093565E-03_JPRB, 0.37094025E-03_JPRB, &
  & 0.37094258E-03_JPRB, 0.37094278E-03_JPRB, 0.37094095E-03_JPRB, 0.37093734E-03_JPRB, 0.37093155E-03_JPRB, 0.37092404E-03_JPRB, &
  & 0.37091496E-03_JPRB, 0.37090454E-03_JPRB, 0.37089270E-03_JPRB, 0.37087928E-03_JPRB, 0.37086330E-03_JPRB, 0.37084444E-03_JPRB, &
  & 0.37082226E-03_JPRB, 0.37079706E-03_JPRB, 0.37076900E-03_JPRB, 0.37073847E-03_JPRB, 0.37070661E-03_JPRB, 0.37067375E-03_JPRB, &
  & 0.37064101E-03_JPRB, 0.37060873E-03_JPRB, 0.37057733E-03_JPRB, 0.37054680E-03_JPRB, 0.37051702E-03_JPRB, 0.37048769E-03_JPRB, &
  & 0.37045823E-03_JPRB, 0.37042768E-03_JPRB, 0.37039537E-03_JPRB, 0.37036053E-03_JPRB, 0.37032351E-03_JPRB, 0.37028542E-03_JPRB, &
  & 0.37024813E-03_JPRB, 0.37021172E-03_JPRB, 0.37017270E-03_JPRB, 0.37010902E-03_JPRB /)

RGHG1(:,35, 3) = (/ &
  & 0.36999866E-03_JPRB, 0.37005861E-03_JPRB, 0.37009409E-03_JPRB, 0.37012517E-03_JPRB, 0.37015672E-03_JPRB, 0.37018963E-03_JPRB, &
  & 0.37022395E-03_JPRB, 0.37025943E-03_JPRB, 0.37029621E-03_JPRB, 0.37033466E-03_JPRB, 0.37037561E-03_JPRB, 0.37041973E-03_JPRB, &
  & 0.37046761E-03_JPRB, 0.37051830E-03_JPRB, 0.37057075E-03_JPRB, 0.37062331E-03_JPRB, 0.37067392E-03_JPRB, 0.37072104E-03_JPRB, &
  & 0.37076353E-03_JPRB, 0.37080122E-03_JPRB, 0.37083353E-03_JPRB, 0.37086115E-03_JPRB, 0.37088394E-03_JPRB, 0.37090309E-03_JPRB, &
  & 0.37091828E-03_JPRB, 0.37093065E-03_JPRB, 0.37094040E-03_JPRB, 0.37094767E-03_JPRB, 0.37095320E-03_JPRB, 0.37095675E-03_JPRB, &
  & 0.37095850E-03_JPRB, 0.37095862E-03_JPRB, 0.37095704E-03_JPRB, 0.37095408E-03_JPRB, 0.37094942E-03_JPRB, 0.37094342E-03_JPRB, &
  & 0.37093632E-03_JPRB, 0.37092788E-03_JPRB, 0.37091813E-03_JPRB, 0.37090655E-03_JPRB, 0.37089229E-03_JPRB, 0.37087506E-03_JPRB, &
  & 0.37085445E-03_JPRB, 0.37083047E-03_JPRB, 0.37080378E-03_JPRB, 0.37077503E-03_JPRB, 0.37074491E-03_JPRB, 0.37071417E-03_JPRB, &
  & 0.37068318E-03_JPRB, 0.37065271E-03_JPRB, 0.37062285E-03_JPRB, 0.37059386E-03_JPRB, 0.37056569E-03_JPRB, 0.37053801E-03_JPRB, &
  & 0.37051013E-03_JPRB, 0.37048160E-03_JPRB, 0.37045154E-03_JPRB, 0.37041938E-03_JPRB, 0.37038498E-03_JPRB, 0.37034939E-03_JPRB, &
  & 0.37031402E-03_JPRB, 0.37027930E-03_JPRB, 0.37024182E-03_JPRB, 0.37017971E-03_JPRB /)

RGHG1(:,36, 3) = (/ &
  & 0.37006816E-03_JPRB, 0.37012598E-03_JPRB, 0.37015919E-03_JPRB, 0.37018914E-03_JPRB, 0.37021918E-03_JPRB, 0.37025014E-03_JPRB, &
  & 0.37028239E-03_JPRB, 0.37031525E-03_JPRB, 0.37034909E-03_JPRB, 0.37038446E-03_JPRB, 0.37042197E-03_JPRB, 0.37046312E-03_JPRB, &
  & 0.37050806E-03_JPRB, 0.37055643E-03_JPRB, 0.37060707E-03_JPRB, 0.37065815E-03_JPRB, 0.37070748E-03_JPRB, 0.37075343E-03_JPRB, &
  & 0.37079470E-03_JPRB, 0.37083108E-03_JPRB, 0.37086202E-03_JPRB, 0.37088798E-03_JPRB, 0.37090897E-03_JPRB, 0.37092585E-03_JPRB, &
  & 0.37093880E-03_JPRB, 0.37094875E-03_JPRB, 0.37095638E-03_JPRB, 0.37096199E-03_JPRB, 0.37096610E-03_JPRB, 0.37096877E-03_JPRB, &
  & 0.37097005E-03_JPRB, 0.37097014E-03_JPRB, 0.37096898E-03_JPRB, 0.37096662E-03_JPRB, 0.37096310E-03_JPRB, 0.37095853E-03_JPRB, &
  & 0.37095300E-03_JPRB, 0.37094628E-03_JPRB, 0.37093833E-03_JPRB, 0.37092844E-03_JPRB, 0.37091580E-03_JPRB, 0.37090003E-03_JPRB, &
  & 0.37088079E-03_JPRB, 0.37085827E-03_JPRB, 0.37083292E-03_JPRB, 0.37080582E-03_JPRB, 0.37077744E-03_JPRB, 0.37074837E-03_JPRB, &
  & 0.37071906E-03_JPRB, 0.37068993E-03_JPRB, 0.37066147E-03_JPRB, 0.37063408E-03_JPRB, 0.37060745E-03_JPRB, 0.37058146E-03_JPRB, &
  & 0.37055553E-03_JPRB, 0.37052913E-03_JPRB, 0.37050145E-03_JPRB, 0.37047185E-03_JPRB, 0.37044013E-03_JPRB, 0.37040730E-03_JPRB, &
  & 0.37037456E-03_JPRB, 0.37034199E-03_JPRB, 0.37030620E-03_JPRB, 0.37024653E-03_JPRB /)

RGHG1(:,37, 3) = (/ &
  & 0.37013637E-03_JPRB, 0.37019100E-03_JPRB, 0.37022302E-03_JPRB, 0.37025148E-03_JPRB, 0.37028024E-03_JPRB, 0.37030972E-03_JPRB, &
  & 0.37033961E-03_JPRB, 0.37036996E-03_JPRB, 0.37040081E-03_JPRB, 0.37043294E-03_JPRB, 0.37046726E-03_JPRB, 0.37050474E-03_JPRB, &
  & 0.37054654E-03_JPRB, 0.37059232E-03_JPRB, 0.37064092E-03_JPRB, 0.37069022E-03_JPRB, 0.37073813E-03_JPRB, 0.37078274E-03_JPRB, &
  & 0.37082270E-03_JPRB, 0.37085766E-03_JPRB, 0.37088699E-03_JPRB, 0.37091092E-03_JPRB, 0.37092948E-03_JPRB, 0.37094374E-03_JPRB, &
  & 0.37095399E-03_JPRB, 0.37096167E-03_JPRB, 0.37096726E-03_JPRB, 0.37097145E-03_JPRB, 0.37097451E-03_JPRB, 0.37097643E-03_JPRB, &
  & 0.37097748E-03_JPRB, 0.37097750E-03_JPRB, 0.37097660E-03_JPRB, 0.37097486E-03_JPRB, 0.37097215E-03_JPRB, 0.37096857E-03_JPRB, &
  & 0.37096432E-03_JPRB, 0.37095899E-03_JPRB, 0.37095242E-03_JPRB, 0.37094404E-03_JPRB, 0.37093315E-03_JPRB, 0.37091898E-03_JPRB, &
  & 0.37090149E-03_JPRB, 0.37088065E-03_JPRB, 0.37085704E-03_JPRB, 0.37083140E-03_JPRB, 0.37080466E-03_JPRB, 0.37077704E-03_JPRB, &
  & 0.37074898E-03_JPRB, 0.37072113E-03_JPRB, 0.37069409E-03_JPRB, 0.37066796E-03_JPRB, 0.37064299E-03_JPRB, 0.37061865E-03_JPRB, &
  & 0.37059456E-03_JPRB, 0.37057020E-03_JPRB, 0.37054502E-03_JPRB, 0.37051810E-03_JPRB, 0.37048940E-03_JPRB, 0.37045951E-03_JPRB, &
  & 0.37042957E-03_JPRB, 0.37039936E-03_JPRB, 0.37036595E-03_JPRB, 0.37030931E-03_JPRB /)

RGHG1(:,38, 3) = (/ &
  & 0.37020227E-03_JPRB, 0.37025422E-03_JPRB, 0.37028466E-03_JPRB, 0.37031216E-03_JPRB, 0.37033969E-03_JPRB, 0.37036755E-03_JPRB, &
  & 0.37039546E-03_JPRB, 0.37042328E-03_JPRB, 0.37045113E-03_JPRB, 0.37048003E-03_JPRB, 0.37051088E-03_JPRB, 0.37054505E-03_JPRB, &
  & 0.37058344E-03_JPRB, 0.37062608E-03_JPRB, 0.37067226E-03_JPRB, 0.37071962E-03_JPRB, 0.37076575E-03_JPRB, 0.37080885E-03_JPRB, &
  & 0.37084732E-03_JPRB, 0.37088059E-03_JPRB, 0.37090768E-03_JPRB, 0.37092910E-03_JPRB, 0.37094494E-03_JPRB, 0.37095635E-03_JPRB, &
  & 0.37096423E-03_JPRB, 0.37097000E-03_JPRB, 0.37097410E-03_JPRB, 0.37097721E-03_JPRB, 0.37097954E-03_JPRB, 0.37098108E-03_JPRB, &
  & 0.37098193E-03_JPRB, 0.37098199E-03_JPRB, 0.37098135E-03_JPRB, 0.37097998E-03_JPRB, 0.37097782E-03_JPRB, 0.37097494E-03_JPRB, &
  & 0.37097145E-03_JPRB, 0.37096706E-03_JPRB, 0.37096161E-03_JPRB, 0.37095457E-03_JPRB, 0.37094511E-03_JPRB, 0.37093277E-03_JPRB, &
  & 0.37091694E-03_JPRB, 0.37089814E-03_JPRB, 0.37087640E-03_JPRB, 0.37085265E-03_JPRB, 0.37082745E-03_JPRB, 0.37080143E-03_JPRB, &
  & 0.37077453E-03_JPRB, 0.37074788E-03_JPRB, 0.37072183E-03_JPRB, 0.37069694E-03_JPRB, 0.37067325E-03_JPRB, 0.37065055E-03_JPRB, &
  & 0.37062840E-03_JPRB, 0.37060608E-03_JPRB, 0.37058329E-03_JPRB, 0.37055911E-03_JPRB, 0.37053335E-03_JPRB, 0.37050660E-03_JPRB, &
  & 0.37047945E-03_JPRB, 0.37045198E-03_JPRB, 0.37042118E-03_JPRB, 0.37036830E-03_JPRB /)

RGHG1(:,39, 3) = (/ &
  & 0.37026656E-03_JPRB, 0.37031554E-03_JPRB, 0.37034438E-03_JPRB, 0.37037072E-03_JPRB, 0.37039732E-03_JPRB, 0.37042383E-03_JPRB, &
  & 0.37044974E-03_JPRB, 0.37047506E-03_JPRB, 0.37049991E-03_JPRB, 0.37052552E-03_JPRB, 0.37055291E-03_JPRB, 0.37058332E-03_JPRB, &
  & 0.37061813E-03_JPRB, 0.37065777E-03_JPRB, 0.37070134E-03_JPRB, 0.37074645E-03_JPRB, 0.37079080E-03_JPRB, 0.37083210E-03_JPRB, &
  & 0.37086860E-03_JPRB, 0.37089951E-03_JPRB, 0.37092410E-03_JPRB, 0.37094249E-03_JPRB, 0.37095547E-03_JPRB, 0.37096441E-03_JPRB, &
  & 0.37097055E-03_JPRB, 0.37097491E-03_JPRB, 0.37097814E-03_JPRB, 0.37098071E-03_JPRB, 0.37098266E-03_JPRB, 0.37098394E-03_JPRB, &
  & 0.37098464E-03_JPRB, 0.37098481E-03_JPRB, 0.37098420E-03_JPRB, 0.37098309E-03_JPRB, 0.37098126E-03_JPRB, 0.37097879E-03_JPRB, &
  & 0.37097593E-03_JPRB, 0.37097224E-03_JPRB, 0.37096764E-03_JPRB, 0.37096153E-03_JPRB, 0.37095329E-03_JPRB, 0.37094238E-03_JPRB, &
  & 0.37092844E-03_JPRB, 0.37091138E-03_JPRB, 0.37089165E-03_JPRB, 0.37086982E-03_JPRB, 0.37084654E-03_JPRB, 0.37082186E-03_JPRB, &
  & 0.37079630E-03_JPRB, 0.37077037E-03_JPRB, 0.37074526E-03_JPRB, 0.37072136E-03_JPRB, 0.37069892E-03_JPRB, 0.37067788E-03_JPRB, &
  & 0.37065762E-03_JPRB, 0.37063760E-03_JPRB, 0.37061700E-03_JPRB, 0.37059540E-03_JPRB, 0.37057261E-03_JPRB, 0.37054881E-03_JPRB, &
  & 0.37052491E-03_JPRB, 0.37050026E-03_JPRB, 0.37047249E-03_JPRB, 0.37042412E-03_JPRB /)

RGHG1(:,40, 3) = (/ &
  & 0.37032904E-03_JPRB, 0.37037453E-03_JPRB, 0.37040171E-03_JPRB, 0.37042674E-03_JPRB, 0.37045247E-03_JPRB, 0.37047782E-03_JPRB, &
  & 0.37050201E-03_JPRB, 0.37052491E-03_JPRB, 0.37054691E-03_JPRB, 0.37056927E-03_JPRB, 0.37059310E-03_JPRB, 0.37061993E-03_JPRB, &
  & 0.37065116E-03_JPRB, 0.37068734E-03_JPRB, 0.37072797E-03_JPRB, 0.37077069E-03_JPRB, 0.37081281E-03_JPRB, 0.37085195E-03_JPRB, &
  & 0.37088632E-03_JPRB, 0.37091455E-03_JPRB, 0.37093600E-03_JPRB, 0.37095163E-03_JPRB, 0.37096234E-03_JPRB, 0.37096965E-03_JPRB, &
  & 0.37097459E-03_JPRB, 0.37097826E-03_JPRB, 0.37098085E-03_JPRB, 0.37098298E-03_JPRB, 0.37098469E-03_JPRB, 0.37098586E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098670E-03_JPRB, 0.37098618E-03_JPRB, 0.37098513E-03_JPRB, 0.37098350E-03_JPRB, 0.37098149E-03_JPRB, &
  & 0.37097893E-03_JPRB, 0.37097573E-03_JPRB, 0.37097171E-03_JPRB, 0.37096633E-03_JPRB, 0.37095911E-03_JPRB, 0.37094948E-03_JPRB, &
  & 0.37093705E-03_JPRB, 0.37092171E-03_JPRB, 0.37090387E-03_JPRB, 0.37088402E-03_JPRB, 0.37086249E-03_JPRB, 0.37083947E-03_JPRB, &
  & 0.37081499E-03_JPRB, 0.37079008E-03_JPRB, 0.37076569E-03_JPRB, 0.37074261E-03_JPRB, 0.37072127E-03_JPRB, 0.37070157E-03_JPRB, &
  & 0.37068309E-03_JPRB, 0.37066502E-03_JPRB, 0.37064683E-03_JPRB, 0.37062771E-03_JPRB, 0.37060771E-03_JPRB, 0.37058716E-03_JPRB, &
  & 0.37056638E-03_JPRB, 0.37054491E-03_JPRB, 0.37052028E-03_JPRB, 0.37047709E-03_JPRB /)

RGHG1(:,41, 3) = (/ &
  & 0.37038943E-03_JPRB, 0.37043140E-03_JPRB, 0.37045637E-03_JPRB, 0.37048027E-03_JPRB, 0.37050489E-03_JPRB, 0.37052919E-03_JPRB, &
  & 0.37055160E-03_JPRB, 0.37057223E-03_JPRB, 0.37059153E-03_JPRB, 0.37061068E-03_JPRB, 0.37063117E-03_JPRB, 0.37065445E-03_JPRB, &
  & 0.37068204E-03_JPRB, 0.37071493E-03_JPRB, 0.37075268E-03_JPRB, 0.37079299E-03_JPRB, 0.37083280E-03_JPRB, 0.37086956E-03_JPRB, &
  & 0.37090111E-03_JPRB, 0.37092634E-03_JPRB, 0.37094505E-03_JPRB, 0.37095818E-03_JPRB, 0.37096711E-03_JPRB, 0.37097323E-03_JPRB, &
  & 0.37097733E-03_JPRB, 0.37098042E-03_JPRB, 0.37098269E-03_JPRB, 0.37098464E-03_JPRB, 0.37098618E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098816E-03_JPRB, 0.37098760E-03_JPRB, 0.37098659E-03_JPRB, 0.37098513E-03_JPRB, 0.37098338E-03_JPRB, &
  & 0.37098114E-03_JPRB, 0.37097829E-03_JPRB, 0.37097471E-03_JPRB, 0.37096988E-03_JPRB, 0.37096351E-03_JPRB, 0.37095480E-03_JPRB, &
  & 0.37094374E-03_JPRB, 0.37092989E-03_JPRB, 0.37091371E-03_JPRB, 0.37089558E-03_JPRB, 0.37087579E-03_JPRB, 0.37085422E-03_JPRB, &
  & 0.37083137E-03_JPRB, 0.37080751E-03_JPRB, 0.37078394E-03_JPRB, 0.37076155E-03_JPRB, 0.37074121E-03_JPRB, 0.37072279E-03_JPRB, &
  & 0.37070591E-03_JPRB, 0.37068984E-03_JPRB, 0.37067360E-03_JPRB, 0.37065707E-03_JPRB, 0.37063984E-03_JPRB, 0.37062226E-03_JPRB, &
  & 0.37060448E-03_JPRB, 0.37058615E-03_JPRB, 0.37056502E-03_JPRB, 0.37052738E-03_JPRB /)

RGHG1(:,42, 3) = (/ &
  & 0.37044717E-03_JPRB, 0.37048530E-03_JPRB, 0.37050850E-03_JPRB, 0.37053094E-03_JPRB, 0.37055439E-03_JPRB, 0.37057756E-03_JPRB, &
  & 0.37059834E-03_JPRB, 0.37061676E-03_JPRB, 0.37063347E-03_JPRB, 0.37064980E-03_JPRB, 0.37066711E-03_JPRB, 0.37068708E-03_JPRB, &
  & 0.37071123E-03_JPRB, 0.37074086E-03_JPRB, 0.37077570E-03_JPRB, 0.37081350E-03_JPRB, 0.37085102E-03_JPRB, 0.37088516E-03_JPRB, &
  & 0.37091377E-03_JPRB, 0.37093586E-03_JPRB, 0.37095189E-03_JPRB, 0.37096301E-03_JPRB, 0.37097064E-03_JPRB, 0.37097596E-03_JPRB, &
  & 0.37097945E-03_JPRB, 0.37098210E-03_JPRB, 0.37098417E-03_JPRB, 0.37098592E-03_JPRB, 0.37098734E-03_JPRB, 0.37098842E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37098918E-03_JPRB, 0.37098868E-03_JPRB, 0.37098787E-03_JPRB, 0.37098644E-03_JPRB, 0.37098478E-03_JPRB, &
  & 0.37098269E-03_JPRB, 0.37098018E-03_JPRB, 0.37097695E-03_JPRB, 0.37097267E-03_JPRB, 0.37096703E-03_JPRB, 0.37095923E-03_JPRB, &
  & 0.37094927E-03_JPRB, 0.37093690E-03_JPRB, 0.37092215E-03_JPRB, 0.37090559E-03_JPRB, 0.37088746E-03_JPRB, 0.37086761E-03_JPRB, &
  & 0.37084628E-03_JPRB, 0.37082346E-03_JPRB, 0.37080061E-03_JPRB, 0.37077902E-03_JPRB, 0.37075958E-03_JPRB, 0.37074232E-03_JPRB, &
  & 0.37072683E-03_JPRB, 0.37071225E-03_JPRB, 0.37069799E-03_JPRB, 0.37068359E-03_JPRB, 0.37066897E-03_JPRB, 0.37065428E-03_JPRB, &
  & 0.37063955E-03_JPRB, 0.37062424E-03_JPRB, 0.37060640E-03_JPRB, 0.37057453E-03_JPRB /)

RGHG1(:,43, 3) = (/ &
  & 0.37050227E-03_JPRB, 0.37053658E-03_JPRB, 0.37055783E-03_JPRB, 0.37057869E-03_JPRB, 0.37060099E-03_JPRB, 0.37062285E-03_JPRB, &
  & 0.37064223E-03_JPRB, 0.37065861E-03_JPRB, 0.37067314E-03_JPRB, 0.37068690E-03_JPRB, 0.37070137E-03_JPRB, 0.37071810E-03_JPRB, &
  & 0.37073920E-03_JPRB, 0.37076572E-03_JPRB, 0.37079776E-03_JPRB, 0.37083298E-03_JPRB, 0.37086767E-03_JPRB, 0.37089901E-03_JPRB, &
  & 0.37092445E-03_JPRB, 0.37094363E-03_JPRB, 0.37095725E-03_JPRB, 0.37096662E-03_JPRB, 0.37097326E-03_JPRB, 0.37097791E-03_JPRB, &
  & 0.37098103E-03_JPRB, 0.37098350E-03_JPRB, 0.37098533E-03_JPRB, 0.37098693E-03_JPRB, 0.37098833E-03_JPRB, 0.37098932E-03_JPRB, &
  & 0.37098993E-03_JPRB, 0.37099016E-03_JPRB, 0.37098958E-03_JPRB, 0.37098883E-03_JPRB, 0.37098757E-03_JPRB, 0.37098597E-03_JPRB, &
  & 0.37098402E-03_JPRB, 0.37098172E-03_JPRB, 0.37097870E-03_JPRB, 0.37097491E-03_JPRB, 0.37096988E-03_JPRB, 0.37096292E-03_JPRB, &
  & 0.37095405E-03_JPRB, 0.37094293E-03_JPRB, 0.37092969E-03_JPRB, 0.37091455E-03_JPRB, 0.37089802E-03_JPRB, 0.37087969E-03_JPRB, &
  & 0.37085981E-03_JPRB, 0.37083830E-03_JPRB, 0.37081641E-03_JPRB, 0.37079578E-03_JPRB, 0.37077727E-03_JPRB, 0.37076135E-03_JPRB, &
  & 0.37074706E-03_JPRB, 0.37073393E-03_JPRB, 0.37072127E-03_JPRB, 0.37070879E-03_JPRB, 0.37069642E-03_JPRB, 0.37068420E-03_JPRB, &
  & 0.37067215E-03_JPRB, 0.37065960E-03_JPRB, 0.37064491E-03_JPRB, 0.37061833E-03_JPRB /)

RGHG1(:,44, 3) = (/ &
  & 0.37055410E-03_JPRB, 0.37058530E-03_JPRB, 0.37060434E-03_JPRB, 0.37062366E-03_JPRB, 0.37064438E-03_JPRB, 0.37066519E-03_JPRB, &
  & 0.37068303E-03_JPRB, 0.37069793E-03_JPRB, 0.37071033E-03_JPRB, 0.37072203E-03_JPRB, 0.37073408E-03_JPRB, 0.37074828E-03_JPRB, &
  & 0.37076621E-03_JPRB, 0.37078990E-03_JPRB, 0.37081906E-03_JPRB, 0.37085169E-03_JPRB, 0.37088385E-03_JPRB, 0.37091179E-03_JPRB, &
  & 0.37093385E-03_JPRB, 0.37095003E-03_JPRB, 0.37096167E-03_JPRB, 0.37096965E-03_JPRB, 0.37097544E-03_JPRB, 0.37097951E-03_JPRB, &
  & 0.37098245E-03_JPRB, 0.37098461E-03_JPRB, 0.37098632E-03_JPRB, 0.37098792E-03_JPRB, 0.37098926E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099098E-03_JPRB, 0.37099043E-03_JPRB, 0.37098967E-03_JPRB, 0.37098851E-03_JPRB, 0.37098696E-03_JPRB, &
  & 0.37098513E-03_JPRB, 0.37098301E-03_JPRB, 0.37098018E-03_JPRB, 0.37097675E-03_JPRB, 0.37097224E-03_JPRB, 0.37096621E-03_JPRB, &
  & 0.37095841E-03_JPRB, 0.37094860E-03_JPRB, 0.37093667E-03_JPRB, 0.37092314E-03_JPRB, 0.37090792E-03_JPRB, 0.37089110E-03_JPRB, &
  & 0.37087264E-03_JPRB, 0.37085253E-03_JPRB, 0.37083199E-03_JPRB, 0.37081240E-03_JPRB, 0.37079514E-03_JPRB, 0.37078018E-03_JPRB, &
  & 0.37076711E-03_JPRB, 0.37075533E-03_JPRB, 0.37074421E-03_JPRB, 0.37073344E-03_JPRB, 0.37072299E-03_JPRB, 0.37071295E-03_JPRB, &
  & 0.37070294E-03_JPRB, 0.37069275E-03_JPRB, 0.37068073E-03_JPRB, 0.37065873E-03_JPRB /)

RGHG1(:,45, 3) = (/ &
  & 0.37060294E-03_JPRB, 0.37063047E-03_JPRB, 0.37064846E-03_JPRB, 0.37066580E-03_JPRB, 0.37068556E-03_JPRB, 0.37070486E-03_JPRB, &
  & 0.37072177E-03_JPRB, 0.37073501E-03_JPRB, 0.37074601E-03_JPRB, 0.37075579E-03_JPRB, 0.37076589E-03_JPRB, 0.37077756E-03_JPRB, &
  & 0.37079304E-03_JPRB, 0.37081380E-03_JPRB, 0.37084066E-03_JPRB, 0.37087052E-03_JPRB, 0.37089927E-03_JPRB, 0.37092363E-03_JPRB, &
  & 0.37094200E-03_JPRB, 0.37095544E-03_JPRB, 0.37096511E-03_JPRB, 0.37097203E-03_JPRB, 0.37097713E-03_JPRB, 0.37098079E-03_JPRB, &
  & 0.37098356E-03_JPRB, 0.37098560E-03_JPRB, 0.37098725E-03_JPRB, 0.37098877E-03_JPRB, 0.37099008E-03_JPRB, 0.37099098E-03_JPRB, &
  & 0.37099145E-03_JPRB, 0.37099156E-03_JPRB, 0.37099113E-03_JPRB, 0.37099037E-03_JPRB, 0.37098926E-03_JPRB, 0.37098784E-03_JPRB, &
  & 0.37098609E-03_JPRB, 0.37098399E-03_JPRB, 0.37098143E-03_JPRB, 0.37097823E-03_JPRB, 0.37097425E-03_JPRB, 0.37096889E-03_JPRB, &
  & 0.37096220E-03_JPRB, 0.37095373E-03_JPRB, 0.37094337E-03_JPRB, 0.37093138E-03_JPRB, 0.37091773E-03_JPRB, 0.37090245E-03_JPRB, &
  & 0.37088542E-03_JPRB, 0.37086679E-03_JPRB, 0.37084761E-03_JPRB, 0.37082960E-03_JPRB, 0.37081356E-03_JPRB, 0.37079997E-03_JPRB, &
  & 0.37078804E-03_JPRB, 0.37077736E-03_JPRB, 0.37076746E-03_JPRB, 0.37075803E-03_JPRB, 0.37074921E-03_JPRB, 0.37074072E-03_JPRB, &
  & 0.37073251E-03_JPRB, 0.37072410E-03_JPRB, 0.37071423E-03_JPRB, 0.37069613E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART6',0,ZHOOK_HANDLE)



RGHG1(:,46, 3) = (/ &
  & 0.37064755E-03_JPRB, 0.37067337E-03_JPRB, 0.37068897E-03_JPRB, 0.37070588E-03_JPRB, 0.37072404E-03_JPRB, 0.37074269E-03_JPRB, &
  & 0.37075832E-03_JPRB, 0.37077055E-03_JPRB, 0.37078001E-03_JPRB, 0.37078848E-03_JPRB, 0.37079694E-03_JPRB, 0.37080696E-03_JPRB, &
  & 0.37081997E-03_JPRB, 0.37083836E-03_JPRB, 0.37086220E-03_JPRB, 0.37088897E-03_JPRB, 0.37091394E-03_JPRB, 0.37093402E-03_JPRB, &
  & 0.37094904E-03_JPRB, 0.37095990E-03_JPRB, 0.37096799E-03_JPRB, 0.37097395E-03_JPRB, 0.37097852E-03_JPRB, 0.37098193E-03_JPRB, &
  & 0.37098452E-03_JPRB, 0.37098644E-03_JPRB, 0.37098807E-03_JPRB, 0.37098952E-03_JPRB, 0.37099083E-03_JPRB, 0.37099159E-03_JPRB, &
  & 0.37099217E-03_JPRB, 0.37099226E-03_JPRB, 0.37099188E-03_JPRB, 0.37099113E-03_JPRB, 0.37099005E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37098685E-03_JPRB, 0.37098493E-03_JPRB, 0.37098251E-03_JPRB, 0.37097960E-03_JPRB, 0.37097599E-03_JPRB, 0.37097133E-03_JPRB, &
  & 0.37096557E-03_JPRB, 0.37095850E-03_JPRB, 0.37094991E-03_JPRB, 0.37093982E-03_JPRB, 0.37092791E-03_JPRB, 0.37091426E-03_JPRB, &
  & 0.37089878E-03_JPRB, 0.37088158E-03_JPRB, 0.37086400E-03_JPRB, 0.37084721E-03_JPRB, 0.37083295E-03_JPRB, 0.37082055E-03_JPRB, &
  & 0.37080981E-03_JPRB, 0.37080009E-03_JPRB, 0.37079124E-03_JPRB, 0.37078303E-03_JPRB, 0.37077526E-03_JPRB, 0.37076819E-03_JPRB, &
  & 0.37076138E-03_JPRB, 0.37075448E-03_JPRB, 0.37074622E-03_JPRB, 0.37073120E-03_JPRB /)

RGHG1(:,47, 3) = (/ &
  & 0.37068932E-03_JPRB, 0.37071289E-03_JPRB, 0.37072803E-03_JPRB, 0.37074322E-03_JPRB, 0.37076091E-03_JPRB, 0.37077841E-03_JPRB, &
  & 0.37079328E-03_JPRB, 0.37080434E-03_JPRB, 0.37081284E-03_JPRB, 0.37082008E-03_JPRB, 0.37082736E-03_JPRB, 0.37083586E-03_JPRB, &
  & 0.37084709E-03_JPRB, 0.37086310E-03_JPRB, 0.37088402E-03_JPRB, 0.37090696E-03_JPRB, 0.37092718E-03_JPRB, 0.37094299E-03_JPRB, &
  & 0.37095466E-03_JPRB, 0.37096351E-03_JPRB, 0.37097026E-03_JPRB, 0.37097550E-03_JPRB, 0.37097957E-03_JPRB, 0.37098280E-03_JPRB, &
  & 0.37098528E-03_JPRB, 0.37098717E-03_JPRB, 0.37098888E-03_JPRB, 0.37099028E-03_JPRB, 0.37099147E-03_JPRB, 0.37099226E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099278E-03_JPRB, 0.37099246E-03_JPRB, 0.37099177E-03_JPRB, 0.37099066E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098752E-03_JPRB, 0.37098560E-03_JPRB, 0.37098338E-03_JPRB, 0.37098074E-03_JPRB, 0.37097745E-03_JPRB, 0.37097349E-03_JPRB, &
  & 0.37096880E-03_JPRB, 0.37096310E-03_JPRB, 0.37095626E-03_JPRB, 0.37094817E-03_JPRB, 0.37093856E-03_JPRB, 0.37092692E-03_JPRB, &
  & 0.37091287E-03_JPRB, 0.37089727E-03_JPRB, 0.37088094E-03_JPRB, 0.37086627E-03_JPRB, 0.37085314E-03_JPRB, 0.37084217E-03_JPRB, &
  & 0.37083248E-03_JPRB, 0.37082378E-03_JPRB, 0.37081580E-03_JPRB, 0.37080835E-03_JPRB, 0.37080160E-03_JPRB, 0.37079549E-03_JPRB, &
  & 0.37078976E-03_JPRB, 0.37078388E-03_JPRB, 0.37077695E-03_JPRB, 0.37076438E-03_JPRB /)

RGHG1(:,48, 3) = (/ &
  & 0.37072762E-03_JPRB, 0.37074997E-03_JPRB, 0.37076429E-03_JPRB, 0.37077916E-03_JPRB, 0.37079595E-03_JPRB, 0.37081278E-03_JPRB, &
  & 0.37082681E-03_JPRB, 0.37083705E-03_JPRB, 0.37084465E-03_JPRB, 0.37085099E-03_JPRB, 0.37085725E-03_JPRB, 0.37086449E-03_JPRB, &
  & 0.37087410E-03_JPRB, 0.37088752E-03_JPRB, 0.37090524E-03_JPRB, 0.37092314E-03_JPRB, 0.37093851E-03_JPRB, 0.37095032E-03_JPRB, &
  & 0.37095937E-03_JPRB, 0.37096639E-03_JPRB, 0.37097203E-03_JPRB, 0.37097672E-03_JPRB, 0.37098047E-03_JPRB, 0.37098350E-03_JPRB, &
  & 0.37098603E-03_JPRB, 0.37098795E-03_JPRB, 0.37098958E-03_JPRB, 0.37099101E-03_JPRB, 0.37099217E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099331E-03_JPRB, 0.37099296E-03_JPRB, 0.37099229E-03_JPRB, 0.37099115E-03_JPRB, 0.37098973E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098624E-03_JPRB, 0.37098414E-03_JPRB, 0.37098170E-03_JPRB, 0.37097873E-03_JPRB, 0.37097535E-03_JPRB, &
  & 0.37097139E-03_JPRB, 0.37096706E-03_JPRB, 0.37096217E-03_JPRB, 0.37095643E-03_JPRB, 0.37094930E-03_JPRB, 0.37093993E-03_JPRB, &
  & 0.37092814E-03_JPRB, 0.37091385E-03_JPRB, 0.37089965E-03_JPRB, 0.37088624E-03_JPRB, 0.37087494E-03_JPRB, 0.37086502E-03_JPRB, &
  & 0.37085635E-03_JPRB, 0.37084852E-03_JPRB, 0.37084118E-03_JPRB, 0.37083446E-03_JPRB, 0.37082849E-03_JPRB, 0.37082314E-03_JPRB, &
  & 0.37081816E-03_JPRB, 0.37081313E-03_JPRB, 0.37080713E-03_JPRB, 0.37079639E-03_JPRB /)

RGHG1(:,49, 3) = (/ &
  & 0.37076336E-03_JPRB, 0.37078522E-03_JPRB, 0.37079881E-03_JPRB, 0.37081348E-03_JPRB, 0.37082989E-03_JPRB, 0.37084619E-03_JPRB, &
  & 0.37085937E-03_JPRB, 0.37086866E-03_JPRB, 0.37087535E-03_JPRB, 0.37088082E-03_JPRB, 0.37088612E-03_JPRB, 0.37089217E-03_JPRB, &
  & 0.37090003E-03_JPRB, 0.37091083E-03_JPRB, 0.37092366E-03_JPRB, 0.37093688E-03_JPRB, 0.37094773E-03_JPRB, 0.37095638E-03_JPRB, &
  & 0.37096316E-03_JPRB, 0.37096877E-03_JPRB, 0.37097355E-03_JPRB, 0.37097780E-03_JPRB, 0.37098132E-03_JPRB, 0.37098426E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098856E-03_JPRB, 0.37099031E-03_JPRB, 0.37099171E-03_JPRB, 0.37099284E-03_JPRB, 0.37099351E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099380E-03_JPRB, 0.37099337E-03_JPRB, 0.37099270E-03_JPRB, 0.37099156E-03_JPRB, 0.37099016E-03_JPRB, &
  & 0.37098853E-03_JPRB, 0.37098679E-03_JPRB, 0.37098478E-03_JPRB, 0.37098239E-03_JPRB, 0.37097977E-03_JPRB, 0.37097692E-03_JPRB, &
  & 0.37097372E-03_JPRB, 0.37097049E-03_JPRB, 0.37096714E-03_JPRB, 0.37096333E-03_JPRB, 0.37095873E-03_JPRB, 0.37095218E-03_JPRB, &
  & 0.37094307E-03_JPRB, 0.37093175E-03_JPRB, 0.37091924E-03_JPRB, 0.37090827E-03_JPRB, 0.37089840E-03_JPRB, 0.37088981E-03_JPRB, &
  & 0.37088199E-03_JPRB, 0.37087483E-03_JPRB, 0.37086807E-03_JPRB, 0.37086185E-03_JPRB, 0.37085635E-03_JPRB, 0.37085143E-03_JPRB, &
  & 0.37084694E-03_JPRB, 0.37084252E-03_JPRB, 0.37083725E-03_JPRB, 0.37082759E-03_JPRB /)

RGHG1(:,50, 3) = (/ &
  & 0.37079674E-03_JPRB, 0.37081816E-03_JPRB, 0.37083187E-03_JPRB, 0.37084630E-03_JPRB, 0.37086278E-03_JPRB, 0.37087861E-03_JPRB, &
  & 0.37089063E-03_JPRB, 0.37089881E-03_JPRB, 0.37090445E-03_JPRB, 0.37090891E-03_JPRB, 0.37091295E-03_JPRB, 0.37091767E-03_JPRB, &
  & 0.37092320E-03_JPRB, 0.37093044E-03_JPRB, 0.37093897E-03_JPRB, 0.37094738E-03_JPRB, 0.37095486E-03_JPRB, 0.37096094E-03_JPRB, &
  & 0.37096613E-03_JPRB, 0.37097069E-03_JPRB, 0.37097477E-03_JPRB, 0.37097858E-03_JPRB, 0.37098199E-03_JPRB, 0.37098490E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098932E-03_JPRB, 0.37099104E-03_JPRB, 0.37099241E-03_JPRB, 0.37099345E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099430E-03_JPRB, 0.37099421E-03_JPRB, 0.37099374E-03_JPRB, 0.37099313E-03_JPRB, 0.37099203E-03_JPRB, 0.37099066E-03_JPRB, &
  & 0.37098900E-03_JPRB, 0.37098731E-03_JPRB, 0.37098528E-03_JPRB, 0.37098315E-03_JPRB, 0.37098079E-03_JPRB, 0.37097820E-03_JPRB, &
  & 0.37097564E-03_JPRB, 0.37097323E-03_JPRB, 0.37097104E-03_JPRB, 0.37096880E-03_JPRB, 0.37096598E-03_JPRB, 0.37096193E-03_JPRB, &
  & 0.37095585E-03_JPRB, 0.37094753E-03_JPRB, 0.37093888E-03_JPRB, 0.37093050E-03_JPRB, 0.37092285E-03_JPRB, 0.37091580E-03_JPRB, &
  & 0.37090908E-03_JPRB, 0.37090259E-03_JPRB, 0.37089642E-03_JPRB, 0.37089051E-03_JPRB, 0.37088525E-03_JPRB, 0.37088071E-03_JPRB, &
  & 0.37087663E-03_JPRB, 0.37087250E-03_JPRB, 0.37086758E-03_JPRB, 0.37085867E-03_JPRB /)

RGHG1(:,51, 3) = (/ &
  & 0.37082817E-03_JPRB, 0.37084892E-03_JPRB, 0.37086316E-03_JPRB, 0.37087747E-03_JPRB, 0.37089383E-03_JPRB, 0.37090859E-03_JPRB, &
  & 0.37091906E-03_JPRB, 0.37092547E-03_JPRB, 0.37092966E-03_JPRB, 0.37093263E-03_JPRB, 0.37093533E-03_JPRB, 0.37093787E-03_JPRB, &
  & 0.37094107E-03_JPRB, 0.37094491E-03_JPRB, 0.37094980E-03_JPRB, 0.37095504E-03_JPRB, 0.37095993E-03_JPRB, 0.37096435E-03_JPRB, &
  & 0.37096845E-03_JPRB, 0.37097224E-03_JPRB, 0.37097576E-03_JPRB, 0.37097931E-03_JPRB, 0.37098263E-03_JPRB, 0.37098548E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098999E-03_JPRB, 0.37099171E-03_JPRB, 0.37099302E-03_JPRB, 0.37099406E-03_JPRB, 0.37099459E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099456E-03_JPRB, 0.37099412E-03_JPRB, 0.37099345E-03_JPRB, 0.37099243E-03_JPRB, 0.37099101E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37098775E-03_JPRB, 0.37098586E-03_JPRB, 0.37098379E-03_JPRB, 0.37098158E-03_JPRB, 0.37097940E-03_JPRB, &
  & 0.37097733E-03_JPRB, 0.37097558E-03_JPRB, 0.37097433E-03_JPRB, 0.37097291E-03_JPRB, 0.37097133E-03_JPRB, 0.37096880E-03_JPRB, &
  & 0.37096490E-03_JPRB, 0.37096004E-03_JPRB, 0.37095472E-03_JPRB, 0.37094968E-03_JPRB, 0.37094485E-03_JPRB, 0.37093979E-03_JPRB, &
  & 0.37093490E-03_JPRB, 0.37092977E-03_JPRB, 0.37092442E-03_JPRB, 0.37091924E-03_JPRB, 0.37091441E-03_JPRB, 0.37091027E-03_JPRB, &
  & 0.37090643E-03_JPRB, 0.37090253E-03_JPRB, 0.37089785E-03_JPRB, 0.37088958E-03_JPRB /)

RGHG1(:,52, 3) = (/ &
  & 0.37085655E-03_JPRB, 0.37087855E-03_JPRB, 0.37089112E-03_JPRB, 0.37090594E-03_JPRB, 0.37092075E-03_JPRB, 0.37093338E-03_JPRB, &
  & 0.37094080E-03_JPRB, 0.37094502E-03_JPRB, 0.37094744E-03_JPRB, 0.37094910E-03_JPRB, 0.37095035E-03_JPRB, 0.37095166E-03_JPRB, &
  & 0.37095300E-03_JPRB, 0.37095495E-03_JPRB, 0.37095748E-03_JPRB, 0.37096060E-03_JPRB, 0.37096388E-03_JPRB, 0.37096711E-03_JPRB, &
  & 0.37097032E-03_JPRB, 0.37097343E-03_JPRB, 0.37097657E-03_JPRB, 0.37097995E-03_JPRB, 0.37098327E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098853E-03_JPRB, 0.37099060E-03_JPRB, 0.37099232E-03_JPRB, 0.37099363E-03_JPRB, 0.37099456E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099514E-03_JPRB, 0.37099494E-03_JPRB, 0.37099453E-03_JPRB, 0.37099380E-03_JPRB, 0.37099273E-03_JPRB, 0.37099133E-03_JPRB, &
  & 0.37098970E-03_JPRB, 0.37098816E-03_JPRB, 0.37098632E-03_JPRB, 0.37098437E-03_JPRB, 0.37098245E-03_JPRB, 0.37098053E-03_JPRB, &
  & 0.37097873E-03_JPRB, 0.37097753E-03_JPRB, 0.37097669E-03_JPRB, 0.37097602E-03_JPRB, 0.37097497E-03_JPRB, 0.37097343E-03_JPRB, &
  & 0.37097116E-03_JPRB, 0.37096842E-03_JPRB, 0.37096566E-03_JPRB, 0.37096307E-03_JPRB, 0.37096045E-03_JPRB, 0.37095789E-03_JPRB, &
  & 0.37095492E-03_JPRB, 0.37095157E-03_JPRB, 0.37094799E-03_JPRB, 0.37094404E-03_JPRB, 0.37094031E-03_JPRB, 0.37093682E-03_JPRB, &
  & 0.37093350E-03_JPRB, 0.37093012E-03_JPRB, 0.37092602E-03_JPRB, 0.37091837E-03_JPRB /)

RGHG1(:,53, 3) = (/ &
  & 0.37088370E-03_JPRB, 0.37090282E-03_JPRB, 0.37091685E-03_JPRB, 0.37092884E-03_JPRB, 0.37094144E-03_JPRB, 0.37095015E-03_JPRB, &
  & 0.37095480E-03_JPRB, 0.37095707E-03_JPRB, 0.37095830E-03_JPRB, 0.37095899E-03_JPRB, 0.37095958E-03_JPRB, 0.37096004E-03_JPRB, &
  & 0.37096068E-03_JPRB, 0.37096144E-03_JPRB, 0.37096275E-03_JPRB, 0.37096455E-03_JPRB, 0.37096685E-03_JPRB, 0.37096936E-03_JPRB, &
  & 0.37097192E-03_JPRB, 0.37097454E-03_JPRB, 0.37097748E-03_JPRB, 0.37098068E-03_JPRB, 0.37098391E-03_JPRB, 0.37098676E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37099124E-03_JPRB, 0.37099293E-03_JPRB, 0.37099421E-03_JPRB, 0.37099514E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099558E-03_JPRB, 0.37099529E-03_JPRB, 0.37099488E-03_JPRB, 0.37099409E-03_JPRB, 0.37099299E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37098859E-03_JPRB, 0.37098673E-03_JPRB, 0.37098498E-03_JPRB, 0.37098306E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098007E-03_JPRB, 0.37097919E-03_JPRB, 0.37097879E-03_JPRB, 0.37097832E-03_JPRB, 0.37097777E-03_JPRB, 0.37097678E-03_JPRB, &
  & 0.37097538E-03_JPRB, 0.37097384E-03_JPRB, 0.37097241E-03_JPRB, 0.37097110E-03_JPRB, 0.37096997E-03_JPRB, 0.37096866E-03_JPRB, &
  & 0.37096717E-03_JPRB, 0.37096534E-03_JPRB, 0.37096313E-03_JPRB, 0.37096080E-03_JPRB, 0.37095835E-03_JPRB, 0.37095608E-03_JPRB, &
  & 0.37095393E-03_JPRB, 0.37095154E-03_JPRB, 0.37094843E-03_JPRB, 0.37094249E-03_JPRB /)

RGHG1(:,54, 3) = (/ &
  & 0.37090603E-03_JPRB, 0.37092605E-03_JPRB, 0.37093618E-03_JPRB, 0.37094671E-03_JPRB, 0.37095507E-03_JPRB, 0.37096048E-03_JPRB, &
  & 0.37096298E-03_JPRB, 0.37096418E-03_JPRB, 0.37096476E-03_JPRB, 0.37096508E-03_JPRB, 0.37096528E-03_JPRB, 0.37096551E-03_JPRB, &
  & 0.37096569E-03_JPRB, 0.37096598E-03_JPRB, 0.37096656E-03_JPRB, 0.37096767E-03_JPRB, 0.37096924E-03_JPRB, 0.37097122E-03_JPRB, &
  & 0.37097331E-03_JPRB, 0.37097573E-03_JPRB, 0.37097841E-03_JPRB, 0.37098149E-03_JPRB, 0.37098458E-03_JPRB, 0.37098740E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37099177E-03_JPRB, 0.37099345E-03_JPRB, 0.37099468E-03_JPRB, 0.37099549E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099564E-03_JPRB, 0.37099520E-03_JPRB, 0.37099438E-03_JPRB, 0.37099328E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099040E-03_JPRB, 0.37098894E-03_JPRB, 0.37098717E-03_JPRB, 0.37098548E-03_JPRB, 0.37098370E-03_JPRB, 0.37098234E-03_JPRB, &
  & 0.37098123E-03_JPRB, 0.37098071E-03_JPRB, 0.37098056E-03_JPRB, 0.37098036E-03_JPRB, 0.37097992E-03_JPRB, 0.37097925E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37097742E-03_JPRB, 0.37097669E-03_JPRB, 0.37097605E-03_JPRB, 0.37097535E-03_JPRB, 0.37097474E-03_JPRB, &
  & 0.37097395E-03_JPRB, 0.37097296E-03_JPRB, 0.37097180E-03_JPRB, 0.37097046E-03_JPRB, 0.37096912E-03_JPRB, 0.37096793E-03_JPRB, &
  & 0.37096671E-03_JPRB, 0.37096540E-03_JPRB, 0.37096362E-03_JPRB, 0.37096007E-03_JPRB /)

RGHG1(:,55, 3) = (/ &
  & 0.37092689E-03_JPRB, 0.37094255E-03_JPRB, 0.37095172E-03_JPRB, 0.37095830E-03_JPRB, 0.37096362E-03_JPRB, 0.37096671E-03_JPRB, &
  & 0.37096808E-03_JPRB, 0.37096866E-03_JPRB, 0.37096889E-03_JPRB, 0.37096898E-03_JPRB, 0.37096906E-03_JPRB, 0.37096912E-03_JPRB, &
  & 0.37096918E-03_JPRB, 0.37096927E-03_JPRB, 0.37096953E-03_JPRB, 0.37097011E-03_JPRB, 0.37097122E-03_JPRB, 0.37097279E-03_JPRB, &
  & 0.37097459E-03_JPRB, 0.37097678E-03_JPRB, 0.37097934E-03_JPRB, 0.37098228E-03_JPRB, 0.37098522E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37099232E-03_JPRB, 0.37099398E-03_JPRB, 0.37099511E-03_JPRB, 0.37099590E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099596E-03_JPRB, 0.37099535E-03_JPRB, 0.37099462E-03_JPRB, 0.37099351E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099072E-03_JPRB, 0.37098929E-03_JPRB, 0.37098763E-03_JPRB, 0.37098597E-03_JPRB, 0.37098437E-03_JPRB, 0.37098315E-03_JPRB, &
  & 0.37098245E-03_JPRB, 0.37098207E-03_JPRB, 0.37098204E-03_JPRB, 0.37098199E-03_JPRB, 0.37098175E-03_JPRB, 0.37098123E-03_JPRB, &
  & 0.37098065E-03_JPRB, 0.37098007E-03_JPRB, 0.37097960E-03_JPRB, 0.37097925E-03_JPRB, 0.37097890E-03_JPRB, 0.37097849E-03_JPRB, &
  & 0.37097800E-03_JPRB, 0.37097739E-03_JPRB, 0.37097675E-03_JPRB, 0.37097608E-03_JPRB, 0.37097541E-03_JPRB, 0.37097471E-03_JPRB, &
  & 0.37097407E-03_JPRB, 0.37097331E-03_JPRB, 0.37097232E-03_JPRB, 0.37097002E-03_JPRB /)

RGHG1(:,56, 3) = (/ &
  & 0.37094319E-03_JPRB, 0.37095594E-03_JPRB, 0.37096170E-03_JPRB, 0.37096580E-03_JPRB, 0.37096901E-03_JPRB, 0.37097075E-03_JPRB, &
  & 0.37097151E-03_JPRB, 0.37097180E-03_JPRB, 0.37097195E-03_JPRB, 0.37097200E-03_JPRB, 0.37097197E-03_JPRB, 0.37097195E-03_JPRB, &
  & 0.37097195E-03_JPRB, 0.37097195E-03_JPRB, 0.37097203E-03_JPRB, 0.37097232E-03_JPRB, 0.37097302E-03_JPRB, 0.37097430E-03_JPRB, &
  & 0.37097582E-03_JPRB, 0.37097788E-03_JPRB, 0.37098030E-03_JPRB, 0.37098309E-03_JPRB, 0.37098592E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099293E-03_JPRB, 0.37099447E-03_JPRB, 0.37099549E-03_JPRB, 0.37099631E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099622E-03_JPRB, 0.37099561E-03_JPRB, 0.37099485E-03_JPRB, 0.37099372E-03_JPRB, 0.37099243E-03_JPRB, &
  & 0.37099098E-03_JPRB, 0.37098958E-03_JPRB, 0.37098807E-03_JPRB, 0.37098653E-03_JPRB, 0.37098507E-03_JPRB, 0.37098405E-03_JPRB, &
  & 0.37098344E-03_JPRB, 0.37098330E-03_JPRB, 0.37098338E-03_JPRB, 0.37098353E-03_JPRB, 0.37098333E-03_JPRB, 0.37098286E-03_JPRB, &
  & 0.37098242E-03_JPRB, 0.37098202E-03_JPRB, 0.37098170E-03_JPRB, 0.37098146E-03_JPRB, 0.37098123E-03_JPRB, 0.37098100E-03_JPRB, &
  & 0.37098071E-03_JPRB, 0.37098036E-03_JPRB, 0.37097998E-03_JPRB, 0.37097954E-03_JPRB, 0.37097913E-03_JPRB, 0.37097876E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37097806E-03_JPRB, 0.37097777E-03_JPRB, 0.37097742E-03_JPRB /)

RGHG1(:,57, 3) = (/ &
  & 0.37095626E-03_JPRB, 0.37096476E-03_JPRB, 0.37096831E-03_JPRB, 0.37097081E-03_JPRB, 0.37097250E-03_JPRB, 0.37097355E-03_JPRB, &
  & 0.37097401E-03_JPRB, 0.37097419E-03_JPRB, 0.37097425E-03_JPRB, 0.37097425E-03_JPRB, 0.37097425E-03_JPRB, 0.37097419E-03_JPRB, &
  & 0.37097419E-03_JPRB, 0.37097413E-03_JPRB, 0.37097419E-03_JPRB, 0.37097430E-03_JPRB, 0.37097471E-03_JPRB, 0.37097579E-03_JPRB, &
  & 0.37097704E-03_JPRB, 0.37097899E-03_JPRB, 0.37098132E-03_JPRB, 0.37098402E-03_JPRB, 0.37098664E-03_JPRB, 0.37098938E-03_JPRB, &
  & 0.37099168E-03_JPRB, 0.37099348E-03_JPRB, 0.37099505E-03_JPRB, 0.37099596E-03_JPRB, 0.37099665E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099660E-03_JPRB, 0.37099593E-03_JPRB, 0.37099508E-03_JPRB, 0.37099398E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099127E-03_JPRB, 0.37098987E-03_JPRB, 0.37098851E-03_JPRB, 0.37098714E-03_JPRB, 0.37098589E-03_JPRB, 0.37098490E-03_JPRB, &
  & 0.37098446E-03_JPRB, 0.37098443E-03_JPRB, 0.37098466E-03_JPRB, 0.37098487E-03_JPRB, 0.37098472E-03_JPRB, 0.37098437E-03_JPRB, &
  & 0.37098402E-03_JPRB, 0.37098370E-03_JPRB, 0.37098344E-03_JPRB, 0.37098321E-03_JPRB, 0.37098301E-03_JPRB, 0.37098283E-03_JPRB, &
  & 0.37098263E-03_JPRB, 0.37098239E-03_JPRB, 0.37098210E-03_JPRB, 0.37098181E-03_JPRB, 0.37098149E-03_JPRB, 0.37098123E-03_JPRB, &
  & 0.37098103E-03_JPRB, 0.37098082E-03_JPRB, 0.37098062E-03_JPRB, 0.37098021E-03_JPRB /)

RGHG1(:,58, 3) = (/ &
  & 0.37096583E-03_JPRB, 0.37097058E-03_JPRB, 0.37097267E-03_JPRB, 0.37097401E-03_JPRB, 0.37097506E-03_JPRB, 0.37097570E-03_JPRB, &
  & 0.37097599E-03_JPRB, 0.37097611E-03_JPRB, 0.37097614E-03_JPRB, 0.37097611E-03_JPRB, 0.37097605E-03_JPRB, 0.37097599E-03_JPRB, &
  & 0.37097599E-03_JPRB, 0.37097599E-03_JPRB, 0.37097602E-03_JPRB, 0.37097608E-03_JPRB, 0.37097643E-03_JPRB, 0.37097724E-03_JPRB, &
  & 0.37097826E-03_JPRB, 0.37098001E-03_JPRB, 0.37098219E-03_JPRB, 0.37098478E-03_JPRB, 0.37098743E-03_JPRB, 0.37099011E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099412E-03_JPRB, 0.37099549E-03_JPRB, 0.37099631E-03_JPRB, 0.37099709E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099709E-03_JPRB, 0.37099683E-03_JPRB, 0.37099613E-03_JPRB, 0.37099532E-03_JPRB, 0.37099418E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099028E-03_JPRB, 0.37098903E-03_JPRB, 0.37098772E-03_JPRB, 0.37098653E-03_JPRB, 0.37098571E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098551E-03_JPRB, 0.37098589E-03_JPRB, 0.37098615E-03_JPRB, 0.37098603E-03_JPRB, 0.37098565E-03_JPRB, &
  & 0.37098536E-03_JPRB, 0.37098498E-03_JPRB, 0.37098469E-03_JPRB, 0.37098452E-03_JPRB, 0.37098437E-03_JPRB, 0.37098420E-03_JPRB, &
  & 0.37098408E-03_JPRB, 0.37098391E-03_JPRB, 0.37098373E-03_JPRB, 0.37098350E-03_JPRB, 0.37098327E-03_JPRB, 0.37098309E-03_JPRB, &
  & 0.37098292E-03_JPRB, 0.37098274E-03_JPRB, 0.37098257E-03_JPRB, 0.37098225E-03_JPRB /)

RGHG1(:,59, 3) = (/ &
  & 0.37097145E-03_JPRB, 0.37097457E-03_JPRB, 0.37097573E-03_JPRB, 0.37097663E-03_JPRB, 0.37097727E-03_JPRB, 0.37097765E-03_JPRB, &
  & 0.37097782E-03_JPRB, 0.37097791E-03_JPRB, 0.37097797E-03_JPRB, 0.37097803E-03_JPRB, 0.37097803E-03_JPRB, 0.37097797E-03_JPRB, &
  & 0.37097797E-03_JPRB, 0.37097794E-03_JPRB, 0.37097785E-03_JPRB, 0.37097780E-03_JPRB, 0.37097791E-03_JPRB, 0.37097864E-03_JPRB, &
  & 0.37097951E-03_JPRB, 0.37098120E-03_JPRB, 0.37098321E-03_JPRB, 0.37098562E-03_JPRB, 0.37098830E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099290E-03_JPRB, 0.37099465E-03_JPRB, 0.37099596E-03_JPRB, 0.37099677E-03_JPRB, 0.37099744E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099738E-03_JPRB, 0.37099709E-03_JPRB, 0.37099636E-03_JPRB, 0.37099546E-03_JPRB, 0.37099450E-03_JPRB, 0.37099331E-03_JPRB, &
  & 0.37099209E-03_JPRB, 0.37099072E-03_JPRB, 0.37098958E-03_JPRB, 0.37098824E-03_JPRB, 0.37098728E-03_JPRB, 0.37098656E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098650E-03_JPRB, 0.37098691E-03_JPRB, 0.37098725E-03_JPRB, 0.37098717E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098635E-03_JPRB, 0.37098615E-03_JPRB, 0.37098594E-03_JPRB, 0.37098577E-03_JPRB, 0.37098565E-03_JPRB, &
  & 0.37098554E-03_JPRB, 0.37098530E-03_JPRB, 0.37098513E-03_JPRB, 0.37098496E-03_JPRB, 0.37098481E-03_JPRB, 0.37098469E-03_JPRB, &
  & 0.37098455E-03_JPRB, 0.37098437E-03_JPRB, 0.37098426E-03_JPRB, 0.37098394E-03_JPRB /)

RGHG1(:,60, 3) = (/ &
  & 0.37097617E-03_JPRB, 0.37097750E-03_JPRB, 0.37097814E-03_JPRB, 0.37097855E-03_JPRB, 0.37097899E-03_JPRB, 0.37097919E-03_JPRB, &
  & 0.37097931E-03_JPRB, 0.37097937E-03_JPRB, 0.37097943E-03_JPRB, 0.37097943E-03_JPRB, 0.37097943E-03_JPRB, 0.37097943E-03_JPRB, &
  & 0.37097945E-03_JPRB, 0.37097948E-03_JPRB, 0.37097943E-03_JPRB, 0.37097943E-03_JPRB, 0.37097957E-03_JPRB, 0.37098004E-03_JPRB, &
  & 0.37098091E-03_JPRB, 0.37098239E-03_JPRB, 0.37098429E-03_JPRB, 0.37098659E-03_JPRB, 0.37098915E-03_JPRB, 0.37099139E-03_JPRB, &
  & 0.37099351E-03_JPRB, 0.37099514E-03_JPRB, 0.37099651E-03_JPRB, 0.37099724E-03_JPRB, 0.37099782E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099730E-03_JPRB, 0.37099665E-03_JPRB, 0.37099575E-03_JPRB, 0.37099473E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099249E-03_JPRB, 0.37099118E-03_JPRB, 0.37099005E-03_JPRB, 0.37098888E-03_JPRB, 0.37098804E-03_JPRB, 0.37098749E-03_JPRB, &
  & 0.37098740E-03_JPRB, 0.37098752E-03_JPRB, 0.37098798E-03_JPRB, 0.37098833E-03_JPRB, 0.37098830E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098746E-03_JPRB, 0.37098723E-03_JPRB, 0.37098699E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098635E-03_JPRB, 0.37098618E-03_JPRB, 0.37098606E-03_JPRB, 0.37098592E-03_JPRB, 0.37098583E-03_JPRB, &
  & 0.37098571E-03_JPRB, 0.37098560E-03_JPRB, 0.37098542E-03_JPRB, 0.37098519E-03_JPRB /)

RGHG1(:,61, 3) = (/ &
  & 0.37097847E-03_JPRB, 0.37097951E-03_JPRB, 0.37097989E-03_JPRB, 0.37098024E-03_JPRB, 0.37098047E-03_JPRB, 0.37098065E-03_JPRB, &
  & 0.37098076E-03_JPRB, 0.37098094E-03_JPRB, 0.37098100E-03_JPRB, 0.37098106E-03_JPRB, 0.37098106E-03_JPRB, 0.37098106E-03_JPRB, &
  & 0.37098106E-03_JPRB, 0.37098106E-03_JPRB, 0.37098100E-03_JPRB, 0.37098100E-03_JPRB, 0.37098108E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098225E-03_JPRB, 0.37098356E-03_JPRB, 0.37098536E-03_JPRB, 0.37098752E-03_JPRB, 0.37098996E-03_JPRB, 0.37099209E-03_JPRB, &
  & 0.37099418E-03_JPRB, 0.37099572E-03_JPRB, 0.37099692E-03_JPRB, 0.37099767E-03_JPRB, 0.37099811E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099753E-03_JPRB, 0.37099689E-03_JPRB, 0.37099596E-03_JPRB, 0.37099494E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099278E-03_JPRB, 0.37099162E-03_JPRB, 0.37099063E-03_JPRB, 0.37098947E-03_JPRB, 0.37098877E-03_JPRB, 0.37098830E-03_JPRB, &
  & 0.37098830E-03_JPRB, 0.37098851E-03_JPRB, 0.37098888E-03_JPRB, 0.37098932E-03_JPRB, 0.37098932E-03_JPRB, 0.37098912E-03_JPRB, &
  & 0.37098883E-03_JPRB, 0.37098856E-03_JPRB, 0.37098827E-03_JPRB, 0.37098807E-03_JPRB, 0.37098792E-03_JPRB, 0.37098775E-03_JPRB, &
  & 0.37098757E-03_JPRB, 0.37098737E-03_JPRB, 0.37098720E-03_JPRB, 0.37098705E-03_JPRB, 0.37098699E-03_JPRB, 0.37098691E-03_JPRB, &
  & 0.37098682E-03_JPRB, 0.37098670E-03_JPRB, 0.37098661E-03_JPRB, 0.37098635E-03_JPRB /)

RGHG1(:,62, 3) = (/ &
  & 0.37098050E-03_JPRB, 0.37098123E-03_JPRB, 0.37098149E-03_JPRB, 0.37098167E-03_JPRB, 0.37098187E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098225E-03_JPRB, 0.37098231E-03_JPRB, 0.37098236E-03_JPRB, 0.37098239E-03_JPRB, 0.37098245E-03_JPRB, 0.37098245E-03_JPRB, &
  & 0.37098248E-03_JPRB, 0.37098257E-03_JPRB, 0.37098254E-03_JPRB, 0.37098245E-03_JPRB, 0.37098266E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098362E-03_JPRB, 0.37098478E-03_JPRB, 0.37098644E-03_JPRB, 0.37098848E-03_JPRB, 0.37099069E-03_JPRB, 0.37099276E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099619E-03_JPRB, 0.37099735E-03_JPRB, 0.37099796E-03_JPRB, 0.37099837E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099785E-03_JPRB, 0.37099718E-03_JPRB, 0.37099628E-03_JPRB, 0.37099532E-03_JPRB, 0.37099421E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099209E-03_JPRB, 0.37099118E-03_JPRB, 0.37099019E-03_JPRB, 0.37098947E-03_JPRB, 0.37098918E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37098944E-03_JPRB, 0.37098990E-03_JPRB, 0.37099031E-03_JPRB, 0.37099037E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37098958E-03_JPRB, 0.37098926E-03_JPRB, 0.37098903E-03_JPRB, 0.37098886E-03_JPRB, 0.37098868E-03_JPRB, &
  & 0.37098848E-03_JPRB, 0.37098830E-03_JPRB, 0.37098816E-03_JPRB, 0.37098804E-03_JPRB, 0.37098792E-03_JPRB, 0.37098784E-03_JPRB, &
  & 0.37098769E-03_JPRB, 0.37098757E-03_JPRB, 0.37098752E-03_JPRB, 0.37098728E-03_JPRB /)

RGHG1(:,63, 3) = (/ &
  & 0.37098213E-03_JPRB, 0.37098269E-03_JPRB, 0.37098292E-03_JPRB, 0.37098309E-03_JPRB, 0.37098327E-03_JPRB, 0.37098338E-03_JPRB, &
  & 0.37098350E-03_JPRB, 0.37098362E-03_JPRB, 0.37098373E-03_JPRB, 0.37098382E-03_JPRB, 0.37098385E-03_JPRB, 0.37098391E-03_JPRB, &
  & 0.37098388E-03_JPRB, 0.37098397E-03_JPRB, 0.37098402E-03_JPRB, 0.37098391E-03_JPRB, 0.37098408E-03_JPRB, 0.37098417E-03_JPRB, &
  & 0.37098487E-03_JPRB, 0.37098603E-03_JPRB, 0.37098766E-03_JPRB, 0.37098944E-03_JPRB, 0.37099159E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099665E-03_JPRB, 0.37099773E-03_JPRB, 0.37099828E-03_JPRB, 0.37099869E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099808E-03_JPRB, 0.37099750E-03_JPRB, 0.37099663E-03_JPRB, 0.37099567E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099261E-03_JPRB, 0.37099174E-03_JPRB, 0.37099081E-03_JPRB, 0.37099014E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37099040E-03_JPRB, 0.37099081E-03_JPRB, 0.37099124E-03_JPRB, 0.37099127E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099060E-03_JPRB, 0.37099025E-03_JPRB, 0.37098996E-03_JPRB, 0.37098976E-03_JPRB, 0.37098955E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098918E-03_JPRB, 0.37098903E-03_JPRB, 0.37098891E-03_JPRB, 0.37098874E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098833E-03_JPRB, 0.37098824E-03_JPRB, 0.37098807E-03_JPRB /)

RGHG1(:,64, 3) = (/ &
  & 0.37098350E-03_JPRB, 0.37098402E-03_JPRB, 0.37098426E-03_JPRB, 0.37098443E-03_JPRB, 0.37098461E-03_JPRB, 0.37098472E-03_JPRB, &
  & 0.37098484E-03_JPRB, 0.37098496E-03_JPRB, 0.37098507E-03_JPRB, 0.37098525E-03_JPRB, 0.37098536E-03_JPRB, 0.37098542E-03_JPRB, &
  & 0.37098545E-03_JPRB, 0.37098548E-03_JPRB, 0.37098554E-03_JPRB, 0.37098539E-03_JPRB, 0.37098545E-03_JPRB, 0.37098562E-03_JPRB, &
  & 0.37098621E-03_JPRB, 0.37098725E-03_JPRB, 0.37098877E-03_JPRB, 0.37099043E-03_JPRB, 0.37099252E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099712E-03_JPRB, 0.37099805E-03_JPRB, 0.37099855E-03_JPRB, 0.37099895E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099840E-03_JPRB, 0.37099788E-03_JPRB, 0.37099698E-03_JPRB, 0.37099610E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099316E-03_JPRB, 0.37099235E-03_JPRB, 0.37099145E-03_JPRB, 0.37099095E-03_JPRB, 0.37099075E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37099127E-03_JPRB, 0.37099171E-03_JPRB, 0.37099209E-03_JPRB, 0.37099223E-03_JPRB, 0.37099206E-03_JPRB, &
  & 0.37099188E-03_JPRB, 0.37099147E-03_JPRB, 0.37099113E-03_JPRB, 0.37099083E-03_JPRB, 0.37099057E-03_JPRB, 0.37099037E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37099002E-03_JPRB, 0.37098984E-03_JPRB, 0.37098967E-03_JPRB, 0.37098955E-03_JPRB, 0.37098941E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098912E-03_JPRB, 0.37098897E-03_JPRB, 0.37098874E-03_JPRB /)

RGHG1(:,65, 3) = (/ &
  & 0.37098472E-03_JPRB, 0.37098519E-03_JPRB, 0.37098536E-03_JPRB, 0.37098548E-03_JPRB, 0.37098565E-03_JPRB, 0.37098586E-03_JPRB, &
  & 0.37098606E-03_JPRB, 0.37098629E-03_JPRB, 0.37098641E-03_JPRB, 0.37098659E-03_JPRB, 0.37098667E-03_JPRB, 0.37098670E-03_JPRB, &
  & 0.37098688E-03_JPRB, 0.37098702E-03_JPRB, 0.37098699E-03_JPRB, 0.37098679E-03_JPRB, 0.37098676E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098749E-03_JPRB, 0.37098851E-03_JPRB, 0.37098990E-03_JPRB, 0.37099153E-03_JPRB, 0.37099334E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099750E-03_JPRB, 0.37099846E-03_JPRB, 0.37099887E-03_JPRB, 0.37099922E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099869E-03_JPRB, 0.37099811E-03_JPRB, 0.37099735E-03_JPRB, 0.37099654E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099465E-03_JPRB, 0.37099374E-03_JPRB, 0.37099293E-03_JPRB, 0.37099217E-03_JPRB, 0.37099177E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099179E-03_JPRB, 0.37099217E-03_JPRB, 0.37099264E-03_JPRB, 0.37099299E-03_JPRB, 0.37099316E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099273E-03_JPRB, 0.37099238E-03_JPRB, 0.37099209E-03_JPRB, 0.37099171E-03_JPRB, 0.37099142E-03_JPRB, 0.37099121E-03_JPRB, &
  & 0.37099101E-03_JPRB, 0.37099083E-03_JPRB, 0.37099057E-03_JPRB, 0.37099037E-03_JPRB, 0.37099019E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098979E-03_JPRB, 0.37098961E-03_JPRB, 0.37098932E-03_JPRB /)

RGHG1(:,66, 3) = (/ &
  & 0.37098592E-03_JPRB, 0.37098635E-03_JPRB, 0.37098653E-03_JPRB, 0.37098670E-03_JPRB, 0.37098688E-03_JPRB, 0.37098699E-03_JPRB, &
  & 0.37098723E-03_JPRB, 0.37098746E-03_JPRB, 0.37098766E-03_JPRB, 0.37098781E-03_JPRB, 0.37098798E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098819E-03_JPRB, 0.37098830E-03_JPRB, 0.37098833E-03_JPRB, 0.37098821E-03_JPRB, 0.37098821E-03_JPRB, 0.37098833E-03_JPRB, &
  & 0.37098888E-03_JPRB, 0.37098979E-03_JPRB, 0.37099110E-03_JPRB, 0.37099255E-03_JPRB, 0.37099415E-03_JPRB, 0.37099564E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099791E-03_JPRB, 0.37099878E-03_JPRB, 0.37099913E-03_JPRB, 0.37099951E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099898E-03_JPRB, 0.37099846E-03_JPRB, 0.37099782E-03_JPRB, 0.37099695E-03_JPRB, 0.37099596E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37099433E-03_JPRB, 0.37099360E-03_JPRB, 0.37099287E-03_JPRB, 0.37099249E-03_JPRB, 0.37099238E-03_JPRB, &
  & 0.37099252E-03_JPRB, 0.37099296E-03_JPRB, 0.37099342E-03_JPRB, 0.37099377E-03_JPRB, 0.37099395E-03_JPRB, 0.37099383E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099322E-03_JPRB, 0.37099287E-03_JPRB, 0.37099252E-03_JPRB, 0.37099226E-03_JPRB, 0.37099203E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099156E-03_JPRB, 0.37099133E-03_JPRB, 0.37099110E-03_JPRB, 0.37099095E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099066E-03_JPRB, 0.37099043E-03_JPRB, 0.37099025E-03_JPRB, 0.37098993E-03_JPRB /)

RGHG1(:,67, 3) = (/ &
  & 0.37098693E-03_JPRB, 0.37098740E-03_JPRB, 0.37098766E-03_JPRB, 0.37098781E-03_JPRB, 0.37098798E-03_JPRB, 0.37098813E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098868E-03_JPRB, 0.37098894E-03_JPRB, 0.37098918E-03_JPRB, 0.37098920E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098967E-03_JPRB, 0.37098970E-03_JPRB, 0.37098958E-03_JPRB, 0.37098958E-03_JPRB, 0.37098967E-03_JPRB, &
  & 0.37099022E-03_JPRB, 0.37099101E-03_JPRB, 0.37099214E-03_JPRB, 0.37099354E-03_JPRB, 0.37099491E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099823E-03_JPRB, 0.37099898E-03_JPRB, 0.37099939E-03_JPRB, 0.37099971E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099925E-03_JPRB, 0.37099875E-03_JPRB, 0.37099823E-03_JPRB, 0.37099732E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099503E-03_JPRB, 0.37099427E-03_JPRB, 0.37099372E-03_JPRB, 0.37099340E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099383E-03_JPRB, 0.37099433E-03_JPRB, 0.37099471E-03_JPRB, 0.37099482E-03_JPRB, 0.37099471E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099409E-03_JPRB, 0.37099366E-03_JPRB, 0.37099334E-03_JPRB, 0.37099305E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099249E-03_JPRB, 0.37099238E-03_JPRB, 0.37099217E-03_JPRB, 0.37099191E-03_JPRB, 0.37099171E-03_JPRB, 0.37099150E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099107E-03_JPRB, 0.37099086E-03_JPRB, 0.37099046E-03_JPRB /)

RGHG1(:,68, 3) = (/ &
  & 0.37098798E-03_JPRB, 0.37098848E-03_JPRB, 0.37098874E-03_JPRB, 0.37098891E-03_JPRB, 0.37098906E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098952E-03_JPRB, 0.37098993E-03_JPRB, 0.37099014E-03_JPRB, 0.37099040E-03_JPRB, 0.37099051E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37099075E-03_JPRB, 0.37099083E-03_JPRB, 0.37099092E-03_JPRB, 0.37099083E-03_JPRB, 0.37099092E-03_JPRB, 0.37099098E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099223E-03_JPRB, 0.37099328E-03_JPRB, 0.37099444E-03_JPRB, 0.37099564E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099773E-03_JPRB, 0.37099855E-03_JPRB, 0.37099922E-03_JPRB, 0.37099954E-03_JPRB, 0.37099989E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099948E-03_JPRB, 0.37099893E-03_JPRB, 0.37099852E-03_JPRB, 0.37099770E-03_JPRB, 0.37099703E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099564E-03_JPRB, 0.37099497E-03_JPRB, 0.37099447E-03_JPRB, 0.37099418E-03_JPRB, 0.37099395E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099456E-03_JPRB, 0.37099514E-03_JPRB, 0.37099555E-03_JPRB, 0.37099561E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099494E-03_JPRB, 0.37099459E-03_JPRB, 0.37099424E-03_JPRB, 0.37099392E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099337E-03_JPRB, 0.37099322E-03_JPRB, 0.37099287E-03_JPRB, 0.37099264E-03_JPRB, 0.37099238E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099188E-03_JPRB, 0.37099165E-03_JPRB, 0.37099101E-03_JPRB /)

RGHG1(:,69, 3) = (/ &
  & 0.37098883E-03_JPRB, 0.37098941E-03_JPRB, 0.37098967E-03_JPRB, 0.37098990E-03_JPRB, 0.37099011E-03_JPRB, 0.37099031E-03_JPRB, &
  & 0.37099069E-03_JPRB, 0.37099113E-03_JPRB, 0.37099136E-03_JPRB, 0.37099159E-03_JPRB, 0.37099171E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099197E-03_JPRB, 0.37099211E-03_JPRB, 0.37099214E-03_JPRB, 0.37099211E-03_JPRB, 0.37099229E-03_JPRB, 0.37099226E-03_JPRB, &
  & 0.37099281E-03_JPRB, 0.37099348E-03_JPRB, 0.37099441E-03_JPRB, 0.37099535E-03_JPRB, 0.37099639E-03_JPRB, 0.37099727E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099878E-03_JPRB, 0.37099942E-03_JPRB, 0.37099974E-03_JPRB, 0.37100009E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099965E-03_JPRB, 0.37099925E-03_JPRB, 0.37099881E-03_JPRB, 0.37099811E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099619E-03_JPRB, 0.37099572E-03_JPRB, 0.37099532E-03_JPRB, 0.37099505E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099537E-03_JPRB, 0.37099596E-03_JPRB, 0.37099631E-03_JPRB, 0.37099633E-03_JPRB, 0.37099619E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099569E-03_JPRB, 0.37099532E-03_JPRB, 0.37099500E-03_JPRB, 0.37099473E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099395E-03_JPRB, 0.37099366E-03_JPRB, 0.37099331E-03_JPRB, 0.37099305E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099264E-03_JPRB, 0.37099241E-03_JPRB, 0.37099156E-03_JPRB /)

RGHG1(:,70, 3) = (/ &
  & 0.37098979E-03_JPRB, 0.37099043E-03_JPRB, 0.37099069E-03_JPRB, 0.37099089E-03_JPRB, 0.37099121E-03_JPRB, 0.37099145E-03_JPRB, &
  & 0.37099185E-03_JPRB, 0.37099229E-03_JPRB, 0.37099264E-03_JPRB, 0.37099287E-03_JPRB, 0.37099284E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099310E-03_JPRB, 0.37099328E-03_JPRB, 0.37099325E-03_JPRB, 0.37099328E-03_JPRB, 0.37099354E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099406E-03_JPRB, 0.37099456E-03_JPRB, 0.37099546E-03_JPRB, 0.37099613E-03_JPRB, 0.37099698E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099901E-03_JPRB, 0.37099951E-03_JPRB, 0.37099983E-03_JPRB, 0.37100026E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099974E-03_JPRB, 0.37099951E-03_JPRB, 0.37099910E-03_JPRB, 0.37099849E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099683E-03_JPRB, 0.37099636E-03_JPRB, 0.37099613E-03_JPRB, 0.37099587E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37099619E-03_JPRB, 0.37099683E-03_JPRB, 0.37099709E-03_JPRB, 0.37099703E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099636E-03_JPRB, 0.37099610E-03_JPRB, 0.37099584E-03_JPRB, 0.37099552E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099471E-03_JPRB, 0.37099438E-03_JPRB, 0.37099409E-03_JPRB, 0.37099377E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099357E-03_JPRB, 0.37099345E-03_JPRB, 0.37099328E-03_JPRB, 0.37099217E-03_JPRB /)

RGHG1(:,71, 3) = (/ &
  & 0.37099066E-03_JPRB, 0.37099150E-03_JPRB, 0.37099182E-03_JPRB, 0.37099200E-03_JPRB, 0.37099232E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099348E-03_JPRB, 0.37099386E-03_JPRB, 0.37099406E-03_JPRB, 0.37099404E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099441E-03_JPRB, 0.37099433E-03_JPRB, 0.37099427E-03_JPRB, 0.37099479E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099555E-03_JPRB, 0.37099642E-03_JPRB, 0.37099700E-03_JPRB, 0.37099756E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099916E-03_JPRB, 0.37099971E-03_JPRB, 0.37099994E-03_JPRB, 0.37100038E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099997E-03_JPRB, 0.37099971E-03_JPRB, 0.37099954E-03_JPRB, 0.37099895E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099738E-03_JPRB, 0.37099703E-03_JPRB, 0.37099695E-03_JPRB, 0.37099674E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099700E-03_JPRB, 0.37099753E-03_JPRB, 0.37099782E-03_JPRB, 0.37099779E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099718E-03_JPRB, 0.37099686E-03_JPRB, 0.37099665E-03_JPRB, 0.37099639E-03_JPRB, 0.37099561E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099540E-03_JPRB, 0.37099520E-03_JPRB, 0.37099476E-03_JPRB, 0.37099444E-03_JPRB, 0.37099430E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099436E-03_JPRB, 0.37099412E-03_JPRB, 0.37099302E-03_JPRB /)

RGHG1(:,72, 3) = (/ &
  & 0.37099153E-03_JPRB, 0.37099235E-03_JPRB, 0.37099278E-03_JPRB, 0.37099287E-03_JPRB, 0.37099328E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099462E-03_JPRB, 0.37099497E-03_JPRB, 0.37099529E-03_JPRB, 0.37099523E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099546E-03_JPRB, 0.37099552E-03_JPRB, 0.37099535E-03_JPRB, 0.37099517E-03_JPRB, 0.37099604E-03_JPRB, 0.37099564E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099642E-03_JPRB, 0.37099735E-03_JPRB, 0.37099770E-03_JPRB, 0.37099811E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099927E-03_JPRB, 0.37100000E-03_JPRB, 0.37100026E-03_JPRB, 0.37100061E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100012E-03_JPRB, 0.37099997E-03_JPRB, 0.37099989E-03_JPRB, 0.37099939E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099796E-03_JPRB, 0.37099779E-03_JPRB, 0.37099782E-03_JPRB, 0.37099756E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099762E-03_JPRB, 0.37099823E-03_JPRB, 0.37099837E-03_JPRB, 0.37099849E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099776E-03_JPRB, 0.37099756E-03_JPRB, 0.37099744E-03_JPRB, 0.37099721E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099601E-03_JPRB, 0.37099590E-03_JPRB, 0.37099543E-03_JPRB, 0.37099508E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099523E-03_JPRB, 0.37099511E-03_JPRB, 0.37099395E-03_JPRB /)

RGHG1(:,73, 3) = (/ &
  & 0.37099258E-03_JPRB, 0.37099340E-03_JPRB, 0.37099392E-03_JPRB, 0.37099383E-03_JPRB, 0.37099433E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099572E-03_JPRB, 0.37099613E-03_JPRB, 0.37099645E-03_JPRB, 0.37099636E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099657E-03_JPRB, 0.37099625E-03_JPRB, 0.37099599E-03_JPRB, 0.37099718E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099718E-03_JPRB, 0.37099823E-03_JPRB, 0.37099843E-03_JPRB, 0.37099855E-03_JPRB, 0.37099907E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099933E-03_JPRB, 0.37100021E-03_JPRB, 0.37100050E-03_JPRB, 0.37100088E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100023E-03_JPRB, 0.37100012E-03_JPRB, 0.37100021E-03_JPRB, 0.37099997E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099855E-03_JPRB, 0.37099855E-03_JPRB, 0.37099869E-03_JPRB, 0.37099834E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099826E-03_JPRB, 0.37099884E-03_JPRB, 0.37099893E-03_JPRB, 0.37099916E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099840E-03_JPRB, 0.37099817E-03_JPRB, 0.37099826E-03_JPRB, 0.37099799E-03_JPRB, 0.37099680E-03_JPRB, &
  & 0.37099645E-03_JPRB, 0.37099660E-03_JPRB, 0.37099660E-03_JPRB, 0.37099607E-03_JPRB, 0.37099569E-03_JPRB, 0.37099575E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099607E-03_JPRB, 0.37099604E-03_JPRB, 0.37099491E-03_JPRB /)

RGHG1(:,74, 3) = (/ &
  & 0.37099369E-03_JPRB, 0.37099447E-03_JPRB, 0.37099503E-03_JPRB, 0.37099468E-03_JPRB, 0.37099529E-03_JPRB, 0.37099578E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099680E-03_JPRB, 0.37099715E-03_JPRB, 0.37099759E-03_JPRB, 0.37099744E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099764E-03_JPRB, 0.37099709E-03_JPRB, 0.37099665E-03_JPRB, 0.37099828E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099794E-03_JPRB, 0.37099898E-03_JPRB, 0.37099907E-03_JPRB, 0.37099898E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099939E-03_JPRB, 0.37100044E-03_JPRB, 0.37100085E-03_JPRB, 0.37100117E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100053E-03_JPRB, 0.37100038E-03_JPRB, 0.37100058E-03_JPRB, 0.37100055E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099919E-03_JPRB, 0.37099933E-03_JPRB, 0.37099962E-03_JPRB, 0.37099910E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099878E-03_JPRB, 0.37099945E-03_JPRB, 0.37099945E-03_JPRB, 0.37099980E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099895E-03_JPRB, 0.37099869E-03_JPRB, 0.37099898E-03_JPRB, 0.37099872E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099709E-03_JPRB, 0.37099727E-03_JPRB, 0.37099654E-03_JPRB, 0.37099625E-03_JPRB, 0.37099636E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099692E-03_JPRB, 0.37099700E-03_JPRB, 0.37099578E-03_JPRB /)

RGHG1(:,75, 3) = (/ &
  & 0.37099488E-03_JPRB, 0.37099546E-03_JPRB, 0.37099610E-03_JPRB, 0.37099537E-03_JPRB, 0.37099613E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099773E-03_JPRB, 0.37099820E-03_JPRB, 0.37099863E-03_JPRB, 0.37099852E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099860E-03_JPRB, 0.37099779E-03_JPRB, 0.37099724E-03_JPRB, 0.37099939E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099852E-03_JPRB, 0.37099977E-03_JPRB, 0.37099971E-03_JPRB, 0.37099939E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099951E-03_JPRB, 0.37100073E-03_JPRB, 0.37100117E-03_JPRB, 0.37100152E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100067E-03_JPRB, 0.37100055E-03_JPRB, 0.37100093E-03_JPRB, 0.37100125E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099989E-03_JPRB, 0.37100029E-03_JPRB, 0.37100058E-03_JPRB, 0.37099986E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099942E-03_JPRB, 0.37100003E-03_JPRB, 0.37099980E-03_JPRB, 0.37100047E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099942E-03_JPRB, 0.37099913E-03_JPRB, 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37099750E-03_JPRB, 0.37099785E-03_JPRB, 0.37099703E-03_JPRB, 0.37099665E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099767E-03_JPRB, 0.37099791E-03_JPRB, 0.37099660E-03_JPRB /)

RGHG1(:,76, 3) = (/ &
  & 0.37099616E-03_JPRB, 0.37099639E-03_JPRB, 0.37099718E-03_JPRB, 0.37099596E-03_JPRB, 0.37099698E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099860E-03_JPRB, 0.37099910E-03_JPRB, 0.37099962E-03_JPRB, 0.37099951E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099954E-03_JPRB, 0.37099846E-03_JPRB, 0.37099764E-03_JPRB, 0.37100044E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099895E-03_JPRB, 0.37100053E-03_JPRB, 0.37100035E-03_JPRB, 0.37099968E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099957E-03_JPRB, 0.37100096E-03_JPRB, 0.37100160E-03_JPRB, 0.37100198E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100128E-03_JPRB, 0.37100090E-03_JPRB, 0.37100064E-03_JPRB, 0.37100131E-03_JPRB, 0.37100207E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100058E-03_JPRB, 0.37100125E-03_JPRB, 0.37100160E-03_JPRB, 0.37100067E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100000E-03_JPRB, 0.37100061E-03_JPRB, 0.37100018E-03_JPRB, 0.37100114E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099977E-03_JPRB, 0.37099951E-03_JPRB, 0.37100026E-03_JPRB, 0.37100006E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37099770E-03_JPRB, 0.37099840E-03_JPRB, 0.37099747E-03_JPRB, 0.37099703E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099834E-03_JPRB, 0.37099884E-03_JPRB, 0.37099738E-03_JPRB /)

RGHG1(:,77, 3) = (/ &
  & 0.37099747E-03_JPRB, 0.37099724E-03_JPRB, 0.37099834E-03_JPRB, 0.37099631E-03_JPRB, 0.37099759E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099927E-03_JPRB, 0.37099989E-03_JPRB, 0.37100053E-03_JPRB, 0.37100044E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100050E-03_JPRB, 0.37099919E-03_JPRB, 0.37099799E-03_JPRB, 0.37100137E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37099904E-03_JPRB, 0.37100122E-03_JPRB, 0.37100090E-03_JPRB, 0.37099991E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099968E-03_JPRB, 0.37100131E-03_JPRB, 0.37100201E-03_JPRB, 0.37100250E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100114E-03_JPRB, 0.37100082E-03_JPRB, 0.37100172E-03_JPRB, 0.37100282E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100137E-03_JPRB, 0.37100227E-03_JPRB, 0.37100268E-03_JPRB, 0.37100143E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37100055E-03_JPRB, 0.37100125E-03_JPRB, 0.37100044E-03_JPRB, 0.37100178E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37100012E-03_JPRB, 0.37099974E-03_JPRB, 0.37100093E-03_JPRB, 0.37100085E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099674E-03_JPRB, 0.37099779E-03_JPRB, 0.37099904E-03_JPRB, 0.37099785E-03_JPRB, 0.37099730E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099898E-03_JPRB, 0.37099980E-03_JPRB, 0.37099817E-03_JPRB /)

RGHG1(:,78, 3) = (/ &
  & 0.37099881E-03_JPRB, 0.37099799E-03_JPRB, 0.37099957E-03_JPRB, 0.37099651E-03_JPRB, 0.37099811E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099983E-03_JPRB, 0.37100070E-03_JPRB, 0.37100134E-03_JPRB, 0.37100120E-03_JPRB, 0.37100169E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100125E-03_JPRB, 0.37099962E-03_JPRB, 0.37099828E-03_JPRB, 0.37100207E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099910E-03_JPRB, 0.37100192E-03_JPRB, 0.37100140E-03_JPRB, 0.37100009E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099971E-03_JPRB, 0.37100157E-03_JPRB, 0.37100245E-03_JPRB, 0.37100300E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100137E-03_JPRB, 0.37100096E-03_JPRB, 0.37100201E-03_JPRB, 0.37100358E-03_JPRB, 0.37100195E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100210E-03_JPRB, 0.37100323E-03_JPRB, 0.37100376E-03_JPRB, 0.37100216E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100105E-03_JPRB, 0.37100178E-03_JPRB, 0.37100061E-03_JPRB, 0.37100253E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100032E-03_JPRB, 0.37099991E-03_JPRB, 0.37100149E-03_JPRB, 0.37100157E-03_JPRB, 0.37099686E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099788E-03_JPRB, 0.37099962E-03_JPRB, 0.37099802E-03_JPRB, 0.37099732E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099951E-03_JPRB, 0.37100067E-03_JPRB, 0.37099887E-03_JPRB /)

RGHG1(:,79, 3) = (/ &
  & 0.37099994E-03_JPRB, 0.37099834E-03_JPRB, 0.37100038E-03_JPRB, 0.37099631E-03_JPRB, 0.37099837E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100021E-03_JPRB, 0.37100114E-03_JPRB, 0.37100201E-03_JPRB, 0.37100181E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100399E-03_JPRB, 0.37100186E-03_JPRB, 0.37099989E-03_JPRB, 0.37099828E-03_JPRB, 0.37100280E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37099907E-03_JPRB, 0.37100259E-03_JPRB, 0.37100189E-03_JPRB, 0.37100035E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099974E-03_JPRB, 0.37100195E-03_JPRB, 0.37100297E-03_JPRB, 0.37100364E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100169E-03_JPRB, 0.37100117E-03_JPRB, 0.37100248E-03_JPRB, 0.37100451E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100277E-03_JPRB, 0.37100428E-03_JPRB, 0.37100475E-03_JPRB, 0.37100282E-03_JPRB, 0.37100195E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100149E-03_JPRB, 0.37100233E-03_JPRB, 0.37100076E-03_JPRB, 0.37100320E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100055E-03_JPRB, 0.37100006E-03_JPRB, 0.37100201E-03_JPRB, 0.37100224E-03_JPRB, 0.37099639E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099767E-03_JPRB, 0.37100003E-03_JPRB, 0.37099814E-03_JPRB, 0.37099721E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37099983E-03_JPRB, 0.37100137E-03_JPRB, 0.37099951E-03_JPRB /)

RGHG1(:,80, 3) = (/ &
  & 0.37100099E-03_JPRB, 0.37099846E-03_JPRB, 0.37100082E-03_JPRB, 0.37099601E-03_JPRB, 0.37099834E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100038E-03_JPRB, 0.37100154E-03_JPRB, 0.37100233E-03_JPRB, 0.37100227E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100475E-03_JPRB, 0.37100233E-03_JPRB, 0.37100000E-03_JPRB, 0.37099820E-03_JPRB, 0.37100338E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37099895E-03_JPRB, 0.37100306E-03_JPRB, 0.37100218E-03_JPRB, 0.37100050E-03_JPRB, 0.37100309E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099968E-03_JPRB, 0.37100224E-03_JPRB, 0.37100344E-03_JPRB, 0.37100413E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100303E-03_JPRB, 0.37100186E-03_JPRB, 0.37100137E-03_JPRB, 0.37100288E-03_JPRB, 0.37100515E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100315E-03_JPRB, 0.37100329E-03_JPRB, 0.37100495E-03_JPRB, 0.37100556E-03_JPRB, 0.37100341E-03_JPRB, 0.37100239E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100178E-03_JPRB, 0.37100265E-03_JPRB, 0.37100090E-03_JPRB, 0.37100376E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100064E-03_JPRB, 0.37100006E-03_JPRB, 0.37100233E-03_JPRB, 0.37100265E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099747E-03_JPRB, 0.37100021E-03_JPRB, 0.37099808E-03_JPRB, 0.37099698E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100000E-03_JPRB, 0.37100192E-03_JPRB, 0.37099994E-03_JPRB /)

RGHG1(:,81, 3) = (/ &
  & 0.37100207E-03_JPRB, 0.37099846E-03_JPRB, 0.37100099E-03_JPRB, 0.37099578E-03_JPRB, 0.37099834E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100055E-03_JPRB, 0.37100154E-03_JPRB, 0.37100262E-03_JPRB, 0.37100245E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100521E-03_JPRB, 0.37100256E-03_JPRB, 0.37100012E-03_JPRB, 0.37099805E-03_JPRB, 0.37100367E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37099890E-03_JPRB, 0.37100335E-03_JPRB, 0.37100242E-03_JPRB, 0.37100055E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099974E-03_JPRB, 0.37100242E-03_JPRB, 0.37100379E-03_JPRB, 0.37100454E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100332E-03_JPRB, 0.37100201E-03_JPRB, 0.37100154E-03_JPRB, 0.37100309E-03_JPRB, 0.37100553E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100361E-03_JPRB, 0.37100539E-03_JPRB, 0.37100603E-03_JPRB, 0.37100373E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37100198E-03_JPRB, 0.37100285E-03_JPRB, 0.37100088E-03_JPRB, 0.37100405E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100067E-03_JPRB, 0.37100015E-03_JPRB, 0.37100259E-03_JPRB, 0.37100297E-03_JPRB, 0.37099561E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099724E-03_JPRB, 0.37100026E-03_JPRB, 0.37099796E-03_JPRB, 0.37099683E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100012E-03_JPRB, 0.37100218E-03_JPRB, 0.37100023E-03_JPRB /)

RGHG1(:,82, 3) = (/ &
  & 0.37100210E-03_JPRB, 0.37099840E-03_JPRB, 0.37100114E-03_JPRB, 0.37099564E-03_JPRB, 0.37099840E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100058E-03_JPRB, 0.37100201E-03_JPRB, 0.37100274E-03_JPRB, 0.37100271E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100550E-03_JPRB, 0.37100277E-03_JPRB, 0.37100018E-03_JPRB, 0.37099802E-03_JPRB, 0.37100399E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37099878E-03_JPRB, 0.37100358E-03_JPRB, 0.37100250E-03_JPRB, 0.37100055E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099974E-03_JPRB, 0.37100253E-03_JPRB, 0.37100399E-03_JPRB, 0.37100475E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100352E-03_JPRB, 0.37100207E-03_JPRB, 0.37100157E-03_JPRB, 0.37100329E-03_JPRB, 0.37100579E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100367E-03_JPRB, 0.37100396E-03_JPRB, 0.37100574E-03_JPRB, 0.37100638E-03_JPRB, 0.37100399E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100213E-03_JPRB, 0.37100303E-03_JPRB, 0.37100090E-03_JPRB, 0.37100428E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100070E-03_JPRB, 0.37100018E-03_JPRB, 0.37100265E-03_JPRB, 0.37100306E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099503E-03_JPRB, 0.37099718E-03_JPRB, 0.37100035E-03_JPRB, 0.37099794E-03_JPRB, 0.37099668E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100018E-03_JPRB, 0.37100236E-03_JPRB, 0.37100029E-03_JPRB /)

RGHG1(:,83, 3) = (/ &
  & 0.37100218E-03_JPRB, 0.37099831E-03_JPRB, 0.37100117E-03_JPRB, 0.37099549E-03_JPRB, 0.37099843E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100163E-03_JPRB, 0.37100073E-03_JPRB, 0.37100157E-03_JPRB, 0.37100288E-03_JPRB, 0.37100277E-03_JPRB, 0.37100384E-03_JPRB, &
  & 0.37100565E-03_JPRB, 0.37100280E-03_JPRB, 0.37100012E-03_JPRB, 0.37099791E-03_JPRB, 0.37100408E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37099875E-03_JPRB, 0.37100376E-03_JPRB, 0.37100259E-03_JPRB, 0.37100061E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099974E-03_JPRB, 0.37100271E-03_JPRB, 0.37100419E-03_JPRB, 0.37100498E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100370E-03_JPRB, 0.37100216E-03_JPRB, 0.37100169E-03_JPRB, 0.37100344E-03_JPRB, 0.37100585E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100387E-03_JPRB, 0.37100419E-03_JPRB, 0.37100594E-03_JPRB, 0.37100664E-03_JPRB, 0.37100422E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100224E-03_JPRB, 0.37100317E-03_JPRB, 0.37100085E-03_JPRB, 0.37100448E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100073E-03_JPRB, 0.37100015E-03_JPRB, 0.37100280E-03_JPRB, 0.37100326E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099715E-03_JPRB, 0.37100041E-03_JPRB, 0.37099782E-03_JPRB, 0.37099660E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100023E-03_JPRB, 0.37100245E-03_JPRB, 0.37100032E-03_JPRB /)

RGHG1(:,84, 3) = (/ &
  & 0.37100230E-03_JPRB, 0.37099823E-03_JPRB, 0.37100117E-03_JPRB, 0.37099537E-03_JPRB, 0.37099834E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100076E-03_JPRB, 0.37100221E-03_JPRB, 0.37100288E-03_JPRB, 0.37100303E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100568E-03_JPRB, 0.37100297E-03_JPRB, 0.37100021E-03_JPRB, 0.37099791E-03_JPRB, 0.37100419E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37099875E-03_JPRB, 0.37100387E-03_JPRB, 0.37100265E-03_JPRB, 0.37100064E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099971E-03_JPRB, 0.37100280E-03_JPRB, 0.37100437E-03_JPRB, 0.37100515E-03_JPRB, 0.37100122E-03_JPRB, &
  & 0.37100376E-03_JPRB, 0.37100218E-03_JPRB, 0.37100178E-03_JPRB, 0.37100358E-03_JPRB, 0.37100588E-03_JPRB, 0.37100387E-03_JPRB, &
  & 0.37100402E-03_JPRB, 0.37100440E-03_JPRB, 0.37100603E-03_JPRB, 0.37100664E-03_JPRB, 0.37100440E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100236E-03_JPRB, 0.37100323E-03_JPRB, 0.37100090E-03_JPRB, 0.37100472E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100073E-03_JPRB, 0.37100012E-03_JPRB, 0.37100285E-03_JPRB, 0.37100335E-03_JPRB, 0.37099500E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099700E-03_JPRB, 0.37100050E-03_JPRB, 0.37099782E-03_JPRB, 0.37099654E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37100186E-03_JPRB, 0.37100026E-03_JPRB, 0.37100250E-03_JPRB, 0.37100035E-03_JPRB /)

RGHG1(:,85, 3) = (/ &
  & 0.37100224E-03_JPRB, 0.37099817E-03_JPRB, 0.37100117E-03_JPRB, 0.37099526E-03_JPRB, 0.37099831E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100105E-03_JPRB, 0.37100184E-03_JPRB, 0.37100300E-03_JPRB, 0.37100315E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100524E-03_JPRB, 0.37100297E-03_JPRB, 0.37100038E-03_JPRB, 0.37099817E-03_JPRB, 0.37100411E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37099863E-03_JPRB, 0.37100405E-03_JPRB, 0.37100280E-03_JPRB, 0.37100058E-03_JPRB, 0.37100393E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099959E-03_JPRB, 0.37100280E-03_JPRB, 0.37100445E-03_JPRB, 0.37100530E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100390E-03_JPRB, 0.37100233E-03_JPRB, 0.37100189E-03_JPRB, 0.37100373E-03_JPRB, 0.37100597E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100411E-03_JPRB, 0.37100451E-03_JPRB, 0.37100620E-03_JPRB, 0.37100678E-03_JPRB, 0.37100457E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100248E-03_JPRB, 0.37100341E-03_JPRB, 0.37100085E-03_JPRB, 0.37100486E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100067E-03_JPRB, 0.37100009E-03_JPRB, 0.37100294E-03_JPRB, 0.37100344E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099695E-03_JPRB, 0.37100047E-03_JPRB, 0.37099779E-03_JPRB, 0.37099642E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100029E-03_JPRB, 0.37100256E-03_JPRB, 0.37100041E-03_JPRB /)

RGHG1(:,86, 3) = (/ &
  & 0.37100224E-03_JPRB, 0.37099802E-03_JPRB, 0.37100122E-03_JPRB, 0.37099517E-03_JPRB, 0.37099846E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100125E-03_JPRB, 0.37100227E-03_JPRB, 0.37100288E-03_JPRB, 0.37100323E-03_JPRB, 0.37100381E-03_JPRB, &
  & 0.37100472E-03_JPRB, 0.37100300E-03_JPRB, 0.37100064E-03_JPRB, 0.37099875E-03_JPRB, 0.37100393E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37099863E-03_JPRB, 0.37100413E-03_JPRB, 0.37100280E-03_JPRB, 0.37100053E-03_JPRB, 0.37100411E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099951E-03_JPRB, 0.37100285E-03_JPRB, 0.37100457E-03_JPRB, 0.37100544E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100224E-03_JPRB, 0.37100189E-03_JPRB, 0.37100370E-03_JPRB, 0.37100603E-03_JPRB, 0.37100411E-03_JPRB, &
  & 0.37100419E-03_JPRB, 0.37100466E-03_JPRB, 0.37100632E-03_JPRB, 0.37100693E-03_JPRB, 0.37100475E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100259E-03_JPRB, 0.37100349E-03_JPRB, 0.37100085E-03_JPRB, 0.37100501E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100064E-03_JPRB, 0.37100003E-03_JPRB, 0.37100297E-03_JPRB, 0.37100352E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099689E-03_JPRB, 0.37100053E-03_JPRB, 0.37099776E-03_JPRB, 0.37099633E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100029E-03_JPRB, 0.37100250E-03_JPRB, 0.37100044E-03_JPRB /)

RGHG1(:,87, 3) = (/ &
  & 0.37100218E-03_JPRB, 0.37099791E-03_JPRB, 0.37100120E-03_JPRB, 0.37099523E-03_JPRB, 0.37099834E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100146E-03_JPRB, 0.37100213E-03_JPRB, 0.37100294E-03_JPRB, 0.37100317E-03_JPRB, 0.37100370E-03_JPRB, &
  & 0.37100428E-03_JPRB, 0.37100288E-03_JPRB, 0.37100088E-03_JPRB, 0.37099925E-03_JPRB, 0.37100370E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37099858E-03_JPRB, 0.37100425E-03_JPRB, 0.37100288E-03_JPRB, 0.37100044E-03_JPRB, 0.37100428E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099948E-03_JPRB, 0.37100288E-03_JPRB, 0.37100466E-03_JPRB, 0.37100562E-03_JPRB, 0.37100122E-03_JPRB, &
  & 0.37100411E-03_JPRB, 0.37100224E-03_JPRB, 0.37100184E-03_JPRB, 0.37100376E-03_JPRB, 0.37100617E-03_JPRB, 0.37100405E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100460E-03_JPRB, 0.37100658E-03_JPRB, 0.37100731E-03_JPRB, 0.37100472E-03_JPRB, 0.37100335E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100268E-03_JPRB, 0.37100364E-03_JPRB, 0.37100090E-03_JPRB, 0.37100515E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100058E-03_JPRB, 0.37100000E-03_JPRB, 0.37100297E-03_JPRB, 0.37100355E-03_JPRB, 0.37099453E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099683E-03_JPRB, 0.37100053E-03_JPRB, 0.37099762E-03_JPRB, 0.37099622E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100029E-03_JPRB, 0.37100250E-03_JPRB, 0.37100041E-03_JPRB /)

RGHG1(:,88, 3) = (/ &
  & 0.37100216E-03_JPRB, 0.37099791E-03_JPRB, 0.37100111E-03_JPRB, 0.37099520E-03_JPRB, 0.37099858E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100149E-03_JPRB, 0.37100233E-03_JPRB, 0.37100288E-03_JPRB, 0.37100317E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100288E-03_JPRB, 0.37100090E-03_JPRB, 0.37099939E-03_JPRB, 0.37100364E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37099858E-03_JPRB, 0.37100428E-03_JPRB, 0.37100300E-03_JPRB, 0.37100047E-03_JPRB, 0.37100451E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099936E-03_JPRB, 0.37100288E-03_JPRB, 0.37100469E-03_JPRB, 0.37100579E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100224E-03_JPRB, 0.37100184E-03_JPRB, 0.37100367E-03_JPRB, 0.37100643E-03_JPRB, 0.37100396E-03_JPRB, &
  & 0.37100419E-03_JPRB, 0.37100451E-03_JPRB, 0.37100678E-03_JPRB, 0.37100771E-03_JPRB, 0.37100480E-03_JPRB, 0.37100335E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100282E-03_JPRB, 0.37100381E-03_JPRB, 0.37100090E-03_JPRB, 0.37100530E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100055E-03_JPRB, 0.37099994E-03_JPRB, 0.37100303E-03_JPRB, 0.37100352E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099683E-03_JPRB, 0.37100064E-03_JPRB, 0.37099764E-03_JPRB, 0.37099613E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37100029E-03_JPRB, 0.37100259E-03_JPRB, 0.37100047E-03_JPRB /)

RGHG1(:,89, 3) = (/ &
  & 0.37100207E-03_JPRB, 0.37099811E-03_JPRB, 0.37100105E-03_JPRB, 0.37099532E-03_JPRB, 0.37099826E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37100143E-03_JPRB, 0.37100213E-03_JPRB, 0.37100288E-03_JPRB, 0.37100317E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100440E-03_JPRB, 0.37100288E-03_JPRB, 0.37100076E-03_JPRB, 0.37099916E-03_JPRB, 0.37100390E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37099846E-03_JPRB, 0.37100440E-03_JPRB, 0.37100303E-03_JPRB, 0.37100035E-03_JPRB, 0.37100469E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099930E-03_JPRB, 0.37100291E-03_JPRB, 0.37100480E-03_JPRB, 0.37100597E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100440E-03_JPRB, 0.37100227E-03_JPRB, 0.37100178E-03_JPRB, 0.37100373E-03_JPRB, 0.37100684E-03_JPRB, 0.37100373E-03_JPRB, &
  & 0.37100416E-03_JPRB, 0.37100440E-03_JPRB, 0.37100699E-03_JPRB, 0.37100815E-03_JPRB, 0.37100472E-03_JPRB, 0.37100352E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100294E-03_JPRB, 0.37100384E-03_JPRB, 0.37100085E-03_JPRB, 0.37100544E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100053E-03_JPRB, 0.37099994E-03_JPRB, 0.37100303E-03_JPRB, 0.37100367E-03_JPRB, 0.37099430E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099692E-03_JPRB, 0.37100067E-03_JPRB, 0.37099762E-03_JPRB, 0.37099607E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100032E-03_JPRB, 0.37100262E-03_JPRB, 0.37100050E-03_JPRB /)

RGHG1(:,90, 3) = (/ &
  & 0.37100189E-03_JPRB, 0.37099823E-03_JPRB, 0.37100099E-03_JPRB, 0.37099505E-03_JPRB, 0.37099837E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100120E-03_JPRB, 0.37100218E-03_JPRB, 0.37100300E-03_JPRB, 0.37100323E-03_JPRB, 0.37100405E-03_JPRB, &
  & 0.37100510E-03_JPRB, 0.37100312E-03_JPRB, 0.37100038E-03_JPRB, 0.37099840E-03_JPRB, 0.37100466E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37099826E-03_JPRB, 0.37100460E-03_JPRB, 0.37100312E-03_JPRB, 0.37100018E-03_JPRB, 0.37100510E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099927E-03_JPRB, 0.37100294E-03_JPRB, 0.37100486E-03_JPRB, 0.37100617E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100451E-03_JPRB, 0.37100210E-03_JPRB, 0.37100157E-03_JPRB, 0.37100364E-03_JPRB, 0.37100728E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37100419E-03_JPRB, 0.37100431E-03_JPRB, 0.37100710E-03_JPRB, 0.37100850E-03_JPRB, 0.37100466E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37100309E-03_JPRB, 0.37100405E-03_JPRB, 0.37100073E-03_JPRB, 0.37100579E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100055E-03_JPRB, 0.37099986E-03_JPRB, 0.37100312E-03_JPRB, 0.37100390E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099692E-03_JPRB, 0.37100088E-03_JPRB, 0.37099767E-03_JPRB, 0.37099601E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37100021E-03_JPRB, 0.37100271E-03_JPRB, 0.37100053E-03_JPRB /)

RGHG1(:,91, 3) = (/ &
  & 0.37100195E-03_JPRB, 0.37099849E-03_JPRB, 0.37100169E-03_JPRB, 0.37099412E-03_JPRB, 0.37099834E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100003E-03_JPRB, 0.37100184E-03_JPRB, 0.37100373E-03_JPRB, 0.37100262E-03_JPRB, 0.37100396E-03_JPRB, &
  & 0.37100742E-03_JPRB, 0.37100312E-03_JPRB, 0.37099980E-03_JPRB, 0.37099660E-03_JPRB, 0.37100626E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37099762E-03_JPRB, 0.37100512E-03_JPRB, 0.37100329E-03_JPRB, 0.37099968E-03_JPRB, 0.37100591E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099916E-03_JPRB, 0.37100312E-03_JPRB, 0.37100489E-03_JPRB, 0.37100672E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100507E-03_JPRB, 0.37100201E-03_JPRB, 0.37100131E-03_JPRB, 0.37100352E-03_JPRB, 0.37100789E-03_JPRB, 0.37100315E-03_JPRB, &
  & 0.37100419E-03_JPRB, 0.37100419E-03_JPRB, 0.37100731E-03_JPRB, 0.37100897E-03_JPRB, 0.37100448E-03_JPRB, 0.37100379E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100329E-03_JPRB, 0.37100434E-03_JPRB, 0.37100012E-03_JPRB, 0.37100646E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37100058E-03_JPRB, 0.37099962E-03_JPRB, 0.37100326E-03_JPRB, 0.37100457E-03_JPRB, 0.37099331E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099689E-03_JPRB, 0.37100143E-03_JPRB, 0.37099756E-03_JPRB, 0.37099572E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37100262E-03_JPRB, 0.37099994E-03_JPRB, 0.37100288E-03_JPRB, 0.37100047E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG1(:, 1, 4) = (/ &
  & 0.36050664E-03_JPRB, 0.36048738E-03_JPRB, 0.36047722E-03_JPRB, 0.36045688E-03_JPRB, 0.36042812E-03_JPRB, 0.36039020E-03_JPRB, &
  & 0.36034282E-03_JPRB, 0.36028304E-03_JPRB, 0.36020676E-03_JPRB, 0.36011200E-03_JPRB, 0.35999925E-03_JPRB, 0.35987198E-03_JPRB, &
  & 0.35973464E-03_JPRB, 0.35959220E-03_JPRB, 0.35944718E-03_JPRB, 0.35929919E-03_JPRB, 0.35914750E-03_JPRB, 0.35899278E-03_JPRB, &
  & 0.35883632E-03_JPRB, 0.35867863E-03_JPRB, 0.35851906E-03_JPRB, 0.35835576E-03_JPRB, 0.35819030E-03_JPRB, 0.35802688E-03_JPRB, &
  & 0.35798730E-03_JPRB, 0.35827450E-03_JPRB, 0.35875090E-03_JPRB, 0.35924796E-03_JPRB, 0.35972235E-03_JPRB, 0.36014809E-03_JPRB, &
  & 0.36051037E-03_JPRB, 0.36081474E-03_JPRB, 0.36108043E-03_JPRB, 0.36130025E-03_JPRB, 0.36146757E-03_JPRB, 0.36158744E-03_JPRB, &
  & 0.36165779E-03_JPRB, 0.36167420E-03_JPRB, 0.36163811E-03_JPRB, 0.36154879E-03_JPRB, 0.36146844E-03_JPRB, 0.36136722E-03_JPRB, &
  & 0.36124914E-03_JPRB, 0.36111023E-03_JPRB, 0.36094565E-03_JPRB, 0.36074902E-03_JPRB, 0.36051424E-03_JPRB, 0.36023255E-03_JPRB, &
  & 0.35988496E-03_JPRB, 0.35945812E-03_JPRB, 0.35898632E-03_JPRB, 0.35850922E-03_JPRB, 0.35806539E-03_JPRB, 0.35769929E-03_JPRB, &
  & 0.35744192E-03_JPRB, 0.35729856E-03_JPRB, 0.35724379E-03_JPRB, 0.35724218E-03_JPRB, 0.35726544E-03_JPRB, 0.35729763E-03_JPRB, &
  & 0.35735799E-03_JPRB, 0.35744347E-03_JPRB, 0.35755045E-03_JPRB, 0.35768835E-03_JPRB /)

RGHG1(:, 2, 4) = (/ &
  & 0.36083587E-03_JPRB, 0.36103182E-03_JPRB, 0.36113622E-03_JPRB, 0.36122062E-03_JPRB, 0.36127464E-03_JPRB, 0.36128942E-03_JPRB, &
  & 0.36125779E-03_JPRB, 0.36118465E-03_JPRB, 0.36108954E-03_JPRB, 0.36099614E-03_JPRB, 0.36091945E-03_JPRB, 0.36086194E-03_JPRB, &
  & 0.36081526E-03_JPRB, 0.36076829E-03_JPRB, 0.36071555E-03_JPRB, 0.36065897E-03_JPRB, 0.36060097E-03_JPRB, 0.36053977E-03_JPRB, &
  & 0.36047149E-03_JPRB, 0.36039314E-03_JPRB, 0.36030644E-03_JPRB, 0.36021924E-03_JPRB, 0.36014733E-03_JPRB, 0.36012070E-03_JPRB, &
  & 0.36019439E-03_JPRB, 0.36040804E-03_JPRB, 0.36073322E-03_JPRB, 0.36112522E-03_JPRB, 0.36155406E-03_JPRB, 0.36199536E-03_JPRB, &
  & 0.36241973E-03_JPRB, 0.36279659E-03_JPRB, 0.36311243E-03_JPRB, 0.36335975E-03_JPRB, 0.36354669E-03_JPRB, 0.36368147E-03_JPRB, &
  & 0.36377093E-03_JPRB, 0.36381453E-03_JPRB, 0.36380827E-03_JPRB, 0.36375009E-03_JPRB, 0.36366103E-03_JPRB, 0.36354054E-03_JPRB, &
  & 0.36338955E-03_JPRB, 0.36320562E-03_JPRB, 0.36298062E-03_JPRB, 0.36270794E-03_JPRB, 0.36238020E-03_JPRB, 0.36199577E-03_JPRB, &
  & 0.36156521E-03_JPRB, 0.36111288E-03_JPRB, 0.36066587E-03_JPRB, 0.36023094E-03_JPRB, 0.35980897E-03_JPRB, 0.35942058E-03_JPRB, &
  & 0.35909400E-03_JPRB, 0.35885515E-03_JPRB, 0.35869970E-03_JPRB, 0.35861135E-03_JPRB, 0.35856746E-03_JPRB, 0.35855034E-03_JPRB, &
  & 0.35854994E-03_JPRB, 0.35855986E-03_JPRB, 0.35857421E-03_JPRB, 0.35857072E-03_JPRB /)

RGHG1(:, 3, 4) = (/ &
  & 0.36117347E-03_JPRB, 0.36140665E-03_JPRB, 0.36151777E-03_JPRB, 0.36159341E-03_JPRB, 0.36164297E-03_JPRB, 0.36167327E-03_JPRB, &
  & 0.36170695E-03_JPRB, 0.36176681E-03_JPRB, 0.36185849E-03_JPRB, 0.36196923E-03_JPRB, 0.36208151E-03_JPRB, 0.36218422E-03_JPRB, &
  & 0.36227133E-03_JPRB, 0.36234027E-03_JPRB, 0.36239013E-03_JPRB, 0.36242575E-03_JPRB, 0.36245503E-03_JPRB, 0.36247916E-03_JPRB, &
  & 0.36249295E-03_JPRB, 0.36249214E-03_JPRB, 0.36247683E-03_JPRB, 0.36245419E-03_JPRB, 0.36244080E-03_JPRB, 0.36246394E-03_JPRB, &
  & 0.36255084E-03_JPRB, 0.36270675E-03_JPRB, 0.36291851E-03_JPRB, 0.36316775E-03_JPRB, 0.36344345E-03_JPRB, 0.36373467E-03_JPRB, &
  & 0.36402294E-03_JPRB, 0.36428272E-03_JPRB, 0.36449166E-03_JPRB, 0.36464960E-03_JPRB, 0.36476043E-03_JPRB, 0.36483633E-03_JPRB, &
  & 0.36488302E-03_JPRB, 0.36490100E-03_JPRB, 0.36488695E-03_JPRB, 0.36483724E-03_JPRB, 0.36475487E-03_JPRB, 0.36464326E-03_JPRB, &
  & 0.36450470E-03_JPRB, 0.36433560E-03_JPRB, 0.36413071E-03_JPRB, 0.36388187E-03_JPRB, 0.36358484E-03_JPRB, 0.36323688E-03_JPRB, &
  & 0.36284380E-03_JPRB, 0.36241705E-03_JPRB, 0.36197182E-03_JPRB, 0.36153285E-03_JPRB, 0.36112871E-03_JPRB, 0.36077845E-03_JPRB, &
  & 0.36049227E-03_JPRB, 0.36026695E-03_JPRB, 0.36010164E-03_JPRB, 0.35998679E-03_JPRB, 0.35991200E-03_JPRB, 0.35986362E-03_JPRB, &
  & 0.35982899E-03_JPRB, 0.35979805E-03_JPRB, 0.35975914E-03_JPRB, 0.35969086E-03_JPRB /)

RGHG1(:, 4, 4) = (/ &
  & 0.36147935E-03_JPRB, 0.36177743E-03_JPRB, 0.36193820E-03_JPRB, 0.36208541E-03_JPRB, 0.36224053E-03_JPRB, 0.36241929E-03_JPRB, &
  & 0.36261440E-03_JPRB, 0.36280806E-03_JPRB, 0.36298676E-03_JPRB, 0.36314491E-03_JPRB, 0.36328434E-03_JPRB, 0.36340969E-03_JPRB, &
  & 0.36352506E-03_JPRB, 0.36363240E-03_JPRB, 0.36373304E-03_JPRB, 0.36382538E-03_JPRB, 0.36390618E-03_JPRB, 0.36397585E-03_JPRB, &
  & 0.36403985E-03_JPRB, 0.36410493E-03_JPRB, 0.36417632E-03_JPRB, 0.36425720E-03_JPRB, 0.36435039E-03_JPRB, 0.36445813E-03_JPRB, &
  & 0.36457769E-03_JPRB, 0.36470522E-03_JPRB, 0.36483421E-03_JPRB, 0.36496273E-03_JPRB, 0.36508814E-03_JPRB, 0.36520555E-03_JPRB, &
  & 0.36530758E-03_JPRB, 0.36538640E-03_JPRB, 0.36544111E-03_JPRB, 0.36547467E-03_JPRB, 0.36549228E-03_JPRB, 0.36549655E-03_JPRB, &
  & 0.36548826E-03_JPRB, 0.36546463E-03_JPRB, 0.36542065E-03_JPRB, 0.36535066E-03_JPRB, 0.36525074E-03_JPRB, 0.36512158E-03_JPRB, &
  & 0.36496576E-03_JPRB, 0.36478625E-03_JPRB, 0.36458118E-03_JPRB, 0.36435109E-03_JPRB, 0.36409419E-03_JPRB, 0.36381540E-03_JPRB, &
  & 0.36352070E-03_JPRB, 0.36321787E-03_JPRB, 0.36291717E-03_JPRB, 0.36262631E-03_JPRB, 0.36234618E-03_JPRB, 0.36207592E-03_JPRB, &
  & 0.36181757E-03_JPRB, 0.36158273E-03_JPRB, 0.36137906E-03_JPRB, 0.36121224E-03_JPRB, 0.36108182E-03_JPRB, 0.36098142E-03_JPRB, &
  & 0.36090412E-03_JPRB, 0.36084166E-03_JPRB, 0.36078645E-03_JPRB, 0.36070094E-03_JPRB /)

RGHG1(:, 5, 4) = (/ &
  & 0.36180069E-03_JPRB, 0.36220119E-03_JPRB, 0.36245651E-03_JPRB, 0.36269592E-03_JPRB, 0.36294226E-03_JPRB, 0.36318606E-03_JPRB, &
  & 0.36341639E-03_JPRB, 0.36362751E-03_JPRB, 0.36381662E-03_JPRB, 0.36398313E-03_JPRB, 0.36412268E-03_JPRB, 0.36423339E-03_JPRB, &
  & 0.36432134E-03_JPRB, 0.36439853E-03_JPRB, 0.36447748E-03_JPRB, 0.36456611E-03_JPRB, 0.36466529E-03_JPRB, 0.36477327E-03_JPRB, &
  & 0.36489006E-03_JPRB, 0.36501538E-03_JPRB, 0.36514644E-03_JPRB, 0.36528014E-03_JPRB, 0.36541332E-03_JPRB, 0.36554169E-03_JPRB, &
  & 0.36566035E-03_JPRB, 0.36576553E-03_JPRB, 0.36585773E-03_JPRB, 0.36593631E-03_JPRB, 0.36600046E-03_JPRB, 0.36604673E-03_JPRB, &
  & 0.36607188E-03_JPRB, 0.36607316E-03_JPRB, 0.36605450E-03_JPRB, 0.36602284E-03_JPRB, 0.36598369E-03_JPRB, 0.36593954E-03_JPRB, &
  & 0.36588992E-03_JPRB, 0.36583107E-03_JPRB, 0.36575657E-03_JPRB, 0.36566029E-03_JPRB, 0.36553666E-03_JPRB, 0.36538651E-03_JPRB, &
  & 0.36521288E-03_JPRB, 0.36501794E-03_JPRB, 0.36480912E-03_JPRB, 0.36459151E-03_JPRB, 0.36437425E-03_JPRB, 0.36415987E-03_JPRB, &
  & 0.36395027E-03_JPRB, 0.36374567E-03_JPRB, 0.36354401E-03_JPRB, 0.36334293E-03_JPRB, 0.36314115E-03_JPRB, 0.36294025E-03_JPRB, &
  & 0.36274505E-03_JPRB, 0.36255940E-03_JPRB, 0.36238725E-03_JPRB, 0.36223308E-03_JPRB, 0.36209970E-03_JPRB, 0.36198972E-03_JPRB, &
  & 0.36189731E-03_JPRB, 0.36181536E-03_JPRB, 0.36172790E-03_JPRB, 0.36158442E-03_JPRB /)

RGHG1(:, 6, 4) = (/ &
  & 0.36218448E-03_JPRB, 0.36271074E-03_JPRB, 0.36303961E-03_JPRB, 0.36332518E-03_JPRB, 0.36358877E-03_JPRB, 0.36383013E-03_JPRB, &
  & 0.36404326E-03_JPRB, 0.36422274E-03_JPRB, 0.36437102E-03_JPRB, 0.36449567E-03_JPRB, 0.36460490E-03_JPRB, 0.36470269E-03_JPRB, &
  & 0.36479061E-03_JPRB, 0.36487204E-03_JPRB, 0.36495106E-03_JPRB, 0.36503220E-03_JPRB, 0.36512199E-03_JPRB, 0.36522435E-03_JPRB, &
  & 0.36533928E-03_JPRB, 0.36546349E-03_JPRB, 0.36559429E-03_JPRB, 0.36572944E-03_JPRB, 0.36586582E-03_JPRB, 0.36599766E-03_JPRB, &
  & 0.36611781E-03_JPRB, 0.36622226E-03_JPRB, 0.36631053E-03_JPRB, 0.36638294E-03_JPRB, 0.36643865E-03_JPRB, 0.36647468E-03_JPRB, &
  & 0.36648760E-03_JPRB, 0.36647526E-03_JPRB, 0.36644030E-03_JPRB, 0.36638943E-03_JPRB, 0.36632887E-03_JPRB, 0.36626184E-03_JPRB, &
  & 0.36618876E-03_JPRB, 0.36610718E-03_JPRB, 0.36601259E-03_JPRB, 0.36589932E-03_JPRB, 0.36576318E-03_JPRB, 0.36560200E-03_JPRB, &
  & 0.36542409E-03_JPRB, 0.36524062E-03_JPRB, 0.36505912E-03_JPRB, 0.36488200E-03_JPRB, 0.36470787E-03_JPRB, 0.36453933E-03_JPRB, &
  & 0.36437841E-03_JPRB, 0.36422344E-03_JPRB, 0.36407128E-03_JPRB, 0.36391962E-03_JPRB, 0.36376741E-03_JPRB, 0.36361560E-03_JPRB, &
  & 0.36346514E-03_JPRB, 0.36331816E-03_JPRB, 0.36317910E-03_JPRB, 0.36305215E-03_JPRB, 0.36294185E-03_JPRB, 0.36284706E-03_JPRB, &
  & 0.36276702E-03_JPRB, 0.36269487E-03_JPRB, 0.36262124E-03_JPRB, 0.36249709E-03_JPRB /)

RGHG1(:, 7, 4) = (/ &
  & 0.36268597E-03_JPRB, 0.36333158E-03_JPRB, 0.36368382E-03_JPRB, 0.36395065E-03_JPRB, 0.36416721E-03_JPRB, 0.36434465E-03_JPRB, &
  & 0.36448997E-03_JPRB, 0.36461127E-03_JPRB, 0.36471416E-03_JPRB, 0.36480368E-03_JPRB, 0.36488505E-03_JPRB, 0.36496288E-03_JPRB, &
  & 0.36503910E-03_JPRB, 0.36511448E-03_JPRB, 0.36519044E-03_JPRB, 0.36526972E-03_JPRB, 0.36535476E-03_JPRB, 0.36544877E-03_JPRB, &
  & 0.36555371E-03_JPRB, 0.36567010E-03_JPRB, 0.36579542E-03_JPRB, 0.36592566E-03_JPRB, 0.36605902E-03_JPRB, 0.36619359E-03_JPRB, &
  & 0.36632220E-03_JPRB, 0.36643827E-03_JPRB, 0.36653818E-03_JPRB, 0.36662116E-03_JPRB, 0.36668484E-03_JPRB, 0.36672640E-03_JPRB, &
  & 0.36674240E-03_JPRB, 0.36673166E-03_JPRB, 0.36669639E-03_JPRB, 0.36664199E-03_JPRB, 0.36657415E-03_JPRB, 0.36649656E-03_JPRB, &
  & 0.36641100E-03_JPRB, 0.36631574E-03_JPRB, 0.36620704E-03_JPRB, 0.36608224E-03_JPRB, 0.36594179E-03_JPRB, 0.36579344E-03_JPRB, &
  & 0.36564036E-03_JPRB, 0.36548419E-03_JPRB, 0.36532874E-03_JPRB, 0.36518121E-03_JPRB, 0.36504568E-03_JPRB, 0.36491806E-03_JPRB, &
  & 0.36479312E-03_JPRB, 0.36466925E-03_JPRB, 0.36454538E-03_JPRB, 0.36442076E-03_JPRB, 0.36429521E-03_JPRB, 0.36416930E-03_JPRB, &
  & 0.36404526E-03_JPRB, 0.36392696E-03_JPRB, 0.36381761E-03_JPRB, 0.36371936E-03_JPRB, 0.36363385E-03_JPRB, 0.36356313E-03_JPRB, &
  & 0.36350387E-03_JPRB, 0.36345189E-03_JPRB, 0.36339642E-03_JPRB, 0.36330233E-03_JPRB /)

RGHG1(:, 8, 4) = (/ &
  & 0.36331316E-03_JPRB, 0.36395347E-03_JPRB, 0.36423409E-03_JPRB, 0.36441931E-03_JPRB, 0.36456174E-03_JPRB, 0.36468043E-03_JPRB, &
  & 0.36478371E-03_JPRB, 0.36487705E-03_JPRB, 0.36496442E-03_JPRB, 0.36504757E-03_JPRB, 0.36512752E-03_JPRB, 0.36520412E-03_JPRB, &
  & 0.36527743E-03_JPRB, 0.36534769E-03_JPRB, 0.36541643E-03_JPRB, 0.36548564E-03_JPRB, 0.36555878E-03_JPRB, 0.36563841E-03_JPRB, &
  & 0.36572709E-03_JPRB, 0.36582683E-03_JPRB, 0.36593911E-03_JPRB, 0.36606373E-03_JPRB, 0.36619636E-03_JPRB, 0.36633195E-03_JPRB, &
  & 0.36646819E-03_JPRB, 0.36659520E-03_JPRB, 0.36670704E-03_JPRB, 0.36679846E-03_JPRB, 0.36686746E-03_JPRB, 0.36691054E-03_JPRB, &
  & 0.36692532E-03_JPRB, 0.36691202E-03_JPRB, 0.36687357E-03_JPRB, 0.36681519E-03_JPRB, 0.36674298E-03_JPRB, 0.36666053E-03_JPRB, &
  & 0.36656731E-03_JPRB, 0.36646327E-03_JPRB, 0.36634953E-03_JPRB, 0.36622671E-03_JPRB, 0.36609374E-03_JPRB, 0.36594991E-03_JPRB, &
  & 0.36580412E-03_JPRB, 0.36566536E-03_JPRB, 0.36553890E-03_JPRB, 0.36542237E-03_JPRB, 0.36531239E-03_JPRB, 0.36520703E-03_JPRB, &
  & 0.36510511E-03_JPRB, 0.36500429E-03_JPRB, 0.36490351E-03_JPRB, 0.36480208E-03_JPRB, 0.36470051E-03_JPRB, 0.36459978E-03_JPRB, &
  & 0.36450196E-03_JPRB, 0.36440857E-03_JPRB, 0.36432192E-03_JPRB, 0.36424474E-03_JPRB, 0.36417958E-03_JPRB, 0.36412600E-03_JPRB, &
  & 0.36408257E-03_JPRB, 0.36404523E-03_JPRB, 0.36400833E-03_JPRB, 0.36394884E-03_JPRB /)

RGHG1(:, 9, 4) = (/ &
  & 0.36394276E-03_JPRB, 0.36441258E-03_JPRB, 0.36460161E-03_JPRB, 0.36473383E-03_JPRB, 0.36484483E-03_JPRB, 0.36494777E-03_JPRB, &
  & 0.36504725E-03_JPRB, 0.36514574E-03_JPRB, 0.36524338E-03_JPRB, 0.36534067E-03_JPRB, 0.36543628E-03_JPRB, 0.36552857E-03_JPRB, &
  & 0.36561498E-03_JPRB, 0.36569423E-03_JPRB, 0.36576675E-03_JPRB, 0.36583477E-03_JPRB, 0.36590116E-03_JPRB, 0.36596984E-03_JPRB, &
  & 0.36604464E-03_JPRB, 0.36612828E-03_JPRB, 0.36622310E-03_JPRB, 0.36633020E-03_JPRB, 0.36644802E-03_JPRB, 0.36657165E-03_JPRB, &
  & 0.36669237E-03_JPRB, 0.36680687E-03_JPRB, 0.36690701E-03_JPRB, 0.36698882E-03_JPRB, 0.36704782E-03_JPRB, 0.36708012E-03_JPRB, &
  & 0.36708341E-03_JPRB, 0.36705719E-03_JPRB, 0.36700585E-03_JPRB, 0.36693539E-03_JPRB, 0.36685070E-03_JPRB, 0.36675655E-03_JPRB, &
  & 0.36665684E-03_JPRB, 0.36655081E-03_JPRB, 0.36643457E-03_JPRB, 0.36630762E-03_JPRB, 0.36617526E-03_JPRB, 0.36604481E-03_JPRB, &
  & 0.36591719E-03_JPRB, 0.36579216E-03_JPRB, 0.36567269E-03_JPRB, 0.36556236E-03_JPRB, 0.36546373E-03_JPRB, 0.36537449E-03_JPRB, &
  & 0.36528989E-03_JPRB, 0.36520779E-03_JPRB, 0.36512699E-03_JPRB, 0.36504664E-03_JPRB, 0.36496719E-03_JPRB, 0.36488936E-03_JPRB, &
  & 0.36481381E-03_JPRB, 0.36474253E-03_JPRB, 0.36467749E-03_JPRB, 0.36462009E-03_JPRB, 0.36457123E-03_JPRB, 0.36453153E-03_JPRB, &
  & 0.36449978E-03_JPRB, 0.36447309E-03_JPRB, 0.36444719E-03_JPRB, 0.36440860E-03_JPRB /)

RGHG1(:,10, 4) = (/ &
  & 0.36445557E-03_JPRB, 0.36475973E-03_JPRB, 0.36490429E-03_JPRB, 0.36501675E-03_JPRB, 0.36512350E-03_JPRB, 0.36523145E-03_JPRB, &
  & 0.36534353E-03_JPRB, 0.36546026E-03_JPRB, 0.36558087E-03_JPRB, 0.36570409E-03_JPRB, 0.36582767E-03_JPRB, 0.36594897E-03_JPRB, &
  & 0.36606423E-03_JPRB, 0.36617066E-03_JPRB, 0.36626702E-03_JPRB, 0.36635395E-03_JPRB, 0.36643312E-03_JPRB, 0.36650721E-03_JPRB, &
  & 0.36657945E-03_JPRB, 0.36665265E-03_JPRB, 0.36672922E-03_JPRB, 0.36680992E-03_JPRB, 0.36689377E-03_JPRB, 0.36697762E-03_JPRB, &
  & 0.36705812E-03_JPRB, 0.36712989E-03_JPRB, 0.36719182E-03_JPRB, 0.36723877E-03_JPRB, 0.36726627E-03_JPRB, 0.36727067E-03_JPRB, &
  & 0.36724936E-03_JPRB, 0.36720256E-03_JPRB, 0.36713289E-03_JPRB, 0.36704427E-03_JPRB, 0.36694296E-03_JPRB, 0.36683347E-03_JPRB, &
  & 0.36671697E-03_JPRB, 0.36659688E-03_JPRB, 0.36647770E-03_JPRB, 0.36635957E-03_JPRB, 0.36623847E-03_JPRB, 0.36611239E-03_JPRB, &
  & 0.36598369E-03_JPRB, 0.36585832E-03_JPRB, 0.36574079E-03_JPRB, 0.36563390E-03_JPRB, 0.36553759E-03_JPRB, 0.36545083E-03_JPRB, &
  & 0.36537275E-03_JPRB, 0.36530121E-03_JPRB, 0.36523363E-03_JPRB, 0.36516902E-03_JPRB, 0.36510694E-03_JPRB, 0.36504731E-03_JPRB, &
  & 0.36499090E-03_JPRB, 0.36493799E-03_JPRB, 0.36488971E-03_JPRB, 0.36484760E-03_JPRB, 0.36481238E-03_JPRB, 0.36478369E-03_JPRB, &
  & 0.36476061E-03_JPRB, 0.36474178E-03_JPRB, 0.36472449E-03_JPRB, 0.36470106E-03_JPRB /)

RGHG1(:,11, 4) = (/ &
  & 0.36484597E-03_JPRB, 0.36507510E-03_JPRB, 0.36519987E-03_JPRB, 0.36531180E-03_JPRB, 0.36542397E-03_JPRB, 0.36554350E-03_JPRB, &
  & 0.36567173E-03_JPRB, 0.36580817E-03_JPRB, 0.36595168E-03_JPRB, 0.36610037E-03_JPRB, 0.36625200E-03_JPRB, 0.36640291E-03_JPRB, &
  & 0.36654947E-03_JPRB, 0.36668751E-03_JPRB, 0.36681467E-03_JPRB, 0.36692998E-03_JPRB, 0.36703338E-03_JPRB, 0.36712553E-03_JPRB, &
  & 0.36720643E-03_JPRB, 0.36727692E-03_JPRB, 0.36733813E-03_JPRB, 0.36739057E-03_JPRB, 0.36743542E-03_JPRB, 0.36747250E-03_JPRB, &
  & 0.36750146E-03_JPRB, 0.36752174E-03_JPRB, 0.36753315E-03_JPRB, 0.36753510E-03_JPRB, 0.36752457E-03_JPRB, 0.36749669E-03_JPRB, &
  & 0.36744776E-03_JPRB, 0.36737759E-03_JPRB, 0.36728827E-03_JPRB, 0.36718301E-03_JPRB, 0.36706694E-03_JPRB, 0.36694336E-03_JPRB, &
  & 0.36681769E-03_JPRB, 0.36669208E-03_JPRB, 0.36656670E-03_JPRB, 0.36644129E-03_JPRB, 0.36631618E-03_JPRB, 0.36619068E-03_JPRB, &
  & 0.36606353E-03_JPRB, 0.36593544E-03_JPRB, 0.36581067E-03_JPRB, 0.36569417E-03_JPRB, 0.36558934E-03_JPRB, 0.36549702E-03_JPRB, &
  & 0.36541536E-03_JPRB, 0.36534233E-03_JPRB, 0.36527656E-03_JPRB, 0.36521666E-03_JPRB, 0.36516157E-03_JPRB, 0.36511087E-03_JPRB, &
  & 0.36506430E-03_JPRB, 0.36502263E-03_JPRB, 0.36498593E-03_JPRB, 0.36495441E-03_JPRB, 0.36492824E-03_JPRB, 0.36490714E-03_JPRB, &
  & 0.36489053E-03_JPRB, 0.36487693E-03_JPRB, 0.36486494E-03_JPRB, 0.36485048E-03_JPRB /)

RGHG1(:,12, 4) = (/ &
  & 0.36517606E-03_JPRB, 0.36538549E-03_JPRB, 0.36551559E-03_JPRB, 0.36563250E-03_JPRB, 0.36575500E-03_JPRB, 0.36588623E-03_JPRB, &
  & 0.36602819E-03_JPRB, 0.36617980E-03_JPRB, 0.36633995E-03_JPRB, 0.36650649E-03_JPRB, 0.36667689E-03_JPRB, 0.36684723E-03_JPRB, &
  & 0.36701321E-03_JPRB, 0.36717116E-03_JPRB, 0.36731755E-03_JPRB, 0.36745056E-03_JPRB, 0.36756851E-03_JPRB, 0.36767067E-03_JPRB, &
  & 0.36775586E-03_JPRB, 0.36782399E-03_JPRB, 0.36787486E-03_JPRB, 0.36790950E-03_JPRB, 0.36792911E-03_JPRB, 0.36793511E-03_JPRB, &
  & 0.36792911E-03_JPRB, 0.36791296E-03_JPRB, 0.36788790E-03_JPRB, 0.36785365E-03_JPRB, 0.36780929E-03_JPRB, 0.36775440E-03_JPRB, &
  & 0.36768633E-03_JPRB, 0.36760222E-03_JPRB, 0.36750402E-03_JPRB, 0.36739395E-03_JPRB, 0.36727381E-03_JPRB, 0.36714747E-03_JPRB, &
  & 0.36701671E-03_JPRB, 0.36688516E-03_JPRB, 0.36675431E-03_JPRB, 0.36662564E-03_JPRB, 0.36649767E-03_JPRB, 0.36636851E-03_JPRB, &
  & 0.36623736E-03_JPRB, 0.36610384E-03_JPRB, 0.36597037E-03_JPRB, 0.36584050E-03_JPRB, 0.36571830E-03_JPRB, 0.36560584E-03_JPRB, &
  & 0.36550511E-03_JPRB, 0.36541553E-03_JPRB, 0.36533625E-03_JPRB, 0.36526594E-03_JPRB, 0.36520345E-03_JPRB, 0.36514801E-03_JPRB, &
  & 0.36509905E-03_JPRB, 0.36505680E-03_JPRB, 0.36502135E-03_JPRB, 0.36499207E-03_JPRB, 0.36496870E-03_JPRB, 0.36495028E-03_JPRB, &
  & 0.36493578E-03_JPRB, 0.36492449E-03_JPRB, 0.36491483E-03_JPRB, 0.36490409E-03_JPRB /)

RGHG1(:,13, 4) = (/ &
  & 0.36550869E-03_JPRB, 0.36573532E-03_JPRB, 0.36587275E-03_JPRB, 0.36600055E-03_JPRB, 0.36613047E-03_JPRB, 0.36626967E-03_JPRB, &
  & 0.36641865E-03_JPRB, 0.36657712E-03_JPRB, 0.36674342E-03_JPRB, 0.36691525E-03_JPRB, 0.36709043E-03_JPRB, 0.36726511E-03_JPRB, &
  & 0.36743484E-03_JPRB, 0.36759683E-03_JPRB, 0.36774669E-03_JPRB, 0.36788211E-03_JPRB, 0.36800100E-03_JPRB, 0.36810237E-03_JPRB, &
  & 0.36818482E-03_JPRB, 0.36824829E-03_JPRB, 0.36829244E-03_JPRB, 0.36831803E-03_JPRB, 0.36832615E-03_JPRB, 0.36831867E-03_JPRB, &
  & 0.36829690E-03_JPRB, 0.36826302E-03_JPRB, 0.36821878E-03_JPRB, 0.36816584E-03_JPRB, 0.36810443E-03_JPRB, 0.36803458E-03_JPRB, &
  & 0.36795699E-03_JPRB, 0.36787032E-03_JPRB, 0.36777399E-03_JPRB, 0.36767207E-03_JPRB, 0.36756331E-03_JPRB, 0.36744674E-03_JPRB, &
  & 0.36732835E-03_JPRB, 0.36721083E-03_JPRB, 0.36709296E-03_JPRB, 0.36697683E-03_JPRB, 0.36685987E-03_JPRB, 0.36673687E-03_JPRB, &
  & 0.36660692E-03_JPRB, 0.36646807E-03_JPRB, 0.36632165E-03_JPRB, 0.36617223E-03_JPRB, 0.36602479E-03_JPRB, 0.36588512E-03_JPRB, &
  & 0.36575549E-03_JPRB, 0.36563745E-03_JPRB, 0.36553061E-03_JPRB, 0.36543456E-03_JPRB, 0.36534815E-03_JPRB, 0.36527112E-03_JPRB, &
  & 0.36520316E-03_JPRB, 0.36514434E-03_JPRB, 0.36509495E-03_JPRB, 0.36505450E-03_JPRB, 0.36502228E-03_JPRB, 0.36499731E-03_JPRB, &
  & 0.36497816E-03_JPRB, 0.36496314E-03_JPRB, 0.36495097E-03_JPRB, 0.36493785E-03_JPRB /)

RGHG1(:,14, 4) = (/ &
  & 0.36589810E-03_JPRB, 0.36614272E-03_JPRB, 0.36629173E-03_JPRB, 0.36642171E-03_JPRB, 0.36655326E-03_JPRB, 0.36669060E-03_JPRB, &
  & 0.36683591E-03_JPRB, 0.36698932E-03_JPRB, 0.36714959E-03_JPRB, 0.36731525E-03_JPRB, 0.36748304E-03_JPRB, 0.36764905E-03_JPRB, &
  & 0.36780909E-03_JPRB, 0.36796037E-03_JPRB, 0.36810062E-03_JPRB, 0.36822743E-03_JPRB, 0.36833892E-03_JPRB, 0.36843360E-03_JPRB, &
  & 0.36851110E-03_JPRB, 0.36857044E-03_JPRB, 0.36861119E-03_JPRB, 0.36863363E-03_JPRB, 0.36863878E-03_JPRB, 0.36862784E-03_JPRB, &
  & 0.36860243E-03_JPRB, 0.36856497E-03_JPRB, 0.36851721E-03_JPRB, 0.36846037E-03_JPRB, 0.36839614E-03_JPRB, 0.36832469E-03_JPRB, &
  & 0.36824652E-03_JPRB, 0.36816247E-03_JPRB, 0.36807239E-03_JPRB, 0.36797702E-03_JPRB, 0.36788281E-03_JPRB, 0.36779145E-03_JPRB, &
  & 0.36770216E-03_JPRB, 0.36761645E-03_JPRB, 0.36753152E-03_JPRB, 0.36744459E-03_JPRB, 0.36735192E-03_JPRB, 0.36724855E-03_JPRB, &
  & 0.36713207E-03_JPRB, 0.36699965E-03_JPRB, 0.36685157E-03_JPRB, 0.36669226E-03_JPRB, 0.36652936E-03_JPRB, 0.36636877E-03_JPRB, &
  & 0.36621612E-03_JPRB, 0.36607301E-03_JPRB, 0.36593972E-03_JPRB, 0.36581550E-03_JPRB, 0.36570034E-03_JPRB, 0.36559399E-03_JPRB, &
  & 0.36549743E-03_JPRB, 0.36541146E-03_JPRB, 0.36533648E-03_JPRB, 0.36527318E-03_JPRB, 0.36522123E-03_JPRB, 0.36518005E-03_JPRB, &
  & 0.36514783E-03_JPRB, 0.36512315E-03_JPRB, 0.36510293E-03_JPRB, 0.36508369E-03_JPRB /)

RGHG1(:,15, 4) = (/ &
  & 0.36635075E-03_JPRB, 0.36660134E-03_JPRB, 0.36674517E-03_JPRB, 0.36686976E-03_JPRB, 0.36699156E-03_JPRB, 0.36711778E-03_JPRB, &
  & 0.36725047E-03_JPRB, 0.36738976E-03_JPRB, 0.36753537E-03_JPRB, 0.36768557E-03_JPRB, 0.36783810E-03_JPRB, 0.36798909E-03_JPRB, &
  & 0.36813348E-03_JPRB, 0.36826881E-03_JPRB, 0.36839323E-03_JPRB, 0.36850688E-03_JPRB, 0.36860805E-03_JPRB, 0.36869547E-03_JPRB, &
  & 0.36876788E-03_JPRB, 0.36882481E-03_JPRB, 0.36886524E-03_JPRB, 0.36888864E-03_JPRB, 0.36889565E-03_JPRB, 0.36888785E-03_JPRB, &
  & 0.36886681E-03_JPRB, 0.36883459E-03_JPRB, 0.36879288E-03_JPRB, 0.36874230E-03_JPRB, 0.36868334E-03_JPRB, 0.36861739E-03_JPRB, &
  & 0.36854472E-03_JPRB, 0.36846651E-03_JPRB, 0.36838569E-03_JPRB, 0.36830473E-03_JPRB, 0.36822713E-03_JPRB, 0.36815653E-03_JPRB, &
  & 0.36809509E-03_JPRB, 0.36804003E-03_JPRB, 0.36798813E-03_JPRB, 0.36793438E-03_JPRB, 0.36787236E-03_JPRB, 0.36779637E-03_JPRB, &
  & 0.36770216E-03_JPRB, 0.36758641E-03_JPRB, 0.36745012E-03_JPRB, 0.36729776E-03_JPRB, 0.36713624E-03_JPRB, 0.36697337E-03_JPRB, &
  & 0.36681438E-03_JPRB, 0.36666208E-03_JPRB, 0.36651711E-03_JPRB, 0.36637887E-03_JPRB, 0.36624674E-03_JPRB, 0.36612077E-03_JPRB, &
  & 0.36600212E-03_JPRB, 0.36589248E-03_JPRB, 0.36579365E-03_JPRB, 0.36570738E-03_JPRB, 0.36563468E-03_JPRB, 0.36557575E-03_JPRB, &
  & 0.36552953E-03_JPRB, 0.36549362E-03_JPRB, 0.36546626E-03_JPRB, 0.36544248E-03_JPRB /)

RGHG1(:,16, 4) = (/ &
  & 0.36682907E-03_JPRB, 0.36706071E-03_JPRB, 0.36718976E-03_JPRB, 0.36729925E-03_JPRB, 0.36740629E-03_JPRB, 0.36751656E-03_JPRB, &
  & 0.36763266E-03_JPRB, 0.36775530E-03_JPRB, 0.36788394E-03_JPRB, 0.36801689E-03_JPRB, 0.36815132E-03_JPRB, 0.36828421E-03_JPRB, &
  & 0.36841212E-03_JPRB, 0.36853182E-03_JPRB, 0.36864195E-03_JPRB, 0.36874239E-03_JPRB, 0.36883357E-03_JPRB, 0.36891457E-03_JPRB, &
  & 0.36898389E-03_JPRB, 0.36904009E-03_JPRB, 0.36908220E-03_JPRB, 0.36910939E-03_JPRB, 0.36912196E-03_JPRB, 0.36912150E-03_JPRB, &
  & 0.36910974E-03_JPRB, 0.36908794E-03_JPRB, 0.36905709E-03_JPRB, 0.36901789E-03_JPRB, 0.36896949E-03_JPRB, 0.36891265E-03_JPRB, &
  & 0.36884801E-03_JPRB, 0.36877688E-03_JPRB, 0.36870348E-03_JPRB, 0.36863278E-03_JPRB, 0.36856925E-03_JPRB, 0.36851666E-03_JPRB, &
  & 0.36847702E-03_JPRB, 0.36844783E-03_JPRB, 0.36842411E-03_JPRB, 0.36839789E-03_JPRB, 0.36836159E-03_JPRB, 0.36830964E-03_JPRB, &
  & 0.36823700E-03_JPRB, 0.36814139E-03_JPRB, 0.36802315E-03_JPRB, 0.36788679E-03_JPRB, 0.36773895E-03_JPRB, 0.36758650E-03_JPRB, &
  & 0.36743554E-03_JPRB, 0.36728891E-03_JPRB, 0.36714727E-03_JPRB, 0.36701013E-03_JPRB, 0.36687640E-03_JPRB, 0.36674587E-03_JPRB, &
  & 0.36661964E-03_JPRB, 0.36650003E-03_JPRB, 0.36638969E-03_JPRB, 0.36629121E-03_JPRB, 0.36620727E-03_JPRB, 0.36613856E-03_JPRB, &
  & 0.36608477E-03_JPRB, 0.36604481E-03_JPRB, 0.36601583E-03_JPRB, 0.36599836E-03_JPRB /)

RGHG1(:,17, 4) = (/ &
  & 0.36728216E-03_JPRB, 0.36748248E-03_JPRB, 0.36759189E-03_JPRB, 0.36768534E-03_JPRB, 0.36777690E-03_JPRB, 0.36787213E-03_JPRB, &
  & 0.36797326E-03_JPRB, 0.36808112E-03_JPRB, 0.36819480E-03_JPRB, 0.36831253E-03_JPRB, 0.36843150E-03_JPRB, 0.36854824E-03_JPRB, &
  & 0.36866002E-03_JPRB, 0.36876518E-03_JPRB, 0.36886276E-03_JPRB, 0.36895229E-03_JPRB, 0.36903436E-03_JPRB, 0.36910921E-03_JPRB, &
  & 0.36917580E-03_JPRB, 0.36923232E-03_JPRB, 0.36927711E-03_JPRB, 0.36930988E-03_JPRB, 0.36933017E-03_JPRB, 0.36933919E-03_JPRB, &
  & 0.36933873E-03_JPRB, 0.36932912E-03_JPRB, 0.36931160E-03_JPRB, 0.36928584E-03_JPRB, 0.36925063E-03_JPRB, 0.36920520E-03_JPRB, &
  & 0.36915080E-03_JPRB, 0.36908910E-03_JPRB, 0.36902417E-03_JPRB, 0.36896192E-03_JPRB, 0.36890834E-03_JPRB, 0.36886806E-03_JPRB, &
  & 0.36884283E-03_JPRB, 0.36883014E-03_JPRB, 0.36882350E-03_JPRB, 0.36881512E-03_JPRB, 0.36879617E-03_JPRB, 0.36876064E-03_JPRB, &
  & 0.36870429E-03_JPRB, 0.36862481E-03_JPRB, 0.36852315E-03_JPRB, 0.36840353E-03_JPRB, 0.36827155E-03_JPRB, 0.36813461E-03_JPRB, &
  & 0.36799771E-03_JPRB, 0.36786299E-03_JPRB, 0.36773179E-03_JPRB, 0.36760356E-03_JPRB, 0.36747745E-03_JPRB, 0.36735326E-03_JPRB, &
  & 0.36723170E-03_JPRB, 0.36711522E-03_JPRB, 0.36700675E-03_JPRB, 0.36690931E-03_JPRB, 0.36682564E-03_JPRB, 0.36675783E-03_JPRB, &
  & 0.36670585E-03_JPRB, 0.36666865E-03_JPRB, 0.36664490E-03_JPRB, 0.36663807E-03_JPRB /)

RGHG1(:,18, 4) = (/ &
  & 0.36768342E-03_JPRB, 0.36785140E-03_JPRB, 0.36794515E-03_JPRB, 0.36802501E-03_JPRB, 0.36810432E-03_JPRB, 0.36818755E-03_JPRB, &
  & 0.36827655E-03_JPRB, 0.36837225E-03_JPRB, 0.36847364E-03_JPRB, 0.36857877E-03_JPRB, 0.36868503E-03_JPRB, 0.36878901E-03_JPRB, &
  & 0.36888826E-03_JPRB, 0.36898095E-03_JPRB, 0.36906725E-03_JPRB, 0.36914740E-03_JPRB, 0.36922187E-03_JPRB, 0.36929059E-03_JPRB, &
  & 0.36935374E-03_JPRB, 0.36940977E-03_JPRB, 0.36945706E-03_JPRB, 0.36949455E-03_JPRB, 0.36952188E-03_JPRB, 0.36953995E-03_JPRB, &
  & 0.36954950E-03_JPRB, 0.36955220E-03_JPRB, 0.36954792E-03_JPRB, 0.36953625E-03_JPRB, 0.36951518E-03_JPRB, 0.36948442E-03_JPRB, &
  & 0.36944330E-03_JPRB, 0.36939449E-03_JPRB, 0.36934181E-03_JPRB, 0.36929079E-03_JPRB, 0.36924690E-03_JPRB, 0.36921527E-03_JPRB, &
  & 0.36919795E-03_JPRB, 0.36919277E-03_JPRB, 0.36919303E-03_JPRB, 0.36919059E-03_JPRB, 0.36917810E-03_JPRB, 0.36914932E-03_JPRB, &
  & 0.36910022E-03_JPRB, 0.36902947E-03_JPRB, 0.36893872E-03_JPRB, 0.36883139E-03_JPRB, 0.36871340E-03_JPRB, 0.36859061E-03_JPRB, &
  & 0.36846698E-03_JPRB, 0.36834500E-03_JPRB, 0.36822565E-03_JPRB, 0.36810938E-03_JPRB, 0.36799491E-03_JPRB, 0.36788231E-03_JPRB, &
  & 0.36777245E-03_JPRB, 0.36766686E-03_JPRB, 0.36756825E-03_JPRB, 0.36747952E-03_JPRB, 0.36740364E-03_JPRB, 0.36734258E-03_JPRB, &
  & 0.36729709E-03_JPRB, 0.36726604E-03_JPRB, 0.36724878E-03_JPRB, 0.36725029E-03_JPRB /)

RGHG1(:,19, 4) = (/ &
  & 0.36802725E-03_JPRB, 0.36817169E-03_JPRB, 0.36825115E-03_JPRB, 0.36832155E-03_JPRB, 0.36839102E-03_JPRB, 0.36846512E-03_JPRB, &
  & 0.36854509E-03_JPRB, 0.36863139E-03_JPRB, 0.36872303E-03_JPRB, 0.36881876E-03_JPRB, 0.36891527E-03_JPRB, 0.36900977E-03_JPRB, &
  & 0.36909973E-03_JPRB, 0.36918360E-03_JPRB, 0.36926108E-03_JPRB, 0.36933308E-03_JPRB, 0.36940060E-03_JPRB, 0.36946370E-03_JPRB, &
  & 0.36952269E-03_JPRB, 0.36957671E-03_JPRB, 0.36962476E-03_JPRB, 0.36966492E-03_JPRB, 0.36969819E-03_JPRB, 0.36972272E-03_JPRB, &
  & 0.36974135E-03_JPRB, 0.36975375E-03_JPRB, 0.36976024E-03_JPRB, 0.36976027E-03_JPRB, 0.36975287E-03_JPRB, 0.36973704E-03_JPRB, &
  & 0.36971256E-03_JPRB, 0.36968064E-03_JPRB, 0.36964429E-03_JPRB, 0.36960744E-03_JPRB, 0.36957551E-03_JPRB, 0.36955194E-03_JPRB, &
  & 0.36953922E-03_JPRB, 0.36953427E-03_JPRB, 0.36953177E-03_JPRB, 0.36952578E-03_JPRB, 0.36951003E-03_JPRB, 0.36947947E-03_JPRB, &
  & 0.36943078E-03_JPRB, 0.36936317E-03_JPRB, 0.36927755E-03_JPRB, 0.36917801E-03_JPRB, 0.36906949E-03_JPRB, 0.36895709E-03_JPRB, &
  & 0.36884446E-03_JPRB, 0.36873436E-03_JPRB, 0.36862746E-03_JPRB, 0.36852341E-03_JPRB, 0.36842169E-03_JPRB, 0.36832260E-03_JPRB, &
  & 0.36822644E-03_JPRB, 0.36813476E-03_JPRB, 0.36804911E-03_JPRB, 0.36797189E-03_JPRB, 0.36790603E-03_JPRB, 0.36785362E-03_JPRB, &
  & 0.36781497E-03_JPRB, 0.36778994E-03_JPRB, 0.36777672E-03_JPRB, 0.36778281E-03_JPRB /)

RGHG1(:,20, 4) = (/ &
  & 0.36832332E-03_JPRB, 0.36844690E-03_JPRB, 0.36851907E-03_JPRB, 0.36858098E-03_JPRB, 0.36864422E-03_JPRB, 0.36871157E-03_JPRB, &
  & 0.36878471E-03_JPRB, 0.36886390E-03_JPRB, 0.36894850E-03_JPRB, 0.36903672E-03_JPRB, 0.36912560E-03_JPRB, 0.36921256E-03_JPRB, &
  & 0.36929516E-03_JPRB, 0.36937225E-03_JPRB, 0.36944318E-03_JPRB, 0.36950890E-03_JPRB, 0.36957022E-03_JPRB, 0.36962799E-03_JPRB, &
  & 0.36968241E-03_JPRB, 0.36973346E-03_JPRB, 0.36978011E-03_JPRB, 0.36982170E-03_JPRB, 0.36985672E-03_JPRB, 0.36988637E-03_JPRB, &
  & 0.36990995E-03_JPRB, 0.36992854E-03_JPRB, 0.36994269E-03_JPRB, 0.36995183E-03_JPRB, 0.36995596E-03_JPRB, 0.36995381E-03_JPRB, &
  & 0.36994551E-03_JPRB, 0.36993140E-03_JPRB, 0.36991286E-03_JPRB, 0.36989234E-03_JPRB, 0.36987310E-03_JPRB, 0.36985776E-03_JPRB, &
  & 0.36984662E-03_JPRB, 0.36983757E-03_JPRB, 0.36982892E-03_JPRB, 0.36981481E-03_JPRB, 0.36979091E-03_JPRB, 0.36975357E-03_JPRB, &
  & 0.36970078E-03_JPRB, 0.36963192E-03_JPRB, 0.36954839E-03_JPRB, 0.36945342E-03_JPRB, 0.36935238E-03_JPRB, 0.36924941E-03_JPRB, &
  & 0.36914760E-03_JPRB, 0.36904859E-03_JPRB, 0.36895246E-03_JPRB, 0.36885915E-03_JPRB, 0.36876931E-03_JPRB, 0.36868287E-03_JPRB, &
  & 0.36860019E-03_JPRB, 0.36852204E-03_JPRB, 0.36844931E-03_JPRB, 0.36838374E-03_JPRB, 0.36832737E-03_JPRB, 0.36828232E-03_JPRB, &
  & 0.36824920E-03_JPRB, 0.36822702E-03_JPRB, 0.36821619E-03_JPRB, 0.36822003E-03_JPRB /)

RGHG1(:,21, 4) = (/ &
  & 0.36857231E-03_JPRB, 0.36868427E-03_JPRB, 0.36874766E-03_JPRB, 0.36880543E-03_JPRB, 0.36886346E-03_JPRB, 0.36892612E-03_JPRB, &
  & 0.36899443E-03_JPRB, 0.36906838E-03_JPRB, 0.36914731E-03_JPRB, 0.36922976E-03_JPRB, 0.36931279E-03_JPRB, 0.36939420E-03_JPRB, &
  & 0.36947156E-03_JPRB, 0.36954359E-03_JPRB, 0.36960994E-03_JPRB, 0.36967092E-03_JPRB, 0.36972761E-03_JPRB, 0.36978093E-03_JPRB, &
  & 0.36983140E-03_JPRB, 0.36987904E-03_JPRB, 0.36992342E-03_JPRB, 0.36996364E-03_JPRB, 0.36999932E-03_JPRB, 0.37002988E-03_JPRB, &
  & 0.37005567E-03_JPRB, 0.37007753E-03_JPRB, 0.37009610E-03_JPRB, 0.37011149E-03_JPRB, 0.37012409E-03_JPRB, 0.37013300E-03_JPRB, &
  & 0.37013786E-03_JPRB, 0.37013812E-03_JPRB, 0.37013463E-03_JPRB, 0.37012767E-03_JPRB, 0.37011906E-03_JPRB, 0.37010951E-03_JPRB, &
  & 0.37009950E-03_JPRB, 0.37008763E-03_JPRB, 0.37007188E-03_JPRB, 0.37004921E-03_JPRB, 0.37001667E-03_JPRB, 0.36997205E-03_JPRB, &
  & 0.36991452E-03_JPRB, 0.36984391E-03_JPRB, 0.36976166E-03_JPRB, 0.36967150E-03_JPRB, 0.36957741E-03_JPRB, 0.36948340E-03_JPRB, &
  & 0.36939114E-03_JPRB, 0.36930133E-03_JPRB, 0.36921434E-03_JPRB, 0.36913084E-03_JPRB, 0.36905141E-03_JPRB, 0.36897656E-03_JPRB, &
  & 0.36890601E-03_JPRB, 0.36883997E-03_JPRB, 0.36877848E-03_JPRB, 0.36872271E-03_JPRB, 0.36867414E-03_JPRB, 0.36863444E-03_JPRB, &
  & 0.36860432E-03_JPRB, 0.36858418E-03_JPRB, 0.36857216E-03_JPRB, 0.36857295E-03_JPRB /)

RGHG1(:,22, 4) = (/ &
  & 0.36878418E-03_JPRB, 0.36888407E-03_JPRB, 0.36894422E-03_JPRB, 0.36899705E-03_JPRB, 0.36905176E-03_JPRB, 0.36911061E-03_JPRB, &
  & 0.36917510E-03_JPRB, 0.36924498E-03_JPRB, 0.36931958E-03_JPRB, 0.36939725E-03_JPRB, 0.36947595E-03_JPRB, 0.36955293E-03_JPRB, &
  & 0.36962633E-03_JPRB, 0.36969481E-03_JPRB, 0.36975782E-03_JPRB, 0.36981574E-03_JPRB, 0.36986917E-03_JPRB, 0.36991917E-03_JPRB, &
  & 0.36996641E-03_JPRB, 0.37001111E-03_JPRB, 0.37005305E-03_JPRB, 0.37009164E-03_JPRB, 0.37012622E-03_JPRB, 0.37015657E-03_JPRB, &
  & 0.37018294E-03_JPRB, 0.37020561E-03_JPRB, 0.37022601E-03_JPRB, 0.37024487E-03_JPRB, 0.37026222E-03_JPRB, 0.37027796E-03_JPRB, &
  & 0.37029135E-03_JPRB, 0.37030157E-03_JPRB, 0.37030809E-03_JPRB, 0.37031039E-03_JPRB, 0.37030870E-03_JPRB, 0.37030276E-03_JPRB, &
  & 0.37029266E-03_JPRB, 0.37027750E-03_JPRB, 0.37025590E-03_JPRB, 0.37022645E-03_JPRB, 0.37018766E-03_JPRB, 0.37013800E-03_JPRB, &
  & 0.37007770E-03_JPRB, 0.37000686E-03_JPRB, 0.36992761E-03_JPRB, 0.36984266E-03_JPRB, 0.36975567E-03_JPRB, 0.36966923E-03_JPRB, &
  & 0.36958500E-03_JPRB, 0.36950363E-03_JPRB, 0.36942540E-03_JPRB, 0.36935121E-03_JPRB, 0.36928151E-03_JPRB, 0.36921664E-03_JPRB, &
  & 0.36915627E-03_JPRB, 0.36909999E-03_JPRB, 0.36904772E-03_JPRB, 0.36899967E-03_JPRB, 0.36895703E-03_JPRB, 0.36892132E-03_JPRB, &
  & 0.36889352E-03_JPRB, 0.36887289E-03_JPRB, 0.36885991E-03_JPRB, 0.36885351E-03_JPRB /)

RGHG1(:,23, 4) = (/ &
  & 0.36896157E-03_JPRB, 0.36905456E-03_JPRB, 0.36910945E-03_JPRB, 0.36915997E-03_JPRB, 0.36921166E-03_JPRB, 0.36926751E-03_JPRB, &
  & 0.36932871E-03_JPRB, 0.36939519E-03_JPRB, 0.36946594E-03_JPRB, 0.36953972E-03_JPRB, 0.36961440E-03_JPRB, 0.36968809E-03_JPRB, &
  & 0.36975872E-03_JPRB, 0.36982467E-03_JPRB, 0.36988541E-03_JPRB, 0.36994123E-03_JPRB, 0.36999278E-03_JPRB, 0.37004071E-03_JPRB, &
  & 0.37008600E-03_JPRB, 0.37012858E-03_JPRB, 0.37016845E-03_JPRB, 0.37020538E-03_JPRB, 0.37023870E-03_JPRB, 0.37026804E-03_JPRB, &
  & 0.37029371E-03_JPRB, 0.37031661E-03_JPRB, 0.37033760E-03_JPRB, 0.37035721E-03_JPRB, 0.37037654E-03_JPRB, 0.37039557E-03_JPRB, &
  & 0.37041312E-03_JPRB, 0.37042861E-03_JPRB, 0.37044004E-03_JPRB, 0.37044668E-03_JPRB, 0.37044781E-03_JPRB, 0.37044287E-03_JPRB, &
  & 0.37043163E-03_JPRB, 0.37041350E-03_JPRB, 0.37038795E-03_JPRB, 0.37035416E-03_JPRB, 0.37031161E-03_JPRB, 0.37025983E-03_JPRB, &
  & 0.37019947E-03_JPRB, 0.37013079E-03_JPRB, 0.37005590E-03_JPRB, 0.36997706E-03_JPRB, 0.36989720E-03_JPRB, 0.36981885E-03_JPRB, &
  & 0.36974295E-03_JPRB, 0.36966961E-03_JPRB, 0.36959935E-03_JPRB, 0.36953340E-03_JPRB, 0.36947220E-03_JPRB, 0.36941553E-03_JPRB, &
  & 0.36936306E-03_JPRB, 0.36931440E-03_JPRB, 0.36926888E-03_JPRB, 0.36922650E-03_JPRB, 0.36918811E-03_JPRB, 0.36915494E-03_JPRB, &
  & 0.36912799E-03_JPRB, 0.36910761E-03_JPRB, 0.36909193E-03_JPRB, 0.36908002E-03_JPRB /)

RGHG1(:,24, 4) = (/ &
  & 0.36911227E-03_JPRB, 0.36919853E-03_JPRB, 0.36925060E-03_JPRB, 0.36929813E-03_JPRB, 0.36934760E-03_JPRB, 0.36940075E-03_JPRB, &
  & 0.36945916E-03_JPRB, 0.36952231E-03_JPRB, 0.36958943E-03_JPRB, 0.36965928E-03_JPRB, 0.36973064E-03_JPRB, 0.36980124E-03_JPRB, &
  & 0.36986938E-03_JPRB, 0.36993375E-03_JPRB, 0.36999333E-03_JPRB, 0.37004819E-03_JPRB, 0.37009883E-03_JPRB, 0.37014583E-03_JPRB, &
  & 0.37018978E-03_JPRB, 0.37023096E-03_JPRB, 0.37026955E-03_JPRB, 0.37030497E-03_JPRB, 0.37033716E-03_JPRB, 0.37036560E-03_JPRB, &
  & 0.37039048E-03_JPRB, 0.37041274E-03_JPRB, 0.37043312E-03_JPRB, 0.37045270E-03_JPRB, 0.37047241E-03_JPRB, 0.37049191E-03_JPRB, &
  & 0.37051065E-03_JPRB, 0.37052736E-03_JPRB, 0.37054025E-03_JPRB, 0.37054790E-03_JPRB, 0.37054918E-03_JPRB, 0.37054342E-03_JPRB, &
  & 0.37053038E-03_JPRB, 0.37050978E-03_JPRB, 0.37048152E-03_JPRB, 0.37044549E-03_JPRB, 0.37040145E-03_JPRB, 0.37034985E-03_JPRB, &
  & 0.37029144E-03_JPRB, 0.37022674E-03_JPRB, 0.37015753E-03_JPRB, 0.37008576E-03_JPRB, 0.37001373E-03_JPRB, 0.36994324E-03_JPRB, &
  & 0.36987467E-03_JPRB, 0.36980875E-03_JPRB, 0.36974621E-03_JPRB, 0.36968762E-03_JPRB, 0.36963329E-03_JPRB, 0.36958331E-03_JPRB, &
  & 0.36953692E-03_JPRB, 0.36949365E-03_JPRB, 0.36945281E-03_JPRB, 0.36941448E-03_JPRB, 0.36937901E-03_JPRB, 0.36934766E-03_JPRB, &
  & 0.36932147E-03_JPRB, 0.36930025E-03_JPRB, 0.36928343E-03_JPRB, 0.36926588E-03_JPRB /)

RGHG1(:,25, 4) = (/ &
  & 0.36924391E-03_JPRB, 0.36932316E-03_JPRB, 0.36937249E-03_JPRB, 0.36941725E-03_JPRB, 0.36946402E-03_JPRB, 0.36951475E-03_JPRB, &
  & 0.36957010E-03_JPRB, 0.36963000E-03_JPRB, 0.36969365E-03_JPRB, 0.36975998E-03_JPRB, 0.36982811E-03_JPRB, 0.36989618E-03_JPRB, &
  & 0.36996257E-03_JPRB, 0.37002572E-03_JPRB, 0.37008442E-03_JPRB, 0.37013888E-03_JPRB, 0.37018917E-03_JPRB, 0.37023579E-03_JPRB, &
  & 0.37027916E-03_JPRB, 0.37031961E-03_JPRB, 0.37035727E-03_JPRB, 0.37039179E-03_JPRB, 0.37042284E-03_JPRB, 0.37045029E-03_JPRB, &
  & 0.37047444E-03_JPRB, 0.37049595E-03_JPRB, 0.37051545E-03_JPRB, 0.37053422E-03_JPRB, 0.37055288E-03_JPRB, 0.37057165E-03_JPRB, &
  & 0.37058973E-03_JPRB, 0.37060576E-03_JPRB, 0.37061784E-03_JPRB, 0.37062456E-03_JPRB, 0.37062480E-03_JPRB, 0.37061755E-03_JPRB, &
  & 0.37060262E-03_JPRB, 0.37058000E-03_JPRB, 0.37055000E-03_JPRB, 0.37051318E-03_JPRB, 0.37046964E-03_JPRB, 0.37041976E-03_JPRB, &
  & 0.37036449E-03_JPRB, 0.37030503E-03_JPRB, 0.37024223E-03_JPRB, 0.37017761E-03_JPRB, 0.37011280E-03_JPRB, 0.37004924E-03_JPRB, &
  & 0.36998783E-03_JPRB, 0.36992913E-03_JPRB, 0.36987325E-03_JPRB, 0.36982086E-03_JPRB, 0.36977237E-03_JPRB, 0.36972729E-03_JPRB, &
  & 0.36968538E-03_JPRB, 0.36964600E-03_JPRB, 0.36960837E-03_JPRB, 0.36957258E-03_JPRB, 0.36953911E-03_JPRB, 0.36950893E-03_JPRB, &
  & 0.36948311E-03_JPRB, 0.36946181E-03_JPRB, 0.36944353E-03_JPRB, 0.36942313E-03_JPRB /)

RGHG1(:,26, 4) = (/ &
  & 0.36935910E-03_JPRB, 0.36943439E-03_JPRB, 0.36947877E-03_JPRB, 0.36952147E-03_JPRB, 0.36956547E-03_JPRB, 0.36961338E-03_JPRB, &
  & 0.36966571E-03_JPRB, 0.36972226E-03_JPRB, 0.36978253E-03_JPRB, 0.36984571E-03_JPRB, 0.36991070E-03_JPRB, 0.36997639E-03_JPRB, &
  & 0.37004109E-03_JPRB, 0.37010314E-03_JPRB, 0.37016149E-03_JPRB, 0.37021586E-03_JPRB, 0.37026621E-03_JPRB, 0.37031304E-03_JPRB, &
  & 0.37035640E-03_JPRB, 0.37039671E-03_JPRB, 0.37043376E-03_JPRB, 0.37046766E-03_JPRB, 0.37049784E-03_JPRB, 0.37052459E-03_JPRB, &
  & 0.37054770E-03_JPRB, 0.37056825E-03_JPRB, 0.37058696E-03_JPRB, 0.37060457E-03_JPRB, 0.37062194E-03_JPRB, 0.37063914E-03_JPRB, &
  & 0.37065550E-03_JPRB, 0.37066959E-03_JPRB, 0.37067998E-03_JPRB, 0.37068513E-03_JPRB, 0.37068361E-03_JPRB, 0.37067465E-03_JPRB, &
  & 0.37065818E-03_JPRB, 0.37063463E-03_JPRB, 0.37060434E-03_JPRB, 0.37056790E-03_JPRB, 0.37052590E-03_JPRB, 0.37047887E-03_JPRB, &
  & 0.37042768E-03_JPRB, 0.37037354E-03_JPRB, 0.37031694E-03_JPRB, 0.37025881E-03_JPRB, 0.37020067E-03_JPRB, 0.37014380E-03_JPRB, &
  & 0.37008891E-03_JPRB, 0.37003605E-03_JPRB, 0.36998582E-03_JPRB, 0.36993853E-03_JPRB, 0.36989443E-03_JPRB, 0.36985328E-03_JPRB, &
  & 0.36981454E-03_JPRB, 0.36977767E-03_JPRB, 0.36974231E-03_JPRB, 0.36970840E-03_JPRB, 0.36967610E-03_JPRB, 0.36964664E-03_JPRB, &
  & 0.36962124E-03_JPRB, 0.36959982E-03_JPRB, 0.36958081E-03_JPRB, 0.36955773E-03_JPRB /)

RGHG1(:,27, 4) = (/ &
  & 0.36946544E-03_JPRB, 0.36953221E-03_JPRB, 0.36957578E-03_JPRB, 0.36961422E-03_JPRB, 0.36965578E-03_JPRB, 0.36970072E-03_JPRB, &
  & 0.36974973E-03_JPRB, 0.36980328E-03_JPRB, 0.36986012E-03_JPRB, 0.36992002E-03_JPRB, 0.36998242E-03_JPRB, 0.37004577E-03_JPRB, &
  & 0.37010887E-03_JPRB, 0.37017016E-03_JPRB, 0.37022843E-03_JPRB, 0.37028288E-03_JPRB, 0.37033358E-03_JPRB, 0.37038064E-03_JPRB, &
  & 0.37042410E-03_JPRB, 0.37046417E-03_JPRB, 0.37050084E-03_JPRB, 0.37053408E-03_JPRB, 0.37056385E-03_JPRB, 0.37058990E-03_JPRB, &
  & 0.37061237E-03_JPRB, 0.37063207E-03_JPRB, 0.37064971E-03_JPRB, 0.37066615E-03_JPRB, 0.37068201E-03_JPRB, 0.37069709E-03_JPRB, &
  & 0.37071106E-03_JPRB, 0.37072299E-03_JPRB, 0.37073123E-03_JPRB, 0.37073449E-03_JPRB, 0.37073143E-03_JPRB, 0.37072139E-03_JPRB, &
  & 0.37070410E-03_JPRB, 0.37068012E-03_JPRB, 0.37065012E-03_JPRB, 0.37061528E-03_JPRB, 0.37057578E-03_JPRB, 0.37053248E-03_JPRB, &
  & 0.37048606E-03_JPRB, 0.37043710E-03_JPRB, 0.37038652E-03_JPRB, 0.37033454E-03_JPRB, 0.37028253E-03_JPRB, 0.37023134E-03_JPRB, &
  & 0.37018143E-03_JPRB, 0.37013361E-03_JPRB, 0.37008795E-03_JPRB, 0.37004484E-03_JPRB, 0.37000427E-03_JPRB, 0.36996609E-03_JPRB, &
  & 0.36992962E-03_JPRB, 0.36989455E-03_JPRB, 0.36986056E-03_JPRB, 0.36982738E-03_JPRB, 0.36979595E-03_JPRB, 0.36976696E-03_JPRB, &
  & 0.36974170E-03_JPRB, 0.36972022E-03_JPRB, 0.36970095E-03_JPRB, 0.36967584E-03_JPRB /)

RGHG1(:,28, 4) = (/ &
  & 0.36955977E-03_JPRB, 0.36962429E-03_JPRB, 0.36966190E-03_JPRB, 0.36969915E-03_JPRB, 0.36973724E-03_JPRB, 0.36977927E-03_JPRB, &
  & 0.36982572E-03_JPRB, 0.36987595E-03_JPRB, 0.36992985E-03_JPRB, 0.36998664E-03_JPRB, 0.37004621E-03_JPRB, 0.37010753E-03_JPRB, &
  & 0.37016900E-03_JPRB, 0.37022942E-03_JPRB, 0.37028739E-03_JPRB, 0.37034237E-03_JPRB, 0.37039345E-03_JPRB, 0.37044068E-03_JPRB, &
  & 0.37048431E-03_JPRB, 0.37052445E-03_JPRB, 0.37056071E-03_JPRB, 0.37059354E-03_JPRB, 0.37062241E-03_JPRB, 0.37064770E-03_JPRB, &
  & 0.37066953E-03_JPRB, 0.37068845E-03_JPRB, 0.37070495E-03_JPRB, 0.37071999E-03_JPRB, 0.37073411E-03_JPRB, 0.37074703E-03_JPRB, &
  & 0.37075879E-03_JPRB, 0.37076839E-03_JPRB, 0.37077456E-03_JPRB, 0.37077605E-03_JPRB, 0.37077154E-03_JPRB, 0.37076062E-03_JPRB, &
  & 0.37074322E-03_JPRB, 0.37071991E-03_JPRB, 0.37069191E-03_JPRB, 0.37065960E-03_JPRB, 0.37062340E-03_JPRB, 0.37058422E-03_JPRB, &
  & 0.37054240E-03_JPRB, 0.37049883E-03_JPRB, 0.37045349E-03_JPRB, 0.37040698E-03_JPRB, 0.37035986E-03_JPRB, 0.37031341E-03_JPRB, &
  & 0.37026813E-03_JPRB, 0.37022436E-03_JPRB, 0.37018227E-03_JPRB, 0.37014231E-03_JPRB, 0.37010436E-03_JPRB, 0.37006818E-03_JPRB, &
  & 0.37003326E-03_JPRB, 0.36999932E-03_JPRB, 0.36996594E-03_JPRB, 0.36993338E-03_JPRB, 0.36990215E-03_JPRB, 0.36987348E-03_JPRB, &
  & 0.36984831E-03_JPRB, 0.36982700E-03_JPRB, 0.36980747E-03_JPRB, 0.36978174E-03_JPRB /)

RGHG1(:,29, 4) = (/ &
  & 0.36964766E-03_JPRB, 0.36970474E-03_JPRB, 0.36974272E-03_JPRB, 0.36977601E-03_JPRB, 0.36981236E-03_JPRB, 0.36985212E-03_JPRB, &
  & 0.36989542E-03_JPRB, 0.36994286E-03_JPRB, 0.36999359E-03_JPRB, 0.37004740E-03_JPRB, 0.37010439E-03_JPRB, 0.37016344E-03_JPRB, &
  & 0.37022348E-03_JPRB, 0.37028285E-03_JPRB, 0.37034042E-03_JPRB, 0.37039534E-03_JPRB, 0.37044683E-03_JPRB, 0.37049467E-03_JPRB, &
  & 0.37053839E-03_JPRB, 0.37057829E-03_JPRB, 0.37061443E-03_JPRB, 0.37064656E-03_JPRB, 0.37067485E-03_JPRB, 0.37069933E-03_JPRB, &
  & 0.37072028E-03_JPRB, 0.37073815E-03_JPRB, 0.37075364E-03_JPRB, 0.37076743E-03_JPRB, 0.37077972E-03_JPRB, 0.37079072E-03_JPRB, &
  & 0.37080009E-03_JPRB, 0.37080742E-03_JPRB, 0.37081161E-03_JPRB, 0.37081155E-03_JPRB, 0.37080620E-03_JPRB, 0.37079505E-03_JPRB, &
  & 0.37077843E-03_JPRB, 0.37075696E-03_JPRB, 0.37073100E-03_JPRB, 0.37070163E-03_JPRB, 0.37066932E-03_JPRB, 0.37063437E-03_JPRB, &
  & 0.37059750E-03_JPRB, 0.37055888E-03_JPRB, 0.37051857E-03_JPRB, 0.37047677E-03_JPRB, 0.37043411E-03_JPRB, 0.37039141E-03_JPRB, &
  & 0.37034947E-03_JPRB, 0.37030876E-03_JPRB, 0.37026947E-03_JPRB, 0.37023181E-03_JPRB, 0.37019578E-03_JPRB, 0.37016100E-03_JPRB, &
  & 0.37012724E-03_JPRB, 0.37009406E-03_JPRB, 0.37006120E-03_JPRB, 0.37002901E-03_JPRB, 0.36999804E-03_JPRB, 0.36996941E-03_JPRB, &
  & 0.36994441E-03_JPRB, 0.36992316E-03_JPRB, 0.36990375E-03_JPRB, 0.36987712E-03_JPRB /)

RGHG1(:,30, 4) = (/ &
  & 0.36972549E-03_JPRB, 0.36978209E-03_JPRB, 0.36981524E-03_JPRB, 0.36984833E-03_JPRB, 0.36988212E-03_JPRB, 0.36991946E-03_JPRB, &
  & 0.36996068E-03_JPRB, 0.37000529E-03_JPRB, 0.37005323E-03_JPRB, 0.37010442E-03_JPRB, 0.37015867E-03_JPRB, 0.37021571E-03_JPRB, &
  & 0.37027412E-03_JPRB, 0.37033253E-03_JPRB, 0.37038975E-03_JPRB, 0.37044438E-03_JPRB, 0.37049584E-03_JPRB, 0.37054374E-03_JPRB, &
  & 0.37058757E-03_JPRB, 0.37062721E-03_JPRB, 0.37066295E-03_JPRB, 0.37069438E-03_JPRB, 0.37072200E-03_JPRB, 0.37074537E-03_JPRB, &
  & 0.37076548E-03_JPRB, 0.37078228E-03_JPRB, 0.37079657E-03_JPRB, 0.37080896E-03_JPRB, 0.37081962E-03_JPRB, 0.37082849E-03_JPRB, &
  & 0.37083600E-03_JPRB, 0.37084127E-03_JPRB, 0.37084369E-03_JPRB, 0.37084238E-03_JPRB, 0.37083641E-03_JPRB, 0.37082550E-03_JPRB, &
  & 0.37080998E-03_JPRB, 0.37079005E-03_JPRB, 0.37076711E-03_JPRB, 0.37074141E-03_JPRB, 0.37071330E-03_JPRB, 0.37068277E-03_JPRB, &
  & 0.37065035E-03_JPRB, 0.37061630E-03_JPRB, 0.37058030E-03_JPRB, 0.37054272E-03_JPRB, 0.37050375E-03_JPRB, 0.37046438E-03_JPRB, &
  & 0.37042543E-03_JPRB, 0.37038699E-03_JPRB, 0.37034979E-03_JPRB, 0.37031388E-03_JPRB, 0.37027925E-03_JPRB, 0.37024566E-03_JPRB, &
  & 0.37021254E-03_JPRB, 0.37017989E-03_JPRB, 0.37014749E-03_JPRB, 0.37011533E-03_JPRB, 0.37008437E-03_JPRB, 0.37005587E-03_JPRB, &
  & 0.37003116E-03_JPRB, 0.37001018E-03_JPRB, 0.36999068E-03_JPRB, 0.36996382E-03_JPRB /)

RGHG1(:,31, 4) = (/ &
  & 0.36979883E-03_JPRB, 0.36985072E-03_JPRB, 0.36988486E-03_JPRB, 0.36991498E-03_JPRB, 0.36994790E-03_JPRB, 0.36998349E-03_JPRB, &
  & 0.37002238E-03_JPRB, 0.37006460E-03_JPRB, 0.37010977E-03_JPRB, 0.37015814E-03_JPRB, 0.37021015E-03_JPRB, 0.37026504E-03_JPRB, &
  & 0.37032165E-03_JPRB, 0.37037887E-03_JPRB, 0.37043530E-03_JPRB, 0.37048978E-03_JPRB, 0.37054115E-03_JPRB, 0.37058900E-03_JPRB, &
  & 0.37063260E-03_JPRB, 0.37067194E-03_JPRB, 0.37070698E-03_JPRB, 0.37073737E-03_JPRB, 0.37076394E-03_JPRB, 0.37078629E-03_JPRB, &
  & 0.37080550E-03_JPRB, 0.37082090E-03_JPRB, 0.37083434E-03_JPRB, 0.37084523E-03_JPRB, 0.37085428E-03_JPRB, 0.37086150E-03_JPRB, &
  & 0.37086708E-03_JPRB, 0.37087058E-03_JPRB, 0.37087154E-03_JPRB, 0.37086930E-03_JPRB, 0.37086310E-03_JPRB, 0.37085291E-03_JPRB, &
  & 0.37083871E-03_JPRB, 0.37082136E-03_JPRB, 0.37080148E-03_JPRB, 0.37077913E-03_JPRB, 0.37075469E-03_JPRB, 0.37072826E-03_JPRB, &
  & 0.37070012E-03_JPRB, 0.37066991E-03_JPRB, 0.37063769E-03_JPRB, 0.37060352E-03_JPRB, 0.37056784E-03_JPRB, 0.37053146E-03_JPRB, &
  & 0.37049479E-03_JPRB, 0.37045861E-03_JPRB, 0.37042319E-03_JPRB, 0.37038859E-03_JPRB, 0.37035494E-03_JPRB, 0.37032214E-03_JPRB, &
  & 0.37028984E-03_JPRB, 0.37025777E-03_JPRB, 0.37022567E-03_JPRB, 0.37019377E-03_JPRB, 0.37016300E-03_JPRB, 0.37013460E-03_JPRB, &
  & 0.37011006E-03_JPRB, 0.37008923E-03_JPRB, 0.37006976E-03_JPRB, 0.37004260E-03_JPRB /)

RGHG1(:,32, 4) = (/ &
  & 0.36986565E-03_JPRB, 0.36991821E-03_JPRB, 0.36994909E-03_JPRB, 0.36997936E-03_JPRB, 0.37001036E-03_JPRB, 0.37004455E-03_JPRB, &
  & 0.37008157E-03_JPRB, 0.37012150E-03_JPRB, 0.37016414E-03_JPRB, 0.37020989E-03_JPRB, 0.37025916E-03_JPRB, 0.37031170E-03_JPRB, &
  & 0.37036650E-03_JPRB, 0.37042249E-03_JPRB, 0.37047817E-03_JPRB, 0.37053198E-03_JPRB, 0.37058294E-03_JPRB, 0.37063041E-03_JPRB, &
  & 0.37067378E-03_JPRB, 0.37071243E-03_JPRB, 0.37074642E-03_JPRB, 0.37077596E-03_JPRB, 0.37080146E-03_JPRB, 0.37082253E-03_JPRB, &
  & 0.37084054E-03_JPRB, 0.37085489E-03_JPRB, 0.37086682E-03_JPRB, 0.37087663E-03_JPRB, 0.37088440E-03_JPRB, 0.37089005E-03_JPRB, &
  & 0.37089409E-03_JPRB, 0.37089619E-03_JPRB, 0.37089604E-03_JPRB, 0.37089313E-03_JPRB, 0.37088699E-03_JPRB, 0.37087753E-03_JPRB, &
  & 0.37086522E-03_JPRB, 0.37085029E-03_JPRB, 0.37083309E-03_JPRB, 0.37081400E-03_JPRB, 0.37079278E-03_JPRB, 0.37076988E-03_JPRB, &
  & 0.37074511E-03_JPRB, 0.37071834E-03_JPRB, 0.37068926E-03_JPRB, 0.37065815E-03_JPRB, 0.37062523E-03_JPRB, 0.37059150E-03_JPRB, &
  & 0.37055713E-03_JPRB, 0.37052276E-03_JPRB, 0.37048888E-03_JPRB, 0.37045570E-03_JPRB, 0.37042337E-03_JPRB, 0.37039162E-03_JPRB, &
  & 0.37036004E-03_JPRB, 0.37032849E-03_JPRB, 0.37029688E-03_JPRB, 0.37026530E-03_JPRB, 0.37023489E-03_JPRB, 0.37020684E-03_JPRB, &
  & 0.37018262E-03_JPRB, 0.37016204E-03_JPRB, 0.37014272E-03_JPRB, 0.37011551E-03_JPRB /)

RGHG1(:,33, 4) = (/ &
  & 0.36993032E-03_JPRB, 0.36998017E-03_JPRB, 0.37001213E-03_JPRB, 0.37004048E-03_JPRB, 0.37007089E-03_JPRB, 0.37010363E-03_JPRB, &
  & 0.37013864E-03_JPRB, 0.37017654E-03_JPRB, 0.37021667E-03_JPRB, 0.37025975E-03_JPRB, 0.37030640E-03_JPRB, 0.37035655E-03_JPRB, &
  & 0.37040949E-03_JPRB, 0.37046379E-03_JPRB, 0.37051810E-03_JPRB, 0.37057113E-03_JPRB, 0.37062151E-03_JPRB, 0.37066836E-03_JPRB, &
  & 0.37071083E-03_JPRB, 0.37074860E-03_JPRB, 0.37078164E-03_JPRB, 0.37081001E-03_JPRB, 0.37083431E-03_JPRB, 0.37085434E-03_JPRB, &
  & 0.37087101E-03_JPRB, 0.37088434E-03_JPRB, 0.37089500E-03_JPRB, 0.37090361E-03_JPRB, 0.37091022E-03_JPRB, 0.37091455E-03_JPRB, &
  & 0.37091732E-03_JPRB, 0.37091825E-03_JPRB, 0.37091738E-03_JPRB, 0.37091412E-03_JPRB, 0.37090815E-03_JPRB, 0.37089986E-03_JPRB, &
  & 0.37088917E-03_JPRB, 0.37087643E-03_JPRB, 0.37086179E-03_JPRB, 0.37084543E-03_JPRB, 0.37082715E-03_JPRB, 0.37080704E-03_JPRB, &
  & 0.37078507E-03_JPRB, 0.37076071E-03_JPRB, 0.37073425E-03_JPRB, 0.37070579E-03_JPRB, 0.37067549E-03_JPRB, 0.37064403E-03_JPRB, &
  & 0.37061190E-03_JPRB, 0.37057948E-03_JPRB, 0.37054720E-03_JPRB, 0.37051536E-03_JPRB, 0.37048419E-03_JPRB, 0.37045366E-03_JPRB, &
  & 0.37042308E-03_JPRB, 0.37039249E-03_JPRB, 0.37036152E-03_JPRB, 0.37033053E-03_JPRB, 0.37030064E-03_JPRB, 0.37027322E-03_JPRB, &
  & 0.37024959E-03_JPRB, 0.37022945E-03_JPRB, 0.37021030E-03_JPRB, 0.37018303E-03_JPRB /)

RGHG1(:,34, 4) = (/ &
  & 0.36999211E-03_JPRB, 0.37004257E-03_JPRB, 0.37007235E-03_JPRB, 0.37010096E-03_JPRB, 0.37012994E-03_JPRB, 0.37016108E-03_JPRB, &
  & 0.37019470E-03_JPRB, 0.37023023E-03_JPRB, 0.37026801E-03_JPRB, 0.37030847E-03_JPRB, 0.37035235E-03_JPRB, 0.37039974E-03_JPRB, &
  & 0.37045026E-03_JPRB, 0.37050285E-03_JPRB, 0.37055579E-03_JPRB, 0.37060777E-03_JPRB, 0.37065701E-03_JPRB, 0.37070274E-03_JPRB, &
  & 0.37074406E-03_JPRB, 0.37078070E-03_JPRB, 0.37081272E-03_JPRB, 0.37083999E-03_JPRB, 0.37086310E-03_JPRB, 0.37088184E-03_JPRB, &
  & 0.37089729E-03_JPRB, 0.37090949E-03_JPRB, 0.37091895E-03_JPRB, 0.37092657E-03_JPRB, 0.37093199E-03_JPRB, 0.37093533E-03_JPRB, &
  & 0.37093728E-03_JPRB, 0.37093746E-03_JPRB, 0.37093589E-03_JPRB, 0.37093266E-03_JPRB, 0.37092742E-03_JPRB, 0.37092017E-03_JPRB, &
  & 0.37091100E-03_JPRB, 0.37090020E-03_JPRB, 0.37088781E-03_JPRB, 0.37087363E-03_JPRB, 0.37085754E-03_JPRB, 0.37083941E-03_JPRB, &
  & 0.37081947E-03_JPRB, 0.37079715E-03_JPRB, 0.37077273E-03_JPRB, 0.37074627E-03_JPRB, 0.37071834E-03_JPRB, 0.37068914E-03_JPRB, &
  & 0.37065893E-03_JPRB, 0.37062838E-03_JPRB, 0.37059787E-03_JPRB, 0.37056772E-03_JPRB, 0.37053801E-03_JPRB, 0.37050882E-03_JPRB, &
  & 0.37047954E-03_JPRB, 0.37045014E-03_JPRB, 0.37042022E-03_JPRB, 0.37039033E-03_JPRB, 0.37036126E-03_JPRB, 0.37033460E-03_JPRB, &
  & 0.37031173E-03_JPRB, 0.37029199E-03_JPRB, 0.37027313E-03_JPRB, 0.37024589E-03_JPRB /)

RGHG1(:,35, 4) = (/ &
  & 0.37005378E-03_JPRB, 0.37010238E-03_JPRB, 0.37013271E-03_JPRB, 0.37015951E-03_JPRB, 0.37018771E-03_JPRB, 0.37021755E-03_JPRB, &
  & 0.37024921E-03_JPRB, 0.37028262E-03_JPRB, 0.37031781E-03_JPRB, 0.37035561E-03_JPRB, 0.37039680E-03_JPRB, 0.37044156E-03_JPRB, &
  & 0.37048967E-03_JPRB, 0.37053990E-03_JPRB, 0.37059109E-03_JPRB, 0.37064136E-03_JPRB, 0.37068943E-03_JPRB, 0.37073391E-03_JPRB, &
  & 0.37077384E-03_JPRB, 0.37080934E-03_JPRB, 0.37084008E-03_JPRB, 0.37086618E-03_JPRB, 0.37088807E-03_JPRB, 0.37090594E-03_JPRB, &
  & 0.37092002E-03_JPRB, 0.37093088E-03_JPRB, 0.37093929E-03_JPRB, 0.37094572E-03_JPRB, 0.37095009E-03_JPRB, 0.37095262E-03_JPRB, &
  & 0.37095390E-03_JPRB, 0.37095370E-03_JPRB, 0.37095195E-03_JPRB, 0.37094895E-03_JPRB, 0.37094427E-03_JPRB, 0.37093810E-03_JPRB, &
  & 0.37093059E-03_JPRB, 0.37092165E-03_JPRB, 0.37091103E-03_JPRB, 0.37089875E-03_JPRB, 0.37088423E-03_JPRB, 0.37086749E-03_JPRB, &
  & 0.37084881E-03_JPRB, 0.37082806E-03_JPRB, 0.37080509E-03_JPRB, 0.37078065E-03_JPRB, 0.37075463E-03_JPRB, 0.37072733E-03_JPRB, &
  & 0.37069895E-03_JPRB, 0.37067017E-03_JPRB, 0.37064127E-03_JPRB, 0.37061266E-03_JPRB, 0.37058466E-03_JPRB, 0.37055701E-03_JPRB, &
  & 0.37052939E-03_JPRB, 0.37050142E-03_JPRB, 0.37047296E-03_JPRB, 0.37044426E-03_JPRB, 0.37041653E-03_JPRB, 0.37039112E-03_JPRB, &
  & 0.37036906E-03_JPRB, 0.37034997E-03_JPRB, 0.37033160E-03_JPRB, 0.37030451E-03_JPRB /)

RGHG1(:,36, 4) = (/ &
  & 0.37011411E-03_JPRB, 0.37016231E-03_JPRB, 0.37019077E-03_JPRB, 0.37021737E-03_JPRB, 0.37024429E-03_JPRB, 0.37027267E-03_JPRB, &
  & 0.37030250E-03_JPRB, 0.37033364E-03_JPRB, 0.37036635E-03_JPRB, 0.37040145E-03_JPRB, 0.37043961E-03_JPRB, 0.37048149E-03_JPRB, &
  & 0.37052674E-03_JPRB, 0.37057471E-03_JPRB, 0.37062383E-03_JPRB, 0.37067244E-03_JPRB, 0.37071866E-03_JPRB, 0.37076173E-03_JPRB, &
  & 0.37080029E-03_JPRB, 0.37083452E-03_JPRB, 0.37086415E-03_JPRB, 0.37088917E-03_JPRB, 0.37090969E-03_JPRB, 0.37092628E-03_JPRB, &
  & 0.37093897E-03_JPRB, 0.37094852E-03_JPRB, 0.37095576E-03_JPRB, 0.37096097E-03_JPRB, 0.37096441E-03_JPRB, 0.37096627E-03_JPRB, &
  & 0.37096703E-03_JPRB, 0.37096671E-03_JPRB, 0.37096519E-03_JPRB, 0.37096249E-03_JPRB, 0.37095859E-03_JPRB, 0.37095352E-03_JPRB, &
  & 0.37094729E-03_JPRB, 0.37093999E-03_JPRB, 0.37093111E-03_JPRB, 0.37092026E-03_JPRB, 0.37090710E-03_JPRB, 0.37089153E-03_JPRB, &
  & 0.37087369E-03_JPRB, 0.37085396E-03_JPRB, 0.37083239E-03_JPRB, 0.37080928E-03_JPRB, 0.37078484E-03_JPRB, 0.37075923E-03_JPRB, &
  & 0.37073257E-03_JPRB, 0.37070541E-03_JPRB, 0.37067794E-03_JPRB, 0.37065099E-03_JPRB, 0.37062471E-03_JPRB, 0.37059872E-03_JPRB, &
  & 0.37057290E-03_JPRB, 0.37054674E-03_JPRB, 0.37051996E-03_JPRB, 0.37049304E-03_JPRB, 0.37046691E-03_JPRB, 0.37044295E-03_JPRB, &
  & 0.37042203E-03_JPRB, 0.37040361E-03_JPRB, 0.37038565E-03_JPRB, 0.37035911E-03_JPRB /)

RGHG1(:,37, 4) = (/ &
  & 0.37017412E-03_JPRB, 0.37022043E-03_JPRB, 0.37024816E-03_JPRB, 0.37027357E-03_JPRB, 0.37029959E-03_JPRB, 0.37032663E-03_JPRB, &
  & 0.37035457E-03_JPRB, 0.37038344E-03_JPRB, 0.37041371E-03_JPRB, 0.37044592E-03_JPRB, 0.37048123E-03_JPRB, 0.37051999E-03_JPRB, &
  & 0.37056225E-03_JPRB, 0.37060754E-03_JPRB, 0.37065439E-03_JPRB, 0.37070081E-03_JPRB, 0.37074531E-03_JPRB, 0.37078653E-03_JPRB, &
  & 0.37082369E-03_JPRB, 0.37085672E-03_JPRB, 0.37088525E-03_JPRB, 0.37090905E-03_JPRB, 0.37092823E-03_JPRB, 0.37094307E-03_JPRB, &
  & 0.37095405E-03_JPRB, 0.37096205E-03_JPRB, 0.37096787E-03_JPRB, 0.37097195E-03_JPRB, 0.37097459E-03_JPRB, 0.37097602E-03_JPRB, &
  & 0.37097652E-03_JPRB, 0.37097617E-03_JPRB, 0.37097483E-03_JPRB, 0.37097270E-03_JPRB, 0.37096962E-03_JPRB, 0.37096551E-03_JPRB, &
  & 0.37096062E-03_JPRB, 0.37095463E-03_JPRB, 0.37094724E-03_JPRB, 0.37093772E-03_JPRB, 0.37092590E-03_JPRB, 0.37091150E-03_JPRB, &
  & 0.37089444E-03_JPRB, 0.37087552E-03_JPRB, 0.37085506E-03_JPRB, 0.37083341E-03_JPRB, 0.37081027E-03_JPRB, 0.37078612E-03_JPRB, &
  & 0.37076083E-03_JPRB, 0.37073490E-03_JPRB, 0.37070885E-03_JPRB, 0.37068329E-03_JPRB, 0.37065847E-03_JPRB, 0.37063449E-03_JPRB, &
  & 0.37061059E-03_JPRB, 0.37058644E-03_JPRB, 0.37056161E-03_JPRB, 0.37053664E-03_JPRB, 0.37051240E-03_JPRB, 0.37049007E-03_JPRB, &
  & 0.37047049E-03_JPRB, 0.37045308E-03_JPRB, 0.37043582E-03_JPRB, 0.37040998E-03_JPRB /)

RGHG1(:,38, 4) = (/ &
  & 0.37023344E-03_JPRB, 0.37027715E-03_JPRB, 0.37030398E-03_JPRB, 0.37032849E-03_JPRB, 0.37035358E-03_JPRB, 0.37037939E-03_JPRB, &
  & 0.37040561E-03_JPRB, 0.37043227E-03_JPRB, 0.37045981E-03_JPRB, 0.37048920E-03_JPRB, 0.37052127E-03_JPRB, 0.37055675E-03_JPRB, &
  & 0.37059598E-03_JPRB, 0.37063836E-03_JPRB, 0.37068262E-03_JPRB, 0.37072672E-03_JPRB, 0.37076900E-03_JPRB, 0.37080862E-03_JPRB, &
  & 0.37084435E-03_JPRB, 0.37087605E-03_JPRB, 0.37090320E-03_JPRB, 0.37092564E-03_JPRB, 0.37094305E-03_JPRB, 0.37095597E-03_JPRB, &
  & 0.37096496E-03_JPRB, 0.37097128E-03_JPRB, 0.37097579E-03_JPRB, 0.37097887E-03_JPRB, 0.37098091E-03_JPRB, 0.37098196E-03_JPRB, &
  & 0.37098236E-03_JPRB, 0.37098213E-03_JPRB, 0.37098103E-03_JPRB, 0.37097928E-03_JPRB, 0.37097686E-03_JPRB, 0.37097369E-03_JPRB, &
  & 0.37096973E-03_JPRB, 0.37096482E-03_JPRB, 0.37095859E-03_JPRB, 0.37095044E-03_JPRB, 0.37093990E-03_JPRB, 0.37092675E-03_JPRB, &
  & 0.37091112E-03_JPRB, 0.37089348E-03_JPRB, 0.37087413E-03_JPRB, 0.37085358E-03_JPRB, 0.37083181E-03_JPRB, 0.37080885E-03_JPRB, &
  & 0.37078475E-03_JPRB, 0.37075975E-03_JPRB, 0.37073475E-03_JPRB, 0.37071056E-03_JPRB, 0.37068728E-03_JPRB, 0.37066505E-03_JPRB, &
  & 0.37064313E-03_JPRB, 0.37062113E-03_JPRB, 0.37059851E-03_JPRB, 0.37057570E-03_JPRB, 0.37055355E-03_JPRB, 0.37053321E-03_JPRB, &
  & 0.37051504E-03_JPRB, 0.37049886E-03_JPRB, 0.37048259E-03_JPRB, 0.37045791E-03_JPRB /)

RGHG1(:,39, 4) = (/ &
  & 0.37029112E-03_JPRB, 0.37033283E-03_JPRB, 0.37035765E-03_JPRB, 0.37038175E-03_JPRB, 0.37040599E-03_JPRB, 0.37043105E-03_JPRB, &
  & 0.37045570E-03_JPRB, 0.37048009E-03_JPRB, 0.37050497E-03_JPRB, 0.37053140E-03_JPRB, 0.37056024E-03_JPRB, 0.37059243E-03_JPRB, &
  & 0.37062826E-03_JPRB, 0.37066752E-03_JPRB, 0.37070893E-03_JPRB, 0.37075058E-03_JPRB, 0.37079072E-03_JPRB, 0.37082817E-03_JPRB, &
  & 0.37086228E-03_JPRB, 0.37089252E-03_JPRB, 0.37091807E-03_JPRB, 0.37093851E-03_JPRB, 0.37095381E-03_JPRB, 0.37096464E-03_JPRB, &
  & 0.37097186E-03_JPRB, 0.37097681E-03_JPRB, 0.37098033E-03_JPRB, 0.37098283E-03_JPRB, 0.37098449E-03_JPRB, 0.37098530E-03_JPRB, &
  & 0.37098580E-03_JPRB, 0.37098557E-03_JPRB, 0.37098466E-03_JPRB, 0.37098318E-03_JPRB, 0.37098123E-03_JPRB, 0.37097858E-03_JPRB, &
  & 0.37097538E-03_JPRB, 0.37097133E-03_JPRB, 0.37096615E-03_JPRB, 0.37095926E-03_JPRB, 0.37094997E-03_JPRB, 0.37093824E-03_JPRB, &
  & 0.37092398E-03_JPRB, 0.37090751E-03_JPRB, 0.37088958E-03_JPRB, 0.37087040E-03_JPRB, 0.37085000E-03_JPRB, 0.37082843E-03_JPRB, &
  & 0.37080530E-03_JPRB, 0.37078111E-03_JPRB, 0.37075701E-03_JPRB, 0.37073382E-03_JPRB, 0.37071205E-03_JPRB, 0.37069147E-03_JPRB, &
  & 0.37067122E-03_JPRB, 0.37065119E-03_JPRB, 0.37063088E-03_JPRB, 0.37061045E-03_JPRB, 0.37059066E-03_JPRB, 0.37057229E-03_JPRB, &
  & 0.37055591E-03_JPRB, 0.37054106E-03_JPRB, 0.37052608E-03_JPRB, 0.37050265E-03_JPRB /)

RGHG1(:,40, 4) = (/ &
  & 0.37034749E-03_JPRB, 0.37038547E-03_JPRB, 0.37040995E-03_JPRB, 0.37043262E-03_JPRB, 0.37045695E-03_JPRB, 0.37048099E-03_JPRB, &
  & 0.37050416E-03_JPRB, 0.37052640E-03_JPRB, 0.37054869E-03_JPRB, 0.37057191E-03_JPRB, 0.37059750E-03_JPRB, 0.37062622E-03_JPRB, &
  & 0.37065882E-03_JPRB, 0.37069499E-03_JPRB, 0.37073353E-03_JPRB, 0.37077241E-03_JPRB, 0.37081004E-03_JPRB, 0.37084558E-03_JPRB, &
  & 0.37087809E-03_JPRB, 0.37090646E-03_JPRB, 0.37092995E-03_JPRB, 0.37094805E-03_JPRB, 0.37096124E-03_JPRB, 0.37097020E-03_JPRB, &
  & 0.37097608E-03_JPRB, 0.37098021E-03_JPRB, 0.37098309E-03_JPRB, 0.37098519E-03_JPRB, 0.37098664E-03_JPRB, 0.37098743E-03_JPRB, &
  & 0.37098781E-03_JPRB, 0.37098763E-03_JPRB, 0.37098679E-03_JPRB, 0.37098548E-03_JPRB, 0.37098382E-03_JPRB, 0.37098155E-03_JPRB, &
  & 0.37097884E-03_JPRB, 0.37097541E-03_JPRB, 0.37097104E-03_JPRB, 0.37096505E-03_JPRB, 0.37095707E-03_JPRB, 0.37094680E-03_JPRB, &
  & 0.37093394E-03_JPRB, 0.37091901E-03_JPRB, 0.37090250E-03_JPRB, 0.37088490E-03_JPRB, 0.37086595E-03_JPRB, 0.37084543E-03_JPRB, &
  & 0.37082305E-03_JPRB, 0.37079974E-03_JPRB, 0.37077628E-03_JPRB, 0.37075407E-03_JPRB, 0.37073347E-03_JPRB, 0.37071441E-03_JPRB, &
  & 0.37069619E-03_JPRB, 0.37067823E-03_JPRB, 0.37065998E-03_JPRB, 0.37064168E-03_JPRB, 0.37062404E-03_JPRB, 0.37060777E-03_JPRB, &
  & 0.37059330E-03_JPRB, 0.37058003E-03_JPRB, 0.37056635E-03_JPRB, 0.37054464E-03_JPRB /)

RGHG1(:,41, 4) = (/ &
  & 0.37040102E-03_JPRB, 0.37043705E-03_JPRB, 0.37045931E-03_JPRB, 0.37048219E-03_JPRB, 0.37050576E-03_JPRB, 0.37052925E-03_JPRB, &
  & 0.37055119E-03_JPRB, 0.37057130E-03_JPRB, 0.37059083E-03_JPRB, 0.37061109E-03_JPRB, 0.37063315E-03_JPRB, 0.37065856E-03_JPRB, &
  & 0.37068789E-03_JPRB, 0.37072090E-03_JPRB, 0.37075637E-03_JPRB, 0.37079270E-03_JPRB, 0.37082814E-03_JPRB, 0.37086147E-03_JPRB, &
  & 0.37089188E-03_JPRB, 0.37091816E-03_JPRB, 0.37093941E-03_JPRB, 0.37095533E-03_JPRB, 0.37096653E-03_JPRB, 0.37097407E-03_JPRB, &
  & 0.37097899E-03_JPRB, 0.37098245E-03_JPRB, 0.37098498E-03_JPRB, 0.37098676E-03_JPRB, 0.37098807E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37098903E-03_JPRB, 0.37098827E-03_JPRB, 0.37098708E-03_JPRB, 0.37098560E-03_JPRB, 0.37098356E-03_JPRB, &
  & 0.37098117E-03_JPRB, 0.37097820E-03_JPRB, 0.37097439E-03_JPRB, 0.37096921E-03_JPRB, 0.37096228E-03_JPRB, 0.37095332E-03_JPRB, &
  & 0.37094206E-03_JPRB, 0.37092867E-03_JPRB, 0.37091368E-03_JPRB, 0.37089759E-03_JPRB, 0.37087986E-03_JPRB, 0.37086042E-03_JPRB, &
  & 0.37083912E-03_JPRB, 0.37081644E-03_JPRB, 0.37079363E-03_JPRB, 0.37077226E-03_JPRB, 0.37075288E-03_JPRB, 0.37073527E-03_JPRB, &
  & 0.37071866E-03_JPRB, 0.37070247E-03_JPRB, 0.37068626E-03_JPRB, 0.37067011E-03_JPRB, 0.37065466E-03_JPRB, 0.37064072E-03_JPRB, &
  & 0.37062803E-03_JPRB, 0.37061624E-03_JPRB, 0.37060384E-03_JPRB, 0.37058367E-03_JPRB /)

RGHG1(:,42, 4) = (/ &
  & 0.37045268E-03_JPRB, 0.37048591E-03_JPRB, 0.37050748E-03_JPRB, 0.37052919E-03_JPRB, 0.37055294E-03_JPRB, 0.37057605E-03_JPRB, &
  & 0.37059651E-03_JPRB, 0.37061475E-03_JPRB, 0.37063161E-03_JPRB, 0.37064875E-03_JPRB, 0.37066769E-03_JPRB, 0.37068961E-03_JPRB, &
  & 0.37071545E-03_JPRB, 0.37074529E-03_JPRB, 0.37077788E-03_JPRB, 0.37081167E-03_JPRB, 0.37084476E-03_JPRB, 0.37087596E-03_JPRB, &
  & 0.37090413E-03_JPRB, 0.37092820E-03_JPRB, 0.37094700E-03_JPRB, 0.37096083E-03_JPRB, 0.37097040E-03_JPRB, 0.37097684E-03_JPRB, &
  & 0.37098108E-03_JPRB, 0.37098408E-03_JPRB, 0.37098629E-03_JPRB, 0.37098795E-03_JPRB, 0.37098915E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099008E-03_JPRB, 0.37098947E-03_JPRB, 0.37098827E-03_JPRB, 0.37098688E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098301E-03_JPRB, 0.37098030E-03_JPRB, 0.37097692E-03_JPRB, 0.37097235E-03_JPRB, 0.37096642E-03_JPRB, 0.37095867E-03_JPRB, &
  & 0.37094881E-03_JPRB, 0.37093717E-03_JPRB, 0.37092372E-03_JPRB, 0.37090911E-03_JPRB, 0.37089278E-03_JPRB, 0.37087451E-03_JPRB, &
  & 0.37085416E-03_JPRB, 0.37083210E-03_JPRB, 0.37080978E-03_JPRB, 0.37078914E-03_JPRB, 0.37077084E-03_JPRB, 0.37075466E-03_JPRB, &
  & 0.37073958E-03_JPRB, 0.37072512E-03_JPRB, 0.37071068E-03_JPRB, 0.37069645E-03_JPRB, 0.37068309E-03_JPRB, 0.37067092E-03_JPRB, &
  & 0.37066007E-03_JPRB, 0.37064980E-03_JPRB, 0.37063871E-03_JPRB, 0.37062037E-03_JPRB /)

RGHG1(:,43, 4) = (/ &
  & 0.37050215E-03_JPRB, 0.37053326E-03_JPRB, 0.37055384E-03_JPRB, 0.37057523E-03_JPRB, 0.37059872E-03_JPRB, 0.37062116E-03_JPRB, &
  & 0.37064031E-03_JPRB, 0.37065649E-03_JPRB, 0.37067101E-03_JPRB, 0.37068536E-03_JPRB, 0.37070102E-03_JPRB, 0.37071947E-03_JPRB, &
  & 0.37074203E-03_JPRB, 0.37076880E-03_JPRB, 0.37079863E-03_JPRB, 0.37082983E-03_JPRB, 0.37086048E-03_JPRB, 0.37088949E-03_JPRB, &
  & 0.37091531E-03_JPRB, 0.37093685E-03_JPRB, 0.37095335E-03_JPRB, 0.37096519E-03_JPRB, 0.37097337E-03_JPRB, 0.37097896E-03_JPRB, &
  & 0.37098274E-03_JPRB, 0.37098533E-03_JPRB, 0.37098731E-03_JPRB, 0.37098891E-03_JPRB, 0.37098996E-03_JPRB, 0.37099063E-03_JPRB, &
  & 0.37099104E-03_JPRB, 0.37099089E-03_JPRB, 0.37099034E-03_JPRB, 0.37098923E-03_JPRB, 0.37098792E-03_JPRB, 0.37098621E-03_JPRB, &
  & 0.37098434E-03_JPRB, 0.37098187E-03_JPRB, 0.37097881E-03_JPRB, 0.37097483E-03_JPRB, 0.37096970E-03_JPRB, 0.37096298E-03_JPRB, &
  & 0.37095466E-03_JPRB, 0.37094482E-03_JPRB, 0.37093324E-03_JPRB, 0.37092008E-03_JPRB, 0.37090504E-03_JPRB, 0.37088786E-03_JPRB, &
  & 0.37086837E-03_JPRB, 0.37084703E-03_JPRB, 0.37082552E-03_JPRB, 0.37080585E-03_JPRB, 0.37078882E-03_JPRB, 0.37077395E-03_JPRB, &
  & 0.37076045E-03_JPRB, 0.37074747E-03_JPRB, 0.37073457E-03_JPRB, 0.37072203E-03_JPRB, 0.37071030E-03_JPRB, 0.37069980E-03_JPRB, &
  & 0.37069048E-03_JPRB, 0.37068155E-03_JPRB, 0.37067165E-03_JPRB, 0.37065509E-03_JPRB /)

RGHG1(:,44, 4) = (/ &
  & 0.37055003E-03_JPRB, 0.37057977E-03_JPRB, 0.37059921E-03_JPRB, 0.37061996E-03_JPRB, 0.37064278E-03_JPRB, 0.37066467E-03_JPRB, &
  & 0.37068242E-03_JPRB, 0.37069683E-03_JPRB, 0.37070899E-03_JPRB, 0.37072084E-03_JPRB, 0.37073370E-03_JPRB, 0.37074913E-03_JPRB, &
  & 0.37076836E-03_JPRB, 0.37079203E-03_JPRB, 0.37081918E-03_JPRB, 0.37084793E-03_JPRB, 0.37087625E-03_JPRB, 0.37090265E-03_JPRB, &
  & 0.37092576E-03_JPRB, 0.37094444E-03_JPRB, 0.37095862E-03_JPRB, 0.37096872E-03_JPRB, 0.37097582E-03_JPRB, 0.37098065E-03_JPRB, &
  & 0.37098397E-03_JPRB, 0.37098635E-03_JPRB, 0.37098816E-03_JPRB, 0.37098955E-03_JPRB, 0.37099069E-03_JPRB, 0.37099139E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099165E-03_JPRB, 0.37099113E-03_JPRB, 0.37099008E-03_JPRB, 0.37098880E-03_JPRB, 0.37098723E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098321E-03_JPRB, 0.37098039E-03_JPRB, 0.37097686E-03_JPRB, 0.37097238E-03_JPRB, 0.37096674E-03_JPRB, &
  & 0.37095996E-03_JPRB, 0.37095189E-03_JPRB, 0.37094226E-03_JPRB, 0.37093071E-03_JPRB, 0.37091726E-03_JPRB, 0.37090131E-03_JPRB, &
  & 0.37088280E-03_JPRB, 0.37086228E-03_JPRB, 0.37084171E-03_JPRB, 0.37082317E-03_JPRB, 0.37080751E-03_JPRB, 0.37079395E-03_JPRB, &
  & 0.37078178E-03_JPRB, 0.37077014E-03_JPRB, 0.37075859E-03_JPRB, 0.37074729E-03_JPRB, 0.37073696E-03_JPRB, 0.37072785E-03_JPRB, &
  & 0.37071985E-03_JPRB, 0.37071202E-03_JPRB, 0.37070332E-03_JPRB, 0.37068850E-03_JPRB /)

RGHG1(:,45, 4) = (/ &
  & 0.37059630E-03_JPRB, 0.37062436E-03_JPRB, 0.37064333E-03_JPRB, 0.37066318E-03_JPRB, 0.37068574E-03_JPRB, 0.37070672E-03_JPRB, &
  & 0.37072320E-03_JPRB, 0.37073565E-03_JPRB, 0.37074601E-03_JPRB, 0.37075553E-03_JPRB, 0.37076592E-03_JPRB, 0.37077846E-03_JPRB, &
  & 0.37079485E-03_JPRB, 0.37081569E-03_JPRB, 0.37084022E-03_JPRB, 0.37086642E-03_JPRB, 0.37089208E-03_JPRB, 0.37091575E-03_JPRB, &
  & 0.37093542E-03_JPRB, 0.37095122E-03_JPRB, 0.37096313E-03_JPRB, 0.37097171E-03_JPRB, 0.37097780E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098504E-03_JPRB, 0.37098728E-03_JPRB, 0.37098897E-03_JPRB, 0.37099028E-03_JPRB, 0.37099136E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099223E-03_JPRB, 0.37099179E-03_JPRB, 0.37099078E-03_JPRB, 0.37098947E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098641E-03_JPRB, 0.37098426E-03_JPRB, 0.37098164E-03_JPRB, 0.37097855E-03_JPRB, 0.37097462E-03_JPRB, 0.37096988E-03_JPRB, &
  & 0.37096458E-03_JPRB, 0.37095818E-03_JPRB, 0.37095064E-03_JPRB, 0.37094107E-03_JPRB, 0.37092954E-03_JPRB, 0.37091508E-03_JPRB, &
  & 0.37089770E-03_JPRB, 0.37087826E-03_JPRB, 0.37085882E-03_JPRB, 0.37084159E-03_JPRB, 0.37082715E-03_JPRB, 0.37081493E-03_JPRB, &
  & 0.37080399E-03_JPRB, 0.37079348E-03_JPRB, 0.37078300E-03_JPRB, 0.37077296E-03_JPRB, 0.37076388E-03_JPRB, 0.37075600E-03_JPRB, &
  & 0.37074892E-03_JPRB, 0.37074208E-03_JPRB, 0.37073449E-03_JPRB, 0.37072122E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART8',0,ZHOOK_HANDLE)



RGHG1(:,46, 4) = (/ &
  & 0.37064060E-03_JPRB, 0.37066746E-03_JPRB, 0.37068559E-03_JPRB, 0.37070498E-03_JPRB, 0.37072678E-03_JPRB, 0.37074700E-03_JPRB, &
  & 0.37076214E-03_JPRB, 0.37077308E-03_JPRB, 0.37078172E-03_JPRB, 0.37078964E-03_JPRB, 0.37079788E-03_JPRB, 0.37080812E-03_JPRB, &
  & 0.37082168E-03_JPRB, 0.37083984E-03_JPRB, 0.37086202E-03_JPRB, 0.37088554E-03_JPRB, 0.37090827E-03_JPRB, 0.37092812E-03_JPRB, &
  & 0.37094444E-03_JPRB, 0.37095713E-03_JPRB, 0.37096691E-03_JPRB, 0.37097410E-03_JPRB, 0.37097951E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098804E-03_JPRB, 0.37098961E-03_JPRB, 0.37099089E-03_JPRB, 0.37099191E-03_JPRB, 0.37099255E-03_JPRB, &
  & 0.37099287E-03_JPRB, 0.37099278E-03_JPRB, 0.37099241E-03_JPRB, 0.37099150E-03_JPRB, 0.37099016E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37098714E-03_JPRB, 0.37098507E-03_JPRB, 0.37098269E-03_JPRB, 0.37097995E-03_JPRB, 0.37097652E-03_JPRB, 0.37097267E-03_JPRB, &
  & 0.37096845E-03_JPRB, 0.37096371E-03_JPRB, 0.37095812E-03_JPRB, 0.37095105E-03_JPRB, 0.37094171E-03_JPRB, 0.37092925E-03_JPRB, &
  & 0.37091348E-03_JPRB, 0.37089534E-03_JPRB, 0.37087715E-03_JPRB, 0.37086132E-03_JPRB, 0.37084820E-03_JPRB, 0.37083722E-03_JPRB, &
  & 0.37082724E-03_JPRB, 0.37081775E-03_JPRB, 0.37080832E-03_JPRB, 0.37079927E-03_JPRB, 0.37079118E-03_JPRB, 0.37078426E-03_JPRB, &
  & 0.37077806E-03_JPRB, 0.37077215E-03_JPRB, 0.37076548E-03_JPRB, 0.37075373E-03_JPRB /)

RGHG1(:,47, 4) = (/ &
  & 0.37068201E-03_JPRB, 0.37070861E-03_JPRB, 0.37072579E-03_JPRB, 0.37074511E-03_JPRB, 0.37076627E-03_JPRB, 0.37078545E-03_JPRB, &
  & 0.37079933E-03_JPRB, 0.37080882E-03_JPRB, 0.37081621E-03_JPRB, 0.37082258E-03_JPRB, 0.37082948E-03_JPRB, 0.37083769E-03_JPRB, &
  & 0.37084927E-03_JPRB, 0.37086511E-03_JPRB, 0.37088458E-03_JPRB, 0.37090530E-03_JPRB, 0.37092398E-03_JPRB, 0.37093987E-03_JPRB, &
  & 0.37095230E-03_JPRB, 0.37096217E-03_JPRB, 0.37096994E-03_JPRB, 0.37097605E-03_JPRB, 0.37098076E-03_JPRB, 0.37098423E-03_JPRB, &
  & 0.37098670E-03_JPRB, 0.37098862E-03_JPRB, 0.37099014E-03_JPRB, 0.37099147E-03_JPRB, 0.37099249E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099337E-03_JPRB, 0.37099337E-03_JPRB, 0.37099305E-03_JPRB, 0.37099209E-03_JPRB, 0.37099075E-03_JPRB, 0.37098941E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098577E-03_JPRB, 0.37098356E-03_JPRB, 0.37098100E-03_JPRB, 0.37097806E-03_JPRB, 0.37097491E-03_JPRB, &
  & 0.37097168E-03_JPRB, 0.37096819E-03_JPRB, 0.37096435E-03_JPRB, 0.37095946E-03_JPRB, 0.37095259E-03_JPRB, 0.37094273E-03_JPRB, &
  & 0.37092937E-03_JPRB, 0.37091304E-03_JPRB, 0.37089636E-03_JPRB, 0.37088210E-03_JPRB, 0.37087040E-03_JPRB, 0.37086048E-03_JPRB, &
  & 0.37085169E-03_JPRB, 0.37084307E-03_JPRB, 0.37083455E-03_JPRB, 0.37082637E-03_JPRB, 0.37081906E-03_JPRB, 0.37081284E-03_JPRB, &
  & 0.37080742E-03_JPRB, 0.37080227E-03_JPRB, 0.37079636E-03_JPRB, 0.37078600E-03_JPRB /)

RGHG1(:,48, 4) = (/ &
  & 0.37072154E-03_JPRB, 0.37074677E-03_JPRB, 0.37076458E-03_JPRB, 0.37078295E-03_JPRB, 0.37080396E-03_JPRB, 0.37082206E-03_JPRB, &
  & 0.37083472E-03_JPRB, 0.37084328E-03_JPRB, 0.37084956E-03_JPRB, 0.37085504E-03_JPRB, 0.37086054E-03_JPRB, 0.37086767E-03_JPRB, &
  & 0.37087727E-03_JPRB, 0.37089078E-03_JPRB, 0.37090731E-03_JPRB, 0.37092387E-03_JPRB, 0.37093827E-03_JPRB, 0.37094971E-03_JPRB, &
  & 0.37095891E-03_JPRB, 0.37096624E-03_JPRB, 0.37097238E-03_JPRB, 0.37097750E-03_JPRB, 0.37098175E-03_JPRB, 0.37098496E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098920E-03_JPRB, 0.37099066E-03_JPRB, 0.37099197E-03_JPRB, 0.37099296E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37099380E-03_JPRB, 0.37099351E-03_JPRB, 0.37099264E-03_JPRB, 0.37099130E-03_JPRB, 0.37098996E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098644E-03_JPRB, 0.37098429E-03_JPRB, 0.37098196E-03_JPRB, 0.37097940E-03_JPRB, 0.37097678E-03_JPRB, &
  & 0.37097427E-03_JPRB, 0.37097180E-03_JPRB, 0.37096921E-03_JPRB, 0.37096592E-03_JPRB, 0.37096138E-03_JPRB, 0.37095440E-03_JPRB, &
  & 0.37094406E-03_JPRB, 0.37093053E-03_JPRB, 0.37091627E-03_JPRB, 0.37090378E-03_JPRB, 0.37089357E-03_JPRB, 0.37088498E-03_JPRB, &
  & 0.37087713E-03_JPRB, 0.37086947E-03_JPRB, 0.37086173E-03_JPRB, 0.37085434E-03_JPRB, 0.37084776E-03_JPRB, 0.37084220E-03_JPRB, &
  & 0.37083728E-03_JPRB, 0.37083260E-03_JPRB, 0.37082736E-03_JPRB, 0.37081807E-03_JPRB /)

RGHG1(:,49, 4) = (/ &
  & 0.37075795E-03_JPRB, 0.37078344E-03_JPRB, 0.37080052E-03_JPRB, 0.37081935E-03_JPRB, 0.37083949E-03_JPRB, 0.37085696E-03_JPRB, &
  & 0.37086863E-03_JPRB, 0.37087622E-03_JPRB, 0.37088175E-03_JPRB, 0.37088632E-03_JPRB, 0.37089112E-03_JPRB, 0.37089674E-03_JPRB, &
  & 0.37090469E-03_JPRB, 0.37091522E-03_JPRB, 0.37092777E-03_JPRB, 0.37093979E-03_JPRB, 0.37094968E-03_JPRB, 0.37095760E-03_JPRB, &
  & 0.37096397E-03_JPRB, 0.37096959E-03_JPRB, 0.37097445E-03_JPRB, 0.37097879E-03_JPRB, 0.37098257E-03_JPRB, 0.37098560E-03_JPRB, &
  & 0.37098787E-03_JPRB, 0.37098964E-03_JPRB, 0.37099110E-03_JPRB, 0.37099241E-03_JPRB, 0.37099331E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099424E-03_JPRB, 0.37099386E-03_JPRB, 0.37099302E-03_JPRB, 0.37099177E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098696E-03_JPRB, 0.37098501E-03_JPRB, 0.37098277E-03_JPRB, 0.37098050E-03_JPRB, 0.37097826E-03_JPRB, &
  & 0.37097643E-03_JPRB, 0.37097477E-03_JPRB, 0.37097302E-03_JPRB, 0.37097081E-03_JPRB, 0.37096784E-03_JPRB, 0.37096310E-03_JPRB, &
  & 0.37095597E-03_JPRB, 0.37094610E-03_JPRB, 0.37093533E-03_JPRB, 0.37092567E-03_JPRB, 0.37091738E-03_JPRB, 0.37091016E-03_JPRB, &
  & 0.37090335E-03_JPRB, 0.37089645E-03_JPRB, 0.37088944E-03_JPRB, 0.37088254E-03_JPRB, 0.37087651E-03_JPRB, 0.37087148E-03_JPRB, &
  & 0.37086714E-03_JPRB, 0.37086292E-03_JPRB, 0.37085812E-03_JPRB, 0.37084980E-03_JPRB /)

RGHG1(:,50, 4) = (/ &
  & 0.37079173E-03_JPRB, 0.37081781E-03_JPRB, 0.37083478E-03_JPRB, 0.37085352E-03_JPRB, 0.37087320E-03_JPRB, 0.37088964E-03_JPRB, &
  & 0.37090020E-03_JPRB, 0.37090675E-03_JPRB, 0.37091132E-03_JPRB, 0.37091505E-03_JPRB, 0.37091863E-03_JPRB, 0.37092302E-03_JPRB, &
  & 0.37092838E-03_JPRB, 0.37093583E-03_JPRB, 0.37094398E-03_JPRB, 0.37095172E-03_JPRB, 0.37095809E-03_JPRB, 0.37096336E-03_JPRB, &
  & 0.37096787E-03_JPRB, 0.37097197E-03_JPRB, 0.37097593E-03_JPRB, 0.37097972E-03_JPRB, 0.37098309E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098824E-03_JPRB, 0.37099011E-03_JPRB, 0.37099156E-03_JPRB, 0.37099284E-03_JPRB, 0.37099369E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099462E-03_JPRB, 0.37099436E-03_JPRB, 0.37099357E-03_JPRB, 0.37099232E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37098935E-03_JPRB, 0.37098757E-03_JPRB, 0.37098571E-03_JPRB, 0.37098356E-03_JPRB, 0.37098149E-03_JPRB, 0.37097960E-03_JPRB, &
  & 0.37097817E-03_JPRB, 0.37097698E-03_JPRB, 0.37097576E-03_JPRB, 0.37097439E-03_JPRB, 0.37097232E-03_JPRB, 0.37096936E-03_JPRB, &
  & 0.37096464E-03_JPRB, 0.37095824E-03_JPRB, 0.37095146E-03_JPRB, 0.37094502E-03_JPRB, 0.37093944E-03_JPRB, 0.37093402E-03_JPRB, &
  & 0.37092873E-03_JPRB, 0.37092293E-03_JPRB, 0.37091685E-03_JPRB, 0.37091074E-03_JPRB, 0.37090533E-03_JPRB, 0.37090079E-03_JPRB, &
  & 0.37089671E-03_JPRB, 0.37089287E-03_JPRB, 0.37088851E-03_JPRB, 0.37088068E-03_JPRB /)

RGHG1(:,51, 4) = (/ &
  & 0.37082424E-03_JPRB, 0.37084869E-03_JPRB, 0.37086740E-03_JPRB, 0.37088478E-03_JPRB, 0.37090399E-03_JPRB, 0.37091839E-03_JPRB, &
  & 0.37092707E-03_JPRB, 0.37093213E-03_JPRB, 0.37093536E-03_JPRB, 0.37093792E-03_JPRB, 0.37094025E-03_JPRB, 0.37094275E-03_JPRB, &
  & 0.37094619E-03_JPRB, 0.37095021E-03_JPRB, 0.37095518E-03_JPRB, 0.37095987E-03_JPRB, 0.37096397E-03_JPRB, 0.37096755E-03_JPRB, &
  & 0.37097081E-03_JPRB, 0.37097401E-03_JPRB, 0.37097724E-03_JPRB, 0.37098053E-03_JPRB, 0.37098370E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098868E-03_JPRB, 0.37099063E-03_JPRB, 0.37099203E-03_JPRB, 0.37099325E-03_JPRB, 0.37099406E-03_JPRB, 0.37099473E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099503E-03_JPRB, 0.37099468E-03_JPRB, 0.37099389E-03_JPRB, 0.37099270E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37098976E-03_JPRB, 0.37098807E-03_JPRB, 0.37098621E-03_JPRB, 0.37098414E-03_JPRB, 0.37098234E-03_JPRB, 0.37098082E-03_JPRB, &
  & 0.37097966E-03_JPRB, 0.37097879E-03_JPRB, 0.37097791E-03_JPRB, 0.37097701E-03_JPRB, 0.37097567E-03_JPRB, 0.37097372E-03_JPRB, &
  & 0.37097072E-03_JPRB, 0.37096691E-03_JPRB, 0.37096289E-03_JPRB, 0.37095958E-03_JPRB, 0.37095638E-03_JPRB, 0.37095335E-03_JPRB, &
  & 0.37094991E-03_JPRB, 0.37094601E-03_JPRB, 0.37094147E-03_JPRB, 0.37093664E-03_JPRB, 0.37093210E-03_JPRB, 0.37092814E-03_JPRB, &
  & 0.37092465E-03_JPRB, 0.37092122E-03_JPRB, 0.37091720E-03_JPRB, 0.37091025E-03_JPRB /)

RGHG1(:,52, 4) = (/ &
  & 0.37085207E-03_JPRB, 0.37087983E-03_JPRB, 0.37089494E-03_JPRB, 0.37091324E-03_JPRB, 0.37092884E-03_JPRB, 0.37094031E-03_JPRB, &
  & 0.37094639E-03_JPRB, 0.37094956E-03_JPRB, 0.37095154E-03_JPRB, 0.37095297E-03_JPRB, 0.37095428E-03_JPRB, 0.37095573E-03_JPRB, &
  & 0.37095728E-03_JPRB, 0.37095966E-03_JPRB, 0.37096231E-03_JPRB, 0.37096531E-03_JPRB, 0.37096802E-03_JPRB, 0.37097061E-03_JPRB, &
  & 0.37097302E-03_JPRB, 0.37097550E-03_JPRB, 0.37097817E-03_JPRB, 0.37098117E-03_JPRB, 0.37098417E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098909E-03_JPRB, 0.37099104E-03_JPRB, 0.37099246E-03_JPRB, 0.37099366E-03_JPRB, 0.37099450E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099537E-03_JPRB, 0.37099505E-03_JPRB, 0.37099433E-03_JPRB, 0.37099316E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099022E-03_JPRB, 0.37098853E-03_JPRB, 0.37098670E-03_JPRB, 0.37098484E-03_JPRB, 0.37098315E-03_JPRB, 0.37098184E-03_JPRB, &
  & 0.37098094E-03_JPRB, 0.37098027E-03_JPRB, 0.37097969E-03_JPRB, 0.37097911E-03_JPRB, 0.37097814E-03_JPRB, 0.37097681E-03_JPRB, &
  & 0.37097483E-03_JPRB, 0.37097250E-03_JPRB, 0.37097052E-03_JPRB, 0.37096874E-03_JPRB, 0.37096726E-03_JPRB, 0.37096578E-03_JPRB, &
  & 0.37096412E-03_JPRB, 0.37096202E-03_JPRB, 0.37095937E-03_JPRB, 0.37095626E-03_JPRB, 0.37095317E-03_JPRB, 0.37095038E-03_JPRB, &
  & 0.37094776E-03_JPRB, 0.37094511E-03_JPRB, 0.37094200E-03_JPRB, 0.37093580E-03_JPRB /)

RGHG1(:,53, 4) = (/ &
  & 0.37088033E-03_JPRB, 0.37090314E-03_JPRB, 0.37092116E-03_JPRB, 0.37093434E-03_JPRB, 0.37094727E-03_JPRB, 0.37095475E-03_JPRB, &
  & 0.37095844E-03_JPRB, 0.37096028E-03_JPRB, 0.37096126E-03_JPRB, 0.37096196E-03_JPRB, 0.37096263E-03_JPRB, 0.37096330E-03_JPRB, &
  & 0.37096423E-03_JPRB, 0.37096534E-03_JPRB, 0.37096711E-03_JPRB, 0.37096898E-03_JPRB, 0.37097090E-03_JPRB, 0.37097285E-03_JPRB, &
  & 0.37097483E-03_JPRB, 0.37097692E-03_JPRB, 0.37097919E-03_JPRB, 0.37098187E-03_JPRB, 0.37098464E-03_JPRB, 0.37098740E-03_JPRB, &
  & 0.37098961E-03_JPRB, 0.37099150E-03_JPRB, 0.37099290E-03_JPRB, 0.37099406E-03_JPRB, 0.37099491E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099555E-03_JPRB, 0.37099567E-03_JPRB, 0.37099537E-03_JPRB, 0.37099465E-03_JPRB, 0.37099351E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37098894E-03_JPRB, 0.37098717E-03_JPRB, 0.37098542E-03_JPRB, 0.37098388E-03_JPRB, 0.37098283E-03_JPRB, &
  & 0.37098210E-03_JPRB, 0.37098167E-03_JPRB, 0.37098129E-03_JPRB, 0.37098085E-03_JPRB, 0.37098012E-03_JPRB, 0.37097911E-03_JPRB, &
  & 0.37097771E-03_JPRB, 0.37097634E-03_JPRB, 0.37097521E-03_JPRB, 0.37097445E-03_JPRB, 0.37097378E-03_JPRB, 0.37097311E-03_JPRB, &
  & 0.37097238E-03_JPRB, 0.37097133E-03_JPRB, 0.37096994E-03_JPRB, 0.37096831E-03_JPRB, 0.37096656E-03_JPRB, 0.37096496E-03_JPRB, &
  & 0.37096342E-03_JPRB, 0.37096176E-03_JPRB, 0.37095958E-03_JPRB, 0.37095536E-03_JPRB /)

RGHG1(:,54, 4) = (/ &
  & 0.37090143E-03_JPRB, 0.37092678E-03_JPRB, 0.37093839E-03_JPRB, 0.37095055E-03_JPRB, 0.37095867E-03_JPRB, 0.37096348E-03_JPRB, &
  & 0.37096554E-03_JPRB, 0.37096659E-03_JPRB, 0.37096714E-03_JPRB, 0.37096755E-03_JPRB, 0.37096790E-03_JPRB, 0.37096825E-03_JPRB, &
  & 0.37096866E-03_JPRB, 0.37096941E-03_JPRB, 0.37097037E-03_JPRB, 0.37097174E-03_JPRB, 0.37097314E-03_JPRB, 0.37097465E-03_JPRB, &
  & 0.37097625E-03_JPRB, 0.37097803E-03_JPRB, 0.37098007E-03_JPRB, 0.37098251E-03_JPRB, 0.37098519E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37099188E-03_JPRB, 0.37099334E-03_JPRB, 0.37099441E-03_JPRB, 0.37099523E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099596E-03_JPRB, 0.37099567E-03_JPRB, 0.37099491E-03_JPRB, 0.37099377E-03_JPRB, 0.37099255E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37098941E-03_JPRB, 0.37098766E-03_JPRB, 0.37098600E-03_JPRB, 0.37098466E-03_JPRB, 0.37098370E-03_JPRB, &
  & 0.37098318E-03_JPRB, 0.37098280E-03_JPRB, 0.37098260E-03_JPRB, 0.37098228E-03_JPRB, 0.37098175E-03_JPRB, 0.37098100E-03_JPRB, &
  & 0.37098001E-03_JPRB, 0.37097913E-03_JPRB, 0.37097849E-03_JPRB, 0.37097803E-03_JPRB, 0.37097765E-03_JPRB, 0.37097733E-03_JPRB, &
  & 0.37097695E-03_JPRB, 0.37097646E-03_JPRB, 0.37097576E-03_JPRB, 0.37097497E-03_JPRB, 0.37097413E-03_JPRB, 0.37097337E-03_JPRB, &
  & 0.37097256E-03_JPRB, 0.37097174E-03_JPRB, 0.37097072E-03_JPRB, 0.37096874E-03_JPRB /)

RGHG1(:,55, 4) = (/ &
  & 0.37092229E-03_JPRB, 0.37094153E-03_JPRB, 0.37095312E-03_JPRB, 0.37096036E-03_JPRB, 0.37096610E-03_JPRB, 0.37096889E-03_JPRB, &
  & 0.37097017E-03_JPRB, 0.37097075E-03_JPRB, 0.37097104E-03_JPRB, 0.37097125E-03_JPRB, 0.37097139E-03_JPRB, 0.37097157E-03_JPRB, &
  & 0.37097189E-03_JPRB, 0.37097232E-03_JPRB, 0.37097291E-03_JPRB, 0.37097384E-03_JPRB, 0.37097494E-03_JPRB, 0.37097622E-03_JPRB, &
  & 0.37097756E-03_JPRB, 0.37097905E-03_JPRB, 0.37098088E-03_JPRB, 0.37098330E-03_JPRB, 0.37098577E-03_JPRB, 0.37098833E-03_JPRB, &
  & 0.37099046E-03_JPRB, 0.37099229E-03_JPRB, 0.37099374E-03_JPRB, 0.37099479E-03_JPRB, 0.37099561E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099619E-03_JPRB, 0.37099590E-03_JPRB, 0.37099523E-03_JPRB, 0.37099406E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099136E-03_JPRB, 0.37098987E-03_JPRB, 0.37098819E-03_JPRB, 0.37098667E-03_JPRB, 0.37098548E-03_JPRB, 0.37098464E-03_JPRB, &
  & 0.37098423E-03_JPRB, 0.37098394E-03_JPRB, 0.37098379E-03_JPRB, 0.37098356E-03_JPRB, 0.37098315E-03_JPRB, 0.37098245E-03_JPRB, &
  & 0.37098172E-03_JPRB, 0.37098117E-03_JPRB, 0.37098079E-03_JPRB, 0.37098053E-03_JPRB, 0.37098033E-03_JPRB, 0.37098012E-03_JPRB, &
  & 0.37097989E-03_JPRB, 0.37097963E-03_JPRB, 0.37097937E-03_JPRB, 0.37097902E-03_JPRB, 0.37097855E-03_JPRB, 0.37097803E-03_JPRB, &
  & 0.37097756E-03_JPRB, 0.37097710E-03_JPRB, 0.37097649E-03_JPRB, 0.37097521E-03_JPRB /)

RGHG1(:,56, 4) = (/ &
  & 0.37093824E-03_JPRB, 0.37095501E-03_JPRB, 0.37096196E-03_JPRB, 0.37096738E-03_JPRB, 0.37097087E-03_JPRB, 0.37097256E-03_JPRB, &
  & 0.37097331E-03_JPRB, 0.37097366E-03_JPRB, 0.37097381E-03_JPRB, 0.37097398E-03_JPRB, 0.37097407E-03_JPRB, 0.37097425E-03_JPRB, &
  & 0.37097436E-03_JPRB, 0.37097459E-03_JPRB, 0.37097494E-03_JPRB, 0.37097561E-03_JPRB, 0.37097646E-03_JPRB, 0.37097753E-03_JPRB, &
  & 0.37097873E-03_JPRB, 0.37098007E-03_JPRB, 0.37098170E-03_JPRB, 0.37098397E-03_JPRB, 0.37098638E-03_JPRB, 0.37098883E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37099276E-03_JPRB, 0.37099412E-03_JPRB, 0.37099517E-03_JPRB, 0.37099601E-03_JPRB, 0.37099651E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099648E-03_JPRB, 0.37099613E-03_JPRB, 0.37099549E-03_JPRB, 0.37099438E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099025E-03_JPRB, 0.37098865E-03_JPRB, 0.37098720E-03_JPRB, 0.37098618E-03_JPRB, 0.37098554E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098496E-03_JPRB, 0.37098487E-03_JPRB, 0.37098472E-03_JPRB, 0.37098440E-03_JPRB, 0.37098391E-03_JPRB, &
  & 0.37098330E-03_JPRB, 0.37098280E-03_JPRB, 0.37098248E-03_JPRB, 0.37098234E-03_JPRB, 0.37098216E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098187E-03_JPRB, 0.37098175E-03_JPRB, 0.37098167E-03_JPRB, 0.37098146E-03_JPRB, 0.37098117E-03_JPRB, 0.37098094E-03_JPRB, &
  & 0.37098068E-03_JPRB, 0.37098042E-03_JPRB, 0.37098024E-03_JPRB, 0.37097998E-03_JPRB /)

RGHG1(:,57, 4) = (/ &
  & 0.37095125E-03_JPRB, 0.37096345E-03_JPRB, 0.37096860E-03_JPRB, 0.37097197E-03_JPRB, 0.37097425E-03_JPRB, 0.37097535E-03_JPRB, &
  & 0.37097582E-03_JPRB, 0.37097602E-03_JPRB, 0.37097614E-03_JPRB, 0.37097617E-03_JPRB, 0.37097619E-03_JPRB, 0.37097628E-03_JPRB, &
  & 0.37097640E-03_JPRB, 0.37097657E-03_JPRB, 0.37097684E-03_JPRB, 0.37097727E-03_JPRB, 0.37097785E-03_JPRB, 0.37097876E-03_JPRB, &
  & 0.37097975E-03_JPRB, 0.37098100E-03_JPRB, 0.37098257E-03_JPRB, 0.37098472E-03_JPRB, 0.37098705E-03_JPRB, 0.37098932E-03_JPRB, &
  & 0.37099142E-03_JPRB, 0.37099310E-03_JPRB, 0.37099456E-03_JPRB, 0.37099549E-03_JPRB, 0.37099639E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099674E-03_JPRB, 0.37099645E-03_JPRB, 0.37099578E-03_JPRB, 0.37099468E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099063E-03_JPRB, 0.37098912E-03_JPRB, 0.37098781E-03_JPRB, 0.37098688E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098609E-03_JPRB, 0.37098594E-03_JPRB, 0.37098592E-03_JPRB, 0.37098589E-03_JPRB, 0.37098554E-03_JPRB, 0.37098516E-03_JPRB, &
  & 0.37098461E-03_JPRB, 0.37098426E-03_JPRB, 0.37098408E-03_JPRB, 0.37098402E-03_JPRB, 0.37098388E-03_JPRB, 0.37098373E-03_JPRB, &
  & 0.37098362E-03_JPRB, 0.37098350E-03_JPRB, 0.37098341E-03_JPRB, 0.37098321E-03_JPRB, 0.37098306E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098274E-03_JPRB, 0.37098260E-03_JPRB, 0.37098245E-03_JPRB, 0.37098216E-03_JPRB /)

RGHG1(:,58, 4) = (/ &
  & 0.37096339E-03_JPRB, 0.37097017E-03_JPRB, 0.37097326E-03_JPRB, 0.37097523E-03_JPRB, 0.37097669E-03_JPRB, 0.37097739E-03_JPRB, &
  & 0.37097765E-03_JPRB, 0.37097780E-03_JPRB, 0.37097785E-03_JPRB, 0.37097788E-03_JPRB, 0.37097794E-03_JPRB, 0.37097803E-03_JPRB, &
  & 0.37097809E-03_JPRB, 0.37097820E-03_JPRB, 0.37097838E-03_JPRB, 0.37097879E-03_JPRB, 0.37097928E-03_JPRB, 0.37097995E-03_JPRB, &
  & 0.37098076E-03_JPRB, 0.37098199E-03_JPRB, 0.37098341E-03_JPRB, 0.37098545E-03_JPRB, 0.37098766E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099357E-03_JPRB, 0.37099494E-03_JPRB, 0.37099596E-03_JPRB, 0.37099677E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099706E-03_JPRB, 0.37099671E-03_JPRB, 0.37099601E-03_JPRB, 0.37099491E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37099110E-03_JPRB, 0.37098967E-03_JPRB, 0.37098845E-03_JPRB, 0.37098766E-03_JPRB, 0.37098723E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098691E-03_JPRB, 0.37098688E-03_JPRB, 0.37098699E-03_JPRB, 0.37098670E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098594E-03_JPRB, 0.37098565E-03_JPRB, 0.37098548E-03_JPRB, 0.37098533E-03_JPRB, 0.37098519E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098496E-03_JPRB, 0.37098487E-03_JPRB, 0.37098478E-03_JPRB, 0.37098464E-03_JPRB, 0.37098449E-03_JPRB, 0.37098434E-03_JPRB, &
  & 0.37098420E-03_JPRB, 0.37098402E-03_JPRB, 0.37098388E-03_JPRB, 0.37098365E-03_JPRB /)

RGHG1(:,59, 4) = (/ &
  & 0.37097005E-03_JPRB, 0.37097457E-03_JPRB, 0.37097628E-03_JPRB, 0.37097759E-03_JPRB, 0.37097844E-03_JPRB, 0.37097893E-03_JPRB, &
  & 0.37097916E-03_JPRB, 0.37097922E-03_JPRB, 0.37097931E-03_JPRB, 0.37097937E-03_JPRB, 0.37097943E-03_JPRB, 0.37097948E-03_JPRB, &
  & 0.37097960E-03_JPRB, 0.37097966E-03_JPRB, 0.37097986E-03_JPRB, 0.37098015E-03_JPRB, 0.37098056E-03_JPRB, 0.37098108E-03_JPRB, &
  & 0.37098187E-03_JPRB, 0.37098303E-03_JPRB, 0.37098431E-03_JPRB, 0.37098626E-03_JPRB, 0.37098830E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37099243E-03_JPRB, 0.37099401E-03_JPRB, 0.37099535E-03_JPRB, 0.37099636E-03_JPRB, 0.37099706E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099730E-03_JPRB, 0.37099692E-03_JPRB, 0.37099636E-03_JPRB, 0.37099532E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099153E-03_JPRB, 0.37099019E-03_JPRB, 0.37098912E-03_JPRB, 0.37098830E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098769E-03_JPRB, 0.37098775E-03_JPRB, 0.37098781E-03_JPRB, 0.37098792E-03_JPRB, 0.37098778E-03_JPRB, 0.37098755E-03_JPRB, &
  & 0.37098711E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, 0.37098647E-03_JPRB, 0.37098635E-03_JPRB, 0.37098629E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098609E-03_JPRB, 0.37098594E-03_JPRB, 0.37098577E-03_JPRB, 0.37098565E-03_JPRB, 0.37098554E-03_JPRB, &
  & 0.37098539E-03_JPRB, 0.37098525E-03_JPRB, 0.37098516E-03_JPRB, 0.37098487E-03_JPRB /)

RGHG1(:,60, 4) = (/ &
  & 0.37097526E-03_JPRB, 0.37097762E-03_JPRB, 0.37097879E-03_JPRB, 0.37097948E-03_JPRB, 0.37098012E-03_JPRB, 0.37098047E-03_JPRB, &
  & 0.37098071E-03_JPRB, 0.37098082E-03_JPRB, 0.37098088E-03_JPRB, 0.37098094E-03_JPRB, 0.37098100E-03_JPRB, 0.37098106E-03_JPRB, &
  & 0.37098114E-03_JPRB, 0.37098123E-03_JPRB, 0.37098140E-03_JPRB, 0.37098158E-03_JPRB, 0.37098190E-03_JPRB, 0.37098231E-03_JPRB, &
  & 0.37098301E-03_JPRB, 0.37098405E-03_JPRB, 0.37098530E-03_JPRB, 0.37098708E-03_JPRB, 0.37098906E-03_JPRB, 0.37099115E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099447E-03_JPRB, 0.37099581E-03_JPRB, 0.37099674E-03_JPRB, 0.37099747E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099762E-03_JPRB, 0.37099721E-03_JPRB, 0.37099660E-03_JPRB, 0.37099567E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099313E-03_JPRB, 0.37099197E-03_JPRB, 0.37099075E-03_JPRB, 0.37098973E-03_JPRB, 0.37098894E-03_JPRB, 0.37098868E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098851E-03_JPRB, 0.37098874E-03_JPRB, 0.37098888E-03_JPRB, 0.37098877E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098789E-03_JPRB, 0.37098763E-03_JPRB, 0.37098752E-03_JPRB, 0.37098740E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098723E-03_JPRB, 0.37098711E-03_JPRB, 0.37098705E-03_JPRB, 0.37098685E-03_JPRB, 0.37098670E-03_JPRB, 0.37098659E-03_JPRB, &
  & 0.37098647E-03_JPRB, 0.37098635E-03_JPRB, 0.37098621E-03_JPRB, 0.37098597E-03_JPRB /)

RGHG1(:,61, 4) = (/ &
  & 0.37097812E-03_JPRB, 0.37097983E-03_JPRB, 0.37098053E-03_JPRB, 0.37098108E-03_JPRB, 0.37098149E-03_JPRB, 0.37098181E-03_JPRB, &
  & 0.37098199E-03_JPRB, 0.37098210E-03_JPRB, 0.37098216E-03_JPRB, 0.37098222E-03_JPRB, 0.37098231E-03_JPRB, 0.37098239E-03_JPRB, &
  & 0.37098251E-03_JPRB, 0.37098260E-03_JPRB, 0.37098277E-03_JPRB, 0.37098298E-03_JPRB, 0.37098312E-03_JPRB, 0.37098350E-03_JPRB, &
  & 0.37098408E-03_JPRB, 0.37098513E-03_JPRB, 0.37098626E-03_JPRB, 0.37098784E-03_JPRB, 0.37098979E-03_JPRB, 0.37099179E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099497E-03_JPRB, 0.37099622E-03_JPRB, 0.37099715E-03_JPRB, 0.37099782E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099794E-03_JPRB, 0.37099741E-03_JPRB, 0.37099683E-03_JPRB, 0.37099599E-03_JPRB, 0.37099488E-03_JPRB, &
  & 0.37099354E-03_JPRB, 0.37099238E-03_JPRB, 0.37099130E-03_JPRB, 0.37099043E-03_JPRB, 0.37098970E-03_JPRB, 0.37098941E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098935E-03_JPRB, 0.37098958E-03_JPRB, 0.37098979E-03_JPRB, 0.37098973E-03_JPRB, 0.37098958E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098891E-03_JPRB, 0.37098865E-03_JPRB, 0.37098845E-03_JPRB, 0.37098830E-03_JPRB, 0.37098819E-03_JPRB, &
  & 0.37098810E-03_JPRB, 0.37098804E-03_JPRB, 0.37098792E-03_JPRB, 0.37098778E-03_JPRB, 0.37098772E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098752E-03_JPRB, 0.37098740E-03_JPRB, 0.37098728E-03_JPRB, 0.37098691E-03_JPRB /)

RGHG1(:,62, 4) = (/ &
  & 0.37098030E-03_JPRB, 0.37098152E-03_JPRB, 0.37098213E-03_JPRB, 0.37098251E-03_JPRB, 0.37098286E-03_JPRB, 0.37098309E-03_JPRB, &
  & 0.37098327E-03_JPRB, 0.37098344E-03_JPRB, 0.37098350E-03_JPRB, 0.37098359E-03_JPRB, 0.37098367E-03_JPRB, 0.37098379E-03_JPRB, &
  & 0.37098391E-03_JPRB, 0.37098402E-03_JPRB, 0.37098420E-03_JPRB, 0.37098429E-03_JPRB, 0.37098446E-03_JPRB, 0.37098475E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098624E-03_JPRB, 0.37098725E-03_JPRB, 0.37098874E-03_JPRB, 0.37099048E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099549E-03_JPRB, 0.37099665E-03_JPRB, 0.37099756E-03_JPRB, 0.37099817E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099823E-03_JPRB, 0.37099770E-03_JPRB, 0.37099706E-03_JPRB, 0.37099622E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099299E-03_JPRB, 0.37099194E-03_JPRB, 0.37099101E-03_JPRB, 0.37099031E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37099011E-03_JPRB, 0.37099025E-03_JPRB, 0.37099048E-03_JPRB, 0.37099069E-03_JPRB, 0.37099060E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099025E-03_JPRB, 0.37098996E-03_JPRB, 0.37098967E-03_JPRB, 0.37098944E-03_JPRB, 0.37098920E-03_JPRB, 0.37098912E-03_JPRB, &
  & 0.37098903E-03_JPRB, 0.37098888E-03_JPRB, 0.37098877E-03_JPRB, 0.37098862E-03_JPRB, 0.37098851E-03_JPRB, 0.37098842E-03_JPRB, &
  & 0.37098827E-03_JPRB, 0.37098816E-03_JPRB, 0.37098801E-03_JPRB, 0.37098766E-03_JPRB /)

RGHG1(:,63, 4) = (/ &
  & 0.37098202E-03_JPRB, 0.37098298E-03_JPRB, 0.37098344E-03_JPRB, 0.37098376E-03_JPRB, 0.37098402E-03_JPRB, 0.37098426E-03_JPRB, &
  & 0.37098446E-03_JPRB, 0.37098461E-03_JPRB, 0.37098472E-03_JPRB, 0.37098484E-03_JPRB, 0.37098498E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098536E-03_JPRB, 0.37098554E-03_JPRB, 0.37098571E-03_JPRB, 0.37098574E-03_JPRB, 0.37098594E-03_JPRB, &
  & 0.37098638E-03_JPRB, 0.37098723E-03_JPRB, 0.37098827E-03_JPRB, 0.37098964E-03_JPRB, 0.37099130E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099610E-03_JPRB, 0.37099709E-03_JPRB, 0.37099796E-03_JPRB, 0.37099852E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099849E-03_JPRB, 0.37099802E-03_JPRB, 0.37099741E-03_JPRB, 0.37099654E-03_JPRB, 0.37099564E-03_JPRB, &
  & 0.37099453E-03_JPRB, 0.37099348E-03_JPRB, 0.37099252E-03_JPRB, 0.37099171E-03_JPRB, 0.37099110E-03_JPRB, 0.37099092E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099107E-03_JPRB, 0.37099130E-03_JPRB, 0.37099159E-03_JPRB, 0.37099156E-03_JPRB, 0.37099150E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099101E-03_JPRB, 0.37099078E-03_JPRB, 0.37099051E-03_JPRB, 0.37099031E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098979E-03_JPRB, 0.37098961E-03_JPRB, 0.37098941E-03_JPRB, 0.37098926E-03_JPRB, 0.37098912E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37098886E-03_JPRB, 0.37098871E-03_JPRB, 0.37098833E-03_JPRB /)

RGHG1(:,64, 4) = (/ &
  & 0.37098338E-03_JPRB, 0.37098417E-03_JPRB, 0.37098455E-03_JPRB, 0.37098484E-03_JPRB, 0.37098507E-03_JPRB, 0.37098525E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098565E-03_JPRB, 0.37098583E-03_JPRB, 0.37098594E-03_JPRB, 0.37098612E-03_JPRB, 0.37098629E-03_JPRB, &
  & 0.37098647E-03_JPRB, 0.37098670E-03_JPRB, 0.37098691E-03_JPRB, 0.37098702E-03_JPRB, 0.37098693E-03_JPRB, 0.37098717E-03_JPRB, &
  & 0.37098755E-03_JPRB, 0.37098821E-03_JPRB, 0.37098918E-03_JPRB, 0.37099054E-03_JPRB, 0.37099211E-03_JPRB, 0.37099383E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099660E-03_JPRB, 0.37099762E-03_JPRB, 0.37099837E-03_JPRB, 0.37099893E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099875E-03_JPRB, 0.37099834E-03_JPRB, 0.37099773E-03_JPRB, 0.37099698E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099505E-03_JPRB, 0.37099415E-03_JPRB, 0.37099319E-03_JPRB, 0.37099241E-03_JPRB, 0.37099179E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099162E-03_JPRB, 0.37099188E-03_JPRB, 0.37099214E-03_JPRB, 0.37099243E-03_JPRB, 0.37099246E-03_JPRB, 0.37099243E-03_JPRB, &
  & 0.37099220E-03_JPRB, 0.37099197E-03_JPRB, 0.37099179E-03_JPRB, 0.37099150E-03_JPRB, 0.37099118E-03_JPRB, 0.37099101E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099054E-03_JPRB, 0.37099034E-03_JPRB, 0.37099019E-03_JPRB, 0.37098999E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098964E-03_JPRB, 0.37098952E-03_JPRB, 0.37098935E-03_JPRB, 0.37098897E-03_JPRB /)

RGHG1(:,65, 4) = (/ &
  & 0.37098458E-03_JPRB, 0.37098530E-03_JPRB, 0.37098565E-03_JPRB, 0.37098597E-03_JPRB, 0.37098618E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098682E-03_JPRB, 0.37098699E-03_JPRB, 0.37098717E-03_JPRB, 0.37098734E-03_JPRB, 0.37098752E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098792E-03_JPRB, 0.37098816E-03_JPRB, 0.37098827E-03_JPRB, 0.37098821E-03_JPRB, 0.37098842E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098935E-03_JPRB, 0.37099016E-03_JPRB, 0.37099150E-03_JPRB, 0.37099299E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099715E-03_JPRB, 0.37099796E-03_JPRB, 0.37099869E-03_JPRB, 0.37099919E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099907E-03_JPRB, 0.37099869E-03_JPRB, 0.37099808E-03_JPRB, 0.37099735E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099558E-03_JPRB, 0.37099473E-03_JPRB, 0.37099380E-03_JPRB, 0.37099302E-03_JPRB, 0.37099264E-03_JPRB, 0.37099249E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099264E-03_JPRB, 0.37099296E-03_JPRB, 0.37099331E-03_JPRB, 0.37099337E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099308E-03_JPRB, 0.37099287E-03_JPRB, 0.37099264E-03_JPRB, 0.37099232E-03_JPRB, 0.37099200E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099168E-03_JPRB, 0.37099139E-03_JPRB, 0.37099113E-03_JPRB, 0.37099095E-03_JPRB, 0.37099072E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37099034E-03_JPRB, 0.37099019E-03_JPRB, 0.37098996E-03_JPRB, 0.37098950E-03_JPRB /)

RGHG1(:,66, 4) = (/ &
  & 0.37098560E-03_JPRB, 0.37098632E-03_JPRB, 0.37098664E-03_JPRB, 0.37098693E-03_JPRB, 0.37098711E-03_JPRB, 0.37098737E-03_JPRB, &
  & 0.37098757E-03_JPRB, 0.37098781E-03_JPRB, 0.37098804E-03_JPRB, 0.37098827E-03_JPRB, 0.37098856E-03_JPRB, 0.37098883E-03_JPRB, &
  & 0.37098912E-03_JPRB, 0.37098929E-03_JPRB, 0.37098950E-03_JPRB, 0.37098952E-03_JPRB, 0.37098932E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37099043E-03_JPRB, 0.37099115E-03_JPRB, 0.37099243E-03_JPRB, 0.37099372E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099764E-03_JPRB, 0.37099843E-03_JPRB, 0.37099907E-03_JPRB, 0.37099945E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099933E-03_JPRB, 0.37099904E-03_JPRB, 0.37099843E-03_JPRB, 0.37099770E-03_JPRB, 0.37099703E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099537E-03_JPRB, 0.37099441E-03_JPRB, 0.37099377E-03_JPRB, 0.37099345E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099340E-03_JPRB, 0.37099360E-03_JPRB, 0.37099401E-03_JPRB, 0.37099415E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099395E-03_JPRB, 0.37099380E-03_JPRB, 0.37099351E-03_JPRB, 0.37099319E-03_JPRB, 0.37099290E-03_JPRB, 0.37099276E-03_JPRB, &
  & 0.37099264E-03_JPRB, 0.37099220E-03_JPRB, 0.37099188E-03_JPRB, 0.37099171E-03_JPRB, 0.37099150E-03_JPRB, 0.37099130E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099083E-03_JPRB, 0.37099057E-03_JPRB, 0.37098999E-03_JPRB /)

RGHG1(:,67, 4) = (/ &
  & 0.37098653E-03_JPRB, 0.37098723E-03_JPRB, 0.37098757E-03_JPRB, 0.37098789E-03_JPRB, 0.37098810E-03_JPRB, 0.37098833E-03_JPRB, &
  & 0.37098859E-03_JPRB, 0.37098883E-03_JPRB, 0.37098906E-03_JPRB, 0.37098944E-03_JPRB, 0.37098973E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099046E-03_JPRB, 0.37099069E-03_JPRB, 0.37099069E-03_JPRB, 0.37099048E-03_JPRB, 0.37099063E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099153E-03_JPRB, 0.37099226E-03_JPRB, 0.37099331E-03_JPRB, 0.37099453E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099805E-03_JPRB, 0.37099884E-03_JPRB, 0.37099933E-03_JPRB, 0.37099962E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099959E-03_JPRB, 0.37099927E-03_JPRB, 0.37099878E-03_JPRB, 0.37099814E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099590E-03_JPRB, 0.37099505E-03_JPRB, 0.37099444E-03_JPRB, 0.37099421E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099395E-03_JPRB, 0.37099415E-03_JPRB, 0.37099438E-03_JPRB, 0.37099468E-03_JPRB, 0.37099485E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099462E-03_JPRB, 0.37099436E-03_JPRB, 0.37099401E-03_JPRB, 0.37099374E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099340E-03_JPRB, 0.37099299E-03_JPRB, 0.37099273E-03_JPRB, 0.37099246E-03_JPRB, 0.37099229E-03_JPRB, 0.37099197E-03_JPRB, &
  & 0.37099179E-03_JPRB, 0.37099147E-03_JPRB, 0.37099110E-03_JPRB, 0.37099043E-03_JPRB /)

RGHG1(:,68, 4) = (/ &
  & 0.37098728E-03_JPRB, 0.37098813E-03_JPRB, 0.37098856E-03_JPRB, 0.37098891E-03_JPRB, 0.37098909E-03_JPRB, 0.37098932E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098982E-03_JPRB, 0.37099008E-03_JPRB, 0.37099060E-03_JPRB, 0.37099098E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099147E-03_JPRB, 0.37099156E-03_JPRB, 0.37099177E-03_JPRB, 0.37099177E-03_JPRB, 0.37099171E-03_JPRB, 0.37099185E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099258E-03_JPRB, 0.37099334E-03_JPRB, 0.37099433E-03_JPRB, 0.37099532E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099860E-03_JPRB, 0.37099922E-03_JPRB, 0.37099957E-03_JPRB, 0.37099977E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37099977E-03_JPRB, 0.37099959E-03_JPRB, 0.37099895E-03_JPRB, 0.37099846E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099651E-03_JPRB, 0.37099578E-03_JPRB, 0.37099520E-03_JPRB, 0.37099497E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099488E-03_JPRB, 0.37099511E-03_JPRB, 0.37099540E-03_JPRB, 0.37099564E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099552E-03_JPRB, 0.37099520E-03_JPRB, 0.37099488E-03_JPRB, 0.37099459E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099377E-03_JPRB, 0.37099351E-03_JPRB, 0.37099331E-03_JPRB, 0.37099310E-03_JPRB, 0.37099276E-03_JPRB, &
  & 0.37099252E-03_JPRB, 0.37099211E-03_JPRB, 0.37099174E-03_JPRB, 0.37099107E-03_JPRB /)

RGHG1(:,69, 4) = (/ &
  & 0.37098804E-03_JPRB, 0.37098909E-03_JPRB, 0.37098961E-03_JPRB, 0.37098996E-03_JPRB, 0.37099008E-03_JPRB, 0.37099043E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099086E-03_JPRB, 0.37099104E-03_JPRB, 0.37099165E-03_JPRB, 0.37099217E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099261E-03_JPRB, 0.37099270E-03_JPRB, 0.37099281E-03_JPRB, 0.37099284E-03_JPRB, 0.37099287E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099360E-03_JPRB, 0.37099436E-03_JPRB, 0.37099526E-03_JPRB, 0.37099619E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099901E-03_JPRB, 0.37099948E-03_JPRB, 0.37099980E-03_JPRB, 0.37099994E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100000E-03_JPRB, 0.37099980E-03_JPRB, 0.37099919E-03_JPRB, 0.37099872E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099706E-03_JPRB, 0.37099651E-03_JPRB, 0.37099590E-03_JPRB, 0.37099572E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099546E-03_JPRB, 0.37099555E-03_JPRB, 0.37099584E-03_JPRB, 0.37099604E-03_JPRB, 0.37099631E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099636E-03_JPRB, 0.37099607E-03_JPRB, 0.37099569E-03_JPRB, 0.37099540E-03_JPRB, 0.37099535E-03_JPRB, &
  & 0.37099514E-03_JPRB, 0.37099462E-03_JPRB, 0.37099433E-03_JPRB, 0.37099412E-03_JPRB, 0.37099386E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099281E-03_JPRB, 0.37099243E-03_JPRB, 0.37099174E-03_JPRB /)

RGHG1(:,70, 4) = (/ &
  & 0.37098886E-03_JPRB, 0.37098993E-03_JPRB, 0.37099060E-03_JPRB, 0.37099089E-03_JPRB, 0.37099113E-03_JPRB, 0.37099156E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099200E-03_JPRB, 0.37099217E-03_JPRB, 0.37099287E-03_JPRB, 0.37099334E-03_JPRB, 0.37099342E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099377E-03_JPRB, 0.37099389E-03_JPRB, 0.37099383E-03_JPRB, 0.37099386E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099462E-03_JPRB, 0.37099529E-03_JPRB, 0.37099616E-03_JPRB, 0.37099689E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099933E-03_JPRB, 0.37099977E-03_JPRB, 0.37100006E-03_JPRB, 0.37100023E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37100015E-03_JPRB, 0.37099997E-03_JPRB, 0.37099945E-03_JPRB, 0.37099907E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099762E-03_JPRB, 0.37099712E-03_JPRB, 0.37099657E-03_JPRB, 0.37099648E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099619E-03_JPRB, 0.37099639E-03_JPRB, 0.37099677E-03_JPRB, 0.37099695E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099706E-03_JPRB, 0.37099686E-03_JPRB, 0.37099654E-03_JPRB, 0.37099613E-03_JPRB, 0.37099616E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099543E-03_JPRB, 0.37099526E-03_JPRB, 0.37099505E-03_JPRB, 0.37099479E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099354E-03_JPRB, 0.37099310E-03_JPRB, 0.37099246E-03_JPRB /)

RGHG1(:,71, 4) = (/ &
  & 0.37098964E-03_JPRB, 0.37099095E-03_JPRB, 0.37099171E-03_JPRB, 0.37099191E-03_JPRB, 0.37099211E-03_JPRB, 0.37099261E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099310E-03_JPRB, 0.37099313E-03_JPRB, 0.37099398E-03_JPRB, 0.37099438E-03_JPRB, 0.37099453E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099482E-03_JPRB, 0.37099494E-03_JPRB, 0.37099485E-03_JPRB, 0.37099485E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099540E-03_JPRB, 0.37099572E-03_JPRB, 0.37099625E-03_JPRB, 0.37099703E-03_JPRB, 0.37099756E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099962E-03_JPRB, 0.37099991E-03_JPRB, 0.37100018E-03_JPRB, 0.37100035E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100041E-03_JPRB, 0.37100029E-03_JPRB, 0.37099977E-03_JPRB, 0.37099945E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099823E-03_JPRB, 0.37099770E-03_JPRB, 0.37099727E-03_JPRB, 0.37099715E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099683E-03_JPRB, 0.37099709E-03_JPRB, 0.37099744E-03_JPRB, 0.37099759E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099782E-03_JPRB, 0.37099762E-03_JPRB, 0.37099727E-03_JPRB, 0.37099686E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099619E-03_JPRB, 0.37099604E-03_JPRB, 0.37099593E-03_JPRB, 0.37099578E-03_JPRB, 0.37099535E-03_JPRB, &
  & 0.37099500E-03_JPRB, 0.37099427E-03_JPRB, 0.37099389E-03_JPRB, 0.37099331E-03_JPRB /)

RGHG1(:,72, 4) = (/ &
  & 0.37099046E-03_JPRB, 0.37099203E-03_JPRB, 0.37099293E-03_JPRB, 0.37099296E-03_JPRB, 0.37099325E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37099430E-03_JPRB, 0.37099427E-03_JPRB, 0.37099523E-03_JPRB, 0.37099549E-03_JPRB, 0.37099564E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099584E-03_JPRB, 0.37099590E-03_JPRB, 0.37099581E-03_JPRB, 0.37099584E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099660E-03_JPRB, 0.37099706E-03_JPRB, 0.37099791E-03_JPRB, 0.37099826E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099994E-03_JPRB, 0.37100006E-03_JPRB, 0.37100038E-03_JPRB, 0.37100061E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100058E-03_JPRB, 0.37100058E-03_JPRB, 0.37100006E-03_JPRB, 0.37099977E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099875E-03_JPRB, 0.37099826E-03_JPRB, 0.37099799E-03_JPRB, 0.37099776E-03_JPRB, 0.37099750E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099747E-03_JPRB, 0.37099767E-03_JPRB, 0.37099808E-03_JPRB, 0.37099811E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099858E-03_JPRB, 0.37099826E-03_JPRB, 0.37099802E-03_JPRB, 0.37099767E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099706E-03_JPRB, 0.37099698E-03_JPRB, 0.37099680E-03_JPRB, 0.37099677E-03_JPRB, 0.37099633E-03_JPRB, &
  & 0.37099584E-03_JPRB, 0.37099503E-03_JPRB, 0.37099465E-03_JPRB, 0.37099406E-03_JPRB /)

RGHG1(:,73, 4) = (/ &
  & 0.37099153E-03_JPRB, 0.37099328E-03_JPRB, 0.37099424E-03_JPRB, 0.37099398E-03_JPRB, 0.37099433E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099500E-03_JPRB, 0.37099549E-03_JPRB, 0.37099520E-03_JPRB, 0.37099633E-03_JPRB, 0.37099663E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099686E-03_JPRB, 0.37099689E-03_JPRB, 0.37099671E-03_JPRB, 0.37099674E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099744E-03_JPRB, 0.37099794E-03_JPRB, 0.37099881E-03_JPRB, 0.37099893E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100018E-03_JPRB, 0.37100021E-03_JPRB, 0.37100050E-03_JPRB, 0.37100067E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100067E-03_JPRB, 0.37100093E-03_JPRB, 0.37100035E-03_JPRB, 0.37100009E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099927E-03_JPRB, 0.37099893E-03_JPRB, 0.37099863E-03_JPRB, 0.37099846E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099820E-03_JPRB, 0.37099823E-03_JPRB, 0.37099863E-03_JPRB, 0.37099860E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099925E-03_JPRB, 0.37099898E-03_JPRB, 0.37099878E-03_JPRB, 0.37099834E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099794E-03_JPRB, 0.37099776E-03_JPRB, 0.37099767E-03_JPRB, 0.37099770E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099567E-03_JPRB, 0.37099540E-03_JPRB, 0.37099476E-03_JPRB /)

RGHG1(:,74, 4) = (/ &
  & 0.37099252E-03_JPRB, 0.37099456E-03_JPRB, 0.37099549E-03_JPRB, 0.37099491E-03_JPRB, 0.37099532E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099677E-03_JPRB, 0.37099610E-03_JPRB, 0.37099747E-03_JPRB, 0.37099776E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099773E-03_JPRB, 0.37099767E-03_JPRB, 0.37099747E-03_JPRB, 0.37099759E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099820E-03_JPRB, 0.37099869E-03_JPRB, 0.37099962E-03_JPRB, 0.37099936E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100050E-03_JPRB, 0.37100023E-03_JPRB, 0.37100073E-03_JPRB, 0.37100090E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100076E-03_JPRB, 0.37100131E-03_JPRB, 0.37100076E-03_JPRB, 0.37100041E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099983E-03_JPRB, 0.37099936E-03_JPRB, 0.37099930E-03_JPRB, 0.37099898E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099887E-03_JPRB, 0.37099869E-03_JPRB, 0.37099919E-03_JPRB, 0.37099916E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099991E-03_JPRB, 0.37099957E-03_JPRB, 0.37099951E-03_JPRB, 0.37099907E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099872E-03_JPRB, 0.37099843E-03_JPRB, 0.37099846E-03_JPRB, 0.37099881E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099625E-03_JPRB, 0.37099599E-03_JPRB, 0.37099552E-03_JPRB /)

RGHG1(:,75, 4) = (/ &
  & 0.37099345E-03_JPRB, 0.37099578E-03_JPRB, 0.37099683E-03_JPRB, 0.37099590E-03_JPRB, 0.37099636E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099802E-03_JPRB, 0.37099709E-03_JPRB, 0.37099855E-03_JPRB, 0.37099875E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099863E-03_JPRB, 0.37099837E-03_JPRB, 0.37099820E-03_JPRB, 0.37099828E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099890E-03_JPRB, 0.37099936E-03_JPRB, 0.37100050E-03_JPRB, 0.37099989E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100073E-03_JPRB, 0.37100021E-03_JPRB, 0.37100093E-03_JPRB, 0.37100117E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100082E-03_JPRB, 0.37100175E-03_JPRB, 0.37100108E-03_JPRB, 0.37100073E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100021E-03_JPRB, 0.37099980E-03_JPRB, 0.37099991E-03_JPRB, 0.37099965E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099945E-03_JPRB, 0.37099916E-03_JPRB, 0.37099971E-03_JPRB, 0.37099951E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100053E-03_JPRB, 0.37100018E-03_JPRB, 0.37100029E-03_JPRB, 0.37099986E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099957E-03_JPRB, 0.37099910E-03_JPRB, 0.37099925E-03_JPRB, 0.37099983E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099671E-03_JPRB, 0.37099648E-03_JPRB, 0.37099610E-03_JPRB /)

RGHG1(:,76, 4) = (/ &
  & 0.37099438E-03_JPRB, 0.37099706E-03_JPRB, 0.37099817E-03_JPRB, 0.37099668E-03_JPRB, 0.37099741E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099933E-03_JPRB, 0.37099779E-03_JPRB, 0.37099957E-03_JPRB, 0.37099959E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099945E-03_JPRB, 0.37099895E-03_JPRB, 0.37099884E-03_JPRB, 0.37099887E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099933E-03_JPRB, 0.37099994E-03_JPRB, 0.37100140E-03_JPRB, 0.37100044E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100108E-03_JPRB, 0.37100021E-03_JPRB, 0.37100117E-03_JPRB, 0.37100143E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100090E-03_JPRB, 0.37100233E-03_JPRB, 0.37100137E-03_JPRB, 0.37100102E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100061E-03_JPRB, 0.37100009E-03_JPRB, 0.37100050E-03_JPRB, 0.37100021E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100032E-03_JPRB, 0.37099971E-03_JPRB, 0.37100015E-03_JPRB, 0.37099986E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100134E-03_JPRB, 0.37100070E-03_JPRB, 0.37100114E-03_JPRB, 0.37100055E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100029E-03_JPRB, 0.37099959E-03_JPRB, 0.37099989E-03_JPRB, 0.37100099E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099698E-03_JPRB, 0.37099677E-03_JPRB, 0.37099654E-03_JPRB /)

RGHG1(:,77, 4) = (/ &
  & 0.37099520E-03_JPRB, 0.37099811E-03_JPRB, 0.37099939E-03_JPRB, 0.37099730E-03_JPRB, 0.37099823E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100067E-03_JPRB, 0.37099843E-03_JPRB, 0.37100050E-03_JPRB, 0.37100038E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100018E-03_JPRB, 0.37099945E-03_JPRB, 0.37099933E-03_JPRB, 0.37099930E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099986E-03_JPRB, 0.37100038E-03_JPRB, 0.37100242E-03_JPRB, 0.37100090E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37100137E-03_JPRB, 0.37100006E-03_JPRB, 0.37100152E-03_JPRB, 0.37100186E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100088E-03_JPRB, 0.37100288E-03_JPRB, 0.37100172E-03_JPRB, 0.37100125E-03_JPRB, 0.37100186E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100090E-03_JPRB, 0.37100041E-03_JPRB, 0.37100117E-03_JPRB, 0.37100079E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100090E-03_JPRB, 0.37100003E-03_JPRB, 0.37100067E-03_JPRB, 0.37100009E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100207E-03_JPRB, 0.37100108E-03_JPRB, 0.37100189E-03_JPRB, 0.37100128E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100102E-03_JPRB, 0.37099994E-03_JPRB, 0.37100050E-03_JPRB, 0.37100207E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37099712E-03_JPRB, 0.37099692E-03_JPRB, 0.37099700E-03_JPRB /)

RGHG1(:,78, 4) = (/ &
  & 0.37099590E-03_JPRB, 0.37099919E-03_JPRB, 0.37100058E-03_JPRB, 0.37099767E-03_JPRB, 0.37099898E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100184E-03_JPRB, 0.37099875E-03_JPRB, 0.37100114E-03_JPRB, 0.37100099E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100093E-03_JPRB, 0.37099971E-03_JPRB, 0.37099980E-03_JPRB, 0.37099971E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37100006E-03_JPRB, 0.37100064E-03_JPRB, 0.37100329E-03_JPRB, 0.37100134E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100169E-03_JPRB, 0.37099991E-03_JPRB, 0.37100181E-03_JPRB, 0.37100224E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100096E-03_JPRB, 0.37100349E-03_JPRB, 0.37100204E-03_JPRB, 0.37100146E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100175E-03_JPRB, 0.37100114E-03_JPRB, 0.37100061E-03_JPRB, 0.37100166E-03_JPRB, 0.37100131E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100166E-03_JPRB, 0.37100038E-03_JPRB, 0.37100117E-03_JPRB, 0.37100023E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100285E-03_JPRB, 0.37100137E-03_JPRB, 0.37100259E-03_JPRB, 0.37100204E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100160E-03_JPRB, 0.37100029E-03_JPRB, 0.37100102E-03_JPRB, 0.37100317E-03_JPRB, 0.37100262E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37099703E-03_JPRB, 0.37099706E-03_JPRB, 0.37099738E-03_JPRB /)

RGHG1(:,79, 4) = (/ &
  & 0.37099607E-03_JPRB, 0.37099974E-03_JPRB, 0.37100154E-03_JPRB, 0.37099779E-03_JPRB, 0.37099933E-03_JPRB, 0.37100204E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100262E-03_JPRB, 0.37099907E-03_JPRB, 0.37100178E-03_JPRB, 0.37100146E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100152E-03_JPRB, 0.37099983E-03_JPRB, 0.37100009E-03_JPRB, 0.37099994E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100023E-03_JPRB, 0.37100090E-03_JPRB, 0.37100422E-03_JPRB, 0.37100169E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100128E-03_JPRB, 0.37100201E-03_JPRB, 0.37099989E-03_JPRB, 0.37100221E-03_JPRB, 0.37100271E-03_JPRB, 0.37100204E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100096E-03_JPRB, 0.37100416E-03_JPRB, 0.37100248E-03_JPRB, 0.37100175E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37100216E-03_JPRB, 0.37100137E-03_JPRB, 0.37100079E-03_JPRB, 0.37100207E-03_JPRB, 0.37100163E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100221E-03_JPRB, 0.37100055E-03_JPRB, 0.37100152E-03_JPRB, 0.37100038E-03_JPRB, 0.37100198E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37100358E-03_JPRB, 0.37100166E-03_JPRB, 0.37100329E-03_JPRB, 0.37100271E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100361E-03_JPRB, 0.37100210E-03_JPRB, 0.37100041E-03_JPRB, 0.37100137E-03_JPRB, 0.37100413E-03_JPRB, 0.37100352E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37099668E-03_JPRB, 0.37099686E-03_JPRB, 0.37099750E-03_JPRB /)

RGHG1(:,80, 4) = (/ &
  & 0.37099593E-03_JPRB, 0.37100015E-03_JPRB, 0.37100210E-03_JPRB, 0.37099773E-03_JPRB, 0.37099948E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100335E-03_JPRB, 0.37099919E-03_JPRB, 0.37100195E-03_JPRB, 0.37100172E-03_JPRB, 0.37100184E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100186E-03_JPRB, 0.37099986E-03_JPRB, 0.37100021E-03_JPRB, 0.37100000E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100032E-03_JPRB, 0.37100108E-03_JPRB, 0.37100492E-03_JPRB, 0.37100198E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100224E-03_JPRB, 0.37099989E-03_JPRB, 0.37100248E-03_JPRB, 0.37100306E-03_JPRB, 0.37100233E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100114E-03_JPRB, 0.37100475E-03_JPRB, 0.37100282E-03_JPRB, 0.37100201E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100163E-03_JPRB, 0.37100093E-03_JPRB, 0.37100242E-03_JPRB, 0.37100195E-03_JPRB, 0.37100184E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100268E-03_JPRB, 0.37100073E-03_JPRB, 0.37100181E-03_JPRB, 0.37100047E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100408E-03_JPRB, 0.37100192E-03_JPRB, 0.37100384E-03_JPRB, 0.37100315E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100425E-03_JPRB, 0.37100248E-03_JPRB, 0.37100050E-03_JPRB, 0.37100163E-03_JPRB, 0.37100486E-03_JPRB, 0.37100416E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37099633E-03_JPRB, 0.37099660E-03_JPRB, 0.37099727E-03_JPRB /)

RGHG1(:,81, 4) = (/ &
  & 0.37099540E-03_JPRB, 0.37100035E-03_JPRB, 0.37100236E-03_JPRB, 0.37099773E-03_JPRB, 0.37099957E-03_JPRB, 0.37100291E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100329E-03_JPRB, 0.37099927E-03_JPRB, 0.37100248E-03_JPRB, 0.37100207E-03_JPRB, 0.37100210E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37100207E-03_JPRB, 0.37099986E-03_JPRB, 0.37100023E-03_JPRB, 0.37100003E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37100032E-03_JPRB, 0.37100117E-03_JPRB, 0.37100536E-03_JPRB, 0.37100216E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100163E-03_JPRB, 0.37100242E-03_JPRB, 0.37099980E-03_JPRB, 0.37100265E-03_JPRB, 0.37100335E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37100125E-03_JPRB, 0.37100515E-03_JPRB, 0.37100309E-03_JPRB, 0.37100218E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100178E-03_JPRB, 0.37100111E-03_JPRB, 0.37100256E-03_JPRB, 0.37100210E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100291E-03_JPRB, 0.37100076E-03_JPRB, 0.37100201E-03_JPRB, 0.37100055E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37100443E-03_JPRB, 0.37100201E-03_JPRB, 0.37100416E-03_JPRB, 0.37100344E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100460E-03_JPRB, 0.37100268E-03_JPRB, 0.37100055E-03_JPRB, 0.37100184E-03_JPRB, 0.37100530E-03_JPRB, 0.37100451E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37099610E-03_JPRB, 0.37099636E-03_JPRB, 0.37099689E-03_JPRB /)

RGHG1(:,82, 4) = (/ &
  & 0.37099540E-03_JPRB, 0.37100041E-03_JPRB, 0.37100253E-03_JPRB, 0.37099764E-03_JPRB, 0.37099962E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37100303E-03_JPRB, 0.37100431E-03_JPRB, 0.37099930E-03_JPRB, 0.37100207E-03_JPRB, 0.37100201E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100218E-03_JPRB, 0.37099991E-03_JPRB, 0.37100029E-03_JPRB, 0.37100012E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100026E-03_JPRB, 0.37100122E-03_JPRB, 0.37100571E-03_JPRB, 0.37100221E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37100250E-03_JPRB, 0.37099983E-03_JPRB, 0.37100274E-03_JPRB, 0.37100347E-03_JPRB, 0.37100268E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100131E-03_JPRB, 0.37100539E-03_JPRB, 0.37100329E-03_JPRB, 0.37100239E-03_JPRB, 0.37100364E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100189E-03_JPRB, 0.37100120E-03_JPRB, 0.37100265E-03_JPRB, 0.37100224E-03_JPRB, 0.37100224E-03_JPRB, &
  & 0.37100216E-03_JPRB, 0.37100315E-03_JPRB, 0.37100088E-03_JPRB, 0.37100213E-03_JPRB, 0.37100055E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37100475E-03_JPRB, 0.37100213E-03_JPRB, 0.37100437E-03_JPRB, 0.37100355E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100288E-03_JPRB, 0.37100061E-03_JPRB, 0.37100189E-03_JPRB, 0.37100556E-03_JPRB, 0.37100477E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37099596E-03_JPRB, 0.37099622E-03_JPRB, 0.37099680E-03_JPRB /)

RGHG1(:,83, 4) = (/ &
  & 0.37099526E-03_JPRB, 0.37100050E-03_JPRB, 0.37100265E-03_JPRB, 0.37099770E-03_JPRB, 0.37099954E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100326E-03_JPRB, 0.37099965E-03_JPRB, 0.37100288E-03_JPRB, 0.37100242E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100227E-03_JPRB, 0.37099994E-03_JPRB, 0.37100029E-03_JPRB, 0.37100012E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37100032E-03_JPRB, 0.37100125E-03_JPRB, 0.37100611E-03_JPRB, 0.37100236E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100262E-03_JPRB, 0.37099983E-03_JPRB, 0.37100285E-03_JPRB, 0.37100367E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37100134E-03_JPRB, 0.37100550E-03_JPRB, 0.37100332E-03_JPRB, 0.37100248E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100297E-03_JPRB, 0.37100204E-03_JPRB, 0.37100146E-03_JPRB, 0.37100277E-03_JPRB, 0.37100236E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100326E-03_JPRB, 0.37100096E-03_JPRB, 0.37100224E-03_JPRB, 0.37100055E-03_JPRB, 0.37100285E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37100501E-03_JPRB, 0.37100224E-03_JPRB, 0.37100454E-03_JPRB, 0.37100376E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100507E-03_JPRB, 0.37100297E-03_JPRB, 0.37100055E-03_JPRB, 0.37100195E-03_JPRB, 0.37100576E-03_JPRB, 0.37100498E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37099578E-03_JPRB, 0.37099610E-03_JPRB, 0.37099677E-03_JPRB /)

RGHG1(:,84, 4) = (/ &
  & 0.37099520E-03_JPRB, 0.37100047E-03_JPRB, 0.37100268E-03_JPRB, 0.37099776E-03_JPRB, 0.37099974E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100335E-03_JPRB, 0.37100445E-03_JPRB, 0.37099983E-03_JPRB, 0.37100201E-03_JPRB, 0.37100218E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100224E-03_JPRB, 0.37100003E-03_JPRB, 0.37100026E-03_JPRB, 0.37100015E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100026E-03_JPRB, 0.37100122E-03_JPRB, 0.37100646E-03_JPRB, 0.37100236E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100274E-03_JPRB, 0.37099968E-03_JPRB, 0.37100297E-03_JPRB, 0.37100373E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100140E-03_JPRB, 0.37100562E-03_JPRB, 0.37100352E-03_JPRB, 0.37100265E-03_JPRB, 0.37100384E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100210E-03_JPRB, 0.37100154E-03_JPRB, 0.37100271E-03_JPRB, 0.37100242E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100335E-03_JPRB, 0.37100102E-03_JPRB, 0.37100227E-03_JPRB, 0.37100050E-03_JPRB, 0.37100291E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100521E-03_JPRB, 0.37100230E-03_JPRB, 0.37100469E-03_JPRB, 0.37100384E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100524E-03_JPRB, 0.37100303E-03_JPRB, 0.37100055E-03_JPRB, 0.37100201E-03_JPRB, 0.37100591E-03_JPRB, 0.37100512E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37099572E-03_JPRB, 0.37099601E-03_JPRB, 0.37099671E-03_JPRB /)

RGHG1(:,85, 4) = (/ &
  & 0.37099508E-03_JPRB, 0.37100053E-03_JPRB, 0.37100282E-03_JPRB, 0.37099770E-03_JPRB, 0.37099959E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100291E-03_JPRB, 0.37100312E-03_JPRB, 0.37100041E-03_JPRB, 0.37100271E-03_JPRB, 0.37100253E-03_JPRB, 0.37100250E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100210E-03_JPRB, 0.37100026E-03_JPRB, 0.37100026E-03_JPRB, 0.37100021E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100023E-03_JPRB, 0.37100125E-03_JPRB, 0.37100672E-03_JPRB, 0.37100245E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100288E-03_JPRB, 0.37099951E-03_JPRB, 0.37100306E-03_JPRB, 0.37100393E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100149E-03_JPRB, 0.37100574E-03_JPRB, 0.37100358E-03_JPRB, 0.37100271E-03_JPRB, 0.37100393E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100224E-03_JPRB, 0.37100166E-03_JPRB, 0.37100268E-03_JPRB, 0.37100248E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100329E-03_JPRB, 0.37100114E-03_JPRB, 0.37100236E-03_JPRB, 0.37100050E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37100550E-03_JPRB, 0.37100239E-03_JPRB, 0.37100480E-03_JPRB, 0.37100399E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100539E-03_JPRB, 0.37100315E-03_JPRB, 0.37100055E-03_JPRB, 0.37100207E-03_JPRB, 0.37100611E-03_JPRB, 0.37100533E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37099561E-03_JPRB, 0.37099593E-03_JPRB, 0.37099660E-03_JPRB /)

RGHG1(:,86, 4) = (/ &
  & 0.37099497E-03_JPRB, 0.37100047E-03_JPRB, 0.37100280E-03_JPRB, 0.37099764E-03_JPRB, 0.37099991E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100317E-03_JPRB, 0.37100367E-03_JPRB, 0.37100073E-03_JPRB, 0.37100213E-03_JPRB, 0.37100230E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100201E-03_JPRB, 0.37100055E-03_JPRB, 0.37100032E-03_JPRB, 0.37100032E-03_JPRB, 0.37100320E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100026E-03_JPRB, 0.37100125E-03_JPRB, 0.37100696E-03_JPRB, 0.37100242E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100300E-03_JPRB, 0.37099945E-03_JPRB, 0.37100317E-03_JPRB, 0.37100402E-03_JPRB, 0.37100303E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100149E-03_JPRB, 0.37100579E-03_JPRB, 0.37100373E-03_JPRB, 0.37100282E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100312E-03_JPRB, 0.37100221E-03_JPRB, 0.37100166E-03_JPRB, 0.37100271E-03_JPRB, 0.37100253E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100335E-03_JPRB, 0.37100114E-03_JPRB, 0.37100248E-03_JPRB, 0.37100053E-03_JPRB, 0.37100306E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37100568E-03_JPRB, 0.37100248E-03_JPRB, 0.37100498E-03_JPRB, 0.37100413E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100544E-03_JPRB, 0.37100326E-03_JPRB, 0.37100050E-03_JPRB, 0.37100207E-03_JPRB, 0.37100629E-03_JPRB, 0.37100553E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37099558E-03_JPRB, 0.37099575E-03_JPRB, 0.37099648E-03_JPRB /)

RGHG1(:,87, 4) = (/ &
  & 0.37099488E-03_JPRB, 0.37100044E-03_JPRB, 0.37100282E-03_JPRB, 0.37099764E-03_JPRB, 0.37099959E-03_JPRB, 0.37100349E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100309E-03_JPRB, 0.37100120E-03_JPRB, 0.37100253E-03_JPRB, 0.37100248E-03_JPRB, 0.37100248E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100184E-03_JPRB, 0.37100067E-03_JPRB, 0.37100038E-03_JPRB, 0.37100047E-03_JPRB, 0.37100309E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100026E-03_JPRB, 0.37100117E-03_JPRB, 0.37100710E-03_JPRB, 0.37100245E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37100312E-03_JPRB, 0.37099933E-03_JPRB, 0.37100326E-03_JPRB, 0.37100411E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100152E-03_JPRB, 0.37100585E-03_JPRB, 0.37100376E-03_JPRB, 0.37100282E-03_JPRB, 0.37100419E-03_JPRB, &
  & 0.37100326E-03_JPRB, 0.37100224E-03_JPRB, 0.37100160E-03_JPRB, 0.37100277E-03_JPRB, 0.37100253E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100349E-03_JPRB, 0.37100117E-03_JPRB, 0.37100253E-03_JPRB, 0.37100050E-03_JPRB, 0.37100309E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37100582E-03_JPRB, 0.37100248E-03_JPRB, 0.37100507E-03_JPRB, 0.37100422E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100559E-03_JPRB, 0.37100326E-03_JPRB, 0.37100050E-03_JPRB, 0.37100213E-03_JPRB, 0.37100632E-03_JPRB, 0.37100562E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37099546E-03_JPRB, 0.37099561E-03_JPRB, 0.37099636E-03_JPRB /)

RGHG1(:,88, 4) = (/ &
  & 0.37099511E-03_JPRB, 0.37100038E-03_JPRB, 0.37100259E-03_JPRB, 0.37099770E-03_JPRB, 0.37100009E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100312E-03_JPRB, 0.37100335E-03_JPRB, 0.37100114E-03_JPRB, 0.37100218E-03_JPRB, 0.37100224E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37100192E-03_JPRB, 0.37100085E-03_JPRB, 0.37100053E-03_JPRB, 0.37100061E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100032E-03_JPRB, 0.37100114E-03_JPRB, 0.37100725E-03_JPRB, 0.37100248E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100320E-03_JPRB, 0.37099916E-03_JPRB, 0.37100335E-03_JPRB, 0.37100422E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100154E-03_JPRB, 0.37100603E-03_JPRB, 0.37100384E-03_JPRB, 0.37100277E-03_JPRB, 0.37100440E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100216E-03_JPRB, 0.37100131E-03_JPRB, 0.37100291E-03_JPRB, 0.37100253E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100373E-03_JPRB, 0.37100096E-03_JPRB, 0.37100262E-03_JPRB, 0.37100044E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37100606E-03_JPRB, 0.37100248E-03_JPRB, 0.37100527E-03_JPRB, 0.37100431E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100562E-03_JPRB, 0.37100323E-03_JPRB, 0.37100044E-03_JPRB, 0.37100210E-03_JPRB, 0.37100649E-03_JPRB, 0.37100579E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37099543E-03_JPRB, 0.37099552E-03_JPRB, 0.37099631E-03_JPRB /)

RGHG1(:,89, 4) = (/ &
  & 0.37099549E-03_JPRB, 0.37100041E-03_JPRB, 0.37100233E-03_JPRB, 0.37099776E-03_JPRB, 0.37099965E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100317E-03_JPRB, 0.37100102E-03_JPRB, 0.37100230E-03_JPRB, 0.37100224E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100178E-03_JPRB, 0.37100067E-03_JPRB, 0.37100038E-03_JPRB, 0.37100047E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100032E-03_JPRB, 0.37100114E-03_JPRB, 0.37100739E-03_JPRB, 0.37100248E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100335E-03_JPRB, 0.37099910E-03_JPRB, 0.37100335E-03_JPRB, 0.37100431E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100152E-03_JPRB, 0.37100614E-03_JPRB, 0.37100384E-03_JPRB, 0.37100277E-03_JPRB, 0.37100457E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100221E-03_JPRB, 0.37100114E-03_JPRB, 0.37100315E-03_JPRB, 0.37100256E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100405E-03_JPRB, 0.37100096E-03_JPRB, 0.37100274E-03_JPRB, 0.37100044E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100626E-03_JPRB, 0.37100250E-03_JPRB, 0.37100539E-03_JPRB, 0.37100437E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100574E-03_JPRB, 0.37100326E-03_JPRB, 0.37100035E-03_JPRB, 0.37100216E-03_JPRB, 0.37100655E-03_JPRB, 0.37100585E-03_JPRB, &
  & 0.37100186E-03_JPRB, 0.37099537E-03_JPRB, 0.37099537E-03_JPRB, 0.37099622E-03_JPRB /)

RGHG1(:,90, 4) = (/ &
  & 0.37099581E-03_JPRB, 0.37100044E-03_JPRB, 0.37100221E-03_JPRB, 0.37099764E-03_JPRB, 0.37099980E-03_JPRB, 0.37100393E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100405E-03_JPRB, 0.37100038E-03_JPRB, 0.37100242E-03_JPRB, 0.37100245E-03_JPRB, 0.37100250E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100207E-03_JPRB, 0.37100047E-03_JPRB, 0.37100021E-03_JPRB, 0.37100026E-03_JPRB, 0.37100370E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100026E-03_JPRB, 0.37100099E-03_JPRB, 0.37100777E-03_JPRB, 0.37100239E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100355E-03_JPRB, 0.37099893E-03_JPRB, 0.37100352E-03_JPRB, 0.37100443E-03_JPRB, 0.37100355E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37100143E-03_JPRB, 0.37100652E-03_JPRB, 0.37100387E-03_JPRB, 0.37100256E-03_JPRB, 0.37100475E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100221E-03_JPRB, 0.37100088E-03_JPRB, 0.37100338E-03_JPRB, 0.37100250E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100239E-03_JPRB, 0.37100428E-03_JPRB, 0.37100079E-03_JPRB, 0.37100282E-03_JPRB, 0.37100032E-03_JPRB, 0.37100338E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37100649E-03_JPRB, 0.37100236E-03_JPRB, 0.37100562E-03_JPRB, 0.37100443E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100588E-03_JPRB, 0.37100326E-03_JPRB, 0.37100021E-03_JPRB, 0.37100210E-03_JPRB, 0.37100675E-03_JPRB, 0.37100597E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37099520E-03_JPRB, 0.37099529E-03_JPRB, 0.37099628E-03_JPRB /)

RGHG1(:,91, 4) = (/ &
  & 0.37099607E-03_JPRB, 0.37100096E-03_JPRB, 0.37100294E-03_JPRB, 0.37099660E-03_JPRB, 0.37099925E-03_JPRB, 0.37100469E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100737E-03_JPRB, 0.37099473E-03_JPRB, 0.37100501E-03_JPRB, 0.37100239E-03_JPRB, 0.37100248E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100274E-03_JPRB, 0.37099942E-03_JPRB, 0.37100006E-03_JPRB, 0.37099965E-03_JPRB, 0.37100454E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100006E-03_JPRB, 0.37100061E-03_JPRB, 0.37100865E-03_JPRB, 0.37100221E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100387E-03_JPRB, 0.37099826E-03_JPRB, 0.37100376E-03_JPRB, 0.37100466E-03_JPRB, 0.37100384E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100111E-03_JPRB, 0.37100731E-03_JPRB, 0.37100376E-03_JPRB, 0.37100227E-03_JPRB, 0.37100510E-03_JPRB, &
  & 0.37100349E-03_JPRB, 0.37100224E-03_JPRB, 0.37100058E-03_JPRB, 0.37100379E-03_JPRB, 0.37100245E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100227E-03_JPRB, 0.37100472E-03_JPRB, 0.37100038E-03_JPRB, 0.37100309E-03_JPRB, 0.37099991E-03_JPRB, 0.37100387E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37100734E-03_JPRB, 0.37100184E-03_JPRB, 0.37100585E-03_JPRB, 0.37100451E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100646E-03_JPRB, 0.37100329E-03_JPRB, 0.37099989E-03_JPRB, 0.37100198E-03_JPRB, 0.37100713E-03_JPRB, 0.37100614E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37099465E-03_JPRB, 0.37099529E-03_JPRB, 0.37099631E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG1(:, 1, 5) = (/ &
  & 0.35830584E-03_JPRB, 0.35839627E-03_JPRB, 0.35844330E-03_JPRB, 0.35851810E-03_JPRB, 0.35861981E-03_JPRB, 0.35879706E-03_JPRB, &
  & 0.35902747E-03_JPRB, 0.35928859E-03_JPRB, 0.35956365E-03_JPRB, 0.35984052E-03_JPRB, 0.36011048E-03_JPRB, 0.36036831E-03_JPRB, &
  & 0.36060929E-03_JPRB, 0.36082824E-03_JPRB, 0.36102009E-03_JPRB, 0.36118180E-03_JPRB, 0.36131340E-03_JPRB, 0.36141812E-03_JPRB, &
  & 0.36150054E-03_JPRB, 0.36156666E-03_JPRB, 0.36162187E-03_JPRB, 0.36167214E-03_JPRB, 0.36172333E-03_JPRB, 0.36178215E-03_JPRB, &
  & 0.36185447E-03_JPRB, 0.36194152E-03_JPRB, 0.36203212E-03_JPRB, 0.36211888E-03_JPRB, 0.36219982E-03_JPRB, 0.36226850E-03_JPRB, &
  & 0.36232080E-03_JPRB, 0.36235189E-03_JPRB, 0.36235488E-03_JPRB, 0.36232360E-03_JPRB, 0.36225666E-03_JPRB, 0.36215468E-03_JPRB, &
  & 0.36201932E-03_JPRB, 0.36185351E-03_JPRB, 0.36167059E-03_JPRB, 0.36150363E-03_JPRB, 0.36136090E-03_JPRB, 0.36121355E-03_JPRB, &
  & 0.36106131E-03_JPRB, 0.36088357E-03_JPRB, 0.36067684E-03_JPRB, 0.36042664E-03_JPRB, 0.36010367E-03_JPRB, 0.35966653E-03_JPRB, &
  & 0.35898888E-03_JPRB, 0.35822231E-03_JPRB, 0.35753034E-03_JPRB, 0.35691346E-03_JPRB, 0.35638828E-03_JPRB, 0.35596153E-03_JPRB, &
  & 0.35562861E-03_JPRB, 0.35537232E-03_JPRB, 0.35517110E-03_JPRB, 0.35514132E-03_JPRB, 0.35523772E-03_JPRB, 0.35538981E-03_JPRB, &
  & 0.35556682E-03_JPRB, 0.35574840E-03_JPRB, 0.35589293E-03_JPRB, 0.35595882E-03_JPRB /)

RGHG1(:, 2, 5) = (/ &
  & 0.35848713E-03_JPRB, 0.35872561E-03_JPRB, 0.35890553E-03_JPRB, 0.35911717E-03_JPRB, 0.35937291E-03_JPRB, 0.35971036E-03_JPRB, &
  & 0.36010638E-03_JPRB, 0.36052323E-03_JPRB, 0.36092364E-03_JPRB, 0.36128215E-03_JPRB, 0.36158646E-03_JPRB, 0.36183480E-03_JPRB, &
  & 0.36203887E-03_JPRB, 0.36221754E-03_JPRB, 0.36238760E-03_JPRB, 0.36255541E-03_JPRB, 0.36271798E-03_JPRB, 0.36286851E-03_JPRB, &
  & 0.36300163E-03_JPRB, 0.36311557E-03_JPRB, 0.36321196E-03_JPRB, 0.36329453E-03_JPRB, 0.36336965E-03_JPRB, 0.36344625E-03_JPRB, &
  & 0.36353263E-03_JPRB, 0.36363321E-03_JPRB, 0.36374660E-03_JPRB, 0.36387119E-03_JPRB, 0.36400362E-03_JPRB, 0.36413464E-03_JPRB, &
  & 0.36424954E-03_JPRB, 0.36433164E-03_JPRB, 0.36437524E-03_JPRB, 0.36437836E-03_JPRB, 0.36434279E-03_JPRB, 0.36427140E-03_JPRB, &
  & 0.36416654E-03_JPRB, 0.36402949E-03_JPRB, 0.36387035E-03_JPRB, 0.36370236E-03_JPRB, 0.36353775E-03_JPRB, 0.36336688E-03_JPRB, &
  & 0.36318257E-03_JPRB, 0.36297183E-03_JPRB, 0.36271731E-03_JPRB, 0.36241021E-03_JPRB, 0.36202325E-03_JPRB, 0.36153107E-03_JPRB, &
  & 0.36091940E-03_JPRB, 0.36027376E-03_JPRB, 0.35966898E-03_JPRB, 0.35913760E-03_JPRB, 0.35867517E-03_JPRB, 0.35829493E-03_JPRB, &
  & 0.35799315E-03_JPRB, 0.35777519E-03_JPRB, 0.35761792E-03_JPRB, 0.35751332E-03_JPRB, 0.35743794E-03_JPRB, 0.35737493E-03_JPRB, &
  & 0.35731361E-03_JPRB, 0.35723898E-03_JPRB, 0.35713491E-03_JPRB, 0.35693587E-03_JPRB /)

RGHG1(:, 3, 5) = (/ &
  & 0.35871574E-03_JPRB, 0.35900876E-03_JPRB, 0.35921956E-03_JPRB, 0.35943792E-03_JPRB, 0.35970478E-03_JPRB, 0.36002859E-03_JPRB, &
  & 0.36039748E-03_JPRB, 0.36077079E-03_JPRB, 0.36112269E-03_JPRB, 0.36145819E-03_JPRB, 0.36179478E-03_JPRB, 0.36214944E-03_JPRB, &
  & 0.36251731E-03_JPRB, 0.36287672E-03_JPRB, 0.36320672E-03_JPRB, 0.36350006E-03_JPRB, 0.36375850E-03_JPRB, 0.36398423E-03_JPRB, &
  & 0.36417774E-03_JPRB, 0.36434041E-03_JPRB, 0.36447542E-03_JPRB, 0.36458758E-03_JPRB, 0.36468310E-03_JPRB, 0.36476814E-03_JPRB, &
  & 0.36484931E-03_JPRB, 0.36492990E-03_JPRB, 0.36501302E-03_JPRB, 0.36509745E-03_JPRB, 0.36518055E-03_JPRB, 0.36525499E-03_JPRB, &
  & 0.36531052E-03_JPRB, 0.36533896E-03_JPRB, 0.36533698E-03_JPRB, 0.36530659E-03_JPRB, 0.36525348E-03_JPRB, 0.36518174E-03_JPRB, &
  & 0.36509265E-03_JPRB, 0.36498639E-03_JPRB, 0.36486139E-03_JPRB, 0.36472554E-03_JPRB, 0.36458290E-03_JPRB, 0.36443304E-03_JPRB, &
  & 0.36427169E-03_JPRB, 0.36409037E-03_JPRB, 0.36387934E-03_JPRB, 0.36362864E-03_JPRB, 0.36332870E-03_JPRB, 0.36296691E-03_JPRB, &
  & 0.36255372E-03_JPRB, 0.36211591E-03_JPRB, 0.36169623E-03_JPRB, 0.36130295E-03_JPRB, 0.36094477E-03_JPRB, 0.36061674E-03_JPRB, &
  & 0.36032856E-03_JPRB, 0.36007582E-03_JPRB, 0.35986424E-03_JPRB, 0.35968475E-03_JPRB, 0.35952841E-03_JPRB, 0.35938629E-03_JPRB, &
  & 0.35924604E-03_JPRB, 0.35909784E-03_JPRB, 0.35891190E-03_JPRB, 0.35856621E-03_JPRB /)

RGHG1(:, 4, 5) = (/ &
  & 0.35884918E-03_JPRB, 0.35912317E-03_JPRB, 0.35930818E-03_JPRB, 0.35951435E-03_JPRB, 0.35975632E-03_JPRB, 0.36006072E-03_JPRB, &
  & 0.36041677E-03_JPRB, 0.36081040E-03_JPRB, 0.36123319E-03_JPRB, 0.36167348E-03_JPRB, 0.36212394E-03_JPRB, 0.36256877E-03_JPRB, &
  & 0.36300247E-03_JPRB, 0.36342334E-03_JPRB, 0.36381977E-03_JPRB, 0.36417198E-03_JPRB, 0.36447155E-03_JPRB, 0.36472589E-03_JPRB, &
  & 0.36494478E-03_JPRB, 0.36513258E-03_JPRB, 0.36529047E-03_JPRB, 0.36542022E-03_JPRB, 0.36552575E-03_JPRB, 0.36561184E-03_JPRB, &
  & 0.36568183E-03_JPRB, 0.36574010E-03_JPRB, 0.36578861E-03_JPRB, 0.36582840E-03_JPRB, 0.36585776E-03_JPRB, 0.36587266E-03_JPRB, &
  & 0.36586809E-03_JPRB, 0.36584036E-03_JPRB, 0.36579015E-03_JPRB, 0.36572362E-03_JPRB, 0.36564784E-03_JPRB, 0.36556629E-03_JPRB, &
  & 0.36547717E-03_JPRB, 0.36537793E-03_JPRB, 0.36526931E-03_JPRB, 0.36514853E-03_JPRB, 0.36501657E-03_JPRB, 0.36487306E-03_JPRB, &
  & 0.36471657E-03_JPRB, 0.36454675E-03_JPRB, 0.36436258E-03_JPRB, 0.36416171E-03_JPRB, 0.36394288E-03_JPRB, 0.36370842E-03_JPRB, &
  & 0.36346205E-03_JPRB, 0.36321170E-03_JPRB, 0.36295754E-03_JPRB, 0.36270422E-03_JPRB, 0.36244607E-03_JPRB, 0.36218434E-03_JPRB, &
  & 0.36192118E-03_JPRB, 0.36167185E-03_JPRB, 0.36143957E-03_JPRB, 0.36122772E-03_JPRB, 0.36103427E-03_JPRB, 0.36085385E-03_JPRB, &
  & 0.36068278E-03_JPRB, 0.36051130E-03_JPRB, 0.36032443E-03_JPRB, 0.36001936E-03_JPRB /)

RGHG1(:, 5, 5) = (/ &
  & 0.35896717E-03_JPRB, 0.35925888E-03_JPRB, 0.35945678E-03_JPRB, 0.35965379E-03_JPRB, 0.35988967E-03_JPRB, 0.36018071E-03_JPRB, &
  & 0.36053531E-03_JPRB, 0.36094344E-03_JPRB, 0.36138494E-03_JPRB, 0.36185567E-03_JPRB, 0.36234962E-03_JPRB, 0.36286280E-03_JPRB, &
  & 0.36337294E-03_JPRB, 0.36384878E-03_JPRB, 0.36427617E-03_JPRB, 0.36465953E-03_JPRB, 0.36499745E-03_JPRB, 0.36528084E-03_JPRB, &
  & 0.36550869E-03_JPRB, 0.36569117E-03_JPRB, 0.36583975E-03_JPRB, 0.36596131E-03_JPRB, 0.36606027E-03_JPRB, 0.36613937E-03_JPRB, &
  & 0.36620061E-03_JPRB, 0.36624516E-03_JPRB, 0.36627441E-03_JPRB, 0.36628806E-03_JPRB, 0.36628501E-03_JPRB, 0.36626298E-03_JPRB, &
  & 0.36621949E-03_JPRB, 0.36615587E-03_JPRB, 0.36607686E-03_JPRB, 0.36598806E-03_JPRB, 0.36589397E-03_JPRB, 0.36579865E-03_JPRB, &
  & 0.36570476E-03_JPRB, 0.36561204E-03_JPRB, 0.36551530E-03_JPRB, 0.36541061E-03_JPRB, 0.36529501E-03_JPRB, 0.36516751E-03_JPRB, &
  & 0.36502941E-03_JPRB, 0.36488136E-03_JPRB, 0.36472600E-03_JPRB, 0.36456494E-03_JPRB, 0.36440010E-03_JPRB, 0.36423246E-03_JPRB, &
  & 0.36406174E-03_JPRB, 0.36389139E-03_JPRB, 0.36371805E-03_JPRB, 0.36353659E-03_JPRB, 0.36334753E-03_JPRB, 0.36314881E-03_JPRB, &
  & 0.36294156E-03_JPRB, 0.36272689E-03_JPRB, 0.36251266E-03_JPRB, 0.36230506E-03_JPRB, 0.36210637E-03_JPRB, 0.36192031E-03_JPRB, &
  & 0.36174478E-03_JPRB, 0.36157380E-03_JPRB, 0.36138025E-03_JPRB, 0.36104865E-03_JPRB /)

RGHG1(:, 6, 5) = (/ &
  & 0.35929185E-03_JPRB, 0.35981683E-03_JPRB, 0.36012524E-03_JPRB, 0.36038243E-03_JPRB, 0.36063691E-03_JPRB, 0.36092271E-03_JPRB, &
  & 0.36124719E-03_JPRB, 0.36161568E-03_JPRB, 0.36202464E-03_JPRB, 0.36246775E-03_JPRB, 0.36293548E-03_JPRB, 0.36340929E-03_JPRB, &
  & 0.36387239E-03_JPRB, 0.36430985E-03_JPRB, 0.36470435E-03_JPRB, 0.36504067E-03_JPRB, 0.36532324E-03_JPRB, 0.36556454E-03_JPRB, &
  & 0.36576932E-03_JPRB, 0.36593815E-03_JPRB, 0.36607654E-03_JPRB, 0.36619176E-03_JPRB, 0.36628914E-03_JPRB, 0.36637063E-03_JPRB, &
  & 0.36643620E-03_JPRB, 0.36648510E-03_JPRB, 0.36651647E-03_JPRB, 0.36652907E-03_JPRB, 0.36652124E-03_JPRB, 0.36649156E-03_JPRB, &
  & 0.36644004E-03_JPRB, 0.36636769E-03_JPRB, 0.36627759E-03_JPRB, 0.36617729E-03_JPRB, 0.36607758E-03_JPRB, 0.36598419E-03_JPRB, &
  & 0.36589531E-03_JPRB, 0.36580674E-03_JPRB, 0.36571699E-03_JPRB, 0.36562403E-03_JPRB, 0.36552615E-03_JPRB, 0.36542208E-03_JPRB, &
  & 0.36531201E-03_JPRB, 0.36519731E-03_JPRB, 0.36507970E-03_JPRB, 0.36496075E-03_JPRB, 0.36483892E-03_JPRB, 0.36471582E-03_JPRB, &
  & 0.36458747E-03_JPRB, 0.36445275E-03_JPRB, 0.36431343E-03_JPRB, 0.36416581E-03_JPRB, 0.36400824E-03_JPRB, 0.36384122E-03_JPRB, &
  & 0.36366540E-03_JPRB, 0.36348356E-03_JPRB, 0.36329677E-03_JPRB, 0.36310597E-03_JPRB, 0.36291842E-03_JPRB, 0.36273422E-03_JPRB, &
  & 0.36255823E-03_JPRB, 0.36238375E-03_JPRB, 0.36219278E-03_JPRB, 0.36187054E-03_JPRB /)

RGHG1(:, 7, 5) = (/ &
  & 0.36009282E-03_JPRB, 0.36096663E-03_JPRB, 0.36141791E-03_JPRB, 0.36176405E-03_JPRB, 0.36207549E-03_JPRB, 0.36237403E-03_JPRB, &
  & 0.36267954E-03_JPRB, 0.36298629E-03_JPRB, 0.36329651E-03_JPRB, 0.36360868E-03_JPRB, 0.36392326E-03_JPRB, 0.36423904E-03_JPRB, &
  & 0.36454742E-03_JPRB, 0.36483759E-03_JPRB, 0.36510336E-03_JPRB, 0.36534527E-03_JPRB, 0.36555805E-03_JPRB, 0.36574007E-03_JPRB, &
  & 0.36589766E-03_JPRB, 0.36603771E-03_JPRB, 0.36616100E-03_JPRB, 0.36626900E-03_JPRB, 0.36636577E-03_JPRB, 0.36645410E-03_JPRB, &
  & 0.36653120E-03_JPRB, 0.36659359E-03_JPRB, 0.36663775E-03_JPRB, 0.36666053E-03_JPRB, 0.36665983E-03_JPRB, 0.36663504E-03_JPRB, &
  & 0.36658638E-03_JPRB, 0.36651781E-03_JPRB, 0.36643576E-03_JPRB, 0.36634659E-03_JPRB, 0.36625340E-03_JPRB, 0.36615925E-03_JPRB, &
  & 0.36606772E-03_JPRB, 0.36598096E-03_JPRB, 0.36589731E-03_JPRB, 0.36581300E-03_JPRB, 0.36572528E-03_JPRB, 0.36563360E-03_JPRB, &
  & 0.36554073E-03_JPRB, 0.36544784E-03_JPRB, 0.36535517E-03_JPRB, 0.36526329E-03_JPRB, 0.36516902E-03_JPRB, 0.36507196E-03_JPRB, &
  & 0.36497074E-03_JPRB, 0.36486244E-03_JPRB, 0.36474745E-03_JPRB, 0.36462411E-03_JPRB, 0.36449186E-03_JPRB, 0.36435298E-03_JPRB, &
  & 0.36420909E-03_JPRB, 0.36406080E-03_JPRB, 0.36390961E-03_JPRB, 0.36375798E-03_JPRB, 0.36360574E-03_JPRB, 0.36345888E-03_JPRB, &
  & 0.36331624E-03_JPRB, 0.36317477E-03_JPRB, 0.36301085E-03_JPRB, 0.36271295E-03_JPRB /)

RGHG1(:, 8, 5) = (/ &
  & 0.36136858E-03_JPRB, 0.36238763E-03_JPRB, 0.36286184E-03_JPRB, 0.36319639E-03_JPRB, 0.36347023E-03_JPRB, 0.36371656E-03_JPRB, &
  & 0.36393959E-03_JPRB, 0.36415219E-03_JPRB, 0.36435446E-03_JPRB, 0.36455091E-03_JPRB, 0.36474134E-03_JPRB, 0.36492496E-03_JPRB, &
  & 0.36510214E-03_JPRB, 0.36527190E-03_JPRB, 0.36543139E-03_JPRB, 0.36557682E-03_JPRB, 0.36571169E-03_JPRB, 0.36583809E-03_JPRB, &
  & 0.36595497E-03_JPRB, 0.36606303E-03_JPRB, 0.36616798E-03_JPRB, 0.36627220E-03_JPRB, 0.36637310E-03_JPRB, 0.36647133E-03_JPRB, &
  & 0.36656650E-03_JPRB, 0.36664898E-03_JPRB, 0.36671091E-03_JPRB, 0.36674770E-03_JPRB, 0.36675821E-03_JPRB, 0.36674173E-03_JPRB, &
  & 0.36670043E-03_JPRB, 0.36663862E-03_JPRB, 0.36656184E-03_JPRB, 0.36647683E-03_JPRB, 0.36638978E-03_JPRB, 0.36630462E-03_JPRB, &
  & 0.36622147E-03_JPRB, 0.36613818E-03_JPRB, 0.36605299E-03_JPRB, 0.36596606E-03_JPRB, 0.36587816E-03_JPRB, 0.36579050E-03_JPRB, &
  & 0.36570383E-03_JPRB, 0.36561835E-03_JPRB, 0.36553468E-03_JPRB, 0.36545240E-03_JPRB, 0.36537065E-03_JPRB, 0.36528875E-03_JPRB, &
  & 0.36520540E-03_JPRB, 0.36511855E-03_JPRB, 0.36502717E-03_JPRB, 0.36493095E-03_JPRB, 0.36483011E-03_JPRB, 0.36472472E-03_JPRB, &
  & 0.36461672E-03_JPRB, 0.36450845E-03_JPRB, 0.36440120E-03_JPRB, 0.36429631E-03_JPRB, 0.36419704E-03_JPRB, 0.36410402E-03_JPRB, &
  & 0.36401843E-03_JPRB, 0.36393592E-03_JPRB, 0.36384401E-03_JPRB, 0.36367308E-03_JPRB /)

RGHG1(:, 9, 5) = (/ &
  & 0.36272249E-03_JPRB, 0.36351336E-03_JPRB, 0.36384698E-03_JPRB, 0.36408028E-03_JPRB, 0.36426948E-03_JPRB, 0.36443432E-03_JPRB, &
  & 0.36458732E-03_JPRB, 0.36472824E-03_JPRB, 0.36486247E-03_JPRB, 0.36499067E-03_JPRB, 0.36511529E-03_JPRB, 0.36523695E-03_JPRB, &
  & 0.36535453E-03_JPRB, 0.36546765E-03_JPRB, 0.36557621E-03_JPRB, 0.36568087E-03_JPRB, 0.36578026E-03_JPRB, 0.36587613E-03_JPRB, &
  & 0.36597115E-03_JPRB, 0.36606862E-03_JPRB, 0.36616786E-03_JPRB, 0.36627275E-03_JPRB, 0.36638792E-03_JPRB, 0.36650753E-03_JPRB, &
  & 0.36661819E-03_JPRB, 0.36671635E-03_JPRB, 0.36679188E-03_JPRB, 0.36683952E-03_JPRB, 0.36685725E-03_JPRB, 0.36684587E-03_JPRB, &
  & 0.36680911E-03_JPRB, 0.36675209E-03_JPRB, 0.36668204E-03_JPRB, 0.36660561E-03_JPRB, 0.36652622E-03_JPRB, 0.36644528E-03_JPRB, &
  & 0.36636298E-03_JPRB, 0.36627954E-03_JPRB, 0.36619403E-03_JPRB, 0.36610619E-03_JPRB, 0.36601559E-03_JPRB, 0.36592301E-03_JPRB, &
  & 0.36583125E-03_JPRB, 0.36574161E-03_JPRB, 0.36565546E-03_JPRB, 0.36557289E-03_JPRB, 0.36549321E-03_JPRB, 0.36541573E-03_JPRB, &
  & 0.36534059E-03_JPRB, 0.36526608E-03_JPRB, 0.36519108E-03_JPRB, 0.36511593E-03_JPRB, 0.36504169E-03_JPRB, 0.36496838E-03_JPRB, &
  & 0.36489603E-03_JPRB, 0.36482594E-03_JPRB, 0.36476017E-03_JPRB, 0.36469920E-03_JPRB, 0.36464416E-03_JPRB, 0.36459640E-03_JPRB, &
  & 0.36455583E-03_JPRB, 0.36452059E-03_JPRB, 0.36448642E-03_JPRB, 0.36443441E-03_JPRB /)

RGHG1(:,10, 5) = (/ &
  & 0.36380911E-03_JPRB, 0.36429852E-03_JPRB, 0.36451541E-03_JPRB, 0.36466419E-03_JPRB, 0.36478959E-03_JPRB, 0.36490388E-03_JPRB, &
  & 0.36501331E-03_JPRB, 0.36512353E-03_JPRB, 0.36523395E-03_JPRB, 0.36534551E-03_JPRB, 0.36545721E-03_JPRB, 0.36556835E-03_JPRB, &
  & 0.36567685E-03_JPRB, 0.36578011E-03_JPRB, 0.36587613E-03_JPRB, 0.36596344E-03_JPRB, 0.36604423E-03_JPRB, 0.36612069E-03_JPRB, &
  & 0.36619644E-03_JPRB, 0.36627473E-03_JPRB, 0.36636100E-03_JPRB, 0.36645733E-03_JPRB, 0.36656164E-03_JPRB, 0.36666996E-03_JPRB, &
  & 0.36677805E-03_JPRB, 0.36686831E-03_JPRB, 0.36693603E-03_JPRB, 0.36697718E-03_JPRB, 0.36699179E-03_JPRB, 0.36698169E-03_JPRB, &
  & 0.36694985E-03_JPRB, 0.36690041E-03_JPRB, 0.36683914E-03_JPRB, 0.36677072E-03_JPRB, 0.36669816E-03_JPRB, 0.36662212E-03_JPRB, &
  & 0.36654191E-03_JPRB, 0.36645660E-03_JPRB, 0.36636644E-03_JPRB, 0.36627188E-03_JPRB, 0.36617406E-03_JPRB, 0.36607526E-03_JPRB, &
  & 0.36597624E-03_JPRB, 0.36587848E-03_JPRB, 0.36578282E-03_JPRB, 0.36569012E-03_JPRB, 0.36560133E-03_JPRB, 0.36551693E-03_JPRB, &
  & 0.36543686E-03_JPRB, 0.36536131E-03_JPRB, 0.36529091E-03_JPRB, 0.36522621E-03_JPRB, 0.36516675E-03_JPRB, 0.36511183E-03_JPRB, &
  & 0.36506183E-03_JPRB, 0.36501684E-03_JPRB, 0.36497682E-03_JPRB, 0.36494201E-03_JPRB, 0.36491232E-03_JPRB, 0.36488779E-03_JPRB, &
  & 0.36486817E-03_JPRB, 0.36485281E-03_JPRB, 0.36484050E-03_JPRB, 0.36482519E-03_JPRB /)

RGHG1(:,11, 5) = (/ &
  & 0.36460068E-03_JPRB, 0.36489821E-03_JPRB, 0.36503674E-03_JPRB, 0.36514612E-03_JPRB, 0.36524347E-03_JPRB, 0.36534236E-03_JPRB, &
  & 0.36544719E-03_JPRB, 0.36556047E-03_JPRB, 0.36568384E-03_JPRB, 0.36581577E-03_JPRB, 0.36595439E-03_JPRB, 0.36609604E-03_JPRB, &
  & 0.36623640E-03_JPRB, 0.36637019E-03_JPRB, 0.36649202E-03_JPRB, 0.36659828E-03_JPRB, 0.36668652E-03_JPRB, 0.36675850E-03_JPRB, &
  & 0.36681694E-03_JPRB, 0.36686682E-03_JPRB, 0.36691269E-03_JPRB, 0.36695832E-03_JPRB, 0.36700678E-03_JPRB, 0.36705696E-03_JPRB, &
  & 0.36710198E-03_JPRB, 0.36714124E-03_JPRB, 0.36716976E-03_JPRB, 0.36718714E-03_JPRB, 0.36719249E-03_JPRB, 0.36718184E-03_JPRB, &
  & 0.36715533E-03_JPRB, 0.36711845E-03_JPRB, 0.36707424E-03_JPRB, 0.36702264E-03_JPRB, 0.36696414E-03_JPRB, 0.36689651E-03_JPRB, &
  & 0.36681892E-03_JPRB, 0.36673067E-03_JPRB, 0.36663265E-03_JPRB, 0.36652668E-03_JPRB, 0.36641478E-03_JPRB, 0.36630023E-03_JPRB, &
  & 0.36618568E-03_JPRB, 0.36607258E-03_JPRB, 0.36596131E-03_JPRB, 0.36585267E-03_JPRB, 0.36574720E-03_JPRB, 0.36564580E-03_JPRB, &
  & 0.36555034E-03_JPRB, 0.36546311E-03_JPRB, 0.36538512E-03_JPRB, 0.36531599E-03_JPRB, 0.36525534E-03_JPRB, 0.36520272E-03_JPRB, &
  & 0.36515764E-03_JPRB, 0.36511946E-03_JPRB, 0.36508733E-03_JPRB, 0.36506064E-03_JPRB, 0.36503846E-03_JPRB, 0.36502053E-03_JPRB, &
  & 0.36500636E-03_JPRB, 0.36499542E-03_JPRB, 0.36498701E-03_JPRB, 0.36497653E-03_JPRB /)

RGHG1(:,12, 5) = (/ &
  & 0.36520715E-03_JPRB, 0.36540895E-03_JPRB, 0.36551626E-03_JPRB, 0.36560491E-03_JPRB, 0.36569600E-03_JPRB, 0.36579321E-03_JPRB, &
  & 0.36590366E-03_JPRB, 0.36603012E-03_JPRB, 0.36617191E-03_JPRB, 0.36632791E-03_JPRB, 0.36649380E-03_JPRB, 0.36666467E-03_JPRB, &
  & 0.36683405E-03_JPRB, 0.36699563E-03_JPRB, 0.36714267E-03_JPRB, 0.36726941E-03_JPRB, 0.36737201E-03_JPRB, 0.36744910E-03_JPRB, &
  & 0.36750204E-03_JPRB, 0.36753292E-03_JPRB, 0.36754622E-03_JPRB, 0.36754640E-03_JPRB, 0.36753801E-03_JPRB, 0.36752509E-03_JPRB, &
  & 0.36751037E-03_JPRB, 0.36749529E-03_JPRB, 0.36748129E-03_JPRB, 0.36746595E-03_JPRB, 0.36744939E-03_JPRB, 0.36743554E-03_JPRB, &
  & 0.36742046E-03_JPRB, 0.36740172E-03_JPRB, 0.36737969E-03_JPRB, 0.36735387E-03_JPRB, 0.36731779E-03_JPRB, 0.36726709E-03_JPRB, &
  & 0.36719965E-03_JPRB, 0.36711473E-03_JPRB, 0.36701348E-03_JPRB, 0.36689953E-03_JPRB, 0.36677590E-03_JPRB, 0.36664717E-03_JPRB, &
  & 0.36651615E-03_JPRB, 0.36638504E-03_JPRB, 0.36625474E-03_JPRB, 0.36612627E-03_JPRB, 0.36600058E-03_JPRB, 0.36587933E-03_JPRB, &
  & 0.36576396E-03_JPRB, 0.36565604E-03_JPRB, 0.36555668E-03_JPRB, 0.36546742E-03_JPRB, 0.36538852E-03_JPRB, 0.36532091E-03_JPRB, &
  & 0.36526425E-03_JPRB, 0.36521748E-03_JPRB, 0.36517903E-03_JPRB, 0.36514748E-03_JPRB, 0.36512181E-03_JPRB, 0.36510127E-03_JPRB, &
  & 0.36508523E-03_JPRB, 0.36507277E-03_JPRB, 0.36506358E-03_JPRB, 0.36505467E-03_JPRB /)

RGHG1(:,13, 5) = (/ &
  & 0.36571873E-03_JPRB, 0.36587569E-03_JPRB, 0.36596120E-03_JPRB, 0.36604286E-03_JPRB, 0.36612828E-03_JPRB, 0.36622677E-03_JPRB, &
  & 0.36634150E-03_JPRB, 0.36647555E-03_JPRB, 0.36662884E-03_JPRB, 0.36679767E-03_JPRB, 0.36697710E-03_JPRB, 0.36716074E-03_JPRB, &
  & 0.36734095E-03_JPRB, 0.36751060E-03_JPRB, 0.36766246E-03_JPRB, 0.36779128E-03_JPRB, 0.36789259E-03_JPRB, 0.36796535E-03_JPRB, &
  & 0.36800999E-03_JPRB, 0.36802946E-03_JPRB, 0.36802673E-03_JPRB, 0.36800685E-03_JPRB, 0.36797547E-03_JPRB, 0.36793749E-03_JPRB, &
  & 0.36789721E-03_JPRB, 0.36785763E-03_JPRB, 0.36782084E-03_JPRB, 0.36779008E-03_JPRB, 0.36776438E-03_JPRB, 0.36774343E-03_JPRB, &
  & 0.36773269E-03_JPRB, 0.36772652E-03_JPRB, 0.36772393E-03_JPRB, 0.36771392E-03_JPRB, 0.36769517E-03_JPRB, 0.36766278E-03_JPRB, &
  & 0.36761296E-03_JPRB, 0.36754290E-03_JPRB, 0.36745393E-03_JPRB, 0.36734797E-03_JPRB, 0.36722812E-03_JPRB, 0.36709811E-03_JPRB, &
  & 0.36696219E-03_JPRB, 0.36682229E-03_JPRB, 0.36668062E-03_JPRB, 0.36653830E-03_JPRB, 0.36639665E-03_JPRB, 0.36625721E-03_JPRB, &
  & 0.36612173E-03_JPRB, 0.36599286E-03_JPRB, 0.36587220E-03_JPRB, 0.36576117E-03_JPRB, 0.36566102E-03_JPRB, 0.36557257E-03_JPRB, &
  & 0.36549597E-03_JPRB, 0.36543110E-03_JPRB, 0.36537694E-03_JPRB, 0.36533235E-03_JPRB, 0.36529644E-03_JPRB, 0.36526853E-03_JPRB, &
  & 0.36524786E-03_JPRB, 0.36523418E-03_JPRB, 0.36522787E-03_JPRB, 0.36523322E-03_JPRB /)

RGHG1(:,14, 5) = (/ &
  & 0.36620797E-03_JPRB, 0.36632729E-03_JPRB, 0.36639906E-03_JPRB, 0.36647019E-03_JPRB, 0.36655058E-03_JPRB, 0.36664488E-03_JPRB, &
  & 0.36675771E-03_JPRB, 0.36689162E-03_JPRB, 0.36704494E-03_JPRB, 0.36721426E-03_JPRB, 0.36739331E-03_JPRB, 0.36757509E-03_JPRB, &
  & 0.36775158E-03_JPRB, 0.36791427E-03_JPRB, 0.36805772E-03_JPRB, 0.36817678E-03_JPRB, 0.36826881E-03_JPRB, 0.36833293E-03_JPRB, &
  & 0.36837120E-03_JPRB, 0.36838619E-03_JPRB, 0.36838136E-03_JPRB, 0.36836101E-03_JPRB, 0.36832999E-03_JPRB, 0.36829256E-03_JPRB, &
  & 0.36825222E-03_JPRB, 0.36821215E-03_JPRB, 0.36817425E-03_JPRB, 0.36813991E-03_JPRB, 0.36811372E-03_JPRB, 0.36809494E-03_JPRB, &
  & 0.36808453E-03_JPRB, 0.36808377E-03_JPRB, 0.36808098E-03_JPRB, 0.36807972E-03_JPRB, 0.36807012E-03_JPRB, 0.36804818E-03_JPRB, &
  & 0.36801328E-03_JPRB, 0.36796331E-03_JPRB, 0.36789666E-03_JPRB, 0.36781316E-03_JPRB, 0.36771310E-03_JPRB, 0.36759928E-03_JPRB, &
  & 0.36747358E-03_JPRB, 0.36733859E-03_JPRB, 0.36719689E-03_JPRB, 0.36705096E-03_JPRB, 0.36690364E-03_JPRB, 0.36675754E-03_JPRB, &
  & 0.36661566E-03_JPRB, 0.36647983E-03_JPRB, 0.36635139E-03_JPRB, 0.36623058E-03_JPRB, 0.36611845E-03_JPRB, 0.36601577E-03_JPRB, &
  & 0.36592357E-03_JPRB, 0.36584257E-03_JPRB, 0.36577284E-03_JPRB, 0.36571472E-03_JPRB, 0.36566830E-03_JPRB, 0.36563360E-03_JPRB, &
  & 0.36561070E-03_JPRB, 0.36560028E-03_JPRB, 0.36560534E-03_JPRB, 0.36564647E-03_JPRB /)

RGHG1(:,15, 5) = (/ &
  & 0.36672351E-03_JPRB, 0.36679796E-03_JPRB, 0.36684898E-03_JPRB, 0.36690678E-03_JPRB, 0.36697506E-03_JPRB, 0.36705832E-03_JPRB, &
  & 0.36716118E-03_JPRB, 0.36728414E-03_JPRB, 0.36742669E-03_JPRB, 0.36758502E-03_JPRB, 0.36775292E-03_JPRB, 0.36792216E-03_JPRB, &
  & 0.36808502E-03_JPRB, 0.36823403E-03_JPRB, 0.36836331E-03_JPRB, 0.36847073E-03_JPRB, 0.36855449E-03_JPRB, 0.36861480E-03_JPRB, &
  & 0.36865345E-03_JPRB, 0.36867321E-03_JPRB, 0.36867734E-03_JPRB, 0.36866911E-03_JPRB, 0.36865220E-03_JPRB, 0.36862961E-03_JPRB, &
  & 0.36860374E-03_JPRB, 0.36857609E-03_JPRB, 0.36854876E-03_JPRB, 0.36852233E-03_JPRB, 0.36849742E-03_JPRB, 0.36847693E-03_JPRB, &
  & 0.36845857E-03_JPRB, 0.36844268E-03_JPRB, 0.36843188E-03_JPRB, 0.36842137E-03_JPRB, 0.36841215E-03_JPRB, 0.36839995E-03_JPRB, &
  & 0.36838080E-03_JPRB, 0.36835216E-03_JPRB, 0.36831215E-03_JPRB, 0.36825772E-03_JPRB, 0.36818720E-03_JPRB, 0.36809969E-03_JPRB, &
  & 0.36799622E-03_JPRB, 0.36787841E-03_JPRB, 0.36774922E-03_JPRB, 0.36761240E-03_JPRB, 0.36747172E-03_JPRB, 0.36733126E-03_JPRB, &
  & 0.36719389E-03_JPRB, 0.36706176E-03_JPRB, 0.36693577E-03_JPRB, 0.36681574E-03_JPRB, 0.36670186E-03_JPRB, 0.36659496E-03_JPRB, &
  & 0.36649653E-03_JPRB, 0.36640823E-03_JPRB, 0.36633149E-03_JPRB, 0.36626769E-03_JPRB, 0.36621754E-03_JPRB, 0.36618218E-03_JPRB, &
  & 0.36616283E-03_JPRB, 0.36616117E-03_JPRB, 0.36618373E-03_JPRB, 0.36626661E-03_JPRB /)

RGHG1(:,16, 5) = (/ &
  & 0.36721921E-03_JPRB, 0.36726281E-03_JPRB, 0.36729351E-03_JPRB, 0.36733446E-03_JPRB, 0.36738670E-03_JPRB, 0.36745545E-03_JPRB, &
  & 0.36754168E-03_JPRB, 0.36764800E-03_JPRB, 0.36777297E-03_JPRB, 0.36791360E-03_JPRB, 0.36806366E-03_JPRB, 0.36821587E-03_JPRB, &
  & 0.36836218E-03_JPRB, 0.36849608E-03_JPRB, 0.36861241E-03_JPRB, 0.36870912E-03_JPRB, 0.36878762E-03_JPRB, 0.36884879E-03_JPRB, &
  & 0.36889437E-03_JPRB, 0.36892644E-03_JPRB, 0.36894734E-03_JPRB, 0.36895930E-03_JPRB, 0.36896486E-03_JPRB, 0.36896544E-03_JPRB, &
  & 0.36896241E-03_JPRB, 0.36895572E-03_JPRB, 0.36894553E-03_JPRB, 0.36893069E-03_JPRB, 0.36891067E-03_JPRB, 0.36888590E-03_JPRB, &
  & 0.36885703E-03_JPRB, 0.36882679E-03_JPRB, 0.36879661E-03_JPRB, 0.36876887E-03_JPRB, 0.36874568E-03_JPRB, 0.36872883E-03_JPRB, &
  & 0.36871666E-03_JPRB, 0.36870511E-03_JPRB, 0.36868849E-03_JPRB, 0.36866189E-03_JPRB, 0.36862062E-03_JPRB, 0.36856160E-03_JPRB, &
  & 0.36848374E-03_JPRB, 0.36838820E-03_JPRB, 0.36827783E-03_JPRB, 0.36815685E-03_JPRB, 0.36802975E-03_JPRB, 0.36790024E-03_JPRB, &
  & 0.36777236E-03_JPRB, 0.36764843E-03_JPRB, 0.36752928E-03_JPRB, 0.36741496E-03_JPRB, 0.36730530E-03_JPRB, 0.36720160E-03_JPRB, &
  & 0.36710547E-03_JPRB, 0.36701883E-03_JPRB, 0.36694412E-03_JPRB, 0.36688271E-03_JPRB, 0.36683612E-03_JPRB, 0.36680576E-03_JPRB, &
  & 0.36679307E-03_JPRB, 0.36680081E-03_JPRB, 0.36683847E-03_JPRB, 0.36694563E-03_JPRB /)

RGHG1(:,17, 5) = (/ &
  & 0.36766441E-03_JPRB, 0.36768205E-03_JPRB, 0.36769852E-03_JPRB, 0.36772463E-03_JPRB, 0.36776348E-03_JPRB, 0.36781636E-03_JPRB, &
  & 0.36788709E-03_JPRB, 0.36797594E-03_JPRB, 0.36808269E-03_JPRB, 0.36820414E-03_JPRB, 0.36833540E-03_JPRB, 0.36846989E-03_JPRB, &
  & 0.36859975E-03_JPRB, 0.36871986E-03_JPRB, 0.36882644E-03_JPRB, 0.36891739E-03_JPRB, 0.36899318E-03_JPRB, 0.36905665E-03_JPRB, &
  & 0.36911014E-03_JPRB, 0.36915555E-03_JPRB, 0.36919463E-03_JPRB, 0.36922845E-03_JPRB, 0.36925747E-03_JPRB, 0.36928232E-03_JPRB, &
  & 0.36930264E-03_JPRB, 0.36931728E-03_JPRB, 0.36932441E-03_JPRB, 0.36932202E-03_JPRB, 0.36930823E-03_JPRB, 0.36928180E-03_JPRB, &
  & 0.36924440E-03_JPRB, 0.36919973E-03_JPRB, 0.36915226E-03_JPRB, 0.36910796E-03_JPRB, 0.36907155E-03_JPRB, 0.36904615E-03_JPRB, &
  & 0.36903293E-03_JPRB, 0.36902883E-03_JPRB, 0.36902697E-03_JPRB, 0.36902010E-03_JPRB, 0.36900115E-03_JPRB, 0.36896509E-03_JPRB, &
  & 0.36890947E-03_JPRB, 0.36883450E-03_JPRB, 0.36874265E-03_JPRB, 0.36863796E-03_JPRB, 0.36852434E-03_JPRB, 0.36840653E-03_JPRB, &
  & 0.36828898E-03_JPRB, 0.36817446E-03_JPRB, 0.36806348E-03_JPRB, 0.36795589E-03_JPRB, 0.36785228E-03_JPRB, 0.36775431E-03_JPRB, &
  & 0.36766406E-03_JPRB, 0.36758411E-03_JPRB, 0.36751642E-03_JPRB, 0.36746231E-03_JPRB, 0.36742294E-03_JPRB, 0.36739942E-03_JPRB, &
  & 0.36739316E-03_JPRB, 0.36740646E-03_JPRB, 0.36744896E-03_JPRB, 0.36755993E-03_JPRB /)

RGHG1(:,18, 5) = (/ &
  & 0.36804771E-03_JPRB, 0.36804512E-03_JPRB, 0.36805164E-03_JPRB, 0.36806797E-03_JPRB, 0.36809527E-03_JPRB, 0.36813662E-03_JPRB, &
  & 0.36819317E-03_JPRB, 0.36826730E-03_JPRB, 0.36835778E-03_JPRB, 0.36846235E-03_JPRB, 0.36857644E-03_JPRB, 0.36869416E-03_JPRB, &
  & 0.36880982E-03_JPRB, 0.36891762E-03_JPRB, 0.36901535E-03_JPRB, 0.36910214E-03_JPRB, 0.36917801E-03_JPRB, 0.36924458E-03_JPRB, &
  & 0.36930415E-03_JPRB, 0.36935907E-03_JPRB, 0.36941058E-03_JPRB, 0.36945922E-03_JPRB, 0.36950535E-03_JPRB, 0.36954868E-03_JPRB, &
  & 0.36958759E-03_JPRB, 0.36961981E-03_JPRB, 0.36964286E-03_JPRB, 0.36965305E-03_JPRB, 0.36964761E-03_JPRB, 0.36962569E-03_JPRB, &
  & 0.36958820E-03_JPRB, 0.36953922E-03_JPRB, 0.36948372E-03_JPRB, 0.36942895E-03_JPRB, 0.36938279E-03_JPRB, 0.36935011E-03_JPRB, &
  & 0.36933308E-03_JPRB, 0.36932953E-03_JPRB, 0.36933375E-03_JPRB, 0.36933681E-03_JPRB, 0.36933037E-03_JPRB, 0.36930837E-03_JPRB, &
  & 0.36926728E-03_JPRB, 0.36920677E-03_JPRB, 0.36912900E-03_JPRB, 0.36903698E-03_JPRB, 0.36893552E-03_JPRB, 0.36882923E-03_JPRB, &
  & 0.36872222E-03_JPRB, 0.36861631E-03_JPRB, 0.36851218E-03_JPRB, 0.36841090E-03_JPRB, 0.36831372E-03_JPRB, 0.36822277E-03_JPRB, &
  & 0.36814035E-03_JPRB, 0.36806881E-03_JPRB, 0.36800938E-03_JPRB, 0.36796337E-03_JPRB, 0.36793086E-03_JPRB, 0.36791284E-03_JPRB, &
  & 0.36791028E-03_JPRB, 0.36792501E-03_JPRB, 0.36796462E-03_JPRB, 0.36806602E-03_JPRB /)

RGHG1(:,19, 5) = (/ &
  & 0.36836814E-03_JPRB, 0.36835589E-03_JPRB, 0.36835702E-03_JPRB, 0.36836724E-03_JPRB, 0.36838726E-03_JPRB, 0.36841902E-03_JPRB, &
  & 0.36846529E-03_JPRB, 0.36852679E-03_JPRB, 0.36860368E-03_JPRB, 0.36869379E-03_JPRB, 0.36879329E-03_JPRB, 0.36889713E-03_JPRB, &
  & 0.36899975E-03_JPRB, 0.36909743E-03_JPRB, 0.36918698E-03_JPRB, 0.36926809E-03_JPRB, 0.36934181E-03_JPRB, 0.36940927E-03_JPRB, &
  & 0.36947161E-03_JPRB, 0.36953040E-03_JPRB, 0.36958780E-03_JPRB, 0.36964467E-03_JPRB, 0.36970092E-03_JPRB, 0.36975526E-03_JPRB, &
  & 0.36980578E-03_JPRB, 0.36984973E-03_JPRB, 0.36988387E-03_JPRB, 0.36990482E-03_JPRB, 0.36991030E-03_JPRB, 0.36989863E-03_JPRB, &
  & 0.36987072E-03_JPRB, 0.36982886E-03_JPRB, 0.36977750E-03_JPRB, 0.36972362E-03_JPRB, 0.36967572E-03_JPRB, 0.36963995E-03_JPRB, &
  & 0.36961964E-03_JPRB, 0.36961315E-03_JPRB, 0.36961577E-03_JPRB, 0.36961888E-03_JPRB, 0.36961510E-03_JPRB, 0.36959766E-03_JPRB, &
  & 0.36956300E-03_JPRB, 0.36951015E-03_JPRB, 0.36944050E-03_JPRB, 0.36935776E-03_JPRB, 0.36926579E-03_JPRB, 0.36916928E-03_JPRB, &
  & 0.36907033E-03_JPRB, 0.36897062E-03_JPRB, 0.36887228E-03_JPRB, 0.36877766E-03_JPRB, 0.36868855E-03_JPRB, 0.36860636E-03_JPRB, &
  & 0.36853325E-03_JPRB, 0.36847073E-03_JPRB, 0.36841963E-03_JPRB, 0.36838034E-03_JPRB, 0.36835312E-03_JPRB, 0.36833843E-03_JPRB, &
  & 0.36833648E-03_JPRB, 0.36834873E-03_JPRB, 0.36838013E-03_JPRB, 0.36846584E-03_JPRB /)

RGHG1(:,20, 5) = (/ &
  & 0.36863543E-03_JPRB, 0.36862071E-03_JPRB, 0.36862041E-03_JPRB, 0.36862801E-03_JPRB, 0.36864376E-03_JPRB, 0.36867004E-03_JPRB, &
  & 0.36870889E-03_JPRB, 0.36876171E-03_JPRB, 0.36882795E-03_JPRB, 0.36890621E-03_JPRB, 0.36899341E-03_JPRB, 0.36908529E-03_JPRB, &
  & 0.36917720E-03_JPRB, 0.36926538E-03_JPRB, 0.36934792E-03_JPRB, 0.36942377E-03_JPRB, 0.36949350E-03_JPRB, 0.36955869E-03_JPRB, &
  & 0.36962060E-03_JPRB, 0.36968046E-03_JPRB, 0.36973922E-03_JPRB, 0.36979758E-03_JPRB, 0.36985584E-03_JPRB, 0.36991385E-03_JPRB, &
  & 0.36996894E-03_JPRB, 0.37001853E-03_JPRB, 0.37006012E-03_JPRB, 0.37008995E-03_JPRB, 0.37010619E-03_JPRB, 0.37010727E-03_JPRB, &
  & 0.37009353E-03_JPRB, 0.37006609E-03_JPRB, 0.37002872E-03_JPRB, 0.36998594E-03_JPRB, 0.36994432E-03_JPRB, 0.36991021E-03_JPRB, &
  & 0.36988760E-03_JPRB, 0.36987624E-03_JPRB, 0.36987243E-03_JPRB, 0.36986923E-03_JPRB, 0.36986059E-03_JPRB, 0.36984062E-03_JPRB, &
  & 0.36980590E-03_JPRB, 0.36975532E-03_JPRB, 0.36968998E-03_JPRB, 0.36961265E-03_JPRB, 0.36952674E-03_JPRB, 0.36943523E-03_JPRB, &
  & 0.36934079E-03_JPRB, 0.36924685E-03_JPRB, 0.36915619E-03_JPRB, 0.36907016E-03_JPRB, 0.36899018E-03_JPRB, 0.36891788E-03_JPRB, &
  & 0.36885461E-03_JPRB, 0.36880089E-03_JPRB, 0.36875694E-03_JPRB, 0.36872277E-03_JPRB, 0.36869870E-03_JPRB, 0.36868453E-03_JPRB, &
  & 0.36868089E-03_JPRB, 0.36868860E-03_JPRB, 0.36871148E-03_JPRB, 0.36877769E-03_JPRB /)

RGHG1(:,21, 5) = (/ &
  & 0.36885712E-03_JPRB, 0.36884635E-03_JPRB, 0.36884719E-03_JPRB, 0.36885461E-03_JPRB, 0.36886911E-03_JPRB, 0.36889248E-03_JPRB, &
  & 0.36892682E-03_JPRB, 0.36897330E-03_JPRB, 0.36903206E-03_JPRB, 0.36910165E-03_JPRB, 0.36917935E-03_JPRB, 0.36926201E-03_JPRB, &
  & 0.36934533E-03_JPRB, 0.36942601E-03_JPRB, 0.36950203E-03_JPRB, 0.36957281E-03_JPRB, 0.36963850E-03_JPRB, 0.36970008E-03_JPRB, &
  & 0.36975890E-03_JPRB, 0.36981635E-03_JPRB, 0.36987307E-03_JPRB, 0.36992977E-03_JPRB, 0.36998626E-03_JPRB, 0.37004257E-03_JPRB, &
  & 0.37009717E-03_JPRB, 0.37014761E-03_JPRB, 0.37019147E-03_JPRB, 0.37022683E-03_JPRB, 0.37025177E-03_JPRB, 0.37026434E-03_JPRB, &
  & 0.37026481E-03_JPRB, 0.37025328E-03_JPRB, 0.37023218E-03_JPRB, 0.37020419E-03_JPRB, 0.37017444E-03_JPRB, 0.37014735E-03_JPRB, &
  & 0.37012578E-03_JPRB, 0.37010983E-03_JPRB, 0.37009793E-03_JPRB, 0.37008550E-03_JPRB, 0.37006781E-03_JPRB, 0.37004100E-03_JPRB, &
  & 0.37000218E-03_JPRB, 0.36995031E-03_JPRB, 0.36988602E-03_JPRB, 0.36981117E-03_JPRB, 0.36972837E-03_JPRB, 0.36964126E-03_JPRB, &
  & 0.36955375E-03_JPRB, 0.36946859E-03_JPRB, 0.36938666E-03_JPRB, 0.36930895E-03_JPRB, 0.36923774E-03_JPRB, 0.36917420E-03_JPRB, &
  & 0.36911902E-03_JPRB, 0.36907202E-03_JPRB, 0.36903322E-03_JPRB, 0.36900255E-03_JPRB, 0.36897970E-03_JPRB, 0.36896497E-03_JPRB, &
  & 0.36895872E-03_JPRB, 0.36896142E-03_JPRB, 0.36897595E-03_JPRB, 0.36902077E-03_JPRB /)

RGHG1(:,22, 5) = (/ &
  & 0.36904323E-03_JPRB, 0.36903750E-03_JPRB, 0.36904091E-03_JPRB, 0.36904993E-03_JPRB, 0.36906480E-03_JPRB, 0.36908762E-03_JPRB, &
  & 0.36912001E-03_JPRB, 0.36916335E-03_JPRB, 0.36921742E-03_JPRB, 0.36928122E-03_JPRB, 0.36935252E-03_JPRB, 0.36942816E-03_JPRB, &
  & 0.36950511E-03_JPRB, 0.36958014E-03_JPRB, 0.36965110E-03_JPRB, 0.36971725E-03_JPRB, 0.36977881E-03_JPRB, 0.36983649E-03_JPRB, &
  & 0.36989170E-03_JPRB, 0.36994531E-03_JPRB, 0.36999799E-03_JPRB, 0.37005017E-03_JPRB, 0.37010215E-03_JPRB, 0.37015366E-03_JPRB, &
  & 0.37020404E-03_JPRB, 0.37025212E-03_JPRB, 0.37029610E-03_JPRB, 0.37033358E-03_JPRB, 0.37036312E-03_JPRB, 0.37038402E-03_JPRB, &
  & 0.37039525E-03_JPRB, 0.37039688E-03_JPRB, 0.37038993E-03_JPRB, 0.37037593E-03_JPRB, 0.37035783E-03_JPRB, 0.37033798E-03_JPRB, &
  & 0.37031926E-03_JPRB, 0.37030110E-03_JPRB, 0.37028280E-03_JPRB, 0.37026213E-03_JPRB, 0.37023582E-03_JPRB, 0.37020122E-03_JPRB, &
  & 0.37015675E-03_JPRB, 0.37010200E-03_JPRB, 0.37003704E-03_JPRB, 0.36996370E-03_JPRB, 0.36988512E-03_JPRB, 0.36980482E-03_JPRB, &
  & 0.36972543E-03_JPRB, 0.36964795E-03_JPRB, 0.36957354E-03_JPRB, 0.36950412E-03_JPRB, 0.36944106E-03_JPRB, 0.36938506E-03_JPRB, &
  & 0.36933637E-03_JPRB, 0.36929475E-03_JPRB, 0.36925991E-03_JPRB, 0.36923136E-03_JPRB, 0.36920913E-03_JPRB, 0.36919318E-03_JPRB, &
  & 0.36918407E-03_JPRB, 0.36918212E-03_JPRB, 0.36918902E-03_JPRB, 0.36921710E-03_JPRB /)

RGHG1(:,23, 5) = (/ &
  & 0.36919845E-03_JPRB, 0.36919944E-03_JPRB, 0.36920587E-03_JPRB, 0.36921678E-03_JPRB, 0.36923360E-03_JPRB, 0.36925726E-03_JPRB, &
  & 0.36928963E-03_JPRB, 0.36933162E-03_JPRB, 0.36938314E-03_JPRB, 0.36944353E-03_JPRB, 0.36951058E-03_JPRB, 0.36958198E-03_JPRB, &
  & 0.36965453E-03_JPRB, 0.36972534E-03_JPRB, 0.36979257E-03_JPRB, 0.36985520E-03_JPRB, 0.36991326E-03_JPRB, 0.36996760E-03_JPRB, &
  & 0.37001912E-03_JPRB, 0.37006862E-03_JPRB, 0.37011638E-03_JPRB, 0.37016312E-03_JPRB, 0.37020893E-03_JPRB, 0.37025384E-03_JPRB, &
  & 0.37029799E-03_JPRB, 0.37034065E-03_JPRB, 0.37038111E-03_JPRB, 0.37041842E-03_JPRB, 0.37045061E-03_JPRB, 0.37047622E-03_JPRB, &
  & 0.37049456E-03_JPRB, 0.37050527E-03_JPRB, 0.37050835E-03_JPRB, 0.37050454E-03_JPRB, 0.37049525E-03_JPRB, 0.37048175E-03_JPRB, &
  & 0.37046539E-03_JPRB, 0.37044621E-03_JPRB, 0.37042415E-03_JPRB, 0.37039752E-03_JPRB, 0.37036464E-03_JPRB, 0.37032444E-03_JPRB, &
  & 0.37027619E-03_JPRB, 0.37021920E-03_JPRB, 0.37015439E-03_JPRB, 0.37008390E-03_JPRB, 0.37001015E-03_JPRB, 0.36993591E-03_JPRB, &
  & 0.36986292E-03_JPRB, 0.36979257E-03_JPRB, 0.36972613E-03_JPRB, 0.36966449E-03_JPRB, 0.36960878E-03_JPRB, 0.36955945E-03_JPRB, &
  & 0.36951632E-03_JPRB, 0.36947904E-03_JPRB, 0.36944708E-03_JPRB, 0.36942025E-03_JPRB, 0.36939816E-03_JPRB, 0.36938139E-03_JPRB, &
  & 0.36936987E-03_JPRB, 0.36936393E-03_JPRB, 0.36936466E-03_JPRB, 0.36937968E-03_JPRB /)

RGHG1(:,24, 5) = (/ &
  & 0.36933192E-03_JPRB, 0.36933797E-03_JPRB, 0.36934722E-03_JPRB, 0.36936052E-03_JPRB, 0.36937863E-03_JPRB, 0.36940366E-03_JPRB, &
  & 0.36943660E-03_JPRB, 0.36947854E-03_JPRB, 0.36952901E-03_JPRB, 0.36958727E-03_JPRB, 0.36965165E-03_JPRB, 0.36971999E-03_JPRB, &
  & 0.36978946E-03_JPRB, 0.36985744E-03_JPRB, 0.36992188E-03_JPRB, 0.36998192E-03_JPRB, 0.37003768E-03_JPRB, 0.37008926E-03_JPRB, &
  & 0.37013760E-03_JPRB, 0.37018329E-03_JPRB, 0.37022674E-03_JPRB, 0.37026813E-03_JPRB, 0.37030797E-03_JPRB, 0.37034642E-03_JPRB, &
  & 0.37038408E-03_JPRB, 0.37042081E-03_JPRB, 0.37045663E-03_JPRB, 0.37049054E-03_JPRB, 0.37052203E-03_JPRB, 0.37054950E-03_JPRB, &
  & 0.37057165E-03_JPRB, 0.37058734E-03_JPRB, 0.37059607E-03_JPRB, 0.37059825E-03_JPRB, 0.37059427E-03_JPRB, 0.37058472E-03_JPRB, &
  & 0.37056996E-03_JPRB, 0.37055044E-03_JPRB, 0.37052587E-03_JPRB, 0.37049578E-03_JPRB, 0.37045951E-03_JPRB, 0.37041632E-03_JPRB, &
  & 0.37036612E-03_JPRB, 0.37030896E-03_JPRB, 0.37024592E-03_JPRB, 0.37017872E-03_JPRB, 0.37010989E-03_JPRB, 0.37004158E-03_JPRB, &
  & 0.36997549E-03_JPRB, 0.36991242E-03_JPRB, 0.36985325E-03_JPRB, 0.36979877E-03_JPRB, 0.36974956E-03_JPRB, 0.36970587E-03_JPRB, &
  & 0.36966731E-03_JPRB, 0.36963355E-03_JPRB, 0.36960407E-03_JPRB, 0.36957828E-03_JPRB, 0.36955645E-03_JPRB, 0.36953870E-03_JPRB, &
  & 0.36952551E-03_JPRB, 0.36951678E-03_JPRB, 0.36951297E-03_JPRB, 0.36951731E-03_JPRB /)

RGHG1(:,25, 5) = (/ &
  & 0.36944833E-03_JPRB, 0.36945872E-03_JPRB, 0.36947028E-03_JPRB, 0.36948471E-03_JPRB, 0.36950421E-03_JPRB, 0.36953000E-03_JPRB, &
  & 0.36956335E-03_JPRB, 0.36960529E-03_JPRB, 0.36965520E-03_JPRB, 0.36971210E-03_JPRB, 0.36977450E-03_JPRB, 0.36984039E-03_JPRB, &
  & 0.36990744E-03_JPRB, 0.36997313E-03_JPRB, 0.37003576E-03_JPRB, 0.37009423E-03_JPRB, 0.37014802E-03_JPRB, 0.37019770E-03_JPRB, &
  & 0.37024374E-03_JPRB, 0.37028667E-03_JPRB, 0.37032668E-03_JPRB, 0.37036385E-03_JPRB, 0.37039840E-03_JPRB, 0.37043108E-03_JPRB, &
  & 0.37046248E-03_JPRB, 0.37049345E-03_JPRB, 0.37052407E-03_JPRB, 0.37055436E-03_JPRB, 0.37058341E-03_JPRB, 0.37061016E-03_JPRB, &
  & 0.37063318E-03_JPRB, 0.37065093E-03_JPRB, 0.37066251E-03_JPRB, 0.37066761E-03_JPRB, 0.37066615E-03_JPRB, 0.37065821E-03_JPRB, &
  & 0.37064386E-03_JPRB, 0.37062401E-03_JPRB, 0.37059787E-03_JPRB, 0.37056592E-03_JPRB, 0.37052791E-03_JPRB, 0.37048367E-03_JPRB, &
  & 0.37043329E-03_JPRB, 0.37037750E-03_JPRB, 0.37031734E-03_JPRB, 0.37025448E-03_JPRB, 0.37019135E-03_JPRB, 0.37012933E-03_JPRB, &
  & 0.37006999E-03_JPRB, 0.37001408E-03_JPRB, 0.36996193E-03_JPRB, 0.36991382E-03_JPRB, 0.36987048E-03_JPRB, 0.36983166E-03_JPRB, &
  & 0.36979708E-03_JPRB, 0.36976615E-03_JPRB, 0.36973826E-03_JPRB, 0.36971332E-03_JPRB, 0.36969135E-03_JPRB, 0.36967284E-03_JPRB, &
  & 0.36965826E-03_JPRB, 0.36964766E-03_JPRB, 0.36964062E-03_JPRB, 0.36963850E-03_JPRB /)

RGHG1(:,26, 5) = (/ &
  & 0.36955305E-03_JPRB, 0.36956681E-03_JPRB, 0.36957895E-03_JPRB, 0.36959455E-03_JPRB, 0.36961422E-03_JPRB, 0.36964024E-03_JPRB, &
  & 0.36967368E-03_JPRB, 0.36971489E-03_JPRB, 0.36976387E-03_JPRB, 0.36981929E-03_JPRB, 0.36987977E-03_JPRB, 0.36994356E-03_JPRB, &
  & 0.37000841E-03_JPRB, 0.37007232E-03_JPRB, 0.37013352E-03_JPRB, 0.37019074E-03_JPRB, 0.37024351E-03_JPRB, 0.37029205E-03_JPRB, &
  & 0.37033664E-03_JPRB, 0.37037741E-03_JPRB, 0.37041472E-03_JPRB, 0.37044886E-03_JPRB, 0.37047977E-03_JPRB, 0.37050803E-03_JPRB, &
  & 0.37053466E-03_JPRB, 0.37056027E-03_JPRB, 0.37058600E-03_JPRB, 0.37061184E-03_JPRB, 0.37063751E-03_JPRB, 0.37066211E-03_JPRB, &
  & 0.37068414E-03_JPRB, 0.37070195E-03_JPRB, 0.37071417E-03_JPRB, 0.37072023E-03_JPRB, 0.37071959E-03_JPRB, 0.37071193E-03_JPRB, &
  & 0.37069773E-03_JPRB, 0.37067695E-03_JPRB, 0.37065006E-03_JPRB, 0.37061720E-03_JPRB, 0.37057878E-03_JPRB, 0.37053475E-03_JPRB, &
  & 0.37048574E-03_JPRB, 0.37043251E-03_JPRB, 0.37037631E-03_JPRB, 0.37031883E-03_JPRB, 0.37026146E-03_JPRB, 0.37020617E-03_JPRB, &
  & 0.37015372E-03_JPRB, 0.37010430E-03_JPRB, 0.37005823E-03_JPRB, 0.37001574E-03_JPRB, 0.36997709E-03_JPRB, 0.36994211E-03_JPRB, &
  & 0.36991044E-03_JPRB, 0.36988172E-03_JPRB, 0.36985544E-03_JPRB, 0.36983137E-03_JPRB, 0.36980960E-03_JPRB, 0.36979080E-03_JPRB, &
  & 0.36977499E-03_JPRB, 0.36976268E-03_JPRB, 0.36975299E-03_JPRB, 0.36974467E-03_JPRB /)

RGHG1(:,27, 5) = (/ &
  & 0.36964932E-03_JPRB, 0.36966338E-03_JPRB, 0.36967694E-03_JPRB, 0.36969193E-03_JPRB, 0.36971175E-03_JPRB, 0.36973739E-03_JPRB, &
  & 0.36976999E-03_JPRB, 0.36981047E-03_JPRB, 0.36985800E-03_JPRB, 0.36991152E-03_JPRB, 0.36996990E-03_JPRB, 0.37003137E-03_JPRB, &
  & 0.37009441E-03_JPRB, 0.37015672E-03_JPRB, 0.37021670E-03_JPRB, 0.37027308E-03_JPRB, 0.37032523E-03_JPRB, 0.37037296E-03_JPRB, &
  & 0.37041659E-03_JPRB, 0.37045626E-03_JPRB, 0.37049211E-03_JPRB, 0.37052401E-03_JPRB, 0.37055230E-03_JPRB, 0.37057741E-03_JPRB, &
  & 0.37060026E-03_JPRB, 0.37062180E-03_JPRB, 0.37064304E-03_JPRB, 0.37066455E-03_JPRB, 0.37068632E-03_JPRB, 0.37070806E-03_JPRB, &
  & 0.37072791E-03_JPRB, 0.37074453E-03_JPRB, 0.37075620E-03_JPRB, 0.37076208E-03_JPRB, 0.37076126E-03_JPRB, 0.37075358E-03_JPRB, &
  & 0.37073903E-03_JPRB, 0.37071769E-03_JPRB, 0.37069048E-03_JPRB, 0.37065762E-03_JPRB, 0.37061959E-03_JPRB, 0.37057689E-03_JPRB, &
  & 0.37053012E-03_JPRB, 0.37048070E-03_JPRB, 0.37042922E-03_JPRB, 0.37037701E-03_JPRB, 0.37032575E-03_JPRB, 0.37027660E-03_JPRB, &
  & 0.37023009E-03_JPRB, 0.37018632E-03_JPRB, 0.37014557E-03_JPRB, 0.37010782E-03_JPRB, 0.37007296E-03_JPRB, 0.37004118E-03_JPRB, &
  & 0.37001213E-03_JPRB, 0.36998527E-03_JPRB, 0.36996018E-03_JPRB, 0.36993678E-03_JPRB, 0.36991521E-03_JPRB, 0.36989601E-03_JPRB, &
  & 0.36987971E-03_JPRB, 0.36986615E-03_JPRB, 0.36985480E-03_JPRB, 0.36984237E-03_JPRB /)

RGHG1(:,28, 5) = (/ &
  & 0.36973428E-03_JPRB, 0.36975107E-03_JPRB, 0.36976358E-03_JPRB, 0.36977913E-03_JPRB, 0.36979810E-03_JPRB, 0.36982290E-03_JPRB, &
  & 0.36985494E-03_JPRB, 0.36989391E-03_JPRB, 0.36993989E-03_JPRB, 0.36999150E-03_JPRB, 0.37004746E-03_JPRB, 0.37010686E-03_JPRB, &
  & 0.37016778E-03_JPRB, 0.37022875E-03_JPRB, 0.37028757E-03_JPRB, 0.37034330E-03_JPRB, 0.37039522E-03_JPRB, 0.37044272E-03_JPRB, &
  & 0.37048577E-03_JPRB, 0.37052468E-03_JPRB, 0.37055940E-03_JPRB, 0.37059002E-03_JPRB, 0.37061647E-03_JPRB, 0.37063946E-03_JPRB, &
  & 0.37065955E-03_JPRB, 0.37067782E-03_JPRB, 0.37069526E-03_JPRB, 0.37071307E-03_JPRB, 0.37073117E-03_JPRB, 0.37074945E-03_JPRB, &
  & 0.37076662E-03_JPRB, 0.37078117E-03_JPRB, 0.37079165E-03_JPRB, 0.37079677E-03_JPRB, 0.37079546E-03_JPRB, 0.37078737E-03_JPRB, &
  & 0.37077247E-03_JPRB, 0.37075137E-03_JPRB, 0.37072436E-03_JPRB, 0.37069229E-03_JPRB, 0.37065562E-03_JPRB, 0.37061519E-03_JPRB, &
  & 0.37057186E-03_JPRB, 0.37052651E-03_JPRB, 0.37047997E-03_JPRB, 0.37043341E-03_JPRB, 0.37038786E-03_JPRB, 0.37034403E-03_JPRB, &
  & 0.37030279E-03_JPRB, 0.37026379E-03_JPRB, 0.37022709E-03_JPRB, 0.37019269E-03_JPRB, 0.37016088E-03_JPRB, 0.37013146E-03_JPRB, &
  & 0.37010410E-03_JPRB, 0.37007866E-03_JPRB, 0.37005451E-03_JPRB, 0.37003180E-03_JPRB, 0.37001050E-03_JPRB, 0.36999115E-03_JPRB, &
  & 0.36997432E-03_JPRB, 0.36996021E-03_JPRB, 0.36994772E-03_JPRB, 0.36993274E-03_JPRB /)

RGHG1(:,29, 5) = (/ &
  & 0.36981213E-03_JPRB, 0.36982802E-03_JPRB, 0.36984187E-03_JPRB, 0.36985625E-03_JPRB, 0.36987488E-03_JPRB, 0.36989903E-03_JPRB, &
  & 0.36992982E-03_JPRB, 0.36996789E-03_JPRB, 0.37001213E-03_JPRB, 0.37006158E-03_JPRB, 0.37011565E-03_JPRB, 0.37017275E-03_JPRB, &
  & 0.37023195E-03_JPRB, 0.37029127E-03_JPRB, 0.37034909E-03_JPRB, 0.37040433E-03_JPRB, 0.37045576E-03_JPRB, 0.37050311E-03_JPRB, &
  & 0.37054598E-03_JPRB, 0.37058428E-03_JPRB, 0.37061825E-03_JPRB, 0.37064773E-03_JPRB, 0.37067299E-03_JPRB, 0.37069441E-03_JPRB, &
  & 0.37071260E-03_JPRB, 0.37072849E-03_JPRB, 0.37074307E-03_JPRB, 0.37075757E-03_JPRB, 0.37077229E-03_JPRB, 0.37078719E-03_JPRB, &
  & 0.37080143E-03_JPRB, 0.37081359E-03_JPRB, 0.37082232E-03_JPRB, 0.37082614E-03_JPRB, 0.37082413E-03_JPRB, 0.37081577E-03_JPRB, &
  & 0.37080125E-03_JPRB, 0.37078082E-03_JPRB, 0.37075495E-03_JPRB, 0.37072436E-03_JPRB, 0.37068999E-03_JPRB, 0.37065271E-03_JPRB, &
  & 0.37061342E-03_JPRB, 0.37057261E-03_JPRB, 0.37053117E-03_JPRB, 0.37048972E-03_JPRB, 0.37044927E-03_JPRB, 0.37041024E-03_JPRB, &
  & 0.37037305E-03_JPRB, 0.37033763E-03_JPRB, 0.37030390E-03_JPRB, 0.37027209E-03_JPRB, 0.37024223E-03_JPRB, 0.37021437E-03_JPRB, &
  & 0.37018841E-03_JPRB, 0.37016399E-03_JPRB, 0.37014059E-03_JPRB, 0.37011821E-03_JPRB, 0.37009720E-03_JPRB, 0.37007773E-03_JPRB, &
  & 0.37006073E-03_JPRB, 0.37004589E-03_JPRB, 0.37003236E-03_JPRB, 0.37001492E-03_JPRB /)

RGHG1(:,30, 5) = (/ &
  & 0.36987985E-03_JPRB, 0.36989804E-03_JPRB, 0.36991067E-03_JPRB, 0.36992575E-03_JPRB, 0.36994385E-03_JPRB, 0.36996725E-03_JPRB, &
  & 0.36999746E-03_JPRB, 0.37003419E-03_JPRB, 0.37007689E-03_JPRB, 0.37012435E-03_JPRB, 0.37017599E-03_JPRB, 0.37023099E-03_JPRB, &
  & 0.37028821E-03_JPRB, 0.37034604E-03_JPRB, 0.37040317E-03_JPRB, 0.37045768E-03_JPRB, 0.37050864E-03_JPRB, 0.37055567E-03_JPRB, &
  & 0.37059808E-03_JPRB, 0.37063594E-03_JPRB, 0.37066947E-03_JPRB, 0.37069825E-03_JPRB, 0.37072258E-03_JPRB, 0.37074281E-03_JPRB, &
  & 0.37075958E-03_JPRB, 0.37077389E-03_JPRB, 0.37078623E-03_JPRB, 0.37079796E-03_JPRB, 0.37080981E-03_JPRB, 0.37082174E-03_JPRB, &
  & 0.37083283E-03_JPRB, 0.37084238E-03_JPRB, 0.37084927E-03_JPRB, 0.37085172E-03_JPRB, 0.37084895E-03_JPRB, 0.37084069E-03_JPRB, &
  & 0.37082660E-03_JPRB, 0.37080745E-03_JPRB, 0.37078341E-03_JPRB, 0.37075538E-03_JPRB, 0.37072421E-03_JPRB, 0.37069083E-03_JPRB, &
  & 0.37065579E-03_JPRB, 0.37061976E-03_JPRB, 0.37058309E-03_JPRB, 0.37054642E-03_JPRB, 0.37050995E-03_JPRB, 0.37047462E-03_JPRB, &
  & 0.37044071E-03_JPRB, 0.37040783E-03_JPRB, 0.37037616E-03_JPRB, 0.37034607E-03_JPRB, 0.37031755E-03_JPRB, 0.37029089E-03_JPRB, &
  & 0.37026580E-03_JPRB, 0.37024205E-03_JPRB, 0.37021929E-03_JPRB, 0.37019726E-03_JPRB, 0.37017654E-03_JPRB, 0.37015727E-03_JPRB, &
  & 0.37013998E-03_JPRB, 0.37012488E-03_JPRB, 0.37011059E-03_JPRB, 0.37009144E-03_JPRB /)

RGHG1(:,31, 5) = (/ &
  & 0.36994205E-03_JPRB, 0.36995986E-03_JPRB, 0.36997424E-03_JPRB, 0.36998879E-03_JPRB, 0.37000707E-03_JPRB, 0.37003012E-03_JPRB, &
  & 0.37005919E-03_JPRB, 0.37009481E-03_JPRB, 0.37013562E-03_JPRB, 0.37018117E-03_JPRB, 0.37023085E-03_JPRB, 0.37028373E-03_JPRB, &
  & 0.37033908E-03_JPRB, 0.37039522E-03_JPRB, 0.37045087E-03_JPRB, 0.37050480E-03_JPRB, 0.37055538E-03_JPRB, 0.37060192E-03_JPRB, &
  & 0.37064395E-03_JPRB, 0.37068134E-03_JPRB, 0.37071411E-03_JPRB, 0.37074205E-03_JPRB, 0.37076563E-03_JPRB, 0.37078501E-03_JPRB, &
  & 0.37080076E-03_JPRB, 0.37081380E-03_JPRB, 0.37082462E-03_JPRB, 0.37083440E-03_JPRB, 0.37084380E-03_JPRB, 0.37085268E-03_JPRB, &
  & 0.37086126E-03_JPRB, 0.37086851E-03_JPRB, 0.37087325E-03_JPRB, 0.37087442E-03_JPRB, 0.37087116E-03_JPRB, 0.37086298E-03_JPRB, &
  & 0.37084983E-03_JPRB, 0.37083225E-03_JPRB, 0.37081065E-03_JPRB, 0.37078562E-03_JPRB, 0.37075824E-03_JPRB, 0.37072875E-03_JPRB, &
  & 0.37069814E-03_JPRB, 0.37066668E-03_JPRB, 0.37063452E-03_JPRB, 0.37060175E-03_JPRB, 0.37056889E-03_JPRB, 0.37053641E-03_JPRB, &
  & 0.37050463E-03_JPRB, 0.37047375E-03_JPRB, 0.37044357E-03_JPRB, 0.37041455E-03_JPRB, 0.37038710E-03_JPRB, 0.37036111E-03_JPRB, &
  & 0.37033684E-03_JPRB, 0.37031368E-03_JPRB, 0.37029147E-03_JPRB, 0.37026993E-03_JPRB, 0.37024941E-03_JPRB, 0.37023021E-03_JPRB, &
  & 0.37021295E-03_JPRB, 0.37019770E-03_JPRB, 0.37018306E-03_JPRB, 0.37016277E-03_JPRB /)

RGHG1(:,32, 5) = (/ &
  & 0.36999802E-03_JPRB, 0.37001862E-03_JPRB, 0.37003239E-03_JPRB, 0.37004799E-03_JPRB, 0.37006597E-03_JPRB, 0.37008876E-03_JPRB, &
  & 0.37011737E-03_JPRB, 0.37015142E-03_JPRB, 0.37019051E-03_JPRB, 0.37023405E-03_JPRB, 0.37028143E-03_JPRB, 0.37033221E-03_JPRB, &
  & 0.37038536E-03_JPRB, 0.37043981E-03_JPRB, 0.37049406E-03_JPRB, 0.37054671E-03_JPRB, 0.37059668E-03_JPRB, 0.37064249E-03_JPRB, &
  & 0.37068411E-03_JPRB, 0.37072084E-03_JPRB, 0.37075282E-03_JPRB, 0.37078001E-03_JPRB, 0.37080285E-03_JPRB, 0.37082145E-03_JPRB, &
  & 0.37083635E-03_JPRB, 0.37084825E-03_JPRB, 0.37085812E-03_JPRB, 0.37086650E-03_JPRB, 0.37087384E-03_JPRB, 0.37088050E-03_JPRB, &
  & 0.37088676E-03_JPRB, 0.37089182E-03_JPRB, 0.37089476E-03_JPRB, 0.37089468E-03_JPRB, 0.37089083E-03_JPRB, 0.37088286E-03_JPRB, &
  & 0.37087093E-03_JPRB, 0.37085524E-03_JPRB, 0.37083632E-03_JPRB, 0.37081464E-03_JPRB, 0.37079092E-03_JPRB, 0.37076554E-03_JPRB, &
  & 0.37073912E-03_JPRB, 0.37071176E-03_JPRB, 0.37068332E-03_JPRB, 0.37065399E-03_JPRB, 0.37062404E-03_JPRB, 0.37059397E-03_JPRB, &
  & 0.37056403E-03_JPRB, 0.37053449E-03_JPRB, 0.37050538E-03_JPRB, 0.37047736E-03_JPRB, 0.37045055E-03_JPRB, 0.37042526E-03_JPRB, &
  & 0.37040137E-03_JPRB, 0.37037878E-03_JPRB, 0.37035707E-03_JPRB, 0.37033609E-03_JPRB, 0.37031606E-03_JPRB, 0.37029712E-03_JPRB, &
  & 0.37027994E-03_JPRB, 0.37026449E-03_JPRB, 0.37024959E-03_JPRB, 0.37022858E-03_JPRB /)

RGHG1(:,33, 5) = (/ &
  & 0.37005200E-03_JPRB, 0.37007316E-03_JPRB, 0.37008891E-03_JPRB, 0.37010436E-03_JPRB, 0.37012273E-03_JPRB, 0.37014531E-03_JPRB, &
  & 0.37017278E-03_JPRB, 0.37020547E-03_JPRB, 0.37024255E-03_JPRB, 0.37028364E-03_JPRB, 0.37032878E-03_JPRB, 0.37037703E-03_JPRB, &
  & 0.37042805E-03_JPRB, 0.37048035E-03_JPRB, 0.37053291E-03_JPRB, 0.37058434E-03_JPRB, 0.37063309E-03_JPRB, 0.37067820E-03_JPRB, &
  & 0.37071898E-03_JPRB, 0.37075518E-03_JPRB, 0.37078641E-03_JPRB, 0.37081295E-03_JPRB, 0.37083481E-03_JPRB, 0.37085282E-03_JPRB, &
  & 0.37086711E-03_JPRB, 0.37087829E-03_JPRB, 0.37088711E-03_JPRB, 0.37089424E-03_JPRB, 0.37090009E-03_JPRB, 0.37090515E-03_JPRB, &
  & 0.37090937E-03_JPRB, 0.37091249E-03_JPRB, 0.37091397E-03_JPRB, 0.37091298E-03_JPRB, 0.37090885E-03_JPRB, 0.37090134E-03_JPRB, &
  & 0.37089054E-03_JPRB, 0.37087683E-03_JPRB, 0.37086054E-03_JPRB, 0.37084200E-03_JPRB, 0.37082160E-03_JPRB, 0.37079997E-03_JPRB, &
  & 0.37077712E-03_JPRB, 0.37075311E-03_JPRB, 0.37072794E-03_JPRB, 0.37070128E-03_JPRB, 0.37067386E-03_JPRB, 0.37064584E-03_JPRB, &
  & 0.37061761E-03_JPRB, 0.37058938E-03_JPRB, 0.37056123E-03_JPRB, 0.37053393E-03_JPRB, 0.37050777E-03_JPRB, 0.37048318E-03_JPRB, &
  & 0.37046010E-03_JPRB, 0.37043818E-03_JPRB, 0.37041717E-03_JPRB, 0.37039671E-03_JPRB, 0.37037686E-03_JPRB, 0.37035826E-03_JPRB, &
  & 0.37034138E-03_JPRB, 0.37032604E-03_JPRB, 0.37031111E-03_JPRB, 0.37028978E-03_JPRB /)

RGHG1(:,34, 5) = (/ &
  & 0.37010305E-03_JPRB, 0.37012750E-03_JPRB, 0.37014304E-03_JPRB, 0.37015943E-03_JPRB, 0.37017767E-03_JPRB, 0.37019979E-03_JPRB, &
  & 0.37022631E-03_JPRB, 0.37025721E-03_JPRB, 0.37029205E-03_JPRB, 0.37033082E-03_JPRB, 0.37037316E-03_JPRB, 0.37041903E-03_JPRB, &
  & 0.37046755E-03_JPRB, 0.37051766E-03_JPRB, 0.37056810E-03_JPRB, 0.37061772E-03_JPRB, 0.37066531E-03_JPRB, 0.37070955E-03_JPRB, &
  & 0.37074956E-03_JPRB, 0.37078490E-03_JPRB, 0.37081557E-03_JPRB, 0.37084136E-03_JPRB, 0.37086263E-03_JPRB, 0.37087980E-03_JPRB, &
  & 0.37089334E-03_JPRB, 0.37090378E-03_JPRB, 0.37091182E-03_JPRB, 0.37091796E-03_JPRB, 0.37092270E-03_JPRB, 0.37092646E-03_JPRB, &
  & 0.37092919E-03_JPRB, 0.37093097E-03_JPRB, 0.37093120E-03_JPRB, 0.37092928E-03_JPRB, 0.37092503E-03_JPRB, 0.37091819E-03_JPRB, &
  & 0.37090885E-03_JPRB, 0.37089706E-03_JPRB, 0.37088312E-03_JPRB, 0.37086726E-03_JPRB, 0.37085000E-03_JPRB, 0.37083129E-03_JPRB, &
  & 0.37081123E-03_JPRB, 0.37078993E-03_JPRB, 0.37076717E-03_JPRB, 0.37074307E-03_JPRB, 0.37071767E-03_JPRB, 0.37069136E-03_JPRB, &
  & 0.37066475E-03_JPRB, 0.37063766E-03_JPRB, 0.37061056E-03_JPRB, 0.37058417E-03_JPRB, 0.37055893E-03_JPRB, 0.37053507E-03_JPRB, &
  & 0.37051275E-03_JPRB, 0.37049147E-03_JPRB, 0.37047087E-03_JPRB, 0.37045116E-03_JPRB, 0.37043219E-03_JPRB, 0.37041440E-03_JPRB, &
  & 0.37039799E-03_JPRB, 0.37038303E-03_JPRB, 0.37036813E-03_JPRB, 0.37034656E-03_JPRB /)

RGHG1(:,35, 5) = (/ &
  & 0.37015384E-03_JPRB, 0.37017919E-03_JPRB, 0.37019636E-03_JPRB, 0.37021283E-03_JPRB, 0.37023131E-03_JPRB, 0.37025288E-03_JPRB, &
  & 0.37027808E-03_JPRB, 0.37030724E-03_JPRB, 0.37033987E-03_JPRB, 0.37037593E-03_JPRB, 0.37041566E-03_JPRB, 0.37045850E-03_JPRB, &
  & 0.37050428E-03_JPRB, 0.37055192E-03_JPRB, 0.37060020E-03_JPRB, 0.37064790E-03_JPRB, 0.37069389E-03_JPRB, 0.37073714E-03_JPRB, &
  & 0.37077631E-03_JPRB, 0.37081097E-03_JPRB, 0.37084077E-03_JPRB, 0.37086583E-03_JPRB, 0.37088644E-03_JPRB, 0.37090285E-03_JPRB, &
  & 0.37091580E-03_JPRB, 0.37092558E-03_JPRB, 0.37093300E-03_JPRB, 0.37093827E-03_JPRB, 0.37094220E-03_JPRB, 0.37094488E-03_JPRB, &
  & 0.37094648E-03_JPRB, 0.37094724E-03_JPRB, 0.37094654E-03_JPRB, 0.37094427E-03_JPRB, 0.37094011E-03_JPRB, 0.37093394E-03_JPRB, &
  & 0.37092582E-03_JPRB, 0.37091586E-03_JPRB, 0.37090419E-03_JPRB, 0.37089063E-03_JPRB, 0.37087550E-03_JPRB, 0.37085894E-03_JPRB, &
  & 0.37084115E-03_JPRB, 0.37082192E-03_JPRB, 0.37080128E-03_JPRB, 0.37077902E-03_JPRB, 0.37075541E-03_JPRB, 0.37073091E-03_JPRB, &
  & 0.37070553E-03_JPRB, 0.37067971E-03_JPRB, 0.37065372E-03_JPRB, 0.37062835E-03_JPRB, 0.37060404E-03_JPRB, 0.37058114E-03_JPRB, &
  & 0.37055969E-03_JPRB, 0.37053914E-03_JPRB, 0.37051953E-03_JPRB, 0.37050061E-03_JPRB, 0.37048236E-03_JPRB, 0.37046531E-03_JPRB, &
  & 0.37044971E-03_JPRB, 0.37043518E-03_JPRB, 0.37042069E-03_JPRB, 0.37039950E-03_JPRB /)

RGHG1(:,36, 5) = (/ &
  & 0.37020264E-03_JPRB, 0.37023018E-03_JPRB, 0.37024776E-03_JPRB, 0.37026484E-03_JPRB, 0.37028326E-03_JPRB, 0.37030427E-03_JPRB, &
  & 0.37032837E-03_JPRB, 0.37035544E-03_JPRB, 0.37038571E-03_JPRB, 0.37041918E-03_JPRB, 0.37045593E-03_JPRB, 0.37049604E-03_JPRB, &
  & 0.37053888E-03_JPRB, 0.37058382E-03_JPRB, 0.37062966E-03_JPRB, 0.37067532E-03_JPRB, 0.37071964E-03_JPRB, 0.37076132E-03_JPRB, &
  & 0.37079965E-03_JPRB, 0.37083362E-03_JPRB, 0.37086284E-03_JPRB, 0.37088725E-03_JPRB, 0.37090731E-03_JPRB, 0.37092302E-03_JPRB, &
  & 0.37093510E-03_JPRB, 0.37094421E-03_JPRB, 0.37095067E-03_JPRB, 0.37095515E-03_JPRB, 0.37095835E-03_JPRB, 0.37096033E-03_JPRB, &
  & 0.37096126E-03_JPRB, 0.37096121E-03_JPRB, 0.37096010E-03_JPRB, 0.37095771E-03_JPRB, 0.37095387E-03_JPRB, 0.37094858E-03_JPRB, &
  & 0.37094177E-03_JPRB, 0.37093330E-03_JPRB, 0.37092337E-03_JPRB, 0.37091179E-03_JPRB, 0.37089837E-03_JPRB, 0.37088335E-03_JPRB, &
  & 0.37086697E-03_JPRB, 0.37084927E-03_JPRB, 0.37083012E-03_JPRB, 0.37080955E-03_JPRB, 0.37078740E-03_JPRB, 0.37076432E-03_JPRB, &
  & 0.37074031E-03_JPRB, 0.37071563E-03_JPRB, 0.37069083E-03_JPRB, 0.37066656E-03_JPRB, 0.37064328E-03_JPRB, 0.37062145E-03_JPRB, &
  & 0.37060087E-03_JPRB, 0.37058134E-03_JPRB, 0.37056263E-03_JPRB, 0.37054461E-03_JPRB, 0.37052750E-03_JPRB, 0.37051149E-03_JPRB, &
  & 0.37049683E-03_JPRB, 0.37048323E-03_JPRB, 0.37046944E-03_JPRB, 0.37044912E-03_JPRB /)

RGHG1(:,37, 5) = (/ &
  & 0.37025064E-03_JPRB, 0.37027925E-03_JPRB, 0.37029770E-03_JPRB, 0.37031513E-03_JPRB, 0.37033358E-03_JPRB, 0.37035422E-03_JPRB, &
  & 0.37037721E-03_JPRB, 0.37040259E-03_JPRB, 0.37043047E-03_JPRB, 0.37046103E-03_JPRB, 0.37049488E-03_JPRB, 0.37053178E-03_JPRB, &
  & 0.37057154E-03_JPRB, 0.37061353E-03_JPRB, 0.37065666E-03_JPRB, 0.37069997E-03_JPRB, 0.37074237E-03_JPRB, 0.37078260E-03_JPRB, &
  & 0.37081997E-03_JPRB, 0.37085332E-03_JPRB, 0.37088201E-03_JPRB, 0.37090611E-03_JPRB, 0.37092526E-03_JPRB, 0.37094025E-03_JPRB, &
  & 0.37095125E-03_JPRB, 0.37095920E-03_JPRB, 0.37096476E-03_JPRB, 0.37096848E-03_JPRB, 0.37097099E-03_JPRB, 0.37097244E-03_JPRB, &
  & 0.37097282E-03_JPRB, 0.37097241E-03_JPRB, 0.37097110E-03_JPRB, 0.37096886E-03_JPRB, 0.37096554E-03_JPRB, 0.37096115E-03_JPRB, &
  & 0.37095568E-03_JPRB, 0.37094881E-03_JPRB, 0.37094054E-03_JPRB, 0.37093059E-03_JPRB, 0.37091871E-03_JPRB, 0.37090486E-03_JPRB, &
  & 0.37088952E-03_JPRB, 0.37087285E-03_JPRB, 0.37085480E-03_JPRB, 0.37083545E-03_JPRB, 0.37081470E-03_JPRB, 0.37079281E-03_JPRB, &
  & 0.37076994E-03_JPRB, 0.37074627E-03_JPRB, 0.37072247E-03_JPRB, 0.37069930E-03_JPRB, 0.37067709E-03_JPRB, 0.37065643E-03_JPRB, &
  & 0.37063705E-03_JPRB, 0.37061863E-03_JPRB, 0.37060093E-03_JPRB, 0.37058408E-03_JPRB, 0.37056804E-03_JPRB, 0.37055323E-03_JPRB, &
  & 0.37053972E-03_JPRB, 0.37052721E-03_JPRB, 0.37051449E-03_JPRB, 0.37049514E-03_JPRB /)

RGHG1(:,38, 5) = (/ &
  & 0.37029761E-03_JPRB, 0.37032709E-03_JPRB, 0.37034621E-03_JPRB, 0.37036394E-03_JPRB, 0.37038312E-03_JPRB, 0.37040323E-03_JPRB, &
  & 0.37042506E-03_JPRB, 0.37044860E-03_JPRB, 0.37047412E-03_JPRB, 0.37050198E-03_JPRB, 0.37053280E-03_JPRB, 0.37056650E-03_JPRB, &
  & 0.37060305E-03_JPRB, 0.37064176E-03_JPRB, 0.37068196E-03_JPRB, 0.37072267E-03_JPRB, 0.37076301E-03_JPRB, 0.37080186E-03_JPRB, &
  & 0.37083795E-03_JPRB, 0.37087052E-03_JPRB, 0.37089869E-03_JPRB, 0.37092203E-03_JPRB, 0.37094014E-03_JPRB, 0.37095364E-03_JPRB, &
  & 0.37096330E-03_JPRB, 0.37097005E-03_JPRB, 0.37097454E-03_JPRB, 0.37097745E-03_JPRB, 0.37097928E-03_JPRB, 0.37098033E-03_JPRB, &
  & 0.37098056E-03_JPRB, 0.37098018E-03_JPRB, 0.37097890E-03_JPRB, 0.37097686E-03_JPRB, 0.37097425E-03_JPRB, 0.37097069E-03_JPRB, &
  & 0.37096636E-03_JPRB, 0.37096106E-03_JPRB, 0.37095428E-03_JPRB, 0.37094578E-03_JPRB, 0.37093539E-03_JPRB, 0.37092291E-03_JPRB, &
  & 0.37090864E-03_JPRB, 0.37089293E-03_JPRB, 0.37087590E-03_JPRB, 0.37085760E-03_JPRB, 0.37083795E-03_JPRB, 0.37081706E-03_JPRB, &
  & 0.37079508E-03_JPRB, 0.37077235E-03_JPRB, 0.37074956E-03_JPRB, 0.37072742E-03_JPRB, 0.37070646E-03_JPRB, 0.37068699E-03_JPRB, &
  & 0.37066900E-03_JPRB, 0.37065177E-03_JPRB, 0.37063507E-03_JPRB, 0.37061929E-03_JPRB, 0.37060448E-03_JPRB, 0.37059101E-03_JPRB, &
  & 0.37057878E-03_JPRB, 0.37056743E-03_JPRB, 0.37055576E-03_JPRB, 0.37053792E-03_JPRB /)

RGHG1(:,39, 5) = (/ &
  & 0.37034351E-03_JPRB, 0.37037377E-03_JPRB, 0.37039272E-03_JPRB, 0.37041149E-03_JPRB, 0.37043061E-03_JPRB, 0.37045093E-03_JPRB, &
  & 0.37047183E-03_JPRB, 0.37049362E-03_JPRB, 0.37051673E-03_JPRB, 0.37054176E-03_JPRB, 0.37056938E-03_JPRB, 0.37060003E-03_JPRB, &
  & 0.37063335E-03_JPRB, 0.37066883E-03_JPRB, 0.37070600E-03_JPRB, 0.37074392E-03_JPRB, 0.37078190E-03_JPRB, 0.37081892E-03_JPRB, &
  & 0.37085367E-03_JPRB, 0.37088530E-03_JPRB, 0.37091263E-03_JPRB, 0.37093472E-03_JPRB, 0.37095125E-03_JPRB, 0.37096324E-03_JPRB, &
  & 0.37097128E-03_JPRB, 0.37097672E-03_JPRB, 0.37098024E-03_JPRB, 0.37098251E-03_JPRB, 0.37098399E-03_JPRB, 0.37098484E-03_JPRB, &
  & 0.37098493E-03_JPRB, 0.37098458E-03_JPRB, 0.37098344E-03_JPRB, 0.37098175E-03_JPRB, 0.37097963E-03_JPRB, 0.37097669E-03_JPRB, &
  & 0.37097331E-03_JPRB, 0.37096898E-03_JPRB, 0.37096371E-03_JPRB, 0.37095681E-03_JPRB, 0.37094808E-03_JPRB, 0.37093734E-03_JPRB, &
  & 0.37092436E-03_JPRB, 0.37090981E-03_JPRB, 0.37089371E-03_JPRB, 0.37087649E-03_JPRB, 0.37085783E-03_JPRB, 0.37083792E-03_JPRB, &
  & 0.37081679E-03_JPRB, 0.37079479E-03_JPRB, 0.37077279E-03_JPRB, 0.37075172E-03_JPRB, 0.37073196E-03_JPRB, 0.37071388E-03_JPRB, &
  & 0.37069694E-03_JPRB, 0.37068091E-03_JPRB, 0.37066551E-03_JPRB, 0.37065096E-03_JPRB, 0.37063757E-03_JPRB, 0.37062546E-03_JPRB, &
  & 0.37061455E-03_JPRB, 0.37060445E-03_JPRB, 0.37059389E-03_JPRB, 0.37057759E-03_JPRB /)

RGHG1(:,40, 5) = (/ &
  & 0.37038923E-03_JPRB, 0.37041868E-03_JPRB, 0.37043830E-03_JPRB, 0.37045687E-03_JPRB, 0.37047721E-03_JPRB, 0.37049726E-03_JPRB, &
  & 0.37051734E-03_JPRB, 0.37053743E-03_JPRB, 0.37055815E-03_JPRB, 0.37058035E-03_JPRB, 0.37060498E-03_JPRB, 0.37063233E-03_JPRB, &
  & 0.37066225E-03_JPRB, 0.37069459E-03_JPRB, 0.37072861E-03_JPRB, 0.37076380E-03_JPRB, 0.37079936E-03_JPRB, 0.37083434E-03_JPRB, &
  & 0.37086761E-03_JPRB, 0.37089793E-03_JPRB, 0.37092395E-03_JPRB, 0.37094430E-03_JPRB, 0.37095917E-03_JPRB, 0.37096947E-03_JPRB, &
  & 0.37097617E-03_JPRB, 0.37098068E-03_JPRB, 0.37098362E-03_JPRB, 0.37098554E-03_JPRB, 0.37098664E-03_JPRB, 0.37098731E-03_JPRB, &
  & 0.37098740E-03_JPRB, 0.37098705E-03_JPRB, 0.37098609E-03_JPRB, 0.37098464E-03_JPRB, 0.37098277E-03_JPRB, 0.37098030E-03_JPRB, &
  & 0.37097753E-03_JPRB, 0.37097404E-03_JPRB, 0.37096973E-03_JPRB, 0.37096418E-03_JPRB, 0.37095696E-03_JPRB, 0.37094785E-03_JPRB, &
  & 0.37093679E-03_JPRB, 0.37092378E-03_JPRB, 0.37090905E-03_JPRB, 0.37089281E-03_JPRB, 0.37087512E-03_JPRB, 0.37085611E-03_JPRB, &
  & 0.37083583E-03_JPRB, 0.37081476E-03_JPRB, 0.37079351E-03_JPRB, 0.37077325E-03_JPRB, 0.37075469E-03_JPRB, 0.37073781E-03_JPRB, &
  & 0.37072203E-03_JPRB, 0.37070719E-03_JPRB, 0.37069304E-03_JPRB, 0.37067971E-03_JPRB, 0.37066749E-03_JPRB, 0.37065678E-03_JPRB, &
  & 0.37064715E-03_JPRB, 0.37063815E-03_JPRB, 0.37062887E-03_JPRB, 0.37061426E-03_JPRB /)

RGHG1(:,41, 5) = (/ &
  & 0.37043419E-03_JPRB, 0.37046324E-03_JPRB, 0.37048184E-03_JPRB, 0.37050145E-03_JPRB, 0.37052174E-03_JPRB, 0.37054229E-03_JPRB, &
  & 0.37056158E-03_JPRB, 0.37057998E-03_JPRB, 0.37059825E-03_JPRB, 0.37061769E-03_JPRB, 0.37063920E-03_JPRB, 0.37066324E-03_JPRB, &
  & 0.37069010E-03_JPRB, 0.37071930E-03_JPRB, 0.37075035E-03_JPRB, 0.37078271E-03_JPRB, 0.37081551E-03_JPRB, 0.37084831E-03_JPRB, &
  & 0.37087986E-03_JPRB, 0.37090870E-03_JPRB, 0.37093295E-03_JPRB, 0.37095163E-03_JPRB, 0.37096484E-03_JPRB, 0.37097360E-03_JPRB, &
  & 0.37097940E-03_JPRB, 0.37098321E-03_JPRB, 0.37098560E-03_JPRB, 0.37098723E-03_JPRB, 0.37098821E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098888E-03_JPRB, 0.37098859E-03_JPRB, 0.37098781E-03_JPRB, 0.37098638E-03_JPRB, 0.37098475E-03_JPRB, 0.37098269E-03_JPRB, &
  & 0.37098015E-03_JPRB, 0.37097730E-03_JPRB, 0.37097366E-03_JPRB, 0.37096909E-03_JPRB, 0.37096324E-03_JPRB, 0.37095585E-03_JPRB, &
  & 0.37094668E-03_JPRB, 0.37093548E-03_JPRB, 0.37092224E-03_JPRB, 0.37090728E-03_JPRB, 0.37089060E-03_JPRB, 0.37087241E-03_JPRB, &
  & 0.37085282E-03_JPRB, 0.37083233E-03_JPRB, 0.37081187E-03_JPRB, 0.37079267E-03_JPRB, 0.37077506E-03_JPRB, 0.37075928E-03_JPRB, &
  & 0.37074488E-03_JPRB, 0.37073111E-03_JPRB, 0.37071807E-03_JPRB, 0.37070591E-03_JPRB, 0.37069502E-03_JPRB, 0.37068554E-03_JPRB, &
  & 0.37067721E-03_JPRB, 0.37066941E-03_JPRB, 0.37066115E-03_JPRB, 0.37064814E-03_JPRB /)

RGHG1(:,42, 5) = (/ &
  & 0.37047948E-03_JPRB, 0.37050684E-03_JPRB, 0.37052535E-03_JPRB, 0.37054444E-03_JPRB, 0.37056551E-03_JPRB, 0.37058588E-03_JPRB, &
  & 0.37060442E-03_JPRB, 0.37062101E-03_JPRB, 0.37063708E-03_JPRB, 0.37065375E-03_JPRB, 0.37067221E-03_JPRB, 0.37069316E-03_JPRB, &
  & 0.37071694E-03_JPRB, 0.37074310E-03_JPRB, 0.37077113E-03_JPRB, 0.37080073E-03_JPRB, 0.37083120E-03_JPRB, 0.37086167E-03_JPRB, &
  & 0.37089112E-03_JPRB, 0.37091810E-03_JPRB, 0.37094060E-03_JPRB, 0.37095745E-03_JPRB, 0.37096906E-03_JPRB, 0.37097672E-03_JPRB, &
  & 0.37098170E-03_JPRB, 0.37098496E-03_JPRB, 0.37098702E-03_JPRB, 0.37098851E-03_JPRB, 0.37098935E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37098967E-03_JPRB, 0.37098897E-03_JPRB, 0.37098766E-03_JPRB, 0.37098618E-03_JPRB, 0.37098431E-03_JPRB, &
  & 0.37098207E-03_JPRB, 0.37097948E-03_JPRB, 0.37097643E-03_JPRB, 0.37097262E-03_JPRB, 0.37096790E-03_JPRB, 0.37096196E-03_JPRB, &
  & 0.37095451E-03_JPRB, 0.37094526E-03_JPRB, 0.37093385E-03_JPRB, 0.37092040E-03_JPRB, 0.37090515E-03_JPRB, 0.37088795E-03_JPRB, &
  & 0.37086912E-03_JPRB, 0.37084930E-03_JPRB, 0.37082948E-03_JPRB, 0.37081083E-03_JPRB, 0.37079430E-03_JPRB, 0.37077948E-03_JPRB, &
  & 0.37076604E-03_JPRB, 0.37075341E-03_JPRB, 0.37074144E-03_JPRB, 0.37073041E-03_JPRB, 0.37072069E-03_JPRB, 0.37071243E-03_JPRB, &
  & 0.37070518E-03_JPRB, 0.37069834E-03_JPRB, 0.37069112E-03_JPRB, 0.37067960E-03_JPRB /)

RGHG1(:,43, 5) = (/ &
  & 0.37052482E-03_JPRB, 0.37055087E-03_JPRB, 0.37056807E-03_JPRB, 0.37058693E-03_JPRB, 0.37060809E-03_JPRB, 0.37062829E-03_JPRB, &
  & 0.37064569E-03_JPRB, 0.37066068E-03_JPRB, 0.37067453E-03_JPRB, 0.37068874E-03_JPRB, 0.37070428E-03_JPRB, 0.37072232E-03_JPRB, &
  & 0.37074302E-03_JPRB, 0.37076633E-03_JPRB, 0.37079171E-03_JPRB, 0.37081863E-03_JPRB, 0.37084648E-03_JPRB, 0.37087459E-03_JPRB, &
  & 0.37090183E-03_JPRB, 0.37092669E-03_JPRB, 0.37094706E-03_JPRB, 0.37096205E-03_JPRB, 0.37097232E-03_JPRB, 0.37097902E-03_JPRB, &
  & 0.37098333E-03_JPRB, 0.37098618E-03_JPRB, 0.37098810E-03_JPRB, 0.37098935E-03_JPRB, 0.37099016E-03_JPRB, 0.37099066E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099054E-03_JPRB, 0.37098987E-03_JPRB, 0.37098865E-03_JPRB, 0.37098725E-03_JPRB, 0.37098557E-03_JPRB, &
  & 0.37098350E-03_JPRB, 0.37098117E-03_JPRB, 0.37097849E-03_JPRB, 0.37097529E-03_JPRB, 0.37097139E-03_JPRB, 0.37096668E-03_JPRB, &
  & 0.37096080E-03_JPRB, 0.37095341E-03_JPRB, 0.37094418E-03_JPRB, 0.37093274E-03_JPRB, 0.37091898E-03_JPRB, 0.37090285E-03_JPRB, &
  & 0.37088507E-03_JPRB, 0.37086592E-03_JPRB, 0.37084668E-03_JPRB, 0.37082878E-03_JPRB, 0.37081307E-03_JPRB, 0.37079927E-03_JPRB, &
  & 0.37078693E-03_JPRB, 0.37077529E-03_JPRB, 0.37076423E-03_JPRB, 0.37075428E-03_JPRB, 0.37074561E-03_JPRB, 0.37073821E-03_JPRB, &
  & 0.37073187E-03_JPRB, 0.37072590E-03_JPRB, 0.37071944E-03_JPRB, 0.37070914E-03_JPRB /)

RGHG1(:,44, 5) = (/ &
  & 0.37057034E-03_JPRB, 0.37059403E-03_JPRB, 0.37061080E-03_JPRB, 0.37062875E-03_JPRB, 0.37064971E-03_JPRB, 0.37066959E-03_JPRB, &
  & 0.37068583E-03_JPRB, 0.37069918E-03_JPRB, 0.37071100E-03_JPRB, 0.37072279E-03_JPRB, 0.37073571E-03_JPRB, 0.37075079E-03_JPRB, &
  & 0.37076877E-03_JPRB, 0.37078938E-03_JPRB, 0.37081225E-03_JPRB, 0.37083661E-03_JPRB, 0.37086205E-03_JPRB, 0.37088757E-03_JPRB, &
  & 0.37091237E-03_JPRB, 0.37093466E-03_JPRB, 0.37095285E-03_JPRB, 0.37096604E-03_JPRB, 0.37097506E-03_JPRB, 0.37098088E-03_JPRB, &
  & 0.37098461E-03_JPRB, 0.37098720E-03_JPRB, 0.37098891E-03_JPRB, 0.37099005E-03_JPRB, 0.37099081E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099136E-03_JPRB, 0.37099130E-03_JPRB, 0.37099069E-03_JPRB, 0.37098952E-03_JPRB, 0.37098821E-03_JPRB, 0.37098670E-03_JPRB, &
  & 0.37098472E-03_JPRB, 0.37098257E-03_JPRB, 0.37098018E-03_JPRB, 0.37097745E-03_JPRB, 0.37097425E-03_JPRB, 0.37097040E-03_JPRB, &
  & 0.37096575E-03_JPRB, 0.37096010E-03_JPRB, 0.37095303E-03_JPRB, 0.37094386E-03_JPRB, 0.37093207E-03_JPRB, 0.37091770E-03_JPRB, &
  & 0.37090102E-03_JPRB, 0.37088274E-03_JPRB, 0.37086415E-03_JPRB, 0.37084715E-03_JPRB, 0.37083225E-03_JPRB, 0.37081941E-03_JPRB, &
  & 0.37080795E-03_JPRB, 0.37079724E-03_JPRB, 0.37078714E-03_JPRB, 0.37077803E-03_JPRB, 0.37077020E-03_JPRB, 0.37076365E-03_JPRB, &
  & 0.37075806E-03_JPRB, 0.37075276E-03_JPRB, 0.37074712E-03_JPRB, 0.37073795E-03_JPRB /)

RGHG1(:,45, 5) = (/ &
  & 0.37061481E-03_JPRB, 0.37063760E-03_JPRB, 0.37065244E-03_JPRB, 0.37067005E-03_JPRB, 0.37069031E-03_JPRB, 0.37070955E-03_JPRB, &
  & 0.37072459E-03_JPRB, 0.37073638E-03_JPRB, 0.37074636E-03_JPRB, 0.37075605E-03_JPRB, 0.37076668E-03_JPRB, 0.37077913E-03_JPRB, &
  & 0.37079453E-03_JPRB, 0.37081284E-03_JPRB, 0.37083335E-03_JPRB, 0.37085547E-03_JPRB, 0.37087829E-03_JPRB, 0.37090119E-03_JPRB, &
  & 0.37092296E-03_JPRB, 0.37094246E-03_JPRB, 0.37095795E-03_JPRB, 0.37096941E-03_JPRB, 0.37097718E-03_JPRB, 0.37098236E-03_JPRB, &
  & 0.37098574E-03_JPRB, 0.37098795E-03_JPRB, 0.37098955E-03_JPRB, 0.37099069E-03_JPRB, 0.37099147E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099188E-03_JPRB, 0.37099136E-03_JPRB, 0.37099028E-03_JPRB, 0.37098909E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098580E-03_JPRB, 0.37098382E-03_JPRB, 0.37098164E-03_JPRB, 0.37097922E-03_JPRB, 0.37097652E-03_JPRB, 0.37097343E-03_JPRB, &
  & 0.37096976E-03_JPRB, 0.37096566E-03_JPRB, 0.37096051E-03_JPRB, 0.37095361E-03_JPRB, 0.37094427E-03_JPRB, 0.37093204E-03_JPRB, &
  & 0.37091685E-03_JPRB, 0.37089974E-03_JPRB, 0.37088228E-03_JPRB, 0.37086604E-03_JPRB, 0.37085218E-03_JPRB, 0.37084025E-03_JPRB, &
  & 0.37082983E-03_JPRB, 0.37082002E-03_JPRB, 0.37081071E-03_JPRB, 0.37080236E-03_JPRB, 0.37079523E-03_JPRB, 0.37078941E-03_JPRB, &
  & 0.37078440E-03_JPRB, 0.37077980E-03_JPRB, 0.37077471E-03_JPRB, 0.37076636E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART10',0,ZHOOK_HANDLE)



RGHG1(:,46, 5) = (/ &
  & 0.37065940E-03_JPRB, 0.37067934E-03_JPRB, 0.37069412E-03_JPRB, 0.37070998E-03_JPRB, 0.37072983E-03_JPRB, 0.37074834E-03_JPRB, &
  & 0.37076237E-03_JPRB, 0.37077285E-03_JPRB, 0.37078129E-03_JPRB, 0.37078929E-03_JPRB, 0.37079788E-03_JPRB, 0.37080821E-03_JPRB, &
  & 0.37082113E-03_JPRB, 0.37083720E-03_JPRB, 0.37085553E-03_JPRB, 0.37087520E-03_JPRB, 0.37089537E-03_JPRB, 0.37091511E-03_JPRB, &
  & 0.37093367E-03_JPRB, 0.37094962E-03_JPRB, 0.37096266E-03_JPRB, 0.37097230E-03_JPRB, 0.37097908E-03_JPRB, 0.37098359E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098865E-03_JPRB, 0.37099016E-03_JPRB, 0.37099124E-03_JPRB, 0.37099197E-03_JPRB, 0.37099246E-03_JPRB, &
  & 0.37099252E-03_JPRB, 0.37099252E-03_JPRB, 0.37099206E-03_JPRB, 0.37099092E-03_JPRB, 0.37098982E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37098676E-03_JPRB, 0.37098490E-03_JPRB, 0.37098289E-03_JPRB, 0.37098065E-03_JPRB, 0.37097835E-03_JPRB, 0.37097587E-03_JPRB, &
  & 0.37097302E-03_JPRB, 0.37097002E-03_JPRB, 0.37096636E-03_JPRB, 0.37096158E-03_JPRB, 0.37095477E-03_JPRB, 0.37094511E-03_JPRB, &
  & 0.37093236E-03_JPRB, 0.37091694E-03_JPRB, 0.37090073E-03_JPRB, 0.37088571E-03_JPRB, 0.37087279E-03_JPRB, 0.37086196E-03_JPRB, &
  & 0.37085224E-03_JPRB, 0.37084337E-03_JPRB, 0.37083487E-03_JPRB, 0.37082724E-03_JPRB, 0.37082078E-03_JPRB, 0.37081569E-03_JPRB, &
  & 0.37081132E-03_JPRB, 0.37080713E-03_JPRB, 0.37080253E-03_JPRB, 0.37079482E-03_JPRB /)

RGHG1(:,47, 5) = (/ &
  & 0.37070154E-03_JPRB, 0.37072127E-03_JPRB, 0.37073393E-03_JPRB, 0.37074988E-03_JPRB, 0.37076839E-03_JPRB, 0.37078603E-03_JPRB, &
  & 0.37079895E-03_JPRB, 0.37080818E-03_JPRB, 0.37081543E-03_JPRB, 0.37082200E-03_JPRB, 0.37082905E-03_JPRB, 0.37083743E-03_JPRB, &
  & 0.37084846E-03_JPRB, 0.37086237E-03_JPRB, 0.37087858E-03_JPRB, 0.37089593E-03_JPRB, 0.37091310E-03_JPRB, 0.37092934E-03_JPRB, &
  & 0.37094386E-03_JPRB, 0.37095646E-03_JPRB, 0.37096679E-03_JPRB, 0.37097480E-03_JPRB, 0.37098056E-03_JPRB, 0.37098464E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098926E-03_JPRB, 0.37099066E-03_JPRB, 0.37099168E-03_JPRB, 0.37099241E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099310E-03_JPRB, 0.37099310E-03_JPRB, 0.37099264E-03_JPRB, 0.37099165E-03_JPRB, 0.37099054E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098755E-03_JPRB, 0.37098580E-03_JPRB, 0.37098385E-03_JPRB, 0.37098181E-03_JPRB, 0.37097986E-03_JPRB, 0.37097780E-03_JPRB, &
  & 0.37097558E-03_JPRB, 0.37097334E-03_JPRB, 0.37097081E-03_JPRB, 0.37096764E-03_JPRB, 0.37096298E-03_JPRB, 0.37095614E-03_JPRB, &
  & 0.37094631E-03_JPRB, 0.37093341E-03_JPRB, 0.37091912E-03_JPRB, 0.37090544E-03_JPRB, 0.37089401E-03_JPRB, 0.37088417E-03_JPRB, &
  & 0.37087558E-03_JPRB, 0.37086738E-03_JPRB, 0.37085975E-03_JPRB, 0.37085277E-03_JPRB, 0.37084692E-03_JPRB, 0.37084226E-03_JPRB, &
  & 0.37083836E-03_JPRB, 0.37083466E-03_JPRB, 0.37083047E-03_JPRB, 0.37082346E-03_JPRB /)

RGHG1(:,48, 5) = (/ &
  & 0.37074264E-03_JPRB, 0.37076019E-03_JPRB, 0.37077337E-03_JPRB, 0.37078772E-03_JPRB, 0.37080600E-03_JPRB, 0.37082288E-03_JPRB, &
  & 0.37083504E-03_JPRB, 0.37084339E-03_JPRB, 0.37084954E-03_JPRB, 0.37085509E-03_JPRB, 0.37086089E-03_JPRB, 0.37086784E-03_JPRB, &
  & 0.37087692E-03_JPRB, 0.37088883E-03_JPRB, 0.37090268E-03_JPRB, 0.37091709E-03_JPRB, 0.37093071E-03_JPRB, 0.37094275E-03_JPRB, &
  & 0.37095309E-03_JPRB, 0.37096225E-03_JPRB, 0.37097023E-03_JPRB, 0.37097675E-03_JPRB, 0.37098181E-03_JPRB, 0.37098548E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098979E-03_JPRB, 0.37099110E-03_JPRB, 0.37099217E-03_JPRB, 0.37099293E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099357E-03_JPRB, 0.37099357E-03_JPRB, 0.37099313E-03_JPRB, 0.37099229E-03_JPRB, 0.37099121E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098664E-03_JPRB, 0.37098478E-03_JPRB, 0.37098286E-03_JPRB, 0.37098114E-03_JPRB, 0.37097945E-03_JPRB, &
  & 0.37097768E-03_JPRB, 0.37097605E-03_JPRB, 0.37097425E-03_JPRB, 0.37097218E-03_JPRB, 0.37096909E-03_JPRB, 0.37096450E-03_JPRB, &
  & 0.37095760E-03_JPRB, 0.37094805E-03_JPRB, 0.37093661E-03_JPRB, 0.37092532E-03_JPRB, 0.37091540E-03_JPRB, 0.37090696E-03_JPRB, &
  & 0.37089924E-03_JPRB, 0.37089194E-03_JPRB, 0.37088495E-03_JPRB, 0.37087861E-03_JPRB, 0.37087340E-03_JPRB, 0.37086918E-03_JPRB, &
  & 0.37086560E-03_JPRB, 0.37086231E-03_JPRB, 0.37085847E-03_JPRB, 0.37085204E-03_JPRB /)

RGHG1(:,49, 5) = (/ &
  & 0.37078164E-03_JPRB, 0.37079884E-03_JPRB, 0.37081103E-03_JPRB, 0.37082552E-03_JPRB, 0.37084299E-03_JPRB, 0.37085940E-03_JPRB, &
  & 0.37087069E-03_JPRB, 0.37087817E-03_JPRB, 0.37088353E-03_JPRB, 0.37088821E-03_JPRB, 0.37089281E-03_JPRB, 0.37089846E-03_JPRB, &
  & 0.37090585E-03_JPRB, 0.37091531E-03_JPRB, 0.37092622E-03_JPRB, 0.37093658E-03_JPRB, 0.37094601E-03_JPRB, 0.37095393E-03_JPRB, &
  & 0.37096077E-03_JPRB, 0.37096703E-03_JPRB, 0.37097296E-03_JPRB, 0.37097832E-03_JPRB, 0.37098277E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37099014E-03_JPRB, 0.37099147E-03_JPRB, 0.37099252E-03_JPRB, 0.37099328E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099401E-03_JPRB, 0.37099363E-03_JPRB, 0.37099296E-03_JPRB, 0.37099188E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37098894E-03_JPRB, 0.37098734E-03_JPRB, 0.37098565E-03_JPRB, 0.37098388E-03_JPRB, 0.37098228E-03_JPRB, 0.37098085E-03_JPRB, &
  & 0.37097943E-03_JPRB, 0.37097809E-03_JPRB, 0.37097689E-03_JPRB, 0.37097547E-03_JPRB, 0.37097349E-03_JPRB, 0.37097052E-03_JPRB, &
  & 0.37096604E-03_JPRB, 0.37095966E-03_JPRB, 0.37095181E-03_JPRB, 0.37094354E-03_JPRB, 0.37093589E-03_JPRB, 0.37092913E-03_JPRB, &
  & 0.37092259E-03_JPRB, 0.37091627E-03_JPRB, 0.37090998E-03_JPRB, 0.37090428E-03_JPRB, 0.37089956E-03_JPRB, 0.37089578E-03_JPRB, &
  & 0.37089255E-03_JPRB, 0.37088952E-03_JPRB, 0.37088615E-03_JPRB, 0.37088018E-03_JPRB /)

RGHG1(:,50, 5) = (/ &
  & 0.37081834E-03_JPRB, 0.37083609E-03_JPRB, 0.37084764E-03_JPRB, 0.37086193E-03_JPRB, 0.37087893E-03_JPRB, 0.37089433E-03_JPRB, &
  & 0.37090445E-03_JPRB, 0.37091071E-03_JPRB, 0.37091514E-03_JPRB, 0.37091854E-03_JPRB, 0.37092215E-03_JPRB, 0.37092611E-03_JPRB, &
  & 0.37093146E-03_JPRB, 0.37093792E-03_JPRB, 0.37094497E-03_JPRB, 0.37095166E-03_JPRB, 0.37095731E-03_JPRB, 0.37096220E-03_JPRB, &
  & 0.37096647E-03_JPRB, 0.37097081E-03_JPRB, 0.37097523E-03_JPRB, 0.37097966E-03_JPRB, 0.37098353E-03_JPRB, 0.37098659E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37099048E-03_JPRB, 0.37099182E-03_JPRB, 0.37099278E-03_JPRB, 0.37099360E-03_JPRB, 0.37099424E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099444E-03_JPRB, 0.37099404E-03_JPRB, 0.37099340E-03_JPRB, 0.37099235E-03_JPRB, 0.37099110E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37098804E-03_JPRB, 0.37098644E-03_JPRB, 0.37098472E-03_JPRB, 0.37098318E-03_JPRB, 0.37098196E-03_JPRB, &
  & 0.37098074E-03_JPRB, 0.37097975E-03_JPRB, 0.37097890E-03_JPRB, 0.37097800E-03_JPRB, 0.37097663E-03_JPRB, 0.37097471E-03_JPRB, &
  & 0.37097192E-03_JPRB, 0.37096802E-03_JPRB, 0.37096324E-03_JPRB, 0.37095801E-03_JPRB, 0.37095329E-03_JPRB, 0.37094852E-03_JPRB, &
  & 0.37094392E-03_JPRB, 0.37093897E-03_JPRB, 0.37093388E-03_JPRB, 0.37092899E-03_JPRB, 0.37092494E-03_JPRB, 0.37092157E-03_JPRB, &
  & 0.37091874E-03_JPRB, 0.37091598E-03_JPRB, 0.37091289E-03_JPRB, 0.37090731E-03_JPRB /)

RGHG1(:,51, 5) = (/ &
  & 0.37085358E-03_JPRB, 0.37086944E-03_JPRB, 0.37088228E-03_JPRB, 0.37089479E-03_JPRB, 0.37091086E-03_JPRB, 0.37092360E-03_JPRB, &
  & 0.37093158E-03_JPRB, 0.37093621E-03_JPRB, 0.37093915E-03_JPRB, 0.37094153E-03_JPRB, 0.37094360E-03_JPRB, 0.37094625E-03_JPRB, &
  & 0.37094930E-03_JPRB, 0.37095312E-03_JPRB, 0.37095739E-03_JPRB, 0.37096138E-03_JPRB, 0.37096484E-03_JPRB, 0.37096778E-03_JPRB, &
  & 0.37097067E-03_JPRB, 0.37097360E-03_JPRB, 0.37097701E-03_JPRB, 0.37098059E-03_JPRB, 0.37098402E-03_JPRB, 0.37098699E-03_JPRB, &
  & 0.37098923E-03_JPRB, 0.37099089E-03_JPRB, 0.37099220E-03_JPRB, 0.37099316E-03_JPRB, 0.37099398E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099485E-03_JPRB, 0.37099444E-03_JPRB, 0.37099386E-03_JPRB, 0.37099293E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099022E-03_JPRB, 0.37098871E-03_JPRB, 0.37098708E-03_JPRB, 0.37098539E-03_JPRB, 0.37098402E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098196E-03_JPRB, 0.37098123E-03_JPRB, 0.37098065E-03_JPRB, 0.37097995E-03_JPRB, 0.37097896E-03_JPRB, 0.37097762E-03_JPRB, &
  & 0.37097587E-03_JPRB, 0.37097349E-03_JPRB, 0.37097081E-03_JPRB, 0.37096816E-03_JPRB, 0.37096540E-03_JPRB, 0.37096295E-03_JPRB, &
  & 0.37096028E-03_JPRB, 0.37095731E-03_JPRB, 0.37095393E-03_JPRB, 0.37095050E-03_JPRB, 0.37094735E-03_JPRB, 0.37094479E-03_JPRB, &
  & 0.37094252E-03_JPRB, 0.37094031E-03_JPRB, 0.37093746E-03_JPRB, 0.37093248E-03_JPRB /)

RGHG1(:,52, 5) = (/ &
  & 0.37088312E-03_JPRB, 0.37090061E-03_JPRB, 0.37091010E-03_JPRB, 0.37092273E-03_JPRB, 0.37093472E-03_JPRB, 0.37094421E-03_JPRB, &
  & 0.37094939E-03_JPRB, 0.37095218E-03_JPRB, 0.37095405E-03_JPRB, 0.37095539E-03_JPRB, 0.37095684E-03_JPRB, 0.37095824E-03_JPRB, &
  & 0.37096016E-03_JPRB, 0.37096237E-03_JPRB, 0.37096493E-03_JPRB, 0.37096749E-03_JPRB, 0.37096968E-03_JPRB, 0.37097174E-03_JPRB, &
  & 0.37097366E-03_JPRB, 0.37097585E-03_JPRB, 0.37097832E-03_JPRB, 0.37098135E-03_JPRB, 0.37098455E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37099127E-03_JPRB, 0.37099258E-03_JPRB, 0.37099345E-03_JPRB, 0.37099427E-03_JPRB, 0.37099488E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099526E-03_JPRB, 0.37099485E-03_JPRB, 0.37099433E-03_JPRB, 0.37099345E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37098932E-03_JPRB, 0.37098769E-03_JPRB, 0.37098615E-03_JPRB, 0.37098484E-03_JPRB, 0.37098391E-03_JPRB, &
  & 0.37098306E-03_JPRB, 0.37098251E-03_JPRB, 0.37098207E-03_JPRB, 0.37098155E-03_JPRB, 0.37098079E-03_JPRB, 0.37097989E-03_JPRB, &
  & 0.37097867E-03_JPRB, 0.37097718E-03_JPRB, 0.37097570E-03_JPRB, 0.37097419E-03_JPRB, 0.37097296E-03_JPRB, 0.37097165E-03_JPRB, &
  & 0.37097037E-03_JPRB, 0.37096895E-03_JPRB, 0.37096729E-03_JPRB, 0.37096543E-03_JPRB, 0.37096371E-03_JPRB, 0.37096208E-03_JPRB, &
  & 0.37096074E-03_JPRB, 0.37095917E-03_JPRB, 0.37095731E-03_JPRB, 0.37095306E-03_JPRB /)

RGHG1(:,53, 5) = (/ &
  & 0.37091013E-03_JPRB, 0.37092305E-03_JPRB, 0.37093333E-03_JPRB, 0.37094153E-03_JPRB, 0.37095096E-03_JPRB, 0.37095696E-03_JPRB, &
  & 0.37096016E-03_JPRB, 0.37096188E-03_JPRB, 0.37096295E-03_JPRB, 0.37096377E-03_JPRB, 0.37096455E-03_JPRB, 0.37096551E-03_JPRB, &
  & 0.37096650E-03_JPRB, 0.37096790E-03_JPRB, 0.37096959E-03_JPRB, 0.37097128E-03_JPRB, 0.37097291E-03_JPRB, 0.37097439E-03_JPRB, &
  & 0.37097593E-03_JPRB, 0.37097748E-03_JPRB, 0.37097960E-03_JPRB, 0.37098213E-03_JPRB, 0.37098496E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37099153E-03_JPRB, 0.37099290E-03_JPRB, 0.37099377E-03_JPRB, 0.37099459E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099555E-03_JPRB, 0.37099558E-03_JPRB, 0.37099526E-03_JPRB, 0.37099468E-03_JPRB, 0.37099392E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37098993E-03_JPRB, 0.37098836E-03_JPRB, 0.37098685E-03_JPRB, 0.37098557E-03_JPRB, 0.37098484E-03_JPRB, &
  & 0.37098411E-03_JPRB, 0.37098370E-03_JPRB, 0.37098341E-03_JPRB, 0.37098295E-03_JPRB, 0.37098234E-03_JPRB, 0.37098158E-03_JPRB, &
  & 0.37098068E-03_JPRB, 0.37097972E-03_JPRB, 0.37097884E-03_JPRB, 0.37097814E-03_JPRB, 0.37097745E-03_JPRB, 0.37097686E-03_JPRB, &
  & 0.37097619E-03_JPRB, 0.37097553E-03_JPRB, 0.37097474E-03_JPRB, 0.37097384E-03_JPRB, 0.37097296E-03_JPRB, 0.37097230E-03_JPRB, &
  & 0.37097157E-03_JPRB, 0.37097087E-03_JPRB, 0.37096970E-03_JPRB, 0.37096732E-03_JPRB /)

RGHG1(:,54, 5) = (/ &
  & 0.37092992E-03_JPRB, 0.37094209E-03_JPRB, 0.37094796E-03_JPRB, 0.37095486E-03_JPRB, 0.37096068E-03_JPRB, 0.37096464E-03_JPRB, &
  & 0.37096662E-03_JPRB, 0.37096767E-03_JPRB, 0.37096837E-03_JPRB, 0.37096883E-03_JPRB, 0.37096933E-03_JPRB, 0.37096985E-03_JPRB, &
  & 0.37097058E-03_JPRB, 0.37097154E-03_JPRB, 0.37097279E-03_JPRB, 0.37097407E-03_JPRB, 0.37097526E-03_JPRB, 0.37097646E-03_JPRB, &
  & 0.37097765E-03_JPRB, 0.37097902E-03_JPRB, 0.37098068E-03_JPRB, 0.37098286E-03_JPRB, 0.37098542E-03_JPRB, 0.37098792E-03_JPRB, &
  & 0.37099016E-03_JPRB, 0.37099182E-03_JPRB, 0.37099313E-03_JPRB, 0.37099404E-03_JPRB, 0.37099491E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099599E-03_JPRB, 0.37099564E-03_JPRB, 0.37099497E-03_JPRB, 0.37099427E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099034E-03_JPRB, 0.37098891E-03_JPRB, 0.37098743E-03_JPRB, 0.37098641E-03_JPRB, 0.37098577E-03_JPRB, &
  & 0.37098504E-03_JPRB, 0.37098475E-03_JPRB, 0.37098455E-03_JPRB, 0.37098417E-03_JPRB, 0.37098367E-03_JPRB, 0.37098309E-03_JPRB, &
  & 0.37098234E-03_JPRB, 0.37098167E-03_JPRB, 0.37098111E-03_JPRB, 0.37098059E-03_JPRB, 0.37098027E-03_JPRB, 0.37097989E-03_JPRB, &
  & 0.37097960E-03_JPRB, 0.37097925E-03_JPRB, 0.37097884E-03_JPRB, 0.37097838E-03_JPRB, 0.37097797E-03_JPRB, 0.37097762E-03_JPRB, &
  & 0.37097733E-03_JPRB, 0.37097701E-03_JPRB, 0.37097672E-03_JPRB, 0.37097628E-03_JPRB /)

RGHG1(:,55, 5) = (/ &
  & 0.37094473E-03_JPRB, 0.37095346E-03_JPRB, 0.37095897E-03_JPRB, 0.37096310E-03_JPRB, 0.37096717E-03_JPRB, 0.37096968E-03_JPRB, &
  & 0.37097087E-03_JPRB, 0.37097157E-03_JPRB, 0.37097203E-03_JPRB, 0.37097238E-03_JPRB, 0.37097267E-03_JPRB, 0.37097302E-03_JPRB, &
  & 0.37097343E-03_JPRB, 0.37097407E-03_JPRB, 0.37097500E-03_JPRB, 0.37097602E-03_JPRB, 0.37097704E-03_JPRB, 0.37097809E-03_JPRB, &
  & 0.37097908E-03_JPRB, 0.37098012E-03_JPRB, 0.37098161E-03_JPRB, 0.37098362E-03_JPRB, 0.37098589E-03_JPRB, 0.37098836E-03_JPRB, &
  & 0.37099054E-03_JPRB, 0.37099214E-03_JPRB, 0.37099348E-03_JPRB, 0.37099438E-03_JPRB, 0.37099520E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099619E-03_JPRB, 0.37099631E-03_JPRB, 0.37099596E-03_JPRB, 0.37099535E-03_JPRB, 0.37099471E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099235E-03_JPRB, 0.37099095E-03_JPRB, 0.37098952E-03_JPRB, 0.37098804E-03_JPRB, 0.37098705E-03_JPRB, 0.37098650E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098562E-03_JPRB, 0.37098554E-03_JPRB, 0.37098525E-03_JPRB, 0.37098490E-03_JPRB, 0.37098434E-03_JPRB, &
  & 0.37098373E-03_JPRB, 0.37098318E-03_JPRB, 0.37098269E-03_JPRB, 0.37098236E-03_JPRB, 0.37098210E-03_JPRB, 0.37098193E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098158E-03_JPRB, 0.37098132E-03_JPRB, 0.37098108E-03_JPRB, 0.37098085E-03_JPRB, 0.37098071E-03_JPRB, &
  & 0.37098059E-03_JPRB, 0.37098044E-03_JPRB, 0.37098021E-03_JPRB, 0.37097977E-03_JPRB /)

RGHG1(:,56, 5) = (/ &
  & 0.37095736E-03_JPRB, 0.37096301E-03_JPRB, 0.37096592E-03_JPRB, 0.37096889E-03_JPRB, 0.37097148E-03_JPRB, 0.37097314E-03_JPRB, &
  & 0.37097390E-03_JPRB, 0.37097436E-03_JPRB, 0.37097468E-03_JPRB, 0.37097489E-03_JPRB, 0.37097512E-03_JPRB, 0.37097529E-03_JPRB, &
  & 0.37097564E-03_JPRB, 0.37097611E-03_JPRB, 0.37097681E-03_JPRB, 0.37097768E-03_JPRB, 0.37097849E-03_JPRB, 0.37097937E-03_JPRB, &
  & 0.37098024E-03_JPRB, 0.37098123E-03_JPRB, 0.37098257E-03_JPRB, 0.37098423E-03_JPRB, 0.37098644E-03_JPRB, 0.37098868E-03_JPRB, &
  & 0.37099083E-03_JPRB, 0.37099249E-03_JPRB, 0.37099374E-03_JPRB, 0.37099468E-03_JPRB, 0.37099552E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099665E-03_JPRB, 0.37099628E-03_JPRB, 0.37099578E-03_JPRB, 0.37099511E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099159E-03_JPRB, 0.37099008E-03_JPRB, 0.37098868E-03_JPRB, 0.37098781E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098688E-03_JPRB, 0.37098659E-03_JPRB, 0.37098650E-03_JPRB, 0.37098624E-03_JPRB, 0.37098589E-03_JPRB, 0.37098545E-03_JPRB, &
  & 0.37098496E-03_JPRB, 0.37098449E-03_JPRB, 0.37098414E-03_JPRB, 0.37098391E-03_JPRB, 0.37098370E-03_JPRB, 0.37098359E-03_JPRB, &
  & 0.37098350E-03_JPRB, 0.37098338E-03_JPRB, 0.37098324E-03_JPRB, 0.37098309E-03_JPRB, 0.37098292E-03_JPRB, 0.37098280E-03_JPRB, &
  & 0.37098269E-03_JPRB, 0.37098257E-03_JPRB, 0.37098242E-03_JPRB, 0.37098222E-03_JPRB /)

RGHG1(:,57, 5) = (/ &
  & 0.37096493E-03_JPRB, 0.37096877E-03_JPRB, 0.37097093E-03_JPRB, 0.37097285E-03_JPRB, 0.37097448E-03_JPRB, 0.37097553E-03_JPRB, &
  & 0.37097599E-03_JPRB, 0.37097634E-03_JPRB, 0.37097657E-03_JPRB, 0.37097681E-03_JPRB, 0.37097695E-03_JPRB, 0.37097710E-03_JPRB, &
  & 0.37097733E-03_JPRB, 0.37097768E-03_JPRB, 0.37097820E-03_JPRB, 0.37097890E-03_JPRB, 0.37097972E-03_JPRB, 0.37098050E-03_JPRB, &
  & 0.37098129E-03_JPRB, 0.37098216E-03_JPRB, 0.37098344E-03_JPRB, 0.37098501E-03_JPRB, 0.37098708E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37099110E-03_JPRB, 0.37099276E-03_JPRB, 0.37099395E-03_JPRB, 0.37099488E-03_JPRB, 0.37099578E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099674E-03_JPRB, 0.37099689E-03_JPRB, 0.37099657E-03_JPRB, 0.37099607E-03_JPRB, 0.37099552E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099325E-03_JPRB, 0.37099197E-03_JPRB, 0.37099057E-03_JPRB, 0.37098935E-03_JPRB, 0.37098859E-03_JPRB, 0.37098807E-03_JPRB, &
  & 0.37098772E-03_JPRB, 0.37098746E-03_JPRB, 0.37098740E-03_JPRB, 0.37098717E-03_JPRB, 0.37098688E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098594E-03_JPRB, 0.37098560E-03_JPRB, 0.37098536E-03_JPRB, 0.37098525E-03_JPRB, 0.37098510E-03_JPRB, 0.37098498E-03_JPRB, &
  & 0.37098484E-03_JPRB, 0.37098466E-03_JPRB, 0.37098455E-03_JPRB, 0.37098446E-03_JPRB, 0.37098437E-03_JPRB, 0.37098426E-03_JPRB, &
  & 0.37098414E-03_JPRB, 0.37098402E-03_JPRB, 0.37098391E-03_JPRB, 0.37098370E-03_JPRB /)

RGHG1(:,58, 5) = (/ &
  & 0.37097113E-03_JPRB, 0.37097337E-03_JPRB, 0.37097457E-03_JPRB, 0.37097567E-03_JPRB, 0.37097681E-03_JPRB, 0.37097750E-03_JPRB, &
  & 0.37097785E-03_JPRB, 0.37097809E-03_JPRB, 0.37097826E-03_JPRB, 0.37097841E-03_JPRB, 0.37097855E-03_JPRB, 0.37097867E-03_JPRB, &
  & 0.37097879E-03_JPRB, 0.37097902E-03_JPRB, 0.37097948E-03_JPRB, 0.37098007E-03_JPRB, 0.37098082E-03_JPRB, 0.37098158E-03_JPRB, &
  & 0.37098234E-03_JPRB, 0.37098321E-03_JPRB, 0.37098437E-03_JPRB, 0.37098580E-03_JPRB, 0.37098772E-03_JPRB, 0.37098958E-03_JPRB, &
  & 0.37099150E-03_JPRB, 0.37099299E-03_JPRB, 0.37099427E-03_JPRB, 0.37099514E-03_JPRB, 0.37099610E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099721E-03_JPRB, 0.37099692E-03_JPRB, 0.37099645E-03_JPRB, 0.37099581E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099243E-03_JPRB, 0.37099113E-03_JPRB, 0.37098996E-03_JPRB, 0.37098920E-03_JPRB, 0.37098877E-03_JPRB, &
  & 0.37098853E-03_JPRB, 0.37098830E-03_JPRB, 0.37098827E-03_JPRB, 0.37098813E-03_JPRB, 0.37098787E-03_JPRB, 0.37098746E-03_JPRB, &
  & 0.37098705E-03_JPRB, 0.37098676E-03_JPRB, 0.37098647E-03_JPRB, 0.37098629E-03_JPRB, 0.37098615E-03_JPRB, 0.37098606E-03_JPRB, &
  & 0.37098597E-03_JPRB, 0.37098586E-03_JPRB, 0.37098571E-03_JPRB, 0.37098557E-03_JPRB, 0.37098545E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098525E-03_JPRB, 0.37098513E-03_JPRB, 0.37098493E-03_JPRB /)

RGHG1(:,59, 5) = (/ &
  & 0.37097500E-03_JPRB, 0.37097646E-03_JPRB, 0.37097721E-03_JPRB, 0.37097803E-03_JPRB, 0.37097867E-03_JPRB, 0.37097916E-03_JPRB, &
  & 0.37097940E-03_JPRB, 0.37097954E-03_JPRB, 0.37097966E-03_JPRB, 0.37097972E-03_JPRB, 0.37097983E-03_JPRB, 0.37097998E-03_JPRB, &
  & 0.37098012E-03_JPRB, 0.37098036E-03_JPRB, 0.37098071E-03_JPRB, 0.37098117E-03_JPRB, 0.37098187E-03_JPRB, 0.37098263E-03_JPRB, &
  & 0.37098330E-03_JPRB, 0.37098414E-03_JPRB, 0.37098530E-03_JPRB, 0.37098661E-03_JPRB, 0.37098845E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099334E-03_JPRB, 0.37099453E-03_JPRB, 0.37099546E-03_JPRB, 0.37099642E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099741E-03_JPRB, 0.37099718E-03_JPRB, 0.37099680E-03_JPRB, 0.37099619E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099296E-03_JPRB, 0.37099171E-03_JPRB, 0.37099060E-03_JPRB, 0.37098984E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098915E-03_JPRB, 0.37098909E-03_JPRB, 0.37098897E-03_JPRB, 0.37098880E-03_JPRB, 0.37098845E-03_JPRB, &
  & 0.37098804E-03_JPRB, 0.37098775E-03_JPRB, 0.37098746E-03_JPRB, 0.37098728E-03_JPRB, 0.37098717E-03_JPRB, 0.37098708E-03_JPRB, &
  & 0.37098699E-03_JPRB, 0.37098688E-03_JPRB, 0.37098679E-03_JPRB, 0.37098667E-03_JPRB, 0.37098650E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098629E-03_JPRB, 0.37098624E-03_JPRB, 0.37098612E-03_JPRB, 0.37098594E-03_JPRB /)

RGHG1(:,60, 5) = (/ &
  & 0.37097791E-03_JPRB, 0.37097881E-03_JPRB, 0.37097931E-03_JPRB, 0.37097977E-03_JPRB, 0.37098024E-03_JPRB, 0.37098053E-03_JPRB, &
  & 0.37098062E-03_JPRB, 0.37098074E-03_JPRB, 0.37098088E-03_JPRB, 0.37098094E-03_JPRB, 0.37098100E-03_JPRB, 0.37098111E-03_JPRB, &
  & 0.37098123E-03_JPRB, 0.37098138E-03_JPRB, 0.37098170E-03_JPRB, 0.37098222E-03_JPRB, 0.37098292E-03_JPRB, 0.37098367E-03_JPRB, &
  & 0.37098434E-03_JPRB, 0.37098513E-03_JPRB, 0.37098618E-03_JPRB, 0.37098743E-03_JPRB, 0.37098909E-03_JPRB, 0.37099075E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37099374E-03_JPRB, 0.37099500E-03_JPRB, 0.37099587E-03_JPRB, 0.37099671E-03_JPRB, 0.37099724E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099770E-03_JPRB, 0.37099744E-03_JPRB, 0.37099709E-03_JPRB, 0.37099654E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099351E-03_JPRB, 0.37099223E-03_JPRB, 0.37099124E-03_JPRB, 0.37099054E-03_JPRB, 0.37099025E-03_JPRB, &
  & 0.37099005E-03_JPRB, 0.37098996E-03_JPRB, 0.37098993E-03_JPRB, 0.37098984E-03_JPRB, 0.37098961E-03_JPRB, 0.37098935E-03_JPRB, &
  & 0.37098894E-03_JPRB, 0.37098865E-03_JPRB, 0.37098839E-03_JPRB, 0.37098819E-03_JPRB, 0.37098807E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098787E-03_JPRB, 0.37098775E-03_JPRB, 0.37098766E-03_JPRB, 0.37098755E-03_JPRB, 0.37098740E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098717E-03_JPRB, 0.37098705E-03_JPRB, 0.37098693E-03_JPRB, 0.37098667E-03_JPRB /)

RGHG1(:,61, 5) = (/ &
  & 0.37097995E-03_JPRB, 0.37098056E-03_JPRB, 0.37098088E-03_JPRB, 0.37098123E-03_JPRB, 0.37098149E-03_JPRB, 0.37098170E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098187E-03_JPRB, 0.37098196E-03_JPRB, 0.37098202E-03_JPRB, 0.37098204E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098213E-03_JPRB, 0.37098228E-03_JPRB, 0.37098263E-03_JPRB, 0.37098327E-03_JPRB, 0.37098399E-03_JPRB, 0.37098475E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098603E-03_JPRB, 0.37098699E-03_JPRB, 0.37098807E-03_JPRB, 0.37098964E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099418E-03_JPRB, 0.37099537E-03_JPRB, 0.37099625E-03_JPRB, 0.37099700E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099791E-03_JPRB, 0.37099767E-03_JPRB, 0.37099738E-03_JPRB, 0.37099680E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099398E-03_JPRB, 0.37099276E-03_JPRB, 0.37099194E-03_JPRB, 0.37099133E-03_JPRB, 0.37099098E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099078E-03_JPRB, 0.37099075E-03_JPRB, 0.37099063E-03_JPRB, 0.37099043E-03_JPRB, 0.37099025E-03_JPRB, &
  & 0.37098993E-03_JPRB, 0.37098967E-03_JPRB, 0.37098938E-03_JPRB, 0.37098915E-03_JPRB, 0.37098903E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098868E-03_JPRB, 0.37098856E-03_JPRB, 0.37098839E-03_JPRB, 0.37098827E-03_JPRB, 0.37098813E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098789E-03_JPRB, 0.37098772E-03_JPRB, 0.37098740E-03_JPRB /)

RGHG1(:,62, 5) = (/ &
  & 0.37098152E-03_JPRB, 0.37098202E-03_JPRB, 0.37098228E-03_JPRB, 0.37098251E-03_JPRB, 0.37098274E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098303E-03_JPRB, 0.37098312E-03_JPRB, 0.37098315E-03_JPRB, 0.37098312E-03_JPRB, 0.37098312E-03_JPRB, 0.37098315E-03_JPRB, &
  & 0.37098315E-03_JPRB, 0.37098327E-03_JPRB, 0.37098367E-03_JPRB, 0.37098431E-03_JPRB, 0.37098516E-03_JPRB, 0.37098583E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098699E-03_JPRB, 0.37098781E-03_JPRB, 0.37098894E-03_JPRB, 0.37099040E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099331E-03_JPRB, 0.37099468E-03_JPRB, 0.37099575E-03_JPRB, 0.37099665E-03_JPRB, 0.37099735E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099820E-03_JPRB, 0.37099799E-03_JPRB, 0.37099767E-03_JPRB, 0.37099718E-03_JPRB, 0.37099639E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099444E-03_JPRB, 0.37099334E-03_JPRB, 0.37099255E-03_JPRB, 0.37099200E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099162E-03_JPRB, 0.37099159E-03_JPRB, 0.37099150E-03_JPRB, 0.37099130E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099081E-03_JPRB, 0.37099048E-03_JPRB, 0.37099028E-03_JPRB, 0.37099011E-03_JPRB, 0.37099002E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098967E-03_JPRB, 0.37098944E-03_JPRB, 0.37098926E-03_JPRB, 0.37098909E-03_JPRB, 0.37098891E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098865E-03_JPRB, 0.37098851E-03_JPRB, 0.37098830E-03_JPRB, 0.37098792E-03_JPRB /)

RGHG1(:,63, 5) = (/ &
  & 0.37098292E-03_JPRB, 0.37098333E-03_JPRB, 0.37098356E-03_JPRB, 0.37098373E-03_JPRB, 0.37098391E-03_JPRB, 0.37098402E-03_JPRB, &
  & 0.37098405E-03_JPRB, 0.37098408E-03_JPRB, 0.37098408E-03_JPRB, 0.37098408E-03_JPRB, 0.37098405E-03_JPRB, 0.37098402E-03_JPRB, &
  & 0.37098402E-03_JPRB, 0.37098411E-03_JPRB, 0.37098455E-03_JPRB, 0.37098539E-03_JPRB, 0.37098629E-03_JPRB, 0.37098691E-03_JPRB, &
  & 0.37098737E-03_JPRB, 0.37098792E-03_JPRB, 0.37098865E-03_JPRB, 0.37098964E-03_JPRB, 0.37099104E-03_JPRB, 0.37099243E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099511E-03_JPRB, 0.37099622E-03_JPRB, 0.37099703E-03_JPRB, 0.37099764E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099840E-03_JPRB, 0.37099828E-03_JPRB, 0.37099805E-03_JPRB, 0.37099750E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099505E-03_JPRB, 0.37099404E-03_JPRB, 0.37099316E-03_JPRB, 0.37099267E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099246E-03_JPRB, 0.37099235E-03_JPRB, 0.37099226E-03_JPRB, 0.37099217E-03_JPRB, 0.37099206E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099147E-03_JPRB, 0.37099124E-03_JPRB, 0.37099101E-03_JPRB, 0.37099081E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099043E-03_JPRB, 0.37099022E-03_JPRB, 0.37099005E-03_JPRB, 0.37098984E-03_JPRB, 0.37098964E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37098923E-03_JPRB, 0.37098900E-03_JPRB, 0.37098851E-03_JPRB /)

RGHG1(:,64, 5) = (/ &
  & 0.37098408E-03_JPRB, 0.37098443E-03_JPRB, 0.37098461E-03_JPRB, 0.37098472E-03_JPRB, 0.37098484E-03_JPRB, 0.37098490E-03_JPRB, &
  & 0.37098490E-03_JPRB, 0.37098493E-03_JPRB, 0.37098501E-03_JPRB, 0.37098501E-03_JPRB, 0.37098496E-03_JPRB, 0.37098484E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098466E-03_JPRB, 0.37098528E-03_JPRB, 0.37098632E-03_JPRB, 0.37098737E-03_JPRB, 0.37098795E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098880E-03_JPRB, 0.37098958E-03_JPRB, 0.37099057E-03_JPRB, 0.37099179E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099558E-03_JPRB, 0.37099665E-03_JPRB, 0.37099747E-03_JPRB, 0.37099794E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099863E-03_JPRB, 0.37099849E-03_JPRB, 0.37099837E-03_JPRB, 0.37099794E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099555E-03_JPRB, 0.37099468E-03_JPRB, 0.37099392E-03_JPRB, 0.37099345E-03_JPRB, 0.37099322E-03_JPRB, &
  & 0.37099302E-03_JPRB, 0.37099313E-03_JPRB, 0.37099310E-03_JPRB, 0.37099302E-03_JPRB, 0.37099296E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099255E-03_JPRB, 0.37099229E-03_JPRB, 0.37099214E-03_JPRB, 0.37099197E-03_JPRB, 0.37099171E-03_JPRB, 0.37099153E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099107E-03_JPRB, 0.37099089E-03_JPRB, 0.37099063E-03_JPRB, 0.37099031E-03_JPRB, 0.37099011E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098979E-03_JPRB, 0.37098955E-03_JPRB, 0.37098897E-03_JPRB /)

RGHG1(:,65, 5) = (/ &
  & 0.37098519E-03_JPRB, 0.37098548E-03_JPRB, 0.37098562E-03_JPRB, 0.37098571E-03_JPRB, 0.37098586E-03_JPRB, 0.37098589E-03_JPRB, &
  & 0.37098594E-03_JPRB, 0.37098600E-03_JPRB, 0.37098603E-03_JPRB, 0.37098600E-03_JPRB, 0.37098594E-03_JPRB, 0.37098571E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098519E-03_JPRB, 0.37098600E-03_JPRB, 0.37098725E-03_JPRB, 0.37098839E-03_JPRB, 0.37098891E-03_JPRB, &
  & 0.37098929E-03_JPRB, 0.37098976E-03_JPRB, 0.37099048E-03_JPRB, 0.37099139E-03_JPRB, 0.37099255E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099497E-03_JPRB, 0.37099616E-03_JPRB, 0.37099718E-03_JPRB, 0.37099782E-03_JPRB, 0.37099823E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099881E-03_JPRB, 0.37099881E-03_JPRB, 0.37099860E-03_JPRB, 0.37099823E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099610E-03_JPRB, 0.37099546E-03_JPRB, 0.37099468E-03_JPRB, 0.37099424E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099386E-03_JPRB, 0.37099395E-03_JPRB, 0.37099377E-03_JPRB, 0.37099369E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099340E-03_JPRB, 0.37099310E-03_JPRB, 0.37099296E-03_JPRB, 0.37099276E-03_JPRB, 0.37099246E-03_JPRB, 0.37099232E-03_JPRB, &
  & 0.37099211E-03_JPRB, 0.37099188E-03_JPRB, 0.37099171E-03_JPRB, 0.37099139E-03_JPRB, 0.37099110E-03_JPRB, 0.37099092E-03_JPRB, &
  & 0.37099066E-03_JPRB, 0.37099048E-03_JPRB, 0.37099014E-03_JPRB, 0.37098952E-03_JPRB /)

RGHG1(:,66, 5) = (/ &
  & 0.37098612E-03_JPRB, 0.37098647E-03_JPRB, 0.37098659E-03_JPRB, 0.37098673E-03_JPRB, 0.37098685E-03_JPRB, 0.37098691E-03_JPRB, &
  & 0.37098699E-03_JPRB, 0.37098705E-03_JPRB, 0.37098699E-03_JPRB, 0.37098693E-03_JPRB, 0.37098676E-03_JPRB, 0.37098638E-03_JPRB, &
  & 0.37098574E-03_JPRB, 0.37098557E-03_JPRB, 0.37098670E-03_JPRB, 0.37098839E-03_JPRB, 0.37098947E-03_JPRB, 0.37098993E-03_JPRB, &
  & 0.37099031E-03_JPRB, 0.37099075E-03_JPRB, 0.37099136E-03_JPRB, 0.37099223E-03_JPRB, 0.37099322E-03_JPRB, 0.37099438E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099657E-03_JPRB, 0.37099753E-03_JPRB, 0.37099820E-03_JPRB, 0.37099855E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099893E-03_JPRB, 0.37099898E-03_JPRB, 0.37099881E-03_JPRB, 0.37099849E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099674E-03_JPRB, 0.37099610E-03_JPRB, 0.37099535E-03_JPRB, 0.37099494E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099456E-03_JPRB, 0.37099462E-03_JPRB, 0.37099456E-03_JPRB, 0.37099453E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099398E-03_JPRB, 0.37099380E-03_JPRB, 0.37099357E-03_JPRB, 0.37099342E-03_JPRB, 0.37099313E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099270E-03_JPRB, 0.37099255E-03_JPRB, 0.37099223E-03_JPRB, 0.37099185E-03_JPRB, 0.37099168E-03_JPRB, &
  & 0.37099139E-03_JPRB, 0.37099121E-03_JPRB, 0.37099081E-03_JPRB, 0.37099008E-03_JPRB /)

RGHG1(:,67, 5) = (/ &
  & 0.37098708E-03_JPRB, 0.37098746E-03_JPRB, 0.37098763E-03_JPRB, 0.37098784E-03_JPRB, 0.37098795E-03_JPRB, 0.37098792E-03_JPRB, &
  & 0.37098789E-03_JPRB, 0.37098798E-03_JPRB, 0.37098804E-03_JPRB, 0.37098795E-03_JPRB, 0.37098775E-03_JPRB, 0.37098705E-03_JPRB, &
  & 0.37098589E-03_JPRB, 0.37098539E-03_JPRB, 0.37098705E-03_JPRB, 0.37098920E-03_JPRB, 0.37099057E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37099139E-03_JPRB, 0.37099179E-03_JPRB, 0.37099223E-03_JPRB, 0.37099299E-03_JPRB, 0.37099401E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099619E-03_JPRB, 0.37099709E-03_JPRB, 0.37099799E-03_JPRB, 0.37099855E-03_JPRB, 0.37099881E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099913E-03_JPRB, 0.37099922E-03_JPRB, 0.37099913E-03_JPRB, 0.37099878E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099718E-03_JPRB, 0.37099665E-03_JPRB, 0.37099601E-03_JPRB, 0.37099572E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099529E-03_JPRB, 0.37099532E-03_JPRB, 0.37099532E-03_JPRB, 0.37099526E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099497E-03_JPRB, 0.37099473E-03_JPRB, 0.37099462E-03_JPRB, 0.37099444E-03_JPRB, 0.37099421E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099348E-03_JPRB, 0.37099331E-03_JPRB, 0.37099302E-03_JPRB, 0.37099261E-03_JPRB, 0.37099249E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099194E-03_JPRB, 0.37099145E-03_JPRB, 0.37099060E-03_JPRB /)

RGHG1(:,68, 5) = (/ &
  & 0.37098787E-03_JPRB, 0.37098827E-03_JPRB, 0.37098856E-03_JPRB, 0.37098880E-03_JPRB, 0.37098891E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098906E-03_JPRB, 0.37098909E-03_JPRB, 0.37098909E-03_JPRB, 0.37098891E-03_JPRB, 0.37098865E-03_JPRB, 0.37098778E-03_JPRB, &
  & 0.37098670E-03_JPRB, 0.37098693E-03_JPRB, 0.37098883E-03_JPRB, 0.37099037E-03_JPRB, 0.37099147E-03_JPRB, 0.37099197E-03_JPRB, &
  & 0.37099246E-03_JPRB, 0.37099281E-03_JPRB, 0.37099302E-03_JPRB, 0.37099377E-03_JPRB, 0.37099471E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099753E-03_JPRB, 0.37099834E-03_JPRB, 0.37099884E-03_JPRB, 0.37099907E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099939E-03_JPRB, 0.37099948E-03_JPRB, 0.37099942E-03_JPRB, 0.37099913E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099779E-03_JPRB, 0.37099727E-03_JPRB, 0.37099660E-03_JPRB, 0.37099633E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099593E-03_JPRB, 0.37099599E-03_JPRB, 0.37099599E-03_JPRB, 0.37099593E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099561E-03_JPRB, 0.37099543E-03_JPRB, 0.37099520E-03_JPRB, 0.37099497E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099433E-03_JPRB, 0.37099406E-03_JPRB, 0.37099380E-03_JPRB, 0.37099345E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099267E-03_JPRB, 0.37099217E-03_JPRB, 0.37099127E-03_JPRB /)

RGHG1(:,69, 5) = (/ &
  & 0.37098862E-03_JPRB, 0.37098920E-03_JPRB, 0.37098955E-03_JPRB, 0.37098987E-03_JPRB, 0.37098999E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37099014E-03_JPRB, 0.37099014E-03_JPRB, 0.37098990E-03_JPRB, 0.37098950E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098533E-03_JPRB, 0.37098391E-03_JPRB, 0.37098699E-03_JPRB, 0.37099086E-03_JPRB, 0.37099261E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099380E-03_JPRB, 0.37099398E-03_JPRB, 0.37099456E-03_JPRB, 0.37099532E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099799E-03_JPRB, 0.37099875E-03_JPRB, 0.37099913E-03_JPRB, 0.37099925E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099945E-03_JPRB, 0.37099968E-03_JPRB, 0.37099957E-03_JPRB, 0.37099939E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099820E-03_JPRB, 0.37099773E-03_JPRB, 0.37099724E-03_JPRB, 0.37099695E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099654E-03_JPRB, 0.37099663E-03_JPRB, 0.37099680E-03_JPRB, 0.37099674E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099631E-03_JPRB, 0.37099613E-03_JPRB, 0.37099601E-03_JPRB, 0.37099572E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099511E-03_JPRB, 0.37099482E-03_JPRB, 0.37099462E-03_JPRB, 0.37099427E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099372E-03_JPRB, 0.37099345E-03_JPRB, 0.37099293E-03_JPRB, 0.37099194E-03_JPRB /)

RGHG1(:,70, 5) = (/ &
  & 0.37098938E-03_JPRB, 0.37099014E-03_JPRB, 0.37099060E-03_JPRB, 0.37099089E-03_JPRB, 0.37099101E-03_JPRB, 0.37099104E-03_JPRB, &
  & 0.37099121E-03_JPRB, 0.37099118E-03_JPRB, 0.37099124E-03_JPRB, 0.37099095E-03_JPRB, 0.37099048E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098801E-03_JPRB, 0.37098874E-03_JPRB, 0.37099081E-03_JPRB, 0.37099209E-03_JPRB, 0.37099354E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099479E-03_JPRB, 0.37099491E-03_JPRB, 0.37099523E-03_JPRB, 0.37099593E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099843E-03_JPRB, 0.37099910E-03_JPRB, 0.37099936E-03_JPRB, 0.37099945E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099951E-03_JPRB, 0.37099983E-03_JPRB, 0.37099974E-03_JPRB, 0.37099968E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099866E-03_JPRB, 0.37099823E-03_JPRB, 0.37099779E-03_JPRB, 0.37099756E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099709E-03_JPRB, 0.37099718E-03_JPRB, 0.37099741E-03_JPRB, 0.37099735E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099700E-03_JPRB, 0.37099677E-03_JPRB, 0.37099671E-03_JPRB, 0.37099642E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099590E-03_JPRB, 0.37099564E-03_JPRB, 0.37099549E-03_JPRB, 0.37099511E-03_JPRB, 0.37099482E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099421E-03_JPRB, 0.37099374E-03_JPRB, 0.37099261E-03_JPRB /)

RGHG1(:,71, 5) = (/ &
  & 0.37099008E-03_JPRB, 0.37099107E-03_JPRB, 0.37099171E-03_JPRB, 0.37099197E-03_JPRB, 0.37099211E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099229E-03_JPRB, 0.37099229E-03_JPRB, 0.37099232E-03_JPRB, 0.37099191E-03_JPRB, 0.37099139E-03_JPRB, 0.37098935E-03_JPRB, &
  & 0.37098484E-03_JPRB, 0.37098382E-03_JPRB, 0.37098862E-03_JPRB, 0.37099308E-03_JPRB, 0.37099468E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099578E-03_JPRB, 0.37099581E-03_JPRB, 0.37099596E-03_JPRB, 0.37099648E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099887E-03_JPRB, 0.37099939E-03_JPRB, 0.37099959E-03_JPRB, 0.37099959E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099954E-03_JPRB, 0.37099994E-03_JPRB, 0.37099986E-03_JPRB, 0.37099989E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099907E-03_JPRB, 0.37099875E-03_JPRB, 0.37099831E-03_JPRB, 0.37099805E-03_JPRB, 0.37099779E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099764E-03_JPRB, 0.37099767E-03_JPRB, 0.37099802E-03_JPRB, 0.37099808E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099773E-03_JPRB, 0.37099753E-03_JPRB, 0.37099747E-03_JPRB, 0.37099744E-03_JPRB, 0.37099712E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099668E-03_JPRB, 0.37099642E-03_JPRB, 0.37099622E-03_JPRB, 0.37099593E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099503E-03_JPRB, 0.37099447E-03_JPRB, 0.37099345E-03_JPRB /)

RGHG1(:,72, 5) = (/ &
  & 0.37099089E-03_JPRB, 0.37099197E-03_JPRB, 0.37099293E-03_JPRB, 0.37099316E-03_JPRB, 0.37099328E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099331E-03_JPRB, 0.37099337E-03_JPRB, 0.37099342E-03_JPRB, 0.37099299E-03_JPRB, 0.37099235E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37098801E-03_JPRB, 0.37098781E-03_JPRB, 0.37099101E-03_JPRB, 0.37099386E-03_JPRB, 0.37099593E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099683E-03_JPRB, 0.37099663E-03_JPRB, 0.37099665E-03_JPRB, 0.37099703E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099933E-03_JPRB, 0.37099968E-03_JPRB, 0.37099974E-03_JPRB, 0.37099977E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099965E-03_JPRB, 0.37100015E-03_JPRB, 0.37099994E-03_JPRB, 0.37100003E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099939E-03_JPRB, 0.37099922E-03_JPRB, 0.37099884E-03_JPRB, 0.37099855E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099799E-03_JPRB, 0.37099802E-03_JPRB, 0.37099855E-03_JPRB, 0.37099858E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099805E-03_JPRB, 0.37099802E-03_JPRB, 0.37099820E-03_JPRB, 0.37099785E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099747E-03_JPRB, 0.37099724E-03_JPRB, 0.37099712E-03_JPRB, 0.37099671E-03_JPRB, 0.37099633E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099587E-03_JPRB, 0.37099535E-03_JPRB, 0.37099424E-03_JPRB /)

RGHG1(:,73, 5) = (/ &
  & 0.37099182E-03_JPRB, 0.37099308E-03_JPRB, 0.37099424E-03_JPRB, 0.37099433E-03_JPRB, 0.37099453E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099438E-03_JPRB, 0.37099447E-03_JPRB, 0.37099409E-03_JPRB, 0.37099319E-03_JPRB, 0.37099031E-03_JPRB, &
  & 0.37098353E-03_JPRB, 0.37098335E-03_JPRB, 0.37099019E-03_JPRB, 0.37099517E-03_JPRB, 0.37099700E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099767E-03_JPRB, 0.37099750E-03_JPRB, 0.37099727E-03_JPRB, 0.37099753E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099968E-03_JPRB, 0.37100000E-03_JPRB, 0.37099983E-03_JPRB, 0.37099974E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099954E-03_JPRB, 0.37100032E-03_JPRB, 0.37099997E-03_JPRB, 0.37100026E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099983E-03_JPRB, 0.37099965E-03_JPRB, 0.37099930E-03_JPRB, 0.37099898E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099828E-03_JPRB, 0.37099834E-03_JPRB, 0.37099904E-03_JPRB, 0.37099913E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099831E-03_JPRB, 0.37099846E-03_JPRB, 0.37099887E-03_JPRB, 0.37099840E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099823E-03_JPRB, 0.37099808E-03_JPRB, 0.37099796E-03_JPRB, 0.37099750E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099668E-03_JPRB, 0.37099610E-03_JPRB, 0.37099505E-03_JPRB /)

RGHG1(:,74, 5) = (/ &
  & 0.37099284E-03_JPRB, 0.37099404E-03_JPRB, 0.37099569E-03_JPRB, 0.37099555E-03_JPRB, 0.37099578E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099546E-03_JPRB, 0.37099543E-03_JPRB, 0.37099561E-03_JPRB, 0.37099532E-03_JPRB, 0.37099462E-03_JPRB, 0.37099273E-03_JPRB, &
  & 0.37098950E-03_JPRB, 0.37099037E-03_JPRB, 0.37099284E-03_JPRB, 0.37099631E-03_JPRB, 0.37099823E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099852E-03_JPRB, 0.37099828E-03_JPRB, 0.37099785E-03_JPRB, 0.37099788E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100003E-03_JPRB, 0.37100026E-03_JPRB, 0.37099986E-03_JPRB, 0.37099983E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099965E-03_JPRB, 0.37100053E-03_JPRB, 0.37100003E-03_JPRB, 0.37100055E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100021E-03_JPRB, 0.37100009E-03_JPRB, 0.37099962E-03_JPRB, 0.37099925E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099843E-03_JPRB, 0.37099858E-03_JPRB, 0.37099962E-03_JPRB, 0.37099968E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099855E-03_JPRB, 0.37099881E-03_JPRB, 0.37099945E-03_JPRB, 0.37099878E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099901E-03_JPRB, 0.37099893E-03_JPRB, 0.37099875E-03_JPRB, 0.37099817E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099759E-03_JPRB, 0.37099695E-03_JPRB, 0.37099584E-03_JPRB /)

RGHG1(:,75, 5) = (/ &
  & 0.37099374E-03_JPRB, 0.37099497E-03_JPRB, 0.37099712E-03_JPRB, 0.37099677E-03_JPRB, 0.37099700E-03_JPRB, 0.37099619E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099642E-03_JPRB, 0.37099668E-03_JPRB, 0.37099648E-03_JPRB, 0.37099511E-03_JPRB, 0.37099115E-03_JPRB, &
  & 0.37098074E-03_JPRB, 0.37097890E-03_JPRB, 0.37099165E-03_JPRB, 0.37099700E-03_JPRB, 0.37099942E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099936E-03_JPRB, 0.37099898E-03_JPRB, 0.37099831E-03_JPRB, 0.37099814E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100044E-03_JPRB, 0.37100061E-03_JPRB, 0.37099974E-03_JPRB, 0.37099962E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099927E-03_JPRB, 0.37100058E-03_JPRB, 0.37100000E-03_JPRB, 0.37100079E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100055E-03_JPRB, 0.37100055E-03_JPRB, 0.37099997E-03_JPRB, 0.37099951E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099849E-03_JPRB, 0.37099872E-03_JPRB, 0.37100012E-03_JPRB, 0.37100021E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099863E-03_JPRB, 0.37099904E-03_JPRB, 0.37100000E-03_JPRB, 0.37099898E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099968E-03_JPRB, 0.37099971E-03_JPRB, 0.37099954E-03_JPRB, 0.37099878E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099852E-03_JPRB, 0.37099756E-03_JPRB, 0.37099648E-03_JPRB /)

RGHG1(:,76, 5) = (/ &
  & 0.37099462E-03_JPRB, 0.37099564E-03_JPRB, 0.37099858E-03_JPRB, 0.37099799E-03_JPRB, 0.37099826E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099732E-03_JPRB, 0.37099776E-03_JPRB, 0.37099782E-03_JPRB, 0.37099735E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37099238E-03_JPRB, 0.37099465E-03_JPRB, 0.37099843E-03_JPRB, 0.37100085E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100015E-03_JPRB, 0.37099962E-03_JPRB, 0.37099860E-03_JPRB, 0.37099828E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100070E-03_JPRB, 0.37100102E-03_JPRB, 0.37099968E-03_JPRB, 0.37099948E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099957E-03_JPRB, 0.37100102E-03_JPRB, 0.37100000E-03_JPRB, 0.37100105E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100085E-03_JPRB, 0.37100090E-03_JPRB, 0.37100018E-03_JPRB, 0.37099965E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099843E-03_JPRB, 0.37099866E-03_JPRB, 0.37100055E-03_JPRB, 0.37100067E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099860E-03_JPRB, 0.37099927E-03_JPRB, 0.37100058E-03_JPRB, 0.37099913E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100050E-03_JPRB, 0.37100050E-03_JPRB, 0.37100032E-03_JPRB, 0.37099927E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099945E-03_JPRB, 0.37099811E-03_JPRB, 0.37099706E-03_JPRB /)

RGHG1(:,77, 5) = (/ &
  & 0.37099540E-03_JPRB, 0.37099619E-03_JPRB, 0.37100015E-03_JPRB, 0.37099910E-03_JPRB, 0.37099945E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099811E-03_JPRB, 0.37099869E-03_JPRB, 0.37099881E-03_JPRB, 0.37099753E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37097954E-03_JPRB, 0.37097844E-03_JPRB, 0.37099369E-03_JPRB, 0.37099916E-03_JPRB, 0.37100213E-03_JPRB, 0.37100189E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100082E-03_JPRB, 0.37100021E-03_JPRB, 0.37099881E-03_JPRB, 0.37099828E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100093E-03_JPRB, 0.37100140E-03_JPRB, 0.37099954E-03_JPRB, 0.37099916E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099884E-03_JPRB, 0.37100090E-03_JPRB, 0.37099994E-03_JPRB, 0.37100131E-03_JPRB, 0.37100274E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100111E-03_JPRB, 0.37100134E-03_JPRB, 0.37100038E-03_JPRB, 0.37099968E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099828E-03_JPRB, 0.37099849E-03_JPRB, 0.37100099E-03_JPRB, 0.37100108E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099837E-03_JPRB, 0.37099933E-03_JPRB, 0.37100122E-03_JPRB, 0.37099904E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100122E-03_JPRB, 0.37100128E-03_JPRB, 0.37100096E-03_JPRB, 0.37099968E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100053E-03_JPRB, 0.37099866E-03_JPRB, 0.37099762E-03_JPRB /)

RGHG1(:,78, 5) = (/ &
  & 0.37099622E-03_JPRB, 0.37099654E-03_JPRB, 0.37100152E-03_JPRB, 0.37100003E-03_JPRB, 0.37100064E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099878E-03_JPRB, 0.37099968E-03_JPRB, 0.37100018E-03_JPRB, 0.37099974E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098688E-03_JPRB, 0.37099567E-03_JPRB, 0.37100018E-03_JPRB, 0.37100341E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100149E-03_JPRB, 0.37100073E-03_JPRB, 0.37099904E-03_JPRB, 0.37099823E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100122E-03_JPRB, 0.37100178E-03_JPRB, 0.37099948E-03_JPRB, 0.37099913E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099922E-03_JPRB, 0.37100146E-03_JPRB, 0.37099994E-03_JPRB, 0.37100154E-03_JPRB, 0.37100326E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100128E-03_JPRB, 0.37100157E-03_JPRB, 0.37100055E-03_JPRB, 0.37099971E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099811E-03_JPRB, 0.37099823E-03_JPRB, 0.37100152E-03_JPRB, 0.37100157E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099799E-03_JPRB, 0.37099927E-03_JPRB, 0.37100172E-03_JPRB, 0.37099893E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100189E-03_JPRB, 0.37100189E-03_JPRB, 0.37100169E-03_JPRB, 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100160E-03_JPRB, 0.37099901E-03_JPRB, 0.37099808E-03_JPRB /)

RGHG1(:,79, 5) = (/ &
  & 0.37099654E-03_JPRB, 0.37099645E-03_JPRB, 0.37100253E-03_JPRB, 0.37100058E-03_JPRB, 0.37100149E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099901E-03_JPRB, 0.37100026E-03_JPRB, 0.37100108E-03_JPRB, 0.37100099E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37099145E-03_JPRB, 0.37099654E-03_JPRB, 0.37100090E-03_JPRB, 0.37100460E-03_JPRB, 0.37100390E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100198E-03_JPRB, 0.37100114E-03_JPRB, 0.37099901E-03_JPRB, 0.37099805E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37100143E-03_JPRB, 0.37100216E-03_JPRB, 0.37099930E-03_JPRB, 0.37099893E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099951E-03_JPRB, 0.37100195E-03_JPRB, 0.37099991E-03_JPRB, 0.37100184E-03_JPRB, 0.37100393E-03_JPRB, &
  & 0.37100349E-03_JPRB, 0.37100154E-03_JPRB, 0.37100181E-03_JPRB, 0.37100061E-03_JPRB, 0.37099968E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099773E-03_JPRB, 0.37099788E-03_JPRB, 0.37100189E-03_JPRB, 0.37100195E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099764E-03_JPRB, 0.37099922E-03_JPRB, 0.37100224E-03_JPRB, 0.37099872E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100250E-03_JPRB, 0.37100250E-03_JPRB, 0.37100218E-03_JPRB, 0.37100009E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100242E-03_JPRB, 0.37099916E-03_JPRB, 0.37099826E-03_JPRB /)

RGHG1(:,80, 5) = (/ &
  & 0.37099660E-03_JPRB, 0.37099628E-03_JPRB, 0.37100317E-03_JPRB, 0.37100090E-03_JPRB, 0.37100201E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099913E-03_JPRB, 0.37100061E-03_JPRB, 0.37100160E-03_JPRB, 0.37100172E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099366E-03_JPRB, 0.37099689E-03_JPRB, 0.37100128E-03_JPRB, 0.37100542E-03_JPRB, 0.37100448E-03_JPRB, &
  & 0.37100160E-03_JPRB, 0.37100239E-03_JPRB, 0.37100143E-03_JPRB, 0.37099898E-03_JPRB, 0.37099788E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100172E-03_JPRB, 0.37100239E-03_JPRB, 0.37099919E-03_JPRB, 0.37099875E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099968E-03_JPRB, 0.37100236E-03_JPRB, 0.37100003E-03_JPRB, 0.37100210E-03_JPRB, 0.37100448E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100184E-03_JPRB, 0.37100207E-03_JPRB, 0.37100073E-03_JPRB, 0.37099962E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099753E-03_JPRB, 0.37099764E-03_JPRB, 0.37100221E-03_JPRB, 0.37100236E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099735E-03_JPRB, 0.37099916E-03_JPRB, 0.37100268E-03_JPRB, 0.37099863E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100294E-03_JPRB, 0.37100282E-03_JPRB, 0.37100256E-03_JPRB, 0.37100026E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100303E-03_JPRB, 0.37099919E-03_JPRB, 0.37099820E-03_JPRB /)

RGHG1(:,81, 5) = (/ &
  & 0.37099639E-03_JPRB, 0.37099613E-03_JPRB, 0.37100355E-03_JPRB, 0.37100111E-03_JPRB, 0.37100230E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099930E-03_JPRB, 0.37100073E-03_JPRB, 0.37100195E-03_JPRB, 0.37100216E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099468E-03_JPRB, 0.37099695E-03_JPRB, 0.37100149E-03_JPRB, 0.37100600E-03_JPRB, 0.37100498E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100265E-03_JPRB, 0.37100154E-03_JPRB, 0.37099890E-03_JPRB, 0.37099770E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100280E-03_JPRB, 0.37100184E-03_JPRB, 0.37100259E-03_JPRB, 0.37099913E-03_JPRB, 0.37099866E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099974E-03_JPRB, 0.37100256E-03_JPRB, 0.37100006E-03_JPRB, 0.37100221E-03_JPRB, 0.37100477E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100210E-03_JPRB, 0.37100224E-03_JPRB, 0.37100079E-03_JPRB, 0.37099957E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099732E-03_JPRB, 0.37099753E-03_JPRB, 0.37100236E-03_JPRB, 0.37100253E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099712E-03_JPRB, 0.37099907E-03_JPRB, 0.37100300E-03_JPRB, 0.37099855E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100317E-03_JPRB, 0.37100309E-03_JPRB, 0.37100271E-03_JPRB, 0.37100032E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100332E-03_JPRB, 0.37099916E-03_JPRB, 0.37099799E-03_JPRB /)

RGHG1(:,82, 5) = (/ &
  & 0.37099633E-03_JPRB, 0.37099601E-03_JPRB, 0.37100379E-03_JPRB, 0.37100120E-03_JPRB, 0.37100242E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37099922E-03_JPRB, 0.37100108E-03_JPRB, 0.37100204E-03_JPRB, 0.37100233E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37099188E-03_JPRB, 0.37099537E-03_JPRB, 0.37099700E-03_JPRB, 0.37100163E-03_JPRB, 0.37100640E-03_JPRB, 0.37100527E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37100285E-03_JPRB, 0.37100172E-03_JPRB, 0.37099881E-03_JPRB, 0.37099753E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100189E-03_JPRB, 0.37100280E-03_JPRB, 0.37099904E-03_JPRB, 0.37099860E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099977E-03_JPRB, 0.37100271E-03_JPRB, 0.37100006E-03_JPRB, 0.37100236E-03_JPRB, 0.37100498E-03_JPRB, &
  & 0.37100440E-03_JPRB, 0.37100224E-03_JPRB, 0.37100227E-03_JPRB, 0.37100076E-03_JPRB, 0.37099954E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099727E-03_JPRB, 0.37099738E-03_JPRB, 0.37100248E-03_JPRB, 0.37100268E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37099695E-03_JPRB, 0.37099904E-03_JPRB, 0.37100312E-03_JPRB, 0.37099840E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100335E-03_JPRB, 0.37100323E-03_JPRB, 0.37100288E-03_JPRB, 0.37100035E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100349E-03_JPRB, 0.37099910E-03_JPRB, 0.37099799E-03_JPRB /)

RGHG1(:,83, 5) = (/ &
  & 0.37099628E-03_JPRB, 0.37099593E-03_JPRB, 0.37100387E-03_JPRB, 0.37100122E-03_JPRB, 0.37100268E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37099951E-03_JPRB, 0.37100085E-03_JPRB, 0.37100224E-03_JPRB, 0.37100236E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099567E-03_JPRB, 0.37099703E-03_JPRB, 0.37100160E-03_JPRB, 0.37100661E-03_JPRB, 0.37100556E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100300E-03_JPRB, 0.37100186E-03_JPRB, 0.37099881E-03_JPRB, 0.37099732E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100192E-03_JPRB, 0.37100285E-03_JPRB, 0.37099901E-03_JPRB, 0.37099849E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099974E-03_JPRB, 0.37100274E-03_JPRB, 0.37100003E-03_JPRB, 0.37100242E-03_JPRB, 0.37100501E-03_JPRB, &
  & 0.37100445E-03_JPRB, 0.37100236E-03_JPRB, 0.37100224E-03_JPRB, 0.37100073E-03_JPRB, 0.37099939E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099718E-03_JPRB, 0.37099724E-03_JPRB, 0.37100253E-03_JPRB, 0.37100277E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099683E-03_JPRB, 0.37099904E-03_JPRB, 0.37100329E-03_JPRB, 0.37099834E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100347E-03_JPRB, 0.37100335E-03_JPRB, 0.37100294E-03_JPRB, 0.37100044E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100367E-03_JPRB, 0.37099910E-03_JPRB, 0.37099794E-03_JPRB /)

RGHG1(:,84, 5) = (/ &
  & 0.37099622E-03_JPRB, 0.37099584E-03_JPRB, 0.37100402E-03_JPRB, 0.37100131E-03_JPRB, 0.37100265E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099951E-03_JPRB, 0.37100137E-03_JPRB, 0.37100207E-03_JPRB, 0.37100218E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37099354E-03_JPRB, 0.37099584E-03_JPRB, 0.37099709E-03_JPRB, 0.37100163E-03_JPRB, 0.37100670E-03_JPRB, 0.37100574E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100317E-03_JPRB, 0.37100201E-03_JPRB, 0.37099878E-03_JPRB, 0.37099721E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100189E-03_JPRB, 0.37100297E-03_JPRB, 0.37099898E-03_JPRB, 0.37099849E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099977E-03_JPRB, 0.37100282E-03_JPRB, 0.37100003E-03_JPRB, 0.37100253E-03_JPRB, 0.37100510E-03_JPRB, &
  & 0.37100454E-03_JPRB, 0.37100259E-03_JPRB, 0.37100224E-03_JPRB, 0.37100076E-03_JPRB, 0.37099942E-03_JPRB, 0.37099750E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099715E-03_JPRB, 0.37099718E-03_JPRB, 0.37100253E-03_JPRB, 0.37100288E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099671E-03_JPRB, 0.37099895E-03_JPRB, 0.37100341E-03_JPRB, 0.37099826E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100352E-03_JPRB, 0.37100335E-03_JPRB, 0.37100303E-03_JPRB, 0.37100044E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100376E-03_JPRB, 0.37099913E-03_JPRB, 0.37099788E-03_JPRB /)

RGHG1(:,85, 5) = (/ &
  & 0.37099610E-03_JPRB, 0.37099578E-03_JPRB, 0.37100416E-03_JPRB, 0.37100140E-03_JPRB, 0.37100288E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099986E-03_JPRB, 0.37100090E-03_JPRB, 0.37100195E-03_JPRB, 0.37100184E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099648E-03_JPRB, 0.37099762E-03_JPRB, 0.37100160E-03_JPRB, 0.37100640E-03_JPRB, 0.37100579E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100329E-03_JPRB, 0.37100201E-03_JPRB, 0.37099863E-03_JPRB, 0.37099712E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100358E-03_JPRB, 0.37100192E-03_JPRB, 0.37100309E-03_JPRB, 0.37099895E-03_JPRB, 0.37099840E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099968E-03_JPRB, 0.37100277E-03_JPRB, 0.37099997E-03_JPRB, 0.37100262E-03_JPRB, 0.37100521E-03_JPRB, &
  & 0.37100463E-03_JPRB, 0.37100265E-03_JPRB, 0.37100218E-03_JPRB, 0.37100073E-03_JPRB, 0.37099939E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099712E-03_JPRB, 0.37099724E-03_JPRB, 0.37100242E-03_JPRB, 0.37100288E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099668E-03_JPRB, 0.37099904E-03_JPRB, 0.37100355E-03_JPRB, 0.37099826E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100364E-03_JPRB, 0.37100347E-03_JPRB, 0.37100312E-03_JPRB, 0.37100044E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100387E-03_JPRB, 0.37099907E-03_JPRB, 0.37099782E-03_JPRB /)

RGHG1(:,86, 5) = (/ &
  & 0.37099596E-03_JPRB, 0.37099575E-03_JPRB, 0.37100422E-03_JPRB, 0.37100134E-03_JPRB, 0.37100262E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37099997E-03_JPRB, 0.37100120E-03_JPRB, 0.37100160E-03_JPRB, 0.37100137E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099590E-03_JPRB, 0.37099680E-03_JPRB, 0.37099794E-03_JPRB, 0.37100143E-03_JPRB, 0.37100579E-03_JPRB, 0.37100571E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100338E-03_JPRB, 0.37100210E-03_JPRB, 0.37099863E-03_JPRB, 0.37099706E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100376E-03_JPRB, 0.37100195E-03_JPRB, 0.37100317E-03_JPRB, 0.37099890E-03_JPRB, 0.37099840E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099971E-03_JPRB, 0.37100282E-03_JPRB, 0.37099991E-03_JPRB, 0.37100265E-03_JPRB, 0.37100527E-03_JPRB, &
  & 0.37100466E-03_JPRB, 0.37100268E-03_JPRB, 0.37100221E-03_JPRB, 0.37100070E-03_JPRB, 0.37099930E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099706E-03_JPRB, 0.37099712E-03_JPRB, 0.37100242E-03_JPRB, 0.37100282E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099668E-03_JPRB, 0.37099893E-03_JPRB, 0.37100358E-03_JPRB, 0.37099817E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100364E-03_JPRB, 0.37100352E-03_JPRB, 0.37100317E-03_JPRB, 0.37100041E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100399E-03_JPRB, 0.37099904E-03_JPRB, 0.37099779E-03_JPRB /)

RGHG1(:,87, 5) = (/ &
  & 0.37099593E-03_JPRB, 0.37099590E-03_JPRB, 0.37100416E-03_JPRB, 0.37100143E-03_JPRB, 0.37100280E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100015E-03_JPRB, 0.37100079E-03_JPRB, 0.37100131E-03_JPRB, 0.37100111E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099770E-03_JPRB, 0.37099852E-03_JPRB, 0.37100143E-03_JPRB, 0.37100521E-03_JPRB, 0.37100544E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100341E-03_JPRB, 0.37100216E-03_JPRB, 0.37099858E-03_JPRB, 0.37099692E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100381E-03_JPRB, 0.37100195E-03_JPRB, 0.37100326E-03_JPRB, 0.37099893E-03_JPRB, 0.37099834E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099968E-03_JPRB, 0.37100288E-03_JPRB, 0.37099977E-03_JPRB, 0.37100274E-03_JPRB, 0.37100556E-03_JPRB, &
  & 0.37100504E-03_JPRB, 0.37100271E-03_JPRB, 0.37100236E-03_JPRB, 0.37100070E-03_JPRB, 0.37099925E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099692E-03_JPRB, 0.37099706E-03_JPRB, 0.37100242E-03_JPRB, 0.37100282E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099665E-03_JPRB, 0.37099881E-03_JPRB, 0.37100349E-03_JPRB, 0.37099820E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37100364E-03_JPRB, 0.37100358E-03_JPRB, 0.37100315E-03_JPRB, 0.37100041E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100402E-03_JPRB, 0.37099895E-03_JPRB, 0.37099770E-03_JPRB /)

RGHG1(:,88, 5) = (/ &
  & 0.37099587E-03_JPRB, 0.37099631E-03_JPRB, 0.37100390E-03_JPRB, 0.37100143E-03_JPRB, 0.37100248E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100018E-03_JPRB, 0.37100108E-03_JPRB, 0.37100131E-03_JPRB, 0.37100096E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37099735E-03_JPRB, 0.37099776E-03_JPRB, 0.37099863E-03_JPRB, 0.37100131E-03_JPRB, 0.37100504E-03_JPRB, 0.37100544E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100344E-03_JPRB, 0.37100216E-03_JPRB, 0.37099852E-03_JPRB, 0.37099683E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100201E-03_JPRB, 0.37100335E-03_JPRB, 0.37099884E-03_JPRB, 0.37099834E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099962E-03_JPRB, 0.37100294E-03_JPRB, 0.37099965E-03_JPRB, 0.37100274E-03_JPRB, 0.37100574E-03_JPRB, &
  & 0.37100527E-03_JPRB, 0.37100274E-03_JPRB, 0.37100256E-03_JPRB, 0.37100067E-03_JPRB, 0.37099910E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099660E-03_JPRB, 0.37099660E-03_JPRB, 0.37100262E-03_JPRB, 0.37100280E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099671E-03_JPRB, 0.37099881E-03_JPRB, 0.37100341E-03_JPRB, 0.37099814E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100128E-03_JPRB, 0.37100364E-03_JPRB, 0.37100358E-03_JPRB, 0.37100320E-03_JPRB, 0.37100032E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100411E-03_JPRB, 0.37099890E-03_JPRB, 0.37099770E-03_JPRB /)

RGHG1(:,89, 5) = (/ &
  & 0.37099601E-03_JPRB, 0.37099680E-03_JPRB, 0.37100347E-03_JPRB, 0.37100154E-03_JPRB, 0.37100294E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100003E-03_JPRB, 0.37100076E-03_JPRB, 0.37100114E-03_JPRB, 0.37100088E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099788E-03_JPRB, 0.37099855E-03_JPRB, 0.37100140E-03_JPRB, 0.37100536E-03_JPRB, 0.37100562E-03_JPRB, &
  & 0.37100221E-03_JPRB, 0.37100352E-03_JPRB, 0.37100224E-03_JPRB, 0.37099840E-03_JPRB, 0.37099671E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37100399E-03_JPRB, 0.37100201E-03_JPRB, 0.37100341E-03_JPRB, 0.37099884E-03_JPRB, 0.37099831E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099962E-03_JPRB, 0.37100312E-03_JPRB, 0.37099954E-03_JPRB, 0.37100271E-03_JPRB, 0.37100600E-03_JPRB, &
  & 0.37100559E-03_JPRB, 0.37100268E-03_JPRB, 0.37100282E-03_JPRB, 0.37100067E-03_JPRB, 0.37099913E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099642E-03_JPRB, 0.37099642E-03_JPRB, 0.37100285E-03_JPRB, 0.37100291E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099671E-03_JPRB, 0.37099872E-03_JPRB, 0.37100329E-03_JPRB, 0.37099805E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100361E-03_JPRB, 0.37100367E-03_JPRB, 0.37100326E-03_JPRB, 0.37100026E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37100416E-03_JPRB, 0.37099881E-03_JPRB, 0.37099767E-03_JPRB /)

RGHG1(:,90, 5) = (/ &
  & 0.37099622E-03_JPRB, 0.37099741E-03_JPRB, 0.37100303E-03_JPRB, 0.37100143E-03_JPRB, 0.37100303E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37099986E-03_JPRB, 0.37100120E-03_JPRB, 0.37100154E-03_JPRB, 0.37100111E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099712E-03_JPRB, 0.37099788E-03_JPRB, 0.37100143E-03_JPRB, 0.37100623E-03_JPRB, 0.37100626E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100367E-03_JPRB, 0.37100236E-03_JPRB, 0.37099837E-03_JPRB, 0.37099663E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37100425E-03_JPRB, 0.37100198E-03_JPRB, 0.37100370E-03_JPRB, 0.37099869E-03_JPRB, 0.37099831E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099954E-03_JPRB, 0.37100338E-03_JPRB, 0.37099927E-03_JPRB, 0.37100277E-03_JPRB, 0.37100623E-03_JPRB, &
  & 0.37100582E-03_JPRB, 0.37100259E-03_JPRB, 0.37100309E-03_JPRB, 0.37100061E-03_JPRB, 0.37099925E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099613E-03_JPRB, 0.37099607E-03_JPRB, 0.37100317E-03_JPRB, 0.37100315E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099663E-03_JPRB, 0.37099866E-03_JPRB, 0.37100361E-03_JPRB, 0.37099788E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100373E-03_JPRB, 0.37100370E-03_JPRB, 0.37100341E-03_JPRB, 0.37100021E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37100128E-03_JPRB, 0.37100445E-03_JPRB, 0.37099869E-03_JPRB, 0.37099767E-03_JPRB /)

RGHG1(:,91, 5) = (/ &
  & 0.37099651E-03_JPRB, 0.37099811E-03_JPRB, 0.37100312E-03_JPRB, 0.37100093E-03_JPRB, 0.37100390E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37099840E-03_JPRB, 0.37100152E-03_JPRB, 0.37100317E-03_JPRB, 0.37100399E-03_JPRB, 0.37100416E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37099674E-03_JPRB, 0.37099613E-03_JPRB, 0.37100160E-03_JPRB, 0.37100833E-03_JPRB, 0.37100702E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100399E-03_JPRB, 0.37100253E-03_JPRB, 0.37099814E-03_JPRB, 0.37099631E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100475E-03_JPRB, 0.37100169E-03_JPRB, 0.37100419E-03_JPRB, 0.37099843E-03_JPRB, 0.37099837E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37099922E-03_JPRB, 0.37100405E-03_JPRB, 0.37099863E-03_JPRB, 0.37100268E-03_JPRB, 0.37100652E-03_JPRB, &
  & 0.37100608E-03_JPRB, 0.37100224E-03_JPRB, 0.37100347E-03_JPRB, 0.37100055E-03_JPRB, 0.37099948E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099581E-03_JPRB, 0.37099546E-03_JPRB, 0.37100381E-03_JPRB, 0.37100387E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099601E-03_JPRB, 0.37099828E-03_JPRB, 0.37100460E-03_JPRB, 0.37099721E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100393E-03_JPRB, 0.37100376E-03_JPRB, 0.37100355E-03_JPRB, 0.37100000E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100492E-03_JPRB, 0.37099834E-03_JPRB, 0.37099759E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG1(:, 1, 6) = (/ &
  & 0.36033167E-03_JPRB, 0.36036829E-03_JPRB, 0.36038470E-03_JPRB, 0.36039850E-03_JPRB, 0.36042204E-03_JPRB, 0.36047105E-03_JPRB, &
  & 0.36054058E-03_JPRB, 0.36062542E-03_JPRB, 0.36072251E-03_JPRB, 0.36082920E-03_JPRB, 0.36094166E-03_JPRB, 0.36105583E-03_JPRB, &
  & 0.36116783E-03_JPRB, 0.36127304E-03_JPRB, 0.36136602E-03_JPRB, 0.36144195E-03_JPRB, 0.36149769E-03_JPRB, 0.36153215E-03_JPRB, &
  & 0.36154612E-03_JPRB, 0.36154225E-03_JPRB, 0.36152435E-03_JPRB, 0.36149798E-03_JPRB, 0.36147045E-03_JPRB, 0.36145098E-03_JPRB, &
  & 0.36144847E-03_JPRB, 0.36146623E-03_JPRB, 0.36149853E-03_JPRB, 0.36153372E-03_JPRB, 0.36156341E-03_JPRB, 0.36157915E-03_JPRB, &
  & 0.36157461E-03_JPRB, 0.36154161E-03_JPRB, 0.36147030E-03_JPRB, 0.36135467E-03_JPRB, 0.36119195E-03_JPRB, 0.36098328E-03_JPRB, &
  & 0.36073374E-03_JPRB, 0.36045257E-03_JPRB, 0.36016654E-03_JPRB, 0.35992768E-03_JPRB, 0.35971234E-03_JPRB, 0.35949415E-03_JPRB, &
  & 0.35925742E-03_JPRB, 0.35898059E-03_JPRB, 0.35863655E-03_JPRB, 0.35817499E-03_JPRB, 0.35752822E-03_JPRB, 0.35673732E-03_JPRB, &
  & 0.35609101E-03_JPRB, 0.35571287E-03_JPRB, 0.35546950E-03_JPRB, 0.35531638E-03_JPRB, 0.35522477E-03_JPRB, 0.35516138E-03_JPRB, &
  & 0.35510201E-03_JPRB, 0.35505299E-03_JPRB, 0.35503620E-03_JPRB, 0.35507188E-03_JPRB, 0.35509330E-03_JPRB, 0.35510995E-03_JPRB, &
  & 0.35511676E-03_JPRB, 0.35509898E-03_JPRB, 0.35505410E-03_JPRB, 0.35493483E-03_JPRB /)

RGHG1(:, 2, 6) = (/ &
  & 0.36058135E-03_JPRB, 0.36081334E-03_JPRB, 0.36095543E-03_JPRB, 0.36107836E-03_JPRB, 0.36122176E-03_JPRB, 0.36141474E-03_JPRB, &
  & 0.36164996E-03_JPRB, 0.36190441E-03_JPRB, 0.36215450E-03_JPRB, 0.36238245E-03_JPRB, 0.36257377E-03_JPRB, 0.36271790E-03_JPRB, &
  & 0.36281548E-03_JPRB, 0.36288024E-03_JPRB, 0.36293210E-03_JPRB, 0.36298568E-03_JPRB, 0.36304430E-03_JPRB, 0.36310370E-03_JPRB, &
  & 0.36315783E-03_JPRB, 0.36320294E-03_JPRB, 0.36323871E-03_JPRB, 0.36326837E-03_JPRB, 0.36329776E-03_JPRB, 0.36333504E-03_JPRB, &
  & 0.36338822E-03_JPRB, 0.36346199E-03_JPRB, 0.36355507E-03_JPRB, 0.36366103E-03_JPRB, 0.36377143E-03_JPRB, 0.36387422E-03_JPRB, &
  & 0.36395539E-03_JPRB, 0.36400012E-03_JPRB, 0.36400164E-03_JPRB, 0.36395653E-03_JPRB, 0.36386345E-03_JPRB, 0.36372128E-03_JPRB, &
  & 0.36353135E-03_JPRB, 0.36329959E-03_JPRB, 0.36304674E-03_JPRB, 0.36279979E-03_JPRB, 0.36256530E-03_JPRB, 0.36233146E-03_JPRB, &
  & 0.36208448E-03_JPRB, 0.36180665E-03_JPRB, 0.36147638E-03_JPRB, 0.36106561E-03_JPRB, 0.36055790E-03_JPRB, 0.35999619E-03_JPRB, &
  & 0.35949479E-03_JPRB, 0.35914042E-03_JPRB, 0.35891455E-03_JPRB, 0.35878347E-03_JPRB, 0.35870870E-03_JPRB, 0.35865017E-03_JPRB, &
  & 0.35857919E-03_JPRB, 0.35847843E-03_JPRB, 0.35835139E-03_JPRB, 0.35820721E-03_JPRB, 0.35803844E-03_JPRB, 0.35784024E-03_JPRB, &
  & 0.35760261E-03_JPRB, 0.35731733E-03_JPRB, 0.35697574E-03_JPRB, 0.35631593E-03_JPRB /)

RGHG1(:, 3, 6) = (/ &
  & 0.36091424E-03_JPRB, 0.36124213E-03_JPRB, 0.36141838E-03_JPRB, 0.36156847E-03_JPRB, 0.36173640E-03_JPRB, 0.36194455E-03_JPRB, &
  & 0.36218303E-03_JPRB, 0.36241685E-03_JPRB, 0.36261827E-03_JPRB, 0.36278352E-03_JPRB, 0.36293082E-03_JPRB, 0.36309310E-03_JPRB, &
  & 0.36329354E-03_JPRB, 0.36352832E-03_JPRB, 0.36377355E-03_JPRB, 0.36400379E-03_JPRB, 0.36420309E-03_JPRB, 0.36436535E-03_JPRB, &
  & 0.36449087E-03_JPRB, 0.36458392E-03_JPRB, 0.36465056E-03_JPRB, 0.36469783E-03_JPRB, 0.36473371E-03_JPRB, 0.36476614E-03_JPRB, &
  & 0.36480231E-03_JPRB, 0.36484582E-03_JPRB, 0.36489603E-03_JPRB, 0.36494882E-03_JPRB, 0.36499868E-03_JPRB, 0.36503794E-03_JPRB, &
  & 0.36505886E-03_JPRB, 0.36505755E-03_JPRB, 0.36503319E-03_JPRB, 0.36498593E-03_JPRB, 0.36491785E-03_JPRB, 0.36482912E-03_JPRB, &
  & 0.36471896E-03_JPRB, 0.36458820E-03_JPRB, 0.36444102E-03_JPRB, 0.36428749E-03_JPRB, 0.36413080E-03_JPRB, 0.36396994E-03_JPRB, &
  & 0.36379957E-03_JPRB, 0.36361118E-03_JPRB, 0.36339706E-03_JPRB, 0.36314974E-03_JPRB, 0.36287145E-03_JPRB, 0.36258000E-03_JPRB, &
  & 0.36231134E-03_JPRB, 0.36208413E-03_JPRB, 0.36189682E-03_JPRB, 0.36173742E-03_JPRB, 0.36158736E-03_JPRB, 0.36142900E-03_JPRB, &
  & 0.36125159E-03_JPRB, 0.36105135E-03_JPRB, 0.36083639E-03_JPRB, 0.36060991E-03_JPRB, 0.36037224E-03_JPRB, 0.36012102E-03_JPRB, &
  & 0.35985481E-03_JPRB, 0.35956508E-03_JPRB, 0.35917401E-03_JPRB, 0.35850087E-03_JPRB /)

RGHG1(:, 4, 6) = (/ &
  & 0.36117327E-03_JPRB, 0.36153148E-03_JPRB, 0.36172790E-03_JPRB, 0.36189717E-03_JPRB, 0.36207767E-03_JPRB, 0.36228908E-03_JPRB, &
  & 0.36252063E-03_JPRB, 0.36275448E-03_JPRB, 0.36298978E-03_JPRB, 0.36323949E-03_JPRB, 0.36351712E-03_JPRB, 0.36381435E-03_JPRB, &
  & 0.36411241E-03_JPRB, 0.36439343E-03_JPRB, 0.36464451E-03_JPRB, 0.36485851E-03_JPRB, 0.36503631E-03_JPRB, 0.36518177E-03_JPRB, &
  & 0.36529772E-03_JPRB, 0.36538619E-03_JPRB, 0.36545051E-03_JPRB, 0.36549501E-03_JPRB, 0.36552423E-03_JPRB, 0.36554266E-03_JPRB, &
  & 0.36555418E-03_JPRB, 0.36556215E-03_JPRB, 0.36556783E-03_JPRB, 0.36556995E-03_JPRB, 0.36556585E-03_JPRB, 0.36555197E-03_JPRB, &
  & 0.36552615E-03_JPRB, 0.36548800E-03_JPRB, 0.36543887E-03_JPRB, 0.36538139E-03_JPRB, 0.36531792E-03_JPRB, 0.36524897E-03_JPRB, &
  & 0.36517467E-03_JPRB, 0.36509347E-03_JPRB, 0.36500549E-03_JPRB, 0.36490982E-03_JPRB, 0.36480743E-03_JPRB, 0.36469768E-03_JPRB, &
  & 0.36457926E-03_JPRB, 0.36445170E-03_JPRB, 0.36431401E-03_JPRB, 0.36416604E-03_JPRB, 0.36401238E-03_JPRB, 0.36385906E-03_JPRB, &
  & 0.36370812E-03_JPRB, 0.36356883E-03_JPRB, 0.36342454E-03_JPRB, 0.36328216E-03_JPRB, 0.36312258E-03_JPRB, 0.36293827E-03_JPRB, &
  & 0.36272465E-03_JPRB, 0.36248707E-03_JPRB, 0.36223524E-03_JPRB, 0.36198407E-03_JPRB, 0.36173788E-03_JPRB, 0.36149719E-03_JPRB, &
  & 0.36125517E-03_JPRB, 0.36099399E-03_JPRB, 0.36070964E-03_JPRB, 0.36022611E-03_JPRB /)

RGHG1(:, 5, 6) = (/ &
  & 0.36135266E-03_JPRB, 0.36170697E-03_JPRB, 0.36191189E-03_JPRB, 0.36210250E-03_JPRB, 0.36231161E-03_JPRB, 0.36255197E-03_JPRB, &
  & 0.36281941E-03_JPRB, 0.36310690E-03_JPRB, 0.36340754E-03_JPRB, 0.36372154E-03_JPRB, 0.36403936E-03_JPRB, 0.36435394E-03_JPRB, &
  & 0.36465464E-03_JPRB, 0.36493072E-03_JPRB, 0.36517574E-03_JPRB, 0.36538622E-03_JPRB, 0.36555881E-03_JPRB, 0.36569405E-03_JPRB, &
  & 0.36579766E-03_JPRB, 0.36587563E-03_JPRB, 0.36593236E-03_JPRB, 0.36597159E-03_JPRB, 0.36599633E-03_JPRB, 0.36600858E-03_JPRB, &
  & 0.36600974E-03_JPRB, 0.36600075E-03_JPRB, 0.36598195E-03_JPRB, 0.36595340E-03_JPRB, 0.36591507E-03_JPRB, 0.36586649E-03_JPRB, &
  & 0.36580852E-03_JPRB, 0.36574321E-03_JPRB, 0.36567374E-03_JPRB, 0.36560404E-03_JPRB, 0.36553753E-03_JPRB, 0.36547572E-03_JPRB, &
  & 0.36541652E-03_JPRB, 0.36535866E-03_JPRB, 0.36529946E-03_JPRB, 0.36523721E-03_JPRB, 0.36517021E-03_JPRB, 0.36509742E-03_JPRB, &
  & 0.36501957E-03_JPRB, 0.36493607E-03_JPRB, 0.36484850E-03_JPRB, 0.36475735E-03_JPRB, 0.36466241E-03_JPRB, 0.36456488E-03_JPRB, &
  & 0.36446130E-03_JPRB, 0.36435304E-03_JPRB, 0.36423199E-03_JPRB, 0.36409730E-03_JPRB, 0.36394520E-03_JPRB, 0.36376575E-03_JPRB, &
  & 0.36356336E-03_JPRB, 0.36333752E-03_JPRB, 0.36309793E-03_JPRB, 0.36285556E-03_JPRB, 0.36261854E-03_JPRB, 0.36238815E-03_JPRB, &
  & 0.36216629E-03_JPRB, 0.36195049E-03_JPRB, 0.36170479E-03_JPRB, 0.36127656E-03_JPRB /)

RGHG1(:, 6, 6) = (/ &
  & 0.36146719E-03_JPRB, 0.36177356E-03_JPRB, 0.36197994E-03_JPRB, 0.36219831E-03_JPRB, 0.36245171E-03_JPRB, 0.36274170E-03_JPRB, &
  & 0.36305815E-03_JPRB, 0.36338973E-03_JPRB, 0.36372896E-03_JPRB, 0.36406764E-03_JPRB, 0.36440211E-03_JPRB, 0.36472330E-03_JPRB, &
  & 0.36502228E-03_JPRB, 0.36529047E-03_JPRB, 0.36552156E-03_JPRB, 0.36571320E-03_JPRB, 0.36586879E-03_JPRB, 0.36599246E-03_JPRB, &
  & 0.36608794E-03_JPRB, 0.36616015E-03_JPRB, 0.36621367E-03_JPRB, 0.36625189E-03_JPRB, 0.36627697E-03_JPRB, 0.36629007E-03_JPRB, &
  & 0.36629091E-03_JPRB, 0.36627916E-03_JPRB, 0.36625381E-03_JPRB, 0.36621455E-03_JPRB, 0.36616181E-03_JPRB, 0.36609630E-03_JPRB, &
  & 0.36602019E-03_JPRB, 0.36593759E-03_JPRB, 0.36585415E-03_JPRB, 0.36577543E-03_JPRB, 0.36570567E-03_JPRB, 0.36564501E-03_JPRB, &
  & 0.36559242E-03_JPRB, 0.36554452E-03_JPRB, 0.36549888E-03_JPRB, 0.36545226E-03_JPRB, 0.36540313E-03_JPRB, 0.36535109E-03_JPRB, &
  & 0.36529574E-03_JPRB, 0.36523782E-03_JPRB, 0.36517717E-03_JPRB, 0.36511343E-03_JPRB, 0.36504579E-03_JPRB, 0.36497272E-03_JPRB, &
  & 0.36489134E-03_JPRB, 0.36479987E-03_JPRB, 0.36469573E-03_JPRB, 0.36457367E-03_JPRB, 0.36443380E-03_JPRB, 0.36427172E-03_JPRB, &
  & 0.36408516E-03_JPRB, 0.36387937E-03_JPRB, 0.36366296E-03_JPRB, 0.36344057E-03_JPRB, 0.36321761E-03_JPRB, 0.36300262E-03_JPRB, &
  & 0.36279747E-03_JPRB, 0.36259595E-03_JPRB, 0.36237846E-03_JPRB, 0.36202779E-03_JPRB /)

RGHG1(:, 7, 6) = (/ &
  & 0.36147278E-03_JPRB, 0.36167115E-03_JPRB, 0.36185965E-03_JPRB, 0.36210104E-03_JPRB, 0.36239676E-03_JPRB, 0.36272954E-03_JPRB, &
  & 0.36309025E-03_JPRB, 0.36345996E-03_JPRB, 0.36383193E-03_JPRB, 0.36419870E-03_JPRB, 0.36455295E-03_JPRB, 0.36488642E-03_JPRB, &
  & 0.36518983E-03_JPRB, 0.36545639E-03_JPRB, 0.36568206E-03_JPRB, 0.36586792E-03_JPRB, 0.36601649E-03_JPRB, 0.36613352E-03_JPRB, &
  & 0.36622485E-03_JPRB, 0.36629548E-03_JPRB, 0.36634921E-03_JPRB, 0.36638966E-03_JPRB, 0.36641903E-03_JPRB, 0.36643774E-03_JPRB, &
  & 0.36644493E-03_JPRB, 0.36643932E-03_JPRB, 0.36641938E-03_JPRB, 0.36638384E-03_JPRB, 0.36633245E-03_JPRB, 0.36626591E-03_JPRB, &
  & 0.36618722E-03_JPRB, 0.36610171E-03_JPRB, 0.36601539E-03_JPRB, 0.36593486E-03_JPRB, 0.36586396E-03_JPRB, 0.36580436E-03_JPRB, &
  & 0.36575377E-03_JPRB, 0.36570884E-03_JPRB, 0.36566672E-03_JPRB, 0.36562464E-03_JPRB, 0.36558131E-03_JPRB, 0.36553602E-03_JPRB, &
  & 0.36548916E-03_JPRB, 0.36544021E-03_JPRB, 0.36538928E-03_JPRB, 0.36533590E-03_JPRB, 0.36527909E-03_JPRB, 0.36521739E-03_JPRB, &
  & 0.36514879E-03_JPRB, 0.36507123E-03_JPRB, 0.36498258E-03_JPRB, 0.36488028E-03_JPRB, 0.36476206E-03_JPRB, 0.36462693E-03_JPRB, &
  & 0.36447341E-03_JPRB, 0.36430443E-03_JPRB, 0.36412312E-03_JPRB, 0.36393589E-03_JPRB, 0.36374945E-03_JPRB, 0.36356901E-03_JPRB, &
  & 0.36339689E-03_JPRB, 0.36322940E-03_JPRB, 0.36304636E-03_JPRB, 0.36274368E-03_JPRB /)

RGHG1(:, 8, 6) = (/ &
  & 0.36127513E-03_JPRB, 0.36133255E-03_JPRB, 0.36149580E-03_JPRB, 0.36174248E-03_JPRB, 0.36205127E-03_JPRB, 0.36241472E-03_JPRB, &
  & 0.36279694E-03_JPRB, 0.36320457E-03_JPRB, 0.36361389E-03_JPRB, 0.36401916E-03_JPRB, 0.36441034E-03_JPRB, 0.36477658E-03_JPRB, &
  & 0.36510872E-03_JPRB, 0.36539827E-03_JPRB, 0.36564301E-03_JPRB, 0.36584274E-03_JPRB, 0.36600314E-03_JPRB, 0.36613017E-03_JPRB, &
  & 0.36623079E-03_JPRB, 0.36631149E-03_JPRB, 0.36637738E-03_JPRB, 0.36643053E-03_JPRB, 0.36647310E-03_JPRB, 0.36650605E-03_JPRB, &
  & 0.36652799E-03_JPRB, 0.36653710E-03_JPRB, 0.36653175E-03_JPRB, 0.36651030E-03_JPRB, 0.36647150E-03_JPRB, 0.36641560E-03_JPRB, &
  & 0.36634470E-03_JPRB, 0.36626455E-03_JPRB, 0.36618268E-03_JPRB, 0.36610581E-03_JPRB, 0.36603928E-03_JPRB, 0.36598323E-03_JPRB, &
  & 0.36593646E-03_JPRB, 0.36589539E-03_JPRB, 0.36585692E-03_JPRB, 0.36581792E-03_JPRB, 0.36577607E-03_JPRB, 0.36573084E-03_JPRB, &
  & 0.36568189E-03_JPRB, 0.36562982E-03_JPRB, 0.36557522E-03_JPRB, 0.36551812E-03_JPRB, 0.36545837E-03_JPRB, 0.36539562E-03_JPRB, &
  & 0.36532903E-03_JPRB, 0.36525761E-03_JPRB, 0.36517993E-03_JPRB, 0.36509446E-03_JPRB, 0.36499920E-03_JPRB, 0.36489387E-03_JPRB, &
  & 0.36477932E-03_JPRB, 0.36465802E-03_JPRB, 0.36453205E-03_JPRB, 0.36440557E-03_JPRB, 0.36428333E-03_JPRB, 0.36416805E-03_JPRB, &
  & 0.36406080E-03_JPRB, 0.36395743E-03_JPRB, 0.36384640E-03_JPRB, 0.36365833E-03_JPRB /)

RGHG1(:, 9, 6) = (/ &
  & 0.36105677E-03_JPRB, 0.36130680E-03_JPRB, 0.36159693E-03_JPRB, 0.36189100E-03_JPRB, 0.36219723E-03_JPRB, 0.36250090E-03_JPRB, &
  & 0.36283812E-03_JPRB, 0.36318536E-03_JPRB, 0.36355585E-03_JPRB, 0.36393121E-03_JPRB, 0.36430047E-03_JPRB, 0.36465115E-03_JPRB, &
  & 0.36497277E-03_JPRB, 0.36525886E-03_JPRB, 0.36550534E-03_JPRB, 0.36571332E-03_JPRB, 0.36588509E-03_JPRB, 0.36602674E-03_JPRB, &
  & 0.36614452E-03_JPRB, 0.36624397E-03_JPRB, 0.36632986E-03_JPRB, 0.36640652E-03_JPRB, 0.36647351E-03_JPRB, 0.36652971E-03_JPRB, &
  & 0.36657543E-03_JPRB, 0.36660820E-03_JPRB, 0.36662523E-03_JPRB, 0.36662415E-03_JPRB, 0.36660407E-03_JPRB, 0.36656560E-03_JPRB, &
  & 0.36651158E-03_JPRB, 0.36644851E-03_JPRB, 0.36638326E-03_JPRB, 0.36632238E-03_JPRB, 0.36626894E-03_JPRB, 0.36622366E-03_JPRB, &
  & 0.36618466E-03_JPRB, 0.36614906E-03_JPRB, 0.36611356E-03_JPRB, 0.36607488E-03_JPRB, 0.36603102E-03_JPRB, 0.36598073E-03_JPRB, &
  & 0.36592377E-03_JPRB, 0.36586088E-03_JPRB, 0.36579289E-03_JPRB, 0.36572065E-03_JPRB, 0.36564568E-03_JPRB, 0.36556897E-03_JPRB, &
  & 0.36549137E-03_JPRB, 0.36541291E-03_JPRB, 0.36533456E-03_JPRB, 0.36525604E-03_JPRB, 0.36517752E-03_JPRB, 0.36509868E-03_JPRB, &
  & 0.36501981E-03_JPRB, 0.36494245E-03_JPRB, 0.36486838E-03_JPRB, 0.36479987E-03_JPRB, 0.36473895E-03_JPRB, 0.36468642E-03_JPRB, &
  & 0.36464250E-03_JPRB, 0.36460557E-03_JPRB, 0.36457382E-03_JPRB, 0.36453272E-03_JPRB /)

RGHG1(:,10, 6) = (/ &
  & 0.36170013E-03_JPRB, 0.36260107E-03_JPRB, 0.36304581E-03_JPRB, 0.36334866E-03_JPRB, 0.36357561E-03_JPRB, 0.36378458E-03_JPRB, &
  & 0.36397754E-03_JPRB, 0.36418790E-03_JPRB, 0.36440545E-03_JPRB, 0.36463348E-03_JPRB, 0.36486023E-03_JPRB, 0.36507696E-03_JPRB, &
  & 0.36527734E-03_JPRB, 0.36545767E-03_JPRB, 0.36561792E-03_JPRB, 0.36575965E-03_JPRB, 0.36588556E-03_JPRB, 0.36599848E-03_JPRB, &
  & 0.36610221E-03_JPRB, 0.36620037E-03_JPRB, 0.36629569E-03_JPRB, 0.36638815E-03_JPRB, 0.36647863E-03_JPRB, 0.36656452E-03_JPRB, &
  & 0.36663754E-03_JPRB, 0.36669470E-03_JPRB, 0.36673452E-03_JPRB, 0.36675742E-03_JPRB, 0.36676385E-03_JPRB, 0.36675527E-03_JPRB, &
  & 0.36673364E-03_JPRB, 0.36670285E-03_JPRB, 0.36666868E-03_JPRB, 0.36663513E-03_JPRB, 0.36660451E-03_JPRB, 0.36657657E-03_JPRB, &
  & 0.36654950E-03_JPRB, 0.36652060E-03_JPRB, 0.36648667E-03_JPRB, 0.36644479E-03_JPRB, 0.36639316E-03_JPRB, 0.36633143E-03_JPRB, &
  & 0.36625931E-03_JPRB, 0.36617799E-03_JPRB, 0.36608838E-03_JPRB, 0.36599263E-03_JPRB, 0.36589205E-03_JPRB, 0.36578911E-03_JPRB, &
  & 0.36568561E-03_JPRB, 0.36558459E-03_JPRB, 0.36548870E-03_JPRB, 0.36539973E-03_JPRB, 0.36531835E-03_JPRB, 0.36524527E-03_JPRB, &
  & 0.36518101E-03_JPRB, 0.36512513E-03_JPRB, 0.36507705E-03_JPRB, 0.36503680E-03_JPRB, 0.36500394E-03_JPRB, 0.36497804E-03_JPRB, &
  & 0.36495866E-03_JPRB, 0.36494428E-03_JPRB, 0.36493727E-03_JPRB, 0.36492886E-03_JPRB /)

RGHG1(:,11, 6) = (/ &
  & 0.36331371E-03_JPRB, 0.36404567E-03_JPRB, 0.36431808E-03_JPRB, 0.36448138E-03_JPRB, 0.36460703E-03_JPRB, 0.36471340E-03_JPRB, &
  & 0.36482548E-03_JPRB, 0.36494149E-03_JPRB, 0.36507161E-03_JPRB, 0.36520930E-03_JPRB, 0.36535176E-03_JPRB, 0.36549362E-03_JPRB, &
  & 0.36563084E-03_JPRB, 0.36576029E-03_JPRB, 0.36587921E-03_JPRB, 0.36598631E-03_JPRB, 0.36608180E-03_JPRB, 0.36616821E-03_JPRB, &
  & 0.36624965E-03_JPRB, 0.36633087E-03_JPRB, 0.36641571E-03_JPRB, 0.36650657E-03_JPRB, 0.36659950E-03_JPRB, 0.36668751E-03_JPRB, &
  & 0.36676679E-03_JPRB, 0.36683484E-03_JPRB, 0.36689354E-03_JPRB, 0.36694194E-03_JPRB, 0.36697928E-03_JPRB, 0.36700745E-03_JPRB, &
  & 0.36702876E-03_JPRB, 0.36704523E-03_JPRB, 0.36705766E-03_JPRB, 0.36706499E-03_JPRB, 0.36706598E-03_JPRB, 0.36705914E-03_JPRB, &
  & 0.36704217E-03_JPRB, 0.36701359E-03_JPRB, 0.36697224E-03_JPRB, 0.36691729E-03_JPRB, 0.36684881E-03_JPRB, 0.36676764E-03_JPRB, &
  & 0.36667404E-03_JPRB, 0.36656938E-03_JPRB, 0.36645430E-03_JPRB, 0.36633035E-03_JPRB, 0.36620023E-03_JPRB, 0.36606714E-03_JPRB, &
  & 0.36593497E-03_JPRB, 0.36580727E-03_JPRB, 0.36568718E-03_JPRB, 0.36557662E-03_JPRB, 0.36547784E-03_JPRB, 0.36539204E-03_JPRB, &
  & 0.36531975E-03_JPRB, 0.36526029E-03_JPRB, 0.36521268E-03_JPRB, 0.36517510E-03_JPRB, 0.36514609E-03_JPRB, 0.36512414E-03_JPRB, &
  & 0.36510843E-03_JPRB, 0.36509722E-03_JPRB, 0.36509201E-03_JPRB, 0.36508738E-03_JPRB /)

RGHG1(:,12, 6) = (/ &
  & 0.36470831E-03_JPRB, 0.36502833E-03_JPRB, 0.36514964E-03_JPRB, 0.36522868E-03_JPRB, 0.36529161E-03_JPRB, 0.36535520E-03_JPRB, &
  & 0.36542476E-03_JPRB, 0.36551376E-03_JPRB, 0.36562260E-03_JPRB, 0.36575526E-03_JPRB, 0.36590683E-03_JPRB, 0.36607153E-03_JPRB, &
  & 0.36624106E-03_JPRB, 0.36640564E-03_JPRB, 0.36655532E-03_JPRB, 0.36668213E-03_JPRB, 0.36678073E-03_JPRB, 0.36685047E-03_JPRB, &
  & 0.36689578E-03_JPRB, 0.36692404E-03_JPRB, 0.36694569E-03_JPRB, 0.36696874E-03_JPRB, 0.36699674E-03_JPRB, 0.36703097E-03_JPRB, &
  & 0.36706956E-03_JPRB, 0.36711039E-03_JPRB, 0.36715169E-03_JPRB, 0.36719622E-03_JPRB, 0.36724735E-03_JPRB, 0.36730370E-03_JPRB, &
  & 0.36736485E-03_JPRB, 0.36742797E-03_JPRB, 0.36748606E-03_JPRB, 0.36753350E-03_JPRB, 0.36756636E-03_JPRB, 0.36758036E-03_JPRB, &
  & 0.36757326E-03_JPRB, 0.36754488E-03_JPRB, 0.36749593E-03_JPRB, 0.36742780E-03_JPRB, 0.36734284E-03_JPRB, 0.36724296E-03_JPRB, &
  & 0.36712980E-03_JPRB, 0.36700463E-03_JPRB, 0.36686895E-03_JPRB, 0.36672468E-03_JPRB, 0.36657398E-03_JPRB, 0.36642011E-03_JPRB, &
  & 0.36626638E-03_JPRB, 0.36611655E-03_JPRB, 0.36597389E-03_JPRB, 0.36584184E-03_JPRB, 0.36572304E-03_JPRB, 0.36561946E-03_JPRB, &
  & 0.36553125E-03_JPRB, 0.36545834E-03_JPRB, 0.36539932E-03_JPRB, 0.36535267E-03_JPRB, 0.36531690E-03_JPRB, 0.36529097E-03_JPRB, &
  & 0.36527327E-03_JPRB, 0.36526305E-03_JPRB, 0.36526233E-03_JPRB, 0.36527842E-03_JPRB /)

RGHG1(:,13, 6) = (/ &
  & 0.36559103E-03_JPRB, 0.36576742E-03_JPRB, 0.36583358E-03_JPRB, 0.36588262E-03_JPRB, 0.36592782E-03_JPRB, 0.36597715E-03_JPRB, &
  & 0.36604187E-03_JPRB, 0.36612680E-03_JPRB, 0.36624147E-03_JPRB, 0.36638480E-03_JPRB, 0.36655329E-03_JPRB, 0.36673708E-03_JPRB, &
  & 0.36692407E-03_JPRB, 0.36710268E-03_JPRB, 0.36726112E-03_JPRB, 0.36739057E-03_JPRB, 0.36748464E-03_JPRB, 0.36754191E-03_JPRB, &
  & 0.36756546E-03_JPRB, 0.36756229E-03_JPRB, 0.36754104E-03_JPRB, 0.36751234E-03_JPRB, 0.36748638E-03_JPRB, 0.36746843E-03_JPRB, &
  & 0.36746048E-03_JPRB, 0.36746467E-03_JPRB, 0.36748376E-03_JPRB, 0.36751718E-03_JPRB, 0.36756619E-03_JPRB, 0.36763487E-03_JPRB, &
  & 0.36771837E-03_JPRB, 0.36780725E-03_JPRB, 0.36789346E-03_JPRB, 0.36796634E-03_JPRB, 0.36801747E-03_JPRB, 0.36804468E-03_JPRB, &
  & 0.36804687E-03_JPRB, 0.36802317E-03_JPRB, 0.36797504E-03_JPRB, 0.36790420E-03_JPRB, 0.36781345E-03_JPRB, 0.36770577E-03_JPRB, &
  & 0.36758359E-03_JPRB, 0.36744881E-03_JPRB, 0.36730315E-03_JPRB, 0.36714855E-03_JPRB, 0.36698784E-03_JPRB, 0.36682445E-03_JPRB, &
  & 0.36666266E-03_JPRB, 0.36650655E-03_JPRB, 0.36635960E-03_JPRB, 0.36622389E-03_JPRB, 0.36610066E-03_JPRB, 0.36599170E-03_JPRB, &
  & 0.36589749E-03_JPRB, 0.36581786E-03_JPRB, 0.36575273E-03_JPRB, 0.36570130E-03_JPRB, 0.36566320E-03_JPRB, 0.36563774E-03_JPRB, &
  & 0.36562470E-03_JPRB, 0.36562511E-03_JPRB, 0.36564597E-03_JPRB, 0.36571705E-03_JPRB /)

RGHG1(:,14, 6) = (/ &
  & 0.36628751E-03_JPRB, 0.36639094E-03_JPRB, 0.36642354E-03_JPRB, 0.36645660E-03_JPRB, 0.36649022E-03_JPRB, 0.36653318E-03_JPRB, &
  & 0.36659150E-03_JPRB, 0.36667410E-03_JPRB, 0.36678452E-03_JPRB, 0.36692480E-03_JPRB, 0.36708909E-03_JPRB, 0.36726752E-03_JPRB, &
  & 0.36744744E-03_JPRB, 0.36761555E-03_JPRB, 0.36776104E-03_JPRB, 0.36787614E-03_JPRB, 0.36795560E-03_JPRB, 0.36799876E-03_JPRB, &
  & 0.36801022E-03_JPRB, 0.36799686E-03_JPRB, 0.36796735E-03_JPRB, 0.36793126E-03_JPRB, 0.36789611E-03_JPRB, 0.36786837E-03_JPRB, &
  & 0.36785065E-03_JPRB, 0.36784474E-03_JPRB, 0.36785268E-03_JPRB, 0.36788010E-03_JPRB, 0.36792958E-03_JPRB, 0.36799922E-03_JPRB, &
  & 0.36808362E-03_JPRB, 0.36817661E-03_JPRB, 0.36826605E-03_JPRB, 0.36834265E-03_JPRB, 0.36840240E-03_JPRB, 0.36843703E-03_JPRB, &
  & 0.36844431E-03_JPRB, 0.36842594E-03_JPRB, 0.36838348E-03_JPRB, 0.36831840E-03_JPRB, 0.36823269E-03_JPRB, 0.36812940E-03_JPRB, &
  & 0.36801072E-03_JPRB, 0.36787856E-03_JPRB, 0.36773551E-03_JPRB, 0.36758423E-03_JPRB, 0.36742815E-03_JPRB, 0.36727160E-03_JPRB, &
  & 0.36711915E-03_JPRB, 0.36697416E-03_JPRB, 0.36683839E-03_JPRB, 0.36671353E-03_JPRB, 0.36660049E-03_JPRB, 0.36649973E-03_JPRB, &
  & 0.36641196E-03_JPRB, 0.36633789E-03_JPRB, 0.36627776E-03_JPRB, 0.36623201E-03_JPRB, 0.36620098E-03_JPRB, 0.36618527E-03_JPRB, &
  & 0.36618617E-03_JPRB, 0.36620494E-03_JPRB, 0.36625724E-03_JPRB, 0.36638291E-03_JPRB /)

RGHG1(:,15, 6) = (/ &
  & 0.36691170E-03_JPRB, 0.36694313E-03_JPRB, 0.36695239E-03_JPRB, 0.36696819E-03_JPRB, 0.36698818E-03_JPRB, 0.36701950E-03_JPRB, &
  & 0.36706770E-03_JPRB, 0.36713883E-03_JPRB, 0.36723717E-03_JPRB, 0.36736298E-03_JPRB, 0.36751240E-03_JPRB, 0.36767503E-03_JPRB, &
  & 0.36783851E-03_JPRB, 0.36799040E-03_JPRB, 0.36811945E-03_JPRB, 0.36822009E-03_JPRB, 0.36828977E-03_JPRB, 0.36833002E-03_JPRB, &
  & 0.36834498E-03_JPRB, 0.36834157E-03_JPRB, 0.36832609E-03_JPRB, 0.36830551E-03_JPRB, 0.36828517E-03_JPRB, 0.36826881E-03_JPRB, &
  & 0.36825956E-03_JPRB, 0.36826043E-03_JPRB, 0.36827347E-03_JPRB, 0.36829998E-03_JPRB, 0.36834265E-03_JPRB, 0.36840193E-03_JPRB, &
  & 0.36847839E-03_JPRB, 0.36855915E-03_JPRB, 0.36863529E-03_JPRB, 0.36869934E-03_JPRB, 0.36874390E-03_JPRB, 0.36877030E-03_JPRB, &
  & 0.36877848E-03_JPRB, 0.36876468E-03_JPRB, 0.36872987E-03_JPRB, 0.36867551E-03_JPRB, 0.36860260E-03_JPRB, 0.36851253E-03_JPRB, &
  & 0.36840720E-03_JPRB, 0.36828828E-03_JPRB, 0.36815906E-03_JPRB, 0.36802224E-03_JPRB, 0.36788161E-03_JPRB, 0.36774226E-03_JPRB, &
  & 0.36760760E-03_JPRB, 0.36748045E-03_JPRB, 0.36736208E-03_JPRB, 0.36725312E-03_JPRB, 0.36715443E-03_JPRB, 0.36706644E-03_JPRB, &
  & 0.36699037E-03_JPRB, 0.36692712E-03_JPRB, 0.36687782E-03_JPRB, 0.36684316E-03_JPRB, 0.36682395E-03_JPRB, 0.36682119E-03_JPRB, &
  & 0.36683615E-03_JPRB, 0.36686895E-03_JPRB, 0.36694101E-03_JPRB, 0.36708900E-03_JPRB /)

RGHG1(:,16, 6) = (/ &
  & 0.36744680E-03_JPRB, 0.36744436E-03_JPRB, 0.36743208E-03_JPRB, 0.36743243E-03_JPRB, 0.36743836E-03_JPRB, 0.36745658E-03_JPRB, &
  & 0.36749031E-03_JPRB, 0.36754552E-03_JPRB, 0.36762597E-03_JPRB, 0.36773284E-03_JPRB, 0.36786209E-03_JPRB, 0.36800571E-03_JPRB, &
  & 0.36815190E-03_JPRB, 0.36829026E-03_JPRB, 0.36841125E-03_JPRB, 0.36850764E-03_JPRB, 0.36857877E-03_JPRB, 0.36862731E-03_JPRB, &
  & 0.36865781E-03_JPRB, 0.36867589E-03_JPRB, 0.36868628E-03_JPRB, 0.36869300E-03_JPRB, 0.36869949E-03_JPRB, 0.36870799E-03_JPRB, &
  & 0.36872056E-03_JPRB, 0.36873875E-03_JPRB, 0.36876436E-03_JPRB, 0.36879885E-03_JPRB, 0.36884134E-03_JPRB, 0.36888907E-03_JPRB, &
  & 0.36893433E-03_JPRB, 0.36897761E-03_JPRB, 0.36901611E-03_JPRB, 0.36904588E-03_JPRB, 0.36906666E-03_JPRB, 0.36907519E-03_JPRB, &
  & 0.36907056E-03_JPRB, 0.36905616E-03_JPRB, 0.36902956E-03_JPRB, 0.36898872E-03_JPRB, 0.36893252E-03_JPRB, 0.36886107E-03_JPRB, &
  & 0.36877498E-03_JPRB, 0.36867594E-03_JPRB, 0.36856614E-03_JPRB, 0.36844888E-03_JPRB, 0.36832874E-03_JPRB, 0.36820903E-03_JPRB, &
  & 0.36809291E-03_JPRB, 0.36798176E-03_JPRB, 0.36787777E-03_JPRB, 0.36778179E-03_JPRB, 0.36769439E-03_JPRB, 0.36761674E-03_JPRB, &
  & 0.36755038E-03_JPRB, 0.36749651E-03_JPRB, 0.36745629E-03_JPRB, 0.36743085E-03_JPRB, 0.36742061E-03_JPRB, 0.36742585E-03_JPRB, &
  & 0.36744738E-03_JPRB, 0.36748531E-03_JPRB, 0.36755842E-03_JPRB, 0.36769992E-03_JPRB /)

RGHG1(:,17, 6) = (/ &
  & 0.36789529E-03_JPRB, 0.36787268E-03_JPRB, 0.36784774E-03_JPRB, 0.36783761E-03_JPRB, 0.36783441E-03_JPRB, 0.36784180E-03_JPRB, &
  & 0.36786305E-03_JPRB, 0.36790338E-03_JPRB, 0.36796634E-03_JPRB, 0.36805324E-03_JPRB, 0.36816284E-03_JPRB, 0.36828773E-03_JPRB, &
  & 0.36841870E-03_JPRB, 0.36854585E-03_JPRB, 0.36866247E-03_JPRB, 0.36876276E-03_JPRB, 0.36884373E-03_JPRB, 0.36890813E-03_JPRB, &
  & 0.36896026E-03_JPRB, 0.36900432E-03_JPRB, 0.36904385E-03_JPRB, 0.36908145E-03_JPRB, 0.36911925E-03_JPRB, 0.36915878E-03_JPRB, &
  & 0.36920040E-03_JPRB, 0.36924344E-03_JPRB, 0.36928523E-03_JPRB, 0.36932304E-03_JPRB, 0.36935275E-03_JPRB, 0.36937464E-03_JPRB, &
  & 0.36938634E-03_JPRB, 0.36938937E-03_JPRB, 0.36938436E-03_JPRB, 0.36937423E-03_JPRB, 0.36936090E-03_JPRB, 0.36934734E-03_JPRB, &
  & 0.36933346E-03_JPRB, 0.36931675E-03_JPRB, 0.36929510E-03_JPRB, 0.36926661E-03_JPRB, 0.36922755E-03_JPRB, 0.36917595E-03_JPRB, &
  & 0.36911070E-03_JPRB, 0.36903264E-03_JPRB, 0.36894341E-03_JPRB, 0.36884670E-03_JPRB, 0.36874576E-03_JPRB, 0.36864323E-03_JPRB, &
  & 0.36854134E-03_JPRB, 0.36844242E-03_JPRB, 0.36834838E-03_JPRB, 0.36826034E-03_JPRB, 0.36817972E-03_JPRB, 0.36810827E-03_JPRB, &
  & 0.36804753E-03_JPRB, 0.36799925E-03_JPRB, 0.36796450E-03_JPRB, 0.36794358E-03_JPRB, 0.36793668E-03_JPRB, 0.36794358E-03_JPRB, &
  & 0.36796453E-03_JPRB, 0.36800010E-03_JPRB, 0.36806116E-03_JPRB, 0.36818252E-03_JPRB /)

RGHG1(:,18, 6) = (/ &
  & 0.36826255E-03_JPRB, 0.36822469E-03_JPRB, 0.36819789E-03_JPRB, 0.36818202E-03_JPRB, 0.36817344E-03_JPRB, 0.36817361E-03_JPRB, &
  & 0.36818595E-03_JPRB, 0.36821479E-03_JPRB, 0.36826334E-03_JPRB, 0.36833441E-03_JPRB, 0.36842655E-03_JPRB, 0.36853517E-03_JPRB, &
  & 0.36865316E-03_JPRB, 0.36877251E-03_JPRB, 0.36888567E-03_JPRB, 0.36898867E-03_JPRB, 0.36907961E-03_JPRB, 0.36915857E-03_JPRB, &
  & 0.36922787E-03_JPRB, 0.36929123E-03_JPRB, 0.36935147E-03_JPRB, 0.36941090E-03_JPRB, 0.36947097E-03_JPRB, 0.36953256E-03_JPRB, &
  & 0.36959435E-03_JPRB, 0.36965264E-03_JPRB, 0.36970360E-03_JPRB, 0.36974324E-03_JPRB, 0.36976748E-03_JPRB, 0.36977441E-03_JPRB, &
  & 0.36976449E-03_JPRB, 0.36974062E-03_JPRB, 0.36970637E-03_JPRB, 0.36966661E-03_JPRB, 0.36962653E-03_JPRB, 0.36959149E-03_JPRB, &
  & 0.36956463E-03_JPRB, 0.36954557E-03_JPRB, 0.36953005E-03_JPRB, 0.36951300E-03_JPRB, 0.36948925E-03_JPRB, 0.36945470E-03_JPRB, &
  & 0.36940779E-03_JPRB, 0.36934833E-03_JPRB, 0.36927767E-03_JPRB, 0.36919833E-03_JPRB, 0.36911306E-03_JPRB, 0.36902318E-03_JPRB, &
  & 0.36893185E-03_JPRB, 0.36884166E-03_JPRB, 0.36875438E-03_JPRB, 0.36867149E-03_JPRB, 0.36859489E-03_JPRB, 0.36852655E-03_JPRB, &
  & 0.36846887E-03_JPRB, 0.36842327E-03_JPRB, 0.36839023E-03_JPRB, 0.36837006E-03_JPRB, 0.36836247E-03_JPRB, 0.36836695E-03_JPRB, &
  & 0.36838272E-03_JPRB, 0.36841069E-03_JPRB, 0.36845589E-03_JPRB, 0.36855391E-03_JPRB /)

RGHG1(:,19, 6) = (/ &
  & 0.36855950E-03_JPRB, 0.36851611E-03_JPRB, 0.36849067E-03_JPRB, 0.36847341E-03_JPRB, 0.36846241E-03_JPRB, 0.36845866E-03_JPRB, &
  & 0.36846488E-03_JPRB, 0.36848494E-03_JPRB, 0.36852289E-03_JPRB, 0.36858107E-03_JPRB, 0.36865912E-03_JPRB, 0.36875333E-03_JPRB, &
  & 0.36885837E-03_JPRB, 0.36896861E-03_JPRB, 0.36907836E-03_JPRB, 0.36918209E-03_JPRB, 0.36927691E-03_JPRB, 0.36936247E-03_JPRB, &
  & 0.36943998E-03_JPRB, 0.36951175E-03_JPRB, 0.36958081E-03_JPRB, 0.36964967E-03_JPRB, 0.36972002E-03_JPRB, 0.36979179E-03_JPRB, &
  & 0.36986300E-03_JPRB, 0.36992974E-03_JPRB, 0.36998693E-03_JPRB, 0.37002878E-03_JPRB, 0.37005224E-03_JPRB, 0.37005567E-03_JPRB, &
  & 0.37004048E-03_JPRB, 0.37000843E-03_JPRB, 0.36996347E-03_JPRB, 0.36991164E-03_JPRB, 0.36985989E-03_JPRB, 0.36981420E-03_JPRB, &
  & 0.36978011E-03_JPRB, 0.36975768E-03_JPRB, 0.36974455E-03_JPRB, 0.36973413E-03_JPRB, 0.36972007E-03_JPRB, 0.36969775E-03_JPRB, &
  & 0.36966387E-03_JPRB, 0.36961786E-03_JPRB, 0.36956079E-03_JPRB, 0.36949408E-03_JPRB, 0.36941905E-03_JPRB, 0.36933913E-03_JPRB, &
  & 0.36925645E-03_JPRB, 0.36917356E-03_JPRB, 0.36909161E-03_JPRB, 0.36901276E-03_JPRB, 0.36893925E-03_JPRB, 0.36887356E-03_JPRB, &
  & 0.36881771E-03_JPRB, 0.36877295E-03_JPRB, 0.36873980E-03_JPRB, 0.36871817E-03_JPRB, 0.36870755E-03_JPRB, 0.36870703E-03_JPRB, &
  & 0.36871585E-03_JPRB, 0.36873459E-03_JPRB, 0.36876663E-03_JPRB, 0.36884000E-03_JPRB /)

RGHG1(:,20, 6) = (/ &
  & 0.36880406E-03_JPRB, 0.36876119E-03_JPRB, 0.36873811E-03_JPRB, 0.36872187E-03_JPRB, 0.36871040E-03_JPRB, 0.36870479E-03_JPRB, &
  & 0.36870723E-03_JPRB, 0.36872161E-03_JPRB, 0.36875167E-03_JPRB, 0.36879969E-03_JPRB, 0.36886573E-03_JPRB, 0.36894728E-03_JPRB, &
  & 0.36904053E-03_JPRB, 0.36914012E-03_JPRB, 0.36924181E-03_JPRB, 0.36934111E-03_JPRB, 0.36943468E-03_JPRB, 0.36952045E-03_JPRB, &
  & 0.36959929E-03_JPRB, 0.36967275E-03_JPRB, 0.36974353E-03_JPRB, 0.36981405E-03_JPRB, 0.36988623E-03_JPRB, 0.36996033E-03_JPRB, &
  & 0.37003451E-03_JPRB, 0.37010427E-03_JPRB, 0.37016423E-03_JPRB, 0.37020905E-03_JPRB, 0.37023608E-03_JPRB, 0.37024412E-03_JPRB, &
  & 0.37023364E-03_JPRB, 0.37020599E-03_JPRB, 0.37016405E-03_JPRB, 0.37011347E-03_JPRB, 0.37006065E-03_JPRB, 0.37001332E-03_JPRB, &
  & 0.36997709E-03_JPRB, 0.36995357E-03_JPRB, 0.36994056E-03_JPRB, 0.36993230E-03_JPRB, 0.36992211E-03_JPRB, 0.36990509E-03_JPRB, &
  & 0.36987819E-03_JPRB, 0.36984004E-03_JPRB, 0.36979080E-03_JPRB, 0.36973140E-03_JPRB, 0.36966422E-03_JPRB, 0.36959167E-03_JPRB, &
  & 0.36951574E-03_JPRB, 0.36943823E-03_JPRB, 0.36936093E-03_JPRB, 0.36928657E-03_JPRB, 0.36921690E-03_JPRB, 0.36915435E-03_JPRB, &
  & 0.36910072E-03_JPRB, 0.36905726E-03_JPRB, 0.36902388E-03_JPRB, 0.36900066E-03_JPRB, 0.36898663E-03_JPRB, 0.36898110E-03_JPRB, &
  & 0.36898357E-03_JPRB, 0.36899420E-03_JPRB, 0.36901483E-03_JPRB, 0.36906471E-03_JPRB /)

RGHG1(:,21, 6) = (/ &
  & 0.36901023E-03_JPRB, 0.36897062E-03_JPRB, 0.36894996E-03_JPRB, 0.36893523E-03_JPRB, 0.36892464E-03_JPRB, 0.36891864E-03_JPRB, &
  & 0.36891922E-03_JPRB, 0.36893017E-03_JPRB, 0.36895479E-03_JPRB, 0.36899507E-03_JPRB, 0.36905118E-03_JPRB, 0.36912179E-03_JPRB, &
  & 0.36920345E-03_JPRB, 0.36929263E-03_JPRB, 0.36938520E-03_JPRB, 0.36947685E-03_JPRB, 0.36956448E-03_JPRB, 0.36964644E-03_JPRB, &
  & 0.36972237E-03_JPRB, 0.36979356E-03_JPRB, 0.36986225E-03_JPRB, 0.36993093E-03_JPRB, 0.37000125E-03_JPRB, 0.37007403E-03_JPRB, &
  & 0.37014729E-03_JPRB, 0.37021760E-03_JPRB, 0.37027913E-03_JPRB, 0.37032703E-03_JPRB, 0.37035887E-03_JPRB, 0.37037366E-03_JPRB, &
  & 0.37037174E-03_JPRB, 0.37035372E-03_JPRB, 0.37032214E-03_JPRB, 0.37028070E-03_JPRB, 0.37023565E-03_JPRB, 0.37019324E-03_JPRB, &
  & 0.37015919E-03_JPRB, 0.37013579E-03_JPRB, 0.37012040E-03_JPRB, 0.37011033E-03_JPRB, 0.37009895E-03_JPRB, 0.37008204E-03_JPRB, &
  & 0.37005596E-03_JPRB, 0.37001961E-03_JPRB, 0.36997342E-03_JPRB, 0.36991853E-03_JPRB, 0.36985654E-03_JPRB, 0.36978937E-03_JPRB, &
  & 0.36971859E-03_JPRB, 0.36964589E-03_JPRB, 0.36957406E-03_JPRB, 0.36950462E-03_JPRB, 0.36943980E-03_JPRB, 0.36938145E-03_JPRB, &
  & 0.36933116E-03_JPRB, 0.36928919E-03_JPRB, 0.36925593E-03_JPRB, 0.36923119E-03_JPRB, 0.36921428E-03_JPRB, 0.36920467E-03_JPRB, &
  & 0.36920133E-03_JPRB, 0.36920453E-03_JPRB, 0.36921547E-03_JPRB, 0.36924717E-03_JPRB /)

RGHG1(:,22, 6) = (/ &
  & 0.36918506E-03_JPRB, 0.36915054E-03_JPRB, 0.36913314E-03_JPRB, 0.36912056E-03_JPRB, 0.36911134E-03_JPRB, 0.36910598E-03_JPRB, &
  & 0.36910671E-03_JPRB, 0.36911631E-03_JPRB, 0.36913788E-03_JPRB, 0.36917295E-03_JPRB, 0.36922208E-03_JPRB, 0.36928375E-03_JPRB, &
  & 0.36935569E-03_JPRB, 0.36943474E-03_JPRB, 0.36951763E-03_JPRB, 0.36960052E-03_JPRB, 0.36968075E-03_JPRB, 0.36975660E-03_JPRB, &
  & 0.36982785E-03_JPRB, 0.36989534E-03_JPRB, 0.36996079E-03_JPRB, 0.37002636E-03_JPRB, 0.37009345E-03_JPRB, 0.37016245E-03_JPRB, &
  & 0.37023233E-03_JPRB, 0.37029971E-03_JPRB, 0.37036001E-03_JPRB, 0.37040989E-03_JPRB, 0.37044586E-03_JPRB, 0.37046723E-03_JPRB, &
  & 0.37047392E-03_JPRB, 0.37046665E-03_JPRB, 0.37044726E-03_JPRB, 0.37041859E-03_JPRB, 0.37038518E-03_JPRB, 0.37035241E-03_JPRB, &
  & 0.37032296E-03_JPRB, 0.37030017E-03_JPRB, 0.37028323E-03_JPRB, 0.37026859E-03_JPRB, 0.37025276E-03_JPRB, 0.37023213E-03_JPRB, &
  & 0.37020427E-03_JPRB, 0.37016752E-03_JPRB, 0.37012214E-03_JPRB, 0.37006894E-03_JPRB, 0.37000948E-03_JPRB, 0.36994528E-03_JPRB, &
  & 0.36987831E-03_JPRB, 0.36981079E-03_JPRB, 0.36974411E-03_JPRB, 0.36967991E-03_JPRB, 0.36962031E-03_JPRB, 0.36956661E-03_JPRB, &
  & 0.36951955E-03_JPRB, 0.36947968E-03_JPRB, 0.36944676E-03_JPRB, 0.36942097E-03_JPRB, 0.36940162E-03_JPRB, 0.36938849E-03_JPRB, &
  & 0.36938101E-03_JPRB, 0.36937901E-03_JPRB, 0.36938264E-03_JPRB, 0.36939961E-03_JPRB /)

RGHG1(:,23, 6) = (/ &
  & 0.36933596E-03_JPRB, 0.36930642E-03_JPRB, 0.36929216E-03_JPRB, 0.36928218E-03_JPRB, 0.36927531E-03_JPRB, 0.36927205E-03_JPRB, &
  & 0.36927423E-03_JPRB, 0.36928424E-03_JPRB, 0.36930473E-03_JPRB, 0.36933704E-03_JPRB, 0.36938180E-03_JPRB, 0.36943768E-03_JPRB, &
  & 0.36950252E-03_JPRB, 0.36957377E-03_JPRB, 0.36964822E-03_JPRB, 0.36972307E-03_JPRB, 0.36979601E-03_JPRB, 0.36986559E-03_JPRB, &
  & 0.36993131E-03_JPRB, 0.36999438E-03_JPRB, 0.37005576E-03_JPRB, 0.37011638E-03_JPRB, 0.37017820E-03_JPRB, 0.37024159E-03_JPRB, &
  & 0.37030547E-03_JPRB, 0.37036813E-03_JPRB, 0.37042552E-03_JPRB, 0.37047386E-03_JPRB, 0.37051181E-03_JPRB, 0.37053807E-03_JPRB, &
  & 0.37055192E-03_JPRB, 0.37055422E-03_JPRB, 0.37054589E-03_JPRB, 0.37052957E-03_JPRB, 0.37050783E-03_JPRB, 0.37048489E-03_JPRB, &
  & 0.37046213E-03_JPRB, 0.37044132E-03_JPRB, 0.37042232E-03_JPRB, 0.37040320E-03_JPRB, 0.37038187E-03_JPRB, 0.37035611E-03_JPRB, &
  & 0.37032412E-03_JPRB, 0.37028542E-03_JPRB, 0.37023955E-03_JPRB, 0.37018684E-03_JPRB, 0.37012860E-03_JPRB, 0.37006693E-03_JPRB, &
  & 0.37000372E-03_JPRB, 0.36994071E-03_JPRB, 0.36987927E-03_JPRB, 0.36982121E-03_JPRB, 0.36976737E-03_JPRB, 0.36971859E-03_JPRB, &
  & 0.36967540E-03_JPRB, 0.36963783E-03_JPRB, 0.36960587E-03_JPRB, 0.36957944E-03_JPRB, 0.36955846E-03_JPRB, 0.36954277E-03_JPRB, &
  & 0.36953186E-03_JPRB, 0.36952540E-03_JPRB, 0.36952356E-03_JPRB, 0.36953000E-03_JPRB /)

RGHG1(:,24, 6) = (/ &
  & 0.36946635E-03_JPRB, 0.36944263E-03_JPRB, 0.36943160E-03_JPRB, 0.36942452E-03_JPRB, 0.36942016E-03_JPRB, 0.36941934E-03_JPRB, &
  & 0.36942374E-03_JPRB, 0.36943561E-03_JPRB, 0.36945709E-03_JPRB, 0.36948925E-03_JPRB, 0.36953215E-03_JPRB, 0.36958465E-03_JPRB, &
  & 0.36964519E-03_JPRB, 0.36971102E-03_JPRB, 0.36977947E-03_JPRB, 0.36984813E-03_JPRB, 0.36991489E-03_JPRB, 0.36997895E-03_JPRB, &
  & 0.37003969E-03_JPRB, 0.37009758E-03_JPRB, 0.37015366E-03_JPRB, 0.37020899E-03_JPRB, 0.37026411E-03_JPRB, 0.37031982E-03_JPRB, &
  & 0.37037578E-03_JPRB, 0.37043035E-03_JPRB, 0.37048204E-03_JPRB, 0.37052823E-03_JPRB, 0.37056595E-03_JPRB, 0.37059438E-03_JPRB, &
  & 0.37061310E-03_JPRB, 0.37062244E-03_JPRB, 0.37062273E-03_JPRB, 0.37061612E-03_JPRB, 0.37060396E-03_JPRB, 0.37058879E-03_JPRB, &
  & 0.37057139E-03_JPRB, 0.37055279E-03_JPRB, 0.37053280E-03_JPRB, 0.37051074E-03_JPRB, 0.37048504E-03_JPRB, 0.37045471E-03_JPRB, &
  & 0.37041877E-03_JPRB, 0.37037669E-03_JPRB, 0.37032898E-03_JPRB, 0.37027616E-03_JPRB, 0.37021970E-03_JPRB, 0.37016129E-03_JPRB, &
  & 0.37010259E-03_JPRB, 0.37004508E-03_JPRB, 0.36998984E-03_JPRB, 0.36993780E-03_JPRB, 0.36988952E-03_JPRB, 0.36984537E-03_JPRB, &
  & 0.36980590E-03_JPRB, 0.36977074E-03_JPRB, 0.36974013E-03_JPRB, 0.36971387E-03_JPRB, 0.36969208E-03_JPRB, 0.36967461E-03_JPRB, &
  & 0.36966131E-03_JPRB, 0.36965183E-03_JPRB, 0.36964568E-03_JPRB, 0.36964388E-03_JPRB /)

RGHG1(:,25, 6) = (/ &
  & 0.36958131E-03_JPRB, 0.36956309E-03_JPRB, 0.36955497E-03_JPRB, 0.36955051E-03_JPRB, 0.36954874E-03_JPRB, 0.36955078E-03_JPRB, &
  & 0.36955785E-03_JPRB, 0.36957214E-03_JPRB, 0.36959554E-03_JPRB, 0.36962892E-03_JPRB, 0.36967188E-03_JPRB, 0.36972328E-03_JPRB, &
  & 0.36978145E-03_JPRB, 0.36984376E-03_JPRB, 0.36990823E-03_JPRB, 0.36997220E-03_JPRB, 0.37003431E-03_JPRB, 0.37009365E-03_JPRB, &
  & 0.37014973E-03_JPRB, 0.37020305E-03_JPRB, 0.37025407E-03_JPRB, 0.37030317E-03_JPRB, 0.37035099E-03_JPRB, 0.37039845E-03_JPRB, &
  & 0.37044543E-03_JPRB, 0.37049167E-03_JPRB, 0.37053582E-03_JPRB, 0.37057660E-03_JPRB, 0.37061205E-03_JPRB, 0.37064089E-03_JPRB, &
  & 0.37066219E-03_JPRB, 0.37067608E-03_JPRB, 0.37068254E-03_JPRB, 0.37068251E-03_JPRB, 0.37067709E-03_JPRB, 0.37066708E-03_JPRB, &
  & 0.37065358E-03_JPRB, 0.37063658E-03_JPRB, 0.37061621E-03_JPRB, 0.37059229E-03_JPRB, 0.37056388E-03_JPRB, 0.37053076E-03_JPRB, &
  & 0.37049223E-03_JPRB, 0.37044848E-03_JPRB, 0.37040008E-03_JPRB, 0.37034805E-03_JPRB, 0.37029371E-03_JPRB, 0.37023870E-03_JPRB, &
  & 0.37018477E-03_JPRB, 0.37013268E-03_JPRB, 0.37008294E-03_JPRB, 0.37003643E-03_JPRB, 0.36999318E-03_JPRB, 0.36995346E-03_JPRB, &
  & 0.36991731E-03_JPRB, 0.36988480E-03_JPRB, 0.36985564E-03_JPRB, 0.36983003E-03_JPRB, 0.36980788E-03_JPRB, 0.36978952E-03_JPRB, &
  & 0.36977479E-03_JPRB, 0.36976335E-03_JPRB, 0.36975410E-03_JPRB, 0.36974609E-03_JPRB /)

RGHG1(:,26, 6) = (/ &
  & 0.36968270E-03_JPRB, 0.36966984E-03_JPRB, 0.36966498E-03_JPRB, 0.36966309E-03_JPRB, 0.36966385E-03_JPRB, 0.36966815E-03_JPRB, &
  & 0.36967773E-03_JPRB, 0.36969464E-03_JPRB, 0.36972034E-03_JPRB, 0.36975517E-03_JPRB, 0.36979880E-03_JPRB, 0.36984993E-03_JPRB, &
  & 0.36990669E-03_JPRB, 0.36996682E-03_JPRB, 0.37002857E-03_JPRB, 0.37008955E-03_JPRB, 0.37014807E-03_JPRB, 0.37020369E-03_JPRB, &
  & 0.37025596E-03_JPRB, 0.37030512E-03_JPRB, 0.37035119E-03_JPRB, 0.37039435E-03_JPRB, 0.37043533E-03_JPRB, 0.37047494E-03_JPRB, &
  & 0.37051336E-03_JPRB, 0.37055064E-03_JPRB, 0.37058696E-03_JPRB, 0.37062162E-03_JPRB, 0.37065332E-03_JPRB, 0.37068094E-03_JPRB, &
  & 0.37070317E-03_JPRB, 0.37071944E-03_JPRB, 0.37072937E-03_JPRB, 0.37073341E-03_JPRB, 0.37073184E-03_JPRB, 0.37072529E-03_JPRB, &
  & 0.37071400E-03_JPRB, 0.37069790E-03_JPRB, 0.37067756E-03_JPRB, 0.37065236E-03_JPRB, 0.37062267E-03_JPRB, 0.37058792E-03_JPRB, &
  & 0.37054851E-03_JPRB, 0.37050468E-03_JPRB, 0.37045713E-03_JPRB, 0.37040681E-03_JPRB, 0.37035518E-03_JPRB, 0.37030398E-03_JPRB, &
  & 0.37025471E-03_JPRB, 0.37020768E-03_JPRB, 0.37016338E-03_JPRB, 0.37012188E-03_JPRB, 0.37008341E-03_JPRB, 0.37004767E-03_JPRB, &
  & 0.37001472E-03_JPRB, 0.36998442E-03_JPRB, 0.36995683E-03_JPRB, 0.36993180E-03_JPRB, 0.36990986E-03_JPRB, 0.36989120E-03_JPRB, &
  & 0.36987560E-03_JPRB, 0.36986280E-03_JPRB, 0.36985180E-03_JPRB, 0.36983957E-03_JPRB /)

RGHG1(:,27, 6) = (/ &
  & 0.36977368E-03_JPRB, 0.36976585E-03_JPRB, 0.36976347E-03_JPRB, 0.36976373E-03_JPRB, 0.36976661E-03_JPRB, 0.36977301E-03_JPRB, &
  & 0.36978460E-03_JPRB, 0.36980363E-03_JPRB, 0.36983108E-03_JPRB, 0.36986711E-03_JPRB, 0.36991123E-03_JPRB, 0.36996207E-03_JPRB, &
  & 0.37001792E-03_JPRB, 0.37007657E-03_JPRB, 0.37013614E-03_JPRB, 0.37019470E-03_JPRB, 0.37025078E-03_JPRB, 0.37030363E-03_JPRB, &
  & 0.37035265E-03_JPRB, 0.37039825E-03_JPRB, 0.37044007E-03_JPRB, 0.37047843E-03_JPRB, 0.37051376E-03_JPRB, 0.37054648E-03_JPRB, &
  & 0.37057739E-03_JPRB, 0.37060707E-03_JPRB, 0.37063609E-03_JPRB, 0.37066464E-03_JPRB, 0.37069176E-03_JPRB, 0.37071694E-03_JPRB, &
  & 0.37073856E-03_JPRB, 0.37075547E-03_JPRB, 0.37076711E-03_JPRB, 0.37077325E-03_JPRB, 0.37077375E-03_JPRB, 0.37076883E-03_JPRB, &
  & 0.37075853E-03_JPRB, 0.37074299E-03_JPRB, 0.37072232E-03_JPRB, 0.37069683E-03_JPRB, 0.37066615E-03_JPRB, 0.37063117E-03_JPRB, &
  & 0.37059191E-03_JPRB, 0.37054881E-03_JPRB, 0.37050291E-03_JPRB, 0.37045529E-03_JPRB, 0.37040745E-03_JPRB, 0.37036088E-03_JPRB, &
  & 0.37031644E-03_JPRB, 0.37027459E-03_JPRB, 0.37023521E-03_JPRB, 0.37019828E-03_JPRB, 0.37016405E-03_JPRB, 0.37013175E-03_JPRB, &
  & 0.37010168E-03_JPRB, 0.37007366E-03_JPRB, 0.37004764E-03_JPRB, 0.37002406E-03_JPRB, 0.37000264E-03_JPRB, 0.36998384E-03_JPRB, &
  & 0.36996783E-03_JPRB, 0.36995451E-03_JPRB, 0.36994228E-03_JPRB, 0.36992744E-03_JPRB /)

RGHG1(:,28, 6) = (/ &
  & 0.36985669E-03_JPRB, 0.36985206E-03_JPRB, 0.36985186E-03_JPRB, 0.36985383E-03_JPRB, 0.36985820E-03_JPRB, 0.36986620E-03_JPRB, &
  & 0.36987959E-03_JPRB, 0.36989988E-03_JPRB, 0.36992854E-03_JPRB, 0.36996530E-03_JPRB, 0.37000948E-03_JPRB, 0.37005983E-03_JPRB, &
  & 0.37011455E-03_JPRB, 0.37017182E-03_JPRB, 0.37022957E-03_JPRB, 0.37028623E-03_JPRB, 0.37034025E-03_JPRB, 0.37039080E-03_JPRB, &
  & 0.37043751E-03_JPRB, 0.37048018E-03_JPRB, 0.37051871E-03_JPRB, 0.37055323E-03_JPRB, 0.37058396E-03_JPRB, 0.37061144E-03_JPRB, &
  & 0.37063632E-03_JPRB, 0.37065957E-03_JPRB, 0.37068230E-03_JPRB, 0.37070515E-03_JPRB, 0.37072794E-03_JPRB, 0.37075012E-03_JPRB, &
  & 0.37077002E-03_JPRB, 0.37078647E-03_JPRB, 0.37079860E-03_JPRB, 0.37080550E-03_JPRB, 0.37080681E-03_JPRB, 0.37080262E-03_JPRB, &
  & 0.37079278E-03_JPRB, 0.37077730E-03_JPRB, 0.37075652E-03_JPRB, 0.37073094E-03_JPRB, 0.37070041E-03_JPRB, 0.37066548E-03_JPRB, &
  & 0.37062704E-03_JPRB, 0.37058553E-03_JPRB, 0.37054220E-03_JPRB, 0.37049814E-03_JPRB, 0.37045451E-03_JPRB, 0.37041289E-03_JPRB, &
  & 0.37037357E-03_JPRB, 0.37033658E-03_JPRB, 0.37030157E-03_JPRB, 0.37026871E-03_JPRB, 0.37023777E-03_JPRB, 0.37020870E-03_JPRB, &
  & 0.37018119E-03_JPRB, 0.37015523E-03_JPRB, 0.37013087E-03_JPRB, 0.37010835E-03_JPRB, 0.37008757E-03_JPRB, 0.37006920E-03_JPRB, &
  & 0.37005305E-03_JPRB, 0.37003911E-03_JPRB, 0.37002572E-03_JPRB, 0.37000704E-03_JPRB /)

RGHG1(:,29, 6) = (/ &
  & 0.36993038E-03_JPRB, 0.36992889E-03_JPRB, 0.36993041E-03_JPRB, 0.36993361E-03_JPRB, 0.36993923E-03_JPRB, 0.36994831E-03_JPRB, &
  & 0.36996260E-03_JPRB, 0.36998425E-03_JPRB, 0.37001367E-03_JPRB, 0.37005069E-03_JPRB, 0.37009470E-03_JPRB, 0.37014426E-03_JPRB, &
  & 0.37019787E-03_JPRB, 0.37025352E-03_JPRB, 0.37030975E-03_JPRB, 0.37036446E-03_JPRB, 0.37041676E-03_JPRB, 0.37046545E-03_JPRB, &
  & 0.37051013E-03_JPRB, 0.37055061E-03_JPRB, 0.37058673E-03_JPRB, 0.37061825E-03_JPRB, 0.37064543E-03_JPRB, 0.37066889E-03_JPRB, &
  & 0.37068929E-03_JPRB, 0.37070771E-03_JPRB, 0.37072552E-03_JPRB, 0.37074345E-03_JPRB, 0.37076179E-03_JPRB, 0.37078065E-03_JPRB, &
  & 0.37079857E-03_JPRB, 0.37081397E-03_JPRB, 0.37082555E-03_JPRB, 0.37083251E-03_JPRB, 0.37083402E-03_JPRB, 0.37082995E-03_JPRB, &
  & 0.37082040E-03_JPRB, 0.37080518E-03_JPRB, 0.37078469E-03_JPRB, 0.37075923E-03_JPRB, 0.37072942E-03_JPRB, 0.37069549E-03_JPRB, &
  & 0.37065853E-03_JPRB, 0.37061947E-03_JPRB, 0.37057948E-03_JPRB, 0.37053926E-03_JPRB, 0.37050014E-03_JPRB, 0.37046324E-03_JPRB, &
  & 0.37042855E-03_JPRB, 0.37039563E-03_JPRB, 0.37036443E-03_JPRB, 0.37033483E-03_JPRB, 0.37030669E-03_JPRB, 0.37027983E-03_JPRB, &
  & 0.37025459E-03_JPRB, 0.37023050E-03_JPRB, 0.37020762E-03_JPRB, 0.37018617E-03_JPRB, 0.37016635E-03_JPRB, 0.37014837E-03_JPRB, &
  & 0.37013242E-03_JPRB, 0.37011816E-03_JPRB, 0.37010433E-03_JPRB, 0.37008605E-03_JPRB /)

RGHG1(:,30, 6) = (/ &
  & 0.36999641E-03_JPRB, 0.36999735E-03_JPRB, 0.36999994E-03_JPRB, 0.37000430E-03_JPRB, 0.37001085E-03_JPRB, 0.37002083E-03_JPRB, &
  & 0.37003629E-03_JPRB, 0.37005835E-03_JPRB, 0.37008830E-03_JPRB, 0.37012537E-03_JPRB, 0.37016880E-03_JPRB, 0.37021746E-03_JPRB, &
  & 0.37026958E-03_JPRB, 0.37032377E-03_JPRB, 0.37037829E-03_JPRB, 0.37043149E-03_JPRB, 0.37048216E-03_JPRB, 0.37052936E-03_JPRB, &
  & 0.37057247E-03_JPRB, 0.37061106E-03_JPRB, 0.37064505E-03_JPRB, 0.37067424E-03_JPRB, 0.37069884E-03_JPRB, 0.37071927E-03_JPRB, &
  & 0.37073641E-03_JPRB, 0.37075122E-03_JPRB, 0.37076528E-03_JPRB, 0.37077931E-03_JPRB, 0.37079418E-03_JPRB, 0.37080975E-03_JPRB, &
  & 0.37082518E-03_JPRB, 0.37083880E-03_JPRB, 0.37084951E-03_JPRB, 0.37085588E-03_JPRB, 0.37085701E-03_JPRB, 0.37085311E-03_JPRB, &
  & 0.37084374E-03_JPRB, 0.37082908E-03_JPRB, 0.37080934E-03_JPRB, 0.37078484E-03_JPRB, 0.37075614E-03_JPRB, 0.37072386E-03_JPRB, &
  & 0.37068938E-03_JPRB, 0.37065332E-03_JPRB, 0.37061670E-03_JPRB, 0.37058062E-03_JPRB, 0.37054569E-03_JPRB, 0.37051301E-03_JPRB, &
  & 0.37048207E-03_JPRB, 0.37045268E-03_JPRB, 0.37042442E-03_JPRB, 0.37039729E-03_JPRB, 0.37037130E-03_JPRB, 0.37034633E-03_JPRB, &
  & 0.37032258E-03_JPRB, 0.37030000E-03_JPRB, 0.37027872E-03_JPRB, 0.37025847E-03_JPRB, 0.37023940E-03_JPRB, 0.37022209E-03_JPRB, &
  & 0.37020657E-03_JPRB, 0.37019257E-03_JPRB, 0.37017890E-03_JPRB, 0.37015928E-03_JPRB /)

RGHG1(:,31, 6) = (/ &
  & 0.37005584E-03_JPRB, 0.37005875E-03_JPRB, 0.37006260E-03_JPRB, 0.37006763E-03_JPRB, 0.37007494E-03_JPRB, 0.37008573E-03_JPRB, &
  & 0.37010154E-03_JPRB, 0.37012430E-03_JPRB, 0.37015424E-03_JPRB, 0.37019097E-03_JPRB, 0.37023381E-03_JPRB, 0.37028111E-03_JPRB, &
  & 0.37033201E-03_JPRB, 0.37038451E-03_JPRB, 0.37043734E-03_JPRB, 0.37048876E-03_JPRB, 0.37053789E-03_JPRB, 0.37058361E-03_JPRB, &
  & 0.37062544E-03_JPRB, 0.37066254E-03_JPRB, 0.37069505E-03_JPRB, 0.37072247E-03_JPRB, 0.37074488E-03_JPRB, 0.37076324E-03_JPRB, &
  & 0.37077791E-03_JPRB, 0.37079019E-03_JPRB, 0.37080143E-03_JPRB, 0.37081257E-03_JPRB, 0.37082453E-03_JPRB, 0.37083725E-03_JPRB, &
  & 0.37085012E-03_JPRB, 0.37086185E-03_JPRB, 0.37087113E-03_JPRB, 0.37087651E-03_JPRB, 0.37087739E-03_JPRB, 0.37087337E-03_JPRB, &
  & 0.37086447E-03_JPRB, 0.37085050E-03_JPRB, 0.37083207E-03_JPRB, 0.37080920E-03_JPRB, 0.37078251E-03_JPRB, 0.37075279E-03_JPRB, &
  & 0.37072119E-03_JPRB, 0.37068847E-03_JPRB, 0.37065556E-03_JPRB, 0.37062328E-03_JPRB, 0.37059185E-03_JPRB, 0.37056245E-03_JPRB, &
  & 0.37053446E-03_JPRB, 0.37050745E-03_JPRB, 0.37048131E-03_JPRB, 0.37045596E-03_JPRB, 0.37043169E-03_JPRB, 0.37040829E-03_JPRB, &
  & 0.37038600E-03_JPRB, 0.37036469E-03_JPRB, 0.37034444E-03_JPRB, 0.37032538E-03_JPRB, 0.37030739E-03_JPRB, 0.37029077E-03_JPRB, &
  & 0.37027569E-03_JPRB, 0.37026196E-03_JPRB, 0.37024828E-03_JPRB, 0.37022840E-03_JPRB /)

RGHG1(:,32, 6) = (/ &
  & 0.37011018E-03_JPRB, 0.37011507E-03_JPRB, 0.37011952E-03_JPRB, 0.37012540E-03_JPRB, 0.37013344E-03_JPRB, 0.37014493E-03_JPRB, &
  & 0.37016146E-03_JPRB, 0.37018422E-03_JPRB, 0.37021394E-03_JPRB, 0.37024985E-03_JPRB, 0.37029135E-03_JPRB, 0.37033745E-03_JPRB, &
  & 0.37038670E-03_JPRB, 0.37043751E-03_JPRB, 0.37048841E-03_JPRB, 0.37053833E-03_JPRB, 0.37058588E-03_JPRB, 0.37063021E-03_JPRB, &
  & 0.37067058E-03_JPRB, 0.37070649E-03_JPRB, 0.37073754E-03_JPRB, 0.37076348E-03_JPRB, 0.37078446E-03_JPRB, 0.37080128E-03_JPRB, &
  & 0.37081435E-03_JPRB, 0.37082494E-03_JPRB, 0.37083434E-03_JPRB, 0.37084328E-03_JPRB, 0.37085277E-03_JPRB, 0.37086295E-03_JPRB, &
  & 0.37087355E-03_JPRB, 0.37088344E-03_JPRB, 0.37089098E-03_JPRB, 0.37089537E-03_JPRB, 0.37089569E-03_JPRB, 0.37089153E-03_JPRB, &
  & 0.37088321E-03_JPRB, 0.37087043E-03_JPRB, 0.37085364E-03_JPRB, 0.37083303E-03_JPRB, 0.37080885E-03_JPRB, 0.37078222E-03_JPRB, &
  & 0.37075393E-03_JPRB, 0.37072483E-03_JPRB, 0.37069526E-03_JPRB, 0.37066615E-03_JPRB, 0.37063795E-03_JPRB, 0.37061080E-03_JPRB, &
  & 0.37058495E-03_JPRB, 0.37055969E-03_JPRB, 0.37053510E-03_JPRB, 0.37051117E-03_JPRB, 0.37048798E-03_JPRB, 0.37046583E-03_JPRB, &
  & 0.37044453E-03_JPRB, 0.37042442E-03_JPRB, 0.37040518E-03_JPRB, 0.37038705E-03_JPRB, 0.37036987E-03_JPRB, 0.37035419E-03_JPRB, &
  & 0.37033984E-03_JPRB, 0.37032660E-03_JPRB, 0.37031341E-03_JPRB, 0.37029400E-03_JPRB /)

RGHG1(:,33, 6) = (/ &
  & 0.37016100E-03_JPRB, 0.37016705E-03_JPRB, 0.37017270E-03_JPRB, 0.37017919E-03_JPRB, 0.37018798E-03_JPRB, 0.37019997E-03_JPRB, &
  & 0.37021664E-03_JPRB, 0.37023943E-03_JPRB, 0.37026842E-03_JPRB, 0.37030329E-03_JPRB, 0.37034345E-03_JPRB, 0.37038774E-03_JPRB, &
  & 0.37043510E-03_JPRB, 0.37048399E-03_JPRB, 0.37053321E-03_JPRB, 0.37058123E-03_JPRB, 0.37062715E-03_JPRB, 0.37066999E-03_JPRB, &
  & 0.37070902E-03_JPRB, 0.37074395E-03_JPRB, 0.37077384E-03_JPRB, 0.37079866E-03_JPRB, 0.37081869E-03_JPRB, 0.37083437E-03_JPRB, &
  & 0.37084654E-03_JPRB, 0.37085591E-03_JPRB, 0.37086394E-03_JPRB, 0.37087133E-03_JPRB, 0.37087902E-03_JPRB, 0.37088722E-03_JPRB, &
  & 0.37089564E-03_JPRB, 0.37090346E-03_JPRB, 0.37090955E-03_JPRB, 0.37091275E-03_JPRB, 0.37091257E-03_JPRB, 0.37090862E-03_JPRB, &
  & 0.37090079E-03_JPRB, 0.37088935E-03_JPRB, 0.37087448E-03_JPRB, 0.37085614E-03_JPRB, 0.37083501E-03_JPRB, 0.37081153E-03_JPRB, &
  & 0.37078670E-03_JPRB, 0.37076106E-03_JPRB, 0.37073490E-03_JPRB, 0.37070859E-03_JPRB, 0.37068262E-03_JPRB, 0.37065742E-03_JPRB, &
  & 0.37063286E-03_JPRB, 0.37060893E-03_JPRB, 0.37058524E-03_JPRB, 0.37056222E-03_JPRB, 0.37054004E-03_JPRB, 0.37051877E-03_JPRB, &
  & 0.37049848E-03_JPRB, 0.37047916E-03_JPRB, 0.37046085E-03_JPRB, 0.37044365E-03_JPRB, 0.37042762E-03_JPRB, 0.37041280E-03_JPRB, &
  & 0.37039927E-03_JPRB, 0.37038673E-03_JPRB, 0.37037389E-03_JPRB, 0.37035494E-03_JPRB /)

RGHG1(:,34, 6) = (/ &
  & 0.37020814E-03_JPRB, 0.37021638E-03_JPRB, 0.37022267E-03_JPRB, 0.37023021E-03_JPRB, 0.37023955E-03_JPRB, 0.37025192E-03_JPRB, &
  & 0.37026886E-03_JPRB, 0.37029115E-03_JPRB, 0.37031923E-03_JPRB, 0.37035262E-03_JPRB, 0.37039100E-03_JPRB, 0.37043352E-03_JPRB, &
  & 0.37047875E-03_JPRB, 0.37052561E-03_JPRB, 0.37057264E-03_JPRB, 0.37061871E-03_JPRB, 0.37066283E-03_JPRB, 0.37070431E-03_JPRB, &
  & 0.37074237E-03_JPRB, 0.37077605E-03_JPRB, 0.37080501E-03_JPRB, 0.37082910E-03_JPRB, 0.37084831E-03_JPRB, 0.37086324E-03_JPRB, &
  & 0.37087471E-03_JPRB, 0.37088350E-03_JPRB, 0.37089063E-03_JPRB, 0.37089689E-03_JPRB, 0.37090312E-03_JPRB, 0.37090961E-03_JPRB, &
  & 0.37091610E-03_JPRB, 0.37092221E-03_JPRB, 0.37092666E-03_JPRB, 0.37092878E-03_JPRB, 0.37092809E-03_JPRB, 0.37092419E-03_JPRB, &
  & 0.37091729E-03_JPRB, 0.37090731E-03_JPRB, 0.37089441E-03_JPRB, 0.37087878E-03_JPRB, 0.37086030E-03_JPRB, 0.37083999E-03_JPRB, &
  & 0.37081828E-03_JPRB, 0.37079575E-03_JPRB, 0.37077244E-03_JPRB, 0.37074852E-03_JPRB, 0.37072451E-03_JPRB, 0.37070061E-03_JPRB, &
  & 0.37067707E-03_JPRB, 0.37065404E-03_JPRB, 0.37063129E-03_JPRB, 0.37060908E-03_JPRB, 0.37058757E-03_JPRB, 0.37056714E-03_JPRB, &
  & 0.37054770E-03_JPRB, 0.37052925E-03_JPRB, 0.37051184E-03_JPRB, 0.37049552E-03_JPRB, 0.37048053E-03_JPRB, 0.37046647E-03_JPRB, &
  & 0.37045384E-03_JPRB, 0.37044199E-03_JPRB, 0.37042995E-03_JPRB, 0.37041196E-03_JPRB /)

RGHG1(:,35, 6) = (/ &
  & 0.37025337E-03_JPRB, 0.37026301E-03_JPRB, 0.37027049E-03_JPRB, 0.37027863E-03_JPRB, 0.37028859E-03_JPRB, 0.37030151E-03_JPRB, &
  & 0.37031839E-03_JPRB, 0.37034013E-03_JPRB, 0.37036691E-03_JPRB, 0.37039857E-03_JPRB, 0.37043489E-03_JPRB, 0.37047494E-03_JPRB, &
  & 0.37051793E-03_JPRB, 0.37056251E-03_JPRB, 0.37060745E-03_JPRB, 0.37065151E-03_JPRB, 0.37069383E-03_JPRB, 0.37073385E-03_JPRB, &
  & 0.37077075E-03_JPRB, 0.37080349E-03_JPRB, 0.37083190E-03_JPRB, 0.37085538E-03_JPRB, 0.37087419E-03_JPRB, 0.37088880E-03_JPRB, &
  & 0.37089968E-03_JPRB, 0.37090795E-03_JPRB, 0.37091441E-03_JPRB, 0.37091988E-03_JPRB, 0.37092503E-03_JPRB, 0.37093009E-03_JPRB, &
  & 0.37093501E-03_JPRB, 0.37093929E-03_JPRB, 0.37094243E-03_JPRB, 0.37094363E-03_JPRB, 0.37094255E-03_JPRB, 0.37093894E-03_JPRB, &
  & 0.37093303E-03_JPRB, 0.37092454E-03_JPRB, 0.37091351E-03_JPRB, 0.37090018E-03_JPRB, 0.37088446E-03_JPRB, 0.37086703E-03_JPRB, &
  & 0.37084831E-03_JPRB, 0.37082820E-03_JPRB, 0.37080716E-03_JPRB, 0.37078513E-03_JPRB, 0.37076263E-03_JPRB, 0.37073993E-03_JPRB, &
  & 0.37071720E-03_JPRB, 0.37069482E-03_JPRB, 0.37067273E-03_JPRB, 0.37065122E-03_JPRB, 0.37063044E-03_JPRB, 0.37061065E-03_JPRB, &
  & 0.37059197E-03_JPRB, 0.37057424E-03_JPRB, 0.37055765E-03_JPRB, 0.37054232E-03_JPRB, 0.37052808E-03_JPRB, 0.37051516E-03_JPRB, &
  & 0.37050346E-03_JPRB, 0.37049252E-03_JPRB, 0.37048140E-03_JPRB, 0.37046458E-03_JPRB /)

RGHG1(:,36, 6) = (/ &
  & 0.37029624E-03_JPRB, 0.37030777E-03_JPRB, 0.37031586E-03_JPRB, 0.37032488E-03_JPRB, 0.37033545E-03_JPRB, 0.37034854E-03_JPRB, &
  & 0.37036528E-03_JPRB, 0.37038620E-03_JPRB, 0.37041155E-03_JPRB, 0.37044153E-03_JPRB, 0.37047555E-03_JPRB, 0.37051336E-03_JPRB, &
  & 0.37055387E-03_JPRB, 0.37059581E-03_JPRB, 0.37063842E-03_JPRB, 0.37068050E-03_JPRB, 0.37072110E-03_JPRB, 0.37075975E-03_JPRB, &
  & 0.37079537E-03_JPRB, 0.37082750E-03_JPRB, 0.37085538E-03_JPRB, 0.37087852E-03_JPRB, 0.37089712E-03_JPRB, 0.37091132E-03_JPRB, &
  & 0.37092203E-03_JPRB, 0.37092989E-03_JPRB, 0.37093568E-03_JPRB, 0.37094040E-03_JPRB, 0.37094456E-03_JPRB, 0.37094834E-03_JPRB, &
  & 0.37095172E-03_JPRB, 0.37095472E-03_JPRB, 0.37095661E-03_JPRB, 0.37095716E-03_JPRB, 0.37095588E-03_JPRB, 0.37095280E-03_JPRB, &
  & 0.37094764E-03_JPRB, 0.37094063E-03_JPRB, 0.37093143E-03_JPRB, 0.37092020E-03_JPRB, 0.37090684E-03_JPRB, 0.37089179E-03_JPRB, &
  & 0.37087535E-03_JPRB, 0.37085751E-03_JPRB, 0.37083824E-03_JPRB, 0.37081784E-03_JPRB, 0.37079660E-03_JPRB, 0.37077483E-03_JPRB, &
  & 0.37075297E-03_JPRB, 0.37073105E-03_JPRB, 0.37070963E-03_JPRB, 0.37068877E-03_JPRB, 0.37066865E-03_JPRB, 0.37064968E-03_JPRB, &
  & 0.37063181E-03_JPRB, 0.37061493E-03_JPRB, 0.37059915E-03_JPRB, 0.37058454E-03_JPRB, 0.37057127E-03_JPRB, 0.37055940E-03_JPRB, &
  & 0.37054860E-03_JPRB, 0.37053871E-03_JPRB, 0.37052843E-03_JPRB, 0.37051336E-03_JPRB /)

RGHG1(:,37, 6) = (/ &
  & 0.37033774E-03_JPRB, 0.37035064E-03_JPRB, 0.37035978E-03_JPRB, 0.37036923E-03_JPRB, 0.37038024E-03_JPRB, 0.37039354E-03_JPRB, &
  & 0.37041001E-03_JPRB, 0.37043000E-03_JPRB, 0.37045387E-03_JPRB, 0.37048181E-03_JPRB, 0.37051353E-03_JPRB, 0.37054875E-03_JPRB, &
  & 0.37058647E-03_JPRB, 0.37062590E-03_JPRB, 0.37066609E-03_JPRB, 0.37070605E-03_JPRB, 0.37074485E-03_JPRB, 0.37078201E-03_JPRB, &
  & 0.37081674E-03_JPRB, 0.37084820E-03_JPRB, 0.37087584E-03_JPRB, 0.37089884E-03_JPRB, 0.37091714E-03_JPRB, 0.37093105E-03_JPRB, &
  & 0.37094118E-03_JPRB, 0.37094828E-03_JPRB, 0.37095344E-03_JPRB, 0.37095739E-03_JPRB, 0.37096062E-03_JPRB, 0.37096327E-03_JPRB, &
  & 0.37096557E-03_JPRB, 0.37096741E-03_JPRB, 0.37096840E-03_JPRB, 0.37096840E-03_JPRB, 0.37096714E-03_JPRB, 0.37096447E-03_JPRB, &
  & 0.37096033E-03_JPRB, 0.37095469E-03_JPRB, 0.37094750E-03_JPRB, 0.37093827E-03_JPRB, 0.37092713E-03_JPRB, 0.37091412E-03_JPRB, &
  & 0.37089948E-03_JPRB, 0.37088338E-03_JPRB, 0.37086583E-03_JPRB, 0.37084692E-03_JPRB, 0.37082675E-03_JPRB, 0.37080591E-03_JPRB, &
  & 0.37078455E-03_JPRB, 0.37076324E-03_JPRB, 0.37074229E-03_JPRB, 0.37072200E-03_JPRB, 0.37070271E-03_JPRB, 0.37068443E-03_JPRB, &
  & 0.37066726E-03_JPRB, 0.37065113E-03_JPRB, 0.37063626E-03_JPRB, 0.37062267E-03_JPRB, 0.37061036E-03_JPRB, 0.37059950E-03_JPRB, &
  & 0.37058984E-03_JPRB, 0.37058088E-03_JPRB, 0.37057186E-03_JPRB, 0.37055806E-03_JPRB /)

RGHG1(:,38, 6) = (/ &
  & 0.37037814E-03_JPRB, 0.37039220E-03_JPRB, 0.37040209E-03_JPRB, 0.37041216E-03_JPRB, 0.37042366E-03_JPRB, 0.37043713E-03_JPRB, &
  & 0.37045314E-03_JPRB, 0.37047209E-03_JPRB, 0.37049438E-03_JPRB, 0.37052011E-03_JPRB, 0.37054945E-03_JPRB, 0.37058195E-03_JPRB, &
  & 0.37061700E-03_JPRB, 0.37065355E-03_JPRB, 0.37069106E-03_JPRB, 0.37072881E-03_JPRB, 0.37076577E-03_JPRB, 0.37080163E-03_JPRB, &
  & 0.37083539E-03_JPRB, 0.37086627E-03_JPRB, 0.37089337E-03_JPRB, 0.37091598E-03_JPRB, 0.37093370E-03_JPRB, 0.37094665E-03_JPRB, &
  & 0.37095565E-03_JPRB, 0.37096185E-03_JPRB, 0.37096615E-03_JPRB, 0.37096930E-03_JPRB, 0.37097171E-03_JPRB, 0.37097355E-03_JPRB, &
  & 0.37097512E-03_JPRB, 0.37097619E-03_JPRB, 0.37097660E-03_JPRB, 0.37097634E-03_JPRB, 0.37097512E-03_JPRB, 0.37097305E-03_JPRB, &
  & 0.37096991E-03_JPRB, 0.37096551E-03_JPRB, 0.37095987E-03_JPRB, 0.37095271E-03_JPRB, 0.37094366E-03_JPRB, 0.37093283E-03_JPRB, &
  & 0.37092011E-03_JPRB, 0.37090571E-03_JPRB, 0.37088961E-03_JPRB, 0.37087203E-03_JPRB, 0.37085285E-03_JPRB, 0.37083286E-03_JPRB, &
  & 0.37081219E-03_JPRB, 0.37079144E-03_JPRB, 0.37077116E-03_JPRB, 0.37075154E-03_JPRB, 0.37073289E-03_JPRB, 0.37071545E-03_JPRB, &
  & 0.37069916E-03_JPRB, 0.37068379E-03_JPRB, 0.37066959E-03_JPRB, 0.37065678E-03_JPRB, 0.37064546E-03_JPRB, 0.37063565E-03_JPRB, &
  & 0.37062709E-03_JPRB, 0.37061927E-03_JPRB, 0.37061126E-03_JPRB, 0.37059913E-03_JPRB /)

RGHG1(:,39, 6) = (/ &
  & 0.37041720E-03_JPRB, 0.37043251E-03_JPRB, 0.37044307E-03_JPRB, 0.37045404E-03_JPRB, 0.37046586E-03_JPRB, 0.37047951E-03_JPRB, &
  & 0.37049502E-03_JPRB, 0.37051275E-03_JPRB, 0.37053315E-03_JPRB, 0.37055678E-03_JPRB, 0.37058364E-03_JPRB, 0.37061336E-03_JPRB, &
  & 0.37064543E-03_JPRB, 0.37067916E-03_JPRB, 0.37071400E-03_JPRB, 0.37074945E-03_JPRB, 0.37078446E-03_JPRB, 0.37081869E-03_JPRB, &
  & 0.37085131E-03_JPRB, 0.37088149E-03_JPRB, 0.37090786E-03_JPRB, 0.37092945E-03_JPRB, 0.37094590E-03_JPRB, 0.37095757E-03_JPRB, &
  & 0.37096525E-03_JPRB, 0.37097043E-03_JPRB, 0.37097387E-03_JPRB, 0.37097640E-03_JPRB, 0.37097826E-03_JPRB, 0.37097972E-03_JPRB, &
  & 0.37098074E-03_JPRB, 0.37098140E-03_JPRB, 0.37098155E-03_JPRB, 0.37098108E-03_JPRB, 0.37098009E-03_JPRB, 0.37097835E-03_JPRB, &
  & 0.37097587E-03_JPRB, 0.37097250E-03_JPRB, 0.37096810E-03_JPRB, 0.37096266E-03_JPRB, 0.37095568E-03_JPRB, 0.37094695E-03_JPRB, &
  & 0.37093647E-03_JPRB, 0.37092395E-03_JPRB, 0.37090958E-03_JPRB, 0.37089334E-03_JPRB, 0.37087541E-03_JPRB, 0.37085626E-03_JPRB, &
  & 0.37083626E-03_JPRB, 0.37081627E-03_JPRB, 0.37079660E-03_JPRB, 0.37077768E-03_JPRB, 0.37075984E-03_JPRB, 0.37074316E-03_JPRB, &
  & 0.37072744E-03_JPRB, 0.37071307E-03_JPRB, 0.37069968E-03_JPRB, 0.37068775E-03_JPRB, 0.37067747E-03_JPRB, 0.37066871E-03_JPRB, &
  & 0.37066109E-03_JPRB, 0.37065431E-03_JPRB, 0.37064735E-03_JPRB, 0.37063664E-03_JPRB /)

RGHG1(:,40, 6) = (/ &
  & 0.37045567E-03_JPRB, 0.37047156E-03_JPRB, 0.37048326E-03_JPRB, 0.37049458E-03_JPRB, 0.37050736E-03_JPRB, 0.37052101E-03_JPRB, &
  & 0.37053597E-03_JPRB, 0.37055253E-03_JPRB, 0.37057110E-03_JPRB, 0.37059229E-03_JPRB, 0.37061633E-03_JPRB, 0.37064319E-03_JPRB, &
  & 0.37067232E-03_JPRB, 0.37070320E-03_JPRB, 0.37073527E-03_JPRB, 0.37076825E-03_JPRB, 0.37080114E-03_JPRB, 0.37083362E-03_JPRB, &
  & 0.37086487E-03_JPRB, 0.37089389E-03_JPRB, 0.37091918E-03_JPRB, 0.37093947E-03_JPRB, 0.37095445E-03_JPRB, 0.37096470E-03_JPRB, &
  & 0.37097131E-03_JPRB, 0.37097553E-03_JPRB, 0.37097838E-03_JPRB, 0.37098047E-03_JPRB, 0.37098204E-03_JPRB, 0.37098321E-03_JPRB, &
  & 0.37098391E-03_JPRB, 0.37098440E-03_JPRB, 0.37098440E-03_JPRB, 0.37098399E-03_JPRB, 0.37098303E-03_JPRB, 0.37098167E-03_JPRB, &
  & 0.37097960E-03_JPRB, 0.37097681E-03_JPRB, 0.37097337E-03_JPRB, 0.37096906E-03_JPRB, 0.37096365E-03_JPRB, 0.37095687E-03_JPRB, &
  & 0.37094843E-03_JPRB, 0.37093807E-03_JPRB, 0.37092567E-03_JPRB, 0.37091106E-03_JPRB, 0.37089453E-03_JPRB, 0.37087643E-03_JPRB, &
  & 0.37085742E-03_JPRB, 0.37083816E-03_JPRB, 0.37081915E-03_JPRB, 0.37080096E-03_JPRB, 0.37078391E-03_JPRB, 0.37076796E-03_JPRB, &
  & 0.37075311E-03_JPRB, 0.37073938E-03_JPRB, 0.37072692E-03_JPRB, 0.37071583E-03_JPRB, 0.37070640E-03_JPRB, 0.37069863E-03_JPRB, &
  & 0.37069197E-03_JPRB, 0.37068612E-03_JPRB, 0.37068027E-03_JPRB, 0.37067104E-03_JPRB /)

RGHG1(:,41, 6) = (/ &
  & 0.37049316E-03_JPRB, 0.37051007E-03_JPRB, 0.37052180E-03_JPRB, 0.37053446E-03_JPRB, 0.37054758E-03_JPRB, 0.37056158E-03_JPRB, &
  & 0.37057593E-03_JPRB, 0.37059106E-03_JPRB, 0.37060777E-03_JPRB, 0.37062675E-03_JPRB, 0.37064796E-03_JPRB, 0.37067191E-03_JPRB, &
  & 0.37069822E-03_JPRB, 0.37072611E-03_JPRB, 0.37075544E-03_JPRB, 0.37078589E-03_JPRB, 0.37081650E-03_JPRB, 0.37084706E-03_JPRB, &
  & 0.37087678E-03_JPRB, 0.37090428E-03_JPRB, 0.37092806E-03_JPRB, 0.37094695E-03_JPRB, 0.37096057E-03_JPRB, 0.37096953E-03_JPRB, &
  & 0.37097521E-03_JPRB, 0.37097876E-03_JPRB, 0.37098126E-03_JPRB, 0.37098309E-03_JPRB, 0.37098449E-03_JPRB, 0.37098533E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098632E-03_JPRB, 0.37098624E-03_JPRB, 0.37098583E-03_JPRB, 0.37098501E-03_JPRB, 0.37098370E-03_JPRB, &
  & 0.37098199E-03_JPRB, 0.37097972E-03_JPRB, 0.37097681E-03_JPRB, 0.37097331E-03_JPRB, 0.37096901E-03_JPRB, 0.37096368E-03_JPRB, &
  & 0.37095702E-03_JPRB, 0.37094869E-03_JPRB, 0.37093839E-03_JPRB, 0.37092582E-03_JPRB, 0.37091080E-03_JPRB, 0.37089383E-03_JPRB, &
  & 0.37087587E-03_JPRB, 0.37085751E-03_JPRB, 0.37083938E-03_JPRB, 0.37082200E-03_JPRB, 0.37080573E-03_JPRB, 0.37079051E-03_JPRB, &
  & 0.37077646E-03_JPRB, 0.37076336E-03_JPRB, 0.37075148E-03_JPRB, 0.37074121E-03_JPRB, 0.37073283E-03_JPRB, 0.37072599E-03_JPRB, &
  & 0.37072040E-03_JPRB, 0.37071537E-03_JPRB, 0.37071030E-03_JPRB, 0.37070233E-03_JPRB /)

RGHG1(:,42, 6) = (/ &
  & 0.37053030E-03_JPRB, 0.37054738E-03_JPRB, 0.37056004E-03_JPRB, 0.37057282E-03_JPRB, 0.37058708E-03_JPRB, 0.37060102E-03_JPRB, &
  & 0.37061487E-03_JPRB, 0.37062890E-03_JPRB, 0.37064377E-03_JPRB, 0.37066021E-03_JPRB, 0.37067881E-03_JPRB, 0.37069997E-03_JPRB, &
  & 0.37072340E-03_JPRB, 0.37074854E-03_JPRB, 0.37077503E-03_JPRB, 0.37080268E-03_JPRB, 0.37083117E-03_JPRB, 0.37085940E-03_JPRB, &
  & 0.37088722E-03_JPRB, 0.37091310E-03_JPRB, 0.37093551E-03_JPRB, 0.37095291E-03_JPRB, 0.37096511E-03_JPRB, 0.37097299E-03_JPRB, &
  & 0.37097797E-03_JPRB, 0.37098111E-03_JPRB, 0.37098333E-03_JPRB, 0.37098478E-03_JPRB, 0.37098606E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098746E-03_JPRB, 0.37098772E-03_JPRB, 0.37098757E-03_JPRB, 0.37098714E-03_JPRB, 0.37098647E-03_JPRB, 0.37098530E-03_JPRB, &
  & 0.37098376E-03_JPRB, 0.37098170E-03_JPRB, 0.37097931E-03_JPRB, 0.37097631E-03_JPRB, 0.37097279E-03_JPRB, 0.37096860E-03_JPRB, &
  & 0.37096330E-03_JPRB, 0.37095670E-03_JPRB, 0.37094834E-03_JPRB, 0.37093769E-03_JPRB, 0.37092451E-03_JPRB, 0.37090908E-03_JPRB, &
  & 0.37089223E-03_JPRB, 0.37087488E-03_JPRB, 0.37085768E-03_JPRB, 0.37084115E-03_JPRB, 0.37082564E-03_JPRB, 0.37081126E-03_JPRB, &
  & 0.37079782E-03_JPRB, 0.37078542E-03_JPRB, 0.37077436E-03_JPRB, 0.37076496E-03_JPRB, 0.37075742E-03_JPRB, 0.37075148E-03_JPRB, &
  & 0.37074668E-03_JPRB, 0.37074243E-03_JPRB, 0.37073804E-03_JPRB, 0.37073114E-03_JPRB /)

RGHG1(:,43, 6) = (/ &
  & 0.37056691E-03_JPRB, 0.37058457E-03_JPRB, 0.37059680E-03_JPRB, 0.37061068E-03_JPRB, 0.37062512E-03_JPRB, 0.37063941E-03_JPRB, &
  & 0.37065279E-03_JPRB, 0.37066574E-03_JPRB, 0.37067890E-03_JPRB, 0.37069313E-03_JPRB, 0.37070920E-03_JPRB, 0.37072750E-03_JPRB, &
  & 0.37074808E-03_JPRB, 0.37077052E-03_JPRB, 0.37079433E-03_JPRB, 0.37081944E-03_JPRB, 0.37084532E-03_JPRB, 0.37087133E-03_JPRB, &
  & 0.37089686E-03_JPRB, 0.37092090E-03_JPRB, 0.37094162E-03_JPRB, 0.37095771E-03_JPRB, 0.37096869E-03_JPRB, 0.37097570E-03_JPRB, &
  & 0.37098007E-03_JPRB, 0.37098289E-03_JPRB, 0.37098484E-03_JPRB, 0.37098618E-03_JPRB, 0.37098728E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098862E-03_JPRB, 0.37098883E-03_JPRB, 0.37098868E-03_JPRB, 0.37098833E-03_JPRB, 0.37098766E-03_JPRB, 0.37098656E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098341E-03_JPRB, 0.37098126E-03_JPRB, 0.37097867E-03_JPRB, 0.37097567E-03_JPRB, 0.37097224E-03_JPRB, &
  & 0.37096813E-03_JPRB, 0.37096284E-03_JPRB, 0.37095620E-03_JPRB, 0.37094756E-03_JPRB, 0.37093638E-03_JPRB, 0.37092264E-03_JPRB, &
  & 0.37090719E-03_JPRB, 0.37089092E-03_JPRB, 0.37087471E-03_JPRB, 0.37085905E-03_JPRB, 0.37084444E-03_JPRB, 0.37083085E-03_JPRB, &
  & 0.37081810E-03_JPRB, 0.37080637E-03_JPRB, 0.37079593E-03_JPRB, 0.37078734E-03_JPRB, 0.37078065E-03_JPRB, 0.37077544E-03_JPRB, &
  & 0.37077125E-03_JPRB, 0.37076767E-03_JPRB, 0.37076377E-03_JPRB, 0.37075771E-03_JPRB /)

RGHG1(:,44, 6) = (/ &
  & 0.37060422E-03_JPRB, 0.37062122E-03_JPRB, 0.37063408E-03_JPRB, 0.37064741E-03_JPRB, 0.37066278E-03_JPRB, 0.37067709E-03_JPRB, &
  & 0.37069013E-03_JPRB, 0.37070195E-03_JPRB, 0.37071359E-03_JPRB, 0.37072579E-03_JPRB, 0.37073946E-03_JPRB, 0.37075509E-03_JPRB, &
  & 0.37077296E-03_JPRB, 0.37079270E-03_JPRB, 0.37081400E-03_JPRB, 0.37083644E-03_JPRB, 0.37085963E-03_JPRB, 0.37088309E-03_JPRB, &
  & 0.37090635E-03_JPRB, 0.37092820E-03_JPRB, 0.37094724E-03_JPRB, 0.37096167E-03_JPRB, 0.37097163E-03_JPRB, 0.37097788E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098431E-03_JPRB, 0.37098597E-03_JPRB, 0.37098725E-03_JPRB, 0.37098827E-03_JPRB, 0.37098906E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098967E-03_JPRB, 0.37098961E-03_JPRB, 0.37098926E-03_JPRB, 0.37098862E-03_JPRB, 0.37098766E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098475E-03_JPRB, 0.37098283E-03_JPRB, 0.37098065E-03_JPRB, 0.37097809E-03_JPRB, 0.37097518E-03_JPRB, &
  & 0.37097186E-03_JPRB, 0.37096767E-03_JPRB, 0.37096249E-03_JPRB, 0.37095565E-03_JPRB, 0.37094657E-03_JPRB, 0.37093490E-03_JPRB, &
  & 0.37092107E-03_JPRB, 0.37090600E-03_JPRB, 0.37089072E-03_JPRB, 0.37087602E-03_JPRB, 0.37086237E-03_JPRB, 0.37084956E-03_JPRB, &
  & 0.37083763E-03_JPRB, 0.37082657E-03_JPRB, 0.37081697E-03_JPRB, 0.37080905E-03_JPRB, 0.37080303E-03_JPRB, 0.37079843E-03_JPRB, &
  & 0.37079482E-03_JPRB, 0.37079159E-03_JPRB, 0.37078827E-03_JPRB, 0.37078289E-03_JPRB /)

RGHG1(:,45, 6) = (/ &
  & 0.37064211E-03_JPRB, 0.37065885E-03_JPRB, 0.37067028E-03_JPRB, 0.37068443E-03_JPRB, 0.37069948E-03_JPRB, 0.37071438E-03_JPRB, &
  & 0.37072683E-03_JPRB, 0.37073783E-03_JPRB, 0.37074799E-03_JPRB, 0.37075841E-03_JPRB, 0.37076985E-03_JPRB, 0.37078321E-03_JPRB, &
  & 0.37079852E-03_JPRB, 0.37081566E-03_JPRB, 0.37083431E-03_JPRB, 0.37085419E-03_JPRB, 0.37087454E-03_JPRB, 0.37089537E-03_JPRB, &
  & 0.37091583E-03_JPRB, 0.37093542E-03_JPRB, 0.37095230E-03_JPRB, 0.37096528E-03_JPRB, 0.37097416E-03_JPRB, 0.37097975E-03_JPRB, &
  & 0.37098327E-03_JPRB, 0.37098551E-03_JPRB, 0.37098699E-03_JPRB, 0.37098819E-03_JPRB, 0.37098915E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099037E-03_JPRB, 0.37099051E-03_JPRB, 0.37099048E-03_JPRB, 0.37099008E-03_JPRB, 0.37098944E-03_JPRB, 0.37098859E-03_JPRB, &
  & 0.37098740E-03_JPRB, 0.37098583E-03_JPRB, 0.37098414E-03_JPRB, 0.37098216E-03_JPRB, 0.37098001E-03_JPRB, 0.37097750E-03_JPRB, &
  & 0.37097471E-03_JPRB, 0.37097145E-03_JPRB, 0.37096755E-03_JPRB, 0.37096237E-03_JPRB, 0.37095521E-03_JPRB, 0.37094578E-03_JPRB, &
  & 0.37093379E-03_JPRB, 0.37092014E-03_JPRB, 0.37090608E-03_JPRB, 0.37089255E-03_JPRB, 0.37087989E-03_JPRB, 0.37086796E-03_JPRB, &
  & 0.37085690E-03_JPRB, 0.37084671E-03_JPRB, 0.37083786E-03_JPRB, 0.37083062E-03_JPRB, 0.37082535E-03_JPRB, 0.37082130E-03_JPRB, &
  & 0.37081813E-03_JPRB, 0.37081528E-03_JPRB, 0.37081219E-03_JPRB, 0.37080733E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART12',0,ZHOOK_HANDLE)



RGHG1(:,46, 6) = (/ &
  & 0.37067896E-03_JPRB, 0.37069520E-03_JPRB, 0.37070760E-03_JPRB, 0.37072043E-03_JPRB, 0.37073664E-03_JPRB, 0.37075111E-03_JPRB, &
  & 0.37076359E-03_JPRB, 0.37077366E-03_JPRB, 0.37078263E-03_JPRB, 0.37079139E-03_JPRB, 0.37080102E-03_JPRB, 0.37081196E-03_JPRB, &
  & 0.37082488E-03_JPRB, 0.37083961E-03_JPRB, 0.37085591E-03_JPRB, 0.37087296E-03_JPRB, 0.37089060E-03_JPRB, 0.37090830E-03_JPRB, &
  & 0.37092582E-03_JPRB, 0.37094246E-03_JPRB, 0.37095716E-03_JPRB, 0.37096842E-03_JPRB, 0.37097625E-03_JPRB, 0.37098117E-03_JPRB, &
  & 0.37098434E-03_JPRB, 0.37098650E-03_JPRB, 0.37098792E-03_JPRB, 0.37098897E-03_JPRB, 0.37098987E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099127E-03_JPRB, 0.37099127E-03_JPRB, 0.37099083E-03_JPRB, 0.37099031E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098691E-03_JPRB, 0.37098533E-03_JPRB, 0.37098350E-03_JPRB, 0.37098158E-03_JPRB, 0.37097945E-03_JPRB, &
  & 0.37097716E-03_JPRB, 0.37097454E-03_JPRB, 0.37097151E-03_JPRB, 0.37096758E-03_JPRB, 0.37096237E-03_JPRB, 0.37095518E-03_JPRB, &
  & 0.37094561E-03_JPRB, 0.37093385E-03_JPRB, 0.37092122E-03_JPRB, 0.37090888E-03_JPRB, 0.37089724E-03_JPRB, 0.37088641E-03_JPRB, &
  & 0.37087637E-03_JPRB, 0.37086700E-03_JPRB, 0.37085888E-03_JPRB, 0.37085242E-03_JPRB, 0.37084767E-03_JPRB, 0.37084406E-03_JPRB, &
  & 0.37084121E-03_JPRB, 0.37083868E-03_JPRB, 0.37083597E-03_JPRB, 0.37083135E-03_JPRB /)

RGHG1(:,47, 6) = (/ &
  & 0.37071973E-03_JPRB, 0.37073463E-03_JPRB, 0.37074499E-03_JPRB, 0.37075847E-03_JPRB, 0.37077349E-03_JPRB, 0.37078885E-03_JPRB, &
  & 0.37080044E-03_JPRB, 0.37080990E-03_JPRB, 0.37081767E-03_JPRB, 0.37082503E-03_JPRB, 0.37083274E-03_JPRB, 0.37084182E-03_JPRB, &
  & 0.37085259E-03_JPRB, 0.37086511E-03_JPRB, 0.37087878E-03_JPRB, 0.37089322E-03_JPRB, 0.37090777E-03_JPRB, 0.37092218E-03_JPRB, &
  & 0.37093612E-03_JPRB, 0.37094956E-03_JPRB, 0.37096150E-03_JPRB, 0.37097119E-03_JPRB, 0.37097800E-03_JPRB, 0.37098236E-03_JPRB, &
  & 0.37098522E-03_JPRB, 0.37098723E-03_JPRB, 0.37098856E-03_JPRB, 0.37098964E-03_JPRB, 0.37099048E-03_JPRB, 0.37099118E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099197E-03_JPRB, 0.37099194E-03_JPRB, 0.37099159E-03_JPRB, 0.37099107E-03_JPRB, 0.37099034E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098784E-03_JPRB, 0.37098638E-03_JPRB, 0.37098481E-03_JPRB, 0.37098295E-03_JPRB, 0.37098106E-03_JPRB, &
  & 0.37097911E-03_JPRB, 0.37097701E-03_JPRB, 0.37097462E-03_JPRB, 0.37097180E-03_JPRB, 0.37096805E-03_JPRB, 0.37096284E-03_JPRB, &
  & 0.37095559E-03_JPRB, 0.37094645E-03_JPRB, 0.37093577E-03_JPRB, 0.37092497E-03_JPRB, 0.37091464E-03_JPRB, 0.37090504E-03_JPRB, &
  & 0.37089610E-03_JPRB, 0.37088763E-03_JPRB, 0.37088030E-03_JPRB, 0.37087448E-03_JPRB, 0.37087017E-03_JPRB, 0.37086697E-03_JPRB, &
  & 0.37086438E-03_JPRB, 0.37086202E-03_JPRB, 0.37085955E-03_JPRB, 0.37085524E-03_JPRB /)

RGHG1(:,48, 6) = (/ &
  & 0.37075614E-03_JPRB, 0.37077192E-03_JPRB, 0.37078359E-03_JPRB, 0.37079648E-03_JPRB, 0.37081272E-03_JPRB, 0.37082742E-03_JPRB, &
  & 0.37083917E-03_JPRB, 0.37084759E-03_JPRB, 0.37085422E-03_JPRB, 0.37086004E-03_JPRB, 0.37086621E-03_JPRB, 0.37087317E-03_JPRB, &
  & 0.37088184E-03_JPRB, 0.37089197E-03_JPRB, 0.37090335E-03_JPRB, 0.37091479E-03_JPRB, 0.37092596E-03_JPRB, 0.37093664E-03_JPRB, &
  & 0.37094677E-03_JPRB, 0.37095649E-03_JPRB, 0.37096557E-03_JPRB, 0.37097343E-03_JPRB, 0.37097943E-03_JPRB, 0.37098338E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098787E-03_JPRB, 0.37098920E-03_JPRB, 0.37099019E-03_JPRB, 0.37099098E-03_JPRB, 0.37099168E-03_JPRB, &
  & 0.37099220E-03_JPRB, 0.37099252E-03_JPRB, 0.37099252E-03_JPRB, 0.37099235E-03_JPRB, 0.37099179E-03_JPRB, 0.37099104E-03_JPRB, &
  & 0.37099005E-03_JPRB, 0.37098874E-03_JPRB, 0.37098728E-03_JPRB, 0.37098583E-03_JPRB, 0.37098408E-03_JPRB, 0.37098245E-03_JPRB, &
  & 0.37098074E-03_JPRB, 0.37097908E-03_JPRB, 0.37097724E-03_JPRB, 0.37097515E-03_JPRB, 0.37097250E-03_JPRB, 0.37096895E-03_JPRB, &
  & 0.37096415E-03_JPRB, 0.37095754E-03_JPRB, 0.37094974E-03_JPRB, 0.37094107E-03_JPRB, 0.37093251E-03_JPRB, 0.37092424E-03_JPRB, &
  & 0.37091639E-03_JPRB, 0.37090885E-03_JPRB, 0.37090224E-03_JPRB, 0.37089695E-03_JPRB, 0.37089299E-03_JPRB, 0.37089008E-03_JPRB, &
  & 0.37088778E-03_JPRB, 0.37088557E-03_JPRB, 0.37088312E-03_JPRB, 0.37087913E-03_JPRB /)

RGHG1(:,49, 6) = (/ &
  & 0.37079415E-03_JPRB, 0.37081109E-03_JPRB, 0.37082288E-03_JPRB, 0.37083650E-03_JPRB, 0.37085242E-03_JPRB, 0.37086764E-03_JPRB, &
  & 0.37087844E-03_JPRB, 0.37088586E-03_JPRB, 0.37089112E-03_JPRB, 0.37089569E-03_JPRB, 0.37090023E-03_JPRB, 0.37090541E-03_JPRB, &
  & 0.37091167E-03_JPRB, 0.37091938E-03_JPRB, 0.37092788E-03_JPRB, 0.37093612E-03_JPRB, 0.37094354E-03_JPRB, 0.37095015E-03_JPRB, &
  & 0.37095649E-03_JPRB, 0.37096269E-03_JPRB, 0.37096927E-03_JPRB, 0.37097550E-03_JPRB, 0.37098056E-03_JPRB, 0.37098414E-03_JPRB, &
  & 0.37098661E-03_JPRB, 0.37098839E-03_JPRB, 0.37098967E-03_JPRB, 0.37099072E-03_JPRB, 0.37099150E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099308E-03_JPRB, 0.37099310E-03_JPRB, 0.37099293E-03_JPRB, 0.37099246E-03_JPRB, 0.37099174E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37098952E-03_JPRB, 0.37098813E-03_JPRB, 0.37098676E-03_JPRB, 0.37098522E-03_JPRB, 0.37098370E-03_JPRB, &
  & 0.37098222E-03_JPRB, 0.37098074E-03_JPRB, 0.37097925E-03_JPRB, 0.37097768E-03_JPRB, 0.37097582E-03_JPRB, 0.37097352E-03_JPRB, &
  & 0.37097052E-03_JPRB, 0.37096642E-03_JPRB, 0.37096138E-03_JPRB, 0.37095573E-03_JPRB, 0.37094954E-03_JPRB, 0.37094334E-03_JPRB, &
  & 0.37093693E-03_JPRB, 0.37093050E-03_JPRB, 0.37092454E-03_JPRB, 0.37091968E-03_JPRB, 0.37091604E-03_JPRB, 0.37091333E-03_JPRB, &
  & 0.37091115E-03_JPRB, 0.37090908E-03_JPRB, 0.37090675E-03_JPRB, 0.37090274E-03_JPRB /)

RGHG1(:,50, 6) = (/ &
  & 0.37083315E-03_JPRB, 0.37085009E-03_JPRB, 0.37086141E-03_JPRB, 0.37087465E-03_JPRB, 0.37089008E-03_JPRB, 0.37090419E-03_JPRB, &
  & 0.37091377E-03_JPRB, 0.37091965E-03_JPRB, 0.37092355E-03_JPRB, 0.37092663E-03_JPRB, 0.37092972E-03_JPRB, 0.37093312E-03_JPRB, &
  & 0.37093740E-03_JPRB, 0.37094258E-03_JPRB, 0.37094802E-03_JPRB, 0.37095300E-03_JPRB, 0.37095710E-03_JPRB, 0.37096077E-03_JPRB, &
  & 0.37096409E-03_JPRB, 0.37096802E-03_JPRB, 0.37097221E-03_JPRB, 0.37097707E-03_JPRB, 0.37098138E-03_JPRB, 0.37098478E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098888E-03_JPRB, 0.37099008E-03_JPRB, 0.37099115E-03_JPRB, 0.37099194E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099354E-03_JPRB, 0.37099363E-03_JPRB, 0.37099357E-03_JPRB, 0.37099316E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099142E-03_JPRB, 0.37099037E-03_JPRB, 0.37098894E-03_JPRB, 0.37098757E-03_JPRB, 0.37098612E-03_JPRB, 0.37098464E-03_JPRB, &
  & 0.37098344E-03_JPRB, 0.37098216E-03_JPRB, 0.37098088E-03_JPRB, 0.37097972E-03_JPRB, 0.37097844E-03_JPRB, 0.37097698E-03_JPRB, &
  & 0.37097506E-03_JPRB, 0.37097276E-03_JPRB, 0.37096997E-03_JPRB, 0.37096679E-03_JPRB, 0.37096339E-03_JPRB, 0.37095952E-03_JPRB, &
  & 0.37095527E-03_JPRB, 0.37095067E-03_JPRB, 0.37094596E-03_JPRB, 0.37094182E-03_JPRB, 0.37093865E-03_JPRB, 0.37093618E-03_JPRB, &
  & 0.37093420E-03_JPRB, 0.37093219E-03_JPRB, 0.37092992E-03_JPRB, 0.37092582E-03_JPRB /)

RGHG1(:,51, 6) = (/ &
  & 0.37086819E-03_JPRB, 0.37088373E-03_JPRB, 0.37089497E-03_JPRB, 0.37090611E-03_JPRB, 0.37091976E-03_JPRB, 0.37093129E-03_JPRB, &
  & 0.37093856E-03_JPRB, 0.37094258E-03_JPRB, 0.37094526E-03_JPRB, 0.37094732E-03_JPRB, 0.37094910E-03_JPRB, 0.37095131E-03_JPRB, &
  & 0.37095405E-03_JPRB, 0.37095731E-03_JPRB, 0.37096068E-03_JPRB, 0.37096356E-03_JPRB, 0.37096592E-03_JPRB, 0.37096784E-03_JPRB, &
  & 0.37096985E-03_JPRB, 0.37097189E-03_JPRB, 0.37097489E-03_JPRB, 0.37097832E-03_JPRB, 0.37098207E-03_JPRB, 0.37098528E-03_JPRB, &
  & 0.37098757E-03_JPRB, 0.37098923E-03_JPRB, 0.37099043E-03_JPRB, 0.37099147E-03_JPRB, 0.37099235E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099401E-03_JPRB, 0.37099418E-03_JPRB, 0.37099404E-03_JPRB, 0.37099366E-03_JPRB, 0.37099296E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099101E-03_JPRB, 0.37098967E-03_JPRB, 0.37098839E-03_JPRB, 0.37098693E-03_JPRB, 0.37098562E-03_JPRB, &
  & 0.37098455E-03_JPRB, 0.37098338E-03_JPRB, 0.37098236E-03_JPRB, 0.37098146E-03_JPRB, 0.37098044E-03_JPRB, 0.37097943E-03_JPRB, &
  & 0.37097829E-03_JPRB, 0.37097692E-03_JPRB, 0.37097547E-03_JPRB, 0.37097390E-03_JPRB, 0.37097215E-03_JPRB, 0.37097029E-03_JPRB, &
  & 0.37096816E-03_JPRB, 0.37096557E-03_JPRB, 0.37096284E-03_JPRB, 0.37096033E-03_JPRB, 0.37095812E-03_JPRB, 0.37095655E-03_JPRB, &
  & 0.37095492E-03_JPRB, 0.37095335E-03_JPRB, 0.37095122E-03_JPRB, 0.37094727E-03_JPRB /)

RGHG1(:,52, 6) = (/ &
  & 0.37089974E-03_JPRB, 0.37091254E-03_JPRB, 0.37092040E-03_JPRB, 0.37092972E-03_JPRB, 0.37093976E-03_JPRB, 0.37094849E-03_JPRB, &
  & 0.37095341E-03_JPRB, 0.37095620E-03_JPRB, 0.37095783E-03_JPRB, 0.37095911E-03_JPRB, 0.37096036E-03_JPRB, 0.37096170E-03_JPRB, &
  & 0.37096353E-03_JPRB, 0.37096566E-03_JPRB, 0.37096787E-03_JPRB, 0.37096970E-03_JPRB, 0.37097116E-03_JPRB, 0.37097238E-03_JPRB, &
  & 0.37097349E-03_JPRB, 0.37097512E-03_JPRB, 0.37097681E-03_JPRB, 0.37097960E-03_JPRB, 0.37098269E-03_JPRB, 0.37098571E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098961E-03_JPRB, 0.37099083E-03_JPRB, 0.37099185E-03_JPRB, 0.37099270E-03_JPRB, 0.37099342E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099447E-03_JPRB, 0.37099465E-03_JPRB, 0.37099450E-03_JPRB, 0.37099421E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099153E-03_JPRB, 0.37099031E-03_JPRB, 0.37098903E-03_JPRB, 0.37098769E-03_JPRB, 0.37098650E-03_JPRB, &
  & 0.37098551E-03_JPRB, 0.37098458E-03_JPRB, 0.37098359E-03_JPRB, 0.37098289E-03_JPRB, 0.37098213E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098068E-03_JPRB, 0.37097983E-03_JPRB, 0.37097902E-03_JPRB, 0.37097820E-03_JPRB, 0.37097739E-03_JPRB, 0.37097652E-03_JPRB, &
  & 0.37097553E-03_JPRB, 0.37097445E-03_JPRB, 0.37097317E-03_JPRB, 0.37097195E-03_JPRB, 0.37097101E-03_JPRB, 0.37097008E-03_JPRB, &
  & 0.37096924E-03_JPRB, 0.37096825E-03_JPRB, 0.37096700E-03_JPRB, 0.37096391E-03_JPRB /)

RGHG1(:,53, 6) = (/ &
  & 0.37092291E-03_JPRB, 0.37093257E-03_JPRB, 0.37093926E-03_JPRB, 0.37094564E-03_JPRB, 0.37095309E-03_JPRB, 0.37095897E-03_JPRB, &
  & 0.37096237E-03_JPRB, 0.37096415E-03_JPRB, 0.37096528E-03_JPRB, 0.37096615E-03_JPRB, 0.37096694E-03_JPRB, 0.37096796E-03_JPRB, &
  & 0.37096909E-03_JPRB, 0.37097069E-03_JPRB, 0.37097227E-03_JPRB, 0.37097355E-03_JPRB, 0.37097465E-03_JPRB, 0.37097553E-03_JPRB, &
  & 0.37097640E-03_JPRB, 0.37097721E-03_JPRB, 0.37097867E-03_JPRB, 0.37098050E-03_JPRB, 0.37098324E-03_JPRB, 0.37098606E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098996E-03_JPRB, 0.37099115E-03_JPRB, 0.37099211E-03_JPRB, 0.37099293E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099436E-03_JPRB, 0.37099482E-03_JPRB, 0.37099505E-03_JPRB, 0.37099505E-03_JPRB, 0.37099468E-03_JPRB, 0.37099406E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099211E-03_JPRB, 0.37099104E-03_JPRB, 0.37098973E-03_JPRB, 0.37098845E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098554E-03_JPRB, 0.37098478E-03_JPRB, 0.37098414E-03_JPRB, 0.37098356E-03_JPRB, 0.37098303E-03_JPRB, &
  & 0.37098257E-03_JPRB, 0.37098193E-03_JPRB, 0.37098140E-03_JPRB, 0.37098088E-03_JPRB, 0.37098042E-03_JPRB, 0.37097998E-03_JPRB, &
  & 0.37097954E-03_JPRB, 0.37097908E-03_JPRB, 0.37097861E-03_JPRB, 0.37097814E-03_JPRB, 0.37097768E-03_JPRB, 0.37097730E-03_JPRB, &
  & 0.37097692E-03_JPRB, 0.37097654E-03_JPRB, 0.37097587E-03_JPRB, 0.37097430E-03_JPRB /)

RGHG1(:,54, 6) = (/ &
  & 0.37094200E-03_JPRB, 0.37094840E-03_JPRB, 0.37095239E-03_JPRB, 0.37095690E-03_JPRB, 0.37096182E-03_JPRB, 0.37096586E-03_JPRB, &
  & 0.37096808E-03_JPRB, 0.37096930E-03_JPRB, 0.37097005E-03_JPRB, 0.37097064E-03_JPRB, 0.37097125E-03_JPRB, 0.37097186E-03_JPRB, &
  & 0.37097273E-03_JPRB, 0.37097390E-03_JPRB, 0.37097518E-03_JPRB, 0.37097622E-03_JPRB, 0.37097698E-03_JPRB, 0.37097765E-03_JPRB, &
  & 0.37097820E-03_JPRB, 0.37097905E-03_JPRB, 0.37097995E-03_JPRB, 0.37098164E-03_JPRB, 0.37098376E-03_JPRB, 0.37098641E-03_JPRB, &
  & 0.37098862E-03_JPRB, 0.37099034E-03_JPRB, 0.37099147E-03_JPRB, 0.37099243E-03_JPRB, 0.37099325E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099465E-03_JPRB, 0.37099520E-03_JPRB, 0.37099546E-03_JPRB, 0.37099549E-03_JPRB, 0.37099517E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099273E-03_JPRB, 0.37099162E-03_JPRB, 0.37099043E-03_JPRB, 0.37098918E-03_JPRB, 0.37098813E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098644E-03_JPRB, 0.37098583E-03_JPRB, 0.37098536E-03_JPRB, 0.37098484E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098391E-03_JPRB, 0.37098350E-03_JPRB, 0.37098315E-03_JPRB, 0.37098280E-03_JPRB, 0.37098254E-03_JPRB, 0.37098225E-03_JPRB, &
  & 0.37098199E-03_JPRB, 0.37098175E-03_JPRB, 0.37098155E-03_JPRB, 0.37098140E-03_JPRB, 0.37098129E-03_JPRB, 0.37098114E-03_JPRB, &
  & 0.37098103E-03_JPRB, 0.37098088E-03_JPRB, 0.37098074E-03_JPRB, 0.37098074E-03_JPRB /)

RGHG1(:,55, 6) = (/ &
  & 0.37095379E-03_JPRB, 0.37095859E-03_JPRB, 0.37096161E-03_JPRB, 0.37096464E-03_JPRB, 0.37096790E-03_JPRB, 0.37097064E-03_JPRB, &
  & 0.37097221E-03_JPRB, 0.37097305E-03_JPRB, 0.37097363E-03_JPRB, 0.37097401E-03_JPRB, 0.37097436E-03_JPRB, 0.37097483E-03_JPRB, &
  & 0.37097541E-03_JPRB, 0.37097634E-03_JPRB, 0.37097727E-03_JPRB, 0.37097812E-03_JPRB, 0.37097881E-03_JPRB, 0.37097937E-03_JPRB, &
  & 0.37097995E-03_JPRB, 0.37098050E-03_JPRB, 0.37098135E-03_JPRB, 0.37098254E-03_JPRB, 0.37098443E-03_JPRB, 0.37098682E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37099066E-03_JPRB, 0.37099177E-03_JPRB, 0.37099276E-03_JPRB, 0.37099354E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099558E-03_JPRB, 0.37099584E-03_JPRB, 0.37099593E-03_JPRB, 0.37099555E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099418E-03_JPRB, 0.37099319E-03_JPRB, 0.37099217E-03_JPRB, 0.37099098E-03_JPRB, 0.37098984E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098731E-03_JPRB, 0.37098676E-03_JPRB, 0.37098632E-03_JPRB, 0.37098592E-03_JPRB, 0.37098554E-03_JPRB, &
  & 0.37098513E-03_JPRB, 0.37098481E-03_JPRB, 0.37098443E-03_JPRB, 0.37098414E-03_JPRB, 0.37098399E-03_JPRB, 0.37098385E-03_JPRB, &
  & 0.37098370E-03_JPRB, 0.37098356E-03_JPRB, 0.37098344E-03_JPRB, 0.37098338E-03_JPRB, 0.37098330E-03_JPRB, 0.37098321E-03_JPRB, &
  & 0.37098315E-03_JPRB, 0.37098309E-03_JPRB, 0.37098298E-03_JPRB, 0.37098277E-03_JPRB /)

RGHG1(:,56, 6) = (/ &
  & 0.37096383E-03_JPRB, 0.37096639E-03_JPRB, 0.37096819E-03_JPRB, 0.37097005E-03_JPRB, 0.37097221E-03_JPRB, 0.37097401E-03_JPRB, &
  & 0.37097509E-03_JPRB, 0.37097567E-03_JPRB, 0.37097608E-03_JPRB, 0.37097640E-03_JPRB, 0.37097669E-03_JPRB, 0.37097707E-03_JPRB, &
  & 0.37097762E-03_JPRB, 0.37097826E-03_JPRB, 0.37097896E-03_JPRB, 0.37097966E-03_JPRB, 0.37098024E-03_JPRB, 0.37098076E-03_JPRB, &
  & 0.37098123E-03_JPRB, 0.37098181E-03_JPRB, 0.37098239E-03_JPRB, 0.37098344E-03_JPRB, 0.37098507E-03_JPRB, 0.37098725E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37099098E-03_JPRB, 0.37099209E-03_JPRB, 0.37099310E-03_JPRB, 0.37099389E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099596E-03_JPRB, 0.37099622E-03_JPRB, 0.37099631E-03_JPRB, 0.37099601E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099383E-03_JPRB, 0.37099276E-03_JPRB, 0.37099156E-03_JPRB, 0.37099040E-03_JPRB, 0.37098941E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37098816E-03_JPRB, 0.37098772E-03_JPRB, 0.37098734E-03_JPRB, 0.37098691E-03_JPRB, 0.37098656E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098586E-03_JPRB, 0.37098557E-03_JPRB, 0.37098536E-03_JPRB, 0.37098525E-03_JPRB, 0.37098516E-03_JPRB, &
  & 0.37098498E-03_JPRB, 0.37098487E-03_JPRB, 0.37098472E-03_JPRB, 0.37098458E-03_JPRB, 0.37098449E-03_JPRB, 0.37098437E-03_JPRB, &
  & 0.37098434E-03_JPRB, 0.37098431E-03_JPRB, 0.37098431E-03_JPRB, 0.37098417E-03_JPRB /)

RGHG1(:,57, 6) = (/ &
  & 0.37096965E-03_JPRB, 0.37097145E-03_JPRB, 0.37097262E-03_JPRB, 0.37097395E-03_JPRB, 0.37097535E-03_JPRB, 0.37097666E-03_JPRB, &
  & 0.37097739E-03_JPRB, 0.37097780E-03_JPRB, 0.37097809E-03_JPRB, 0.37097832E-03_JPRB, 0.37097855E-03_JPRB, 0.37097881E-03_JPRB, &
  & 0.37097919E-03_JPRB, 0.37097977E-03_JPRB, 0.37098036E-03_JPRB, 0.37098094E-03_JPRB, 0.37098146E-03_JPRB, 0.37098193E-03_JPRB, &
  & 0.37098234E-03_JPRB, 0.37098280E-03_JPRB, 0.37098335E-03_JPRB, 0.37098426E-03_JPRB, 0.37098577E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098970E-03_JPRB, 0.37099130E-03_JPRB, 0.37099243E-03_JPRB, 0.37099348E-03_JPRB, 0.37099421E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099631E-03_JPRB, 0.37099648E-03_JPRB, 0.37099665E-03_JPRB, 0.37099636E-03_JPRB, 0.37099596E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099436E-03_JPRB, 0.37099328E-03_JPRB, 0.37099211E-03_JPRB, 0.37099104E-03_JPRB, 0.37099005E-03_JPRB, &
  & 0.37098944E-03_JPRB, 0.37098888E-03_JPRB, 0.37098853E-03_JPRB, 0.37098816E-03_JPRB, 0.37098778E-03_JPRB, 0.37098749E-03_JPRB, &
  & 0.37098717E-03_JPRB, 0.37098693E-03_JPRB, 0.37098661E-03_JPRB, 0.37098635E-03_JPRB, 0.37098618E-03_JPRB, 0.37098606E-03_JPRB, &
  & 0.37098594E-03_JPRB, 0.37098589E-03_JPRB, 0.37098577E-03_JPRB, 0.37098565E-03_JPRB, 0.37098560E-03_JPRB, 0.37098551E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098539E-03_JPRB, 0.37098536E-03_JPRB, 0.37098522E-03_JPRB /)

RGHG1(:,58, 6) = (/ &
  & 0.37097401E-03_JPRB, 0.37097521E-03_JPRB, 0.37097605E-03_JPRB, 0.37097689E-03_JPRB, 0.37097785E-03_JPRB, 0.37097867E-03_JPRB, &
  & 0.37097916E-03_JPRB, 0.37097943E-03_JPRB, 0.37097963E-03_JPRB, 0.37097980E-03_JPRB, 0.37098001E-03_JPRB, 0.37098027E-03_JPRB, &
  & 0.37098065E-03_JPRB, 0.37098108E-03_JPRB, 0.37098158E-03_JPRB, 0.37098216E-03_JPRB, 0.37098263E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098341E-03_JPRB, 0.37098385E-03_JPRB, 0.37098437E-03_JPRB, 0.37098522E-03_JPRB, 0.37098659E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37099168E-03_JPRB, 0.37099273E-03_JPRB, 0.37099374E-03_JPRB, 0.37099459E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099665E-03_JPRB, 0.37099677E-03_JPRB, 0.37099706E-03_JPRB, 0.37099677E-03_JPRB, 0.37099639E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099488E-03_JPRB, 0.37099383E-03_JPRB, 0.37099264E-03_JPRB, 0.37099159E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099016E-03_JPRB, 0.37098970E-03_JPRB, 0.37098935E-03_JPRB, 0.37098894E-03_JPRB, 0.37098868E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37098807E-03_JPRB, 0.37098787E-03_JPRB, 0.37098752E-03_JPRB, 0.37098731E-03_JPRB, 0.37098711E-03_JPRB, 0.37098696E-03_JPRB, &
  & 0.37098682E-03_JPRB, 0.37098676E-03_JPRB, 0.37098667E-03_JPRB, 0.37098659E-03_JPRB, 0.37098653E-03_JPRB, 0.37098653E-03_JPRB, &
  & 0.37098647E-03_JPRB, 0.37098641E-03_JPRB, 0.37098632E-03_JPRB, 0.37098615E-03_JPRB /)

RGHG1(:,59, 6) = (/ &
  & 0.37097704E-03_JPRB, 0.37097800E-03_JPRB, 0.37097855E-03_JPRB, 0.37097913E-03_JPRB, 0.37097972E-03_JPRB, 0.37098024E-03_JPRB, &
  & 0.37098062E-03_JPRB, 0.37098082E-03_JPRB, 0.37098097E-03_JPRB, 0.37098106E-03_JPRB, 0.37098123E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098172E-03_JPRB, 0.37098216E-03_JPRB, 0.37098271E-03_JPRB, 0.37098321E-03_JPRB, 0.37098362E-03_JPRB, 0.37098397E-03_JPRB, &
  & 0.37098443E-03_JPRB, 0.37098484E-03_JPRB, 0.37098530E-03_JPRB, 0.37098612E-03_JPRB, 0.37098734E-03_JPRB, 0.37098906E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099209E-03_JPRB, 0.37099310E-03_JPRB, 0.37099415E-03_JPRB, 0.37099503E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099695E-03_JPRB, 0.37099718E-03_JPRB, 0.37099744E-03_JPRB, 0.37099715E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099532E-03_JPRB, 0.37099438E-03_JPRB, 0.37099325E-03_JPRB, 0.37099229E-03_JPRB, 0.37099145E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099046E-03_JPRB, 0.37099014E-03_JPRB, 0.37098976E-03_JPRB, 0.37098947E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098900E-03_JPRB, 0.37098877E-03_JPRB, 0.37098848E-03_JPRB, 0.37098827E-03_JPRB, 0.37098810E-03_JPRB, 0.37098789E-03_JPRB, &
  & 0.37098769E-03_JPRB, 0.37098757E-03_JPRB, 0.37098740E-03_JPRB, 0.37098737E-03_JPRB, 0.37098731E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098723E-03_JPRB, 0.37098717E-03_JPRB, 0.37098711E-03_JPRB, 0.37098691E-03_JPRB /)

RGHG1(:,60, 6) = (/ &
  & 0.37097948E-03_JPRB, 0.37098015E-03_JPRB, 0.37098053E-03_JPRB, 0.37098094E-03_JPRB, 0.37098140E-03_JPRB, 0.37098181E-03_JPRB, &
  & 0.37098210E-03_JPRB, 0.37098228E-03_JPRB, 0.37098239E-03_JPRB, 0.37098251E-03_JPRB, 0.37098263E-03_JPRB, 0.37098274E-03_JPRB, &
  & 0.37098298E-03_JPRB, 0.37098327E-03_JPRB, 0.37098373E-03_JPRB, 0.37098426E-03_JPRB, 0.37098469E-03_JPRB, 0.37098504E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098583E-03_JPRB, 0.37098621E-03_JPRB, 0.37098696E-03_JPRB, 0.37098810E-03_JPRB, 0.37098970E-03_JPRB, &
  & 0.37099110E-03_JPRB, 0.37099249E-03_JPRB, 0.37099351E-03_JPRB, 0.37099459E-03_JPRB, 0.37099537E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099741E-03_JPRB, 0.37099753E-03_JPRB, 0.37099779E-03_JPRB, 0.37099756E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099657E-03_JPRB, 0.37099578E-03_JPRB, 0.37099491E-03_JPRB, 0.37099374E-03_JPRB, 0.37099281E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099121E-03_JPRB, 0.37099089E-03_JPRB, 0.37099057E-03_JPRB, 0.37099034E-03_JPRB, 0.37099005E-03_JPRB, &
  & 0.37098984E-03_JPRB, 0.37098958E-03_JPRB, 0.37098932E-03_JPRB, 0.37098915E-03_JPRB, 0.37098894E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37098856E-03_JPRB, 0.37098830E-03_JPRB, 0.37098816E-03_JPRB, 0.37098810E-03_JPRB, 0.37098804E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098789E-03_JPRB, 0.37098775E-03_JPRB, 0.37098763E-03_JPRB, 0.37098743E-03_JPRB /)

RGHG1(:,61, 6) = (/ &
  & 0.37098135E-03_JPRB, 0.37098187E-03_JPRB, 0.37098216E-03_JPRB, 0.37098245E-03_JPRB, 0.37098280E-03_JPRB, 0.37098309E-03_JPRB, &
  & 0.37098335E-03_JPRB, 0.37098356E-03_JPRB, 0.37098373E-03_JPRB, 0.37098385E-03_JPRB, 0.37098397E-03_JPRB, 0.37098411E-03_JPRB, &
  & 0.37098429E-03_JPRB, 0.37098455E-03_JPRB, 0.37098487E-03_JPRB, 0.37098530E-03_JPRB, 0.37098568E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098641E-03_JPRB, 0.37098670E-03_JPRB, 0.37098708E-03_JPRB, 0.37098781E-03_JPRB, 0.37098877E-03_JPRB, 0.37099028E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099299E-03_JPRB, 0.37099398E-03_JPRB, 0.37099491E-03_JPRB, 0.37099575E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099715E-03_JPRB, 0.37099782E-03_JPRB, 0.37099785E-03_JPRB, 0.37099817E-03_JPRB, 0.37099796E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099619E-03_JPRB, 0.37099537E-03_JPRB, 0.37099436E-03_JPRB, 0.37099345E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099200E-03_JPRB, 0.37099165E-03_JPRB, 0.37099136E-03_JPRB, 0.37099115E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37099069E-03_JPRB, 0.37099048E-03_JPRB, 0.37099025E-03_JPRB, 0.37099005E-03_JPRB, 0.37098996E-03_JPRB, 0.37098961E-03_JPRB, &
  & 0.37098941E-03_JPRB, 0.37098918E-03_JPRB, 0.37098897E-03_JPRB, 0.37098880E-03_JPRB, 0.37098868E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37098836E-03_JPRB, 0.37098824E-03_JPRB, 0.37098798E-03_JPRB /)

RGHG1(:,62, 6) = (/ &
  & 0.37098289E-03_JPRB, 0.37098333E-03_JPRB, 0.37098356E-03_JPRB, 0.37098379E-03_JPRB, 0.37098405E-03_JPRB, 0.37098426E-03_JPRB, &
  & 0.37098443E-03_JPRB, 0.37098455E-03_JPRB, 0.37098466E-03_JPRB, 0.37098478E-03_JPRB, 0.37098490E-03_JPRB, 0.37098501E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098562E-03_JPRB, 0.37098612E-03_JPRB, 0.37098664E-03_JPRB, 0.37098696E-03_JPRB, 0.37098705E-03_JPRB, &
  & 0.37098740E-03_JPRB, 0.37098760E-03_JPRB, 0.37098801E-03_JPRB, 0.37098865E-03_JPRB, 0.37098955E-03_JPRB, 0.37099086E-03_JPRB, &
  & 0.37099217E-03_JPRB, 0.37099337E-03_JPRB, 0.37099433E-03_JPRB, 0.37099532E-03_JPRB, 0.37099619E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099814E-03_JPRB, 0.37099817E-03_JPRB, 0.37099852E-03_JPRB, 0.37099831E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099663E-03_JPRB, 0.37099575E-03_JPRB, 0.37099491E-03_JPRB, 0.37099404E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099302E-03_JPRB, 0.37099264E-03_JPRB, 0.37099243E-03_JPRB, 0.37099211E-03_JPRB, 0.37099194E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099118E-03_JPRB, 0.37099095E-03_JPRB, 0.37099092E-03_JPRB, 0.37099078E-03_JPRB, 0.37099037E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098996E-03_JPRB, 0.37098973E-03_JPRB, 0.37098955E-03_JPRB, 0.37098944E-03_JPRB, 0.37098932E-03_JPRB, &
  & 0.37098923E-03_JPRB, 0.37098903E-03_JPRB, 0.37098880E-03_JPRB, 0.37098839E-03_JPRB /)

RGHG1(:,63, 6) = (/ &
  & 0.37098417E-03_JPRB, 0.37098461E-03_JPRB, 0.37098481E-03_JPRB, 0.37098501E-03_JPRB, 0.37098522E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098545E-03_JPRB, 0.37098551E-03_JPRB, 0.37098560E-03_JPRB, 0.37098571E-03_JPRB, 0.37098580E-03_JPRB, 0.37098597E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098647E-03_JPRB, 0.37098679E-03_JPRB, 0.37098717E-03_JPRB, 0.37098749E-03_JPRB, 0.37098801E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098848E-03_JPRB, 0.37098891E-03_JPRB, 0.37098947E-03_JPRB, 0.37099034E-03_JPRB, 0.37099156E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099386E-03_JPRB, 0.37099485E-03_JPRB, 0.37099578E-03_JPRB, 0.37099665E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099858E-03_JPRB, 0.37099849E-03_JPRB, 0.37099881E-03_JPRB, 0.37099875E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099703E-03_JPRB, 0.37099631E-03_JPRB, 0.37099546E-03_JPRB, 0.37099468E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099342E-03_JPRB, 0.37099316E-03_JPRB, 0.37099290E-03_JPRB, 0.37099273E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099209E-03_JPRB, 0.37099177E-03_JPRB, 0.37099165E-03_JPRB, 0.37099153E-03_JPRB, 0.37099115E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099072E-03_JPRB, 0.37099046E-03_JPRB, 0.37099034E-03_JPRB, 0.37099014E-03_JPRB, 0.37099008E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37098967E-03_JPRB, 0.37098938E-03_JPRB, 0.37098886E-03_JPRB /)

RGHG1(:,64, 6) = (/ &
  & 0.37098519E-03_JPRB, 0.37098551E-03_JPRB, 0.37098571E-03_JPRB, 0.37098589E-03_JPRB, 0.37098606E-03_JPRB, 0.37098626E-03_JPRB, &
  & 0.37098638E-03_JPRB, 0.37098647E-03_JPRB, 0.37098661E-03_JPRB, 0.37098673E-03_JPRB, 0.37098688E-03_JPRB, 0.37098711E-03_JPRB, &
  & 0.37098749E-03_JPRB, 0.37098798E-03_JPRB, 0.37098868E-03_JPRB, 0.37098929E-03_JPRB, 0.37098947E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098938E-03_JPRB, 0.37098979E-03_JPRB, 0.37099022E-03_JPRB, 0.37099107E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099438E-03_JPRB, 0.37099543E-03_JPRB, 0.37099631E-03_JPRB, 0.37099712E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099890E-03_JPRB, 0.37099890E-03_JPRB, 0.37099910E-03_JPRB, 0.37099910E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099744E-03_JPRB, 0.37099668E-03_JPRB, 0.37099599E-03_JPRB, 0.37099520E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099404E-03_JPRB, 0.37099386E-03_JPRB, 0.37099366E-03_JPRB, 0.37099345E-03_JPRB, 0.37099319E-03_JPRB, &
  & 0.37099305E-03_JPRB, 0.37099281E-03_JPRB, 0.37099252E-03_JPRB, 0.37099249E-03_JPRB, 0.37099232E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099159E-03_JPRB, 0.37099130E-03_JPRB, 0.37099110E-03_JPRB, 0.37099089E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099051E-03_JPRB, 0.37099025E-03_JPRB, 0.37098993E-03_JPRB, 0.37098932E-03_JPRB /)

RGHG1(:,65, 6) = (/ &
  & 0.37098618E-03_JPRB, 0.37098650E-03_JPRB, 0.37098670E-03_JPRB, 0.37098688E-03_JPRB, 0.37098705E-03_JPRB, 0.37098717E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098743E-03_JPRB, 0.37098760E-03_JPRB, 0.37098781E-03_JPRB, 0.37098792E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098842E-03_JPRB, 0.37098862E-03_JPRB, 0.37098871E-03_JPRB, 0.37098877E-03_JPRB, 0.37098906E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37099037E-03_JPRB, 0.37099031E-03_JPRB, 0.37099060E-03_JPRB, 0.37099098E-03_JPRB, 0.37099185E-03_JPRB, 0.37099278E-03_JPRB, &
  & 0.37099383E-03_JPRB, 0.37099494E-03_JPRB, 0.37099599E-03_JPRB, 0.37099680E-03_JPRB, 0.37099756E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099919E-03_JPRB, 0.37099922E-03_JPRB, 0.37099933E-03_JPRB, 0.37099942E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099782E-03_JPRB, 0.37099712E-03_JPRB, 0.37099648E-03_JPRB, 0.37099572E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099473E-03_JPRB, 0.37099459E-03_JPRB, 0.37099430E-03_JPRB, 0.37099412E-03_JPRB, 0.37099395E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099354E-03_JPRB, 0.37099337E-03_JPRB, 0.37099322E-03_JPRB, 0.37099308E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099243E-03_JPRB, 0.37099209E-03_JPRB, 0.37099188E-03_JPRB, 0.37099159E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099089E-03_JPRB, 0.37099054E-03_JPRB, 0.37098979E-03_JPRB /)

RGHG1(:,66, 6) = (/ &
  & 0.37098699E-03_JPRB, 0.37098728E-03_JPRB, 0.37098752E-03_JPRB, 0.37098775E-03_JPRB, 0.37098792E-03_JPRB, 0.37098807E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098839E-03_JPRB, 0.37098856E-03_JPRB, 0.37098871E-03_JPRB, 0.37098891E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098964E-03_JPRB, 0.37099016E-03_JPRB, 0.37099069E-03_JPRB, 0.37099136E-03_JPRB, 0.37099153E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099121E-03_JPRB, 0.37099147E-03_JPRB, 0.37099179E-03_JPRB, 0.37099258E-03_JPRB, 0.37099340E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099543E-03_JPRB, 0.37099642E-03_JPRB, 0.37099727E-03_JPRB, 0.37099791E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099939E-03_JPRB, 0.37099945E-03_JPRB, 0.37099957E-03_JPRB, 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099823E-03_JPRB, 0.37099759E-03_JPRB, 0.37099698E-03_JPRB, 0.37099625E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099537E-03_JPRB, 0.37099523E-03_JPRB, 0.37099503E-03_JPRB, 0.37099482E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099430E-03_JPRB, 0.37099404E-03_JPRB, 0.37099389E-03_JPRB, 0.37099380E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099334E-03_JPRB, 0.37099299E-03_JPRB, 0.37099264E-03_JPRB, 0.37099235E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099162E-03_JPRB, 0.37099115E-03_JPRB, 0.37099037E-03_JPRB /)

RGHG1(:,67, 6) = (/ &
  & 0.37098787E-03_JPRB, 0.37098821E-03_JPRB, 0.37098845E-03_JPRB, 0.37098871E-03_JPRB, 0.37098891E-03_JPRB, 0.37098909E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098944E-03_JPRB, 0.37098961E-03_JPRB, 0.37098976E-03_JPRB, 0.37098990E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099081E-03_JPRB, 0.37099089E-03_JPRB, 0.37099124E-03_JPRB, 0.37099130E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099211E-03_JPRB, 0.37099229E-03_JPRB, 0.37099261E-03_JPRB, 0.37099337E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099511E-03_JPRB, 0.37099610E-03_JPRB, 0.37099695E-03_JPRB, 0.37099782E-03_JPRB, 0.37099837E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099962E-03_JPRB, 0.37099968E-03_JPRB, 0.37099980E-03_JPRB, 0.37099997E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099869E-03_JPRB, 0.37099796E-03_JPRB, 0.37099741E-03_JPRB, 0.37099677E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099601E-03_JPRB, 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, 0.37099549E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099497E-03_JPRB, 0.37099476E-03_JPRB, 0.37099468E-03_JPRB, 0.37099459E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099421E-03_JPRB, 0.37099380E-03_JPRB, 0.37099345E-03_JPRB, 0.37099316E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099264E-03_JPRB, 0.37099238E-03_JPRB, 0.37099185E-03_JPRB, 0.37099104E-03_JPRB /)

RGHG1(:,68, 6) = (/ &
  & 0.37098859E-03_JPRB, 0.37098903E-03_JPRB, 0.37098926E-03_JPRB, 0.37098950E-03_JPRB, 0.37098970E-03_JPRB, 0.37098993E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37099031E-03_JPRB, 0.37099054E-03_JPRB, 0.37099069E-03_JPRB, 0.37099086E-03_JPRB, 0.37099110E-03_JPRB, &
  & 0.37099171E-03_JPRB, 0.37099200E-03_JPRB, 0.37099229E-03_JPRB, 0.37099284E-03_JPRB, 0.37099293E-03_JPRB, 0.37099313E-03_JPRB, &
  & 0.37099308E-03_JPRB, 0.37099305E-03_JPRB, 0.37099319E-03_JPRB, 0.37099348E-03_JPRB, 0.37099409E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099665E-03_JPRB, 0.37099747E-03_JPRB, 0.37099817E-03_JPRB, 0.37099869E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099983E-03_JPRB, 0.37099994E-03_JPRB, 0.37100000E-03_JPRB, 0.37100023E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099895E-03_JPRB, 0.37099831E-03_JPRB, 0.37099776E-03_JPRB, 0.37099721E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099648E-03_JPRB, 0.37099648E-03_JPRB, 0.37099633E-03_JPRB, 0.37099610E-03_JPRB, 0.37099593E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099564E-03_JPRB, 0.37099546E-03_JPRB, 0.37099543E-03_JPRB, 0.37099535E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099500E-03_JPRB, 0.37099465E-03_JPRB, 0.37099424E-03_JPRB, 0.37099383E-03_JPRB, 0.37099351E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099310E-03_JPRB, 0.37099264E-03_JPRB, 0.37099165E-03_JPRB /)

RGHG1(:,69, 6) = (/ &
  & 0.37098929E-03_JPRB, 0.37098984E-03_JPRB, 0.37099014E-03_JPRB, 0.37099040E-03_JPRB, 0.37099063E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099118E-03_JPRB, 0.37099150E-03_JPRB, 0.37099162E-03_JPRB, 0.37099177E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099261E-03_JPRB, 0.37099270E-03_JPRB, 0.37099255E-03_JPRB, 0.37099310E-03_JPRB, 0.37099334E-03_JPRB, 0.37099395E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37099374E-03_JPRB, 0.37099404E-03_JPRB, 0.37099433E-03_JPRB, 0.37099485E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099721E-03_JPRB, 0.37099799E-03_JPRB, 0.37099860E-03_JPRB, 0.37099901E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100003E-03_JPRB, 0.37100009E-03_JPRB, 0.37100021E-03_JPRB, 0.37100038E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099930E-03_JPRB, 0.37099863E-03_JPRB, 0.37099820E-03_JPRB, 0.37099756E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099703E-03_JPRB, 0.37099703E-03_JPRB, 0.37099700E-03_JPRB, 0.37099677E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099622E-03_JPRB, 0.37099610E-03_JPRB, 0.37099610E-03_JPRB, 0.37099599E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, 0.37099543E-03_JPRB, 0.37099511E-03_JPRB, 0.37099462E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099406E-03_JPRB, 0.37099389E-03_JPRB, 0.37099334E-03_JPRB, 0.37099241E-03_JPRB /)

RGHG1(:,70, 6) = (/ &
  & 0.37098984E-03_JPRB, 0.37099060E-03_JPRB, 0.37099101E-03_JPRB, 0.37099136E-03_JPRB, 0.37099165E-03_JPRB, 0.37099191E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099217E-03_JPRB, 0.37099255E-03_JPRB, 0.37099258E-03_JPRB, 0.37099270E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099366E-03_JPRB, 0.37099383E-03_JPRB, 0.37099398E-03_JPRB, 0.37099436E-03_JPRB, 0.37099430E-03_JPRB, 0.37099482E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099482E-03_JPRB, 0.37099485E-03_JPRB, 0.37099526E-03_JPRB, 0.37099569E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099770E-03_JPRB, 0.37099837E-03_JPRB, 0.37099910E-03_JPRB, 0.37099939E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100018E-03_JPRB, 0.37100018E-03_JPRB, 0.37100026E-03_JPRB, 0.37100050E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37099959E-03_JPRB, 0.37099887E-03_JPRB, 0.37099855E-03_JPRB, 0.37099794E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099756E-03_JPRB, 0.37099759E-03_JPRB, 0.37099767E-03_JPRB, 0.37099750E-03_JPRB, 0.37099724E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099683E-03_JPRB, 0.37099674E-03_JPRB, 0.37099674E-03_JPRB, 0.37099665E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099660E-03_JPRB, 0.37099619E-03_JPRB, 0.37099590E-03_JPRB, 0.37099537E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099468E-03_JPRB, 0.37099421E-03_JPRB, 0.37099322E-03_JPRB /)

RGHG1(:,71, 6) = (/ &
  & 0.37099048E-03_JPRB, 0.37099145E-03_JPRB, 0.37099185E-03_JPRB, 0.37099235E-03_JPRB, 0.37099258E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099313E-03_JPRB, 0.37099357E-03_JPRB, 0.37099351E-03_JPRB, 0.37099357E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099459E-03_JPRB, 0.37099424E-03_JPRB, 0.37099409E-03_JPRB, 0.37099462E-03_JPRB, 0.37099497E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099552E-03_JPRB, 0.37099567E-03_JPRB, 0.37099622E-03_JPRB, 0.37099648E-03_JPRB, 0.37099665E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099826E-03_JPRB, 0.37099881E-03_JPRB, 0.37099945E-03_JPRB, 0.37099965E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100035E-03_JPRB, 0.37100023E-03_JPRB, 0.37100041E-03_JPRB, 0.37100055E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099983E-03_JPRB, 0.37099913E-03_JPRB, 0.37099884E-03_JPRB, 0.37099826E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099799E-03_JPRB, 0.37099811E-03_JPRB, 0.37099826E-03_JPRB, 0.37099805E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099738E-03_JPRB, 0.37099744E-03_JPRB, 0.37099744E-03_JPRB, 0.37099732E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099738E-03_JPRB, 0.37099698E-03_JPRB, 0.37099671E-03_JPRB, 0.37099616E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099546E-03_JPRB, 0.37099508E-03_JPRB, 0.37099424E-03_JPRB /)

RGHG1(:,72, 6) = (/ &
  & 0.37099127E-03_JPRB, 0.37099238E-03_JPRB, 0.37099284E-03_JPRB, 0.37099345E-03_JPRB, 0.37099357E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099398E-03_JPRB, 0.37099447E-03_JPRB, 0.37099433E-03_JPRB, 0.37099433E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099555E-03_JPRB, 0.37099564E-03_JPRB, 0.37099549E-03_JPRB, 0.37099564E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099625E-03_JPRB, 0.37099645E-03_JPRB, 0.37099654E-03_JPRB, 0.37099718E-03_JPRB, 0.37099732E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099878E-03_JPRB, 0.37099916E-03_JPRB, 0.37099983E-03_JPRB, 0.37099989E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100053E-03_JPRB, 0.37100032E-03_JPRB, 0.37100041E-03_JPRB, 0.37100055E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100009E-03_JPRB, 0.37099933E-03_JPRB, 0.37099910E-03_JPRB, 0.37099855E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099837E-03_JPRB, 0.37099858E-03_JPRB, 0.37099881E-03_JPRB, 0.37099852E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099796E-03_JPRB, 0.37099805E-03_JPRB, 0.37099808E-03_JPRB, 0.37099802E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099811E-03_JPRB, 0.37099764E-03_JPRB, 0.37099747E-03_JPRB, 0.37099695E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099645E-03_JPRB, 0.37099642E-03_JPRB, 0.37099604E-03_JPRB, 0.37099532E-03_JPRB /)

RGHG1(:,73, 6) = (/ &
  & 0.37099217E-03_JPRB, 0.37099354E-03_JPRB, 0.37099386E-03_JPRB, 0.37099462E-03_JPRB, 0.37099450E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099497E-03_JPRB, 0.37099543E-03_JPRB, 0.37099526E-03_JPRB, 0.37099508E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099561E-03_JPRB, 0.37099584E-03_JPRB, 0.37099593E-03_JPRB, 0.37099631E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099724E-03_JPRB, 0.37099730E-03_JPRB, 0.37099799E-03_JPRB, 0.37099823E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099922E-03_JPRB, 0.37099959E-03_JPRB, 0.37100018E-03_JPRB, 0.37100009E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100070E-03_JPRB, 0.37100038E-03_JPRB, 0.37100041E-03_JPRB, 0.37100058E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100021E-03_JPRB, 0.37099948E-03_JPRB, 0.37099927E-03_JPRB, 0.37099875E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099872E-03_JPRB, 0.37099898E-03_JPRB, 0.37099930E-03_JPRB, 0.37099898E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099849E-03_JPRB, 0.37099866E-03_JPRB, 0.37099875E-03_JPRB, 0.37099869E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099884E-03_JPRB, 0.37099826E-03_JPRB, 0.37099814E-03_JPRB, 0.37099759E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099715E-03_JPRB, 0.37099727E-03_JPRB, 0.37099689E-03_JPRB, 0.37099639E-03_JPRB /)

RGHG1(:,74, 6) = (/ &
  & 0.37099319E-03_JPRB, 0.37099468E-03_JPRB, 0.37099511E-03_JPRB, 0.37099593E-03_JPRB, 0.37099549E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099590E-03_JPRB, 0.37099636E-03_JPRB, 0.37099596E-03_JPRB, 0.37099578E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099695E-03_JPRB, 0.37099665E-03_JPRB, 0.37099657E-03_JPRB, 0.37099683E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099808E-03_JPRB, 0.37099802E-03_JPRB, 0.37099893E-03_JPRB, 0.37099910E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099968E-03_JPRB, 0.37100000E-03_JPRB, 0.37100055E-03_JPRB, 0.37100038E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100085E-03_JPRB, 0.37100038E-03_JPRB, 0.37100038E-03_JPRB, 0.37100064E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100032E-03_JPRB, 0.37099962E-03_JPRB, 0.37099948E-03_JPRB, 0.37099887E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099893E-03_JPRB, 0.37099933E-03_JPRB, 0.37099980E-03_JPRB, 0.37099939E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099878E-03_JPRB, 0.37099922E-03_JPRB, 0.37099936E-03_JPRB, 0.37099933E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099954E-03_JPRB, 0.37099887E-03_JPRB, 0.37099878E-03_JPRB, 0.37099817E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099811E-03_JPRB, 0.37099779E-03_JPRB, 0.37099750E-03_JPRB /)

RGHG1(:,75, 6) = (/ &
  & 0.37099424E-03_JPRB, 0.37099587E-03_JPRB, 0.37099622E-03_JPRB, 0.37099715E-03_JPRB, 0.37099636E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099671E-03_JPRB, 0.37099727E-03_JPRB, 0.37099677E-03_JPRB, 0.37099642E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099706E-03_JPRB, 0.37099657E-03_JPRB, 0.37099695E-03_JPRB, 0.37099738E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099791E-03_JPRB, 0.37099878E-03_JPRB, 0.37099869E-03_JPRB, 0.37099980E-03_JPRB, 0.37100003E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100023E-03_JPRB, 0.37100041E-03_JPRB, 0.37100102E-03_JPRB, 0.37100073E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100108E-03_JPRB, 0.37100032E-03_JPRB, 0.37100032E-03_JPRB, 0.37100058E-03_JPRB, 0.37100140E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100032E-03_JPRB, 0.37099971E-03_JPRB, 0.37099951E-03_JPRB, 0.37099895E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099916E-03_JPRB, 0.37099959E-03_JPRB, 0.37100021E-03_JPRB, 0.37099968E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099913E-03_JPRB, 0.37099986E-03_JPRB, 0.37100006E-03_JPRB, 0.37100015E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100026E-03_JPRB, 0.37099930E-03_JPRB, 0.37099930E-03_JPRB, 0.37099855E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099898E-03_JPRB, 0.37099866E-03_JPRB, 0.37099860E-03_JPRB /)

RGHG1(:,76, 6) = (/ &
  & 0.37099535E-03_JPRB, 0.37099703E-03_JPRB, 0.37099741E-03_JPRB, 0.37099849E-03_JPRB, 0.37099718E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099753E-03_JPRB, 0.37099817E-03_JPRB, 0.37099718E-03_JPRB, 0.37099680E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37099855E-03_JPRB, 0.37099692E-03_JPRB, 0.37099718E-03_JPRB, 0.37099776E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099951E-03_JPRB, 0.37099936E-03_JPRB, 0.37100067E-03_JPRB, 0.37100090E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100067E-03_JPRB, 0.37100082E-03_JPRB, 0.37100152E-03_JPRB, 0.37100105E-03_JPRB, 0.37100181E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100125E-03_JPRB, 0.37100029E-03_JPRB, 0.37100026E-03_JPRB, 0.37100050E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100021E-03_JPRB, 0.37099965E-03_JPRB, 0.37099951E-03_JPRB, 0.37099904E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099927E-03_JPRB, 0.37099986E-03_JPRB, 0.37100047E-03_JPRB, 0.37099986E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099942E-03_JPRB, 0.37100061E-03_JPRB, 0.37100079E-03_JPRB, 0.37100093E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100099E-03_JPRB, 0.37099968E-03_JPRB, 0.37099980E-03_JPRB, 0.37099881E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37099989E-03_JPRB, 0.37099962E-03_JPRB, 0.37099980E-03_JPRB /)

RGHG1(:,77, 6) = (/ &
  & 0.37099648E-03_JPRB, 0.37099814E-03_JPRB, 0.37099860E-03_JPRB, 0.37099986E-03_JPRB, 0.37099776E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099811E-03_JPRB, 0.37099910E-03_JPRB, 0.37099791E-03_JPRB, 0.37099712E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099954E-03_JPRB, 0.37099689E-03_JPRB, 0.37099730E-03_JPRB, 0.37099811E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37100021E-03_JPRB, 0.37099991E-03_JPRB, 0.37100143E-03_JPRB, 0.37100178E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100175E-03_JPRB, 0.37100114E-03_JPRB, 0.37100134E-03_JPRB, 0.37100207E-03_JPRB, 0.37100134E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100146E-03_JPRB, 0.37100026E-03_JPRB, 0.37100018E-03_JPRB, 0.37100047E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100009E-03_JPRB, 0.37099965E-03_JPRB, 0.37099954E-03_JPRB, 0.37099910E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37099933E-03_JPRB, 0.37099989E-03_JPRB, 0.37100076E-03_JPRB, 0.37100006E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099957E-03_JPRB, 0.37100131E-03_JPRB, 0.37100163E-03_JPRB, 0.37100189E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100169E-03_JPRB, 0.37099994E-03_JPRB, 0.37100041E-03_JPRB, 0.37099898E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100099E-03_JPRB, 0.37100061E-03_JPRB, 0.37100108E-03_JPRB /)

RGHG1(:,78, 6) = (/ &
  & 0.37099762E-03_JPRB, 0.37099922E-03_JPRB, 0.37099965E-03_JPRB, 0.37100125E-03_JPRB, 0.37099817E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099878E-03_JPRB, 0.37100023E-03_JPRB, 0.37099805E-03_JPRB, 0.37099712E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37100079E-03_JPRB, 0.37099700E-03_JPRB, 0.37099741E-03_JPRB, 0.37099828E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100085E-03_JPRB, 0.37100035E-03_JPRB, 0.37100221E-03_JPRB, 0.37100250E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100143E-03_JPRB, 0.37100181E-03_JPRB, 0.37100268E-03_JPRB, 0.37100166E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100166E-03_JPRB, 0.37100026E-03_JPRB, 0.37100000E-03_JPRB, 0.37100032E-03_JPRB, 0.37100186E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37099997E-03_JPRB, 0.37099965E-03_JPRB, 0.37099933E-03_JPRB, 0.37099913E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099927E-03_JPRB, 0.37099994E-03_JPRB, 0.37100096E-03_JPRB, 0.37100015E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099971E-03_JPRB, 0.37100207E-03_JPRB, 0.37100242E-03_JPRB, 0.37100282E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100227E-03_JPRB, 0.37100239E-03_JPRB, 0.37099994E-03_JPRB, 0.37100088E-03_JPRB, 0.37099884E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100204E-03_JPRB, 0.37100152E-03_JPRB, 0.37100233E-03_JPRB /)

RGHG1(:,79, 6) = (/ &
  & 0.37099834E-03_JPRB, 0.37099986E-03_JPRB, 0.37100035E-03_JPRB, 0.37100230E-03_JPRB, 0.37099823E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099898E-03_JPRB, 0.37100093E-03_JPRB, 0.37099808E-03_JPRB, 0.37099692E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37100169E-03_JPRB, 0.37099689E-03_JPRB, 0.37099727E-03_JPRB, 0.37099826E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100137E-03_JPRB, 0.37100067E-03_JPRB, 0.37100291E-03_JPRB, 0.37100326E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100178E-03_JPRB, 0.37100221E-03_JPRB, 0.37100329E-03_JPRB, 0.37100201E-03_JPRB, 0.37100291E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100195E-03_JPRB, 0.37100023E-03_JPRB, 0.37099991E-03_JPRB, 0.37100026E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37099986E-03_JPRB, 0.37099962E-03_JPRB, 0.37099927E-03_JPRB, 0.37099913E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099933E-03_JPRB, 0.37100003E-03_JPRB, 0.37100117E-03_JPRB, 0.37100012E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37099977E-03_JPRB, 0.37100277E-03_JPRB, 0.37100315E-03_JPRB, 0.37100370E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100303E-03_JPRB, 0.37099997E-03_JPRB, 0.37100131E-03_JPRB, 0.37099869E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100309E-03_JPRB, 0.37100242E-03_JPRB, 0.37100384E-03_JPRB /)

RGHG1(:,80, 6) = (/ &
  & 0.37099878E-03_JPRB, 0.37100023E-03_JPRB, 0.37100076E-03_JPRB, 0.37100294E-03_JPRB, 0.37099820E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099884E-03_JPRB, 0.37100131E-03_JPRB, 0.37099828E-03_JPRB, 0.37099671E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37100221E-03_JPRB, 0.37099671E-03_JPRB, 0.37099706E-03_JPRB, 0.37099823E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100172E-03_JPRB, 0.37100090E-03_JPRB, 0.37100347E-03_JPRB, 0.37100384E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100341E-03_JPRB, 0.37100201E-03_JPRB, 0.37100253E-03_JPRB, 0.37100370E-03_JPRB, 0.37100233E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100221E-03_JPRB, 0.37100023E-03_JPRB, 0.37099983E-03_JPRB, 0.37100026E-03_JPRB, 0.37100239E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099983E-03_JPRB, 0.37099962E-03_JPRB, 0.37099919E-03_JPRB, 0.37099910E-03_JPRB, 0.37100169E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099927E-03_JPRB, 0.37100003E-03_JPRB, 0.37100137E-03_JPRB, 0.37100021E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37099980E-03_JPRB, 0.37100329E-03_JPRB, 0.37100367E-03_JPRB, 0.37100428E-03_JPRB, 0.37100198E-03_JPRB, &
  & 0.37100341E-03_JPRB, 0.37100355E-03_JPRB, 0.37100003E-03_JPRB, 0.37100163E-03_JPRB, 0.37099855E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100370E-03_JPRB, 0.37100306E-03_JPRB, 0.37100562E-03_JPRB /)

RGHG1(:,81, 6) = (/ &
  & 0.37099910E-03_JPRB, 0.37100050E-03_JPRB, 0.37100102E-03_JPRB, 0.37100329E-03_JPRB, 0.37099817E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099942E-03_JPRB, 0.37100157E-03_JPRB, 0.37099753E-03_JPRB, 0.37099657E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37100256E-03_JPRB, 0.37099657E-03_JPRB, 0.37099692E-03_JPRB, 0.37099805E-03_JPRB, 0.37100140E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100201E-03_JPRB, 0.37100102E-03_JPRB, 0.37100379E-03_JPRB, 0.37100419E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100379E-03_JPRB, 0.37100227E-03_JPRB, 0.37100280E-03_JPRB, 0.37100405E-03_JPRB, 0.37100256E-03_JPRB, 0.37100349E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100236E-03_JPRB, 0.37100026E-03_JPRB, 0.37099983E-03_JPRB, 0.37100026E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099977E-03_JPRB, 0.37099954E-03_JPRB, 0.37099913E-03_JPRB, 0.37099913E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099922E-03_JPRB, 0.37100003E-03_JPRB, 0.37100140E-03_JPRB, 0.37100015E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099977E-03_JPRB, 0.37100361E-03_JPRB, 0.37100405E-03_JPRB, 0.37100469E-03_JPRB, 0.37100216E-03_JPRB, &
  & 0.37100376E-03_JPRB, 0.37100387E-03_JPRB, 0.37100015E-03_JPRB, 0.37100184E-03_JPRB, 0.37099843E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37100408E-03_JPRB, 0.37100349E-03_JPRB, 0.37100777E-03_JPRB /)

RGHG1(:,82, 6) = (/ &
  & 0.37099910E-03_JPRB, 0.37100055E-03_JPRB, 0.37100120E-03_JPRB, 0.37100355E-03_JPRB, 0.37099820E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099863E-03_JPRB, 0.37100108E-03_JPRB, 0.37099860E-03_JPRB, 0.37099689E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37100262E-03_JPRB, 0.37099648E-03_JPRB, 0.37099680E-03_JPRB, 0.37099791E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100224E-03_JPRB, 0.37100096E-03_JPRB, 0.37100405E-03_JPRB, 0.37100454E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100399E-03_JPRB, 0.37100236E-03_JPRB, 0.37100294E-03_JPRB, 0.37100434E-03_JPRB, 0.37100265E-03_JPRB, 0.37100364E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100248E-03_JPRB, 0.37100023E-03_JPRB, 0.37099980E-03_JPRB, 0.37100026E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099974E-03_JPRB, 0.37099951E-03_JPRB, 0.37099910E-03_JPRB, 0.37099913E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37099925E-03_JPRB, 0.37099997E-03_JPRB, 0.37100137E-03_JPRB, 0.37100015E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099974E-03_JPRB, 0.37100384E-03_JPRB, 0.37100428E-03_JPRB, 0.37100492E-03_JPRB, 0.37100224E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100413E-03_JPRB, 0.37100018E-03_JPRB, 0.37100195E-03_JPRB, 0.37099834E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100428E-03_JPRB, 0.37100373E-03_JPRB, 0.37100798E-03_JPRB /)

RGHG1(:,83, 6) = (/ &
  & 0.37099916E-03_JPRB, 0.37100064E-03_JPRB, 0.37100131E-03_JPRB, 0.37100379E-03_JPRB, 0.37099823E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099968E-03_JPRB, 0.37100128E-03_JPRB, 0.37099741E-03_JPRB, 0.37099665E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37100253E-03_JPRB, 0.37099636E-03_JPRB, 0.37099668E-03_JPRB, 0.37099782E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100239E-03_JPRB, 0.37100096E-03_JPRB, 0.37100434E-03_JPRB, 0.37100475E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100425E-03_JPRB, 0.37100250E-03_JPRB, 0.37100309E-03_JPRB, 0.37100457E-03_JPRB, 0.37100280E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100253E-03_JPRB, 0.37100029E-03_JPRB, 0.37099980E-03_JPRB, 0.37100021E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099965E-03_JPRB, 0.37099945E-03_JPRB, 0.37099904E-03_JPRB, 0.37099910E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099916E-03_JPRB, 0.37099994E-03_JPRB, 0.37100143E-03_JPRB, 0.37100018E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37099980E-03_JPRB, 0.37100411E-03_JPRB, 0.37100445E-03_JPRB, 0.37100515E-03_JPRB, 0.37100239E-03_JPRB, &
  & 0.37100411E-03_JPRB, 0.37100431E-03_JPRB, 0.37100018E-03_JPRB, 0.37100195E-03_JPRB, 0.37099831E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100454E-03_JPRB, 0.37100390E-03_JPRB, 0.37100824E-03_JPRB /)

RGHG1(:,84, 6) = (/ &
  & 0.37099910E-03_JPRB, 0.37100061E-03_JPRB, 0.37100134E-03_JPRB, 0.37100387E-03_JPRB, 0.37099823E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099855E-03_JPRB, 0.37100061E-03_JPRB, 0.37099878E-03_JPRB, 0.37099724E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37100192E-03_JPRB, 0.37099668E-03_JPRB, 0.37099665E-03_JPRB, 0.37099770E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100248E-03_JPRB, 0.37100099E-03_JPRB, 0.37100460E-03_JPRB, 0.37100504E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100445E-03_JPRB, 0.37100253E-03_JPRB, 0.37100317E-03_JPRB, 0.37100469E-03_JPRB, 0.37100285E-03_JPRB, 0.37100381E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100259E-03_JPRB, 0.37100026E-03_JPRB, 0.37099968E-03_JPRB, 0.37100018E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099957E-03_JPRB, 0.37099942E-03_JPRB, 0.37099904E-03_JPRB, 0.37099916E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37099925E-03_JPRB, 0.37099997E-03_JPRB, 0.37100140E-03_JPRB, 0.37100018E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37099974E-03_JPRB, 0.37100425E-03_JPRB, 0.37100469E-03_JPRB, 0.37100536E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100437E-03_JPRB, 0.37100009E-03_JPRB, 0.37100195E-03_JPRB, 0.37099823E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100463E-03_JPRB, 0.37100399E-03_JPRB, 0.37100844E-03_JPRB /)

RGHG1(:,85, 6) = (/ &
  & 0.37099910E-03_JPRB, 0.37100058E-03_JPRB, 0.37100140E-03_JPRB, 0.37100393E-03_JPRB, 0.37099811E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099962E-03_JPRB, 0.37100055E-03_JPRB, 0.37099770E-03_JPRB, 0.37099721E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37100111E-03_JPRB, 0.37099700E-03_JPRB, 0.37099686E-03_JPRB, 0.37099782E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100253E-03_JPRB, 0.37100099E-03_JPRB, 0.37100477E-03_JPRB, 0.37100518E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37100469E-03_JPRB, 0.37100259E-03_JPRB, 0.37100341E-03_JPRB, 0.37100492E-03_JPRB, 0.37100285E-03_JPRB, 0.37100387E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37100262E-03_JPRB, 0.37100026E-03_JPRB, 0.37099968E-03_JPRB, 0.37100015E-03_JPRB, 0.37100262E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37099959E-03_JPRB, 0.37099942E-03_JPRB, 0.37099904E-03_JPRB, 0.37099919E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37099922E-03_JPRB, 0.37100003E-03_JPRB, 0.37100137E-03_JPRB, 0.37100023E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37099974E-03_JPRB, 0.37100434E-03_JPRB, 0.37100480E-03_JPRB, 0.37100550E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37100443E-03_JPRB, 0.37100451E-03_JPRB, 0.37100003E-03_JPRB, 0.37100201E-03_JPRB, 0.37099817E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100480E-03_JPRB, 0.37100413E-03_JPRB, 0.37100865E-03_JPRB /)

RGHG1(:,86, 6) = (/ &
  & 0.37099904E-03_JPRB, 0.37100055E-03_JPRB, 0.37100140E-03_JPRB, 0.37100411E-03_JPRB, 0.37099823E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099863E-03_JPRB, 0.37099991E-03_JPRB, 0.37099887E-03_JPRB, 0.37099794E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100003E-03_JPRB, 0.37099747E-03_JPRB, 0.37099721E-03_JPRB, 0.37099802E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100250E-03_JPRB, 0.37100108E-03_JPRB, 0.37100486E-03_JPRB, 0.37100539E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100475E-03_JPRB, 0.37100265E-03_JPRB, 0.37100344E-03_JPRB, 0.37100510E-03_JPRB, 0.37100288E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100271E-03_JPRB, 0.37100021E-03_JPRB, 0.37099957E-03_JPRB, 0.37100015E-03_JPRB, 0.37100277E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099954E-03_JPRB, 0.37099939E-03_JPRB, 0.37099904E-03_JPRB, 0.37099925E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099927E-03_JPRB, 0.37100003E-03_JPRB, 0.37100131E-03_JPRB, 0.37100029E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37099994E-03_JPRB, 0.37100431E-03_JPRB, 0.37100483E-03_JPRB, 0.37100556E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37100445E-03_JPRB, 0.37100457E-03_JPRB, 0.37100003E-03_JPRB, 0.37100207E-03_JPRB, 0.37099805E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100480E-03_JPRB, 0.37100422E-03_JPRB, 0.37100876E-03_JPRB /)

RGHG1(:,87, 6) = (/ &
  & 0.37099904E-03_JPRB, 0.37100053E-03_JPRB, 0.37100128E-03_JPRB, 0.37100381E-03_JPRB, 0.37099826E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099930E-03_JPRB, 0.37099983E-03_JPRB, 0.37099799E-03_JPRB, 0.37099770E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099957E-03_JPRB, 0.37099764E-03_JPRB, 0.37099744E-03_JPRB, 0.37099808E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37100245E-03_JPRB, 0.37100108E-03_JPRB, 0.37100489E-03_JPRB, 0.37100550E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100268E-03_JPRB, 0.37100361E-03_JPRB, 0.37100524E-03_JPRB, 0.37100291E-03_JPRB, 0.37100413E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100271E-03_JPRB, 0.37100018E-03_JPRB, 0.37099951E-03_JPRB, 0.37100009E-03_JPRB, 0.37100288E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099948E-03_JPRB, 0.37099939E-03_JPRB, 0.37099895E-03_JPRB, 0.37099919E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099919E-03_JPRB, 0.37100009E-03_JPRB, 0.37100125E-03_JPRB, 0.37100038E-03_JPRB, 0.37100163E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100009E-03_JPRB, 0.37100434E-03_JPRB, 0.37100486E-03_JPRB, 0.37100553E-03_JPRB, 0.37100277E-03_JPRB, &
  & 0.37100454E-03_JPRB, 0.37100460E-03_JPRB, 0.37100000E-03_JPRB, 0.37100210E-03_JPRB, 0.37099802E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100489E-03_JPRB, 0.37100422E-03_JPRB, 0.37100882E-03_JPRB /)

RGHG1(:,88, 6) = (/ &
  & 0.37099910E-03_JPRB, 0.37100055E-03_JPRB, 0.37100128E-03_JPRB, 0.37100402E-03_JPRB, 0.37099837E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099852E-03_JPRB, 0.37099939E-03_JPRB, 0.37099863E-03_JPRB, 0.37099808E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099942E-03_JPRB, 0.37099776E-03_JPRB, 0.37099756E-03_JPRB, 0.37099823E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100230E-03_JPRB, 0.37100105E-03_JPRB, 0.37100486E-03_JPRB, 0.37100556E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100495E-03_JPRB, 0.37100271E-03_JPRB, 0.37100364E-03_JPRB, 0.37100539E-03_JPRB, 0.37100291E-03_JPRB, 0.37100428E-03_JPRB, &
  & 0.37100146E-03_JPRB, 0.37100274E-03_JPRB, 0.37100012E-03_JPRB, 0.37099948E-03_JPRB, 0.37100006E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099945E-03_JPRB, 0.37099933E-03_JPRB, 0.37099872E-03_JPRB, 0.37099890E-03_JPRB, 0.37100186E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099898E-03_JPRB, 0.37100006E-03_JPRB, 0.37100125E-03_JPRB, 0.37100038E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37100038E-03_JPRB, 0.37100422E-03_JPRB, 0.37100492E-03_JPRB, 0.37100556E-03_JPRB, 0.37100288E-03_JPRB, &
  & 0.37100460E-03_JPRB, 0.37100460E-03_JPRB, 0.37100000E-03_JPRB, 0.37100218E-03_JPRB, 0.37099796E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100501E-03_JPRB, 0.37100425E-03_JPRB, 0.37100894E-03_JPRB /)

RGHG1(:,89, 6) = (/ &
  & 0.37099922E-03_JPRB, 0.37100058E-03_JPRB, 0.37100131E-03_JPRB, 0.37100364E-03_JPRB, 0.37099831E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099831E-03_JPRB, 0.37099907E-03_JPRB, 0.37099957E-03_JPRB, 0.37099817E-03_JPRB, 0.37099788E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099962E-03_JPRB, 0.37099770E-03_JPRB, 0.37099747E-03_JPRB, 0.37099814E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100250E-03_JPRB, 0.37100105E-03_JPRB, 0.37100492E-03_JPRB, 0.37100571E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37100510E-03_JPRB, 0.37100277E-03_JPRB, 0.37100373E-03_JPRB, 0.37100553E-03_JPRB, 0.37100291E-03_JPRB, 0.37100443E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100282E-03_JPRB, 0.37100009E-03_JPRB, 0.37099942E-03_JPRB, 0.37100003E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099945E-03_JPRB, 0.37099933E-03_JPRB, 0.37099858E-03_JPRB, 0.37099863E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099887E-03_JPRB, 0.37100009E-03_JPRB, 0.37100128E-03_JPRB, 0.37100044E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100047E-03_JPRB, 0.37100416E-03_JPRB, 0.37100486E-03_JPRB, 0.37100553E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100469E-03_JPRB, 0.37100460E-03_JPRB, 0.37099991E-03_JPRB, 0.37100230E-03_JPRB, 0.37099794E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100510E-03_JPRB, 0.37100422E-03_JPRB, 0.37100897E-03_JPRB /)

RGHG1(:,90, 6) = (/ &
  & 0.37099933E-03_JPRB, 0.37100064E-03_JPRB, 0.37100128E-03_JPRB, 0.37100402E-03_JPRB, 0.37099817E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099863E-03_JPRB, 0.37099974E-03_JPRB, 0.37099863E-03_JPRB, 0.37099799E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37100015E-03_JPRB, 0.37099724E-03_JPRB, 0.37099700E-03_JPRB, 0.37099782E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100271E-03_JPRB, 0.37100090E-03_JPRB, 0.37100504E-03_JPRB, 0.37100585E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100527E-03_JPRB, 0.37100265E-03_JPRB, 0.37100379E-03_JPRB, 0.37100571E-03_JPRB, 0.37100280E-03_JPRB, 0.37100466E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100300E-03_JPRB, 0.37100003E-03_JPRB, 0.37099936E-03_JPRB, 0.37099997E-03_JPRB, 0.37100352E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099942E-03_JPRB, 0.37099939E-03_JPRB, 0.37099846E-03_JPRB, 0.37099828E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099866E-03_JPRB, 0.37100012E-03_JPRB, 0.37100143E-03_JPRB, 0.37100038E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100044E-03_JPRB, 0.37100422E-03_JPRB, 0.37100504E-03_JPRB, 0.37100568E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100475E-03_JPRB, 0.37100477E-03_JPRB, 0.37099980E-03_JPRB, 0.37100242E-03_JPRB, 0.37099782E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37100530E-03_JPRB, 0.37100419E-03_JPRB, 0.37100902E-03_JPRB /)

RGHG1(:,91, 6) = (/ &
  & 0.37099925E-03_JPRB, 0.37100044E-03_JPRB, 0.37100070E-03_JPRB, 0.37100530E-03_JPRB, 0.37099718E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099808E-03_JPRB, 0.37100137E-03_JPRB, 0.37099942E-03_JPRB, 0.37099677E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37100530E-03_JPRB, 0.37099450E-03_JPRB, 0.37099625E-03_JPRB, 0.37099706E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37100332E-03_JPRB, 0.37100044E-03_JPRB, 0.37100533E-03_JPRB, 0.37100629E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100579E-03_JPRB, 0.37100242E-03_JPRB, 0.37100373E-03_JPRB, 0.37100608E-03_JPRB, 0.37100248E-03_JPRB, 0.37100515E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100341E-03_JPRB, 0.37099977E-03_JPRB, 0.37099925E-03_JPRB, 0.37099974E-03_JPRB, 0.37100416E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099951E-03_JPRB, 0.37099951E-03_JPRB, 0.37099837E-03_JPRB, 0.37099788E-03_JPRB, 0.37100355E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099820E-03_JPRB, 0.37100018E-03_JPRB, 0.37100184E-03_JPRB, 0.37099991E-03_JPRB, 0.37100195E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37099991E-03_JPRB, 0.37100457E-03_JPRB, 0.37100507E-03_JPRB, 0.37100603E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100495E-03_JPRB, 0.37100512E-03_JPRB, 0.37099925E-03_JPRB, 0.37100294E-03_JPRB, 0.37099747E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37100579E-03_JPRB, 0.37100411E-03_JPRB, 0.37100914E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG1(:, 1, 7) = (/ &
  & 0.35946170E-03_JPRB, 0.35944977E-03_JPRB, 0.35944246E-03_JPRB, 0.35943562E-03_JPRB, 0.35943245E-03_JPRB, 0.35944182E-03_JPRB, &
  & 0.35947224E-03_JPRB, 0.35952637E-03_JPRB, 0.35960230E-03_JPRB, 0.35969663E-03_JPRB, 0.35980568E-03_JPRB, 0.35992544E-03_JPRB, &
  & 0.36004992E-03_JPRB, 0.36017163E-03_JPRB, 0.36028237E-03_JPRB, 0.36037428E-03_JPRB, 0.36044233E-03_JPRB, 0.36048342E-03_JPRB, &
  & 0.36049736E-03_JPRB, 0.36048575E-03_JPRB, 0.36045481E-03_JPRB, 0.36041555E-03_JPRB, 0.36038287E-03_JPRB, 0.36037515E-03_JPRB, &
  & 0.36040659E-03_JPRB, 0.36048106E-03_JPRB, 0.36058779E-03_JPRB, 0.36070152E-03_JPRB, 0.36080027E-03_JPRB, 0.36087193E-03_JPRB, &
  & 0.36090909E-03_JPRB, 0.36090679E-03_JPRB, 0.36085420E-03_JPRB, 0.36074218E-03_JPRB, 0.36056660E-03_JPRB, 0.36032783E-03_JPRB, &
  & 0.36003298E-03_JPRB, 0.35969567E-03_JPRB, 0.35934820E-03_JPRB, 0.35905425E-03_JPRB, 0.35881455E-03_JPRB, 0.35858515E-03_JPRB, &
  & 0.35835156E-03_JPRB, 0.35809784E-03_JPRB, 0.35781204E-03_JPRB, 0.35746777E-03_JPRB, 0.35708153E-03_JPRB, 0.35680272E-03_JPRB, &
  & 0.35669451E-03_JPRB, 0.35665149E-03_JPRB, 0.35664072E-03_JPRB, 0.35663936E-03_JPRB, 0.35662638E-03_JPRB, 0.35658147E-03_JPRB, &
  & 0.35648339E-03_JPRB, 0.35633141E-03_JPRB, 0.35617177E-03_JPRB, 0.35601188E-03_JPRB, 0.35588793E-03_JPRB, 0.35579450E-03_JPRB, &
  & 0.35569401E-03_JPRB, 0.35557468E-03_JPRB, 0.35542221E-03_JPRB, 0.35523501E-03_JPRB /)

RGHG1(:, 2, 7) = (/ &
  & 0.35982148E-03_JPRB, 0.35998307E-03_JPRB, 0.36009643E-03_JPRB, 0.36021677E-03_JPRB, 0.36036543E-03_JPRB, 0.36055964E-03_JPRB, &
  & 0.36079570E-03_JPRB, 0.36105761E-03_JPRB, 0.36132519E-03_JPRB, 0.36157839E-03_JPRB, 0.36179787E-03_JPRB, 0.36196876E-03_JPRB, &
  & 0.36208890E-03_JPRB, 0.36217071E-03_JPRB, 0.36223308E-03_JPRB, 0.36229048E-03_JPRB, 0.36234799E-03_JPRB, 0.36240404E-03_JPRB, &
  & 0.36245561E-03_JPRB, 0.36250101E-03_JPRB, 0.36254089E-03_JPRB, 0.36257910E-03_JPRB, 0.36262357E-03_JPRB, 0.36268338E-03_JPRB, &
  & 0.36276787E-03_JPRB, 0.36288332E-03_JPRB, 0.36302913E-03_JPRB, 0.36319639E-03_JPRB, 0.36337110E-03_JPRB, 0.36353825E-03_JPRB, &
  & 0.36368123E-03_JPRB, 0.36378240E-03_JPRB, 0.36383051E-03_JPRB, 0.36382207E-03_JPRB, 0.36375588E-03_JPRB, 0.36363021E-03_JPRB, &
  & 0.36344447E-03_JPRB, 0.36320326E-03_JPRB, 0.36292715E-03_JPRB, 0.36265084E-03_JPRB, 0.36239505E-03_JPRB, 0.36215116E-03_JPRB, &
  & 0.36190980E-03_JPRB, 0.36166012E-03_JPRB, 0.36139155E-03_JPRB, 0.36109640E-03_JPRB, 0.36079000E-03_JPRB, 0.36052990E-03_JPRB, &
  & 0.36035522E-03_JPRB, 0.36024445E-03_JPRB, 0.36017451E-03_JPRB, 0.36012183E-03_JPRB, 0.36006543E-03_JPRB, 0.35998321E-03_JPRB, &
  & 0.35985478E-03_JPRB, 0.35966682E-03_JPRB, 0.35942864E-03_JPRB, 0.35915460E-03_JPRB, 0.35884944E-03_JPRB, 0.35851379E-03_JPRB, &
  & 0.35814560E-03_JPRB, 0.35773512E-03_JPRB, 0.35723037E-03_JPRB, 0.35635030E-03_JPRB /)

RGHG1(:, 3, 7) = (/ &
  & 0.36025504E-03_JPRB, 0.36050065E-03_JPRB, 0.36065190E-03_JPRB, 0.36080152E-03_JPRB, 0.36098002E-03_JPRB, 0.36119751E-03_JPRB, &
  & 0.36144105E-03_JPRB, 0.36168101E-03_JPRB, 0.36189155E-03_JPRB, 0.36206908E-03_JPRB, 0.36223268E-03_JPRB, 0.36241367E-03_JPRB, &
  & 0.36263160E-03_JPRB, 0.36288160E-03_JPRB, 0.36314226E-03_JPRB, 0.36338923E-03_JPRB, 0.36360548E-03_JPRB, 0.36378278E-03_JPRB, &
  & 0.36392076E-03_JPRB, 0.36402329E-03_JPRB, 0.36409736E-03_JPRB, 0.36415196E-03_JPRB, 0.36419855E-03_JPRB, 0.36425010E-03_JPRB, &
  & 0.36431756E-03_JPRB, 0.36440502E-03_JPRB, 0.36450708E-03_JPRB, 0.36461221E-03_JPRB, 0.36471084E-03_JPRB, 0.36479512E-03_JPRB, &
  & 0.36485848E-03_JPRB, 0.36489617E-03_JPRB, 0.36490886E-03_JPRB, 0.36489757E-03_JPRB, 0.36486343E-03_JPRB, 0.36480726E-03_JPRB, &
  & 0.36472824E-03_JPRB, 0.36462647E-03_JPRB, 0.36450487E-03_JPRB, 0.36437289E-03_JPRB, 0.36423720E-03_JPRB, 0.36410143E-03_JPRB, &
  & 0.36396389E-03_JPRB, 0.36382175E-03_JPRB, 0.36367273E-03_JPRB, 0.36351534E-03_JPRB, 0.36335763E-03_JPRB, 0.36321426E-03_JPRB, &
  & 0.36309430E-03_JPRB, 0.36299485E-03_JPRB, 0.36290259E-03_JPRB, 0.36280986E-03_JPRB, 0.36270090E-03_JPRB, 0.36256624E-03_JPRB, &
  & 0.36239234E-03_JPRB, 0.36217278E-03_JPRB, 0.36190805E-03_JPRB, 0.36159938E-03_JPRB, 0.36125869E-03_JPRB, 0.36089061E-03_JPRB, &
  & 0.36049396E-03_JPRB, 0.36006013E-03_JPRB, 0.35950821E-03_JPRB, 0.35845826E-03_JPRB /)

RGHG1(:, 4, 7) = (/ &
  & 0.36058945E-03_JPRB, 0.36089012E-03_JPRB, 0.36106963E-03_JPRB, 0.36124128E-03_JPRB, 0.36143215E-03_JPRB, 0.36165290E-03_JPRB, &
  & 0.36189318E-03_JPRB, 0.36213829E-03_JPRB, 0.36239350E-03_JPRB, 0.36267022E-03_JPRB, 0.36297552E-03_JPRB, 0.36329753E-03_JPRB, &
  & 0.36361735E-03_JPRB, 0.36391499E-03_JPRB, 0.36417533E-03_JPRB, 0.36439209E-03_JPRB, 0.36456849E-03_JPRB, 0.36471011E-03_JPRB, &
  & 0.36482161E-03_JPRB, 0.36490711E-03_JPRB, 0.36497109E-03_JPRB, 0.36501847E-03_JPRB, 0.36505423E-03_JPRB, 0.36508351E-03_JPRB, &
  & 0.36511067E-03_JPRB, 0.36513913E-03_JPRB, 0.36516989E-03_JPRB, 0.36520153E-03_JPRB, 0.36523095E-03_JPRB, 0.36525400E-03_JPRB, &
  & 0.36526701E-03_JPRB, 0.36526966E-03_JPRB, 0.36526262E-03_JPRB, 0.36524641E-03_JPRB, 0.36522202E-03_JPRB, 0.36519018E-03_JPRB, &
  & 0.36515133E-03_JPRB, 0.36510514E-03_JPRB, 0.36505150E-03_JPRB, 0.36499085E-03_JPRB, 0.36492507E-03_JPRB, 0.36485496E-03_JPRB, &
  & 0.36478191E-03_JPRB, 0.36470650E-03_JPRB, 0.36462824E-03_JPRB, 0.36454733E-03_JPRB, 0.36446453E-03_JPRB, 0.36438173E-03_JPRB, &
  & 0.36429937E-03_JPRB, 0.36421538E-03_JPRB, 0.36412413E-03_JPRB, 0.36402332E-03_JPRB, 0.36390219E-03_JPRB, 0.36375687E-03_JPRB, &
  & 0.36358021E-03_JPRB, 0.36336790E-03_JPRB, 0.36311633E-03_JPRB, 0.36283667E-03_JPRB, 0.36252869E-03_JPRB, 0.36220046E-03_JPRB, &
  & 0.36185369E-03_JPRB, 0.36146792E-03_JPRB, 0.36100222E-03_JPRB, 0.36022972E-03_JPRB /)

RGHG1(:, 5, 7) = (/ &
  & 0.36085543E-03_JPRB, 0.36120997E-03_JPRB, 0.36142248E-03_JPRB, 0.36162173E-03_JPRB, 0.36183948E-03_JPRB, 0.36208978E-03_JPRB, &
  & 0.36236609E-03_JPRB, 0.36266964E-03_JPRB, 0.36298938E-03_JPRB, 0.36332238E-03_JPRB, 0.36365440E-03_JPRB, 0.36397492E-03_JPRB, &
  & 0.36427152E-03_JPRB, 0.36453613E-03_JPRB, 0.36476550E-03_JPRB, 0.36495787E-03_JPRB, 0.36511247E-03_JPRB, 0.36523206E-03_JPRB, &
  & 0.36532281E-03_JPRB, 0.36539091E-03_JPRB, 0.36544161E-03_JPRB, 0.36547869E-03_JPRB, 0.36550473E-03_JPRB, 0.36552153E-03_JPRB, &
  & 0.36553040E-03_JPRB, 0.36553250E-03_JPRB, 0.36552933E-03_JPRB, 0.36552231E-03_JPRB, 0.36551210E-03_JPRB, 0.36549906E-03_JPRB, &
  & 0.36548357E-03_JPRB, 0.36546658E-03_JPRB, 0.36544824E-03_JPRB, 0.36542903E-03_JPRB, 0.36540907E-03_JPRB, 0.36538835E-03_JPRB, &
  & 0.36536579E-03_JPRB, 0.36534099E-03_JPRB, 0.36531300E-03_JPRB, 0.36528113E-03_JPRB, 0.36524437E-03_JPRB, 0.36520307E-03_JPRB, &
  & 0.36515802E-03_JPRB, 0.36510991E-03_JPRB, 0.36505895E-03_JPRB, 0.36500418E-03_JPRB, 0.36494495E-03_JPRB, 0.36487999E-03_JPRB, &
  & 0.36480787E-03_JPRB, 0.36472775E-03_JPRB, 0.36463633E-03_JPRB, 0.36453095E-03_JPRB, 0.36440793E-03_JPRB, 0.36426322E-03_JPRB, &
  & 0.36409413E-03_JPRB, 0.36390041E-03_JPRB, 0.36368240E-03_JPRB, 0.36343903E-03_JPRB, 0.36318079E-03_JPRB, 0.36291091E-03_JPRB, &
  & 0.36263707E-03_JPRB, 0.36236350E-03_JPRB, 0.36205878E-03_JPRB, 0.36145910E-03_JPRB /)

RGHG1(:, 6, 7) = (/ &
  & 0.36112347E-03_JPRB, 0.36154740E-03_JPRB, 0.36180543E-03_JPRB, 0.36204324E-03_JPRB, 0.36230049E-03_JPRB, 0.36258117E-03_JPRB, &
  & 0.36289354E-03_JPRB, 0.36321863E-03_JPRB, 0.36355352E-03_JPRB, 0.36388193E-03_JPRB, 0.36419803E-03_JPRB, 0.36449239E-03_JPRB, &
  & 0.36475935E-03_JPRB, 0.36499288E-03_JPRB, 0.36518913E-03_JPRB, 0.36534935E-03_JPRB, 0.36547845E-03_JPRB, 0.36558113E-03_JPRB, &
  & 0.36566160E-03_JPRB, 0.36572324E-03_JPRB, 0.36576961E-03_JPRB, 0.36580348E-03_JPRB, 0.36582694E-03_JPRB, 0.36584042E-03_JPRB, &
  & 0.36584336E-03_JPRB, 0.36583492E-03_JPRB, 0.36581536E-03_JPRB, 0.36578646E-03_JPRB, 0.36575113E-03_JPRB, 0.36571283E-03_JPRB, &
  & 0.36567467E-03_JPRB, 0.36563966E-03_JPRB, 0.36561029E-03_JPRB, 0.36558803E-03_JPRB, 0.36557193E-03_JPRB, 0.36555994E-03_JPRB, &
  & 0.36554993E-03_JPRB, 0.36554001E-03_JPRB, 0.36552857E-03_JPRB, 0.36551396E-03_JPRB, 0.36549455E-03_JPRB, 0.36546911E-03_JPRB, &
  & 0.36543747E-03_JPRB, 0.36540022E-03_JPRB, 0.36535758E-03_JPRB, 0.36530950E-03_JPRB, 0.36525511E-03_JPRB, 0.36519300E-03_JPRB, &
  & 0.36512176E-03_JPRB, 0.36504003E-03_JPRB, 0.36494591E-03_JPRB, 0.36483744E-03_JPRB, 0.36471264E-03_JPRB, 0.36456937E-03_JPRB, &
  & 0.36440647E-03_JPRB, 0.36422414E-03_JPRB, 0.36402413E-03_JPRB, 0.36381267E-03_JPRB, 0.36359584E-03_JPRB, 0.36338528E-03_JPRB, &
  & 0.36318437E-03_JPRB, 0.36298097E-03_JPRB, 0.36274898E-03_JPRB, 0.36234796E-03_JPRB /)

RGHG1(:, 7, 7) = (/ &
  & 0.36145948E-03_JPRB, 0.36196678E-03_JPRB, 0.36226964E-03_JPRB, 0.36254409E-03_JPRB, 0.36282322E-03_JPRB, 0.36312136E-03_JPRB, &
  & 0.36343059E-03_JPRB, 0.36375006E-03_JPRB, 0.36406305E-03_JPRB, 0.36436596E-03_JPRB, 0.36465013E-03_JPRB, 0.36491014E-03_JPRB, &
  & 0.36514096E-03_JPRB, 0.36534003E-03_JPRB, 0.36550791E-03_JPRB, 0.36564615E-03_JPRB, 0.36575750E-03_JPRB, 0.36584612E-03_JPRB, &
  & 0.36591635E-03_JPRB, 0.36597179E-03_JPRB, 0.36601513E-03_JPRB, 0.36604790E-03_JPRB, 0.36607104E-03_JPRB, 0.36608474E-03_JPRB, &
  & 0.36608806E-03_JPRB, 0.36607945E-03_JPRB, 0.36605788E-03_JPRB, 0.36602336E-03_JPRB, 0.36597817E-03_JPRB, 0.36592613E-03_JPRB, &
  & 0.36587269E-03_JPRB, 0.36582421E-03_JPRB, 0.36578724E-03_JPRB, 0.36576480E-03_JPRB, 0.36575625E-03_JPRB, 0.36575811E-03_JPRB, &
  & 0.36576568E-03_JPRB, 0.36577508E-03_JPRB, 0.36578285E-03_JPRB, 0.36578611E-03_JPRB, 0.36578180E-03_JPRB, 0.36576725E-03_JPRB, &
  & 0.36574158E-03_JPRB, 0.36570558E-03_JPRB, 0.36566035E-03_JPRB, 0.36560671E-03_JPRB, 0.36554498E-03_JPRB, 0.36547484E-03_JPRB, &
  & 0.36539609E-03_JPRB, 0.36530817E-03_JPRB, 0.36521041E-03_JPRB, 0.36510173E-03_JPRB, 0.36498025E-03_JPRB, 0.36484527E-03_JPRB, &
  & 0.36469559E-03_JPRB, 0.36453328E-03_JPRB, 0.36436020E-03_JPRB, 0.36418202E-03_JPRB, 0.36400446E-03_JPRB, 0.36383225E-03_JPRB, &
  & 0.36366977E-03_JPRB, 0.36351569E-03_JPRB, 0.36335000E-03_JPRB, 0.36306839E-03_JPRB /)

RGHG1(:, 8, 7) = (/ &
  & 0.36189469E-03_JPRB, 0.36245771E-03_JPRB, 0.36277855E-03_JPRB, 0.36306141E-03_JPRB, 0.36333507E-03_JPRB, 0.36362110E-03_JPRB, &
  & 0.36391028E-03_JPRB, 0.36420237E-03_JPRB, 0.36448790E-03_JPRB, 0.36475906E-03_JPRB, 0.36501020E-03_JPRB, 0.36523709E-03_JPRB, &
  & 0.36543701E-03_JPRB, 0.36560878E-03_JPRB, 0.36575246E-03_JPRB, 0.36587054E-03_JPRB, 0.36596635E-03_JPRB, 0.36604359E-03_JPRB, &
  & 0.36610573E-03_JPRB, 0.36615564E-03_JPRB, 0.36619618E-03_JPRB, 0.36622945E-03_JPRB, 0.36625535E-03_JPRB, 0.36627287E-03_JPRB, &
  & 0.36628149E-03_JPRB, 0.36627988E-03_JPRB, 0.36626647E-03_JPRB, 0.36623995E-03_JPRB, 0.36620005E-03_JPRB, 0.36614935E-03_JPRB, &
  & 0.36609449E-03_JPRB, 0.36604510E-03_JPRB, 0.36601021E-03_JPRB, 0.36599417E-03_JPRB, 0.36599670E-03_JPRB, 0.36601405E-03_JPRB, &
  & 0.36604106E-03_JPRB, 0.36607168E-03_JPRB, 0.36610095E-03_JPRB, 0.36612345E-03_JPRB, 0.36613413E-03_JPRB, 0.36612886E-03_JPRB, &
  & 0.36610579E-03_JPRB, 0.36606559E-03_JPRB, 0.36600986E-03_JPRB, 0.36594068E-03_JPRB, 0.36585989E-03_JPRB, 0.36576879E-03_JPRB, &
  & 0.36566987E-03_JPRB, 0.36556507E-03_JPRB, 0.36545633E-03_JPRB, 0.36534460E-03_JPRB, 0.36523046E-03_JPRB, 0.36511343E-03_JPRB, &
  & 0.36499277E-03_JPRB, 0.36486896E-03_JPRB, 0.36474361E-03_JPRB, 0.36461954E-03_JPRB, 0.36450202E-03_JPRB, 0.36439375E-03_JPRB, &
  & 0.36429477E-03_JPRB, 0.36420050E-03_JPRB, 0.36410394E-03_JPRB, 0.36392512E-03_JPRB /)

RGHG1(:, 9, 7) = (/ &
  & 0.36239059E-03_JPRB, 0.36291932E-03_JPRB, 0.36321429E-03_JPRB, 0.36345958E-03_JPRB, 0.36371269E-03_JPRB, 0.36395786E-03_JPRB, &
  & 0.36422361E-03_JPRB, 0.36448668E-03_JPRB, 0.36474978E-03_JPRB, 0.36500013E-03_JPRB, 0.36523206E-03_JPRB, 0.36544033E-03_JPRB, &
  & 0.36562263E-03_JPRB, 0.36577851E-03_JPRB, 0.36590907E-03_JPRB, 0.36601649E-03_JPRB, 0.36610410E-03_JPRB, 0.36617523E-03_JPRB, &
  & 0.36623343E-03_JPRB, 0.36628213E-03_JPRB, 0.36632319E-03_JPRB, 0.36635817E-03_JPRB, 0.36638920E-03_JPRB, 0.36641641E-03_JPRB, &
  & 0.36643827E-03_JPRB, 0.36645320E-03_JPRB, 0.36645902E-03_JPRB, 0.36645337E-03_JPRB, 0.36643544E-03_JPRB, 0.36640675E-03_JPRB, &
  & 0.36637229E-03_JPRB, 0.36634016E-03_JPRB, 0.36631883E-03_JPRB, 0.36631397E-03_JPRB, 0.36632820E-03_JPRB, 0.36635969E-03_JPRB, &
  & 0.36640314E-03_JPRB, 0.36645192E-03_JPRB, 0.36649869E-03_JPRB, 0.36653597E-03_JPRB, 0.36655684E-03_JPRB, 0.36655611E-03_JPRB, &
  & 0.36653137E-03_JPRB, 0.36648253E-03_JPRB, 0.36641164E-03_JPRB, 0.36632112E-03_JPRB, 0.36621396E-03_JPRB, 0.36609350E-03_JPRB, &
  & 0.36596411E-03_JPRB, 0.36583067E-03_JPRB, 0.36569830E-03_JPRB, 0.36557097E-03_JPRB, 0.36545144E-03_JPRB, 0.36534108E-03_JPRB, &
  & 0.36524076E-03_JPRB, 0.36515039E-03_JPRB, 0.36507007E-03_JPRB, 0.36499967E-03_JPRB, 0.36494021E-03_JPRB, 0.36489198E-03_JPRB, &
  & 0.36485720E-03_JPRB, 0.36483080E-03_JPRB, 0.36481762E-03_JPRB, 0.36480863E-03_JPRB /)

RGHG1(:,10, 7) = (/ &
  & 0.36280727E-03_JPRB, 0.36318047E-03_JPRB, 0.36338661E-03_JPRB, 0.36358510E-03_JPRB, 0.36377780E-03_JPRB, 0.36400367E-03_JPRB, &
  & 0.36423112E-03_JPRB, 0.36448488E-03_JPRB, 0.36473729E-03_JPRB, 0.36498508E-03_JPRB, 0.36521608E-03_JPRB, 0.36542490E-03_JPRB, &
  & 0.36560945E-03_JPRB, 0.36576946E-03_JPRB, 0.36590640E-03_JPRB, 0.36602237E-03_JPRB, 0.36611967E-03_JPRB, 0.36620095E-03_JPRB, &
  & 0.36626955E-03_JPRB, 0.36632878E-03_JPRB, 0.36638213E-03_JPRB, 0.36643253E-03_JPRB, 0.36648105E-03_JPRB, 0.36652852E-03_JPRB, &
  & 0.36657418E-03_JPRB, 0.36661609E-03_JPRB, 0.36665384E-03_JPRB, 0.36668722E-03_JPRB, 0.36671432E-03_JPRB, 0.36673358E-03_JPRB, &
  & 0.36674555E-03_JPRB, 0.36675401E-03_JPRB, 0.36676525E-03_JPRB, 0.36678463E-03_JPRB, 0.36681490E-03_JPRB, 0.36685570E-03_JPRB, &
  & 0.36690320E-03_JPRB, 0.36695233E-03_JPRB, 0.36699601E-03_JPRB, 0.36702683E-03_JPRB, 0.36703877E-03_JPRB, 0.36702747E-03_JPRB, &
  & 0.36699008E-03_JPRB, 0.36692619E-03_JPRB, 0.36683693E-03_JPRB, 0.36672471E-03_JPRB, 0.36659231E-03_JPRB, 0.36644345E-03_JPRB, &
  & 0.36628419E-03_JPRB, 0.36612095E-03_JPRB, 0.36596030E-03_JPRB, 0.36580832E-03_JPRB, 0.36566952E-03_JPRB, 0.36554682E-03_JPRB, &
  & 0.36544164E-03_JPRB, 0.36535412E-03_JPRB, 0.36528305E-03_JPRB, 0.36522688E-03_JPRB, 0.36518424E-03_JPRB, 0.36515220E-03_JPRB, &
  & 0.36513217E-03_JPRB, 0.36511759E-03_JPRB, 0.36511387E-03_JPRB, 0.36511771E-03_JPRB /)

RGHG1(:,11, 7) = (/ &
  & 0.36292788E-03_JPRB, 0.36306313E-03_JPRB, 0.36318120E-03_JPRB, 0.36331755E-03_JPRB, 0.36349348E-03_JPRB, 0.36368295E-03_JPRB, &
  & 0.36391628E-03_JPRB, 0.36416089E-03_JPRB, 0.36442585E-03_JPRB, 0.36468703E-03_JPRB, 0.36493526E-03_JPRB, 0.36516282E-03_JPRB, &
  & 0.36536666E-03_JPRB, 0.36554804E-03_JPRB, 0.36570887E-03_JPRB, 0.36585127E-03_JPRB, 0.36597738E-03_JPRB, 0.36608949E-03_JPRB, &
  & 0.36618963E-03_JPRB, 0.36628035E-03_JPRB, 0.36636490E-03_JPRB, 0.36644537E-03_JPRB, 0.36652337E-03_JPRB, 0.36660035E-03_JPRB, &
  & 0.36667776E-03_JPRB, 0.36675733E-03_JPRB, 0.36683932E-03_JPRB, 0.36692288E-03_JPRB, 0.36700969E-03_JPRB, 0.36709884E-03_JPRB, &
  & 0.36718641E-03_JPRB, 0.36726723E-03_JPRB, 0.36733857E-03_JPRB, 0.36740131E-03_JPRB, 0.36745603E-03_JPRB, 0.36750283E-03_JPRB, &
  & 0.36754087E-03_JPRB, 0.36756819E-03_JPRB, 0.36758234E-03_JPRB, 0.36758048E-03_JPRB, 0.36756013E-03_JPRB, 0.36751878E-03_JPRB, &
  & 0.36745486E-03_JPRB, 0.36736720E-03_JPRB, 0.36725594E-03_JPRB, 0.36712235E-03_JPRB, 0.36696874E-03_JPRB, 0.36679959E-03_JPRB, &
  & 0.36662110E-03_JPRB, 0.36643934E-03_JPRB, 0.36626073E-03_JPRB, 0.36609115E-03_JPRB, 0.36593527E-03_JPRB, 0.36579676E-03_JPRB, &
  & 0.36567810E-03_JPRB, 0.36557979E-03_JPRB, 0.36550031E-03_JPRB, 0.36543870E-03_JPRB, 0.36539300E-03_JPRB, 0.36536122E-03_JPRB, &
  & 0.36534327E-03_JPRB, 0.36533564E-03_JPRB, 0.36534405E-03_JPRB, 0.36538063E-03_JPRB /)

RGHG1(:,12, 7) = (/ &
  & 0.36314176E-03_JPRB, 0.36349331E-03_JPRB, 0.36371627E-03_JPRB, 0.36389663E-03_JPRB, 0.36404328E-03_JPRB, 0.36419425E-03_JPRB, &
  & 0.36434978E-03_JPRB, 0.36453258E-03_JPRB, 0.36473508E-03_JPRB, 0.36495479E-03_JPRB, 0.36517638E-03_JPRB, 0.36538785E-03_JPRB, &
  & 0.36558165E-03_JPRB, 0.36575430E-03_JPRB, 0.36590596E-03_JPRB, 0.36603812E-03_JPRB, 0.36615212E-03_JPRB, 0.36625043E-03_JPRB, &
  & 0.36633649E-03_JPRB, 0.36641580E-03_JPRB, 0.36649386E-03_JPRB, 0.36657447E-03_JPRB, 0.36665902E-03_JPRB, 0.36674840E-03_JPRB, &
  & 0.36684284E-03_JPRB, 0.36694366E-03_JPRB, 0.36705483E-03_JPRB, 0.36718033E-03_JPRB, 0.36731752E-03_JPRB, 0.36746496E-03_JPRB, &
  & 0.36761750E-03_JPRB, 0.36776278E-03_JPRB, 0.36788906E-03_JPRB, 0.36799107E-03_JPRB, 0.36806735E-03_JPRB, 0.36811834E-03_JPRB, &
  & 0.36814573E-03_JPRB, 0.36815036E-03_JPRB, 0.36813391E-03_JPRB, 0.36809870E-03_JPRB, 0.36804425E-03_JPRB, 0.36797160E-03_JPRB, &
  & 0.36787978E-03_JPRB, 0.36776887E-03_JPRB, 0.36763883E-03_JPRB, 0.36749031E-03_JPRB, 0.36732631E-03_JPRB, 0.36715006E-03_JPRB, &
  & 0.36696659E-03_JPRB, 0.36678227E-03_JPRB, 0.36660332E-03_JPRB, 0.36643445E-03_JPRB, 0.36627968E-03_JPRB, 0.36614193E-03_JPRB, &
  & 0.36602298E-03_JPRB, 0.36592336E-03_JPRB, 0.36584280E-03_JPRB, 0.36578125E-03_JPRB, 0.36573771E-03_JPRB, 0.36571163E-03_JPRB, &
  & 0.36570293E-03_JPRB, 0.36571000E-03_JPRB, 0.36574478E-03_JPRB, 0.36583329E-03_JPRB /)

RGHG1(:,13, 7) = (/ &
  & 0.36419157E-03_JPRB, 0.36465458E-03_JPRB, 0.36484306E-03_JPRB, 0.36495749E-03_JPRB, 0.36504911E-03_JPRB, 0.36513575E-03_JPRB, &
  & 0.36523063E-03_JPRB, 0.36534446E-03_JPRB, 0.36548200E-03_JPRB, 0.36564321E-03_JPRB, 0.36582438E-03_JPRB, 0.36601871E-03_JPRB, &
  & 0.36621670E-03_JPRB, 0.36640753E-03_JPRB, 0.36657954E-03_JPRB, 0.36672290E-03_JPRB, 0.36683219E-03_JPRB, 0.36690509E-03_JPRB, &
  & 0.36694744E-03_JPRB, 0.36696845E-03_JPRB, 0.36698105E-03_JPRB, 0.36699788E-03_JPRB, 0.36702730E-03_JPRB, 0.36707305E-03_JPRB, &
  & 0.36713702E-03_JPRB, 0.36722160E-03_JPRB, 0.36732852E-03_JPRB, 0.36746069E-03_JPRB, 0.36762000E-03_JPRB, 0.36779779E-03_JPRB, &
  & 0.36798252E-03_JPRB, 0.36815833E-03_JPRB, 0.36831130E-03_JPRB, 0.36843325E-03_JPRB, 0.36852079E-03_JPRB, 0.36857507E-03_JPRB, &
  & 0.36859812E-03_JPRB, 0.36859172E-03_JPRB, 0.36856043E-03_JPRB, 0.36850673E-03_JPRB, 0.36843316E-03_JPRB, 0.36834227E-03_JPRB, &
  & 0.36823415E-03_JPRB, 0.36810973E-03_JPRB, 0.36797044E-03_JPRB, 0.36781750E-03_JPRB, 0.36765327E-03_JPRB, 0.36748234E-03_JPRB, &
  & 0.36731068E-03_JPRB, 0.36714281E-03_JPRB, 0.36698303E-03_JPRB, 0.36683481E-03_JPRB, 0.36670055E-03_JPRB, 0.36658184E-03_JPRB, &
  & 0.36647980E-03_JPRB, 0.36639499E-03_JPRB, 0.36632747E-03_JPRB, 0.36627764E-03_JPRB, 0.36624540E-03_JPRB, 0.36623047E-03_JPRB, &
  & 0.36623451E-03_JPRB, 0.36625483E-03_JPRB, 0.36630899E-03_JPRB, 0.36642878E-03_JPRB /)

RGHG1(:,14, 7) = (/ &
  & 0.36549330E-03_JPRB, 0.36573020E-03_JPRB, 0.36581294E-03_JPRB, 0.36586780E-03_JPRB, 0.36590963E-03_JPRB, 0.36595139E-03_JPRB, &
  & 0.36600945E-03_JPRB, 0.36608995E-03_JPRB, 0.36620416E-03_JPRB, 0.36635288E-03_JPRB, 0.36652992E-03_JPRB, 0.36672229E-03_JPRB, &
  & 0.36691487E-03_JPRB, 0.36709383E-03_JPRB, 0.36724823E-03_JPRB, 0.36737041E-03_JPRB, 0.36745606E-03_JPRB, 0.36750644E-03_JPRB, &
  & 0.36752658E-03_JPRB, 0.36752626E-03_JPRB, 0.36751584E-03_JPRB, 0.36750495E-03_JPRB, 0.36750175E-03_JPRB, 0.36751293E-03_JPRB, &
  & 0.36754293E-03_JPRB, 0.36759680E-03_JPRB, 0.36768022E-03_JPRB, 0.36779628E-03_JPRB, 0.36794541E-03_JPRB, 0.36812114E-03_JPRB, &
  & 0.36830598E-03_JPRB, 0.36848462E-03_JPRB, 0.36864140E-03_JPRB, 0.36876686E-03_JPRB, 0.36885659E-03_JPRB, 0.36891026E-03_JPRB, &
  & 0.36892892E-03_JPRB, 0.36891640E-03_JPRB, 0.36887728E-03_JPRB, 0.36881567E-03_JPRB, 0.36873424E-03_JPRB, 0.36863660E-03_JPRB, &
  & 0.36852472E-03_JPRB, 0.36839952E-03_JPRB, 0.36826273E-03_JPRB, 0.36811648E-03_JPRB, 0.36796494E-03_JPRB, 0.36781232E-03_JPRB, &
  & 0.36766255E-03_JPRB, 0.36751997E-03_JPRB, 0.36738798E-03_JPRB, 0.36726848E-03_JPRB, 0.36716269E-03_JPRB, 0.36707093E-03_JPRB, &
  & 0.36699307E-03_JPRB, 0.36692928E-03_JPRB, 0.36687971E-03_JPRB, 0.36684508E-03_JPRB, 0.36682544E-03_JPRB, 0.36682098E-03_JPRB, &
  & 0.36683405E-03_JPRB, 0.36686100E-03_JPRB, 0.36692093E-03_JPRB, 0.36704465E-03_JPRB /)

RGHG1(:,15, 7) = (/ &
  & 0.36647051E-03_JPRB, 0.36658326E-03_JPRB, 0.36660882E-03_JPRB, 0.36663222E-03_JPRB, 0.36664473E-03_JPRB, 0.36666600E-03_JPRB, &
  & 0.36669936E-03_JPRB, 0.36675803E-03_JPRB, 0.36684514E-03_JPRB, 0.36696435E-03_JPRB, 0.36711089E-03_JPRB, 0.36727334E-03_JPRB, &
  & 0.36743845E-03_JPRB, 0.36759223E-03_JPRB, 0.36772370E-03_JPRB, 0.36782544E-03_JPRB, 0.36789553E-03_JPRB, 0.36793604E-03_JPRB, &
  & 0.36795353E-03_JPRB, 0.36795606E-03_JPRB, 0.36795158E-03_JPRB, 0.36794634E-03_JPRB, 0.36794602E-03_JPRB, 0.36795528E-03_JPRB, &
  & 0.36797923E-03_JPRB, 0.36802300E-03_JPRB, 0.36809221E-03_JPRB, 0.36819163E-03_JPRB, 0.36832079E-03_JPRB, 0.36847495E-03_JPRB, &
  & 0.36864189E-03_JPRB, 0.36880371E-03_JPRB, 0.36894571E-03_JPRB, 0.36905907E-03_JPRB, 0.36913686E-03_JPRB, 0.36917903E-03_JPRB, &
  & 0.36918899E-03_JPRB, 0.36917024E-03_JPRB, 0.36912732E-03_JPRB, 0.36906399E-03_JPRB, 0.36898375E-03_JPRB, 0.36888939E-03_JPRB, &
  & 0.36878273E-03_JPRB, 0.36866573E-03_JPRB, 0.36854079E-03_JPRB, 0.36841084E-03_JPRB, 0.36827940E-03_JPRB, 0.36815004E-03_JPRB, &
  & 0.36802675E-03_JPRB, 0.36791275E-03_JPRB, 0.36780941E-03_JPRB, 0.36771753E-03_JPRB, 0.36763682E-03_JPRB, 0.36756723E-03_JPRB, &
  & 0.36750850E-03_JPRB, 0.36746089E-03_JPRB, 0.36742463E-03_JPRB, 0.36740050E-03_JPRB, 0.36738900E-03_JPRB, 0.36739020E-03_JPRB, &
  & 0.36740585E-03_JPRB, 0.36743327E-03_JPRB, 0.36748807E-03_JPRB, 0.36759948E-03_JPRB /)

RGHG1(:,16, 7) = (/ &
  & 0.36722256E-03_JPRB, 0.36724712E-03_JPRB, 0.36724214E-03_JPRB, 0.36724063E-03_JPRB, 0.36723493E-03_JPRB, 0.36723746E-03_JPRB, &
  & 0.36725256E-03_JPRB, 0.36728784E-03_JPRB, 0.36735073E-03_JPRB, 0.36744206E-03_JPRB, 0.36755926E-03_JPRB, 0.36769427E-03_JPRB, &
  & 0.36783508E-03_JPRB, 0.36797026E-03_JPRB, 0.36808997E-03_JPRB, 0.36818706E-03_JPRB, 0.36825938E-03_JPRB, 0.36830993E-03_JPRB, &
  & 0.36834358E-03_JPRB, 0.36836643E-03_JPRB, 0.36838392E-03_JPRB, 0.36840001E-03_JPRB, 0.36841840E-03_JPRB, 0.36844279E-03_JPRB, &
  & 0.36847743E-03_JPRB, 0.36852679E-03_JPRB, 0.36859518E-03_JPRB, 0.36868465E-03_JPRB, 0.36879434E-03_JPRB, 0.36891853E-03_JPRB, &
  & 0.36904725E-03_JPRB, 0.36916710E-03_JPRB, 0.36926946E-03_JPRB, 0.36934574E-03_JPRB, 0.36939408E-03_JPRB, 0.36941541E-03_JPRB, &
  & 0.36941137E-03_JPRB, 0.36938544E-03_JPRB, 0.36934172E-03_JPRB, 0.36928352E-03_JPRB, 0.36921259E-03_JPRB, 0.36913049E-03_JPRB, &
  & 0.36903904E-03_JPRB, 0.36893928E-03_JPRB, 0.36883433E-03_JPRB, 0.36872621E-03_JPRB, 0.36861814E-03_JPRB, 0.36851346E-03_JPRB, &
  & 0.36841497E-03_JPRB, 0.36832396E-03_JPRB, 0.36824125E-03_JPRB, 0.36816645E-03_JPRB, 0.36809978E-03_JPRB, 0.36804148E-03_JPRB, &
  & 0.36799157E-03_JPRB, 0.36795103E-03_JPRB, 0.36792009E-03_JPRB, 0.36789966E-03_JPRB, 0.36788985E-03_JPRB, 0.36789128E-03_JPRB, &
  & 0.36790423E-03_JPRB, 0.36792818E-03_JPRB, 0.36797245E-03_JPRB, 0.36806552E-03_JPRB /)

RGHG1(:,17, 7) = (/ &
  & 0.36778415E-03_JPRB, 0.36777486E-03_JPRB, 0.36774669E-03_JPRB, 0.36773249E-03_JPRB, 0.36771430E-03_JPRB, 0.36770347E-03_JPRB, &
  & 0.36770263E-03_JPRB, 0.36772000E-03_JPRB, 0.36776112E-03_JPRB, 0.36782876E-03_JPRB, 0.36792294E-03_JPRB, 0.36803738E-03_JPRB, &
  & 0.36816351E-03_JPRB, 0.36829122E-03_JPRB, 0.36841174E-03_JPRB, 0.36851846E-03_JPRB, 0.36860799E-03_JPRB, 0.36868118E-03_JPRB, &
  & 0.36874184E-03_JPRB, 0.36879384E-03_JPRB, 0.36884096E-03_JPRB, 0.36888657E-03_JPRB, 0.36893392E-03_JPRB, 0.36898590E-03_JPRB, &
  & 0.36904501E-03_JPRB, 0.36911259E-03_JPRB, 0.36918916E-03_JPRB, 0.36927155E-03_JPRB, 0.36935497E-03_JPRB, 0.36943253E-03_JPRB, &
  & 0.36950209E-03_JPRB, 0.36955887E-03_JPRB, 0.36960075E-03_JPRB, 0.36962563E-03_JPRB, 0.36963355E-03_JPRB, 0.36962514E-03_JPRB, &
  & 0.36960380E-03_JPRB, 0.36957383E-03_JPRB, 0.36953541E-03_JPRB, 0.36948919E-03_JPRB, 0.36943515E-03_JPRB, 0.36937333E-03_JPRB, &
  & 0.36930374E-03_JPRB, 0.36922720E-03_JPRB, 0.36914516E-03_JPRB, 0.36905991E-03_JPRB, 0.36897333E-03_JPRB, 0.36888864E-03_JPRB, &
  & 0.36880691E-03_JPRB, 0.36872947E-03_JPRB, 0.36865659E-03_JPRB, 0.36858855E-03_JPRB, 0.36852609E-03_JPRB, 0.36846992E-03_JPRB, &
  & 0.36842111E-03_JPRB, 0.36838066E-03_JPRB, 0.36834925E-03_JPRB, 0.36832748E-03_JPRB, 0.36831584E-03_JPRB, 0.36831404E-03_JPRB, &
  & 0.36832155E-03_JPRB, 0.36833959E-03_JPRB, 0.36837155E-03_JPRB, 0.36844471E-03_JPRB /)

RGHG1(:,18, 7) = (/ &
  & 0.36821142E-03_JPRB, 0.36818095E-03_JPRB, 0.36814774E-03_JPRB, 0.36812553E-03_JPRB, 0.36810272E-03_JPRB, 0.36808438E-03_JPRB, &
  & 0.36807454E-03_JPRB, 0.36807946E-03_JPRB, 0.36810528E-03_JPRB, 0.36815641E-03_JPRB, 0.36823336E-03_JPRB, 0.36833313E-03_JPRB, &
  & 0.36844966E-03_JPRB, 0.36857551E-03_JPRB, 0.36870260E-03_JPRB, 0.36882373E-03_JPRB, 0.36893389E-03_JPRB, 0.36903133E-03_JPRB, &
  & 0.36911719E-03_JPRB, 0.36919457E-03_JPRB, 0.36926701E-03_JPRB, 0.36933762E-03_JPRB, 0.36940951E-03_JPRB, 0.36948483E-03_JPRB, &
  & 0.36956376E-03_JPRB, 0.36964315E-03_JPRB, 0.36971807E-03_JPRB, 0.36978352E-03_JPRB, 0.36983562E-03_JPRB, 0.36987208E-03_JPRB, &
  & 0.36989176E-03_JPRB, 0.36989697E-03_JPRB, 0.36988847E-03_JPRB, 0.36986894E-03_JPRB, 0.36984152E-03_JPRB, 0.36981032E-03_JPRB, &
  & 0.36977825E-03_JPRB, 0.36974571E-03_JPRB, 0.36971454E-03_JPRB, 0.36968317E-03_JPRB, 0.36964903E-03_JPRB, 0.36960957E-03_JPRB, &
  & 0.36956312E-03_JPRB, 0.36950933E-03_JPRB, 0.36944891E-03_JPRB, 0.36938311E-03_JPRB, 0.36931355E-03_JPRB, 0.36924228E-03_JPRB, &
  & 0.36917033E-03_JPRB, 0.36909885E-03_JPRB, 0.36902892E-03_JPRB, 0.36896160E-03_JPRB, 0.36889795E-03_JPRB, 0.36883980E-03_JPRB, &
  & 0.36878849E-03_JPRB, 0.36874530E-03_JPRB, 0.36871096E-03_JPRB, 0.36868593E-03_JPRB, 0.36867021E-03_JPRB, 0.36866331E-03_JPRB, &
  & 0.36866483E-03_JPRB, 0.36867525E-03_JPRB, 0.36869635E-03_JPRB, 0.36875028E-03_JPRB /)

RGHG1(:,19, 7) = (/ &
  & 0.36853668E-03_JPRB, 0.36849902E-03_JPRB, 0.36846794E-03_JPRB, 0.36844308E-03_JPRB, 0.36841966E-03_JPRB, 0.36839914E-03_JPRB, &
  & 0.36838505E-03_JPRB, 0.36838299E-03_JPRB, 0.36839925E-03_JPRB, 0.36843852E-03_JPRB, 0.36850304E-03_JPRB, 0.36859192E-03_JPRB, &
  & 0.36870071E-03_JPRB, 0.36882397E-03_JPRB, 0.36895424E-03_JPRB, 0.36908404E-03_JPRB, 0.36920630E-03_JPRB, 0.36931690E-03_JPRB, &
  & 0.36941507E-03_JPRB, 0.36950328E-03_JPRB, 0.36958541E-03_JPRB, 0.36966513E-03_JPRB, 0.36974490E-03_JPRB, 0.36982616E-03_JPRB, &
  & 0.36990794E-03_JPRB, 0.36998655E-03_JPRB, 0.37005643E-03_JPRB, 0.37011068E-03_JPRB, 0.37014595E-03_JPRB, 0.37016079E-03_JPRB, &
  & 0.37015707E-03_JPRB, 0.37013693E-03_JPRB, 0.37010363E-03_JPRB, 0.37006094E-03_JPRB, 0.37001347E-03_JPRB, 0.36996824E-03_JPRB, &
  & 0.36992927E-03_JPRB, 0.36989927E-03_JPRB, 0.36987741E-03_JPRB, 0.36986024E-03_JPRB, 0.36984333E-03_JPRB, 0.36982249E-03_JPRB, &
  & 0.36979496E-03_JPRB, 0.36975896E-03_JPRB, 0.36971478E-03_JPRB, 0.36966318E-03_JPRB, 0.36960555E-03_JPRB, 0.36954327E-03_JPRB, &
  & 0.36947723E-03_JPRB, 0.36940919E-03_JPRB, 0.36934065E-03_JPRB, 0.36927278E-03_JPRB, 0.36920773E-03_JPRB, 0.36914743E-03_JPRB, &
  & 0.36909379E-03_JPRB, 0.36904789E-03_JPRB, 0.36901038E-03_JPRB, 0.36898162E-03_JPRB, 0.36896160E-03_JPRB, 0.36894987E-03_JPRB, &
  & 0.36894574E-03_JPRB, 0.36894908E-03_JPRB, 0.36896142E-03_JPRB, 0.36899757E-03_JPRB /)

RGHG1(:,20, 7) = (/ &
  & 0.36879454E-03_JPRB, 0.36875511E-03_JPRB, 0.36872766E-03_JPRB, 0.36870403E-03_JPRB, 0.36868203E-03_JPRB, 0.36866183E-03_JPRB, &
  & 0.36864670E-03_JPRB, 0.36864105E-03_JPRB, 0.36865115E-03_JPRB, 0.36868241E-03_JPRB, 0.36873715E-03_JPRB, 0.36881556E-03_JPRB, &
  & 0.36891524E-03_JPRB, 0.36903133E-03_JPRB, 0.36915747E-03_JPRB, 0.36928576E-03_JPRB, 0.36940863E-03_JPRB, 0.36952051E-03_JPRB, &
  & 0.36962010E-03_JPRB, 0.36970910E-03_JPRB, 0.36979071E-03_JPRB, 0.36986877E-03_JPRB, 0.36994647E-03_JPRB, 0.37002514E-03_JPRB, &
  & 0.37010352E-03_JPRB, 0.37017814E-03_JPRB, 0.37024281E-03_JPRB, 0.37029173E-03_JPRB, 0.37032165E-03_JPRB, 0.37033187E-03_JPRB, &
  & 0.37032354E-03_JPRB, 0.37029816E-03_JPRB, 0.37025890E-03_JPRB, 0.37021076E-03_JPRB, 0.37015844E-03_JPRB, 0.37011006E-03_JPRB, &
  & 0.37007077E-03_JPRB, 0.37004397E-03_JPRB, 0.37002805E-03_JPRB, 0.37001944E-03_JPRB, 0.37001309E-03_JPRB, 0.37000369E-03_JPRB, &
  & 0.36998754E-03_JPRB, 0.36996300E-03_JPRB, 0.36992930E-03_JPRB, 0.36988690E-03_JPRB, 0.36983695E-03_JPRB, 0.36978064E-03_JPRB, &
  & 0.36971920E-03_JPRB, 0.36965447E-03_JPRB, 0.36958809E-03_JPRB, 0.36952141E-03_JPRB, 0.36945695E-03_JPRB, 0.36939661E-03_JPRB, &
  & 0.36934248E-03_JPRB, 0.36929539E-03_JPRB, 0.36925587E-03_JPRB, 0.36922412E-03_JPRB, 0.36920042E-03_JPRB, 0.36918439E-03_JPRB, &
  & 0.36917557E-03_JPRB, 0.36917330E-03_JPRB, 0.36917822E-03_JPRB, 0.36920016E-03_JPRB /)

RGHG1(:,21, 7) = (/ &
  & 0.36900700E-03_JPRB, 0.36896832E-03_JPRB, 0.36894393E-03_JPRB, 0.36892266E-03_JPRB, 0.36890263E-03_JPRB, 0.36888398E-03_JPRB, &
  & 0.36886870E-03_JPRB, 0.36886148E-03_JPRB, 0.36886759E-03_JPRB, 0.36889230E-03_JPRB, 0.36893846E-03_JPRB, 0.36900680E-03_JPRB, &
  & 0.36909539E-03_JPRB, 0.36920048E-03_JPRB, 0.36931597E-03_JPRB, 0.36943526E-03_JPRB, 0.36955078E-03_JPRB, 0.36965674E-03_JPRB, &
  & 0.36975113E-03_JPRB, 0.36983564E-03_JPRB, 0.36991326E-03_JPRB, 0.36998719E-03_JPRB, 0.37006038E-03_JPRB, 0.37013486E-03_JPRB, &
  & 0.37020966E-03_JPRB, 0.37028137E-03_JPRB, 0.37034455E-03_JPRB, 0.37039336E-03_JPRB, 0.37042482E-03_JPRB, 0.37043780E-03_JPRB, &
  & 0.37043315E-03_JPRB, 0.37041202E-03_JPRB, 0.37037715E-03_JPRB, 0.37033236E-03_JPRB, 0.37028408E-03_JPRB, 0.37023949E-03_JPRB, &
  & 0.37020331E-03_JPRB, 0.37017901E-03_JPRB, 0.37016734E-03_JPRB, 0.37016312E-03_JPRB, 0.37016120E-03_JPRB, 0.37015649E-03_JPRB, &
  & 0.37014531E-03_JPRB, 0.37012552E-03_JPRB, 0.37009665E-03_JPRB, 0.37005916E-03_JPRB, 0.37001379E-03_JPRB, 0.36996169E-03_JPRB, &
  & 0.36990430E-03_JPRB, 0.36984327E-03_JPRB, 0.36977997E-03_JPRB, 0.36971629E-03_JPRB, 0.36965436E-03_JPRB, 0.36959615E-03_JPRB, &
  & 0.36954298E-03_JPRB, 0.36949627E-03_JPRB, 0.36945631E-03_JPRB, 0.36942307E-03_JPRB, 0.36939690E-03_JPRB, 0.36937764E-03_JPRB, &
  & 0.36936507E-03_JPRB, 0.36935840E-03_JPRB, 0.36935811E-03_JPRB, 0.36936905E-03_JPRB /)

RGHG1(:,22, 7) = (/ &
  & 0.36918838E-03_JPRB, 0.36915179E-03_JPRB, 0.36912932E-03_JPRB, 0.36911029E-03_JPRB, 0.36909193E-03_JPRB, 0.36907435E-03_JPRB, &
  & 0.36905959E-03_JPRB, 0.36905118E-03_JPRB, 0.36905459E-03_JPRB, 0.36907394E-03_JPRB, 0.36911247E-03_JPRB, 0.36917080E-03_JPRB, &
  & 0.36924769E-03_JPRB, 0.36933972E-03_JPRB, 0.36944193E-03_JPRB, 0.36954827E-03_JPRB, 0.36965223E-03_JPRB, 0.36974906E-03_JPRB, &
  & 0.36983643E-03_JPRB, 0.36991498E-03_JPRB, 0.36998771E-03_JPRB, 0.37005765E-03_JPRB, 0.37012729E-03_JPRB, 0.37019866E-03_JPRB, &
  & 0.37027113E-03_JPRB, 0.37034205E-03_JPRB, 0.37040567E-03_JPRB, 0.37045704E-03_JPRB, 0.37049249E-03_JPRB, 0.37051112E-03_JPRB, &
  & 0.37051298E-03_JPRB, 0.37049974E-03_JPRB, 0.37047337E-03_JPRB, 0.37043792E-03_JPRB, 0.37039845E-03_JPRB, 0.37036053E-03_JPRB, &
  & 0.37033012E-03_JPRB, 0.37031027E-03_JPRB, 0.37029921E-03_JPRB, 0.37029490E-03_JPRB, 0.37029223E-03_JPRB, 0.37028705E-03_JPRB, &
  & 0.37027607E-03_JPRB, 0.37025736E-03_JPRB, 0.37023021E-03_JPRB, 0.37019412E-03_JPRB, 0.37015058E-03_JPRB, 0.37010078E-03_JPRB, &
  & 0.37004647E-03_JPRB, 0.36998876E-03_JPRB, 0.36992907E-03_JPRB, 0.36986903E-03_JPRB, 0.36981064E-03_JPRB, 0.36975541E-03_JPRB, &
  & 0.36970491E-03_JPRB, 0.36965974E-03_JPRB, 0.36962042E-03_JPRB, 0.36958710E-03_JPRB, 0.36955980E-03_JPRB, 0.36953867E-03_JPRB, &
  & 0.36952336E-03_JPRB, 0.36951341E-03_JPRB, 0.36950866E-03_JPRB, 0.36951178E-03_JPRB /)

RGHG1(:,23, 7) = (/ &
  & 0.36934635E-03_JPRB, 0.36931172E-03_JPRB, 0.36929181E-03_JPRB, 0.36927444E-03_JPRB, 0.36925758E-03_JPRB, 0.36924134E-03_JPRB, &
  & 0.36922714E-03_JPRB, 0.36921841E-03_JPRB, 0.36921969E-03_JPRB, 0.36923488E-03_JPRB, 0.36926672E-03_JPRB, 0.36931603E-03_JPRB, &
  & 0.36938151E-03_JPRB, 0.36946073E-03_JPRB, 0.36954932E-03_JPRB, 0.36964208E-03_JPRB, 0.36973384E-03_JPRB, 0.36982028E-03_JPRB, &
  & 0.36989996E-03_JPRB, 0.36997334E-03_JPRB, 0.37004234E-03_JPRB, 0.37010942E-03_JPRB, 0.37017680E-03_JPRB, 0.37024581E-03_JPRB, &
  & 0.37031670E-03_JPRB, 0.37038664E-03_JPRB, 0.37045087E-03_JPRB, 0.37050422E-03_JPRB, 0.37054328E-03_JPRB, 0.37056726E-03_JPRB, &
  & 0.37057625E-03_JPRB, 0.37057168E-03_JPRB, 0.37055564E-03_JPRB, 0.37053166E-03_JPRB, 0.37050323E-03_JPRB, 0.37047567E-03_JPRB, &
  & 0.37045209E-03_JPRB, 0.37043457E-03_JPRB, 0.37042351E-03_JPRB, 0.37041595E-03_JPRB, 0.37040902E-03_JPRB, 0.37039950E-03_JPRB, &
  & 0.37038495E-03_JPRB, 0.37036336E-03_JPRB, 0.37033466E-03_JPRB, 0.37029857E-03_JPRB, 0.37025602E-03_JPRB, 0.37020791E-03_JPRB, &
  & 0.37015579E-03_JPRB, 0.37010110E-03_JPRB, 0.37004513E-03_JPRB, 0.36998960E-03_JPRB, 0.36993585E-03_JPRB, 0.36988477E-03_JPRB, &
  & 0.36983780E-03_JPRB, 0.36979481E-03_JPRB, 0.36975683E-03_JPRB, 0.36972392E-03_JPRB, 0.36969635E-03_JPRB, 0.36967403E-03_JPRB, &
  & 0.36965709E-03_JPRB, 0.36964499E-03_JPRB, 0.36963719E-03_JPRB, 0.36963419E-03_JPRB /)

RGHG1(:,24, 7) = (/ &
  & 0.36948474E-03_JPRB, 0.36945398E-03_JPRB, 0.36943564E-03_JPRB, 0.36942010E-03_JPRB, 0.36940520E-03_JPRB, 0.36939047E-03_JPRB, &
  & 0.36937761E-03_JPRB, 0.36936917E-03_JPRB, 0.36936949E-03_JPRB, 0.36938186E-03_JPRB, 0.36940869E-03_JPRB, 0.36945072E-03_JPRB, &
  & 0.36950727E-03_JPRB, 0.36957560E-03_JPRB, 0.36965223E-03_JPRB, 0.36973300E-03_JPRB, 0.36981353E-03_JPRB, 0.36989097E-03_JPRB, &
  & 0.36996382E-03_JPRB, 0.37003215E-03_JPRB, 0.37009752E-03_JPRB, 0.37016149E-03_JPRB, 0.37022625E-03_JPRB, 0.37029290E-03_JPRB, &
  & 0.37036082E-03_JPRB, 0.37042805E-03_JPRB, 0.37049051E-03_JPRB, 0.37054386E-03_JPRB, 0.37058545E-03_JPRB, 0.37061353E-03_JPRB, &
  & 0.37062899E-03_JPRB, 0.37063248E-03_JPRB, 0.37062657E-03_JPRB, 0.37061356E-03_JPRB, 0.37059642E-03_JPRB, 0.37057849E-03_JPRB, &
  & 0.37056152E-03_JPRB, 0.37054718E-03_JPRB, 0.37053472E-03_JPRB, 0.37052337E-03_JPRB, 0.37051100E-03_JPRB, 0.37049598E-03_JPRB, &
  & 0.37047631E-03_JPRB, 0.37045099E-03_JPRB, 0.37041932E-03_JPRB, 0.37038137E-03_JPRB, 0.37033812E-03_JPRB, 0.37029109E-03_JPRB, &
  & 0.37024124E-03_JPRB, 0.37019004E-03_JPRB, 0.37013824E-03_JPRB, 0.37008701E-03_JPRB, 0.37003771E-03_JPRB, 0.36999115E-03_JPRB, &
  & 0.36994778E-03_JPRB, 0.36990803E-03_JPRB, 0.36987208E-03_JPRB, 0.36984039E-03_JPRB, 0.36981283E-03_JPRB, 0.36979016E-03_JPRB, &
  & 0.36977229E-03_JPRB, 0.36975887E-03_JPRB, 0.36974860E-03_JPRB, 0.36974082E-03_JPRB /)

RGHG1(:,25, 7) = (/ &
  & 0.36960805E-03_JPRB, 0.36958040E-03_JPRB, 0.36956480E-03_JPRB, 0.36955133E-03_JPRB, 0.36953861E-03_JPRB, 0.36952633E-03_JPRB, &
  & 0.36951553E-03_JPRB, 0.36950878E-03_JPRB, 0.36950930E-03_JPRB, 0.36952045E-03_JPRB, 0.36954461E-03_JPRB, 0.36958189E-03_JPRB, &
  & 0.36963183E-03_JPRB, 0.36969225E-03_JPRB, 0.36976003E-03_JPRB, 0.36983166E-03_JPRB, 0.36990372E-03_JPRB, 0.36997383E-03_JPRB, &
  & 0.37004071E-03_JPRB, 0.37010454E-03_JPRB, 0.37016603E-03_JPRB, 0.37022663E-03_JPRB, 0.37028719E-03_JPRB, 0.37034901E-03_JPRB, &
  & 0.37041155E-03_JPRB, 0.37047314E-03_JPRB, 0.37053111E-03_JPRB, 0.37058193E-03_JPRB, 0.37062305E-03_JPRB, 0.37065358E-03_JPRB, &
  & 0.37067366E-03_JPRB, 0.37068393E-03_JPRB, 0.37068626E-03_JPRB, 0.37068228E-03_JPRB, 0.37067442E-03_JPRB, 0.37066382E-03_JPRB, &
  & 0.37065224E-03_JPRB, 0.37064007E-03_JPRB, 0.37062666E-03_JPRB, 0.37061225E-03_JPRB, 0.37059525E-03_JPRB, 0.37057491E-03_JPRB, &
  & 0.37055052E-03_JPRB, 0.37052136E-03_JPRB, 0.37048743E-03_JPRB, 0.37044866E-03_JPRB, 0.37040564E-03_JPRB, 0.37035943E-03_JPRB, &
  & 0.37031143E-03_JPRB, 0.37026289E-03_JPRB, 0.37021504E-03_JPRB, 0.37016833E-03_JPRB, 0.37012345E-03_JPRB, 0.37008116E-03_JPRB, &
  & 0.37004144E-03_JPRB, 0.37000480E-03_JPRB, 0.36997136E-03_JPRB, 0.36994123E-03_JPRB, 0.36991475E-03_JPRB, 0.36989243E-03_JPRB, &
  & 0.36987424E-03_JPRB, 0.36985986E-03_JPRB, 0.36984819E-03_JPRB, 0.36983649E-03_JPRB /)

RGHG1(:,26, 7) = (/ &
  & 0.36971728E-03_JPRB, 0.36969408E-03_JPRB, 0.36968122E-03_JPRB, 0.36967031E-03_JPRB, 0.36966032E-03_JPRB, 0.36965089E-03_JPRB, &
  & 0.36964304E-03_JPRB, 0.36963896E-03_JPRB, 0.36964132E-03_JPRB, 0.36965328E-03_JPRB, 0.36967656E-03_JPRB, 0.36971160E-03_JPRB, &
  & 0.36975797E-03_JPRB, 0.36981338E-03_JPRB, 0.36987543E-03_JPRB, 0.36994118E-03_JPRB, 0.37000733E-03_JPRB, 0.37007188E-03_JPRB, &
  & 0.37013373E-03_JPRB, 0.37019298E-03_JPRB, 0.37024985E-03_JPRB, 0.37030512E-03_JPRB, 0.37035980E-03_JPRB, 0.37041435E-03_JPRB, &
  & 0.37046900E-03_JPRB, 0.37052255E-03_JPRB, 0.37057328E-03_JPRB, 0.37061912E-03_JPRB, 0.37065832E-03_JPRB, 0.37068923E-03_JPRB, &
  & 0.37071205E-03_JPRB, 0.37072704E-03_JPRB, 0.37073551E-03_JPRB, 0.37073821E-03_JPRB, 0.37073650E-03_JPRB, 0.37073126E-03_JPRB, &
  & 0.37072317E-03_JPRB, 0.37071217E-03_JPRB, 0.37069828E-03_JPRB, 0.37068102E-03_JPRB, 0.37066074E-03_JPRB, 0.37063652E-03_JPRB, &
  & 0.37060861E-03_JPRB, 0.37057622E-03_JPRB, 0.37053999E-03_JPRB, 0.37050020E-03_JPRB, 0.37045754E-03_JPRB, 0.37041327E-03_JPRB, &
  & 0.37036825E-03_JPRB, 0.37032375E-03_JPRB, 0.37027989E-03_JPRB, 0.37023751E-03_JPRB, 0.37019709E-03_JPRB, 0.37015887E-03_JPRB, &
  & 0.37012290E-03_JPRB, 0.37008949E-03_JPRB, 0.37005846E-03_JPRB, 0.37003023E-03_JPRB, 0.37000509E-03_JPRB, 0.36998338E-03_JPRB, &
  & 0.36996527E-03_JPRB, 0.36995046E-03_JPRB, 0.36993809E-03_JPRB, 0.36992462E-03_JPRB /)

RGHG1(:,27, 7) = (/ &
  & 0.36981501E-03_JPRB, 0.36979705E-03_JPRB, 0.36978698E-03_JPRB, 0.36977881E-03_JPRB, 0.36977162E-03_JPRB, 0.36976536E-03_JPRB, &
  & 0.36976091E-03_JPRB, 0.36976000E-03_JPRB, 0.36976530E-03_JPRB, 0.36977924E-03_JPRB, 0.36980349E-03_JPRB, 0.36983809E-03_JPRB, &
  & 0.36988262E-03_JPRB, 0.36993541E-03_JPRB, 0.36999403E-03_JPRB, 0.37005582E-03_JPRB, 0.37011798E-03_JPRB, 0.37017849E-03_JPRB, &
  & 0.37023614E-03_JPRB, 0.37029042E-03_JPRB, 0.37034185E-03_JPRB, 0.37039127E-03_JPRB, 0.37043830E-03_JPRB, 0.37048440E-03_JPRB, &
  & 0.37052980E-03_JPRB, 0.37057375E-03_JPRB, 0.37061604E-03_JPRB, 0.37065544E-03_JPRB, 0.37069092E-03_JPRB, 0.37072104E-03_JPRB, &
  & 0.37074520E-03_JPRB, 0.37076313E-03_JPRB, 0.37077529E-03_JPRB, 0.37078216E-03_JPRB, 0.37078423E-03_JPRB, 0.37078204E-03_JPRB, &
  & 0.37077570E-03_JPRB, 0.37076531E-03_JPRB, 0.37075090E-03_JPRB, 0.37073213E-03_JPRB, 0.37070969E-03_JPRB, 0.37068321E-03_JPRB, &
  & 0.37065311E-03_JPRB, 0.37061932E-03_JPRB, 0.37058213E-03_JPRB, 0.37054229E-03_JPRB, 0.37050067E-03_JPRB, 0.37045873E-03_JPRB, &
  & 0.37041723E-03_JPRB, 0.37037645E-03_JPRB, 0.37033696E-03_JPRB, 0.37029880E-03_JPRB, 0.37026260E-03_JPRB, 0.37022823E-03_JPRB, &
  & 0.37019583E-03_JPRB, 0.37016516E-03_JPRB, 0.37013658E-03_JPRB, 0.37011021E-03_JPRB, 0.37008661E-03_JPRB, 0.37006603E-03_JPRB, &
  & 0.37004854E-03_JPRB, 0.37003393E-03_JPRB, 0.37002104E-03_JPRB, 0.37000523E-03_JPRB /)

RGHG1(:,28, 7) = (/ &
  & 0.36990430E-03_JPRB, 0.36989036E-03_JPRB, 0.36988303E-03_JPRB, 0.36987750E-03_JPRB, 0.36987299E-03_JPRB, 0.36986952E-03_JPRB, &
  & 0.36986836E-03_JPRB, 0.36987101E-03_JPRB, 0.36987953E-03_JPRB, 0.36989612E-03_JPRB, 0.36992176E-03_JPRB, 0.36995678E-03_JPRB, &
  & 0.37000078E-03_JPRB, 0.37005194E-03_JPRB, 0.37010823E-03_JPRB, 0.37016722E-03_JPRB, 0.37022622E-03_JPRB, 0.37028347E-03_JPRB, &
  & 0.37033728E-03_JPRB, 0.37038702E-03_JPRB, 0.37043326E-03_JPRB, 0.37047625E-03_JPRB, 0.37051589E-03_JPRB, 0.37055361E-03_JPRB, &
  & 0.37058978E-03_JPRB, 0.37062462E-03_JPRB, 0.37065853E-03_JPRB, 0.37069138E-03_JPRB, 0.37072241E-03_JPRB, 0.37075061E-03_JPRB, &
  & 0.37077448E-03_JPRB, 0.37079360E-03_JPRB, 0.37080777E-03_JPRB, 0.37081671E-03_JPRB, 0.37082087E-03_JPRB, 0.37082017E-03_JPRB, &
  & 0.37081446E-03_JPRB, 0.37080422E-03_JPRB, 0.37078926E-03_JPRB, 0.37077002E-03_JPRB, 0.37074627E-03_JPRB, 0.37071877E-03_JPRB, &
  & 0.37068748E-03_JPRB, 0.37065326E-03_JPRB, 0.37061636E-03_JPRB, 0.37057756E-03_JPRB, 0.37053833E-03_JPRB, 0.37049924E-03_JPRB, &
  & 0.37046123E-03_JPRB, 0.37042436E-03_JPRB, 0.37038894E-03_JPRB, 0.37035480E-03_JPRB, 0.37032232E-03_JPRB, 0.37029147E-03_JPRB, &
  & 0.37026219E-03_JPRB, 0.37023425E-03_JPRB, 0.37020803E-03_JPRB, 0.37018370E-03_JPRB, 0.37016175E-03_JPRB, 0.37014220E-03_JPRB, &
  & 0.37012549E-03_JPRB, 0.37011100E-03_JPRB, 0.37009810E-03_JPRB, 0.37008183E-03_JPRB /)

RGHG1(:,29, 7) = (/ &
  & 0.36998445E-03_JPRB, 0.36997447E-03_JPRB, 0.36996938E-03_JPRB, 0.36996603E-03_JPRB, 0.36996385E-03_JPRB, 0.36996306E-03_JPRB, &
  & 0.36996463E-03_JPRB, 0.36997048E-03_JPRB, 0.36998210E-03_JPRB, 0.37000127E-03_JPRB, 0.37002875E-03_JPRB, 0.37006458E-03_JPRB, &
  & 0.37010826E-03_JPRB, 0.37015823E-03_JPRB, 0.37021263E-03_JPRB, 0.37026906E-03_JPRB, 0.37032549E-03_JPRB, 0.37037951E-03_JPRB, &
  & 0.37042968E-03_JPRB, 0.37047520E-03_JPRB, 0.37051662E-03_JPRB, 0.37055384E-03_JPRB, 0.37058708E-03_JPRB, 0.37061737E-03_JPRB, &
  & 0.37064572E-03_JPRB, 0.37067270E-03_JPRB, 0.37069921E-03_JPRB, 0.37072587E-03_JPRB, 0.37075230E-03_JPRB, 0.37077756E-03_JPRB, &
  & 0.37080055E-03_JPRB, 0.37081979E-03_JPRB, 0.37083463E-03_JPRB, 0.37084479E-03_JPRB, 0.37084980E-03_JPRB, 0.37084948E-03_JPRB, &
  & 0.37084415E-03_JPRB, 0.37083379E-03_JPRB, 0.37081860E-03_JPRB, 0.37079895E-03_JPRB, 0.37077483E-03_JPRB, 0.37074654E-03_JPRB, &
  & 0.37071540E-03_JPRB, 0.37068117E-03_JPRB, 0.37064534E-03_JPRB, 0.37060858E-03_JPRB, 0.37057194E-03_JPRB, 0.37053644E-03_JPRB, &
  & 0.37050236E-03_JPRB, 0.37046929E-03_JPRB, 0.37043742E-03_JPRB, 0.37040695E-03_JPRB, 0.37037782E-03_JPRB, 0.37035003E-03_JPRB, &
  & 0.37032351E-03_JPRB, 0.37029831E-03_JPRB, 0.37027441E-03_JPRB, 0.37025206E-03_JPRB, 0.37023169E-03_JPRB, 0.37021359E-03_JPRB, &
  & 0.37019784E-03_JPRB, 0.37018419E-03_JPRB, 0.37017174E-03_JPRB, 0.37015523E-03_JPRB /)

RGHG1(:,30, 7) = (/ &
  & 0.37005622E-03_JPRB, 0.37004959E-03_JPRB, 0.37004676E-03_JPRB, 0.37004525E-03_JPRB, 0.37004484E-03_JPRB, 0.37004627E-03_JPRB, &
  & 0.37005031E-03_JPRB, 0.37005861E-03_JPRB, 0.37007272E-03_JPRB, 0.37009400E-03_JPRB, 0.37012290E-03_JPRB, 0.37015934E-03_JPRB, &
  & 0.37020270E-03_JPRB, 0.37025171E-03_JPRB, 0.37030416E-03_JPRB, 0.37035818E-03_JPRB, 0.37041164E-03_JPRB, 0.37046272E-03_JPRB, &
  & 0.37050981E-03_JPRB, 0.37055204E-03_JPRB, 0.37058926E-03_JPRB, 0.37062183E-03_JPRB, 0.37064991E-03_JPRB, 0.37067430E-03_JPRB, &
  & 0.37069625E-03_JPRB, 0.37071697E-03_JPRB, 0.37073749E-03_JPRB, 0.37075888E-03_JPRB, 0.37078117E-03_JPRB, 0.37080338E-03_JPRB, &
  & 0.37082453E-03_JPRB, 0.37084328E-03_JPRB, 0.37085815E-03_JPRB, 0.37086834E-03_JPRB, 0.37087337E-03_JPRB, 0.37087305E-03_JPRB, &
  & 0.37086784E-03_JPRB, 0.37085763E-03_JPRB, 0.37084246E-03_JPRB, 0.37082270E-03_JPRB, 0.37079881E-03_JPRB, 0.37077090E-03_JPRB, &
  & 0.37074002E-03_JPRB, 0.37070693E-03_JPRB, 0.37067270E-03_JPRB, 0.37063821E-03_JPRB, 0.37060477E-03_JPRB, 0.37057273E-03_JPRB, &
  & 0.37054217E-03_JPRB, 0.37051260E-03_JPRB, 0.37048399E-03_JPRB, 0.37045666E-03_JPRB, 0.37043044E-03_JPRB, 0.37040527E-03_JPRB, &
  & 0.37038125E-03_JPRB, 0.37035818E-03_JPRB, 0.37033643E-03_JPRB, 0.37031592E-03_JPRB, 0.37029723E-03_JPRB, 0.37028047E-03_JPRB, &
  & 0.37026592E-03_JPRB, 0.37025311E-03_JPRB, 0.37024103E-03_JPRB, 0.37022392E-03_JPRB /)

RGHG1(:,31, 7) = (/ &
  & 0.37012104E-03_JPRB, 0.37011664E-03_JPRB, 0.37011533E-03_JPRB, 0.37011527E-03_JPRB, 0.37011641E-03_JPRB, 0.37011955E-03_JPRB, &
  & 0.37012552E-03_JPRB, 0.37013597E-03_JPRB, 0.37015235E-03_JPRB, 0.37017523E-03_JPRB, 0.37020512E-03_JPRB, 0.37024185E-03_JPRB, &
  & 0.37028463E-03_JPRB, 0.37033207E-03_JPRB, 0.37038242E-03_JPRB, 0.37043405E-03_JPRB, 0.37048489E-03_JPRB, 0.37053315E-03_JPRB, &
  & 0.37057756E-03_JPRB, 0.37061702E-03_JPRB, 0.37065102E-03_JPRB, 0.37067980E-03_JPRB, 0.37070387E-03_JPRB, 0.37072386E-03_JPRB, &
  & 0.37074118E-03_JPRB, 0.37075725E-03_JPRB, 0.37077325E-03_JPRB, 0.37079031E-03_JPRB, 0.37080873E-03_JPRB, 0.37082809E-03_JPRB, &
  & 0.37084735E-03_JPRB, 0.37086464E-03_JPRB, 0.37087893E-03_JPRB, 0.37088868E-03_JPRB, 0.37089337E-03_JPRB, 0.37089299E-03_JPRB, &
  & 0.37088775E-03_JPRB, 0.37087768E-03_JPRB, 0.37086321E-03_JPRB, 0.37084395E-03_JPRB, 0.37082081E-03_JPRB, 0.37079383E-03_JPRB, &
  & 0.37076432E-03_JPRB, 0.37073280E-03_JPRB, 0.37070067E-03_JPRB, 0.37066895E-03_JPRB, 0.37063842E-03_JPRB, 0.37060946E-03_JPRB, &
  & 0.37058193E-03_JPRB, 0.37055547E-03_JPRB, 0.37052942E-03_JPRB, 0.37050460E-03_JPRB, 0.37048064E-03_JPRB, 0.37045759E-03_JPRB, &
  & 0.37043550E-03_JPRB, 0.37041440E-03_JPRB, 0.37039453E-03_JPRB, 0.37037587E-03_JPRB, 0.37035867E-03_JPRB, 0.37034319E-03_JPRB, &
  & 0.37032960E-03_JPRB, 0.37031743E-03_JPRB, 0.37030602E-03_JPRB, 0.37029004E-03_JPRB /)

RGHG1(:,32, 7) = (/ &
  & 0.37017913E-03_JPRB, 0.37017674E-03_JPRB, 0.37017660E-03_JPRB, 0.37017776E-03_JPRB, 0.37018035E-03_JPRB, 0.37018483E-03_JPRB, &
  & 0.37019246E-03_JPRB, 0.37020465E-03_JPRB, 0.37022241E-03_JPRB, 0.37024639E-03_JPRB, 0.37027677E-03_JPRB, 0.37031321E-03_JPRB, &
  & 0.37035500E-03_JPRB, 0.37040093E-03_JPRB, 0.37044910E-03_JPRB, 0.37049831E-03_JPRB, 0.37054648E-03_JPRB, 0.37059237E-03_JPRB, &
  & 0.37063420E-03_JPRB, 0.37067139E-03_JPRB, 0.37070288E-03_JPRB, 0.37072922E-03_JPRB, 0.37075032E-03_JPRB, 0.37076723E-03_JPRB, &
  & 0.37078126E-03_JPRB, 0.37079377E-03_JPRB, 0.37080635E-03_JPRB, 0.37082008E-03_JPRB, 0.37083536E-03_JPRB, 0.37085215E-03_JPRB, &
  & 0.37086918E-03_JPRB, 0.37088490E-03_JPRB, 0.37089782E-03_JPRB, 0.37090667E-03_JPRB, 0.37091083E-03_JPRB, 0.37091042E-03_JPRB, &
  & 0.37090527E-03_JPRB, 0.37089584E-03_JPRB, 0.37088216E-03_JPRB, 0.37086432E-03_JPRB, 0.37084232E-03_JPRB, 0.37081706E-03_JPRB, &
  & 0.37078926E-03_JPRB, 0.37076013E-03_JPRB, 0.37073038E-03_JPRB, 0.37070125E-03_JPRB, 0.37067346E-03_JPRB, 0.37064715E-03_JPRB, &
  & 0.37062186E-03_JPRB, 0.37059750E-03_JPRB, 0.37057363E-03_JPRB, 0.37055049E-03_JPRB, 0.37052835E-03_JPRB, 0.37050704E-03_JPRB, &
  & 0.37048673E-03_JPRB, 0.37046726E-03_JPRB, 0.37044883E-03_JPRB, 0.37043169E-03_JPRB, 0.37041592E-03_JPRB, 0.37040163E-03_JPRB, &
  & 0.37038903E-03_JPRB, 0.37037779E-03_JPRB, 0.37036685E-03_JPRB, 0.37035107E-03_JPRB /)

RGHG1(:,33, 7) = (/ &
  & 0.37023099E-03_JPRB, 0.37023079E-03_JPRB, 0.37023186E-03_JPRB, 0.37023405E-03_JPRB, 0.37023774E-03_JPRB, 0.37024362E-03_JPRB, &
  & 0.37025259E-03_JPRB, 0.37026600E-03_JPRB, 0.37028472E-03_JPRB, 0.37030925E-03_JPRB, 0.37033958E-03_JPRB, 0.37037540E-03_JPRB, &
  & 0.37041595E-03_JPRB, 0.37045978E-03_JPRB, 0.37050576E-03_JPRB, 0.37055238E-03_JPRB, 0.37059831E-03_JPRB, 0.37064176E-03_JPRB, &
  & 0.37068152E-03_JPRB, 0.37071679E-03_JPRB, 0.37074677E-03_JPRB, 0.37077107E-03_JPRB, 0.37079028E-03_JPRB, 0.37080509E-03_JPRB, &
  & 0.37081703E-03_JPRB, 0.37082733E-03_JPRB, 0.37083746E-03_JPRB, 0.37084866E-03_JPRB, 0.37086135E-03_JPRB, 0.37087555E-03_JPRB, &
  & 0.37089046E-03_JPRB, 0.37090416E-03_JPRB, 0.37091546E-03_JPRB, 0.37092308E-03_JPRB, 0.37092654E-03_JPRB, 0.37092596E-03_JPRB, &
  & 0.37092116E-03_JPRB, 0.37091260E-03_JPRB, 0.37090018E-03_JPRB, 0.37088396E-03_JPRB, 0.37086406E-03_JPRB, 0.37084086E-03_JPRB, &
  & 0.37081540E-03_JPRB, 0.37078903E-03_JPRB, 0.37076199E-03_JPRB, 0.37073542E-03_JPRB, 0.37070957E-03_JPRB, 0.37068519E-03_JPRB, &
  & 0.37066187E-03_JPRB, 0.37063885E-03_JPRB, 0.37061650E-03_JPRB, 0.37059473E-03_JPRB, 0.37057389E-03_JPRB, 0.37055384E-03_JPRB, &
  & 0.37053484E-03_JPRB, 0.37051665E-03_JPRB, 0.37049959E-03_JPRB, 0.37048355E-03_JPRB, 0.37046886E-03_JPRB, 0.37045573E-03_JPRB, &
  & 0.37044412E-03_JPRB, 0.37043364E-03_JPRB, 0.37042346E-03_JPRB, 0.37040855E-03_JPRB /)

RGHG1(:,34, 7) = (/ &
  & 0.37027820E-03_JPRB, 0.37027983E-03_JPRB, 0.37028201E-03_JPRB, 0.37028536E-03_JPRB, 0.37029022E-03_JPRB, 0.37029717E-03_JPRB, &
  & 0.37030724E-03_JPRB, 0.37032162E-03_JPRB, 0.37034095E-03_JPRB, 0.37036528E-03_JPRB, 0.37039514E-03_JPRB, 0.37042986E-03_JPRB, &
  & 0.37046848E-03_JPRB, 0.37051036E-03_JPRB, 0.37055404E-03_JPRB, 0.37059828E-03_JPRB, 0.37064168E-03_JPRB, 0.37068315E-03_JPRB, &
  & 0.37072127E-03_JPRB, 0.37075501E-03_JPRB, 0.37078370E-03_JPRB, 0.37080678E-03_JPRB, 0.37082483E-03_JPRB, 0.37083862E-03_JPRB, &
  & 0.37084936E-03_JPRB, 0.37085818E-03_JPRB, 0.37086685E-03_JPRB, 0.37087628E-03_JPRB, 0.37088688E-03_JPRB, 0.37089878E-03_JPRB, &
  & 0.37091115E-03_JPRB, 0.37092279E-03_JPRB, 0.37093210E-03_JPRB, 0.37093824E-03_JPRB, 0.37094083E-03_JPRB, 0.37093996E-03_JPRB, &
  & 0.37093571E-03_JPRB, 0.37092814E-03_JPRB, 0.37091726E-03_JPRB, 0.37090306E-03_JPRB, 0.37088548E-03_JPRB, 0.37086496E-03_JPRB, &
  & 0.37084252E-03_JPRB, 0.37081871E-03_JPRB, 0.37079465E-03_JPRB, 0.37077026E-03_JPRB, 0.37074625E-03_JPRB, 0.37072305E-03_JPRB, &
  & 0.37070087E-03_JPRB, 0.37067881E-03_JPRB, 0.37065730E-03_JPRB, 0.37063650E-03_JPRB, 0.37061656E-03_JPRB, 0.37059758E-03_JPRB, &
  & 0.37057960E-03_JPRB, 0.37056248E-03_JPRB, 0.37054651E-03_JPRB, 0.37053166E-03_JPRB, 0.37051807E-03_JPRB, 0.37050585E-03_JPRB, &
  & 0.37049505E-03_JPRB, 0.37048536E-03_JPRB, 0.37047570E-03_JPRB, 0.37046141E-03_JPRB /)

RGHG1(:,35, 7) = (/ &
  & 0.37032194E-03_JPRB, 0.37032517E-03_JPRB, 0.37032843E-03_JPRB, 0.37033274E-03_JPRB, 0.37033853E-03_JPRB, 0.37034653E-03_JPRB, &
  & 0.37035751E-03_JPRB, 0.37037244E-03_JPRB, 0.37039173E-03_JPRB, 0.37041563E-03_JPRB, 0.37044435E-03_JPRB, 0.37047753E-03_JPRB, &
  & 0.37051429E-03_JPRB, 0.37055372E-03_JPRB, 0.37059517E-03_JPRB, 0.37063725E-03_JPRB, 0.37067881E-03_JPRB, 0.37071819E-03_JPRB, &
  & 0.37075483E-03_JPRB, 0.37078743E-03_JPRB, 0.37081534E-03_JPRB, 0.37083789E-03_JPRB, 0.37085556E-03_JPRB, 0.37086886E-03_JPRB, &
  & 0.37087899E-03_JPRB, 0.37088717E-03_JPRB, 0.37089473E-03_JPRB, 0.37090271E-03_JPRB, 0.37091164E-03_JPRB, 0.37092122E-03_JPRB, &
  & 0.37093120E-03_JPRB, 0.37094051E-03_JPRB, 0.37094764E-03_JPRB, 0.37095230E-03_JPRB, 0.37095396E-03_JPRB, 0.37095282E-03_JPRB, &
  & 0.37094898E-03_JPRB, 0.37094243E-03_JPRB, 0.37093327E-03_JPRB, 0.37092122E-03_JPRB, 0.37090614E-03_JPRB, 0.37088856E-03_JPRB, &
  & 0.37086901E-03_JPRB, 0.37084828E-03_JPRB, 0.37082657E-03_JPRB, 0.37080451E-03_JPRB, 0.37078199E-03_JPRB, 0.37075966E-03_JPRB, &
  & 0.37073798E-03_JPRB, 0.37071653E-03_JPRB, 0.37069569E-03_JPRB, 0.37067564E-03_JPRB, 0.37065629E-03_JPRB, 0.37063801E-03_JPRB, &
  & 0.37062084E-03_JPRB, 0.37060471E-03_JPRB, 0.37058973E-03_JPRB, 0.37057578E-03_JPRB, 0.37056315E-03_JPRB, 0.37055183E-03_JPRB, &
  & 0.37054173E-03_JPRB, 0.37053277E-03_JPRB, 0.37052378E-03_JPRB, 0.37051039E-03_JPRB /)

RGHG1(:,36, 7) = (/ &
  & 0.37036324E-03_JPRB, 0.37036781E-03_JPRB, 0.37037203E-03_JPRB, 0.37037718E-03_JPRB, 0.37038382E-03_JPRB, 0.37039243E-03_JPRB, &
  & 0.37040398E-03_JPRB, 0.37041891E-03_JPRB, 0.37043783E-03_JPRB, 0.37046097E-03_JPRB, 0.37048830E-03_JPRB, 0.37051958E-03_JPRB, &
  & 0.37055433E-03_JPRB, 0.37059185E-03_JPRB, 0.37063108E-03_JPRB, 0.37067087E-03_JPRB, 0.37071030E-03_JPRB, 0.37074828E-03_JPRB, &
  & 0.37078361E-03_JPRB, 0.37081545E-03_JPRB, 0.37084287E-03_JPRB, 0.37086534E-03_JPRB, 0.37088280E-03_JPRB, 0.37089604E-03_JPRB, &
  & 0.37090597E-03_JPRB, 0.37091374E-03_JPRB, 0.37092069E-03_JPRB, 0.37092745E-03_JPRB, 0.37093446E-03_JPRB, 0.37094197E-03_JPRB, &
  & 0.37094959E-03_JPRB, 0.37095629E-03_JPRB, 0.37096138E-03_JPRB, 0.37096447E-03_JPRB, 0.37096543E-03_JPRB, 0.37096412E-03_JPRB, &
  & 0.37096080E-03_JPRB, 0.37095536E-03_JPRB, 0.37094788E-03_JPRB, 0.37093798E-03_JPRB, 0.37092538E-03_JPRB, 0.37091086E-03_JPRB, &
  & 0.37089424E-03_JPRB, 0.37087625E-03_JPRB, 0.37085707E-03_JPRB, 0.37083650E-03_JPRB, 0.37081525E-03_JPRB, 0.37079383E-03_JPRB, &
  & 0.37077276E-03_JPRB, 0.37075178E-03_JPRB, 0.37073114E-03_JPRB, 0.37071152E-03_JPRB, 0.37069296E-03_JPRB, 0.37067538E-03_JPRB, &
  & 0.37065896E-03_JPRB, 0.37064371E-03_JPRB, 0.37062960E-03_JPRB, 0.37061630E-03_JPRB, 0.37060431E-03_JPRB, 0.37059374E-03_JPRB, &
  & 0.37058446E-03_JPRB, 0.37057619E-03_JPRB, 0.37056784E-03_JPRB, 0.37055524E-03_JPRB /)

RGHG1(:,37, 7) = (/ &
  & 0.37040288E-03_JPRB, 0.37040879E-03_JPRB, 0.37041373E-03_JPRB, 0.37041947E-03_JPRB, 0.37042671E-03_JPRB, 0.37043585E-03_JPRB, &
  & 0.37044741E-03_JPRB, 0.37046213E-03_JPRB, 0.37048041E-03_JPRB, 0.37050247E-03_JPRB, 0.37052823E-03_JPRB, 0.37055748E-03_JPRB, &
  & 0.37059010E-03_JPRB, 0.37062520E-03_JPRB, 0.37066222E-03_JPRB, 0.37069985E-03_JPRB, 0.37073743E-03_JPRB, 0.37077384E-03_JPRB, &
  & 0.37080818E-03_JPRB, 0.37083932E-03_JPRB, 0.37086650E-03_JPRB, 0.37088897E-03_JPRB, 0.37090649E-03_JPRB, 0.37091953E-03_JPRB, &
  & 0.37092916E-03_JPRB, 0.37093635E-03_JPRB, 0.37094243E-03_JPRB, 0.37094805E-03_JPRB, 0.37095344E-03_JPRB, 0.37095894E-03_JPRB, &
  & 0.37096426E-03_JPRB, 0.37096886E-03_JPRB, 0.37097218E-03_JPRB, 0.37097407E-03_JPRB, 0.37097448E-03_JPRB, 0.37097323E-03_JPRB, &
  & 0.37097064E-03_JPRB, 0.37096624E-03_JPRB, 0.37096051E-03_JPRB, 0.37095265E-03_JPRB, 0.37094287E-03_JPRB, 0.37093097E-03_JPRB, &
  & 0.37091709E-03_JPRB, 0.37090160E-03_JPRB, 0.37088440E-03_JPRB, 0.37086575E-03_JPRB, 0.37084587E-03_JPRB, 0.37082529E-03_JPRB, &
  & 0.37080457E-03_JPRB, 0.37078385E-03_JPRB, 0.37076362E-03_JPRB, 0.37074444E-03_JPRB, 0.37072628E-03_JPRB, 0.37070955E-03_JPRB, &
  & 0.37069374E-03_JPRB, 0.37067910E-03_JPRB, 0.37066557E-03_JPRB, 0.37065308E-03_JPRB, 0.37064194E-03_JPRB, 0.37063210E-03_JPRB, &
  & 0.37062354E-03_JPRB, 0.37061592E-03_JPRB, 0.37060824E-03_JPRB, 0.37059659E-03_JPRB /)

RGHG1(:,38, 7) = (/ &
  & 0.37044185E-03_JPRB, 0.37044880E-03_JPRB, 0.37045433E-03_JPRB, 0.37046042E-03_JPRB, 0.37046801E-03_JPRB, 0.37047730E-03_JPRB, &
  & 0.37048871E-03_JPRB, 0.37050288E-03_JPRB, 0.37052011E-03_JPRB, 0.37054077E-03_JPRB, 0.37056475E-03_JPRB, 0.37059205E-03_JPRB, &
  & 0.37062255E-03_JPRB, 0.37065541E-03_JPRB, 0.37068999E-03_JPRB, 0.37072555E-03_JPRB, 0.37076109E-03_JPRB, 0.37079581E-03_JPRB, &
  & 0.37082902E-03_JPRB, 0.37085961E-03_JPRB, 0.37088641E-03_JPRB, 0.37090850E-03_JPRB, 0.37092547E-03_JPRB, 0.37093775E-03_JPRB, &
  & 0.37094642E-03_JPRB, 0.37095274E-03_JPRB, 0.37095780E-03_JPRB, 0.37096223E-03_JPRB, 0.37096624E-03_JPRB, 0.37097035E-03_JPRB, &
  & 0.37097404E-03_JPRB, 0.37097710E-03_JPRB, 0.37097931E-03_JPRB, 0.37098039E-03_JPRB, 0.37098050E-03_JPRB, 0.37097943E-03_JPRB, &
  & 0.37097742E-03_JPRB, 0.37097410E-03_JPRB, 0.37096979E-03_JPRB, 0.37096388E-03_JPRB, 0.37095640E-03_JPRB, 0.37094697E-03_JPRB, &
  & 0.37093594E-03_JPRB, 0.37092293E-03_JPRB, 0.37090806E-03_JPRB, 0.37089127E-03_JPRB, 0.37087276E-03_JPRB, 0.37085326E-03_JPRB, &
  & 0.37083303E-03_JPRB, 0.37081284E-03_JPRB, 0.37079310E-03_JPRB, 0.37077442E-03_JPRB, 0.37075678E-03_JPRB, 0.37074048E-03_JPRB, &
  & 0.37072532E-03_JPRB, 0.37071138E-03_JPRB, 0.37069843E-03_JPRB, 0.37068667E-03_JPRB, 0.37067619E-03_JPRB, 0.37066708E-03_JPRB, &
  & 0.37065937E-03_JPRB, 0.37065256E-03_JPRB, 0.37064560E-03_JPRB, 0.37063478E-03_JPRB /)

RGHG1(:,39, 7) = (/ &
  & 0.37048050E-03_JPRB, 0.37048798E-03_JPRB, 0.37049371E-03_JPRB, 0.37050011E-03_JPRB, 0.37050780E-03_JPRB, 0.37051708E-03_JPRB, &
  & 0.37052832E-03_JPRB, 0.37054170E-03_JPRB, 0.37055777E-03_JPRB, 0.37057686E-03_JPRB, 0.37059898E-03_JPRB, 0.37062430E-03_JPRB, &
  & 0.37065233E-03_JPRB, 0.37068277E-03_JPRB, 0.37071499E-03_JPRB, 0.37074817E-03_JPRB, 0.37078169E-03_JPRB, 0.37081481E-03_JPRB, &
  & 0.37084660E-03_JPRB, 0.37087619E-03_JPRB, 0.37090218E-03_JPRB, 0.37092326E-03_JPRB, 0.37093906E-03_JPRB, 0.37095021E-03_JPRB, &
  & 0.37095774E-03_JPRB, 0.37096307E-03_JPRB, 0.37096729E-03_JPRB, 0.37097087E-03_JPRB, 0.37097404E-03_JPRB, 0.37097716E-03_JPRB, &
  & 0.37097986E-03_JPRB, 0.37098202E-03_JPRB, 0.37098353E-03_JPRB, 0.37098426E-03_JPRB, 0.37098423E-03_JPRB, 0.37098324E-03_JPRB, &
  & 0.37098161E-03_JPRB, 0.37097908E-03_JPRB, 0.37097579E-03_JPRB, 0.37097128E-03_JPRB, 0.37096557E-03_JPRB, 0.37095844E-03_JPRB, &
  & 0.37094986E-03_JPRB, 0.37093961E-03_JPRB, 0.37092721E-03_JPRB, 0.37091252E-03_JPRB, 0.37089572E-03_JPRB, 0.37087745E-03_JPRB, &
  & 0.37085821E-03_JPRB, 0.37083862E-03_JPRB, 0.37081959E-03_JPRB, 0.37080151E-03_JPRB, 0.37078449E-03_JPRB, 0.37076877E-03_JPRB, &
  & 0.37075434E-03_JPRB, 0.37074089E-03_JPRB, 0.37072855E-03_JPRB, 0.37071737E-03_JPRB, 0.37070751E-03_JPRB, 0.37069910E-03_JPRB, &
  & 0.37069205E-03_JPRB, 0.37068562E-03_JPRB, 0.37067928E-03_JPRB, 0.37066982E-03_JPRB /)

RGHG1(:,40, 7) = (/ &
  & 0.37051868E-03_JPRB, 0.37052640E-03_JPRB, 0.37053227E-03_JPRB, 0.37053879E-03_JPRB, 0.37054665E-03_JPRB, 0.37055567E-03_JPRB, &
  & 0.37056633E-03_JPRB, 0.37057887E-03_JPRB, 0.37059360E-03_JPRB, 0.37061097E-03_JPRB, 0.37063126E-03_JPRB, 0.37065448E-03_JPRB, &
  & 0.37068027E-03_JPRB, 0.37070818E-03_JPRB, 0.37073786E-03_JPRB, 0.37076877E-03_JPRB, 0.37079994E-03_JPRB, 0.37083105E-03_JPRB, &
  & 0.37086132E-03_JPRB, 0.37088938E-03_JPRB, 0.37091423E-03_JPRB, 0.37093402E-03_JPRB, 0.37094846E-03_JPRB, 0.37095827E-03_JPRB, &
  & 0.37096482E-03_JPRB, 0.37096947E-03_JPRB, 0.37097308E-03_JPRB, 0.37097602E-03_JPRB, 0.37097867E-03_JPRB, 0.37098117E-03_JPRB, &
  & 0.37098321E-03_JPRB, 0.37098496E-03_JPRB, 0.37098600E-03_JPRB, 0.37098653E-03_JPRB, 0.37098641E-03_JPRB, 0.37098557E-03_JPRB, &
  & 0.37098420E-03_JPRB, 0.37098207E-03_JPRB, 0.37097954E-03_JPRB, 0.37097602E-03_JPRB, 0.37097160E-03_JPRB, 0.37096607E-03_JPRB, &
  & 0.37095949E-03_JPRB, 0.37095149E-03_JPRB, 0.37094153E-03_JPRB, 0.37092925E-03_JPRB, 0.37091447E-03_JPRB, 0.37089782E-03_JPRB, &
  & 0.37087972E-03_JPRB, 0.37086123E-03_JPRB, 0.37084299E-03_JPRB, 0.37082576E-03_JPRB, 0.37080952E-03_JPRB, 0.37079456E-03_JPRB, &
  & 0.37078053E-03_JPRB, 0.37076761E-03_JPRB, 0.37075591E-03_JPRB, 0.37074534E-03_JPRB, 0.37073620E-03_JPRB, 0.37072843E-03_JPRB, &
  & 0.37072191E-03_JPRB, 0.37071609E-03_JPRB, 0.37071039E-03_JPRB, 0.37070172E-03_JPRB /)

RGHG1(:,41, 7) = (/ &
  & 0.37055620E-03_JPRB, 0.37056397E-03_JPRB, 0.37056976E-03_JPRB, 0.37057637E-03_JPRB, 0.37058408E-03_JPRB, 0.37059298E-03_JPRB, &
  & 0.37060317E-03_JPRB, 0.37061473E-03_JPRB, 0.37062820E-03_JPRB, 0.37064395E-03_JPRB, 0.37066234E-03_JPRB, 0.37068338E-03_JPRB, &
  & 0.37070684E-03_JPRB, 0.37073239E-03_JPRB, 0.37075943E-03_JPRB, 0.37078766E-03_JPRB, 0.37081630E-03_JPRB, 0.37084532E-03_JPRB, &
  & 0.37087372E-03_JPRB, 0.37090026E-03_JPRB, 0.37092346E-03_JPRB, 0.37094188E-03_JPRB, 0.37095501E-03_JPRB, 0.37096377E-03_JPRB, &
  & 0.37096953E-03_JPRB, 0.37097366E-03_JPRB, 0.37097675E-03_JPRB, 0.37097943E-03_JPRB, 0.37098170E-03_JPRB, 0.37098373E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098673E-03_JPRB, 0.37098769E-03_JPRB, 0.37098804E-03_JPRB, 0.37098787E-03_JPRB, 0.37098717E-03_JPRB, &
  & 0.37098586E-03_JPRB, 0.37098408E-03_JPRB, 0.37098187E-03_JPRB, 0.37097896E-03_JPRB, 0.37097547E-03_JPRB, 0.37097122E-03_JPRB, &
  & 0.37096615E-03_JPRB, 0.37095987E-03_JPRB, 0.37095195E-03_JPRB, 0.37094194E-03_JPRB, 0.37092948E-03_JPRB, 0.37091461E-03_JPRB, &
  & 0.37089820E-03_JPRB, 0.37088076E-03_JPRB, 0.37086359E-03_JPRB, 0.37084721E-03_JPRB, 0.37083181E-03_JPRB, 0.37081764E-03_JPRB, &
  & 0.37080440E-03_JPRB, 0.37079217E-03_JPRB, 0.37078076E-03_JPRB, 0.37077063E-03_JPRB, 0.37076202E-03_JPRB, 0.37075486E-03_JPRB, &
  & 0.37074886E-03_JPRB, 0.37074363E-03_JPRB, 0.37073847E-03_JPRB, 0.37073062E-03_JPRB /)

RGHG1(:,42, 7) = (/ &
  & 0.37059459E-03_JPRB, 0.37060087E-03_JPRB, 0.37060631E-03_JPRB, 0.37061260E-03_JPRB, 0.37062046E-03_JPRB, 0.37062939E-03_JPRB, &
  & 0.37063909E-03_JPRB, 0.37064980E-03_JPRB, 0.37066196E-03_JPRB, 0.37067605E-03_JPRB, 0.37069246E-03_JPRB, 0.37071135E-03_JPRB, &
  & 0.37073233E-03_JPRB, 0.37075538E-03_JPRB, 0.37077992E-03_JPRB, 0.37080536E-03_JPRB, 0.37083155E-03_JPRB, 0.37085806E-03_JPRB, &
  & 0.37088431E-03_JPRB, 0.37090917E-03_JPRB, 0.37093094E-03_JPRB, 0.37094799E-03_JPRB, 0.37095996E-03_JPRB, 0.37096784E-03_JPRB, &
  & 0.37097302E-03_JPRB, 0.37097669E-03_JPRB, 0.37097945E-03_JPRB, 0.37098178E-03_JPRB, 0.37098379E-03_JPRB, 0.37098557E-03_JPRB, &
  & 0.37098699E-03_JPRB, 0.37098816E-03_JPRB, 0.37098894E-03_JPRB, 0.37098929E-03_JPRB, 0.37098903E-03_JPRB, 0.37098842E-03_JPRB, &
  & 0.37098723E-03_JPRB, 0.37098568E-03_JPRB, 0.37098370E-03_JPRB, 0.37098120E-03_JPRB, 0.37097823E-03_JPRB, 0.37097471E-03_JPRB, &
  & 0.37097067E-03_JPRB, 0.37096575E-03_JPRB, 0.37095958E-03_JPRB, 0.37095163E-03_JPRB, 0.37094136E-03_JPRB, 0.37092846E-03_JPRB, &
  & 0.37091353E-03_JPRB, 0.37089750E-03_JPRB, 0.37088149E-03_JPRB, 0.37086610E-03_JPRB, 0.37085169E-03_JPRB, 0.37083833E-03_JPRB, &
  & 0.37082593E-03_JPRB, 0.37081417E-03_JPRB, 0.37080338E-03_JPRB, 0.37079371E-03_JPRB, 0.37078562E-03_JPRB, 0.37077907E-03_JPRB, &
  & 0.37077357E-03_JPRB, 0.37076886E-03_JPRB, 0.37076412E-03_JPRB, 0.37075690E-03_JPRB /)

RGHG1(:,43, 7) = (/ &
  & 0.37062794E-03_JPRB, 0.37063551E-03_JPRB, 0.37064127E-03_JPRB, 0.37064799E-03_JPRB, 0.37065597E-03_JPRB, 0.37066490E-03_JPRB, &
  & 0.37067424E-03_JPRB, 0.37068431E-03_JPRB, 0.37069523E-03_JPRB, 0.37070771E-03_JPRB, 0.37072218E-03_JPRB, 0.37073885E-03_JPRB, &
  & 0.37075754E-03_JPRB, 0.37077800E-03_JPRB, 0.37079983E-03_JPRB, 0.37082270E-03_JPRB, 0.37084601E-03_JPRB, 0.37087008E-03_JPRB, &
  & 0.37089401E-03_JPRB, 0.37091709E-03_JPRB, 0.37093722E-03_JPRB, 0.37095291E-03_JPRB, 0.37096385E-03_JPRB, 0.37097099E-03_JPRB, &
  & 0.37097573E-03_JPRB, 0.37097902E-03_JPRB, 0.37098152E-03_JPRB, 0.37098362E-03_JPRB, 0.37098539E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098827E-03_JPRB, 0.37098923E-03_JPRB, 0.37098990E-03_JPRB, 0.37099016E-03_JPRB, 0.37098996E-03_JPRB, 0.37098938E-03_JPRB, &
  & 0.37098836E-03_JPRB, 0.37098691E-03_JPRB, 0.37098510E-03_JPRB, 0.37098292E-03_JPRB, 0.37098039E-03_JPRB, 0.37097748E-03_JPRB, &
  & 0.37097419E-03_JPRB, 0.37097020E-03_JPRB, 0.37096534E-03_JPRB, 0.37095905E-03_JPRB, 0.37095067E-03_JPRB, 0.37093982E-03_JPRB, &
  & 0.37092663E-03_JPRB, 0.37091211E-03_JPRB, 0.37089718E-03_JPRB, 0.37088286E-03_JPRB, 0.37086947E-03_JPRB, 0.37085701E-03_JPRB, &
  & 0.37084537E-03_JPRB, 0.37083428E-03_JPRB, 0.37082407E-03_JPRB, 0.37081499E-03_JPRB, 0.37080748E-03_JPRB, 0.37080146E-03_JPRB, &
  & 0.37079654E-03_JPRB, 0.37079223E-03_JPRB, 0.37078766E-03_JPRB, 0.37078091E-03_JPRB /)

RGHG1(:,44, 7) = (/ &
  & 0.37066144E-03_JPRB, 0.37066996E-03_JPRB, 0.37067581E-03_JPRB, 0.37068254E-03_JPRB, 0.37069109E-03_JPRB, 0.37070000E-03_JPRB, &
  & 0.37070917E-03_JPRB, 0.37071845E-03_JPRB, 0.37072832E-03_JPRB, 0.37073929E-03_JPRB, 0.37075192E-03_JPRB, 0.37076636E-03_JPRB, &
  & 0.37078263E-03_JPRB, 0.37080055E-03_JPRB, 0.37081979E-03_JPRB, 0.37083973E-03_JPRB, 0.37086057E-03_JPRB, 0.37088175E-03_JPRB, &
  & 0.37090317E-03_JPRB, 0.37092413E-03_JPRB, 0.37094275E-03_JPRB, 0.37095713E-03_JPRB, 0.37096709E-03_JPRB, 0.37097360E-03_JPRB, &
  & 0.37097785E-03_JPRB, 0.37098088E-03_JPRB, 0.37098315E-03_JPRB, 0.37098504E-03_JPRB, 0.37098664E-03_JPRB, 0.37098810E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37099022E-03_JPRB, 0.37099081E-03_JPRB, 0.37099098E-03_JPRB, 0.37099078E-03_JPRB, 0.37099022E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098798E-03_JPRB, 0.37098635E-03_JPRB, 0.37098440E-03_JPRB, 0.37098213E-03_JPRB, 0.37097963E-03_JPRB, &
  & 0.37097681E-03_JPRB, 0.37097366E-03_JPRB, 0.37096976E-03_JPRB, 0.37096487E-03_JPRB, 0.37095830E-03_JPRB, 0.37094933E-03_JPRB, &
  & 0.37093789E-03_JPRB, 0.37092468E-03_JPRB, 0.37091100E-03_JPRB, 0.37089785E-03_JPRB, 0.37088551E-03_JPRB, 0.37087419E-03_JPRB, &
  & 0.37086348E-03_JPRB, 0.37085311E-03_JPRB, 0.37084337E-03_JPRB, 0.37083487E-03_JPRB, 0.37082794E-03_JPRB, 0.37082244E-03_JPRB, &
  & 0.37081784E-03_JPRB, 0.37081385E-03_JPRB, 0.37080975E-03_JPRB, 0.37080341E-03_JPRB /)

RGHG1(:,45, 7) = (/ &
  & 0.37070052E-03_JPRB, 0.37070675E-03_JPRB, 0.37071155E-03_JPRB, 0.37071816E-03_JPRB, 0.37072628E-03_JPRB, 0.37073559E-03_JPRB, &
  & 0.37074427E-03_JPRB, 0.37075291E-03_JPRB, 0.37076155E-03_JPRB, 0.37077104E-03_JPRB, 0.37078181E-03_JPRB, 0.37079421E-03_JPRB, &
  & 0.37080818E-03_JPRB, 0.37082360E-03_JPRB, 0.37084013E-03_JPRB, 0.37085751E-03_JPRB, 0.37087518E-03_JPRB, 0.37089357E-03_JPRB, &
  & 0.37091237E-03_JPRB, 0.37093117E-03_JPRB, 0.37094782E-03_JPRB, 0.37096089E-03_JPRB, 0.37096988E-03_JPRB, 0.37097582E-03_JPRB, &
  & 0.37097969E-03_JPRB, 0.37098236E-03_JPRB, 0.37098437E-03_JPRB, 0.37098618E-03_JPRB, 0.37098769E-03_JPRB, 0.37098903E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37099098E-03_JPRB, 0.37099156E-03_JPRB, 0.37099174E-03_JPRB, 0.37099156E-03_JPRB, 0.37099101E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37098894E-03_JPRB, 0.37098743E-03_JPRB, 0.37098568E-03_JPRB, 0.37098370E-03_JPRB, 0.37098149E-03_JPRB, &
  & 0.37097908E-03_JPRB, 0.37097643E-03_JPRB, 0.37097331E-03_JPRB, 0.37096950E-03_JPRB, 0.37096435E-03_JPRB, 0.37095725E-03_JPRB, &
  & 0.37094767E-03_JPRB, 0.37093606E-03_JPRB, 0.37092358E-03_JPRB, 0.37091144E-03_JPRB, 0.37090032E-03_JPRB, 0.37089005E-03_JPRB, &
  & 0.37088027E-03_JPRB, 0.37087098E-03_JPRB, 0.37086205E-03_JPRB, 0.37085428E-03_JPRB, 0.37084785E-03_JPRB, 0.37084281E-03_JPRB, &
  & 0.37083856E-03_JPRB, 0.37083487E-03_JPRB, 0.37083097E-03_JPRB, 0.37082474E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART14',0,ZHOOK_HANDLE)



RGHG1(:,46, 7) = (/ &
  & 0.37073120E-03_JPRB, 0.37074083E-03_JPRB, 0.37074718E-03_JPRB, 0.37075378E-03_JPRB, 0.37076272E-03_JPRB, 0.37077162E-03_JPRB, &
  & 0.37078041E-03_JPRB, 0.37078804E-03_JPRB, 0.37079566E-03_JPRB, 0.37080367E-03_JPRB, 0.37081272E-03_JPRB, 0.37082296E-03_JPRB, &
  & 0.37083460E-03_JPRB, 0.37084761E-03_JPRB, 0.37086141E-03_JPRB, 0.37087576E-03_JPRB, 0.37089069E-03_JPRB, 0.37090611E-03_JPRB, &
  & 0.37092227E-03_JPRB, 0.37093807E-03_JPRB, 0.37095271E-03_JPRB, 0.37096420E-03_JPRB, 0.37097227E-03_JPRB, 0.37097762E-03_JPRB, &
  & 0.37098120E-03_JPRB, 0.37098373E-03_JPRB, 0.37098554E-03_JPRB, 0.37098723E-03_JPRB, 0.37098865E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099165E-03_JPRB, 0.37099223E-03_JPRB, 0.37099241E-03_JPRB, 0.37099229E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099101E-03_JPRB, 0.37098982E-03_JPRB, 0.37098845E-03_JPRB, 0.37098685E-03_JPRB, 0.37098496E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098085E-03_JPRB, 0.37097864E-03_JPRB, 0.37097622E-03_JPRB, 0.37097328E-03_JPRB, 0.37096936E-03_JPRB, 0.37096385E-03_JPRB, &
  & 0.37095626E-03_JPRB, 0.37094639E-03_JPRB, 0.37093554E-03_JPRB, 0.37092474E-03_JPRB, 0.37091467E-03_JPRB, 0.37090547E-03_JPRB, &
  & 0.37089677E-03_JPRB, 0.37088839E-03_JPRB, 0.37088041E-03_JPRB, 0.37087325E-03_JPRB, 0.37086738E-03_JPRB, 0.37086272E-03_JPRB, &
  & 0.37085888E-03_JPRB, 0.37085547E-03_JPRB, 0.37085183E-03_JPRB, 0.37084572E-03_JPRB /)

RGHG1(:,47, 7) = (/ &
  & 0.37077267E-03_JPRB, 0.37077998E-03_JPRB, 0.37078522E-03_JPRB, 0.37079206E-03_JPRB, 0.37080047E-03_JPRB, 0.37080998E-03_JPRB, &
  & 0.37081804E-03_JPRB, 0.37082520E-03_JPRB, 0.37083152E-03_JPRB, 0.37083798E-03_JPRB, 0.37084502E-03_JPRB, 0.37085323E-03_JPRB, &
  & 0.37086254E-03_JPRB, 0.37087279E-03_JPRB, 0.37088379E-03_JPRB, 0.37089526E-03_JPRB, 0.37090704E-03_JPRB, 0.37091953E-03_JPRB, &
  & 0.37093222E-03_JPRB, 0.37094523E-03_JPRB, 0.37095725E-03_JPRB, 0.37096711E-03_JPRB, 0.37097425E-03_JPRB, 0.37097905E-03_JPRB, &
  & 0.37098234E-03_JPRB, 0.37098469E-03_JPRB, 0.37098647E-03_JPRB, 0.37098804E-03_JPRB, 0.37098938E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099226E-03_JPRB, 0.37099276E-03_JPRB, 0.37099296E-03_JPRB, 0.37099284E-03_JPRB, 0.37099246E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099063E-03_JPRB, 0.37098941E-03_JPRB, 0.37098781E-03_JPRB, 0.37098618E-03_JPRB, 0.37098437E-03_JPRB, &
  & 0.37098242E-03_JPRB, 0.37098047E-03_JPRB, 0.37097847E-03_JPRB, 0.37097611E-03_JPRB, 0.37097320E-03_JPRB, 0.37096924E-03_JPRB, &
  & 0.37096342E-03_JPRB, 0.37095579E-03_JPRB, 0.37094677E-03_JPRB, 0.37093757E-03_JPRB, 0.37092884E-03_JPRB, 0.37092087E-03_JPRB, &
  & 0.37091333E-03_JPRB, 0.37090605E-03_JPRB, 0.37089901E-03_JPRB, 0.37089267E-03_JPRB, 0.37088731E-03_JPRB, 0.37088300E-03_JPRB, &
  & 0.37087948E-03_JPRB, 0.37087617E-03_JPRB, 0.37087253E-03_JPRB, 0.37086662E-03_JPRB /)

RGHG1(:,48, 7) = (/ &
  & 0.37080550E-03_JPRB, 0.37081589E-03_JPRB, 0.37082320E-03_JPRB, 0.37083108E-03_JPRB, 0.37084089E-03_JPRB, 0.37085018E-03_JPRB, &
  & 0.37085812E-03_JPRB, 0.37086417E-03_JPRB, 0.37086933E-03_JPRB, 0.37087413E-03_JPRB, 0.37087916E-03_JPRB, 0.37088519E-03_JPRB, &
  & 0.37089200E-03_JPRB, 0.37089959E-03_JPRB, 0.37090771E-03_JPRB, 0.37091604E-03_JPRB, 0.37092471E-03_JPRB, 0.37093353E-03_JPRB, &
  & 0.37094284E-03_JPRB, 0.37095236E-03_JPRB, 0.37096167E-03_JPRB, 0.37096979E-03_JPRB, 0.37097599E-03_JPRB, 0.37098027E-03_JPRB, &
  & 0.37098327E-03_JPRB, 0.37098545E-03_JPRB, 0.37098717E-03_JPRB, 0.37098862E-03_JPRB, 0.37098990E-03_JPRB, 0.37099107E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099273E-03_JPRB, 0.37099328E-03_JPRB, 0.37099351E-03_JPRB, 0.37099337E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37099136E-03_JPRB, 0.37099014E-03_JPRB, 0.37098874E-03_JPRB, 0.37098728E-03_JPRB, 0.37098562E-03_JPRB, &
  & 0.37098373E-03_JPRB, 0.37098202E-03_JPRB, 0.37098033E-03_JPRB, 0.37097849E-03_JPRB, 0.37097634E-03_JPRB, 0.37097343E-03_JPRB, &
  & 0.37096950E-03_JPRB, 0.37096418E-03_JPRB, 0.37095771E-03_JPRB, 0.37095055E-03_JPRB, 0.37094363E-03_JPRB, 0.37093705E-03_JPRB, &
  & 0.37093082E-03_JPRB, 0.37092459E-03_JPRB, 0.37091842E-03_JPRB, 0.37091266E-03_JPRB, 0.37090771E-03_JPRB, 0.37090373E-03_JPRB, &
  & 0.37090032E-03_JPRB, 0.37089706E-03_JPRB, 0.37089354E-03_JPRB, 0.37088763E-03_JPRB /)

RGHG1(:,49, 7) = (/ &
  & 0.37083897E-03_JPRB, 0.37085149E-03_JPRB, 0.37085984E-03_JPRB, 0.37086895E-03_JPRB, 0.37087937E-03_JPRB, 0.37088949E-03_JPRB, &
  & 0.37089689E-03_JPRB, 0.37090224E-03_JPRB, 0.37090623E-03_JPRB, 0.37090958E-03_JPRB, 0.37091307E-03_JPRB, 0.37091703E-03_JPRB, &
  & 0.37092151E-03_JPRB, 0.37092657E-03_JPRB, 0.37093187E-03_JPRB, 0.37093705E-03_JPRB, 0.37094226E-03_JPRB, 0.37094750E-03_JPRB, &
  & 0.37095306E-03_JPRB, 0.37095905E-03_JPRB, 0.37096563E-03_JPRB, 0.37097200E-03_JPRB, 0.37097733E-03_JPRB, 0.37098129E-03_JPRB, &
  & 0.37098405E-03_JPRB, 0.37098612E-03_JPRB, 0.37098784E-03_JPRB, 0.37098929E-03_JPRB, 0.37099054E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099252E-03_JPRB, 0.37099319E-03_JPRB, 0.37099372E-03_JPRB, 0.37099401E-03_JPRB, 0.37099392E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099302E-03_JPRB, 0.37099209E-03_JPRB, 0.37099092E-03_JPRB, 0.37098961E-03_JPRB, 0.37098816E-03_JPRB, 0.37098667E-03_JPRB, &
  & 0.37098496E-03_JPRB, 0.37098333E-03_JPRB, 0.37098187E-03_JPRB, 0.37098042E-03_JPRB, 0.37097879E-03_JPRB, 0.37097672E-03_JPRB, &
  & 0.37097425E-03_JPRB, 0.37097101E-03_JPRB, 0.37096703E-03_JPRB, 0.37096266E-03_JPRB, 0.37095795E-03_JPRB, 0.37095329E-03_JPRB, &
  & 0.37094866E-03_JPRB, 0.37094357E-03_JPRB, 0.37093827E-03_JPRB, 0.37093303E-03_JPRB, 0.37092846E-03_JPRB, 0.37092468E-03_JPRB, &
  & 0.37092145E-03_JPRB, 0.37091842E-03_JPRB, 0.37091496E-03_JPRB, 0.37090908E-03_JPRB /)

RGHG1(:,50, 7) = (/ &
  & 0.37087317E-03_JPRB, 0.37088443E-03_JPRB, 0.37089220E-03_JPRB, 0.37090096E-03_JPRB, 0.37091121E-03_JPRB, 0.37092078E-03_JPRB, &
  & 0.37092736E-03_JPRB, 0.37093175E-03_JPRB, 0.37093466E-03_JPRB, 0.37093720E-03_JPRB, 0.37093950E-03_JPRB, 0.37094211E-03_JPRB, &
  & 0.37094502E-03_JPRB, 0.37094817E-03_JPRB, 0.37095119E-03_JPRB, 0.37095405E-03_JPRB, 0.37095664E-03_JPRB, 0.37095905E-03_JPRB, &
  & 0.37096167E-03_JPRB, 0.37096514E-03_JPRB, 0.37096912E-03_JPRB, 0.37097401E-03_JPRB, 0.37097849E-03_JPRB, 0.37098213E-03_JPRB, &
  & 0.37098472E-03_JPRB, 0.37098670E-03_JPRB, 0.37098833E-03_JPRB, 0.37098973E-03_JPRB, 0.37099089E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099360E-03_JPRB, 0.37099421E-03_JPRB, 0.37099441E-03_JPRB, 0.37099441E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099267E-03_JPRB, 0.37099156E-03_JPRB, 0.37099037E-03_JPRB, 0.37098903E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098592E-03_JPRB, 0.37098443E-03_JPRB, 0.37098312E-03_JPRB, 0.37098199E-03_JPRB, 0.37098074E-03_JPRB, 0.37097937E-03_JPRB, &
  & 0.37097777E-03_JPRB, 0.37097587E-03_JPRB, 0.37097384E-03_JPRB, 0.37097163E-03_JPRB, 0.37096927E-03_JPRB, 0.37096674E-03_JPRB, &
  & 0.37096385E-03_JPRB, 0.37096068E-03_JPRB, 0.37095681E-03_JPRB, 0.37095274E-03_JPRB, 0.37094898E-03_JPRB, 0.37094567E-03_JPRB, &
  & 0.37094264E-03_JPRB, 0.37093973E-03_JPRB, 0.37093629E-03_JPRB, 0.37093018E-03_JPRB /)

RGHG1(:,51, 7) = (/ &
  & 0.37089939E-03_JPRB, 0.37091004E-03_JPRB, 0.37091709E-03_JPRB, 0.37092448E-03_JPRB, 0.37093333E-03_JPRB, 0.37094124E-03_JPRB, &
  & 0.37094665E-03_JPRB, 0.37094980E-03_JPRB, 0.37095207E-03_JPRB, 0.37095376E-03_JPRB, 0.37095544E-03_JPRB, 0.37095719E-03_JPRB, &
  & 0.37095923E-03_JPRB, 0.37096135E-03_JPRB, 0.37096316E-03_JPRB, 0.37096464E-03_JPRB, 0.37096583E-03_JPRB, 0.37096691E-03_JPRB, &
  & 0.37096813E-03_JPRB, 0.37096970E-03_JPRB, 0.37097227E-03_JPRB, 0.37097561E-03_JPRB, 0.37097948E-03_JPRB, 0.37098274E-03_JPRB, &
  & 0.37098522E-03_JPRB, 0.37098717E-03_JPRB, 0.37098874E-03_JPRB, 0.37099014E-03_JPRB, 0.37099124E-03_JPRB, 0.37099229E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099404E-03_JPRB, 0.37099459E-03_JPRB, 0.37099479E-03_JPRB, 0.37099485E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099406E-03_JPRB, 0.37099316E-03_JPRB, 0.37099214E-03_JPRB, 0.37099107E-03_JPRB, 0.37098976E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37098688E-03_JPRB, 0.37098554E-03_JPRB, 0.37098434E-03_JPRB, 0.37098330E-03_JPRB, 0.37098231E-03_JPRB, 0.37098135E-03_JPRB, &
  & 0.37098030E-03_JPRB, 0.37097919E-03_JPRB, 0.37097814E-03_JPRB, 0.37097710E-03_JPRB, 0.37097608E-03_JPRB, 0.37097497E-03_JPRB, &
  & 0.37097372E-03_JPRB, 0.37097209E-03_JPRB, 0.37097017E-03_JPRB, 0.37096799E-03_JPRB, 0.37096569E-03_JPRB, 0.37096359E-03_JPRB, &
  & 0.37096138E-03_JPRB, 0.37095911E-03_JPRB, 0.37095614E-03_JPRB, 0.37095023E-03_JPRB /)

RGHG1(:,52, 7) = (/ &
  & 0.37092404E-03_JPRB, 0.37093094E-03_JPRB, 0.37093583E-03_JPRB, 0.37094144E-03_JPRB, 0.37094805E-03_JPRB, 0.37095422E-03_JPRB, &
  & 0.37095806E-03_JPRB, 0.37096048E-03_JPRB, 0.37096190E-03_JPRB, 0.37096316E-03_JPRB, 0.37096429E-03_JPRB, 0.37096554E-03_JPRB, &
  & 0.37096697E-03_JPRB, 0.37096842E-03_JPRB, 0.37096976E-03_JPRB, 0.37097075E-03_JPRB, 0.37097142E-03_JPRB, 0.37097203E-03_JPRB, &
  & 0.37097253E-03_JPRB, 0.37097343E-03_JPRB, 0.37097477E-03_JPRB, 0.37097730E-03_JPRB, 0.37098024E-03_JPRB, 0.37098327E-03_JPRB, &
  & 0.37098571E-03_JPRB, 0.37098757E-03_JPRB, 0.37098912E-03_JPRB, 0.37099051E-03_JPRB, 0.37099165E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099433E-03_JPRB, 0.37099503E-03_JPRB, 0.37099511E-03_JPRB, 0.37099523E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099363E-03_JPRB, 0.37099270E-03_JPRB, 0.37099165E-03_JPRB, 0.37099043E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098653E-03_JPRB, 0.37098545E-03_JPRB, 0.37098452E-03_JPRB, 0.37098373E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098225E-03_JPRB, 0.37098164E-03_JPRB, 0.37098108E-03_JPRB, 0.37098053E-03_JPRB, 0.37098007E-03_JPRB, 0.37097960E-03_JPRB, &
  & 0.37097913E-03_JPRB, 0.37097852E-03_JPRB, 0.37097771E-03_JPRB, 0.37097675E-03_JPRB, 0.37097576E-03_JPRB, 0.37097477E-03_JPRB, &
  & 0.37097375E-03_JPRB, 0.37097247E-03_JPRB, 0.37097052E-03_JPRB, 0.37096607E-03_JPRB /)

RGHG1(:,53, 7) = (/ &
  & 0.37093961E-03_JPRB, 0.37094526E-03_JPRB, 0.37094904E-03_JPRB, 0.37095312E-03_JPRB, 0.37095803E-03_JPRB, 0.37096237E-03_JPRB, &
  & 0.37096537E-03_JPRB, 0.37096697E-03_JPRB, 0.37096810E-03_JPRB, 0.37096892E-03_JPRB, 0.37096973E-03_JPRB, 0.37097061E-03_JPRB, &
  & 0.37097168E-03_JPRB, 0.37097288E-03_JPRB, 0.37097384E-03_JPRB, 0.37097448E-03_JPRB, 0.37097494E-03_JPRB, 0.37097523E-03_JPRB, &
  & 0.37097553E-03_JPRB, 0.37097599E-03_JPRB, 0.37097698E-03_JPRB, 0.37097849E-03_JPRB, 0.37098103E-03_JPRB, 0.37098376E-03_JPRB, &
  & 0.37098615E-03_JPRB, 0.37098798E-03_JPRB, 0.37098950E-03_JPRB, 0.37099081E-03_JPRB, 0.37099197E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099389E-03_JPRB, 0.37099468E-03_JPRB, 0.37099535E-03_JPRB, 0.37099549E-03_JPRB, 0.37099555E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099491E-03_JPRB, 0.37099418E-03_JPRB, 0.37099328E-03_JPRB, 0.37099226E-03_JPRB, 0.37099113E-03_JPRB, 0.37098993E-03_JPRB, &
  & 0.37098853E-03_JPRB, 0.37098740E-03_JPRB, 0.37098635E-03_JPRB, 0.37098557E-03_JPRB, 0.37098481E-03_JPRB, 0.37098423E-03_JPRB, &
  & 0.37098379E-03_JPRB, 0.37098344E-03_JPRB, 0.37098315E-03_JPRB, 0.37098289E-03_JPRB, 0.37098263E-03_JPRB, 0.37098239E-03_JPRB, &
  & 0.37098222E-03_JPRB, 0.37098193E-03_JPRB, 0.37098158E-03_JPRB, 0.37098123E-03_JPRB, 0.37098082E-03_JPRB, 0.37098042E-03_JPRB, &
  & 0.37097995E-03_JPRB, 0.37097934E-03_JPRB, 0.37097847E-03_JPRB, 0.37097631E-03_JPRB /)

RGHG1(:,54, 7) = (/ &
  & 0.37095285E-03_JPRB, 0.37095632E-03_JPRB, 0.37095882E-03_JPRB, 0.37096161E-03_JPRB, 0.37096499E-03_JPRB, 0.37096808E-03_JPRB, &
  & 0.37097008E-03_JPRB, 0.37097131E-03_JPRB, 0.37097209E-03_JPRB, 0.37097267E-03_JPRB, 0.37097326E-03_JPRB, 0.37097395E-03_JPRB, &
  & 0.37097477E-03_JPRB, 0.37097570E-03_JPRB, 0.37097640E-03_JPRB, 0.37097686E-03_JPRB, 0.37097727E-03_JPRB, 0.37097756E-03_JPRB, &
  & 0.37097782E-03_JPRB, 0.37097820E-03_JPRB, 0.37097870E-03_JPRB, 0.37097992E-03_JPRB, 0.37098181E-03_JPRB, 0.37098429E-03_JPRB, &
  & 0.37098656E-03_JPRB, 0.37098830E-03_JPRB, 0.37098979E-03_JPRB, 0.37099104E-03_JPRB, 0.37099226E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099497E-03_JPRB, 0.37099561E-03_JPRB, 0.37099581E-03_JPRB, 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099473E-03_JPRB, 0.37099386E-03_JPRB, 0.37099293E-03_JPRB, 0.37099177E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098819E-03_JPRB, 0.37098723E-03_JPRB, 0.37098641E-03_JPRB, 0.37098577E-03_JPRB, 0.37098530E-03_JPRB, &
  & 0.37098498E-03_JPRB, 0.37098469E-03_JPRB, 0.37098449E-03_JPRB, 0.37098431E-03_JPRB, 0.37098426E-03_JPRB, 0.37098420E-03_JPRB, &
  & 0.37098405E-03_JPRB, 0.37098391E-03_JPRB, 0.37098382E-03_JPRB, 0.37098367E-03_JPRB, 0.37098350E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098315E-03_JPRB, 0.37098292E-03_JPRB, 0.37098271E-03_JPRB, 0.37098266E-03_JPRB /)

RGHG1(:,55, 7) = (/ &
  & 0.37096132E-03_JPRB, 0.37096406E-03_JPRB, 0.37096586E-03_JPRB, 0.37096778E-03_JPRB, 0.37097008E-03_JPRB, 0.37097221E-03_JPRB, &
  & 0.37097372E-03_JPRB, 0.37097454E-03_JPRB, 0.37097509E-03_JPRB, 0.37097550E-03_JPRB, 0.37097593E-03_JPRB, 0.37097646E-03_JPRB, &
  & 0.37097710E-03_JPRB, 0.37097780E-03_JPRB, 0.37097838E-03_JPRB, 0.37097884E-03_JPRB, 0.37097916E-03_JPRB, 0.37097934E-03_JPRB, &
  & 0.37097951E-03_JPRB, 0.37097972E-03_JPRB, 0.37098018E-03_JPRB, 0.37098097E-03_JPRB, 0.37098263E-03_JPRB, 0.37098478E-03_JPRB, &
  & 0.37098696E-03_JPRB, 0.37098868E-03_JPRB, 0.37099008E-03_JPRB, 0.37099136E-03_JPRB, 0.37099249E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099520E-03_JPRB, 0.37099587E-03_JPRB, 0.37099616E-03_JPRB, 0.37099622E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099514E-03_JPRB, 0.37099433E-03_JPRB, 0.37099334E-03_JPRB, 0.37099229E-03_JPRB, 0.37099118E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098888E-03_JPRB, 0.37098810E-03_JPRB, 0.37098725E-03_JPRB, 0.37098664E-03_JPRB, 0.37098626E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098583E-03_JPRB, 0.37098565E-03_JPRB, 0.37098557E-03_JPRB, 0.37098548E-03_JPRB, 0.37098542E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098533E-03_JPRB, 0.37098525E-03_JPRB, 0.37098513E-03_JPRB, 0.37098501E-03_JPRB, 0.37098490E-03_JPRB, &
  & 0.37098481E-03_JPRB, 0.37098466E-03_JPRB, 0.37098455E-03_JPRB, 0.37098440E-03_JPRB /)

RGHG1(:,56, 7) = (/ &
  & 0.37096819E-03_JPRB, 0.37096994E-03_JPRB, 0.37097110E-03_JPRB, 0.37097238E-03_JPRB, 0.37097395E-03_JPRB, 0.37097541E-03_JPRB, &
  & 0.37097640E-03_JPRB, 0.37097704E-03_JPRB, 0.37097739E-03_JPRB, 0.37097774E-03_JPRB, 0.37097809E-03_JPRB, 0.37097844E-03_JPRB, &
  & 0.37097896E-03_JPRB, 0.37097954E-03_JPRB, 0.37098001E-03_JPRB, 0.37098042E-03_JPRB, 0.37098068E-03_JPRB, 0.37098088E-03_JPRB, &
  & 0.37098100E-03_JPRB, 0.37098123E-03_JPRB, 0.37098149E-03_JPRB, 0.37098222E-03_JPRB, 0.37098350E-03_JPRB, 0.37098539E-03_JPRB, &
  & 0.37098734E-03_JPRB, 0.37098909E-03_JPRB, 0.37099037E-03_JPRB, 0.37099159E-03_JPRB, 0.37099270E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099552E-03_JPRB, 0.37099613E-03_JPRB, 0.37099645E-03_JPRB, 0.37099660E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099619E-03_JPRB, 0.37099558E-03_JPRB, 0.37099482E-03_JPRB, 0.37099380E-03_JPRB, 0.37099276E-03_JPRB, 0.37099185E-03_JPRB, &
  & 0.37099066E-03_JPRB, 0.37098967E-03_JPRB, 0.37098891E-03_JPRB, 0.37098816E-03_JPRB, 0.37098766E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098702E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, 0.37098653E-03_JPRB, 0.37098650E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098635E-03_JPRB, 0.37098629E-03_JPRB, 0.37098626E-03_JPRB, 0.37098621E-03_JPRB, 0.37098615E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098597E-03_JPRB, 0.37098589E-03_JPRB, 0.37098580E-03_JPRB /)

RGHG1(:,57, 7) = (/ &
  & 0.37097262E-03_JPRB, 0.37097395E-03_JPRB, 0.37097483E-03_JPRB, 0.37097570E-03_JPRB, 0.37097672E-03_JPRB, 0.37097777E-03_JPRB, &
  & 0.37097849E-03_JPRB, 0.37097896E-03_JPRB, 0.37097928E-03_JPRB, 0.37097954E-03_JPRB, 0.37097980E-03_JPRB, 0.37098012E-03_JPRB, &
  & 0.37098047E-03_JPRB, 0.37098091E-03_JPRB, 0.37098129E-03_JPRB, 0.37098164E-03_JPRB, 0.37098187E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098228E-03_JPRB, 0.37098239E-03_JPRB, 0.37098269E-03_JPRB, 0.37098315E-03_JPRB, 0.37098429E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098929E-03_JPRB, 0.37099072E-03_JPRB, 0.37099194E-03_JPRB, 0.37099302E-03_JPRB, 0.37099406E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099578E-03_JPRB, 0.37099642E-03_JPRB, 0.37099686E-03_JPRB, 0.37099689E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099599E-03_JPRB, 0.37099526E-03_JPRB, 0.37099424E-03_JPRB, 0.37099331E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099043E-03_JPRB, 0.37098967E-03_JPRB, 0.37098903E-03_JPRB, 0.37098853E-03_JPRB, 0.37098807E-03_JPRB, &
  & 0.37098784E-03_JPRB, 0.37098760E-03_JPRB, 0.37098752E-03_JPRB, 0.37098743E-03_JPRB, 0.37098737E-03_JPRB, 0.37098737E-03_JPRB, &
  & 0.37098731E-03_JPRB, 0.37098728E-03_JPRB, 0.37098723E-03_JPRB, 0.37098708E-03_JPRB, 0.37098699E-03_JPRB, 0.37098693E-03_JPRB, &
  & 0.37098688E-03_JPRB, 0.37098679E-03_JPRB, 0.37098676E-03_JPRB, 0.37098664E-03_JPRB /)

RGHG1(:,58, 7) = (/ &
  & 0.37097622E-03_JPRB, 0.37097710E-03_JPRB, 0.37097771E-03_JPRB, 0.37097832E-03_JPRB, 0.37097908E-03_JPRB, 0.37097977E-03_JPRB, &
  & 0.37098027E-03_JPRB, 0.37098059E-03_JPRB, 0.37098076E-03_JPRB, 0.37098094E-03_JPRB, 0.37098117E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098222E-03_JPRB, 0.37098257E-03_JPRB, 0.37098292E-03_JPRB, 0.37098315E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098344E-03_JPRB, 0.37098350E-03_JPRB, 0.37098370E-03_JPRB, 0.37098417E-03_JPRB, 0.37098516E-03_JPRB, 0.37098664E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098961E-03_JPRB, 0.37099101E-03_JPRB, 0.37099223E-03_JPRB, 0.37099328E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099596E-03_JPRB, 0.37099665E-03_JPRB, 0.37099715E-03_JPRB, 0.37099721E-03_JPRB, 0.37099703E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099642E-03_JPRB, 0.37099572E-03_JPRB, 0.37099471E-03_JPRB, 0.37099383E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099200E-03_JPRB, 0.37099110E-03_JPRB, 0.37099046E-03_JPRB, 0.37098979E-03_JPRB, 0.37098941E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098853E-03_JPRB, 0.37098836E-03_JPRB, 0.37098821E-03_JPRB, 0.37098816E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098810E-03_JPRB, 0.37098810E-03_JPRB, 0.37098798E-03_JPRB, 0.37098792E-03_JPRB, 0.37098787E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098769E-03_JPRB, 0.37098757E-03_JPRB, 0.37098743E-03_JPRB /)

RGHG1(:,59, 7) = (/ &
  & 0.37097876E-03_JPRB, 0.37097948E-03_JPRB, 0.37097995E-03_JPRB, 0.37098036E-03_JPRB, 0.37098085E-03_JPRB, 0.37098132E-03_JPRB, &
  & 0.37098167E-03_JPRB, 0.37098193E-03_JPRB, 0.37098210E-03_JPRB, 0.37098228E-03_JPRB, 0.37098245E-03_JPRB, 0.37098263E-03_JPRB, &
  & 0.37098286E-03_JPRB, 0.37098327E-03_JPRB, 0.37098362E-03_JPRB, 0.37098399E-03_JPRB, 0.37098423E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098455E-03_JPRB, 0.37098466E-03_JPRB, 0.37098481E-03_JPRB, 0.37098504E-03_JPRB, 0.37098597E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37099005E-03_JPRB, 0.37099142E-03_JPRB, 0.37099258E-03_JPRB, 0.37099357E-03_JPRB, 0.37099459E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099625E-03_JPRB, 0.37099698E-03_JPRB, 0.37099744E-03_JPRB, 0.37099753E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099718E-03_JPRB, 0.37099680E-03_JPRB, 0.37099619E-03_JPRB, 0.37099514E-03_JPRB, 0.37099433E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099177E-03_JPRB, 0.37099110E-03_JPRB, 0.37099057E-03_JPRB, 0.37099022E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37098961E-03_JPRB, 0.37098935E-03_JPRB, 0.37098920E-03_JPRB, 0.37098909E-03_JPRB, 0.37098903E-03_JPRB, 0.37098891E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098868E-03_JPRB, 0.37098862E-03_JPRB, 0.37098851E-03_JPRB, 0.37098836E-03_JPRB, 0.37098827E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098816E-03_JPRB, 0.37098807E-03_JPRB, 0.37098789E-03_JPRB /)

RGHG1(:,60, 7) = (/ &
  & 0.37098082E-03_JPRB, 0.37098140E-03_JPRB, 0.37098178E-03_JPRB, 0.37098204E-03_JPRB, 0.37098234E-03_JPRB, 0.37098263E-03_JPRB, &
  & 0.37098286E-03_JPRB, 0.37098309E-03_JPRB, 0.37098324E-03_JPRB, 0.37098338E-03_JPRB, 0.37098359E-03_JPRB, 0.37098385E-03_JPRB, &
  & 0.37098414E-03_JPRB, 0.37098446E-03_JPRB, 0.37098478E-03_JPRB, 0.37098513E-03_JPRB, 0.37098542E-03_JPRB, 0.37098554E-03_JPRB, &
  & 0.37098568E-03_JPRB, 0.37098565E-03_JPRB, 0.37098574E-03_JPRB, 0.37098597E-03_JPRB, 0.37098682E-03_JPRB, 0.37098795E-03_JPRB, &
  & 0.37098929E-03_JPRB, 0.37099057E-03_JPRB, 0.37099174E-03_JPRB, 0.37099293E-03_JPRB, 0.37099392E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37099663E-03_JPRB, 0.37099724E-03_JPRB, 0.37099770E-03_JPRB, 0.37099782E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099715E-03_JPRB, 0.37099657E-03_JPRB, 0.37099564E-03_JPRB, 0.37099488E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099243E-03_JPRB, 0.37099179E-03_JPRB, 0.37099136E-03_JPRB, 0.37099098E-03_JPRB, 0.37099063E-03_JPRB, &
  & 0.37099037E-03_JPRB, 0.37099014E-03_JPRB, 0.37098999E-03_JPRB, 0.37098990E-03_JPRB, 0.37098984E-03_JPRB, 0.37098976E-03_JPRB, &
  & 0.37098961E-03_JPRB, 0.37098950E-03_JPRB, 0.37098932E-03_JPRB, 0.37098920E-03_JPRB, 0.37098909E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098883E-03_JPRB, 0.37098868E-03_JPRB, 0.37098842E-03_JPRB /)

RGHG1(:,61, 7) = (/ &
  & 0.37098245E-03_JPRB, 0.37098292E-03_JPRB, 0.37098321E-03_JPRB, 0.37098338E-03_JPRB, 0.37098365E-03_JPRB, 0.37098391E-03_JPRB, &
  & 0.37098411E-03_JPRB, 0.37098426E-03_JPRB, 0.37098437E-03_JPRB, 0.37098452E-03_JPRB, 0.37098466E-03_JPRB, 0.37098493E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098554E-03_JPRB, 0.37098583E-03_JPRB, 0.37098609E-03_JPRB, 0.37098629E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098673E-03_JPRB, 0.37098673E-03_JPRB, 0.37098688E-03_JPRB, 0.37098755E-03_JPRB, 0.37098868E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37099115E-03_JPRB, 0.37099223E-03_JPRB, 0.37099328E-03_JPRB, 0.37099430E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099698E-03_JPRB, 0.37099759E-03_JPRB, 0.37099802E-03_JPRB, 0.37099811E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099741E-03_JPRB, 0.37099698E-03_JPRB, 0.37099616E-03_JPRB, 0.37099537E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099310E-03_JPRB, 0.37099249E-03_JPRB, 0.37099211E-03_JPRB, 0.37099179E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099086E-03_JPRB, 0.37099075E-03_JPRB, 0.37099063E-03_JPRB, 0.37099057E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099031E-03_JPRB, 0.37099019E-03_JPRB, 0.37098996E-03_JPRB, 0.37098984E-03_JPRB, 0.37098973E-03_JPRB, 0.37098961E-03_JPRB, &
  & 0.37098950E-03_JPRB, 0.37098938E-03_JPRB, 0.37098920E-03_JPRB, 0.37098883E-03_JPRB /)

RGHG1(:,62, 7) = (/ &
  & 0.37098397E-03_JPRB, 0.37098434E-03_JPRB, 0.37098455E-03_JPRB, 0.37098472E-03_JPRB, 0.37098487E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098548E-03_JPRB, 0.37098562E-03_JPRB, 0.37098577E-03_JPRB, 0.37098589E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098647E-03_JPRB, 0.37098685E-03_JPRB, 0.37098720E-03_JPRB, 0.37098757E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098772E-03_JPRB, 0.37098766E-03_JPRB, 0.37098778E-03_JPRB, 0.37098839E-03_JPRB, 0.37098941E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37099162E-03_JPRB, 0.37099270E-03_JPRB, 0.37099372E-03_JPRB, 0.37099468E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099735E-03_JPRB, 0.37099791E-03_JPRB, 0.37099828E-03_JPRB, 0.37099843E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099779E-03_JPRB, 0.37099732E-03_JPRB, 0.37099654E-03_JPRB, 0.37099575E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099372E-03_JPRB, 0.37099319E-03_JPRB, 0.37099278E-03_JPRB, 0.37099246E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099162E-03_JPRB, 0.37099150E-03_JPRB, 0.37099136E-03_JPRB, 0.37099139E-03_JPRB, 0.37099127E-03_JPRB, &
  & 0.37099104E-03_JPRB, 0.37099089E-03_JPRB, 0.37099057E-03_JPRB, 0.37099043E-03_JPRB, 0.37099034E-03_JPRB, 0.37099025E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098996E-03_JPRB, 0.37098967E-03_JPRB, 0.37098926E-03_JPRB /)

RGHG1(:,63, 7) = (/ &
  & 0.37098507E-03_JPRB, 0.37098542E-03_JPRB, 0.37098560E-03_JPRB, 0.37098571E-03_JPRB, 0.37098583E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098618E-03_JPRB, 0.37098638E-03_JPRB, 0.37098653E-03_JPRB, 0.37098664E-03_JPRB, 0.37098676E-03_JPRB, 0.37098699E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098760E-03_JPRB, 0.37098795E-03_JPRB, 0.37098830E-03_JPRB, 0.37098859E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098874E-03_JPRB, 0.37098856E-03_JPRB, 0.37098874E-03_JPRB, 0.37098929E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099223E-03_JPRB, 0.37099325E-03_JPRB, 0.37099421E-03_JPRB, 0.37099517E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099680E-03_JPRB, 0.37099762E-03_JPRB, 0.37099826E-03_JPRB, 0.37099863E-03_JPRB, 0.37099869E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099817E-03_JPRB, 0.37099773E-03_JPRB, 0.37099698E-03_JPRB, 0.37099622E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099500E-03_JPRB, 0.37099433E-03_JPRB, 0.37099386E-03_JPRB, 0.37099351E-03_JPRB, 0.37099316E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099270E-03_JPRB, 0.37099241E-03_JPRB, 0.37099226E-03_JPRB, 0.37099217E-03_JPRB, 0.37099220E-03_JPRB, 0.37099206E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099156E-03_JPRB, 0.37099127E-03_JPRB, 0.37099113E-03_JPRB, 0.37099107E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37099075E-03_JPRB, 0.37099051E-03_JPRB, 0.37099025E-03_JPRB, 0.37098970E-03_JPRB /)

RGHG1(:,64, 7) = (/ &
  & 0.37098612E-03_JPRB, 0.37098638E-03_JPRB, 0.37098659E-03_JPRB, 0.37098676E-03_JPRB, 0.37098693E-03_JPRB, 0.37098714E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098752E-03_JPRB, 0.37098763E-03_JPRB, 0.37098775E-03_JPRB, 0.37098789E-03_JPRB, 0.37098807E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098862E-03_JPRB, 0.37098909E-03_JPRB, 0.37098941E-03_JPRB, 0.37098976E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098967E-03_JPRB, 0.37098941E-03_JPRB, 0.37098961E-03_JPRB, 0.37098958E-03_JPRB, 0.37099011E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099284E-03_JPRB, 0.37099383E-03_JPRB, 0.37099473E-03_JPRB, 0.37099564E-03_JPRB, 0.37099651E-03_JPRB, &
  & 0.37099718E-03_JPRB, 0.37099791E-03_JPRB, 0.37099852E-03_JPRB, 0.37099890E-03_JPRB, 0.37099898E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099855E-03_JPRB, 0.37099814E-03_JPRB, 0.37099735E-03_JPRB, 0.37099665E-03_JPRB, 0.37099616E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099500E-03_JPRB, 0.37099453E-03_JPRB, 0.37099418E-03_JPRB, 0.37099380E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099340E-03_JPRB, 0.37099316E-03_JPRB, 0.37099305E-03_JPRB, 0.37099293E-03_JPRB, 0.37099293E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099246E-03_JPRB, 0.37099232E-03_JPRB, 0.37099194E-03_JPRB, 0.37099185E-03_JPRB, 0.37099179E-03_JPRB, 0.37099156E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099113E-03_JPRB, 0.37099081E-03_JPRB, 0.37099011E-03_JPRB /)

RGHG1(:,65, 7) = (/ &
  & 0.37098711E-03_JPRB, 0.37098743E-03_JPRB, 0.37098763E-03_JPRB, 0.37098778E-03_JPRB, 0.37098792E-03_JPRB, 0.37098810E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098839E-03_JPRB, 0.37098851E-03_JPRB, 0.37098868E-03_JPRB, 0.37098891E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098932E-03_JPRB, 0.37098973E-03_JPRB, 0.37099019E-03_JPRB, 0.37099048E-03_JPRB, 0.37099066E-03_JPRB, 0.37099066E-03_JPRB, &
  & 0.37099066E-03_JPRB, 0.37099081E-03_JPRB, 0.37099046E-03_JPRB, 0.37099043E-03_JPRB, 0.37099083E-03_JPRB, 0.37099159E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37099345E-03_JPRB, 0.37099441E-03_JPRB, 0.37099532E-03_JPRB, 0.37099619E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099823E-03_JPRB, 0.37099887E-03_JPRB, 0.37099916E-03_JPRB, 0.37099922E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099881E-03_JPRB, 0.37099846E-03_JPRB, 0.37099776E-03_JPRB, 0.37099706E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099558E-03_JPRB, 0.37099520E-03_JPRB, 0.37099488E-03_JPRB, 0.37099447E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099406E-03_JPRB, 0.37099392E-03_JPRB, 0.37099383E-03_JPRB, 0.37099374E-03_JPRB, 0.37099369E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099308E-03_JPRB, 0.37099276E-03_JPRB, 0.37099255E-03_JPRB, 0.37099255E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099197E-03_JPRB, 0.37099177E-03_JPRB, 0.37099142E-03_JPRB, 0.37099060E-03_JPRB /)

RGHG1(:,66, 7) = (/ &
  & 0.37098787E-03_JPRB, 0.37098816E-03_JPRB, 0.37098839E-03_JPRB, 0.37098856E-03_JPRB, 0.37098874E-03_JPRB, 0.37098891E-03_JPRB, &
  & 0.37098909E-03_JPRB, 0.37098932E-03_JPRB, 0.37098950E-03_JPRB, 0.37098961E-03_JPRB, 0.37098976E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37099034E-03_JPRB, 0.37099072E-03_JPRB, 0.37099124E-03_JPRB, 0.37099147E-03_JPRB, 0.37099174E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099147E-03_JPRB, 0.37099118E-03_JPRB, 0.37099121E-03_JPRB, 0.37099124E-03_JPRB, 0.37099165E-03_JPRB, 0.37099238E-03_JPRB, &
  & 0.37099313E-03_JPRB, 0.37099409E-03_JPRB, 0.37099500E-03_JPRB, 0.37099584E-03_JPRB, 0.37099663E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099855E-03_JPRB, 0.37099910E-03_JPRB, 0.37099939E-03_JPRB, 0.37099939E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099887E-03_JPRB, 0.37099866E-03_JPRB, 0.37099817E-03_JPRB, 0.37099759E-03_JPRB, 0.37099715E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099613E-03_JPRB, 0.37099581E-03_JPRB, 0.37099543E-03_JPRB, 0.37099508E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099465E-03_JPRB, 0.37099450E-03_JPRB, 0.37099447E-03_JPRB, 0.37099441E-03_JPRB, 0.37099424E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099383E-03_JPRB, 0.37099351E-03_JPRB, 0.37099328E-03_JPRB, 0.37099322E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099267E-03_JPRB, 0.37099246E-03_JPRB, 0.37099206E-03_JPRB, 0.37099110E-03_JPRB /)

RGHG1(:,67, 7) = (/ &
  & 0.37098868E-03_JPRB, 0.37098903E-03_JPRB, 0.37098926E-03_JPRB, 0.37098941E-03_JPRB, 0.37098961E-03_JPRB, 0.37098979E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37099008E-03_JPRB, 0.37099031E-03_JPRB, 0.37099048E-03_JPRB, 0.37099075E-03_JPRB, 0.37099101E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099168E-03_JPRB, 0.37099220E-03_JPRB, 0.37099241E-03_JPRB, 0.37099264E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099243E-03_JPRB, 0.37099264E-03_JPRB, 0.37099238E-03_JPRB, 0.37099220E-03_JPRB, 0.37099249E-03_JPRB, 0.37099305E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099468E-03_JPRB, 0.37099561E-03_JPRB, 0.37099636E-03_JPRB, 0.37099712E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099890E-03_JPRB, 0.37099942E-03_JPRB, 0.37099962E-03_JPRB, 0.37099954E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099916E-03_JPRB, 0.37099887E-03_JPRB, 0.37099855E-03_JPRB, 0.37099796E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099718E-03_JPRB, 0.37099671E-03_JPRB, 0.37099639E-03_JPRB, 0.37099604E-03_JPRB, 0.37099569E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099537E-03_JPRB, 0.37099526E-03_JPRB, 0.37099526E-03_JPRB, 0.37099511E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099462E-03_JPRB, 0.37099427E-03_JPRB, 0.37099401E-03_JPRB, 0.37099398E-03_JPRB, 0.37099369E-03_JPRB, &
  & 0.37099342E-03_JPRB, 0.37099316E-03_JPRB, 0.37099270E-03_JPRB, 0.37099168E-03_JPRB /)

RGHG1(:,68, 7) = (/ &
  & 0.37098938E-03_JPRB, 0.37098979E-03_JPRB, 0.37098996E-03_JPRB, 0.37099014E-03_JPRB, 0.37099037E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099101E-03_JPRB, 0.37099133E-03_JPRB, 0.37099136E-03_JPRB, 0.37099168E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099223E-03_JPRB, 0.37099261E-03_JPRB, 0.37099313E-03_JPRB, 0.37099337E-03_JPRB, 0.37099363E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099302E-03_JPRB, 0.37099305E-03_JPRB, 0.37099302E-03_JPRB, 0.37099325E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099447E-03_JPRB, 0.37099529E-03_JPRB, 0.37099613E-03_JPRB, 0.37099689E-03_JPRB, 0.37099753E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099907E-03_JPRB, 0.37099965E-03_JPRB, 0.37099989E-03_JPRB, 0.37099983E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099933E-03_JPRB, 0.37099913E-03_JPRB, 0.37099881E-03_JPRB, 0.37099837E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099730E-03_JPRB, 0.37099689E-03_JPRB, 0.37099651E-03_JPRB, 0.37099625E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099616E-03_JPRB, 0.37099593E-03_JPRB, 0.37099596E-03_JPRB, 0.37099578E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099555E-03_JPRB, 0.37099529E-03_JPRB, 0.37099500E-03_JPRB, 0.37099476E-03_JPRB, 0.37099459E-03_JPRB, 0.37099433E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099386E-03_JPRB, 0.37099340E-03_JPRB, 0.37099241E-03_JPRB /)

RGHG1(:,69, 7) = (/ &
  & 0.37099008E-03_JPRB, 0.37099054E-03_JPRB, 0.37099072E-03_JPRB, 0.37099092E-03_JPRB, 0.37099113E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099156E-03_JPRB, 0.37099188E-03_JPRB, 0.37099217E-03_JPRB, 0.37099217E-03_JPRB, 0.37099252E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099345E-03_JPRB, 0.37099406E-03_JPRB, 0.37099430E-03_JPRB, 0.37099450E-03_JPRB, 0.37099424E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099436E-03_JPRB, 0.37099412E-03_JPRB, 0.37099392E-03_JPRB, 0.37099406E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099593E-03_JPRB, 0.37099680E-03_JPRB, 0.37099744E-03_JPRB, 0.37099799E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099933E-03_JPRB, 0.37099977E-03_JPRB, 0.37100006E-03_JPRB, 0.37099997E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099936E-03_JPRB, 0.37099927E-03_JPRB, 0.37099898E-03_JPRB, 0.37099863E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099773E-03_JPRB, 0.37099741E-03_JPRB, 0.37099703E-03_JPRB, 0.37099677E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099689E-03_JPRB, 0.37099663E-03_JPRB, 0.37099660E-03_JPRB, 0.37099639E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099604E-03_JPRB, 0.37099572E-03_JPRB, 0.37099552E-03_JPRB, 0.37099532E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099456E-03_JPRB, 0.37099412E-03_JPRB, 0.37099310E-03_JPRB /)

RGHG1(:,70, 7) = (/ &
  & 0.37099072E-03_JPRB, 0.37099142E-03_JPRB, 0.37099153E-03_JPRB, 0.37099171E-03_JPRB, 0.37099200E-03_JPRB, 0.37099226E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099281E-03_JPRB, 0.37099310E-03_JPRB, 0.37099305E-03_JPRB, 0.37099331E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099421E-03_JPRB, 0.37099500E-03_JPRB, 0.37099511E-03_JPRB, 0.37099555E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099491E-03_JPRB, 0.37099479E-03_JPRB, 0.37099476E-03_JPRB, 0.37099491E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099660E-03_JPRB, 0.37099744E-03_JPRB, 0.37099794E-03_JPRB, 0.37099834E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099957E-03_JPRB, 0.37100009E-03_JPRB, 0.37100035E-03_JPRB, 0.37100021E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099948E-03_JPRB, 0.37099957E-03_JPRB, 0.37099925E-03_JPRB, 0.37099890E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099817E-03_JPRB, 0.37099788E-03_JPRB, 0.37099753E-03_JPRB, 0.37099724E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099747E-03_JPRB, 0.37099730E-03_JPRB, 0.37099727E-03_JPRB, 0.37099709E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099683E-03_JPRB, 0.37099642E-03_JPRB, 0.37099625E-03_JPRB, 0.37099613E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099535E-03_JPRB, 0.37099485E-03_JPRB, 0.37099398E-03_JPRB /)

RGHG1(:,71, 7) = (/ &
  & 0.37099136E-03_JPRB, 0.37099235E-03_JPRB, 0.37099238E-03_JPRB, 0.37099255E-03_JPRB, 0.37099281E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099369E-03_JPRB, 0.37099392E-03_JPRB, 0.37099380E-03_JPRB, 0.37099412E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099497E-03_JPRB, 0.37099578E-03_JPRB, 0.37099569E-03_JPRB, 0.37099636E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37099607E-03_JPRB, 0.37099590E-03_JPRB, 0.37099569E-03_JPRB, 0.37099567E-03_JPRB, 0.37099599E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099724E-03_JPRB, 0.37099799E-03_JPRB, 0.37099837E-03_JPRB, 0.37099875E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099983E-03_JPRB, 0.37100038E-03_JPRB, 0.37100064E-03_JPRB, 0.37100032E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099957E-03_JPRB, 0.37099983E-03_JPRB, 0.37099957E-03_JPRB, 0.37099925E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099860E-03_JPRB, 0.37099826E-03_JPRB, 0.37099791E-03_JPRB, 0.37099767E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099811E-03_JPRB, 0.37099799E-03_JPRB, 0.37099788E-03_JPRB, 0.37099776E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099759E-03_JPRB, 0.37099712E-03_JPRB, 0.37099689E-03_JPRB, 0.37099686E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099610E-03_JPRB, 0.37099572E-03_JPRB, 0.37099491E-03_JPRB /)

RGHG1(:,72, 7) = (/ &
  & 0.37099211E-03_JPRB, 0.37099345E-03_JPRB, 0.37099322E-03_JPRB, 0.37099340E-03_JPRB, 0.37099380E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099418E-03_JPRB, 0.37099462E-03_JPRB, 0.37099485E-03_JPRB, 0.37099471E-03_JPRB, 0.37099497E-03_JPRB, 0.37099529E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099561E-03_JPRB, 0.37099665E-03_JPRB, 0.37099636E-03_JPRB, 0.37099732E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099657E-03_JPRB, 0.37099665E-03_JPRB, 0.37099651E-03_JPRB, 0.37099645E-03_JPRB, 0.37099648E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099788E-03_JPRB, 0.37099855E-03_JPRB, 0.37099881E-03_JPRB, 0.37099907E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100015E-03_JPRB, 0.37100073E-03_JPRB, 0.37100096E-03_JPRB, 0.37100053E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099968E-03_JPRB, 0.37100000E-03_JPRB, 0.37099977E-03_JPRB, 0.37099951E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099895E-03_JPRB, 0.37099863E-03_JPRB, 0.37099826E-03_JPRB, 0.37099805E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099878E-03_JPRB, 0.37099863E-03_JPRB, 0.37099843E-03_JPRB, 0.37099826E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099831E-03_JPRB, 0.37099782E-03_JPRB, 0.37099759E-03_JPRB, 0.37099762E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099683E-03_JPRB, 0.37099642E-03_JPRB, 0.37099584E-03_JPRB /)

RGHG1(:,73, 7) = (/ &
  & 0.37099328E-03_JPRB, 0.37099473E-03_JPRB, 0.37099412E-03_JPRB, 0.37099421E-03_JPRB, 0.37099471E-03_JPRB, 0.37099494E-03_JPRB, &
  & 0.37099505E-03_JPRB, 0.37099543E-03_JPRB, 0.37099567E-03_JPRB, 0.37099561E-03_JPRB, 0.37099596E-03_JPRB, 0.37099619E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099631E-03_JPRB, 0.37099750E-03_JPRB, 0.37099674E-03_JPRB, 0.37099846E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099770E-03_JPRB, 0.37099747E-03_JPRB, 0.37099727E-03_JPRB, 0.37099721E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099858E-03_JPRB, 0.37099913E-03_JPRB, 0.37099933E-03_JPRB, 0.37099939E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100050E-03_JPRB, 0.37100105E-03_JPRB, 0.37100125E-03_JPRB, 0.37100073E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099977E-03_JPRB, 0.37100026E-03_JPRB, 0.37100009E-03_JPRB, 0.37099977E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099927E-03_JPRB, 0.37099898E-03_JPRB, 0.37099852E-03_JPRB, 0.37099826E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099933E-03_JPRB, 0.37099927E-03_JPRB, 0.37099904E-03_JPRB, 0.37099878E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099910E-03_JPRB, 0.37099852E-03_JPRB, 0.37099831E-03_JPRB, 0.37099834E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099762E-03_JPRB, 0.37099732E-03_JPRB, 0.37099680E-03_JPRB /)

RGHG1(:,74, 7) = (/ &
  & 0.37099450E-03_JPRB, 0.37099616E-03_JPRB, 0.37099503E-03_JPRB, 0.37099505E-03_JPRB, 0.37099567E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099590E-03_JPRB, 0.37099636E-03_JPRB, 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, 0.37099671E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099686E-03_JPRB, 0.37099846E-03_JPRB, 0.37099718E-03_JPRB, 0.37099916E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099840E-03_JPRB, 0.37099811E-03_JPRB, 0.37099808E-03_JPRB, 0.37099788E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099933E-03_JPRB, 0.37099962E-03_JPRB, 0.37099983E-03_JPRB, 0.37099977E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100090E-03_JPRB, 0.37100140E-03_JPRB, 0.37100160E-03_JPRB, 0.37100082E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099997E-03_JPRB, 0.37100064E-03_JPRB, 0.37100047E-03_JPRB, 0.37100003E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37099957E-03_JPRB, 0.37099922E-03_JPRB, 0.37099881E-03_JPRB, 0.37099846E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099986E-03_JPRB, 0.37099991E-03_JPRB, 0.37099957E-03_JPRB, 0.37099922E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37099983E-03_JPRB, 0.37099916E-03_JPRB, 0.37099895E-03_JPRB, 0.37099910E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099843E-03_JPRB, 0.37099814E-03_JPRB, 0.37099762E-03_JPRB /)

RGHG1(:,75, 7) = (/ &
  & 0.37099590E-03_JPRB, 0.37099770E-03_JPRB, 0.37099590E-03_JPRB, 0.37099578E-03_JPRB, 0.37099654E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099706E-03_JPRB, 0.37099721E-03_JPRB, 0.37099695E-03_JPRB, 0.37099767E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099715E-03_JPRB, 0.37099904E-03_JPRB, 0.37099794E-03_JPRB, 0.37099959E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099925E-03_JPRB, 0.37099895E-03_JPRB, 0.37099893E-03_JPRB, 0.37099855E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37100009E-03_JPRB, 0.37100018E-03_JPRB, 0.37100021E-03_JPRB, 0.37100009E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100131E-03_JPRB, 0.37100178E-03_JPRB, 0.37100195E-03_JPRB, 0.37100093E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100003E-03_JPRB, 0.37100085E-03_JPRB, 0.37100073E-03_JPRB, 0.37100044E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099986E-03_JPRB, 0.37099948E-03_JPRB, 0.37099901E-03_JPRB, 0.37099855E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100023E-03_JPRB, 0.37100053E-03_JPRB, 0.37100003E-03_JPRB, 0.37099959E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100050E-03_JPRB, 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, 0.37099980E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099910E-03_JPRB, 0.37099895E-03_JPRB, 0.37099843E-03_JPRB /)

RGHG1(:,76, 7) = (/ &
  & 0.37099744E-03_JPRB, 0.37099933E-03_JPRB, 0.37099657E-03_JPRB, 0.37099636E-03_JPRB, 0.37099741E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099799E-03_JPRB, 0.37099802E-03_JPRB, 0.37099759E-03_JPRB, 0.37099837E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099767E-03_JPRB, 0.37099916E-03_JPRB, 0.37099863E-03_JPRB, 0.37100009E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100003E-03_JPRB, 0.37099968E-03_JPRB, 0.37099980E-03_JPRB, 0.37099910E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100085E-03_JPRB, 0.37100067E-03_JPRB, 0.37100061E-03_JPRB, 0.37100035E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100175E-03_JPRB, 0.37100216E-03_JPRB, 0.37100236E-03_JPRB, 0.37100102E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100023E-03_JPRB, 0.37100125E-03_JPRB, 0.37100102E-03_JPRB, 0.37100076E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100003E-03_JPRB, 0.37099968E-03_JPRB, 0.37099919E-03_JPRB, 0.37099866E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100073E-03_JPRB, 0.37100122E-03_JPRB, 0.37100058E-03_JPRB, 0.37099986E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100131E-03_JPRB, 0.37100029E-03_JPRB, 0.37100003E-03_JPRB, 0.37100055E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099986E-03_JPRB, 0.37099980E-03_JPRB, 0.37099922E-03_JPRB /)

RGHG1(:,77, 7) = (/ &
  & 0.37099904E-03_JPRB, 0.37100111E-03_JPRB, 0.37099712E-03_JPRB, 0.37099683E-03_JPRB, 0.37099817E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099872E-03_JPRB, 0.37099858E-03_JPRB, 0.37099785E-03_JPRB, 0.37099939E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099805E-03_JPRB, 0.37099898E-03_JPRB, 0.37099922E-03_JPRB, 0.37100058E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100088E-03_JPRB, 0.37100038E-03_JPRB, 0.37100064E-03_JPRB, 0.37099971E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37100166E-03_JPRB, 0.37100111E-03_JPRB, 0.37100099E-03_JPRB, 0.37100053E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100227E-03_JPRB, 0.37100259E-03_JPRB, 0.37100280E-03_JPRB, 0.37100108E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37100012E-03_JPRB, 0.37100149E-03_JPRB, 0.37100146E-03_JPRB, 0.37100125E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100015E-03_JPRB, 0.37099971E-03_JPRB, 0.37099925E-03_JPRB, 0.37099869E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100120E-03_JPRB, 0.37100195E-03_JPRB, 0.37100105E-03_JPRB, 0.37099994E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100216E-03_JPRB, 0.37100079E-03_JPRB, 0.37100050E-03_JPRB, 0.37100143E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100050E-03_JPRB, 0.37100067E-03_JPRB, 0.37099997E-03_JPRB /)

RGHG1(:,78, 7) = (/ &
  & 0.37100070E-03_JPRB, 0.37100280E-03_JPRB, 0.37099753E-03_JPRB, 0.37099718E-03_JPRB, 0.37099890E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099951E-03_JPRB, 0.37099922E-03_JPRB, 0.37099799E-03_JPRB, 0.37100006E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099855E-03_JPRB, 0.37099893E-03_JPRB, 0.37099962E-03_JPRB, 0.37100105E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100169E-03_JPRB, 0.37100102E-03_JPRB, 0.37100140E-03_JPRB, 0.37100018E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100233E-03_JPRB, 0.37100152E-03_JPRB, 0.37100134E-03_JPRB, 0.37100076E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100280E-03_JPRB, 0.37100309E-03_JPRB, 0.37100320E-03_JPRB, 0.37100114E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100023E-03_JPRB, 0.37100184E-03_JPRB, 0.37100178E-03_JPRB, 0.37100152E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100029E-03_JPRB, 0.37099977E-03_JPRB, 0.37099930E-03_JPRB, 0.37099863E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100146E-03_JPRB, 0.37100146E-03_JPRB, 0.37100277E-03_JPRB, 0.37100149E-03_JPRB, 0.37099994E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100300E-03_JPRB, 0.37100114E-03_JPRB, 0.37100073E-03_JPRB, 0.37100227E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100122E-03_JPRB, 0.37100146E-03_JPRB, 0.37100064E-03_JPRB /)

RGHG1(:,79, 7) = (/ &
  & 0.37100221E-03_JPRB, 0.37100428E-03_JPRB, 0.37099762E-03_JPRB, 0.37099712E-03_JPRB, 0.37099933E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37100006E-03_JPRB, 0.37099962E-03_JPRB, 0.37099776E-03_JPRB, 0.37100058E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099872E-03_JPRB, 0.37099875E-03_JPRB, 0.37099986E-03_JPRB, 0.37100149E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100236E-03_JPRB, 0.37100146E-03_JPRB, 0.37100207E-03_JPRB, 0.37100047E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100300E-03_JPRB, 0.37100184E-03_JPRB, 0.37100160E-03_JPRB, 0.37100093E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100186E-03_JPRB, 0.37100335E-03_JPRB, 0.37100367E-03_JPRB, 0.37100373E-03_JPRB, 0.37100120E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37100038E-03_JPRB, 0.37100218E-03_JPRB, 0.37100221E-03_JPRB, 0.37100186E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100044E-03_JPRB, 0.37099980E-03_JPRB, 0.37099930E-03_JPRB, 0.37099852E-03_JPRB, 0.37100134E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100181E-03_JPRB, 0.37100341E-03_JPRB, 0.37100189E-03_JPRB, 0.37099997E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37100323E-03_JPRB, 0.37100379E-03_JPRB, 0.37100146E-03_JPRB, 0.37100099E-03_JPRB, 0.37100315E-03_JPRB, 0.37100175E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100169E-03_JPRB, 0.37100213E-03_JPRB, 0.37100137E-03_JPRB /)

RGHG1(:,80, 7) = (/ &
  & 0.37100376E-03_JPRB, 0.37100536E-03_JPRB, 0.37099753E-03_JPRB, 0.37099706E-03_JPRB, 0.37099954E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37100021E-03_JPRB, 0.37099948E-03_JPRB, 0.37099767E-03_JPRB, 0.37100108E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099875E-03_JPRB, 0.37099855E-03_JPRB, 0.37099997E-03_JPRB, 0.37100172E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100282E-03_JPRB, 0.37100172E-03_JPRB, 0.37100248E-03_JPRB, 0.37100058E-03_JPRB, 0.37100163E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100358E-03_JPRB, 0.37100218E-03_JPRB, 0.37100189E-03_JPRB, 0.37100099E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100384E-03_JPRB, 0.37100416E-03_JPRB, 0.37100416E-03_JPRB, 0.37100125E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100047E-03_JPRB, 0.37100248E-03_JPRB, 0.37100253E-03_JPRB, 0.37100218E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100050E-03_JPRB, 0.37099977E-03_JPRB, 0.37099925E-03_JPRB, 0.37099834E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100207E-03_JPRB, 0.37100210E-03_JPRB, 0.37100402E-03_JPRB, 0.37100224E-03_JPRB, 0.37100000E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100364E-03_JPRB, 0.37100443E-03_JPRB, 0.37100163E-03_JPRB, 0.37100117E-03_JPRB, 0.37100379E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37100198E-03_JPRB, 0.37100277E-03_JPRB, 0.37100218E-03_JPRB /)

RGHG1(:,81, 7) = (/ &
  & 0.37100527E-03_JPRB, 0.37100597E-03_JPRB, 0.37099744E-03_JPRB, 0.37099689E-03_JPRB, 0.37099954E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37100050E-03_JPRB, 0.37100006E-03_JPRB, 0.37099794E-03_JPRB, 0.37100061E-03_JPRB, 0.37100131E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099878E-03_JPRB, 0.37099846E-03_JPRB, 0.37099997E-03_JPRB, 0.37100189E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100323E-03_JPRB, 0.37100184E-03_JPRB, 0.37100277E-03_JPRB, 0.37100053E-03_JPRB, 0.37100181E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100399E-03_JPRB, 0.37100236E-03_JPRB, 0.37100201E-03_JPRB, 0.37100111E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37100425E-03_JPRB, 0.37100454E-03_JPRB, 0.37100451E-03_JPRB, 0.37100134E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100053E-03_JPRB, 0.37100262E-03_JPRB, 0.37100274E-03_JPRB, 0.37100230E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37100055E-03_JPRB, 0.37099968E-03_JPRB, 0.37099916E-03_JPRB, 0.37099826E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37100216E-03_JPRB, 0.37100434E-03_JPRB, 0.37100245E-03_JPRB, 0.37099997E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100396E-03_JPRB, 0.37100486E-03_JPRB, 0.37100189E-03_JPRB, 0.37100125E-03_JPRB, 0.37100419E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100216E-03_JPRB, 0.37100317E-03_JPRB, 0.37100312E-03_JPRB /)

RGHG1(:,82, 7) = (/ &
  & 0.37100539E-03_JPRB, 0.37100626E-03_JPRB, 0.37099735E-03_JPRB, 0.37099677E-03_JPRB, 0.37099957E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37100015E-03_JPRB, 0.37099916E-03_JPRB, 0.37099788E-03_JPRB, 0.37100131E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099878E-03_JPRB, 0.37099834E-03_JPRB, 0.37100000E-03_JPRB, 0.37100201E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100352E-03_JPRB, 0.37100192E-03_JPRB, 0.37100300E-03_JPRB, 0.37100047E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100434E-03_JPRB, 0.37100250E-03_JPRB, 0.37100210E-03_JPRB, 0.37100114E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100445E-03_JPRB, 0.37100477E-03_JPRB, 0.37100475E-03_JPRB, 0.37100146E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100067E-03_JPRB, 0.37100280E-03_JPRB, 0.37100285E-03_JPRB, 0.37100248E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100058E-03_JPRB, 0.37099971E-03_JPRB, 0.37099910E-03_JPRB, 0.37099817E-03_JPRB, 0.37100192E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100224E-03_JPRB, 0.37100457E-03_JPRB, 0.37100259E-03_JPRB, 0.37099991E-03_JPRB, 0.37100227E-03_JPRB, &
  & 0.37100411E-03_JPRB, 0.37100510E-03_JPRB, 0.37100192E-03_JPRB, 0.37100134E-03_JPRB, 0.37100445E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100230E-03_JPRB, 0.37100335E-03_JPRB, 0.37100320E-03_JPRB /)

RGHG1(:,83, 7) = (/ &
  & 0.37100562E-03_JPRB, 0.37100652E-03_JPRB, 0.37099730E-03_JPRB, 0.37099674E-03_JPRB, 0.37099954E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37100044E-03_JPRB, 0.37100009E-03_JPRB, 0.37099846E-03_JPRB, 0.37100038E-03_JPRB, 0.37100134E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099878E-03_JPRB, 0.37099837E-03_JPRB, 0.37099997E-03_JPRB, 0.37100201E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100379E-03_JPRB, 0.37100207E-03_JPRB, 0.37100315E-03_JPRB, 0.37100044E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100463E-03_JPRB, 0.37100265E-03_JPRB, 0.37100224E-03_JPRB, 0.37100120E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100463E-03_JPRB, 0.37100504E-03_JPRB, 0.37100498E-03_JPRB, 0.37100149E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100070E-03_JPRB, 0.37100294E-03_JPRB, 0.37100294E-03_JPRB, 0.37100245E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100061E-03_JPRB, 0.37099965E-03_JPRB, 0.37099910E-03_JPRB, 0.37099811E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100236E-03_JPRB, 0.37100475E-03_JPRB, 0.37100280E-03_JPRB, 0.37099997E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100428E-03_JPRB, 0.37100527E-03_JPRB, 0.37100195E-03_JPRB, 0.37100137E-03_JPRB, 0.37100466E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100230E-03_JPRB, 0.37100347E-03_JPRB, 0.37100329E-03_JPRB /)

RGHG1(:,84, 7) = (/ &
  & 0.37100574E-03_JPRB, 0.37100672E-03_JPRB, 0.37099724E-03_JPRB, 0.37099663E-03_JPRB, 0.37099957E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099989E-03_JPRB, 0.37099922E-03_JPRB, 0.37099840E-03_JPRB, 0.37100117E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099884E-03_JPRB, 0.37099837E-03_JPRB, 0.37099991E-03_JPRB, 0.37100189E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100390E-03_JPRB, 0.37100207E-03_JPRB, 0.37100335E-03_JPRB, 0.37100035E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100495E-03_JPRB, 0.37100280E-03_JPRB, 0.37100224E-03_JPRB, 0.37100117E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100477E-03_JPRB, 0.37100512E-03_JPRB, 0.37100510E-03_JPRB, 0.37100154E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100076E-03_JPRB, 0.37100297E-03_JPRB, 0.37100303E-03_JPRB, 0.37100248E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100064E-03_JPRB, 0.37099971E-03_JPRB, 0.37099913E-03_JPRB, 0.37099820E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100239E-03_JPRB, 0.37100489E-03_JPRB, 0.37100291E-03_JPRB, 0.37099989E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100440E-03_JPRB, 0.37100544E-03_JPRB, 0.37100204E-03_JPRB, 0.37100143E-03_JPRB, 0.37100480E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100236E-03_JPRB, 0.37100364E-03_JPRB, 0.37100338E-03_JPRB /)

RGHG1(:,85, 7) = (/ &
  & 0.37100579E-03_JPRB, 0.37100687E-03_JPRB, 0.37099712E-03_JPRB, 0.37099660E-03_JPRB, 0.37099951E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37100023E-03_JPRB, 0.37099997E-03_JPRB, 0.37099910E-03_JPRB, 0.37100032E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099901E-03_JPRB, 0.37099863E-03_JPRB, 0.37099991E-03_JPRB, 0.37100154E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100399E-03_JPRB, 0.37100213E-03_JPRB, 0.37100352E-03_JPRB, 0.37100032E-03_JPRB, 0.37100259E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100518E-03_JPRB, 0.37100277E-03_JPRB, 0.37100236E-03_JPRB, 0.37100111E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100486E-03_JPRB, 0.37100536E-03_JPRB, 0.37100527E-03_JPRB, 0.37100157E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100082E-03_JPRB, 0.37100309E-03_JPRB, 0.37100315E-03_JPRB, 0.37100259E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100073E-03_JPRB, 0.37099959E-03_JPRB, 0.37099910E-03_JPRB, 0.37099823E-03_JPRB, 0.37100195E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100250E-03_JPRB, 0.37100501E-03_JPRB, 0.37100303E-03_JPRB, 0.37099994E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100451E-03_JPRB, 0.37100571E-03_JPRB, 0.37100207E-03_JPRB, 0.37100149E-03_JPRB, 0.37100498E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100248E-03_JPRB, 0.37100370E-03_JPRB, 0.37100349E-03_JPRB /)

RGHG1(:,86, 7) = (/ &
  & 0.37100582E-03_JPRB, 0.37100687E-03_JPRB, 0.37099700E-03_JPRB, 0.37099648E-03_JPRB, 0.37099957E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099954E-03_JPRB, 0.37099925E-03_JPRB, 0.37099895E-03_JPRB, 0.37100050E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37099922E-03_JPRB, 0.37099898E-03_JPRB, 0.37099986E-03_JPRB, 0.37100108E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100399E-03_JPRB, 0.37100216E-03_JPRB, 0.37100361E-03_JPRB, 0.37100032E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100544E-03_JPRB, 0.37100288E-03_JPRB, 0.37100239E-03_JPRB, 0.37100105E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100498E-03_JPRB, 0.37100553E-03_JPRB, 0.37100542E-03_JPRB, 0.37100166E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37100090E-03_JPRB, 0.37100323E-03_JPRB, 0.37100323E-03_JPRB, 0.37100265E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100073E-03_JPRB, 0.37099968E-03_JPRB, 0.37099904E-03_JPRB, 0.37099837E-03_JPRB, 0.37100189E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100250E-03_JPRB, 0.37100486E-03_JPRB, 0.37100312E-03_JPRB, 0.37099997E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37100469E-03_JPRB, 0.37100579E-03_JPRB, 0.37100213E-03_JPRB, 0.37100157E-03_JPRB, 0.37100507E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100245E-03_JPRB, 0.37100376E-03_JPRB, 0.37100355E-03_JPRB /)

RGHG1(:,87, 7) = (/ &
  & 0.37100582E-03_JPRB, 0.37100672E-03_JPRB, 0.37099700E-03_JPRB, 0.37099660E-03_JPRB, 0.37099930E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37100000E-03_JPRB, 0.37099986E-03_JPRB, 0.37099945E-03_JPRB, 0.37100015E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37099927E-03_JPRB, 0.37099907E-03_JPRB, 0.37099980E-03_JPRB, 0.37100070E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100384E-03_JPRB, 0.37100218E-03_JPRB, 0.37100364E-03_JPRB, 0.37100038E-03_JPRB, 0.37100277E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100562E-03_JPRB, 0.37100277E-03_JPRB, 0.37100242E-03_JPRB, 0.37100099E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100274E-03_JPRB, 0.37100512E-03_JPRB, 0.37100568E-03_JPRB, 0.37100559E-03_JPRB, 0.37100163E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100079E-03_JPRB, 0.37100335E-03_JPRB, 0.37100335E-03_JPRB, 0.37100285E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100073E-03_JPRB, 0.37099965E-03_JPRB, 0.37099913E-03_JPRB, 0.37099858E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100262E-03_JPRB, 0.37100483E-03_JPRB, 0.37100312E-03_JPRB, 0.37100012E-03_JPRB, 0.37100262E-03_JPRB, &
  & 0.37100483E-03_JPRB, 0.37100600E-03_JPRB, 0.37100221E-03_JPRB, 0.37100157E-03_JPRB, 0.37100515E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100253E-03_JPRB, 0.37100384E-03_JPRB, 0.37100364E-03_JPRB /)

RGHG1(:,88, 7) = (/ &
  & 0.37100576E-03_JPRB, 0.37100626E-03_JPRB, 0.37099730E-03_JPRB, 0.37099648E-03_JPRB, 0.37099957E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099957E-03_JPRB, 0.37099945E-03_JPRB, 0.37099927E-03_JPRB, 0.37100029E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099933E-03_JPRB, 0.37099904E-03_JPRB, 0.37099965E-03_JPRB, 0.37100053E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100381E-03_JPRB, 0.37100213E-03_JPRB, 0.37100376E-03_JPRB, 0.37100041E-03_JPRB, 0.37100277E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100574E-03_JPRB, 0.37100285E-03_JPRB, 0.37100242E-03_JPRB, 0.37100085E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100510E-03_JPRB, 0.37100576E-03_JPRB, 0.37100574E-03_JPRB, 0.37100169E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100079E-03_JPRB, 0.37100355E-03_JPRB, 0.37100352E-03_JPRB, 0.37100297E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100070E-03_JPRB, 0.37099968E-03_JPRB, 0.37099916E-03_JPRB, 0.37099863E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100268E-03_JPRB, 0.37100469E-03_JPRB, 0.37100312E-03_JPRB, 0.37100026E-03_JPRB, 0.37100268E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100608E-03_JPRB, 0.37100221E-03_JPRB, 0.37100163E-03_JPRB, 0.37100524E-03_JPRB, 0.37100268E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100250E-03_JPRB, 0.37100384E-03_JPRB, 0.37100370E-03_JPRB /)

RGHG1(:,89, 7) = (/ &
  & 0.37100559E-03_JPRB, 0.37100542E-03_JPRB, 0.37099776E-03_JPRB, 0.37099668E-03_JPRB, 0.37099933E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099997E-03_JPRB, 0.37099980E-03_JPRB, 0.37099954E-03_JPRB, 0.37100026E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099922E-03_JPRB, 0.37099895E-03_JPRB, 0.37099974E-03_JPRB, 0.37100070E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100399E-03_JPRB, 0.37100213E-03_JPRB, 0.37100384E-03_JPRB, 0.37100044E-03_JPRB, 0.37100285E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100588E-03_JPRB, 0.37100280E-03_JPRB, 0.37100242E-03_JPRB, 0.37100082E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100521E-03_JPRB, 0.37100585E-03_JPRB, 0.37100591E-03_JPRB, 0.37100169E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37100073E-03_JPRB, 0.37100370E-03_JPRB, 0.37100355E-03_JPRB, 0.37100312E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100070E-03_JPRB, 0.37099968E-03_JPRB, 0.37099916E-03_JPRB, 0.37099869E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100271E-03_JPRB, 0.37100463E-03_JPRB, 0.37100315E-03_JPRB, 0.37100038E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100492E-03_JPRB, 0.37100620E-03_JPRB, 0.37100224E-03_JPRB, 0.37100163E-03_JPRB, 0.37100536E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100253E-03_JPRB, 0.37100384E-03_JPRB, 0.37100379E-03_JPRB /)

RGHG1(:,90, 7) = (/ &
  & 0.37100527E-03_JPRB, 0.37100445E-03_JPRB, 0.37099817E-03_JPRB, 0.37099663E-03_JPRB, 0.37099959E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099965E-03_JPRB, 0.37099939E-03_JPRB, 0.37099904E-03_JPRB, 0.37100061E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37099910E-03_JPRB, 0.37099863E-03_JPRB, 0.37099968E-03_JPRB, 0.37100111E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100434E-03_JPRB, 0.37100201E-03_JPRB, 0.37100396E-03_JPRB, 0.37100032E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100608E-03_JPRB, 0.37100277E-03_JPRB, 0.37100256E-03_JPRB, 0.37100079E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100280E-03_JPRB, 0.37100539E-03_JPRB, 0.37100600E-03_JPRB, 0.37100611E-03_JPRB, 0.37100152E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37100070E-03_JPRB, 0.37100387E-03_JPRB, 0.37100355E-03_JPRB, 0.37100329E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37100373E-03_JPRB, 0.37100067E-03_JPRB, 0.37099962E-03_JPRB, 0.37099907E-03_JPRB, 0.37099849E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37100227E-03_JPRB, 0.37100271E-03_JPRB, 0.37100475E-03_JPRB, 0.37100320E-03_JPRB, 0.37100026E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37100507E-03_JPRB, 0.37100638E-03_JPRB, 0.37100213E-03_JPRB, 0.37100146E-03_JPRB, 0.37100553E-03_JPRB, 0.37100262E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100256E-03_JPRB, 0.37100390E-03_JPRB, 0.37100373E-03_JPRB /)

RGHG1(:,91, 7) = (/ &
  & 0.37100527E-03_JPRB, 0.37100387E-03_JPRB, 0.37099904E-03_JPRB, 0.37099590E-03_JPRB, 0.37099980E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099625E-03_JPRB, 0.37100157E-03_JPRB, 0.37099834E-03_JPRB, 0.37099724E-03_JPRB, 0.37100250E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37099817E-03_JPRB, 0.37099721E-03_JPRB, 0.37099971E-03_JPRB, 0.37100303E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100515E-03_JPRB, 0.37100172E-03_JPRB, 0.37100437E-03_JPRB, 0.37099986E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37100667E-03_JPRB, 0.37100262E-03_JPRB, 0.37100271E-03_JPRB, 0.37100079E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37100291E-03_JPRB, 0.37100553E-03_JPRB, 0.37100611E-03_JPRB, 0.37100652E-03_JPRB, 0.37100125E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37100061E-03_JPRB, 0.37100413E-03_JPRB, 0.37100361E-03_JPRB, 0.37100361E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37100472E-03_JPRB, 0.37100038E-03_JPRB, 0.37099951E-03_JPRB, 0.37099907E-03_JPRB, 0.37099756E-03_JPRB, 0.37100245E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100265E-03_JPRB, 0.37100533E-03_JPRB, 0.37100341E-03_JPRB, 0.37099954E-03_JPRB, 0.37100274E-03_JPRB, &
  & 0.37100521E-03_JPRB, 0.37100684E-03_JPRB, 0.37100189E-03_JPRB, 0.37100120E-03_JPRB, 0.37100597E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100248E-03_JPRB, 0.37100399E-03_JPRB, 0.37100379E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG1(:, 1, 8) = (/ &
  & 0.35862476E-03_JPRB, 0.35862770E-03_JPRB, 0.35863795E-03_JPRB, 0.35866187E-03_JPRB, 0.35869807E-03_JPRB, 0.35875084E-03_JPRB, &
  & 0.35882500E-03_JPRB, 0.35892401E-03_JPRB, 0.35904819E-03_JPRB, 0.35919494E-03_JPRB, 0.35935832E-03_JPRB, 0.35953036E-03_JPRB, &
  & 0.35970128E-03_JPRB, 0.35986002E-03_JPRB, 0.35999654E-03_JPRB, 0.36010376E-03_JPRB, 0.36017859E-03_JPRB, 0.36022146E-03_JPRB, &
  & 0.36023511E-03_JPRB, 0.36022082E-03_JPRB, 0.36017981E-03_JPRB, 0.36011988E-03_JPRB, 0.36005961E-03_JPRB, 0.36002812E-03_JPRB, &
  & 0.36005766E-03_JPRB, 0.36017303E-03_JPRB, 0.36037349E-03_JPRB, 0.36061666E-03_JPRB, 0.36083811E-03_JPRB, 0.36100476E-03_JPRB, &
  & 0.36111783E-03_JPRB, 0.36118121E-03_JPRB, 0.36120060E-03_JPRB, 0.36117359E-03_JPRB, 0.36109812E-03_JPRB, 0.36097682E-03_JPRB, &
  & 0.36081864E-03_JPRB, 0.36063491E-03_JPRB, 0.36043965E-03_JPRB, 0.36026444E-03_JPRB, 0.36013708E-03_JPRB, 0.36003138E-03_JPRB, &
  & 0.35992087E-03_JPRB, 0.35979849E-03_JPRB, 0.35964185E-03_JPRB, 0.35944645E-03_JPRB, 0.35915573E-03_JPRB, 0.35875858E-03_JPRB, &
  & 0.35838602E-03_JPRB, 0.35807022E-03_JPRB, 0.35783980E-03_JPRB, 0.35765721E-03_JPRB, 0.35749824E-03_JPRB, 0.35733648E-03_JPRB, &
  & 0.35716288E-03_JPRB, 0.35696596E-03_JPRB, 0.35673357E-03_JPRB, 0.35646011E-03_JPRB, 0.35616057E-03_JPRB, 0.35589334E-03_JPRB, &
  & 0.35570899E-03_JPRB, 0.35561557E-03_JPRB, 0.35562727E-03_JPRB, 0.35567564E-03_JPRB /)

RGHG1(:, 2, 8) = (/ &
  & 0.35929595E-03_JPRB, 0.35948551E-03_JPRB, 0.35965879E-03_JPRB, 0.35986357E-03_JPRB, 0.36009238E-03_JPRB, 0.36033851E-03_JPRB, &
  & 0.36059381E-03_JPRB, 0.36084716E-03_JPRB, 0.36108302E-03_JPRB, 0.36128645E-03_JPRB, 0.36144757E-03_JPRB, 0.36156742E-03_JPRB, &
  & 0.36165805E-03_JPRB, 0.36173593E-03_JPRB, 0.36181297E-03_JPRB, 0.36189260E-03_JPRB, 0.36197103E-03_JPRB, 0.36204164E-03_JPRB, &
  & 0.36209676E-03_JPRB, 0.36213419E-03_JPRB, 0.36215741E-03_JPRB, 0.36217598E-03_JPRB, 0.36220404E-03_JPRB, 0.36225477E-03_JPRB, &
  & 0.36233608E-03_JPRB, 0.36245229E-03_JPRB, 0.36260436E-03_JPRB, 0.36278920E-03_JPRB, 0.36299753E-03_JPRB, 0.36321423E-03_JPRB, &
  & 0.36342058E-03_JPRB, 0.36359581E-03_JPRB, 0.36372020E-03_JPRB, 0.36378475E-03_JPRB, 0.36379480E-03_JPRB, 0.36375670E-03_JPRB, &
  & 0.36367759E-03_JPRB, 0.36356345E-03_JPRB, 0.36342524E-03_JPRB, 0.36328184E-03_JPRB, 0.36315303E-03_JPRB, 0.36303725E-03_JPRB, &
  & 0.36292191E-03_JPRB, 0.36279496E-03_JPRB, 0.36264214E-03_JPRB, 0.36244866E-03_JPRB, 0.36219385E-03_JPRB, 0.36187115E-03_JPRB, &
  & 0.36152123E-03_JPRB, 0.36117196E-03_JPRB, 0.36085682E-03_JPRB, 0.36057201E-03_JPRB, 0.36029765E-03_JPRB, 0.36000233E-03_JPRB, &
  & 0.35969686E-03_JPRB, 0.35936275E-03_JPRB, 0.35898597E-03_JPRB, 0.35858768E-03_JPRB, 0.35819309E-03_JPRB, 0.35782412E-03_JPRB, &
  & 0.35749329E-03_JPRB, 0.35717615E-03_JPRB, 0.35681768E-03_JPRB, 0.35626371E-03_JPRB /)

RGHG1(:, 3, 8) = (/ &
  & 0.35991185E-03_JPRB, 0.36015769E-03_JPRB, 0.36033368E-03_JPRB, 0.36052158E-03_JPRB, 0.36072242E-03_JPRB, 0.36092816E-03_JPRB, &
  & 0.36113121E-03_JPRB, 0.36132653E-03_JPRB, 0.36151859E-03_JPRB, 0.36172237E-03_JPRB, 0.36195328E-03_JPRB, 0.36221539E-03_JPRB, &
  & 0.36249837E-03_JPRB, 0.36278256E-03_JPRB, 0.36304834E-03_JPRB, 0.36328138E-03_JPRB, 0.36347430E-03_JPRB, 0.36362626E-03_JPRB, &
  & 0.36373956E-03_JPRB, 0.36381761E-03_JPRB, 0.36386360E-03_JPRB, 0.36388278E-03_JPRB, 0.36388540E-03_JPRB, 0.36388956E-03_JPRB, &
  & 0.36392131E-03_JPRB, 0.36400364E-03_JPRB, 0.36413985E-03_JPRB, 0.36430766E-03_JPRB, 0.36447676E-03_JPRB, 0.36462708E-03_JPRB, &
  & 0.36475220E-03_JPRB, 0.36484687E-03_JPRB, 0.36490831E-03_JPRB, 0.36493948E-03_JPRB, 0.36494533E-03_JPRB, 0.36493051E-03_JPRB, &
  & 0.36489824E-03_JPRB, 0.36485068E-03_JPRB, 0.36478977E-03_JPRB, 0.36471998E-03_JPRB, 0.36464803E-03_JPRB, 0.36457749E-03_JPRB, &
  & 0.36450551E-03_JPRB, 0.36442711E-03_JPRB, 0.36433636E-03_JPRB, 0.36422609E-03_JPRB, 0.36408973E-03_JPRB, 0.36392768E-03_JPRB, &
  & 0.36374523E-03_JPRB, 0.36355323E-03_JPRB, 0.36335090E-03_JPRB, 0.36314083E-03_JPRB, 0.36291510E-03_JPRB, 0.36265032E-03_JPRB, &
  & 0.36234691E-03_JPRB, 0.36200421E-03_JPRB, 0.36160840E-03_JPRB, 0.36116585E-03_JPRB, 0.36067722E-03_JPRB, 0.36015178E-03_JPRB, &
  & 0.35961575E-03_JPRB, 0.35907666E-03_JPRB, 0.35850002E-03_JPRB, 0.35763148E-03_JPRB /)

RGHG1(:, 4, 8) = (/ &
  & 0.36028784E-03_JPRB, 0.36055394E-03_JPRB, 0.36074576E-03_JPRB, 0.36094751E-03_JPRB, 0.36117106E-03_JPRB, 0.36141666E-03_JPRB, &
  & 0.36168552E-03_JPRB, 0.36198081E-03_JPRB, 0.36230061E-03_JPRB, 0.36263405E-03_JPRB, 0.36296854E-03_JPRB, 0.36329249E-03_JPRB, &
  & 0.36359529E-03_JPRB, 0.36386764E-03_JPRB, 0.36410411E-03_JPRB, 0.36430382E-03_JPRB, 0.36446823E-03_JPRB, 0.36460019E-03_JPRB, &
  & 0.36470353E-03_JPRB, 0.36478261E-03_JPRB, 0.36484201E-03_JPRB, 0.36488561E-03_JPRB, 0.36491748E-03_JPRB, 0.36494306E-03_JPRB, &
  & 0.36496931E-03_JPRB, 0.36500324E-03_JPRB, 0.36504911E-03_JPRB, 0.36510584E-03_JPRB, 0.36516733E-03_JPRB, 0.36522746E-03_JPRB, &
  & 0.36527982E-03_JPRB, 0.36532013E-03_JPRB, 0.36534722E-03_JPRB, 0.36536195E-03_JPRB, 0.36536582E-03_JPRB, 0.36536029E-03_JPRB, &
  & 0.36534682E-03_JPRB, 0.36532601E-03_JPRB, 0.36529815E-03_JPRB, 0.36526337E-03_JPRB, 0.36522301E-03_JPRB, 0.36517833E-03_JPRB, &
  & 0.36512967E-03_JPRB, 0.36507595E-03_JPRB, 0.36501535E-03_JPRB, 0.36494635E-03_JPRB, 0.36486701E-03_JPRB, 0.36477760E-03_JPRB, &
  & 0.36467999E-03_JPRB, 0.36457294E-03_JPRB, 0.36445539E-03_JPRB, 0.36432283E-03_JPRB, 0.36417210E-03_JPRB, 0.36399500E-03_JPRB, &
  & 0.36377681E-03_JPRB, 0.36351744E-03_JPRB, 0.36320582E-03_JPRB, 0.36283027E-03_JPRB, 0.36240558E-03_JPRB, 0.36195063E-03_JPRB, &
  & 0.36150089E-03_JPRB, 0.36105118E-03_JPRB, 0.36052117E-03_JPRB, 0.35949080E-03_JPRB /)

RGHG1(:, 5, 8) = (/ &
  & 0.36052370E-03_JPRB, 0.36084402E-03_JPRB, 0.36107775E-03_JPRB, 0.36132903E-03_JPRB, 0.36161600E-03_JPRB, 0.36193652E-03_JPRB, &
  & 0.36228221E-03_JPRB, 0.36264109E-03_JPRB, 0.36299700E-03_JPRB, 0.36334389E-03_JPRB, 0.36367468E-03_JPRB, 0.36398225E-03_JPRB, &
  & 0.36425973E-03_JPRB, 0.36450106E-03_JPRB, 0.36470301E-03_JPRB, 0.36486675E-03_JPRB, 0.36499789E-03_JPRB, 0.36510275E-03_JPRB, &
  & 0.36518683E-03_JPRB, 0.36525456E-03_JPRB, 0.36530959E-03_JPRB, 0.36535453E-03_JPRB, 0.36539102E-03_JPRB, 0.36542036E-03_JPRB, &
  & 0.36544370E-03_JPRB, 0.36546245E-03_JPRB, 0.36547886E-03_JPRB, 0.36549487E-03_JPRB, 0.36551204E-03_JPRB, 0.36553072E-03_JPRB, &
  & 0.36555011E-03_JPRB, 0.36556876E-03_JPRB, 0.36558646E-03_JPRB, 0.36560133E-03_JPRB, 0.36561274E-03_JPRB, 0.36561963E-03_JPRB, &
  & 0.36562217E-03_JPRB, 0.36562013E-03_JPRB, 0.36561314E-03_JPRB, 0.36560022E-03_JPRB, 0.36558000E-03_JPRB, 0.36555179E-03_JPRB, &
  & 0.36551518E-03_JPRB, 0.36547077E-03_JPRB, 0.36541876E-03_JPRB, 0.36535854E-03_JPRB, 0.36528998E-03_JPRB, 0.36521279E-03_JPRB, &
  & 0.36512630E-03_JPRB, 0.36503081E-03_JPRB, 0.36492525E-03_JPRB, 0.36480755E-03_JPRB, 0.36467559E-03_JPRB, 0.36452722E-03_JPRB, &
  & 0.36435673E-03_JPRB, 0.36415557E-03_JPRB, 0.36392314E-03_JPRB, 0.36365792E-03_JPRB, 0.36336549E-03_JPRB, 0.36306298E-03_JPRB, &
  & 0.36274662E-03_JPRB, 0.36240072E-03_JPRB, 0.36197639E-03_JPRB, 0.36118264E-03_JPRB /)

RGHG1(:, 6, 8) = (/ &
  & 0.36073715E-03_JPRB, 0.36113895E-03_JPRB, 0.36143156E-03_JPRB, 0.36173986E-03_JPRB, 0.36207665E-03_JPRB, 0.36244252E-03_JPRB, &
  & 0.36282311E-03_JPRB, 0.36319724E-03_JPRB, 0.36355515E-03_JPRB, 0.36388868E-03_JPRB, 0.36419541E-03_JPRB, 0.36447076E-03_JPRB, &
  & 0.36471037E-03_JPRB, 0.36491218E-03_JPRB, 0.36507804E-03_JPRB, 0.36521215E-03_JPRB, 0.36531981E-03_JPRB, 0.36540689E-03_JPRB, &
  & 0.36547863E-03_JPRB, 0.36553922E-03_JPRB, 0.36559172E-03_JPRB, 0.36563820E-03_JPRB, 0.36567950E-03_JPRB, 0.36571521E-03_JPRB, &
  & 0.36574405E-03_JPRB, 0.36576463E-03_JPRB, 0.36577642E-03_JPRB, 0.36578075E-03_JPRB, 0.36578087E-03_JPRB, 0.36578067E-03_JPRB, &
  & 0.36578273E-03_JPRB, 0.36578937E-03_JPRB, 0.36580194E-03_JPRB, 0.36582071E-03_JPRB, 0.36584362E-03_JPRB, 0.36586807E-03_JPRB, &
  & 0.36589132E-03_JPRB, 0.36591146E-03_JPRB, 0.36592697E-03_JPRB, 0.36593544E-03_JPRB, 0.36593416E-03_JPRB, 0.36592048E-03_JPRB, &
  & 0.36589344E-03_JPRB, 0.36585386E-03_JPRB, 0.36580313E-03_JPRB, 0.36574178E-03_JPRB, 0.36566961E-03_JPRB, 0.36558593E-03_JPRB, &
  & 0.36549059E-03_JPRB, 0.36538352E-03_JPRB, 0.36526442E-03_JPRB, 0.36513308E-03_JPRB, 0.36498829E-03_JPRB, 0.36483002E-03_JPRB, &
  & 0.36465816E-03_JPRB, 0.36447222E-03_JPRB, 0.36426910E-03_JPRB, 0.36405461E-03_JPRB, 0.36383260E-03_JPRB, 0.36360574E-03_JPRB, &
  & 0.36337657E-03_JPRB, 0.36314450E-03_JPRB, 0.36288082E-03_JPRB, 0.36236018E-03_JPRB /)

RGHG1(:, 7, 8) = (/ &
  & 0.36101963E-03_JPRB, 0.36151320E-03_JPRB, 0.36186032E-03_JPRB, 0.36219190E-03_JPRB, 0.36254639E-03_JPRB, 0.36291755E-03_JPRB, &
  & 0.36329075E-03_JPRB, 0.36365035E-03_JPRB, 0.36398403E-03_JPRB, 0.36428953E-03_JPRB, 0.36456488E-03_JPRB, 0.36480813E-03_JPRB, &
  & 0.36501838E-03_JPRB, 0.36519504E-03_JPRB, 0.36534050E-03_JPRB, 0.36545884E-03_JPRB, 0.36555543E-03_JPRB, 0.36563561E-03_JPRB, &
  & 0.36570380E-03_JPRB, 0.36576350E-03_JPRB, 0.36581731E-03_JPRB, 0.36586734E-03_JPRB, 0.36591460E-03_JPRB, 0.36595861E-03_JPRB, &
  & 0.36599723E-03_JPRB, 0.36602741E-03_JPRB, 0.36604609E-03_JPRB, 0.36605305E-03_JPRB, 0.36605052E-03_JPRB, 0.36604263E-03_JPRB, &
  & 0.36603436E-03_JPRB, 0.36603227E-03_JPRB, 0.36604205E-03_JPRB, 0.36606603E-03_JPRB, 0.36610250E-03_JPRB, 0.36614647E-03_JPRB, &
  & 0.36619283E-03_JPRB, 0.36623754E-03_JPRB, 0.36627671E-03_JPRB, 0.36630663E-03_JPRB, 0.36632273E-03_JPRB, 0.36632127E-03_JPRB, &
  & 0.36630046E-03_JPRB, 0.36626181E-03_JPRB, 0.36620750E-03_JPRB, 0.36613815E-03_JPRB, 0.36605450E-03_JPRB, 0.36595689E-03_JPRB, &
  & 0.36584586E-03_JPRB, 0.36572246E-03_JPRB, 0.36558794E-03_JPRB, 0.36544248E-03_JPRB, 0.36528596E-03_JPRB, 0.36511786E-03_JPRB, &
  & 0.36493869E-03_JPRB, 0.36474998E-03_JPRB, 0.36455481E-03_JPRB, 0.36435627E-03_JPRB, 0.36416244E-03_JPRB, 0.36397402E-03_JPRB, &
  & 0.36379459E-03_JPRB, 0.36362497E-03_JPRB, 0.36343487E-03_JPRB, 0.36309764E-03_JPRB /)

RGHG1(:, 8, 8) = (/ &
  & 0.36142673E-03_JPRB, 0.36199138E-03_JPRB, 0.36234403E-03_JPRB, 0.36266888E-03_JPRB, 0.36299758E-03_JPRB, 0.36333990E-03_JPRB, &
  & 0.36368170E-03_JPRB, 0.36400964E-03_JPRB, 0.36431430E-03_JPRB, 0.36459236E-03_JPRB, 0.36484201E-03_JPRB, 0.36506244E-03_JPRB, &
  & 0.36525275E-03_JPRB, 0.36541341E-03_JPRB, 0.36554653E-03_JPRB, 0.36565584E-03_JPRB, 0.36574589E-03_JPRB, 0.36582109E-03_JPRB, &
  & 0.36588605E-03_JPRB, 0.36594490E-03_JPRB, 0.36600063E-03_JPRB, 0.36605538E-03_JPRB, 0.36611053E-03_JPRB, 0.36616623E-03_JPRB, &
  & 0.36621990E-03_JPRB, 0.36626661E-03_JPRB, 0.36630186E-03_JPRB, 0.36632325E-03_JPRB, 0.36633061E-03_JPRB, 0.36632712E-03_JPRB, &
  & 0.36631996E-03_JPRB, 0.36631915E-03_JPRB, 0.36633186E-03_JPRB, 0.36636178E-03_JPRB, 0.36640812E-03_JPRB, 0.36646737E-03_JPRB, &
  & 0.36653318E-03_JPRB, 0.36659939E-03_JPRB, 0.36665998E-03_JPRB, 0.36670873E-03_JPRB, 0.36673943E-03_JPRB, 0.36674732E-03_JPRB, &
  & 0.36673064E-03_JPRB, 0.36669007E-03_JPRB, 0.36662788E-03_JPRB, 0.36654586E-03_JPRB, 0.36644502E-03_JPRB, 0.36632677E-03_JPRB, &
  & 0.36619362E-03_JPRB, 0.36604935E-03_JPRB, 0.36589746E-03_JPRB, 0.36574071E-03_JPRB, 0.36557982E-03_JPRB, 0.36541486E-03_JPRB, &
  & 0.36524559E-03_JPRB, 0.36507231E-03_JPRB, 0.36489655E-03_JPRB, 0.36472105E-03_JPRB, 0.36454957E-03_JPRB, 0.36438982E-03_JPRB, &
  & 0.36424407E-03_JPRB, 0.36410193E-03_JPRB, 0.36394532E-03_JPRB, 0.36368013E-03_JPRB /)

RGHG1(:, 9, 8) = (/ &
  & 0.36196900E-03_JPRB, 0.36254799E-03_JPRB, 0.36286761E-03_JPRB, 0.36315565E-03_JPRB, 0.36344017E-03_JPRB, 0.36373510E-03_JPRB, &
  & 0.36403490E-03_JPRB, 0.36432658E-03_JPRB, 0.36460100E-03_JPRB, 0.36485249E-03_JPRB, 0.36507912E-03_JPRB, 0.36527909E-03_JPRB, &
  & 0.36545203E-03_JPRB, 0.36559859E-03_JPRB, 0.36572083E-03_JPRB, 0.36582208E-03_JPRB, 0.36590640E-03_JPRB, 0.36597808E-03_JPRB, &
  & 0.36604094E-03_JPRB, 0.36609874E-03_JPRB, 0.36615517E-03_JPRB, 0.36621350E-03_JPRB, 0.36627537E-03_JPRB, 0.36634188E-03_JPRB, &
  & 0.36641161E-03_JPRB, 0.36647997E-03_JPRB, 0.36654144E-03_JPRB, 0.36659106E-03_JPRB, 0.36662686E-03_JPRB, 0.36665105E-03_JPRB, &
  & 0.36666848E-03_JPRB, 0.36668591E-03_JPRB, 0.36671016E-03_JPRB, 0.36674723E-03_JPRB, 0.36679965E-03_JPRB, 0.36686548E-03_JPRB, &
  & 0.36693996E-03_JPRB, 0.36701659E-03_JPRB, 0.36708743E-03_JPRB, 0.36714427E-03_JPRB, 0.36718033E-03_JPRB, 0.36719051E-03_JPRB, &
  & 0.36717195E-03_JPRB, 0.36712544E-03_JPRB, 0.36705262E-03_JPRB, 0.36695463E-03_JPRB, 0.36683347E-03_JPRB, 0.36669159E-03_JPRB, &
  & 0.36653347E-03_JPRB, 0.36636542E-03_JPRB, 0.36619289E-03_JPRB, 0.36602130E-03_JPRB, 0.36585424E-03_JPRB, 0.36569455E-03_JPRB, &
  & 0.36554405E-03_JPRB, 0.36540403E-03_JPRB, 0.36527499E-03_JPRB, 0.36515642E-03_JPRB, 0.36504725E-03_JPRB, 0.36494623E-03_JPRB, &
  & 0.36485150E-03_JPRB, 0.36475473E-03_JPRB, 0.36463837E-03_JPRB, 0.36439305E-03_JPRB /)

RGHG1(:,10, 8) = (/ &
  & 0.36264255E-03_JPRB, 0.36314444E-03_JPRB, 0.36343807E-03_JPRB, 0.36366825E-03_JPRB, 0.36390414E-03_JPRB, 0.36414605E-03_JPRB, &
  & 0.36439687E-03_JPRB, 0.36464707E-03_JPRB, 0.36488622E-03_JPRB, 0.36510819E-03_JPRB, 0.36530895E-03_JPRB, 0.36548602E-03_JPRB, &
  & 0.36563922E-03_JPRB, 0.36576967E-03_JPRB, 0.36587942E-03_JPRB, 0.36597141E-03_JPRB, 0.36604912E-03_JPRB, 0.36611588E-03_JPRB, &
  & 0.36617555E-03_JPRB, 0.36623213E-03_JPRB, 0.36628920E-03_JPRB, 0.36635096E-03_JPRB, 0.36642145E-03_JPRB, 0.36650378E-03_JPRB, &
  & 0.36659674E-03_JPRB, 0.36669566E-03_JPRB, 0.36679511E-03_JPRB, 0.36689002E-03_JPRB, 0.36697814E-03_JPRB, 0.36705771E-03_JPRB, &
  & 0.36712672E-03_JPRB, 0.36718554E-03_JPRB, 0.36723848E-03_JPRB, 0.36729188E-03_JPRB, 0.36735006E-03_JPRB, 0.36741426E-03_JPRB, &
  & 0.36748120E-03_JPRB, 0.36754546E-03_JPRB, 0.36760041E-03_JPRB, 0.36763915E-03_JPRB, 0.36765696E-03_JPRB, 0.36764919E-03_JPRB, &
  & 0.36761415E-03_JPRB, 0.36755161E-03_JPRB, 0.36746162E-03_JPRB, 0.36734540E-03_JPRB, 0.36720480E-03_JPRB, 0.36704299E-03_JPRB, &
  & 0.36686528E-03_JPRB, 0.36667826E-03_JPRB, 0.36648891E-03_JPRB, 0.36630264E-03_JPRB, 0.36612403E-03_JPRB, 0.36595738E-03_JPRB, &
  & 0.36580587E-03_JPRB, 0.36567161E-03_JPRB, 0.36555665E-03_JPRB, 0.36546023E-03_JPRB, 0.36538337E-03_JPRB, 0.36532138E-03_JPRB, &
  & 0.36527368E-03_JPRB, 0.36523450E-03_JPRB, 0.36519897E-03_JPRB, 0.36514236E-03_JPRB /)

RGHG1(:,11, 8) = (/ &
  & 0.36332669E-03_JPRB, 0.36376278E-03_JPRB, 0.36396677E-03_JPRB, 0.36415327E-03_JPRB, 0.36432565E-03_JPRB, 0.36451334E-03_JPRB, &
  & 0.36471154E-03_JPRB, 0.36491590E-03_JPRB, 0.36511716E-03_JPRB, 0.36530831E-03_JPRB, 0.36548328E-03_JPRB, 0.36563899E-03_JPRB, &
  & 0.36577441E-03_JPRB, 0.36589062E-03_JPRB, 0.36598960E-03_JPRB, 0.36607424E-03_JPRB, 0.36614740E-03_JPRB, 0.36621222E-03_JPRB, &
  & 0.36627206E-03_JPRB, 0.36632997E-03_JPRB, 0.36639022E-03_JPRB, 0.36645762E-03_JPRB, 0.36653722E-03_JPRB, 0.36663347E-03_JPRB, &
  & 0.36674796E-03_JPRB, 0.36687855E-03_JPRB, 0.36701967E-03_JPRB, 0.36716930E-03_JPRB, 0.36732439E-03_JPRB, 0.36747823E-03_JPRB, &
  & 0.36762230E-03_JPRB, 0.36774940E-03_JPRB, 0.36785615E-03_JPRB, 0.36794419E-03_JPRB, 0.36801564E-03_JPRB, 0.36807326E-03_JPRB, &
  & 0.36811689E-03_JPRB, 0.36814684E-03_JPRB, 0.36816057E-03_JPRB, 0.36815772E-03_JPRB, 0.36813537E-03_JPRB, 0.36809218E-03_JPRB, &
  & 0.36802754E-03_JPRB, 0.36794005E-03_JPRB, 0.36782946E-03_JPRB, 0.36769619E-03_JPRB, 0.36754148E-03_JPRB, 0.36736840E-03_JPRB, &
  & 0.36718248E-03_JPRB, 0.36699080E-03_JPRB, 0.36679886E-03_JPRB, 0.36661135E-03_JPRB, 0.36643274E-03_JPRB, 0.36626626E-03_JPRB, &
  & 0.36611498E-03_JPRB, 0.36598145E-03_JPRB, 0.36586740E-03_JPRB, 0.36577284E-03_JPRB, 0.36569810E-03_JPRB, 0.36563980E-03_JPRB, &
  & 0.36559772E-03_JPRB, 0.36556408E-03_JPRB, 0.36553849E-03_JPRB, 0.36549874E-03_JPRB /)

RGHG1(:,12, 8) = (/ &
  & 0.36389922E-03_JPRB, 0.36415842E-03_JPRB, 0.36430144E-03_JPRB, 0.36441290E-03_JPRB, 0.36453619E-03_JPRB, 0.36466922E-03_JPRB, &
  & 0.36481995E-03_JPRB, 0.36498264E-03_JPRB, 0.36514970E-03_JPRB, 0.36531378E-03_JPRB, 0.36546873E-03_JPRB, 0.36561061E-03_JPRB, &
  & 0.36573847E-03_JPRB, 0.36585331E-03_JPRB, 0.36595744E-03_JPRB, 0.36605328E-03_JPRB, 0.36614167E-03_JPRB, 0.36622421E-03_JPRB, &
  & 0.36630247E-03_JPRB, 0.36637927E-03_JPRB, 0.36645847E-03_JPRB, 0.36654493E-03_JPRB, 0.36664470E-03_JPRB, 0.36676240E-03_JPRB, &
  & 0.36690055E-03_JPRB, 0.36705725E-03_JPRB, 0.36723274E-03_JPRB, 0.36742026E-03_JPRB, 0.36761517E-03_JPRB, 0.36781671E-03_JPRB, &
  & 0.36801537E-03_JPRB, 0.36819451E-03_JPRB, 0.36834241E-03_JPRB, 0.36845679E-03_JPRB, 0.36853910E-03_JPRB, 0.36859326E-03_JPRB, &
  & 0.36862158E-03_JPRB, 0.36862807E-03_JPRB, 0.36861238E-03_JPRB, 0.36857871E-03_JPRB, 0.36852612E-03_JPRB, 0.36845557E-03_JPRB, &
  & 0.36836666E-03_JPRB, 0.36825973E-03_JPRB, 0.36813418E-03_JPRB, 0.36799052E-03_JPRB, 0.36783057E-03_JPRB, 0.36765813E-03_JPRB, &
  & 0.36747890E-03_JPRB, 0.36729823E-03_JPRB, 0.36712131E-03_JPRB, 0.36695192E-03_JPRB, 0.36679290E-03_JPRB, 0.36664633E-03_JPRB, &
  & 0.36651443E-03_JPRB, 0.36639872E-03_JPRB, 0.36630037E-03_JPRB, 0.36621984E-03_JPRB, 0.36615788E-03_JPRB, 0.36611155E-03_JPRB, &
  & 0.36608221E-03_JPRB, 0.36606047E-03_JPRB, 0.36605491E-03_JPRB, 0.36604775E-03_JPRB /)

RGHG1(:,13, 8) = (/ &
  & 0.36413912E-03_JPRB, 0.36422815E-03_JPRB, 0.36428860E-03_JPRB, 0.36436203E-03_JPRB, 0.36445021E-03_JPRB, 0.36456477E-03_JPRB, &
  & 0.36470292E-03_JPRB, 0.36486299E-03_JPRB, 0.36503933E-03_JPRB, 0.36522743E-03_JPRB, 0.36542342E-03_JPRB, 0.36562339E-03_JPRB, &
  & 0.36582159E-03_JPRB, 0.36601050E-03_JPRB, 0.36618358E-03_JPRB, 0.36633448E-03_JPRB, 0.36646158E-03_JPRB, 0.36656414E-03_JPRB, &
  & 0.36664706E-03_JPRB, 0.36671685E-03_JPRB, 0.36678085E-03_JPRB, 0.36684735E-03_JPRB, 0.36692488E-03_JPRB, 0.36702113E-03_JPRB, &
  & 0.36714019E-03_JPRB, 0.36728385E-03_JPRB, 0.36745140E-03_JPRB, 0.36764549E-03_JPRB, 0.36786130E-03_JPRB, 0.36808354E-03_JPRB, &
  & 0.36830071E-03_JPRB, 0.36849812E-03_JPRB, 0.36866212E-03_JPRB, 0.36878765E-03_JPRB, 0.36887598E-03_JPRB, 0.36893008E-03_JPRB, &
  & 0.36895325E-03_JPRB, 0.36894923E-03_JPRB, 0.36892117E-03_JPRB, 0.36887257E-03_JPRB, 0.36880517E-03_JPRB, 0.36872120E-03_JPRB, &
  & 0.36862132E-03_JPRB, 0.36850615E-03_JPRB, 0.36837623E-03_JPRB, 0.36823290E-03_JPRB, 0.36807920E-03_JPRB, 0.36791846E-03_JPRB, &
  & 0.36775650E-03_JPRB, 0.36759899E-03_JPRB, 0.36744971E-03_JPRB, 0.36731115E-03_JPRB, 0.36718455E-03_JPRB, 0.36707078E-03_JPRB, &
  & 0.36697046E-03_JPRB, 0.36688385E-03_JPRB, 0.36681161E-03_JPRB, 0.36675387E-03_JPRB, 0.36671117E-03_JPRB, 0.36668082E-03_JPRB, &
  & 0.36666633E-03_JPRB, 0.36665803E-03_JPRB, 0.36666787E-03_JPRB, 0.36668940E-03_JPRB /)

RGHG1(:,14, 8) = (/ &
  & 0.36432859E-03_JPRB, 0.36451136E-03_JPRB, 0.36463625E-03_JPRB, 0.36473846E-03_JPRB, 0.36484367E-03_JPRB, 0.36496014E-03_JPRB, &
  & 0.36510144E-03_JPRB, 0.36527184E-03_JPRB, 0.36547187E-03_JPRB, 0.36569667E-03_JPRB, 0.36593736E-03_JPRB, 0.36618291E-03_JPRB, &
  & 0.36642107E-03_JPRB, 0.36663862E-03_JPRB, 0.36682491E-03_JPRB, 0.36697488E-03_JPRB, 0.36708923E-03_JPRB, 0.36717331E-03_JPRB, &
  & 0.36723333E-03_JPRB, 0.36727669E-03_JPRB, 0.36731045E-03_JPRB, 0.36734191E-03_JPRB, 0.36737957E-03_JPRB, 0.36743219E-03_JPRB, &
  & 0.36750713E-03_JPRB, 0.36761083E-03_JPRB, 0.36774666E-03_JPRB, 0.36791153E-03_JPRB, 0.36810467E-03_JPRB, 0.36831727E-03_JPRB, &
  & 0.36852941E-03_JPRB, 0.36872528E-03_JPRB, 0.36889128E-03_JPRB, 0.36902080E-03_JPRB, 0.36911239E-03_JPRB, 0.36916690E-03_JPRB, &
  & 0.36918765E-03_JPRB, 0.36917866E-03_JPRB, 0.36914437E-03_JPRB, 0.36908861E-03_JPRB, 0.36901492E-03_JPRB, 0.36892574E-03_JPRB, &
  & 0.36882289E-03_JPRB, 0.36870816E-03_JPRB, 0.36858273E-03_JPRB, 0.36844879E-03_JPRB, 0.36830956E-03_JPRB, 0.36816986E-03_JPRB, &
  & 0.36803438E-03_JPRB, 0.36790693E-03_JPRB, 0.36779034E-03_JPRB, 0.36768534E-03_JPRB, 0.36759209E-03_JPRB, 0.36751042E-03_JPRB, &
  & 0.36743964E-03_JPRB, 0.36737975E-03_JPRB, 0.36733056E-03_JPRB, 0.36729226E-03_JPRB, 0.36726525E-03_JPRB, 0.36724791E-03_JPRB, &
  & 0.36724337E-03_JPRB, 0.36724418E-03_JPRB, 0.36726127E-03_JPRB, 0.36729773E-03_JPRB /)

RGHG1(:,15, 8) = (/ &
  & 0.36518456E-03_JPRB, 0.36549583E-03_JPRB, 0.36561259E-03_JPRB, 0.36568771E-03_JPRB, 0.36575343E-03_JPRB, 0.36583061E-03_JPRB, &
  & 0.36592840E-03_JPRB, 0.36605596E-03_JPRB, 0.36621498E-03_JPRB, 0.36640288E-03_JPRB, 0.36661158E-03_JPRB, 0.36682794E-03_JPRB, &
  & 0.36703734E-03_JPRB, 0.36722719E-03_JPRB, 0.36738865E-03_JPRB, 0.36751747E-03_JPRB, 0.36761462E-03_JPRB, 0.36768508E-03_JPRB, &
  & 0.36773545E-03_JPRB, 0.36777189E-03_JPRB, 0.36780033E-03_JPRB, 0.36782579E-03_JPRB, 0.36785379E-03_JPRB, 0.36789023E-03_JPRB, &
  & 0.36794227E-03_JPRB, 0.36801596E-03_JPRB, 0.36811767E-03_JPRB, 0.36825056E-03_JPRB, 0.36841014E-03_JPRB, 0.36859018E-03_JPRB, &
  & 0.36877682E-03_JPRB, 0.36895386E-03_JPRB, 0.36910758E-03_JPRB, 0.36922985E-03_JPRB, 0.36931538E-03_JPRB, 0.36936495E-03_JPRB, &
  & 0.36938104E-03_JPRB, 0.36936803E-03_JPRB, 0.36933078E-03_JPRB, 0.36927388E-03_JPRB, 0.36920086E-03_JPRB, 0.36911416E-03_JPRB, &
  & 0.36901637E-03_JPRB, 0.36890910E-03_JPRB, 0.36879454E-03_JPRB, 0.36867589E-03_JPRB, 0.36855671E-03_JPRB, 0.36844116E-03_JPRB, &
  & 0.36833293E-03_JPRB, 0.36823450E-03_JPRB, 0.36814716E-03_JPRB, 0.36807021E-03_JPRB, 0.36800301E-03_JPRB, 0.36794448E-03_JPRB, &
  & 0.36789390E-03_JPRB, 0.36785117E-03_JPRB, 0.36781625E-03_JPRB, 0.36778970E-03_JPRB, 0.36777169E-03_JPRB, 0.36776159E-03_JPRB, &
  & 0.36776086E-03_JPRB, 0.36776593E-03_JPRB, 0.36778382E-03_JPRB, 0.36782425E-03_JPRB /)

RGHG1(:,16, 8) = (/ &
  & 0.36641391E-03_JPRB, 0.36656609E-03_JPRB, 0.36660145E-03_JPRB, 0.36662089E-03_JPRB, 0.36663245E-03_JPRB, 0.36665768E-03_JPRB, &
  & 0.36670454E-03_JPRB, 0.36677983E-03_JPRB, 0.36688824E-03_JPRB, 0.36702692E-03_JPRB, 0.36718894E-03_JPRB, 0.36736514E-03_JPRB, &
  & 0.36754159E-03_JPRB, 0.36770641E-03_JPRB, 0.36785050E-03_JPRB, 0.36796977E-03_JPRB, 0.36806459E-03_JPRB, 0.36813848E-03_JPRB, &
  & 0.36819602E-03_JPRB, 0.36824209E-03_JPRB, 0.36828109E-03_JPRB, 0.36831695E-03_JPRB, 0.36835345E-03_JPRB, 0.36839474E-03_JPRB, &
  & 0.36844535E-03_JPRB, 0.36851023E-03_JPRB, 0.36859323E-03_JPRB, 0.36869745E-03_JPRB, 0.36882184E-03_JPRB, 0.36896026E-03_JPRB, &
  & 0.36910397E-03_JPRB, 0.36924091E-03_JPRB, 0.36936015E-03_JPRB, 0.36945363E-03_JPRB, 0.36951783E-03_JPRB, 0.36955229E-03_JPRB, &
  & 0.36955901E-03_JPRB, 0.36954254E-03_JPRB, 0.36950700E-03_JPRB, 0.36945633E-03_JPRB, 0.36939277E-03_JPRB, 0.36931824E-03_JPRB, &
  & 0.36923416E-03_JPRB, 0.36914254E-03_JPRB, 0.36904565E-03_JPRB, 0.36894661E-03_JPRB, 0.36884891E-03_JPRB, 0.36875592E-03_JPRB, &
  & 0.36867044E-03_JPRB, 0.36859355E-03_JPRB, 0.36852527E-03_JPRB, 0.36846477E-03_JPRB, 0.36841087E-03_JPRB, 0.36836302E-03_JPRB, &
  & 0.36832091E-03_JPRB, 0.36828479E-03_JPRB, 0.36825510E-03_JPRB, 0.36823226E-03_JPRB, 0.36821674E-03_JPRB, 0.36820839E-03_JPRB, &
  & 0.36820729E-03_JPRB, 0.36821282E-03_JPRB, 0.36822847E-03_JPRB, 0.36826578E-03_JPRB /)

RGHG1(:,17, 8) = (/ &
  & 0.36736004E-03_JPRB, 0.36738045E-03_JPRB, 0.36736036E-03_JPRB, 0.36733988E-03_JPRB, 0.36731639E-03_JPRB, 0.36730818E-03_JPRB, &
  & 0.36731726E-03_JPRB, 0.36735524E-03_JPRB, 0.36742503E-03_JPRB, 0.36752707E-03_JPRB, 0.36765562E-03_JPRB, 0.36780277E-03_JPRB, &
  & 0.36795891E-03_JPRB, 0.36811345E-03_JPRB, 0.36825673E-03_JPRB, 0.36838267E-03_JPRB, 0.36848977E-03_JPRB, 0.36857984E-03_JPRB, &
  & 0.36865607E-03_JPRB, 0.36872213E-03_JPRB, 0.36878191E-03_JPRB, 0.36883884E-03_JPRB, 0.36889603E-03_JPRB, 0.36895624E-03_JPRB, &
  & 0.36902181E-03_JPRB, 0.36909396E-03_JPRB, 0.36917318E-03_JPRB, 0.36925761E-03_JPRB, 0.36934516E-03_JPRB, 0.36943160E-03_JPRB, &
  & 0.36951402E-03_JPRB, 0.36958742E-03_JPRB, 0.36964926E-03_JPRB, 0.36969475E-03_JPRB, 0.36972197E-03_JPRB, 0.36973105E-03_JPRB, &
  & 0.36972549E-03_JPRB, 0.36970680E-03_JPRB, 0.36967773E-03_JPRB, 0.36964013E-03_JPRB, 0.36959426E-03_JPRB, 0.36954053E-03_JPRB, &
  & 0.36947880E-03_JPRB, 0.36940980E-03_JPRB, 0.36933541E-03_JPRB, 0.36925770E-03_JPRB, 0.36917994E-03_JPRB, 0.36910447E-03_JPRB, &
  & 0.36903340E-03_JPRB, 0.36896762E-03_JPRB, 0.36890694E-03_JPRB, 0.36885065E-03_JPRB, 0.36879856E-03_JPRB, 0.36875095E-03_JPRB, &
  & 0.36870810E-03_JPRB, 0.36867091E-03_JPRB, 0.36863988E-03_JPRB, 0.36861573E-03_JPRB, 0.36859856E-03_JPRB, 0.36858843E-03_JPRB, &
  & 0.36858494E-03_JPRB, 0.36858837E-03_JPRB, 0.36859940E-03_JPRB, 0.36863040E-03_JPRB /)

RGHG1(:,18, 8) = (/ &
  & 0.36799384E-03_JPRB, 0.36795903E-03_JPRB, 0.36791078E-03_JPRB, 0.36787527E-03_JPRB, 0.36783464E-03_JPRB, 0.36780880E-03_JPRB, &
  & 0.36779852E-03_JPRB, 0.36781258E-03_JPRB, 0.36785705E-03_JPRB, 0.36793383E-03_JPRB, 0.36804040E-03_JPRB, 0.36817143E-03_JPRB, &
  & 0.36831811E-03_JPRB, 0.36847108E-03_JPRB, 0.36862103E-03_JPRB, 0.36875976E-03_JPRB, 0.36888299E-03_JPRB, 0.36899056E-03_JPRB, &
  & 0.36908471E-03_JPRB, 0.36916917E-03_JPRB, 0.36924725E-03_JPRB, 0.36932220E-03_JPRB, 0.36939708E-03_JPRB, 0.36947394E-03_JPRB, &
  & 0.36955232E-03_JPRB, 0.36963029E-03_JPRB, 0.36970407E-03_JPRB, 0.36976952E-03_JPRB, 0.36982301E-03_JPRB, 0.36986446E-03_JPRB, &
  & 0.36989371E-03_JPRB, 0.36991190E-03_JPRB, 0.36991976E-03_JPRB, 0.36991879E-03_JPRB, 0.36991050E-03_JPRB, 0.36989676E-03_JPRB, &
  & 0.36987907E-03_JPRB, 0.36985922E-03_JPRB, 0.36983832E-03_JPRB, 0.36981562E-03_JPRB, 0.36978969E-03_JPRB, 0.36975843E-03_JPRB, &
  & 0.36972051E-03_JPRB, 0.36967511E-03_JPRB, 0.36962281E-03_JPRB, 0.36956498E-03_JPRB, 0.36950369E-03_JPRB, 0.36944074E-03_JPRB, &
  & 0.36937799E-03_JPRB, 0.36931629E-03_JPRB, 0.36925590E-03_JPRB, 0.36919763E-03_JPRB, 0.36914210E-03_JPRB, 0.36909018E-03_JPRB, &
  & 0.36904326E-03_JPRB, 0.36900217E-03_JPRB, 0.36896748E-03_JPRB, 0.36893977E-03_JPRB, 0.36891919E-03_JPRB, 0.36890566E-03_JPRB, &
  & 0.36889882E-03_JPRB, 0.36889836E-03_JPRB, 0.36890520E-03_JPRB, 0.36892950E-03_JPRB /)

RGHG1(:,19, 8) = (/ &
  & 0.36842082E-03_JPRB, 0.36836709E-03_JPRB, 0.36831514E-03_JPRB, 0.36827417E-03_JPRB, 0.36823272E-03_JPRB, 0.36820016E-03_JPRB, &
  & 0.36818066E-03_JPRB, 0.36818290E-03_JPRB, 0.36821258E-03_JPRB, 0.36827388E-03_JPRB, 0.36836570E-03_JPRB, 0.36848514E-03_JPRB, &
  & 0.36862522E-03_JPRB, 0.36877676E-03_JPRB, 0.36892941E-03_JPRB, 0.36907406E-03_JPRB, 0.36920494E-03_JPRB, 0.36931969E-03_JPRB, &
  & 0.36941981E-03_JPRB, 0.36950898E-03_JPRB, 0.36959129E-03_JPRB, 0.36967004E-03_JPRB, 0.36974781E-03_JPRB, 0.36982622E-03_JPRB, &
  & 0.36990480E-03_JPRB, 0.36998058E-03_JPRB, 0.37004834E-03_JPRB, 0.37010180E-03_JPRB, 0.37013798E-03_JPRB, 0.37015599E-03_JPRB, &
  & 0.37015835E-03_JPRB, 0.37014738E-03_JPRB, 0.37012692E-03_JPRB, 0.37009930E-03_JPRB, 0.37006979E-03_JPRB, 0.37004126E-03_JPRB, &
  & 0.37001618E-03_JPRB, 0.36999662E-03_JPRB, 0.36998294E-03_JPRB, 0.36997275E-03_JPRB, 0.36996289E-03_JPRB, 0.36994932E-03_JPRB, &
  & 0.36993009E-03_JPRB, 0.36990302E-03_JPRB, 0.36986780E-03_JPRB, 0.36982508E-03_JPRB, 0.36977601E-03_JPRB, 0.36972217E-03_JPRB, &
  & 0.36966454E-03_JPRB, 0.36960474E-03_JPRB, 0.36954420E-03_JPRB, 0.36948393E-03_JPRB, 0.36942540E-03_JPRB, 0.36936998E-03_JPRB, &
  & 0.36931955E-03_JPRB, 0.36927505E-03_JPRB, 0.36923736E-03_JPRB, 0.36920654E-03_JPRB, 0.36918279E-03_JPRB, 0.36916597E-03_JPRB, &
  & 0.36915595E-03_JPRB, 0.36915232E-03_JPRB, 0.36915534E-03_JPRB, 0.36917286E-03_JPRB /)

RGHG1(:,20, 8) = (/ &
  & 0.36872589E-03_JPRB, 0.36866954E-03_JPRB, 0.36862254E-03_JPRB, 0.36858246E-03_JPRB, 0.36854533E-03_JPRB, 0.36851308E-03_JPRB, &
  & 0.36849210E-03_JPRB, 0.36848895E-03_JPRB, 0.36851040E-03_JPRB, 0.36856090E-03_JPRB, 0.36864111E-03_JPRB, 0.36874917E-03_JPRB, &
  & 0.36887909E-03_JPRB, 0.36902254E-03_JPRB, 0.36916923E-03_JPRB, 0.36930959E-03_JPRB, 0.36943704E-03_JPRB, 0.36954915E-03_JPRB, &
  & 0.36964705E-03_JPRB, 0.36973323E-03_JPRB, 0.36981181E-03_JPRB, 0.36988629E-03_JPRB, 0.36995916E-03_JPRB, 0.37003218E-03_JPRB, &
  & 0.37010515E-03_JPRB, 0.37017511E-03_JPRB, 0.37023670E-03_JPRB, 0.37028443E-03_JPRB, 0.37031452E-03_JPRB, 0.37032645E-03_JPRB, &
  & 0.37032180E-03_JPRB, 0.37030305E-03_JPRB, 0.37027354E-03_JPRB, 0.37023713E-03_JPRB, 0.37019880E-03_JPRB, 0.37016414E-03_JPRB, &
  & 0.37013780E-03_JPRB, 0.37012095E-03_JPRB, 0.37011239E-03_JPRB, 0.37010974E-03_JPRB, 0.37010940E-03_JPRB, 0.37010672E-03_JPRB, &
  & 0.37009860E-03_JPRB, 0.37008277E-03_JPRB, 0.37005829E-03_JPRB, 0.37002555E-03_JPRB, 0.36998489E-03_JPRB, 0.36993710E-03_JPRB, &
  & 0.36988413E-03_JPRB, 0.36982729E-03_JPRB, 0.36976812E-03_JPRB, 0.36970814E-03_JPRB, 0.36964915E-03_JPRB, 0.36959318E-03_JPRB, &
  & 0.36954193E-03_JPRB, 0.36949624E-03_JPRB, 0.36945683E-03_JPRB, 0.36942409E-03_JPRB, 0.36939804E-03_JPRB, 0.36937895E-03_JPRB, &
  & 0.36936640E-03_JPRB, 0.36935991E-03_JPRB, 0.36935930E-03_JPRB, 0.36937042E-03_JPRB /)

RGHG1(:,21, 8) = (/ &
  & 0.36896227E-03_JPRB, 0.36890691E-03_JPRB, 0.36886643E-03_JPRB, 0.36883092E-03_JPRB, 0.36879722E-03_JPRB, 0.36876835E-03_JPRB, &
  & 0.36874815E-03_JPRB, 0.36874317E-03_JPRB, 0.36875962E-03_JPRB, 0.36880167E-03_JPRB, 0.36887085E-03_JPRB, 0.36896617E-03_JPRB, &
  & 0.36908255E-03_JPRB, 0.36921218E-03_JPRB, 0.36934600E-03_JPRB, 0.36947537E-03_JPRB, 0.36959376E-03_JPRB, 0.36969825E-03_JPRB, &
  & 0.36978937E-03_JPRB, 0.36986984E-03_JPRB, 0.36994266E-03_JPRB, 0.37001137E-03_JPRB, 0.37007855E-03_JPRB, 0.37014607E-03_JPRB, &
  & 0.37021408E-03_JPRB, 0.37028009E-03_JPRB, 0.37033937E-03_JPRB, 0.37038620E-03_JPRB, 0.37041691E-03_JPRB, 0.37043061E-03_JPRB, &
  & 0.37042811E-03_JPRB, 0.37041144E-03_JPRB, 0.37038358E-03_JPRB, 0.37034880E-03_JPRB, 0.37031178E-03_JPRB, 0.37027831E-03_JPRB, &
  & 0.37025247E-03_JPRB, 0.37023655E-03_JPRB, 0.37023082E-03_JPRB, 0.37023157E-03_JPRB, 0.37023492E-03_JPRB, 0.37023643E-03_JPRB, &
  & 0.37023312E-03_JPRB, 0.37022278E-03_JPRB, 0.37020410E-03_JPRB, 0.37017668E-03_JPRB, 0.37014094E-03_JPRB, 0.37009764E-03_JPRB, &
  & 0.37004854E-03_JPRB, 0.36999490E-03_JPRB, 0.36993841E-03_JPRB, 0.36988067E-03_JPRB, 0.36982371E-03_JPRB, 0.36976932E-03_JPRB, &
  & 0.36971923E-03_JPRB, 0.36967432E-03_JPRB, 0.36963500E-03_JPRB, 0.36960153E-03_JPRB, 0.36957444E-03_JPRB, 0.36955334E-03_JPRB, &
  & 0.36953861E-03_JPRB, 0.36952947E-03_JPRB, 0.36952586E-03_JPRB, 0.36953107E-03_JPRB /)

RGHG1(:,22, 8) = (/ &
  & 0.36915587E-03_JPRB, 0.36910360E-03_JPRB, 0.36906783E-03_JPRB, 0.36903570E-03_JPRB, 0.36900630E-03_JPRB, 0.36897970E-03_JPRB, &
  & 0.36896090E-03_JPRB, 0.36895476E-03_JPRB, 0.36896730E-03_JPRB, 0.36900197E-03_JPRB, 0.36906061E-03_JPRB, 0.36914236E-03_JPRB, &
  & 0.36924312E-03_JPRB, 0.36935654E-03_JPRB, 0.36947473E-03_JPRB, 0.36959004E-03_JPRB, 0.36969694E-03_JPRB, 0.36979251E-03_JPRB, &
  & 0.36987651E-03_JPRB, 0.36995107E-03_JPRB, 0.37001932E-03_JPRB, 0.37008346E-03_JPRB, 0.37014688E-03_JPRB, 0.37021108E-03_JPRB, &
  & 0.37027698E-03_JPRB, 0.37034194E-03_JPRB, 0.37040157E-03_JPRB, 0.37045052E-03_JPRB, 0.37048469E-03_JPRB, 0.37050320E-03_JPRB, &
  & 0.37050631E-03_JPRB, 0.37049589E-03_JPRB, 0.37047442E-03_JPRB, 0.37044601E-03_JPRB, 0.37041501E-03_JPRB, 0.37038641E-03_JPRB, &
  & 0.37036411E-03_JPRB, 0.37035023E-03_JPRB, 0.37034426E-03_JPRB, 0.37034441E-03_JPRB, 0.37034665E-03_JPRB, 0.37034776E-03_JPRB, &
  & 0.37034455E-03_JPRB, 0.37033492E-03_JPRB, 0.37031781E-03_JPRB, 0.37029258E-03_JPRB, 0.37025925E-03_JPRB, 0.37021894E-03_JPRB, &
  & 0.37017273E-03_JPRB, 0.37012206E-03_JPRB, 0.37006853E-03_JPRB, 0.37001399E-03_JPRB, 0.36996033E-03_JPRB, 0.36990907E-03_JPRB, &
  & 0.36986143E-03_JPRB, 0.36981821E-03_JPRB, 0.36978003E-03_JPRB, 0.36974708E-03_JPRB, 0.36971938E-03_JPRB, 0.36969746E-03_JPRB, &
  & 0.36968099E-03_JPRB, 0.36966993E-03_JPRB, 0.36966387E-03_JPRB, 0.36966483E-03_JPRB /)

RGHG1(:,23, 8) = (/ &
  & 0.36932150E-03_JPRB, 0.36927109E-03_JPRB, 0.36923887E-03_JPRB, 0.36921009E-03_JPRB, 0.36918256E-03_JPRB, 0.36915817E-03_JPRB, &
  & 0.36913963E-03_JPRB, 0.36913261E-03_JPRB, 0.36914146E-03_JPRB, 0.36916946E-03_JPRB, 0.36921821E-03_JPRB, 0.36928713E-03_JPRB, &
  & 0.36937269E-03_JPRB, 0.36946958E-03_JPRB, 0.36957199E-03_JPRB, 0.36967327E-03_JPRB, 0.36976847E-03_JPRB, 0.36985500E-03_JPRB, &
  & 0.36993285E-03_JPRB, 0.37000285E-03_JPRB, 0.37006749E-03_JPRB, 0.37012945E-03_JPRB, 0.37019124E-03_JPRB, 0.37025445E-03_JPRB, &
  & 0.37031993E-03_JPRB, 0.37038515E-03_JPRB, 0.37044624E-03_JPRB, 0.37049761E-03_JPRB, 0.37053606E-03_JPRB, 0.37056010E-03_JPRB, &
  & 0.37056996E-03_JPRB, 0.37056743E-03_JPRB, 0.37055451E-03_JPRB, 0.37053489E-03_JPRB, 0.37051190E-03_JPRB, 0.37049057E-03_JPRB, &
  & 0.37047311E-03_JPRB, 0.37046068E-03_JPRB, 0.37045428E-03_JPRB, 0.37045148E-03_JPRB, 0.37044962E-03_JPRB, 0.37044671E-03_JPRB, &
  & 0.37044025E-03_JPRB, 0.37042837E-03_JPRB, 0.37040975E-03_JPRB, 0.37038396E-03_JPRB, 0.37035113E-03_JPRB, 0.37031190E-03_JPRB, &
  & 0.37026737E-03_JPRB, 0.37021950E-03_JPRB, 0.37016947E-03_JPRB, 0.37011859E-03_JPRB, 0.37006871E-03_JPRB, 0.37002104E-03_JPRB, &
  & 0.36997654E-03_JPRB, 0.36993588E-03_JPRB, 0.36989935E-03_JPRB, 0.36986737E-03_JPRB, 0.36984024E-03_JPRB, 0.36981795E-03_JPRB, &
  & 0.36980066E-03_JPRB, 0.36978812E-03_JPRB, 0.36977974E-03_JPRB, 0.36977584E-03_JPRB /)

RGHG1(:,24, 8) = (/ &
  & 0.36946477E-03_JPRB, 0.36941800E-03_JPRB, 0.36938768E-03_JPRB, 0.36936102E-03_JPRB, 0.36933567E-03_JPRB, 0.36931230E-03_JPRB, &
  & 0.36929420E-03_JPRB, 0.36928584E-03_JPRB, 0.36929126E-03_JPRB, 0.36931352E-03_JPRB, 0.36935398E-03_JPRB, 0.36941149E-03_JPRB, &
  & 0.36948361E-03_JPRB, 0.36956603E-03_JPRB, 0.36965398E-03_JPRB, 0.36974251E-03_JPRB, 0.36982755E-03_JPRB, 0.36990654E-03_JPRB, &
  & 0.36997907E-03_JPRB, 0.37004601E-03_JPRB, 0.37010884E-03_JPRB, 0.37016982E-03_JPRB, 0.37023111E-03_JPRB, 0.37029397E-03_JPRB, &
  & 0.37035893E-03_JPRB, 0.37042404E-03_JPRB, 0.37048524E-03_JPRB, 0.37053830E-03_JPRB, 0.37057960E-03_JPRB, 0.37060821E-03_JPRB, &
  & 0.37062468E-03_JPRB, 0.37062992E-03_JPRB, 0.37062619E-03_JPRB, 0.37061615E-03_JPRB, 0.37060268E-03_JPRB, 0.37058862E-03_JPRB, &
  & 0.37057593E-03_JPRB, 0.37056563E-03_JPRB, 0.37055733E-03_JPRB, 0.37055067E-03_JPRB, 0.37054368E-03_JPRB, 0.37053536E-03_JPRB, &
  & 0.37052354E-03_JPRB, 0.37050757E-03_JPRB, 0.37048571E-03_JPRB, 0.37045786E-03_JPRB, 0.37042424E-03_JPRB, 0.37038568E-03_JPRB, &
  & 0.37034290E-03_JPRB, 0.37029732E-03_JPRB, 0.37025026E-03_JPRB, 0.37020296E-03_JPRB, 0.37015672E-03_JPRB, 0.37011277E-03_JPRB, &
  & 0.37007174E-03_JPRB, 0.37003384E-03_JPRB, 0.36999950E-03_JPRB, 0.36996897E-03_JPRB, 0.36994260E-03_JPRB, 0.36992042E-03_JPRB, &
  & 0.36990258E-03_JPRB, 0.36988905E-03_JPRB, 0.36987910E-03_JPRB, 0.36987130E-03_JPRB /)

RGHG1(:,25, 8) = (/ &
  & 0.36958957E-03_JPRB, 0.36954676E-03_JPRB, 0.36951993E-03_JPRB, 0.36949542E-03_JPRB, 0.36947217E-03_JPRB, 0.36945031E-03_JPRB, &
  & 0.36943288E-03_JPRB, 0.36942342E-03_JPRB, 0.36942604E-03_JPRB, 0.36944362E-03_JPRB, 0.36947700E-03_JPRB, 0.36952511E-03_JPRB, &
  & 0.36958625E-03_JPRB, 0.36965709E-03_JPRB, 0.36973387E-03_JPRB, 0.36981254E-03_JPRB, 0.36988966E-03_JPRB, 0.36996286E-03_JPRB, &
  & 0.37003157E-03_JPRB, 0.37009607E-03_JPRB, 0.37015756E-03_JPRB, 0.37021769E-03_JPRB, 0.37027785E-03_JPRB, 0.37033946E-03_JPRB, &
  & 0.37040201E-03_JPRB, 0.37046438E-03_JPRB, 0.37052311E-03_JPRB, 0.37057494E-03_JPRB, 0.37061772E-03_JPRB, 0.37064980E-03_JPRB, &
  & 0.37067157E-03_JPRB, 0.37068370E-03_JPRB, 0.37068815E-03_JPRB, 0.37068658E-03_JPRB, 0.37068126E-03_JPRB, 0.37067378E-03_JPRB, &
  & 0.37066537E-03_JPRB, 0.37065658E-03_JPRB, 0.37064686E-03_JPRB, 0.37063690E-03_JPRB, 0.37062512E-03_JPRB, 0.37061126E-03_JPRB, &
  & 0.37059412E-03_JPRB, 0.37057334E-03_JPRB, 0.37054799E-03_JPRB, 0.37051775E-03_JPRB, 0.37048271E-03_JPRB, 0.37044397E-03_JPRB, &
  & 0.37040256E-03_JPRB, 0.37035951E-03_JPRB, 0.37031554E-03_JPRB, 0.37027194E-03_JPRB, 0.37022989E-03_JPRB, 0.37018972E-03_JPRB, &
  & 0.37015192E-03_JPRB, 0.37011690E-03_JPRB, 0.37008504E-03_JPRB, 0.37005625E-03_JPRB, 0.37003099E-03_JPRB, 0.37000916E-03_JPRB, &
  & 0.36999126E-03_JPRB, 0.36997718E-03_JPRB, 0.36996600E-03_JPRB, 0.36995570E-03_JPRB /)

RGHG1(:,26, 8) = (/ &
  & 0.36969903E-03_JPRB, 0.36966222E-03_JPRB, 0.36963855E-03_JPRB, 0.36961786E-03_JPRB, 0.36959696E-03_JPRB, 0.36957787E-03_JPRB, &
  & 0.36956169E-03_JPRB, 0.36955246E-03_JPRB, 0.36955354E-03_JPRB, 0.36956757E-03_JPRB, 0.36959574E-03_JPRB, 0.36963687E-03_JPRB, &
  & 0.36969021E-03_JPRB, 0.36975258E-03_JPRB, 0.36982144E-03_JPRB, 0.36989324E-03_JPRB, 0.36996478E-03_JPRB, 0.37003396E-03_JPRB, &
  & 0.37009956E-03_JPRB, 0.37016187E-03_JPRB, 0.37022136E-03_JPRB, 0.37027930E-03_JPRB, 0.37033661E-03_JPRB, 0.37039432E-03_JPRB, &
  & 0.37045221E-03_JPRB, 0.37050925E-03_JPRB, 0.37056347E-03_JPRB, 0.37061257E-03_JPRB, 0.37065396E-03_JPRB, 0.37068711E-03_JPRB, &
  & 0.37071196E-03_JPRB, 0.37072922E-03_JPRB, 0.37073967E-03_JPRB, 0.37074464E-03_JPRB, 0.37074534E-03_JPRB, 0.37074275E-03_JPRB, &
  & 0.37073734E-03_JPRB, 0.37072957E-03_JPRB, 0.37071903E-03_JPRB, 0.37070620E-03_JPRB, 0.37069066E-03_JPRB, 0.37067247E-03_JPRB, &
  & 0.37065128E-03_JPRB, 0.37062657E-03_JPRB, 0.37059811E-03_JPRB, 0.37056583E-03_JPRB, 0.37053047E-03_JPRB, 0.37049258E-03_JPRB, &
  & 0.37045279E-03_JPRB, 0.37041216E-03_JPRB, 0.37037133E-03_JPRB, 0.37033122E-03_JPRB, 0.37029260E-03_JPRB, 0.37025593E-03_JPRB, &
  & 0.37022142E-03_JPRB, 0.37018914E-03_JPRB, 0.37015954E-03_JPRB, 0.37013259E-03_JPRB, 0.37010846E-03_JPRB, 0.37008742E-03_JPRB, &
  & 0.37006987E-03_JPRB, 0.37005552E-03_JPRB, 0.37004368E-03_JPRB, 0.37003096E-03_JPRB /)

RGHG1(:,27, 8) = (/ &
  & 0.36979761E-03_JPRB, 0.36976722E-03_JPRB, 0.36974810E-03_JPRB, 0.36973032E-03_JPRB, 0.36971376E-03_JPRB, 0.36969731E-03_JPRB, &
  & 0.36968390E-03_JPRB, 0.36967595E-03_JPRB, 0.36967703E-03_JPRB, 0.36968925E-03_JPRB, 0.36971390E-03_JPRB, 0.36975098E-03_JPRB, &
  & 0.36979900E-03_JPRB, 0.36985608E-03_JPRB, 0.36991964E-03_JPRB, 0.36998681E-03_JPRB, 0.37005451E-03_JPRB, 0.37012046E-03_JPRB, &
  & 0.37018338E-03_JPRB, 0.37024257E-03_JPRB, 0.37029883E-03_JPRB, 0.37035241E-03_JPRB, 0.37040462E-03_JPRB, 0.37045626E-03_JPRB, &
  & 0.37050719E-03_JPRB, 0.37055684E-03_JPRB, 0.37060407E-03_JPRB, 0.37064770E-03_JPRB, 0.37068679E-03_JPRB, 0.37071994E-03_JPRB, &
  & 0.37074657E-03_JPRB, 0.37076685E-03_JPRB, 0.37078123E-03_JPRB, 0.37079048E-03_JPRB, 0.37079511E-03_JPRB, 0.37079534E-03_JPRB, &
  & 0.37079153E-03_JPRB, 0.37078428E-03_JPRB, 0.37077331E-03_JPRB, 0.37075864E-03_JPRB, 0.37074074E-03_JPRB, 0.37071950E-03_JPRB, &
  & 0.37069531E-03_JPRB, 0.37066784E-03_JPRB, 0.37063748E-03_JPRB, 0.37060407E-03_JPRB, 0.37056836E-03_JPRB, 0.37053134E-03_JPRB, &
  & 0.37049386E-03_JPRB, 0.37045643E-03_JPRB, 0.37041903E-03_JPRB, 0.37038248E-03_JPRB, 0.37034752E-03_JPRB, 0.37031417E-03_JPRB, &
  & 0.37028280E-03_JPRB, 0.37025328E-03_JPRB, 0.37022599E-03_JPRB, 0.37020084E-03_JPRB, 0.37017817E-03_JPRB, 0.37015826E-03_JPRB, &
  & 0.37014138E-03_JPRB, 0.37012706E-03_JPRB, 0.37011461E-03_JPRB, 0.37010008E-03_JPRB /)

RGHG1(:,28, 8) = (/ &
  & 0.36988899E-03_JPRB, 0.36986466E-03_JPRB, 0.36984889E-03_JPRB, 0.36983562E-03_JPRB, 0.36982202E-03_JPRB, 0.36980986E-03_JPRB, &
  & 0.36979944E-03_JPRB, 0.36979408E-03_JPRB, 0.36979635E-03_JPRB, 0.36980867E-03_JPRB, 0.36983212E-03_JPRB, 0.36986684E-03_JPRB, &
  & 0.36991184E-03_JPRB, 0.36996527E-03_JPRB, 0.37002526E-03_JPRB, 0.37008902E-03_JPRB, 0.37015340E-03_JPRB, 0.37021624E-03_JPRB, &
  & 0.37027572E-03_JPRB, 0.37033117E-03_JPRB, 0.37038283E-03_JPRB, 0.37043093E-03_JPRB, 0.37047706E-03_JPRB, 0.37052124E-03_JPRB, &
  & 0.37056406E-03_JPRB, 0.37060538E-03_JPRB, 0.37064534E-03_JPRB, 0.37068326E-03_JPRB, 0.37071842E-03_JPRB, 0.37074991E-03_JPRB, &
  & 0.37077689E-03_JPRB, 0.37079846E-03_JPRB, 0.37081476E-03_JPRB, 0.37082622E-03_JPRB, 0.37083274E-03_JPRB, 0.37083446E-03_JPRB, &
  & 0.37083155E-03_JPRB, 0.37082421E-03_JPRB, 0.37081272E-03_JPRB, 0.37079715E-03_JPRB, 0.37077777E-03_JPRB, 0.37075509E-03_JPRB, &
  & 0.37072934E-03_JPRB, 0.37070049E-03_JPRB, 0.37066918E-03_JPRB, 0.37063568E-03_JPRB, 0.37060087E-03_JPRB, 0.37056577E-03_JPRB, &
  & 0.37053076E-03_JPRB, 0.37049616E-03_JPRB, 0.37046202E-03_JPRB, 0.37042890E-03_JPRB, 0.37039712E-03_JPRB, 0.37036694E-03_JPRB, &
  & 0.37033827E-03_JPRB, 0.37031129E-03_JPRB, 0.37028620E-03_JPRB, 0.37026301E-03_JPRB, 0.37024179E-03_JPRB, 0.37022302E-03_JPRB, &
  & 0.37020678E-03_JPRB, 0.37019298E-03_JPRB, 0.37018064E-03_JPRB, 0.37016513E-03_JPRB /)

RGHG1(:,29, 8) = (/ &
  & 0.36997438E-03_JPRB, 0.36995532E-03_JPRB, 0.36994359E-03_JPRB, 0.36993294E-03_JPRB, 0.36992339E-03_JPRB, 0.36991423E-03_JPRB, &
  & 0.36990727E-03_JPRB, 0.36990482E-03_JPRB, 0.36990945E-03_JPRB, 0.36992296E-03_JPRB, 0.36994653E-03_JPRB, 0.36998020E-03_JPRB, &
  & 0.37002336E-03_JPRB, 0.37007450E-03_JPRB, 0.37013157E-03_JPRB, 0.37019208E-03_JPRB, 0.37025317E-03_JPRB, 0.37031248E-03_JPRB, &
  & 0.37036816E-03_JPRB, 0.37041926E-03_JPRB, 0.37046603E-03_JPRB, 0.37050853E-03_JPRB, 0.37054796E-03_JPRB, 0.37058492E-03_JPRB, &
  & 0.37061979E-03_JPRB, 0.37065340E-03_JPRB, 0.37068606E-03_JPRB, 0.37071799E-03_JPRB, 0.37074881E-03_JPRB, 0.37077788E-03_JPRB, &
  & 0.37080361E-03_JPRB, 0.37082538E-03_JPRB, 0.37084249E-03_JPRB, 0.37085466E-03_JPRB, 0.37086190E-03_JPRB, 0.37086403E-03_JPRB, &
  & 0.37086147E-03_JPRB, 0.37085390E-03_JPRB, 0.37084214E-03_JPRB, 0.37082605E-03_JPRB, 0.37080602E-03_JPRB, 0.37078263E-03_JPRB, &
  & 0.37075617E-03_JPRB, 0.37072683E-03_JPRB, 0.37069549E-03_JPRB, 0.37066272E-03_JPRB, 0.37062957E-03_JPRB, 0.37059674E-03_JPRB, &
  & 0.37056458E-03_JPRB, 0.37053294E-03_JPRB, 0.37050204E-03_JPRB, 0.37047197E-03_JPRB, 0.37044316E-03_JPRB, 0.37041568E-03_JPRB, &
  & 0.37038978E-03_JPRB, 0.37036519E-03_JPRB, 0.37034205E-03_JPRB, 0.37032051E-03_JPRB, 0.37030081E-03_JPRB, 0.37028326E-03_JPRB, &
  & 0.37026804E-03_JPRB, 0.37025489E-03_JPRB, 0.37024266E-03_JPRB, 0.37022610E-03_JPRB /)

RGHG1(:,30, 8) = (/ &
  & 0.37005343E-03_JPRB, 0.37003876E-03_JPRB, 0.37002985E-03_JPRB, 0.37002252E-03_JPRB, 0.37001545E-03_JPRB, 0.37000971E-03_JPRB, &
  & 0.37000611E-03_JPRB, 0.37000663E-03_JPRB, 0.37001373E-03_JPRB, 0.37002916E-03_JPRB, 0.37005331E-03_JPRB, 0.37008690E-03_JPRB, &
  & 0.37012884E-03_JPRB, 0.37017776E-03_JPRB, 0.37023210E-03_JPRB, 0.37028923E-03_JPRB, 0.37034659E-03_JPRB, 0.37040209E-03_JPRB, &
  & 0.37045378E-03_JPRB, 0.37050064E-03_JPRB, 0.37054266E-03_JPRB, 0.37057989E-03_JPRB, 0.37061333E-03_JPRB, 0.37064386E-03_JPRB, &
  & 0.37067215E-03_JPRB, 0.37069895E-03_JPRB, 0.37072529E-03_JPRB, 0.37075172E-03_JPRB, 0.37077838E-03_JPRB, 0.37080419E-03_JPRB, &
  & 0.37082806E-03_JPRB, 0.37084887E-03_JPRB, 0.37086572E-03_JPRB, 0.37087779E-03_JPRB, 0.37088495E-03_JPRB, 0.37088717E-03_JPRB, &
  & 0.37088452E-03_JPRB, 0.37087675E-03_JPRB, 0.37086481E-03_JPRB, 0.37084869E-03_JPRB, 0.37082852E-03_JPRB, 0.37080504E-03_JPRB, &
  & 0.37077849E-03_JPRB, 0.37074962E-03_JPRB, 0.37071912E-03_JPRB, 0.37068789E-03_JPRB, 0.37065684E-03_JPRB, 0.37062651E-03_JPRB, &
  & 0.37059691E-03_JPRB, 0.37056822E-03_JPRB, 0.37054013E-03_JPRB, 0.37051292E-03_JPRB, 0.37048687E-03_JPRB, 0.37046196E-03_JPRB, &
  & 0.37043812E-03_JPRB, 0.37041557E-03_JPRB, 0.37039418E-03_JPRB, 0.37037436E-03_JPRB, 0.37035620E-03_JPRB, 0.37033981E-03_JPRB, &
  & 0.37032558E-03_JPRB, 0.37031312E-03_JPRB, 0.37030122E-03_JPRB, 0.37028483E-03_JPRB /)

RGHG1(:,31, 8) = (/ &
  & 0.37012575E-03_JPRB, 0.37011481E-03_JPRB, 0.37010832E-03_JPRB, 0.37010296E-03_JPRB, 0.37009866E-03_JPRB, 0.37009534E-03_JPRB, &
  & 0.37009464E-03_JPRB, 0.37009813E-03_JPRB, 0.37010794E-03_JPRB, 0.37012508E-03_JPRB, 0.37015055E-03_JPRB, 0.37018405E-03_JPRB, &
  & 0.37022482E-03_JPRB, 0.37027174E-03_JPRB, 0.37032305E-03_JPRB, 0.37037669E-03_JPRB, 0.37043021E-03_JPRB, 0.37048178E-03_JPRB, &
  & 0.37052974E-03_JPRB, 0.37057261E-03_JPRB, 0.37061036E-03_JPRB, 0.37064331E-03_JPRB, 0.37067197E-03_JPRB, 0.37069706E-03_JPRB, &
  & 0.37071991E-03_JPRB, 0.37074144E-03_JPRB, 0.37076263E-03_JPRB, 0.37078437E-03_JPRB, 0.37080687E-03_JPRB, 0.37082940E-03_JPRB, &
  & 0.37085122E-03_JPRB, 0.37087058E-03_JPRB, 0.37088644E-03_JPRB, 0.37089761E-03_JPRB, 0.37090422E-03_JPRB, 0.37090603E-03_JPRB, &
  & 0.37090303E-03_JPRB, 0.37089555E-03_JPRB, 0.37088376E-03_JPRB, 0.37086781E-03_JPRB, 0.37084814E-03_JPRB, 0.37082506E-03_JPRB, &
  & 0.37079933E-03_JPRB, 0.37077151E-03_JPRB, 0.37074229E-03_JPRB, 0.37071289E-03_JPRB, 0.37068420E-03_JPRB, 0.37065631E-03_JPRB, &
  & 0.37062916E-03_JPRB, 0.37060294E-03_JPRB, 0.37057744E-03_JPRB, 0.37055259E-03_JPRB, 0.37052864E-03_JPRB, 0.37050570E-03_JPRB, &
  & 0.37048370E-03_JPRB, 0.37046289E-03_JPRB, 0.37044316E-03_JPRB, 0.37042471E-03_JPRB, 0.37040765E-03_JPRB, 0.37039246E-03_JPRB, &
  & 0.37037913E-03_JPRB, 0.37036737E-03_JPRB, 0.37035625E-03_JPRB, 0.37034016E-03_JPRB /)

RGHG1(:,32, 8) = (/ &
  & 0.37019051E-03_JPRB, 0.37018256E-03_JPRB, 0.37017805E-03_JPRB, 0.37017482E-03_JPRB, 0.37017249E-03_JPRB, 0.37017174E-03_JPRB, &
  & 0.37017372E-03_JPRB, 0.37017991E-03_JPRB, 0.37019202E-03_JPRB, 0.37021091E-03_JPRB, 0.37023716E-03_JPRB, 0.37027043E-03_JPRB, &
  & 0.37031004E-03_JPRB, 0.37035462E-03_JPRB, 0.37040285E-03_JPRB, 0.37045288E-03_JPRB, 0.37050262E-03_JPRB, 0.37055041E-03_JPRB, &
  & 0.37059461E-03_JPRB, 0.37063414E-03_JPRB, 0.37066865E-03_JPRB, 0.37069825E-03_JPRB, 0.37072311E-03_JPRB, 0.37074447E-03_JPRB, &
  & 0.37076321E-03_JPRB, 0.37078070E-03_JPRB, 0.37079796E-03_JPRB, 0.37081592E-03_JPRB, 0.37083492E-03_JPRB, 0.37085442E-03_JPRB, &
  & 0.37087346E-03_JPRB, 0.37089083E-03_JPRB, 0.37090509E-03_JPRB, 0.37091511E-03_JPRB, 0.37092081E-03_JPRB, 0.37092200E-03_JPRB, &
  & 0.37091880E-03_JPRB, 0.37091156E-03_JPRB, 0.37090032E-03_JPRB, 0.37088519E-03_JPRB, 0.37086633E-03_JPRB, 0.37084444E-03_JPRB, &
  & 0.37081997E-03_JPRB, 0.37079363E-03_JPRB, 0.37076653E-03_JPRB, 0.37073923E-03_JPRB, 0.37071266E-03_JPRB, 0.37068684E-03_JPRB, &
  & 0.37066202E-03_JPRB, 0.37063760E-03_JPRB, 0.37061406E-03_JPRB, 0.37059106E-03_JPRB, 0.37056883E-03_JPRB, 0.37054758E-03_JPRB, &
  & 0.37052724E-03_JPRB, 0.37050786E-03_JPRB, 0.37048946E-03_JPRB, 0.37047235E-03_JPRB, 0.37045655E-03_JPRB, 0.37044246E-03_JPRB, &
  & 0.37043009E-03_JPRB, 0.37041915E-03_JPRB, 0.37040855E-03_JPRB, 0.37039290E-03_JPRB /)

RGHG1(:,33, 8) = (/ &
  & 0.37024848E-03_JPRB, 0.37024327E-03_JPRB, 0.37024054E-03_JPRB, 0.37023894E-03_JPRB, 0.37023844E-03_JPRB, 0.37023984E-03_JPRB, &
  & 0.37024394E-03_JPRB, 0.37025253E-03_JPRB, 0.37026661E-03_JPRB, 0.37028690E-03_JPRB, 0.37031359E-03_JPRB, 0.37034624E-03_JPRB, &
  & 0.37038419E-03_JPRB, 0.37042639E-03_JPRB, 0.37047145E-03_JPRB, 0.37051790E-03_JPRB, 0.37056411E-03_JPRB, 0.37060850E-03_JPRB, &
  & 0.37064962E-03_JPRB, 0.37068658E-03_JPRB, 0.37071857E-03_JPRB, 0.37074561E-03_JPRB, 0.37076796E-03_JPRB, 0.37078661E-03_JPRB, &
  & 0.37080259E-03_JPRB, 0.37081726E-03_JPRB, 0.37083155E-03_JPRB, 0.37084639E-03_JPRB, 0.37086214E-03_JPRB, 0.37087867E-03_JPRB, &
  & 0.37089520E-03_JPRB, 0.37091019E-03_JPRB, 0.37092247E-03_JPRB, 0.37093091E-03_JPRB, 0.37093554E-03_JPRB, 0.37093609E-03_JPRB, &
  & 0.37093283E-03_JPRB, 0.37092599E-03_JPRB, 0.37091551E-03_JPRB, 0.37090163E-03_JPRB, 0.37088429E-03_JPRB, 0.37086371E-03_JPRB, &
  & 0.37084101E-03_JPRB, 0.37081691E-03_JPRB, 0.37079182E-03_JPRB, 0.37076688E-03_JPRB, 0.37074220E-03_JPRB, 0.37071842E-03_JPRB, &
  & 0.37069517E-03_JPRB, 0.37067270E-03_JPRB, 0.37065044E-03_JPRB, 0.37062881E-03_JPRB, 0.37060789E-03_JPRB, 0.37058786E-03_JPRB, &
  & 0.37056877E-03_JPRB, 0.37055061E-03_JPRB, 0.37053353E-03_JPRB, 0.37051749E-03_JPRB, 0.37050276E-03_JPRB, 0.37048952E-03_JPRB, &
  & 0.37047808E-03_JPRB, 0.37046787E-03_JPRB, 0.37045783E-03_JPRB, 0.37044290E-03_JPRB /)

RGHG1(:,34, 8) = (/ &
  & 0.37030125E-03_JPRB, 0.37029808E-03_JPRB, 0.37029691E-03_JPRB, 0.37029671E-03_JPRB, 0.37029790E-03_JPRB, 0.37030078E-03_JPRB, &
  & 0.37030672E-03_JPRB, 0.37031717E-03_JPRB, 0.37033268E-03_JPRB, 0.37035378E-03_JPRB, 0.37038035E-03_JPRB, 0.37041199E-03_JPRB, &
  & 0.37044825E-03_JPRB, 0.37048789E-03_JPRB, 0.37053003E-03_JPRB, 0.37057319E-03_JPRB, 0.37061595E-03_JPRB, 0.37065742E-03_JPRB, &
  & 0.37069610E-03_JPRB, 0.37073094E-03_JPRB, 0.37076120E-03_JPRB, 0.37078650E-03_JPRB, 0.37080725E-03_JPRB, 0.37082427E-03_JPRB, &
  & 0.37083850E-03_JPRB, 0.37085128E-03_JPRB, 0.37086339E-03_JPRB, 0.37087582E-03_JPRB, 0.37088885E-03_JPRB, 0.37090262E-03_JPRB, &
  & 0.37091624E-03_JPRB, 0.37092858E-03_JPRB, 0.37093862E-03_JPRB, 0.37094537E-03_JPRB, 0.37094878E-03_JPRB, 0.37094869E-03_JPRB, &
  & 0.37094564E-03_JPRB, 0.37093929E-03_JPRB, 0.37092980E-03_JPRB, 0.37091717E-03_JPRB, 0.37090157E-03_JPRB, 0.37088327E-03_JPRB, &
  & 0.37086286E-03_JPRB, 0.37084118E-03_JPRB, 0.37081848E-03_JPRB, 0.37079529E-03_JPRB, 0.37077261E-03_JPRB, 0.37075026E-03_JPRB, &
  & 0.37072835E-03_JPRB, 0.37070704E-03_JPRB, 0.37068600E-03_JPRB, 0.37066522E-03_JPRB, 0.37064531E-03_JPRB, 0.37062619E-03_JPRB, &
  & 0.37060809E-03_JPRB, 0.37059112E-03_JPRB, 0.37057509E-03_JPRB, 0.37056016E-03_JPRB, 0.37054633E-03_JPRB, 0.37053411E-03_JPRB, &
  & 0.37052325E-03_JPRB, 0.37051379E-03_JPRB, 0.37050442E-03_JPRB, 0.37049013E-03_JPRB /)

RGHG1(:,35, 8) = (/ &
  & 0.37034843E-03_JPRB, 0.37034770E-03_JPRB, 0.37034781E-03_JPRB, 0.37034892E-03_JPRB, 0.37035136E-03_JPRB, 0.37035585E-03_JPRB, &
  & 0.37036327E-03_JPRB, 0.37037497E-03_JPRB, 0.37039141E-03_JPRB, 0.37041277E-03_JPRB, 0.37043888E-03_JPRB, 0.37046918E-03_JPRB, &
  & 0.37050349E-03_JPRB, 0.37054071E-03_JPRB, 0.37057995E-03_JPRB, 0.37061996E-03_JPRB, 0.37065998E-03_JPRB, 0.37069866E-03_JPRB, &
  & 0.37073516E-03_JPRB, 0.37076825E-03_JPRB, 0.37079729E-03_JPRB, 0.37082171E-03_JPRB, 0.37084179E-03_JPRB, 0.37085806E-03_JPRB, &
  & 0.37087130E-03_JPRB, 0.37088286E-03_JPRB, 0.37089331E-03_JPRB, 0.37090378E-03_JPRB, 0.37091444E-03_JPRB, 0.37092553E-03_JPRB, &
  & 0.37093629E-03_JPRB, 0.37094596E-03_JPRB, 0.37095358E-03_JPRB, 0.37095853E-03_JPRB, 0.37096071E-03_JPRB, 0.37096013E-03_JPRB, &
  & 0.37095693E-03_JPRB, 0.37095131E-03_JPRB, 0.37094313E-03_JPRB, 0.37093210E-03_JPRB, 0.37091845E-03_JPRB, 0.37090259E-03_JPRB, &
  & 0.37088463E-03_JPRB, 0.37086560E-03_JPRB, 0.37084502E-03_JPRB, 0.37082381E-03_JPRB, 0.37080265E-03_JPRB, 0.37078161E-03_JPRB, &
  & 0.37076077E-03_JPRB, 0.37074010E-03_JPRB, 0.37072011E-03_JPRB, 0.37070012E-03_JPRB, 0.37068099E-03_JPRB, 0.37066263E-03_JPRB, &
  & 0.37064543E-03_JPRB, 0.37062936E-03_JPRB, 0.37061423E-03_JPRB, 0.37060023E-03_JPRB, 0.37058734E-03_JPRB, 0.37057581E-03_JPRB, &
  & 0.37056574E-03_JPRB, 0.37055684E-03_JPRB, 0.37054796E-03_JPRB, 0.37053434E-03_JPRB /)

RGHG1(:,36, 8) = (/ &
  & 0.37039188E-03_JPRB, 0.37039310E-03_JPRB, 0.37039447E-03_JPRB, 0.37039665E-03_JPRB, 0.37040029E-03_JPRB, 0.37040579E-03_JPRB, &
  & 0.37041432E-03_JPRB, 0.37042686E-03_JPRB, 0.37044362E-03_JPRB, 0.37046487E-03_JPRB, 0.37049016E-03_JPRB, 0.37051921E-03_JPRB, &
  & 0.37055140E-03_JPRB, 0.37058600E-03_JPRB, 0.37062235E-03_JPRB, 0.37065975E-03_JPRB, 0.37069694E-03_JPRB, 0.37073335E-03_JPRB, &
  & 0.37076804E-03_JPRB, 0.37079983E-03_JPRB, 0.37082820E-03_JPRB, 0.37085236E-03_JPRB, 0.37087227E-03_JPRB, 0.37088824E-03_JPRB, &
  & 0.37090093E-03_JPRB, 0.37091150E-03_JPRB, 0.37092066E-03_JPRB, 0.37092925E-03_JPRB, 0.37093781E-03_JPRB, 0.37094619E-03_JPRB, &
  & 0.37095428E-03_JPRB, 0.37096132E-03_JPRB, 0.37096659E-03_JPRB, 0.37096991E-03_JPRB, 0.37097104E-03_JPRB, 0.37097005E-03_JPRB, &
  & 0.37096717E-03_JPRB, 0.37096237E-03_JPRB, 0.37095550E-03_JPRB, 0.37094616E-03_JPRB, 0.37093466E-03_JPRB, 0.37092099E-03_JPRB, &
  & 0.37090568E-03_JPRB, 0.37088877E-03_JPRB, 0.37087061E-03_JPRB, 0.37085119E-03_JPRB, 0.37083152E-03_JPRB, 0.37081155E-03_JPRB, &
  & 0.37079136E-03_JPRB, 0.37077157E-03_JPRB, 0.37075192E-03_JPRB, 0.37073254E-03_JPRB, 0.37071411E-03_JPRB, 0.37069671E-03_JPRB, &
  & 0.37068030E-03_JPRB, 0.37066513E-03_JPRB, 0.37065096E-03_JPRB, 0.37063778E-03_JPRB, 0.37062578E-03_JPRB, 0.37061493E-03_JPRB, &
  & 0.37060553E-03_JPRB, 0.37059723E-03_JPRB, 0.37058900E-03_JPRB, 0.37057610E-03_JPRB /)

RGHG1(:,37, 8) = (/ &
  & 0.37043256E-03_JPRB, 0.37043536E-03_JPRB, 0.37043801E-03_JPRB, 0.37044118E-03_JPRB, 0.37044560E-03_JPRB, 0.37045195E-03_JPRB, &
  & 0.37046132E-03_JPRB, 0.37047415E-03_JPRB, 0.37049095E-03_JPRB, 0.37051155E-03_JPRB, 0.37053580E-03_JPRB, 0.37056312E-03_JPRB, &
  & 0.37059316E-03_JPRB, 0.37062526E-03_JPRB, 0.37065899E-03_JPRB, 0.37069354E-03_JPRB, 0.37072843E-03_JPRB, 0.37076266E-03_JPRB, &
  & 0.37079590E-03_JPRB, 0.37082686E-03_JPRB, 0.37085477E-03_JPRB, 0.37087878E-03_JPRB, 0.37089834E-03_JPRB, 0.37091383E-03_JPRB, &
  & 0.37092564E-03_JPRB, 0.37093510E-03_JPRB, 0.37094296E-03_JPRB, 0.37094997E-03_JPRB, 0.37095649E-03_JPRB, 0.37096266E-03_JPRB, &
  & 0.37096837E-03_JPRB, 0.37097305E-03_JPRB, 0.37097654E-03_JPRB, 0.37097858E-03_JPRB, 0.37097905E-03_JPRB, 0.37097806E-03_JPRB, &
  & 0.37097553E-03_JPRB, 0.37097168E-03_JPRB, 0.37096621E-03_JPRB, 0.37095879E-03_JPRB, 0.37094942E-03_JPRB, 0.37093804E-03_JPRB, &
  & 0.37092509E-03_JPRB, 0.37091039E-03_JPRB, 0.37089427E-03_JPRB, 0.37087686E-03_JPRB, 0.37085844E-03_JPRB, 0.37083938E-03_JPRB, &
  & 0.37081982E-03_JPRB, 0.37080064E-03_JPRB, 0.37078146E-03_JPRB, 0.37076281E-03_JPRB, 0.37074491E-03_JPRB, 0.37072826E-03_JPRB, &
  & 0.37071275E-03_JPRB, 0.37069849E-03_JPRB, 0.37068519E-03_JPRB, 0.37067279E-03_JPRB, 0.37066147E-03_JPRB, 0.37065140E-03_JPRB, &
  & 0.37064261E-03_JPRB, 0.37063487E-03_JPRB, 0.37062707E-03_JPRB, 0.37061487E-03_JPRB /)

RGHG1(:,38, 8) = (/ &
  & 0.37047092E-03_JPRB, 0.37047541E-03_JPRB, 0.37047899E-03_JPRB, 0.37048309E-03_JPRB, 0.37048839E-03_JPRB, 0.37049557E-03_JPRB, &
  & 0.37050527E-03_JPRB, 0.37051822E-03_JPRB, 0.37053452E-03_JPRB, 0.37055419E-03_JPRB, 0.37057701E-03_JPRB, 0.37060241E-03_JPRB, &
  & 0.37063012E-03_JPRB, 0.37065963E-03_JPRB, 0.37069080E-03_JPRB, 0.37072279E-03_JPRB, 0.37075515E-03_JPRB, 0.37078760E-03_JPRB, &
  & 0.37081918E-03_JPRB, 0.37084924E-03_JPRB, 0.37087669E-03_JPRB, 0.37090026E-03_JPRB, 0.37091901E-03_JPRB, 0.37093338E-03_JPRB, &
  & 0.37094398E-03_JPRB, 0.37095195E-03_JPRB, 0.37095841E-03_JPRB, 0.37096403E-03_JPRB, 0.37096898E-03_JPRB, 0.37097355E-03_JPRB, &
  & 0.37097753E-03_JPRB, 0.37098074E-03_JPRB, 0.37098301E-03_JPRB, 0.37098414E-03_JPRB, 0.37098423E-03_JPRB, 0.37098347E-03_JPRB, &
  & 0.37098146E-03_JPRB, 0.37097849E-03_JPRB, 0.37097430E-03_JPRB, 0.37096869E-03_JPRB, 0.37096144E-03_JPRB, 0.37095250E-03_JPRB, &
  & 0.37094177E-03_JPRB, 0.37092928E-03_JPRB, 0.37091528E-03_JPRB, 0.37089962E-03_JPRB, 0.37088257E-03_JPRB, 0.37086458E-03_JPRB, &
  & 0.37084593E-03_JPRB, 0.37082718E-03_JPRB, 0.37080847E-03_JPRB, 0.37079034E-03_JPRB, 0.37077325E-03_JPRB, 0.37075736E-03_JPRB, &
  & 0.37074275E-03_JPRB, 0.37072937E-03_JPRB, 0.37071697E-03_JPRB, 0.37070550E-03_JPRB, 0.37069508E-03_JPRB, 0.37068577E-03_JPRB, &
  & 0.37067774E-03_JPRB, 0.37067052E-03_JPRB, 0.37066313E-03_JPRB, 0.37065131E-03_JPRB /)

RGHG1(:,39, 8) = (/ &
  & 0.37050777E-03_JPRB, 0.37051350E-03_JPRB, 0.37051787E-03_JPRB, 0.37052273E-03_JPRB, 0.37052884E-03_JPRB, 0.37053670E-03_JPRB, &
  & 0.37054683E-03_JPRB, 0.37055943E-03_JPRB, 0.37057500E-03_JPRB, 0.37059339E-03_JPRB, 0.37061438E-03_JPRB, 0.37063780E-03_JPRB, &
  & 0.37066315E-03_JPRB, 0.37069008E-03_JPRB, 0.37071836E-03_JPRB, 0.37074773E-03_JPRB, 0.37077788E-03_JPRB, 0.37080835E-03_JPRB, &
  & 0.37083859E-03_JPRB, 0.37086755E-03_JPRB, 0.37089386E-03_JPRB, 0.37091624E-03_JPRB, 0.37093376E-03_JPRB, 0.37094665E-03_JPRB, &
  & 0.37095585E-03_JPRB, 0.37096263E-03_JPRB, 0.37096802E-03_JPRB, 0.37097244E-03_JPRB, 0.37097634E-03_JPRB, 0.37097975E-03_JPRB, &
  & 0.37098274E-03_JPRB, 0.37098510E-03_JPRB, 0.37098659E-03_JPRB, 0.37098734E-03_JPRB, 0.37098740E-03_JPRB, 0.37098661E-03_JPRB, &
  & 0.37098498E-03_JPRB, 0.37098277E-03_JPRB, 0.37097957E-03_JPRB, 0.37097532E-03_JPRB, 0.37096979E-03_JPRB, 0.37096307E-03_JPRB, &
  & 0.37095460E-03_JPRB, 0.37094450E-03_JPRB, 0.37093263E-03_JPRB, 0.37091889E-03_JPRB, 0.37090346E-03_JPRB, 0.37088673E-03_JPRB, &
  & 0.37086906E-03_JPRB, 0.37085076E-03_JPRB, 0.37083274E-03_JPRB, 0.37081540E-03_JPRB, 0.37079913E-03_JPRB, 0.37078408E-03_JPRB, &
  & 0.37077037E-03_JPRB, 0.37075789E-03_JPRB, 0.37074642E-03_JPRB, 0.37073577E-03_JPRB, 0.37072613E-03_JPRB, 0.37071764E-03_JPRB, &
  & 0.37071016E-03_JPRB, 0.37070346E-03_JPRB, 0.37069662E-03_JPRB, 0.37068556E-03_JPRB /)

RGHG1(:,40, 8) = (/ &
  & 0.37054365E-03_JPRB, 0.37055032E-03_JPRB, 0.37055532E-03_JPRB, 0.37056080E-03_JPRB, 0.37056752E-03_JPRB, 0.37057599E-03_JPRB, &
  & 0.37058626E-03_JPRB, 0.37059857E-03_JPRB, 0.37061307E-03_JPRB, 0.37062989E-03_JPRB, 0.37064916E-03_JPRB, 0.37067026E-03_JPRB, &
  & 0.37069307E-03_JPRB, 0.37071740E-03_JPRB, 0.37074304E-03_JPRB, 0.37076982E-03_JPRB, 0.37079767E-03_JPRB, 0.37082602E-03_JPRB, &
  & 0.37085457E-03_JPRB, 0.37088204E-03_JPRB, 0.37090704E-03_JPRB, 0.37092791E-03_JPRB, 0.37094401E-03_JPRB, 0.37095541E-03_JPRB, &
  & 0.37096339E-03_JPRB, 0.37096927E-03_JPRB, 0.37097375E-03_JPRB, 0.37097739E-03_JPRB, 0.37098062E-03_JPRB, 0.37098341E-03_JPRB, &
  & 0.37098586E-03_JPRB, 0.37098760E-03_JPRB, 0.37098880E-03_JPRB, 0.37098935E-03_JPRB, 0.37098923E-03_JPRB, 0.37098853E-03_JPRB, &
  & 0.37098717E-03_JPRB, 0.37098530E-03_JPRB, 0.37098274E-03_JPRB, 0.37097948E-03_JPRB, 0.37097532E-03_JPRB, 0.37097011E-03_JPRB, &
  & 0.37096365E-03_JPRB, 0.37095573E-03_JPRB, 0.37094613E-03_JPRB, 0.37093461E-03_JPRB, 0.37092107E-03_JPRB, 0.37090573E-03_JPRB, &
  & 0.37088900E-03_JPRB, 0.37087171E-03_JPRB, 0.37085445E-03_JPRB, 0.37083784E-03_JPRB, 0.37082250E-03_JPRB, 0.37080850E-03_JPRB, &
  & 0.37079584E-03_JPRB, 0.37078440E-03_JPRB, 0.37077378E-03_JPRB, 0.37076391E-03_JPRB, 0.37075503E-03_JPRB, 0.37074709E-03_JPRB, &
  & 0.37074031E-03_JPRB, 0.37073431E-03_JPRB, 0.37072808E-03_JPRB, 0.37071799E-03_JPRB /)

RGHG1(:,41, 8) = (/ &
  & 0.37057948E-03_JPRB, 0.37058670E-03_JPRB, 0.37059170E-03_JPRB, 0.37059758E-03_JPRB, 0.37060483E-03_JPRB, 0.37061362E-03_JPRB, &
  & 0.37062389E-03_JPRB, 0.37063559E-03_JPRB, 0.37064895E-03_JPRB, 0.37066423E-03_JPRB, 0.37068140E-03_JPRB, 0.37070035E-03_JPRB, &
  & 0.37072072E-03_JPRB, 0.37074235E-03_JPRB, 0.37076534E-03_JPRB, 0.37078952E-03_JPRB, 0.37081493E-03_JPRB, 0.37084124E-03_JPRB, &
  & 0.37086796E-03_JPRB, 0.37089383E-03_JPRB, 0.37091720E-03_JPRB, 0.37093673E-03_JPRB, 0.37095117E-03_JPRB, 0.37096138E-03_JPRB, &
  & 0.37096857E-03_JPRB, 0.37097363E-03_JPRB, 0.37097753E-03_JPRB, 0.37098071E-03_JPRB, 0.37098338E-03_JPRB, 0.37098571E-03_JPRB, &
  & 0.37098781E-03_JPRB, 0.37098929E-03_JPRB, 0.37099028E-03_JPRB, 0.37099063E-03_JPRB, 0.37099054E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098868E-03_JPRB, 0.37098708E-03_JPRB, 0.37098493E-03_JPRB, 0.37098222E-03_JPRB, 0.37097896E-03_JPRB, 0.37097483E-03_JPRB, &
  & 0.37096982E-03_JPRB, 0.37096380E-03_JPRB, 0.37095623E-03_JPRB, 0.37094689E-03_JPRB, 0.37093536E-03_JPRB, 0.37092163E-03_JPRB, &
  & 0.37090626E-03_JPRB, 0.37088993E-03_JPRB, 0.37087352E-03_JPRB, 0.37085786E-03_JPRB, 0.37084345E-03_JPRB, 0.37083041E-03_JPRB, &
  & 0.37081866E-03_JPRB, 0.37080818E-03_JPRB, 0.37079837E-03_JPRB, 0.37078949E-03_JPRB, 0.37078140E-03_JPRB, 0.37077436E-03_JPRB, &
  & 0.37076822E-03_JPRB, 0.37076275E-03_JPRB, 0.37075704E-03_JPRB, 0.37074776E-03_JPRB /)

RGHG1(:,42, 8) = (/ &
  & 0.37061746E-03_JPRB, 0.37062299E-03_JPRB, 0.37062750E-03_JPRB, 0.37063321E-03_JPRB, 0.37064080E-03_JPRB, 0.37065000E-03_JPRB, &
  & 0.37066004E-03_JPRB, 0.37067104E-03_JPRB, 0.37068321E-03_JPRB, 0.37069680E-03_JPRB, 0.37071199E-03_JPRB, 0.37072855E-03_JPRB, &
  & 0.37074671E-03_JPRB, 0.37076601E-03_JPRB, 0.37078635E-03_JPRB, 0.37080792E-03_JPRB, 0.37083070E-03_JPRB, 0.37085463E-03_JPRB, &
  & 0.37087945E-03_JPRB, 0.37090361E-03_JPRB, 0.37092555E-03_JPRB, 0.37094351E-03_JPRB, 0.37095672E-03_JPRB, 0.37096583E-03_JPRB, &
  & 0.37097227E-03_JPRB, 0.37097686E-03_JPRB, 0.37098021E-03_JPRB, 0.37098298E-03_JPRB, 0.37098530E-03_JPRB, 0.37098728E-03_JPRB, &
  & 0.37098918E-03_JPRB, 0.37099048E-03_JPRB, 0.37099130E-03_JPRB, 0.37099156E-03_JPRB, 0.37099139E-03_JPRB, 0.37099081E-03_JPRB, &
  & 0.37098979E-03_JPRB, 0.37098836E-03_JPRB, 0.37098653E-03_JPRB, 0.37098426E-03_JPRB, 0.37098158E-03_JPRB, 0.37097826E-03_JPRB, &
  & 0.37097427E-03_JPRB, 0.37096965E-03_JPRB, 0.37096371E-03_JPRB, 0.37095626E-03_JPRB, 0.37094671E-03_JPRB, 0.37093484E-03_JPRB, &
  & 0.37092093E-03_JPRB, 0.37090568E-03_JPRB, 0.37089046E-03_JPRB, 0.37087567E-03_JPRB, 0.37086225E-03_JPRB, 0.37085020E-03_JPRB, &
  & 0.37083958E-03_JPRB, 0.37082989E-03_JPRB, 0.37082110E-03_JPRB, 0.37081307E-03_JPRB, 0.37080579E-03_JPRB, 0.37079948E-03_JPRB, &
  & 0.37079395E-03_JPRB, 0.37078894E-03_JPRB, 0.37078376E-03_JPRB, 0.37077509E-03_JPRB /)

RGHG1(:,43, 8) = (/ &
  & 0.37065067E-03_JPRB, 0.37065733E-03_JPRB, 0.37066208E-03_JPRB, 0.37066793E-03_JPRB, 0.37067587E-03_JPRB, 0.37068513E-03_JPRB, &
  & 0.37069514E-03_JPRB, 0.37070533E-03_JPRB, 0.37071621E-03_JPRB, 0.37072808E-03_JPRB, 0.37074133E-03_JPRB, 0.37075591E-03_JPRB, &
  & 0.37077174E-03_JPRB, 0.37078862E-03_JPRB, 0.37080652E-03_JPRB, 0.37082547E-03_JPRB, 0.37084566E-03_JPRB, 0.37086735E-03_JPRB, &
  & 0.37088999E-03_JPRB, 0.37091231E-03_JPRB, 0.37093266E-03_JPRB, 0.37094916E-03_JPRB, 0.37096115E-03_JPRB, 0.37096936E-03_JPRB, &
  & 0.37097515E-03_JPRB, 0.37097919E-03_JPRB, 0.37098222E-03_JPRB, 0.37098469E-03_JPRB, 0.37098676E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37099136E-03_JPRB, 0.37099211E-03_JPRB, 0.37099229E-03_JPRB, 0.37099217E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099069E-03_JPRB, 0.37098935E-03_JPRB, 0.37098772E-03_JPRB, 0.37098580E-03_JPRB, 0.37098353E-03_JPRB, 0.37098076E-03_JPRB, &
  & 0.37097756E-03_JPRB, 0.37097392E-03_JPRB, 0.37096933E-03_JPRB, 0.37096348E-03_JPRB, 0.37095585E-03_JPRB, 0.37094575E-03_JPRB, &
  & 0.37093341E-03_JPRB, 0.37091941E-03_JPRB, 0.37090527E-03_JPRB, 0.37089147E-03_JPRB, 0.37087899E-03_JPRB, 0.37086802E-03_JPRB, &
  & 0.37085841E-03_JPRB, 0.37084991E-03_JPRB, 0.37084211E-03_JPRB, 0.37083498E-03_JPRB, 0.37082843E-03_JPRB, 0.37082282E-03_JPRB, &
  & 0.37081778E-03_JPRB, 0.37081330E-03_JPRB, 0.37080841E-03_JPRB, 0.37080055E-03_JPRB /)

RGHG1(:,44, 8) = (/ &
  & 0.37068292E-03_JPRB, 0.37069162E-03_JPRB, 0.37069657E-03_JPRB, 0.37070244E-03_JPRB, 0.37071045E-03_JPRB, 0.37071994E-03_JPRB, &
  & 0.37072937E-03_JPRB, 0.37073874E-03_JPRB, 0.37074843E-03_JPRB, 0.37075882E-03_JPRB, 0.37077023E-03_JPRB, 0.37078295E-03_JPRB, &
  & 0.37079648E-03_JPRB, 0.37081106E-03_JPRB, 0.37082651E-03_JPRB, 0.37084290E-03_JPRB, 0.37086059E-03_JPRB, 0.37087972E-03_JPRB, &
  & 0.37090000E-03_JPRB, 0.37092037E-03_JPRB, 0.37093909E-03_JPRB, 0.37095402E-03_JPRB, 0.37096493E-03_JPRB, 0.37097230E-03_JPRB, &
  & 0.37097748E-03_JPRB, 0.37098111E-03_JPRB, 0.37098385E-03_JPRB, 0.37098612E-03_JPRB, 0.37098795E-03_JPRB, 0.37098955E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099211E-03_JPRB, 0.37099276E-03_JPRB, 0.37099293E-03_JPRB, 0.37099281E-03_JPRB, 0.37099232E-03_JPRB, &
  & 0.37099147E-03_JPRB, 0.37099034E-03_JPRB, 0.37098880E-03_JPRB, 0.37098705E-03_JPRB, 0.37098507E-03_JPRB, 0.37098271E-03_JPRB, &
  & 0.37098018E-03_JPRB, 0.37097721E-03_JPRB, 0.37097372E-03_JPRB, 0.37096915E-03_JPRB, 0.37096313E-03_JPRB, 0.37095492E-03_JPRB, &
  & 0.37094418E-03_JPRB, 0.37093164E-03_JPRB, 0.37091842E-03_JPRB, 0.37090568E-03_JPRB, 0.37089415E-03_JPRB, 0.37088426E-03_JPRB, &
  & 0.37087573E-03_JPRB, 0.37086831E-03_JPRB, 0.37086155E-03_JPRB, 0.37085530E-03_JPRB, 0.37084951E-03_JPRB, 0.37084447E-03_JPRB, &
  & 0.37084002E-03_JPRB, 0.37083583E-03_JPRB, 0.37083140E-03_JPRB, 0.37082407E-03_JPRB /)

RGHG1(:,45, 8) = (/ &
  & 0.37072488E-03_JPRB, 0.37072954E-03_JPRB, 0.37073327E-03_JPRB, 0.37073833E-03_JPRB, 0.37074593E-03_JPRB, 0.37075503E-03_JPRB, &
  & 0.37076382E-03_JPRB, 0.37077250E-03_JPRB, 0.37078076E-03_JPRB, 0.37078961E-03_JPRB, 0.37079936E-03_JPRB, 0.37081004E-03_JPRB, &
  & 0.37082160E-03_JPRB, 0.37083391E-03_JPRB, 0.37084697E-03_JPRB, 0.37086097E-03_JPRB, 0.37087608E-03_JPRB, 0.37089258E-03_JPRB, &
  & 0.37091027E-03_JPRB, 0.37092844E-03_JPRB, 0.37094500E-03_JPRB, 0.37095835E-03_JPRB, 0.37096813E-03_JPRB, 0.37097474E-03_JPRB, &
  & 0.37097943E-03_JPRB, 0.37098271E-03_JPRB, 0.37098519E-03_JPRB, 0.37098723E-03_JPRB, 0.37098888E-03_JPRB, 0.37099037E-03_JPRB, &
  & 0.37099171E-03_JPRB, 0.37099270E-03_JPRB, 0.37099340E-03_JPRB, 0.37099360E-03_JPRB, 0.37099340E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099113E-03_JPRB, 0.37098982E-03_JPRB, 0.37098816E-03_JPRB, 0.37098629E-03_JPRB, 0.37098434E-03_JPRB, &
  & 0.37098216E-03_JPRB, 0.37097977E-03_JPRB, 0.37097704E-03_JPRB, 0.37097360E-03_JPRB, 0.37096895E-03_JPRB, 0.37096243E-03_JPRB, &
  & 0.37095349E-03_JPRB, 0.37094241E-03_JPRB, 0.37093030E-03_JPRB, 0.37091860E-03_JPRB, 0.37090818E-03_JPRB, 0.37089933E-03_JPRB, &
  & 0.37089217E-03_JPRB, 0.37088583E-03_JPRB, 0.37087998E-03_JPRB, 0.37087454E-03_JPRB, 0.37086947E-03_JPRB, 0.37086499E-03_JPRB, &
  & 0.37086086E-03_JPRB, 0.37085707E-03_JPRB, 0.37085300E-03_JPRB, 0.37084622E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART16',0,ZHOOK_HANDLE)



RGHG1(:,46, 8) = (/ &
  & 0.37075367E-03_JPRB, 0.37076313E-03_JPRB, 0.37076868E-03_JPRB, 0.37077477E-03_JPRB, 0.37078257E-03_JPRB, 0.37079118E-03_JPRB, &
  & 0.37079939E-03_JPRB, 0.37080684E-03_JPRB, 0.37081406E-03_JPRB, 0.37082139E-03_JPRB, 0.37082937E-03_JPRB, 0.37083804E-03_JPRB, &
  & 0.37084747E-03_JPRB, 0.37085754E-03_JPRB, 0.37086837E-03_JPRB, 0.37087983E-03_JPRB, 0.37089235E-03_JPRB, 0.37090597E-03_JPRB, &
  & 0.37092093E-03_JPRB, 0.37093621E-03_JPRB, 0.37095061E-03_JPRB, 0.37096228E-03_JPRB, 0.37097087E-03_JPRB, 0.37097681E-03_JPRB, &
  & 0.37098103E-03_JPRB, 0.37098397E-03_JPRB, 0.37098624E-03_JPRB, 0.37098810E-03_JPRB, 0.37098973E-03_JPRB, 0.37099104E-03_JPRB, &
  & 0.37099229E-03_JPRB, 0.37099328E-03_JPRB, 0.37099389E-03_JPRB, 0.37099404E-03_JPRB, 0.37099398E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099188E-03_JPRB, 0.37099060E-03_JPRB, 0.37098909E-03_JPRB, 0.37098740E-03_JPRB, 0.37098568E-03_JPRB, &
  & 0.37098382E-03_JPRB, 0.37098187E-03_JPRB, 0.37097966E-03_JPRB, 0.37097704E-03_JPRB, 0.37097360E-03_JPRB, 0.37096866E-03_JPRB, &
  & 0.37096150E-03_JPRB, 0.37095210E-03_JPRB, 0.37094139E-03_JPRB, 0.37093076E-03_JPRB, 0.37092151E-03_JPRB, 0.37091391E-03_JPRB, &
  & 0.37090774E-03_JPRB, 0.37090250E-03_JPRB, 0.37089767E-03_JPRB, 0.37089307E-03_JPRB, 0.37088868E-03_JPRB, 0.37088472E-03_JPRB, &
  & 0.37088100E-03_JPRB, 0.37087750E-03_JPRB, 0.37087375E-03_JPRB, 0.37086746E-03_JPRB /)

RGHG1(:,47, 8) = (/ &
  & 0.37079290E-03_JPRB, 0.37080090E-03_JPRB, 0.37080649E-03_JPRB, 0.37081284E-03_JPRB, 0.37082087E-03_JPRB, 0.37082931E-03_JPRB, &
  & 0.37083658E-03_JPRB, 0.37084293E-03_JPRB, 0.37084855E-03_JPRB, 0.37085440E-03_JPRB, 0.37086045E-03_JPRB, 0.37086714E-03_JPRB, &
  & 0.37087442E-03_JPRB, 0.37088228E-03_JPRB, 0.37089048E-03_JPRB, 0.37089959E-03_JPRB, 0.37090926E-03_JPRB, 0.37092023E-03_JPRB, &
  & 0.37093187E-03_JPRB, 0.37094421E-03_JPRB, 0.37095585E-03_JPRB, 0.37096580E-03_JPRB, 0.37097323E-03_JPRB, 0.37097844E-03_JPRB, &
  & 0.37098222E-03_JPRB, 0.37098498E-03_JPRB, 0.37098711E-03_JPRB, 0.37098886E-03_JPRB, 0.37099031E-03_JPRB, 0.37099162E-03_JPRB, &
  & 0.37099287E-03_JPRB, 0.37099380E-03_JPRB, 0.37099433E-03_JPRB, 0.37099453E-03_JPRB, 0.37099447E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099331E-03_JPRB, 0.37099255E-03_JPRB, 0.37099139E-03_JPRB, 0.37098993E-03_JPRB, 0.37098842E-03_JPRB, 0.37098685E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098356E-03_JPRB, 0.37098178E-03_JPRB, 0.37097972E-03_JPRB, 0.37097704E-03_JPRB, 0.37097343E-03_JPRB, &
  & 0.37096808E-03_JPRB, 0.37096086E-03_JPRB, 0.37095184E-03_JPRB, 0.37094275E-03_JPRB, 0.37093466E-03_JPRB, 0.37092826E-03_JPRB, &
  & 0.37092326E-03_JPRB, 0.37091901E-03_JPRB, 0.37091502E-03_JPRB, 0.37091115E-03_JPRB, 0.37090725E-03_JPRB, 0.37090355E-03_JPRB, &
  & 0.37090018E-03_JPRB, 0.37089700E-03_JPRB, 0.37089360E-03_JPRB, 0.37088786E-03_JPRB /)

RGHG1(:,48, 8) = (/ &
  & 0.37082480E-03_JPRB, 0.37083554E-03_JPRB, 0.37084270E-03_JPRB, 0.37085038E-03_JPRB, 0.37085952E-03_JPRB, 0.37086810E-03_JPRB, &
  & 0.37087509E-03_JPRB, 0.37088012E-03_JPRB, 0.37088455E-03_JPRB, 0.37088862E-03_JPRB, 0.37089270E-03_JPRB, 0.37089738E-03_JPRB, &
  & 0.37090242E-03_JPRB, 0.37090780E-03_JPRB, 0.37091359E-03_JPRB, 0.37092000E-03_JPRB, 0.37092710E-03_JPRB, 0.37093475E-03_JPRB, &
  & 0.37094322E-03_JPRB, 0.37095207E-03_JPRB, 0.37096080E-03_JPRB, 0.37096877E-03_JPRB, 0.37097512E-03_JPRB, 0.37097980E-03_JPRB, &
  & 0.37098324E-03_JPRB, 0.37098577E-03_JPRB, 0.37098775E-03_JPRB, 0.37098944E-03_JPRB, 0.37099086E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099331E-03_JPRB, 0.37099418E-03_JPRB, 0.37099473E-03_JPRB, 0.37099497E-03_JPRB, 0.37099494E-03_JPRB, 0.37099453E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099313E-03_JPRB, 0.37099206E-03_JPRB, 0.37099078E-03_JPRB, 0.37098920E-03_JPRB, 0.37098775E-03_JPRB, &
  & 0.37098632E-03_JPRB, 0.37098493E-03_JPRB, 0.37098347E-03_JPRB, 0.37098187E-03_JPRB, 0.37097986E-03_JPRB, 0.37097721E-03_JPRB, &
  & 0.37097343E-03_JPRB, 0.37096810E-03_JPRB, 0.37096150E-03_JPRB, 0.37095440E-03_JPRB, 0.37094794E-03_JPRB, 0.37094284E-03_JPRB, &
  & 0.37093874E-03_JPRB, 0.37093530E-03_JPRB, 0.37093202E-03_JPRB, 0.37092867E-03_JPRB, 0.37092529E-03_JPRB, 0.37092203E-03_JPRB, &
  & 0.37091892E-03_JPRB, 0.37091604E-03_JPRB, 0.37091289E-03_JPRB, 0.37090754E-03_JPRB /)

RGHG1(:,49, 8) = (/ &
  & 0.37085550E-03_JPRB, 0.37086738E-03_JPRB, 0.37087541E-03_JPRB, 0.37088396E-03_JPRB, 0.37089380E-03_JPRB, 0.37090303E-03_JPRB, &
  & 0.37090975E-03_JPRB, 0.37091429E-03_JPRB, 0.37091778E-03_JPRB, 0.37092061E-03_JPRB, 0.37092331E-03_JPRB, 0.37092614E-03_JPRB, &
  & 0.37092919E-03_JPRB, 0.37093248E-03_JPRB, 0.37093612E-03_JPRB, 0.37094005E-03_JPRB, 0.37094427E-03_JPRB, 0.37094866E-03_JPRB, &
  & 0.37095355E-03_JPRB, 0.37095917E-03_JPRB, 0.37096519E-03_JPRB, 0.37097131E-03_JPRB, 0.37097669E-03_JPRB, 0.37098082E-03_JPRB, &
  & 0.37098397E-03_JPRB, 0.37098641E-03_JPRB, 0.37098830E-03_JPRB, 0.37098987E-03_JPRB, 0.37099124E-03_JPRB, 0.37099246E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099459E-03_JPRB, 0.37099520E-03_JPRB, 0.37099537E-03_JPRB, 0.37099532E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099436E-03_JPRB, 0.37099366E-03_JPRB, 0.37099261E-03_JPRB, 0.37099142E-03_JPRB, 0.37099008E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37098734E-03_JPRB, 0.37098603E-03_JPRB, 0.37098481E-03_JPRB, 0.37098353E-03_JPRB, 0.37098202E-03_JPRB, 0.37098012E-03_JPRB, &
  & 0.37097753E-03_JPRB, 0.37097416E-03_JPRB, 0.37096976E-03_JPRB, 0.37096505E-03_JPRB, 0.37096062E-03_JPRB, 0.37095696E-03_JPRB, &
  & 0.37095393E-03_JPRB, 0.37095131E-03_JPRB, 0.37094869E-03_JPRB, 0.37094584E-03_JPRB, 0.37094278E-03_JPRB, 0.37093982E-03_JPRB, &
  & 0.37093696E-03_JPRB, 0.37093429E-03_JPRB, 0.37093123E-03_JPRB, 0.37092625E-03_JPRB /)

RGHG1(:,50, 8) = (/ &
  & 0.37088554E-03_JPRB, 0.37089578E-03_JPRB, 0.37090277E-03_JPRB, 0.37091071E-03_JPRB, 0.37092017E-03_JPRB, 0.37092905E-03_JPRB, &
  & 0.37093513E-03_JPRB, 0.37093929E-03_JPRB, 0.37094209E-03_JPRB, 0.37094438E-03_JPRB, 0.37094631E-03_JPRB, 0.37094817E-03_JPRB, &
  & 0.37095009E-03_JPRB, 0.37095195E-03_JPRB, 0.37095384E-03_JPRB, 0.37095579E-03_JPRB, 0.37095771E-03_JPRB, 0.37095975E-03_JPRB, &
  & 0.37096208E-03_JPRB, 0.37096511E-03_JPRB, 0.37096895E-03_JPRB, 0.37097349E-03_JPRB, 0.37097800E-03_JPRB, 0.37098170E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098693E-03_JPRB, 0.37098874E-03_JPRB, 0.37099025E-03_JPRB, 0.37099168E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099497E-03_JPRB, 0.37099552E-03_JPRB, 0.37099572E-03_JPRB, 0.37099569E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099421E-03_JPRB, 0.37099313E-03_JPRB, 0.37099194E-03_JPRB, 0.37099072E-03_JPRB, 0.37098944E-03_JPRB, &
  & 0.37098810E-03_JPRB, 0.37098696E-03_JPRB, 0.37098594E-03_JPRB, 0.37098487E-03_JPRB, 0.37098370E-03_JPRB, 0.37098236E-03_JPRB, &
  & 0.37098071E-03_JPRB, 0.37097852E-03_JPRB, 0.37097605E-03_JPRB, 0.37097349E-03_JPRB, 0.37097110E-03_JPRB, 0.37096895E-03_JPRB, &
  & 0.37096714E-03_JPRB, 0.37096543E-03_JPRB, 0.37096365E-03_JPRB, 0.37096150E-03_JPRB, 0.37095899E-03_JPRB, 0.37095640E-03_JPRB, &
  & 0.37095387E-03_JPRB, 0.37095143E-03_JPRB, 0.37094866E-03_JPRB, 0.37094389E-03_JPRB /)

RGHG1(:,51, 8) = (/ &
  & 0.37090838E-03_JPRB, 0.37091755E-03_JPRB, 0.37092375E-03_JPRB, 0.37093033E-03_JPRB, 0.37093851E-03_JPRB, 0.37094596E-03_JPRB, &
  & 0.37095119E-03_JPRB, 0.37095437E-03_JPRB, 0.37095672E-03_JPRB, 0.37095838E-03_JPRB, 0.37095981E-03_JPRB, 0.37096115E-03_JPRB, &
  & 0.37096255E-03_JPRB, 0.37096371E-03_JPRB, 0.37096473E-03_JPRB, 0.37096560E-03_JPRB, 0.37096645E-03_JPRB, 0.37096726E-03_JPRB, &
  & 0.37096825E-03_JPRB, 0.37096976E-03_JPRB, 0.37097215E-03_JPRB, 0.37097535E-03_JPRB, 0.37097905E-03_JPRB, 0.37098242E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098743E-03_JPRB, 0.37098920E-03_JPRB, 0.37099060E-03_JPRB, 0.37099194E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099424E-03_JPRB, 0.37099523E-03_JPRB, 0.37099584E-03_JPRB, 0.37099601E-03_JPRB, 0.37099601E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099468E-03_JPRB, 0.37099366E-03_JPRB, 0.37099258E-03_JPRB, 0.37099130E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098784E-03_JPRB, 0.37098691E-03_JPRB, 0.37098594E-03_JPRB, 0.37098501E-03_JPRB, 0.37098399E-03_JPRB, &
  & 0.37098286E-03_JPRB, 0.37098164E-03_JPRB, 0.37098027E-03_JPRB, 0.37097896E-03_JPRB, 0.37097785E-03_JPRB, 0.37097686E-03_JPRB, &
  & 0.37097602E-03_JPRB, 0.37097518E-03_JPRB, 0.37097425E-03_JPRB, 0.37097305E-03_JPRB, 0.37097157E-03_JPRB, 0.37096979E-03_JPRB, &
  & 0.37096790E-03_JPRB, 0.37096598E-03_JPRB, 0.37096359E-03_JPRB, 0.37095931E-03_JPRB /)

RGHG1(:,52, 8) = (/ &
  & 0.37092919E-03_JPRB, 0.37093536E-03_JPRB, 0.37093955E-03_JPRB, 0.37094473E-03_JPRB, 0.37095096E-03_JPRB, 0.37095702E-03_JPRB, &
  & 0.37096089E-03_JPRB, 0.37096353E-03_JPRB, 0.37096505E-03_JPRB, 0.37096639E-03_JPRB, 0.37096746E-03_JPRB, 0.37096851E-03_JPRB, &
  & 0.37096941E-03_JPRB, 0.37097023E-03_JPRB, 0.37097084E-03_JPRB, 0.37097133E-03_JPRB, 0.37097168E-03_JPRB, 0.37097197E-03_JPRB, &
  & 0.37097241E-03_JPRB, 0.37097326E-03_JPRB, 0.37097474E-03_JPRB, 0.37097704E-03_JPRB, 0.37098004E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098562E-03_JPRB, 0.37098784E-03_JPRB, 0.37098950E-03_JPRB, 0.37099092E-03_JPRB, 0.37099223E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099453E-03_JPRB, 0.37099552E-03_JPRB, 0.37099613E-03_JPRB, 0.37099639E-03_JPRB, 0.37099628E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099511E-03_JPRB, 0.37099418E-03_JPRB, 0.37099310E-03_JPRB, 0.37099185E-03_JPRB, 0.37099069E-03_JPRB, &
  & 0.37098961E-03_JPRB, 0.37098868E-03_JPRB, 0.37098778E-03_JPRB, 0.37098691E-03_JPRB, 0.37098606E-03_JPRB, 0.37098525E-03_JPRB, &
  & 0.37098455E-03_JPRB, 0.37098379E-03_JPRB, 0.37098301E-03_JPRB, 0.37098239E-03_JPRB, 0.37098187E-03_JPRB, 0.37098140E-03_JPRB, &
  & 0.37098097E-03_JPRB, 0.37098059E-03_JPRB, 0.37098021E-03_JPRB, 0.37097977E-03_JPRB, 0.37097902E-03_JPRB, 0.37097817E-03_JPRB, &
  & 0.37097718E-03_JPRB, 0.37097599E-03_JPRB, 0.37097448E-03_JPRB, 0.37097128E-03_JPRB /)

RGHG1(:,53, 8) = (/ &
  & 0.37094275E-03_JPRB, 0.37094776E-03_JPRB, 0.37095122E-03_JPRB, 0.37095495E-03_JPRB, 0.37095984E-03_JPRB, 0.37096426E-03_JPRB, &
  & 0.37096738E-03_JPRB, 0.37096906E-03_JPRB, 0.37097035E-03_JPRB, 0.37097122E-03_JPRB, 0.37097203E-03_JPRB, 0.37097279E-03_JPRB, &
  & 0.37097352E-03_JPRB, 0.37097416E-03_JPRB, 0.37097465E-03_JPRB, 0.37097494E-03_JPRB, 0.37097512E-03_JPRB, 0.37097521E-03_JPRB, &
  & 0.37097538E-03_JPRB, 0.37097585E-03_JPRB, 0.37097678E-03_JPRB, 0.37097847E-03_JPRB, 0.37098085E-03_JPRB, 0.37098356E-03_JPRB, &
  & 0.37098606E-03_JPRB, 0.37098816E-03_JPRB, 0.37098979E-03_JPRB, 0.37099118E-03_JPRB, 0.37099241E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099578E-03_JPRB, 0.37099636E-03_JPRB, 0.37099665E-03_JPRB, 0.37099660E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099552E-03_JPRB, 0.37099459E-03_JPRB, 0.37099363E-03_JPRB, 0.37099249E-03_JPRB, 0.37099145E-03_JPRB, &
  & 0.37099031E-03_JPRB, 0.37098941E-03_JPRB, 0.37098856E-03_JPRB, 0.37098772E-03_JPRB, 0.37098705E-03_JPRB, 0.37098641E-03_JPRB, &
  & 0.37098586E-03_JPRB, 0.37098533E-03_JPRB, 0.37098487E-03_JPRB, 0.37098455E-03_JPRB, 0.37098429E-03_JPRB, 0.37098414E-03_JPRB, &
  & 0.37098397E-03_JPRB, 0.37098379E-03_JPRB, 0.37098362E-03_JPRB, 0.37098344E-03_JPRB, 0.37098318E-03_JPRB, 0.37098277E-03_JPRB, &
  & 0.37098228E-03_JPRB, 0.37098164E-03_JPRB, 0.37098082E-03_JPRB, 0.37097899E-03_JPRB /)

RGHG1(:,54, 8) = (/ &
  & 0.37095443E-03_JPRB, 0.37095777E-03_JPRB, 0.37096010E-03_JPRB, 0.37096289E-03_JPRB, 0.37096615E-03_JPRB, 0.37096947E-03_JPRB, &
  & 0.37097163E-03_JPRB, 0.37097302E-03_JPRB, 0.37097390E-03_JPRB, 0.37097462E-03_JPRB, 0.37097518E-03_JPRB, 0.37097573E-03_JPRB, &
  & 0.37097628E-03_JPRB, 0.37097684E-03_JPRB, 0.37097724E-03_JPRB, 0.37097745E-03_JPRB, 0.37097756E-03_JPRB, 0.37097762E-03_JPRB, &
  & 0.37097768E-03_JPRB, 0.37097797E-03_JPRB, 0.37097855E-03_JPRB, 0.37097969E-03_JPRB, 0.37098170E-03_JPRB, 0.37098408E-03_JPRB, &
  & 0.37098650E-03_JPRB, 0.37098853E-03_JPRB, 0.37099005E-03_JPRB, 0.37099147E-03_JPRB, 0.37099270E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099500E-03_JPRB, 0.37099599E-03_JPRB, 0.37099663E-03_JPRB, 0.37099689E-03_JPRB, 0.37099686E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099596E-03_JPRB, 0.37099508E-03_JPRB, 0.37099406E-03_JPRB, 0.37099302E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37099005E-03_JPRB, 0.37098929E-03_JPRB, 0.37098845E-03_JPRB, 0.37098781E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098653E-03_JPRB, 0.37098624E-03_JPRB, 0.37098603E-03_JPRB, 0.37098589E-03_JPRB, 0.37098577E-03_JPRB, &
  & 0.37098565E-03_JPRB, 0.37098557E-03_JPRB, 0.37098548E-03_JPRB, 0.37098536E-03_JPRB, 0.37098525E-03_JPRB, 0.37098507E-03_JPRB, &
  & 0.37098487E-03_JPRB, 0.37098464E-03_JPRB, 0.37098443E-03_JPRB, 0.37098417E-03_JPRB /)

RGHG1(:,55, 8) = (/ &
  & 0.37096231E-03_JPRB, 0.37096496E-03_JPRB, 0.37096674E-03_JPRB, 0.37096866E-03_JPRB, 0.37097101E-03_JPRB, 0.37097331E-03_JPRB, &
  & 0.37097494E-03_JPRB, 0.37097587E-03_JPRB, 0.37097652E-03_JPRB, 0.37097695E-03_JPRB, 0.37097739E-03_JPRB, 0.37097785E-03_JPRB, &
  & 0.37097832E-03_JPRB, 0.37097879E-03_JPRB, 0.37097916E-03_JPRB, 0.37097931E-03_JPRB, 0.37097937E-03_JPRB, 0.37097943E-03_JPRB, &
  & 0.37097943E-03_JPRB, 0.37097954E-03_JPRB, 0.37097995E-03_JPRB, 0.37098085E-03_JPRB, 0.37098239E-03_JPRB, 0.37098458E-03_JPRB, &
  & 0.37098685E-03_JPRB, 0.37098883E-03_JPRB, 0.37099031E-03_JPRB, 0.37099168E-03_JPRB, 0.37099287E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37099613E-03_JPRB, 0.37099674E-03_JPRB, 0.37099706E-03_JPRB, 0.37099709E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099631E-03_JPRB, 0.37099552E-03_JPRB, 0.37099453E-03_JPRB, 0.37099348E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099075E-03_JPRB, 0.37098996E-03_JPRB, 0.37098906E-03_JPRB, 0.37098851E-03_JPRB, 0.37098810E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098749E-03_JPRB, 0.37098728E-03_JPRB, 0.37098711E-03_JPRB, 0.37098702E-03_JPRB, 0.37098696E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098685E-03_JPRB, 0.37098682E-03_JPRB, 0.37098679E-03_JPRB, 0.37098664E-03_JPRB, 0.37098653E-03_JPRB, &
  & 0.37098641E-03_JPRB, 0.37098629E-03_JPRB, 0.37098615E-03_JPRB, 0.37098583E-03_JPRB /)

RGHG1(:,56, 8) = (/ &
  & 0.37096889E-03_JPRB, 0.37097058E-03_JPRB, 0.37097171E-03_JPRB, 0.37097302E-03_JPRB, 0.37097465E-03_JPRB, 0.37097628E-03_JPRB, &
  & 0.37097745E-03_JPRB, 0.37097817E-03_JPRB, 0.37097864E-03_JPRB, 0.37097902E-03_JPRB, 0.37097931E-03_JPRB, 0.37097963E-03_JPRB, &
  & 0.37098001E-03_JPRB, 0.37098039E-03_JPRB, 0.37098068E-03_JPRB, 0.37098082E-03_JPRB, 0.37098088E-03_JPRB, 0.37098094E-03_JPRB, &
  & 0.37098097E-03_JPRB, 0.37098103E-03_JPRB, 0.37098123E-03_JPRB, 0.37098193E-03_JPRB, 0.37098324E-03_JPRB, 0.37098519E-03_JPRB, &
  & 0.37098725E-03_JPRB, 0.37098915E-03_JPRB, 0.37099060E-03_JPRB, 0.37099185E-03_JPRB, 0.37099302E-03_JPRB, 0.37099418E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099633E-03_JPRB, 0.37099698E-03_JPRB, 0.37099735E-03_JPRB, 0.37099738E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099671E-03_JPRB, 0.37099593E-03_JPRB, 0.37099491E-03_JPRB, 0.37099392E-03_JPRB, 0.37099302E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099136E-03_JPRB, 0.37099066E-03_JPRB, 0.37098973E-03_JPRB, 0.37098926E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098868E-03_JPRB, 0.37098833E-03_JPRB, 0.37098807E-03_JPRB, 0.37098792E-03_JPRB, 0.37098787E-03_JPRB, 0.37098787E-03_JPRB, &
  & 0.37098784E-03_JPRB, 0.37098781E-03_JPRB, 0.37098775E-03_JPRB, 0.37098769E-03_JPRB, 0.37098769E-03_JPRB, 0.37098763E-03_JPRB, &
  & 0.37098760E-03_JPRB, 0.37098749E-03_JPRB, 0.37098731E-03_JPRB, 0.37098714E-03_JPRB /)

RGHG1(:,57, 8) = (/ &
  & 0.37097314E-03_JPRB, 0.37097454E-03_JPRB, 0.37097541E-03_JPRB, 0.37097640E-03_JPRB, 0.37097750E-03_JPRB, 0.37097867E-03_JPRB, &
  & 0.37097948E-03_JPRB, 0.37097995E-03_JPRB, 0.37098030E-03_JPRB, 0.37098059E-03_JPRB, 0.37098088E-03_JPRB, 0.37098120E-03_JPRB, &
  & 0.37098158E-03_JPRB, 0.37098190E-03_JPRB, 0.37098210E-03_JPRB, 0.37098225E-03_JPRB, 0.37098225E-03_JPRB, 0.37098231E-03_JPRB, &
  & 0.37098234E-03_JPRB, 0.37098234E-03_JPRB, 0.37098248E-03_JPRB, 0.37098298E-03_JPRB, 0.37098408E-03_JPRB, 0.37098583E-03_JPRB, &
  & 0.37098766E-03_JPRB, 0.37098944E-03_JPRB, 0.37099086E-03_JPRB, 0.37099209E-03_JPRB, 0.37099328E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099657E-03_JPRB, 0.37099721E-03_JPRB, 0.37099764E-03_JPRB, 0.37099770E-03_JPRB, 0.37099779E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099703E-03_JPRB, 0.37099625E-03_JPRB, 0.37099535E-03_JPRB, 0.37099438E-03_JPRB, 0.37099357E-03_JPRB, &
  & 0.37099267E-03_JPRB, 0.37099188E-03_JPRB, 0.37099127E-03_JPRB, 0.37099043E-03_JPRB, 0.37098993E-03_JPRB, 0.37098973E-03_JPRB, &
  & 0.37098944E-03_JPRB, 0.37098909E-03_JPRB, 0.37098886E-03_JPRB, 0.37098880E-03_JPRB, 0.37098880E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37098871E-03_JPRB, 0.37098868E-03_JPRB, 0.37098859E-03_JPRB, 0.37098856E-03_JPRB, 0.37098848E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098821E-03_JPRB, 0.37098810E-03_JPRB, 0.37098795E-03_JPRB /)

RGHG1(:,58, 8) = (/ &
  & 0.37097672E-03_JPRB, 0.37097765E-03_JPRB, 0.37097829E-03_JPRB, 0.37097893E-03_JPRB, 0.37097969E-03_JPRB, 0.37098047E-03_JPRB, &
  & 0.37098111E-03_JPRB, 0.37098152E-03_JPRB, 0.37098175E-03_JPRB, 0.37098204E-03_JPRB, 0.37098222E-03_JPRB, 0.37098245E-03_JPRB, &
  & 0.37098280E-03_JPRB, 0.37098306E-03_JPRB, 0.37098330E-03_JPRB, 0.37098344E-03_JPRB, 0.37098347E-03_JPRB, 0.37098359E-03_JPRB, &
  & 0.37098353E-03_JPRB, 0.37098356E-03_JPRB, 0.37098362E-03_JPRB, 0.37098405E-03_JPRB, 0.37098498E-03_JPRB, 0.37098644E-03_JPRB, &
  & 0.37098807E-03_JPRB, 0.37098973E-03_JPRB, 0.37099121E-03_JPRB, 0.37099238E-03_JPRB, 0.37099354E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099680E-03_JPRB, 0.37099738E-03_JPRB, 0.37099785E-03_JPRB, 0.37099794E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099730E-03_JPRB, 0.37099654E-03_JPRB, 0.37099569E-03_JPRB, 0.37099479E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099319E-03_JPRB, 0.37099246E-03_JPRB, 0.37099185E-03_JPRB, 0.37099113E-03_JPRB, 0.37099060E-03_JPRB, 0.37099031E-03_JPRB, &
  & 0.37099016E-03_JPRB, 0.37098982E-03_JPRB, 0.37098955E-03_JPRB, 0.37098947E-03_JPRB, 0.37098938E-03_JPRB, 0.37098938E-03_JPRB, &
  & 0.37098935E-03_JPRB, 0.37098932E-03_JPRB, 0.37098932E-03_JPRB, 0.37098932E-03_JPRB, 0.37098926E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098912E-03_JPRB, 0.37098903E-03_JPRB, 0.37098891E-03_JPRB, 0.37098874E-03_JPRB /)

RGHG1(:,59, 8) = (/ &
  & 0.37097931E-03_JPRB, 0.37098007E-03_JPRB, 0.37098053E-03_JPRB, 0.37098094E-03_JPRB, 0.37098140E-03_JPRB, 0.37098193E-03_JPRB, &
  & 0.37098239E-03_JPRB, 0.37098271E-03_JPRB, 0.37098295E-03_JPRB, 0.37098318E-03_JPRB, 0.37098338E-03_JPRB, 0.37098367E-03_JPRB, &
  & 0.37098391E-03_JPRB, 0.37098420E-03_JPRB, 0.37098443E-03_JPRB, 0.37098461E-03_JPRB, 0.37098472E-03_JPRB, 0.37098481E-03_JPRB, &
  & 0.37098469E-03_JPRB, 0.37098461E-03_JPRB, 0.37098466E-03_JPRB, 0.37098490E-03_JPRB, 0.37098571E-03_JPRB, 0.37098705E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37099011E-03_JPRB, 0.37099145E-03_JPRB, 0.37099264E-03_JPRB, 0.37099386E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099698E-03_JPRB, 0.37099764E-03_JPRB, 0.37099808E-03_JPRB, 0.37099817E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099762E-03_JPRB, 0.37099695E-03_JPRB, 0.37099613E-03_JPRB, 0.37099523E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099302E-03_JPRB, 0.37099246E-03_JPRB, 0.37099174E-03_JPRB, 0.37099130E-03_JPRB, 0.37099104E-03_JPRB, &
  & 0.37099081E-03_JPRB, 0.37099048E-03_JPRB, 0.37099028E-03_JPRB, 0.37099019E-03_JPRB, 0.37099016E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37098999E-03_JPRB, 0.37098993E-03_JPRB, 0.37098990E-03_JPRB, 0.37098982E-03_JPRB, 0.37098973E-03_JPRB, &
  & 0.37098961E-03_JPRB, 0.37098952E-03_JPRB, 0.37098944E-03_JPRB, 0.37098926E-03_JPRB /)

RGHG1(:,60, 8) = (/ &
  & 0.37098140E-03_JPRB, 0.37098199E-03_JPRB, 0.37098228E-03_JPRB, 0.37098257E-03_JPRB, 0.37098301E-03_JPRB, 0.37098344E-03_JPRB, &
  & 0.37098385E-03_JPRB, 0.37098411E-03_JPRB, 0.37098431E-03_JPRB, 0.37098449E-03_JPRB, 0.37098466E-03_JPRB, 0.37098484E-03_JPRB, &
  & 0.37098504E-03_JPRB, 0.37098525E-03_JPRB, 0.37098551E-03_JPRB, 0.37098571E-03_JPRB, 0.37098586E-03_JPRB, 0.37098592E-03_JPRB, &
  & 0.37098577E-03_JPRB, 0.37098565E-03_JPRB, 0.37098560E-03_JPRB, 0.37098583E-03_JPRB, 0.37098647E-03_JPRB, 0.37098769E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37099054E-03_JPRB, 0.37099182E-03_JPRB, 0.37099299E-03_JPRB, 0.37099409E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099721E-03_JPRB, 0.37099782E-03_JPRB, 0.37099831E-03_JPRB, 0.37099840E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099794E-03_JPRB, 0.37099727E-03_JPRB, 0.37099654E-03_JPRB, 0.37099569E-03_JPRB, 0.37099500E-03_JPRB, &
  & 0.37099424E-03_JPRB, 0.37099351E-03_JPRB, 0.37099302E-03_JPRB, 0.37099241E-03_JPRB, 0.37099194E-03_JPRB, 0.37099159E-03_JPRB, &
  & 0.37099150E-03_JPRB, 0.37099115E-03_JPRB, 0.37099092E-03_JPRB, 0.37099083E-03_JPRB, 0.37099083E-03_JPRB, 0.37099075E-03_JPRB, &
  & 0.37099072E-03_JPRB, 0.37099066E-03_JPRB, 0.37099060E-03_JPRB, 0.37099048E-03_JPRB, 0.37099031E-03_JPRB, 0.37099016E-03_JPRB, &
  & 0.37099005E-03_JPRB, 0.37098996E-03_JPRB, 0.37098987E-03_JPRB, 0.37098970E-03_JPRB /)

RGHG1(:,61, 8) = (/ &
  & 0.37098312E-03_JPRB, 0.37098353E-03_JPRB, 0.37098379E-03_JPRB, 0.37098402E-03_JPRB, 0.37098426E-03_JPRB, 0.37098452E-03_JPRB, &
  & 0.37098478E-03_JPRB, 0.37098498E-03_JPRB, 0.37098513E-03_JPRB, 0.37098533E-03_JPRB, 0.37098554E-03_JPRB, 0.37098574E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098626E-03_JPRB, 0.37098653E-03_JPRB, 0.37098679E-03_JPRB, 0.37098693E-03_JPRB, 0.37098696E-03_JPRB, &
  & 0.37098685E-03_JPRB, 0.37098667E-03_JPRB, 0.37098664E-03_JPRB, 0.37098673E-03_JPRB, 0.37098728E-03_JPRB, 0.37098833E-03_JPRB, &
  & 0.37098950E-03_JPRB, 0.37099089E-03_JPRB, 0.37099214E-03_JPRB, 0.37099328E-03_JPRB, 0.37099441E-03_JPRB, 0.37099555E-03_JPRB, &
  & 0.37099645E-03_JPRB, 0.37099741E-03_JPRB, 0.37099796E-03_JPRB, 0.37099852E-03_JPRB, 0.37099863E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099823E-03_JPRB, 0.37099764E-03_JPRB, 0.37099692E-03_JPRB, 0.37099604E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099412E-03_JPRB, 0.37099363E-03_JPRB, 0.37099302E-03_JPRB, 0.37099258E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099185E-03_JPRB, 0.37099165E-03_JPRB, 0.37099147E-03_JPRB, 0.37099145E-03_JPRB, 0.37099139E-03_JPRB, &
  & 0.37099130E-03_JPRB, 0.37099124E-03_JPRB, 0.37099113E-03_JPRB, 0.37099101E-03_JPRB, 0.37099089E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099054E-03_JPRB, 0.37099046E-03_JPRB, 0.37099037E-03_JPRB, 0.37099016E-03_JPRB /)

RGHG1(:,62, 8) = (/ &
  & 0.37098443E-03_JPRB, 0.37098475E-03_JPRB, 0.37098490E-03_JPRB, 0.37098507E-03_JPRB, 0.37098533E-03_JPRB, 0.37098560E-03_JPRB, &
  & 0.37098589E-03_JPRB, 0.37098615E-03_JPRB, 0.37098632E-03_JPRB, 0.37098644E-03_JPRB, 0.37098656E-03_JPRB, 0.37098670E-03_JPRB, &
  & 0.37098705E-03_JPRB, 0.37098734E-03_JPRB, 0.37098769E-03_JPRB, 0.37098792E-03_JPRB, 0.37098798E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098763E-03_JPRB, 0.37098755E-03_JPRB, 0.37098772E-03_JPRB, 0.37098821E-03_JPRB, 0.37098909E-03_JPRB, &
  & 0.37099016E-03_JPRB, 0.37099145E-03_JPRB, 0.37099255E-03_JPRB, 0.37099372E-03_JPRB, 0.37099476E-03_JPRB, 0.37099587E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099770E-03_JPRB, 0.37099826E-03_JPRB, 0.37099875E-03_JPRB, 0.37099890E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099855E-03_JPRB, 0.37099802E-03_JPRB, 0.37099735E-03_JPRB, 0.37099663E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099456E-03_JPRB, 0.37099424E-03_JPRB, 0.37099372E-03_JPRB, 0.37099319E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099278E-03_JPRB, 0.37099246E-03_JPRB, 0.37099232E-03_JPRB, 0.37099211E-03_JPRB, 0.37099211E-03_JPRB, 0.37099197E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099182E-03_JPRB, 0.37099171E-03_JPRB, 0.37099159E-03_JPRB, 0.37099139E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099095E-03_JPRB, 0.37099083E-03_JPRB, 0.37099054E-03_JPRB /)

RGHG1(:,63, 8) = (/ &
  & 0.37098557E-03_JPRB, 0.37098583E-03_JPRB, 0.37098597E-03_JPRB, 0.37098612E-03_JPRB, 0.37098632E-03_JPRB, 0.37098656E-03_JPRB, &
  & 0.37098682E-03_JPRB, 0.37098702E-03_JPRB, 0.37098717E-03_JPRB, 0.37098734E-03_JPRB, 0.37098755E-03_JPRB, 0.37098781E-03_JPRB, &
  & 0.37098810E-03_JPRB, 0.37098845E-03_JPRB, 0.37098877E-03_JPRB, 0.37098909E-03_JPRB, 0.37098909E-03_JPRB, 0.37098912E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098874E-03_JPRB, 0.37098845E-03_JPRB, 0.37098856E-03_JPRB, 0.37098903E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099200E-03_JPRB, 0.37099299E-03_JPRB, 0.37099418E-03_JPRB, 0.37099523E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099715E-03_JPRB, 0.37099802E-03_JPRB, 0.37099858E-03_JPRB, 0.37099901E-03_JPRB, 0.37099919E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099887E-03_JPRB, 0.37099834E-03_JPRB, 0.37099776E-03_JPRB, 0.37099712E-03_JPRB, 0.37099636E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099508E-03_JPRB, 0.37099479E-03_JPRB, 0.37099427E-03_JPRB, 0.37099380E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099345E-03_JPRB, 0.37099316E-03_JPRB, 0.37099296E-03_JPRB, 0.37099276E-03_JPRB, 0.37099276E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099252E-03_JPRB, 0.37099252E-03_JPRB, 0.37099235E-03_JPRB, 0.37099211E-03_JPRB, 0.37099188E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099139E-03_JPRB, 0.37099118E-03_JPRB, 0.37099089E-03_JPRB /)

RGHG1(:,64, 8) = (/ &
  & 0.37098661E-03_JPRB, 0.37098688E-03_JPRB, 0.37098705E-03_JPRB, 0.37098717E-03_JPRB, 0.37098737E-03_JPRB, 0.37098757E-03_JPRB, &
  & 0.37098781E-03_JPRB, 0.37098801E-03_JPRB, 0.37098819E-03_JPRB, 0.37098839E-03_JPRB, 0.37098848E-03_JPRB, 0.37098877E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098952E-03_JPRB, 0.37098982E-03_JPRB, 0.37099016E-03_JPRB, 0.37099014E-03_JPRB, 0.37099005E-03_JPRB, &
  & 0.37098982E-03_JPRB, 0.37098958E-03_JPRB, 0.37098941E-03_JPRB, 0.37098952E-03_JPRB, 0.37098990E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099142E-03_JPRB, 0.37099243E-03_JPRB, 0.37099348E-03_JPRB, 0.37099468E-03_JPRB, 0.37099564E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099840E-03_JPRB, 0.37099890E-03_JPRB, 0.37099927E-03_JPRB, 0.37099945E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099919E-03_JPRB, 0.37099872E-03_JPRB, 0.37099820E-03_JPRB, 0.37099759E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099567E-03_JPRB, 0.37099526E-03_JPRB, 0.37099485E-03_JPRB, 0.37099450E-03_JPRB, 0.37099421E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099386E-03_JPRB, 0.37099369E-03_JPRB, 0.37099342E-03_JPRB, 0.37099337E-03_JPRB, 0.37099331E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099319E-03_JPRB, 0.37099299E-03_JPRB, 0.37099270E-03_JPRB, 0.37099241E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099182E-03_JPRB, 0.37099156E-03_JPRB, 0.37099118E-03_JPRB /)

RGHG1(:,65, 8) = (/ &
  & 0.37098752E-03_JPRB, 0.37098775E-03_JPRB, 0.37098787E-03_JPRB, 0.37098801E-03_JPRB, 0.37098821E-03_JPRB, 0.37098845E-03_JPRB, &
  & 0.37098871E-03_JPRB, 0.37098891E-03_JPRB, 0.37098909E-03_JPRB, 0.37098932E-03_JPRB, 0.37098955E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37099051E-03_JPRB, 0.37099083E-03_JPRB, 0.37099118E-03_JPRB, 0.37099113E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099063E-03_JPRB, 0.37099034E-03_JPRB, 0.37099034E-03_JPRB, 0.37099072E-03_JPRB, 0.37099139E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099302E-03_JPRB, 0.37099404E-03_JPRB, 0.37099517E-03_JPRB, 0.37099619E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099881E-03_JPRB, 0.37099922E-03_JPRB, 0.37099951E-03_JPRB, 0.37099965E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, 0.37099907E-03_JPRB, 0.37099860E-03_JPRB, 0.37099808E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099680E-03_JPRB, 0.37099616E-03_JPRB, 0.37099578E-03_JPRB, 0.37099546E-03_JPRB, 0.37099505E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099450E-03_JPRB, 0.37099430E-03_JPRB, 0.37099406E-03_JPRB, 0.37099398E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099386E-03_JPRB, 0.37099354E-03_JPRB, 0.37099325E-03_JPRB, 0.37099293E-03_JPRB, 0.37099273E-03_JPRB, &
  & 0.37099249E-03_JPRB, 0.37099223E-03_JPRB, 0.37099194E-03_JPRB, 0.37099153E-03_JPRB /)

RGHG1(:,66, 8) = (/ &
  & 0.37098833E-03_JPRB, 0.37098862E-03_JPRB, 0.37098877E-03_JPRB, 0.37098891E-03_JPRB, 0.37098915E-03_JPRB, 0.37098935E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37098979E-03_JPRB, 0.37099002E-03_JPRB, 0.37099019E-03_JPRB, 0.37099040E-03_JPRB, 0.37099075E-03_JPRB, &
  & 0.37099101E-03_JPRB, 0.37099150E-03_JPRB, 0.37099194E-03_JPRB, 0.37099223E-03_JPRB, 0.37099211E-03_JPRB, 0.37099209E-03_JPRB, &
  & 0.37099185E-03_JPRB, 0.37099147E-03_JPRB, 0.37099118E-03_JPRB, 0.37099130E-03_JPRB, 0.37099162E-03_JPRB, 0.37099220E-03_JPRB, &
  & 0.37099281E-03_JPRB, 0.37099372E-03_JPRB, 0.37099462E-03_JPRB, 0.37099569E-03_JPRB, 0.37099665E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099904E-03_JPRB, 0.37099945E-03_JPRB, 0.37099968E-03_JPRB, 0.37099991E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099968E-03_JPRB, 0.37099942E-03_JPRB, 0.37099898E-03_JPRB, 0.37099855E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099677E-03_JPRB, 0.37099636E-03_JPRB, 0.37099601E-03_JPRB, 0.37099567E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099511E-03_JPRB, 0.37099491E-03_JPRB, 0.37099476E-03_JPRB, 0.37099459E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099444E-03_JPRB, 0.37099418E-03_JPRB, 0.37099380E-03_JPRB, 0.37099351E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099308E-03_JPRB, 0.37099284E-03_JPRB, 0.37099246E-03_JPRB, 0.37099191E-03_JPRB /)

RGHG1(:,67, 8) = (/ &
  & 0.37098909E-03_JPRB, 0.37098935E-03_JPRB, 0.37098950E-03_JPRB, 0.37098967E-03_JPRB, 0.37098987E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099040E-03_JPRB, 0.37099060E-03_JPRB, 0.37099089E-03_JPRB, 0.37099110E-03_JPRB, 0.37099142E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099197E-03_JPRB, 0.37099241E-03_JPRB, 0.37099290E-03_JPRB, 0.37099310E-03_JPRB, 0.37099296E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099276E-03_JPRB, 0.37099252E-03_JPRB, 0.37099214E-03_JPRB, 0.37099209E-03_JPRB, 0.37099252E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099357E-03_JPRB, 0.37099438E-03_JPRB, 0.37099520E-03_JPRB, 0.37099619E-03_JPRB, 0.37099712E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099930E-03_JPRB, 0.37099962E-03_JPRB, 0.37099997E-03_JPRB, 0.37100015E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099991E-03_JPRB, 0.37099974E-03_JPRB, 0.37099930E-03_JPRB, 0.37099890E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099724E-03_JPRB, 0.37099689E-03_JPRB, 0.37099657E-03_JPRB, 0.37099625E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099584E-03_JPRB, 0.37099572E-03_JPRB, 0.37099552E-03_JPRB, 0.37099535E-03_JPRB, 0.37099517E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099514E-03_JPRB, 0.37099485E-03_JPRB, 0.37099450E-03_JPRB, 0.37099412E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099334E-03_JPRB, 0.37099290E-03_JPRB, 0.37099232E-03_JPRB /)

RGHG1(:,68, 8) = (/ &
  & 0.37098984E-03_JPRB, 0.37099025E-03_JPRB, 0.37099043E-03_JPRB, 0.37099063E-03_JPRB, 0.37099083E-03_JPRB, 0.37099107E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099145E-03_JPRB, 0.37099185E-03_JPRB, 0.37099197E-03_JPRB, 0.37099241E-03_JPRB, 0.37099267E-03_JPRB, &
  & 0.37099287E-03_JPRB, 0.37099322E-03_JPRB, 0.37099383E-03_JPRB, 0.37099398E-03_JPRB, 0.37099386E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099331E-03_JPRB, 0.37099296E-03_JPRB, 0.37099290E-03_JPRB, 0.37099340E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099436E-03_JPRB, 0.37099503E-03_JPRB, 0.37099578E-03_JPRB, 0.37099677E-03_JPRB, 0.37099753E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099971E-03_JPRB, 0.37099991E-03_JPRB, 0.37100003E-03_JPRB, 0.37100015E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100009E-03_JPRB, 0.37099989E-03_JPRB, 0.37099962E-03_JPRB, 0.37099925E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099770E-03_JPRB, 0.37099735E-03_JPRB, 0.37099700E-03_JPRB, 0.37099680E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099633E-03_JPRB, 0.37099616E-03_JPRB, 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099567E-03_JPRB, 0.37099546E-03_JPRB, 0.37099514E-03_JPRB, 0.37099482E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099424E-03_JPRB, 0.37099389E-03_JPRB, 0.37099342E-03_JPRB, 0.37099284E-03_JPRB /)

RGHG1(:,69, 8) = (/ &
  & 0.37099057E-03_JPRB, 0.37099101E-03_JPRB, 0.37099124E-03_JPRB, 0.37099142E-03_JPRB, 0.37099165E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099238E-03_JPRB, 0.37099281E-03_JPRB, 0.37099290E-03_JPRB, 0.37099331E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37099404E-03_JPRB, 0.37099459E-03_JPRB, 0.37099473E-03_JPRB, 0.37099465E-03_JPRB, 0.37099465E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099427E-03_JPRB, 0.37099386E-03_JPRB, 0.37099374E-03_JPRB, 0.37099424E-03_JPRB, 0.37099471E-03_JPRB, &
  & 0.37099511E-03_JPRB, 0.37099564E-03_JPRB, 0.37099633E-03_JPRB, 0.37099721E-03_JPRB, 0.37099788E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099994E-03_JPRB, 0.37100015E-03_JPRB, 0.37100026E-03_JPRB, 0.37100035E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100021E-03_JPRB, 0.37100018E-03_JPRB, 0.37099991E-03_JPRB, 0.37099959E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099808E-03_JPRB, 0.37099785E-03_JPRB, 0.37099753E-03_JPRB, 0.37099727E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099692E-03_JPRB, 0.37099665E-03_JPRB, 0.37099648E-03_JPRB, 0.37099633E-03_JPRB, 0.37099636E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099636E-03_JPRB, 0.37099613E-03_JPRB, 0.37099584E-03_JPRB, 0.37099543E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099465E-03_JPRB, 0.37099406E-03_JPRB, 0.37099345E-03_JPRB /)

RGHG1(:,70, 8) = (/ &
  & 0.37099118E-03_JPRB, 0.37099179E-03_JPRB, 0.37099206E-03_JPRB, 0.37099211E-03_JPRB, 0.37099246E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099310E-03_JPRB, 0.37099334E-03_JPRB, 0.37099380E-03_JPRB, 0.37099374E-03_JPRB, 0.37099412E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099459E-03_JPRB, 0.37099482E-03_JPRB, 0.37099549E-03_JPRB, 0.37099552E-03_JPRB, 0.37099549E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099508E-03_JPRB, 0.37099476E-03_JPRB, 0.37099453E-03_JPRB, 0.37099508E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099584E-03_JPRB, 0.37099622E-03_JPRB, 0.37099692E-03_JPRB, 0.37099776E-03_JPRB, 0.37099831E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37100018E-03_JPRB, 0.37100026E-03_JPRB, 0.37100041E-03_JPRB, 0.37100053E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100038E-03_JPRB, 0.37100035E-03_JPRB, 0.37100009E-03_JPRB, 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099843E-03_JPRB, 0.37099831E-03_JPRB, 0.37099791E-03_JPRB, 0.37099767E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099750E-03_JPRB, 0.37099727E-03_JPRB, 0.37099712E-03_JPRB, 0.37099689E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37099698E-03_JPRB, 0.37099668E-03_JPRB, 0.37099642E-03_JPRB, 0.37099616E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099532E-03_JPRB, 0.37099473E-03_JPRB, 0.37099415E-03_JPRB /)

RGHG1(:,71, 8) = (/ &
  & 0.37099185E-03_JPRB, 0.37099258E-03_JPRB, 0.37099281E-03_JPRB, 0.37099293E-03_JPRB, 0.37099334E-03_JPRB, 0.37099372E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099421E-03_JPRB, 0.37099462E-03_JPRB, 0.37099462E-03_JPRB, 0.37099485E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099558E-03_JPRB, 0.37099622E-03_JPRB, 0.37099625E-03_JPRB, 0.37099622E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099599E-03_JPRB, 0.37099564E-03_JPRB, 0.37099526E-03_JPRB, 0.37099590E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099677E-03_JPRB, 0.37099750E-03_JPRB, 0.37099831E-03_JPRB, 0.37099869E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37100044E-03_JPRB, 0.37100050E-03_JPRB, 0.37100050E-03_JPRB, 0.37100070E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100044E-03_JPRB, 0.37100055E-03_JPRB, 0.37100032E-03_JPRB, 0.37100018E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099872E-03_JPRB, 0.37099875E-03_JPRB, 0.37099834E-03_JPRB, 0.37099811E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099796E-03_JPRB, 0.37099776E-03_JPRB, 0.37099773E-03_JPRB, 0.37099735E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099764E-03_JPRB, 0.37099724E-03_JPRB, 0.37099709E-03_JPRB, 0.37099689E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099601E-03_JPRB, 0.37099543E-03_JPRB, 0.37099500E-03_JPRB /)

RGHG1(:,72, 8) = (/ &
  & 0.37099258E-03_JPRB, 0.37099351E-03_JPRB, 0.37099377E-03_JPRB, 0.37099392E-03_JPRB, 0.37099436E-03_JPRB, 0.37099479E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37099514E-03_JPRB, 0.37099552E-03_JPRB, 0.37099552E-03_JPRB, 0.37099558E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099631E-03_JPRB, 0.37099700E-03_JPRB, 0.37099695E-03_JPRB, 0.37099686E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099665E-03_JPRB, 0.37099642E-03_JPRB, 0.37099593E-03_JPRB, 0.37099660E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099727E-03_JPRB, 0.37099794E-03_JPRB, 0.37099884E-03_JPRB, 0.37099904E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100067E-03_JPRB, 0.37100058E-03_JPRB, 0.37100064E-03_JPRB, 0.37100082E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100047E-03_JPRB, 0.37100067E-03_JPRB, 0.37100041E-03_JPRB, 0.37100055E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099904E-03_JPRB, 0.37099919E-03_JPRB, 0.37099863E-03_JPRB, 0.37099852E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099858E-03_JPRB, 0.37099826E-03_JPRB, 0.37099814E-03_JPRB, 0.37099776E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099831E-03_JPRB, 0.37099794E-03_JPRB, 0.37099776E-03_JPRB, 0.37099756E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099680E-03_JPRB, 0.37099616E-03_JPRB, 0.37099575E-03_JPRB /)

RGHG1(:,73, 8) = (/ &
  & 0.37099351E-03_JPRB, 0.37099459E-03_JPRB, 0.37099482E-03_JPRB, 0.37099485E-03_JPRB, 0.37099532E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099607E-03_JPRB, 0.37099645E-03_JPRB, 0.37099636E-03_JPRB, 0.37099631E-03_JPRB, 0.37099680E-03_JPRB, &
  & 0.37099674E-03_JPRB, 0.37099689E-03_JPRB, 0.37099773E-03_JPRB, 0.37099759E-03_JPRB, 0.37099753E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099750E-03_JPRB, 0.37099732E-03_JPRB, 0.37099665E-03_JPRB, 0.37099738E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099762E-03_JPRB, 0.37099834E-03_JPRB, 0.37099933E-03_JPRB, 0.37099939E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100085E-03_JPRB, 0.37100073E-03_JPRB, 0.37100067E-03_JPRB, 0.37100096E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100047E-03_JPRB, 0.37100082E-03_JPRB, 0.37100050E-03_JPRB, 0.37100096E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099919E-03_JPRB, 0.37099954E-03_JPRB, 0.37099890E-03_JPRB, 0.37099884E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37099904E-03_JPRB, 0.37099869E-03_JPRB, 0.37099863E-03_JPRB, 0.37099820E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099895E-03_JPRB, 0.37099849E-03_JPRB, 0.37099840E-03_JPRB, 0.37099840E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099759E-03_JPRB, 0.37099671E-03_JPRB, 0.37099654E-03_JPRB /)

RGHG1(:,74, 8) = (/ &
  & 0.37099465E-03_JPRB, 0.37099558E-03_JPRB, 0.37099590E-03_JPRB, 0.37099575E-03_JPRB, 0.37099639E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099698E-03_JPRB, 0.37099727E-03_JPRB, 0.37099700E-03_JPRB, 0.37099686E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099764E-03_JPRB, 0.37099863E-03_JPRB, 0.37099811E-03_JPRB, 0.37099808E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099808E-03_JPRB, 0.37099808E-03_JPRB, 0.37099727E-03_JPRB, 0.37099805E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099796E-03_JPRB, 0.37099872E-03_JPRB, 0.37099991E-03_JPRB, 0.37099974E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100102E-03_JPRB, 0.37100082E-03_JPRB, 0.37100076E-03_JPRB, 0.37100114E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100050E-03_JPRB, 0.37100085E-03_JPRB, 0.37100053E-03_JPRB, 0.37100137E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099927E-03_JPRB, 0.37099983E-03_JPRB, 0.37099907E-03_JPRB, 0.37099913E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37099951E-03_JPRB, 0.37099910E-03_JPRB, 0.37099898E-03_JPRB, 0.37099858E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099945E-03_JPRB, 0.37099898E-03_JPRB, 0.37099890E-03_JPRB, 0.37099916E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099834E-03_JPRB, 0.37099732E-03_JPRB, 0.37099732E-03_JPRB /)

RGHG1(:,75, 8) = (/ &
  & 0.37099584E-03_JPRB, 0.37099668E-03_JPRB, 0.37099698E-03_JPRB, 0.37099660E-03_JPRB, 0.37099747E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099770E-03_JPRB, 0.37099799E-03_JPRB, 0.37099770E-03_JPRB, 0.37099741E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099791E-03_JPRB, 0.37099805E-03_JPRB, 0.37099936E-03_JPRB, 0.37099863E-03_JPRB, 0.37099849E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099878E-03_JPRB, 0.37099898E-03_JPRB, 0.37099788E-03_JPRB, 0.37099866E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099817E-03_JPRB, 0.37099901E-03_JPRB, 0.37100041E-03_JPRB, 0.37100000E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100125E-03_JPRB, 0.37100093E-03_JPRB, 0.37100088E-03_JPRB, 0.37100125E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100053E-03_JPRB, 0.37100099E-03_JPRB, 0.37100061E-03_JPRB, 0.37100192E-03_JPRB, 0.37100140E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, 0.37100009E-03_JPRB, 0.37099922E-03_JPRB, 0.37099939E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37100006E-03_JPRB, 0.37099942E-03_JPRB, 0.37099939E-03_JPRB, 0.37099887E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, 0.37099927E-03_JPRB, 0.37099977E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099895E-03_JPRB, 0.37099762E-03_JPRB, 0.37099799E-03_JPRB /)

RGHG1(:,76, 8) = (/ &
  & 0.37099712E-03_JPRB, 0.37099776E-03_JPRB, 0.37099802E-03_JPRB, 0.37099741E-03_JPRB, 0.37099849E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099837E-03_JPRB, 0.37099881E-03_JPRB, 0.37099811E-03_JPRB, 0.37099764E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099858E-03_JPRB, 0.37100018E-03_JPRB, 0.37099910E-03_JPRB, 0.37099884E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099930E-03_JPRB, 0.37099962E-03_JPRB, 0.37099828E-03_JPRB, 0.37099919E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099820E-03_JPRB, 0.37099919E-03_JPRB, 0.37100096E-03_JPRB, 0.37100018E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100140E-03_JPRB, 0.37100102E-03_JPRB, 0.37100090E-03_JPRB, 0.37100140E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100082E-03_JPRB, 0.37100055E-03_JPRB, 0.37100114E-03_JPRB, 0.37100053E-03_JPRB, 0.37100248E-03_JPRB, 0.37100192E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099925E-03_JPRB, 0.37100026E-03_JPRB, 0.37099922E-03_JPRB, 0.37099959E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37100058E-03_JPRB, 0.37099968E-03_JPRB, 0.37099974E-03_JPRB, 0.37099916E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37100047E-03_JPRB, 0.37099959E-03_JPRB, 0.37099965E-03_JPRB, 0.37100058E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099968E-03_JPRB, 0.37099788E-03_JPRB, 0.37099863E-03_JPRB /)

RGHG1(:,77, 8) = (/ &
  & 0.37099843E-03_JPRB, 0.37099878E-03_JPRB, 0.37099904E-03_JPRB, 0.37099811E-03_JPRB, 0.37099957E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099881E-03_JPRB, 0.37099962E-03_JPRB, 0.37099863E-03_JPRB, 0.37099782E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099878E-03_JPRB, 0.37100099E-03_JPRB, 0.37099939E-03_JPRB, 0.37099919E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37099989E-03_JPRB, 0.37100038E-03_JPRB, 0.37099858E-03_JPRB, 0.37099974E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099820E-03_JPRB, 0.37099930E-03_JPRB, 0.37100149E-03_JPRB, 0.37100026E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100157E-03_JPRB, 0.37100152E-03_JPRB, 0.37100108E-03_JPRB, 0.37100102E-03_JPRB, 0.37100154E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100041E-03_JPRB, 0.37100128E-03_JPRB, 0.37100044E-03_JPRB, 0.37100312E-03_JPRB, 0.37100248E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099913E-03_JPRB, 0.37100041E-03_JPRB, 0.37099925E-03_JPRB, 0.37099986E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100108E-03_JPRB, 0.37099983E-03_JPRB, 0.37100006E-03_JPRB, 0.37099925E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100099E-03_JPRB, 0.37099974E-03_JPRB, 0.37099991E-03_JPRB, 0.37100137E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100044E-03_JPRB, 0.37099791E-03_JPRB, 0.37099922E-03_JPRB /)

RGHG1(:,78, 8) = (/ &
  & 0.37099983E-03_JPRB, 0.37099983E-03_JPRB, 0.37100009E-03_JPRB, 0.37099860E-03_JPRB, 0.37100061E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099916E-03_JPRB, 0.37100050E-03_JPRB, 0.37099869E-03_JPRB, 0.37099759E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099904E-03_JPRB, 0.37100166E-03_JPRB, 0.37099957E-03_JPRB, 0.37099951E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100044E-03_JPRB, 0.37100125E-03_JPRB, 0.37099878E-03_JPRB, 0.37100015E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099805E-03_JPRB, 0.37099936E-03_JPRB, 0.37100195E-03_JPRB, 0.37100032E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100175E-03_JPRB, 0.37100175E-03_JPRB, 0.37100114E-03_JPRB, 0.37100099E-03_JPRB, 0.37100166E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100038E-03_JPRB, 0.37100146E-03_JPRB, 0.37100035E-03_JPRB, 0.37100370E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099898E-03_JPRB, 0.37100050E-03_JPRB, 0.37099916E-03_JPRB, 0.37100003E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100166E-03_JPRB, 0.37100000E-03_JPRB, 0.37100038E-03_JPRB, 0.37099936E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100140E-03_JPRB, 0.37099974E-03_JPRB, 0.37099991E-03_JPRB, 0.37100213E-03_JPRB, 0.37100169E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100102E-03_JPRB, 0.37099779E-03_JPRB, 0.37099977E-03_JPRB /)

RGHG1(:,79, 8) = (/ &
  & 0.37100108E-03_JPRB, 0.37100050E-03_JPRB, 0.37100079E-03_JPRB, 0.37099884E-03_JPRB, 0.37100128E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099916E-03_JPRB, 0.37100120E-03_JPRB, 0.37099881E-03_JPRB, 0.37099724E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099919E-03_JPRB, 0.37100227E-03_JPRB, 0.37099971E-03_JPRB, 0.37099959E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37100082E-03_JPRB, 0.37100189E-03_JPRB, 0.37099881E-03_JPRB, 0.37100047E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37099776E-03_JPRB, 0.37099927E-03_JPRB, 0.37100236E-03_JPRB, 0.37100035E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100204E-03_JPRB, 0.37100122E-03_JPRB, 0.37100114E-03_JPRB, 0.37100192E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100041E-03_JPRB, 0.37100178E-03_JPRB, 0.37100038E-03_JPRB, 0.37100434E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099878E-03_JPRB, 0.37100053E-03_JPRB, 0.37099901E-03_JPRB, 0.37100015E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100218E-03_JPRB, 0.37100003E-03_JPRB, 0.37100061E-03_JPRB, 0.37099936E-03_JPRB, 0.37100210E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100178E-03_JPRB, 0.37099965E-03_JPRB, 0.37099994E-03_JPRB, 0.37100282E-03_JPRB, 0.37100221E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100149E-03_JPRB, 0.37099738E-03_JPRB, 0.37100021E-03_JPRB /)

RGHG1(:,80, 8) = (/ &
  & 0.37100230E-03_JPRB, 0.37100093E-03_JPRB, 0.37100125E-03_JPRB, 0.37099895E-03_JPRB, 0.37100172E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37099922E-03_JPRB, 0.37100160E-03_JPRB, 0.37099893E-03_JPRB, 0.37099703E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099925E-03_JPRB, 0.37100271E-03_JPRB, 0.37099980E-03_JPRB, 0.37099968E-03_JPRB, 0.37100122E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100102E-03_JPRB, 0.37100242E-03_JPRB, 0.37099875E-03_JPRB, 0.37100070E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37099759E-03_JPRB, 0.37099933E-03_JPRB, 0.37100262E-03_JPRB, 0.37100044E-03_JPRB, 0.37100355E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37100227E-03_JPRB, 0.37100137E-03_JPRB, 0.37100125E-03_JPRB, 0.37100210E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100050E-03_JPRB, 0.37100201E-03_JPRB, 0.37100055E-03_JPRB, 0.37100492E-03_JPRB, 0.37100425E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37099866E-03_JPRB, 0.37100058E-03_JPRB, 0.37099890E-03_JPRB, 0.37100023E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100262E-03_JPRB, 0.37100003E-03_JPRB, 0.37100073E-03_JPRB, 0.37099922E-03_JPRB, 0.37100250E-03_JPRB, &
  & 0.37100111E-03_JPRB, 0.37100210E-03_JPRB, 0.37099951E-03_JPRB, 0.37099997E-03_JPRB, 0.37100341E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100186E-03_JPRB, 0.37099698E-03_JPRB, 0.37100064E-03_JPRB /)

RGHG1(:,81, 8) = (/ &
  & 0.37100349E-03_JPRB, 0.37100114E-03_JPRB, 0.37100140E-03_JPRB, 0.37099893E-03_JPRB, 0.37100201E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37099954E-03_JPRB, 0.37100181E-03_JPRB, 0.37099855E-03_JPRB, 0.37099689E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099922E-03_JPRB, 0.37100291E-03_JPRB, 0.37099980E-03_JPRB, 0.37099971E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37100207E-03_JPRB, 0.37100111E-03_JPRB, 0.37100274E-03_JPRB, 0.37099855E-03_JPRB, 0.37100090E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37099741E-03_JPRB, 0.37099930E-03_JPRB, 0.37100285E-03_JPRB, 0.37100061E-03_JPRB, 0.37100373E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100248E-03_JPRB, 0.37100149E-03_JPRB, 0.37100131E-03_JPRB, 0.37100233E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100053E-03_JPRB, 0.37100213E-03_JPRB, 0.37100064E-03_JPRB, 0.37100521E-03_JPRB, 0.37100460E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37099863E-03_JPRB, 0.37100055E-03_JPRB, 0.37099884E-03_JPRB, 0.37100038E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100285E-03_JPRB, 0.37100006E-03_JPRB, 0.37100079E-03_JPRB, 0.37099910E-03_JPRB, 0.37100280E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100233E-03_JPRB, 0.37099948E-03_JPRB, 0.37099986E-03_JPRB, 0.37100373E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100213E-03_JPRB, 0.37099677E-03_JPRB, 0.37100114E-03_JPRB /)

RGHG1(:,82, 8) = (/ &
  & 0.37100358E-03_JPRB, 0.37100125E-03_JPRB, 0.37100149E-03_JPRB, 0.37099893E-03_JPRB, 0.37100218E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37099933E-03_JPRB, 0.37100154E-03_JPRB, 0.37099916E-03_JPRB, 0.37099709E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099930E-03_JPRB, 0.37100306E-03_JPRB, 0.37099983E-03_JPRB, 0.37099965E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100122E-03_JPRB, 0.37100294E-03_JPRB, 0.37099837E-03_JPRB, 0.37100108E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37099721E-03_JPRB, 0.37099927E-03_JPRB, 0.37100300E-03_JPRB, 0.37100073E-03_JPRB, 0.37100390E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100253E-03_JPRB, 0.37100154E-03_JPRB, 0.37100134E-03_JPRB, 0.37100242E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100055E-03_JPRB, 0.37100224E-03_JPRB, 0.37100082E-03_JPRB, 0.37100539E-03_JPRB, 0.37100475E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37099858E-03_JPRB, 0.37100055E-03_JPRB, 0.37099881E-03_JPRB, 0.37100041E-03_JPRB, 0.37100088E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100303E-03_JPRB, 0.37099994E-03_JPRB, 0.37100085E-03_JPRB, 0.37099898E-03_JPRB, 0.37100306E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37100242E-03_JPRB, 0.37099930E-03_JPRB, 0.37099983E-03_JPRB, 0.37100393E-03_JPRB, 0.37100309E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100227E-03_JPRB, 0.37099665E-03_JPRB, 0.37100122E-03_JPRB /)

RGHG1(:,83, 8) = (/ &
  & 0.37100367E-03_JPRB, 0.37100137E-03_JPRB, 0.37100160E-03_JPRB, 0.37099893E-03_JPRB, 0.37100224E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37099986E-03_JPRB, 0.37100157E-03_JPRB, 0.37099823E-03_JPRB, 0.37099700E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099942E-03_JPRB, 0.37100315E-03_JPRB, 0.37099991E-03_JPRB, 0.37099962E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100131E-03_JPRB, 0.37100317E-03_JPRB, 0.37099823E-03_JPRB, 0.37100120E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37099703E-03_JPRB, 0.37099925E-03_JPRB, 0.37100315E-03_JPRB, 0.37100079E-03_JPRB, 0.37100399E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100262E-03_JPRB, 0.37100157E-03_JPRB, 0.37100143E-03_JPRB, 0.37100245E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100058E-03_JPRB, 0.37100224E-03_JPRB, 0.37100093E-03_JPRB, 0.37100550E-03_JPRB, 0.37100486E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37099860E-03_JPRB, 0.37100055E-03_JPRB, 0.37099875E-03_JPRB, 0.37100044E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100317E-03_JPRB, 0.37099997E-03_JPRB, 0.37100093E-03_JPRB, 0.37099893E-03_JPRB, 0.37100320E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100256E-03_JPRB, 0.37099925E-03_JPRB, 0.37099974E-03_JPRB, 0.37100411E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100245E-03_JPRB, 0.37099654E-03_JPRB, 0.37100128E-03_JPRB /)

RGHG1(:,84, 8) = (/ &
  & 0.37100376E-03_JPRB, 0.37100146E-03_JPRB, 0.37100166E-03_JPRB, 0.37099887E-03_JPRB, 0.37100230E-03_JPRB, 0.37100134E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099957E-03_JPRB, 0.37100108E-03_JPRB, 0.37099933E-03_JPRB, 0.37099773E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099957E-03_JPRB, 0.37100288E-03_JPRB, 0.37099997E-03_JPRB, 0.37099968E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100131E-03_JPRB, 0.37100329E-03_JPRB, 0.37099808E-03_JPRB, 0.37100131E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37099683E-03_JPRB, 0.37099910E-03_JPRB, 0.37100323E-03_JPRB, 0.37100085E-03_JPRB, 0.37100405E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100271E-03_JPRB, 0.37100163E-03_JPRB, 0.37100149E-03_JPRB, 0.37100250E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100050E-03_JPRB, 0.37100230E-03_JPRB, 0.37100102E-03_JPRB, 0.37100550E-03_JPRB, 0.37100498E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37099855E-03_JPRB, 0.37100044E-03_JPRB, 0.37099869E-03_JPRB, 0.37100038E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100326E-03_JPRB, 0.37099991E-03_JPRB, 0.37100096E-03_JPRB, 0.37099878E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100265E-03_JPRB, 0.37099919E-03_JPRB, 0.37099968E-03_JPRB, 0.37100428E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100259E-03_JPRB, 0.37099651E-03_JPRB, 0.37100131E-03_JPRB /)

RGHG1(:,85, 8) = (/ &
  & 0.37100379E-03_JPRB, 0.37100152E-03_JPRB, 0.37100175E-03_JPRB, 0.37099884E-03_JPRB, 0.37100236E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100003E-03_JPRB, 0.37100088E-03_JPRB, 0.37099872E-03_JPRB, 0.37099799E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099997E-03_JPRB, 0.37100224E-03_JPRB, 0.37100015E-03_JPRB, 0.37099986E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100128E-03_JPRB, 0.37100341E-03_JPRB, 0.37099791E-03_JPRB, 0.37100143E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37099663E-03_JPRB, 0.37099922E-03_JPRB, 0.37100338E-03_JPRB, 0.37100088E-03_JPRB, 0.37100411E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100280E-03_JPRB, 0.37100163E-03_JPRB, 0.37100149E-03_JPRB, 0.37100253E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100053E-03_JPRB, 0.37100233E-03_JPRB, 0.37100102E-03_JPRB, 0.37100562E-03_JPRB, 0.37100515E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37099855E-03_JPRB, 0.37100044E-03_JPRB, 0.37099869E-03_JPRB, 0.37100044E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100329E-03_JPRB, 0.37100000E-03_JPRB, 0.37100111E-03_JPRB, 0.37099884E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100140E-03_JPRB, 0.37100280E-03_JPRB, 0.37099916E-03_JPRB, 0.37099962E-03_JPRB, 0.37100434E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100271E-03_JPRB, 0.37099642E-03_JPRB, 0.37100125E-03_JPRB /)

RGHG1(:,86, 8) = (/ &
  & 0.37100381E-03_JPRB, 0.37100154E-03_JPRB, 0.37100178E-03_JPRB, 0.37099884E-03_JPRB, 0.37100230E-03_JPRB, 0.37100134E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099980E-03_JPRB, 0.37100038E-03_JPRB, 0.37099927E-03_JPRB, 0.37099852E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37100006E-03_JPRB, 0.37100166E-03_JPRB, 0.37100041E-03_JPRB, 0.37100009E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100134E-03_JPRB, 0.37100347E-03_JPRB, 0.37099785E-03_JPRB, 0.37100149E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37099639E-03_JPRB, 0.37099895E-03_JPRB, 0.37100349E-03_JPRB, 0.37100076E-03_JPRB, 0.37100422E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100280E-03_JPRB, 0.37100172E-03_JPRB, 0.37100154E-03_JPRB, 0.37100265E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100044E-03_JPRB, 0.37100236E-03_JPRB, 0.37100096E-03_JPRB, 0.37100579E-03_JPRB, 0.37100527E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37099840E-03_JPRB, 0.37100044E-03_JPRB, 0.37099869E-03_JPRB, 0.37100038E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100326E-03_JPRB, 0.37100006E-03_JPRB, 0.37100120E-03_JPRB, 0.37099881E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100280E-03_JPRB, 0.37099907E-03_JPRB, 0.37099962E-03_JPRB, 0.37100448E-03_JPRB, 0.37100349E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100282E-03_JPRB, 0.37099633E-03_JPRB, 0.37100134E-03_JPRB /)

RGHG1(:,87, 8) = (/ &
  & 0.37100376E-03_JPRB, 0.37100163E-03_JPRB, 0.37100184E-03_JPRB, 0.37099898E-03_JPRB, 0.37100216E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37099986E-03_JPRB, 0.37100021E-03_JPRB, 0.37099913E-03_JPRB, 0.37099875E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100015E-03_JPRB, 0.37100128E-03_JPRB, 0.37100044E-03_JPRB, 0.37100029E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100146E-03_JPRB, 0.37100355E-03_JPRB, 0.37099782E-03_JPRB, 0.37100149E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37099625E-03_JPRB, 0.37099893E-03_JPRB, 0.37100370E-03_JPRB, 0.37100067E-03_JPRB, 0.37100443E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100288E-03_JPRB, 0.37100175E-03_JPRB, 0.37100163E-03_JPRB, 0.37100274E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100038E-03_JPRB, 0.37100248E-03_JPRB, 0.37100079E-03_JPRB, 0.37100614E-03_JPRB, 0.37100565E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37099820E-03_JPRB, 0.37100047E-03_JPRB, 0.37099869E-03_JPRB, 0.37100032E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37100315E-03_JPRB, 0.37100009E-03_JPRB, 0.37100120E-03_JPRB, 0.37099878E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100285E-03_JPRB, 0.37099898E-03_JPRB, 0.37099945E-03_JPRB, 0.37100454E-03_JPRB, 0.37100361E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100288E-03_JPRB, 0.37099628E-03_JPRB, 0.37100140E-03_JPRB /)

RGHG1(:,88, 8) = (/ &
  & 0.37100370E-03_JPRB, 0.37100172E-03_JPRB, 0.37100178E-03_JPRB, 0.37099893E-03_JPRB, 0.37100213E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37099980E-03_JPRB, 0.37100015E-03_JPRB, 0.37099930E-03_JPRB, 0.37099884E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100003E-03_JPRB, 0.37100108E-03_JPRB, 0.37100044E-03_JPRB, 0.37100032E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100146E-03_JPRB, 0.37100352E-03_JPRB, 0.37099782E-03_JPRB, 0.37100157E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37099607E-03_JPRB, 0.37099878E-03_JPRB, 0.37100393E-03_JPRB, 0.37100047E-03_JPRB, 0.37100463E-03_JPRB, &
  & 0.37100288E-03_JPRB, 0.37100294E-03_JPRB, 0.37100178E-03_JPRB, 0.37100166E-03_JPRB, 0.37100288E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100026E-03_JPRB, 0.37100259E-03_JPRB, 0.37100044E-03_JPRB, 0.37100655E-03_JPRB, 0.37100600E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37099799E-03_JPRB, 0.37100053E-03_JPRB, 0.37099866E-03_JPRB, 0.37100029E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37100306E-03_JPRB, 0.37100021E-03_JPRB, 0.37100120E-03_JPRB, 0.37099881E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100294E-03_JPRB, 0.37099901E-03_JPRB, 0.37099942E-03_JPRB, 0.37100466E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100280E-03_JPRB, 0.37100306E-03_JPRB, 0.37099625E-03_JPRB, 0.37100140E-03_JPRB /)

RGHG1(:,89, 8) = (/ &
  & 0.37100358E-03_JPRB, 0.37100175E-03_JPRB, 0.37100169E-03_JPRB, 0.37099913E-03_JPRB, 0.37100227E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37099991E-03_JPRB, 0.37100035E-03_JPRB, 0.37099910E-03_JPRB, 0.37099863E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100015E-03_JPRB, 0.37100131E-03_JPRB, 0.37100044E-03_JPRB, 0.37100026E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100143E-03_JPRB, 0.37100373E-03_JPRB, 0.37099779E-03_JPRB, 0.37100163E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37099596E-03_JPRB, 0.37099875E-03_JPRB, 0.37100413E-03_JPRB, 0.37100044E-03_JPRB, 0.37100486E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100300E-03_JPRB, 0.37100184E-03_JPRB, 0.37100172E-03_JPRB, 0.37100306E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100015E-03_JPRB, 0.37100271E-03_JPRB, 0.37100009E-03_JPRB, 0.37100690E-03_JPRB, 0.37100638E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37099776E-03_JPRB, 0.37100073E-03_JPRB, 0.37099872E-03_JPRB, 0.37100038E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100300E-03_JPRB, 0.37100015E-03_JPRB, 0.37100117E-03_JPRB, 0.37099878E-03_JPRB, 0.37100344E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100297E-03_JPRB, 0.37099890E-03_JPRB, 0.37099933E-03_JPRB, 0.37100477E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100315E-03_JPRB, 0.37099619E-03_JPRB, 0.37100146E-03_JPRB /)

RGHG1(:,90, 8) = (/ &
  & 0.37100352E-03_JPRB, 0.37100175E-03_JPRB, 0.37100169E-03_JPRB, 0.37099898E-03_JPRB, 0.37100250E-03_JPRB, 0.37100134E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099971E-03_JPRB, 0.37100070E-03_JPRB, 0.37099901E-03_JPRB, 0.37099817E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099997E-03_JPRB, 0.37100178E-03_JPRB, 0.37100035E-03_JPRB, 0.37100003E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100134E-03_JPRB, 0.37100402E-03_JPRB, 0.37099753E-03_JPRB, 0.37100178E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37099567E-03_JPRB, 0.37099869E-03_JPRB, 0.37100445E-03_JPRB, 0.37100021E-03_JPRB, 0.37100524E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100312E-03_JPRB, 0.37100178E-03_JPRB, 0.37100172E-03_JPRB, 0.37100329E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37099997E-03_JPRB, 0.37100294E-03_JPRB, 0.37099968E-03_JPRB, 0.37100728E-03_JPRB, 0.37100672E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37099744E-03_JPRB, 0.37100093E-03_JPRB, 0.37099860E-03_JPRB, 0.37100047E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37100315E-03_JPRB, 0.37100012E-03_JPRB, 0.37100128E-03_JPRB, 0.37099863E-03_JPRB, 0.37100361E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100315E-03_JPRB, 0.37099875E-03_JPRB, 0.37099927E-03_JPRB, 0.37100501E-03_JPRB, 0.37100381E-03_JPRB, &
  & 0.37100280E-03_JPRB, 0.37100323E-03_JPRB, 0.37099601E-03_JPRB, 0.37100146E-03_JPRB /)

RGHG1(:,91, 8) = (/ &
  & 0.37100367E-03_JPRB, 0.37100195E-03_JPRB, 0.37100224E-03_JPRB, 0.37099808E-03_JPRB, 0.37100309E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37099869E-03_JPRB, 0.37100373E-03_JPRB, 0.37099799E-03_JPRB, 0.37099494E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099884E-03_JPRB, 0.37100451E-03_JPRB, 0.37099942E-03_JPRB, 0.37099922E-03_JPRB, 0.37100204E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100096E-03_JPRB, 0.37100469E-03_JPRB, 0.37099680E-03_JPRB, 0.37100221E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37100303E-03_JPRB, 0.37099503E-03_JPRB, 0.37099849E-03_JPRB, 0.37100518E-03_JPRB, 0.37099951E-03_JPRB, 0.37100582E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100332E-03_JPRB, 0.37100169E-03_JPRB, 0.37100157E-03_JPRB, 0.37100367E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100291E-03_JPRB, 0.37099962E-03_JPRB, 0.37100338E-03_JPRB, 0.37099890E-03_JPRB, 0.37100795E-03_JPRB, 0.37100725E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37099665E-03_JPRB, 0.37100154E-03_JPRB, 0.37099826E-03_JPRB, 0.37100061E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100379E-03_JPRB, 0.37099977E-03_JPRB, 0.37100163E-03_JPRB, 0.37099796E-03_JPRB, 0.37100416E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100358E-03_JPRB, 0.37099843E-03_JPRB, 0.37099895E-03_JPRB, 0.37100544E-03_JPRB, 0.37100379E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37100358E-03_JPRB, 0.37099549E-03_JPRB, 0.37100157E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG1(:, 1, 9) = (/ &
  & 0.35868469E-03_JPRB, 0.35868576E-03_JPRB, 0.35869499E-03_JPRB, 0.35871743E-03_JPRB, 0.35875628E-03_JPRB, 0.35881676E-03_JPRB, &
  & 0.35890297E-03_JPRB, 0.35901560E-03_JPRB, 0.35915102E-03_JPRB, 0.35930108E-03_JPRB, 0.35945472E-03_JPRB, 0.35960082E-03_JPRB, &
  & 0.35973251E-03_JPRB, 0.35985169E-03_JPRB, 0.35995757E-03_JPRB, 0.36004689E-03_JPRB, 0.36011444E-03_JPRB, 0.36015423E-03_JPRB, &
  & 0.36016011E-03_JPRB, 0.36012684E-03_JPRB, 0.36005056E-03_JPRB, 0.35993595E-03_JPRB, 0.35978650E-03_JPRB, 0.35958659E-03_JPRB, &
  & 0.35933510E-03_JPRB, 0.35904048E-03_JPRB, 0.35873294E-03_JPRB, 0.35847316E-03_JPRB, 0.35850564E-03_JPRB, 0.35879802E-03_JPRB, &
  & 0.35918021E-03_JPRB, 0.35956549E-03_JPRB, 0.35991124E-03_JPRB, 0.36020193E-03_JPRB, 0.36044666E-03_JPRB, 0.36065586E-03_JPRB, &
  & 0.36084556E-03_JPRB, 0.36102650E-03_JPRB, 0.36119754E-03_JPRB, 0.36134239E-03_JPRB, 0.36143165E-03_JPRB, 0.36146125E-03_JPRB, &
  & 0.36146451E-03_JPRB, 0.36144379E-03_JPRB, 0.36139518E-03_JPRB, 0.36131393E-03_JPRB, 0.36119102E-03_JPRB, 0.36101864E-03_JPRB, &
  & 0.36078936E-03_JPRB, 0.36048985E-03_JPRB, 0.36013409E-03_JPRB, 0.35973726E-03_JPRB, 0.35932616E-03_JPRB, 0.35894272E-03_JPRB, &
  & 0.35858960E-03_JPRB, 0.35827473E-03_JPRB, 0.35798125E-03_JPRB, 0.35769123E-03_JPRB, 0.35740365E-03_JPRB, 0.35712976E-03_JPRB, &
  & 0.35688348E-03_JPRB, 0.35667809E-03_JPRB, 0.35654783E-03_JPRB, 0.35651203E-03_JPRB /)

RGHG1(:, 2, 9) = (/ &
  & 0.35980230E-03_JPRB, 0.35998100E-03_JPRB, 0.36013243E-03_JPRB, 0.36028473E-03_JPRB, 0.36043499E-03_JPRB, 0.36057591E-03_JPRB, &
  & 0.36070379E-03_JPRB, 0.36081875E-03_JPRB, 0.36092906E-03_JPRB, 0.36104949E-03_JPRB, 0.36119350E-03_JPRB, 0.36136468E-03_JPRB, &
  & 0.36155549E-03_JPRB, 0.36175048E-03_JPRB, 0.36193710E-03_JPRB, 0.36210465E-03_JPRB, 0.36224254E-03_JPRB, 0.36234036E-03_JPRB, &
  & 0.36238722E-03_JPRB, 0.36237179E-03_JPRB, 0.36228192E-03_JPRB, 0.36210948E-03_JPRB, 0.36185951E-03_JPRB, 0.36156212E-03_JPRB, &
  & 0.36128220E-03_JPRB, 0.36104314E-03_JPRB, 0.36083994E-03_JPRB, 0.36073406E-03_JPRB, 0.36081913E-03_JPRB, 0.36103299E-03_JPRB, &
  & 0.36128200E-03_JPRB, 0.36153267E-03_JPRB, 0.36180514E-03_JPRB, 0.36210063E-03_JPRB, 0.36240343E-03_JPRB, 0.36269502E-03_JPRB, &
  & 0.36296828E-03_JPRB, 0.36321866E-03_JPRB, 0.36344078E-03_JPRB, 0.36362052E-03_JPRB, 0.36374226E-03_JPRB, 0.36379870E-03_JPRB, &
  & 0.36380778E-03_JPRB, 0.36377565E-03_JPRB, 0.36370166E-03_JPRB, 0.36358176E-03_JPRB, 0.36340390E-03_JPRB, 0.36316158E-03_JPRB, &
  & 0.36284924E-03_JPRB, 0.36246076E-03_JPRB, 0.36201687E-03_JPRB, 0.36153683E-03_JPRB, 0.36104312E-03_JPRB, 0.36056683E-03_JPRB, &
  & 0.36012084E-03_JPRB, 0.35971942E-03_JPRB, 0.35936839E-03_JPRB, 0.35906860E-03_JPRB, 0.35881711E-03_JPRB, 0.35859263E-03_JPRB, &
  & 0.35836332E-03_JPRB, 0.35811999E-03_JPRB, 0.35786864E-03_JPRB, 0.35759446E-03_JPRB /)

RGHG1(:, 3, 9) = (/ &
  & 0.36058039E-03_JPRB, 0.36070618E-03_JPRB, 0.36079943E-03_JPRB, 0.36091078E-03_JPRB, 0.36104801E-03_JPRB, 0.36122103E-03_JPRB, &
  & 0.36143415E-03_JPRB, 0.36168599E-03_JPRB, 0.36196181E-03_JPRB, 0.36224161E-03_JPRB, 0.36251097E-03_JPRB, 0.36276557E-03_JPRB, &
  & 0.36300553E-03_JPRB, 0.36322925E-03_JPRB, 0.36343146E-03_JPRB, 0.36360542E-03_JPRB, 0.36374730E-03_JPRB, 0.36385379E-03_JPRB, &
  & 0.36392076E-03_JPRB, 0.36394162E-03_JPRB, 0.36390804E-03_JPRB, 0.36381133E-03_JPRB, 0.36364488E-03_JPRB, 0.36340312E-03_JPRB, &
  & 0.36308629E-03_JPRB, 0.36274284E-03_JPRB, 0.36246431E-03_JPRB, 0.36233763E-03_JPRB, 0.36240288E-03_JPRB, 0.36264153E-03_JPRB, &
  & 0.36299363E-03_JPRB, 0.36338740E-03_JPRB, 0.36375006E-03_JPRB, 0.36404983E-03_JPRB, 0.36428397E-03_JPRB, 0.36447091E-03_JPRB, &
  & 0.36462463E-03_JPRB, 0.36475318E-03_JPRB, 0.36486011E-03_JPRB, 0.36494562E-03_JPRB, 0.36500063E-03_JPRB, 0.36502257E-03_JPRB, &
  & 0.36501355E-03_JPRB, 0.36497563E-03_JPRB, 0.36490939E-03_JPRB, 0.36481232E-03_JPRB, 0.36467885E-03_JPRB, 0.36450219E-03_JPRB, &
  & 0.36427850E-03_JPRB, 0.36400888E-03_JPRB, 0.36369573E-03_JPRB, 0.36334645E-03_JPRB, 0.36297613E-03_JPRB, 0.36258899E-03_JPRB, &
  & 0.36218204E-03_JPRB, 0.36175299E-03_JPRB, 0.36128977E-03_JPRB, 0.36077824E-03_JPRB, 0.36022160E-03_JPRB, 0.35965510E-03_JPRB, &
  & 0.35915370E-03_JPRB, 0.35876755E-03_JPRB, 0.35850576E-03_JPRB, 0.35825715E-03_JPRB /)

RGHG1(:, 4, 9) = (/ &
  & 0.36097760E-03_JPRB, 0.36118258E-03_JPRB, 0.36137630E-03_JPRB, 0.36159839E-03_JPRB, 0.36186085E-03_JPRB, 0.36214184E-03_JPRB, &
  & 0.36242473E-03_JPRB, 0.36269616E-03_JPRB, 0.36295928E-03_JPRB, 0.36322098E-03_JPRB, 0.36348071E-03_JPRB, 0.36372949E-03_JPRB, &
  & 0.36395679E-03_JPRB, 0.36415609E-03_JPRB, 0.36432827E-03_JPRB, 0.36447594E-03_JPRB, 0.36459943E-03_JPRB, 0.36469911E-03_JPRB, &
  & 0.36477490E-03_JPRB, 0.36482554E-03_JPRB, 0.36484830E-03_JPRB, 0.36483916E-03_JPRB, 0.36479410E-03_JPRB, 0.36471142E-03_JPRB, &
  & 0.36460304E-03_JPRB, 0.36449300E-03_JPRB, 0.36441034E-03_JPRB, 0.36438424E-03_JPRB, 0.36442891E-03_JPRB, 0.36453505E-03_JPRB, &
  & 0.36468336E-03_JPRB, 0.36484975E-03_JPRB, 0.36501302E-03_JPRB, 0.36515418E-03_JPRB, 0.36526870E-03_JPRB, 0.36535785E-03_JPRB, &
  & 0.36542743E-03_JPRB, 0.36548267E-03_JPRB, 0.36552764E-03_JPRB, 0.36556093E-03_JPRB, 0.36557968E-03_JPRB, 0.36557906E-03_JPRB, &
  & 0.36555773E-03_JPRB, 0.36551629E-03_JPRB, 0.36545546E-03_JPRB, 0.36537653E-03_JPRB, 0.36527994E-03_JPRB, 0.36516489E-03_JPRB, &
  & 0.36502973E-03_JPRB, 0.36487204E-03_JPRB, 0.36469204E-03_JPRB, 0.36448881E-03_JPRB, 0.36425464E-03_JPRB, 0.36398353E-03_JPRB, &
  & 0.36366525E-03_JPRB, 0.36328469E-03_JPRB, 0.36283131E-03_JPRB, 0.36231155E-03_JPRB, 0.36175636E-03_JPRB, 0.36120659E-03_JPRB, &
  & 0.36067859E-03_JPRB, 0.36016962E-03_JPRB, 0.35965155E-03_JPRB, 0.35903789E-03_JPRB /)

RGHG1(:, 5, 9) = (/ &
  & 0.36125368E-03_JPRB, 0.36157126E-03_JPRB, 0.36183186E-03_JPRB, 0.36212735E-03_JPRB, 0.36244601E-03_JPRB, 0.36277436E-03_JPRB, &
  & 0.36309587E-03_JPRB, 0.36340542E-03_JPRB, 0.36369317E-03_JPRB, 0.36395388E-03_JPRB, 0.36418656E-03_JPRB, 0.36439238E-03_JPRB, &
  & 0.36457388E-03_JPRB, 0.36473243E-03_JPRB, 0.36486695E-03_JPRB, 0.36498002E-03_JPRB, 0.36507609E-03_JPRB, 0.36515808E-03_JPRB, &
  & 0.36522778E-03_JPRB, 0.36528608E-03_JPRB, 0.36533311E-03_JPRB, 0.36536824E-03_JPRB, 0.36539033E-03_JPRB, 0.36539859E-03_JPRB, &
  & 0.36539524E-03_JPRB, 0.36538695E-03_JPRB, 0.36538270E-03_JPRB, 0.36539079E-03_JPRB, 0.36541483E-03_JPRB, 0.36545342E-03_JPRB, &
  & 0.36550287E-03_JPRB, 0.36555968E-03_JPRB, 0.36562118E-03_JPRB, 0.36568390E-03_JPRB, 0.36574304E-03_JPRB, 0.36579589E-03_JPRB, &
  & 0.36584141E-03_JPRB, 0.36588078E-03_JPRB, 0.36591373E-03_JPRB, 0.36593821E-03_JPRB, 0.36595034E-03_JPRB, 0.36594560E-03_JPRB, &
  & 0.36592197E-03_JPRB, 0.36587991E-03_JPRB, 0.36582205E-03_JPRB, 0.36575142E-03_JPRB, 0.36567065E-03_JPRB, 0.36558069E-03_JPRB, &
  & 0.36548130E-03_JPRB, 0.36537056E-03_JPRB, 0.36524492E-03_JPRB, 0.36510176E-03_JPRB, 0.36493741E-03_JPRB, 0.36474245E-03_JPRB, &
  & 0.36450874E-03_JPRB, 0.36422742E-03_JPRB, 0.36389387E-03_JPRB, 0.36350841E-03_JPRB, 0.36307317E-03_JPRB, 0.36258320E-03_JPRB, &
  & 0.36205052E-03_JPRB, 0.36151023E-03_JPRB, 0.36095831E-03_JPRB, 0.36008732E-03_JPRB /)

RGHG1(:, 6, 9) = (/ &
  & 0.36148826E-03_JPRB, 0.36191038E-03_JPRB, 0.36224801E-03_JPRB, 0.36260331E-03_JPRB, 0.36296662E-03_JPRB, 0.36332020E-03_JPRB, &
  & 0.36364608E-03_JPRB, 0.36393452E-03_JPRB, 0.36418985E-03_JPRB, 0.36441899E-03_JPRB, 0.36462533E-03_JPRB, 0.36480825E-03_JPRB, &
  & 0.36496544E-03_JPRB, 0.36509763E-03_JPRB, 0.36520942E-03_JPRB, 0.36530412E-03_JPRB, 0.36538532E-03_JPRB, 0.36545645E-03_JPRB, &
  & 0.36551993E-03_JPRB, 0.36557752E-03_JPRB, 0.36563014E-03_JPRB, 0.36567810E-03_JPRB, 0.36572095E-03_JPRB, 0.36575744E-03_JPRB, &
  & 0.36578681E-03_JPRB, 0.36580968E-03_JPRB, 0.36582854E-03_JPRB, 0.36584630E-03_JPRB, 0.36586565E-03_JPRB, 0.36588815E-03_JPRB, &
  & 0.36591478E-03_JPRB, 0.36594659E-03_JPRB, 0.36598384E-03_JPRB, 0.36602624E-03_JPRB, 0.36607243E-03_JPRB, 0.36612040E-03_JPRB, &
  & 0.36616783E-03_JPRB, 0.36621219E-03_JPRB, 0.36625058E-03_JPRB, 0.36627933E-03_JPRB, 0.36629423E-03_JPRB, 0.36629103E-03_JPRB, &
  & 0.36626804E-03_JPRB, 0.36622686E-03_JPRB, 0.36617095E-03_JPRB, 0.36610366E-03_JPRB, 0.36602738E-03_JPRB, 0.36594280E-03_JPRB, &
  & 0.36584909E-03_JPRB, 0.36574452E-03_JPRB, 0.36562665E-03_JPRB, 0.36549181E-03_JPRB, 0.36533803E-03_JPRB, 0.36516378E-03_JPRB, &
  & 0.36496451E-03_JPRB, 0.36473884E-03_JPRB, 0.36448435E-03_JPRB, 0.36419628E-03_JPRB, 0.36386683E-03_JPRB, 0.36350597E-03_JPRB, &
  & 0.36312966E-03_JPRB, 0.36272849E-03_JPRB, 0.36222808E-03_JPRB, 0.36132513E-03_JPRB /)

RGHG1(:, 7, 9) = (/ &
  & 0.36181801E-03_JPRB, 0.36232884E-03_JPRB, 0.36270602E-03_JPRB, 0.36305230E-03_JPRB, 0.36339732E-03_JPRB, 0.36372442E-03_JPRB, &
  & 0.36402419E-03_JPRB, 0.36429265E-03_JPRB, 0.36453156E-03_JPRB, 0.36474306E-03_JPRB, 0.36492973E-03_JPRB, 0.36509283E-03_JPRB, &
  & 0.36523421E-03_JPRB, 0.36535453E-03_JPRB, 0.36545543E-03_JPRB, 0.36554085E-03_JPRB, 0.36561480E-03_JPRB, 0.36568084E-03_JPRB, &
  & 0.36574178E-03_JPRB, 0.36579973E-03_JPRB, 0.36585654E-03_JPRB, 0.36591344E-03_JPRB, 0.36597086E-03_JPRB, 0.36602779E-03_JPRB, &
  & 0.36608102E-03_JPRB, 0.36612718E-03_JPRB, 0.36616490E-03_JPRB, 0.36619548E-03_JPRB, 0.36622115E-03_JPRB, 0.36624406E-03_JPRB, &
  & 0.36626650E-03_JPRB, 0.36629033E-03_JPRB, 0.36631859E-03_JPRB, 0.36635381E-03_JPRB, 0.36639685E-03_JPRB, 0.36644645E-03_JPRB, &
  & 0.36649956E-03_JPRB, 0.36655189E-03_JPRB, 0.36659805E-03_JPRB, 0.36663318E-03_JPRB, 0.36665244E-03_JPRB, 0.36665198E-03_JPRB, &
  & 0.36663015E-03_JPRB, 0.36658894E-03_JPRB, 0.36653169E-03_JPRB, 0.36646237E-03_JPRB, 0.36638297E-03_JPRB, 0.36629368E-03_JPRB, &
  & 0.36619324E-03_JPRB, 0.36607988E-03_JPRB, 0.36595165E-03_JPRB, 0.36580634E-03_JPRB, 0.36564207E-03_JPRB, 0.36545881E-03_JPRB, &
  & 0.36525936E-03_JPRB, 0.36504501E-03_JPRB, 0.36481774E-03_JPRB, 0.36457623E-03_JPRB, 0.36432664E-03_JPRB, 0.36407536E-03_JPRB, &
  & 0.36382038E-03_JPRB, 0.36354503E-03_JPRB, 0.36321447E-03_JPRB, 0.36253541E-03_JPRB /)

RGHG1(:, 8, 9) = (/ &
  & 0.36227430E-03_JPRB, 0.36281251E-03_JPRB, 0.36314264E-03_JPRB, 0.36344677E-03_JPRB, 0.36374203E-03_JPRB, 0.36403167E-03_JPRB, &
  & 0.36430420E-03_JPRB, 0.36455347E-03_JPRB, 0.36477658E-03_JPRB, 0.36497624E-03_JPRB, 0.36515374E-03_JPRB, 0.36530959E-03_JPRB, &
  & 0.36544318E-03_JPRB, 0.36555575E-03_JPRB, 0.36565034E-03_JPRB, 0.36573072E-03_JPRB, 0.36580081E-03_JPRB, 0.36586431E-03_JPRB, &
  & 0.36592429E-03_JPRB, 0.36598364E-03_JPRB, 0.36604470E-03_JPRB, 0.36610986E-03_JPRB, 0.36618090E-03_JPRB, 0.36625742E-03_JPRB, &
  & 0.36633550E-03_JPRB, 0.36640881E-03_JPRB, 0.36647348E-03_JPRB, 0.36652735E-03_JPRB, 0.36657081E-03_JPRB, 0.36660529E-03_JPRB, &
  & 0.36663320E-03_JPRB, 0.36665844E-03_JPRB, 0.36668571E-03_JPRB, 0.36671959E-03_JPRB, 0.36676219E-03_JPRB, 0.36681307E-03_JPRB, &
  & 0.36686877E-03_JPRB, 0.36692477E-03_JPRB, 0.36697512E-03_JPRB, 0.36701406E-03_JPRB, 0.36703591E-03_JPRB, 0.36703670E-03_JPRB, &
  & 0.36701435E-03_JPRB, 0.36697014E-03_JPRB, 0.36690760E-03_JPRB, 0.36683006E-03_JPRB, 0.36674010E-03_JPRB, 0.36663830E-03_JPRB, &
  & 0.36652351E-03_JPRB, 0.36639423E-03_JPRB, 0.36624889E-03_JPRB, 0.36608649E-03_JPRB, 0.36590721E-03_JPRB, 0.36571283E-03_JPRB, &
  & 0.36550607E-03_JPRB, 0.36529198E-03_JPRB, 0.36507283E-03_JPRB, 0.36485537E-03_JPRB, 0.36464568E-03_JPRB, 0.36444620E-03_JPRB, &
  & 0.36425836E-03_JPRB, 0.36407687E-03_JPRB, 0.36386715E-03_JPRB, 0.36346071E-03_JPRB /)

RGHG1(:, 9, 9) = (/ &
  & 0.36280850E-03_JPRB, 0.36327439E-03_JPRB, 0.36354311E-03_JPRB, 0.36378822E-03_JPRB, 0.36403121E-03_JPRB, 0.36427952E-03_JPRB, &
  & 0.36452376E-03_JPRB, 0.36475487E-03_JPRB, 0.36496765E-03_JPRB, 0.36515950E-03_JPRB, 0.36533052E-03_JPRB, 0.36548020E-03_JPRB, &
  & 0.36560901E-03_JPRB, 0.36571804E-03_JPRB, 0.36580965E-03_JPRB, 0.36588759E-03_JPRB, 0.36595605E-03_JPRB, 0.36601879E-03_JPRB, &
  & 0.36607921E-03_JPRB, 0.36614042E-03_JPRB, 0.36620584E-03_JPRB, 0.36627933E-03_JPRB, 0.36636461E-03_JPRB, 0.36646295E-03_JPRB, &
  & 0.36657017E-03_JPRB, 0.36667797E-03_JPRB, 0.36677727E-03_JPRB, 0.36686318E-03_JPRB, 0.36693475E-03_JPRB, 0.36699369E-03_JPRB, &
  & 0.36704232E-03_JPRB, 0.36708402E-03_JPRB, 0.36712363E-03_JPRB, 0.36716487E-03_JPRB, 0.36721054E-03_JPRB, 0.36726121E-03_JPRB, &
  & 0.36731450E-03_JPRB, 0.36736618E-03_JPRB, 0.36741080E-03_JPRB, 0.36744308E-03_JPRB, 0.36745824E-03_JPRB, 0.36745216E-03_JPRB, &
  & 0.36742265E-03_JPRB, 0.36736965E-03_JPRB, 0.36729543E-03_JPRB, 0.36720303E-03_JPRB, 0.36709598E-03_JPRB, 0.36697529E-03_JPRB, &
  & 0.36684136E-03_JPRB, 0.36669365E-03_JPRB, 0.36653198E-03_JPRB, 0.36635686E-03_JPRB, 0.36616999E-03_JPRB, 0.36597360E-03_JPRB, &
  & 0.36577089E-03_JPRB, 0.36556419E-03_JPRB, 0.36535895E-03_JPRB, 0.36516041E-03_JPRB, 0.36497382E-03_JPRB, 0.36480333E-03_JPRB, &
  & 0.36465007E-03_JPRB, 0.36450929E-03_JPRB, 0.36435446E-03_JPRB, 0.36409969E-03_JPRB /)

RGHG1(:,10, 9) = (/ &
  & 0.36333513E-03_JPRB, 0.36368752E-03_JPRB, 0.36390501E-03_JPRB, 0.36409084E-03_JPRB, 0.36429099E-03_JPRB, 0.36449847E-03_JPRB, &
  & 0.36471404E-03_JPRB, 0.36492603E-03_JPRB, 0.36512595E-03_JPRB, 0.36530948E-03_JPRB, 0.36547438E-03_JPRB, 0.36561963E-03_JPRB, &
  & 0.36574490E-03_JPRB, 0.36585110E-03_JPRB, 0.36594065E-03_JPRB, 0.36601734E-03_JPRB, 0.36608503E-03_JPRB, 0.36614743E-03_JPRB, &
  & 0.36620809E-03_JPRB, 0.36627054E-03_JPRB, 0.36633882E-03_JPRB, 0.36641752E-03_JPRB, 0.36651138E-03_JPRB, 0.36662340E-03_JPRB, &
  & 0.36675064E-03_JPRB, 0.36688472E-03_JPRB, 0.36701866E-03_JPRB, 0.36714890E-03_JPRB, 0.36727253E-03_JPRB, 0.36738638E-03_JPRB, &
  & 0.36748787E-03_JPRB, 0.36757573E-03_JPRB, 0.36765003E-03_JPRB, 0.36771316E-03_JPRB, 0.36776823E-03_JPRB, 0.36781729E-03_JPRB, &
  & 0.36785976E-03_JPRB, 0.36789372E-03_JPRB, 0.36791639E-03_JPRB, 0.36792451E-03_JPRB, 0.36791601E-03_JPRB, 0.36788810E-03_JPRB, &
  & 0.36783924E-03_JPRB, 0.36776846E-03_JPRB, 0.36767637E-03_JPRB, 0.36756552E-03_JPRB, 0.36743828E-03_JPRB, 0.36729730E-03_JPRB, &
  & 0.36714389E-03_JPRB, 0.36697867E-03_JPRB, 0.36680343E-03_JPRB, 0.36662011E-03_JPRB, 0.36643125E-03_JPRB, 0.36624164E-03_JPRB, &
  & 0.36605526E-03_JPRB, 0.36587729E-03_JPRB, 0.36571035E-03_JPRB, 0.36555511E-03_JPRB, 0.36541081E-03_JPRB, 0.36527702E-03_JPRB, &
  & 0.36515290E-03_JPRB, 0.36502792E-03_JPRB, 0.36489876E-03_JPRB, 0.36466104E-03_JPRB /)

RGHG1(:,11, 9) = (/ &
  & 0.36378455E-03_JPRB, 0.36406983E-03_JPRB, 0.36422635E-03_JPRB, 0.36438450E-03_JPRB, 0.36454090E-03_JPRB, 0.36471843E-03_JPRB, &
  & 0.36490496E-03_JPRB, 0.36509533E-03_JPRB, 0.36528011E-03_JPRB, 0.36545299E-03_JPRB, 0.36561018E-03_JPRB, 0.36574979E-03_JPRB, &
  & 0.36587109E-03_JPRB, 0.36597493E-03_JPRB, 0.36606335E-03_JPRB, 0.36613957E-03_JPRB, 0.36620721E-03_JPRB, 0.36627005E-03_JPRB, &
  & 0.36633169E-03_JPRB, 0.36639575E-03_JPRB, 0.36646650E-03_JPRB, 0.36654933E-03_JPRB, 0.36665003E-03_JPRB, 0.36677357E-03_JPRB, &
  & 0.36691918E-03_JPRB, 0.36708103E-03_JPRB, 0.36725122E-03_JPRB, 0.36742148E-03_JPRB, 0.36758781E-03_JPRB, 0.36774823E-03_JPRB, &
  & 0.36789765E-03_JPRB, 0.36802946E-03_JPRB, 0.36813991E-03_JPRB, 0.36822830E-03_JPRB, 0.36829634E-03_JPRB, 0.36834602E-03_JPRB, &
  & 0.36837789E-03_JPRB, 0.36839291E-03_JPRB, 0.36839076E-03_JPRB, 0.36837190E-03_JPRB, 0.36833645E-03_JPRB, 0.36828383E-03_JPRB, &
  & 0.36821334E-03_JPRB, 0.36812414E-03_JPRB, 0.36801590E-03_JPRB, 0.36788965E-03_JPRB, 0.36774829E-03_JPRB, 0.36759433E-03_JPRB, &
  & 0.36742989E-03_JPRB, 0.36725725E-03_JPRB, 0.36707835E-03_JPRB, 0.36689528E-03_JPRB, 0.36671164E-03_JPRB, 0.36653178E-03_JPRB, &
  & 0.36636059E-03_JPRB, 0.36620200E-03_JPRB, 0.36605872E-03_JPRB, 0.36593099E-03_JPRB, 0.36581940E-03_JPRB, 0.36572161E-03_JPRB, &
  & 0.36563375E-03_JPRB, 0.36555552E-03_JPRB, 0.36545852E-03_JPRB, 0.36528692E-03_JPRB /)

RGHG1(:,12, 9) = (/ &
  & 0.36417862E-03_JPRB, 0.36440411E-03_JPRB, 0.36454707E-03_JPRB, 0.36466878E-03_JPRB, 0.36480697E-03_JPRB, 0.36495365E-03_JPRB, &
  & 0.36511503E-03_JPRB, 0.36528177E-03_JPRB, 0.36544702E-03_JPRB, 0.36560459E-03_JPRB, 0.36575063E-03_JPRB, 0.36588236E-03_JPRB, &
  & 0.36599889E-03_JPRB, 0.36610031E-03_JPRB, 0.36618832E-03_JPRB, 0.36626507E-03_JPRB, 0.36633431E-03_JPRB, 0.36639938E-03_JPRB, &
  & 0.36646385E-03_JPRB, 0.36653128E-03_JPRB, 0.36660541E-03_JPRB, 0.36669101E-03_JPRB, 0.36679336E-03_JPRB, 0.36691691E-03_JPRB, &
  & 0.36706281E-03_JPRB, 0.36722812E-03_JPRB, 0.36740804E-03_JPRB, 0.36759902E-03_JPRB, 0.36779547E-03_JPRB, 0.36798982E-03_JPRB, &
  & 0.36817294E-03_JPRB, 0.36833613E-03_JPRB, 0.36847327E-03_JPRB, 0.36858171E-03_JPRB, 0.36866200E-03_JPRB, 0.36871602E-03_JPRB, &
  & 0.36874507E-03_JPRB, 0.36875185E-03_JPRB, 0.36873773E-03_JPRB, 0.36870473E-03_JPRB, 0.36865450E-03_JPRB, 0.36858788E-03_JPRB, &
  & 0.36850499E-03_JPRB, 0.36840574E-03_JPRB, 0.36828985E-03_JPRB, 0.36815918E-03_JPRB, 0.36801558E-03_JPRB, 0.36786226E-03_JPRB, &
  & 0.36770225E-03_JPRB, 0.36753851E-03_JPRB, 0.36737366E-03_JPRB, 0.36720955E-03_JPRB, 0.36704895E-03_JPRB, 0.36689514E-03_JPRB, &
  & 0.36675102E-03_JPRB, 0.36661889E-03_JPRB, 0.36649994E-03_JPRB, 0.36639321E-03_JPRB, 0.36629857E-03_JPRB, 0.36621350E-03_JPRB, &
  & 0.36613821E-03_JPRB, 0.36606329E-03_JPRB, 0.36598873E-03_JPRB, 0.36585852E-03_JPRB /)

RGHG1(:,13, 9) = (/ &
  & 0.36450793E-03_JPRB, 0.36470575E-03_JPRB, 0.36482044E-03_JPRB, 0.36492987E-03_JPRB, 0.36504009E-03_JPRB, 0.36516471E-03_JPRB, &
  & 0.36529996E-03_JPRB, 0.36544423E-03_JPRB, 0.36559251E-03_JPRB, 0.36574071E-03_JPRB, 0.36588553E-03_JPRB, 0.36602479E-03_JPRB, &
  & 0.36615680E-03_JPRB, 0.36627983E-03_JPRB, 0.36639359E-03_JPRB, 0.36649709E-03_JPRB, 0.36659001E-03_JPRB, 0.36667465E-03_JPRB, &
  & 0.36675282E-03_JPRB, 0.36682721E-03_JPRB, 0.36690186E-03_JPRB, 0.36698120E-03_JPRB, 0.36707020E-03_JPRB, 0.36717471E-03_JPRB, &
  & 0.36729834E-03_JPRB, 0.36744284E-03_JPRB, 0.36760699E-03_JPRB, 0.36778898E-03_JPRB, 0.36798319E-03_JPRB, 0.36818191E-03_JPRB, &
  & 0.36837504E-03_JPRB, 0.36855074E-03_JPRB, 0.36870013E-03_JPRB, 0.36881928E-03_JPRB, 0.36890752E-03_JPRB, 0.36896564E-03_JPRB, &
  & 0.36899571E-03_JPRB, 0.36900019E-03_JPRB, 0.36898156E-03_JPRB, 0.36894283E-03_JPRB, 0.36888619E-03_JPRB, 0.36881361E-03_JPRB, &
  & 0.36872647E-03_JPRB, 0.36862525E-03_JPRB, 0.36851084E-03_JPRB, 0.36838430E-03_JPRB, 0.36824879E-03_JPRB, 0.36810798E-03_JPRB, &
  & 0.36796508E-03_JPRB, 0.36782373E-03_JPRB, 0.36768592E-03_JPRB, 0.36755321E-03_JPRB, 0.36742724E-03_JPRB, 0.36730978E-03_JPRB, &
  & 0.36720251E-03_JPRB, 0.36710568E-03_JPRB, 0.36701880E-03_JPRB, 0.36694072E-03_JPRB, 0.36687046E-03_JPRB, 0.36680617E-03_JPRB, &
  & 0.36674563E-03_JPRB, 0.36668713E-03_JPRB, 0.36661548E-03_JPRB, 0.36648996E-03_JPRB /)

RGHG1(:,14, 9) = (/ &
  & 0.36475604E-03_JPRB, 0.36491809E-03_JPRB, 0.36500982E-03_JPRB, 0.36509868E-03_JPRB, 0.36519612E-03_JPRB, 0.36530834E-03_JPRB, &
  & 0.36543849E-03_JPRB, 0.36558724E-03_JPRB, 0.36575331E-03_JPRB, 0.36593393E-03_JPRB, 0.36612514E-03_JPRB, 0.36631935E-03_JPRB, &
  & 0.36650759E-03_JPRB, 0.36668059E-03_JPRB, 0.36683309E-03_JPRB, 0.36696409E-03_JPRB, 0.36707614E-03_JPRB, 0.36717186E-03_JPRB, &
  & 0.36725469E-03_JPRB, 0.36732783E-03_JPRB, 0.36739447E-03_JPRB, 0.36745821E-03_JPRB, 0.36752297E-03_JPRB, 0.36759407E-03_JPRB, &
  & 0.36767719E-03_JPRB, 0.36777783E-03_JPRB, 0.36790108E-03_JPRB, 0.36804681E-03_JPRB, 0.36821299E-03_JPRB, 0.36839256E-03_JPRB, &
  & 0.36857231E-03_JPRB, 0.36874114E-03_JPRB, 0.36888896E-03_JPRB, 0.36901000E-03_JPRB, 0.36910098E-03_JPRB, 0.36916131E-03_JPRB, &
  & 0.36919245E-03_JPRB, 0.36919673E-03_JPRB, 0.36917723E-03_JPRB, 0.36913712E-03_JPRB, 0.36907924E-03_JPRB, 0.36900595E-03_JPRB, &
  & 0.36891928E-03_JPRB, 0.36882056E-03_JPRB, 0.36871157E-03_JPRB, 0.36859457E-03_JPRB, 0.36847292E-03_JPRB, 0.36835051E-03_JPRB, &
  & 0.36823095E-03_JPRB, 0.36811683E-03_JPRB, 0.36800932E-03_JPRB, 0.36790909E-03_JPRB, 0.36781628E-03_JPRB, 0.36773155E-03_JPRB, &
  & 0.36765510E-03_JPRB, 0.36758656E-03_JPRB, 0.36752509E-03_JPRB, 0.36746985E-03_JPRB, 0.36741956E-03_JPRB, 0.36737422E-03_JPRB, &
  & 0.36733021E-03_JPRB, 0.36728848E-03_JPRB, 0.36723650E-03_JPRB, 0.36714543E-03_JPRB /)

RGHG1(:,15, 9) = (/ &
  & 0.36491948E-03_JPRB, 0.36504760E-03_JPRB, 0.36514233E-03_JPRB, 0.36523613E-03_JPRB, 0.36535069E-03_JPRB, 0.36548916E-03_JPRB, &
  & 0.36565764E-03_JPRB, 0.36585567E-03_JPRB, 0.36607846E-03_JPRB, 0.36631641E-03_JPRB, 0.36655809E-03_JPRB, 0.36679176E-03_JPRB, &
  & 0.36700841E-03_JPRB, 0.36720093E-03_JPRB, 0.36736613E-03_JPRB, 0.36750446E-03_JPRB, 0.36761948E-03_JPRB, 0.36771520E-03_JPRB, &
  & 0.36779518E-03_JPRB, 0.36786319E-03_JPRB, 0.36792224E-03_JPRB, 0.36797504E-03_JPRB, 0.36802446E-03_JPRB, 0.36807434E-03_JPRB, &
  & 0.36812975E-03_JPRB, 0.36819634E-03_JPRB, 0.36827978E-03_JPRB, 0.36838552E-03_JPRB, 0.36851253E-03_JPRB, 0.36865618E-03_JPRB, &
  & 0.36880776E-03_JPRB, 0.36895508E-03_JPRB, 0.36908846E-03_JPRB, 0.36920040E-03_JPRB, 0.36928634E-03_JPRB, 0.36934443E-03_JPRB, &
  & 0.36937511E-03_JPRB, 0.36938014E-03_JPRB, 0.36936268E-03_JPRB, 0.36932569E-03_JPRB, 0.36927167E-03_JPRB, 0.36920290E-03_JPRB, &
  & 0.36912158E-03_JPRB, 0.36902956E-03_JPRB, 0.36892935E-03_JPRB, 0.36882432E-03_JPRB, 0.36871852E-03_JPRB, 0.36861582E-03_JPRB, &
  & 0.36851910E-03_JPRB, 0.36842999E-03_JPRB, 0.36834861E-03_JPRB, 0.36827425E-03_JPRB, 0.36820598E-03_JPRB, 0.36814337E-03_JPRB, &
  & 0.36808618E-03_JPRB, 0.36803441E-03_JPRB, 0.36798746E-03_JPRB, 0.36794500E-03_JPRB, 0.36790647E-03_JPRB, 0.36787175E-03_JPRB, &
  & 0.36783834E-03_JPRB, 0.36780664E-03_JPRB, 0.36776686E-03_JPRB, 0.36769753E-03_JPRB /)

RGHG1(:,16, 9) = (/ &
  & 0.36509815E-03_JPRB, 0.36530226E-03_JPRB, 0.36544615E-03_JPRB, 0.36559883E-03_JPRB, 0.36575983E-03_JPRB, 0.36594173E-03_JPRB, &
  & 0.36614371E-03_JPRB, 0.36636484E-03_JPRB, 0.36660020E-03_JPRB, 0.36684368E-03_JPRB, 0.36708708E-03_JPRB, 0.36732119E-03_JPRB, &
  & 0.36753720E-03_JPRB, 0.36772829E-03_JPRB, 0.36789218E-03_JPRB, 0.36802975E-03_JPRB, 0.36814384E-03_JPRB, 0.36823933E-03_JPRB, &
  & 0.36831966E-03_JPRB, 0.36838808E-03_JPRB, 0.36844745E-03_JPRB, 0.36849984E-03_JPRB, 0.36854696E-03_JPRB, 0.36859058E-03_JPRB, &
  & 0.36863418E-03_JPRB, 0.36868226E-03_JPRB, 0.36873922E-03_JPRB, 0.36880973E-03_JPRB, 0.36889696E-03_JPRB, 0.36899891E-03_JPRB, &
  & 0.36910956E-03_JPRB, 0.36922147E-03_JPRB, 0.36932580E-03_JPRB, 0.36941498E-03_JPRB, 0.36948430E-03_JPRB, 0.36953163E-03_JPRB, &
  & 0.36955709E-03_JPRB, 0.36956207E-03_JPRB, 0.36954923E-03_JPRB, 0.36952025E-03_JPRB, 0.36947647E-03_JPRB, 0.36941940E-03_JPRB, &
  & 0.36935019E-03_JPRB, 0.36927045E-03_JPRB, 0.36918325E-03_JPRB, 0.36909248E-03_JPRB, 0.36900287E-03_JPRB, 0.36891867E-03_JPRB, &
  & 0.36884143E-03_JPRB, 0.36877158E-03_JPRB, 0.36870796E-03_JPRB, 0.36864920E-03_JPRB, 0.36859410E-03_JPRB, 0.36854218E-03_JPRB, &
  & 0.36849338E-03_JPRB, 0.36844806E-03_JPRB, 0.36840644E-03_JPRB, 0.36836846E-03_JPRB, 0.36833429E-03_JPRB, 0.36830376E-03_JPRB, &
  & 0.36827513E-03_JPRB, 0.36824826E-03_JPRB, 0.36821366E-03_JPRB, 0.36815752E-03_JPRB /)

RGHG1(:,17, 9) = (/ &
  & 0.36552871E-03_JPRB, 0.36589830E-03_JPRB, 0.36610098E-03_JPRB, 0.36626184E-03_JPRB, 0.36641888E-03_JPRB, 0.36658117E-03_JPRB, &
  & 0.36675864E-03_JPRB, 0.36695274E-03_JPRB, 0.36716176E-03_JPRB, 0.36738065E-03_JPRB, 0.36760294E-03_JPRB, 0.36782020E-03_JPRB, &
  & 0.36802446E-03_JPRB, 0.36820918E-03_JPRB, 0.36837021E-03_JPRB, 0.36850767E-03_JPRB, 0.36862388E-03_JPRB, 0.36872251E-03_JPRB, &
  & 0.36880752E-03_JPRB, 0.36888197E-03_JPRB, 0.36894850E-03_JPRB, 0.36900904E-03_JPRB, 0.36906384E-03_JPRB, 0.36911311E-03_JPRB, &
  & 0.36915747E-03_JPRB, 0.36919952E-03_JPRB, 0.36924335E-03_JPRB, 0.36929076E-03_JPRB, 0.36934318E-03_JPRB, 0.36940293E-03_JPRB, &
  & 0.36946783E-03_JPRB, 0.36953413E-03_JPRB, 0.36959618E-03_JPRB, 0.36964944E-03_JPRB, 0.36969094E-03_JPRB, 0.36971935E-03_JPRB, &
  & 0.36973532E-03_JPRB, 0.36973908E-03_JPRB, 0.36973169E-03_JPRB, 0.36971338E-03_JPRB, 0.36968425E-03_JPRB, 0.36964376E-03_JPRB, &
  & 0.36959208E-03_JPRB, 0.36953003E-03_JPRB, 0.36946029E-03_JPRB, 0.36938649E-03_JPRB, 0.36931317E-03_JPRB, 0.36924405E-03_JPRB, &
  & 0.36918090E-03_JPRB, 0.36912312E-03_JPRB, 0.36906905E-03_JPRB, 0.36901713E-03_JPRB, 0.36896623E-03_JPRB, 0.36891617E-03_JPRB, &
  & 0.36886791E-03_JPRB, 0.36882213E-03_JPRB, 0.36877999E-03_JPRB, 0.36874189E-03_JPRB, 0.36870793E-03_JPRB, 0.36867781E-03_JPRB, &
  & 0.36865065E-03_JPRB, 0.36862408E-03_JPRB, 0.36859492E-03_JPRB, 0.36854108E-03_JPRB /)

RGHG1(:,18, 9) = (/ &
  & 0.36629173E-03_JPRB, 0.36668603E-03_JPRB, 0.36686799E-03_JPRB, 0.36699430E-03_JPRB, 0.36710998E-03_JPRB, 0.36722713E-03_JPRB, &
  & 0.36735862E-03_JPRB, 0.36750821E-03_JPRB, 0.36767617E-03_JPRB, 0.36786028E-03_JPRB, 0.36805487E-03_JPRB, 0.36825193E-03_JPRB, &
  & 0.36844210E-03_JPRB, 0.36861742E-03_JPRB, 0.36877338E-03_JPRB, 0.36890819E-03_JPRB, 0.36902350E-03_JPRB, 0.36912254E-03_JPRB, &
  & 0.36920924E-03_JPRB, 0.36928745E-03_JPRB, 0.36935965E-03_JPRB, 0.36942749E-03_JPRB, 0.36949155E-03_JPRB, 0.36955142E-03_JPRB, &
  & 0.36960607E-03_JPRB, 0.36965404E-03_JPRB, 0.36969499E-03_JPRB, 0.36973116E-03_JPRB, 0.36976350E-03_JPRB, 0.36979187E-03_JPRB, &
  & 0.36981684E-03_JPRB, 0.36983876E-03_JPRB, 0.36985867E-03_JPRB, 0.36987624E-03_JPRB, 0.36988940E-03_JPRB, 0.36989787E-03_JPRB, &
  & 0.36990206E-03_JPRB, 0.36990264E-03_JPRB, 0.36989947E-03_JPRB, 0.36989088E-03_JPRB, 0.36987558E-03_JPRB, 0.36985145E-03_JPRB, &
  & 0.36981751E-03_JPRB, 0.36977400E-03_JPRB, 0.36972220E-03_JPRB, 0.36966515E-03_JPRB, 0.36960698E-03_JPRB, 0.36955022E-03_JPRB, &
  & 0.36949635E-03_JPRB, 0.36944490E-03_JPRB, 0.36939449E-03_JPRB, 0.36934399E-03_JPRB, 0.36929283E-03_JPRB, 0.36924161E-03_JPRB, &
  & 0.36919143E-03_JPRB, 0.36914382E-03_JPRB, 0.36910022E-03_JPRB, 0.36906108E-03_JPRB, 0.36902670E-03_JPRB, 0.36899638E-03_JPRB, &
  & 0.36896934E-03_JPRB, 0.36894385E-03_JPRB, 0.36891617E-03_JPRB, 0.36886608E-03_JPRB /)

RGHG1(:,19, 9) = (/ &
  & 0.36718830E-03_JPRB, 0.36746761E-03_JPRB, 0.36756526E-03_JPRB, 0.36763391E-03_JPRB, 0.36769715E-03_JPRB, 0.36776773E-03_JPRB, &
  & 0.36785717E-03_JPRB, 0.36796805E-03_JPRB, 0.36810158E-03_JPRB, 0.36825589E-03_JPRB, 0.36842562E-03_JPRB, 0.36860246E-03_JPRB, &
  & 0.36877720E-03_JPRB, 0.36894059E-03_JPRB, 0.36908712E-03_JPRB, 0.36921474E-03_JPRB, 0.36932447E-03_JPRB, 0.36941931E-03_JPRB, &
  & 0.36950281E-03_JPRB, 0.36957895E-03_JPRB, 0.36965049E-03_JPRB, 0.36971906E-03_JPRB, 0.36978564E-03_JPRB, 0.36984993E-03_JPRB, &
  & 0.36990995E-03_JPRB, 0.36996312E-03_JPRB, 0.37000660E-03_JPRB, 0.37003908E-03_JPRB, 0.37006065E-03_JPRB, 0.37007328E-03_JPRB, &
  & 0.37007834E-03_JPRB, 0.37007764E-03_JPRB, 0.37007307E-03_JPRB, 0.37006644E-03_JPRB, 0.37006027E-03_JPRB, 0.37005520E-03_JPRB, &
  & 0.37005128E-03_JPRB, 0.37004877E-03_JPRB, 0.37004735E-03_JPRB, 0.37004519E-03_JPRB, 0.37003920E-03_JPRB, 0.37002724E-03_JPRB, &
  & 0.37000718E-03_JPRB, 0.36997820E-03_JPRB, 0.36994106E-03_JPRB, 0.36989775E-03_JPRB, 0.36985090E-03_JPRB, 0.36980317E-03_JPRB, &
  & 0.36975564E-03_JPRB, 0.36970797E-03_JPRB, 0.36965957E-03_JPRB, 0.36960962E-03_JPRB, 0.36955834E-03_JPRB, 0.36950674E-03_JPRB, &
  & 0.36945636E-03_JPRB, 0.36940869E-03_JPRB, 0.36936495E-03_JPRB, 0.36932572E-03_JPRB, 0.36929140E-03_JPRB, 0.36926137E-03_JPRB, &
  & 0.36923506E-03_JPRB, 0.36921081E-03_JPRB, 0.36918363E-03_JPRB, 0.36913977E-03_JPRB /)

RGHG1(:,20, 9) = (/ &
  & 0.36793275E-03_JPRB, 0.36805519E-03_JPRB, 0.36809908E-03_JPRB, 0.36812629E-03_JPRB, 0.36815711E-03_JPRB, 0.36819736E-03_JPRB, &
  & 0.36825708E-03_JPRB, 0.36833930E-03_JPRB, 0.36844576E-03_JPRB, 0.36857437E-03_JPRB, 0.36872062E-03_JPRB, 0.36887682E-03_JPRB, &
  & 0.36903325E-03_JPRB, 0.36918162E-03_JPRB, 0.36931562E-03_JPRB, 0.36943285E-03_JPRB, 0.36953413E-03_JPRB, 0.36962231E-03_JPRB, &
  & 0.36970043E-03_JPRB, 0.36977205E-03_JPRB, 0.36984036E-03_JPRB, 0.36990707E-03_JPRB, 0.36997310E-03_JPRB, 0.37003806E-03_JPRB, &
  & 0.37009997E-03_JPRB, 0.37015515E-03_JPRB, 0.37020023E-03_JPRB, 0.37023271E-03_JPRB, 0.37025241E-03_JPRB, 0.37026059E-03_JPRB, &
  & 0.37025873E-03_JPRB, 0.37024915E-03_JPRB, 0.37023416E-03_JPRB, 0.37021603E-03_JPRB, 0.37019842E-03_JPRB, 0.37018408E-03_JPRB, &
  & 0.37017663E-03_JPRB, 0.37017453E-03_JPRB, 0.37017502E-03_JPRB, 0.37017648E-03_JPRB, 0.37017613E-03_JPRB, 0.37017104E-03_JPRB, &
  & 0.37015934E-03_JPRB, 0.37013984E-03_JPRB, 0.37011260E-03_JPRB, 0.37007849E-03_JPRB, 0.37003966E-03_JPRB, 0.36999790E-03_JPRB, &
  & 0.36995451E-03_JPRB, 0.36990966E-03_JPRB, 0.36986309E-03_JPRB, 0.36981457E-03_JPRB, 0.36976472E-03_JPRB, 0.36971466E-03_JPRB, &
  & 0.36966612E-03_JPRB, 0.36962039E-03_JPRB, 0.36957848E-03_JPRB, 0.36954091E-03_JPRB, 0.36950779E-03_JPRB, 0.36947880E-03_JPRB, &
  & 0.36945363E-03_JPRB, 0.36943011E-03_JPRB, 0.36940660E-03_JPRB, 0.36936524E-03_JPRB /)

RGHG1(:,21, 9) = (/ &
  & 0.36841890E-03_JPRB, 0.36847423E-03_JPRB, 0.36848756E-03_JPRB, 0.36849579E-03_JPRB, 0.36850825E-03_JPRB, 0.36853214E-03_JPRB, &
  & 0.36857306E-03_JPRB, 0.36863520E-03_JPRB, 0.36872027E-03_JPRB, 0.36882746E-03_JPRB, 0.36895205E-03_JPRB, 0.36908756E-03_JPRB, &
  & 0.36922537E-03_JPRB, 0.36935712E-03_JPRB, 0.36947732E-03_JPRB, 0.36958334E-03_JPRB, 0.36967560E-03_JPRB, 0.36975657E-03_JPRB, &
  & 0.36982915E-03_JPRB, 0.36989665E-03_JPRB, 0.36996137E-03_JPRB, 0.37002546E-03_JPRB, 0.37008978E-03_JPRB, 0.37015422E-03_JPRB, &
  & 0.37021618E-03_JPRB, 0.37027223E-03_JPRB, 0.37031859E-03_JPRB, 0.37035297E-03_JPRB, 0.37037459E-03_JPRB, 0.37038434E-03_JPRB, &
  & 0.37038350E-03_JPRB, 0.37037392E-03_JPRB, 0.37035812E-03_JPRB, 0.37033891E-03_JPRB, 0.37032034E-03_JPRB, 0.37030553E-03_JPRB, &
  & 0.37029482E-03_JPRB, 0.37028998E-03_JPRB, 0.37029019E-03_JPRB, 0.37029223E-03_JPRB, 0.37029342E-03_JPRB, 0.37029071E-03_JPRB, &
  & 0.37028253E-03_JPRB, 0.37026757E-03_JPRB, 0.37024566E-03_JPRB, 0.37021688E-03_JPRB, 0.37018280E-03_JPRB, 0.37014502E-03_JPRB, &
  & 0.37010456E-03_JPRB, 0.37006190E-03_JPRB, 0.37001728E-03_JPRB, 0.36997092E-03_JPRB, 0.36992351E-03_JPRB, 0.36987633E-03_JPRB, &
  & 0.36983099E-03_JPRB, 0.36978832E-03_JPRB, 0.36974929E-03_JPRB, 0.36971428E-03_JPRB, 0.36968317E-03_JPRB, 0.36965599E-03_JPRB, &
  & 0.36963201E-03_JPRB, 0.36961064E-03_JPRB, 0.36958751E-03_JPRB, 0.36955276E-03_JPRB /)

RGHG1(:,22, 9) = (/ &
  & 0.36875741E-03_JPRB, 0.36878005E-03_JPRB, 0.36878081E-03_JPRB, 0.36877941E-03_JPRB, 0.36878249E-03_JPRB, 0.36879565E-03_JPRB, &
  & 0.36882423E-03_JPRB, 0.36887178E-03_JPRB, 0.36894027E-03_JPRB, 0.36902877E-03_JPRB, 0.36913398E-03_JPRB, 0.36924993E-03_JPRB, &
  & 0.36936931E-03_JPRB, 0.36948506E-03_JPRB, 0.36959170E-03_JPRB, 0.36968719E-03_JPRB, 0.36977133E-03_JPRB, 0.36984606E-03_JPRB, &
  & 0.36991405E-03_JPRB, 0.36997793E-03_JPRB, 0.37004001E-03_JPRB, 0.37010224E-03_JPRB, 0.37016539E-03_JPRB, 0.37022907E-03_JPRB, &
  & 0.37029138E-03_JPRB, 0.37034825E-03_JPRB, 0.37039639E-03_JPRB, 0.37043323E-03_JPRB, 0.37045835E-03_JPRB, 0.37047209E-03_JPRB, &
  & 0.37047555E-03_JPRB, 0.37047020E-03_JPRB, 0.37045823E-03_JPRB, 0.37044173E-03_JPRB, 0.37042494E-03_JPRB, 0.37041094E-03_JPRB, &
  & 0.37040078E-03_JPRB, 0.37039636E-03_JPRB, 0.37039540E-03_JPRB, 0.37039604E-03_JPRB, 0.37039584E-03_JPRB, 0.37039281E-03_JPRB, &
  & 0.37038510E-03_JPRB, 0.37037139E-03_JPRB, 0.37035125E-03_JPRB, 0.37032505E-03_JPRB, 0.37029345E-03_JPRB, 0.37025780E-03_JPRB, &
  & 0.37021941E-03_JPRB, 0.37017872E-03_JPRB, 0.37013611E-03_JPRB, 0.37009211E-03_JPRB, 0.37004755E-03_JPRB, 0.37000404E-03_JPRB, &
  & 0.36996242E-03_JPRB, 0.36992342E-03_JPRB, 0.36988754E-03_JPRB, 0.36985494E-03_JPRB, 0.36982601E-03_JPRB, 0.36980034E-03_JPRB, &
  & 0.36977802E-03_JPRB, 0.36975747E-03_JPRB, 0.36973771E-03_JPRB, 0.36970447E-03_JPRB /)

RGHG1(:,23, 9) = (/ &
  & 0.36901093E-03_JPRB, 0.36901690E-03_JPRB, 0.36901073E-03_JPRB, 0.36900386E-03_JPRB, 0.36900127E-03_JPRB, 0.36900752E-03_JPRB, &
  & 0.36902694E-03_JPRB, 0.36906332E-03_JPRB, 0.36911812E-03_JPRB, 0.36919129E-03_JPRB, 0.36927959E-03_JPRB, 0.36937828E-03_JPRB, &
  & 0.36948128E-03_JPRB, 0.36958247E-03_JPRB, 0.36967738E-03_JPRB, 0.36976367E-03_JPRB, 0.36984109E-03_JPRB, 0.36991102E-03_JPRB, &
  & 0.36997552E-03_JPRB, 0.37003690E-03_JPRB, 0.37009740E-03_JPRB, 0.37015829E-03_JPRB, 0.37022081E-03_JPRB, 0.37028416E-03_JPRB, &
  & 0.37034624E-03_JPRB, 0.37040361E-03_JPRB, 0.37045276E-03_JPRB, 0.37049229E-03_JPRB, 0.37052139E-03_JPRB, 0.37053993E-03_JPRB, &
  & 0.37054869E-03_JPRB, 0.37054913E-03_JPRB, 0.37054298E-03_JPRB, 0.37053225E-03_JPRB, 0.37052025E-03_JPRB, 0.37050908E-03_JPRB, &
  & 0.37050026E-03_JPRB, 0.37049508E-03_JPRB, 0.37049275E-03_JPRB, 0.37049071E-03_JPRB, 0.37048792E-03_JPRB, 0.37048230E-03_JPRB, &
  & 0.37047279E-03_JPRB, 0.37045812E-03_JPRB, 0.37043748E-03_JPRB, 0.37041161E-03_JPRB, 0.37038082E-03_JPRB, 0.37034653E-03_JPRB, &
  & 0.37030946E-03_JPRB, 0.37027034E-03_JPRB, 0.37022965E-03_JPRB, 0.37018809E-03_JPRB, 0.37014682E-03_JPRB, 0.37010666E-03_JPRB, &
  & 0.37006871E-03_JPRB, 0.37003335E-03_JPRB, 0.37000063E-03_JPRB, 0.36997069E-03_JPRB, 0.36994362E-03_JPRB, 0.36991941E-03_JPRB, &
  & 0.36989796E-03_JPRB, 0.36987889E-03_JPRB, 0.36985936E-03_JPRB, 0.36983099E-03_JPRB /)

RGHG1(:,24, 9) = (/ &
  & 0.36921102E-03_JPRB, 0.36920744E-03_JPRB, 0.36919722E-03_JPRB, 0.36918704E-03_JPRB, 0.36918058E-03_JPRB, 0.36918180E-03_JPRB, &
  & 0.36919472E-03_JPRB, 0.36922214E-03_JPRB, 0.36926600E-03_JPRB, 0.36932607E-03_JPRB, 0.36939996E-03_JPRB, 0.36948390E-03_JPRB, &
  & 0.36957287E-03_JPRB, 0.36966219E-03_JPRB, 0.36974752E-03_JPRB, 0.36982671E-03_JPRB, 0.36989950E-03_JPRB, 0.36996620E-03_JPRB, &
  & 0.37002872E-03_JPRB, 0.37008870E-03_JPRB, 0.37014810E-03_JPRB, 0.37020812E-03_JPRB, 0.37026979E-03_JPRB, 0.37033221E-03_JPRB, &
  & 0.37039336E-03_JPRB, 0.37045081E-03_JPRB, 0.37050119E-03_JPRB, 0.37054243E-03_JPRB, 0.37057375E-03_JPRB, 0.37059601E-03_JPRB, &
  & 0.37060987E-03_JPRB, 0.37061609E-03_JPRB, 0.37061586E-03_JPRB, 0.37061161E-03_JPRB, 0.37060477E-03_JPRB, 0.37059700E-03_JPRB, &
  & 0.37059054E-03_JPRB, 0.37058507E-03_JPRB, 0.37058085E-03_JPRB, 0.37057581E-03_JPRB, 0.37056927E-03_JPRB, 0.37056016E-03_JPRB, &
  & 0.37054747E-03_JPRB, 0.37053067E-03_JPRB, 0.37050876E-03_JPRB, 0.37048210E-03_JPRB, 0.37045137E-03_JPRB, 0.37041772E-03_JPRB, &
  & 0.37038172E-03_JPRB, 0.37034394E-03_JPRB, 0.37030518E-03_JPRB, 0.37026618E-03_JPRB, 0.37022788E-03_JPRB, 0.37019109E-03_JPRB, &
  & 0.37015637E-03_JPRB, 0.37012403E-03_JPRB, 0.37009403E-03_JPRB, 0.37006644E-03_JPRB, 0.37004126E-03_JPRB, 0.37001859E-03_JPRB, &
  & 0.36999851E-03_JPRB, 0.36998006E-03_JPRB, 0.36996193E-03_JPRB, 0.36993396E-03_JPRB /)

RGHG1(:,25, 9) = (/ &
  & 0.36937432E-03_JPRB, 0.36936550E-03_JPRB, 0.36935380E-03_JPRB, 0.36934216E-03_JPRB, 0.36933378E-03_JPRB, 0.36933162E-03_JPRB, &
  & 0.36933937E-03_JPRB, 0.36935956E-03_JPRB, 0.36939443E-03_JPRB, 0.36944373E-03_JPRB, 0.36950593E-03_JPRB, 0.36957784E-03_JPRB, &
  & 0.36965561E-03_JPRB, 0.36973532E-03_JPRB, 0.36981361E-03_JPRB, 0.36988792E-03_JPRB, 0.36995744E-03_JPRB, 0.37002235E-03_JPRB, &
  & 0.37008361E-03_JPRB, 0.37014295E-03_JPRB, 0.37020154E-03_JPRB, 0.37026021E-03_JPRB, 0.37032014E-03_JPRB, 0.37038070E-03_JPRB, &
  & 0.37044007E-03_JPRB, 0.37049534E-03_JPRB, 0.37054412E-03_JPRB, 0.37058542E-03_JPRB, 0.37061865E-03_JPRB, 0.37064403E-03_JPRB, &
  & 0.37066199E-03_JPRB, 0.37067296E-03_JPRB, 0.37067838E-03_JPRB, 0.37067948E-03_JPRB, 0.37067762E-03_JPRB, 0.37067384E-03_JPRB, &
  & 0.37066895E-03_JPRB, 0.37066336E-03_JPRB, 0.37065675E-03_JPRB, 0.37064901E-03_JPRB, 0.37063891E-03_JPRB, 0.37062651E-03_JPRB, &
  & 0.37061039E-03_JPRB, 0.37059083E-03_JPRB, 0.37056746E-03_JPRB, 0.37054002E-03_JPRB, 0.37050911E-03_JPRB, 0.37047570E-03_JPRB, &
  & 0.37044068E-03_JPRB, 0.37040451E-03_JPRB, 0.37036775E-03_JPRB, 0.37033111E-03_JPRB, 0.37029566E-03_JPRB, 0.37026184E-03_JPRB, &
  & 0.37023006E-03_JPRB, 0.37020037E-03_JPRB, 0.37017261E-03_JPRB, 0.37014671E-03_JPRB, 0.37012305E-03_JPRB, 0.37010133E-03_JPRB, &
  & 0.37008204E-03_JPRB, 0.37006460E-03_JPRB, 0.37004743E-03_JPRB, 0.37002171E-03_JPRB /)

RGHG1(:,26, 9) = (/ &
  & 0.36951154E-03_JPRB, 0.36950156E-03_JPRB, 0.36949012E-03_JPRB, 0.36947898E-03_JPRB, 0.36946975E-03_JPRB, 0.36946591E-03_JPRB, &
  & 0.36946998E-03_JPRB, 0.36948477E-03_JPRB, 0.36951242E-03_JPRB, 0.36955316E-03_JPRB, 0.36960584E-03_JPRB, 0.36966830E-03_JPRB, &
  & 0.36973742E-03_JPRB, 0.36980998E-03_JPRB, 0.36988306E-03_JPRB, 0.36995416E-03_JPRB, 0.37002182E-03_JPRB, 0.37008576E-03_JPRB, &
  & 0.37014642E-03_JPRB, 0.37020474E-03_JPRB, 0.37026187E-03_JPRB, 0.37031886E-03_JPRB, 0.37037610E-03_JPRB, 0.37043320E-03_JPRB, &
  & 0.37048862E-03_JPRB, 0.37054022E-03_JPRB, 0.37058649E-03_JPRB, 0.37062631E-03_JPRB, 0.37065940E-03_JPRB, 0.37068618E-03_JPRB, &
  & 0.37070661E-03_JPRB, 0.37072130E-03_JPRB, 0.37073073E-03_JPRB, 0.37073568E-03_JPRB, 0.37073719E-03_JPRB, 0.37073620E-03_JPRB, &
  & 0.37073245E-03_JPRB, 0.37072663E-03_JPRB, 0.37071868E-03_JPRB, 0.37070856E-03_JPRB, 0.37069572E-03_JPRB, 0.37068044E-03_JPRB, &
  & 0.37066219E-03_JPRB, 0.37064051E-03_JPRB, 0.37061563E-03_JPRB, 0.37058737E-03_JPRB, 0.37055666E-03_JPRB, 0.37052427E-03_JPRB, &
  & 0.37049034E-03_JPRB, 0.37045567E-03_JPRB, 0.37042081E-03_JPRB, 0.37038661E-03_JPRB, 0.37035361E-03_JPRB, 0.37032241E-03_JPRB, &
  & 0.37029322E-03_JPRB, 0.37026560E-03_JPRB, 0.37023987E-03_JPRB, 0.37021592E-03_JPRB, 0.37019368E-03_JPRB, 0.37017334E-03_JPRB, &
  & 0.37015486E-03_JPRB, 0.37013827E-03_JPRB, 0.37012176E-03_JPRB, 0.37009799E-03_JPRB /)

RGHG1(:,27, 9) = (/ &
  & 0.36963206E-03_JPRB, 0.36962310E-03_JPRB, 0.36961335E-03_JPRB, 0.36960345E-03_JPRB, 0.36959554E-03_JPRB, 0.36959100E-03_JPRB, &
  & 0.36959298E-03_JPRB, 0.36960436E-03_JPRB, 0.36962680E-03_JPRB, 0.36966073E-03_JPRB, 0.36970610E-03_JPRB, 0.36976099E-03_JPRB, &
  & 0.36982348E-03_JPRB, 0.36989059E-03_JPRB, 0.36995963E-03_JPRB, 0.37002820E-03_JPRB, 0.37009438E-03_JPRB, 0.37015748E-03_JPRB, &
  & 0.37021708E-03_JPRB, 0.37027401E-03_JPRB, 0.37032928E-03_JPRB, 0.37038338E-03_JPRB, 0.37043667E-03_JPRB, 0.37048906E-03_JPRB, &
  & 0.37053926E-03_JPRB, 0.37058606E-03_JPRB, 0.37062855E-03_JPRB, 0.37066574E-03_JPRB, 0.37069758E-03_JPRB, 0.37072386E-03_JPRB, &
  & 0.37074529E-03_JPRB, 0.37076199E-03_JPRB, 0.37077416E-03_JPRB, 0.37078199E-03_JPRB, 0.37078589E-03_JPRB, 0.37078626E-03_JPRB, &
  & 0.37078327E-03_JPRB, 0.37077727E-03_JPRB, 0.37076828E-03_JPRB, 0.37075632E-03_JPRB, 0.37074168E-03_JPRB, 0.37072427E-03_JPRB, &
  & 0.37070410E-03_JPRB, 0.37068117E-03_JPRB, 0.37065512E-03_JPRB, 0.37062654E-03_JPRB, 0.37059601E-03_JPRB, 0.37056446E-03_JPRB, &
  & 0.37053236E-03_JPRB, 0.37049971E-03_JPRB, 0.37046708E-03_JPRB, 0.37043510E-03_JPRB, 0.37040454E-03_JPRB, 0.37037564E-03_JPRB, &
  & 0.37034845E-03_JPRB, 0.37032302E-03_JPRB, 0.37029924E-03_JPRB, 0.37027712E-03_JPRB, 0.37025631E-03_JPRB, 0.37023707E-03_JPRB, &
  & 0.37021964E-03_JPRB, 0.37020331E-03_JPRB, 0.37018786E-03_JPRB, 0.37016437E-03_JPRB /)

RGHG1(:,28, 9) = (/ &
  & 0.36974344E-03_JPRB, 0.36973602E-03_JPRB, 0.36972808E-03_JPRB, 0.36972039E-03_JPRB, 0.36971341E-03_JPRB, 0.36970951E-03_JPRB, &
  & 0.36971096E-03_JPRB, 0.36972025E-03_JPRB, 0.36973917E-03_JPRB, 0.36976871E-03_JPRB, 0.36980881E-03_JPRB, 0.36985832E-03_JPRB, &
  & 0.36991539E-03_JPRB, 0.36997796E-03_JPRB, 0.37004339E-03_JPRB, 0.37010945E-03_JPRB, 0.37017406E-03_JPRB, 0.37023544E-03_JPRB, &
  & 0.37029336E-03_JPRB, 0.37034837E-03_JPRB, 0.37040078E-03_JPRB, 0.37045099E-03_JPRB, 0.37049953E-03_JPRB, 0.37054636E-03_JPRB, &
  & 0.37059071E-03_JPRB, 0.37063181E-03_JPRB, 0.37066903E-03_JPRB, 0.37070239E-03_JPRB, 0.37073181E-03_JPRB, 0.37075728E-03_JPRB, &
  & 0.37077893E-03_JPRB, 0.37079651E-03_JPRB, 0.37081004E-03_JPRB, 0.37081933E-03_JPRB, 0.37082468E-03_JPRB, 0.37082587E-03_JPRB, &
  & 0.37082323E-03_JPRB, 0.37081682E-03_JPRB, 0.37080710E-03_JPRB, 0.37079430E-03_JPRB, 0.37077835E-03_JPRB, 0.37075981E-03_JPRB, &
  & 0.37073856E-03_JPRB, 0.37071490E-03_JPRB, 0.37068874E-03_JPRB, 0.37066059E-03_JPRB, 0.37063082E-03_JPRB, 0.37060044E-03_JPRB, &
  & 0.37056973E-03_JPRB, 0.37053876E-03_JPRB, 0.37050818E-03_JPRB, 0.37047852E-03_JPRB, 0.37045020E-03_JPRB, 0.37042331E-03_JPRB, &
  & 0.37039813E-03_JPRB, 0.37037462E-03_JPRB, 0.37035244E-03_JPRB, 0.37033146E-03_JPRB, 0.37031167E-03_JPRB, 0.37029339E-03_JPRB, &
  & 0.37027680E-03_JPRB, 0.37026205E-03_JPRB, 0.37024714E-03_JPRB, 0.37022575E-03_JPRB /)

RGHG1(:,29, 9) = (/ &
  & 0.36984816E-03_JPRB, 0.36984298E-03_JPRB, 0.36983704E-03_JPRB, 0.36983076E-03_JPRB, 0.36982534E-03_JPRB, 0.36982234E-03_JPRB, &
  & 0.36982395E-03_JPRB, 0.36983233E-03_JPRB, 0.36984953E-03_JPRB, 0.36987598E-03_JPRB, 0.36991260E-03_JPRB, 0.36995811E-03_JPRB, &
  & 0.37001120E-03_JPRB, 0.37006976E-03_JPRB, 0.37013192E-03_JPRB, 0.37019502E-03_JPRB, 0.37025716E-03_JPRB, 0.37031580E-03_JPRB, &
  & 0.37037156E-03_JPRB, 0.37042372E-03_JPRB, 0.37047249E-03_JPRB, 0.37051833E-03_JPRB, 0.37056167E-03_JPRB, 0.37060271E-03_JPRB, &
  & 0.37064109E-03_JPRB, 0.37067640E-03_JPRB, 0.37070859E-03_JPRB, 0.37073792E-03_JPRB, 0.37076444E-03_JPRB, 0.37078821E-03_JPRB, &
  & 0.37080905E-03_JPRB, 0.37082651E-03_JPRB, 0.37084022E-03_JPRB, 0.37085012E-03_JPRB, 0.37085591E-03_JPRB, 0.37085736E-03_JPRB, &
  & 0.37085474E-03_JPRB, 0.37084817E-03_JPRB, 0.37083810E-03_JPRB, 0.37082465E-03_JPRB, 0.37080824E-03_JPRB, 0.37078897E-03_JPRB, &
  & 0.37076752E-03_JPRB, 0.37074380E-03_JPRB, 0.37071810E-03_JPRB, 0.37069054E-03_JPRB, 0.37066182E-03_JPRB, 0.37063271E-03_JPRB, &
  & 0.37060349E-03_JPRB, 0.37057447E-03_JPRB, 0.37054589E-03_JPRB, 0.37051851E-03_JPRB, 0.37049214E-03_JPRB, 0.37046720E-03_JPRB, &
  & 0.37044371E-03_JPRB, 0.37042151E-03_JPRB, 0.37040038E-03_JPRB, 0.37038056E-03_JPRB, 0.37036178E-03_JPRB, 0.37034458E-03_JPRB, &
  & 0.37032922E-03_JPRB, 0.37031501E-03_JPRB, 0.37030139E-03_JPRB, 0.37027991E-03_JPRB /)

RGHG1(:,30, 9) = (/ &
  & 0.36994700E-03_JPRB, 0.36994333E-03_JPRB, 0.36993867E-03_JPRB, 0.36993434E-03_JPRB, 0.36993032E-03_JPRB, 0.36992843E-03_JPRB, &
  & 0.36993058E-03_JPRB, 0.36993885E-03_JPRB, 0.36995500E-03_JPRB, 0.36998006E-03_JPRB, 0.37001417E-03_JPRB, 0.37005683E-03_JPRB, &
  & 0.37010666E-03_JPRB, 0.37016196E-03_JPRB, 0.37022040E-03_JPRB, 0.37028035E-03_JPRB, 0.37033879E-03_JPRB, 0.37039450E-03_JPRB, &
  & 0.37044700E-03_JPRB, 0.37049584E-03_JPRB, 0.37054077E-03_JPRB, 0.37058225E-03_JPRB, 0.37062066E-03_JPRB, 0.37065637E-03_JPRB, &
  & 0.37068914E-03_JPRB, 0.37071912E-03_JPRB, 0.37074659E-03_JPRB, 0.37077206E-03_JPRB, 0.37079555E-03_JPRB, 0.37081703E-03_JPRB, &
  & 0.37083638E-03_JPRB, 0.37085294E-03_JPRB, 0.37086612E-03_JPRB, 0.37087561E-03_JPRB, 0.37088135E-03_JPRB, 0.37088277E-03_JPRB, &
  & 0.37087998E-03_JPRB, 0.37087334E-03_JPRB, 0.37086313E-03_JPRB, 0.37084962E-03_JPRB, 0.37083306E-03_JPRB, 0.37081412E-03_JPRB, &
  & 0.37079272E-03_JPRB, 0.37076959E-03_JPRB, 0.37074447E-03_JPRB, 0.37071807E-03_JPRB, 0.37069089E-03_JPRB, 0.37066342E-03_JPRB, &
  & 0.37063594E-03_JPRB, 0.37060867E-03_JPRB, 0.37058193E-03_JPRB, 0.37055620E-03_JPRB, 0.37053140E-03_JPRB, 0.37050786E-03_JPRB, &
  & 0.37048565E-03_JPRB, 0.37046455E-03_JPRB, 0.37044464E-03_JPRB, 0.37042587E-03_JPRB, 0.37040826E-03_JPRB, 0.37039199E-03_JPRB, &
  & 0.37037730E-03_JPRB, 0.37036414E-03_JPRB, 0.37035090E-03_JPRB, 0.37033187E-03_JPRB /)

RGHG1(:,31, 9) = (/ &
  & 0.37003832E-03_JPRB, 0.37003591E-03_JPRB, 0.37003279E-03_JPRB, 0.37002971E-03_JPRB, 0.37002732E-03_JPRB, 0.37002674E-03_JPRB, &
  & 0.37002962E-03_JPRB, 0.37003835E-03_JPRB, 0.37005442E-03_JPRB, 0.37007860E-03_JPRB, 0.37011120E-03_JPRB, 0.37015154E-03_JPRB, &
  & 0.37019848E-03_JPRB, 0.37025032E-03_JPRB, 0.37030518E-03_JPRB, 0.37036114E-03_JPRB, 0.37041592E-03_JPRB, 0.37046816E-03_JPRB, &
  & 0.37051711E-03_JPRB, 0.37056234E-03_JPRB, 0.37060349E-03_JPRB, 0.37064092E-03_JPRB, 0.37067494E-03_JPRB, 0.37070602E-03_JPRB, &
  & 0.37073391E-03_JPRB, 0.37075943E-03_JPRB, 0.37078289E-03_JPRB, 0.37080457E-03_JPRB, 0.37082503E-03_JPRB, 0.37084421E-03_JPRB, &
  & 0.37086173E-03_JPRB, 0.37087678E-03_JPRB, 0.37088891E-03_JPRB, 0.37089764E-03_JPRB, 0.37090268E-03_JPRB, 0.37090373E-03_JPRB, &
  & 0.37090087E-03_JPRB, 0.37089433E-03_JPRB, 0.37088426E-03_JPRB, 0.37087110E-03_JPRB, 0.37085498E-03_JPRB, 0.37083638E-03_JPRB, &
  & 0.37081592E-03_JPRB, 0.37079360E-03_JPRB, 0.37076991E-03_JPRB, 0.37074470E-03_JPRB, 0.37071880E-03_JPRB, 0.37069287E-03_JPRB, &
  & 0.37066708E-03_JPRB, 0.37064141E-03_JPRB, 0.37061624E-03_JPRB, 0.37059202E-03_JPRB, 0.37056877E-03_JPRB, 0.37054639E-03_JPRB, &
  & 0.37052520E-03_JPRB, 0.37050535E-03_JPRB, 0.37048655E-03_JPRB, 0.37046871E-03_JPRB, 0.37045198E-03_JPRB, 0.37043644E-03_JPRB, &
  & 0.37042279E-03_JPRB, 0.37041027E-03_JPRB, 0.37039805E-03_JPRB, 0.37037869E-03_JPRB /)

RGHG1(:,32, 9) = (/ &
  & 0.37012176E-03_JPRB, 0.37012072E-03_JPRB, 0.37011874E-03_JPRB, 0.37011702E-03_JPRB, 0.37011591E-03_JPRB, 0.37011656E-03_JPRB, &
  & 0.37012063E-03_JPRB, 0.37013000E-03_JPRB, 0.37014618E-03_JPRB, 0.37017005E-03_JPRB, 0.37020128E-03_JPRB, 0.37023952E-03_JPRB, &
  & 0.37028364E-03_JPRB, 0.37033216E-03_JPRB, 0.37038309E-03_JPRB, 0.37043498E-03_JPRB, 0.37048588E-03_JPRB, 0.37053440E-03_JPRB, &
  & 0.37057989E-03_JPRB, 0.37062191E-03_JPRB, 0.37065978E-03_JPRB, 0.37069374E-03_JPRB, 0.37072404E-03_JPRB, 0.37075116E-03_JPRB, &
  & 0.37077517E-03_JPRB, 0.37079689E-03_JPRB, 0.37081679E-03_JPRB, 0.37083542E-03_JPRB, 0.37085297E-03_JPRB, 0.37086953E-03_JPRB, &
  & 0.37088472E-03_JPRB, 0.37089828E-03_JPRB, 0.37090899E-03_JPRB, 0.37091668E-03_JPRB, 0.37092099E-03_JPRB, 0.37092168E-03_JPRB, &
  & 0.37091866E-03_JPRB, 0.37091237E-03_JPRB, 0.37090265E-03_JPRB, 0.37089013E-03_JPRB, 0.37087483E-03_JPRB, 0.37085710E-03_JPRB, &
  & 0.37083760E-03_JPRB, 0.37081662E-03_JPRB, 0.37079418E-03_JPRB, 0.37077061E-03_JPRB, 0.37074633E-03_JPRB, 0.37072180E-03_JPRB, &
  & 0.37069738E-03_JPRB, 0.37067331E-03_JPRB, 0.37064962E-03_JPRB, 0.37062663E-03_JPRB, 0.37060448E-03_JPRB, 0.37058338E-03_JPRB, &
  & 0.37056333E-03_JPRB, 0.37054432E-03_JPRB, 0.37052642E-03_JPRB, 0.37050925E-03_JPRB, 0.37049316E-03_JPRB, 0.37047849E-03_JPRB, &
  & 0.37046522E-03_JPRB, 0.37045334E-03_JPRB, 0.37044132E-03_JPRB, 0.37042348E-03_JPRB /)

RGHG1(:,33, 9) = (/ &
  & 0.37019741E-03_JPRB, 0.37019755E-03_JPRB, 0.37019659E-03_JPRB, 0.37019580E-03_JPRB, 0.37019598E-03_JPRB, 0.37019790E-03_JPRB, &
  & 0.37020323E-03_JPRB, 0.37021344E-03_JPRB, 0.37023000E-03_JPRB, 0.37025334E-03_JPRB, 0.37028329E-03_JPRB, 0.37031935E-03_JPRB, &
  & 0.37036053E-03_JPRB, 0.37040559E-03_JPRB, 0.37045282E-03_JPRB, 0.37050055E-03_JPRB, 0.37054770E-03_JPRB, 0.37059275E-03_JPRB, &
  & 0.37063495E-03_JPRB, 0.37067389E-03_JPRB, 0.37070899E-03_JPRB, 0.37074019E-03_JPRB, 0.37076767E-03_JPRB, 0.37079171E-03_JPRB, &
  & 0.37081286E-03_JPRB, 0.37083164E-03_JPRB, 0.37084866E-03_JPRB, 0.37086444E-03_JPRB, 0.37087942E-03_JPRB, 0.37089348E-03_JPRB, &
  & 0.37090658E-03_JPRB, 0.37091799E-03_JPRB, 0.37092710E-03_JPRB, 0.37093356E-03_JPRB, 0.37093693E-03_JPRB, 0.37093714E-03_JPRB, &
  & 0.37093420E-03_JPRB, 0.37092809E-03_JPRB, 0.37091912E-03_JPRB, 0.37090739E-03_JPRB, 0.37089334E-03_JPRB, 0.37087678E-03_JPRB, &
  & 0.37085862E-03_JPRB, 0.37083885E-03_JPRB, 0.37081799E-03_JPRB, 0.37079584E-03_JPRB, 0.37077305E-03_JPRB, 0.37075012E-03_JPRB, &
  & 0.37072718E-03_JPRB, 0.37070439E-03_JPRB, 0.37068210E-03_JPRB, 0.37066027E-03_JPRB, 0.37063903E-03_JPRB, 0.37061897E-03_JPRB, &
  & 0.37059991E-03_JPRB, 0.37058163E-03_JPRB, 0.37056426E-03_JPRB, 0.37054782E-03_JPRB, 0.37053251E-03_JPRB, 0.37051848E-03_JPRB, &
  & 0.37050573E-03_JPRB, 0.37049447E-03_JPRB, 0.37048312E-03_JPRB, 0.37046539E-03_JPRB /)

RGHG1(:,34, 9) = (/ &
  & 0.37026429E-03_JPRB, 0.37026609E-03_JPRB, 0.37026627E-03_JPRB, 0.37026661E-03_JPRB, 0.37026798E-03_JPRB, 0.37027107E-03_JPRB, &
  & 0.37027756E-03_JPRB, 0.37028856E-03_JPRB, 0.37030526E-03_JPRB, 0.37032811E-03_JPRB, 0.37035649E-03_JPRB, 0.37039048E-03_JPRB, &
  & 0.37042872E-03_JPRB, 0.37047037E-03_JPRB, 0.37051371E-03_JPRB, 0.37055800E-03_JPRB, 0.37060137E-03_JPRB, 0.37064310E-03_JPRB, &
  & 0.37068257E-03_JPRB, 0.37071900E-03_JPRB, 0.37075210E-03_JPRB, 0.37078129E-03_JPRB, 0.37080661E-03_JPRB, 0.37082838E-03_JPRB, &
  & 0.37084729E-03_JPRB, 0.37086362E-03_JPRB, 0.37087823E-03_JPRB, 0.37089150E-03_JPRB, 0.37090399E-03_JPRB, 0.37091578E-03_JPRB, &
  & 0.37092654E-03_JPRB, 0.37093592E-03_JPRB, 0.37094331E-03_JPRB, 0.37094852E-03_JPRB, 0.37095096E-03_JPRB, 0.37095087E-03_JPRB, &
  & 0.37094794E-03_JPRB, 0.37094229E-03_JPRB, 0.37093423E-03_JPRB, 0.37092363E-03_JPRB, 0.37091059E-03_JPRB, 0.37089561E-03_JPRB, &
  & 0.37087876E-03_JPRB, 0.37086036E-03_JPRB, 0.37084095E-03_JPRB, 0.37082043E-03_JPRB, 0.37079904E-03_JPRB, 0.37077753E-03_JPRB, &
  & 0.37075582E-03_JPRB, 0.37073423E-03_JPRB, 0.37071289E-03_JPRB, 0.37069226E-03_JPRB, 0.37067215E-03_JPRB, 0.37065297E-03_JPRB, &
  & 0.37063475E-03_JPRB, 0.37061720E-03_JPRB, 0.37060061E-03_JPRB, 0.37058495E-03_JPRB, 0.37057023E-03_JPRB, 0.37055655E-03_JPRB, &
  & 0.37054444E-03_JPRB, 0.37053358E-03_JPRB, 0.37052244E-03_JPRB, 0.37050535E-03_JPRB /)

RGHG1(:,35, 9) = (/ &
  & 0.37032497E-03_JPRB, 0.37032735E-03_JPRB, 0.37032866E-03_JPRB, 0.37032983E-03_JPRB, 0.37033198E-03_JPRB, 0.37033614E-03_JPRB, &
  & 0.37034348E-03_JPRB, 0.37035524E-03_JPRB, 0.37037226E-03_JPRB, 0.37039429E-03_JPRB, 0.37042136E-03_JPRB, 0.37045300E-03_JPRB, &
  & 0.37048836E-03_JPRB, 0.37052674E-03_JPRB, 0.37056691E-03_JPRB, 0.37060748E-03_JPRB, 0.37064758E-03_JPRB, 0.37068647E-03_JPRB, &
  & 0.37072343E-03_JPRB, 0.37075795E-03_JPRB, 0.37078932E-03_JPRB, 0.37081697E-03_JPRB, 0.37084089E-03_JPRB, 0.37086121E-03_JPRB, &
  & 0.37087838E-03_JPRB, 0.37089278E-03_JPRB, 0.37090533E-03_JPRB, 0.37091644E-03_JPRB, 0.37092672E-03_JPRB, 0.37093618E-03_JPRB, &
  & 0.37094476E-03_JPRB, 0.37095210E-03_JPRB, 0.37095786E-03_JPRB, 0.37096158E-03_JPRB, 0.37096330E-03_JPRB, 0.37096263E-03_JPRB, &
  & 0.37095998E-03_JPRB, 0.37095486E-03_JPRB, 0.37094776E-03_JPRB, 0.37093842E-03_JPRB, 0.37092678E-03_JPRB, 0.37091319E-03_JPRB, &
  & 0.37089770E-03_JPRB, 0.37088088E-03_JPRB, 0.37086298E-03_JPRB, 0.37084389E-03_JPRB, 0.37082366E-03_JPRB, 0.37080343E-03_JPRB, &
  & 0.37078303E-03_JPRB, 0.37076263E-03_JPRB, 0.37074237E-03_JPRB, 0.37072267E-03_JPRB, 0.37070358E-03_JPRB, 0.37068530E-03_JPRB, &
  & 0.37066799E-03_JPRB, 0.37065145E-03_JPRB, 0.37063565E-03_JPRB, 0.37062052E-03_JPRB, 0.37060623E-03_JPRB, 0.37059328E-03_JPRB, &
  & 0.37058158E-03_JPRB, 0.37057092E-03_JPRB, 0.37056024E-03_JPRB, 0.37054325E-03_JPRB /)

RGHG1(:,36, 9) = (/ &
  & 0.37037797E-03_JPRB, 0.37038224E-03_JPRB, 0.37038451E-03_JPRB, 0.37038658E-03_JPRB, 0.37038955E-03_JPRB, 0.37039447E-03_JPRB, &
  & 0.37040244E-03_JPRB, 0.37041455E-03_JPRB, 0.37043128E-03_JPRB, 0.37045276E-03_JPRB, 0.37047829E-03_JPRB, 0.37050768E-03_JPRB, &
  & 0.37054042E-03_JPRB, 0.37057581E-03_JPRB, 0.37061254E-03_JPRB, 0.37065006E-03_JPRB, 0.37068716E-03_JPRB, 0.37072346E-03_JPRB, &
  & 0.37075829E-03_JPRB, 0.37079104E-03_JPRB, 0.37082113E-03_JPRB, 0.37084791E-03_JPRB, 0.37087101E-03_JPRB, 0.37089031E-03_JPRB, &
  & 0.37090597E-03_JPRB, 0.37091871E-03_JPRB, 0.37092940E-03_JPRB, 0.37093865E-03_JPRB, 0.37094674E-03_JPRB, 0.37095411E-03_JPRB, &
  & 0.37096057E-03_JPRB, 0.37096595E-03_JPRB, 0.37097005E-03_JPRB, 0.37097262E-03_JPRB, 0.37097346E-03_JPRB, 0.37097267E-03_JPRB, &
  & 0.37097032E-03_JPRB, 0.37096598E-03_JPRB, 0.37095993E-03_JPRB, 0.37095181E-03_JPRB, 0.37094159E-03_JPRB, 0.37092937E-03_JPRB, &
  & 0.37091560E-03_JPRB, 0.37090041E-03_JPRB, 0.37088370E-03_JPRB, 0.37086580E-03_JPRB, 0.37084697E-03_JPRB, 0.37082791E-03_JPRB, &
  & 0.37080850E-03_JPRB, 0.37078894E-03_JPRB, 0.37076967E-03_JPRB, 0.37075090E-03_JPRB, 0.37073280E-03_JPRB, 0.37071557E-03_JPRB, &
  & 0.37069927E-03_JPRB, 0.37068367E-03_JPRB, 0.37066871E-03_JPRB, 0.37065451E-03_JPRB, 0.37064092E-03_JPRB, 0.37062838E-03_JPRB, &
  & 0.37061711E-03_JPRB, 0.37060690E-03_JPRB, 0.37059630E-03_JPRB, 0.37057974E-03_JPRB /)

RGHG1(:,37, 9) = (/ &
  & 0.37042602E-03_JPRB, 0.37043198E-03_JPRB, 0.37043495E-03_JPRB, 0.37043786E-03_JPRB, 0.37044150E-03_JPRB, 0.37044715E-03_JPRB, &
  & 0.37045567E-03_JPRB, 0.37046795E-03_JPRB, 0.37048446E-03_JPRB, 0.37050477E-03_JPRB, 0.37052867E-03_JPRB, 0.37055582E-03_JPRB, &
  & 0.37058597E-03_JPRB, 0.37061831E-03_JPRB, 0.37065215E-03_JPRB, 0.37068655E-03_JPRB, 0.37072101E-03_JPRB, 0.37075480E-03_JPRB, &
  & 0.37078772E-03_JPRB, 0.37081930E-03_JPRB, 0.37084846E-03_JPRB, 0.37087454E-03_JPRB, 0.37089665E-03_JPRB, 0.37091481E-03_JPRB, &
  & 0.37092913E-03_JPRB, 0.37094025E-03_JPRB, 0.37094904E-03_JPRB, 0.37095646E-03_JPRB, 0.37096272E-03_JPRB, 0.37096819E-03_JPRB, &
  & 0.37097288E-03_JPRB, 0.37097663E-03_JPRB, 0.37097940E-03_JPRB, 0.37098106E-03_JPRB, 0.37098143E-03_JPRB, 0.37098062E-03_JPRB, &
  & 0.37097861E-03_JPRB, 0.37097518E-03_JPRB, 0.37097026E-03_JPRB, 0.37096348E-03_JPRB, 0.37095477E-03_JPRB, 0.37094418E-03_JPRB, &
  & 0.37093196E-03_JPRB, 0.37091810E-03_JPRB, 0.37090271E-03_JPRB, 0.37088612E-03_JPRB, 0.37086857E-03_JPRB, 0.37085055E-03_JPRB, &
  & 0.37083216E-03_JPRB, 0.37081353E-03_JPRB, 0.37079511E-03_JPRB, 0.37077712E-03_JPRB, 0.37075992E-03_JPRB, 0.37074371E-03_JPRB, &
  & 0.37072855E-03_JPRB, 0.37071414E-03_JPRB, 0.37070015E-03_JPRB, 0.37068673E-03_JPRB, 0.37067386E-03_JPRB, 0.37066208E-03_JPRB, &
  & 0.37065137E-03_JPRB, 0.37064147E-03_JPRB, 0.37063146E-03_JPRB, 0.37061490E-03_JPRB /)

RGHG1(:,38, 9) = (/ &
  & 0.37047191E-03_JPRB, 0.37047779E-03_JPRB, 0.37048126E-03_JPRB, 0.37048466E-03_JPRB, 0.37048903E-03_JPRB, 0.37049537E-03_JPRB, &
  & 0.37050436E-03_JPRB, 0.37051673E-03_JPRB, 0.37053259E-03_JPRB, 0.37055172E-03_JPRB, 0.37057369E-03_JPRB, 0.37059857E-03_JPRB, &
  & 0.37062593E-03_JPRB, 0.37065533E-03_JPRB, 0.37068620E-03_JPRB, 0.37071787E-03_JPRB, 0.37074977E-03_JPRB, 0.37078149E-03_JPRB, &
  & 0.37081257E-03_JPRB, 0.37084281E-03_JPRB, 0.37087119E-03_JPRB, 0.37089622E-03_JPRB, 0.37091723E-03_JPRB, 0.37093391E-03_JPRB, &
  & 0.37094639E-03_JPRB, 0.37095573E-03_JPRB, 0.37096287E-03_JPRB, 0.37096866E-03_JPRB, 0.37097346E-03_JPRB, 0.37097756E-03_JPRB, &
  & 0.37098091E-03_JPRB, 0.37098359E-03_JPRB, 0.37098536E-03_JPRB, 0.37098647E-03_JPRB, 0.37098653E-03_JPRB, 0.37098577E-03_JPRB, &
  & 0.37098414E-03_JPRB, 0.37098161E-03_JPRB, 0.37097791E-03_JPRB, 0.37097270E-03_JPRB, 0.37096554E-03_JPRB, 0.37095678E-03_JPRB, &
  & 0.37094616E-03_JPRB, 0.37093385E-03_JPRB, 0.37091985E-03_JPRB, 0.37090463E-03_JPRB, 0.37088824E-03_JPRB, 0.37087122E-03_JPRB, &
  & 0.37085361E-03_JPRB, 0.37083571E-03_JPRB, 0.37081802E-03_JPRB, 0.37080099E-03_JPRB, 0.37078484E-03_JPRB, 0.37076991E-03_JPRB, &
  & 0.37075582E-03_JPRB, 0.37074252E-03_JPRB, 0.37072977E-03_JPRB, 0.37071737E-03_JPRB, 0.37070556E-03_JPRB, 0.37069441E-03_JPRB, &
  & 0.37068420E-03_JPRB, 0.37067482E-03_JPRB, 0.37066493E-03_JPRB, 0.37064866E-03_JPRB /)

RGHG1(:,39, 9) = (/ &
  & 0.37051275E-03_JPRB, 0.37051993E-03_JPRB, 0.37052401E-03_JPRB, 0.37052820E-03_JPRB, 0.37053344E-03_JPRB, 0.37054025E-03_JPRB, &
  & 0.37054956E-03_JPRB, 0.37056161E-03_JPRB, 0.37057666E-03_JPRB, 0.37059435E-03_JPRB, 0.37061452E-03_JPRB, 0.37063705E-03_JPRB, &
  & 0.37066155E-03_JPRB, 0.37068813E-03_JPRB, 0.37071598E-03_JPRB, 0.37074473E-03_JPRB, 0.37077419E-03_JPRB, 0.37080387E-03_JPRB, &
  & 0.37083332E-03_JPRB, 0.37086225E-03_JPRB, 0.37088909E-03_JPRB, 0.37091284E-03_JPRB, 0.37093222E-03_JPRB, 0.37094683E-03_JPRB, &
  & 0.37095760E-03_JPRB, 0.37096554E-03_JPRB, 0.37097131E-03_JPRB, 0.37097582E-03_JPRB, 0.37097969E-03_JPRB, 0.37098289E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098740E-03_JPRB, 0.37098871E-03_JPRB, 0.37098947E-03_JPRB, 0.37098938E-03_JPRB, 0.37098877E-03_JPRB, &
  & 0.37098740E-03_JPRB, 0.37098548E-03_JPRB, 0.37098266E-03_JPRB, 0.37097881E-03_JPRB, 0.37097328E-03_JPRB, 0.37096633E-03_JPRB, &
  & 0.37095754E-03_JPRB, 0.37094700E-03_JPRB, 0.37093472E-03_JPRB, 0.37092090E-03_JPRB, 0.37090579E-03_JPRB, 0.37088987E-03_JPRB, &
  & 0.37087296E-03_JPRB, 0.37085582E-03_JPRB, 0.37083894E-03_JPRB, 0.37082267E-03_JPRB, 0.37080768E-03_JPRB, 0.37079395E-03_JPRB, &
  & 0.37078117E-03_JPRB, 0.37076918E-03_JPRB, 0.37075765E-03_JPRB, 0.37074636E-03_JPRB, 0.37073554E-03_JPRB, 0.37072532E-03_JPRB, &
  & 0.37071572E-03_JPRB, 0.37070675E-03_JPRB, 0.37069715E-03_JPRB, 0.37068137E-03_JPRB /)

RGHG1(:,40, 9) = (/ &
  & 0.37055131E-03_JPRB, 0.37055920E-03_JPRB, 0.37056406E-03_JPRB, 0.37056871E-03_JPRB, 0.37057468E-03_JPRB, 0.37058216E-03_JPRB, &
  & 0.37059176E-03_JPRB, 0.37060352E-03_JPRB, 0.37061749E-03_JPRB, 0.37063364E-03_JPRB, 0.37065172E-03_JPRB, 0.37067174E-03_JPRB, &
  & 0.37069368E-03_JPRB, 0.37071726E-03_JPRB, 0.37074217E-03_JPRB, 0.37076825E-03_JPRB, 0.37079526E-03_JPRB, 0.37082276E-03_JPRB, &
  & 0.37085035E-03_JPRB, 0.37087762E-03_JPRB, 0.37090312E-03_JPRB, 0.37092509E-03_JPRB, 0.37094270E-03_JPRB, 0.37095565E-03_JPRB, &
  & 0.37096493E-03_JPRB, 0.37097157E-03_JPRB, 0.37097637E-03_JPRB, 0.37098021E-03_JPRB, 0.37098333E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098801E-03_JPRB, 0.37098961E-03_JPRB, 0.37099069E-03_JPRB, 0.37099115E-03_JPRB, 0.37099107E-03_JPRB, 0.37099043E-03_JPRB, &
  & 0.37098941E-03_JPRB, 0.37098775E-03_JPRB, 0.37098557E-03_JPRB, 0.37098248E-03_JPRB, 0.37097814E-03_JPRB, 0.37097279E-03_JPRB, &
  & 0.37096589E-03_JPRB, 0.37095736E-03_JPRB, 0.37094703E-03_JPRB, 0.37093484E-03_JPRB, 0.37092110E-03_JPRB, 0.37090614E-03_JPRB, &
  & 0.37089019E-03_JPRB, 0.37087390E-03_JPRB, 0.37085783E-03_JPRB, 0.37084252E-03_JPRB, 0.37082855E-03_JPRB, 0.37081604E-03_JPRB, &
  & 0.37080457E-03_JPRB, 0.37079380E-03_JPRB, 0.37078347E-03_JPRB, 0.37077340E-03_JPRB, 0.37076362E-03_JPRB, 0.37075422E-03_JPRB, &
  & 0.37074537E-03_JPRB, 0.37073708E-03_JPRB, 0.37072814E-03_JPRB, 0.37071289E-03_JPRB /)

RGHG1(:,41, 9) = (/ &
  & 0.37058783E-03_JPRB, 0.37059642E-03_JPRB, 0.37060154E-03_JPRB, 0.37060701E-03_JPRB, 0.37061359E-03_JPRB, 0.37062165E-03_JPRB, &
  & 0.37063155E-03_JPRB, 0.37064278E-03_JPRB, 0.37065579E-03_JPRB, 0.37067040E-03_JPRB, 0.37068641E-03_JPRB, 0.37070387E-03_JPRB, &
  & 0.37072288E-03_JPRB, 0.37074371E-03_JPRB, 0.37076586E-03_JPRB, 0.37078929E-03_JPRB, 0.37081374E-03_JPRB, 0.37083906E-03_JPRB, &
  & 0.37086481E-03_JPRB, 0.37089048E-03_JPRB, 0.37091417E-03_JPRB, 0.37093449E-03_JPRB, 0.37095021E-03_JPRB, 0.37096170E-03_JPRB, &
  & 0.37096982E-03_JPRB, 0.37097553E-03_JPRB, 0.37097972E-03_JPRB, 0.37098295E-03_JPRB, 0.37098560E-03_JPRB, 0.37098784E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37099104E-03_JPRB, 0.37099200E-03_JPRB, 0.37099243E-03_JPRB, 0.37099220E-03_JPRB, 0.37099156E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37098926E-03_JPRB, 0.37098740E-03_JPRB, 0.37098498E-03_JPRB, 0.37098158E-03_JPRB, 0.37097739E-03_JPRB, &
  & 0.37097195E-03_JPRB, 0.37096514E-03_JPRB, 0.37095670E-03_JPRB, 0.37094645E-03_JPRB, 0.37093434E-03_JPRB, 0.37092058E-03_JPRB, &
  & 0.37090565E-03_JPRB, 0.37089013E-03_JPRB, 0.37087477E-03_JPRB, 0.37086045E-03_JPRB, 0.37084764E-03_JPRB, 0.37083635E-03_JPRB, &
  & 0.37082605E-03_JPRB, 0.37081656E-03_JPRB, 0.37080736E-03_JPRB, 0.37079849E-03_JPRB, 0.37078967E-03_JPRB, 0.37078137E-03_JPRB, &
  & 0.37077349E-03_JPRB, 0.37076583E-03_JPRB, 0.37075745E-03_JPRB, 0.37074296E-03_JPRB /)

RGHG1(:,42, 9) = (/ &
  & 0.37062314E-03_JPRB, 0.37063178E-03_JPRB, 0.37063746E-03_JPRB, 0.37064331E-03_JPRB, 0.37065049E-03_JPRB, 0.37065931E-03_JPRB, &
  & 0.37066930E-03_JPRB, 0.37068024E-03_JPRB, 0.37069205E-03_JPRB, 0.37070486E-03_JPRB, 0.37071883E-03_JPRB, 0.37073402E-03_JPRB, &
  & 0.37075058E-03_JPRB, 0.37076854E-03_JPRB, 0.37078798E-03_JPRB, 0.37080873E-03_JPRB, 0.37083065E-03_JPRB, 0.37085370E-03_JPRB, &
  & 0.37087756E-03_JPRB, 0.37090131E-03_JPRB, 0.37092343E-03_JPRB, 0.37094194E-03_JPRB, 0.37095614E-03_JPRB, 0.37096633E-03_JPRB, &
  & 0.37097340E-03_JPRB, 0.37097849E-03_JPRB, 0.37098204E-03_JPRB, 0.37098481E-03_JPRB, 0.37098714E-03_JPRB, 0.37098918E-03_JPRB, &
  & 0.37099069E-03_JPRB, 0.37099203E-03_JPRB, 0.37099281E-03_JPRB, 0.37099322E-03_JPRB, 0.37099299E-03_JPRB, 0.37099243E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099031E-03_JPRB, 0.37098871E-03_JPRB, 0.37098664E-03_JPRB, 0.37098391E-03_JPRB, 0.37098050E-03_JPRB, &
  & 0.37097625E-03_JPRB, 0.37097096E-03_JPRB, 0.37096426E-03_JPRB, 0.37095576E-03_JPRB, 0.37094552E-03_JPRB, 0.37093315E-03_JPRB, &
  & 0.37091924E-03_JPRB, 0.37090469E-03_JPRB, 0.37089022E-03_JPRB, 0.37087678E-03_JPRB, 0.37086499E-03_JPRB, 0.37085474E-03_JPRB, &
  & 0.37084572E-03_JPRB, 0.37083752E-03_JPRB, 0.37082954E-03_JPRB, 0.37082174E-03_JPRB, 0.37081409E-03_JPRB, 0.37080661E-03_JPRB, &
  & 0.37079974E-03_JPRB, 0.37079284E-03_JPRB, 0.37078516E-03_JPRB, 0.37077192E-03_JPRB /)

RGHG1(:,43, 9) = (/ &
  & 0.37065832E-03_JPRB, 0.37066717E-03_JPRB, 0.37067261E-03_JPRB, 0.37067870E-03_JPRB, 0.37068626E-03_JPRB, 0.37069543E-03_JPRB, &
  & 0.37070547E-03_JPRB, 0.37071583E-03_JPRB, 0.37072654E-03_JPRB, 0.37073789E-03_JPRB, 0.37075000E-03_JPRB, 0.37076295E-03_JPRB, &
  & 0.37077715E-03_JPRB, 0.37079255E-03_JPRB, 0.37080937E-03_JPRB, 0.37082750E-03_JPRB, 0.37084689E-03_JPRB, 0.37086767E-03_JPRB, &
  & 0.37088949E-03_JPRB, 0.37091138E-03_JPRB, 0.37093152E-03_JPRB, 0.37094820E-03_JPRB, 0.37096083E-03_JPRB, 0.37096988E-03_JPRB, &
  & 0.37097611E-03_JPRB, 0.37098059E-03_JPRB, 0.37098385E-03_JPRB, 0.37098635E-03_JPRB, 0.37098836E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099162E-03_JPRB, 0.37099276E-03_JPRB, 0.37099345E-03_JPRB, 0.37099386E-03_JPRB, 0.37099369E-03_JPRB, 0.37099308E-03_JPRB, &
  & 0.37099226E-03_JPRB, 0.37099115E-03_JPRB, 0.37098967E-03_JPRB, 0.37098798E-03_JPRB, 0.37098560E-03_JPRB, 0.37098289E-03_JPRB, &
  & 0.37097940E-03_JPRB, 0.37097523E-03_JPRB, 0.37096997E-03_JPRB, 0.37096321E-03_JPRB, 0.37095460E-03_JPRB, 0.37094392E-03_JPRB, &
  & 0.37093132E-03_JPRB, 0.37091775E-03_JPRB, 0.37090416E-03_JPRB, 0.37089182E-03_JPRB, 0.37088100E-03_JPRB, 0.37087189E-03_JPRB, &
  & 0.37086400E-03_JPRB, 0.37085687E-03_JPRB, 0.37085006E-03_JPRB, 0.37084334E-03_JPRB, 0.37083664E-03_JPRB, 0.37083036E-03_JPRB, &
  & 0.37082436E-03_JPRB, 0.37081825E-03_JPRB, 0.37081135E-03_JPRB, 0.37079942E-03_JPRB /)

RGHG1(:,44, 9) = (/ &
  & 0.37069342E-03_JPRB, 0.37070268E-03_JPRB, 0.37070815E-03_JPRB, 0.37071403E-03_JPRB, 0.37072168E-03_JPRB, 0.37073108E-03_JPRB, &
  & 0.37074066E-03_JPRB, 0.37075035E-03_JPRB, 0.37076010E-03_JPRB, 0.37077002E-03_JPRB, 0.37078033E-03_JPRB, 0.37079136E-03_JPRB, &
  & 0.37080335E-03_JPRB, 0.37081641E-03_JPRB, 0.37083073E-03_JPRB, 0.37084625E-03_JPRB, 0.37086316E-03_JPRB, 0.37088149E-03_JPRB, &
  & 0.37090114E-03_JPRB, 0.37092075E-03_JPRB, 0.37093891E-03_JPRB, 0.37095379E-03_JPRB, 0.37096502E-03_JPRB, 0.37097291E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37098234E-03_JPRB, 0.37098522E-03_JPRB, 0.37098740E-03_JPRB, 0.37098929E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099342E-03_JPRB, 0.37099401E-03_JPRB, 0.37099438E-03_JPRB, 0.37099424E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099182E-03_JPRB, 0.37099054E-03_JPRB, 0.37098903E-03_JPRB, 0.37098705E-03_JPRB, 0.37098481E-03_JPRB, &
  & 0.37098202E-03_JPRB, 0.37097867E-03_JPRB, 0.37097462E-03_JPRB, 0.37096930E-03_JPRB, 0.37096231E-03_JPRB, 0.37095320E-03_JPRB, &
  & 0.37094194E-03_JPRB, 0.37092957E-03_JPRB, 0.37091706E-03_JPRB, 0.37090568E-03_JPRB, 0.37089590E-03_JPRB, 0.37088781E-03_JPRB, &
  & 0.37088103E-03_JPRB, 0.37087506E-03_JPRB, 0.37086924E-03_JPRB, 0.37086356E-03_JPRB, 0.37085789E-03_JPRB, 0.37085250E-03_JPRB, &
  & 0.37084721E-03_JPRB, 0.37084200E-03_JPRB, 0.37083623E-03_JPRB, 0.37082602E-03_JPRB /)

RGHG1(:,45, 9) = (/ &
  & 0.37073379E-03_JPRB, 0.37074031E-03_JPRB, 0.37074450E-03_JPRB, 0.37074974E-03_JPRB, 0.37075719E-03_JPRB, 0.37076624E-03_JPRB, &
  & 0.37077552E-03_JPRB, 0.37078443E-03_JPRB, 0.37079293E-03_JPRB, 0.37080148E-03_JPRB, 0.37081016E-03_JPRB, 0.37081938E-03_JPRB, &
  & 0.37082942E-03_JPRB, 0.37084048E-03_JPRB, 0.37085247E-03_JPRB, 0.37086566E-03_JPRB, 0.37088007E-03_JPRB, 0.37089593E-03_JPRB, &
  & 0.37091278E-03_JPRB, 0.37093018E-03_JPRB, 0.37094581E-03_JPRB, 0.37095865E-03_JPRB, 0.37096837E-03_JPRB, 0.37097521E-03_JPRB, &
  & 0.37098018E-03_JPRB, 0.37098376E-03_JPRB, 0.37098635E-03_JPRB, 0.37098833E-03_JPRB, 0.37099008E-03_JPRB, 0.37099168E-03_JPRB, &
  & 0.37099287E-03_JPRB, 0.37099389E-03_JPRB, 0.37099444E-03_JPRB, 0.37099491E-03_JPRB, 0.37099471E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099342E-03_JPRB, 0.37099252E-03_JPRB, 0.37099133E-03_JPRB, 0.37098999E-03_JPRB, 0.37098819E-03_JPRB, 0.37098626E-03_JPRB, &
  & 0.37098399E-03_JPRB, 0.37098140E-03_JPRB, 0.37097820E-03_JPRB, 0.37097410E-03_JPRB, 0.37096872E-03_JPRB, 0.37096121E-03_JPRB, &
  & 0.37095157E-03_JPRB, 0.37094043E-03_JPRB, 0.37092905E-03_JPRB, 0.37091866E-03_JPRB, 0.37090993E-03_JPRB, 0.37090294E-03_JPRB, &
  & 0.37089721E-03_JPRB, 0.37089217E-03_JPRB, 0.37088746E-03_JPRB, 0.37088286E-03_JPRB, 0.37087809E-03_JPRB, 0.37087346E-03_JPRB, &
  & 0.37086898E-03_JPRB, 0.37086455E-03_JPRB, 0.37085963E-03_JPRB, 0.37085116E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART18',0,ZHOOK_HANDLE)



RGHG1(:,46, 9) = (/ &
  & 0.37076554E-03_JPRB, 0.37077462E-03_JPRB, 0.37077992E-03_JPRB, 0.37078574E-03_JPRB, 0.37079302E-03_JPRB, 0.37080178E-03_JPRB, &
  & 0.37081045E-03_JPRB, 0.37081836E-03_JPRB, 0.37082567E-03_JPRB, 0.37083280E-03_JPRB, 0.37083993E-03_JPRB, 0.37084735E-03_JPRB, &
  & 0.37085562E-03_JPRB, 0.37086458E-03_JPRB, 0.37087459E-03_JPRB, 0.37088554E-03_JPRB, 0.37089764E-03_JPRB, 0.37091080E-03_JPRB, &
  & 0.37092518E-03_JPRB, 0.37093923E-03_JPRB, 0.37095230E-03_JPRB, 0.37096289E-03_JPRB, 0.37097128E-03_JPRB, 0.37097733E-03_JPRB, &
  & 0.37098164E-03_JPRB, 0.37098484E-03_JPRB, 0.37098728E-03_JPRB, 0.37098915E-03_JPRB, 0.37099072E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099436E-03_JPRB, 0.37099497E-03_JPRB, 0.37099526E-03_JPRB, 0.37099520E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099389E-03_JPRB, 0.37099305E-03_JPRB, 0.37099197E-03_JPRB, 0.37099078E-03_JPRB, 0.37098912E-03_JPRB, 0.37098743E-03_JPRB, &
  & 0.37098560E-03_JPRB, 0.37098350E-03_JPRB, 0.37098111E-03_JPRB, 0.37097812E-03_JPRB, 0.37097410E-03_JPRB, 0.37096819E-03_JPRB, &
  & 0.37096013E-03_JPRB, 0.37095050E-03_JPRB, 0.37094037E-03_JPRB, 0.37093103E-03_JPRB, 0.37092334E-03_JPRB, 0.37091741E-03_JPRB, &
  & 0.37091272E-03_JPRB, 0.37090876E-03_JPRB, 0.37090489E-03_JPRB, 0.37090108E-03_JPRB, 0.37089712E-03_JPRB, 0.37089331E-03_JPRB, &
  & 0.37088955E-03_JPRB, 0.37088586E-03_JPRB, 0.37088184E-03_JPRB, 0.37087497E-03_JPRB /)

RGHG1(:,47, 9) = (/ &
  & 0.37080253E-03_JPRB, 0.37081100E-03_JPRB, 0.37081639E-03_JPRB, 0.37082226E-03_JPRB, 0.37082974E-03_JPRB, 0.37083810E-03_JPRB, &
  & 0.37084587E-03_JPRB, 0.37085265E-03_JPRB, 0.37085859E-03_JPRB, 0.37086420E-03_JPRB, 0.37086970E-03_JPRB, 0.37087552E-03_JPRB, &
  & 0.37088181E-03_JPRB, 0.37088903E-03_JPRB, 0.37089700E-03_JPRB, 0.37090591E-03_JPRB, 0.37091563E-03_JPRB, 0.37092628E-03_JPRB, &
  & 0.37093717E-03_JPRB, 0.37094814E-03_JPRB, 0.37095803E-03_JPRB, 0.37096674E-03_JPRB, 0.37097372E-03_JPRB, 0.37097896E-03_JPRB, &
  & 0.37098286E-03_JPRB, 0.37098580E-03_JPRB, 0.37098801E-03_JPRB, 0.37098976E-03_JPRB, 0.37099130E-03_JPRB, 0.37099261E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099471E-03_JPRB, 0.37099535E-03_JPRB, 0.37099572E-03_JPRB, 0.37099558E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099357E-03_JPRB, 0.37099249E-03_JPRB, 0.37099139E-03_JPRB, 0.37098993E-03_JPRB, 0.37098848E-03_JPRB, &
  & 0.37098693E-03_JPRB, 0.37098530E-03_JPRB, 0.37098338E-03_JPRB, 0.37098120E-03_JPRB, 0.37097817E-03_JPRB, 0.37097387E-03_JPRB, &
  & 0.37096761E-03_JPRB, 0.37095969E-03_JPRB, 0.37095096E-03_JPRB, 0.37094290E-03_JPRB, 0.37093641E-03_JPRB, 0.37093146E-03_JPRB, &
  & 0.37092777E-03_JPRB, 0.37092448E-03_JPRB, 0.37092148E-03_JPRB, 0.37091839E-03_JPRB, 0.37091516E-03_JPRB, 0.37091185E-03_JPRB, &
  & 0.37090876E-03_JPRB, 0.37090568E-03_JPRB, 0.37090242E-03_JPRB, 0.37089695E-03_JPRB /)

RGHG1(:,48, 9) = (/ &
  & 0.37083589E-03_JPRB, 0.37084555E-03_JPRB, 0.37085172E-03_JPRB, 0.37085830E-03_JPRB, 0.37086607E-03_JPRB, 0.37087422E-03_JPRB, &
  & 0.37088135E-03_JPRB, 0.37088699E-03_JPRB, 0.37089153E-03_JPRB, 0.37089555E-03_JPRB, 0.37089948E-03_JPRB, 0.37090352E-03_JPRB, &
  & 0.37090812E-03_JPRB, 0.37091353E-03_JPRB, 0.37091965E-03_JPRB, 0.37092625E-03_JPRB, 0.37093359E-03_JPRB, 0.37094086E-03_JPRB, &
  & 0.37094852E-03_JPRB, 0.37095591E-03_JPRB, 0.37096321E-03_JPRB, 0.37096994E-03_JPRB, 0.37097570E-03_JPRB, 0.37098030E-03_JPRB, &
  & 0.37098379E-03_JPRB, 0.37098647E-03_JPRB, 0.37098859E-03_JPRB, 0.37099025E-03_JPRB, 0.37099168E-03_JPRB, 0.37099299E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099503E-03_JPRB, 0.37099567E-03_JPRB, 0.37099599E-03_JPRB, 0.37099593E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099398E-03_JPRB, 0.37099293E-03_JPRB, 0.37099191E-03_JPRB, 0.37099060E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37098804E-03_JPRB, 0.37098664E-03_JPRB, 0.37098516E-03_JPRB, 0.37098341E-03_JPRB, 0.37098117E-03_JPRB, 0.37097812E-03_JPRB, &
  & 0.37097366E-03_JPRB, 0.37096773E-03_JPRB, 0.37096097E-03_JPRB, 0.37095448E-03_JPRB, 0.37094907E-03_JPRB, 0.37094502E-03_JPRB, &
  & 0.37094194E-03_JPRB, 0.37093944E-03_JPRB, 0.37093705E-03_JPRB, 0.37093455E-03_JPRB, 0.37093187E-03_JPRB, 0.37092910E-03_JPRB, &
  & 0.37092646E-03_JPRB, 0.37092392E-03_JPRB, 0.37092122E-03_JPRB, 0.37091682E-03_JPRB /)

RGHG1(:,49, 9) = (/ &
  & 0.37086621E-03_JPRB, 0.37087681E-03_JPRB, 0.37088359E-03_JPRB, 0.37089066E-03_JPRB, 0.37089895E-03_JPRB, 0.37090736E-03_JPRB, &
  & 0.37091409E-03_JPRB, 0.37091895E-03_JPRB, 0.37092238E-03_JPRB, 0.37092509E-03_JPRB, 0.37092748E-03_JPRB, 0.37093009E-03_JPRB, &
  & 0.37093300E-03_JPRB, 0.37093644E-03_JPRB, 0.37094037E-03_JPRB, 0.37094485E-03_JPRB, 0.37094919E-03_JPRB, 0.37095349E-03_JPRB, &
  & 0.37095786E-03_JPRB, 0.37096249E-03_JPRB, 0.37096749E-03_JPRB, 0.37097259E-03_JPRB, 0.37097730E-03_JPRB, 0.37098132E-03_JPRB, &
  & 0.37098449E-03_JPRB, 0.37098705E-03_JPRB, 0.37098906E-03_JPRB, 0.37099069E-03_JPRB, 0.37099211E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099537E-03_JPRB, 0.37099601E-03_JPRB, 0.37099631E-03_JPRB, 0.37099628E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099511E-03_JPRB, 0.37099444E-03_JPRB, 0.37099340E-03_JPRB, 0.37099249E-03_JPRB, 0.37099121E-03_JPRB, 0.37098999E-03_JPRB, &
  & 0.37098888E-03_JPRB, 0.37098769E-03_JPRB, 0.37098650E-03_JPRB, 0.37098513E-03_JPRB, 0.37098356E-03_JPRB, 0.37098143E-03_JPRB, &
  & 0.37097847E-03_JPRB, 0.37097442E-03_JPRB, 0.37096970E-03_JPRB, 0.37096499E-03_JPRB, 0.37096109E-03_JPRB, 0.37095798E-03_JPRB, &
  & 0.37095556E-03_JPRB, 0.37095355E-03_JPRB, 0.37095163E-03_JPRB, 0.37094965E-03_JPRB, 0.37094738E-03_JPRB, 0.37094502E-03_JPRB, &
  & 0.37094275E-03_JPRB, 0.37094057E-03_JPRB, 0.37093827E-03_JPRB, 0.37093455E-03_JPRB /)

RGHG1(:,50, 9) = (/ &
  & 0.37089552E-03_JPRB, 0.37090457E-03_JPRB, 0.37091051E-03_JPRB, 0.37091711E-03_JPRB, 0.37092503E-03_JPRB, 0.37093300E-03_JPRB, &
  & 0.37093906E-03_JPRB, 0.37094310E-03_JPRB, 0.37094581E-03_JPRB, 0.37094767E-03_JPRB, 0.37094924E-03_JPRB, 0.37095079E-03_JPRB, &
  & 0.37095239E-03_JPRB, 0.37095428E-03_JPRB, 0.37095649E-03_JPRB, 0.37095862E-03_JPRB, 0.37096071E-03_JPRB, 0.37096272E-03_JPRB, &
  & 0.37096493E-03_JPRB, 0.37096761E-03_JPRB, 0.37097093E-03_JPRB, 0.37097477E-03_JPRB, 0.37097873E-03_JPRB, 0.37098228E-03_JPRB, &
  & 0.37098519E-03_JPRB, 0.37098757E-03_JPRB, 0.37098944E-03_JPRB, 0.37099104E-03_JPRB, 0.37099249E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099567E-03_JPRB, 0.37099631E-03_JPRB, 0.37099657E-03_JPRB, 0.37099654E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099549E-03_JPRB, 0.37099476E-03_JPRB, 0.37099383E-03_JPRB, 0.37099299E-03_JPRB, 0.37099174E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37098856E-03_JPRB, 0.37098755E-03_JPRB, 0.37098650E-03_JPRB, 0.37098525E-03_JPRB, 0.37098373E-03_JPRB, &
  & 0.37098184E-03_JPRB, 0.37097937E-03_JPRB, 0.37097663E-03_JPRB, 0.37097381E-03_JPRB, 0.37097128E-03_JPRB, 0.37096927E-03_JPRB, &
  & 0.37096773E-03_JPRB, 0.37096630E-03_JPRB, 0.37096493E-03_JPRB, 0.37096330E-03_JPRB, 0.37096141E-03_JPRB, 0.37095940E-03_JPRB, &
  & 0.37095748E-03_JPRB, 0.37095565E-03_JPRB, 0.37095364E-03_JPRB, 0.37095023E-03_JPRB /)

RGHG1(:,51, 9) = (/ &
  & 0.37091784E-03_JPRB, 0.37092558E-03_JPRB, 0.37093076E-03_JPRB, 0.37093612E-03_JPRB, 0.37094299E-03_JPRB, 0.37094994E-03_JPRB, &
  & 0.37095498E-03_JPRB, 0.37095801E-03_JPRB, 0.37095998E-03_JPRB, 0.37096144E-03_JPRB, 0.37096240E-03_JPRB, 0.37096342E-03_JPRB, &
  & 0.37096441E-03_JPRB, 0.37096537E-03_JPRB, 0.37096636E-03_JPRB, 0.37096732E-03_JPRB, 0.37096816E-03_JPRB, 0.37096895E-03_JPRB, &
  & 0.37097000E-03_JPRB, 0.37097142E-03_JPRB, 0.37097372E-03_JPRB, 0.37097654E-03_JPRB, 0.37097983E-03_JPRB, 0.37098301E-03_JPRB, &
  & 0.37098565E-03_JPRB, 0.37098801E-03_JPRB, 0.37098987E-03_JPRB, 0.37099142E-03_JPRB, 0.37099281E-03_JPRB, 0.37099395E-03_JPRB, &
  & 0.37099491E-03_JPRB, 0.37099584E-03_JPRB, 0.37099648E-03_JPRB, 0.37099686E-03_JPRB, 0.37099674E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099587E-03_JPRB, 0.37099517E-03_JPRB, 0.37099427E-03_JPRB, 0.37099340E-03_JPRB, 0.37099226E-03_JPRB, 0.37099118E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37098932E-03_JPRB, 0.37098845E-03_JPRB, 0.37098763E-03_JPRB, 0.37098667E-03_JPRB, 0.37098557E-03_JPRB, &
  & 0.37098429E-03_JPRB, 0.37098277E-03_JPRB, 0.37098129E-03_JPRB, 0.37097975E-03_JPRB, 0.37097849E-03_JPRB, 0.37097750E-03_JPRB, &
  & 0.37097666E-03_JPRB, 0.37097590E-03_JPRB, 0.37097512E-03_JPRB, 0.37097413E-03_JPRB, 0.37097291E-03_JPRB, 0.37097145E-03_JPRB, &
  & 0.37096994E-03_JPRB, 0.37096848E-03_JPRB, 0.37096671E-03_JPRB, 0.37096385E-03_JPRB /)

RGHG1(:,52, 9) = (/ &
  & 0.37093757E-03_JPRB, 0.37094223E-03_JPRB, 0.37094549E-03_JPRB, 0.37094974E-03_JPRB, 0.37095495E-03_JPRB, 0.37096071E-03_JPRB, &
  & 0.37096452E-03_JPRB, 0.37096679E-03_JPRB, 0.37096819E-03_JPRB, 0.37096912E-03_JPRB, 0.37096982E-03_JPRB, 0.37097043E-03_JPRB, &
  & 0.37097104E-03_JPRB, 0.37097165E-03_JPRB, 0.37097212E-03_JPRB, 0.37097247E-03_JPRB, 0.37097279E-03_JPRB, 0.37097314E-03_JPRB, &
  & 0.37097366E-03_JPRB, 0.37097448E-03_JPRB, 0.37097596E-03_JPRB, 0.37097806E-03_JPRB, 0.37098082E-03_JPRB, 0.37098359E-03_JPRB, &
  & 0.37098615E-03_JPRB, 0.37098845E-03_JPRB, 0.37099022E-03_JPRB, 0.37099171E-03_JPRB, 0.37099308E-03_JPRB, 0.37099418E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37099619E-03_JPRB, 0.37099680E-03_JPRB, 0.37099712E-03_JPRB, 0.37099703E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099552E-03_JPRB, 0.37099468E-03_JPRB, 0.37099380E-03_JPRB, 0.37099273E-03_JPRB, 0.37099174E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37098999E-03_JPRB, 0.37098923E-03_JPRB, 0.37098845E-03_JPRB, 0.37098766E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098600E-03_JPRB, 0.37098510E-03_JPRB, 0.37098426E-03_JPRB, 0.37098359E-03_JPRB, 0.37098298E-03_JPRB, 0.37098248E-03_JPRB, &
  & 0.37098204E-03_JPRB, 0.37098167E-03_JPRB, 0.37098129E-03_JPRB, 0.37098082E-03_JPRB, 0.37098024E-03_JPRB, 0.37097954E-03_JPRB, &
  & 0.37097861E-03_JPRB, 0.37097762E-03_JPRB, 0.37097649E-03_JPRB, 0.37097419E-03_JPRB /)

RGHG1(:,53, 9) = (/ &
  & 0.37094910E-03_JPRB, 0.37095309E-03_JPRB, 0.37095597E-03_JPRB, 0.37095902E-03_JPRB, 0.37096330E-03_JPRB, 0.37096758E-03_JPRB, &
  & 0.37097035E-03_JPRB, 0.37097200E-03_JPRB, 0.37097299E-03_JPRB, 0.37097366E-03_JPRB, 0.37097419E-03_JPRB, 0.37097465E-03_JPRB, &
  & 0.37097503E-03_JPRB, 0.37097541E-03_JPRB, 0.37097564E-03_JPRB, 0.37097576E-03_JPRB, 0.37097590E-03_JPRB, 0.37097605E-03_JPRB, &
  & 0.37097628E-03_JPRB, 0.37097678E-03_JPRB, 0.37097777E-03_JPRB, 0.37097937E-03_JPRB, 0.37098170E-03_JPRB, 0.37098420E-03_JPRB, &
  & 0.37098664E-03_JPRB, 0.37098886E-03_JPRB, 0.37099057E-03_JPRB, 0.37099197E-03_JPRB, 0.37099328E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099642E-03_JPRB, 0.37099700E-03_JPRB, 0.37099732E-03_JPRB, 0.37099730E-03_JPRB, 0.37099680E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099587E-03_JPRB, 0.37099508E-03_JPRB, 0.37099430E-03_JPRB, 0.37099322E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099057E-03_JPRB, 0.37098993E-03_JPRB, 0.37098923E-03_JPRB, 0.37098856E-03_JPRB, 0.37098792E-03_JPRB, &
  & 0.37098734E-03_JPRB, 0.37098679E-03_JPRB, 0.37098624E-03_JPRB, 0.37098583E-03_JPRB, 0.37098557E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098525E-03_JPRB, 0.37098513E-03_JPRB, 0.37098496E-03_JPRB, 0.37098475E-03_JPRB, 0.37098443E-03_JPRB, 0.37098402E-03_JPRB, &
  & 0.37098356E-03_JPRB, 0.37098309E-03_JPRB, 0.37098245E-03_JPRB, 0.37098114E-03_JPRB /)

RGHG1(:,54, 9) = (/ &
  & 0.37095911E-03_JPRB, 0.37096179E-03_JPRB, 0.37096359E-03_JPRB, 0.37096607E-03_JPRB, 0.37096909E-03_JPRB, 0.37097241E-03_JPRB, &
  & 0.37097442E-03_JPRB, 0.37097553E-03_JPRB, 0.37097617E-03_JPRB, 0.37097657E-03_JPRB, 0.37097692E-03_JPRB, 0.37097724E-03_JPRB, &
  & 0.37097759E-03_JPRB, 0.37097785E-03_JPRB, 0.37097806E-03_JPRB, 0.37097817E-03_JPRB, 0.37097820E-03_JPRB, 0.37097826E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37097867E-03_JPRB, 0.37097931E-03_JPRB, 0.37098056E-03_JPRB, 0.37098251E-03_JPRB, 0.37098472E-03_JPRB, &
  & 0.37098705E-03_JPRB, 0.37098912E-03_JPRB, 0.37099081E-03_JPRB, 0.37099226E-03_JPRB, 0.37099351E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099660E-03_JPRB, 0.37099718E-03_JPRB, 0.37099750E-03_JPRB, 0.37099738E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099619E-03_JPRB, 0.37099540E-03_JPRB, 0.37099465E-03_JPRB, 0.37099369E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099113E-03_JPRB, 0.37099051E-03_JPRB, 0.37098993E-03_JPRB, 0.37098938E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098839E-03_JPRB, 0.37098798E-03_JPRB, 0.37098757E-03_JPRB, 0.37098737E-03_JPRB, 0.37098725E-03_JPRB, 0.37098723E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098714E-03_JPRB, 0.37098711E-03_JPRB, 0.37098699E-03_JPRB, 0.37098682E-03_JPRB, 0.37098664E-03_JPRB, &
  & 0.37098644E-03_JPRB, 0.37098624E-03_JPRB, 0.37098603E-03_JPRB, 0.37098577E-03_JPRB /)

RGHG1(:,55, 9) = (/ &
  & 0.37096572E-03_JPRB, 0.37096778E-03_JPRB, 0.37096941E-03_JPRB, 0.37097107E-03_JPRB, 0.37097349E-03_JPRB, 0.37097576E-03_JPRB, &
  & 0.37097724E-03_JPRB, 0.37097803E-03_JPRB, 0.37097844E-03_JPRB, 0.37097876E-03_JPRB, 0.37097896E-03_JPRB, 0.37097913E-03_JPRB, &
  & 0.37097943E-03_JPRB, 0.37097963E-03_JPRB, 0.37097983E-03_JPRB, 0.37097986E-03_JPRB, 0.37097989E-03_JPRB, 0.37097992E-03_JPRB, &
  & 0.37097998E-03_JPRB, 0.37098012E-03_JPRB, 0.37098065E-03_JPRB, 0.37098164E-03_JPRB, 0.37098327E-03_JPRB, 0.37098530E-03_JPRB, &
  & 0.37098746E-03_JPRB, 0.37098938E-03_JPRB, 0.37099107E-03_JPRB, 0.37099246E-03_JPRB, 0.37099369E-03_JPRB, 0.37099488E-03_JPRB, &
  & 0.37099584E-03_JPRB, 0.37099683E-03_JPRB, 0.37099747E-03_JPRB, 0.37099767E-03_JPRB, 0.37099767E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099654E-03_JPRB, 0.37099578E-03_JPRB, 0.37099503E-03_JPRB, 0.37099421E-03_JPRB, 0.37099313E-03_JPRB, &
  & 0.37099232E-03_JPRB, 0.37099168E-03_JPRB, 0.37099107E-03_JPRB, 0.37099051E-03_JPRB, 0.37098999E-03_JPRB, 0.37098955E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37098891E-03_JPRB, 0.37098868E-03_JPRB, 0.37098853E-03_JPRB, 0.37098839E-03_JPRB, 0.37098827E-03_JPRB, &
  & 0.37098821E-03_JPRB, 0.37098824E-03_JPRB, 0.37098821E-03_JPRB, 0.37098819E-03_JPRB, 0.37098810E-03_JPRB, 0.37098801E-03_JPRB, &
  & 0.37098795E-03_JPRB, 0.37098784E-03_JPRB, 0.37098769E-03_JPRB, 0.37098743E-03_JPRB /)

RGHG1(:,56, 9) = (/ &
  & 0.37097128E-03_JPRB, 0.37097273E-03_JPRB, 0.37097369E-03_JPRB, 0.37097506E-03_JPRB, 0.37097672E-03_JPRB, 0.37097838E-03_JPRB, &
  & 0.37097931E-03_JPRB, 0.37097989E-03_JPRB, 0.37098024E-03_JPRB, 0.37098042E-03_JPRB, 0.37098059E-03_JPRB, 0.37098071E-03_JPRB, &
  & 0.37098088E-03_JPRB, 0.37098106E-03_JPRB, 0.37098123E-03_JPRB, 0.37098135E-03_JPRB, 0.37098140E-03_JPRB, 0.37098140E-03_JPRB, &
  & 0.37098140E-03_JPRB, 0.37098143E-03_JPRB, 0.37098175E-03_JPRB, 0.37098260E-03_JPRB, 0.37098402E-03_JPRB, 0.37098589E-03_JPRB, &
  & 0.37098787E-03_JPRB, 0.37098982E-03_JPRB, 0.37099142E-03_JPRB, 0.37099270E-03_JPRB, 0.37099395E-03_JPRB, 0.37099505E-03_JPRB, &
  & 0.37099604E-03_JPRB, 0.37099703E-03_JPRB, 0.37099767E-03_JPRB, 0.37099779E-03_JPRB, 0.37099785E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099677E-03_JPRB, 0.37099607E-03_JPRB, 0.37099540E-03_JPRB, 0.37099456E-03_JPRB, 0.37099369E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099223E-03_JPRB, 0.37099165E-03_JPRB, 0.37099118E-03_JPRB, 0.37099069E-03_JPRB, 0.37099022E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37098970E-03_JPRB, 0.37098952E-03_JPRB, 0.37098938E-03_JPRB, 0.37098926E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37098923E-03_JPRB, 0.37098920E-03_JPRB, 0.37098915E-03_JPRB, 0.37098909E-03_JPRB, 0.37098903E-03_JPRB, 0.37098900E-03_JPRB, &
  & 0.37098894E-03_JPRB, 0.37098888E-03_JPRB, 0.37098880E-03_JPRB, 0.37098859E-03_JPRB /)

RGHG1(:,57, 9) = (/ &
  & 0.37097509E-03_JPRB, 0.37097622E-03_JPRB, 0.37097710E-03_JPRB, 0.37097800E-03_JPRB, 0.37097916E-03_JPRB, 0.37098027E-03_JPRB, &
  & 0.37098097E-03_JPRB, 0.37098135E-03_JPRB, 0.37098158E-03_JPRB, 0.37098175E-03_JPRB, 0.37098187E-03_JPRB, 0.37098199E-03_JPRB, &
  & 0.37098213E-03_JPRB, 0.37098234E-03_JPRB, 0.37098251E-03_JPRB, 0.37098263E-03_JPRB, 0.37098269E-03_JPRB, 0.37098269E-03_JPRB, &
  & 0.37098266E-03_JPRB, 0.37098266E-03_JPRB, 0.37098286E-03_JPRB, 0.37098356E-03_JPRB, 0.37098475E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37099014E-03_JPRB, 0.37099171E-03_JPRB, 0.37099293E-03_JPRB, 0.37099418E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099718E-03_JPRB, 0.37099782E-03_JPRB, 0.37099808E-03_JPRB, 0.37099811E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099715E-03_JPRB, 0.37099639E-03_JPRB, 0.37099564E-03_JPRB, 0.37099494E-03_JPRB, 0.37099401E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099273E-03_JPRB, 0.37099229E-03_JPRB, 0.37099179E-03_JPRB, 0.37099124E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37099072E-03_JPRB, 0.37099048E-03_JPRB, 0.37099031E-03_JPRB, 0.37099019E-03_JPRB, 0.37099019E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37099019E-03_JPRB, 0.37099014E-03_JPRB, 0.37099002E-03_JPRB, 0.37098990E-03_JPRB, 0.37098982E-03_JPRB, &
  & 0.37098973E-03_JPRB, 0.37098967E-03_JPRB, 0.37098961E-03_JPRB, 0.37098944E-03_JPRB /)

RGHG1(:,58, 9) = (/ &
  & 0.37097809E-03_JPRB, 0.37097905E-03_JPRB, 0.37097966E-03_JPRB, 0.37098036E-03_JPRB, 0.37098117E-03_JPRB, 0.37098199E-03_JPRB, &
  & 0.37098245E-03_JPRB, 0.37098277E-03_JPRB, 0.37098292E-03_JPRB, 0.37098306E-03_JPRB, 0.37098321E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098344E-03_JPRB, 0.37098356E-03_JPRB, 0.37098367E-03_JPRB, 0.37098379E-03_JPRB, 0.37098388E-03_JPRB, 0.37098391E-03_JPRB, &
  & 0.37098385E-03_JPRB, 0.37098376E-03_JPRB, 0.37098391E-03_JPRB, 0.37098449E-03_JPRB, 0.37098551E-03_JPRB, 0.37098708E-03_JPRB, &
  & 0.37098883E-03_JPRB, 0.37099048E-03_JPRB, 0.37099194E-03_JPRB, 0.37099310E-03_JPRB, 0.37099441E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099645E-03_JPRB, 0.37099727E-03_JPRB, 0.37099799E-03_JPRB, 0.37099823E-03_JPRB, 0.37099831E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099770E-03_JPRB, 0.37099730E-03_JPRB, 0.37099671E-03_JPRB, 0.37099601E-03_JPRB, 0.37099537E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099383E-03_JPRB, 0.37099325E-03_JPRB, 0.37099273E-03_JPRB, 0.37099238E-03_JPRB, 0.37099179E-03_JPRB, 0.37099153E-03_JPRB, &
  & 0.37099139E-03_JPRB, 0.37099115E-03_JPRB, 0.37099104E-03_JPRB, 0.37099089E-03_JPRB, 0.37099083E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099081E-03_JPRB, 0.37099078E-03_JPRB, 0.37099075E-03_JPRB, 0.37099072E-03_JPRB, 0.37099063E-03_JPRB, 0.37099057E-03_JPRB, &
  & 0.37099051E-03_JPRB, 0.37099040E-03_JPRB, 0.37099034E-03_JPRB, 0.37099019E-03_JPRB /)

RGHG1(:,59, 9) = (/ &
  & 0.37098053E-03_JPRB, 0.37098129E-03_JPRB, 0.37098172E-03_JPRB, 0.37098216E-03_JPRB, 0.37098274E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098365E-03_JPRB, 0.37098385E-03_JPRB, 0.37098402E-03_JPRB, 0.37098414E-03_JPRB, 0.37098426E-03_JPRB, 0.37098434E-03_JPRB, &
  & 0.37098443E-03_JPRB, 0.37098455E-03_JPRB, 0.37098466E-03_JPRB, 0.37098484E-03_JPRB, 0.37098498E-03_JPRB, 0.37098501E-03_JPRB, &
  & 0.37098496E-03_JPRB, 0.37098484E-03_JPRB, 0.37098490E-03_JPRB, 0.37098536E-03_JPRB, 0.37098624E-03_JPRB, 0.37098775E-03_JPRB, &
  & 0.37098929E-03_JPRB, 0.37099081E-03_JPRB, 0.37099229E-03_JPRB, 0.37099345E-03_JPRB, 0.37099468E-03_JPRB, 0.37099564E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099759E-03_JPRB, 0.37099814E-03_JPRB, 0.37099837E-03_JPRB, 0.37099852E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099794E-03_JPRB, 0.37099756E-03_JPRB, 0.37099695E-03_JPRB, 0.37099636E-03_JPRB, 0.37099572E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099415E-03_JPRB, 0.37099372E-03_JPRB, 0.37099328E-03_JPRB, 0.37099293E-03_JPRB, 0.37099246E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099177E-03_JPRB, 0.37099165E-03_JPRB, 0.37099153E-03_JPRB, 0.37099142E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37099136E-03_JPRB, 0.37099133E-03_JPRB, 0.37099127E-03_JPRB, 0.37099118E-03_JPRB, 0.37099118E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099107E-03_JPRB, 0.37099101E-03_JPRB, 0.37099089E-03_JPRB, 0.37099075E-03_JPRB /)

RGHG1(:,60, 9) = (/ &
  & 0.37098248E-03_JPRB, 0.37098309E-03_JPRB, 0.37098338E-03_JPRB, 0.37098367E-03_JPRB, 0.37098402E-03_JPRB, 0.37098443E-03_JPRB, &
  & 0.37098466E-03_JPRB, 0.37098487E-03_JPRB, 0.37098501E-03_JPRB, 0.37098504E-03_JPRB, 0.37098510E-03_JPRB, 0.37098522E-03_JPRB, &
  & 0.37098533E-03_JPRB, 0.37098542E-03_JPRB, 0.37098565E-03_JPRB, 0.37098586E-03_JPRB, 0.37098603E-03_JPRB, 0.37098606E-03_JPRB, &
  & 0.37098597E-03_JPRB, 0.37098583E-03_JPRB, 0.37098580E-03_JPRB, 0.37098621E-03_JPRB, 0.37098699E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37099124E-03_JPRB, 0.37099258E-03_JPRB, 0.37099374E-03_JPRB, 0.37099485E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099776E-03_JPRB, 0.37099826E-03_JPRB, 0.37099855E-03_JPRB, 0.37099872E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099785E-03_JPRB, 0.37099730E-03_JPRB, 0.37099671E-03_JPRB, 0.37099604E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099468E-03_JPRB, 0.37099418E-03_JPRB, 0.37099377E-03_JPRB, 0.37099348E-03_JPRB, 0.37099308E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099261E-03_JPRB, 0.37099235E-03_JPRB, 0.37099226E-03_JPRB, 0.37099217E-03_JPRB, 0.37099211E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099194E-03_JPRB, 0.37099188E-03_JPRB, 0.37099179E-03_JPRB, 0.37099174E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099142E-03_JPRB, 0.37099136E-03_JPRB, 0.37099124E-03_JPRB /)

RGHG1(:,61, 9) = (/ &
  & 0.37098397E-03_JPRB, 0.37098443E-03_JPRB, 0.37098472E-03_JPRB, 0.37098496E-03_JPRB, 0.37098525E-03_JPRB, 0.37098548E-03_JPRB, &
  & 0.37098571E-03_JPRB, 0.37098580E-03_JPRB, 0.37098586E-03_JPRB, 0.37098586E-03_JPRB, 0.37098589E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098612E-03_JPRB, 0.37098624E-03_JPRB, 0.37098644E-03_JPRB, 0.37098673E-03_JPRB, 0.37098699E-03_JPRB, 0.37098717E-03_JPRB, &
  & 0.37098705E-03_JPRB, 0.37098679E-03_JPRB, 0.37098679E-03_JPRB, 0.37098723E-03_JPRB, 0.37098784E-03_JPRB, 0.37098906E-03_JPRB, &
  & 0.37099034E-03_JPRB, 0.37099162E-03_JPRB, 0.37099299E-03_JPRB, 0.37099404E-03_JPRB, 0.37099520E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099715E-03_JPRB, 0.37099799E-03_JPRB, 0.37099846E-03_JPRB, 0.37099872E-03_JPRB, 0.37099904E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099799E-03_JPRB, 0.37099756E-03_JPRB, 0.37099709E-03_JPRB, 0.37099648E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099514E-03_JPRB, 0.37099468E-03_JPRB, 0.37099430E-03_JPRB, 0.37099389E-03_JPRB, 0.37099366E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099313E-03_JPRB, 0.37099293E-03_JPRB, 0.37099290E-03_JPRB, 0.37099281E-03_JPRB, 0.37099276E-03_JPRB, 0.37099258E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099235E-03_JPRB, 0.37099223E-03_JPRB, 0.37099217E-03_JPRB, 0.37099206E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099191E-03_JPRB, 0.37099179E-03_JPRB, 0.37099171E-03_JPRB, 0.37099159E-03_JPRB /)

RGHG1(:,62, 9) = (/ &
  & 0.37098533E-03_JPRB, 0.37098571E-03_JPRB, 0.37098589E-03_JPRB, 0.37098603E-03_JPRB, 0.37098624E-03_JPRB, 0.37098641E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098667E-03_JPRB, 0.37098676E-03_JPRB, 0.37098682E-03_JPRB, 0.37098682E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098691E-03_JPRB, 0.37098693E-03_JPRB, 0.37098723E-03_JPRB, 0.37098769E-03_JPRB, 0.37098795E-03_JPRB, 0.37098821E-03_JPRB, &
  & 0.37098804E-03_JPRB, 0.37098792E-03_JPRB, 0.37098787E-03_JPRB, 0.37098819E-03_JPRB, 0.37098862E-03_JPRB, 0.37098967E-03_JPRB, &
  & 0.37099083E-03_JPRB, 0.37099209E-03_JPRB, 0.37099337E-03_JPRB, 0.37099441E-03_JPRB, 0.37099558E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099823E-03_JPRB, 0.37099866E-03_JPRB, 0.37099898E-03_JPRB, 0.37099925E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099826E-03_JPRB, 0.37099791E-03_JPRB, 0.37099741E-03_JPRB, 0.37099683E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099558E-03_JPRB, 0.37099514E-03_JPRB, 0.37099479E-03_JPRB, 0.37099447E-03_JPRB, 0.37099424E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099348E-03_JPRB, 0.37099345E-03_JPRB, 0.37099340E-03_JPRB, 0.37099331E-03_JPRB, 0.37099319E-03_JPRB, &
  & 0.37099305E-03_JPRB, 0.37099293E-03_JPRB, 0.37099281E-03_JPRB, 0.37099270E-03_JPRB, 0.37099258E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099229E-03_JPRB, 0.37099220E-03_JPRB, 0.37099203E-03_JPRB /)

RGHG1(:,63, 9) = (/ &
  & 0.37098641E-03_JPRB, 0.37098676E-03_JPRB, 0.37098693E-03_JPRB, 0.37098711E-03_JPRB, 0.37098728E-03_JPRB, 0.37098740E-03_JPRB, &
  & 0.37098752E-03_JPRB, 0.37098757E-03_JPRB, 0.37098763E-03_JPRB, 0.37098769E-03_JPRB, 0.37098769E-03_JPRB, 0.37098763E-03_JPRB, &
  & 0.37098766E-03_JPRB, 0.37098763E-03_JPRB, 0.37098798E-03_JPRB, 0.37098868E-03_JPRB, 0.37098891E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37098906E-03_JPRB, 0.37098886E-03_JPRB, 0.37098883E-03_JPRB, 0.37098903E-03_JPRB, 0.37098950E-03_JPRB, 0.37099043E-03_JPRB, &
  & 0.37099147E-03_JPRB, 0.37099267E-03_JPRB, 0.37099386E-03_JPRB, 0.37099485E-03_JPRB, 0.37099593E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099840E-03_JPRB, 0.37099887E-03_JPRB, 0.37099927E-03_JPRB, 0.37099951E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37099855E-03_JPRB, 0.37099814E-03_JPRB, 0.37099776E-03_JPRB, 0.37099724E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099567E-03_JPRB, 0.37099537E-03_JPRB, 0.37099500E-03_JPRB, 0.37099473E-03_JPRB, 0.37099441E-03_JPRB, &
  & 0.37099421E-03_JPRB, 0.37099404E-03_JPRB, 0.37099404E-03_JPRB, 0.37099404E-03_JPRB, 0.37099398E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, 0.37099316E-03_JPRB, 0.37099293E-03_JPRB, 0.37099278E-03_JPRB, &
  & 0.37099267E-03_JPRB, 0.37099258E-03_JPRB, 0.37099252E-03_JPRB, 0.37099238E-03_JPRB /)

RGHG1(:,64, 9) = (/ &
  & 0.37098734E-03_JPRB, 0.37098760E-03_JPRB, 0.37098775E-03_JPRB, 0.37098787E-03_JPRB, 0.37098804E-03_JPRB, 0.37098821E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098839E-03_JPRB, 0.37098842E-03_JPRB, 0.37098845E-03_JPRB, 0.37098845E-03_JPRB, 0.37098845E-03_JPRB, &
  & 0.37098833E-03_JPRB, 0.37098821E-03_JPRB, 0.37098877E-03_JPRB, 0.37098961E-03_JPRB, 0.37098990E-03_JPRB, 0.37099022E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37098979E-03_JPRB, 0.37098973E-03_JPRB, 0.37098990E-03_JPRB, 0.37099034E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099214E-03_JPRB, 0.37099322E-03_JPRB, 0.37099441E-03_JPRB, 0.37099537E-03_JPRB, 0.37099631E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099875E-03_JPRB, 0.37099910E-03_JPRB, 0.37099951E-03_JPRB, 0.37099959E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099881E-03_JPRB, 0.37099849E-03_JPRB, 0.37099799E-03_JPRB, 0.37099759E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099657E-03_JPRB, 0.37099625E-03_JPRB, 0.37099596E-03_JPRB, 0.37099549E-03_JPRB, 0.37099520E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099471E-03_JPRB, 0.37099468E-03_JPRB, 0.37099468E-03_JPRB, 0.37099456E-03_JPRB, 0.37099438E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099392E-03_JPRB, 0.37099374E-03_JPRB, 0.37099360E-03_JPRB, 0.37099340E-03_JPRB, 0.37099325E-03_JPRB, &
  & 0.37099310E-03_JPRB, 0.37099299E-03_JPRB, 0.37099287E-03_JPRB, 0.37099267E-03_JPRB /)

RGHG1(:,65, 9) = (/ &
  & 0.37098824E-03_JPRB, 0.37098851E-03_JPRB, 0.37098862E-03_JPRB, 0.37098874E-03_JPRB, 0.37098891E-03_JPRB, 0.37098909E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37098926E-03_JPRB, 0.37098932E-03_JPRB, 0.37098938E-03_JPRB, 0.37098935E-03_JPRB, 0.37098912E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098868E-03_JPRB, 0.37098938E-03_JPRB, 0.37099046E-03_JPRB, 0.37099089E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099104E-03_JPRB, 0.37099078E-03_JPRB, 0.37099072E-03_JPRB, 0.37099072E-03_JPRB, 0.37099110E-03_JPRB, 0.37099179E-03_JPRB, &
  & 0.37099278E-03_JPRB, 0.37099377E-03_JPRB, 0.37099485E-03_JPRB, 0.37099584E-03_JPRB, 0.37099677E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099907E-03_JPRB, 0.37099930E-03_JPRB, 0.37099968E-03_JPRB, 0.37099977E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099904E-03_JPRB, 0.37099878E-03_JPRB, 0.37099840E-03_JPRB, 0.37099796E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099680E-03_JPRB, 0.37099639E-03_JPRB, 0.37099601E-03_JPRB, 0.37099572E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099529E-03_JPRB, 0.37099526E-03_JPRB, 0.37099514E-03_JPRB, 0.37099514E-03_JPRB, 0.37099494E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099450E-03_JPRB, 0.37099424E-03_JPRB, 0.37099409E-03_JPRB, 0.37099389E-03_JPRB, 0.37099369E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099328E-03_JPRB, 0.37099313E-03_JPRB, 0.37099284E-03_JPRB /)

RGHG1(:,66, 9) = (/ &
  & 0.37098909E-03_JPRB, 0.37098935E-03_JPRB, 0.37098950E-03_JPRB, 0.37098961E-03_JPRB, 0.37098976E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37099014E-03_JPRB, 0.37099014E-03_JPRB, 0.37099014E-03_JPRB, 0.37099014E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37098906E-03_JPRB, 0.37099014E-03_JPRB, 0.37099127E-03_JPRB, 0.37099182E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099165E-03_JPRB, 0.37099153E-03_JPRB, 0.37099159E-03_JPRB, 0.37099182E-03_JPRB, 0.37099249E-03_JPRB, &
  & 0.37099337E-03_JPRB, 0.37099436E-03_JPRB, 0.37099537E-03_JPRB, 0.37099628E-03_JPRB, 0.37099721E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099927E-03_JPRB, 0.37099954E-03_JPRB, 0.37099986E-03_JPRB, 0.37099994E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099930E-03_JPRB, 0.37099907E-03_JPRB, 0.37099872E-03_JPRB, 0.37099834E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099715E-03_JPRB, 0.37099692E-03_JPRB, 0.37099651E-03_JPRB, 0.37099625E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099587E-03_JPRB, 0.37099590E-03_JPRB, 0.37099578E-03_JPRB, 0.37099572E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099540E-03_JPRB, 0.37099514E-03_JPRB, 0.37099479E-03_JPRB, 0.37099465E-03_JPRB, 0.37099433E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099369E-03_JPRB, 0.37099348E-03_JPRB, 0.37099313E-03_JPRB /)

RGHG1(:,67, 9) = (/ &
  & 0.37098984E-03_JPRB, 0.37099008E-03_JPRB, 0.37099019E-03_JPRB, 0.37099037E-03_JPRB, 0.37099054E-03_JPRB, 0.37099066E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099089E-03_JPRB, 0.37099095E-03_JPRB, 0.37099098E-03_JPRB, 0.37099101E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37098941E-03_JPRB, 0.37099069E-03_JPRB, 0.37099209E-03_JPRB, 0.37099276E-03_JPRB, 0.37099308E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099276E-03_JPRB, 0.37099249E-03_JPRB, 0.37099252E-03_JPRB, 0.37099270E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099491E-03_JPRB, 0.37099590E-03_JPRB, 0.37099677E-03_JPRB, 0.37099759E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099957E-03_JPRB, 0.37099974E-03_JPRB, 0.37099994E-03_JPRB, 0.37100009E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099951E-03_JPRB, 0.37099930E-03_JPRB, 0.37099898E-03_JPRB, 0.37099866E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099791E-03_JPRB, 0.37099759E-03_JPRB, 0.37099735E-03_JPRB, 0.37099695E-03_JPRB, 0.37099677E-03_JPRB, 0.37099651E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099648E-03_JPRB, 0.37099660E-03_JPRB, 0.37099639E-03_JPRB, 0.37099625E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099572E-03_JPRB, 0.37099535E-03_JPRB, 0.37099520E-03_JPRB, 0.37099473E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099404E-03_JPRB, 0.37099377E-03_JPRB, 0.37099328E-03_JPRB /)

RGHG1(:,68, 9) = (/ &
  & 0.37099048E-03_JPRB, 0.37099078E-03_JPRB, 0.37099092E-03_JPRB, 0.37099113E-03_JPRB, 0.37099130E-03_JPRB, 0.37099147E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099177E-03_JPRB, 0.37099179E-03_JPRB, 0.37099179E-03_JPRB, 0.37099171E-03_JPRB, 0.37099110E-03_JPRB, &
  & 0.37099019E-03_JPRB, 0.37098967E-03_JPRB, 0.37099136E-03_JPRB, 0.37099287E-03_JPRB, 0.37099357E-03_JPRB, 0.37099389E-03_JPRB, &
  & 0.37099389E-03_JPRB, 0.37099366E-03_JPRB, 0.37099340E-03_JPRB, 0.37099345E-03_JPRB, 0.37099351E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099552E-03_JPRB, 0.37099642E-03_JPRB, 0.37099724E-03_JPRB, 0.37099799E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099974E-03_JPRB, 0.37099997E-03_JPRB, 0.37100009E-03_JPRB, 0.37100023E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099977E-03_JPRB, 0.37099962E-03_JPRB, 0.37099930E-03_JPRB, 0.37099890E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099802E-03_JPRB, 0.37099782E-03_JPRB, 0.37099741E-03_JPRB, 0.37099724E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099700E-03_JPRB, 0.37099709E-03_JPRB, 0.37099695E-03_JPRB, 0.37099683E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099619E-03_JPRB, 0.37099590E-03_JPRB, 0.37099567E-03_JPRB, 0.37099523E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099444E-03_JPRB, 0.37099412E-03_JPRB, 0.37099351E-03_JPRB /)

RGHG1(:,69, 9) = (/ &
  & 0.37099115E-03_JPRB, 0.37099142E-03_JPRB, 0.37099165E-03_JPRB, 0.37099188E-03_JPRB, 0.37099211E-03_JPRB, 0.37099235E-03_JPRB, &
  & 0.37099246E-03_JPRB, 0.37099258E-03_JPRB, 0.37099255E-03_JPRB, 0.37099258E-03_JPRB, 0.37099252E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099040E-03_JPRB, 0.37098967E-03_JPRB, 0.37099168E-03_JPRB, 0.37099354E-03_JPRB, 0.37099444E-03_JPRB, 0.37099473E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099462E-03_JPRB, 0.37099444E-03_JPRB, 0.37099436E-03_JPRB, 0.37099427E-03_JPRB, 0.37099479E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099616E-03_JPRB, 0.37099698E-03_JPRB, 0.37099773E-03_JPRB, 0.37099843E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099997E-03_JPRB, 0.37100015E-03_JPRB, 0.37100018E-03_JPRB, 0.37100035E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37099991E-03_JPRB, 0.37099983E-03_JPRB, 0.37099962E-03_JPRB, 0.37099919E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099843E-03_JPRB, 0.37099826E-03_JPRB, 0.37099794E-03_JPRB, 0.37099770E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099764E-03_JPRB, 0.37099764E-03_JPRB, 0.37099747E-03_JPRB, 0.37099744E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099703E-03_JPRB, 0.37099671E-03_JPRB, 0.37099631E-03_JPRB, 0.37099616E-03_JPRB, 0.37099569E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099491E-03_JPRB, 0.37099456E-03_JPRB, 0.37099386E-03_JPRB /)

RGHG1(:,70, 9) = (/ &
  & 0.37099177E-03_JPRB, 0.37099200E-03_JPRB, 0.37099229E-03_JPRB, 0.37099267E-03_JPRB, 0.37099302E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099340E-03_JPRB, 0.37099328E-03_JPRB, 0.37099325E-03_JPRB, 0.37099319E-03_JPRB, 0.37099220E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099025E-03_JPRB, 0.37099270E-03_JPRB, 0.37099447E-03_JPRB, 0.37099532E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099552E-03_JPRB, 0.37099532E-03_JPRB, 0.37099526E-03_JPRB, 0.37099503E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099668E-03_JPRB, 0.37099738E-03_JPRB, 0.37099808E-03_JPRB, 0.37099872E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100021E-03_JPRB, 0.37100035E-03_JPRB, 0.37100023E-03_JPRB, 0.37100044E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100009E-03_JPRB, 0.37100012E-03_JPRB, 0.37099994E-03_JPRB, 0.37099942E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099881E-03_JPRB, 0.37099869E-03_JPRB, 0.37099849E-03_JPRB, 0.37099811E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099808E-03_JPRB, 0.37099814E-03_JPRB, 0.37099796E-03_JPRB, 0.37099794E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099724E-03_JPRB, 0.37099695E-03_JPRB, 0.37099677E-03_JPRB, 0.37099622E-03_JPRB, 0.37099590E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099543E-03_JPRB, 0.37099503E-03_JPRB, 0.37099424E-03_JPRB /)

RGHG1(:,71, 9) = (/ &
  & 0.37099252E-03_JPRB, 0.37099261E-03_JPRB, 0.37099293E-03_JPRB, 0.37099340E-03_JPRB, 0.37099392E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099421E-03_JPRB, 0.37099404E-03_JPRB, 0.37099401E-03_JPRB, 0.37099383E-03_JPRB, 0.37099267E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098883E-03_JPRB, 0.37099241E-03_JPRB, 0.37099508E-03_JPRB, 0.37099619E-03_JPRB, 0.37099633E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099642E-03_JPRB, 0.37099625E-03_JPRB, 0.37099601E-03_JPRB, 0.37099572E-03_JPRB, 0.37099619E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099724E-03_JPRB, 0.37099788E-03_JPRB, 0.37099849E-03_JPRB, 0.37099904E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100032E-03_JPRB, 0.37100055E-03_JPRB, 0.37100026E-03_JPRB, 0.37100050E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100021E-03_JPRB, 0.37100032E-03_JPRB, 0.37100015E-03_JPRB, 0.37099971E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099916E-03_JPRB, 0.37099919E-03_JPRB, 0.37099898E-03_JPRB, 0.37099863E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099858E-03_JPRB, 0.37099860E-03_JPRB, 0.37099840E-03_JPRB, 0.37099840E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099773E-03_JPRB, 0.37099753E-03_JPRB, 0.37099730E-03_JPRB, 0.37099671E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099601E-03_JPRB, 0.37099567E-03_JPRB, 0.37099479E-03_JPRB /)

RGHG1(:,72, 9) = (/ &
  & 0.37099331E-03_JPRB, 0.37099331E-03_JPRB, 0.37099357E-03_JPRB, 0.37099424E-03_JPRB, 0.37099488E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099503E-03_JPRB, 0.37099488E-03_JPRB, 0.37099465E-03_JPRB, 0.37099453E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099191E-03_JPRB, 0.37099078E-03_JPRB, 0.37099415E-03_JPRB, 0.37099604E-03_JPRB, 0.37099695E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099730E-03_JPRB, 0.37099700E-03_JPRB, 0.37099680E-03_JPRB, 0.37099636E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099767E-03_JPRB, 0.37099828E-03_JPRB, 0.37099890E-03_JPRB, 0.37099927E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100050E-03_JPRB, 0.37100079E-03_JPRB, 0.37100029E-03_JPRB, 0.37100061E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100035E-03_JPRB, 0.37100061E-03_JPRB, 0.37100044E-03_JPRB, 0.37099994E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37099951E-03_JPRB, 0.37099959E-03_JPRB, 0.37099939E-03_JPRB, 0.37099895E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099901E-03_JPRB, 0.37099898E-03_JPRB, 0.37099887E-03_JPRB, 0.37099901E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099823E-03_JPRB, 0.37099796E-03_JPRB, 0.37099773E-03_JPRB, 0.37099715E-03_JPRB, 0.37099674E-03_JPRB, &
  & 0.37099703E-03_JPRB, 0.37099665E-03_JPRB, 0.37099628E-03_JPRB, 0.37099535E-03_JPRB /)

RGHG1(:,73, 9) = (/ &
  & 0.37099427E-03_JPRB, 0.37099395E-03_JPRB, 0.37099421E-03_JPRB, 0.37099503E-03_JPRB, 0.37099584E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099584E-03_JPRB, 0.37099564E-03_JPRB, 0.37099529E-03_JPRB, 0.37099500E-03_JPRB, 0.37099331E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098702E-03_JPRB, 0.37099348E-03_JPRB, 0.37099680E-03_JPRB, 0.37099767E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099817E-03_JPRB, 0.37099785E-03_JPRB, 0.37099747E-03_JPRB, 0.37099689E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099811E-03_JPRB, 0.37099866E-03_JPRB, 0.37099930E-03_JPRB, 0.37099951E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100067E-03_JPRB, 0.37100102E-03_JPRB, 0.37100029E-03_JPRB, 0.37100067E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100035E-03_JPRB, 0.37100085E-03_JPRB, 0.37100067E-03_JPRB, 0.37100023E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37099977E-03_JPRB, 0.37100000E-03_JPRB, 0.37099986E-03_JPRB, 0.37099930E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099939E-03_JPRB, 0.37099945E-03_JPRB, 0.37099922E-03_JPRB, 0.37099942E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099860E-03_JPRB, 0.37099837E-03_JPRB, 0.37099808E-03_JPRB, 0.37099759E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099732E-03_JPRB, 0.37099695E-03_JPRB, 0.37099604E-03_JPRB /)

RGHG1(:,74, 9) = (/ &
  & 0.37099529E-03_JPRB, 0.37099456E-03_JPRB, 0.37099473E-03_JPRB, 0.37099578E-03_JPRB, 0.37099692E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099660E-03_JPRB, 0.37099636E-03_JPRB, 0.37099590E-03_JPRB, 0.37099572E-03_JPRB, 0.37099430E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099081E-03_JPRB, 0.37099546E-03_JPRB, 0.37099779E-03_JPRB, 0.37099849E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099904E-03_JPRB, 0.37099869E-03_JPRB, 0.37099834E-03_JPRB, 0.37099747E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099855E-03_JPRB, 0.37099913E-03_JPRB, 0.37099974E-03_JPRB, 0.37099968E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100088E-03_JPRB, 0.37100137E-03_JPRB, 0.37100021E-03_JPRB, 0.37100088E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100041E-03_JPRB, 0.37100117E-03_JPRB, 0.37100090E-03_JPRB, 0.37100053E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100006E-03_JPRB, 0.37100038E-03_JPRB, 0.37100026E-03_JPRB, 0.37099968E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099974E-03_JPRB, 0.37099983E-03_JPRB, 0.37099948E-03_JPRB, 0.37099983E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099890E-03_JPRB, 0.37099866E-03_JPRB, 0.37099837E-03_JPRB, 0.37099796E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099808E-03_JPRB, 0.37099759E-03_JPRB, 0.37099680E-03_JPRB /)

RGHG1(:,75, 9) = (/ &
  & 0.37099642E-03_JPRB, 0.37099508E-03_JPRB, 0.37099523E-03_JPRB, 0.37099665E-03_JPRB, 0.37099811E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099727E-03_JPRB, 0.37099695E-03_JPRB, 0.37099636E-03_JPRB, 0.37099578E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37098752E-03_JPRB, 0.37098408E-03_JPRB, 0.37099468E-03_JPRB, 0.37099852E-03_JPRB, 0.37099919E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37099980E-03_JPRB, 0.37099939E-03_JPRB, 0.37099893E-03_JPRB, 0.37099794E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099884E-03_JPRB, 0.37099948E-03_JPRB, 0.37100026E-03_JPRB, 0.37099989E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100090E-03_JPRB, 0.37100166E-03_JPRB, 0.37100009E-03_JPRB, 0.37100090E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100035E-03_JPRB, 0.37100137E-03_JPRB, 0.37100111E-03_JPRB, 0.37100085E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100018E-03_JPRB, 0.37100070E-03_JPRB, 0.37100055E-03_JPRB, 0.37099994E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100015E-03_JPRB, 0.37100021E-03_JPRB, 0.37099962E-03_JPRB, 0.37100009E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099916E-03_JPRB, 0.37099893E-03_JPRB, 0.37099863E-03_JPRB, 0.37099828E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099881E-03_JPRB, 0.37099808E-03_JPRB, 0.37099753E-03_JPRB /)

RGHG1(:,76, 9) = (/ &
  & 0.37099762E-03_JPRB, 0.37099537E-03_JPRB, 0.37099549E-03_JPRB, 0.37099721E-03_JPRB, 0.37099927E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099799E-03_JPRB, 0.37099759E-03_JPRB, 0.37099677E-03_JPRB, 0.37099663E-03_JPRB, 0.37099473E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37098984E-03_JPRB, 0.37099651E-03_JPRB, 0.37099957E-03_JPRB, 0.37099997E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100053E-03_JPRB, 0.37100009E-03_JPRB, 0.37099962E-03_JPRB, 0.37099823E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37099919E-03_JPRB, 0.37099983E-03_JPRB, 0.37100070E-03_JPRB, 0.37100015E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100102E-03_JPRB, 0.37100201E-03_JPRB, 0.37099991E-03_JPRB, 0.37100114E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100026E-03_JPRB, 0.37100166E-03_JPRB, 0.37100134E-03_JPRB, 0.37100125E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100038E-03_JPRB, 0.37100105E-03_JPRB, 0.37100096E-03_JPRB, 0.37100018E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100050E-03_JPRB, 0.37100050E-03_JPRB, 0.37099968E-03_JPRB, 0.37100026E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099925E-03_JPRB, 0.37099916E-03_JPRB, 0.37099878E-03_JPRB, 0.37099863E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099965E-03_JPRB, 0.37099863E-03_JPRB, 0.37099820E-03_JPRB /)

RGHG1(:,77, 9) = (/ &
  & 0.37099898E-03_JPRB, 0.37099555E-03_JPRB, 0.37099555E-03_JPRB, 0.37099782E-03_JPRB, 0.37100082E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099884E-03_JPRB, 0.37099811E-03_JPRB, 0.37099700E-03_JPRB, 0.37099680E-03_JPRB, 0.37099418E-03_JPRB, &
  & 0.37098641E-03_JPRB, 0.37098004E-03_JPRB, 0.37099601E-03_JPRB, 0.37100026E-03_JPRB, 0.37100076E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100114E-03_JPRB, 0.37100064E-03_JPRB, 0.37100015E-03_JPRB, 0.37099846E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37099948E-03_JPRB, 0.37100026E-03_JPRB, 0.37100128E-03_JPRB, 0.37100032E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100117E-03_JPRB, 0.37100245E-03_JPRB, 0.37099959E-03_JPRB, 0.37100114E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100009E-03_JPRB, 0.37100189E-03_JPRB, 0.37100149E-03_JPRB, 0.37100163E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100055E-03_JPRB, 0.37100131E-03_JPRB, 0.37100146E-03_JPRB, 0.37100041E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100082E-03_JPRB, 0.37100082E-03_JPRB, 0.37099962E-03_JPRB, 0.37100050E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099939E-03_JPRB, 0.37099930E-03_JPRB, 0.37099881E-03_JPRB, 0.37099884E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100050E-03_JPRB, 0.37099898E-03_JPRB, 0.37099887E-03_JPRB /)

RGHG1(:,78, 9) = (/ &
  & 0.37100050E-03_JPRB, 0.37099567E-03_JPRB, 0.37099543E-03_JPRB, 0.37099817E-03_JPRB, 0.37100250E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099962E-03_JPRB, 0.37099872E-03_JPRB, 0.37099712E-03_JPRB, 0.37099750E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099057E-03_JPRB, 0.37098589E-03_JPRB, 0.37099770E-03_JPRB, 0.37100122E-03_JPRB, 0.37100149E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100172E-03_JPRB, 0.37100117E-03_JPRB, 0.37100067E-03_JPRB, 0.37099858E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37099968E-03_JPRB, 0.37100061E-03_JPRB, 0.37100178E-03_JPRB, 0.37100058E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100122E-03_JPRB, 0.37100285E-03_JPRB, 0.37099927E-03_JPRB, 0.37100146E-03_JPRB, 0.37100152E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100009E-03_JPRB, 0.37100221E-03_JPRB, 0.37100166E-03_JPRB, 0.37100198E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100064E-03_JPRB, 0.37100154E-03_JPRB, 0.37100189E-03_JPRB, 0.37100061E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100125E-03_JPRB, 0.37100114E-03_JPRB, 0.37099951E-03_JPRB, 0.37100073E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099942E-03_JPRB, 0.37099939E-03_JPRB, 0.37099869E-03_JPRB, 0.37099904E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100120E-03_JPRB, 0.37099927E-03_JPRB, 0.37099962E-03_JPRB /)

RGHG1(:,79, 9) = (/ &
  & 0.37100198E-03_JPRB, 0.37099529E-03_JPRB, 0.37099491E-03_JPRB, 0.37099826E-03_JPRB, 0.37100393E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100029E-03_JPRB, 0.37099904E-03_JPRB, 0.37099692E-03_JPRB, 0.37099773E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37098865E-03_JPRB, 0.37099866E-03_JPRB, 0.37100192E-03_JPRB, 0.37100213E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37100259E-03_JPRB, 0.37100218E-03_JPRB, 0.37100157E-03_JPRB, 0.37100108E-03_JPRB, 0.37099852E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37099991E-03_JPRB, 0.37100102E-03_JPRB, 0.37100218E-03_JPRB, 0.37100070E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100137E-03_JPRB, 0.37100335E-03_JPRB, 0.37099913E-03_JPRB, 0.37100181E-03_JPRB, 0.37100195E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100012E-03_JPRB, 0.37100250E-03_JPRB, 0.37100186E-03_JPRB, 0.37100233E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100079E-03_JPRB, 0.37100181E-03_JPRB, 0.37100227E-03_JPRB, 0.37100070E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100149E-03_JPRB, 0.37100131E-03_JPRB, 0.37099933E-03_JPRB, 0.37100099E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099942E-03_JPRB, 0.37099942E-03_JPRB, 0.37099852E-03_JPRB, 0.37099910E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100186E-03_JPRB, 0.37099939E-03_JPRB, 0.37100021E-03_JPRB /)

RGHG1(:,80, 9) = (/ &
  & 0.37100341E-03_JPRB, 0.37099494E-03_JPRB, 0.37099438E-03_JPRB, 0.37099820E-03_JPRB, 0.37100486E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100058E-03_JPRB, 0.37099907E-03_JPRB, 0.37099668E-03_JPRB, 0.37099776E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099325E-03_JPRB, 0.37098982E-03_JPRB, 0.37099913E-03_JPRB, 0.37100236E-03_JPRB, 0.37100242E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37100309E-03_JPRB, 0.37100253E-03_JPRB, 0.37100189E-03_JPRB, 0.37100137E-03_JPRB, 0.37099843E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100277E-03_JPRB, 0.37099994E-03_JPRB, 0.37100117E-03_JPRB, 0.37100245E-03_JPRB, 0.37100093E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100152E-03_JPRB, 0.37100379E-03_JPRB, 0.37099904E-03_JPRB, 0.37100207E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100015E-03_JPRB, 0.37100280E-03_JPRB, 0.37100216E-03_JPRB, 0.37100259E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100088E-03_JPRB, 0.37100207E-03_JPRB, 0.37100271E-03_JPRB, 0.37100090E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100172E-03_JPRB, 0.37100160E-03_JPRB, 0.37099922E-03_JPRB, 0.37100117E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099933E-03_JPRB, 0.37099933E-03_JPRB, 0.37099834E-03_JPRB, 0.37099913E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37100146E-03_JPRB, 0.37100227E-03_JPRB, 0.37099945E-03_JPRB, 0.37100076E-03_JPRB /)

RGHG1(:,81, 9) = (/ &
  & 0.37100501E-03_JPRB, 0.37099471E-03_JPRB, 0.37099406E-03_JPRB, 0.37099814E-03_JPRB, 0.37100542E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100070E-03_JPRB, 0.37099919E-03_JPRB, 0.37099651E-03_JPRB, 0.37099767E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099031E-03_JPRB, 0.37099930E-03_JPRB, 0.37100265E-03_JPRB, 0.37100274E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37100335E-03_JPRB, 0.37100277E-03_JPRB, 0.37100213E-03_JPRB, 0.37100149E-03_JPRB, 0.37099831E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100297E-03_JPRB, 0.37100009E-03_JPRB, 0.37100131E-03_JPRB, 0.37100262E-03_JPRB, 0.37100105E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100160E-03_JPRB, 0.37100396E-03_JPRB, 0.37099887E-03_JPRB, 0.37100218E-03_JPRB, 0.37100253E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100023E-03_JPRB, 0.37100297E-03_JPRB, 0.37100230E-03_JPRB, 0.37100271E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100096E-03_JPRB, 0.37100218E-03_JPRB, 0.37100294E-03_JPRB, 0.37100099E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100189E-03_JPRB, 0.37100184E-03_JPRB, 0.37099922E-03_JPRB, 0.37100131E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099927E-03_JPRB, 0.37099930E-03_JPRB, 0.37099826E-03_JPRB, 0.37099910E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37100154E-03_JPRB, 0.37100253E-03_JPRB, 0.37099948E-03_JPRB, 0.37100131E-03_JPRB /)

RGHG1(:,82, 9) = (/ &
  & 0.37100521E-03_JPRB, 0.37099447E-03_JPRB, 0.37099389E-03_JPRB, 0.37099811E-03_JPRB, 0.37100574E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100076E-03_JPRB, 0.37099881E-03_JPRB, 0.37099657E-03_JPRB, 0.37099753E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099054E-03_JPRB, 0.37099939E-03_JPRB, 0.37100282E-03_JPRB, 0.37100285E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37100352E-03_JPRB, 0.37100306E-03_JPRB, 0.37100221E-03_JPRB, 0.37100154E-03_JPRB, 0.37099817E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100309E-03_JPRB, 0.37100009E-03_JPRB, 0.37100143E-03_JPRB, 0.37100268E-03_JPRB, 0.37100108E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100166E-03_JPRB, 0.37100416E-03_JPRB, 0.37099893E-03_JPRB, 0.37100233E-03_JPRB, 0.37100268E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100035E-03_JPRB, 0.37100312E-03_JPRB, 0.37100245E-03_JPRB, 0.37100274E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100102E-03_JPRB, 0.37100242E-03_JPRB, 0.37100312E-03_JPRB, 0.37100102E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100201E-03_JPRB, 0.37100192E-03_JPRB, 0.37099901E-03_JPRB, 0.37100140E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099922E-03_JPRB, 0.37099927E-03_JPRB, 0.37099817E-03_JPRB, 0.37099907E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37100163E-03_JPRB, 0.37100271E-03_JPRB, 0.37099936E-03_JPRB, 0.37100134E-03_JPRB /)

RGHG1(:,83, 9) = (/ &
  & 0.37100530E-03_JPRB, 0.37099436E-03_JPRB, 0.37099374E-03_JPRB, 0.37099805E-03_JPRB, 0.37100594E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100073E-03_JPRB, 0.37099922E-03_JPRB, 0.37099654E-03_JPRB, 0.37099738E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099083E-03_JPRB, 0.37099939E-03_JPRB, 0.37100300E-03_JPRB, 0.37100297E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37100376E-03_JPRB, 0.37100317E-03_JPRB, 0.37100227E-03_JPRB, 0.37100166E-03_JPRB, 0.37099805E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100015E-03_JPRB, 0.37100152E-03_JPRB, 0.37100277E-03_JPRB, 0.37100114E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100172E-03_JPRB, 0.37100422E-03_JPRB, 0.37099893E-03_JPRB, 0.37100236E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100038E-03_JPRB, 0.37100312E-03_JPRB, 0.37100248E-03_JPRB, 0.37100277E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100105E-03_JPRB, 0.37100253E-03_JPRB, 0.37100326E-03_JPRB, 0.37100108E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100204E-03_JPRB, 0.37100198E-03_JPRB, 0.37099898E-03_JPRB, 0.37100143E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099916E-03_JPRB, 0.37099922E-03_JPRB, 0.37099808E-03_JPRB, 0.37099904E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37100175E-03_JPRB, 0.37100280E-03_JPRB, 0.37099942E-03_JPRB, 0.37100146E-03_JPRB /)

RGHG1(:,84, 9) = (/ &
  & 0.37100550E-03_JPRB, 0.37099418E-03_JPRB, 0.37099351E-03_JPRB, 0.37099805E-03_JPRB, 0.37100608E-03_JPRB, 0.37100026E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100053E-03_JPRB, 0.37099846E-03_JPRB, 0.37099671E-03_JPRB, 0.37099706E-03_JPRB, 0.37099511E-03_JPRB, &
  & 0.37099377E-03_JPRB, 0.37099150E-03_JPRB, 0.37099916E-03_JPRB, 0.37100300E-03_JPRB, 0.37100300E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37100381E-03_JPRB, 0.37100329E-03_JPRB, 0.37100233E-03_JPRB, 0.37100175E-03_JPRB, 0.37099796E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100026E-03_JPRB, 0.37100163E-03_JPRB, 0.37100285E-03_JPRB, 0.37100120E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100178E-03_JPRB, 0.37100431E-03_JPRB, 0.37099890E-03_JPRB, 0.37100248E-03_JPRB, 0.37100285E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100044E-03_JPRB, 0.37100312E-03_JPRB, 0.37100250E-03_JPRB, 0.37100271E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100108E-03_JPRB, 0.37100262E-03_JPRB, 0.37100341E-03_JPRB, 0.37100102E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100210E-03_JPRB, 0.37100204E-03_JPRB, 0.37099901E-03_JPRB, 0.37100152E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099773E-03_JPRB, 0.37099922E-03_JPRB, 0.37099919E-03_JPRB, 0.37099805E-03_JPRB, 0.37099898E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37100178E-03_JPRB, 0.37100297E-03_JPRB, 0.37099942E-03_JPRB, 0.37100149E-03_JPRB /)

RGHG1(:,85, 9) = (/ &
  & 0.37100556E-03_JPRB, 0.37099415E-03_JPRB, 0.37099340E-03_JPRB, 0.37099805E-03_JPRB, 0.37100626E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100003E-03_JPRB, 0.37099875E-03_JPRB, 0.37099677E-03_JPRB, 0.37099680E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099281E-03_JPRB, 0.37099878E-03_JPRB, 0.37100248E-03_JPRB, 0.37100274E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37100381E-03_JPRB, 0.37100326E-03_JPRB, 0.37100239E-03_JPRB, 0.37100178E-03_JPRB, 0.37099782E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100367E-03_JPRB, 0.37100018E-03_JPRB, 0.37100163E-03_JPRB, 0.37100288E-03_JPRB, 0.37100114E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100184E-03_JPRB, 0.37100443E-03_JPRB, 0.37099890E-03_JPRB, 0.37100250E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100038E-03_JPRB, 0.37100317E-03_JPRB, 0.37100256E-03_JPRB, 0.37100277E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100108E-03_JPRB, 0.37100277E-03_JPRB, 0.37100349E-03_JPRB, 0.37100102E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100218E-03_JPRB, 0.37100213E-03_JPRB, 0.37099895E-03_JPRB, 0.37100157E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099925E-03_JPRB, 0.37099916E-03_JPRB, 0.37099796E-03_JPRB, 0.37099904E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100306E-03_JPRB, 0.37099939E-03_JPRB, 0.37100154E-03_JPRB /)

RGHG1(:,86, 9) = (/ &
  & 0.37100591E-03_JPRB, 0.37099395E-03_JPRB, 0.37099322E-03_JPRB, 0.37099794E-03_JPRB, 0.37100594E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37099962E-03_JPRB, 0.37099805E-03_JPRB, 0.37099683E-03_JPRB, 0.37099648E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099421E-03_JPRB, 0.37099840E-03_JPRB, 0.37100169E-03_JPRB, 0.37100216E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37100355E-03_JPRB, 0.37100335E-03_JPRB, 0.37100242E-03_JPRB, 0.37100186E-03_JPRB, 0.37099770E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100018E-03_JPRB, 0.37100163E-03_JPRB, 0.37100294E-03_JPRB, 0.37100117E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100192E-03_JPRB, 0.37100451E-03_JPRB, 0.37099887E-03_JPRB, 0.37100268E-03_JPRB, 0.37100309E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100035E-03_JPRB, 0.37100329E-03_JPRB, 0.37100268E-03_JPRB, 0.37100280E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100114E-03_JPRB, 0.37100277E-03_JPRB, 0.37100367E-03_JPRB, 0.37100099E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100218E-03_JPRB, 0.37100213E-03_JPRB, 0.37099893E-03_JPRB, 0.37100160E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099764E-03_JPRB, 0.37099922E-03_JPRB, 0.37099907E-03_JPRB, 0.37099791E-03_JPRB, 0.37099893E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100317E-03_JPRB, 0.37099936E-03_JPRB, 0.37100157E-03_JPRB /)

RGHG1(:,87, 9) = (/ &
  & 0.37100588E-03_JPRB, 0.37099389E-03_JPRB, 0.37099319E-03_JPRB, 0.37099828E-03_JPRB, 0.37100606E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099913E-03_JPRB, 0.37099811E-03_JPRB, 0.37099677E-03_JPRB, 0.37099642E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099503E-03_JPRB, 0.37099497E-03_JPRB, 0.37099834E-03_JPRB, 0.37100102E-03_JPRB, 0.37100166E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37100338E-03_JPRB, 0.37100329E-03_JPRB, 0.37100242E-03_JPRB, 0.37100184E-03_JPRB, 0.37099759E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100408E-03_JPRB, 0.37099994E-03_JPRB, 0.37100169E-03_JPRB, 0.37100300E-03_JPRB, 0.37100108E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100204E-03_JPRB, 0.37100463E-03_JPRB, 0.37099881E-03_JPRB, 0.37100271E-03_JPRB, 0.37100315E-03_JPRB, &
  & 0.37100268E-03_JPRB, 0.37100021E-03_JPRB, 0.37100335E-03_JPRB, 0.37100271E-03_JPRB, 0.37100288E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100108E-03_JPRB, 0.37100291E-03_JPRB, 0.37100379E-03_JPRB, 0.37100099E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100218E-03_JPRB, 0.37100221E-03_JPRB, 0.37099887E-03_JPRB, 0.37100160E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099919E-03_JPRB, 0.37099910E-03_JPRB, 0.37099794E-03_JPRB, 0.37099898E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100323E-03_JPRB, 0.37099930E-03_JPRB, 0.37100160E-03_JPRB /)

RGHG1(:,88, 9) = (/ &
  & 0.37100594E-03_JPRB, 0.37099377E-03_JPRB, 0.37099316E-03_JPRB, 0.37099782E-03_JPRB, 0.37100556E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099925E-03_JPRB, 0.37099788E-03_JPRB, 0.37099689E-03_JPRB, 0.37099645E-03_JPRB, 0.37099561E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099532E-03_JPRB, 0.37099834E-03_JPRB, 0.37100099E-03_JPRB, 0.37100160E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37100332E-03_JPRB, 0.37100329E-03_JPRB, 0.37100242E-03_JPRB, 0.37100189E-03_JPRB, 0.37099741E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100434E-03_JPRB, 0.37099983E-03_JPRB, 0.37100169E-03_JPRB, 0.37100312E-03_JPRB, 0.37100099E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100204E-03_JPRB, 0.37100480E-03_JPRB, 0.37099869E-03_JPRB, 0.37100288E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37100274E-03_JPRB, 0.37100003E-03_JPRB, 0.37100364E-03_JPRB, 0.37100280E-03_JPRB, 0.37100315E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100114E-03_JPRB, 0.37100291E-03_JPRB, 0.37100390E-03_JPRB, 0.37100105E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100224E-03_JPRB, 0.37100230E-03_JPRB, 0.37099878E-03_JPRB, 0.37100166E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099913E-03_JPRB, 0.37099910E-03_JPRB, 0.37099788E-03_JPRB, 0.37099893E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100335E-03_JPRB, 0.37099933E-03_JPRB, 0.37100154E-03_JPRB /)

RGHG1(:,89, 9) = (/ &
  & 0.37100544E-03_JPRB, 0.37099398E-03_JPRB, 0.37099340E-03_JPRB, 0.37099826E-03_JPRB, 0.37100638E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099919E-03_JPRB, 0.37099805E-03_JPRB, 0.37099668E-03_JPRB, 0.37099636E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099488E-03_JPRB, 0.37099834E-03_JPRB, 0.37100114E-03_JPRB, 0.37100175E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37100344E-03_JPRB, 0.37100332E-03_JPRB, 0.37100250E-03_JPRB, 0.37100189E-03_JPRB, 0.37099735E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100445E-03_JPRB, 0.37099968E-03_JPRB, 0.37100169E-03_JPRB, 0.37100323E-03_JPRB, 0.37100096E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100079E-03_JPRB, 0.37100213E-03_JPRB, 0.37100504E-03_JPRB, 0.37099852E-03_JPRB, 0.37100294E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37099986E-03_JPRB, 0.37100381E-03_JPRB, 0.37100280E-03_JPRB, 0.37100332E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100117E-03_JPRB, 0.37100312E-03_JPRB, 0.37100402E-03_JPRB, 0.37100105E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100233E-03_JPRB, 0.37100236E-03_JPRB, 0.37099875E-03_JPRB, 0.37100172E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099916E-03_JPRB, 0.37099904E-03_JPRB, 0.37099779E-03_JPRB, 0.37099893E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37100344E-03_JPRB, 0.37099927E-03_JPRB, 0.37100166E-03_JPRB /)

RGHG1(:,90, 9) = (/ &
  & 0.37100530E-03_JPRB, 0.37099386E-03_JPRB, 0.37099319E-03_JPRB, 0.37099776E-03_JPRB, 0.37100670E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099994E-03_JPRB, 0.37099811E-03_JPRB, 0.37099671E-03_JPRB, 0.37099648E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099389E-03_JPRB, 0.37099858E-03_JPRB, 0.37100210E-03_JPRB, 0.37100250E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37100396E-03_JPRB, 0.37100335E-03_JPRB, 0.37100250E-03_JPRB, 0.37100207E-03_JPRB, 0.37099712E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100475E-03_JPRB, 0.37099957E-03_JPRB, 0.37100178E-03_JPRB, 0.37100338E-03_JPRB, 0.37100090E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100216E-03_JPRB, 0.37100547E-03_JPRB, 0.37099808E-03_JPRB, 0.37100317E-03_JPRB, 0.37100355E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37099968E-03_JPRB, 0.37100405E-03_JPRB, 0.37100282E-03_JPRB, 0.37100349E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100114E-03_JPRB, 0.37100315E-03_JPRB, 0.37100413E-03_JPRB, 0.37100105E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100236E-03_JPRB, 0.37100253E-03_JPRB, 0.37099860E-03_JPRB, 0.37100189E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099916E-03_JPRB, 0.37099910E-03_JPRB, 0.37099776E-03_JPRB, 0.37099893E-03_JPRB, 0.37099747E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100355E-03_JPRB, 0.37099913E-03_JPRB, 0.37100175E-03_JPRB /)

RGHG1(:,91, 9) = (/ &
  & 0.37100626E-03_JPRB, 0.37099328E-03_JPRB, 0.37099255E-03_JPRB, 0.37099732E-03_JPRB, 0.37100876E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37100181E-03_JPRB, 0.37099878E-03_JPRB, 0.37099532E-03_JPRB, 0.37099805E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37098891E-03_JPRB, 0.37100026E-03_JPRB, 0.37100425E-03_JPRB, 0.37100434E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37100521E-03_JPRB, 0.37100344E-03_JPRB, 0.37100245E-03_JPRB, 0.37100239E-03_JPRB, 0.37099660E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100539E-03_JPRB, 0.37099904E-03_JPRB, 0.37100181E-03_JPRB, 0.37100364E-03_JPRB, 0.37100064E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100195E-03_JPRB, 0.37100661E-03_JPRB, 0.37099686E-03_JPRB, 0.37100358E-03_JPRB, 0.37100367E-03_JPRB, &
  & 0.37100323E-03_JPRB, 0.37099904E-03_JPRB, 0.37100443E-03_JPRB, 0.37100268E-03_JPRB, 0.37100390E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100096E-03_JPRB, 0.37100329E-03_JPRB, 0.37100443E-03_JPRB, 0.37100090E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100099E-03_JPRB, 0.37100248E-03_JPRB, 0.37100280E-03_JPRB, 0.37099808E-03_JPRB, 0.37100227E-03_JPRB, 0.37099907E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099936E-03_JPRB, 0.37099925E-03_JPRB, 0.37099762E-03_JPRB, 0.37099907E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100384E-03_JPRB, 0.37099887E-03_JPRB, 0.37100181E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG1(:, 1,10) = (/ &
  & 0.35978336E-03_JPRB, 0.35967253E-03_JPRB, 0.35957948E-03_JPRB, 0.35950245E-03_JPRB, 0.35944112E-03_JPRB, 0.35940215E-03_JPRB, &
  & 0.35937881E-03_JPRB, 0.35936901E-03_JPRB, 0.35937811E-03_JPRB, 0.35941563E-03_JPRB, 0.35948912E-03_JPRB, 0.35959930E-03_JPRB, &
  & 0.35973827E-03_JPRB, 0.35990219E-03_JPRB, 0.36009250E-03_JPRB, 0.36029879E-03_JPRB, 0.36050915E-03_JPRB, 0.36071142E-03_JPRB, &
  & 0.36089227E-03_JPRB, 0.36103898E-03_JPRB, 0.36114338E-03_JPRB, 0.36120421E-03_JPRB, 0.36122667E-03_JPRB, 0.36121794E-03_JPRB, &
  & 0.36118395E-03_JPRB, 0.36112813E-03_JPRB, 0.36104850E-03_JPRB, 0.36093206E-03_JPRB, 0.36077495E-03_JPRB, 0.36056849E-03_JPRB, &
  & 0.36029858E-03_JPRB, 0.35994832E-03_JPRB, 0.35949171E-03_JPRB, 0.35890331E-03_JPRB, 0.35818011E-03_JPRB, 0.35735051E-03_JPRB, &
  & 0.35664125E-03_JPRB, 0.35666203E-03_JPRB, 0.35738866E-03_JPRB, 0.35852633E-03_JPRB, 0.35961851E-03_JPRB, 0.36032419E-03_JPRB, &
  & 0.36077364E-03_JPRB, 0.36109850E-03_JPRB, 0.36134280E-03_JPRB, 0.36153075E-03_JPRB, 0.36167805E-03_JPRB, 0.36178355E-03_JPRB, &
  & 0.36183826E-03_JPRB, 0.36183238E-03_JPRB, 0.36176032E-03_JPRB, 0.36162723E-03_JPRB, 0.36144484E-03_JPRB, 0.36123057E-03_JPRB, &
  & 0.36100671E-03_JPRB, 0.36079431E-03_JPRB, 0.36060892E-03_JPRB, 0.36045618E-03_JPRB, 0.36033528E-03_JPRB, 0.36024326E-03_JPRB, &
  & 0.36017603E-03_JPRB, 0.36012978E-03_JPRB, 0.36010530E-03_JPRB, 0.36009387E-03_JPRB /)

RGHG1(:, 2,10) = (/ &
  & 0.36176885E-03_JPRB, 0.36159766E-03_JPRB, 0.36148686E-03_JPRB, 0.36139757E-03_JPRB, 0.36133459E-03_JPRB, 0.36130997E-03_JPRB, &
  & 0.36133215E-03_JPRB, 0.36140042E-03_JPRB, 0.36150508E-03_JPRB, 0.36163582E-03_JPRB, 0.36179286E-03_JPRB, 0.36198270E-03_JPRB, &
  & 0.36219836E-03_JPRB, 0.36242849E-03_JPRB, 0.36266295E-03_JPRB, 0.36289167E-03_JPRB, 0.36310271E-03_JPRB, 0.36328693E-03_JPRB, &
  & 0.36343510E-03_JPRB, 0.36354002E-03_JPRB, 0.36359730E-03_JPRB, 0.36360780E-03_JPRB, 0.36357614E-03_JPRB, 0.36350774E-03_JPRB, &
  & 0.36340646E-03_JPRB, 0.36327264E-03_JPRB, 0.36309805E-03_JPRB, 0.36287506E-03_JPRB, 0.36259959E-03_JPRB, 0.36227779E-03_JPRB, &
  & 0.36190968E-03_JPRB, 0.36149414E-03_JPRB, 0.36101698E-03_JPRB, 0.36046380E-03_JPRB, 0.35985935E-03_JPRB, 0.35931770E-03_JPRB, &
  & 0.35902401E-03_JPRB, 0.35912782E-03_JPRB, 0.35959299E-03_JPRB, 0.36024844E-03_JPRB, 0.36096966E-03_JPRB, 0.36159452E-03_JPRB, &
  & 0.36206277E-03_JPRB, 0.36239452E-03_JPRB, 0.36262092E-03_JPRB, 0.36276702E-03_JPRB, 0.36285268E-03_JPRB, 0.36289802E-03_JPRB, &
  & 0.36291781E-03_JPRB, 0.36292250E-03_JPRB, 0.36291569E-03_JPRB, 0.36288373E-03_JPRB, 0.36280058E-03_JPRB, 0.36264744E-03_JPRB, &
  & 0.36242921E-03_JPRB, 0.36217633E-03_JPRB, 0.36192284E-03_JPRB, 0.36169277E-03_JPRB, 0.36149740E-03_JPRB, 0.36134067E-03_JPRB, &
  & 0.36122161E-03_JPRB, 0.36113645E-03_JPRB, 0.36107685E-03_JPRB, 0.36102236E-03_JPRB /)

RGHG1(:, 3,10) = (/ &
  & 0.36281440E-03_JPRB, 0.36275288E-03_JPRB, 0.36274621E-03_JPRB, 0.36276516E-03_JPRB, 0.36280142E-03_JPRB, 0.36285113E-03_JPRB, &
  & 0.36291734E-03_JPRB, 0.36301126E-03_JPRB, 0.36313524E-03_JPRB, 0.36328606E-03_JPRB, 0.36345125E-03_JPRB, 0.36362206E-03_JPRB, &
  & 0.36379791E-03_JPRB, 0.36397230E-03_JPRB, 0.36413549E-03_JPRB, 0.36428409E-03_JPRB, 0.36441619E-03_JPRB, 0.36452987E-03_JPRB, &
  & 0.36462178E-03_JPRB, 0.36468758E-03_JPRB, 0.36472216E-03_JPRB, 0.36472120E-03_JPRB, 0.36468307E-03_JPRB, 0.36460836E-03_JPRB, &
  & 0.36449646E-03_JPRB, 0.36434230E-03_JPRB, 0.36413851E-03_JPRB, 0.36386747E-03_JPRB, 0.36353353E-03_JPRB, 0.36314473E-03_JPRB, &
  & 0.36271152E-03_JPRB, 0.36222444E-03_JPRB, 0.36168183E-03_JPRB, 0.36115019E-03_JPRB, 0.36077047E-03_JPRB, 0.36066456E-03_JPRB, &
  & 0.36085726E-03_JPRB, 0.36127266E-03_JPRB, 0.36181620E-03_JPRB, 0.36240823E-03_JPRB, 0.36296065E-03_JPRB, 0.36342302E-03_JPRB, &
  & 0.36376462E-03_JPRB, 0.36399637E-03_JPRB, 0.36413939E-03_JPRB, 0.36421334E-03_JPRB, 0.36423345E-03_JPRB, 0.36420851E-03_JPRB, &
  & 0.36414061E-03_JPRB, 0.36402681E-03_JPRB, 0.36386203E-03_JPRB, 0.36364634E-03_JPRB, 0.36338967E-03_JPRB, 0.36311074E-03_JPRB, &
  & 0.36282637E-03_JPRB, 0.36254595E-03_JPRB, 0.36228160E-03_JPRB, 0.36204534E-03_JPRB, 0.36184830E-03_JPRB, 0.36169373E-03_JPRB, &
  & 0.36158043E-03_JPRB, 0.36150310E-03_JPRB, 0.36145389E-03_JPRB, 0.36141582E-03_JPRB /)

RGHG1(:, 4,10) = (/ &
  & 0.36321688E-03_JPRB, 0.36325323E-03_JPRB, 0.36329898E-03_JPRB, 0.36337035E-03_JPRB, 0.36347227E-03_JPRB, 0.36359829E-03_JPRB, &
  & 0.36373816E-03_JPRB, 0.36387867E-03_JPRB, 0.36402038E-03_JPRB, 0.36416389E-03_JPRB, 0.36431002E-03_JPRB, 0.36445184E-03_JPRB, &
  & 0.36458310E-03_JPRB, 0.36470330E-03_JPRB, 0.36481093E-03_JPRB, 0.36490534E-03_JPRB, 0.36498823E-03_JPRB, 0.36506139E-03_JPRB, &
  & 0.36512429E-03_JPRB, 0.36517339E-03_JPRB, 0.36520211E-03_JPRB, 0.36520226E-03_JPRB, 0.36516410E-03_JPRB, 0.36507950E-03_JPRB, &
  & 0.36494402E-03_JPRB, 0.36475278E-03_JPRB, 0.36449876E-03_JPRB, 0.36419381E-03_JPRB, 0.36385027E-03_JPRB, 0.36347695E-03_JPRB, &
  & 0.36307005E-03_JPRB, 0.36266510E-03_JPRB, 0.36233960E-03_JPRB, 0.36217124E-03_JPRB, 0.36220709E-03_JPRB, 0.36244190E-03_JPRB, &
  & 0.36281947E-03_JPRB, 0.36327282E-03_JPRB, 0.36374253E-03_JPRB, 0.36418156E-03_JPRB, 0.36455304E-03_JPRB, 0.36483048E-03_JPRB, &
  & 0.36501582E-03_JPRB, 0.36512341E-03_JPRB, 0.36517141E-03_JPRB, 0.36517481E-03_JPRB, 0.36514213E-03_JPRB, 0.36507664E-03_JPRB, &
  & 0.36497868E-03_JPRB, 0.36484801E-03_JPRB, 0.36468296E-03_JPRB, 0.36447862E-03_JPRB, 0.36422737E-03_JPRB, 0.36392012E-03_JPRB, &
  & 0.36355539E-03_JPRB, 0.36315544E-03_JPRB, 0.36275564E-03_JPRB, 0.36239548E-03_JPRB, 0.36209231E-03_JPRB, 0.36185194E-03_JPRB, &
  & 0.36167243E-03_JPRB, 0.36154498E-03_JPRB, 0.36145220E-03_JPRB, 0.36136707E-03_JPRB /)

RGHG1(:, 5,10) = (/ &
  & 0.36344887E-03_JPRB, 0.36358595E-03_JPRB, 0.36371738E-03_JPRB, 0.36385914E-03_JPRB, 0.36400382E-03_JPRB, 0.36414724E-03_JPRB, &
  & 0.36428732E-03_JPRB, 0.36442396E-03_JPRB, 0.36455615E-03_JPRB, 0.36468249E-03_JPRB, 0.36480237E-03_JPRB, 0.36491407E-03_JPRB, &
  & 0.36501521E-03_JPRB, 0.36510476E-03_JPRB, 0.36518398E-03_JPRB, 0.36525397E-03_JPRB, 0.36531611E-03_JPRB, 0.36537228E-03_JPRB, &
  & 0.36542385E-03_JPRB, 0.36546972E-03_JPRB, 0.36550435E-03_JPRB, 0.36551777E-03_JPRB, 0.36549987E-03_JPRB, 0.36544396E-03_JPRB, &
  & 0.36534588E-03_JPRB, 0.36521067E-03_JPRB, 0.36505202E-03_JPRB, 0.36488060E-03_JPRB, 0.36470857E-03_JPRB, 0.36455822E-03_JPRB, &
  & 0.36445310E-03_JPRB, 0.36439826E-03_JPRB, 0.36439666E-03_JPRB, 0.36445798E-03_JPRB, 0.36458339E-03_JPRB, 0.36475924E-03_JPRB, &
  & 0.36496410E-03_JPRB, 0.36517379E-03_JPRB, 0.36537054E-03_JPRB, 0.36553846E-03_JPRB, 0.36566699E-03_JPRB, 0.36575153E-03_JPRB, &
  & 0.36579397E-03_JPRB, 0.36580014E-03_JPRB, 0.36577813E-03_JPRB, 0.36573427E-03_JPRB, 0.36567147E-03_JPRB, 0.36559094E-03_JPRB, &
  & 0.36549248E-03_JPRB, 0.36537310E-03_JPRB, 0.36522560E-03_JPRB, 0.36503968E-03_JPRB, 0.36480371E-03_JPRB, 0.36450673E-03_JPRB, &
  & 0.36414497E-03_JPRB, 0.36372387E-03_JPRB, 0.36327087E-03_JPRB, 0.36282255E-03_JPRB, 0.36242465E-03_JPRB, 0.36209964E-03_JPRB, &
  & 0.36185043E-03_JPRB, 0.36166832E-03_JPRB, 0.36153547E-03_JPRB, 0.36139504E-03_JPRB /)

RGHG1(:, 6,10) = (/ &
  & 0.36378880E-03_JPRB, 0.36398572E-03_JPRB, 0.36413688E-03_JPRB, 0.36428170E-03_JPRB, 0.36442099E-03_JPRB, 0.36455283E-03_JPRB, &
  & 0.36467635E-03_JPRB, 0.36479486E-03_JPRB, 0.36490773E-03_JPRB, 0.36501652E-03_JPRB, 0.36511919E-03_JPRB, 0.36521378E-03_JPRB, &
  & 0.36529833E-03_JPRB, 0.36537246E-03_JPRB, 0.36543730E-03_JPRB, 0.36549522E-03_JPRB, 0.36554871E-03_JPRB, 0.36559999E-03_JPRB, &
  & 0.36564993E-03_JPRB, 0.36569842E-03_JPRB, 0.36574426E-03_JPRB, 0.36578299E-03_JPRB, 0.36580680E-03_JPRB, 0.36581134E-03_JPRB, &
  & 0.36579825E-03_JPRB, 0.36577490E-03_JPRB, 0.36575017E-03_JPRB, 0.36573154E-03_JPRB, 0.36572383E-03_JPRB, 0.36572851E-03_JPRB, &
  & 0.36574676E-03_JPRB, 0.36577688E-03_JPRB, 0.36581524E-03_JPRB, 0.36585878E-03_JPRB, 0.36590724E-03_JPRB, 0.36595922E-03_JPRB, &
  & 0.36601615E-03_JPRB, 0.36607677E-03_JPRB, 0.36613567E-03_JPRB, 0.36618594E-03_JPRB, 0.36621906E-03_JPRB, 0.36622881E-03_JPRB, &
  & 0.36621472E-03_JPRB, 0.36618087E-03_JPRB, 0.36613308E-03_JPRB, 0.36607476E-03_JPRB, 0.36600715E-03_JPRB, 0.36592985E-03_JPRB, &
  & 0.36584053E-03_JPRB, 0.36573462E-03_JPRB, 0.36560523E-03_JPRB, 0.36544420E-03_JPRB, 0.36524129E-03_JPRB, 0.36498625E-03_JPRB, &
  & 0.36466913E-03_JPRB, 0.36429259E-03_JPRB, 0.36387594E-03_JPRB, 0.36346418E-03_JPRB, 0.36309712E-03_JPRB, 0.36279840E-03_JPRB, &
  & 0.36256862E-03_JPRB, 0.36239653E-03_JPRB, 0.36224932E-03_JPRB, 0.36208471E-03_JPRB /)

RGHG1(:, 7,10) = (/ &
  & 0.36413787E-03_JPRB, 0.36433825E-03_JPRB, 0.36448202E-03_JPRB, 0.36461162E-03_JPRB, 0.36473473E-03_JPRB, 0.36485013E-03_JPRB, &
  & 0.36495956E-03_JPRB, 0.36506209E-03_JPRB, 0.36516140E-03_JPRB, 0.36525694E-03_JPRB, 0.36534815E-03_JPRB, 0.36543320E-03_JPRB, &
  & 0.36551047E-03_JPRB, 0.36557906E-03_JPRB, 0.36563945E-03_JPRB, 0.36569341E-03_JPRB, 0.36574353E-03_JPRB, 0.36579318E-03_JPRB, &
  & 0.36584571E-03_JPRB, 0.36590357E-03_JPRB, 0.36596664E-03_JPRB, 0.36602982E-03_JPRB, 0.36608669E-03_JPRB, 0.36613288E-03_JPRB, &
  & 0.36616848E-03_JPRB, 0.36619671E-03_JPRB, 0.36622243E-03_JPRB, 0.36625031E-03_JPRB, 0.36628262E-03_JPRB, 0.36631990E-03_JPRB, &
  & 0.36636111E-03_JPRB, 0.36640398E-03_JPRB, 0.36644295E-03_JPRB, 0.36647584E-03_JPRB, 0.36650407E-03_JPRB, 0.36652733E-03_JPRB, &
  & 0.36654828E-03_JPRB, 0.36656886E-03_JPRB, 0.36658676E-03_JPRB, 0.36659813E-03_JPRB, 0.36659642E-03_JPRB, 0.36657651E-03_JPRB, &
  & 0.36653868E-03_JPRB, 0.36648873E-03_JPRB, 0.36643131E-03_JPRB, 0.36636938E-03_JPRB, 0.36630328E-03_JPRB, 0.36623163E-03_JPRB, &
  & 0.36615162E-03_JPRB, 0.36605855E-03_JPRB, 0.36594665E-03_JPRB, 0.36580916E-03_JPRB, 0.36563893E-03_JPRB, 0.36542836E-03_JPRB, &
  & 0.36517423E-03_JPRB, 0.36488133E-03_JPRB, 0.36457268E-03_JPRB, 0.36427306E-03_JPRB, 0.36400778E-03_JPRB, 0.36378819E-03_JPRB, &
  & 0.36361540E-03_JPRB, 0.36347719E-03_JPRB, 0.36336016E-03_JPRB, 0.36320640E-03_JPRB /)

RGHG1(:, 8,10) = (/ &
  & 0.36444224E-03_JPRB, 0.36462845E-03_JPRB, 0.36475019E-03_JPRB, 0.36486317E-03_JPRB, 0.36496864E-03_JPRB, 0.36507007E-03_JPRB, &
  & 0.36516707E-03_JPRB, 0.36526192E-03_JPRB, 0.36535336E-03_JPRB, 0.36544199E-03_JPRB, 0.36552694E-03_JPRB, 0.36560692E-03_JPRB, &
  & 0.36568055E-03_JPRB, 0.36574691E-03_JPRB, 0.36580625E-03_JPRB, 0.36586015E-03_JPRB, 0.36591140E-03_JPRB, 0.36596312E-03_JPRB, &
  & 0.36601830E-03_JPRB, 0.36608012E-03_JPRB, 0.36615063E-03_JPRB, 0.36622959E-03_JPRB, 0.36631236E-03_JPRB, 0.36639351E-03_JPRB, &
  & 0.36646996E-03_JPRB, 0.36654019E-03_JPRB, 0.36660605E-03_JPRB, 0.36666877E-03_JPRB, 0.36672983E-03_JPRB, 0.36678929E-03_JPRB, &
  & 0.36684590E-03_JPRB, 0.36689770E-03_JPRB, 0.36694054E-03_JPRB, 0.36697256E-03_JPRB, 0.36699488E-03_JPRB, 0.36700719E-03_JPRB, &
  & 0.36701138E-03_JPRB, 0.36700984E-03_JPRB, 0.36700332E-03_JPRB, 0.36698979E-03_JPRB, 0.36696519E-03_JPRB, 0.36692480E-03_JPRB, &
  & 0.36687066E-03_JPRB, 0.36680736E-03_JPRB, 0.36674144E-03_JPRB, 0.36667491E-03_JPRB, 0.36660727E-03_JPRB, 0.36653611E-03_JPRB, &
  & 0.36645783E-03_JPRB, 0.36636784E-03_JPRB, 0.36626117E-03_JPRB, 0.36613297E-03_JPRB, 0.36597796E-03_JPRB, 0.36579306E-03_JPRB, &
  & 0.36557912E-03_JPRB, 0.36534743E-03_JPRB, 0.36511209E-03_JPRB, 0.36489189E-03_JPRB, 0.36469926E-03_JPRB, 0.36454020E-03_JPRB, &
  & 0.36441590E-03_JPRB, 0.36431724E-03_JPRB, 0.36423688E-03_JPRB, 0.36412579E-03_JPRB /)

RGHG1(:, 9,10) = (/ &
  & 0.36470447E-03_JPRB, 0.36485397E-03_JPRB, 0.36495895E-03_JPRB, 0.36505295E-03_JPRB, 0.36514658E-03_JPRB, 0.36523884E-03_JPRB, &
  & 0.36532985E-03_JPRB, 0.36541806E-03_JPRB, 0.36550401E-03_JPRB, 0.36558745E-03_JPRB, 0.36566792E-03_JPRB, 0.36574440E-03_JPRB, &
  & 0.36581559E-03_JPRB, 0.36588070E-03_JPRB, 0.36593989E-03_JPRB, 0.36599458E-03_JPRB, 0.36604682E-03_JPRB, 0.36610014E-03_JPRB, &
  & 0.36615887E-03_JPRB, 0.36622799E-03_JPRB, 0.36631178E-03_JPRB, 0.36641044E-03_JPRB, 0.36651929E-03_JPRB, 0.36663172E-03_JPRB, &
  & 0.36674101E-03_JPRB, 0.36684403E-03_JPRB, 0.36693848E-03_JPRB, 0.36702515E-03_JPRB, 0.36710533E-03_JPRB, 0.36718129E-03_JPRB, &
  & 0.36725606E-03_JPRB, 0.36732599E-03_JPRB, 0.36738455E-03_JPRB, 0.36742759E-03_JPRB, 0.36745376E-03_JPRB, 0.36746409E-03_JPRB, &
  & 0.36746185E-03_JPRB, 0.36745032E-03_JPRB, 0.36743074E-03_JPRB, 0.36740259E-03_JPRB, 0.36736261E-03_JPRB, 0.36730891E-03_JPRB, &
  & 0.36724115E-03_JPRB, 0.36716671E-03_JPRB, 0.36709022E-03_JPRB, 0.36701447E-03_JPRB, 0.36693824E-03_JPRB, 0.36685841E-03_JPRB, &
  & 0.36677113E-03_JPRB, 0.36667212E-03_JPRB, 0.36655684E-03_JPRB, 0.36642101E-03_JPRB, 0.36626161E-03_JPRB, 0.36607860E-03_JPRB, &
  & 0.36587872E-03_JPRB, 0.36567159E-03_JPRB, 0.36547257E-03_JPRB, 0.36529280E-03_JPRB, 0.36514032E-03_JPRB, 0.36501791E-03_JPRB, &
  & 0.36492164E-03_JPRB, 0.36485342E-03_JPRB, 0.36478811E-03_JPRB, 0.36472065E-03_JPRB /)

RGHG1(:,10,10) = (/ &
  & 0.36491081E-03_JPRB, 0.36503776E-03_JPRB, 0.36512146E-03_JPRB, 0.36520383E-03_JPRB, 0.36528625E-03_JPRB, 0.36537109E-03_JPRB, &
  & 0.36545683E-03_JPRB, 0.36554236E-03_JPRB, 0.36562610E-03_JPRB, 0.36570724E-03_JPRB, 0.36578544E-03_JPRB, 0.36586018E-03_JPRB, &
  & 0.36593064E-03_JPRB, 0.36599557E-03_JPRB, 0.36605448E-03_JPRB, 0.36610881E-03_JPRB, 0.36616140E-03_JPRB, 0.36621606E-03_JPRB, &
  & 0.36627660E-03_JPRB, 0.36634752E-03_JPRB, 0.36643277E-03_JPRB, 0.36653326E-03_JPRB, 0.36664662E-03_JPRB, 0.36676688E-03_JPRB, &
  & 0.36688923E-03_JPRB, 0.36701016E-03_JPRB, 0.36712896E-03_JPRB, 0.36724645E-03_JPRB, 0.36736479E-03_JPRB, 0.36748109E-03_JPRB, &
  & 0.36758653E-03_JPRB, 0.36768112E-03_JPRB, 0.36776206E-03_JPRB, 0.36782451E-03_JPRB, 0.36786706E-03_JPRB, 0.36789023E-03_JPRB, &
  & 0.36789582E-03_JPRB, 0.36788586E-03_JPRB, 0.36786328E-03_JPRB, 0.36782899E-03_JPRB, 0.36778307E-03_JPRB, 0.36772268E-03_JPRB, &
  & 0.36764864E-03_JPRB, 0.36756427E-03_JPRB, 0.36747492E-03_JPRB, 0.36738455E-03_JPRB, 0.36729255E-03_JPRB, 0.36719628E-03_JPRB, &
  & 0.36709174E-03_JPRB, 0.36697468E-03_JPRB, 0.36684109E-03_JPRB, 0.36668745E-03_JPRB, 0.36651298E-03_JPRB, 0.36632156E-03_JPRB, &
  & 0.36612159E-03_JPRB, 0.36592648E-03_JPRB, 0.36574746E-03_JPRB, 0.36559298E-03_JPRB, 0.36546611E-03_JPRB, 0.36536614E-03_JPRB, &
  & 0.36529376E-03_JPRB, 0.36523299E-03_JPRB, 0.36519201E-03_JPRB, 0.36512385E-03_JPRB /)

RGHG1(:,11,10) = (/ &
  & 0.36508151E-03_JPRB, 0.36518351E-03_JPRB, 0.36525785E-03_JPRB, 0.36532857E-03_JPRB, 0.36540432E-03_JPRB, 0.36548488E-03_JPRB, &
  & 0.36556934E-03_JPRB, 0.36565520E-03_JPRB, 0.36574044E-03_JPRB, 0.36582409E-03_JPRB, 0.36590555E-03_JPRB, 0.36598448E-03_JPRB, &
  & 0.36606050E-03_JPRB, 0.36613282E-03_JPRB, 0.36620043E-03_JPRB, 0.36626295E-03_JPRB, 0.36632086E-03_JPRB, 0.36637729E-03_JPRB, &
  & 0.36643655E-03_JPRB, 0.36650378E-03_JPRB, 0.36658312E-03_JPRB, 0.36667715E-03_JPRB, 0.36678428E-03_JPRB, 0.36690207E-03_JPRB, &
  & 0.36702573E-03_JPRB, 0.36715280E-03_JPRB, 0.36728312E-03_JPRB, 0.36741461E-03_JPRB, 0.36754578E-03_JPRB, 0.36767672E-03_JPRB, &
  & 0.36780944E-03_JPRB, 0.36793450E-03_JPRB, 0.36804529E-03_JPRB, 0.36813607E-03_JPRB, 0.36820362E-03_JPRB, 0.36824599E-03_JPRB, &
  & 0.36826532E-03_JPRB, 0.36826479E-03_JPRB, 0.36824853E-03_JPRB, 0.36821835E-03_JPRB, 0.36817440E-03_JPRB, 0.36811558E-03_JPRB, &
  & 0.36804075E-03_JPRB, 0.36795175E-03_JPRB, 0.36785286E-03_JPRB, 0.36774823E-03_JPRB, 0.36763941E-03_JPRB, 0.36752541E-03_JPRB, &
  & 0.36740291E-03_JPRB, 0.36726863E-03_JPRB, 0.36711909E-03_JPRB, 0.36695262E-03_JPRB, 0.36677075E-03_JPRB, 0.36658003E-03_JPRB, &
  & 0.36639179E-03_JPRB, 0.36621699E-03_JPRB, 0.36606396E-03_JPRB, 0.36593611E-03_JPRB, 0.36583279E-03_JPRB, 0.36575308E-03_JPRB, &
  & 0.36568905E-03_JPRB, 0.36564562E-03_JPRB, 0.36559626E-03_JPRB, 0.36554781E-03_JPRB /)

RGHG1(:,12,10) = (/ &
  & 0.36521928E-03_JPRB, 0.36531157E-03_JPRB, 0.36537644E-03_JPRB, 0.36544388E-03_JPRB, 0.36551611E-03_JPRB, 0.36559583E-03_JPRB, &
  & 0.36568166E-03_JPRB, 0.36577112E-03_JPRB, 0.36586158E-03_JPRB, 0.36595095E-03_JPRB, 0.36603829E-03_JPRB, 0.36612275E-03_JPRB, &
  & 0.36620401E-03_JPRB, 0.36628160E-03_JPRB, 0.36635608E-03_JPRB, 0.36642831E-03_JPRB, 0.36649854E-03_JPRB, 0.36656740E-03_JPRB, &
  & 0.36663766E-03_JPRB, 0.36671269E-03_JPRB, 0.36679508E-03_JPRB, 0.36688620E-03_JPRB, 0.36698862E-03_JPRB, 0.36709904E-03_JPRB, &
  & 0.36721525E-03_JPRB, 0.36733694E-03_JPRB, 0.36746435E-03_JPRB, 0.36759739E-03_JPRB, 0.36773735E-03_JPRB, 0.36788228E-03_JPRB, &
  & 0.36802387E-03_JPRB, 0.36816054E-03_JPRB, 0.36828560E-03_JPRB, 0.36839224E-03_JPRB, 0.36847414E-03_JPRB, 0.36852920E-03_JPRB, &
  & 0.36855874E-03_JPRB, 0.36856649E-03_JPRB, 0.36855662E-03_JPRB, 0.36853142E-03_JPRB, 0.36849169E-03_JPRB, 0.36843689E-03_JPRB, &
  & 0.36836564E-03_JPRB, 0.36827917E-03_JPRB, 0.36817894E-03_JPRB, 0.36806922E-03_JPRB, 0.36795251E-03_JPRB, 0.36782905E-03_JPRB, &
  & 0.36769800E-03_JPRB, 0.36755670E-03_JPRB, 0.36740431E-03_JPRB, 0.36724028E-03_JPRB, 0.36706851E-03_JPRB, 0.36689598E-03_JPRB, &
  & 0.36673190E-03_JPRB, 0.36658411E-03_JPRB, 0.36645666E-03_JPRB, 0.36635081E-03_JPRB, 0.36626426E-03_JPRB, 0.36619540E-03_JPRB, &
  & 0.36614333E-03_JPRB, 0.36609743E-03_JPRB, 0.36606335E-03_JPRB, 0.36600005E-03_JPRB /)

RGHG1(:,13,10) = (/ &
  & 0.36534807E-03_JPRB, 0.36544059E-03_JPRB, 0.36551058E-03_JPRB, 0.36558131E-03_JPRB, 0.36566105E-03_JPRB, 0.36575121E-03_JPRB, &
  & 0.36585180E-03_JPRB, 0.36596027E-03_JPRB, 0.36607336E-03_JPRB, 0.36618797E-03_JPRB, 0.36630195E-03_JPRB, 0.36641365E-03_JPRB, &
  & 0.36652220E-03_JPRB, 0.36662671E-03_JPRB, 0.36672541E-03_JPRB, 0.36681807E-03_JPRB, 0.36690617E-03_JPRB, 0.36699060E-03_JPRB, &
  & 0.36707311E-03_JPRB, 0.36715553E-03_JPRB, 0.36723792E-03_JPRB, 0.36732139E-03_JPRB, 0.36740646E-03_JPRB, 0.36749119E-03_JPRB, &
  & 0.36757576E-03_JPRB, 0.36766427E-03_JPRB, 0.36775906E-03_JPRB, 0.36786337E-03_JPRB, 0.36797830E-03_JPRB, 0.36810368E-03_JPRB, &
  & 0.36823822E-03_JPRB, 0.36837358E-03_JPRB, 0.36850109E-03_JPRB, 0.36861221E-03_JPRB, 0.36870025E-03_JPRB, 0.36876230E-03_JPRB, &
  & 0.36879850E-03_JPRB, 0.36881192E-03_JPRB, 0.36880642E-03_JPRB, 0.36878462E-03_JPRB, 0.36874786E-03_JPRB, 0.36869643E-03_JPRB, &
  & 0.36862990E-03_JPRB, 0.36854835E-03_JPRB, 0.36845368E-03_JPRB, 0.36834815E-03_JPRB, 0.36823476E-03_JPRB, 0.36811514E-03_JPRB, &
  & 0.36798953E-03_JPRB, 0.36785787E-03_JPRB, 0.36771953E-03_JPRB, 0.36757617E-03_JPRB, 0.36743027E-03_JPRB, 0.36728696E-03_JPRB, &
  & 0.36715198E-03_JPRB, 0.36703009E-03_JPRB, 0.36692317E-03_JPRB, 0.36683175E-03_JPRB, 0.36675384E-03_JPRB, 0.36668987E-03_JPRB, &
  & 0.36663431E-03_JPRB, 0.36659255E-03_JPRB, 0.36654255E-03_JPRB, 0.36648338E-03_JPRB /)

RGHG1(:,14,10) = (/ &
  & 0.36548282E-03_JPRB, 0.36558873E-03_JPRB, 0.36566786E-03_JPRB, 0.36575121E-03_JPRB, 0.36584467E-03_JPRB, 0.36595247E-03_JPRB, &
  & 0.36607450E-03_JPRB, 0.36620858E-03_JPRB, 0.36635069E-03_JPRB, 0.36649636E-03_JPRB, 0.36664162E-03_JPRB, 0.36678367E-03_JPRB, &
  & 0.36692055E-03_JPRB, 0.36705163E-03_JPRB, 0.36717602E-03_JPRB, 0.36729226E-03_JPRB, 0.36740117E-03_JPRB, 0.36750344E-03_JPRB, &
  & 0.36759971E-03_JPRB, 0.36769058E-03_JPRB, 0.36777518E-03_JPRB, 0.36785263E-03_JPRB, 0.36792282E-03_JPRB, 0.36798476E-03_JPRB, &
  & 0.36803941E-03_JPRB, 0.36809169E-03_JPRB, 0.36814716E-03_JPRB, 0.36821020E-03_JPRB, 0.36828814E-03_JPRB, 0.36838304E-03_JPRB, &
  & 0.36849169E-03_JPRB, 0.36860700E-03_JPRB, 0.36872108E-03_JPRB, 0.36882519E-03_JPRB, 0.36891171E-03_JPRB, 0.36897624E-03_JPRB, &
  & 0.36901684E-03_JPRB, 0.36903529E-03_JPRB, 0.36903386E-03_JPRB, 0.36901532E-03_JPRB, 0.36898136E-03_JPRB, 0.36893232E-03_JPRB, &
  & 0.36886922E-03_JPRB, 0.36879268E-03_JPRB, 0.36870476E-03_JPRB, 0.36860773E-03_JPRB, 0.36850461E-03_JPRB, 0.36839748E-03_JPRB, &
  & 0.36828767E-03_JPRB, 0.36817574E-03_JPRB, 0.36806238E-03_JPRB, 0.36794815E-03_JPRB, 0.36783467E-03_JPRB, 0.36772410E-03_JPRB, &
  & 0.36761936E-03_JPRB, 0.36752244E-03_JPRB, 0.36743475E-03_JPRB, 0.36735620E-03_JPRB, 0.36728595E-03_JPRB, 0.36722489E-03_JPRB, &
  & 0.36717020E-03_JPRB, 0.36712276E-03_JPRB, 0.36707390E-03_JPRB, 0.36699662E-03_JPRB /)

RGHG1(:,15,10) = (/ &
  & 0.36563081E-03_JPRB, 0.36575709E-03_JPRB, 0.36585279E-03_JPRB, 0.36595290E-03_JPRB, 0.36606682E-03_JPRB, 0.36619825E-03_JPRB, &
  & 0.36634831E-03_JPRB, 0.36651417E-03_JPRB, 0.36669034E-03_JPRB, 0.36687031E-03_JPRB, 0.36704799E-03_JPRB, 0.36721886E-03_JPRB, &
  & 0.36738094E-03_JPRB, 0.36753327E-03_JPRB, 0.36767585E-03_JPRB, 0.36780830E-03_JPRB, 0.36793062E-03_JPRB, 0.36804372E-03_JPRB, &
  & 0.36814765E-03_JPRB, 0.36824250E-03_JPRB, 0.36832725E-03_JPRB, 0.36839981E-03_JPRB, 0.36845866E-03_JPRB, 0.36850348E-03_JPRB, &
  & 0.36853435E-03_JPRB, 0.36855513E-03_JPRB, 0.36857251E-03_JPRB, 0.36859544E-03_JPRB, 0.36863313E-03_JPRB, 0.36868910E-03_JPRB, &
  & 0.36876259E-03_JPRB, 0.36885167E-03_JPRB, 0.36894827E-03_JPRB, 0.36904166E-03_JPRB, 0.36912359E-03_JPRB, 0.36918838E-03_JPRB, &
  & 0.36923285E-03_JPRB, 0.36925665E-03_JPRB, 0.36926073E-03_JPRB, 0.36924725E-03_JPRB, 0.36921696E-03_JPRB, 0.36917115E-03_JPRB, &
  & 0.36911137E-03_JPRB, 0.36903948E-03_JPRB, 0.36895805E-03_JPRB, 0.36887015E-03_JPRB, 0.36877848E-03_JPRB, 0.36868558E-03_JPRB, &
  & 0.36859314E-03_JPRB, 0.36850193E-03_JPRB, 0.36841165E-03_JPRB, 0.36832230E-03_JPRB, 0.36823389E-03_JPRB, 0.36814742E-03_JPRB, &
  & 0.36806392E-03_JPRB, 0.36798496E-03_JPRB, 0.36791107E-03_JPRB, 0.36784273E-03_JPRB, 0.36777992E-03_JPRB, 0.36772282E-03_JPRB, &
  & 0.36767084E-03_JPRB, 0.36762402E-03_JPRB, 0.36757160E-03_JPRB, 0.36748979E-03_JPRB /)

RGHG1(:,16,10) = (/ &
  & 0.36580459E-03_JPRB, 0.36595855E-03_JPRB, 0.36607604E-03_JPRB, 0.36619880E-03_JPRB, 0.36633707E-03_JPRB, 0.36649508E-03_JPRB, &
  & 0.36667340E-03_JPRB, 0.36686810E-03_JPRB, 0.36707256E-03_JPRB, 0.36727911E-03_JPRB, 0.36748088E-03_JPRB, 0.36767215E-03_JPRB, &
  & 0.36785007E-03_JPRB, 0.36801412E-03_JPRB, 0.36816517E-03_JPRB, 0.36830423E-03_JPRB, 0.36843162E-03_JPRB, 0.36854815E-03_JPRB, &
  & 0.36865444E-03_JPRB, 0.36874972E-03_JPRB, 0.36883319E-03_JPRB, 0.36890234E-03_JPRB, 0.36895458E-03_JPRB, 0.36898852E-03_JPRB, &
  & 0.36900426E-03_JPRB, 0.36900421E-03_JPRB, 0.36899571E-03_JPRB, 0.36899000E-03_JPRB, 0.36899481E-03_JPRB, 0.36901841E-03_JPRB, &
  & 0.36906247E-03_JPRB, 0.36912333E-03_JPRB, 0.36919661E-03_JPRB, 0.36927333E-03_JPRB, 0.36934522E-03_JPRB, 0.36940566E-03_JPRB, &
  & 0.36945048E-03_JPRB, 0.36947793E-03_JPRB, 0.36948768E-03_JPRB, 0.36948005E-03_JPRB, 0.36945569E-03_JPRB, 0.36941550E-03_JPRB, &
  & 0.36936143E-03_JPRB, 0.36929603E-03_JPRB, 0.36922266E-03_JPRB, 0.36914484E-03_JPRB, 0.36906550E-03_JPRB, 0.36898730E-03_JPRB, &
  & 0.36891134E-03_JPRB, 0.36883735E-03_JPRB, 0.36876445E-03_JPRB, 0.36869189E-03_JPRB, 0.36861913E-03_JPRB, 0.36854646E-03_JPRB, &
  & 0.36847458E-03_JPRB, 0.36840473E-03_JPRB, 0.36833819E-03_JPRB, 0.36827542E-03_JPRB, 0.36821698E-03_JPRB, 0.36816322E-03_JPRB, &
  & 0.36811302E-03_JPRB, 0.36806814E-03_JPRB, 0.36801273E-03_JPRB, 0.36793697E-03_JPRB /)

RGHG1(:,17,10) = (/ &
  & 0.36603102E-03_JPRB, 0.36622447E-03_JPRB, 0.36636656E-03_JPRB, 0.36651327E-03_JPRB, 0.36667529E-03_JPRB, 0.36685701E-03_JPRB, &
  & 0.36705742E-03_JPRB, 0.36727160E-03_JPRB, 0.36749200E-03_JPRB, 0.36771043E-03_JPRB, 0.36791986E-03_JPRB, 0.36811543E-03_JPRB, &
  & 0.36829466E-03_JPRB, 0.36845740E-03_JPRB, 0.36860508E-03_JPRB, 0.36873948E-03_JPRB, 0.36886189E-03_JPRB, 0.36897324E-03_JPRB, &
  & 0.36907423E-03_JPRB, 0.36916498E-03_JPRB, 0.36924472E-03_JPRB, 0.36931148E-03_JPRB, 0.36936253E-03_JPRB, 0.36939530E-03_JPRB, &
  & 0.36940936E-03_JPRB, 0.36940607E-03_JPRB, 0.36939073E-03_JPRB, 0.36937156E-03_JPRB, 0.36935828E-03_JPRB, 0.36936079E-03_JPRB, &
  & 0.36937924E-03_JPRB, 0.36941501E-03_JPRB, 0.36946300E-03_JPRB, 0.36951789E-03_JPRB, 0.36957394E-03_JPRB, 0.36962391E-03_JPRB, &
  & 0.36966335E-03_JPRB, 0.36969021E-03_JPRB, 0.36970279E-03_JPRB, 0.36970034E-03_JPRB, 0.36968276E-03_JPRB, 0.36965046E-03_JPRB, &
  & 0.36960500E-03_JPRB, 0.36954891E-03_JPRB, 0.36948605E-03_JPRB, 0.36942016E-03_JPRB, 0.36935427E-03_JPRB, 0.36929047E-03_JPRB, &
  & 0.36922900E-03_JPRB, 0.36916905E-03_JPRB, 0.36910921E-03_JPRB, 0.36904792E-03_JPRB, 0.36898453E-03_JPRB, 0.36891917E-03_JPRB, &
  & 0.36885275E-03_JPRB, 0.36878683E-03_JPRB, 0.36872298E-03_JPRB, 0.36866238E-03_JPRB, 0.36860580E-03_JPRB, 0.36855362E-03_JPRB, &
  & 0.36850598E-03_JPRB, 0.36845970E-03_JPRB, 0.36841081E-03_JPRB, 0.36832661E-03_JPRB /)

RGHG1(:,18,10) = (/ &
  & 0.36635005E-03_JPRB, 0.36658454E-03_JPRB, 0.36675125E-03_JPRB, 0.36691374E-03_JPRB, 0.36708929E-03_JPRB, 0.36727978E-03_JPRB, &
  & 0.36748429E-03_JPRB, 0.36769762E-03_JPRB, 0.36791293E-03_JPRB, 0.36812323E-03_JPRB, 0.36832300E-03_JPRB, 0.36850778E-03_JPRB, &
  & 0.36867589E-03_JPRB, 0.36882731E-03_JPRB, 0.36896352E-03_JPRB, 0.36908657E-03_JPRB, 0.36919813E-03_JPRB, 0.36929952E-03_JPRB, &
  & 0.36939204E-03_JPRB, 0.36947610E-03_JPRB, 0.36955124E-03_JPRB, 0.36961620E-03_JPRB, 0.36966844E-03_JPRB, 0.36970543E-03_JPRB, &
  & 0.36972555E-03_JPRB, 0.36972965E-03_JPRB, 0.36972144E-03_JPRB, 0.36970607E-03_JPRB, 0.36969126E-03_JPRB, 0.36968166E-03_JPRB, &
  & 0.36968346E-03_JPRB, 0.36969822E-03_JPRB, 0.36972406E-03_JPRB, 0.36975701E-03_JPRB, 0.36979304E-03_JPRB, 0.36982843E-03_JPRB, &
  & 0.36985893E-03_JPRB, 0.36988122E-03_JPRB, 0.36989362E-03_JPRB, 0.36989458E-03_JPRB, 0.36988329E-03_JPRB, 0.36985922E-03_JPRB, &
  & 0.36982345E-03_JPRB, 0.36977828E-03_JPRB, 0.36972732E-03_JPRB, 0.36967394E-03_JPRB, 0.36962100E-03_JPRB, 0.36956967E-03_JPRB, &
  & 0.36952001E-03_JPRB, 0.36947074E-03_JPRB, 0.36942033E-03_JPRB, 0.36936707E-03_JPRB, 0.36931015E-03_JPRB, 0.36924973E-03_JPRB, &
  & 0.36918698E-03_JPRB, 0.36912371E-03_JPRB, 0.36906195E-03_JPRB, 0.36900316E-03_JPRB, 0.36894818E-03_JPRB, 0.36889754E-03_JPRB, &
  & 0.36885095E-03_JPRB, 0.36880627E-03_JPRB, 0.36875808E-03_JPRB, 0.36867490E-03_JPRB /)

RGHG1(:,19,10) = (/ &
  & 0.36676333E-03_JPRB, 0.36702919E-03_JPRB, 0.36719901E-03_JPRB, 0.36736196E-03_JPRB, 0.36753088E-03_JPRB, 0.36771246E-03_JPRB, &
  & 0.36790359E-03_JPRB, 0.36810013E-03_JPRB, 0.36829588E-03_JPRB, 0.36848563E-03_JPRB, 0.36866480E-03_JPRB, 0.36883022E-03_JPRB, &
  & 0.36898052E-03_JPRB, 0.36911579E-03_JPRB, 0.36923739E-03_JPRB, 0.36934714E-03_JPRB, 0.36944664E-03_JPRB, 0.36953745E-03_JPRB, &
  & 0.36962098E-03_JPRB, 0.36969807E-03_JPRB, 0.36976900E-03_JPRB, 0.36983256E-03_JPRB, 0.36988693E-03_JPRB, 0.36992968E-03_JPRB, &
  & 0.36995840E-03_JPRB, 0.36997290E-03_JPRB, 0.36997523E-03_JPRB, 0.36996894E-03_JPRB, 0.36995890E-03_JPRB, 0.36994988E-03_JPRB, &
  & 0.36994569E-03_JPRB, 0.36994793E-03_JPRB, 0.36995712E-03_JPRB, 0.36997144E-03_JPRB, 0.36998914E-03_JPRB, 0.37000902E-03_JPRB, &
  & 0.37002913E-03_JPRB, 0.37004572E-03_JPRB, 0.37005614E-03_JPRB, 0.37005893E-03_JPRB, 0.37005221E-03_JPRB, 0.37003524E-03_JPRB, &
  & 0.37000852E-03_JPRB, 0.36997342E-03_JPRB, 0.36993279E-03_JPRB, 0.36988952E-03_JPRB, 0.36984647E-03_JPRB, 0.36980427E-03_JPRB, &
  & 0.36976277E-03_JPRB, 0.36972086E-03_JPRB, 0.36967697E-03_JPRB, 0.36962971E-03_JPRB, 0.36957831E-03_JPRB, 0.36952301E-03_JPRB, &
  & 0.36946489E-03_JPRB, 0.36940590E-03_JPRB, 0.36934792E-03_JPRB, 0.36929239E-03_JPRB, 0.36924006E-03_JPRB, 0.36919161E-03_JPRB, &
  & 0.36914658E-03_JPRB, 0.36910476E-03_JPRB, 0.36905656E-03_JPRB, 0.36897926E-03_JPRB /)

RGHG1(:,20,10) = (/ &
  & 0.36723079E-03_JPRB, 0.36748993E-03_JPRB, 0.36765615E-03_JPRB, 0.36780041E-03_JPRB, 0.36795306E-03_JPRB, 0.36811206E-03_JPRB, &
  & 0.36827859E-03_JPRB, 0.36844891E-03_JPRB, 0.36861864E-03_JPRB, 0.36878284E-03_JPRB, 0.36893837E-03_JPRB, 0.36908220E-03_JPRB, &
  & 0.36921352E-03_JPRB, 0.36933232E-03_JPRB, 0.36943966E-03_JPRB, 0.36953675E-03_JPRB, 0.36962540E-03_JPRB, 0.36970695E-03_JPRB, &
  & 0.36978288E-03_JPRB, 0.36985430E-03_JPRB, 0.36992159E-03_JPRB, 0.36998431E-03_JPRB, 0.37004074E-03_JPRB, 0.37008818E-03_JPRB, &
  & 0.37012465E-03_JPRB, 0.37014892E-03_JPRB, 0.37016172E-03_JPRB, 0.37016562E-03_JPRB, 0.37016411E-03_JPRB, 0.37015922E-03_JPRB, &
  & 0.37015395E-03_JPRB, 0.37015014E-03_JPRB, 0.37014874E-03_JPRB, 0.37015069E-03_JPRB, 0.37015681E-03_JPRB, 0.37016466E-03_JPRB, &
  & 0.37017462E-03_JPRB, 0.37018550E-03_JPRB, 0.37019359E-03_JPRB, 0.37019679E-03_JPRB, 0.37019281E-03_JPRB, 0.37018102E-03_JPRB, &
  & 0.37016082E-03_JPRB, 0.37013309E-03_JPRB, 0.37010023E-03_JPRB, 0.37006446E-03_JPRB, 0.37002776E-03_JPRB, 0.36999135E-03_JPRB, &
  & 0.36995480E-03_JPRB, 0.36991731E-03_JPRB, 0.36987787E-03_JPRB, 0.36983547E-03_JPRB, 0.36978911E-03_JPRB, 0.36973914E-03_JPRB, &
  & 0.36968675E-03_JPRB, 0.36963349E-03_JPRB, 0.36958075E-03_JPRB, 0.36952982E-03_JPRB, 0.36948168E-03_JPRB, 0.36943657E-03_JPRB, &
  & 0.36939522E-03_JPRB, 0.36935406E-03_JPRB, 0.36931297E-03_JPRB, 0.36923392E-03_JPRB /)

RGHG1(:,21,10) = (/ &
  & 0.36768464E-03_JPRB, 0.36792312E-03_JPRB, 0.36806721E-03_JPRB, 0.36819233E-03_JPRB, 0.36832053E-03_JPRB, 0.36845417E-03_JPRB, &
  & 0.36859312E-03_JPRB, 0.36873581E-03_JPRB, 0.36887845E-03_JPRB, 0.36901783E-03_JPRB, 0.36915066E-03_JPRB, 0.36927467E-03_JPRB, &
  & 0.36938878E-03_JPRB, 0.36949306E-03_JPRB, 0.36958803E-03_JPRB, 0.36967467E-03_JPRB, 0.36975436E-03_JPRB, 0.36982872E-03_JPRB, &
  & 0.36989886E-03_JPRB, 0.36996600E-03_JPRB, 0.37003096E-03_JPRB, 0.37009324E-03_JPRB, 0.37015119E-03_JPRB, 0.37020241E-03_JPRB, &
  & 0.37024415E-03_JPRB, 0.37027552E-03_JPRB, 0.37029648E-03_JPRB, 0.37030884E-03_JPRB, 0.37031440E-03_JPRB, 0.37031475E-03_JPRB, &
  & 0.37031173E-03_JPRB, 0.37030660E-03_JPRB, 0.37030122E-03_JPRB, 0.37029665E-03_JPRB, 0.37029525E-03_JPRB, 0.37029717E-03_JPRB, &
  & 0.37030142E-03_JPRB, 0.37030666E-03_JPRB, 0.37031178E-03_JPRB, 0.37031420E-03_JPRB, 0.37031158E-03_JPRB, 0.37030230E-03_JPRB, &
  & 0.37028617E-03_JPRB, 0.37026335E-03_JPRB, 0.37023565E-03_JPRB, 0.37020424E-03_JPRB, 0.37017156E-03_JPRB, 0.37013830E-03_JPRB, &
  & 0.37010448E-03_JPRB, 0.37006990E-03_JPRB, 0.37003338E-03_JPRB, 0.36999420E-03_JPRB, 0.36995212E-03_JPRB, 0.36990750E-03_JPRB, &
  & 0.36986114E-03_JPRB, 0.36981428E-03_JPRB, 0.36976763E-03_JPRB, 0.36972229E-03_JPRB, 0.36967883E-03_JPRB, 0.36963786E-03_JPRB, &
  & 0.36959897E-03_JPRB, 0.36956312E-03_JPRB, 0.36952001E-03_JPRB, 0.36945281E-03_JPRB /)

RGHG1(:,22,10) = (/ &
  & 0.36808848E-03_JPRB, 0.36829419E-03_JPRB, 0.36841739E-03_JPRB, 0.36851934E-03_JPRB, 0.36862516E-03_JPRB, 0.36873369E-03_JPRB, &
  & 0.36884705E-03_JPRB, 0.36896448E-03_JPRB, 0.36908334E-03_JPRB, 0.36920077E-03_JPRB, 0.36931428E-03_JPRB, 0.36942147E-03_JPRB, &
  & 0.36952147E-03_JPRB, 0.36961384E-03_JPRB, 0.36969889E-03_JPRB, 0.36977729E-03_JPRB, 0.36985052E-03_JPRB, 0.36991941E-03_JPRB, &
  & 0.36998553E-03_JPRB, 0.37004997E-03_JPRB, 0.37011332E-03_JPRB, 0.37017520E-03_JPRB, 0.37023411E-03_JPRB, 0.37028774E-03_JPRB, &
  & 0.37033347E-03_JPRB, 0.37036947E-03_JPRB, 0.37039630E-03_JPRB, 0.37041475E-03_JPRB, 0.37042596E-03_JPRB, 0.37043123E-03_JPRB, &
  & 0.37043137E-03_JPRB, 0.37042756E-03_JPRB, 0.37042142E-03_JPRB, 0.37041446E-03_JPRB, 0.37040917E-03_JPRB, 0.37040605E-03_JPRB, &
  & 0.37040643E-03_JPRB, 0.37041001E-03_JPRB, 0.37041318E-03_JPRB, 0.37041464E-03_JPRB, 0.37041213E-03_JPRB, 0.37040436E-03_JPRB, &
  & 0.37039025E-03_JPRB, 0.37037022E-03_JPRB, 0.37034517E-03_JPRB, 0.37031644E-03_JPRB, 0.37028568E-03_JPRB, 0.37025427E-03_JPRB, &
  & 0.37022211E-03_JPRB, 0.37018905E-03_JPRB, 0.37015427E-03_JPRB, 0.37011784E-03_JPRB, 0.37007948E-03_JPRB, 0.37003975E-03_JPRB, &
  & 0.36999906E-03_JPRB, 0.36995820E-03_JPRB, 0.36991766E-03_JPRB, 0.36987785E-03_JPRB, 0.36983920E-03_JPRB, 0.36980218E-03_JPRB, &
  & 0.36976743E-03_JPRB, 0.36973227E-03_JPRB, 0.36969647E-03_JPRB, 0.36962988E-03_JPRB /)

RGHG1(:,23,10) = (/ &
  & 0.36842638E-03_JPRB, 0.36859690E-03_JPRB, 0.36869894E-03_JPRB, 0.36878407E-03_JPRB, 0.36886934E-03_JPRB, 0.36895752E-03_JPRB, &
  & 0.36905022E-03_JPRB, 0.36914676E-03_JPRB, 0.36924565E-03_JPRB, 0.36934513E-03_JPRB, 0.36944263E-03_JPRB, 0.36953652E-03_JPRB, &
  & 0.36962531E-03_JPRB, 0.36970849E-03_JPRB, 0.36978623E-03_JPRB, 0.36985875E-03_JPRB, 0.36992703E-03_JPRB, 0.36999211E-03_JPRB, &
  & 0.37005541E-03_JPRB, 0.37011784E-03_JPRB, 0.37017986E-03_JPRB, 0.37024156E-03_JPRB, 0.37030081E-03_JPRB, 0.37035573E-03_JPRB, &
  & 0.37040346E-03_JPRB, 0.37044258E-03_JPRB, 0.37047346E-03_JPRB, 0.37049601E-03_JPRB, 0.37051155E-03_JPRB, 0.37052066E-03_JPRB, &
  & 0.37052433E-03_JPRB, 0.37052331E-03_JPRB, 0.37051862E-03_JPRB, 0.37051205E-03_JPRB, 0.37050626E-03_JPRB, 0.37050218E-03_JPRB, &
  & 0.37050055E-03_JPRB, 0.37050102E-03_JPRB, 0.37050160E-03_JPRB, 0.37050145E-03_JPRB, 0.37049799E-03_JPRB, 0.37049028E-03_JPRB, &
  & 0.37047704E-03_JPRB, 0.37045838E-03_JPRB, 0.37043466E-03_JPRB, 0.37040748E-03_JPRB, 0.37037799E-03_JPRB, 0.37034741E-03_JPRB, &
  & 0.37031612E-03_JPRB, 0.37028387E-03_JPRB, 0.37025052E-03_JPRB, 0.37021603E-03_JPRB, 0.37018093E-03_JPRB, 0.37014528E-03_JPRB, &
  & 0.37010954E-03_JPRB, 0.37007389E-03_JPRB, 0.37003862E-03_JPRB, 0.37000387E-03_JPRB, 0.36996964E-03_JPRB, 0.36993649E-03_JPRB, &
  & 0.36990439E-03_JPRB, 0.36987365E-03_JPRB, 0.36983783E-03_JPRB, 0.36977822E-03_JPRB /)

RGHG1(:,24,10) = (/ &
  & 0.36869993E-03_JPRB, 0.36884355E-03_JPRB, 0.36892461E-03_JPRB, 0.36899513E-03_JPRB, 0.36906480E-03_JPRB, 0.36913727E-03_JPRB, &
  & 0.36921358E-03_JPRB, 0.36929405E-03_JPRB, 0.36937735E-03_JPRB, 0.36946227E-03_JPRB, 0.36954726E-03_JPRB, 0.36963058E-03_JPRB, &
  & 0.36971091E-03_JPRB, 0.36978739E-03_JPRB, 0.36985986E-03_JPRB, 0.36992820E-03_JPRB, 0.36999327E-03_JPRB, 0.37005561E-03_JPRB, &
  & 0.37011690E-03_JPRB, 0.37017791E-03_JPRB, 0.37023885E-03_JPRB, 0.37029950E-03_JPRB, 0.37035826E-03_JPRB, 0.37041298E-03_JPRB, &
  & 0.37046144E-03_JPRB, 0.37050209E-03_JPRB, 0.37053489E-03_JPRB, 0.37056036E-03_JPRB, 0.37057919E-03_JPRB, 0.37059182E-03_JPRB, &
  & 0.37059875E-03_JPRB, 0.37060049E-03_JPRB, 0.37059846E-03_JPRB, 0.37059380E-03_JPRB, 0.37058842E-03_JPRB, 0.37058382E-03_JPRB, &
  & 0.37058117E-03_JPRB, 0.37058000E-03_JPRB, 0.37057869E-03_JPRB, 0.37057657E-03_JPRB, 0.37057183E-03_JPRB, 0.37056324E-03_JPRB, &
  & 0.37055003E-03_JPRB, 0.37053184E-03_JPRB, 0.37050873E-03_JPRB, 0.37048222E-03_JPRB, 0.37045332E-03_JPRB, 0.37042331E-03_JPRB, &
  & 0.37039226E-03_JPRB, 0.37036071E-03_JPRB, 0.37032834E-03_JPRB, 0.37029569E-03_JPRB, 0.37026312E-03_JPRB, 0.37023105E-03_JPRB, &
  & 0.37019944E-03_JPRB, 0.37016819E-03_JPRB, 0.37013731E-03_JPRB, 0.37010649E-03_JPRB, 0.37007604E-03_JPRB, 0.37004612E-03_JPRB, &
  & 0.37001717E-03_JPRB, 0.36998806E-03_JPRB, 0.36995611E-03_JPRB, 0.36990116E-03_JPRB /)

RGHG1(:,25,10) = (/ &
  & 0.36892400E-03_JPRB, 0.36904268E-03_JPRB, 0.36911113E-03_JPRB, 0.36916879E-03_JPRB, 0.36922609E-03_JPRB, 0.36928619E-03_JPRB, &
  & 0.36935008E-03_JPRB, 0.36941774E-03_JPRB, 0.36948896E-03_JPRB, 0.36956268E-03_JPRB, 0.36963780E-03_JPRB, 0.36971265E-03_JPRB, &
  & 0.36978640E-03_JPRB, 0.36985800E-03_JPRB, 0.36992668E-03_JPRB, 0.36999254E-03_JPRB, 0.37005561E-03_JPRB, 0.37011635E-03_JPRB, &
  & 0.37017610E-03_JPRB, 0.37023533E-03_JPRB, 0.37029479E-03_JPRB, 0.37035363E-03_JPRB, 0.37041114E-03_JPRB, 0.37046470E-03_JPRB, &
  & 0.37051260E-03_JPRB, 0.37055355E-03_JPRB, 0.37058760E-03_JPRB, 0.37061455E-03_JPRB, 0.37063519E-03_JPRB, 0.37065012E-03_JPRB, &
  & 0.37065978E-03_JPRB, 0.37066423E-03_JPRB, 0.37066490E-03_JPRB, 0.37066248E-03_JPRB, 0.37065858E-03_JPRB, 0.37065457E-03_JPRB, &
  & 0.37065125E-03_JPRB, 0.37064840E-03_JPRB, 0.37064569E-03_JPRB, 0.37064170E-03_JPRB, 0.37063516E-03_JPRB, 0.37062520E-03_JPRB, &
  & 0.37061120E-03_JPRB, 0.37059281E-03_JPRB, 0.37057020E-03_JPRB, 0.37054421E-03_JPRB, 0.37051574E-03_JPRB, 0.37048612E-03_JPRB, &
  & 0.37045564E-03_JPRB, 0.37042450E-03_JPRB, 0.37039313E-03_JPRB, 0.37036208E-03_JPRB, 0.37033172E-03_JPRB, 0.37030244E-03_JPRB, &
  & 0.37027389E-03_JPRB, 0.37024613E-03_JPRB, 0.37021883E-03_JPRB, 0.37019170E-03_JPRB, 0.37016452E-03_JPRB, 0.37013763E-03_JPRB, &
  & 0.37011111E-03_JPRB, 0.37008469E-03_JPRB, 0.37005558E-03_JPRB, 0.37000410E-03_JPRB /)

RGHG1(:,26,10) = (/ &
  & 0.36911119E-03_JPRB, 0.36921373E-03_JPRB, 0.36926917E-03_JPRB, 0.36931733E-03_JPRB, 0.36936533E-03_JPRB, 0.36941565E-03_JPRB, &
  & 0.36946966E-03_JPRB, 0.36952755E-03_JPRB, 0.36958908E-03_JPRB, 0.36965404E-03_JPRB, 0.36972118E-03_JPRB, 0.36978957E-03_JPRB, &
  & 0.36985817E-03_JPRB, 0.36992581E-03_JPRB, 0.36999179E-03_JPRB, 0.37005573E-03_JPRB, 0.37011754E-03_JPRB, 0.37017721E-03_JPRB, &
  & 0.37023559E-03_JPRB, 0.37029310E-03_JPRB, 0.37035026E-03_JPRB, 0.37040672E-03_JPRB, 0.37046164E-03_JPRB, 0.37051315E-03_JPRB, &
  & 0.37055946E-03_JPRB, 0.37059959E-03_JPRB, 0.37063326E-03_JPRB, 0.37066094E-03_JPRB, 0.37068254E-03_JPRB, 0.37069901E-03_JPRB, &
  & 0.37071030E-03_JPRB, 0.37071714E-03_JPRB, 0.37072017E-03_JPRB, 0.37072017E-03_JPRB, 0.37071810E-03_JPRB, 0.37071493E-03_JPRB, &
  & 0.37071129E-03_JPRB, 0.37070733E-03_JPRB, 0.37070282E-03_JPRB, 0.37069700E-03_JPRB, 0.37068894E-03_JPRB, 0.37067785E-03_JPRB, &
  & 0.37066301E-03_JPRB, 0.37064438E-03_JPRB, 0.37062191E-03_JPRB, 0.37059619E-03_JPRB, 0.37056807E-03_JPRB, 0.37053853E-03_JPRB, &
  & 0.37050832E-03_JPRB, 0.37047779E-03_JPRB, 0.37044744E-03_JPRB, 0.37041784E-03_JPRB, 0.37038955E-03_JPRB, 0.37036251E-03_JPRB, &
  & 0.37033661E-03_JPRB, 0.37031158E-03_JPRB, 0.37028699E-03_JPRB, 0.37026260E-03_JPRB, 0.37023815E-03_JPRB, 0.37021391E-03_JPRB, &
  & 0.37018984E-03_JPRB, 0.37016621E-03_JPRB, 0.37013879E-03_JPRB, 0.37009455E-03_JPRB /)

RGHG1(:,27,10) = (/ &
  & 0.36927371E-03_JPRB, 0.36936224E-03_JPRB, 0.36941041E-03_JPRB, 0.36945095E-03_JPRB, 0.36949129E-03_JPRB, 0.36953416E-03_JPRB, &
  & 0.36958026E-03_JPRB, 0.36963023E-03_JPRB, 0.36968425E-03_JPRB, 0.36974181E-03_JPRB, 0.36980261E-03_JPRB, 0.36986559E-03_JPRB, &
  & 0.36992982E-03_JPRB, 0.36999429E-03_JPRB, 0.37005806E-03_JPRB, 0.37012072E-03_JPRB, 0.37018111E-03_JPRB, 0.37023958E-03_JPRB, &
  & 0.37029624E-03_JPRB, 0.37035192E-03_JPRB, 0.37040637E-03_JPRB, 0.37045995E-03_JPRB, 0.37051155E-03_JPRB, 0.37055992E-03_JPRB, &
  & 0.37060367E-03_JPRB, 0.37064200E-03_JPRB, 0.37067450E-03_JPRB, 0.37070154E-03_JPRB, 0.37072354E-03_JPRB, 0.37074074E-03_JPRB, &
  & 0.37075326E-03_JPRB, 0.37076164E-03_JPRB, 0.37076639E-03_JPRB, 0.37076831E-03_JPRB, 0.37076781E-03_JPRB, 0.37076560E-03_JPRB, &
  & 0.37076205E-03_JPRB, 0.37075733E-03_JPRB, 0.37075154E-03_JPRB, 0.37074421E-03_JPRB, 0.37073455E-03_JPRB, 0.37072232E-03_JPRB, &
  & 0.37070698E-03_JPRB, 0.37068815E-03_JPRB, 0.37066583E-03_JPRB, 0.37064025E-03_JPRB, 0.37061263E-03_JPRB, 0.37058370E-03_JPRB, &
  & 0.37055422E-03_JPRB, 0.37052456E-03_JPRB, 0.37049520E-03_JPRB, 0.37046685E-03_JPRB, 0.37044007E-03_JPRB, 0.37041481E-03_JPRB, &
  & 0.37039083E-03_JPRB, 0.37036778E-03_JPRB, 0.37034522E-03_JPRB, 0.37032290E-03_JPRB, 0.37030055E-03_JPRB, 0.37027866E-03_JPRB, &
  & 0.37025742E-03_JPRB, 0.37023565E-03_JPRB, 0.37021289E-03_JPRB, 0.37017150E-03_JPRB /)

RGHG1(:,28,10) = (/ &
  & 0.36941929E-03_JPRB, 0.36949836E-03_JPRB, 0.36953972E-03_JPRB, 0.36957450E-03_JPRB, 0.36960910E-03_JPRB, 0.36964566E-03_JPRB, &
  & 0.36968579E-03_JPRB, 0.36972971E-03_JPRB, 0.36977741E-03_JPRB, 0.36982927E-03_JPRB, 0.36988463E-03_JPRB, 0.36994307E-03_JPRB, &
  & 0.37000352E-03_JPRB, 0.37006495E-03_JPRB, 0.37012663E-03_JPRB, 0.37018739E-03_JPRB, 0.37024618E-03_JPRB, 0.37030340E-03_JPRB, &
  & 0.37035823E-03_JPRB, 0.37041155E-03_JPRB, 0.37046301E-03_JPRB, 0.37051321E-03_JPRB, 0.37056115E-03_JPRB, 0.37060567E-03_JPRB, &
  & 0.37064619E-03_JPRB, 0.37068175E-03_JPRB, 0.37071225E-03_JPRB, 0.37073821E-03_JPRB, 0.37075963E-03_JPRB, 0.37077686E-03_JPRB, &
  & 0.37079005E-03_JPRB, 0.37079951E-03_JPRB, 0.37080573E-03_JPRB, 0.37080896E-03_JPRB, 0.37080960E-03_JPRB, 0.37080818E-03_JPRB, &
  & 0.37080472E-03_JPRB, 0.37079939E-03_JPRB, 0.37079252E-03_JPRB, 0.37078399E-03_JPRB, 0.37077343E-03_JPRB, 0.37076039E-03_JPRB, &
  & 0.37074462E-03_JPRB, 0.37072576E-03_JPRB, 0.37070364E-03_JPRB, 0.37067843E-03_JPRB, 0.37065125E-03_JPRB, 0.37062264E-03_JPRB, &
  & 0.37059357E-03_JPRB, 0.37056449E-03_JPRB, 0.37053617E-03_JPRB, 0.37050940E-03_JPRB, 0.37048428E-03_JPRB, 0.37046059E-03_JPRB, &
  & 0.37043815E-03_JPRB, 0.37041673E-03_JPRB, 0.37039595E-03_JPRB, 0.37037552E-03_JPRB, 0.37035550E-03_JPRB, 0.37033571E-03_JPRB, &
  & 0.37031603E-03_JPRB, 0.37029694E-03_JPRB, 0.37027497E-03_JPRB, 0.37023998E-03_JPRB /)

RGHG1(:,29,10) = (/ &
  & 0.36955293E-03_JPRB, 0.36962397E-03_JPRB, 0.36966114E-03_JPRB, 0.36969149E-03_JPRB, 0.36972127E-03_JPRB, 0.36975322E-03_JPRB, &
  & 0.36978826E-03_JPRB, 0.36982706E-03_JPRB, 0.36986993E-03_JPRB, 0.36991687E-03_JPRB, 0.36996781E-03_JPRB, 0.37002211E-03_JPRB, &
  & 0.37007916E-03_JPRB, 0.37013783E-03_JPRB, 0.37019735E-03_JPRB, 0.37025558E-03_JPRB, 0.37031289E-03_JPRB, 0.37036795E-03_JPRB, &
  & 0.37042060E-03_JPRB, 0.37047113E-03_JPRB, 0.37051961E-03_JPRB, 0.37056592E-03_JPRB, 0.37060972E-03_JPRB, 0.37065041E-03_JPRB, &
  & 0.37068714E-03_JPRB, 0.37071950E-03_JPRB, 0.37074761E-03_JPRB, 0.37077174E-03_JPRB, 0.37079214E-03_JPRB, 0.37080879E-03_JPRB, &
  & 0.37082203E-03_JPRB, 0.37083199E-03_JPRB, 0.37083891E-03_JPRB, 0.37084287E-03_JPRB, 0.37084427E-03_JPRB, 0.37084345E-03_JPRB, &
  & 0.37084005E-03_JPRB, 0.37083455E-03_JPRB, 0.37082721E-03_JPRB, 0.37081784E-03_JPRB, 0.37080678E-03_JPRB, 0.37079331E-03_JPRB, &
  & 0.37077739E-03_JPRB, 0.37075850E-03_JPRB, 0.37073664E-03_JPRB, 0.37071208E-03_JPRB, 0.37068533E-03_JPRB, 0.37065742E-03_JPRB, &
  & 0.37062893E-03_JPRB, 0.37060096E-03_JPRB, 0.37057401E-03_JPRB, 0.37054846E-03_JPRB, 0.37052439E-03_JPRB, 0.37050183E-03_JPRB, &
  & 0.37048073E-03_JPRB, 0.37046068E-03_JPRB, 0.37044147E-03_JPRB, 0.37042249E-03_JPRB, 0.37040366E-03_JPRB, 0.37038507E-03_JPRB, &
  & 0.37036714E-03_JPRB, 0.37034918E-03_JPRB, 0.37033050E-03_JPRB, 0.37029805E-03_JPRB /)

RGHG1(:,30,10) = (/ &
  & 0.36967741E-03_JPRB, 0.36974277E-03_JPRB, 0.36977552E-03_JPRB, 0.36980229E-03_JPRB, 0.36982863E-03_JPRB, 0.36985672E-03_JPRB, &
  & 0.36988780E-03_JPRB, 0.36992258E-03_JPRB, 0.36996132E-03_JPRB, 0.37000445E-03_JPRB, 0.37005142E-03_JPRB, 0.37010212E-03_JPRB, &
  & 0.37015570E-03_JPRB, 0.37021149E-03_JPRB, 0.37026813E-03_JPRB, 0.37032380E-03_JPRB, 0.37037875E-03_JPRB, 0.37043152E-03_JPRB, &
  & 0.37048163E-03_JPRB, 0.37052919E-03_JPRB, 0.37057424E-03_JPRB, 0.37061685E-03_JPRB, 0.37065675E-03_JPRB, 0.37069339E-03_JPRB, &
  & 0.37072643E-03_JPRB, 0.37075547E-03_JPRB, 0.37078076E-03_JPRB, 0.37080274E-03_JPRB, 0.37082145E-03_JPRB, 0.37083711E-03_JPRB, &
  & 0.37085000E-03_JPRB, 0.37085998E-03_JPRB, 0.37086708E-03_JPRB, 0.37087157E-03_JPRB, 0.37087337E-03_JPRB, 0.37087273E-03_JPRB, &
  & 0.37086953E-03_JPRB, 0.37086409E-03_JPRB, 0.37085637E-03_JPRB, 0.37084692E-03_JPRB, 0.37083545E-03_JPRB, 0.37082189E-03_JPRB, &
  & 0.37080597E-03_JPRB, 0.37078757E-03_JPRB, 0.37076630E-03_JPRB, 0.37074240E-03_JPRB, 0.37071647E-03_JPRB, 0.37068917E-03_JPRB, &
  & 0.37066176E-03_JPRB, 0.37063478E-03_JPRB, 0.37060888E-03_JPRB, 0.37058431E-03_JPRB, 0.37056138E-03_JPRB, 0.37053990E-03_JPRB, &
  & 0.37051985E-03_JPRB, 0.37050078E-03_JPRB, 0.37048245E-03_JPRB, 0.37046435E-03_JPRB, 0.37044659E-03_JPRB, 0.37042919E-03_JPRB, &
  & 0.37041240E-03_JPRB, 0.37039618E-03_JPRB, 0.37037808E-03_JPRB, 0.37034912E-03_JPRB /)

RGHG1(:,31,10) = (/ &
  & 0.36979435E-03_JPRB, 0.36985392E-03_JPRB, 0.36988378E-03_JPRB, 0.36990776E-03_JPRB, 0.36993096E-03_JPRB, 0.36995596E-03_JPRB, &
  & 0.36998375E-03_JPRB, 0.37001510E-03_JPRB, 0.37005069E-03_JPRB, 0.37009013E-03_JPRB, 0.37013373E-03_JPRB, 0.37018105E-03_JPRB, &
  & 0.37023149E-03_JPRB, 0.37028413E-03_JPRB, 0.37033769E-03_JPRB, 0.37039063E-03_JPRB, 0.37044255E-03_JPRB, 0.37049263E-03_JPRB, &
  & 0.37053993E-03_JPRB, 0.37058454E-03_JPRB, 0.37062637E-03_JPRB, 0.37066545E-03_JPRB, 0.37070148E-03_JPRB, 0.37073443E-03_JPRB, &
  & 0.37076374E-03_JPRB, 0.37078938E-03_JPRB, 0.37081190E-03_JPRB, 0.37083155E-03_JPRB, 0.37084857E-03_JPRB, 0.37086304E-03_JPRB, &
  & 0.37087497E-03_JPRB, 0.37088440E-03_JPRB, 0.37089147E-03_JPRB, 0.37089604E-03_JPRB, 0.37089788E-03_JPRB, 0.37089735E-03_JPRB, &
  & 0.37089436E-03_JPRB, 0.37088903E-03_JPRB, 0.37088137E-03_JPRB, 0.37087180E-03_JPRB, 0.37086019E-03_JPRB, 0.37084683E-03_JPRB, &
  & 0.37083129E-03_JPRB, 0.37081339E-03_JPRB, 0.37079304E-03_JPRB, 0.37076991E-03_JPRB, 0.37074453E-03_JPRB, 0.37071813E-03_JPRB, &
  & 0.37069153E-03_JPRB, 0.37066560E-03_JPRB, 0.37064066E-03_JPRB, 0.37061729E-03_JPRB, 0.37059552E-03_JPRB, 0.37057514E-03_JPRB, &
  & 0.37055602E-03_JPRB, 0.37053775E-03_JPRB, 0.37052002E-03_JPRB, 0.37050276E-03_JPRB, 0.37048588E-03_JPRB, 0.37046953E-03_JPRB, &
  & 0.37045372E-03_JPRB, 0.37043804E-03_JPRB, 0.37042153E-03_JPRB, 0.37039389E-03_JPRB /)

RGHG1(:,32,10) = (/ &
  & 0.36990331E-03_JPRB, 0.36995808E-03_JPRB, 0.36998506E-03_JPRB, 0.37000654E-03_JPRB, 0.37002764E-03_JPRB, 0.37005008E-03_JPRB, &
  & 0.37007534E-03_JPRB, 0.37010398E-03_JPRB, 0.37013635E-03_JPRB, 0.37017273E-03_JPRB, 0.37021303E-03_JPRB, 0.37025701E-03_JPRB, &
  & 0.37030410E-03_JPRB, 0.37035331E-03_JPRB, 0.37040352E-03_JPRB, 0.37045352E-03_JPRB, 0.37050244E-03_JPRB, 0.37054956E-03_JPRB, &
  & 0.37059400E-03_JPRB, 0.37063585E-03_JPRB, 0.37067471E-03_JPRB, 0.37071048E-03_JPRB, 0.37074307E-03_JPRB, 0.37077241E-03_JPRB, &
  & 0.37079846E-03_JPRB, 0.37082110E-03_JPRB, 0.37084095E-03_JPRB, 0.37085827E-03_JPRB, 0.37087343E-03_JPRB, 0.37088641E-03_JPRB, &
  & 0.37089738E-03_JPRB, 0.37090608E-03_JPRB, 0.37091260E-03_JPRB, 0.37091679E-03_JPRB, 0.37091869E-03_JPRB, 0.37091831E-03_JPRB, &
  & 0.37091540E-03_JPRB, 0.37091019E-03_JPRB, 0.37090280E-03_JPRB, 0.37089331E-03_JPRB, 0.37088196E-03_JPRB, 0.37086886E-03_JPRB, &
  & 0.37085378E-03_JPRB, 0.37083661E-03_JPRB, 0.37081691E-03_JPRB, 0.37079470E-03_JPRB, 0.37077058E-03_JPRB, 0.37074537E-03_JPRB, &
  & 0.37071985E-03_JPRB, 0.37069496E-03_JPRB, 0.37067122E-03_JPRB, 0.37064881E-03_JPRB, 0.37062785E-03_JPRB, 0.37060841E-03_JPRB, &
  & 0.37059007E-03_JPRB, 0.37057235E-03_JPRB, 0.37055535E-03_JPRB, 0.37053879E-03_JPRB, 0.37052255E-03_JPRB, 0.37050666E-03_JPRB, &
  & 0.37049130E-03_JPRB, 0.37047666E-03_JPRB, 0.37046048E-03_JPRB, 0.37043457E-03_JPRB /)

RGHG1(:,33,10) = (/ &
  & 0.37000375E-03_JPRB, 0.37005381E-03_JPRB, 0.37007849E-03_JPRB, 0.37009851E-03_JPRB, 0.37011740E-03_JPRB, 0.37013815E-03_JPRB, &
  & 0.37016123E-03_JPRB, 0.37018763E-03_JPRB, 0.37021737E-03_JPRB, 0.37025087E-03_JPRB, 0.37028803E-03_JPRB, 0.37032861E-03_JPRB, &
  & 0.37037214E-03_JPRB, 0.37041787E-03_JPRB, 0.37046461E-03_JPRB, 0.37051141E-03_JPRB, 0.37055736E-03_JPRB, 0.37060142E-03_JPRB, &
  & 0.37064328E-03_JPRB, 0.37068245E-03_JPRB, 0.37071857E-03_JPRB, 0.37075154E-03_JPRB, 0.37078117E-03_JPRB, 0.37080754E-03_JPRB, &
  & 0.37083062E-03_JPRB, 0.37085047E-03_JPRB, 0.37086781E-03_JPRB, 0.37088289E-03_JPRB, 0.37089613E-03_JPRB, 0.37090748E-03_JPRB, &
  & 0.37091711E-03_JPRB, 0.37092497E-03_JPRB, 0.37093082E-03_JPRB, 0.37093463E-03_JPRB, 0.37093647E-03_JPRB, 0.37093589E-03_JPRB, &
  & 0.37093295E-03_JPRB, 0.37092812E-03_JPRB, 0.37092101E-03_JPRB, 0.37091199E-03_JPRB, 0.37090111E-03_JPRB, 0.37088856E-03_JPRB, &
  & 0.37087401E-03_JPRB, 0.37085748E-03_JPRB, 0.37083856E-03_JPRB, 0.37081743E-03_JPRB, 0.37079444E-03_JPRB, 0.37077055E-03_JPRB, &
  & 0.37074630E-03_JPRB, 0.37072261E-03_JPRB, 0.37070003E-03_JPRB, 0.37067875E-03_JPRB, 0.37065896E-03_JPRB, 0.37064031E-03_JPRB, &
  & 0.37062255E-03_JPRB, 0.37060562E-03_JPRB, 0.37058914E-03_JPRB, 0.37057293E-03_JPRB, 0.37055701E-03_JPRB, 0.37054167E-03_JPRB, &
  & 0.37052704E-03_JPRB, 0.37051275E-03_JPRB, 0.37049744E-03_JPRB, 0.37047235E-03_JPRB /)

RGHG1(:,34,10) = (/ &
  & 0.37009516E-03_JPRB, 0.37014094E-03_JPRB, 0.37016382E-03_JPRB, 0.37018210E-03_JPRB, 0.37020014E-03_JPRB, 0.37021923E-03_JPRB, &
  & 0.37024080E-03_JPRB, 0.37026519E-03_JPRB, 0.37029260E-03_JPRB, 0.37032343E-03_JPRB, 0.37035759E-03_JPRB, 0.37039482E-03_JPRB, &
  & 0.37043472E-03_JPRB, 0.37047680E-03_JPRB, 0.37051993E-03_JPRB, 0.37056344E-03_JPRB, 0.37060634E-03_JPRB, 0.37064790E-03_JPRB, &
  & 0.37068728E-03_JPRB, 0.37072395E-03_JPRB, 0.37075774E-03_JPRB, 0.37078848E-03_JPRB, 0.37081566E-03_JPRB, 0.37083949E-03_JPRB, &
  & 0.37085998E-03_JPRB, 0.37087747E-03_JPRB, 0.37089258E-03_JPRB, 0.37090556E-03_JPRB, 0.37091688E-03_JPRB, 0.37092669E-03_JPRB, &
  & 0.37093495E-03_JPRB, 0.37094165E-03_JPRB, 0.37094665E-03_JPRB, 0.37094997E-03_JPRB, 0.37095140E-03_JPRB, 0.37095082E-03_JPRB, &
  & 0.37094817E-03_JPRB, 0.37094354E-03_JPRB, 0.37093690E-03_JPRB, 0.37092861E-03_JPRB, 0.37091834E-03_JPRB, 0.37090614E-03_JPRB, &
  & 0.37089229E-03_JPRB, 0.37087628E-03_JPRB, 0.37085824E-03_JPRB, 0.37083821E-03_JPRB, 0.37081647E-03_JPRB, 0.37079386E-03_JPRB, &
  & 0.37077107E-03_JPRB, 0.37074878E-03_JPRB, 0.37072744E-03_JPRB, 0.37070733E-03_JPRB, 0.37068850E-03_JPRB, 0.37067072E-03_JPRB, &
  & 0.37065372E-03_JPRB, 0.37063725E-03_JPRB, 0.37062127E-03_JPRB, 0.37060550E-03_JPRB, 0.37058990E-03_JPRB, 0.37057506E-03_JPRB, &
  & 0.37056085E-03_JPRB, 0.37054709E-03_JPRB, 0.37053227E-03_JPRB, 0.37050812E-03_JPRB /)

RGHG1(:,35,10) = (/ &
  & 0.37017756E-03_JPRB, 0.37021950E-03_JPRB, 0.37024065E-03_JPRB, 0.37025817E-03_JPRB, 0.37027482E-03_JPRB, 0.37029310E-03_JPRB, &
  & 0.37031330E-03_JPRB, 0.37033594E-03_JPRB, 0.37036141E-03_JPRB, 0.37038964E-03_JPRB, 0.37042081E-03_JPRB, 0.37045474E-03_JPRB, &
  & 0.37049118E-03_JPRB, 0.37052965E-03_JPRB, 0.37056941E-03_JPRB, 0.37060969E-03_JPRB, 0.37064971E-03_JPRB, 0.37068862E-03_JPRB, &
  & 0.37072558E-03_JPRB, 0.37076054E-03_JPRB, 0.37079249E-03_JPRB, 0.37082119E-03_JPRB, 0.37084662E-03_JPRB, 0.37086857E-03_JPRB, &
  & 0.37088702E-03_JPRB, 0.37090253E-03_JPRB, 0.37091537E-03_JPRB, 0.37092640E-03_JPRB, 0.37093583E-03_JPRB, 0.37094398E-03_JPRB, &
  & 0.37095073E-03_JPRB, 0.37095617E-03_JPRB, 0.37096028E-03_JPRB, 0.37096304E-03_JPRB, 0.37096400E-03_JPRB, 0.37096336E-03_JPRB, &
  & 0.37096118E-03_JPRB, 0.37095696E-03_JPRB, 0.37095082E-03_JPRB, 0.37094310E-03_JPRB, 0.37093341E-03_JPRB, 0.37092189E-03_JPRB, &
  & 0.37090867E-03_JPRB, 0.37089339E-03_JPRB, 0.37087619E-03_JPRB, 0.37085719E-03_JPRB, 0.37083676E-03_JPRB, 0.37081548E-03_JPRB, &
  & 0.37079418E-03_JPRB, 0.37077325E-03_JPRB, 0.37075314E-03_JPRB, 0.37073420E-03_JPRB, 0.37071621E-03_JPRB, 0.37069939E-03_JPRB, &
  & 0.37068318E-03_JPRB, 0.37066746E-03_JPRB, 0.37065204E-03_JPRB, 0.37063673E-03_JPRB, 0.37062168E-03_JPRB, 0.37060707E-03_JPRB, &
  & 0.37059325E-03_JPRB, 0.37057986E-03_JPRB, 0.37056554E-03_JPRB, 0.37054205E-03_JPRB /)

RGHG1(:,36,10) = (/ &
  & 0.37025168E-03_JPRB, 0.37028993E-03_JPRB, 0.37030980E-03_JPRB, 0.37032584E-03_JPRB, 0.37034214E-03_JPRB, 0.37035937E-03_JPRB, &
  & 0.37037866E-03_JPRB, 0.37040000E-03_JPRB, 0.37042343E-03_JPRB, 0.37044944E-03_JPRB, 0.37047768E-03_JPRB, 0.37050861E-03_JPRB, &
  & 0.37054165E-03_JPRB, 0.37057669E-03_JPRB, 0.37061310E-03_JPRB, 0.37065038E-03_JPRB, 0.37068743E-03_JPRB, 0.37072407E-03_JPRB, &
  & 0.37075911E-03_JPRB, 0.37079220E-03_JPRB, 0.37082291E-03_JPRB, 0.37085050E-03_JPRB, 0.37087459E-03_JPRB, 0.37089497E-03_JPRB, &
  & 0.37091150E-03_JPRB, 0.37092500E-03_JPRB, 0.37093583E-03_JPRB, 0.37094488E-03_JPRB, 0.37095271E-03_JPRB, 0.37095911E-03_JPRB, &
  & 0.37096444E-03_JPRB, 0.37096872E-03_JPRB, 0.37097192E-03_JPRB, 0.37097384E-03_JPRB, 0.37097451E-03_JPRB, 0.37097395E-03_JPRB, &
  & 0.37097192E-03_JPRB, 0.37096816E-03_JPRB, 0.37096289E-03_JPRB, 0.37095582E-03_JPRB, 0.37094689E-03_JPRB, 0.37093615E-03_JPRB, &
  & 0.37092363E-03_JPRB, 0.37090902E-03_JPRB, 0.37089252E-03_JPRB, 0.37087459E-03_JPRB, 0.37085538E-03_JPRB, 0.37083548E-03_JPRB, &
  & 0.37081543E-03_JPRB, 0.37079572E-03_JPRB, 0.37077680E-03_JPRB, 0.37075896E-03_JPRB, 0.37074211E-03_JPRB, 0.37072619E-03_JPRB, &
  & 0.37071080E-03_JPRB, 0.37069593E-03_JPRB, 0.37068114E-03_JPRB, 0.37066641E-03_JPRB, 0.37065195E-03_JPRB, 0.37063769E-03_JPRB, &
  & 0.37062418E-03_JPRB, 0.37061123E-03_JPRB, 0.37059741E-03_JPRB, 0.37057468E-03_JPRB /)

RGHG1(:,37,10) = (/ &
  & 0.37031912E-03_JPRB, 0.37035369E-03_JPRB, 0.37037188E-03_JPRB, 0.37038731E-03_JPRB, 0.37040267E-03_JPRB, 0.37041953E-03_JPRB, &
  & 0.37043760E-03_JPRB, 0.37045754E-03_JPRB, 0.37047945E-03_JPRB, 0.37050323E-03_JPRB, 0.37052904E-03_JPRB, 0.37055678E-03_JPRB, &
  & 0.37058652E-03_JPRB, 0.37061819E-03_JPRB, 0.37065140E-03_JPRB, 0.37068571E-03_JPRB, 0.37072043E-03_JPRB, 0.37075471E-03_JPRB, &
  & 0.37078804E-03_JPRB, 0.37081991E-03_JPRB, 0.37084956E-03_JPRB, 0.37087614E-03_JPRB, 0.37089910E-03_JPRB, 0.37091778E-03_JPRB, &
  & 0.37093257E-03_JPRB, 0.37094415E-03_JPRB, 0.37095312E-03_JPRB, 0.37096033E-03_JPRB, 0.37096636E-03_JPRB, 0.37097128E-03_JPRB, &
  & 0.37097518E-03_JPRB, 0.37097820E-03_JPRB, 0.37098050E-03_JPRB, 0.37098190E-03_JPRB, 0.37098231E-03_JPRB, 0.37098181E-03_JPRB, &
  & 0.37098015E-03_JPRB, 0.37097721E-03_JPRB, 0.37097276E-03_JPRB, 0.37096671E-03_JPRB, 0.37095882E-03_JPRB, 0.37094898E-03_JPRB, &
  & 0.37093717E-03_JPRB, 0.37092328E-03_JPRB, 0.37090771E-03_JPRB, 0.37089072E-03_JPRB, 0.37087259E-03_JPRB, 0.37085396E-03_JPRB, &
  & 0.37083522E-03_JPRB, 0.37081676E-03_JPRB, 0.37079889E-03_JPRB, 0.37078193E-03_JPRB, 0.37076609E-03_JPRB, 0.37075119E-03_JPRB, &
  & 0.37073687E-03_JPRB, 0.37072290E-03_JPRB, 0.37070888E-03_JPRB, 0.37069485E-03_JPRB, 0.37068085E-03_JPRB, 0.37066717E-03_JPRB, &
  & 0.37065416E-03_JPRB, 0.37064165E-03_JPRB, 0.37062808E-03_JPRB, 0.37060591E-03_JPRB /)

RGHG1(:,38,10) = (/ &
  & 0.37038140E-03_JPRB, 0.37041199E-03_JPRB, 0.37042858E-03_JPRB, 0.37044298E-03_JPRB, 0.37045786E-03_JPRB, 0.37047389E-03_JPRB, &
  & 0.37049109E-03_JPRB, 0.37050986E-03_JPRB, 0.37053018E-03_JPRB, 0.37055183E-03_JPRB, 0.37057512E-03_JPRB, 0.37059994E-03_JPRB, &
  & 0.37062640E-03_JPRB, 0.37065486E-03_JPRB, 0.37068507E-03_JPRB, 0.37071650E-03_JPRB, 0.37074898E-03_JPRB, 0.37078149E-03_JPRB, &
  & 0.37081318E-03_JPRB, 0.37084374E-03_JPRB, 0.37087235E-03_JPRB, 0.37089776E-03_JPRB, 0.37091918E-03_JPRB, 0.37093600E-03_JPRB, &
  & 0.37094878E-03_JPRB, 0.37095833E-03_JPRB, 0.37096546E-03_JPRB, 0.37097107E-03_JPRB, 0.37097570E-03_JPRB, 0.37097925E-03_JPRB, &
  & 0.37098216E-03_JPRB, 0.37098446E-03_JPRB, 0.37098603E-03_JPRB, 0.37098711E-03_JPRB, 0.37098731E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098551E-03_JPRB, 0.37098321E-03_JPRB, 0.37097977E-03_JPRB, 0.37097489E-03_JPRB, 0.37096845E-03_JPRB, 0.37095990E-03_JPRB, &
  & 0.37094904E-03_JPRB, 0.37093624E-03_JPRB, 0.37092154E-03_JPRB, 0.37090550E-03_JPRB, 0.37088859E-03_JPRB, 0.37087110E-03_JPRB, &
  & 0.37085341E-03_JPRB, 0.37083583E-03_JPRB, 0.37081883E-03_JPRB, 0.37080306E-03_JPRB, 0.37078818E-03_JPRB, 0.37077433E-03_JPRB, &
  & 0.37076115E-03_JPRB, 0.37074820E-03_JPRB, 0.37073519E-03_JPRB, 0.37072200E-03_JPRB, 0.37070882E-03_JPRB, 0.37069587E-03_JPRB, &
  & 0.37068321E-03_JPRB, 0.37067104E-03_JPRB, 0.37065786E-03_JPRB, 0.37063583E-03_JPRB /)

RGHG1(:,39,10) = (/ &
  & 0.37043935E-03_JPRB, 0.37046598E-03_JPRB, 0.37048094E-03_JPRB, 0.37049453E-03_JPRB, 0.37050855E-03_JPRB, 0.37052395E-03_JPRB, &
  & 0.37054051E-03_JPRB, 0.37055794E-03_JPRB, 0.37057657E-03_JPRB, 0.37059624E-03_JPRB, 0.37061697E-03_JPRB, 0.37063888E-03_JPRB, &
  & 0.37066234E-03_JPRB, 0.37068751E-03_JPRB, 0.37071481E-03_JPRB, 0.37074392E-03_JPRB, 0.37077395E-03_JPRB, 0.37080454E-03_JPRB, &
  & 0.37083478E-03_JPRB, 0.37086409E-03_JPRB, 0.37089118E-03_JPRB, 0.37091499E-03_JPRB, 0.37093426E-03_JPRB, 0.37094898E-03_JPRB, &
  & 0.37095972E-03_JPRB, 0.37096743E-03_JPRB, 0.37097320E-03_JPRB, 0.37097762E-03_JPRB, 0.37098114E-03_JPRB, 0.37098399E-03_JPRB, &
  & 0.37098626E-03_JPRB, 0.37098792E-03_JPRB, 0.37098923E-03_JPRB, 0.37099005E-03_JPRB, 0.37099014E-03_JPRB, 0.37098970E-03_JPRB, &
  & 0.37098859E-03_JPRB, 0.37098679E-03_JPRB, 0.37098420E-03_JPRB, 0.37098039E-03_JPRB, 0.37097515E-03_JPRB, 0.37096802E-03_JPRB, &
  & 0.37095876E-03_JPRB, 0.37094721E-03_JPRB, 0.37093385E-03_JPRB, 0.37091898E-03_JPRB, 0.37090317E-03_JPRB, 0.37088679E-03_JPRB, &
  & 0.37087020E-03_JPRB, 0.37085352E-03_JPRB, 0.37083740E-03_JPRB, 0.37082226E-03_JPRB, 0.37080841E-03_JPRB, 0.37079558E-03_JPRB, &
  & 0.37078344E-03_JPRB, 0.37077177E-03_JPRB, 0.37076007E-03_JPRB, 0.37074793E-03_JPRB, 0.37073556E-03_JPRB, 0.37072314E-03_JPRB, &
  & 0.37071106E-03_JPRB, 0.37069927E-03_JPRB, 0.37068626E-03_JPRB, 0.37066484E-03_JPRB /)

RGHG1(:,40,10) = (/ &
  & 0.37049328E-03_JPRB, 0.37051603E-03_JPRB, 0.37052942E-03_JPRB, 0.37054197E-03_JPRB, 0.37055544E-03_JPRB, 0.37057028E-03_JPRB, &
  & 0.37058597E-03_JPRB, 0.37060236E-03_JPRB, 0.37061935E-03_JPRB, 0.37063684E-03_JPRB, 0.37065509E-03_JPRB, 0.37067424E-03_JPRB, &
  & 0.37069473E-03_JPRB, 0.37071700E-03_JPRB, 0.37074153E-03_JPRB, 0.37076816E-03_JPRB, 0.37079616E-03_JPRB, 0.37082488E-03_JPRB, &
  & 0.37085355E-03_JPRB, 0.37088126E-03_JPRB, 0.37090655E-03_JPRB, 0.37092812E-03_JPRB, 0.37094500E-03_JPRB, 0.37095763E-03_JPRB, &
  & 0.37096659E-03_JPRB, 0.37097299E-03_JPRB, 0.37097774E-03_JPRB, 0.37098140E-03_JPRB, 0.37098420E-03_JPRB, 0.37098664E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098987E-03_JPRB, 0.37099107E-03_JPRB, 0.37099168E-03_JPRB, 0.37099177E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099037E-03_JPRB, 0.37098894E-03_JPRB, 0.37098682E-03_JPRB, 0.37098382E-03_JPRB, 0.37097969E-03_JPRB, 0.37097390E-03_JPRB, &
  & 0.37096624E-03_JPRB, 0.37095640E-03_JPRB, 0.37094456E-03_JPRB, 0.37093105E-03_JPRB, 0.37091662E-03_JPRB, 0.37090131E-03_JPRB, &
  & 0.37088551E-03_JPRB, 0.37086970E-03_JPRB, 0.37085431E-03_JPRB, 0.37084002E-03_JPRB, 0.37082692E-03_JPRB, 0.37081508E-03_JPRB, &
  & 0.37080422E-03_JPRB, 0.37079371E-03_JPRB, 0.37078327E-03_JPRB, 0.37077232E-03_JPRB, 0.37076091E-03_JPRB, 0.37074921E-03_JPRB, &
  & 0.37073781E-03_JPRB, 0.37072646E-03_JPRB, 0.37071403E-03_JPRB, 0.37069269E-03_JPRB /)

RGHG1(:,41,10) = (/ &
  & 0.37054296E-03_JPRB, 0.37056257E-03_JPRB, 0.37057450E-03_JPRB, 0.37058623E-03_JPRB, 0.37059910E-03_JPRB, 0.37061333E-03_JPRB, &
  & 0.37062829E-03_JPRB, 0.37064342E-03_JPRB, 0.37065879E-03_JPRB, 0.37067448E-03_JPRB, 0.37069037E-03_JPRB, 0.37070687E-03_JPRB, &
  & 0.37072453E-03_JPRB, 0.37074409E-03_JPRB, 0.37076598E-03_JPRB, 0.37079031E-03_JPRB, 0.37081621E-03_JPRB, 0.37084304E-03_JPRB, &
  & 0.37086988E-03_JPRB, 0.37089581E-03_JPRB, 0.37091901E-03_JPRB, 0.37093816E-03_JPRB, 0.37095277E-03_JPRB, 0.37096359E-03_JPRB, &
  & 0.37097116E-03_JPRB, 0.37097666E-03_JPRB, 0.37098071E-03_JPRB, 0.37098376E-03_JPRB, 0.37098624E-03_JPRB, 0.37098824E-03_JPRB, &
  & 0.37098984E-03_JPRB, 0.37099113E-03_JPRB, 0.37099214E-03_JPRB, 0.37099270E-03_JPRB, 0.37099276E-03_JPRB, 0.37099238E-03_JPRB, &
  & 0.37099156E-03_JPRB, 0.37099031E-03_JPRB, 0.37098848E-03_JPRB, 0.37098597E-03_JPRB, 0.37098269E-03_JPRB, 0.37097806E-03_JPRB, &
  & 0.37097180E-03_JPRB, 0.37096371E-03_JPRB, 0.37095358E-03_JPRB, 0.37094171E-03_JPRB, 0.37092849E-03_JPRB, 0.37091438E-03_JPRB, &
  & 0.37089959E-03_JPRB, 0.37088449E-03_JPRB, 0.37086976E-03_JPRB, 0.37085620E-03_JPRB, 0.37084401E-03_JPRB, 0.37083332E-03_JPRB, &
  & 0.37082355E-03_JPRB, 0.37081426E-03_JPRB, 0.37080489E-03_JPRB, 0.37079502E-03_JPRB, 0.37078458E-03_JPRB, 0.37077384E-03_JPRB, &
  & 0.37076318E-03_JPRB, 0.37075265E-03_JPRB, 0.37074077E-03_JPRB, 0.37072026E-03_JPRB /)

RGHG1(:,42,10) = (/ &
  & 0.37058882E-03_JPRB, 0.37060602E-03_JPRB, 0.37061673E-03_JPRB, 0.37062762E-03_JPRB, 0.37064007E-03_JPRB, 0.37065404E-03_JPRB, &
  & 0.37066836E-03_JPRB, 0.37068236E-03_JPRB, 0.37069613E-03_JPRB, 0.37070960E-03_JPRB, 0.37072331E-03_JPRB, 0.37073740E-03_JPRB, &
  & 0.37075265E-03_JPRB, 0.37076973E-03_JPRB, 0.37078914E-03_JPRB, 0.37081106E-03_JPRB, 0.37083487E-03_JPRB, 0.37085966E-03_JPRB, &
  & 0.37088461E-03_JPRB, 0.37090841E-03_JPRB, 0.37092943E-03_JPRB, 0.37094622E-03_JPRB, 0.37095879E-03_JPRB, 0.37096790E-03_JPRB, &
  & 0.37097445E-03_JPRB, 0.37097919E-03_JPRB, 0.37098274E-03_JPRB, 0.37098539E-03_JPRB, 0.37098769E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37099206E-03_JPRB, 0.37099296E-03_JPRB, 0.37099348E-03_JPRB, 0.37099348E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099243E-03_JPRB, 0.37099124E-03_JPRB, 0.37098973E-03_JPRB, 0.37098769E-03_JPRB, 0.37098490E-03_JPRB, 0.37098111E-03_JPRB, &
  & 0.37097611E-03_JPRB, 0.37096950E-03_JPRB, 0.37096103E-03_JPRB, 0.37095090E-03_JPRB, 0.37093917E-03_JPRB, 0.37092622E-03_JPRB, &
  & 0.37091246E-03_JPRB, 0.37089820E-03_JPRB, 0.37088414E-03_JPRB, 0.37087130E-03_JPRB, 0.37086004E-03_JPRB, 0.37085029E-03_JPRB, &
  & 0.37084159E-03_JPRB, 0.37083335E-03_JPRB, 0.37082509E-03_JPRB, 0.37081627E-03_JPRB, 0.37080699E-03_JPRB, 0.37079732E-03_JPRB, &
  & 0.37078772E-03_JPRB, 0.37077794E-03_JPRB, 0.37076703E-03_JPRB, 0.37074788E-03_JPRB /)

RGHG1(:,43,10) = (/ &
  & 0.37063158E-03_JPRB, 0.37064671E-03_JPRB, 0.37065646E-03_JPRB, 0.37066673E-03_JPRB, 0.37067887E-03_JPRB, 0.37069246E-03_JPRB, &
  & 0.37070611E-03_JPRB, 0.37071918E-03_JPRB, 0.37073140E-03_JPRB, 0.37074319E-03_JPRB, 0.37075486E-03_JPRB, 0.37076679E-03_JPRB, &
  & 0.37077974E-03_JPRB, 0.37079441E-03_JPRB, 0.37081144E-03_JPRB, 0.37083120E-03_JPRB, 0.37085277E-03_JPRB, 0.37087564E-03_JPRB, &
  & 0.37089846E-03_JPRB, 0.37091997E-03_JPRB, 0.37093824E-03_JPRB, 0.37095274E-03_JPRB, 0.37096348E-03_JPRB, 0.37097131E-03_JPRB, &
  & 0.37097704E-03_JPRB, 0.37098108E-03_JPRB, 0.37098423E-03_JPRB, 0.37098667E-03_JPRB, 0.37098874E-03_JPRB, 0.37099040E-03_JPRB, &
  & 0.37099171E-03_JPRB, 0.37099278E-03_JPRB, 0.37099363E-03_JPRB, 0.37099404E-03_JPRB, 0.37099404E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099305E-03_JPRB, 0.37099206E-03_JPRB, 0.37099066E-03_JPRB, 0.37098886E-03_JPRB, 0.37098661E-03_JPRB, 0.37098344E-03_JPRB, &
  & 0.37097943E-03_JPRB, 0.37097407E-03_JPRB, 0.37096717E-03_JPRB, 0.37095867E-03_JPRB, 0.37094846E-03_JPRB, 0.37093676E-03_JPRB, &
  & 0.37092407E-03_JPRB, 0.37091080E-03_JPRB, 0.37089767E-03_JPRB, 0.37088551E-03_JPRB, 0.37087520E-03_JPRB, 0.37086633E-03_JPRB, &
  & 0.37085870E-03_JPRB, 0.37085154E-03_JPRB, 0.37084435E-03_JPRB, 0.37083676E-03_JPRB, 0.37082855E-03_JPRB, 0.37081997E-03_JPRB, &
  & 0.37081132E-03_JPRB, 0.37080268E-03_JPRB, 0.37079302E-03_JPRB, 0.37077576E-03_JPRB /)

RGHG1(:,44,10) = (/ &
  & 0.37067154E-03_JPRB, 0.37068524E-03_JPRB, 0.37069427E-03_JPRB, 0.37070410E-03_JPRB, 0.37071609E-03_JPRB, 0.37072960E-03_JPRB, &
  & 0.37074269E-03_JPRB, 0.37075469E-03_JPRB, 0.37076554E-03_JPRB, 0.37077564E-03_JPRB, 0.37078539E-03_JPRB, 0.37079537E-03_JPRB, &
  & 0.37080623E-03_JPRB, 0.37081880E-03_JPRB, 0.37083362E-03_JPRB, 0.37085102E-03_JPRB, 0.37087049E-03_JPRB, 0.37089098E-03_JPRB, &
  & 0.37091167E-03_JPRB, 0.37093039E-03_JPRB, 0.37094601E-03_JPRB, 0.37095824E-03_JPRB, 0.37096738E-03_JPRB, 0.37097401E-03_JPRB, &
  & 0.37097899E-03_JPRB, 0.37098254E-03_JPRB, 0.37098536E-03_JPRB, 0.37098763E-03_JPRB, 0.37098961E-03_JPRB, 0.37099115E-03_JPRB, &
  & 0.37099235E-03_JPRB, 0.37099334E-03_JPRB, 0.37099412E-03_JPRB, 0.37099456E-03_JPRB, 0.37099450E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099258E-03_JPRB, 0.37099139E-03_JPRB, 0.37098982E-03_JPRB, 0.37098795E-03_JPRB, 0.37098533E-03_JPRB, &
  & 0.37098207E-03_JPRB, 0.37097788E-03_JPRB, 0.37097238E-03_JPRB, 0.37096540E-03_JPRB, 0.37095667E-03_JPRB, 0.37094633E-03_JPRB, &
  & 0.37093484E-03_JPRB, 0.37092256E-03_JPRB, 0.37091045E-03_JPRB, 0.37089939E-03_JPRB, 0.37089002E-03_JPRB, 0.37088219E-03_JPRB, &
  & 0.37087544E-03_JPRB, 0.37086930E-03_JPRB, 0.37086307E-03_JPRB, 0.37085637E-03_JPRB, 0.37084924E-03_JPRB, 0.37084179E-03_JPRB, &
  & 0.37083437E-03_JPRB, 0.37082707E-03_JPRB, 0.37081871E-03_JPRB, 0.37080387E-03_JPRB /)

RGHG1(:,45,10) = (/ &
  & 0.37070975E-03_JPRB, 0.37072241E-03_JPRB, 0.37073082E-03_JPRB, 0.37074022E-03_JPRB, 0.37075224E-03_JPRB, 0.37076545E-03_JPRB, &
  & 0.37077803E-03_JPRB, 0.37078897E-03_JPRB, 0.37079846E-03_JPRB, 0.37080710E-03_JPRB, 0.37081534E-03_JPRB, 0.37082346E-03_JPRB, &
  & 0.37083248E-03_JPRB, 0.37084293E-03_JPRB, 0.37085573E-03_JPRB, 0.37087104E-03_JPRB, 0.37088833E-03_JPRB, 0.37090661E-03_JPRB, &
  & 0.37092419E-03_JPRB, 0.37094002E-03_JPRB, 0.37095280E-03_JPRB, 0.37096284E-03_JPRB, 0.37097052E-03_JPRB, 0.37097619E-03_JPRB, &
  & 0.37098053E-03_JPRB, 0.37098376E-03_JPRB, 0.37098635E-03_JPRB, 0.37098848E-03_JPRB, 0.37099022E-03_JPRB, 0.37099174E-03_JPRB, &
  & 0.37099290E-03_JPRB, 0.37099386E-03_JPRB, 0.37099465E-03_JPRB, 0.37099503E-03_JPRB, 0.37099497E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099404E-03_JPRB, 0.37099308E-03_JPRB, 0.37099194E-03_JPRB, 0.37099060E-03_JPRB, 0.37098894E-03_JPRB, 0.37098679E-03_JPRB, &
  & 0.37098408E-03_JPRB, 0.37098082E-03_JPRB, 0.37097654E-03_JPRB, 0.37097104E-03_JPRB, 0.37096394E-03_JPRB, 0.37095507E-03_JPRB, &
  & 0.37094482E-03_JPRB, 0.37093376E-03_JPRB, 0.37092267E-03_JPRB, 0.37091278E-03_JPRB, 0.37090448E-03_JPRB, 0.37089773E-03_JPRB, &
  & 0.37089188E-03_JPRB, 0.37088650E-03_JPRB, 0.37088111E-03_JPRB, 0.37087538E-03_JPRB, 0.37086924E-03_JPRB, 0.37086278E-03_JPRB, &
  & 0.37085667E-03_JPRB, 0.37085055E-03_JPRB, 0.37084366E-03_JPRB, 0.37083164E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART20',0,ZHOOK_HANDLE)



RGHG1(:,46,10) = (/ &
  & 0.37074674E-03_JPRB, 0.37075867E-03_JPRB, 0.37076668E-03_JPRB, 0.37077596E-03_JPRB, 0.37078728E-03_JPRB, 0.37080058E-03_JPRB, &
  & 0.37081237E-03_JPRB, 0.37082235E-03_JPRB, 0.37083070E-03_JPRB, 0.37083792E-03_JPRB, 0.37084453E-03_JPRB, 0.37085116E-03_JPRB, &
  & 0.37085832E-03_JPRB, 0.37086708E-03_JPRB, 0.37087779E-03_JPRB, 0.37089107E-03_JPRB, 0.37090626E-03_JPRB, 0.37092168E-03_JPRB, &
  & 0.37093612E-03_JPRB, 0.37094849E-03_JPRB, 0.37095859E-03_JPRB, 0.37096668E-03_JPRB, 0.37097308E-03_JPRB, 0.37097797E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098478E-03_JPRB, 0.37098723E-03_JPRB, 0.37098920E-03_JPRB, 0.37099089E-03_JPRB, 0.37099229E-03_JPRB, &
  & 0.37099342E-03_JPRB, 0.37099441E-03_JPRB, 0.37099505E-03_JPRB, 0.37099543E-03_JPRB, 0.37099535E-03_JPRB, 0.37099505E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099357E-03_JPRB, 0.37099255E-03_JPRB, 0.37099133E-03_JPRB, 0.37098987E-03_JPRB, 0.37098804E-03_JPRB, &
  & 0.37098583E-03_JPRB, 0.37098324E-03_JPRB, 0.37098001E-03_JPRB, 0.37097590E-03_JPRB, 0.37097040E-03_JPRB, 0.37096313E-03_JPRB, &
  & 0.37095411E-03_JPRB, 0.37094430E-03_JPRB, 0.37093449E-03_JPRB, 0.37092576E-03_JPRB, 0.37091869E-03_JPRB, 0.37091284E-03_JPRB, &
  & 0.37090786E-03_JPRB, 0.37090329E-03_JPRB, 0.37089863E-03_JPRB, 0.37089377E-03_JPRB, 0.37088868E-03_JPRB, 0.37088327E-03_JPRB, &
  & 0.37087817E-03_JPRB, 0.37087331E-03_JPRB, 0.37086793E-03_JPRB, 0.37085838E-03_JPRB /)

RGHG1(:,47,10) = (/ &
  & 0.37078332E-03_JPRB, 0.37079473E-03_JPRB, 0.37080265E-03_JPRB, 0.37081123E-03_JPRB, 0.37082258E-03_JPRB, 0.37083490E-03_JPRB, &
  & 0.37084616E-03_JPRB, 0.37085504E-03_JPRB, 0.37086196E-03_JPRB, 0.37086778E-03_JPRB, 0.37087308E-03_JPRB, 0.37087838E-03_JPRB, &
  & 0.37088414E-03_JPRB, 0.37089101E-03_JPRB, 0.37089997E-03_JPRB, 0.37091109E-03_JPRB, 0.37092349E-03_JPRB, 0.37093577E-03_JPRB, &
  & 0.37094660E-03_JPRB, 0.37095588E-03_JPRB, 0.37096356E-03_JPRB, 0.37096997E-03_JPRB, 0.37097526E-03_JPRB, 0.37097951E-03_JPRB, &
  & 0.37098295E-03_JPRB, 0.37098565E-03_JPRB, 0.37098792E-03_JPRB, 0.37098987E-03_JPRB, 0.37099145E-03_JPRB, 0.37099276E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099479E-03_JPRB, 0.37099549E-03_JPRB, 0.37099581E-03_JPRB, 0.37099564E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099401E-03_JPRB, 0.37099299E-03_JPRB, 0.37099194E-03_JPRB, 0.37099066E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098731E-03_JPRB, 0.37098525E-03_JPRB, 0.37098274E-03_JPRB, 0.37097969E-03_JPRB, 0.37097561E-03_JPRB, 0.37096997E-03_JPRB, &
  & 0.37096278E-03_JPRB, 0.37095428E-03_JPRB, 0.37094581E-03_JPRB, 0.37093821E-03_JPRB, 0.37093210E-03_JPRB, 0.37092727E-03_JPRB, &
  & 0.37092320E-03_JPRB, 0.37091941E-03_JPRB, 0.37091563E-03_JPRB, 0.37091161E-03_JPRB, 0.37090731E-03_JPRB, 0.37090288E-03_JPRB, &
  & 0.37089863E-03_JPRB, 0.37089468E-03_JPRB, 0.37089037E-03_JPRB, 0.37088292E-03_JPRB /)

RGHG1(:,48,10) = (/ &
  & 0.37081962E-03_JPRB, 0.37083085E-03_JPRB, 0.37083830E-03_JPRB, 0.37084680E-03_JPRB, 0.37085733E-03_JPRB, 0.37086941E-03_JPRB, &
  & 0.37087922E-03_JPRB, 0.37088670E-03_JPRB, 0.37089229E-03_JPRB, 0.37089680E-03_JPRB, 0.37090085E-03_JPRB, 0.37090472E-03_JPRB, &
  & 0.37090902E-03_JPRB, 0.37091444E-03_JPRB, 0.37092128E-03_JPRB, 0.37092998E-03_JPRB, 0.37093929E-03_JPRB, 0.37094794E-03_JPRB, &
  & 0.37095544E-03_JPRB, 0.37096188E-03_JPRB, 0.37096758E-03_JPRB, 0.37097256E-03_JPRB, 0.37097707E-03_JPRB, 0.37098074E-03_JPRB, &
  & 0.37098382E-03_JPRB, 0.37098638E-03_JPRB, 0.37098851E-03_JPRB, 0.37099034E-03_JPRB, 0.37099191E-03_JPRB, 0.37099325E-03_JPRB, &
  & 0.37099436E-03_JPRB, 0.37099520E-03_JPRB, 0.37099584E-03_JPRB, 0.37099616E-03_JPRB, 0.37099596E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099511E-03_JPRB, 0.37099441E-03_JPRB, 0.37099342E-03_JPRB, 0.37099241E-03_JPRB, 0.37099124E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098679E-03_JPRB, 0.37098490E-03_JPRB, 0.37098266E-03_JPRB, 0.37097969E-03_JPRB, 0.37097582E-03_JPRB, &
  & 0.37097029E-03_JPRB, 0.37096359E-03_JPRB, 0.37095655E-03_JPRB, 0.37095023E-03_JPRB, 0.37094526E-03_JPRB, 0.37094124E-03_JPRB, &
  & 0.37093781E-03_JPRB, 0.37093466E-03_JPRB, 0.37093155E-03_JPRB, 0.37092826E-03_JPRB, 0.37092471E-03_JPRB, 0.37092101E-03_JPRB, &
  & 0.37091758E-03_JPRB, 0.37091444E-03_JPRB, 0.37091092E-03_JPRB, 0.37090501E-03_JPRB /)

RGHG1(:,49,10) = (/ &
  & 0.37085533E-03_JPRB, 0.37086639E-03_JPRB, 0.37087372E-03_JPRB, 0.37088167E-03_JPRB, 0.37089176E-03_JPRB, 0.37090242E-03_JPRB, &
  & 0.37091092E-03_JPRB, 0.37091682E-03_JPRB, 0.37092093E-03_JPRB, 0.37092410E-03_JPRB, 0.37092681E-03_JPRB, 0.37092943E-03_JPRB, &
  & 0.37093234E-03_JPRB, 0.37093594E-03_JPRB, 0.37094078E-03_JPRB, 0.37094648E-03_JPRB, 0.37095230E-03_JPRB, 0.37095766E-03_JPRB, &
  & 0.37096234E-03_JPRB, 0.37096668E-03_JPRB, 0.37097081E-03_JPRB, 0.37097483E-03_JPRB, 0.37097847E-03_JPRB, 0.37098178E-03_JPRB, &
  & 0.37098464E-03_JPRB, 0.37098702E-03_JPRB, 0.37098906E-03_JPRB, 0.37099086E-03_JPRB, 0.37099235E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099564E-03_JPRB, 0.37099625E-03_JPRB, 0.37099651E-03_JPRB, 0.37099628E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099468E-03_JPRB, 0.37099380E-03_JPRB, 0.37099287E-03_JPRB, 0.37099177E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37098935E-03_JPRB, 0.37098798E-03_JPRB, 0.37098647E-03_JPRB, 0.37098481E-03_JPRB, 0.37098280E-03_JPRB, 0.37098012E-03_JPRB, &
  & 0.37097646E-03_JPRB, 0.37097174E-03_JPRB, 0.37096668E-03_JPRB, 0.37096185E-03_JPRB, 0.37095777E-03_JPRB, 0.37095451E-03_JPRB, &
  & 0.37095178E-03_JPRB, 0.37094916E-03_JPRB, 0.37094654E-03_JPRB, 0.37094380E-03_JPRB, 0.37094083E-03_JPRB, 0.37093781E-03_JPRB, &
  & 0.37093504E-03_JPRB, 0.37093248E-03_JPRB, 0.37092972E-03_JPRB, 0.37092480E-03_JPRB /)

RGHG1(:,50,10) = (/ &
  & 0.37088856E-03_JPRB, 0.37089901E-03_JPRB, 0.37090573E-03_JPRB, 0.37091295E-03_JPRB, 0.37092168E-03_JPRB, 0.37093082E-03_JPRB, &
  & 0.37093766E-03_JPRB, 0.37094191E-03_JPRB, 0.37094459E-03_JPRB, 0.37094654E-03_JPRB, 0.37094817E-03_JPRB, 0.37094968E-03_JPRB, &
  & 0.37095131E-03_JPRB, 0.37095338E-03_JPRB, 0.37095591E-03_JPRB, 0.37095894E-03_JPRB, 0.37096193E-03_JPRB, 0.37096479E-03_JPRB, &
  & 0.37096752E-03_JPRB, 0.37097037E-03_JPRB, 0.37097343E-03_JPRB, 0.37097657E-03_JPRB, 0.37097972E-03_JPRB, 0.37098260E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098760E-03_JPRB, 0.37098964E-03_JPRB, 0.37099142E-03_JPRB, 0.37099281E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099593E-03_JPRB, 0.37099651E-03_JPRB, 0.37099674E-03_JPRB, 0.37099657E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099497E-03_JPRB, 0.37099409E-03_JPRB, 0.37099322E-03_JPRB, 0.37099226E-03_JPRB, 0.37099121E-03_JPRB, &
  & 0.37099014E-03_JPRB, 0.37098897E-03_JPRB, 0.37098781E-03_JPRB, 0.37098650E-03_JPRB, 0.37098510E-03_JPRB, 0.37098338E-03_JPRB, &
  & 0.37098103E-03_JPRB, 0.37097814E-03_JPRB, 0.37097489E-03_JPRB, 0.37097180E-03_JPRB, 0.37096901E-03_JPRB, 0.37096668E-03_JPRB, &
  & 0.37096452E-03_JPRB, 0.37096249E-03_JPRB, 0.37096039E-03_JPRB, 0.37095818E-03_JPRB, 0.37095573E-03_JPRB, 0.37095326E-03_JPRB, &
  & 0.37095093E-03_JPRB, 0.37094869E-03_JPRB, 0.37094636E-03_JPRB, 0.37094223E-03_JPRB /)

RGHG1(:,51,10) = (/ &
  & 0.37091685E-03_JPRB, 0.37092558E-03_JPRB, 0.37093108E-03_JPRB, 0.37093690E-03_JPRB, 0.37094398E-03_JPRB, 0.37095096E-03_JPRB, &
  & 0.37095576E-03_JPRB, 0.37095856E-03_JPRB, 0.37096022E-03_JPRB, 0.37096138E-03_JPRB, 0.37096220E-03_JPRB, 0.37096301E-03_JPRB, &
  & 0.37096380E-03_JPRB, 0.37096473E-03_JPRB, 0.37096583E-03_JPRB, 0.37096706E-03_JPRB, 0.37096845E-03_JPRB, 0.37096982E-03_JPRB, &
  & 0.37097139E-03_JPRB, 0.37097328E-03_JPRB, 0.37097553E-03_JPRB, 0.37097803E-03_JPRB, 0.37098082E-03_JPRB, 0.37098341E-03_JPRB, &
  & 0.37098586E-03_JPRB, 0.37098810E-03_JPRB, 0.37099008E-03_JPRB, 0.37099177E-03_JPRB, 0.37099322E-03_JPRB, 0.37099438E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099628E-03_JPRB, 0.37099680E-03_JPRB, 0.37099703E-03_JPRB, 0.37099686E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099526E-03_JPRB, 0.37099447E-03_JPRB, 0.37099357E-03_JPRB, 0.37099270E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099075E-03_JPRB, 0.37098973E-03_JPRB, 0.37098880E-03_JPRB, 0.37098784E-03_JPRB, 0.37098685E-03_JPRB, 0.37098565E-03_JPRB, &
  & 0.37098426E-03_JPRB, 0.37098269E-03_JPRB, 0.37098094E-03_JPRB, 0.37097925E-03_JPRB, 0.37097774E-03_JPRB, 0.37097637E-03_JPRB, &
  & 0.37097509E-03_JPRB, 0.37097378E-03_JPRB, 0.37097232E-03_JPRB, 0.37097072E-03_JPRB, 0.37096889E-03_JPRB, 0.37096694E-03_JPRB, &
  & 0.37096516E-03_JPRB, 0.37096345E-03_JPRB, 0.37096129E-03_JPRB, 0.37095771E-03_JPRB /)

RGHG1(:,52,10) = (/ &
  & 0.37093990E-03_JPRB, 0.37094508E-03_JPRB, 0.37094869E-03_JPRB, 0.37095297E-03_JPRB, 0.37095824E-03_JPRB, 0.37096319E-03_JPRB, &
  & 0.37096645E-03_JPRB, 0.37096825E-03_JPRB, 0.37096921E-03_JPRB, 0.37096982E-03_JPRB, 0.37097029E-03_JPRB, 0.37097069E-03_JPRB, &
  & 0.37097104E-03_JPRB, 0.37097136E-03_JPRB, 0.37097171E-03_JPRB, 0.37097221E-03_JPRB, 0.37097276E-03_JPRB, 0.37097340E-03_JPRB, &
  & 0.37097425E-03_JPRB, 0.37097544E-03_JPRB, 0.37097710E-03_JPRB, 0.37097919E-03_JPRB, 0.37098170E-03_JPRB, 0.37098408E-03_JPRB, &
  & 0.37098647E-03_JPRB, 0.37098868E-03_JPRB, 0.37099060E-03_JPRB, 0.37099229E-03_JPRB, 0.37099369E-03_JPRB, 0.37099473E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099663E-03_JPRB, 0.37099709E-03_JPRB, 0.37099730E-03_JPRB, 0.37099709E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099561E-03_JPRB, 0.37099485E-03_JPRB, 0.37099404E-03_JPRB, 0.37099310E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099037E-03_JPRB, 0.37098958E-03_JPRB, 0.37098880E-03_JPRB, 0.37098813E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098650E-03_JPRB, 0.37098571E-03_JPRB, 0.37098493E-03_JPRB, 0.37098408E-03_JPRB, 0.37098341E-03_JPRB, 0.37098280E-03_JPRB, &
  & 0.37098216E-03_JPRB, 0.37098149E-03_JPRB, 0.37098074E-03_JPRB, 0.37097977E-03_JPRB, 0.37097861E-03_JPRB, 0.37097727E-03_JPRB, &
  & 0.37097605E-03_JPRB, 0.37097480E-03_JPRB, 0.37097331E-03_JPRB, 0.37097037E-03_JPRB /)

RGHG1(:,53,10) = (/ &
  & 0.37095288E-03_JPRB, 0.37095710E-03_JPRB, 0.37095996E-03_JPRB, 0.37096316E-03_JPRB, 0.37096706E-03_JPRB, 0.37097058E-03_JPRB, &
  & 0.37097267E-03_JPRB, 0.37097378E-03_JPRB, 0.37097436E-03_JPRB, 0.37097471E-03_JPRB, 0.37097494E-03_JPRB, 0.37097512E-03_JPRB, &
  & 0.37097532E-03_JPRB, 0.37097547E-03_JPRB, 0.37097558E-03_JPRB, 0.37097570E-03_JPRB, 0.37097587E-03_JPRB, 0.37097608E-03_JPRB, &
  & 0.37097657E-03_JPRB, 0.37097736E-03_JPRB, 0.37097855E-03_JPRB, 0.37098027E-03_JPRB, 0.37098245E-03_JPRB, 0.37098472E-03_JPRB, &
  & 0.37098702E-03_JPRB, 0.37098915E-03_JPRB, 0.37099107E-03_JPRB, 0.37099270E-03_JPRB, 0.37099409E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099610E-03_JPRB, 0.37099689E-03_JPRB, 0.37099732E-03_JPRB, 0.37099753E-03_JPRB, 0.37099730E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099581E-03_JPRB, 0.37099517E-03_JPRB, 0.37099436E-03_JPRB, 0.37099348E-03_JPRB, 0.37099255E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099101E-03_JPRB, 0.37099043E-03_JPRB, 0.37098976E-03_JPRB, 0.37098926E-03_JPRB, 0.37098868E-03_JPRB, &
  & 0.37098819E-03_JPRB, 0.37098772E-03_JPRB, 0.37098734E-03_JPRB, 0.37098699E-03_JPRB, 0.37098670E-03_JPRB, 0.37098641E-03_JPRB, &
  & 0.37098615E-03_JPRB, 0.37098586E-03_JPRB, 0.37098548E-03_JPRB, 0.37098501E-03_JPRB, 0.37098437E-03_JPRB, 0.37098367E-03_JPRB, &
  & 0.37098298E-03_JPRB, 0.37098231E-03_JPRB, 0.37098146E-03_JPRB, 0.37097969E-03_JPRB /)

RGHG1(:,54,10) = (/ &
  & 0.37096243E-03_JPRB, 0.37096551E-03_JPRB, 0.37096749E-03_JPRB, 0.37096988E-03_JPRB, 0.37097270E-03_JPRB, 0.37097518E-03_JPRB, &
  & 0.37097652E-03_JPRB, 0.37097716E-03_JPRB, 0.37097750E-03_JPRB, 0.37097774E-03_JPRB, 0.37097791E-03_JPRB, 0.37097803E-03_JPRB, &
  & 0.37097814E-03_JPRB, 0.37097820E-03_JPRB, 0.37097820E-03_JPRB, 0.37097814E-03_JPRB, 0.37097806E-03_JPRB, 0.37097806E-03_JPRB, &
  & 0.37097829E-03_JPRB, 0.37097887E-03_JPRB, 0.37097983E-03_JPRB, 0.37098126E-03_JPRB, 0.37098321E-03_JPRB, 0.37098545E-03_JPRB, &
  & 0.37098757E-03_JPRB, 0.37098967E-03_JPRB, 0.37099142E-03_JPRB, 0.37099305E-03_JPRB, 0.37099447E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099712E-03_JPRB, 0.37099756E-03_JPRB, 0.37099785E-03_JPRB, 0.37099759E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099613E-03_JPRB, 0.37099543E-03_JPRB, 0.37099468E-03_JPRB, 0.37099380E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099217E-03_JPRB, 0.37099153E-03_JPRB, 0.37099095E-03_JPRB, 0.37099046E-03_JPRB, 0.37099014E-03_JPRB, 0.37098973E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37098915E-03_JPRB, 0.37098897E-03_JPRB, 0.37098880E-03_JPRB, 0.37098868E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098827E-03_JPRB, 0.37098804E-03_JPRB, 0.37098781E-03_JPRB, 0.37098746E-03_JPRB, 0.37098711E-03_JPRB, &
  & 0.37098676E-03_JPRB, 0.37098641E-03_JPRB, 0.37098615E-03_JPRB, 0.37098583E-03_JPRB /)

RGHG1(:,55,10) = (/ &
  & 0.37096877E-03_JPRB, 0.37097110E-03_JPRB, 0.37097276E-03_JPRB, 0.37097442E-03_JPRB, 0.37097654E-03_JPRB, 0.37097820E-03_JPRB, &
  & 0.37097919E-03_JPRB, 0.37097957E-03_JPRB, 0.37097977E-03_JPRB, 0.37097995E-03_JPRB, 0.37098007E-03_JPRB, 0.37098015E-03_JPRB, &
  & 0.37098024E-03_JPRB, 0.37098024E-03_JPRB, 0.37098018E-03_JPRB, 0.37098004E-03_JPRB, 0.37097989E-03_JPRB, 0.37097980E-03_JPRB, &
  & 0.37097992E-03_JPRB, 0.37098027E-03_JPRB, 0.37098106E-03_JPRB, 0.37098225E-03_JPRB, 0.37098399E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098807E-03_JPRB, 0.37099008E-03_JPRB, 0.37099174E-03_JPRB, 0.37099337E-03_JPRB, 0.37099479E-03_JPRB, 0.37099578E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099738E-03_JPRB, 0.37099773E-03_JPRB, 0.37099808E-03_JPRB, 0.37099791E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099642E-03_JPRB, 0.37099572E-03_JPRB, 0.37099500E-03_JPRB, 0.37099412E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099261E-03_JPRB, 0.37099206E-03_JPRB, 0.37099153E-03_JPRB, 0.37099107E-03_JPRB, 0.37099083E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099040E-03_JPRB, 0.37099025E-03_JPRB, 0.37099016E-03_JPRB, 0.37099005E-03_JPRB, 0.37098996E-03_JPRB, 0.37098984E-03_JPRB, &
  & 0.37098979E-03_JPRB, 0.37098964E-03_JPRB, 0.37098950E-03_JPRB, 0.37098935E-03_JPRB, 0.37098915E-03_JPRB, 0.37098903E-03_JPRB, &
  & 0.37098891E-03_JPRB, 0.37098874E-03_JPRB, 0.37098856E-03_JPRB, 0.37098824E-03_JPRB /)

RGHG1(:,56,10) = (/ &
  & 0.37097355E-03_JPRB, 0.37097544E-03_JPRB, 0.37097649E-03_JPRB, 0.37097780E-03_JPRB, 0.37097922E-03_JPRB, 0.37098047E-03_JPRB, &
  & 0.37098114E-03_JPRB, 0.37098140E-03_JPRB, 0.37098152E-03_JPRB, 0.37098164E-03_JPRB, 0.37098175E-03_JPRB, 0.37098181E-03_JPRB, &
  & 0.37098181E-03_JPRB, 0.37098175E-03_JPRB, 0.37098170E-03_JPRB, 0.37098158E-03_JPRB, 0.37098143E-03_JPRB, 0.37098123E-03_JPRB, &
  & 0.37098123E-03_JPRB, 0.37098152E-03_JPRB, 0.37098216E-03_JPRB, 0.37098327E-03_JPRB, 0.37098484E-03_JPRB, 0.37098679E-03_JPRB, &
  & 0.37098865E-03_JPRB, 0.37099054E-03_JPRB, 0.37099214E-03_JPRB, 0.37099369E-03_JPRB, 0.37099508E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099698E-03_JPRB, 0.37099759E-03_JPRB, 0.37099799E-03_JPRB, 0.37099828E-03_JPRB, 0.37099814E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099738E-03_JPRB, 0.37099674E-03_JPRB, 0.37099607E-03_JPRB, 0.37099529E-03_JPRB, 0.37099447E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099252E-03_JPRB, 0.37099209E-03_JPRB, 0.37099168E-03_JPRB, 0.37099153E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099101E-03_JPRB, 0.37099101E-03_JPRB, 0.37099095E-03_JPRB, 0.37099098E-03_JPRB, 0.37099095E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099081E-03_JPRB, 0.37099078E-03_JPRB, 0.37099066E-03_JPRB, 0.37099054E-03_JPRB, 0.37099046E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099014E-03_JPRB, 0.37099002E-03_JPRB, 0.37098984E-03_JPRB /)

RGHG1(:,57,10) = (/ &
  & 0.37097698E-03_JPRB, 0.37097838E-03_JPRB, 0.37097937E-03_JPRB, 0.37098027E-03_JPRB, 0.37098129E-03_JPRB, 0.37098213E-03_JPRB, &
  & 0.37098257E-03_JPRB, 0.37098271E-03_JPRB, 0.37098286E-03_JPRB, 0.37098295E-03_JPRB, 0.37098298E-03_JPRB, 0.37098303E-03_JPRB, &
  & 0.37098303E-03_JPRB, 0.37098303E-03_JPRB, 0.37098303E-03_JPRB, 0.37098295E-03_JPRB, 0.37098274E-03_JPRB, 0.37098251E-03_JPRB, &
  & 0.37098239E-03_JPRB, 0.37098266E-03_JPRB, 0.37098321E-03_JPRB, 0.37098420E-03_JPRB, 0.37098565E-03_JPRB, 0.37098740E-03_JPRB, &
  & 0.37098918E-03_JPRB, 0.37099095E-03_JPRB, 0.37099258E-03_JPRB, 0.37099404E-03_JPRB, 0.37099532E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099715E-03_JPRB, 0.37099785E-03_JPRB, 0.37099820E-03_JPRB, 0.37099846E-03_JPRB, 0.37099834E-03_JPRB, 0.37099802E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099695E-03_JPRB, 0.37099633E-03_JPRB, 0.37099561E-03_JPRB, 0.37099476E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099345E-03_JPRB, 0.37099299E-03_JPRB, 0.37099252E-03_JPRB, 0.37099223E-03_JPRB, 0.37099206E-03_JPRB, 0.37099194E-03_JPRB, &
  & 0.37099191E-03_JPRB, 0.37099177E-03_JPRB, 0.37099171E-03_JPRB, 0.37099165E-03_JPRB, 0.37099171E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099159E-03_JPRB, 0.37099153E-03_JPRB, 0.37099142E-03_JPRB, 0.37099130E-03_JPRB, 0.37099124E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099118E-03_JPRB, 0.37099110E-03_JPRB, 0.37099095E-03_JPRB /)

RGHG1(:,58,10) = (/ &
  & 0.37097975E-03_JPRB, 0.37098085E-03_JPRB, 0.37098152E-03_JPRB, 0.37098222E-03_JPRB, 0.37098286E-03_JPRB, 0.37098353E-03_JPRB, &
  & 0.37098385E-03_JPRB, 0.37098399E-03_JPRB, 0.37098402E-03_JPRB, 0.37098408E-03_JPRB, 0.37098408E-03_JPRB, 0.37098408E-03_JPRB, &
  & 0.37098411E-03_JPRB, 0.37098414E-03_JPRB, 0.37098417E-03_JPRB, 0.37098417E-03_JPRB, 0.37098397E-03_JPRB, 0.37098373E-03_JPRB, &
  & 0.37098362E-03_JPRB, 0.37098388E-03_JPRB, 0.37098420E-03_JPRB, 0.37098510E-03_JPRB, 0.37098632E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098970E-03_JPRB, 0.37099136E-03_JPRB, 0.37099296E-03_JPRB, 0.37099438E-03_JPRB, 0.37099558E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099814E-03_JPRB, 0.37099840E-03_JPRB, 0.37099863E-03_JPRB, 0.37099858E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099718E-03_JPRB, 0.37099657E-03_JPRB, 0.37099590E-03_JPRB, 0.37099508E-03_JPRB, 0.37099436E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099340E-03_JPRB, 0.37099296E-03_JPRB, 0.37099276E-03_JPRB, 0.37099264E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099241E-03_JPRB, 0.37099241E-03_JPRB, 0.37099232E-03_JPRB, 0.37099229E-03_JPRB, 0.37099220E-03_JPRB, &
  & 0.37099217E-03_JPRB, 0.37099214E-03_JPRB, 0.37099214E-03_JPRB, 0.37099206E-03_JPRB, 0.37099194E-03_JPRB, 0.37099188E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099179E-03_JPRB, 0.37099177E-03_JPRB, 0.37099168E-03_JPRB /)

RGHG1(:,59,10) = (/ &
  & 0.37098181E-03_JPRB, 0.37098263E-03_JPRB, 0.37098315E-03_JPRB, 0.37098367E-03_JPRB, 0.37098420E-03_JPRB, 0.37098466E-03_JPRB, &
  & 0.37098490E-03_JPRB, 0.37098501E-03_JPRB, 0.37098510E-03_JPRB, 0.37098516E-03_JPRB, 0.37098519E-03_JPRB, 0.37098525E-03_JPRB, &
  & 0.37098528E-03_JPRB, 0.37098530E-03_JPRB, 0.37098528E-03_JPRB, 0.37098528E-03_JPRB, 0.37098510E-03_JPRB, 0.37098493E-03_JPRB, &
  & 0.37098481E-03_JPRB, 0.37098498E-03_JPRB, 0.37098525E-03_JPRB, 0.37098597E-03_JPRB, 0.37098717E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37099028E-03_JPRB, 0.37099182E-03_JPRB, 0.37099331E-03_JPRB, 0.37099473E-03_JPRB, 0.37099590E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099834E-03_JPRB, 0.37099863E-03_JPRB, 0.37099887E-03_JPRB, 0.37099875E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099744E-03_JPRB, 0.37099683E-03_JPRB, 0.37099613E-03_JPRB, 0.37099546E-03_JPRB, 0.37099476E-03_JPRB, &
  & 0.37099433E-03_JPRB, 0.37099383E-03_JPRB, 0.37099342E-03_JPRB, 0.37099325E-03_JPRB, 0.37099322E-03_JPRB, 0.37099325E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099305E-03_JPRB, 0.37099305E-03_JPRB, 0.37099299E-03_JPRB, 0.37099293E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099287E-03_JPRB, 0.37099281E-03_JPRB, 0.37099276E-03_JPRB, 0.37099270E-03_JPRB, 0.37099264E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099252E-03_JPRB, 0.37099246E-03_JPRB, 0.37099232E-03_JPRB /)

RGHG1(:,60,10) = (/ &
  & 0.37098347E-03_JPRB, 0.37098417E-03_JPRB, 0.37098455E-03_JPRB, 0.37098501E-03_JPRB, 0.37098542E-03_JPRB, 0.37098577E-03_JPRB, &
  & 0.37098589E-03_JPRB, 0.37098594E-03_JPRB, 0.37098600E-03_JPRB, 0.37098603E-03_JPRB, 0.37098612E-03_JPRB, 0.37098618E-03_JPRB, &
  & 0.37098624E-03_JPRB, 0.37098629E-03_JPRB, 0.37098635E-03_JPRB, 0.37098632E-03_JPRB, 0.37098612E-03_JPRB, 0.37098594E-03_JPRB, &
  & 0.37098592E-03_JPRB, 0.37098615E-03_JPRB, 0.37098632E-03_JPRB, 0.37098682E-03_JPRB, 0.37098787E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37099078E-03_JPRB, 0.37099232E-03_JPRB, 0.37099374E-03_JPRB, 0.37099505E-03_JPRB, 0.37099619E-03_JPRB, 0.37099712E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099846E-03_JPRB, 0.37099884E-03_JPRB, 0.37099910E-03_JPRB, 0.37099898E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099770E-03_JPRB, 0.37099721E-03_JPRB, 0.37099645E-03_JPRB, 0.37099590E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099479E-03_JPRB, 0.37099433E-03_JPRB, 0.37099398E-03_JPRB, 0.37099374E-03_JPRB, 0.37099374E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099348E-03_JPRB, 0.37099351E-03_JPRB, 0.37099345E-03_JPRB, 0.37099345E-03_JPRB, 0.37099342E-03_JPRB, &
  & 0.37099340E-03_JPRB, 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, 0.37099322E-03_JPRB, 0.37099313E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099305E-03_JPRB, 0.37099305E-03_JPRB, 0.37099296E-03_JPRB, 0.37099284E-03_JPRB /)

RGHG1(:,61,10) = (/ &
  & 0.37098484E-03_JPRB, 0.37098536E-03_JPRB, 0.37098571E-03_JPRB, 0.37098600E-03_JPRB, 0.37098629E-03_JPRB, 0.37098659E-03_JPRB, &
  & 0.37098676E-03_JPRB, 0.37098682E-03_JPRB, 0.37098691E-03_JPRB, 0.37098693E-03_JPRB, 0.37098699E-03_JPRB, 0.37098708E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098725E-03_JPRB, 0.37098728E-03_JPRB, 0.37098728E-03_JPRB, 0.37098714E-03_JPRB, 0.37098708E-03_JPRB, &
  & 0.37098691E-03_JPRB, 0.37098717E-03_JPRB, 0.37098728E-03_JPRB, 0.37098778E-03_JPRB, 0.37098865E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099139E-03_JPRB, 0.37099281E-03_JPRB, 0.37099412E-03_JPRB, 0.37099540E-03_JPRB, 0.37099645E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099872E-03_JPRB, 0.37099904E-03_JPRB, 0.37099927E-03_JPRB, 0.37099925E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099796E-03_JPRB, 0.37099750E-03_JPRB, 0.37099671E-03_JPRB, 0.37099610E-03_JPRB, 0.37099558E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099482E-03_JPRB, 0.37099450E-03_JPRB, 0.37099433E-03_JPRB, 0.37099436E-03_JPRB, 0.37099436E-03_JPRB, &
  & 0.37099424E-03_JPRB, 0.37099415E-03_JPRB, 0.37099412E-03_JPRB, 0.37099404E-03_JPRB, 0.37099395E-03_JPRB, 0.37099386E-03_JPRB, &
  & 0.37099383E-03_JPRB, 0.37099377E-03_JPRB, 0.37099374E-03_JPRB, 0.37099369E-03_JPRB, 0.37099357E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099337E-03_JPRB, 0.37099331E-03_JPRB, 0.37099328E-03_JPRB, 0.37099322E-03_JPRB /)

RGHG1(:,62,10) = (/ &
  & 0.37098600E-03_JPRB, 0.37098650E-03_JPRB, 0.37098679E-03_JPRB, 0.37098699E-03_JPRB, 0.37098728E-03_JPRB, 0.37098752E-03_JPRB, &
  & 0.37098769E-03_JPRB, 0.37098781E-03_JPRB, 0.37098792E-03_JPRB, 0.37098798E-03_JPRB, 0.37098804E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098827E-03_JPRB, 0.37098839E-03_JPRB, 0.37098859E-03_JPRB, 0.37098862E-03_JPRB, 0.37098833E-03_JPRB, 0.37098807E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098821E-03_JPRB, 0.37098824E-03_JPRB, 0.37098874E-03_JPRB, 0.37098944E-03_JPRB, 0.37099060E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099328E-03_JPRB, 0.37099456E-03_JPRB, 0.37099567E-03_JPRB, 0.37099668E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099887E-03_JPRB, 0.37099925E-03_JPRB, 0.37099936E-03_JPRB, 0.37099939E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099826E-03_JPRB, 0.37099782E-03_JPRB, 0.37099712E-03_JPRB, 0.37099657E-03_JPRB, 0.37099599E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099529E-03_JPRB, 0.37099500E-03_JPRB, 0.37099491E-03_JPRB, 0.37099491E-03_JPRB, 0.37099482E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099471E-03_JPRB, 0.37099473E-03_JPRB, 0.37099462E-03_JPRB, 0.37099450E-03_JPRB, 0.37099438E-03_JPRB, &
  & 0.37099430E-03_JPRB, 0.37099427E-03_JPRB, 0.37099421E-03_JPRB, 0.37099415E-03_JPRB, 0.37099404E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099389E-03_JPRB, 0.37099383E-03_JPRB, 0.37099380E-03_JPRB, 0.37099369E-03_JPRB /)

RGHG1(:,63,10) = (/ &
  & 0.37098708E-03_JPRB, 0.37098757E-03_JPRB, 0.37098781E-03_JPRB, 0.37098798E-03_JPRB, 0.37098821E-03_JPRB, 0.37098842E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37098862E-03_JPRB, 0.37098874E-03_JPRB, 0.37098880E-03_JPRB, 0.37098886E-03_JPRB, 0.37098891E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37098894E-03_JPRB, 0.37098906E-03_JPRB, 0.37098903E-03_JPRB, 0.37098918E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37098903E-03_JPRB, 0.37098920E-03_JPRB, 0.37098926E-03_JPRB, 0.37098958E-03_JPRB, 0.37099028E-03_JPRB, 0.37099130E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099377E-03_JPRB, 0.37099497E-03_JPRB, 0.37099604E-03_JPRB, 0.37099703E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099904E-03_JPRB, 0.37099939E-03_JPRB, 0.37099962E-03_JPRB, 0.37099959E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099846E-03_JPRB, 0.37099814E-03_JPRB, 0.37099735E-03_JPRB, 0.37099689E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099575E-03_JPRB, 0.37099552E-03_JPRB, 0.37099543E-03_JPRB, 0.37099543E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099511E-03_JPRB, 0.37099517E-03_JPRB, 0.37099508E-03_JPRB, 0.37099500E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099476E-03_JPRB, 0.37099473E-03_JPRB, 0.37099465E-03_JPRB, 0.37099450E-03_JPRB, 0.37099436E-03_JPRB, &
  & 0.37099424E-03_JPRB, 0.37099415E-03_JPRB, 0.37099409E-03_JPRB, 0.37099398E-03_JPRB /)

RGHG1(:,64,10) = (/ &
  & 0.37098792E-03_JPRB, 0.37098839E-03_JPRB, 0.37098865E-03_JPRB, 0.37098883E-03_JPRB, 0.37098909E-03_JPRB, 0.37098929E-03_JPRB, &
  & 0.37098938E-03_JPRB, 0.37098947E-03_JPRB, 0.37098955E-03_JPRB, 0.37098961E-03_JPRB, 0.37098973E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37099011E-03_JPRB, 0.37099046E-03_JPRB, 0.37099095E-03_JPRB, 0.37099089E-03_JPRB, 0.37099060E-03_JPRB, 0.37099014E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37099019E-03_JPRB, 0.37099025E-03_JPRB, 0.37099048E-03_JPRB, 0.37099121E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099319E-03_JPRB, 0.37099436E-03_JPRB, 0.37099546E-03_JPRB, 0.37099654E-03_JPRB, 0.37099741E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099930E-03_JPRB, 0.37099965E-03_JPRB, 0.37099983E-03_JPRB, 0.37099983E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099872E-03_JPRB, 0.37099843E-03_JPRB, 0.37099776E-03_JPRB, 0.37099727E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, 0.37099604E-03_JPRB, 0.37099593E-03_JPRB, 0.37099593E-03_JPRB, 0.37099581E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099561E-03_JPRB, 0.37099569E-03_JPRB, 0.37099558E-03_JPRB, 0.37099540E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099514E-03_JPRB, 0.37099514E-03_JPRB, 0.37099497E-03_JPRB, 0.37099482E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099453E-03_JPRB, 0.37099444E-03_JPRB, 0.37099430E-03_JPRB /)

RGHG1(:,65,10) = (/ &
  & 0.37098880E-03_JPRB, 0.37098920E-03_JPRB, 0.37098947E-03_JPRB, 0.37098967E-03_JPRB, 0.37098984E-03_JPRB, 0.37098996E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37099014E-03_JPRB, 0.37099028E-03_JPRB, 0.37099037E-03_JPRB, 0.37099054E-03_JPRB, 0.37099066E-03_JPRB, &
  & 0.37099072E-03_JPRB, 0.37099066E-03_JPRB, 0.37099081E-03_JPRB, 0.37099083E-03_JPRB, 0.37099113E-03_JPRB, 0.37099113E-03_JPRB, &
  & 0.37099101E-03_JPRB, 0.37099121E-03_JPRB, 0.37099118E-03_JPRB, 0.37099142E-03_JPRB, 0.37099209E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099383E-03_JPRB, 0.37099491E-03_JPRB, 0.37099596E-03_JPRB, 0.37099695E-03_JPRB, 0.37099779E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099951E-03_JPRB, 0.37099986E-03_JPRB, 0.37100009E-03_JPRB, 0.37100009E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37099907E-03_JPRB, 0.37099869E-03_JPRB, 0.37099808E-03_JPRB, 0.37099770E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099703E-03_JPRB, 0.37099677E-03_JPRB, 0.37099651E-03_JPRB, 0.37099639E-03_JPRB, 0.37099631E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099619E-03_JPRB, 0.37099599E-03_JPRB, 0.37099613E-03_JPRB, 0.37099596E-03_JPRB, 0.37099578E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099558E-03_JPRB, 0.37099546E-03_JPRB, 0.37099532E-03_JPRB, 0.37099514E-03_JPRB, 0.37099497E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099479E-03_JPRB, 0.37099471E-03_JPRB, 0.37099453E-03_JPRB /)

RGHG1(:,66,10) = (/ &
  & 0.37098950E-03_JPRB, 0.37098996E-03_JPRB, 0.37099025E-03_JPRB, 0.37099046E-03_JPRB, 0.37099060E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099098E-03_JPRB, 0.37099113E-03_JPRB, 0.37099115E-03_JPRB, 0.37099142E-03_JPRB, 0.37099159E-03_JPRB, &
  & 0.37099194E-03_JPRB, 0.37099267E-03_JPRB, 0.37099325E-03_JPRB, 0.37099308E-03_JPRB, 0.37099261E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099211E-03_JPRB, 0.37099217E-03_JPRB, 0.37099241E-03_JPRB, 0.37099299E-03_JPRB, 0.37099372E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099555E-03_JPRB, 0.37099645E-03_JPRB, 0.37099732E-03_JPRB, 0.37099811E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099968E-03_JPRB, 0.37100000E-03_JPRB, 0.37100026E-03_JPRB, 0.37100018E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099927E-03_JPRB, 0.37099898E-03_JPRB, 0.37099840E-03_JPRB, 0.37099799E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099721E-03_JPRB, 0.37099689E-03_JPRB, 0.37099680E-03_JPRB, 0.37099680E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099668E-03_JPRB, 0.37099648E-03_JPRB, 0.37099657E-03_JPRB, 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099596E-03_JPRB, 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, 0.37099561E-03_JPRB, 0.37099549E-03_JPRB, &
  & 0.37099537E-03_JPRB, 0.37099520E-03_JPRB, 0.37099503E-03_JPRB, 0.37099471E-03_JPRB /)

RGHG1(:,67,10) = (/ &
  & 0.37099019E-03_JPRB, 0.37099066E-03_JPRB, 0.37099095E-03_JPRB, 0.37099118E-03_JPRB, 0.37099142E-03_JPRB, 0.37099156E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099171E-03_JPRB, 0.37099177E-03_JPRB, 0.37099191E-03_JPRB, 0.37099214E-03_JPRB, 0.37099232E-03_JPRB, &
  & 0.37099238E-03_JPRB, 0.37099241E-03_JPRB, 0.37099246E-03_JPRB, 0.37099267E-03_JPRB, 0.37099310E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099296E-03_JPRB, 0.37099310E-03_JPRB, 0.37099313E-03_JPRB, 0.37099340E-03_JPRB, 0.37099386E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099613E-03_JPRB, 0.37099698E-03_JPRB, 0.37099773E-03_JPRB, 0.37099849E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099997E-03_JPRB, 0.37100018E-03_JPRB, 0.37100041E-03_JPRB, 0.37100032E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099954E-03_JPRB, 0.37099919E-03_JPRB, 0.37099878E-03_JPRB, 0.37099843E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099773E-03_JPRB, 0.37099735E-03_JPRB, 0.37099724E-03_JPRB, 0.37099718E-03_JPRB, 0.37099718E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099695E-03_JPRB, 0.37099692E-03_JPRB, 0.37099695E-03_JPRB, 0.37099674E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099648E-03_JPRB, 0.37099636E-03_JPRB, 0.37099610E-03_JPRB, 0.37099596E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099569E-03_JPRB, 0.37099552E-03_JPRB, 0.37099532E-03_JPRB, 0.37099491E-03_JPRB /)

RGHG1(:,68,10) = (/ &
  & 0.37099083E-03_JPRB, 0.37099147E-03_JPRB, 0.37099179E-03_JPRB, 0.37099197E-03_JPRB, 0.37099217E-03_JPRB, 0.37099235E-03_JPRB, &
  & 0.37099246E-03_JPRB, 0.37099258E-03_JPRB, 0.37099264E-03_JPRB, 0.37099276E-03_JPRB, 0.37099296E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099473E-03_JPRB, 0.37099503E-03_JPRB, 0.37099482E-03_JPRB, 0.37099444E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099395E-03_JPRB, 0.37099409E-03_JPRB, 0.37099412E-03_JPRB, 0.37099433E-03_JPRB, 0.37099479E-03_JPRB, 0.37099535E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099671E-03_JPRB, 0.37099744E-03_JPRB, 0.37099814E-03_JPRB, 0.37099875E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100015E-03_JPRB, 0.37100032E-03_JPRB, 0.37100055E-03_JPRB, 0.37100053E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099980E-03_JPRB, 0.37099954E-03_JPRB, 0.37099919E-03_JPRB, 0.37099884E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099817E-03_JPRB, 0.37099785E-03_JPRB, 0.37099779E-03_JPRB, 0.37099767E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099730E-03_JPRB, 0.37099738E-03_JPRB, 0.37099738E-03_JPRB, 0.37099718E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099680E-03_JPRB, 0.37099674E-03_JPRB, 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099578E-03_JPRB, 0.37099558E-03_JPRB, 0.37099505E-03_JPRB /)

RGHG1(:,69,10) = (/ &
  & 0.37099150E-03_JPRB, 0.37099217E-03_JPRB, 0.37099252E-03_JPRB, 0.37099278E-03_JPRB, 0.37099296E-03_JPRB, 0.37099310E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099337E-03_JPRB, 0.37099334E-03_JPRB, 0.37099351E-03_JPRB, 0.37099369E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099386E-03_JPRB, 0.37099404E-03_JPRB, 0.37099415E-03_JPRB, 0.37099468E-03_JPRB, 0.37099514E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099491E-03_JPRB, 0.37099491E-03_JPRB, 0.37099523E-03_JPRB, 0.37099561E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099735E-03_JPRB, 0.37099799E-03_JPRB, 0.37099858E-03_JPRB, 0.37099904E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37100021E-03_JPRB, 0.37100041E-03_JPRB, 0.37100073E-03_JPRB, 0.37100055E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100015E-03_JPRB, 0.37099989E-03_JPRB, 0.37099954E-03_JPRB, 0.37099910E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099852E-03_JPRB, 0.37099834E-03_JPRB, 0.37099820E-03_JPRB, 0.37099805E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099782E-03_JPRB, 0.37099782E-03_JPRB, 0.37099782E-03_JPRB, 0.37099764E-03_JPRB, 0.37099744E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099715E-03_JPRB, 0.37099706E-03_JPRB, 0.37099677E-03_JPRB, 0.37099671E-03_JPRB, 0.37099654E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099613E-03_JPRB, 0.37099587E-03_JPRB, 0.37099537E-03_JPRB /)

RGHG1(:,70,10) = (/ &
  & 0.37099217E-03_JPRB, 0.37099284E-03_JPRB, 0.37099325E-03_JPRB, 0.37099354E-03_JPRB, 0.37099369E-03_JPRB, 0.37099392E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099415E-03_JPRB, 0.37099412E-03_JPRB, 0.37099427E-03_JPRB, 0.37099438E-03_JPRB, 0.37099459E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099657E-03_JPRB, 0.37099633E-03_JPRB, 0.37099622E-03_JPRB, 0.37099613E-03_JPRB, 0.37099619E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099581E-03_JPRB, 0.37099590E-03_JPRB, 0.37099613E-03_JPRB, 0.37099639E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099796E-03_JPRB, 0.37099843E-03_JPRB, 0.37099898E-03_JPRB, 0.37099945E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100026E-03_JPRB, 0.37100041E-03_JPRB, 0.37100082E-03_JPRB, 0.37100061E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100038E-03_JPRB, 0.37100012E-03_JPRB, 0.37099983E-03_JPRB, 0.37099945E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099893E-03_JPRB, 0.37099887E-03_JPRB, 0.37099863E-03_JPRB, 0.37099849E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099820E-03_JPRB, 0.37099814E-03_JPRB, 0.37099817E-03_JPRB, 0.37099811E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099747E-03_JPRB, 0.37099744E-03_JPRB, 0.37099712E-03_JPRB, 0.37099712E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099648E-03_JPRB, 0.37099616E-03_JPRB, 0.37099567E-03_JPRB /)

RGHG1(:,71,10) = (/ &
  & 0.37099287E-03_JPRB, 0.37099363E-03_JPRB, 0.37099404E-03_JPRB, 0.37099424E-03_JPRB, 0.37099436E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099491E-03_JPRB, 0.37099494E-03_JPRB, 0.37099511E-03_JPRB, 0.37099520E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37099564E-03_JPRB, 0.37099584E-03_JPRB, 0.37099660E-03_JPRB, 0.37099700E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099674E-03_JPRB, 0.37099689E-03_JPRB, 0.37099698E-03_JPRB, 0.37099715E-03_JPRB, 0.37099747E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099858E-03_JPRB, 0.37099878E-03_JPRB, 0.37099936E-03_JPRB, 0.37099977E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100032E-03_JPRB, 0.37100058E-03_JPRB, 0.37100096E-03_JPRB, 0.37100067E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37100064E-03_JPRB, 0.37100055E-03_JPRB, 0.37100018E-03_JPRB, 0.37099986E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099933E-03_JPRB, 0.37099933E-03_JPRB, 0.37099904E-03_JPRB, 0.37099881E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099858E-03_JPRB, 0.37099846E-03_JPRB, 0.37099858E-03_JPRB, 0.37099852E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099782E-03_JPRB, 0.37099788E-03_JPRB, 0.37099762E-03_JPRB, 0.37099759E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099709E-03_JPRB, 0.37099677E-03_JPRB, 0.37099642E-03_JPRB, 0.37099601E-03_JPRB /)

RGHG1(:,72,10) = (/ &
  & 0.37099363E-03_JPRB, 0.37099447E-03_JPRB, 0.37099485E-03_JPRB, 0.37099500E-03_JPRB, 0.37099500E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099564E-03_JPRB, 0.37099569E-03_JPRB, 0.37099590E-03_JPRB, 0.37099599E-03_JPRB, 0.37099596E-03_JPRB, &
  & 0.37099625E-03_JPRB, 0.37099826E-03_JPRB, 0.37099738E-03_JPRB, 0.37099750E-03_JPRB, 0.37099773E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099750E-03_JPRB, 0.37099770E-03_JPRB, 0.37099779E-03_JPRB, 0.37099785E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099916E-03_JPRB, 0.37099922E-03_JPRB, 0.37099971E-03_JPRB, 0.37100012E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100035E-03_JPRB, 0.37100044E-03_JPRB, 0.37100105E-03_JPRB, 0.37100082E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100085E-03_JPRB, 0.37100090E-03_JPRB, 0.37100044E-03_JPRB, 0.37100021E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099986E-03_JPRB, 0.37099980E-03_JPRB, 0.37099945E-03_JPRB, 0.37099916E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099898E-03_JPRB, 0.37099878E-03_JPRB, 0.37099890E-03_JPRB, 0.37099884E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099820E-03_JPRB, 0.37099831E-03_JPRB, 0.37099799E-03_JPRB, 0.37099811E-03_JPRB, 0.37099785E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099712E-03_JPRB, 0.37099689E-03_JPRB, 0.37099645E-03_JPRB /)

RGHG1(:,73,10) = (/ &
  & 0.37099450E-03_JPRB, 0.37099537E-03_JPRB, 0.37099564E-03_JPRB, 0.37099567E-03_JPRB, 0.37099564E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099648E-03_JPRB, 0.37099654E-03_JPRB, 0.37099671E-03_JPRB, 0.37099665E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099730E-03_JPRB, 0.37099735E-03_JPRB, 0.37099794E-03_JPRB, 0.37099840E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099814E-03_JPRB, 0.37099843E-03_JPRB, 0.37099852E-03_JPRB, 0.37099858E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099974E-03_JPRB, 0.37099962E-03_JPRB, 0.37100012E-03_JPRB, 0.37100035E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100029E-03_JPRB, 0.37100041E-03_JPRB, 0.37100114E-03_JPRB, 0.37100099E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100117E-03_JPRB, 0.37100117E-03_JPRB, 0.37100061E-03_JPRB, 0.37100055E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100038E-03_JPRB, 0.37100023E-03_JPRB, 0.37099980E-03_JPRB, 0.37099945E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099927E-03_JPRB, 0.37099910E-03_JPRB, 0.37099927E-03_JPRB, 0.37099927E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099843E-03_JPRB, 0.37099860E-03_JPRB, 0.37099834E-03_JPRB, 0.37099860E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099753E-03_JPRB, 0.37099721E-03_JPRB, 0.37099700E-03_JPRB /)

RGHG1(:,74,10) = (/ &
  & 0.37099546E-03_JPRB, 0.37099636E-03_JPRB, 0.37099645E-03_JPRB, 0.37099616E-03_JPRB, 0.37099613E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099738E-03_JPRB, 0.37099741E-03_JPRB, 0.37099753E-03_JPRB, 0.37099738E-03_JPRB, 0.37099715E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099925E-03_JPRB, 0.37099799E-03_JPRB, 0.37099843E-03_JPRB, 0.37099893E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099893E-03_JPRB, 0.37099922E-03_JPRB, 0.37099933E-03_JPRB, 0.37099916E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37100041E-03_JPRB, 0.37099997E-03_JPRB, 0.37100050E-03_JPRB, 0.37100055E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100029E-03_JPRB, 0.37100026E-03_JPRB, 0.37100120E-03_JPRB, 0.37100120E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100125E-03_JPRB, 0.37100137E-03_JPRB, 0.37100079E-03_JPRB, 0.37100096E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37100088E-03_JPRB, 0.37100076E-03_JPRB, 0.37100015E-03_JPRB, 0.37099957E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099957E-03_JPRB, 0.37099939E-03_JPRB, 0.37099965E-03_JPRB, 0.37099983E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099860E-03_JPRB, 0.37099890E-03_JPRB, 0.37099869E-03_JPRB, 0.37099910E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099791E-03_JPRB, 0.37099753E-03_JPRB, 0.37099750E-03_JPRB /)

RGHG1(:,75,10) = (/ &
  & 0.37099642E-03_JPRB, 0.37099727E-03_JPRB, 0.37099721E-03_JPRB, 0.37099671E-03_JPRB, 0.37099660E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099820E-03_JPRB, 0.37099820E-03_JPRB, 0.37099831E-03_JPRB, 0.37099817E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099890E-03_JPRB, 0.37099820E-03_JPRB, 0.37099866E-03_JPRB, 0.37099927E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37099959E-03_JPRB, 0.37099994E-03_JPRB, 0.37100003E-03_JPRB, 0.37099980E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100096E-03_JPRB, 0.37100032E-03_JPRB, 0.37100088E-03_JPRB, 0.37100067E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100035E-03_JPRB, 0.37100006E-03_JPRB, 0.37099989E-03_JPRB, 0.37100122E-03_JPRB, 0.37100149E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100137E-03_JPRB, 0.37100166E-03_JPRB, 0.37100090E-03_JPRB, 0.37100134E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100146E-03_JPRB, 0.37100128E-03_JPRB, 0.37100050E-03_JPRB, 0.37099974E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099986E-03_JPRB, 0.37099951E-03_JPRB, 0.37100000E-03_JPRB, 0.37100029E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099860E-03_JPRB, 0.37099925E-03_JPRB, 0.37099898E-03_JPRB, 0.37099962E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099820E-03_JPRB, 0.37099776E-03_JPRB, 0.37099802E-03_JPRB /)

RGHG1(:,76,10) = (/ &
  & 0.37099741E-03_JPRB, 0.37099828E-03_JPRB, 0.37099799E-03_JPRB, 0.37099709E-03_JPRB, 0.37099677E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099898E-03_JPRB, 0.37099890E-03_JPRB, 0.37099925E-03_JPRB, 0.37099910E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099942E-03_JPRB, 0.37099817E-03_JPRB, 0.37099881E-03_JPRB, 0.37099968E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100018E-03_JPRB, 0.37100061E-03_JPRB, 0.37100073E-03_JPRB, 0.37100032E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100154E-03_JPRB, 0.37100055E-03_JPRB, 0.37100125E-03_JPRB, 0.37100079E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099989E-03_JPRB, 0.37099962E-03_JPRB, 0.37100134E-03_JPRB, 0.37100172E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100154E-03_JPRB, 0.37100175E-03_JPRB, 0.37100090E-03_JPRB, 0.37100166E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100216E-03_JPRB, 0.37100186E-03_JPRB, 0.37100079E-03_JPRB, 0.37099974E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100012E-03_JPRB, 0.37099959E-03_JPRB, 0.37100041E-03_JPRB, 0.37100088E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099843E-03_JPRB, 0.37099945E-03_JPRB, 0.37099916E-03_JPRB, 0.37100015E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099846E-03_JPRB, 0.37099808E-03_JPRB, 0.37099860E-03_JPRB /)

RGHG1(:,77,10) = (/ &
  & 0.37099849E-03_JPRB, 0.37099936E-03_JPRB, 0.37099881E-03_JPRB, 0.37099735E-03_JPRB, 0.37099683E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37099991E-03_JPRB, 0.37099962E-03_JPRB, 0.37100023E-03_JPRB, 0.37099989E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37099957E-03_JPRB, 0.37099791E-03_JPRB, 0.37099875E-03_JPRB, 0.37099986E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100172E-03_JPRB, 0.37100073E-03_JPRB, 0.37100131E-03_JPRB, 0.37100143E-03_JPRB, 0.37100079E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100218E-03_JPRB, 0.37100079E-03_JPRB, 0.37100163E-03_JPRB, 0.37100082E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37099965E-03_JPRB, 0.37099925E-03_JPRB, 0.37100125E-03_JPRB, 0.37100207E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100166E-03_JPRB, 0.37100189E-03_JPRB, 0.37100076E-03_JPRB, 0.37100192E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100288E-03_JPRB, 0.37100250E-03_JPRB, 0.37100105E-03_JPRB, 0.37099968E-03_JPRB, 0.37100137E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100047E-03_JPRB, 0.37099968E-03_JPRB, 0.37100090E-03_JPRB, 0.37100163E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099817E-03_JPRB, 0.37099980E-03_JPRB, 0.37099925E-03_JPRB, 0.37100076E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099878E-03_JPRB, 0.37099826E-03_JPRB, 0.37099916E-03_JPRB /)

RGHG1(:,78,10) = (/ &
  & 0.37099959E-03_JPRB, 0.37100050E-03_JPRB, 0.37099962E-03_JPRB, 0.37099753E-03_JPRB, 0.37099665E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100160E-03_JPRB, 0.37100067E-03_JPRB, 0.37100026E-03_JPRB, 0.37100125E-03_JPRB, 0.37100067E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099936E-03_JPRB, 0.37099779E-03_JPRB, 0.37099860E-03_JPRB, 0.37100003E-03_JPRB, 0.37100335E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100117E-03_JPRB, 0.37100192E-03_JPRB, 0.37100204E-03_JPRB, 0.37100122E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100277E-03_JPRB, 0.37100093E-03_JPRB, 0.37100198E-03_JPRB, 0.37100088E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37099951E-03_JPRB, 0.37099901E-03_JPRB, 0.37100131E-03_JPRB, 0.37100242E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37100181E-03_JPRB, 0.37100195E-03_JPRB, 0.37100061E-03_JPRB, 0.37100221E-03_JPRB, 0.37100274E-03_JPRB, &
  & 0.37100373E-03_JPRB, 0.37100355E-03_JPRB, 0.37100300E-03_JPRB, 0.37100122E-03_JPRB, 0.37099948E-03_JPRB, 0.37100178E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37100079E-03_JPRB, 0.37099962E-03_JPRB, 0.37100125E-03_JPRB, 0.37100245E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099776E-03_JPRB, 0.37100006E-03_JPRB, 0.37099927E-03_JPRB, 0.37100143E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099898E-03_JPRB, 0.37099837E-03_JPRB, 0.37099968E-03_JPRB /)

RGHG1(:,79,10) = (/ &
  & 0.37100047E-03_JPRB, 0.37100125E-03_JPRB, 0.37100018E-03_JPRB, 0.37099738E-03_JPRB, 0.37099619E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100265E-03_JPRB, 0.37100120E-03_JPRB, 0.37100053E-03_JPRB, 0.37100192E-03_JPRB, 0.37100122E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099904E-03_JPRB, 0.37099744E-03_JPRB, 0.37099843E-03_JPRB, 0.37100006E-03_JPRB, 0.37100422E-03_JPRB, &
  & 0.37100326E-03_JPRB, 0.37100149E-03_JPRB, 0.37100245E-03_JPRB, 0.37100265E-03_JPRB, 0.37100166E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37100338E-03_JPRB, 0.37100120E-03_JPRB, 0.37100236E-03_JPRB, 0.37100085E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099930E-03_JPRB, 0.37099863E-03_JPRB, 0.37100143E-03_JPRB, 0.37100288E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100198E-03_JPRB, 0.37100213E-03_JPRB, 0.37100064E-03_JPRB, 0.37100253E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37100454E-03_JPRB, 0.37100431E-03_JPRB, 0.37100379E-03_JPRB, 0.37100143E-03_JPRB, 0.37099927E-03_JPRB, 0.37100218E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37100117E-03_JPRB, 0.37099957E-03_JPRB, 0.37100169E-03_JPRB, 0.37100332E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099730E-03_JPRB, 0.37100029E-03_JPRB, 0.37099913E-03_JPRB, 0.37100204E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37099913E-03_JPRB, 0.37099840E-03_JPRB, 0.37100015E-03_JPRB /)

RGHG1(:,80,10) = (/ &
  & 0.37100131E-03_JPRB, 0.37100186E-03_JPRB, 0.37100050E-03_JPRB, 0.37099727E-03_JPRB, 0.37099578E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37100329E-03_JPRB, 0.37100154E-03_JPRB, 0.37100076E-03_JPRB, 0.37100250E-03_JPRB, 0.37100160E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099887E-03_JPRB, 0.37099721E-03_JPRB, 0.37099831E-03_JPRB, 0.37100015E-03_JPRB, 0.37100498E-03_JPRB, &
  & 0.37100387E-03_JPRB, 0.37100175E-03_JPRB, 0.37100291E-03_JPRB, 0.37100312E-03_JPRB, 0.37100201E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100230E-03_JPRB, 0.37100376E-03_JPRB, 0.37100137E-03_JPRB, 0.37100256E-03_JPRB, 0.37100096E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099919E-03_JPRB, 0.37099837E-03_JPRB, 0.37100152E-03_JPRB, 0.37100320E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100221E-03_JPRB, 0.37100236E-03_JPRB, 0.37100070E-03_JPRB, 0.37100280E-03_JPRB, 0.37100376E-03_JPRB, &
  & 0.37100515E-03_JPRB, 0.37100486E-03_JPRB, 0.37100416E-03_JPRB, 0.37100163E-03_JPRB, 0.37099925E-03_JPRB, 0.37100256E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100137E-03_JPRB, 0.37099951E-03_JPRB, 0.37100198E-03_JPRB, 0.37100393E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099619E-03_JPRB, 0.37099698E-03_JPRB, 0.37100044E-03_JPRB, 0.37099904E-03_JPRB, 0.37100250E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099916E-03_JPRB, 0.37099828E-03_JPRB, 0.37100064E-03_JPRB /)

RGHG1(:,81,10) = (/ &
  & 0.37100210E-03_JPRB, 0.37100224E-03_JPRB, 0.37100070E-03_JPRB, 0.37099721E-03_JPRB, 0.37099555E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100370E-03_JPRB, 0.37100172E-03_JPRB, 0.37100079E-03_JPRB, 0.37100280E-03_JPRB, 0.37100181E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099875E-03_JPRB, 0.37099709E-03_JPRB, 0.37099820E-03_JPRB, 0.37100012E-03_JPRB, 0.37100542E-03_JPRB, &
  & 0.37100422E-03_JPRB, 0.37100195E-03_JPRB, 0.37100323E-03_JPRB, 0.37100341E-03_JPRB, 0.37100221E-03_JPRB, 0.37100189E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100399E-03_JPRB, 0.37100154E-03_JPRB, 0.37100277E-03_JPRB, 0.37100102E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099907E-03_JPRB, 0.37099817E-03_JPRB, 0.37100157E-03_JPRB, 0.37100335E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100230E-03_JPRB, 0.37100250E-03_JPRB, 0.37100076E-03_JPRB, 0.37100303E-03_JPRB, 0.37100402E-03_JPRB, &
  & 0.37100556E-03_JPRB, 0.37100530E-03_JPRB, 0.37100451E-03_JPRB, 0.37100178E-03_JPRB, 0.37099907E-03_JPRB, 0.37100274E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100154E-03_JPRB, 0.37099945E-03_JPRB, 0.37100213E-03_JPRB, 0.37100428E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099593E-03_JPRB, 0.37099674E-03_JPRB, 0.37100055E-03_JPRB, 0.37099893E-03_JPRB, 0.37100271E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099913E-03_JPRB, 0.37099823E-03_JPRB, 0.37100111E-03_JPRB /)

RGHG1(:,82,10) = (/ &
  & 0.37100221E-03_JPRB, 0.37100242E-03_JPRB, 0.37100076E-03_JPRB, 0.37099706E-03_JPRB, 0.37099543E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100393E-03_JPRB, 0.37100198E-03_JPRB, 0.37100099E-03_JPRB, 0.37100291E-03_JPRB, 0.37100192E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099863E-03_JPRB, 0.37099692E-03_JPRB, 0.37099811E-03_JPRB, 0.37100015E-03_JPRB, 0.37100574E-03_JPRB, &
  & 0.37100445E-03_JPRB, 0.37100198E-03_JPRB, 0.37100347E-03_JPRB, 0.37100364E-03_JPRB, 0.37100236E-03_JPRB, 0.37100201E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100425E-03_JPRB, 0.37100175E-03_JPRB, 0.37100285E-03_JPRB, 0.37100108E-03_JPRB, 0.37100018E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099898E-03_JPRB, 0.37099814E-03_JPRB, 0.37100160E-03_JPRB, 0.37100352E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37100230E-03_JPRB, 0.37100256E-03_JPRB, 0.37100079E-03_JPRB, 0.37100309E-03_JPRB, 0.37100422E-03_JPRB, &
  & 0.37100591E-03_JPRB, 0.37100562E-03_JPRB, 0.37100483E-03_JPRB, 0.37100189E-03_JPRB, 0.37099898E-03_JPRB, 0.37100288E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100163E-03_JPRB, 0.37099945E-03_JPRB, 0.37100227E-03_JPRB, 0.37100448E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099654E-03_JPRB, 0.37100061E-03_JPRB, 0.37099890E-03_JPRB, 0.37100285E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099904E-03_JPRB, 0.37099811E-03_JPRB, 0.37100114E-03_JPRB /)

RGHG1(:,83,10) = (/ &
  & 0.37100230E-03_JPRB, 0.37100248E-03_JPRB, 0.37100082E-03_JPRB, 0.37099695E-03_JPRB, 0.37099526E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100402E-03_JPRB, 0.37100198E-03_JPRB, 0.37100108E-03_JPRB, 0.37100306E-03_JPRB, 0.37100207E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099852E-03_JPRB, 0.37099680E-03_JPRB, 0.37099814E-03_JPRB, 0.37100021E-03_JPRB, 0.37100603E-03_JPRB, &
  & 0.37100469E-03_JPRB, 0.37100213E-03_JPRB, 0.37100370E-03_JPRB, 0.37100379E-03_JPRB, 0.37100248E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100440E-03_JPRB, 0.37100184E-03_JPRB, 0.37100300E-03_JPRB, 0.37100117E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099887E-03_JPRB, 0.37099799E-03_JPRB, 0.37100169E-03_JPRB, 0.37100364E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100233E-03_JPRB, 0.37100256E-03_JPRB, 0.37100090E-03_JPRB, 0.37100323E-03_JPRB, 0.37100440E-03_JPRB, &
  & 0.37100608E-03_JPRB, 0.37100588E-03_JPRB, 0.37100501E-03_JPRB, 0.37100195E-03_JPRB, 0.37099887E-03_JPRB, 0.37100303E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100169E-03_JPRB, 0.37099936E-03_JPRB, 0.37100227E-03_JPRB, 0.37100469E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099645E-03_JPRB, 0.37100067E-03_JPRB, 0.37099881E-03_JPRB, 0.37100297E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099893E-03_JPRB, 0.37099808E-03_JPRB, 0.37100122E-03_JPRB /)

RGHG1(:,84,10) = (/ &
  & 0.37100233E-03_JPRB, 0.37100256E-03_JPRB, 0.37100093E-03_JPRB, 0.37099689E-03_JPRB, 0.37099517E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100399E-03_JPRB, 0.37100221E-03_JPRB, 0.37100137E-03_JPRB, 0.37100294E-03_JPRB, 0.37100201E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099843E-03_JPRB, 0.37099683E-03_JPRB, 0.37099811E-03_JPRB, 0.37100023E-03_JPRB, 0.37100611E-03_JPRB, &
  & 0.37100483E-03_JPRB, 0.37100216E-03_JPRB, 0.37100381E-03_JPRB, 0.37100399E-03_JPRB, 0.37100259E-03_JPRB, 0.37100221E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100448E-03_JPRB, 0.37100186E-03_JPRB, 0.37100312E-03_JPRB, 0.37100114E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099881E-03_JPRB, 0.37099788E-03_JPRB, 0.37100169E-03_JPRB, 0.37100373E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100227E-03_JPRB, 0.37100253E-03_JPRB, 0.37100096E-03_JPRB, 0.37100323E-03_JPRB, 0.37100451E-03_JPRB, &
  & 0.37100632E-03_JPRB, 0.37100608E-03_JPRB, 0.37100515E-03_JPRB, 0.37100201E-03_JPRB, 0.37099878E-03_JPRB, 0.37100312E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100175E-03_JPRB, 0.37099930E-03_JPRB, 0.37100233E-03_JPRB, 0.37100483E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099529E-03_JPRB, 0.37099619E-03_JPRB, 0.37100058E-03_JPRB, 0.37099872E-03_JPRB, 0.37100306E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099887E-03_JPRB, 0.37099799E-03_JPRB, 0.37100120E-03_JPRB /)

RGHG1(:,85,10) = (/ &
  & 0.37100245E-03_JPRB, 0.37100265E-03_JPRB, 0.37100099E-03_JPRB, 0.37099686E-03_JPRB, 0.37099503E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100381E-03_JPRB, 0.37100224E-03_JPRB, 0.37100157E-03_JPRB, 0.37100262E-03_JPRB, 0.37100189E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099834E-03_JPRB, 0.37099706E-03_JPRB, 0.37099817E-03_JPRB, 0.37100023E-03_JPRB, 0.37100603E-03_JPRB, &
  & 0.37100498E-03_JPRB, 0.37100227E-03_JPRB, 0.37100390E-03_JPRB, 0.37100411E-03_JPRB, 0.37100271E-03_JPRB, 0.37100230E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100469E-03_JPRB, 0.37100192E-03_JPRB, 0.37100326E-03_JPRB, 0.37100117E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099875E-03_JPRB, 0.37099782E-03_JPRB, 0.37100175E-03_JPRB, 0.37100381E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100230E-03_JPRB, 0.37100253E-03_JPRB, 0.37100096E-03_JPRB, 0.37100323E-03_JPRB, 0.37100445E-03_JPRB, &
  & 0.37100661E-03_JPRB, 0.37100632E-03_JPRB, 0.37100530E-03_JPRB, 0.37100201E-03_JPRB, 0.37099869E-03_JPRB, 0.37100317E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100178E-03_JPRB, 0.37099927E-03_JPRB, 0.37100233E-03_JPRB, 0.37100495E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37099616E-03_JPRB, 0.37100067E-03_JPRB, 0.37099869E-03_JPRB, 0.37100309E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099834E-03_JPRB, 0.37099884E-03_JPRB, 0.37099794E-03_JPRB, 0.37100128E-03_JPRB /)

RGHG1(:,86,10) = (/ &
  & 0.37100245E-03_JPRB, 0.37100265E-03_JPRB, 0.37100102E-03_JPRB, 0.37099674E-03_JPRB, 0.37099520E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100242E-03_JPRB, 0.37100172E-03_JPRB, 0.37100221E-03_JPRB, 0.37100154E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099846E-03_JPRB, 0.37099750E-03_JPRB, 0.37099837E-03_JPRB, 0.37100035E-03_JPRB, 0.37100565E-03_JPRB, &
  & 0.37100492E-03_JPRB, 0.37100233E-03_JPRB, 0.37100399E-03_JPRB, 0.37100428E-03_JPRB, 0.37100271E-03_JPRB, 0.37100233E-03_JPRB, &
  & 0.37100297E-03_JPRB, 0.37100489E-03_JPRB, 0.37100184E-03_JPRB, 0.37100341E-03_JPRB, 0.37100117E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37099863E-03_JPRB, 0.37099770E-03_JPRB, 0.37100178E-03_JPRB, 0.37100390E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100239E-03_JPRB, 0.37100259E-03_JPRB, 0.37100088E-03_JPRB, 0.37100323E-03_JPRB, 0.37100457E-03_JPRB, &
  & 0.37100678E-03_JPRB, 0.37100649E-03_JPRB, 0.37100547E-03_JPRB, 0.37100210E-03_JPRB, 0.37099860E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100181E-03_JPRB, 0.37099922E-03_JPRB, 0.37100242E-03_JPRB, 0.37100515E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099497E-03_JPRB, 0.37099596E-03_JPRB, 0.37100061E-03_JPRB, 0.37099860E-03_JPRB, 0.37100315E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099875E-03_JPRB, 0.37099785E-03_JPRB, 0.37100131E-03_JPRB /)

RGHG1(:,87,10) = (/ &
  & 0.37100239E-03_JPRB, 0.37100262E-03_JPRB, 0.37100096E-03_JPRB, 0.37099657E-03_JPRB, 0.37099503E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100210E-03_JPRB, 0.37100169E-03_JPRB, 0.37100192E-03_JPRB, 0.37100137E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099863E-03_JPRB, 0.37099782E-03_JPRB, 0.37099860E-03_JPRB, 0.37100055E-03_JPRB, 0.37100527E-03_JPRB, &
  & 0.37100492E-03_JPRB, 0.37100245E-03_JPRB, 0.37100408E-03_JPRB, 0.37100431E-03_JPRB, 0.37100277E-03_JPRB, 0.37100233E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100515E-03_JPRB, 0.37100181E-03_JPRB, 0.37100358E-03_JPRB, 0.37100105E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099858E-03_JPRB, 0.37099759E-03_JPRB, 0.37100175E-03_JPRB, 0.37100396E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100250E-03_JPRB, 0.37100271E-03_JPRB, 0.37100070E-03_JPRB, 0.37100332E-03_JPRB, 0.37100463E-03_JPRB, &
  & 0.37100707E-03_JPRB, 0.37100658E-03_JPRB, 0.37100550E-03_JPRB, 0.37100201E-03_JPRB, 0.37099858E-03_JPRB, 0.37100329E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37100178E-03_JPRB, 0.37099919E-03_JPRB, 0.37100239E-03_JPRB, 0.37100518E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099581E-03_JPRB, 0.37100055E-03_JPRB, 0.37099849E-03_JPRB, 0.37100315E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099869E-03_JPRB, 0.37099770E-03_JPRB, 0.37100128E-03_JPRB /)

RGHG1(:,88,10) = (/ &
  & 0.37100230E-03_JPRB, 0.37100265E-03_JPRB, 0.37100096E-03_JPRB, 0.37099668E-03_JPRB, 0.37099555E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100236E-03_JPRB, 0.37100178E-03_JPRB, 0.37100189E-03_JPRB, 0.37100128E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099863E-03_JPRB, 0.37099794E-03_JPRB, 0.37099869E-03_JPRB, 0.37100055E-03_JPRB, 0.37100510E-03_JPRB, &
  & 0.37100486E-03_JPRB, 0.37100256E-03_JPRB, 0.37100413E-03_JPRB, 0.37100445E-03_JPRB, 0.37100280E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100300E-03_JPRB, 0.37100547E-03_JPRB, 0.37100172E-03_JPRB, 0.37100381E-03_JPRB, 0.37100099E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099852E-03_JPRB, 0.37099744E-03_JPRB, 0.37100184E-03_JPRB, 0.37100399E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100259E-03_JPRB, 0.37100274E-03_JPRB, 0.37100058E-03_JPRB, 0.37100341E-03_JPRB, 0.37100466E-03_JPRB, &
  & 0.37100722E-03_JPRB, 0.37100670E-03_JPRB, 0.37100559E-03_JPRB, 0.37100201E-03_JPRB, 0.37099858E-03_JPRB, 0.37100326E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100175E-03_JPRB, 0.37099916E-03_JPRB, 0.37100242E-03_JPRB, 0.37100527E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099578E-03_JPRB, 0.37100061E-03_JPRB, 0.37099843E-03_JPRB, 0.37100315E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099860E-03_JPRB, 0.37099764E-03_JPRB, 0.37100128E-03_JPRB /)

RGHG1(:,89,10) = (/ &
  & 0.37100227E-03_JPRB, 0.37100271E-03_JPRB, 0.37100105E-03_JPRB, 0.37099636E-03_JPRB, 0.37099462E-03_JPRB, 0.37100090E-03_JPRB, &
  & 0.37100312E-03_JPRB, 0.37100210E-03_JPRB, 0.37100166E-03_JPRB, 0.37100198E-03_JPRB, 0.37100143E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099852E-03_JPRB, 0.37099773E-03_JPRB, 0.37099855E-03_JPRB, 0.37100055E-03_JPRB, 0.37100550E-03_JPRB, &
  & 0.37100504E-03_JPRB, 0.37100248E-03_JPRB, 0.37100413E-03_JPRB, 0.37100448E-03_JPRB, 0.37100280E-03_JPRB, 0.37100236E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100571E-03_JPRB, 0.37100166E-03_JPRB, 0.37100399E-03_JPRB, 0.37100099E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099852E-03_JPRB, 0.37099732E-03_JPRB, 0.37100192E-03_JPRB, 0.37100419E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37100268E-03_JPRB, 0.37100280E-03_JPRB, 0.37100038E-03_JPRB, 0.37100349E-03_JPRB, 0.37100477E-03_JPRB, &
  & 0.37100742E-03_JPRB, 0.37100672E-03_JPRB, 0.37100565E-03_JPRB, 0.37100204E-03_JPRB, 0.37099852E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100172E-03_JPRB, 0.37099907E-03_JPRB, 0.37100242E-03_JPRB, 0.37100539E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099471E-03_JPRB, 0.37099575E-03_JPRB, 0.37100061E-03_JPRB, 0.37099834E-03_JPRB, 0.37100326E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099860E-03_JPRB, 0.37099753E-03_JPRB, 0.37100131E-03_JPRB /)

RGHG1(:,90,10) = (/ &
  & 0.37100230E-03_JPRB, 0.37100268E-03_JPRB, 0.37100122E-03_JPRB, 0.37099648E-03_JPRB, 0.37099447E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100390E-03_JPRB, 0.37100262E-03_JPRB, 0.37100175E-03_JPRB, 0.37100236E-03_JPRB, 0.37100166E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099828E-03_JPRB, 0.37099718E-03_JPRB, 0.37099820E-03_JPRB, 0.37100035E-03_JPRB, 0.37100626E-03_JPRB, &
  & 0.37100530E-03_JPRB, 0.37100239E-03_JPRB, 0.37100422E-03_JPRB, 0.37100454E-03_JPRB, 0.37100274E-03_JPRB, 0.37100233E-03_JPRB, &
  & 0.37100297E-03_JPRB, 0.37100597E-03_JPRB, 0.37100152E-03_JPRB, 0.37100425E-03_JPRB, 0.37100099E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099846E-03_JPRB, 0.37099703E-03_JPRB, 0.37100201E-03_JPRB, 0.37100448E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37100288E-03_JPRB, 0.37100297E-03_JPRB, 0.37100012E-03_JPRB, 0.37100361E-03_JPRB, 0.37100480E-03_JPRB, &
  & 0.37100757E-03_JPRB, 0.37100681E-03_JPRB, 0.37100571E-03_JPRB, 0.37100198E-03_JPRB, 0.37099828E-03_JPRB, 0.37100358E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37100184E-03_JPRB, 0.37099893E-03_JPRB, 0.37100248E-03_JPRB, 0.37100568E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099564E-03_JPRB, 0.37100085E-03_JPRB, 0.37099823E-03_JPRB, 0.37100352E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099860E-03_JPRB, 0.37099744E-03_JPRB, 0.37100137E-03_JPRB /)

RGHG1(:,91,10) = (/ &
  & 0.37100230E-03_JPRB, 0.37100277E-03_JPRB, 0.37100172E-03_JPRB, 0.37099625E-03_JPRB, 0.37099316E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100571E-03_JPRB, 0.37100250E-03_JPRB, 0.37100038E-03_JPRB, 0.37100413E-03_JPRB, 0.37100233E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37099732E-03_JPRB, 0.37099849E-03_JPRB, 0.37099575E-03_JPRB, 0.37099785E-03_JPRB, 0.37099968E-03_JPRB, 0.37100789E-03_JPRB, &
  & 0.37100547E-03_JPRB, 0.37100192E-03_JPRB, 0.37100434E-03_JPRB, 0.37100472E-03_JPRB, 0.37100274E-03_JPRB, 0.37100227E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100646E-03_JPRB, 0.37100105E-03_JPRB, 0.37100466E-03_JPRB, 0.37100085E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100006E-03_JPRB, 0.37099855E-03_JPRB, 0.37099645E-03_JPRB, 0.37100236E-03_JPRB, 0.37100507E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37100326E-03_JPRB, 0.37100312E-03_JPRB, 0.37099971E-03_JPRB, 0.37100379E-03_JPRB, 0.37100466E-03_JPRB, &
  & 0.37100780E-03_JPRB, 0.37100678E-03_JPRB, 0.37100588E-03_JPRB, 0.37100192E-03_JPRB, 0.37099767E-03_JPRB, 0.37100416E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37100218E-03_JPRB, 0.37099846E-03_JPRB, 0.37100250E-03_JPRB, 0.37100626E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099537E-03_JPRB, 0.37100134E-03_JPRB, 0.37099773E-03_JPRB, 0.37100419E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099863E-03_JPRB, 0.37099735E-03_JPRB, 0.37100146E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG1(:, 1,11) = (/ &
  & 0.36435653E-03_JPRB, 0.36427044E-03_JPRB, 0.36398496E-03_JPRB, 0.36370117E-03_JPRB, 0.36342299E-03_JPRB, 0.36314843E-03_JPRB, &
  & 0.36285221E-03_JPRB, 0.36251175E-03_JPRB, 0.36219903E-03_JPRB, 0.36191932E-03_JPRB, 0.36166384E-03_JPRB, 0.36144574E-03_JPRB, &
  & 0.36128037E-03_JPRB, 0.36117519E-03_JPRB, 0.36113436E-03_JPRB, 0.36115671E-03_JPRB, 0.36122632E-03_JPRB, 0.36132161E-03_JPRB, &
  & 0.36141998E-03_JPRB, 0.36150371E-03_JPRB, 0.36156157E-03_JPRB, 0.36159181E-03_JPRB, 0.36159836E-03_JPRB, 0.36158771E-03_JPRB, &
  & 0.36156602E-03_JPRB, 0.36153727E-03_JPRB, 0.36150357E-03_JPRB, 0.36146169E-03_JPRB, 0.36141666E-03_JPRB, 0.36136867E-03_JPRB, &
  & 0.36131739E-03_JPRB, 0.36126198E-03_JPRB, 0.36120249E-03_JPRB, 0.36113960E-03_JPRB, 0.36107775E-03_JPRB, 0.36102004E-03_JPRB, &
  & 0.36096940E-03_JPRB, 0.36092752E-03_JPRB, 0.36089303E-03_JPRB, 0.36086363E-03_JPRB, 0.36083476E-03_JPRB, 0.36080068E-03_JPRB, &
  & 0.36075653E-03_JPRB, 0.36069652E-03_JPRB, 0.36061599E-03_JPRB, 0.36050894E-03_JPRB, 0.36036759E-03_JPRB, 0.36018383E-03_JPRB, &
  & 0.35995332E-03_JPRB, 0.35968272E-03_JPRB, 0.35939354E-03_JPRB, 0.35911967E-03_JPRB, 0.35889543E-03_JPRB, 0.35874237E-03_JPRB, &
  & 0.35865977E-03_JPRB, 0.35862857E-03_JPRB, 0.35862520E-03_JPRB, 0.35863195E-03_JPRB, 0.35864214E-03_JPRB, 0.35865384E-03_JPRB, &
  & 0.35866734E-03_JPRB, 0.35867860E-03_JPRB, 0.35869016E-03_JPRB, 0.35869781E-03_JPRB /)

RGHG1(:, 2,11) = (/ &
  & 0.36478226E-03_JPRB, 0.36467580E-03_JPRB, 0.36448459E-03_JPRB, 0.36435545E-03_JPRB, 0.36422253E-03_JPRB, 0.36409262E-03_JPRB, &
  & 0.36396025E-03_JPRB, 0.36382975E-03_JPRB, 0.36371386E-03_JPRB, 0.36361095E-03_JPRB, 0.36353091E-03_JPRB, 0.36348106E-03_JPRB, &
  & 0.36347337E-03_JPRB, 0.36351668E-03_JPRB, 0.36360911E-03_JPRB, 0.36373659E-03_JPRB, 0.36387349E-03_JPRB, 0.36399733E-03_JPRB, &
  & 0.36409305E-03_JPRB, 0.36415330E-03_JPRB, 0.36417693E-03_JPRB, 0.36416849E-03_JPRB, 0.36413508E-03_JPRB, 0.36408385E-03_JPRB, &
  & 0.36402087E-03_JPRB, 0.36394966E-03_JPRB, 0.36387111E-03_JPRB, 0.36378534E-03_JPRB, 0.36369485E-03_JPRB, 0.36360111E-03_JPRB, &
  & 0.36350248E-03_JPRB, 0.36339724E-03_JPRB, 0.36328551E-03_JPRB, 0.36317154E-03_JPRB, 0.36306141E-03_JPRB, 0.36296181E-03_JPRB, &
  & 0.36287753E-03_JPRB, 0.36280951E-03_JPRB, 0.36275230E-03_JPRB, 0.36269685E-03_JPRB, 0.36263210E-03_JPRB, 0.36255002E-03_JPRB, &
  & 0.36244642E-03_JPRB, 0.36232179E-03_JPRB, 0.36217947E-03_JPRB, 0.36202453E-03_JPRB, 0.36186300E-03_JPRB, 0.36169929E-03_JPRB, &
  & 0.36152941E-03_JPRB, 0.36133418E-03_JPRB, 0.36108639E-03_JPRB, 0.36077501E-03_JPRB, 0.36042448E-03_JPRB, 0.36008298E-03_JPRB, &
  & 0.35979177E-03_JPRB, 0.35957061E-03_JPRB, 0.35942084E-03_JPRB, 0.35933577E-03_JPRB, 0.35929770E-03_JPRB, 0.35928824E-03_JPRB, &
  & 0.35929578E-03_JPRB, 0.35930637E-03_JPRB, 0.35933181E-03_JPRB, 0.35935990E-03_JPRB /)

RGHG1(:, 3,11) = (/ &
  & 0.36493377E-03_JPRB, 0.36480516E-03_JPRB, 0.36472146E-03_JPRB, 0.36465685E-03_JPRB, 0.36460627E-03_JPRB, 0.36456177E-03_JPRB, &
  & 0.36452481E-03_JPRB, 0.36449661E-03_JPRB, 0.36447958E-03_JPRB, 0.36447469E-03_JPRB, 0.36448397E-03_JPRB, 0.36451247E-03_JPRB, &
  & 0.36456811E-03_JPRB, 0.36465144E-03_JPRB, 0.36475362E-03_JPRB, 0.36486163E-03_JPRB, 0.36496235E-03_JPRB, 0.36504696E-03_JPRB, &
  & 0.36511177E-03_JPRB, 0.36515482E-03_JPRB, 0.36517633E-03_JPRB, 0.36517874E-03_JPRB, 0.36516521E-03_JPRB, 0.36513945E-03_JPRB, &
  & 0.36510488E-03_JPRB, 0.36506311E-03_JPRB, 0.36501556E-03_JPRB, 0.36496154E-03_JPRB, 0.36490243E-03_JPRB, 0.36483846E-03_JPRB, &
  & 0.36476812E-03_JPRB, 0.36468927E-03_JPRB, 0.36459995E-03_JPRB, 0.36450132E-03_JPRB, 0.36439797E-03_JPRB, 0.36429468E-03_JPRB, &
  & 0.36419439E-03_JPRB, 0.36409619E-03_JPRB, 0.36399701E-03_JPRB, 0.36389235E-03_JPRB, 0.36377818E-03_JPRB, 0.36364968E-03_JPRB, &
  & 0.36350533E-03_JPRB, 0.36334398E-03_JPRB, 0.36316481E-03_JPRB, 0.36296717E-03_JPRB, 0.36274889E-03_JPRB, 0.36250253E-03_JPRB, &
  & 0.36221795E-03_JPRB, 0.36189568E-03_JPRB, 0.36155654E-03_JPRB, 0.36122615E-03_JPRB, 0.36091256E-03_JPRB, 0.36061759E-03_JPRB, &
  & 0.36035993E-03_JPRB, 0.36016485E-03_JPRB, 0.36004226E-03_JPRB, 0.35998126E-03_JPRB, 0.35997102E-03_JPRB, 0.36000067E-03_JPRB, &
  & 0.36006153E-03_JPRB, 0.36013013E-03_JPRB, 0.36023004E-03_JPRB, 0.36036863E-03_JPRB /)

RGHG1(:, 4,11) = (/ &
  & 0.36505039E-03_JPRB, 0.36494891E-03_JPRB, 0.36490563E-03_JPRB, 0.36487769E-03_JPRB, 0.36486215E-03_JPRB, 0.36485650E-03_JPRB, &
  & 0.36485726E-03_JPRB, 0.36486363E-03_JPRB, 0.36487711E-03_JPRB, 0.36490214E-03_JPRB, 0.36493971E-03_JPRB, 0.36499271E-03_JPRB, &
  & 0.36505985E-03_JPRB, 0.36513770E-03_JPRB, 0.36522010E-03_JPRB, 0.36529999E-03_JPRB, 0.36537208E-03_JPRB, 0.36543456E-03_JPRB, &
  & 0.36548506E-03_JPRB, 0.36552263E-03_JPRB, 0.36554597E-03_JPRB, 0.36555555E-03_JPRB, 0.36555255E-03_JPRB, 0.36553881E-03_JPRB, &
  & 0.36551687E-03_JPRB, 0.36548823E-03_JPRB, 0.36545366E-03_JPRB, 0.36541364E-03_JPRB, 0.36536765E-03_JPRB, 0.36531530E-03_JPRB, &
  & 0.36525528E-03_JPRB, 0.36518532E-03_JPRB, 0.36510345E-03_JPRB, 0.36500933E-03_JPRB, 0.36490388E-03_JPRB, 0.36478962E-03_JPRB, &
  & 0.36466843E-03_JPRB, 0.36454201E-03_JPRB, 0.36440976E-03_JPRB, 0.36427134E-03_JPRB, 0.36412623E-03_JPRB, 0.36397664E-03_JPRB, &
  & 0.36382402E-03_JPRB, 0.36366720E-03_JPRB, 0.36350338E-03_JPRB, 0.36332777E-03_JPRB, 0.36313350E-03_JPRB, 0.36291365E-03_JPRB, &
  & 0.36266624E-03_JPRB, 0.36239438E-03_JPRB, 0.36209618E-03_JPRB, 0.36176617E-03_JPRB, 0.36141754E-03_JPRB, 0.36108610E-03_JPRB, &
  & 0.36080796E-03_JPRB, 0.36061267E-03_JPRB, 0.36051843E-03_JPRB, 0.36053167E-03_JPRB, 0.36063147E-03_JPRB, 0.36078741E-03_JPRB, &
  & 0.36097266E-03_JPRB, 0.36116011E-03_JPRB, 0.36137784E-03_JPRB, 0.36167249E-03_JPRB /)

RGHG1(:, 5,11) = (/ &
  & 0.36516369E-03_JPRB, 0.36510534E-03_JPRB, 0.36508346E-03_JPRB, 0.36507624E-03_JPRB, 0.36507632E-03_JPRB, 0.36508258E-03_JPRB, &
  & 0.36509635E-03_JPRB, 0.36511719E-03_JPRB, 0.36514443E-03_JPRB, 0.36517830E-03_JPRB, 0.36522219E-03_JPRB, 0.36527577E-03_JPRB, &
  & 0.36533817E-03_JPRB, 0.36540462E-03_JPRB, 0.36547080E-03_JPRB, 0.36553509E-03_JPRB, 0.36559493E-03_JPRB, 0.36564886E-03_JPRB, &
  & 0.36569525E-03_JPRB, 0.36573291E-03_JPRB, 0.36576093E-03_JPRB, 0.36577848E-03_JPRB, 0.36578532E-03_JPRB, 0.36578192E-03_JPRB, &
  & 0.36576981E-03_JPRB, 0.36575110E-03_JPRB, 0.36572863E-03_JPRB, 0.36570345E-03_JPRB, 0.36567589E-03_JPRB, 0.36564501E-03_JPRB, &
  & 0.36560919E-03_JPRB, 0.36556704E-03_JPRB, 0.36551760E-03_JPRB, 0.36546195E-03_JPRB, 0.36540450E-03_JPRB, 0.36535115E-03_JPRB, &
  & 0.36530645E-03_JPRB, 0.36526794E-03_JPRB, 0.36522243E-03_JPRB, 0.36514929E-03_JPRB, 0.36503040E-03_JPRB, 0.36486023E-03_JPRB, &
  & 0.36464591E-03_JPRB, 0.36440062E-03_JPRB, 0.36413668E-03_JPRB, 0.36386598E-03_JPRB, 0.36359817E-03_JPRB, 0.36333481E-03_JPRB, &
  & 0.36306903E-03_JPRB, 0.36279071E-03_JPRB, 0.36249339E-03_JPRB, 0.36218076E-03_JPRB, 0.36186227E-03_JPRB, 0.36155121E-03_JPRB, &
  & 0.36128002E-03_JPRB, 0.36109993E-03_JPRB, 0.36105802E-03_JPRB, 0.36116299E-03_JPRB, 0.36138040E-03_JPRB, 0.36164897E-03_JPRB, &
  & 0.36191984E-03_JPRB, 0.36217051E-03_JPRB, 0.36241327E-03_JPRB, 0.36275599E-03_JPRB /)

RGHG1(:, 6,11) = (/ &
  & 0.36528011E-03_JPRB, 0.36525249E-03_JPRB, 0.36524911E-03_JPRB, 0.36525406E-03_JPRB, 0.36526500E-03_JPRB, 0.36528034E-03_JPRB, &
  & 0.36529842E-03_JPRB, 0.36532036E-03_JPRB, 0.36534894E-03_JPRB, 0.36538579E-03_JPRB, 0.36542979E-03_JPRB, 0.36548058E-03_JPRB, &
  & 0.36553631E-03_JPRB, 0.36559440E-03_JPRB, 0.36565281E-03_JPRB, 0.36571041E-03_JPRB, 0.36576643E-03_JPRB, 0.36582048E-03_JPRB, &
  & 0.36587019E-03_JPRB, 0.36591387E-03_JPRB, 0.36595055E-03_JPRB, 0.36598058E-03_JPRB, 0.36600392E-03_JPRB, 0.36602153E-03_JPRB, &
  & 0.36603407E-03_JPRB, 0.36604246E-03_JPRB, 0.36604848E-03_JPRB, 0.36605334E-03_JPRB, 0.36605840E-03_JPRB, 0.36606457E-03_JPRB, &
  & 0.36607168E-03_JPRB, 0.36607886E-03_JPRB, 0.36608474E-03_JPRB, 0.36608861E-03_JPRB, 0.36609013E-03_JPRB, 0.36608914E-03_JPRB, &
  & 0.36608378E-03_JPRB, 0.36606833E-03_JPRB, 0.36603186E-03_JPRB, 0.36596091E-03_JPRB, 0.36584801E-03_JPRB, 0.36569510E-03_JPRB, &
  & 0.36551437E-03_JPRB, 0.36531501E-03_JPRB, 0.36510263E-03_JPRB, 0.36487397E-03_JPRB, 0.36462012E-03_JPRB, 0.36433415E-03_JPRB, &
  & 0.36401718E-03_JPRB, 0.36367541E-03_JPRB, 0.36331639E-03_JPRB, 0.36294950E-03_JPRB, 0.36258833E-03_JPRB, 0.36225928E-03_JPRB, &
  & 0.36200052E-03_JPRB, 0.36186015E-03_JPRB, 0.36187575E-03_JPRB, 0.36203992E-03_JPRB, 0.36229059E-03_JPRB, 0.36255800E-03_JPRB, &
  & 0.36280663E-03_JPRB, 0.36302739E-03_JPRB, 0.36324761E-03_JPRB, 0.36354008E-03_JPRB /)

RGHG1(:, 7,11) = (/ &
  & 0.36539836E-03_JPRB, 0.36539263E-03_JPRB, 0.36539917E-03_JPRB, 0.36541119E-03_JPRB, 0.36542636E-03_JPRB, 0.36544434E-03_JPRB, &
  & 0.36546635E-03_JPRB, 0.36549222E-03_JPRB, 0.36552234E-03_JPRB, 0.36555677E-03_JPRB, 0.36559638E-03_JPRB, 0.36564059E-03_JPRB, &
  & 0.36568847E-03_JPRB, 0.36574050E-03_JPRB, 0.36579571E-03_JPRB, 0.36585244E-03_JPRB, 0.36590867E-03_JPRB, 0.36596414E-03_JPRB, &
  & 0.36601900E-03_JPRB, 0.36607255E-03_JPRB, 0.36612386E-03_JPRB, 0.36617223E-03_JPRB, 0.36621687E-03_JPRB, 0.36625739E-03_JPRB, &
  & 0.36629415E-03_JPRB, 0.36632770E-03_JPRB, 0.36635951E-03_JPRB, 0.36639156E-03_JPRB, 0.36642532E-03_JPRB, 0.36646190E-03_JPRB, &
  & 0.36650052E-03_JPRB, 0.36653876E-03_JPRB, 0.36657360E-03_JPRB, 0.36660171E-03_JPRB, 0.36662121E-03_JPRB, 0.36663222E-03_JPRB, &
  & 0.36663294E-03_JPRB, 0.36661790E-03_JPRB, 0.36657820E-03_JPRB, 0.36650439E-03_JPRB, 0.36639211E-03_JPRB, 0.36625157E-03_JPRB, &
  & 0.36609429E-03_JPRB, 0.36593108E-03_JPRB, 0.36576297E-03_JPRB, 0.36558826E-03_JPRB, 0.36540435E-03_JPRB, 0.36520738E-03_JPRB, &
  & 0.36498829E-03_JPRB, 0.36473616E-03_JPRB, 0.36444748E-03_JPRB, 0.36412867E-03_JPRB, 0.36380041E-03_JPRB, 0.36349759E-03_JPRB, &
  & 0.36326770E-03_JPRB, 0.36315250E-03_JPRB, 0.36316545E-03_JPRB, 0.36327759E-03_JPRB, 0.36343999E-03_JPRB, 0.36361211E-03_JPRB, &
  & 0.36376936E-03_JPRB, 0.36390987E-03_JPRB, 0.36404139E-03_JPRB, 0.36424180E-03_JPRB /)

RGHG1(:, 8,11) = (/ &
  & 0.36551207E-03_JPRB, 0.36551704E-03_JPRB, 0.36552947E-03_JPRB, 0.36554600E-03_JPRB, 0.36556547E-03_JPRB, 0.36558718E-03_JPRB, &
  & 0.36561026E-03_JPRB, 0.36563550E-03_JPRB, 0.36566370E-03_JPRB, 0.36569644E-03_JPRB, 0.36573398E-03_JPRB, 0.36577549E-03_JPRB, &
  & 0.36582001E-03_JPRB, 0.36586745E-03_JPRB, 0.36591856E-03_JPRB, 0.36597508E-03_JPRB, 0.36603582E-03_JPRB, 0.36609810E-03_JPRB, &
  & 0.36615983E-03_JPRB, 0.36622037E-03_JPRB, 0.36628015E-03_JPRB, 0.36633978E-03_JPRB, 0.36639924E-03_JPRB, 0.36645832E-03_JPRB, &
  & 0.36651688E-03_JPRB, 0.36657424E-03_JPRB, 0.36663067E-03_JPRB, 0.36668713E-03_JPRB, 0.36674400E-03_JPRB, 0.36680137E-03_JPRB, &
  & 0.36685853E-03_JPRB, 0.36691304E-03_JPRB, 0.36696307E-03_JPRB, 0.36700594E-03_JPRB, 0.36703676E-03_JPRB, 0.36705253E-03_JPRB, &
  & 0.36705111E-03_JPRB, 0.36702977E-03_JPRB, 0.36698219E-03_JPRB, 0.36690145E-03_JPRB, 0.36678984E-03_JPRB, 0.36665794E-03_JPRB, &
  & 0.36652508E-03_JPRB, 0.36639808E-03_JPRB, 0.36627863E-03_JPRB, 0.36616309E-03_JPRB, 0.36604446E-03_JPRB, 0.36591414E-03_JPRB, &
  & 0.36576661E-03_JPRB, 0.36559944E-03_JPRB, 0.36540904E-03_JPRB, 0.36519626E-03_JPRB, 0.36497205E-03_JPRB, 0.36475930E-03_JPRB, &
  & 0.36458566E-03_JPRB, 0.36447425E-03_JPRB, 0.36443057E-03_JPRB, 0.36444265E-03_JPRB, 0.36448950E-03_JPRB, 0.36455222E-03_JPRB, &
  & 0.36461707E-03_JPRB, 0.36467938E-03_JPRB, 0.36473988E-03_JPRB, 0.36482513E-03_JPRB /)

RGHG1(:, 9,11) = (/ &
  & 0.36562013E-03_JPRB, 0.36563168E-03_JPRB, 0.36564859E-03_JPRB, 0.36566757E-03_JPRB, 0.36568841E-03_JPRB, 0.36571044E-03_JPRB, &
  & 0.36573430E-03_JPRB, 0.36576000E-03_JPRB, 0.36578806E-03_JPRB, 0.36581847E-03_JPRB, 0.36585249E-03_JPRB, 0.36589045E-03_JPRB, &
  & 0.36593305E-03_JPRB, 0.36598041E-03_JPRB, 0.36603099E-03_JPRB, 0.36608445E-03_JPRB, 0.36614205E-03_JPRB, 0.36620497E-03_JPRB, &
  & 0.36627188E-03_JPRB, 0.36634089E-03_JPRB, 0.36641097E-03_JPRB, 0.36648204E-03_JPRB, 0.36655372E-03_JPRB, 0.36662538E-03_JPRB, &
  & 0.36669709E-03_JPRB, 0.36676778E-03_JPRB, 0.36683842E-03_JPRB, 0.36690856E-03_JPRB, 0.36697937E-03_JPRB, 0.36705061E-03_JPRB, &
  & 0.36712209E-03_JPRB, 0.36719159E-03_JPRB, 0.36725422E-03_JPRB, 0.36730536E-03_JPRB, 0.36734177E-03_JPRB, 0.36736048E-03_JPRB, &
  & 0.36735952E-03_JPRB, 0.36733781E-03_JPRB, 0.36729107E-03_JPRB, 0.36721598E-03_JPRB, 0.36711141E-03_JPRB, 0.36698979E-03_JPRB, &
  & 0.36686505E-03_JPRB, 0.36675038E-03_JPRB, 0.36664680E-03_JPRB, 0.36655040E-03_JPRB, 0.36645550E-03_JPRB, 0.36635846E-03_JPRB, &
  & 0.36625459E-03_JPRB, 0.36613643E-03_JPRB, 0.36600069E-03_JPRB, 0.36584982E-03_JPRB, 0.36568844E-03_JPRB, 0.36552790E-03_JPRB, &
  & 0.36538596E-03_JPRB, 0.36527732E-03_JPRB, 0.36520883E-03_JPRB, 0.36517743E-03_JPRB, 0.36517359E-03_JPRB, 0.36518610E-03_JPRB, &
  & 0.36520697E-03_JPRB, 0.36522871E-03_JPRB, 0.36525755E-03_JPRB, 0.36529996E-03_JPRB /)

RGHG1(:,10,11) = (/ &
  & 0.36573363E-03_JPRB, 0.36574889E-03_JPRB, 0.36576681E-03_JPRB, 0.36578745E-03_JPRB, 0.36581038E-03_JPRB, 0.36583559E-03_JPRB, &
  & 0.36586262E-03_JPRB, 0.36589120E-03_JPRB, 0.36592159E-03_JPRB, 0.36595439E-03_JPRB, 0.36599027E-03_JPRB, 0.36603009E-03_JPRB, &
  & 0.36607395E-03_JPRB, 0.36612325E-03_JPRB, 0.36617985E-03_JPRB, 0.36624243E-03_JPRB, 0.36630844E-03_JPRB, 0.36637706E-03_JPRB, &
  & 0.36644813E-03_JPRB, 0.36652185E-03_JPRB, 0.36659648E-03_JPRB, 0.36667252E-03_JPRB, 0.36674921E-03_JPRB, 0.36682666E-03_JPRB, &
  & 0.36690311E-03_JPRB, 0.36697893E-03_JPRB, 0.36705390E-03_JPRB, 0.36712835E-03_JPRB, 0.36720387E-03_JPRB, 0.36728045E-03_JPRB, &
  & 0.36735769E-03_JPRB, 0.36743400E-03_JPRB, 0.36750609E-03_JPRB, 0.36756616E-03_JPRB, 0.36760859E-03_JPRB, 0.36763129E-03_JPRB, &
  & 0.36763379E-03_JPRB, 0.36761627E-03_JPRB, 0.36757885E-03_JPRB, 0.36751831E-03_JPRB, 0.36743298E-03_JPRB, 0.36732657E-03_JPRB, &
  & 0.36721467E-03_JPRB, 0.36710640E-03_JPRB, 0.36700646E-03_JPRB, 0.36691158E-03_JPRB, 0.36681868E-03_JPRB, 0.36672305E-03_JPRB, &
  & 0.36661947E-03_JPRB, 0.36650582E-03_JPRB, 0.36638160E-03_JPRB, 0.36624537E-03_JPRB, 0.36610314E-03_JPRB, 0.36596731E-03_JPRB, &
  & 0.36585063E-03_JPRB, 0.36576175E-03_JPRB, 0.36570273E-03_JPRB, 0.36566888E-03_JPRB, 0.36565290E-03_JPRB, 0.36564836E-03_JPRB, &
  & 0.36564987E-03_JPRB, 0.36565453E-03_JPRB, 0.36565901E-03_JPRB, 0.36566821E-03_JPRB /)

RGHG1(:,11,11) = (/ &
  & 0.36586233E-03_JPRB, 0.36588003E-03_JPRB, 0.36590069E-03_JPRB, 0.36592409E-03_JPRB, 0.36595055E-03_JPRB, 0.36597985E-03_JPRB, &
  & 0.36601169E-03_JPRB, 0.36604586E-03_JPRB, 0.36608207E-03_JPRB, 0.36612008E-03_JPRB, 0.36616041E-03_JPRB, 0.36620430E-03_JPRB, &
  & 0.36625372E-03_JPRB, 0.36630899E-03_JPRB, 0.36637101E-03_JPRB, 0.36644237E-03_JPRB, 0.36652200E-03_JPRB, 0.36660759E-03_JPRB, &
  & 0.36669671E-03_JPRB, 0.36678818E-03_JPRB, 0.36687934E-03_JPRB, 0.36696924E-03_JPRB, 0.36705620E-03_JPRB, 0.36714066E-03_JPRB, &
  & 0.36721799E-03_JPRB, 0.36729034E-03_JPRB, 0.36735699E-03_JPRB, 0.36742032E-03_JPRB, 0.36748298E-03_JPRB, 0.36754666E-03_JPRB, &
  & 0.36761360E-03_JPRB, 0.36768246E-03_JPRB, 0.36775076E-03_JPRB, 0.36781287E-03_JPRB, 0.36786104E-03_JPRB, 0.36789017E-03_JPRB, &
  & 0.36789969E-03_JPRB, 0.36789218E-03_JPRB, 0.36786991E-03_JPRB, 0.36783225E-03_JPRB, 0.36777646E-03_JPRB, 0.36770213E-03_JPRB, &
  & 0.36761267E-03_JPRB, 0.36751671E-03_JPRB, 0.36741927E-03_JPRB, 0.36732276E-03_JPRB, 0.36722486E-03_JPRB, 0.36712299E-03_JPRB, &
  & 0.36701362E-03_JPRB, 0.36689511E-03_JPRB, 0.36676636E-03_JPRB, 0.36663140E-03_JPRB, 0.36649624E-03_JPRB, 0.36637037E-03_JPRB, &
  & 0.36626167E-03_JPRB, 0.36617555E-03_JPRB, 0.36611190E-03_JPRB, 0.36606748E-03_JPRB, 0.36603815E-03_JPRB, 0.36601984E-03_JPRB, &
  & 0.36600867E-03_JPRB, 0.36600319E-03_JPRB, 0.36599897E-03_JPRB, 0.36599656E-03_JPRB /)

RGHG1(:,12,11) = (/ &
  & 0.36603090E-03_JPRB, 0.36604755E-03_JPRB, 0.36607016E-03_JPRB, 0.36609804E-03_JPRB, 0.36613093E-03_JPRB, 0.36616914E-03_JPRB, &
  & 0.36621204E-03_JPRB, 0.36625919E-03_JPRB, 0.36630992E-03_JPRB, 0.36636414E-03_JPRB, 0.36642165E-03_JPRB, 0.36648251E-03_JPRB, &
  & 0.36654779E-03_JPRB, 0.36662037E-03_JPRB, 0.36670148E-03_JPRB, 0.36679127E-03_JPRB, 0.36688999E-03_JPRB, 0.36699494E-03_JPRB, &
  & 0.36710303E-03_JPRB, 0.36721100E-03_JPRB, 0.36731604E-03_JPRB, 0.36741342E-03_JPRB, 0.36750379E-03_JPRB, 0.36758484E-03_JPRB, &
  & 0.36765283E-03_JPRB, 0.36771013E-03_JPRB, 0.36775632E-03_JPRB, 0.36779491E-03_JPRB, 0.36783083E-03_JPRB, 0.36786869E-03_JPRB, &
  & 0.36791275E-03_JPRB, 0.36796535E-03_JPRB, 0.36802341E-03_JPRB, 0.36808132E-03_JPRB, 0.36812772E-03_JPRB, 0.36815667E-03_JPRB, &
  & 0.36817120E-03_JPRB, 0.36817422E-03_JPRB, 0.36816573E-03_JPRB, 0.36814614E-03_JPRB, 0.36811575E-03_JPRB, 0.36807146E-03_JPRB, &
  & 0.36801098E-03_JPRB, 0.36793441E-03_JPRB, 0.36784553E-03_JPRB, 0.36774838E-03_JPRB, 0.36764424E-03_JPRB, 0.36753278E-03_JPRB, &
  & 0.36741295E-03_JPRB, 0.36728405E-03_JPRB, 0.36714756E-03_JPRB, 0.36700608E-03_JPRB, 0.36686668E-03_JPRB, 0.36673679E-03_JPRB, &
  & 0.36662395E-03_JPRB, 0.36653157E-03_JPRB, 0.36645966E-03_JPRB, 0.36640564E-03_JPRB, 0.36636650E-03_JPRB, 0.36633888E-03_JPRB, &
  & 0.36632089E-03_JPRB, 0.36630657E-03_JPRB, 0.36629743E-03_JPRB, 0.36628003E-03_JPRB /)

RGHG1(:,13,11) = (/ &
  & 0.36625957E-03_JPRB, 0.36628346E-03_JPRB, 0.36631367E-03_JPRB, 0.36634968E-03_JPRB, 0.36639217E-03_JPRB, 0.36644135E-03_JPRB, &
  & 0.36649706E-03_JPRB, 0.36655832E-03_JPRB, 0.36662415E-03_JPRB, 0.36669377E-03_JPRB, 0.36676717E-03_JPRB, 0.36684485E-03_JPRB, &
  & 0.36692762E-03_JPRB, 0.36701662E-03_JPRB, 0.36711484E-03_JPRB, 0.36722299E-03_JPRB, 0.36734020E-03_JPRB, 0.36746322E-03_JPRB, &
  & 0.36758755E-03_JPRB, 0.36770874E-03_JPRB, 0.36782236E-03_JPRB, 0.36792259E-03_JPRB, 0.36800836E-03_JPRB, 0.36807940E-03_JPRB, &
  & 0.36813156E-03_JPRB, 0.36816692E-03_JPRB, 0.36818752E-03_JPRB, 0.36819774E-03_JPRB, 0.36820420E-03_JPRB, 0.36821252E-03_JPRB, &
  & 0.36822987E-03_JPRB, 0.36825889E-03_JPRB, 0.36830021E-03_JPRB, 0.36834306E-03_JPRB, 0.36838383E-03_JPRB, 0.36841776E-03_JPRB, &
  & 0.36844035E-03_JPRB, 0.36845120E-03_JPRB, 0.36845336E-03_JPRB, 0.36844786E-03_JPRB, 0.36843307E-03_JPRB, 0.36840641E-03_JPRB, &
  & 0.36836442E-03_JPRB, 0.36830496E-03_JPRB, 0.36822850E-03_JPRB, 0.36813735E-03_JPRB, 0.36803389E-03_JPRB, 0.36791957E-03_JPRB, &
  & 0.36779483E-03_JPRB, 0.36766112E-03_JPRB, 0.36752009E-03_JPRB, 0.36737605E-03_JPRB, 0.36723432E-03_JPRB, 0.36710280E-03_JPRB, &
  & 0.36698673E-03_JPRB, 0.36688981E-03_JPRB, 0.36681214E-03_JPRB, 0.36675160E-03_JPRB, 0.36670564E-03_JPRB, 0.36667188E-03_JPRB, &
  & 0.36664680E-03_JPRB, 0.36663000E-03_JPRB, 0.36661202E-03_JPRB, 0.36659307E-03_JPRB /)

RGHG1(:,14,11) = (/ &
  & 0.36651391E-03_JPRB, 0.36655040E-03_JPRB, 0.36658946E-03_JPRB, 0.36663542E-03_JPRB, 0.36668923E-03_JPRB, 0.36675174E-03_JPRB, &
  & 0.36682302E-03_JPRB, 0.36690192E-03_JPRB, 0.36698685E-03_JPRB, 0.36707590E-03_JPRB, 0.36716758E-03_JPRB, 0.36726147E-03_JPRB, &
  & 0.36735926E-03_JPRB, 0.36746249E-03_JPRB, 0.36757358E-03_JPRB, 0.36769407E-03_JPRB, 0.36782245E-03_JPRB, 0.36795525E-03_JPRB, &
  & 0.36808680E-03_JPRB, 0.36821212E-03_JPRB, 0.36832641E-03_JPRB, 0.36842300E-03_JPRB, 0.36849937E-03_JPRB, 0.36855577E-03_JPRB, &
  & 0.36859012E-03_JPRB, 0.36860356E-03_JPRB, 0.36859961E-03_JPRB, 0.36858290E-03_JPRB, 0.36856107E-03_JPRB, 0.36854332E-03_JPRB, &
  & 0.36853546E-03_JPRB, 0.36854332E-03_JPRB, 0.36856424E-03_JPRB, 0.36860124E-03_JPRB, 0.36864402E-03_JPRB, 0.36868104E-03_JPRB, &
  & 0.36870845E-03_JPRB, 0.36872659E-03_JPRB, 0.36873584E-03_JPRB, 0.36873668E-03_JPRB, 0.36872827E-03_JPRB, 0.36870915E-03_JPRB, &
  & 0.36867693E-03_JPRB, 0.36862926E-03_JPRB, 0.36856535E-03_JPRB, 0.36848651E-03_JPRB, 0.36839361E-03_JPRB, 0.36828750E-03_JPRB, &
  & 0.36816992E-03_JPRB, 0.36804235E-03_JPRB, 0.36790760E-03_JPRB, 0.36776927E-03_JPRB, 0.36763295E-03_JPRB, 0.36750417E-03_JPRB, &
  & 0.36738790E-03_JPRB, 0.36728714E-03_JPRB, 0.36720283E-03_JPRB, 0.36713402E-03_JPRB, 0.36707922E-03_JPRB, 0.36703688E-03_JPRB, &
  & 0.36700506E-03_JPRB, 0.36698006E-03_JPRB, 0.36695891E-03_JPRB, 0.36692535E-03_JPRB /)

RGHG1(:,15,11) = (/ &
  & 0.36678562E-03_JPRB, 0.36683751E-03_JPRB, 0.36688781E-03_JPRB, 0.36694476E-03_JPRB, 0.36701065E-03_JPRB, 0.36708664E-03_JPRB, &
  & 0.36717279E-03_JPRB, 0.36726790E-03_JPRB, 0.36736956E-03_JPRB, 0.36747564E-03_JPRB, 0.36758414E-03_JPRB, 0.36769340E-03_JPRB, &
  & 0.36780350E-03_JPRB, 0.36791601E-03_JPRB, 0.36803327E-03_JPRB, 0.36815731E-03_JPRB, 0.36828752E-03_JPRB, 0.36842033E-03_JPRB, &
  & 0.36854963E-03_JPRB, 0.36867039E-03_JPRB, 0.36877746E-03_JPRB, 0.36886547E-03_JPRB, 0.36893063E-03_JPRB, 0.36897286E-03_JPRB, &
  & 0.36899175E-03_JPRB, 0.36898803E-03_JPRB, 0.36896591E-03_JPRB, 0.36893089E-03_JPRB, 0.36889050E-03_JPRB, 0.36885322E-03_JPRB, &
  & 0.36882827E-03_JPRB, 0.36882120E-03_JPRB, 0.36883843E-03_JPRB, 0.36887149E-03_JPRB, 0.36891078E-03_JPRB, 0.36895004E-03_JPRB, &
  & 0.36898241E-03_JPRB, 0.36900555E-03_JPRB, 0.36901888E-03_JPRB, 0.36902257E-03_JPRB, 0.36901672E-03_JPRB, 0.36900016E-03_JPRB, &
  & 0.36897167E-03_JPRB, 0.36893028E-03_JPRB, 0.36887586E-03_JPRB, 0.36880875E-03_JPRB, 0.36872952E-03_JPRB, 0.36863814E-03_JPRB, &
  & 0.36853555E-03_JPRB, 0.36842318E-03_JPRB, 0.36830315E-03_JPRB, 0.36817876E-03_JPRB, 0.36805400E-03_JPRB, 0.36793342E-03_JPRB, &
  & 0.36782114E-03_JPRB, 0.36772017E-03_JPRB, 0.36763202E-03_JPRB, 0.36755719E-03_JPRB, 0.36749514E-03_JPRB, 0.36744506E-03_JPRB, &
  & 0.36740635E-03_JPRB, 0.36737474E-03_JPRB, 0.36734581E-03_JPRB, 0.36730018E-03_JPRB /)

RGHG1(:,16,11) = (/ &
  & 0.36707803E-03_JPRB, 0.36714406E-03_JPRB, 0.36720344E-03_JPRB, 0.36726968E-03_JPRB, 0.36734572E-03_JPRB, 0.36743301E-03_JPRB, &
  & 0.36753126E-03_JPRB, 0.36763930E-03_JPRB, 0.36775426E-03_JPRB, 0.36787277E-03_JPRB, 0.36799174E-03_JPRB, 0.36810941E-03_JPRB, &
  & 0.36822530E-03_JPRB, 0.36834064E-03_JPRB, 0.36845737E-03_JPRB, 0.36857743E-03_JPRB, 0.36870083E-03_JPRB, 0.36882510E-03_JPRB, &
  & 0.36894481E-03_JPRB, 0.36905485E-03_JPRB, 0.36915083E-03_JPRB, 0.36922819E-03_JPRB, 0.36928302E-03_JPRB, 0.36931445E-03_JPRB, &
  & 0.36932292E-03_JPRB, 0.36930983E-03_JPRB, 0.36927839E-03_JPRB, 0.36923517E-03_JPRB, 0.36918721E-03_JPRB, 0.36914478E-03_JPRB, &
  & 0.36911637E-03_JPRB, 0.36910770E-03_JPRB, 0.36911710E-03_JPRB, 0.36914303E-03_JPRB, 0.36918113E-03_JPRB, 0.36922214E-03_JPRB, &
  & 0.36925814E-03_JPRB, 0.36928465E-03_JPRB, 0.36930031E-03_JPRB, 0.36930502E-03_JPRB, 0.36929914E-03_JPRB, 0.36928226E-03_JPRB, &
  & 0.36925412E-03_JPRB, 0.36921550E-03_JPRB, 0.36916704E-03_JPRB, 0.36910927E-03_JPRB, 0.36904195E-03_JPRB, 0.36896506E-03_JPRB, &
  & 0.36887862E-03_JPRB, 0.36878273E-03_JPRB, 0.36867888E-03_JPRB, 0.36856980E-03_JPRB, 0.36845868E-03_JPRB, 0.36834890E-03_JPRB, &
  & 0.36824378E-03_JPRB, 0.36814640E-03_JPRB, 0.36805877E-03_JPRB, 0.36798188E-03_JPRB, 0.36791631E-03_JPRB, 0.36786243E-03_JPRB, &
  & 0.36781828E-03_JPRB, 0.36778455E-03_JPRB, 0.36774832E-03_JPRB, 0.36770053E-03_JPRB /)

RGHG1(:,17,11) = (/ &
  & 0.36739020E-03_JPRB, 0.36746584E-03_JPRB, 0.36753097E-03_JPRB, 0.36760260E-03_JPRB, 0.36768444E-03_JPRB, 0.36777777E-03_JPRB, &
  & 0.36788260E-03_JPRB, 0.36799701E-03_JPRB, 0.36811805E-03_JPRB, 0.36824195E-03_JPRB, 0.36836477E-03_JPRB, 0.36848398E-03_JPRB, &
  & 0.36859914E-03_JPRB, 0.36871136E-03_JPRB, 0.36882251E-03_JPRB, 0.36893433E-03_JPRB, 0.36904711E-03_JPRB, 0.36915889E-03_JPRB, &
  & 0.36926544E-03_JPRB, 0.36936242E-03_JPRB, 0.36944618E-03_JPRB, 0.36951320E-03_JPRB, 0.36956000E-03_JPRB, 0.36958521E-03_JPRB, &
  & 0.36958919E-03_JPRB, 0.36957351E-03_JPRB, 0.36954190E-03_JPRB, 0.36950014E-03_JPRB, 0.36945619E-03_JPRB, 0.36941795E-03_JPRB, &
  & 0.36939047E-03_JPRB, 0.36937959E-03_JPRB, 0.36938864E-03_JPRB, 0.36941437E-03_JPRB, 0.36945040E-03_JPRB, 0.36948975E-03_JPRB, &
  & 0.36952499E-03_JPRB, 0.36955127E-03_JPRB, 0.36956661E-03_JPRB, 0.36957063E-03_JPRB, 0.36956315E-03_JPRB, 0.36954472E-03_JPRB, &
  & 0.36951667E-03_JPRB, 0.36948017E-03_JPRB, 0.36943631E-03_JPRB, 0.36938576E-03_JPRB, 0.36932854E-03_JPRB, 0.36926422E-03_JPRB, &
  & 0.36919172E-03_JPRB, 0.36911081E-03_JPRB, 0.36902213E-03_JPRB, 0.36892731E-03_JPRB, 0.36882851E-03_JPRB, 0.36872868E-03_JPRB, &
  & 0.36863098E-03_JPRB, 0.36853860E-03_JPRB, 0.36845345E-03_JPRB, 0.36837731E-03_JPRB, 0.36831098E-03_JPRB, 0.36825542E-03_JPRB, &
  & 0.36821101E-03_JPRB, 0.36817338E-03_JPRB, 0.36813965E-03_JPRB, 0.36808374E-03_JPRB /)

RGHG1(:,18,11) = (/ &
  & 0.36770559E-03_JPRB, 0.36778772E-03_JPRB, 0.36785463E-03_JPRB, 0.36792754E-03_JPRB, 0.36801034E-03_JPRB, 0.36810467E-03_JPRB, &
  & 0.36821002E-03_JPRB, 0.36832469E-03_JPRB, 0.36844501E-03_JPRB, 0.36856698E-03_JPRB, 0.36868692E-03_JPRB, 0.36880228E-03_JPRB, &
  & 0.36891236E-03_JPRB, 0.36901806E-03_JPRB, 0.36912115E-03_JPRB, 0.36922307E-03_JPRB, 0.36932435E-03_JPRB, 0.36942348E-03_JPRB, &
  & 0.36951719E-03_JPRB, 0.36960182E-03_JPRB, 0.36967493E-03_JPRB, 0.36973349E-03_JPRB, 0.36977508E-03_JPRB, 0.36979793E-03_JPRB, &
  & 0.36980218E-03_JPRB, 0.36978995E-03_JPRB, 0.36976475E-03_JPRB, 0.36973221E-03_JPRB, 0.36969854E-03_JPRB, 0.36966929E-03_JPRB, &
  & 0.36964988E-03_JPRB, 0.36964531E-03_JPRB, 0.36965439E-03_JPRB, 0.36967589E-03_JPRB, 0.36970552E-03_JPRB, 0.36973771E-03_JPRB, &
  & 0.36976737E-03_JPRB, 0.36978975E-03_JPRB, 0.36980261E-03_JPRB, 0.36980433E-03_JPRB, 0.36979531E-03_JPRB, 0.36977613E-03_JPRB, &
  & 0.36974880E-03_JPRB, 0.36971463E-03_JPRB, 0.36967528E-03_JPRB, 0.36963131E-03_JPRB, 0.36958276E-03_JPRB, 0.36952886E-03_JPRB, &
  & 0.36946838E-03_JPRB, 0.36940057E-03_JPRB, 0.36932548E-03_JPRB, 0.36924393E-03_JPRB, 0.36915738E-03_JPRB, 0.36906812E-03_JPRB, &
  & 0.36897903E-03_JPRB, 0.36889283E-03_JPRB, 0.36881230E-03_JPRB, 0.36873875E-03_JPRB, 0.36867394E-03_JPRB, 0.36861902E-03_JPRB, &
  & 0.36857440E-03_JPRB, 0.36853750E-03_JPRB, 0.36850214E-03_JPRB, 0.36844637E-03_JPRB /)

RGHG1(:,19,11) = (/ &
  & 0.36801124E-03_JPRB, 0.36809445E-03_JPRB, 0.36816017E-03_JPRB, 0.36823039E-03_JPRB, 0.36831037E-03_JPRB, 0.36840135E-03_JPRB, &
  & 0.36850284E-03_JPRB, 0.36861238E-03_JPRB, 0.36872676E-03_JPRB, 0.36884189E-03_JPRB, 0.36895453E-03_JPRB, 0.36906239E-03_JPRB, &
  & 0.36916474E-03_JPRB, 0.36926259E-03_JPRB, 0.36935718E-03_JPRB, 0.36944967E-03_JPRB, 0.36954039E-03_JPRB, 0.36962848E-03_JPRB, &
  & 0.36971158E-03_JPRB, 0.36978701E-03_JPRB, 0.36985223E-03_JPRB, 0.36990512E-03_JPRB, 0.36994382E-03_JPRB, 0.36996734E-03_JPRB, &
  & 0.36997534E-03_JPRB, 0.36996978E-03_JPRB, 0.36995421E-03_JPRB, 0.36993332E-03_JPRB, 0.36991268E-03_JPRB, 0.36989580E-03_JPRB, &
  & 0.36988739E-03_JPRB, 0.36988719E-03_JPRB, 0.36989612E-03_JPRB, 0.36991236E-03_JPRB, 0.36993372E-03_JPRB, 0.36995663E-03_JPRB, &
  & 0.36997744E-03_JPRB, 0.36999307E-03_JPRB, 0.37000127E-03_JPRB, 0.37000055E-03_JPRB, 0.36999036E-03_JPRB, 0.36997165E-03_JPRB, &
  & 0.36994580E-03_JPRB, 0.36991475E-03_JPRB, 0.36987965E-03_JPRB, 0.36984117E-03_JPRB, 0.36979932E-03_JPRB, 0.36975351E-03_JPRB, &
  & 0.36970249E-03_JPRB, 0.36964580E-03_JPRB, 0.36958285E-03_JPRB, 0.36951376E-03_JPRB, 0.36943954E-03_JPRB, 0.36936183E-03_JPRB, &
  & 0.36928308E-03_JPRB, 0.36920561E-03_JPRB, 0.36913183E-03_JPRB, 0.36906381E-03_JPRB, 0.36900278E-03_JPRB, 0.36895039E-03_JPRB, &
  & 0.36890630E-03_JPRB, 0.36887117E-03_JPRB, 0.36883444E-03_JPRB, 0.36878217E-03_JPRB /)

RGHG1(:,20,11) = (/ &
  & 0.36829122E-03_JPRB, 0.36837417E-03_JPRB, 0.36843657E-03_JPRB, 0.36850304E-03_JPRB, 0.36857781E-03_JPRB, 0.36866264E-03_JPRB, &
  & 0.36875668E-03_JPRB, 0.36885802E-03_JPRB, 0.36896294E-03_JPRB, 0.36906826E-03_JPRB, 0.36917118E-03_JPRB, 0.36926987E-03_JPRB, &
  & 0.36936376E-03_JPRB, 0.36945351E-03_JPRB, 0.36954036E-03_JPRB, 0.36962505E-03_JPRB, 0.36970753E-03_JPRB, 0.36978736E-03_JPRB, &
  & 0.36986294E-03_JPRB, 0.36993201E-03_JPRB, 0.36999254E-03_JPRB, 0.37004257E-03_JPRB, 0.37008084E-03_JPRB, 0.37010634E-03_JPRB, &
  & 0.37011935E-03_JPRB, 0.37012165E-03_JPRB, 0.37011670E-03_JPRB, 0.37010823E-03_JPRB, 0.37009982E-03_JPRB, 0.37009420E-03_JPRB, &
  & 0.37009234E-03_JPRB, 0.37009543E-03_JPRB, 0.37010273E-03_JPRB, 0.37011330E-03_JPRB, 0.37012622E-03_JPRB, 0.37013961E-03_JPRB, &
  & 0.37015221E-03_JPRB, 0.37016120E-03_JPRB, 0.37016446E-03_JPRB, 0.37016146E-03_JPRB, 0.37015096E-03_JPRB, 0.37013352E-03_JPRB, &
  & 0.37010995E-03_JPRB, 0.37008181E-03_JPRB, 0.37005034E-03_JPRB, 0.37001594E-03_JPRB, 0.36997904E-03_JPRB, 0.36993920E-03_JPRB, &
  & 0.36989545E-03_JPRB, 0.36984732E-03_JPRB, 0.36979408E-03_JPRB, 0.36973602E-03_JPRB, 0.36967348E-03_JPRB, 0.36960747E-03_JPRB, &
  & 0.36953969E-03_JPRB, 0.36947220E-03_JPRB, 0.36940732E-03_JPRB, 0.36934644E-03_JPRB, 0.36929111E-03_JPRB, 0.36924251E-03_JPRB, &
  & 0.36920217E-03_JPRB, 0.36916562E-03_JPRB, 0.36913427E-03_JPRB, 0.36907490E-03_JPRB /)

RGHG1(:,21,11) = (/ &
  & 0.36853948E-03_JPRB, 0.36861736E-03_JPRB, 0.36867789E-03_JPRB, 0.36873930E-03_JPRB, 0.36880811E-03_JPRB, 0.36888552E-03_JPRB, &
  & 0.36897094E-03_JPRB, 0.36906207E-03_JPRB, 0.36915636E-03_JPRB, 0.36925104E-03_JPRB, 0.36934391E-03_JPRB, 0.36943360E-03_JPRB, &
  & 0.36951969E-03_JPRB, 0.36960264E-03_JPRB, 0.36968300E-03_JPRB, 0.36976160E-03_JPRB, 0.36983838E-03_JPRB, 0.36991260E-03_JPRB, &
  & 0.36998291E-03_JPRB, 0.37004813E-03_JPRB, 0.37010640E-03_JPRB, 0.37015590E-03_JPRB, 0.37019522E-03_JPRB, 0.37022372E-03_JPRB, &
  & 0.37024193E-03_JPRB, 0.37025133E-03_JPRB, 0.37025535E-03_JPRB, 0.37025657E-03_JPRB, 0.37025727E-03_JPRB, 0.37025905E-03_JPRB, &
  & 0.37026231E-03_JPRB, 0.37026673E-03_JPRB, 0.37027162E-03_JPRB, 0.37027698E-03_JPRB, 0.37028274E-03_JPRB, 0.37028830E-03_JPRB, &
  & 0.37029386E-03_JPRB, 0.37029735E-03_JPRB, 0.37029796E-03_JPRB, 0.37029319E-03_JPRB, 0.37028315E-03_JPRB, 0.37026705E-03_JPRB, &
  & 0.37024589E-03_JPRB, 0.37022046E-03_JPRB, 0.37019153E-03_JPRB, 0.37016033E-03_JPRB, 0.37012712E-03_JPRB, 0.37009132E-03_JPRB, &
  & 0.37005282E-03_JPRB, 0.37001097E-03_JPRB, 0.36996539E-03_JPRB, 0.36991597E-03_JPRB, 0.36986300E-03_JPRB, 0.36980727E-03_JPRB, &
  & 0.36974991E-03_JPRB, 0.36969254E-03_JPRB, 0.36963657E-03_JPRB, 0.36958337E-03_JPRB, 0.36953433E-03_JPRB, 0.36949030E-03_JPRB, &
  & 0.36945130E-03_JPRB, 0.36941943E-03_JPRB, 0.36938293E-03_JPRB, 0.36933235E-03_JPRB /)

RGHG1(:,22,11) = (/ &
  & 0.36875260E-03_JPRB, 0.36882679E-03_JPRB, 0.36888343E-03_JPRB, 0.36894061E-03_JPRB, 0.36900319E-03_JPRB, 0.36907295E-03_JPRB, &
  & 0.36914914E-03_JPRB, 0.36923026E-03_JPRB, 0.36931410E-03_JPRB, 0.36939856E-03_JPRB, 0.36948232E-03_JPRB, 0.36956390E-03_JPRB, &
  & 0.36964339E-03_JPRB, 0.36972045E-03_JPRB, 0.36979577E-03_JPRB, 0.36986984E-03_JPRB, 0.36994260E-03_JPRB, 0.37001324E-03_JPRB, &
  & 0.37008076E-03_JPRB, 0.37014383E-03_JPRB, 0.37020110E-03_JPRB, 0.37025107E-03_JPRB, 0.37029240E-03_JPRB, 0.37032415E-03_JPRB, &
  & 0.37034688E-03_JPRB, 0.37036240E-03_JPRB, 0.37037325E-03_JPRB, 0.37038111E-03_JPRB, 0.37038783E-03_JPRB, 0.37039403E-03_JPRB, &
  & 0.37039924E-03_JPRB, 0.37040329E-03_JPRB, 0.37040573E-03_JPRB, 0.37040722E-03_JPRB, 0.37040803E-03_JPRB, 0.37040882E-03_JPRB, &
  & 0.37040986E-03_JPRB, 0.37040978E-03_JPRB, 0.37040745E-03_JPRB, 0.37040224E-03_JPRB, 0.37039258E-03_JPRB, 0.37037805E-03_JPRB, &
  & 0.37035870E-03_JPRB, 0.37033542E-03_JPRB, 0.37030873E-03_JPRB, 0.37027936E-03_JPRB, 0.37024834E-03_JPRB, 0.37021548E-03_JPRB, &
  & 0.37018047E-03_JPRB, 0.37014324E-03_JPRB, 0.37010328E-03_JPRB, 0.37006073E-03_JPRB, 0.37001556E-03_JPRB, 0.36996842E-03_JPRB, &
  & 0.36991993E-03_JPRB, 0.36987115E-03_JPRB, 0.36982316E-03_JPRB, 0.36977683E-03_JPRB, 0.36973305E-03_JPRB, 0.36969301E-03_JPRB, &
  & 0.36965776E-03_JPRB, 0.36962429E-03_JPRB, 0.36959405E-03_JPRB, 0.36953739E-03_JPRB /)

RGHG1(:,23,11) = (/ &
  & 0.36893395E-03_JPRB, 0.36900328E-03_JPRB, 0.36905712E-03_JPRB, 0.36910916E-03_JPRB, 0.36916614E-03_JPRB, 0.36922860E-03_JPRB, &
  & 0.36929658E-03_JPRB, 0.36936853E-03_JPRB, 0.36944303E-03_JPRB, 0.36951870E-03_JPRB, 0.36959449E-03_JPRB, 0.36966958E-03_JPRB, &
  & 0.36974353E-03_JPRB, 0.36981629E-03_JPRB, 0.36988806E-03_JPRB, 0.36995887E-03_JPRB, 0.37002857E-03_JPRB, 0.37009662E-03_JPRB, &
  & 0.37016225E-03_JPRB, 0.37022430E-03_JPRB, 0.37028143E-03_JPRB, 0.37033233E-03_JPRB, 0.37037538E-03_JPRB, 0.37041010E-03_JPRB, &
  & 0.37043673E-03_JPRB, 0.37045666E-03_JPRB, 0.37047180E-03_JPRB, 0.37048373E-03_JPRB, 0.37049357E-03_JPRB, 0.37050157E-03_JPRB, &
  & 0.37050751E-03_JPRB, 0.37051080E-03_JPRB, 0.37051181E-03_JPRB, 0.37051091E-03_JPRB, 0.37050899E-03_JPRB, 0.37050666E-03_JPRB, &
  & 0.37050483E-03_JPRB, 0.37050244E-03_JPRB, 0.37049880E-03_JPRB, 0.37049328E-03_JPRB, 0.37048355E-03_JPRB, 0.37047005E-03_JPRB, &
  & 0.37045238E-03_JPRB, 0.37043064E-03_JPRB, 0.37040559E-03_JPRB, 0.37037785E-03_JPRB, 0.37034831E-03_JPRB, 0.37031746E-03_JPRB, &
  & 0.37028495E-03_JPRB, 0.37025087E-03_JPRB, 0.37021490E-03_JPRB, 0.37017724E-03_JPRB, 0.37013821E-03_JPRB, 0.37009793E-03_JPRB, &
  & 0.37005672E-03_JPRB, 0.37001498E-03_JPRB, 0.36997351E-03_JPRB, 0.36993294E-03_JPRB, 0.36989403E-03_JPRB, 0.36985741E-03_JPRB, &
  & 0.36982345E-03_JPRB, 0.36979304E-03_JPRB, 0.36975855E-03_JPRB, 0.36970616E-03_JPRB /)

RGHG1(:,24,11) = (/ &
  & 0.36908651E-03_JPRB, 0.36915307E-03_JPRB, 0.36920267E-03_JPRB, 0.36925101E-03_JPRB, 0.36930267E-03_JPRB, 0.36935901E-03_JPRB, &
  & 0.36941955E-03_JPRB, 0.36948387E-03_JPRB, 0.36955060E-03_JPRB, 0.36961908E-03_JPRB, 0.36968855E-03_JPRB, 0.36975803E-03_JPRB, &
  & 0.36982755E-03_JPRB, 0.36989670E-03_JPRB, 0.36996574E-03_JPRB, 0.37003407E-03_JPRB, 0.37010157E-03_JPRB, 0.37016752E-03_JPRB, &
  & 0.37023149E-03_JPRB, 0.37029252E-03_JPRB, 0.37034944E-03_JPRB, 0.37040096E-03_JPRB, 0.37044549E-03_JPRB, 0.37048259E-03_JPRB, &
  & 0.37051208E-03_JPRB, 0.37053504E-03_JPRB, 0.37055305E-03_JPRB, 0.37056702E-03_JPRB, 0.37057826E-03_JPRB, 0.37058705E-03_JPRB, &
  & 0.37059287E-03_JPRB, 0.37059581E-03_JPRB, 0.37059610E-03_JPRB, 0.37059400E-03_JPRB, 0.37059074E-03_JPRB, 0.37058722E-03_JPRB, &
  & 0.37058361E-03_JPRB, 0.37057989E-03_JPRB, 0.37057555E-03_JPRB, 0.37056921E-03_JPRB, 0.37055986E-03_JPRB, 0.37054700E-03_JPRB, &
  & 0.37053047E-03_JPRB, 0.37050995E-03_JPRB, 0.37048606E-03_JPRB, 0.37045960E-03_JPRB, 0.37043128E-03_JPRB, 0.37040174E-03_JPRB, &
  & 0.37037098E-03_JPRB, 0.37033902E-03_JPRB, 0.37030611E-03_JPRB, 0.37027232E-03_JPRB, 0.37023771E-03_JPRB, 0.37020247E-03_JPRB, &
  & 0.37016688E-03_JPRB, 0.37013099E-03_JPRB, 0.37009493E-03_JPRB, 0.37005899E-03_JPRB, 0.37002383E-03_JPRB, 0.36999013E-03_JPRB, &
  & 0.36995843E-03_JPRB, 0.36992726E-03_JPRB, 0.36989519E-03_JPRB, 0.36984053E-03_JPRB /)

RGHG1(:,25,11) = (/ &
  & 0.36921632E-03_JPRB, 0.36928107E-03_JPRB, 0.36932714E-03_JPRB, 0.36937161E-03_JPRB, 0.36941902E-03_JPRB, 0.36947013E-03_JPRB, &
  & 0.36952508E-03_JPRB, 0.36958308E-03_JPRB, 0.36964365E-03_JPRB, 0.36970622E-03_JPRB, 0.36977039E-03_JPRB, 0.36983547E-03_JPRB, &
  & 0.36990101E-03_JPRB, 0.36996690E-03_JPRB, 0.37003309E-03_JPRB, 0.37009915E-03_JPRB, 0.37016472E-03_JPRB, 0.37022898E-03_JPRB, &
  & 0.37029129E-03_JPRB, 0.37035113E-03_JPRB, 0.37040751E-03_JPRB, 0.37045925E-03_JPRB, 0.37050480E-03_JPRB, 0.37054316E-03_JPRB, &
  & 0.37057450E-03_JPRB, 0.37059942E-03_JPRB, 0.37061909E-03_JPRB, 0.37063460E-03_JPRB, 0.37064654E-03_JPRB, 0.37065527E-03_JPRB, &
  & 0.37066100E-03_JPRB, 0.37066382E-03_JPRB, 0.37066394E-03_JPRB, 0.37066173E-03_JPRB, 0.37065821E-03_JPRB, 0.37065428E-03_JPRB, &
  & 0.37065003E-03_JPRB, 0.37064560E-03_JPRB, 0.37064051E-03_JPRB, 0.37063364E-03_JPRB, 0.37062433E-03_JPRB, 0.37061202E-03_JPRB, &
  & 0.37059607E-03_JPRB, 0.37057663E-03_JPRB, 0.37055346E-03_JPRB, 0.37052782E-03_JPRB, 0.37050032E-03_JPRB, 0.37047162E-03_JPRB, &
  & 0.37044205E-03_JPRB, 0.37041187E-03_JPRB, 0.37038117E-03_JPRB, 0.37035008E-03_JPRB, 0.37031877E-03_JPRB, 0.37028769E-03_JPRB, &
  & 0.37025640E-03_JPRB, 0.37022494E-03_JPRB, 0.37019327E-03_JPRB, 0.37016155E-03_JPRB, 0.37013000E-03_JPRB, 0.37009912E-03_JPRB, &
  & 0.37006938E-03_JPRB, 0.37004019E-03_JPRB, 0.37000838E-03_JPRB, 0.36995349E-03_JPRB /)

RGHG1(:,26,11) = (/ &
  & 0.36933029E-03_JPRB, 0.36939330E-03_JPRB, 0.36943622E-03_JPRB, 0.36947784E-03_JPRB, 0.36952144E-03_JPRB, 0.36956847E-03_JPRB, &
  & 0.36961868E-03_JPRB, 0.36967185E-03_JPRB, 0.36972738E-03_JPRB, 0.36978530E-03_JPRB, 0.36984484E-03_JPRB, 0.36990602E-03_JPRB, &
  & 0.36996830E-03_JPRB, 0.37003122E-03_JPRB, 0.37009484E-03_JPRB, 0.37015846E-03_JPRB, 0.37022150E-03_JPRB, 0.37028367E-03_JPRB, &
  & 0.37034432E-03_JPRB, 0.37040273E-03_JPRB, 0.37045780E-03_JPRB, 0.37050885E-03_JPRB, 0.37055433E-03_JPRB, 0.37059322E-03_JPRB, &
  & 0.37062555E-03_JPRB, 0.37065169E-03_JPRB, 0.37067267E-03_JPRB, 0.37068914E-03_JPRB, 0.37070175E-03_JPRB, 0.37071074E-03_JPRB, &
  & 0.37071653E-03_JPRB, 0.37071930E-03_JPRB, 0.37071956E-03_JPRB, 0.37071799E-03_JPRB, 0.37071473E-03_JPRB, 0.37071068E-03_JPRB, &
  & 0.37070652E-03_JPRB, 0.37070151E-03_JPRB, 0.37069572E-03_JPRB, 0.37068850E-03_JPRB, 0.37067910E-03_JPRB, 0.37066673E-03_JPRB, &
  & 0.37065131E-03_JPRB, 0.37063248E-03_JPRB, 0.37061039E-03_JPRB, 0.37058542E-03_JPRB, 0.37055867E-03_JPRB, 0.37053062E-03_JPRB, &
  & 0.37050180E-03_JPRB, 0.37047279E-03_JPRB, 0.37044357E-03_JPRB, 0.37041452E-03_JPRB, 0.37038597E-03_JPRB, 0.37035771E-03_JPRB, &
  & 0.37032971E-03_JPRB, 0.37030177E-03_JPRB, 0.37027380E-03_JPRB, 0.37024566E-03_JPRB, 0.37021772E-03_JPRB, 0.37019004E-03_JPRB, &
  & 0.37016315E-03_JPRB, 0.37013667E-03_JPRB, 0.37010599E-03_JPRB, 0.37005582E-03_JPRB /)

RGHG1(:,27,11) = (/ &
  & 0.36943378E-03_JPRB, 0.36949542E-03_JPRB, 0.36953622E-03_JPRB, 0.36957502E-03_JPRB, 0.36961579E-03_JPRB, 0.36965939E-03_JPRB, &
  & 0.36970596E-03_JPRB, 0.36975494E-03_JPRB, 0.36980645E-03_JPRB, 0.36986030E-03_JPRB, 0.36991603E-03_JPRB, 0.36997348E-03_JPRB, &
  & 0.37003230E-03_JPRB, 0.37009246E-03_JPRB, 0.37015326E-03_JPRB, 0.37021452E-03_JPRB, 0.37027514E-03_JPRB, 0.37033492E-03_JPRB, &
  & 0.37039322E-03_JPRB, 0.37044930E-03_JPRB, 0.37050253E-03_JPRB, 0.37055209E-03_JPRB, 0.37059648E-03_JPRB, 0.37063524E-03_JPRB, &
  & 0.37066784E-03_JPRB, 0.37069479E-03_JPRB, 0.37071656E-03_JPRB, 0.37073367E-03_JPRB, 0.37074674E-03_JPRB, 0.37075608E-03_JPRB, &
  & 0.37076185E-03_JPRB, 0.37076499E-03_JPRB, 0.37076580E-03_JPRB, 0.37076473E-03_JPRB, 0.37076225E-03_JPRB, 0.37075856E-03_JPRB, &
  & 0.37075442E-03_JPRB, 0.37074956E-03_JPRB, 0.37074357E-03_JPRB, 0.37073594E-03_JPRB, 0.37072619E-03_JPRB, 0.37071406E-03_JPRB, &
  & 0.37069886E-03_JPRB, 0.37068041E-03_JPRB, 0.37065882E-03_JPRB, 0.37063443E-03_JPRB, 0.37060818E-03_JPRB, 0.37058094E-03_JPRB, &
  & 0.37055294E-03_JPRB, 0.37052465E-03_JPRB, 0.37049662E-03_JPRB, 0.37046924E-03_JPRB, 0.37044258E-03_JPRB, 0.37041662E-03_JPRB, &
  & 0.37039106E-03_JPRB, 0.37036597E-03_JPRB, 0.37034103E-03_JPRB, 0.37031624E-03_JPRB, 0.37029170E-03_JPRB, 0.37026766E-03_JPRB, &
  & 0.37024438E-03_JPRB, 0.37022069E-03_JPRB, 0.37019514E-03_JPRB, 0.37014790E-03_JPRB /)

RGHG1(:,28,11) = (/ &
  & 0.36953166E-03_JPRB, 0.36959234E-03_JPRB, 0.36963128E-03_JPRB, 0.36966821E-03_JPRB, 0.36970619E-03_JPRB, 0.36974665E-03_JPRB, &
  & 0.36978984E-03_JPRB, 0.36983544E-03_JPRB, 0.36988317E-03_JPRB, 0.36993311E-03_JPRB, 0.36998524E-03_JPRB, 0.37003926E-03_JPRB, &
  & 0.37009479E-03_JPRB, 0.37015180E-03_JPRB, 0.37020954E-03_JPRB, 0.37026804E-03_JPRB, 0.37032613E-03_JPRB, 0.37038326E-03_JPRB, &
  & 0.37043900E-03_JPRB, 0.37049246E-03_JPRB, 0.37054325E-03_JPRB, 0.37059071E-03_JPRB, 0.37063388E-03_JPRB, 0.37067177E-03_JPRB, &
  & 0.37070413E-03_JPRB, 0.37073111E-03_JPRB, 0.37075323E-03_JPRB, 0.37077078E-03_JPRB, 0.37078437E-03_JPRB, 0.37079389E-03_JPRB, &
  & 0.37080012E-03_JPRB, 0.37080352E-03_JPRB, 0.37080480E-03_JPRB, 0.37080451E-03_JPRB, 0.37080271E-03_JPRB, 0.37079956E-03_JPRB, &
  & 0.37079561E-03_JPRB, 0.37079066E-03_JPRB, 0.37078431E-03_JPRB, 0.37077646E-03_JPRB, 0.37076662E-03_JPRB, 0.37075437E-03_JPRB, &
  & 0.37073949E-03_JPRB, 0.37072157E-03_JPRB, 0.37070047E-03_JPRB, 0.37067660E-03_JPRB, 0.37065081E-03_JPRB, 0.37062366E-03_JPRB, &
  & 0.37059595E-03_JPRB, 0.37056857E-03_JPRB, 0.37054194E-03_JPRB, 0.37051601E-03_JPRB, 0.37049103E-03_JPRB, 0.37046697E-03_JPRB, &
  & 0.37044380E-03_JPRB, 0.37042110E-03_JPRB, 0.37039869E-03_JPRB, 0.37037674E-03_JPRB, 0.37035521E-03_JPRB, 0.37033422E-03_JPRB, &
  & 0.37031400E-03_JPRB, 0.37029423E-03_JPRB, 0.37027124E-03_JPRB, 0.37023242E-03_JPRB /)

RGHG1(:,29,11) = (/ &
  & 0.36962662E-03_JPRB, 0.36968623E-03_JPRB, 0.36972418E-03_JPRB, 0.36975881E-03_JPRB, 0.36979467E-03_JPRB, 0.36983239E-03_JPRB, &
  & 0.36987243E-03_JPRB, 0.36991469E-03_JPRB, 0.36995916E-03_JPRB, 0.37000547E-03_JPRB, 0.37005404E-03_JPRB, 0.37010445E-03_JPRB, &
  & 0.37015683E-03_JPRB, 0.37021039E-03_JPRB, 0.37026522E-03_JPRB, 0.37032078E-03_JPRB, 0.37037610E-03_JPRB, 0.37043056E-03_JPRB, &
  & 0.37048335E-03_JPRB, 0.37053387E-03_JPRB, 0.37058193E-03_JPRB, 0.37062707E-03_JPRB, 0.37066831E-03_JPRB, 0.37070483E-03_JPRB, &
  & 0.37073650E-03_JPRB, 0.37076313E-03_JPRB, 0.37078510E-03_JPRB, 0.37080277E-03_JPRB, 0.37081650E-03_JPRB, 0.37082631E-03_JPRB, &
  & 0.37083280E-03_JPRB, 0.37083644E-03_JPRB, 0.37083813E-03_JPRB, 0.37083833E-03_JPRB, 0.37083690E-03_JPRB, 0.37083434E-03_JPRB, &
  & 0.37083073E-03_JPRB, 0.37082582E-03_JPRB, 0.37081944E-03_JPRB, 0.37081141E-03_JPRB, 0.37080143E-03_JPRB, 0.37078926E-03_JPRB, &
  & 0.37077459E-03_JPRB, 0.37075707E-03_JPRB, 0.37073655E-03_JPRB, 0.37071327E-03_JPRB, 0.37068783E-03_JPRB, 0.37066132E-03_JPRB, &
  & 0.37063452E-03_JPRB, 0.37060809E-03_JPRB, 0.37058222E-03_JPRB, 0.37055748E-03_JPRB, 0.37053385E-03_JPRB, 0.37051147E-03_JPRB, &
  & 0.37048990E-03_JPRB, 0.37046918E-03_JPRB, 0.37044883E-03_JPRB, 0.37042898E-03_JPRB, 0.37040978E-03_JPRB, 0.37039132E-03_JPRB, &
  & 0.37037380E-03_JPRB, 0.37035655E-03_JPRB, 0.37033777E-03_JPRB, 0.37030451E-03_JPRB /)

RGHG1(:,30,11) = (/ &
  & 0.36971938E-03_JPRB, 0.36977901E-03_JPRB, 0.36981501E-03_JPRB, 0.36984845E-03_JPRB, 0.36988180E-03_JPRB, 0.36991714E-03_JPRB, &
  & 0.36995433E-03_JPRB, 0.36999362E-03_JPRB, 0.37003463E-03_JPRB, 0.37007773E-03_JPRB, 0.37012267E-03_JPRB, 0.37016961E-03_JPRB, &
  & 0.37021856E-03_JPRB, 0.37026877E-03_JPRB, 0.37032049E-03_JPRB, 0.37037313E-03_JPRB, 0.37042564E-03_JPRB, 0.37047721E-03_JPRB, &
  & 0.37052704E-03_JPRB, 0.37057462E-03_JPRB, 0.37061964E-03_JPRB, 0.37066199E-03_JPRB, 0.37070096E-03_JPRB, 0.37073586E-03_JPRB, &
  & 0.37076609E-03_JPRB, 0.37079194E-03_JPRB, 0.37081330E-03_JPRB, 0.37083088E-03_JPRB, 0.37084447E-03_JPRB, 0.37085425E-03_JPRB, &
  & 0.37086080E-03_JPRB, 0.37086476E-03_JPRB, 0.37086679E-03_JPRB, 0.37086729E-03_JPRB, 0.37086630E-03_JPRB, 0.37086426E-03_JPRB, &
  & 0.37086080E-03_JPRB, 0.37085597E-03_JPRB, 0.37084962E-03_JPRB, 0.37084165E-03_JPRB, 0.37083169E-03_JPRB, 0.37081970E-03_JPRB, &
  & 0.37080515E-03_JPRB, 0.37078804E-03_JPRB, 0.37076802E-03_JPRB, 0.37074531E-03_JPRB, 0.37072043E-03_JPRB, 0.37069453E-03_JPRB, &
  & 0.37066831E-03_JPRB, 0.37064252E-03_JPRB, 0.37061758E-03_JPRB, 0.37059418E-03_JPRB, 0.37057209E-03_JPRB, 0.37055108E-03_JPRB, &
  & 0.37053099E-03_JPRB, 0.37051173E-03_JPRB, 0.37049287E-03_JPRB, 0.37047456E-03_JPRB, 0.37045704E-03_JPRB, 0.37044042E-03_JPRB, &
  & 0.37042494E-03_JPRB, 0.37040986E-03_JPRB, 0.37039313E-03_JPRB, 0.37036516E-03_JPRB /)

RGHG1(:,31,11) = (/ &
  & 0.36981111E-03_JPRB, 0.36986909E-03_JPRB, 0.36990477E-03_JPRB, 0.36993608E-03_JPRB, 0.36996760E-03_JPRB, 0.37000040E-03_JPRB, &
  & 0.37003515E-03_JPRB, 0.37007159E-03_JPRB, 0.37010957E-03_JPRB, 0.37014927E-03_JPRB, 0.37019086E-03_JPRB, 0.37023425E-03_JPRB, &
  & 0.37027965E-03_JPRB, 0.37032651E-03_JPRB, 0.37037517E-03_JPRB, 0.37042488E-03_JPRB, 0.37047453E-03_JPRB, 0.37052314E-03_JPRB, &
  & 0.37057023E-03_JPRB, 0.37061481E-03_JPRB, 0.37065698E-03_JPRB, 0.37069648E-03_JPRB, 0.37073292E-03_JPRB, 0.37076566E-03_JPRB, &
  & 0.37079430E-03_JPRB, 0.37081854E-03_JPRB, 0.37083903E-03_JPRB, 0.37085573E-03_JPRB, 0.37086903E-03_JPRB, 0.37087873E-03_JPRB, &
  & 0.37088519E-03_JPRB, 0.37088932E-03_JPRB, 0.37089153E-03_JPRB, 0.37089232E-03_JPRB, 0.37089165E-03_JPRB, 0.37088979E-03_JPRB, &
  & 0.37088653E-03_JPRB, 0.37088193E-03_JPRB, 0.37087567E-03_JPRB, 0.37086770E-03_JPRB, 0.37085792E-03_JPRB, 0.37084607E-03_JPRB, &
  & 0.37083172E-03_JPRB, 0.37081519E-03_JPRB, 0.37079561E-03_JPRB, 0.37077346E-03_JPRB, 0.37074916E-03_JPRB, 0.37072395E-03_JPRB, &
  & 0.37069857E-03_JPRB, 0.37067389E-03_JPRB, 0.37065023E-03_JPRB, 0.37062808E-03_JPRB, 0.37060713E-03_JPRB, 0.37058734E-03_JPRB, &
  & 0.37056836E-03_JPRB, 0.37055009E-03_JPRB, 0.37053225E-03_JPRB, 0.37051493E-03_JPRB, 0.37049851E-03_JPRB, 0.37048332E-03_JPRB, &
  & 0.37046900E-03_JPRB, 0.37045535E-03_JPRB, 0.37044060E-03_JPRB, 0.37041592E-03_JPRB /)

RGHG1(:,32,11) = (/ &
  & 0.36990075E-03_JPRB, 0.36995826E-03_JPRB, 0.36999190E-03_JPRB, 0.37002197E-03_JPRB, 0.37005148E-03_JPRB, 0.37008210E-03_JPRB, &
  & 0.37011426E-03_JPRB, 0.37014793E-03_JPRB, 0.37018280E-03_JPRB, 0.37021929E-03_JPRB, 0.37025733E-03_JPRB, 0.37029735E-03_JPRB, &
  & 0.37033932E-03_JPRB, 0.37038303E-03_JPRB, 0.37042855E-03_JPRB, 0.37047520E-03_JPRB, 0.37052212E-03_JPRB, 0.37056807E-03_JPRB, &
  & 0.37061225E-03_JPRB, 0.37065390E-03_JPRB, 0.37069331E-03_JPRB, 0.37073012E-03_JPRB, 0.37076403E-03_JPRB, 0.37079450E-03_JPRB, &
  & 0.37082107E-03_JPRB, 0.37084369E-03_JPRB, 0.37086266E-03_JPRB, 0.37087841E-03_JPRB, 0.37089101E-03_JPRB, 0.37090015E-03_JPRB, &
  & 0.37090661E-03_JPRB, 0.37091065E-03_JPRB, 0.37091310E-03_JPRB, 0.37091400E-03_JPRB, 0.37091342E-03_JPRB, 0.37091167E-03_JPRB, &
  & 0.37090862E-03_JPRB, 0.37090425E-03_JPRB, 0.37089817E-03_JPRB, 0.37089037E-03_JPRB, 0.37088073E-03_JPRB, 0.37086901E-03_JPRB, &
  & 0.37085509E-03_JPRB, 0.37083874E-03_JPRB, 0.37081967E-03_JPRB, 0.37079823E-03_JPRB, 0.37077491E-03_JPRB, 0.37075081E-03_JPRB, &
  & 0.37072657E-03_JPRB, 0.37070282E-03_JPRB, 0.37068030E-03_JPRB, 0.37065920E-03_JPRB, 0.37063938E-03_JPRB, 0.37062058E-03_JPRB, &
  & 0.37060244E-03_JPRB, 0.37058495E-03_JPRB, 0.37056781E-03_JPRB, 0.37055131E-03_JPRB, 0.37053571E-03_JPRB, 0.37052136E-03_JPRB, &
  & 0.37050812E-03_JPRB, 0.37049552E-03_JPRB, 0.37048198E-03_JPRB, 0.37045957E-03_JPRB /)

RGHG1(:,33,11) = (/ &
  & 0.36998870E-03_JPRB, 0.37004385E-03_JPRB, 0.37007639E-03_JPRB, 0.37010451E-03_JPRB, 0.37013233E-03_JPRB, 0.37016103E-03_JPRB, &
  & 0.37019097E-03_JPRB, 0.37022200E-03_JPRB, 0.37025413E-03_JPRB, 0.37028734E-03_JPRB, 0.37032194E-03_JPRB, 0.37035838E-03_JPRB, &
  & 0.37039680E-03_JPRB, 0.37043725E-03_JPRB, 0.37047983E-03_JPRB, 0.37052360E-03_JPRB, 0.37056766E-03_JPRB, 0.37061103E-03_JPRB, &
  & 0.37065276E-03_JPRB, 0.37069203E-03_JPRB, 0.37072884E-03_JPRB, 0.37076301E-03_JPRB, 0.37079441E-03_JPRB, 0.37082241E-03_JPRB, &
  & 0.37084660E-03_JPRB, 0.37086738E-03_JPRB, 0.37088478E-03_JPRB, 0.37089919E-03_JPRB, 0.37091077E-03_JPRB, 0.37091959E-03_JPRB, &
  & 0.37092555E-03_JPRB, 0.37092945E-03_JPRB, 0.37093178E-03_JPRB, 0.37093260E-03_JPRB, 0.37093210E-03_JPRB, 0.37093047E-03_JPRB, &
  & 0.37092759E-03_JPRB, 0.37092340E-03_JPRB, 0.37091749E-03_JPRB, 0.37091007E-03_JPRB, 0.37090076E-03_JPRB, 0.37088923E-03_JPRB, &
  & 0.37087564E-03_JPRB, 0.37085966E-03_JPRB, 0.37084112E-03_JPRB, 0.37082043E-03_JPRB, 0.37079820E-03_JPRB, 0.37077506E-03_JPRB, &
  & 0.37075189E-03_JPRB, 0.37072945E-03_JPRB, 0.37070827E-03_JPRB, 0.37068836E-03_JPRB, 0.37066967E-03_JPRB, 0.37065183E-03_JPRB, &
  & 0.37063452E-03_JPRB, 0.37061755E-03_JPRB, 0.37060099E-03_JPRB, 0.37058501E-03_JPRB, 0.37056996E-03_JPRB, 0.37055611E-03_JPRB, &
  & 0.37054345E-03_JPRB, 0.37053181E-03_JPRB, 0.37051912E-03_JPRB, 0.37049846E-03_JPRB /)

RGHG1(:,34,11) = (/ &
  & 0.37007392E-03_JPRB, 0.37012628E-03_JPRB, 0.37015666E-03_JPRB, 0.37018326E-03_JPRB, 0.37020940E-03_JPRB, 0.37023600E-03_JPRB, &
  & 0.37026385E-03_JPRB, 0.37029252E-03_JPRB, 0.37032191E-03_JPRB, 0.37035209E-03_JPRB, 0.37038355E-03_JPRB, 0.37041647E-03_JPRB, &
  & 0.37045131E-03_JPRB, 0.37048839E-03_JPRB, 0.37052773E-03_JPRB, 0.37056874E-03_JPRB, 0.37061033E-03_JPRB, 0.37065143E-03_JPRB, &
  & 0.37069095E-03_JPRB, 0.37072811E-03_JPRB, 0.37076260E-03_JPRB, 0.37079459E-03_JPRB, 0.37082349E-03_JPRB, 0.37084904E-03_JPRB, &
  & 0.37087116E-03_JPRB, 0.37088979E-03_JPRB, 0.37090539E-03_JPRB, 0.37091825E-03_JPRB, 0.37092881E-03_JPRB, 0.37093664E-03_JPRB, &
  & 0.37094223E-03_JPRB, 0.37094581E-03_JPRB, 0.37094785E-03_JPRB, 0.37094863E-03_JPRB, 0.37094817E-03_JPRB, 0.37094671E-03_JPRB, &
  & 0.37094404E-03_JPRB, 0.37094008E-03_JPRB, 0.37093449E-03_JPRB, 0.37092736E-03_JPRB, 0.37091825E-03_JPRB, 0.37090722E-03_JPRB, &
  & 0.37089383E-03_JPRB, 0.37087817E-03_JPRB, 0.37086027E-03_JPRB, 0.37084040E-03_JPRB, 0.37081930E-03_JPRB, 0.37079735E-03_JPRB, &
  & 0.37077558E-03_JPRB, 0.37075448E-03_JPRB, 0.37073446E-03_JPRB, 0.37071560E-03_JPRB, 0.37069788E-03_JPRB, 0.37068082E-03_JPRB, &
  & 0.37066417E-03_JPRB, 0.37064782E-03_JPRB, 0.37063187E-03_JPRB, 0.37061638E-03_JPRB, 0.37060177E-03_JPRB, 0.37058850E-03_JPRB, &
  & 0.37057666E-03_JPRB, 0.37056534E-03_JPRB, 0.37055367E-03_JPRB, 0.37053437E-03_JPRB /)

RGHG1(:,35,11) = (/ &
  & 0.37015599E-03_JPRB, 0.37020459E-03_JPRB, 0.37023262E-03_JPRB, 0.37025716E-03_JPRB, 0.37028134E-03_JPRB, 0.37030649E-03_JPRB, &
  & 0.37033239E-03_JPRB, 0.37035896E-03_JPRB, 0.37038588E-03_JPRB, 0.37041312E-03_JPRB, 0.37044109E-03_JPRB, 0.37047052E-03_JPRB, &
  & 0.37050177E-03_JPRB, 0.37053553E-03_JPRB, 0.37057188E-03_JPRB, 0.37061016E-03_JPRB, 0.37064956E-03_JPRB, 0.37068859E-03_JPRB, &
  & 0.37072628E-03_JPRB, 0.37076185E-03_JPRB, 0.37079470E-03_JPRB, 0.37082459E-03_JPRB, 0.37085143E-03_JPRB, 0.37087480E-03_JPRB, &
  & 0.37089453E-03_JPRB, 0.37091106E-03_JPRB, 0.37092477E-03_JPRB, 0.37093589E-03_JPRB, 0.37094500E-03_JPRB, 0.37095186E-03_JPRB, &
  & 0.37095681E-03_JPRB, 0.37095993E-03_JPRB, 0.37096176E-03_JPRB, 0.37096252E-03_JPRB, 0.37096196E-03_JPRB, 0.37096057E-03_JPRB, &
  & 0.37095812E-03_JPRB, 0.37095451E-03_JPRB, 0.37094933E-03_JPRB, 0.37094258E-03_JPRB, 0.37093397E-03_JPRB, 0.37092328E-03_JPRB, &
  & 0.37091036E-03_JPRB, 0.37089508E-03_JPRB, 0.37087768E-03_JPRB, 0.37085864E-03_JPRB, 0.37083839E-03_JPRB, 0.37081775E-03_JPRB, &
  & 0.37079732E-03_JPRB, 0.37077756E-03_JPRB, 0.37075876E-03_JPRB, 0.37074101E-03_JPRB, 0.37072413E-03_JPRB, 0.37070789E-03_JPRB, &
  & 0.37069208E-03_JPRB, 0.37067637E-03_JPRB, 0.37066083E-03_JPRB, 0.37064584E-03_JPRB, 0.37063175E-03_JPRB, 0.37061900E-03_JPRB, &
  & 0.37060742E-03_JPRB, 0.37059694E-03_JPRB, 0.37058565E-03_JPRB, 0.37056761E-03_JPRB /)

RGHG1(:,36,11) = (/ &
  & 0.37023559E-03_JPRB, 0.37027861E-03_JPRB, 0.37030395E-03_JPRB, 0.37032616E-03_JPRB, 0.37034845E-03_JPRB, 0.37037165E-03_JPRB, &
  & 0.37039586E-03_JPRB, 0.37042031E-03_JPRB, 0.37044473E-03_JPRB, 0.37046935E-03_JPRB, 0.37049418E-03_JPRB, 0.37052008E-03_JPRB, &
  & 0.37054787E-03_JPRB, 0.37057835E-03_JPRB, 0.37061182E-03_JPRB, 0.37064770E-03_JPRB, 0.37068510E-03_JPRB, 0.37072279E-03_JPRB, &
  & 0.37075920E-03_JPRB, 0.37079339E-03_JPRB, 0.37082483E-03_JPRB, 0.37085303E-03_JPRB, 0.37087779E-03_JPRB, 0.37089890E-03_JPRB, &
  & 0.37091639E-03_JPRB, 0.37093068E-03_JPRB, 0.37094226E-03_JPRB, 0.37095163E-03_JPRB, 0.37095908E-03_JPRB, 0.37096487E-03_JPRB, &
  & 0.37096898E-03_JPRB, 0.37097157E-03_JPRB, 0.37097305E-03_JPRB, 0.37097366E-03_JPRB, 0.37097320E-03_JPRB, 0.37097203E-03_JPRB, &
  & 0.37096988E-03_JPRB, 0.37096674E-03_JPRB, 0.37096220E-03_JPRB, 0.37095597E-03_JPRB, 0.37094811E-03_JPRB, 0.37093792E-03_JPRB, &
  & 0.37092535E-03_JPRB, 0.37091062E-03_JPRB, 0.37089386E-03_JPRB, 0.37087558E-03_JPRB, 0.37085643E-03_JPRB, 0.37083693E-03_JPRB, &
  & 0.37081772E-03_JPRB, 0.37079910E-03_JPRB, 0.37078137E-03_JPRB, 0.37076461E-03_JPRB, 0.37074849E-03_JPRB, 0.37073303E-03_JPRB, &
  & 0.37071778E-03_JPRB, 0.37070271E-03_JPRB, 0.37068781E-03_JPRB, 0.37067331E-03_JPRB, 0.37065969E-03_JPRB, 0.37064732E-03_JPRB, &
  & 0.37063629E-03_JPRB, 0.37062608E-03_JPRB, 0.37061557E-03_JPRB, 0.37059849E-03_JPRB /)

RGHG1(:,37,11) = (/ &
  & 0.37031181E-03_JPRB, 0.37034904E-03_JPRB, 0.37037069E-03_JPRB, 0.37039048E-03_JPRB, 0.37041056E-03_JPRB, 0.37043192E-03_JPRB, &
  & 0.37045431E-03_JPRB, 0.37047686E-03_JPRB, 0.37049910E-03_JPRB, 0.37052101E-03_JPRB, 0.37054290E-03_JPRB, 0.37056548E-03_JPRB, &
  & 0.37058984E-03_JPRB, 0.37061726E-03_JPRB, 0.37064790E-03_JPRB, 0.37068164E-03_JPRB, 0.37071735E-03_JPRB, 0.37075364E-03_JPRB, &
  & 0.37078912E-03_JPRB, 0.37082250E-03_JPRB, 0.37085277E-03_JPRB, 0.37087934E-03_JPRB, 0.37090210E-03_JPRB, 0.37092087E-03_JPRB, &
  & 0.37093589E-03_JPRB, 0.37094764E-03_JPRB, 0.37095702E-03_JPRB, 0.37096441E-03_JPRB, 0.37097017E-03_JPRB, 0.37097465E-03_JPRB, &
  & 0.37097791E-03_JPRB, 0.37097998E-03_JPRB, 0.37098129E-03_JPRB, 0.37098175E-03_JPRB, 0.37098140E-03_JPRB, 0.37098053E-03_JPRB, &
  & 0.37097876E-03_JPRB, 0.37097622E-03_JPRB, 0.37097235E-03_JPRB, 0.37096709E-03_JPRB, 0.37096010E-03_JPRB, 0.37095073E-03_JPRB, &
  & 0.37093883E-03_JPRB, 0.37092486E-03_JPRB, 0.37090876E-03_JPRB, 0.37089121E-03_JPRB, 0.37087296E-03_JPRB, 0.37085454E-03_JPRB, &
  & 0.37083644E-03_JPRB, 0.37081889E-03_JPRB, 0.37080201E-03_JPRB, 0.37078609E-03_JPRB, 0.37077075E-03_JPRB, 0.37075608E-03_JPRB, &
  & 0.37074165E-03_JPRB, 0.37072739E-03_JPRB, 0.37071324E-03_JPRB, 0.37069936E-03_JPRB, 0.37068623E-03_JPRB, 0.37067416E-03_JPRB, &
  & 0.37066345E-03_JPRB, 0.37065364E-03_JPRB, 0.37064351E-03_JPRB, 0.37062730E-03_JPRB /)

RGHG1(:,38,11) = (/ &
  & 0.37038457E-03_JPRB, 0.37041487E-03_JPRB, 0.37043323E-03_JPRB, 0.37045014E-03_JPRB, 0.37046807E-03_JPRB, 0.37048757E-03_JPRB, &
  & 0.37050809E-03_JPRB, 0.37052869E-03_JPRB, 0.37054883E-03_JPRB, 0.37056828E-03_JPRB, 0.37058728E-03_JPRB, 0.37060687E-03_JPRB, &
  & 0.37062820E-03_JPRB, 0.37065241E-03_JPRB, 0.37068050E-03_JPRB, 0.37071214E-03_JPRB, 0.37074642E-03_JPRB, 0.37078161E-03_JPRB, &
  & 0.37081615E-03_JPRB, 0.37084855E-03_JPRB, 0.37087768E-03_JPRB, 0.37090250E-03_JPRB, 0.37092282E-03_JPRB, 0.37093874E-03_JPRB, &
  & 0.37095096E-03_JPRB, 0.37096022E-03_JPRB, 0.37096749E-03_JPRB, 0.37097317E-03_JPRB, 0.37097750E-03_JPRB, 0.37098097E-03_JPRB, &
  & 0.37098353E-03_JPRB, 0.37098522E-03_JPRB, 0.37098621E-03_JPRB, 0.37098667E-03_JPRB, 0.37098647E-03_JPRB, 0.37098580E-03_JPRB, &
  & 0.37098440E-03_JPRB, 0.37098239E-03_JPRB, 0.37097940E-03_JPRB, 0.37097512E-03_JPRB, 0.37096927E-03_JPRB, 0.37096124E-03_JPRB, &
  & 0.37095070E-03_JPRB, 0.37093763E-03_JPRB, 0.37092244E-03_JPRB, 0.37090573E-03_JPRB, 0.37088853E-03_JPRB, 0.37087104E-03_JPRB, &
  & 0.37085373E-03_JPRB, 0.37083705E-03_JPRB, 0.37082098E-03_JPRB, 0.37080573E-03_JPRB, 0.37079118E-03_JPRB, 0.37077712E-03_JPRB, &
  & 0.37076365E-03_JPRB, 0.37075032E-03_JPRB, 0.37073699E-03_JPRB, 0.37072401E-03_JPRB, 0.37071155E-03_JPRB, 0.37069991E-03_JPRB, &
  & 0.37068955E-03_JPRB, 0.37067992E-03_JPRB, 0.37066996E-03_JPRB, 0.37065399E-03_JPRB /)

RGHG1(:,39,11) = (/ &
  & 0.37045244E-03_JPRB, 0.37047672E-03_JPRB, 0.37049162E-03_JPRB, 0.37050594E-03_JPRB, 0.37052188E-03_JPRB, 0.37053929E-03_JPRB, &
  & 0.37055794E-03_JPRB, 0.37057654E-03_JPRB, 0.37059444E-03_JPRB, 0.37061144E-03_JPRB, 0.37062791E-03_JPRB, 0.37064470E-03_JPRB, &
  & 0.37066327E-03_JPRB, 0.37068457E-03_JPRB, 0.37071016E-03_JPRB, 0.37073978E-03_JPRB, 0.37077241E-03_JPRB, 0.37080658E-03_JPRB, &
  & 0.37084011E-03_JPRB, 0.37087128E-03_JPRB, 0.37089840E-03_JPRB, 0.37092072E-03_JPRB, 0.37093813E-03_JPRB, 0.37095134E-03_JPRB, &
  & 0.37096121E-03_JPRB, 0.37096842E-03_JPRB, 0.37097413E-03_JPRB, 0.37097847E-03_JPRB, 0.37098184E-03_JPRB, 0.37098466E-03_JPRB, &
  & 0.37098673E-03_JPRB, 0.37098813E-03_JPRB, 0.37098903E-03_JPRB, 0.37098944E-03_JPRB, 0.37098929E-03_JPRB, 0.37098874E-03_JPRB, &
  & 0.37098760E-03_JPRB, 0.37098609E-03_JPRB, 0.37098370E-03_JPRB, 0.37098036E-03_JPRB, 0.37097555E-03_JPRB, 0.37096895E-03_JPRB, &
  & 0.37096004E-03_JPRB, 0.37094823E-03_JPRB, 0.37093437E-03_JPRB, 0.37091889E-03_JPRB, 0.37090247E-03_JPRB, 0.37088600E-03_JPRB, &
  & 0.37086956E-03_JPRB, 0.37085346E-03_JPRB, 0.37083807E-03_JPRB, 0.37082349E-03_JPRB, 0.37080969E-03_JPRB, 0.37079671E-03_JPRB, &
  & 0.37078411E-03_JPRB, 0.37077192E-03_JPRB, 0.37075963E-03_JPRB, 0.37074758E-03_JPRB, 0.37073571E-03_JPRB, 0.37072453E-03_JPRB, &
  & 0.37071438E-03_JPRB, 0.37070498E-03_JPRB, 0.37069505E-03_JPRB, 0.37067942E-03_JPRB /)

RGHG1(:,40,11) = (/ &
  & 0.37051397E-03_JPRB, 0.37053315E-03_JPRB, 0.37054543E-03_JPRB, 0.37055771E-03_JPRB, 0.37057159E-03_JPRB, 0.37058734E-03_JPRB, &
  & 0.37060399E-03_JPRB, 0.37062058E-03_JPRB, 0.37063632E-03_JPRB, 0.37065113E-03_JPRB, 0.37066537E-03_JPRB, 0.37067986E-03_JPRB, &
  & 0.37069572E-03_JPRB, 0.37071464E-03_JPRB, 0.37073757E-03_JPRB, 0.37076516E-03_JPRB, 0.37079639E-03_JPRB, 0.37082919E-03_JPRB, &
  & 0.37086126E-03_JPRB, 0.37089048E-03_JPRB, 0.37091505E-03_JPRB, 0.37093434E-03_JPRB, 0.37094887E-03_JPRB, 0.37095963E-03_JPRB, &
  & 0.37096752E-03_JPRB, 0.37097337E-03_JPRB, 0.37097794E-03_JPRB, 0.37098158E-03_JPRB, 0.37098443E-03_JPRB, 0.37098688E-03_JPRB, &
  & 0.37098868E-03_JPRB, 0.37098987E-03_JPRB, 0.37099072E-03_JPRB, 0.37099110E-03_JPRB, 0.37099098E-03_JPRB, 0.37099048E-03_JPRB, &
  & 0.37098958E-03_JPRB, 0.37098824E-03_JPRB, 0.37098641E-03_JPRB, 0.37098370E-03_JPRB, 0.37097980E-03_JPRB, 0.37097436E-03_JPRB, &
  & 0.37096682E-03_JPRB, 0.37095684E-03_JPRB, 0.37094456E-03_JPRB, 0.37093041E-03_JPRB, 0.37091511E-03_JPRB, 0.37089945E-03_JPRB, &
  & 0.37088373E-03_JPRB, 0.37086837E-03_JPRB, 0.37085355E-03_JPRB, 0.37083949E-03_JPRB, 0.37082651E-03_JPRB, 0.37081444E-03_JPRB, &
  & 0.37080306E-03_JPRB, 0.37079200E-03_JPRB, 0.37078100E-03_JPRB, 0.37076985E-03_JPRB, 0.37075876E-03_JPRB, 0.37074817E-03_JPRB, &
  & 0.37073833E-03_JPRB, 0.37072907E-03_JPRB, 0.37071932E-03_JPRB, 0.37070364E-03_JPRB /)

RGHG1(:,41,11) = (/ &
  & 0.37056848E-03_JPRB, 0.37058417E-03_JPRB, 0.37059435E-03_JPRB, 0.37060480E-03_JPRB, 0.37061723E-03_JPRB, 0.37063143E-03_JPRB, &
  & 0.37064654E-03_JPRB, 0.37066123E-03_JPRB, 0.37067500E-03_JPRB, 0.37068775E-03_JPRB, 0.37070000E-03_JPRB, 0.37071243E-03_JPRB, &
  & 0.37072631E-03_JPRB, 0.37074275E-03_JPRB, 0.37076348E-03_JPRB, 0.37078888E-03_JPRB, 0.37081842E-03_JPRB, 0.37084956E-03_JPRB, &
  & 0.37087980E-03_JPRB, 0.37090646E-03_JPRB, 0.37092809E-03_JPRB, 0.37094441E-03_JPRB, 0.37095652E-03_JPRB, 0.37096534E-03_JPRB, &
  & 0.37097180E-03_JPRB, 0.37097669E-03_JPRB, 0.37098047E-03_JPRB, 0.37098362E-03_JPRB, 0.37098603E-03_JPRB, 0.37098827E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37099104E-03_JPRB, 0.37099179E-03_JPRB, 0.37099211E-03_JPRB, 0.37099200E-03_JPRB, 0.37099159E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37098973E-03_JPRB, 0.37098810E-03_JPRB, 0.37098589E-03_JPRB, 0.37098269E-03_JPRB, 0.37097820E-03_JPRB, &
  & 0.37097200E-03_JPRB, 0.37096351E-03_JPRB, 0.37095291E-03_JPRB, 0.37094031E-03_JPRB, 0.37092622E-03_JPRB, 0.37091158E-03_JPRB, &
  & 0.37089671E-03_JPRB, 0.37088196E-03_JPRB, 0.37086778E-03_JPRB, 0.37085445E-03_JPRB, 0.37084223E-03_JPRB, 0.37083103E-03_JPRB, &
  & 0.37082069E-03_JPRB, 0.37081077E-03_JPRB, 0.37080093E-03_JPRB, 0.37079080E-03_JPRB, 0.37078056E-03_JPRB, 0.37077063E-03_JPRB, &
  & 0.37076129E-03_JPRB, 0.37075236E-03_JPRB, 0.37074275E-03_JPRB, 0.37072724E-03_JPRB /)

RGHG1(:,42,11) = (/ &
  & 0.37061673E-03_JPRB, 0.37062968E-03_JPRB, 0.37063845E-03_JPRB, 0.37064787E-03_JPRB, 0.37065931E-03_JPRB, 0.37067253E-03_JPRB, &
  & 0.37068606E-03_JPRB, 0.37069901E-03_JPRB, 0.37071094E-03_JPRB, 0.37072197E-03_JPRB, 0.37073245E-03_JPRB, 0.37074316E-03_JPRB, &
  & 0.37075489E-03_JPRB, 0.37076932E-03_JPRB, 0.37078775E-03_JPRB, 0.37081126E-03_JPRB, 0.37083888E-03_JPRB, 0.37086819E-03_JPRB, &
  & 0.37089601E-03_JPRB, 0.37091994E-03_JPRB, 0.37093845E-03_JPRB, 0.37095213E-03_JPRB, 0.37096205E-03_JPRB, 0.37096938E-03_JPRB, &
  & 0.37097477E-03_JPRB, 0.37097899E-03_JPRB, 0.37098225E-03_JPRB, 0.37098507E-03_JPRB, 0.37098734E-03_JPRB, 0.37098929E-03_JPRB, &
  & 0.37099086E-03_JPRB, 0.37099191E-03_JPRB, 0.37099264E-03_JPRB, 0.37099293E-03_JPRB, 0.37099278E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099179E-03_JPRB, 0.37099083E-03_JPRB, 0.37098941E-03_JPRB, 0.37098752E-03_JPRB, 0.37098484E-03_JPRB, 0.37098108E-03_JPRB, &
  & 0.37097590E-03_JPRB, 0.37096892E-03_JPRB, 0.37095990E-03_JPRB, 0.37094884E-03_JPRB, 0.37093618E-03_JPRB, 0.37092259E-03_JPRB, &
  & 0.37090859E-03_JPRB, 0.37089459E-03_JPRB, 0.37088105E-03_JPRB, 0.37086828E-03_JPRB, 0.37085681E-03_JPRB, 0.37084654E-03_JPRB, &
  & 0.37083728E-03_JPRB, 0.37082849E-03_JPRB, 0.37081982E-03_JPRB, 0.37081080E-03_JPRB, 0.37080151E-03_JPRB, 0.37079235E-03_JPRB, &
  & 0.37078361E-03_JPRB, 0.37077517E-03_JPRB, 0.37076618E-03_JPRB, 0.37075105E-03_JPRB /)

RGHG1(:,43,11) = (/ &
  & 0.37065963E-03_JPRB, 0.37067098E-03_JPRB, 0.37067884E-03_JPRB, 0.37068746E-03_JPRB, 0.37069828E-03_JPRB, 0.37071068E-03_JPRB, &
  & 0.37072311E-03_JPRB, 0.37073466E-03_JPRB, 0.37074517E-03_JPRB, 0.37075474E-03_JPRB, 0.37076380E-03_JPRB, 0.37077288E-03_JPRB, &
  & 0.37078292E-03_JPRB, 0.37079526E-03_JPRB, 0.37081167E-03_JPRB, 0.37083289E-03_JPRB, 0.37085838E-03_JPRB, 0.37088539E-03_JPRB, &
  & 0.37091057E-03_JPRB, 0.37093123E-03_JPRB, 0.37094680E-03_JPRB, 0.37095812E-03_JPRB, 0.37096633E-03_JPRB, 0.37097238E-03_JPRB, &
  & 0.37097704E-03_JPRB, 0.37098071E-03_JPRB, 0.37098367E-03_JPRB, 0.37098624E-03_JPRB, 0.37098833E-03_JPRB, 0.37099025E-03_JPRB, &
  & 0.37099162E-03_JPRB, 0.37099264E-03_JPRB, 0.37099322E-03_JPRB, 0.37099348E-03_JPRB, 0.37099340E-03_JPRB, 0.37099305E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099159E-03_JPRB, 0.37099037E-03_JPRB, 0.37098874E-03_JPRB, 0.37098644E-03_JPRB, 0.37098330E-03_JPRB, &
  & 0.37097908E-03_JPRB, 0.37097334E-03_JPRB, 0.37096569E-03_JPRB, 0.37095608E-03_JPRB, 0.37094476E-03_JPRB, 0.37093248E-03_JPRB, &
  & 0.37091953E-03_JPRB, 0.37090646E-03_JPRB, 0.37089366E-03_JPRB, 0.37088169E-03_JPRB, 0.37087104E-03_JPRB, 0.37086158E-03_JPRB, &
  & 0.37085338E-03_JPRB, 0.37084558E-03_JPRB, 0.37083789E-03_JPRB, 0.37082995E-03_JPRB, 0.37082174E-03_JPRB, 0.37081365E-03_JPRB, &
  & 0.37080579E-03_JPRB, 0.37079808E-03_JPRB, 0.37078970E-03_JPRB, 0.37077564E-03_JPRB /)

RGHG1(:,44,11) = (/ &
  & 0.37069881E-03_JPRB, 0.37070905E-03_JPRB, 0.37071615E-03_JPRB, 0.37072436E-03_JPRB, 0.37073466E-03_JPRB, 0.37074674E-03_JPRB, &
  & 0.37075829E-03_JPRB, 0.37076880E-03_JPRB, 0.37077803E-03_JPRB, 0.37078629E-03_JPRB, 0.37079395E-03_JPRB, 0.37080166E-03_JPRB, &
  & 0.37081010E-03_JPRB, 0.37082072E-03_JPRB, 0.37083481E-03_JPRB, 0.37085381E-03_JPRB, 0.37087704E-03_JPRB, 0.37090146E-03_JPRB, &
  & 0.37092343E-03_JPRB, 0.37094092E-03_JPRB, 0.37095370E-03_JPRB, 0.37096289E-03_JPRB, 0.37096970E-03_JPRB, 0.37097483E-03_JPRB, &
  & 0.37097890E-03_JPRB, 0.37098222E-03_JPRB, 0.37098484E-03_JPRB, 0.37098720E-03_JPRB, 0.37098926E-03_JPRB, 0.37099098E-03_JPRB, &
  & 0.37099229E-03_JPRB, 0.37099322E-03_JPRB, 0.37099377E-03_JPRB, 0.37099404E-03_JPRB, 0.37099395E-03_JPRB, 0.37099363E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099226E-03_JPRB, 0.37099118E-03_JPRB, 0.37098976E-03_JPRB, 0.37098775E-03_JPRB, 0.37098513E-03_JPRB, &
  & 0.37098170E-03_JPRB, 0.37097701E-03_JPRB, 0.37097067E-03_JPRB, 0.37096249E-03_JPRB, 0.37095248E-03_JPRB, 0.37094121E-03_JPRB, &
  & 0.37092963E-03_JPRB, 0.37091764E-03_JPRB, 0.37090588E-03_JPRB, 0.37089462E-03_JPRB, 0.37088478E-03_JPRB, 0.37087640E-03_JPRB, &
  & 0.37086901E-03_JPRB, 0.37086217E-03_JPRB, 0.37085538E-03_JPRB, 0.37084852E-03_JPRB, 0.37084124E-03_JPRB, 0.37083423E-03_JPRB, &
  & 0.37082756E-03_JPRB, 0.37082084E-03_JPRB, 0.37081342E-03_JPRB, 0.37080105E-03_JPRB /)

RGHG1(:,45,11) = (/ &
  & 0.37073487E-03_JPRB, 0.37074424E-03_JPRB, 0.37075096E-03_JPRB, 0.37075873E-03_JPRB, 0.37076895E-03_JPRB, 0.37078050E-03_JPRB, &
  & 0.37079165E-03_JPRB, 0.37080122E-03_JPRB, 0.37080946E-03_JPRB, 0.37081662E-03_JPRB, 0.37082314E-03_JPRB, 0.37082948E-03_JPRB, &
  & 0.37083661E-03_JPRB, 0.37084543E-03_JPRB, 0.37085754E-03_JPRB, 0.37087424E-03_JPRB, 0.37089488E-03_JPRB, 0.37091642E-03_JPRB, &
  & 0.37093490E-03_JPRB, 0.37094907E-03_JPRB, 0.37095931E-03_JPRB, 0.37096674E-03_JPRB, 0.37097247E-03_JPRB, 0.37097686E-03_JPRB, &
  & 0.37098039E-03_JPRB, 0.37098335E-03_JPRB, 0.37098583E-03_JPRB, 0.37098798E-03_JPRB, 0.37098996E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099372E-03_JPRB, 0.37099418E-03_JPRB, 0.37099450E-03_JPRB, 0.37099441E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099369E-03_JPRB, 0.37099290E-03_JPRB, 0.37099182E-03_JPRB, 0.37099051E-03_JPRB, 0.37098886E-03_JPRB, 0.37098676E-03_JPRB, &
  & 0.37098379E-03_JPRB, 0.37098001E-03_JPRB, 0.37097486E-03_JPRB, 0.37096802E-03_JPRB, 0.37095946E-03_JPRB, 0.37094954E-03_JPRB, &
  & 0.37093909E-03_JPRB, 0.37092817E-03_JPRB, 0.37091732E-03_JPRB, 0.37090722E-03_JPRB, 0.37089837E-03_JPRB, 0.37089089E-03_JPRB, &
  & 0.37088452E-03_JPRB, 0.37087852E-03_JPRB, 0.37087273E-03_JPRB, 0.37086674E-03_JPRB, 0.37086065E-03_JPRB, 0.37085474E-03_JPRB, &
  & 0.37084919E-03_JPRB, 0.37084369E-03_JPRB, 0.37083749E-03_JPRB, 0.37082695E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART22',0,ZHOOK_HANDLE)



RGHG1(:,46,11) = (/ &
  & 0.37076866E-03_JPRB, 0.37077756E-03_JPRB, 0.37078373E-03_JPRB, 0.37079133E-03_JPRB, 0.37080116E-03_JPRB, 0.37081269E-03_JPRB, &
  & 0.37082320E-03_JPRB, 0.37083213E-03_JPRB, 0.37083955E-03_JPRB, 0.37084561E-03_JPRB, 0.37085105E-03_JPRB, 0.37085632E-03_JPRB, &
  & 0.37086214E-03_JPRB, 0.37086947E-03_JPRB, 0.37087983E-03_JPRB, 0.37089406E-03_JPRB, 0.37091208E-03_JPRB, 0.37092983E-03_JPRB, &
  & 0.37094479E-03_JPRB, 0.37095582E-03_JPRB, 0.37096394E-03_JPRB, 0.37096994E-03_JPRB, 0.37097465E-03_JPRB, 0.37097844E-03_JPRB, &
  & 0.37098161E-03_JPRB, 0.37098437E-03_JPRB, 0.37098664E-03_JPRB, 0.37098877E-03_JPRB, 0.37099060E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099348E-03_JPRB, 0.37099430E-03_JPRB, 0.37099473E-03_JPRB, 0.37099505E-03_JPRB, 0.37099494E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099337E-03_JPRB, 0.37099243E-03_JPRB, 0.37099124E-03_JPRB, 0.37098982E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098551E-03_JPRB, 0.37098248E-03_JPRB, 0.37097826E-03_JPRB, 0.37097282E-03_JPRB, 0.37096580E-03_JPRB, 0.37095728E-03_JPRB, &
  & 0.37094785E-03_JPRB, 0.37093836E-03_JPRB, 0.37092867E-03_JPRB, 0.37091973E-03_JPRB, 0.37091202E-03_JPRB, 0.37090553E-03_JPRB, &
  & 0.37089988E-03_JPRB, 0.37089488E-03_JPRB, 0.37088987E-03_JPRB, 0.37088472E-03_JPRB, 0.37087963E-03_JPRB, 0.37087483E-03_JPRB, &
  & 0.37087032E-03_JPRB, 0.37086589E-03_JPRB, 0.37086094E-03_JPRB, 0.37085245E-03_JPRB /)

RGHG1(:,47,11) = (/ &
  & 0.37080067E-03_JPRB, 0.37080902E-03_JPRB, 0.37081511E-03_JPRB, 0.37082203E-03_JPRB, 0.37083184E-03_JPRB, 0.37084296E-03_JPRB, &
  & 0.37085314E-03_JPRB, 0.37086126E-03_JPRB, 0.37086775E-03_JPRB, 0.37087308E-03_JPRB, 0.37087768E-03_JPRB, 0.37088199E-03_JPRB, &
  & 0.37088670E-03_JPRB, 0.37089270E-03_JPRB, 0.37090105E-03_JPRB, 0.37091310E-03_JPRB, 0.37092762E-03_JPRB, 0.37094182E-03_JPRB, &
  & 0.37095306E-03_JPRB, 0.37096147E-03_JPRB, 0.37096770E-03_JPRB, 0.37097259E-03_JPRB, 0.37097652E-03_JPRB, 0.37097986E-03_JPRB, &
  & 0.37098266E-03_JPRB, 0.37098519E-03_JPRB, 0.37098740E-03_JPRB, 0.37098941E-03_JPRB, 0.37099124E-03_JPRB, 0.37099273E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099473E-03_JPRB, 0.37099514E-03_JPRB, 0.37099549E-03_JPRB, 0.37099526E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099383E-03_JPRB, 0.37099296E-03_JPRB, 0.37099177E-03_JPRB, 0.37099054E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098691E-03_JPRB, 0.37098449E-03_JPRB, 0.37098117E-03_JPRB, 0.37097686E-03_JPRB, 0.37097139E-03_JPRB, 0.37096444E-03_JPRB, &
  & 0.37095643E-03_JPRB, 0.37094794E-03_JPRB, 0.37093929E-03_JPRB, 0.37093170E-03_JPRB, 0.37092506E-03_JPRB, 0.37091968E-03_JPRB, &
  & 0.37091493E-03_JPRB, 0.37091059E-03_JPRB, 0.37090637E-03_JPRB, 0.37090207E-03_JPRB, 0.37089793E-03_JPRB, 0.37089401E-03_JPRB, &
  & 0.37089048E-03_JPRB, 0.37088708E-03_JPRB, 0.37088327E-03_JPRB, 0.37087654E-03_JPRB /)

RGHG1(:,48,11) = (/ &
  & 0.37083111E-03_JPRB, 0.37083909E-03_JPRB, 0.37084467E-03_JPRB, 0.37085163E-03_JPRB, 0.37086059E-03_JPRB, 0.37087151E-03_JPRB, &
  & 0.37088111E-03_JPRB, 0.37088868E-03_JPRB, 0.37089438E-03_JPRB, 0.37089881E-03_JPRB, 0.37090256E-03_JPRB, 0.37090597E-03_JPRB, &
  & 0.37090969E-03_JPRB, 0.37091447E-03_JPRB, 0.37092110E-03_JPRB, 0.37093036E-03_JPRB, 0.37094139E-03_JPRB, 0.37095166E-03_JPRB, &
  & 0.37095972E-03_JPRB, 0.37096592E-03_JPRB, 0.37097072E-03_JPRB, 0.37097468E-03_JPRB, 0.37097809E-03_JPRB, 0.37098103E-03_JPRB, &
  & 0.37098365E-03_JPRB, 0.37098600E-03_JPRB, 0.37098807E-03_JPRB, 0.37099005E-03_JPRB, 0.37099182E-03_JPRB, 0.37099325E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099520E-03_JPRB, 0.37099561E-03_JPRB, 0.37099590E-03_JPRB, 0.37099569E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099488E-03_JPRB, 0.37099427E-03_JPRB, 0.37099340E-03_JPRB, 0.37099229E-03_JPRB, 0.37099115E-03_JPRB, 0.37098982E-03_JPRB, &
  & 0.37098813E-03_JPRB, 0.37098615E-03_JPRB, 0.37098359E-03_JPRB, 0.37098036E-03_JPRB, 0.37097619E-03_JPRB, 0.37097093E-03_JPRB, &
  & 0.37096435E-03_JPRB, 0.37095725E-03_JPRB, 0.37095015E-03_JPRB, 0.37094348E-03_JPRB, 0.37093801E-03_JPRB, 0.37093344E-03_JPRB, &
  & 0.37092957E-03_JPRB, 0.37092587E-03_JPRB, 0.37092238E-03_JPRB, 0.37091889E-03_JPRB, 0.37091546E-03_JPRB, 0.37091237E-03_JPRB, &
  & 0.37090952E-03_JPRB, 0.37090687E-03_JPRB, 0.37090387E-03_JPRB, 0.37089855E-03_JPRB /)

RGHG1(:,49,11) = (/ &
  & 0.37086027E-03_JPRB, 0.37086781E-03_JPRB, 0.37087311E-03_JPRB, 0.37087940E-03_JPRB, 0.37088816E-03_JPRB, 0.37089843E-03_JPRB, &
  & 0.37090760E-03_JPRB, 0.37091441E-03_JPRB, 0.37091918E-03_JPRB, 0.37092279E-03_JPRB, 0.37092564E-03_JPRB, 0.37092826E-03_JPRB, &
  & 0.37093105E-03_JPRB, 0.37093437E-03_JPRB, 0.37093906E-03_JPRB, 0.37094526E-03_JPRB, 0.37095271E-03_JPRB, 0.37095949E-03_JPRB, &
  & 0.37096502E-03_JPRB, 0.37096953E-03_JPRB, 0.37097326E-03_JPRB, 0.37097649E-03_JPRB, 0.37097937E-03_JPRB, 0.37098204E-03_JPRB, &
  & 0.37098443E-03_JPRB, 0.37098670E-03_JPRB, 0.37098871E-03_JPRB, 0.37099060E-03_JPRB, 0.37099241E-03_JPRB, 0.37099377E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099564E-03_JPRB, 0.37099596E-03_JPRB, 0.37099625E-03_JPRB, 0.37099601E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099456E-03_JPRB, 0.37099369E-03_JPRB, 0.37099270E-03_JPRB, 0.37099171E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098746E-03_JPRB, 0.37098545E-03_JPRB, 0.37098303E-03_JPRB, 0.37098012E-03_JPRB, 0.37097634E-03_JPRB, &
  & 0.37097160E-03_JPRB, 0.37096615E-03_JPRB, 0.37096051E-03_JPRB, 0.37095527E-03_JPRB, 0.37095079E-03_JPRB, 0.37094706E-03_JPRB, &
  & 0.37094386E-03_JPRB, 0.37094072E-03_JPRB, 0.37093769E-03_JPRB, 0.37093472E-03_JPRB, 0.37093199E-03_JPRB, 0.37092945E-03_JPRB, &
  & 0.37092724E-03_JPRB, 0.37092518E-03_JPRB, 0.37092276E-03_JPRB, 0.37091839E-03_JPRB /)

RGHG1(:,50,11) = (/ &
  & 0.37088743E-03_JPRB, 0.37089456E-03_JPRB, 0.37089945E-03_JPRB, 0.37090533E-03_JPRB, 0.37091342E-03_JPRB, 0.37092311E-03_JPRB, &
  & 0.37093135E-03_JPRB, 0.37093722E-03_JPRB, 0.37094101E-03_JPRB, 0.37094369E-03_JPRB, 0.37094567E-03_JPRB, 0.37094732E-03_JPRB, &
  & 0.37094901E-03_JPRB, 0.37095111E-03_JPRB, 0.37095358E-03_JPRB, 0.37095719E-03_JPRB, 0.37096126E-03_JPRB, 0.37096548E-03_JPRB, &
  & 0.37096909E-03_JPRB, 0.37097241E-03_JPRB, 0.37097535E-03_JPRB, 0.37097800E-03_JPRB, 0.37098056E-03_JPRB, 0.37098298E-03_JPRB, &
  & 0.37098528E-03_JPRB, 0.37098746E-03_JPRB, 0.37098929E-03_JPRB, 0.37099121E-03_JPRB, 0.37099293E-03_JPRB, 0.37099427E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099599E-03_JPRB, 0.37099636E-03_JPRB, 0.37099654E-03_JPRB, 0.37099631E-03_JPRB, 0.37099596E-03_JPRB, &
  & 0.37099549E-03_JPRB, 0.37099488E-03_JPRB, 0.37099406E-03_JPRB, 0.37099313E-03_JPRB, 0.37099223E-03_JPRB, 0.37099118E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37098856E-03_JPRB, 0.37098693E-03_JPRB, 0.37098516E-03_JPRB, 0.37098315E-03_JPRB, 0.37098071E-03_JPRB, &
  & 0.37097765E-03_JPRB, 0.37097398E-03_JPRB, 0.37097011E-03_JPRB, 0.37096645E-03_JPRB, 0.37096313E-03_JPRB, 0.37096022E-03_JPRB, &
  & 0.37095754E-03_JPRB, 0.37095504E-03_JPRB, 0.37095250E-03_JPRB, 0.37095003E-03_JPRB, 0.37094770E-03_JPRB, 0.37094567E-03_JPRB, &
  & 0.37094386E-03_JPRB, 0.37094211E-03_JPRB, 0.37094008E-03_JPRB, 0.37093653E-03_JPRB /)

RGHG1(:,51,11) = (/ &
  & 0.37091228E-03_JPRB, 0.37091869E-03_JPRB, 0.37092311E-03_JPRB, 0.37092841E-03_JPRB, 0.37093565E-03_JPRB, 0.37094421E-03_JPRB, &
  & 0.37095108E-03_JPRB, 0.37095536E-03_JPRB, 0.37095792E-03_JPRB, 0.37095958E-03_JPRB, 0.37096062E-03_JPRB, 0.37096147E-03_JPRB, &
  & 0.37096225E-03_JPRB, 0.37096301E-03_JPRB, 0.37096415E-03_JPRB, 0.37096554E-03_JPRB, 0.37096761E-03_JPRB, 0.37096994E-03_JPRB, &
  & 0.37097230E-03_JPRB, 0.37097471E-03_JPRB, 0.37097704E-03_JPRB, 0.37097931E-03_JPRB, 0.37098158E-03_JPRB, 0.37098373E-03_JPRB, &
  & 0.37098589E-03_JPRB, 0.37098807E-03_JPRB, 0.37098993E-03_JPRB, 0.37099174E-03_JPRB, 0.37099342E-03_JPRB, 0.37099471E-03_JPRB, &
  & 0.37099558E-03_JPRB, 0.37099631E-03_JPRB, 0.37099663E-03_JPRB, 0.37099686E-03_JPRB, 0.37099660E-03_JPRB, 0.37099625E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099514E-03_JPRB, 0.37099433E-03_JPRB, 0.37099351E-03_JPRB, 0.37099264E-03_JPRB, 0.37099168E-03_JPRB, &
  & 0.37099054E-03_JPRB, 0.37098938E-03_JPRB, 0.37098816E-03_JPRB, 0.37098685E-03_JPRB, 0.37098551E-03_JPRB, 0.37098399E-03_JPRB, &
  & 0.37098222E-03_JPRB, 0.37098030E-03_JPRB, 0.37097803E-03_JPRB, 0.37097582E-03_JPRB, 0.37097378E-03_JPRB, 0.37097195E-03_JPRB, &
  & 0.37097011E-03_JPRB, 0.37096825E-03_JPRB, 0.37096636E-03_JPRB, 0.37096435E-03_JPRB, 0.37096252E-03_JPRB, 0.37096089E-03_JPRB, &
  & 0.37095946E-03_JPRB, 0.37095803E-03_JPRB, 0.37095635E-03_JPRB, 0.37095332E-03_JPRB /)

RGHG1(:,52,11) = (/ &
  & 0.37093324E-03_JPRB, 0.37093897E-03_JPRB, 0.37094275E-03_JPRB, 0.37094727E-03_JPRB, 0.37095335E-03_JPRB, 0.37096013E-03_JPRB, &
  & 0.37096470E-03_JPRB, 0.37096735E-03_JPRB, 0.37096872E-03_JPRB, 0.37096950E-03_JPRB, 0.37097000E-03_JPRB, 0.37097032E-03_JPRB, &
  & 0.37097058E-03_JPRB, 0.37097078E-03_JPRB, 0.37097093E-03_JPRB, 0.37097133E-03_JPRB, 0.37097212E-03_JPRB, 0.37097337E-03_JPRB, &
  & 0.37097483E-03_JPRB, 0.37097660E-03_JPRB, 0.37097849E-03_JPRB, 0.37098050E-03_JPRB, 0.37098254E-03_JPRB, 0.37098452E-03_JPRB, &
  & 0.37098659E-03_JPRB, 0.37098865E-03_JPRB, 0.37099046E-03_JPRB, 0.37099229E-03_JPRB, 0.37099389E-03_JPRB, 0.37099508E-03_JPRB, &
  & 0.37099590E-03_JPRB, 0.37099671E-03_JPRB, 0.37099695E-03_JPRB, 0.37099715E-03_JPRB, 0.37099689E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099604E-03_JPRB, 0.37099543E-03_JPRB, 0.37099465E-03_JPRB, 0.37099380E-03_JPRB, 0.37099299E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099113E-03_JPRB, 0.37099008E-03_JPRB, 0.37098912E-03_JPRB, 0.37098824E-03_JPRB, 0.37098723E-03_JPRB, 0.37098632E-03_JPRB, &
  & 0.37098548E-03_JPRB, 0.37098449E-03_JPRB, 0.37098347E-03_JPRB, 0.37098239E-03_JPRB, 0.37098135E-03_JPRB, 0.37098036E-03_JPRB, &
  & 0.37097937E-03_JPRB, 0.37097832E-03_JPRB, 0.37097704E-03_JPRB, 0.37097576E-03_JPRB, 0.37097442E-03_JPRB, 0.37097331E-03_JPRB, &
  & 0.37097232E-03_JPRB, 0.37097128E-03_JPRB, 0.37097000E-03_JPRB, 0.37096749E-03_JPRB /)

RGHG1(:,53,11) = (/ &
  & 0.37095003E-03_JPRB, 0.37095457E-03_JPRB, 0.37095771E-03_JPRB, 0.37096121E-03_JPRB, 0.37096572E-03_JPRB, 0.37097011E-03_JPRB, &
  & 0.37097291E-03_JPRB, 0.37097413E-03_JPRB, 0.37097477E-03_JPRB, 0.37097512E-03_JPRB, 0.37097529E-03_JPRB, 0.37097541E-03_JPRB, &
  & 0.37097547E-03_JPRB, 0.37097544E-03_JPRB, 0.37097535E-03_JPRB, 0.37097532E-03_JPRB, 0.37097544E-03_JPRB, 0.37097593E-03_JPRB, &
  & 0.37097681E-03_JPRB, 0.37097817E-03_JPRB, 0.37097972E-03_JPRB, 0.37098146E-03_JPRB, 0.37098335E-03_JPRB, 0.37098525E-03_JPRB, &
  & 0.37098720E-03_JPRB, 0.37098929E-03_JPRB, 0.37099107E-03_JPRB, 0.37099273E-03_JPRB, 0.37099433E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099700E-03_JPRB, 0.37099724E-03_JPRB, 0.37099741E-03_JPRB, 0.37099712E-03_JPRB, 0.37099680E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099567E-03_JPRB, 0.37099491E-03_JPRB, 0.37099409E-03_JPRB, 0.37099340E-03_JPRB, 0.37099252E-03_JPRB, &
  & 0.37099156E-03_JPRB, 0.37099066E-03_JPRB, 0.37098987E-03_JPRB, 0.37098926E-03_JPRB, 0.37098868E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098766E-03_JPRB, 0.37098728E-03_JPRB, 0.37098682E-03_JPRB, 0.37098632E-03_JPRB, 0.37098594E-03_JPRB, 0.37098548E-03_JPRB, &
  & 0.37098501E-03_JPRB, 0.37098437E-03_JPRB, 0.37098362E-03_JPRB, 0.37098280E-03_JPRB, 0.37098207E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37098091E-03_JPRB, 0.37098027E-03_JPRB, 0.37097954E-03_JPRB, 0.37097794E-03_JPRB /)

RGHG1(:,54,11) = (/ &
  & 0.37096208E-03_JPRB, 0.37096566E-03_JPRB, 0.37096784E-03_JPRB, 0.37097043E-03_JPRB, 0.37097337E-03_JPRB, 0.37097611E-03_JPRB, &
  & 0.37097753E-03_JPRB, 0.37097817E-03_JPRB, 0.37097844E-03_JPRB, 0.37097855E-03_JPRB, 0.37097861E-03_JPRB, 0.37097861E-03_JPRB, &
  & 0.37097861E-03_JPRB, 0.37097855E-03_JPRB, 0.37097838E-03_JPRB, 0.37097817E-03_JPRB, 0.37097803E-03_JPRB, 0.37097806E-03_JPRB, &
  & 0.37097858E-03_JPRB, 0.37097948E-03_JPRB, 0.37098088E-03_JPRB, 0.37098239E-03_JPRB, 0.37098420E-03_JPRB, 0.37098600E-03_JPRB, &
  & 0.37098789E-03_JPRB, 0.37098993E-03_JPRB, 0.37099153E-03_JPRB, 0.37099316E-03_JPRB, 0.37099462E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099724E-03_JPRB, 0.37099753E-03_JPRB, 0.37099764E-03_JPRB, 0.37099735E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099657E-03_JPRB, 0.37099599E-03_JPRB, 0.37099532E-03_JPRB, 0.37099447E-03_JPRB, 0.37099369E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099124E-03_JPRB, 0.37099060E-03_JPRB, 0.37099016E-03_JPRB, 0.37098982E-03_JPRB, 0.37098947E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098906E-03_JPRB, 0.37098886E-03_JPRB, 0.37098862E-03_JPRB, 0.37098845E-03_JPRB, 0.37098827E-03_JPRB, &
  & 0.37098798E-03_JPRB, 0.37098766E-03_JPRB, 0.37098728E-03_JPRB, 0.37098688E-03_JPRB, 0.37098641E-03_JPRB, 0.37098612E-03_JPRB, &
  & 0.37098580E-03_JPRB, 0.37098548E-03_JPRB, 0.37098522E-03_JPRB, 0.37098484E-03_JPRB /)

RGHG1(:,55,11) = (/ &
  & 0.37097052E-03_JPRB, 0.37097288E-03_JPRB, 0.37097462E-03_JPRB, 0.37097619E-03_JPRB, 0.37097814E-03_JPRB, 0.37097972E-03_JPRB, &
  & 0.37098050E-03_JPRB, 0.37098076E-03_JPRB, 0.37098088E-03_JPRB, 0.37098088E-03_JPRB, 0.37098088E-03_JPRB, 0.37098088E-03_JPRB, &
  & 0.37098082E-03_JPRB, 0.37098076E-03_JPRB, 0.37098059E-03_JPRB, 0.37098039E-03_JPRB, 0.37098007E-03_JPRB, 0.37097986E-03_JPRB, &
  & 0.37098007E-03_JPRB, 0.37098076E-03_JPRB, 0.37098193E-03_JPRB, 0.37098333E-03_JPRB, 0.37098498E-03_JPRB, 0.37098664E-03_JPRB, &
  & 0.37098856E-03_JPRB, 0.37099043E-03_JPRB, 0.37099209E-03_JPRB, 0.37099354E-03_JPRB, 0.37099500E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099756E-03_JPRB, 0.37099770E-03_JPRB, 0.37099788E-03_JPRB, 0.37099759E-03_JPRB, 0.37099727E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099628E-03_JPRB, 0.37099555E-03_JPRB, 0.37099476E-03_JPRB, 0.37099412E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099249E-03_JPRB, 0.37099177E-03_JPRB, 0.37099127E-03_JPRB, 0.37099092E-03_JPRB, 0.37099069E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099043E-03_JPRB, 0.37099031E-03_JPRB, 0.37099019E-03_JPRB, 0.37099008E-03_JPRB, 0.37098996E-03_JPRB, 0.37098987E-03_JPRB, &
  & 0.37098976E-03_JPRB, 0.37098961E-03_JPRB, 0.37098938E-03_JPRB, 0.37098909E-03_JPRB, 0.37098880E-03_JPRB, 0.37098856E-03_JPRB, &
  & 0.37098839E-03_JPRB, 0.37098827E-03_JPRB, 0.37098810E-03_JPRB, 0.37098772E-03_JPRB /)

RGHG1(:,56,11) = (/ &
  & 0.37097608E-03_JPRB, 0.37097780E-03_JPRB, 0.37097890E-03_JPRB, 0.37097989E-03_JPRB, 0.37098111E-03_JPRB, 0.37098207E-03_JPRB, &
  & 0.37098251E-03_JPRB, 0.37098263E-03_JPRB, 0.37098260E-03_JPRB, 0.37098257E-03_JPRB, 0.37098257E-03_JPRB, 0.37098260E-03_JPRB, &
  & 0.37098257E-03_JPRB, 0.37098248E-03_JPRB, 0.37098236E-03_JPRB, 0.37098210E-03_JPRB, 0.37098175E-03_JPRB, 0.37098143E-03_JPRB, &
  & 0.37098140E-03_JPRB, 0.37098193E-03_JPRB, 0.37098295E-03_JPRB, 0.37098431E-03_JPRB, 0.37098586E-03_JPRB, 0.37098737E-03_JPRB, &
  & 0.37098920E-03_JPRB, 0.37099098E-03_JPRB, 0.37099255E-03_JPRB, 0.37099401E-03_JPRB, 0.37099537E-03_JPRB, 0.37099639E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099782E-03_JPRB, 0.37099796E-03_JPRB, 0.37099817E-03_JPRB, 0.37099776E-03_JPRB, 0.37099750E-03_JPRB, &
  & 0.37099709E-03_JPRB, 0.37099654E-03_JPRB, 0.37099590E-03_JPRB, 0.37099514E-03_JPRB, 0.37099441E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099229E-03_JPRB, 0.37099185E-03_JPRB, 0.37099162E-03_JPRB, 0.37099156E-03_JPRB, 0.37099147E-03_JPRB, &
  & 0.37099136E-03_JPRB, 0.37099130E-03_JPRB, 0.37099124E-03_JPRB, 0.37099115E-03_JPRB, 0.37099113E-03_JPRB, 0.37099101E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099078E-03_JPRB, 0.37099060E-03_JPRB, 0.37099043E-03_JPRB, 0.37099028E-03_JPRB, 0.37099019E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37098996E-03_JPRB, 0.37098987E-03_JPRB, 0.37098973E-03_JPRB /)

RGHG1(:,57,11) = (/ &
  & 0.37097986E-03_JPRB, 0.37098114E-03_JPRB, 0.37098181E-03_JPRB, 0.37098257E-03_JPRB, 0.37098330E-03_JPRB, 0.37098379E-03_JPRB, &
  & 0.37098408E-03_JPRB, 0.37098414E-03_JPRB, 0.37098414E-03_JPRB, 0.37098411E-03_JPRB, 0.37098408E-03_JPRB, 0.37098408E-03_JPRB, &
  & 0.37098405E-03_JPRB, 0.37098402E-03_JPRB, 0.37098388E-03_JPRB, 0.37098365E-03_JPRB, 0.37098327E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098274E-03_JPRB, 0.37098315E-03_JPRB, 0.37098399E-03_JPRB, 0.37098519E-03_JPRB, 0.37098664E-03_JPRB, 0.37098810E-03_JPRB, &
  & 0.37098982E-03_JPRB, 0.37099159E-03_JPRB, 0.37099316E-03_JPRB, 0.37099450E-03_JPRB, 0.37099575E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099814E-03_JPRB, 0.37099817E-03_JPRB, 0.37099831E-03_JPRB, 0.37099802E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099674E-03_JPRB, 0.37099610E-03_JPRB, 0.37099526E-03_JPRB, 0.37099465E-03_JPRB, 0.37099389E-03_JPRB, &
  & 0.37099328E-03_JPRB, 0.37099273E-03_JPRB, 0.37099241E-03_JPRB, 0.37099229E-03_JPRB, 0.37099223E-03_JPRB, 0.37099223E-03_JPRB, &
  & 0.37099217E-03_JPRB, 0.37099217E-03_JPRB, 0.37099217E-03_JPRB, 0.37099211E-03_JPRB, 0.37099206E-03_JPRB, 0.37099200E-03_JPRB, &
  & 0.37099191E-03_JPRB, 0.37099182E-03_JPRB, 0.37099174E-03_JPRB, 0.37099159E-03_JPRB, 0.37099147E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099118E-03_JPRB, 0.37099110E-03_JPRB, 0.37099089E-03_JPRB /)

RGHG1(:,58,11) = (/ &
  & 0.37098303E-03_JPRB, 0.37098362E-03_JPRB, 0.37098399E-03_JPRB, 0.37098443E-03_JPRB, 0.37098484E-03_JPRB, 0.37098513E-03_JPRB, &
  & 0.37098530E-03_JPRB, 0.37098536E-03_JPRB, 0.37098539E-03_JPRB, 0.37098539E-03_JPRB, 0.37098539E-03_JPRB, 0.37098542E-03_JPRB, &
  & 0.37098542E-03_JPRB, 0.37098536E-03_JPRB, 0.37098525E-03_JPRB, 0.37098498E-03_JPRB, 0.37098461E-03_JPRB, 0.37098417E-03_JPRB, &
  & 0.37098397E-03_JPRB, 0.37098423E-03_JPRB, 0.37098498E-03_JPRB, 0.37098603E-03_JPRB, 0.37098731E-03_JPRB, 0.37098877E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37099217E-03_JPRB, 0.37099366E-03_JPRB, 0.37099485E-03_JPRB, 0.37099607E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099837E-03_JPRB, 0.37099834E-03_JPRB, 0.37099852E-03_JPRB, 0.37099828E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099750E-03_JPRB, 0.37099706E-03_JPRB, 0.37099628E-03_JPRB, 0.37099555E-03_JPRB, 0.37099500E-03_JPRB, 0.37099436E-03_JPRB, &
  & 0.37099372E-03_JPRB, 0.37099325E-03_JPRB, 0.37099305E-03_JPRB, 0.37099284E-03_JPRB, 0.37099290E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099293E-03_JPRB, 0.37099287E-03_JPRB, 0.37099287E-03_JPRB, 0.37099281E-03_JPRB, 0.37099276E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099264E-03_JPRB, 0.37099261E-03_JPRB, 0.37099255E-03_JPRB, 0.37099241E-03_JPRB, 0.37099229E-03_JPRB, 0.37099220E-03_JPRB, &
  & 0.37099211E-03_JPRB, 0.37099209E-03_JPRB, 0.37099206E-03_JPRB, 0.37099194E-03_JPRB /)

RGHG1(:,59,11) = (/ &
  & 0.37098481E-03_JPRB, 0.37098530E-03_JPRB, 0.37098557E-03_JPRB, 0.37098580E-03_JPRB, 0.37098618E-03_JPRB, 0.37098641E-03_JPRB, &
  & 0.37098653E-03_JPRB, 0.37098661E-03_JPRB, 0.37098661E-03_JPRB, 0.37098661E-03_JPRB, 0.37098659E-03_JPRB, 0.37098656E-03_JPRB, &
  & 0.37098647E-03_JPRB, 0.37098635E-03_JPRB, 0.37098621E-03_JPRB, 0.37098606E-03_JPRB, 0.37098571E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098513E-03_JPRB, 0.37098530E-03_JPRB, 0.37098594E-03_JPRB, 0.37098693E-03_JPRB, 0.37098810E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37099104E-03_JPRB, 0.37099276E-03_JPRB, 0.37099409E-03_JPRB, 0.37099526E-03_JPRB, 0.37099642E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099866E-03_JPRB, 0.37099855E-03_JPRB, 0.37099875E-03_JPRB, 0.37099846E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099727E-03_JPRB, 0.37099657E-03_JPRB, 0.37099593E-03_JPRB, 0.37099526E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099412E-03_JPRB, 0.37099374E-03_JPRB, 0.37099357E-03_JPRB, 0.37099345E-03_JPRB, 0.37099351E-03_JPRB, 0.37099351E-03_JPRB, &
  & 0.37099351E-03_JPRB, 0.37099351E-03_JPRB, 0.37099351E-03_JPRB, 0.37099340E-03_JPRB, 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, &
  & 0.37099322E-03_JPRB, 0.37099316E-03_JPRB, 0.37099305E-03_JPRB, 0.37099293E-03_JPRB, 0.37099287E-03_JPRB, 0.37099287E-03_JPRB, &
  & 0.37099284E-03_JPRB, 0.37099276E-03_JPRB, 0.37099267E-03_JPRB, 0.37099249E-03_JPRB /)

RGHG1(:,60,11) = (/ &
  & 0.37098638E-03_JPRB, 0.37098676E-03_JPRB, 0.37098693E-03_JPRB, 0.37098705E-03_JPRB, 0.37098728E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098746E-03_JPRB, 0.37098749E-03_JPRB, 0.37098755E-03_JPRB, 0.37098757E-03_JPRB, 0.37098757E-03_JPRB, 0.37098757E-03_JPRB, &
  & 0.37098763E-03_JPRB, 0.37098763E-03_JPRB, 0.37098760E-03_JPRB, 0.37098746E-03_JPRB, 0.37098696E-03_JPRB, 0.37098653E-03_JPRB, &
  & 0.37098621E-03_JPRB, 0.37098635E-03_JPRB, 0.37098688E-03_JPRB, 0.37098781E-03_JPRB, 0.37098888E-03_JPRB, 0.37099022E-03_JPRB, &
  & 0.37099165E-03_JPRB, 0.37099325E-03_JPRB, 0.37099453E-03_JPRB, 0.37099575E-03_JPRB, 0.37099677E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099884E-03_JPRB, 0.37099872E-03_JPRB, 0.37099901E-03_JPRB, 0.37099866E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37099759E-03_JPRB, 0.37099689E-03_JPRB, 0.37099628E-03_JPRB, 0.37099564E-03_JPRB, 0.37099503E-03_JPRB, &
  & 0.37099447E-03_JPRB, 0.37099421E-03_JPRB, 0.37099412E-03_JPRB, 0.37099398E-03_JPRB, 0.37099409E-03_JPRB, 0.37099418E-03_JPRB, &
  & 0.37099418E-03_JPRB, 0.37099415E-03_JPRB, 0.37099412E-03_JPRB, 0.37099409E-03_JPRB, 0.37099406E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099386E-03_JPRB, 0.37099374E-03_JPRB, 0.37099363E-03_JPRB, 0.37099351E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, 0.37099322E-03_JPRB, 0.37099313E-03_JPRB /)

RGHG1(:,61,11) = (/ &
  & 0.37098760E-03_JPRB, 0.37098787E-03_JPRB, 0.37098804E-03_JPRB, 0.37098816E-03_JPRB, 0.37098827E-03_JPRB, 0.37098836E-03_JPRB, &
  & 0.37098839E-03_JPRB, 0.37098845E-03_JPRB, 0.37098845E-03_JPRB, 0.37098845E-03_JPRB, 0.37098848E-03_JPRB, 0.37098845E-03_JPRB, &
  & 0.37098839E-03_JPRB, 0.37098833E-03_JPRB, 0.37098833E-03_JPRB, 0.37098816E-03_JPRB, 0.37098775E-03_JPRB, 0.37098760E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098737E-03_JPRB, 0.37098781E-03_JPRB, 0.37098868E-03_JPRB, 0.37098979E-03_JPRB, 0.37099098E-03_JPRB, &
  & 0.37099235E-03_JPRB, 0.37099377E-03_JPRB, 0.37099505E-03_JPRB, 0.37099607E-03_JPRB, 0.37099718E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099852E-03_JPRB, 0.37099910E-03_JPRB, 0.37099904E-03_JPRB, 0.37099925E-03_JPRB, 0.37099890E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099776E-03_JPRB, 0.37099718E-03_JPRB, 0.37099660E-03_JPRB, 0.37099599E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099491E-03_JPRB, 0.37099468E-03_JPRB, 0.37099459E-03_JPRB, 0.37099450E-03_JPRB, 0.37099462E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099465E-03_JPRB, 0.37099468E-03_JPRB, 0.37099468E-03_JPRB, 0.37099462E-03_JPRB, 0.37099459E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099438E-03_JPRB, 0.37099427E-03_JPRB, 0.37099415E-03_JPRB, 0.37099406E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099392E-03_JPRB, 0.37099386E-03_JPRB, 0.37099383E-03_JPRB, 0.37099372E-03_JPRB /)

RGHG1(:,62,11) = (/ &
  & 0.37098865E-03_JPRB, 0.37098880E-03_JPRB, 0.37098891E-03_JPRB, 0.37098897E-03_JPRB, 0.37098915E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098926E-03_JPRB, 0.37098935E-03_JPRB, 0.37098938E-03_JPRB, 0.37098938E-03_JPRB, 0.37098938E-03_JPRB, 0.37098950E-03_JPRB, &
  & 0.37098955E-03_JPRB, 0.37098961E-03_JPRB, 0.37098964E-03_JPRB, 0.37098955E-03_JPRB, 0.37098912E-03_JPRB, 0.37098862E-03_JPRB, &
  & 0.37098845E-03_JPRB, 0.37098845E-03_JPRB, 0.37098874E-03_JPRB, 0.37098955E-03_JPRB, 0.37099066E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099430E-03_JPRB, 0.37099549E-03_JPRB, 0.37099654E-03_JPRB, 0.37099747E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099927E-03_JPRB, 0.37099933E-03_JPRB, 0.37099948E-03_JPRB, 0.37099919E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099855E-03_JPRB, 0.37099805E-03_JPRB, 0.37099750E-03_JPRB, 0.37099689E-03_JPRB, 0.37099625E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099517E-03_JPRB, 0.37099514E-03_JPRB, 0.37099505E-03_JPRB, 0.37099514E-03_JPRB, 0.37099526E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099517E-03_JPRB, 0.37099514E-03_JPRB, 0.37099503E-03_JPRB, 0.37099497E-03_JPRB, 0.37099479E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099468E-03_JPRB, 0.37099462E-03_JPRB, 0.37099456E-03_JPRB, 0.37099450E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099438E-03_JPRB, 0.37099433E-03_JPRB, 0.37099427E-03_JPRB, 0.37099415E-03_JPRB /)

RGHG1(:,63,11) = (/ &
  & 0.37098961E-03_JPRB, 0.37098979E-03_JPRB, 0.37098984E-03_JPRB, 0.37098990E-03_JPRB, 0.37099002E-03_JPRB, 0.37099002E-03_JPRB, &
  & 0.37099008E-03_JPRB, 0.37099014E-03_JPRB, 0.37099019E-03_JPRB, 0.37099025E-03_JPRB, 0.37099034E-03_JPRB, 0.37099043E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37099057E-03_JPRB, 0.37099048E-03_JPRB, 0.37099019E-03_JPRB, 0.37098976E-03_JPRB, 0.37098961E-03_JPRB, &
  & 0.37098952E-03_JPRB, 0.37098944E-03_JPRB, 0.37098979E-03_JPRB, 0.37099048E-03_JPRB, 0.37099142E-03_JPRB, 0.37099246E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099500E-03_JPRB, 0.37099601E-03_JPRB, 0.37099695E-03_JPRB, 0.37099779E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099942E-03_JPRB, 0.37099951E-03_JPRB, 0.37099968E-03_JPRB, 0.37099936E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099826E-03_JPRB, 0.37099785E-03_JPRB, 0.37099730E-03_JPRB, 0.37099668E-03_JPRB, 0.37099616E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099561E-03_JPRB, 0.37099561E-03_JPRB, 0.37099549E-03_JPRB, 0.37099558E-03_JPRB, 0.37099572E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099567E-03_JPRB, 0.37099564E-03_JPRB, 0.37099558E-03_JPRB, 0.37099543E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099508E-03_JPRB, 0.37099497E-03_JPRB, 0.37099491E-03_JPRB, 0.37099491E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099471E-03_JPRB, 0.37099462E-03_JPRB, 0.37099450E-03_JPRB /)

RGHG1(:,64,11) = (/ &
  & 0.37099048E-03_JPRB, 0.37099060E-03_JPRB, 0.37099066E-03_JPRB, 0.37099066E-03_JPRB, 0.37099081E-03_JPRB, 0.37099081E-03_JPRB, &
  & 0.37099089E-03_JPRB, 0.37099092E-03_JPRB, 0.37099092E-03_JPRB, 0.37099101E-03_JPRB, 0.37099113E-03_JPRB, 0.37099130E-03_JPRB, &
  & 0.37099150E-03_JPRB, 0.37099162E-03_JPRB, 0.37099159E-03_JPRB, 0.37099147E-03_JPRB, 0.37099113E-03_JPRB, 0.37099063E-03_JPRB, &
  & 0.37099043E-03_JPRB, 0.37099048E-03_JPRB, 0.37099075E-03_JPRB, 0.37099139E-03_JPRB, 0.37099229E-03_JPRB, 0.37099322E-03_JPRB, &
  & 0.37099441E-03_JPRB, 0.37099552E-03_JPRB, 0.37099654E-03_JPRB, 0.37099732E-03_JPRB, 0.37099811E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099965E-03_JPRB, 0.37099974E-03_JPRB, 0.37099989E-03_JPRB, 0.37099962E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099849E-03_JPRB, 0.37099811E-03_JPRB, 0.37099759E-03_JPRB, 0.37099703E-03_JPRB, 0.37099648E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099599E-03_JPRB, 0.37099604E-03_JPRB, 0.37099596E-03_JPRB, 0.37099604E-03_JPRB, 0.37099616E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099619E-03_JPRB, 0.37099610E-03_JPRB, 0.37099601E-03_JPRB, 0.37099593E-03_JPRB, 0.37099575E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099549E-03_JPRB, 0.37099537E-03_JPRB, 0.37099532E-03_JPRB, 0.37099523E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099514E-03_JPRB, 0.37099511E-03_JPRB, 0.37099503E-03_JPRB, 0.37099485E-03_JPRB /)

RGHG1(:,65,11) = (/ &
  & 0.37099121E-03_JPRB, 0.37099142E-03_JPRB, 0.37099142E-03_JPRB, 0.37099153E-03_JPRB, 0.37099159E-03_JPRB, 0.37099165E-03_JPRB, &
  & 0.37099171E-03_JPRB, 0.37099171E-03_JPRB, 0.37099171E-03_JPRB, 0.37099182E-03_JPRB, 0.37099191E-03_JPRB, 0.37099209E-03_JPRB, &
  & 0.37099235E-03_JPRB, 0.37099261E-03_JPRB, 0.37099241E-03_JPRB, 0.37099214E-03_JPRB, 0.37099182E-03_JPRB, 0.37099171E-03_JPRB, &
  & 0.37099153E-03_JPRB, 0.37099142E-03_JPRB, 0.37099177E-03_JPRB, 0.37099226E-03_JPRB, 0.37099302E-03_JPRB, 0.37099398E-03_JPRB, &
  & 0.37099505E-03_JPRB, 0.37099616E-03_JPRB, 0.37099700E-03_JPRB, 0.37099788E-03_JPRB, 0.37099852E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099977E-03_JPRB, 0.37099991E-03_JPRB, 0.37100015E-03_JPRB, 0.37099991E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099875E-03_JPRB, 0.37099837E-03_JPRB, 0.37099788E-03_JPRB, 0.37099738E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099642E-03_JPRB, 0.37099648E-03_JPRB, 0.37099645E-03_JPRB, 0.37099651E-03_JPRB, 0.37099657E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099671E-03_JPRB, 0.37099665E-03_JPRB, 0.37099654E-03_JPRB, 0.37099642E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099601E-03_JPRB, 0.37099590E-03_JPRB, 0.37099578E-03_JPRB, 0.37099567E-03_JPRB, 0.37099567E-03_JPRB, 0.37099555E-03_JPRB, &
  & 0.37099552E-03_JPRB, 0.37099543E-03_JPRB, 0.37099532E-03_JPRB, 0.37099505E-03_JPRB /)

RGHG1(:,66,11) = (/ &
  & 0.37099188E-03_JPRB, 0.37099209E-03_JPRB, 0.37099211E-03_JPRB, 0.37099226E-03_JPRB, 0.37099235E-03_JPRB, 0.37099241E-03_JPRB, &
  & 0.37099243E-03_JPRB, 0.37099241E-03_JPRB, 0.37099241E-03_JPRB, 0.37099258E-03_JPRB, 0.37099270E-03_JPRB, 0.37099284E-03_JPRB, &
  & 0.37099316E-03_JPRB, 0.37099348E-03_JPRB, 0.37099310E-03_JPRB, 0.37099319E-03_JPRB, 0.37099302E-03_JPRB, 0.37099258E-03_JPRB, &
  & 0.37099241E-03_JPRB, 0.37099246E-03_JPRB, 0.37099276E-03_JPRB, 0.37099328E-03_JPRB, 0.37099389E-03_JPRB, 0.37099465E-03_JPRB, &
  & 0.37099567E-03_JPRB, 0.37099665E-03_JPRB, 0.37099750E-03_JPRB, 0.37099826E-03_JPRB, 0.37099884E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099994E-03_JPRB, 0.37100012E-03_JPRB, 0.37100032E-03_JPRB, 0.37100009E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099895E-03_JPRB, 0.37099872E-03_JPRB, 0.37099828E-03_JPRB, 0.37099794E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099706E-03_JPRB, 0.37099692E-03_JPRB, 0.37099692E-03_JPRB, 0.37099686E-03_JPRB, 0.37099703E-03_JPRB, 0.37099698E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099715E-03_JPRB, 0.37099712E-03_JPRB, 0.37099706E-03_JPRB, 0.37099689E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099645E-03_JPRB, 0.37099631E-03_JPRB, 0.37099619E-03_JPRB, 0.37099601E-03_JPRB, 0.37099593E-03_JPRB, 0.37099584E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099567E-03_JPRB, 0.37099549E-03_JPRB, 0.37099526E-03_JPRB /)

RGHG1(:,67,11) = (/ &
  & 0.37099258E-03_JPRB, 0.37099281E-03_JPRB, 0.37099287E-03_JPRB, 0.37099305E-03_JPRB, 0.37099305E-03_JPRB, 0.37099313E-03_JPRB, &
  & 0.37099313E-03_JPRB, 0.37099310E-03_JPRB, 0.37099310E-03_JPRB, 0.37099342E-03_JPRB, 0.37099348E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099444E-03_JPRB, 0.37099406E-03_JPRB, 0.37099401E-03_JPRB, 0.37099374E-03_JPRB, 0.37099369E-03_JPRB, &
  & 0.37099351E-03_JPRB, 0.37099345E-03_JPRB, 0.37099374E-03_JPRB, 0.37099412E-03_JPRB, 0.37099465E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099636E-03_JPRB, 0.37099718E-03_JPRB, 0.37099794E-03_JPRB, 0.37099866E-03_JPRB, 0.37099916E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100021E-03_JPRB, 0.37100035E-03_JPRB, 0.37100044E-03_JPRB, 0.37100018E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099965E-03_JPRB, 0.37099919E-03_JPRB, 0.37099898E-03_JPRB, 0.37099852E-03_JPRB, 0.37099820E-03_JPRB, 0.37099776E-03_JPRB, &
  & 0.37099747E-03_JPRB, 0.37099735E-03_JPRB, 0.37099735E-03_JPRB, 0.37099732E-03_JPRB, 0.37099750E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099762E-03_JPRB, 0.37099759E-03_JPRB, 0.37099750E-03_JPRB, 0.37099735E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099668E-03_JPRB, 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, 0.37099619E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099599E-03_JPRB, 0.37099584E-03_JPRB, 0.37099546E-03_JPRB /)

RGHG1(:,68,11) = (/ &
  & 0.37099313E-03_JPRB, 0.37099345E-03_JPRB, 0.37099363E-03_JPRB, 0.37099374E-03_JPRB, 0.37099377E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099383E-03_JPRB, 0.37099383E-03_JPRB, 0.37099383E-03_JPRB, 0.37099409E-03_JPRB, 0.37099430E-03_JPRB, 0.37099459E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099532E-03_JPRB, 0.37099473E-03_JPRB, 0.37099491E-03_JPRB, 0.37099468E-03_JPRB, 0.37099453E-03_JPRB, &
  & 0.37099433E-03_JPRB, 0.37099438E-03_JPRB, 0.37099462E-03_JPRB, 0.37099500E-03_JPRB, 0.37099546E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099689E-03_JPRB, 0.37099767E-03_JPRB, 0.37099837E-03_JPRB, 0.37099904E-03_JPRB, 0.37099939E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37100041E-03_JPRB, 0.37100053E-03_JPRB, 0.37100058E-03_JPRB, 0.37100035E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099951E-03_JPRB, 0.37099922E-03_JPRB, 0.37099878E-03_JPRB, 0.37099855E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099776E-03_JPRB, 0.37099776E-03_JPRB, 0.37099779E-03_JPRB, 0.37099785E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099811E-03_JPRB, 0.37099799E-03_JPRB, 0.37099805E-03_JPRB, 0.37099779E-03_JPRB, 0.37099750E-03_JPRB, &
  & 0.37099735E-03_JPRB, 0.37099712E-03_JPRB, 0.37099686E-03_JPRB, 0.37099671E-03_JPRB, 0.37099668E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099631E-03_JPRB, 0.37099607E-03_JPRB, 0.37099572E-03_JPRB /)

RGHG1(:,69,11) = (/ &
  & 0.37099377E-03_JPRB, 0.37099412E-03_JPRB, 0.37099427E-03_JPRB, 0.37099441E-03_JPRB, 0.37099447E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099450E-03_JPRB, 0.37099459E-03_JPRB, 0.37099494E-03_JPRB, 0.37099508E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099628E-03_JPRB, 0.37099543E-03_JPRB, 0.37099567E-03_JPRB, 0.37099535E-03_JPRB, 0.37099540E-03_JPRB, &
  & 0.37099535E-03_JPRB, 0.37099535E-03_JPRB, 0.37099558E-03_JPRB, 0.37099584E-03_JPRB, 0.37099613E-03_JPRB, 0.37099668E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099823E-03_JPRB, 0.37099875E-03_JPRB, 0.37099930E-03_JPRB, 0.37099959E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100061E-03_JPRB, 0.37100079E-03_JPRB, 0.37100061E-03_JPRB, 0.37100041E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, 0.37099904E-03_JPRB, 0.37099890E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099820E-03_JPRB, 0.37099820E-03_JPRB, 0.37099820E-03_JPRB, 0.37099826E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099852E-03_JPRB, 0.37099846E-03_JPRB, 0.37099852E-03_JPRB, 0.37099820E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099773E-03_JPRB, 0.37099756E-03_JPRB, 0.37099727E-03_JPRB, 0.37099715E-03_JPRB, 0.37099706E-03_JPRB, 0.37099689E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099663E-03_JPRB, 0.37099633E-03_JPRB, 0.37099599E-03_JPRB /)

RGHG1(:,70,11) = (/ &
  & 0.37099433E-03_JPRB, 0.37099479E-03_JPRB, 0.37099500E-03_JPRB, 0.37099520E-03_JPRB, 0.37099520E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099532E-03_JPRB, 0.37099540E-03_JPRB, 0.37099572E-03_JPRB, 0.37099575E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099721E-03_JPRB, 0.37099616E-03_JPRB, 0.37099657E-03_JPRB, 0.37099610E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099607E-03_JPRB, 0.37099622E-03_JPRB, 0.37099654E-03_JPRB, 0.37099663E-03_JPRB, 0.37099683E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099875E-03_JPRB, 0.37099913E-03_JPRB, 0.37099957E-03_JPRB, 0.37099980E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100076E-03_JPRB, 0.37100082E-03_JPRB, 0.37100090E-03_JPRB, 0.37100061E-03_JPRB, 0.37100050E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099991E-03_JPRB, 0.37099974E-03_JPRB, 0.37099936E-03_JPRB, 0.37099922E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099866E-03_JPRB, 0.37099860E-03_JPRB, 0.37099869E-03_JPRB, 0.37099863E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099898E-03_JPRB, 0.37099875E-03_JPRB, 0.37099898E-03_JPRB, 0.37099858E-03_JPRB, 0.37099831E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099794E-03_JPRB, 0.37099764E-03_JPRB, 0.37099759E-03_JPRB, 0.37099750E-03_JPRB, 0.37099732E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099698E-03_JPRB, 0.37099668E-03_JPRB, 0.37099628E-03_JPRB /)

RGHG1(:,71,11) = (/ &
  & 0.37099485E-03_JPRB, 0.37099549E-03_JPRB, 0.37099575E-03_JPRB, 0.37099601E-03_JPRB, 0.37099596E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099601E-03_JPRB, 0.37099619E-03_JPRB, 0.37099642E-03_JPRB, 0.37099636E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099823E-03_JPRB, 0.37099645E-03_JPRB, 0.37099730E-03_JPRB, 0.37099686E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099692E-03_JPRB, 0.37099700E-03_JPRB, 0.37099747E-03_JPRB, 0.37099753E-03_JPRB, 0.37099750E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099919E-03_JPRB, 0.37099948E-03_JPRB, 0.37099986E-03_JPRB, 0.37100000E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100105E-03_JPRB, 0.37100114E-03_JPRB, 0.37100061E-03_JPRB, 0.37100055E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100012E-03_JPRB, 0.37100009E-03_JPRB, 0.37099968E-03_JPRB, 0.37099959E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099898E-03_JPRB, 0.37099898E-03_JPRB, 0.37099916E-03_JPRB, 0.37099904E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099942E-03_JPRB, 0.37099916E-03_JPRB, 0.37099954E-03_JPRB, 0.37099907E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099831E-03_JPRB, 0.37099805E-03_JPRB, 0.37099805E-03_JPRB, 0.37099788E-03_JPRB, 0.37099770E-03_JPRB, &
  & 0.37099753E-03_JPRB, 0.37099741E-03_JPRB, 0.37099712E-03_JPRB, 0.37099671E-03_JPRB /)

RGHG1(:,72,11) = (/ &
  & 0.37099540E-03_JPRB, 0.37099616E-03_JPRB, 0.37099654E-03_JPRB, 0.37099674E-03_JPRB, 0.37099665E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099671E-03_JPRB, 0.37099695E-03_JPRB, 0.37099712E-03_JPRB, 0.37099703E-03_JPRB, 0.37099727E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099904E-03_JPRB, 0.37099730E-03_JPRB, 0.37099796E-03_JPRB, 0.37099764E-03_JPRB, 0.37099767E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099759E-03_JPRB, 0.37099834E-03_JPRB, 0.37099840E-03_JPRB, 0.37099808E-03_JPRB, 0.37099837E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099959E-03_JPRB, 0.37099983E-03_JPRB, 0.37100018E-03_JPRB, 0.37100012E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100111E-03_JPRB, 0.37100137E-03_JPRB, 0.37100076E-03_JPRB, 0.37100073E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100029E-03_JPRB, 0.37100032E-03_JPRB, 0.37099994E-03_JPRB, 0.37099986E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099930E-03_JPRB, 0.37099927E-03_JPRB, 0.37099962E-03_JPRB, 0.37099942E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37099983E-03_JPRB, 0.37099951E-03_JPRB, 0.37099994E-03_JPRB, 0.37099945E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099878E-03_JPRB, 0.37099852E-03_JPRB, 0.37099855E-03_JPRB, 0.37099840E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099776E-03_JPRB, 0.37099753E-03_JPRB, 0.37099724E-03_JPRB /)

RGHG1(:,73,11) = (/ &
  & 0.37099587E-03_JPRB, 0.37099683E-03_JPRB, 0.37099732E-03_JPRB, 0.37099753E-03_JPRB, 0.37099730E-03_JPRB, 0.37099747E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099738E-03_JPRB, 0.37099762E-03_JPRB, 0.37099773E-03_JPRB, 0.37099750E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099779E-03_JPRB, 0.37099957E-03_JPRB, 0.37099828E-03_JPRB, 0.37099846E-03_JPRB, 0.37099828E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099814E-03_JPRB, 0.37099916E-03_JPRB, 0.37099916E-03_JPRB, 0.37099855E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100006E-03_JPRB, 0.37100015E-03_JPRB, 0.37100038E-03_JPRB, 0.37100009E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100134E-03_JPRB, 0.37100163E-03_JPRB, 0.37100085E-03_JPRB, 0.37100090E-03_JPRB, 0.37100058E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100050E-03_JPRB, 0.37100067E-03_JPRB, 0.37100023E-03_JPRB, 0.37100012E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099951E-03_JPRB, 0.37099948E-03_JPRB, 0.37099997E-03_JPRB, 0.37099965E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100015E-03_JPRB, 0.37099986E-03_JPRB, 0.37100041E-03_JPRB, 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099913E-03_JPRB, 0.37099901E-03_JPRB, 0.37099916E-03_JPRB, 0.37099901E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099826E-03_JPRB, 0.37099811E-03_JPRB, 0.37099796E-03_JPRB, 0.37099773E-03_JPRB /)

RGHG1(:,74,11) = (/ &
  & 0.37099636E-03_JPRB, 0.37099744E-03_JPRB, 0.37099811E-03_JPRB, 0.37099828E-03_JPRB, 0.37099796E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099802E-03_JPRB, 0.37099817E-03_JPRB, 0.37099826E-03_JPRB, 0.37099794E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099805E-03_JPRB, 0.37099980E-03_JPRB, 0.37099913E-03_JPRB, 0.37099901E-03_JPRB, 0.37099893E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099846E-03_JPRB, 0.37099997E-03_JPRB, 0.37099991E-03_JPRB, 0.37099895E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100044E-03_JPRB, 0.37100038E-03_JPRB, 0.37100067E-03_JPRB, 0.37100009E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100140E-03_JPRB, 0.37100186E-03_JPRB, 0.37100111E-03_JPRB, 0.37100117E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100067E-03_JPRB, 0.37100099E-03_JPRB, 0.37100053E-03_JPRB, 0.37100023E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37099971E-03_JPRB, 0.37099971E-03_JPRB, 0.37100029E-03_JPRB, 0.37099986E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100050E-03_JPRB, 0.37100015E-03_JPRB, 0.37100099E-03_JPRB, 0.37100035E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099945E-03_JPRB, 0.37099942E-03_JPRB, 0.37099965E-03_JPRB, 0.37099959E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099858E-03_JPRB, 0.37099837E-03_JPRB, 0.37099831E-03_JPRB /)

RGHG1(:,75,11) = (/ &
  & 0.37099671E-03_JPRB, 0.37099805E-03_JPRB, 0.37099895E-03_JPRB, 0.37099910E-03_JPRB, 0.37099858E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099860E-03_JPRB, 0.37099872E-03_JPRB, 0.37099875E-03_JPRB, 0.37099826E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099840E-03_JPRB, 0.37099991E-03_JPRB, 0.37100015E-03_JPRB, 0.37099957E-03_JPRB, 0.37099948E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099869E-03_JPRB, 0.37100082E-03_JPRB, 0.37100073E-03_JPRB, 0.37099930E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100090E-03_JPRB, 0.37100067E-03_JPRB, 0.37100082E-03_JPRB, 0.37099986E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100163E-03_JPRB, 0.37100149E-03_JPRB, 0.37100216E-03_JPRB, 0.37100131E-03_JPRB, 0.37100131E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100088E-03_JPRB, 0.37100131E-03_JPRB, 0.37100070E-03_JPRB, 0.37100050E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099991E-03_JPRB, 0.37099991E-03_JPRB, 0.37100055E-03_JPRB, 0.37099986E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100055E-03_JPRB, 0.37100079E-03_JPRB, 0.37100032E-03_JPRB, 0.37100169E-03_JPRB, 0.37100088E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37099986E-03_JPRB, 0.37099983E-03_JPRB, 0.37100023E-03_JPRB, 0.37100021E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37099890E-03_JPRB, 0.37099872E-03_JPRB, 0.37099887E-03_JPRB /)

RGHG1(:,76,11) = (/ &
  & 0.37099698E-03_JPRB, 0.37099869E-03_JPRB, 0.37099983E-03_JPRB, 0.37099997E-03_JPRB, 0.37099910E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099919E-03_JPRB, 0.37099933E-03_JPRB, 0.37099916E-03_JPRB, 0.37099843E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099986E-03_JPRB, 0.37100093E-03_JPRB, 0.37100000E-03_JPRB, 0.37100000E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099860E-03_JPRB, 0.37100157E-03_JPRB, 0.37100157E-03_JPRB, 0.37099968E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37100128E-03_JPRB, 0.37100099E-03_JPRB, 0.37100099E-03_JPRB, 0.37099948E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100184E-03_JPRB, 0.37100157E-03_JPRB, 0.37100239E-03_JPRB, 0.37100140E-03_JPRB, 0.37100152E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100102E-03_JPRB, 0.37100163E-03_JPRB, 0.37100088E-03_JPRB, 0.37100079E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100003E-03_JPRB, 0.37099994E-03_JPRB, 0.37100088E-03_JPRB, 0.37099980E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100102E-03_JPRB, 0.37100044E-03_JPRB, 0.37100248E-03_JPRB, 0.37100134E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100018E-03_JPRB, 0.37100021E-03_JPRB, 0.37100082E-03_JPRB, 0.37100082E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37099916E-03_JPRB, 0.37099910E-03_JPRB, 0.37099951E-03_JPRB /)

RGHG1(:,77,11) = (/ &
  & 0.37099718E-03_JPRB, 0.37099927E-03_JPRB, 0.37100073E-03_JPRB, 0.37100085E-03_JPRB, 0.37099962E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37099968E-03_JPRB, 0.37099974E-03_JPRB, 0.37099957E-03_JPRB, 0.37099843E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099872E-03_JPRB, 0.37099977E-03_JPRB, 0.37100184E-03_JPRB, 0.37100035E-03_JPRB, 0.37100050E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37099828E-03_JPRB, 0.37099834E-03_JPRB, 0.37100253E-03_JPRB, 0.37100242E-03_JPRB, 0.37099994E-03_JPRB, 0.37100012E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100169E-03_JPRB, 0.37100131E-03_JPRB, 0.37100117E-03_JPRB, 0.37099904E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100154E-03_JPRB, 0.37100259E-03_JPRB, 0.37100163E-03_JPRB, 0.37100184E-03_JPRB, 0.37100146E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100117E-03_JPRB, 0.37100201E-03_JPRB, 0.37100117E-03_JPRB, 0.37100096E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100000E-03_JPRB, 0.37099989E-03_JPRB, 0.37100111E-03_JPRB, 0.37099957E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100125E-03_JPRB, 0.37100035E-03_JPRB, 0.37100347E-03_JPRB, 0.37100189E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37100064E-03_JPRB, 0.37100067E-03_JPRB, 0.37100152E-03_JPRB, 0.37100154E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099945E-03_JPRB, 0.37099939E-03_JPRB, 0.37100012E-03_JPRB /)

RGHG1(:,78,11) = (/ &
  & 0.37099724E-03_JPRB, 0.37099980E-03_JPRB, 0.37100154E-03_JPRB, 0.37100172E-03_JPRB, 0.37099994E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100015E-03_JPRB, 0.37100018E-03_JPRB, 0.37099989E-03_JPRB, 0.37099840E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099965E-03_JPRB, 0.37100282E-03_JPRB, 0.37100061E-03_JPRB, 0.37100090E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099799E-03_JPRB, 0.37099802E-03_JPRB, 0.37100341E-03_JPRB, 0.37100323E-03_JPRB, 0.37100015E-03_JPRB, 0.37100029E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100207E-03_JPRB, 0.37100154E-03_JPRB, 0.37100134E-03_JPRB, 0.37099860E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37100216E-03_JPRB, 0.37100152E-03_JPRB, 0.37100277E-03_JPRB, 0.37100184E-03_JPRB, 0.37100210E-03_JPRB, 0.37100181E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100134E-03_JPRB, 0.37100242E-03_JPRB, 0.37100137E-03_JPRB, 0.37100108E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37100015E-03_JPRB, 0.37099997E-03_JPRB, 0.37100143E-03_JPRB, 0.37099922E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100143E-03_JPRB, 0.37100021E-03_JPRB, 0.37100448E-03_JPRB, 0.37100248E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100090E-03_JPRB, 0.37100096E-03_JPRB, 0.37100227E-03_JPRB, 0.37100230E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099962E-03_JPRB, 0.37099965E-03_JPRB, 0.37100088E-03_JPRB /)

RGHG1(:,79,11) = (/ &
  & 0.37099698E-03_JPRB, 0.37100015E-03_JPRB, 0.37100227E-03_JPRB, 0.37100242E-03_JPRB, 0.37100015E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37100160E-03_JPRB, 0.37100047E-03_JPRB, 0.37100050E-03_JPRB, 0.37100018E-03_JPRB, 0.37099823E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099959E-03_JPRB, 0.37100379E-03_JPRB, 0.37100082E-03_JPRB, 0.37100134E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099764E-03_JPRB, 0.37100440E-03_JPRB, 0.37100411E-03_JPRB, 0.37100041E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100250E-03_JPRB, 0.37100195E-03_JPRB, 0.37100160E-03_JPRB, 0.37099817E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100160E-03_JPRB, 0.37100312E-03_JPRB, 0.37100218E-03_JPRB, 0.37100248E-03_JPRB, 0.37100213E-03_JPRB, &
  & 0.37100088E-03_JPRB, 0.37100160E-03_JPRB, 0.37100282E-03_JPRB, 0.37100166E-03_JPRB, 0.37100125E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100018E-03_JPRB, 0.37100018E-03_JPRB, 0.37099991E-03_JPRB, 0.37100172E-03_JPRB, 0.37099893E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37100172E-03_JPRB, 0.37100015E-03_JPRB, 0.37100544E-03_JPRB, 0.37100306E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37100122E-03_JPRB, 0.37100134E-03_JPRB, 0.37100294E-03_JPRB, 0.37100306E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099968E-03_JPRB, 0.37099989E-03_JPRB, 0.37100163E-03_JPRB /)

RGHG1(:,80,11) = (/ &
  & 0.37099645E-03_JPRB, 0.37100032E-03_JPRB, 0.37100271E-03_JPRB, 0.37100282E-03_JPRB, 0.37100026E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37100198E-03_JPRB, 0.37100070E-03_JPRB, 0.37100067E-03_JPRB, 0.37100041E-03_JPRB, 0.37099805E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099951E-03_JPRB, 0.37100445E-03_JPRB, 0.37100102E-03_JPRB, 0.37100160E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099738E-03_JPRB, 0.37100504E-03_JPRB, 0.37100469E-03_JPRB, 0.37100053E-03_JPRB, 0.37100061E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100285E-03_JPRB, 0.37100224E-03_JPRB, 0.37100178E-03_JPRB, 0.37099782E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100271E-03_JPRB, 0.37100181E-03_JPRB, 0.37100352E-03_JPRB, 0.37100253E-03_JPRB, 0.37100285E-03_JPRB, 0.37100248E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100175E-03_JPRB, 0.37100329E-03_JPRB, 0.37100186E-03_JPRB, 0.37100140E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100021E-03_JPRB, 0.37099989E-03_JPRB, 0.37100201E-03_JPRB, 0.37099878E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100195E-03_JPRB, 0.37100009E-03_JPRB, 0.37100620E-03_JPRB, 0.37100349E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37100140E-03_JPRB, 0.37100154E-03_JPRB, 0.37100341E-03_JPRB, 0.37100361E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099971E-03_JPRB, 0.37100000E-03_JPRB, 0.37100248E-03_JPRB /)

RGHG1(:,81,11) = (/ &
  & 0.37099569E-03_JPRB, 0.37100038E-03_JPRB, 0.37100294E-03_JPRB, 0.37100312E-03_JPRB, 0.37100038E-03_JPRB, 0.37100143E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100079E-03_JPRB, 0.37100076E-03_JPRB, 0.37100044E-03_JPRB, 0.37099796E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099945E-03_JPRB, 0.37100480E-03_JPRB, 0.37100114E-03_JPRB, 0.37100184E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099706E-03_JPRB, 0.37100559E-03_JPRB, 0.37100510E-03_JPRB, 0.37100073E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100306E-03_JPRB, 0.37100239E-03_JPRB, 0.37100192E-03_JPRB, 0.37099764E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100189E-03_JPRB, 0.37100384E-03_JPRB, 0.37100280E-03_JPRB, 0.37100309E-03_JPRB, 0.37100265E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100192E-03_JPRB, 0.37100347E-03_JPRB, 0.37100201E-03_JPRB, 0.37100149E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100018E-03_JPRB, 0.37099991E-03_JPRB, 0.37100221E-03_JPRB, 0.37099863E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100204E-03_JPRB, 0.37100000E-03_JPRB, 0.37100678E-03_JPRB, 0.37100384E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100152E-03_JPRB, 0.37100169E-03_JPRB, 0.37100376E-03_JPRB, 0.37100402E-03_JPRB, 0.37100096E-03_JPRB, &
  & 0.37099942E-03_JPRB, 0.37099974E-03_JPRB, 0.37100009E-03_JPRB, 0.37100338E-03_JPRB /)

RGHG1(:,82,11) = (/ &
  & 0.37099558E-03_JPRB, 0.37100044E-03_JPRB, 0.37100309E-03_JPRB, 0.37100329E-03_JPRB, 0.37100044E-03_JPRB, 0.37100149E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100088E-03_JPRB, 0.37100085E-03_JPRB, 0.37100061E-03_JPRB, 0.37099791E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099942E-03_JPRB, 0.37100507E-03_JPRB, 0.37100114E-03_JPRB, 0.37100195E-03_JPRB, 0.37099794E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099698E-03_JPRB, 0.37100571E-03_JPRB, 0.37100533E-03_JPRB, 0.37100079E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100323E-03_JPRB, 0.37100253E-03_JPRB, 0.37100204E-03_JPRB, 0.37099750E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100198E-03_JPRB, 0.37100408E-03_JPRB, 0.37100300E-03_JPRB, 0.37100326E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37100125E-03_JPRB, 0.37100198E-03_JPRB, 0.37100364E-03_JPRB, 0.37100224E-03_JPRB, 0.37100160E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100021E-03_JPRB, 0.37099989E-03_JPRB, 0.37100227E-03_JPRB, 0.37099852E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100058E-03_JPRB, 0.37100210E-03_JPRB, 0.37099994E-03_JPRB, 0.37100713E-03_JPRB, 0.37100402E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37100163E-03_JPRB, 0.37100186E-03_JPRB, 0.37100402E-03_JPRB, 0.37100422E-03_JPRB, 0.37100102E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099974E-03_JPRB, 0.37100003E-03_JPRB, 0.37100347E-03_JPRB /)

RGHG1(:,83,11) = (/ &
  & 0.37099543E-03_JPRB, 0.37100047E-03_JPRB, 0.37100323E-03_JPRB, 0.37100347E-03_JPRB, 0.37100050E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100090E-03_JPRB, 0.37100085E-03_JPRB, 0.37100047E-03_JPRB, 0.37099796E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099939E-03_JPRB, 0.37100524E-03_JPRB, 0.37100122E-03_JPRB, 0.37100198E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099674E-03_JPRB, 0.37100608E-03_JPRB, 0.37100562E-03_JPRB, 0.37100082E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100189E-03_JPRB, 0.37100332E-03_JPRB, 0.37100259E-03_JPRB, 0.37100213E-03_JPRB, 0.37099741E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37100303E-03_JPRB, 0.37100201E-03_JPRB, 0.37100425E-03_JPRB, 0.37100309E-03_JPRB, 0.37100332E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100207E-03_JPRB, 0.37100370E-03_JPRB, 0.37100236E-03_JPRB, 0.37100154E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100018E-03_JPRB, 0.37099977E-03_JPRB, 0.37100236E-03_JPRB, 0.37099834E-03_JPRB, 0.37100023E-03_JPRB, &
  & 0.37100053E-03_JPRB, 0.37100221E-03_JPRB, 0.37099991E-03_JPRB, 0.37100737E-03_JPRB, 0.37100416E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100163E-03_JPRB, 0.37100195E-03_JPRB, 0.37100416E-03_JPRB, 0.37100440E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099974E-03_JPRB, 0.37100000E-03_JPRB, 0.37100358E-03_JPRB /)

RGHG1(:,84,11) = (/ &
  & 0.37099535E-03_JPRB, 0.37100044E-03_JPRB, 0.37100335E-03_JPRB, 0.37100358E-03_JPRB, 0.37100055E-03_JPRB, 0.37100160E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100099E-03_JPRB, 0.37100082E-03_JPRB, 0.37100044E-03_JPRB, 0.37099802E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099860E-03_JPRB, 0.37099939E-03_JPRB, 0.37100521E-03_JPRB, 0.37100134E-03_JPRB, 0.37100216E-03_JPRB, 0.37099779E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099668E-03_JPRB, 0.37100620E-03_JPRB, 0.37100579E-03_JPRB, 0.37100088E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100349E-03_JPRB, 0.37100268E-03_JPRB, 0.37100216E-03_JPRB, 0.37099730E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100201E-03_JPRB, 0.37100434E-03_JPRB, 0.37100320E-03_JPRB, 0.37100341E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100218E-03_JPRB, 0.37100370E-03_JPRB, 0.37100253E-03_JPRB, 0.37100172E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37100018E-03_JPRB, 0.37099971E-03_JPRB, 0.37100242E-03_JPRB, 0.37099826E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100044E-03_JPRB, 0.37100224E-03_JPRB, 0.37099994E-03_JPRB, 0.37100769E-03_JPRB, 0.37100434E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37100154E-03_JPRB, 0.37100198E-03_JPRB, 0.37100431E-03_JPRB, 0.37100457E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099974E-03_JPRB, 0.37100000E-03_JPRB, 0.37100364E-03_JPRB /)

RGHG1(:,85,11) = (/ &
  & 0.37099517E-03_JPRB, 0.37100044E-03_JPRB, 0.37100347E-03_JPRB, 0.37100376E-03_JPRB, 0.37100061E-03_JPRB, 0.37100166E-03_JPRB, &
  & 0.37100239E-03_JPRB, 0.37100102E-03_JPRB, 0.37100073E-03_JPRB, 0.37100012E-03_JPRB, 0.37099840E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099878E-03_JPRB, 0.37099974E-03_JPRB, 0.37100472E-03_JPRB, 0.37100157E-03_JPRB, 0.37100210E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099654E-03_JPRB, 0.37099657E-03_JPRB, 0.37100655E-03_JPRB, 0.37100603E-03_JPRB, 0.37100070E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100364E-03_JPRB, 0.37100274E-03_JPRB, 0.37100218E-03_JPRB, 0.37099712E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37100315E-03_JPRB, 0.37100210E-03_JPRB, 0.37100448E-03_JPRB, 0.37100335E-03_JPRB, 0.37100349E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100221E-03_JPRB, 0.37100384E-03_JPRB, 0.37100271E-03_JPRB, 0.37100172E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100003E-03_JPRB, 0.37099965E-03_JPRB, 0.37100253E-03_JPRB, 0.37099817E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37100224E-03_JPRB, 0.37099986E-03_JPRB, 0.37100789E-03_JPRB, 0.37100448E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37100154E-03_JPRB, 0.37100207E-03_JPRB, 0.37100443E-03_JPRB, 0.37100469E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099977E-03_JPRB, 0.37100003E-03_JPRB, 0.37100379E-03_JPRB /)

RGHG1(:,86,11) = (/ &
  & 0.37099500E-03_JPRB, 0.37100038E-03_JPRB, 0.37100358E-03_JPRB, 0.37100387E-03_JPRB, 0.37100058E-03_JPRB, 0.37100157E-03_JPRB, &
  & 0.37100213E-03_JPRB, 0.37100102E-03_JPRB, 0.37100061E-03_JPRB, 0.37099991E-03_JPRB, 0.37099863E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100000E-03_JPRB, 0.37100387E-03_JPRB, 0.37100166E-03_JPRB, 0.37100198E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099654E-03_JPRB, 0.37100670E-03_JPRB, 0.37100632E-03_JPRB, 0.37100067E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100379E-03_JPRB, 0.37100285E-03_JPRB, 0.37100230E-03_JPRB, 0.37099700E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37100320E-03_JPRB, 0.37100216E-03_JPRB, 0.37100457E-03_JPRB, 0.37100335E-03_JPRB, 0.37100347E-03_JPRB, 0.37100294E-03_JPRB, &
  & 0.37100152E-03_JPRB, 0.37100218E-03_JPRB, 0.37100396E-03_JPRB, 0.37100280E-03_JPRB, 0.37100178E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100003E-03_JPRB, 0.37099957E-03_JPRB, 0.37100259E-03_JPRB, 0.37099805E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37100230E-03_JPRB, 0.37099986E-03_JPRB, 0.37100818E-03_JPRB, 0.37100457E-03_JPRB, 0.37099863E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37100154E-03_JPRB, 0.37100213E-03_JPRB, 0.37100451E-03_JPRB, 0.37100477E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099977E-03_JPRB, 0.37099997E-03_JPRB, 0.37100390E-03_JPRB /)

RGHG1(:,87,11) = (/ &
  & 0.37099494E-03_JPRB, 0.37100032E-03_JPRB, 0.37100358E-03_JPRB, 0.37100384E-03_JPRB, 0.37100055E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100201E-03_JPRB, 0.37100090E-03_JPRB, 0.37100053E-03_JPRB, 0.37099986E-03_JPRB, 0.37099898E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100035E-03_JPRB, 0.37100329E-03_JPRB, 0.37100172E-03_JPRB, 0.37100181E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099657E-03_JPRB, 0.37100672E-03_JPRB, 0.37100652E-03_JPRB, 0.37100053E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37100207E-03_JPRB, 0.37100405E-03_JPRB, 0.37100285E-03_JPRB, 0.37100242E-03_JPRB, 0.37099677E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37100332E-03_JPRB, 0.37100218E-03_JPRB, 0.37100472E-03_JPRB, 0.37100347E-03_JPRB, 0.37100349E-03_JPRB, 0.37100291E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100218E-03_JPRB, 0.37100416E-03_JPRB, 0.37100294E-03_JPRB, 0.37100178E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100003E-03_JPRB, 0.37099945E-03_JPRB, 0.37100262E-03_JPRB, 0.37099796E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37100230E-03_JPRB, 0.37099983E-03_JPRB, 0.37100833E-03_JPRB, 0.37100466E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37100146E-03_JPRB, 0.37100213E-03_JPRB, 0.37100454E-03_JPRB, 0.37100477E-03_JPRB, 0.37100128E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099977E-03_JPRB, 0.37099986E-03_JPRB, 0.37100396E-03_JPRB /)

RGHG1(:,88,11) = (/ &
  & 0.37099488E-03_JPRB, 0.37100032E-03_JPRB, 0.37100367E-03_JPRB, 0.37100399E-03_JPRB, 0.37100055E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100181E-03_JPRB, 0.37100102E-03_JPRB, 0.37100055E-03_JPRB, 0.37099991E-03_JPRB, 0.37099904E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37100023E-03_JPRB, 0.37100306E-03_JPRB, 0.37100172E-03_JPRB, 0.37100175E-03_JPRB, 0.37099814E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099648E-03_JPRB, 0.37100690E-03_JPRB, 0.37100681E-03_JPRB, 0.37100044E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100428E-03_JPRB, 0.37100285E-03_JPRB, 0.37100250E-03_JPRB, 0.37099654E-03_JPRB, 0.37099828E-03_JPRB, &
  & 0.37100341E-03_JPRB, 0.37100230E-03_JPRB, 0.37100480E-03_JPRB, 0.37100349E-03_JPRB, 0.37100352E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100137E-03_JPRB, 0.37100213E-03_JPRB, 0.37100428E-03_JPRB, 0.37100297E-03_JPRB, 0.37100181E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37100026E-03_JPRB, 0.37099991E-03_JPRB, 0.37099933E-03_JPRB, 0.37100265E-03_JPRB, 0.37099782E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37100009E-03_JPRB, 0.37100233E-03_JPRB, 0.37099980E-03_JPRB, 0.37100853E-03_JPRB, 0.37100469E-03_JPRB, 0.37099846E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100146E-03_JPRB, 0.37100221E-03_JPRB, 0.37100463E-03_JPRB, 0.37100480E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37099948E-03_JPRB, 0.37099980E-03_JPRB, 0.37099994E-03_JPRB, 0.37100411E-03_JPRB /)

RGHG1(:,89,11) = (/ &
  & 0.37099500E-03_JPRB, 0.37100029E-03_JPRB, 0.37100379E-03_JPRB, 0.37100399E-03_JPRB, 0.37100050E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100096E-03_JPRB, 0.37100053E-03_JPRB, 0.37099980E-03_JPRB, 0.37099881E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099922E-03_JPRB, 0.37100021E-03_JPRB, 0.37100332E-03_JPRB, 0.37100175E-03_JPRB, 0.37100189E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099636E-03_JPRB, 0.37100702E-03_JPRB, 0.37100702E-03_JPRB, 0.37100035E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100448E-03_JPRB, 0.37100291E-03_JPRB, 0.37100259E-03_JPRB, 0.37099639E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37100352E-03_JPRB, 0.37100227E-03_JPRB, 0.37100498E-03_JPRB, 0.37100349E-03_JPRB, 0.37100355E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100134E-03_JPRB, 0.37100207E-03_JPRB, 0.37100445E-03_JPRB, 0.37100303E-03_JPRB, 0.37100178E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37100029E-03_JPRB, 0.37099991E-03_JPRB, 0.37099927E-03_JPRB, 0.37100277E-03_JPRB, 0.37099776E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37100236E-03_JPRB, 0.37099971E-03_JPRB, 0.37100879E-03_JPRB, 0.37100475E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100152E-03_JPRB, 0.37100221E-03_JPRB, 0.37100460E-03_JPRB, 0.37100489E-03_JPRB, 0.37100125E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37099986E-03_JPRB, 0.37099986E-03_JPRB, 0.37100416E-03_JPRB /)

RGHG1(:,90,11) = (/ &
  & 0.37099523E-03_JPRB, 0.37100032E-03_JPRB, 0.37100387E-03_JPRB, 0.37100422E-03_JPRB, 0.37100032E-03_JPRB, 0.37100172E-03_JPRB, &
  & 0.37100236E-03_JPRB, 0.37100125E-03_JPRB, 0.37100076E-03_JPRB, 0.37099994E-03_JPRB, 0.37099852E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37099997E-03_JPRB, 0.37100428E-03_JPRB, 0.37100175E-03_JPRB, 0.37100230E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099590E-03_JPRB, 0.37100745E-03_JPRB, 0.37100728E-03_JPRB, 0.37100012E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100472E-03_JPRB, 0.37100288E-03_JPRB, 0.37100277E-03_JPRB, 0.37099613E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37100373E-03_JPRB, 0.37100218E-03_JPRB, 0.37100518E-03_JPRB, 0.37100347E-03_JPRB, 0.37100355E-03_JPRB, 0.37100300E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37100195E-03_JPRB, 0.37100463E-03_JPRB, 0.37100306E-03_JPRB, 0.37100178E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37100032E-03_JPRB, 0.37099994E-03_JPRB, 0.37099916E-03_JPRB, 0.37100300E-03_JPRB, 0.37099753E-03_JPRB, 0.37100006E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100250E-03_JPRB, 0.37099945E-03_JPRB, 0.37100920E-03_JPRB, 0.37100483E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099898E-03_JPRB, 0.37100154E-03_JPRB, 0.37100224E-03_JPRB, 0.37100475E-03_JPRB, 0.37100504E-03_JPRB, 0.37100122E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099991E-03_JPRB, 0.37099994E-03_JPRB, 0.37100434E-03_JPRB /)

RGHG1(:,91,11) = (/ &
  & 0.37099549E-03_JPRB, 0.37100000E-03_JPRB, 0.37100396E-03_JPRB, 0.37100457E-03_JPRB, 0.37099986E-03_JPRB, 0.37100181E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100114E-03_JPRB, 0.37100143E-03_JPRB, 0.37100088E-03_JPRB, 0.37099703E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099858E-03_JPRB, 0.37099846E-03_JPRB, 0.37100734E-03_JPRB, 0.37100082E-03_JPRB, 0.37100329E-03_JPRB, 0.37099715E-03_JPRB, &
  & 0.37099625E-03_JPRB, 0.37099497E-03_JPRB, 0.37100835E-03_JPRB, 0.37100786E-03_JPRB, 0.37099968E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100207E-03_JPRB, 0.37100501E-03_JPRB, 0.37100282E-03_JPRB, 0.37100320E-03_JPRB, 0.37099552E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37100425E-03_JPRB, 0.37100189E-03_JPRB, 0.37100568E-03_JPRB, 0.37100329E-03_JPRB, 0.37100361E-03_JPRB, 0.37100315E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100184E-03_JPRB, 0.37100495E-03_JPRB, 0.37100306E-03_JPRB, 0.37100184E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37100038E-03_JPRB, 0.37099991E-03_JPRB, 0.37099890E-03_JPRB, 0.37100358E-03_JPRB, 0.37099706E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100282E-03_JPRB, 0.37099860E-03_JPRB, 0.37101013E-03_JPRB, 0.37100495E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099887E-03_JPRB, 0.37100172E-03_JPRB, 0.37100216E-03_JPRB, 0.37100489E-03_JPRB, 0.37100524E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099994E-03_JPRB, 0.37099986E-03_JPRB, 0.37100443E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG1(:, 1,12) = (/ &
  & 0.36501171E-03_JPRB, 0.36500060E-03_JPRB, 0.36482021E-03_JPRB, 0.36462612E-03_JPRB, 0.36441968E-03_JPRB, 0.36420207E-03_JPRB, &
  & 0.36397376E-03_JPRB, 0.36373961E-03_JPRB, 0.36353603E-03_JPRB, 0.36337125E-03_JPRB, 0.36323990E-03_JPRB, 0.36314066E-03_JPRB, &
  & 0.36307596E-03_JPRB, 0.36304520E-03_JPRB, 0.36304301E-03_JPRB, 0.36306362E-03_JPRB, 0.36309694E-03_JPRB, 0.36313059E-03_JPRB, &
  & 0.36315474E-03_JPRB, 0.36316173E-03_JPRB, 0.36314796E-03_JPRB, 0.36311476E-03_JPRB, 0.36306749E-03_JPRB, 0.36301115E-03_JPRB, &
  & 0.36294974E-03_JPRB, 0.36288495E-03_JPRB, 0.36281536E-03_JPRB, 0.36273335E-03_JPRB, 0.36265043E-03_JPRB, 0.36256920E-03_JPRB, &
  & 0.36249144E-03_JPRB, 0.36241725E-03_JPRB, 0.36234630E-03_JPRB, 0.36227913E-03_JPRB, 0.36221670E-03_JPRB, 0.36216059E-03_JPRB, &
  & 0.36211289E-03_JPRB, 0.36207490E-03_JPRB, 0.36204536E-03_JPRB, 0.36202424E-03_JPRB, 0.36200730E-03_JPRB, 0.36198905E-03_JPRB, &
  & 0.36196440E-03_JPRB, 0.36192793E-03_JPRB, 0.36187322E-03_JPRB, 0.36179126E-03_JPRB, 0.36167132E-03_JPRB, 0.36150336E-03_JPRB, &
  & 0.36128424E-03_JPRB, 0.36102306E-03_JPRB, 0.36074151E-03_JPRB, 0.36046846E-03_JPRB, 0.36023185E-03_JPRB, 0.36005120E-03_JPRB, &
  & 0.35993126E-03_JPRB, 0.35986240E-03_JPRB, 0.35982783E-03_JPRB, 0.35981199E-03_JPRB, 0.35980489E-03_JPRB, 0.35980120E-03_JPRB, &
  & 0.35980152E-03_JPRB, 0.35980516E-03_JPRB, 0.35981202E-03_JPRB, 0.35982052E-03_JPRB /)

RGHG1(:, 2,12) = (/ &
  & 0.36534783E-03_JPRB, 0.36528817E-03_JPRB, 0.36518538E-03_JPRB, 0.36510438E-03_JPRB, 0.36502082E-03_JPRB, 0.36494181E-03_JPRB, &
  & 0.36486739E-03_JPRB, 0.36480016E-03_JPRB, 0.36474387E-03_JPRB, 0.36469789E-03_JPRB, 0.36466462E-03_JPRB, 0.36464588E-03_JPRB, &
  & 0.36464536E-03_JPRB, 0.36466555E-03_JPRB, 0.36470353E-03_JPRB, 0.36475371E-03_JPRB, 0.36480557E-03_JPRB, 0.36484940E-03_JPRB, &
  & 0.36487752E-03_JPRB, 0.36488555E-03_JPRB, 0.36487234E-03_JPRB, 0.36483989E-03_JPRB, 0.36479277E-03_JPRB, 0.36473499E-03_JPRB, &
  & 0.36466995E-03_JPRB, 0.36459946E-03_JPRB, 0.36452260E-03_JPRB, 0.36443886E-03_JPRB, 0.36435403E-03_JPRB, 0.36427099E-03_JPRB, &
  & 0.36419134E-03_JPRB, 0.36411398E-03_JPRB, 0.36403770E-03_JPRB, 0.36396316E-03_JPRB, 0.36389276E-03_JPRB, 0.36383091E-03_JPRB, &
  & 0.36378234E-03_JPRB, 0.36375000E-03_JPRB, 0.36373045E-03_JPRB, 0.36371575E-03_JPRB, 0.36369407E-03_JPRB, 0.36365492E-03_JPRB, &
  & 0.36359121E-03_JPRB, 0.36350067E-03_JPRB, 0.36338618E-03_JPRB, 0.36325422E-03_JPRB, 0.36311321E-03_JPRB, 0.36297052E-03_JPRB, &
  & 0.36282657E-03_JPRB, 0.36266842E-03_JPRB, 0.36247302E-03_JPRB, 0.36222476E-03_JPRB, 0.36193291E-03_JPRB, 0.36162938E-03_JPRB, &
  & 0.36134859E-03_JPRB, 0.36111358E-03_JPRB, 0.36093395E-03_JPRB, 0.36081008E-03_JPRB, 0.36073563E-03_JPRB, 0.36070170E-03_JPRB, &
  & 0.36069134E-03_JPRB, 0.36069524E-03_JPRB, 0.36071092E-03_JPRB, 0.36073997E-03_JPRB /)

RGHG1(:, 3,12) = (/ &
  & 0.36543224E-03_JPRB, 0.36537086E-03_JPRB, 0.36533357E-03_JPRB, 0.36530546E-03_JPRB, 0.36528215E-03_JPRB, 0.36526212E-03_JPRB, &
  & 0.36524620E-03_JPRB, 0.36523407E-03_JPRB, 0.36522601E-03_JPRB, 0.36522219E-03_JPRB, 0.36522397E-03_JPRB, 0.36523360E-03_JPRB, &
  & 0.36525456E-03_JPRB, 0.36528712E-03_JPRB, 0.36533043E-03_JPRB, 0.36537898E-03_JPRB, 0.36542653E-03_JPRB, 0.36546696E-03_JPRB, &
  & 0.36549717E-03_JPRB, 0.36551530E-03_JPRB, 0.36552100E-03_JPRB, 0.36551489E-03_JPRB, 0.36549926E-03_JPRB, 0.36547636E-03_JPRB, &
  & 0.36544839E-03_JPRB, 0.36541672E-03_JPRB, 0.36538177E-03_JPRB, 0.36534402E-03_JPRB, 0.36530528E-03_JPRB, 0.36526704E-03_JPRB, &
  & 0.36522857E-03_JPRB, 0.36518907E-03_JPRB, 0.36514812E-03_JPRB, 0.36510694E-03_JPRB, 0.36506925E-03_JPRB, 0.36503939E-03_JPRB, &
  & 0.36502047E-03_JPRB, 0.36501006E-03_JPRB, 0.36500272E-03_JPRB, 0.36499003E-03_JPRB, 0.36496285E-03_JPRB, 0.36491288E-03_JPRB, &
  & 0.36483543E-03_JPRB, 0.36472693E-03_JPRB, 0.36458636E-03_JPRB, 0.36441247E-03_JPRB, 0.36420336E-03_JPRB, 0.36395679E-03_JPRB, &
  & 0.36367343E-03_JPRB, 0.36336266E-03_JPRB, 0.36304578E-03_JPRB, 0.36274607E-03_JPRB, 0.36247133E-03_JPRB, 0.36221626E-03_JPRB, &
  & 0.36198422E-03_JPRB, 0.36179007E-03_JPRB, 0.36164478E-03_JPRB, 0.36154606E-03_JPRB, 0.36148349E-03_JPRB, 0.36144321E-03_JPRB, &
  & 0.36142507E-03_JPRB, 0.36141867E-03_JPRB, 0.36142633E-03_JPRB, 0.36144967E-03_JPRB /)

RGHG1(:, 4,12) = (/ &
  & 0.36548363E-03_JPRB, 0.36544455E-03_JPRB, 0.36542755E-03_JPRB, 0.36541771E-03_JPRB, 0.36541274E-03_JPRB, 0.36541128E-03_JPRB, &
  & 0.36541236E-03_JPRB, 0.36541576E-03_JPRB, 0.36542222E-03_JPRB, 0.36543320E-03_JPRB, 0.36544900E-03_JPRB, 0.36547254E-03_JPRB, &
  & 0.36550488E-03_JPRB, 0.36554510E-03_JPRB, 0.36558963E-03_JPRB, 0.36563477E-03_JPRB, 0.36567700E-03_JPRB, 0.36571402E-03_JPRB, &
  & 0.36574522E-03_JPRB, 0.36576935E-03_JPRB, 0.36578617E-03_JPRB, 0.36579539E-03_JPRB, 0.36579810E-03_JPRB, 0.36579551E-03_JPRB, &
  & 0.36578911E-03_JPRB, 0.36578014E-03_JPRB, 0.36576935E-03_JPRB, 0.36575738E-03_JPRB, 0.36574478E-03_JPRB, 0.36573125E-03_JPRB, &
  & 0.36571643E-03_JPRB, 0.36569982E-03_JPRB, 0.36568128E-03_JPRB, 0.36566198E-03_JPRB, 0.36564443E-03_JPRB, 0.36563037E-03_JPRB, &
  & 0.36561955E-03_JPRB, 0.36560968E-03_JPRB, 0.36559530E-03_JPRB, 0.36556975E-03_JPRB, 0.36552618E-03_JPRB, 0.36546140E-03_JPRB, &
  & 0.36537444E-03_JPRB, 0.36526547E-03_JPRB, 0.36513369E-03_JPRB, 0.36497781E-03_JPRB, 0.36479550E-03_JPRB, 0.36458450E-03_JPRB, &
  & 0.36434474E-03_JPRB, 0.36407955E-03_JPRB, 0.36379159E-03_JPRB, 0.36348036E-03_JPRB, 0.36315387E-03_JPRB, 0.36283489E-03_JPRB, &
  & 0.36254647E-03_JPRB, 0.36230165E-03_JPRB, 0.36210555E-03_JPRB, 0.36196056E-03_JPRB, 0.36186495E-03_JPRB, 0.36181428E-03_JPRB, &
  & 0.36179691E-03_JPRB, 0.36179830E-03_JPRB, 0.36182679E-03_JPRB, 0.36188395E-03_JPRB /)

RGHG1(:, 5,12) = (/ &
  & 0.36553969E-03_JPRB, 0.36551745E-03_JPRB, 0.36550968E-03_JPRB, 0.36550820E-03_JPRB, 0.36551047E-03_JPRB, 0.36551568E-03_JPRB, &
  & 0.36552383E-03_JPRB, 0.36553523E-03_JPRB, 0.36554999E-03_JPRB, 0.36556955E-03_JPRB, 0.36559586E-03_JPRB, 0.36562758E-03_JPRB, &
  & 0.36566478E-03_JPRB, 0.36570599E-03_JPRB, 0.36574813E-03_JPRB, 0.36578981E-03_JPRB, 0.36582994E-03_JPRB, 0.36586702E-03_JPRB, &
  & 0.36590037E-03_JPRB, 0.36592918E-03_JPRB, 0.36595284E-03_JPRB, 0.36597141E-03_JPRB, 0.36598492E-03_JPRB, 0.36599438E-03_JPRB, &
  & 0.36600055E-03_JPRB, 0.36600462E-03_JPRB, 0.36600744E-03_JPRB, 0.36600928E-03_JPRB, 0.36601024E-03_JPRB, 0.36600971E-03_JPRB, &
  & 0.36600753E-03_JPRB, 0.36600314E-03_JPRB, 0.36599755E-03_JPRB, 0.36599213E-03_JPRB, 0.36598826E-03_JPRB, 0.36598690E-03_JPRB, &
  & 0.36598693E-03_JPRB, 0.36598343E-03_JPRB, 0.36596780E-03_JPRB, 0.36593055E-03_JPRB, 0.36586582E-03_JPRB, 0.36577450E-03_JPRB, &
  & 0.36566297E-03_JPRB, 0.36553718E-03_JPRB, 0.36540109E-03_JPRB, 0.36525595E-03_JPRB, 0.36510010E-03_JPRB, 0.36492862E-03_JPRB, &
  & 0.36473555E-03_JPRB, 0.36451576E-03_JPRB, 0.36426634E-03_JPRB, 0.36399066E-03_JPRB, 0.36369660E-03_JPRB, 0.36339002E-03_JPRB, &
  & 0.36308100E-03_JPRB, 0.36278923E-03_JPRB, 0.36253902E-03_JPRB, 0.36234842E-03_JPRB, 0.36222482E-03_JPRB, 0.36215899E-03_JPRB, &
  & 0.36214423E-03_JPRB, 0.36216158E-03_JPRB, 0.36221161E-03_JPRB, 0.36232002E-03_JPRB /)

RGHG1(:, 6,12) = (/ &
  & 0.36560601E-03_JPRB, 0.36559379E-03_JPRB, 0.36559283E-03_JPRB, 0.36559650E-03_JPRB, 0.36560345E-03_JPRB, 0.36561349E-03_JPRB, &
  & 0.36562685E-03_JPRB, 0.36564379E-03_JPRB, 0.36566478E-03_JPRB, 0.36568972E-03_JPRB, 0.36572013E-03_JPRB, 0.36575543E-03_JPRB, &
  & 0.36579315E-03_JPRB, 0.36583279E-03_JPRB, 0.36587298E-03_JPRB, 0.36591294E-03_JPRB, 0.36595279E-03_JPRB, 0.36599147E-03_JPRB, &
  & 0.36602857E-03_JPRB, 0.36606405E-03_JPRB, 0.36609665E-03_JPRB, 0.36612633E-03_JPRB, 0.36615285E-03_JPRB, 0.36617569E-03_JPRB, &
  & 0.36619551E-03_JPRB, 0.36621263E-03_JPRB, 0.36622767E-03_JPRB, 0.36624167E-03_JPRB, 0.36625497E-03_JPRB, 0.36626749E-03_JPRB, &
  & 0.36627945E-03_JPRB, 0.36629074E-03_JPRB, 0.36630174E-03_JPRB, 0.36631327E-03_JPRB, 0.36632575E-03_JPRB, 0.36633882E-03_JPRB, &
  & 0.36634901E-03_JPRB, 0.36634860E-03_JPRB, 0.36632555E-03_JPRB, 0.36626845E-03_JPRB, 0.36617371E-03_JPRB, 0.36605075E-03_JPRB, &
  & 0.36591338E-03_JPRB, 0.36577176E-03_JPRB, 0.36563026E-03_JPRB, 0.36548794E-03_JPRB, 0.36533992E-03_JPRB, 0.36518014E-03_JPRB, &
  & 0.36500453E-03_JPRB, 0.36481005E-03_JPRB, 0.36459381E-03_JPRB, 0.36435371E-03_JPRB, 0.36408840E-03_JPRB, 0.36380312E-03_JPRB, &
  & 0.36350900E-03_JPRB, 0.36322212E-03_JPRB, 0.36296371E-03_JPRB, 0.36275876E-03_JPRB, 0.36262395E-03_JPRB, 0.36256132E-03_JPRB, &
  & 0.36255262E-03_JPRB, 0.36258105E-03_JPRB, 0.36264109E-03_JPRB, 0.36275265E-03_JPRB /)

RGHG1(:, 7,12) = (/ &
  & 0.36568259E-03_JPRB, 0.36567677E-03_JPRB, 0.36567973E-03_JPRB, 0.36568678E-03_JPRB, 0.36569708E-03_JPRB, 0.36571073E-03_JPRB, &
  & 0.36572770E-03_JPRB, 0.36574851E-03_JPRB, 0.36577272E-03_JPRB, 0.36580110E-03_JPRB, 0.36583343E-03_JPRB, 0.36586914E-03_JPRB, &
  & 0.36590753E-03_JPRB, 0.36594848E-03_JPRB, 0.36599094E-03_JPRB, 0.36603390E-03_JPRB, 0.36607694E-03_JPRB, 0.36611949E-03_JPRB, &
  & 0.36616097E-03_JPRB, 0.36620116E-03_JPRB, 0.36624010E-03_JPRB, 0.36627747E-03_JPRB, 0.36631292E-03_JPRB, 0.36634586E-03_JPRB, &
  & 0.36637610E-03_JPRB, 0.36640395E-03_JPRB, 0.36643023E-03_JPRB, 0.36645596E-03_JPRB, 0.36648224E-03_JPRB, 0.36650937E-03_JPRB, &
  & 0.36653725E-03_JPRB, 0.36656554E-03_JPRB, 0.36659362E-03_JPRB, 0.36662119E-03_JPRB, 0.36664697E-03_JPRB, 0.36666845E-03_JPRB, &
  & 0.36668082E-03_JPRB, 0.36667514E-03_JPRB, 0.36663807E-03_JPRB, 0.36655599E-03_JPRB, 0.36642852E-03_JPRB, 0.36627270E-03_JPRB, &
  & 0.36611123E-03_JPRB, 0.36595706E-03_JPRB, 0.36581256E-03_JPRB, 0.36567298E-03_JPRB, 0.36553148E-03_JPRB, 0.36538354E-03_JPRB, &
  & 0.36522438E-03_JPRB, 0.36504722E-03_JPRB, 0.36484742E-03_JPRB, 0.36462396E-03_JPRB, 0.36437932E-03_JPRB, 0.36411796E-03_JPRB, &
  & 0.36384887E-03_JPRB, 0.36358743E-03_JPRB, 0.36335690E-03_JPRB, 0.36318009E-03_JPRB, 0.36306944E-03_JPRB, 0.36302092E-03_JPRB, &
  & 0.36301682E-03_JPRB, 0.36304479E-03_JPRB, 0.36309636E-03_JPRB, 0.36322090E-03_JPRB /)

RGHG1(:, 8,12) = (/ &
  & 0.36577485E-03_JPRB, 0.36577275E-03_JPRB, 0.36577618E-03_JPRB, 0.36578471E-03_JPRB, 0.36579746E-03_JPRB, 0.36581384E-03_JPRB, &
  & 0.36583393E-03_JPRB, 0.36585733E-03_JPRB, 0.36588457E-03_JPRB, 0.36591594E-03_JPRB, 0.36595252E-03_JPRB, 0.36599359E-03_JPRB, &
  & 0.36603748E-03_JPRB, 0.36608346E-03_JPRB, 0.36613178E-03_JPRB, 0.36618198E-03_JPRB, 0.36623314E-03_JPRB, 0.36628416E-03_JPRB, &
  & 0.36633480E-03_JPRB, 0.36638451E-03_JPRB, 0.36643303E-03_JPRB, 0.36647997E-03_JPRB, 0.36652494E-03_JPRB, 0.36656711E-03_JPRB, &
  & 0.36660617E-03_JPRB, 0.36664205E-03_JPRB, 0.36667581E-03_JPRB, 0.36670832E-03_JPRB, 0.36674121E-03_JPRB, 0.36677514E-03_JPRB, &
  & 0.36681004E-03_JPRB, 0.36684528E-03_JPRB, 0.36687957E-03_JPRB, 0.36691077E-03_JPRB, 0.36693626E-03_JPRB, 0.36695294E-03_JPRB, &
  & 0.36695597E-03_JPRB, 0.36693731E-03_JPRB, 0.36688428E-03_JPRB, 0.36678222E-03_JPRB, 0.36662986E-03_JPRB, 0.36644988E-03_JPRB, &
  & 0.36627133E-03_JPRB, 0.36610797E-03_JPRB, 0.36595922E-03_JPRB, 0.36581937E-03_JPRB, 0.36568355E-03_JPRB, 0.36554539E-03_JPRB, &
  & 0.36539586E-03_JPRB, 0.36522909E-03_JPRB, 0.36504227E-03_JPRB, 0.36483424E-03_JPRB, 0.36460586E-03_JPRB, 0.36436436E-03_JPRB, &
  & 0.36412128E-03_JPRB, 0.36389549E-03_JPRB, 0.36370716E-03_JPRB, 0.36357439E-03_JPRB, 0.36350379E-03_JPRB, 0.36348772E-03_JPRB, &
  & 0.36350993E-03_JPRB, 0.36355294E-03_JPRB, 0.36360923E-03_JPRB, 0.36369756E-03_JPRB /)

RGHG1(:, 9,12) = (/ &
  & 0.36590156E-03_JPRB, 0.36590194E-03_JPRB, 0.36590028E-03_JPRB, 0.36590773E-03_JPRB, 0.36592101E-03_JPRB, 0.36593908E-03_JPRB, &
  & 0.36596146E-03_JPRB, 0.36598812E-03_JPRB, 0.36601897E-03_JPRB, 0.36605453E-03_JPRB, 0.36609516E-03_JPRB, 0.36614155E-03_JPRB, &
  & 0.36619327E-03_JPRB, 0.36624866E-03_JPRB, 0.36630649E-03_JPRB, 0.36636632E-03_JPRB, 0.36642817E-03_JPRB, 0.36649167E-03_JPRB, &
  & 0.36655692E-03_JPRB, 0.36662252E-03_JPRB, 0.36668748E-03_JPRB, 0.36675078E-03_JPRB, 0.36681085E-03_JPRB, 0.36686589E-03_JPRB, &
  & 0.36691473E-03_JPRB, 0.36695699E-03_JPRB, 0.36699366E-03_JPRB, 0.36702721E-03_JPRB, 0.36705929E-03_JPRB, 0.36709136E-03_JPRB, &
  & 0.36712375E-03_JPRB, 0.36715498E-03_JPRB, 0.36718306E-03_JPRB, 0.36720553E-03_JPRB, 0.36721933E-03_JPRB, 0.36722134E-03_JPRB, &
  & 0.36720748E-03_JPRB, 0.36717230E-03_JPRB, 0.36710504E-03_JPRB, 0.36699290E-03_JPRB, 0.36683015E-03_JPRB, 0.36663597E-03_JPRB, &
  & 0.36644196E-03_JPRB, 0.36626612E-03_JPRB, 0.36610989E-03_JPRB, 0.36596824E-03_JPRB, 0.36583294E-03_JPRB, 0.36569429E-03_JPRB, &
  & 0.36554664E-03_JPRB, 0.36538552E-03_JPRB, 0.36520610E-03_JPRB, 0.36500735E-03_JPRB, 0.36479434E-03_JPRB, 0.36457565E-03_JPRB, &
  & 0.36436634E-03_JPRB, 0.36418487E-03_JPRB, 0.36405073E-03_JPRB, 0.36397495E-03_JPRB, 0.36395539E-03_JPRB, 0.36397864E-03_JPRB, &
  & 0.36402716E-03_JPRB, 0.36408362E-03_JPRB, 0.36415370E-03_JPRB, 0.36425042E-03_JPRB /)

RGHG1(:,10,12) = (/ &
  & 0.36610250E-03_JPRB, 0.36608431E-03_JPRB, 0.36606990E-03_JPRB, 0.36607249E-03_JPRB, 0.36608306E-03_JPRB, 0.36610037E-03_JPRB, &
  & 0.36612432E-03_JPRB, 0.36615448E-03_JPRB, 0.36619054E-03_JPRB, 0.36623323E-03_JPRB, 0.36628335E-03_JPRB, 0.36634060E-03_JPRB, &
  & 0.36640419E-03_JPRB, 0.36647447E-03_JPRB, 0.36655075E-03_JPRB, 0.36663155E-03_JPRB, 0.36671537E-03_JPRB, 0.36680110E-03_JPRB, &
  & 0.36688865E-03_JPRB, 0.36697637E-03_JPRB, 0.36706240E-03_JPRB, 0.36714438E-03_JPRB, 0.36722072E-03_JPRB, 0.36728824E-03_JPRB, &
  & 0.36734526E-03_JPRB, 0.36739139E-03_JPRB, 0.36742719E-03_JPRB, 0.36745524E-03_JPRB, 0.36747771E-03_JPRB, 0.36749610E-03_JPRB, &
  & 0.36751077E-03_JPRB, 0.36752099E-03_JPRB, 0.36752500E-03_JPRB, 0.36752084E-03_JPRB, 0.36750670E-03_JPRB, 0.36748187E-03_JPRB, &
  & 0.36744500E-03_JPRB, 0.36739252E-03_JPRB, 0.36731845E-03_JPRB, 0.36721112E-03_JPRB, 0.36706289E-03_JPRB, 0.36688280E-03_JPRB, &
  & 0.36669799E-03_JPRB, 0.36652584E-03_JPRB, 0.36636967E-03_JPRB, 0.36622386E-03_JPRB, 0.36608128E-03_JPRB, 0.36593626E-03_JPRB, &
  & 0.36578276E-03_JPRB, 0.36561504E-03_JPRB, 0.36543282E-03_JPRB, 0.36523968E-03_JPRB, 0.36504242E-03_JPRB, 0.36485452E-03_JPRB, &
  & 0.36469323E-03_JPRB, 0.36457612E-03_JPRB, 0.36451398E-03_JPRB, 0.36450583E-03_JPRB, 0.36453910E-03_JPRB, 0.36459530E-03_JPRB, &
  & 0.36465516E-03_JPRB, 0.36471520E-03_JPRB, 0.36476119E-03_JPRB, 0.36482420E-03_JPRB /)

RGHG1(:,11,12) = (/ &
  & 0.36639007E-03_JPRB, 0.36634190E-03_JPRB, 0.36631475E-03_JPRB, 0.36630910E-03_JPRB, 0.36631580E-03_JPRB, 0.36633178E-03_JPRB, &
  & 0.36635675E-03_JPRB, 0.36639016E-03_JPRB, 0.36643216E-03_JPRB, 0.36648320E-03_JPRB, 0.36654389E-03_JPRB, 0.36661467E-03_JPRB, &
  & 0.36669432E-03_JPRB, 0.36678149E-03_JPRB, 0.36687497E-03_JPRB, 0.36697427E-03_JPRB, 0.36707884E-03_JPRB, 0.36718650E-03_JPRB, &
  & 0.36729517E-03_JPRB, 0.36740274E-03_JPRB, 0.36750751E-03_JPRB, 0.36760545E-03_JPRB, 0.36769302E-03_JPRB, 0.36776933E-03_JPRB, &
  & 0.36783074E-03_JPRB, 0.36787661E-03_JPRB, 0.36790772E-03_JPRB, 0.36792498E-03_JPRB, 0.36793068E-03_JPRB, 0.36792617E-03_JPRB, &
  & 0.36791302E-03_JPRB, 0.36789160E-03_JPRB, 0.36786255E-03_JPRB, 0.36782579E-03_JPRB, 0.36778217E-03_JPRB, 0.36773214E-03_JPRB, &
  & 0.36767696E-03_JPRB, 0.36761450E-03_JPRB, 0.36753830E-03_JPRB, 0.36744500E-03_JPRB, 0.36733062E-03_JPRB, 0.36719776E-03_JPRB, &
  & 0.36705524E-03_JPRB, 0.36691531E-03_JPRB, 0.36678129E-03_JPRB, 0.36665180E-03_JPRB, 0.36652121E-03_JPRB, 0.36638274E-03_JPRB, &
  & 0.36623166E-03_JPRB, 0.36606725E-03_JPRB, 0.36589144E-03_JPRB, 0.36571064E-03_JPRB, 0.36553809E-03_JPRB, 0.36539094E-03_JPRB, &
  & 0.36528386E-03_JPRB, 0.36522525E-03_JPRB, 0.36521268E-03_JPRB, 0.36523442E-03_JPRB, 0.36527537E-03_JPRB, 0.36532155E-03_JPRB, &
  & 0.36536509E-03_JPRB, 0.36539676E-03_JPRB, 0.36542912E-03_JPRB, 0.36545825E-03_JPRB /)

RGHG1(:,12,12) = (/ &
  & 0.36671810E-03_JPRB, 0.36665014E-03_JPRB, 0.36662235E-03_JPRB, 0.36661437E-03_JPRB, 0.36661964E-03_JPRB, 0.36663559E-03_JPRB, &
  & 0.36666123E-03_JPRB, 0.36669686E-03_JPRB, 0.36674284E-03_JPRB, 0.36680041E-03_JPRB, 0.36686962E-03_JPRB, 0.36694971E-03_JPRB, &
  & 0.36704048E-03_JPRB, 0.36714156E-03_JPRB, 0.36725117E-03_JPRB, 0.36736723E-03_JPRB, 0.36748839E-03_JPRB, 0.36761229E-03_JPRB, &
  & 0.36773592E-03_JPRB, 0.36785589E-03_JPRB, 0.36797021E-03_JPRB, 0.36807574E-03_JPRB, 0.36816733E-03_JPRB, 0.36824431E-03_JPRB, &
  & 0.36830443E-03_JPRB, 0.36834489E-03_JPRB, 0.36836666E-03_JPRB, 0.36836916E-03_JPRB, 0.36835435E-03_JPRB, 0.36832388E-03_JPRB, &
  & 0.36828034E-03_JPRB, 0.36822652E-03_JPRB, 0.36816506E-03_JPRB, 0.36809986E-03_JPRB, 0.36803389E-03_JPRB, 0.36797038E-03_JPRB, &
  & 0.36790821E-03_JPRB, 0.36784750E-03_JPRB, 0.36778781E-03_JPRB, 0.36772306E-03_JPRB, 0.36764907E-03_JPRB, 0.36756304E-03_JPRB, &
  & 0.36746683E-03_JPRB, 0.36736412E-03_JPRB, 0.36725949E-03_JPRB, 0.36715245E-03_JPRB, 0.36704083E-03_JPRB, 0.36692290E-03_JPRB, &
  & 0.36679691E-03_JPRB, 0.36666155E-03_JPRB, 0.36651903E-03_JPRB, 0.36637572E-03_JPRB, 0.36624179E-03_JPRB, 0.36612773E-03_JPRB, &
  & 0.36604164E-03_JPRB, 0.36598556E-03_JPRB, 0.36595546E-03_JPRB, 0.36594438E-03_JPRB, 0.36594487E-03_JPRB, 0.36595063E-03_JPRB, &
  & 0.36595657E-03_JPRB, 0.36595992E-03_JPRB, 0.36595797E-03_JPRB, 0.36593855E-03_JPRB /)

RGHG1(:,13,12) = (/ &
  & 0.36705102E-03_JPRB, 0.36697582E-03_JPRB, 0.36695285E-03_JPRB, 0.36694837E-03_JPRB, 0.36695739E-03_JPRB, 0.36697779E-03_JPRB, &
  & 0.36700827E-03_JPRB, 0.36704855E-03_JPRB, 0.36709913E-03_JPRB, 0.36716170E-03_JPRB, 0.36723725E-03_JPRB, 0.36732579E-03_JPRB, &
  & 0.36742576E-03_JPRB, 0.36753580E-03_JPRB, 0.36765431E-03_JPRB, 0.36777946E-03_JPRB, 0.36790891E-03_JPRB, 0.36803976E-03_JPRB, &
  & 0.36816866E-03_JPRB, 0.36829113E-03_JPRB, 0.36840508E-03_JPRB, 0.36850825E-03_JPRB, 0.36859591E-03_JPRB, 0.36866657E-03_JPRB, &
  & 0.36871945E-03_JPRB, 0.36875036E-03_JPRB, 0.36875973E-03_JPRB, 0.36874673E-03_JPRB, 0.36871218E-03_JPRB, 0.36865904E-03_JPRB, &
  & 0.36859105E-03_JPRB, 0.36851331E-03_JPRB, 0.36843144E-03_JPRB, 0.36835161E-03_JPRB, 0.36827984E-03_JPRB, 0.36821736E-03_JPRB, &
  & 0.36816706E-03_JPRB, 0.36812454E-03_JPRB, 0.36808435E-03_JPRB, 0.36804526E-03_JPRB, 0.36800414E-03_JPRB, 0.36795737E-03_JPRB, &
  & 0.36790187E-03_JPRB, 0.36783461E-03_JPRB, 0.36775501E-03_JPRB, 0.36766424E-03_JPRB, 0.36756296E-03_JPRB, 0.36745105E-03_JPRB, &
  & 0.36732832E-03_JPRB, 0.36719674E-03_JPRB, 0.36706030E-03_JPRB, 0.36692448E-03_JPRB, 0.36679587E-03_JPRB, 0.36668309E-03_JPRB, &
  & 0.36659068E-03_JPRB, 0.36652069E-03_JPRB, 0.36647083E-03_JPRB, 0.36643739E-03_JPRB, 0.36641594E-03_JPRB, 0.36640250E-03_JPRB, &
  & 0.36639330E-03_JPRB, 0.36638638E-03_JPRB, 0.36637779E-03_JPRB, 0.36636437E-03_JPRB /)

RGHG1(:,14,12) = (/ &
  & 0.36736409E-03_JPRB, 0.36730015E-03_JPRB, 0.36728522E-03_JPRB, 0.36728938E-03_JPRB, 0.36730702E-03_JPRB, 0.36733580E-03_JPRB, &
  & 0.36737422E-03_JPRB, 0.36742230E-03_JPRB, 0.36748053E-03_JPRB, 0.36754974E-03_JPRB, 0.36763059E-03_JPRB, 0.36772300E-03_JPRB, &
  & 0.36782649E-03_JPRB, 0.36793941E-03_JPRB, 0.36805973E-03_JPRB, 0.36818514E-03_JPRB, 0.36831276E-03_JPRB, 0.36844035E-03_JPRB, &
  & 0.36856439E-03_JPRB, 0.36868051E-03_JPRB, 0.36878599E-03_JPRB, 0.36887976E-03_JPRB, 0.36895720E-03_JPRB, 0.36901757E-03_JPRB, &
  & 0.36905956E-03_JPRB, 0.36907924E-03_JPRB, 0.36907633E-03_JPRB, 0.36904961E-03_JPRB, 0.36900045E-03_JPRB, 0.36893171E-03_JPRB, &
  & 0.36884908E-03_JPRB, 0.36875973E-03_JPRB, 0.36867187E-03_JPRB, 0.36859294E-03_JPRB, 0.36852912E-03_JPRB, 0.36848450E-03_JPRB, &
  & 0.36845016E-03_JPRB, 0.36842452E-03_JPRB, 0.36840519E-03_JPRB, 0.36838764E-03_JPRB, 0.36836817E-03_JPRB, 0.36834358E-03_JPRB, &
  & 0.36831011E-03_JPRB, 0.36826459E-03_JPRB, 0.36820513E-03_JPRB, 0.36813156E-03_JPRB, 0.36804337E-03_JPRB, 0.36794122E-03_JPRB, &
  & 0.36782623E-03_JPRB, 0.36770053E-03_JPRB, 0.36756709E-03_JPRB, 0.36743114E-03_JPRB, 0.36729948E-03_JPRB, 0.36717858E-03_JPRB, &
  & 0.36707346E-03_JPRB, 0.36698667E-03_JPRB, 0.36691802E-03_JPRB, 0.36686516E-03_JPRB, 0.36682520E-03_JPRB, 0.36679555E-03_JPRB, &
  & 0.36677325E-03_JPRB, 0.36675489E-03_JPRB, 0.36673667E-03_JPRB, 0.36670206E-03_JPRB /)

RGHG1(:,15,12) = (/ &
  & 0.36765303E-03_JPRB, 0.36761101E-03_JPRB, 0.36761101E-03_JPRB, 0.36762774E-03_JPRB, 0.36765623E-03_JPRB, 0.36769448E-03_JPRB, &
  & 0.36774084E-03_JPRB, 0.36779564E-03_JPRB, 0.36785976E-03_JPRB, 0.36793455E-03_JPRB, 0.36801971E-03_JPRB, 0.36811465E-03_JPRB, &
  & 0.36821800E-03_JPRB, 0.36832839E-03_JPRB, 0.36844434E-03_JPRB, 0.36856311E-03_JPRB, 0.36868220E-03_JPRB, 0.36879943E-03_JPRB, &
  & 0.36891171E-03_JPRB, 0.36901495E-03_JPRB, 0.36910773E-03_JPRB, 0.36918849E-03_JPRB, 0.36925331E-03_JPRB, 0.36930144E-03_JPRB, &
  & 0.36933148E-03_JPRB, 0.36934018E-03_JPRB, 0.36932691E-03_JPRB, 0.36929053E-03_JPRB, 0.36923250E-03_JPRB, 0.36915721E-03_JPRB, &
  & 0.36907138E-03_JPRB, 0.36898343E-03_JPRB, 0.36890211E-03_JPRB, 0.36883837E-03_JPRB, 0.36879364E-03_JPRB, 0.36876413E-03_JPRB, &
  & 0.36875033E-03_JPRB, 0.36874402E-03_JPRB, 0.36873948E-03_JPRB, 0.36873398E-03_JPRB, 0.36872493E-03_JPRB, 0.36870927E-03_JPRB, &
  & 0.36868444E-03_JPRB, 0.36864873E-03_JPRB, 0.36860071E-03_JPRB, 0.36853930E-03_JPRB, 0.36846360E-03_JPRB, 0.36837289E-03_JPRB, &
  & 0.36826785E-03_JPRB, 0.36814995E-03_JPRB, 0.36802248E-03_JPRB, 0.36789008E-03_JPRB, 0.36775786E-03_JPRB, 0.36763193E-03_JPRB, &
  & 0.36751752E-03_JPRB, 0.36741796E-03_JPRB, 0.36733408E-03_JPRB, 0.36726528E-03_JPRB, 0.36720996E-03_JPRB, 0.36716624E-03_JPRB, &
  & 0.36713312E-03_JPRB, 0.36710483E-03_JPRB, 0.36707951E-03_JPRB, 0.36703466E-03_JPRB /)

RGHG1(:,16,12) = (/ &
  & 0.36792067E-03_JPRB, 0.36790784E-03_JPRB, 0.36792125E-03_JPRB, 0.36794762E-03_JPRB, 0.36798432E-03_JPRB, 0.36803022E-03_JPRB, &
  & 0.36808438E-03_JPRB, 0.36814678E-03_JPRB, 0.36821730E-03_JPRB, 0.36829649E-03_JPRB, 0.36838447E-03_JPRB, 0.36847990E-03_JPRB, &
  & 0.36858092E-03_JPRB, 0.36868616E-03_JPRB, 0.36879379E-03_JPRB, 0.36890226E-03_JPRB, 0.36900910E-03_JPRB, 0.36911247E-03_JPRB, &
  & 0.36921020E-03_JPRB, 0.36929833E-03_JPRB, 0.36937668E-03_JPRB, 0.36944301E-03_JPRB, 0.36949452E-03_JPRB, 0.36953099E-03_JPRB, &
  & 0.36955011E-03_JPRB, 0.36954973E-03_JPRB, 0.36952901E-03_JPRB, 0.36948762E-03_JPRB, 0.36942845E-03_JPRB, 0.36935555E-03_JPRB, &
  & 0.36927743E-03_JPRB, 0.36920229E-03_JPRB, 0.36914033E-03_JPRB, 0.36909399E-03_JPRB, 0.36906908E-03_JPRB, 0.36906317E-03_JPRB, &
  & 0.36906602E-03_JPRB, 0.36907228E-03_JPRB, 0.36907732E-03_JPRB, 0.36907766E-03_JPRB, 0.36907123E-03_JPRB, 0.36905656E-03_JPRB, &
  & 0.36903284E-03_JPRB, 0.36899952E-03_JPRB, 0.36895624E-03_JPRB, 0.36890194E-03_JPRB, 0.36883546E-03_JPRB, 0.36875557E-03_JPRB, &
  & 0.36866151E-03_JPRB, 0.36855447E-03_JPRB, 0.36843700E-03_JPRB, 0.36831241E-03_JPRB, 0.36818534E-03_JPRB, 0.36806072E-03_JPRB, &
  & 0.36794317E-03_JPRB, 0.36783671E-03_JPRB, 0.36774349E-03_JPRB, 0.36766403E-03_JPRB, 0.36759785E-03_JPRB, 0.36754421E-03_JPRB, &
  & 0.36750035E-03_JPRB, 0.36746674E-03_JPRB, 0.36742969E-03_JPRB, 0.36737756E-03_JPRB /)

RGHG1(:,17,12) = (/ &
  & 0.36816747E-03_JPRB, 0.36817635E-03_JPRB, 0.36820129E-03_JPRB, 0.36823729E-03_JPRB, 0.36828275E-03_JPRB, 0.36833624E-03_JPRB, &
  & 0.36839664E-03_JPRB, 0.36846427E-03_JPRB, 0.36853962E-03_JPRB, 0.36862210E-03_JPRB, 0.36871101E-03_JPRB, 0.36880476E-03_JPRB, &
  & 0.36890147E-03_JPRB, 0.36899972E-03_JPRB, 0.36909812E-03_JPRB, 0.36919516E-03_JPRB, 0.36928925E-03_JPRB, 0.36937903E-03_JPRB, &
  & 0.36946248E-03_JPRB, 0.36953669E-03_JPRB, 0.36960142E-03_JPRB, 0.36965471E-03_JPRB, 0.36969432E-03_JPRB, 0.36971990E-03_JPRB, &
  & 0.36972959E-03_JPRB, 0.36972231E-03_JPRB, 0.36969781E-03_JPRB, 0.36965718E-03_JPRB, 0.36960290E-03_JPRB, 0.36954100E-03_JPRB, &
  & 0.36947933E-03_JPRB, 0.36942397E-03_JPRB, 0.36938241E-03_JPRB, 0.36936131E-03_JPRB, 0.36935677E-03_JPRB, 0.36936472E-03_JPRB, &
  & 0.36937982E-03_JPRB, 0.36939411E-03_JPRB, 0.36940261E-03_JPRB, 0.36940316E-03_JPRB, 0.36939466E-03_JPRB, 0.36937671E-03_JPRB, &
  & 0.36935031E-03_JPRB, 0.36931579E-03_JPRB, 0.36927339E-03_JPRB, 0.36922281E-03_JPRB, 0.36916265E-03_JPRB, 0.36909126E-03_JPRB, &
  & 0.36900805E-03_JPRB, 0.36891291E-03_JPRB, 0.36880776E-03_JPRB, 0.36869507E-03_JPRB, 0.36857795E-03_JPRB, 0.36846017E-03_JPRB, &
  & 0.36834643E-03_JPRB, 0.36824052E-03_JPRB, 0.36814535E-03_JPRB, 0.36806197E-03_JPRB, 0.36799067E-03_JPRB, 0.36793121E-03_JPRB, &
  & 0.36788365E-03_JPRB, 0.36784227E-03_JPRB, 0.36780498E-03_JPRB, 0.36773802E-03_JPRB /)

RGHG1(:,18,12) = (/ &
  & 0.36839608E-03_JPRB, 0.36842431E-03_JPRB, 0.36845854E-03_JPRB, 0.36850071E-03_JPRB, 0.36855074E-03_JPRB, 0.36860831E-03_JPRB, &
  & 0.36867222E-03_JPRB, 0.36874265E-03_JPRB, 0.36881925E-03_JPRB, 0.36890173E-03_JPRB, 0.36898916E-03_JPRB, 0.36907973E-03_JPRB, &
  & 0.36917147E-03_JPRB, 0.36926294E-03_JPRB, 0.36935246E-03_JPRB, 0.36943951E-03_JPRB, 0.36952278E-03_JPRB, 0.36960121E-03_JPRB, &
  & 0.36967304E-03_JPRB, 0.36973608E-03_JPRB, 0.36978960E-03_JPRB, 0.36983212E-03_JPRB, 0.36986190E-03_JPRB, 0.36987857E-03_JPRB, &
  & 0.36988131E-03_JPRB, 0.36986978E-03_JPRB, 0.36984461E-03_JPRB, 0.36980855E-03_JPRB, 0.36976559E-03_JPRB, 0.36972080E-03_JPRB, &
  & 0.36967851E-03_JPRB, 0.36964784E-03_JPRB, 0.36963014E-03_JPRB, 0.36962566E-03_JPRB, 0.36963509E-03_JPRB, 0.36965290E-03_JPRB, &
  & 0.36967258E-03_JPRB, 0.36968791E-03_JPRB, 0.36969452E-03_JPRB, 0.36969135E-03_JPRB, 0.36967805E-03_JPRB, 0.36965581E-03_JPRB, &
  & 0.36962604E-03_JPRB, 0.36958966E-03_JPRB, 0.36954731E-03_JPRB, 0.36949874E-03_JPRB, 0.36944303E-03_JPRB, 0.36937869E-03_JPRB, &
  & 0.36930473E-03_JPRB, 0.36922126E-03_JPRB, 0.36912895E-03_JPRB, 0.36902924E-03_JPRB, 0.36892426E-03_JPRB, 0.36881751E-03_JPRB, &
  & 0.36871270E-03_JPRB, 0.36861363E-03_JPRB, 0.36852292E-03_JPRB, 0.36844201E-03_JPRB, 0.36837163E-03_JPRB, 0.36831206E-03_JPRB, &
  & 0.36826343E-03_JPRB, 0.36822254E-03_JPRB, 0.36818243E-03_JPRB, 0.36811540E-03_JPRB /)

RGHG1(:,19,12) = (/ &
  & 0.36859891E-03_JPRB, 0.36864338E-03_JPRB, 0.36868377E-03_JPRB, 0.36872970E-03_JPRB, 0.36878235E-03_JPRB, 0.36884114E-03_JPRB, &
  & 0.36890604E-03_JPRB, 0.36897644E-03_JPRB, 0.36905243E-03_JPRB, 0.36913331E-03_JPRB, 0.36921792E-03_JPRB, 0.36930447E-03_JPRB, &
  & 0.36939094E-03_JPRB, 0.36947615E-03_JPRB, 0.36955875E-03_JPRB, 0.36963797E-03_JPRB, 0.36971286E-03_JPRB, 0.36978282E-03_JPRB, &
  & 0.36984641E-03_JPRB, 0.36990145E-03_JPRB, 0.36994694E-03_JPRB, 0.36998148E-03_JPRB, 0.37000416E-03_JPRB, 0.37001446E-03_JPRB, &
  & 0.37001289E-03_JPRB, 0.36999997E-03_JPRB, 0.36997811E-03_JPRB, 0.36995063E-03_JPRB, 0.36992138E-03_JPRB, 0.36989423E-03_JPRB, &
  & 0.36987511E-03_JPRB, 0.36986402E-03_JPRB, 0.36986393E-03_JPRB, 0.36987360E-03_JPRB, 0.36988992E-03_JPRB, 0.36990919E-03_JPRB, &
  & 0.36992668E-03_JPRB, 0.36993751E-03_JPRB, 0.36993914E-03_JPRB, 0.36993108E-03_JPRB, 0.36991382E-03_JPRB, 0.36988838E-03_JPRB, &
  & 0.36985660E-03_JPRB, 0.36981923E-03_JPRB, 0.36977741E-03_JPRB, 0.36973099E-03_JPRB, 0.36967907E-03_JPRB, 0.36962068E-03_JPRB, &
  & 0.36955503E-03_JPRB, 0.36948174E-03_JPRB, 0.36940110E-03_JPRB, 0.36931408E-03_JPRB, 0.36922225E-03_JPRB, 0.36912810E-03_JPRB, &
  & 0.36903485E-03_JPRB, 0.36894582E-03_JPRB, 0.36886349E-03_JPRB, 0.36878930E-03_JPRB, 0.36872408E-03_JPRB, 0.36866858E-03_JPRB, &
  & 0.36862204E-03_JPRB, 0.36858479E-03_JPRB, 0.36854463E-03_JPRB, 0.36848552E-03_JPRB /)

RGHG1(:,20,12) = (/ &
  & 0.36878133E-03_JPRB, 0.36883206E-03_JPRB, 0.36887507E-03_JPRB, 0.36892242E-03_JPRB, 0.36897548E-03_JPRB, 0.36903474E-03_JPRB, &
  & 0.36909900E-03_JPRB, 0.36916853E-03_JPRB, 0.36924236E-03_JPRB, 0.36932042E-03_JPRB, 0.36940168E-03_JPRB, 0.36948384E-03_JPRB, &
  & 0.36956565E-03_JPRB, 0.36964566E-03_JPRB, 0.36972307E-03_JPRB, 0.36979700E-03_JPRB, 0.36986650E-03_JPRB, 0.36993079E-03_JPRB, &
  & 0.36998885E-03_JPRB, 0.37003879E-03_JPRB, 0.37007942E-03_JPRB, 0.37010916E-03_JPRB, 0.37012756E-03_JPRB, 0.37013454E-03_JPRB, &
  & 0.37013122E-03_JPRB, 0.37011967E-03_JPRB, 0.37010352E-03_JPRB, 0.37008568E-03_JPRB, 0.37007051E-03_JPRB, 0.37006114E-03_JPRB, &
  & 0.37005838E-03_JPRB, 0.37006353E-03_JPRB, 0.37007447E-03_JPRB, 0.37008955E-03_JPRB, 0.37010660E-03_JPRB, 0.37012232E-03_JPRB, &
  & 0.37013472E-03_JPRB, 0.37014051E-03_JPRB, 0.37013757E-03_JPRB, 0.37012497E-03_JPRB, 0.37010480E-03_JPRB, 0.37007773E-03_JPRB, &
  & 0.37004534E-03_JPRB, 0.37000852E-03_JPRB, 0.36996798E-03_JPRB, 0.36992365E-03_JPRB, 0.36987531E-03_JPRB, 0.36982249E-03_JPRB, &
  & 0.36976411E-03_JPRB, 0.36969973E-03_JPRB, 0.36962962E-03_JPRB, 0.36955453E-03_JPRB, 0.36947546E-03_JPRB, 0.36939455E-03_JPRB, &
  & 0.36931416E-03_JPRB, 0.36923710E-03_JPRB, 0.36916538E-03_JPRB, 0.36910022E-03_JPRB, 0.36904265E-03_JPRB, 0.36899297E-03_JPRB, &
  & 0.36895263E-03_JPRB, 0.36891640E-03_JPRB, 0.36888500E-03_JPRB, 0.36882283E-03_JPRB /)

RGHG1(:,21,12) = (/ &
  & 0.36894466E-03_JPRB, 0.36899879E-03_JPRB, 0.36904169E-03_JPRB, 0.36908762E-03_JPRB, 0.36913922E-03_JPRB, 0.36919664E-03_JPRB, &
  & 0.36925927E-03_JPRB, 0.36932624E-03_JPRB, 0.36939714E-03_JPRB, 0.36947173E-03_JPRB, 0.36954888E-03_JPRB, 0.36962723E-03_JPRB, &
  & 0.36970494E-03_JPRB, 0.36978084E-03_JPRB, 0.36985424E-03_JPRB, 0.36992444E-03_JPRB, 0.36999077E-03_JPRB, 0.37005192E-03_JPRB, &
  & 0.37010683E-03_JPRB, 0.37015422E-03_JPRB, 0.37019243E-03_JPRB, 0.37022014E-03_JPRB, 0.37023693E-03_JPRB, 0.37024336E-03_JPRB, &
  & 0.37024106E-03_JPRB, 0.37023303E-03_JPRB, 0.37022290E-03_JPRB, 0.37021431E-03_JPRB, 0.37021071E-03_JPRB, 0.37021350E-03_JPRB, &
  & 0.37022243E-03_JPRB, 0.37023559E-03_JPRB, 0.37025131E-03_JPRB, 0.37026708E-03_JPRB, 0.37028117E-03_JPRB, 0.37029223E-03_JPRB, &
  & 0.37029866E-03_JPRB, 0.37029854E-03_JPRB, 0.37029167E-03_JPRB, 0.37027750E-03_JPRB, 0.37025643E-03_JPRB, 0.37022948E-03_JPRB, &
  & 0.37019807E-03_JPRB, 0.37016283E-03_JPRB, 0.37012427E-03_JPRB, 0.37008242E-03_JPRB, 0.37003777E-03_JPRB, 0.36998969E-03_JPRB, &
  & 0.36993760E-03_JPRB, 0.36988122E-03_JPRB, 0.36982098E-03_JPRB, 0.36975718E-03_JPRB, 0.36969039E-03_JPRB, 0.36962217E-03_JPRB, &
  & 0.36955427E-03_JPRB, 0.36948890E-03_JPRB, 0.36942767E-03_JPRB, 0.36937170E-03_JPRB, 0.36932193E-03_JPRB, 0.36927901E-03_JPRB, &
  & 0.36924222E-03_JPRB, 0.36921300E-03_JPRB, 0.36917871E-03_JPRB, 0.36913031E-03_JPRB /)

RGHG1(:,22,12) = (/ &
  & 0.36909099E-03_JPRB, 0.36914516E-03_JPRB, 0.36918689E-03_JPRB, 0.36923081E-03_JPRB, 0.36927982E-03_JPRB, 0.36933416E-03_JPRB, &
  & 0.36939318E-03_JPRB, 0.36945683E-03_JPRB, 0.36952406E-03_JPRB, 0.36959469E-03_JPRB, 0.36966807E-03_JPRB, 0.36974231E-03_JPRB, &
  & 0.36981664E-03_JPRB, 0.36988946E-03_JPRB, 0.36995995E-03_JPRB, 0.37002741E-03_JPRB, 0.37009155E-03_JPRB, 0.37015142E-03_JPRB, &
  & 0.37020532E-03_JPRB, 0.37025212E-03_JPRB, 0.37028993E-03_JPRB, 0.37031784E-03_JPRB, 0.37033559E-03_JPRB, 0.37034391E-03_JPRB, &
  & 0.37034493E-03_JPRB, 0.37034196E-03_JPRB, 0.37033833E-03_JPRB, 0.37033754E-03_JPRB, 0.37034159E-03_JPRB, 0.37035061E-03_JPRB, &
  & 0.37036356E-03_JPRB, 0.37037893E-03_JPRB, 0.37039432E-03_JPRB, 0.37040768E-03_JPRB, 0.37041816E-03_JPRB, 0.37042482E-03_JPRB, &
  & 0.37042738E-03_JPRB, 0.37042392E-03_JPRB, 0.37041449E-03_JPRB, 0.37039843E-03_JPRB, 0.37037735E-03_JPRB, 0.37035177E-03_JPRB, &
  & 0.37032180E-03_JPRB, 0.37028865E-03_JPRB, 0.37025221E-03_JPRB, 0.37021312E-03_JPRB, 0.37017191E-03_JPRB, 0.37012837E-03_JPRB, &
  & 0.37008227E-03_JPRB, 0.37003343E-03_JPRB, 0.36998180E-03_JPRB, 0.36992776E-03_JPRB, 0.36987170E-03_JPRB, 0.36981460E-03_JPRB, &
  & 0.36975788E-03_JPRB, 0.36970276E-03_JPRB, 0.36965063E-03_JPRB, 0.36960258E-03_JPRB, 0.36955942E-03_JPRB, 0.36952161E-03_JPRB, &
  & 0.36949024E-03_JPRB, 0.36946125E-03_JPRB, 0.36943582E-03_JPRB, 0.36938506E-03_JPRB /)

RGHG1(:,23,12) = (/ &
  & 0.36922237E-03_JPRB, 0.36927414E-03_JPRB, 0.36931387E-03_JPRB, 0.36935508E-03_JPRB, 0.36940063E-03_JPRB, 0.36945136E-03_JPRB, &
  & 0.36950677E-03_JPRB, 0.36956617E-03_JPRB, 0.36962953E-03_JPRB, 0.36969627E-03_JPRB, 0.36976574E-03_JPRB, 0.36983666E-03_JPRB, &
  & 0.36990779E-03_JPRB, 0.36997788E-03_JPRB, 0.37004644E-03_JPRB, 0.37011254E-03_JPRB, 0.37017511E-03_JPRB, 0.37023381E-03_JPRB, &
  & 0.37028731E-03_JPRB, 0.37033454E-03_JPRB, 0.37037372E-03_JPRB, 0.37040387E-03_JPRB, 0.37042468E-03_JPRB, 0.37043693E-03_JPRB, &
  & 0.37044284E-03_JPRB, 0.37044549E-03_JPRB, 0.37044729E-03_JPRB, 0.37045107E-03_JPRB, 0.37045829E-03_JPRB, 0.37046886E-03_JPRB, &
  & 0.37048187E-03_JPRB, 0.37049552E-03_JPRB, 0.37050783E-03_JPRB, 0.37051766E-03_JPRB, 0.37052453E-03_JPRB, 0.37052733E-03_JPRB, &
  & 0.37052622E-03_JPRB, 0.37052046E-03_JPRB, 0.37051013E-03_JPRB, 0.37049467E-03_JPRB, 0.37047459E-03_JPRB, 0.37045055E-03_JPRB, &
  & 0.37042238E-03_JPRB, 0.37039159E-03_JPRB, 0.37035753E-03_JPRB, 0.37032139E-03_JPRB, 0.37028361E-03_JPRB, 0.37024420E-03_JPRB, &
  & 0.37020323E-03_JPRB, 0.37016039E-03_JPRB, 0.37011591E-03_JPRB, 0.37006996E-03_JPRB, 0.37002284E-03_JPRB, 0.36997505E-03_JPRB, &
  & 0.36992721E-03_JPRB, 0.36988046E-03_JPRB, 0.36983559E-03_JPRB, 0.36979379E-03_JPRB, 0.36975561E-03_JPRB, 0.36972205E-03_JPRB, &
  & 0.36969275E-03_JPRB, 0.36966798E-03_JPRB, 0.36964004E-03_JPRB, 0.36959714E-03_JPRB /)

RGHG1(:,24,12) = (/ &
  & 0.36933931E-03_JPRB, 0.36938844E-03_JPRB, 0.36942572E-03_JPRB, 0.36946384E-03_JPRB, 0.36950599E-03_JPRB, 0.36955273E-03_JPRB, &
  & 0.36960392E-03_JPRB, 0.36965942E-03_JPRB, 0.36971885E-03_JPRB, 0.36978183E-03_JPRB, 0.36984790E-03_JPRB, 0.36991551E-03_JPRB, &
  & 0.36998355E-03_JPRB, 0.37005096E-03_JPRB, 0.37011708E-03_JPRB, 0.37018131E-03_JPRB, 0.37024310E-03_JPRB, 0.37030151E-03_JPRB, &
  & 0.37035567E-03_JPRB, 0.37040396E-03_JPRB, 0.37044514E-03_JPRB, 0.37047811E-03_JPRB, 0.37050268E-03_JPRB, 0.37051985E-03_JPRB, &
  & 0.37053120E-03_JPRB, 0.37053894E-03_JPRB, 0.37054496E-03_JPRB, 0.37055145E-03_JPRB, 0.37055937E-03_JPRB, 0.37056889E-03_JPRB, &
  & 0.37057934E-03_JPRB, 0.37058935E-03_JPRB, 0.37059790E-03_JPRB, 0.37060393E-03_JPRB, 0.37060754E-03_JPRB, 0.37060783E-03_JPRB, &
  & 0.37060471E-03_JPRB, 0.37059793E-03_JPRB, 0.37058702E-03_JPRB, 0.37057209E-03_JPRB, 0.37055355E-03_JPRB, 0.37053111E-03_JPRB, &
  & 0.37050553E-03_JPRB, 0.37047674E-03_JPRB, 0.37044543E-03_JPRB, 0.37041193E-03_JPRB, 0.37037706E-03_JPRB, 0.37034112E-03_JPRB, &
  & 0.37030433E-03_JPRB, 0.37026641E-03_JPRB, 0.37022764E-03_JPRB, 0.37018803E-03_JPRB, 0.37014773E-03_JPRB, 0.37010707E-03_JPRB, &
  & 0.37006661E-03_JPRB, 0.37002651E-03_JPRB, 0.36998763E-03_JPRB, 0.36995052E-03_JPRB, 0.36991615E-03_JPRB, 0.36988518E-03_JPRB, &
  & 0.36985817E-03_JPRB, 0.36983352E-03_JPRB, 0.36980934E-03_JPRB, 0.36976626E-03_JPRB /)

RGHG1(:,25,12) = (/ &
  & 0.36944493E-03_JPRB, 0.36949132E-03_JPRB, 0.36952560E-03_JPRB, 0.36956047E-03_JPRB, 0.36959894E-03_JPRB, 0.36964190E-03_JPRB, &
  & 0.36968949E-03_JPRB, 0.36974132E-03_JPRB, 0.36979705E-03_JPRB, 0.36985645E-03_JPRB, 0.36991888E-03_JPRB, 0.36998332E-03_JPRB, &
  & 0.37004860E-03_JPRB, 0.37011382E-03_JPRB, 0.37017796E-03_JPRB, 0.37024065E-03_JPRB, 0.37030113E-03_JPRB, 0.37035864E-03_JPRB, &
  & 0.37041245E-03_JPRB, 0.37046126E-03_JPRB, 0.37050407E-03_JPRB, 0.37054002E-03_JPRB, 0.37056865E-03_JPRB, 0.37059034E-03_JPRB, &
  & 0.37060631E-03_JPRB, 0.37061813E-03_JPRB, 0.37062750E-03_JPRB, 0.37063565E-03_JPRB, 0.37064328E-03_JPRB, 0.37065076E-03_JPRB, &
  & 0.37065794E-03_JPRB, 0.37066446E-03_JPRB, 0.37066944E-03_JPRB, 0.37067253E-03_JPRB, 0.37067352E-03_JPRB, 0.37067200E-03_JPRB, &
  & 0.37066761E-03_JPRB, 0.37065998E-03_JPRB, 0.37064942E-03_JPRB, 0.37063524E-03_JPRB, 0.37061804E-03_JPRB, 0.37059758E-03_JPRB, &
  & 0.37057427E-03_JPRB, 0.37054782E-03_JPRB, 0.37051889E-03_JPRB, 0.37048786E-03_JPRB, 0.37045556E-03_JPRB, 0.37042249E-03_JPRB, &
  & 0.37038873E-03_JPRB, 0.37035468E-03_JPRB, 0.37032017E-03_JPRB, 0.37028550E-03_JPRB, 0.37025049E-03_JPRB, 0.37021539E-03_JPRB, &
  & 0.37018032E-03_JPRB, 0.37014560E-03_JPRB, 0.37011149E-03_JPRB, 0.37007860E-03_JPRB, 0.37004746E-03_JPRB, 0.37001891E-03_JPRB, &
  & 0.36999339E-03_JPRB, 0.36997025E-03_JPRB, 0.36994612E-03_JPRB, 0.36990386E-03_JPRB /)

RGHG1(:,26,12) = (/ &
  & 0.36954187E-03_JPRB, 0.36958538E-03_JPRB, 0.36961676E-03_JPRB, 0.36964868E-03_JPRB, 0.36968369E-03_JPRB, 0.36972328E-03_JPRB, &
  & 0.36976731E-03_JPRB, 0.36981553E-03_JPRB, 0.36986780E-03_JPRB, 0.36992342E-03_JPRB, 0.36998239E-03_JPRB, 0.37004321E-03_JPRB, &
  & 0.37010518E-03_JPRB, 0.37016743E-03_JPRB, 0.37022910E-03_JPRB, 0.37028972E-03_JPRB, 0.37034851E-03_JPRB, 0.37040480E-03_JPRB, &
  & 0.37045809E-03_JPRB, 0.37050745E-03_JPRB, 0.37055166E-03_JPRB, 0.37058987E-03_JPRB, 0.37062162E-03_JPRB, 0.37064691E-03_JPRB, &
  & 0.37066679E-03_JPRB, 0.37068201E-03_JPRB, 0.37069380E-03_JPRB, 0.37070314E-03_JPRB, 0.37071036E-03_JPRB, 0.37071615E-03_JPRB, &
  & 0.37072113E-03_JPRB, 0.37072468E-03_JPRB, 0.37072689E-03_JPRB, 0.37072747E-03_JPRB, 0.37072669E-03_JPRB, 0.37072395E-03_JPRB, &
  & 0.37071883E-03_JPRB, 0.37071120E-03_JPRB, 0.37070099E-03_JPRB, 0.37068804E-03_JPRB, 0.37067226E-03_JPRB, 0.37065355E-03_JPRB, &
  & 0.37063216E-03_JPRB, 0.37060783E-03_JPRB, 0.37058099E-03_JPRB, 0.37055198E-03_JPRB, 0.37052180E-03_JPRB, 0.37049095E-03_JPRB, &
  & 0.37045972E-03_JPRB, 0.37042843E-03_JPRB, 0.37039706E-03_JPRB, 0.37036580E-03_JPRB, 0.37033469E-03_JPRB, 0.37030369E-03_JPRB, &
  & 0.37027319E-03_JPRB, 0.37024287E-03_JPRB, 0.37021312E-03_JPRB, 0.37018408E-03_JPRB, 0.37015622E-03_JPRB, 0.37013026E-03_JPRB, &
  & 0.37010631E-03_JPRB, 0.37008469E-03_JPRB, 0.37006056E-03_JPRB, 0.37002194E-03_JPRB /)

RGHG1(:,27,12) = (/ &
  & 0.36963308E-03_JPRB, 0.36967394E-03_JPRB, 0.36970279E-03_JPRB, 0.36973169E-03_JPRB, 0.36976387E-03_JPRB, 0.36980005E-03_JPRB, &
  & 0.36984088E-03_JPRB, 0.36988576E-03_JPRB, 0.36993428E-03_JPRB, 0.36998646E-03_JPRB, 0.37004158E-03_JPRB, 0.37009877E-03_JPRB, &
  & 0.37015718E-03_JPRB, 0.37021615E-03_JPRB, 0.37027471E-03_JPRB, 0.37033265E-03_JPRB, 0.37038932E-03_JPRB, 0.37044412E-03_JPRB, &
  & 0.37049642E-03_JPRB, 0.37054525E-03_JPRB, 0.37058967E-03_JPRB, 0.37062907E-03_JPRB, 0.37066272E-03_JPRB, 0.37069054E-03_JPRB, &
  & 0.37071330E-03_JPRB, 0.37073132E-03_JPRB, 0.37074537E-03_JPRB, 0.37075579E-03_JPRB, 0.37076342E-03_JPRB, 0.37076845E-03_JPRB, &
  & 0.37077189E-03_JPRB, 0.37077349E-03_JPRB, 0.37077369E-03_JPRB, 0.37077290E-03_JPRB, 0.37077069E-03_JPRB, 0.37076697E-03_JPRB, &
  & 0.37076147E-03_JPRB, 0.37075393E-03_JPRB, 0.37074438E-03_JPRB, 0.37073254E-03_JPRB, 0.37071813E-03_JPRB, 0.37070119E-03_JPRB, &
  & 0.37068164E-03_JPRB, 0.37065917E-03_JPRB, 0.37063399E-03_JPRB, 0.37060693E-03_JPRB, 0.37057837E-03_JPRB, 0.37054921E-03_JPRB, &
  & 0.37051967E-03_JPRB, 0.37049036E-03_JPRB, 0.37046126E-03_JPRB, 0.37043268E-03_JPRB, 0.37040454E-03_JPRB, 0.37037703E-03_JPRB, &
  & 0.37035008E-03_JPRB, 0.37032360E-03_JPRB, 0.37029746E-03_JPRB, 0.37027206E-03_JPRB, 0.37024758E-03_JPRB, 0.37022456E-03_JPRB, &
  & 0.37020346E-03_JPRB, 0.37018297E-03_JPRB, 0.37016234E-03_JPRB, 0.37012380E-03_JPRB /)

RGHG1(:,28,12) = (/ &
  & 0.36972083E-03_JPRB, 0.36975907E-03_JPRB, 0.36978564E-03_JPRB, 0.36981219E-03_JPRB, 0.36984141E-03_JPRB, 0.36987479E-03_JPRB, &
  & 0.36991239E-03_JPRB, 0.36995386E-03_JPRB, 0.36999883E-03_JPRB, 0.37004711E-03_JPRB, 0.37009813E-03_JPRB, 0.37015157E-03_JPRB, &
  & 0.37020619E-03_JPRB, 0.37026173E-03_JPRB, 0.37031737E-03_JPRB, 0.37037241E-03_JPRB, 0.37042639E-03_JPRB, 0.37047875E-03_JPRB, &
  & 0.37052916E-03_JPRB, 0.37057660E-03_JPRB, 0.37062040E-03_JPRB, 0.37065987E-03_JPRB, 0.37069459E-03_JPRB, 0.37072424E-03_JPRB, &
  & 0.37074910E-03_JPRB, 0.37076909E-03_JPRB, 0.37078495E-03_JPRB, 0.37079677E-03_JPRB, 0.37080509E-03_JPRB, 0.37081004E-03_JPRB, &
  & 0.37081266E-03_JPRB, 0.37081336E-03_JPRB, 0.37081249E-03_JPRB, 0.37081057E-03_JPRB, 0.37080754E-03_JPRB, 0.37080335E-03_JPRB, &
  & 0.37079788E-03_JPRB, 0.37079060E-03_JPRB, 0.37078178E-03_JPRB, 0.37077093E-03_JPRB, 0.37075780E-03_JPRB, 0.37074235E-03_JPRB, &
  & 0.37072433E-03_JPRB, 0.37070364E-03_JPRB, 0.37068009E-03_JPRB, 0.37065428E-03_JPRB, 0.37062698E-03_JPRB, 0.37059883E-03_JPRB, &
  & 0.37057066E-03_JPRB, 0.37054290E-03_JPRB, 0.37051577E-03_JPRB, 0.37048926E-03_JPRB, 0.37046373E-03_JPRB, 0.37043885E-03_JPRB, &
  & 0.37041481E-03_JPRB, 0.37039156E-03_JPRB, 0.37036883E-03_JPRB, 0.37034653E-03_JPRB, 0.37032520E-03_JPRB, 0.37030494E-03_JPRB, &
  & 0.37028603E-03_JPRB, 0.37026856E-03_JPRB, 0.37024874E-03_JPRB, 0.37021635E-03_JPRB /)

RGHG1(:,29,12) = (/ &
  & 0.36980587E-03_JPRB, 0.36984184E-03_JPRB, 0.36986647E-03_JPRB, 0.36989077E-03_JPRB, 0.36991789E-03_JPRB, 0.36994851E-03_JPRB, &
  & 0.36998323E-03_JPRB, 0.37002147E-03_JPRB, 0.37006268E-03_JPRB, 0.37010683E-03_JPRB, 0.37015355E-03_JPRB, 0.37020267E-03_JPRB, &
  & 0.37025358E-03_JPRB, 0.37030518E-03_JPRB, 0.37035721E-03_JPRB, 0.37040902E-03_JPRB, 0.37046030E-03_JPRB, 0.37051018E-03_JPRB, &
  & 0.37055821E-03_JPRB, 0.37060393E-03_JPRB, 0.37064654E-03_JPRB, 0.37068556E-03_JPRB, 0.37072058E-03_JPRB, 0.37075111E-03_JPRB, &
  & 0.37077730E-03_JPRB, 0.37079895E-03_JPRB, 0.37081627E-03_JPRB, 0.37082937E-03_JPRB, 0.37083833E-03_JPRB, 0.37084363E-03_JPRB, &
  & 0.37084633E-03_JPRB, 0.37084648E-03_JPRB, 0.37084494E-03_JPRB, 0.37084261E-03_JPRB, 0.37083903E-03_JPRB, 0.37083452E-03_JPRB, &
  & 0.37082893E-03_JPRB, 0.37082218E-03_JPRB, 0.37081400E-03_JPRB, 0.37080413E-03_JPRB, 0.37079226E-03_JPRB, 0.37077826E-03_JPRB, &
  & 0.37076161E-03_JPRB, 0.37074214E-03_JPRB, 0.37072005E-03_JPRB, 0.37069543E-03_JPRB, 0.37066906E-03_JPRB, 0.37064205E-03_JPRB, &
  & 0.37061505E-03_JPRB, 0.37058844E-03_JPRB, 0.37056289E-03_JPRB, 0.37053833E-03_JPRB, 0.37051484E-03_JPRB, 0.37049226E-03_JPRB, &
  & 0.37047069E-03_JPRB, 0.37044985E-03_JPRB, 0.37042960E-03_JPRB, 0.37040989E-03_JPRB, 0.37039100E-03_JPRB, 0.37037345E-03_JPRB, &
  & 0.37035710E-03_JPRB, 0.37034144E-03_JPRB, 0.37032523E-03_JPRB, 0.37029592E-03_JPRB /)

RGHG1(:,30,12) = (/ &
  & 0.36988864E-03_JPRB, 0.36992269E-03_JPRB, 0.36994577E-03_JPRB, 0.36996871E-03_JPRB, 0.36999359E-03_JPRB, 0.37002205E-03_JPRB, &
  & 0.37005392E-03_JPRB, 0.37008873E-03_JPRB, 0.37012633E-03_JPRB, 0.37016621E-03_JPRB, 0.37020867E-03_JPRB, 0.37025337E-03_JPRB, &
  & 0.37029997E-03_JPRB, 0.37034776E-03_JPRB, 0.37039630E-03_JPRB, 0.37044499E-03_JPRB, 0.37049328E-03_JPRB, 0.37054063E-03_JPRB, &
  & 0.37058638E-03_JPRB, 0.37062995E-03_JPRB, 0.37067092E-03_JPRB, 0.37070899E-03_JPRB, 0.37074360E-03_JPRB, 0.37077445E-03_JPRB, &
  & 0.37080114E-03_JPRB, 0.37082372E-03_JPRB, 0.37084203E-03_JPRB, 0.37085603E-03_JPRB, 0.37086583E-03_JPRB, 0.37087168E-03_JPRB, &
  & 0.37087439E-03_JPRB, 0.37087456E-03_JPRB, 0.37087276E-03_JPRB, 0.37086991E-03_JPRB, 0.37086610E-03_JPRB, 0.37086170E-03_JPRB, &
  & 0.37085640E-03_JPRB, 0.37085003E-03_JPRB, 0.37084246E-03_JPRB, 0.37083350E-03_JPRB, 0.37082276E-03_JPRB, 0.37080972E-03_JPRB, &
  & 0.37079427E-03_JPRB, 0.37077599E-03_JPRB, 0.37075501E-03_JPRB, 0.37073140E-03_JPRB, 0.37070602E-03_JPRB, 0.37067998E-03_JPRB, &
  & 0.37065404E-03_JPRB, 0.37062884E-03_JPRB, 0.37060466E-03_JPRB, 0.37058163E-03_JPRB, 0.37055989E-03_JPRB, 0.37053908E-03_JPRB, &
  & 0.37051929E-03_JPRB, 0.37050026E-03_JPRB, 0.37048172E-03_JPRB, 0.37046391E-03_JPRB, 0.37044712E-03_JPRB, 0.37043149E-03_JPRB, &
  & 0.37041737E-03_JPRB, 0.37040398E-03_JPRB, 0.37038926E-03_JPRB, 0.37036455E-03_JPRB /)

RGHG1(:,31,12) = (/ &
  & 0.36997051E-03_JPRB, 0.37000279E-03_JPRB, 0.37002441E-03_JPRB, 0.37004563E-03_JPRB, 0.37006880E-03_JPRB, 0.37009508E-03_JPRB, &
  & 0.37012427E-03_JPRB, 0.37015602E-03_JPRB, 0.37018975E-03_JPRB, 0.37022555E-03_JPRB, 0.37026362E-03_JPRB, 0.37030381E-03_JPRB, &
  & 0.37034613E-03_JPRB, 0.37039004E-03_JPRB, 0.37043501E-03_JPRB, 0.37048064E-03_JPRB, 0.37052610E-03_JPRB, 0.37057101E-03_JPRB, &
  & 0.37061452E-03_JPRB, 0.37065611E-03_JPRB, 0.37069540E-03_JPRB, 0.37073216E-03_JPRB, 0.37076592E-03_JPRB, 0.37079648E-03_JPRB, &
  & 0.37082302E-03_JPRB, 0.37084555E-03_JPRB, 0.37086406E-03_JPRB, 0.37087849E-03_JPRB, 0.37088877E-03_JPRB, 0.37089508E-03_JPRB, &
  & 0.37089799E-03_JPRB, 0.37089840E-03_JPRB, 0.37089680E-03_JPRB, 0.37089392E-03_JPRB, 0.37089008E-03_JPRB, 0.37088577E-03_JPRB, &
  & 0.37088050E-03_JPRB, 0.37087459E-03_JPRB, 0.37086772E-03_JPRB, 0.37085949E-03_JPRB, 0.37084974E-03_JPRB, 0.37083766E-03_JPRB, &
  & 0.37082305E-03_JPRB, 0.37080570E-03_JPRB, 0.37078565E-03_JPRB, 0.37076321E-03_JPRB, 0.37073888E-03_JPRB, 0.37071394E-03_JPRB, &
  & 0.37068914E-03_JPRB, 0.37066505E-03_JPRB, 0.37064214E-03_JPRB, 0.37062046E-03_JPRB, 0.37059997E-03_JPRB, 0.37058053E-03_JPRB, &
  & 0.37056213E-03_JPRB, 0.37054444E-03_JPRB, 0.37052730E-03_JPRB, 0.37051080E-03_JPRB, 0.37049540E-03_JPRB, 0.37048137E-03_JPRB, &
  & 0.37046865E-03_JPRB, 0.37045695E-03_JPRB, 0.37044435E-03_JPRB, 0.37042273E-03_JPRB /)

RGHG1(:,32,12) = (/ &
  & 0.37005084E-03_JPRB, 0.37008131E-03_JPRB, 0.37010160E-03_JPRB, 0.37012133E-03_JPRB, 0.37014292E-03_JPRB, 0.37016702E-03_JPRB, &
  & 0.37019374E-03_JPRB, 0.37022235E-03_JPRB, 0.37025267E-03_JPRB, 0.37028454E-03_JPRB, 0.37031822E-03_JPRB, 0.37035398E-03_JPRB, &
  & 0.37039199E-03_JPRB, 0.37043224E-03_JPRB, 0.37047410E-03_JPRB, 0.37051685E-03_JPRB, 0.37055992E-03_JPRB, 0.37060262E-03_JPRB, &
  & 0.37064409E-03_JPRB, 0.37068379E-03_JPRB, 0.37072142E-03_JPRB, 0.37075669E-03_JPRB, 0.37078909E-03_JPRB, 0.37081836E-03_JPRB, &
  & 0.37084401E-03_JPRB, 0.37086589E-03_JPRB, 0.37088396E-03_JPRB, 0.37089834E-03_JPRB, 0.37090879E-03_JPRB, 0.37091537E-03_JPRB, &
  & 0.37091857E-03_JPRB, 0.37091912E-03_JPRB, 0.37091767E-03_JPRB, 0.37091487E-03_JPRB, 0.37091135E-03_JPRB, 0.37090704E-03_JPRB, &
  & 0.37090224E-03_JPRB, 0.37089674E-03_JPRB, 0.37089048E-03_JPRB, 0.37088292E-03_JPRB, 0.37087360E-03_JPRB, 0.37086231E-03_JPRB, &
  & 0.37084849E-03_JPRB, 0.37083193E-03_JPRB, 0.37081284E-03_JPRB, 0.37079130E-03_JPRB, 0.37076825E-03_JPRB, 0.37074432E-03_JPRB, &
  & 0.37072052E-03_JPRB, 0.37069764E-03_JPRB, 0.37067587E-03_JPRB, 0.37065553E-03_JPRB, 0.37063615E-03_JPRB, 0.37061775E-03_JPRB, &
  & 0.37060029E-03_JPRB, 0.37058361E-03_JPRB, 0.37056743E-03_JPRB, 0.37055198E-03_JPRB, 0.37053757E-03_JPRB, 0.37052477E-03_JPRB, &
  & 0.37051333E-03_JPRB, 0.37050265E-03_JPRB, 0.37049138E-03_JPRB, 0.37047235E-03_JPRB /)

RGHG1(:,33,12) = (/ &
  & 0.37012971E-03_JPRB, 0.37015794E-03_JPRB, 0.37017665E-03_JPRB, 0.37019490E-03_JPRB, 0.37021469E-03_JPRB, 0.37023687E-03_JPRB, &
  & 0.37026120E-03_JPRB, 0.37028719E-03_JPRB, 0.37031411E-03_JPRB, 0.37034237E-03_JPRB, 0.37037191E-03_JPRB, 0.37040358E-03_JPRB, &
  & 0.37043757E-03_JPRB, 0.37047412E-03_JPRB, 0.37051298E-03_JPRB, 0.37055346E-03_JPRB, 0.37059453E-03_JPRB, 0.37063536E-03_JPRB, &
  & 0.37067500E-03_JPRB, 0.37071298E-03_JPRB, 0.37074901E-03_JPRB, 0.37078251E-03_JPRB, 0.37081327E-03_JPRB, 0.37084095E-03_JPRB, &
  & 0.37086496E-03_JPRB, 0.37088548E-03_JPRB, 0.37090247E-03_JPRB, 0.37091618E-03_JPRB, 0.37092634E-03_JPRB, 0.37093283E-03_JPRB, &
  & 0.37093632E-03_JPRB, 0.37093717E-03_JPRB, 0.37093603E-03_JPRB, 0.37093350E-03_JPRB, 0.37093018E-03_JPRB, 0.37092619E-03_JPRB, &
  & 0.37092171E-03_JPRB, 0.37091671E-03_JPRB, 0.37091092E-03_JPRB, 0.37090378E-03_JPRB, 0.37089500E-03_JPRB, 0.37088426E-03_JPRB, &
  & 0.37087104E-03_JPRB, 0.37085512E-03_JPRB, 0.37083673E-03_JPRB, 0.37081633E-03_JPRB, 0.37079427E-03_JPRB, 0.37077151E-03_JPRB, &
  & 0.37074895E-03_JPRB, 0.37072739E-03_JPRB, 0.37070684E-03_JPRB, 0.37068743E-03_JPRB, 0.37066900E-03_JPRB, 0.37065148E-03_JPRB, &
  & 0.37063478E-03_JPRB, 0.37061877E-03_JPRB, 0.37060340E-03_JPRB, 0.37058885E-03_JPRB, 0.37057538E-03_JPRB, 0.37056336E-03_JPRB, &
  & 0.37055256E-03_JPRB, 0.37054284E-03_JPRB, 0.37053230E-03_JPRB, 0.37051496E-03_JPRB /)

RGHG1(:,34,12) = (/ &
  & 0.37020608E-03_JPRB, 0.37023192E-03_JPRB, 0.37024895E-03_JPRB, 0.37026548E-03_JPRB, 0.37028361E-03_JPRB, 0.37030401E-03_JPRB, &
  & 0.37032642E-03_JPRB, 0.37034991E-03_JPRB, 0.37037415E-03_JPRB, 0.37039883E-03_JPRB, 0.37042447E-03_JPRB, 0.37045195E-03_JPRB, &
  & 0.37048210E-03_JPRB, 0.37051516E-03_JPRB, 0.37055119E-03_JPRB, 0.37058952E-03_JPRB, 0.37062878E-03_JPRB, 0.37066819E-03_JPRB, &
  & 0.37070652E-03_JPRB, 0.37074316E-03_JPRB, 0.37077747E-03_JPRB, 0.37080934E-03_JPRB, 0.37083821E-03_JPRB, 0.37086388E-03_JPRB, &
  & 0.37088597E-03_JPRB, 0.37090463E-03_JPRB, 0.37092002E-03_JPRB, 0.37093242E-03_JPRB, 0.37094179E-03_JPRB, 0.37094808E-03_JPRB, &
  & 0.37095154E-03_JPRB, 0.37095277E-03_JPRB, 0.37095198E-03_JPRB, 0.37094997E-03_JPRB, 0.37094712E-03_JPRB, 0.37094357E-03_JPRB, &
  & 0.37093950E-03_JPRB, 0.37093498E-03_JPRB, 0.37092954E-03_JPRB, 0.37092276E-03_JPRB, 0.37091449E-03_JPRB, 0.37090402E-03_JPRB, &
  & 0.37089127E-03_JPRB, 0.37087608E-03_JPRB, 0.37085838E-03_JPRB, 0.37083865E-03_JPRB, 0.37081764E-03_JPRB, 0.37079604E-03_JPRB, &
  & 0.37077488E-03_JPRB, 0.37075428E-03_JPRB, 0.37073466E-03_JPRB, 0.37071612E-03_JPRB, 0.37069875E-03_JPRB, 0.37068210E-03_JPRB, &
  & 0.37066609E-03_JPRB, 0.37065079E-03_JPRB, 0.37063606E-03_JPRB, 0.37062221E-03_JPRB, 0.37060931E-03_JPRB, 0.37059779E-03_JPRB, &
  & 0.37058775E-03_JPRB, 0.37057846E-03_JPRB, 0.37056880E-03_JPRB, 0.37055244E-03_JPRB /)

RGHG1(:,35,12) = (/ &
  & 0.37027930E-03_JPRB, 0.37030241E-03_JPRB, 0.37031752E-03_JPRB, 0.37033256E-03_JPRB, 0.37034901E-03_JPRB, 0.37036766E-03_JPRB, &
  & 0.37038815E-03_JPRB, 0.37040954E-03_JPRB, 0.37043105E-03_JPRB, 0.37045270E-03_JPRB, 0.37047497E-03_JPRB, 0.37049875E-03_JPRB, &
  & 0.37052511E-03_JPRB, 0.37055500E-03_JPRB, 0.37058847E-03_JPRB, 0.37062485E-03_JPRB, 0.37066286E-03_JPRB, 0.37070108E-03_JPRB, &
  & 0.37073845E-03_JPRB, 0.37077389E-03_JPRB, 0.37080684E-03_JPRB, 0.37083687E-03_JPRB, 0.37086371E-03_JPRB, 0.37088708E-03_JPRB, &
  & 0.37090675E-03_JPRB, 0.37092291E-03_JPRB, 0.37093632E-03_JPRB, 0.37094718E-03_JPRB, 0.37095527E-03_JPRB, 0.37096103E-03_JPRB, &
  & 0.37096423E-03_JPRB, 0.37096566E-03_JPRB, 0.37096525E-03_JPRB, 0.37096385E-03_JPRB, 0.37096170E-03_JPRB, 0.37095876E-03_JPRB, &
  & 0.37095518E-03_JPRB, 0.37095119E-03_JPRB, 0.37094625E-03_JPRB, 0.37094002E-03_JPRB, 0.37093213E-03_JPRB, 0.37092209E-03_JPRB, &
  & 0.37090958E-03_JPRB, 0.37089462E-03_JPRB, 0.37087765E-03_JPRB, 0.37085876E-03_JPRB, 0.37083880E-03_JPRB, 0.37081854E-03_JPRB, &
  & 0.37079817E-03_JPRB, 0.37077875E-03_JPRB, 0.37076010E-03_JPRB, 0.37074255E-03_JPRB, 0.37072581E-03_JPRB, 0.37070987E-03_JPRB, &
  & 0.37069450E-03_JPRB, 0.37067971E-03_JPRB, 0.37066557E-03_JPRB, 0.37065218E-03_JPRB, 0.37063990E-03_JPRB, 0.37062902E-03_JPRB, &
  & 0.37061941E-03_JPRB, 0.37061077E-03_JPRB, 0.37060142E-03_JPRB, 0.37058606E-03_JPRB /)

RGHG1(:,36,12) = (/ &
  & 0.37034889E-03_JPRB, 0.37036906E-03_JPRB, 0.37038265E-03_JPRB, 0.37039592E-03_JPRB, 0.37041091E-03_JPRB, 0.37042802E-03_JPRB, &
  & 0.37044671E-03_JPRB, 0.37046586E-03_JPRB, 0.37048501E-03_JPRB, 0.37050381E-03_JPRB, 0.37052282E-03_JPRB, 0.37054316E-03_JPRB, &
  & 0.37056609E-03_JPRB, 0.37059281E-03_JPRB, 0.37062372E-03_JPRB, 0.37065838E-03_JPRB, 0.37069540E-03_JPRB, 0.37073303E-03_JPRB, &
  & 0.37076962E-03_JPRB, 0.37080428E-03_JPRB, 0.37083603E-03_JPRB, 0.37086441E-03_JPRB, 0.37088891E-03_JPRB, 0.37090978E-03_JPRB, &
  & 0.37092654E-03_JPRB, 0.37093999E-03_JPRB, 0.37095102E-03_JPRB, 0.37095972E-03_JPRB, 0.37096627E-03_JPRB, 0.37097096E-03_JPRB, &
  & 0.37097378E-03_JPRB, 0.37097518E-03_JPRB, 0.37097535E-03_JPRB, 0.37097451E-03_JPRB, 0.37097294E-03_JPRB, 0.37097061E-03_JPRB, &
  & 0.37096778E-03_JPRB, 0.37096450E-03_JPRB, 0.37096022E-03_JPRB, 0.37095460E-03_JPRB, 0.37094738E-03_JPRB, 0.37093807E-03_JPRB, &
  & 0.37092605E-03_JPRB, 0.37091161E-03_JPRB, 0.37089511E-03_JPRB, 0.37087704E-03_JPRB, 0.37085777E-03_JPRB, 0.37083848E-03_JPRB, &
  & 0.37081947E-03_JPRB, 0.37080105E-03_JPRB, 0.37078332E-03_JPRB, 0.37076647E-03_JPRB, 0.37075023E-03_JPRB, 0.37073484E-03_JPRB, &
  & 0.37072005E-03_JPRB, 0.37070585E-03_JPRB, 0.37069229E-03_JPRB, 0.37067954E-03_JPRB, 0.37066767E-03_JPRB, 0.37065719E-03_JPRB, &
  & 0.37064811E-03_JPRB, 0.37063958E-03_JPRB, 0.37063085E-03_JPRB, 0.37061641E-03_JPRB /)

RGHG1(:,37,12) = (/ &
  & 0.37041440E-03_JPRB, 0.37043190E-03_JPRB, 0.37044345E-03_JPRB, 0.37045521E-03_JPRB, 0.37046862E-03_JPRB, 0.37048443E-03_JPRB, &
  & 0.37050145E-03_JPRB, 0.37051892E-03_JPRB, 0.37053574E-03_JPRB, 0.37055180E-03_JPRB, 0.37056807E-03_JPRB, 0.37058516E-03_JPRB, &
  & 0.37060489E-03_JPRB, 0.37062849E-03_JPRB, 0.37065707E-03_JPRB, 0.37069013E-03_JPRB, 0.37072613E-03_JPRB, 0.37076330E-03_JPRB, &
  & 0.37079948E-03_JPRB, 0.37083338E-03_JPRB, 0.37086388E-03_JPRB, 0.37089034E-03_JPRB, 0.37091231E-03_JPRB, 0.37092989E-03_JPRB, &
  & 0.37094357E-03_JPRB, 0.37095422E-03_JPRB, 0.37096255E-03_JPRB, 0.37096898E-03_JPRB, 0.37097401E-03_JPRB, 0.37097774E-03_JPRB, &
  & 0.37098021E-03_JPRB, 0.37098140E-03_JPRB, 0.37098178E-03_JPRB, 0.37098135E-03_JPRB, 0.37098033E-03_JPRB, 0.37097870E-03_JPRB, &
  & 0.37097657E-03_JPRB, 0.37097390E-03_JPRB, 0.37097046E-03_JPRB, 0.37096580E-03_JPRB, 0.37095961E-03_JPRB, 0.37095117E-03_JPRB, &
  & 0.37094019E-03_JPRB, 0.37092660E-03_JPRB, 0.37091068E-03_JPRB, 0.37089313E-03_JPRB, 0.37087486E-03_JPRB, 0.37085664E-03_JPRB, &
  & 0.37083845E-03_JPRB, 0.37082093E-03_JPRB, 0.37080396E-03_JPRB, 0.37078763E-03_JPRB, 0.37077209E-03_JPRB, 0.37075713E-03_JPRB, &
  & 0.37074304E-03_JPRB, 0.37072954E-03_JPRB, 0.37071668E-03_JPRB, 0.37070425E-03_JPRB, 0.37069296E-03_JPRB, 0.37068297E-03_JPRB, &
  & 0.37067413E-03_JPRB, 0.37066621E-03_JPRB, 0.37065771E-03_JPRB, 0.37064397E-03_JPRB /)

RGHG1(:,38,12) = (/ &
  & 0.37047549E-03_JPRB, 0.37049007E-03_JPRB, 0.37050017E-03_JPRB, 0.37051050E-03_JPRB, 0.37052261E-03_JPRB, 0.37053673E-03_JPRB, &
  & 0.37055227E-03_JPRB, 0.37056793E-03_JPRB, 0.37058274E-03_JPRB, 0.37059665E-03_JPRB, 0.37061013E-03_JPRB, 0.37062459E-03_JPRB, &
  & 0.37064127E-03_JPRB, 0.37066211E-03_JPRB, 0.37068815E-03_JPRB, 0.37071985E-03_JPRB, 0.37075521E-03_JPRB, 0.37079171E-03_JPRB, &
  & 0.37082721E-03_JPRB, 0.37086025E-03_JPRB, 0.37088900E-03_JPRB, 0.37091284E-03_JPRB, 0.37093158E-03_JPRB, 0.37094575E-03_JPRB, &
  & 0.37095623E-03_JPRB, 0.37096423E-03_JPRB, 0.37097040E-03_JPRB, 0.37097518E-03_JPRB, 0.37097902E-03_JPRB, 0.37098202E-03_JPRB, &
  & 0.37098399E-03_JPRB, 0.37098513E-03_JPRB, 0.37098568E-03_JPRB, 0.37098536E-03_JPRB, 0.37098472E-03_JPRB, 0.37098350E-03_JPRB, &
  & 0.37098190E-03_JPRB, 0.37097980E-03_JPRB, 0.37097710E-03_JPRB, 0.37097328E-03_JPRB, 0.37096831E-03_JPRB, 0.37096121E-03_JPRB, &
  & 0.37095146E-03_JPRB, 0.37093912E-03_JPRB, 0.37092427E-03_JPRB, 0.37090763E-03_JPRB, 0.37089031E-03_JPRB, 0.37087285E-03_JPRB, &
  & 0.37085550E-03_JPRB, 0.37083868E-03_JPRB, 0.37082241E-03_JPRB, 0.37080661E-03_JPRB, 0.37079162E-03_JPRB, 0.37077730E-03_JPRB, &
  & 0.37076385E-03_JPRB, 0.37075114E-03_JPRB, 0.37073885E-03_JPRB, 0.37072724E-03_JPRB, 0.37071650E-03_JPRB, 0.37070684E-03_JPRB, &
  & 0.37069843E-03_JPRB, 0.37069080E-03_JPRB, 0.37068268E-03_JPRB, 0.37066956E-03_JPRB /)

RGHG1(:,39,12) = (/ &
  & 0.37053128E-03_JPRB, 0.37054362E-03_JPRB, 0.37055230E-03_JPRB, 0.37056129E-03_JPRB, 0.37057220E-03_JPRB, 0.37058504E-03_JPRB, &
  & 0.37059910E-03_JPRB, 0.37061304E-03_JPRB, 0.37062593E-03_JPRB, 0.37063780E-03_JPRB, 0.37064939E-03_JPRB, 0.37066150E-03_JPRB, &
  & 0.37067570E-03_JPRB, 0.37069357E-03_JPRB, 0.37071749E-03_JPRB, 0.37074726E-03_JPRB, 0.37078161E-03_JPRB, 0.37081764E-03_JPRB, &
  & 0.37085233E-03_JPRB, 0.37088338E-03_JPRB, 0.37090963E-03_JPRB, 0.37093001E-03_JPRB, 0.37094529E-03_JPRB, 0.37095626E-03_JPRB, &
  & 0.37096435E-03_JPRB, 0.37097049E-03_JPRB, 0.37097518E-03_JPRB, 0.37097896E-03_JPRB, 0.37098204E-03_JPRB, 0.37098452E-03_JPRB, &
  & 0.37098626E-03_JPRB, 0.37098731E-03_JPRB, 0.37098798E-03_JPRB, 0.37098784E-03_JPRB, 0.37098740E-03_JPRB, 0.37098647E-03_JPRB, &
  & 0.37098516E-03_JPRB, 0.37098341E-03_JPRB, 0.37098123E-03_JPRB, 0.37097817E-03_JPRB, 0.37097410E-03_JPRB, 0.37096813E-03_JPRB, &
  & 0.37095993E-03_JPRB, 0.37094901E-03_JPRB, 0.37093557E-03_JPRB, 0.37092011E-03_JPRB, 0.37090376E-03_JPRB, 0.37088722E-03_JPRB, &
  & 0.37087072E-03_JPRB, 0.37085451E-03_JPRB, 0.37083871E-03_JPRB, 0.37082340E-03_JPRB, 0.37080888E-03_JPRB, 0.37079529E-03_JPRB, &
  & 0.37078271E-03_JPRB, 0.37077101E-03_JPRB, 0.37075963E-03_JPRB, 0.37074875E-03_JPRB, 0.37073847E-03_JPRB, 0.37072916E-03_JPRB, &
  & 0.37072113E-03_JPRB, 0.37071388E-03_JPRB, 0.37070620E-03_JPRB, 0.37069365E-03_JPRB /)

RGHG1(:,40,12) = (/ &
  & 0.37058120E-03_JPRB, 0.37059179E-03_JPRB, 0.37059927E-03_JPRB, 0.37060745E-03_JPRB, 0.37061726E-03_JPRB, 0.37062902E-03_JPRB, &
  & 0.37064168E-03_JPRB, 0.37065410E-03_JPRB, 0.37066545E-03_JPRB, 0.37067570E-03_JPRB, 0.37068536E-03_JPRB, 0.37069572E-03_JPRB, &
  & 0.37070771E-03_JPRB, 0.37072363E-03_JPRB, 0.37074485E-03_JPRB, 0.37077308E-03_JPRB, 0.37080597E-03_JPRB, 0.37084080E-03_JPRB, &
  & 0.37087390E-03_JPRB, 0.37090247E-03_JPRB, 0.37092529E-03_JPRB, 0.37094217E-03_JPRB, 0.37095440E-03_JPRB, 0.37096324E-03_JPRB, &
  & 0.37096959E-03_JPRB, 0.37097442E-03_JPRB, 0.37097826E-03_JPRB, 0.37098140E-03_JPRB, 0.37098402E-03_JPRB, 0.37098615E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098871E-03_JPRB, 0.37098935E-03_JPRB, 0.37098938E-03_JPRB, 0.37098906E-03_JPRB, 0.37098830E-03_JPRB, &
  & 0.37098728E-03_JPRB, 0.37098580E-03_JPRB, 0.37098397E-03_JPRB, 0.37098138E-03_JPRB, 0.37097800E-03_JPRB, 0.37097302E-03_JPRB, &
  & 0.37096598E-03_JPRB, 0.37095661E-03_JPRB, 0.37094468E-03_JPRB, 0.37093056E-03_JPRB, 0.37091531E-03_JPRB, 0.37089971E-03_JPRB, &
  & 0.37088402E-03_JPRB, 0.37086860E-03_JPRB, 0.37085329E-03_JPRB, 0.37083839E-03_JPRB, 0.37082448E-03_JPRB, 0.37081153E-03_JPRB, &
  & 0.37079991E-03_JPRB, 0.37078909E-03_JPRB, 0.37077878E-03_JPRB, 0.37076889E-03_JPRB, 0.37075928E-03_JPRB, 0.37075049E-03_JPRB, &
  & 0.37074284E-03_JPRB, 0.37073606E-03_JPRB, 0.37072902E-03_JPRB, 0.37071691E-03_JPRB /)

RGHG1(:,41,12) = (/ &
  & 0.37062564E-03_JPRB, 0.37063484E-03_JPRB, 0.37064147E-03_JPRB, 0.37064881E-03_JPRB, 0.37065812E-03_JPRB, 0.37066897E-03_JPRB, &
  & 0.37068041E-03_JPRB, 0.37069130E-03_JPRB, 0.37070125E-03_JPRB, 0.37071019E-03_JPRB, 0.37071877E-03_JPRB, 0.37072753E-03_JPRB, &
  & 0.37073821E-03_JPRB, 0.37075178E-03_JPRB, 0.37077107E-03_JPRB, 0.37079692E-03_JPRB, 0.37082838E-03_JPRB, 0.37086135E-03_JPRB, &
  & 0.37089197E-03_JPRB, 0.37091741E-03_JPRB, 0.37093688E-03_JPRB, 0.37095085E-03_JPRB, 0.37096077E-03_JPRB, 0.37096790E-03_JPRB, &
  & 0.37097314E-03_JPRB, 0.37097718E-03_JPRB, 0.37098044E-03_JPRB, 0.37098315E-03_JPRB, 0.37098548E-03_JPRB, 0.37098734E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098979E-03_JPRB, 0.37099037E-03_JPRB, 0.37099043E-03_JPRB, 0.37099019E-03_JPRB, 0.37098964E-03_JPRB, &
  & 0.37098874E-03_JPRB, 0.37098752E-03_JPRB, 0.37098600E-03_JPRB, 0.37098370E-03_JPRB, 0.37098074E-03_JPRB, 0.37097657E-03_JPRB, &
  & 0.37097067E-03_JPRB, 0.37096249E-03_JPRB, 0.37095195E-03_JPRB, 0.37093932E-03_JPRB, 0.37092547E-03_JPRB, 0.37091086E-03_JPRB, &
  & 0.37089601E-03_JPRB, 0.37088126E-03_JPRB, 0.37086624E-03_JPRB, 0.37085192E-03_JPRB, 0.37083821E-03_JPRB, 0.37082631E-03_JPRB, &
  & 0.37081551E-03_JPRB, 0.37080582E-03_JPRB, 0.37079651E-03_JPRB, 0.37078754E-03_JPRB, 0.37077905E-03_JPRB, 0.37077113E-03_JPRB, &
  & 0.37076412E-03_JPRB, 0.37075774E-03_JPRB, 0.37075102E-03_JPRB, 0.37073961E-03_JPRB /)

RGHG1(:,42,12) = (/ &
  & 0.37066484E-03_JPRB, 0.37067308E-03_JPRB, 0.37067922E-03_JPRB, 0.37068618E-03_JPRB, 0.37069470E-03_JPRB, 0.37070515E-03_JPRB, &
  & 0.37071572E-03_JPRB, 0.37072558E-03_JPRB, 0.37073425E-03_JPRB, 0.37074211E-03_JPRB, 0.37074951E-03_JPRB, 0.37075742E-03_JPRB, &
  & 0.37076647E-03_JPRB, 0.37077867E-03_JPRB, 0.37079578E-03_JPRB, 0.37081973E-03_JPRB, 0.37084913E-03_JPRB, 0.37087989E-03_JPRB, &
  & 0.37090745E-03_JPRB, 0.37092951E-03_JPRB, 0.37094575E-03_JPRB, 0.37095722E-03_JPRB, 0.37096534E-03_JPRB, 0.37097119E-03_JPRB, &
  & 0.37097567E-03_JPRB, 0.37097928E-03_JPRB, 0.37098210E-03_JPRB, 0.37098455E-03_JPRB, 0.37098664E-03_JPRB, 0.37098833E-03_JPRB, &
  & 0.37098973E-03_JPRB, 0.37099069E-03_JPRB, 0.37099110E-03_JPRB, 0.37099136E-03_JPRB, 0.37099115E-03_JPRB, 0.37099063E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37098877E-03_JPRB, 0.37098737E-03_JPRB, 0.37098539E-03_JPRB, 0.37098286E-03_JPRB, 0.37097928E-03_JPRB, &
  & 0.37097430E-03_JPRB, 0.37096720E-03_JPRB, 0.37095798E-03_JPRB, 0.37094677E-03_JPRB, 0.37093408E-03_JPRB, 0.37092058E-03_JPRB, &
  & 0.37090664E-03_JPRB, 0.37089252E-03_JPRB, 0.37087814E-03_JPRB, 0.37086400E-03_JPRB, 0.37085108E-03_JPRB, 0.37083967E-03_JPRB, &
  & 0.37082998E-03_JPRB, 0.37082139E-03_JPRB, 0.37081330E-03_JPRB, 0.37080550E-03_JPRB, 0.37079799E-03_JPRB, 0.37079107E-03_JPRB, &
  & 0.37078490E-03_JPRB, 0.37077925E-03_JPRB, 0.37077308E-03_JPRB, 0.37076254E-03_JPRB /)

RGHG1(:,43,12) = (/ &
  & 0.37069997E-03_JPRB, 0.37070771E-03_JPRB, 0.37071342E-03_JPRB, 0.37072017E-03_JPRB, 0.37072867E-03_JPRB, 0.37073859E-03_JPRB, &
  & 0.37074840E-03_JPRB, 0.37075719E-03_JPRB, 0.37076505E-03_JPRB, 0.37077203E-03_JPRB, 0.37077878E-03_JPRB, 0.37078565E-03_JPRB, &
  & 0.37079374E-03_JPRB, 0.37080428E-03_JPRB, 0.37081965E-03_JPRB, 0.37084109E-03_JPRB, 0.37086831E-03_JPRB, 0.37089642E-03_JPRB, &
  & 0.37092084E-03_JPRB, 0.37093944E-03_JPRB, 0.37095277E-03_JPRB, 0.37096217E-03_JPRB, 0.37096895E-03_JPRB, 0.37097395E-03_JPRB, &
  & 0.37097777E-03_JPRB, 0.37098091E-03_JPRB, 0.37098350E-03_JPRB, 0.37098568E-03_JPRB, 0.37098763E-03_JPRB, 0.37098926E-03_JPRB, &
  & 0.37099051E-03_JPRB, 0.37099139E-03_JPRB, 0.37099177E-03_JPRB, 0.37099203E-03_JPRB, 0.37099188E-03_JPRB, 0.37099139E-03_JPRB, &
  & 0.37099072E-03_JPRB, 0.37098987E-03_JPRB, 0.37098856E-03_JPRB, 0.37098679E-03_JPRB, 0.37098458E-03_JPRB, 0.37098146E-03_JPRB, &
  & 0.37097718E-03_JPRB, 0.37097107E-03_JPRB, 0.37096301E-03_JPRB, 0.37095317E-03_JPRB, 0.37094168E-03_JPRB, 0.37092943E-03_JPRB, &
  & 0.37091650E-03_JPRB, 0.37090297E-03_JPRB, 0.37088923E-03_JPRB, 0.37087570E-03_JPRB, 0.37086330E-03_JPRB, 0.37085282E-03_JPRB, &
  & 0.37084403E-03_JPRB, 0.37083647E-03_JPRB, 0.37082948E-03_JPRB, 0.37082273E-03_JPRB, 0.37081636E-03_JPRB, 0.37081054E-03_JPRB, &
  & 0.37080533E-03_JPRB, 0.37080050E-03_JPRB, 0.37079517E-03_JPRB, 0.37078577E-03_JPRB /)

RGHG1(:,44,12) = (/ &
  & 0.37073213E-03_JPRB, 0.37073944E-03_JPRB, 0.37074499E-03_JPRB, 0.37075160E-03_JPRB, 0.37076001E-03_JPRB, 0.37076959E-03_JPRB, &
  & 0.37077890E-03_JPRB, 0.37078714E-03_JPRB, 0.37079424E-03_JPRB, 0.37080050E-03_JPRB, 0.37080649E-03_JPRB, 0.37081266E-03_JPRB, &
  & 0.37081970E-03_JPRB, 0.37082910E-03_JPRB, 0.37084243E-03_JPRB, 0.37086190E-03_JPRB, 0.37088635E-03_JPRB, 0.37091121E-03_JPRB, &
  & 0.37093213E-03_JPRB, 0.37094762E-03_JPRB, 0.37095844E-03_JPRB, 0.37096610E-03_JPRB, 0.37097183E-03_JPRB, 0.37097605E-03_JPRB, &
  & 0.37097940E-03_JPRB, 0.37098228E-03_JPRB, 0.37098466E-03_JPRB, 0.37098664E-03_JPRB, 0.37098851E-03_JPRB, 0.37098996E-03_JPRB, &
  & 0.37099118E-03_JPRB, 0.37099203E-03_JPRB, 0.37099238E-03_JPRB, 0.37099264E-03_JPRB, 0.37099252E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099142E-03_JPRB, 0.37099066E-03_JPRB, 0.37098952E-03_JPRB, 0.37098798E-03_JPRB, 0.37098600E-03_JPRB, 0.37098338E-03_JPRB, &
  & 0.37097966E-03_JPRB, 0.37097448E-03_JPRB, 0.37096758E-03_JPRB, 0.37095882E-03_JPRB, 0.37094860E-03_JPRB, 0.37093734E-03_JPRB, &
  & 0.37092550E-03_JPRB, 0.37091295E-03_JPRB, 0.37090003E-03_JPRB, 0.37088722E-03_JPRB, 0.37087552E-03_JPRB, 0.37086589E-03_JPRB, &
  & 0.37085806E-03_JPRB, 0.37085149E-03_JPRB, 0.37084558E-03_JPRB, 0.37084002E-03_JPRB, 0.37083472E-03_JPRB, 0.37082992E-03_JPRB, &
  & 0.37082570E-03_JPRB, 0.37082177E-03_JPRB, 0.37081735E-03_JPRB, 0.37080958E-03_JPRB /)

RGHG1(:,45,12) = (/ &
  & 0.37076199E-03_JPRB, 0.37076941E-03_JPRB, 0.37077488E-03_JPRB, 0.37078140E-03_JPRB, 0.37078973E-03_JPRB, 0.37079910E-03_JPRB, &
  & 0.37080795E-03_JPRB, 0.37081575E-03_JPRB, 0.37082238E-03_JPRB, 0.37082809E-03_JPRB, 0.37083338E-03_JPRB, 0.37083880E-03_JPRB, &
  & 0.37084499E-03_JPRB, 0.37085306E-03_JPRB, 0.37086455E-03_JPRB, 0.37088140E-03_JPRB, 0.37090309E-03_JPRB, 0.37092465E-03_JPRB, &
  & 0.37094194E-03_JPRB, 0.37095440E-03_JPRB, 0.37096313E-03_JPRB, 0.37096936E-03_JPRB, 0.37097413E-03_JPRB, 0.37097777E-03_JPRB, &
  & 0.37098079E-03_JPRB, 0.37098338E-03_JPRB, 0.37098560E-03_JPRB, 0.37098757E-03_JPRB, 0.37098941E-03_JPRB, 0.37099072E-03_JPRB, &
  & 0.37099185E-03_JPRB, 0.37099261E-03_JPRB, 0.37099293E-03_JPRB, 0.37099322E-03_JPRB, 0.37099310E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099133E-03_JPRB, 0.37099031E-03_JPRB, 0.37098897E-03_JPRB, 0.37098723E-03_JPRB, 0.37098493E-03_JPRB, &
  & 0.37098178E-03_JPRB, 0.37097745E-03_JPRB, 0.37097157E-03_JPRB, 0.37096400E-03_JPRB, 0.37095486E-03_JPRB, 0.37094476E-03_JPRB, &
  & 0.37093385E-03_JPRB, 0.37092224E-03_JPRB, 0.37091030E-03_JPRB, 0.37089855E-03_JPRB, 0.37088786E-03_JPRB, 0.37087937E-03_JPRB, &
  & 0.37087261E-03_JPRB, 0.37086688E-03_JPRB, 0.37086182E-03_JPRB, 0.37085710E-03_JPRB, 0.37085285E-03_JPRB, 0.37084910E-03_JPRB, &
  & 0.37084581E-03_JPRB, 0.37084272E-03_JPRB, 0.37083926E-03_JPRB, 0.37083315E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART24',0,ZHOOK_HANDLE)



RGHG1(:,46,12) = (/ &
  & 0.37079060E-03_JPRB, 0.37079796E-03_JPRB, 0.37080343E-03_JPRB, 0.37080987E-03_JPRB, 0.37081819E-03_JPRB, 0.37082736E-03_JPRB, &
  & 0.37083583E-03_JPRB, 0.37084328E-03_JPRB, 0.37084951E-03_JPRB, 0.37085474E-03_JPRB, 0.37085952E-03_JPRB, 0.37086412E-03_JPRB, &
  & 0.37086933E-03_JPRB, 0.37087602E-03_JPRB, 0.37088586E-03_JPRB, 0.37090015E-03_JPRB, 0.37091866E-03_JPRB, 0.37093632E-03_JPRB, &
  & 0.37095009E-03_JPRB, 0.37095993E-03_JPRB, 0.37096685E-03_JPRB, 0.37097192E-03_JPRB, 0.37097596E-03_JPRB, 0.37097922E-03_JPRB, &
  & 0.37098199E-03_JPRB, 0.37098443E-03_JPRB, 0.37098659E-03_JPRB, 0.37098842E-03_JPRB, 0.37099019E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099255E-03_JPRB, 0.37099322E-03_JPRB, 0.37099345E-03_JPRB, 0.37099374E-03_JPRB, 0.37099363E-03_JPRB, 0.37099316E-03_JPRB, &
  & 0.37099261E-03_JPRB, 0.37099191E-03_JPRB, 0.37099101E-03_JPRB, 0.37098987E-03_JPRB, 0.37098830E-03_JPRB, 0.37098624E-03_JPRB, &
  & 0.37098359E-03_JPRB, 0.37097992E-03_JPRB, 0.37097506E-03_JPRB, 0.37096854E-03_JPRB, 0.37096060E-03_JPRB, 0.37095163E-03_JPRB, &
  & 0.37094194E-03_JPRB, 0.37093155E-03_JPRB, 0.37092072E-03_JPRB, 0.37090995E-03_JPRB, 0.37090067E-03_JPRB, 0.37089322E-03_JPRB, &
  & 0.37088731E-03_JPRB, 0.37088245E-03_JPRB, 0.37087826E-03_JPRB, 0.37087442E-03_JPRB, 0.37087101E-03_JPRB, 0.37086802E-03_JPRB, &
  & 0.37086543E-03_JPRB, 0.37086301E-03_JPRB, 0.37086033E-03_JPRB, 0.37085559E-03_JPRB /)

RGHG1(:,47,12) = (/ &
  & 0.37081790E-03_JPRB, 0.37082541E-03_JPRB, 0.37083076E-03_JPRB, 0.37083711E-03_JPRB, 0.37084505E-03_JPRB, 0.37085405E-03_JPRB, &
  & 0.37086240E-03_JPRB, 0.37086967E-03_JPRB, 0.37087547E-03_JPRB, 0.37088024E-03_JPRB, 0.37088431E-03_JPRB, 0.37088827E-03_JPRB, &
  & 0.37089249E-03_JPRB, 0.37089802E-03_JPRB, 0.37090568E-03_JPRB, 0.37091755E-03_JPRB, 0.37093222E-03_JPRB, 0.37094625E-03_JPRB, &
  & 0.37095678E-03_JPRB, 0.37096435E-03_JPRB, 0.37096988E-03_JPRB, 0.37097410E-03_JPRB, 0.37097756E-03_JPRB, 0.37098050E-03_JPRB, &
  & 0.37098301E-03_JPRB, 0.37098539E-03_JPRB, 0.37098749E-03_JPRB, 0.37098926E-03_JPRB, 0.37099086E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099310E-03_JPRB, 0.37099374E-03_JPRB, 0.37099401E-03_JPRB, 0.37099427E-03_JPRB, 0.37099412E-03_JPRB, 0.37099366E-03_JPRB, &
  & 0.37099308E-03_JPRB, 0.37099246E-03_JPRB, 0.37099162E-03_JPRB, 0.37099063E-03_JPRB, 0.37098923E-03_JPRB, 0.37098743E-03_JPRB, &
  & 0.37098513E-03_JPRB, 0.37098210E-03_JPRB, 0.37097806E-03_JPRB, 0.37097276E-03_JPRB, 0.37096624E-03_JPRB, 0.37095844E-03_JPRB, &
  & 0.37094991E-03_JPRB, 0.37094072E-03_JPRB, 0.37093082E-03_JPRB, 0.37092165E-03_JPRB, 0.37091351E-03_JPRB, 0.37090725E-03_JPRB, &
  & 0.37090227E-03_JPRB, 0.37089823E-03_JPRB, 0.37089479E-03_JPRB, 0.37089165E-03_JPRB, 0.37088885E-03_JPRB, 0.37088641E-03_JPRB, &
  & 0.37088440E-03_JPRB, 0.37088263E-03_JPRB, 0.37088056E-03_JPRB, 0.37087689E-03_JPRB /)

RGHG1(:,48,12) = (/ &
  & 0.37084386E-03_JPRB, 0.37085137E-03_JPRB, 0.37085684E-03_JPRB, 0.37086301E-03_JPRB, 0.37087087E-03_JPRB, 0.37087960E-03_JPRB, &
  & 0.37088792E-03_JPRB, 0.37089468E-03_JPRB, 0.37090009E-03_JPRB, 0.37090419E-03_JPRB, 0.37090771E-03_JPRB, 0.37091092E-03_JPRB, &
  & 0.37091441E-03_JPRB, 0.37091860E-03_JPRB, 0.37092474E-03_JPRB, 0.37093321E-03_JPRB, 0.37094421E-03_JPRB, 0.37095443E-03_JPRB, &
  & 0.37096220E-03_JPRB, 0.37096796E-03_JPRB, 0.37097244E-03_JPRB, 0.37097596E-03_JPRB, 0.37097896E-03_JPRB, 0.37098161E-03_JPRB, &
  & 0.37098402E-03_JPRB, 0.37098624E-03_JPRB, 0.37098824E-03_JPRB, 0.37098999E-03_JPRB, 0.37099156E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099372E-03_JPRB, 0.37099421E-03_JPRB, 0.37099450E-03_JPRB, 0.37099471E-03_JPRB, 0.37099453E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099293E-03_JPRB, 0.37099211E-03_JPRB, 0.37099121E-03_JPRB, 0.37098996E-03_JPRB, 0.37098839E-03_JPRB, &
  & 0.37098641E-03_JPRB, 0.37098394E-03_JPRB, 0.37098082E-03_JPRB, 0.37097657E-03_JPRB, 0.37097139E-03_JPRB, 0.37096505E-03_JPRB, &
  & 0.37095789E-03_JPRB, 0.37094986E-03_JPRB, 0.37094142E-03_JPRB, 0.37093327E-03_JPRB, 0.37092663E-03_JPRB, 0.37092136E-03_JPRB, &
  & 0.37091738E-03_JPRB, 0.37091406E-03_JPRB, 0.37091121E-03_JPRB, 0.37090864E-03_JPRB, 0.37090626E-03_JPRB, 0.37090434E-03_JPRB, &
  & 0.37090274E-03_JPRB, 0.37090119E-03_JPRB, 0.37089962E-03_JPRB, 0.37089674E-03_JPRB /)

RGHG1(:,49,12) = (/ &
  & 0.37086854E-03_JPRB, 0.37087587E-03_JPRB, 0.37088132E-03_JPRB, 0.37088740E-03_JPRB, 0.37089520E-03_JPRB, 0.37090387E-03_JPRB, &
  & 0.37091176E-03_JPRB, 0.37091810E-03_JPRB, 0.37092291E-03_JPRB, 0.37092649E-03_JPRB, 0.37092922E-03_JPRB, 0.37093164E-03_JPRB, &
  & 0.37093408E-03_JPRB, 0.37093714E-03_JPRB, 0.37094124E-03_JPRB, 0.37094689E-03_JPRB, 0.37095405E-03_JPRB, 0.37096100E-03_JPRB, &
  & 0.37096659E-03_JPRB, 0.37097093E-03_JPRB, 0.37097442E-03_JPRB, 0.37097745E-03_JPRB, 0.37098012E-03_JPRB, 0.37098257E-03_JPRB, &
  & 0.37098496E-03_JPRB, 0.37098708E-03_JPRB, 0.37098909E-03_JPRB, 0.37099078E-03_JPRB, 0.37099220E-03_JPRB, 0.37099348E-03_JPRB, &
  & 0.37099418E-03_JPRB, 0.37099471E-03_JPRB, 0.37099505E-03_JPRB, 0.37099514E-03_JPRB, 0.37099494E-03_JPRB, 0.37099444E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099331E-03_JPRB, 0.37099258E-03_JPRB, 0.37099174E-03_JPRB, 0.37099060E-03_JPRB, 0.37098920E-03_JPRB, &
  & 0.37098755E-03_JPRB, 0.37098554E-03_JPRB, 0.37098303E-03_JPRB, 0.37097992E-03_JPRB, 0.37097619E-03_JPRB, 0.37097133E-03_JPRB, &
  & 0.37096566E-03_JPRB, 0.37095917E-03_JPRB, 0.37095218E-03_JPRB, 0.37094567E-03_JPRB, 0.37094002E-03_JPRB, 0.37093574E-03_JPRB, &
  & 0.37093245E-03_JPRB, 0.37092975E-03_JPRB, 0.37092739E-03_JPRB, 0.37092518E-03_JPRB, 0.37092331E-03_JPRB, 0.37092171E-03_JPRB, &
  & 0.37092043E-03_JPRB, 0.37091933E-03_JPRB, 0.37091805E-03_JPRB, 0.37091563E-03_JPRB /)

RGHG1(:,50,12) = (/ &
  & 0.37089130E-03_JPRB, 0.37089881E-03_JPRB, 0.37090393E-03_JPRB, 0.37090995E-03_JPRB, 0.37091761E-03_JPRB, 0.37092614E-03_JPRB, &
  & 0.37093382E-03_JPRB, 0.37093938E-03_JPRB, 0.37094328E-03_JPRB, 0.37094590E-03_JPRB, 0.37094785E-03_JPRB, 0.37094951E-03_JPRB, &
  & 0.37095102E-03_JPRB, 0.37095280E-03_JPRB, 0.37095483E-03_JPRB, 0.37095786E-03_JPRB, 0.37096185E-03_JPRB, 0.37096618E-03_JPRB, &
  & 0.37097005E-03_JPRB, 0.37097328E-03_JPRB, 0.37097622E-03_JPRB, 0.37097879E-03_JPRB, 0.37098126E-03_JPRB, 0.37098359E-03_JPRB, &
  & 0.37098589E-03_JPRB, 0.37098792E-03_JPRB, 0.37098990E-03_JPRB, 0.37099153E-03_JPRB, 0.37099290E-03_JPRB, 0.37099409E-03_JPRB, &
  & 0.37099473E-03_JPRB, 0.37099526E-03_JPRB, 0.37099558E-03_JPRB, 0.37099555E-03_JPRB, 0.37099532E-03_JPRB, 0.37099479E-03_JPRB, &
  & 0.37099433E-03_JPRB, 0.37099369E-03_JPRB, 0.37099299E-03_JPRB, 0.37099226E-03_JPRB, 0.37099118E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37098842E-03_JPRB, 0.37098679E-03_JPRB, 0.37098487E-03_JPRB, 0.37098271E-03_JPRB, 0.37098012E-03_JPRB, 0.37097698E-03_JPRB, &
  & 0.37097296E-03_JPRB, 0.37096825E-03_JPRB, 0.37096295E-03_JPRB, 0.37095806E-03_JPRB, 0.37095390E-03_JPRB, 0.37095067E-03_JPRB, &
  & 0.37094805E-03_JPRB, 0.37094584E-03_JPRB, 0.37094386E-03_JPRB, 0.37094206E-03_JPRB, 0.37094051E-03_JPRB, 0.37093915E-03_JPRB, &
  & 0.37093804E-03_JPRB, 0.37093699E-03_JPRB, 0.37093586E-03_JPRB, 0.37093376E-03_JPRB /)

RGHG1(:,51,12) = (/ &
  & 0.37091202E-03_JPRB, 0.37091889E-03_JPRB, 0.37092430E-03_JPRB, 0.37092995E-03_JPRB, 0.37093769E-03_JPRB, 0.37094569E-03_JPRB, &
  & 0.37095242E-03_JPRB, 0.37095678E-03_JPRB, 0.37095940E-03_JPRB, 0.37096097E-03_JPRB, 0.37096208E-03_JPRB, 0.37096284E-03_JPRB, &
  & 0.37096345E-03_JPRB, 0.37096400E-03_JPRB, 0.37096482E-03_JPRB, 0.37096583E-03_JPRB, 0.37096773E-03_JPRB, 0.37097023E-03_JPRB, &
  & 0.37097282E-03_JPRB, 0.37097529E-03_JPRB, 0.37097759E-03_JPRB, 0.37097989E-03_JPRB, 0.37098222E-03_JPRB, 0.37098449E-03_JPRB, &
  & 0.37098673E-03_JPRB, 0.37098874E-03_JPRB, 0.37099066E-03_JPRB, 0.37099223E-03_JPRB, 0.37099351E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099523E-03_JPRB, 0.37099567E-03_JPRB, 0.37099599E-03_JPRB, 0.37099590E-03_JPRB, 0.37099572E-03_JPRB, 0.37099517E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099401E-03_JPRB, 0.37099334E-03_JPRB, 0.37099258E-03_JPRB, 0.37099159E-03_JPRB, 0.37099040E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098781E-03_JPRB, 0.37098638E-03_JPRB, 0.37098496E-03_JPRB, 0.37098333E-03_JPRB, 0.37098152E-03_JPRB, &
  & 0.37097913E-03_JPRB, 0.37097625E-03_JPRB, 0.37097314E-03_JPRB, 0.37096994E-03_JPRB, 0.37096729E-03_JPRB, 0.37096511E-03_JPRB, &
  & 0.37096321E-03_JPRB, 0.37096161E-03_JPRB, 0.37096004E-03_JPRB, 0.37095862E-03_JPRB, 0.37095734E-03_JPRB, 0.37095623E-03_JPRB, &
  & 0.37095530E-03_JPRB, 0.37095443E-03_JPRB, 0.37095335E-03_JPRB, 0.37095140E-03_JPRB /)

RGHG1(:,52,12) = (/ &
  & 0.37092951E-03_JPRB, 0.37093682E-03_JPRB, 0.37094142E-03_JPRB, 0.37094735E-03_JPRB, 0.37095390E-03_JPRB, 0.37096106E-03_JPRB, &
  & 0.37096575E-03_JPRB, 0.37096842E-03_JPRB, 0.37096982E-03_JPRB, 0.37097046E-03_JPRB, 0.37097087E-03_JPRB, 0.37097116E-03_JPRB, &
  & 0.37097128E-03_JPRB, 0.37097139E-03_JPRB, 0.37097145E-03_JPRB, 0.37097157E-03_JPRB, 0.37097215E-03_JPRB, 0.37097343E-03_JPRB, &
  & 0.37097518E-03_JPRB, 0.37097695E-03_JPRB, 0.37097890E-03_JPRB, 0.37098088E-03_JPRB, 0.37098306E-03_JPRB, 0.37098536E-03_JPRB, &
  & 0.37098749E-03_JPRB, 0.37098944E-03_JPRB, 0.37099147E-03_JPRB, 0.37099281E-03_JPRB, 0.37099406E-03_JPRB, 0.37099514E-03_JPRB, &
  & 0.37099578E-03_JPRB, 0.37099601E-03_JPRB, 0.37099636E-03_JPRB, 0.37099616E-03_JPRB, 0.37099601E-03_JPRB, 0.37099546E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099430E-03_JPRB, 0.37099363E-03_JPRB, 0.37099287E-03_JPRB, 0.37099200E-03_JPRB, 0.37099089E-03_JPRB, &
  & 0.37098982E-03_JPRB, 0.37098877E-03_JPRB, 0.37098760E-03_JPRB, 0.37098664E-03_JPRB, 0.37098571E-03_JPRB, 0.37098481E-03_JPRB, &
  & 0.37098356E-03_JPRB, 0.37098219E-03_JPRB, 0.37098056E-03_JPRB, 0.37097908E-03_JPRB, 0.37097768E-03_JPRB, 0.37097654E-03_JPRB, &
  & 0.37097553E-03_JPRB, 0.37097448E-03_JPRB, 0.37097349E-03_JPRB, 0.37097241E-03_JPRB, 0.37097145E-03_JPRB, 0.37097061E-03_JPRB, &
  & 0.37096988E-03_JPRB, 0.37096915E-03_JPRB, 0.37096831E-03_JPRB, 0.37096668E-03_JPRB /)

RGHG1(:,53,12) = (/ &
  & 0.37094485E-03_JPRB, 0.37095064E-03_JPRB, 0.37095571E-03_JPRB, 0.37096022E-03_JPRB, 0.37096613E-03_JPRB, 0.37097081E-03_JPRB, &
  & 0.37097390E-03_JPRB, 0.37097521E-03_JPRB, 0.37097582E-03_JPRB, 0.37097605E-03_JPRB, 0.37097614E-03_JPRB, 0.37097614E-03_JPRB, &
  & 0.37097611E-03_JPRB, 0.37097605E-03_JPRB, 0.37097582E-03_JPRB, 0.37097550E-03_JPRB, 0.37097550E-03_JPRB, 0.37097593E-03_JPRB, &
  & 0.37097710E-03_JPRB, 0.37097849E-03_JPRB, 0.37098018E-03_JPRB, 0.37098199E-03_JPRB, 0.37098394E-03_JPRB, 0.37098609E-03_JPRB, &
  & 0.37098824E-03_JPRB, 0.37099022E-03_JPRB, 0.37099206E-03_JPRB, 0.37099342E-03_JPRB, 0.37099462E-03_JPRB, 0.37099561E-03_JPRB, &
  & 0.37099628E-03_JPRB, 0.37099633E-03_JPRB, 0.37099668E-03_JPRB, 0.37099636E-03_JPRB, 0.37099631E-03_JPRB, 0.37099567E-03_JPRB, &
  & 0.37099520E-03_JPRB, 0.37099456E-03_JPRB, 0.37099395E-03_JPRB, 0.37099316E-03_JPRB, 0.37099241E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099048E-03_JPRB, 0.37098961E-03_JPRB, 0.37098868E-03_JPRB, 0.37098804E-03_JPRB, 0.37098752E-03_JPRB, 0.37098711E-03_JPRB, &
  & 0.37098659E-03_JPRB, 0.37098594E-03_JPRB, 0.37098525E-03_JPRB, 0.37098461E-03_JPRB, 0.37098397E-03_JPRB, 0.37098333E-03_JPRB, &
  & 0.37098280E-03_JPRB, 0.37098228E-03_JPRB, 0.37098170E-03_JPRB, 0.37098111E-03_JPRB, 0.37098053E-03_JPRB, 0.37098004E-03_JPRB, &
  & 0.37097966E-03_JPRB, 0.37097931E-03_JPRB, 0.37097881E-03_JPRB, 0.37097777E-03_JPRB /)

RGHG1(:,54,12) = (/ &
  & 0.37095652E-03_JPRB, 0.37096257E-03_JPRB, 0.37096580E-03_JPRB, 0.37097017E-03_JPRB, 0.37097384E-03_JPRB, 0.37097689E-03_JPRB, &
  & 0.37097838E-03_JPRB, 0.37097896E-03_JPRB, 0.37097922E-03_JPRB, 0.37097931E-03_JPRB, 0.37097928E-03_JPRB, 0.37097922E-03_JPRB, &
  & 0.37097911E-03_JPRB, 0.37097896E-03_JPRB, 0.37097881E-03_JPRB, 0.37097838E-03_JPRB, 0.37097806E-03_JPRB, 0.37097809E-03_JPRB, &
  & 0.37097879E-03_JPRB, 0.37097983E-03_JPRB, 0.37098120E-03_JPRB, 0.37098292E-03_JPRB, 0.37098484E-03_JPRB, 0.37098691E-03_JPRB, &
  & 0.37098897E-03_JPRB, 0.37099095E-03_JPRB, 0.37099267E-03_JPRB, 0.37099392E-03_JPRB, 0.37099505E-03_JPRB, 0.37099596E-03_JPRB, &
  & 0.37099663E-03_JPRB, 0.37099674E-03_JPRB, 0.37099703E-03_JPRB, 0.37099671E-03_JPRB, 0.37099660E-03_JPRB, 0.37099593E-03_JPRB, &
  & 0.37099549E-03_JPRB, 0.37099491E-03_JPRB, 0.37099427E-03_JPRB, 0.37099351E-03_JPRB, 0.37099273E-03_JPRB, 0.37099179E-03_JPRB, &
  & 0.37099095E-03_JPRB, 0.37099031E-03_JPRB, 0.37098967E-03_JPRB, 0.37098920E-03_JPRB, 0.37098897E-03_JPRB, 0.37098886E-03_JPRB, &
  & 0.37098859E-03_JPRB, 0.37098833E-03_JPRB, 0.37098798E-03_JPRB, 0.37098775E-03_JPRB, 0.37098743E-03_JPRB, 0.37098711E-03_JPRB, &
  & 0.37098679E-03_JPRB, 0.37098647E-03_JPRB, 0.37098618E-03_JPRB, 0.37098583E-03_JPRB, 0.37098548E-03_JPRB, 0.37098519E-03_JPRB, &
  & 0.37098498E-03_JPRB, 0.37098481E-03_JPRB, 0.37098469E-03_JPRB, 0.37098464E-03_JPRB /)

RGHG1(:,55,12) = (/ &
  & 0.37096604E-03_JPRB, 0.37097029E-03_JPRB, 0.37097360E-03_JPRB, 0.37097622E-03_JPRB, 0.37097884E-03_JPRB, 0.37098047E-03_JPRB, &
  & 0.37098123E-03_JPRB, 0.37098143E-03_JPRB, 0.37098149E-03_JPRB, 0.37098149E-03_JPRB, 0.37098146E-03_JPRB, 0.37098140E-03_JPRB, &
  & 0.37098135E-03_JPRB, 0.37098123E-03_JPRB, 0.37098106E-03_JPRB, 0.37098065E-03_JPRB, 0.37098015E-03_JPRB, 0.37097989E-03_JPRB, &
  & 0.37098027E-03_JPRB, 0.37098103E-03_JPRB, 0.37098234E-03_JPRB, 0.37098385E-03_JPRB, 0.37098562E-03_JPRB, 0.37098766E-03_JPRB, &
  & 0.37098964E-03_JPRB, 0.37099159E-03_JPRB, 0.37099319E-03_JPRB, 0.37099438E-03_JPRB, 0.37099558E-03_JPRB, 0.37099642E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099712E-03_JPRB, 0.37099724E-03_JPRB, 0.37099695E-03_JPRB, 0.37099689E-03_JPRB, 0.37099622E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099520E-03_JPRB, 0.37099459E-03_JPRB, 0.37099374E-03_JPRB, 0.37099293E-03_JPRB, 0.37099214E-03_JPRB, &
  & 0.37099142E-03_JPRB, 0.37099095E-03_JPRB, 0.37099048E-03_JPRB, 0.37099022E-03_JPRB, 0.37099011E-03_JPRB, 0.37099011E-03_JPRB, &
  & 0.37099002E-03_JPRB, 0.37098990E-03_JPRB, 0.37098982E-03_JPRB, 0.37098967E-03_JPRB, 0.37098950E-03_JPRB, 0.37098935E-03_JPRB, &
  & 0.37098915E-03_JPRB, 0.37098891E-03_JPRB, 0.37098868E-03_JPRB, 0.37098851E-03_JPRB, 0.37098827E-03_JPRB, 0.37098816E-03_JPRB, &
  & 0.37098810E-03_JPRB, 0.37098792E-03_JPRB, 0.37098772E-03_JPRB, 0.37098752E-03_JPRB /)

RGHG1(:,56,12) = (/ &
  & 0.37097273E-03_JPRB, 0.37097660E-03_JPRB, 0.37097849E-03_JPRB, 0.37098047E-03_JPRB, 0.37098199E-03_JPRB, 0.37098292E-03_JPRB, &
  & 0.37098327E-03_JPRB, 0.37098335E-03_JPRB, 0.37098333E-03_JPRB, 0.37098330E-03_JPRB, 0.37098324E-03_JPRB, 0.37098315E-03_JPRB, &
  & 0.37098306E-03_JPRB, 0.37098292E-03_JPRB, 0.37098269E-03_JPRB, 0.37098236E-03_JPRB, 0.37098190E-03_JPRB, 0.37098158E-03_JPRB, &
  & 0.37098164E-03_JPRB, 0.37098213E-03_JPRB, 0.37098335E-03_JPRB, 0.37098475E-03_JPRB, 0.37098647E-03_JPRB, 0.37098845E-03_JPRB, &
  & 0.37099031E-03_JPRB, 0.37099217E-03_JPRB, 0.37099372E-03_JPRB, 0.37099491E-03_JPRB, 0.37099601E-03_JPRB, 0.37099677E-03_JPRB, &
  & 0.37099721E-03_JPRB, 0.37099744E-03_JPRB, 0.37099750E-03_JPRB, 0.37099730E-03_JPRB, 0.37099715E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37099540E-03_JPRB, 0.37099485E-03_JPRB, 0.37099415E-03_JPRB, 0.37099331E-03_JPRB, 0.37099258E-03_JPRB, &
  & 0.37099200E-03_JPRB, 0.37099153E-03_JPRB, 0.37099124E-03_JPRB, 0.37099104E-03_JPRB, 0.37099101E-03_JPRB, 0.37099107E-03_JPRB, &
  & 0.37099110E-03_JPRB, 0.37099107E-03_JPRB, 0.37099107E-03_JPRB, 0.37099098E-03_JPRB, 0.37099089E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099060E-03_JPRB, 0.37099048E-03_JPRB, 0.37099031E-03_JPRB, 0.37099019E-03_JPRB, 0.37099005E-03_JPRB, 0.37098996E-03_JPRB, &
  & 0.37098990E-03_JPRB, 0.37098979E-03_JPRB, 0.37098967E-03_JPRB, 0.37098952E-03_JPRB /)

RGHG1(:,57,12) = (/ &
  & 0.37097791E-03_JPRB, 0.37098071E-03_JPRB, 0.37098216E-03_JPRB, 0.37098327E-03_JPRB, 0.37098408E-03_JPRB, 0.37098455E-03_JPRB, &
  & 0.37098464E-03_JPRB, 0.37098461E-03_JPRB, 0.37098461E-03_JPRB, 0.37098458E-03_JPRB, 0.37098455E-03_JPRB, 0.37098446E-03_JPRB, &
  & 0.37098440E-03_JPRB, 0.37098431E-03_JPRB, 0.37098414E-03_JPRB, 0.37098391E-03_JPRB, 0.37098344E-03_JPRB, 0.37098301E-03_JPRB, &
  & 0.37098301E-03_JPRB, 0.37098333E-03_JPRB, 0.37098443E-03_JPRB, 0.37098580E-03_JPRB, 0.37098731E-03_JPRB, 0.37098915E-03_JPRB, &
  & 0.37099098E-03_JPRB, 0.37099276E-03_JPRB, 0.37099415E-03_JPRB, 0.37099532E-03_JPRB, 0.37099639E-03_JPRB, 0.37099706E-03_JPRB, &
  & 0.37099756E-03_JPRB, 0.37099776E-03_JPRB, 0.37099779E-03_JPRB, 0.37099762E-03_JPRB, 0.37099738E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099625E-03_JPRB, 0.37099564E-03_JPRB, 0.37099514E-03_JPRB, 0.37099444E-03_JPRB, 0.37099369E-03_JPRB, 0.37099305E-03_JPRB, &
  & 0.37099255E-03_JPRB, 0.37099211E-03_JPRB, 0.37099188E-03_JPRB, 0.37099185E-03_JPRB, 0.37099194E-03_JPRB, 0.37099197E-03_JPRB, &
  & 0.37099203E-03_JPRB, 0.37099200E-03_JPRB, 0.37099197E-03_JPRB, 0.37099194E-03_JPRB, 0.37099188E-03_JPRB, 0.37099182E-03_JPRB, &
  & 0.37099177E-03_JPRB, 0.37099165E-03_JPRB, 0.37099153E-03_JPRB, 0.37099145E-03_JPRB, 0.37099139E-03_JPRB, 0.37099130E-03_JPRB, &
  & 0.37099124E-03_JPRB, 0.37099118E-03_JPRB, 0.37099110E-03_JPRB, 0.37099089E-03_JPRB /)

RGHG1(:,58,12) = (/ &
  & 0.37098158E-03_JPRB, 0.37098367E-03_JPRB, 0.37098461E-03_JPRB, 0.37098528E-03_JPRB, 0.37098571E-03_JPRB, 0.37098586E-03_JPRB, &
  & 0.37098583E-03_JPRB, 0.37098583E-03_JPRB, 0.37098583E-03_JPRB, 0.37098580E-03_JPRB, 0.37098571E-03_JPRB, 0.37098568E-03_JPRB, &
  & 0.37098565E-03_JPRB, 0.37098560E-03_JPRB, 0.37098548E-03_JPRB, 0.37098525E-03_JPRB, 0.37098478E-03_JPRB, 0.37098434E-03_JPRB, &
  & 0.37098426E-03_JPRB, 0.37098449E-03_JPRB, 0.37098536E-03_JPRB, 0.37098661E-03_JPRB, 0.37098813E-03_JPRB, 0.37098982E-03_JPRB, &
  & 0.37099159E-03_JPRB, 0.37099322E-03_JPRB, 0.37099471E-03_JPRB, 0.37099572E-03_JPRB, 0.37099677E-03_JPRB, 0.37099741E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099799E-03_JPRB, 0.37099799E-03_JPRB, 0.37099796E-03_JPRB, 0.37099756E-03_JPRB, 0.37099700E-03_JPRB, &
  & 0.37099648E-03_JPRB, 0.37099590E-03_JPRB, 0.37099529E-03_JPRB, 0.37099468E-03_JPRB, 0.37099401E-03_JPRB, 0.37099345E-03_JPRB, &
  & 0.37099308E-03_JPRB, 0.37099264E-03_JPRB, 0.37099255E-03_JPRB, 0.37099252E-03_JPRB, 0.37099273E-03_JPRB, 0.37099276E-03_JPRB, &
  & 0.37099281E-03_JPRB, 0.37099281E-03_JPRB, 0.37099276E-03_JPRB, 0.37099270E-03_JPRB, 0.37099270E-03_JPRB, 0.37099264E-03_JPRB, &
  & 0.37099258E-03_JPRB, 0.37099252E-03_JPRB, 0.37099246E-03_JPRB, 0.37099235E-03_JPRB, 0.37099223E-03_JPRB, 0.37099211E-03_JPRB, &
  & 0.37099197E-03_JPRB, 0.37099188E-03_JPRB, 0.37099182E-03_JPRB, 0.37099171E-03_JPRB /)

RGHG1(:,59,12) = (/ &
  & 0.37098426E-03_JPRB, 0.37098583E-03_JPRB, 0.37098638E-03_JPRB, 0.37098673E-03_JPRB, 0.37098693E-03_JPRB, 0.37098699E-03_JPRB, &
  & 0.37098696E-03_JPRB, 0.37098688E-03_JPRB, 0.37098682E-03_JPRB, 0.37098682E-03_JPRB, 0.37098682E-03_JPRB, 0.37098682E-03_JPRB, &
  & 0.37098682E-03_JPRB, 0.37098673E-03_JPRB, 0.37098659E-03_JPRB, 0.37098644E-03_JPRB, 0.37098609E-03_JPRB, 0.37098560E-03_JPRB, &
  & 0.37098533E-03_JPRB, 0.37098562E-03_JPRB, 0.37098632E-03_JPRB, 0.37098757E-03_JPRB, 0.37098894E-03_JPRB, 0.37099054E-03_JPRB, &
  & 0.37099223E-03_JPRB, 0.37099380E-03_JPRB, 0.37099523E-03_JPRB, 0.37099625E-03_JPRB, 0.37099718E-03_JPRB, 0.37099782E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099837E-03_JPRB, 0.37099826E-03_JPRB, 0.37099826E-03_JPRB, 0.37099782E-03_JPRB, 0.37099724E-03_JPRB, &
  & 0.37099671E-03_JPRB, 0.37099610E-03_JPRB, 0.37099552E-03_JPRB, 0.37099494E-03_JPRB, 0.37099427E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099354E-03_JPRB, 0.37099313E-03_JPRB, 0.37099310E-03_JPRB, 0.37099305E-03_JPRB, 0.37099328E-03_JPRB, 0.37099337E-03_JPRB, &
  & 0.37099345E-03_JPRB, 0.37099342E-03_JPRB, 0.37099342E-03_JPRB, 0.37099337E-03_JPRB, 0.37099334E-03_JPRB, 0.37099334E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, 0.37099319E-03_JPRB, 0.37099308E-03_JPRB, 0.37099293E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099273E-03_JPRB, 0.37099267E-03_JPRB, 0.37099258E-03_JPRB, 0.37099243E-03_JPRB /)

RGHG1(:,60,12) = (/ &
  & 0.37098714E-03_JPRB, 0.37098755E-03_JPRB, 0.37098778E-03_JPRB, 0.37098787E-03_JPRB, 0.37098795E-03_JPRB, 0.37098798E-03_JPRB, &
  & 0.37098784E-03_JPRB, 0.37098775E-03_JPRB, 0.37098769E-03_JPRB, 0.37098772E-03_JPRB, 0.37098775E-03_JPRB, 0.37098775E-03_JPRB, &
  & 0.37098775E-03_JPRB, 0.37098769E-03_JPRB, 0.37098763E-03_JPRB, 0.37098746E-03_JPRB, 0.37098711E-03_JPRB, 0.37098659E-03_JPRB, &
  & 0.37098644E-03_JPRB, 0.37098676E-03_JPRB, 0.37098734E-03_JPRB, 0.37098851E-03_JPRB, 0.37098982E-03_JPRB, 0.37099142E-03_JPRB, &
  & 0.37099299E-03_JPRB, 0.37099450E-03_JPRB, 0.37099572E-03_JPRB, 0.37099663E-03_JPRB, 0.37099750E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099846E-03_JPRB, 0.37099855E-03_JPRB, 0.37099843E-03_JPRB, 0.37099843E-03_JPRB, 0.37099799E-03_JPRB, 0.37099750E-03_JPRB, &
  & 0.37099703E-03_JPRB, 0.37099642E-03_JPRB, 0.37099587E-03_JPRB, 0.37099529E-03_JPRB, 0.37099473E-03_JPRB, 0.37099424E-03_JPRB, &
  & 0.37099398E-03_JPRB, 0.37099374E-03_JPRB, 0.37099369E-03_JPRB, 0.37099372E-03_JPRB, 0.37099389E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099409E-03_JPRB, 0.37099404E-03_JPRB, 0.37099404E-03_JPRB, 0.37099395E-03_JPRB, 0.37099386E-03_JPRB, 0.37099380E-03_JPRB, &
  & 0.37099374E-03_JPRB, 0.37099374E-03_JPRB, 0.37099366E-03_JPRB, 0.37099357E-03_JPRB, 0.37099345E-03_JPRB, 0.37099340E-03_JPRB, &
  & 0.37099334E-03_JPRB, 0.37099328E-03_JPRB, 0.37099319E-03_JPRB, 0.37099310E-03_JPRB /)

RGHG1(:,61,12) = (/ &
  & 0.37098845E-03_JPRB, 0.37098871E-03_JPRB, 0.37098886E-03_JPRB, 0.37098891E-03_JPRB, 0.37098894E-03_JPRB, 0.37098897E-03_JPRB, &
  & 0.37098886E-03_JPRB, 0.37098886E-03_JPRB, 0.37098886E-03_JPRB, 0.37098883E-03_JPRB, 0.37098880E-03_JPRB, 0.37098880E-03_JPRB, &
  & 0.37098880E-03_JPRB, 0.37098880E-03_JPRB, 0.37098865E-03_JPRB, 0.37098845E-03_JPRB, 0.37098810E-03_JPRB, 0.37098789E-03_JPRB, &
  & 0.37098778E-03_JPRB, 0.37098778E-03_JPRB, 0.37098839E-03_JPRB, 0.37098944E-03_JPRB, 0.37099066E-03_JPRB, 0.37099217E-03_JPRB, &
  & 0.37099360E-03_JPRB, 0.37099503E-03_JPRB, 0.37099628E-03_JPRB, 0.37099700E-03_JPRB, 0.37099782E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099875E-03_JPRB, 0.37099875E-03_JPRB, 0.37099872E-03_JPRB, 0.37099828E-03_JPRB, 0.37099779E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37099674E-03_JPRB, 0.37099622E-03_JPRB, 0.37099567E-03_JPRB, 0.37099508E-03_JPRB, 0.37099468E-03_JPRB, &
  & 0.37099444E-03_JPRB, 0.37099427E-03_JPRB, 0.37099421E-03_JPRB, 0.37099433E-03_JPRB, 0.37099444E-03_JPRB, 0.37099465E-03_JPRB, &
  & 0.37099468E-03_JPRB, 0.37099465E-03_JPRB, 0.37099465E-03_JPRB, 0.37099453E-03_JPRB, 0.37099444E-03_JPRB, 0.37099436E-03_JPRB, &
  & 0.37099427E-03_JPRB, 0.37099427E-03_JPRB, 0.37099421E-03_JPRB, 0.37099415E-03_JPRB, 0.37099409E-03_JPRB, 0.37099404E-03_JPRB, &
  & 0.37099401E-03_JPRB, 0.37099395E-03_JPRB, 0.37099392E-03_JPRB, 0.37099377E-03_JPRB /)

RGHG1(:,62,12) = (/ &
  & 0.37098952E-03_JPRB, 0.37098973E-03_JPRB, 0.37098984E-03_JPRB, 0.37098979E-03_JPRB, 0.37098984E-03_JPRB, 0.37098979E-03_JPRB, &
  & 0.37098973E-03_JPRB, 0.37098967E-03_JPRB, 0.37098973E-03_JPRB, 0.37098979E-03_JPRB, 0.37098984E-03_JPRB, 0.37098990E-03_JPRB, &
  & 0.37098987E-03_JPRB, 0.37098982E-03_JPRB, 0.37098970E-03_JPRB, 0.37098950E-03_JPRB, 0.37098909E-03_JPRB, 0.37098871E-03_JPRB, &
  & 0.37098851E-03_JPRB, 0.37098888E-03_JPRB, 0.37098950E-03_JPRB, 0.37099031E-03_JPRB, 0.37099150E-03_JPRB, 0.37099293E-03_JPRB, &
  & 0.37099436E-03_JPRB, 0.37099558E-03_JPRB, 0.37099665E-03_JPRB, 0.37099738E-03_JPRB, 0.37099820E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37099895E-03_JPRB, 0.37099901E-03_JPRB, 0.37099895E-03_JPRB, 0.37099895E-03_JPRB, 0.37099852E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099703E-03_JPRB, 0.37099654E-03_JPRB, 0.37099607E-03_JPRB, 0.37099549E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099482E-03_JPRB, 0.37099473E-03_JPRB, 0.37099473E-03_JPRB, 0.37099491E-03_JPRB, 0.37099505E-03_JPRB, 0.37099520E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099520E-03_JPRB, 0.37099520E-03_JPRB, 0.37099505E-03_JPRB, 0.37099494E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099476E-03_JPRB, 0.37099473E-03_JPRB, 0.37099473E-03_JPRB, 0.37099468E-03_JPRB, 0.37099462E-03_JPRB, 0.37099456E-03_JPRB, &
  & 0.37099450E-03_JPRB, 0.37099444E-03_JPRB, 0.37099436E-03_JPRB, 0.37099421E-03_JPRB /)

RGHG1(:,63,12) = (/ &
  & 0.37099046E-03_JPRB, 0.37099066E-03_JPRB, 0.37099069E-03_JPRB, 0.37099066E-03_JPRB, 0.37099066E-03_JPRB, 0.37099057E-03_JPRB, &
  & 0.37099054E-03_JPRB, 0.37099051E-03_JPRB, 0.37099054E-03_JPRB, 0.37099060E-03_JPRB, 0.37099066E-03_JPRB, 0.37099078E-03_JPRB, &
  & 0.37099083E-03_JPRB, 0.37099078E-03_JPRB, 0.37099057E-03_JPRB, 0.37099046E-03_JPRB, 0.37099002E-03_JPRB, 0.37098993E-03_JPRB, &
  & 0.37098996E-03_JPRB, 0.37099002E-03_JPRB, 0.37099046E-03_JPRB, 0.37099127E-03_JPRB, 0.37099241E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37099619E-03_JPRB, 0.37099718E-03_JPRB, 0.37099779E-03_JPRB, 0.37099846E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099930E-03_JPRB, 0.37099922E-03_JPRB, 0.37099916E-03_JPRB, 0.37099875E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099788E-03_JPRB, 0.37099730E-03_JPRB, 0.37099683E-03_JPRB, 0.37099645E-03_JPRB, 0.37099593E-03_JPRB, 0.37099561E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099532E-03_JPRB, 0.37099532E-03_JPRB, 0.37099546E-03_JPRB, 0.37099561E-03_JPRB, 0.37099578E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37099572E-03_JPRB, 0.37099567E-03_JPRB, 0.37099555E-03_JPRB, 0.37099537E-03_JPRB, 0.37099532E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099520E-03_JPRB, 0.37099514E-03_JPRB, 0.37099511E-03_JPRB, 0.37099503E-03_JPRB, 0.37099491E-03_JPRB, &
  & 0.37099485E-03_JPRB, 0.37099482E-03_JPRB, 0.37099473E-03_JPRB, 0.37099459E-03_JPRB /)

RGHG1(:,64,12) = (/ &
  & 0.37099136E-03_JPRB, 0.37099147E-03_JPRB, 0.37099153E-03_JPRB, 0.37099147E-03_JPRB, 0.37099142E-03_JPRB, 0.37099136E-03_JPRB, &
  & 0.37099133E-03_JPRB, 0.37099127E-03_JPRB, 0.37099136E-03_JPRB, 0.37099142E-03_JPRB, 0.37099156E-03_JPRB, 0.37099177E-03_JPRB, &
  & 0.37099182E-03_JPRB, 0.37099182E-03_JPRB, 0.37099150E-03_JPRB, 0.37099153E-03_JPRB, 0.37099107E-03_JPRB, 0.37099083E-03_JPRB, &
  & 0.37099066E-03_JPRB, 0.37099092E-03_JPRB, 0.37099145E-03_JPRB, 0.37099232E-03_JPRB, 0.37099334E-03_JPRB, 0.37099462E-03_JPRB, &
  & 0.37099564E-03_JPRB, 0.37099674E-03_JPRB, 0.37099756E-03_JPRB, 0.37099820E-03_JPRB, 0.37099875E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099959E-03_JPRB, 0.37099948E-03_JPRB, 0.37099939E-03_JPRB, 0.37099895E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099759E-03_JPRB, 0.37099718E-03_JPRB, 0.37099680E-03_JPRB, 0.37099631E-03_JPRB, 0.37099604E-03_JPRB, &
  & 0.37099581E-03_JPRB, 0.37099578E-03_JPRB, 0.37099587E-03_JPRB, 0.37099599E-03_JPRB, 0.37099613E-03_JPRB, 0.37099628E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099628E-03_JPRB, 0.37099625E-03_JPRB, 0.37099613E-03_JPRB, 0.37099604E-03_JPRB, 0.37099599E-03_JPRB, &
  & 0.37099587E-03_JPRB, 0.37099572E-03_JPRB, 0.37099561E-03_JPRB, 0.37099549E-03_JPRB, 0.37099543E-03_JPRB, 0.37099537E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37099523E-03_JPRB, 0.37099514E-03_JPRB, 0.37099497E-03_JPRB /)

RGHG1(:,65,12) = (/ &
  & 0.37099211E-03_JPRB, 0.37099223E-03_JPRB, 0.37099217E-03_JPRB, 0.37099217E-03_JPRB, 0.37099214E-03_JPRB, 0.37099209E-03_JPRB, &
  & 0.37099211E-03_JPRB, 0.37099211E-03_JPRB, 0.37099226E-03_JPRB, 0.37099235E-03_JPRB, 0.37099241E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099273E-03_JPRB, 0.37099273E-03_JPRB, 0.37099229E-03_JPRB, 0.37099246E-03_JPRB, 0.37099206E-03_JPRB, 0.37099191E-03_JPRB, &
  & 0.37099206E-03_JPRB, 0.37099209E-03_JPRB, 0.37099246E-03_JPRB, 0.37099316E-03_JPRB, 0.37099415E-03_JPRB, 0.37099523E-03_JPRB, &
  & 0.37099633E-03_JPRB, 0.37099727E-03_JPRB, 0.37099802E-03_JPRB, 0.37099846E-03_JPRB, 0.37099901E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37099977E-03_JPRB, 0.37099977E-03_JPRB, 0.37099959E-03_JPRB, 0.37099922E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099779E-03_JPRB, 0.37099753E-03_JPRB, 0.37099706E-03_JPRB, 0.37099663E-03_JPRB, 0.37099645E-03_JPRB, &
  & 0.37099631E-03_JPRB, 0.37099628E-03_JPRB, 0.37099639E-03_JPRB, 0.37099648E-03_JPRB, 0.37099665E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099683E-03_JPRB, 0.37099677E-03_JPRB, 0.37099671E-03_JPRB, 0.37099660E-03_JPRB, 0.37099648E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099607E-03_JPRB, 0.37099601E-03_JPRB, 0.37099590E-03_JPRB, 0.37099578E-03_JPRB, 0.37099569E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099552E-03_JPRB, 0.37099543E-03_JPRB, 0.37099523E-03_JPRB /)

RGHG1(:,66,12) = (/ &
  & 0.37099281E-03_JPRB, 0.37099293E-03_JPRB, 0.37099287E-03_JPRB, 0.37099281E-03_JPRB, 0.37099281E-03_JPRB, 0.37099281E-03_JPRB, &
  & 0.37099290E-03_JPRB, 0.37099290E-03_JPRB, 0.37099305E-03_JPRB, 0.37099313E-03_JPRB, 0.37099325E-03_JPRB, 0.37099360E-03_JPRB, &
  & 0.37099363E-03_JPRB, 0.37099360E-03_JPRB, 0.37099287E-03_JPRB, 0.37099331E-03_JPRB, 0.37099290E-03_JPRB, 0.37099270E-03_JPRB, &
  & 0.37099270E-03_JPRB, 0.37099299E-03_JPRB, 0.37099325E-03_JPRB, 0.37099406E-03_JPRB, 0.37099503E-03_JPRB, 0.37099593E-03_JPRB, &
  & 0.37099695E-03_JPRB, 0.37099782E-03_JPRB, 0.37099849E-03_JPRB, 0.37099884E-03_JPRB, 0.37099936E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100006E-03_JPRB, 0.37099991E-03_JPRB, 0.37099971E-03_JPRB, 0.37099951E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099863E-03_JPRB, 0.37099814E-03_JPRB, 0.37099785E-03_JPRB, 0.37099744E-03_JPRB, 0.37099706E-03_JPRB, 0.37099683E-03_JPRB, &
  & 0.37099674E-03_JPRB, 0.37099674E-03_JPRB, 0.37099683E-03_JPRB, 0.37099695E-03_JPRB, 0.37099712E-03_JPRB, 0.37099715E-03_JPRB, &
  & 0.37099724E-03_JPRB, 0.37099718E-03_JPRB, 0.37099712E-03_JPRB, 0.37099712E-03_JPRB, 0.37099700E-03_JPRB, 0.37099680E-03_JPRB, &
  & 0.37099665E-03_JPRB, 0.37099651E-03_JPRB, 0.37099633E-03_JPRB, 0.37099619E-03_JPRB, 0.37099607E-03_JPRB, 0.37099601E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099584E-03_JPRB, 0.37099575E-03_JPRB, 0.37099543E-03_JPRB /)

RGHG1(:,67,12) = (/ &
  & 0.37099345E-03_JPRB, 0.37099351E-03_JPRB, 0.37099345E-03_JPRB, 0.37099351E-03_JPRB, 0.37099357E-03_JPRB, 0.37099351E-03_JPRB, &
  & 0.37099351E-03_JPRB, 0.37099357E-03_JPRB, 0.37099380E-03_JPRB, 0.37099401E-03_JPRB, 0.37099409E-03_JPRB, 0.37099447E-03_JPRB, &
  & 0.37099453E-03_JPRB, 0.37099450E-03_JPRB, 0.37099357E-03_JPRB, 0.37099438E-03_JPRB, 0.37099377E-03_JPRB, 0.37099374E-03_JPRB, &
  & 0.37099389E-03_JPRB, 0.37099401E-03_JPRB, 0.37099418E-03_JPRB, 0.37099491E-03_JPRB, 0.37099575E-03_JPRB, 0.37099660E-03_JPRB, &
  & 0.37099759E-03_JPRB, 0.37099834E-03_JPRB, 0.37099887E-03_JPRB, 0.37099916E-03_JPRB, 0.37099962E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37100023E-03_JPRB, 0.37100026E-03_JPRB, 0.37100009E-03_JPRB, 0.37099989E-03_JPRB, 0.37099974E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099837E-03_JPRB, 0.37099805E-03_JPRB, 0.37099779E-03_JPRB, 0.37099747E-03_JPRB, 0.37099727E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099718E-03_JPRB, 0.37099732E-03_JPRB, 0.37099747E-03_JPRB, 0.37099756E-03_JPRB, 0.37099762E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099759E-03_JPRB, 0.37099759E-03_JPRB, 0.37099756E-03_JPRB, 0.37099744E-03_JPRB, 0.37099721E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099683E-03_JPRB, 0.37099671E-03_JPRB, 0.37099663E-03_JPRB, 0.37099651E-03_JPRB, 0.37099631E-03_JPRB, &
  & 0.37099622E-03_JPRB, 0.37099616E-03_JPRB, 0.37099599E-03_JPRB, 0.37099564E-03_JPRB /)

RGHG1(:,68,12) = (/ &
  & 0.37099406E-03_JPRB, 0.37099415E-03_JPRB, 0.37099415E-03_JPRB, 0.37099415E-03_JPRB, 0.37099415E-03_JPRB, 0.37099415E-03_JPRB, &
  & 0.37099430E-03_JPRB, 0.37099438E-03_JPRB, 0.37099459E-03_JPRB, 0.37099473E-03_JPRB, 0.37099494E-03_JPRB, 0.37099535E-03_JPRB, &
  & 0.37099540E-03_JPRB, 0.37099532E-03_JPRB, 0.37099398E-03_JPRB, 0.37099537E-03_JPRB, 0.37099447E-03_JPRB, 0.37099450E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37099485E-03_JPRB, 0.37099511E-03_JPRB, 0.37099578E-03_JPRB, 0.37099660E-03_JPRB, 0.37099730E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099875E-03_JPRB, 0.37099925E-03_JPRB, 0.37099945E-03_JPRB, 0.37099980E-03_JPRB, 0.37100015E-03_JPRB, &
  & 0.37100047E-03_JPRB, 0.37100050E-03_JPRB, 0.37100018E-03_JPRB, 0.37099997E-03_JPRB, 0.37099991E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099858E-03_JPRB, 0.37099828E-03_JPRB, 0.37099814E-03_JPRB, 0.37099788E-03_JPRB, 0.37099764E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37099773E-03_JPRB, 0.37099788E-03_JPRB, 0.37099796E-03_JPRB, 0.37099805E-03_JPRB, 0.37099799E-03_JPRB, &
  & 0.37099808E-03_JPRB, 0.37099802E-03_JPRB, 0.37099794E-03_JPRB, 0.37099794E-03_JPRB, 0.37099779E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099724E-03_JPRB, 0.37099712E-03_JPRB, 0.37099698E-03_JPRB, 0.37099686E-03_JPRB, 0.37099663E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099645E-03_JPRB, 0.37099633E-03_JPRB, 0.37099584E-03_JPRB /)

RGHG1(:,69,12) = (/ &
  & 0.37099473E-03_JPRB, 0.37099479E-03_JPRB, 0.37099485E-03_JPRB, 0.37099485E-03_JPRB, 0.37099482E-03_JPRB, 0.37099485E-03_JPRB, &
  & 0.37099503E-03_JPRB, 0.37099508E-03_JPRB, 0.37099546E-03_JPRB, 0.37099558E-03_JPRB, 0.37099572E-03_JPRB, 0.37099607E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37099622E-03_JPRB, 0.37099430E-03_JPRB, 0.37099642E-03_JPRB, 0.37099517E-03_JPRB, 0.37099543E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099575E-03_JPRB, 0.37099584E-03_JPRB, 0.37099651E-03_JPRB, 0.37099732E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099866E-03_JPRB, 0.37099910E-03_JPRB, 0.37099948E-03_JPRB, 0.37099977E-03_JPRB, 0.37100000E-03_JPRB, 0.37100035E-03_JPRB, &
  & 0.37100061E-03_JPRB, 0.37100055E-03_JPRB, 0.37100021E-03_JPRB, 0.37100000E-03_JPRB, 0.37100003E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099930E-03_JPRB, 0.37099881E-03_JPRB, 0.37099852E-03_JPRB, 0.37099843E-03_JPRB, 0.37099828E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099817E-03_JPRB, 0.37099831E-03_JPRB, 0.37099843E-03_JPRB, 0.37099846E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099849E-03_JPRB, 0.37099840E-03_JPRB, 0.37099831E-03_JPRB, 0.37099840E-03_JPRB, 0.37099828E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37099785E-03_JPRB, 0.37099759E-03_JPRB, 0.37099744E-03_JPRB, 0.37099735E-03_JPRB, 0.37099727E-03_JPRB, 0.37099695E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37099683E-03_JPRB, 0.37099671E-03_JPRB, 0.37099607E-03_JPRB /)

RGHG1(:,70,12) = (/ &
  & 0.37099526E-03_JPRB, 0.37099540E-03_JPRB, 0.37099540E-03_JPRB, 0.37099543E-03_JPRB, 0.37099552E-03_JPRB, 0.37099552E-03_JPRB, &
  & 0.37099572E-03_JPRB, 0.37099584E-03_JPRB, 0.37099622E-03_JPRB, 0.37099648E-03_JPRB, 0.37099660E-03_JPRB, 0.37099686E-03_JPRB, &
  & 0.37099700E-03_JPRB, 0.37099721E-03_JPRB, 0.37099459E-03_JPRB, 0.37099718E-03_JPRB, 0.37099596E-03_JPRB, 0.37099610E-03_JPRB, &
  & 0.37099651E-03_JPRB, 0.37099657E-03_JPRB, 0.37099648E-03_JPRB, 0.37099718E-03_JPRB, 0.37099799E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37099916E-03_JPRB, 0.37099948E-03_JPRB, 0.37099977E-03_JPRB, 0.37099991E-03_JPRB, 0.37100015E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100061E-03_JPRB, 0.37100021E-03_JPRB, 0.37100012E-03_JPRB, 0.37100021E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37099904E-03_JPRB, 0.37099872E-03_JPRB, 0.37099872E-03_JPRB, 0.37099858E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099872E-03_JPRB, 0.37099887E-03_JPRB, 0.37099890E-03_JPRB, 0.37099881E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099884E-03_JPRB, 0.37099878E-03_JPRB, 0.37099869E-03_JPRB, 0.37099881E-03_JPRB, 0.37099869E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099820E-03_JPRB, 0.37099799E-03_JPRB, 0.37099782E-03_JPRB, 0.37099770E-03_JPRB, 0.37099773E-03_JPRB, 0.37099735E-03_JPRB, &
  & 0.37099712E-03_JPRB, 0.37099724E-03_JPRB, 0.37099718E-03_JPRB, 0.37099633E-03_JPRB /)

RGHG1(:,71,12) = (/ &
  & 0.37099584E-03_JPRB, 0.37099607E-03_JPRB, 0.37099596E-03_JPRB, 0.37099601E-03_JPRB, 0.37099625E-03_JPRB, 0.37099613E-03_JPRB, &
  & 0.37099642E-03_JPRB, 0.37099657E-03_JPRB, 0.37099692E-03_JPRB, 0.37099730E-03_JPRB, 0.37099735E-03_JPRB, 0.37099759E-03_JPRB, &
  & 0.37099773E-03_JPRB, 0.37099820E-03_JPRB, 0.37099523E-03_JPRB, 0.37099753E-03_JPRB, 0.37099674E-03_JPRB, 0.37099692E-03_JPRB, &
  & 0.37099744E-03_JPRB, 0.37099732E-03_JPRB, 0.37099721E-03_JPRB, 0.37099782E-03_JPRB, 0.37099866E-03_JPRB, 0.37099930E-03_JPRB, &
  & 0.37099957E-03_JPRB, 0.37099991E-03_JPRB, 0.37100012E-03_JPRB, 0.37100015E-03_JPRB, 0.37100029E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100093E-03_JPRB, 0.37100073E-03_JPRB, 0.37100032E-03_JPRB, 0.37100009E-03_JPRB, 0.37100032E-03_JPRB, 0.37099986E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099927E-03_JPRB, 0.37099890E-03_JPRB, 0.37099904E-03_JPRB, 0.37099890E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099913E-03_JPRB, 0.37099933E-03_JPRB, 0.37099939E-03_JPRB, 0.37099922E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099907E-03_JPRB, 0.37099910E-03_JPRB, 0.37099898E-03_JPRB, 0.37099916E-03_JPRB, 0.37099901E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37099869E-03_JPRB, 0.37099840E-03_JPRB, 0.37099820E-03_JPRB, 0.37099799E-03_JPRB, 0.37099814E-03_JPRB, 0.37099773E-03_JPRB, &
  & 0.37099741E-03_JPRB, 0.37099770E-03_JPRB, 0.37099764E-03_JPRB, 0.37099665E-03_JPRB /)

RGHG1(:,72,12) = (/ &
  & 0.37099631E-03_JPRB, 0.37099671E-03_JPRB, 0.37099654E-03_JPRB, 0.37099665E-03_JPRB, 0.37099700E-03_JPRB, 0.37099671E-03_JPRB, &
  & 0.37099709E-03_JPRB, 0.37099724E-03_JPRB, 0.37099762E-03_JPRB, 0.37099799E-03_JPRB, 0.37099805E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37099843E-03_JPRB, 0.37099881E-03_JPRB, 0.37099622E-03_JPRB, 0.37099767E-03_JPRB, 0.37099759E-03_JPRB, 0.37099756E-03_JPRB, &
  & 0.37099814E-03_JPRB, 0.37099799E-03_JPRB, 0.37099785E-03_JPRB, 0.37099840E-03_JPRB, 0.37099925E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100021E-03_JPRB, 0.37100055E-03_JPRB, 0.37100038E-03_JPRB, 0.37100050E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100079E-03_JPRB, 0.37100026E-03_JPRB, 0.37100009E-03_JPRB, 0.37100044E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099948E-03_JPRB, 0.37099901E-03_JPRB, 0.37099933E-03_JPRB, 0.37099922E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37099968E-03_JPRB, 0.37099991E-03_JPRB, 0.37099980E-03_JPRB, 0.37099959E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099925E-03_JPRB, 0.37099939E-03_JPRB, 0.37099925E-03_JPRB, 0.37099957E-03_JPRB, 0.37099951E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099904E-03_JPRB, 0.37099881E-03_JPRB, 0.37099863E-03_JPRB, 0.37099828E-03_JPRB, 0.37099860E-03_JPRB, 0.37099808E-03_JPRB, &
  & 0.37099767E-03_JPRB, 0.37099826E-03_JPRB, 0.37099823E-03_JPRB, 0.37099695E-03_JPRB /)

RGHG1(:,73,12) = (/ &
  & 0.37099683E-03_JPRB, 0.37099744E-03_JPRB, 0.37099712E-03_JPRB, 0.37099721E-03_JPRB, 0.37099773E-03_JPRB, 0.37099738E-03_JPRB, &
  & 0.37099776E-03_JPRB, 0.37099788E-03_JPRB, 0.37099831E-03_JPRB, 0.37099866E-03_JPRB, 0.37099863E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099893E-03_JPRB, 0.37099927E-03_JPRB, 0.37099730E-03_JPRB, 0.37099799E-03_JPRB, 0.37099826E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099890E-03_JPRB, 0.37099863E-03_JPRB, 0.37099834E-03_JPRB, 0.37099887E-03_JPRB, 0.37099986E-03_JPRB, 0.37100041E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100053E-03_JPRB, 0.37100085E-03_JPRB, 0.37100058E-03_JPRB, 0.37100079E-03_JPRB, 0.37100073E-03_JPRB, &
  & 0.37100120E-03_JPRB, 0.37100079E-03_JPRB, 0.37100026E-03_JPRB, 0.37099997E-03_JPRB, 0.37100050E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099965E-03_JPRB, 0.37099910E-03_JPRB, 0.37099968E-03_JPRB, 0.37099945E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100029E-03_JPRB, 0.37100050E-03_JPRB, 0.37100021E-03_JPRB, 0.37099991E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099957E-03_JPRB, 0.37099945E-03_JPRB, 0.37099991E-03_JPRB, 0.37099989E-03_JPRB, 0.37099959E-03_JPRB, &
  & 0.37099939E-03_JPRB, 0.37099916E-03_JPRB, 0.37099890E-03_JPRB, 0.37099843E-03_JPRB, 0.37099898E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099796E-03_JPRB, 0.37099890E-03_JPRB, 0.37099887E-03_JPRB, 0.37099738E-03_JPRB /)

RGHG1(:,74,12) = (/ &
  & 0.37099718E-03_JPRB, 0.37099811E-03_JPRB, 0.37099759E-03_JPRB, 0.37099770E-03_JPRB, 0.37099846E-03_JPRB, 0.37099791E-03_JPRB, &
  & 0.37099823E-03_JPRB, 0.37099831E-03_JPRB, 0.37099881E-03_JPRB, 0.37099922E-03_JPRB, 0.37099904E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099927E-03_JPRB, 0.37099959E-03_JPRB, 0.37099802E-03_JPRB, 0.37099834E-03_JPRB, 0.37099890E-03_JPRB, 0.37099858E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37099925E-03_JPRB, 0.37099875E-03_JPRB, 0.37099930E-03_JPRB, 0.37100038E-03_JPRB, 0.37100079E-03_JPRB, &
  & 0.37100070E-03_JPRB, 0.37100073E-03_JPRB, 0.37100114E-03_JPRB, 0.37100088E-03_JPRB, 0.37100102E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100079E-03_JPRB, 0.37100012E-03_JPRB, 0.37099974E-03_JPRB, 0.37100064E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37100050E-03_JPRB, 0.37099986E-03_JPRB, 0.37099916E-03_JPRB, 0.37100003E-03_JPRB, 0.37099962E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100076E-03_JPRB, 0.37100114E-03_JPRB, 0.37100061E-03_JPRB, 0.37100021E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099936E-03_JPRB, 0.37099971E-03_JPRB, 0.37099968E-03_JPRB, 0.37100026E-03_JPRB, 0.37100029E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099942E-03_JPRB, 0.37099916E-03_JPRB, 0.37099855E-03_JPRB, 0.37099942E-03_JPRB, 0.37099855E-03_JPRB, &
  & 0.37099811E-03_JPRB, 0.37099951E-03_JPRB, 0.37099962E-03_JPRB, 0.37099776E-03_JPRB /)

RGHG1(:,75,12) = (/ &
  & 0.37099750E-03_JPRB, 0.37099884E-03_JPRB, 0.37099799E-03_JPRB, 0.37099805E-03_JPRB, 0.37099927E-03_JPRB, 0.37099840E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37099866E-03_JPRB, 0.37099936E-03_JPRB, 0.37099971E-03_JPRB, 0.37099927E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37099997E-03_JPRB, 0.37099855E-03_JPRB, 0.37099860E-03_JPRB, 0.37099933E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099977E-03_JPRB, 0.37099927E-03_JPRB, 0.37099968E-03_JPRB, 0.37100085E-03_JPRB, 0.37100117E-03_JPRB, &
  & 0.37100096E-03_JPRB, 0.37100085E-03_JPRB, 0.37100131E-03_JPRB, 0.37100111E-03_JPRB, 0.37100134E-03_JPRB, 0.37100085E-03_JPRB, &
  & 0.37100143E-03_JPRB, 0.37100070E-03_JPRB, 0.37100000E-03_JPRB, 0.37099939E-03_JPRB, 0.37100070E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100090E-03_JPRB, 0.37100006E-03_JPRB, 0.37099925E-03_JPRB, 0.37100050E-03_JPRB, 0.37099991E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100137E-03_JPRB, 0.37100189E-03_JPRB, 0.37100102E-03_JPRB, 0.37100038E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099913E-03_JPRB, 0.37099968E-03_JPRB, 0.37099986E-03_JPRB, 0.37100064E-03_JPRB, 0.37100076E-03_JPRB, 0.37100021E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37099971E-03_JPRB, 0.37099933E-03_JPRB, 0.37099849E-03_JPRB, 0.37099980E-03_JPRB, 0.37099872E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37100015E-03_JPRB, 0.37100032E-03_JPRB, 0.37099820E-03_JPRB /)

RGHG1(:,76,12) = (/ &
  & 0.37099773E-03_JPRB, 0.37099962E-03_JPRB, 0.37099837E-03_JPRB, 0.37099834E-03_JPRB, 0.37100015E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099919E-03_JPRB, 0.37099893E-03_JPRB, 0.37099968E-03_JPRB, 0.37100015E-03_JPRB, 0.37099948E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100038E-03_JPRB, 0.37099890E-03_JPRB, 0.37099893E-03_JPRB, 0.37099983E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37100073E-03_JPRB, 0.37100021E-03_JPRB, 0.37099945E-03_JPRB, 0.37099994E-03_JPRB, 0.37100128E-03_JPRB, 0.37100154E-03_JPRB, &
  & 0.37100122E-03_JPRB, 0.37100085E-03_JPRB, 0.37100160E-03_JPRB, 0.37100146E-03_JPRB, 0.37100166E-03_JPRB, 0.37100076E-03_JPRB, &
  & 0.37100160E-03_JPRB, 0.37100064E-03_JPRB, 0.37099997E-03_JPRB, 0.37099904E-03_JPRB, 0.37100079E-03_JPRB, 0.37099971E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100035E-03_JPRB, 0.37099925E-03_JPRB, 0.37100099E-03_JPRB, 0.37100009E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100192E-03_JPRB, 0.37100250E-03_JPRB, 0.37100140E-03_JPRB, 0.37100053E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099881E-03_JPRB, 0.37099959E-03_JPRB, 0.37099997E-03_JPRB, 0.37100111E-03_JPRB, 0.37100134E-03_JPRB, 0.37100047E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37099997E-03_JPRB, 0.37099945E-03_JPRB, 0.37099826E-03_JPRB, 0.37100032E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099802E-03_JPRB, 0.37100079E-03_JPRB, 0.37100122E-03_JPRB, 0.37099849E-03_JPRB /)

RGHG1(:,77,12) = (/ &
  & 0.37099788E-03_JPRB, 0.37100050E-03_JPRB, 0.37099863E-03_JPRB, 0.37099855E-03_JPRB, 0.37100114E-03_JPRB, 0.37099904E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37099893E-03_JPRB, 0.37100003E-03_JPRB, 0.37100067E-03_JPRB, 0.37099936E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099989E-03_JPRB, 0.37100073E-03_JPRB, 0.37099919E-03_JPRB, 0.37099904E-03_JPRB, 0.37100023E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37100131E-03_JPRB, 0.37100073E-03_JPRB, 0.37099977E-03_JPRB, 0.37100012E-03_JPRB, 0.37100172E-03_JPRB, 0.37100189E-03_JPRB, &
  & 0.37100149E-03_JPRB, 0.37100090E-03_JPRB, 0.37100186E-03_JPRB, 0.37100184E-03_JPRB, 0.37100207E-03_JPRB, 0.37100067E-03_JPRB, &
  & 0.37100175E-03_JPRB, 0.37100044E-03_JPRB, 0.37099997E-03_JPRB, 0.37099858E-03_JPRB, 0.37100096E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37100204E-03_JPRB, 0.37100067E-03_JPRB, 0.37099927E-03_JPRB, 0.37100146E-03_JPRB, 0.37100026E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100259E-03_JPRB, 0.37100338E-03_JPRB, 0.37100184E-03_JPRB, 0.37100058E-03_JPRB, 0.37100003E-03_JPRB, &
  & 0.37099837E-03_JPRB, 0.37099948E-03_JPRB, 0.37100000E-03_JPRB, 0.37100149E-03_JPRB, 0.37100192E-03_JPRB, 0.37100064E-03_JPRB, &
  & 0.37100041E-03_JPRB, 0.37100006E-03_JPRB, 0.37099945E-03_JPRB, 0.37099782E-03_JPRB, 0.37100085E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37099762E-03_JPRB, 0.37100169E-03_JPRB, 0.37100207E-03_JPRB, 0.37099878E-03_JPRB /)

RGHG1(:,78,12) = (/ &
  & 0.37099788E-03_JPRB, 0.37100140E-03_JPRB, 0.37099887E-03_JPRB, 0.37099858E-03_JPRB, 0.37100218E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37099875E-03_JPRB, 0.37100029E-03_JPRB, 0.37100108E-03_JPRB, 0.37099919E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099977E-03_JPRB, 0.37100114E-03_JPRB, 0.37099939E-03_JPRB, 0.37099916E-03_JPRB, 0.37100064E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37100169E-03_JPRB, 0.37100108E-03_JPRB, 0.37099994E-03_JPRB, 0.37100038E-03_JPRB, 0.37100213E-03_JPRB, 0.37100207E-03_JPRB, &
  & 0.37100166E-03_JPRB, 0.37100090E-03_JPRB, 0.37100213E-03_JPRB, 0.37100221E-03_JPRB, 0.37100245E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100192E-03_JPRB, 0.37100038E-03_JPRB, 0.37100000E-03_JPRB, 0.37099805E-03_JPRB, 0.37100108E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100102E-03_JPRB, 0.37099933E-03_JPRB, 0.37100201E-03_JPRB, 0.37100038E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099983E-03_JPRB, 0.37100315E-03_JPRB, 0.37100413E-03_JPRB, 0.37100216E-03_JPRB, 0.37100061E-03_JPRB, 0.37100000E-03_JPRB, &
  & 0.37099782E-03_JPRB, 0.37099933E-03_JPRB, 0.37099997E-03_JPRB, 0.37100178E-03_JPRB, 0.37100248E-03_JPRB, 0.37100070E-03_JPRB, &
  & 0.37100067E-03_JPRB, 0.37100015E-03_JPRB, 0.37099939E-03_JPRB, 0.37099724E-03_JPRB, 0.37100137E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37099730E-03_JPRB, 0.37100253E-03_JPRB, 0.37100294E-03_JPRB, 0.37099907E-03_JPRB /)

RGHG1(:,79,12) = (/ &
  & 0.37099770E-03_JPRB, 0.37100207E-03_JPRB, 0.37099887E-03_JPRB, 0.37099852E-03_JPRB, 0.37100315E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37099852E-03_JPRB, 0.37100035E-03_JPRB, 0.37100146E-03_JPRB, 0.37099895E-03_JPRB, 0.37099936E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100149E-03_JPRB, 0.37099951E-03_JPRB, 0.37099916E-03_JPRB, 0.37100088E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37100218E-03_JPRB, 0.37100143E-03_JPRB, 0.37099994E-03_JPRB, 0.37100055E-03_JPRB, 0.37100256E-03_JPRB, 0.37100242E-03_JPRB, &
  & 0.37100195E-03_JPRB, 0.37100099E-03_JPRB, 0.37100253E-03_JPRB, 0.37100271E-03_JPRB, 0.37100294E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100216E-03_JPRB, 0.37100026E-03_JPRB, 0.37100000E-03_JPRB, 0.37099762E-03_JPRB, 0.37100128E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100352E-03_JPRB, 0.37100134E-03_JPRB, 0.37099922E-03_JPRB, 0.37100256E-03_JPRB, 0.37100053E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099974E-03_JPRB, 0.37100384E-03_JPRB, 0.37100507E-03_JPRB, 0.37100262E-03_JPRB, 0.37100058E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099727E-03_JPRB, 0.37099916E-03_JPRB, 0.37099994E-03_JPRB, 0.37100218E-03_JPRB, 0.37100306E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100085E-03_JPRB, 0.37100023E-03_JPRB, 0.37099933E-03_JPRB, 0.37099671E-03_JPRB, 0.37100181E-03_JPRB, 0.37099860E-03_JPRB, &
  & 0.37099677E-03_JPRB, 0.37100329E-03_JPRB, 0.37100373E-03_JPRB, 0.37099910E-03_JPRB /)

RGHG1(:,80,12) = (/ &
  & 0.37099724E-03_JPRB, 0.37100259E-03_JPRB, 0.37099881E-03_JPRB, 0.37099837E-03_JPRB, 0.37100364E-03_JPRB, 0.37099919E-03_JPRB, &
  & 0.37100012E-03_JPRB, 0.37099834E-03_JPRB, 0.37100058E-03_JPRB, 0.37100184E-03_JPRB, 0.37099881E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100166E-03_JPRB, 0.37099948E-03_JPRB, 0.37099913E-03_JPRB, 0.37100108E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100166E-03_JPRB, 0.37100003E-03_JPRB, 0.37100070E-03_JPRB, 0.37100297E-03_JPRB, 0.37100271E-03_JPRB, &
  & 0.37100210E-03_JPRB, 0.37100114E-03_JPRB, 0.37100288E-03_JPRB, 0.37100312E-03_JPRB, 0.37100338E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100242E-03_JPRB, 0.37100021E-03_JPRB, 0.37099994E-03_JPRB, 0.37099724E-03_JPRB, 0.37100134E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37100399E-03_JPRB, 0.37100157E-03_JPRB, 0.37099916E-03_JPRB, 0.37100285E-03_JPRB, 0.37100055E-03_JPRB, 0.37099994E-03_JPRB, &
  & 0.37099971E-03_JPRB, 0.37100434E-03_JPRB, 0.37100582E-03_JPRB, 0.37100306E-03_JPRB, 0.37100076E-03_JPRB, 0.37099997E-03_JPRB, &
  & 0.37099686E-03_JPRB, 0.37099904E-03_JPRB, 0.37099991E-03_JPRB, 0.37100248E-03_JPRB, 0.37100349E-03_JPRB, 0.37100093E-03_JPRB, &
  & 0.37100102E-03_JPRB, 0.37100026E-03_JPRB, 0.37099933E-03_JPRB, 0.37099631E-03_JPRB, 0.37100210E-03_JPRB, 0.37099849E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37100387E-03_JPRB, 0.37100443E-03_JPRB, 0.37099907E-03_JPRB /)

RGHG1(:,81,12) = (/ &
  & 0.37099654E-03_JPRB, 0.37100288E-03_JPRB, 0.37099878E-03_JPRB, 0.37099837E-03_JPRB, 0.37100396E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37100021E-03_JPRB, 0.37099834E-03_JPRB, 0.37100053E-03_JPRB, 0.37100189E-03_JPRB, 0.37099878E-03_JPRB, 0.37099933E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100184E-03_JPRB, 0.37099954E-03_JPRB, 0.37099910E-03_JPRB, 0.37100122E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37100285E-03_JPRB, 0.37100189E-03_JPRB, 0.37100012E-03_JPRB, 0.37100082E-03_JPRB, 0.37100323E-03_JPRB, 0.37100282E-03_JPRB, &
  & 0.37100224E-03_JPRB, 0.37100125E-03_JPRB, 0.37100309E-03_JPRB, 0.37100338E-03_JPRB, 0.37100364E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100018E-03_JPRB, 0.37099994E-03_JPRB, 0.37099692E-03_JPRB, 0.37100140E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37100431E-03_JPRB, 0.37100172E-03_JPRB, 0.37099919E-03_JPRB, 0.37100309E-03_JPRB, 0.37100067E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37100472E-03_JPRB, 0.37100638E-03_JPRB, 0.37100329E-03_JPRB, 0.37100073E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099660E-03_JPRB, 0.37099895E-03_JPRB, 0.37099994E-03_JPRB, 0.37100271E-03_JPRB, 0.37100381E-03_JPRB, 0.37100099E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100035E-03_JPRB, 0.37099930E-03_JPRB, 0.37099607E-03_JPRB, 0.37100233E-03_JPRB, 0.37099843E-03_JPRB, &
  & 0.37099616E-03_JPRB, 0.37100431E-03_JPRB, 0.37100492E-03_JPRB, 0.37099890E-03_JPRB /)

RGHG1(:,82,12) = (/ &
  & 0.37099645E-03_JPRB, 0.37100297E-03_JPRB, 0.37099875E-03_JPRB, 0.37099828E-03_JPRB, 0.37100416E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099823E-03_JPRB, 0.37100070E-03_JPRB, 0.37100210E-03_JPRB, 0.37099860E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100192E-03_JPRB, 0.37099951E-03_JPRB, 0.37099907E-03_JPRB, 0.37100134E-03_JPRB, 0.37099881E-03_JPRB, &
  & 0.37100309E-03_JPRB, 0.37100201E-03_JPRB, 0.37100012E-03_JPRB, 0.37100090E-03_JPRB, 0.37100341E-03_JPRB, 0.37100297E-03_JPRB, &
  & 0.37100233E-03_JPRB, 0.37100131E-03_JPRB, 0.37100326E-03_JPRB, 0.37100358E-03_JPRB, 0.37100384E-03_JPRB, 0.37100055E-03_JPRB, &
  & 0.37100274E-03_JPRB, 0.37100015E-03_JPRB, 0.37099986E-03_JPRB, 0.37099680E-03_JPRB, 0.37100140E-03_JPRB, 0.37099884E-03_JPRB, &
  & 0.37100434E-03_JPRB, 0.37100184E-03_JPRB, 0.37099930E-03_JPRB, 0.37100315E-03_JPRB, 0.37100073E-03_JPRB, 0.37099991E-03_JPRB, &
  & 0.37099962E-03_JPRB, 0.37100498E-03_JPRB, 0.37100675E-03_JPRB, 0.37100347E-03_JPRB, 0.37100067E-03_JPRB, 0.37099983E-03_JPRB, &
  & 0.37099639E-03_JPRB, 0.37099887E-03_JPRB, 0.37099991E-03_JPRB, 0.37100288E-03_JPRB, 0.37100396E-03_JPRB, 0.37100105E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100035E-03_JPRB, 0.37099927E-03_JPRB, 0.37099587E-03_JPRB, 0.37100242E-03_JPRB, 0.37099834E-03_JPRB, &
  & 0.37099599E-03_JPRB, 0.37100454E-03_JPRB, 0.37100512E-03_JPRB, 0.37099884E-03_JPRB /)

RGHG1(:,83,12) = (/ &
  & 0.37099642E-03_JPRB, 0.37100309E-03_JPRB, 0.37099869E-03_JPRB, 0.37099823E-03_JPRB, 0.37100422E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37100015E-03_JPRB, 0.37099820E-03_JPRB, 0.37100055E-03_JPRB, 0.37100201E-03_JPRB, 0.37099875E-03_JPRB, 0.37099927E-03_JPRB, &
  & 0.37099954E-03_JPRB, 0.37100195E-03_JPRB, 0.37099951E-03_JPRB, 0.37099904E-03_JPRB, 0.37100131E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37100320E-03_JPRB, 0.37100218E-03_JPRB, 0.37100009E-03_JPRB, 0.37100085E-03_JPRB, 0.37100349E-03_JPRB, 0.37100306E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100137E-03_JPRB, 0.37100347E-03_JPRB, 0.37100373E-03_JPRB, 0.37100402E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100282E-03_JPRB, 0.37100009E-03_JPRB, 0.37099983E-03_JPRB, 0.37099677E-03_JPRB, 0.37100137E-03_JPRB, 0.37099901E-03_JPRB, &
  & 0.37100431E-03_JPRB, 0.37100189E-03_JPRB, 0.37099951E-03_JPRB, 0.37100309E-03_JPRB, 0.37100076E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100510E-03_JPRB, 0.37100707E-03_JPRB, 0.37100361E-03_JPRB, 0.37100067E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099613E-03_JPRB, 0.37099878E-03_JPRB, 0.37099980E-03_JPRB, 0.37100300E-03_JPRB, 0.37100408E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100032E-03_JPRB, 0.37099922E-03_JPRB, 0.37099567E-03_JPRB, 0.37100248E-03_JPRB, 0.37099826E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37100469E-03_JPRB, 0.37100533E-03_JPRB, 0.37099884E-03_JPRB /)

RGHG1(:,84,12) = (/ &
  & 0.37099636E-03_JPRB, 0.37100317E-03_JPRB, 0.37099866E-03_JPRB, 0.37099823E-03_JPRB, 0.37100425E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37099826E-03_JPRB, 0.37100079E-03_JPRB, 0.37100195E-03_JPRB, 0.37099875E-03_JPRB, 0.37099925E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100189E-03_JPRB, 0.37099954E-03_JPRB, 0.37099904E-03_JPRB, 0.37100134E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37100326E-03_JPRB, 0.37100218E-03_JPRB, 0.37100015E-03_JPRB, 0.37100105E-03_JPRB, 0.37100370E-03_JPRB, 0.37100315E-03_JPRB, &
  & 0.37100245E-03_JPRB, 0.37100143E-03_JPRB, 0.37100361E-03_JPRB, 0.37100387E-03_JPRB, 0.37100419E-03_JPRB, 0.37100050E-03_JPRB, &
  & 0.37100294E-03_JPRB, 0.37100009E-03_JPRB, 0.37099980E-03_JPRB, 0.37099665E-03_JPRB, 0.37100122E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100416E-03_JPRB, 0.37100195E-03_JPRB, 0.37099962E-03_JPRB, 0.37100303E-03_JPRB, 0.37100079E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099959E-03_JPRB, 0.37100533E-03_JPRB, 0.37100728E-03_JPRB, 0.37100376E-03_JPRB, 0.37100064E-03_JPRB, 0.37099968E-03_JPRB, &
  & 0.37099596E-03_JPRB, 0.37099869E-03_JPRB, 0.37099980E-03_JPRB, 0.37100306E-03_JPRB, 0.37100419E-03_JPRB, 0.37100111E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100026E-03_JPRB, 0.37099913E-03_JPRB, 0.37099552E-03_JPRB, 0.37100256E-03_JPRB, 0.37099820E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37100480E-03_JPRB, 0.37100544E-03_JPRB, 0.37099875E-03_JPRB /)

RGHG1(:,85,12) = (/ &
  & 0.37099628E-03_JPRB, 0.37100320E-03_JPRB, 0.37099855E-03_JPRB, 0.37099805E-03_JPRB, 0.37100440E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099849E-03_JPRB, 0.37100053E-03_JPRB, 0.37100143E-03_JPRB, 0.37099919E-03_JPRB, 0.37099939E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37100160E-03_JPRB, 0.37099957E-03_JPRB, 0.37099907E-03_JPRB, 0.37100131E-03_JPRB, 0.37099875E-03_JPRB, &
  & 0.37100341E-03_JPRB, 0.37100230E-03_JPRB, 0.37100009E-03_JPRB, 0.37100099E-03_JPRB, 0.37100381E-03_JPRB, 0.37100320E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100143E-03_JPRB, 0.37100376E-03_JPRB, 0.37100405E-03_JPRB, 0.37100434E-03_JPRB, 0.37100053E-03_JPRB, &
  & 0.37100306E-03_JPRB, 0.37100009E-03_JPRB, 0.37099968E-03_JPRB, 0.37099660E-03_JPRB, 0.37100120E-03_JPRB, 0.37099913E-03_JPRB, &
  & 0.37100416E-03_JPRB, 0.37100207E-03_JPRB, 0.37099974E-03_JPRB, 0.37100315E-03_JPRB, 0.37100082E-03_JPRB, 0.37099989E-03_JPRB, &
  & 0.37099968E-03_JPRB, 0.37100536E-03_JPRB, 0.37100757E-03_JPRB, 0.37100384E-03_JPRB, 0.37100053E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099584E-03_JPRB, 0.37099860E-03_JPRB, 0.37099980E-03_JPRB, 0.37100317E-03_JPRB, 0.37100434E-03_JPRB, 0.37100114E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100023E-03_JPRB, 0.37099910E-03_JPRB, 0.37099535E-03_JPRB, 0.37100262E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099540E-03_JPRB, 0.37100489E-03_JPRB, 0.37100565E-03_JPRB, 0.37099881E-03_JPRB /)

RGHG1(:,86,12) = (/ &
  & 0.37099610E-03_JPRB, 0.37100326E-03_JPRB, 0.37099849E-03_JPRB, 0.37099791E-03_JPRB, 0.37100454E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37099881E-03_JPRB, 0.37100038E-03_JPRB, 0.37100096E-03_JPRB, 0.37099945E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37100120E-03_JPRB, 0.37099962E-03_JPRB, 0.37099925E-03_JPRB, 0.37100111E-03_JPRB, 0.37099887E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37100236E-03_JPRB, 0.37100003E-03_JPRB, 0.37100099E-03_JPRB, 0.37100393E-03_JPRB, 0.37100323E-03_JPRB, &
  & 0.37100248E-03_JPRB, 0.37100134E-03_JPRB, 0.37100396E-03_JPRB, 0.37100428E-03_JPRB, 0.37100448E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100312E-03_JPRB, 0.37100006E-03_JPRB, 0.37099968E-03_JPRB, 0.37099657E-03_JPRB, 0.37100120E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37100428E-03_JPRB, 0.37100210E-03_JPRB, 0.37099962E-03_JPRB, 0.37100335E-03_JPRB, 0.37100085E-03_JPRB, 0.37099980E-03_JPRB, &
  & 0.37099945E-03_JPRB, 0.37100568E-03_JPRB, 0.37100780E-03_JPRB, 0.37100390E-03_JPRB, 0.37100041E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099575E-03_JPRB, 0.37099849E-03_JPRB, 0.37099980E-03_JPRB, 0.37100332E-03_JPRB, 0.37100451E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100018E-03_JPRB, 0.37099898E-03_JPRB, 0.37099526E-03_JPRB, 0.37100265E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099532E-03_JPRB, 0.37100504E-03_JPRB, 0.37100579E-03_JPRB, 0.37099890E-03_JPRB /)

RGHG1(:,87,12) = (/ &
  & 0.37099607E-03_JPRB, 0.37100335E-03_JPRB, 0.37099849E-03_JPRB, 0.37099776E-03_JPRB, 0.37100460E-03_JPRB, 0.37099910E-03_JPRB, &
  & 0.37099980E-03_JPRB, 0.37099898E-03_JPRB, 0.37100026E-03_JPRB, 0.37100070E-03_JPRB, 0.37099957E-03_JPRB, 0.37099965E-03_JPRB, &
  & 0.37099997E-03_JPRB, 0.37100088E-03_JPRB, 0.37099965E-03_JPRB, 0.37099933E-03_JPRB, 0.37100102E-03_JPRB, 0.37099898E-03_JPRB, &
  & 0.37100338E-03_JPRB, 0.37100242E-03_JPRB, 0.37099991E-03_JPRB, 0.37100085E-03_JPRB, 0.37100411E-03_JPRB, 0.37100332E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100122E-03_JPRB, 0.37100413E-03_JPRB, 0.37100443E-03_JPRB, 0.37100463E-03_JPRB, 0.37100044E-03_JPRB, &
  & 0.37100312E-03_JPRB, 0.37100003E-03_JPRB, 0.37099954E-03_JPRB, 0.37099639E-03_JPRB, 0.37100114E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100448E-03_JPRB, 0.37100218E-03_JPRB, 0.37099939E-03_JPRB, 0.37100364E-03_JPRB, 0.37100079E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099933E-03_JPRB, 0.37100588E-03_JPRB, 0.37100806E-03_JPRB, 0.37100405E-03_JPRB, 0.37100044E-03_JPRB, 0.37099954E-03_JPRB, &
  & 0.37099561E-03_JPRB, 0.37099840E-03_JPRB, 0.37099980E-03_JPRB, 0.37100341E-03_JPRB, 0.37100460E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37099997E-03_JPRB, 0.37099893E-03_JPRB, 0.37099514E-03_JPRB, 0.37100268E-03_JPRB, 0.37099817E-03_JPRB, &
  & 0.37099517E-03_JPRB, 0.37100507E-03_JPRB, 0.37100588E-03_JPRB, 0.37099895E-03_JPRB /)

RGHG1(:,88,12) = (/ &
  & 0.37099601E-03_JPRB, 0.37100329E-03_JPRB, 0.37099849E-03_JPRB, 0.37099759E-03_JPRB, 0.37100469E-03_JPRB, 0.37099916E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099910E-03_JPRB, 0.37100023E-03_JPRB, 0.37100070E-03_JPRB, 0.37099974E-03_JPRB, 0.37099977E-03_JPRB, &
  & 0.37100003E-03_JPRB, 0.37100085E-03_JPRB, 0.37099968E-03_JPRB, 0.37099939E-03_JPRB, 0.37100096E-03_JPRB, 0.37099895E-03_JPRB, &
  & 0.37100344E-03_JPRB, 0.37100239E-03_JPRB, 0.37099983E-03_JPRB, 0.37100085E-03_JPRB, 0.37100419E-03_JPRB, 0.37100338E-03_JPRB, &
  & 0.37100250E-03_JPRB, 0.37100108E-03_JPRB, 0.37100428E-03_JPRB, 0.37100454E-03_JPRB, 0.37100475E-03_JPRB, 0.37100038E-03_JPRB, &
  & 0.37100315E-03_JPRB, 0.37099997E-03_JPRB, 0.37099957E-03_JPRB, 0.37099625E-03_JPRB, 0.37100117E-03_JPRB, 0.37099878E-03_JPRB, &
  & 0.37100480E-03_JPRB, 0.37100221E-03_JPRB, 0.37099910E-03_JPRB, 0.37100399E-03_JPRB, 0.37100079E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099910E-03_JPRB, 0.37100606E-03_JPRB, 0.37100824E-03_JPRB, 0.37100411E-03_JPRB, 0.37100035E-03_JPRB, 0.37099948E-03_JPRB, &
  & 0.37099543E-03_JPRB, 0.37099826E-03_JPRB, 0.37099980E-03_JPRB, 0.37100352E-03_JPRB, 0.37100463E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100105E-03_JPRB, 0.37099997E-03_JPRB, 0.37099893E-03_JPRB, 0.37099508E-03_JPRB, 0.37100274E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099508E-03_JPRB, 0.37100515E-03_JPRB, 0.37100608E-03_JPRB, 0.37099901E-03_JPRB /)

RGHG1(:,89,12) = (/ &
  & 0.37099613E-03_JPRB, 0.37100317E-03_JPRB, 0.37099852E-03_JPRB, 0.37099759E-03_JPRB, 0.37100495E-03_JPRB, 0.37099893E-03_JPRB, &
  & 0.37099986E-03_JPRB, 0.37099893E-03_JPRB, 0.37100029E-03_JPRB, 0.37100079E-03_JPRB, 0.37099957E-03_JPRB, 0.37099962E-03_JPRB, &
  & 0.37099994E-03_JPRB, 0.37100088E-03_JPRB, 0.37099957E-03_JPRB, 0.37099933E-03_JPRB, 0.37100114E-03_JPRB, 0.37099890E-03_JPRB, &
  & 0.37100349E-03_JPRB, 0.37100242E-03_JPRB, 0.37099968E-03_JPRB, 0.37100082E-03_JPRB, 0.37100434E-03_JPRB, 0.37100341E-03_JPRB, &
  & 0.37100253E-03_JPRB, 0.37100096E-03_JPRB, 0.37100448E-03_JPRB, 0.37100472E-03_JPRB, 0.37100495E-03_JPRB, 0.37100032E-03_JPRB, &
  & 0.37100323E-03_JPRB, 0.37099997E-03_JPRB, 0.37099954E-03_JPRB, 0.37099604E-03_JPRB, 0.37100137E-03_JPRB, 0.37099866E-03_JPRB, &
  & 0.37100512E-03_JPRB, 0.37100230E-03_JPRB, 0.37099884E-03_JPRB, 0.37100434E-03_JPRB, 0.37100079E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099901E-03_JPRB, 0.37100629E-03_JPRB, 0.37100847E-03_JPRB, 0.37100413E-03_JPRB, 0.37100032E-03_JPRB, 0.37099945E-03_JPRB, &
  & 0.37099526E-03_JPRB, 0.37099826E-03_JPRB, 0.37099983E-03_JPRB, 0.37100358E-03_JPRB, 0.37100475E-03_JPRB, 0.37100120E-03_JPRB, &
  & 0.37100114E-03_JPRB, 0.37100000E-03_JPRB, 0.37099890E-03_JPRB, 0.37099500E-03_JPRB, 0.37100297E-03_JPRB, 0.37099811E-03_JPRB, &
  & 0.37099494E-03_JPRB, 0.37100533E-03_JPRB, 0.37100614E-03_JPRB, 0.37099893E-03_JPRB /)

RGHG1(:,90,12) = (/ &
  & 0.37099648E-03_JPRB, 0.37100317E-03_JPRB, 0.37099849E-03_JPRB, 0.37099718E-03_JPRB, 0.37100547E-03_JPRB, 0.37099869E-03_JPRB, &
  & 0.37100000E-03_JPRB, 0.37099852E-03_JPRB, 0.37100032E-03_JPRB, 0.37100120E-03_JPRB, 0.37099939E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099991E-03_JPRB, 0.37100134E-03_JPRB, 0.37099939E-03_JPRB, 0.37099901E-03_JPRB, 0.37100140E-03_JPRB, 0.37099852E-03_JPRB, &
  & 0.37100384E-03_JPRB, 0.37100250E-03_JPRB, 0.37099957E-03_JPRB, 0.37100067E-03_JPRB, 0.37100454E-03_JPRB, 0.37100338E-03_JPRB, &
  & 0.37100256E-03_JPRB, 0.37100085E-03_JPRB, 0.37100454E-03_JPRB, 0.37100480E-03_JPRB, 0.37100518E-03_JPRB, 0.37100009E-03_JPRB, &
  & 0.37100347E-03_JPRB, 0.37099991E-03_JPRB, 0.37099965E-03_JPRB, 0.37099561E-03_JPRB, 0.37100163E-03_JPRB, 0.37099823E-03_JPRB, &
  & 0.37100565E-03_JPRB, 0.37100242E-03_JPRB, 0.37099858E-03_JPRB, 0.37100457E-03_JPRB, 0.37100073E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37099875E-03_JPRB, 0.37100643E-03_JPRB, 0.37100867E-03_JPRB, 0.37100416E-03_JPRB, 0.37100026E-03_JPRB, 0.37099957E-03_JPRB, &
  & 0.37099505E-03_JPRB, 0.37099828E-03_JPRB, 0.37099977E-03_JPRB, 0.37100370E-03_JPRB, 0.37100489E-03_JPRB, 0.37100108E-03_JPRB, &
  & 0.37100108E-03_JPRB, 0.37100000E-03_JPRB, 0.37099893E-03_JPRB, 0.37099473E-03_JPRB, 0.37100338E-03_JPRB, 0.37099805E-03_JPRB, &
  & 0.37099462E-03_JPRB, 0.37100562E-03_JPRB, 0.37100632E-03_JPRB, 0.37099884E-03_JPRB /)

RGHG1(:,91,12) = (/ &
  & 0.37099715E-03_JPRB, 0.37100338E-03_JPRB, 0.37099823E-03_JPRB, 0.37099654E-03_JPRB, 0.37100670E-03_JPRB, 0.37099796E-03_JPRB, &
  & 0.37100064E-03_JPRB, 0.37099715E-03_JPRB, 0.37100076E-03_JPRB, 0.37100361E-03_JPRB, 0.37099762E-03_JPRB, 0.37099922E-03_JPRB, &
  & 0.37099951E-03_JPRB, 0.37100277E-03_JPRB, 0.37099884E-03_JPRB, 0.37099849E-03_JPRB, 0.37100221E-03_JPRB, 0.37099753E-03_JPRB, &
  & 0.37100451E-03_JPRB, 0.37100265E-03_JPRB, 0.37099922E-03_JPRB, 0.37100053E-03_JPRB, 0.37100489E-03_JPRB, 0.37100347E-03_JPRB, &
  & 0.37100262E-03_JPRB, 0.37100041E-03_JPRB, 0.37100480E-03_JPRB, 0.37100477E-03_JPRB, 0.37100550E-03_JPRB, 0.37099951E-03_JPRB, &
  & 0.37100396E-03_JPRB, 0.37099965E-03_JPRB, 0.37100006E-03_JPRB, 0.37099456E-03_JPRB, 0.37100253E-03_JPRB, 0.37099709E-03_JPRB, &
  & 0.37100693E-03_JPRB, 0.37100239E-03_JPRB, 0.37099779E-03_JPRB, 0.37100530E-03_JPRB, 0.37100055E-03_JPRB, 0.37099942E-03_JPRB, &
  & 0.37099817E-03_JPRB, 0.37100681E-03_JPRB, 0.37100920E-03_JPRB, 0.37100413E-03_JPRB, 0.37100003E-03_JPRB, 0.37099974E-03_JPRB, &
  & 0.37099456E-03_JPRB, 0.37099837E-03_JPRB, 0.37099959E-03_JPRB, 0.37100390E-03_JPRB, 0.37100524E-03_JPRB, 0.37100082E-03_JPRB, &
  & 0.37100117E-03_JPRB, 0.37100003E-03_JPRB, 0.37099913E-03_JPRB, 0.37099389E-03_JPRB, 0.37100428E-03_JPRB, 0.37099788E-03_JPRB, &
  & 0.37099380E-03_JPRB, 0.37100635E-03_JPRB, 0.37100646E-03_JPRB, 0.37099860E-03_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CO2CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_CO2CLIM
