!option! -Nv -NO                                            
#ifdef RS6K                                                 
@PROCESS NOOPTIMIZE                                         
#endif                                                      
!pgi$r opt=0                                                
SUBROUTINE SU_GCH4CLIM
                                                            
                                                            
!**   METHANE CLIMATOLOGY FROM GEMS-reana         
                                                            
!     PURPOSE.                                              
!     --------                                              
                                                            
!**   INTERFACE.                                            
!     ----------                                            
!        CALL *SU_GCH4CLIM* FROM *SUECRAD*                   
                                                            
!        EXPLICIT ARGUMENTS :                               
!        --------------------                               
!     ==== INPUTS ===                                       
!     ==== OUTPUTS ===                                      
                                                            
!        IMPLICIT ARGUMENTS :   NONE                        
!        --------------------                               
                                                            
!     METHOD.                                               
!     -------                                               
                                                            
!     EXTERNALS.                                            
!     ----------                                            
                                                            
!          NONE                                             
                                                            
!     REFERENCE.                                            
!     ----------                                            
                                                            
!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION A
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F
                                                            
!     AUTHOR.                                               
!     -------                                               
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423               
                                                            
!     MODIFICATIONS.                                        
!     --------------                                        
!        Same history as suecaesu                           
!        M.Hamrud      01-Oct-2003 CY28 Cleaning            
!     R. Elkhatib 12-10-2005 Split for faster and more robus
                                                            
!-----------------------------------------------------------
                                                            
USE PARKIND1  ,ONLY : JPRB                        
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK                      
USE YOMCLIM   ,ONLY : RGHG2
                                                            
IMPLICIT NONE                                               
                                                            
!     ------------------------------------------------------
                                                            
!*       0.1   ARGUMENTS.                                   
!              ----------                                   
! REAL(KIND=JPRB),INTENT(OUT) :: PCLCH4(64,91,12)             
!     ------------------------------------------------------
                                                            
!*       0.2   LOCAL ARRAYS.                                
!              -------------                                
                                                            
! REAL(KIND=JPRB),SAVE :: ZGHG2(64,91,12)                     
                                                            
LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.                        
                                                            
REAL(KIND=JPRB) :: ZHOOK_HANDLE                             
!     ------------------------------------------------------
                                                            
IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM',0,ZHOOK_HANDLE)        
                                                            
IF(LLFIRSTCALL) THEN                                        
                                                            
  ALLOCATE(RGHG2(64,91,12))

  CALL PART1                                                
  CALL PART2                                                
  CALL PART3                                                
  CALL PART4                                                
  CALL PART5                                                
  CALL PART6                                                
  CALL PART7                                                
  CALL PART8                                                
  CALL PART9                                                
  CALL PART10                                               
  CALL PART11                                               
  CALL PART12                                               
  CALL PART13                                               
  CALL PART14                                               
  CALL PART15                                               
  CALL PART16                                               
  CALL PART17                                               
  CALL PART18                                               
  CALL PART19                                               
  CALL PART20                                               
  CALL PART21                                               
  CALL PART22                                               
  CALL PART23                                               
  CALL PART24                                               
                                                            
ENDIF                                                       
                                                            
! PCLCH4(:,:,:)=ZGHG2(:,:,:)                                  
                                                            
!     ------------------------------------------------------
                                                            
LLFIRSTCALL = .FALSE.                                       
                                                            
IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM',1,ZHOOK_HANDLE)        
                                                            
!-----------------------------------------------------------
                                                            
CONTAINS                                                    
                                                            

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ---GEMS----

RGHG2(:, 1, 1) = (/ &
  & 0.15308701E-06_JPRB, 0.15317261E-06_JPRB, 0.15327467E-06_JPRB, 0.15336851E-06_JPRB, 0.15342612E-06_JPRB, 0.15340801E-06_JPRB, &
  & 0.15325986E-06_JPRB, 0.15284173E-06_JPRB, 0.15202522E-06_JPRB, 0.15091404E-06_JPRB, 0.14983579E-06_JPRB, 0.14901105E-06_JPRB, &
  & 0.14849415E-06_JPRB, 0.14837233E-06_JPRB, 0.14870486E-06_JPRB, 0.14962014E-06_JPRB, 0.15117414E-06_JPRB, 0.15354300E-06_JPRB, &
  & 0.15672837E-06_JPRB, 0.16070720E-06_JPRB, 0.16523092E-06_JPRB, 0.17018593E-06_JPRB, 0.17539940E-06_JPRB, 0.18067543E-06_JPRB, &
  & 0.18562386E-06_JPRB, 0.18994016E-06_JPRB, 0.19358481E-06_JPRB, 0.19659075E-06_JPRB, 0.19927403E-06_JPRB, 0.20138609E-06_JPRB, &
  & 0.20292033E-06_JPRB, 0.20432288E-06_JPRB, 0.20568428E-06_JPRB, 0.20690081E-06_JPRB, 0.20808112E-06_JPRB, 0.20928613E-06_JPRB, &
  & 0.21028536E-06_JPRB, 0.21075782E-06_JPRB, 0.21082861E-06_JPRB, 0.21094548E-06_JPRB, 0.21131588E-06_JPRB, 0.21176858E-06_JPRB, &
  & 0.21230688E-06_JPRB, 0.21279086E-06_JPRB, 0.21316948E-06_JPRB, 0.21333245E-06_JPRB, 0.21312503E-06_JPRB, 0.21272501E-06_JPRB, &
  & 0.21220317E-06_JPRB, 0.21155787E-06_JPRB, 0.21080062E-06_JPRB, 0.21002033E-06_JPRB, 0.20927131E-06_JPRB, 0.20856675E-06_JPRB, &
  & 0.20797083E-06_JPRB, 0.20738149E-06_JPRB, 0.20689916E-06_JPRB, 0.20654358E-06_JPRB, 0.20621106E-06_JPRB, 0.20597565E-06_JPRB, &
  & 0.20574518E-06_JPRB, 0.20568592E-06_JPRB, 0.20583902E-06_JPRB, 0.20592462E-06_JPRB  /)

RGHG2(:, 2, 1) = (/ &
  & 0.15308701E-06_JPRB, 0.15317261E-06_JPRB, 0.15327467E-06_JPRB, 0.15336851E-06_JPRB, 0.15342612E-06_JPRB, 0.15340801E-06_JPRB, &
  & 0.15325986E-06_JPRB, 0.15284173E-06_JPRB, 0.15202522E-06_JPRB, 0.15091404E-06_JPRB, 0.14983579E-06_JPRB, 0.14901105E-06_JPRB, &
  & 0.14849415E-06_JPRB, 0.14837233E-06_JPRB, 0.14870486E-06_JPRB, 0.14962014E-06_JPRB, 0.15117414E-06_JPRB, 0.15354300E-06_JPRB, &
  & 0.15672837E-06_JPRB, 0.16070720E-06_JPRB, 0.16523092E-06_JPRB, 0.17018593E-06_JPRB, 0.17539940E-06_JPRB, 0.18067543E-06_JPRB, &
  & 0.18562386E-06_JPRB, 0.18994016E-06_JPRB, 0.19358481E-06_JPRB, 0.19659075E-06_JPRB, 0.19927403E-06_JPRB, 0.20138609E-06_JPRB, &
  & 0.20292033E-06_JPRB, 0.20432288E-06_JPRB, 0.20568428E-06_JPRB, 0.20690081E-06_JPRB, 0.20808112E-06_JPRB, 0.20928613E-06_JPRB, &
  & 0.21028536E-06_JPRB, 0.21075782E-06_JPRB, 0.21082861E-06_JPRB, 0.21094548E-06_JPRB, 0.21131588E-06_JPRB, 0.21176858E-06_JPRB, &
  & 0.21230688E-06_JPRB, 0.21279086E-06_JPRB, 0.21316948E-06_JPRB, 0.21333245E-06_JPRB, 0.21312503E-06_JPRB, 0.21272501E-06_JPRB, &
  & 0.21220317E-06_JPRB, 0.21155787E-06_JPRB, 0.21080062E-06_JPRB, 0.21002033E-06_JPRB, 0.20927131E-06_JPRB, 0.20856675E-06_JPRB, &
  & 0.20797083E-06_JPRB, 0.20738149E-06_JPRB, 0.20689916E-06_JPRB, 0.20654358E-06_JPRB, 0.20621106E-06_JPRB, 0.20597565E-06_JPRB, &
  & 0.20574518E-06_JPRB, 0.20568592E-06_JPRB, 0.20583902E-06_JPRB, 0.20592462E-06_JPRB  /)

RGHG2(:, 3, 1) = (/ &
  & 0.15308701E-06_JPRB, 0.15317261E-06_JPRB, 0.15327467E-06_JPRB, 0.15336851E-06_JPRB, 0.15342612E-06_JPRB, 0.15340801E-06_JPRB, &
  & 0.15325986E-06_JPRB, 0.15284173E-06_JPRB, 0.15202522E-06_JPRB, 0.15091404E-06_JPRB, 0.14983579E-06_JPRB, 0.14901105E-06_JPRB, &
  & 0.14849415E-06_JPRB, 0.14837233E-06_JPRB, 0.14870486E-06_JPRB, 0.14962014E-06_JPRB, 0.15117414E-06_JPRB, 0.15354300E-06_JPRB, &
  & 0.15672837E-06_JPRB, 0.16070720E-06_JPRB, 0.16523092E-06_JPRB, 0.17018593E-06_JPRB, 0.17539940E-06_JPRB, 0.18067543E-06_JPRB, &
  & 0.18562386E-06_JPRB, 0.18994016E-06_JPRB, 0.19358481E-06_JPRB, 0.19659075E-06_JPRB, 0.19927403E-06_JPRB, 0.20138609E-06_JPRB, &
  & 0.20292033E-06_JPRB, 0.20432288E-06_JPRB, 0.20568428E-06_JPRB, 0.20690081E-06_JPRB, 0.20808112E-06_JPRB, 0.20928613E-06_JPRB, &
  & 0.21028536E-06_JPRB, 0.21075782E-06_JPRB, 0.21082861E-06_JPRB, 0.21094548E-06_JPRB, 0.21131588E-06_JPRB, 0.21176858E-06_JPRB, &
  & 0.21230688E-06_JPRB, 0.21279086E-06_JPRB, 0.21316948E-06_JPRB, 0.21333245E-06_JPRB, 0.21312503E-06_JPRB, 0.21272501E-06_JPRB, &
  & 0.21220317E-06_JPRB, 0.21155787E-06_JPRB, 0.21080062E-06_JPRB, 0.21002033E-06_JPRB, 0.20927131E-06_JPRB, 0.20856675E-06_JPRB, &
  & 0.20797083E-06_JPRB, 0.20738149E-06_JPRB, 0.20689916E-06_JPRB, 0.20654358E-06_JPRB, 0.20621106E-06_JPRB, 0.20597565E-06_JPRB, &
  & 0.20574518E-06_JPRB, 0.20568592E-06_JPRB, 0.20583902E-06_JPRB, 0.20592462E-06_JPRB  /)

RGHG2(:, 4, 1) = (/ &
  & 0.15314852E-06_JPRB, 0.15323261E-06_JPRB, 0.15333323E-06_JPRB, 0.15342514E-06_JPRB, 0.15347946E-06_JPRB, 0.15345633E-06_JPRB, &
  & 0.15330149E-06_JPRB, 0.15287384E-06_JPRB, 0.15204670E-06_JPRB, 0.15092853E-06_JPRB, 0.14984795E-06_JPRB, 0.14902452E-06_JPRB, &
  & 0.14851202E-06_JPRB, 0.14839851E-06_JPRB, 0.14874290E-06_JPRB, 0.14967345E-06_JPRB, 0.15124616E-06_JPRB, 0.15363637E-06_JPRB, &
  & 0.15684383E-06_JPRB, 0.16084310E-06_JPRB, 0.16538225E-06_JPRB, 0.17034618E-06_JPRB, 0.17556346E-06_JPRB, 0.18083816E-06_JPRB, &
  & 0.18578233E-06_JPRB, 0.19009420E-06_JPRB, 0.19373369E-06_JPRB, 0.19673551E-06_JPRB, 0.19941352E-06_JPRB, 0.20152036E-06_JPRB, &
  & 0.20305083E-06_JPRB, 0.20445066E-06_JPRB, 0.20580977E-06_JPRB, 0.20702332E-06_JPRB, 0.20819874E-06_JPRB, 0.20939729E-06_JPRB, &
  & 0.21038808E-06_JPRB, 0.21084761E-06_JPRB, 0.21090744E-06_JPRB, 0.21101870E-06_JPRB, 0.21138735E-06_JPRB, 0.21183792E-06_JPRB, &
  & 0.21237303E-06_JPRB, 0.21285419E-06_JPRB, 0.21322955E-06_JPRB, 0.21338995E-06_JPRB, 0.21318022E-06_JPRB, 0.21277613E-06_JPRB, &
  & 0.21224998E-06_JPRB, 0.21160011E-06_JPRB, 0.21083749E-06_JPRB, 0.21005174E-06_JPRB, 0.20929908E-06_JPRB, 0.20859110E-06_JPRB, &
  & 0.20799195E-06_JPRB, 0.20740012E-06_JPRB, 0.20691495E-06_JPRB, 0.20655683E-06_JPRB, 0.20622229E-06_JPRB, 0.20598510E-06_JPRB, &
  & 0.20575353E-06_JPRB, 0.20569318E-06_JPRB, 0.20584408E-06_JPRB, 0.20593023E-06_JPRB  /)

RGHG2(:, 5, 1) = (/ &
  & 0.15606806E-06_JPRB, 0.15608065E-06_JPRB, 0.15611277E-06_JPRB, 0.15611334E-06_JPRB, 0.15601143E-06_JPRB, 0.15574973E-06_JPRB, &
  & 0.15527761E-06_JPRB, 0.15439808E-06_JPRB, 0.15306617E-06_JPRB, 0.15161631E-06_JPRB, 0.15042516E-06_JPRB, 0.14966362E-06_JPRB, &
  & 0.14936024E-06_JPRB, 0.14964092E-06_JPRB, 0.15054836E-06_JPRB, 0.15220361E-06_JPRB, 0.15466446E-06_JPRB, 0.15806841E-06_JPRB, &
  & 0.16232445E-06_JPRB, 0.16729358E-06_JPRB, 0.17256524E-06_JPRB, 0.17795221E-06_JPRB, 0.18335036E-06_JPRB, 0.18856257E-06_JPRB, &
  & 0.19330423E-06_JPRB, 0.19740578E-06_JPRB, 0.20080010E-06_JPRB, 0.20360663E-06_JPRB, 0.20603467E-06_JPRB, 0.20789393E-06_JPRB, &
  & 0.20924533E-06_JPRB, 0.21051597E-06_JPRB, 0.21176630E-06_JPRB, 0.21283865E-06_JPRB, 0.21378151E-06_JPRB, 0.21467360E-06_JPRB, &
  & 0.21526358E-06_JPRB, 0.21510959E-06_JPRB, 0.21464964E-06_JPRB, 0.21449409E-06_JPRB, 0.21477981E-06_JPRB, 0.21512943E-06_JPRB, &
  & 0.21551312E-06_JPRB, 0.21586027E-06_JPRB, 0.21608059E-06_JPRB, 0.21611901E-06_JPRB, 0.21579992E-06_JPRB, 0.21520233E-06_JPRB, &
  & 0.21447188E-06_JPRB, 0.21360507E-06_JPRB, 0.21258767E-06_JPRB, 0.21154293E-06_JPRB, 0.21061721E-06_JPRB, 0.20974698E-06_JPRB, &
  & 0.20899460E-06_JPRB, 0.20828440E-06_JPRB, 0.20766462E-06_JPRB, 0.20718572E-06_JPRB, 0.20675563E-06_JPRB, 0.20643372E-06_JPRB, &
  & 0.20614987E-06_JPRB, 0.20603784E-06_JPRB, 0.20608418E-06_JPRB, 0.20619677E-06_JPRB  /)

RGHG2(:, 6, 1) = (/ &
  & 0.16044841E-06_JPRB, 0.16035371E-06_JPRB, 0.16028305E-06_JPRB, 0.16014658E-06_JPRB, 0.15981026E-06_JPRB, 0.15919064E-06_JPRB, &
  & 0.15824249E-06_JPRB, 0.15668497E-06_JPRB, 0.15459575E-06_JPRB, 0.15264821E-06_JPRB, 0.15129118E-06_JPRB, 0.15062250E-06_JPRB, &
  & 0.15063286E-06_JPRB, 0.15150498E-06_JPRB, 0.15325719E-06_JPRB, 0.15599973E-06_JPRB, 0.15979311E-06_JPRB, 0.16471801E-06_JPRB, &
  & 0.17054730E-06_JPRB, 0.17697156E-06_JPRB, 0.18334223E-06_JPRB, 0.18936391E-06_JPRB, 0.19503344E-06_JPRB, 0.20015189E-06_JPRB, &
  & 0.20458972E-06_JPRB, 0.20837572E-06_JPRB, 0.21140219E-06_JPRB, 0.21391571E-06_JPRB, 0.21596869E-06_JPRB, 0.21745651E-06_JPRB, &
  & 0.21853924E-06_JPRB, 0.21961604E-06_JPRB, 0.22070319E-06_JPRB, 0.22156367E-06_JPRB, 0.22215762E-06_JPRB, 0.22258991E-06_JPRB, &
  & 0.22257855E-06_JPRB, 0.22150404E-06_JPRB, 0.22026423E-06_JPRB, 0.21970839E-06_JPRB, 0.21986969E-06_JPRB, 0.22006785E-06_JPRB, &
  & 0.22022434E-06_JPRB, 0.22037044E-06_JPRB, 0.22035816E-06_JPRB, 0.22021355E-06_JPRB, 0.21973038E-06_JPRB, 0.21884248E-06_JPRB, &
  & 0.21780549E-06_JPRB, 0.21661322E-06_JPRB, 0.21521356E-06_JPRB, 0.21378024E-06_JPRB, 0.21259487E-06_JPRB, 0.21148121E-06_JPRB, &
  & 0.21049893E-06_JPRB, 0.20961112E-06_JPRB, 0.20878939E-06_JPRB, 0.20812927E-06_JPRB, 0.20755584E-06_JPRB, 0.20710680E-06_JPRB, &
  & 0.20674451E-06_JPRB, 0.20655495E-06_JPRB, 0.20644441E-06_JPRB, 0.20659668E-06_JPRB  /)

RGHG2(:, 7, 1) = (/ &
  & 0.16658599E-06_JPRB, 0.16654050E-06_JPRB, 0.16649708E-06_JPRB, 0.16630263E-06_JPRB, 0.16579028E-06_JPRB, 0.16488514E-06_JPRB, &
  & 0.16343473E-06_JPRB, 0.16105039E-06_JPRB, 0.15807960E-06_JPRB, 0.15559992E-06_JPRB, 0.15405933E-06_JPRB, 0.15365308E-06_JPRB, &
  & 0.15444351E-06_JPRB, 0.15665757E-06_JPRB, 0.16016401E-06_JPRB, 0.16503136E-06_JPRB, 0.17139666E-06_JPRB, 0.17933130E-06_JPRB, &
  & 0.18833326E-06_JPRB, 0.19769701E-06_JPRB, 0.20643696E-06_JPRB, 0.21423273E-06_JPRB, 0.22111745E-06_JPRB, 0.22694850E-06_JPRB, &
  & 0.23186780E-06_JPRB, 0.23592168E-06_JPRB, 0.23907881E-06_JPRB, 0.24147979E-06_JPRB, 0.24311309E-06_JPRB, 0.24395750E-06_JPRB, &
  & 0.24437988E-06_JPRB, 0.24490595E-06_JPRB, 0.24566696E-06_JPRB, 0.24610781E-06_JPRB, 0.24580756E-06_JPRB, 0.24455494E-06_JPRB, &
  & 0.24192055E-06_JPRB, 0.23737223E-06_JPRB, 0.23307096E-06_JPRB, 0.23043358E-06_JPRB, 0.22938563E-06_JPRB, 0.22873679E-06_JPRB, &
  & 0.22842411E-06_JPRB, 0.22831571E-06_JPRB, 0.22830357E-06_JPRB, 0.22821980E-06_JPRB, 0.22767883E-06_JPRB, 0.22622515E-06_JPRB, &
  & 0.22451922E-06_JPRB, 0.22250198E-06_JPRB, 0.22029378E-06_JPRB, 0.21809113E-06_JPRB, 0.21626934E-06_JPRB, 0.21455763E-06_JPRB, &
  & 0.21307596E-06_JPRB, 0.21174778E-06_JPRB, 0.21046364E-06_JPRB, 0.20950665E-06_JPRB, 0.20860892E-06_JPRB, 0.20783076E-06_JPRB, &
  & 0.20723591E-06_JPRB, 0.20684684E-06_JPRB, 0.20658491E-06_JPRB, 0.20670694E-06_JPRB  /)

RGHG2(:, 8, 1) = (/ &
  & 0.17580480E-06_JPRB, 0.17584283E-06_JPRB, 0.17589536E-06_JPRB, 0.17578067E-06_JPRB, 0.17530133E-06_JPRB, 0.17429243E-06_JPRB, &
  & 0.17246531E-06_JPRB, 0.16932551E-06_JPRB, 0.16535473E-06_JPRB, 0.16213207E-06_JPRB, 0.16043331E-06_JPRB, 0.16065534E-06_JPRB, &
  & 0.16273730E-06_JPRB, 0.16680656E-06_JPRB, 0.17252000E-06_JPRB, 0.17982467E-06_JPRB, 0.18886538E-06_JPRB, 0.19975677E-06_JPRB, &
  & 0.21190613E-06_JPRB, 0.22456643E-06_JPRB, 0.23668280E-06_JPRB, 0.24791591E-06_JPRB, 0.25814977E-06_JPRB, 0.26724895E-06_JPRB, &
  & 0.27552342E-06_JPRB, 0.28294428E-06_JPRB, 0.28930138E-06_JPRB, 0.29451036E-06_JPRB, 0.29829410E-06_JPRB, 0.30025093E-06_JPRB, &
  & 0.30077767E-06_JPRB, 0.30074391E-06_JPRB, 0.30066608E-06_JPRB, 0.29949348E-06_JPRB, 0.29558926E-06_JPRB, 0.28813444E-06_JPRB, &
  & 0.27807187E-06_JPRB, 0.26673817E-06_JPRB, 0.25687497E-06_JPRB, 0.24980931E-06_JPRB, 0.24571226E-06_JPRB, 0.24325433E-06_JPRB, &
  & 0.24222996E-06_JPRB, 0.24165471E-06_JPRB, 0.24150754E-06_JPRB, 0.24144429E-06_JPRB, 0.24106957E-06_JPRB, 0.23917070E-06_JPRB, &
  & 0.23630921E-06_JPRB, 0.23268080E-06_JPRB, 0.22896325E-06_JPRB, 0.22547906E-06_JPRB, 0.22238107E-06_JPRB, 0.21963636E-06_JPRB, &
  & 0.21740354E-06_JPRB, 0.21531940E-06_JPRB, 0.21335145E-06_JPRB, 0.21174280E-06_JPRB, 0.21015580E-06_JPRB, 0.20874055E-06_JPRB, &
  & 0.20759656E-06_JPRB, 0.20686620E-06_JPRB, 0.20639474E-06_JPRB, 0.20631001E-06_JPRB  /)

RGHG2(:, 9, 1) = (/ &
  & 0.19068396E-06_JPRB, 0.19068572E-06_JPRB, 0.19079782E-06_JPRB, 0.19086124E-06_JPRB, 0.19055397E-06_JPRB, 0.18959288E-06_JPRB, &
  & 0.18764070E-06_JPRB, 0.18397060E-06_JPRB, 0.17891265E-06_JPRB, 0.17482212E-06_JPRB, 0.17331285E-06_JPRB, 0.17488480E-06_JPRB, &
  & 0.17892504E-06_JPRB, 0.18523535E-06_JPRB, 0.19330047E-06_JPRB, 0.20292777E-06_JPRB, 0.21417319E-06_JPRB, 0.22719394E-06_JPRB, &
  & 0.24150047E-06_JPRB, 0.25677065E-06_JPRB, 0.27247497E-06_JPRB, 0.28850534E-06_JPRB, 0.30459300E-06_JPRB, 0.32048795E-06_JPRB, &
  & 0.33645964E-06_JPRB, 0.35251751E-06_JPRB, 0.36790301E-06_JPRB, 0.38171292E-06_JPRB, 0.39285058E-06_JPRB, 0.39994621E-06_JPRB, &
  & 0.40315362E-06_JPRB, 0.40341479E-06_JPRB, 0.40082572E-06_JPRB, 0.39288194E-06_JPRB, 0.37698155E-06_JPRB, 0.35482072E-06_JPRB, &
  & 0.33117785E-06_JPRB, 0.31025395E-06_JPRB, 0.29302219E-06_JPRB, 0.27968167E-06_JPRB, 0.27077974E-06_JPRB, 0.26497665E-06_JPRB, &
  & 0.26233419E-06_JPRB, 0.26102916E-06_JPRB, 0.26072189E-06_JPRB, 0.26089229E-06_JPRB, 0.26068345E-06_JPRB, 0.25850793E-06_JPRB, &
  & 0.25398359E-06_JPRB, 0.24782144E-06_JPRB, 0.24183161E-06_JPRB, 0.23645335E-06_JPRB, 0.23139884E-06_JPRB, 0.22729379E-06_JPRB, &
  & 0.22406274E-06_JPRB, 0.22095847E-06_JPRB, 0.21805721E-06_JPRB, 0.21538941E-06_JPRB, 0.21249316E-06_JPRB, 0.20993125E-06_JPRB, &
  & 0.20793317E-06_JPRB, 0.20671630E-06_JPRB, 0.20591759E-06_JPRB, 0.20552006E-06_JPRB  /)

RGHG2(:,10, 1) = (/ &
  & 0.21507311E-06_JPRB, 0.21478896E-06_JPRB, 0.21470118E-06_JPRB, 0.21467348E-06_JPRB, 0.21425845E-06_JPRB, 0.21331055E-06_JPRB, &
  & 0.21143137E-06_JPRB, 0.20741973E-06_JPRB, 0.20124140E-06_JPRB, 0.19652719E-06_JPRB, 0.19603483E-06_JPRB, 0.19994187E-06_JPRB, &
  & 0.20657410E-06_JPRB, 0.21520467E-06_JPRB, 0.22534467E-06_JPRB, 0.23678197E-06_JPRB, 0.24958626E-06_JPRB, 0.26389121E-06_JPRB, &
  & 0.27922814E-06_JPRB, 0.29586815E-06_JPRB, 0.31430864E-06_JPRB, 0.33510814E-06_JPRB, 0.35811928E-06_JPRB, 0.38295842E-06_JPRB, &
  & 0.40974233E-06_JPRB, 0.43893106E-06_JPRB, 0.46928670E-06_JPRB, 0.49764838E-06_JPRB, 0.52053883E-06_JPRB, 0.53531043E-06_JPRB, &
  & 0.54212781E-06_JPRB, 0.54067968E-06_JPRB, 0.52869750E-06_JPRB, 0.50233098E-06_JPRB, 0.46091366E-06_JPRB, 0.41539911E-06_JPRB, &
  & 0.37611439E-06_JPRB, 0.34699377E-06_JPRB, 0.32497193E-06_JPRB, 0.30801919E-06_JPRB, 0.29580756E-06_JPRB, 0.28744355E-06_JPRB, &
  & 0.28322768E-06_JPRB, 0.28158980E-06_JPRB, 0.28171364E-06_JPRB, 0.28228756E-06_JPRB, 0.28201965E-06_JPRB, 0.27961992E-06_JPRB, &
  & 0.27344441E-06_JPRB, 0.26475512E-06_JPRB, 0.25676123E-06_JPRB, 0.24951159E-06_JPRB, 0.24238622E-06_JPRB, 0.23694903E-06_JPRB, &
  & 0.23259609E-06_JPRB, 0.22847885E-06_JPRB, 0.22452563E-06_JPRB, 0.22083852E-06_JPRB, 0.21635647E-06_JPRB, 0.21214785E-06_JPRB, &
  & 0.20914390E-06_JPRB, 0.20735060E-06_JPRB, 0.20621626E-06_JPRB, 0.20564021E-06_JPRB  /)

RGHG2(:,11, 1) = (/ &
  & 0.24869102E-06_JPRB, 0.24810426E-06_JPRB, 0.24757716E-06_JPRB, 0.24699149E-06_JPRB, 0.24618448E-06_JPRB, 0.24542518E-06_JPRB, &
  & 0.24390712E-06_JPRB, 0.23984955E-06_JPRB, 0.23291341E-06_JPRB, 0.22832574E-06_JPRB, 0.22982564E-06_JPRB, 0.23678309E-06_JPRB, &
  & 0.24615021E-06_JPRB, 0.25669182E-06_JPRB, 0.26816701E-06_JPRB, 0.28040595E-06_JPRB, 0.29388002E-06_JPRB, 0.30879155E-06_JPRB, &
  & 0.32466559E-06_JPRB, 0.34250227E-06_JPRB, 0.36364186E-06_JPRB, 0.38900815E-06_JPRB, 0.41840749E-06_JPRB, 0.45152832E-06_JPRB, &
  & 0.48851132E-06_JPRB, 0.53025061E-06_JPRB, 0.57523136E-06_JPRB, 0.61686790E-06_JPRB, 0.64679257E-06_JPRB, 0.66153059E-06_JPRB, &
  & 0.66330887E-06_JPRB, 0.64977498E-06_JPRB, 0.61689793E-06_JPRB, 0.56390828E-06_JPRB, 0.49361689E-06_JPRB, 0.42610015E-06_JPRB, &
  & 0.37886517E-06_JPRB, 0.34914447E-06_JPRB, 0.32991492E-06_JPRB, 0.31625426E-06_JPRB, 0.30651222E-06_JPRB, 0.30062697E-06_JPRB, &
  & 0.29763766E-06_JPRB, 0.29658946E-06_JPRB, 0.29689586E-06_JPRB, 0.29705495E-06_JPRB, 0.29687450E-06_JPRB, 0.29401072E-06_JPRB, &
  & 0.28658804E-06_JPRB, 0.27694657E-06_JPRB, 0.26883679E-06_JPRB, 0.26084205E-06_JPRB, 0.25240456E-06_JPRB, 0.24606216E-06_JPRB, &
  & 0.24074133E-06_JPRB, 0.23585848E-06_JPRB, 0.23107930E-06_JPRB, 0.22677813E-06_JPRB, 0.22151844E-06_JPRB, 0.21595553E-06_JPRB, &
  & 0.21184122E-06_JPRB, 0.20958978E-06_JPRB, 0.20828234E-06_JPRB, 0.20756752E-06_JPRB  /)

RGHG2(:,12, 1) = (/ &
  & 0.28765817E-06_JPRB, 0.28704784E-06_JPRB, 0.28643939E-06_JPRB, 0.28541520E-06_JPRB, 0.28426384E-06_JPRB, 0.28361442E-06_JPRB, &
  & 0.28265039E-06_JPRB, 0.27900241E-06_JPRB, 0.27220842E-06_JPRB, 0.26879816E-06_JPRB, 0.27299488E-06_JPRB, 0.28287671E-06_JPRB, &
  & 0.29424563E-06_JPRB, 0.30582082E-06_JPRB, 0.31756314E-06_JPRB, 0.32935518E-06_JPRB, 0.34239944E-06_JPRB, 0.35723546E-06_JPRB, &
  & 0.37360397E-06_JPRB, 0.39309618E-06_JPRB, 0.41742602E-06_JPRB, 0.44728093E-06_JPRB, 0.48210295E-06_JPRB, 0.52187172E-06_JPRB, &
  & 0.56716816E-06_JPRB, 0.61855634E-06_JPRB, 0.67235962E-06_JPRB, 0.71784260E-06_JPRB, 0.74297559E-06_JPRB, 0.74712338E-06_JPRB, &
  & 0.73610217E-06_JPRB, 0.70613394E-06_JPRB, 0.65272757E-06_JPRB, 0.57956429E-06_JPRB, 0.49086390E-06_JPRB, 0.41201222E-06_JPRB, &
  & 0.36484931E-06_JPRB, 0.34068746E-06_JPRB, 0.32779753E-06_JPRB, 0.31954067E-06_JPRB, 0.31495361E-06_JPRB, 0.31230939E-06_JPRB, &
  & 0.31056683E-06_JPRB, 0.30939254E-06_JPRB, 0.30859339E-06_JPRB, 0.30792294E-06_JPRB, 0.30631649E-06_JPRB, 0.30134393E-06_JPRB, &
  & 0.29260399E-06_JPRB, 0.28339770E-06_JPRB, 0.27539185E-06_JPRB, 0.26706952E-06_JPRB, 0.25879299E-06_JPRB, 0.25217929E-06_JPRB, &
  & 0.24611875E-06_JPRB, 0.24069296E-06_JPRB, 0.23534016E-06_JPRB, 0.23045470E-06_JPRB, 0.22495401E-06_JPRB, 0.21890622E-06_JPRB, &
  & 0.21419719E-06_JPRB, 0.21183986E-06_JPRB, 0.21033704E-06_JPRB, 0.20950811E-06_JPRB  /)

RGHG2(:,13, 1) = (/ &
  & 0.33440467E-06_JPRB, 0.33423456E-06_JPRB, 0.33418190E-06_JPRB, 0.33300175E-06_JPRB, 0.33115101E-06_JPRB, 0.32937174E-06_JPRB, &
  & 0.32814642E-06_JPRB, 0.32512659E-06_JPRB, 0.31937318E-06_JPRB, 0.31787300E-06_JPRB, 0.32451962E-06_JPRB, 0.33591931E-06_JPRB, &
  & 0.34785543E-06_JPRB, 0.35943113E-06_JPRB, 0.37031903E-06_JPRB, 0.38045732E-06_JPRB, 0.39208404E-06_JPRB, 0.40641430E-06_JPRB, &
  & 0.42288234E-06_JPRB, 0.44335552E-06_JPRB, 0.46974075E-06_JPRB, 0.50265135E-06_JPRB, 0.54180165E-06_JPRB, 0.58778027E-06_JPRB, &
  & 0.64127979E-06_JPRB, 0.70200456E-06_JPRB, 0.76168802E-06_JPRB, 0.80431617E-06_JPRB, 0.82031201E-06_JPRB, 0.81371920E-06_JPRB, &
  & 0.79259322E-06_JPRB, 0.75336116E-06_JPRB, 0.69052942E-06_JPRB, 0.60947737E-06_JPRB, 0.51631141E-06_JPRB, 0.43217332E-06_JPRB, &
  & 0.37944646E-06_JPRB, 0.35414207E-06_JPRB, 0.34259157E-06_JPRB, 0.33662500E-06_JPRB, 0.33431230E-06_JPRB, 0.33260591E-06_JPRB, &
  & 0.33088660E-06_JPRB, 0.32866334E-06_JPRB, 0.32649059E-06_JPRB, 0.32364750E-06_JPRB, 0.31822047E-06_JPRB, 0.30964918E-06_JPRB, &
  & 0.29937612E-06_JPRB, 0.28925033E-06_JPRB, 0.27982012E-06_JPRB, 0.27089522E-06_JPRB, 0.26317173E-06_JPRB, 0.25627064E-06_JPRB, &
  & 0.24975900E-06_JPRB, 0.24327500E-06_JPRB, 0.23720142E-06_JPRB, 0.23215644E-06_JPRB, 0.22646077E-06_JPRB, 0.22036222E-06_JPRB, &
  & 0.21589644E-06_JPRB, 0.21359931E-06_JPRB, 0.21230334E-06_JPRB, 0.21171502E-06_JPRB  /)

RGHG2(:,14, 1) = (/ &
  & 0.38942595E-06_JPRB, 0.38971200E-06_JPRB, 0.39011175E-06_JPRB, 0.38911071E-06_JPRB, 0.38648139E-06_JPRB, 0.38289894E-06_JPRB, &
  & 0.38058045E-06_JPRB, 0.37823244E-06_JPRB, 0.37434002E-06_JPRB, 0.37505267E-06_JPRB, 0.38283961E-06_JPRB, 0.39370229E-06_JPRB, &
  & 0.40496898E-06_JPRB, 0.41577473E-06_JPRB, 0.42522713E-06_JPRB, 0.43363710E-06_JPRB, 0.44384834E-06_JPRB, 0.45756161E-06_JPRB, &
  & 0.47352686E-06_JPRB, 0.49329563E-06_JPRB, 0.51951860E-06_JPRB, 0.55371371E-06_JPRB, 0.59624381E-06_JPRB, 0.64850439E-06_JPRB, &
  & 0.71077920E-06_JPRB, 0.78106279E-06_JPRB, 0.84801399E-06_JPRB, 0.89083724E-06_JPRB, 0.90295077E-06_JPRB, 0.89096863E-06_JPRB, &
  & 0.86555019E-06_JPRB, 0.82521290E-06_JPRB, 0.76105878E-06_JPRB, 0.68213591E-06_JPRB, 0.59767973E-06_JPRB, 0.51476037E-06_JPRB, &
  & 0.44915951E-06_JPRB, 0.40750037E-06_JPRB, 0.38607152E-06_JPRB, 0.37465881E-06_JPRB, 0.36999612E-06_JPRB, 0.36709424E-06_JPRB, &
  & 0.36422688E-06_JPRB, 0.36070235E-06_JPRB, 0.35620744E-06_JPRB, 0.34978912E-06_JPRB, 0.34085437E-06_JPRB, 0.32800279E-06_JPRB, &
  & 0.31360661E-06_JPRB, 0.30054498E-06_JPRB, 0.28916285E-06_JPRB, 0.27879738E-06_JPRB, 0.27050665E-06_JPRB, 0.26282524E-06_JPRB, &
  & 0.25507698E-06_JPRB, 0.24698632E-06_JPRB, 0.24008804E-06_JPRB, 0.23495619E-06_JPRB, 0.22904530E-06_JPRB, 0.22279756E-06_JPRB, &
  & 0.21880002E-06_JPRB, 0.21690885E-06_JPRB, 0.21586421E-06_JPRB, 0.21552516E-06_JPRB  /)

RGHG2(:,15, 1) = (/ &
  & 0.45064496E-06_JPRB, 0.45040570E-06_JPRB, 0.45054006E-06_JPRB, 0.44979013E-06_JPRB, 0.44709452E-06_JPRB, 0.44285511E-06_JPRB, &
  & 0.43953044E-06_JPRB, 0.43735145E-06_JPRB, 0.43534129E-06_JPRB, 0.43775684E-06_JPRB, 0.44479694E-06_JPRB, 0.45347993E-06_JPRB, &
  & 0.46327400E-06_JPRB, 0.47265379E-06_JPRB, 0.48111994E-06_JPRB, 0.48915070E-06_JPRB, 0.49871178E-06_JPRB, 0.51132296E-06_JPRB, &
  & 0.52611614E-06_JPRB, 0.54415507E-06_JPRB, 0.56886603E-06_JPRB, 0.60343515E-06_JPRB, 0.64877975E-06_JPRB, 0.70729359E-06_JPRB, &
  & 0.77909257E-06_JPRB, 0.85922706E-06_JPRB, 0.93458527E-06_JPRB, 0.98406776E-06_JPRB, 0.10001786E-05_JPRB, 0.99021543E-06_JPRB, &
  & 0.96656360E-06_JPRB, 0.93155341E-06_JPRB, 0.87067062E-06_JPRB, 0.79591545E-06_JPRB, 0.72441817E-06_JPRB, 0.65474227E-06_JPRB, &
  & 0.58125813E-06_JPRB, 0.51281976E-06_JPRB, 0.47005439E-06_JPRB, 0.44509999E-06_JPRB, 0.43150715E-06_JPRB, 0.42341849E-06_JPRB, &
  & 0.41648188E-06_JPRB, 0.40942632E-06_JPRB, 0.40166221E-06_JPRB, 0.39154002E-06_JPRB, 0.37883437E-06_JPRB, 0.36127903E-06_JPRB, &
  & 0.34135135E-06_JPRB, 0.32482540E-06_JPRB, 0.31090732E-06_JPRB, 0.29762442E-06_JPRB, 0.28723349E-06_JPRB, 0.27758680E-06_JPRB, &
  & 0.26627299E-06_JPRB, 0.25546819E-06_JPRB, 0.24790933E-06_JPRB, 0.24245531E-06_JPRB, 0.23552297E-06_JPRB, 0.22852816E-06_JPRB, &
  & 0.22530496E-06_JPRB, 0.22398045E-06_JPRB, 0.22319967E-06_JPRB, 0.22287344E-06_JPRB  /)

RGHG2(:,16, 1) = (/ &
  & 0.51155742E-06_JPRB, 0.51039564E-06_JPRB, 0.51030661E-06_JPRB, 0.50976351E-06_JPRB, 0.50772934E-06_JPRB, 0.50457284E-06_JPRB, &
  & 0.50163204E-06_JPRB, 0.49927785E-06_JPRB, 0.49758128E-06_JPRB, 0.49987254E-06_JPRB, 0.50508411E-06_JPRB, 0.51155536E-06_JPRB, &
  & 0.51935794E-06_JPRB, 0.52712679E-06_JPRB, 0.53564755E-06_JPRB, 0.54464638E-06_JPRB, 0.55439638E-06_JPRB, 0.56562456E-06_JPRB, &
  & 0.57865118E-06_JPRB, 0.59484066E-06_JPRB, 0.61817933E-06_JPRB, 0.65336756E-06_JPRB, 0.70152486E-06_JPRB, 0.76590251E-06_JPRB, &
  & 0.84735490E-06_JPRB, 0.93645710E-06_JPRB, 0.10189183E-05_JPRB, 0.10777784E-05_JPRB, 0.11029323E-05_JPRB, 0.11023797E-05_JPRB, &
  & 0.10859035E-05_JPRB, 0.10577433E-05_JPRB, 0.10057997E-05_JPRB, 0.93507254E-06_JPRB, 0.86887373E-06_JPRB, 0.80939175E-06_JPRB, &
  & 0.73355506E-06_JPRB, 0.64402885E-06_JPRB, 0.58041888E-06_JPRB, 0.54287823E-06_JPRB, 0.51798751E-06_JPRB, 0.50240698E-06_JPRB, &
  & 0.49014676E-06_JPRB, 0.47722979E-06_JPRB, 0.46592677E-06_JPRB, 0.45338782E-06_JPRB, 0.43686401E-06_JPRB, 0.41526875E-06_JPRB, &
  & 0.39032884E-06_JPRB, 0.36834605E-06_JPRB, 0.35108063E-06_JPRB, 0.33398389E-06_JPRB, 0.31947685E-06_JPRB, 0.30512956E-06_JPRB, &
  & 0.28688358E-06_JPRB, 0.27132252E-06_JPRB, 0.26252548E-06_JPRB, 0.25562026E-06_JPRB, 0.24609677E-06_JPRB, 0.23872163E-06_JPRB, &
  & 0.23619138E-06_JPRB, 0.23526539E-06_JPRB, 0.23508256E-06_JPRB, 0.23466876E-06_JPRB  /)

RGHG2(:,17, 1) = (/ &
  & 0.56939089E-06_JPRB, 0.56891739E-06_JPRB, 0.56934483E-06_JPRB, 0.56911919E-06_JPRB, 0.56753757E-06_JPRB, 0.56540884E-06_JPRB, &
  & 0.56334548E-06_JPRB, 0.56062751E-06_JPRB, 0.55755193E-06_JPRB, 0.55826504E-06_JPRB, 0.56223338E-06_JPRB, 0.56755547E-06_JPRB, &
  & 0.57310894E-06_JPRB, 0.57954268E-06_JPRB, 0.58893360E-06_JPRB, 0.59934093E-06_JPRB, 0.60920535E-06_JPRB, 0.61930114E-06_JPRB, &
  & 0.63086050E-06_JPRB, 0.64588168E-06_JPRB, 0.66911265E-06_JPRB, 0.70572091E-06_JPRB, 0.75679270E-06_JPRB, 0.82708295E-06_JPRB, &
  & 0.91781467E-06_JPRB, 0.10143946E-05_JPRB, 0.11005423E-05_JPRB, 0.11641581E-05_JPRB, 0.11975810E-05_JPRB, 0.12081295E-05_JPRB, &
  & 0.12008676E-05_JPRB, 0.11806771E-05_JPRB, 0.11415693E-05_JPRB, 0.10773039E-05_JPRB, 0.10092327E-05_JPRB, 0.94797500E-06_JPRB, &
  & 0.86913782E-06_JPRB, 0.77700574E-06_JPRB, 0.70432506E-06_JPRB, 0.65291155E-06_JPRB, 0.61651307E-06_JPRB, 0.59357367E-06_JPRB, &
  & 0.57677812E-06_JPRB, 0.56059182E-06_JPRB, 0.54659354E-06_JPRB, 0.53255143E-06_JPRB, 0.51370550E-06_JPRB, 0.49005412E-06_JPRB, &
  & 0.46096335E-06_JPRB, 0.43395909E-06_JPRB, 0.41122843E-06_JPRB, 0.39018151E-06_JPRB, 0.36816843E-06_JPRB, 0.34563525E-06_JPRB, &
  & 0.31837092E-06_JPRB, 0.29599287E-06_JPRB, 0.28361559E-06_JPRB, 0.27308520E-06_JPRB, 0.26039786E-06_JPRB, 0.25281130E-06_JPRB, &
  & 0.25026594E-06_JPRB, 0.24943991E-06_JPRB, 0.24928505E-06_JPRB, 0.24851615E-06_JPRB  /)

RGHG2(:,18, 1) = (/ &
  & 0.62746734E-06_JPRB, 0.62748838E-06_JPRB, 0.62891199E-06_JPRB, 0.62897380E-06_JPRB, 0.62724099E-06_JPRB, 0.62486996E-06_JPRB, &
  & 0.62236697E-06_JPRB, 0.61865770E-06_JPRB, 0.61418129E-06_JPRB, 0.61402525E-06_JPRB, 0.61815212E-06_JPRB, 0.62272545E-06_JPRB, &
  & 0.62629051E-06_JPRB, 0.63243609E-06_JPRB, 0.64329844E-06_JPRB, 0.65423546E-06_JPRB, 0.66345609E-06_JPRB, 0.67300193E-06_JPRB, &
  & 0.68388800E-06_JPRB, 0.69913879E-06_JPRB, 0.72419558E-06_JPRB, 0.76300158E-06_JPRB, 0.81641101E-06_JPRB, 0.89093473E-06_JPRB, &
  & 0.98814474E-06_JPRB, 0.10902264E-05_JPRB, 0.11770898E-05_JPRB, 0.12413336E-05_JPRB, 0.12782467E-05_JPRB, 0.12966463E-05_JPRB, &
  & 0.12987475E-05_JPRB, 0.12872453E-05_JPRB, 0.12600692E-05_JPRB, 0.12046868E-05_JPRB, 0.11323925E-05_JPRB, 0.10648774E-05_JPRB, &
  & 0.98655244E-06_JPRB, 0.90040049E-06_JPRB, 0.82368837E-06_JPRB, 0.76107314E-06_JPRB, 0.71286402E-06_JPRB, 0.68200534E-06_JPRB, &
  & 0.66093476E-06_JPRB, 0.64485991E-06_JPRB, 0.63202910E-06_JPRB, 0.61835996E-06_JPRB, 0.59827367E-06_JPRB, 0.57342003E-06_JPRB, &
  & 0.54229693E-06_JPRB, 0.51179527E-06_JPRB, 0.48285560E-06_JPRB, 0.45657138E-06_JPRB, 0.42625364E-06_JPRB, 0.39370943E-06_JPRB, &
  & 0.35761711E-06_JPRB, 0.32742577E-06_JPRB, 0.30905385E-06_JPRB, 0.29252565E-06_JPRB, 0.27670670E-06_JPRB, 0.26802796E-06_JPRB, &
  & 0.26452940E-06_JPRB, 0.26283075E-06_JPRB, 0.26146234E-06_JPRB, 0.26062531E-06_JPRB  /)

RGHG2(:,19, 1) = (/ &
  & 0.68973343E-06_JPRB, 0.68899339E-06_JPRB, 0.69064619E-06_JPRB, 0.69062985E-06_JPRB, 0.68795062E-06_JPRB, 0.68407670E-06_JPRB, &
  & 0.67995261E-06_JPRB, 0.67498855E-06_JPRB, 0.66995470E-06_JPRB, 0.67056627E-06_JPRB, 0.67530683E-06_JPRB, 0.67908042E-06_JPRB, &
  & 0.68209629E-06_JPRB, 0.68960499E-06_JPRB, 0.70172347E-06_JPRB, 0.71182197E-06_JPRB, 0.72009963E-06_JPRB, 0.72928227E-06_JPRB, &
  & 0.74009436E-06_JPRB, 0.75712765E-06_JPRB, 0.78567984E-06_JPRB, 0.82683296E-06_JPRB, 0.88147586E-06_JPRB, 0.95772982E-06_JPRB, &
  & 0.10568101E-05_JPRB, 0.11607004E-05_JPRB, 0.12455072E-05_JPRB, 0.13082117E-05_JPRB, 0.13464981E-05_JPRB, 0.13695061E-05_JPRB, &
  & 0.13787502E-05_JPRB, 0.13738672E-05_JPRB, 0.13526518E-05_JPRB, 0.13028256E-05_JPRB, 0.12281360E-05_JPRB, 0.11569698E-05_JPRB, &
  & 0.10807432E-05_JPRB, 0.99637617E-06_JPRB, 0.91722893E-06_JPRB, 0.84775689E-06_JPRB, 0.79147490E-06_JPRB, 0.75580119E-06_JPRB, &
  & 0.73375869E-06_JPRB, 0.71928748E-06_JPRB, 0.70870753E-06_JPRB, 0.69672529E-06_JPRB, 0.67740148E-06_JPRB, 0.65242214E-06_JPRB, &
  & 0.62080226E-06_JPRB, 0.58757729E-06_JPRB, 0.55358983E-06_JPRB, 0.52125618E-06_JPRB, 0.48456637E-06_JPRB, 0.44339718E-06_JPRB, &
  & 0.39907387E-06_JPRB, 0.36173293E-06_JPRB, 0.33661328E-06_JPRB, 0.31328800E-06_JPRB, 0.29468782E-06_JPRB, 0.28406145E-06_JPRB, &
  & 0.27830480E-06_JPRB, 0.27476027E-06_JPRB, 0.27192979E-06_JPRB, 0.27082378E-06_JPRB  /)

RGHG2(:,20, 1) = (/ &
  & 0.75329913E-06_JPRB, 0.75236010E-06_JPRB, 0.75392583E-06_JPRB, 0.75332700E-06_JPRB, 0.74928371E-06_JPRB, 0.74349236E-06_JPRB, &
  & 0.73745615E-06_JPRB, 0.73156217E-06_JPRB, 0.72705022E-06_JPRB, 0.72888596E-06_JPRB, 0.73393183E-06_JPRB, 0.73794640E-06_JPRB, &
  & 0.74250406E-06_JPRB, 0.75222178E-06_JPRB, 0.76479719E-06_JPRB, 0.77372627E-06_JPRB, 0.78120127E-06_JPRB, 0.78964112E-06_JPRB, &
  & 0.80070587E-06_JPRB, 0.82067709E-06_JPRB, 0.85340844E-06_JPRB, 0.89704294E-06_JPRB, 0.95202408E-06_JPRB, 0.10274670E-05_JPRB, &
  & 0.11241069E-05_JPRB, 0.12248047E-05_JPRB, 0.13060152E-05_JPRB, 0.13653688E-05_JPRB, 0.14042626E-05_JPRB, 0.14306918E-05_JPRB, &
  & 0.14452453E-05_JPRB, 0.14449395E-05_JPRB, 0.14249147E-05_JPRB, 0.13764175E-05_JPRB, 0.13017639E-05_JPRB, 0.12283677E-05_JPRB, &
  & 0.11546621E-05_JPRB, 0.10702687E-05_JPRB, 0.98604467E-06_JPRB, 0.91060596E-06_JPRB, 0.84945469E-06_JPRB, 0.81323488E-06_JPRB, &
  & 0.79224001E-06_JPRB, 0.77959119E-06_JPRB, 0.77064749E-06_JPRB, 0.76024683E-06_JPRB, 0.74255554E-06_JPRB, 0.71849515E-06_JPRB, &
  & 0.68784510E-06_JPRB, 0.65370827E-06_JPRB, 0.61693975E-06_JPRB, 0.57945566E-06_JPRB, 0.53819915E-06_JPRB, 0.49130662E-06_JPRB, &
  & 0.44069654E-06_JPRB, 0.39736877E-06_JPRB, 0.36557815E-06_JPRB, 0.33629244E-06_JPRB, 0.31481446E-06_JPRB, 0.30139331E-06_JPRB, &
  & 0.29282482E-06_JPRB, 0.28704231E-06_JPRB, 0.28286631E-06_JPRB, 0.28141138E-06_JPRB  /)

RGHG2(:,21, 1) = (/ &
  & 0.81656239E-06_JPRB, 0.81643219E-06_JPRB, 0.81774487E-06_JPRB, 0.81626759E-06_JPRB, 0.81103414E-06_JPRB, 0.80359820E-06_JPRB, &
  & 0.79591195E-06_JPRB, 0.78958455E-06_JPRB, 0.78630479E-06_JPRB, 0.78910393E-06_JPRB, 0.79443391E-06_JPRB, 0.80013234E-06_JPRB, &
  & 0.80774043E-06_JPRB, 0.81974955E-06_JPRB, 0.83232044E-06_JPRB, 0.84056978E-06_JPRB, 0.84737814E-06_JPRB, 0.85481357E-06_JPRB, &
  & 0.86635332E-06_JPRB, 0.88968658E-06_JPRB, 0.92682607E-06_JPRB, 0.97323849E-06_JPRB, 0.10280122E-05_JPRB, 0.11002601E-05_JPRB, &
  & 0.11905465E-05_JPRB, 0.12835790E-05_JPRB, 0.13600713E-05_JPRB, 0.14154430E-05_JPRB, 0.14545938E-05_JPRB, 0.14838540E-05_JPRB, &
  & 0.15021764E-05_JPRB, 0.15047915E-05_JPRB, 0.14839098E-05_JPRB, 0.14343122E-05_JPRB, 0.13610518E-05_JPRB, 0.12864875E-05_JPRB, &
  & 0.12141296E-05_JPRB, 0.11284534E-05_JPRB, 0.10360063E-05_JPRB, 0.95436258E-06_JPRB, 0.89074072E-06_JPRB, 0.85624094E-06_JPRB, &
  & 0.83709418E-06_JPRB, 0.82573603E-06_JPRB, 0.81745234E-06_JPRB, 0.80788819E-06_JPRB, 0.79206521E-06_JPRB, 0.76969201E-06_JPRB, &
  & 0.74120949E-06_JPRB, 0.70813074E-06_JPRB, 0.67103815E-06_JPRB, 0.63025102E-06_JPRB, 0.58613505E-06_JPRB, 0.53636846E-06_JPRB, &
  & 0.48196098E-06_JPRB, 0.43419859E-06_JPRB, 0.39632046E-06_JPRB, 0.36241202E-06_JPRB, 0.33770682E-06_JPRB, 0.32086177E-06_JPRB, &
  & 0.30940542E-06_JPRB, 0.30137135E-06_JPRB, 0.29622200E-06_JPRB, 0.29444403E-06_JPRB  /)

RGHG2(:,22, 1) = (/ &
  & 0.87814029E-06_JPRB, 0.87940542E-06_JPRB, 0.88010645E-06_JPRB, 0.87782637E-06_JPRB, 0.87232533E-06_JPRB, 0.86416305E-06_JPRB, &
  & 0.85550198E-06_JPRB, 0.84925103E-06_JPRB, 0.84730927E-06_JPRB, 0.85043334E-06_JPRB, 0.85689105E-06_JPRB, 0.86580065E-06_JPRB, &
  & 0.87686840E-06_JPRB, 0.89055956E-06_JPRB, 0.90345539E-06_JPRB, 0.91222081E-06_JPRB, 0.91828373E-06_JPRB, 0.92495459E-06_JPRB, &
  & 0.93720157E-06_JPRB, 0.96340194E-06_JPRB, 0.10050141E-05_JPRB, 0.10547142E-05_JPRB, 0.11090483E-05_JPRB, 0.11756384E-05_JPRB, &
  & 0.12554885E-05_JPRB, 0.13374156E-05_JPRB, 0.14078679E-05_JPRB, 0.14604872E-05_JPRB, 0.14995806E-05_JPRB, 0.15306184E-05_JPRB, &
  & 0.15508905E-05_JPRB, 0.15548245E-05_JPRB, 0.15339619E-05_JPRB, 0.14834659E-05_JPRB, 0.14113523E-05_JPRB, 0.13376864E-05_JPRB, &
  & 0.12632260E-05_JPRB, 0.11730006E-05_JPRB, 0.10705377E-05_JPRB, 0.98306421E-06_JPRB, 0.91919387E-06_JPRB, 0.88530574E-06_JPRB, &
  & 0.86805127E-06_JPRB, 0.85676958E-06_JPRB, 0.84823741E-06_JPRB, 0.83846300E-06_JPRB, 0.82455143E-06_JPRB, 0.80431901E-06_JPRB, &
  & 0.77887564E-06_JPRB, 0.74858755E-06_JPRB, 0.71375042E-06_JPRB, 0.67231342E-06_JPRB, 0.62750933E-06_JPRB, 0.57739869E-06_JPRB, &
  & 0.52213108E-06_JPRB, 0.47224702E-06_JPRB, 0.42949479E-06_JPRB, 0.39247075E-06_JPRB, 0.36409565E-06_JPRB, 0.34352334E-06_JPRB, &
  & 0.32939102E-06_JPRB, 0.31936908E-06_JPRB, 0.31397124E-06_JPRB, 0.31194479E-06_JPRB  /)

RGHG2(:,23, 1) = (/ &
  & 0.93831853E-06_JPRB, 0.93951276E-06_JPRB, 0.93929343E-06_JPRB, 0.93701415E-06_JPRB, 0.93183268E-06_JPRB, 0.92339092E-06_JPRB, &
  & 0.91489373E-06_JPRB, 0.90979176E-06_JPRB, 0.90903464E-06_JPRB, 0.91319884E-06_JPRB, 0.92144092E-06_JPRB, 0.93252161E-06_JPRB, &
  & 0.94578845E-06_JPRB, 0.96112875E-06_JPRB, 0.97524716E-06_JPRB, 0.98477014E-06_JPRB, 0.99117482E-06_JPRB, 0.99888473E-06_JPRB, &
  & 0.10125342E-05_JPRB, 0.10397417E-05_JPRB, 0.10830285E-05_JPRB, 0.11355773E-05_JPRB, 0.11903485E-05_JPRB, 0.12500520E-05_JPRB, &
  & 0.13166538E-05_JPRB, 0.13861697E-05_JPRB, 0.14489170E-05_JPRB, 0.14986869E-05_JPRB, 0.15378044E-05_JPRB, 0.15692400E-05_JPRB, &
  & 0.15900815E-05_JPRB, 0.15948634E-05_JPRB, 0.15764510E-05_JPRB, 0.15286211E-05_JPRB, 0.14562566E-05_JPRB, 0.13794988E-05_JPRB, &
  & 0.12986892E-05_JPRB, 0.12031771E-05_JPRB, 0.10961192E-05_JPRB, 0.10051913E-05_JPRB, 0.94219009E-06_JPRB, 0.90748898E-06_JPRB, &
  & 0.88816694E-06_JPRB, 0.87627046E-06_JPRB, 0.86652431E-06_JPRB, 0.85696950E-06_JPRB, 0.84506741E-06_JPRB, 0.82683990E-06_JPRB, &
  & 0.80476464E-06_JPRB, 0.77880499E-06_JPRB, 0.74668512E-06_JPRB, 0.70693867E-06_JPRB, 0.66426179E-06_JPRB, 0.61595219E-06_JPRB, &
  & 0.56153038E-06_JPRB, 0.51139213E-06_JPRB, 0.46667681E-06_JPRB, 0.42781174E-06_JPRB, 0.39686416E-06_JPRB, 0.37304389E-06_JPRB, &
  & 0.35652707E-06_JPRB, 0.34547535E-06_JPRB, 0.34026239E-06_JPRB, 0.33912025E-06_JPRB  /)

RGHG2(:,24, 1) = (/ &
  & 0.99814992E-06_JPRB, 0.99955080E-06_JPRB, 0.99910534E-06_JPRB, 0.99712419E-06_JPRB, 0.99249536E-06_JPRB, 0.98445453E-06_JPRB, &
  & 0.97698812E-06_JPRB, 0.97339736E-06_JPRB, 0.97383627E-06_JPRB, 0.97927505E-06_JPRB, 0.98911627E-06_JPRB, 0.10019549E-05_JPRB, &
  & 0.10169026E-05_JPRB, 0.10332761E-05_JPRB, 0.10480969E-05_JPRB, 0.10585354E-05_JPRB, 0.10663788E-05_JPRB, 0.10761226E-05_JPRB, &
  & 0.10919210E-05_JPRB, 0.11195169E-05_JPRB, 0.11627357E-05_JPRB, 0.12167376E-05_JPRB, 0.12718591E-05_JPRB, 0.13250352E-05_JPRB, &
  & 0.13786921E-05_JPRB, 0.14356821E-05_JPRB, 0.14897208E-05_JPRB, 0.15354250E-05_JPRB, 0.15736572E-05_JPRB, 0.16046386E-05_JPRB, &
  & 0.16251430E-05_JPRB, 0.16298321E-05_JPRB, 0.16124767E-05_JPRB, 0.15669402E-05_JPRB, 0.14959758E-05_JPRB, 0.14169274E-05_JPRB, &
  & 0.13300167E-05_JPRB, 0.12301070E-05_JPRB, 0.11228593E-05_JPRB, 0.10314545E-05_JPRB, 0.96905677E-06_JPRB, 0.93204915E-06_JPRB, &
  & 0.90899887E-06_JPRB, 0.89591043E-06_JPRB, 0.88496961E-06_JPRB, 0.87550990E-06_JPRB, 0.86538427E-06_JPRB, 0.84925495E-06_JPRB, &
  & 0.83033250E-06_JPRB, 0.80859338E-06_JPRB, 0.77915505E-06_JPRB, 0.74217702E-06_JPRB, 0.70245502E-06_JPRB, 0.65670854E-06_JPRB, &
  & 0.60329140E-06_JPRB, 0.55337926E-06_JPRB, 0.50797249E-06_JPRB, 0.46793917E-06_JPRB, 0.43496571E-06_JPRB, 0.40857629E-06_JPRB, &
  & 0.39028498E-06_JPRB, 0.37880330E-06_JPRB, 0.37404278E-06_JPRB, 0.37392455E-06_JPRB  /)

RGHG2(:,25, 1) = (/ &
  & 0.10549885E-05_JPRB, 0.10574083E-05_JPRB, 0.10580465E-05_JPRB, 0.10566961E-05_JPRB, 0.10528759E-05_JPRB, 0.10463231E-05_JPRB, &
  & 0.10411210E-05_JPRB, 0.10393740E-05_JPRB, 0.10410097E-05_JPRB, 0.10479203E-05_JPRB, 0.10588128E-05_JPRB, 0.10728321E-05_JPRB, &
  & 0.10887502E-05_JPRB, 0.11050267E-05_JPRB, 0.11193947E-05_JPRB, 0.11309329E-05_JPRB, 0.11418493E-05_JPRB, 0.11548925E-05_JPRB, &
  & 0.11739094E-05_JPRB, 0.12011980E-05_JPRB, 0.12418938E-05_JPRB, 0.12949090E-05_JPRB, 0.13500144E-05_JPRB, 0.13978694E-05_JPRB, &
  & 0.14403343E-05_JPRB, 0.14854528E-05_JPRB, 0.15297712E-05_JPRB, 0.15694588E-05_JPRB, 0.16052165E-05_JPRB, 0.16345644E-05_JPRB, &
  & 0.16534514E-05_JPRB, 0.16564908E-05_JPRB, 0.16371300E-05_JPRB, 0.15923212E-05_JPRB, 0.15259340E-05_JPRB, 0.14470149E-05_JPRB, &
  & 0.13556726E-05_JPRB, 0.12533046E-05_JPRB, 0.11524616E-05_JPRB, 0.10653428E-05_JPRB, 0.10027995E-05_JPRB, 0.96126331E-06_JPRB, &
  & 0.93260081E-06_JPRB, 0.91750685E-06_JPRB, 0.90567648E-06_JPRB, 0.89599034E-06_JPRB, 0.88712625E-06_JPRB, 0.87319654E-06_JPRB, &
  & 0.85682951E-06_JPRB, 0.83858387E-06_JPRB, 0.81153922E-06_JPRB, 0.77858841E-06_JPRB, 0.74252163E-06_JPRB, 0.70009073E-06_JPRB, &
  & 0.64753079E-06_JPRB, 0.59826559E-06_JPRB, 0.55379688E-06_JPRB, 0.51355330E-06_JPRB, 0.47936683E-06_JPRB, 0.45161883E-06_JPRB, &
  & 0.43264824E-06_JPRB, 0.42160324E-06_JPRB, 0.41765140E-06_JPRB, 0.41850358E-06_JPRB  /)

RGHG2(:,26, 1) = (/ &
  & 0.11076175E-05_JPRB, 0.11111778E-05_JPRB, 0.11132078E-05_JPRB, 0.11130774E-05_JPRB, 0.11104918E-05_JPRB, 0.11060227E-05_JPRB, &
  & 0.11033312E-05_JPRB, 0.11035800E-05_JPRB, 0.11065200E-05_JPRB, 0.11145297E-05_JPRB, 0.11267097E-05_JPRB, 0.11411553E-05_JPRB, &
  & 0.11562726E-05_JPRB, 0.11710640E-05_JPRB, 0.11849511E-05_JPRB, 0.11980133E-05_JPRB, 0.12115881E-05_JPRB, 0.12276900E-05_JPRB, &
  & 0.12488814E-05_JPRB, 0.12759937E-05_JPRB, 0.13130668E-05_JPRB, 0.13626166E-05_JPRB, 0.14155015E-05_JPRB, 0.14601414E-05_JPRB, &
  & 0.14963199E-05_JPRB, 0.15320974E-05_JPRB, 0.15670305E-05_JPRB, 0.16000393E-05_JPRB, 0.16316756E-05_JPRB, 0.16573886E-05_JPRB, &
  & 0.16734762E-05_JPRB, 0.16743896E-05_JPRB, 0.16527350E-05_JPRB, 0.16077438E-05_JPRB, 0.15458153E-05_JPRB, 0.14711069E-05_JPRB, &
  & 0.13817263E-05_JPRB, 0.12822521E-05_JPRB, 0.11896174E-05_JPRB, 0.11114094E-05_JPRB, 0.10502558E-05_JPRB, 0.10041031E-05_JPRB, &
  & 0.97030601E-06_JPRB, 0.95193802E-06_JPRB, 0.93887321E-06_JPRB, 0.92716728E-06_JPRB, 0.91782367E-06_JPRB, 0.90588693E-06_JPRB, &
  & 0.89165929E-06_JPRB, 0.87469052E-06_JPRB, 0.85007323E-06_JPRB, 0.82049952E-06_JPRB, 0.78751002E-06_JPRB, 0.74792895E-06_JPRB, &
  & 0.69686137E-06_JPRB, 0.64785078E-06_JPRB, 0.60414975E-06_JPRB, 0.56444781E-06_JPRB, 0.53009293E-06_JPRB, 0.50289493E-06_JPRB, &
  & 0.48439645E-06_JPRB, 0.47466979E-06_JPRB, 0.47196319E-06_JPRB, 0.47322925E-06_JPRB  /)

RGHG2(:,27, 1) = (/ &
  & 0.11610815E-05_JPRB, 0.11658792E-05_JPRB, 0.11694786E-05_JPRB, 0.11708422E-05_JPRB, 0.11697054E-05_JPRB, 0.11676356E-05_JPRB, &
  & 0.11676605E-05_JPRB, 0.11700522E-05_JPRB, 0.11743956E-05_JPRB, 0.11834164E-05_JPRB, 0.11970300E-05_JPRB, 0.12116416E-05_JPRB, &
  & 0.12252649E-05_JPRB, 0.12379889E-05_JPRB, 0.12513629E-05_JPRB, 0.12661756E-05_JPRB, 0.12823762E-05_JPRB, 0.13015868E-05_JPRB, &
  & 0.13246646E-05_JPRB, 0.13516410E-05_JPRB, 0.13845190E-05_JPRB, 0.14295264E-05_JPRB, 0.14792724E-05_JPRB, 0.15213319E-05_JPRB, &
  & 0.15527567E-05_JPRB, 0.15797062E-05_JPRB, 0.16049510E-05_JPRB, 0.16307313E-05_JPRB, 0.16574480E-05_JPRB, 0.16786187E-05_JPRB, &
  & 0.16913411E-05_JPRB, 0.16898550E-05_JPRB, 0.16656953E-05_JPRB, 0.16201760E-05_JPRB, 0.15628653E-05_JPRB, 0.14940724E-05_JPRB, &
  & 0.14091134E-05_JPRB, 0.13146493E-05_JPRB, 0.12312653E-05_JPRB, 0.11640887E-05_JPRB, 0.11049572E-05_JPRB, 0.10539453E-05_JPRB, &
  & 0.10149570E-05_JPRB, 0.99269556E-06_JPRB, 0.97821222E-06_JPRB, 0.96372959E-06_JPRB, 0.95323909E-06_JPRB, 0.94330941E-06_JPRB, &
  & 0.93116430E-06_JPRB, 0.91470862E-06_JPRB, 0.89264166E-06_JPRB, 0.86635774E-06_JPRB, 0.83637130E-06_JPRB, 0.79959712E-06_JPRB, &
  & 0.75032533E-06_JPRB, 0.70143547E-06_JPRB, 0.65847388E-06_JPRB, 0.61961703E-06_JPRB, 0.58547342E-06_JPRB, 0.55955813E-06_JPRB, &
  & 0.54198019E-06_JPRB, 0.53395879E-06_JPRB, 0.53271599E-06_JPRB, 0.53420841E-06_JPRB  /)

RGHG2(:,28, 1) = (/ &
  & 0.12114572E-05_JPRB, 0.12158153E-05_JPRB, 0.12208034E-05_JPRB, 0.12233775E-05_JPRB, 0.12236997E-05_JPRB, 0.12239401E-05_JPRB, &
  & 0.12263002E-05_JPRB, 0.12299904E-05_JPRB, 0.12351651E-05_JPRB, 0.12447641E-05_JPRB, 0.12571946E-05_JPRB, 0.12700726E-05_JPRB, &
  & 0.12828234E-05_JPRB, 0.12953284E-05_JPRB, 0.13094835E-05_JPRB, 0.13257922E-05_JPRB, 0.13433103E-05_JPRB, 0.13633943E-05_JPRB, &
  & 0.13866213E-05_JPRB, 0.14125784E-05_JPRB, 0.14419864E-05_JPRB, 0.14801302E-05_JPRB, 0.15237688E-05_JPRB, 0.15622465E-05_JPRB, &
  & 0.15912061E-05_JPRB, 0.16140027E-05_JPRB, 0.16336713E-05_JPRB, 0.16542475E-05_JPRB, 0.16756756E-05_JPRB, 0.16920108E-05_JPRB, &
  & 0.17015462E-05_JPRB, 0.16991897E-05_JPRB, 0.16762710E-05_JPRB, 0.16335602E-05_JPRB, 0.15803744E-05_JPRB, 0.15192003E-05_JPRB, &
  & 0.14439671E-05_JPRB, 0.13631703E-05_JPRB, 0.12896642E-05_JPRB, 0.12294937E-05_JPRB, 0.11758499E-05_JPRB, 0.11257987E-05_JPRB, &
  & 0.10843905E-05_JPRB, 0.10569059E-05_JPRB, 0.10380227E-05_JPRB, 0.10205015E-05_JPRB, 0.10072743E-05_JPRB, 0.99676005E-06_JPRB, &
  & 0.98442139E-06_JPRB, 0.96732237E-06_JPRB, 0.94543079E-06_JPRB, 0.92102884E-06_JPRB, 0.89242487E-06_JPRB, 0.85675002E-06_JPRB, &
  & 0.80941415E-06_JPRB, 0.76105482E-06_JPRB, 0.71832261E-06_JPRB, 0.68111392E-06_JPRB, 0.64894408E-06_JPRB, 0.62480683E-06_JPRB, &
  & 0.60993161E-06_JPRB, 0.60478148E-06_JPRB, 0.60489819E-06_JPRB, 0.60678760E-06_JPRB  /)

RGHG2(:,29, 1) = (/ &
  & 0.12647004E-05_JPRB, 0.12685201E-05_JPRB, 0.12749718E-05_JPRB, 0.12788161E-05_JPRB, 0.12806848E-05_JPRB, 0.12833692E-05_JPRB, &
  & 0.12881870E-05_JPRB, 0.12932165E-05_JPRB, 0.12992474E-05_JPRB, 0.13094400E-05_JPRB, 0.13205036E-05_JPRB, 0.13314624E-05_JPRB, &
  & 0.13433157E-05_JPRB, 0.13556688E-05_JPRB, 0.13707076E-05_JPRB, 0.13885903E-05_JPRB, 0.14074478E-05_JPRB, 0.14283602E-05_JPRB, &
  & 0.14516701E-05_JPRB, 0.14765088E-05_JPRB, 0.15022716E-05_JPRB, 0.15330421E-05_JPRB, 0.15700806E-05_JPRB, 0.16047198E-05_JPRB, &
  & 0.16311664E-05_JPRB, 0.16497655E-05_JPRB, 0.16637040E-05_JPRB, 0.16788538E-05_JPRB, 0.16946622E-05_JPRB, 0.17058609E-05_JPRB, &
  & 0.17120272E-05_JPRB, 0.17088147E-05_JPRB, 0.16873734E-05_JPRB, 0.16477831E-05_JPRB, 0.15989468E-05_JPRB, 0.15459191E-05_JPRB, &
  & 0.14812211E-05_JPRB, 0.14152813E-05_JPRB, 0.13522691E-05_JPRB, 0.12993476E-05_JPRB, 0.12516687E-05_JPRB, 0.12028878E-05_JPRB, &
  & 0.11590356E-05_JPRB, 0.11259589E-05_JPRB, 0.11022845E-05_JPRB, 0.10815323E-05_JPRB, 0.10653365E-05_JPRB, 0.10540904E-05_JPRB, &
  & 0.10414480E-05_JPRB, 0.10236171E-05_JPRB, 0.10018084E-05_JPRB, 0.97933952E-06_JPRB, 0.95213011E-06_JPRB, 0.91754607E-06_JPRB, &
  & 0.87226753E-06_JPRB, 0.82448813E-06_JPRB, 0.78197684E-06_JPRB, 0.74654933E-06_JPRB, 0.71654729E-06_JPRB, 0.69431549E-06_JPRB, &
  & 0.68238129E-06_JPRB, 0.68032407E-06_JPRB, 0.68187677E-06_JPRB, 0.68419422E-06_JPRB  /)

RGHG2(:,30, 1) = (/ &
  & 0.13083168E-05_JPRB, 0.13120511E-05_JPRB, 0.13201416E-05_JPRB, 0.13251758E-05_JPRB, 0.13277737E-05_JPRB, 0.13321706E-05_JPRB, &
  & 0.13376820E-05_JPRB, 0.13428340E-05_JPRB, 0.13490476E-05_JPRB, 0.13579429E-05_JPRB, 0.13678165E-05_JPRB, 0.13789676E-05_JPRB, &
  & 0.13914994E-05_JPRB, 0.14051745E-05_JPRB, 0.14215120E-05_JPRB, 0.14400026E-05_JPRB, 0.14588492E-05_JPRB, 0.14787556E-05_JPRB, &
  & 0.15008647E-05_JPRB, 0.15236767E-05_JPRB, 0.15465614E-05_JPRB, 0.15717942E-05_JPRB, 0.16012457E-05_JPRB, 0.16292100E-05_JPRB, &
  & 0.16514574E-05_JPRB, 0.16678694E-05_JPRB, 0.16802380E-05_JPRB, 0.16925081E-05_JPRB, 0.17047939E-05_JPRB, 0.17134528E-05_JPRB, &
  & 0.17176026E-05_JPRB, 0.17146076E-05_JPRB, 0.16970492E-05_JPRB, 0.16638784E-05_JPRB, 0.16218628E-05_JPRB, 0.15779156E-05_JPRB, &
  & 0.15264849E-05_JPRB, 0.14757328E-05_JPRB, 0.14258787E-05_JPRB, 0.13805084E-05_JPRB, 0.13373229E-05_JPRB, 0.12916119E-05_JPRB, &
  & 0.12464961E-05_JPRB, 0.12096784E-05_JPRB, 0.11810628E-05_JPRB, 0.11560987E-05_JPRB, 0.11360672E-05_JPRB, 0.11215454E-05_JPRB, &
  & 0.11065132E-05_JPRB, 0.10875294E-05_JPRB, 0.10650293E-05_JPRB, 0.10421376E-05_JPRB, 0.10156209E-05_JPRB, 0.98141384E-06_JPRB, &
  & 0.93767763E-06_JPRB, 0.89158479E-06_JPRB, 0.85102659E-06_JPRB, 0.81796598E-06_JPRB, 0.79147140E-06_JPRB, 0.77267404E-06_JPRB, &
  & 0.76404179E-06_JPRB, 0.76460738E-06_JPRB, 0.76892696E-06_JPRB, 0.77095368E-06_JPRB  /)

RGHG2(:,31, 1) = (/ &
  & 0.13542642E-05_JPRB, 0.13579089E-05_JPRB, 0.13677264E-05_JPRB, 0.13740143E-05_JPRB, 0.13773796E-05_JPRB, 0.13835802E-05_JPRB, &
  & 0.13898208E-05_JPRB, 0.13951007E-05_JPRB, 0.14015062E-05_JPRB, 0.14090327E-05_JPRB, 0.14176528E-05_JPRB, 0.14290085E-05_JPRB, &
  & 0.14422567E-05_JPRB, 0.14573261E-05_JPRB, 0.14750323E-05_JPRB, 0.14941626E-05_JPRB, 0.15129963E-05_JPRB, 0.15318410E-05_JPRB, &
  & 0.15526837E-05_JPRB, 0.15733594E-05_JPRB, 0.15932124E-05_JPRB, 0.16126120E-05_JPRB, 0.16340684E-05_JPRB, 0.16549971E-05_JPRB, &
  & 0.16728185E-05_JPRB, 0.16869279E-05_JPRB, 0.16976463E-05_JPRB, 0.17068847E-05_JPRB, 0.17154607E-05_JPRB, 0.17214461E-05_JPRB, &
  & 0.17234724E-05_JPRB, 0.17207076E-05_JPRB, 0.17072427E-05_JPRB, 0.16808389E-05_JPRB, 0.16460125E-05_JPRB, 0.16116338E-05_JPRB, &
  & 0.15741848E-05_JPRB, 0.15394356E-05_JPRB, 0.15034481E-05_JPRB, 0.14660345E-05_JPRB, 0.14275821E-05_JPRB, 0.13851076E-05_JPRB, &
  & 0.13386613E-05_JPRB, 0.12979036E-05_JPRB, 0.12640817E-05_JPRB, 0.12346787E-05_JPRB, 0.12106050E-05_JPRB, 0.11926293E-05_JPRB, &
  & 0.11750770E-05_JPRB, 0.11548779E-05_JPRB, 0.11316487E-05_JPRB, 0.11083093E-05_JPRB, 0.10825217E-05_JPRB, 0.10487112E-05_JPRB, &
  & 0.10065996E-05_JPRB, 0.96228489E-06_JPRB, 0.92378622E-06_JPRB, 0.89322007E-06_JPRB, 0.87042241E-06_JPRB, 0.85524520E-06_JPRB, &
  & 0.85009239E-06_JPRB, 0.85342107E-06_JPRB, 0.86065726E-06_JPRB, 0.86237696E-06_JPRB  /)

RGHG2(:,32, 1) = (/ &
  & 0.13946270E-05_JPRB, 0.13986016E-05_JPRB, 0.14077609E-05_JPRB, 0.14139250E-05_JPRB, 0.14175196E-05_JPRB, 0.14233484E-05_JPRB, &
  & 0.14286607E-05_JPRB, 0.14350927E-05_JPRB, 0.14424822E-05_JPRB, 0.14498777E-05_JPRB, 0.14582816E-05_JPRB, 0.14695159E-05_JPRB, &
  & 0.14829463E-05_JPRB, 0.14986079E-05_JPRB, 0.15162237E-05_JPRB, 0.15344054E-05_JPRB, 0.15523831E-05_JPRB, 0.15705077E-05_JPRB, &
  & 0.15898354E-05_JPRB, 0.16076692E-05_JPRB, 0.16242516E-05_JPRB, 0.16402864E-05_JPRB, 0.16569699E-05_JPRB, 0.16725832E-05_JPRB, &
  & 0.16861093E-05_JPRB, 0.16972503E-05_JPRB, 0.17060559E-05_JPRB, 0.17136661E-05_JPRB, 0.17205749E-05_JPRB, 0.17252910E-05_JPRB, &
  & 0.17268916E-05_JPRB, 0.17246054E-05_JPRB, 0.17141426E-05_JPRB, 0.16942241E-05_JPRB, 0.16686380E-05_JPRB, 0.16437065E-05_JPRB, &
  & 0.16176868E-05_JPRB, 0.15937979E-05_JPRB, 0.15681199E-05_JPRB, 0.15392336E-05_JPRB, 0.15059496E-05_JPRB, 0.14666088E-05_JPRB, &
  & 0.14213590E-05_JPRB, 0.13789961E-05_JPRB, 0.13418840E-05_JPRB, 0.13096466E-05_JPRB, 0.12820255E-05_JPRB, 0.12603670E-05_JPRB, &
  & 0.12408879E-05_JPRB, 0.12206675E-05_JPRB, 0.11973420E-05_JPRB, 0.11728152E-05_JPRB, 0.11471186E-05_JPRB, 0.11147577E-05_JPRB, &
  & 0.10751224E-05_JPRB, 0.10339188E-05_JPRB, 0.99886621E-06_JPRB, 0.97167592E-06_JPRB, 0.95311328E-06_JPRB, 0.94250758E-06_JPRB, &
  & 0.94129798E-06_JPRB, 0.94784178E-06_JPRB, 0.95773342E-06_JPRB, 0.96190594E-06_JPRB  /)

RGHG2(:,33, 1) = (/ &
  & 0.14358509E-05_JPRB, 0.14402226E-05_JPRB, 0.14483890E-05_JPRB, 0.14542463E-05_JPRB, 0.14580093E-05_JPRB, 0.14631703E-05_JPRB, &
  & 0.14673031E-05_JPRB, 0.14750649E-05_JPRB, 0.14835797E-05_JPRB, 0.14909992E-05_JPRB, 0.14993129E-05_JPRB, 0.15103787E-05_JPRB, &
  & 0.15239295E-05_JPRB, 0.15401026E-05_JPRB, 0.15574356E-05_JPRB, 0.15744258E-05_JPRB, 0.15914046E-05_JPRB, 0.16088252E-05_JPRB, &
  & 0.16265462E-05_JPRB, 0.16413352E-05_JPRB, 0.16544877E-05_JPRB, 0.16673454E-05_JPRB, 0.16794857E-05_JPRB, 0.16897977E-05_JPRB, &
  & 0.16988770E-05_JPRB, 0.17068467E-05_JPRB, 0.17136305E-05_JPRB, 0.17197304E-05_JPRB, 0.17251709E-05_JPRB, 0.17287498E-05_JPRB, &
  & 0.17301277E-05_JPRB, 0.17283710E-05_JPRB, 0.17208868E-05_JPRB, 0.17076717E-05_JPRB, 0.16919541E-05_JPRB, 0.16768249E-05_JPRB, &
  & 0.16623526E-05_JPRB, 0.16490844E-05_JPRB, 0.16336601E-05_JPRB, 0.16137096E-05_JPRB, 0.15858533E-05_JPRB, 0.15497558E-05_JPRB, &
  & 0.15060765E-05_JPRB, 0.14623477E-05_JPRB, 0.14220645E-05_JPRB, 0.13870892E-05_JPRB, 0.13558456E-05_JPRB, 0.13303299E-05_JPRB, &
  & 0.13089252E-05_JPRB, 0.12888372E-05_JPRB, 0.12654937E-05_JPRB, 0.12396370E-05_JPRB, 0.12139525E-05_JPRB, 0.11832343E-05_JPRB, &
  & 0.11462828E-05_JPRB, 0.11084850E-05_JPRB, 0.10771933E-05_JPRB, 0.10536255E-05_JPRB, 0.10395338E-05_JPRB, 0.10338021E-05_JPRB, &
  & 0.10367506E-05_JPRB, 0.10466942E-05_JPRB, 0.10593117E-05_JPRB, 0.10663906E-05_JPRB  /)

RGHG2(:,34, 1) = (/ &
  & 0.14737547E-05_JPRB, 0.14780413E-05_JPRB, 0.14844208E-05_JPRB, 0.14896614E-05_JPRB, 0.14933501E-05_JPRB, 0.14968105E-05_JPRB, &
  & 0.15006666E-05_JPRB, 0.15095668E-05_JPRB, 0.15180613E-05_JPRB, 0.15251628E-05_JPRB, 0.15333160E-05_JPRB, 0.15441156E-05_JPRB, &
  & 0.15573225E-05_JPRB, 0.15728398E-05_JPRB, 0.15889193E-05_JPRB, 0.16045383E-05_JPRB, 0.16203622E-05_JPRB, 0.16365484E-05_JPRB, &
  & 0.16521079E-05_JPRB, 0.16643725E-05_JPRB, 0.16750788E-05_JPRB, 0.16853535E-05_JPRB, 0.16943184E-05_JPRB, 0.17014597E-05_JPRB, &
  & 0.17077796E-05_JPRB, 0.17135234E-05_JPRB, 0.17186776E-05_JPRB, 0.17235320E-05_JPRB, 0.17278859E-05_JPRB, 0.17307999E-05_JPRB, &
  & 0.17322486E-05_JPRB, 0.17312008E-05_JPRB, 0.17262263E-05_JPRB, 0.17179673E-05_JPRB, 0.17086002E-05_JPRB, 0.16995458E-05_JPRB, &
  & 0.16914106E-05_JPRB, 0.16837252E-05_JPRB, 0.16738485E-05_JPRB, 0.16595214E-05_JPRB, 0.16370769E-05_JPRB, 0.16062363E-05_JPRB, &
  & 0.15674346E-05_JPRB, 0.15262724E-05_JPRB, 0.14863645E-05_JPRB, 0.14508471E-05_JPRB, 0.14180244E-05_JPRB, 0.13903514E-05_JPRB, &
  & 0.13684832E-05_JPRB, 0.13487399E-05_JPRB, 0.13261041E-05_JPRB, 0.13002104E-05_JPRB, 0.12748632E-05_JPRB, 0.12461194E-05_JPRB, &
  & 0.12124669E-05_JPRB, 0.11791904E-05_JPRB, 0.11520020E-05_JPRB, 0.11325711E-05_JPRB, 0.11225329E-05_JPRB, 0.11213766E-05_JPRB, &
  & 0.11276838E-05_JPRB, 0.11390274E-05_JPRB, 0.11530742E-05_JPRB, 0.11618707E-05_JPRB  /)

RGHG2(:,35, 1) = (/ &
  & 0.15110211E-05_JPRB, 0.15149727E-05_JPRB, 0.15191074E-05_JPRB, 0.15235552E-05_JPRB, 0.15270429E-05_JPRB, 0.15282251E-05_JPRB, &
  & 0.15322599E-05_JPRB, 0.15422321E-05_JPRB, 0.15501180E-05_JPRB, 0.15567170E-05_JPRB, 0.15646692E-05_JPRB, 0.15751449E-05_JPRB, &
  & 0.15877599E-05_JPRB, 0.16020041E-05_JPRB, 0.16162968E-05_JPRB, 0.16304138E-05_JPRB, 0.16449701E-05_JPRB, 0.16596153E-05_JPRB, &
  & 0.16726677E-05_JPRB, 0.16826038E-05_JPRB, 0.16913000E-05_JPRB, 0.16992239E-05_JPRB, 0.17056258E-05_JPRB, 0.17106006E-05_JPRB, &
  & 0.17149495E-05_JPRB, 0.17188897E-05_JPRB, 0.17225698E-05_JPRB, 0.17262795E-05_JPRB, 0.17297121E-05_JPRB, 0.17321850E-05_JPRB, &
  & 0.17338570E-05_JPRB, 0.17336300E-05_JPRB, 0.17309951E-05_JPRB, 0.17269351E-05_JPRB, 0.17222919E-05_JPRB, 0.17175705E-05_JPRB, &
  & 0.17132769E-05_JPRB, 0.17087464E-05_JPRB, 0.17021585E-05_JPRB, 0.16919131E-05_JPRB, 0.16750245E-05_JPRB, 0.16506220E-05_JPRB, &
  & 0.16185320E-05_JPRB, 0.15820267E-05_JPRB, 0.15443243E-05_JPRB, 0.15093766E-05_JPRB, 0.14759787E-05_JPRB, 0.14469600E-05_JPRB, &
  & 0.14253654E-05_JPRB, 0.14060856E-05_JPRB, 0.13845498E-05_JPRB, 0.13592815E-05_JPRB, 0.13344480E-05_JPRB, 0.13079041E-05_JPRB, &
  & 0.12779593E-05_JPRB, 0.12499036E-05_JPRB, 0.12271096E-05_JPRB, 0.12121960E-05_JPRB, 0.12061111E-05_JPRB, 0.12095056E-05_JPRB, &
  & 0.12188560E-05_JPRB, 0.12306128E-05_JPRB, 0.12454636E-05_JPRB, 0.12554160E-05_JPRB  /)

RGHG2(:,36, 1) = (/ &
  & 0.15466732E-05_JPRB, 0.15497830E-05_JPRB, 0.15521428E-05_JPRB, 0.15558579E-05_JPRB, 0.15589884E-05_JPRB, 0.15583942E-05_JPRB, &
  & 0.15626826E-05_JPRB, 0.15728908E-05_JPRB, 0.15798932E-05_JPRB, 0.15859249E-05_JPRB, 0.15935700E-05_JPRB, 0.16035446E-05_JPRB, &
  & 0.16153830E-05_JPRB, 0.16282625E-05_JPRB, 0.16408412E-05_JPRB, 0.16534573E-05_JPRB, 0.16665795E-05_JPRB, 0.16794089E-05_JPRB, &
  & 0.16899911E-05_JPRB, 0.16977354E-05_JPRB, 0.17045566E-05_JPRB, 0.17104555E-05_JPRB, 0.17147592E-05_JPRB, 0.17179803E-05_JPRB, &
  & 0.17207411E-05_JPRB, 0.17231892E-05_JPRB, 0.17256148E-05_JPRB, 0.17283047E-05_JPRB, 0.17310013E-05_JPRB, 0.17332193E-05_JPRB, &
  & 0.17352062E-05_JPRB, 0.17357453E-05_JPRB, 0.17349543E-05_JPRB, 0.17340483E-05_JPRB, 0.17329140E-05_JPRB, 0.17314330E-05_JPRB, &
  & 0.17299823E-05_JPRB, 0.17278647E-05_JPRB, 0.17239836E-05_JPRB, 0.17172613E-05_JPRB, 0.17053345E-05_JPRB, 0.16868822E-05_JPRB, &
  & 0.16612700E-05_JPRB, 0.16298201E-05_JPRB, 0.15950497E-05_JPRB, 0.15614755E-05_JPRB, 0.15285135E-05_JPRB, 0.14990089E-05_JPRB, &
  & 0.14780249E-05_JPRB, 0.14594921E-05_JPRB, 0.14392611E-05_JPRB, 0.14152137E-05_JPRB, 0.13913974E-05_JPRB, 0.13671688E-05_JPRB, &
  & 0.13410983E-05_JPRB, 0.13181752E-05_JPRB, 0.12999400E-05_JPRB, 0.12894195E-05_JPRB, 0.12872085E-05_JPRB, 0.12946114E-05_JPRB, &
  & 0.13059939E-05_JPRB, 0.13175725E-05_JPRB, 0.13324634E-05_JPRB, 0.13422013E-05_JPRB  /)

RGHG2(:,37, 1) = (/ &
  & 0.15764060E-05_JPRB, 0.15775648E-05_JPRB, 0.15793370E-05_JPRB, 0.15825031E-05_JPRB, 0.15849403E-05_JPRB, 0.15838306E-05_JPRB, &
  & 0.15885288E-05_JPRB, 0.15970411E-05_JPRB, 0.16025848E-05_JPRB, 0.16079361E-05_JPRB, 0.16150503E-05_JPRB, 0.16241486E-05_JPRB, &
  & 0.16348349E-05_JPRB, 0.16462248E-05_JPRB, 0.16573627E-05_JPRB, 0.16685742E-05_JPRB, 0.16799697E-05_JPRB, 0.16904666E-05_JPRB, &
  & 0.16988168E-05_JPRB, 0.17048188E-05_JPRB, 0.17101916E-05_JPRB, 0.17149384E-05_JPRB, 0.17183401E-05_JPRB, 0.17208627E-05_JPRB, &
  & 0.17230128E-05_JPRB, 0.17247752E-05_JPRB, 0.17265282E-05_JPRB, 0.17285480E-05_JPRB, 0.17309791E-05_JPRB, 0.17333853E-05_JPRB, &
  & 0.17358773E-05_JPRB, 0.17370092E-05_JPRB, 0.17368109E-05_JPRB, 0.17364668E-05_JPRB, 0.17358377E-05_JPRB, 0.17348902E-05_JPRB, &
  & 0.17338158E-05_JPRB, 0.17322601E-05_JPRB, 0.17295825E-05_JPRB, 0.17248834E-05_JPRB, 0.17162478E-05_JPRB, 0.17022569E-05_JPRB, &
  & 0.16821833E-05_JPRB, 0.16563880E-05_JPRB, 0.16260325E-05_JPRB, 0.15955897E-05_JPRB, 0.15653545E-05_JPRB, 0.15373653E-05_JPRB, &
  & 0.15177267E-05_JPRB, 0.15005444E-05_JPRB, 0.14820067E-05_JPRB, 0.14604696E-05_JPRB, 0.14387616E-05_JPRB, 0.14169685E-05_JPRB, &
  & 0.13949134E-05_JPRB, 0.13766011E-05_JPRB, 0.13630180E-05_JPRB, 0.13563325E-05_JPRB, 0.13575725E-05_JPRB, 0.13674909E-05_JPRB, &
  & 0.13784610E-05_JPRB, 0.13885164E-05_JPRB, 0.14016934E-05_JPRB, 0.14080885E-05_JPRB  /)

RGHG2(:,38, 1) = (/ &
  & 0.16093972E-05_JPRB, 0.16083912E-05_JPRB, 0.16095113E-05_JPRB, 0.16120683E-05_JPRB, 0.16137362E-05_JPRB, 0.16120546E-05_JPRB, &
  & 0.16172075E-05_JPRB, 0.16238381E-05_JPRB, 0.16277631E-05_JPRB, 0.16323594E-05_JPRB, 0.16388846E-05_JPRB, 0.16470106E-05_JPRB, &
  & 0.16564185E-05_JPRB, 0.16661555E-05_JPRB, 0.16756948E-05_JPRB, 0.16853478E-05_JPRB, 0.16948272E-05_JPRB, 0.17027360E-05_JPRB, &
  & 0.17086097E-05_JPRB, 0.17126786E-05_JPRB, 0.17164441E-05_JPRB, 0.17199126E-05_JPRB, 0.17223134E-05_JPRB, 0.17240610E-05_JPRB, &
  & 0.17255333E-05_JPRB, 0.17265351E-05_JPRB, 0.17275417E-05_JPRB, 0.17288179E-05_JPRB, 0.17309545E-05_JPRB, 0.17335694E-05_JPRB, &
  & 0.17366220E-05_JPRB, 0.17384116E-05_JPRB, 0.17388711E-05_JPRB, 0.17391504E-05_JPRB, 0.17390818E-05_JPRB, 0.17387262E-05_JPRB, &
  & 0.17380693E-05_JPRB, 0.17371370E-05_JPRB, 0.17357950E-05_JPRB, 0.17333408E-05_JPRB, 0.17283571E-05_JPRB, 0.17193164E-05_JPRB, &
  & 0.17053884E-05_JPRB, 0.16858674E-05_JPRB, 0.16604107E-05_JPRB, 0.16334425E-05_JPRB, 0.16062329E-05_JPRB, 0.15799252E-05_JPRB, &
  & 0.15617794E-05_JPRB, 0.15460956E-05_JPRB, 0.15294368E-05_JPRB, 0.15106851E-05_JPRB, 0.14913163E-05_JPRB, 0.14722257E-05_JPRB, &
  & 0.14546261E-05_JPRB, 0.14414299E-05_JPRB, 0.14330086E-05_JPRB, 0.14305784E-05_JPRB, 0.14356477E-05_JPRB, 0.14483572E-05_JPRB, &
  & 0.14588697E-05_JPRB, 0.14672350E-05_JPRB, 0.14785103E-05_JPRB, 0.14811963E-05_JPRB  /)

RGHG2(:,39, 1) = (/ &
  & 0.16283753E-05_JPRB, 0.16270972E-05_JPRB, 0.16280738E-05_JPRB, 0.16299176E-05_JPRB, 0.16309535E-05_JPRB, 0.16298478E-05_JPRB, &
  & 0.16345719E-05_JPRB, 0.16396106E-05_JPRB, 0.16429869E-05_JPRB, 0.16472327E-05_JPRB, 0.16530337E-05_JPRB, 0.16601152E-05_JPRB, &
  & 0.16683270E-05_JPRB, 0.16767170E-05_JPRB, 0.16849511E-05_JPRB, 0.16933119E-05_JPRB, 0.17012775E-05_JPRB, 0.17076921E-05_JPRB, &
  & 0.17123742E-05_JPRB, 0.17155432E-05_JPRB, 0.17185105E-05_JPRB, 0.17213742E-05_JPRB, 0.17234335E-05_JPRB, 0.17249423E-05_JPRB, &
  & 0.17261136E-05_JPRB, 0.17267004E-05_JPRB, 0.17272331E-05_JPRB, 0.17283237E-05_JPRB, 0.17304469E-05_JPRB, 0.17332427E-05_JPRB, &
  & 0.17365119E-05_JPRB, 0.17384777E-05_JPRB, 0.17391945E-05_JPRB, 0.17396745E-05_JPRB, 0.17398041E-05_JPRB, 0.17395631E-05_JPRB, &
  & 0.17389748E-05_JPRB, 0.17382936E-05_JPRB, 0.17374091E-05_JPRB, 0.17357345E-05_JPRB, 0.17321171E-05_JPRB, 0.17253543E-05_JPRB, &
  & 0.17142834E-05_JPRB, 0.16980745E-05_JPRB, 0.16762376E-05_JPRB, 0.16526410E-05_JPRB, 0.16283789E-05_JPRB, 0.16047062E-05_JPRB, &
  & 0.15881735E-05_JPRB, 0.15740296E-05_JPRB, 0.15594128E-05_JPRB, 0.15433045E-05_JPRB, 0.15268342E-05_JPRB, 0.15104541E-05_JPRB, &
  & 0.14959059E-05_JPRB, 0.14861649E-05_JPRB, 0.14811715E-05_JPRB, 0.14817672E-05_JPRB, 0.14885412E-05_JPRB, 0.15012877E-05_JPRB, &
  & 0.15110460E-05_JPRB, 0.15181596E-05_JPRB, 0.15279938E-05_JPRB, 0.15294269E-05_JPRB  /)

RGHG2(:,40, 1) = (/ &
  & 0.16483550E-05_JPRB, 0.16470674E-05_JPRB, 0.16479587E-05_JPRB, 0.16489485E-05_JPRB, 0.16492651E-05_JPRB, 0.16490231E-05_JPRB, &
  & 0.16530995E-05_JPRB, 0.16563174E-05_JPRB, 0.16592247E-05_JPRB, 0.16631254E-05_JPRB, 0.16680545E-05_JPRB, 0.16738982E-05_JPRB, &
  & 0.16807197E-05_JPRB, 0.16875791E-05_JPRB, 0.16943293E-05_JPRB, 0.17012172E-05_JPRB, 0.17074721E-05_JPRB, 0.17123121E-05_JPRB, &
  & 0.17158060E-05_JPRB, 0.17180879E-05_JPRB, 0.17202507E-05_JPRB, 0.17225148E-05_JPRB, 0.17242812E-05_JPRB, 0.17255974E-05_JPRB, &
  & 0.17264772E-05_JPRB, 0.17266336E-05_JPRB, 0.17266547E-05_JPRB, 0.17276188E-05_JPRB, 0.17297722E-05_JPRB, 0.17327757E-05_JPRB, &
  & 0.17362430E-05_JPRB, 0.17383366E-05_JPRB, 0.17392899E-05_JPRB, 0.17399364E-05_JPRB, 0.17402392E-05_JPRB, 0.17400546E-05_JPRB, &
  & 0.17394897E-05_JPRB, 0.17390423E-05_JPRB, 0.17385511E-05_JPRB, 0.17375517E-05_JPRB, 0.17351637E-05_JPRB, 0.17306370E-05_JPRB, &
  & 0.17223813E-05_JPRB, 0.17095746E-05_JPRB, 0.16917768E-05_JPRB, 0.16721202E-05_JPRB, 0.16513044E-05_JPRB, 0.16308800E-05_JPRB, &
  & 0.16162603E-05_JPRB, 0.16039302E-05_JPRB, 0.15917366E-05_JPRB, 0.15787075E-05_JPRB, 0.15657302E-05_JPRB, 0.15525323E-05_JPRB, &
  & 0.15413356E-05_JPRB, 0.15353778E-05_JPRB, 0.15341237E-05_JPRB, 0.15380694E-05_JPRB, 0.15464964E-05_JPRB, 0.15588359E-05_JPRB, &
  & 0.15676603E-05_JPRB, 0.15733767E-05_JPRB, 0.15815950E-05_JPRB, 0.15819596E-05_JPRB  /)

RGHG2(:,41, 1) = (/ &
  & 0.16727832E-05_JPRB, 0.16714838E-05_JPRB, 0.16722709E-05_JPRB, 0.16722165E-05_JPRB, 0.16716538E-05_JPRB, 0.16724677E-05_JPRB, &
  & 0.16757521E-05_JPRB, 0.16767439E-05_JPRB, 0.16790778E-05_JPRB, 0.16825564E-05_JPRB, 0.16864195E-05_JPRB, 0.16907500E-05_JPRB, &
  & 0.16958715E-05_JPRB, 0.17008596E-05_JPRB, 0.17057955E-05_JPRB, 0.17108827E-05_JPRB, 0.17150458E-05_JPRB, 0.17179606E-05_JPRB, &
  & 0.17200018E-05_JPRB, 0.17211992E-05_JPRB, 0.17223784E-05_JPRB, 0.17239094E-05_JPRB, 0.17253176E-05_JPRB, 0.17263985E-05_JPRB, &
  & 0.17269218E-05_JPRB, 0.17265519E-05_JPRB, 0.17259475E-05_JPRB, 0.17267569E-05_JPRB, 0.17289473E-05_JPRB, 0.17322047E-05_JPRB, &
  & 0.17359141E-05_JPRB, 0.17381641E-05_JPRB, 0.17394066E-05_JPRB, 0.17402565E-05_JPRB, 0.17407712E-05_JPRB, 0.17406556E-05_JPRB, &
  & 0.17401192E-05_JPRB, 0.17399577E-05_JPRB, 0.17399473E-05_JPRB, 0.17397736E-05_JPRB, 0.17388887E-05_JPRB, 0.17370960E-05_JPRB, &
  & 0.17322821E-05_JPRB, 0.17236352E-05_JPRB, 0.17107757E-05_JPRB, 0.16959364E-05_JPRB, 0.16793342E-05_JPRB, 0.16628812E-05_JPRB, &
  & 0.16506004E-05_JPRB, 0.16404881E-05_JPRB, 0.16312571E-05_JPRB, 0.16219926E-05_JPRB, 0.16132862E-05_JPRB, 0.16039791E-05_JPRB, &
  & 0.15968800E-05_JPRB, 0.15955477E-05_JPRB, 0.15988653E-05_JPRB, 0.16069070E-05_JPRB, 0.16173550E-05_JPRB, 0.16291968E-05_JPRB, &
  & 0.16368796E-05_JPRB, 0.16408877E-05_JPRB, 0.16471303E-05_JPRB, 0.16461884E-05_JPRB  /)

RGHG2(:,42, 1) = (/ &
  & 0.16761404E-05_JPRB, 0.16766434E-05_JPRB, 0.16768616E-05_JPRB, 0.16767932E-05_JPRB, 0.16764124E-05_JPRB, 0.16771384E-05_JPRB, &
  & 0.16795274E-05_JPRB, 0.16810769E-05_JPRB, 0.16836585E-05_JPRB, 0.16867207E-05_JPRB, 0.16899148E-05_JPRB, 0.16936562E-05_JPRB, &
  & 0.16980695E-05_JPRB, 0.17024628E-05_JPRB, 0.17068525E-05_JPRB, 0.17111362E-05_JPRB, 0.17145449E-05_JPRB, 0.17171313E-05_JPRB, &
  & 0.17191329E-05_JPRB, 0.17202890E-05_JPRB, 0.17216447E-05_JPRB, 0.17232269E-05_JPRB, 0.17246649E-05_JPRB, 0.17256513E-05_JPRB, &
  & 0.17260846E-05_JPRB, 0.17257846E-05_JPRB, 0.17254024E-05_JPRB, 0.17262275E-05_JPRB, 0.17283341E-05_JPRB, 0.17315735E-05_JPRB, &
  & 0.17352642E-05_JPRB, 0.17378768E-05_JPRB, 0.17393884E-05_JPRB, 0.17404477E-05_JPRB, 0.17409689E-05_JPRB, 0.17409280E-05_JPRB, &
  & 0.17405763E-05_JPRB, 0.17402209E-05_JPRB, 0.17399357E-05_JPRB, 0.17396236E-05_JPRB, 0.17386309E-05_JPRB, 0.17366172E-05_JPRB, &
  & 0.17321348E-05_JPRB, 0.17238999E-05_JPRB, 0.17121607E-05_JPRB, 0.16985077E-05_JPRB, 0.16835710E-05_JPRB, 0.16695412E-05_JPRB, &
  & 0.16591126E-05_JPRB, 0.16503089E-05_JPRB, 0.16422315E-05_JPRB, 0.16346243E-05_JPRB, 0.16273473E-05_JPRB, 0.16200370E-05_JPRB, &
  & 0.16149089E-05_JPRB, 0.16148317E-05_JPRB, 0.16182607E-05_JPRB, 0.16258438E-05_JPRB, 0.16350009E-05_JPRB, 0.16446523E-05_JPRB, &
  & 0.16516063E-05_JPRB, 0.16562989E-05_JPRB, 0.16621832E-05_JPRB, 0.16634652E-05_JPRB  /)

RGHG2(:,43, 1) = (/ &
  & 0.16897112E-05_JPRB, 0.16918538E-05_JPRB, 0.16915080E-05_JPRB, 0.16909777E-05_JPRB, 0.16903846E-05_JPRB, 0.16914846E-05_JPRB, &
  & 0.16927159E-05_JPRB, 0.16938168E-05_JPRB, 0.16963776E-05_JPRB, 0.16988784E-05_JPRB, 0.17010036E-05_JPRB, 0.17035566E-05_JPRB, &
  & 0.17065924E-05_JPRB, 0.17096381E-05_JPRB, 0.17127491E-05_JPRB, 0.17155252E-05_JPRB, 0.17173458E-05_JPRB, 0.17188043E-05_JPRB, &
  & 0.17201450E-05_JPRB, 0.17207969E-05_JPRB, 0.17218906E-05_JPRB, 0.17232040E-05_JPRB, 0.17245151E-05_JPRB, 0.17253141E-05_JPRB, &
  & 0.17255119E-05_JPRB, 0.17250494E-05_JPRB, 0.17246008E-05_JPRB, 0.17253737E-05_JPRB, 0.17274198E-05_JPRB, 0.17307521E-05_JPRB, &
  & 0.17345298E-05_JPRB, 0.17375404E-05_JPRB, 0.17394219E-05_JPRB, 0.17407599E-05_JPRB, 0.17413781E-05_JPRB, 0.17414351E-05_JPRB, &
  & 0.17412642E-05_JPRB, 0.17408549E-05_JPRB, 0.17405257E-05_JPRB, 0.17404424E-05_JPRB, 0.17399979E-05_JPRB, 0.17389586E-05_JPRB, &
  & 0.17362592E-05_JPRB, 0.17301896E-05_JPRB, 0.17215967E-05_JPRB, 0.17110983E-05_JPRB, 0.16994937E-05_JPRB, 0.16893832E-05_JPRB, &
  & 0.16816506E-05_JPRB, 0.16749947E-05_JPRB, 0.16692443E-05_JPRB, 0.16647685E-05_JPRB, 0.16606328E-05_JPRB, 0.16568180E-05_JPRB, &
  & 0.16552508E-05_JPRB, 0.16583083E-05_JPRB, 0.16638056E-05_JPRB, 0.16727321E-05_JPRB, 0.16815807E-05_JPRB, 0.16890196E-05_JPRB, &
  & 0.16948176E-05_JPRB, 0.16993999E-05_JPRB, 0.17041074E-05_JPRB, 0.17068564E-05_JPRB  /)

RGHG2(:,44, 1) = (/ &
  & 0.16958361E-05_JPRB, 0.16971127E-05_JPRB, 0.16965877E-05_JPRB, 0.16961955E-05_JPRB, 0.16960124E-05_JPRB, 0.16971295E-05_JPRB, &
  & 0.16981170E-05_JPRB, 0.16990998E-05_JPRB, 0.17013929E-05_JPRB, 0.17033570E-05_JPRB, 0.17050279E-05_JPRB, 0.17070952E-05_JPRB, &
  & 0.17095649E-05_JPRB, 0.17120533E-05_JPRB, 0.17144111E-05_JPRB, 0.17162879E-05_JPRB, 0.17174314E-05_JPRB, 0.17185593E-05_JPRB, &
  & 0.17195426E-05_JPRB, 0.17201280E-05_JPRB, 0.17212764E-05_JPRB, 0.17226840E-05_JPRB, 0.17240934E-05_JPRB, 0.17248268E-05_JPRB, &
  & 0.17249703E-05_JPRB, 0.17244962E-05_JPRB, 0.17240925E-05_JPRB, 0.17247630E-05_JPRB, 0.17267965E-05_JPRB, 0.17301260E-05_JPRB, &
  & 0.17340391E-05_JPRB, 0.17373088E-05_JPRB, 0.17394035E-05_JPRB, 0.17408224E-05_JPRB, 0.17416195E-05_JPRB, 0.17417559E-05_JPRB, &
  & 0.17416571E-05_JPRB, 0.17412785E-05_JPRB, 0.17409617E-05_JPRB, 0.17409027E-05_JPRB, 0.17405837E-05_JPRB, 0.17397374E-05_JPRB, &
  & 0.17375024E-05_JPRB, 0.17324987E-05_JPRB, 0.17253743E-05_JPRB, 0.17166962E-05_JPRB, 0.17069706E-05_JPRB, 0.16986118E-05_JPRB, &
  & 0.16923899E-05_JPRB, 0.16870080E-05_JPRB, 0.16828131E-05_JPRB, 0.16798386E-05_JPRB, 0.16768688E-05_JPRB, 0.16743209E-05_JPRB, &
  & 0.16743195E-05_JPRB, 0.16781764E-05_JPRB, 0.16837371E-05_JPRB, 0.16915087E-05_JPRB, 0.16991614E-05_JPRB, 0.17055518E-05_JPRB, &
  & 0.17102447E-05_JPRB, 0.17141984E-05_JPRB, 0.17182479E-05_JPRB, 0.17209284E-05_JPRB  /)

RGHG2(:,45, 1) = (/ &
  & 0.17045231E-05_JPRB, 0.17050210E-05_JPRB, 0.17042208E-05_JPRB, 0.17039273E-05_JPRB, 0.17041842E-05_JPRB, 0.17053680E-05_JPRB, &
  & 0.17059318E-05_JPRB, 0.17067235E-05_JPRB, 0.17087092E-05_JPRB, 0.17099914E-05_JPRB, 0.17110100E-05_JPRB, 0.17123744E-05_JPRB, &
  & 0.17140255E-05_JPRB, 0.17157092E-05_JPRB, 0.17170480E-05_JPRB, 0.17177106E-05_JPRB, 0.17178827E-05_JPRB, 0.17184918E-05_JPRB, &
  & 0.17189847E-05_JPRB, 0.17194306E-05_JPRB, 0.17206083E-05_JPRB, 0.17220890E-05_JPRB, 0.17235945E-05_JPRB, 0.17242294E-05_JPRB, &
  & 0.17242815E-05_JPRB, 0.17237736E-05_JPRB, 0.17234126E-05_JPRB, 0.17239598E-05_JPRB, 0.17259714E-05_JPRB, 0.17293094E-05_JPRB, &
  & 0.17333876E-05_JPRB, 0.17370025E-05_JPRB, 0.17393868E-05_JPRB, 0.17409329E-05_JPRB, 0.17419459E-05_JPRB, 0.17421853E-05_JPRB, &
  & 0.17421914E-05_JPRB, 0.17418408E-05_JPRB, 0.17415325E-05_JPRB, 0.17415300E-05_JPRB, 0.17414234E-05_JPRB, 0.17409198E-05_JPRB, &
  & 0.17394386E-05_JPRB, 0.17359220E-05_JPRB, 0.17308669E-05_JPRB, 0.17246594E-05_JPRB, 0.17174939E-05_JPRB, 0.17116244E-05_JPRB, &
  & 0.17074629E-05_JPRB, 0.17038026E-05_JPRB, 0.17016726E-05_JPRB, 0.17008027E-05_JPRB, 0.16995570E-05_JPRB, 0.16988929E-05_JPRB, &
  & 0.17011240E-05_JPRB, 0.17062869E-05_JPRB, 0.17121810E-05_JPRB, 0.17188076E-05_JPRB, 0.17250599E-05_JPRB, 0.17299770E-05_JPRB, &
  & 0.17332659E-05_JPRB, 0.17364902E-05_JPRB, 0.17396418E-05_JPRB, 0.17424296E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART2',0,ZHOOK_HANDLE)



RGHG2(:,46, 1) = (/ &
  & 0.17089878E-05_JPRB, 0.17088956E-05_JPRB, 0.17082392E-05_JPRB, 0.17080631E-05_JPRB, 0.17085533E-05_JPRB, 0.17097453E-05_JPRB, &
  & 0.17102201E-05_JPRB, 0.17109246E-05_JPRB, 0.17124603E-05_JPRB, 0.17133057E-05_JPRB, 0.17140173E-05_JPRB, 0.17149281E-05_JPRB, &
  & 0.17160402E-05_JPRB, 0.17170546E-05_JPRB, 0.17176171E-05_JPRB, 0.17175579E-05_JPRB, 0.17172753E-05_JPRB, 0.17176525E-05_JPRB, &
  & 0.17179481E-05_JPRB, 0.17184108E-05_JPRB, 0.17196515E-05_JPRB, 0.17213501E-05_JPRB, 0.17230523E-05_JPRB, 0.17236797E-05_JPRB, &
  & 0.17236846E-05_JPRB, 0.17232110E-05_JPRB, 0.17228319E-05_JPRB, 0.17233353E-05_JPRB, 0.17253351E-05_JPRB, 0.17287266E-05_JPRB, &
  & 0.17329316E-05_JPRB, 0.17367630E-05_JPRB, 0.17393740E-05_JPRB, 0.17410162E-05_JPRB, 0.17420260E-05_JPRB, 0.17423278E-05_JPRB, &
  & 0.17424670E-05_JPRB, 0.17422427E-05_JPRB, 0.17420073E-05_JPRB, 0.17420338E-05_JPRB, 0.17420320E-05_JPRB, 0.17416933E-05_JPRB, &
  & 0.17406760E-05_JPRB, 0.17381297E-05_JPRB, 0.17344996E-05_JPRB, 0.17300881E-05_JPRB, 0.17248059E-05_JPRB, 0.17205354E-05_JPRB, &
  & 0.17175037E-05_JPRB, 0.17149975E-05_JPRB, 0.17141562E-05_JPRB, 0.17142853E-05_JPRB, 0.17140712E-05_JPRB, 0.17144588E-05_JPRB, &
  & 0.17171987E-05_JPRB, 0.17222942E-05_JPRB, 0.17276962E-05_JPRB, 0.17331199E-05_JPRB, 0.17381471E-05_JPRB, 0.17421037E-05_JPRB, &
  & 0.17447637E-05_JPRB, 0.17473617E-05_JPRB, 0.17498233E-05_JPRB, 0.17520516E-05_JPRB  /)

RGHG2(:,47, 1) = (/ &
  & 0.17133810E-05_JPRB, 0.17126341E-05_JPRB, 0.17122304E-05_JPRB, 0.17121958E-05_JPRB, 0.17129184E-05_JPRB, 0.17141083E-05_JPRB, &
  & 0.17145456E-05_JPRB, 0.17151686E-05_JPRB, 0.17161479E-05_JPRB, 0.17165297E-05_JPRB, 0.17169502E-05_JPRB, 0.17173787E-05_JPRB, &
  & 0.17179144E-05_JPRB, 0.17181705E-05_JPRB, 0.17178708E-05_JPRB, 0.17170631E-05_JPRB, 0.17163504E-05_JPRB, 0.17165132E-05_JPRB, &
  & 0.17166359E-05_JPRB, 0.17171495E-05_JPRB, 0.17184710E-05_JPRB, 0.17204541E-05_JPRB, 0.17224075E-05_JPRB, 0.17230443E-05_JPRB, &
  & 0.17230027E-05_JPRB, 0.17225829E-05_JPRB, 0.17221703E-05_JPRB, 0.17226383E-05_JPRB, 0.17246262E-05_JPRB, 0.17280895E-05_JPRB, &
  & 0.17324355E-05_JPRB, 0.17364952E-05_JPRB, 0.17393599E-05_JPRB, 0.17411084E-05_JPRB, 0.17420705E-05_JPRB, 0.17424376E-05_JPRB, &
  & 0.17427386E-05_JPRB, 0.17426823E-05_JPRB, 0.17425451E-05_JPRB, 0.17426002E-05_JPRB, 0.17426998E-05_JPRB, 0.17425189E-05_JPRB, &
  & 0.17419880E-05_JPRB, 0.17404768E-05_JPRB, 0.17383898E-05_JPRB, 0.17359506E-05_JPRB, 0.17327426E-05_JPRB, 0.17301701E-05_JPRB, &
  & 0.17282778E-05_JPRB, 0.17270122E-05_JPRB, 0.17275276E-05_JPRB, 0.17286074E-05_JPRB, 0.17294650E-05_JPRB, 0.17309199E-05_JPRB, &
  & 0.17339118E-05_JPRB, 0.17386530E-05_JPRB, 0.17433123E-05_JPRB, 0.17473127E-05_JPRB, 0.17509376E-05_JPRB, 0.17538696E-05_JPRB, &
  & 0.17559471E-05_JPRB, 0.17578308E-05_JPRB, 0.17595244E-05_JPRB, 0.17609627E-05_JPRB  /)

RGHG2(:,48, 1) = (/ &
  & 0.17157795E-05_JPRB, 0.17149087E-05_JPRB, 0.17146699E-05_JPRB, 0.17146760E-05_JPRB, 0.17153901E-05_JPRB, 0.17164721E-05_JPRB, &
  & 0.17168711E-05_JPRB, 0.17173583E-05_JPRB, 0.17179075E-05_JPRB, 0.17179852E-05_JPRB, 0.17181287E-05_JPRB, 0.17181918E-05_JPRB, &
  & 0.17182182E-05_JPRB, 0.17178478E-05_JPRB, 0.17169395E-05_JPRB, 0.17156659E-05_JPRB, 0.17148318E-05_JPRB, 0.17149456E-05_JPRB, &
  & 0.17151369E-05_JPRB, 0.17157725E-05_JPRB, 0.17172857E-05_JPRB, 0.17195418E-05_JPRB, 0.17216872E-05_JPRB, 0.17224368E-05_JPRB, &
  & 0.17224462E-05_JPRB, 0.17220188E-05_JPRB, 0.17215920E-05_JPRB, 0.17220807E-05_JPRB, 0.17240681E-05_JPRB, 0.17275279E-05_JPRB, &
  & 0.17319702E-05_JPRB, 0.17361780E-05_JPRB, 0.17392391E-05_JPRB, 0.17411478E-05_JPRB, 0.17420381E-05_JPRB, 0.17424523E-05_JPRB, &
  & 0.17428393E-05_JPRB, 0.17429966E-05_JPRB, 0.17429447E-05_JPRB, 0.17430132E-05_JPRB, 0.17431545E-05_JPRB, 0.17431679E-05_JPRB, &
  & 0.17430869E-05_JPRB, 0.17423821E-05_JPRB, 0.17414716E-05_JPRB, 0.17405595E-05_JPRB, 0.17390133E-05_JPRB, 0.17376986E-05_JPRB, &
  & 0.17367279E-05_JPRB, 0.17363277E-05_JPRB, 0.17374673E-05_JPRB, 0.17389202E-05_JPRB, 0.17403317E-05_JPRB, 0.17422716E-05_JPRB, &
  & 0.17451369E-05_JPRB, 0.17492043E-05_JPRB, 0.17530280E-05_JPRB, 0.17560826E-05_JPRB, 0.17586987E-05_JPRB, 0.17608595E-05_JPRB, &
  & 0.17624819E-05_JPRB, 0.17639472E-05_JPRB, 0.17652099E-05_JPRB, 0.17661654E-05_JPRB  /)

RGHG2(:,49, 1) = (/ &
  & 0.17175287E-05_JPRB, 0.17167620E-05_JPRB, 0.17166660E-05_JPRB, 0.17166712E-05_JPRB, 0.17172665E-05_JPRB, 0.17181806E-05_JPRB, &
  & 0.17185370E-05_JPRB, 0.17188494E-05_JPRB, 0.17189798E-05_JPRB, 0.17187930E-05_JPRB, 0.17186361E-05_JPRB, 0.17183477E-05_JPRB, &
  & 0.17178406E-05_JPRB, 0.17168363E-05_JPRB, 0.17153695E-05_JPRB, 0.17137085E-05_JPRB, 0.17128802E-05_JPRB, 0.17130149E-05_JPRB, &
  & 0.17133921E-05_JPRB, 0.17141950E-05_JPRB, 0.17159709E-05_JPRB, 0.17185241E-05_JPRB, 0.17208552E-05_JPRB, 0.17217768E-05_JPRB, &
  & 0.17218871E-05_JPRB, 0.17214232E-05_JPRB, 0.17209893E-05_JPRB, 0.17215266E-05_JPRB, 0.17235186E-05_JPRB, 0.17269403E-05_JPRB, &
  & 0.17314687E-05_JPRB, 0.17358042E-05_JPRB, 0.17390570E-05_JPRB, 0.17411673E-05_JPRB, 0.17419672E-05_JPRB, 0.17424253E-05_JPRB, &
  & 0.17428730E-05_JPRB, 0.17432876E-05_JPRB, 0.17433245E-05_JPRB, 0.17434009E-05_JPRB, 0.17435610E-05_JPRB, 0.17438062E-05_JPRB, &
  & 0.17442068E-05_JPRB, 0.17442911E-05_JPRB, 0.17445170E-05_JPRB, 0.17450936E-05_JPRB, 0.17452000E-05_JPRB, 0.17450783E-05_JPRB, &
  & 0.17450288E-05_JPRB, 0.17454165E-05_JPRB, 0.17469142E-05_JPRB, 0.17485177E-05_JPRB, 0.17503070E-05_JPRB, 0.17525193E-05_JPRB, &
  & 0.17550726E-05_JPRB, 0.17582483E-05_JPRB, 0.17611047E-05_JPRB, 0.17633287E-05_JPRB, 0.17650068E-05_JPRB, 0.17664287E-05_JPRB, &
  & 0.17676051E-05_JPRB, 0.17687415E-05_JPRB, 0.17696804E-05_JPRB, 0.17702409E-05_JPRB  /)

RGHG2(:,50, 1) = (/ &
  & 0.17178095E-05_JPRB, 0.17170981E-05_JPRB, 0.17170640E-05_JPRB, 0.17170379E-05_JPRB, 0.17174954E-05_JPRB, 0.17181496E-05_JPRB, &
  & 0.17183234E-05_JPRB, 0.17184127E-05_JPRB, 0.17182539E-05_JPRB, 0.17179322E-05_JPRB, 0.17176047E-05_JPRB, 0.17170736E-05_JPRB, &
  & 0.17162229E-05_JPRB, 0.17148422E-05_JPRB, 0.17130877E-05_JPRB, 0.17113685E-05_JPRB, 0.17107243E-05_JPRB, 0.17109758E-05_JPRB, &
  & 0.17116111E-05_JPRB, 0.17126607E-05_JPRB, 0.17146705E-05_JPRB, 0.17174916E-05_JPRB, 0.17199852E-05_JPRB, 0.17211338E-05_JPRB, &
  & 0.17213695E-05_JPRB, 0.17209193E-05_JPRB, 0.17205331E-05_JPRB, 0.17211128E-05_JPRB, 0.17230602E-05_JPRB, 0.17264128E-05_JPRB, &
  & 0.17310315E-05_JPRB, 0.17354663E-05_JPRB, 0.17388318E-05_JPRB, 0.17410336E-05_JPRB, 0.17418432E-05_JPRB, 0.17423396E-05_JPRB, &
  & 0.17427951E-05_JPRB, 0.17433450E-05_JPRB, 0.17434881E-05_JPRB, 0.17436237E-05_JPRB, 0.17438443E-05_JPRB, 0.17443513E-05_JPRB, &
  & 0.17452183E-05_JPRB, 0.17459294E-05_JPRB, 0.17470638E-05_JPRB, 0.17488174E-05_JPRB, 0.17501980E-05_JPRB, 0.17509498E-05_JPRB, &
  & 0.17515378E-05_JPRB, 0.17523462E-05_JPRB, 0.17538806E-05_JPRB, 0.17555405E-05_JPRB, 0.17574338E-05_JPRB, 0.17596182E-05_JPRB, &
  & 0.17618763E-05_JPRB, 0.17643580E-05_JPRB, 0.17665750E-05_JPRB, 0.17683544E-05_JPRB, 0.17695750E-05_JPRB, 0.17705748E-05_JPRB, &
  & 0.17714106E-05_JPRB, 0.17723410E-05_JPRB, 0.17731789E-05_JPRB, 0.17735906E-05_JPRB  /)

RGHG2(:,51, 1) = (/ &
  & 0.17173414E-05_JPRB, 0.17166641E-05_JPRB, 0.17166545E-05_JPRB, 0.17165786E-05_JPRB, 0.17168769E-05_JPRB, 0.17172016E-05_JPRB, &
  & 0.17171045E-05_JPRB, 0.17169271E-05_JPRB, 0.17165235E-05_JPRB, 0.17161240E-05_JPRB, 0.17156803E-05_JPRB, 0.17149438E-05_JPRB, &
  & 0.17138212E-05_JPRB, 0.17121687E-05_JPRB, 0.17102455E-05_JPRB, 0.17086364E-05_JPRB, 0.17082851E-05_JPRB, 0.17087131E-05_JPRB, &
  & 0.17096657E-05_JPRB, 0.17110239E-05_JPRB, 0.17132714E-05_JPRB, 0.17163670E-05_JPRB, 0.17190241E-05_JPRB, 0.17204472E-05_JPRB, &
  & 0.17208314E-05_JPRB, 0.17204223E-05_JPRB, 0.17201166E-05_JPRB, 0.17207392E-05_JPRB, 0.17226122E-05_JPRB, 0.17258739E-05_JPRB, &
  & 0.17305922E-05_JPRB, 0.17351197E-05_JPRB, 0.17385656E-05_JPRB, 0.17408085E-05_JPRB, 0.17416810E-05_JPRB, 0.17422159E-05_JPRB, &
  & 0.17426522E-05_JPRB, 0.17432843E-05_JPRB, 0.17435515E-05_JPRB, 0.17437780E-05_JPRB, 0.17440860E-05_JPRB, 0.17448920E-05_JPRB, &
  & 0.17462555E-05_JPRB, 0.17475593E-05_JPRB, 0.17495564E-05_JPRB, 0.17524192E-05_JPRB, 0.17549790E-05_JPRB, 0.17565080E-05_JPRB, &
  & 0.17576361E-05_JPRB, 0.17587068E-05_JPRB, 0.17601119E-05_JPRB, 0.17617831E-05_JPRB, 0.17636449E-05_JPRB, 0.17656414E-05_JPRB, &
  & 0.17675892E-05_JPRB, 0.17694240E-05_JPRB, 0.17711218E-05_JPRB, 0.17726232E-05_JPRB, 0.17736017E-05_JPRB, 0.17743113E-05_JPRB, &
  & 0.17748341E-05_JPRB, 0.17756064E-05_JPRB, 0.17764521E-05_JPRB, 0.17768323E-05_JPRB  /)

RGHG2(:,52, 1) = (/ &
  & 0.17160327E-05_JPRB, 0.17152542E-05_JPRB, 0.17151526E-05_JPRB, 0.17150280E-05_JPRB, 0.17151515E-05_JPRB, 0.17150529E-05_JPRB, &
  & 0.17145889E-05_JPRB, 0.17141242E-05_JPRB, 0.17134783E-05_JPRB, 0.17131461E-05_JPRB, 0.17127340E-05_JPRB, 0.17120045E-05_JPRB, &
  & 0.17108236E-05_JPRB, 0.17091914E-05_JPRB, 0.17074195E-05_JPRB, 0.17061346E-05_JPRB, 0.17060487E-05_JPRB, 0.17066843E-05_JPRB, &
  & 0.17078987E-05_JPRB, 0.17094958E-05_JPRB, 0.17119350E-05_JPRB, 0.17151930E-05_JPRB, 0.17180667E-05_JPRB, 0.17197837E-05_JPRB, &
  & 0.17202975E-05_JPRB, 0.17200074E-05_JPRB, 0.17198691E-05_JPRB, 0.17204822E-05_JPRB, 0.17222970E-05_JPRB, 0.17254937E-05_JPRB, &
  & 0.17303069E-05_JPRB, 0.17348667E-05_JPRB, 0.17383824E-05_JPRB, 0.17405866E-05_JPRB, 0.17415087E-05_JPRB, 0.17420348E-05_JPRB, &
  & 0.17424605E-05_JPRB, 0.17431340E-05_JPRB, 0.17434875E-05_JPRB, 0.17437972E-05_JPRB, 0.17442194E-05_JPRB, 0.17453388E-05_JPRB, &
  & 0.17471667E-05_JPRB, 0.17489701E-05_JPRB, 0.17516706E-05_JPRB, 0.17553595E-05_JPRB, 0.17586621E-05_JPRB, 0.17607913E-05_JPRB, &
  & 0.17621763E-05_JPRB, 0.17633430E-05_JPRB, 0.17646999E-05_JPRB, 0.17664141E-05_JPRB, 0.17682283E-05_JPRB, 0.17700374E-05_JPRB, &
  & 0.17717596E-05_JPRB, 0.17733317E-05_JPRB, 0.17748501E-05_JPRB, 0.17762934E-05_JPRB, 0.17772312E-05_JPRB, 0.17779244E-05_JPRB, &
  & 0.17783506E-05_JPRB, 0.17792004E-05_JPRB, 0.17801821E-05_JPRB, 0.17805072E-05_JPRB  /)

RGHG2(:,53, 1) = (/ &
  & 0.17142841E-05_JPRB, 0.17133433E-05_JPRB, 0.17130969E-05_JPRB, 0.17129198E-05_JPRB, 0.17128468E-05_JPRB, 0.17122510E-05_JPRB, &
  & 0.17113507E-05_JPRB, 0.17105650E-05_JPRB, 0.17096562E-05_JPRB, 0.17094532E-05_JPRB, 0.17091324E-05_JPRB, 0.17084924E-05_JPRB, &
  & 0.17073299E-05_JPRB, 0.17058324E-05_JPRB, 0.17043482E-05_JPRB, 0.17034987E-05_JPRB, 0.17036913E-05_JPRB, 0.17045649E-05_JPRB, &
  & 0.17060432E-05_JPRB, 0.17078736E-05_JPRB, 0.17105037E-05_JPRB, 0.17138955E-05_JPRB, 0.17170257E-05_JPRB, 0.17190700E-05_JPRB, &
  & 0.17197176E-05_JPRB, 0.17195871E-05_JPRB, 0.17196646E-05_JPRB, 0.17202473E-05_JPRB, 0.17220049E-05_JPRB, 0.17251407E-05_JPRB, &
  & 0.17300554E-05_JPRB, 0.17346272E-05_JPRB, 0.17382148E-05_JPRB, 0.17403461E-05_JPRB, 0.17413171E-05_JPRB, 0.17418156E-05_JPRB, &
  & 0.17422329E-05_JPRB, 0.17429360E-05_JPRB, 0.17433688E-05_JPRB, 0.17437661E-05_JPRB, 0.17443230E-05_JPRB, 0.17457892E-05_JPRB, &
  & 0.17481106E-05_JPRB, 0.17504222E-05_JPRB, 0.17538275E-05_JPRB, 0.17583068E-05_JPRB, 0.17622505E-05_JPRB, 0.17649654E-05_JPRB, &
  & 0.17665211E-05_JPRB, 0.17677284E-05_JPRB, 0.17690640E-05_JPRB, 0.17708373E-05_JPRB, 0.17725933E-05_JPRB, 0.17741986E-05_JPRB, &
  & 0.17757077E-05_JPRB, 0.17771414E-05_JPRB, 0.17785953E-05_JPRB, 0.17800598E-05_JPRB, 0.17810308E-05_JPRB, 0.17818117E-05_JPRB, &
  & 0.17822157E-05_JPRB, 0.17832408E-05_JPRB, 0.17844199E-05_JPRB, 0.17846758E-05_JPRB  /)

RGHG2(:,54, 1) = (/ &
  & 0.17119131E-05_JPRB, 0.17106992E-05_JPRB, 0.17102061E-05_JPRB, 0.17099594E-05_JPRB, 0.17097408E-05_JPRB, 0.17088055E-05_JPRB, &
  & 0.17074728E-05_JPRB, 0.17064137E-05_JPRB, 0.17053807E-05_JPRB, 0.17053525E-05_JPRB, 0.17051882E-05_JPRB, 0.17047812E-05_JPRB, &
  & 0.17039065E-05_JPRB, 0.17027337E-05_JPRB, 0.17016686E-05_JPRB, 0.17012878E-05_JPRB, 0.17017746E-05_JPRB, 0.17028953E-05_JPRB, &
  & 0.17045682E-05_JPRB, 0.17065332E-05_JPRB, 0.17092404E-05_JPRB, 0.17126795E-05_JPRB, 0.17159799E-05_JPRB, 0.17182430E-05_JPRB, &
  & 0.17191898E-05_JPRB, 0.17192721E-05_JPRB, 0.17195304E-05_JPRB, 0.17201699E-05_JPRB, 0.17218614E-05_JPRB, 0.17249853E-05_JPRB, &
  & 0.17300355E-05_JPRB, 0.17346149E-05_JPRB, 0.17381138E-05_JPRB, 0.17401237E-05_JPRB, 0.17410722E-05_JPRB, 0.17415409E-05_JPRB, &
  & 0.17420427E-05_JPRB, 0.17427323E-05_JPRB, 0.17431648E-05_JPRB, 0.17436472E-05_JPRB, 0.17443669E-05_JPRB, 0.17460839E-05_JPRB, &
  & 0.17487720E-05_JPRB, 0.17515845E-05_JPRB, 0.17556284E-05_JPRB, 0.17605422E-05_JPRB, 0.17648185E-05_JPRB, 0.17679431E-05_JPRB, &
  & 0.17696574E-05_JPRB, 0.17709409E-05_JPRB, 0.17723564E-05_JPRB, 0.17741976E-05_JPRB, 0.17759585E-05_JPRB, 0.17774971E-05_JPRB, &
  & 0.17789481E-05_JPRB, 0.17804848E-05_JPRB, 0.17820684E-05_JPRB, 0.17835833E-05_JPRB, 0.17846945E-05_JPRB, 0.17856213E-05_JPRB, &
  & 0.17861501E-05_JPRB, 0.17873896E-05_JPRB, 0.17886836E-05_JPRB, 0.17888611E-05_JPRB  /)

RGHG2(:,55, 1) = (/ &
  & 0.17092048E-05_JPRB, 0.17076737E-05_JPRB, 0.17068939E-05_JPRB, 0.17065679E-05_JPRB, 0.17061947E-05_JPRB, 0.17049041E-05_JPRB, &
  & 0.17030929E-05_JPRB, 0.17017372E-05_JPRB, 0.17005848E-05_JPRB, 0.17007563E-05_JPRB, 0.17007740E-05_JPRB, 0.17006440E-05_JPRB, &
  & 0.17001236E-05_JPRB, 0.16993353E-05_JPRB, 0.16987518E-05_JPRB, 0.16988946E-05_JPRB, 0.16997092E-05_JPRB, 0.17011049E-05_JPRB, &
  & 0.17029843E-05_JPRB, 0.17050854E-05_JPRB, 0.17078630E-05_JPRB, 0.17113433E-05_JPRB, 0.17148207E-05_JPRB, 0.17173119E-05_JPRB, &
  & 0.17186120E-05_JPRB, 0.17189370E-05_JPRB, 0.17193911E-05_JPRB, 0.17201050E-05_JPRB, 0.17217221E-05_JPRB, 0.17248391E-05_JPRB, &
  & 0.17300439E-05_JPRB, 0.17346312E-05_JPRB, 0.17380107E-05_JPRB, 0.17398796E-05_JPRB, 0.17407939E-05_JPRB, 0.17412293E-05_JPRB, &
  & 0.17418368E-05_JPRB, 0.17425058E-05_JPRB, 0.17429276E-05_JPRB, 0.17435039E-05_JPRB, 0.17444076E-05_JPRB, 0.17463898E-05_JPRB, &
  & 0.17494674E-05_JPRB, 0.17528339E-05_JPRB, 0.17575766E-05_JPRB, 0.17629249E-05_JPRB, 0.17675291E-05_JPRB, 0.17710843E-05_JPRB, &
  & 0.17729728E-05_JPRB, 0.17743453E-05_JPRB, 0.17758627E-05_JPRB, 0.17777801E-05_JPRB, 0.17795548E-05_JPRB, 0.17810376E-05_JPRB, &
  & 0.17824445E-05_JPRB, 0.17841270E-05_JPRB, 0.17858800E-05_JPRB, 0.17874546E-05_JPRB, 0.17887351E-05_JPRB, 0.17898311E-05_JPRB, &
  & 0.17905175E-05_JPRB, 0.17919998E-05_JPRB, 0.17934103E-05_JPRB, 0.17934997E-05_JPRB  /)

RGHG2(:,56, 1) = (/ &
  & 0.17058922E-05_JPRB, 0.17042723E-05_JPRB, 0.17034164E-05_JPRB, 0.17030094E-05_JPRB, 0.17026095E-05_JPRB, 0.17013310E-05_JPRB, &
  & 0.16993412E-05_JPRB, 0.16979673E-05_JPRB, 0.16969656E-05_JPRB, 0.16971946E-05_JPRB, 0.16973046E-05_JPRB, 0.16973699E-05_JPRB, &
  & 0.16971469E-05_JPRB, 0.16967055E-05_JPRB, 0.16964672E-05_JPRB, 0.16969542E-05_JPRB, 0.16981103E-05_JPRB, 0.16997527E-05_JPRB, &
  & 0.17018811E-05_JPRB, 0.17040153E-05_JPRB, 0.17068281E-05_JPRB, 0.17103074E-05_JPRB, 0.17138118E-05_JPRB, 0.17164009E-05_JPRB, &
  & 0.17180780E-05_JPRB, 0.17186182E-05_JPRB, 0.17191419E-05_JPRB, 0.17200188E-05_JPRB, 0.17217341E-05_JPRB, 0.17248708E-05_JPRB, &
  & 0.17300991E-05_JPRB, 0.17348786E-05_JPRB, 0.17379492E-05_JPRB, 0.17395568E-05_JPRB, 0.17404847E-05_JPRB, 0.17410559E-05_JPRB, &
  & 0.17417505E-05_JPRB, 0.17422456E-05_JPRB, 0.17426310E-05_JPRB, 0.17433022E-05_JPRB, 0.17444003E-05_JPRB, 0.17465510E-05_JPRB, &
  & 0.17500324E-05_JPRB, 0.17539200E-05_JPRB, 0.17591500E-05_JPRB, 0.17645789E-05_JPRB, 0.17693051E-05_JPRB, 0.17731942E-05_JPRB, &
  & 0.17753117E-05_JPRB, 0.17768674E-05_JPRB, 0.17785194E-05_JPRB, 0.17805234E-05_JPRB, 0.17823956E-05_JPRB, 0.17839951E-05_JPRB, &
  & 0.17855371E-05_JPRB, 0.17873445E-05_JPRB, 0.17892278E-05_JPRB, 0.17908180E-05_JPRB, 0.17921368E-05_JPRB, 0.17931836E-05_JPRB, &
  & 0.17940373E-05_JPRB, 0.17956021E-05_JPRB, 0.17969437E-05_JPRB, 0.17970055E-05_JPRB  /)

RGHG2(:,57, 1) = (/ &
  & 0.17024582E-05_JPRB, 0.17008020E-05_JPRB, 0.16999242E-05_JPRB, 0.16994576E-05_JPRB, 0.16990565E-05_JPRB, 0.16978154E-05_JPRB, &
  & 0.16957166E-05_JPRB, 0.16943613E-05_JPRB, 0.16935231E-05_JPRB, 0.16937857E-05_JPRB, 0.16939887E-05_JPRB, 0.16942142E-05_JPRB, &
  & 0.16942393E-05_JPRB, 0.16940900E-05_JPRB, 0.16941664E-05_JPRB, 0.16949720E-05_JPRB, 0.16964230E-05_JPRB, 0.16983176E-05_JPRB, &
  & 0.17007128E-05_JPRB, 0.17028992E-05_JPRB, 0.17057147E-05_JPRB, 0.17091625E-05_JPRB, 0.17126929E-05_JPRB, 0.17153995E-05_JPRB, &
  & 0.17174420E-05_JPRB, 0.17182341E-05_JPRB, 0.17188435E-05_JPRB, 0.17198738E-05_JPRB, 0.17217239E-05_JPRB, 0.17249018E-05_JPRB, &
  & 0.17301380E-05_JPRB, 0.17351328E-05_JPRB, 0.17379017E-05_JPRB, 0.17393008E-05_JPRB, 0.17402338E-05_JPRB, 0.17408663E-05_JPRB, &
  & 0.17415699E-05_JPRB, 0.17419645E-05_JPRB, 0.17423178E-05_JPRB, 0.17430804E-05_JPRB, 0.17443529E-05_JPRB, 0.17467260E-05_JPRB, &
  & 0.17506505E-05_JPRB, 0.17551178E-05_JPRB, 0.17607432E-05_JPRB, 0.17662828E-05_JPRB, 0.17711877E-05_JPRB, 0.17753848E-05_JPRB, &
  & 0.17777425E-05_JPRB, 0.17795070E-05_JPRB, 0.17813002E-05_JPRB, 0.17834067E-05_JPRB, 0.17853812E-05_JPRB, 0.17870960E-05_JPRB, &
  & 0.17887905E-05_JPRB, 0.17907076E-05_JPRB, 0.17926769E-05_JPRB, 0.17942530E-05_JPRB, 0.17955703E-05_JPRB, 0.17965837E-05_JPRB, &
  & 0.17975685E-05_JPRB, 0.17991515E-05_JPRB, 0.18003948E-05_JPRB, 0.18004554E-05_JPRB  /)

RGHG2(:,58, 1) = (/ &
  & 0.16989818E-05_JPRB, 0.16974242E-05_JPRB, 0.16966571E-05_JPRB, 0.16961711E-05_JPRB, 0.16958361E-05_JPRB, 0.16947413E-05_JPRB, &
  & 0.16927156E-05_JPRB, 0.16914924E-05_JPRB, 0.16908767E-05_JPRB, 0.16911027E-05_JPRB, 0.16913758E-05_JPRB, 0.16916745E-05_JPRB, &
  & 0.16918336E-05_JPRB, 0.16918529E-05_JPRB, 0.16921417E-05_JPRB, 0.16931637E-05_JPRB, 0.16948097E-05_JPRB, 0.16969400E-05_JPRB, &
  & 0.16996186E-05_JPRB, 0.17018660E-05_JPRB, 0.17046225E-05_JPRB, 0.17079819E-05_JPRB, 0.17115062E-05_JPRB, 0.17143297E-05_JPRB, &
  & 0.17166932E-05_JPRB, 0.17177738E-05_JPRB, 0.17184655E-05_JPRB, 0.17196370E-05_JPRB, 0.17217055E-05_JPRB, 0.17249626E-05_JPRB, &
  & 0.17301552E-05_JPRB, 0.17354212E-05_JPRB, 0.17378893E-05_JPRB, 0.17391635E-05_JPRB, 0.17400955E-05_JPRB, 0.17406904E-05_JPRB, &
  & 0.17412671E-05_JPRB, 0.17416647E-05_JPRB, 0.17419906E-05_JPRB, 0.17428314E-05_JPRB, 0.17442329E-05_JPRB, 0.17468834E-05_JPRB, &
  & 0.17512842E-05_JPRB, 0.17563773E-05_JPRB, 0.17621714E-05_JPRB, 0.17677973E-05_JPRB, 0.17729237E-05_JPRB, 0.17773422E-05_JPRB, &
  & 0.17799498E-05_JPRB, 0.17819673E-05_JPRB, 0.17839078E-05_JPRB, 0.17861372E-05_JPRB, 0.17882295E-05_JPRB, 0.17900805E-05_JPRB, &
  & 0.17919781E-05_JPRB, 0.17939663E-05_JPRB, 0.17959326E-05_JPRB, 0.17974376E-05_JPRB, 0.17986615E-05_JPRB, 0.17996301E-05_JPRB, &
  & 0.18006758E-05_JPRB, 0.18021369E-05_JPRB, 0.18032056E-05_JPRB, 0.18033210E-05_JPRB  /)

RGHG2(:,59, 1) = (/ &
  & 0.16960186E-05_JPRB, 0.16946027E-05_JPRB, 0.16939865E-05_JPRB, 0.16935416E-05_JPRB, 0.16932822E-05_JPRB, 0.16923656E-05_JPRB, &
  & 0.16905149E-05_JPRB, 0.16894950E-05_JPRB, 0.16890440E-05_JPRB, 0.16892234E-05_JPRB, 0.16895116E-05_JPRB, 0.16898403E-05_JPRB, &
  & 0.16900155E-05_JPRB, 0.16900842E-05_JPRB, 0.16904706E-05_JPRB, 0.16915692E-05_JPRB, 0.16932536E-05_JPRB, 0.16955138E-05_JPRB, &
  & 0.16984505E-05_JPRB, 0.17007754E-05_JPRB, 0.17034502E-05_JPRB, 0.17066120E-05_JPRB, 0.17101585E-05_JPRB, 0.17131721E-05_JPRB, &
  & 0.17156969E-05_JPRB, 0.17170589E-05_JPRB, 0.17178962E-05_JPRB, 0.17192873E-05_JPRB, 0.17215432E-05_JPRB, 0.17249674E-05_JPRB, &
  & 0.17301969E-05_JPRB, 0.17355288E-05_JPRB, 0.17379493E-05_JPRB, 0.17390298E-05_JPRB, 0.17398559E-05_JPRB, 0.17403930E-05_JPRB, &
  & 0.17409380E-05_JPRB, 0.17413931E-05_JPRB, 0.17417314E-05_JPRB, 0.17425939E-05_JPRB, 0.17440529E-05_JPRB, 0.17470624E-05_JPRB, &
  & 0.17519737E-05_JPRB, 0.17576221E-05_JPRB, 0.17634372E-05_JPRB, 0.17692287E-05_JPRB, 0.17745606E-05_JPRB, 0.17791278E-05_JPRB, &
  & 0.17819886E-05_JPRB, 0.17842238E-05_JPRB, 0.17862907E-05_JPRB, 0.17886045E-05_JPRB, 0.17907879E-05_JPRB, 0.17927878E-05_JPRB, &
  & 0.17948219E-05_JPRB, 0.17968443E-05_JPRB, 0.17987831E-05_JPRB, 0.18001451E-05_JPRB, 0.18012774E-05_JPRB, 0.18022008E-05_JPRB, &
  & 0.18032325E-05_JPRB, 0.18044644E-05_JPRB, 0.18053039E-05_JPRB, 0.18054797E-05_JPRB  /)

RGHG2(:,60, 1) = (/ &
  & 0.16932845E-05_JPRB, 0.16920245E-05_JPRB, 0.16915671E-05_JPRB, 0.16911885E-05_JPRB, 0.16910032E-05_JPRB, 0.16902726E-05_JPRB, &
  & 0.16886431E-05_JPRB, 0.16878544E-05_JPRB, 0.16875391E-05_JPRB, 0.16876613E-05_JPRB, 0.16879343E-05_JPRB, 0.16882762E-05_JPRB, &
  & 0.16884267E-05_JPRB, 0.16884918E-05_JPRB, 0.16889266E-05_JPRB, 0.16900311E-05_JPRB, 0.16916796E-05_JPRB, 0.16940058E-05_JPRB, &
  & 0.16971634E-05_JPRB, 0.16995793E-05_JPRB, 0.17021695E-05_JPRB, 0.17050829E-05_JPRB, 0.17086341E-05_JPRB, 0.17118678E-05_JPRB, &
  & 0.17145161E-05_JPRB, 0.17161557E-05_JPRB, 0.17171834E-05_JPRB, 0.17188462E-05_JPRB, 0.17212805E-05_JPRB, 0.17249468E-05_JPRB, &
  & 0.17302886E-05_JPRB, 0.17355900E-05_JPRB, 0.17380144E-05_JPRB, 0.17388704E-05_JPRB, 0.17395556E-05_JPRB, 0.17400343E-05_JPRB, &
  & 0.17405775E-05_JPRB, 0.17411056E-05_JPRB, 0.17414662E-05_JPRB, 0.17423227E-05_JPRB, 0.17438332E-05_JPRB, 0.17472767E-05_JPRB, &
  & 0.17527446E-05_JPRB, 0.17589016E-05_JPRB, 0.17646904E-05_JPRB, 0.17706840E-05_JPRB, 0.17762193E-05_JPRB, 0.17809131E-05_JPRB, &
  & 0.17840309E-05_JPRB, 0.17864614E-05_JPRB, 0.17886443E-05_JPRB, 0.17910279E-05_JPRB, 0.17932938E-05_JPRB, 0.17954457E-05_JPRB, &
  & 0.17975834E-05_JPRB, 0.17996283E-05_JPRB, 0.18015316E-05_JPRB, 0.18027295E-05_JPRB, 0.18037685E-05_JPRB, 0.18046461E-05_JPRB, &
  & 0.18056215E-05_JPRB, 0.18065971E-05_JPRB, 0.18071824E-05_JPRB, 0.18073891E-05_JPRB  /)

RGHG2(:,61, 1) = (/ &
  & 0.16912745E-05_JPRB, 0.16901488E-05_JPRB, 0.16898059E-05_JPRB, 0.16895089E-05_JPRB, 0.16893676E-05_JPRB, 0.16887846E-05_JPRB, &
  & 0.16873997E-05_JPRB, 0.16868291E-05_JPRB, 0.16865820E-05_JPRB, 0.16866249E-05_JPRB, 0.16868318E-05_JPRB, 0.16871715E-05_JPRB, &
  & 0.16872845E-05_JPRB, 0.16872814E-05_JPRB, 0.16877007E-05_JPRB, 0.16886995E-05_JPRB, 0.16902137E-05_JPRB, 0.16924671E-05_JPRB, &
  & 0.16956908E-05_JPRB, 0.16982169E-05_JPRB, 0.17007543E-05_JPRB, 0.17033901E-05_JPRB, 0.17068377E-05_JPRB, 0.17102851E-05_JPRB, &
  & 0.17130854E-05_JPRB, 0.17149518E-05_JPRB, 0.17162417E-05_JPRB, 0.17182460E-05_JPRB, 0.17208323E-05_JPRB, 0.17248973E-05_JPRB, &
  & 0.17305387E-05_JPRB, 0.17356815E-05_JPRB, 0.17379979E-05_JPRB, 0.17386271E-05_JPRB, 0.17391845E-05_JPRB, 0.17396367E-05_JPRB, &
  & 0.17401799E-05_JPRB, 0.17407631E-05_JPRB, 0.17411326E-05_JPRB, 0.17419428E-05_JPRB, 0.17435635E-05_JPRB, 0.17475731E-05_JPRB, &
  & 0.17536533E-05_JPRB, 0.17601364E-05_JPRB, 0.17658965E-05_JPRB, 0.17721082E-05_JPRB, 0.17778264E-05_JPRB, 0.17826281E-05_JPRB, &
  & 0.17859729E-05_JPRB, 0.17885200E-05_JPRB, 0.17907845E-05_JPRB, 0.17932166E-05_JPRB, 0.17955507E-05_JPRB, 0.17978260E-05_JPRB, &
  & 0.18000012E-05_JPRB, 0.18020637E-05_JPRB, 0.18039361E-05_JPRB, 0.18050019E-05_JPRB, 0.18059527E-05_JPRB, 0.18067907E-05_JPRB, &
  & 0.18076405E-05_JPRB, 0.18084267E-05_JPRB, 0.18087653E-05_JPRB, 0.18088706E-05_JPRB  /)

RGHG2(:,62, 1) = (/ &
  & 0.16896951E-05_JPRB, 0.16887015E-05_JPRB, 0.16884442E-05_JPRB, 0.16882150E-05_JPRB, 0.16880997E-05_JPRB, 0.16876331E-05_JPRB, &
  & 0.16864923E-05_JPRB, 0.16861043E-05_JPRB, 0.16858723E-05_JPRB, 0.16858349E-05_JPRB, 0.16859574E-05_JPRB, 0.16862704E-05_JPRB, &
  & 0.16863431E-05_JPRB, 0.16862825E-05_JPRB, 0.16866485E-05_JPRB, 0.16874941E-05_JPRB, 0.16888321E-05_JPRB, 0.16909241E-05_JPRB, &
  & 0.16940399E-05_JPRB, 0.16966486E-05_JPRB, 0.16991200E-05_JPRB, 0.17015053E-05_JPRB, 0.17047776E-05_JPRB, 0.17083802E-05_JPRB, &
  & 0.17112950E-05_JPRB, 0.17134070E-05_JPRB, 0.17150636E-05_JPRB, 0.17173762E-05_JPRB, 0.17201992E-05_JPRB, 0.17246300E-05_JPRB, &
  & 0.17307779E-05_JPRB, 0.17359495E-05_JPRB, 0.17380843E-05_JPRB, 0.17384957E-05_JPRB, 0.17389017E-05_JPRB, 0.17391994E-05_JPRB, &
  & 0.17396774E-05_JPRB, 0.17402424E-05_JPRB, 0.17406389E-05_JPRB, 0.17414536E-05_JPRB, 0.17433836E-05_JPRB, 0.17479856E-05_JPRB, &
  & 0.17546651E-05_JPRB, 0.17613069E-05_JPRB, 0.17671712E-05_JPRB, 0.17735573E-05_JPRB, 0.17794365E-05_JPRB, 0.17842974E-05_JPRB, &
  & 0.17878355E-05_JPRB, 0.17904820E-05_JPRB, 0.17928126E-05_JPRB, 0.17953077E-05_JPRB, 0.17977303E-05_JPRB, 0.18000872E-05_JPRB, &
  & 0.18022814E-05_JPRB, 0.18043588E-05_JPRB, 0.18061587E-05_JPRB, 0.18071452E-05_JPRB, 0.18080328E-05_JPRB, 0.18088706E-05_JPRB, &
  & 0.18095387E-05_JPRB, 0.18101881E-05_JPRB, 0.18103732E-05_JPRB, 0.18102646E-05_JPRB  /)

RGHG2(:,63, 1) = (/ &
  & 0.16884145E-05_JPRB, 0.16875422E-05_JPRB, 0.16873492E-05_JPRB, 0.16871760E-05_JPRB, 0.16870760E-05_JPRB, 0.16867080E-05_JPRB, &
  & 0.16858026E-05_JPRB, 0.16855652E-05_JPRB, 0.16853170E-05_JPRB, 0.16852041E-05_JPRB, 0.16852322E-05_JPRB, 0.16855011E-05_JPRB, &
  & 0.16855223E-05_JPRB, 0.16854040E-05_JPRB, 0.16856866E-05_JPRB, 0.16863455E-05_JPRB, 0.16874790E-05_JPRB, 0.16893590E-05_JPRB, &
  & 0.16922329E-05_JPRB, 0.16948798E-05_JPRB, 0.16972488E-05_JPRB, 0.16994285E-05_JPRB, 0.17025271E-05_JPRB, 0.17062307E-05_JPRB, &
  & 0.17092525E-05_JPRB, 0.17115864E-05_JPRB, 0.17136518E-05_JPRB, 0.17162573E-05_JPRB, 0.17193999E-05_JPRB, 0.17241582E-05_JPRB, &
  & 0.17309033E-05_JPRB, 0.17362944E-05_JPRB, 0.17382325E-05_JPRB, 0.17384272E-05_JPRB, 0.17387260E-05_JPRB, 0.17387876E-05_JPRB, &
  & 0.17391482E-05_JPRB, 0.17396336E-05_JPRB, 0.17400711E-05_JPRB, 0.17409787E-05_JPRB, 0.17433349E-05_JPRB, 0.17485237E-05_JPRB, &
  & 0.17557777E-05_JPRB, 0.17624829E-05_JPRB, 0.17685337E-05_JPRB, 0.17750587E-05_JPRB, 0.17810670E-05_JPRB, 0.17859444E-05_JPRB, &
  & 0.17896567E-05_JPRB, 0.17924122E-05_JPRB, 0.17947951E-05_JPRB, 0.17973624E-05_JPRB, 0.17998777E-05_JPRB, 0.18023014E-05_JPRB, &
  & 0.18044963E-05_JPRB, 0.18065858E-05_JPRB, 0.18082797E-05_JPRB, 0.18092162E-05_JPRB, 0.18100566E-05_JPRB, 0.18109151E-05_JPRB, &
  & 0.18113774E-05_JPRB, 0.18119248E-05_JPRB, 0.18120527E-05_JPRB, 0.18116985E-05_JPRB  /)

RGHG2(:,64, 1) = (/ &
  & 0.16874870E-05_JPRB, 0.16867063E-05_JPRB, 0.16865519E-05_JPRB, 0.16864172E-05_JPRB, 0.16863245E-05_JPRB, 0.16860383E-05_JPRB, &
  & 0.16853378E-05_JPRB, 0.16852016E-05_JPRB, 0.16849148E-05_JPRB, 0.16847417E-05_JPRB, 0.16846733E-05_JPRB, 0.16848821E-05_JPRB, &
  & 0.16848286E-05_JPRB, 0.16846428E-05_JPRB, 0.16848097E-05_JPRB, 0.16852542E-05_JPRB, 0.16861637E-05_JPRB, 0.16878052E-05_JPRB, &
  & 0.16902911E-05_JPRB, 0.16928923E-05_JPRB, 0.16950854E-05_JPRB, 0.16971518E-05_JPRB, 0.17001613E-05_JPRB, 0.17038866E-05_JPRB, &
  & 0.17070312E-05_JPRB, 0.17095000E-05_JPRB, 0.17119558E-05_JPRB, 0.17148383E-05_JPRB, 0.17184074E-05_JPRB, 0.17234187E-05_JPRB, &
  & 0.17307517E-05_JPRB, 0.17366367E-05_JPRB, 0.17384229E-05_JPRB, 0.17384032E-05_JPRB, 0.17387333E-05_JPRB, 0.17384962E-05_JPRB, &
  & 0.17386809E-05_JPRB, 0.17390121E-05_JPRB, 0.17395050E-05_JPRB, 0.17406705E-05_JPRB, 0.17435230E-05_JPRB, 0.17492346E-05_JPRB, &
  & 0.17569922E-05_JPRB, 0.17636925E-05_JPRB, 0.17699915E-05_JPRB, 0.17766056E-05_JPRB, 0.17826814E-05_JPRB, 0.17875178E-05_JPRB, &
  & 0.17913844E-05_JPRB, 0.17942868E-05_JPRB, 0.17967010E-05_JPRB, 0.17993454E-05_JPRB, 0.18019403E-05_JPRB, 0.18044338E-05_JPRB, &
  & 0.18066022E-05_JPRB, 0.18086989E-05_JPRB, 0.18102507E-05_JPRB, 0.18111583E-05_JPRB, 0.18119673E-05_JPRB, 0.18128572E-05_JPRB, &
  & 0.18131195E-05_JPRB, 0.18136019E-05_JPRB, 0.18138189E-05_JPRB, 0.18132647E-05_JPRB  /)

RGHG2(:,65, 1) = (/ &
  & 0.16868756E-05_JPRB, 0.16861691E-05_JPRB, 0.16860311E-05_JPRB, 0.16859107E-05_JPRB, 0.16858230E-05_JPRB, 0.16855947E-05_JPRB, &
  & 0.16850579E-05_JPRB, 0.16849788E-05_JPRB, 0.16846913E-05_JPRB, 0.16844597E-05_JPRB, 0.16842988E-05_JPRB, 0.16844020E-05_JPRB, &
  & 0.16842597E-05_JPRB, 0.16839858E-05_JPRB, 0.16840026E-05_JPRB, 0.16842333E-05_JPRB, 0.16849237E-05_JPRB, 0.16862755E-05_JPRB, &
  & 0.16883728E-05_JPRB, 0.16907417E-05_JPRB, 0.16927576E-05_JPRB, 0.16948377E-05_JPRB, 0.16977753E-05_JPRB, 0.17015158E-05_JPRB, &
  & 0.17048156E-05_JPRB, 0.17073957E-05_JPRB, 0.17099554E-05_JPRB, 0.17131575E-05_JPRB, 0.17172056E-05_JPRB, 0.17225683E-05_JPRB, &
  & 0.17301819E-05_JPRB, 0.17366072E-05_JPRB, 0.17385320E-05_JPRB, 0.17384824E-05_JPRB, 0.17390504E-05_JPRB, 0.17383507E-05_JPRB, &
  & 0.17381990E-05_JPRB, 0.17384556E-05_JPRB, 0.17391232E-05_JPRB, 0.17406358E-05_JPRB, 0.17440872E-05_JPRB, 0.17503233E-05_JPRB, &
  & 0.17584067E-05_JPRB, 0.17651762E-05_JPRB, 0.17715906E-05_JPRB, 0.17782026E-05_JPRB, 0.17842679E-05_JPRB, 0.17890204E-05_JPRB, &
  & 0.17930311E-05_JPRB, 0.17960951E-05_JPRB, 0.17985162E-05_JPRB, 0.18012630E-05_JPRB, 0.18038976E-05_JPRB, 0.18064503E-05_JPRB, &
  & 0.18085562E-05_JPRB, 0.18106422E-05_JPRB, 0.18120731E-05_JPRB, 0.18129696E-05_JPRB, 0.18137897E-05_JPRB, 0.18146415E-05_JPRB, &
  & 0.18147988E-05_JPRB, 0.18153075E-05_JPRB, 0.18157175E-05_JPRB, 0.18150426E-05_JPRB  /)

RGHG2(:,66, 1) = (/ &
  & 0.16864158E-05_JPRB, 0.16857847E-05_JPRB, 0.16856685E-05_JPRB, 0.16855604E-05_JPRB, 0.16854663E-05_JPRB, 0.16852791E-05_JPRB, &
  & 0.16848766E-05_JPRB, 0.16848503E-05_JPRB, 0.16845836E-05_JPRB, 0.16842873E-05_JPRB, 0.16840327E-05_JPRB, 0.16840025E-05_JPRB, &
  & 0.16837678E-05_JPRB, 0.16833957E-05_JPRB, 0.16832488E-05_JPRB, 0.16832444E-05_JPRB, 0.16837273E-05_JPRB, 0.16847910E-05_JPRB, &
  & 0.16865367E-05_JPRB, 0.16885796E-05_JPRB, 0.16904566E-05_JPRB, 0.16925770E-05_JPRB, 0.16954545E-05_JPRB, 0.16992464E-05_JPRB, &
  & 0.17025905E-05_JPRB, 0.17052135E-05_JPRB, 0.17078334E-05_JPRB, 0.17113093E-05_JPRB, 0.17158150E-05_JPRB, 0.17216720E-05_JPRB, &
  & 0.17295231E-05_JPRB, 0.17362132E-05_JPRB, 0.17385432E-05_JPRB, 0.17386059E-05_JPRB, 0.17392587E-05_JPRB, 0.17381400E-05_JPRB, &
  & 0.17375404E-05_JPRB, 0.17377831E-05_JPRB, 0.17388300E-05_JPRB, 0.17407983E-05_JPRB, 0.17449486E-05_JPRB, 0.17517195E-05_JPRB, &
  & 0.17600064E-05_JPRB, 0.17668565E-05_JPRB, 0.17732978E-05_JPRB, 0.17798349E-05_JPRB, 0.17858590E-05_JPRB, 0.17905398E-05_JPRB, &
  & 0.17947113E-05_JPRB, 0.17978937E-05_JPRB, 0.18003154E-05_JPRB, 0.18031752E-05_JPRB, 0.18058241E-05_JPRB, 0.18083879E-05_JPRB, &
  & 0.18104301E-05_JPRB, 0.18125038E-05_JPRB, 0.18138353E-05_JPRB, 0.18147445E-05_JPRB, 0.18155878E-05_JPRB, 0.18163798E-05_JPRB, &
  & 0.18165092E-05_JPRB, 0.18171075E-05_JPRB, 0.18177177E-05_JPRB, 0.18169171E-05_JPRB  /)

RGHG2(:,67, 1) = (/ &
  & 0.16860735E-05_JPRB, 0.16855256E-05_JPRB, 0.16854469E-05_JPRB, 0.16853535E-05_JPRB, 0.16852481E-05_JPRB, 0.16850871E-05_JPRB, &
  & 0.16847943E-05_JPRB, 0.16848140E-05_JPRB, 0.16845856E-05_JPRB, 0.16842199E-05_JPRB, 0.16838749E-05_JPRB, 0.16836948E-05_JPRB, &
  & 0.16833624E-05_JPRB, 0.16828856E-05_JPRB, 0.16825691E-05_JPRB, 0.16823158E-05_JPRB, 0.16826078E-05_JPRB, 0.16834101E-05_JPRB, &
  & 0.16848428E-05_JPRB, 0.16865108E-05_JPRB, 0.16882712E-05_JPRB, 0.16904327E-05_JPRB, 0.16932833E-05_JPRB, 0.16971109E-05_JPRB, &
  & 0.17003878E-05_JPRB, 0.17029856E-05_JPRB, 0.17056738E-05_JPRB, 0.17093713E-05_JPRB, 0.17142901E-05_JPRB, 0.17207528E-05_JPRB, &
  & 0.17288941E-05_JPRB, 0.17355999E-05_JPRB, 0.17384756E-05_JPRB, 0.17387403E-05_JPRB, 0.17392847E-05_JPRB, 0.17378046E-05_JPRB, &
  & 0.17367727E-05_JPRB, 0.17370701E-05_JPRB, 0.17386580E-05_JPRB, 0.17411932E-05_JPRB, 0.17461075E-05_JPRB, 0.17533908E-05_JPRB, &
  & 0.17618038E-05_JPRB, 0.17686892E-05_JPRB, 0.17750804E-05_JPRB, 0.17814991E-05_JPRB, 0.17874530E-05_JPRB, 0.17921071E-05_JPRB, &
  & 0.17964365E-05_JPRB, 0.17996852E-05_JPRB, 0.18021110E-05_JPRB, 0.18050759E-05_JPRB, 0.18077027E-05_JPRB, 0.18102310E-05_JPRB, &
  & 0.18122184E-05_JPRB, 0.18142827E-05_JPRB, 0.18155413E-05_JPRB, 0.18164933E-05_JPRB, 0.18173694E-05_JPRB, 0.18181021E-05_JPRB, &
  & 0.18182753E-05_JPRB, 0.18190234E-05_JPRB, 0.18198048E-05_JPRB, 0.18188681E-05_JPRB  /)

RGHG2(:,68, 1) = (/ &
  & 0.16857948E-05_JPRB, 0.16853509E-05_JPRB, 0.16853414E-05_JPRB, 0.16852703E-05_JPRB, 0.16851649E-05_JPRB, 0.16850187E-05_JPRB, &
  & 0.16848224E-05_JPRB, 0.16848694E-05_JPRB, 0.16846904E-05_JPRB, 0.16842555E-05_JPRB, 0.16838313E-05_JPRB, 0.16835052E-05_JPRB, &
  & 0.16830639E-05_JPRB, 0.16824808E-05_JPRB, 0.16819986E-05_JPRB, 0.16815003E-05_JPRB, 0.16816241E-05_JPRB, 0.16822309E-05_JPRB, &
  & 0.16833791E-05_JPRB, 0.16847008E-05_JPRB, 0.16863201E-05_JPRB, 0.16884891E-05_JPRB, 0.16913916E-05_JPRB, 0.16951178E-05_JPRB, &
  & 0.16982488E-05_JPRB, 0.17007649E-05_JPRB, 0.17035966E-05_JPRB, 0.17074723E-05_JPRB, 0.17127325E-05_JPRB, 0.17198359E-05_JPRB, &
  & 0.17284794E-05_JPRB, 0.17350862E-05_JPRB, 0.17383775E-05_JPRB, 0.17388254E-05_JPRB, 0.17390605E-05_JPRB, 0.17372588E-05_JPRB, &
  & 0.17360711E-05_JPRB, 0.17365095E-05_JPRB, 0.17386887E-05_JPRB, 0.17419066E-05_JPRB, 0.17475804E-05_JPRB, 0.17552892E-05_JPRB, &
  & 0.17638433E-05_JPRB, 0.17706099E-05_JPRB, 0.17768947E-05_JPRB, 0.17832120E-05_JPRB, 0.17890620E-05_JPRB, 0.17937928E-05_JPRB, &
  & 0.17982310E-05_JPRB, 0.18014896E-05_JPRB, 0.18039402E-05_JPRB, 0.18069669E-05_JPRB, 0.18095096E-05_JPRB, 0.18119686E-05_JPRB, &
  & 0.18139239E-05_JPRB, 0.18159882E-05_JPRB, 0.18172097E-05_JPRB, 0.18182458E-05_JPRB, 0.18191639E-05_JPRB, 0.18198769E-05_JPRB, &
  & 0.18201540E-05_JPRB, 0.18211099E-05_JPRB, 0.18219779E-05_JPRB, 0.18208977E-05_JPRB  /)

RGHG2(:,69, 1) = (/ &
  & 0.16855322E-05_JPRB, 0.16852417E-05_JPRB, 0.16853239E-05_JPRB, 0.16852863E-05_JPRB, 0.16851967E-05_JPRB, 0.16850586E-05_JPRB, &
  & 0.16849565E-05_JPRB, 0.16850014E-05_JPRB, 0.16848719E-05_JPRB, 0.16843880E-05_JPRB, 0.16839049E-05_JPRB, 0.16834577E-05_JPRB, &
  & 0.16829188E-05_JPRB, 0.16822339E-05_JPRB, 0.16815904E-05_JPRB, 0.16808968E-05_JPRB, 0.16808501E-05_JPRB, 0.16812953E-05_JPRB, &
  & 0.16821726E-05_JPRB, 0.16832020E-05_JPRB, 0.16845970E-05_JPRB, 0.16866699E-05_JPRB, 0.16896108E-05_JPRB, 0.16931568E-05_JPRB, &
  & 0.16962274E-05_JPRB, 0.16987834E-05_JPRB, 0.17017091E-05_JPRB, 0.17058056E-05_JPRB, 0.17114680E-05_JPRB, 0.17192413E-05_JPRB, &
  & 0.17284297E-05_JPRB, 0.17350952E-05_JPRB, 0.17383855E-05_JPRB, 0.17387754E-05_JPRB, 0.17389738E-05_JPRB, 0.17370352E-05_JPRB, &
  & 0.17357277E-05_JPRB, 0.17363588E-05_JPRB, 0.17389851E-05_JPRB, 0.17429871E-05_JPRB, 0.17492919E-05_JPRB, 0.17574239E-05_JPRB, &
  & 0.17661910E-05_JPRB, 0.17726858E-05_JPRB, 0.17788237E-05_JPRB, 0.17850013E-05_JPRB, 0.17907113E-05_JPRB, 0.17956089E-05_JPRB, &
  & 0.18000907E-05_JPRB, 0.18033456E-05_JPRB, 0.18058705E-05_JPRB, 0.18088712E-05_JPRB, 0.18112758E-05_JPRB, 0.18136430E-05_JPRB, &
  & 0.18155977E-05_JPRB, 0.18176417E-05_JPRB, 0.18189162E-05_JPRB, 0.18200612E-05_JPRB, 0.18210754E-05_JPRB, 0.18219013E-05_JPRB, &
  & 0.18222688E-05_JPRB, 0.18234010E-05_JPRB, 0.18242565E-05_JPRB, 0.18230306E-05_JPRB  /)

RGHG2(:,70, 1) = (/ &
  & 0.16853173E-05_JPRB, 0.16852013E-05_JPRB, 0.16853734E-05_JPRB, 0.16853734E-05_JPRB, 0.16853040E-05_JPRB, 0.16851733E-05_JPRB, &
  & 0.16851625E-05_JPRB, 0.16851881E-05_JPRB, 0.16851010E-05_JPRB, 0.16845815E-05_JPRB, 0.16840557E-05_JPRB, 0.16835011E-05_JPRB, &
  & 0.16828972E-05_JPRB, 0.16821193E-05_JPRB, 0.16813132E-05_JPRB, 0.16804446E-05_JPRB, 0.16802082E-05_JPRB, 0.16804891E-05_JPRB, &
  & 0.16810904E-05_JPRB, 0.16818568E-05_JPRB, 0.16829930E-05_JPRB, 0.16849219E-05_JPRB, 0.16877907E-05_JPRB, 0.16911699E-05_JPRB, &
  & 0.16942215E-05_JPRB, 0.16969101E-05_JPRB, 0.16999408E-05_JPRB, 0.17042830E-05_JPRB, 0.17103830E-05_JPRB, 0.17188880E-05_JPRB, &
  & 0.17286180E-05_JPRB, 0.17354182E-05_JPRB, 0.17384910E-05_JPRB, 0.17387186E-05_JPRB, 0.17389891E-05_JPRB, 0.17370939E-05_JPRB, &
  & 0.17357619E-05_JPRB, 0.17365914E-05_JPRB, 0.17395795E-05_JPRB, 0.17443799E-05_JPRB, 0.17512511E-05_JPRB, 0.17597839E-05_JPRB, &
  & 0.17687270E-05_JPRB, 0.17749171E-05_JPRB, 0.17808520E-05_JPRB, 0.17868571E-05_JPRB, 0.17924277E-05_JPRB, 0.17974769E-05_JPRB, &
  & 0.18019901E-05_JPRB, 0.18052515E-05_JPRB, 0.18078845E-05_JPRB, 0.18107815E-05_JPRB, 0.18130495E-05_JPRB, 0.18153139E-05_JPRB, &
  & 0.18172667E-05_JPRB, 0.18192899E-05_JPRB, 0.18206695E-05_JPRB, 0.18219605E-05_JPRB, 0.18231051E-05_JPRB, 0.18241063E-05_JPRB, &
  & 0.18246047E-05_JPRB, 0.18258112E-05_JPRB, 0.18265955E-05_JPRB, 0.18251975E-05_JPRB  /)

RGHG2(:,71, 1) = (/ &
  & 0.16851643E-05_JPRB, 0.16852291E-05_JPRB, 0.16854817E-05_JPRB, 0.16855188E-05_JPRB, 0.16854693E-05_JPRB, 0.16853554E-05_JPRB, &
  & 0.16854282E-05_JPRB, 0.16854234E-05_JPRB, 0.16853685E-05_JPRB, 0.16848292E-05_JPRB, 0.16842731E-05_JPRB, 0.16836287E-05_JPRB, &
  & 0.16829858E-05_JPRB, 0.16821292E-05_JPRB, 0.16811696E-05_JPRB, 0.16801411E-05_JPRB, 0.16796928E-05_JPRB, 0.16797951E-05_JPRB, &
  & 0.16801289E-05_JPRB, 0.16806481E-05_JPRB, 0.16815104E-05_JPRB, 0.16832584E-05_JPRB, 0.16859492E-05_JPRB, 0.16891847E-05_JPRB, &
  & 0.16922188E-05_JPRB, 0.16950802E-05_JPRB, 0.16982648E-05_JPRB, 0.17028952E-05_JPRB, 0.17094824E-05_JPRB, 0.17187457E-05_JPRB, &
  & 0.17290447E-05_JPRB, 0.17359329E-05_JPRB, 0.17386325E-05_JPRB, 0.17386364E-05_JPRB, 0.17390887E-05_JPRB, 0.17374501E-05_JPRB, &
  & 0.17361907E-05_JPRB, 0.17372596E-05_JPRB, 0.17406155E-05_JPRB, 0.17461116E-05_JPRB, 0.17534858E-05_JPRB, 0.17624220E-05_JPRB, &
  & 0.17714522E-05_JPRB, 0.17773150E-05_JPRB, 0.17829865E-05_JPRB, 0.17887989E-05_JPRB, 0.17942320E-05_JPRB, 0.17993968E-05_JPRB, &
  & 0.18039329E-05_JPRB, 0.18072168E-05_JPRB, 0.18099667E-05_JPRB, 0.18127170E-05_JPRB, 0.18148499E-05_JPRB, 0.18170065E-05_JPRB, &
  & 0.18189394E-05_JPRB, 0.18209440E-05_JPRB, 0.18224598E-05_JPRB, 0.18239537E-05_JPRB, 0.18252525E-05_JPRB, 0.18264632E-05_JPRB, &
  & 0.18271327E-05_JPRB, 0.18283067E-05_JPRB, 0.18289582E-05_JPRB, 0.18274193E-05_JPRB  /)

RGHG2(:,72, 1) = (/ &
  & 0.16850940E-05_JPRB, 0.16853247E-05_JPRB, 0.16856393E-05_JPRB, 0.16857061E-05_JPRB, 0.16856689E-05_JPRB, 0.16855996E-05_JPRB, &
  & 0.16857393E-05_JPRB, 0.16857023E-05_JPRB, 0.16856647E-05_JPRB, 0.16851279E-05_JPRB, 0.16845471E-05_JPRB, 0.16838407E-05_JPRB, &
  & 0.16831681E-05_JPRB, 0.16822570E-05_JPRB, 0.16811736E-05_JPRB, 0.16799966E-05_JPRB, 0.16793105E-05_JPRB, 0.16792048E-05_JPRB, &
  & 0.16793083E-05_JPRB, 0.16795749E-05_JPRB, 0.16801747E-05_JPRB, 0.16817121E-05_JPRB, 0.16841454E-05_JPRB, 0.16872596E-05_JPRB, &
  & 0.16902095E-05_JPRB, 0.16931897E-05_JPRB, 0.16966393E-05_JPRB, 0.17016412E-05_JPRB, 0.17088005E-05_JPRB, 0.17187769E-05_JPRB, &
  & 0.17297446E-05_JPRB, 0.17364520E-05_JPRB, 0.17386935E-05_JPRB, 0.17384646E-05_JPRB, 0.17392488E-05_JPRB, 0.17381500E-05_JPRB, &
  & 0.17370541E-05_JPRB, 0.17384845E-05_JPRB, 0.17423803E-05_JPRB, 0.17482603E-05_JPRB, 0.17560628E-05_JPRB, 0.17654597E-05_JPRB, &
  & 0.17744081E-05_JPRB, 0.17799143E-05_JPRB, 0.17852540E-05_JPRB, 0.17908757E-05_JPRB, 0.17961676E-05_JPRB, 0.18013944E-05_JPRB, &
  & 0.18059404E-05_JPRB, 0.18092688E-05_JPRB, 0.18121005E-05_JPRB, 0.18147244E-05_JPRB, 0.18167112E-05_JPRB, 0.18187638E-05_JPRB, &
  & 0.18206323E-05_JPRB, 0.18226221E-05_JPRB, 0.18242741E-05_JPRB, 0.18260651E-05_JPRB, 0.18275274E-05_JPRB, 0.18289437E-05_JPRB, &
  & 0.18298137E-05_JPRB, 0.18308515E-05_JPRB, 0.18312926E-05_JPRB, 0.18297611E-05_JPRB  /)

RGHG2(:,73, 1) = (/ &
  & 0.16851027E-05_JPRB, 0.16854820E-05_JPRB, 0.16858266E-05_JPRB, 0.16859073E-05_JPRB, 0.16858665E-05_JPRB, 0.16858627E-05_JPRB, &
  & 0.16860650E-05_JPRB, 0.16860209E-05_JPRB, 0.16859778E-05_JPRB, 0.16854664E-05_JPRB, 0.16848745E-05_JPRB, 0.16841380E-05_JPRB, &
  & 0.16834309E-05_JPRB, 0.16824972E-05_JPRB, 0.16813168E-05_JPRB, 0.16800432E-05_JPRB, 0.16791548E-05_JPRB, 0.16787985E-05_JPRB, &
  & 0.16787049E-05_JPRB, 0.16787265E-05_JPRB, 0.16790716E-05_JPRB, 0.16803743E-05_JPRB, 0.16826083E-05_JPRB, 0.16855337E-05_JPRB, &
  & 0.16882955E-05_JPRB, 0.16912528E-05_JPRB, 0.16949620E-05_JPRB, 0.17003582E-05_JPRB, 0.17082078E-05_JPRB, 0.17188556E-05_JPRB, &
  & 0.17302866E-05_JPRB, 0.17367915E-05_JPRB, 0.17387630E-05_JPRB, 0.17385459E-05_JPRB, 0.17397673E-05_JPRB, 0.17393080E-05_JPRB, &
  & 0.17385029E-05_JPRB, 0.17404257E-05_JPRB, 0.17449702E-05_JPRB, 0.17511489E-05_JPRB, 0.17591710E-05_JPRB, 0.17691391E-05_JPRB, &
  & 0.17776675E-05_JPRB, 0.17827782E-05_JPRB, 0.17877129E-05_JPRB, 0.17931635E-05_JPRB, 0.17984652E-05_JPRB, 0.18035565E-05_JPRB, &
  & 0.18080826E-05_JPRB, 0.18114214E-05_JPRB, 0.18142870E-05_JPRB, 0.18168138E-05_JPRB, 0.18186927E-05_JPRB, 0.18206660E-05_JPRB, &
  & 0.18223916E-05_JPRB, 0.18243641E-05_JPRB, 0.18261508E-05_JPRB, 0.18282246E-05_JPRB, 0.18299111E-05_JPRB, 0.18315547E-05_JPRB, &
  & 0.18324519E-05_JPRB, 0.18333619E-05_JPRB, 0.18335498E-05_JPRB, 0.18322303E-05_JPRB  /)

RGHG2(:,74, 1) = (/ &
  & 0.16851794E-05_JPRB, 0.16856771E-05_JPRB, 0.16860431E-05_JPRB, 0.16861332E-05_JPRB, 0.16860769E-05_JPRB, 0.16861374E-05_JPRB, &
  & 0.16863959E-05_JPRB, 0.16863558E-05_JPRB, 0.16862993E-05_JPRB, 0.16858138E-05_JPRB, 0.16852268E-05_JPRB, 0.16844765E-05_JPRB, &
  & 0.16837390E-05_JPRB, 0.16827974E-05_JPRB, 0.16815403E-05_JPRB, 0.16801896E-05_JPRB, 0.16791828E-05_JPRB, 0.16785696E-05_JPRB, &
  & 0.16782593E-05_JPRB, 0.16780759E-05_JPRB, 0.16782328E-05_JPRB, 0.16792751E-05_JPRB, 0.16813449E-05_JPRB, 0.16840313E-05_JPRB, &
  & 0.16866174E-05_JPRB, 0.16894935E-05_JPRB, 0.16933539E-05_JPRB, 0.16989829E-05_JPRB, 0.17073720E-05_JPRB, 0.17187408E-05_JPRB, &
  & 0.17304229E-05_JPRB, 0.17369959E-05_JPRB, 0.17388136E-05_JPRB, 0.17389026E-05_JPRB, 0.17406518E-05_JPRB, 0.17409115E-05_JPRB, &
  & 0.17404615E-05_JPRB, 0.17430217E-05_JPRB, 0.17482099E-05_JPRB, 0.17545692E-05_JPRB, 0.17626822E-05_JPRB, 0.17731706E-05_JPRB, &
  & 0.17809563E-05_JPRB, 0.17858332E-05_JPRB, 0.17903407E-05_JPRB, 0.17955637E-05_JPRB, 0.18009895E-05_JPRB, 0.18059021E-05_JPRB, &
  & 0.18103340E-05_JPRB, 0.18136383E-05_JPRB, 0.18164874E-05_JPRB, 0.18189511E-05_JPRB, 0.18207643E-05_JPRB, 0.18226903E-05_JPRB, &
  & 0.18242262E-05_JPRB, 0.18261633E-05_JPRB, 0.18280456E-05_JPRB, 0.18303738E-05_JPRB, 0.18322848E-05_JPRB, 0.18341918E-05_JPRB, &
  & 0.18350326E-05_JPRB, 0.18357723E-05_JPRB, 0.18358444E-05_JPRB, 0.18348168E-05_JPRB  /)

RGHG2(:,75, 1) = (/ &
  & 0.16853232E-05_JPRB, 0.16859038E-05_JPRB, 0.16862886E-05_JPRB, 0.16863854E-05_JPRB, 0.16863096E-05_JPRB, 0.16864273E-05_JPRB, &
  & 0.16867291E-05_JPRB, 0.16866975E-05_JPRB, 0.16866208E-05_JPRB, 0.16861547E-05_JPRB, 0.16855868E-05_JPRB, 0.16848355E-05_JPRB, &
  & 0.16840735E-05_JPRB, 0.16831353E-05_JPRB, 0.16818185E-05_JPRB, 0.16804144E-05_JPRB, 0.16793657E-05_JPRB, 0.16785183E-05_JPRB, &
  & 0.16779772E-05_JPRB, 0.16776301E-05_JPRB, 0.16776574E-05_JPRB, 0.16784708E-05_JPRB, 0.16803670E-05_JPRB, 0.16827819E-05_JPRB, &
  & 0.16851963E-05_JPRB, 0.16879497E-05_JPRB, 0.16918464E-05_JPRB, 0.16975460E-05_JPRB, 0.17062663E-05_JPRB, 0.17183754E-05_JPRB, &
  & 0.17301696E-05_JPRB, 0.17370210E-05_JPRB, 0.17388643E-05_JPRB, 0.17394893E-05_JPRB, 0.17419182E-05_JPRB, 0.17430269E-05_JPRB, &
  & 0.17429098E-05_JPRB, 0.17461901E-05_JPRB, 0.17520142E-05_JPRB, 0.17584206E-05_JPRB, 0.17665468E-05_JPRB, 0.17773518E-05_JPRB, &
  & 0.17842235E-05_JPRB, 0.17890188E-05_JPRB, 0.17930701E-05_JPRB, 0.17980837E-05_JPRB, 0.18036657E-05_JPRB, 0.18084048E-05_JPRB, &
  & 0.18127020E-05_JPRB, 0.18159299E-05_JPRB, 0.18187072E-05_JPRB, 0.18211382E-05_JPRB, 0.18229364E-05_JPRB, 0.18248413E-05_JPRB, &
  & 0.18261515E-05_JPRB, 0.18280374E-05_JPRB, 0.18299768E-05_JPRB, 0.18325382E-05_JPRB, 0.18346673E-05_JPRB, 0.18368640E-05_JPRB, &
  & 0.18375626E-05_JPRB, 0.18380831E-05_JPRB, 0.18381514E-05_JPRB, 0.18374701E-05_JPRB  /)

RGHG2(:,76, 1) = (/ &
  & 0.16855370E-05_JPRB, 0.16861572E-05_JPRB, 0.16865643E-05_JPRB, 0.16866661E-05_JPRB, 0.16865779E-05_JPRB, 0.16867401E-05_JPRB, &
  & 0.16870618E-05_JPRB, 0.16870352E-05_JPRB, 0.16869312E-05_JPRB, 0.16864700E-05_JPRB, 0.16859318E-05_JPRB, 0.16851905E-05_JPRB, &
  & 0.16844111E-05_JPRB, 0.16834853E-05_JPRB, 0.16821215E-05_JPRB, 0.16807001E-05_JPRB, 0.16796687E-05_JPRB, 0.16786504E-05_JPRB, &
  & 0.16778789E-05_JPRB, 0.16774079E-05_JPRB, 0.16773436E-05_JPRB, 0.16780504E-05_JPRB, 0.16796966E-05_JPRB, 0.16818315E-05_JPRB, &
  & 0.16840477E-05_JPRB, 0.16866500E-05_JPRB, 0.16904699E-05_JPRB, 0.16961002E-05_JPRB, 0.17048873E-05_JPRB, 0.17176975E-05_JPRB, &
  & 0.17295784E-05_JPRB, 0.17367865E-05_JPRB, 0.17389493E-05_JPRB, 0.17402381E-05_JPRB, 0.17436033E-05_JPRB, 0.17457797E-05_JPRB, &
  & 0.17458458E-05_JPRB, 0.17498321E-05_JPRB, 0.17562977E-05_JPRB, 0.17625951E-05_JPRB, 0.17707238E-05_JPRB, 0.17814199E-05_JPRB, &
  & 0.17874370E-05_JPRB, 0.17922620E-05_JPRB, 0.17958080E-05_JPRB, 0.18007597E-05_JPRB, 0.18064060E-05_JPRB, 0.18110312E-05_JPRB, &
  & 0.18152120E-05_JPRB, 0.18183260E-05_JPRB, 0.18209670E-05_JPRB, 0.18233906E-05_JPRB, 0.18252383E-05_JPRB, 0.18271382E-05_JPRB, &
  & 0.18281983E-05_JPRB, 0.18300222E-05_JPRB, 0.18319865E-05_JPRB, 0.18347732E-05_JPRB, 0.18371129E-05_JPRB, 0.18396093E-05_JPRB, &
  & 0.18400602E-05_JPRB, 0.18403082E-05_JPRB, 0.18404211E-05_JPRB, 0.18401213E-05_JPRB  /)

RGHG2(:,77, 1) = (/ &
  & 0.16857830E-05_JPRB, 0.16864195E-05_JPRB, 0.16868445E-05_JPRB, 0.16869465E-05_JPRB, 0.16868696E-05_JPRB, 0.16870747E-05_JPRB, &
  & 0.16873950E-05_JPRB, 0.16873877E-05_JPRB, 0.16872514E-05_JPRB, 0.16867833E-05_JPRB, 0.16862728E-05_JPRB, 0.16855463E-05_JPRB, &
  & 0.16847517E-05_JPRB, 0.16838480E-05_JPRB, 0.16824579E-05_JPRB, 0.16810499E-05_JPRB, 0.16800432E-05_JPRB, 0.16789016E-05_JPRB, &
  & 0.16780013E-05_JPRB, 0.16774238E-05_JPRB, 0.16773308E-05_JPRB, 0.16780011E-05_JPRB, 0.16793101E-05_JPRB, 0.16811730E-05_JPRB, &
  & 0.16832360E-05_JPRB, 0.16856207E-05_JPRB, 0.16893126E-05_JPRB, 0.16948607E-05_JPRB, 0.17033106E-05_JPRB, 0.17164505E-05_JPRB, &
  & 0.17288387E-05_JPRB, 0.17364276E-05_JPRB, 0.17390241E-05_JPRB, 0.17410839E-05_JPRB, 0.17455680E-05_JPRB, 0.17488724E-05_JPRB, &
  & 0.17494819E-05_JPRB, 0.17539269E-05_JPRB, 0.17604856E-05_JPRB, 0.17669751E-05_JPRB, 0.17751730E-05_JPRB, 0.17854273E-05_JPRB, &
  & 0.17908945E-05_JPRB, 0.17954614E-05_JPRB, 0.17988380E-05_JPRB, 0.18036125E-05_JPRB, 0.18093766E-05_JPRB, 0.18139338E-05_JPRB, &
  & 0.18180299E-05_JPRB, 0.18210045E-05_JPRB, 0.18234764E-05_JPRB, 0.18258614E-05_JPRB, 0.18277975E-05_JPRB, 0.18297282E-05_JPRB, &
  & 0.18304964E-05_JPRB, 0.18321813E-05_JPRB, 0.18341611E-05_JPRB, 0.18371407E-05_JPRB, 0.18394938E-05_JPRB, 0.18424229E-05_JPRB, &
  & 0.18426058E-05_JPRB, 0.18426323E-05_JPRB, 0.18426760E-05_JPRB, 0.18426321E-05_JPRB  /)

RGHG2(:,78, 1) = (/ &
  & 0.16860149E-05_JPRB, 0.16866632E-05_JPRB, 0.16871073E-05_JPRB, 0.16872062E-05_JPRB, 0.16871481E-05_JPRB, 0.16873894E-05_JPRB, &
  & 0.16876865E-05_JPRB, 0.16877136E-05_JPRB, 0.16875734E-05_JPRB, 0.16870866E-05_JPRB, 0.16865862E-05_JPRB, 0.16858668E-05_JPRB, &
  & 0.16850715E-05_JPRB, 0.16841776E-05_JPRB, 0.16827847E-05_JPRB, 0.16814157E-05_JPRB, 0.16804292E-05_JPRB, 0.16792025E-05_JPRB, &
  & 0.16782065E-05_JPRB, 0.16775478E-05_JPRB, 0.16774138E-05_JPRB, 0.16780276E-05_JPRB, 0.16790342E-05_JPRB, 0.16807495E-05_JPRB, &
  & 0.16826733E-05_JPRB, 0.16849141E-05_JPRB, 0.16884678E-05_JPRB, 0.16939460E-05_JPRB, 0.17020153E-05_JPRB, 0.17154761E-05_JPRB, &
  & 0.17283418E-05_JPRB, 0.17361440E-05_JPRB, 0.17391438E-05_JPRB, 0.17418595E-05_JPRB, 0.17474954E-05_JPRB, 0.17516751E-05_JPRB, &
  & 0.17530036E-05_JPRB, 0.17577643E-05_JPRB, 0.17643889E-05_JPRB, 0.17712298E-05_JPRB, 0.17795738E-05_JPRB, 0.17894303E-05_JPRB, &
  & 0.17943553E-05_JPRB, 0.17986125E-05_JPRB, 0.18019329E-05_JPRB, 0.18066091E-05_JPRB, 0.18124599E-05_JPRB, 0.18169552E-05_JPRB, &
  & 0.18210675E-05_JPRB, 0.18238971E-05_JPRB, 0.18261986E-05_JPRB, 0.18285037E-05_JPRB, 0.18305475E-05_JPRB, 0.18325442E-05_JPRB, &
  & 0.18329795E-05_JPRB, 0.18344577E-05_JPRB, 0.18365084E-05_JPRB, 0.18396290E-05_JPRB, 0.18418905E-05_JPRB, 0.18452930E-05_JPRB, &
  & 0.18453196E-05_JPRB, 0.18451903E-05_JPRB, 0.18450903E-05_JPRB, 0.18451428E-05_JPRB  /)

RGHG2(:,79, 1) = (/ &
  & 0.16862311E-05_JPRB, 0.16868839E-05_JPRB, 0.16873471E-05_JPRB, 0.16874394E-05_JPRB, 0.16874014E-05_JPRB, 0.16876751E-05_JPRB, &
  & 0.16879396E-05_JPRB, 0.16880083E-05_JPRB, 0.16878790E-05_JPRB, 0.16873721E-05_JPRB, 0.16868629E-05_JPRB, 0.16861467E-05_JPRB, &
  & 0.16853590E-05_JPRB, 0.16844675E-05_JPRB, 0.16830870E-05_JPRB, 0.16817671E-05_JPRB, 0.16807814E-05_JPRB, 0.16795082E-05_JPRB, &
  & 0.16784389E-05_JPRB, 0.16777208E-05_JPRB, 0.16775386E-05_JPRB, 0.16780906E-05_JPRB, 0.16788602E-05_JPRB, 0.16804990E-05_JPRB, &
  & 0.16823146E-05_JPRB, 0.16844852E-05_JPRB, 0.16879247E-05_JPRB, 0.16933525E-05_JPRB, 0.17011466E-05_JPRB, 0.17149457E-05_JPRB, &
  & 0.17281064E-05_JPRB, 0.17359439E-05_JPRB, 0.17392780E-05_JPRB, 0.17425078E-05_JPRB, 0.17492642E-05_JPRB, 0.17540950E-05_JPRB, &
  & 0.17562529E-05_JPRB, 0.17612490E-05_JPRB, 0.17679408E-05_JPRB, 0.17751834E-05_JPRB, 0.17836904E-05_JPRB, 0.17932960E-05_JPRB, &
  & 0.17976810E-05_JPRB, 0.18016514E-05_JPRB, 0.18050170E-05_JPRB, 0.18097458E-05_JPRB, 0.18156504E-05_JPRB, 0.18200811E-05_JPRB, &
  & 0.18242657E-05_JPRB, 0.18269355E-05_JPRB, 0.18290446E-05_JPRB, 0.18312785E-05_JPRB, 0.18334529E-05_JPRB, 0.18354947E-05_JPRB, &
  & 0.18356325E-05_JPRB, 0.18368842E-05_JPRB, 0.18390371E-05_JPRB, 0.18422792E-05_JPRB, 0.18444169E-05_JPRB, 0.18482157E-05_JPRB, &
  & 0.18482248E-05_JPRB, 0.18480935E-05_JPRB, 0.18478672E-05_JPRB, 0.18478455E-05_JPRB  /)

RGHG2(:,80, 1) = (/ &
  & 0.16864330E-05_JPRB, 0.16870787E-05_JPRB, 0.16875595E-05_JPRB, 0.16876418E-05_JPRB, 0.16876186E-05_JPRB, 0.16879246E-05_JPRB, &
  & 0.16881618E-05_JPRB, 0.16882702E-05_JPRB, 0.16881482E-05_JPRB, 0.16876313E-05_JPRB, 0.16870950E-05_JPRB, 0.16863838E-05_JPRB, &
  & 0.16856034E-05_JPRB, 0.16847144E-05_JPRB, 0.16833512E-05_JPRB, 0.16820734E-05_JPRB, 0.16810535E-05_JPRB, 0.16797731E-05_JPRB, &
  & 0.16786435E-05_JPRB, 0.16778834E-05_JPRB, 0.16776563E-05_JPRB, 0.16781634E-05_JPRB, 0.16787871E-05_JPRB, 0.16803518E-05_JPRB, &
  & 0.16821096E-05_JPRB, 0.16842726E-05_JPRB, 0.16876573E-05_JPRB, 0.16930603E-05_JPRB, 0.17008259E-05_JPRB, 0.17149852E-05_JPRB, &
  & 0.17281208E-05_JPRB, 0.17358215E-05_JPRB, 0.17393873E-05_JPRB, 0.17429774E-05_JPRB, 0.17507603E-05_JPRB, 0.17560778E-05_JPRB, &
  & 0.17591138E-05_JPRB, 0.17643289E-05_JPRB, 0.17710840E-05_JPRB, 0.17786654E-05_JPRB, 0.17872841E-05_JPRB, 0.17968733E-05_JPRB, &
  & 0.18007327E-05_JPRB, 0.18045083E-05_JPRB, 0.18080179E-05_JPRB, 0.18130107E-05_JPRB, 0.18189356E-05_JPRB, 0.18232956E-05_JPRB, &
  & 0.18275545E-05_JPRB, 0.18300379E-05_JPRB, 0.18319043E-05_JPRB, 0.18341334E-05_JPRB, 0.18364675E-05_JPRB, 0.18384698E-05_JPRB, &
  & 0.18384312E-05_JPRB, 0.18394903E-05_JPRB, 0.18417448E-05_JPRB, 0.18451257E-05_JPRB, 0.18471838E-05_JPRB, 0.18511777E-05_JPRB, &
  & 0.18513257E-05_JPRB, 0.18514397E-05_JPRB, 0.18512016E-05_JPRB, 0.18509314E-05_JPRB  /)

RGHG2(:,81, 1) = (/ &
  & 0.16866227E-05_JPRB, 0.16872403E-05_JPRB, 0.16877109E-05_JPRB, 0.16877958E-05_JPRB, 0.16877803E-05_JPRB, 0.16881016E-05_JPRB, &
  & 0.16883285E-05_JPRB, 0.16884573E-05_JPRB, 0.16883531E-05_JPRB, 0.16878337E-05_JPRB, 0.16872694E-05_JPRB, 0.16865633E-05_JPRB, &
  & 0.16857905E-05_JPRB, 0.16849016E-05_JPRB, 0.16835511E-05_JPRB, 0.16823039E-05_JPRB, 0.16812228E-05_JPRB, 0.16799195E-05_JPRB, &
  & 0.16788128E-05_JPRB, 0.16780196E-05_JPRB, 0.16777823E-05_JPRB, 0.16782868E-05_JPRB, 0.16787883E-05_JPRB, 0.16802868E-05_JPRB, &
  & 0.16820751E-05_JPRB, 0.16842382E-05_JPRB, 0.16876127E-05_JPRB, 0.16929953E-05_JPRB, 0.17008526E-05_JPRB, 0.17153863E-05_JPRB, &
  & 0.17283258E-05_JPRB, 0.17357667E-05_JPRB, 0.17395923E-05_JPRB, 0.17433428E-05_JPRB, 0.17519612E-05_JPRB, 0.17575308E-05_JPRB, &
  & 0.17610712E-05_JPRB, 0.17665614E-05_JPRB, 0.17736628E-05_JPRB, 0.17813156E-05_JPRB, 0.17900005E-05_JPRB, 0.17997094E-05_JPRB, &
  & 0.18032377E-05_JPRB, 0.18067968E-05_JPRB, 0.18105916E-05_JPRB, 0.18162697E-05_JPRB, 0.18225792E-05_JPRB, 0.18265902E-05_JPRB, &
  & 0.18306963E-05_JPRB, 0.18330982E-05_JPRB, 0.18350002E-05_JPRB, 0.18372141E-05_JPRB, 0.18395635E-05_JPRB, 0.18415199E-05_JPRB, &
  & 0.18414074E-05_JPRB, 0.18422781E-05_JPRB, 0.18445988E-05_JPRB, 0.18482878E-05_JPRB, 0.18503078E-05_JPRB, 0.18542863E-05_JPRB, &
  & 0.18547171E-05_JPRB, 0.18552081E-05_JPRB, 0.18553316E-05_JPRB, 0.18545342E-05_JPRB  /)

RGHG2(:,82, 1) = (/ &
  & 0.16867922E-05_JPRB, 0.16873662E-05_JPRB, 0.16878214E-05_JPRB, 0.16879088E-05_JPRB, 0.16879079E-05_JPRB, 0.16882409E-05_JPRB, &
  & 0.16884612E-05_JPRB, 0.16886032E-05_JPRB, 0.16885203E-05_JPRB, 0.16879930E-05_JPRB, 0.16874184E-05_JPRB, 0.16867103E-05_JPRB, &
  & 0.16859399E-05_JPRB, 0.16850457E-05_JPRB, 0.16836851E-05_JPRB, 0.16824647E-05_JPRB, 0.16813159E-05_JPRB, 0.16800179E-05_JPRB, &
  & 0.16789568E-05_JPRB, 0.16781412E-05_JPRB, 0.16779061E-05_JPRB, 0.16784256E-05_JPRB, 0.16788214E-05_JPRB, 0.16802699E-05_JPRB, &
  & 0.16821166E-05_JPRB, 0.16842709E-05_JPRB, 0.16876406E-05_JPRB, 0.16930311E-05_JPRB, 0.17009215E-05_JPRB, 0.17157887E-05_JPRB, &
  & 0.17285193E-05_JPRB, 0.17357792E-05_JPRB, 0.17399174E-05_JPRB, 0.17436325E-05_JPRB, 0.17529108E-05_JPRB, 0.17586380E-05_JPRB, &
  & 0.17623847E-05_JPRB, 0.17681499E-05_JPRB, 0.17755745E-05_JPRB, 0.17833649E-05_JPRB, 0.17921629E-05_JPRB, 0.18019978E-05_JPRB, &
  & 0.18052356E-05_JPRB, 0.18086043E-05_JPRB, 0.18126579E-05_JPRB, 0.18190887E-05_JPRB, 0.18260735E-05_JPRB, 0.18297062E-05_JPRB, &
  & 0.18336938E-05_JPRB, 0.18359620E-05_JPRB, 0.18380504E-05_JPRB, 0.18402368E-05_JPRB, 0.18425311E-05_JPRB, 0.18443736E-05_JPRB, &
  & 0.18443106E-05_JPRB, 0.18449623E-05_JPRB, 0.18472576E-05_JPRB, 0.18513090E-05_JPRB, 0.18535525E-05_JPRB, 0.18572684E-05_JPRB, &
  & 0.18579082E-05_JPRB, 0.18586860E-05_JPRB, 0.18593198E-05_JPRB, 0.18580827E-05_JPRB  /)

RGHG2(:,83, 1) = (/ &
  & 0.16869405E-05_JPRB, 0.16874566E-05_JPRB, 0.16878991E-05_JPRB, 0.16879889E-05_JPRB, 0.16880095E-05_JPRB, 0.16883515E-05_JPRB, &
  & 0.16885698E-05_JPRB, 0.16887189E-05_JPRB, 0.16886624E-05_JPRB, 0.16881223E-05_JPRB, 0.16875442E-05_JPRB, 0.16868281E-05_JPRB, &
  & 0.16860538E-05_JPRB, 0.16851492E-05_JPRB, 0.16837763E-05_JPRB, 0.16825742E-05_JPRB, 0.16813814E-05_JPRB, 0.16800873E-05_JPRB, &
  & 0.16790717E-05_JPRB, 0.16782531E-05_JPRB, 0.16780362E-05_JPRB, 0.16786007E-05_JPRB, 0.16788908E-05_JPRB, 0.16803180E-05_JPRB, &
  & 0.16822506E-05_JPRB, 0.16843885E-05_JPRB, 0.16877712E-05_JPRB, 0.16932012E-05_JPRB, 0.17010068E-05_JPRB, 0.17161206E-05_JPRB, &
  & 0.17286301E-05_JPRB, 0.17358290E-05_JPRB, 0.17403710E-05_JPRB, 0.17438558E-05_JPRB, 0.17535466E-05_JPRB, 0.17594466E-05_JPRB, &
  & 0.17632365E-05_JPRB, 0.17691829E-05_JPRB, 0.17768847E-05_JPRB, 0.17848679E-05_JPRB, 0.17938067E-05_JPRB, 0.18037998E-05_JPRB, &
  & 0.18068103E-05_JPRB, 0.18100202E-05_JPRB, 0.18142877E-05_JPRB, 0.18215616E-05_JPRB, 0.18292725E-05_JPRB, 0.18325901E-05_JPRB, &
  & 0.18365098E-05_JPRB, 0.18386050E-05_JPRB, 0.18409608E-05_JPRB, 0.18431107E-05_JPRB, 0.18453256E-05_JPRB, 0.18470298E-05_JPRB, &
  & 0.18471514E-05_JPRB, 0.18475528E-05_JPRB, 0.18497896E-05_JPRB, 0.18542065E-05_JPRB, 0.18568233E-05_JPRB, 0.18600381E-05_JPRB, &
  & 0.18607232E-05_JPRB, 0.18617314E-05_JPRB, 0.18629190E-05_JPRB, 0.18615580E-05_JPRB  /)

RGHG2(:,84, 1) = (/ &
  & 0.16870668E-05_JPRB, 0.16875140E-05_JPRB, 0.16879514E-05_JPRB, 0.16880444E-05_JPRB, 0.16880922E-05_JPRB, 0.16884415E-05_JPRB, &
  & 0.16886630E-05_JPRB, 0.16888137E-05_JPRB, 0.16887898E-05_JPRB, 0.16882318E-05_JPRB, 0.16876479E-05_JPRB, 0.16869201E-05_JPRB, &
  & 0.16861362E-05_JPRB, 0.16852169E-05_JPRB, 0.16838446E-05_JPRB, 0.16826514E-05_JPRB, 0.16814564E-05_JPRB, 0.16801449E-05_JPRB, &
  & 0.16791582E-05_JPRB, 0.16783617E-05_JPRB, 0.16781782E-05_JPRB, 0.16788269E-05_JPRB, 0.16789994E-05_JPRB, 0.16804397E-05_JPRB, &
  & 0.16824815E-05_JPRB, 0.16846005E-05_JPRB, 0.16880162E-05_JPRB, 0.16935233E-05_JPRB, 0.17010984E-05_JPRB, 0.17163586E-05_JPRB, &
  & 0.17286583E-05_JPRB, 0.17359266E-05_JPRB, 0.17409653E-05_JPRB, 0.17440382E-05_JPRB, 0.17538635E-05_JPRB, 0.17600212E-05_JPRB, &
  & 0.17637961E-05_JPRB, 0.17697755E-05_JPRB, 0.17776886E-05_JPRB, 0.17859011E-05_JPRB, 0.17949955E-05_JPRB, 0.18051933E-05_JPRB, &
  & 0.18080547E-05_JPRB, 0.18111387E-05_JPRB, 0.18155634E-05_JPRB, 0.18237591E-05_JPRB, 0.18320751E-05_JPRB, 0.18351988E-05_JPRB, &
  & 0.18391001E-05_JPRB, 0.18410025E-05_JPRB, 0.18436441E-05_JPRB, 0.18457548E-05_JPRB, 0.18479015E-05_JPRB, 0.18494863E-05_JPRB, &
  & 0.18499200E-05_JPRB, 0.18500476E-05_JPRB, 0.18522521E-05_JPRB, 0.18569844E-05_JPRB, 0.18600168E-05_JPRB, 0.18625200E-05_JPRB, &
  & 0.18630375E-05_JPRB, 0.18642370E-05_JPRB, 0.18659232E-05_JPRB, 0.18649053E-05_JPRB  /)

RGHG2(:,85, 1) = (/ &
  & 0.16871644E-05_JPRB, 0.16875475E-05_JPRB, 0.16879772E-05_JPRB, 0.16880830E-05_JPRB, 0.16881590E-05_JPRB, 0.16885134E-05_JPRB, &
  & 0.16887504E-05_JPRB, 0.16888882E-05_JPRB, 0.16889054E-05_JPRB, 0.16883218E-05_JPRB, 0.16877173E-05_JPRB, 0.16869869E-05_JPRB, &
  & 0.16861979E-05_JPRB, 0.16852657E-05_JPRB, 0.16839037E-05_JPRB, 0.16827439E-05_JPRB, 0.16815515E-05_JPRB, 0.16802194E-05_JPRB, &
  & 0.16792507E-05_JPRB, 0.16785133E-05_JPRB, 0.16783452E-05_JPRB, 0.16791608E-05_JPRB, 0.16791895E-05_JPRB, 0.16806555E-05_JPRB, &
  & 0.16828153E-05_JPRB, 0.16849677E-05_JPRB, 0.16883553E-05_JPRB, 0.16940652E-05_JPRB, 0.17013526E-05_JPRB, 0.17168902E-05_JPRB, &
  & 0.17292900E-05_JPRB, 0.17365916E-05_JPRB, 0.17419847E-05_JPRB, 0.17444158E-05_JPRB, 0.17541999E-05_JPRB, 0.17605938E-05_JPRB, &
  & 0.17642353E-05_JPRB, 0.17702224E-05_JPRB, 0.17782150E-05_JPRB, 0.17866149E-05_JPRB, 0.17959456E-05_JPRB, 0.18063847E-05_JPRB, &
  & 0.18091974E-05_JPRB, 0.18121556E-05_JPRB, 0.18166855E-05_JPRB, 0.18256695E-05_JPRB, 0.18346376E-05_JPRB, 0.18375842E-05_JPRB, &
  & 0.18413725E-05_JPRB, 0.18431542E-05_JPRB, 0.18460346E-05_JPRB, 0.18481504E-05_JPRB, 0.18502432E-05_JPRB, 0.18518486E-05_JPRB, &
  & 0.18526520E-05_JPRB, 0.18525460E-05_JPRB, 0.18549482E-05_JPRB, 0.18597549E-05_JPRB, 0.18630646E-05_JPRB, 0.18646487E-05_JPRB, &
  & 0.18648452E-05_JPRB, 0.18660627E-05_JPRB, 0.18679774E-05_JPRB, 0.18678863E-05_JPRB  /)

RGHG2(:,86, 1) = (/ &
  & 0.16872417E-05_JPRB, 0.16875682E-05_JPRB, 0.16879882E-05_JPRB, 0.16881109E-05_JPRB, 0.16882133E-05_JPRB, 0.16885789E-05_JPRB, &
  & 0.16888293E-05_JPRB, 0.16889543E-05_JPRB, 0.16890087E-05_JPRB, 0.16883953E-05_JPRB, 0.16877661E-05_JPRB, 0.16870332E-05_JPRB, &
  & 0.16862470E-05_JPRB, 0.16853140E-05_JPRB, 0.16839623E-05_JPRB, 0.16828240E-05_JPRB, 0.16816222E-05_JPRB, 0.16802875E-05_JPRB, &
  & 0.16793650E-05_JPRB, 0.16787271E-05_JPRB, 0.16785725E-05_JPRB, 0.16795980E-05_JPRB, 0.16794219E-05_JPRB, 0.16809157E-05_JPRB, &
  & 0.16832666E-05_JPRB, 0.16854545E-05_JPRB, 0.16887293E-05_JPRB, 0.16947817E-05_JPRB, 0.17016335E-05_JPRB, 0.17176848E-05_JPRB, &
  & 0.17304465E-05_JPRB, 0.17377716E-05_JPRB, 0.17438122E-05_JPRB, 0.17450013E-05_JPRB, 0.17546498E-05_JPRB, 0.17612329E-05_JPRB, &
  & 0.17646638E-05_JPRB, 0.17706647E-05_JPRB, 0.17787172E-05_JPRB, 0.17872653E-05_JPRB, 0.17968214E-05_JPRB, 0.18075733E-05_JPRB, &
  & 0.18103249E-05_JPRB, 0.18132511E-05_JPRB, 0.18178225E-05_JPRB, 0.18274420E-05_JPRB, 0.18370998E-05_JPRB, 0.18397397E-05_JPRB, &
  & 0.18434547E-05_JPRB, 0.18450649E-05_JPRB, 0.18481008E-05_JPRB, 0.18502721E-05_JPRB, 0.18522404E-05_JPRB, 0.18539548E-05_JPRB, &
  & 0.18551539E-05_JPRB, 0.18550019E-05_JPRB, 0.18577937E-05_JPRB, 0.18624282E-05_JPRB, 0.18656308E-05_JPRB, 0.18663352E-05_JPRB, &
  & 0.18663819E-05_JPRB, 0.18674206E-05_JPRB, 0.18693941E-05_JPRB, 0.18700157E-05_JPRB  /)

RGHG2(:,87, 1) = (/ &
  & 0.16873022E-05_JPRB, 0.16875804E-05_JPRB, 0.16879899E-05_JPRB, 0.16881296E-05_JPRB, 0.16882569E-05_JPRB, 0.16886356E-05_JPRB, &
  & 0.16889005E-05_JPRB, 0.16890096E-05_JPRB, 0.16890954E-05_JPRB, 0.16884559E-05_JPRB, 0.16877992E-05_JPRB, 0.16870636E-05_JPRB, &
  & 0.16862854E-05_JPRB, 0.16853550E-05_JPRB, 0.16840111E-05_JPRB, 0.16828925E-05_JPRB, 0.16816815E-05_JPRB, 0.16803508E-05_JPRB, &
  & 0.16794900E-05_JPRB, 0.16789662E-05_JPRB, 0.16788140E-05_JPRB, 0.16800743E-05_JPRB, 0.16796755E-05_JPRB, 0.16811914E-05_JPRB, &
  & 0.16838589E-05_JPRB, 0.16859765E-05_JPRB, 0.16891391E-05_JPRB, 0.16956423E-05_JPRB, 0.17019838E-05_JPRB, 0.17191051E-05_JPRB, &
  & 0.17321946E-05_JPRB, 0.17397294E-05_JPRB, 0.17467391E-05_JPRB, 0.17458631E-05_JPRB, 0.17553224E-05_JPRB, 0.17619954E-05_JPRB, &
  & 0.17651797E-05_JPRB, 0.17711896E-05_JPRB, 0.17793146E-05_JPRB, 0.17880391E-05_JPRB, 0.17978687E-05_JPRB, 0.18089989E-05_JPRB, &
  & 0.18115953E-05_JPRB, 0.18145430E-05_JPRB, 0.18192009E-05_JPRB, 0.18292788E-05_JPRB, 0.18395760E-05_JPRB, 0.18418071E-05_JPRB, &
  & 0.18454819E-05_JPRB, 0.18468111E-05_JPRB, 0.18498884E-05_JPRB, 0.18521705E-05_JPRB, 0.18539051E-05_JPRB, 0.18559658E-05_JPRB, &
  & 0.18577343E-05_JPRB, 0.18573815E-05_JPRB, 0.18607673E-05_JPRB, 0.18648798E-05_JPRB, 0.18676789E-05_JPRB, 0.18677020E-05_JPRB, &
  & 0.18675957E-05_JPRB, 0.18683544E-05_JPRB, 0.18702408E-05_JPRB, 0.18713288E-05_JPRB  /)

RGHG2(:,88, 1) = (/ &
  & 0.16873462E-05_JPRB, 0.16875860E-05_JPRB, 0.16879861E-05_JPRB, 0.16881399E-05_JPRB, 0.16882903E-05_JPRB, 0.16886859E-05_JPRB, &
  & 0.16889704E-05_JPRB, 0.16890572E-05_JPRB, 0.16891689E-05_JPRB, 0.16885042E-05_JPRB, 0.16878204E-05_JPRB, 0.16870821E-05_JPRB, &
  & 0.16863141E-05_JPRB, 0.16853880E-05_JPRB, 0.16840480E-05_JPRB, 0.16829562E-05_JPRB, 0.16817397E-05_JPRB, 0.16804113E-05_JPRB, &
  & 0.16796227E-05_JPRB, 0.16792014E-05_JPRB, 0.16790402E-05_JPRB, 0.16805471E-05_JPRB, 0.16799580E-05_JPRB, 0.16814754E-05_JPRB, &
  & 0.16846762E-05_JPRB, 0.16865352E-05_JPRB, 0.16896143E-05_JPRB, 0.16966860E-05_JPRB, 0.17024667E-05_JPRB, 0.17218085E-05_JPRB, &
  & 0.17347994E-05_JPRB, 0.17428784E-05_JPRB, 0.17512083E-05_JPRB, 0.17473193E-05_JPRB, 0.17563854E-05_JPRB, 0.17630039E-05_JPRB, &
  & 0.17659421E-05_JPRB, 0.17719429E-05_JPRB, 0.17802157E-05_JPRB, 0.17892116E-05_JPRB, 0.17995713E-05_JPRB, 0.18110969E-05_JPRB, &
  & 0.18133230E-05_JPRB, 0.18163122E-05_JPRB, 0.18212843E-05_JPRB, 0.18315994E-05_JPRB, 0.18424160E-05_JPRB, 0.18439640E-05_JPRB, &
  & 0.18476410E-05_JPRB, 0.18485056E-05_JPRB, 0.18515177E-05_JPRB, 0.18538875E-05_JPRB, 0.18552907E-05_JPRB, 0.18579457E-05_JPRB, &
  & 0.18610924E-05_JPRB, 0.18596809E-05_JPRB, 0.18638499E-05_JPRB, 0.18670551E-05_JPRB, 0.18692247E-05_JPRB, 0.18687913E-05_JPRB, &
  & 0.18684531E-05_JPRB, 0.18688990E-05_JPRB, 0.18706110E-05_JPRB, 0.18719398E-05_JPRB  /)

RGHG2(:,89, 1) = (/ &
  & 0.16873697E-05_JPRB, 0.16875866E-05_JPRB, 0.16879817E-05_JPRB, 0.16881434E-05_JPRB, 0.16883135E-05_JPRB, 0.16887358E-05_JPRB, &
  & 0.16890501E-05_JPRB, 0.16891034E-05_JPRB, 0.16892384E-05_JPRB, 0.16885382E-05_JPRB, 0.16878346E-05_JPRB, 0.16870935E-05_JPRB, &
  & 0.16863344E-05_JPRB, 0.16854162E-05_JPRB, 0.16840762E-05_JPRB, 0.16830265E-05_JPRB, 0.16818035E-05_JPRB, 0.16804690E-05_JPRB, &
  & 0.16797584E-05_JPRB, 0.16793975E-05_JPRB, 0.16792301E-05_JPRB, 0.16809686E-05_JPRB, 0.16802966E-05_JPRB, 0.16817684E-05_JPRB, &
  & 0.16858285E-05_JPRB, 0.16871949E-05_JPRB, 0.16901983E-05_JPRB, 0.16979613E-05_JPRB, 0.17031752E-05_JPRB, 0.17266378E-05_JPRB, &
  & 0.17384974E-05_JPRB, 0.17476583E-05_JPRB, 0.17575048E-05_JPRB, 0.17500130E-05_JPRB, 0.17580614E-05_JPRB, 0.17644442E-05_JPRB, &
  & 0.17671930E-05_JPRB, 0.17731397E-05_JPRB, 0.17817689E-05_JPRB, 0.17913027E-05_JPRB, 0.18028936E-05_JPRB, 0.18147228E-05_JPRB, &
  & 0.18161624E-05_JPRB, 0.18191630E-05_JPRB, 0.18250220E-05_JPRB, 0.18352105E-05_JPRB, 0.18463577E-05_JPRB, 0.18464776E-05_JPRB, &
  & 0.18501795E-05_JPRB, 0.18502854E-05_JPRB, 0.18531812E-05_JPRB, 0.18553750E-05_JPRB, 0.18564918E-05_JPRB, 0.18597034E-05_JPRB, &
  & 0.18661220E-05_JPRB, 0.18618001E-05_JPRB, 0.18667865E-05_JPRB, 0.18688682E-05_JPRB, 0.18702950E-05_JPRB, 0.18695695E-05_JPRB, &
  & 0.18689608E-05_JPRB, 0.18691387E-05_JPRB, 0.18707080E-05_JPRB, 0.18721362E-05_JPRB  /)

RGHG2(:,90, 1) = (/ &
  & 0.16873716E-05_JPRB, 0.16875857E-05_JPRB, 0.16879807E-05_JPRB, 0.16881453E-05_JPRB, 0.16883337E-05_JPRB, 0.16887898E-05_JPRB, &
  & 0.16891423E-05_JPRB, 0.16891480E-05_JPRB, 0.16893095E-05_JPRB, 0.16885640E-05_JPRB, 0.16878426E-05_JPRB, 0.16870985E-05_JPRB, &
  & 0.16863514E-05_JPRB, 0.16854364E-05_JPRB, 0.16840962E-05_JPRB, 0.16831051E-05_JPRB, 0.16818685E-05_JPRB, 0.16805253E-05_JPRB, &
  & 0.16799013E-05_JPRB, 0.16796039E-05_JPRB, 0.16794681E-05_JPRB, 0.16814209E-05_JPRB, 0.16807459E-05_JPRB, 0.16821108E-05_JPRB, &
  & 0.16873610E-05_JPRB, 0.16880881E-05_JPRB, 0.16909590E-05_JPRB, 0.16995270E-05_JPRB, 0.17043089E-05_JPRB, 0.17334512E-05_JPRB, &
  & 0.17428908E-05_JPRB, 0.17543606E-05_JPRB, 0.17653732E-05_JPRB, 0.17548021E-05_JPRB, 0.17606180E-05_JPRB, 0.17665970E-05_JPRB, &
  & 0.17692124E-05_JPRB, 0.17749939E-05_JPRB, 0.17844574E-05_JPRB, 0.17954948E-05_JPRB, 0.18096792E-05_JPRB, 0.18217500E-05_JPRB, &
  & 0.18218004E-05_JPRB, 0.18246600E-05_JPRB, 0.18325019E-05_JPRB, 0.18416542E-05_JPRB, 0.18531176E-05_JPRB, 0.18502173E-05_JPRB, &
  & 0.18536645E-05_JPRB, 0.18524210E-05_JPRB, 0.18551515E-05_JPRB, 0.18565143E-05_JPRB, 0.18577414E-05_JPRB, 0.18606831E-05_JPRB, &
  & 0.18720611E-05_JPRB, 0.18636852E-05_JPRB, 0.18691940E-05_JPRB, 0.18704234E-05_JPRB, 0.18708827E-05_JPRB, 0.18701223E-05_JPRB, &
  & 0.18694144E-05_JPRB, 0.18693285E-05_JPRB, 0.18707573E-05_JPRB, 0.18721799E-05_JPRB  /)

RGHG2(:,91, 1) = (/ &
  & 0.16873713E-05_JPRB, 0.16875886E-05_JPRB, 0.16879804E-05_JPRB, 0.16881450E-05_JPRB, 0.16883557E-05_JPRB, 0.16888693E-05_JPRB, &
  & 0.16892282E-05_JPRB, 0.16892051E-05_JPRB, 0.16893730E-05_JPRB, 0.16885829E-05_JPRB, 0.16878487E-05_JPRB, 0.16871046E-05_JPRB, &
  & 0.16863671E-05_JPRB, 0.16854584E-05_JPRB, 0.16841118E-05_JPRB, 0.16832229E-05_JPRB, 0.16819257E-05_JPRB, 0.16805824E-05_JPRB, &
  & 0.16801116E-05_JPRB, 0.16798844E-05_JPRB, 0.16798252E-05_JPRB, 0.16819981E-05_JPRB, 0.16813232E-05_JPRB, 0.16825381E-05_JPRB, &
  & 0.16886849E-05_JPRB, 0.16895014E-05_JPRB, 0.16920596E-05_JPRB, 0.17018050E-05_JPRB, 0.17062168E-05_JPRB, 0.17406912E-05_JPRB, &
  & 0.17491065E-05_JPRB, 0.17640736E-05_JPRB, 0.17772530E-05_JPRB, 0.17607944E-05_JPRB, 0.17638629E-05_JPRB, 0.17695324E-05_JPRB, &
  & 0.17720840E-05_JPRB, 0.17773518E-05_JPRB, 0.17888224E-05_JPRB, 0.18029071E-05_JPRB, 0.18230268E-05_JPRB, 0.18338851E-05_JPRB, &
  & 0.18353139E-05_JPRB, 0.18358473E-05_JPRB, 0.18474035E-05_JPRB, 0.18526022E-05_JPRB, 0.18652877E-05_JPRB, 0.18576296E-05_JPRB, &
  & 0.18592166E-05_JPRB, 0.18549990E-05_JPRB, 0.18577646E-05_JPRB, 0.18577712E-05_JPRB, 0.18590717E-05_JPRB, 0.18612381E-05_JPRB, &
  & 0.18769526E-05_JPRB, 0.18653601E-05_JPRB, 0.18715136E-05_JPRB, 0.18723696E-05_JPRB, 0.18712238E-05_JPRB, 0.18704666E-05_JPRB, &
  & 0.18697587E-05_JPRB, 0.18694558E-05_JPRB, 0.18707794E-05_JPRB, 0.18722115E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ---GEMS----

RGHG2(:, 1, 2) = (/ &
  & 0.14352421E-06_JPRB, 0.14357195E-06_JPRB, 0.14358018E-06_JPRB, 0.14352751E-06_JPRB, 0.14341886E-06_JPRB, 0.14329375E-06_JPRB, &
  & 0.14330198E-06_JPRB, 0.14351598E-06_JPRB, 0.14386004E-06_JPRB, 0.14431768E-06_JPRB, 0.14494158E-06_JPRB, 0.14589472E-06_JPRB, &
  & 0.14722648E-06_JPRB, 0.14912783E-06_JPRB, 0.15190659E-06_JPRB, 0.15587719E-06_JPRB, 0.16090299E-06_JPRB, 0.16685066E-06_JPRB, &
  & 0.17371525E-06_JPRB, 0.18179802E-06_JPRB, 0.19102489E-06_JPRB, 0.20095139E-06_JPRB, 0.21082027E-06_JPRB, 0.21992861E-06_JPRB, &
  & 0.22789451E-06_JPRB, 0.23443809E-06_JPRB, 0.23971576E-06_JPRB, 0.24407651E-06_JPRB, 0.24748247E-06_JPRB, 0.24937558E-06_JPRB, &
  & 0.24992870E-06_JPRB, 0.24987602E-06_JPRB, 0.24978219E-06_JPRB, 0.24924224E-06_JPRB, 0.24851133E-06_JPRB, 0.24805369E-06_JPRB, &
  & 0.24743143E-06_JPRB, 0.24616387E-06_JPRB, 0.24478601E-06_JPRB, 0.24378019E-06_JPRB, 0.24300155E-06_JPRB, 0.24225418E-06_JPRB, &
  & 0.24132902E-06_JPRB, 0.24021950E-06_JPRB, 0.23906552E-06_JPRB, 0.23753127E-06_JPRB, 0.23571882E-06_JPRB, 0.23372365E-06_JPRB, &
  & 0.23208899E-06_JPRB, 0.23082801E-06_JPRB, 0.22997858E-06_JPRB, 0.22909951E-06_JPRB, 0.22817106E-06_JPRB, 0.22734633E-06_JPRB, &
  & 0.22673559E-06_JPRB, 0.22619893E-06_JPRB, 0.22591908E-06_JPRB, 0.22576434E-06_JPRB, 0.22569685E-06_JPRB, 0.22575611E-06_JPRB, &
  & 0.22562442E-06_JPRB, 0.22536597E-06_JPRB, 0.22536761E-06_JPRB, 0.22518488E-06_JPRB  /)

RGHG2(:, 2, 2) = (/ &
  & 0.14352421E-06_JPRB, 0.14357195E-06_JPRB, 0.14358018E-06_JPRB, 0.14352751E-06_JPRB, 0.14341886E-06_JPRB, 0.14329375E-06_JPRB, &
  & 0.14330198E-06_JPRB, 0.14351598E-06_JPRB, 0.14386004E-06_JPRB, 0.14431768E-06_JPRB, 0.14494158E-06_JPRB, 0.14589472E-06_JPRB, &
  & 0.14722648E-06_JPRB, 0.14912783E-06_JPRB, 0.15190659E-06_JPRB, 0.15587719E-06_JPRB, 0.16090299E-06_JPRB, 0.16685066E-06_JPRB, &
  & 0.17371525E-06_JPRB, 0.18179802E-06_JPRB, 0.19102489E-06_JPRB, 0.20095139E-06_JPRB, 0.21082027E-06_JPRB, 0.21992861E-06_JPRB, &
  & 0.22789451E-06_JPRB, 0.23443809E-06_JPRB, 0.23971576E-06_JPRB, 0.24407651E-06_JPRB, 0.24748247E-06_JPRB, 0.24937558E-06_JPRB, &
  & 0.24992870E-06_JPRB, 0.24987602E-06_JPRB, 0.24978219E-06_JPRB, 0.24924224E-06_JPRB, 0.24851133E-06_JPRB, 0.24805369E-06_JPRB, &
  & 0.24743143E-06_JPRB, 0.24616387E-06_JPRB, 0.24478601E-06_JPRB, 0.24378019E-06_JPRB, 0.24300155E-06_JPRB, 0.24225418E-06_JPRB, &
  & 0.24132902E-06_JPRB, 0.24021950E-06_JPRB, 0.23906552E-06_JPRB, 0.23753127E-06_JPRB, 0.23571882E-06_JPRB, 0.23372365E-06_JPRB, &
  & 0.23208899E-06_JPRB, 0.23082801E-06_JPRB, 0.22997858E-06_JPRB, 0.22909951E-06_JPRB, 0.22817106E-06_JPRB, 0.22734633E-06_JPRB, &
  & 0.22673559E-06_JPRB, 0.22619893E-06_JPRB, 0.22591908E-06_JPRB, 0.22576434E-06_JPRB, 0.22569685E-06_JPRB, 0.22575611E-06_JPRB, &
  & 0.22562442E-06_JPRB, 0.22536597E-06_JPRB, 0.22536761E-06_JPRB, 0.22518488E-06_JPRB  /)

RGHG2(:, 3, 2) = (/ &
  & 0.14352421E-06_JPRB, 0.14357195E-06_JPRB, 0.14358018E-06_JPRB, 0.14352751E-06_JPRB, 0.14341886E-06_JPRB, 0.14329375E-06_JPRB, &
  & 0.14330198E-06_JPRB, 0.14351598E-06_JPRB, 0.14386004E-06_JPRB, 0.14431768E-06_JPRB, 0.14494158E-06_JPRB, 0.14589472E-06_JPRB, &
  & 0.14722648E-06_JPRB, 0.14912783E-06_JPRB, 0.15190659E-06_JPRB, 0.15587719E-06_JPRB, 0.16090299E-06_JPRB, 0.16685066E-06_JPRB, &
  & 0.17371525E-06_JPRB, 0.18179802E-06_JPRB, 0.19102489E-06_JPRB, 0.20095139E-06_JPRB, 0.21082027E-06_JPRB, 0.21992861E-06_JPRB, &
  & 0.22789451E-06_JPRB, 0.23443809E-06_JPRB, 0.23971576E-06_JPRB, 0.24407651E-06_JPRB, 0.24748247E-06_JPRB, 0.24937558E-06_JPRB, &
  & 0.24992870E-06_JPRB, 0.24987602E-06_JPRB, 0.24978219E-06_JPRB, 0.24924224E-06_JPRB, 0.24851133E-06_JPRB, 0.24805369E-06_JPRB, &
  & 0.24743143E-06_JPRB, 0.24616387E-06_JPRB, 0.24478601E-06_JPRB, 0.24378019E-06_JPRB, 0.24300155E-06_JPRB, 0.24225418E-06_JPRB, &
  & 0.24132902E-06_JPRB, 0.24021950E-06_JPRB, 0.23906552E-06_JPRB, 0.23753127E-06_JPRB, 0.23571882E-06_JPRB, 0.23372365E-06_JPRB, &
  & 0.23208899E-06_JPRB, 0.23082801E-06_JPRB, 0.22997858E-06_JPRB, 0.22909951E-06_JPRB, 0.22817106E-06_JPRB, 0.22734633E-06_JPRB, &
  & 0.22673559E-06_JPRB, 0.22619893E-06_JPRB, 0.22591908E-06_JPRB, 0.22576434E-06_JPRB, 0.22569685E-06_JPRB, 0.22575611E-06_JPRB, &
  & 0.22562442E-06_JPRB, 0.22536597E-06_JPRB, 0.22536761E-06_JPRB, 0.22518488E-06_JPRB  /)

RGHG2(:, 4, 2) = (/ &
  & 0.14354761E-06_JPRB, 0.14359506E-06_JPRB, 0.14360241E-06_JPRB, 0.14354758E-06_JPRB, 0.14343602E-06_JPRB, 0.14330881E-06_JPRB, &
  & 0.14331673E-06_JPRB, 0.14353288E-06_JPRB, 0.14388047E-06_JPRB, 0.14434241E-06_JPRB, 0.14497144E-06_JPRB, 0.14593174E-06_JPRB, &
  & 0.14727387E-06_JPRB, 0.14919011E-06_JPRB, 0.15198913E-06_JPRB, 0.15598513E-06_JPRB, 0.16103773E-06_JPRB, 0.16701005E-06_JPRB, &
  & 0.17389672E-06_JPRB, 0.18200169E-06_JPRB, 0.19124853E-06_JPRB, 0.20118627E-06_JPRB, 0.21106063E-06_JPRB, 0.22017134E-06_JPRB, &
  & 0.22813552E-06_JPRB, 0.23466930E-06_JPRB, 0.23993066E-06_JPRB, 0.24427283E-06_JPRB, 0.24766209E-06_JPRB, 0.24954614E-06_JPRB, &
  & 0.25009399E-06_JPRB, 0.25003106E-06_JPRB, 0.24992266E-06_JPRB, 0.24937002E-06_JPRB, 0.24862545E-06_JPRB, 0.24815588E-06_JPRB, &
  & 0.24752800E-06_JPRB, 0.24625743E-06_JPRB, 0.24487358E-06_JPRB, 0.24385899E-06_JPRB, 0.24307208E-06_JPRB, 0.24231506E-06_JPRB, &
  & 0.24137912E-06_JPRB, 0.24026050E-06_JPRB, 0.23909674E-06_JPRB, 0.23755548E-06_JPRB, 0.23574124E-06_JPRB, 0.23374736E-06_JPRB, &
  & 0.23211352E-06_JPRB, 0.23085272E-06_JPRB, 0.23000233E-06_JPRB, 0.22912288E-06_JPRB, 0.22819532E-06_JPRB, 0.22737151E-06_JPRB, &
  & 0.22676099E-06_JPRB, 0.22622547E-06_JPRB, 0.22594529E-06_JPRB, 0.22579037E-06_JPRB, 0.22572203E-06_JPRB, 0.22578000E-06_JPRB, &
  & 0.22564828E-06_JPRB, 0.22539040E-06_JPRB, 0.22539221E-06_JPRB, 0.22521038E-06_JPRB  /)

RGHG2(:, 5, 2) = (/ &
  & 0.14465805E-06_JPRB, 0.14469168E-06_JPRB, 0.14465757E-06_JPRB, 0.14450059E-06_JPRB, 0.14425082E-06_JPRB, 0.14402386E-06_JPRB, &
  & 0.14401675E-06_JPRB, 0.14433506E-06_JPRB, 0.14485030E-06_JPRB, 0.14551655E-06_JPRB, 0.14638895E-06_JPRB, 0.14768875E-06_JPRB, &
  & 0.14952303E-06_JPRB, 0.15214654E-06_JPRB, 0.15590701E-06_JPRB, 0.16110843E-06_JPRB, 0.16743316E-06_JPRB, 0.17457544E-06_JPRB, &
  & 0.18251010E-06_JPRB, 0.19166906E-06_JPRB, 0.20186353E-06_JPRB, 0.21233487E-06_JPRB, 0.22246943E-06_JPRB, 0.23169251E-06_JPRB, &
  & 0.23957557E-06_JPRB, 0.24564364E-06_JPRB, 0.25013104E-06_JPRB, 0.25359168E-06_JPRB, 0.25618834E-06_JPRB, 0.25764214E-06_JPRB, &
  & 0.25794001E-06_JPRB, 0.25739035E-06_JPRB, 0.25659030E-06_JPRB, 0.25543555E-06_JPRB, 0.25404199E-06_JPRB, 0.25300637E-06_JPRB, &
  & 0.25211169E-06_JPRB, 0.25069810E-06_JPRB, 0.24903002E-06_JPRB, 0.24759900E-06_JPRB, 0.24641970E-06_JPRB, 0.24520479E-06_JPRB, &
  & 0.24375687E-06_JPRB, 0.24220680E-06_JPRB, 0.24057854E-06_JPRB, 0.23870438E-06_JPRB, 0.23680541E-06_JPRB, 0.23487282E-06_JPRB, &
  & 0.23327804E-06_JPRB, 0.23202565E-06_JPRB, 0.23112959E-06_JPRB, 0.23023212E-06_JPRB, 0.22934662E-06_JPRB, 0.22856667E-06_JPRB, &
  & 0.22796637E-06_JPRB, 0.22748493E-06_JPRB, 0.22718913E-06_JPRB, 0.22702580E-06_JPRB, 0.22691720E-06_JPRB, 0.22691388E-06_JPRB, &
  & 0.22678095E-06_JPRB, 0.22655011E-06_JPRB, 0.22655974E-06_JPRB, 0.22642057E-06_JPRB  /)

RGHG2(:, 6, 2) = (/ &
  & 0.14632410E-06_JPRB, 0.14633699E-06_JPRB, 0.14624067E-06_JPRB, 0.14593042E-06_JPRB, 0.14547329E-06_JPRB, 0.14509667E-06_JPRB, &
  & 0.14506702E-06_JPRB, 0.14553860E-06_JPRB, 0.14630538E-06_JPRB, 0.14727816E-06_JPRB, 0.14851570E-06_JPRB, 0.15032489E-06_JPRB, &
  & 0.15289756E-06_JPRB, 0.15658222E-06_JPRB, 0.16178521E-06_JPRB, 0.16879518E-06_JPRB, 0.17702853E-06_JPRB, 0.18592618E-06_JPRB, &
  & 0.19543317E-06_JPRB, 0.20617350E-06_JPRB, 0.21778974E-06_JPRB, 0.22906168E-06_JPRB, 0.23958662E-06_JPRB, 0.24897829E-06_JPRB, &
  & 0.25673964E-06_JPRB, 0.26210900E-06_JPRB, 0.26543517E-06_JPRB, 0.26757320E-06_JPRB, 0.26898069E-06_JPRB, 0.26978896E-06_JPRB, &
  & 0.26971178E-06_JPRB, 0.26843184E-06_JPRB, 0.26659408E-06_JPRB, 0.26453596E-06_JPRB, 0.26216871E-06_JPRB, 0.26028381E-06_JPRB, &
  & 0.25898882E-06_JPRB, 0.25736066E-06_JPRB, 0.25526614E-06_JPRB, 0.25321033E-06_JPRB, 0.25144230E-06_JPRB, 0.24954039E-06_JPRB, &
  & 0.24732434E-06_JPRB, 0.24512694E-06_JPRB, 0.24280176E-06_JPRB, 0.24042813E-06_JPRB, 0.23840204E-06_JPRB, 0.23656141E-06_JPRB, &
  & 0.23502523E-06_JPRB, 0.23378547E-06_JPRB, 0.23282088E-06_JPRB, 0.23189637E-06_JPRB, 0.23107398E-06_JPRB, 0.23035984E-06_JPRB, &
  & 0.22977487E-06_JPRB, 0.22937457E-06_JPRB, 0.22905533E-06_JPRB, 0.22887937E-06_JPRB, 0.22871037E-06_JPRB, 0.22861508E-06_JPRB, &
  & 0.22848036E-06_JPRB, 0.22829009E-06_JPRB, 0.22831143E-06_JPRB, 0.22823628E-06_JPRB  /)

RGHG2(:, 7, 2) = (/ &
  & 0.14715941E-06_JPRB, 0.14711991E-06_JPRB, 0.14696723E-06_JPRB, 0.14667174E-06_JPRB, 0.14636345E-06_JPRB, 0.14617697E-06_JPRB, &
  & 0.14640121E-06_JPRB, 0.14732504E-06_JPRB, 0.14857276E-06_JPRB, 0.14995424E-06_JPRB, 0.15167483E-06_JPRB, 0.15437275E-06_JPRB, &
  & 0.15842085E-06_JPRB, 0.16418538E-06_JPRB, 0.17200919E-06_JPRB, 0.18219311E-06_JPRB, 0.19402025E-06_JPRB, 0.20654495E-06_JPRB, &
  & 0.21953308E-06_JPRB, 0.23378876E-06_JPRB, 0.24847131E-06_JPRB, 0.26168650E-06_JPRB, 0.27363011E-06_JPRB, 0.28425598E-06_JPRB, &
  & 0.29247076E-06_JPRB, 0.29740527E-06_JPRB, 0.29959572E-06_JPRB, 0.30007878E-06_JPRB, 0.29980336E-06_JPRB, 0.29926079E-06_JPRB, &
  & 0.29800376E-06_JPRB, 0.29528248E-06_JPRB, 0.29142175E-06_JPRB, 0.28746099E-06_JPRB, 0.28319939E-06_JPRB, 0.27956578E-06_JPRB, &
  & 0.27660175E-06_JPRB, 0.27257856E-06_JPRB, 0.26831127E-06_JPRB, 0.26456201E-06_JPRB, 0.26141025E-06_JPRB, 0.25795192E-06_JPRB, &
  & 0.25409359E-06_JPRB, 0.25045663E-06_JPRB, 0.24718666E-06_JPRB, 0.24462316E-06_JPRB, 0.24267529E-06_JPRB, 0.24101878E-06_JPRB, &
  & 0.23929156E-06_JPRB, 0.23764834E-06_JPRB, 0.23627469E-06_JPRB, 0.23506233E-06_JPRB, 0.23411951E-06_JPRB, 0.23328327E-06_JPRB, &
  & 0.23253182E-06_JPRB, 0.23194582E-06_JPRB, 0.23137012E-06_JPRB, 0.23095369E-06_JPRB, 0.23045702E-06_JPRB, 0.23006241E-06_JPRB, &
  & 0.22965380E-06_JPRB, 0.22908060E-06_JPRB, 0.22879299E-06_JPRB, 0.22844529E-06_JPRB  /)

RGHG2(:, 8, 2) = (/ &
  & 0.14765862E-06_JPRB, 0.14761774E-06_JPRB, 0.14763147E-06_JPRB, 0.14771659E-06_JPRB, 0.14796337E-06_JPRB, 0.14840079E-06_JPRB, &
  & 0.14925974E-06_JPRB, 0.15082983E-06_JPRB, 0.15266851E-06_JPRB, 0.15467606E-06_JPRB, 0.15732247E-06_JPRB, 0.16157127E-06_JPRB, &
  & 0.16781029E-06_JPRB, 0.17631014E-06_JPRB, 0.18720237E-06_JPRB, 0.20070429E-06_JPRB, 0.21615370E-06_JPRB, 0.23274445E-06_JPRB, &
  & 0.24995749E-06_JPRB, 0.26842960E-06_JPRB, 0.28731382E-06_JPRB, 0.30459249E-06_JPRB, 0.32062530E-06_JPRB, 0.33533821E-06_JPRB, &
  & 0.34689177E-06_JPRB, 0.35368135E-06_JPRB, 0.35659252E-06_JPRB, 0.35713430E-06_JPRB, 0.35663789E-06_JPRB, 0.35571246E-06_JPRB, &
  & 0.35373374E-06_JPRB, 0.34926214E-06_JPRB, 0.34187437E-06_JPRB, 0.33371544E-06_JPRB, 0.32486526E-06_JPRB, 0.31648470E-06_JPRB, &
  & 0.30910060E-06_JPRB, 0.30027816E-06_JPRB, 0.29130406E-06_JPRB, 0.28366758E-06_JPRB, 0.27764565E-06_JPRB, 0.27164438E-06_JPRB, &
  & 0.26557190E-06_JPRB, 0.26010112E-06_JPRB, 0.25609724E-06_JPRB, 0.25361800E-06_JPRB, 0.25171034E-06_JPRB, 0.24999871E-06_JPRB, &
  & 0.24776951E-06_JPRB, 0.24547105E-06_JPRB, 0.24313804E-06_JPRB, 0.24119610E-06_JPRB, 0.23988400E-06_JPRB, 0.23875458E-06_JPRB, &
  & 0.23764459E-06_JPRB, 0.23658610E-06_JPRB, 0.23563691E-06_JPRB, 0.23477682E-06_JPRB, 0.23379278E-06_JPRB, 0.23297071E-06_JPRB, &
  & 0.23203202E-06_JPRB, 0.23099786E-06_JPRB, 0.23018768E-06_JPRB, 0.22925588E-06_JPRB  /)

RGHG2(:, 9, 2) = (/ &
  & 0.15013203E-06_JPRB, 0.15036816E-06_JPRB, 0.15101815E-06_JPRB, 0.15199047E-06_JPRB, 0.15317089E-06_JPRB, 0.15450635E-06_JPRB, &
  & 0.15615781E-06_JPRB, 0.15836327E-06_JPRB, 0.16085725E-06_JPRB, 0.16388296E-06_JPRB, 0.16820850E-06_JPRB, 0.17496224E-06_JPRB, &
  & 0.18420126E-06_JPRB, 0.19586046E-06_JPRB, 0.20976748E-06_JPRB, 0.22591820E-06_JPRB, 0.24387866E-06_JPRB, 0.26370716E-06_JPRB, &
  & 0.28492321E-06_JPRB, 0.30747823E-06_JPRB, 0.33115663E-06_JPRB, 0.35502799E-06_JPRB, 0.37880884E-06_JPRB, 0.40175644E-06_JPRB, &
  & 0.42049883E-06_JPRB, 0.43265548E-06_JPRB, 0.43994228E-06_JPRB, 0.44463157E-06_JPRB, 0.44761825E-06_JPRB, 0.44904068E-06_JPRB, &
  & 0.44809108E-06_JPRB, 0.44251531E-06_JPRB, 0.43025417E-06_JPRB, 0.41335681E-06_JPRB, 0.39403150E-06_JPRB, 0.37578053E-06_JPRB, &
  & 0.35966431E-06_JPRB, 0.34271934E-06_JPRB, 0.32552669E-06_JPRB, 0.31045573E-06_JPRB, 0.29940652E-06_JPRB, 0.29017327E-06_JPRB, &
  & 0.28182879E-06_JPRB, 0.27505762E-06_JPRB, 0.27092507E-06_JPRB, 0.26855982E-06_JPRB, 0.26679706E-06_JPRB, 0.26458948E-06_JPRB, &
  & 0.26147038E-06_JPRB, 0.25826733E-06_JPRB, 0.25469173E-06_JPRB, 0.25170454E-06_JPRB, 0.24975305E-06_JPRB, 0.24810192E-06_JPRB, &
  & 0.24645593E-06_JPRB, 0.24454659E-06_JPRB, 0.24285250E-06_JPRB, 0.24140168E-06_JPRB, 0.23989658E-06_JPRB, 0.23863313E-06_JPRB, &
  & 0.23714087E-06_JPRB, 0.23569249E-06_JPRB, 0.23411261E-06_JPRB, 0.23254388E-06_JPRB  /)

RGHG2(:,10, 2) = (/ &
  & 0.16326059E-06_JPRB, 0.16407928E-06_JPRB, 0.16558707E-06_JPRB, 0.16747531E-06_JPRB, 0.16924907E-06_JPRB, 0.17076660E-06_JPRB, &
  & 0.17233181E-06_JPRB, 0.17453163E-06_JPRB, 0.17756843E-06_JPRB, 0.18214298E-06_JPRB, 0.18899398E-06_JPRB, 0.19913019E-06_JPRB, &
  & 0.21197990E-06_JPRB, 0.22663675E-06_JPRB, 0.24288703E-06_JPRB, 0.26066620E-06_JPRB, 0.27977537E-06_JPRB, 0.30118149E-06_JPRB, &
  & 0.32505543E-06_JPRB, 0.35054817E-06_JPRB, 0.37830108E-06_JPRB, 0.40989808E-06_JPRB, 0.44427126E-06_JPRB, 0.47881690E-06_JPRB, &
  & 0.50685323E-06_JPRB, 0.52716043E-06_JPRB, 0.54288514E-06_JPRB, 0.55634722E-06_JPRB, 0.56673566E-06_JPRB, 0.57296107E-06_JPRB, &
  & 0.57407349E-06_JPRB, 0.56667403E-06_JPRB, 0.54647342E-06_JPRB, 0.51427783E-06_JPRB, 0.47652938E-06_JPRB, 0.44222138E-06_JPRB, &
  & 0.41257849E-06_JPRB, 0.38437608E-06_JPRB, 0.35777338E-06_JPRB, 0.33453030E-06_JPRB, 0.31844504E-06_JPRB, 0.30736869E-06_JPRB, &
  & 0.29888166E-06_JPRB, 0.29323595E-06_JPRB, 0.28960718E-06_JPRB, 0.28701297E-06_JPRB, 0.28550559E-06_JPRB, 0.28258777E-06_JPRB, &
  & 0.27842244E-06_JPRB, 0.27426834E-06_JPRB, 0.26975660E-06_JPRB, 0.26586042E-06_JPRB, 0.26307183E-06_JPRB, 0.26068984E-06_JPRB, &
  & 0.25846513E-06_JPRB, 0.25580919E-06_JPRB, 0.25310667E-06_JPRB, 0.25105687E-06_JPRB, 0.24914200E-06_JPRB, 0.24770458E-06_JPRB, &
  & 0.24607392E-06_JPRB, 0.24413629E-06_JPRB, 0.24174984E-06_JPRB, 0.23966129E-06_JPRB  /)

RGHG2(:,11, 2) = (/ &
  & 0.19562418E-06_JPRB, 0.19667716E-06_JPRB, 0.19837236E-06_JPRB, 0.20035167E-06_JPRB, 0.20160969E-06_JPRB, 0.20176249E-06_JPRB, &
  & 0.20155237E-06_JPRB, 0.20265006E-06_JPRB, 0.20603943E-06_JPRB, 0.21267064E-06_JPRB, 0.22256852E-06_JPRB, 0.23611068E-06_JPRB, &
  & 0.25211518E-06_JPRB, 0.26868951E-06_JPRB, 0.28597967E-06_JPRB, 0.30439370E-06_JPRB, 0.32411071E-06_JPRB, 0.34634763E-06_JPRB, &
  & 0.37121837E-06_JPRB, 0.39765680E-06_JPRB, 0.42742802E-06_JPRB, 0.46521030E-06_JPRB, 0.51107174E-06_JPRB, 0.55801876E-06_JPRB, &
  & 0.59551126E-06_JPRB, 0.62474218E-06_JPRB, 0.64977025E-06_JPRB, 0.67180448E-06_JPRB, 0.68825846E-06_JPRB, 0.69658814E-06_JPRB, &
  & 0.69535624E-06_JPRB, 0.67939099E-06_JPRB, 0.64430324E-06_JPRB, 0.59336282E-06_JPRB, 0.53496114E-06_JPRB, 0.48138367E-06_JPRB, &
  & 0.43575859E-06_JPRB, 0.39720215E-06_JPRB, 0.36605568E-06_JPRB, 0.34072946E-06_JPRB, 0.32496879E-06_JPRB, 0.31646745E-06_JPRB, &
  & 0.31207779E-06_JPRB, 0.30969942E-06_JPRB, 0.30711667E-06_JPRB, 0.30429531E-06_JPRB, 0.30209192E-06_JPRB, 0.29840490E-06_JPRB, &
  & 0.29347722E-06_JPRB, 0.28866274E-06_JPRB, 0.28359220E-06_JPRB, 0.27929729E-06_JPRB, 0.27588639E-06_JPRB, 0.27309280E-06_JPRB, &
  & 0.27058333E-06_JPRB, 0.26810416E-06_JPRB, 0.26520017E-06_JPRB, 0.26278764E-06_JPRB, 0.26039073E-06_JPRB, 0.25894878E-06_JPRB, &
  & 0.25718681E-06_JPRB, 0.25460891E-06_JPRB, 0.25203164E-06_JPRB, 0.24939494E-06_JPRB  /)

RGHG2(:,12, 2) = (/ &
  & 0.24129871E-06_JPRB, 0.24190081E-06_JPRB, 0.24306204E-06_JPRB, 0.24439938E-06_JPRB, 0.24470950E-06_JPRB, 0.24296147E-06_JPRB, &
  & 0.24046657E-06_JPRB, 0.24028904E-06_JPRB, 0.24424737E-06_JPRB, 0.25321111E-06_JPRB, 0.26592250E-06_JPRB, 0.28150043E-06_JPRB, &
  & 0.29852333E-06_JPRB, 0.31546572E-06_JPRB, 0.33272530E-06_JPRB, 0.35102602E-06_JPRB, 0.37096200E-06_JPRB, 0.39400856E-06_JPRB, &
  & 0.41908325E-06_JPRB, 0.44511034E-06_JPRB, 0.47490918E-06_JPRB, 0.51578714E-06_JPRB, 0.57111236E-06_JPRB, 0.63039029E-06_JPRB, &
  & 0.67897573E-06_JPRB, 0.71663910E-06_JPRB, 0.74745053E-06_JPRB, 0.77303801E-06_JPRB, 0.78966224E-06_JPRB, 0.79433370E-06_JPRB, &
  & 0.78531586E-06_JPRB, 0.75780096E-06_JPRB, 0.70934426E-06_JPRB, 0.64454772E-06_JPRB, 0.57187208E-06_JPRB, 0.50266623E-06_JPRB, &
  & 0.44259027E-06_JPRB, 0.39651272E-06_JPRB, 0.36319909E-06_JPRB, 0.33942990E-06_JPRB, 0.32745558E-06_JPRB, 0.32346762E-06_JPRB, &
  & 0.32294447E-06_JPRB, 0.32199589E-06_JPRB, 0.32027709E-06_JPRB, 0.31725076E-06_JPRB, 0.31362171E-06_JPRB, 0.30864600E-06_JPRB, &
  & 0.30295084E-06_JPRB, 0.29785537E-06_JPRB, 0.29315192E-06_JPRB, 0.28930187E-06_JPRB, 0.28601286E-06_JPRB, 0.28360318E-06_JPRB, &
  & 0.28148473E-06_JPRB, 0.27936029E-06_JPRB, 0.27677002E-06_JPRB, 0.27446798E-06_JPRB, 0.27128253E-06_JPRB, 0.26889033E-06_JPRB, &
  & 0.26662069E-06_JPRB, 0.26368805E-06_JPRB, 0.26089843E-06_JPRB, 0.25860388E-06_JPRB  /)

RGHG2(:,13, 2) = (/ &
  & 0.29561721E-06_JPRB, 0.29523097E-06_JPRB, 0.29535026E-06_JPRB, 0.29551928E-06_JPRB, 0.29457506E-06_JPRB, 0.29120363E-06_JPRB, &
  & 0.28744520E-06_JPRB, 0.28670583E-06_JPRB, 0.29085125E-06_JPRB, 0.30132290E-06_JPRB, 0.31553979E-06_JPRB, 0.33116173E-06_JPRB, &
  & 0.34692178E-06_JPRB, 0.36267056E-06_JPRB, 0.37905013E-06_JPRB, 0.39678887E-06_JPRB, 0.41618803E-06_JPRB, 0.43899406E-06_JPRB, &
  & 0.46344088E-06_JPRB, 0.48891146E-06_JPRB, 0.51782516E-06_JPRB, 0.55871261E-06_JPRB, 0.61907329E-06_JPRB, 0.68994289E-06_JPRB, &
  & 0.75247203E-06_JPRB, 0.80014320E-06_JPRB, 0.83571897E-06_JPRB, 0.86224476E-06_JPRB, 0.87637608E-06_JPRB, 0.87554518E-06_JPRB, &
  & 0.86058265E-06_JPRB, 0.82945163E-06_JPRB, 0.77864436E-06_JPRB, 0.71106967E-06_JPRB, 0.63652864E-06_JPRB, 0.56105886E-06_JPRB, &
  & 0.49076530E-06_JPRB, 0.43213806E-06_JPRB, 0.38741157E-06_JPRB, 0.35927806E-06_JPRB, 0.34482959E-06_JPRB, 0.33965143E-06_JPRB, &
  & 0.33824220E-06_JPRB, 0.33609390E-06_JPRB, 0.33316457E-06_JPRB, 0.32947064E-06_JPRB, 0.32512954E-06_JPRB, 0.31912880E-06_JPRB, &
  & 0.31182666E-06_JPRB, 0.30620192E-06_JPRB, 0.30172751E-06_JPRB, 0.29779331E-06_JPRB, 0.29445605E-06_JPRB, 0.29237770E-06_JPRB, &
  & 0.29062455E-06_JPRB, 0.28879830E-06_JPRB, 0.28651219E-06_JPRB, 0.28423091E-06_JPRB, 0.27999514E-06_JPRB, 0.27597491E-06_JPRB, &
  & 0.27307007E-06_JPRB, 0.26989945E-06_JPRB, 0.26610230E-06_JPRB, 0.26370597E-06_JPRB  /)

RGHG2(:,14, 2) = (/ &
  & 0.35686373E-06_JPRB, 0.35550571E-06_JPRB, 0.35455186E-06_JPRB, 0.35345534E-06_JPRB, 0.35084670E-06_JPRB, 0.34651851E-06_JPRB, &
  & 0.34271033E-06_JPRB, 0.34175116E-06_JPRB, 0.34516401E-06_JPRB, 0.35527939E-06_JPRB, 0.36938145E-06_JPRB, 0.38400578E-06_JPRB, &
  & 0.39790202E-06_JPRB, 0.41205870E-06_JPRB, 0.42721055E-06_JPRB, 0.44354445E-06_JPRB, 0.46162565E-06_JPRB, 0.48266825E-06_JPRB, &
  & 0.50525446E-06_JPRB, 0.53000040E-06_JPRB, 0.55848542E-06_JPRB, 0.59759786E-06_JPRB, 0.65746893E-06_JPRB, 0.73582529E-06_JPRB, &
  & 0.81337595E-06_JPRB, 0.87618139E-06_JPRB, 0.92196404E-06_JPRB, 0.95267001E-06_JPRB, 0.96757044E-06_JPRB, 0.96555315E-06_JPRB, &
  & 0.94980212E-06_JPRB, 0.92255215E-06_JPRB, 0.87904101E-06_JPRB, 0.81855048E-06_JPRB, 0.75128282E-06_JPRB, 0.67832147E-06_JPRB, &
  & 0.60524711E-06_JPRB, 0.53305498E-06_JPRB, 0.46174993E-06_JPRB, 0.41197489E-06_JPRB, 0.38386123E-06_JPRB, 0.37143054E-06_JPRB, &
  & 0.36618593E-06_JPRB, 0.36069577E-06_JPRB, 0.35497642E-06_JPRB, 0.34960718E-06_JPRB, 0.34417659E-06_JPRB, 0.33745917E-06_JPRB, &
  & 0.32743266E-06_JPRB, 0.31904432E-06_JPRB, 0.31308523E-06_JPRB, 0.30771378E-06_JPRB, 0.30374951E-06_JPRB, 0.30108771E-06_JPRB, &
  & 0.29920946E-06_JPRB, 0.29749743E-06_JPRB, 0.29540201E-06_JPRB, 0.29255437E-06_JPRB, 0.28701564E-06_JPRB, 0.28208853E-06_JPRB, &
  & 0.27787862E-06_JPRB, 0.27362846E-06_JPRB, 0.26952441E-06_JPRB, 0.26626720E-06_JPRB  /)

RGHG2(:,15, 2) = (/ &
  & 0.42411849E-06_JPRB, 0.42222927E-06_JPRB, 0.42051201E-06_JPRB, 0.41836546E-06_JPRB, 0.41442561E-06_JPRB, 0.40996115E-06_JPRB, &
  & 0.40654459E-06_JPRB, 0.40540374E-06_JPRB, 0.40739394E-06_JPRB, 0.41522583E-06_JPRB, 0.42761544E-06_JPRB, 0.44059991E-06_JPRB, &
  & 0.45301996E-06_JPRB, 0.46632758E-06_JPRB, 0.48059545E-06_JPRB, 0.49477839E-06_JPRB, 0.51022601E-06_JPRB, 0.52834330E-06_JPRB, &
  & 0.54847961E-06_JPRB, 0.57208731E-06_JPRB, 0.60072000E-06_JPRB, 0.63880996E-06_JPRB, 0.69477266E-06_JPRB, 0.77443861E-06_JPRB, &
  & 0.86446927E-06_JPRB, 0.94693593E-06_JPRB, 0.10107618E-05_JPRB, 0.10521358E-05_JPRB, 0.10717876E-05_JPRB, 0.10740754E-05_JPRB, &
  & 0.10639352E-05_JPRB, 0.10429937E-05_JPRB, 0.10050619E-05_JPRB, 0.95123031E-06_JPRB, 0.89281025E-06_JPRB, 0.82640321E-06_JPRB, &
  & 0.75246227E-06_JPRB, 0.67472722E-06_JPRB, 0.57472199E-06_JPRB, 0.48538689E-06_JPRB, 0.43558374E-06_JPRB, 0.41584618E-06_JPRB, &
  & 0.40688704E-06_JPRB, 0.39665883E-06_JPRB, 0.38770455E-06_JPRB, 0.38016649E-06_JPRB, 0.37290272E-06_JPRB, 0.36480660E-06_JPRB, &
  & 0.35210726E-06_JPRB, 0.33966577E-06_JPRB, 0.33035708E-06_JPRB, 0.32267191E-06_JPRB, 0.31705845E-06_JPRB, 0.31308400E-06_JPRB, &
  & 0.31033315E-06_JPRB, 0.30815458E-06_JPRB, 0.30606365E-06_JPRB, 0.30170955E-06_JPRB, 0.29456203E-06_JPRB, 0.28903991E-06_JPRB, &
  & 0.28260133E-06_JPRB, 0.27622972E-06_JPRB, 0.27247224E-06_JPRB, 0.27044779E-06_JPRB  /)

RGHG2(:,16, 2) = (/ &
  & 0.48988615E-06_JPRB, 0.48755155E-06_JPRB, 0.48542221E-06_JPRB, 0.48320648E-06_JPRB, 0.47941498E-06_JPRB, 0.47578415E-06_JPRB, &
  & 0.47325848E-06_JPRB, 0.47263115E-06_JPRB, 0.47379722E-06_JPRB, 0.47884354E-06_JPRB, 0.48840361E-06_JPRB, 0.49929546E-06_JPRB, &
  & 0.51045791E-06_JPRB, 0.52329455E-06_JPRB, 0.53703107E-06_JPRB, 0.54937070E-06_JPRB, 0.56183350E-06_JPRB, 0.57685879E-06_JPRB, &
  & 0.59449645E-06_JPRB, 0.61680572E-06_JPRB, 0.64589746E-06_JPRB, 0.68465364E-06_JPRB, 0.73804874E-06_JPRB, 0.81542970E-06_JPRB, &
  & 0.91285690E-06_JPRB, 0.10141544E-05_JPRB, 0.10989951E-05_JPRB, 0.11550463E-05_JPRB, 0.11812418E-05_JPRB, 0.11885313E-05_JPRB, &
  & 0.11860127E-05_JPRB, 0.11729103E-05_JPRB, 0.11370521E-05_JPRB, 0.10822296E-05_JPRB, 0.10259167E-05_JPRB, 0.96573868E-06_JPRB, &
  & 0.88996010E-06_JPRB, 0.80635152E-06_JPRB, 0.69169646E-06_JPRB, 0.56550063E-06_JPRB, 0.48985855E-06_JPRB, 0.46545350E-06_JPRB, &
  & 0.45318051E-06_JPRB, 0.43989708E-06_JPRB, 0.42856972E-06_JPRB, 0.41920496E-06_JPRB, 0.41063844E-06_JPRB, 0.40043604E-06_JPRB, &
  & 0.38614721E-06_JPRB, 0.37002960E-06_JPRB, 0.35579419E-06_JPRB, 0.34477219E-06_JPRB, 0.33631858E-06_JPRB, 0.32984063E-06_JPRB, &
  & 0.32556931E-06_JPRB, 0.32246062E-06_JPRB, 0.32006464E-06_JPRB, 0.31398789E-06_JPRB, 0.30490175E-06_JPRB, 0.29757814E-06_JPRB, &
  & 0.28769851E-06_JPRB, 0.27871944E-06_JPRB, 0.27539226E-06_JPRB, 0.27509497E-06_JPRB  /)

RGHG2(:,17, 2) = (/ &
  & 0.54984295E-06_JPRB, 0.54740294E-06_JPRB, 0.54501150E-06_JPRB, 0.54284536E-06_JPRB, 0.54019079E-06_JPRB, 0.53802492E-06_JPRB, &
  & 0.53675680E-06_JPRB, 0.53747457E-06_JPRB, 0.53925258E-06_JPRB, 0.54277539E-06_JPRB, 0.54973657E-06_JPRB, 0.55881184E-06_JPRB, &
  & 0.56892445E-06_JPRB, 0.58086809E-06_JPRB, 0.59389257E-06_JPRB, 0.60543890E-06_JPRB, 0.61633979E-06_JPRB, 0.62917011E-06_JPRB, &
  & 0.64468383E-06_JPRB, 0.66563668E-06_JPRB, 0.69557835E-06_JPRB, 0.73674162E-06_JPRB, 0.79112773E-06_JPRB, 0.86707317E-06_JPRB, &
  & 0.96843618E-06_JPRB, 0.10833292E-05_JPRB, 0.11834767E-05_JPRB, 0.12509070E-05_JPRB, 0.12832005E-05_JPRB, 0.12943662E-05_JPRB, &
  & 0.12971954E-05_JPRB, 0.12890226E-05_JPRB, 0.12558551E-05_JPRB, 0.12011405E-05_JPRB, 0.11405781E-05_JPRB, 0.10767707E-05_JPRB, &
  & 0.10028508E-05_JPRB, 0.91196322E-06_JPRB, 0.78893608E-06_JPRB, 0.64312068E-06_JPRB, 0.54530738E-06_JPRB, 0.51644859E-06_JPRB, &
  & 0.50342478E-06_JPRB, 0.49100164E-06_JPRB, 0.47993164E-06_JPRB, 0.46963567E-06_JPRB, 0.46018255E-06_JPRB, 0.44776650E-06_JPRB, &
  & 0.43183021E-06_JPRB, 0.41187683E-06_JPRB, 0.39144118E-06_JPRB, 0.37439690E-06_JPRB, 0.36209134E-06_JPRB, 0.35255198E-06_JPRB, &
  & 0.34618437E-06_JPRB, 0.34135266E-06_JPRB, 0.33788706E-06_JPRB, 0.33079080E-06_JPRB, 0.31892821E-06_JPRB, 0.30848285E-06_JPRB, &
  & 0.29389154E-06_JPRB, 0.28323986E-06_JPRB, 0.28034130E-06_JPRB, 0.28071605E-06_JPRB  /)

RGHG2(:,18, 2) = (/ &
  & 0.60565124E-06_JPRB, 0.60328378E-06_JPRB, 0.60045030E-06_JPRB, 0.59808535E-06_JPRB, 0.59658838E-06_JPRB, 0.59582334E-06_JPRB, &
  & 0.59598902E-06_JPRB, 0.59776669E-06_JPRB, 0.60090868E-06_JPRB, 0.60503330E-06_JPRB, 0.61093218E-06_JPRB, 0.61885890E-06_JPRB, &
  & 0.62820541E-06_JPRB, 0.63900586E-06_JPRB, 0.65103563E-06_JPRB, 0.66271875E-06_JPRB, 0.67389003E-06_JPRB, 0.68587930E-06_JPRB, &
  & 0.70006279E-06_JPRB, 0.72022879E-06_JPRB, 0.75120472E-06_JPRB, 0.79611458E-06_JPRB, 0.85410908E-06_JPRB, 0.92988628E-06_JPRB, &
  & 0.10317948E-05_JPRB, 0.11521195E-05_JPRB, 0.12588282E-05_JPRB, 0.13310779E-05_JPRB, 0.13681952E-05_JPRB, 0.13831400E-05_JPRB, &
  & 0.13895093E-05_JPRB, 0.13856164E-05_JPRB, 0.13566548E-05_JPRB, 0.13006622E-05_JPRB, 0.12355232E-05_JPRB, 0.11666990E-05_JPRB, &
  & 0.10881317E-05_JPRB, 0.99085711E-06_JPRB, 0.86450873E-06_JPRB, 0.71258896E-06_JPRB, 0.59895879E-06_JPRB, 0.56477871E-06_JPRB, &
  & 0.55753499E-06_JPRB, 0.54963071E-06_JPRB, 0.54130847E-06_JPRB, 0.53195084E-06_JPRB, 0.52158972E-06_JPRB, 0.50686336E-06_JPRB, &
  & 0.48741467E-06_JPRB, 0.46332398E-06_JPRB, 0.43649421E-06_JPRB, 0.41211848E-06_JPRB, 0.39418901E-06_JPRB, 0.38118199E-06_JPRB, &
  & 0.37216484E-06_JPRB, 0.36515884E-06_JPRB, 0.35906810E-06_JPRB, 0.35086651E-06_JPRB, 0.33690146E-06_JPRB, 0.32155704E-06_JPRB, &
  & 0.30203082E-06_JPRB, 0.29080989E-06_JPRB, 0.28806786E-06_JPRB, 0.28792069E-06_JPRB  /)

RGHG2(:,19, 2) = (/ &
  & 0.66275485E-06_JPRB, 0.66037779E-06_JPRB, 0.65700018E-06_JPRB, 0.65472503E-06_JPRB, 0.65384239E-06_JPRB, 0.65404598E-06_JPRB, &
  & 0.65508264E-06_JPRB, 0.65765352E-06_JPRB, 0.66158425E-06_JPRB, 0.66704863E-06_JPRB, 0.67359313E-06_JPRB, 0.68129067E-06_JPRB, &
  & 0.68988095E-06_JPRB, 0.69961715E-06_JPRB, 0.71094658E-06_JPRB, 0.72317074E-06_JPRB, 0.73550637E-06_JPRB, 0.74787535E-06_JPRB, &
  & 0.76177243E-06_JPRB, 0.78184594E-06_JPRB, 0.81372542E-06_JPRB, 0.86240403E-06_JPRB, 0.92445271E-06_JPRB, 0.10004108E-05_JPRB, &
  & 0.10990366E-05_JPRB, 0.12161400E-05_JPRB, 0.13208107E-05_JPRB, 0.13934409E-05_JPRB, 0.14346227E-05_JPRB, 0.14541565E-05_JPRB, &
  & 0.14635017E-05_JPRB, 0.14618578E-05_JPRB, 0.14359484E-05_JPRB, 0.13774777E-05_JPRB, 0.13061101E-05_JPRB, 0.12337358E-05_JPRB, &
  & 0.11489022E-05_JPRB, 0.10449138E-05_JPRB, 0.91756186E-06_JPRB, 0.76717401E-06_JPRB, 0.65110040E-06_JPRB, 0.61394080E-06_JPRB, &
  & 0.61274851E-06_JPRB, 0.61090396E-06_JPRB, 0.60671647E-06_JPRB, 0.59974474E-06_JPRB, 0.58988018E-06_JPRB, 0.57385354E-06_JPRB, &
  & 0.55017762E-06_JPRB, 0.52174423E-06_JPRB, 0.48947570E-06_JPRB, 0.45760049E-06_JPRB, 0.43314909E-06_JPRB, 0.41609403E-06_JPRB, &
  & 0.40375319E-06_JPRB, 0.39407214E-06_JPRB, 0.38403647E-06_JPRB, 0.37402567E-06_JPRB, 0.35803594E-06_JPRB, 0.33679421E-06_JPRB, &
  & 0.31334167E-06_JPRB, 0.30176920E-06_JPRB, 0.29895759E-06_JPRB, 0.29776979E-06_JPRB  /)

RGHG2(:,20, 2) = (/ &
  & 0.72202017E-06_JPRB, 0.71974669E-06_JPRB, 0.71636987E-06_JPRB, 0.71455384E-06_JPRB, 0.71410455E-06_JPRB, 0.71494196E-06_JPRB, &
  & 0.71681236E-06_JPRB, 0.72000125E-06_JPRB, 0.72411064E-06_JPRB, 0.73034855E-06_JPRB, 0.73797938E-06_JPRB, 0.74612288E-06_JPRB, &
  & 0.75437819E-06_JPRB, 0.76333548E-06_JPRB, 0.77431933E-06_JPRB, 0.78729017E-06_JPRB, 0.80115738E-06_JPRB, 0.81450325E-06_JPRB, &
  & 0.82895978E-06_JPRB, 0.84986782E-06_JPRB, 0.88272746E-06_JPRB, 0.93416424E-06_JPRB, 0.99928504E-06_JPRB, 0.10746118E-05_JPRB, &
  & 0.11671446E-05_JPRB, 0.12747466E-05_JPRB, 0.13711538E-05_JPRB, 0.14410391E-05_JPRB, 0.14855081E-05_JPRB, 0.15100977E-05_JPRB, &
  & 0.15224209E-05_JPRB, 0.15212523E-05_JPRB, 0.14958247E-05_JPRB, 0.14364356E-05_JPRB, 0.13608465E-05_JPRB, 0.12849328E-05_JPRB, &
  & 0.11959938E-05_JPRB, 0.10879462E-05_JPRB, 0.96011744E-06_JPRB, 0.81324253E-06_JPRB, 0.70287649E-06_JPRB, 0.66596014E-06_JPRB, &
  & 0.66800320E-06_JPRB, 0.67172600E-06_JPRB, 0.67173076E-06_JPRB, 0.66764143E-06_JPRB, 0.65897472E-06_JPRB, 0.64266988E-06_JPRB, &
  & 0.61619701E-06_JPRB, 0.58444088E-06_JPRB, 0.54809701E-06_JPRB, 0.51022719E-06_JPRB, 0.47899461E-06_JPRB, 0.45683419E-06_JPRB, &
  & 0.44042229E-06_JPRB, 0.42684089E-06_JPRB, 0.41274819E-06_JPRB, 0.39994456E-06_JPRB, 0.38042177E-06_JPRB, 0.35376504E-06_JPRB, &
  & 0.32825295E-06_JPRB, 0.31613957E-06_JPRB, 0.31257327E-06_JPRB, 0.31087246E-06_JPRB  /)

RGHG2(:,21, 2) = (/ &
  & 0.78281353E-06_JPRB, 0.78085350E-06_JPRB, 0.77824040E-06_JPRB, 0.77710604E-06_JPRB, 0.77724822E-06_JPRB, 0.77873271E-06_JPRB, &
  & 0.78166895E-06_JPRB, 0.78540828E-06_JPRB, 0.78957410E-06_JPRB, 0.79598870E-06_JPRB, 0.80439083E-06_JPRB, 0.81315975E-06_JPRB, &
  & 0.82165841E-06_JPRB, 0.83034946E-06_JPRB, 0.84118688E-06_JPRB, 0.85483358E-06_JPRB, 0.87019968E-06_JPRB, 0.88482339E-06_JPRB, &
  & 0.90035571E-06_JPRB, 0.92301217E-06_JPRB, 0.95753558E-06_JPRB, 0.10105814E-05_JPRB, 0.10769501E-05_JPRB, 0.11502389E-05_JPRB, &
  & 0.12349086E-05_JPRB, 0.13295428E-05_JPRB, 0.14143257E-05_JPRB, 0.14792703E-05_JPRB, 0.15257403E-05_JPRB, 0.15548660E-05_JPRB, &
  & 0.15697773E-05_JPRB, 0.15679717E-05_JPRB, 0.15413832E-05_JPRB, 0.14836091E-05_JPRB, 0.14070151E-05_JPRB, 0.13275841E-05_JPRB, &
  & 0.12365550E-05_JPRB, 0.11276531E-05_JPRB, 0.99892371E-06_JPRB, 0.85541582E-06_JPRB, 0.75452401E-06_JPRB, 0.72050379E-06_JPRB, &
  & 0.72301366E-06_JPRB, 0.73078729E-06_JPRB, 0.73416737E-06_JPRB, 0.73268685E-06_JPRB, 0.72511449E-06_JPRB, 0.70911774E-06_JPRB, &
  & 0.68184008E-06_JPRB, 0.64831467E-06_JPRB, 0.60940366E-06_JPRB, 0.56764476E-06_JPRB, 0.53022471E-06_JPRB, 0.50196878E-06_JPRB, &
  & 0.48060680E-06_JPRB, 0.46212216E-06_JPRB, 0.44452180E-06_JPRB, 0.42785357E-06_JPRB, 0.40317894E-06_JPRB, 0.37239503E-06_JPRB, &
  & 0.34626269E-06_JPRB, 0.33319902E-06_JPRB, 0.32817774E-06_JPRB, 0.32644640E-06_JPRB  /)

RGHG2(:,22, 2) = (/ &
  & 0.84333560E-06_JPRB, 0.84192987E-06_JPRB, 0.84088414E-06_JPRB, 0.84043788E-06_JPRB, 0.84161222E-06_JPRB, 0.84422445E-06_JPRB, &
  & 0.84849868E-06_JPRB, 0.85283054E-06_JPRB, 0.85760801E-06_JPRB, 0.86417553E-06_JPRB, 0.87257766E-06_JPRB, 0.88153771E-06_JPRB, &
  & 0.89089651E-06_JPRB, 0.90018010E-06_JPRB, 0.91086461E-06_JPRB, 0.92472156E-06_JPRB, 0.94111983E-06_JPRB, 0.95725355E-06_JPRB, &
  & 0.97404740E-06_JPRB, 0.99930338E-06_JPRB, 0.10370762E-05_JPRB, 0.10907146E-05_JPRB, 0.11555732E-05_JPRB, 0.12249436E-05_JPRB, &
  & 0.13008399E-05_JPRB, 0.13817693E-05_JPRB, 0.14544339E-05_JPRB, 0.15128988E-05_JPRB, 0.15591012E-05_JPRB, 0.15907882E-05_JPRB, &
  & 0.16069037E-05_JPRB, 0.16039512E-05_JPRB, 0.15765217E-05_JPRB, 0.15230675E-05_JPRB, 0.14485569E-05_JPRB, 0.13668704E-05_JPRB, &
  & 0.12739490E-05_JPRB, 0.11666718E-05_JPRB, 0.10359163E-05_JPRB, 0.89523731E-06_JPRB, 0.80491560E-06_JPRB, 0.77559746E-06_JPRB, &
  & 0.77684580E-06_JPRB, 0.78632057E-06_JPRB, 0.79142093E-06_JPRB, 0.79150777E-06_JPRB, 0.78418388E-06_JPRB, 0.76855031E-06_JPRB, &
  & 0.74240038E-06_JPRB, 0.70898965E-06_JPRB, 0.66935231E-06_JPRB, 0.62615985E-06_JPRB, 0.58440090E-06_JPRB, 0.54941680E-06_JPRB, &
  & 0.52199565E-06_JPRB, 0.49836931E-06_JPRB, 0.47826500E-06_JPRB, 0.45655065E-06_JPRB, 0.42574038E-06_JPRB, 0.39279658E-06_JPRB, &
  & 0.36654955E-06_JPRB, 0.35189942E-06_JPRB, 0.34492849E-06_JPRB, 0.34302513E-06_JPRB  /)

RGHG2(:,23, 2) = (/ &
  & 0.90164760E-06_JPRB, 0.90159673E-06_JPRB, 0.90151820E-06_JPRB, 0.90183367E-06_JPRB, 0.90417342E-06_JPRB, 0.90768812E-06_JPRB, &
  & 0.91275167E-06_JPRB, 0.91807778E-06_JPRB, 0.92423177E-06_JPRB, 0.93212413E-06_JPRB, 0.94152978E-06_JPRB, 0.95154530E-06_JPRB, &
  & 0.96203492E-06_JPRB, 0.97211509E-06_JPRB, 0.98291922E-06_JPRB, 0.99620686E-06_JPRB, 0.10119764E-05_JPRB, 0.10287971E-05_JPRB, &
  & 0.10466606E-05_JPRB, 0.10738667E-05_JPRB, 0.11143775E-05_JPRB, 0.11684932E-05_JPRB, 0.12302319E-05_JPRB, 0.12942346E-05_JPRB, &
  & 0.13602478E-05_JPRB, 0.14279105E-05_JPRB, 0.14903000E-05_JPRB, 0.15434127E-05_JPRB, 0.15878972E-05_JPRB, 0.16192949E-05_JPRB, &
  & 0.16348922E-05_JPRB, 0.16307158E-05_JPRB, 0.16019904E-05_JPRB, 0.15495549E-05_JPRB, 0.14761305E-05_JPRB, 0.13911946E-05_JPRB, &
  & 0.12974670E-05_JPRB, 0.11939156E-05_JPRB, 0.10662313E-05_JPRB, 0.93268278E-06_JPRB, 0.85196002E-06_JPRB, 0.82581718E-06_JPRB, &
  & 0.82474912E-06_JPRB, 0.83049266E-06_JPRB, 0.83502655E-06_JPRB, 0.83474256E-06_JPRB, 0.82773556E-06_JPRB, 0.81358736E-06_JPRB, &
  & 0.79007326E-06_JPRB, 0.75810471E-06_JPRB, 0.71976920E-06_JPRB, 0.67720592E-06_JPRB, 0.63418277E-06_JPRB, 0.59509571E-06_JPRB, &
  & 0.56238496E-06_JPRB, 0.53475835E-06_JPRB, 0.51142224E-06_JPRB, 0.48474526E-06_JPRB, 0.44989878E-06_JPRB, 0.41557132E-06_JPRB, &
  & 0.38858154E-06_JPRB, 0.37267315E-06_JPRB, 0.36347557E-06_JPRB, 0.35908963E-06_JPRB  /)

RGHG2(:,24, 2) = (/ &
  & 0.96124353E-06_JPRB, 0.96222802E-06_JPRB, 0.96323261E-06_JPRB, 0.96465410E-06_JPRB, 0.96802900E-06_JPRB, 0.97224796E-06_JPRB, &
  & 0.97793336E-06_JPRB, 0.98428265E-06_JPRB, 0.99196949E-06_JPRB, 0.10016379E-05_JPRB, 0.10125791E-05_JPRB, 0.10242058E-05_JPRB, &
  & 0.10362414E-05_JPRB, 0.10474907E-05_JPRB, 0.10585848E-05_JPRB, 0.10712425E-05_JPRB, 0.10859207E-05_JPRB, 0.11024321E-05_JPRB, &
  & 0.11207552E-05_JPRB, 0.11491216E-05_JPRB, 0.11912032E-05_JPRB, 0.12455068E-05_JPRB, 0.13042374E-05_JPRB, 0.13625093E-05_JPRB, &
  & 0.14185808E-05_JPRB, 0.14733708E-05_JPRB, 0.15257245E-05_JPRB, 0.15734418E-05_JPRB, 0.16152313E-05_JPRB, 0.16451146E-05_JPRB, &
  & 0.16593316E-05_JPRB, 0.16533631E-05_JPRB, 0.16226252E-05_JPRB, 0.15696601E-05_JPRB, 0.14966813E-05_JPRB, 0.14092376E-05_JPRB, &
  & 0.13156571E-05_JPRB, 0.12159631E-05_JPRB, 0.10953925E-05_JPRB, 0.97278694E-06_JPRB, 0.90022014E-06_JPRB, 0.87532068E-06_JPRB, &
  & 0.87048370E-06_JPRB, 0.87092879E-06_JPRB, 0.87319779E-06_JPRB, 0.87194358E-06_JPRB, 0.86548028E-06_JPRB, 0.85336253E-06_JPRB, &
  & 0.83325732E-06_JPRB, 0.80371141E-06_JPRB, 0.76739147E-06_JPRB, 0.72630870E-06_JPRB, 0.68297868E-06_JPRB, 0.64108626E-06_JPRB, &
  & 0.60419524E-06_JPRB, 0.57293653E-06_JPRB, 0.54602286E-06_JPRB, 0.51496562E-06_JPRB, 0.47729598E-06_JPRB, 0.44189028E-06_JPRB, &
  & 0.41387971E-06_JPRB, 0.39693763E-06_JPRB, 0.38593227E-06_JPRB, 0.37766669E-06_JPRB  /)

RGHG2(:,25, 2) = (/ &
  & 0.10209291E-05_JPRB, 0.10221562E-05_JPRB, 0.10245355E-05_JPRB, 0.10276067E-05_JPRB, 0.10317094E-05_JPRB, 0.10363004E-05_JPRB, &
  & 0.10424063E-05_JPRB, 0.10496936E-05_JPRB, 0.10589493E-05_JPRB, 0.10708497E-05_JPRB, 0.10839743E-05_JPRB, 0.10979300E-05_JPRB, &
  & 0.11121167E-05_JPRB, 0.11250965E-05_JPRB, 0.11367082E-05_JPRB, 0.11488321E-05_JPRB, 0.11620224E-05_JPRB, 0.11766576E-05_JPRB, &
  & 0.11943824E-05_JPRB, 0.12226032E-05_JPRB, 0.12642320E-05_JPRB, 0.13182283E-05_JPRB, 0.13746460E-05_JPRB, 0.14271278E-05_JPRB, &
  & 0.14738510E-05_JPRB, 0.15169476E-05_JPRB, 0.15597265E-05_JPRB, 0.16019610E-05_JPRB, 0.16397718E-05_JPRB, 0.16666791E-05_JPRB, &
  & 0.16784378E-05_JPRB, 0.16697682E-05_JPRB, 0.16359412E-05_JPRB, 0.15804692E-05_JPRB, 0.15070052E-05_JPRB, 0.14187043E-05_JPRB, &
  & 0.13267088E-05_JPRB, 0.12304598E-05_JPRB, 0.11226986E-05_JPRB, 0.10163313E-05_JPRB, 0.94921498E-06_JPRB, 0.92242322E-06_JPRB, &
  & 0.91165055E-06_JPRB, 0.90548066E-06_JPRB, 0.90309168E-06_JPRB, 0.90028481E-06_JPRB, 0.89472723E-06_JPRB, 0.88526194E-06_JPRB, &
  & 0.86944272E-06_JPRB, 0.84364907E-06_JPRB, 0.81006246E-06_JPRB, 0.77143807E-06_JPRB, 0.72881969E-06_JPRB, 0.68595685E-06_JPRB, &
  & 0.64686623E-06_JPRB, 0.61253455E-06_JPRB, 0.58175540E-06_JPRB, 0.54752815E-06_JPRB, 0.50883957E-06_JPRB, 0.47277076E-06_JPRB, &
  & 0.44343395E-06_JPRB, 0.42582876E-06_JPRB, 0.41390150E-06_JPRB, 0.39997519E-06_JPRB  /)

RGHG2(:,26, 2) = (/ &
  & 0.10781334E-05_JPRB, 0.10794560E-05_JPRB, 0.10827600E-05_JPRB, 0.10866893E-05_JPRB, 0.10912702E-05_JPRB, 0.10965446E-05_JPRB, &
  & 0.11034425E-05_JPRB, 0.11117213E-05_JPRB, 0.11223892E-05_JPRB, 0.11363123E-05_JPRB, 0.11510102E-05_JPRB, 0.11659272E-05_JPRB, &
  & 0.11810713E-05_JPRB, 0.11954418E-05_JPRB, 0.12084249E-05_JPRB, 0.12213681E-05_JPRB, 0.12343287E-05_JPRB, 0.12477055E-05_JPRB, &
  & 0.12637926E-05_JPRB, 0.12892583E-05_JPRB, 0.13283711E-05_JPRB, 0.13801134E-05_JPRB, 0.14341676E-05_JPRB, 0.14819583E-05_JPRB, &
  & 0.15218016E-05_JPRB, 0.15564880E-05_JPRB, 0.15913583E-05_JPRB, 0.16272028E-05_JPRB, 0.16594116E-05_JPRB, 0.16823114E-05_JPRB, &
  & 0.16913594E-05_JPRB, 0.16805123E-05_JPRB, 0.16445128E-05_JPRB, 0.15875107E-05_JPRB, 0.15145909E-05_JPRB, 0.14288892E-05_JPRB, &
  & 0.13406117E-05_JPRB, 0.12506773E-05_JPRB, 0.11578410E-05_JPRB, 0.10673707E-05_JPRB, 0.10027042E-05_JPRB, 0.97129354E-06_JPRB, &
  & 0.95286161E-06_JPRB, 0.94079383E-06_JPRB, 0.93383973E-06_JPRB, 0.92845276E-06_JPRB, 0.92290854E-06_JPRB, 0.91512858E-06_JPRB, &
  & 0.90226409E-06_JPRB, 0.88002063E-06_JPRB, 0.84964286E-06_JPRB, 0.81349473E-06_JPRB, 0.77208553E-06_JPRB, 0.72939484E-06_JPRB, &
  & 0.68944067E-06_JPRB, 0.65346275E-06_JPRB, 0.62068071E-06_JPRB, 0.58553831E-06_JPRB, 0.54721162E-06_JPRB, 0.51103313E-06_JPRB, &
  & 0.48099750E-06_JPRB, 0.46293102E-06_JPRB, 0.45098617E-06_JPRB, 0.43483203E-06_JPRB  /)

RGHG2(:,27, 2) = (/ &
  & 0.11370218E-05_JPRB, 0.11383897E-05_JPRB, 0.11424934E-05_JPRB, 0.11470264E-05_JPRB, 0.11520147E-05_JPRB, 0.11581191E-05_JPRB, &
  & 0.11659828E-05_JPRB, 0.11753180E-05_JPRB, 0.11874045E-05_JPRB, 0.12033648E-05_JPRB, 0.12194812E-05_JPRB, 0.12348962E-05_JPRB, &
  & 0.12505986E-05_JPRB, 0.12662971E-05_JPRB, 0.12810308E-05_JPRB, 0.12953322E-05_JPRB, 0.13085191E-05_JPRB, 0.13208094E-05_JPRB, &
  & 0.13347988E-05_JPRB, 0.13564164E-05_JPRB, 0.13921338E-05_JPRB, 0.14407975E-05_JPRB, 0.14923618E-05_JPRB, 0.15356554E-05_JPRB, &
  & 0.15692210E-05_JPRB, 0.15963319E-05_JPRB, 0.16235511E-05_JPRB, 0.16523784E-05_JPRB, 0.16781284E-05_JPRB, 0.16964557E-05_JPRB, &
  & 0.17025761E-05_JPRB, 0.16896465E-05_JPRB, 0.16517153E-05_JPRB, 0.15934758E-05_JPRB, 0.15215067E-05_JPRB, 0.14398041E-05_JPRB, &
  & 0.13562047E-05_JPRB, 0.12739364E-05_JPRB, 0.11974886E-05_JPRB, 0.11235125E-05_JPRB, 0.10602948E-05_JPRB, 0.10230440E-05_JPRB, &
  & 0.99596506E-06_JPRB, 0.97799679E-06_JPRB, 0.96630420E-06_JPRB, 0.95783871E-06_JPRB, 0.95197758E-06_JPRB, 0.94560106E-06_JPRB, &
  & 0.93533218E-06_JPRB, 0.91672559E-06_JPRB, 0.88987906E-06_JPRB, 0.85632654E-06_JPRB, 0.81636606E-06_JPRB, 0.77427900E-06_JPRB, &
  & 0.73391738E-06_JPRB, 0.69674729E-06_JPRB, 0.66256181E-06_JPRB, 0.62729868E-06_JPRB, 0.58986234E-06_JPRB, 0.55377440E-06_JPRB, &
  & 0.52324078E-06_JPRB, 0.50476684E-06_JPRB, 0.49313890E-06_JPRB, 0.47592840E-06_JPRB  /)

RGHG2(:,28, 2) = (/ &
  & 0.11928654E-05_JPRB, 0.11953492E-05_JPRB, 0.11993468E-05_JPRB, 0.12032023E-05_JPRB, 0.12073805E-05_JPRB, 0.12135550E-05_JPRB, &
  & 0.12218573E-05_JPRB, 0.12314093E-05_JPRB, 0.12441149E-05_JPRB, 0.12604933E-05_JPRB, 0.12766905E-05_JPRB, 0.12921376E-05_JPRB, &
  & 0.13079496E-05_JPRB, 0.13236628E-05_JPRB, 0.13389535E-05_JPRB, 0.13540844E-05_JPRB, 0.13685572E-05_JPRB, 0.13816936E-05_JPRB, &
  & 0.13956507E-05_JPRB, 0.14143252E-05_JPRB, 0.14445260E-05_JPRB, 0.14870221E-05_JPRB, 0.15332180E-05_JPRB, 0.15725542E-05_JPRB, &
  & 0.16023426E-05_JPRB, 0.16257881E-05_JPRB, 0.16482748E-05_JPRB, 0.16707045E-05_JPRB, 0.16907424E-05_JPRB, 0.17049340E-05_JPRB, &
  & 0.17089738E-05_JPRB, 0.16966634E-05_JPRB, 0.16610724E-05_JPRB, 0.16056887E-05_JPRB, 0.15365111E-05_JPRB, 0.14612752E-05_JPRB, &
  & 0.13868483E-05_JPRB, 0.13175631E-05_JPRB, 0.12549044E-05_JPRB, 0.11924181E-05_JPRB, 0.11325247E-05_JPRB, 0.10899366E-05_JPRB, &
  & 0.10575477E-05_JPRB, 0.10333009E-05_JPRB, 0.10164144E-05_JPRB, 0.10030207E-05_JPRB, 0.99397981E-06_JPRB, 0.98581818E-06_JPRB, &
  & 0.97522570E-06_JPRB, 0.95746314E-06_JPRB, 0.93200732E-06_JPRB, 0.90030948E-06_JPRB, 0.86199585E-06_JPRB, 0.82073373E-06_JPRB, &
  & 0.78093197E-06_JPRB, 0.74504201E-06_JPRB, 0.71279186E-06_JPRB, 0.67958961E-06_JPRB, 0.64262644E-06_JPRB, 0.60703029E-06_JPRB, &
  & 0.57730334E-06_JPRB, 0.55967719E-06_JPRB, 0.54905070E-06_JPRB, 0.53527894E-06_JPRB  /)

RGHG2(:,29, 2) = (/ &
  & 0.12519044E-05_JPRB, 0.12556170E-05_JPRB, 0.12594627E-05_JPRB, 0.12625450E-05_JPRB, 0.12658119E-05_JPRB, 0.12720278E-05_JPRB, &
  & 0.12807720E-05_JPRB, 0.12905172E-05_JPRB, 0.13038442E-05_JPRB, 0.13205954E-05_JPRB, 0.13368202E-05_JPRB, 0.13522812E-05_JPRB, &
  & 0.13681898E-05_JPRB, 0.13838615E-05_JPRB, 0.13996908E-05_JPRB, 0.14156777E-05_JPRB, 0.14315589E-05_JPRB, 0.14456757E-05_JPRB, &
  & 0.14596880E-05_JPRB, 0.14752834E-05_JPRB, 0.14995469E-05_JPRB, 0.15353739E-05_JPRB, 0.15757568E-05_JPRB, 0.16109231E-05_JPRB, &
  & 0.16368178E-05_JPRB, 0.16565490E-05_JPRB, 0.16741478E-05_JPRB, 0.16898256E-05_JPRB, 0.17038433E-05_JPRB, 0.17136717E-05_JPRB, &
  & 0.17155437E-05_JPRB, 0.17040066E-05_JPRB, 0.16710805E-05_JPRB, 0.16189001E-05_JPRB, 0.15527602E-05_JPRB, 0.14844833E-05_JPRB, &
  & 0.14199703E-05_JPRB, 0.13646722E-05_JPRB, 0.13165115E-05_JPRB, 0.12659826E-05_JPRB, 0.12096930E-05_JPRB, 0.11614714E-05_JPRB, &
  & 0.11236009E-05_JPRB, 0.10926850E-05_JPRB, 0.10702755E-05_JPRB, 0.10515796E-05_JPRB, 0.10390454E-05_JPRB, 0.10288541E-05_JPRB, &
  & 0.10177921E-05_JPRB, 0.10008028E-05_JPRB, 0.97672773E-06_JPRB, 0.94696296E-06_JPRB, 0.91040290E-06_JPRB, 0.87002447E-06_JPRB, &
  & 0.83085785E-06_JPRB, 0.79643151E-06_JPRB, 0.76637677E-06_JPRB, 0.73545278E-06_JPRB, 0.69897287E-06_JPRB, 0.66391523E-06_JPRB, &
  & 0.63509958E-06_JPRB, 0.61842615E-06_JPRB, 0.60889047E-06_JPRB, 0.59895722E-06_JPRB  /)

RGHG2(:,30, 2) = (/ &
  & 0.13063053E-05_JPRB, 0.13106135E-05_JPRB, 0.13134522E-05_JPRB, 0.13149327E-05_JPRB, 0.13171799E-05_JPRB, 0.13225953E-05_JPRB, &
  & 0.13306363E-05_JPRB, 0.13398602E-05_JPRB, 0.13524599E-05_JPRB, 0.13679136E-05_JPRB, 0.13836168E-05_JPRB, 0.13995387E-05_JPRB, &
  & 0.14164178E-05_JPRB, 0.14324534E-05_JPRB, 0.14478950E-05_JPRB, 0.14634339E-05_JPRB, 0.14793042E-05_JPRB, 0.14937009E-05_JPRB, &
  & 0.15078587E-05_JPRB, 0.15227964E-05_JPRB, 0.15440828E-05_JPRB, 0.15726987E-05_JPRB, 0.16046704E-05_JPRB, 0.16338408E-05_JPRB, &
  & 0.16561659E-05_JPRB, 0.16734436E-05_JPRB, 0.16882967E-05_JPRB, 0.17004750E-05_JPRB, 0.17110667E-05_JPRB, 0.17186471E-05_JPRB, &
  & 0.17197894E-05_JPRB, 0.17092233E-05_JPRB, 0.16808483E-05_JPRB, 0.16364460E-05_JPRB, 0.15805585E-05_JPRB, 0.15225133E-05_JPRB, &
  & 0.14713155E-05_JPRB, 0.14287178E-05_JPRB, 0.13907591E-05_JPRB, 0.13494232E-05_JPRB, 0.13004875E-05_JPRB, 0.12524549E-05_JPRB, &
  & 0.12109648E-05_JPRB, 0.11745117E-05_JPRB, 0.11453046E-05_JPRB, 0.11203692E-05_JPRB, 0.11019732E-05_JPRB, 0.10873162E-05_JPRB, &
  & 0.10731851E-05_JPRB, 0.10543163E-05_JPRB, 0.10291993E-05_JPRB, 0.10002126E-05_JPRB, 0.96507330E-06_JPRB, 0.92545984E-06_JPRB, &
  & 0.88750678E-06_JPRB, 0.85542279E-06_JPRB, 0.82835396E-06_JPRB, 0.80030676E-06_JPRB, 0.76559824E-06_JPRB, 0.73202091E-06_JPRB, &
  & 0.70530453E-06_JPRB, 0.68977216E-06_JPRB, 0.68125636E-06_JPRB, 0.67317029E-06_JPRB  /)

RGHG2(:,31, 2) = (/ &
  & 0.13636207E-05_JPRB, 0.13685557E-05_JPRB, 0.13703327E-05_JPRB, 0.13701246E-05_JPRB, 0.13712972E-05_JPRB, 0.13758684E-05_JPRB, &
  & 0.13831675E-05_JPRB, 0.13918412E-05_JPRB, 0.14036735E-05_JPRB, 0.14177584E-05_JPRB, 0.14329116E-05_JPRB, 0.14493196E-05_JPRB, &
  & 0.14672220E-05_JPRB, 0.14836414E-05_JPRB, 0.14986736E-05_JPRB, 0.15137392E-05_JPRB, 0.15295967E-05_JPRB, 0.15442876E-05_JPRB, &
  & 0.15585990E-05_JPRB, 0.15728459E-05_JPRB, 0.15909982E-05_JPRB, 0.16120156E-05_JPRB, 0.16351224E-05_JPRB, 0.16579736E-05_JPRB, &
  & 0.16765377E-05_JPRB, 0.16912314E-05_JPRB, 0.17031935E-05_JPRB, 0.17116877E-05_JPRB, 0.17186721E-05_JPRB, 0.17238859E-05_JPRB, &
  & 0.17242607E-05_JPRB, 0.17147180E-05_JPRB, 0.16911400E-05_JPRB, 0.16549374E-05_JPRB, 0.16098592E-05_JPRB, 0.15625977E-05_JPRB, &
  & 0.15254329E-05_JPRB, 0.14962156E-05_JPRB, 0.14690024E-05_JPRB, 0.14373501E-05_JPRB, 0.13961663E-05_JPRB, 0.13483384E-05_JPRB, &
  & 0.13030363E-05_JPRB, 0.12607500E-05_JPRB, 0.12243793E-05_JPRB, 0.11928688E-05_JPRB, 0.11682942E-05_JPRB, 0.11489298E-05_JPRB, &
  & 0.11315622E-05_JPRB, 0.11107107E-05_JPRB, 0.10844936E-05_JPRB, 0.10563255E-05_JPRB, 0.10226829E-05_JPRB, 0.98387535E-06_JPRB, &
  & 0.94720149E-06_JPRB, 0.91758638E-06_JPRB, 0.89366440E-06_JPRB, 0.86864893E-06_JPRB, 0.83580805E-06_JPRB, 0.80379135E-06_JPRB, &
  & 0.77928801E-06_JPRB, 0.76495809E-06_JPRB, 0.75751682E-06_JPRB, 0.75137516E-06_JPRB  /)

RGHG2(:,32, 2) = (/ &
  & 0.14113486E-05_JPRB, 0.14152564E-05_JPRB, 0.14154844E-05_JPRB, 0.14148782E-05_JPRB, 0.14166577E-05_JPRB, 0.14214134E-05_JPRB, &
  & 0.14282904E-05_JPRB, 0.14362700E-05_JPRB, 0.14470955E-05_JPRB, 0.14602566E-05_JPRB, 0.14747309E-05_JPRB, 0.14906625E-05_JPRB, &
  & 0.15080090E-05_JPRB, 0.15244811E-05_JPRB, 0.15394886E-05_JPRB, 0.15539509E-05_JPRB, 0.15688081E-05_JPRB, 0.15826460E-05_JPRB, &
  & 0.15960168E-05_JPRB, 0.16089823E-05_JPRB, 0.16242440E-05_JPRB, 0.16406611E-05_JPRB, 0.16578431E-05_JPRB, 0.16747373E-05_JPRB, &
  & 0.16891160E-05_JPRB, 0.17009697E-05_JPRB, 0.17104954E-05_JPRB, 0.17171758E-05_JPRB, 0.17228441E-05_JPRB, 0.17271214E-05_JPRB, &
  & 0.17272927E-05_JPRB, 0.17190887E-05_JPRB, 0.17001199E-05_JPRB, 0.16715087E-05_JPRB, 0.16378430E-05_JPRB, 0.16048384E-05_JPRB, &
  & 0.15803751E-05_JPRB, 0.15608009E-05_JPRB, 0.15412911E-05_JPRB, 0.15163545E-05_JPRB, 0.14807767E-05_JPRB, 0.14356179E-05_JPRB, &
  & 0.13902230E-05_JPRB, 0.13462916E-05_JPRB, 0.13059506E-05_JPRB, 0.12698141E-05_JPRB, 0.12401426E-05_JPRB, 0.12155405E-05_JPRB, &
  & 0.11944780E-05_JPRB, 0.11710899E-05_JPRB, 0.11440816E-05_JPRB, 0.11164985E-05_JPRB, 0.10843398E-05_JPRB, 0.10470168E-05_JPRB, &
  & 0.10125493E-05_JPRB, 0.98502000E-06_JPRB, 0.96340829E-06_JPRB, 0.94123609E-06_JPRB, 0.91139272E-06_JPRB, 0.88331261E-06_JPRB, &
  & 0.86216424E-06_JPRB, 0.84937314E-06_JPRB, 0.84212813E-06_JPRB, 0.83524936E-06_JPRB  /)

RGHG2(:,33, 2) = (/ &
  & 0.14597084E-05_JPRB, 0.14623344E-05_JPRB, 0.14608896E-05_JPRB, 0.14600367E-05_JPRB, 0.14626647E-05_JPRB, 0.14677453E-05_JPRB, &
  & 0.14742252E-05_JPRB, 0.14814646E-05_JPRB, 0.14912131E-05_JPRB, 0.15034715E-05_JPRB, 0.15172238E-05_JPRB, 0.15325355E-05_JPRB, &
  & 0.15490998E-05_JPRB, 0.15655840E-05_JPRB, 0.15806155E-05_JPRB, 0.15944339E-05_JPRB, 0.16081238E-05_JPRB, 0.16209267E-05_JPRB, &
  & 0.16331782E-05_JPRB, 0.16447357E-05_JPRB, 0.16570248E-05_JPRB, 0.16690492E-05_JPRB, 0.16804544E-05_JPRB, 0.16912049E-05_JPRB, &
  & 0.17011789E-05_JPRB, 0.17100479E-05_JPRB, 0.17171005E-05_JPRB, 0.17221382E-05_JPRB, 0.17267354E-05_JPRB, 0.17302243E-05_JPRB, &
  & 0.17302573E-05_JPRB, 0.17234854E-05_JPRB, 0.17092824E-05_JPRB, 0.16884818E-05_JPRB, 0.16667546E-05_JPRB, 0.16490161E-05_JPRB, &
  & 0.16375804E-05_JPRB, 0.16275438E-05_JPRB, 0.16156460E-05_JPRB, 0.15973045E-05_JPRB, 0.15672747E-05_JPRB, 0.15252088E-05_JPRB, &
  & 0.14801990E-05_JPRB, 0.14351003E-05_JPRB, 0.13910465E-05_JPRB, 0.13503549E-05_JPRB, 0.13155265E-05_JPRB, 0.12854124E-05_JPRB, &
  & 0.12604506E-05_JPRB, 0.12343547E-05_JPRB, 0.12065642E-05_JPRB, 0.11795588E-05_JPRB, 0.11489405E-05_JPRB, 0.11132482E-05_JPRB, &
  & 0.10811937E-05_JPRB, 0.10557825E-05_JPRB, 0.10364634E-05_JPRB, 0.10172217E-05_JPRB, 0.99063976E-06_JPRB, 0.96695837E-06_JPRB, &
  & 0.94944450E-06_JPRB, 0.93829614E-06_JPRB, 0.93114140E-06_JPRB, 0.92314941E-06_JPRB  /)

RGHG2(:,34, 2) = (/ &
  & 0.14983407E-05_JPRB, 0.14994315E-05_JPRB, 0.14970674E-05_JPRB, 0.14967048E-05_JPRB, 0.15004594E-05_JPRB, 0.15063474E-05_JPRB, &
  & 0.15126081E-05_JPRB, 0.15193439E-05_JPRB, 0.15284113E-05_JPRB, 0.15396808E-05_JPRB, 0.15523595E-05_JPRB, 0.15665664E-05_JPRB, &
  & 0.15819210E-05_JPRB, 0.15974709E-05_JPRB, 0.16119670E-05_JPRB, 0.16249299E-05_JPRB, 0.16370898E-05_JPRB, 0.16485265E-05_JPRB, &
  & 0.16592932E-05_JPRB, 0.16690958E-05_JPRB, 0.16788193E-05_JPRB, 0.16877908E-05_JPRB, 0.16958889E-05_JPRB, 0.17031484E-05_JPRB, &
  & 0.17099857E-05_JPRB, 0.17162127E-05_JPRB, 0.17212789E-05_JPRB, 0.17250379E-05_JPRB, 0.17289198E-05_JPRB, 0.17321427E-05_JPRB, &
  & 0.17324556E-05_JPRB, 0.17273561E-05_JPRB, 0.17173228E-05_JPRB, 0.17032961E-05_JPRB, 0.16898476E-05_JPRB, 0.16803001E-05_JPRB, &
  & 0.16748429E-05_JPRB, 0.16693619E-05_JPRB, 0.16614766E-05_JPRB, 0.16479175E-05_JPRB, 0.16238358E-05_JPRB, 0.15879949E-05_JPRB, &
  & 0.15466709E-05_JPRB, 0.15035275E-05_JPRB, 0.14600310E-05_JPRB, 0.14187104E-05_JPRB, 0.13817122E-05_JPRB, 0.13485603E-05_JPRB, &
  & 0.13204019E-05_JPRB, 0.12922416E-05_JPRB, 0.12641217E-05_JPRB, 0.12376927E-05_JPRB, 0.12086850E-05_JPRB, 0.11762346E-05_JPRB, &
  & 0.11472876E-05_JPRB, 0.11244510E-05_JPRB, 0.11077320E-05_JPRB, 0.10914839E-05_JPRB, 0.10685418E-05_JPRB, 0.10495058E-05_JPRB, &
  & 0.10359988E-05_JPRB, 0.10272849E-05_JPRB, 0.10208521E-05_JPRB, 0.10124134E-05_JPRB  /)

RGHG2(:,35, 2) = (/ &
  & 0.15330683E-05_JPRB, 0.15324503E-05_JPRB, 0.15295279E-05_JPRB, 0.15300475E-05_JPRB, 0.15351031E-05_JPRB, 0.15420688E-05_JPRB, &
  & 0.15481955E-05_JPRB, 0.15545348E-05_JPRB, 0.15631053E-05_JPRB, 0.15733139E-05_JPRB, 0.15847083E-05_JPRB, 0.15975304E-05_JPRB, &
  & 0.16114221E-05_JPRB, 0.16255258E-05_JPRB, 0.16391844E-05_JPRB, 0.16511589E-05_JPRB, 0.16615600E-05_JPRB, 0.16714220E-05_JPRB, &
  & 0.16804745E-05_JPRB, 0.16882948E-05_JPRB, 0.16955894E-05_JPRB, 0.17021096E-05_JPRB, 0.17080747E-05_JPRB, 0.17131063E-05_JPRB, &
  & 0.17173695E-05_JPRB, 0.17210558E-05_JPRB, 0.17243297E-05_JPRB, 0.17269607E-05_JPRB, 0.17302898E-05_JPRB, 0.17335072E-05_JPRB, &
  & 0.17343226E-05_JPRB, 0.17310658E-05_JPRB, 0.17250137E-05_JPRB, 0.17174195E-05_JPRB, 0.17106045E-05_JPRB, 0.17058479E-05_JPRB, &
  & 0.17029202E-05_JPRB, 0.16995666E-05_JPRB, 0.16939594E-05_JPRB, 0.16843871E-05_JPRB, 0.16666263E-05_JPRB, 0.16387925E-05_JPRB, &
  & 0.16029518E-05_JPRB, 0.15634211E-05_JPRB, 0.15226885E-05_JPRB, 0.14827360E-05_JPRB, 0.14450398E-05_JPRB, 0.14100341E-05_JPRB, &
  & 0.13789498E-05_JPRB, 0.13489971E-05_JPRB, 0.13207712E-05_JPRB, 0.12949340E-05_JPRB, 0.12676182E-05_JPRB, 0.12393277E-05_JPRB, &
  & 0.12139320E-05_JPRB, 0.11939766E-05_JPRB, 0.11800886E-05_JPRB, 0.11669506E-05_JPRB, 0.11479452E-05_JPRB, 0.11338117E-05_JPRB, &
  & 0.11246153E-05_JPRB, 0.11188106E-05_JPRB, 0.11134443E-05_JPRB, 0.11048884E-05_JPRB  /)

RGHG2(:,36, 2) = (/ &
  & 0.15650424E-05_JPRB, 0.15630363E-05_JPRB, 0.15597615E-05_JPRB, 0.15611753E-05_JPRB, 0.15672683E-05_JPRB, 0.15750092E-05_JPRB, &
  & 0.15809379E-05_JPRB, 0.15869304E-05_JPRB, 0.15949240E-05_JPRB, 0.16040965E-05_JPRB, 0.16142020E-05_JPRB, 0.16255866E-05_JPRB, &
  & 0.16379518E-05_JPRB, 0.16505026E-05_JPRB, 0.16630018E-05_JPRB, 0.16737547E-05_JPRB, 0.16824209E-05_JPRB, 0.16906181E-05_JPRB, &
  & 0.16979450E-05_JPRB, 0.17039476E-05_JPRB, 0.17091362E-05_JPRB, 0.17136064E-05_JPRB, 0.17177186E-05_JPRB, 0.17209169E-05_JPRB, &
  & 0.17231729E-05_JPRB, 0.17248671E-05_JPRB, 0.17266590E-05_JPRB, 0.17283827E-05_JPRB, 0.17312365E-05_JPRB, 0.17344913E-05_JPRB, &
  & 0.17358262E-05_JPRB, 0.17341093E-05_JPRB, 0.17311891E-05_JPRB, 0.17284314E-05_JPRB, 0.17265125E-05_JPRB, 0.17252079E-05_JPRB, &
  & 0.17241017E-05_JPRB, 0.17223680E-05_JPRB, 0.17186904E-05_JPRB, 0.17125021E-05_JPRB, 0.17003362E-05_JPRB, 0.16798318E-05_JPRB, &
  & 0.16498054E-05_JPRB, 0.16145292E-05_JPRB, 0.15773020E-05_JPRB, 0.15396638E-05_JPRB, 0.15025070E-05_JPRB, 0.14667927E-05_JPRB, &
  & 0.14335538E-05_JPRB, 0.14022460E-05_JPRB, 0.13742734E-05_JPRB, 0.13492848E-05_JPRB, 0.13240871E-05_JPRB, 0.13002218E-05_JPRB, &
  & 0.12784075E-05_JPRB, 0.12615924E-05_JPRB, 0.12507179E-05_JPRB, 0.12408276E-05_JPRB, 0.12258900E-05_JPRB, 0.12162739E-05_JPRB, &
  & 0.12112012E-05_JPRB, 0.12083266E-05_JPRB, 0.12043803E-05_JPRB, 0.11962007E-05_JPRB  /)

RGHG2(:,37, 2) = (/ &
  & 0.15887145E-05_JPRB, 0.15861414E-05_JPRB, 0.15830083E-05_JPRB, 0.15852881E-05_JPRB, 0.15917497E-05_JPRB, 0.15995241E-05_JPRB, &
  & 0.16051203E-05_JPRB, 0.16109015E-05_JPRB, 0.16181709E-05_JPRB, 0.16264284E-05_JPRB, 0.16353149E-05_JPRB, 0.16452304E-05_JPRB, &
  & 0.16560183E-05_JPRB, 0.16668680E-05_JPRB, 0.16775426E-05_JPRB, 0.16866151E-05_JPRB, 0.16937090E-05_JPRB, 0.17001383E-05_JPRB, &
  & 0.17058208E-05_JPRB, 0.17104961E-05_JPRB, 0.17144501E-05_JPRB, 0.17179178E-05_JPRB, 0.17209346E-05_JPRB, 0.17233185E-05_JPRB, &
  & 0.17249921E-05_JPRB, 0.17260754E-05_JPRB, 0.17271895E-05_JPRB, 0.17285678E-05_JPRB, 0.17311536E-05_JPRB, 0.17345424E-05_JPRB, &
  & 0.17364031E-05_JPRB, 0.17354361E-05_JPRB, 0.17335056E-05_JPRB, 0.17316242E-05_JPRB, 0.17303136E-05_JPRB, 0.17291765E-05_JPRB, &
  & 0.17281553E-05_JPRB, 0.17267774E-05_JPRB, 0.17241101E-05_JPRB, 0.17197130E-05_JPRB, 0.17111295E-05_JPRB, 0.16959447E-05_JPRB, &
  & 0.16721295E-05_JPRB, 0.16423147E-05_JPRB, 0.16100745E-05_JPRB, 0.15767765E-05_JPRB, 0.15429626E-05_JPRB, 0.15092096E-05_JPRB, &
  & 0.14757181E-05_JPRB, 0.14441422E-05_JPRB, 0.14172315E-05_JPRB, 0.13936269E-05_JPRB, 0.13713932E-05_JPRB, 0.13522855E-05_JPRB, &
  & 0.13338990E-05_JPRB, 0.13206225E-05_JPRB, 0.13129929E-05_JPRB, 0.13064634E-05_JPRB, 0.12956418E-05_JPRB, 0.12893787E-05_JPRB, &
  & 0.12877441E-05_JPRB, 0.12876660E-05_JPRB, 0.12858614E-05_JPRB, 0.12791663E-05_JPRB  /)

RGHG2(:,38, 2) = (/ &
  & 0.16149808E-05_JPRB, 0.16117786E-05_JPRB, 0.16088028E-05_JPRB, 0.16120435E-05_JPRB, 0.16189140E-05_JPRB, 0.16267255E-05_JPRB, &
  & 0.16319529E-05_JPRB, 0.16374996E-05_JPRB, 0.16439653E-05_JPRB, 0.16512076E-05_JPRB, 0.16587415E-05_JPRB, 0.16670270E-05_JPRB, &
  & 0.16760646E-05_JPRB, 0.16850269E-05_JPRB, 0.16936768E-05_JPRB, 0.17008847E-05_JPRB, 0.17062343E-05_JPRB, 0.17107017E-05_JPRB, &
  & 0.17145597E-05_JPRB, 0.17177623E-05_JPRB, 0.17203465E-05_JPRB, 0.17227016E-05_JPRB, 0.17245031E-05_JPRB, 0.17259833E-05_JPRB, &
  & 0.17270106E-05_JPRB, 0.17274161E-05_JPRB, 0.17277781E-05_JPRB, 0.17287732E-05_JPRB, 0.17310616E-05_JPRB, 0.17345992E-05_JPRB, &
  & 0.17370431E-05_JPRB, 0.17369084E-05_JPRB, 0.17360761E-05_JPRB, 0.17351669E-05_JPRB, 0.17345312E-05_JPRB, 0.17335801E-05_JPRB, &
  & 0.17326532E-05_JPRB, 0.17316699E-05_JPRB, 0.17301236E-05_JPRB, 0.17277141E-05_JPRB, 0.17231057E-05_JPRB, 0.17138234E-05_JPRB, &
  & 0.16969002E-05_JPRB, 0.16731451E-05_JPRB, 0.16464386E-05_JPRB, 0.16179565E-05_JPRB, 0.15878516E-05_JPRB, 0.15562749E-05_JPRB, &
  & 0.15225031E-05_JPRB, 0.14906298E-05_JPRB, 0.14648974E-05_JPRB, 0.14428284E-05_JPRB, 0.14238834E-05_JPRB, 0.14100548E-05_JPRB, &
  & 0.13954718E-05_JPRB, 0.13861218E-05_JPRB, 0.13820926E-05_JPRB, 0.13792922E-05_JPRB, 0.13730376E-05_JPRB, 0.13704950E-05_JPRB, &
  & 0.13726754E-05_JPRB, 0.13757000E-05_JPRB, 0.13762719E-05_JPRB, 0.13712240E-05_JPRB  /)

RGHG2(:,39, 2) = (/ &
  & 0.16311424E-05_JPRB, 0.16280606E-05_JPRB, 0.16256265E-05_JPRB, 0.16290855E-05_JPRB, 0.16356009E-05_JPRB, 0.16427649E-05_JPRB, &
  & 0.16475522E-05_JPRB, 0.16526917E-05_JPRB, 0.16584133E-05_JPRB, 0.16647786E-05_JPRB, 0.16712769E-05_JPRB, 0.16783941E-05_JPRB, &
  & 0.16861625E-05_JPRB, 0.16936844E-05_JPRB, 0.17007866E-05_JPRB, 0.17067009E-05_JPRB, 0.17110061E-05_JPRB, 0.17143963E-05_JPRB, &
  & 0.17173708E-05_JPRB, 0.17198790E-05_JPRB, 0.17219418E-05_JPRB, 0.17237680E-05_JPRB, 0.17249806E-05_JPRB, 0.17260191E-05_JPRB, &
  & 0.17268212E-05_JPRB, 0.17269999E-05_JPRB, 0.17273131E-05_JPRB, 0.17285225E-05_JPRB, 0.17308773E-05_JPRB, 0.17345442E-05_JPRB, &
  & 0.17370636E-05_JPRB, 0.17371068E-05_JPRB, 0.17364829E-05_JPRB, 0.17356989E-05_JPRB, 0.17351149E-05_JPRB, 0.17342996E-05_JPRB, &
  & 0.17335962E-05_JPRB, 0.17329183E-05_JPRB, 0.17316901E-05_JPRB, 0.17298076E-05_JPRB, 0.17263849E-05_JPRB, 0.17193530E-05_JPRB, &
  & 0.17059038E-05_JPRB, 0.16861647E-05_JPRB, 0.16633810E-05_JPRB, 0.16387832E-05_JPRB, 0.16125075E-05_JPRB, 0.15834946E-05_JPRB, &
  & 0.15506429E-05_JPRB, 0.15201813E-05_JPRB, 0.14964442E-05_JPRB, 0.14771116E-05_JPRB, 0.14614692E-05_JPRB, 0.14509276E-05_JPRB, &
  & 0.14392617E-05_JPRB, 0.14328192E-05_JPRB, 0.14310344E-05_JPRB, 0.14304057E-05_JPRB, 0.14271946E-05_JPRB, 0.14271148E-05_JPRB, &
  & 0.14310515E-05_JPRB, 0.14357064E-05_JPRB, 0.14378134E-05_JPRB, 0.14353901E-05_JPRB  /)

RGHG2(:,40, 2) = (/ &
  & 0.16484561E-05_JPRB, 0.16456384E-05_JPRB, 0.16439029E-05_JPRB, 0.16474967E-05_JPRB, 0.16534702E-05_JPRB, 0.16597624E-05_JPRB, &
  & 0.16640216E-05_JPRB, 0.16686550E-05_JPRB, 0.16735130E-05_JPRB, 0.16788716E-05_JPRB, 0.16842064E-05_JPRB, 0.16900282E-05_JPRB, &
  & 0.16963856E-05_JPRB, 0.17022903E-05_JPRB, 0.17076542E-05_JPRB, 0.17121438E-05_JPRB, 0.17153377E-05_JPRB, 0.17176085E-05_JPRB, &
  & 0.17197002E-05_JPRB, 0.17215207E-05_JPRB, 0.17231105E-05_JPRB, 0.17244113E-05_JPRB, 0.17250353E-05_JPRB, 0.17256310E-05_JPRB, &
  & 0.17262378E-05_JPRB, 0.17262240E-05_JPRB, 0.17265949E-05_JPRB, 0.17281536E-05_JPRB, 0.17306460E-05_JPRB, 0.17344613E-05_JPRB, &
  & 0.17369863E-05_JPRB, 0.17371313E-05_JPRB, 0.17366064E-05_JPRB, 0.17358306E-05_JPRB, 0.17352054E-05_JPRB, 0.17345413E-05_JPRB, &
  & 0.17341212E-05_JPRB, 0.17337871E-05_JPRB, 0.17328010E-05_JPRB, 0.17312980E-05_JPRB, 0.17288105E-05_JPRB, 0.17238222E-05_JPRB, &
  & 0.17138908E-05_JPRB, 0.16985304E-05_JPRB, 0.16800869E-05_JPRB, 0.16598953E-05_JPRB, 0.16381331E-05_JPRB, 0.16121924E-05_JPRB, &
  & 0.15806170E-05_JPRB, 0.15520917E-05_JPRB, 0.15308300E-05_JPRB, 0.15149052E-05_JPRB, 0.15031409E-05_JPRB, 0.14961308E-05_JPRB, &
  & 0.14877435E-05_JPRB, 0.14845465E-05_JPRB, 0.14851739E-05_JPRB, 0.14868390E-05_JPRB, 0.14869505E-05_JPRB, 0.14895551E-05_JPRB, &
  & 0.14952163E-05_JPRB, 0.15015435E-05_JPRB, 0.15053146E-05_JPRB, 0.15061312E-05_JPRB  /)

RGHG2(:,41, 2) = (/ &
  & 0.16696247E-05_JPRB, 0.16671298E-05_JPRB, 0.16662485E-05_JPRB, 0.16700070E-05_JPRB, 0.16753181E-05_JPRB, 0.16805442E-05_JPRB, &
  & 0.16841578E-05_JPRB, 0.16881725E-05_JPRB, 0.16919745E-05_JPRB, 0.16961023E-05_JPRB, 0.17000147E-05_JPRB, 0.17042526E-05_JPRB, &
  & 0.17088848E-05_JPRB, 0.17128122E-05_JPRB, 0.17160507E-05_JPRB, 0.17187984E-05_JPRB, 0.17206338E-05_JPRB, 0.17215359E-05_JPRB, &
  & 0.17225481E-05_JPRB, 0.17235279E-05_JPRB, 0.17245393E-05_JPRB, 0.17251978E-05_JPRB, 0.17251022E-05_JPRB, 0.17251564E-05_JPRB, &
  & 0.17255246E-05_JPRB, 0.17252753E-05_JPRB, 0.17257168E-05_JPRB, 0.17277027E-05_JPRB, 0.17303631E-05_JPRB, 0.17343601E-05_JPRB, &
  & 0.17368918E-05_JPRB, 0.17371612E-05_JPRB, 0.17367573E-05_JPRB, 0.17359917E-05_JPRB, 0.17353160E-05_JPRB, 0.17348369E-05_JPRB, &
  & 0.17347631E-05_JPRB, 0.17348494E-05_JPRB, 0.17341592E-05_JPRB, 0.17331203E-05_JPRB, 0.17317761E-05_JPRB, 0.17292864E-05_JPRB, &
  & 0.17236561E-05_JPRB, 0.17136493E-05_JPRB, 0.17005123E-05_JPRB, 0.16857079E-05_JPRB, 0.16694641E-05_JPRB, 0.16472797E-05_JPRB, &
  & 0.16172646E-05_JPRB, 0.15911067E-05_JPRB, 0.15728716E-05_JPRB, 0.15611133E-05_JPRB, 0.15540906E-05_JPRB, 0.15513984E-05_JPRB, &
  & 0.15470195E-05_JPRB, 0.15477907E-05_JPRB, 0.15513672E-05_JPRB, 0.15558370E-05_JPRB, 0.15600107E-05_JPRB, 0.15658974E-05_JPRB, &
  & 0.15736672E-05_JPRB, 0.15820389E-05_JPRB, 0.15878445E-05_JPRB, 0.15926225E-05_JPRB  /)

RGHG2(:,42, 2) = (/ &
  & 0.16755791E-05_JPRB, 0.16736119E-05_JPRB, 0.16732931E-05_JPRB, 0.16763650E-05_JPRB, 0.16806468E-05_JPRB, 0.16848995E-05_JPRB, &
  & 0.16879248E-05_JPRB, 0.16911187E-05_JPRB, 0.16943297E-05_JPRB, 0.16977998E-05_JPRB, 0.17013194E-05_JPRB, 0.17051479E-05_JPRB, &
  & 0.17091501E-05_JPRB, 0.17126008E-05_JPRB, 0.17153835E-05_JPRB, 0.17177490E-05_JPRB, 0.17194214E-05_JPRB, 0.17202490E-05_JPRB, &
  & 0.17211611E-05_JPRB, 0.17221882E-05_JPRB, 0.17231451E-05_JPRB, 0.17237610E-05_JPRB, 0.17238483E-05_JPRB, 0.17242051E-05_JPRB, &
  & 0.17248076E-05_JPRB, 0.17246566E-05_JPRB, 0.17253284E-05_JPRB, 0.17271510E-05_JPRB, 0.17300086E-05_JPRB, 0.17342689E-05_JPRB, &
  & 0.17366411E-05_JPRB, 0.17369991E-05_JPRB, 0.17365963E-05_JPRB, 0.17361277E-05_JPRB, 0.17355467E-05_JPRB, 0.17349295E-05_JPRB, &
  & 0.17345834E-05_JPRB, 0.17346132E-05_JPRB, 0.17340799E-05_JPRB, 0.17330985E-05_JPRB, 0.17315570E-05_JPRB, 0.17286637E-05_JPRB, &
  & 0.17228344E-05_JPRB, 0.17132867E-05_JPRB, 0.17015126E-05_JPRB, 0.16881004E-05_JPRB, 0.16733795E-05_JPRB, 0.16531145E-05_JPRB, &
  & 0.16262539E-05_JPRB, 0.16036154E-05_JPRB, 0.15885852E-05_JPRB, 0.15794144E-05_JPRB, 0.15743573E-05_JPRB, 0.15723489E-05_JPRB, &
  & 0.15694669E-05_JPRB, 0.15703305E-05_JPRB, 0.15744399E-05_JPRB, 0.15787526E-05_JPRB, 0.15830763E-05_JPRB, 0.15889044E-05_JPRB, &
  & 0.15963545E-05_JPRB, 0.16028498E-05_JPRB, 0.16080725E-05_JPRB, 0.16116864E-05_JPRB  /)

RGHG2(:,43, 2) = (/ &
  & 0.16901175E-05_JPRB, 0.16887706E-05_JPRB, 0.16893325E-05_JPRB, 0.16918488E-05_JPRB, 0.16949066E-05_JPRB, 0.16978125E-05_JPRB, &
  & 0.17000235E-05_JPRB, 0.17022023E-05_JPRB, 0.17044198E-05_JPRB, 0.17067604E-05_JPRB, 0.17093097E-05_JPRB, 0.17120834E-05_JPRB, &
  & 0.17147687E-05_JPRB, 0.17169340E-05_JPRB, 0.17183865E-05_JPRB, 0.17196541E-05_JPRB, 0.17205933E-05_JPRB, 0.17207641E-05_JPRB, &
  & 0.17211206E-05_JPRB, 0.17218293E-05_JPRB, 0.17224876E-05_JPRB, 0.17227884E-05_JPRB, 0.17227331E-05_JPRB, 0.17231330E-05_JPRB, &
  & 0.17238466E-05_JPRB, 0.17236840E-05_JPRB, 0.17245963E-05_JPRB, 0.17264538E-05_JPRB, 0.17295634E-05_JPRB, 0.17341422E-05_JPRB, &
  & 0.17363718E-05_JPRB, 0.17368641E-05_JPRB, 0.17365144E-05_JPRB, 0.17363211E-05_JPRB, 0.17358048E-05_JPRB, 0.17351411E-05_JPRB, &
  & 0.17346955E-05_JPRB, 0.17348547E-05_JPRB, 0.17345917E-05_JPRB, 0.17338624E-05_JPRB, 0.17326327E-05_JPRB, 0.17304460E-05_JPRB, &
  & 0.17262852E-05_JPRB, 0.17194592E-05_JPRB, 0.17112113E-05_JPRB, 0.17013866E-05_JPRB, 0.16904290E-05_JPRB, 0.16735309E-05_JPRB, &
  & 0.16502196E-05_JPRB, 0.16318105E-05_JPRB, 0.16210063E-05_JPRB, 0.16159887E-05_JPRB, 0.16147645E-05_JPRB, 0.16152374E-05_JPRB, &
  & 0.16154453E-05_JPRB, 0.16181001E-05_JPRB, 0.16239643E-05_JPRB, 0.16293402E-05_JPRB, 0.16355480E-05_JPRB, 0.16427345E-05_JPRB, &
  & 0.16507999E-05_JPRB, 0.16564626E-05_JPRB, 0.16620286E-05_JPRB, 0.16662844E-05_JPRB  /)

RGHG2(:,44, 2) = (/ &
  & 0.16961221E-05_JPRB, 0.16948243E-05_JPRB, 0.16953313E-05_JPRB, 0.16973399E-05_JPRB, 0.16997863E-05_JPRB, 0.17021366E-05_JPRB, &
  & 0.17039214E-05_JPRB, 0.17056365E-05_JPRB, 0.17074841E-05_JPRB, 0.17094343E-05_JPRB, 0.17115376E-05_JPRB, 0.17138040E-05_JPRB, &
  & 0.17159125E-05_JPRB, 0.17175290E-05_JPRB, 0.17185040E-05_JPRB, 0.17193505E-05_JPRB, 0.17199189E-05_JPRB, 0.17199225E-05_JPRB, &
  & 0.17201328E-05_JPRB, 0.17207376E-05_JPRB, 0.17212082E-05_JPRB, 0.17215705E-05_JPRB, 0.17217403E-05_JPRB, 0.17222382E-05_JPRB, &
  & 0.17230845E-05_JPRB, 0.17232482E-05_JPRB, 0.17242632E-05_JPRB, 0.17260746E-05_JPRB, 0.17291570E-05_JPRB, 0.17336983E-05_JPRB, &
  & 0.17359930E-05_JPRB, 0.17365840E-05_JPRB, 0.17363863E-05_JPRB, 0.17364224E-05_JPRB, 0.17361625E-05_JPRB, 0.17355798E-05_JPRB, &
  & 0.17350238E-05_JPRB, 0.17350808E-05_JPRB, 0.17349020E-05_JPRB, 0.17342505E-05_JPRB, 0.17331370E-05_JPRB, 0.17310718E-05_JPRB, &
  & 0.17274660E-05_JPRB, 0.17217724E-05_JPRB, 0.17149984E-05_JPRB, 0.17067115E-05_JPRB, 0.16972694E-05_JPRB, 0.16824693E-05_JPRB, &
  & 0.16630983E-05_JPRB, 0.16478244E-05_JPRB, 0.16398195E-05_JPRB, 0.16368634E-05_JPRB, 0.16369841E-05_JPRB, 0.16383418E-05_JPRB, &
  & 0.16394205E-05_JPRB, 0.16425502E-05_JPRB, 0.16484147E-05_JPRB, 0.16538134E-05_JPRB, 0.16596178E-05_JPRB, 0.16663728E-05_JPRB, &
  & 0.16734113E-05_JPRB, 0.16781977E-05_JPRB, 0.16826598E-05_JPRB, 0.16858936E-05_JPRB  /)

RGHG2(:,45, 2) = (/ &
  & 0.17047945E-05_JPRB, 0.17036308E-05_JPRB, 0.17041867E-05_JPRB, 0.17055471E-05_JPRB, 0.17071428E-05_JPRB, 0.17086904E-05_JPRB, &
  & 0.17098873E-05_JPRB, 0.17109461E-05_JPRB, 0.17122472E-05_JPRB, 0.17136103E-05_JPRB, 0.17150833E-05_JPRB, 0.17166389E-05_JPRB, &
  & 0.17179244E-05_JPRB, 0.17187537E-05_JPRB, 0.17190171E-05_JPRB, 0.17192455E-05_JPRB, 0.17192992E-05_JPRB, 0.17190295E-05_JPRB, &
  & 0.17190031E-05_JPRB, 0.17194493E-05_JPRB, 0.17196687E-05_JPRB, 0.17200610E-05_JPRB, 0.17204691E-05_JPRB, 0.17210842E-05_JPRB, &
  & 0.17220956E-05_JPRB, 0.17226293E-05_JPRB, 0.17237914E-05_JPRB, 0.17255549E-05_JPRB, 0.17286381E-05_JPRB, 0.17331770E-05_JPRB, &
  & 0.17355278E-05_JPRB, 0.17362481E-05_JPRB, 0.17362301E-05_JPRB, 0.17365623E-05_JPRB, 0.17366025E-05_JPRB, 0.17361059E-05_JPRB, &
  & 0.17354116E-05_JPRB, 0.17353686E-05_JPRB, 0.17353200E-05_JPRB, 0.17347888E-05_JPRB, 0.17338469E-05_JPRB, 0.17320095E-05_JPRB, &
  & 0.17292461E-05_JPRB, 0.17251855E-05_JPRB, 0.17205349E-05_JPRB, 0.17144519E-05_JPRB, 0.17072104E-05_JPRB, 0.16952242E-05_JPRB, &
  & 0.16807870E-05_JPRB, 0.16696168E-05_JPRB, 0.16653325E-05_JPRB, 0.16652480E-05_JPRB, 0.16673839E-05_JPRB, 0.16700622E-05_JPRB, &
  & 0.16725226E-05_JPRB, 0.16764193E-05_JPRB, 0.16825058E-05_JPRB, 0.16880646E-05_JPRB, 0.16936478E-05_JPRB, 0.17000833E-05_JPRB, &
  & 0.17060304E-05_JPRB, 0.17097140E-05_JPRB, 0.17129628E-05_JPRB, 0.17151141E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART4',0,ZHOOK_HANDLE)



RGHG2(:,46, 2) = (/ &
  & 0.17085358E-05_JPRB, 0.17076597E-05_JPRB, 0.17080325E-05_JPRB, 0.17090610E-05_JPRB, 0.17103466E-05_JPRB, 0.17115519E-05_JPRB, &
  & 0.17124640E-05_JPRB, 0.17132163E-05_JPRB, 0.17142636E-05_JPRB, 0.17152540E-05_JPRB, 0.17163372E-05_JPRB, 0.17174209E-05_JPRB, &
  & 0.17182033E-05_JPRB, 0.17185488E-05_JPRB, 0.17184408E-05_JPRB, 0.17182862E-05_JPRB, 0.17179915E-05_JPRB, 0.17175948E-05_JPRB, &
  & 0.17175496E-05_JPRB, 0.17180091E-05_JPRB, 0.17182441E-05_JPRB, 0.17187934E-05_JPRB, 0.17193499E-05_JPRB, 0.17201093E-05_JPRB, &
  & 0.17212991E-05_JPRB, 0.17221711E-05_JPRB, 0.17234567E-05_JPRB, 0.17251930E-05_JPRB, 0.17282105E-05_JPRB, 0.17326650E-05_JPRB, &
  & 0.17351329E-05_JPRB, 0.17358726E-05_JPRB, 0.17360491E-05_JPRB, 0.17364711E-05_JPRB, 0.17367553E-05_JPRB, 0.17364770E-05_JPRB, &
  & 0.17358023E-05_JPRB, 0.17356738E-05_JPRB, 0.17356539E-05_JPRB, 0.17352098E-05_JPRB, 0.17343314E-05_JPRB, 0.17327299E-05_JPRB, &
  & 0.17306221E-05_JPRB, 0.17276437E-05_JPRB, 0.17242609E-05_JPRB, 0.17197118E-05_JPRB, 0.17140089E-05_JPRB, 0.17044960E-05_JPRB, &
  & 0.16938118E-05_JPRB, 0.16857625E-05_JPRB, 0.16837799E-05_JPRB, 0.16850047E-05_JPRB, 0.16878024E-05_JPRB, 0.16909826E-05_JPRB, &
  & 0.16939525E-05_JPRB, 0.16978933E-05_JPRB, 0.17031367E-05_JPRB, 0.17082676E-05_JPRB, 0.17132333E-05_JPRB, 0.17188028E-05_JPRB, &
  & 0.17235346E-05_JPRB, 0.17265583E-05_JPRB, 0.17289217E-05_JPRB, 0.17302900E-05_JPRB  /)

RGHG2(:,47, 2) = (/ &
  & 0.17119383E-05_JPRB, 0.17114303E-05_JPRB, 0.17115418E-05_JPRB, 0.17122441E-05_JPRB, 0.17132741E-05_JPRB, 0.17141700E-05_JPRB, &
  & 0.17148085E-05_JPRB, 0.17152714E-05_JPRB, 0.17160793E-05_JPRB, 0.17166756E-05_JPRB, 0.17173495E-05_JPRB, 0.17179272E-05_JPRB, &
  & 0.17181833E-05_JPRB, 0.17180221E-05_JPRB, 0.17175464E-05_JPRB, 0.17169894E-05_JPRB, 0.17163192E-05_JPRB, 0.17158026E-05_JPRB, &
  & 0.17157790E-05_JPRB, 0.17162888E-05_JPRB, 0.17165955E-05_JPRB, 0.17173543E-05_JPRB, 0.17180669E-05_JPRB, 0.17190012E-05_JPRB, &
  & 0.17204030E-05_JPRB, 0.17216655E-05_JPRB, 0.17230915E-05_JPRB, 0.17248000E-05_JPRB, 0.17277270E-05_JPRB, 0.17320661E-05_JPRB, &
  & 0.17346837E-05_JPRB, 0.17354242E-05_JPRB, 0.17358318E-05_JPRB, 0.17363178E-05_JPRB, 0.17368772E-05_JPRB, 0.17368814E-05_JPRB, &
  & 0.17362614E-05_JPRB, 0.17360354E-05_JPRB, 0.17360290E-05_JPRB, 0.17356802E-05_JPRB, 0.17348549E-05_JPRB, 0.17335318E-05_JPRB, &
  & 0.17321558E-05_JPRB, 0.17303368E-05_JPRB, 0.17282704E-05_JPRB, 0.17253871E-05_JPRB, 0.17213568E-05_JPRB, 0.17146781E-05_JPRB, &
  & 0.17081611E-05_JPRB, 0.17035770E-05_JPRB, 0.17040112E-05_JPRB, 0.17064593E-05_JPRB, 0.17097626E-05_JPRB, 0.17133676E-05_JPRB, &
  & 0.17167607E-05_JPRB, 0.17206085E-05_JPRB, 0.17246493E-05_JPRB, 0.17291601E-05_JPRB, 0.17333219E-05_JPRB, 0.17377658E-05_JPRB, &
  & 0.17410467E-05_JPRB, 0.17433846E-05_JPRB, 0.17447749E-05_JPRB, 0.17452842E-05_JPRB  /)

RGHG2(:,48, 2) = (/ &
  & 0.17136476E-05_JPRB, 0.17134512E-05_JPRB, 0.17134440E-05_JPRB, 0.17139984E-05_JPRB, 0.17148166E-05_JPRB, 0.17154887E-05_JPRB, &
  & 0.17159627E-05_JPRB, 0.17162406E-05_JPRB, 0.17167638E-05_JPRB, 0.17170238E-05_JPRB, 0.17173391E-05_JPRB, 0.17174484E-05_JPRB, &
  & 0.17172928E-05_JPRB, 0.17167964E-05_JPRB, 0.17160149E-05_JPRB, 0.17151857E-05_JPRB, 0.17143765E-05_JPRB, 0.17138524E-05_JPRB, &
  & 0.17139575E-05_JPRB, 0.17146337E-05_JPRB, 0.17151948E-05_JPRB, 0.17161550E-05_JPRB, 0.17169583E-05_JPRB, 0.17180537E-05_JPRB, &
  & 0.17196607E-05_JPRB, 0.17211837E-05_JPRB, 0.17227570E-05_JPRB, 0.17244833E-05_JPRB, 0.17273335E-05_JPRB, 0.17315836E-05_JPRB, &
  & 0.17343323E-05_JPRB, 0.17350474E-05_JPRB, 0.17355354E-05_JPRB, 0.17360450E-05_JPRB, 0.17368252E-05_JPRB, 0.17370667E-05_JPRB, &
  & 0.17365644E-05_JPRB, 0.17363076E-05_JPRB, 0.17364522E-05_JPRB, 0.17360616E-05_JPRB, 0.17352532E-05_JPRB, 0.17342938E-05_JPRB, &
  & 0.17336014E-05_JPRB, 0.17327562E-05_JPRB, 0.17317842E-05_JPRB, 0.17303253E-05_JPRB, 0.17278445E-05_JPRB, 0.17235849E-05_JPRB, &
  & 0.17200589E-05_JPRB, 0.17180096E-05_JPRB, 0.17196770E-05_JPRB, 0.17225426E-05_JPRB, 0.17258285E-05_JPRB, 0.17293563E-05_JPRB, &
  & 0.17325200E-05_JPRB, 0.17358329E-05_JPRB, 0.17389478E-05_JPRB, 0.17427705E-05_JPRB, 0.17461610E-05_JPRB, 0.17495672E-05_JPRB, &
  & 0.17519921E-05_JPRB, 0.17538562E-05_JPRB, 0.17546705E-05_JPRB, 0.17548042E-05_JPRB  /)

RGHG2(:,49, 2) = (/ &
  & 0.17147708E-05_JPRB, 0.17148935E-05_JPRB, 0.17148198E-05_JPRB, 0.17152914E-05_JPRB, 0.17158949E-05_JPRB, 0.17163583E-05_JPRB, &
  & 0.17166996E-05_JPRB, 0.17168202E-05_JPRB, 0.17170075E-05_JPRB, 0.17169215E-05_JPRB, 0.17168627E-05_JPRB, 0.17164704E-05_JPRB, &
  & 0.17159110E-05_JPRB, 0.17151213E-05_JPRB, 0.17140293E-05_JPRB, 0.17129579E-05_JPRB, 0.17121022E-05_JPRB, 0.17116208E-05_JPRB, &
  & 0.17119171E-05_JPRB, 0.17128305E-05_JPRB, 0.17137565E-05_JPRB, 0.17149359E-05_JPRB, 0.17158100E-05_JPRB, 0.17170773E-05_JPRB, &
  & 0.17189086E-05_JPRB, 0.17206608E-05_JPRB, 0.17224007E-05_JPRB, 0.17241671E-05_JPRB, 0.17269387E-05_JPRB, 0.17311022E-05_JPRB, &
  & 0.17339877E-05_JPRB, 0.17346626E-05_JPRB, 0.17351711E-05_JPRB, 0.17356887E-05_JPRB, 0.17366886E-05_JPRB, 0.17371723E-05_JPRB, &
  & 0.17368290E-05_JPRB, 0.17365684E-05_JPRB, 0.17369427E-05_JPRB, 0.17364433E-05_JPRB, 0.17356375E-05_JPRB, 0.17351194E-05_JPRB, &
  & 0.17351622E-05_JPRB, 0.17353111E-05_JPRB, 0.17354499E-05_JPRB, 0.17354588E-05_JPRB, 0.17346378E-05_JPRB, 0.17328686E-05_JPRB, &
  & 0.17321199E-05_JPRB, 0.17324547E-05_JPRB, 0.17349496E-05_JPRB, 0.17379111E-05_JPRB, 0.17409401E-05_JPRB, 0.17441540E-05_JPRB, &
  & 0.17467672E-05_JPRB, 0.17492868E-05_JPRB, 0.17515021E-05_JPRB, 0.17545319E-05_JPRB, 0.17570831E-05_JPRB, 0.17593801E-05_JPRB, &
  & 0.17611277E-05_JPRB, 0.17625634E-05_JPRB, 0.17629203E-05_JPRB, 0.17628578E-05_JPRB  /)

RGHG2(:,50, 2) = (/ &
  & 0.17146353E-05_JPRB, 0.17148358E-05_JPRB, 0.17147273E-05_JPRB, 0.17151549E-05_JPRB, 0.17156610E-05_JPRB, 0.17160028E-05_JPRB, &
  & 0.17162709E-05_JPRB, 0.17162438E-05_JPRB, 0.17161172E-05_JPRB, 0.17158103E-05_JPRB, 0.17154182E-05_JPRB, 0.17146910E-05_JPRB, &
  & 0.17138572E-05_JPRB, 0.17129046E-05_JPRB, 0.17116948E-05_JPRB, 0.17106001E-05_JPRB, 0.17099398E-05_JPRB, 0.17096332E-05_JPRB, &
  & 0.17101857E-05_JPRB, 0.17113600E-05_JPRB, 0.17125402E-05_JPRB, 0.17138348E-05_JPRB, 0.17148370E-05_JPRB, 0.17162432E-05_JPRB, &
  & 0.17183001E-05_JPRB, 0.17202040E-05_JPRB, 0.17220740E-05_JPRB, 0.17239443E-05_JPRB, 0.17266782E-05_JPRB, 0.17307764E-05_JPRB, &
  & 0.17336729E-05_JPRB, 0.17343532E-05_JPRB, 0.17348097E-05_JPRB, 0.17353745E-05_JPRB, 0.17365185E-05_JPRB, 0.17371125E-05_JPRB, &
  & 0.17369435E-05_JPRB, 0.17367981E-05_JPRB, 0.17372480E-05_JPRB, 0.17368022E-05_JPRB, 0.17360886E-05_JPRB, 0.17360276E-05_JPRB, &
  & 0.17367181E-05_JPRB, 0.17377100E-05_JPRB, 0.17388941E-05_JPRB, 0.17402287E-05_JPRB, 0.17408451E-05_JPRB, 0.17410030E-05_JPRB, &
  & 0.17420579E-05_JPRB, 0.17436004E-05_JPRB, 0.17461468E-05_JPRB, 0.17489139E-05_JPRB, 0.17516207E-05_JPRB, 0.17543654E-05_JPRB, &
  & 0.17564216E-05_JPRB, 0.17583256E-05_JPRB, 0.17599905E-05_JPRB, 0.17624984E-05_JPRB, 0.17644074E-05_JPRB, 0.17659990E-05_JPRB, &
  & 0.17673021E-05_JPRB, 0.17685019E-05_JPRB, 0.17687425E-05_JPRB, 0.17686641E-05_JPRB  /)

RGHG2(:,51, 2) = (/ &
  & 0.17138271E-05_JPRB, 0.17139848E-05_JPRB, 0.17138553E-05_JPRB, 0.17142558E-05_JPRB, 0.17147182E-05_JPRB, 0.17149744E-05_JPRB, &
  & 0.17151943E-05_JPRB, 0.17150125E-05_JPRB, 0.17145581E-05_JPRB, 0.17140782E-05_JPRB, 0.17133469E-05_JPRB, 0.17123453E-05_JPRB, &
  & 0.17112823E-05_JPRB, 0.17102223E-05_JPRB, 0.17089863E-05_JPRB, 0.17079816E-05_JPRB, 0.17076596E-05_JPRB, 0.17076118E-05_JPRB, &
  & 0.17084754E-05_JPRB, 0.17099443E-05_JPRB, 0.17113413E-05_JPRB, 0.17127058E-05_JPRB, 0.17138767E-05_JPRB, 0.17154157E-05_JPRB, &
  & 0.17177174E-05_JPRB, 0.17197446E-05_JPRB, 0.17217360E-05_JPRB, 0.17237524E-05_JPRB, 0.17264670E-05_JPRB, 0.17305058E-05_JPRB, &
  & 0.17333481E-05_JPRB, 0.17340581E-05_JPRB, 0.17344202E-05_JPRB, 0.17350567E-05_JPRB, 0.17363169E-05_JPRB, 0.17369607E-05_JPRB, &
  & 0.17369884E-05_JPRB, 0.17370301E-05_JPRB, 0.17374810E-05_JPRB, 0.17371785E-05_JPRB, 0.17366117E-05_JPRB, 0.17370534E-05_JPRB, &
  & 0.17383986E-05_JPRB, 0.17402226E-05_JPRB, 0.17425029E-05_JPRB, 0.17451967E-05_JPRB, 0.17472511E-05_JPRB, 0.17491975E-05_JPRB, &
  & 0.17516912E-05_JPRB, 0.17539216E-05_JPRB, 0.17561158E-05_JPRB, 0.17585201E-05_JPRB, 0.17608440E-05_JPRB, 0.17629996E-05_JPRB, &
  & 0.17644500E-05_JPRB, 0.17657814E-05_JPRB, 0.17670346E-05_JPRB, 0.17691203E-05_JPRB, 0.17704384E-05_JPRB, 0.17714793E-05_JPRB, &
  & 0.17724240E-05_JPRB, 0.17734700E-05_JPRB, 0.17737639E-05_JPRB, 0.17737633E-05_JPRB  /)

RGHG2(:,52, 2) = (/ &
  & 0.17121835E-05_JPRB, 0.17122048E-05_JPRB, 0.17120247E-05_JPRB, 0.17124138E-05_JPRB, 0.17128354E-05_JPRB, 0.17130129E-05_JPRB, &
  & 0.17131145E-05_JPRB, 0.17128059E-05_JPRB, 0.17121007E-05_JPRB, 0.17115931E-05_JPRB, 0.17107489E-05_JPRB, 0.17097088E-05_JPRB, &
  & 0.17085998E-05_JPRB, 0.17076356E-05_JPRB, 0.17065862E-05_JPRB, 0.17058235E-05_JPRB, 0.17057994E-05_JPRB, 0.17060313E-05_JPRB, &
  & 0.17071477E-05_JPRB, 0.17088368E-05_JPRB, 0.17103286E-05_JPRB, 0.17117057E-05_JPRB, 0.17130252E-05_JPRB, 0.17146646E-05_JPRB, &
  & 0.17172599E-05_JPRB, 0.17194025E-05_JPRB, 0.17214839E-05_JPRB, 0.17236109E-05_JPRB, 0.17263725E-05_JPRB, 0.17303538E-05_JPRB, &
  & 0.17330900E-05_JPRB, 0.17337589E-05_JPRB, 0.17341283E-05_JPRB, 0.17348486E-05_JPRB, 0.17361436E-05_JPRB, 0.17367390E-05_JPRB, &
  & 0.17369195E-05_JPRB, 0.17370788E-05_JPRB, 0.17375205E-05_JPRB, 0.17373925E-05_JPRB, 0.17370713E-05_JPRB, 0.17379615E-05_JPRB, &
  & 0.17398713E-05_JPRB, 0.17423814E-05_JPRB, 0.17455762E-05_JPRB, 0.17493866E-05_JPRB, 0.17525412E-05_JPRB, 0.17556273E-05_JPRB, &
  & 0.17586944E-05_JPRB, 0.17609498E-05_JPRB, 0.17628079E-05_JPRB, 0.17649172E-05_JPRB, 0.17669603E-05_JPRB, 0.17687843E-05_JPRB, &
  & 0.17699564E-05_JPRB, 0.17710883E-05_JPRB, 0.17721126E-05_JPRB, 0.17739259E-05_JPRB, 0.17749390E-05_JPRB, 0.17757391E-05_JPRB, &
  & 0.17765508E-05_JPRB, 0.17775666E-05_JPRB, 0.17779139E-05_JPRB, 0.17778222E-05_JPRB  /)

RGHG2(:,53, 2) = (/ &
  & 0.17100722E-05_JPRB, 0.17099090E-05_JPRB, 0.17096626E-05_JPRB, 0.17100452E-05_JPRB, 0.17104235E-05_JPRB, 0.17105179E-05_JPRB, &
  & 0.17104636E-05_JPRB, 0.17100277E-05_JPRB, 0.17090790E-05_JPRB, 0.17085973E-05_JPRB, 0.17077171E-05_JPRB, 0.17067258E-05_JPRB, &
  & 0.17056372E-05_JPRB, 0.17048556E-05_JPRB, 0.17040912E-05_JPRB, 0.17036504E-05_JPRB, 0.17039353E-05_JPRB, 0.17044799E-05_JPRB, &
  & 0.17058491E-05_JPRB, 0.17077494E-05_JPRB, 0.17092974E-05_JPRB, 0.17106663E-05_JPRB, 0.17121397E-05_JPRB, 0.17138760E-05_JPRB, &
  & 0.17168098E-05_JPRB, 0.17190751E-05_JPRB, 0.17212423E-05_JPRB, 0.17234763E-05_JPRB, 0.17263144E-05_JPRB, 0.17302340E-05_JPRB, &
  & 0.17328345E-05_JPRB, 0.17334315E-05_JPRB, 0.17338479E-05_JPRB, 0.17346641E-05_JPRB, 0.17359656E-05_JPRB, 0.17364707E-05_JPRB, &
  & 0.17368005E-05_JPRB, 0.17370614E-05_JPRB, 0.17374892E-05_JPRB, 0.17375632E-05_JPRB, 0.17375473E-05_JPRB, 0.17389052E-05_JPRB, &
  & 0.17413952E-05_JPRB, 0.17445961E-05_JPRB, 0.17487170E-05_JPRB, 0.17536500E-05_JPRB, 0.17578726E-05_JPRB, 0.17619503E-05_JPRB, &
  & 0.17653089E-05_JPRB, 0.17673365E-05_JPRB, 0.17688348E-05_JPRB, 0.17706490E-05_JPRB, 0.17724255E-05_JPRB, 0.17739876E-05_JPRB, &
  & 0.17749826E-05_JPRB, 0.17760407E-05_JPRB, 0.17768860E-05_JPRB, 0.17784605E-05_JPRB, 0.17792512E-05_JPRB, 0.17799084E-05_JPRB, &
  & 0.17806619E-05_JPRB, 0.17816925E-05_JPRB, 0.17820979E-05_JPRB, 0.17818420E-05_JPRB  /)

RGHG2(:,54, 2) = (/ &
  & 0.17075746E-05_JPRB, 0.17070704E-05_JPRB, 0.17066527E-05_JPRB, 0.17070512E-05_JPRB, 0.17073735E-05_JPRB, 0.17073312E-05_JPRB, &
  & 0.17069587E-05_JPRB, 0.17063640E-05_JPRB, 0.17053105E-05_JPRB, 0.17050937E-05_JPRB, 0.17044537E-05_JPRB, 0.17037369E-05_JPRB, &
  & 0.17028794E-05_JPRB, 0.17024702E-05_JPRB, 0.17020993E-05_JPRB, 0.17019533E-05_JPRB, 0.17024590E-05_JPRB, 0.17032895E-05_JPRB, &
  & 0.17048852E-05_JPRB, 0.17069320E-05_JPRB, 0.17085112E-05_JPRB, 0.17098508E-05_JPRB, 0.17114346E-05_JPRB, 0.17133067E-05_JPRB, &
  & 0.17164644E-05_JPRB, 0.17189054E-05_JPRB, 0.17210943E-05_JPRB, 0.17233436E-05_JPRB, 0.17262989E-05_JPRB, 0.17300729E-05_JPRB, &
  & 0.17326780E-05_JPRB, 0.17333005E-05_JPRB, 0.17337582E-05_JPRB, 0.17346272E-05_JPRB, 0.17357691E-05_JPRB, 0.17362077E-05_JPRB, &
  & 0.17366229E-05_JPRB, 0.17370817E-05_JPRB, 0.17374314E-05_JPRB, 0.17375798E-05_JPRB, 0.17378166E-05_JPRB, 0.17394539E-05_JPRB, &
  & 0.17425085E-05_JPRB, 0.17463111E-05_JPRB, 0.17510033E-05_JPRB, 0.17566004E-05_JPRB, 0.17615326E-05_JPRB, 0.17660694E-05_JPRB, &
  & 0.17693586E-05_JPRB, 0.17712325E-05_JPRB, 0.17726729E-05_JPRB, 0.17743199E-05_JPRB, 0.17760168E-05_JPRB, 0.17775139E-05_JPRB, &
  & 0.17785075E-05_JPRB, 0.17796707E-05_JPRB, 0.17805105E-05_JPRB, 0.17820122E-05_JPRB, 0.17828172E-05_JPRB, 0.17834363E-05_JPRB, &
  & 0.17842548E-05_JPRB, 0.17853169E-05_JPRB, 0.17856992E-05_JPRB, 0.17853849E-05_JPRB  /)

RGHG2(:,55, 2) = (/ &
  & 0.17047570E-05_JPRB, 0.17038546E-05_JPRB, 0.17032332E-05_JPRB, 0.17036523E-05_JPRB, 0.17039110E-05_JPRB, 0.17037102E-05_JPRB, &
  & 0.17029639E-05_JPRB, 0.17021891E-05_JPRB, 0.17010377E-05_JPRB, 0.17011458E-05_JPRB, 0.17008082E-05_JPRB, 0.17004251E-05_JPRB, &
  & 0.16998515E-05_JPRB, 0.16998798E-05_JPRB, 0.16999590E-05_JPRB, 0.17001360E-05_JPRB, 0.17008746E-05_JPRB, 0.17020182E-05_JPRB, &
  & 0.17038616E-05_JPRB, 0.17060620E-05_JPRB, 0.17076726E-05_JPRB, 0.17089769E-05_JPRB, 0.17106771E-05_JPRB, 0.17127049E-05_JPRB, &
  & 0.17160955E-05_JPRB, 0.17187381E-05_JPRB, 0.17209426E-05_JPRB, 0.17231969E-05_JPRB, 0.17262872E-05_JPRB, 0.17298889E-05_JPRB, &
  & 0.17325175E-05_JPRB, 0.17331811E-05_JPRB, 0.17336839E-05_JPRB, 0.17346058E-05_JPRB, 0.17355489E-05_JPRB, 0.17359171E-05_JPRB, &
  & 0.17364184E-05_JPRB, 0.17371091E-05_JPRB, 0.17373640E-05_JPRB, 0.17375779E-05_JPRB, 0.17380878E-05_JPRB, 0.17400099E-05_JPRB, &
  & 0.17436879E-05_JPRB, 0.17481452E-05_JPRB, 0.17534236E-05_JPRB, 0.17596960E-05_JPRB, 0.17653671E-05_JPRB, 0.17703423E-05_JPRB, &
  & 0.17735072E-05_JPRB, 0.17752206E-05_JPRB, 0.17766366E-05_JPRB, 0.17781152E-05_JPRB, 0.17797485E-05_JPRB, 0.17811997E-05_JPRB, &
  & 0.17822148E-05_JPRB, 0.17835179E-05_JPRB, 0.17843744E-05_JPRB, 0.17858173E-05_JPRB, 0.17866693E-05_JPRB, 0.17872601E-05_JPRB, &
  & 0.17881666E-05_JPRB, 0.17892659E-05_JPRB, 0.17896121E-05_JPRB, 0.17892468E-05_JPRB  /)

RGHG2(:,56, 2) = (/ &
  & 0.17014795E-05_JPRB, 0.17003614E-05_JPRB, 0.16996547E-05_JPRB, 0.17001569E-05_JPRB, 0.17003149E-05_JPRB, 0.17000084E-05_JPRB, &
  & 0.16988773E-05_JPRB, 0.16980216E-05_JPRB, 0.16969817E-05_JPRB, 0.16973804E-05_JPRB, 0.16973958E-05_JPRB, 0.16974548E-05_JPRB, &
  & 0.16973409E-05_JPRB, 0.16977921E-05_JPRB, 0.16983020E-05_JPRB, 0.16987406E-05_JPRB, 0.16996726E-05_JPRB, 0.17010008E-05_JPRB, &
  & 0.17030567E-05_JPRB, 0.17053904E-05_JPRB, 0.17070587E-05_JPRB, 0.17083424E-05_JPRB, 0.17101252E-05_JPRB, 0.17123718E-05_JPRB, &
  & 0.17157500E-05_JPRB, 0.17185085E-05_JPRB, 0.17207383E-05_JPRB, 0.17230587E-05_JPRB, 0.17262335E-05_JPRB, 0.17296374E-05_JPRB, &
  & 0.17323999E-05_JPRB, 0.17331346E-05_JPRB, 0.17337436E-05_JPRB, 0.17345826E-05_JPRB, 0.17352183E-05_JPRB, 0.17354856E-05_JPRB, &
  & 0.17360190E-05_JPRB, 0.17370130E-05_JPRB, 0.17371794E-05_JPRB, 0.17375189E-05_JPRB, 0.17382172E-05_JPRB, 0.17403388E-05_JPRB, &
  & 0.17445397E-05_JPRB, 0.17493510E-05_JPRB, 0.17550149E-05_JPRB, 0.17615142E-05_JPRB, 0.17675633E-05_JPRB, 0.17727700E-05_JPRB, &
  & 0.17759505E-05_JPRB, 0.17776630E-05_JPRB, 0.17792053E-05_JPRB, 0.17806862E-05_JPRB, 0.17823525E-05_JPRB, 0.17838700E-05_JPRB, &
  & 0.17849315E-05_JPRB, 0.17863686E-05_JPRB, 0.17872617E-05_JPRB, 0.17887861E-05_JPRB, 0.17896699E-05_JPRB, 0.17902558E-05_JPRB, &
  & 0.17911712E-05_JPRB, 0.17922847E-05_JPRB, 0.17926635E-05_JPRB, 0.17924812E-05_JPRB  /)

RGHG2(:,57, 2) = (/ &
  & 0.16980406E-05_JPRB, 0.16967674E-05_JPRB, 0.16960282E-05_JPRB, 0.16966174E-05_JPRB, 0.16966779E-05_JPRB, 0.16962837E-05_JPRB, &
  & 0.16948325E-05_JPRB, 0.16939367E-05_JPRB, 0.16930260E-05_JPRB, 0.16936628E-05_JPRB, 0.16939857E-05_JPRB, 0.16944482E-05_JPRB, &
  & 0.16947744E-05_JPRB, 0.16956433E-05_JPRB, 0.16965775E-05_JPRB, 0.16973021E-05_JPRB, 0.16984206E-05_JPRB, 0.16999316E-05_JPRB, &
  & 0.17021666E-05_JPRB, 0.17046275E-05_JPRB, 0.17063496E-05_JPRB, 0.17076231E-05_JPRB, 0.17095386E-05_JPRB, 0.17119620E-05_JPRB, &
  & 0.17153257E-05_JPRB, 0.17181688E-05_JPRB, 0.17204843E-05_JPRB, 0.17229278E-05_JPRB, 0.17261399E-05_JPRB, 0.17293555E-05_JPRB, &
  & 0.17322755E-05_JPRB, 0.17331052E-05_JPRB, 0.17337602E-05_JPRB, 0.17344567E-05_JPRB, 0.17348179E-05_JPRB, 0.17350142E-05_JPRB, &
  & 0.17356435E-05_JPRB, 0.17367680E-05_JPRB, 0.17368806E-05_JPRB, 0.17373590E-05_JPRB, 0.17383006E-05_JPRB, 0.17406724E-05_JPRB, &
  & 0.17453828E-05_JPRB, 0.17505628E-05_JPRB, 0.17566126E-05_JPRB, 0.17633796E-05_JPRB, 0.17698367E-05_JPRB, 0.17753005E-05_JPRB, &
  & 0.17785402E-05_JPRB, 0.17802886E-05_JPRB, 0.17819486E-05_JPRB, 0.17834229E-05_JPRB, 0.17851095E-05_JPRB, 0.17866895E-05_JPRB, &
  & 0.17878237E-05_JPRB, 0.17893519E-05_JPRB, 0.17902859E-05_JPRB, 0.17918998E-05_JPRB, 0.17927717E-05_JPRB, 0.17933516E-05_JPRB, &
  & 0.17942586E-05_JPRB, 0.17953864E-05_JPRB, 0.17958228E-05_JPRB, 0.17958352E-05_JPRB  /)

RGHG2(:,58, 2) = (/ &
  & 0.16945198E-05_JPRB, 0.16932405E-05_JPRB, 0.16925825E-05_JPRB, 0.16932703E-05_JPRB, 0.16932393E-05_JPRB, 0.16928044E-05_JPRB, &
  & 0.16911664E-05_JPRB, 0.16903213E-05_JPRB, 0.16895985E-05_JPRB, 0.16903593E-05_JPRB, 0.16908976E-05_JPRB, 0.16916862E-05_JPRB, &
  & 0.16924167E-05_JPRB, 0.16936584E-05_JPRB, 0.16949685E-05_JPRB, 0.16959856E-05_JPRB, 0.16972565E-05_JPRB, 0.16989087E-05_JPRB, &
  & 0.17012453E-05_JPRB, 0.17038087E-05_JPRB, 0.17055786E-05_JPRB, 0.17068633E-05_JPRB, 0.17089789E-05_JPRB, 0.17115059E-05_JPRB, &
  & 0.17148066E-05_JPRB, 0.17176589E-05_JPRB, 0.17201573E-05_JPRB, 0.17228212E-05_JPRB, 0.17259784E-05_JPRB, 0.17290326E-05_JPRB, &
  & 0.17321577E-05_JPRB, 0.17331205E-05_JPRB, 0.17337277E-05_JPRB, 0.17341673E-05_JPRB, 0.17343110E-05_JPRB, 0.17344871E-05_JPRB, &
  & 0.17353023E-05_JPRB, 0.17362683E-05_JPRB, 0.17363910E-05_JPRB, 0.17370309E-05_JPRB, 0.17382733E-05_JPRB, 0.17409448E-05_JPRB, &
  & 0.17460817E-05_JPRB, 0.17515696E-05_JPRB, 0.17579373E-05_JPRB, 0.17649349E-05_JPRB, 0.17717507E-05_JPRB, 0.17774552E-05_JPRB, &
  & 0.17808493E-05_JPRB, 0.17827226E-05_JPRB, 0.17845045E-05_JPRB, 0.17859900E-05_JPRB, 0.17876919E-05_JPRB, 0.17893440E-05_JPRB, &
  & 0.17905940E-05_JPRB, 0.17921324E-05_JPRB, 0.17931151E-05_JPRB, 0.17948509E-05_JPRB, 0.17956355E-05_JPRB, 0.17962124E-05_JPRB, &
  & 0.17970675E-05_JPRB, 0.17982045E-05_JPRB, 0.17987485E-05_JPRB, 0.17990037E-05_JPRB  /)

RGHG2(:,59, 2) = (/ &
  & 0.16913884E-05_JPRB, 0.16902496E-05_JPRB, 0.16897213E-05_JPRB, 0.16904387E-05_JPRB, 0.16903766E-05_JPRB, 0.16899668E-05_JPRB, &
  & 0.16883380E-05_JPRB, 0.16875524E-05_JPRB, 0.16870003E-05_JPRB, 0.16877905E-05_JPRB, 0.16884476E-05_JPRB, 0.16893955E-05_JPRB, &
  & 0.16904127E-05_JPRB, 0.16919258E-05_JPRB, 0.16934686E-05_JPRB, 0.16947459E-05_JPRB, 0.16961571E-05_JPRB, 0.16979248E-05_JPRB, &
  & 0.17002507E-05_JPRB, 0.17028306E-05_JPRB, 0.17046970E-05_JPRB, 0.17060537E-05_JPRB, 0.17082846E-05_JPRB, 0.17108945E-05_JPRB, &
  & 0.17140652E-05_JPRB, 0.17169102E-05_JPRB, 0.17196490E-05_JPRB, 0.17225466E-05_JPRB, 0.17256987E-05_JPRB, 0.17287066E-05_JPRB, &
  & 0.17320713E-05_JPRB, 0.17330845E-05_JPRB, 0.17334581E-05_JPRB, 0.17336711E-05_JPRB, 0.17338532E-05_JPRB, 0.17341695E-05_JPRB, &
  & 0.17349074E-05_JPRB, 0.17356450E-05_JPRB, 0.17357149E-05_JPRB, 0.17365287E-05_JPRB, 0.17381010E-05_JPRB, 0.17411275E-05_JPRB, &
  & 0.17466243E-05_JPRB, 0.17524374E-05_JPRB, 0.17590494E-05_JPRB, 0.17663271E-05_JPRB, 0.17734566E-05_JPRB, 0.17793839E-05_JPRB, &
  & 0.17829344E-05_JPRB, 0.17849714E-05_JPRB, 0.17868548E-05_JPRB, 0.17883887E-05_JPRB, 0.17900784E-05_JPRB, 0.17917776E-05_JPRB, &
  & 0.17931386E-05_JPRB, 0.17946305E-05_JPRB, 0.17956879E-05_JPRB, 0.17974542E-05_JPRB, 0.17981691E-05_JPRB, 0.17987453E-05_JPRB, &
  & 0.17995392E-05_JPRB, 0.18006611E-05_JPRB, 0.18013284E-05_JPRB, 0.18017153E-05_JPRB  /)

RGHG2(:,60, 2) = (/ &
  & 0.16884355E-05_JPRB, 0.16874935E-05_JPRB, 0.16871063E-05_JPRB, 0.16878127E-05_JPRB, 0.16877488E-05_JPRB, 0.16873902E-05_JPRB, &
  & 0.16858653E-05_JPRB, 0.16851396E-05_JPRB, 0.16847351E-05_JPRB, 0.16855096E-05_JPRB, 0.16862387E-05_JPRB, 0.16872718E-05_JPRB, &
  & 0.16885162E-05_JPRB, 0.16902457E-05_JPRB, 0.16919580E-05_JPRB, 0.16934857E-05_JPRB, 0.16950293E-05_JPRB, 0.16969108E-05_JPRB, &
  & 0.16991838E-05_JPRB, 0.17017395E-05_JPRB, 0.17037146E-05_JPRB, 0.17051763E-05_JPRB, 0.17074635E-05_JPRB, 0.17101320E-05_JPRB, &
  & 0.17131381E-05_JPRB, 0.17159697E-05_JPRB, 0.17189725E-05_JPRB, 0.17221157E-05_JPRB, 0.17253224E-05_JPRB, 0.17283741E-05_JPRB, &
  & 0.17319557E-05_JPRB, 0.17329586E-05_JPRB, 0.17330577E-05_JPRB, 0.17330978E-05_JPRB, 0.17334174E-05_JPRB, 0.17338915E-05_JPRB, &
  & 0.17344633E-05_JPRB, 0.17349621E-05_JPRB, 0.17349670E-05_JPRB, 0.17359450E-05_JPRB, 0.17378410E-05_JPRB, 0.17412978E-05_JPRB, &
  & 0.17471484E-05_JPRB, 0.17532682E-05_JPRB, 0.17601200E-05_JPRB, 0.17677186E-05_JPRB, 0.17751473E-05_JPRB, 0.17812900E-05_JPRB, &
  & 0.17850004E-05_JPRB, 0.17872176E-05_JPRB, 0.17892013E-05_JPRB, 0.17907912E-05_JPRB, 0.17924575E-05_JPRB, 0.17941964E-05_JPRB, &
  & 0.17956627E-05_JPRB, 0.17970943E-05_JPRB, 0.17982395E-05_JPRB, 0.17999919E-05_JPRB, 0.18006505E-05_JPRB, 0.18012428E-05_JPRB, &
  & 0.18019737E-05_JPRB, 0.18030592E-05_JPRB, 0.18038343E-05_JPRB, 0.18042759E-05_JPRB  /)

RGHG2(:,61, 2) = (/ &
  & 0.16861922E-05_JPRB, 0.16854595E-05_JPRB, 0.16851758E-05_JPRB, 0.16857941E-05_JPRB, 0.16857720E-05_JPRB, 0.16854795E-05_JPRB, &
  & 0.16841793E-05_JPRB, 0.16834955E-05_JPRB, 0.16831416E-05_JPRB, 0.16838390E-05_JPRB, 0.16845593E-05_JPRB, 0.16855726E-05_JPRB, &
  & 0.16869139E-05_JPRB, 0.16887293E-05_JPRB, 0.16905077E-05_JPRB, 0.16922469E-05_JPRB, 0.16938853E-05_JPRB, 0.16958879E-05_JPRB, &
  & 0.16980860E-05_JPRB, 0.17005646E-05_JPRB, 0.17026190E-05_JPRB, 0.17042260E-05_JPRB, 0.17064274E-05_JPRB, 0.17090716E-05_JPRB, &
  & 0.17118839E-05_JPRB, 0.17147000E-05_JPRB, 0.17179474E-05_JPRB, 0.17213285E-05_JPRB, 0.17247621E-05_JPRB, 0.17280715E-05_JPRB, &
  & 0.17316994E-05_JPRB, 0.17325503E-05_JPRB, 0.17324886E-05_JPRB, 0.17325639E-05_JPRB, 0.17330796E-05_JPRB, 0.17335537E-05_JPRB, &
  & 0.17339581E-05_JPRB, 0.17343027E-05_JPRB, 0.17342834E-05_JPRB, 0.17353428E-05_JPRB, 0.17374482E-05_JPRB, 0.17415041E-05_JPRB, &
  & 0.17477116E-05_JPRB, 0.17539900E-05_JPRB, 0.17611193E-05_JPRB, 0.17690902E-05_JPRB, 0.17767679E-05_JPRB, 0.17830846E-05_JPRB, &
  & 0.17869404E-05_JPRB, 0.17893273E-05_JPRB, 0.17914167E-05_JPRB, 0.17930374E-05_JPRB, 0.17946729E-05_JPRB, 0.17964470E-05_JPRB, &
  & 0.17979838E-05_JPRB, 0.17993801E-05_JPRB, 0.18006201E-05_JPRB, 0.18022953E-05_JPRB, 0.18029386E-05_JPRB, 0.18036101E-05_JPRB, &
  & 0.18042926E-05_JPRB, 0.18052922E-05_JPRB, 0.18060739E-05_JPRB, 0.18063877E-05_JPRB  /)

RGHG2(:,62, 2) = (/ &
  & 0.16844375E-05_JPRB, 0.16838833E-05_JPRB, 0.16836706E-05_JPRB, 0.16841703E-05_JPRB, 0.16841897E-05_JPRB, 0.16839719E-05_JPRB, &
  & 0.16829248E-05_JPRB, 0.16822776E-05_JPRB, 0.16819222E-05_JPRB, 0.16825075E-05_JPRB, 0.16831779E-05_JPRB, 0.16841120E-05_JPRB, &
  & 0.16854457E-05_JPRB, 0.16872552E-05_JPRB, 0.16890479E-05_JPRB, 0.16909516E-05_JPRB, 0.16926518E-05_JPRB, 0.16947517E-05_JPRB, &
  & 0.16968905E-05_JPRB, 0.16993401E-05_JPRB, 0.17013898E-05_JPRB, 0.17031355E-05_JPRB, 0.17052107E-05_JPRB, 0.17077712E-05_JPRB, &
  & 0.17103540E-05_JPRB, 0.17131559E-05_JPRB, 0.17165970E-05_JPRB, 0.17202855E-05_JPRB, 0.17239483E-05_JPRB, 0.17277732E-05_JPRB, &
  & 0.17315483E-05_JPRB, 0.17321837E-05_JPRB, 0.17320685E-05_JPRB, 0.17321851E-05_JPRB, 0.17327678E-05_JPRB, 0.17332076E-05_JPRB, &
  & 0.17334099E-05_JPRB, 0.17336035E-05_JPRB, 0.17335625E-05_JPRB, 0.17345772E-05_JPRB, 0.17370469E-05_JPRB, 0.17418141E-05_JPRB, &
  & 0.17483816E-05_JPRB, 0.17547014E-05_JPRB, 0.17622623E-05_JPRB, 0.17705766E-05_JPRB, 0.17784329E-05_JPRB, 0.17848737E-05_JPRB, &
  & 0.17889056E-05_JPRB, 0.17914675E-05_JPRB, 0.17935976E-05_JPRB, 0.17952192E-05_JPRB, 0.17968358E-05_JPRB, 0.17986659E-05_JPRB, &
  & 0.18002428E-05_JPRB, 0.18016436E-05_JPRB, 0.18029535E-05_JPRB, 0.18045345E-05_JPRB, 0.18051765E-05_JPRB, 0.18059837E-05_JPRB, &
  & 0.18066537E-05_JPRB, 0.18075418E-05_JPRB, 0.18082504E-05_JPRB, 0.18083459E-05_JPRB  /)

RGHG2(:,63, 2) = (/ &
  & 0.16830219E-05_JPRB, 0.16826145E-05_JPRB, 0.16824531E-05_JPRB, 0.16828217E-05_JPRB, 0.16828746E-05_JPRB, 0.16827356E-05_JPRB, &
  & 0.16819438E-05_JPRB, 0.16813299E-05_JPRB, 0.16809509E-05_JPRB, 0.16814029E-05_JPRB, 0.16819903E-05_JPRB, 0.16828035E-05_JPRB, &
  & 0.16840526E-05_JPRB, 0.16857851E-05_JPRB, 0.16875470E-05_JPRB, 0.16895533E-05_JPRB, 0.16912939E-05_JPRB, 0.16934584E-05_JPRB, &
  & 0.16955527E-05_JPRB, 0.16979914E-05_JPRB, 0.17000094E-05_JPRB, 0.17018692E-05_JPRB, 0.17038253E-05_JPRB, 0.17062547E-05_JPRB, &
  & 0.17085861E-05_JPRB, 0.17113738E-05_JPRB, 0.17150246E-05_JPRB, 0.17190331E-05_JPRB, 0.17229208E-05_JPRB, 0.17274525E-05_JPRB, &
  & 0.17314803E-05_JPRB, 0.17320034E-05_JPRB, 0.17318634E-05_JPRB, 0.17319090E-05_JPRB, 0.17324653E-05_JPRB, 0.17328082E-05_JPRB, &
  & 0.17327908E-05_JPRB, 0.17328317E-05_JPRB, 0.17328099E-05_JPRB, 0.17338344E-05_JPRB, 0.17367095E-05_JPRB, 0.17422124E-05_JPRB, &
  & 0.17491141E-05_JPRB, 0.17554714E-05_JPRB, 0.17635696E-05_JPRB, 0.17721741E-05_JPRB, 0.17801774E-05_JPRB, 0.17867077E-05_JPRB, &
  & 0.17909275E-05_JPRB, 0.17936683E-05_JPRB, 0.17957734E-05_JPRB, 0.17973888E-05_JPRB, 0.17989941E-05_JPRB, 0.18008958E-05_JPRB, &
  & 0.18024982E-05_JPRB, 0.18039153E-05_JPRB, 0.18052692E-05_JPRB, 0.18067583E-05_JPRB, 0.18074057E-05_JPRB, 0.18083589E-05_JPRB, &
  & 0.18090327E-05_JPRB, 0.18098188E-05_JPRB, 0.18104223E-05_JPRB, 0.18102594E-05_JPRB  /)

RGHG2(:,64, 2) = (/ &
  & 0.16820053E-05_JPRB, 0.16816919E-05_JPRB, 0.16815642E-05_JPRB, 0.16818076E-05_JPRB, 0.16818725E-05_JPRB, 0.16818106E-05_JPRB, &
  & 0.16812404E-05_JPRB, 0.16806555E-05_JPRB, 0.16802523E-05_JPRB, 0.16805598E-05_JPRB, 0.16810267E-05_JPRB, 0.16816809E-05_JPRB, &
  & 0.16827637E-05_JPRB, 0.16843396E-05_JPRB, 0.16860124E-05_JPRB, 0.16880115E-05_JPRB, 0.16897714E-05_JPRB, 0.16919407E-05_JPRB, &
  & 0.16940133E-05_JPRB, 0.16964376E-05_JPRB, 0.16984435E-05_JPRB, 0.17003587E-05_JPRB, 0.17022594E-05_JPRB, 0.17045057E-05_JPRB, &
  & 0.17065769E-05_JPRB, 0.17093501E-05_JPRB, 0.17132948E-05_JPRB, 0.17175708E-05_JPRB, 0.17216609E-05_JPRB, 0.17270840E-05_JPRB, &
  & 0.17315142E-05_JPRB, 0.17322517E-05_JPRB, 0.17320491E-05_JPRB, 0.17317405E-05_JPRB, 0.17321715E-05_JPRB, 0.17323000E-05_JPRB, &
  & 0.17320633E-05_JPRB, 0.17319501E-05_JPRB, 0.17320463E-05_JPRB, 0.17333455E-05_JPRB, 0.17365530E-05_JPRB, 0.17427089E-05_JPRB, &
  & 0.17498635E-05_JPRB, 0.17563678E-05_JPRB, 0.17650876E-05_JPRB, 0.17738680E-05_JPRB, 0.17820063E-05_JPRB, 0.17885871E-05_JPRB, &
  & 0.17929852E-05_JPRB, 0.17959019E-05_JPRB, 0.17978866E-05_JPRB, 0.17995092E-05_JPRB, 0.18011096E-05_JPRB, 0.18030981E-05_JPRB, &
  & 0.18047198E-05_JPRB, 0.18061417E-05_JPRB, 0.18074980E-05_JPRB, 0.18089220E-05_JPRB, 0.18095766E-05_JPRB, 0.18106383E-05_JPRB, &
  & 0.18113193E-05_JPRB, 0.18120572E-05_JPRB, 0.18125619E-05_JPRB, 0.18121437E-05_JPRB  /)

RGHG2(:,65, 2) = (/ &
  & 0.16813169E-05_JPRB, 0.16810600E-05_JPRB, 0.16809551E-05_JPRB, 0.16811081E-05_JPRB, 0.16811717E-05_JPRB, 0.16811696E-05_JPRB, &
  & 0.16807465E-05_JPRB, 0.16801974E-05_JPRB, 0.16797925E-05_JPRB, 0.16799542E-05_JPRB, 0.16802773E-05_JPRB, 0.16807713E-05_JPRB, &
  & 0.16816664E-05_JPRB, 0.16829792E-05_JPRB, 0.16844769E-05_JPRB, 0.16863207E-05_JPRB, 0.16880260E-05_JPRB, 0.16901531E-05_JPRB, &
  & 0.16922060E-05_JPRB, 0.16946494E-05_JPRB, 0.16966343E-05_JPRB, 0.16985851E-05_JPRB, 0.17003761E-05_JPRB, 0.17025164E-05_JPRB, &
  & 0.17045070E-05_JPRB, 0.17071828E-05_JPRB, 0.17115021E-05_JPRB, 0.17159781E-05_JPRB, 0.17203797E-05_JPRB, 0.17266024E-05_JPRB, &
  & 0.17315681E-05_JPRB, 0.17325956E-05_JPRB, 0.17321774E-05_JPRB, 0.17314671E-05_JPRB, 0.17318459E-05_JPRB, 0.17317112E-05_JPRB, &
  & 0.17313859E-05_JPRB, 0.17310904E-05_JPRB, 0.17314021E-05_JPRB, 0.17330542E-05_JPRB, 0.17365721E-05_JPRB, 0.17432402E-05_JPRB, &
  & 0.17506116E-05_JPRB, 0.17575734E-05_JPRB, 0.17667985E-05_JPRB, 0.17757224E-05_JPRB, 0.17839339E-05_JPRB, 0.17905657E-05_JPRB, &
  & 0.17950918E-05_JPRB, 0.17980602E-05_JPRB, 0.17999459E-05_JPRB, 0.18015937E-05_JPRB, 0.18032072E-05_JPRB, 0.18052248E-05_JPRB, &
  & 0.18068457E-05_JPRB, 0.18082703E-05_JPRB, 0.18095796E-05_JPRB, 0.18110076E-05_JPRB, 0.18116830E-05_JPRB, 0.18127508E-05_JPRB, &
  & 0.18134099E-05_JPRB, 0.18141755E-05_JPRB, 0.18147623E-05_JPRB, 0.18141809E-05_JPRB  /)

RGHG2(:,66, 2) = (/ &
  & 0.16807688E-05_JPRB, 0.16805746E-05_JPRB, 0.16804904E-05_JPRB, 0.16805788E-05_JPRB, 0.16806386E-05_JPRB, 0.16806757E-05_JPRB, &
  & 0.16803588E-05_JPRB, 0.16798537E-05_JPRB, 0.16794586E-05_JPRB, 0.16794783E-05_JPRB, 0.16796465E-05_JPRB, 0.16799851E-05_JPRB, &
  & 0.16806938E-05_JPRB, 0.16817010E-05_JPRB, 0.16829773E-05_JPRB, 0.16845932E-05_JPRB, 0.16861960E-05_JPRB, 0.16882481E-05_JPRB, &
  & 0.16902587E-05_JPRB, 0.16927186E-05_JPRB, 0.16946813E-05_JPRB, 0.16966426E-05_JPRB, 0.16982755E-05_JPRB, 0.17003318E-05_JPRB, &
  & 0.17023859E-05_JPRB, 0.17050377E-05_JPRB, 0.17096871E-05_JPRB, 0.17144307E-05_JPRB, 0.17191616E-05_JPRB, 0.17260374E-05_JPRB, &
  & 0.17314993E-05_JPRB, 0.17326351E-05_JPRB, 0.17321309E-05_JPRB, 0.17310828E-05_JPRB, 0.17313824E-05_JPRB, 0.17309231E-05_JPRB, &
  & 0.17303467E-05_JPRB, 0.17300744E-05_JPRB, 0.17306762E-05_JPRB, 0.17327522E-05_JPRB, 0.17366648E-05_JPRB, 0.17437949E-05_JPRB, &
  & 0.17514070E-05_JPRB, 0.17590045E-05_JPRB, 0.17686556E-05_JPRB, 0.17777309E-05_JPRB, 0.17859675E-05_JPRB, 0.17926581E-05_JPRB, &
  & 0.17972815E-05_JPRB, 0.18002056E-05_JPRB, 0.18020352E-05_JPRB, 0.18037143E-05_JPRB, 0.18053440E-05_JPRB, 0.18073156E-05_JPRB, &
  & 0.18089242E-05_JPRB, 0.18103498E-05_JPRB, 0.18116074E-05_JPRB, 0.18130283E-05_JPRB, 0.18137527E-05_JPRB, 0.18147996E-05_JPRB, &
  & 0.18154072E-05_JPRB, 0.18162638E-05_JPRB, 0.18169831E-05_JPRB, 0.18163458E-05_JPRB  /)

RGHG2(:,67, 2) = (/ &
  & 0.16803396E-05_JPRB, 0.16802183E-05_JPRB, 0.16801563E-05_JPRB, 0.16802048E-05_JPRB, 0.16802554E-05_JPRB, 0.16803138E-05_JPRB, &
  & 0.16800701E-05_JPRB, 0.16796151E-05_JPRB, 0.16792368E-05_JPRB, 0.16791267E-05_JPRB, 0.16791358E-05_JPRB, 0.16793251E-05_JPRB, &
  & 0.16798541E-05_JPRB, 0.16805422E-05_JPRB, 0.16815565E-05_JPRB, 0.16828988E-05_JPRB, 0.16843524E-05_JPRB, 0.16862971E-05_JPRB, &
  & 0.16882370E-05_JPRB, 0.16906765E-05_JPRB, 0.16926222E-05_JPRB, 0.16945463E-05_JPRB, 0.16960350E-05_JPRB, 0.16980058E-05_JPRB, &
  & 0.17002465E-05_JPRB, 0.17029688E-05_JPRB, 0.17078836E-05_JPRB, 0.17129431E-05_JPRB, 0.17179719E-05_JPRB, 0.17253632E-05_JPRB, &
  & 0.17312730E-05_JPRB, 0.17324004E-05_JPRB, 0.17319161E-05_JPRB, 0.17305677E-05_JPRB, 0.17307030E-05_JPRB, 0.17299011E-05_JPRB, &
  & 0.17288753E-05_JPRB, 0.17288215E-05_JPRB, 0.17297768E-05_JPRB, 0.17324079E-05_JPRB, 0.17368377E-05_JPRB, 0.17443754E-05_JPRB, &
  & 0.17522786E-05_JPRB, 0.17606388E-05_JPRB, 0.17706506E-05_JPRB, 0.17798772E-05_JPRB, 0.17881004E-05_JPRB, 0.17948440E-05_JPRB, &
  & 0.17995282E-05_JPRB, 0.18023194E-05_JPRB, 0.18041308E-05_JPRB, 0.18058547E-05_JPRB, 0.18074952E-05_JPRB, 0.18093684E-05_JPRB, &
  & 0.18109344E-05_JPRB, 0.18123523E-05_JPRB, 0.18135758E-05_JPRB, 0.18149620E-05_JPRB, 0.18157592E-05_JPRB, 0.18167888E-05_JPRB, &
  & 0.18173258E-05_JPRB, 0.18183346E-05_JPRB, 0.18191784E-05_JPRB, 0.18185794E-05_JPRB  /)

RGHG2(:,68, 2) = (/ &
  & 0.16800073E-05_JPRB, 0.16799702E-05_JPRB, 0.16799379E-05_JPRB, 0.16799690E-05_JPRB, 0.16799974E-05_JPRB, 0.16800656E-05_JPRB, &
  & 0.16798764E-05_JPRB, 0.16794733E-05_JPRB, 0.16791099E-05_JPRB, 0.16788984E-05_JPRB, 0.16787541E-05_JPRB, 0.16787999E-05_JPRB, &
  & 0.16791607E-05_JPRB, 0.16795617E-05_JPRB, 0.16802767E-05_JPRB, 0.16813419E-05_JPRB, 0.16825976E-05_JPRB, 0.16844013E-05_JPRB, &
  & 0.16862348E-05_JPRB, 0.16885506E-05_JPRB, 0.16904963E-05_JPRB, 0.16922893E-05_JPRB, 0.16937805E-05_JPRB, 0.16956226E-05_JPRB, &
  & 0.16981305E-05_JPRB, 0.17010285E-05_JPRB, 0.17061312E-05_JPRB, 0.17114876E-05_JPRB, 0.17166995E-05_JPRB, 0.17245139E-05_JPRB, &
  & 0.17308467E-05_JPRB, 0.17320483E-05_JPRB, 0.17315764E-05_JPRB, 0.17298792E-05_JPRB, 0.17296607E-05_JPRB, 0.17285916E-05_JPRB, &
  & 0.17269028E-05_JPRB, 0.17271854E-05_JPRB, 0.17285391E-05_JPRB, 0.17319915E-05_JPRB, 0.17371239E-05_JPRB, 0.17449956E-05_JPRB, &
  & 0.17532872E-05_JPRB, 0.17624563E-05_JPRB, 0.17727947E-05_JPRB, 0.17821500E-05_JPRB, 0.17903410E-05_JPRB, 0.17971020E-05_JPRB, &
  & 0.18017960E-05_JPRB, 0.18043794E-05_JPRB, 0.18061933E-05_JPRB, 0.18079939E-05_JPRB, 0.18096245E-05_JPRB, 0.18114012E-05_JPRB, &
  & 0.18128534E-05_JPRB, 0.18142391E-05_JPRB, 0.18154849E-05_JPRB, 0.18167894E-05_JPRB, 0.18176708E-05_JPRB, 0.18187375E-05_JPRB, &
  & 0.18192077E-05_JPRB, 0.18204268E-05_JPRB, 0.18212879E-05_JPRB, 0.18207854E-05_JPRB  /)

RGHG2(:,69, 2) = (/ &
  & 0.16797583E-05_JPRB, 0.16797963E-05_JPRB, 0.16797869E-05_JPRB, 0.16798165E-05_JPRB, 0.16798226E-05_JPRB, 0.16798917E-05_JPRB, &
  & 0.16797502E-05_JPRB, 0.16794013E-05_JPRB, 0.16790437E-05_JPRB, 0.16787803E-05_JPRB, 0.16785007E-05_JPRB, 0.16784278E-05_JPRB, &
  & 0.16786339E-05_JPRB, 0.16787818E-05_JPRB, 0.16791839E-05_JPRB, 0.16800329E-05_JPRB, 0.16810570E-05_JPRB, 0.16826904E-05_JPRB, &
  & 0.16843320E-05_JPRB, 0.16864092E-05_JPRB, 0.16883325E-05_JPRB, 0.16900078E-05_JPRB, 0.16915331E-05_JPRB, 0.16933704E-05_JPRB, &
  & 0.16960013E-05_JPRB, 0.16991064E-05_JPRB, 0.17044512E-05_JPRB, 0.17100774E-05_JPRB, 0.17155354E-05_JPRB, 0.17237907E-05_JPRB, &
  & 0.17304857E-05_JPRB, 0.17318674E-05_JPRB, 0.17313087E-05_JPRB, 0.17291885E-05_JPRB, 0.17286118E-05_JPRB, 0.17272035E-05_JPRB, &
  & 0.17252075E-05_JPRB, 0.17257973E-05_JPRB, 0.17276099E-05_JPRB, 0.17318746E-05_JPRB, 0.17376689E-05_JPRB, 0.17457912E-05_JPRB, &
  & 0.17545657E-05_JPRB, 0.17645820E-05_JPRB, 0.17751388E-05_JPRB, 0.17845349E-05_JPRB, 0.17926239E-05_JPRB, 0.17993617E-05_JPRB, &
  & 0.18040003E-05_JPRB, 0.18064074E-05_JPRB, 0.18082013E-05_JPRB, 0.18100606E-05_JPRB, 0.18117083E-05_JPRB, 0.18134065E-05_JPRB, &
  & 0.18146774E-05_JPRB, 0.18159747E-05_JPRB, 0.18172900E-05_JPRB, 0.18186030E-05_JPRB, 0.18195685E-05_JPRB, 0.18207173E-05_JPRB, &
  & 0.18212108E-05_JPRB, 0.18226221E-05_JPRB, 0.18233158E-05_JPRB, 0.18228242E-05_JPRB  /)

RGHG2(:,70, 2) = (/ &
  & 0.16795807E-05_JPRB, 0.16796656E-05_JPRB, 0.16796786E-05_JPRB, 0.16797125E-05_JPRB, 0.16797078E-05_JPRB, 0.16797740E-05_JPRB, &
  & 0.16796709E-05_JPRB, 0.16793708E-05_JPRB, 0.16790239E-05_JPRB, 0.16787249E-05_JPRB, 0.16783417E-05_JPRB, 0.16781667E-05_JPRB, &
  & 0.16782248E-05_JPRB, 0.16781440E-05_JPRB, 0.16782530E-05_JPRB, 0.16789287E-05_JPRB, 0.16797057E-05_JPRB, 0.16811283E-05_JPRB, &
  & 0.16825332E-05_JPRB, 0.16843544E-05_JPRB, 0.16861997E-05_JPRB, 0.16878002E-05_JPRB, 0.16893454E-05_JPRB, 0.16912174E-05_JPRB, &
  & 0.16938869E-05_JPRB, 0.16971467E-05_JPRB, 0.17027767E-05_JPRB, 0.17087381E-05_JPRB, 0.17144503E-05_JPRB, 0.17232097E-05_JPRB, &
  & 0.17302357E-05_JPRB, 0.17317953E-05_JPRB, 0.17312694E-05_JPRB, 0.17288300E-05_JPRB, 0.17278206E-05_JPRB, 0.17259733E-05_JPRB, &
  & 0.17239161E-05_JPRB, 0.17248538E-05_JPRB, 0.17271597E-05_JPRB, 0.17320504E-05_JPRB, 0.17384407E-05_JPRB, 0.17467758E-05_JPRB, &
  & 0.17561168E-05_JPRB, 0.17669640E-05_JPRB, 0.17776686E-05_JPRB, 0.17869920E-05_JPRB, 0.17948843E-05_JPRB, 0.18015833E-05_JPRB, &
  & 0.18061599E-05_JPRB, 0.18084209E-05_JPRB, 0.18101881E-05_JPRB, 0.18120556E-05_JPRB, 0.18137648E-05_JPRB, 0.18153862E-05_JPRB, &
  & 0.18164486E-05_JPRB, 0.18176747E-05_JPRB, 0.18191032E-05_JPRB, 0.18204666E-05_JPRB, 0.18215437E-05_JPRB, 0.18227375E-05_JPRB, &
  & 0.18233567E-05_JPRB, 0.18248985E-05_JPRB, 0.18253991E-05_JPRB, 0.18248726E-05_JPRB  /)

RGHG2(:,71, 2) = (/ &
  & 0.16794678E-05_JPRB, 0.16795719E-05_JPRB, 0.16796065E-05_JPRB, 0.16796498E-05_JPRB, 0.16796451E-05_JPRB, 0.16797076E-05_JPRB, &
  & 0.16796367E-05_JPRB, 0.16793769E-05_JPRB, 0.16790485E-05_JPRB, 0.16787229E-05_JPRB, 0.16782697E-05_JPRB, 0.16780080E-05_JPRB, &
  & 0.16779275E-05_JPRB, 0.16776447E-05_JPRB, 0.16774979E-05_JPRB, 0.16780255E-05_JPRB, 0.16785499E-05_JPRB, 0.16797239E-05_JPRB, &
  & 0.16808617E-05_JPRB, 0.16824308E-05_JPRB, 0.16841540E-05_JPRB, 0.16857112E-05_JPRB, 0.16872582E-05_JPRB, 0.16891411E-05_JPRB, &
  & 0.16918094E-05_JPRB, 0.16951177E-05_JPRB, 0.17010725E-05_JPRB, 0.17074392E-05_JPRB, 0.17134042E-05_JPRB, 0.17227368E-05_JPRB, &
  & 0.17300838E-05_JPRB, 0.17318580E-05_JPRB, 0.17315465E-05_JPRB, 0.17288324E-05_JPRB, 0.17273840E-05_JPRB, 0.17250773E-05_JPRB, &
  & 0.17232028E-05_JPRB, 0.17244692E-05_JPRB, 0.17272557E-05_JPRB, 0.17325548E-05_JPRB, 0.17394603E-05_JPRB, 0.17480255E-05_JPRB, &
  & 0.17580010E-05_JPRB, 0.17695863E-05_JPRB, 0.17803657E-05_JPRB, 0.17895004E-05_JPRB, 0.17971226E-05_JPRB, 0.18037788E-05_JPRB, &
  & 0.18082705E-05_JPRB, 0.18104319E-05_JPRB, 0.18121700E-05_JPRB, 0.18139952E-05_JPRB, 0.18158017E-05_JPRB, 0.18173469E-05_JPRB, &
  & 0.18181925E-05_JPRB, 0.18193697E-05_JPRB, 0.18209457E-05_JPRB, 0.18224034E-05_JPRB, 0.18236211E-05_JPRB, 0.18248293E-05_JPRB, &
  & 0.18256349E-05_JPRB, 0.18272266E-05_JPRB, 0.18275889E-05_JPRB, 0.18270172E-05_JPRB  /)

RGHG2(:,72, 2) = (/ &
  & 0.16794108E-05_JPRB, 0.16795100E-05_JPRB, 0.16795644E-05_JPRB, 0.16796225E-05_JPRB, 0.16796252E-05_JPRB, 0.16796878E-05_JPRB, &
  & 0.16796491E-05_JPRB, 0.16794165E-05_JPRB, 0.16791179E-05_JPRB, 0.16787675E-05_JPRB, 0.16782796E-05_JPRB, 0.16779461E-05_JPRB, &
  & 0.16777417E-05_JPRB, 0.16772906E-05_JPRB, 0.16769531E-05_JPRB, 0.16773272E-05_JPRB, 0.16776063E-05_JPRB, 0.16785006E-05_JPRB, &
  & 0.16793586E-05_JPRB, 0.16806998E-05_JPRB, 0.16822843E-05_JPRB, 0.16838019E-05_JPRB, 0.16853340E-05_JPRB, 0.16870981E-05_JPRB, &
  & 0.16897986E-05_JPRB, 0.16929607E-05_JPRB, 0.16992770E-05_JPRB, 0.17061119E-05_JPRB, 0.17123220E-05_JPRB, 0.17223034E-05_JPRB, &
  & 0.17299971E-05_JPRB, 0.17321230E-05_JPRB, 0.17322869E-05_JPRB, 0.17291890E-05_JPRB, 0.17274410E-05_JPRB, 0.17248123E-05_JPRB, &
  & 0.17233910E-05_JPRB, 0.17248357E-05_JPRB, 0.17280061E-05_JPRB, 0.17334686E-05_JPRB, 0.17407852E-05_JPRB, 0.17496971E-05_JPRB, &
  & 0.17603512E-05_JPRB, 0.17724441E-05_JPRB, 0.17832111E-05_JPRB, 0.17920388E-05_JPRB, 0.17993612E-05_JPRB, 0.18059878E-05_JPRB, &
  & 0.18103259E-05_JPRB, 0.18124675E-05_JPRB, 0.18141783E-05_JPRB, 0.18159169E-05_JPRB, 0.18178373E-05_JPRB, 0.18193082E-05_JPRB, &
  & 0.18199557E-05_JPRB, 0.18211007E-05_JPRB, 0.18228426E-05_JPRB, 0.18244538E-05_JPRB, 0.18258400E-05_JPRB, 0.18270605E-05_JPRB, &
  & 0.18280321E-05_JPRB, 0.18295643E-05_JPRB, 0.18299662E-05_JPRB, 0.18293996E-05_JPRB  /)

RGHG2(:,73, 2) = (/ &
  & 0.16793808E-05_JPRB, 0.16794657E-05_JPRB, 0.16795401E-05_JPRB, 0.16796086E-05_JPRB, 0.16796325E-05_JPRB, 0.16796997E-05_JPRB, &
  & 0.16796911E-05_JPRB, 0.16794859E-05_JPRB, 0.16792240E-05_JPRB, 0.16788534E-05_JPRB, 0.16783513E-05_JPRB, 0.16779662E-05_JPRB, &
  & 0.16776603E-05_JPRB, 0.16771018E-05_JPRB, 0.16766346E-05_JPRB, 0.16768359E-05_JPRB, 0.16769006E-05_JPRB, 0.16775341E-05_JPRB, &
  & 0.16781612E-05_JPRB, 0.16792732E-05_JPRB, 0.16807665E-05_JPRB, 0.16821546E-05_JPRB, 0.16836350E-05_JPRB, 0.16852726E-05_JPRB, &
  & 0.16878676E-05_JPRB, 0.16907311E-05_JPRB, 0.16972916E-05_JPRB, 0.17046018E-05_JPRB, 0.17111228E-05_JPRB, 0.17216144E-05_JPRB, &
  & 0.17296499E-05_JPRB, 0.17325960E-05_JPRB, 0.17332841E-05_JPRB, 0.17298622E-05_JPRB, 0.17281024E-05_JPRB, 0.17256487E-05_JPRB, &
  & 0.17247545E-05_JPRB, 0.17260958E-05_JPRB, 0.17295373E-05_JPRB, 0.17349849E-05_JPRB, 0.17427610E-05_JPRB, 0.17521526E-05_JPRB, &
  & 0.17633237E-05_JPRB, 0.17756284E-05_JPRB, 0.17861761E-05_JPRB, 0.17946627E-05_JPRB, 0.18017298E-05_JPRB, 0.18081633E-05_JPRB, &
  & 0.18123653E-05_JPRB, 0.18146249E-05_JPRB, 0.18162831E-05_JPRB, 0.18179252E-05_JPRB, 0.18199350E-05_JPRB, 0.18213013E-05_JPRB, &
  & 0.18217656E-05_JPRB, 0.18229058E-05_JPRB, 0.18248261E-05_JPRB, 0.18267296E-05_JPRB, 0.18283174E-05_JPRB, 0.18296583E-05_JPRB, &
  & 0.18305416E-05_JPRB, 0.18320187E-05_JPRB, 0.18326696E-05_JPRB, 0.18322320E-05_JPRB  /)

RGHG2(:,74, 2) = (/ &
  & 0.16793607E-05_JPRB, 0.16794352E-05_JPRB, 0.16795400E-05_JPRB, 0.16796124E-05_JPRB, 0.16796573E-05_JPRB, 0.16797339E-05_JPRB, &
  & 0.16797462E-05_JPRB, 0.16795714E-05_JPRB, 0.16793454E-05_JPRB, 0.16789638E-05_JPRB, 0.16784567E-05_JPRB, 0.16780264E-05_JPRB, &
  & 0.16776343E-05_JPRB, 0.16770231E-05_JPRB, 0.16764539E-05_JPRB, 0.16764884E-05_JPRB, 0.16763849E-05_JPRB, 0.16767878E-05_JPRB, &
  & 0.16772243E-05_JPRB, 0.16781492E-05_JPRB, 0.16795016E-05_JPRB, 0.16807198E-05_JPRB, 0.16821260E-05_JPRB, 0.16837189E-05_JPRB, &
  & 0.16861581E-05_JPRB, 0.16886700E-05_JPRB, 0.16951968E-05_JPRB, 0.17028583E-05_JPRB, 0.17097404E-05_JPRB, 0.17207552E-05_JPRB, &
  & 0.17291258E-05_JPRB, 0.17329457E-05_JPRB, 0.17343081E-05_JPRB, 0.17307395E-05_JPRB, 0.17290609E-05_JPRB, 0.17269689E-05_JPRB, &
  & 0.17266268E-05_JPRB, 0.17279309E-05_JPRB, 0.17315665E-05_JPRB, 0.17371741E-05_JPRB, 0.17454103E-05_JPRB, 0.17553102E-05_JPRB, &
  & 0.17668271E-05_JPRB, 0.17790105E-05_JPRB, 0.17892096E-05_JPRB, 0.17972779E-05_JPRB, 0.18041518E-05_JPRB, 0.18103533E-05_JPRB, &
  & 0.18144074E-05_JPRB, 0.18168293E-05_JPRB, 0.18184701E-05_JPRB, 0.18200197E-05_JPRB, 0.18220956E-05_JPRB, 0.18233668E-05_JPRB, &
  & 0.18236390E-05_JPRB, 0.18248215E-05_JPRB, 0.18268777E-05_JPRB, 0.18291657E-05_JPRB, 0.18310204E-05_JPRB, 0.18324833E-05_JPRB, &
  & 0.18330956E-05_JPRB, 0.18346869E-05_JPRB, 0.18356774E-05_JPRB, 0.18355019E-05_JPRB  /)

RGHG2(:,75, 2) = (/ &
  & 0.16793472E-05_JPRB, 0.16794218E-05_JPRB, 0.16795645E-05_JPRB, 0.16796369E-05_JPRB, 0.16796983E-05_JPRB, 0.16797866E-05_JPRB, &
  & 0.16798131E-05_JPRB, 0.16796685E-05_JPRB, 0.16794725E-05_JPRB, 0.16790907E-05_JPRB, 0.16785878E-05_JPRB, 0.16781186E-05_JPRB, &
  & 0.16776571E-05_JPRB, 0.16770357E-05_JPRB, 0.16763885E-05_JPRB, 0.16762739E-05_JPRB, 0.16760499E-05_JPRB, 0.16762597E-05_JPRB, &
  & 0.16765415E-05_JPRB, 0.16773294E-05_JPRB, 0.16784898E-05_JPRB, 0.16795134E-05_JPRB, 0.16808025E-05_JPRB, 0.16823985E-05_JPRB, &
  & 0.16847065E-05_JPRB, 0.16868637E-05_JPRB, 0.16930299E-05_JPRB, 0.17008684E-05_JPRB, 0.17081327E-05_JPRB, 0.17197322E-05_JPRB, &
  & 0.17284199E-05_JPRB, 0.17330842E-05_JPRB, 0.17352560E-05_JPRB, 0.17317189E-05_JPRB, 0.17302465E-05_JPRB, 0.17286490E-05_JPRB, &
  & 0.17288067E-05_JPRB, 0.17302805E-05_JPRB, 0.17341549E-05_JPRB, 0.17401537E-05_JPRB, 0.17487500E-05_JPRB, 0.17591036E-05_JPRB, &
  & 0.17707345E-05_JPRB, 0.17824987E-05_JPRB, 0.17922312E-05_JPRB, 0.17998821E-05_JPRB, 0.18066117E-05_JPRB, 0.18125663E-05_JPRB, &
  & 0.18164949E-05_JPRB, 0.18191019E-05_JPRB, 0.18207542E-05_JPRB, 0.18222329E-05_JPRB, 0.18243562E-05_JPRB, 0.18255247E-05_JPRB, &
  & 0.18255969E-05_JPRB, 0.18268665E-05_JPRB, 0.18290363E-05_JPRB, 0.18317908E-05_JPRB, 0.18339745E-05_JPRB, 0.18354767E-05_JPRB, &
  & 0.18357370E-05_JPRB, 0.18376303E-05_JPRB, 0.18390040E-05_JPRB, 0.18391841E-05_JPRB  /)

RGHG2(:,76, 2) = (/ &
  & 0.16793375E-05_JPRB, 0.16794319E-05_JPRB, 0.16796142E-05_JPRB, 0.16796866E-05_JPRB, 0.16797554E-05_JPRB, 0.16798536E-05_JPRB, &
  & 0.16798925E-05_JPRB, 0.16797727E-05_JPRB, 0.16795940E-05_JPRB, 0.16792246E-05_JPRB, 0.16787365E-05_JPRB, 0.16782377E-05_JPRB, &
  & 0.16777266E-05_JPRB, 0.16771201E-05_JPRB, 0.16764184E-05_JPRB, 0.16761874E-05_JPRB, 0.16758916E-05_JPRB, 0.16759552E-05_JPRB, &
  & 0.16761131E-05_JPRB, 0.16768218E-05_JPRB, 0.16777493E-05_JPRB, 0.16785698E-05_JPRB, 0.16796633E-05_JPRB, 0.16812444E-05_JPRB, &
  & 0.16835523E-05_JPRB, 0.16854148E-05_JPRB, 0.16908305E-05_JPRB, 0.16986070E-05_JPRB, 0.17062330E-05_JPRB, 0.17185360E-05_JPRB, &
  & 0.17275061E-05_JPRB, 0.17329159E-05_JPRB, 0.17359993E-05_JPRB, 0.17326603E-05_JPRB, 0.17316016E-05_JPRB, 0.17305960E-05_JPRB, &
  & 0.17310857E-05_JPRB, 0.17331144E-05_JPRB, 0.17374619E-05_JPRB, 0.17441270E-05_JPRB, 0.17528297E-05_JPRB, 0.17634658E-05_JPRB, &
  & 0.17748787E-05_JPRB, 0.17859791E-05_JPRB, 0.17951294E-05_JPRB, 0.18024930E-05_JPRB, 0.18091037E-05_JPRB, 0.18148155E-05_JPRB, &
  & 0.18186996E-05_JPRB, 0.18214948E-05_JPRB, 0.18231695E-05_JPRB, 0.18246259E-05_JPRB, 0.18267838E-05_JPRB, 0.18278087E-05_JPRB, &
  & 0.18276778E-05_JPRB, 0.18290737E-05_JPRB, 0.18313748E-05_JPRB, 0.18346717E-05_JPRB, 0.18372394E-05_JPRB, 0.18385781E-05_JPRB, &
  & 0.18385535E-05_JPRB, 0.18409472E-05_JPRB, 0.18426924E-05_JPRB, 0.18432614E-05_JPRB  /)

RGHG2(:,77, 2) = (/ &
  & 0.16793344E-05_JPRB, 0.16794584E-05_JPRB, 0.16796809E-05_JPRB, 0.16797534E-05_JPRB, 0.16798225E-05_JPRB, 0.16799379E-05_JPRB, &
  & 0.16799798E-05_JPRB, 0.16798851E-05_JPRB, 0.16797169E-05_JPRB, 0.16793577E-05_JPRB, 0.16788871E-05_JPRB, 0.16783890E-05_JPRB, &
  & 0.16778516E-05_JPRB, 0.16772625E-05_JPRB, 0.16765222E-05_JPRB, 0.16762351E-05_JPRB, 0.16759307E-05_JPRB, 0.16759462E-05_JPRB, &
  & 0.16760023E-05_JPRB, 0.16765329E-05_JPRB, 0.16772457E-05_JPRB, 0.16779055E-05_JPRB, 0.16787385E-05_JPRB, 0.16801997E-05_JPRB, &
  & 0.16825339E-05_JPRB, 0.16842498E-05_JPRB, 0.16888972E-05_JPRB, 0.16963083E-05_JPRB, 0.17042844E-05_JPRB, 0.17174295E-05_JPRB, &
  & 0.17265860E-05_JPRB, 0.17323208E-05_JPRB, 0.17362500E-05_JPRB, 0.17334027E-05_JPRB, 0.17329828E-05_JPRB, 0.17328136E-05_JPRB, &
  & 0.17334707E-05_JPRB, 0.17359359E-05_JPRB, 0.17407561E-05_JPRB, 0.17482805E-05_JPRB, 0.17573343E-05_JPRB, 0.17682734E-05_JPRB, &
  & 0.17789625E-05_JPRB, 0.17891823E-05_JPRB, 0.17978995E-05_JPRB, 0.18052004E-05_JPRB, 0.18116166E-05_JPRB, 0.18171680E-05_JPRB, &
  & 0.18212237E-05_JPRB, 0.18241979E-05_JPRB, 0.18258880E-05_JPRB, 0.18272623E-05_JPRB, 0.18295460E-05_JPRB, 0.18304847E-05_JPRB, &
  & 0.18300333E-05_JPRB, 0.18314454E-05_JPRB, 0.18339225E-05_JPRB, 0.18377863E-05_JPRB, 0.18405957E-05_JPRB, 0.18417805E-05_JPRB, &
  & 0.18418149E-05_JPRB, 0.18447852E-05_JPRB, 0.18470169E-05_JPRB, 0.18481876E-05_JPRB  /)

RGHG2(:,78, 2) = (/ &
  & 0.16793457E-05_JPRB, 0.16795030E-05_JPRB, 0.16797544E-05_JPRB, 0.16798268E-05_JPRB, 0.16799008E-05_JPRB, 0.16800274E-05_JPRB, &
  & 0.16800702E-05_JPRB, 0.16799957E-05_JPRB, 0.16798375E-05_JPRB, 0.16794835E-05_JPRB, 0.16790305E-05_JPRB, 0.16785493E-05_JPRB, &
  & 0.16779979E-05_JPRB, 0.16774184E-05_JPRB, 0.16766724E-05_JPRB, 0.16763630E-05_JPRB, 0.16760664E-05_JPRB, 0.16760409E-05_JPRB, &
  & 0.16759968E-05_JPRB, 0.16763861E-05_JPRB, 0.16769146E-05_JPRB, 0.16774358E-05_JPRB, 0.16780297E-05_JPRB, 0.16793513E-05_JPRB, &
  & 0.16816268E-05_JPRB, 0.16832688E-05_JPRB, 0.16874272E-05_JPRB, 0.16944911E-05_JPRB, 0.17027595E-05_JPRB, 0.17167482E-05_JPRB, &
  & 0.17259749E-05_JPRB, 0.17317040E-05_JPRB, 0.17364038E-05_JPRB, 0.17339716E-05_JPRB, 0.17342371E-05_JPRB, 0.17347966E-05_JPRB, &
  & 0.17357232E-05_JPRB, 0.17384667E-05_JPRB, 0.17438201E-05_JPRB, 0.17520421E-05_JPRB, 0.17616075E-05_JPRB, 0.17727955E-05_JPRB, &
  & 0.17828792E-05_JPRB, 0.17921826E-05_JPRB, 0.18006375E-05_JPRB, 0.18079601E-05_JPRB, 0.18141530E-05_JPRB, 0.18196496E-05_JPRB, &
  & 0.18239790E-05_JPRB, 0.18270051E-05_JPRB, 0.18286097E-05_JPRB, 0.18299434E-05_JPRB, 0.18323797E-05_JPRB, 0.18333618E-05_JPRB, &
  & 0.18325673E-05_JPRB, 0.18338841E-05_JPRB, 0.18366444E-05_JPRB, 0.18410200E-05_JPRB, 0.18439603E-05_JPRB, 0.18450625E-05_JPRB, &
  & 0.18453165E-05_JPRB, 0.18489133E-05_JPRB, 0.18517205E-05_JPRB, 0.18536077E-05_JPRB  /)

RGHG2(:,79, 2) = (/ &
  & 0.16793737E-05_JPRB, 0.16795603E-05_JPRB, 0.16798286E-05_JPRB, 0.16799034E-05_JPRB, 0.16799840E-05_JPRB, 0.16801173E-05_JPRB, &
  & 0.16801601E-05_JPRB, 0.16801007E-05_JPRB, 0.16799509E-05_JPRB, 0.16795986E-05_JPRB, 0.16791646E-05_JPRB, 0.16787075E-05_JPRB, &
  & 0.16781503E-05_JPRB, 0.16775733E-05_JPRB, 0.16768493E-05_JPRB, 0.16765358E-05_JPRB, 0.16762525E-05_JPRB, 0.16761927E-05_JPRB, &
  & 0.16760648E-05_JPRB, 0.16763529E-05_JPRB, 0.16767216E-05_JPRB, 0.16771419E-05_JPRB, 0.16775402E-05_JPRB, 0.16787172E-05_JPRB, &
  & 0.16808833E-05_JPRB, 0.16824887E-05_JPRB, 0.16863953E-05_JPRB, 0.16932789E-05_JPRB, 0.17017294E-05_JPRB, 0.17165401E-05_JPRB, &
  & 0.17256678E-05_JPRB, 0.17311111E-05_JPRB, 0.17365122E-05_JPRB, 0.17344031E-05_JPRB, 0.17353808E-05_JPRB, 0.17364613E-05_JPRB, &
  & 0.17377709E-05_JPRB, 0.17407532E-05_JPRB, 0.17466681E-05_JPRB, 0.17553888E-05_JPRB, 0.17655464E-05_JPRB, 0.17769050E-05_JPRB, &
  & 0.17865482E-05_JPRB, 0.17949550E-05_JPRB, 0.18032946E-05_JPRB, 0.18106620E-05_JPRB, 0.18167111E-05_JPRB, 0.18221529E-05_JPRB, &
  & 0.18268674E-05_JPRB, 0.18298069E-05_JPRB, 0.18313203E-05_JPRB, 0.18327050E-05_JPRB, 0.18353407E-05_JPRB, 0.18364429E-05_JPRB, &
  & 0.18353241E-05_JPRB, 0.18364317E-05_JPRB, 0.18395126E-05_JPRB, 0.18444040E-05_JPRB, 0.18473617E-05_JPRB, 0.18484405E-05_JPRB, &
  & 0.18490428E-05_JPRB, 0.18532581E-05_JPRB, 0.18567540E-05_JPRB, 0.18594239E-05_JPRB  /)

RGHG2(:,80, 2) = (/ &
  & 0.16794197E-05_JPRB, 0.16796239E-05_JPRB, 0.16798973E-05_JPRB, 0.16799795E-05_JPRB, 0.16800650E-05_JPRB, 0.16802032E-05_JPRB, &
  & 0.16802461E-05_JPRB, 0.16801967E-05_JPRB, 0.16800517E-05_JPRB, 0.16796995E-05_JPRB, 0.16792877E-05_JPRB, 0.16788529E-05_JPRB, &
  & 0.16782933E-05_JPRB, 0.16777139E-05_JPRB, 0.16770318E-05_JPRB, 0.16767157E-05_JPRB, 0.16764426E-05_JPRB, 0.16763606E-05_JPRB, &
  & 0.16761827E-05_JPRB, 0.16764038E-05_JPRB, 0.16766285E-05_JPRB, 0.16770041E-05_JPRB, 0.16772685E-05_JPRB, 0.16783065E-05_JPRB, &
  & 0.16803581E-05_JPRB, 0.16819301E-05_JPRB, 0.16857497E-05_JPRB, 0.16927631E-05_JPRB, 0.17012314E-05_JPRB, 0.17168258E-05_JPRB, &
  & 0.17256303E-05_JPRB, 0.17305653E-05_JPRB, 0.17366069E-05_JPRB, 0.17347388E-05_JPRB, 0.17364433E-05_JPRB, 0.17377529E-05_JPRB, &
  & 0.17395505E-05_JPRB, 0.17428677E-05_JPRB, 0.17493325E-05_JPRB, 0.17583388E-05_JPRB, 0.17690856E-05_JPRB, 0.17805138E-05_JPRB, &
  & 0.17898903E-05_JPRB, 0.17974697E-05_JPRB, 0.18058091E-05_JPRB, 0.18131809E-05_JPRB, 0.18192797E-05_JPRB, 0.18245489E-05_JPRB, &
  & 0.18297769E-05_JPRB, 0.18324872E-05_JPRB, 0.18340154E-05_JPRB, 0.18355896E-05_JPRB, 0.18384961E-05_JPRB, 0.18397267E-05_JPRB, &
  & 0.18383425E-05_JPRB, 0.18391282E-05_JPRB, 0.18424861E-05_JPRB, 0.18479697E-05_JPRB, 0.18508287E-05_JPRB, 0.18519217E-05_JPRB, &
  & 0.18529788E-05_JPRB, 0.18577437E-05_JPRB, 0.18620655E-05_JPRB, 0.18655338E-05_JPRB  /)

RGHG2(:,81, 2) = (/ &
  & 0.16794908E-05_JPRB, 0.16796898E-05_JPRB, 0.16799556E-05_JPRB, 0.16800505E-05_JPRB, 0.16801436E-05_JPRB, 0.16802819E-05_JPRB, &
  & 0.16803222E-05_JPRB, 0.16802728E-05_JPRB, 0.16801380E-05_JPRB, 0.16797756E-05_JPRB, 0.16793918E-05_JPRB, 0.16789672E-05_JPRB, &
  & 0.16784050E-05_JPRB, 0.16778180E-05_JPRB, 0.16771818E-05_JPRB, 0.16768708E-05_JPRB, 0.16765824E-05_JPRB, 0.16764774E-05_JPRB, &
  & 0.16763097E-05_JPRB, 0.16764900E-05_JPRB, 0.16766460E-05_JPRB, 0.16769936E-05_JPRB, 0.16771790E-05_JPRB, 0.16781431E-05_JPRB, &
  & 0.16801540E-05_JPRB, 0.16815961E-05_JPRB, 0.16853826E-05_JPRB, 0.16926100E-05_JPRB, 0.17010528E-05_JPRB, 0.17173222E-05_JPRB, &
  & 0.17258006E-05_JPRB, 0.17302109E-05_JPRB, 0.17367900E-05_JPRB, 0.17350314E-05_JPRB, 0.17373574E-05_JPRB, 0.17387282E-05_JPRB, &
  & 0.17410810E-05_JPRB, 0.17447905E-05_JPRB, 0.17516526E-05_JPRB, 0.17607888E-05_JPRB, 0.17717674E-05_JPRB, 0.17834401E-05_JPRB, &
  & 0.17925568E-05_JPRB, 0.17995580E-05_JPRB, 0.18079152E-05_JPRB, 0.18155392E-05_JPRB, 0.18220761E-05_JPRB, 0.18269531E-05_JPRB, &
  & 0.18324816E-05_JPRB, 0.18351308E-05_JPRB, 0.18368908E-05_JPRB, 0.18386993E-05_JPRB, 0.18419394E-05_JPRB, 0.18435037E-05_JPRB, &
  & 0.18419616E-05_JPRB, 0.18422965E-05_JPRB, 0.18456824E-05_JPRB, 0.18515659E-05_JPRB, 0.18543179E-05_JPRB, 0.18556911E-05_JPRB, &
  & 0.18567278E-05_JPRB, 0.18616990E-05_JPRB, 0.18669226E-05_JPRB, 0.18710913E-05_JPRB  /)

RGHG2(:,82, 2) = (/ &
  & 0.16795656E-05_JPRB, 0.16797543E-05_JPRB, 0.16800072E-05_JPRB, 0.16801147E-05_JPRB, 0.16802120E-05_JPRB, 0.16803538E-05_JPRB, &
  & 0.16803898E-05_JPRB, 0.16803386E-05_JPRB, 0.16802157E-05_JPRB, 0.16798380E-05_JPRB, 0.16794767E-05_JPRB, 0.16790588E-05_JPRB, &
  & 0.16784975E-05_JPRB, 0.16778994E-05_JPRB, 0.16773228E-05_JPRB, 0.16770309E-05_JPRB, 0.16766869E-05_JPRB, 0.16765592E-05_JPRB, &
  & 0.16764209E-05_JPRB, 0.16765800E-05_JPRB, 0.16766922E-05_JPRB, 0.16770313E-05_JPRB, 0.16771295E-05_JPRB, 0.16780676E-05_JPRB, &
  & 0.16800871E-05_JPRB, 0.16813774E-05_JPRB, 0.16851642E-05_JPRB, 0.16926007E-05_JPRB, 0.17009831E-05_JPRB, 0.17178021E-05_JPRB, &
  & 0.17259636E-05_JPRB, 0.17300105E-05_JPRB, 0.17369481E-05_JPRB, 0.17353124E-05_JPRB, 0.17381348E-05_JPRB, 0.17395821E-05_JPRB, &
  & 0.17423076E-05_JPRB, 0.17464016E-05_JPRB, 0.17535357E-05_JPRB, 0.17627238E-05_JPRB, 0.17738941E-05_JPRB, 0.17857571E-05_JPRB, &
  & 0.17945753E-05_JPRB, 0.18012600E-05_JPRB, 0.18096051E-05_JPRB, 0.18176306E-05_JPRB, 0.18246659E-05_JPRB, 0.18291514E-05_JPRB, &
  & 0.18350417E-05_JPRB, 0.18375495E-05_JPRB, 0.18396994E-05_JPRB, 0.18417899E-05_JPRB, 0.18455020E-05_JPRB, 0.18472364E-05_JPRB, &
  & 0.18457444E-05_JPRB, 0.18454839E-05_JPRB, 0.18487819E-05_JPRB, 0.18548766E-05_JPRB, 0.18576505E-05_JPRB, 0.18593284E-05_JPRB, &
  & 0.18600624E-05_JPRB, 0.18651034E-05_JPRB, 0.18709474E-05_JPRB, 0.18756559E-05_JPRB  /)

RGHG2(:,83, 2) = (/ &
  & 0.16796390E-05_JPRB, 0.16798113E-05_JPRB, 0.16800521E-05_JPRB, 0.16801702E-05_JPRB, 0.16802699E-05_JPRB, 0.16804177E-05_JPRB, &
  & 0.16804507E-05_JPRB, 0.16803941E-05_JPRB, 0.16802847E-05_JPRB, 0.16798894E-05_JPRB, 0.16795394E-05_JPRB, 0.16791275E-05_JPRB, &
  & 0.16785707E-05_JPRB, 0.16779688E-05_JPRB, 0.16774516E-05_JPRB, 0.16771750E-05_JPRB, 0.16767661E-05_JPRB, 0.16766245E-05_JPRB, &
  & 0.16765181E-05_JPRB, 0.16766715E-05_JPRB, 0.16767636E-05_JPRB, 0.16771416E-05_JPRB, 0.16771397E-05_JPRB, 0.16781010E-05_JPRB, &
  & 0.16801691E-05_JPRB, 0.16813085E-05_JPRB, 0.16851308E-05_JPRB, 0.16927721E-05_JPRB, 0.17010336E-05_JPRB, 0.17182093E-05_JPRB, &
  & 0.17261451E-05_JPRB, 0.17300078E-05_JPRB, 0.17371666E-05_JPRB, 0.17355734E-05_JPRB, 0.17387660E-05_JPRB, 0.17403117E-05_JPRB, &
  & 0.17432321E-05_JPRB, 0.17476292E-05_JPRB, 0.17549441E-05_JPRB, 0.17641468E-05_JPRB, 0.17755194E-05_JPRB, 0.17875656E-05_JPRB, &
  & 0.17960798E-05_JPRB, 0.18026123E-05_JPRB, 0.18109673E-05_JPRB, 0.18194415E-05_JPRB, 0.18270388E-05_JPRB, 0.18311897E-05_JPRB, &
  & 0.18374004E-05_JPRB, 0.18398520E-05_JPRB, 0.18424869E-05_JPRB, 0.18448951E-05_JPRB, 0.18489374E-05_JPRB, 0.18507998E-05_JPRB, &
  & 0.18494212E-05_JPRB, 0.18485319E-05_JPRB, 0.18517122E-05_JPRB, 0.18578543E-05_JPRB, 0.18607653E-05_JPRB, 0.18625878E-05_JPRB, &
  & 0.18630483E-05_JPRB, 0.18679039E-05_JPRB, 0.18740080E-05_JPRB, 0.18792514E-05_JPRB  /)

RGHG2(:,84, 2) = (/ &
  & 0.16797057E-05_JPRB, 0.16798560E-05_JPRB, 0.16800893E-05_JPRB, 0.16802154E-05_JPRB, 0.16803178E-05_JPRB, 0.16804729E-05_JPRB, &
  & 0.16805059E-05_JPRB, 0.16804396E-05_JPRB, 0.16803452E-05_JPRB, 0.16799321E-05_JPRB, 0.16795794E-05_JPRB, 0.16791747E-05_JPRB, &
  & 0.16786257E-05_JPRB, 0.16780341E-05_JPRB, 0.16775656E-05_JPRB, 0.16772888E-05_JPRB, 0.16768299E-05_JPRB, 0.16766882E-05_JPRB, &
  & 0.16766033E-05_JPRB, 0.16767631E-05_JPRB, 0.16768560E-05_JPRB, 0.16773386E-05_JPRB, 0.16772200E-05_JPRB, 0.16782533E-05_JPRB, &
  & 0.16803939E-05_JPRB, 0.16814025E-05_JPRB, 0.16852916E-05_JPRB, 0.16931364E-05_JPRB, 0.17012039E-05_JPRB, 0.17185397E-05_JPRB, &
  & 0.17263837E-05_JPRB, 0.17302296E-05_JPRB, 0.17375294E-05_JPRB, 0.17358195E-05_JPRB, 0.17392576E-05_JPRB, 0.17409280E-05_JPRB, &
  & 0.17438812E-05_JPRB, 0.17484496E-05_JPRB, 0.17558815E-05_JPRB, 0.17650977E-05_JPRB, 0.17767155E-05_JPRB, 0.17889693E-05_JPRB, &
  & 0.17972067E-05_JPRB, 0.18036675E-05_JPRB, 0.18120860E-05_JPRB, 0.18209712E-05_JPRB, 0.18291839E-05_JPRB, 0.18330913E-05_JPRB, &
  & 0.18395030E-05_JPRB, 0.18421092E-05_JPRB, 0.18452738E-05_JPRB, 0.18480088E-05_JPRB, 0.18520391E-05_JPRB, 0.18540771E-05_JPRB, &
  & 0.18527674E-05_JPRB, 0.18513075E-05_JPRB, 0.18544222E-05_JPRB, 0.18604631E-05_JPRB, 0.18635888E-05_JPRB, 0.18652805E-05_JPRB, &
  & 0.18656961E-05_JPRB, 0.18700692E-05_JPRB, 0.18760511E-05_JPRB, 0.18819262E-05_JPRB  /)

RGHG2(:,85, 2) = (/ &
  & 0.16797511E-05_JPRB, 0.16798808E-05_JPRB, 0.16801063E-05_JPRB, 0.16802505E-05_JPRB, 0.16803580E-05_JPRB, 0.16805182E-05_JPRB, &
  & 0.16805538E-05_JPRB, 0.16804798E-05_JPRB, 0.16804034E-05_JPRB, 0.16799646E-05_JPRB, 0.16796042E-05_JPRB, 0.16792047E-05_JPRB, &
  & 0.16786685E-05_JPRB, 0.16780949E-05_JPRB, 0.16776649E-05_JPRB, 0.16773829E-05_JPRB, 0.16769035E-05_JPRB, 0.16767592E-05_JPRB, &
  & 0.16766872E-05_JPRB, 0.16768751E-05_JPRB, 0.16769809E-05_JPRB, 0.16776613E-05_JPRB, 0.16773758E-05_JPRB, 0.16785657E-05_JPRB, &
  & 0.16807166E-05_JPRB, 0.16816327E-05_JPRB, 0.16855911E-05_JPRB, 0.16936952E-05_JPRB, 0.17015086E-05_JPRB, 0.17193091E-05_JPRB, &
  & 0.17270145E-05_JPRB, 0.17308116E-05_JPRB, 0.17384529E-05_JPRB, 0.17362269E-05_JPRB, 0.17397343E-05_JPRB, 0.17415895E-05_JPRB, &
  & 0.17444324E-05_JPRB, 0.17490315E-05_JPRB, 0.17564815E-05_JPRB, 0.17657670E-05_JPRB, 0.17776441E-05_JPRB, 0.17901110E-05_JPRB, &
  & 0.17981815E-05_JPRB, 0.18046064E-05_JPRB, 0.18130788E-05_JPRB, 0.18222798E-05_JPRB, 0.18311242E-05_JPRB, 0.18348005E-05_JPRB, &
  & 0.18412352E-05_JPRB, 0.18443704E-05_JPRB, 0.18482077E-05_JPRB, 0.18510916E-05_JPRB, 0.18546880E-05_JPRB, 0.18569468E-05_JPRB, &
  & 0.18557039E-05_JPRB, 0.18537792E-05_JPRB, 0.18571174E-05_JPRB, 0.18627063E-05_JPRB, 0.18658525E-05_JPRB, 0.18672592E-05_JPRB, &
  & 0.18674668E-05_JPRB, 0.18714138E-05_JPRB, 0.18770593E-05_JPRB, 0.18835660E-05_JPRB  /)

RGHG2(:,86, 2) = (/ &
  & 0.16797755E-05_JPRB, 0.16798946E-05_JPRB, 0.16801184E-05_JPRB, 0.16802746E-05_JPRB, 0.16803933E-05_JPRB, 0.16805627E-05_JPRB, &
  & 0.16805989E-05_JPRB, 0.16805151E-05_JPRB, 0.16804608E-05_JPRB, 0.16799922E-05_JPRB, 0.16796220E-05_JPRB, 0.16792236E-05_JPRB, &
  & 0.16787003E-05_JPRB, 0.16781549E-05_JPRB, 0.16777515E-05_JPRB, 0.16774784E-05_JPRB, 0.16769824E-05_JPRB, 0.16768315E-05_JPRB, &
  & 0.16767925E-05_JPRB, 0.16770309E-05_JPRB, 0.16771235E-05_JPRB, 0.16780749E-05_JPRB, 0.16776196E-05_JPRB, 0.16789750E-05_JPRB, &
  & 0.16811664E-05_JPRB, 0.16820820E-05_JPRB, 0.16859936E-05_JPRB, 0.16944849E-05_JPRB, 0.17018620E-05_JPRB, 0.17202742E-05_JPRB, &
  & 0.17280934E-05_JPRB, 0.17318796E-05_JPRB, 0.17405815E-05_JPRB, 0.17367859E-05_JPRB, 0.17402384E-05_JPRB, 0.17422594E-05_JPRB, &
  & 0.17449129E-05_JPRB, 0.17496214E-05_JPRB, 0.17570753E-05_JPRB, 0.17664004E-05_JPRB, 0.17786065E-05_JPRB, 0.17912494E-05_JPRB, &
  & 0.17991702E-05_JPRB, 0.18055610E-05_JPRB, 0.18141037E-05_JPRB, 0.18237346E-05_JPRB, 0.18329767E-05_JPRB, 0.18362962E-05_JPRB, &
  & 0.18426858E-05_JPRB, 0.18463988E-05_JPRB, 0.18508259E-05_JPRB, 0.18536043E-05_JPRB, 0.18568569E-05_JPRB, 0.18593276E-05_JPRB, &
  & 0.18582724E-05_JPRB, 0.18560815E-05_JPRB, 0.18598371E-05_JPRB, 0.18647207E-05_JPRB, 0.18675018E-05_JPRB, 0.18685999E-05_JPRB, &
  & 0.18686467E-05_JPRB, 0.18722115E-05_JPRB, 0.18774728E-05_JPRB, 0.18841924E-05_JPRB  /)

RGHG2(:,87, 2) = (/ &
  & 0.16797874E-05_JPRB, 0.16799013E-05_JPRB, 0.16801265E-05_JPRB, 0.16802918E-05_JPRB, 0.16804223E-05_JPRB, 0.16806048E-05_JPRB, &
  & 0.16806464E-05_JPRB, 0.16805454E-05_JPRB, 0.16805160E-05_JPRB, 0.16800147E-05_JPRB, 0.16796353E-05_JPRB, 0.16792369E-05_JPRB, &
  & 0.16787254E-05_JPRB, 0.16782100E-05_JPRB, 0.16778276E-05_JPRB, 0.16775716E-05_JPRB, 0.16770746E-05_JPRB, 0.16769105E-05_JPRB, &
  & 0.16769201E-05_JPRB, 0.16772537E-05_JPRB, 0.16772972E-05_JPRB, 0.16785287E-05_JPRB, 0.16779299E-05_JPRB, 0.16794302E-05_JPRB, &
  & 0.16817637E-05_JPRB, 0.16828808E-05_JPRB, 0.16865653E-05_JPRB, 0.16955667E-05_JPRB, 0.17022879E-05_JPRB, 0.17216990E-05_JPRB, &
  & 0.17299036E-05_JPRB, 0.17337634E-05_JPRB, 0.17446726E-05_JPRB, 0.17375641E-05_JPRB, 0.17408646E-05_JPRB, 0.17429906E-05_JPRB, &
  & 0.17454492E-05_JPRB, 0.17502553E-05_JPRB, 0.17578082E-05_JPRB, 0.17671420E-05_JPRB, 0.17797862E-05_JPRB, 0.17926450E-05_JPRB, &
  & 0.18003602E-05_JPRB, 0.18066393E-05_JPRB, 0.18153262E-05_JPRB, 0.18254932E-05_JPRB, 0.18349758E-05_JPRB, 0.18377698E-05_JPRB, &
  & 0.18440645E-05_JPRB, 0.18482452E-05_JPRB, 0.18532329E-05_JPRB, 0.18557743E-05_JPRB, 0.18587019E-05_JPRB, 0.18613474E-05_JPRB, &
  & 0.18608854E-05_JPRB, 0.18583017E-05_JPRB, 0.18626559E-05_JPRB, 0.18664817E-05_JPRB, 0.18687926E-05_JPRB, 0.18696339E-05_JPRB, &
  & 0.18695420E-05_JPRB, 0.18725915E-05_JPRB, 0.18776097E-05_JPRB, 0.18842645E-05_JPRB  /)

RGHG2(:,88, 2) = (/ &
  & 0.16797939E-05_JPRB, 0.16799034E-05_JPRB, 0.16801306E-05_JPRB, 0.16803034E-05_JPRB, 0.16804464E-05_JPRB, 0.16806454E-05_JPRB, &
  & 0.16807003E-05_JPRB, 0.16805723E-05_JPRB, 0.16805735E-05_JPRB, 0.16800317E-05_JPRB, 0.16796441E-05_JPRB, 0.16792466E-05_JPRB, &
  & 0.16787460E-05_JPRB, 0.16782600E-05_JPRB, 0.16778921E-05_JPRB, 0.16776755E-05_JPRB, 0.16771842E-05_JPRB, 0.16770080E-05_JPRB, &
  & 0.16770820E-05_JPRB, 0.16775473E-05_JPRB, 0.16775120E-05_JPRB, 0.16790026E-05_JPRB, 0.16783162E-05_JPRB, 0.16798961E-05_JPRB, &
  & 0.16825866E-05_JPRB, 0.16840860E-05_JPRB, 0.16873135E-05_JPRB, 0.16970381E-05_JPRB, 0.17028470E-05_JPRB, 0.17243713E-05_JPRB, &
  & 0.17327533E-05_JPRB, 0.17368969E-05_JPRB, 0.17515236E-05_JPRB, 0.17387921E-05_JPRB, 0.17417592E-05_JPRB, 0.17439207E-05_JPRB, &
  & 0.17462176E-05_JPRB, 0.17511045E-05_JPRB, 0.17588693E-05_JPRB, 0.17682763E-05_JPRB, 0.17815407E-05_JPRB, 0.17947088E-05_JPRB, &
  & 0.18020396E-05_JPRB, 0.18080748E-05_JPRB, 0.18171117E-05_JPRB, 0.18279928E-05_JPRB, 0.18376602E-05_JPRB, 0.18394916E-05_JPRB, &
  & 0.18457055E-05_JPRB, 0.18500605E-05_JPRB, 0.18556132E-05_JPRB, 0.18579305E-05_JPRB, 0.18603711E-05_JPRB, 0.18630127E-05_JPRB, &
  & 0.18641599E-05_JPRB, 0.18606172E-05_JPRB, 0.18656755E-05_JPRB, 0.18680070E-05_JPRB, 0.18698968E-05_JPRB, 0.18705362E-05_JPRB, &
  & 0.18702710E-05_JPRB, 0.18726824E-05_JPRB, 0.18776397E-05_JPRB, 0.18841307E-05_JPRB  /)

RGHG2(:,89, 2) = (/ &
  & 0.16798014E-05_JPRB, 0.16799038E-05_JPRB, 0.16801310E-05_JPRB, 0.16803095E-05_JPRB, 0.16804698E-05_JPRB, 0.16806861E-05_JPRB, &
  & 0.16807611E-05_JPRB, 0.16805978E-05_JPRB, 0.16806389E-05_JPRB, 0.16800444E-05_JPRB, 0.16796478E-05_JPRB, 0.16792527E-05_JPRB, &
  & 0.16787629E-05_JPRB, 0.16783064E-05_JPRB, 0.16779395E-05_JPRB, 0.16778091E-05_JPRB, 0.16773009E-05_JPRB, 0.16771368E-05_JPRB, &
  & 0.16772888E-05_JPRB, 0.16778651E-05_JPRB, 0.16777623E-05_JPRB, 0.16794791E-05_JPRB, 0.16788049E-05_JPRB, 0.16803201E-05_JPRB, &
  & 0.16838039E-05_JPRB, 0.16855393E-05_JPRB, 0.16881494E-05_JPRB, 0.16989371E-05_JPRB, 0.17036511E-05_JPRB, 0.17297637E-05_JPRB, &
  & 0.17367991E-05_JPRB, 0.17417073E-05_JPRB, 0.17616056E-05_JPRB, 0.17408831E-05_JPRB, 0.17431302E-05_JPRB, 0.17452871E-05_JPRB, &
  & 0.17475025E-05_JPRB, 0.17524899E-05_JPRB, 0.17605495E-05_JPRB, 0.17703844E-05_JPRB, 0.17845409E-05_JPRB, 0.17980868E-05_JPRB, &
  & 0.18046907E-05_JPRB, 0.18103184E-05_JPRB, 0.18201638E-05_JPRB, 0.18319941E-05_JPRB, 0.18419993E-05_JPRB, 0.18419480E-05_JPRB, &
  & 0.18481749E-05_JPRB, 0.18521202E-05_JPRB, 0.18582281E-05_JPRB, 0.18605071E-05_JPRB, 0.18620212E-05_JPRB, 0.18641940E-05_JPRB, &
  & 0.18686306E-05_JPRB, 0.18631268E-05_JPRB, 0.18687842E-05_JPRB, 0.18693213E-05_JPRB, 0.18708947E-05_JPRB, 0.18713552E-05_JPRB, &
  & 0.18708135E-05_JPRB, 0.18726976E-05_JPRB, 0.18776687E-05_JPRB, 0.18841561E-05_JPRB  /)

RGHG2(:,90, 2) = (/ &
  & 0.16797991E-05_JPRB, 0.16799043E-05_JPRB, 0.16801316E-05_JPRB, 0.16803159E-05_JPRB, 0.16804942E-05_JPRB, 0.16807288E-05_JPRB, &
  & 0.16808249E-05_JPRB, 0.16806192E-05_JPRB, 0.16806994E-05_JPRB, 0.16800627E-05_JPRB, 0.16796543E-05_JPRB, 0.16792592E-05_JPRB, &
  & 0.16787754E-05_JPRB, 0.16783553E-05_JPRB, 0.16779762E-05_JPRB, 0.16779368E-05_JPRB, 0.16773911E-05_JPRB, 0.16772836E-05_JPRB, &
  & 0.16775243E-05_JPRB, 0.16781281E-05_JPRB, 0.16780502E-05_JPRB, 0.16800209E-05_JPRB, 0.16794827E-05_JPRB, 0.16807389E-05_JPRB, &
  & 0.16859351E-05_JPRB, 0.16868528E-05_JPRB, 0.16891470E-05_JPRB, 0.17012437E-05_JPRB, 0.17049867E-05_JPRB, 0.17393452E-05_JPRB, &
  & 0.17418774E-05_JPRB, 0.17485099E-05_JPRB, 0.17748615E-05_JPRB, 0.17442827E-05_JPRB, 0.17452555E-05_JPRB, 0.17474122E-05_JPRB, &
  & 0.17497805E-05_JPRB, 0.17546728E-05_JPRB, 0.17634534E-05_JPRB, 0.17746531E-05_JPRB, 0.17901056E-05_JPRB, 0.18037644E-05_JPRB, &
  & 0.18093850E-05_JPRB, 0.18143338E-05_JPRB, 0.18258065E-05_JPRB, 0.18384188E-05_JPRB, 0.18493789E-05_JPRB, 0.18463315E-05_JPRB, &
  & 0.18523319E-05_JPRB, 0.18549911E-05_JPRB, 0.18615684E-05_JPRB, 0.18636944E-05_JPRB, 0.18639615E-05_JPRB, 0.18650449E-05_JPRB, &
  & 0.18729322E-05_JPRB, 0.18653162E-05_JPRB, 0.18714602E-05_JPRB, 0.18705865E-05_JPRB, 0.18716088E-05_JPRB, 0.18720358E-05_JPRB, &
  & 0.18712474E-05_JPRB, 0.18727975E-05_JPRB, 0.18777375E-05_JPRB, 0.18842367E-05_JPRB  /)

RGHG2(:,91, 2) = (/ &
  & 0.16798026E-05_JPRB, 0.16799014E-05_JPRB, 0.16801319E-05_JPRB, 0.16803162E-05_JPRB, 0.16805105E-05_JPRB, 0.16807706E-05_JPRB, &
  & 0.16808858E-05_JPRB, 0.16806323E-05_JPRB, 0.16807475E-05_JPRB, 0.16800726E-05_JPRB, 0.16796578E-05_JPRB, 0.16792627E-05_JPRB, &
  & 0.16787853E-05_JPRB, 0.16784067E-05_JPRB, 0.16780116E-05_JPRB, 0.16780807E-05_JPRB, 0.16774585E-05_JPRB, 0.16773860E-05_JPRB, &
  & 0.16778437E-05_JPRB, 0.16784890E-05_JPRB, 0.16785515E-05_JPRB, 0.16808891E-05_JPRB, 0.16804084E-05_JPRB, 0.16814093E-05_JPRB, &
  & 0.16894295E-05_JPRB, 0.16895941E-05_JPRB, 0.16910428E-05_JPRB, 0.17050189E-05_JPRB, 0.17075079E-05_JPRB, 0.17511713E-05_JPRB, &
  & 0.17480140E-05_JPRB, 0.17581182E-05_JPRB, 0.17895308E-05_JPRB, 0.17481983E-05_JPRB, 0.17482872E-05_JPRB, 0.17503483E-05_JPRB, &
  & 0.17535781E-05_JPRB, 0.17572227E-05_JPRB, 0.17684859E-05_JPRB, 0.17820373E-05_JPRB, 0.18004351E-05_JPRB, 0.18133313E-05_JPRB, &
  & 0.18196922E-05_JPRB, 0.18216478E-05_JPRB, 0.18362956E-05_JPRB, 0.18474337E-05_JPRB, 0.18626346E-05_JPRB, 0.18547592E-05_JPRB, &
  & 0.18590525E-05_JPRB, 0.18598130E-05_JPRB, 0.18664669E-05_JPRB, 0.18676324E-05_JPRB, 0.18676027E-05_JPRB, 0.18659961E-05_JPRB, &
  & 0.18768510E-05_JPRB, 0.18672439E-05_JPRB, 0.18754748E-05_JPRB, 0.18721791E-05_JPRB, 0.18721133E-05_JPRB, 0.18724030E-05_JPRB, &
  & 0.18715668E-05_JPRB, 0.18728903E-05_JPRB, 0.18777729E-05_JPRB, 0.18842753E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ---GEMS----

RGHG2(:, 1, 3) = (/ &
  & 0.11363247E-06_JPRB, 0.11437325E-06_JPRB, 0.11568033E-06_JPRB, 0.11725408E-06_JPRB, 0.11926901E-06_JPRB, 0.12200497E-06_JPRB, &
  & 0.12577473E-06_JPRB, 0.13072317E-06_JPRB, 0.13666260E-06_JPRB, 0.14365231E-06_JPRB, 0.15113257E-06_JPRB, 0.15857662E-06_JPRB, &
  & 0.16621163E-06_JPRB, 0.17492324E-06_JPRB, 0.18452380E-06_JPRB, 0.19507914E-06_JPRB, 0.20605261E-06_JPRB, 0.21758578E-06_JPRB, &
  & 0.22829587E-06_JPRB, 0.23816639E-06_JPRB, 0.24714469E-06_JPRB, 0.25477640E-06_JPRB, 0.26169697E-06_JPRB, 0.26829159E-06_JPRB, &
  & 0.27478085E-06_JPRB, 0.28142485E-06_JPRB, 0.28783181E-06_JPRB, 0.29361650E-06_JPRB, 0.29838385E-06_JPRB, 0.30135357E-06_JPRB, &
  & 0.30275283E-06_JPRB, 0.30305573E-06_JPRB, 0.30282855E-06_JPRB, 0.30192974E-06_JPRB, 0.30014527E-06_JPRB, 0.29803816E-06_JPRB, &
  & 0.29575325E-06_JPRB, 0.29294815E-06_JPRB, 0.28952408E-06_JPRB, 0.28560946E-06_JPRB, 0.28144131E-06_JPRB, 0.27698344E-06_JPRB, &
  & 0.27230499E-06_JPRB, 0.26783065E-06_JPRB, 0.26335303E-06_JPRB, 0.25875030E-06_JPRB, 0.25421341E-06_JPRB, 0.24994979E-06_JPRB, &
  & 0.24616027E-06_JPRB, 0.24290082E-06_JPRB, 0.24028010E-06_JPRB, 0.23815981E-06_JPRB, 0.23635559E-06_JPRB, 0.23484110E-06_JPRB, &
  & 0.23372828E-06_JPRB, 0.23291506E-06_JPRB, 0.23243438E-06_JPRB, 0.23201625E-06_JPRB, 0.23173310E-06_JPRB, 0.23142691E-06_JPRB, &
  & 0.23103512E-06_JPRB, 0.23058077E-06_JPRB, 0.23014947E-06_JPRB, 0.22993876E-06_JPRB  /)

RGHG2(:, 2, 3) = (/ &
  & 0.11363247E-06_JPRB, 0.11437325E-06_JPRB, 0.11568033E-06_JPRB, 0.11725408E-06_JPRB, 0.11926901E-06_JPRB, 0.12200497E-06_JPRB, &
  & 0.12577473E-06_JPRB, 0.13072317E-06_JPRB, 0.13666260E-06_JPRB, 0.14365231E-06_JPRB, 0.15113257E-06_JPRB, 0.15857662E-06_JPRB, &
  & 0.16621163E-06_JPRB, 0.17492324E-06_JPRB, 0.18452380E-06_JPRB, 0.19507914E-06_JPRB, 0.20605261E-06_JPRB, 0.21758578E-06_JPRB, &
  & 0.22829587E-06_JPRB, 0.23816639E-06_JPRB, 0.24714469E-06_JPRB, 0.25477640E-06_JPRB, 0.26169697E-06_JPRB, 0.26829159E-06_JPRB, &
  & 0.27478085E-06_JPRB, 0.28142485E-06_JPRB, 0.28783181E-06_JPRB, 0.29361650E-06_JPRB, 0.29838385E-06_JPRB, 0.30135357E-06_JPRB, &
  & 0.30275283E-06_JPRB, 0.30305573E-06_JPRB, 0.30282855E-06_JPRB, 0.30192974E-06_JPRB, 0.30014527E-06_JPRB, 0.29803816E-06_JPRB, &
  & 0.29575325E-06_JPRB, 0.29294815E-06_JPRB, 0.28952408E-06_JPRB, 0.28560946E-06_JPRB, 0.28144131E-06_JPRB, 0.27698344E-06_JPRB, &
  & 0.27230499E-06_JPRB, 0.26783065E-06_JPRB, 0.26335303E-06_JPRB, 0.25875030E-06_JPRB, 0.25421341E-06_JPRB, 0.24994979E-06_JPRB, &
  & 0.24616027E-06_JPRB, 0.24290082E-06_JPRB, 0.24028010E-06_JPRB, 0.23815981E-06_JPRB, 0.23635559E-06_JPRB, 0.23484110E-06_JPRB, &
  & 0.23372828E-06_JPRB, 0.23291506E-06_JPRB, 0.23243438E-06_JPRB, 0.23201625E-06_JPRB, 0.23173310E-06_JPRB, 0.23142691E-06_JPRB, &
  & 0.23103512E-06_JPRB, 0.23058077E-06_JPRB, 0.23014947E-06_JPRB, 0.22993876E-06_JPRB  /)

RGHG2(:, 3, 3) = (/ &
  & 0.11363247E-06_JPRB, 0.11437325E-06_JPRB, 0.11568033E-06_JPRB, 0.11725408E-06_JPRB, 0.11926901E-06_JPRB, 0.12200497E-06_JPRB, &
  & 0.12577473E-06_JPRB, 0.13072317E-06_JPRB, 0.13666260E-06_JPRB, 0.14365231E-06_JPRB, 0.15113257E-06_JPRB, 0.15857662E-06_JPRB, &
  & 0.16621163E-06_JPRB, 0.17492324E-06_JPRB, 0.18452380E-06_JPRB, 0.19507914E-06_JPRB, 0.20605261E-06_JPRB, 0.21758578E-06_JPRB, &
  & 0.22829587E-06_JPRB, 0.23816639E-06_JPRB, 0.24714469E-06_JPRB, 0.25477640E-06_JPRB, 0.26169697E-06_JPRB, 0.26829159E-06_JPRB, &
  & 0.27478085E-06_JPRB, 0.28142485E-06_JPRB, 0.28783181E-06_JPRB, 0.29361650E-06_JPRB, 0.29838385E-06_JPRB, 0.30135357E-06_JPRB, &
  & 0.30275283E-06_JPRB, 0.30305573E-06_JPRB, 0.30282855E-06_JPRB, 0.30192974E-06_JPRB, 0.30014527E-06_JPRB, 0.29803816E-06_JPRB, &
  & 0.29575325E-06_JPRB, 0.29294815E-06_JPRB, 0.28952408E-06_JPRB, 0.28560946E-06_JPRB, 0.28144131E-06_JPRB, 0.27698344E-06_JPRB, &
  & 0.27230499E-06_JPRB, 0.26783065E-06_JPRB, 0.26335303E-06_JPRB, 0.25875030E-06_JPRB, 0.25421341E-06_JPRB, 0.24994979E-06_JPRB, &
  & 0.24616027E-06_JPRB, 0.24290082E-06_JPRB, 0.24028010E-06_JPRB, 0.23815981E-06_JPRB, 0.23635559E-06_JPRB, 0.23484110E-06_JPRB, &
  & 0.23372828E-06_JPRB, 0.23291506E-06_JPRB, 0.23243438E-06_JPRB, 0.23201625E-06_JPRB, 0.23173310E-06_JPRB, 0.23142691E-06_JPRB, &
  & 0.23103512E-06_JPRB, 0.23058077E-06_JPRB, 0.23014947E-06_JPRB, 0.22993876E-06_JPRB  /)

RGHG2(:, 4, 3) = (/ &
  & 0.11365868E-06_JPRB, 0.11439792E-06_JPRB, 0.11570281E-06_JPRB, 0.11727560E-06_JPRB, 0.11928985E-06_JPRB, 0.12202556E-06_JPRB, &
  & 0.12579408E-06_JPRB, 0.13074180E-06_JPRB, 0.13668149E-06_JPRB, 0.14367279E-06_JPRB, 0.15115871E-06_JPRB, 0.15861334E-06_JPRB, &
  & 0.16625853E-06_JPRB, 0.17497877E-06_JPRB, 0.18459198E-06_JPRB, 0.19516566E-06_JPRB, 0.20615908E-06_JPRB, 0.21771178E-06_JPRB, &
  & 0.22844847E-06_JPRB, 0.23834168E-06_JPRB, 0.24733104E-06_JPRB, 0.25496499E-06_JPRB, 0.26188337E-06_JPRB, 0.26847824E-06_JPRB, &
  & 0.27497267E-06_JPRB, 0.28162088E-06_JPRB, 0.28802634E-06_JPRB, 0.29380197E-06_JPRB, 0.29855740E-06_JPRB, 0.30151845E-06_JPRB, &
  & 0.30291080E-06_JPRB, 0.30320329E-06_JPRB, 0.30295624E-06_JPRB, 0.30203416E-06_JPRB, 0.30023052E-06_JPRB, 0.29810546E-06_JPRB, &
  & 0.29580536E-06_JPRB, 0.29298902E-06_JPRB, 0.28955584E-06_JPRB, 0.28563288E-06_JPRB, 0.28145410E-06_JPRB, 0.27698441E-06_JPRB, &
  & 0.27229572E-06_JPRB, 0.26781111E-06_JPRB, 0.26332655E-06_JPRB, 0.25871984E-06_JPRB, 0.25418095E-06_JPRB, 0.24991958E-06_JPRB, &
  & 0.24613470E-06_JPRB, 0.24287938E-06_JPRB, 0.24026326E-06_JPRB, 0.23814839E-06_JPRB, 0.23634870E-06_JPRB, 0.23483925E-06_JPRB, &
  & 0.23373028E-06_JPRB, 0.23291889E-06_JPRB, 0.23243820E-06_JPRB, 0.23202053E-06_JPRB, 0.23173738E-06_JPRB, 0.23143129E-06_JPRB, &
  & 0.23103887E-06_JPRB, 0.23058536E-06_JPRB, 0.23015702E-06_JPRB, 0.22994539E-06_JPRB  /)

RGHG2(:, 5, 3) = (/ &
  & 0.11490263E-06_JPRB, 0.11556856E-06_JPRB, 0.11677010E-06_JPRB, 0.11829722E-06_JPRB, 0.12027902E-06_JPRB, 0.12300271E-06_JPRB, &
  & 0.12671234E-06_JPRB, 0.13162642E-06_JPRB, 0.13757812E-06_JPRB, 0.14464514E-06_JPRB, 0.15239905E-06_JPRB, 0.16035605E-06_JPRB, &
  & 0.16848436E-06_JPRB, 0.17761443E-06_JPRB, 0.18782855E-06_JPRB, 0.19927234E-06_JPRB, 0.21121279E-06_JPRB, 0.22369209E-06_JPRB, &
  & 0.23569189E-06_JPRB, 0.24666193E-06_JPRB, 0.25617648E-06_JPRB, 0.26391619E-06_JPRB, 0.27073122E-06_JPRB, 0.27733811E-06_JPRB, &
  & 0.28407770E-06_JPRB, 0.29092541E-06_JPRB, 0.29725997E-06_JPRB, 0.30260535E-06_JPRB, 0.30679472E-06_JPRB, 0.30934476E-06_JPRB, &
  & 0.31040901E-06_JPRB, 0.31020755E-06_JPRB, 0.30901708E-06_JPRB, 0.30699052E-06_JPRB, 0.30427711E-06_JPRB, 0.30129996E-06_JPRB, &
  & 0.29827877E-06_JPRB, 0.29492882E-06_JPRB, 0.29106299E-06_JPRB, 0.28674463E-06_JPRB, 0.28206109E-06_JPRB, 0.27703015E-06_JPRB, &
  & 0.27185593E-06_JPRB, 0.26688338E-06_JPRB, 0.26206952E-06_JPRB, 0.25727413E-06_JPRB, 0.25264030E-06_JPRB, 0.24848589E-06_JPRB, &
  & 0.24492094E-06_JPRB, 0.24186152E-06_JPRB, 0.23946413E-06_JPRB, 0.23760645E-06_JPRB, 0.23602189E-06_JPRB, 0.23475160E-06_JPRB, &
  & 0.23382530E-06_JPRB, 0.23310044E-06_JPRB, 0.23261975E-06_JPRB, 0.23222371E-06_JPRB, 0.23194056E-06_JPRB, 0.23163928E-06_JPRB, &
  & 0.23121681E-06_JPRB, 0.23080296E-06_JPRB, 0.23051523E-06_JPRB, 0.23026035E-06_JPRB  /)

RGHG2(:, 6, 3) = (/ &
  & 0.11676900E-06_JPRB, 0.11732494E-06_JPRB, 0.11837140E-06_JPRB, 0.11983001E-06_JPRB, 0.12176312E-06_JPRB, 0.12446878E-06_JPRB, &
  & 0.12809006E-06_JPRB, 0.13295364E-06_JPRB, 0.13892338E-06_JPRB, 0.14610399E-06_JPRB, 0.15426001E-06_JPRB, 0.16297072E-06_JPRB, &
  & 0.17182390E-06_JPRB, 0.18156884E-06_JPRB, 0.19268453E-06_JPRB, 0.20543379E-06_JPRB, 0.21879512E-06_JPRB, 0.23266464E-06_JPRB, &
  & 0.24655955E-06_JPRB, 0.25914521E-06_JPRB, 0.26944774E-06_JPRB, 0.27734612E-06_JPRB, 0.28400607E-06_JPRB, 0.29063100E-06_JPRB, &
  & 0.29773844E-06_JPRB, 0.30488547E-06_JPRB, 0.31111363E-06_JPRB, 0.31581349E-06_JPRB, 0.31915358E-06_JPRB, 0.32108694E-06_JPRB, &
  & 0.32165893E-06_JPRB, 0.32071639E-06_JPRB, 0.31811044E-06_JPRB, 0.31442680E-06_JPRB, 0.31034841E-06_JPRB, 0.30609283E-06_JPRB, &
  & 0.30198975E-06_JPRB, 0.29783921E-06_JPRB, 0.29332424E-06_JPRB, 0.28841265E-06_JPRB, 0.28297179E-06_JPRB, 0.27709878E-06_JPRB, &
  & 0.27119609E-06_JPRB, 0.26549147E-06_JPRB, 0.26018355E-06_JPRB, 0.25510506E-06_JPRB, 0.25032878E-06_JPRB, 0.24633485E-06_JPRB, &
  & 0.24309988E-06_JPRB, 0.24033437E-06_JPRB, 0.23826515E-06_JPRB, 0.23679334E-06_JPRB, 0.23553154E-06_JPRB, 0.23462008E-06_JPRB, &
  & 0.23396786E-06_JPRB, 0.23337282E-06_JPRB, 0.23289214E-06_JPRB, 0.23252855E-06_JPRB, 0.23224541E-06_JPRB, 0.23195134E-06_JPRB, &
  & 0.23148379E-06_JPRB, 0.23112944E-06_JPRB, 0.23105268E-06_JPRB, 0.23073288E-06_JPRB  /)

RGHG2(:, 7, 3) = (/ &
  & 0.11735749E-06_JPRB, 0.11789332E-06_JPRB, 0.11880822E-06_JPRB, 0.12014988E-06_JPRB, 0.12202448E-06_JPRB, 0.12477072E-06_JPRB, &
  & 0.12839150E-06_JPRB, 0.13315106E-06_JPRB, 0.13905759E-06_JPRB, 0.14625882E-06_JPRB, 0.15480863E-06_JPRB, 0.16484887E-06_JPRB, &
  & 0.17537301E-06_JPRB, 0.18680584E-06_JPRB, 0.20015925E-06_JPRB, 0.21622536E-06_JPRB, 0.23295528E-06_JPRB, 0.25026918E-06_JPRB, &
  & 0.26787934E-06_JPRB, 0.28385161E-06_JPRB, 0.29584868E-06_JPRB, 0.30397997E-06_JPRB, 0.31044869E-06_JPRB, 0.31711532E-06_JPRB, &
  & 0.32436057E-06_JPRB, 0.33144413E-06_JPRB, 0.33715691E-06_JPRB, 0.34138645E-06_JPRB, 0.34421427E-06_JPRB, 0.34533383E-06_JPRB, &
  & 0.34429130E-06_JPRB, 0.34094303E-06_JPRB, 0.33534165E-06_JPRB, 0.32856573E-06_JPRB, 0.32118448E-06_JPRB, 0.31367564E-06_JPRB, &
  & 0.30711526E-06_JPRB, 0.30131771E-06_JPRB, 0.29549459E-06_JPRB, 0.28869458E-06_JPRB, 0.28092999E-06_JPRB, 0.27303158E-06_JPRB, &
  & 0.26593881E-06_JPRB, 0.25977186E-06_JPRB, 0.25436333E-06_JPRB, 0.24951731E-06_JPRB, 0.24546301E-06_JPRB, 0.24226184E-06_JPRB, &
  & 0.23977431E-06_JPRB, 0.23768311E-06_JPRB, 0.23629524E-06_JPRB, 0.23542676E-06_JPRB, 0.23470357E-06_JPRB, 0.23422486E-06_JPRB, &
  & 0.23380587E-06_JPRB, 0.23332640E-06_JPRB, 0.23294857E-06_JPRB, 0.23271109E-06_JPRB, 0.23247320E-06_JPRB, 0.23224807E-06_JPRB, &
  & 0.23181923E-06_JPRB, 0.23152085E-06_JPRB, 0.23140892E-06_JPRB, 0.23111672E-06_JPRB  /)

RGHG2(:, 8, 3) = (/ &
  & 0.11519684E-06_JPRB, 0.11573616E-06_JPRB, 0.11662723E-06_JPRB, 0.11797307E-06_JPRB, 0.11994766E-06_JPRB, 0.12294290E-06_JPRB, &
  & 0.12688338E-06_JPRB, 0.13191799E-06_JPRB, 0.13815082E-06_JPRB, 0.14591665E-06_JPRB, 0.15543213E-06_JPRB, 0.16759668E-06_JPRB, &
  & 0.18113966E-06_JPRB, 0.19541479E-06_JPRB, 0.21173711E-06_JPRB, 0.23216694E-06_JPRB, 0.25352546E-06_JPRB, 0.27534659E-06_JPRB, &
  & 0.29854024E-06_JPRB, 0.32061904E-06_JPRB, 0.33675890E-06_JPRB, 0.34686610E-06_JPRB, 0.35406631E-06_JPRB, 0.36099731E-06_JPRB, &
  & 0.36837053E-06_JPRB, 0.37508056E-06_JPRB, 0.38000248E-06_JPRB, 0.38354798E-06_JPRB, 0.38574383E-06_JPRB, 0.38559885E-06_JPRB, &
  & 0.38182171E-06_JPRB, 0.37424759E-06_JPRB, 0.36383073E-06_JPRB, 0.35241046E-06_JPRB, 0.34006938E-06_JPRB, 0.32765565E-06_JPRB, &
  & 0.31718938E-06_JPRB, 0.30870926E-06_JPRB, 0.30064657E-06_JPRB, 0.29068569E-06_JPRB, 0.27932287E-06_JPRB, 0.26859567E-06_JPRB, &
  & 0.25985269E-06_JPRB, 0.25314492E-06_JPRB, 0.24780534E-06_JPRB, 0.24350131E-06_JPRB, 0.24053232E-06_JPRB, 0.23839682E-06_JPRB, &
  & 0.23690620E-06_JPRB, 0.23577116E-06_JPRB, 0.23528120E-06_JPRB, 0.23519630E-06_JPRB, 0.23515196E-06_JPRB, 0.23511290E-06_JPRB, &
  & 0.23495871E-06_JPRB, 0.23470384E-06_JPRB, 0.23453946E-06_JPRB, 0.23448191E-06_JPRB, 0.23441693E-06_JPRB, 0.23440803E-06_JPRB, &
  & 0.23427999E-06_JPRB, 0.23427174E-06_JPRB, 0.23435525E-06_JPRB, 0.23431429E-06_JPRB  /)

RGHG2(:, 9, 3) = (/ &
  & 0.10846952E-06_JPRB, 0.10912552E-06_JPRB, 0.11031223E-06_JPRB, 0.11211710E-06_JPRB, 0.11469316E-06_JPRB, 0.11845890E-06_JPRB, &
  & 0.12342574E-06_JPRB, 0.12963810E-06_JPRB, 0.13714550E-06_JPRB, 0.14660267E-06_JPRB, 0.15834533E-06_JPRB, 0.17387961E-06_JPRB, &
  & 0.19195713E-06_JPRB, 0.21000261E-06_JPRB, 0.22920286E-06_JPRB, 0.25404794E-06_JPRB, 0.28103630E-06_JPRB, 0.30817439E-06_JPRB, &
  & 0.33809508E-06_JPRB, 0.36871428E-06_JPRB, 0.39284382E-06_JPRB, 0.40862102E-06_JPRB, 0.41923558E-06_JPRB, 0.42773212E-06_JPRB, &
  & 0.43588929E-06_JPRB, 0.44234041E-06_JPRB, 0.44638818E-06_JPRB, 0.44880655E-06_JPRB, 0.44979043E-06_JPRB, 0.44769578E-06_JPRB, &
  & 0.44017907E-06_JPRB, 0.42674625E-06_JPRB, 0.40939222E-06_JPRB, 0.39122805E-06_JPRB, 0.37262741E-06_JPRB, 0.35426037E-06_JPRB, &
  & 0.33854664E-06_JPRB, 0.32573624E-06_JPRB, 0.31366919E-06_JPRB, 0.29919518E-06_JPRB, 0.28354980E-06_JPRB, 0.26939049E-06_JPRB, &
  & 0.25843255E-06_JPRB, 0.25088025E-06_JPRB, 0.24563586E-06_JPRB, 0.24189270E-06_JPRB, 0.23984275E-06_JPRB, 0.23865437E-06_JPRB, &
  & 0.23812119E-06_JPRB, 0.23804592E-06_JPRB, 0.23859587E-06_JPRB, 0.23940128E-06_JPRB, 0.24012729E-06_JPRB, 0.24070629E-06_JPRB, &
  & 0.24100390E-06_JPRB, 0.24113683E-06_JPRB, 0.24131126E-06_JPRB, 0.24156692E-06_JPRB, 0.24178356E-06_JPRB, 0.24214474E-06_JPRB, &
  & 0.24269629E-06_JPRB, 0.24322231E-06_JPRB, 0.24365293E-06_JPRB, 0.24407796E-06_JPRB  /)

RGHG2(:,10, 3) = (/ &
  & 0.10238870E-06_JPRB, 0.10330922E-06_JPRB, 0.10505747E-06_JPRB, 0.10777210E-06_JPRB, 0.11152472E-06_JPRB, 0.11668718E-06_JPRB, &
  & 0.12338024E-06_JPRB, 0.13163113E-06_JPRB, 0.14146602E-06_JPRB, 0.15393752E-06_JPRB, 0.16970053E-06_JPRB, 0.19007016E-06_JPRB, &
  & 0.21324424E-06_JPRB, 0.23458559E-06_JPRB, 0.25551138E-06_JPRB, 0.28319636E-06_JPRB, 0.31545953E-06_JPRB, 0.34852703E-06_JPRB, &
  & 0.38402337E-06_JPRB, 0.42245712E-06_JPRB, 0.45804479E-06_JPRB, 0.48429184E-06_JPRB, 0.50272382E-06_JPRB, 0.51643269E-06_JPRB, &
  & 0.52797855E-06_JPRB, 0.53575242E-06_JPRB, 0.53952372E-06_JPRB, 0.54050636E-06_JPRB, 0.53900651E-06_JPRB, 0.53379514E-06_JPRB, &
  & 0.52207259E-06_JPRB, 0.50273930E-06_JPRB, 0.47753879E-06_JPRB, 0.45043472E-06_JPRB, 0.42430973E-06_JPRB, 0.39929516E-06_JPRB, &
  & 0.37692784E-06_JPRB, 0.35767822E-06_JPRB, 0.33952663E-06_JPRB, 0.32059239E-06_JPRB, 0.30182539E-06_JPRB, 0.28416847E-06_JPRB, &
  & 0.27021341E-06_JPRB, 0.26124455E-06_JPRB, 0.25568295E-06_JPRB, 0.25182481E-06_JPRB, 0.24979100E-06_JPRB, 0.24907967E-06_JPRB, &
  & 0.24911989E-06_JPRB, 0.24979654E-06_JPRB, 0.25129869E-06_JPRB, 0.25280443E-06_JPRB, 0.25443558E-06_JPRB, 0.25596790E-06_JPRB, &
  & 0.25686872E-06_JPRB, 0.25739845E-06_JPRB, 0.25783704E-06_JPRB, 0.25849904E-06_JPRB, 0.25899472E-06_JPRB, 0.25968618E-06_JPRB, &
  & 0.26073015E-06_JPRB, 0.26147375E-06_JPRB, 0.26183484E-06_JPRB, 0.26243846E-06_JPRB  /)

RGHG2(:,11, 3) = (/ &
  & 0.11224539E-06_JPRB, 0.11330960E-06_JPRB, 0.11541535E-06_JPRB, 0.11883948E-06_JPRB, 0.12376162E-06_JPRB, 0.13040730E-06_JPRB, &
  & 0.13866441E-06_JPRB, 0.14855620E-06_JPRB, 0.16063418E-06_JPRB, 0.17663515E-06_JPRB, 0.19716454E-06_JPRB, 0.22241220E-06_JPRB, &
  & 0.24925742E-06_JPRB, 0.27193613E-06_JPRB, 0.29314397E-06_JPRB, 0.32115144E-06_JPRB, 0.35550666E-06_JPRB, 0.39367273E-06_JPRB, &
  & 0.43195626E-06_JPRB, 0.47427613E-06_JPRB, 0.52101073E-06_JPRB, 0.56103425E-06_JPRB, 0.59194232E-06_JPRB, 0.61612727E-06_JPRB, &
  & 0.63574302E-06_JPRB, 0.64765718E-06_JPRB, 0.65231650E-06_JPRB, 0.65185652E-06_JPRB, 0.64652947E-06_JPRB, 0.63659915E-06_JPRB, &
  & 0.62057905E-06_JPRB, 0.59711299E-06_JPRB, 0.56590985E-06_JPRB, 0.52897241E-06_JPRB, 0.49118397E-06_JPRB, 0.45525495E-06_JPRB, &
  & 0.42382287E-06_JPRB, 0.39770136E-06_JPRB, 0.37537685E-06_JPRB, 0.35597911E-06_JPRB, 0.33670466E-06_JPRB, 0.31640583E-06_JPRB, &
  & 0.29918017E-06_JPRB, 0.28774563E-06_JPRB, 0.28043429E-06_JPRB, 0.27546869E-06_JPRB, 0.27252953E-06_JPRB, 0.27170454E-06_JPRB, &
  & 0.27180817E-06_JPRB, 0.27242146E-06_JPRB, 0.27407262E-06_JPRB, 0.27592059E-06_JPRB, 0.27822776E-06_JPRB, 0.28004451E-06_JPRB, &
  & 0.28088420E-06_JPRB, 0.28146279E-06_JPRB, 0.28190019E-06_JPRB, 0.28255694E-06_JPRB, 0.28327119E-06_JPRB, 0.28414656E-06_JPRB, &
  & 0.28465421E-06_JPRB, 0.28457758E-06_JPRB, 0.28433233E-06_JPRB, 0.28426498E-06_JPRB  /)

RGHG2(:,12, 3) = (/ &
  & 0.14590615E-06_JPRB, 0.14683707E-06_JPRB, 0.14898672E-06_JPRB, 0.15280662E-06_JPRB, 0.15855375E-06_JPRB, 0.16613070E-06_JPRB, &
  & 0.17499791E-06_JPRB, 0.18536645E-06_JPRB, 0.19858782E-06_JPRB, 0.21709723E-06_JPRB, 0.24062496E-06_JPRB, 0.26795276E-06_JPRB, &
  & 0.29538902E-06_JPRB, 0.31765719E-06_JPRB, 0.33766590E-06_JPRB, 0.36446064E-06_JPRB, 0.39693572E-06_JPRB, 0.43693560E-06_JPRB, &
  & 0.47660122E-06_JPRB, 0.51944536E-06_JPRB, 0.57253997E-06_JPRB, 0.62693834E-06_JPRB, 0.67442585E-06_JPRB, 0.71343190E-06_JPRB, &
  & 0.74509639E-06_JPRB, 0.76449997E-06_JPRB, 0.77092952E-06_JPRB, 0.76838272E-06_JPRB, 0.75901159E-06_JPRB, 0.74420864E-06_JPRB, &
  & 0.72412810E-06_JPRB, 0.69810988E-06_JPRB, 0.66268727E-06_JPRB, 0.61580200E-06_JPRB, 0.56218755E-06_JPRB, 0.51238741E-06_JPRB, &
  & 0.47264046E-06_JPRB, 0.44393016E-06_JPRB, 0.42313682E-06_JPRB, 0.40439459E-06_JPRB, 0.38381585E-06_JPRB, 0.36153211E-06_JPRB, &
  & 0.34210574E-06_JPRB, 0.32693667E-06_JPRB, 0.31534341E-06_JPRB, 0.30811961E-06_JPRB, 0.30372602E-06_JPRB, 0.30110739E-06_JPRB, &
  & 0.29982449E-06_JPRB, 0.29946674E-06_JPRB, 0.30027767E-06_JPRB, 0.30191189E-06_JPRB, 0.30324855E-06_JPRB, 0.30379202E-06_JPRB, &
  & 0.30370593E-06_JPRB, 0.30407883E-06_JPRB, 0.30466843E-06_JPRB, 0.30530655E-06_JPRB, 0.30597520E-06_JPRB, 0.30695576E-06_JPRB, &
  & 0.30672403E-06_JPRB, 0.30533906E-06_JPRB, 0.30474116E-06_JPRB, 0.30414965E-06_JPRB  /)

RGHG2(:,13, 3) = (/ &
  & 0.20194878E-06_JPRB, 0.20285076E-06_JPRB, 0.20468964E-06_JPRB, 0.20831150E-06_JPRB, 0.21403995E-06_JPRB, 0.22130599E-06_JPRB, &
  & 0.22947077E-06_JPRB, 0.23925728E-06_JPRB, 0.25238455E-06_JPRB, 0.27103466E-06_JPRB, 0.29426423E-06_JPRB, 0.32000484E-06_JPRB, &
  & 0.34490608E-06_JPRB, 0.36502386E-06_JPRB, 0.38369278E-06_JPRB, 0.40884564E-06_JPRB, 0.43792591E-06_JPRB, 0.47634605E-06_JPRB, &
  & 0.51680406E-06_JPRB, 0.55819300E-06_JPRB, 0.61219403E-06_JPRB, 0.67726657E-06_JPRB, 0.74083503E-06_JPRB, 0.79692356E-06_JPRB, &
  & 0.84394637E-06_JPRB, 0.87563148E-06_JPRB, 0.88749715E-06_JPRB, 0.88546671E-06_JPRB, 0.87496501E-06_JPRB, 0.85856875E-06_JPRB, &
  & 0.83674342E-06_JPRB, 0.80994837E-06_JPRB, 0.77414411E-06_JPRB, 0.72284601E-06_JPRB, 0.65929369E-06_JPRB, 0.60255273E-06_JPRB, &
  & 0.55913477E-06_JPRB, 0.52942757E-06_JPRB, 0.50553924E-06_JPRB, 0.47750718E-06_JPRB, 0.44647028E-06_JPRB, 0.41934766E-06_JPRB, &
  & 0.39626544E-06_JPRB, 0.37471589E-06_JPRB, 0.35641224E-06_JPRB, 0.34521106E-06_JPRB, 0.33841955E-06_JPRB, 0.33287861E-06_JPRB, &
  & 0.32866750E-06_JPRB, 0.32663262E-06_JPRB, 0.32613321E-06_JPRB, 0.32558618E-06_JPRB, 0.32450701E-06_JPRB, 0.32336687E-06_JPRB, &
  & 0.32231490E-06_JPRB, 0.32203696E-06_JPRB, 0.32270511E-06_JPRB, 0.32451986E-06_JPRB, 0.32545599E-06_JPRB, 0.32592711E-06_JPRB, &
  & 0.32543527E-06_JPRB, 0.32319026E-06_JPRB, 0.32205228E-06_JPRB, 0.32240226E-06_JPRB  /)

RGHG2(:,14, 3) = (/ &
  & 0.27212117E-06_JPRB, 0.27310332E-06_JPRB, 0.27457159E-06_JPRB, 0.27750331E-06_JPRB, 0.28235793E-06_JPRB, 0.28868123E-06_JPRB, &
  & 0.29622619E-06_JPRB, 0.30505170E-06_JPRB, 0.31670430E-06_JPRB, 0.33248899E-06_JPRB, 0.35231556E-06_JPRB, 0.37478258E-06_JPRB, &
  & 0.39541969E-06_JPRB, 0.41252027E-06_JPRB, 0.43009939E-06_JPRB, 0.45365353E-06_JPRB, 0.48071353E-06_JPRB, 0.51599094E-06_JPRB, &
  & 0.55473978E-06_JPRB, 0.59345836E-06_JPRB, 0.64407330E-06_JPRB, 0.71242022E-06_JPRB, 0.78673677E-06_JPRB, 0.85972091E-06_JPRB, &
  & 0.92455569E-06_JPRB, 0.97441098E-06_JPRB, 0.10003211E-05_JPRB, 0.10086413E-05_JPRB, 0.10061557E-05_JPRB, 0.99564382E-06_JPRB, &
  & 0.97785755E-06_JPRB, 0.95390558E-06_JPRB, 0.92169413E-06_JPRB, 0.87383963E-06_JPRB, 0.81116954E-06_JPRB, 0.75433481E-06_JPRB, &
  & 0.70790948E-06_JPRB, 0.67006224E-06_JPRB, 0.62931793E-06_JPRB, 0.58210013E-06_JPRB, 0.53138071E-06_JPRB, 0.48769200E-06_JPRB, &
  & 0.45119861E-06_JPRB, 0.41990552E-06_JPRB, 0.39578674E-06_JPRB, 0.38105669E-06_JPRB, 0.37191410E-06_JPRB, 0.36402539E-06_JPRB, &
  & 0.35828603E-06_JPRB, 0.35371709E-06_JPRB, 0.35034280E-06_JPRB, 0.34650685E-06_JPRB, 0.34375098E-06_JPRB, 0.34151821E-06_JPRB, &
  & 0.33931824E-06_JPRB, 0.33745060E-06_JPRB, 0.33733755E-06_JPRB, 0.33988671E-06_JPRB, 0.34168414E-06_JPRB, 0.34122999E-06_JPRB, &
  & 0.34019213E-06_JPRB, 0.33786244E-06_JPRB, 0.33591515E-06_JPRB, 0.33737853E-06_JPRB  /)

RGHG2(:,15, 3) = (/ &
  & 0.35240041E-06_JPRB, 0.35264167E-06_JPRB, 0.35317454E-06_JPRB, 0.35502023E-06_JPRB, 0.35873598E-06_JPRB, 0.36447640E-06_JPRB, &
  & 0.37182687E-06_JPRB, 0.37948632E-06_JPRB, 0.38819646E-06_JPRB, 0.39985964E-06_JPRB, 0.41556848E-06_JPRB, 0.43333145E-06_JPRB, &
  & 0.44927475E-06_JPRB, 0.46421623E-06_JPRB, 0.48077033E-06_JPRB, 0.50264120E-06_JPRB, 0.52795683E-06_JPRB, 0.55961991E-06_JPRB, &
  & 0.59414647E-06_JPRB, 0.62885926E-06_JPRB, 0.67438276E-06_JPRB, 0.73868443E-06_JPRB, 0.81662014E-06_JPRB, 0.90093612E-06_JPRB, &
  & 0.98288489E-06_JPRB, 0.10565894E-05_JPRB, 0.11062257E-05_JPRB, 0.11361369E-05_JPRB, 0.11526756E-05_JPRB, 0.11555105E-05_JPRB, &
  & 0.11450982E-05_JPRB, 0.11252861E-05_JPRB, 0.10955068E-05_JPRB, 0.10456914E-05_JPRB, 0.98109001E-06_JPRB, 0.92390742E-06_JPRB, &
  & 0.87583663E-06_JPRB, 0.82654142E-06_JPRB, 0.76225870E-06_JPRB, 0.69407382E-06_JPRB, 0.62104155E-06_JPRB, 0.54678749E-06_JPRB, &
  & 0.49101383E-06_JPRB, 0.45053107E-06_JPRB, 0.42429154E-06_JPRB, 0.41013162E-06_JPRB, 0.40086517E-06_JPRB, 0.39140356E-06_JPRB, &
  & 0.38454874E-06_JPRB, 0.37734258E-06_JPRB, 0.37075993E-06_JPRB, 0.36582894E-06_JPRB, 0.36187141E-06_JPRB, 0.35849483E-06_JPRB, &
  & 0.35542866E-06_JPRB, 0.35257469E-06_JPRB, 0.35076571E-06_JPRB, 0.35136716E-06_JPRB, 0.35256113E-06_JPRB, 0.35225557E-06_JPRB, &
  & 0.35047549E-06_JPRB, 0.34862570E-06_JPRB, 0.34635831E-06_JPRB, 0.34750146E-06_JPRB  /)

RGHG2(:,16, 3) = (/ &
  & 0.43374506E-06_JPRB, 0.43269385E-06_JPRB, 0.43236621E-06_JPRB, 0.43345109E-06_JPRB, 0.43650269E-06_JPRB, 0.44197444E-06_JPRB, &
  & 0.44888699E-06_JPRB, 0.45567087E-06_JPRB, 0.46206529E-06_JPRB, 0.47111100E-06_JPRB, 0.48314974E-06_JPRB, 0.49547140E-06_JPRB, &
  & 0.50740346E-06_JPRB, 0.52072657E-06_JPRB, 0.53655909E-06_JPRB, 0.55652157E-06_JPRB, 0.57988503E-06_JPRB, 0.60709106E-06_JPRB, &
  & 0.63648277E-06_JPRB, 0.66712530E-06_JPRB, 0.70851085E-06_JPRB, 0.76669472E-06_JPRB, 0.84242938E-06_JPRB, 0.93091210E-06_JPRB, &
  & 0.10237038E-05_JPRB, 0.11190241E-05_JPRB, 0.11960028E-05_JPRB, 0.12516667E-05_JPRB, 0.12900625E-05_JPRB, 0.13074334E-05_JPRB, &
  & 0.13052147E-05_JPRB, 0.12874009E-05_JPRB, 0.12528216E-05_JPRB, 0.11905873E-05_JPRB, 0.11163337E-05_JPRB, 0.10560524E-05_JPRB, &
  & 0.10033094E-05_JPRB, 0.93940493E-06_JPRB, 0.85680445E-06_JPRB, 0.77192885E-06_JPRB, 0.67600697E-06_JPRB, 0.57856573E-06_JPRB, &
  & 0.50941593E-06_JPRB, 0.46501376E-06_JPRB, 0.44120757E-06_JPRB, 0.43016731E-06_JPRB, 0.42326724E-06_JPRB, 0.41416094E-06_JPRB, &
  & 0.40490978E-06_JPRB, 0.39508569E-06_JPRB, 0.38883620E-06_JPRB, 0.38492023E-06_JPRB, 0.38025777E-06_JPRB, 0.37530490E-06_JPRB, &
  & 0.37171038E-06_JPRB, 0.36803661E-06_JPRB, 0.36444008E-06_JPRB, 0.36272862E-06_JPRB, 0.36260144E-06_JPRB, 0.36178230E-06_JPRB, &
  & 0.35921259E-06_JPRB, 0.35626171E-06_JPRB, 0.35343863E-06_JPRB, 0.35642742E-06_JPRB  /)

RGHG2(:,17, 3) = (/ &
  & 0.50737991E-06_JPRB, 0.50559555E-06_JPRB, 0.50466768E-06_JPRB, 0.50548641E-06_JPRB, 0.50841956E-06_JPRB, 0.51361692E-06_JPRB, &
  & 0.51998176E-06_JPRB, 0.52672136E-06_JPRB, 0.53265938E-06_JPRB, 0.54035104E-06_JPRB, 0.54957326E-06_JPRB, 0.55936730E-06_JPRB, &
  & 0.56871264E-06_JPRB, 0.57993946E-06_JPRB, 0.59455826E-06_JPRB, 0.61318376E-06_JPRB, 0.63562395E-06_JPRB, 0.65859485E-06_JPRB, &
  & 0.68342122E-06_JPRB, 0.71139773E-06_JPRB, 0.75016686E-06_JPRB, 0.80525475E-06_JPRB, 0.87636726E-06_JPRB, 0.96413349E-06_JPRB, &
  & 0.10624215E-05_JPRB, 0.11697162E-05_JPRB, 0.12653413E-05_JPRB, 0.13406383E-05_JPRB, 0.13936617E-05_JPRB, 0.14202888E-05_JPRB, &
  & 0.14246882E-05_JPRB, 0.14068757E-05_JPRB, 0.13601699E-05_JPRB, 0.12805893E-05_JPRB, 0.11955129E-05_JPRB, 0.11318556E-05_JPRB, &
  & 0.10675845E-05_JPRB, 0.99353296E-06_JPRB, 0.90636125E-06_JPRB, 0.80848195E-06_JPRB, 0.69820274E-06_JPRB, 0.59133949E-06_JPRB, &
  & 0.51672486E-06_JPRB, 0.47719654E-06_JPRB, 0.45783916E-06_JPRB, 0.44940616E-06_JPRB, 0.44366582E-06_JPRB, 0.43629624E-06_JPRB, &
  & 0.42475572E-06_JPRB, 0.41465108E-06_JPRB, 0.40927219E-06_JPRB, 0.40563836E-06_JPRB, 0.40036773E-06_JPRB, 0.39424190E-06_JPRB, &
  & 0.39032914E-06_JPRB, 0.38647319E-06_JPRB, 0.38171380E-06_JPRB, 0.37879815E-06_JPRB, 0.37805147E-06_JPRB, 0.37630203E-06_JPRB, &
  & 0.37246356E-06_JPRB, 0.36755506E-06_JPRB, 0.36236764E-06_JPRB, 0.36798378E-06_JPRB  /)

RGHG2(:,18, 3) = (/ &
  & 0.57051492E-06_JPRB, 0.56921927E-06_JPRB, 0.56815685E-06_JPRB, 0.56915217E-06_JPRB, 0.57271175E-06_JPRB, 0.57807934E-06_JPRB, &
  & 0.58390251E-06_JPRB, 0.59072735E-06_JPRB, 0.59730427E-06_JPRB, 0.60477566E-06_JPRB, 0.61313902E-06_JPRB, 0.62217555E-06_JPRB, &
  & 0.63079951E-06_JPRB, 0.64071026E-06_JPRB, 0.65434976E-06_JPRB, 0.67211587E-06_JPRB, 0.69453337E-06_JPRB, 0.71553813E-06_JPRB, &
  & 0.73735504E-06_JPRB, 0.76443654E-06_JPRB, 0.80129127E-06_JPRB, 0.85532613E-06_JPRB, 0.92448156E-06_JPRB, 0.10087674E-05_JPRB, &
  & 0.11092146E-05_JPRB, 0.12200286E-05_JPRB, 0.13209404E-05_JPRB, 0.14039332E-05_JPRB, 0.14622468E-05_JPRB, 0.14922794E-05_JPRB, &
  & 0.15003871E-05_JPRB, 0.14834378E-05_JPRB, 0.14294905E-05_JPRB, 0.13413426E-05_JPRB, 0.12519234E-05_JPRB, 0.11779730E-05_JPRB, &
  & 0.11037467E-05_JPRB, 0.10225206E-05_JPRB, 0.93376836E-06_JPRB, 0.83024465E-06_JPRB, 0.71905145E-06_JPRB, 0.60937643E-06_JPRB, &
  & 0.53386513E-06_JPRB, 0.49875469E-06_JPRB, 0.48327791E-06_JPRB, 0.47563735E-06_JPRB, 0.46803721E-06_JPRB, 0.45944279E-06_JPRB, &
  & 0.44925779E-06_JPRB, 0.44064121E-06_JPRB, 0.43373223E-06_JPRB, 0.42801075E-06_JPRB, 0.42172026E-06_JPRB, 0.41508232E-06_JPRB, &
  & 0.41078272E-06_JPRB, 0.40676728E-06_JPRB, 0.40172463E-06_JPRB, 0.39838210E-06_JPRB, 0.39717581E-06_JPRB, 0.39575707E-06_JPRB, &
  & 0.39146634E-06_JPRB, 0.38525765E-06_JPRB, 0.37776286E-06_JPRB, 0.38240251E-06_JPRB  /)

RGHG2(:,19, 3) = (/ &
  & 0.62977701E-06_JPRB, 0.62922011E-06_JPRB, 0.62832114E-06_JPRB, 0.63008195E-06_JPRB, 0.63467737E-06_JPRB, 0.64041570E-06_JPRB, &
  & 0.64618716E-06_JPRB, 0.65301884E-06_JPRB, 0.66029784E-06_JPRB, 0.66839323E-06_JPRB, 0.67713732E-06_JPRB, 0.68528329E-06_JPRB, &
  & 0.69359340E-06_JPRB, 0.70350319E-06_JPRB, 0.71728802E-06_JPRB, 0.73520151E-06_JPRB, 0.75762586E-06_JPRB, 0.77902888E-06_JPRB, &
  & 0.79980732E-06_JPRB, 0.82730142E-06_JPRB, 0.86248473E-06_JPRB, 0.91512089E-06_JPRB, 0.98514196E-06_JPRB, 0.10655836E-05_JPRB, &
  & 0.11623499E-05_JPRB, 0.12699643E-05_JPRB, 0.13684321E-05_JPRB, 0.14499669E-05_JPRB, 0.15084269E-05_JPRB, 0.15399506E-05_JPRB, &
  & 0.15503928E-05_JPRB, 0.15351413E-05_JPRB, 0.14809576E-05_JPRB, 0.13935758E-05_JPRB, 0.12992331E-05_JPRB, 0.12145207E-05_JPRB, &
  & 0.11328182E-05_JPRB, 0.10440149E-05_JPRB, 0.94723890E-06_JPRB, 0.84523239E-06_JPRB, 0.74383896E-06_JPRB, 0.64502850E-06_JPRB, &
  & 0.57045543E-06_JPRB, 0.53393198E-06_JPRB, 0.52019881E-06_JPRB, 0.51163955E-06_JPRB, 0.50161587E-06_JPRB, 0.49097961E-06_JPRB, &
  & 0.48099736E-06_JPRB, 0.47320069E-06_JPRB, 0.46355598E-06_JPRB, 0.45493194E-06_JPRB, 0.44666296E-06_JPRB, 0.43927872E-06_JPRB, &
  & 0.43446892E-06_JPRB, 0.42982060E-06_JPRB, 0.42500034E-06_JPRB, 0.42192168E-06_JPRB, 0.42009485E-06_JPRB, 0.41901806E-06_JPRB, &
  & 0.41398788E-06_JPRB, 0.40697228E-06_JPRB, 0.39828754E-06_JPRB, 0.40053137E-06_JPRB  /)

RGHG2(:,20, 3) = (/ &
  & 0.68937323E-06_JPRB, 0.68956627E-06_JPRB, 0.68914620E-06_JPRB, 0.69209498E-06_JPRB, 0.69766456E-06_JPRB, 0.70398337E-06_JPRB, &
  & 0.71043234E-06_JPRB, 0.71772517E-06_JPRB, 0.72580427E-06_JPRB, 0.73457701E-06_JPRB, 0.74381706E-06_JPRB, 0.75091363E-06_JPRB, &
  & 0.75826390E-06_JPRB, 0.76865454E-06_JPRB, 0.78300333E-06_JPRB, 0.80197690E-06_JPRB, 0.82478389E-06_JPRB, 0.84740057E-06_JPRB, &
  & 0.86917134E-06_JPRB, 0.89843597E-06_JPRB, 0.93285369E-06_JPRB, 0.98336588E-06_JPRB, 0.10545200E-05_JPRB, 0.11318638E-05_JPRB, &
  & 0.12203253E-05_JPRB, 0.13199126E-05_JPRB, 0.14117939E-05_JPRB, 0.14872753E-05_JPRB, 0.15432247E-05_JPRB, 0.15754435E-05_JPRB, &
  & 0.15873452E-05_JPRB, 0.15744221E-05_JPRB, 0.15249735E-05_JPRB, 0.14422639E-05_JPRB, 0.13436513E-05_JPRB, 0.12501588E-05_JPRB, &
  & 0.11640094E-05_JPRB, 0.10684910E-05_JPRB, 0.96111945E-06_JPRB, 0.86385560E-06_JPRB, 0.77437602E-06_JPRB, 0.68877065E-06_JPRB, &
  & 0.61967828E-06_JPRB, 0.58190667E-06_JPRB, 0.56817592E-06_JPRB, 0.55717795E-06_JPRB, 0.54539730E-06_JPRB, 0.53279486E-06_JPRB, &
  & 0.52099450E-06_JPRB, 0.51175292E-06_JPRB, 0.49924038E-06_JPRB, 0.48745955E-06_JPRB, 0.47643474E-06_JPRB, 0.46765536E-06_JPRB, &
  & 0.46198144E-06_JPRB, 0.45641627E-06_JPRB, 0.45179913E-06_JPRB, 0.44944409E-06_JPRB, 0.44773682E-06_JPRB, 0.44671011E-06_JPRB, &
  & 0.44083567E-06_JPRB, 0.43289659E-06_JPRB, 0.42312942E-06_JPRB, 0.42207060E-06_JPRB  /)

RGHG2(:,21, 3) = (/ &
  & 0.75041306E-06_JPRB, 0.75126720E-06_JPRB, 0.75177225E-06_JPRB, 0.75601824E-06_JPRB, 0.76250206E-06_JPRB, 0.76980158E-06_JPRB, &
  & 0.77747785E-06_JPRB, 0.78572540E-06_JPRB, 0.79493655E-06_JPRB, 0.80436117E-06_JPRB, 0.81386348E-06_JPRB, 0.82013821E-06_JPRB, &
  & 0.82598903E-06_JPRB, 0.83653442E-06_JPRB, 0.85138764E-06_JPRB, 0.87152075E-06_JPRB, 0.89492808E-06_JPRB, 0.91890818E-06_JPRB, &
  & 0.94316445E-06_JPRB, 0.97507505E-06_JPRB, 0.10101067E-05_JPRB, 0.10582416E-05_JPRB, 0.11289158E-05_JPRB, 0.12039783E-05_JPRB, &
  & 0.12820599E-05_JPRB, 0.13701152E-05_JPRB, 0.14530622E-05_JPRB, 0.15208542E-05_JPRB, 0.15729197E-05_JPRB, 0.16048884E-05_JPRB, &
  & 0.16171863E-05_JPRB, 0.16063358E-05_JPRB, 0.15635601E-05_JPRB, 0.14871950E-05_JPRB, 0.13860665E-05_JPRB, 0.12855315E-05_JPRB, &
  & 0.11963706E-05_JPRB, 0.10967904E-05_JPRB, 0.98277284E-06_JPRB, 0.89014428E-06_JPRB, 0.80963199E-06_JPRB, 0.73359571E-06_JPRB, &
  & 0.67336452E-06_JPRB, 0.63775157E-06_JPRB, 0.62359366E-06_JPRB, 0.61010499E-06_JPRB, 0.59750794E-06_JPRB, 0.58329060E-06_JPRB, &
  & 0.56820208E-06_JPRB, 0.55532257E-06_JPRB, 0.53992632E-06_JPRB, 0.52487347E-06_JPRB, 0.51094650E-06_JPRB, 0.50023289E-06_JPRB, &
  & 0.49311855E-06_JPRB, 0.48659940E-06_JPRB, 0.48204276E-06_JPRB, 0.48070293E-06_JPRB, 0.48002681E-06_JPRB, 0.47873701E-06_JPRB, &
  & 0.47211561E-06_JPRB, 0.46307593E-06_JPRB, 0.45178793E-06_JPRB, 0.44682060E-06_JPRB  /)

RGHG2(:,22, 3) = (/ &
  & 0.81189695E-06_JPRB, 0.81319072E-06_JPRB, 0.81530135E-06_JPRB, 0.82056039E-06_JPRB, 0.82815283E-06_JPRB, 0.83715350E-06_JPRB, &
  & 0.84626334E-06_JPRB, 0.85571508E-06_JPRB, 0.86668472E-06_JPRB, 0.87708416E-06_JPRB, 0.88666293E-06_JPRB, 0.89286120E-06_JPRB, &
  & 0.89733581E-06_JPRB, 0.90692549E-06_JPRB, 0.92196985E-06_JPRB, 0.94214119E-06_JPRB, 0.96581612E-06_JPRB, 0.99122977E-06_JPRB, &
  & 0.10187546E-05_JPRB, 0.10533985E-05_JPRB, 0.10909150E-05_JPRB, 0.11372149E-05_JPRB, 0.12041428E-05_JPRB, 0.12775040E-05_JPRB, &
  & 0.13461051E-05_JPRB, 0.14198822E-05_JPRB, 0.14925266E-05_JPRB, 0.15530552E-05_JPRB, 0.16006289E-05_JPRB, 0.16306863E-05_JPRB, &
  & 0.16416844E-05_JPRB, 0.16312353E-05_JPRB, 0.15937159E-05_JPRB, 0.15253597E-05_JPRB, 0.14239827E-05_JPRB, 0.13171974E-05_JPRB, &
  & 0.12237549E-05_JPRB, 0.11249966E-05_JPRB, 0.10162546E-05_JPRB, 0.92513602E-06_JPRB, 0.84712768E-06_JPRB, 0.77478042E-06_JPRB, &
  & 0.72320793E-06_JPRB, 0.69453340E-06_JPRB, 0.68121650E-06_JPRB, 0.66751759E-06_JPRB, 0.65509256E-06_JPRB, 0.63980483E-06_JPRB, &
  & 0.62075968E-06_JPRB, 0.60271936E-06_JPRB, 0.58409284E-06_JPRB, 0.56571413E-06_JPRB, 0.54962727E-06_JPRB, 0.53675376E-06_JPRB, &
  & 0.52734573E-06_JPRB, 0.52008112E-06_JPRB, 0.51552448E-06_JPRB, 0.51538884E-06_JPRB, 0.51643299E-06_JPRB, 0.51455066E-06_JPRB, &
  & 0.50739407E-06_JPRB, 0.49734134E-06_JPRB, 0.48391256E-06_JPRB, 0.47481658E-06_JPRB  /)

RGHG2(:,23, 3) = (/ &
  & 0.87015290E-06_JPRB, 0.87211958E-06_JPRB, 0.87547542E-06_JPRB, 0.88208016E-06_JPRB, 0.89137879E-06_JPRB, 0.90245649E-06_JPRB, &
  & 0.91312666E-06_JPRB, 0.92356551E-06_JPRB, 0.93623852E-06_JPRB, 0.94832908E-06_JPRB, 0.95899601E-06_JPRB, 0.96643246E-06_JPRB, &
  & 0.97099533E-06_JPRB, 0.97959548E-06_JPRB, 0.99458534E-06_JPRB, 0.10137575E-05_JPRB, 0.10362157E-05_JPRB, 0.10614564E-05_JPRB, &
  & 0.10909458E-05_JPRB, 0.11277222E-05_JPRB, 0.11675713E-05_JPRB, 0.12124481E-05_JPRB, 0.12734650E-05_JPRB, 0.13427726E-05_JPRB, &
  & 0.14040413E-05_JPRB, 0.14654450E-05_JPRB, 0.15274259E-05_JPRB, 0.15817386E-05_JPRB, 0.16250812E-05_JPRB, 0.16519431E-05_JPRB, &
  & 0.16601187E-05_JPRB, 0.16471908E-05_JPRB, 0.16088647E-05_JPRB, 0.15429767E-05_JPRB, 0.14456922E-05_JPRB, 0.13361502E-05_JPRB, &
  & 0.12367669E-05_JPRB, 0.11433924E-05_JPRB, 0.10478039E-05_JPRB, 0.95711392E-06_JPRB, 0.87824726E-06_JPRB, 0.81253435E-06_JPRB, &
  & 0.76763903E-06_JPRB, 0.74284786E-06_JPRB, 0.73081168E-06_JPRB, 0.71959789E-06_JPRB, 0.70818055E-06_JPRB, 0.69295471E-06_JPRB, &
  & 0.67247556E-06_JPRB, 0.65011351E-06_JPRB, 0.62846226E-06_JPRB, 0.60747380E-06_JPRB, 0.58950151E-06_JPRB, 0.57474258E-06_JPRB, &
  & 0.56294750E-06_JPRB, 0.55517319E-06_JPRB, 0.55098146E-06_JPRB, 0.55149843E-06_JPRB, 0.55269075E-06_JPRB, 0.55033113E-06_JPRB, &
  & 0.54331192E-06_JPRB, 0.53250647E-06_JPRB, 0.51806110E-06_JPRB, 0.50590002E-06_JPRB  /)

RGHG2(:,24, 3) = (/ &
  & 0.92922259E-06_JPRB, 0.93190675E-06_JPRB, 0.93637411E-06_JPRB, 0.94434928E-06_JPRB, 0.95531593E-06_JPRB, 0.96858091E-06_JPRB, &
  & 0.98112950E-06_JPRB, 0.99301037E-06_JPRB, 0.10072542E-05_JPRB, 0.10210365E-05_JPRB, 0.10330693E-05_JPRB, 0.10420474E-05_JPRB, &
  & 0.10476307E-05_JPRB, 0.10556266E-05_JPRB, 0.10703532E-05_JPRB, 0.10885473E-05_JPRB, 0.11091080E-05_JPRB, 0.11332199E-05_JPRB, &
  & 0.11639200E-05_JPRB, 0.12020562E-05_JPRB, 0.12437049E-05_JPRB, 0.12868725E-05_JPRB, 0.13411950E-05_JPRB, 0.14048810E-05_JPRB, &
  & 0.14594569E-05_JPRB, 0.15098045E-05_JPRB, 0.15614755E-05_JPRB, 0.16094097E-05_JPRB, 0.16482035E-05_JPRB, 0.16712639E-05_JPRB, &
  & 0.16761217E-05_JPRB, 0.16600466E-05_JPRB, 0.16194328E-05_JPRB, 0.15540570E-05_JPRB, 0.14608871E-05_JPRB, 0.13509808E-05_JPRB, &
  & 0.12483833E-05_JPRB, 0.11614636E-05_JPRB, 0.10773493E-05_JPRB, 0.98741804E-06_JPRB, 0.90946603E-06_JPRB, 0.85104716E-06_JPRB, &
  & 0.81162012E-06_JPRB, 0.78957480E-06_JPRB, 0.77849605E-06_JPRB, 0.76965318E-06_JPRB, 0.75921460E-06_JPRB, 0.74467398E-06_JPRB, &
  & 0.72382105E-06_JPRB, 0.69861918E-06_JPRB, 0.67442635E-06_JPRB, 0.65105978E-06_JPRB, 0.63108430E-06_JPRB, 0.61418576E-06_JPRB, &
  & 0.60035148E-06_JPRB, 0.59189769E-06_JPRB, 0.58791387E-06_JPRB, 0.58864925E-06_JPRB, 0.58949974E-06_JPRB, 0.58660819E-06_JPRB, &
  & 0.57991166E-06_JPRB, 0.56904190E-06_JPRB, 0.55368468E-06_JPRB, 0.53897910E-06_JPRB  /)

RGHG2(:,25, 3) = (/ &
  & 0.98780146E-06_JPRB, 0.99119726E-06_JPRB, 0.99657034E-06_JPRB, 0.10058232E-05_JPRB, 0.10181808E-05_JPRB, 0.10336454E-05_JPRB, &
  & 0.10485230E-05_JPRB, 0.10626358E-05_JPRB, 0.10781573E-05_JPRB, 0.10933952E-05_JPRB, 0.11069969E-05_JPRB, 0.11176894E-05_JPRB, &
  & 0.11255693E-05_JPRB, 0.11336784E-05_JPRB, 0.11478389E-05_JPRB, 0.11653699E-05_JPRB, 0.11832458E-05_JPRB, 0.12049479E-05_JPRB, &
  & 0.12357612E-05_JPRB, 0.12739621E-05_JPRB, 0.13164195E-05_JPRB, 0.13573551E-05_JPRB, 0.14043834E-05_JPRB, 0.14604516E-05_JPRB, &
  & 0.15092859E-05_JPRB, 0.15509806E-05_JPRB, 0.15935135E-05_JPRB, 0.16348328E-05_JPRB, 0.16686613E-05_JPRB, 0.16873064E-05_JPRB, &
  & 0.16884604E-05_JPRB, 0.16688433E-05_JPRB, 0.16247846E-05_JPRB, 0.15576782E-05_JPRB, 0.14675004E-05_JPRB, 0.13606994E-05_JPRB, &
  & 0.12602368E-05_JPRB, 0.11803526E-05_JPRB, 0.11024490E-05_JPRB, 0.10140703E-05_JPRB, 0.94088952E-06_JPRB, 0.88994283E-06_JPRB, &
  & 0.85404162E-06_JPRB, 0.83329018E-06_JPRB, 0.82245403E-06_JPRB, 0.81506679E-06_JPRB, 0.80532367E-06_JPRB, 0.79228718E-06_JPRB, &
  & 0.77238850E-06_JPRB, 0.74691168E-06_JPRB, 0.72110149E-06_JPRB, 0.69571323E-06_JPRB, 0.67355433E-06_JPRB, 0.65410036E-06_JPRB, &
  & 0.63895603E-06_JPRB, 0.62949947E-06_JPRB, 0.62535392E-06_JPRB, 0.62565261E-06_JPRB, 0.62566208E-06_JPRB, 0.62213976E-06_JPRB, &
  & 0.61592843E-06_JPRB, 0.60615848E-06_JPRB, 0.58986319E-06_JPRB, 0.57341087E-06_JPRB  /)

RGHG2(:,26, 3) = (/ &
  & 0.10433897E-05_JPRB, 0.10473234E-05_JPRB, 0.10537754E-05_JPRB, 0.10636185E-05_JPRB, 0.10769795E-05_JPRB, 0.10943305E-05_JPRB, &
  & 0.11120980E-05_JPRB, 0.11286384E-05_JPRB, 0.11452297E-05_JPRB, 0.11614453E-05_JPRB, 0.11759478E-05_JPRB, 0.11875900E-05_JPRB, &
  & 0.11973604E-05_JPRB, 0.12060958E-05_JPRB, 0.12196926E-05_JPRB, 0.12362828E-05_JPRB, 0.12520920E-05_JPRB, 0.12715436E-05_JPRB, &
  & 0.13008415E-05_JPRB, 0.13380471E-05_JPRB, 0.13791287E-05_JPRB, 0.14180948E-05_JPRB, 0.14586318E-05_JPRB, 0.15063234E-05_JPRB, &
  & 0.15496376E-05_JPRB, 0.15856468E-05_JPRB, 0.16209713E-05_JPRB, 0.16557428E-05_JPRB, 0.16837750E-05_JPRB, 0.16981741E-05_JPRB, &
  & 0.16968455E-05_JPRB, 0.16751823E-05_JPRB, 0.16291988E-05_JPRB, 0.15616607E-05_JPRB, 0.14745784E-05_JPRB, 0.13734704E-05_JPRB, &
  & 0.12787982E-05_JPRB, 0.12055293E-05_JPRB, 0.11345792E-05_JPRB, 0.10509649E-05_JPRB, 0.98365743E-06_JPRB, 0.93584965E-06_JPRB, &
  & 0.90038138E-06_JPRB, 0.87911628E-06_JPRB, 0.86745928E-06_JPRB, 0.85866308E-06_JPRB, 0.84835619E-06_JPRB, 0.83566021E-06_JPRB, &
  & 0.81677850E-06_JPRB, 0.79271075E-06_JPRB, 0.76719102E-06_JPRB, 0.74045305E-06_JPRB, 0.71570873E-06_JPRB, 0.69362525E-06_JPRB, &
  & 0.67742405E-06_JPRB, 0.66662882E-06_JPRB, 0.66209997E-06_JPRB, 0.66163439E-06_JPRB, 0.66078438E-06_JPRB, 0.65670269E-06_JPRB, &
  & 0.65029874E-06_JPRB, 0.64151994E-06_JPRB, 0.62431846E-06_JPRB, 0.60749408E-06_JPRB  /)

RGHG2(:,27, 3) = (/ &
  & 0.11003995E-05_JPRB, 0.11048312E-05_JPRB, 0.11124753E-05_JPRB, 0.11226806E-05_JPRB, 0.11369471E-05_JPRB, 0.11561542E-05_JPRB, &
  & 0.11771511E-05_JPRB, 0.11963023E-05_JPRB, 0.12139348E-05_JPRB, 0.12309956E-05_JPRB, 0.12461922E-05_JPRB, 0.12585436E-05_JPRB, &
  & 0.12701400E-05_JPRB, 0.12797205E-05_JPRB, 0.12927288E-05_JPRB, 0.13082325E-05_JPRB, 0.13221100E-05_JPRB, 0.13392678E-05_JPRB, &
  & 0.13663776E-05_JPRB, 0.14021496E-05_JPRB, 0.14409826E-05_JPRB, 0.14779870E-05_JPRB, 0.15120350E-05_JPRB, 0.15506872E-05_JPRB, &
  & 0.15883122E-05_JPRB, 0.16194772E-05_JPRB, 0.16479807E-05_JPRB, 0.16759311E-05_JPRB, 0.16975951E-05_JPRB, 0.17076179E-05_JPRB, &
  & 0.17041464E-05_JPRB, 0.16808987E-05_JPRB, 0.16334665E-05_JPRB, 0.15659585E-05_JPRB, 0.14821509E-05_JPRB, 0.13879544E-05_JPRB, &
  & 0.13006919E-05_JPRB, 0.12341836E-05_JPRB, 0.11707788E-05_JPRB, 0.10933367E-05_JPRB, 0.10325786E-05_JPRB, 0.98644590E-06_JPRB, &
  & 0.95028345E-06_JPRB, 0.92781109E-06_JPRB, 0.91490156E-06_JPRB, 0.90357011E-06_JPRB, 0.89220687E-06_JPRB, 0.87943544E-06_JPRB, &
  & 0.86164026E-06_JPRB, 0.83967012E-06_JPRB, 0.81516147E-06_JPRB, 0.78726151E-06_JPRB, 0.75966504E-06_JPRB, 0.73480486E-06_JPRB, &
  & 0.71759258E-06_JPRB, 0.70527319E-06_JPRB, 0.70026143E-06_JPRB, 0.69887531E-06_JPRB, 0.69711986E-06_JPRB, 0.69247981E-06_JPRB, &
  & 0.68562314E-06_JPRB, 0.67784033E-06_JPRB, 0.65970322E-06_JPRB, 0.64299957E-06_JPRB  /)

RGHG2(:,28, 3) = (/ &
  & 0.11529872E-05_JPRB, 0.11575261E-05_JPRB, 0.11655175E-05_JPRB, 0.11757496E-05_JPRB, 0.11904147E-05_JPRB, 0.12106087E-05_JPRB, &
  & 0.12330345E-05_JPRB, 0.12530269E-05_JPRB, 0.12710884E-05_JPRB, 0.12882826E-05_JPRB, 0.13028054E-05_JPRB, 0.13154727E-05_JPRB, &
  & 0.13282550E-05_JPRB, 0.13391832E-05_JPRB, 0.13524062E-05_JPRB, 0.13669408E-05_JPRB, 0.13802917E-05_JPRB, 0.13967585E-05_JPRB, &
  & 0.14205649E-05_JPRB, 0.14522119E-05_JPRB, 0.14872008E-05_JPRB, 0.15213488E-05_JPRB, 0.15515989E-05_JPRB, 0.15833108E-05_JPRB, &
  & 0.16150411E-05_JPRB, 0.16423852E-05_JPRB, 0.16662264E-05_JPRB, 0.16885130E-05_JPRB, 0.17051444E-05_JPRB, 0.17126792E-05_JPRB, &
  & 0.17091735E-05_JPRB, 0.16874659E-05_JPRB, 0.16432192E-05_JPRB, 0.15811206E-05_JPRB, 0.15047527E-05_JPRB, 0.14169998E-05_JPRB, &
  & 0.13388043E-05_JPRB, 0.12828273E-05_JPRB, 0.12295339E-05_JPRB, 0.11638518E-05_JPRB, 0.11068190E-05_JPRB, 0.10587992E-05_JPRB, &
  & 0.10176770E-05_JPRB, 0.98893527E-06_JPRB, 0.97100649E-06_JPRB, 0.95640809E-06_JPRB, 0.94219908E-06_JPRB, 0.92665801E-06_JPRB, &
  & 0.90799166E-06_JPRB, 0.88634184E-06_JPRB, 0.86273675E-06_JPRB, 0.83481614E-06_JPRB, 0.80591825E-06_JPRB, 0.77910864E-06_JPRB, &
  & 0.76054213E-06_JPRB, 0.74741168E-06_JPRB, 0.74089119E-06_JPRB, 0.73835470E-06_JPRB, 0.73574992E-06_JPRB, 0.73078747E-06_JPRB, &
  & 0.72319942E-06_JPRB, 0.71376571E-06_JPRB, 0.69592984E-06_JPRB, 0.67990695E-06_JPRB  /)

RGHG2(:,29, 3) = (/ &
  & 0.12085164E-05_JPRB, 0.12131520E-05_JPRB, 0.12214748E-05_JPRB, 0.12317207E-05_JPRB, 0.12467862E-05_JPRB, 0.12679882E-05_JPRB, &
  & 0.12918500E-05_JPRB, 0.13126570E-05_JPRB, 0.13311466E-05_JPRB, 0.13484512E-05_JPRB, 0.13622008E-05_JPRB, 0.13751856E-05_JPRB, &
  & 0.13891969E-05_JPRB, 0.14015749E-05_JPRB, 0.14150602E-05_JPRB, 0.14285730E-05_JPRB, 0.14414269E-05_JPRB, 0.14572308E-05_JPRB, &
  & 0.14774887E-05_JPRB, 0.15046482E-05_JPRB, 0.15354949E-05_JPRB, 0.15665776E-05_JPRB, 0.15929201E-05_JPRB, 0.16173692E-05_JPRB, &
  & 0.16428446E-05_JPRB, 0.16661845E-05_JPRB, 0.16851793E-05_JPRB, 0.17015148E-05_JPRB, 0.17128716E-05_JPRB, 0.17178520E-05_JPRB, &
  & 0.17144016E-05_JPRB, 0.16944614E-05_JPRB, 0.16537908E-05_JPRB, 0.15976571E-05_JPRB, 0.15293529E-05_JPRB, 0.14484071E-05_JPRB, &
  & 0.13798908E-05_JPRB, 0.13352360E-05_JPRB, 0.12927679E-05_JPRB, 0.12397888E-05_JPRB, 0.11865806E-05_JPRB, 0.11364068E-05_JPRB, &
  & 0.10898444E-05_JPRB, 0.10542403E-05_JPRB, 0.10308299E-05_JPRB, 0.10127382E-05_JPRB, 0.99543627E-06_JPRB, 0.97684370E-06_JPRB, &
  & 0.95716940E-06_JPRB, 0.93578193E-06_JPRB, 0.91312956E-06_JPRB, 0.88523657E-06_JPRB, 0.85502696E-06_JPRB, 0.82618762E-06_JPRB, &
  & 0.80617131E-06_JPRB, 0.79221240E-06_JPRB, 0.78404880E-06_JPRB, 0.78028344E-06_JPRB, 0.77678116E-06_JPRB, 0.77148733E-06_JPRB, &
  & 0.76311225E-06_JPRB, 0.75181451E-06_JPRB, 0.73435144E-06_JPRB, 0.71907417E-06_JPRB  /)

RGHG2(:,30, 3) = (/ &
  & 0.12596416E-05_JPRB, 0.12642409E-05_JPRB, 0.12723214E-05_JPRB, 0.12820699E-05_JPRB, 0.12963352E-05_JPRB, 0.13172713E-05_JPRB, &
  & 0.13404551E-05_JPRB, 0.13602318E-05_JPRB, 0.13777150E-05_JPRB, 0.13941706E-05_JPRB, 0.14072646E-05_JPRB, 0.14204802E-05_JPRB, &
  & 0.14350868E-05_JPRB, 0.14486306E-05_JPRB, 0.14627590E-05_JPRB, 0.14763801E-05_JPRB, 0.14896338E-05_JPRB, 0.15048307E-05_JPRB, &
  & 0.15229505E-05_JPRB, 0.15464913E-05_JPRB, 0.15722640E-05_JPRB, 0.15982737E-05_JPRB, 0.16211921E-05_JPRB, 0.16417895E-05_JPRB, &
  & 0.16620678E-05_JPRB, 0.16806250E-05_JPRB, 0.16958794E-05_JPRB, 0.17084736E-05_JPRB, 0.17171571E-05_JPRB, 0.17211406E-05_JPRB, &
  & 0.17181754E-05_JPRB, 0.17011843E-05_JPRB, 0.16667395E-05_JPRB, 0.16203756E-05_JPRB, 0.15651424E-05_JPRB, 0.14984795E-05_JPRB, &
  & 0.14441758E-05_JPRB, 0.14082405E-05_JPRB, 0.13734359E-05_JPRB, 0.13303783E-05_JPRB, 0.12826926E-05_JPRB, 0.12314010E-05_JPRB, &
  & 0.11809643E-05_JPRB, 0.11389980E-05_JPRB, 0.11070433E-05_JPRB, 0.10822407E-05_JPRB, 0.10593927E-05_JPRB, 0.10365519E-05_JPRB, &
  & 0.10142082E-05_JPRB, 0.99078313E-06_JPRB, 0.96645772E-06_JPRB, 0.93829790E-06_JPRB, 0.90813562E-06_JPRB, 0.87890630E-06_JPRB, &
  & 0.85727543E-06_JPRB, 0.84238178E-06_JPRB, 0.83319781E-06_JPRB, 0.82795150E-06_JPRB, 0.82402388E-06_JPRB, 0.81846289E-06_JPRB, &
  & 0.80900755E-06_JPRB, 0.79545200E-06_JPRB, 0.77535710E-06_JPRB, 0.76285822E-06_JPRB  /)

RGHG2(:,31, 3) = (/ &
  & 0.13135056E-05_JPRB, 0.13180665E-05_JPRB, 0.13258912E-05_JPRB, 0.13351153E-05_JPRB, 0.13485363E-05_JPRB, 0.13691909E-05_JPRB, &
  & 0.13916584E-05_JPRB, 0.14103478E-05_JPRB, 0.14267692E-05_JPRB, 0.14423294E-05_JPRB, 0.14547326E-05_JPRB, 0.14681912E-05_JPRB, &
  & 0.14834247E-05_JPRB, 0.14981965E-05_JPRB, 0.15130029E-05_JPRB, 0.15267391E-05_JPRB, 0.15404149E-05_JPRB, 0.15549722E-05_JPRB, &
  & 0.15708406E-05_JPRB, 0.15905694E-05_JPRB, 0.16109950E-05_JPRB, 0.16316576E-05_JPRB, 0.16509686E-05_JPRB, 0.16675110E-05_JPRB, &
  & 0.16823142E-05_JPRB, 0.16958313E-05_JPRB, 0.17071458E-05_JPRB, 0.17158000E-05_JPRB, 0.17216693E-05_JPRB, 0.17246038E-05_JPRB, &
  & 0.17221502E-05_JPRB, 0.17082677E-05_JPRB, 0.16803852E-05_JPRB, 0.16443190E-05_JPRB, 0.16028628E-05_JPRB, 0.15512562E-05_JPRB, &
  & 0.15119321E-05_JPRB, 0.14851814E-05_JPRB, 0.14584487E-05_JPRB, 0.14258422E-05_JPRB, 0.13839769E-05_JPRB, 0.13315084E-05_JPRB, &
  & 0.12769910E-05_JPRB, 0.12283217E-05_JPRB, 0.11873613E-05_JPRB, 0.11554847E-05_JPRB, 0.11267907E-05_JPRB, 0.10994728E-05_JPRB, &
  & 0.10743147E-05_JPRB, 0.10487406E-05_JPRB, 0.10226499E-05_JPRB, 0.99420865E-06_JPRB, 0.96409755E-06_JPRB, 0.93445888E-06_JPRB, &
  & 0.91112666E-06_JPRB, 0.89524803E-06_JPRB, 0.88498951E-06_JPRB, 0.87818257E-06_JPRB, 0.87380723E-06_JPRB, 0.86796481E-06_JPRB, &
  & 0.85737098E-06_JPRB, 0.84143610E-06_JPRB, 0.81856532E-06_JPRB, 0.80899582E-06_JPRB  /)

RGHG2(:,32, 3) = (/ &
  & 0.13649591E-05_JPRB, 0.13692119E-05_JPRB, 0.13763544E-05_JPRB, 0.13844649E-05_JPRB, 0.13964692E-05_JPRB, 0.14157951E-05_JPRB, &
  & 0.14366798E-05_JPRB, 0.14536527E-05_JPRB, 0.14684582E-05_JPRB, 0.14824364E-05_JPRB, 0.14939598E-05_JPRB, 0.15071313E-05_JPRB, &
  & 0.15218679E-05_JPRB, 0.15367500E-05_JPRB, 0.15515800E-05_JPRB, 0.15651487E-05_JPRB, 0.15785367E-05_JPRB, 0.15924053E-05_JPRB, &
  & 0.16067937E-05_JPRB, 0.16236546E-05_JPRB, 0.16405839E-05_JPRB, 0.16571479E-05_JPRB, 0.16726303E-05_JPRB, 0.16855055E-05_JPRB, &
  & 0.16963298E-05_JPRB, 0.17058749E-05_JPRB, 0.17140396E-05_JPRB, 0.17203471E-05_JPRB, 0.17248183E-05_JPRB, 0.17271732E-05_JPRB, &
  & 0.17251676E-05_JPRB, 0.17138948E-05_JPRB, 0.16921867E-05_JPRB, 0.16651645E-05_JPRB, 0.16355372E-05_JPRB, 0.16002466E-05_JPRB, &
  & 0.15732088E-05_JPRB, 0.15538188E-05_JPRB, 0.15331805E-05_JPRB, 0.15067620E-05_JPRB, 0.14703556E-05_JPRB, 0.14221743E-05_JPRB, &
  & 0.13692798E-05_JPRB, 0.13181534E-05_JPRB, 0.12717315E-05_JPRB, 0.12329751E-05_JPRB, 0.11982119E-05_JPRB, 0.11662429E-05_JPRB, &
  & 0.11376479E-05_JPRB, 0.11101778E-05_JPRB, 0.10825323E-05_JPRB, 0.10535707E-05_JPRB, 0.10227290E-05_JPRB, 0.99327155E-06_JPRB, &
  & 0.96986927E-06_JPRB, 0.95303198E-06_JPRB, 0.94172251E-06_JPRB, 0.93372839E-06_JPRB, 0.92870105E-06_JPRB, 0.92245675E-06_JPRB, &
  & 0.91001712E-06_JPRB, 0.89146570E-06_JPRB, 0.86762323E-06_JPRB, 0.85340975E-06_JPRB  /)

RGHG2(:,33, 3) = (/ &
  & 0.14181198E-05_JPRB, 0.14220177E-05_JPRB, 0.14283959E-05_JPRB, 0.14352728E-05_JPRB, 0.14457307E-05_JPRB, 0.14635402E-05_JPRB, &
  & 0.14826678E-05_JPRB, 0.14977753E-05_JPRB, 0.15108298E-05_JPRB, 0.15230749E-05_JPRB, 0.15336597E-05_JPRB, 0.15464641E-05_JPRB, &
  & 0.15605388E-05_JPRB, 0.15753908E-05_JPRB, 0.15901606E-05_JPRB, 0.16035188E-05_JPRB, 0.16165156E-05_JPRB, 0.16296621E-05_JPRB, &
  & 0.16426124E-05_JPRB, 0.16566149E-05_JPRB, 0.16701505E-05_JPRB, 0.16826167E-05_JPRB, 0.16940914E-05_JPRB, 0.17032057E-05_JPRB, &
  & 0.17100887E-05_JPRB, 0.17156443E-05_JPRB, 0.17206378E-05_JPRB, 0.17247129E-05_JPRB, 0.17279144E-05_JPRB, 0.17297277E-05_JPRB, &
  & 0.17281795E-05_JPRB, 0.17195543E-05_JPRB, 0.17042126E-05_JPRB, 0.16864271E-05_JPRB, 0.16688406E-05_JPRB, 0.16506694E-05_JPRB, &
  & 0.16360515E-05_JPRB, 0.16240750E-05_JPRB, 0.16095142E-05_JPRB, 0.15889748E-05_JPRB, 0.15581946E-05_JPRB, 0.15151762E-05_JPRB, &
  & 0.14647067E-05_JPRB, 0.14115765E-05_JPRB, 0.13599375E-05_JPRB, 0.13140565E-05_JPRB, 0.12729570E-05_JPRB, 0.12361320E-05_JPRB, &
  & 0.12038844E-05_JPRB, 0.11744768E-05_JPRB, 0.11452426E-05_JPRB, 0.11157094E-05_JPRB, 0.10840072E-05_JPRB, 0.10548145E-05_JPRB, &
  & 0.10315507E-05_JPRB, 0.10137205E-05_JPRB, 0.10013219E-05_JPRB, 0.99214234E-06_JPRB, 0.98641096E-06_JPRB, 0.97973341E-06_JPRB, &
  & 0.96528398E-06_JPRB, 0.94398261E-06_JPRB, 0.91936389E-06_JPRB, 0.89934363E-06_JPRB  /)

RGHG2(:,34, 3) = (/ &
  & 0.14653490E-05_JPRB, 0.14689838E-05_JPRB, 0.14744337E-05_JPRB, 0.14798964E-05_JPRB, 0.14890677E-05_JPRB, 0.15049957E-05_JPRB, &
  & 0.15220204E-05_JPRB, 0.15351627E-05_JPRB, 0.15465474E-05_JPRB, 0.15573316E-05_JPRB, 0.15670495E-05_JPRB, 0.15787716E-05_JPRB, &
  & 0.15917709E-05_JPRB, 0.16058340E-05_JPRB, 0.16197216E-05_JPRB, 0.16323104E-05_JPRB, 0.16442894E-05_JPRB, 0.16561847E-05_JPRB, &
  & 0.16675549E-05_JPRB, 0.16791205E-05_JPRB, 0.16898922E-05_JPRB, 0.16992914E-05_JPRB, 0.17076965E-05_JPRB, 0.17140770E-05_JPRB, &
  & 0.17185354E-05_JPRB, 0.17218789E-05_JPRB, 0.17249797E-05_JPRB, 0.17276268E-05_JPRB, 0.17299238E-05_JPRB, 0.17313684E-05_JPRB, &
  & 0.17302441E-05_JPRB, 0.17239134E-05_JPRB, 0.17134917E-05_JPRB, 0.17022702E-05_JPRB, 0.16921849E-05_JPRB, 0.16829920E-05_JPRB, &
  & 0.16750415E-05_JPRB, 0.16675583E-05_JPRB, 0.16574374E-05_JPRB, 0.16418477E-05_JPRB, 0.16168280E-05_JPRB, 0.15804230E-05_JPRB, &
  & 0.15350720E-05_JPRB, 0.14842019E-05_JPRB, 0.14322824E-05_JPRB, 0.13839968E-05_JPRB, 0.13399110E-05_JPRB, 0.12995456E-05_JPRB, &
  & 0.12646545E-05_JPRB, 0.12340909E-05_JPRB, 0.12046431E-05_JPRB, 0.11751478E-05_JPRB, 0.11438149E-05_JPRB, 0.11154313E-05_JPRB, &
  & 0.10934706E-05_JPRB, 0.10755671E-05_JPRB, 0.10618639E-05_JPRB, 0.10510253E-05_JPRB, 0.10447915E-05_JPRB, 0.10375639E-05_JPRB, &
  & 0.10215396E-05_JPRB, 0.99927563E-06_JPRB, 0.97366304E-06_JPRB, 0.95157547E-06_JPRB  /)

RGHG2(:,35, 3) = (/ &
  & 0.15108631E-05_JPRB, 0.15142744E-05_JPRB, 0.15186858E-05_JPRB, 0.15226018E-05_JPRB, 0.15305837E-05_JPRB, 0.15443899E-05_JPRB, &
  & 0.15590750E-05_JPRB, 0.15701458E-05_JPRB, 0.15798553E-05_JPRB, 0.15892770E-05_JPRB, 0.15981406E-05_JPRB, 0.16083831E-05_JPRB, &
  & 0.16200646E-05_JPRB, 0.16329272E-05_JPRB, 0.16454858E-05_JPRB, 0.16569970E-05_JPRB, 0.16676079E-05_JPRB, 0.16779454E-05_JPRB, &
  & 0.16876181E-05_JPRB, 0.16968943E-05_JPRB, 0.17051478E-05_JPRB, 0.17119225E-05_JPRB, 0.17176531E-05_JPRB, 0.17217497E-05_JPRB, &
  & 0.17244940E-05_JPRB, 0.17264750E-05_JPRB, 0.17282859E-05_JPRB, 0.17298778E-05_JPRB, 0.17314320E-05_JPRB, 0.17325863E-05_JPRB, &
  & 0.17318808E-05_JPRB, 0.17277278E-05_JPRB, 0.17216223E-05_JPRB, 0.17157780E-05_JPRB, 0.17110754E-05_JPRB, 0.17069359E-05_JPRB, &
  & 0.17028884E-05_JPRB, 0.16985266E-05_JPRB, 0.16921300E-05_JPRB, 0.16811526E-05_JPRB, 0.16621243E-05_JPRB, 0.16332629E-05_JPRB, &
  & 0.15945567E-05_JPRB, 0.15481983E-05_JPRB, 0.14985234E-05_JPRB, 0.14501876E-05_JPRB, 0.14047505E-05_JPRB, 0.13614201E-05_JPRB, &
  & 0.13243290E-05_JPRB, 0.12929781E-05_JPRB, 0.12640161E-05_JPRB, 0.12348725E-05_JPRB, 0.12045503E-05_JPRB, 0.11772778E-05_JPRB, &
  & 0.11572547E-05_JPRB, 0.11397477E-05_JPRB, 0.11245927E-05_JPRB, 0.11118054E-05_JPRB, 0.11051583E-05_JPRB, 0.10973054E-05_JPRB, &
  & 0.10798852E-05_JPRB, 0.10575486E-05_JPRB, 0.10308025E-05_JPRB, 0.10085083E-05_JPRB  /)

RGHG2(:,36, 3) = (/ &
  & 0.15530644E-05_JPRB, 0.15561306E-05_JPRB, 0.15596055E-05_JPRB, 0.15621684E-05_JPRB, 0.15689888E-05_JPRB, 0.15806588E-05_JPRB, &
  & 0.15930468E-05_JPRB, 0.16021926E-05_JPRB, 0.16103255E-05_JPRB, 0.16184756E-05_JPRB, 0.16264711E-05_JPRB, 0.16352837E-05_JPRB, &
  & 0.16455864E-05_JPRB, 0.16570720E-05_JPRB, 0.16681498E-05_JPRB, 0.16784046E-05_JPRB, 0.16875548E-05_JPRB, 0.16962601E-05_JPRB, &
  & 0.17042350E-05_JPRB, 0.17113584E-05_JPRB, 0.17173459E-05_JPRB, 0.17218704E-05_JPRB, 0.17253852E-05_JPRB, 0.17276472E-05_JPRB, &
  & 0.17290313E-05_JPRB, 0.17299145E-05_JPRB, 0.17306744E-05_JPRB, 0.17314438E-05_JPRB, 0.17323721E-05_JPRB, 0.17332805E-05_JPRB, &
  & 0.17330030E-05_JPRB, 0.17306986E-05_JPRB, 0.17280187E-05_JPRB, 0.17262523E-05_JPRB, 0.17255231E-05_JPRB, 0.17250593E-05_JPRB, &
  & 0.17239064E-05_JPRB, 0.17219672E-05_JPRB, 0.17185378E-05_JPRB, 0.17114719E-05_JPRB, 0.16979036E-05_JPRB, 0.16760714E-05_JPRB, &
  & 0.16440723E-05_JPRB, 0.16028418E-05_JPRB, 0.15563636E-05_JPRB, 0.15092398E-05_JPRB, 0.14638649E-05_JPRB, 0.14190956E-05_JPRB, &
  & 0.13806378E-05_JPRB, 0.13491223E-05_JPRB, 0.13211002E-05_JPRB, 0.12929419E-05_JPRB, 0.12642942E-05_JPRB, 0.12386210E-05_JPRB, &
  & 0.12204054E-05_JPRB, 0.12034909E-05_JPRB, 0.11872130E-05_JPRB, 0.11724635E-05_JPRB, 0.11650604E-05_JPRB, 0.11565754E-05_JPRB, &
  & 0.11386846E-05_JPRB, 0.11169650E-05_JPRB, 0.10903814E-05_JPRB, 0.10682517E-05_JPRB  /)

RGHG2(:,37, 3) = (/ &
  & 0.15850453E-05_JPRB, 0.15875084E-05_JPRB, 0.15903389E-05_JPRB, 0.15920771E-05_JPRB, 0.15978717E-05_JPRB, 0.16075057E-05_JPRB, &
  & 0.16178370E-05_JPRB, 0.16255137E-05_JPRB, 0.16323940E-05_JPRB, 0.16395596E-05_JPRB, 0.16467098E-05_JPRB, 0.16542955E-05_JPRB, &
  & 0.16631653E-05_JPRB, 0.16729550E-05_JPRB, 0.16822957E-05_JPRB, 0.16909629E-05_JPRB, 0.16985307E-05_JPRB, 0.17055349E-05_JPRB, &
  & 0.17119171E-05_JPRB, 0.17173342E-05_JPRB, 0.17217754E-05_JPRB, 0.17250473E-05_JPRB, 0.17275363E-05_JPRB, 0.17291076E-05_JPRB, &
  & 0.17300278E-05_JPRB, 0.17304883E-05_JPRB, 0.17308101E-05_JPRB, 0.17313424E-05_JPRB, 0.17319511E-05_JPRB, 0.17327306E-05_JPRB, &
  & 0.17328758E-05_JPRB, 0.17315508E-05_JPRB, 0.17300410E-05_JPRB, 0.17291199E-05_JPRB, 0.17288856E-05_JPRB, 0.17287105E-05_JPRB, &
  & 0.17279595E-05_JPRB, 0.17266904E-05_JPRB, 0.17243074E-05_JPRB, 0.17193034E-05_JPRB, 0.17096371E-05_JPRB, 0.16932173E-05_JPRB, &
  & 0.16676511E-05_JPRB, 0.16326423E-05_JPRB, 0.15913444E-05_JPRB, 0.15482516E-05_JPRB, 0.15061757E-05_JPRB, 0.14635558E-05_JPRB, &
  & 0.14257269E-05_JPRB, 0.13954845E-05_JPRB, 0.13693851E-05_JPRB, 0.13436031E-05_JPRB, 0.13180482E-05_JPRB, 0.12949935E-05_JPRB, &
  & 0.12781748E-05_JPRB, 0.12622654E-05_JPRB, 0.12456886E-05_JPRB, 0.12290679E-05_JPRB, 0.12201700E-05_JPRB, 0.12110767E-05_JPRB, &
  & 0.11948664E-05_JPRB, 0.11753066E-05_JPRB, 0.11518466E-05_JPRB, 0.11307221E-05_JPRB  /)

RGHG2(:,38, 3) = (/ &
  & 0.16205309E-05_JPRB, 0.16223248E-05_JPRB, 0.16244404E-05_JPRB, 0.16252635E-05_JPRB, 0.16299199E-05_JPRB, 0.16372947E-05_JPRB, &
  & 0.16453439E-05_JPRB, 0.16513905E-05_JPRB, 0.16568811E-05_JPRB, 0.16629542E-05_JPRB, 0.16691664E-05_JPRB, 0.16753909E-05_JPRB, &
  & 0.16826706E-05_JPRB, 0.16905786E-05_JPRB, 0.16979918E-05_JPRB, 0.17048975E-05_JPRB, 0.17107093E-05_JPRB, 0.17158261E-05_JPRB, &
  & 0.17204410E-05_JPRB, 0.17239649E-05_JPRB, 0.17266902E-05_JPRB, 0.17285723E-05_JPRB, 0.17299232E-05_JPRB, 0.17307281E-05_JPRB, &
  & 0.17311335E-05_JPRB, 0.17311250E-05_JPRB, 0.17309606E-05_JPRB, 0.17312299E-05_JPRB, 0.17314839E-05_JPRB, 0.17321204E-05_JPRB, &
  & 0.17327347E-05_JPRB, 0.17324964E-05_JPRB, 0.17322848E-05_JPRB, 0.17323018E-05_JPRB, 0.17326165E-05_JPRB, 0.17327617E-05_JPRB, &
  & 0.17324569E-05_JPRB, 0.17319313E-05_JPRB, 0.17307094E-05_JPRB, 0.17279931E-05_JPRB, 0.17226565E-05_JPRB, 0.17122422E-05_JPRB, &
  & 0.16938140E-05_JPRB, 0.16657085E-05_JPRB, 0.16301588E-05_JPRB, 0.15915386E-05_JPRB, 0.15531231E-05_JPRB, 0.15128883E-05_JPRB, &
  & 0.14757572E-05_JPRB, 0.14469275E-05_JPRB, 0.14229614E-05_JPRB, 0.13998161E-05_JPRB, 0.13776930E-05_JPRB, 0.13575438E-05_JPRB, &
  & 0.13422751E-05_JPRB, 0.13274810E-05_JPRB, 0.13105724E-05_JPRB, 0.12918756E-05_JPRB, 0.12813190E-05_JPRB, 0.12715508E-05_JPRB, &
  & 0.12572050E-05_JPRB, 0.12400417E-05_JPRB, 0.12200478E-05_JPRB, 0.12000386E-05_JPRB  /)

RGHG2(:,39, 3) = (/ &
  & 0.16403613E-05_JPRB, 0.16416393E-05_JPRB, 0.16430339E-05_JPRB, 0.16434838E-05_JPRB, 0.16474765E-05_JPRB, 0.16534374E-05_JPRB, &
  & 0.16600905E-05_JPRB, 0.16653042E-05_JPRB, 0.16700035E-05_JPRB, 0.16752847E-05_JPRB, 0.16806808E-05_JPRB, 0.16860559E-05_JPRB, &
  & 0.16922052E-05_JPRB, 0.16987352E-05_JPRB, 0.17048266E-05_JPRB, 0.17104656E-05_JPRB, 0.17152069E-05_JPRB, 0.17192824E-05_JPRB, &
  & 0.17229385E-05_JPRB, 0.17256405E-05_JPRB, 0.17276890E-05_JPRB, 0.17290205E-05_JPRB, 0.17299441E-05_JPRB, 0.17304434E-05_JPRB, &
  & 0.17305020E-05_JPRB, 0.17302222E-05_JPRB, 0.17298790E-05_JPRB, 0.17300749E-05_JPRB, 0.17302095E-05_JPRB, 0.17309622E-05_JPRB, &
  & 0.17318004E-05_JPRB, 0.17318452E-05_JPRB, 0.17318892E-05_JPRB, 0.17321855E-05_JPRB, 0.17326353E-05_JPRB, 0.17328628E-05_JPRB, &
  & 0.17326826E-05_JPRB, 0.17323138E-05_JPRB, 0.17314704E-05_JPRB, 0.17295627E-05_JPRB, 0.17256938E-05_JPRB, 0.17176721E-05_JPRB, &
  & 0.17027500E-05_JPRB, 0.16791401E-05_JPRB, 0.16480105E-05_JPRB, 0.16133273E-05_JPRB, 0.15785355E-05_JPRB, 0.15419925E-05_JPRB, &
  & 0.15073183E-05_JPRB, 0.14808953E-05_JPRB, 0.14599218E-05_JPRB, 0.14401206E-05_JPRB, 0.14207972E-05_JPRB, 0.14030418E-05_JPRB, &
  & 0.13890035E-05_JPRB, 0.13753291E-05_JPRB, 0.13592994E-05_JPRB, 0.13405995E-05_JPRB, 0.13288465E-05_JPRB, 0.13185391E-05_JPRB, &
  & 0.13064742E-05_JPRB, 0.12918687E-05_JPRB, 0.12761082E-05_JPRB, 0.12574840E-05_JPRB  /)

RGHG2(:,40, 3) = (/ &
  & 0.16610727E-05_JPRB, 0.16617704E-05_JPRB, 0.16623179E-05_JPRB, 0.16624185E-05_JPRB, 0.16657097E-05_JPRB, 0.16701496E-05_JPRB, &
  & 0.16753092E-05_JPRB, 0.16796758E-05_JPRB, 0.16835445E-05_JPRB, 0.16879456E-05_JPRB, 0.16924037E-05_JPRB, 0.16968657E-05_JPRB, &
  & 0.17017635E-05_JPRB, 0.17067588E-05_JPRB, 0.17113979E-05_JPRB, 0.17156315E-05_JPRB, 0.17192286E-05_JPRB, 0.17222204E-05_JPRB, &
  & 0.17248836E-05_JPRB, 0.17267963E-05_JPRB, 0.17282204E-05_JPRB, 0.17290430E-05_JPRB, 0.17295816E-05_JPRB, 0.17297976E-05_JPRB, &
  & 0.17294766E-05_JPRB, 0.17289108E-05_JPRB, 0.17284081E-05_JPRB, 0.17285490E-05_JPRB, 0.17285818E-05_JPRB, 0.17295133E-05_JPRB, &
  & 0.17305743E-05_JPRB, 0.17308199E-05_JPRB, 0.17309932E-05_JPRB, 0.17315094E-05_JPRB, 0.17320500E-05_JPRB, 0.17323353E-05_JPRB, &
  & 0.17322485E-05_JPRB, 0.17319678E-05_JPRB, 0.17314407E-05_JPRB, 0.17302399E-05_JPRB, 0.17276251E-05_JPRB, 0.17218203E-05_JPRB, &
  & 0.17104188E-05_JPRB, 0.16916910E-05_JPRB, 0.16655314E-05_JPRB, 0.16353809E-05_JPRB, 0.16048358E-05_JPRB, 0.15728393E-05_JPRB, &
  & 0.15413364E-05_JPRB, 0.15179004E-05_JPRB, 0.15005794E-05_JPRB, 0.14848187E-05_JPRB, 0.14686775E-05_JPRB, 0.14536478E-05_JPRB, &
  & 0.14410013E-05_JPRB, 0.14286415E-05_JPRB, 0.14138413E-05_JPRB, 0.13954769E-05_JPRB, 0.13823955E-05_JPRB, 0.13714775E-05_JPRB, &
  & 0.13621575E-05_JPRB, 0.13505803E-05_JPRB, 0.13399136E-05_JPRB, 0.13229589E-05_JPRB  /)

RGHG2(:,41, 3) = (/ &
  & 0.16863954E-05_JPRB, 0.16863836E-05_JPRB, 0.16858953E-05_JPRB, 0.16855688E-05_JPRB, 0.16880025E-05_JPRB, 0.16905828E-05_JPRB, &
  & 0.16939164E-05_JPRB, 0.16972472E-05_JPRB, 0.17001003E-05_JPRB, 0.17034253E-05_JPRB, 0.17067368E-05_JPRB, 0.17100822E-05_JPRB, &
  & 0.17134500E-05_JPRB, 0.17165689E-05_JPRB, 0.17194324E-05_JPRB, 0.17219475E-05_JPRB, 0.17241458E-05_JPRB, 0.17258126E-05_JPRB, &
  & 0.17272618E-05_JPRB, 0.17282093E-05_JPRB, 0.17288701E-05_JPRB, 0.17290706E-05_JPRB, 0.17291384E-05_JPRB, 0.17290080E-05_JPRB, &
  & 0.17282229E-05_JPRB, 0.17273074E-05_JPRB, 0.17266097E-05_JPRB, 0.17266833E-05_JPRB, 0.17265917E-05_JPRB, 0.17277417E-05_JPRB, &
  & 0.17290752E-05_JPRB, 0.17295662E-05_JPRB, 0.17298976E-05_JPRB, 0.17306829E-05_JPRB, 0.17313344E-05_JPRB, 0.17316903E-05_JPRB, &
  & 0.17317179E-05_JPRB, 0.17315448E-05_JPRB, 0.17314044E-05_JPRB, 0.17310678E-05_JPRB, 0.17299865E-05_JPRB, 0.17268921E-05_JPRB, &
  & 0.17197950E-05_JPRB, 0.17070362E-05_JPRB, 0.16869532E-05_JPRB, 0.16623446E-05_JPRB, 0.16369917E-05_JPRB, 0.16105540E-05_JPRB, &
  & 0.15829284E-05_JPRB, 0.15631444E-05_JPRB, 0.15502893E-05_JPRB, 0.15394685E-05_JPRB, 0.15272181E-05_JPRB, 0.15155210E-05_JPRB, &
  & 0.15045760E-05_JPRB, 0.14938237E-05_JPRB, 0.14805267E-05_JPRB, 0.14625725E-05_JPRB, 0.14478669E-05_JPRB, 0.14362023E-05_JPRB, &
  & 0.14302385E-05_JPRB, 0.14223637E-05_JPRB, 0.14179250E-05_JPRB, 0.14030115E-05_JPRB  /)

RGHG2(:,42, 3) = (/ &
  & 0.16890456E-05_JPRB, 0.16890811E-05_JPRB, 0.16884121E-05_JPRB, 0.16879307E-05_JPRB, 0.16899325E-05_JPRB, 0.16922770E-05_JPRB, &
  & 0.16953117E-05_JPRB, 0.16983964E-05_JPRB, 0.17010921E-05_JPRB, 0.17040118E-05_JPRB, 0.17069077E-05_JPRB, 0.17097834E-05_JPRB, &
  & 0.17128509E-05_JPRB, 0.17157055E-05_JPRB, 0.17183082E-05_JPRB, 0.17206519E-05_JPRB, 0.17226589E-05_JPRB, 0.17242705E-05_JPRB, &
  & 0.17256776E-05_JPRB, 0.17266221E-05_JPRB, 0.17272864E-05_JPRB, 0.17275403E-05_JPRB, 0.17276882E-05_JPRB, 0.17276921E-05_JPRB, &
  & 0.17269985E-05_JPRB, 0.17262333E-05_JPRB, 0.17258130E-05_JPRB, 0.17261183E-05_JPRB, 0.17261581E-05_JPRB, 0.17272705E-05_JPRB, &
  & 0.17284646E-05_JPRB, 0.17289781E-05_JPRB, 0.17293403E-05_JPRB, 0.17301188E-05_JPRB, 0.17308489E-05_JPRB, 0.17313097E-05_JPRB, &
  & 0.17313197E-05_JPRB, 0.17310085E-05_JPRB, 0.17307586E-05_JPRB, 0.17302763E-05_JPRB, 0.17289520E-05_JPRB, 0.17257104E-05_JPRB, &
  & 0.17185472E-05_JPRB, 0.17060464E-05_JPRB, 0.16875596E-05_JPRB, 0.16654173E-05_JPRB, 0.16422302E-05_JPRB, 0.16181053E-05_JPRB, &
  & 0.15943307E-05_JPRB, 0.15773768E-05_JPRB, 0.15660701E-05_JPRB, 0.15572795E-05_JPRB, 0.15478157E-05_JPRB, 0.15381686E-05_JPRB, &
  & 0.15288682E-05_JPRB, 0.15195322E-05_JPRB, 0.15077442E-05_JPRB, 0.14923561E-05_JPRB, 0.14795724E-05_JPRB, 0.14704230E-05_JPRB, &
  & 0.14638004E-05_JPRB, 0.14571831E-05_JPRB, 0.14518551E-05_JPRB, 0.14403966E-05_JPRB  /)

RGHG2(:,43, 3) = (/ &
  & 0.17023562E-05_JPRB, 0.17021296E-05_JPRB, 0.17008503E-05_JPRB, 0.17000438E-05_JPRB, 0.17012827E-05_JPRB, 0.17026121E-05_JPRB, &
  & 0.17045886E-05_JPRB, 0.17070033E-05_JPRB, 0.17091184E-05_JPRB, 0.17112056E-05_JPRB, 0.17132291E-05_JPRB, 0.17151958E-05_JPRB, &
  & 0.17173312E-05_JPRB, 0.17191377E-05_JPRB, 0.17207385E-05_JPRB, 0.17221866E-05_JPRB, 0.17234174E-05_JPRB, 0.17244087E-05_JPRB, &
  & 0.17252552E-05_JPRB, 0.17257817E-05_JPRB, 0.17261209E-05_JPRB, 0.17261559E-05_JPRB, 0.17261745E-05_JPRB, 0.17261518E-05_JPRB, &
  & 0.17253421E-05_JPRB, 0.17245637E-05_JPRB, 0.17243125E-05_JPRB, 0.17248002E-05_JPRB, 0.17249064E-05_JPRB, 0.17260785E-05_JPRB, &
  & 0.17272626E-05_JPRB, 0.17279022E-05_JPRB, 0.17283606E-05_JPRB, 0.17292485E-05_JPRB, 0.17300980E-05_JPRB, 0.17306849E-05_JPRB, &
  & 0.17307281E-05_JPRB, 0.17303373E-05_JPRB, 0.17301537E-05_JPRB, 0.17299103E-05_JPRB, 0.17290238E-05_JPRB, 0.17268139E-05_JPRB, &
  & 0.17214420E-05_JPRB, 0.17117442E-05_JPRB, 0.16973275E-05_JPRB, 0.16798192E-05_JPRB, 0.16608416E-05_JPRB, 0.16412181E-05_JPRB, &
  & 0.16226249E-05_JPRB, 0.16098240E-05_JPRB, 0.16018511E-05_JPRB, 0.15970378E-05_JPRB, 0.15917900E-05_JPRB, 0.15854468E-05_JPRB, &
  & 0.15783789E-05_JPRB, 0.15710265E-05_JPRB, 0.15612620E-05_JPRB, 0.15483917E-05_JPRB, 0.15366628E-05_JPRB, 0.15294871E-05_JPRB, &
  & 0.15237070E-05_JPRB, 0.15198297E-05_JPRB, 0.15163692E-05_JPRB, 0.15089411E-05_JPRB  /)

RGHG2(:,44, 3) = (/ &
  & 0.17055032E-05_JPRB, 0.17053243E-05_JPRB, 0.17041998E-05_JPRB, 0.17032937E-05_JPRB, 0.17042257E-05_JPRB, 0.17053078E-05_JPRB, &
  & 0.17069874E-05_JPRB, 0.17090307E-05_JPRB, 0.17108287E-05_JPRB, 0.17126111E-05_JPRB, 0.17143242E-05_JPRB, 0.17159418E-05_JPRB, &
  & 0.17177148E-05_JPRB, 0.17192133E-05_JPRB, 0.17205210E-05_JPRB, 0.17216583E-05_JPRB, 0.17225524E-05_JPRB, 0.17232839E-05_JPRB, &
  & 0.17239354E-05_JPRB, 0.17243769E-05_JPRB, 0.17247565E-05_JPRB, 0.17248729E-05_JPRB, 0.17250601E-05_JPRB, 0.17251818E-05_JPRB, &
  & 0.17244336E-05_JPRB, 0.17238267E-05_JPRB, 0.17237496E-05_JPRB, 0.17242471E-05_JPRB, 0.17244530E-05_JPRB, 0.17256728E-05_JPRB, &
  & 0.17268352E-05_JPRB, 0.17275293E-05_JPRB, 0.17279857E-05_JPRB, 0.17288428E-05_JPRB, 0.17297748E-05_JPRB, 0.17305077E-05_JPRB, &
  & 0.17305815E-05_JPRB, 0.17302153E-05_JPRB, 0.17300244E-05_JPRB, 0.17296701E-05_JPRB, 0.17288351E-05_JPRB, 0.17267935E-05_JPRB, &
  & 0.17220344E-05_JPRB, 0.17134071E-05_JPRB, 0.17008704E-05_JPRB, 0.16857740E-05_JPRB, 0.16697210E-05_JPRB, 0.16531670E-05_JPRB, &
  & 0.16378549E-05_JPRB, 0.16276421E-05_JPRB, 0.16213251E-05_JPRB, 0.16179393E-05_JPRB, 0.16146925E-05_JPRB, 0.16105686E-05_JPRB, &
  & 0.16050875E-05_JPRB, 0.15991952E-05_JPRB, 0.15910649E-05_JPRB, 0.15799996E-05_JPRB, 0.15701967E-05_JPRB, 0.15646866E-05_JPRB, &
  & 0.15598916E-05_JPRB, 0.15563918E-05_JPRB, 0.15530742E-05_JPRB, 0.15476219E-05_JPRB  /)

RGHG2(:,45, 3) = (/ &
  & 0.17107673E-05_JPRB, 0.17106095E-05_JPRB, 0.17095842E-05_JPRB, 0.17085236E-05_JPRB, 0.17090100E-05_JPRB, 0.17096821E-05_JPRB, &
  & 0.17108901E-05_JPRB, 0.17124259E-05_JPRB, 0.17137897E-05_JPRB, 0.17151199E-05_JPRB, 0.17163695E-05_JPRB, 0.17174747E-05_JPRB, &
  & 0.17187175E-05_JPRB, 0.17197329E-05_JPRB, 0.17205803E-05_JPRB, 0.17212508E-05_JPRB, 0.17216635E-05_JPRB, 0.17220209E-05_JPRB, &
  & 0.17223797E-05_JPRB, 0.17226715E-05_JPRB, 0.17230560E-05_JPRB, 0.17232374E-05_JPRB, 0.17236003E-05_JPRB, 0.17238830E-05_JPRB, &
  & 0.17231901E-05_JPRB, 0.17227767E-05_JPRB, 0.17229192E-05_JPRB, 0.17234509E-05_JPRB, 0.17237788E-05_JPRB, 0.17250604E-05_JPRB, &
  & 0.17261967E-05_JPRB, 0.17269689E-05_JPRB, 0.17274350E-05_JPRB, 0.17282711E-05_JPRB, 0.17293120E-05_JPRB, 0.17302271E-05_JPRB, &
  & 0.17303399E-05_JPRB, 0.17299916E-05_JPRB, 0.17298007E-05_JPRB, 0.17293504E-05_JPRB, 0.17286293E-05_JPRB, 0.17269098E-05_JPRB, &
  & 0.17230744E-05_JPRB, 0.17160200E-05_JPRB, 0.17061377E-05_JPRB, 0.16943724E-05_JPRB, 0.16821807E-05_JPRB, 0.16696896E-05_JPRB, &
  & 0.16587674E-05_JPRB, 0.16520255E-05_JPRB, 0.16480149E-05_JPRB, 0.16467564E-05_JPRB, 0.16463203E-05_JPRB, 0.16451403E-05_JPRB, &
  & 0.16417476E-05_JPRB, 0.16377680E-05_JPRB, 0.16317538E-05_JPRB, 0.16230616E-05_JPRB, 0.16155846E-05_JPRB, 0.16122197E-05_JPRB, &
  & 0.16086528E-05_JPRB, 0.16059288E-05_JPRB, 0.16030096E-05_JPRB, 0.16003159E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART6',0,ZHOOK_HANDLE)



RGHG2(:,46, 3) = (/ &
  & 0.17122513E-05_JPRB, 0.17121458E-05_JPRB, 0.17112995E-05_JPRB, 0.17103632E-05_JPRB, 0.17106697E-05_JPRB, 0.17112183E-05_JPRB, &
  & 0.17122340E-05_JPRB, 0.17134724E-05_JPRB, 0.17145675E-05_JPRB, 0.17156332E-05_JPRB, 0.17166024E-05_JPRB, 0.17174133E-05_JPRB, &
  & 0.17183248E-05_JPRB, 0.17190311E-05_JPRB, 0.17195951E-05_JPRB, 0.17199614E-05_JPRB, 0.17200972E-05_JPRB, 0.17202956E-05_JPRB, &
  & 0.17205467E-05_JPRB, 0.17208618E-05_JPRB, 0.17213942E-05_JPRB, 0.17218006E-05_JPRB, 0.17223879E-05_JPRB, 0.17229289E-05_JPRB, &
  & 0.17223628E-05_JPRB, 0.17221259E-05_JPRB, 0.17224159E-05_JPRB, 0.17230178E-05_JPRB, 0.17234623E-05_JPRB, 0.17247909E-05_JPRB, &
  & 0.17259674E-05_JPRB, 0.17267130E-05_JPRB, 0.17271292E-05_JPRB, 0.17279767E-05_JPRB, 0.17290549E-05_JPRB, 0.17299963E-05_JPRB, &
  & 0.17302569E-05_JPRB, 0.17299848E-05_JPRB, 0.17297787E-05_JPRB, 0.17292661E-05_JPRB, 0.17285417E-05_JPRB, 0.17270063E-05_JPRB, &
  & 0.17237974E-05_JPRB, 0.17179341E-05_JPRB, 0.17099310E-05_JPRB, 0.17006127E-05_JPRB, 0.16913786E-05_JPRB, 0.16821431E-05_JPRB, &
  & 0.16744583E-05_JPRB, 0.16700592E-05_JPRB, 0.16677556E-05_JPRB, 0.16674894E-05_JPRB, 0.16680907E-05_JPRB, 0.16681944E-05_JPRB, &
  & 0.16659968E-05_JPRB, 0.16633119E-05_JPRB, 0.16589913E-05_JPRB, 0.16525669E-05_JPRB, 0.16467790E-05_JPRB, 0.16442564E-05_JPRB, &
  & 0.16416971E-05_JPRB, 0.16397344E-05_JPRB, 0.16375342E-05_JPRB, 0.16360508E-05_JPRB  /)

RGHG2(:,47, 3) = (/ &
  & 0.17132354E-05_JPRB, 0.17131976E-05_JPRB, 0.17125771E-05_JPRB, 0.17118426E-05_JPRB, 0.17119914E-05_JPRB, 0.17124523E-05_JPRB, &
  & 0.17132985E-05_JPRB, 0.17142298E-05_JPRB, 0.17150429E-05_JPRB, 0.17158359E-05_JPRB, 0.17165127E-05_JPRB, 0.17170220E-05_JPRB, &
  & 0.17175845E-05_JPRB, 0.17179630E-05_JPRB, 0.17182298E-05_JPRB, 0.17182715E-05_JPRB, 0.17181237E-05_JPRB, 0.17181786E-05_JPRB, &
  & 0.17183404E-05_JPRB, 0.17187174E-05_JPRB, 0.17194520E-05_JPRB, 0.17201544E-05_JPRB, 0.17210149E-05_JPRB, 0.17218783E-05_JPRB, &
  & 0.17214753E-05_JPRB, 0.17214423E-05_JPRB, 0.17218908E-05_JPRB, 0.17225824E-05_JPRB, 0.17231627E-05_JPRB, 0.17245435E-05_JPRB, &
  & 0.17257803E-05_JPRB, 0.17264737E-05_JPRB, 0.17268194E-05_JPRB, 0.17276869E-05_JPRB, 0.17287944E-05_JPRB, 0.17297353E-05_JPRB, &
  & 0.17301913E-05_JPRB, 0.17300203E-05_JPRB, 0.17297934E-05_JPRB, 0.17292144E-05_JPRB, 0.17284626E-05_JPRB, 0.17271155E-05_JPRB, &
  & 0.17245822E-05_JPRB, 0.17200401E-05_JPRB, 0.17140868E-05_JPRB, 0.17074628E-05_JPRB, 0.17015182E-05_JPRB, 0.16959412E-05_JPRB, &
  & 0.16918244E-05_JPRB, 0.16899484E-05_JPRB, 0.16895279E-05_JPRB, 0.16901985E-05_JPRB, 0.16916620E-05_JPRB, 0.16929394E-05_JPRB, &
  & 0.16919652E-05_JPRB, 0.16906758E-05_JPRB, 0.16882578E-05_JPRB, 0.16844735E-05_JPRB, 0.16805402E-05_JPRB, 0.16787448E-05_JPRB, &
  & 0.16773238E-05_JPRB, 0.16762514E-05_JPRB, 0.16749591E-05_JPRB, 0.16745858E-05_JPRB  /)

RGHG2(:,48, 3) = (/ &
  & 0.17133254E-05_JPRB, 0.17133223E-05_JPRB, 0.17128893E-05_JPRB, 0.17123473E-05_JPRB, 0.17124260E-05_JPRB, 0.17128109E-05_JPRB, &
  & 0.17135005E-05_JPRB, 0.17141923E-05_JPRB, 0.17147271E-05_JPRB, 0.17152598E-05_JPRB, 0.17156676E-05_JPRB, 0.17158870E-05_JPRB, &
  & 0.17161373E-05_JPRB, 0.17162418E-05_JPRB, 0.17162798E-05_JPRB, 0.17161122E-05_JPRB, 0.17158417E-05_JPRB, 0.17159237E-05_JPRB, &
  & 0.17161755E-05_JPRB, 0.17167147E-05_JPRB, 0.17176863E-05_JPRB, 0.17186903E-05_JPRB, 0.17198490E-05_JPRB, 0.17210038E-05_JPRB, &
  & 0.17208074E-05_JPRB, 0.17209617E-05_JPRB, 0.17215809E-05_JPRB, 0.17223292E-05_JPRB, 0.17230265E-05_JPRB, 0.17244930E-05_JPRB, &
  & 0.17257295E-05_JPRB, 0.17264013E-05_JPRB, 0.17266637E-05_JPRB, 0.17275215E-05_JPRB, 0.17286438E-05_JPRB, 0.17295139E-05_JPRB, &
  & 0.17300379E-05_JPRB, 0.17300127E-05_JPRB, 0.17298135E-05_JPRB, 0.17292346E-05_JPRB, 0.17285494E-05_JPRB, 0.17273915E-05_JPRB, &
  & 0.17254048E-05_JPRB, 0.17220394E-05_JPRB, 0.17178320E-05_JPRB, 0.17135185E-05_JPRB, 0.17101803E-05_JPRB, 0.17073508E-05_JPRB, &
  & 0.17058054E-05_JPRB, 0.17056181E-05_JPRB, 0.17063359E-05_JPRB, 0.17076556E-05_JPRB, 0.17094429E-05_JPRB, 0.17111579E-05_JPRB, &
  & 0.17109149E-05_JPRB, 0.17104962E-05_JPRB, 0.17093973E-05_JPRB, 0.17075738E-05_JPRB, 0.17050620E-05_JPRB, 0.17036929E-05_JPRB, &
  & 0.17027660E-05_JPRB, 0.17024609E-05_JPRB, 0.17020065E-05_JPRB, 0.17022325E-05_JPRB  /)

RGHG2(:,49, 3) = (/ &
  & 0.17130186E-05_JPRB, 0.17130389E-05_JPRB, 0.17127960E-05_JPRB, 0.17124631E-05_JPRB, 0.17125038E-05_JPRB, 0.17128099E-05_JPRB, &
  & 0.17133321E-05_JPRB, 0.17137892E-05_JPRB, 0.17140177E-05_JPRB, 0.17142678E-05_JPRB, 0.17143881E-05_JPRB, 0.17142921E-05_JPRB, &
  & 0.17142133E-05_JPRB, 0.17140387E-05_JPRB, 0.17138546E-05_JPRB, 0.17135075E-05_JPRB, 0.17131744E-05_JPRB, 0.17133640E-05_JPRB, &
  & 0.17137969E-05_JPRB, 0.17145612E-05_JPRB, 0.17158110E-05_JPRB, 0.17171517E-05_JPRB, 0.17186520E-05_JPRB, 0.17201153E-05_JPRB, &
  & 0.17201677E-05_JPRB, 0.17205218E-05_JPRB, 0.17213356E-05_JPRB, 0.17221315E-05_JPRB, 0.17229500E-05_JPRB, 0.17245268E-05_JPRB, &
  & 0.17257352E-05_JPRB, 0.17263970E-05_JPRB, 0.17265615E-05_JPRB, 0.17273950E-05_JPRB, 0.17285269E-05_JPRB, 0.17292865E-05_JPRB, &
  & 0.17298281E-05_JPRB, 0.17299847E-05_JPRB, 0.17298383E-05_JPRB, 0.17292896E-05_JPRB, 0.17287210E-05_JPRB, 0.17277729E-05_JPRB, &
  & 0.17263331E-05_JPRB, 0.17242049E-05_JPRB, 0.17217926E-05_JPRB, 0.17198634E-05_JPRB, 0.17191009E-05_JPRB, 0.17188998E-05_JPRB, &
  & 0.17197489E-05_JPRB, 0.17210524E-05_JPRB, 0.17226921E-05_JPRB, 0.17245999E-05_JPRB, 0.17265007E-05_JPRB, 0.17283658E-05_JPRB, &
  & 0.17287087E-05_JPRB, 0.17290155E-05_JPRB, 0.17291122E-05_JPRB, 0.17291513E-05_JPRB, 0.17280168E-05_JPRB, 0.17269829E-05_JPRB, &
  & 0.17263104E-05_JPRB, 0.17267990E-05_JPRB, 0.17272405E-05_JPRB, 0.17278982E-05_JPRB  /)

RGHG2(:,50, 3) = (/ &
  & 0.17120025E-05_JPRB, 0.17119815E-05_JPRB, 0.17118121E-05_JPRB, 0.17116110E-05_JPRB, 0.17116257E-05_JPRB, 0.17118177E-05_JPRB, &
  & 0.17121694E-05_JPRB, 0.17124370E-05_JPRB, 0.17124328E-05_JPRB, 0.17124872E-05_JPRB, 0.17124194E-05_JPRB, 0.17121392E-05_JPRB, &
  & 0.17118844E-05_JPRB, 0.17116193E-05_JPRB, 0.17113653E-05_JPRB, 0.17109962E-05_JPRB, 0.17107595E-05_JPRB, 0.17111160E-05_JPRB, &
  & 0.17117404E-05_JPRB, 0.17127398E-05_JPRB, 0.17141935E-05_JPRB, 0.17158312E-05_JPRB, 0.17176503E-05_JPRB, 0.17193857E-05_JPRB, &
  & 0.17197173E-05_JPRB, 0.17202429E-05_JPRB, 0.17212111E-05_JPRB, 0.17220624E-05_JPRB, 0.17229644E-05_JPRB, 0.17246573E-05_JPRB, &
  & 0.17258133E-05_JPRB, 0.17264560E-05_JPRB, 0.17266192E-05_JPRB, 0.17273418E-05_JPRB, 0.17284009E-05_JPRB, 0.17290964E-05_JPRB, &
  & 0.17296479E-05_JPRB, 0.17299470E-05_JPRB, 0.17298621E-05_JPRB, 0.17293882E-05_JPRB, 0.17289536E-05_JPRB, 0.17282635E-05_JPRB, &
  & 0.17274170E-05_JPRB, 0.17262753E-05_JPRB, 0.17252777E-05_JPRB, 0.17252216E-05_JPRB, 0.17263540E-05_JPRB, 0.17279784E-05_JPRB, &
  & 0.17302705E-05_JPRB, 0.17324912E-05_JPRB, 0.17347195E-05_JPRB, 0.17369584E-05_JPRB, 0.17389664E-05_JPRB, 0.17409111E-05_JPRB, &
  & 0.17416901E-05_JPRB, 0.17425629E-05_JPRB, 0.17432745E-05_JPRB, 0.17443960E-05_JPRB, 0.17441952E-05_JPRB, 0.17434457E-05_JPRB, &
  & 0.17429679E-05_JPRB, 0.17439447E-05_JPRB, 0.17449403E-05_JPRB, 0.17456905E-05_JPRB  /)

RGHG2(:,51, 3) = (/ &
  & 0.17105306E-05_JPRB, 0.17104310E-05_JPRB, 0.17102797E-05_JPRB, 0.17101806E-05_JPRB, 0.17101732E-05_JPRB, 0.17102234E-05_JPRB, &
  & 0.17103889E-05_JPRB, 0.17104757E-05_JPRB, 0.17102581E-05_JPRB, 0.17101466E-05_JPRB, 0.17099277E-05_JPRB, 0.17095172E-05_JPRB, &
  & 0.17091525E-05_JPRB, 0.17088887E-05_JPRB, 0.17086390E-05_JPRB, 0.17083289E-05_JPRB, 0.17082799E-05_JPRB, 0.17088485E-05_JPRB, &
  & 0.17096853E-05_JPRB, 0.17109443E-05_JPRB, 0.17125794E-05_JPRB, 0.17145175E-05_JPRB, 0.17166694E-05_JPRB, 0.17186800E-05_JPRB, &
  & 0.17193296E-05_JPRB, 0.17200258E-05_JPRB, 0.17211400E-05_JPRB, 0.17220551E-05_JPRB, 0.17230277E-05_JPRB, 0.17248493E-05_JPRB, &
  & 0.17259358E-05_JPRB, 0.17265532E-05_JPRB, 0.17267658E-05_JPRB, 0.17273227E-05_JPRB, 0.17282599E-05_JPRB, 0.17289104E-05_JPRB, &
  & 0.17294684E-05_JPRB, 0.17299010E-05_JPRB, 0.17298874E-05_JPRB, 0.17295178E-05_JPRB, 0.17292372E-05_JPRB, 0.17288515E-05_JPRB, &
  & 0.17286711E-05_JPRB, 0.17284647E-05_JPRB, 0.17287974E-05_JPRB, 0.17304984E-05_JPRB, 0.17333228E-05_JPRB, 0.17364996E-05_JPRB, &
  & 0.17398525E-05_JPRB, 0.17427637E-05_JPRB, 0.17454533E-05_JPRB, 0.17479154E-05_JPRB, 0.17500359E-05_JPRB, 0.17520298E-05_JPRB, &
  & 0.17532014E-05_JPRB, 0.17546027E-05_JPRB, 0.17556742E-05_JPRB, 0.17575564E-05_JPRB, 0.17581323E-05_JPRB, 0.17576638E-05_JPRB, &
  & 0.17573652E-05_JPRB, 0.17587096E-05_JPRB, 0.17601245E-05_JPRB, 0.17607968E-05_JPRB  /)

RGHG2(:,52, 3) = (/ &
  & 0.17085382E-05_JPRB, 0.17083505E-05_JPRB, 0.17081839E-05_JPRB, 0.17081403E-05_JPRB, 0.17080839E-05_JPRB, 0.17079513E-05_JPRB, &
  & 0.17079417E-05_JPRB, 0.17079105E-05_JPRB, 0.17075953E-05_JPRB, 0.17074581E-05_JPRB, 0.17072234E-05_JPRB, 0.17068503E-05_JPRB, &
  & 0.17065401E-05_JPRB, 0.17063706E-05_JPRB, 0.17062334E-05_JPRB, 0.17061009E-05_JPRB, 0.17062630E-05_JPRB, 0.17070333E-05_JPRB, &
  & 0.17080576E-05_JPRB, 0.17095378E-05_JPRB, 0.17113335E-05_JPRB, 0.17134696E-05_JPRB, 0.17159012E-05_JPRB, 0.17181188E-05_JPRB, &
  & 0.17191562E-05_JPRB, 0.17199614E-05_JPRB, 0.17211413E-05_JPRB, 0.17221594E-05_JPRB, 0.17231417E-05_JPRB, 0.17250501E-05_JPRB, &
  & 0.17261448E-05_JPRB, 0.17266873E-05_JPRB, 0.17270167E-05_JPRB, 0.17274502E-05_JPRB, 0.17282260E-05_JPRB, 0.17288235E-05_JPRB, &
  & 0.17294257E-05_JPRB, 0.17299352E-05_JPRB, 0.17298794E-05_JPRB, 0.17295964E-05_JPRB, 0.17293987E-05_JPRB, 0.17293047E-05_JPRB, &
  & 0.17297543E-05_JPRB, 0.17302466E-05_JPRB, 0.17314597E-05_JPRB, 0.17344294E-05_JPRB, 0.17384015E-05_JPRB, 0.17425550E-05_JPRB, &
  & 0.17464271E-05_JPRB, 0.17497727E-05_JPRB, 0.17527755E-05_JPRB, 0.17553935E-05_JPRB, 0.17577011E-05_JPRB, 0.17598718E-05_JPRB, &
  & 0.17613356E-05_JPRB, 0.17630275E-05_JPRB, 0.17642443E-05_JPRB, 0.17663570E-05_JPRB, 0.17674017E-05_JPRB, 0.17672832E-05_JPRB, &
  & 0.17672836E-05_JPRB, 0.17687960E-05_JPRB, 0.17703529E-05_JPRB, 0.17711106E-05_JPRB  /)

RGHG2(:,53, 3) = (/ &
  & 0.17061683E-05_JPRB, 0.17058809E-05_JPRB, 0.17056849E-05_JPRB, 0.17056837E-05_JPRB, 0.17055637E-05_JPRB, 0.17052161E-05_JPRB, &
  & 0.17050202E-05_JPRB, 0.17048848E-05_JPRB, 0.17045078E-05_JPRB, 0.17043964E-05_JPRB, 0.17041968E-05_JPRB, 0.17039288E-05_JPRB, &
  & 0.17037413E-05_JPRB, 0.17037101E-05_JPRB, 0.17037372E-05_JPRB, 0.17038435E-05_JPRB, 0.17042445E-05_JPRB, 0.17052307E-05_JPRB, &
  & 0.17064496E-05_JPRB, 0.17081558E-05_JPRB, 0.17101184E-05_JPRB, 0.17124307E-05_JPRB, 0.17151464E-05_JPRB, 0.17175633E-05_JPRB, &
  & 0.17190498E-05_JPRB, 0.17199501E-05_JPRB, 0.17211705E-05_JPRB, 0.17223159E-05_JPRB, 0.17232853E-05_JPRB, 0.17252721E-05_JPRB, &
  & 0.17264055E-05_JPRB, 0.17268475E-05_JPRB, 0.17273300E-05_JPRB, 0.17276455E-05_JPRB, 0.17282304E-05_JPRB, 0.17287669E-05_JPRB, &
  & 0.17294319E-05_JPRB, 0.17300031E-05_JPRB, 0.17298579E-05_JPRB, 0.17296626E-05_JPRB, 0.17295275E-05_JPRB, 0.17297462E-05_JPRB, &
  & 0.17308683E-05_JPRB, 0.17320302E-05_JPRB, 0.17340292E-05_JPRB, 0.17381925E-05_JPRB, 0.17432050E-05_JPRB, 0.17482007E-05_JPRB, &
  & 0.17524297E-05_JPRB, 0.17561498E-05_JPRB, 0.17594367E-05_JPRB, 0.17621986E-05_JPRB, 0.17647387E-05_JPRB, 0.17671510E-05_JPRB, &
  & 0.17688943E-05_JPRB, 0.17708112E-05_JPRB, 0.17721037E-05_JPRB, 0.17742634E-05_JPRB, 0.17757001E-05_JPRB, 0.17759894E-05_JPRB, &
  & 0.17763615E-05_JPRB, 0.17779799E-05_JPRB, 0.17795848E-05_JPRB, 0.17804983E-05_JPRB  /)

RGHG2(:,54, 3) = (/ &
  & 0.17034891E-05_JPRB, 0.17031272E-05_JPRB, 0.17029612E-05_JPRB, 0.17030063E-05_JPRB, 0.17028029E-05_JPRB, 0.17022580E-05_JPRB, &
  & 0.17019034E-05_JPRB, 0.17017371E-05_JPRB, 0.17013859E-05_JPRB, 0.17014408E-05_JPRB, 0.17013760E-05_JPRB, 0.17013055E-05_JPRB, &
  & 0.17013316E-05_JPRB, 0.17015063E-05_JPRB, 0.17017323E-05_JPRB, 0.17021057E-05_JPRB, 0.17027200E-05_JPRB, 0.17038942E-05_JPRB, &
  & 0.17052703E-05_JPRB, 0.17071466E-05_JPRB, 0.17092304E-05_JPRB, 0.17116530E-05_JPRB, 0.17145370E-05_JPRB, 0.17171330E-05_JPRB, &
  & 0.17190123E-05_JPRB, 0.17201240E-05_JPRB, 0.17213377E-05_JPRB, 0.17225756E-05_JPRB, 0.17234780E-05_JPRB, 0.17254100E-05_JPRB, &
  & 0.17266194E-05_JPRB, 0.17270286E-05_JPRB, 0.17275503E-05_JPRB, 0.17278184E-05_JPRB, 0.17283468E-05_JPRB, 0.17288310E-05_JPRB, &
  & 0.17295714E-05_JPRB, 0.17299881E-05_JPRB, 0.17296770E-05_JPRB, 0.17295336E-05_JPRB, 0.17295884E-05_JPRB, 0.17301309E-05_JPRB, &
  & 0.17316497E-05_JPRB, 0.17331978E-05_JPRB, 0.17357943E-05_JPRB, 0.17407113E-05_JPRB, 0.17463744E-05_JPRB, 0.17518046E-05_JPRB, &
  & 0.17562168E-05_JPRB, 0.17601607E-05_JPRB, 0.17636302E-05_JPRB, 0.17665842E-05_JPRB, 0.17693187E-05_JPRB, 0.17718325E-05_JPRB, &
  & 0.17737026E-05_JPRB, 0.17757169E-05_JPRB, 0.17769771E-05_JPRB, 0.17791173E-05_JPRB, 0.17808404E-05_JPRB, 0.17814612E-05_JPRB, &
  & 0.17820741E-05_JPRB, 0.17836959E-05_JPRB, 0.17852348E-05_JPRB, 0.17862392E-05_JPRB  /)

RGHG2(:,55, 3) = (/ &
  & 0.17004805E-05_JPRB, 0.17000393E-05_JPRB, 0.16999144E-05_JPRB, 0.17000114E-05_JPRB, 0.16997131E-05_JPRB, 0.16989519E-05_JPRB, &
  & 0.16984250E-05_JPRB, 0.16982343E-05_JPRB, 0.16979232E-05_JPRB, 0.16981806E-05_JPRB, 0.16982783E-05_JPRB, 0.16984388E-05_JPRB, &
  & 0.16987135E-05_JPRB, 0.16991250E-05_JPRB, 0.16995761E-05_JPRB, 0.17002490E-05_JPRB, 0.17010962E-05_JPRB, 0.17024749E-05_JPRB, &
  & 0.17040204E-05_JPRB, 0.17060777E-05_JPRB, 0.17082897E-05_JPRB, 0.17108258E-05_JPRB, 0.17138811E-05_JPRB, 0.17166728E-05_JPRB, &
  & 0.17189798E-05_JPRB, 0.17203411E-05_JPRB, 0.17215411E-05_JPRB, 0.17228769E-05_JPRB, 0.17236981E-05_JPRB, 0.17255518E-05_JPRB, &
  & 0.17268502E-05_JPRB, 0.17272320E-05_JPRB, 0.17277821E-05_JPRB, 0.17280071E-05_JPRB, 0.17284904E-05_JPRB, 0.17289180E-05_JPRB, &
  & 0.17297434E-05_JPRB, 0.17299605E-05_JPRB, 0.17294556E-05_JPRB, 0.17293651E-05_JPRB, 0.17296470E-05_JPRB, 0.17305496E-05_JPRB, &
  & 0.17324716E-05_JPRB, 0.17344102E-05_JPRB, 0.17376439E-05_JPRB, 0.17433379E-05_JPRB, 0.17496704E-05_JPRB, 0.17555282E-05_JPRB, &
  & 0.17601205E-05_JPRB, 0.17642925E-05_JPRB, 0.17679508E-05_JPRB, 0.17711240E-05_JPRB, 0.17740690E-05_JPRB, 0.17766768E-05_JPRB, &
  & 0.17786672E-05_JPRB, 0.17807725E-05_JPRB, 0.17819828E-05_JPRB, 0.17840927E-05_JPRB, 0.17861192E-05_JPRB, 0.17870972E-05_JPRB, &
  & 0.17879597E-05_JPRB, 0.17895717E-05_JPRB, 0.17910225E-05_JPRB, 0.17921189E-05_JPRB  /)

RGHG2(:,56, 3) = (/ &
  & 0.16974797E-05_JPRB, 0.16970651E-05_JPRB, 0.16969810E-05_JPRB, 0.16971363E-05_JPRB, 0.16968332E-05_JPRB, 0.16960279E-05_JPRB, &
  & 0.16954630E-05_JPRB, 0.16952774E-05_JPRB, 0.16950679E-05_JPRB, 0.16955309E-05_JPRB, 0.16958110E-05_JPRB, 0.16962018E-05_JPRB, &
  & 0.16967380E-05_JPRB, 0.16973811E-05_JPRB, 0.16980413E-05_JPRB, 0.16989285E-05_JPRB, 0.16999598E-05_JPRB, 0.17014572E-05_JPRB, &
  & 0.17031153E-05_JPRB, 0.17052753E-05_JPRB, 0.17075831E-05_JPRB, 0.17101960E-05_JPRB, 0.17132707E-05_JPRB, 0.17161810E-05_JPRB, &
  & 0.17187471E-05_JPRB, 0.17203718E-05_JPRB, 0.17217261E-05_JPRB, 0.17231081E-05_JPRB, 0.17239258E-05_JPRB, 0.17256514E-05_JPRB, &
  & 0.17270213E-05_JPRB, 0.17273689E-05_JPRB, 0.17277587E-05_JPRB, 0.17279599E-05_JPRB, 0.17285940E-05_JPRB, 0.17290035E-05_JPRB, &
  & 0.17297515E-05_JPRB, 0.17298828E-05_JPRB, 0.17293102E-05_JPRB, 0.17292005E-05_JPRB, 0.17297330E-05_JPRB, 0.17308821E-05_JPRB, &
  & 0.17328865E-05_JPRB, 0.17350981E-05_JPRB, 0.17387934E-05_JPRB, 0.17449661E-05_JPRB, 0.17516883E-05_JPRB, 0.17577122E-05_JPRB, &
  & 0.17623875E-05_JPRB, 0.17666961E-05_JPRB, 0.17705053E-05_JPRB, 0.17738351E-05_JPRB, 0.17767945E-05_JPRB, 0.17794334E-05_JPRB, &
  & 0.17814443E-05_JPRB, 0.17835226E-05_JPRB, 0.17848091E-05_JPRB, 0.17869980E-05_JPRB, 0.17892186E-05_JPRB, 0.17903327E-05_JPRB, &
  & 0.17913114E-05_JPRB, 0.17928118E-05_JPRB, 0.17942558E-05_JPRB, 0.17951380E-05_JPRB  /)

RGHG2(:,57, 3) = (/ &
  & 0.16944374E-05_JPRB, 0.16940590E-05_JPRB, 0.16940150E-05_JPRB, 0.16942243E-05_JPRB, 0.16939310E-05_JPRB, 0.16931090E-05_JPRB, &
  & 0.16925153E-05_JPRB, 0.16923550E-05_JPRB, 0.16922466E-05_JPRB, 0.16928963E-05_JPRB, 0.16933588E-05_JPRB, 0.16939696E-05_JPRB, &
  & 0.16947544E-05_JPRB, 0.16956188E-05_JPRB, 0.16964848E-05_JPRB, 0.16975789E-05_JPRB, 0.16987792E-05_JPRB, 0.17003938E-05_JPRB, &
  & 0.17021562E-05_JPRB, 0.17043915E-05_JPRB, 0.17067991E-05_JPRB, 0.17094826E-05_JPRB, 0.17125799E-05_JPRB, 0.17156000E-05_JPRB, &
  & 0.17184509E-05_JPRB, 0.17203348E-05_JPRB, 0.17218431E-05_JPRB, 0.17232783E-05_JPRB, 0.17241256E-05_JPRB, 0.17257593E-05_JPRB, &
  & 0.17271779E-05_JPRB, 0.17274493E-05_JPRB, 0.17276733E-05_JPRB, 0.17279192E-05_JPRB, 0.17286253E-05_JPRB, 0.17290515E-05_JPRB, &
  & 0.17296991E-05_JPRB, 0.17297211E-05_JPRB, 0.17291267E-05_JPRB, 0.17291068E-05_JPRB, 0.17298204E-05_JPRB, 0.17311522E-05_JPRB, &
  & 0.17332828E-05_JPRB, 0.17358346E-05_JPRB, 0.17400081E-05_JPRB, 0.17466964E-05_JPRB, 0.17537787E-05_JPRB, 0.17599787E-05_JPRB, &
  & 0.17647479E-05_JPRB, 0.17692094E-05_JPRB, 0.17731756E-05_JPRB, 0.17766474E-05_JPRB, 0.17796373E-05_JPRB, 0.17823203E-05_JPRB, &
  & 0.17843688E-05_JPRB, 0.17864073E-05_JPRB, 0.17877910E-05_JPRB, 0.17900863E-05_JPRB, 0.17924692E-05_JPRB, 0.17937053E-05_JPRB, &
  & 0.17947850E-05_JPRB, 0.17962151E-05_JPRB, 0.17976321E-05_JPRB, 0.17983295E-05_JPRB  /)

RGHG2(:,58, 3) = (/ &
  & 0.16915714E-05_JPRB, 0.16912620E-05_JPRB, 0.16912536E-05_JPRB, 0.16915066E-05_JPRB, 0.16912641E-05_JPRB, 0.16905051E-05_JPRB, &
  & 0.16899255E-05_JPRB, 0.16898283E-05_JPRB, 0.16898235E-05_JPRB, 0.16906133E-05_JPRB, 0.16912475E-05_JPRB, 0.16920433E-05_JPRB, &
  & 0.16930373E-05_JPRB, 0.16940865E-05_JPRB, 0.16951334E-05_JPRB, 0.16963890E-05_JPRB, 0.16977102E-05_JPRB, 0.16994142E-05_JPRB, &
  & 0.17012477E-05_JPRB, 0.17034912E-05_JPRB, 0.17059912E-05_JPRB, 0.17087224E-05_JPRB, 0.17118177E-05_JPRB, 0.17149089E-05_JPRB, &
  & 0.17180341E-05_JPRB, 0.17201517E-05_JPRB, 0.17218326E-05_JPRB, 0.17233186E-05_JPRB, 0.17242634E-05_JPRB, 0.17258647E-05_JPRB, &
  & 0.17272862E-05_JPRB, 0.17274154E-05_JPRB, 0.17274424E-05_JPRB, 0.17278488E-05_JPRB, 0.17285244E-05_JPRB, 0.17290319E-05_JPRB, &
  & 0.17295180E-05_JPRB, 0.17294211E-05_JPRB, 0.17289079E-05_JPRB, 0.17291410E-05_JPRB, 0.17299085E-05_JPRB, 0.17312788E-05_JPRB, &
  & 0.17335395E-05_JPRB, 0.17364956E-05_JPRB, 0.17411039E-05_JPRB, 0.17482727E-05_JPRB, 0.17555835E-05_JPRB, 0.17619136E-05_JPRB, &
  & 0.17667691E-05_JPRB, 0.17713820E-05_JPRB, 0.17754955E-05_JPRB, 0.17790617E-05_JPRB, 0.17820699E-05_JPRB, 0.17848037E-05_JPRB, &
  & 0.17868970E-05_JPRB, 0.17888552E-05_JPRB, 0.17903872E-05_JPRB, 0.17928471E-05_JPRB, 0.17953051E-05_JPRB, 0.17965879E-05_JPRB, &
  & 0.17977104E-05_JPRB, 0.17991262E-05_JPRB, 0.18004996E-05_JPRB, 0.18010191E-05_JPRB  /)

RGHG2(:,59, 3) = (/ &
  & 0.16892219E-05_JPRB, 0.16889635E-05_JPRB, 0.16889888E-05_JPRB, 0.16892632E-05_JPRB, 0.16890596E-05_JPRB, 0.16883943E-05_JPRB, &
  & 0.16878655E-05_JPRB, 0.16878352E-05_JPRB, 0.16879023E-05_JPRB, 0.16887743E-05_JPRB, 0.16895501E-05_JPRB, 0.16904717E-05_JPRB, &
  & 0.16916116E-05_JPRB, 0.16927914E-05_JPRB, 0.16939884E-05_JPRB, 0.16953691E-05_JPRB, 0.16967694E-05_JPRB, 0.16985167E-05_JPRB, &
  & 0.17003717E-05_JPRB, 0.17025525E-05_JPRB, 0.17050949E-05_JPRB, 0.17078091E-05_JPRB, 0.17109181E-05_JPRB, 0.17140687E-05_JPRB, &
  & 0.17173410E-05_JPRB, 0.17196417E-05_JPRB, 0.17215497E-05_JPRB, 0.17231550E-05_JPRB, 0.17242475E-05_JPRB, 0.17259041E-05_JPRB, &
  & 0.17273201E-05_JPRB, 0.17272910E-05_JPRB, 0.17272555E-05_JPRB, 0.17278340E-05_JPRB, 0.17283841E-05_JPRB, 0.17288762E-05_JPRB, &
  & 0.17291725E-05_JPRB, 0.17290127E-05_JPRB, 0.17287523E-05_JPRB, 0.17291320E-05_JPRB, 0.17298366E-05_JPRB, 0.17312871E-05_JPRB, &
  & 0.17337978E-05_JPRB, 0.17371353E-05_JPRB, 0.17422015E-05_JPRB, 0.17497476E-05_JPRB, 0.17572483E-05_JPRB, 0.17636517E-05_JPRB, &
  & 0.17685908E-05_JPRB, 0.17733564E-05_JPRB, 0.17775899E-05_JPRB, 0.17812322E-05_JPRB, 0.17842936E-05_JPRB, 0.17870820E-05_JPRB, &
  & 0.17891638E-05_JPRB, 0.17911077E-05_JPRB, 0.17928184E-05_JPRB, 0.17954451E-05_JPRB, 0.17978689E-05_JPRB, 0.17990997E-05_JPRB, &
  & 0.18002402E-05_JPRB, 0.18016747E-05_JPRB, 0.18029857E-05_JPRB, 0.18034599E-05_JPRB  /)

RGHG2(:,60, 3) = (/ &
  & 0.16870793E-05_JPRB, 0.16868618E-05_JPRB, 0.16869181E-05_JPRB, 0.16872018E-05_JPRB, 0.16870300E-05_JPRB, 0.16864689E-05_JPRB, &
  & 0.16860027E-05_JPRB, 0.16860362E-05_JPRB, 0.16861614E-05_JPRB, 0.16870897E-05_JPRB, 0.16879914E-05_JPRB, 0.16890138E-05_JPRB, &
  & 0.16902709E-05_JPRB, 0.16915526E-05_JPRB, 0.16928855E-05_JPRB, 0.16943824E-05_JPRB, 0.16958515E-05_JPRB, 0.16976178E-05_JPRB, &
  & 0.16994660E-05_JPRB, 0.17015562E-05_JPRB, 0.17041067E-05_JPRB, 0.17067636E-05_JPRB, 0.17098827E-05_JPRB, 0.17130925E-05_JPRB, &
  & 0.17164429E-05_JPRB, 0.17189103E-05_JPRB, 0.17210739E-05_JPRB, 0.17228302E-05_JPRB, 0.17240918E-05_JPRB, 0.17258443E-05_JPRB, &
  & 0.17272829E-05_JPRB, 0.17271147E-05_JPRB, 0.17270687E-05_JPRB, 0.17278051E-05_JPRB, 0.17282467E-05_JPRB, 0.17286809E-05_JPRB, &
  & 0.17288148E-05_JPRB, 0.17286160E-05_JPRB, 0.17286313E-05_JPRB, 0.17290777E-05_JPRB, 0.17296905E-05_JPRB, 0.17312683E-05_JPRB, &
  & 0.17340907E-05_JPRB, 0.17378084E-05_JPRB, 0.17433751E-05_JPRB, 0.17512456E-05_JPRB, 0.17589287E-05_JPRB, 0.17653865E-05_JPRB, &
  & 0.17704116E-05_JPRB, 0.17753336E-05_JPRB, 0.17796817E-05_JPRB, 0.17833961E-05_JPRB, 0.17865362E-05_JPRB, 0.17893790E-05_JPRB, &
  & 0.17914327E-05_JPRB, 0.17934010E-05_JPRB, 0.17952915E-05_JPRB, 0.17980852E-05_JPRB, 0.18004350E-05_JPRB, 0.18015820E-05_JPRB, &
  & 0.18027261E-05_JPRB, 0.18041891E-05_JPRB, 0.18054435E-05_JPRB, 0.18059380E-05_JPRB  /)

RGHG2(:,61, 3) = (/ &
  & 0.16854709E-05_JPRB, 0.16852689E-05_JPRB, 0.16853427E-05_JPRB, 0.16856133E-05_JPRB, 0.16854547E-05_JPRB, 0.16849839E-05_JPRB, &
  & 0.16845727E-05_JPRB, 0.16846415E-05_JPRB, 0.16847997E-05_JPRB, 0.16857434E-05_JPRB, 0.16867245E-05_JPRB, 0.16878041E-05_JPRB, &
  & 0.16891229E-05_JPRB, 0.16904421E-05_JPRB, 0.16918697E-05_JPRB, 0.16934745E-05_JPRB, 0.16950119E-05_JPRB, 0.16967540E-05_JPRB, &
  & 0.16985427E-05_JPRB, 0.17005338E-05_JPRB, 0.17030138E-05_JPRB, 0.17055407E-05_JPRB, 0.17086334E-05_JPRB, 0.17119071E-05_JPRB, &
  & 0.17152024E-05_JPRB, 0.17178063E-05_JPRB, 0.17202321E-05_JPRB, 0.17221580E-05_JPRB, 0.17235849E-05_JPRB, 0.17254717E-05_JPRB, &
  & 0.17270557E-05_JPRB, 0.17268699E-05_JPRB, 0.17268570E-05_JPRB, 0.17276529E-05_JPRB, 0.17281935E-05_JPRB, 0.17285286E-05_JPRB, &
  & 0.17286736E-05_JPRB, 0.17284681E-05_JPRB, 0.17285914E-05_JPRB, 0.17289012E-05_JPRB, 0.17294678E-05_JPRB, 0.17312922E-05_JPRB, &
  & 0.17344760E-05_JPRB, 0.17385373E-05_JPRB, 0.17446679E-05_JPRB, 0.17527257E-05_JPRB, 0.17605806E-05_JPRB, 0.17670780E-05_JPRB, &
  & 0.17721891E-05_JPRB, 0.17772564E-05_JPRB, 0.17817125E-05_JPRB, 0.17854952E-05_JPRB, 0.17887609E-05_JPRB, 0.17916433E-05_JPRB, &
  & 0.17936772E-05_JPRB, 0.17957402E-05_JPRB, 0.17977474E-05_JPRB, 0.18006800E-05_JPRB, 0.18029438E-05_JPRB, 0.18040159E-05_JPRB, &
  & 0.18051358E-05_JPRB, 0.18066209E-05_JPRB, 0.18078752E-05_JPRB, 0.18084865E-05_JPRB  /)

RGHG2(:,62, 3) = (/ &
  & 0.16841303E-05_JPRB, 0.16839181E-05_JPRB, 0.16839906E-05_JPRB, 0.16842409E-05_JPRB, 0.16841025E-05_JPRB, 0.16837069E-05_JPRB, &
  & 0.16833445E-05_JPRB, 0.16834284E-05_JPRB, 0.16836142E-05_JPRB, 0.16845527E-05_JPRB, 0.16855780E-05_JPRB, 0.16866956E-05_JPRB, &
  & 0.16880453E-05_JPRB, 0.16893657E-05_JPRB, 0.16908617E-05_JPRB, 0.16925502E-05_JPRB, 0.16941482E-05_JPRB, 0.16958523E-05_JPRB, &
  & 0.16975992E-05_JPRB, 0.16994864E-05_JPRB, 0.17018528E-05_JPRB, 0.17042081E-05_JPRB, 0.17072116E-05_JPRB, 0.17104860E-05_JPRB, &
  & 0.17137293E-05_JPRB, 0.17164514E-05_JPRB, 0.17190351E-05_JPRB, 0.17211312E-05_JPRB, 0.17227742E-05_JPRB, 0.17247426E-05_JPRB, &
  & 0.17263609E-05_JPRB, 0.17262205E-05_JPRB, 0.17263216E-05_JPRB, 0.17270304E-05_JPRB, 0.17279017E-05_JPRB, 0.17283905E-05_JPRB, &
  & 0.17286186E-05_JPRB, 0.17284063E-05_JPRB, 0.17283816E-05_JPRB, 0.17285913E-05_JPRB, 0.17292618E-05_JPRB, 0.17313784E-05_JPRB, &
  & 0.17349528E-05_JPRB, 0.17393802E-05_JPRB, 0.17460291E-05_JPRB, 0.17542622E-05_JPRB, 0.17622128E-05_JPRB, 0.17688230E-05_JPRB, &
  & 0.17740194E-05_JPRB, 0.17792091E-05_JPRB, 0.17837390E-05_JPRB, 0.17876346E-05_JPRB, 0.17910494E-05_JPRB, 0.17939858E-05_JPRB, &
  & 0.17960726E-05_JPRB, 0.17981812E-05_JPRB, 0.18002436E-05_JPRB, 0.18032803E-05_JPRB, 0.18054767E-05_JPRB, 0.18065481E-05_JPRB, &
  & 0.18077115E-05_JPRB, 0.18092095E-05_JPRB, 0.18105014E-05_JPRB, 0.18112641E-05_JPRB  /)

RGHG2(:,63, 3) = (/ &
  & 0.16829571E-05_JPRB, 0.16827174E-05_JPRB, 0.16827783E-05_JPRB, 0.16830051E-05_JPRB, 0.16828903E-05_JPRB, 0.16825585E-05_JPRB, &
  & 0.16822411E-05_JPRB, 0.16823286E-05_JPRB, 0.16825342E-05_JPRB, 0.16834521E-05_JPRB, 0.16844928E-05_JPRB, 0.16856355E-05_JPRB, &
  & 0.16869992E-05_JPRB, 0.16882956E-05_JPRB, 0.16898367E-05_JPRB, 0.16915797E-05_JPRB, 0.16932270E-05_JPRB, 0.16948856E-05_JPRB, &
  & 0.16966012E-05_JPRB, 0.16983799E-05_JPRB, 0.17006147E-05_JPRB, 0.17027737E-05_JPRB, 0.17056340E-05_JPRB, 0.17088323E-05_JPRB, &
  & 0.17120181E-05_JPRB, 0.17148206E-05_JPRB, 0.17174951E-05_JPRB, 0.17198035E-05_JPRB, 0.17217062E-05_JPRB, 0.17237506E-05_JPRB, &
  & 0.17253034E-05_JPRB, 0.17251824E-05_JPRB, 0.17254052E-05_JPRB, 0.17260237E-05_JPRB, 0.17273601E-05_JPRB, 0.17281550E-05_JPRB, &
  & 0.17284666E-05_JPRB, 0.17282584E-05_JPRB, 0.17280231E-05_JPRB, 0.17281894E-05_JPRB, 0.17290570E-05_JPRB, 0.17314990E-05_JPRB, &
  & 0.17354906E-05_JPRB, 0.17403242E-05_JPRB, 0.17474187E-05_JPRB, 0.17558404E-05_JPRB, 0.17638696E-05_JPRB, 0.17706281E-05_JPRB, &
  & 0.17759230E-05_JPRB, 0.17812206E-05_JPRB, 0.17858105E-05_JPRB, 0.17898539E-05_JPRB, 0.17934440E-05_JPRB, 0.17964404E-05_JPRB, &
  & 0.17986198E-05_JPRB, 0.18007341E-05_JPRB, 0.18028091E-05_JPRB, 0.18059049E-05_JPRB, 0.18080672E-05_JPRB, 0.18091868E-05_JPRB, &
  & 0.18104484E-05_JPRB, 0.18119530E-05_JPRB, 0.18132615E-05_JPRB, 0.18141536E-05_JPRB  /)

RGHG2(:,64, 3) = (/ &
  & 0.16819726E-05_JPRB, 0.16816895E-05_JPRB, 0.16817336E-05_JPRB, 0.16819363E-05_JPRB, 0.16818455E-05_JPRB, 0.16815620E-05_JPRB, &
  & 0.16812855E-05_JPRB, 0.16813682E-05_JPRB, 0.16815786E-05_JPRB, 0.16824604E-05_JPRB, 0.16834794E-05_JPRB, 0.16846341E-05_JPRB, &
  & 0.16860003E-05_JPRB, 0.16872485E-05_JPRB, 0.16888016E-05_JPRB, 0.16905494E-05_JPRB, 0.16922232E-05_JPRB, 0.16938336E-05_JPRB, &
  & 0.16955275E-05_JPRB, 0.16971954E-05_JPRB, 0.16993025E-05_JPRB, 0.17012543E-05_JPRB, 0.17039074E-05_JPRB, 0.17069057E-05_JPRB, &
  & 0.17100193E-05_JPRB, 0.17128242E-05_JPRB, 0.17155252E-05_JPRB, 0.17181419E-05_JPRB, 0.17203506E-05_JPRB, 0.17225083E-05_JPRB, &
  & 0.17238635E-05_JPRB, 0.17236317E-05_JPRB, 0.17239075E-05_JPRB, 0.17245814E-05_JPRB, 0.17264623E-05_JPRB, 0.17276717E-05_JPRB, &
  & 0.17279905E-05_JPRB, 0.17278136E-05_JPRB, 0.17274819E-05_JPRB, 0.17277108E-05_JPRB, 0.17288459E-05_JPRB, 0.17316373E-05_JPRB, &
  & 0.17360649E-05_JPRB, 0.17413659E-05_JPRB, 0.17487544E-05_JPRB, 0.17574025E-05_JPRB, 0.17655426E-05_JPRB, 0.17724577E-05_JPRB, &
  & 0.17778803E-05_JPRB, 0.17832695E-05_JPRB, 0.17879172E-05_JPRB, 0.17921436E-05_JPRB, 0.17959434E-05_JPRB, 0.17989976E-05_JPRB, &
  & 0.18012902E-05_JPRB, 0.18033612E-05_JPRB, 0.18054048E-05_JPRB, 0.18084814E-05_JPRB, 0.18106750E-05_JPRB, 0.18118861E-05_JPRB, &
  & 0.18133092E-05_JPRB, 0.18148138E-05_JPRB, 0.18160476E-05_JPRB, 0.18169735E-05_JPRB  /)

RGHG2(:,65, 3) = (/ &
  & 0.16811389E-05_JPRB, 0.16808346E-05_JPRB, 0.16808594E-05_JPRB, 0.16810423E-05_JPRB, 0.16809646E-05_JPRB, 0.16807229E-05_JPRB, &
  & 0.16804743E-05_JPRB, 0.16805454E-05_JPRB, 0.16807516E-05_JPRB, 0.16815881E-05_JPRB, 0.16825628E-05_JPRB, 0.16836938E-05_JPRB, &
  & 0.16850422E-05_JPRB, 0.16862306E-05_JPRB, 0.16877577E-05_JPRB, 0.16894499E-05_JPRB, 0.16911212E-05_JPRB, 0.16926629E-05_JPRB, &
  & 0.16942789E-05_JPRB, 0.16958800E-05_JPRB, 0.16978808E-05_JPRB, 0.16996642E-05_JPRB, 0.17020570E-05_JPRB, 0.17047124E-05_JPRB, &
  & 0.17077801E-05_JPRB, 0.17105874E-05_JPRB, 0.17133308E-05_JPRB, 0.17162314E-05_JPRB, 0.17187955E-05_JPRB, 0.17210471E-05_JPRB, &
  & 0.17222705E-05_JPRB, 0.17218889E-05_JPRB, 0.17219826E-05_JPRB, 0.17228851E-05_JPRB, 0.17250635E-05_JPRB, 0.17266680E-05_JPRB, &
  & 0.17271376E-05_JPRB, 0.17269967E-05_JPRB, 0.17267697E-05_JPRB, 0.17270708E-05_JPRB, 0.17285000E-05_JPRB, 0.17317331E-05_JPRB, &
  & 0.17366629E-05_JPRB, 0.17424170E-05_JPRB, 0.17500008E-05_JPRB, 0.17589130E-05_JPRB, 0.17672634E-05_JPRB, 0.17742915E-05_JPRB, &
  & 0.17798831E-05_JPRB, 0.17853869E-05_JPRB, 0.17901534E-05_JPRB, 0.17945823E-05_JPRB, 0.17985911E-05_JPRB, 0.18016811E-05_JPRB, &
  & 0.18040049E-05_JPRB, 0.18059917E-05_JPRB, 0.18080644E-05_JPRB, 0.18110430E-05_JPRB, 0.18133422E-05_JPRB, 0.18146658E-05_JPRB, &
  & 0.18162380E-05_JPRB, 0.18176978E-05_JPRB, 0.18187510E-05_JPRB, 0.18196368E-05_JPRB  /)

RGHG2(:,66, 3) = (/ &
  & 0.16803982E-05_JPRB, 0.16800868E-05_JPRB, 0.16800934E-05_JPRB, 0.16802566E-05_JPRB, 0.16801912E-05_JPRB, 0.16799829E-05_JPRB, &
  & 0.16797515E-05_JPRB, 0.16798074E-05_JPRB, 0.16800031E-05_JPRB, 0.16807857E-05_JPRB, 0.16817051E-05_JPRB, 0.16827878E-05_JPRB, &
  & 0.16840897E-05_JPRB, 0.16852208E-05_JPRB, 0.16866972E-05_JPRB, 0.16883038E-05_JPRB, 0.16899461E-05_JPRB, 0.16914164E-05_JPRB, &
  & 0.16929331E-05_JPRB, 0.16944843E-05_JPRB, 0.16963594E-05_JPRB, 0.16980178E-05_JPRB, 0.17001026E-05_JPRB, 0.17023703E-05_JPRB, &
  & 0.17054105E-05_JPRB, 0.17082952E-05_JPRB, 0.17111409E-05_JPRB, 0.17142593E-05_JPRB, 0.17170833E-05_JPRB, 0.17194525E-05_JPRB, &
  & 0.17206270E-05_JPRB, 0.17201156E-05_JPRB, 0.17201138E-05_JPRB, 0.17211749E-05_JPRB, 0.17234405E-05_JPRB, 0.17253323E-05_JPRB, &
  & 0.17260234E-05_JPRB, 0.17259365E-05_JPRB, 0.17258665E-05_JPRB, 0.17262146E-05_JPRB, 0.17279993E-05_JPRB, 0.17318434E-05_JPRB, &
  & 0.17373685E-05_JPRB, 0.17435057E-05_JPRB, 0.17512890E-05_JPRB, 0.17604424E-05_JPRB, 0.17690427E-05_JPRB, 0.17761533E-05_JPRB, &
  & 0.17819834E-05_JPRB, 0.17876252E-05_JPRB, 0.17925385E-05_JPRB, 0.17971630E-05_JPRB, 0.18013241E-05_JPRB, 0.18044528E-05_JPRB, &
  & 0.18067504E-05_JPRB, 0.18086529E-05_JPRB, 0.18107840E-05_JPRB, 0.18136653E-05_JPRB, 0.18160593E-05_JPRB, 0.18174916E-05_JPRB, &
  & 0.18191745E-05_JPRB, 0.18205497E-05_JPRB, 0.18214009E-05_JPRB, 0.18222272E-05_JPRB  /)

RGHG2(:,67, 3) = (/ &
  & 0.16797647E-05_JPRB, 0.16794510E-05_JPRB, 0.16794409E-05_JPRB, 0.16795842E-05_JPRB, 0.16795301E-05_JPRB, 0.16793472E-05_JPRB, &
  & 0.16791239E-05_JPRB, 0.16791589E-05_JPRB, 0.16793379E-05_JPRB, 0.16800599E-05_JPRB, 0.16809151E-05_JPRB, 0.16819310E-05_JPRB, &
  & 0.16831588E-05_JPRB, 0.16842349E-05_JPRB, 0.16856366E-05_JPRB, 0.16871386E-05_JPRB, 0.16887262E-05_JPRB, 0.16901318E-05_JPRB, &
  & 0.16915443E-05_JPRB, 0.16930481E-05_JPRB, 0.16947803E-05_JPRB, 0.16963493E-05_JPRB, 0.16980996E-05_JPRB, 0.16999861E-05_JPRB, &
  & 0.17029936E-05_JPRB, 0.17059977E-05_JPRB, 0.17090192E-05_JPRB, 0.17122751E-05_JPRB, 0.17152376E-05_JPRB, 0.17177310E-05_JPRB, &
  & 0.17189470E-05_JPRB, 0.17183851E-05_JPRB, 0.17183988E-05_JPRB, 0.17194771E-05_JPRB, 0.17216219E-05_JPRB, 0.17236202E-05_JPRB, &
  & 0.17245775E-05_JPRB, 0.17245615E-05_JPRB, 0.17247112E-05_JPRB, 0.17251408E-05_JPRB, 0.17273701E-05_JPRB, 0.17319937E-05_JPRB, &
  & 0.17381989E-05_JPRB, 0.17446690E-05_JPRB, 0.17526651E-05_JPRB, 0.17620221E-05_JPRB, 0.17708871E-05_JPRB, 0.17780596E-05_JPRB, &
  & 0.17841853E-05_JPRB, 0.17899884E-05_JPRB, 0.17950597E-05_JPRB, 0.17998605E-05_JPRB, 0.18041067E-05_JPRB, 0.18072883E-05_JPRB, &
  & 0.18095107E-05_JPRB, 0.18113392E-05_JPRB, 0.18135424E-05_JPRB, 0.18163511E-05_JPRB, 0.18187982E-05_JPRB, 0.18203309E-05_JPRB, &
  & 0.18220717E-05_JPRB, 0.18233217E-05_JPRB, 0.18239815E-05_JPRB, 0.18246985E-05_JPRB  /)

RGHG2(:,68, 3) = (/ &
  & 0.16792669E-05_JPRB, 0.16789359E-05_JPRB, 0.16789109E-05_JPRB, 0.16790345E-05_JPRB, 0.16789877E-05_JPRB, 0.16788246E-05_JPRB, &
  & 0.16786038E-05_JPRB, 0.16786067E-05_JPRB, 0.16787634E-05_JPRB, 0.16794211E-05_JPRB, 0.16802045E-05_JPRB, 0.16811462E-05_JPRB, &
  & 0.16822776E-05_JPRB, 0.16832967E-05_JPRB, 0.16845995E-05_JPRB, 0.16859951E-05_JPRB, 0.16875036E-05_JPRB, 0.16888671E-05_JPRB, &
  & 0.16901979E-05_JPRB, 0.16916300E-05_JPRB, 0.16932137E-05_JPRB, 0.16947085E-05_JPRB, 0.16961397E-05_JPRB, 0.16977392E-05_JPRB, &
  & 0.17006576E-05_JPRB, 0.17037359E-05_JPRB, 0.17070272E-05_JPRB, 0.17103226E-05_JPRB, 0.17132826E-05_JPRB, 0.17158627E-05_JPRB, &
  & 0.17172197E-05_JPRB, 0.17167988E-05_JPRB, 0.17169238E-05_JPRB, 0.17177769E-05_JPRB, 0.17196001E-05_JPRB, 0.17213931E-05_JPRB, &
  & 0.17226200E-05_JPRB, 0.17226882E-05_JPRB, 0.17231719E-05_JPRB, 0.17238538E-05_JPRB, 0.17266719E-05_JPRB, 0.17322281E-05_JPRB, &
  & 0.17391805E-05_JPRB, 0.17459945E-05_JPRB, 0.17542182E-05_JPRB, 0.17637262E-05_JPRB, 0.17728311E-05_JPRB, 0.17800655E-05_JPRB, &
  & 0.17865127E-05_JPRB, 0.17925014E-05_JPRB, 0.17977137E-05_JPRB, 0.18026530E-05_JPRB, 0.18069092E-05_JPRB, 0.18101773E-05_JPRB, &
  & 0.18122909E-05_JPRB, 0.18140699E-05_JPRB, 0.18163300E-05_JPRB, 0.18191263E-05_JPRB, 0.18215363E-05_JPRB, 0.18231581E-05_JPRB, &
  & 0.18248815E-05_JPRB, 0.18259634E-05_JPRB, 0.18264920E-05_JPRB, 0.18269740E-05_JPRB  /)

RGHG2(:,69, 3) = (/ &
  & 0.16788725E-05_JPRB, 0.16785062E-05_JPRB, 0.16784664E-05_JPRB, 0.16785657E-05_JPRB, 0.16785331E-05_JPRB, 0.16783785E-05_JPRB, &
  & 0.16781624E-05_JPRB, 0.16781309E-05_JPRB, 0.16782541E-05_JPRB, 0.16788565E-05_JPRB, 0.16795637E-05_JPRB, 0.16804357E-05_JPRB, &
  & 0.16814458E-05_JPRB, 0.16823900E-05_JPRB, 0.16835849E-05_JPRB, 0.16848786E-05_JPRB, 0.16862854E-05_JPRB, 0.16876271E-05_JPRB, &
  & 0.16889101E-05_JPRB, 0.16902547E-05_JPRB, 0.16917193E-05_JPRB, 0.16931534E-05_JPRB, 0.16944254E-05_JPRB, 0.16958190E-05_JPRB, &
  & 0.16985448E-05_JPRB, 0.17015622E-05_JPRB, 0.17050150E-05_JPRB, 0.17084445E-05_JPRB, 0.17113301E-05_JPRB, 0.17138976E-05_JPRB, &
  & 0.17154992E-05_JPRB, 0.17153949E-05_JPRB, 0.17155974E-05_JPRB, 0.17160656E-05_JPRB, 0.17176123E-05_JPRB, 0.17189816E-05_JPRB, &
  & 0.17203340E-05_JPRB, 0.17205201E-05_JPRB, 0.17213669E-05_JPRB, 0.17225556E-05_JPRB, 0.17262957E-05_JPRB, 0.17327145E-05_JPRB, &
  & 0.17403553E-05_JPRB, 0.17477225E-05_JPRB, 0.17560522E-05_JPRB, 0.17656953E-05_JPRB, 0.17749321E-05_JPRB, 0.17821968E-05_JPRB, &
  & 0.17890264E-05_JPRB, 0.17952704E-05_JPRB, 0.18005111E-05_JPRB, 0.18055326E-05_JPRB, 0.18097807E-05_JPRB, 0.18131579E-05_JPRB, &
  & 0.18151852E-05_JPRB, 0.18168877E-05_JPRB, 0.18191686E-05_JPRB, 0.18219571E-05_JPRB, 0.18242557E-05_JPRB, 0.18259800E-05_JPRB, &
  & 0.18275623E-05_JPRB, 0.18285412E-05_JPRB, 0.18290019E-05_JPRB, 0.18291386E-05_JPRB  /)

RGHG2(:,70, 3) = (/ &
  & 0.16785218E-05_JPRB, 0.16781284E-05_JPRB, 0.16780751E-05_JPRB, 0.16781511E-05_JPRB, 0.16781305E-05_JPRB, 0.16779819E-05_JPRB, &
  & 0.16777722E-05_JPRB, 0.16777089E-05_JPRB, 0.16777917E-05_JPRB, 0.16783481E-05_JPRB, 0.16789828E-05_JPRB, 0.16797768E-05_JPRB, &
  & 0.16806673E-05_JPRB, 0.16815203E-05_JPRB, 0.16825960E-05_JPRB, 0.16837896E-05_JPRB, 0.16850865E-05_JPRB, 0.16863969E-05_JPRB, &
  & 0.16876569E-05_JPRB, 0.16889338E-05_JPRB, 0.16902891E-05_JPRB, 0.16916508E-05_JPRB, 0.16928336E-05_JPRB, 0.16941196E-05_JPRB, &
  & 0.16965789E-05_JPRB, 0.16994860E-05_JPRB, 0.17029333E-05_JPRB, 0.17065353E-05_JPRB, 0.17093606E-05_JPRB, 0.17120022E-05_JPRB, &
  & 0.17139122E-05_JPRB, 0.17141324E-05_JPRB, 0.17144194E-05_JPRB, 0.17146069E-05_JPRB, 0.17159772E-05_JPRB, 0.17169723E-05_JPRB, &
  & 0.17181645E-05_JPRB, 0.17185899E-05_JPRB, 0.17198826E-05_JPRB, 0.17216617E-05_JPRB, 0.17263757E-05_JPRB, 0.17335198E-05_JPRB, &
  & 0.17417685E-05_JPRB, 0.17496905E-05_JPRB, 0.17580770E-05_JPRB, 0.17678726E-05_JPRB, 0.17770799E-05_JPRB, 0.17844452E-05_JPRB, &
  & 0.17916495E-05_JPRB, 0.17981821E-05_JPRB, 0.18033798E-05_JPRB, 0.18085083E-05_JPRB, 0.18127565E-05_JPRB, 0.18162395E-05_JPRB, &
  & 0.18181610E-05_JPRB, 0.18197784E-05_JPRB, 0.18220278E-05_JPRB, 0.18248376E-05_JPRB, 0.18269627E-05_JPRB, 0.18287896E-05_JPRB, &
  & 0.18301809E-05_JPRB, 0.18311019E-05_JPRB, 0.18315279E-05_JPRB, 0.18314242E-05_JPRB  /)

RGHG2(:,71, 3) = (/ &
  & 0.16782035E-05_JPRB, 0.16777984E-05_JPRB, 0.16777333E-05_JPRB, 0.16777889E-05_JPRB, 0.16777763E-05_JPRB, 0.16776333E-05_JPRB, &
  & 0.16774298E-05_JPRB, 0.16773405E-05_JPRB, 0.16773799E-05_JPRB, 0.16778929E-05_JPRB, 0.16784607E-05_JPRB, 0.16791679E-05_JPRB, &
  & 0.16799470E-05_JPRB, 0.16806978E-05_JPRB, 0.16816477E-05_JPRB, 0.16827409E-05_JPRB, 0.16839170E-05_JPRB, 0.16851790E-05_JPRB, &
  & 0.16864321E-05_JPRB, 0.16876626E-05_JPRB, 0.16889182E-05_JPRB, 0.16902050E-05_JPRB, 0.16913326E-05_JPRB, 0.16926057E-05_JPRB, &
  & 0.16947534E-05_JPRB, 0.16975049E-05_JPRB, 0.17008257E-05_JPRB, 0.17045625E-05_JPRB, 0.17073930E-05_JPRB, 0.17102700E-05_JPRB, &
  & 0.17125077E-05_JPRB, 0.17130576E-05_JPRB, 0.17134593E-05_JPRB, 0.17135202E-05_JPRB, 0.17147559E-05_JPRB, 0.17154587E-05_JPRB, &
  & 0.17163103E-05_JPRB, 0.17170984E-05_JPRB, 0.17189347E-05_JPRB, 0.17213501E-05_JPRB, 0.17269731E-05_JPRB, 0.17346782E-05_JPRB, &
  & 0.17434433E-05_JPRB, 0.17518539E-05_JPRB, 0.17602670E-05_JPRB, 0.17702268E-05_JPRB, 0.17792604E-05_JPRB, 0.17868098E-05_JPRB, &
  & 0.17943710E-05_JPRB, 0.18012027E-05_JPRB, 0.18063256E-05_JPRB, 0.18115686E-05_JPRB, 0.18158361E-05_JPRB, 0.18194076E-05_JPRB, &
  & 0.18211833E-05_JPRB, 0.18227172E-05_JPRB, 0.18248947E-05_JPRB, 0.18277428E-05_JPRB, 0.18296597E-05_JPRB, 0.18315609E-05_JPRB, &
  & 0.18327422E-05_JPRB, 0.18336260E-05_JPRB, 0.18340465E-05_JPRB, 0.18338839E-05_JPRB  /)

RGHG2(:,72, 3) = (/ &
  & 0.16779080E-05_JPRB, 0.16775152E-05_JPRB, 0.16774403E-05_JPRB, 0.16774809E-05_JPRB, 0.16774709E-05_JPRB, 0.16773353E-05_JPRB, &
  & 0.16771343E-05_JPRB, 0.16770301E-05_JPRB, 0.16770299E-05_JPRB, 0.16774884E-05_JPRB, 0.16779968E-05_JPRB, 0.16786099E-05_JPRB, &
  & 0.16792923E-05_JPRB, 0.16799391E-05_JPRB, 0.16807653E-05_JPRB, 0.16817545E-05_JPRB, 0.16827894E-05_JPRB, 0.16839771E-05_JPRB, &
  & 0.16852253E-05_JPRB, 0.16864260E-05_JPRB, 0.16875950E-05_JPRB, 0.16888272E-05_JPRB, 0.16898831E-05_JPRB, 0.16912305E-05_JPRB, &
  & 0.16930686E-05_JPRB, 0.16956071E-05_JPRB, 0.16987793E-05_JPRB, 0.17024765E-05_JPRB, 0.17054606E-05_JPRB, 0.17088452E-05_JPRB, &
  & 0.17113528E-05_JPRB, 0.17122692E-05_JPRB, 0.17128542E-05_JPRB, 0.17129869E-05_JPRB, 0.17140047E-05_JPRB, 0.17145045E-05_JPRB, &
  & 0.17150638E-05_JPRB, 0.17163274E-05_JPRB, 0.17188274E-05_JPRB, 0.17218916E-05_JPRB, 0.17281932E-05_JPRB, 0.17362548E-05_JPRB, &
  & 0.17454285E-05_JPRB, 0.17541734E-05_JPRB, 0.17626039E-05_JPRB, 0.17727222E-05_JPRB, 0.17814784E-05_JPRB, 0.17893027E-05_JPRB, &
  & 0.17971982E-05_JPRB, 0.18043049E-05_JPRB, 0.18093881E-05_JPRB, 0.18147029E-05_JPRB, 0.18190249E-05_JPRB, 0.18226459E-05_JPRB, &
  & 0.18242037E-05_JPRB, 0.18256707E-05_JPRB, 0.18277615E-05_JPRB, 0.18306369E-05_JPRB, 0.18323607E-05_JPRB, 0.18342544E-05_JPRB, &
  & 0.18352499E-05_JPRB, 0.18360743E-05_JPRB, 0.18365171E-05_JPRB, 0.18365848E-05_JPRB  /)

RGHG2(:,73, 3) = (/ &
  & 0.16776242E-05_JPRB, 0.16772668E-05_JPRB, 0.16771842E-05_JPRB, 0.16772145E-05_JPRB, 0.16772070E-05_JPRB, 0.16770835E-05_JPRB, &
  & 0.16768941E-05_JPRB, 0.16767842E-05_JPRB, 0.16767579E-05_JPRB, 0.16771525E-05_JPRB, 0.16776010E-05_JPRB, 0.16781149E-05_JPRB, &
  & 0.16787071E-05_JPRB, 0.16792746E-05_JPRB, 0.16799853E-05_JPRB, 0.16808768E-05_JPRB, 0.16817628E-05_JPRB, 0.16828345E-05_JPRB, &
  & 0.16840363E-05_JPRB, 0.16852302E-05_JPRB, 0.16863257E-05_JPRB, 0.16875239E-05_JPRB, 0.16885466E-05_JPRB, 0.16899342E-05_JPRB, &
  & 0.16915897E-05_JPRB, 0.16937508E-05_JPRB, 0.16967828E-05_JPRB, 0.17005274E-05_JPRB, 0.17036774E-05_JPRB, 0.17076899E-05_JPRB, &
  & 0.17105540E-05_JPRB, 0.17118988E-05_JPRB, 0.17128267E-05_JPRB, 0.17129742E-05_JPRB, 0.17138211E-05_JPRB, 0.17141557E-05_JPRB, &
  & 0.17147889E-05_JPRB, 0.17165789E-05_JPRB, 0.17196752E-05_JPRB, 0.17233943E-05_JPRB, 0.17301830E-05_JPRB, 0.17384286E-05_JPRB, &
  & 0.17477973E-05_JPRB, 0.17568325E-05_JPRB, 0.17652803E-05_JPRB, 0.17753052E-05_JPRB, 0.17838261E-05_JPRB, 0.17919477E-05_JPRB, &
  & 0.18002001E-05_JPRB, 0.18074522E-05_JPRB, 0.18125530E-05_JPRB, 0.18179309E-05_JPRB, 0.18222962E-05_JPRB, 0.18258636E-05_JPRB, &
  & 0.18271677E-05_JPRB, 0.18285928E-05_JPRB, 0.18306148E-05_JPRB, 0.18334279E-05_JPRB, 0.18350746E-05_JPRB, 0.18368482E-05_JPRB, &
  & 0.18377351E-05_JPRB, 0.18384722E-05_JPRB, 0.18389810E-05_JPRB, 0.18395355E-05_JPRB  /)

RGHG2(:,74, 3) = (/ &
  & 0.16773598E-05_JPRB, 0.16770473E-05_JPRB, 0.16769602E-05_JPRB, 0.16769820E-05_JPRB, 0.16769799E-05_JPRB, 0.16768734E-05_JPRB, &
  & 0.16766965E-05_JPRB, 0.16765890E-05_JPRB, 0.16765483E-05_JPRB, 0.16768767E-05_JPRB, 0.16772685E-05_JPRB, 0.16776903E-05_JPRB, &
  & 0.16781929E-05_JPRB, 0.16786921E-05_JPRB, 0.16793078E-05_JPRB, 0.16800933E-05_JPRB, 0.16808389E-05_JPRB, 0.16817701E-05_JPRB, &
  & 0.16829042E-05_JPRB, 0.16841065E-05_JPRB, 0.16851508E-05_JPRB, 0.16863122E-05_JPRB, 0.16873050E-05_JPRB, 0.16887270E-05_JPRB, &
  & 0.16902989E-05_JPRB, 0.16921529E-05_JPRB, 0.16950350E-05_JPRB, 0.16987581E-05_JPRB, 0.17020540E-05_JPRB, 0.17067023E-05_JPRB, &
  & 0.17099298E-05_JPRB, 0.17117123E-05_JPRB, 0.17130216E-05_JPRB, 0.17132613E-05_JPRB, 0.17140610E-05_JPRB, 0.17143056E-05_JPRB, &
  & 0.17150583E-05_JPRB, 0.17173172E-05_JPRB, 0.17211202E-05_JPRB, 0.17255268E-05_JPRB, 0.17327456E-05_JPRB, 0.17411127E-05_JPRB, &
  & 0.17506028E-05_JPRB, 0.17596954E-05_JPRB, 0.17680934E-05_JPRB, 0.17779365E-05_JPRB, 0.17863037E-05_JPRB, 0.17946581E-05_JPRB, &
  & 0.18032899E-05_JPRB, 0.18106226E-05_JPRB, 0.18157787E-05_JPRB, 0.18211890E-05_JPRB, 0.18256250E-05_JPRB, 0.18290674E-05_JPRB, &
  & 0.18301210E-05_JPRB, 0.18314868E-05_JPRB, 0.18334386E-05_JPRB, 0.18361836E-05_JPRB, 0.18377990E-05_JPRB, 0.18394102E-05_JPRB, &
  & 0.18402219E-05_JPRB, 0.18409202E-05_JPRB, 0.18415212E-05_JPRB, 0.18425371E-05_JPRB  /)

RGHG2(:,75, 3) = (/ &
  & 0.16771200E-05_JPRB, 0.16768571E-05_JPRB, 0.16767717E-05_JPRB, 0.16767847E-05_JPRB, 0.16767928E-05_JPRB, 0.16767068E-05_JPRB, &
  & 0.16765416E-05_JPRB, 0.16764437E-05_JPRB, 0.16763976E-05_JPRB, 0.16766637E-05_JPRB, 0.16770023E-05_JPRB, 0.16773413E-05_JPRB, &
  & 0.16777552E-05_JPRB, 0.16781937E-05_JPRB, 0.16787330E-05_JPRB, 0.16794115E-05_JPRB, 0.16800272E-05_JPRB, 0.16808031E-05_JPRB, &
  & 0.16818516E-05_JPRB, 0.16830480E-05_JPRB, 0.16840584E-05_JPRB, 0.16852109E-05_JPRB, 0.16861801E-05_JPRB, 0.16876179E-05_JPRB, &
  & 0.16891911E-05_JPRB, 0.16908163E-05_JPRB, 0.16935708E-05_JPRB, 0.16972068E-05_JPRB, 0.17006233E-05_JPRB, 0.17058827E-05_JPRB, &
  & 0.17094460E-05_JPRB, 0.17115939E-05_JPRB, 0.17133271E-05_JPRB, 0.17137798E-05_JPRB, 0.17146221E-05_JPRB, 0.17149602E-05_JPRB, &
  & 0.17158543E-05_JPRB, 0.17184855E-05_JPRB, 0.17230739E-05_JPRB, 0.17282306E-05_JPRB, 0.17358365E-05_JPRB, 0.17443828E-05_JPRB, &
  & 0.17537948E-05_JPRB, 0.17627040E-05_JPRB, 0.17709500E-05_JPRB, 0.17805329E-05_JPRB, 0.17888524E-05_JPRB, 0.17973867E-05_JPRB, &
  & 0.18064094E-05_JPRB, 0.18137943E-05_JPRB, 0.18190315E-05_JPRB, 0.18244953E-05_JPRB, 0.18290543E-05_JPRB, 0.18322857E-05_JPRB, &
  & 0.18330751E-05_JPRB, 0.18343757E-05_JPRB, 0.18362322E-05_JPRB, 0.18389129E-05_JPRB, 0.18405208E-05_JPRB, 0.18419470E-05_JPRB, &
  & 0.18427311E-05_JPRB, 0.18434491E-05_JPRB, 0.18441520E-05_JPRB, 0.18455413E-05_JPRB  /)

RGHG2(:,76, 3) = (/ &
  & 0.16769116E-05_JPRB, 0.16766983E-05_JPRB, 0.16766252E-05_JPRB, 0.16766259E-05_JPRB, 0.16766513E-05_JPRB, 0.16765876E-05_JPRB, &
  & 0.16764323E-05_JPRB, 0.16763492E-05_JPRB, 0.16763031E-05_JPRB, 0.16765197E-05_JPRB, 0.16768088E-05_JPRB, 0.16770759E-05_JPRB, &
  & 0.16774031E-05_JPRB, 0.16777847E-05_JPRB, 0.16782621E-05_JPRB, 0.16788464E-05_JPRB, 0.16793432E-05_JPRB, 0.16799606E-05_JPRB, &
  & 0.16809075E-05_JPRB, 0.16820370E-05_JPRB, 0.16830228E-05_JPRB, 0.16842470E-05_JPRB, 0.16852088E-05_JPRB, 0.16866194E-05_JPRB, &
  & 0.16882619E-05_JPRB, 0.16897162E-05_JPRB, 0.16924187E-05_JPRB, 0.16959284E-05_JPRB, 0.16994365E-05_JPRB, 0.17052483E-05_JPRB, &
  & 0.17090766E-05_JPRB, 0.17113954E-05_JPRB, 0.17136216E-05_JPRB, 0.17144607E-05_JPRB, 0.17153723E-05_JPRB, 0.17161588E-05_JPRB, &
  & 0.17172263E-05_JPRB, 0.17200853E-05_JPRB, 0.17254664E-05_JPRB, 0.17314826E-05_JPRB, 0.17394353E-05_JPRB, 0.17483953E-05_JPRB, &
  & 0.17573044E-05_JPRB, 0.17657974E-05_JPRB, 0.17737413E-05_JPRB, 0.17829749E-05_JPRB, 0.17913886E-05_JPRB, 0.18000788E-05_JPRB, &
  & 0.18094880E-05_JPRB, 0.18169447E-05_JPRB, 0.18222736E-05_JPRB, 0.18278984E-05_JPRB, 0.18326679E-05_JPRB, 0.18355724E-05_JPRB, &
  & 0.18360497E-05_JPRB, 0.18373032E-05_JPRB, 0.18390037E-05_JPRB, 0.18416274E-05_JPRB, 0.18432279E-05_JPRB, 0.18444658E-05_JPRB, &
  & 0.18452995E-05_JPRB, 0.18461017E-05_JPRB, 0.18468938E-05_JPRB, 0.18485084E-05_JPRB  /)

RGHG2(:,77, 3) = (/ &
  & 0.16767368E-05_JPRB, 0.16765738E-05_JPRB, 0.16765204E-05_JPRB, 0.16765156E-05_JPRB, 0.16765563E-05_JPRB, 0.16765223E-05_JPRB, &
  & 0.16763747E-05_JPRB, 0.16763067E-05_JPRB, 0.16762654E-05_JPRB, 0.16764389E-05_JPRB, 0.16766848E-05_JPRB, 0.16769005E-05_JPRB, &
  & 0.16771469E-05_JPRB, 0.16774755E-05_JPRB, 0.16779020E-05_JPRB, 0.16784052E-05_JPRB, 0.16788195E-05_JPRB, 0.16793309E-05_JPRB, &
  & 0.16801963E-05_JPRB, 0.16812317E-05_JPRB, 0.16822137E-05_JPRB, 0.16834680E-05_JPRB, 0.16844389E-05_JPRB, 0.16858028E-05_JPRB, &
  & 0.16875467E-05_JPRB, 0.16888943E-05_JPRB, 0.16915393E-05_JPRB, 0.16949852E-05_JPRB, 0.16984385E-05_JPRB, 0.17049082E-05_JPRB, &
  & 0.17089149E-05_JPRB, 0.17112211E-05_JPRB, 0.17139901E-05_JPRB, 0.17150639E-05_JPRB, 0.17162865E-05_JPRB, 0.17176636E-05_JPRB, &
  & 0.17191738E-05_JPRB, 0.17223688E-05_JPRB, 0.17283561E-05_JPRB, 0.17351274E-05_JPRB, 0.17435366E-05_JPRB, 0.17524348E-05_JPRB, &
  & 0.17609959E-05_JPRB, 0.17687881E-05_JPRB, 0.17764255E-05_JPRB, 0.17853335E-05_JPRB, 0.17939188E-05_JPRB, 0.18028222E-05_JPRB, &
  & 0.18124898E-05_JPRB, 0.18199170E-05_JPRB, 0.18255842E-05_JPRB, 0.18312984E-05_JPRB, 0.18362863E-05_JPRB, 0.18389545E-05_JPRB, &
  & 0.18391414E-05_JPRB, 0.18403329E-05_JPRB, 0.18417941E-05_JPRB, 0.18443171E-05_JPRB, 0.18458362E-05_JPRB, 0.18470023E-05_JPRB, &
  & 0.18478243E-05_JPRB, 0.18488191E-05_JPRB, 0.18496778E-05_JPRB, 0.18514353E-05_JPRB  /)

RGHG2(:,78, 3) = (/ &
  & 0.16765925E-05_JPRB, 0.16764796E-05_JPRB, 0.16764479E-05_JPRB, 0.16764413E-05_JPRB, 0.16764921E-05_JPRB, 0.16764882E-05_JPRB, &
  & 0.16763498E-05_JPRB, 0.16762952E-05_JPRB, 0.16762589E-05_JPRB, 0.16763946E-05_JPRB, 0.16766027E-05_JPRB, 0.16767859E-05_JPRB, &
  & 0.16769697E-05_JPRB, 0.16772393E-05_JPRB, 0.16776172E-05_JPRB, 0.16780498E-05_JPRB, 0.16784031E-05_JPRB, 0.16788437E-05_JPRB, &
  & 0.16796529E-05_JPRB, 0.16805931E-05_JPRB, 0.16815727E-05_JPRB, 0.16828306E-05_JPRB, 0.16837987E-05_JPRB, 0.16851309E-05_JPRB, &
  & 0.16869839E-05_JPRB, 0.16883357E-05_JPRB, 0.16909119E-05_JPRB, 0.16942849E-05_JPRB, 0.16977108E-05_JPRB, 0.17048370E-05_JPRB, &
  & 0.17089431E-05_JPRB, 0.17111805E-05_JPRB, 0.17144628E-05_JPRB, 0.17156025E-05_JPRB, 0.17173142E-05_JPRB, 0.17191869E-05_JPRB, &
  & 0.17212217E-05_JPRB, 0.17246728E-05_JPRB, 0.17310878E-05_JPRB, 0.17384843E-05_JPRB, 0.17472699E-05_JPRB, 0.17561363E-05_JPRB, &
  & 0.17644199E-05_JPRB, 0.17716242E-05_JPRB, 0.17789320E-05_JPRB, 0.17877067E-05_JPRB, 0.17964499E-05_JPRB, 0.18054506E-05_JPRB, &
  & 0.18152315E-05_JPRB, 0.18226635E-05_JPRB, 0.18286734E-05_JPRB, 0.18345749E-05_JPRB, 0.18396977E-05_JPRB, 0.18422392E-05_JPRB, &
  & 0.18422720E-05_JPRB, 0.18433818E-05_JPRB, 0.18445968E-05_JPRB, 0.18469613E-05_JPRB, 0.18482819E-05_JPRB, 0.18494084E-05_JPRB, &
  & 0.18502026E-05_JPRB, 0.18513666E-05_JPRB, 0.18523750E-05_JPRB, 0.18542543E-05_JPRB  /)

RGHG2(:,79, 3) = (/ &
  & 0.16764783E-05_JPRB, 0.16764112E-05_JPRB, 0.16763995E-05_JPRB, 0.16763961E-05_JPRB, 0.16764537E-05_JPRB, 0.16764789E-05_JPRB, &
  & 0.16763504E-05_JPRB, 0.16763075E-05_JPRB, 0.16762753E-05_JPRB, 0.16763785E-05_JPRB, 0.16765534E-05_JPRB, 0.16767165E-05_JPRB, &
  & 0.16768567E-05_JPRB, 0.16770704E-05_JPRB, 0.16774042E-05_JPRB, 0.16777816E-05_JPRB, 0.16780914E-05_JPRB, 0.16784884E-05_JPRB, &
  & 0.16792631E-05_JPRB, 0.16801206E-05_JPRB, 0.16811009E-05_JPRB, 0.16823416E-05_JPRB, 0.16832919E-05_JPRB, 0.16846025E-05_JPRB, &
  & 0.16865548E-05_JPRB, 0.16880040E-05_JPRB, 0.16905023E-05_JPRB, 0.16938273E-05_JPRB, 0.16972576E-05_JPRB, 0.17050468E-05_JPRB, &
  & 0.17091292E-05_JPRB, 0.17112720E-05_JPRB, 0.17150285E-05_JPRB, 0.17160726E-05_JPRB, 0.17183806E-05_JPRB, 0.17206385E-05_JPRB, &
  & 0.17232227E-05_JPRB, 0.17268719E-05_JPRB, 0.17335356E-05_JPRB, 0.17414273E-05_JPRB, 0.17505305E-05_JPRB, 0.17593929E-05_JPRB, &
  & 0.17674515E-05_JPRB, 0.17741617E-05_JPRB, 0.17811909E-05_JPRB, 0.17900161E-05_JPRB, 0.17989158E-05_JPRB, 0.18079337E-05_JPRB, &
  & 0.18176995E-05_JPRB, 0.18251454E-05_JPRB, 0.18315210E-05_JPRB, 0.18376413E-05_JPRB, 0.18428140E-05_JPRB, 0.18453326E-05_JPRB, &
  & 0.18453605E-05_JPRB, 0.18464178E-05_JPRB, 0.18474148E-05_JPRB, 0.18495708E-05_JPRB, 0.18506140E-05_JPRB, 0.18517132E-05_JPRB, &
  & 0.18524789E-05_JPRB, 0.18537988E-05_JPRB, 0.18550493E-05_JPRB, 0.18570328E-05_JPRB  /)

RGHG2(:,80, 3) = (/ &
  & 0.16763932E-05_JPRB, 0.16763633E-05_JPRB, 0.16763664E-05_JPRB, 0.16763729E-05_JPRB, 0.16764354E-05_JPRB, 0.16764878E-05_JPRB, &
  & 0.16763692E-05_JPRB, 0.16763361E-05_JPRB, 0.16763065E-05_JPRB, 0.16763824E-05_JPRB, 0.16765275E-05_JPRB, 0.16766758E-05_JPRB, &
  & 0.16767912E-05_JPRB, 0.16769627E-05_JPRB, 0.16772593E-05_JPRB, 0.16776018E-05_JPRB, 0.16778820E-05_JPRB, 0.16782541E-05_JPRB, &
  & 0.16790117E-05_JPRB, 0.16798123E-05_JPRB, 0.16807996E-05_JPRB, 0.16820082E-05_JPRB, 0.16829240E-05_JPRB, 0.16842145E-05_JPRB, &
  & 0.16862389E-05_JPRB, 0.16878541E-05_JPRB, 0.16902682E-05_JPRB, 0.16936124E-05_JPRB, 0.16970724E-05_JPRB, 0.17055454E-05_JPRB, &
  & 0.17094334E-05_JPRB, 0.17114831E-05_JPRB, 0.17156694E-05_JPRB, 0.17164700E-05_JPRB, 0.17194024E-05_JPRB, 0.17219345E-05_JPRB, &
  & 0.17250426E-05_JPRB, 0.17288693E-05_JPRB, 0.17356062E-05_JPRB, 0.17438687E-05_JPRB, 0.17532702E-05_JPRB, 0.17621188E-05_JPRB, &
  & 0.17699900E-05_JPRB, 0.17762491E-05_JPRB, 0.17831326E-05_JPRB, 0.17921672E-05_JPRB, 0.18012429E-05_JPRB, 0.18102514E-05_JPRB, &
  & 0.18198966E-05_JPRB, 0.18273258E-05_JPRB, 0.18341262E-05_JPRB, 0.18404102E-05_JPRB, 0.18455549E-05_JPRB, 0.18481430E-05_JPRB, &
  & 0.18483160E-05_JPRB, 0.18494042E-05_JPRB, 0.18502443E-05_JPRB, 0.18521534E-05_JPRB, 0.18528876E-05_JPRB, 0.18539538E-05_JPRB, &
  & 0.18547046E-05_JPRB, 0.18561876E-05_JPRB, 0.18577735E-05_JPRB, 0.18598456E-05_JPRB  /)

RGHG2(:,81, 3) = (/ &
  & 0.16763426E-05_JPRB, 0.16763356E-05_JPRB, 0.16763540E-05_JPRB, 0.16763656E-05_JPRB, 0.16764307E-05_JPRB, 0.16765060E-05_JPRB, &
  & 0.16763976E-05_JPRB, 0.16763747E-05_JPRB, 0.16763451E-05_JPRB, 0.16764032E-05_JPRB, 0.16765304E-05_JPRB, 0.16766660E-05_JPRB, &
  & 0.16767687E-05_JPRB, 0.16769172E-05_JPRB, 0.16771884E-05_JPRB, 0.16775207E-05_JPRB, 0.16777754E-05_JPRB, 0.16781374E-05_JPRB, &
  & 0.16788695E-05_JPRB, 0.16796267E-05_JPRB, 0.16806421E-05_JPRB, 0.16818328E-05_JPRB, 0.16827028E-05_JPRB, 0.16839984E-05_JPRB, &
  & 0.16860635E-05_JPRB, 0.16877857E-05_JPRB, 0.16901361E-05_JPRB, 0.16935466E-05_JPRB, 0.16970346E-05_JPRB, 0.17061826E-05_JPRB, &
  & 0.17098184E-05_JPRB, 0.17117178E-05_JPRB, 0.17163116E-05_JPRB, 0.17167938E-05_JPRB, 0.17203580E-05_JPRB, 0.17231422E-05_JPRB, &
  & 0.17265178E-05_JPRB, 0.17305355E-05_JPRB, 0.17372113E-05_JPRB, 0.17455884E-05_JPRB, 0.17551122E-05_JPRB, 0.17640703E-05_JPRB, &
  & 0.17717377E-05_JPRB, 0.17777039E-05_JPRB, 0.17846587E-05_JPRB, 0.17939378E-05_JPRB, 0.18031231E-05_JPRB, 0.18120857E-05_JPRB, &
  & 0.18215806E-05_JPRB, 0.18291423E-05_JPRB, 0.18363578E-05_JPRB, 0.18427336E-05_JPRB, 0.18477076E-05_JPRB, 0.18505504E-05_JPRB, &
  & 0.18511182E-05_JPRB, 0.18523363E-05_JPRB, 0.18531281E-05_JPRB, 0.18548079E-05_JPRB, 0.18552645E-05_JPRB, 0.18563765E-05_JPRB, &
  & 0.18571121E-05_JPRB, 0.18587529E-05_JPRB, 0.18606929E-05_JPRB, 0.18626657E-05_JPRB  /)

RGHG2(:,82, 3) = (/ &
  & 0.16763152E-05_JPRB, 0.16763187E-05_JPRB, 0.16763505E-05_JPRB, 0.16763672E-05_JPRB, 0.16764365E-05_JPRB, 0.16765311E-05_JPRB, &
  & 0.16764363E-05_JPRB, 0.16764113E-05_JPRB, 0.16763834E-05_JPRB, 0.16764220E-05_JPRB, 0.16765351E-05_JPRB, 0.16766685E-05_JPRB, &
  & 0.16767655E-05_JPRB, 0.16769001E-05_JPRB, 0.16771547E-05_JPRB, 0.16774875E-05_JPRB, 0.16777221E-05_JPRB, 0.16780669E-05_JPRB, &
  & 0.16787860E-05_JPRB, 0.16795072E-05_JPRB, 0.16805557E-05_JPRB, 0.16817445E-05_JPRB, 0.16825654E-05_JPRB, 0.16838714E-05_JPRB, &
  & 0.16859840E-05_JPRB, 0.16877651E-05_JPRB, 0.16901049E-05_JPRB, 0.16935707E-05_JPRB, 0.16970672E-05_JPRB, 0.17067577E-05_JPRB, &
  & 0.17102185E-05_JPRB, 0.17119247E-05_JPRB, 0.17169006E-05_JPRB, 0.17170752E-05_JPRB, 0.17212144E-05_JPRB, 0.17241913E-05_JPRB, &
  & 0.17276799E-05_JPRB, 0.17318716E-05_JPRB, 0.17386113E-05_JPRB, 0.17469303E-05_JPRB, 0.17565580E-05_JPRB, 0.17655688E-05_JPRB, &
  & 0.17730934E-05_JPRB, 0.17788457E-05_JPRB, 0.17859205E-05_JPRB, 0.17954883E-05_JPRB, 0.18046999E-05_JPRB, 0.18134818E-05_JPRB, &
  & 0.18229537E-05_JPRB, 0.18306804E-05_JPRB, 0.18383786E-05_JPRB, 0.18447525E-05_JPRB, 0.18495956E-05_JPRB, 0.18526528E-05_JPRB, &
  & 0.18537129E-05_JPRB, 0.18551373E-05_JPRB, 0.18559284E-05_JPRB, 0.18574647E-05_JPRB, 0.18576963E-05_JPRB, 0.18588012E-05_JPRB, &
  & 0.18595655E-05_JPRB, 0.18612632E-05_JPRB, 0.18635094E-05_JPRB, 0.18652904E-05_JPRB  /)

RGHG2(:,83, 3) = (/ &
  & 0.16763047E-05_JPRB, 0.16763123E-05_JPRB, 0.16763557E-05_JPRB, 0.16763745E-05_JPRB, 0.16764498E-05_JPRB, 0.16765620E-05_JPRB, &
  & 0.16764812E-05_JPRB, 0.16764477E-05_JPRB, 0.16764224E-05_JPRB, 0.16764399E-05_JPRB, 0.16765404E-05_JPRB, 0.16766754E-05_JPRB, &
  & 0.16767758E-05_JPRB, 0.16769022E-05_JPRB, 0.16771482E-05_JPRB, 0.16774869E-05_JPRB, 0.16777079E-05_JPRB, 0.16780346E-05_JPRB, &
  & 0.16787529E-05_JPRB, 0.16794513E-05_JPRB, 0.16805339E-05_JPRB, 0.16817472E-05_JPRB, 0.16825237E-05_JPRB, 0.16838558E-05_JPRB, &
  & 0.16860313E-05_JPRB, 0.16878432E-05_JPRB, 0.16901995E-05_JPRB, 0.16937261E-05_JPRB, 0.16971983E-05_JPRB, 0.17072229E-05_JPRB, &
  & 0.17106404E-05_JPRB, 0.17121776E-05_JPRB, 0.17174680E-05_JPRB, 0.17173162E-05_JPRB, 0.17219451E-05_JPRB, 0.17250536E-05_JPRB, &
  & 0.17285562E-05_JPRB, 0.17328854E-05_JPRB, 0.17397771E-05_JPRB, 0.17479893E-05_JPRB, 0.17577056E-05_JPRB, 0.17667022E-05_JPRB, &
  & 0.17741347E-05_JPRB, 0.17797448E-05_JPRB, 0.17869572E-05_JPRB, 0.17968010E-05_JPRB, 0.18060453E-05_JPRB, 0.18145723E-05_JPRB, &
  & 0.18240973E-05_JPRB, 0.18319808E-05_JPRB, 0.18401885E-05_JPRB, 0.18465031E-05_JPRB, 0.18512002E-05_JPRB, 0.18544503E-05_JPRB, &
  & 0.18560201E-05_JPRB, 0.18577490E-05_JPRB, 0.18586233E-05_JPRB, 0.18601115E-05_JPRB, 0.18601346E-05_JPRB, 0.18612172E-05_JPRB, &
  & 0.18620331E-05_JPRB, 0.18636977E-05_JPRB, 0.18661856E-05_JPRB, 0.18677261E-05_JPRB  /)

RGHG2(:,84, 3) = (/ &
  & 0.16763058E-05_JPRB, 0.16763155E-05_JPRB, 0.16763689E-05_JPRB, 0.16763854E-05_JPRB, 0.16764680E-05_JPRB, 0.16765972E-05_JPRB, &
  & 0.16765291E-05_JPRB, 0.16764851E-05_JPRB, 0.16764624E-05_JPRB, 0.16764574E-05_JPRB, 0.16765460E-05_JPRB, 0.16766811E-05_JPRB, &
  & 0.16767935E-05_JPRB, 0.16769156E-05_JPRB, 0.16771591E-05_JPRB, 0.16775053E-05_JPRB, 0.16777190E-05_JPRB, 0.16780314E-05_JPRB, &
  & 0.16787610E-05_JPRB, 0.16794523E-05_JPRB, 0.16805682E-05_JPRB, 0.16818383E-05_JPRB, 0.16825788E-05_JPRB, 0.16839590E-05_JPRB, &
  & 0.16862159E-05_JPRB, 0.16880460E-05_JPRB, 0.16904223E-05_JPRB, 0.16940310E-05_JPRB, 0.16974351E-05_JPRB, 0.17075683E-05_JPRB, &
  & 0.17110969E-05_JPRB, 0.17125378E-05_JPRB, 0.17180648E-05_JPRB, 0.17175314E-05_JPRB, 0.17225433E-05_JPRB, 0.17257250E-05_JPRB, &
  & 0.17291863E-05_JPRB, 0.17336044E-05_JPRB, 0.17406901E-05_JPRB, 0.17488456E-05_JPRB, 0.17586461E-05_JPRB, 0.17675687E-05_JPRB, &
  & 0.17749417E-05_JPRB, 0.17804699E-05_JPRB, 0.17878158E-05_JPRB, 0.17978864E-05_JPRB, 0.18072280E-05_JPRB, 0.18154749E-05_JPRB, &
  & 0.18250840E-05_JPRB, 0.18330876E-05_JPRB, 0.18417862E-05_JPRB, 0.18480167E-05_JPRB, 0.18525157E-05_JPRB, 0.18559439E-05_JPRB, &
  & 0.18579819E-05_JPRB, 0.18601212E-05_JPRB, 0.18612087E-05_JPRB, 0.18627283E-05_JPRB, 0.18625231E-05_JPRB, 0.18635818E-05_JPRB, &
  & 0.18644523E-05_JPRB, 0.18660148E-05_JPRB, 0.18686822E-05_JPRB, 0.18699660E-05_JPRB  /)

RGHG2(:,85, 3) = (/ &
  & 0.16763170E-05_JPRB, 0.16763242E-05_JPRB, 0.16763904E-05_JPRB, 0.16764069E-05_JPRB, 0.16764947E-05_JPRB, 0.16766367E-05_JPRB, &
  & 0.16765866E-05_JPRB, 0.16765220E-05_JPRB, 0.16765044E-05_JPRB, 0.16764712E-05_JPRB, 0.16765546E-05_JPRB, 0.16766923E-05_JPRB, &
  & 0.16768124E-05_JPRB, 0.16769397E-05_JPRB, 0.16771806E-05_JPRB, 0.16775345E-05_JPRB, 0.16777430E-05_JPRB, 0.16780504E-05_JPRB, &
  & 0.16788134E-05_JPRB, 0.16795020E-05_JPRB, 0.16806693E-05_JPRB, 0.16820369E-05_JPRB, 0.16827184E-05_JPRB, 0.16841654E-05_JPRB, &
  & 0.16865044E-05_JPRB, 0.16883268E-05_JPRB, 0.16906903E-05_JPRB, 0.16944685E-05_JPRB, 0.16977031E-05_JPRB, 0.17081008E-05_JPRB, &
  & 0.17117809E-05_JPRB, 0.17132012E-05_JPRB, 0.17191544E-05_JPRB, 0.17179047E-05_JPRB, 0.17231528E-05_JPRB, 0.17263550E-05_JPRB, &
  & 0.17296674E-05_JPRB, 0.17341369E-05_JPRB, 0.17412868E-05_JPRB, 0.17495013E-05_JPRB, 0.17595072E-05_JPRB, 0.17684349E-05_JPRB, &
  & 0.17756668E-05_JPRB, 0.17811435E-05_JPRB, 0.17886667E-05_JPRB, 0.17989991E-05_JPRB, 0.18084152E-05_JPRB, 0.18163232E-05_JPRB, &
  & 0.18260195E-05_JPRB, 0.18341310E-05_JPRB, 0.18431634E-05_JPRB, 0.18493066E-05_JPRB, 0.18535565E-05_JPRB, 0.18570541E-05_JPRB, &
  & 0.18595876E-05_JPRB, 0.18622661E-05_JPRB, 0.18640880E-05_JPRB, 0.18654714E-05_JPRB, 0.18648632E-05_JPRB, 0.18656780E-05_JPRB, &
  & 0.18665689E-05_JPRB, 0.18680545E-05_JPRB, 0.18710069E-05_JPRB, 0.18719569E-05_JPRB  /)

RGHG2(:,86, 3) = (/ &
  & 0.16763317E-05_JPRB, 0.16763342E-05_JPRB, 0.16764074E-05_JPRB, 0.16764239E-05_JPRB, 0.16765248E-05_JPRB, 0.16766797E-05_JPRB, &
  & 0.16766437E-05_JPRB, 0.16765565E-05_JPRB, 0.16765500E-05_JPRB, 0.16764824E-05_JPRB, 0.16765587E-05_JPRB, 0.16767030E-05_JPRB, &
  & 0.16768328E-05_JPRB, 0.16769733E-05_JPRB, 0.16772076E-05_JPRB, 0.16775732E-05_JPRB, 0.16777807E-05_JPRB, 0.16780848E-05_JPRB, &
  & 0.16789035E-05_JPRB, 0.16796137E-05_JPRB, 0.16808346E-05_JPRB, 0.16823405E-05_JPRB, 0.16829204E-05_JPRB, 0.16844566E-05_JPRB, &
  & 0.16868159E-05_JPRB, 0.16887833E-05_JPRB, 0.16910314E-05_JPRB, 0.16950743E-05_JPRB, 0.16979939E-05_JPRB, 0.17088664E-05_JPRB, &
  & 0.17128374E-05_JPRB, 0.17143395E-05_JPRB, 0.17213138E-05_JPRB, 0.17184600E-05_JPRB, 0.17236904E-05_JPRB, 0.17269736E-05_JPRB, &
  & 0.17301302E-05_JPRB, 0.17346392E-05_JPRB, 0.17419240E-05_JPRB, 0.17501396E-05_JPRB, 0.17605267E-05_JPRB, 0.17695038E-05_JPRB, &
  & 0.17765194E-05_JPRB, 0.17818823E-05_JPRB, 0.17896056E-05_JPRB, 0.18003218E-05_JPRB, 0.18097344E-05_JPRB, 0.18172173E-05_JPRB, &
  & 0.18269652E-05_JPRB, 0.18351449E-05_JPRB, 0.18444003E-05_JPRB, 0.18504116E-05_JPRB, 0.18543951E-05_JPRB, 0.18579703E-05_JPRB, &
  & 0.18609235E-05_JPRB, 0.18640696E-05_JPRB, 0.18669269E-05_JPRB, 0.18678983E-05_JPRB, 0.18667744E-05_JPRB, 0.18672677E-05_JPRB, &
  & 0.18681833E-05_JPRB, 0.18696578E-05_JPRB, 0.18730855E-05_JPRB, 0.18738467E-05_JPRB  /)

RGHG2(:,87, 3) = (/ &
  & 0.16763456E-05_JPRB, 0.16763456E-05_JPRB, 0.16764214E-05_JPRB, 0.16764378E-05_JPRB, 0.16765572E-05_JPRB, 0.16767225E-05_JPRB, &
  & 0.16767009E-05_JPRB, 0.16765861E-05_JPRB, 0.16765995E-05_JPRB, 0.16764925E-05_JPRB, 0.16765622E-05_JPRB, 0.16767104E-05_JPRB, &
  & 0.16768534E-05_JPRB, 0.16770082E-05_JPRB, 0.16772427E-05_JPRB, 0.16776228E-05_JPRB, 0.16778315E-05_JPRB, 0.16781344E-05_JPRB, &
  & 0.16790267E-05_JPRB, 0.16798005E-05_JPRB, 0.16810456E-05_JPRB, 0.16827557E-05_JPRB, 0.16831883E-05_JPRB, 0.16847986E-05_JPRB, &
  & 0.16871793E-05_JPRB, 0.16894343E-05_JPRB, 0.16914420E-05_JPRB, 0.16958279E-05_JPRB, 0.16983471E-05_JPRB, 0.17101795E-05_JPRB, &
  & 0.17145221E-05_JPRB, 0.17161248E-05_JPRB, 0.17252452E-05_JPRB, 0.17192869E-05_JPRB, 0.17242931E-05_JPRB, 0.17276451E-05_JPRB, &
  & 0.17306753E-05_JPRB, 0.17352143E-05_JPRB, 0.17427861E-05_JPRB, 0.17509017E-05_JPRB, 0.17618750E-05_JPRB, 0.17710207E-05_JPRB, &
  & 0.17777069E-05_JPRB, 0.17828812E-05_JPRB, 0.17908263E-05_JPRB, 0.18020473E-05_JPRB, 0.18113828E-05_JPRB, 0.18183067E-05_JPRB, &
  & 0.18280498E-05_JPRB, 0.18362376E-05_JPRB, 0.18456348E-05_JPRB, 0.18514364E-05_JPRB, 0.18551407E-05_JPRB, 0.18587571E-05_JPRB, &
  & 0.18621273E-05_JPRB, 0.18656559E-05_JPRB, 0.18695263E-05_JPRB, 0.18698753E-05_JPRB, 0.18682813E-05_JPRB, 0.18685237E-05_JPRB, &
  & 0.18693812E-05_JPRB, 0.18708448E-05_JPRB, 0.18748526E-05_JPRB, 0.18755153E-05_JPRB  /)

RGHG2(:,88, 3) = (/ &
  & 0.16763563E-05_JPRB, 0.16763571E-05_JPRB, 0.16764320E-05_JPRB, 0.16764485E-05_JPRB, 0.16765922E-05_JPRB, 0.16767642E-05_JPRB, &
  & 0.16767630E-05_JPRB, 0.16766105E-05_JPRB, 0.16766537E-05_JPRB, 0.16765012E-05_JPRB, 0.16765670E-05_JPRB, 0.16767152E-05_JPRB, &
  & 0.16768739E-05_JPRB, 0.16770432E-05_JPRB, 0.16772875E-05_JPRB, 0.16776904E-05_JPRB, 0.16779003E-05_JPRB, 0.16782079E-05_JPRB, &
  & 0.16791920E-05_JPRB, 0.16800776E-05_JPRB, 0.16813038E-05_JPRB, 0.16833063E-05_JPRB, 0.16835609E-05_JPRB, 0.16851842E-05_JPRB, &
  & 0.16877642E-05_JPRB, 0.16902702E-05_JPRB, 0.16919320E-05_JPRB, 0.16967961E-05_JPRB, 0.16988442E-05_JPRB, 0.17127369E-05_JPRB, &
  & 0.17170409E-05_JPRB, 0.17189702E-05_JPRB, 0.17322266E-05_JPRB, 0.17206117E-05_JPRB, 0.17251157E-05_JPRB, 0.17285388E-05_JPRB, &
  & 0.17314734E-05_JPRB, 0.17360308E-05_JPRB, 0.17441632E-05_JPRB, 0.17520941E-05_JPRB, 0.17638875E-05_JPRB, 0.17734409E-05_JPRB, &
  & 0.17796672E-05_JPRB, 0.17845542E-05_JPRB, 0.17927222E-05_JPRB, 0.18045219E-05_JPRB, 0.18137477E-05_JPRB, 0.18198182E-05_JPRB, &
  & 0.18294806E-05_JPRB, 0.18375648E-05_JPRB, 0.18470406E-05_JPRB, 0.18525161E-05_JPRB, 0.18558796E-05_JPRB, 0.18594829E-05_JPRB, &
  & 0.18633863E-05_JPRB, 0.18670791E-05_JPRB, 0.18718302E-05_JPRB, 0.18714767E-05_JPRB, 0.18694314E-05_JPRB, 0.18695431E-05_JPRB, &
  & 0.18702378E-05_JPRB, 0.18716023E-05_JPRB, 0.18761904E-05_JPRB, 0.18768460E-05_JPRB  /)

RGHG2(:,89, 3) = (/ &
  & 0.16763617E-05_JPRB, 0.16763657E-05_JPRB, 0.16764374E-05_JPRB, 0.16764550E-05_JPRB, 0.16766292E-05_JPRB, 0.16768041E-05_JPRB, &
  & 0.16768352E-05_JPRB, 0.16766302E-05_JPRB, 0.16767093E-05_JPRB, 0.16765073E-05_JPRB, 0.16765724E-05_JPRB, 0.16767209E-05_JPRB, &
  & 0.16768944E-05_JPRB, 0.16770802E-05_JPRB, 0.16773382E-05_JPRB, 0.16777891E-05_JPRB, 0.16779883E-05_JPRB, 0.16783196E-05_JPRB, &
  & 0.16794235E-05_JPRB, 0.16804361E-05_JPRB, 0.16816125E-05_JPRB, 0.16839791E-05_JPRB, 0.16840922E-05_JPRB, 0.16855997E-05_JPRB, &
  & 0.16890854E-05_JPRB, 0.16912014E-05_JPRB, 0.16925110E-05_JPRB, 0.16980855E-05_JPRB, 0.16996492E-05_JPRB, 0.17176585E-05_JPRB, &
  & 0.17204126E-05_JPRB, 0.17233613E-05_JPRB, 0.17434043E-05_JPRB, 0.17226820E-05_JPRB, 0.17263376E-05_JPRB, 0.17299427E-05_JPRB, &
  & 0.17328155E-05_JPRB, 0.17373272E-05_JPRB, 0.17465034E-05_JPRB, 0.17543144E-05_JPRB, 0.17671580E-05_JPRB, 0.17775274E-05_JPRB, &
  & 0.17832628E-05_JPRB, 0.17876368E-05_JPRB, 0.17960040E-05_JPRB, 0.18082619E-05_JPRB, 0.18175177E-05_JPRB, 0.18221027E-05_JPRB, &
  & 0.18315800E-05_JPRB, 0.18393109E-05_JPRB, 0.18488556E-05_JPRB, 0.18538153E-05_JPRB, 0.18566852E-05_JPRB, 0.18602257E-05_JPRB, &
  & 0.18648918E-05_JPRB, 0.18682920E-05_JPRB, 0.18738464E-05_JPRB, 0.18729187E-05_JPRB, 0.18702772E-05_JPRB, 0.18703403E-05_JPRB, &
  & 0.18708358E-05_JPRB, 0.18719245E-05_JPRB, 0.18768959E-05_JPRB, 0.18776436E-05_JPRB  /)

RGHG2(:,90, 3) = (/ &
  & 0.16763640E-05_JPRB, 0.16763738E-05_JPRB, 0.16764399E-05_JPRB, 0.16764661E-05_JPRB, 0.16766640E-05_JPRB, 0.16768425E-05_JPRB, &
  & 0.16769129E-05_JPRB, 0.16766474E-05_JPRB, 0.16767537E-05_JPRB, 0.16765157E-05_JPRB, 0.16765749E-05_JPRB, 0.16767263E-05_JPRB, &
  & 0.16769179E-05_JPRB, 0.16771157E-05_JPRB, 0.16773826E-05_JPRB, 0.16779411E-05_JPRB, 0.16780731E-05_JPRB, 0.16784727E-05_JPRB, &
  & 0.16798009E-05_JPRB, 0.16808311E-05_JPRB, 0.16819908E-05_JPRB, 0.16846773E-05_JPRB, 0.16848034E-05_JPRB, 0.16860295E-05_JPRB, &
  & 0.16926253E-05_JPRB, 0.16923017E-05_JPRB, 0.16933043E-05_JPRB, 0.16998154E-05_JPRB, 0.17011615E-05_JPRB, 0.17256592E-05_JPRB, &
  & 0.17246565E-05_JPRB, 0.17292425E-05_JPRB, 0.17563883E-05_JPRB, 0.17251627E-05_JPRB, 0.17281221E-05_JPRB, 0.17321295E-05_JPRB, &
  & 0.17351813E-05_JPRB, 0.17392633E-05_JPRB, 0.17504256E-05_JPRB, 0.17585559E-05_JPRB, 0.17728518E-05_JPRB, 0.17845438E-05_JPRB, &
  & 0.17902115E-05_JPRB, 0.17931312E-05_JPRB, 0.18018690E-05_JPRB, 0.18140792E-05_JPRB, 0.18240092E-05_JPRB, 0.18258822E-05_JPRB, &
  & 0.18349369E-05_JPRB, 0.18416884E-05_JPRB, 0.18515334E-05_JPRB, 0.18554902E-05_JPRB, 0.18576859E-05_JPRB, 0.18611031E-05_JPRB, &
  & 0.18664942E-05_JPRB, 0.18693208E-05_JPRB, 0.18758982E-05_JPRB, 0.18741587E-05_JPRB, 0.18708161E-05_JPRB, 0.18708300E-05_JPRB, &
  & 0.18712363E-05_JPRB, 0.18720775E-05_JPRB, 0.18771517E-05_JPRB, 0.18778753E-05_JPRB  /)

RGHG2(:,91, 3) = (/ &
  & 0.16763615E-05_JPRB, 0.16763714E-05_JPRB, 0.16764438E-05_JPRB, 0.16764668E-05_JPRB, 0.16766743E-05_JPRB, 0.16768751E-05_JPRB, &
  & 0.16769870E-05_JPRB, 0.16766545E-05_JPRB, 0.16767895E-05_JPRB, 0.16765228E-05_JPRB, 0.16765788E-05_JPRB, 0.16767302E-05_JPRB, &
  & 0.16769409E-05_JPRB, 0.16771484E-05_JPRB, 0.16774216E-05_JPRB, 0.16781492E-05_JPRB, 0.16781855E-05_JPRB, 0.16786233E-05_JPRB, &
  & 0.16803057E-05_JPRB, 0.16814317E-05_JPRB, 0.16826137E-05_JPRB, 0.16858172E-05_JPRB, 0.16860773E-05_JPRB, 0.16866205E-05_JPRB, &
  & 0.17007151E-05_JPRB, 0.16942489E-05_JPRB, 0.16946835E-05_JPRB, 0.17030198E-05_JPRB, 0.17040404E-05_JPRB, 0.17345245E-05_JPRB, &
  & 0.17305605E-05_JPRB, 0.17384556E-05_JPRB, 0.17717217E-05_JPRB, 0.17279332E-05_JPRB, 0.17305671E-05_JPRB, 0.17351105E-05_JPRB, &
  & 0.17392951E-05_JPRB, 0.17417019E-05_JPRB, 0.17562179E-05_JPRB, 0.17651205E-05_JPRB, 0.17822277E-05_JPRB, 0.17954992E-05_JPRB, &
  & 0.18022486E-05_JPRB, 0.18018337E-05_JPRB, 0.18113948E-05_JPRB, 0.18220127E-05_JPRB, 0.18335030E-05_JPRB, 0.18328808E-05_JPRB, &
  & 0.18402985E-05_JPRB, 0.18452502E-05_JPRB, 0.18556409E-05_JPRB, 0.18576065E-05_JPRB, 0.18590683E-05_JPRB, 0.18623738E-05_JPRB, &
  & 0.18685372E-05_JPRB, 0.18704862E-05_JPRB, 0.18784900E-05_JPRB, 0.18760931E-05_JPRB, 0.18711678E-05_JPRB, 0.18711019E-05_JPRB, &
  & 0.18715497E-05_JPRB, 0.18721324E-05_JPRB, 0.18772290E-05_JPRB, 0.18779303E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ---GEMS----

RGHG2(:, 1, 4) = (/ &
  & 0.16160571E-06_JPRB, 0.16524378E-06_JPRB, 0.17100213E-06_JPRB, 0.17656624E-06_JPRB, 0.18348680E-06_JPRB, 0.19049297E-06_JPRB, &
  & 0.19899058E-06_JPRB, 0.20822897E-06_JPRB, 0.21813571E-06_JPRB, 0.22908614E-06_JPRB, 0.24015838E-06_JPRB, 0.25086517E-06_JPRB, &
  & 0.26162793E-06_JPRB, 0.27243349E-06_JPRB, 0.28139532E-06_JPRB, 0.28879657E-06_JPRB, 0.29478540E-06_JPRB, 0.29959555E-06_JPRB, &
  & 0.30366821E-06_JPRB, 0.30642393E-06_JPRB, 0.30777709E-06_JPRB, 0.30906441E-06_JPRB, 0.31069084E-06_JPRB, 0.31260371E-06_JPRB, &
  & 0.31472399E-06_JPRB, 0.31682782E-06_JPRB, 0.31833572E-06_JPRB, 0.31886250E-06_JPRB, 0.31812172E-06_JPRB, 0.31579072E-06_JPRB, &
  & 0.31170160E-06_JPRB, 0.30625602E-06_JPRB, 0.29986552E-06_JPRB, 0.29293838E-06_JPRB, 0.28624169E-06_JPRB, 0.28020019E-06_JPRB, &
  & 0.27462950E-06_JPRB, 0.26928598E-06_JPRB, 0.26408404E-06_JPRB, 0.25911914E-06_JPRB, 0.25436825E-06_JPRB, 0.24967992E-06_JPRB, &
  & 0.24522863E-06_JPRB, 0.24101769E-06_JPRB, 0.23731377E-06_JPRB, 0.23424858E-06_JPRB, 0.23181551E-06_JPRB, 0.22978083E-06_JPRB, &
  & 0.22813464E-06_JPRB, 0.22675185E-06_JPRB, 0.22561598E-06_JPRB, 0.22463815E-06_JPRB, 0.22369982E-06_JPRB, 0.22280429E-06_JPRB, &
  & 0.22198449E-06_JPRB, 0.22135565E-06_JPRB, 0.22082887E-06_JPRB, 0.22023625E-06_JPRB, 0.21972593E-06_JPRB, 0.21940328E-06_JPRB, &
  & 0.21918598E-06_JPRB, 0.21900819E-06_JPRB, 0.21884687E-06_JPRB, 0.21884357E-06_JPRB  /)

RGHG2(:, 2, 4) = (/ &
  & 0.16160571E-06_JPRB, 0.16524378E-06_JPRB, 0.17100213E-06_JPRB, 0.17656624E-06_JPRB, 0.18348680E-06_JPRB, 0.19049297E-06_JPRB, &
  & 0.19899058E-06_JPRB, 0.20822897E-06_JPRB, 0.21813571E-06_JPRB, 0.22908614E-06_JPRB, 0.24015838E-06_JPRB, 0.25086517E-06_JPRB, &
  & 0.26162793E-06_JPRB, 0.27243349E-06_JPRB, 0.28139532E-06_JPRB, 0.28879657E-06_JPRB, 0.29478540E-06_JPRB, 0.29959555E-06_JPRB, &
  & 0.30366821E-06_JPRB, 0.30642393E-06_JPRB, 0.30777709E-06_JPRB, 0.30906441E-06_JPRB, 0.31069084E-06_JPRB, 0.31260371E-06_JPRB, &
  & 0.31472399E-06_JPRB, 0.31682782E-06_JPRB, 0.31833572E-06_JPRB, 0.31886250E-06_JPRB, 0.31812172E-06_JPRB, 0.31579072E-06_JPRB, &
  & 0.31170160E-06_JPRB, 0.30625602E-06_JPRB, 0.29986552E-06_JPRB, 0.29293838E-06_JPRB, 0.28624169E-06_JPRB, 0.28020019E-06_JPRB, &
  & 0.27462950E-06_JPRB, 0.26928598E-06_JPRB, 0.26408404E-06_JPRB, 0.25911914E-06_JPRB, 0.25436825E-06_JPRB, 0.24967992E-06_JPRB, &
  & 0.24522863E-06_JPRB, 0.24101769E-06_JPRB, 0.23731377E-06_JPRB, 0.23424858E-06_JPRB, 0.23181551E-06_JPRB, 0.22978083E-06_JPRB, &
  & 0.22813464E-06_JPRB, 0.22675185E-06_JPRB, 0.22561598E-06_JPRB, 0.22463815E-06_JPRB, 0.22369982E-06_JPRB, 0.22280429E-06_JPRB, &
  & 0.22198449E-06_JPRB, 0.22135565E-06_JPRB, 0.22082887E-06_JPRB, 0.22023625E-06_JPRB, 0.21972593E-06_JPRB, 0.21940328E-06_JPRB, &
  & 0.21918598E-06_JPRB, 0.21900819E-06_JPRB, 0.21884687E-06_JPRB, 0.21884357E-06_JPRB  /)

RGHG2(:, 3, 4) = (/ &
  & 0.16160571E-06_JPRB, 0.16524378E-06_JPRB, 0.17100213E-06_JPRB, 0.17656624E-06_JPRB, 0.18348680E-06_JPRB, 0.19049297E-06_JPRB, &
  & 0.19899058E-06_JPRB, 0.20822897E-06_JPRB, 0.21813571E-06_JPRB, 0.22908614E-06_JPRB, 0.24015838E-06_JPRB, 0.25086517E-06_JPRB, &
  & 0.26162793E-06_JPRB, 0.27243349E-06_JPRB, 0.28139532E-06_JPRB, 0.28879657E-06_JPRB, 0.29478540E-06_JPRB, 0.29959555E-06_JPRB, &
  & 0.30366821E-06_JPRB, 0.30642393E-06_JPRB, 0.30777709E-06_JPRB, 0.30906441E-06_JPRB, 0.31069084E-06_JPRB, 0.31260371E-06_JPRB, &
  & 0.31472399E-06_JPRB, 0.31682782E-06_JPRB, 0.31833572E-06_JPRB, 0.31886250E-06_JPRB, 0.31812172E-06_JPRB, 0.31579072E-06_JPRB, &
  & 0.31170160E-06_JPRB, 0.30625602E-06_JPRB, 0.29986552E-06_JPRB, 0.29293838E-06_JPRB, 0.28624169E-06_JPRB, 0.28020019E-06_JPRB, &
  & 0.27462950E-06_JPRB, 0.26928598E-06_JPRB, 0.26408404E-06_JPRB, 0.25911914E-06_JPRB, 0.25436825E-06_JPRB, 0.24967992E-06_JPRB, &
  & 0.24522863E-06_JPRB, 0.24101769E-06_JPRB, 0.23731377E-06_JPRB, 0.23424858E-06_JPRB, 0.23181551E-06_JPRB, 0.22978083E-06_JPRB, &
  & 0.22813464E-06_JPRB, 0.22675185E-06_JPRB, 0.22561598E-06_JPRB, 0.22463815E-06_JPRB, 0.22369982E-06_JPRB, 0.22280429E-06_JPRB, &
  & 0.22198449E-06_JPRB, 0.22135565E-06_JPRB, 0.22082887E-06_JPRB, 0.22023625E-06_JPRB, 0.21972593E-06_JPRB, 0.21940328E-06_JPRB, &
  & 0.21918598E-06_JPRB, 0.21900819E-06_JPRB, 0.21884687E-06_JPRB, 0.21884357E-06_JPRB  /)

RGHG2(:, 4, 4) = (/ &
  & 0.16158838E-06_JPRB, 0.16521245E-06_JPRB, 0.17095672E-06_JPRB, 0.17651992E-06_JPRB, 0.18343582E-06_JPRB, 0.19044368E-06_JPRB, &
  & 0.19893846E-06_JPRB, 0.20818088E-06_JPRB, 0.21809078E-06_JPRB, 0.22903936E-06_JPRB, 0.24011297E-06_JPRB, 0.25082366E-06_JPRB, &
  & 0.26158941E-06_JPRB, 0.27239765E-06_JPRB, 0.28136617E-06_JPRB, 0.28877486E-06_JPRB, 0.29477019E-06_JPRB, 0.29958903E-06_JPRB, &
  & 0.30367197E-06_JPRB, 0.30643781E-06_JPRB, 0.30780554E-06_JPRB, 0.30910784E-06_JPRB, 0.31074496E-06_JPRB, 0.31266368E-06_JPRB, &
  & 0.31478680E-06_JPRB, 0.31688941E-06_JPRB, 0.31839468E-06_JPRB, 0.31891878E-06_JPRB, 0.31817683E-06_JPRB, 0.31584426E-06_JPRB, &
  & 0.31174969E-06_JPRB, 0.30629274E-06_JPRB, 0.29988908E-06_JPRB, 0.29294993E-06_JPRB, 0.28624166E-06_JPRB, 0.28018980E-06_JPRB, &
  & 0.27461134E-06_JPRB, 0.26926205E-06_JPRB, 0.26405587E-06_JPRB, 0.25908829E-06_JPRB, 0.25433591E-06_JPRB, 0.24964603E-06_JPRB, &
  & 0.24519267E-06_JPRB, 0.24098132E-06_JPRB, 0.23727872E-06_JPRB, 0.23421560E-06_JPRB, 0.23178522E-06_JPRB, 0.22975388E-06_JPRB, &
  & 0.22811106E-06_JPRB, 0.22673125E-06_JPRB, 0.22559799E-06_JPRB, 0.22462294E-06_JPRB, 0.22368768E-06_JPRB, 0.22279494E-06_JPRB, &
  & 0.22197757E-06_JPRB, 0.22135027E-06_JPRB, 0.22082440E-06_JPRB, 0.22023266E-06_JPRB, 0.21972268E-06_JPRB, 0.21939980E-06_JPRB, &
  & 0.21918290E-06_JPRB, 0.21900593E-06_JPRB, 0.21884551E-06_JPRB, 0.21884318E-06_JPRB  /)

RGHG2(:, 5, 4) = (/ &
  & 0.16076577E-06_JPRB, 0.16372524E-06_JPRB, 0.16880130E-06_JPRB, 0.17432123E-06_JPRB, 0.18101600E-06_JPRB, 0.18810439E-06_JPRB, &
  & 0.19646456E-06_JPRB, 0.20589806E-06_JPRB, 0.21595820E-06_JPRB, 0.22681904E-06_JPRB, 0.23795755E-06_JPRB, 0.24885332E-06_JPRB, &
  & 0.25976088E-06_JPRB, 0.27069652E-06_JPRB, 0.27998232E-06_JPRB, 0.28774434E-06_JPRB, 0.29404854E-06_JPRB, 0.29927960E-06_JPRB, &
  & 0.30385048E-06_JPRB, 0.30709705E-06_JPRB, 0.30915582E-06_JPRB, 0.31116960E-06_JPRB, 0.31331388E-06_JPRB, 0.31551022E-06_JPRB, &
  & 0.31776794E-06_JPRB, 0.31981286E-06_JPRB, 0.32119315E-06_JPRB, 0.32158985E-06_JPRB, 0.32079262E-06_JPRB, 0.31838554E-06_JPRB, &
  & 0.31403258E-06_JPRB, 0.30803601E-06_JPRB, 0.30100741E-06_JPRB, 0.29349860E-06_JPRB, 0.28623989E-06_JPRB, 0.27969649E-06_JPRB, &
  & 0.27374907E-06_JPRB, 0.26812577E-06_JPRB, 0.26271889E-06_JPRB, 0.25762392E-06_JPRB, 0.25280063E-06_JPRB, 0.24803743E-06_JPRB, &
  & 0.24348552E-06_JPRB, 0.23925495E-06_JPRB, 0.23561484E-06_JPRB, 0.23265027E-06_JPRB, 0.23034728E-06_JPRB, 0.22847458E-06_JPRB, &
  & 0.22699160E-06_JPRB, 0.22575361E-06_JPRB, 0.22474414E-06_JPRB, 0.22390129E-06_JPRB, 0.22311145E-06_JPRB, 0.22235091E-06_JPRB, &
  & 0.22164891E-06_JPRB, 0.22109492E-06_JPRB, 0.22061232E-06_JPRB, 0.22006264E-06_JPRB, 0.21956828E-06_JPRB, 0.21923458E-06_JPRB, &
  & 0.21903692E-06_JPRB, 0.21889840E-06_JPRB, 0.21878125E-06_JPRB, 0.21882459E-06_JPRB  /)

RGHG2(:, 6, 4) = (/ &
  & 0.15953158E-06_JPRB, 0.16149390E-06_JPRB, 0.16556742E-06_JPRB, 0.17102244E-06_JPRB, 0.17738543E-06_JPRB, 0.18459462E-06_JPRB, &
  & 0.19275284E-06_JPRB, 0.20247305E-06_JPRB, 0.21275858E-06_JPRB, 0.22348779E-06_JPRB, 0.23472367E-06_JPRB, 0.24589712E-06_JPRB, &
  & 0.25701745E-06_JPRB, 0.26814423E-06_JPRB, 0.27790605E-06_JPRB, 0.28619820E-06_JPRB, 0.29296581E-06_JPRB, 0.29881535E-06_JPRB, &
  & 0.30411830E-06_JPRB, 0.30808613E-06_JPRB, 0.31118170E-06_JPRB, 0.31426295E-06_JPRB, 0.31716816E-06_JPRB, 0.31978102E-06_JPRB, &
  & 0.32224070E-06_JPRB, 0.32419907E-06_JPRB, 0.32539182E-06_JPRB, 0.32559739E-06_JPRB, 0.32471722E-06_JPRB, 0.32219834E-06_JPRB, &
  & 0.31745771E-06_JPRB, 0.31065153E-06_JPRB, 0.30268529E-06_JPRB, 0.29432179E-06_JPRB, 0.28623724E-06_JPRB, 0.27895636E-06_JPRB, &
  & 0.27245537E-06_JPRB, 0.26642095E-06_JPRB, 0.26071295E-06_JPRB, 0.25542684E-06_JPRB, 0.25049717E-06_JPRB, 0.24562398E-06_JPRB, &
  & 0.24092421E-06_JPRB, 0.23666479E-06_JPRB, 0.23311845E-06_JPRB, 0.23030173E-06_JPRB, 0.22818988E-06_JPRB, 0.22655519E-06_JPRB, &
  & 0.22531203E-06_JPRB, 0.22428681E-06_JPRB, 0.22346306E-06_JPRB, 0.22281856E-06_JPRB, 0.22224690E-06_JPRB, 0.22168470E-06_JPRB, &
  & 0.22115581E-06_JPRB, 0.22071181E-06_JPRB, 0.22029412E-06_JPRB, 0.21980756E-06_JPRB, 0.21933663E-06_JPRB, 0.21898671E-06_JPRB, &
  & 0.21881790E-06_JPRB, 0.21873708E-06_JPRB, 0.21868484E-06_JPRB, 0.21879670E-06_JPRB  /)

RGHG2(:, 7, 4) = (/ &
  & 0.15396721E-06_JPRB, 0.15582574E-06_JPRB, 0.15905612E-06_JPRB, 0.16399766E-06_JPRB, 0.16995652E-06_JPRB, 0.17651876E-06_JPRB, &
  & 0.18413330E-06_JPRB, 0.19378614E-06_JPRB, 0.20439863E-06_JPRB, 0.21547285E-06_JPRB, 0.22718372E-06_JPRB, 0.23907027E-06_JPRB, &
  & 0.25119257E-06_JPRB, 0.26339634E-06_JPRB, 0.27450289E-06_JPRB, 0.28401389E-06_JPRB, 0.29202357E-06_JPRB, 0.29948335E-06_JPRB, &
  & 0.30674634E-06_JPRB, 0.31226940E-06_JPRB, 0.31628510E-06_JPRB, 0.32025802E-06_JPRB, 0.32438271E-06_JPRB, 0.32806213E-06_JPRB, &
  & 0.33135763E-06_JPRB, 0.33396998E-06_JPRB, 0.33574238E-06_JPRB, 0.33657851E-06_JPRB, 0.33603396E-06_JPRB, 0.33296599E-06_JPRB, &
  & 0.32657666E-06_JPRB, 0.31713262E-06_JPRB, 0.30646876E-06_JPRB, 0.29596899E-06_JPRB, 0.28612268E-06_JPRB, 0.27742616E-06_JPRB, &
  & 0.26987984E-06_JPRB, 0.26294217E-06_JPRB, 0.25652177E-06_JPRB, 0.25074705E-06_JPRB, 0.24551800E-06_JPRB, 0.24042928E-06_JPRB, &
  & 0.23559281E-06_JPRB, 0.23136622E-06_JPRB, 0.22792814E-06_JPRB, 0.22532836E-06_JPRB, 0.22351585E-06_JPRB, 0.22222024E-06_JPRB, &
  & 0.22135551E-06_JPRB, 0.22078090E-06_JPRB, 0.22051905E-06_JPRB, 0.22049382E-06_JPRB, 0.22056900E-06_JPRB, 0.22060551E-06_JPRB, &
  & 0.22059758E-06_JPRB, 0.22053989E-06_JPRB, 0.22040114E-06_JPRB, 0.22018091E-06_JPRB, 0.21997261E-06_JPRB, 0.21989806E-06_JPRB, &
  & 0.21999472E-06_JPRB, 0.22018357E-06_JPRB, 0.22032592E-06_JPRB, 0.22048477E-06_JPRB  /)

RGHG2(:, 8, 4) = (/ &
  & 0.14449855E-06_JPRB, 0.14604868E-06_JPRB, 0.14859268E-06_JPRB, 0.15279295E-06_JPRB, 0.15809349E-06_JPRB, 0.16402185E-06_JPRB, &
  & 0.17107036E-06_JPRB, 0.18052688E-06_JPRB, 0.19175169E-06_JPRB, 0.20389216E-06_JPRB, 0.21688049E-06_JPRB, 0.23035909E-06_JPRB, &
  & 0.24471650E-06_JPRB, 0.25947148E-06_JPRB, 0.27307770E-06_JPRB, 0.28501258E-06_JPRB, 0.29572166E-06_JPRB, 0.30634115E-06_JPRB, &
  & 0.31673937E-06_JPRB, 0.32480464E-06_JPRB, 0.33037973E-06_JPRB, 0.33514427E-06_JPRB, 0.34044474E-06_JPRB, 0.34533038E-06_JPRB, &
  & 0.34921709E-06_JPRB, 0.35224597E-06_JPRB, 0.35489576E-06_JPRB, 0.35703720E-06_JPRB, 0.35776613E-06_JPRB, 0.35448982E-06_JPRB, &
  & 0.34530204E-06_JPRB, 0.33081172E-06_JPRB, 0.31459209E-06_JPRB, 0.29979128E-06_JPRB, 0.28716001E-06_JPRB, 0.27652995E-06_JPRB, &
  & 0.26778576E-06_JPRB, 0.26002793E-06_JPRB, 0.25301877E-06_JPRB, 0.24686329E-06_JPRB, 0.24133889E-06_JPRB, 0.23590730E-06_JPRB, &
  & 0.23060610E-06_JPRB, 0.22598387E-06_JPRB, 0.22210443E-06_JPRB, 0.21912233E-06_JPRB, 0.21716800E-06_JPRB, 0.21607302E-06_JPRB, &
  & 0.21572683E-06_JPRB, 0.21590087E-06_JPRB, 0.21665906E-06_JPRB, 0.21788947E-06_JPRB, 0.21929608E-06_JPRB, 0.22061900E-06_JPRB, &
  & 0.22183370E-06_JPRB, 0.22286083E-06_JPRB, 0.22367054E-06_JPRB, 0.22430065E-06_JPRB, 0.22486660E-06_JPRB, 0.22557741E-06_JPRB, &
  & 0.22654324E-06_JPRB, 0.22753285E-06_JPRB, 0.22825479E-06_JPRB, 0.22853848E-06_JPRB  /)

RGHG2(:, 9, 4) = (/ &
  & 0.12928085E-06_JPRB, 0.13027193E-06_JPRB, 0.13237200E-06_JPRB, 0.13592311E-06_JPRB, 0.14059107E-06_JPRB, 0.14632700E-06_JPRB, &
  & 0.15342726E-06_JPRB, 0.16317466E-06_JPRB, 0.17574700E-06_JPRB, 0.19033234E-06_JPRB, 0.20604904E-06_JPRB, 0.22289753E-06_JPRB, &
  & 0.24146649E-06_JPRB, 0.26070504E-06_JPRB, 0.27865304E-06_JPRB, 0.29525635E-06_JPRB, 0.31137509E-06_JPRB, 0.32752313E-06_JPRB, &
  & 0.34254911E-06_JPRB, 0.35484225E-06_JPRB, 0.36369853E-06_JPRB, 0.37017704E-06_JPRB, 0.37659882E-06_JPRB, 0.38232744E-06_JPRB, &
  & 0.38601575E-06_JPRB, 0.38811265E-06_JPRB, 0.39050482E-06_JPRB, 0.39322997E-06_JPRB, 0.39476843E-06_JPRB, 0.39090173E-06_JPRB, &
  & 0.37770204E-06_JPRB, 0.35565756E-06_JPRB, 0.33078841E-06_JPRB, 0.30957223E-06_JPRB, 0.29333595E-06_JPRB, 0.28061261E-06_JPRB, &
  & 0.27106506E-06_JPRB, 0.26330468E-06_JPRB, 0.25661059E-06_JPRB, 0.25085939E-06_JPRB, 0.24544034E-06_JPRB, 0.23944051E-06_JPRB, &
  & 0.23290478E-06_JPRB, 0.22654740E-06_JPRB, 0.22043317E-06_JPRB, 0.21513119E-06_JPRB, 0.21170740E-06_JPRB, 0.21022480E-06_JPRB, &
  & 0.21031008E-06_JPRB, 0.21143687E-06_JPRB, 0.21377646E-06_JPRB, 0.21720025E-06_JPRB, 0.22112411E-06_JPRB, 0.22511394E-06_JPRB, &
  & 0.22904347E-06_JPRB, 0.23260728E-06_JPRB, 0.23562603E-06_JPRB, 0.23823608E-06_JPRB, 0.24056911E-06_JPRB, 0.24302797E-06_JPRB, &
  & 0.24583416E-06_JPRB, 0.24838834E-06_JPRB, 0.25016914E-06_JPRB, 0.25080107E-06_JPRB  /)

RGHG2(:,10, 4) = (/ &
  & 0.10918088E-06_JPRB, 0.10998575E-06_JPRB, 0.11195353E-06_JPRB, 0.11538113E-06_JPRB, 0.12005707E-06_JPRB, 0.12635598E-06_JPRB, &
  & 0.13470728E-06_JPRB, 0.14611621E-06_JPRB, 0.16143527E-06_JPRB, 0.18010255E-06_JPRB, 0.20035566E-06_JPRB, 0.22283913E-06_JPRB, &
  & 0.24762451E-06_JPRB, 0.27330836E-06_JPRB, 0.29810987E-06_JPRB, 0.32241412E-06_JPRB, 0.34716004E-06_JPRB, 0.37162827E-06_JPRB, &
  & 0.39334377E-06_JPRB, 0.41236811E-06_JPRB, 0.42753696E-06_JPRB, 0.43897978E-06_JPRB, 0.44788249E-06_JPRB, 0.45391424E-06_JPRB, &
  & 0.45652236E-06_JPRB, 0.45553846E-06_JPRB, 0.45451280E-06_JPRB, 0.45430834E-06_JPRB, 0.45263823E-06_JPRB, 0.44483595E-06_JPRB, &
  & 0.42579345E-06_JPRB, 0.39553286E-06_JPRB, 0.36193024E-06_JPRB, 0.33416223E-06_JPRB, 0.31409012E-06_JPRB, 0.29977734E-06_JPRB, &
  & 0.29068760E-06_JPRB, 0.28483635E-06_JPRB, 0.28053188E-06_JPRB, 0.27711259E-06_JPRB, 0.27290668E-06_JPRB, 0.26606935E-06_JPRB, &
  & 0.25690733E-06_JPRB, 0.24531662E-06_JPRB, 0.23214400E-06_JPRB, 0.22020281E-06_JPRB, 0.21272209E-06_JPRB, 0.20949581E-06_JPRB, &
  & 0.20930672E-06_JPRB, 0.21119384E-06_JPRB, 0.21564952E-06_JPRB, 0.22244463E-06_JPRB, 0.23064913E-06_JPRB, 0.23934391E-06_JPRB, &
  & 0.24791650E-06_JPRB, 0.25559403E-06_JPRB, 0.26200522E-06_JPRB, 0.26759565E-06_JPRB, 0.27256352E-06_JPRB, 0.27755479E-06_JPRB, &
  & 0.28267899E-06_JPRB, 0.28698584E-06_JPRB, 0.28986908E-06_JPRB, 0.29116688E-06_JPRB  /)

RGHG2(:,11, 4) = (/ &
  & 0.93518285E-07_JPRB, 0.94638011E-07_JPRB, 0.97015313E-07_JPRB, 0.10088497E-06_JPRB, 0.10631148E-06_JPRB, 0.11396955E-06_JPRB, &
  & 0.12423299E-06_JPRB, 0.13846503E-06_JPRB, 0.15780974E-06_JPRB, 0.18122864E-06_JPRB, 0.20708874E-06_JPRB, 0.23568749E-06_JPRB, &
  & 0.26734928E-06_JPRB, 0.30091570E-06_JPRB, 0.33412572E-06_JPRB, 0.36729286E-06_JPRB, 0.40142898E-06_JPRB, 0.43597634E-06_JPRB, &
  & 0.46677542E-06_JPRB, 0.49459786E-06_JPRB, 0.51927071E-06_JPRB, 0.53997538E-06_JPRB, 0.55510125E-06_JPRB, 0.56293864E-06_JPRB, &
  & 0.56471767E-06_JPRB, 0.55999485E-06_JPRB, 0.55360183E-06_JPRB, 0.54653320E-06_JPRB, 0.53681036E-06_JPRB, 0.52010985E-06_JPRB, &
  & 0.49284258E-06_JPRB, 0.45644508E-06_JPRB, 0.41801544E-06_JPRB, 0.38516247E-06_JPRB, 0.36114795E-06_JPRB, 0.34597189E-06_JPRB, &
  & 0.33927011E-06_JPRB, 0.33783350E-06_JPRB, 0.33798304E-06_JPRB, 0.33845916E-06_JPRB, 0.33636876E-06_JPRB, 0.32831672E-06_JPRB, &
  & 0.31439904E-06_JPRB, 0.29225790E-06_JPRB, 0.26431098E-06_JPRB, 0.23978450E-06_JPRB, 0.22440879E-06_JPRB, 0.21710532E-06_JPRB, &
  & 0.21525236E-06_JPRB, 0.21732303E-06_JPRB, 0.22440682E-06_JPRB, 0.23596318E-06_JPRB, 0.24997218E-06_JPRB, 0.26409983E-06_JPRB, &
  & 0.27689601E-06_JPRB, 0.28787586E-06_JPRB, 0.29688810E-06_JPRB, 0.30450487E-06_JPRB, 0.31102488E-06_JPRB, 0.31708807E-06_JPRB, &
  & 0.32247445E-06_JPRB, 0.32671874E-06_JPRB, 0.32998280E-06_JPRB, 0.33223434E-06_JPRB  /)

RGHG2(:,12, 4) = (/ &
  & 0.89713670E-07_JPRB, 0.91429406E-07_JPRB, 0.94851863E-07_JPRB, 0.10002545E-06_JPRB, 0.10724816E-06_JPRB, 0.11707465E-06_JPRB, &
  & 0.12990150E-06_JPRB, 0.14748025E-06_JPRB, 0.17103264E-06_JPRB, 0.19926879E-06_JPRB, 0.23023219E-06_JPRB, 0.26363082E-06_JPRB, &
  & 0.30113642E-06_JPRB, 0.34140870E-06_JPRB, 0.38091045E-06_JPRB, 0.41980008E-06_JPRB, 0.46020379E-06_JPRB, 0.50340635E-06_JPRB, &
  & 0.54357417E-06_JPRB, 0.58120391E-06_JPRB, 0.61757487E-06_JPRB, 0.65079710E-06_JPRB, 0.67614749E-06_JPRB, 0.69097898E-06_JPRB, &
  & 0.69487871E-06_JPRB, 0.68902611E-06_JPRB, 0.67912880E-06_JPRB, 0.66429068E-06_JPRB, 0.64483741E-06_JPRB, 0.61830117E-06_JPRB, &
  & 0.58412333E-06_JPRB, 0.54488288E-06_JPRB, 0.50431384E-06_JPRB, 0.46728455E-06_JPRB, 0.43891595E-06_JPRB, 0.42290006E-06_JPRB, &
  & 0.42033844E-06_JPRB, 0.42440894E-06_JPRB, 0.42865755E-06_JPRB, 0.43042537E-06_JPRB, 0.42815326E-06_JPRB, 0.41732297E-06_JPRB, &
  & 0.39522533E-06_JPRB, 0.36023304E-06_JPRB, 0.31480249E-06_JPRB, 0.27367659E-06_JPRB, 0.24618874E-06_JPRB, 0.23164313E-06_JPRB, &
  & 0.22647497E-06_JPRB, 0.22853917E-06_JPRB, 0.23917454E-06_JPRB, 0.25577643E-06_JPRB, 0.27361535E-06_JPRB, 0.28989137E-06_JPRB, &
  & 0.30308544E-06_JPRB, 0.31393836E-06_JPRB, 0.32297009E-06_JPRB, 0.33081723E-06_JPRB, 0.33714726E-06_JPRB, 0.34150052E-06_JPRB, &
  & 0.34394279E-06_JPRB, 0.34634577E-06_JPRB, 0.34905236E-06_JPRB, 0.35146170E-06_JPRB  /)

RGHG2(:,13, 4) = (/ &
  & 0.10169293E-06_JPRB, 0.10443141E-06_JPRB, 0.10975598E-06_JPRB, 0.11736964E-06_JPRB, 0.12779998E-06_JPRB, 0.14089566E-06_JPRB, &
  & 0.15702703E-06_JPRB, 0.17806605E-06_JPRB, 0.20515819E-06_JPRB, 0.23727139E-06_JPRB, 0.27145326E-06_JPRB, 0.30765353E-06_JPRB, &
  & 0.34823253E-06_JPRB, 0.39086000E-06_JPRB, 0.43323461E-06_JPRB, 0.47252585E-06_JPRB, 0.51341327E-06_JPRB, 0.55990721E-06_JPRB, &
  & 0.60627199E-06_JPRB, 0.65407213E-06_JPRB, 0.70214806E-06_JPRB, 0.74780323E-06_JPRB, 0.78762715E-06_JPRB, 0.81639248E-06_JPRB, &
  & 0.82841762E-06_JPRB, 0.82872565E-06_JPRB, 0.81993498E-06_JPRB, 0.80052039E-06_JPRB, 0.77392809E-06_JPRB, 0.74056211E-06_JPRB, &
  & 0.70259387E-06_JPRB, 0.66240516E-06_JPRB, 0.62086134E-06_JPRB, 0.58095613E-06_JPRB, 0.54791941E-06_JPRB, 0.53013597E-06_JPRB, &
  & 0.53134201E-06_JPRB, 0.53901021E-06_JPRB, 0.54346439E-06_JPRB, 0.54043116E-06_JPRB, 0.53090501E-06_JPRB, 0.51307299E-06_JPRB, &
  & 0.47923779E-06_JPRB, 0.43151390E-06_JPRB, 0.37366222E-06_JPRB, 0.31729805E-06_JPRB, 0.27602073E-06_JPRB, 0.25228232E-06_JPRB, &
  & 0.24304556E-06_JPRB, 0.24602701E-06_JPRB, 0.25996927E-06_JPRB, 0.27752119E-06_JPRB, 0.29338867E-06_JPRB, 0.30706735E-06_JPRB, &
  & 0.31764207E-06_JPRB, 0.32616695E-06_JPRB, 0.33400760E-06_JPRB, 0.34198859E-06_JPRB, 0.34763182E-06_JPRB, 0.35012780E-06_JPRB, &
  & 0.35110826E-06_JPRB, 0.35336215E-06_JPRB, 0.35518005E-06_JPRB, 0.35512055E-06_JPRB  /)

RGHG2(:,14, 4) = (/ &
  & 0.13829758E-06_JPRB, 0.14267019E-06_JPRB, 0.15016103E-06_JPRB, 0.16056127E-06_JPRB, 0.17426133E-06_JPRB, 0.19021369E-06_JPRB, &
  & 0.20937090E-06_JPRB, 0.23286896E-06_JPRB, 0.26136388E-06_JPRB, 0.29505855E-06_JPRB, 0.32992651E-06_JPRB, 0.36552107E-06_JPRB, &
  & 0.40483694E-06_JPRB, 0.44624145E-06_JPRB, 0.48825216E-06_JPRB, 0.52434567E-06_JPRB, 0.56234082E-06_JPRB, 0.60603475E-06_JPRB, &
  & 0.65393756E-06_JPRB, 0.70941820E-06_JPRB, 0.76635168E-06_JPRB, 0.82283652E-06_JPRB, 0.88099315E-06_JPRB, 0.92843728E-06_JPRB, &
  & 0.95734990E-06_JPRB, 0.97342569E-06_JPRB, 0.97251898E-06_JPRB, 0.95546676E-06_JPRB, 0.92623204E-06_JPRB, 0.88931403E-06_JPRB, &
  & 0.84965375E-06_JPRB, 0.80953787E-06_JPRB, 0.76840427E-06_JPRB, 0.72748423E-06_JPRB, 0.69040252E-06_JPRB, 0.66781745E-06_JPRB, &
  & 0.66729145E-06_JPRB, 0.67236092E-06_JPRB, 0.67110009E-06_JPRB, 0.65735249E-06_JPRB, 0.63236121E-06_JPRB, 0.59969752E-06_JPRB, &
  & 0.55141019E-06_JPRB, 0.49114814E-06_JPRB, 0.42583325E-06_JPRB, 0.36039123E-06_JPRB, 0.30923245E-06_JPRB, 0.27874757E-06_JPRB, &
  & 0.26680545E-06_JPRB, 0.27090198E-06_JPRB, 0.28436846E-06_JPRB, 0.29716643E-06_JPRB, 0.30824134E-06_JPRB, 0.31765306E-06_JPRB, &
  & 0.32452626E-06_JPRB, 0.33075319E-06_JPRB, 0.33808041E-06_JPRB, 0.34578210E-06_JPRB, 0.35196277E-06_JPRB, 0.35532412E-06_JPRB, &
  & 0.35901636E-06_JPRB, 0.36255536E-06_JPRB, 0.36399026E-06_JPRB, 0.36253842E-06_JPRB  /)

RGHG2(:,15, 4) = (/ &
  & 0.20688471E-06_JPRB, 0.21278905E-06_JPRB, 0.22171561E-06_JPRB, 0.23378779E-06_JPRB, 0.24836676E-06_JPRB, 0.26522065E-06_JPRB, &
  & 0.28552719E-06_JPRB, 0.30890194E-06_JPRB, 0.33582803E-06_JPRB, 0.36794892E-06_JPRB, 0.40046419E-06_JPRB, 0.43239934E-06_JPRB, &
  & 0.46672090E-06_JPRB, 0.50444761E-06_JPRB, 0.54328053E-06_JPRB, 0.57601783E-06_JPRB, 0.61078021E-06_JPRB, 0.64859963E-06_JPRB, &
  & 0.69539504E-06_JPRB, 0.75271084E-06_JPRB, 0.81427678E-06_JPRB, 0.88186856E-06_JPRB, 0.95608695E-06_JPRB, 0.10226021E-05_JPRB, &
  & 0.10768262E-05_JPRB, 0.11139287E-05_JPRB, 0.11300161E-05_JPRB, 0.11226351E-05_JPRB, 0.10953034E-05_JPRB, 0.10597170E-05_JPRB, &
  & 0.10224058E-05_JPRB, 0.98444664E-06_JPRB, 0.94521272E-06_JPRB, 0.90340834E-06_JPRB, 0.86057332E-06_JPRB, 0.82681590E-06_JPRB, &
  & 0.81193177E-06_JPRB, 0.80335989E-06_JPRB, 0.79051035E-06_JPRB, 0.76521218E-06_JPRB, 0.72239453E-06_JPRB, 0.66795120E-06_JPRB, &
  & 0.60173481E-06_JPRB, 0.53122230E-06_JPRB, 0.46182238E-06_JPRB, 0.39250897E-06_JPRB, 0.33910640E-06_JPRB, 0.30715878E-06_JPRB, &
  & 0.29445741E-06_JPRB, 0.29767612E-06_JPRB, 0.30547591E-06_JPRB, 0.31345693E-06_JPRB, 0.32161465E-06_JPRB, 0.32745009E-06_JPRB, &
  & 0.33113926E-06_JPRB, 0.33607375E-06_JPRB, 0.34273832E-06_JPRB, 0.35121187E-06_JPRB, 0.36036480E-06_JPRB, 0.36731952E-06_JPRB, &
  & 0.37510051E-06_JPRB, 0.37971127E-06_JPRB, 0.38101393E-06_JPRB, 0.38137424E-06_JPRB  /)

RGHG2(:,16, 4) = (/ &
  & 0.30190616E-06_JPRB, 0.30772249E-06_JPRB, 0.31661395E-06_JPRB, 0.32803785E-06_JPRB, 0.34108537E-06_JPRB, 0.35669018E-06_JPRB, &
  & 0.37569924E-06_JPRB, 0.39632711E-06_JPRB, 0.41941035E-06_JPRB, 0.44717494E-06_JPRB, 0.47445822E-06_JPRB, 0.50115116E-06_JPRB, &
  & 0.52938218E-06_JPRB, 0.56092732E-06_JPRB, 0.59544362E-06_JPRB, 0.62588334E-06_JPRB, 0.65740879E-06_JPRB, 0.68986126E-06_JPRB, &
  & 0.73305224E-06_JPRB, 0.78841514E-06_JPRB, 0.85155055E-06_JPRB, 0.92457431E-06_JPRB, 0.10081364E-05_JPRB, 0.10921085E-05_JPRB, &
  & 0.11736821E-05_JPRB, 0.12356997E-05_JPRB, 0.12721783E-05_JPRB, 0.12786217E-05_JPRB, 0.12625416E-05_JPRB, 0.12370533E-05_JPRB, &
  & 0.12078297E-05_JPRB, 0.11740773E-05_JPRB, 0.11335470E-05_JPRB, 0.10857700E-05_JPRB, 0.10307103E-05_JPRB, 0.97704749E-06_JPRB, &
  & 0.93846113E-06_JPRB, 0.90574573E-06_JPRB, 0.87325971E-06_JPRB, 0.83707329E-06_JPRB, 0.78143016E-06_JPRB, 0.70803892E-06_JPRB, &
  & 0.62895194E-06_JPRB, 0.55422577E-06_JPRB, 0.48365647E-06_JPRB, 0.41307388E-06_JPRB, 0.36305893E-06_JPRB, 0.33340092E-06_JPRB, &
  & 0.32058037E-06_JPRB, 0.31882940E-06_JPRB, 0.32130160E-06_JPRB, 0.32873571E-06_JPRB, 0.33576753E-06_JPRB, 0.33984457E-06_JPRB, &
  & 0.34266021E-06_JPRB, 0.34617543E-06_JPRB, 0.35273601E-06_JPRB, 0.36422209E-06_JPRB, 0.37716162E-06_JPRB, 0.38883757E-06_JPRB, &
  & 0.39923001E-06_JPRB, 0.40558778E-06_JPRB, 0.40663675E-06_JPRB, 0.40866817E-06_JPRB  /)

RGHG2(:,17, 4) = (/ &
  & 0.40605013E-06_JPRB, 0.41036216E-06_JPRB, 0.41733888E-06_JPRB, 0.42662931E-06_JPRB, 0.43728842E-06_JPRB, 0.45064458E-06_JPRB, &
  & 0.46670352E-06_JPRB, 0.48356883E-06_JPRB, 0.50224870E-06_JPRB, 0.52373422E-06_JPRB, 0.54462028E-06_JPRB, 0.56659475E-06_JPRB, &
  & 0.58867748E-06_JPRB, 0.61453904E-06_JPRB, 0.64490166E-06_JPRB, 0.67261701E-06_JPRB, 0.70131008E-06_JPRB, 0.72979405E-06_JPRB, &
  & 0.76757764E-06_JPRB, 0.82027915E-06_JPRB, 0.88027594E-06_JPRB, 0.95206110E-06_JPRB, 0.10381495E-05_JPRB, 0.11357219E-05_JPRB, &
  & 0.12370650E-05_JPRB, 0.13218538E-05_JPRB, 0.13782233E-05_JPRB, 0.14013062E-05_JPRB, 0.14046762E-05_JPRB, 0.13948316E-05_JPRB, &
  & 0.13756882E-05_JPRB, 0.13442362E-05_JPRB, 0.12937702E-05_JPRB, 0.12273497E-05_JPRB, 0.11542216E-05_JPRB, 0.10818573E-05_JPRB, &
  & 0.10211652E-05_JPRB, 0.96460287E-06_JPRB, 0.91425225E-06_JPRB, 0.86663020E-06_JPRB, 0.80071235E-06_JPRB, 0.71700490E-06_JPRB, &
  & 0.63957523E-06_JPRB, 0.56961177E-06_JPRB, 0.49744179E-06_JPRB, 0.42957728E-06_JPRB, 0.38420746E-06_JPRB, 0.35828154E-06_JPRB, &
  & 0.34397192E-06_JPRB, 0.33671270E-06_JPRB, 0.33904512E-06_JPRB, 0.34770044E-06_JPRB, 0.35370417E-06_JPRB, 0.35728438E-06_JPRB, &
  & 0.35926237E-06_JPRB, 0.36307706E-06_JPRB, 0.37241524E-06_JPRB, 0.38779928E-06_JPRB, 0.40389705E-06_JPRB, 0.41783664E-06_JPRB, &
  & 0.43094986E-06_JPRB, 0.43845167E-06_JPRB, 0.43987269E-06_JPRB, 0.44316756E-06_JPRB  /)

RGHG2(:,18, 4) = (/ &
  & 0.50240158E-06_JPRB, 0.50536162E-06_JPRB, 0.51045738E-06_JPRB, 0.51741382E-06_JPRB, 0.52618538E-06_JPRB, 0.53756729E-06_JPRB, &
  & 0.55100285E-06_JPRB, 0.56471875E-06_JPRB, 0.57927036E-06_JPRB, 0.59489978E-06_JPRB, 0.61074400E-06_JPRB, 0.62932070E-06_JPRB, &
  & 0.64689521E-06_JPRB, 0.66868448E-06_JPRB, 0.69454664E-06_JPRB, 0.71899971E-06_JPRB, 0.74422217E-06_JPRB, 0.76963561E-06_JPRB, &
  & 0.80460784E-06_JPRB, 0.85327702E-06_JPRB, 0.90646980E-06_JPRB, 0.97282199E-06_JPRB, 0.10555710E-05_JPRB, 0.11606835E-05_JPRB, &
  & 0.12718386E-05_JPRB, 0.13688436E-05_JPRB, 0.14442052E-05_JPRB, 0.14863979E-05_JPRB, 0.15076225E-05_JPRB, 0.15104470E-05_JPRB, &
  & 0.14964050E-05_JPRB, 0.14611167E-05_JPRB, 0.13958707E-05_JPRB, 0.13079916E-05_JPRB, 0.12191958E-05_JPRB, 0.11380568E-05_JPRB, &
  & 0.10630769E-05_JPRB, 0.99343116E-06_JPRB, 0.93094988E-06_JPRB, 0.86948939E-06_JPRB, 0.79495435E-06_JPRB, 0.71042731E-06_JPRB, &
  & 0.64259120E-06_JPRB, 0.57972037E-06_JPRB, 0.50963856E-06_JPRB, 0.44884599E-06_JPRB, 0.40821376E-06_JPRB, 0.38357040E-06_JPRB, &
  & 0.36522134E-06_JPRB, 0.35636432E-06_JPRB, 0.36047859E-06_JPRB, 0.36946627E-06_JPRB, 0.37423205E-06_JPRB, 0.37755632E-06_JPRB, &
  & 0.38002132E-06_JPRB, 0.38545228E-06_JPRB, 0.39902816E-06_JPRB, 0.41739286E-06_JPRB, 0.43447599E-06_JPRB, 0.44982152E-06_JPRB, &
  & 0.46590664E-06_JPRB, 0.47348340E-06_JPRB, 0.47514302E-06_JPRB, 0.47943453E-06_JPRB  /)

RGHG2(:,19, 4) = (/ &
  & 0.58633227E-06_JPRB, 0.58857142E-06_JPRB, 0.59243403E-06_JPRB, 0.59800212E-06_JPRB, 0.60593049E-06_JPRB, 0.61637428E-06_JPRB, &
  & 0.62835263E-06_JPRB, 0.63994623E-06_JPRB, 0.65146138E-06_JPRB, 0.66333894E-06_JPRB, 0.67642086E-06_JPRB, 0.69303187E-06_JPRB, &
  & 0.70847729E-06_JPRB, 0.72653173E-06_JPRB, 0.74795801E-06_JPRB, 0.76923203E-06_JPRB, 0.79046060E-06_JPRB, 0.81390662E-06_JPRB, &
  & 0.84892044E-06_JPRB, 0.89379450E-06_JPRB, 0.94042841E-06_JPRB, 0.99768594E-06_JPRB, 0.10754518E-05_JPRB, 0.11803878E-05_JPRB, &
  & 0.12930368E-05_JPRB, 0.13943976E-05_JPRB, 0.14807741E-05_JPRB, 0.15380691E-05_JPRB, 0.15691871E-05_JPRB, 0.15798700E-05_JPRB, &
  & 0.15702995E-05_JPRB, 0.15312970E-05_JPRB, 0.14544893E-05_JPRB, 0.13513379E-05_JPRB, 0.12517003E-05_JPRB, 0.11684694E-05_JPRB, &
  & 0.10867294E-05_JPRB, 0.10092839E-05_JPRB, 0.93497615E-06_JPRB, 0.86338591E-06_JPRB, 0.78877249E-06_JPRB, 0.70933979E-06_JPRB, &
  & 0.64618049E-06_JPRB, 0.58744591E-06_JPRB, 0.52462841E-06_JPRB, 0.47298797E-06_JPRB, 0.43716716E-06_JPRB, 0.41117195E-06_JPRB, &
  & 0.38885543E-06_JPRB, 0.38140338E-06_JPRB, 0.38570019E-06_JPRB, 0.39341863E-06_JPRB, 0.39724490E-06_JPRB, 0.40133332E-06_JPRB, &
  & 0.40515146E-06_JPRB, 0.41270272E-06_JPRB, 0.42880449E-06_JPRB, 0.44820285E-06_JPRB, 0.46565225E-06_JPRB, 0.48231080E-06_JPRB, &
  & 0.50007893E-06_JPRB, 0.50714478E-06_JPRB, 0.50823179E-06_JPRB, 0.51144627E-06_JPRB  /)

RGHG2(:,20, 4) = (/ &
  & 0.66045898E-06_JPRB, 0.66213550E-06_JPRB, 0.66547715E-06_JPRB, 0.67094189E-06_JPRB, 0.67894690E-06_JPRB, 0.68931562E-06_JPRB, &
  & 0.70090034E-06_JPRB, 0.71151597E-06_JPRB, 0.72150047E-06_JPRB, 0.73184880E-06_JPRB, 0.74392377E-06_JPRB, 0.75942875E-06_JPRB, &
  & 0.77409667E-06_JPRB, 0.78922339E-06_JPRB, 0.80712505E-06_JPRB, 0.82519018E-06_JPRB, 0.84301282E-06_JPRB, 0.86550392E-06_JPRB, &
  & 0.90156519E-06_JPRB, 0.94435004E-06_JPRB, 0.98673470E-06_JPRB, 0.10352181E-05_JPRB, 0.11071347E-05_JPRB, 0.12067459E-05_JPRB, &
  & 0.13129054E-05_JPRB, 0.14122232E-05_JPRB, 0.15025311E-05_JPRB, 0.15666585E-05_JPRB, 0.16021642E-05_JPRB, 0.16175046E-05_JPRB, &
  & 0.16124391E-05_JPRB, 0.15744381E-05_JPRB, 0.14932520E-05_JPRB, 0.13805111E-05_JPRB, 0.12748806E-05_JPRB, 0.11923886E-05_JPRB, &
  & 0.11075536E-05_JPRB, 0.10230135E-05_JPRB, 0.93940491E-06_JPRB, 0.86393935E-06_JPRB, 0.79446923E-06_JPRB, 0.72188040E-06_JPRB, &
  & 0.65777051E-06_JPRB, 0.59962308E-06_JPRB, 0.54589601E-06_JPRB, 0.50310369E-06_JPRB, 0.47089318E-06_JPRB, 0.44316335E-06_JPRB, &
  & 0.41895886E-06_JPRB, 0.41278619E-06_JPRB, 0.41612121E-06_JPRB, 0.42160159E-06_JPRB, 0.42500713E-06_JPRB, 0.43020695E-06_JPRB, &
  & 0.43553354E-06_JPRB, 0.44449746E-06_JPRB, 0.46049523E-06_JPRB, 0.47890260E-06_JPRB, 0.49632489E-06_JPRB, 0.51359934E-06_JPRB, &
  & 0.53096675E-06_JPRB, 0.53696201E-06_JPRB, 0.53680958E-06_JPRB, 0.53744953E-06_JPRB  /)

RGHG2(:,21, 4) = (/ &
  & 0.72805343E-06_JPRB, 0.72926093E-06_JPRB, 0.73277548E-06_JPRB, 0.73916017E-06_JPRB, 0.74788280E-06_JPRB, 0.75878747E-06_JPRB, &
  & 0.77080755E-06_JPRB, 0.78140924E-06_JPRB, 0.79132024E-06_JPRB, 0.80188268E-06_JPRB, 0.81408499E-06_JPRB, 0.82902017E-06_JPRB, &
  & 0.84341023E-06_JPRB, 0.85675181E-06_JPRB, 0.87217579E-06_JPRB, 0.88735960E-06_JPRB, 0.90295308E-06_JPRB, 0.92548649E-06_JPRB, &
  & 0.96244006E-06_JPRB, 0.10046199E-05_JPRB, 0.10456161E-05_JPRB, 0.10888338E-05_JPRB, 0.11536681E-05_JPRB, 0.12451127E-05_JPRB, &
  & 0.13391246E-05_JPRB, 0.14309510E-05_JPRB, 0.15195234E-05_JPRB, 0.15832550E-05_JPRB, 0.16200047E-05_JPRB, 0.16378668E-05_JPRB, &
  & 0.16363414E-05_JPRB, 0.16023568E-05_JPRB, 0.15226545E-05_JPRB, 0.14065909E-05_JPRB, 0.12997119E-05_JPRB, 0.12182219E-05_JPRB, &
  & 0.11315793E-05_JPRB, 0.10406419E-05_JPRB, 0.95038553E-06_JPRB, 0.87614652E-06_JPRB, 0.81320203E-06_JPRB, 0.74661717E-06_JPRB, &
  & 0.67912199E-06_JPRB, 0.61977408E-06_JPRB, 0.57451058E-06_JPRB, 0.53926897E-06_JPRB, 0.50929868E-06_JPRB, 0.48065220E-06_JPRB, &
  & 0.45674316E-06_JPRB, 0.45071022E-06_JPRB, 0.45247424E-06_JPRB, 0.45538998E-06_JPRB, 0.45864880E-06_JPRB, 0.46480215E-06_JPRB, &
  & 0.47113151E-06_JPRB, 0.48007184E-06_JPRB, 0.49364305E-06_JPRB, 0.50939237E-06_JPRB, 0.52613117E-06_JPRB, 0.54312142E-06_JPRB, &
  & 0.55869115E-06_JPRB, 0.56331828E-06_JPRB, 0.56158038E-06_JPRB, 0.55975988E-06_JPRB  /)

RGHG2(:,22, 4) = (/ &
  & 0.79043920E-06_JPRB, 0.79153201E-06_JPRB, 0.79598315E-06_JPRB, 0.80389697E-06_JPRB, 0.81372822E-06_JPRB, 0.82562683E-06_JPRB, &
  & 0.83877464E-06_JPRB, 0.85012178E-06_JPRB, 0.86135165E-06_JPRB, 0.87340499E-06_JPRB, 0.88642921E-06_JPRB, 0.90126882E-06_JPRB, &
  & 0.91529572E-06_JPRB, 0.92829324E-06_JPRB, 0.94218809E-06_JPRB, 0.95563252E-06_JPRB, 0.97063346E-06_JPRB, 0.99440929E-06_JPRB, &
  & 0.10313629E-05_JPRB, 0.10734853E-05_JPRB, 0.11163165E-05_JPRB, 0.11610060E-05_JPRB, 0.12167610E-05_JPRB, 0.12988589E-05_JPRB, &
  & 0.13782103E-05_JPRB, 0.14573640E-05_JPRB, 0.15387687E-05_JPRB, 0.15977026E-05_JPRB, 0.16337833E-05_JPRB, 0.16522570E-05_JPRB, &
  & 0.16515345E-05_JPRB, 0.16198053E-05_JPRB, 0.15442699E-05_JPRB, 0.14342081E-05_JPRB, 0.13315151E-05_JPRB, 0.12492414E-05_JPRB, &
  & 0.11608594E-05_JPRB, 0.10667873E-05_JPRB, 0.97119811E-06_JPRB, 0.90106863E-06_JPRB, 0.84271153E-06_JPRB, 0.77920404E-06_JPRB, &
  & 0.71006505E-06_JPRB, 0.65029663E-06_JPRB, 0.61093939E-06_JPRB, 0.58135556E-06_JPRB, 0.55258946E-06_JPRB, 0.52447817E-06_JPRB, &
  & 0.50248054E-06_JPRB, 0.49554923E-06_JPRB, 0.49532539E-06_JPRB, 0.49592832E-06_JPRB, 0.49886220E-06_JPRB, 0.50547429E-06_JPRB, &
  & 0.51153606E-06_JPRB, 0.51833560E-06_JPRB, 0.52766348E-06_JPRB, 0.53943707E-06_JPRB, 0.55434091E-06_JPRB, 0.57014608E-06_JPRB, &
  & 0.58384263E-06_JPRB, 0.58724646E-06_JPRB, 0.58392208E-06_JPRB, 0.58189133E-06_JPRB  /)

RGHG2(:,23, 4) = (/ &
  & 0.84834403E-06_JPRB, 0.85006253E-06_JPRB, 0.85612445E-06_JPRB, 0.86551814E-06_JPRB, 0.87673627E-06_JPRB, 0.89026733E-06_JPRB, &
  & 0.90443926E-06_JPRB, 0.91725401E-06_JPRB, 0.93074592E-06_JPRB, 0.94460933E-06_JPRB, 0.95921622E-06_JPRB, 0.97393862E-06_JPRB, &
  & 0.98681465E-06_JPRB, 0.99991027E-06_JPRB, 0.10136481E-05_JPRB, 0.10275960E-05_JPRB, 0.10443700E-05_JPRB, 0.10697150E-05_JPRB, &
  & 0.11029890E-05_JPRB, 0.11447249E-05_JPRB, 0.11913511E-05_JPRB, 0.12394754E-05_JPRB, 0.12896007E-05_JPRB, 0.13597894E-05_JPRB, &
  & 0.14259337E-05_JPRB, 0.14923779E-05_JPRB, 0.15626814E-05_JPRB, 0.16156620E-05_JPRB, 0.16497211E-05_JPRB, 0.16665456E-05_JPRB, &
  & 0.16632070E-05_JPRB, 0.16294968E-05_JPRB, 0.15584145E-05_JPRB, 0.14609037E-05_JPRB, 0.13639583E-05_JPRB, 0.12777191E-05_JPRB, &
  & 0.11884266E-05_JPRB, 0.10930891E-05_JPRB, 0.99901264E-06_JPRB, 0.93092739E-06_JPRB, 0.87050219E-06_JPRB, 0.81059520E-06_JPRB, &
  & 0.74517869E-06_JPRB, 0.68980273E-06_JPRB, 0.65399972E-06_JPRB, 0.62654327E-06_JPRB, 0.59905318E-06_JPRB, 0.57357181E-06_JPRB, &
  & 0.55481526E-06_JPRB, 0.54740263E-06_JPRB, 0.54440045E-06_JPRB, 0.54186913E-06_JPRB, 0.54323073E-06_JPRB, 0.54890617E-06_JPRB, &
  & 0.55337169E-06_JPRB, 0.55663063E-06_JPRB, 0.56216585E-06_JPRB, 0.57113485E-06_JPRB, 0.58384015E-06_JPRB, 0.59774807E-06_JPRB, &
  & 0.61070145E-06_JPRB, 0.61466691E-06_JPRB, 0.61222817E-06_JPRB, 0.60977840E-06_JPRB  /)

RGHG2(:,24, 4) = (/ &
  & 0.90712520E-06_JPRB, 0.90986887E-06_JPRB, 0.91760246E-06_JPRB, 0.92839258E-06_JPRB, 0.94128810E-06_JPRB, 0.95657314E-06_JPRB, &
  & 0.97174598E-06_JPRB, 0.98640431E-06_JPRB, 0.10022149E-05_JPRB, 0.10178798E-05_JPRB, 0.10336668E-05_JPRB, 0.10480029E-05_JPRB, &
  & 0.10599178E-05_JPRB, 0.10733628E-05_JPRB, 0.10874201E-05_JPRB, 0.11029656E-05_JPRB, 0.11221307E-05_JPRB, 0.11481665E-05_JPRB, &
  & 0.11773641E-05_JPRB, 0.12179260E-05_JPRB, 0.12671799E-05_JPRB, 0.13179293E-05_JPRB, 0.13633643E-05_JPRB, 0.14215226E-05_JPRB, &
  & 0.14755928E-05_JPRB, 0.15298076E-05_JPRB, 0.15882436E-05_JPRB, 0.16348168E-05_JPRB, 0.16660866E-05_JPRB, 0.16804074E-05_JPRB, &
  & 0.16739185E-05_JPRB, 0.16384885E-05_JPRB, 0.15722924E-05_JPRB, 0.14862117E-05_JPRB, 0.13939780E-05_JPRB, 0.13042234E-05_JPRB, &
  & 0.12148465E-05_JPRB, 0.11202348E-05_JPRB, 0.10293905E-05_JPRB, 0.96193526E-06_JPRB, 0.90009177E-06_JPRB, 0.84412144E-06_JPRB, &
  & 0.78357113E-06_JPRB, 0.73358155E-06_JPRB, 0.70027954E-06_JPRB, 0.67438873E-06_JPRB, 0.64814295E-06_JPRB, 0.62607941E-06_JPRB, &
  & 0.61071292E-06_JPRB, 0.60298042E-06_JPRB, 0.59735445E-06_JPRB, 0.59167490E-06_JPRB, 0.59073758E-06_JPRB, 0.59456238E-06_JPRB, &
  & 0.59686092E-06_JPRB, 0.59697424E-06_JPRB, 0.59937642E-06_JPRB, 0.60601466E-06_JPRB, 0.61663862E-06_JPRB, 0.62827041E-06_JPRB, &
  & 0.64100610E-06_JPRB, 0.64630816E-06_JPRB, 0.64470218E-06_JPRB, 0.64161299E-06_JPRB  /)

RGHG2(:,25, 4) = (/ &
  & 0.96582127E-06_JPRB, 0.97008524E-06_JPRB, 0.97937150E-06_JPRB, 0.99135846E-06_JPRB, 0.10063080E-05_JPRB, 0.10233398E-05_JPRB, &
  & 0.10394507E-05_JPRB, 0.10563733E-05_JPRB, 0.10742865E-05_JPRB, 0.10915850E-05_JPRB, 0.11076146E-05_JPRB, 0.11211096E-05_JPRB, &
  & 0.11326202E-05_JPRB, 0.11467444E-05_JPRB, 0.11616428E-05_JPRB, 0.11801481E-05_JPRB, 0.12021597E-05_JPRB, 0.12272251E-05_JPRB, &
  & 0.12526542E-05_JPRB, 0.12907739E-05_JPRB, 0.13400278E-05_JPRB, 0.13914080E-05_JPRB, 0.14332524E-05_JPRB, 0.14802833E-05_JPRB, &
  & 0.15245039E-05_JPRB, 0.15678986E-05_JPRB, 0.16145279E-05_JPRB, 0.16544376E-05_JPRB, 0.16819875E-05_JPRB, 0.16929118E-05_JPRB, &
  & 0.16832367E-05_JPRB, 0.16475803E-05_JPRB, 0.15867539E-05_JPRB, 0.15081292E-05_JPRB, 0.14182082E-05_JPRB, 0.13266099E-05_JPRB, &
  & 0.12384298E-05_JPRB, 0.11476189E-05_JPRB, 0.10613678E-05_JPRB, 0.99247319E-06_JPRB, 0.93192358E-06_JPRB, 0.88019071E-06_JPRB, &
  & 0.82510707E-06_JPRB, 0.78093996E-06_JPRB, 0.74868923E-06_JPRB, 0.72409230E-06_JPRB, 0.69896250E-06_JPRB, 0.68108791E-06_JPRB, &
  & 0.66892378E-06_JPRB, 0.66107807E-06_JPRB, 0.65339806E-06_JPRB, 0.64487197E-06_JPRB, 0.64073228E-06_JPRB, 0.64148411E-06_JPRB, &
  & 0.64100080E-06_JPRB, 0.63912477E-06_JPRB, 0.63960230E-06_JPRB, 0.64459083E-06_JPRB, 0.65351658E-06_JPRB, 0.66246355E-06_JPRB, &
  & 0.67566828E-06_JPRB, 0.68321846E-06_JPRB, 0.68175805E-06_JPRB, 0.67771462E-06_JPRB  /)

RGHG2(:,26, 4) = (/ &
  & 0.10228282E-05_JPRB, 0.10287262E-05_JPRB, 0.10388664E-05_JPRB, 0.10521363E-05_JPRB, 0.10690834E-05_JPRB, 0.10873609E-05_JPRB, &
  & 0.11046337E-05_JPRB, 0.11231933E-05_JPRB, 0.11425733E-05_JPRB, 0.11605658E-05_JPRB, 0.11758065E-05_JPRB, 0.11885912E-05_JPRB, &
  & 0.12007525E-05_JPRB, 0.12148521E-05_JPRB, 0.12310894E-05_JPRB, 0.12517867E-05_JPRB, 0.12746714E-05_JPRB, 0.12979910E-05_JPRB, &
  & 0.13211550E-05_JPRB, 0.13562273E-05_JPRB, 0.14021035E-05_JPRB, 0.14498983E-05_JPRB, 0.14877767E-05_JPRB, 0.15274194E-05_JPRB, &
  & 0.15648846E-05_JPRB, 0.16000658E-05_JPRB, 0.16370087E-05_JPRB, 0.16703472E-05_JPRB, 0.16936202E-05_JPRB, 0.17018226E-05_JPRB, &
  & 0.16906954E-05_JPRB, 0.16558961E-05_JPRB, 0.15991924E-05_JPRB, 0.15262489E-05_JPRB, 0.14401619E-05_JPRB, 0.13503824E-05_JPRB, &
  & 0.12649130E-05_JPRB, 0.11799451E-05_JPRB, 0.10995848E-05_JPRB, 0.10310698E-05_JPRB, 0.97212685E-06_JPRB, 0.92212135E-06_JPRB, &
  & 0.87209157E-06_JPRB, 0.83070607E-06_JPRB, 0.79913545E-06_JPRB, 0.77542067E-06_JPRB, 0.75209603E-06_JPRB, 0.73570168E-06_JPRB, &
  & 0.72445051E-06_JPRB, 0.71734232E-06_JPRB, 0.70887950E-06_JPRB, 0.69929919E-06_JPRB, 0.69201965E-06_JPRB, 0.68887703E-06_JPRB, &
  & 0.68550248E-06_JPRB, 0.68199752E-06_JPRB, 0.68008525E-06_JPRB, 0.68386408E-06_JPRB, 0.69227064E-06_JPRB, 0.69939597E-06_JPRB, &
  & 0.71157275E-06_JPRB, 0.72071306E-06_JPRB, 0.72003660E-06_JPRB, 0.71615889E-06_JPRB  /)

RGHG2(:,27, 4) = (/ &
  & 0.10818039E-05_JPRB, 0.10894524E-05_JPRB, 0.11002265E-05_JPRB, 0.11148696E-05_JPRB, 0.11338841E-05_JPRB, 0.11532783E-05_JPRB, &
  & 0.11718490E-05_JPRB, 0.11918875E-05_JPRB, 0.12125652E-05_JPRB, 0.12309350E-05_JPRB, 0.12449684E-05_JPRB, 0.12570590E-05_JPRB, &
  & 0.12702917E-05_JPRB, 0.12841046E-05_JPRB, 0.13019264E-05_JPRB, 0.13246307E-05_JPRB, 0.13476966E-05_JPRB, 0.13689035E-05_JPRB, &
  & 0.13902565E-05_JPRB, 0.14219184E-05_JPRB, 0.14630108E-05_JPRB, 0.15054937E-05_JPRB, 0.15390863E-05_JPRB, 0.15723909E-05_JPRB, &
  & 0.16039405E-05_JPRB, 0.16315009E-05_JPRB, 0.16591026E-05_JPRB, 0.16856049E-05_JPRB, 0.17041998E-05_JPRB, 0.17098067E-05_JPRB, &
  & 0.16978042E-05_JPRB, 0.16643027E-05_JPRB, 0.16114471E-05_JPRB, 0.15437854E-05_JPRB, 0.14622709E-05_JPRB, 0.13757510E-05_JPRB, &
  & 0.12936770E-05_JPRB, 0.12155754E-05_JPRB, 0.11418550E-05_JPRB, 0.10744114E-05_JPRB, 0.10172643E-05_JPRB, 0.96813407E-06_JPRB, &
  & 0.92323515E-06_JPRB, 0.88363036E-06_JPRB, 0.85263319E-06_JPRB, 0.82968803E-06_JPRB, 0.80850628E-06_JPRB, 0.79265521E-06_JPRB, &
  & 0.78150967E-06_JPRB, 0.77548801E-06_JPRB, 0.76667810E-06_JPRB, 0.75666016E-06_JPRB, 0.74612102E-06_JPRB, 0.73860208E-06_JPRB, &
  & 0.73216411E-06_JPRB, 0.72708971E-06_JPRB, 0.72250638E-06_JPRB, 0.72518358E-06_JPRB, 0.73348451E-06_JPRB, 0.73902530E-06_JPRB, &
  & 0.74957228E-06_JPRB, 0.76013112E-06_JPRB, 0.76051101E-06_JPRB, 0.75722185E-06_JPRB  /)

RGHG2(:,28, 4) = (/ &
  & 0.11364007E-05_JPRB, 0.11446563E-05_JPRB, 0.11558559E-05_JPRB, 0.11718174E-05_JPRB, 0.11916893E-05_JPRB, 0.12112026E-05_JPRB, &
  & 0.12302749E-05_JPRB, 0.12503966E-05_JPRB, 0.12711755E-05_JPRB, 0.12892220E-05_JPRB, 0.13023568E-05_JPRB, 0.13143324E-05_JPRB, &
  & 0.13277199E-05_JPRB, 0.13414839E-05_JPRB, 0.13585669E-05_JPRB, 0.13809870E-05_JPRB, 0.14029333E-05_JPRB, 0.14236440E-05_JPRB, &
  & 0.14442874E-05_JPRB, 0.14721096E-05_JPRB, 0.15070174E-05_JPRB, 0.15426940E-05_JPRB, 0.15724501E-05_JPRB, 0.16010112E-05_JPRB, &
  & 0.16286477E-05_JPRB, 0.16523782E-05_JPRB, 0.16744924E-05_JPRB, 0.16954806E-05_JPRB, 0.17103362E-05_JPRB, 0.17146643E-05_JPRB, &
  & 0.17041797E-05_JPRB, 0.16738965E-05_JPRB, 0.16256114E-05_JPRB, 0.15635655E-05_JPRB, 0.14889910E-05_JPRB, 0.14103484E-05_JPRB, &
  & 0.13359192E-05_JPRB, 0.12661873E-05_JPRB, 0.12004521E-05_JPRB, 0.11375950E-05_JPRB, 0.10814574E-05_JPRB, 0.10327622E-05_JPRB, &
  & 0.98940447E-06_JPRB, 0.94920618E-06_JPRB, 0.91675432E-06_JPRB, 0.89303821E-06_JPRB, 0.87101430E-06_JPRB, 0.85286858E-06_JPRB, &
  & 0.83972418E-06_JPRB, 0.83335714E-06_JPRB, 0.82497175E-06_JPRB, 0.81388502E-06_JPRB, 0.79943703E-06_JPRB, 0.78851617E-06_JPRB, &
  & 0.77960421E-06_JPRB, 0.77143854E-06_JPRB, 0.76377070E-06_JPRB, 0.76463943E-06_JPRB, 0.77382505E-06_JPRB, 0.77896554E-06_JPRB, &
  & 0.78747046E-06_JPRB, 0.79800995E-06_JPRB, 0.80077241E-06_JPRB, 0.80039825E-06_JPRB  /)

RGHG2(:,29, 4) = (/ &
  & 0.11940606E-05_JPRB, 0.12029100E-05_JPRB, 0.12145514E-05_JPRB, 0.12319075E-05_JPRB, 0.12526355E-05_JPRB, 0.12722316E-05_JPRB, &
  & 0.12918010E-05_JPRB, 0.13119503E-05_JPRB, 0.13327844E-05_JPRB, 0.13504582E-05_JPRB, 0.13626539E-05_JPRB, 0.13745329E-05_JPRB, &
  & 0.13880447E-05_JPRB, 0.14017673E-05_JPRB, 0.14179666E-05_JPRB, 0.14399863E-05_JPRB, 0.14606899E-05_JPRB, 0.14809449E-05_JPRB, &
  & 0.15008842E-05_JPRB, 0.15246193E-05_JPRB, 0.15529133E-05_JPRB, 0.15813132E-05_JPRB, 0.16070237E-05_JPRB, 0.16306279E-05_JPRB, &
  & 0.16542049E-05_JPRB, 0.16740416E-05_JPRB, 0.16905086E-05_JPRB, 0.17057114E-05_JPRB, 0.17166456E-05_JPRB, 0.17196757E-05_JPRB, &
  & 0.17109033E-05_JPRB, 0.16841134E-05_JPRB, 0.16407024E-05_JPRB, 0.15846214E-05_JPRB, 0.15175030E-05_JPRB, 0.14474073E-05_JPRB, &
  & 0.13812627E-05_JPRB, 0.13204643E-05_JPRB, 0.12632484E-05_JPRB, 0.12054036E-05_JPRB, 0.11503015E-05_JPRB, 0.11020481E-05_JPRB, &
  & 0.10601678E-05_JPRB, 0.10192377E-05_JPRB, 0.98515659E-06_JPRB, 0.96055679E-06_JPRB, 0.93751112E-06_JPRB, 0.91681099E-06_JPRB, &
  & 0.90145736E-06_JPRB, 0.89466230E-06_JPRB, 0.88676017E-06_JPRB, 0.87451360E-06_JPRB, 0.85589570E-06_JPRB, 0.84141248E-06_JPRB, &
  & 0.82990469E-06_JPRB, 0.81839757E-06_JPRB, 0.80744351E-06_JPRB, 0.80636537E-06_JPRB, 0.81653133E-06_JPRB, 0.82129902E-06_JPRB, &
  & 0.82762233E-06_JPRB, 0.83807898E-06_JPRB, 0.84342346E-06_JPRB, 0.84623886E-06_JPRB  /)

RGHG2(:,30, 4) = (/ &
  & 0.12488102E-05_JPRB, 0.12564168E-05_JPRB, 0.12681981E-05_JPRB, 0.12853796E-05_JPRB, 0.13050288E-05_JPRB, 0.13236243E-05_JPRB, &
  & 0.13424845E-05_JPRB, 0.13618757E-05_JPRB, 0.13817516E-05_JPRB, 0.13982242E-05_JPRB, 0.14104252E-05_JPRB, 0.14219948E-05_JPRB, &
  & 0.14352883E-05_JPRB, 0.14488654E-05_JPRB, 0.14639540E-05_JPRB, 0.14831956E-05_JPRB, 0.15017753E-05_JPRB, 0.15216722E-05_JPRB, &
  & 0.15416957E-05_JPRB, 0.15633832E-05_JPRB, 0.15869043E-05_JPRB, 0.16097604E-05_JPRB, 0.16311855E-05_JPRB, 0.16507035E-05_JPRB, &
  & 0.16698435E-05_JPRB, 0.16866261E-05_JPRB, 0.17003223E-05_JPRB, 0.17124814E-05_JPRB, 0.17209376E-05_JPRB, 0.17232449E-05_JPRB, &
  & 0.17159963E-05_JPRB, 0.16931275E-05_JPRB, 0.16552217E-05_JPRB, 0.16073761E-05_JPRB, 0.15507627E-05_JPRB, 0.14919433E-05_JPRB, &
  & 0.14378874E-05_JPRB, 0.13892450E-05_JPRB, 0.13423167E-05_JPRB, 0.12915784E-05_JPRB, 0.12399524E-05_JPRB, 0.11920087E-05_JPRB, &
  & 0.11491473E-05_JPRB, 0.11069429E-05_JPRB, 0.10690819E-05_JPRB, 0.10379251E-05_JPRB, 0.10090805E-05_JPRB, 0.98495748E-06_JPRB, &
  & 0.96657548E-06_JPRB, 0.95686889E-06_JPRB, 0.94762079E-06_JPRB, 0.93430575E-06_JPRB, 0.91401020E-06_JPRB, 0.89489020E-06_JPRB, &
  & 0.88042040E-06_JPRB, 0.86649645E-06_JPRB, 0.85221589E-06_JPRB, 0.84916490E-06_JPRB, 0.85849479E-06_JPRB, 0.86352900E-06_JPRB, &
  & 0.86853427E-06_JPRB, 0.87575219E-06_JPRB, 0.88247573E-06_JPRB, 0.88692545E-06_JPRB  /)

RGHG2(:,31, 4) = (/ &
  & 0.13064945E-05_JPRB, 0.13127899E-05_JPRB, 0.13247183E-05_JPRB, 0.13417143E-05_JPRB, 0.13602250E-05_JPRB, 0.13777652E-05_JPRB, &
  & 0.13958771E-05_JPRB, 0.14144688E-05_JPRB, 0.14333341E-05_JPRB, 0.14485403E-05_JPRB, 0.14607477E-05_JPRB, 0.14719910E-05_JPRB, &
  & 0.14850543E-05_JPRB, 0.14984779E-05_JPRB, 0.15123960E-05_JPRB, 0.15287083E-05_JPRB, 0.15450494E-05_JPRB, 0.15645688E-05_JPRB, &
  & 0.15846819E-05_JPRB, 0.16042140E-05_JPRB, 0.16227077E-05_JPRB, 0.16397243E-05_JPRB, 0.16566337E-05_JPRB, 0.16718472E-05_JPRB, &
  & 0.16863117E-05_JPRB, 0.16998771E-05_JPRB, 0.17106567E-05_JPRB, 0.17196114E-05_JPRB, 0.17254580E-05_JPRB, 0.17270041E-05_JPRB, &
  & 0.17213610E-05_JPRB, 0.17026240E-05_JPRB, 0.16705194E-05_JPRB, 0.16313532E-05_JPRB, 0.15858114E-05_JPRB, 0.15388758E-05_JPRB, &
  & 0.14975609E-05_JPRB, 0.14617298E-05_JPRB, 0.14256428E-05_JPRB, 0.13823942E-05_JPRB, 0.13344332E-05_JPRB, 0.12868157E-05_JPRB, &
  & 0.12429181E-05_JPRB, 0.11993705E-05_JPRB, 0.11575247E-05_JPRB, 0.11194539E-05_JPRB, 0.10844946E-05_JPRB, 0.10567642E-05_JPRB, &
  & 0.10351906E-05_JPRB, 0.10224139E-05_JPRB, 0.10117459E-05_JPRB, 0.99730517E-06_JPRB, 0.97524431E-06_JPRB, 0.95123773E-06_JPRB, &
  & 0.93364667E-06_JPRB, 0.91717710E-06_JPRB, 0.89939150E-06_JPRB, 0.89426180E-06_JPRB, 0.90270903E-06_JPRB, 0.90802467E-06_JPRB, &
  & 0.91164200E-06_JPRB, 0.91544443E-06_JPRB, 0.92361987E-06_JPRB, 0.92979013E-06_JPRB  /)

RGHG2(:,32, 4) = (/ &
  & 0.13617529E-05_JPRB, 0.13666828E-05_JPRB, 0.13771859E-05_JPRB, 0.13923799E-05_JPRB, 0.14086123E-05_JPRB, 0.14246094E-05_JPRB, &
  & 0.14412740E-05_JPRB, 0.14583149E-05_JPRB, 0.14751477E-05_JPRB, 0.14889059E-05_JPRB, 0.15010213E-05_JPRB, 0.15116828E-05_JPRB, &
  & 0.15243550E-05_JPRB, 0.15375710E-05_JPRB, 0.15507828E-05_JPRB, 0.15651024E-05_JPRB, 0.15798002E-05_JPRB, 0.15972132E-05_JPRB, &
  & 0.16155805E-05_JPRB, 0.16336638E-05_JPRB, 0.16497111E-05_JPRB, 0.16634601E-05_JPRB, 0.16765123E-05_JPRB, 0.16879538E-05_JPRB, &
  & 0.16985381E-05_JPRB, 0.17085034E-05_JPRB, 0.17166071E-05_JPRB, 0.17235180E-05_JPRB, 0.17281333E-05_JPRB, 0.17293325E-05_JPRB, &
  & 0.17246704E-05_JPRB, 0.17095627E-05_JPRB, 0.16838107E-05_JPRB, 0.16525156E-05_JPRB, 0.16170098E-05_JPRB, 0.15823883E-05_JPRB, &
  & 0.15539561E-05_JPRB, 0.15292495E-05_JPRB, 0.15025706E-05_JPRB, 0.14678696E-05_JPRB, 0.14252419E-05_JPRB, 0.13796480E-05_JPRB, &
  & 0.13354142E-05_JPRB, 0.12907602E-05_JPRB, 0.12448225E-05_JPRB, 0.12001626E-05_JPRB, 0.11597531E-05_JPRB, 0.11272776E-05_JPRB, &
  & 0.11022920E-05_JPRB, 0.10866112E-05_JPRB, 0.10744781E-05_JPRB, 0.10593102E-05_JPRB, 0.10374451E-05_JPRB, 0.10114607E-05_JPRB, &
  & 0.99028534E-06_JPRB, 0.97182439E-06_JPRB, 0.95244571E-06_JPRB, 0.94379571E-06_JPRB, 0.94899415E-06_JPRB, 0.95315161E-06_JPRB, &
  & 0.95415410E-06_JPRB, 0.95483390E-06_JPRB, 0.96115704E-06_JPRB, 0.96873300E-06_JPRB  /)

RGHG2(:,33, 4) = (/ &
  & 0.14188659E-05_JPRB, 0.14223697E-05_JPRB, 0.14311879E-05_JPRB, 0.14442999E-05_JPRB, 0.14580171E-05_JPRB, 0.14723473E-05_JPRB, &
  & 0.14874173E-05_JPRB, 0.15027493E-05_JPRB, 0.15173377E-05_JPRB, 0.15295674E-05_JPRB, 0.15415745E-05_JPRB, 0.15515981E-05_JPRB, &
  & 0.15638431E-05_JPRB, 0.15768365E-05_JPRB, 0.15893744E-05_JPRB, 0.16017443E-05_JPRB, 0.16148114E-05_JPRB, 0.16298114E-05_JPRB, &
  & 0.16461268E-05_JPRB, 0.16627960E-05_JPRB, 0.16766349E-05_JPRB, 0.16873210E-05_JPRB, 0.16964499E-05_JPRB, 0.17040403E-05_JPRB, &
  & 0.17106953E-05_JPRB, 0.17168696E-05_JPRB, 0.17222233E-05_JPRB, 0.17271605E-05_JPRB, 0.17306746E-05_JPRB, 0.17315670E-05_JPRB, &
  & 0.17278435E-05_JPRB, 0.17164426E-05_JPRB, 0.16973639E-05_JPRB, 0.16741442E-05_JPRB, 0.16489340E-05_JPRB, 0.16271657E-05_JPRB, &
  & 0.16121403E-05_JPRB, 0.15987765E-05_JPRB, 0.15816893E-05_JPRB, 0.15560084E-05_JPRB, 0.15191393E-05_JPRB, 0.14758681E-05_JPRB, &
  & 0.14313755E-05_JPRB, 0.13856023E-05_JPRB, 0.13353983E-05_JPRB, 0.12839327E-05_JPRB, 0.12379451E-05_JPRB, 0.12003909E-05_JPRB, &
  & 0.11718310E-05_JPRB, 0.11531535E-05_JPRB, 0.11394920E-05_JPRB, 0.11236201E-05_JPRB, 0.11022123E-05_JPRB, 0.10745490E-05_JPRB, &
  & 0.10495887E-05_JPRB, 0.10291300E-05_JPRB, 0.10083433E-05_JPRB, 0.99584815E-06_JPRB, 0.99736395E-06_JPRB, 0.10001314E-05_JPRB, &
  & 0.99825757E-06_JPRB, 0.99573010E-06_JPRB, 0.99970044E-06_JPRB, 0.10086965E-05_JPRB  /)

RGHG2(:,34, 4) = (/ &
  & 0.14692754E-05_JPRB, 0.14717755E-05_JPRB, 0.14784713E-05_JPRB, 0.14894482E-05_JPRB, 0.15011542E-05_JPRB, 0.15135637E-05_JPRB, &
  & 0.15267768E-05_JPRB, 0.15399602E-05_JPRB, 0.15521711E-05_JPRB, 0.15631022E-05_JPRB, 0.15743559E-05_JPRB, 0.15836672E-05_JPRB, &
  & 0.15952193E-05_JPRB, 0.16075227E-05_JPRB, 0.16191659E-05_JPRB, 0.16302781E-05_JPRB, 0.16419944E-05_JPRB, 0.16550680E-05_JPRB, &
  & 0.16690482E-05_JPRB, 0.16830910E-05_JPRB, 0.16945209E-05_JPRB, 0.17028686E-05_JPRB, 0.17094342E-05_JPRB, 0.17145396E-05_JPRB, &
  & 0.17186727E-05_JPRB, 0.17223930E-05_JPRB, 0.17257117E-05_JPRB, 0.17290100E-05_JPRB, 0.17315778E-05_JPRB, 0.17322629E-05_JPRB, &
  & 0.17293628E-05_JPRB, 0.17208987E-05_JPRB, 0.17073132E-05_JPRB, 0.16910678E-05_JPRB, 0.16742887E-05_JPRB, 0.16612955E-05_JPRB, &
  & 0.16534435E-05_JPRB, 0.16457617E-05_JPRB, 0.16340851E-05_JPRB, 0.16148852E-05_JPRB, 0.15845887E-05_JPRB, 0.15463875E-05_JPRB, &
  & 0.15047361E-05_JPRB, 0.14602639E-05_JPRB, 0.14101974E-05_JPRB, 0.13565021E-05_JPRB, 0.13080017E-05_JPRB, 0.12674089E-05_JPRB, &
  & 0.12364381E-05_JPRB, 0.12154116E-05_JPRB, 0.12002848E-05_JPRB, 0.11839141E-05_JPRB, 0.11629991E-05_JPRB, 0.11347769E-05_JPRB, &
  & 0.11082231E-05_JPRB, 0.10870739E-05_JPRB, 0.10659633E-05_JPRB, 0.10499853E-05_JPRB, 0.10469602E-05_JPRB, 0.10474099E-05_JPRB, &
  & 0.10422562E-05_JPRB, 0.10377480E-05_JPRB, 0.10399532E-05_JPRB, 0.10470310E-05_JPRB  /)

RGHG2(:,35, 4) = (/ &
  & 0.15176631E-05_JPRB, 0.15193479E-05_JPRB, 0.15236371E-05_JPRB, 0.15323917E-05_JPRB, 0.15422885E-05_JPRB, 0.15525929E-05_JPRB, &
  & 0.15637624E-05_JPRB, 0.15745113E-05_JPRB, 0.15842095E-05_JPRB, 0.15939232E-05_JPRB, 0.16040714E-05_JPRB, 0.16126121E-05_JPRB, &
  & 0.16233155E-05_JPRB, 0.16346696E-05_JPRB, 0.16452799E-05_JPRB, 0.16554540E-05_JPRB, 0.16659251E-05_JPRB, 0.16772678E-05_JPRB, &
  & 0.16887017E-05_JPRB, 0.16994222E-05_JPRB, 0.17082724E-05_JPRB, 0.17145876E-05_JPRB, 0.17192156E-05_JPRB, 0.17224672E-05_JPRB, &
  & 0.17247298E-05_JPRB, 0.17266130E-05_JPRB, 0.17282063E-05_JPRB, 0.17299914E-05_JPRB, 0.17316658E-05_JPRB, 0.17321890E-05_JPRB, &
  & 0.17300762E-05_JPRB, 0.17242365E-05_JPRB, 0.17156931E-05_JPRB, 0.17060533E-05_JPRB, 0.16969854E-05_JPRB, 0.16909217E-05_JPRB, &
  & 0.16872463E-05_JPRB, 0.16825016E-05_JPRB, 0.16742423E-05_JPRB, 0.16604028E-05_JPRB, 0.16372815E-05_JPRB, 0.16057026E-05_JPRB, &
  & 0.15685629E-05_JPRB, 0.15266704E-05_JPRB, 0.14790049E-05_JPRB, 0.14253655E-05_JPRB, 0.13758544E-05_JPRB, 0.13331844E-05_JPRB, &
  & 0.13003320E-05_JPRB, 0.12772227E-05_JPRB, 0.12606218E-05_JPRB, 0.12438434E-05_JPRB, 0.12234533E-05_JPRB, 0.11952311E-05_JPRB, &
  & 0.11681636E-05_JPRB, 0.11469753E-05_JPRB, 0.11260881E-05_JPRB, 0.11067151E-05_JPRB, 0.10985808E-05_JPRB, 0.10961717E-05_JPRB, &
  & 0.10874388E-05_JPRB, 0.10815235E-05_JPRB, 0.10822155E-05_JPRB, 0.10856080E-05_JPRB  /)

RGHG2(:,36, 4) = (/ &
  & 0.15623131E-05_JPRB, 0.15633108E-05_JPRB, 0.15654149E-05_JPRB, 0.15721248E-05_JPRB, 0.15802972E-05_JPRB, 0.15885843E-05_JPRB, &
  & 0.15977752E-05_JPRB, 0.16062458E-05_JPRB, 0.16137123E-05_JPRB, 0.16221569E-05_JPRB, 0.16310322E-05_JPRB, 0.16387452E-05_JPRB, &
  & 0.16485207E-05_JPRB, 0.16588294E-05_JPRB, 0.16682900E-05_JPRB, 0.16773947E-05_JPRB, 0.16865321E-05_JPRB, 0.16960942E-05_JPRB, &
  & 0.17051260E-05_JPRB, 0.17128870E-05_JPRB, 0.17193527E-05_JPRB, 0.17238090E-05_JPRB, 0.17267331E-05_JPRB, 0.17284345E-05_JPRB, &
  & 0.17291541E-05_JPRB, 0.17295341E-05_JPRB, 0.17297545E-05_JPRB, 0.17302949E-05_JPRB, 0.17311789E-05_JPRB, 0.17315537E-05_JPRB, &
  & 0.17302390E-05_JPRB, 0.17267772E-05_JPRB, 0.17223660E-05_JPRB, 0.17179504E-05_JPRB, 0.17147779E-05_JPRB, 0.17138029E-05_JPRB, &
  & 0.17131923E-05_JPRB, 0.17107730E-05_JPRB, 0.17054240E-05_JPRB, 0.16961531E-05_JPRB, 0.16794963E-05_JPRB, 0.16543901E-05_JPRB, &
  & 0.16222219E-05_JPRB, 0.15838070E-05_JPRB, 0.15393214E-05_JPRB, 0.14874497E-05_JPRB, 0.14383462E-05_JPRB, 0.13950828E-05_JPRB, &
  & 0.13612188E-05_JPRB, 0.13365851E-05_JPRB, 0.13187305E-05_JPRB, 0.13014810E-05_JPRB, 0.12813150E-05_JPRB, 0.12534438E-05_JPRB, &
  & 0.12265750E-05_JPRB, 0.12059685E-05_JPRB, 0.11851998E-05_JPRB, 0.11635244E-05_JPRB, 0.11511450E-05_JPRB, 0.11456298E-05_JPRB, &
  & 0.11336483E-05_JPRB, 0.11266226E-05_JPRB, 0.11251541E-05_JPRB, 0.11239382E-05_JPRB  /)

RGHG2(:,37, 4) = (/ &
  & 0.15956156E-05_JPRB, 0.15962628E-05_JPRB, 0.15968257E-05_JPRB, 0.16020252E-05_JPRB, 0.16087750E-05_JPRB, 0.16153713E-05_JPRB, &
  & 0.16228561E-05_JPRB, 0.16295484E-05_JPRB, 0.16355664E-05_JPRB, 0.16427017E-05_JPRB, 0.16499997E-05_JPRB, 0.16568055E-05_JPRB, &
  & 0.16655295E-05_JPRB, 0.16746371E-05_JPRB, 0.16827524E-05_JPRB, 0.16905530E-05_JPRB, 0.16982368E-05_JPRB, 0.17060154E-05_JPRB, &
  & 0.17131245E-05_JPRB, 0.17189423E-05_JPRB, 0.17236193E-05_JPRB, 0.17267302E-05_JPRB, 0.17285925E-05_JPRB, 0.17295361E-05_JPRB, &
  & 0.17295599E-05_JPRB, 0.17292956E-05_JPRB, 0.17290365E-05_JPRB, 0.17290254E-05_JPRB, 0.17294043E-05_JPRB, 0.17296708E-05_JPRB, &
  & 0.17291293E-05_JPRB, 0.17273324E-05_JPRB, 0.17247099E-05_JPRB, 0.17220262E-05_JPRB, 0.17202198E-05_JPRB, 0.17197963E-05_JPRB, &
  & 0.17195104E-05_JPRB, 0.17178694E-05_JPRB, 0.17140874E-05_JPRB, 0.17072856E-05_JPRB, 0.16950618E-05_JPRB, 0.16756824E-05_JPRB, &
  & 0.16492306E-05_JPRB, 0.16161353E-05_JPRB, 0.15764177E-05_JPRB, 0.15301284E-05_JPRB, 0.14846589E-05_JPRB, 0.14442409E-05_JPRB, &
  & 0.14114232E-05_JPRB, 0.13866400E-05_JPRB, 0.13681154E-05_JPRB, 0.13502782E-05_JPRB, 0.13296329E-05_JPRB, 0.13028957E-05_JPRB, &
  & 0.12778465E-05_JPRB, 0.12592090E-05_JPRB, 0.12383115E-05_JPRB, 0.12169815E-05_JPRB, 0.12026020E-05_JPRB, 0.11936075E-05_JPRB, &
  & 0.11793373E-05_JPRB, 0.11719508E-05_JPRB, 0.11669720E-05_JPRB, 0.11593180E-05_JPRB  /)

RGHG2(:,38, 4) = (/ &
  & 0.16325676E-05_JPRB, 0.16328259E-05_JPRB, 0.16316787E-05_JPRB, 0.16352024E-05_JPRB, 0.16403736E-05_JPRB, 0.16450940E-05_JPRB, &
  & 0.16506856E-05_JPRB, 0.16554046E-05_JPRB, 0.16598155E-05_JPRB, 0.16654981E-05_JPRB, 0.16710458E-05_JPRB, 0.16768450E-05_JPRB, &
  & 0.16844022E-05_JPRB, 0.16921772E-05_JPRB, 0.16987997E-05_JPRB, 0.17051533E-05_JPRB, 0.17112242E-05_JPRB, 0.17170238E-05_JPRB, &
  & 0.17219995E-05_JPRB, 0.17256611E-05_JPRB, 0.17283534E-05_JPRB, 0.17299715E-05_JPRB, 0.17306556E-05_JPRB, 0.17307585E-05_JPRB, &
  & 0.17300101E-05_JPRB, 0.17290308E-05_JPRB, 0.17282399E-05_JPRB, 0.17276168E-05_JPRB, 0.17274352E-05_JPRB, 0.17275815E-05_JPRB, &
  & 0.17278980E-05_JPRB, 0.17279485E-05_JPRB, 0.17273106E-05_JPRB, 0.17265487E-05_JPRB, 0.17262579E-05_JPRB, 0.17264465E-05_JPRB, &
  & 0.17265209E-05_JPRB, 0.17257436E-05_JPRB, 0.17237003E-05_JPRB, 0.17196381E-05_JPRB, 0.17123331E-05_JPRB, 0.16993080E-05_JPRB, &
  & 0.16791992E-05_JPRB, 0.16520064E-05_JPRB, 0.16175793E-05_JPRB, 0.15774842E-05_JPRB, 0.15360470E-05_JPRB, 0.14987862E-05_JPRB, &
  & 0.14671295E-05_JPRB, 0.14421805E-05_JPRB, 0.14229123E-05_JPRB, 0.14044231E-05_JPRB, 0.13832458E-05_JPRB, 0.13577670E-05_JPRB, &
  & 0.13347367E-05_JPRB, 0.13182841E-05_JPRB, 0.12972436E-05_JPRB, 0.12762968E-05_JPRB, 0.12596982E-05_JPRB, 0.12468430E-05_JPRB, &
  & 0.12300334E-05_JPRB, 0.12222465E-05_JPRB, 0.12133727E-05_JPRB, 0.11985750E-05_JPRB  /)

RGHG2(:,39, 4) = (/ &
  & 0.16522448E-05_JPRB, 0.16523753E-05_JPRB, 0.16510641E-05_JPRB, 0.16536033E-05_JPRB, 0.16577709E-05_JPRB, 0.16614040E-05_JPRB, &
  & 0.16658507E-05_JPRB, 0.16695940E-05_JPRB, 0.16732982E-05_JPRB, 0.16778404E-05_JPRB, 0.16822772E-05_JPRB, 0.16872848E-05_JPRB, &
  & 0.16937530E-05_JPRB, 0.17003550E-05_JPRB, 0.17059146E-05_JPRB, 0.17112169E-05_JPRB, 0.17161731E-05_JPRB, 0.17207865E-05_JPRB, &
  & 0.17246640E-05_JPRB, 0.17274097E-05_JPRB, 0.17293389E-05_JPRB, 0.17303609E-05_JPRB, 0.17305121E-05_JPRB, 0.17301192E-05_JPRB, &
  & 0.17289802E-05_JPRB, 0.17277674E-05_JPRB, 0.17267345E-05_JPRB, 0.17259131E-05_JPRB, 0.17256217E-05_JPRB, 0.17257987E-05_JPRB, &
  & 0.17265410E-05_JPRB, 0.17270191E-05_JPRB, 0.17268914E-05_JPRB, 0.17266300E-05_JPRB, 0.17266069E-05_JPRB, 0.17268189E-05_JPRB, &
  & 0.17269991E-05_JPRB, 0.17267347E-05_JPRB, 0.17253896E-05_JPRB, 0.17223682E-05_JPRB, 0.17170080E-05_JPRB, 0.17068461E-05_JPRB, &
  & 0.16903600E-05_JPRB, 0.16669932E-05_JPRB, 0.16368768E-05_JPRB, 0.16017110E-05_JPRB, 0.15645682E-05_JPRB, 0.15311801E-05_JPRB, &
  & 0.15019116E-05_JPRB, 0.14784150E-05_JPRB, 0.14601378E-05_JPRB, 0.14422620E-05_JPRB, 0.14215338E-05_JPRB, 0.13977022E-05_JPRB, &
  & 0.13762169E-05_JPRB, 0.13603566E-05_JPRB, 0.13407076E-05_JPRB, 0.13196348E-05_JPRB, 0.13031864E-05_JPRB, 0.12892541E-05_JPRB, &
  & 0.12719610E-05_JPRB, 0.12631975E-05_JPRB, 0.12520495E-05_JPRB, 0.12346048E-05_JPRB  /)

RGHG2(:,40, 4) = (/ &
  & 0.16725115E-05_JPRB, 0.16725347E-05_JPRB, 0.16712840E-05_JPRB, 0.16727808E-05_JPRB, 0.16758647E-05_JPRB, 0.16783509E-05_JPRB, &
  & 0.16815764E-05_JPRB, 0.16843378E-05_JPRB, 0.16873598E-05_JPRB, 0.16906148E-05_JPRB, 0.16938525E-05_JPRB, 0.16979661E-05_JPRB, &
  & 0.17031692E-05_JPRB, 0.17084207E-05_JPRB, 0.17128031E-05_JPRB, 0.17169364E-05_JPRB, 0.17206660E-05_JPRB, 0.17240169E-05_JPRB, &
  & 0.17267750E-05_JPRB, 0.17286488E-05_JPRB, 0.17298821E-05_JPRB, 0.17303513E-05_JPRB, 0.17299826E-05_JPRB, 0.17290644E-05_JPRB, &
  & 0.17275293E-05_JPRB, 0.17261213E-05_JPRB, 0.17248518E-05_JPRB, 0.17238654E-05_JPRB, 0.17235190E-05_JPRB, 0.17237565E-05_JPRB, &
  & 0.17249279E-05_JPRB, 0.17256755E-05_JPRB, 0.17259054E-05_JPRB, 0.17259988E-05_JPRB, 0.17260857E-05_JPRB, 0.17262289E-05_JPRB, &
  & 0.17264917E-05_JPRB, 0.17267719E-05_JPRB, 0.17260758E-05_JPRB, 0.17239978E-05_JPRB, 0.17204337E-05_JPRB, 0.17130607E-05_JPRB, &
  & 0.17003813E-05_JPRB, 0.16811649E-05_JPRB, 0.16559471E-05_JPRB, 0.16263591E-05_JPRB, 0.15942991E-05_JPRB, 0.15655730E-05_JPRB, &
  & 0.15393080E-05_JPRB, 0.15177808E-05_JPRB, 0.15009503E-05_JPRB, 0.14840014E-05_JPRB, 0.14639608E-05_JPRB, 0.14421261E-05_JPRB, &
  & 0.14223763E-05_JPRB, 0.14069505E-05_JPRB, 0.13891856E-05_JPRB, 0.13678818E-05_JPRB, 0.13519972E-05_JPRB, 0.13372563E-05_JPRB, &
  & 0.13197322E-05_JPRB, 0.13097282E-05_JPRB, 0.12961763E-05_JPRB, 0.12763607E-05_JPRB  /)

RGHG2(:,41, 4) = (/ &
  & 0.16972904E-05_JPRB, 0.16971825E-05_JPRB, 0.16960058E-05_JPRB, 0.16962280E-05_JPRB, 0.16979870E-05_JPRB, 0.16990709E-05_JPRB, &
  & 0.17008033E-05_JPRB, 0.17023642E-05_JPRB, 0.17045522E-05_JPRB, 0.17062334E-05_JPRB, 0.17080049E-05_JPRB, 0.17110256E-05_JPRB, &
  & 0.17146818E-05_JPRB, 0.17182822E-05_JPRB, 0.17212252E-05_JPRB, 0.17239294E-05_JPRB, 0.17261591E-05_JPRB, 0.17279665E-05_JPRB, &
  & 0.17293560E-05_JPRB, 0.17301637E-05_JPRB, 0.17305462E-05_JPRB, 0.17303395E-05_JPRB, 0.17293353E-05_JPRB, 0.17277748E-05_JPRB, &
  & 0.17257554E-05_JPRB, 0.17241086E-05_JPRB, 0.17225500E-05_JPRB, 0.17213618E-05_JPRB, 0.17209482E-05_JPRB, 0.17212596E-05_JPRB, &
  & 0.17229556E-05_JPRB, 0.17240328E-05_JPRB, 0.17246998E-05_JPRB, 0.17252270E-05_JPRB, 0.17254485E-05_JPRB, 0.17255076E-05_JPRB, &
  & 0.17258712E-05_JPRB, 0.17268173E-05_JPRB, 0.17269149E-05_JPRB, 0.17259903E-05_JPRB, 0.17246221E-05_JPRB, 0.17206590E-05_JPRB, &
  & 0.17126337E-05_JPRB, 0.16984918E-05_JPRB, 0.16792632E-05_JPRB, 0.16564950E-05_JPRB, 0.16306495E-05_JPRB, 0.16076234E-05_JPRB, &
  & 0.15850306E-05_JPRB, 0.15659111E-05_JPRB, 0.15508495E-05_JPRB, 0.15350338E-05_JPRB, 0.15158340E-05_JPRB, 0.14964406E-05_JPRB, &
  & 0.14788128E-05_JPRB, 0.14639184E-05_JPRB, 0.14484569E-05_JPRB, 0.14268707E-05_JPRB, 0.14116754E-05_JPRB, 0.13959459E-05_JPRB, &
  & 0.13781393E-05_JPRB, 0.13666187E-05_JPRB, 0.13501276E-05_JPRB, 0.13274133E-05_JPRB  /)

RGHG2(:,42, 4) = (/ &
  & 0.16970855E-05_JPRB, 0.16969049E-05_JPRB, 0.16963150E-05_JPRB, 0.16966728E-05_JPRB, 0.16983257E-05_JPRB, 0.16994889E-05_JPRB, &
  & 0.17012018E-05_JPRB, 0.17028088E-05_JPRB, 0.17047174E-05_JPRB, 0.17063589E-05_JPRB, 0.17082399E-05_JPRB, 0.17109179E-05_JPRB, &
  & 0.17141762E-05_JPRB, 0.17173735E-05_JPRB, 0.17201371E-05_JPRB, 0.17226389E-05_JPRB, 0.17247540E-05_JPRB, 0.17265584E-05_JPRB, &
  & 0.17279750E-05_JPRB, 0.17288272E-05_JPRB, 0.17291927E-05_JPRB, 0.17289338E-05_JPRB, 0.17279239E-05_JPRB, 0.17264044E-05_JPRB, &
  & 0.17245552E-05_JPRB, 0.17230246E-05_JPRB, 0.17216423E-05_JPRB, 0.17207346E-05_JPRB, 0.17205381E-05_JPRB, 0.17210728E-05_JPRB, &
  & 0.17226051E-05_JPRB, 0.17235160E-05_JPRB, 0.17240388E-05_JPRB, 0.17244087E-05_JPRB, 0.17245922E-05_JPRB, 0.17247491E-05_JPRB, &
  & 0.17250216E-05_JPRB, 0.17255301E-05_JPRB, 0.17254062E-05_JPRB, 0.17246032E-05_JPRB, 0.17230105E-05_JPRB, 0.17190577E-05_JPRB, &
  & 0.17111322E-05_JPRB, 0.16978228E-05_JPRB, 0.16799915E-05_JPRB, 0.16590144E-05_JPRB, 0.16359326E-05_JPRB, 0.16150437E-05_JPRB, &
  & 0.15953988E-05_JPRB, 0.15785362E-05_JPRB, 0.15652038E-05_JPRB, 0.15522932E-05_JPRB, 0.15366599E-05_JPRB, 0.15193549E-05_JPRB, &
  & 0.15023481E-05_JPRB, 0.14872941E-05_JPRB, 0.14720955E-05_JPRB, 0.14537582E-05_JPRB, 0.14396995E-05_JPRB, 0.14254322E-05_JPRB, &
  & 0.14085623E-05_JPRB, 0.13965206E-05_JPRB, 0.13833639E-05_JPRB, 0.13652337E-05_JPRB  /)

RGHG2(:,43, 4) = (/ &
  & 0.17075573E-05_JPRB, 0.17072539E-05_JPRB, 0.17072313E-05_JPRB, 0.17071644E-05_JPRB, 0.17081506E-05_JPRB, 0.17087831E-05_JPRB, &
  & 0.17098358E-05_JPRB, 0.17109684E-05_JPRB, 0.17122634E-05_JPRB, 0.17131917E-05_JPRB, 0.17145419E-05_JPRB, 0.17164371E-05_JPRB, &
  & 0.17186671E-05_JPRB, 0.17207863E-05_JPRB, 0.17227671E-05_JPRB, 0.17244694E-05_JPRB, 0.17258349E-05_JPRB, 0.17269725E-05_JPRB, &
  & 0.17278252E-05_JPRB, 0.17282595E-05_JPRB, 0.17282435E-05_JPRB, 0.17276463E-05_JPRB, 0.17263577E-05_JPRB, 0.17245994E-05_JPRB, &
  & 0.17226971E-05_JPRB, 0.17211698E-05_JPRB, 0.17198240E-05_JPRB, 0.17190855E-05_JPRB, 0.17190582E-05_JPRB, 0.17198284E-05_JPRB, &
  & 0.17214369E-05_JPRB, 0.17223379E-05_JPRB, 0.17229171E-05_JPRB, 0.17233301E-05_JPRB, 0.17235368E-05_JPRB, 0.17237468E-05_JPRB, &
  & 0.17239795E-05_JPRB, 0.17243752E-05_JPRB, 0.17243907E-05_JPRB, 0.17241946E-05_JPRB, 0.17233417E-05_JPRB, 0.17208650E-05_JPRB, &
  & 0.17150327E-05_JPRB, 0.17046656E-05_JPRB, 0.16906855E-05_JPRB, 0.16742761E-05_JPRB, 0.16563889E-05_JPRB, 0.16399019E-05_JPRB, &
  & 0.16245262E-05_JPRB, 0.16107585E-05_JPRB, 0.15997646E-05_JPRB, 0.15899921E-05_JPRB, 0.15779745E-05_JPRB, 0.15636251E-05_JPRB, &
  & 0.15480978E-05_JPRB, 0.15331267E-05_JPRB, 0.15191587E-05_JPRB, 0.15036642E-05_JPRB, 0.14909390E-05_JPRB, 0.14775807E-05_JPRB, &
  & 0.14614438E-05_JPRB, 0.14482743E-05_JPRB, 0.14368956E-05_JPRB, 0.14217011E-05_JPRB  /)

RGHG2(:,44, 4) = (/ &
  & 0.17088506E-05_JPRB, 0.17086837E-05_JPRB, 0.17087081E-05_JPRB, 0.17087370E-05_JPRB, 0.17095557E-05_JPRB, 0.17102042E-05_JPRB, &
  & 0.17111987E-05_JPRB, 0.17122397E-05_JPRB, 0.17134070E-05_JPRB, 0.17143130E-05_JPRB, 0.17155093E-05_JPRB, 0.17171413E-05_JPRB, &
  & 0.17190425E-05_JPRB, 0.17208742E-05_JPRB, 0.17225674E-05_JPRB, 0.17239656E-05_JPRB, 0.17251014E-05_JPRB, 0.17260272E-05_JPRB, &
  & 0.17267110E-05_JPRB, 0.17270860E-05_JPRB, 0.17270152E-05_JPRB, 0.17263883E-05_JPRB, 0.17251135E-05_JPRB, 0.17233688E-05_JPRB, &
  & 0.17216510E-05_JPRB, 0.17202220E-05_JPRB, 0.17190221E-05_JPRB, 0.17184192E-05_JPRB, 0.17185616E-05_JPRB, 0.17195043E-05_JPRB, &
  & 0.17210115E-05_JPRB, 0.17218251E-05_JPRB, 0.17223208E-05_JPRB, 0.17226933E-05_JPRB, 0.17228860E-05_JPRB, 0.17231516E-05_JPRB, &
  & 0.17233658E-05_JPRB, 0.17237040E-05_JPRB, 0.17235840E-05_JPRB, 0.17234735E-05_JPRB, 0.17229499E-05_JPRB, 0.17209367E-05_JPRB, &
  & 0.17157736E-05_JPRB, 0.17065730E-05_JPRB, 0.16945458E-05_JPRB, 0.16803885E-05_JPRB, 0.16652366E-05_JPRB, 0.16514600E-05_JPRB, &
  & 0.16387209E-05_JPRB, 0.16272772E-05_JPRB, 0.16179326E-05_JPRB, 0.16096849E-05_JPRB, 0.15997792E-05_JPRB, 0.15879892E-05_JPRB, &
  & 0.15747195E-05_JPRB, 0.15616122E-05_JPRB, 0.15494479E-05_JPRB, 0.15367954E-05_JPRB, 0.15249094E-05_JPRB, 0.15126904E-05_JPRB, &
  & 0.14973865E-05_JPRB, 0.14858737E-05_JPRB, 0.14760022E-05_JPRB, 0.14650024E-05_JPRB  /)

RGHG2(:,45, 4) = (/ &
  & 0.17116458E-05_JPRB, 0.17116188E-05_JPRB, 0.17117684E-05_JPRB, 0.17118525E-05_JPRB, 0.17123964E-05_JPRB, 0.17129961E-05_JPRB, &
  & 0.17138410E-05_JPRB, 0.17147177E-05_JPRB, 0.17156622E-05_JPRB, 0.17164527E-05_JPRB, 0.17174066E-05_JPRB, 0.17186401E-05_JPRB, &
  & 0.17200372E-05_JPRB, 0.17214053E-05_JPRB, 0.17226724E-05_JPRB, 0.17236233E-05_JPRB, 0.17244028E-05_JPRB, 0.17250034E-05_JPRB, &
  & 0.17254237E-05_JPRB, 0.17256783E-05_JPRB, 0.17254969E-05_JPRB, 0.17247936E-05_JPRB, 0.17234993E-05_JPRB, 0.17217400E-05_JPRB, &
  & 0.17202255E-05_JPRB, 0.17189086E-05_JPRB, 0.17178795E-05_JPRB, 0.17174523E-05_JPRB, 0.17178095E-05_JPRB, 0.17189782E-05_JPRB, &
  & 0.17203797E-05_JPRB, 0.17210924E-05_JPRB, 0.17215003E-05_JPRB, 0.17218322E-05_JPRB, 0.17220118E-05_JPRB, 0.17223473E-05_JPRB, &
  & 0.17225355E-05_JPRB, 0.17227941E-05_JPRB, 0.17225374E-05_JPRB, 0.17226009E-05_JPRB, 0.17225458E-05_JPRB, 0.17212466E-05_JPRB, &
  & 0.17171098E-05_JPRB, 0.17096089E-05_JPRB, 0.17002914E-05_JPRB, 0.16892748E-05_JPRB, 0.16778932E-05_JPRB, 0.16677583E-05_JPRB, &
  & 0.16585600E-05_JPRB, 0.16501529E-05_JPRB, 0.16429813E-05_JPRB, 0.16368660E-05_JPRB, 0.16298212E-05_JPRB, 0.16213184E-05_JPRB, &
  & 0.16108055E-05_JPRB, 0.15998306E-05_JPRB, 0.15898750E-05_JPRB, 0.15808170E-05_JPRB, 0.15700550E-05_JPRB, 0.15592477E-05_JPRB, &
  & 0.15449848E-05_JPRB, 0.15352156E-05_JPRB, 0.15272845E-05_JPRB, 0.15214309E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART8',0,ZHOOK_HANDLE)



RGHG2(:,46, 4) = (/ &
  & 0.17121348E-05_JPRB, 0.17121704E-05_JPRB, 0.17122896E-05_JPRB, 0.17124144E-05_JPRB, 0.17128903E-05_JPRB, 0.17135167E-05_JPRB, &
  & 0.17142947E-05_JPRB, 0.17151219E-05_JPRB, 0.17159621E-05_JPRB, 0.17166943E-05_JPRB, 0.17174971E-05_JPRB, 0.17184920E-05_JPRB, &
  & 0.17196019E-05_JPRB, 0.17206733E-05_JPRB, 0.17216480E-05_JPRB, 0.17223046E-05_JPRB, 0.17228642E-05_JPRB, 0.17233502E-05_JPRB, &
  & 0.17237304E-05_JPRB, 0.17240214E-05_JPRB, 0.17239165E-05_JPRB, 0.17232614E-05_JPRB, 0.17220918E-05_JPRB, 0.17204705E-05_JPRB, &
  & 0.17191631E-05_JPRB, 0.17180353E-05_JPRB, 0.17172139E-05_JPRB, 0.17169268E-05_JPRB, 0.17173830E-05_JPRB, 0.17186357E-05_JPRB, &
  & 0.17199506E-05_JPRB, 0.17206136E-05_JPRB, 0.17209214E-05_JPRB, 0.17212557E-05_JPRB, 0.17214720E-05_JPRB, 0.17218694E-05_JPRB, &
  & 0.17220157E-05_JPRB, 0.17222217E-05_JPRB, 0.17219196E-05_JPRB, 0.17219901E-05_JPRB, 0.17221719E-05_JPRB, 0.17212895E-05_JPRB, &
  & 0.17177802E-05_JPRB, 0.17113860E-05_JPRB, 0.17039166E-05_JPRB, 0.16951035E-05_JPRB, 0.16864635E-05_JPRB, 0.16790225E-05_JPRB, &
  & 0.16723952E-05_JPRB, 0.16662632E-05_JPRB, 0.16608181E-05_JPRB, 0.16562434E-05_JPRB, 0.16509952E-05_JPRB, 0.16448882E-05_JPRB, &
  & 0.16367609E-05_JPRB, 0.16282075E-05_JPRB, 0.16205540E-05_JPRB, 0.16135912E-05_JPRB, 0.16044585E-05_JPRB, 0.15949937E-05_JPRB, &
  & 0.15830234E-05_JPRB, 0.15754570E-05_JPRB, 0.15693917E-05_JPRB, 0.15660335E-05_JPRB  /)

RGHG2(:,47, 4) = (/ &
  & 0.17122467E-05_JPRB, 0.17123402E-05_JPRB, 0.17123925E-05_JPRB, 0.17125622E-05_JPRB, 0.17129997E-05_JPRB, 0.17136727E-05_JPRB, &
  & 0.17143887E-05_JPRB, 0.17151808E-05_JPRB, 0.17159223E-05_JPRB, 0.17165974E-05_JPRB, 0.17172413E-05_JPRB, 0.17179883E-05_JPRB, &
  & 0.17188047E-05_JPRB, 0.17195614E-05_JPRB, 0.17202197E-05_JPRB, 0.17205615E-05_JPRB, 0.17208904E-05_JPRB, 0.17212844E-05_JPRB, &
  & 0.17216620E-05_JPRB, 0.17220273E-05_JPRB, 0.17220495E-05_JPRB, 0.17214760E-05_JPRB, 0.17204817E-05_JPRB, 0.17190528E-05_JPRB, &
  & 0.17179892E-05_JPRB, 0.17170987E-05_JPRB, 0.17165284E-05_JPRB, 0.17163987E-05_JPRB, 0.17169478E-05_JPRB, 0.17182707E-05_JPRB, &
  & 0.17194877E-05_JPRB, 0.17201025E-05_JPRB, 0.17202905E-05_JPRB, 0.17206362E-05_JPRB, 0.17209056E-05_JPRB, 0.17213738E-05_JPRB, &
  & 0.17214680E-05_JPRB, 0.17216177E-05_JPRB, 0.17212806E-05_JPRB, 0.17213258E-05_JPRB, 0.17217391E-05_JPRB, 0.17212865E-05_JPRB, &
  & 0.17184335E-05_JPRB, 0.17132191E-05_JPRB, 0.17077457E-05_JPRB, 0.17013305E-05_JPRB, 0.16957016E-05_JPRB, 0.16912317E-05_JPRB, &
  & 0.16874272E-05_JPRB, 0.16838122E-05_JPRB, 0.16803035E-05_JPRB, 0.16774182E-05_JPRB, 0.16740649E-05_JPRB, 0.16705907E-05_JPRB, &
  & 0.16651882E-05_JPRB, 0.16595342E-05_JPRB, 0.16546007E-05_JPRB, 0.16497962E-05_JPRB, 0.16426765E-05_JPRB, 0.16347731E-05_JPRB, &
  & 0.16257438E-05_JPRB, 0.16208542E-05_JPRB, 0.16169634E-05_JPRB, 0.16160023E-05_JPRB  /)

RGHG2(:,48, 4) = (/ &
  & 0.17117121E-05_JPRB, 0.17117795E-05_JPRB, 0.17118052E-05_JPRB, 0.17120297E-05_JPRB, 0.17124920E-05_JPRB, 0.17131458E-05_JPRB, &
  & 0.17137985E-05_JPRB, 0.17145199E-05_JPRB, 0.17151391E-05_JPRB, 0.17157388E-05_JPRB, 0.17162574E-05_JPRB, 0.17168005E-05_JPRB, &
  & 0.17173739E-05_JPRB, 0.17178561E-05_JPRB, 0.17182811E-05_JPRB, 0.17184472E-05_JPRB, 0.17186811E-05_JPRB, 0.17191145E-05_JPRB, &
  & 0.17195921E-05_JPRB, 0.17200823E-05_JPRB, 0.17202649E-05_JPRB, 0.17198734E-05_JPRB, 0.17191135E-05_JPRB, 0.17179323E-05_JPRB, &
  & 0.17170413E-05_JPRB, 0.17163686E-05_JPRB, 0.17160344E-05_JPRB, 0.17160746E-05_JPRB, 0.17166525E-05_JPRB, 0.17179939E-05_JPRB, &
  & 0.17191194E-05_JPRB, 0.17196805E-05_JPRB, 0.17198603E-05_JPRB, 0.17202387E-05_JPRB, 0.17205541E-05_JPRB, 0.17210397E-05_JPRB, &
  & 0.17211172E-05_JPRB, 0.17211750E-05_JPRB, 0.17208304E-05_JPRB, 0.17208669E-05_JPRB, 0.17213567E-05_JPRB, 0.17212205E-05_JPRB, &
  & 0.17189588E-05_JPRB, 0.17147476E-05_JPRB, 0.17108443E-05_JPRB, 0.17063908E-05_JPRB, 0.17030638E-05_JPRB, 0.17007469E-05_JPRB, &
  & 0.16988298E-05_JPRB, 0.16969462E-05_JPRB, 0.16950496E-05_JPRB, 0.16935054E-05_JPRB, 0.16916658E-05_JPRB, 0.16901110E-05_JPRB, &
  & 0.16868464E-05_JPRB, 0.16832870E-05_JPRB, 0.16803393E-05_JPRB, 0.16772385E-05_JPRB, 0.16723670E-05_JPRB, 0.16663406E-05_JPRB, &
  & 0.16599804E-05_JPRB, 0.16570736E-05_JPRB, 0.16550490E-05_JPRB, 0.16552140E-05_JPRB  /)

RGHG2(:,49, 4) = (/ &
  & 0.17108261E-05_JPRB, 0.17108266E-05_JPRB, 0.17108410E-05_JPRB, 0.17111308E-05_JPRB, 0.17116491E-05_JPRB, 0.17122519E-05_JPRB, &
  & 0.17128339E-05_JPRB, 0.17134607E-05_JPRB, 0.17139337E-05_JPRB, 0.17144415E-05_JPRB, 0.17148370E-05_JPRB, 0.17151739E-05_JPRB, &
  & 0.17155013E-05_JPRB, 0.17156980E-05_JPRB, 0.17159023E-05_JPRB, 0.17159370E-05_JPRB, 0.17161274E-05_JPRB, 0.17166643E-05_JPRB, &
  & 0.17172990E-05_JPRB, 0.17179508E-05_JPRB, 0.17183260E-05_JPRB, 0.17181818E-05_JPRB, 0.17177083E-05_JPRB, 0.17168267E-05_JPRB, &
  & 0.17160945E-05_JPRB, 0.17156539E-05_JPRB, 0.17155744E-05_JPRB, 0.17158085E-05_JPRB, 0.17163891E-05_JPRB, 0.17177276E-05_JPRB, &
  & 0.17187545E-05_JPRB, 0.17192535E-05_JPRB, 0.17194752E-05_JPRB, 0.17198993E-05_JPRB, 0.17202627E-05_JPRB, 0.17207430E-05_JPRB, &
  & 0.17208183E-05_JPRB, 0.17207581E-05_JPRB, 0.17204176E-05_JPRB, 0.17204520E-05_JPRB, 0.17209561E-05_JPRB, 0.17211188E-05_JPRB, &
  & 0.17194822E-05_JPRB, 0.17163017E-05_JPRB, 0.17139436E-05_JPRB, 0.17114642E-05_JPRB, 0.17103639E-05_JPRB, 0.17100593E-05_JPRB, &
  & 0.17098070E-05_JPRB, 0.17094836E-05_JPRB, 0.17092246E-05_JPRB, 0.17090072E-05_JPRB, 0.17086707E-05_JPRB, 0.17089171E-05_JPRB, &
  & 0.17077531E-05_JPRB, 0.17061475E-05_JPRB, 0.17050650E-05_JPRB, 0.17036443E-05_JPRB, 0.17013691E-05_JPRB, 0.16975649E-05_JPRB, &
  & 0.16940368E-05_JPRB, 0.16930103E-05_JPRB, 0.16929121E-05_JPRB, 0.16937464E-05_JPRB  /)

RGHG2(:,50, 4) = (/ &
  & 0.17094218E-05_JPRB, 0.17093628E-05_JPRB, 0.17093662E-05_JPRB, 0.17097143E-05_JPRB, 0.17102926E-05_JPRB, 0.17108308E-05_JPRB, &
  & 0.17113363E-05_JPRB, 0.17118034E-05_JPRB, 0.17121617E-05_JPRB, 0.17126497E-05_JPRB, 0.17129844E-05_JPRB, 0.17132087E-05_JPRB, &
  & 0.17134075E-05_JPRB, 0.17134568E-05_JPRB, 0.17135743E-05_JPRB, 0.17136324E-05_JPRB, 0.17139013E-05_JPRB, 0.17145585E-05_JPRB, &
  & 0.17153409E-05_JPRB, 0.17161314E-05_JPRB, 0.17167028E-05_JPRB, 0.17167980E-05_JPRB, 0.17165757E-05_JPRB, 0.17159691E-05_JPRB, &
  & 0.17153866E-05_JPRB, 0.17151226E-05_JPRB, 0.17152553E-05_JPRB, 0.17156487E-05_JPRB, 0.17162211E-05_JPRB, 0.17175141E-05_JPRB, &
  & 0.17184997E-05_JPRB, 0.17189801E-05_JPRB, 0.17192557E-05_JPRB, 0.17196895E-05_JPRB, 0.17200581E-05_JPRB, 0.17204686E-05_JPRB, &
  & 0.17205514E-05_JPRB, 0.17204042E-05_JPRB, 0.17201622E-05_JPRB, 0.17202557E-05_JPRB, 0.17206956E-05_JPRB, 0.17210868E-05_JPRB, &
  & 0.17200320E-05_JPRB, 0.17177144E-05_JPRB, 0.17165249E-05_JPRB, 0.17155101E-05_JPRB, 0.17159087E-05_JPRB, 0.17169128E-05_JPRB, &
  & 0.17177178E-05_JPRB, 0.17184096E-05_JPRB, 0.17192706E-05_JPRB, 0.17200986E-05_JPRB, 0.17208518E-05_JPRB, 0.17222447E-05_JPRB, &
  & 0.17225638E-05_JPRB, 0.17223978E-05_JPRB, 0.17227354E-05_JPRB, 0.17229727E-05_JPRB, 0.17227751E-05_JPRB, 0.17207768E-05_JPRB, &
  & 0.17192040E-05_JPRB, 0.17196237E-05_JPRB, 0.17205802E-05_JPRB, 0.17216555E-05_JPRB  /)

RGHG2(:,51, 4) = (/ &
  & 0.17076302E-05_JPRB, 0.17075110E-05_JPRB, 0.17075025E-05_JPRB, 0.17079101E-05_JPRB, 0.17085552E-05_JPRB, 0.17090165E-05_JPRB, &
  & 0.17094364E-05_JPRB, 0.17096963E-05_JPRB, 0.17099473E-05_JPRB, 0.17104517E-05_JPRB, 0.17107534E-05_JPRB, 0.17109049E-05_JPRB, &
  & 0.17110263E-05_JPRB, 0.17109889E-05_JPRB, 0.17110831E-05_JPRB, 0.17112478E-05_JPRB, 0.17116657E-05_JPRB, 0.17124616E-05_JPRB, &
  & 0.17133990E-05_JPRB, 0.17143276E-05_JPRB, 0.17151130E-05_JPRB, 0.17154630E-05_JPRB, 0.17154940E-05_JPRB, 0.17151719E-05_JPRB, &
  & 0.17147465E-05_JPRB, 0.17146442E-05_JPRB, 0.17149843E-05_JPRB, 0.17155318E-05_JPRB, 0.17160896E-05_JPRB, 0.17173108E-05_JPRB, &
  & 0.17182818E-05_JPRB, 0.17187650E-05_JPRB, 0.17191054E-05_JPRB, 0.17195306E-05_JPRB, 0.17198824E-05_JPRB, 0.17201834E-05_JPRB, &
  & 0.17202795E-05_JPRB, 0.17200546E-05_JPRB, 0.17199685E-05_JPRB, 0.17201583E-05_JPRB, 0.17204876E-05_JPRB, 0.17210887E-05_JPRB, &
  & 0.17206406E-05_JPRB, 0.17191681E-05_JPRB, 0.17190446E-05_JPRB, 0.17193462E-05_JPRB, 0.17209834E-05_JPRB, 0.17230332E-05_JPRB, &
  & 0.17246626E-05_JPRB, 0.17261660E-05_JPRB, 0.17279662E-05_JPRB, 0.17297772E-05_JPRB, 0.17314918E-05_JPRB, 0.17337806E-05_JPRB, &
  & 0.17353792E-05_JPRB, 0.17365001E-05_JPRB, 0.17381398E-05_JPRB, 0.17401587E-05_JPRB, 0.17419356E-05_JPRB, 0.17416720E-05_JPRB, &
  & 0.17417531E-05_JPRB, 0.17435089E-05_JPRB, 0.17451481E-05_JPRB, 0.17462590E-05_JPRB  /)

RGHG2(:,52, 4) = (/ &
  & 0.17055663E-05_JPRB, 0.17054388E-05_JPRB, 0.17054054E-05_JPRB, 0.17058635E-05_JPRB, 0.17065239E-05_JPRB, 0.17069438E-05_JPRB, &
  & 0.17072534E-05_JPRB, 0.17073791E-05_JPRB, 0.17075624E-05_JPRB, 0.17081168E-05_JPRB, 0.17084699E-05_JPRB, 0.17086684E-05_JPRB, &
  & 0.17088019E-05_JPRB, 0.17088072E-05_JPRB, 0.17089795E-05_JPRB, 0.17093066E-05_JPRB, 0.17098802E-05_JPRB, 0.17108291E-05_JPRB, &
  & 0.17119008E-05_JPRB, 0.17129518E-05_JPRB, 0.17139445E-05_JPRB, 0.17144943E-05_JPRB, 0.17147110E-05_JPRB, 0.17146187E-05_JPRB, &
  & 0.17143711E-05_JPRB, 0.17143627E-05_JPRB, 0.17148449E-05_JPRB, 0.17154751E-05_JPRB, 0.17160481E-05_JPRB, 0.17171784E-05_JPRB, &
  & 0.17182066E-05_JPRB, 0.17186542E-05_JPRB, 0.17190421E-05_JPRB, 0.17194633E-05_JPRB, 0.17197518E-05_JPRB, 0.17199075E-05_JPRB, &
  & 0.17199812E-05_JPRB, 0.17199017E-05_JPRB, 0.17199400E-05_JPRB, 0.17202447E-05_JPRB, 0.17205054E-05_JPRB, 0.17212155E-05_JPRB, &
  & 0.17212149E-05_JPRB, 0.17204778E-05_JPRB, 0.17210738E-05_JPRB, 0.17221898E-05_JPRB, 0.17244765E-05_JPRB, 0.17270677E-05_JPRB, &
  & 0.17292619E-05_JPRB, 0.17312663E-05_JPRB, 0.17336400E-05_JPRB, 0.17360143E-05_JPRB, 0.17382277E-05_JPRB, 0.17410406E-05_JPRB, &
  & 0.17433688E-05_JPRB, 0.17454321E-05_JPRB, 0.17480642E-05_JPRB, 0.17513619E-05_JPRB, 0.17544094E-05_JPRB, 0.17553779E-05_JPRB, &
  & 0.17565876E-05_JPRB, 0.17592234E-05_JPRB, 0.17611609E-05_JPRB, 0.17623941E-05_JPRB  /)

RGHG2(:,53, 4) = (/ &
  & 0.17032139E-05_JPRB, 0.17030975E-05_JPRB, 0.17030318E-05_JPRB, 0.17035416E-05_JPRB, 0.17041988E-05_JPRB, 0.17045873E-05_JPRB, &
  & 0.17047673E-05_JPRB, 0.17047749E-05_JPRB, 0.17048997E-05_JPRB, 0.17055213E-05_JPRB, 0.17059630E-05_JPRB, 0.17062589E-05_JPRB, &
  & 0.17064398E-05_JPRB, 0.17065416E-05_JPRB, 0.17068379E-05_JPRB, 0.17073633E-05_JPRB, 0.17081089E-05_JPRB, 0.17092298E-05_JPRB, &
  & 0.17104399E-05_JPRB, 0.17116182E-05_JPRB, 0.17128341E-05_JPRB, 0.17135804E-05_JPRB, 0.17139732E-05_JPRB, 0.17141102E-05_JPRB, &
  & 0.17140641E-05_JPRB, 0.17141318E-05_JPRB, 0.17147436E-05_JPRB, 0.17154365E-05_JPRB, 0.17160377E-05_JPRB, 0.17170614E-05_JPRB, &
  & 0.17181795E-05_JPRB, 0.17185737E-05_JPRB, 0.17190068E-05_JPRB, 0.17194252E-05_JPRB, 0.17196270E-05_JPRB, 0.17196107E-05_JPRB, &
  & 0.17196460E-05_JPRB, 0.17198111E-05_JPRB, 0.17199725E-05_JPRB, 0.17204095E-05_JPRB, 0.17206116E-05_JPRB, 0.17214015E-05_JPRB, &
  & 0.17218271E-05_JPRB, 0.17218486E-05_JPRB, 0.17230949E-05_JPRB, 0.17249045E-05_JPRB, 0.17276718E-05_JPRB, 0.17306588E-05_JPRB, &
  & 0.17333680E-05_JPRB, 0.17357987E-05_JPRB, 0.17386561E-05_JPRB, 0.17414824E-05_JPRB, 0.17440611E-05_JPRB, 0.17473015E-05_JPRB, &
  & 0.17502126E-05_JPRB, 0.17531698E-05_JPRB, 0.17567634E-05_JPRB, 0.17612602E-05_JPRB, 0.17654205E-05_JPRB, 0.17675375E-05_JPRB, &
  & 0.17697743E-05_JPRB, 0.17731926E-05_JPRB, 0.17753073E-05_JPRB, 0.17767070E-05_JPRB  /)

RGHG2(:,54, 4) = (/ &
  & 0.17009344E-05_JPRB, 0.17007758E-05_JPRB, 0.17007161E-05_JPRB, 0.17012977E-05_JPRB, 0.17019600E-05_JPRB, 0.17022963E-05_JPRB, &
  & 0.17023954E-05_JPRB, 0.17023534E-05_JPRB, 0.17024648E-05_JPRB, 0.17031765E-05_JPRB, 0.17037421E-05_JPRB, 0.17041636E-05_JPRB, &
  & 0.17044760E-05_JPRB, 0.17047474E-05_JPRB, 0.17051880E-05_JPRB, 0.17058814E-05_JPRB, 0.17067858E-05_JPRB, 0.17080513E-05_JPRB, &
  & 0.17093922E-05_JPRB, 0.17107269E-05_JPRB, 0.17120795E-05_JPRB, 0.17130077E-05_JPRB, 0.17135385E-05_JPRB, 0.17138167E-05_JPRB, &
  & 0.17139175E-05_JPRB, 0.17140936E-05_JPRB, 0.17147325E-05_JPRB, 0.17154227E-05_JPRB, 0.17160410E-05_JPRB, 0.17170527E-05_JPRB, &
  & 0.17181827E-05_JPRB, 0.17185183E-05_JPRB, 0.17189554E-05_JPRB, 0.17194201E-05_JPRB, 0.17195234E-05_JPRB, 0.17193902E-05_JPRB, &
  & 0.17194633E-05_JPRB, 0.17197553E-05_JPRB, 0.17199630E-05_JPRB, 0.17205365E-05_JPRB, 0.17207829E-05_JPRB, 0.17216113E-05_JPRB, &
  & 0.17223782E-05_JPRB, 0.17230102E-05_JPRB, 0.17245221E-05_JPRB, 0.17266454E-05_JPRB, 0.17296390E-05_JPRB, 0.17327912E-05_JPRB, &
  & 0.17357107E-05_JPRB, 0.17383729E-05_JPRB, 0.17414665E-05_JPRB, 0.17444411E-05_JPRB, 0.17471746E-05_JPRB, 0.17506294E-05_JPRB, &
  & 0.17538764E-05_JPRB, 0.17571401E-05_JPRB, 0.17612393E-05_JPRB, 0.17661477E-05_JPRB, 0.17707634E-05_JPRB, 0.17734626E-05_JPRB, &
  & 0.17763351E-05_JPRB, 0.17799329E-05_JPRB, 0.17821011E-05_JPRB, 0.17835240E-05_JPRB  /)

RGHG2(:,55, 4) = (/ &
  & 0.16984189E-05_JPRB, 0.16982064E-05_JPRB, 0.16981584E-05_JPRB, 0.16988222E-05_JPRB, 0.16994915E-05_JPRB, 0.16997670E-05_JPRB, &
  & 0.16997830E-05_JPRB, 0.16996949E-05_JPRB, 0.16997975E-05_JPRB, 0.17006121E-05_JPRB, 0.17013195E-05_JPRB, 0.17018839E-05_JPRB, &
  & 0.17023529E-05_JPRB, 0.17028220E-05_JPRB, 0.17034250E-05_JPRB, 0.17043005E-05_JPRB, 0.17053791E-05_JPRB, 0.17068012E-05_JPRB, &
  & 0.17082859E-05_JPRB, 0.17097978E-05_JPRB, 0.17112903E-05_JPRB, 0.17124181E-05_JPRB, 0.17130967E-05_JPRB, 0.17135198E-05_JPRB, &
  & 0.17137762E-05_JPRB, 0.17140765E-05_JPRB, 0.17147322E-05_JPRB, 0.17154106E-05_JPRB, 0.17160466E-05_JPRB, 0.17170572E-05_JPRB, &
  & 0.17181901E-05_JPRB, 0.17184601E-05_JPRB, 0.17188963E-05_JPRB, 0.17194187E-05_JPRB, 0.17194115E-05_JPRB, 0.17191559E-05_JPRB, &
  & 0.17192809E-05_JPRB, 0.17196982E-05_JPRB, 0.17199470E-05_JPRB, 0.17206721E-05_JPRB, 0.17209812E-05_JPRB, 0.17218468E-05_JPRB, &
  & 0.17229807E-05_JPRB, 0.17242694E-05_JPRB, 0.17260250E-05_JPRB, 0.17284458E-05_JPRB, 0.17316567E-05_JPRB, 0.17349615E-05_JPRB, &
  & 0.17380738E-05_JPRB, 0.17409670E-05_JPRB, 0.17442897E-05_JPRB, 0.17473885E-05_JPRB, 0.17502659E-05_JPRB, 0.17539301E-05_JPRB, &
  & 0.17575167E-05_JPRB, 0.17610427E-05_JPRB, 0.17656420E-05_JPRB, 0.17709027E-05_JPRB, 0.17759363E-05_JPRB, 0.17792061E-05_JPRB, &
  & 0.17827314E-05_JPRB, 0.17864485E-05_JPRB, 0.17886598E-05_JPRB, 0.17900896E-05_JPRB  /)

RGHG2(:,56, 4) = (/ &
  & 0.16963613E-05_JPRB, 0.16960385E-05_JPRB, 0.16960038E-05_JPRB, 0.16967273E-05_JPRB, 0.16974312E-05_JPRB, 0.16976172E-05_JPRB, &
  & 0.16976237E-05_JPRB, 0.16975549E-05_JPRB, 0.16976869E-05_JPRB, 0.16985857E-05_JPRB, 0.16994008E-05_JPRB, 0.17001114E-05_JPRB, &
  & 0.17007583E-05_JPRB, 0.17014347E-05_JPRB, 0.17021919E-05_JPRB, 0.17031982E-05_JPRB, 0.17044097E-05_JPRB, 0.17059157E-05_JPRB, &
  & 0.17075235E-05_JPRB, 0.17091637E-05_JPRB, 0.17107265E-05_JPRB, 0.17119914E-05_JPRB, 0.17128072E-05_JPRB, 0.17133532E-05_JPRB, &
  & 0.17136780E-05_JPRB, 0.17140913E-05_JPRB, 0.17147459E-05_JPRB, 0.17153798E-05_JPRB, 0.17160177E-05_JPRB, 0.17170337E-05_JPRB, &
  & 0.17181830E-05_JPRB, 0.17184413E-05_JPRB, 0.17187627E-05_JPRB, 0.17192508E-05_JPRB, 0.17193221E-05_JPRB, 0.17191633E-05_JPRB, &
  & 0.17192776E-05_JPRB, 0.17197200E-05_JPRB, 0.17199584E-05_JPRB, 0.17207775E-05_JPRB, 0.17211550E-05_JPRB, 0.17221225E-05_JPRB, &
  & 0.17234395E-05_JPRB, 0.17250515E-05_JPRB, 0.17267537E-05_JPRB, 0.17293558E-05_JPRB, 0.17327066E-05_JPRB, 0.17360530E-05_JPRB, &
  & 0.17391841E-05_JPRB, 0.17422491E-05_JPRB, 0.17456476E-05_JPRB, 0.17488207E-05_JPRB, 0.17517951E-05_JPRB, 0.17555554E-05_JPRB, &
  & 0.17592804E-05_JPRB, 0.17628760E-05_JPRB, 0.17674860E-05_JPRB, 0.17726411E-05_JPRB, 0.17775472E-05_JPRB, 0.17810059E-05_JPRB, &
  & 0.17845354E-05_JPRB, 0.17878271E-05_JPRB, 0.17899839E-05_JPRB, 0.17913010E-05_JPRB  /)

RGHG2(:,57, 4) = (/ &
  & 0.16942673E-05_JPRB, 0.16938464E-05_JPRB, 0.16938174E-05_JPRB, 0.16945855E-05_JPRB, 0.16953098E-05_JPRB, 0.16954149E-05_JPRB, &
  & 0.16954115E-05_JPRB, 0.16953713E-05_JPRB, 0.16955412E-05_JPRB, 0.16965190E-05_JPRB, 0.16974281E-05_JPRB, 0.16982798E-05_JPRB, &
  & 0.16991046E-05_JPRB, 0.16999920E-05_JPRB, 0.17009221E-05_JPRB, 0.17020729E-05_JPRB, 0.17034139E-05_JPRB, 0.17050004E-05_JPRB, &
  & 0.17067225E-05_JPRB, 0.17084805E-05_JPRB, 0.17101242E-05_JPRB, 0.17115014E-05_JPRB, 0.17124776E-05_JPRB, 0.17131430E-05_JPRB, &
  & 0.17135405E-05_JPRB, 0.17140535E-05_JPRB, 0.17147258E-05_JPRB, 0.17153469E-05_JPRB, 0.17159775E-05_JPRB, 0.17169988E-05_JPRB, &
  & 0.17181889E-05_JPRB, 0.17184156E-05_JPRB, 0.17186279E-05_JPRB, 0.17190770E-05_JPRB, 0.17191989E-05_JPRB, 0.17191773E-05_JPRB, &
  & 0.17193204E-05_JPRB, 0.17197442E-05_JPRB, 0.17199897E-05_JPRB, 0.17208364E-05_JPRB, 0.17212905E-05_JPRB, 0.17223599E-05_JPRB, &
  & 0.17238615E-05_JPRB, 0.17257532E-05_JPRB, 0.17274605E-05_JPRB, 0.17302688E-05_JPRB, 0.17337611E-05_JPRB, 0.17371778E-05_JPRB, &
  & 0.17403674E-05_JPRB, 0.17436285E-05_JPRB, 0.17471381E-05_JPRB, 0.17504261E-05_JPRB, 0.17535378E-05_JPRB, 0.17573981E-05_JPRB, &
  & 0.17612423E-05_JPRB, 0.17649607E-05_JPRB, 0.17695977E-05_JPRB, 0.17746686E-05_JPRB, 0.17794547E-05_JPRB, 0.17830846E-05_JPRB, &
  & 0.17865987E-05_JPRB, 0.17895022E-05_JPRB, 0.17915509E-05_JPRB, 0.17926954E-05_JPRB  /)

RGHG2(:,58, 4) = (/ &
  & 0.16923660E-05_JPRB, 0.16918649E-05_JPRB, 0.16918287E-05_JPRB, 0.16926080E-05_JPRB, 0.16933323E-05_JPRB, 0.16933724E-05_JPRB, &
  & 0.16933731E-05_JPRB, 0.16933867E-05_JPRB, 0.16936135E-05_JPRB, 0.16946512E-05_JPRB, 0.16956172E-05_JPRB, 0.16965908E-05_JPRB, &
  & 0.16975832E-05_JPRB, 0.16986728E-05_JPRB, 0.16997919E-05_JPRB, 0.17010889E-05_JPRB, 0.17025356E-05_JPRB, 0.17041770E-05_JPRB, &
  & 0.17059854E-05_JPRB, 0.17078247E-05_JPRB, 0.17095476E-05_JPRB, 0.17109745E-05_JPRB, 0.17121357E-05_JPRB, 0.17129006E-05_JPRB, &
  & 0.17133560E-05_JPRB, 0.17139360E-05_JPRB, 0.17146531E-05_JPRB, 0.17153097E-05_JPRB, 0.17159149E-05_JPRB, 0.17169423E-05_JPRB, &
  & 0.17182137E-05_JPRB, 0.17183875E-05_JPRB, 0.17184881E-05_JPRB, 0.17188762E-05_JPRB, 0.17190327E-05_JPRB, 0.17192468E-05_JPRB, &
  & 0.17194711E-05_JPRB, 0.17197852E-05_JPRB, 0.17200572E-05_JPRB, 0.17208063E-05_JPRB, 0.17213457E-05_JPRB, 0.17225207E-05_JPRB, &
  & 0.17241605E-05_JPRB, 0.17261731E-05_JPRB, 0.17279281E-05_JPRB, 0.17309468E-05_JPRB, 0.17345569E-05_JPRB, 0.17380660E-05_JPRB, &
  & 0.17413440E-05_JPRB, 0.17448154E-05_JPRB, 0.17484581E-05_JPRB, 0.17519106E-05_JPRB, 0.17552083E-05_JPRB, 0.17591458E-05_JPRB, &
  & 0.17630296E-05_JPRB, 0.17669146E-05_JPRB, 0.17715119E-05_JPRB, 0.17764559E-05_JPRB, 0.17810419E-05_JPRB, 0.17847276E-05_JPRB, &
  & 0.17880731E-05_JPRB, 0.17905804E-05_JPRB, 0.17924208E-05_JPRB, 0.17932829E-05_JPRB  /)

RGHG2(:,59, 4) = (/ &
  & 0.16907080E-05_JPRB, 0.16901854E-05_JPRB, 0.16901483E-05_JPRB, 0.16909058E-05_JPRB, 0.16916167E-05_JPRB, 0.16916123E-05_JPRB, &
  & 0.16916068E-05_JPRB, 0.16916718E-05_JPRB, 0.16919618E-05_JPRB, 0.16930271E-05_JPRB, 0.16940137E-05_JPRB, 0.16950643E-05_JPRB, &
  & 0.16961832E-05_JPRB, 0.16974603E-05_JPRB, 0.16987748E-05_JPRB, 0.17002130E-05_JPRB, 0.17017415E-05_JPRB, 0.17034251E-05_JPRB, &
  & 0.17052737E-05_JPRB, 0.17071654E-05_JPRB, 0.17089764E-05_JPRB, 0.17104554E-05_JPRB, 0.17117740E-05_JPRB, 0.17125924E-05_JPRB, &
  & 0.17131239E-05_JPRB, 0.17137514E-05_JPRB, 0.17145539E-05_JPRB, 0.17152615E-05_JPRB, 0.17158308E-05_JPRB, 0.17168518E-05_JPRB, &
  & 0.17182528E-05_JPRB, 0.17183896E-05_JPRB, 0.17183723E-05_JPRB, 0.17186008E-05_JPRB, 0.17188577E-05_JPRB, 0.17192823E-05_JPRB, &
  & 0.17195251E-05_JPRB, 0.17196925E-05_JPRB, 0.17200220E-05_JPRB, 0.17205784E-05_JPRB, 0.17213274E-05_JPRB, 0.17226110E-05_JPRB, &
  & 0.17243585E-05_JPRB, 0.17263288E-05_JPRB, 0.17282662E-05_JPRB, 0.17315003E-05_JPRB, 0.17351983E-05_JPRB, 0.17388642E-05_JPRB, &
  & 0.17423201E-05_JPRB, 0.17460329E-05_JPRB, 0.17498649E-05_JPRB, 0.17535000E-05_JPRB, 0.17570555E-05_JPRB, 0.17610459E-05_JPRB, &
  & 0.17649352E-05_JPRB, 0.17690088E-05_JPRB, 0.17735234E-05_JPRB, 0.17783686E-05_JPRB, 0.17828283E-05_JPRB, 0.17865218E-05_JPRB, &
  & 0.17897145E-05_JPRB, 0.17919820E-05_JPRB, 0.17936208E-05_JPRB, 0.17942621E-05_JPRB  /)

RGHG2(:,60, 4) = (/ &
  & 0.16891140E-05_JPRB, 0.16885958E-05_JPRB, 0.16885613E-05_JPRB, 0.16892837E-05_JPRB, 0.16899781E-05_JPRB, 0.16899414E-05_JPRB, &
  & 0.16899224E-05_JPRB, 0.16900359E-05_JPRB, 0.16903891E-05_JPRB, 0.16914654E-05_JPRB, 0.16924606E-05_JPRB, 0.16935667E-05_JPRB, &
  & 0.16947918E-05_JPRB, 0.16962480E-05_JPRB, 0.16977629E-05_JPRB, 0.16993415E-05_JPRB, 0.17009438E-05_JPRB, 0.17026658E-05_JPRB, &
  & 0.17045363E-05_JPRB, 0.17064678E-05_JPRB, 0.17083709E-05_JPRB, 0.17099144E-05_JPRB, 0.17113748E-05_JPRB, 0.17122368E-05_JPRB, &
  & 0.17128629E-05_JPRB, 0.17135269E-05_JPRB, 0.17144276E-05_JPRB, 0.17151780E-05_JPRB, 0.17157191E-05_JPRB, 0.17167304E-05_JPRB, &
  & 0.17182586E-05_JPRB, 0.17183929E-05_JPRB, 0.17182391E-05_JPRB, 0.17182654E-05_JPRB, 0.17186577E-05_JPRB, 0.17192959E-05_JPRB, &
  & 0.17195171E-05_JPRB, 0.17195154E-05_JPRB, 0.17199095E-05_JPRB, 0.17202565E-05_JPRB, 0.17212730E-05_JPRB, 0.17226683E-05_JPRB, &
  & 0.17245087E-05_JPRB, 0.17263799E-05_JPRB, 0.17285643E-05_JPRB, 0.17320299E-05_JPRB, 0.17358118E-05_JPRB, 0.17396704E-05_JPRB, &
  & 0.17433652E-05_JPRB, 0.17473512E-05_JPRB, 0.17514026E-05_JPRB, 0.17552387E-05_JPRB, 0.17590804E-05_JPRB, 0.17631268E-05_JPRB, &
  & 0.17670167E-05_JPRB, 0.17713080E-05_JPRB, 0.17757008E-05_JPRB, 0.17804786E-05_JPRB, 0.17848527E-05_JPRB, 0.17885227E-05_JPRB, &
  & 0.17915828E-05_JPRB, 0.17937311E-05_JPRB, 0.17952141E-05_JPRB, 0.17956927E-05_JPRB  /)

RGHG2(:,61, 4) = (/ &
  & 0.16877291E-05_JPRB, 0.16872450E-05_JPRB, 0.16872194E-05_JPRB, 0.16879000E-05_JPRB, 0.16885844E-05_JPRB, 0.16885455E-05_JPRB, &
  & 0.16884979E-05_JPRB, 0.16886433E-05_JPRB, 0.16890417E-05_JPRB, 0.16901004E-05_JPRB, 0.16911000E-05_JPRB, 0.16922215E-05_JPRB, &
  & 0.16935050E-05_JPRB, 0.16950955E-05_JPRB, 0.16967911E-05_JPRB, 0.16984908E-05_JPRB, 0.17001526E-05_JPRB, 0.17019077E-05_JPRB, &
  & 0.17037804E-05_JPRB, 0.17057306E-05_JPRB, 0.17077152E-05_JPRB, 0.17093611E-05_JPRB, 0.17109118E-05_JPRB, 0.17118278E-05_JPRB, &
  & 0.17125860E-05_JPRB, 0.17132611E-05_JPRB, 0.17142444E-05_JPRB, 0.17149772E-05_JPRB, 0.17155403E-05_JPRB, 0.17165461E-05_JPRB, &
  & 0.17181096E-05_JPRB, 0.17183617E-05_JPRB, 0.17180262E-05_JPRB, 0.17178333E-05_JPRB, 0.17183985E-05_JPRB, 0.17192615E-05_JPRB, &
  & 0.17193802E-05_JPRB, 0.17191912E-05_JPRB, 0.17196294E-05_JPRB, 0.17198530E-05_JPRB, 0.17211735E-05_JPRB, 0.17226713E-05_JPRB, &
  & 0.17245678E-05_JPRB, 0.17263311E-05_JPRB, 0.17288150E-05_JPRB, 0.17325340E-05_JPRB, 0.17364085E-05_JPRB, 0.17404940E-05_JPRB, &
  & 0.17445247E-05_JPRB, 0.17488301E-05_JPRB, 0.17531172E-05_JPRB, 0.17571747E-05_JPRB, 0.17612819E-05_JPRB, 0.17654174E-05_JPRB, &
  & 0.17693316E-05_JPRB, 0.17738971E-05_JPRB, 0.17780829E-05_JPRB, 0.17828959E-05_JPRB, 0.17872711E-05_JPRB, 0.17908552E-05_JPRB, &
  & 0.17938658E-05_JPRB, 0.17962090E-05_JPRB, 0.17977394E-05_JPRB, 0.17982400E-05_JPRB  /)

RGHG2(:,62, 4) = (/ &
  & 0.16864892E-05_JPRB, 0.16860266E-05_JPRB, 0.16860051E-05_JPRB, 0.16866425E-05_JPRB, 0.16873175E-05_JPRB, 0.16873041E-05_JPRB, &
  & 0.16872383E-05_JPRB, 0.16874012E-05_JPRB, 0.16878209E-05_JPRB, 0.16888500E-05_JPRB, 0.16898525E-05_JPRB, 0.16909687E-05_JPRB, &
  & 0.16922904E-05_JPRB, 0.16939674E-05_JPRB, 0.16958038E-05_JPRB, 0.16976122E-05_JPRB, 0.16993305E-05_JPRB, 0.17011115E-05_JPRB, &
  & 0.17029946E-05_JPRB, 0.17049454E-05_JPRB, 0.17069733E-05_JPRB, 0.17087290E-05_JPRB, 0.17103403E-05_JPRB, 0.17113487E-05_JPRB, &
  & 0.17122221E-05_JPRB, 0.17129672E-05_JPRB, 0.17138948E-05_JPRB, 0.17146045E-05_JPRB, 0.17152409E-05_JPRB, 0.17163625E-05_JPRB, &
  & 0.17178694E-05_JPRB, 0.17181428E-05_JPRB, 0.17176173E-05_JPRB, 0.17172789E-05_JPRB, 0.17179631E-05_JPRB, 0.17189910E-05_JPRB, &
  & 0.17190457E-05_JPRB, 0.17187107E-05_JPRB, 0.17190835E-05_JPRB, 0.17193902E-05_JPRB, 0.17209445E-05_JPRB, 0.17225260E-05_JPRB, &
  & 0.17245057E-05_JPRB, 0.17263060E-05_JPRB, 0.17290600E-05_JPRB, 0.17330322E-05_JPRB, 0.17370690E-05_JPRB, 0.17414294E-05_JPRB, &
  & 0.17457831E-05_JPRB, 0.17504296E-05_JPRB, 0.17550023E-05_JPRB, 0.17592923E-05_JPRB, 0.17636220E-05_JPRB, 0.17679157E-05_JPRB, &
  & 0.17718646E-05_JPRB, 0.17767320E-05_JPRB, 0.17807627E-05_JPRB, 0.17856741E-05_JPRB, 0.17900366E-05_JPRB, 0.17935190E-05_JPRB, &
  & 0.17965673E-05_JPRB, 0.17993017E-05_JPRB, 0.18010366E-05_JPRB, 0.18017312E-05_JPRB  /)

RGHG2(:,63, 4) = (/ &
  & 0.16853520E-05_JPRB, 0.16848988E-05_JPRB, 0.16848756E-05_JPRB, 0.16854660E-05_JPRB, 0.16861267E-05_JPRB, 0.16861559E-05_JPRB, &
  & 0.16860844E-05_JPRB, 0.16862535E-05_JPRB, 0.16866808E-05_JPRB, 0.16876724E-05_JPRB, 0.16886724E-05_JPRB, 0.16897724E-05_JPRB, &
  & 0.16911129E-05_JPRB, 0.16928443E-05_JPRB, 0.16947857E-05_JPRB, 0.16966955E-05_JPRB, 0.16984641E-05_JPRB, 0.17002631E-05_JPRB, &
  & 0.17021597E-05_JPRB, 0.17041013E-05_JPRB, 0.17061478E-05_JPRB, 0.17079905E-05_JPRB, 0.17096465E-05_JPRB, 0.17107825E-05_JPRB, &
  & 0.17117493E-05_JPRB, 0.17125905E-05_JPRB, 0.17133933E-05_JPRB, 0.17140945E-05_JPRB, 0.17148535E-05_JPRB, 0.17161198E-05_JPRB, &
  & 0.17175314E-05_JPRB, 0.17177454E-05_JPRB, 0.17170287E-05_JPRB, 0.17166003E-05_JPRB, 0.17173752E-05_JPRB, 0.17184661E-05_JPRB, &
  & 0.17185201E-05_JPRB, 0.17180739E-05_JPRB, 0.17183111E-05_JPRB, 0.17188752E-05_JPRB, 0.17206136E-05_JPRB, 0.17222506E-05_JPRB, &
  & 0.17243599E-05_JPRB, 0.17263074E-05_JPRB, 0.17293396E-05_JPRB, 0.17335581E-05_JPRB, 0.17378228E-05_JPRB, 0.17425076E-05_JPRB, &
  & 0.17471778E-05_JPRB, 0.17521599E-05_JPRB, 0.17570575E-05_JPRB, 0.17616094E-05_JPRB, 0.17661177E-05_JPRB, 0.17706109E-05_JPRB, &
  & 0.17746139E-05_JPRB, 0.17797616E-05_JPRB, 0.17837092E-05_JPRB, 0.17887411E-05_JPRB, 0.17930672E-05_JPRB, 0.17964576E-05_JPRB, &
  & 0.17995772E-05_JPRB, 0.18027953E-05_JPRB, 0.18048028E-05_JPRB, 0.18057980E-05_JPRB  /)

RGHG2(:,64, 4) = (/ &
  & 0.16843664E-05_JPRB, 0.16839060E-05_JPRB, 0.16838708E-05_JPRB, 0.16844082E-05_JPRB, 0.16850424E-05_JPRB, 0.16851270E-05_JPRB, &
  & 0.16850699E-05_JPRB, 0.16852318E-05_JPRB, 0.16856567E-05_JPRB, 0.16866049E-05_JPRB, 0.16875905E-05_JPRB, 0.16886687E-05_JPRB, &
  & 0.16899996E-05_JPRB, 0.16917528E-05_JPRB, 0.16937472E-05_JPRB, 0.16957485E-05_JPRB, 0.16975532E-05_JPRB, 0.16993571E-05_JPRB, &
  & 0.17012657E-05_JPRB, 0.17031928E-05_JPRB, 0.17052345E-05_JPRB, 0.17070965E-05_JPRB, 0.17087862E-05_JPRB, 0.17100933E-05_JPRB, &
  & 0.17111131E-05_JPRB, 0.17120506E-05_JPRB, 0.17127041E-05_JPRB, 0.17134390E-05_JPRB, 0.17143859E-05_JPRB, 0.17157390E-05_JPRB, &
  & 0.17170566E-05_JPRB, 0.17171116E-05_JPRB, 0.17162166E-05_JPRB, 0.17157641E-05_JPRB, 0.17166113E-05_JPRB, 0.17175697E-05_JPRB, &
  & 0.17177417E-05_JPRB, 0.17172329E-05_JPRB, 0.17172774E-05_JPRB, 0.17183113E-05_JPRB, 0.17201750E-05_JPRB, 0.17218144E-05_JPRB, &
  & 0.17241357E-05_JPRB, 0.17263506E-05_JPRB, 0.17297009E-05_JPRB, 0.17341386E-05_JPRB, 0.17387141E-05_JPRB, 0.17437844E-05_JPRB, &
  & 0.17487558E-05_JPRB, 0.17540245E-05_JPRB, 0.17592812E-05_JPRB, 0.17641463E-05_JPRB, 0.17687606E-05_JPRB, 0.17734778E-05_JPRB, &
  & 0.17775700E-05_JPRB, 0.17829056E-05_JPRB, 0.17868990E-05_JPRB, 0.17920369E-05_JPRB, 0.17962836E-05_JPRB, 0.17996257E-05_JPRB, &
  & 0.18028079E-05_JPRB, 0.18065200E-05_JPRB, 0.18087973E-05_JPRB, 0.18101708E-05_JPRB  /)

RGHG2(:,65, 4) = (/ &
  & 0.16835611E-05_JPRB, 0.16830844E-05_JPRB, 0.16830258E-05_JPRB, 0.16834986E-05_JPRB, 0.16840971E-05_JPRB, 0.16842286E-05_JPRB, &
  & 0.16841883E-05_JPRB, 0.16843474E-05_JPRB, 0.16847632E-05_JPRB, 0.16856677E-05_JPRB, 0.16866252E-05_JPRB, 0.16876682E-05_JPRB, &
  & 0.16889714E-05_JPRB, 0.16907083E-05_JPRB, 0.16927068E-05_JPRB, 0.16947488E-05_JPRB, 0.16965675E-05_JPRB, 0.16983515E-05_JPRB, &
  & 0.17002723E-05_JPRB, 0.17021669E-05_JPRB, 0.17041723E-05_JPRB, 0.17060313E-05_JPRB, 0.17077483E-05_JPRB, 0.17091986E-05_JPRB, &
  & 0.17102404E-05_JPRB, 0.17112302E-05_JPRB, 0.17118677E-05_JPRB, 0.17127667E-05_JPRB, 0.17138312E-05_JPRB, 0.17150878E-05_JPRB, &
  & 0.17163623E-05_JPRB, 0.17162907E-05_JPRB, 0.17152004E-05_JPRB, 0.17147999E-05_JPRB, 0.17155988E-05_JPRB, 0.17163967E-05_JPRB, &
  & 0.17166137E-05_JPRB, 0.17162167E-05_JPRB, 0.17159772E-05_JPRB, 0.17176392E-05_JPRB, 0.17197369E-05_JPRB, 0.17214953E-05_JPRB, &
  & 0.17240100E-05_JPRB, 0.17264833E-05_JPRB, 0.17302145E-05_JPRB, 0.17349651E-05_JPRB, 0.17398650E-05_JPRB, 0.17453910E-05_JPRB, &
  & 0.17506501E-05_JPRB, 0.17561248E-05_JPRB, 0.17617230E-05_JPRB, 0.17668925E-05_JPRB, 0.17716450E-05_JPRB, 0.17765611E-05_JPRB, &
  & 0.17807790E-05_JPRB, 0.17861829E-05_JPRB, 0.17902516E-05_JPRB, 0.17954469E-05_JPRB, 0.17995910E-05_JPRB, 0.18029519E-05_JPRB, &
  & 0.18061412E-05_JPRB, 0.18102433E-05_JPRB, 0.18127656E-05_JPRB, 0.18144776E-05_JPRB  /)

RGHG2(:,66, 4) = (/ &
  & 0.16828492E-05_JPRB, 0.16823610E-05_JPRB, 0.16822721E-05_JPRB, 0.16826784E-05_JPRB, 0.16832371E-05_JPRB, 0.16833999E-05_JPRB, &
  & 0.16833740E-05_JPRB, 0.16835306E-05_JPRB, 0.16839295E-05_JPRB, 0.16847967E-05_JPRB, 0.16857190E-05_JPRB, 0.16867251E-05_JPRB, &
  & 0.16879790E-05_JPRB, 0.16896820E-05_JPRB, 0.16916621E-05_JPRB, 0.16937057E-05_JPRB, 0.16955283E-05_JPRB, 0.16972831E-05_JPRB, &
  & 0.16992063E-05_JPRB, 0.17010481E-05_JPRB, 0.17030155E-05_JPRB, 0.17048851E-05_JPRB, 0.17065882E-05_JPRB, 0.17080853E-05_JPRB, &
  & 0.17092076E-05_JPRB, 0.17102466E-05_JPRB, 0.17109583E-05_JPRB, 0.17120981E-05_JPRB, 0.17131770E-05_JPRB, 0.17143274E-05_JPRB, &
  & 0.17155441E-05_JPRB, 0.17153159E-05_JPRB, 0.17141547E-05_JPRB, 0.17137807E-05_JPRB, 0.17143694E-05_JPRB, 0.17150052E-05_JPRB, &
  & 0.17151061E-05_JPRB, 0.17148216E-05_JPRB, 0.17146427E-05_JPRB, 0.17168249E-05_JPRB, 0.17192139E-05_JPRB, 0.17213854E-05_JPRB, &
  & 0.17240848E-05_JPRB, 0.17268120E-05_JPRB, 0.17309122E-05_JPRB, 0.17359822E-05_JPRB, 0.17412474E-05_JPRB, 0.17472187E-05_JPRB, &
  & 0.17527755E-05_JPRB, 0.17584267E-05_JPRB, 0.17643329E-05_JPRB, 0.17697933E-05_JPRB, 0.17747197E-05_JPRB, 0.17798240E-05_JPRB, &
  & 0.17841695E-05_JPRB, 0.17896128E-05_JPRB, 0.17937009E-05_JPRB, 0.17989674E-05_JPRB, 0.18029746E-05_JPRB, 0.18063827E-05_JPRB, &
  & 0.18095377E-05_JPRB, 0.18139006E-05_JPRB, 0.18166975E-05_JPRB, 0.18186448E-05_JPRB  /)

RGHG2(:,67, 4) = (/ &
  & 0.16822315E-05_JPRB, 0.16817389E-05_JPRB, 0.16816147E-05_JPRB, 0.16819559E-05_JPRB, 0.16824708E-05_JPRB, 0.16826492E-05_JPRB, &
  & 0.16826321E-05_JPRB, 0.16827851E-05_JPRB, 0.16831592E-05_JPRB, 0.16839967E-05_JPRB, 0.16848776E-05_JPRB, 0.16858471E-05_JPRB, &
  & 0.16870354E-05_JPRB, 0.16886837E-05_JPRB, 0.16906221E-05_JPRB, 0.16926356E-05_JPRB, 0.16944539E-05_JPRB, 0.16961788E-05_JPRB, &
  & 0.16980893E-05_JPRB, 0.16998696E-05_JPRB, 0.17018017E-05_JPRB, 0.17036858E-05_JPRB, 0.17053330E-05_JPRB, 0.17067743E-05_JPRB, &
  & 0.17080199E-05_JPRB, 0.17091227E-05_JPRB, 0.17099861E-05_JPRB, 0.17113977E-05_JPRB, 0.17124399E-05_JPRB, 0.17135215E-05_JPRB, &
  & 0.17146199E-05_JPRB, 0.17141978E-05_JPRB, 0.17130804E-05_JPRB, 0.17127143E-05_JPRB, 0.17129601E-05_JPRB, 0.17134116E-05_JPRB, &
  & 0.17131963E-05_JPRB, 0.17130396E-05_JPRB, 0.17132913E-05_JPRB, 0.17158749E-05_JPRB, 0.17186344E-05_JPRB, 0.17214980E-05_JPRB, &
  & 0.17244151E-05_JPRB, 0.17273697E-05_JPRB, 0.17318174E-05_JPRB, 0.17372008E-05_JPRB, 0.17428699E-05_JPRB, 0.17492589E-05_JPRB, &
  & 0.17551089E-05_JPRB, 0.17609085E-05_JPRB, 0.17670863E-05_JPRB, 0.17728073E-05_JPRB, 0.17779576E-05_JPRB, 0.17832229E-05_JPRB, &
  & 0.17876858E-05_JPRB, 0.17931579E-05_JPRB, 0.17972219E-05_JPRB, 0.18025559E-05_JPRB, 0.18064104E-05_JPRB, 0.18098752E-05_JPRB, &
  & 0.18129969E-05_JPRB, 0.18174865E-05_JPRB, 0.18205757E-05_JPRB, 0.18226433E-05_JPRB  /)

RGHG2(:,68, 4) = (/ &
  & 0.16817134E-05_JPRB, 0.16812257E-05_JPRB, 0.16810644E-05_JPRB, 0.16813463E-05_JPRB, 0.16818116E-05_JPRB, 0.16819925E-05_JPRB, &
  & 0.16819730E-05_JPRB, 0.16821185E-05_JPRB, 0.16824605E-05_JPRB, 0.16832757E-05_JPRB, 0.16841096E-05_JPRB, 0.16850444E-05_JPRB, &
  & 0.16861635E-05_JPRB, 0.16877252E-05_JPRB, 0.16895919E-05_JPRB, 0.16915583E-05_JPRB, 0.16933667E-05_JPRB, 0.16950768E-05_JPRB, &
  & 0.16969502E-05_JPRB, 0.16986860E-05_JPRB, 0.17005883E-05_JPRB, 0.17024626E-05_JPRB, 0.17040182E-05_JPRB, 0.17053061E-05_JPRB, &
  & 0.17066655E-05_JPRB, 0.17078772E-05_JPRB, 0.17089484E-05_JPRB, 0.17105753E-05_JPRB, 0.17116521E-05_JPRB, 0.17127684E-05_JPRB, &
  & 0.17136020E-05_JPRB, 0.17129449E-05_JPRB, 0.17119314E-05_JPRB, 0.17115900E-05_JPRB, 0.17114350E-05_JPRB, 0.17116293E-05_JPRB, &
  & 0.17108351E-05_JPRB, 0.17108887E-05_JPRB, 0.17118974E-05_JPRB, 0.17148051E-05_JPRB, 0.17180717E-05_JPRB, 0.17218334E-05_JPRB, &
  & 0.17250919E-05_JPRB, 0.17282023E-05_JPRB, 0.17329766E-05_JPRB, 0.17386618E-05_JPRB, 0.17447663E-05_JPRB, 0.17515314E-05_JPRB, &
  & 0.17576387E-05_JPRB, 0.17635545E-05_JPRB, 0.17699698E-05_JPRB, 0.17758913E-05_JPRB, 0.17813458E-05_JPRB, 0.17867101E-05_JPRB, &
  & 0.17912620E-05_JPRB, 0.17967762E-05_JPRB, 0.18008180E-05_JPRB, 0.18061668E-05_JPRB, 0.18098952E-05_JPRB, 0.18133921E-05_JPRB, &
  & 0.18165707E-05_JPRB, 0.18210553E-05_JPRB, 0.18244216E-05_JPRB, 0.18264892E-05_JPRB  /)

RGHG2(:,69, 4) = (/ &
  & 0.16812819E-05_JPRB, 0.16807946E-05_JPRB, 0.16806007E-05_JPRB, 0.16808345E-05_JPRB, 0.16812437E-05_JPRB, 0.16814247E-05_JPRB, &
  & 0.16813915E-05_JPRB, 0.16815341E-05_JPRB, 0.16818372E-05_JPRB, 0.16826256E-05_JPRB, 0.16834170E-05_JPRB, 0.16843105E-05_JPRB, &
  & 0.16853535E-05_JPRB, 0.16868084E-05_JPRB, 0.16885696E-05_JPRB, 0.16904643E-05_JPRB, 0.16922470E-05_JPRB, 0.16939670E-05_JPRB, &
  & 0.16957965E-05_JPRB, 0.16974946E-05_JPRB, 0.16993943E-05_JPRB, 0.17011798E-05_JPRB, 0.17026394E-05_JPRB, 0.17037582E-05_JPRB, &
  & 0.17051143E-05_JPRB, 0.17064033E-05_JPRB, 0.17076867E-05_JPRB, 0.17095874E-05_JPRB, 0.17107528E-05_JPRB, 0.17120186E-05_JPRB, &
  & 0.17125380E-05_JPRB, 0.17117697E-05_JPRB, 0.17107768E-05_JPRB, 0.17104310E-05_JPRB, 0.17101207E-05_JPRB, 0.17098303E-05_JPRB, &
  & 0.17083267E-05_JPRB, 0.17088337E-05_JPRB, 0.17105993E-05_JPRB, 0.17139819E-05_JPRB, 0.17178276E-05_JPRB, 0.17223836E-05_JPRB, &
  & 0.17261320E-05_JPRB, 0.17293713E-05_JPRB, 0.17344563E-05_JPRB, 0.17405041E-05_JPRB, 0.17470169E-05_JPRB, 0.17540814E-05_JPRB, &
  & 0.17604121E-05_JPRB, 0.17664555E-05_JPRB, 0.17730970E-05_JPRB, 0.17791918E-05_JPRB, 0.17848785E-05_JPRB, 0.17902359E-05_JPRB, &
  & 0.17948611E-05_JPRB, 0.18003791E-05_JPRB, 0.18045630E-05_JPRB, 0.18097397E-05_JPRB, 0.18133892E-05_JPRB, 0.18168958E-05_JPRB, &
  & 0.18202348E-05_JPRB, 0.18246425E-05_JPRB, 0.18282520E-05_JPRB, 0.18302859E-05_JPRB  /)

RGHG2(:,70, 4) = (/ &
  & 0.16808961E-05_JPRB, 0.16804103E-05_JPRB, 0.16801899E-05_JPRB, 0.16803795E-05_JPRB, 0.16807330E-05_JPRB, 0.16809141E-05_JPRB, &
  & 0.16808674E-05_JPRB, 0.16810004E-05_JPRB, 0.16812696E-05_JPRB, 0.16820207E-05_JPRB, 0.16827714E-05_JPRB, 0.16836155E-05_JPRB, &
  & 0.16845817E-05_JPRB, 0.16859190E-05_JPRB, 0.16875696E-05_JPRB, 0.16893698E-05_JPRB, 0.16911109E-05_JPRB, 0.16928462E-05_JPRB, &
  & 0.16946326E-05_JPRB, 0.16962905E-05_JPRB, 0.16981643E-05_JPRB, 0.16998518E-05_JPRB, 0.17012075E-05_JPRB, 0.17021826E-05_JPRB, &
  & 0.17034894E-05_JPRB, 0.17048139E-05_JPRB, 0.17062803E-05_JPRB, 0.17084567E-05_JPRB, 0.17097911E-05_JPRB, 0.17112323E-05_JPRB, &
  & 0.17115197E-05_JPRB, 0.17107429E-05_JPRB, 0.17097293E-05_JPRB, 0.17093559E-05_JPRB, 0.17090264E-05_JPRB, 0.17081589E-05_JPRB, &
  & 0.17062177E-05_JPRB, 0.17071656E-05_JPRB, 0.17094984E-05_JPRB, 0.17134609E-05_JPRB, 0.17179343E-05_JPRB, 0.17231825E-05_JPRB, &
  & 0.17274365E-05_JPRB, 0.17308151E-05_JPRB, 0.17362430E-05_JPRB, 0.17426672E-05_JPRB, 0.17495247E-05_JPRB, 0.17568270E-05_JPRB, &
  & 0.17633424E-05_JPRB, 0.17695333E-05_JPRB, 0.17764219E-05_JPRB, 0.17826460E-05_JPRB, 0.17884547E-05_JPRB, 0.17938063E-05_JPRB, &
  & 0.17984401E-05_JPRB, 0.18039783E-05_JPRB, 0.18083811E-05_JPRB, 0.18133354E-05_JPRB, 0.18168732E-05_JPRB, 0.18203253E-05_JPRB, &
  & 0.18238383E-05_JPRB, 0.18281617E-05_JPRB, 0.18319182E-05_JPRB, 0.18339839E-05_JPRB  /)

RGHG2(:,71, 4) = (/ &
  & 0.16805499E-05_JPRB, 0.16800690E-05_JPRB, 0.16798276E-05_JPRB, 0.16799763E-05_JPRB, 0.16802785E-05_JPRB, 0.16804564E-05_JPRB, &
  & 0.16804011E-05_JPRB, 0.16805167E-05_JPRB, 0.16807598E-05_JPRB, 0.16814632E-05_JPRB, 0.16821730E-05_JPRB, 0.16829602E-05_JPRB, &
  & 0.16838514E-05_JPRB, 0.16850641E-05_JPRB, 0.16866001E-05_JPRB, 0.16882869E-05_JPRB, 0.16899704E-05_JPRB, 0.16917142E-05_JPRB, &
  & 0.16934604E-05_JPRB, 0.16950793E-05_JPRB, 0.16968998E-05_JPRB, 0.16984869E-05_JPRB, 0.16997392E-05_JPRB, 0.17005947E-05_JPRB, &
  & 0.17018140E-05_JPRB, 0.17031373E-05_JPRB, 0.17047791E-05_JPRB, 0.17072000E-05_JPRB, 0.17087768E-05_JPRB, 0.17103939E-05_JPRB, &
  & 0.17105945E-05_JPRB, 0.17098759E-05_JPRB, 0.17088358E-05_JPRB, 0.17084576E-05_JPRB, 0.17081558E-05_JPRB, 0.17067156E-05_JPRB, &
  & 0.17046374E-05_JPRB, 0.17059419E-05_JPRB, 0.17086859E-05_JPRB, 0.17132647E-05_JPRB, 0.17183905E-05_JPRB, 0.17242850E-05_JPRB, &
  & 0.17290122E-05_JPRB, 0.17325956E-05_JPRB, 0.17383946E-05_JPRB, 0.17451700E-05_JPRB, 0.17522886E-05_JPRB, 0.17597567E-05_JPRB, &
  & 0.17664221E-05_JPRB, 0.17727828E-05_JPRB, 0.17799384E-05_JPRB, 0.17862274E-05_JPRB, 0.17920944E-05_JPRB, 0.17974640E-05_JPRB, &
  & 0.18020177E-05_JPRB, 0.18075812E-05_JPRB, 0.18122380E-05_JPRB, 0.18169731E-05_JPRB, 0.18203390E-05_JPRB, 0.18236559E-05_JPRB, &
  & 0.18273249E-05_JPRB, 0.18315827E-05_JPRB, 0.18353487E-05_JPRB, 0.18375080E-05_JPRB  /)

RGHG2(:,72, 4) = (/ &
  & 0.16802397E-05_JPRB, 0.16797712E-05_JPRB, 0.16795125E-05_JPRB, 0.16796240E-05_JPRB, 0.16798841E-05_JPRB, 0.16800497E-05_JPRB, &
  & 0.16799968E-05_JPRB, 0.16800876E-05_JPRB, 0.16803159E-05_JPRB, 0.16809624E-05_JPRB, 0.16816276E-05_JPRB, 0.16823503E-05_JPRB, &
  & 0.16831722E-05_JPRB, 0.16842587E-05_JPRB, 0.16856708E-05_JPRB, 0.16872313E-05_JPRB, 0.16888405E-05_JPRB, 0.16905670E-05_JPRB, &
  & 0.16922785E-05_JPRB, 0.16938677E-05_JPRB, 0.16956089E-05_JPRB, 0.16970920E-05_JPRB, 0.16982577E-05_JPRB, 0.16990067E-05_JPRB, &
  & 0.17000997E-05_JPRB, 0.17013957E-05_JPRB, 0.17032554E-05_JPRB, 0.17058373E-05_JPRB, 0.17077138E-05_JPRB, 0.17094770E-05_JPRB, &
  & 0.17098336E-05_JPRB, 0.17091769E-05_JPRB, 0.17081640E-05_JPRB, 0.17078924E-05_JPRB, 0.17075162E-05_JPRB, 0.17056649E-05_JPRB, &
  & 0.17037279E-05_JPRB, 0.17052181E-05_JPRB, 0.17083213E-05_JPRB, 0.17134325E-05_JPRB, 0.17191972E-05_JPRB, 0.17258024E-05_JPRB, &
  & 0.17309060E-05_JPRB, 0.17348609E-05_JPRB, 0.17410438E-05_JPRB, 0.17480791E-05_JPRB, 0.17553439E-05_JPRB, 0.17628814E-05_JPRB, &
  & 0.17696705E-05_JPRB, 0.17762269E-05_JPRB, 0.17836624E-05_JPRB, 0.17899142E-05_JPRB, 0.17958728E-05_JPRB, 0.18013068E-05_JPRB, &
  & 0.18056524E-05_JPRB, 0.18112134E-05_JPRB, 0.18160981E-05_JPRB, 0.18206920E-05_JPRB, 0.18237881E-05_JPRB, 0.18268623E-05_JPRB, &
  & 0.18306278E-05_JPRB, 0.18348757E-05_JPRB, 0.18384436E-05_JPRB, 0.18407317E-05_JPRB  /)

RGHG2(:,73, 4) = (/ &
  & 0.16799589E-05_JPRB, 0.16795144E-05_JPRB, 0.16792428E-05_JPRB, 0.16793216E-05_JPRB, 0.16795462E-05_JPRB, 0.16796993E-05_JPRB, &
  & 0.16796512E-05_JPRB, 0.16797217E-05_JPRB, 0.16799374E-05_JPRB, 0.16805312E-05_JPRB, 0.16811424E-05_JPRB, 0.16818003E-05_JPRB, &
  & 0.16825502E-05_JPRB, 0.16835165E-05_JPRB, 0.16847972E-05_JPRB, 0.16862376E-05_JPRB, 0.16877559E-05_JPRB, 0.16894053E-05_JPRB, &
  & 0.16910795E-05_JPRB, 0.16926458E-05_JPRB, 0.16942866E-05_JPRB, 0.16956559E-05_JPRB, 0.16967619E-05_JPRB, 0.16974751E-05_JPRB, &
  & 0.16984549E-05_JPRB, 0.16996614E-05_JPRB, 0.17016760E-05_JPRB, 0.17044083E-05_JPRB, 0.17064896E-05_JPRB, 0.17084825E-05_JPRB, &
  & 0.17091822E-05_JPRB, 0.17086843E-05_JPRB, 0.17078322E-05_JPRB, 0.17077113E-05_JPRB, 0.17072581E-05_JPRB, 0.17052485E-05_JPRB, &
  & 0.17034190E-05_JPRB, 0.17051718E-05_JPRB, 0.17086177E-05_JPRB, 0.17142277E-05_JPRB, 0.17204879E-05_JPRB, 0.17279207E-05_JPRB, &
  & 0.17333040E-05_JPRB, 0.17377750E-05_JPRB, 0.17442475E-05_JPRB, 0.17514248E-05_JPRB, 0.17587975E-05_JPRB, 0.17661427E-05_JPRB, &
  & 0.17731023E-05_JPRB, 0.17798692E-05_JPRB, 0.17875218E-05_JPRB, 0.17937547E-05_JPRB, 0.17999319E-05_JPRB, 0.18053686E-05_JPRB, &
  & 0.18093832E-05_JPRB, 0.18148957E-05_JPRB, 0.18199635E-05_JPRB, 0.18245235E-05_JPRB, 0.18273159E-05_JPRB, 0.18301437E-05_JPRB, &
  & 0.18338823E-05_JPRB, 0.18380972E-05_JPRB, 0.18414750E-05_JPRB, 0.18436651E-05_JPRB  /)

RGHG2(:,74, 4) = (/ &
  & 0.16796970E-05_JPRB, 0.16792834E-05_JPRB, 0.16790038E-05_JPRB, 0.16790532E-05_JPRB, 0.16792460E-05_JPRB, 0.16793852E-05_JPRB, &
  & 0.16793451E-05_JPRB, 0.16794031E-05_JPRB, 0.16796094E-05_JPRB, 0.16801598E-05_JPRB, 0.16807192E-05_JPRB, 0.16813095E-05_JPRB, &
  & 0.16819917E-05_JPRB, 0.16828414E-05_JPRB, 0.16839872E-05_JPRB, 0.16852962E-05_JPRB, 0.16867000E-05_JPRB, 0.16882672E-05_JPRB, &
  & 0.16898921E-05_JPRB, 0.16914360E-05_JPRB, 0.16929673E-05_JPRB, 0.16942280E-05_JPRB, 0.16953022E-05_JPRB, 0.16960514E-05_JPRB, &
  & 0.16969744E-05_JPRB, 0.16981043E-05_JPRB, 0.17001008E-05_JPRB, 0.17029226E-05_JPRB, 0.17051736E-05_JPRB, 0.17074898E-05_JPRB, &
  & 0.17086287E-05_JPRB, 0.17083036E-05_JPRB, 0.17076980E-05_JPRB, 0.17077299E-05_JPRB, 0.17073147E-05_JPRB, 0.17053805E-05_JPRB, &
  & 0.17035688E-05_JPRB, 0.17056369E-05_JPRB, 0.17094971E-05_JPRB, 0.17156009E-05_JPRB, 0.17222828E-05_JPRB, 0.17305191E-05_JPRB, &
  & 0.17361289E-05_JPRB, 0.17411037E-05_JPRB, 0.17477064E-05_JPRB, 0.17550127E-05_JPRB, 0.17623449E-05_JPRB, 0.17694789E-05_JPRB, &
  & 0.17766562E-05_JPRB, 0.17835944E-05_JPRB, 0.17914226E-05_JPRB, 0.17977412E-05_JPRB, 0.18040772E-05_JPRB, 0.18094232E-05_JPRB, &
  & 0.18131207E-05_JPRB, 0.18185824E-05_JPRB, 0.18237293E-05_JPRB, 0.18283197E-05_JPRB, 0.18309121E-05_JPRB, 0.18335338E-05_JPRB, &
  & 0.18371348E-05_JPRB, 0.18412731E-05_JPRB, 0.18445574E-05_JPRB, 0.18466215E-05_JPRB  /)

RGHG2(:,75, 4) = (/ &
  & 0.16794554E-05_JPRB, 0.16790786E-05_JPRB, 0.16787954E-05_JPRB, 0.16788189E-05_JPRB, 0.16789825E-05_JPRB, 0.16791075E-05_JPRB, &
  & 0.16790753E-05_JPRB, 0.16791286E-05_JPRB, 0.16793302E-05_JPRB, 0.16798461E-05_JPRB, 0.16803600E-05_JPRB, 0.16808842E-05_JPRB, &
  & 0.16815018E-05_JPRB, 0.16822456E-05_JPRB, 0.16832500E-05_JPRB, 0.16844227E-05_JPRB, 0.16857015E-05_JPRB, 0.16871758E-05_JPRB, &
  & 0.16887279E-05_JPRB, 0.16902357E-05_JPRB, 0.16916816E-05_JPRB, 0.16928565E-05_JPRB, 0.16939344E-05_JPRB, 0.16947602E-05_JPRB, &
  & 0.16956600E-05_JPRB, 0.16967514E-05_JPRB, 0.16986132E-05_JPRB, 0.17014223E-05_JPRB, 0.17038186E-05_JPRB, 0.17065421E-05_JPRB, &
  & 0.17081719E-05_JPRB, 0.17080011E-05_JPRB, 0.17076916E-05_JPRB, 0.17079045E-05_JPRB, 0.17076378E-05_JPRB, 0.17060183E-05_JPRB, &
  & 0.17042430E-05_JPRB, 0.17065896E-05_JPRB, 0.17108952E-05_JPRB, 0.17174810E-05_JPRB, 0.17245646E-05_JPRB, 0.17335681E-05_JPRB, &
  & 0.17393528E-05_JPRB, 0.17447601E-05_JPRB, 0.17513494E-05_JPRB, 0.17587501E-05_JPRB, 0.17658922E-05_JPRB, 0.17728740E-05_JPRB, &
  & 0.17803224E-05_JPRB, 0.17873332E-05_JPRB, 0.17953294E-05_JPRB, 0.18018410E-05_JPRB, 0.18082407E-05_JPRB, 0.18134130E-05_JPRB, &
  & 0.18168574E-05_JPRB, 0.18222421E-05_JPRB, 0.18273890E-05_JPRB, 0.18321089E-05_JPRB, 0.18345797E-05_JPRB, 0.18370130E-05_JPRB, &
  & 0.18403701E-05_JPRB, 0.18443732E-05_JPRB, 0.18476380E-05_JPRB, 0.18495835E-05_JPRB  /)

RGHG2(:,76, 4) = (/ &
  & 0.16792374E-05_JPRB, 0.16789026E-05_JPRB, 0.16786195E-05_JPRB, 0.16786206E-05_JPRB, 0.16787571E-05_JPRB, 0.16788696E-05_JPRB, &
  & 0.16788399E-05_JPRB, 0.16788957E-05_JPRB, 0.16790997E-05_JPRB, 0.16795884E-05_JPRB, 0.16800676E-05_JPRB, 0.16805348E-05_JPRB, &
  & 0.16810880E-05_JPRB, 0.16817476E-05_JPRB, 0.16825985E-05_JPRB, 0.16836423E-05_JPRB, 0.16848072E-05_JPRB, 0.16861602E-05_JPRB, &
  & 0.16875983E-05_JPRB, 0.16890342E-05_JPRB, 0.16904702E-05_JPRB, 0.16916080E-05_JPRB, 0.16927379E-05_JPRB, 0.16936331E-05_JPRB, &
  & 0.16945007E-05_JPRB, 0.16956218E-05_JPRB, 0.16973350E-05_JPRB, 0.16999683E-05_JPRB, 0.17024933E-05_JPRB, 0.17056949E-05_JPRB, &
  & 0.17078126E-05_JPRB, 0.17077385E-05_JPRB, 0.17077262E-05_JPRB, 0.17081967E-05_JPRB, 0.17081678E-05_JPRB, 0.17071205E-05_JPRB, &
  & 0.17055805E-05_JPRB, 0.17080312E-05_JPRB, 0.17127380E-05_JPRB, 0.17197796E-05_JPRB, 0.17273215E-05_JPRB, 0.17370582E-05_JPRB, &
  & 0.17429617E-05_JPRB, 0.17486588E-05_JPRB, 0.17551218E-05_JPRB, 0.17625324E-05_JPRB, 0.17693451E-05_JPRB, 0.17763219E-05_JPRB, &
  & 0.17841072E-05_JPRB, 0.17910041E-05_JPRB, 0.17992108E-05_JPRB, 0.18060172E-05_JPRB, 0.18123549E-05_JPRB, 0.18172895E-05_JPRB, &
  & 0.18206050E-05_JPRB, 0.18258411E-05_JPRB, 0.18309558E-05_JPRB, 0.18359680E-05_JPRB, 0.18383372E-05_JPRB, 0.18405576E-05_JPRB, &
  & 0.18435653E-05_JPRB, 0.18473529E-05_JPRB, 0.18506252E-05_JPRB, 0.18524865E-05_JPRB  /)

RGHG2(:,77, 4) = (/ &
  & 0.16790457E-05_JPRB, 0.16787560E-05_JPRB, 0.16784824E-05_JPRB, 0.16784681E-05_JPRB, 0.16785745E-05_JPRB, 0.16786769E-05_JPRB, &
  & 0.16786473E-05_JPRB, 0.16787104E-05_JPRB, 0.16789169E-05_JPRB, 0.16793804E-05_JPRB, 0.16798411E-05_JPRB, 0.16802648E-05_JPRB, &
  & 0.16807527E-05_JPRB, 0.16813388E-05_JPRB, 0.16820768E-05_JPRB, 0.16830114E-05_JPRB, 0.16840965E-05_JPRB, 0.16853072E-05_JPRB, &
  & 0.16866584E-05_JPRB, 0.16880286E-05_JPRB, 0.16894331E-05_JPRB, 0.16906095E-05_JPRB, 0.16917754E-05_JPRB, 0.16927362E-05_JPRB, &
  & 0.16935902E-05_JPRB, 0.16947558E-05_JPRB, 0.16964112E-05_JPRB, 0.16988708E-05_JPRB, 0.17013812E-05_JPRB, 0.17050962E-05_JPRB, &
  & 0.17076827E-05_JPRB, 0.17076779E-05_JPRB, 0.17079313E-05_JPRB, 0.17085726E-05_JPRB, 0.17088516E-05_JPRB, 0.17085181E-05_JPRB, &
  & 0.17076338E-05_JPRB, 0.17100494E-05_JPRB, 0.17148153E-05_JPRB, 0.17221476E-05_JPRB, 0.17305784E-05_JPRB, 0.17410039E-05_JPRB, &
  & 0.17469304E-05_JPRB, 0.17527118E-05_JPRB, 0.17589823E-05_JPRB, 0.17661003E-05_JPRB, 0.17727576E-05_JPRB, 0.17797103E-05_JPRB, &
  & 0.17875204E-05_JPRB, 0.17945233E-05_JPRB, 0.18029602E-05_JPRB, 0.18099893E-05_JPRB, 0.18162405E-05_JPRB, 0.18209767E-05_JPRB, &
  & 0.18243689E-05_JPRB, 0.18294828E-05_JPRB, 0.18344410E-05_JPRB, 0.18396472E-05_JPRB, 0.18420516E-05_JPRB, 0.18440988E-05_JPRB, &
  & 0.18466784E-05_JPRB, 0.18501903E-05_JPRB, 0.18533414E-05_JPRB, 0.18550481E-05_JPRB  /)

RGHG2(:,78, 4) = (/ &
  & 0.16788777E-05_JPRB, 0.16786331E-05_JPRB, 0.16783727E-05_JPRB, 0.16783482E-05_JPRB, 0.16784277E-05_JPRB, 0.16785201E-05_JPRB, &
  & 0.16784873E-05_JPRB, 0.16785611E-05_JPRB, 0.16787701E-05_JPRB, 0.16792037E-05_JPRB, 0.16796533E-05_JPRB, 0.16800424E-05_JPRB, &
  & 0.16804731E-05_JPRB, 0.16809993E-05_JPRB, 0.16816527E-05_JPRB, 0.16824907E-05_JPRB, 0.16834822E-05_JPRB, 0.16845964E-05_JPRB, &
  & 0.16859071E-05_JPRB, 0.16872266E-05_JPRB, 0.16885969E-05_JPRB, 0.16898414E-05_JPRB, 0.16910520E-05_JPRB, 0.16919997E-05_JPRB, &
  & 0.16928730E-05_JPRB, 0.16940614E-05_JPRB, 0.16956897E-05_JPRB, 0.16980323E-05_JPRB, 0.17005297E-05_JPRB, 0.17046753E-05_JPRB, &
  & 0.17077341E-05_JPRB, 0.17078257E-05_JPRB, 0.17082688E-05_JPRB, 0.17090067E-05_JPRB, 0.17096235E-05_JPRB, 0.17098845E-05_JPRB, &
  & 0.17094420E-05_JPRB, 0.17120862E-05_JPRB, 0.17169576E-05_JPRB, 0.17245194E-05_JPRB, 0.17338548E-05_JPRB, 0.17448573E-05_JPRB, &
  & 0.17508970E-05_JPRB, 0.17565213E-05_JPRB, 0.17625070E-05_JPRB, 0.17693999E-05_JPRB, 0.17759518E-05_JPRB, 0.17828236E-05_JPRB, &
  & 0.17906332E-05_JPRB, 0.17978687E-05_JPRB, 0.18064069E-05_JPRB, 0.18135550E-05_JPRB, 0.18198222E-05_JPRB, 0.18244699E-05_JPRB, &
  & 0.18280264E-05_JPRB, 0.18330392E-05_JPRB, 0.18378059E-05_JPRB, 0.18431377E-05_JPRB, 0.18455560E-05_JPRB, 0.18474775E-05_JPRB, &
  & 0.18496199E-05_JPRB, 0.18528728E-05_JPRB, 0.18558068E-05_JPRB, 0.18573063E-05_JPRB  /)

RGHG2(:,79, 4) = (/ &
  & 0.16787344E-05_JPRB, 0.16785323E-05_JPRB, 0.16782885E-05_JPRB, 0.16782564E-05_JPRB, 0.16783142E-05_JPRB, 0.16783974E-05_JPRB, &
  & 0.16783612E-05_JPRB, 0.16784451E-05_JPRB, 0.16786598E-05_JPRB, 0.16790602E-05_JPRB, 0.16794991E-05_JPRB, 0.16798663E-05_JPRB, &
  & 0.16802534E-05_JPRB, 0.16807329E-05_JPRB, 0.16813236E-05_JPRB, 0.16820831E-05_JPRB, 0.16829859E-05_JPRB, 0.16840391E-05_JPRB, &
  & 0.16853468E-05_JPRB, 0.16866350E-05_JPRB, 0.16879673E-05_JPRB, 0.16892852E-05_JPRB, 0.16905226E-05_JPRB, 0.16914138E-05_JPRB, &
  & 0.16923134E-05_JPRB, 0.16935046E-05_JPRB, 0.16951332E-05_JPRB, 0.16974324E-05_JPRB, 0.16999096E-05_JPRB, 0.17044467E-05_JPRB, &
  & 0.17079423E-05_JPRB, 0.17081698E-05_JPRB, 0.17086853E-05_JPRB, 0.17094718E-05_JPRB, 0.17104247E-05_JPRB, 0.17111881E-05_JPRB, &
  & 0.17110219E-05_JPRB, 0.17139758E-05_JPRB, 0.17190346E-05_JPRB, 0.17268052E-05_JPRB, 0.17368913E-05_JPRB, 0.17483601E-05_JPRB, &
  & 0.17545493E-05_JPRB, 0.17599101E-05_JPRB, 0.17655843E-05_JPRB, 0.17723003E-05_JPRB, 0.17787834E-05_JPRB, 0.17855654E-05_JPRB, &
  & 0.17933859E-05_JPRB, 0.18008798E-05_JPRB, 0.18094755E-05_JPRB, 0.18167344E-05_JPRB, 0.18230580E-05_JPRB, 0.18277332E-05_JPRB, &
  & 0.18315258E-05_JPRB, 0.18364942E-05_JPRB, 0.18410438E-05_JPRB, 0.18464454E-05_JPRB, 0.18488421E-05_JPRB, 0.18506973E-05_JPRB, &
  & 0.18524235E-05_JPRB, 0.18554520E-05_JPRB, 0.18581028E-05_JPRB, 0.18593419E-05_JPRB  /)

RGHG2(:,80, 4) = (/ &
  & 0.16786166E-05_JPRB, 0.16784516E-05_JPRB, 0.16782275E-05_JPRB, 0.16781880E-05_JPRB, 0.16782309E-05_JPRB, 0.16783067E-05_JPRB, &
  & 0.16782705E-05_JPRB, 0.16783593E-05_JPRB, 0.16785862E-05_JPRB, 0.16789520E-05_JPRB, 0.16793736E-05_JPRB, 0.16797359E-05_JPRB, &
  & 0.16800981E-05_JPRB, 0.16805428E-05_JPRB, 0.16810863E-05_JPRB, 0.16817911E-05_JPRB, 0.16826344E-05_JPRB, 0.16836457E-05_JPRB, &
  & 0.16849756E-05_JPRB, 0.16862563E-05_JPRB, 0.16875440E-05_JPRB, 0.16889169E-05_JPRB, 0.16901324E-05_JPRB, 0.16909688E-05_JPRB, &
  & 0.16918711E-05_JPRB, 0.16930500E-05_JPRB, 0.16947058E-05_JPRB, 0.16970489E-05_JPRB, 0.16994791E-05_JPRB, 0.17044263E-05_JPRB, &
  & 0.17082787E-05_JPRB, 0.17086907E-05_JPRB, 0.17091205E-05_JPRB, 0.17099377E-05_JPRB, 0.17111913E-05_JPRB, 0.17124146E-05_JPRB, &
  & 0.17124582E-05_JPRB, 0.17155700E-05_JPRB, 0.17209113E-05_JPRB, 0.17289107E-05_JPRB, 0.17394328E-05_JPRB, 0.17512657E-05_JPRB, &
  & 0.17575684E-05_JPRB, 0.17627159E-05_JPRB, 0.17681276E-05_JPRB, 0.17746681E-05_JPRB, 0.17811106E-05_JPRB, 0.17878497E-05_JPRB, &
  & 0.17957144E-05_JPRB, 0.18033851E-05_JPRB, 0.18121018E-05_JPRB, 0.18195714E-05_JPRB, 0.18259113E-05_JPRB, 0.18307288E-05_JPRB, &
  & 0.18348145E-05_JPRB, 0.18398321E-05_JPRB, 0.18441427E-05_JPRB, 0.18495758E-05_JPRB, 0.18519106E-05_JPRB, 0.18537704E-05_JPRB, &
  & 0.18551300E-05_JPRB, 0.18579815E-05_JPRB, 0.18603167E-05_JPRB, 0.18612438E-05_JPRB  /)

RGHG2(:,81, 4) = (/ &
  & 0.16785237E-05_JPRB, 0.16783944E-05_JPRB, 0.16781906E-05_JPRB, 0.16781436E-05_JPRB, 0.16781788E-05_JPRB, 0.16782495E-05_JPRB, &
  & 0.16782158E-05_JPRB, 0.16783122E-05_JPRB, 0.16785595E-05_JPRB, 0.16788973E-05_JPRB, 0.16793011E-05_JPRB, 0.16796583E-05_JPRB, &
  & 0.16800129E-05_JPRB, 0.16804397E-05_JPRB, 0.16809628E-05_JPRB, 0.16816473E-05_JPRB, 0.16824524E-05_JPRB, 0.16834229E-05_JPRB, &
  & 0.16847681E-05_JPRB, 0.16860488E-05_JPRB, 0.16873059E-05_JPRB, 0.16886814E-05_JPRB, 0.16898434E-05_JPRB, 0.16906671E-05_JPRB, &
  & 0.16915541E-05_JPRB, 0.16927126E-05_JPRB, 0.16943939E-05_JPRB, 0.16968236E-05_JPRB, 0.16992181E-05_JPRB, 0.17045448E-05_JPRB, &
  & 0.17086443E-05_JPRB, 0.17092906E-05_JPRB, 0.17095676E-05_JPRB, 0.17103313E-05_JPRB, 0.17119211E-05_JPRB, 0.17135392E-05_JPRB, &
  & 0.17137917E-05_JPRB, 0.17168602E-05_JPRB, 0.17223874E-05_JPRB, 0.17304684E-05_JPRB, 0.17412910E-05_JPRB, 0.17533863E-05_JPRB, &
  & 0.17596023E-05_JPRB, 0.17646225E-05_JPRB, 0.17698431E-05_JPRB, 0.17762283E-05_JPRB, 0.17827268E-05_JPRB, 0.17894990E-05_JPRB, &
  & 0.17974223E-05_JPRB, 0.18051414E-05_JPRB, 0.18139753E-05_JPRB, 0.18217862E-05_JPRB, 0.18282305E-05_JPRB, 0.18332543E-05_JPRB, &
  & 0.18378978E-05_JPRB, 0.18431880E-05_JPRB, 0.18474197E-05_JPRB, 0.18525267E-05_JPRB, 0.18548157E-05_JPRB, 0.18567061E-05_JPRB, &
  & 0.18578059E-05_JPRB, 0.18606319E-05_JPRB, 0.18626181E-05_JPRB, 0.18631173E-05_JPRB  /)

RGHG2(:,82, 4) = (/ &
  & 0.16784574E-05_JPRB, 0.16783529E-05_JPRB, 0.16781676E-05_JPRB, 0.16781165E-05_JPRB, 0.16781442E-05_JPRB, 0.16782116E-05_JPRB, &
  & 0.16781804E-05_JPRB, 0.16782827E-05_JPRB, 0.16785502E-05_JPRB, 0.16788654E-05_JPRB, 0.16792568E-05_JPRB, 0.16796123E-05_JPRB, &
  & 0.16799664E-05_JPRB, 0.16803843E-05_JPRB, 0.16808924E-05_JPRB, 0.16815619E-05_JPRB, 0.16823308E-05_JPRB, 0.16832818E-05_JPRB, &
  & 0.16846422E-05_JPRB, 0.16859124E-05_JPRB, 0.16871585E-05_JPRB, 0.16885312E-05_JPRB, 0.16896471E-05_JPRB, 0.16904564E-05_JPRB, &
  & 0.16913335E-05_JPRB, 0.16924876E-05_JPRB, 0.16942046E-05_JPRB, 0.16967151E-05_JPRB, 0.16990619E-05_JPRB, 0.17047359E-05_JPRB, &
  & 0.17090019E-05_JPRB, 0.17098003E-05_JPRB, 0.17099343E-05_JPRB, 0.17106641E-05_JPRB, 0.17125740E-05_JPRB, 0.17145738E-05_JPRB, &
  & 0.17148618E-05_JPRB, 0.17179048E-05_JPRB, 0.17236045E-05_JPRB, 0.17317121E-05_JPRB, 0.17428123E-05_JPRB, 0.17549366E-05_JPRB, &
  & 0.17610140E-05_JPRB, 0.17660480E-05_JPRB, 0.17711578E-05_JPRB, 0.17774885E-05_JPRB, 0.17840550E-05_JPRB, 0.17908584E-05_JPRB, &
  & 0.17987610E-05_JPRB, 0.18065088E-05_JPRB, 0.18154539E-05_JPRB, 0.18236074E-05_JPRB, 0.18301870E-05_JPRB, 0.18354843E-05_JPRB, &
  & 0.18407207E-05_JPRB, 0.18464361E-05_JPRB, 0.18507788E-05_JPRB, 0.18553426E-05_JPRB, 0.18575562E-05_JPRB, 0.18595208E-05_JPRB, &
  & 0.18604291E-05_JPRB, 0.18632228E-05_JPRB, 0.18649062E-05_JPRB, 0.18649784E-05_JPRB  /)

RGHG2(:,83, 4) = (/ &
  & 0.16784105E-05_JPRB, 0.16783241E-05_JPRB, 0.16781565E-05_JPRB, 0.16781038E-05_JPRB, 0.16781239E-05_JPRB, 0.16781917E-05_JPRB, &
  & 0.16781621E-05_JPRB, 0.16782674E-05_JPRB, 0.16785560E-05_JPRB, 0.16788482E-05_JPRB, 0.16792315E-05_JPRB, 0.16795890E-05_JPRB, &
  & 0.16799475E-05_JPRB, 0.16803643E-05_JPRB, 0.16808618E-05_JPRB, 0.16815216E-05_JPRB, 0.16822593E-05_JPRB, 0.16832052E-05_JPRB, &
  & 0.16845806E-05_JPRB, 0.16858435E-05_JPRB, 0.16870949E-05_JPRB, 0.16884606E-05_JPRB, 0.16895494E-05_JPRB, 0.16903494E-05_JPRB, &
  & 0.16912316E-05_JPRB, 0.16923999E-05_JPRB, 0.16941552E-05_JPRB, 0.16967571E-05_JPRB, 0.16990551E-05_JPRB, 0.17050117E-05_JPRB, &
  & 0.17093644E-05_JPRB, 0.17102628E-05_JPRB, 0.17101984E-05_JPRB, 0.17109129E-05_JPRB, 0.17131174E-05_JPRB, 0.17154941E-05_JPRB, &
  & 0.17156739E-05_JPRB, 0.17187276E-05_JPRB, 0.17245948E-05_JPRB, 0.17327224E-05_JPRB, 0.17440624E-05_JPRB, 0.17560789E-05_JPRB, &
  & 0.17620112E-05_JPRB, 0.17671264E-05_JPRB, 0.17722085E-05_JPRB, 0.17785691E-05_JPRB, 0.17851957E-05_JPRB, 0.17919825E-05_JPRB, &
  & 0.17998435E-05_JPRB, 0.18076143E-05_JPRB, 0.18166460E-05_JPRB, 0.18250932E-05_JPRB, 0.18318024E-05_JPRB, 0.18374164E-05_JPRB, &
  & 0.18432070E-05_JPRB, 0.18494759E-05_JPRB, 0.18540314E-05_JPRB, 0.18579777E-05_JPRB, 0.18600393E-05_JPRB, 0.18621493E-05_JPRB, &
  & 0.18629835E-05_JPRB, 0.18656857E-05_JPRB, 0.18671230E-05_JPRB, 0.18667516E-05_JPRB  /)

RGHG2(:,84, 4) = (/ &
  & 0.16783764E-05_JPRB, 0.16783049E-05_JPRB, 0.16781543E-05_JPRB, 0.16781017E-05_JPRB, 0.16781152E-05_JPRB, 0.16781878E-05_JPRB, &
  & 0.16781582E-05_JPRB, 0.16782632E-05_JPRB, 0.16785739E-05_JPRB, 0.16788389E-05_JPRB, 0.16792172E-05_JPRB, 0.16795795E-05_JPRB, &
  & 0.16799461E-05_JPRB, 0.16803681E-05_JPRB, 0.16808584E-05_JPRB, 0.16815137E-05_JPRB, 0.16822268E-05_JPRB, 0.16831754E-05_JPRB, &
  & 0.16845677E-05_JPRB, 0.16858362E-05_JPRB, 0.16871032E-05_JPRB, 0.16884610E-05_JPRB, 0.16895475E-05_JPRB, 0.16903487E-05_JPRB, &
  & 0.16912574E-05_JPRB, 0.16924555E-05_JPRB, 0.16942435E-05_JPRB, 0.16969629E-05_JPRB, 0.16992135E-05_JPRB, 0.17053743E-05_JPRB, &
  & 0.17097488E-05_JPRB, 0.17107251E-05_JPRB, 0.17103760E-05_JPRB, 0.17110813E-05_JPRB, 0.17135416E-05_JPRB, 0.17162796E-05_JPRB, &
  & 0.17162500E-05_JPRB, 0.17193578E-05_JPRB, 0.17253949E-05_JPRB, 0.17335760E-05_JPRB, 0.17451112E-05_JPRB, 0.17569693E-05_JPRB, &
  & 0.17627810E-05_JPRB, 0.17679858E-05_JPRB, 0.17731163E-05_JPRB, 0.17795755E-05_JPRB, 0.17862360E-05_JPRB, 0.17929278E-05_JPRB, &
  & 0.18007726E-05_JPRB, 0.18085681E-05_JPRB, 0.18176527E-05_JPRB, 0.18263091E-05_JPRB, 0.18331165E-05_JPRB, 0.18390556E-05_JPRB, &
  & 0.18453030E-05_JPRB, 0.18522109E-05_JPRB, 0.18570169E-05_JPRB, 0.18603917E-05_JPRB, 0.18621989E-05_JPRB, 0.18645151E-05_JPRB, &
  & 0.18654248E-05_JPRB, 0.18679383E-05_JPRB, 0.18692051E-05_JPRB, 0.18683785E-05_JPRB  /)

RGHG2(:,85, 4) = (/ &
  & 0.16783478E-05_JPRB, 0.16782917E-05_JPRB, 0.16781539E-05_JPRB, 0.16781039E-05_JPRB, 0.16781225E-05_JPRB, 0.16781977E-05_JPRB, &
  & 0.16781680E-05_JPRB, 0.16782679E-05_JPRB, 0.16785992E-05_JPRB, 0.16788359E-05_JPRB, 0.16792091E-05_JPRB, 0.16795740E-05_JPRB, &
  & 0.16799585E-05_JPRB, 0.16803908E-05_JPRB, 0.16808759E-05_JPRB, 0.16815338E-05_JPRB, 0.16822238E-05_JPRB, 0.16831802E-05_JPRB, &
  & 0.16846212E-05_JPRB, 0.16859051E-05_JPRB, 0.16871618E-05_JPRB, 0.16885428E-05_JPRB, 0.16896292E-05_JPRB, 0.16904510E-05_JPRB, &
  & 0.16914136E-05_JPRB, 0.16926066E-05_JPRB, 0.16943998E-05_JPRB, 0.16973374E-05_JPRB, 0.16994545E-05_JPRB, 0.17058489E-05_JPRB, &
  & 0.17103159E-05_JPRB, 0.17114308E-05_JPRB, 0.17108609E-05_JPRB, 0.17114121E-05_JPRB, 0.17139983E-05_JPRB, 0.17168800E-05_JPRB, &
  & 0.17166861E-05_JPRB, 0.17198452E-05_JPRB, 0.17260852E-05_JPRB, 0.17344229E-05_JPRB, 0.17461584E-05_JPRB, 0.17578881E-05_JPRB, &
  & 0.17635457E-05_JPRB, 0.17688532E-05_JPRB, 0.17740556E-05_JPRB, 0.17807279E-05_JPRB, 0.17873345E-05_JPRB, 0.17938337E-05_JPRB, &
  & 0.18017197E-05_JPRB, 0.18094997E-05_JPRB, 0.18186563E-05_JPRB, 0.18274359E-05_JPRB, 0.18343332E-05_JPRB, 0.18404315E-05_JPRB, &
  & 0.18469844E-05_JPRB, 0.18544521E-05_JPRB, 0.18596843E-05_JPRB, 0.18626200E-05_JPRB, 0.18640908E-05_JPRB, 0.18663249E-05_JPRB, &
  & 0.18675273E-05_JPRB, 0.18696788E-05_JPRB, 0.18710431E-05_JPRB, 0.18699366E-05_JPRB  /)

RGHG2(:,86, 4) = (/ &
  & 0.16783213E-05_JPRB, 0.16782807E-05_JPRB, 0.16781497E-05_JPRB, 0.16781044E-05_JPRB, 0.16781342E-05_JPRB, 0.16782119E-05_JPRB, &
  & 0.16781923E-05_JPRB, 0.16782790E-05_JPRB, 0.16786329E-05_JPRB, 0.16788353E-05_JPRB, 0.16792073E-05_JPRB, 0.16795748E-05_JPRB, &
  & 0.16799693E-05_JPRB, 0.16804160E-05_JPRB, 0.16808999E-05_JPRB, 0.16815624E-05_JPRB, 0.16822432E-05_JPRB, 0.16832134E-05_JPRB, &
  & 0.16847356E-05_JPRB, 0.16860631E-05_JPRB, 0.16872753E-05_JPRB, 0.16887157E-05_JPRB, 0.16898001E-05_JPRB, 0.16906406E-05_JPRB, &
  & 0.16917055E-05_JPRB, 0.16928652E-05_JPRB, 0.16946455E-05_JPRB, 0.16979070E-05_JPRB, 0.16997472E-05_JPRB, 0.17064729E-05_JPRB, &
  & 0.17112357E-05_JPRB, 0.17124819E-05_JPRB, 0.17120156E-05_JPRB, 0.17118936E-05_JPRB, 0.17145580E-05_JPRB, 0.17174295E-05_JPRB, &
  & 0.17171006E-05_JPRB, 0.17204018E-05_JPRB, 0.17267733E-05_JPRB, 0.17352824E-05_JPRB, 0.17474764E-05_JPRB, 0.17590670E-05_JPRB, &
  & 0.17644714E-05_JPRB, 0.17699504E-05_JPRB, 0.17751306E-05_JPRB, 0.17820834E-05_JPRB, 0.17886459E-05_JPRB, 0.17948370E-05_JPRB, &
  & 0.18027582E-05_JPRB, 0.18104987E-05_JPRB, 0.18197516E-05_JPRB, 0.18286009E-05_JPRB, 0.18355181E-05_JPRB, 0.18416377E-05_JPRB, &
  & 0.18484697E-05_JPRB, 0.18562789E-05_JPRB, 0.18618732E-05_JPRB, 0.18644801E-05_JPRB, 0.18656631E-05_JPRB, 0.18677905E-05_JPRB, &
  & 0.18690299E-05_JPRB, 0.18709561E-05_JPRB, 0.18724206E-05_JPRB, 0.18712498E-05_JPRB  /)

RGHG2(:,87, 4) = (/ &
  & 0.16782976E-05_JPRB, 0.16782701E-05_JPRB, 0.16781417E-05_JPRB, 0.16781015E-05_JPRB, 0.16781458E-05_JPRB, 0.16782288E-05_JPRB, &
  & 0.16782237E-05_JPRB, 0.16782933E-05_JPRB, 0.16786762E-05_JPRB, 0.16788378E-05_JPRB, 0.16792072E-05_JPRB, 0.16795772E-05_JPRB, &
  & 0.16799796E-05_JPRB, 0.16804420E-05_JPRB, 0.16809300E-05_JPRB, 0.16816031E-05_JPRB, 0.16822813E-05_JPRB, 0.16832698E-05_JPRB, &
  & 0.16849066E-05_JPRB, 0.16863106E-05_JPRB, 0.16874490E-05_JPRB, 0.16890176E-05_JPRB, 0.16900941E-05_JPRB, 0.16909248E-05_JPRB, &
  & 0.16920917E-05_JPRB, 0.16932643E-05_JPRB, 0.16949981E-05_JPRB, 0.16986588E-05_JPRB, 0.17001138E-05_JPRB, 0.17074914E-05_JPRB, &
  & 0.17126360E-05_JPRB, 0.17141056E-05_JPRB, 0.17140780E-05_JPRB, 0.17127345E-05_JPRB, 0.17153935E-05_JPRB, 0.17180923E-05_JPRB, &
  & 0.17176443E-05_JPRB, 0.17210543E-05_JPRB, 0.17275519E-05_JPRB, 0.17363383E-05_JPRB, 0.17492434E-05_JPRB, 0.17608263E-05_JPRB, &
  & 0.17657831E-05_JPRB, 0.17714414E-05_JPRB, 0.17765236E-05_JPRB, 0.17838005E-05_JPRB, 0.17903358E-05_JPRB, 0.17960726E-05_JPRB, &
  & 0.18040025E-05_JPRB, 0.18116716E-05_JPRB, 0.18210481E-05_JPRB, 0.18299056E-05_JPRB, 0.18367199E-05_JPRB, 0.18427890E-05_JPRB, &
  & 0.18498935E-05_JPRB, 0.18578279E-05_JPRB, 0.18636878E-05_JPRB, 0.18660656E-05_JPRB, 0.18669253E-05_JPRB, 0.18689186E-05_JPRB, &
  & 0.18700879E-05_JPRB, 0.18717799E-05_JPRB, 0.18733680E-05_JPRB, 0.18722976E-05_JPRB  /)

RGHG2(:,88, 4) = (/ &
  & 0.16782774E-05_JPRB, 0.16782592E-05_JPRB, 0.16781316E-05_JPRB, 0.16780946E-05_JPRB, 0.16781577E-05_JPRB, 0.16782474E-05_JPRB, &
  & 0.16782603E-05_JPRB, 0.16783083E-05_JPRB, 0.16787292E-05_JPRB, 0.16788434E-05_JPRB, 0.16792073E-05_JPRB, 0.16795793E-05_JPRB, &
  & 0.16799899E-05_JPRB, 0.16804680E-05_JPRB, 0.16809666E-05_JPRB, 0.16816641E-05_JPRB, 0.16823399E-05_JPRB, 0.16833528E-05_JPRB, &
  & 0.16851481E-05_JPRB, 0.16866825E-05_JPRB, 0.16877438E-05_JPRB, 0.16895323E-05_JPRB, 0.16905689E-05_JPRB, 0.16912837E-05_JPRB, &
  & 0.16926273E-05_JPRB, 0.16939555E-05_JPRB, 0.16954931E-05_JPRB, 0.16995861E-05_JPRB, 0.17006037E-05_JPRB, 0.17095089E-05_JPRB, &
  & 0.17148169E-05_JPRB, 0.17167594E-05_JPRB, 0.17174721E-05_JPRB, 0.17141608E-05_JPRB, 0.17166481E-05_JPRB, 0.17190856E-05_JPRB, &
  & 0.17185571E-05_JPRB, 0.17219085E-05_JPRB, 0.17285659E-05_JPRB, 0.17380171E-05_JPRB, 0.17518755E-05_JPRB, 0.17638301E-05_JPRB, &
  & 0.17680164E-05_JPRB, 0.17736887E-05_JPRB, 0.17785836E-05_JPRB, 0.17862296E-05_JPRB, 0.17927606E-05_JPRB, 0.17977538E-05_JPRB, &
  & 0.18056499E-05_JPRB, 0.18132139E-05_JPRB, 0.18227995E-05_JPRB, 0.18315181E-05_JPRB, 0.18380380E-05_JPRB, 0.18440735E-05_JPRB, &
  & 0.18514116E-05_JPRB, 0.18592459E-05_JPRB, 0.18652588E-05_JPRB, 0.18674249E-05_JPRB, 0.18678639E-05_JPRB, 0.18697162E-05_JPRB, &
  & 0.18708140E-05_JPRB, 0.18722063E-05_JPRB, 0.18739335E-05_JPRB, 0.18731010E-05_JPRB  /)

RGHG2(:,89, 4) = (/ &
  & 0.16782622E-05_JPRB, 0.16782502E-05_JPRB, 0.16781243E-05_JPRB, 0.16780844E-05_JPRB, 0.16781738E-05_JPRB, 0.16782663E-05_JPRB, &
  & 0.16783045E-05_JPRB, 0.16783208E-05_JPRB, 0.16787873E-05_JPRB, 0.16788501E-05_JPRB, 0.16792086E-05_JPRB, 0.16795810E-05_JPRB, &
  & 0.16799999E-05_JPRB, 0.16804927E-05_JPRB, 0.16810082E-05_JPRB, 0.16817561E-05_JPRB, 0.16824204E-05_JPRB, 0.16834694E-05_JPRB, &
  & 0.16854807E-05_JPRB, 0.16872249E-05_JPRB, 0.16882815E-05_JPRB, 0.16903274E-05_JPRB, 0.16912694E-05_JPRB, 0.16916404E-05_JPRB, &
  & 0.16935370E-05_JPRB, 0.16951166E-05_JPRB, 0.16961458E-05_JPRB, 0.17006339E-05_JPRB, 0.17012933E-05_JPRB, 0.17135408E-05_JPRB, &
  & 0.17180868E-05_JPRB, 0.17209902E-05_JPRB, 0.17224905E-05_JPRB, 0.17162661E-05_JPRB, 0.17183199E-05_JPRB, 0.17206702E-05_JPRB, &
  & 0.17201946E-05_JPRB, 0.17231170E-05_JPRB, 0.17299964E-05_JPRB, 0.17410126E-05_JPRB, 0.17561357E-05_JPRB, 0.17691946E-05_JPRB, &
  & 0.17722803E-05_JPRB, 0.17772907E-05_JPRB, 0.17819494E-05_JPRB, 0.17899386E-05_JPRB, 0.17964770E-05_JPRB, 0.18001870E-05_JPRB, &
  & 0.18079513E-05_JPRB, 0.18154318E-05_JPRB, 0.18254158E-05_JPRB, 0.18336359E-05_JPRB, 0.18396171E-05_JPRB, 0.18457492E-05_JPRB, &
  & 0.18531443E-05_JPRB, 0.18607230E-05_JPRB, 0.18667399E-05_JPRB, 0.18685362E-05_JPRB, 0.18684325E-05_JPRB, 0.18702032E-05_JPRB, &
  & 0.18713175E-05_JPRB, 0.18723790E-05_JPRB, 0.18742138E-05_JPRB, 0.18736868E-05_JPRB  /)

RGHG2(:,90, 4) = (/ &
  & 0.16782518E-05_JPRB, 0.16782484E-05_JPRB, 0.16781167E-05_JPRB, 0.16780739E-05_JPRB, 0.16781928E-05_JPRB, 0.16782889E-05_JPRB, &
  & 0.16783692E-05_JPRB, 0.16783312E-05_JPRB, 0.16788422E-05_JPRB, 0.16788544E-05_JPRB, 0.16792100E-05_JPRB, 0.16795853E-05_JPRB, &
  & 0.16800103E-05_JPRB, 0.16805211E-05_JPRB, 0.16810518E-05_JPRB, 0.16818854E-05_JPRB, 0.16825160E-05_JPRB, 0.16836354E-05_JPRB, &
  & 0.16859442E-05_JPRB, 0.16879543E-05_JPRB, 0.16891953E-05_JPRB, 0.16911892E-05_JPRB, 0.16921395E-05_JPRB, 0.16919932E-05_JPRB, &
  & 0.16956275E-05_JPRB, 0.16963805E-05_JPRB, 0.16969233E-05_JPRB, 0.17019047E-05_JPRB, 0.17023472E-05_JPRB, 0.17202003E-05_JPRB, &
  & 0.17221595E-05_JPRB, 0.17267061E-05_JPRB, 0.17283460E-05_JPRB, 0.17185089E-05_JPRB, 0.17200561E-05_JPRB, 0.17229380E-05_JPRB, &
  & 0.17228626E-05_JPRB, 0.17247394E-05_JPRB, 0.17319795E-05_JPRB, 0.17457358E-05_JPRB, 0.17634692E-05_JPRB, 0.17782901E-05_JPRB, &
  & 0.17807171E-05_JPRB, 0.17831312E-05_JPRB, 0.17879219E-05_JPRB, 0.17957774E-05_JPRB, 0.18022635E-05_JPRB, 0.18039784E-05_JPRB, &
  & 0.18112059E-05_JPRB, 0.18189149E-05_JPRB, 0.18294951E-05_JPRB, 0.18364732E-05_JPRB, 0.18417863E-05_JPRB, 0.18480265E-05_JPRB, &
  & 0.18550665E-05_JPRB, 0.18625972E-05_JPRB, 0.18682919E-05_JPRB, 0.18694495E-05_JPRB, 0.18687086E-05_JPRB, 0.18705279E-05_JPRB, &
  & 0.18716560E-05_JPRB, 0.18724092E-05_JPRB, 0.18743039E-05_JPRB, 0.18739556E-05_JPRB  /)

RGHG2(:,91, 4) = (/ &
  & 0.16782527E-05_JPRB, 0.16782462E-05_JPRB, 0.16781112E-05_JPRB, 0.16780684E-05_JPRB, 0.16782001E-05_JPRB, 0.16783153E-05_JPRB, &
  & 0.16784371E-05_JPRB, 0.16783416E-05_JPRB, 0.16788750E-05_JPRB, 0.16788585E-05_JPRB, 0.16792141E-05_JPRB, 0.16795862E-05_JPRB, &
  & 0.16800207E-05_JPRB, 0.16805475E-05_JPRB, 0.16810973E-05_JPRB, 0.16820554E-05_JPRB, 0.16826382E-05_JPRB, 0.16838596E-05_JPRB, &
  & 0.16867141E-05_JPRB, 0.16891933E-05_JPRB, 0.16906353E-05_JPRB, 0.16922782E-05_JPRB, 0.16933976E-05_JPRB, 0.16925844E-05_JPRB, &
  & 0.17023167E-05_JPRB, 0.16982736E-05_JPRB, 0.16983889E-05_JPRB, 0.17041999E-05_JPRB, 0.17040616E-05_JPRB, 0.17268448E-05_JPRB, &
  & 0.17276712E-05_JPRB, 0.17347004E-05_JPRB, 0.17353128E-05_JPRB, 0.17214519E-05_JPRB, 0.17225779E-05_JPRB, 0.17261139E-05_JPRB, &
  & 0.17268778E-05_JPRB, 0.17268942E-05_JPRB, 0.17345556E-05_JPRB, 0.17512347E-05_JPRB, 0.17739652E-05_JPRB, 0.17905061E-05_JPRB, &
  & 0.17930511E-05_JPRB, 0.17915531E-05_JPRB, 0.17964587E-05_JPRB, 0.18036888E-05_JPRB, 0.18110077E-05_JPRB, 0.18107410E-05_JPRB, &
  & 0.18162294E-05_JPRB, 0.18246085E-05_JPRB, 0.18365927E-05_JPRB, 0.18403065E-05_JPRB, 0.18450739E-05_JPRB, 0.18518693E-05_JPRB, &
  & 0.18589380E-05_JPRB, 0.18650520E-05_JPRB, 0.18707116E-05_JPRB, 0.18706885E-05_JPRB, 0.18689073E-05_JPRB, 0.18707873E-05_JPRB, &
  & 0.18719824E-05_JPRB, 0.18724005E-05_JPRB, 0.18743430E-05_JPRB, 0.18740171E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ---GEMS----

RGHG2(:, 1, 5) = (/ &
  & 0.26393794E-06_JPRB, 0.26462934E-06_JPRB, 0.26542115E-06_JPRB, 0.26613889E-06_JPRB, 0.26768137E-06_JPRB, 0.26909379E-06_JPRB, &
  & 0.27038605E-06_JPRB, 0.27103629E-06_JPRB, 0.27185609E-06_JPRB, 0.27258700E-06_JPRB, 0.27343478E-06_JPRB, 0.27439780E-06_JPRB, &
  & 0.27541844E-06_JPRB, 0.27638310E-06_JPRB, 0.27675349E-06_JPRB, 0.27595015E-06_JPRB, 0.27412783E-06_JPRB, 0.27144784E-06_JPRB, &
  & 0.26896539E-06_JPRB, 0.26729451E-06_JPRB, 0.26518246E-06_JPRB, 0.26163657E-06_JPRB, 0.25820428E-06_JPRB, 0.25675069E-06_JPRB, &
  & 0.25679514E-06_JPRB, 0.25748160E-06_JPRB, 0.25769396E-06_JPRB, 0.25649554E-06_JPRB, 0.25354722E-06_JPRB, 0.24876999E-06_JPRB, &
  & 0.24298035E-06_JPRB, 0.23675613E-06_JPRB, 0.23029814E-06_JPRB, 0.22460234E-06_JPRB, 0.21998644E-06_JPRB, 0.21602736E-06_JPRB, &
  & 0.21242880E-06_JPRB, 0.20925660E-06_JPRB, 0.20653216E-06_JPRB, 0.20414355E-06_JPRB, 0.20212203E-06_JPRB, 0.20046432E-06_JPRB, &
  & 0.19911116E-06_JPRB, 0.19797200E-06_JPRB, 0.19703697E-06_JPRB, 0.19635215E-06_JPRB, 0.19606407E-06_JPRB, 0.19628795E-06_JPRB, &
  & 0.19699581E-06_JPRB, 0.19798682E-06_JPRB, 0.19912268E-06_JPRB, 0.20032111E-06_JPRB, 0.20142899E-06_JPRB, 0.20236567E-06_JPRB, &
  & 0.20303731E-06_JPRB, 0.20335173E-06_JPRB, 0.20324473E-06_JPRB, 0.20303731E-06_JPRB, 0.20318547E-06_JPRB, 0.20356409E-06_JPRB, &
  & 0.20401515E-06_JPRB, 0.20446620E-06_JPRB, 0.20480861E-06_JPRB, 0.20501438E-06_JPRB  /)

RGHG2(:, 2, 5) = (/ &
  & 0.26393794E-06_JPRB, 0.26462934E-06_JPRB, 0.26542115E-06_JPRB, 0.26613889E-06_JPRB, 0.26768137E-06_JPRB, 0.26909379E-06_JPRB, &
  & 0.27038605E-06_JPRB, 0.27103629E-06_JPRB, 0.27185609E-06_JPRB, 0.27258700E-06_JPRB, 0.27343478E-06_JPRB, 0.27439780E-06_JPRB, &
  & 0.27541844E-06_JPRB, 0.27638310E-06_JPRB, 0.27675349E-06_JPRB, 0.27595015E-06_JPRB, 0.27412783E-06_JPRB, 0.27144784E-06_JPRB, &
  & 0.26896539E-06_JPRB, 0.26729451E-06_JPRB, 0.26518246E-06_JPRB, 0.26163657E-06_JPRB, 0.25820428E-06_JPRB, 0.25675069E-06_JPRB, &
  & 0.25679514E-06_JPRB, 0.25748160E-06_JPRB, 0.25769396E-06_JPRB, 0.25649554E-06_JPRB, 0.25354722E-06_JPRB, 0.24876999E-06_JPRB, &
  & 0.24298035E-06_JPRB, 0.23675613E-06_JPRB, 0.23029814E-06_JPRB, 0.22460234E-06_JPRB, 0.21998644E-06_JPRB, 0.21602736E-06_JPRB, &
  & 0.21242880E-06_JPRB, 0.20925660E-06_JPRB, 0.20653216E-06_JPRB, 0.20414355E-06_JPRB, 0.20212203E-06_JPRB, 0.20046432E-06_JPRB, &
  & 0.19911116E-06_JPRB, 0.19797200E-06_JPRB, 0.19703697E-06_JPRB, 0.19635215E-06_JPRB, 0.19606407E-06_JPRB, 0.19628795E-06_JPRB, &
  & 0.19699581E-06_JPRB, 0.19798682E-06_JPRB, 0.19912268E-06_JPRB, 0.20032111E-06_JPRB, 0.20142899E-06_JPRB, 0.20236567E-06_JPRB, &
  & 0.20303731E-06_JPRB, 0.20335173E-06_JPRB, 0.20324473E-06_JPRB, 0.20303731E-06_JPRB, 0.20318547E-06_JPRB, 0.20356409E-06_JPRB, &
  & 0.20401515E-06_JPRB, 0.20446620E-06_JPRB, 0.20480861E-06_JPRB, 0.20501438E-06_JPRB  /)

RGHG2(:, 3, 5) = (/ &
  & 0.26393794E-06_JPRB, 0.26462934E-06_JPRB, 0.26542115E-06_JPRB, 0.26613889E-06_JPRB, 0.26768137E-06_JPRB, 0.26909379E-06_JPRB, &
  & 0.27038605E-06_JPRB, 0.27103629E-06_JPRB, 0.27185609E-06_JPRB, 0.27258700E-06_JPRB, 0.27343478E-06_JPRB, 0.27439780E-06_JPRB, &
  & 0.27541844E-06_JPRB, 0.27638310E-06_JPRB, 0.27675349E-06_JPRB, 0.27595015E-06_JPRB, 0.27412783E-06_JPRB, 0.27144784E-06_JPRB, &
  & 0.26896539E-06_JPRB, 0.26729451E-06_JPRB, 0.26518246E-06_JPRB, 0.26163657E-06_JPRB, 0.25820428E-06_JPRB, 0.25675069E-06_JPRB, &
  & 0.25679514E-06_JPRB, 0.25748160E-06_JPRB, 0.25769396E-06_JPRB, 0.25649554E-06_JPRB, 0.25354722E-06_JPRB, 0.24876999E-06_JPRB, &
  & 0.24298035E-06_JPRB, 0.23675613E-06_JPRB, 0.23029814E-06_JPRB, 0.22460234E-06_JPRB, 0.21998644E-06_JPRB, 0.21602736E-06_JPRB, &
  & 0.21242880E-06_JPRB, 0.20925660E-06_JPRB, 0.20653216E-06_JPRB, 0.20414355E-06_JPRB, 0.20212203E-06_JPRB, 0.20046432E-06_JPRB, &
  & 0.19911116E-06_JPRB, 0.19797200E-06_JPRB, 0.19703697E-06_JPRB, 0.19635215E-06_JPRB, 0.19606407E-06_JPRB, 0.19628795E-06_JPRB, &
  & 0.19699581E-06_JPRB, 0.19798682E-06_JPRB, 0.19912268E-06_JPRB, 0.20032111E-06_JPRB, 0.20142899E-06_JPRB, 0.20236567E-06_JPRB, &
  & 0.20303731E-06_JPRB, 0.20335173E-06_JPRB, 0.20324473E-06_JPRB, 0.20303731E-06_JPRB, 0.20318547E-06_JPRB, 0.20356409E-06_JPRB, &
  & 0.20401515E-06_JPRB, 0.20446620E-06_JPRB, 0.20480861E-06_JPRB, 0.20501438E-06_JPRB  /)

RGHG2(:, 4, 5) = (/ &
  & 0.26395078E-06_JPRB, 0.26464061E-06_JPRB, 0.26543297E-06_JPRB, 0.26615075E-06_JPRB, 0.26768898E-06_JPRB, 0.26910069E-06_JPRB, &
  & 0.27038857E-06_JPRB, 0.27103842E-06_JPRB, 0.27185806E-06_JPRB, 0.27258811E-06_JPRB, 0.27343511E-06_JPRB, 0.27439877E-06_JPRB, &
  & 0.27542108E-06_JPRB, 0.27638836E-06_JPRB, 0.27676413E-06_JPRB, 0.27596811E-06_JPRB, 0.27415225E-06_JPRB, 0.27147847E-06_JPRB, &
  & 0.26899916E-06_JPRB, 0.26732755E-06_JPRB, 0.26521672E-06_JPRB, 0.26168000E-06_JPRB, 0.25825666E-06_JPRB, 0.25680458E-06_JPRB, &
  & 0.25685331E-06_JPRB, 0.25754440E-06_JPRB, 0.25775845E-06_JPRB, 0.25656335E-06_JPRB, 0.25362140E-06_JPRB, 0.24885241E-06_JPRB, &
  & 0.24306509E-06_JPRB, 0.23683670E-06_JPRB, 0.23037440E-06_JPRB, 0.22467322E-06_JPRB, 0.22005077E-06_JPRB, 0.21608378E-06_JPRB, &
  & 0.21247517E-06_JPRB, 0.20929221E-06_JPRB, 0.20655928E-06_JPRB, 0.20416333E-06_JPRB, 0.20213367E-06_JPRB, 0.20046793E-06_JPRB, &
  & 0.19910729E-06_JPRB, 0.19796179E-06_JPRB, 0.19702005E-06_JPRB, 0.19632733E-06_JPRB, 0.19603183E-06_JPRB, 0.19625055E-06_JPRB, &
  & 0.19695637E-06_JPRB, 0.19794845E-06_JPRB, 0.19908907E-06_JPRB, 0.20029482E-06_JPRB, 0.20141272E-06_JPRB, 0.20236200E-06_JPRB, &
  & 0.20304600E-06_JPRB, 0.20336813E-06_JPRB, 0.20326213E-06_JPRB, 0.20305346E-06_JPRB, 0.20320249E-06_JPRB, 0.20358452E-06_JPRB, &
  & 0.20404011E-06_JPRB, 0.20449649E-06_JPRB, 0.20484338E-06_JPRB, 0.20505148E-06_JPRB  /)

RGHG2(:, 5, 5) = (/ &
  & 0.26456040E-06_JPRB, 0.26517572E-06_JPRB, 0.26599392E-06_JPRB, 0.26671350E-06_JPRB, 0.26805043E-06_JPRB, 0.26942788E-06_JPRB, &
  & 0.27050845E-06_JPRB, 0.27113968E-06_JPRB, 0.27195150E-06_JPRB, 0.27264068E-06_JPRB, 0.27345043E-06_JPRB, 0.27444474E-06_JPRB, &
  & 0.27554637E-06_JPRB, 0.27663804E-06_JPRB, 0.27726920E-06_JPRB, 0.27682050E-06_JPRB, 0.27531171E-06_JPRB, 0.27293236E-06_JPRB, &
  & 0.27060208E-06_JPRB, 0.26889562E-06_JPRB, 0.26684308E-06_JPRB, 0.26374142E-06_JPRB, 0.26074291E-06_JPRB, 0.25936235E-06_JPRB, &
  & 0.25961418E-06_JPRB, 0.26052520E-06_JPRB, 0.26081978E-06_JPRB, 0.25978211E-06_JPRB, 0.25714242E-06_JPRB, 0.25276462E-06_JPRB, &
  & 0.24708727E-06_JPRB, 0.24066118E-06_JPRB, 0.23399397E-06_JPRB, 0.22803740E-06_JPRB, 0.22310428E-06_JPRB, 0.21876173E-06_JPRB, &
  & 0.21467599E-06_JPRB, 0.21098226E-06_JPRB, 0.20784612E-06_JPRB, 0.20510225E-06_JPRB, 0.20268621E-06_JPRB, 0.20063888E-06_JPRB, &
  & 0.19892372E-06_JPRB, 0.19747716E-06_JPRB, 0.19621693E-06_JPRB, 0.19514925E-06_JPRB, 0.19450162E-06_JPRB, 0.19447517E-06_JPRB, &
  & 0.19508424E-06_JPRB, 0.19612740E-06_JPRB, 0.19749335E-06_JPRB, 0.19904703E-06_JPRB, 0.20064025E-06_JPRB, 0.20218804E-06_JPRB, &
  & 0.20345853E-06_JPRB, 0.20414661E-06_JPRB, 0.20408808E-06_JPRB, 0.20381992E-06_JPRB, 0.20401041E-06_JPRB, 0.20455408E-06_JPRB, &
  & 0.20522480E-06_JPRB, 0.20593416E-06_JPRB, 0.20649377E-06_JPRB, 0.20681244E-06_JPRB  /)

RGHG2(:, 6, 5) = (/ &
  & 0.26547505E-06_JPRB, 0.26597857E-06_JPRB, 0.26683554E-06_JPRB, 0.26755782E-06_JPRB, 0.26859272E-06_JPRB, 0.26991879E-06_JPRB, &
  & 0.27068832E-06_JPRB, 0.27129159E-06_JPRB, 0.27209170E-06_JPRB, 0.27271957E-06_JPRB, 0.27347342E-06_JPRB, 0.27451371E-06_JPRB, &
  & 0.27573434E-06_JPRB, 0.27701264E-06_JPRB, 0.27802697E-06_JPRB, 0.27809938E-06_JPRB, 0.27705129E-06_JPRB, 0.27511372E-06_JPRB, &
  & 0.27300703E-06_JPRB, 0.27124827E-06_JPRB, 0.26928318E-06_JPRB, 0.26683426E-06_JPRB, 0.26447317E-06_JPRB, 0.26319989E-06_JPRB, &
  & 0.26375645E-06_JPRB, 0.26499745E-06_JPRB, 0.26541284E-06_JPRB, 0.26461138E-06_JPRB, 0.26242518E-06_JPRB, 0.25863431E-06_JPRB, &
  & 0.25312194E-06_JPRB, 0.24639923E-06_JPRB, 0.23942459E-06_JPRB, 0.23308485E-06_JPRB, 0.22768562E-06_JPRB, 0.22277958E-06_JPRB, &
  & 0.21797800E-06_JPRB, 0.21351793E-06_JPRB, 0.20977684E-06_JPRB, 0.20651096E-06_JPRB, 0.20351520E-06_JPRB, 0.20089538E-06_JPRB, &
  & 0.19864829E-06_JPRB, 0.19675004E-06_JPRB, 0.19501198E-06_JPRB, 0.19338172E-06_JPRB, 0.19220577E-06_JPRB, 0.19181147E-06_JPRB, &
  & 0.19227539E-06_JPRB, 0.19339518E-06_JPRB, 0.19509923E-06_JPRB, 0.19717492E-06_JPRB, 0.19948128E-06_JPRB, 0.20192704E-06_JPRB, &
  & 0.20407746E-06_JPRB, 0.20531460E-06_JPRB, 0.20532729E-06_JPRB, 0.20496987E-06_JPRB, 0.20522257E-06_JPRB, 0.20600877E-06_JPRB, &
  & 0.20700224E-06_JPRB, 0.20809117E-06_JPRB, 0.20896994E-06_JPRB, 0.20945450E-06_JPRB  /)

RGHG2(:, 7, 5) = (/ &
  & 0.26413574E-06_JPRB, 0.26539656E-06_JPRB, 0.26676114E-06_JPRB, 0.26738918E-06_JPRB, 0.26830818E-06_JPRB, 0.26944779E-06_JPRB, &
  & 0.27009084E-06_JPRB, 0.27067668E-06_JPRB, 0.27155120E-06_JPRB, 0.27223189E-06_JPRB, 0.27300641E-06_JPRB, 0.27423957E-06_JPRB, &
  & 0.27580770E-06_JPRB, 0.27754207E-06_JPRB, 0.27924882E-06_JPRB, 0.28035671E-06_JPRB, 0.28049372E-06_JPRB, 0.27953895E-06_JPRB, &
  & 0.27815395E-06_JPRB, 0.27680214E-06_JPRB, 0.27516453E-06_JPRB, 0.27338035E-06_JPRB, 0.27183917E-06_JPRB, 0.27140851E-06_JPRB, &
  & 0.27228916E-06_JPRB, 0.27367379E-06_JPRB, 0.27456551E-06_JPRB, 0.27439604E-06_JPRB, 0.27281065E-06_JPRB, 0.27001647E-06_JPRB, &
  & 0.26596408E-06_JPRB, 0.26009730E-06_JPRB, 0.25330735E-06_JPRB, 0.24636776E-06_JPRB, 0.23996266E-06_JPRB, 0.23389052E-06_JPRB, &
  & 0.22746969E-06_JPRB, 0.22120405E-06_JPRB, 0.21574975E-06_JPRB, 0.21115408E-06_JPRB, 0.20693123E-06_JPRB, 0.20303085E-06_JPRB, &
  & 0.19953275E-06_JPRB, 0.19643528E-06_JPRB, 0.19340779E-06_JPRB, 0.19036160E-06_JPRB, 0.18795985E-06_JPRB, 0.18683730E-06_JPRB, &
  & 0.18711142E-06_JPRB, 0.18855712E-06_JPRB, 0.19108796E-06_JPRB, 0.19429904E-06_JPRB, 0.19811110E-06_JPRB, 0.20256055E-06_JPRB, &
  & 0.20712144E-06_JPRB, 0.21054712E-06_JPRB, 0.21165847E-06_JPRB, 0.21126134E-06_JPRB, 0.21098921E-06_JPRB, 0.21159259E-06_JPRB, &
  & 0.21280579E-06_JPRB, 0.21404761E-06_JPRB, 0.21455925E-06_JPRB, 0.21442604E-06_JPRB  /)

RGHG2(:, 8, 5) = (/ &
  & 0.26005894E-06_JPRB, 0.26210832E-06_JPRB, 0.26371032E-06_JPRB, 0.26450238E-06_JPRB, 0.26554024E-06_JPRB, 0.26650920E-06_JPRB, &
  & 0.26720533E-06_JPRB, 0.26791029E-06_JPRB, 0.26897699E-06_JPRB, 0.27015572E-06_JPRB, 0.27141671E-06_JPRB, 0.27342265E-06_JPRB, &
  & 0.27588273E-06_JPRB, 0.27871631E-06_JPRB, 0.28190650E-06_JPRB, 0.28483152E-06_JPRB, 0.28694026E-06_JPRB, 0.28775858E-06_JPRB, &
  & 0.28764984E-06_JPRB, 0.28723839E-06_JPRB, 0.28631766E-06_JPRB, 0.28529794E-06_JPRB, 0.28463129E-06_JPRB, 0.28492764E-06_JPRB, &
  & 0.28589818E-06_JPRB, 0.28743393E-06_JPRB, 0.28944648E-06_JPRB, 0.29082323E-06_JPRB, 0.29025194E-06_JPRB, 0.28808148E-06_JPRB, &
  & 0.28464878E-06_JPRB, 0.27910907E-06_JPRB, 0.27209473E-06_JPRB, 0.26434517E-06_JPRB, 0.25681400E-06_JPRB, 0.24965527E-06_JPRB, &
  & 0.24204746E-06_JPRB, 0.23449855E-06_JPRB, 0.22745885E-06_JPRB, 0.22133785E-06_JPRB, 0.21534187E-06_JPRB, 0.20920287E-06_JPRB, &
  & 0.20338593E-06_JPRB, 0.19799073E-06_JPRB, 0.19243444E-06_JPRB, 0.18680206E-06_JPRB, 0.18230969E-06_JPRB, 0.17992993E-06_JPRB, &
  & 0.17987005E-06_JPRB, 0.18196794E-06_JPRB, 0.18592853E-06_JPRB, 0.19089024E-06_JPRB, 0.19703332E-06_JPRB, 0.20500002E-06_JPRB, &
  & 0.21392101E-06_JPRB, 0.22160019E-06_JPRB, 0.22586618E-06_JPRB, 0.22659879E-06_JPRB, 0.22593924E-06_JPRB, 0.22606892E-06_JPRB, &
  & 0.22715389E-06_JPRB, 0.22806178E-06_JPRB, 0.22800842E-06_JPRB, 0.22746385E-06_JPRB  /)

RGHG2(:, 9, 5) = (/ &
  & 0.25081821E-06_JPRB, 0.25289707E-06_JPRB, 0.25427152E-06_JPRB, 0.25552322E-06_JPRB, 0.25690659E-06_JPRB, 0.25792970E-06_JPRB, &
  & 0.25907074E-06_JPRB, 0.26039050E-06_JPRB, 0.26216209E-06_JPRB, 0.26470358E-06_JPRB, 0.26777033E-06_JPRB, 0.27189701E-06_JPRB, &
  & 0.27677930E-06_JPRB, 0.28259307E-06_JPRB, 0.28927123E-06_JPRB, 0.29588127E-06_JPRB, 0.30140338E-06_JPRB, 0.30540734E-06_JPRB, &
  & 0.30766158E-06_JPRB, 0.30897955E-06_JPRB, 0.30922797E-06_JPRB, 0.30889585E-06_JPRB, 0.30869661E-06_JPRB, 0.30910977E-06_JPRB, &
  & 0.30980469E-06_JPRB, 0.31101752E-06_JPRB, 0.31411468E-06_JPRB, 0.31811322E-06_JPRB, 0.31986568E-06_JPRB, 0.31779176E-06_JPRB, &
  & 0.31230390E-06_JPRB, 0.30425733E-06_JPRB, 0.29502585E-06_JPRB, 0.28595666E-06_JPRB, 0.27819312E-06_JPRB, 0.27146441E-06_JPRB, &
  & 0.26452648E-06_JPRB, 0.25749799E-06_JPRB, 0.25019047E-06_JPRB, 0.24326607E-06_JPRB, 0.23545428E-06_JPRB, 0.22606632E-06_JPRB, &
  & 0.21617429E-06_JPRB, 0.20614357E-06_JPRB, 0.19540227E-06_JPRB, 0.18497796E-06_JPRB, 0.17705029E-06_JPRB, 0.17244869E-06_JPRB, &
  & 0.17167439E-06_JPRB, 0.17493904E-06_JPRB, 0.18122741E-06_JPRB, 0.18876291E-06_JPRB, 0.19829760E-06_JPRB, 0.21124995E-06_JPRB, &
  & 0.22648583E-06_JPRB, 0.24032490E-06_JPRB, 0.25016997E-06_JPRB, 0.25453750E-06_JPRB, 0.25494605E-06_JPRB, 0.25522358E-06_JPRB, &
  & 0.25638029E-06_JPRB, 0.25692819E-06_JPRB, 0.25652718E-06_JPRB, 0.25598076E-06_JPRB  /)

RGHG2(:,10, 5) = (/ &
  & 0.23409983E-06_JPRB, 0.23498040E-06_JPRB, 0.23604292E-06_JPRB, 0.23765033E-06_JPRB, 0.23925524E-06_JPRB, 0.24081346E-06_JPRB, &
  & 0.24306450E-06_JPRB, 0.24599592E-06_JPRB, 0.24963107E-06_JPRB, 0.25497103E-06_JPRB, 0.26215881E-06_JPRB, 0.27125326E-06_JPRB, &
  & 0.28204054E-06_JPRB, 0.29496448E-06_JPRB, 0.30902692E-06_JPRB, 0.32278069E-06_JPRB, 0.33492718E-06_JPRB, 0.34452415E-06_JPRB, &
  & 0.35096003E-06_JPRB, 0.35495367E-06_JPRB, 0.35647614E-06_JPRB, 0.35617679E-06_JPRB, 0.35541573E-06_JPRB, 0.35505701E-06_JPRB, &
  & 0.35514572E-06_JPRB, 0.35499071E-06_JPRB, 0.35727828E-06_JPRB, 0.36297047E-06_JPRB, 0.36701484E-06_JPRB, 0.36388557E-06_JPRB, &
  & 0.35316715E-06_JPRB, 0.33896491E-06_JPRB, 0.32514758E-06_JPRB, 0.31490473E-06_JPRB, 0.30915566E-06_JPRB, 0.30555132E-06_JPRB, &
  & 0.30178518E-06_JPRB, 0.29743748E-06_JPRB, 0.29226023E-06_JPRB, 0.28648032E-06_JPRB, 0.27784105E-06_JPRB, 0.26484962E-06_JPRB, &
  & 0.24854556E-06_JPRB, 0.22936120E-06_JPRB, 0.20837977E-06_JPRB, 0.18928492E-06_JPRB, 0.17569486E-06_JPRB, 0.16732213E-06_JPRB, &
  & 0.16534090E-06_JPRB, 0.17038907E-06_JPRB, 0.18012868E-06_JPRB, 0.19158245E-06_JPRB, 0.20558269E-06_JPRB, 0.22318584E-06_JPRB, &
  & 0.24464279E-06_JPRB, 0.26455992E-06_JPRB, 0.28052967E-06_JPRB, 0.29090000E-06_JPRB, 0.29483813E-06_JPRB, 0.29716591E-06_JPRB, &
  & 0.29962926E-06_JPRB, 0.30056551E-06_JPRB, 0.30023886E-06_JPRB, 0.29975188E-06_JPRB  /)

RGHG2(:,11, 5) = (/ &
  & 0.21126555E-06_JPRB, 0.21092912E-06_JPRB, 0.21174390E-06_JPRB, 0.21316783E-06_JPRB, 0.21489785E-06_JPRB, 0.21755725E-06_JPRB, &
  & 0.22167532E-06_JPRB, 0.22725584E-06_JPRB, 0.23413996E-06_JPRB, 0.24443912E-06_JPRB, 0.25876593E-06_JPRB, 0.27715938E-06_JPRB, &
  & 0.29875977E-06_JPRB, 0.32418804E-06_JPRB, 0.35003127E-06_JPRB, 0.37561085E-06_JPRB, 0.39935962E-06_JPRB, 0.41713230E-06_JPRB, &
  & 0.42909522E-06_JPRB, 0.43659899E-06_JPRB, 0.43898777E-06_JPRB, 0.43755353E-06_JPRB, 0.43494164E-06_JPRB, 0.43283865E-06_JPRB, &
  & 0.43218054E-06_JPRB, 0.43059283E-06_JPRB, 0.42933774E-06_JPRB, 0.43184644E-06_JPRB, 0.43261713E-06_JPRB, 0.42398347E-06_JPRB, &
  & 0.40611233E-06_JPRB, 0.38648987E-06_JPRB, 0.37033886E-06_JPRB, 0.36167608E-06_JPRB, 0.35998988E-06_JPRB, 0.36070427E-06_JPRB, &
  & 0.36111630E-06_JPRB, 0.36052436E-06_JPRB, 0.35908727E-06_JPRB, 0.35615232E-06_JPRB, 0.34810057E-06_JPRB, 0.33170100E-06_JPRB, &
  & 0.30599679E-06_JPRB, 0.27187010E-06_JPRB, 0.23463797E-06_JPRB, 0.20233005E-06_JPRB, 0.17996555E-06_JPRB, 0.16627866E-06_JPRB, &
  & 0.16315012E-06_JPRB, 0.17012842E-06_JPRB, 0.18391907E-06_JPRB, 0.20080165E-06_JPRB, 0.21894975E-06_JPRB, 0.23759725E-06_JPRB, &
  & 0.26176268E-06_JPRB, 0.28495982E-06_JPRB, 0.30452365E-06_JPRB, 0.31990802E-06_JPRB, 0.32784099E-06_JPRB, 0.33292363E-06_JPRB, &
  & 0.33640283E-06_JPRB, 0.33682024E-06_JPRB, 0.33549364E-06_JPRB, 0.33421276E-06_JPRB  /)

RGHG2(:,12, 5) = (/ &
  & 0.18667263E-06_JPRB, 0.18594137E-06_JPRB, 0.18621609E-06_JPRB, 0.18747808E-06_JPRB, 0.19010210E-06_JPRB, 0.19432806E-06_JPRB, &
  & 0.20096077E-06_JPRB, 0.21015991E-06_JPRB, 0.22219222E-06_JPRB, 0.24042259E-06_JPRB, 0.26507317E-06_JPRB, 0.29592135E-06_JPRB, &
  & 0.33262159E-06_JPRB, 0.37350813E-06_JPRB, 0.41338880E-06_JPRB, 0.45475917E-06_JPRB, 0.49357375E-06_JPRB, 0.52008406E-06_JPRB, &
  & 0.53784737E-06_JPRB, 0.54999658E-06_JPRB, 0.55371811E-06_JPRB, 0.55059519E-06_JPRB, 0.54480333E-06_JPRB, 0.53997168E-06_JPRB, &
  & 0.53796425E-06_JPRB, 0.53523264E-06_JPRB, 0.52895586E-06_JPRB, 0.52393195E-06_JPRB, 0.51746626E-06_JPRB, 0.50042810E-06_JPRB, &
  & 0.47462865E-06_JPRB, 0.45203167E-06_JPRB, 0.43741452E-06_JPRB, 0.43208161E-06_JPRB, 0.43438097E-06_JPRB, 0.43919471E-06_JPRB, &
  & 0.44372210E-06_JPRB, 0.44656652E-06_JPRB, 0.44735137E-06_JPRB, 0.44647592E-06_JPRB, 0.43922141E-06_JPRB, 0.41876634E-06_JPRB, &
  & 0.37912757E-06_JPRB, 0.32607218E-06_JPRB, 0.27020535E-06_JPRB, 0.22258974E-06_JPRB, 0.18942150E-06_JPRB, 0.17005692E-06_JPRB, &
  & 0.16602826E-06_JPRB, 0.17375538E-06_JPRB, 0.19020980E-06_JPRB, 0.21138182E-06_JPRB, 0.22994683E-06_JPRB, 0.24527532E-06_JPRB, &
  & 0.26880025E-06_JPRB, 0.29232510E-06_JPRB, 0.31251582E-06_JPRB, 0.32947608E-06_JPRB, 0.33965319E-06_JPRB, 0.34598036E-06_JPRB, &
  & 0.34771405E-06_JPRB, 0.34637367E-06_JPRB, 0.34385693E-06_JPRB, 0.34095087E-06_JPRB  /)

RGHG2(:,13, 5) = (/ &
  & 0.16639714E-06_JPRB, 0.16555833E-06_JPRB, 0.16569998E-06_JPRB, 0.16770257E-06_JPRB, 0.17157766E-06_JPRB, 0.17788430E-06_JPRB, &
  & 0.18783140E-06_JPRB, 0.20201483E-06_JPRB, 0.22184887E-06_JPRB, 0.25001735E-06_JPRB, 0.28555080E-06_JPRB, 0.33091206E-06_JPRB, &
  & 0.38403742E-06_JPRB, 0.43797941E-06_JPRB, 0.49100038E-06_JPRB, 0.54847677E-06_JPRB, 0.60096557E-06_JPRB, 0.63541904E-06_JPRB, &
  & 0.66046710E-06_JPRB, 0.68033421E-06_JPRB, 0.68740447E-06_JPRB, 0.68390705E-06_JPRB, 0.67557287E-06_JPRB, 0.66736092E-06_JPRB, &
  & 0.66327053E-06_JPRB, 0.65969272E-06_JPRB, 0.65186121E-06_JPRB, 0.64124624E-06_JPRB, 0.62809351E-06_JPRB, 0.60613505E-06_JPRB, &
  & 0.57481224E-06_JPRB, 0.54810007E-06_JPRB, 0.53227535E-06_JPRB, 0.52842100E-06_JPRB, 0.53372328E-06_JPRB, 0.54151700E-06_JPRB, &
  & 0.54819342E-06_JPRB, 0.55150376E-06_JPRB, 0.55054470E-06_JPRB, 0.54719682E-06_JPRB, 0.53802807E-06_JPRB, 0.51131208E-06_JPRB, &
  & 0.45538027E-06_JPRB, 0.38436241E-06_JPRB, 0.31140703E-06_JPRB, 0.24959419E-06_JPRB, 0.20598947E-06_JPRB, 0.18154704E-06_JPRB, &
  & 0.17637784E-06_JPRB, 0.18316412E-06_JPRB, 0.19877660E-06_JPRB, 0.21906342E-06_JPRB, 0.23274739E-06_JPRB, 0.24407842E-06_JPRB, &
  & 0.26692612E-06_JPRB, 0.29108167E-06_JPRB, 0.31023516E-06_JPRB, 0.32549072E-06_JPRB, 0.33552100E-06_JPRB, 0.34063580E-06_JPRB, &
  & 0.34045569E-06_JPRB, 0.34035445E-06_JPRB, 0.34181861E-06_JPRB, 0.34178545E-06_JPRB  /)

RGHG2(:,14, 5) = (/ &
  & 0.15806294E-06_JPRB, 0.15761764E-06_JPRB, 0.15809084E-06_JPRB, 0.16156179E-06_JPRB, 0.16697627E-06_JPRB, 0.17597981E-06_JPRB, &
  & 0.19008879E-06_JPRB, 0.21074711E-06_JPRB, 0.23937259E-06_JPRB, 0.27641500E-06_JPRB, 0.32317676E-06_JPRB, 0.38221724E-06_JPRB, &
  & 0.44658584E-06_JPRB, 0.50881320E-06_JPRB, 0.57376946E-06_JPRB, 0.64206567E-06_JPRB, 0.70136455E-06_JPRB, 0.74375115E-06_JPRB, &
  & 0.77813178E-06_JPRB, 0.80715218E-06_JPRB, 0.81908566E-06_JPRB, 0.81947843E-06_JPRB, 0.81485944E-06_JPRB, 0.81026574E-06_JPRB, &
  & 0.80956937E-06_JPRB, 0.80809466E-06_JPRB, 0.80327107E-06_JPRB, 0.79239317E-06_JPRB, 0.77463183E-06_JPRB, 0.74784407E-06_JPRB, &
  & 0.71107546E-06_JPRB, 0.67581526E-06_JPRB, 0.65509232E-06_JPRB, 0.65265075E-06_JPRB, 0.65968744E-06_JPRB, 0.66750446E-06_JPRB, &
  & 0.67156160E-06_JPRB, 0.66901883E-06_JPRB, 0.65970838E-06_JPRB, 0.64535653E-06_JPRB, 0.62757418E-06_JPRB, 0.59242016E-06_JPRB, &
  & 0.52604007E-06_JPRB, 0.44347901E-06_JPRB, 0.35566606E-06_JPRB, 0.28151545E-06_JPRB, 0.22927530E-06_JPRB, 0.20055564E-06_JPRB, &
  & 0.19427092E-06_JPRB, 0.19956938E-06_JPRB, 0.21192648E-06_JPRB, 0.22561964E-06_JPRB, 0.23215032E-06_JPRB, 0.24217875E-06_JPRB, &
  & 0.26481374E-06_JPRB, 0.28918227E-06_JPRB, 0.30753733E-06_JPRB, 0.32114278E-06_JPRB, 0.32910342E-06_JPRB, 0.33259340E-06_JPRB, &
  & 0.33351341E-06_JPRB, 0.33687232E-06_JPRB, 0.34264419E-06_JPRB, 0.34904144E-06_JPRB  /)

RGHG2(:,15, 5) = (/ &
  & 0.16974558E-06_JPRB, 0.16953147E-06_JPRB, 0.17035135E-06_JPRB, 0.17542563E-06_JPRB, 0.18323044E-06_JPRB, 0.19619419E-06_JPRB, &
  & 0.21509244E-06_JPRB, 0.24229299E-06_JPRB, 0.27808492E-06_JPRB, 0.32304124E-06_JPRB, 0.37938229E-06_JPRB, 0.44584637E-06_JPRB, &
  & 0.51421686E-06_JPRB, 0.58258827E-06_JPRB, 0.65307671E-06_JPRB, 0.72246713E-06_JPRB, 0.78447981E-06_JPRB, 0.83118458E-06_JPRB, &
  & 0.87323237E-06_JPRB, 0.90858564E-06_JPRB, 0.92939802E-06_JPRB, 0.93959836E-06_JPRB, 0.94968466E-06_JPRB, 0.96483779E-06_JPRB, &
  & 0.97885273E-06_JPRB, 0.98721946E-06_JPRB, 0.98637634E-06_JPRB, 0.97437792E-06_JPRB, 0.95135090E-06_JPRB, 0.91452113E-06_JPRB, &
  & 0.86754824E-06_JPRB, 0.82309019E-06_JPRB, 0.80045079E-06_JPRB, 0.79984976E-06_JPRB, 0.80646466E-06_JPRB, 0.81005425E-06_JPRB, &
  & 0.80493730E-06_JPRB, 0.78866236E-06_JPRB, 0.76028056E-06_JPRB, 0.72381290E-06_JPRB, 0.68863362E-06_JPRB, 0.64795266E-06_JPRB, &
  & 0.58307615E-06_JPRB, 0.49576612E-06_JPRB, 0.39677748E-06_JPRB, 0.31195167E-06_JPRB, 0.25348333E-06_JPRB, 0.22208556E-06_JPRB, &
  & 0.21511631E-06_JPRB, 0.21927079E-06_JPRB, 0.22788465E-06_JPRB, 0.23307138E-06_JPRB, 0.23539961E-06_JPRB, 0.24544905E-06_JPRB, &
  & 0.26593680E-06_JPRB, 0.28758991E-06_JPRB, 0.30799039E-06_JPRB, 0.32247861E-06_JPRB, 0.33015866E-06_JPRB, 0.33415648E-06_JPRB, &
  & 0.33725642E-06_JPRB, 0.34244247E-06_JPRB, 0.34888949E-06_JPRB, 0.35559622E-06_JPRB  /)

RGHG2(:,16, 5) = (/ &
  & 0.20783134E-06_JPRB, 0.20730760E-06_JPRB, 0.20877977E-06_JPRB, 0.21595428E-06_JPRB, 0.22744626E-06_JPRB, 0.24510550E-06_JPRB, &
  & 0.26806930E-06_JPRB, 0.29975479E-06_JPRB, 0.34053747E-06_JPRB, 0.39027735E-06_JPRB, 0.45068274E-06_JPRB, 0.51714201E-06_JPRB, &
  & 0.58566272E-06_JPRB, 0.65433144E-06_JPRB, 0.72093598E-06_JPRB, 0.78583829E-06_JPRB, 0.84433306E-06_JPRB, 0.89004766E-06_JPRB, &
  & 0.93446741E-06_JPRB, 0.97414122E-06_JPRB, 0.10074537E-05_JPRB, 0.10331818E-05_JPRB, 0.10672150E-05_JPRB, 0.11095240E-05_JPRB, &
  & 0.11462988E-05_JPRB, 0.11687388E-05_JPRB, 0.11746481E-05_JPRB, 0.11630836E-05_JPRB, 0.11339736E-05_JPRB, 0.10886461E-05_JPRB, &
  & 0.10333945E-05_JPRB, 0.98358844E-06_JPRB, 0.96010668E-06_JPRB, 0.95760832E-06_JPRB, 0.95921110E-06_JPRB, 0.95180487E-06_JPRB, &
  & 0.92739511E-06_JPRB, 0.88972352E-06_JPRB, 0.83570465E-06_JPRB, 0.77096398E-06_JPRB, 0.71748958E-06_JPRB, 0.67757718E-06_JPRB, &
  & 0.62068553E-06_JPRB, 0.53411353E-06_JPRB, 0.42909617E-06_JPRB, 0.33769344E-06_JPRB, 0.27692372E-06_JPRB, 0.24446798E-06_JPRB, &
  & 0.23634814E-06_JPRB, 0.23907428E-06_JPRB, 0.24347426E-06_JPRB, 0.24399697E-06_JPRB, 0.24495646E-06_JPRB, 0.25313322E-06_JPRB, &
  & 0.27101663E-06_JPRB, 0.28845875E-06_JPRB, 0.31181695E-06_JPRB, 0.32977067E-06_JPRB, 0.34079725E-06_JPRB, 0.34739385E-06_JPRB, &
  & 0.35457975E-06_JPRB, 0.36263174E-06_JPRB, 0.36466293E-06_JPRB, 0.36375710E-06_JPRB  /)

RGHG2(:,17, 5) = (/ &
  & 0.27359605E-06_JPRB, 0.27410851E-06_JPRB, 0.27702606E-06_JPRB, 0.28578768E-06_JPRB, 0.30011249E-06_JPRB, 0.32061015E-06_JPRB, &
  & 0.34553849E-06_JPRB, 0.37909555E-06_JPRB, 0.42058766E-06_JPRB, 0.46989677E-06_JPRB, 0.52810312E-06_JPRB, 0.58984753E-06_JPRB, &
  & 0.65430135E-06_JPRB, 0.71742749E-06_JPRB, 0.77650890E-06_JPRB, 0.83216409E-06_JPRB, 0.88212021E-06_JPRB, 0.92440040E-06_JPRB, &
  & 0.96854896E-06_JPRB, 0.10095539E-05_JPRB, 0.10506177E-05_JPRB, 0.10907759E-05_JPRB, 0.11464745E-05_JPRB, 0.12118388E-05_JPRB, &
  & 0.12671135E-05_JPRB, 0.13059788E-05_JPRB, 0.13273531E-05_JPRB, 0.13263598E-05_JPRB, 0.13021290E-05_JPRB, 0.12578322E-05_JPRB, &
  & 0.12035625E-05_JPRB, 0.11559317E-05_JPRB, 0.11274506E-05_JPRB, 0.11121160E-05_JPRB, 0.10970596E-05_JPRB, 0.10677461E-05_JPRB, &
  & 0.10167716E-05_JPRB, 0.95232102E-06_JPRB, 0.87587720E-06_JPRB, 0.79024006E-06_JPRB, 0.72871819E-06_JPRB, 0.69246422E-06_JPRB, &
  & 0.64334528E-06_JPRB, 0.56039549E-06_JPRB, 0.45375287E-06_JPRB, 0.36187939E-06_JPRB, 0.30322750E-06_JPRB, 0.27090736E-06_JPRB, &
  & 0.26136922E-06_JPRB, 0.26119700E-06_JPRB, 0.26228812E-06_JPRB, 0.26147640E-06_JPRB, 0.26053874E-06_JPRB, 0.26873110E-06_JPRB, &
  & 0.28496833E-06_JPRB, 0.29770735E-06_JPRB, 0.32278961E-06_JPRB, 0.34769079E-06_JPRB, 0.36225962E-06_JPRB, 0.37213915E-06_JPRB, &
  & 0.38428188E-06_JPRB, 0.39626185E-06_JPRB, 0.39270597E-06_JPRB, 0.38301796E-06_JPRB  /)

RGHG2(:,18, 5) = (/ &
  & 0.36215900E-06_JPRB, 0.36441764E-06_JPRB, 0.36859241E-06_JPRB, 0.37769126E-06_JPRB, 0.39275185E-06_JPRB, 0.41325773E-06_JPRB, &
  & 0.43796012E-06_JPRB, 0.46998291E-06_JPRB, 0.50794986E-06_JPRB, 0.55300704E-06_JPRB, 0.60435001E-06_JPRB, 0.65864546E-06_JPRB, &
  & 0.71577387E-06_JPRB, 0.77067712E-06_JPRB, 0.82020565E-06_JPRB, 0.86556019E-06_JPRB, 0.90641233E-06_JPRB, 0.94518189E-06_JPRB, &
  & 0.98434974E-06_JPRB, 0.10260451E-05_JPRB, 0.10682961E-05_JPRB, 0.11124697E-05_JPRB, 0.11782485E-05_JPRB, 0.12583446E-05_JPRB, &
  & 0.13288607E-05_JPRB, 0.13862297E-05_JPRB, 0.14248876E-05_JPRB, 0.14431628E-05_JPRB, 0.14398551E-05_JPRB, 0.14122225E-05_JPRB, &
  & 0.13686990E-05_JPRB, 0.13220566E-05_JPRB, 0.12789082E-05_JPRB, 0.12368944E-05_JPRB, 0.11919209E-05_JPRB, 0.11359784E-05_JPRB, &
  & 0.10627763E-05_JPRB, 0.97631429E-06_JPRB, 0.88684974E-06_JPRB, 0.78976342E-06_JPRB, 0.73017112E-06_JPRB, 0.69903918E-06_JPRB, &
  & 0.65532277E-06_JPRB, 0.57806625E-06_JPRB, 0.47470825E-06_JPRB, 0.38735121E-06_JPRB, 0.33301081E-06_JPRB, 0.30262712E-06_JPRB, &
  & 0.29155406E-06_JPRB, 0.28654921E-06_JPRB, 0.28462863E-06_JPRB, 0.28288035E-06_JPRB, 0.28185921E-06_JPRB, 0.29132838E-06_JPRB, &
  & 0.30576865E-06_JPRB, 0.31647487E-06_JPRB, 0.34159615E-06_JPRB, 0.37239346E-06_JPRB, 0.39153017E-06_JPRB, 0.40283393E-06_JPRB, &
  & 0.41540318E-06_JPRB, 0.42829815E-06_JPRB, 0.42655457E-06_JPRB, 0.41276042E-06_JPRB  /)

RGHG2(:,19, 5) = (/ &
  & 0.46399191E-06_JPRB, 0.46639231E-06_JPRB, 0.47093573E-06_JPRB, 0.47989442E-06_JPRB, 0.49402945E-06_JPRB, 0.51260000E-06_JPRB, &
  & 0.53515117E-06_JPRB, 0.56325777E-06_JPRB, 0.59598425E-06_JPRB, 0.63451943E-06_JPRB, 0.67799045E-06_JPRB, 0.72446400E-06_JPRB, &
  & 0.77274594E-06_JPRB, 0.81804547E-06_JPRB, 0.85859331E-06_JPRB, 0.89424589E-06_JPRB, 0.92770076E-06_JPRB, 0.96175375E-06_JPRB, &
  & 0.99495133E-06_JPRB, 0.10331032E-05_JPRB, 0.10726996E-05_JPRB, 0.11146731E-05_JPRB, 0.11808874E-05_JPRB, 0.12682702E-05_JPRB, &
  & 0.13569576E-05_JPRB, 0.14270617E-05_JPRB, 0.14791261E-05_JPRB, 0.15174299E-05_JPRB, 0.15353140E-05_JPRB, 0.15280048E-05_JPRB, &
  & 0.14988839E-05_JPRB, 0.14528825E-05_JPRB, 0.13910084E-05_JPRB, 0.13184580E-05_JPRB, 0.12448155E-05_JPRB, 0.11682469E-05_JPRB, &
  & 0.10795393E-05_JPRB, 0.98140250E-06_JPRB, 0.88432767E-06_JPRB, 0.78446698E-06_JPRB, 0.72954365E-06_JPRB, 0.70142206E-06_JPRB, &
  & 0.66088804E-06_JPRB, 0.58956820E-06_JPRB, 0.49718891E-06_JPRB, 0.41854758E-06_JPRB, 0.36782648E-06_JPRB, 0.34004041E-06_JPRB, &
  & 0.32550722E-06_JPRB, 0.31603123E-06_JPRB, 0.31192358E-06_JPRB, 0.30912577E-06_JPRB, 0.30864466E-06_JPRB, 0.31843620E-06_JPRB, &
  & 0.33225771E-06_JPRB, 0.34375694E-06_JPRB, 0.36759805E-06_JPRB, 0.40009022E-06_JPRB, 0.42192721E-06_JPRB, 0.43493086E-06_JPRB, &
  & 0.44604381E-06_JPRB, 0.45624268E-06_JPRB, 0.45710696E-06_JPRB, 0.44458426E-06_JPRB  /)

RGHG2(:,20, 5) = (/ &
  & 0.56716570E-06_JPRB, 0.56894078E-06_JPRB, 0.57329945E-06_JPRB, 0.58172316E-06_JPRB, 0.59429297E-06_JPRB, 0.61045473E-06_JPRB, &
  & 0.63002848E-06_JPRB, 0.65385709E-06_JPRB, 0.68130501E-06_JPRB, 0.71333947E-06_JPRB, 0.75022948E-06_JPRB, 0.78934879E-06_JPRB, &
  & 0.82907016E-06_JPRB, 0.86539430E-06_JPRB, 0.89793431E-06_JPRB, 0.92549081E-06_JPRB, 0.95295487E-06_JPRB, 0.98031935E-06_JPRB, &
  & 0.10073017E-05_JPRB, 0.10401774E-05_JPRB, 0.10747337E-05_JPRB, 0.11141087E-05_JPRB, 0.11773950E-05_JPRB, 0.12665935E-05_JPRB, &
  & 0.13707802E-05_JPRB, 0.14454045E-05_JPRB, 0.15070224E-05_JPRB, 0.15617517E-05_JPRB, 0.15944514E-05_JPRB, 0.16026821E-05_JPRB, &
  & 0.15847997E-05_JPRB, 0.15396921E-05_JPRB, 0.14643361E-05_JPRB, 0.13697629E-05_JPRB, 0.12765761E-05_JPRB, 0.11860404E-05_JPRB, &
  & 0.10876873E-05_JPRB, 0.98356073E-06_JPRB, 0.88267009E-06_JPRB, 0.78542000E-06_JPRB, 0.73274258E-06_JPRB, 0.70495565E-06_JPRB, &
  & 0.66502935E-06_JPRB, 0.59917140E-06_JPRB, 0.52366235E-06_JPRB, 0.45635560E-06_JPRB, 0.40906832E-06_JPRB, 0.38203639E-06_JPRB, &
  & 0.36182913E-06_JPRB, 0.35043557E-06_JPRB, 0.34558087E-06_JPRB, 0.34169409E-06_JPRB, 0.34136392E-06_JPRB, 0.35110203E-06_JPRB, &
  & 0.36502651E-06_JPRB, 0.37799921E-06_JPRB, 0.39929282E-06_JPRB, 0.42798292E-06_JPRB, 0.45105381E-06_JPRB, 0.46644461E-06_JPRB, &
  & 0.47532610E-06_JPRB, 0.48164660E-06_JPRB, 0.48325583E-06_JPRB, 0.47495872E-06_JPRB  /)

RGHG2(:,21, 5) = (/ &
  & 0.66464543E-06_JPRB, 0.66592705E-06_JPRB, 0.66992746E-06_JPRB, 0.67758881E-06_JPRB, 0.68867014E-06_JPRB, 0.70284933E-06_JPRB, &
  & 0.71972408E-06_JPRB, 0.74010681E-06_JPRB, 0.76334216E-06_JPRB, 0.79026071E-06_JPRB, 0.82234152E-06_JPRB, 0.85526385E-06_JPRB, &
  & 0.88779387E-06_JPRB, 0.91645564E-06_JPRB, 0.94192336E-06_JPRB, 0.96321188E-06_JPRB, 0.98517145E-06_JPRB, 0.10048575E-05_JPRB, &
  & 0.10261725E-05_JPRB, 0.10547724E-05_JPRB, 0.10841933E-05_JPRB, 0.11210753E-05_JPRB, 0.11806749E-05_JPRB, 0.12699184E-05_JPRB, &
  & 0.13821291E-05_JPRB, 0.14555743E-05_JPRB, 0.15236456E-05_JPRB, 0.15887418E-05_JPRB, 0.16290193E-05_JPRB, 0.16452387E-05_JPRB, &
  & 0.16331479E-05_JPRB, 0.15890141E-05_JPRB, 0.15077213E-05_JPRB, 0.14024454E-05_JPRB, 0.12990813E-05_JPRB, 0.12010853E-05_JPRB, &
  & 0.10978567E-05_JPRB, 0.99066904E-06_JPRB, 0.88921842E-06_JPRB, 0.79634809E-06_JPRB, 0.74234757E-06_JPRB, 0.71244623E-06_JPRB, &
  & 0.67104346E-06_JPRB, 0.61071130E-06_JPRB, 0.55377258E-06_JPRB, 0.49890151E-06_JPRB, 0.45561523E-06_JPRB, 0.42734465E-06_JPRB, &
  & 0.40143754E-06_JPRB, 0.39020619E-06_JPRB, 0.38574608E-06_JPRB, 0.38085995E-06_JPRB, 0.38047518E-06_JPRB, 0.39008677E-06_JPRB, &
  & 0.40375093E-06_JPRB, 0.41718410E-06_JPRB, 0.43457198E-06_JPRB, 0.45594045E-06_JPRB, 0.47864868E-06_JPRB, 0.49601505E-06_JPRB, &
  & 0.50248361E-06_JPRB, 0.50511959E-06_JPRB, 0.50643279E-06_JPRB, 0.50349272E-06_JPRB  /)

RGHG2(:,22, 5) = (/ &
  & 0.74949192E-06_JPRB, 0.75113671E-06_JPRB, 0.75492686E-06_JPRB, 0.76188100E-06_JPRB, 0.77214042E-06_JPRB, 0.78545947E-06_JPRB, &
  & 0.80111092E-06_JPRB, 0.81979249E-06_JPRB, 0.84105909E-06_JPRB, 0.86539723E-06_JPRB, 0.89440067E-06_JPRB, 0.92334727E-06_JPRB, &
  & 0.95111788E-06_JPRB, 0.97364401E-06_JPRB, 0.99314813E-06_JPRB, 0.10101933E-05_JPRB, 0.10261702E-05_JPRB, 0.10391472E-05_JPRB, &
  & 0.10567158E-05_JPRB, 0.10847040E-05_JPRB, 0.11120415E-05_JPRB, 0.11440877E-05_JPRB, 0.11995969E-05_JPRB, 0.12917457E-05_JPRB, &
  & 0.13997130E-05_JPRB, 0.14704249E-05_JPRB, 0.15420132E-05_JPRB, 0.16084474E-05_JPRB, 0.16492410E-05_JPRB, 0.16644473E-05_JPRB, &
  & 0.16519552E-05_JPRB, 0.16083566E-05_JPRB, 0.15281150E-05_JPRB, 0.14227436E-05_JPRB, 0.13167608E-05_JPRB, 0.12192045E-05_JPRB, &
  & 0.11155553E-05_JPRB, 0.10077178E-05_JPRB, 0.90917251E-06_JPRB, 0.81878701E-06_JPRB, 0.76019911E-06_JPRB, 0.72580595E-06_JPRB, &
  & 0.68163163E-06_JPRB, 0.62798941E-06_JPRB, 0.58586413E-06_JPRB, 0.54297761E-06_JPRB, 0.50490947E-06_JPRB, 0.47442166E-06_JPRB, &
  & 0.44646934E-06_JPRB, 0.43579230E-06_JPRB, 0.43219233E-06_JPRB, 0.42656074E-06_JPRB, 0.42671117E-06_JPRB, 0.43601693E-06_JPRB, &
  & 0.44767412E-06_JPRB, 0.45902384E-06_JPRB, 0.47086863E-06_JPRB, 0.48482083E-06_JPRB, 0.50456637E-06_JPRB, 0.52156957E-06_JPRB, &
  & 0.52601203E-06_JPRB, 0.52587647E-06_JPRB, 0.52806892E-06_JPRB, 0.53032789E-06_JPRB  /)

RGHG2(:,23, 5) = (/ &
  & 0.81712524E-06_JPRB, 0.81899339E-06_JPRB, 0.82300314E-06_JPRB, 0.83012089E-06_JPRB, 0.84092634E-06_JPRB, 0.85525845E-06_JPRB, &
  & 0.87182124E-06_JPRB, 0.89129951E-06_JPRB, 0.91325664E-06_JPRB, 0.93791231E-06_JPRB, 0.96555038E-06_JPRB, 0.99309123E-06_JPRB, &
  & 0.10181058E-05_JPRB, 0.10374776E-05_JPRB, 0.10528889E-05_JPRB, 0.10667800E-05_JPRB, 0.10782665E-05_JPRB, 0.10881463E-05_JPRB, &
  & 0.11046847E-05_JPRB, 0.11334251E-05_JPRB, 0.11584904E-05_JPRB, 0.11874222E-05_JPRB, 0.12412847E-05_JPRB, 0.13330158E-05_JPRB, &
  & 0.14313517E-05_JPRB, 0.14976505E-05_JPRB, 0.15694068E-05_JPRB, 0.16302138E-05_JPRB, 0.16643602E-05_JPRB, 0.16732640E-05_JPRB, &
  & 0.16565302E-05_JPRB, 0.16104830E-05_JPRB, 0.15331576E-05_JPRB, 0.14355299E-05_JPRB, 0.13353645E-05_JPRB, 0.12417197E-05_JPRB, &
  & 0.11410186E-05_JPRB, 0.10355102E-05_JPRB, 0.93937527E-06_JPRB, 0.84911762E-06_JPRB, 0.78709364E-06_JPRB, 0.74596051E-06_JPRB, &
  & 0.69989269E-06_JPRB, 0.65284272E-06_JPRB, 0.61702356E-06_JPRB, 0.58289179E-06_JPRB, 0.55144779E-06_JPRB, 0.52448102E-06_JPRB, &
  & 0.50000832E-06_JPRB, 0.48971302E-06_JPRB, 0.48541929E-06_JPRB, 0.47862418E-06_JPRB, 0.48024895E-06_JPRB, 0.48702666E-06_JPRB, &
  & 0.49465655E-06_JPRB, 0.50225927E-06_JPRB, 0.50882697E-06_JPRB, 0.51779284E-06_JPRB, 0.53241512E-06_JPRB, 0.54674697E-06_JPRB, &
  & 0.55064190E-06_JPRB, 0.54940348E-06_JPRB, 0.55082830E-06_JPRB, 0.55265418E-06_JPRB  /)

RGHG2(:,24, 5) = (/ &
  & 0.88112423E-06_JPRB, 0.88301330E-06_JPRB, 0.88732575E-06_JPRB, 0.89498345E-06_JPRB, 0.90689709E-06_JPRB, 0.92293168E-06_JPRB, &
  & 0.94120578E-06_JPRB, 0.96229744E-06_JPRB, 0.98572332E-06_JPRB, 0.10114649E-05_JPRB, 0.10384341E-05_JPRB, 0.10649710E-05_JPRB, &
  & 0.10881109E-05_JPRB, 0.11057205E-05_JPRB, 0.11182114E-05_JPRB, 0.11293245E-05_JPRB, 0.11375063E-05_JPRB, 0.11454400E-05_JPRB, &
  & 0.11615865E-05_JPRB, 0.11910112E-05_JPRB, 0.12141575E-05_JPRB, 0.12408814E-05_JPRB, 0.12929205E-05_JPRB, 0.13817098E-05_JPRB, &
  & 0.14687582E-05_JPRB, 0.15298799E-05_JPRB, 0.15986223E-05_JPRB, 0.16517702E-05_JPRB, 0.16778451E-05_JPRB, 0.16800643E-05_JPRB, &
  & 0.16586857E-05_JPRB, 0.16107718E-05_JPRB, 0.15379387E-05_JPRB, 0.14496014E-05_JPRB, 0.13570733E-05_JPRB, 0.12677630E-05_JPRB, &
  & 0.11708983E-05_JPRB, 0.10689640E-05_JPRB, 0.97462728E-06_JPRB, 0.88456671E-06_JPRB, 0.81959242E-06_JPRB, 0.77155149E-06_JPRB, &
  & 0.72398172E-06_JPRB, 0.68234009E-06_JPRB, 0.65101410E-06_JPRB, 0.62429157E-06_JPRB, 0.59997242E-06_JPRB, 0.57857829E-06_JPRB, &
  & 0.55816275E-06_JPRB, 0.54889605E-06_JPRB, 0.54358443E-06_JPRB, 0.53624199E-06_JPRB, 0.53893781E-06_JPRB, 0.54273295E-06_JPRB, &
  & 0.54590673E-06_JPRB, 0.54914032E-06_JPRB, 0.55101393E-06_JPRB, 0.55567685E-06_JPRB, 0.56542772E-06_JPRB, 0.57613112E-06_JPRB, &
  & 0.57995238E-06_JPRB, 0.57817651E-06_JPRB, 0.57772113E-06_JPRB, 0.57837398E-06_JPRB  /)

RGHG2(:,25, 5) = (/ &
  & 0.93967474E-06_JPRB, 0.94125651E-06_JPRB, 0.94590860E-06_JPRB, 0.95455289E-06_JPRB, 0.96821328E-06_JPRB, 0.98667389E-06_JPRB, &
  & 0.10075196E-05_JPRB, 0.10310373E-05_JPRB, 0.10566466E-05_JPRB, 0.10841349E-05_JPRB, 0.11113144E-05_JPRB, 0.11370264E-05_JPRB, &
  & 0.11594870E-05_JPRB, 0.11772099E-05_JPRB, 0.11885686E-05_JPRB, 0.11974497E-05_JPRB, 0.12042406E-05_JPRB, 0.12115436E-05_JPRB, &
  & 0.12278356E-05_JPRB, 0.12574867E-05_JPRB, 0.12794685E-05_JPRB, 0.13053029E-05_JPRB, 0.13547380E-05_JPRB, 0.14369932E-05_JPRB, &
  & 0.15115395E-05_JPRB, 0.15667417E-05_JPRB, 0.16277208E-05_JPRB, 0.16715203E-05_JPRB, 0.16889748E-05_JPRB, 0.16853230E-05_JPRB, &
  & 0.16596584E-05_JPRB, 0.16116636E-05_JPRB, 0.15454940E-05_JPRB, 0.14670064E-05_JPRB, 0.13830988E-05_JPRB, 0.12978966E-05_JPRB, &
  & 0.12055119E-05_JPRB, 0.11085268E-05_JPRB, 0.10149340E-05_JPRB, 0.92571448E-06_JPRB, 0.85852441E-06_JPRB, 0.80409494E-06_JPRB, &
  & 0.75558710E-06_JPRB, 0.71703462E-06_JPRB, 0.68870073E-06_JPRB, 0.66739634E-06_JPRB, 0.65045232E-06_JPRB, 0.63672445E-06_JPRB, &
  & 0.61996414E-06_JPRB, 0.61286469E-06_JPRB, 0.60635623E-06_JPRB, 0.59967690E-06_JPRB, 0.60246976E-06_JPRB, 0.60311107E-06_JPRB, &
  & 0.60172390E-06_JPRB, 0.60005691E-06_JPRB, 0.59842086E-06_JPRB, 0.59963882E-06_JPRB, 0.60566978E-06_JPRB, 0.61173137E-06_JPRB, &
  & 0.61598931E-06_JPRB, 0.61432666E-06_JPRB, 0.61047483E-06_JPRB, 0.60996319E-06_JPRB  /)

RGHG2(:,26, 5) = (/ &
  & 0.99589727E-06_JPRB, 0.99737728E-06_JPRB, 0.10021503E-05_JPRB, 0.10117454E-05_JPRB, 0.10270458E-05_JPRB, 0.10478144E-05_JPRB, &
  & 0.10711873E-05_JPRB, 0.10965974E-05_JPRB, 0.11236946E-05_JPRB, 0.11524074E-05_JPRB, 0.11795993E-05_JPRB, 0.12040193E-05_JPRB, &
  & 0.12260783E-05_JPRB, 0.12444061E-05_JPRB, 0.12564914E-05_JPRB, 0.12647881E-05_JPRB, 0.12708526E-05_JPRB, 0.12780437E-05_JPRB, &
  & 0.12940223E-05_JPRB, 0.13231253E-05_JPRB, 0.13455268E-05_JPRB, 0.13694448E-05_JPRB, 0.14127961E-05_JPRB, 0.14833357E-05_JPRB, &
  & 0.15481733E-05_JPRB, 0.15979154E-05_JPRB, 0.16488282E-05_JPRB, 0.16838726E-05_JPRB, 0.16965876E-05_JPRB, 0.16909513E-05_JPRB, &
  & 0.16649317E-05_JPRB, 0.16190575E-05_JPRB, 0.15589156E-05_JPRB, 0.14883342E-05_JPRB, 0.14113823E-05_JPRB, 0.13301431E-05_JPRB, &
  & 0.12421704E-05_JPRB, 0.11505298E-05_JPRB, 0.10596144E-05_JPRB, 0.97396073E-06_JPRB, 0.90577503E-06_JPRB, 0.84764859E-06_JPRB, &
  & 0.79850093E-06_JPRB, 0.76115143E-06_JPRB, 0.73617937E-06_JPRB, 0.71943667E-06_JPRB, 0.70634135E-06_JPRB, 0.69551553E-06_JPRB, &
  & 0.68143825E-06_JPRB, 0.67574793E-06_JPRB, 0.66953347E-06_JPRB, 0.66406128E-06_JPRB, 0.66612305E-06_JPRB, 0.66444698E-06_JPRB, &
  & 0.66039537E-06_JPRB, 0.65490953E-06_JPRB, 0.65008514E-06_JPRB, 0.64930375E-06_JPRB, 0.65256014E-06_JPRB, 0.65544599E-06_JPRB, &
  & 0.65905111E-06_JPRB, 0.65724761E-06_JPRB, 0.65311393E-06_JPRB, 0.65292606E-06_JPRB  /)

RGHG2(:,27, 5) = (/ &
  & 0.10538160E-05_JPRB, 0.10552658E-05_JPRB, 0.10600840E-05_JPRB, 0.10706601E-05_JPRB, 0.10876355E-05_JPRB, 0.11107734E-05_JPRB, &
  & 0.11367721E-05_JPRB, 0.11639629E-05_JPRB, 0.11923579E-05_JPRB, 0.12221573E-05_JPRB, 0.12492888E-05_JPRB, 0.12721846E-05_JPRB, &
  & 0.12939267E-05_JPRB, 0.13130694E-05_JPRB, 0.13266034E-05_JPRB, 0.13349002E-05_JPRB, 0.13404515E-05_JPRB, 0.13477181E-05_JPRB, &
  & 0.13631986E-05_JPRB, 0.13914415E-05_JPRB, 0.14148692E-05_JPRB, 0.14364028E-05_JPRB, 0.14721032E-05_JPRB, 0.15284725E-05_JPRB, &
  & 0.15841953E-05_JPRB, 0.16283991E-05_JPRB, 0.16679334E-05_JPRB, 0.16940441E-05_JPRB, 0.17032430E-05_JPRB, 0.16969729E-05_JPRB, &
  & 0.16720398E-05_JPRB, 0.16291988E-05_JPRB, 0.15751235E-05_JPRB, 0.15120874E-05_JPRB, 0.14417905E-05_JPRB, 0.13646409E-05_JPRB, &
  & 0.12812558E-05_JPRB, 0.11953497E-05_JPRB, 0.11079505E-05_JPRB, 0.10270353E-05_JPRB, 0.95826104E-06_JPRB, 0.89726736E-06_JPRB, &
  & 0.84756134E-06_JPRB, 0.81077019E-06_JPRB, 0.78945010E-06_JPRB, 0.77715917E-06_JPRB, 0.76678019E-06_JPRB, 0.75722199E-06_JPRB, &
  & 0.74558942E-06_JPRB, 0.74109127E-06_JPRB, 0.73573698E-06_JPRB, 0.73172859E-06_JPRB, 0.73271891E-06_JPRB, 0.72893014E-06_JPRB, &
  & 0.72279601E-06_JPRB, 0.71371856E-06_JPRB, 0.70567985E-06_JPRB, 0.70334410E-06_JPRB, 0.70405016E-06_JPRB, 0.70415931E-06_JPRB, &
  & 0.70667789E-06_JPRB, 0.70463294E-06_JPRB, 0.70135944E-06_JPRB, 0.70206192E-06_JPRB  /)

RGHG2(:,28, 5) = (/ &
  & 0.11106203E-05_JPRB, 0.11129828E-05_JPRB, 0.11180282E-05_JPRB, 0.11285051E-05_JPRB, 0.11458343E-05_JPRB, 0.11699666E-05_JPRB, &
  & 0.11966820E-05_JPRB, 0.12236674E-05_JPRB, 0.12518005E-05_JPRB, 0.12811668E-05_JPRB, 0.13069815E-05_JPRB, 0.13283652E-05_JPRB, &
  & 0.13493437E-05_JPRB, 0.13690442E-05_JPRB, 0.13834238E-05_JPRB, 0.13924717E-05_JPRB, 0.13988918E-05_JPRB, 0.14079015E-05_JPRB, &
  & 0.14230620E-05_JPRB, 0.14476030E-05_JPRB, 0.14692808E-05_JPRB, 0.14876410E-05_JPRB, 0.15160801E-05_JPRB, 0.15586724E-05_JPRB, &
  & 0.16042596E-05_JPRB, 0.16441019E-05_JPRB, 0.16769546E-05_JPRB, 0.16983324E-05_JPRB, 0.17069173E-05_JPRB, 0.17029508E-05_JPRB, &
  & 0.16824797E-05_JPRB, 0.16439016E-05_JPRB, 0.15937954E-05_JPRB, 0.15354877E-05_JPRB, 0.14713613E-05_JPRB, 0.14017962E-05_JPRB, &
  & 0.13257022E-05_JPRB, 0.12468819E-05_JPRB, 0.11675203E-05_JPRB, 0.10927755E-05_JPRB, 0.10253176E-05_JPRB, 0.96752871E-06_JPRB, &
  & 0.92136863E-06_JPRB, 0.88602659E-06_JPRB, 0.86545097E-06_JPRB, 0.85093142E-06_JPRB, 0.83692858E-06_JPRB, 0.82341417E-06_JPRB, &
  & 0.81126427E-06_JPRB, 0.80588659E-06_JPRB, 0.79982750E-06_JPRB, 0.79620215E-06_JPRB, 0.79627403E-06_JPRB, 0.79168862E-06_JPRB, &
  & 0.78484668E-06_JPRB, 0.77535262E-06_JPRB, 0.76593565E-06_JPRB, 0.76088480E-06_JPRB, 0.76041397E-06_JPRB, 0.75962528E-06_JPRB, &
  & 0.76059887E-06_JPRB, 0.76061005E-06_JPRB, 0.76033734E-06_JPRB, 0.75999821E-06_JPRB  /)

RGHG2(:,29, 5) = (/ &
  & 0.11707608E-05_JPRB, 0.11741313E-05_JPRB, 0.11794252E-05_JPRB, 0.11897502E-05_JPRB, 0.12073971E-05_JPRB, 0.12325235E-05_JPRB, &
  & 0.12599154E-05_JPRB, 0.12865971E-05_JPRB, 0.13143850E-05_JPRB, 0.13432267E-05_JPRB, 0.13675915E-05_JPRB, 0.13873735E-05_JPRB, &
  & 0.14075236E-05_JPRB, 0.14278040E-05_JPRB, 0.14430535E-05_JPRB, 0.14529299E-05_JPRB, 0.14603303E-05_JPRB, 0.14712592E-05_JPRB, &
  & 0.14860883E-05_JPRB, 0.15065837E-05_JPRB, 0.15262870E-05_JPRB, 0.15412506E-05_JPRB, 0.15620126E-05_JPRB, 0.15900241E-05_JPRB, &
  & 0.16248275E-05_JPRB, 0.16600995E-05_JPRB, 0.16860759E-05_JPRB, 0.17026212E-05_JPRB, 0.17106814E-05_JPRB, 0.17092831E-05_JPRB, &
  & 0.16936860E-05_JPRB, 0.16596783E-05_JPRB, 0.16136868E-05_JPRB, 0.15602670E-05_JPRB, 0.15026578E-05_JPRB, 0.14412806E-05_JPRB, &
  & 0.13730293E-05_JPRB, 0.13017756E-05_JPRB, 0.12311266E-05_JPRB, 0.11629818E-05_JPRB, 0.10970013E-05_JPRB, 0.10428715E-05_JPRB, &
  & 0.10006466E-05_JPRB, 0.96687859E-06_JPRB, 0.94696574E-06_JPRB, 0.92979512E-06_JPRB, 0.91167761E-06_JPRB, 0.89374476E-06_JPRB, &
  & 0.88091829E-06_JPRB, 0.87451884E-06_JPRB, 0.86764510E-06_JPRB, 0.86437875E-06_JPRB, 0.86348409E-06_JPRB, 0.85811165E-06_JPRB, &
  & 0.85057933E-06_JPRB, 0.84078151E-06_JPRB, 0.82998378E-06_JPRB, 0.82200570E-06_JPRB, 0.82034742E-06_JPRB, 0.81868885E-06_JPRB, &
  & 0.81800552E-06_JPRB, 0.82029496E-06_JPRB, 0.82329466E-06_JPRB, 0.82176807E-06_JPRB  /)

RGHG2(:,30, 5) = (/ &
  & 0.12312830E-05_JPRB, 0.12354914E-05_JPRB, 0.12408462E-05_JPRB, 0.12499641E-05_JPRB, 0.12661920E-05_JPRB, 0.12899002E-05_JPRB, &
  & 0.13150488E-05_JPRB, 0.13398439E-05_JPRB, 0.13660547E-05_JPRB, 0.13924942E-05_JPRB, 0.14146258E-05_JPRB, 0.14332905E-05_JPRB, &
  & 0.14521965E-05_JPRB, 0.14716223E-05_JPRB, 0.14863207E-05_JPRB, 0.14966102E-05_JPRB, 0.15056004E-05_JPRB, 0.15168950E-05_JPRB, &
  & 0.15306261E-05_JPRB, 0.15488981E-05_JPRB, 0.15669621E-05_JPRB, 0.15810735E-05_JPRB, 0.15978562E-05_JPRB, 0.16184553E-05_JPRB, &
  & 0.16437394E-05_JPRB, 0.16705285E-05_JPRB, 0.16913436E-05_JPRB, 0.17052462E-05_JPRB, 0.17131301E-05_JPRB, 0.17135111E-05_JPRB, &
  & 0.17013330E-05_JPRB, 0.16713383E-05_JPRB, 0.16294867E-05_JPRB, 0.15823363E-05_JPRB, 0.15342973E-05_JPRB, 0.14843052E-05_JPRB, &
  & 0.14276934E-05_JPRB, 0.13670601E-05_JPRB, 0.13066565E-05_JPRB, 0.12480576E-05_JPRB, 0.11909696E-05_JPRB, 0.11426896E-05_JPRB, &
  & 0.11019905E-05_JPRB, 0.10666896E-05_JPRB, 0.10410642E-05_JPRB, 0.10166740E-05_JPRB, 0.99214217E-06_JPRB, 0.96905625E-06_JPRB, &
  & 0.95272974E-06_JPRB, 0.94403685E-06_JPRB, 0.93536111E-06_JPRB, 0.93033626E-06_JPRB, 0.92758488E-06_JPRB, 0.92098662E-06_JPRB, &
  & 0.91354465E-06_JPRB, 0.90432272E-06_JPRB, 0.89441528E-06_JPRB, 0.88571892E-06_JPRB, 0.88097254E-06_JPRB, 0.87850049E-06_JPRB, &
  & 0.87703937E-06_JPRB, 0.87885780E-06_JPRB, 0.88161178E-06_JPRB, 0.87995070E-06_JPRB  /)

RGHG2(:,31, 5) = (/ &
  & 0.12950528E-05_JPRB, 0.13001438E-05_JPRB, 0.13055626E-05_JPRB, 0.13134077E-05_JPRB, 0.13281390E-05_JPRB, 0.13503505E-05_JPRB, &
  & 0.13731325E-05_JPRB, 0.13959385E-05_JPRB, 0.14204863E-05_JPRB, 0.14443929E-05_JPRB, 0.14641708E-05_JPRB, 0.14816586E-05_JPRB, &
  & 0.14992534E-05_JPRB, 0.15177774E-05_JPRB, 0.15318937E-05_JPRB, 0.15426182E-05_JPRB, 0.15532842E-05_JPRB, 0.15649625E-05_JPRB, &
  & 0.15775359E-05_JPRB, 0.15934669E-05_JPRB, 0.16098040E-05_JPRB, 0.16230200E-05_JPRB, 0.16356132E-05_JPRB, 0.16484092E-05_JPRB, &
  & 0.16636643E-05_JPRB, 0.16815118E-05_JPRB, 0.16968902E-05_JPRB, 0.17080106E-05_JPRB, 0.17157089E-05_JPRB, 0.17179640E-05_JPRB, &
  & 0.17093869E-05_JPRB, 0.16836199E-05_JPRB, 0.16461304E-05_JPRB, 0.16055872E-05_JPRB, 0.15676347E-05_JPRB, 0.15296416E-05_JPRB, &
  & 0.14852974E-05_JPRB, 0.14358571E-05_JPRB, 0.13862501E-05_JPRB, 0.13377122E-05_JPRB, 0.12900008E-05_JPRB, 0.12478866E-05_JPRB, &
  & 0.12087929E-05_JPRB, 0.11718737E-05_JPRB, 0.11402233E-05_JPRB, 0.11082218E-05_JPRB, 0.10769294E-05_JPRB, 0.10484132E-05_JPRB, &
  & 0.10283962E-05_JPRB, 0.10172856E-05_JPRB, 0.10067102E-05_JPRB, 0.99983051E-06_JPRB, 0.99512194E-06_JPRB, 0.98723169E-06_JPRB, &
  & 0.97988566E-06_JPRB, 0.97127135E-06_JPRB, 0.96230413E-06_JPRB, 0.95285303E-06_JPRB, 0.94485107E-06_JPRB, 0.94152195E-06_JPRB, &
  & 0.93924214E-06_JPRB, 0.94056167E-06_JPRB, 0.94305342E-06_JPRB, 0.94125162E-06_JPRB  /)

RGHG2(:,32, 5) = (/ &
  & 0.13565578E-05_JPRB, 0.13617363E-05_JPRB, 0.13661993E-05_JPRB, 0.13725082E-05_JPRB, 0.13848597E-05_JPRB, 0.14034403E-05_JPRB, &
  & 0.14231901E-05_JPRB, 0.14434846E-05_JPRB, 0.14652481E-05_JPRB, 0.14859033E-05_JPRB, 0.15034897E-05_JPRB, 0.15196011E-05_JPRB, &
  & 0.15357120E-05_JPRB, 0.15523650E-05_JPRB, 0.15652480E-05_JPRB, 0.15760464E-05_JPRB, 0.15866818E-05_JPRB, 0.15980577E-05_JPRB, &
  & 0.16101064E-05_JPRB, 0.16242592E-05_JPRB, 0.16387935E-05_JPRB, 0.16508033E-05_JPRB, 0.16617019E-05_JPRB, 0.16719189E-05_JPRB, &
  & 0.16827935E-05_JPRB, 0.16947386E-05_JPRB, 0.17050096E-05_JPRB, 0.17126553E-05_JPRB, 0.17184847E-05_JPRB, 0.17205561E-05_JPRB, &
  & 0.17137937E-05_JPRB, 0.16922692E-05_JPRB, 0.16608184E-05_JPRB, 0.16281998E-05_JPRB, 0.15990518E-05_JPRB, 0.15708781E-05_JPRB, &
  & 0.15383551E-05_JPRB, 0.15018115E-05_JPRB, 0.14642179E-05_JPRB, 0.14252848E-05_JPRB, 0.13852797E-05_JPRB, 0.13465362E-05_JPRB, &
  & 0.13074504E-05_JPRB, 0.12681226E-05_JPRB, 0.12311915E-05_JPRB, 0.11939652E-05_JPRB, 0.11582734E-05_JPRB, 0.11266328E-05_JPRB, &
  & 0.11034112E-05_JPRB, 0.10890568E-05_JPRB, 0.10771949E-05_JPRB, 0.10681584E-05_JPRB, 0.10604579E-05_JPRB, 0.10507460E-05_JPRB, &
  & 0.10429163E-05_JPRB, 0.10346422E-05_JPRB, 0.10262683E-05_JPRB, 0.10171609E-05_JPRB, 0.10077428E-05_JPRB, 0.10015281E-05_JPRB, &
  & 0.99686131E-06_JPRB, 0.99638017E-06_JPRB, 0.99663407E-06_JPRB, 0.99477034E-06_JPRB  /)

RGHG2(:,33, 5) = (/ &
  & 0.14201835E-05_JPRB, 0.14253499E-05_JPRB, 0.14286877E-05_JPRB, 0.14333658E-05_JPRB, 0.14431299E-05_JPRB, 0.14576608E-05_JPRB, &
  & 0.14741732E-05_JPRB, 0.14917900E-05_JPRB, 0.15105147E-05_JPRB, 0.15276979E-05_JPRB, 0.15430278E-05_JPRB, 0.15576829E-05_JPRB, &
  & 0.15722293E-05_JPRB, 0.15868123E-05_JPRB, 0.15983294E-05_JPRB, 0.16091579E-05_JPRB, 0.16195406E-05_JPRB, 0.16305133E-05_JPRB, &
  & 0.16420987E-05_JPRB, 0.16544763E-05_JPRB, 0.16671271E-05_JPRB, 0.16778432E-05_JPRB, 0.16873036E-05_JPRB, 0.16955169E-05_JPRB, &
  & 0.17025704E-05_JPRB, 0.17087749E-05_JPRB, 0.17137807E-05_JPRB, 0.17177257E-05_JPRB, 0.17213949E-05_JPRB, 0.17230090E-05_JPRB, &
  & 0.17179014E-05_JPRB, 0.17007876E-05_JPRB, 0.16758296E-05_JPRB, 0.16516172E-05_JPRB, 0.16314532E-05_JPRB, 0.16132022E-05_JPRB, &
  & 0.15929066E-05_JPRB, 0.15699863E-05_JPRB, 0.15450352E-05_JPRB, 0.15160248E-05_JPRB, 0.14838123E-05_JPRB, 0.14482098E-05_JPRB, &
  & 0.14089255E-05_JPRB, 0.13669921E-05_JPRB, 0.13246694E-05_JPRB, 0.12823223E-05_JPRB, 0.12423642E-05_JPRB, 0.12077751E-05_JPRB, &
  & 0.11812861E-05_JPRB, 0.11634536E-05_JPRB, 0.11503341E-05_JPRB, 0.11390170E-05_JPRB, 0.11280731E-05_JPRB, 0.11163995E-05_JPRB, &
  & 0.11079922E-05_JPRB, 0.11000370E-05_JPRB, 0.10922347E-05_JPRB, 0.10836268E-05_JPRB, 0.10729751E-05_JPRB, 0.10634990E-05_JPRB, &
  & 0.10561484E-05_JPRB, 0.10536274E-05_JPRB, 0.10512998E-05_JPRB, 0.10493820E-05_JPRB  /)

RGHG2(:,34, 5) = (/ &
  & 0.14754221E-05_JPRB, 0.14796752E-05_JPRB, 0.14820261E-05_JPRB, 0.14853353E-05_JPRB, 0.14924736E-05_JPRB, 0.15033811E-05_JPRB, &
  & 0.15172144E-05_JPRB, 0.15321645E-05_JPRB, 0.15476747E-05_JPRB, 0.15617710E-05_JPRB, 0.15750599E-05_JPRB, 0.15880239E-05_JPRB, &
  & 0.16008719E-05_JPRB, 0.16136898E-05_JPRB, 0.16242159E-05_JPRB, 0.16343443E-05_JPRB, 0.16439509E-05_JPRB, 0.16542279E-05_JPRB, &
  & 0.16647859E-05_JPRB, 0.16753734E-05_JPRB, 0.16860639E-05_JPRB, 0.16951030E-05_JPRB, 0.17027405E-05_JPRB, 0.17090404E-05_JPRB, &
  & 0.17138002E-05_JPRB, 0.17171805E-05_JPRB, 0.17196327E-05_JPRB, 0.17215884E-05_JPRB, 0.17235964E-05_JPRB, 0.17243482E-05_JPRB, &
  & 0.17202516E-05_JPRB, 0.17070481E-05_JPRB, 0.16884071E-05_JPRB, 0.16713699E-05_JPRB, 0.16579937E-05_JPRB, 0.16464808E-05_JPRB, &
  & 0.16338752E-05_JPRB, 0.16193018E-05_JPRB, 0.16022226E-05_JPRB, 0.15803958E-05_JPRB, 0.15539223E-05_JPRB, 0.15223797E-05_JPRB, &
  & 0.14858841E-05_JPRB, 0.14448766E-05_JPRB, 0.14013602E-05_JPRB, 0.13573264E-05_JPRB, 0.13151002E-05_JPRB, 0.12790584E-05_JPRB, &
  & 0.12514670E-05_JPRB, 0.12318608E-05_JPRB, 0.12172067E-05_JPRB, 0.12043767E-05_JPRB, 0.11913929E-05_JPRB, 0.11781751E-05_JPRB, &
  & 0.11683183E-05_JPRB, 0.11596976E-05_JPRB, 0.11518610E-05_JPRB, 0.11435172E-05_JPRB, 0.11324983E-05_JPRB, 0.11212517E-05_JPRB, &
  & 0.11121164E-05_JPRB, 0.11074743E-05_JPRB, 0.11034504E-05_JPRB, 0.11007501E-05_JPRB  /)

RGHG2(:,35, 5) = (/ &
  & 0.15279110E-05_JPRB, 0.15307625E-05_JPRB, 0.15321697E-05_JPRB, 0.15342059E-05_JPRB, 0.15386248E-05_JPRB, 0.15460257E-05_JPRB, &
  & 0.15573910E-05_JPRB, 0.15696050E-05_JPRB, 0.15817203E-05_JPRB, 0.15928405E-05_JPRB, 0.16041415E-05_JPRB, 0.16152461E-05_JPRB, &
  & 0.16262794E-05_JPRB, 0.16374389E-05_JPRB, 0.16471387E-05_JPRB, 0.16561726E-05_JPRB, 0.16647127E-05_JPRB, 0.16741242E-05_JPRB, &
  & 0.16833365E-05_JPRB, 0.16920758E-05_JPRB, 0.17007115E-05_JPRB, 0.17078298E-05_JPRB, 0.17133957E-05_JPRB, 0.17177747E-05_JPRB, &
  & 0.17209599E-05_JPRB, 0.17229331E-05_JPRB, 0.17241513E-05_JPRB, 0.17249400E-05_JPRB, 0.17254962E-05_JPRB, 0.17251535E-05_JPRB, &
  & 0.17217661E-05_JPRB, 0.17123261E-05_JPRB, 0.17000897E-05_JPRB, 0.16897977E-05_JPRB, 0.16822732E-05_JPRB, 0.16760537E-05_JPRB, &
  & 0.16690264E-05_JPRB, 0.16603271E-05_JPRB, 0.16488931E-05_JPRB, 0.16330465E-05_JPRB, 0.16114197E-05_JPRB, 0.15845229E-05_JPRB, &
  & 0.15524273E-05_JPRB, 0.15141838E-05_JPRB, 0.14715943E-05_JPRB, 0.14275884E-05_JPRB, 0.13840555E-05_JPRB, 0.13472879E-05_JPRB, &
  & 0.13196742E-05_JPRB, 0.12991187E-05_JPRB, 0.12827448E-05_JPRB, 0.12687534E-05_JPRB, 0.12542899E-05_JPRB, 0.12396984E-05_JPRB, &
  & 0.12279041E-05_JPRB, 0.12180941E-05_JPRB, 0.12099113E-05_JPRB, 0.12017182E-05_JPRB, 0.11907663E-05_JPRB, 0.11784644E-05_JPRB, &
  & 0.11679554E-05_JPRB, 0.11610910E-05_JPRB, 0.11557773E-05_JPRB, 0.11518988E-05_JPRB  /)

RGHG2(:,36, 5) = (/ &
  & 0.15755759E-05_JPRB, 0.15771313E-05_JPRB, 0.15776829E-05_JPRB, 0.15786647E-05_JPRB, 0.15807652E-05_JPRB, 0.15851684E-05_JPRB, &
  & 0.15940872E-05_JPRB, 0.16037563E-05_JPRB, 0.16128000E-05_JPRB, 0.16212662E-05_JPRB, 0.16306347E-05_JPRB, 0.16399394E-05_JPRB, &
  & 0.16491918E-05_JPRB, 0.16587538E-05_JPRB, 0.16675591E-05_JPRB, 0.16754701E-05_JPRB, 0.16829358E-05_JPRB, 0.16912631E-05_JPRB, &
  & 0.16990329E-05_JPRB, 0.17060034E-05_JPRB, 0.17126861E-05_JPRB, 0.17179984E-05_JPRB, 0.17217574E-05_JPRB, 0.17245115E-05_JPRB, &
  & 0.17263606E-05_JPRB, 0.17271851E-05_JPRB, 0.17274134E-05_JPRB, 0.17272854E-05_JPRB, 0.17267554E-05_JPRB, 0.17256288E-05_JPRB, &
  & 0.17229346E-05_JPRB, 0.17167910E-05_JPRB, 0.17098092E-05_JPRB, 0.17047815E-05_JPRB, 0.17017276E-05_JPRB, 0.16995561E-05_JPRB, &
  & 0.16968123E-05_JPRB, 0.16926865E-05_JPRB, 0.16859083E-05_JPRB, 0.16752299E-05_JPRB, 0.16583001E-05_JPRB, 0.16361819E-05_JPRB, &
  & 0.16087089E-05_JPRB, 0.15741343E-05_JPRB, 0.15337616E-05_JPRB, 0.14909323E-05_JPRB, 0.14473194E-05_JPRB, 0.14104347E-05_JPRB, &
  & 0.13830836E-05_JPRB, 0.13620091E-05_JPRB, 0.13444139E-05_JPRB, 0.13295671E-05_JPRB, 0.13143016E-05_JPRB, 0.12989515E-05_JPRB, &
  & 0.12855889E-05_JPRB, 0.12746668E-05_JPRB, 0.12659136E-05_JPRB, 0.12576592E-05_JPRB, 0.12469128E-05_JPRB, 0.12340525E-05_JPRB, &
  & 0.12227227E-05_JPRB, 0.12140497E-05_JPRB, 0.12079450E-05_JPRB, 0.12028913E-05_JPRB  /)

RGHG2(:,37, 5) = (/ &
  & 0.16092157E-05_JPRB, 0.16097968E-05_JPRB, 0.16097479E-05_JPRB, 0.16102426E-05_JPRB, 0.16110879E-05_JPRB, 0.16138468E-05_JPRB, &
  & 0.16205208E-05_JPRB, 0.16282414E-05_JPRB, 0.16351460E-05_JPRB, 0.16418622E-05_JPRB, 0.16495452E-05_JPRB, 0.16572983E-05_JPRB, &
  & 0.16649579E-05_JPRB, 0.16731617E-05_JPRB, 0.16809722E-05_JPRB, 0.16877647E-05_JPRB, 0.16942045E-05_JPRB, 0.17010138E-05_JPRB, &
  & 0.17072089E-05_JPRB, 0.17127025E-05_JPRB, 0.17177873E-05_JPRB, 0.17216692E-05_JPRB, 0.17243406E-05_JPRB, 0.17262494E-05_JPRB, &
  & 0.17273922E-05_JPRB, 0.17277323E-05_JPRB, 0.17275920E-05_JPRB, 0.17271779E-05_JPRB, 0.17264675E-05_JPRB, 0.17253177E-05_JPRB, &
  & 0.17232369E-05_JPRB, 0.17191139E-05_JPRB, 0.17144234E-05_JPRB, 0.17109368E-05_JPRB, 0.17089087E-05_JPRB, 0.17076780E-05_JPRB, &
  & 0.17059831E-05_JPRB, 0.17031640E-05_JPRB, 0.16984838E-05_JPRB, 0.16907898E-05_JPRB, 0.16779219E-05_JPRB, 0.16605898E-05_JPRB, &
  & 0.16379621E-05_JPRB, 0.16089029E-05_JPRB, 0.15735663E-05_JPRB, 0.15344741E-05_JPRB, 0.14935983E-05_JPRB, 0.14579997E-05_JPRB, &
  & 0.14315480E-05_JPRB, 0.14109736E-05_JPRB, 0.13933758E-05_JPRB, 0.13784285E-05_JPRB, 0.13639645E-05_JPRB, 0.13493128E-05_JPRB, &
  & 0.13353265E-05_JPRB, 0.13235384E-05_JPRB, 0.13137363E-05_JPRB, 0.13049380E-05_JPRB, 0.12947020E-05_JPRB, 0.12824577E-05_JPRB, &
  & 0.12716253E-05_JPRB, 0.12622049E-05_JPRB, 0.12565022E-05_JPRB, 0.12503531E-05_JPRB  /)

RGHG2(:,38, 5) = (/ &
  & 0.16465420E-05_JPRB, 0.16460421E-05_JPRB, 0.16453269E-05_JPRB, 0.16452811E-05_JPRB, 0.16447337E-05_JPRB, 0.16456681E-05_JPRB, &
  & 0.16498513E-05_JPRB, 0.16554099E-05_JPRB, 0.16599409E-05_JPRB, 0.16647154E-05_JPRB, 0.16705280E-05_JPRB, 0.16765596E-05_JPRB, &
  & 0.16824519E-05_JPRB, 0.16891486E-05_JPRB, 0.16958552E-05_JPRB, 0.17014065E-05_JPRB, 0.17067082E-05_JPRB, 0.17118331E-05_JPRB, &
  & 0.17162809E-05_JPRB, 0.17201359E-05_JPRB, 0.17234476E-05_JPRB, 0.17257424E-05_JPRB, 0.17272070E-05_JPRB, 0.17281777E-05_JPRB, &
  & 0.17285370E-05_JPRB, 0.17283394E-05_JPRB, 0.17277902E-05_JPRB, 0.17270586E-05_JPRB, 0.17261481E-05_JPRB, 0.17249726E-05_JPRB, &
  & 0.17235723E-05_JPRB, 0.17216914E-05_JPRB, 0.17195432E-05_JPRB, 0.17177668E-05_JPRB, 0.17168768E-05_JPRB, 0.17166899E-05_JPRB, &
  & 0.17161590E-05_JPRB, 0.17147897E-05_JPRB, 0.17124373E-05_JPRB, 0.17080550E-05_JPRB, 0.16996941E-05_JPRB, 0.16876725E-05_JPRB, &
  & 0.16704211E-05_JPRB, 0.16474818E-05_JPRB, 0.16177331E-05_JPRB, 0.15827876E-05_JPRB, 0.15449488E-05_JPRB, 0.15107772E-05_JPRB, &
  & 0.14853236E-05_JPRB, 0.14653039E-05_JPRB, 0.14477033E-05_JPRB, 0.14326445E-05_JPRB, 0.14190698E-05_JPRB, 0.14051932E-05_JPRB, &
  & 0.13905148E-05_JPRB, 0.13777658E-05_JPRB, 0.13667998E-05_JPRB, 0.13573981E-05_JPRB, 0.13477283E-05_JPRB, 0.13361675E-05_JPRB, &
  & 0.13258870E-05_JPRB, 0.13156373E-05_JPRB, 0.13103808E-05_JPRB, 0.13030163E-05_JPRB  /)

RGHG2(:,39, 5) = (/ &
  & 0.16654043E-05_JPRB, 0.16646735E-05_JPRB, 0.16637410E-05_JPRB, 0.16635550E-05_JPRB, 0.16627817E-05_JPRB, 0.16629498E-05_JPRB, &
  & 0.16657669E-05_JPRB, 0.16700902E-05_JPRB, 0.16735985E-05_JPRB, 0.16774587E-05_JPRB, 0.16821848E-05_JPRB, 0.16871357E-05_JPRB, &
  & 0.16919704E-05_JPRB, 0.16975695E-05_JPRB, 0.17032052E-05_JPRB, 0.17078909E-05_JPRB, 0.17123088E-05_JPRB, 0.17163390E-05_JPRB, &
  & 0.17197358E-05_JPRB, 0.17226499E-05_JPRB, 0.17250762E-05_JPRB, 0.17266954E-05_JPRB, 0.17276298E-05_JPRB, 0.17280950E-05_JPRB, &
  & 0.17279943E-05_JPRB, 0.17274635E-05_JPRB, 0.17266648E-05_JPRB, 0.17257689E-05_JPRB, 0.17249182E-05_JPRB, 0.17239020E-05_JPRB, &
  & 0.17228833E-05_JPRB, 0.17217210E-05_JPRB, 0.17202376E-05_JPRB, 0.17188309E-05_JPRB, 0.17180823E-05_JPRB, 0.17180909E-05_JPRB, &
  & 0.17179698E-05_JPRB, 0.17172078E-05_JPRB, 0.17157408E-05_JPRB, 0.17128353E-05_JPRB, 0.17066487E-05_JPRB, 0.16972885E-05_JPRB, &
  & 0.16831344E-05_JPRB, 0.16637288E-05_JPRB, 0.16379548E-05_JPRB, 0.16069352E-05_JPRB, 0.15727858E-05_JPRB, 0.15410657E-05_JPRB, &
  & 0.15169108E-05_JPRB, 0.14983844E-05_JPRB, 0.14819455E-05_JPRB, 0.14672783E-05_JPRB, 0.14551598E-05_JPRB, 0.14429308E-05_JPRB, &
  & 0.14288980E-05_JPRB, 0.14159368E-05_JPRB, 0.14048572E-05_JPRB, 0.13951596E-05_JPRB, 0.13860733E-05_JPRB, 0.13754538E-05_JPRB, &
  & 0.13662240E-05_JPRB, 0.13569136E-05_JPRB, 0.13531104E-05_JPRB, 0.13469917E-05_JPRB  /)

RGHG2(:,40, 5) = (/ &
  & 0.16845202E-05_JPRB, 0.16836573E-05_JPRB, 0.16825432E-05_JPRB, 0.16822582E-05_JPRB, 0.16814107E-05_JPRB, 0.16808527E-05_JPRB, &
  & 0.16822505E-05_JPRB, 0.16852756E-05_JPRB, 0.16878048E-05_JPRB, 0.16907600E-05_JPRB, 0.16943392E-05_JPRB, 0.16981266E-05_JPRB, &
  & 0.17018365E-05_JPRB, 0.17062143E-05_JPRB, 0.17105986E-05_JPRB, 0.17143299E-05_JPRB, 0.17177521E-05_JPRB, 0.17205941E-05_JPRB, &
  & 0.17228715E-05_JPRB, 0.17247954E-05_JPRB, 0.17263279E-05_JPRB, 0.17273035E-05_JPRB, 0.17277263E-05_JPRB, 0.17276689E-05_JPRB, &
  & 0.17270814E-05_JPRB, 0.17261930E-05_JPRB, 0.17251275E-05_JPRB, 0.17240639E-05_JPRB, 0.17233259E-05_JPRB, 0.17225270E-05_JPRB, &
  & 0.17219071E-05_JPRB, 0.17213389E-05_JPRB, 0.17203286E-05_JPRB, 0.17191364E-05_JPRB, 0.17183905E-05_JPRB, 0.17184899E-05_JPRB, &
  & 0.17187264E-05_JPRB, 0.17185393E-05_JPRB, 0.17178754E-05_JPRB, 0.17164028E-05_JPRB, 0.17123863E-05_JPRB, 0.17057160E-05_JPRB, &
  & 0.16948240E-05_JPRB, 0.16791426E-05_JPRB, 0.16577692E-05_JPRB, 0.16313208E-05_JPRB, 0.16016079E-05_JPRB, 0.15729326E-05_JPRB, &
  & 0.15503509E-05_JPRB, 0.15337306E-05_JPRB, 0.15188457E-05_JPRB, 0.15047203E-05_JPRB, 0.14944033E-05_JPRB, 0.14842510E-05_JPRB, &
  & 0.14711946E-05_JPRB, 0.14581069E-05_JPRB, 0.14470657E-05_JPRB, 0.14370711E-05_JPRB, 0.14286724E-05_JPRB, 0.14191998E-05_JPRB, &
  & 0.14112848E-05_JPRB, 0.14033661E-05_JPRB, 0.14014332E-05_JPRB, 0.13971793E-05_JPRB  /)

RGHG2(:,41, 5) = (/ &
  & 0.17078920E-05_JPRB, 0.17068677E-05_JPRB, 0.17055317E-05_JPRB, 0.17051257E-05_JPRB, 0.17041873E-05_JPRB, 0.17027416E-05_JPRB, &
  & 0.17024042E-05_JPRB, 0.17038420E-05_JPRB, 0.17051740E-05_JPRB, 0.17070229E-05_JPRB, 0.17091998E-05_JPRB, 0.17115647E-05_JPRB, &
  & 0.17138992E-05_JPRB, 0.17167839E-05_JPRB, 0.17196381E-05_JPRB, 0.17222025E-05_JPRB, 0.17244074E-05_JPRB, 0.17257967E-05_JPRB, &
  & 0.17267054E-05_JPRB, 0.17274187E-05_JPRB, 0.17278582E-05_JPRB, 0.17280469E-05_JPRB, 0.17278442E-05_JPRB, 0.17271479E-05_JPRB, &
  & 0.17259652E-05_JPRB, 0.17246397E-05_JPRB, 0.17232480E-05_JPRB, 0.17219792E-05_JPRB, 0.17213791E-05_JPRB, 0.17208459E-05_JPRB, &
  & 0.17207136E-05_JPRB, 0.17208717E-05_JPRB, 0.17204398E-05_JPRB, 0.17195099E-05_JPRB, 0.17187674E-05_JPRB, 0.17189778E-05_JPRB, &
  & 0.17196514E-05_JPRB, 0.17201671E-05_JPRB, 0.17204852E-05_JPRB, 0.17207647E-05_JPRB, 0.17194014E-05_JPRB, 0.17160200E-05_JPRB, &
  & 0.17091162E-05_JPRB, 0.16979880E-05_JPRB, 0.16819952E-05_JPRB, 0.16611358E-05_JPRB, 0.16368471E-05_JPRB, 0.16118945E-05_JPRB, &
  & 0.15912363E-05_JPRB, 0.15769465E-05_JPRB, 0.15639616E-05_JPRB, 0.15504986E-05_JPRB, 0.15423843E-05_JPRB, 0.15347709E-05_JPRB, &
  & 0.15229083E-05_JPRB, 0.15096659E-05_JPRB, 0.14986718E-05_JPRB, 0.14883140E-05_JPRB, 0.14807560E-05_JPRB, 0.14726857E-05_JPRB, &
  & 0.14663781E-05_JPRB, 0.14601610E-05_JPRB, 0.14605148E-05_JPRB, 0.14585409E-05_JPRB  /)

RGHG2(:,42, 5) = (/ &
  & 0.17059453E-05_JPRB, 0.17053825E-05_JPRB, 0.17045583E-05_JPRB, 0.17042493E-05_JPRB, 0.17036192E-05_JPRB, 0.17028574E-05_JPRB, &
  & 0.17029927E-05_JPRB, 0.17044589E-05_JPRB, 0.17058482E-05_JPRB, 0.17076970E-05_JPRB, 0.17098006E-05_JPRB, 0.17120072E-05_JPRB, &
  & 0.17142448E-05_JPRB, 0.17168718E-05_JPRB, 0.17193694E-05_JPRB, 0.17215987E-05_JPRB, 0.17235303E-05_JPRB, 0.17248010E-05_JPRB, &
  & 0.17256552E-05_JPRB, 0.17263375E-05_JPRB, 0.17267851E-05_JPRB, 0.17268540E-05_JPRB, 0.17264935E-05_JPRB, 0.17256949E-05_JPRB, &
  & 0.17245964E-05_JPRB, 0.17233189E-05_JPRB, 0.17221155E-05_JPRB, 0.17211379E-05_JPRB, 0.17207346E-05_JPRB, 0.17203706E-05_JPRB, &
  & 0.17203357E-05_JPRB, 0.17201877E-05_JPRB, 0.17193122E-05_JPRB, 0.17183278E-05_JPRB, 0.17177127E-05_JPRB, 0.17178471E-05_JPRB, &
  & 0.17182510E-05_JPRB, 0.17186590E-05_JPRB, 0.17189559E-05_JPRB, 0.17190856E-05_JPRB, 0.17178366E-05_JPRB, 0.17147425E-05_JPRB, &
  & 0.17082907E-05_JPRB, 0.16982698E-05_JPRB, 0.16834324E-05_JPRB, 0.16639118E-05_JPRB, 0.16411959E-05_JPRB, 0.16184584E-05_JPRB, &
  & 0.16005054E-05_JPRB, 0.15883453E-05_JPRB, 0.15773732E-05_JPRB, 0.15653794E-05_JPRB, 0.15578627E-05_JPRB, 0.15503575E-05_JPRB, &
  & 0.15395263E-05_JPRB, 0.15281401E-05_JPRB, 0.15177092E-05_JPRB, 0.15088842E-05_JPRB, 0.15019532E-05_JPRB, 0.14948652E-05_JPRB, &
  & 0.14893177E-05_JPRB, 0.14838653E-05_JPRB, 0.14845425E-05_JPRB, 0.14841478E-05_JPRB  /)

RGHG2(:,43, 5) = (/ &
  & 0.17142225E-05_JPRB, 0.17140113E-05_JPRB, 0.17135587E-05_JPRB, 0.17132862E-05_JPRB, 0.17128982E-05_JPRB, 0.17123785E-05_JPRB, &
  & 0.17121987E-05_JPRB, 0.17130082E-05_JPRB, 0.17139347E-05_JPRB, 0.17153074E-05_JPRB, 0.17167410E-05_JPRB, 0.17181913E-05_JPRB, &
  & 0.17197489E-05_JPRB, 0.17214985E-05_JPRB, 0.17230125E-05_JPRB, 0.17244341E-05_JPRB, 0.17255929E-05_JPRB, 0.17261305E-05_JPRB, &
  & 0.17263461E-05_JPRB, 0.17264794E-05_JPRB, 0.17264643E-05_JPRB, 0.17260853E-05_JPRB, 0.17253119E-05_JPRB, 0.17241450E-05_JPRB, &
  & 0.17228675E-05_JPRB, 0.17214456E-05_JPRB, 0.17202738E-05_JPRB, 0.17194736E-05_JPRB, 0.17193092E-05_JPRB, 0.17192139E-05_JPRB, &
  & 0.17194775E-05_JPRB, 0.17193626E-05_JPRB, 0.17183313E-05_JPRB, 0.17174098E-05_JPRB, 0.17169126E-05_JPRB, 0.17170254E-05_JPRB, &
  & 0.17173713E-05_JPRB, 0.17179832E-05_JPRB, 0.17186831E-05_JPRB, 0.17194298E-05_JPRB, 0.17194265E-05_JPRB, 0.17180092E-05_JPRB, &
  & 0.17136853E-05_JPRB, 0.17066333E-05_JPRB, 0.16951644E-05_JPRB, 0.16792695E-05_JPRB, 0.16603219E-05_JPRB, 0.16412067E-05_JPRB, &
  & 0.16265493E-05_JPRB, 0.16173348E-05_JPRB, 0.16090165E-05_JPRB, 0.15986481E-05_JPRB, 0.15926240E-05_JPRB, 0.15863097E-05_JPRB, &
  & 0.15769331E-05_JPRB, 0.15671740E-05_JPRB, 0.15572771E-05_JPRB, 0.15496944E-05_JPRB, 0.15436972E-05_JPRB, 0.15381085E-05_JPRB, &
  & 0.15339459E-05_JPRB, 0.15299232E-05_JPRB, 0.15318792E-05_JPRB, 0.15339060E-05_JPRB  /)

RGHG2(:,44, 5) = (/ &
  & 0.17148506E-05_JPRB, 0.17147704E-05_JPRB, 0.17145723E-05_JPRB, 0.17144343E-05_JPRB, 0.17142095E-05_JPRB, 0.17139144E-05_JPRB, &
  & 0.17138867E-05_JPRB, 0.17146491E-05_JPRB, 0.17155326E-05_JPRB, 0.17167696E-05_JPRB, 0.17180561E-05_JPRB, 0.17193089E-05_JPRB, &
  & 0.17206504E-05_JPRB, 0.17221245E-05_JPRB, 0.17233662E-05_JPRB, 0.17244774E-05_JPRB, 0.17253247E-05_JPRB, 0.17256451E-05_JPRB, &
  & 0.17257101E-05_JPRB, 0.17256771E-05_JPRB, 0.17254433E-05_JPRB, 0.17248555E-05_JPRB, 0.17239464E-05_JPRB, 0.17227633E-05_JPRB, &
  & 0.17215385E-05_JPRB, 0.17201769E-05_JPRB, 0.17192073E-05_JPRB, 0.17186475E-05_JPRB, 0.17186809E-05_JPRB, 0.17187558E-05_JPRB, &
  & 0.17190719E-05_JPRB, 0.17188206E-05_JPRB, 0.17177722E-05_JPRB, 0.17167823E-05_JPRB, 0.17163334E-05_JPRB, 0.17164715E-05_JPRB, &
  & 0.17168667E-05_JPRB, 0.17174417E-05_JPRB, 0.17182169E-05_JPRB, 0.17190680E-05_JPRB, 0.17194665E-05_JPRB, 0.17187204E-05_JPRB, &
  & 0.17153705E-05_JPRB, 0.17096549E-05_JPRB, 0.16999725E-05_JPRB, 0.16862069E-05_JPRB, 0.16693814E-05_JPRB, 0.16526217E-05_JPRB, &
  & 0.16399960E-05_JPRB, 0.16320863E-05_JPRB, 0.16251565E-05_JPRB, 0.16168194E-05_JPRB, 0.16114155E-05_JPRB, 0.16054819E-05_JPRB, &
  & 0.15970155E-05_JPRB, 0.15884045E-05_JPRB, 0.15793227E-05_JPRB, 0.15724965E-05_JPRB, 0.15670815E-05_JPRB, 0.15621380E-05_JPRB, &
  & 0.15583374E-05_JPRB, 0.15550319E-05_JPRB, 0.15564717E-05_JPRB, 0.15581641E-05_JPRB  /)

RGHG2(:,45, 5) = (/ &
  & 0.17166113E-05_JPRB, 0.17167246E-05_JPRB, 0.17168632E-05_JPRB, 0.17168830E-05_JPRB, 0.17168745E-05_JPRB, 0.17168657E-05_JPRB, &
  & 0.17169713E-05_JPRB, 0.17175971E-05_JPRB, 0.17183733E-05_JPRB, 0.17193956E-05_JPRB, 0.17204299E-05_JPRB, 0.17213623E-05_JPRB, &
  & 0.17223720E-05_JPRB, 0.17234217E-05_JPRB, 0.17242291E-05_JPRB, 0.17248848E-05_JPRB, 0.17252800E-05_JPRB, 0.17252604E-05_JPRB, &
  & 0.17250733E-05_JPRB, 0.17247818E-05_JPRB, 0.17242405E-05_JPRB, 0.17233583E-05_JPRB, 0.17222427E-05_JPRB, 0.17209945E-05_JPRB, &
  & 0.17198071E-05_JPRB, 0.17184959E-05_JPRB, 0.17177605E-05_JPRB, 0.17174968E-05_JPRB, 0.17177855E-05_JPRB, 0.17180881E-05_JPRB, &
  & 0.17185019E-05_JPRB, 0.17180992E-05_JPRB, 0.17170118E-05_JPRB, 0.17159520E-05_JPRB, 0.17155731E-05_JPRB, 0.17157372E-05_JPRB, &
  & 0.17161811E-05_JPRB, 0.17167399E-05_JPRB, 0.17176517E-05_JPRB, 0.17186996E-05_JPRB, 0.17197129E-05_JPRB, 0.17199427E-05_JPRB, &
  & 0.17179705E-05_JPRB, 0.17141513E-05_JPRB, 0.17069281E-05_JPRB, 0.16960447E-05_JPRB, 0.16821111E-05_JPRB, 0.16684905E-05_JPRB, &
  & 0.16585940E-05_JPRB, 0.16525418E-05_JPRB, 0.16475279E-05_JPRB, 0.16417086E-05_JPRB, 0.16371993E-05_JPRB, 0.16318497E-05_JPRB, &
  & 0.16246031E-05_JPRB, 0.16175047E-05_JPRB, 0.16094184E-05_JPRB, 0.16036103E-05_JPRB, 0.15989761E-05_JPRB, 0.15949564E-05_JPRB, &
  & 0.15917430E-05_JPRB, 0.15894345E-05_JPRB, 0.15904481E-05_JPRB, 0.15920657E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART10',0,ZHOOK_HANDLE)



RGHG2(:,46, 5) = (/ &
  & 0.17167655E-05_JPRB, 0.17169249E-05_JPRB, 0.17171589E-05_JPRB, 0.17172563E-05_JPRB, 0.17173221E-05_JPRB, 0.17174072E-05_JPRB, &
  & 0.17175685E-05_JPRB, 0.17181809E-05_JPRB, 0.17189331E-05_JPRB, 0.17198724E-05_JPRB, 0.17207941E-05_JPRB, 0.17215622E-05_JPRB, &
  & 0.17223746E-05_JPRB, 0.17231647E-05_JPRB, 0.17237141E-05_JPRB, 0.17240915E-05_JPRB, 0.17242332E-05_JPRB, 0.17240732E-05_JPRB, &
  & 0.17237799E-05_JPRB, 0.17234038E-05_JPRB, 0.17227946E-05_JPRB, 0.17218867E-05_JPRB, 0.17207813E-05_JPRB, 0.17196304E-05_JPRB, &
  & 0.17185856E-05_JPRB, 0.17174153E-05_JPRB, 0.17168648E-05_JPRB, 0.17167873E-05_JPRB, 0.17172414E-05_JPRB, 0.17176437E-05_JPRB, &
  & 0.17180503E-05_JPRB, 0.17176215E-05_JPRB, 0.17164815E-05_JPRB, 0.17154240E-05_JPRB, 0.17150801E-05_JPRB, 0.17152730E-05_JPRB, &
  & 0.17157252E-05_JPRB, 0.17163036E-05_JPRB, 0.17172828E-05_JPRB, 0.17184716E-05_JPRB, 0.17197900E-05_JPRB, 0.17205692E-05_JPRB, &
  & 0.17194864E-05_JPRB, 0.17169433E-05_JPRB, 0.17113554E-05_JPRB, 0.17028194E-05_JPRB, 0.16912044E-05_JPRB, 0.16798363E-05_JPRB, &
  & 0.16716163E-05_JPRB, 0.16667732E-05_JPRB, 0.16627736E-05_JPRB, 0.16585488E-05_JPRB, 0.16548697E-05_JPRB, 0.16502658E-05_JPRB, &
  & 0.16441343E-05_JPRB, 0.16380625E-05_JPRB, 0.16309695E-05_JPRB, 0.16257592E-05_JPRB, 0.16216287E-05_JPRB, 0.16182185E-05_JPRB, &
  & 0.16153353E-05_JPRB, 0.16136257E-05_JPRB, 0.16140928E-05_JPRB, 0.16150306E-05_JPRB  /)

RGHG2(:,47, 5) = (/ &
  & 0.17166247E-05_JPRB, 0.17168086E-05_JPRB, 0.17171061E-05_JPRB, 0.17172785E-05_JPRB, 0.17174030E-05_JPRB, 0.17175599E-05_JPRB, &
  & 0.17177710E-05_JPRB, 0.17183923E-05_JPRB, 0.17191331E-05_JPRB, 0.17200015E-05_JPRB, 0.17208188E-05_JPRB, 0.17214255E-05_JPRB, &
  & 0.17220332E-05_JPRB, 0.17225518E-05_JPRB, 0.17228337E-05_JPRB, 0.17229201E-05_JPRB, 0.17228041E-05_JPRB, 0.17225194E-05_JPRB, &
  & 0.17221307E-05_JPRB, 0.17216902E-05_JPRB, 0.17210492E-05_JPRB, 0.17201649E-05_JPRB, 0.17191150E-05_JPRB, 0.17181109E-05_JPRB, &
  & 0.17172544E-05_JPRB, 0.17162676E-05_JPRB, 0.17159242E-05_JPRB, 0.17160431E-05_JPRB, 0.17166734E-05_JPRB, 0.17171670E-05_JPRB, &
  & 0.17175443E-05_JPRB, 0.17171097E-05_JPRB, 0.17159053E-05_JPRB, 0.17148649E-05_JPRB, 0.17145553E-05_JPRB, 0.17147824E-05_JPRB, &
  & 0.17152363E-05_JPRB, 0.17158448E-05_JPRB, 0.17168893E-05_JPRB, 0.17182321E-05_JPRB, 0.17198465E-05_JPRB, 0.17211850E-05_JPRB, &
  & 0.17210480E-05_JPRB, 0.17198780E-05_JPRB, 0.17160439E-05_JPRB, 0.17101553E-05_JPRB, 0.17011462E-05_JPRB, 0.16922437E-05_JPRB, &
  & 0.16857799E-05_JPRB, 0.16822260E-05_JPRB, 0.16792357E-05_JPRB, 0.16766971E-05_JPRB, 0.16739793E-05_JPRB, 0.16702829E-05_JPRB, &
  & 0.16654388E-05_JPRB, 0.16604742E-05_JPRB, 0.16545463E-05_JPRB, 0.16499533E-05_JPRB, 0.16463585E-05_JPRB, 0.16436006E-05_JPRB, &
  & 0.16410533E-05_JPRB, 0.16399665E-05_JPRB, 0.16397684E-05_JPRB, 0.16397873E-05_JPRB  /)

RGHG2(:,48, 5) = (/ &
  & 0.17158022E-05_JPRB, 0.17159412E-05_JPRB, 0.17162230E-05_JPRB, 0.17164687E-05_JPRB, 0.17166652E-05_JPRB, 0.17168649E-05_JPRB, &
  & 0.17170762E-05_JPRB, 0.17176447E-05_JPRB, 0.17183206E-05_JPRB, 0.17191057E-05_JPRB, 0.17198275E-05_JPRB, 0.17203039E-05_JPRB, &
  & 0.17207396E-05_JPRB, 0.17210492E-05_JPRB, 0.17211223E-05_JPRB, 0.17210313E-05_JPRB, 0.17207951E-05_JPRB, 0.17205041E-05_JPRB, &
  & 0.17201720E-05_JPRB, 0.17198503E-05_JPRB, 0.17193860E-05_JPRB, 0.17186856E-05_JPRB, 0.17178299E-05_JPRB, 0.17169923E-05_JPRB, &
  & 0.17163331E-05_JPRB, 0.17155254E-05_JPRB, 0.17153137E-05_JPRB, 0.17155710E-05_JPRB, 0.17162898E-05_JPRB, 0.17168097E-05_JPRB, &
  & 0.17171533E-05_JPRB, 0.17167511E-05_JPRB, 0.17155483E-05_JPRB, 0.17145340E-05_JPRB, 0.17142441E-05_JPRB, 0.17144832E-05_JPRB, &
  & 0.17149494E-05_JPRB, 0.17155860E-05_JPRB, 0.17166808E-05_JPRB, 0.17181114E-05_JPRB, 0.17198695E-05_JPRB, 0.17215719E-05_JPRB, &
  & 0.17220426E-05_JPRB, 0.17218513E-05_JPRB, 0.17194073E-05_JPRB, 0.17155375E-05_JPRB, 0.17087788E-05_JPRB, 0.17018941E-05_JPRB, &
  & 0.16968613E-05_JPRB, 0.16942582E-05_JPRB, 0.16920436E-05_JPRB, 0.16904599E-05_JPRB, 0.16885933E-05_JPRB, 0.16857888E-05_JPRB, &
  & 0.16821182E-05_JPRB, 0.16781656E-05_JPRB, 0.16733483E-05_JPRB, 0.16695445E-05_JPRB, 0.16664787E-05_JPRB, 0.16643015E-05_JPRB, &
  & 0.16622712E-05_JPRB, 0.16616416E-05_JPRB, 0.16611132E-05_JPRB, 0.16608293E-05_JPRB  /)

RGHG2(:,49, 5) = (/ &
  & 0.17145814E-05_JPRB, 0.17146393E-05_JPRB, 0.17148675E-05_JPRB, 0.17151935E-05_JPRB, 0.17154757E-05_JPRB, 0.17157098E-05_JPRB, &
  & 0.17158990E-05_JPRB, 0.17163808E-05_JPRB, 0.17169605E-05_JPRB, 0.17176477E-05_JPRB, 0.17182678E-05_JPRB, 0.17186141E-05_JPRB, &
  & 0.17188740E-05_JPRB, 0.17189807E-05_JPRB, 0.17188493E-05_JPRB, 0.17186135E-05_JPRB, 0.17183065E-05_JPRB, 0.17180624E-05_JPRB, &
  & 0.17178621E-05_JPRB, 0.17177555E-05_JPRB, 0.17175815E-05_JPRB, 0.17171577E-05_JPRB, 0.17165803E-05_JPRB, 0.17159360E-05_JPRB, &
  & 0.17154994E-05_JPRB, 0.17148878E-05_JPRB, 0.17147879E-05_JPRB, 0.17151720E-05_JPRB, 0.17159489E-05_JPRB, 0.17164684E-05_JPRB, &
  & 0.17167726E-05_JPRB, 0.17164236E-05_JPRB, 0.17152526E-05_JPRB, 0.17142714E-05_JPRB, 0.17139965E-05_JPRB, 0.17142390E-05_JPRB, &
  & 0.17147235E-05_JPRB, 0.17153903E-05_JPRB, 0.17165340E-05_JPRB, 0.17180315E-05_JPRB, 0.17198796E-05_JPRB, 0.17218963E-05_JPRB, &
  & 0.17228862E-05_JPRB, 0.17235995E-05_JPRB, 0.17225295E-05_JPRB, 0.17206095E-05_JPRB, 0.17161813E-05_JPRB, 0.17113275E-05_JPRB, &
  & 0.17077315E-05_JPRB, 0.17060275E-05_JPRB, 0.17045656E-05_JPRB, 0.17037071E-05_JPRB, 0.17027328E-05_JPRB, 0.17009091E-05_JPRB, &
  & 0.16984862E-05_JPRB, 0.16956110E-05_JPRB, 0.16919986E-05_JPRB, 0.16891471E-05_JPRB, 0.16866642E-05_JPRB, 0.16850974E-05_JPRB, &
  & 0.16837219E-05_JPRB, 0.16835233E-05_JPRB, 0.16827815E-05_JPRB, 0.16824424E-05_JPRB  /)

RGHG2(:,50, 5) = (/ &
  & 0.17130227E-05_JPRB, 0.17129558E-05_JPRB, 0.17131075E-05_JPRB, 0.17134919E-05_JPRB, 0.17138450E-05_JPRB, 0.17140834E-05_JPRB, &
  & 0.17142098E-05_JPRB, 0.17145595E-05_JPRB, 0.17150232E-05_JPRB, 0.17156568E-05_JPRB, 0.17161975E-05_JPRB, 0.17164703E-05_JPRB, &
  & 0.17166377E-05_JPRB, 0.17166402E-05_JPRB, 0.17164006E-05_JPRB, 0.17161100E-05_JPRB, 0.17158357E-05_JPRB, 0.17157477E-05_JPRB, &
  & 0.17157201E-05_JPRB, 0.17158600E-05_JPRB, 0.17160245E-05_JPRB, 0.17159373E-05_JPRB, 0.17156567E-05_JPRB, 0.17151908E-05_JPRB, &
  & 0.17149106E-05_JPRB, 0.17145057E-05_JPRB, 0.17145095E-05_JPRB, 0.17149004E-05_JPRB, 0.17156955E-05_JPRB, 0.17162041E-05_JPRB, &
  & 0.17165288E-05_JPRB, 0.17162322E-05_JPRB, 0.17151346E-05_JPRB, 0.17141677E-05_JPRB, 0.17138790E-05_JPRB, 0.17141165E-05_JPRB, &
  & 0.17146394E-05_JPRB, 0.17152952E-05_JPRB, 0.17164723E-05_JPRB, 0.17180068E-05_JPRB, 0.17198631E-05_JPRB, 0.17220565E-05_JPRB, &
  & 0.17234388E-05_JPRB, 0.17248020E-05_JPRB, 0.17247123E-05_JPRB, 0.17241635E-05_JPRB, 0.17214090E-05_JPRB, 0.17181708E-05_JPRB, &
  & 0.17157757E-05_JPRB, 0.17147881E-05_JPRB, 0.17141103E-05_JPRB, 0.17137154E-05_JPRB, 0.17135353E-05_JPRB, 0.17125834E-05_JPRB, &
  & 0.17112035E-05_JPRB, 0.17093414E-05_JPRB, 0.17067587E-05_JPRB, 0.17049217E-05_JPRB, 0.17030665E-05_JPRB, 0.17020062E-05_JPRB, &
  & 0.17012915E-05_JPRB, 0.17014541E-05_JPRB, 0.17007428E-05_JPRB, 0.17004889E-05_JPRB  /)

RGHG2(:,51, 5) = (/ &
  & 0.17111591E-05_JPRB, 0.17109345E-05_JPRB, 0.17109913E-05_JPRB, 0.17114273E-05_JPRB, 0.17118492E-05_JPRB, 0.17120764E-05_JPRB, &
  & 0.17121137E-05_JPRB, 0.17122964E-05_JPRB, 0.17126244E-05_JPRB, 0.17132232E-05_JPRB, 0.17136899E-05_JPRB, 0.17139128E-05_JPRB, &
  & 0.17140239E-05_JPRB, 0.17139656E-05_JPRB, 0.17136599E-05_JPRB, 0.17133572E-05_JPRB, 0.17131725E-05_JPRB, 0.17133109E-05_JPRB, &
  & 0.17134916E-05_JPRB, 0.17139144E-05_JPRB, 0.17144703E-05_JPRB, 0.17147789E-05_JPRB, 0.17148292E-05_JPRB, 0.17145484E-05_JPRB, &
  & 0.17144026E-05_JPRB, 0.17142267E-05_JPRB, 0.17143385E-05_JPRB, 0.17146736E-05_JPRB, 0.17154674E-05_JPRB, 0.17159588E-05_JPRB, &
  & 0.17163370E-05_JPRB, 0.17160968E-05_JPRB, 0.17151003E-05_JPRB, 0.17141391E-05_JPRB, 0.17138202E-05_JPRB, 0.17140479E-05_JPRB, &
  & 0.17146228E-05_JPRB, 0.17152452E-05_JPRB, 0.17164503E-05_JPRB, 0.17180091E-05_JPRB, 0.17198312E-05_JPRB, 0.17221436E-05_JPRB, &
  & 0.17238836E-05_JPRB, 0.17258158E-05_JPRB, 0.17265795E-05_JPRB, 0.17272096E-05_JPRB, 0.17259205E-05_JPRB, 0.17242113E-05_JPRB, &
  & 0.17229910E-05_JPRB, 0.17226825E-05_JPRB, 0.17228692E-05_JPRB, 0.17228383E-05_JPRB, 0.17234655E-05_JPRB, 0.17233993E-05_JPRB, &
  & 0.17230402E-05_JPRB, 0.17222399E-05_JPRB, 0.17206789E-05_JPRB, 0.17199719E-05_JPRB, 0.17188193E-05_JPRB, 0.17182522E-05_JPRB, &
  & 0.17182554E-05_JPRB, 0.17187721E-05_JPRB, 0.17182217E-05_JPRB, 0.17181339E-05_JPRB  /)

RGHG2(:,52, 5) = (/ &
  & 0.17091545E-05_JPRB, 0.17088351E-05_JPRB, 0.17088259E-05_JPRB, 0.17092807E-05_JPRB, 0.17097514E-05_JPRB, 0.17099643E-05_JPRB, &
  & 0.17099038E-05_JPRB, 0.17099559E-05_JPRB, 0.17101742E-05_JPRB, 0.17107478E-05_JPRB, 0.17112088E-05_JPRB, 0.17114653E-05_JPRB, &
  & 0.17116032E-05_JPRB, 0.17115714E-05_JPRB, 0.17113227E-05_JPRB, 0.17110928E-05_JPRB, 0.17110529E-05_JPRB, 0.17113815E-05_JPRB, &
  & 0.17117071E-05_JPRB, 0.17123198E-05_JPRB, 0.17131746E-05_JPRB, 0.17138533E-05_JPRB, 0.17141924E-05_JPRB, 0.17141447E-05_JPRB, &
  & 0.17141183E-05_JPRB, 0.17141196E-05_JPRB, 0.17142915E-05_JPRB, 0.17146072E-05_JPRB, 0.17153559E-05_JPRB, 0.17158223E-05_JPRB, &
  & 0.17162541E-05_JPRB, 0.17160846E-05_JPRB, 0.17151579E-05_JPRB, 0.17141991E-05_JPRB, 0.17138313E-05_JPRB, 0.17140600E-05_JPRB, &
  & 0.17146849E-05_JPRB, 0.17153174E-05_JPRB, 0.17165333E-05_JPRB, 0.17179737E-05_JPRB, 0.17197528E-05_JPRB, 0.17220755E-05_JPRB, &
  & 0.17241466E-05_JPRB, 0.17264499E-05_JPRB, 0.17277899E-05_JPRB, 0.17290619E-05_JPRB, 0.17288608E-05_JPRB, 0.17283058E-05_JPRB, &
  & 0.17278500E-05_JPRB, 0.17280365E-05_JPRB, 0.17287468E-05_JPRB, 0.17290592E-05_JPRB, 0.17302219E-05_JPRB, 0.17308988E-05_JPRB, &
  & 0.17312876E-05_JPRB, 0.17313305E-05_JPRB, 0.17308250E-05_JPRB, 0.17309931E-05_JPRB, 0.17304788E-05_JPRB, 0.17303614E-05_JPRB, &
  & 0.17308419E-05_JPRB, 0.17316575E-05_JPRB, 0.17314827E-05_JPRB, 0.17314608E-05_JPRB  /)

RGHG2(:,53, 5) = (/ &
  & 0.17069173E-05_JPRB, 0.17065190E-05_JPRB, 0.17064489E-05_JPRB, 0.17069115E-05_JPRB, 0.17074277E-05_JPRB, 0.17076237E-05_JPRB, &
  & 0.17074535E-05_JPRB, 0.17073774E-05_JPRB, 0.17074861E-05_JPRB, 0.17080360E-05_JPRB, 0.17085170E-05_JPRB, 0.17088423E-05_JPRB, &
  & 0.17090415E-05_JPRB, 0.17090720E-05_JPRB, 0.17089328E-05_JPRB, 0.17088147E-05_JPRB, 0.17089537E-05_JPRB, 0.17094757E-05_JPRB, &
  & 0.17099348E-05_JPRB, 0.17107183E-05_JPRB, 0.17118629E-05_JPRB, 0.17129348E-05_JPRB, 0.17135723E-05_JPRB, 0.17137969E-05_JPRB, &
  & 0.17138949E-05_JPRB, 0.17140691E-05_JPRB, 0.17142880E-05_JPRB, 0.17145966E-05_JPRB, 0.17152794E-05_JPRB, 0.17157155E-05_JPRB, &
  & 0.17162056E-05_JPRB, 0.17161187E-05_JPRB, 0.17152559E-05_JPRB, 0.17142985E-05_JPRB, 0.17138703E-05_JPRB, 0.17141043E-05_JPRB, &
  & 0.17147826E-05_JPRB, 0.17154431E-05_JPRB, 0.17166640E-05_JPRB, 0.17179206E-05_JPRB, 0.17196495E-05_JPRB, 0.17219418E-05_JPRB, &
  & 0.17243632E-05_JPRB, 0.17269944E-05_JPRB, 0.17288552E-05_JPRB, 0.17306195E-05_JPRB, 0.17314582E-05_JPRB, 0.17320159E-05_JPRB, &
  & 0.17322348E-05_JPRB, 0.17328897E-05_JPRB, 0.17340390E-05_JPRB, 0.17347171E-05_JPRB, 0.17363586E-05_JPRB, 0.17377897E-05_JPRB, &
  & 0.17388881E-05_JPRB, 0.17397651E-05_JPRB, 0.17404220E-05_JPRB, 0.17414449E-05_JPRB, 0.17416009E-05_JPRB, 0.17419565E-05_JPRB, &
  & 0.17428643E-05_JPRB, 0.17439843E-05_JPRB, 0.17443009E-05_JPRB, 0.17443122E-05_JPRB  /)

RGHG2(:,54, 5) = (/ &
  & 0.17047965E-05_JPRB, 0.17044033E-05_JPRB, 0.17043255E-05_JPRB, 0.17047759E-05_JPRB, 0.17053139E-05_JPRB, 0.17055137E-05_JPRB, &
  & 0.17052887E-05_JPRB, 0.17051963E-05_JPRB, 0.17052452E-05_JPRB, 0.17057906E-05_JPRB, 0.17062915E-05_JPRB, 0.17067125E-05_JPRB, &
  & 0.17070004E-05_JPRB, 0.17071200E-05_JPRB, 0.17071310E-05_JPRB, 0.17071855E-05_JPRB, 0.17075015E-05_JPRB, 0.17081651E-05_JPRB, &
  & 0.17087012E-05_JPRB, 0.17095384E-05_JPRB, 0.17108385E-05_JPRB, 0.17121966E-05_JPRB, 0.17131173E-05_JPRB, 0.17135659E-05_JPRB, &
  & 0.17137966E-05_JPRB, 0.17140642E-05_JPRB, 0.17143245E-05_JPRB, 0.17146623E-05_JPRB, 0.17152919E-05_JPRB, 0.17156869E-05_JPRB, &
  & 0.17161631E-05_JPRB, 0.17161579E-05_JPRB, 0.17153217E-05_JPRB, 0.17143759E-05_JPRB, 0.17139665E-05_JPRB, 0.17142323E-05_JPRB, &
  & 0.17149878E-05_JPRB, 0.17157523E-05_JPRB, 0.17168616E-05_JPRB, 0.17178519E-05_JPRB, 0.17195218E-05_JPRB, 0.17217693E-05_JPRB, &
  & 0.17244281E-05_JPRB, 0.17272888E-05_JPRB, 0.17294300E-05_JPRB, 0.17314839E-05_JPRB, 0.17330027E-05_JPRB, 0.17342821E-05_JPRB, &
  & 0.17348526E-05_JPRB, 0.17357120E-05_JPRB, 0.17371689E-05_JPRB, 0.17380134E-05_JPRB, 0.17398762E-05_JPRB, 0.17417839E-05_JPRB, &
  & 0.17433138E-05_JPRB, 0.17446358E-05_JPRB, 0.17460810E-05_JPRB, 0.17476018E-05_JPRB, 0.17483999E-05_JPRB, 0.17489940E-05_JPRB, &
  & 0.17498816E-05_JPRB, 0.17511784E-05_JPRB, 0.17517667E-05_JPRB, 0.17519671E-05_JPRB  /)

RGHG2(:,55, 5) = (/ &
  & 0.17024624E-05_JPRB, 0.17020859E-05_JPRB, 0.17020067E-05_JPRB, 0.17024409E-05_JPRB, 0.17030000E-05_JPRB, 0.17032066E-05_JPRB, &
  & 0.17029283E-05_JPRB, 0.17028324E-05_JPRB, 0.17028216E-05_JPRB, 0.17033646E-05_JPRB, 0.17038875E-05_JPRB, 0.17044181E-05_JPRB, &
  & 0.17048078E-05_JPRB, 0.17050296E-05_JPRB, 0.17052124E-05_JPRB, 0.17054661E-05_JPRB, 0.17059778E-05_JPRB, 0.17067917E-05_JPRB, &
  & 0.17074055E-05_JPRB, 0.17082868E-05_JPRB, 0.17097416E-05_JPRB, 0.17114025E-05_JPRB, 0.17126349E-05_JPRB, 0.17133252E-05_JPRB, &
  & 0.17137043E-05_JPRB, 0.17140649E-05_JPRB, 0.17143701E-05_JPRB, 0.17147451E-05_JPRB, 0.17153174E-05_JPRB, 0.17156655E-05_JPRB, &
  & 0.17161167E-05_JPRB, 0.17162021E-05_JPRB, 0.17153903E-05_JPRB, 0.17144587E-05_JPRB, 0.17140807E-05_JPRB, 0.17143851E-05_JPRB, &
  & 0.17152291E-05_JPRB, 0.17161189E-05_JPRB, 0.17170893E-05_JPRB, 0.17177738E-05_JPRB, 0.17193771E-05_JPRB, 0.17215732E-05_JPRB, &
  & 0.17244801E-05_JPRB, 0.17275820E-05_JPRB, 0.17300022E-05_JPRB, 0.17323501E-05_JPRB, 0.17345750E-05_JPRB, 0.17366027E-05_JPRB, &
  & 0.17375201E-05_JPRB, 0.17385713E-05_JPRB, 0.17403517E-05_JPRB, 0.17413542E-05_JPRB, 0.17434285E-05_JPRB, 0.17458274E-05_JPRB, &
  & 0.17477987E-05_JPRB, 0.17495626E-05_JPRB, 0.17518318E-05_JPRB, 0.17538571E-05_JPRB, 0.17553628E-05_JPRB, 0.17561903E-05_JPRB, &
  & 0.17569967E-05_JPRB, 0.17584726E-05_JPRB, 0.17593330E-05_JPRB, 0.17597634E-05_JPRB  /)

RGHG2(:,56, 5) = (/ &
  & 0.17007049E-05_JPRB, 0.17003598E-05_JPRB, 0.17002964E-05_JPRB, 0.17006940E-05_JPRB, 0.17012452E-05_JPRB, 0.17014708E-05_JPRB, &
  & 0.17012201E-05_JPRB, 0.17011915E-05_JPRB, 0.17012101E-05_JPRB, 0.17017669E-05_JPRB, 0.17023153E-05_JPRB, 0.17028897E-05_JPRB, &
  & 0.17033461E-05_JPRB, 0.17036513E-05_JPRB, 0.17039557E-05_JPRB, 0.17043758E-05_JPRB, 0.17050166E-05_JPRB, 0.17059246E-05_JPRB, &
  & 0.17065966E-05_JPRB, 0.17074818E-05_JPRB, 0.17089914E-05_JPRB, 0.17107786E-05_JPRB, 0.17122573E-05_JPRB, 0.17131118E-05_JPRB, &
  & 0.17136008E-05_JPRB, 0.17140177E-05_JPRB, 0.17143790E-05_JPRB, 0.17147692E-05_JPRB, 0.17152954E-05_JPRB, 0.17156483E-05_JPRB, &
  & 0.17160838E-05_JPRB, 0.17161892E-05_JPRB, 0.17154339E-05_JPRB, 0.17144525E-05_JPRB, 0.17141959E-05_JPRB, 0.17145216E-05_JPRB, &
  & 0.17154257E-05_JPRB, 0.17164523E-05_JPRB, 0.17172791E-05_JPRB, 0.17177427E-05_JPRB, 0.17192739E-05_JPRB, 0.17214692E-05_JPRB, &
  & 0.17244192E-05_JPRB, 0.17276968E-05_JPRB, 0.17302566E-05_JPRB, 0.17328646E-05_JPRB, 0.17354015E-05_JPRB, 0.17377087E-05_JPRB, &
  & 0.17387239E-05_JPRB, 0.17399580E-05_JPRB, 0.17417774E-05_JPRB, 0.17428824E-05_JPRB, 0.17449940E-05_JPRB, 0.17475500E-05_JPRB, &
  & 0.17497242E-05_JPRB, 0.17515489E-05_JPRB, 0.17540559E-05_JPRB, 0.17563075E-05_JPRB, 0.17580467E-05_JPRB, 0.17589151E-05_JPRB, &
  & 0.17596491E-05_JPRB, 0.17609021E-05_JPRB, 0.17618590E-05_JPRB, 0.17624331E-05_JPRB  /)

RGHG2(:,57, 5) = (/ &
  & 0.16989678E-05_JPRB, 0.16986430E-05_JPRB, 0.16985907E-05_JPRB, 0.16989492E-05_JPRB, 0.16994881E-05_JPRB, 0.16997247E-05_JPRB, &
  & 0.16995082E-05_JPRB, 0.16995329E-05_JPRB, 0.16995903E-05_JPRB, 0.17001744E-05_JPRB, 0.17007503E-05_JPRB, 0.17013683E-05_JPRB, &
  & 0.17018953E-05_JPRB, 0.17022885E-05_JPRB, 0.17027096E-05_JPRB, 0.17032771E-05_JPRB, 0.17040371E-05_JPRB, 0.17050287E-05_JPRB, &
  & 0.17057558E-05_JPRB, 0.17066589E-05_JPRB, 0.17082163E-05_JPRB, 0.17101146E-05_JPRB, 0.17118268E-05_JPRB, 0.17128582E-05_JPRB, &
  & 0.17134492E-05_JPRB, 0.17139422E-05_JPRB, 0.17143382E-05_JPRB, 0.17147278E-05_JPRB, 0.17152054E-05_JPRB, 0.17155646E-05_JPRB, &
  & 0.17160065E-05_JPRB, 0.17161487E-05_JPRB, 0.17154483E-05_JPRB, 0.17144427E-05_JPRB, 0.17142902E-05_JPRB, 0.17146189E-05_JPRB, &
  & 0.17155926E-05_JPRB, 0.17167309E-05_JPRB, 0.17174479E-05_JPRB, 0.17176845E-05_JPRB, 0.17191666E-05_JPRB, 0.17213503E-05_JPRB, &
  & 0.17243574E-05_JPRB, 0.17278197E-05_JPRB, 0.17305380E-05_JPRB, 0.17334009E-05_JPRB, 0.17362296E-05_JPRB, 0.17388318E-05_JPRB, &
  & 0.17399679E-05_JPRB, 0.17413896E-05_JPRB, 0.17432695E-05_JPRB, 0.17444792E-05_JPRB, 0.17466302E-05_JPRB, 0.17492962E-05_JPRB, &
  & 0.17516743E-05_JPRB, 0.17535953E-05_JPRB, 0.17563397E-05_JPRB, 0.17588416E-05_JPRB, 0.17607781E-05_JPRB, 0.17616736E-05_JPRB, &
  & 0.17623413E-05_JPRB, 0.17634309E-05_JPRB, 0.17645071E-05_JPRB, 0.17652431E-05_JPRB  /)

RGHG2(:,58, 5) = (/ &
  & 0.16975129E-05_JPRB, 0.16971911E-05_JPRB, 0.16971438E-05_JPRB, 0.16974587E-05_JPRB, 0.16979732E-05_JPRB, 0.16982088E-05_JPRB, &
  & 0.16980502E-05_JPRB, 0.16981135E-05_JPRB, 0.16982389E-05_JPRB, 0.16988738E-05_JPRB, 0.16994792E-05_JPRB, 0.17001246E-05_JPRB, &
  & 0.17007167E-05_JPRB, 0.17011952E-05_JPRB, 0.17017057E-05_JPRB, 0.17023707E-05_JPRB, 0.17032110E-05_JPRB, 0.17042513E-05_JPRB, &
  & 0.17050201E-05_JPRB, 0.17059557E-05_JPRB, 0.17075263E-05_JPRB, 0.17094683E-05_JPRB, 0.17113613E-05_JPRB, 0.17125623E-05_JPRB, &
  & 0.17132265E-05_JPRB, 0.17138160E-05_JPRB, 0.17142099E-05_JPRB, 0.17145680E-05_JPRB, 0.17149989E-05_JPRB, 0.17153765E-05_JPRB, &
  & 0.17158630E-05_JPRB, 0.17160539E-05_JPRB, 0.17154074E-05_JPRB, 0.17144109E-05_JPRB, 0.17143418E-05_JPRB, 0.17146390E-05_JPRB, &
  & 0.17156879E-05_JPRB, 0.17168881E-05_JPRB, 0.17175604E-05_JPRB, 0.17175938E-05_JPRB, 0.17190688E-05_JPRB, 0.17212332E-05_JPRB, &
  & 0.17242779E-05_JPRB, 0.17279129E-05_JPRB, 0.17307825E-05_JPRB, 0.17338648E-05_JPRB, 0.17368541E-05_JPRB, 0.17396656E-05_JPRB, &
  & 0.17409053E-05_JPRB, 0.17425058E-05_JPRB, 0.17444243E-05_JPRB, 0.17457233E-05_JPRB, 0.17478814E-05_JPRB, 0.17505069E-05_JPRB, &
  & 0.17530292E-05_JPRB, 0.17550274E-05_JPRB, 0.17578794E-05_JPRB, 0.17605998E-05_JPRB, 0.17625678E-05_JPRB, 0.17634287E-05_JPRB, &
  & 0.17640477E-05_JPRB, 0.17650124E-05_JPRB, 0.17662033E-05_JPRB, 0.17671029E-05_JPRB  /)

RGHG2(:,59, 5) = (/ &
  & 0.16964007E-05_JPRB, 0.16960553E-05_JPRB, 0.16960005E-05_JPRB, 0.16962727E-05_JPRB, 0.16967514E-05_JPRB, 0.16969639E-05_JPRB, &
  & 0.16968483E-05_JPRB, 0.16969230E-05_JPRB, 0.16971222E-05_JPRB, 0.16978133E-05_JPRB, 0.16984485E-05_JPRB, 0.16991162E-05_JPRB, &
  & 0.16997788E-05_JPRB, 0.17003407E-05_JPRB, 0.17009261E-05_JPRB, 0.17016497E-05_JPRB, 0.17025374E-05_JPRB, 0.17035956E-05_JPRB, &
  & 0.17043987E-05_JPRB, 0.17053593E-05_JPRB, 0.17068960E-05_JPRB, 0.17088231E-05_JPRB, 0.17107929E-05_JPRB, 0.17121824E-05_JPRB, &
  & 0.17129357E-05_JPRB, 0.17136041E-05_JPRB, 0.17140077E-05_JPRB, 0.17142882E-05_JPRB, 0.17146693E-05_JPRB, 0.17150607E-05_JPRB, &
  & 0.17155941E-05_JPRB, 0.17158636E-05_JPRB, 0.17152922E-05_JPRB, 0.17143081E-05_JPRB, 0.17142934E-05_JPRB, 0.17145918E-05_JPRB, &
  & 0.17157153E-05_JPRB, 0.17169003E-05_JPRB, 0.17174445E-05_JPRB, 0.17174092E-05_JPRB, 0.17189023E-05_JPRB, 0.17210896E-05_JPRB, &
  & 0.17241820E-05_JPRB, 0.17279525E-05_JPRB, 0.17310189E-05_JPRB, 0.17342345E-05_JPRB, 0.17373288E-05_JPRB, 0.17403216E-05_JPRB, &
  & 0.17416970E-05_JPRB, 0.17434164E-05_JPRB, 0.17453891E-05_JPRB, 0.17467582E-05_JPRB, 0.17489077E-05_JPRB, 0.17514549E-05_JPRB, &
  & 0.17541021E-05_JPRB, 0.17561983E-05_JPRB, 0.17591390E-05_JPRB, 0.17619900E-05_JPRB, 0.17639796E-05_JPRB, 0.17648205E-05_JPRB, &
  & 0.17653357E-05_JPRB, 0.17662881E-05_JPRB, 0.17675181E-05_JPRB, 0.17684391E-05_JPRB  /)

RGHG2(:,60, 5) = (/ &
  & 0.16954028E-05_JPRB, 0.16950220E-05_JPRB, 0.16949542E-05_JPRB, 0.16951855E-05_JPRB, 0.16956238E-05_JPRB, 0.16958050E-05_JPRB, &
  & 0.16957243E-05_JPRB, 0.16957981E-05_JPRB, 0.16960708E-05_JPRB, 0.16968174E-05_JPRB, 0.16974835E-05_JPRB, 0.16981723E-05_JPRB, &
  & 0.16989082E-05_JPRB, 0.16995593E-05_JPRB, 0.17002186E-05_JPRB, 0.17009868E-05_JPRB, 0.17019101E-05_JPRB, 0.17029711E-05_JPRB, &
  & 0.17038062E-05_JPRB, 0.17047825E-05_JPRB, 0.17062597E-05_JPRB, 0.17081408E-05_JPRB, 0.17101383E-05_JPRB, 0.17117179E-05_JPRB, &
  & 0.17125778E-05_JPRB, 0.17133210E-05_JPRB, 0.17137532E-05_JPRB, 0.17139484E-05_JPRB, 0.17142732E-05_JPRB, 0.17146818E-05_JPRB, &
  & 0.17152889E-05_JPRB, 0.17156380E-05_JPRB, 0.17151164E-05_JPRB, 0.17141256E-05_JPRB, 0.17141645E-05_JPRB, 0.17145032E-05_JPRB, &
  & 0.17156945E-05_JPRB, 0.17168361E-05_JPRB, 0.17171976E-05_JPRB, 0.17171758E-05_JPRB, 0.17186844E-05_JPRB, 0.17209215E-05_JPRB, &
  & 0.17240771E-05_JPRB, 0.17279606E-05_JPRB, 0.17312581E-05_JPRB, 0.17345691E-05_JPRB, 0.17377594E-05_JPRB, 0.17409392E-05_JPRB, &
  & 0.17424515E-05_JPRB, 0.17442668E-05_JPRB, 0.17463048E-05_JPRB, 0.17477511E-05_JPRB, 0.17498859E-05_JPRB, 0.17523441E-05_JPRB, &
  & 0.17551217E-05_JPRB, 0.17573294E-05_JPRB, 0.17603585E-05_JPRB, 0.17633004E-05_JPRB, 0.17653232E-05_JPRB, 0.17661577E-05_JPRB, &
  & 0.17665242E-05_JPRB, 0.17675071E-05_JPRB, 0.17687122E-05_JPRB, 0.17695779E-05_JPRB  /)

RGHG2(:,61, 5) = (/ &
  & 0.16945967E-05_JPRB, 0.16941729E-05_JPRB, 0.16940875E-05_JPRB, 0.16942901E-05_JPRB, 0.16946899E-05_JPRB, 0.16948391E-05_JPRB, &
  & 0.16947750E-05_JPRB, 0.16948312E-05_JPRB, 0.16951579E-05_JPRB, 0.16959407E-05_JPRB, 0.16966366E-05_JPRB, 0.16973453E-05_JPRB, &
  & 0.16981461E-05_JPRB, 0.16988985E-05_JPRB, 0.16996349E-05_JPRB, 0.17004329E-05_JPRB, 0.17013793E-05_JPRB, 0.17024205E-05_JPRB, &
  & 0.17032820E-05_JPRB, 0.17042429E-05_JPRB, 0.17056254E-05_JPRB, 0.17074151E-05_JPRB, 0.17093675E-05_JPRB, 0.17110891E-05_JPRB, &
  & 0.17120900E-05_JPRB, 0.17129014E-05_JPRB, 0.17134196E-05_JPRB, 0.17135708E-05_JPRB, 0.17138251E-05_JPRB, 0.17142678E-05_JPRB, &
  & 0.17150434E-05_JPRB, 0.17154256E-05_JPRB, 0.17148158E-05_JPRB, 0.17137369E-05_JPRB, 0.17138541E-05_JPRB, 0.17143448E-05_JPRB, &
  & 0.17155658E-05_JPRB, 0.17166545E-05_JPRB, 0.17167450E-05_JPRB, 0.17168994E-05_JPRB, 0.17183795E-05_JPRB, 0.17207135E-05_JPRB, &
  & 0.17239737E-05_JPRB, 0.17279068E-05_JPRB, 0.17314807E-05_JPRB, 0.17348270E-05_JPRB, 0.17381307E-05_JPRB, 0.17415264E-05_JPRB, &
  & 0.17431169E-05_JPRB, 0.17449950E-05_JPRB, 0.17471145E-05_JPRB, 0.17486786E-05_JPRB, 0.17507958E-05_JPRB, 0.17531836E-05_JPRB, &
  & 0.17561176E-05_JPRB, 0.17584475E-05_JPRB, 0.17615746E-05_JPRB, 0.17645419E-05_JPRB, 0.17666516E-05_JPRB, 0.17675181E-05_JPRB, &
  & 0.17676467E-05_JPRB, 0.17686869E-05_JPRB, 0.17697058E-05_JPRB, 0.17703920E-05_JPRB  /)

RGHG2(:,62, 5) = (/ &
  & 0.16938550E-05_JPRB, 0.16933862E-05_JPRB, 0.16932801E-05_JPRB, 0.16934711E-05_JPRB, 0.16938384E-05_JPRB, 0.16939612E-05_JPRB, &
  & 0.16939158E-05_JPRB, 0.16939693E-05_JPRB, 0.16943288E-05_JPRB, 0.16951182E-05_JPRB, 0.16958358E-05_JPRB, 0.16965625E-05_JPRB, &
  & 0.16974068E-05_JPRB, 0.16982548E-05_JPRB, 0.16990642E-05_JPRB, 0.16998969E-05_JPRB, 0.17008582E-05_JPRB, 0.17018871E-05_JPRB, &
  & 0.17027563E-05_JPRB, 0.17036793E-05_JPRB, 0.17049681E-05_JPRB, 0.17066390E-05_JPRB, 0.17084999E-05_JPRB, 0.17102744E-05_JPRB, &
  & 0.17114518E-05_JPRB, 0.17123158E-05_JPRB, 0.17129055E-05_JPRB, 0.17130853E-05_JPRB, 0.17133966E-05_JPRB, 0.17139235E-05_JPRB, &
  & 0.17148713E-05_JPRB, 0.17151954E-05_JPRB, 0.17143896E-05_JPRB, 0.17131448E-05_JPRB, 0.17133385E-05_JPRB, 0.17139836E-05_JPRB, &
  & 0.17152255E-05_JPRB, 0.17162442E-05_JPRB, 0.17161562E-05_JPRB, 0.17164803E-05_JPRB, 0.17179699E-05_JPRB, 0.17204488E-05_JPRB, &
  & 0.17238765E-05_JPRB, 0.17279113E-05_JPRB, 0.17317411E-05_JPRB, 0.17351376E-05_JPRB, 0.17385275E-05_JPRB, 0.17420782E-05_JPRB, &
  & 0.17436899E-05_JPRB, 0.17456768E-05_JPRB, 0.17479367E-05_JPRB, 0.17496028E-05_JPRB, 0.17517092E-05_JPRB, 0.17541107E-05_JPRB, &
  & 0.17572207E-05_JPRB, 0.17597029E-05_JPRB, 0.17628986E-05_JPRB, 0.17659010E-05_JPRB, 0.17681510E-05_JPRB, 0.17690333E-05_JPRB, &
  & 0.17689532E-05_JPRB, 0.17699815E-05_JPRB, 0.17707888E-05_JPRB, 0.17713394E-05_JPRB  /)

RGHG2(:,63, 5) = (/ &
  & 0.16931376E-05_JPRB, 0.16926257E-05_JPRB, 0.16924969E-05_JPRB, 0.16926856E-05_JPRB, 0.16930275E-05_JPRB, 0.16931315E-05_JPRB, &
  & 0.16931093E-05_JPRB, 0.16931736E-05_JPRB, 0.16935509E-05_JPRB, 0.16943306E-05_JPRB, 0.16950611E-05_JPRB, 0.16958041E-05_JPRB, &
  & 0.16966768E-05_JPRB, 0.16976078E-05_JPRB, 0.16984862E-05_JPRB, 0.16993570E-05_JPRB, 0.17003280E-05_JPRB, 0.17013482E-05_JPRB, &
  & 0.17022135E-05_JPRB, 0.17030840E-05_JPRB, 0.17042869E-05_JPRB, 0.17058239E-05_JPRB, 0.17075621E-05_JPRB, 0.17093252E-05_JPRB, &
  & 0.17106942E-05_JPRB, 0.17115991E-05_JPRB, 0.17122355E-05_JPRB, 0.17125100E-05_JPRB, 0.17129389E-05_JPRB, 0.17135868E-05_JPRB, &
  & 0.17146915E-05_JPRB, 0.17149365E-05_JPRB, 0.17138468E-05_JPRB, 0.17123889E-05_JPRB, 0.17126487E-05_JPRB, 0.17134300E-05_JPRB, &
  & 0.17146875E-05_JPRB, 0.17155902E-05_JPRB, 0.17153904E-05_JPRB, 0.17158384E-05_JPRB, 0.17174045E-05_JPRB, 0.17201236E-05_JPRB, &
  & 0.17237753E-05_JPRB, 0.17279782E-05_JPRB, 0.17320369E-05_JPRB, 0.17355094E-05_JPRB, 0.17389672E-05_JPRB, 0.17425989E-05_JPRB, &
  & 0.17442208E-05_JPRB, 0.17463613E-05_JPRB, 0.17487781E-05_JPRB, 0.17505466E-05_JPRB, 0.17526604E-05_JPRB, 0.17551408E-05_JPRB, &
  & 0.17584399E-05_JPRB, 0.17610932E-05_JPRB, 0.17643701E-05_JPRB, 0.17674004E-05_JPRB, 0.17698175E-05_JPRB, 0.17707382E-05_JPRB, &
  & 0.17704667E-05_JPRB, 0.17713899E-05_JPRB, 0.17719817E-05_JPRB, 0.17724706E-05_JPRB  /)

RGHG2(:,64, 5) = (/ &
  & 0.16924425E-05_JPRB, 0.16918969E-05_JPRB, 0.16917440E-05_JPRB, 0.16919363E-05_JPRB, 0.16922650E-05_JPRB, 0.16923641E-05_JPRB, &
  & 0.16923732E-05_JPRB, 0.16924665E-05_JPRB, 0.16928450E-05_JPRB, 0.16936054E-05_JPRB, 0.16943347E-05_JPRB, 0.16950909E-05_JPRB, &
  & 0.16959757E-05_JPRB, 0.16969609E-05_JPRB, 0.16978995E-05_JPRB, 0.16988101E-05_JPRB, 0.16997859E-05_JPRB, 0.17007988E-05_JPRB, &
  & 0.17016509E-05_JPRB, 0.17024575E-05_JPRB, 0.17035967E-05_JPRB, 0.17049951E-05_JPRB, 0.17065851E-05_JPRB, 0.17082687E-05_JPRB, &
  & 0.17098233E-05_JPRB, 0.17107546E-05_JPRB, 0.17113886E-05_JPRB, 0.17118439E-05_JPRB, 0.17124064E-05_JPRB, 0.17132109E-05_JPRB, &
  & 0.17144240E-05_JPRB, 0.17146342E-05_JPRB, 0.17131637E-05_JPRB, 0.17114637E-05_JPRB, 0.17117620E-05_JPRB, 0.17126265E-05_JPRB, &
  & 0.17138949E-05_JPRB, 0.17145891E-05_JPRB, 0.17143532E-05_JPRB, 0.17148132E-05_JPRB, 0.17165805E-05_JPRB, 0.17197189E-05_JPRB, &
  & 0.17236621E-05_JPRB, 0.17281385E-05_JPRB, 0.17323706E-05_JPRB, 0.17359648E-05_JPRB, 0.17394707E-05_JPRB, 0.17430579E-05_JPRB, &
  & 0.17447207E-05_JPRB, 0.17470733E-05_JPRB, 0.17496213E-05_JPRB, 0.17515056E-05_JPRB, 0.17536651E-05_JPRB, 0.17562972E-05_JPRB, &
  & 0.17597903E-05_JPRB, 0.17626243E-05_JPRB, 0.17660410E-05_JPRB, 0.17690700E-05_JPRB, 0.17716594E-05_JPRB, 0.17726897E-05_JPRB, &
  & 0.17722484E-05_JPRB, 0.17729090E-05_JPRB, 0.17733105E-05_JPRB, 0.17738789E-05_JPRB  /)

RGHG2(:,65, 5) = (/ &
  & 0.16917924E-05_JPRB, 0.16912241E-05_JPRB, 0.16910570E-05_JPRB, 0.16912473E-05_JPRB, 0.16915693E-05_JPRB, 0.16916759E-05_JPRB, &
  & 0.16917200E-05_JPRB, 0.16918513E-05_JPRB, 0.16922154E-05_JPRB, 0.16929597E-05_JPRB, 0.16936733E-05_JPRB, 0.16944271E-05_JPRB, &
  & 0.16953072E-05_JPRB, 0.16963246E-05_JPRB, 0.16973104E-05_JPRB, 0.16982353E-05_JPRB, 0.16992204E-05_JPRB, 0.17002250E-05_JPRB, &
  & 0.17010716E-05_JPRB, 0.17018195E-05_JPRB, 0.17028909E-05_JPRB, 0.17041632E-05_JPRB, 0.17056208E-05_JPRB, 0.17071872E-05_JPRB, &
  & 0.17088356E-05_JPRB, 0.17098666E-05_JPRB, 0.17104757E-05_JPRB, 0.17111209E-05_JPRB, 0.17117924E-05_JPRB, 0.17127311E-05_JPRB, &
  & 0.17140244E-05_JPRB, 0.17142082E-05_JPRB, 0.17124159E-05_JPRB, 0.17106031E-05_JPRB, 0.17107553E-05_JPRB, 0.17115005E-05_JPRB, &
  & 0.17126150E-05_JPRB, 0.17131564E-05_JPRB, 0.17128146E-05_JPRB, 0.17132060E-05_JPRB, 0.17152994E-05_JPRB, 0.17191943E-05_JPRB, &
  & 0.17235535E-05_JPRB, 0.17283547E-05_JPRB, 0.17327527E-05_JPRB, 0.17365165E-05_JPRB, 0.17400654E-05_JPRB, 0.17435606E-05_JPRB, &
  & 0.17453577E-05_JPRB, 0.17479217E-05_JPRB, 0.17505247E-05_JPRB, 0.17525344E-05_JPRB, 0.17548074E-05_JPRB, 0.17576272E-05_JPRB, &
  & 0.17613494E-05_JPRB, 0.17643520E-05_JPRB, 0.17679633E-05_JPRB, 0.17709978E-05_JPRB, 0.17736890E-05_JPRB, 0.17749016E-05_JPRB, &
  & 0.17743295E-05_JPRB, 0.17746021E-05_JPRB, 0.17748892E-05_JPRB, 0.17755567E-05_JPRB  /)

RGHG2(:,66, 5) = (/ &
  & 0.16911613E-05_JPRB, 0.16905863E-05_JPRB, 0.16904107E-05_JPRB, 0.16905964E-05_JPRB, 0.16909094E-05_JPRB, 0.16910247E-05_JPRB, &
  & 0.16911016E-05_JPRB, 0.16912709E-05_JPRB, 0.16916140E-05_JPRB, 0.16923480E-05_JPRB, 0.16930422E-05_JPRB, 0.16937839E-05_JPRB, &
  & 0.16946458E-05_JPRB, 0.16956855E-05_JPRB, 0.16967061E-05_JPRB, 0.16976376E-05_JPRB, 0.16986291E-05_JPRB, 0.16996286E-05_JPRB, &
  & 0.17004801E-05_JPRB, 0.17011830E-05_JPRB, 0.17021799E-05_JPRB, 0.17033359E-05_JPRB, 0.17046739E-05_JPRB, 0.17061143E-05_JPRB, &
  & 0.17077717E-05_JPRB, 0.17088949E-05_JPRB, 0.17095652E-05_JPRB, 0.17103451E-05_JPRB, 0.17110593E-05_JPRB, 0.17121457E-05_JPRB, &
  & 0.17135354E-05_JPRB, 0.17136983E-05_JPRB, 0.17116751E-05_JPRB, 0.17098796E-05_JPRB, 0.17097811E-05_JPRB, 0.17102048E-05_JPRB, &
  & 0.17109367E-05_JPRB, 0.17112983E-05_JPRB, 0.17110155E-05_JPRB, 0.17114309E-05_JPRB, 0.17139176E-05_JPRB, 0.17185959E-05_JPRB, &
  & 0.17234587E-05_JPRB, 0.17285123E-05_JPRB, 0.17331611E-05_JPRB, 0.17371816E-05_JPRB, 0.17407912E-05_JPRB, 0.17441588E-05_JPRB, &
  & 0.17461614E-05_JPRB, 0.17489453E-05_JPRB, 0.17515410E-05_JPRB, 0.17536477E-05_JPRB, 0.17560887E-05_JPRB, 0.17591018E-05_JPRB, &
  & 0.17630493E-05_JPRB, 0.17662395E-05_JPRB, 0.17700343E-05_JPRB, 0.17731421E-05_JPRB, 0.17759363E-05_JPRB, 0.17773326E-05_JPRB, &
  & 0.17765733E-05_JPRB, 0.17764547E-05_JPRB, 0.17767050E-05_JPRB, 0.17774444E-05_JPRB  /)

RGHG2(:,67, 5) = (/ &
  & 0.16905638E-05_JPRB, 0.16899961E-05_JPRB, 0.16898140E-05_JPRB, 0.16899927E-05_JPRB, 0.16902949E-05_JPRB, 0.16904182E-05_JPRB, &
  & 0.16905213E-05_JPRB, 0.16907245E-05_JPRB, 0.16910437E-05_JPRB, 0.16917709E-05_JPRB, 0.16924458E-05_JPRB, 0.16931699E-05_JPRB, &
  & 0.16940039E-05_JPRB, 0.16950511E-05_JPRB, 0.16960926E-05_JPRB, 0.16970284E-05_JPRB, 0.16980215E-05_JPRB, 0.16990182E-05_JPRB, &
  & 0.16998851E-05_JPRB, 0.17005617E-05_JPRB, 0.17014805E-05_JPRB, 0.17025338E-05_JPRB, 0.17037605E-05_JPRB, 0.17050762E-05_JPRB, &
  & 0.17066611E-05_JPRB, 0.17078413E-05_JPRB, 0.17086532E-05_JPRB, 0.17094960E-05_JPRB, 0.17102103E-05_JPRB, 0.17114456E-05_JPRB, &
  & 0.17129774E-05_JPRB, 0.17130866E-05_JPRB, 0.17109190E-05_JPRB, 0.17092763E-05_JPRB, 0.17088668E-05_JPRB, 0.17088251E-05_JPRB, &
  & 0.17090129E-05_JPRB, 0.17091825E-05_JPRB, 0.17090882E-05_JPRB, 0.17096160E-05_JPRB, 0.17126015E-05_JPRB, 0.17180093E-05_JPRB, &
  & 0.17233589E-05_JPRB, 0.17286150E-05_JPRB, 0.17335965E-05_JPRB, 0.17379467E-05_JPRB, 0.17416468E-05_JPRB, 0.17448907E-05_JPRB, &
  & 0.17471498E-05_JPRB, 0.17501411E-05_JPRB, 0.17526987E-05_JPRB, 0.17548698E-05_JPRB, 0.17575192E-05_JPRB, 0.17607023E-05_JPRB, &
  & 0.17648740E-05_JPRB, 0.17682675E-05_JPRB, 0.17722445E-05_JPRB, 0.17754699E-05_JPRB, 0.17784039E-05_JPRB, 0.17799843E-05_JPRB, &
  & 0.17789574E-05_JPRB, 0.17784887E-05_JPRB, 0.17787592E-05_JPRB, 0.17795279E-05_JPRB  /)

RGHG2(:,68, 5) = (/ &
  & 0.16900268E-05_JPRB, 0.16894740E-05_JPRB, 0.16892807E-05_JPRB, 0.16894495E-05_JPRB, 0.16897418E-05_JPRB, 0.16898713E-05_JPRB, &
  & 0.16899855E-05_JPRB, 0.16902122E-05_JPRB, 0.16905104E-05_JPRB, 0.16912289E-05_JPRB, 0.16918903E-05_JPRB, 0.16925995E-05_JPRB, &
  & 0.16934038E-05_JPRB, 0.16944312E-05_JPRB, 0.16954777E-05_JPRB, 0.16964234E-05_JPRB, 0.16974115E-05_JPRB, 0.16984045E-05_JPRB, &
  & 0.16992962E-05_JPRB, 0.16999728E-05_JPRB, 0.17008173E-05_JPRB, 0.17017878E-05_JPRB, 0.17028994E-05_JPRB, 0.17041075E-05_JPRB, &
  & 0.17055477E-05_JPRB, 0.17067068E-05_JPRB, 0.17077042E-05_JPRB, 0.17085199E-05_JPRB, 0.17092540E-05_JPRB, 0.17106080E-05_JPRB, &
  & 0.17123823E-05_JPRB, 0.17123233E-05_JPRB, 0.17100752E-05_JPRB, 0.17087269E-05_JPRB, 0.17080255E-05_JPRB, 0.17075039E-05_JPRB, &
  & 0.17071462E-05_JPRB, 0.17071586E-05_JPRB, 0.17072536E-05_JPRB, 0.17079361E-05_JPRB, 0.17116216E-05_JPRB, 0.17176034E-05_JPRB, &
  & 0.17232103E-05_JPRB, 0.17286977E-05_JPRB, 0.17340688E-05_JPRB, 0.17387853E-05_JPRB, 0.17426263E-05_JPRB, 0.17458331E-05_JPRB, &
  & 0.17483606E-05_JPRB, 0.17515028E-05_JPRB, 0.17540580E-05_JPRB, 0.17562625E-05_JPRB, 0.17591333E-05_JPRB, 0.17624092E-05_JPRB, &
  & 0.17668208E-05_JPRB, 0.17704221E-05_JPRB, 0.17746168E-05_JPRB, 0.17779400E-05_JPRB, 0.17811152E-05_JPRB, 0.17828935E-05_JPRB, &
  & 0.17814856E-05_JPRB, 0.17807732E-05_JPRB, 0.17810735E-05_JPRB, 0.17818075E-05_JPRB  /)

RGHG2(:,69, 5) = (/ &
  & 0.16895465E-05_JPRB, 0.16890041E-05_JPRB, 0.16887929E-05_JPRB, 0.16889586E-05_JPRB, 0.16892466E-05_JPRB, 0.16893823E-05_JPRB, &
  & 0.16894930E-05_JPRB, 0.16897184E-05_JPRB, 0.16899911E-05_JPRB, 0.16906964E-05_JPRB, 0.16913487E-05_JPRB, 0.16920498E-05_JPRB, &
  & 0.16928256E-05_JPRB, 0.16938106E-05_JPRB, 0.16948486E-05_JPRB, 0.16958098E-05_JPRB, 0.16968009E-05_JPRB, 0.16977755E-05_JPRB, &
  & 0.16986897E-05_JPRB, 0.16994023E-05_JPRB, 0.17001794E-05_JPRB, 0.17010771E-05_JPRB, 0.17020658E-05_JPRB, 0.17031528E-05_JPRB, &
  & 0.17044078E-05_JPRB, 0.17055245E-05_JPRB, 0.17065960E-05_JPRB, 0.17073721E-05_JPRB, 0.17081631E-05_JPRB, 0.17097687E-05_JPRB, &
  & 0.17117358E-05_JPRB, 0.17115052E-05_JPRB, 0.17093321E-05_JPRB, 0.17082241E-05_JPRB, 0.17072928E-05_JPRB, 0.17065469E-05_JPRB, &
  & 0.17058464E-05_JPRB, 0.17055847E-05_JPRB, 0.17056595E-05_JPRB, 0.17065225E-05_JPRB, 0.17109002E-05_JPRB, 0.17175312E-05_JPRB, &
  & 0.17231094E-05_JPRB, 0.17290408E-05_JPRB, 0.17347486E-05_JPRB, 0.17397422E-05_JPRB, 0.17437332E-05_JPRB, 0.17471101E-05_JPRB, &
  & 0.17498677E-05_JPRB, 0.17529863E-05_JPRB, 0.17556639E-05_JPRB, 0.17579829E-05_JPRB, 0.17610402E-05_JPRB, 0.17643446E-05_JPRB, &
  & 0.17689534E-05_JPRB, 0.17728267E-05_JPRB, 0.17771996E-05_JPRB, 0.17806002E-05_JPRB, 0.17840628E-05_JPRB, 0.17859972E-05_JPRB, &
  & 0.17842704E-05_JPRB, 0.17833898E-05_JPRB, 0.17836499E-05_JPRB, 0.17842863E-05_JPRB  /)

RGHG2(:,70, 5) = (/ &
  & 0.16891001E-05_JPRB, 0.16885669E-05_JPRB, 0.16883364E-05_JPRB, 0.16885018E-05_JPRB, 0.16887868E-05_JPRB, 0.16889250E-05_JPRB, &
  & 0.16890301E-05_JPRB, 0.16892410E-05_JPRB, 0.16894877E-05_JPRB, 0.16901672E-05_JPRB, 0.16908143E-05_JPRB, 0.16915116E-05_JPRB, &
  & 0.16922560E-05_JPRB, 0.16931922E-05_JPRB, 0.16942073E-05_JPRB, 0.16951860E-05_JPRB, 0.16961787E-05_JPRB, 0.16971356E-05_JPRB, &
  & 0.16980663E-05_JPRB, 0.16988136E-05_JPRB, 0.16995468E-05_JPRB, 0.17003755E-05_JPRB, 0.17012518E-05_JPRB, 0.17022096E-05_JPRB, &
  & 0.17032563E-05_JPRB, 0.17042889E-05_JPRB, 0.17053819E-05_JPRB, 0.17061321E-05_JPRB, 0.17069874E-05_JPRB, 0.17089316E-05_JPRB, &
  & 0.17110518E-05_JPRB, 0.17108251E-05_JPRB, 0.17087971E-05_JPRB, 0.17077808E-05_JPRB, 0.17066862E-05_JPRB, 0.17058106E-05_JPRB, &
  & 0.17049283E-05_JPRB, 0.17043624E-05_JPRB, 0.17043603E-05_JPRB, 0.17054009E-05_JPRB, 0.17103994E-05_JPRB, 0.17177187E-05_JPRB, &
  & 0.17232866E-05_JPRB, 0.17297451E-05_JPRB, 0.17356362E-05_JPRB, 0.17408821E-05_JPRB, 0.17449798E-05_JPRB, 0.17485914E-05_JPRB, &
  & 0.17515815E-05_JPRB, 0.17546196E-05_JPRB, 0.17574661E-05_JPRB, 0.17599401E-05_JPRB, 0.17631686E-05_JPRB, 0.17665298E-05_JPRB, &
  & 0.17712888E-05_JPRB, 0.17754639E-05_JPRB, 0.17799340E-05_JPRB, 0.17834921E-05_JPRB, 0.17871479E-05_JPRB, 0.17891730E-05_JPRB, &
  & 0.17872124E-05_JPRB, 0.17861815E-05_JPRB, 0.17863456E-05_JPRB, 0.17868815E-05_JPRB  /)

RGHG2(:,71, 5) = (/ &
  & 0.16886836E-05_JPRB, 0.16881618E-05_JPRB, 0.16879149E-05_JPRB, 0.16880796E-05_JPRB, 0.16883622E-05_JPRB, 0.16884973E-05_JPRB, &
  & 0.16885974E-05_JPRB, 0.16887848E-05_JPRB, 0.16890039E-05_JPRB, 0.16896477E-05_JPRB, 0.16902918E-05_JPRB, 0.16909872E-05_JPRB, &
  & 0.16916957E-05_JPRB, 0.16925801E-05_JPRB, 0.16935605E-05_JPRB, 0.16945541E-05_JPRB, 0.16955426E-05_JPRB, 0.16964882E-05_JPRB, &
  & 0.16974216E-05_JPRB, 0.16982008E-05_JPRB, 0.16989132E-05_JPRB, 0.16996791E-05_JPRB, 0.17004535E-05_JPRB, 0.17012741E-05_JPRB, &
  & 0.17021052E-05_JPRB, 0.17029867E-05_JPRB, 0.17040756E-05_JPRB, 0.17048375E-05_JPRB, 0.17057804E-05_JPRB, 0.17081014E-05_JPRB, &
  & 0.17103496E-05_JPRB, 0.17103334E-05_JPRB, 0.17084792E-05_JPRB, 0.17074221E-05_JPRB, 0.17062294E-05_JPRB, 0.17052769E-05_JPRB, &
  & 0.17043116E-05_JPRB, 0.17034821E-05_JPRB, 0.17033682E-05_JPRB, 0.17046187E-05_JPRB, 0.17101355E-05_JPRB, 0.17181399E-05_JPRB, &
  & 0.17238217E-05_JPRB, 0.17308109E-05_JPRB, 0.17367564E-05_JPRB, 0.17422346E-05_JPRB, 0.17464107E-05_JPRB, 0.17502774E-05_JPRB, &
  & 0.17535021E-05_JPRB, 0.17564206E-05_JPRB, 0.17594862E-05_JPRB, 0.17621561E-05_JPRB, 0.17655370E-05_JPRB, 0.17689809E-05_JPRB, &
  & 0.17738455E-05_JPRB, 0.17783565E-05_JPRB, 0.17828328E-05_JPRB, 0.17866461E-05_JPRB, 0.17903841E-05_JPRB, 0.17924382E-05_JPRB, &
  & 0.17903200E-05_JPRB, 0.17891784E-05_JPRB, 0.17892044E-05_JPRB, 0.17896461E-05_JPRB  /)

RGHG2(:,72, 5) = (/ &
  & 0.16882928E-05_JPRB, 0.16877908E-05_JPRB, 0.16875378E-05_JPRB, 0.16876963E-05_JPRB, 0.16879764E-05_JPRB, 0.16880992E-05_JPRB, &
  & 0.16881980E-05_JPRB, 0.16883582E-05_JPRB, 0.16885450E-05_JPRB, 0.16891505E-05_JPRB, 0.16897896E-05_JPRB, 0.16904813E-05_JPRB, &
  & 0.16911465E-05_JPRB, 0.16919801E-05_JPRB, 0.16929184E-05_JPRB, 0.16939157E-05_JPRB, 0.16948882E-05_JPRB, 0.16958362E-05_JPRB, &
  & 0.16967436E-05_JPRB, 0.16975574E-05_JPRB, 0.16982687E-05_JPRB, 0.16989838E-05_JPRB, 0.16996628E-05_JPRB, 0.17003360E-05_JPRB, &
  & 0.17009703E-05_JPRB, 0.17015868E-05_JPRB, 0.17026857E-05_JPRB, 0.17035380E-05_JPRB, 0.17046294E-05_JPRB, 0.17072835E-05_JPRB, &
  & 0.17096604E-05_JPRB, 0.17100900E-05_JPRB, 0.17083769E-05_JPRB, 0.17071948E-05_JPRB, 0.17059662E-05_JPRB, 0.17049444E-05_JPRB, &
  & 0.17038850E-05_JPRB, 0.17029515E-05_JPRB, 0.17026988E-05_JPRB, 0.17042676E-05_JPRB, 0.17101522E-05_JPRB, 0.17187670E-05_JPRB, &
  & 0.17248314E-05_JPRB, 0.17322305E-05_JPRB, 0.17381673E-05_JPRB, 0.17438535E-05_JPRB, 0.17481200E-05_JPRB, 0.17522084E-05_JPRB, &
  & 0.17556608E-05_JPRB, 0.17584283E-05_JPRB, 0.17617898E-05_JPRB, 0.17647074E-05_JPRB, 0.17682108E-05_JPRB, 0.17717402E-05_JPRB, &
  & 0.17766704E-05_JPRB, 0.17815689E-05_JPRB, 0.17859487E-05_JPRB, 0.17901310E-05_JPRB, 0.17938343E-05_JPRB, 0.17958673E-05_JPRB, &
  & 0.17936464E-05_JPRB, 0.17924887E-05_JPRB, 0.17923562E-05_JPRB, 0.17927149E-05_JPRB  /)

RGHG2(:,73, 5) = (/ &
  & 0.16879255E-05_JPRB, 0.16874573E-05_JPRB, 0.16872107E-05_JPRB, 0.16873572E-05_JPRB, 0.16876348E-05_JPRB, 0.16877382E-05_JPRB, &
  & 0.16878370E-05_JPRB, 0.16879720E-05_JPRB, 0.16881288E-05_JPRB, 0.16886991E-05_JPRB, 0.16893263E-05_JPRB, 0.16899925E-05_JPRB, &
  & 0.16906335E-05_JPRB, 0.16914104E-05_JPRB, 0.16922948E-05_JPRB, 0.16932970E-05_JPRB, 0.16942223E-05_JPRB, 0.16951797E-05_JPRB, &
  & 0.16960460E-05_JPRB, 0.16969062E-05_JPRB, 0.16976311E-05_JPRB, 0.16982894E-05_JPRB, 0.16988370E-05_JPRB, 0.16993677E-05_JPRB, &
  & 0.16998212E-05_JPRB, 0.17002769E-05_JPRB, 0.17013007E-05_JPRB, 0.17022542E-05_JPRB, 0.17035618E-05_JPRB, 0.17065267E-05_JPRB, &
  & 0.17090217E-05_JPRB, 0.17099709E-05_JPRB, 0.17084687E-05_JPRB, 0.17072149E-05_JPRB, 0.17059950E-05_JPRB, 0.17047839E-05_JPRB, &
  & 0.17036229E-05_JPRB, 0.17027641E-05_JPRB, 0.17024547E-05_JPRB, 0.17043056E-05_JPRB, 0.17104647E-05_JPRB, 0.17197544E-05_JPRB, &
  & 0.17264071E-05_JPRB, 0.17340264E-05_JPRB, 0.17401166E-05_JPRB, 0.17458534E-05_JPRB, 0.17501545E-05_JPRB, 0.17543336E-05_JPRB, &
  & 0.17579670E-05_JPRB, 0.17607549E-05_JPRB, 0.17644727E-05_JPRB, 0.17676945E-05_JPRB, 0.17712603E-05_JPRB, 0.17749228E-05_JPRB, &
  & 0.17799155E-05_JPRB, 0.17849292E-05_JPRB, 0.17893382E-05_JPRB, 0.17940457E-05_JPRB, 0.17975785E-05_JPRB, 0.17996398E-05_JPRB, &
  & 0.17974292E-05_JPRB, 0.17965024E-05_JPRB, 0.17963139E-05_JPRB, 0.17969558E-05_JPRB  /)

RGHG2(:,74, 5) = (/ &
  & 0.16875778E-05_JPRB, 0.16871503E-05_JPRB, 0.16869202E-05_JPRB, 0.16870498E-05_JPRB, 0.16873248E-05_JPRB, 0.16874083E-05_JPRB, &
  & 0.16875056E-05_JPRB, 0.16876233E-05_JPRB, 0.16877547E-05_JPRB, 0.16883036E-05_JPRB, 0.16889124E-05_JPRB, 0.16895481E-05_JPRB, &
  & 0.16901668E-05_JPRB, 0.16908864E-05_JPRB, 0.16917161E-05_JPRB, 0.16927098E-05_JPRB, 0.16935808E-05_JPRB, 0.16945257E-05_JPRB, &
  & 0.16953707E-05_JPRB, 0.16962572E-05_JPRB, 0.16969926E-05_JPRB, 0.16976056E-05_JPRB, 0.16980127E-05_JPRB, 0.16984016E-05_JPRB, &
  & 0.16987476E-05_JPRB, 0.16991277E-05_JPRB, 0.17000694E-05_JPRB, 0.17010771E-05_JPRB, 0.17025763E-05_JPRB, 0.17058470E-05_JPRB, &
  & 0.17084141E-05_JPRB, 0.17098362E-05_JPRB, 0.17086283E-05_JPRB, 0.17073700E-05_JPRB, 0.17061806E-05_JPRB, 0.17048361E-05_JPRB, &
  & 0.17034983E-05_JPRB, 0.17027201E-05_JPRB, 0.17024582E-05_JPRB, 0.17045804E-05_JPRB, 0.17110641E-05_JPRB, 0.17211516E-05_JPRB, &
  & 0.17284017E-05_JPRB, 0.17360906E-05_JPRB, 0.17423625E-05_JPRB, 0.17480903E-05_JPRB, 0.17523256E-05_JPRB, 0.17564767E-05_JPRB, &
  & 0.17603586E-05_JPRB, 0.17632800E-05_JPRB, 0.17673842E-05_JPRB, 0.17709551E-05_JPRB, 0.17745736E-05_JPRB, 0.17782967E-05_JPRB, &
  & 0.17833128E-05_JPRB, 0.17883409E-05_JPRB, 0.17928137E-05_JPRB, 0.17980438E-05_JPRB, 0.18014398E-05_JPRB, 0.18035170E-05_JPRB, &
  & 0.18015043E-05_JPRB, 0.18009620E-05_JPRB, 0.18008578E-05_JPRB, 0.18020167E-05_JPRB  /)

RGHG2(:,75, 5) = (/ &
  & 0.16872507E-05_JPRB, 0.16868700E-05_JPRB, 0.16866643E-05_JPRB, 0.16867740E-05_JPRB, 0.16870438E-05_JPRB, 0.16871096E-05_JPRB, &
  & 0.16872050E-05_JPRB, 0.16873109E-05_JPRB, 0.16874248E-05_JPRB, 0.16879634E-05_JPRB, 0.16885533E-05_JPRB, 0.16891574E-05_JPRB, &
  & 0.16897517E-05_JPRB, 0.16904176E-05_JPRB, 0.16911927E-05_JPRB, 0.16921642E-05_JPRB, 0.16929788E-05_JPRB, 0.16938827E-05_JPRB, &
  & 0.16947209E-05_JPRB, 0.16956212E-05_JPRB, 0.16963729E-05_JPRB, 0.16969576E-05_JPRB, 0.16972338E-05_JPRB, 0.16974914E-05_JPRB, &
  & 0.16977813E-05_JPRB, 0.16981530E-05_JPRB, 0.16990395E-05_JPRB, 0.17000415E-05_JPRB, 0.17016708E-05_JPRB, 0.17052540E-05_JPRB, &
  & 0.17078516E-05_JPRB, 0.17096675E-05_JPRB, 0.17088342E-05_JPRB, 0.17076303E-05_JPRB, 0.17064968E-05_JPRB, 0.17050986E-05_JPRB, &
  & 0.17035150E-05_JPRB, 0.17027907E-05_JPRB, 0.17026692E-05_JPRB, 0.17050770E-05_JPRB, 0.17119760E-05_JPRB, 0.17229614E-05_JPRB, &
  & 0.17307180E-05_JPRB, 0.17383445E-05_JPRB, 0.17448000E-05_JPRB, 0.17505135E-05_JPRB, 0.17545950E-05_JPRB, 0.17586235E-05_JPRB, &
  & 0.17627679E-05_JPRB, 0.17659257E-05_JPRB, 0.17704540E-05_JPRB, 0.17743627E-05_JPRB, 0.17780550E-05_JPRB, 0.17818291E-05_JPRB, &
  & 0.17867927E-05_JPRB, 0.17918013E-05_JPRB, 0.17963474E-05_JPRB, 0.18020273E-05_JPRB, 0.18053556E-05_JPRB, 0.18073808E-05_JPRB, &
  & 0.18057506E-05_JPRB, 0.18056616E-05_JPRB, 0.18057492E-05_JPRB, 0.18075291E-05_JPRB  /)

RGHG2(:,76, 5) = (/ &
  & 0.16869464E-05_JPRB, 0.16866178E-05_JPRB, 0.16864417E-05_JPRB, 0.16865316E-05_JPRB, 0.16867891E-05_JPRB, 0.16868424E-05_JPRB, &
  & 0.16869379E-05_JPRB, 0.16870339E-05_JPRB, 0.16871428E-05_JPRB, 0.16876764E-05_JPRB, 0.16882564E-05_JPRB, 0.16888308E-05_JPRB, &
  & 0.16893954E-05_JPRB, 0.16900167E-05_JPRB, 0.16907373E-05_JPRB, 0.16916741E-05_JPRB, 0.16924342E-05_JPRB, 0.16932613E-05_JPRB, &
  & 0.16940946E-05_JPRB, 0.16950122E-05_JPRB, 0.16958036E-05_JPRB, 0.16963833E-05_JPRB, 0.16965629E-05_JPRB, 0.16967165E-05_JPRB, &
  & 0.16969593E-05_JPRB, 0.16973657E-05_JPRB, 0.16982671E-05_JPRB, 0.16991898E-05_JPRB, 0.17008414E-05_JPRB, 0.17047614E-05_JPRB, &
  & 0.17073591E-05_JPRB, 0.17094549E-05_JPRB, 0.17090724E-05_JPRB, 0.17079676E-05_JPRB, 0.17069257E-05_JPRB, 0.17055671E-05_JPRB, &
  & 0.17036863E-05_JPRB, 0.17029620E-05_JPRB, 0.17030560E-05_JPRB, 0.17058007E-05_JPRB, 0.17132521E-05_JPRB, 0.17251960E-05_JPRB, &
  & 0.17332375E-05_JPRB, 0.17406907E-05_JPRB, 0.17473096E-05_JPRB, 0.17530752E-05_JPRB, 0.17569386E-05_JPRB, 0.17607838E-05_JPRB, &
  & 0.17651041E-05_JPRB, 0.17685963E-05_JPRB, 0.17736052E-05_JPRB, 0.17777541E-05_JPRB, 0.17815826E-05_JPRB, 0.17855153E-05_JPRB, &
  & 0.17902955E-05_JPRB, 0.17953314E-05_JPRB, 0.17999345E-05_JPRB, 0.18059017E-05_JPRB, 0.18092647E-05_JPRB, 0.18110893E-05_JPRB, &
  & 0.18100164E-05_JPRB, 0.18103311E-05_JPRB, 0.18106640E-05_JPRB, 0.18129863E-05_JPRB  /)

RGHG2(:,77, 5) = (/ &
  & 0.16866626E-05_JPRB, 0.16863915E-05_JPRB, 0.16862479E-05_JPRB, 0.16863249E-05_JPRB, 0.16865603E-05_JPRB, 0.16866082E-05_JPRB, &
  & 0.16867060E-05_JPRB, 0.16867968E-05_JPRB, 0.16869030E-05_JPRB, 0.16874388E-05_JPRB, 0.16880087E-05_JPRB, 0.16885673E-05_JPRB, &
  & 0.16891088E-05_JPRB, 0.16896897E-05_JPRB, 0.16903717E-05_JPRB, 0.16912710E-05_JPRB, 0.16919901E-05_JPRB, 0.16927750E-05_JPRB, &
  & 0.16935890E-05_JPRB, 0.16945314E-05_JPRB, 0.16953796E-05_JPRB, 0.16959781E-05_JPRB, 0.16962051E-05_JPRB, 0.16962722E-05_JPRB, &
  & 0.16964959E-05_JPRB, 0.16969065E-05_JPRB, 0.16977967E-05_JPRB, 0.16986176E-05_JPRB, 0.17001774E-05_JPRB, 0.17043748E-05_JPRB, &
  & 0.17070392E-05_JPRB, 0.17093259E-05_JPRB, 0.17093531E-05_JPRB, 0.17083821E-05_JPRB, 0.17074641E-05_JPRB, 0.17061696E-05_JPRB, &
  & 0.17042160E-05_JPRB, 0.17033630E-05_JPRB, 0.17037734E-05_JPRB, 0.17068502E-05_JPRB, 0.17149786E-05_JPRB, 0.17276065E-05_JPRB, &
  & 0.17358225E-05_JPRB, 0.17431022E-05_JPRB, 0.17498036E-05_JPRB, 0.17556457E-05_JPRB, 0.17593119E-05_JPRB, 0.17629069E-05_JPRB, &
  & 0.17673579E-05_JPRB, 0.17710153E-05_JPRB, 0.17765401E-05_JPRB, 0.17809543E-05_JPRB, 0.17848042E-05_JPRB, 0.17891264E-05_JPRB, &
  & 0.17937779E-05_JPRB, 0.17988581E-05_JPRB, 0.18035713E-05_JPRB, 0.18097466E-05_JPRB, 0.18131733E-05_JPRB, 0.18146253E-05_JPRB, &
  & 0.18144727E-05_JPRB, 0.18149253E-05_JPRB, 0.18152186E-05_JPRB, 0.18177576E-05_JPRB  /)

RGHG2(:,78, 5) = (/ &
  & 0.16864000E-05_JPRB, 0.16861913E-05_JPRB, 0.16860756E-05_JPRB, 0.16861464E-05_JPRB, 0.16863576E-05_JPRB, 0.16864037E-05_JPRB, &
  & 0.16865025E-05_JPRB, 0.16865882E-05_JPRB, 0.16866935E-05_JPRB, 0.16872302E-05_JPRB, 0.16877981E-05_JPRB, 0.16883464E-05_JPRB, &
  & 0.16888718E-05_JPRB, 0.16894173E-05_JPRB, 0.16900761E-05_JPRB, 0.16909506E-05_JPRB, 0.16916376E-05_JPRB, 0.16924160E-05_JPRB, &
  & 0.16932322E-05_JPRB, 0.16941853E-05_JPRB, 0.16950816E-05_JPRB, 0.16957209E-05_JPRB, 0.16959790E-05_JPRB, 0.16959498E-05_JPRB, &
  & 0.16961575E-05_JPRB, 0.16965834E-05_JPRB, 0.16974595E-05_JPRB, 0.16982208E-05_JPRB, 0.16996622E-05_JPRB, 0.17041007E-05_JPRB, &
  & 0.17068624E-05_JPRB, 0.17093584E-05_JPRB, 0.17096749E-05_JPRB, 0.17088439E-05_JPRB, 0.17080097E-05_JPRB, 0.17068027E-05_JPRB, &
  & 0.17049406E-05_JPRB, 0.17041134E-05_JPRB, 0.17047694E-05_JPRB, 0.17080030E-05_JPRB, 0.17168095E-05_JPRB, 0.17300112E-05_JPRB, &
  & 0.17383170E-05_JPRB, 0.17454286E-05_JPRB, 0.17521263E-05_JPRB, 0.17579343E-05_JPRB, 0.17614961E-05_JPRB, 0.17649689E-05_JPRB, &
  & 0.17694296E-05_JPRB, 0.17731545E-05_JPRB, 0.17791571E-05_JPRB, 0.17837602E-05_JPRB, 0.17875901E-05_JPRB, 0.17922125E-05_JPRB, &
  & 0.17970148E-05_JPRB, 0.18023395E-05_JPRB, 0.18072293E-05_JPRB, 0.18134798E-05_JPRB, 0.18168856E-05_JPRB, 0.18180716E-05_JPRB, &
  & 0.18187682E-05_JPRB, 0.18190148E-05_JPRB, 0.18195497E-05_JPRB, 0.18220234E-05_JPRB  /)

RGHG2(:,79, 5) = (/ &
  & 0.16861622E-05_JPRB, 0.16860159E-05_JPRB, 0.16859250E-05_JPRB, 0.16859942E-05_JPRB, 0.16861821E-05_JPRB, 0.16862290E-05_JPRB, &
  & 0.16863285E-05_JPRB, 0.16864100E-05_JPRB, 0.16865186E-05_JPRB, 0.16870497E-05_JPRB, 0.16876153E-05_JPRB, 0.16881609E-05_JPRB, &
  & 0.16886850E-05_JPRB, 0.16892045E-05_JPRB, 0.16898451E-05_JPRB, 0.16907014E-05_JPRB, 0.16913800E-05_JPRB, 0.16921812E-05_JPRB, &
  & 0.16930187E-05_JPRB, 0.16939648E-05_JPRB, 0.16949019E-05_JPRB, 0.16955784E-05_JPRB, 0.16958420E-05_JPRB, 0.16957234E-05_JPRB, &
  & 0.16959177E-05_JPRB, 0.16963589E-05_JPRB, 0.16972232E-05_JPRB, 0.16979631E-05_JPRB, 0.16992797E-05_JPRB, 0.17039193E-05_JPRB, &
  & 0.17068129E-05_JPRB, 0.17095371E-05_JPRB, 0.17100475E-05_JPRB, 0.17093196E-05_JPRB, 0.17085333E-05_JPRB, 0.17074569E-05_JPRB, &
  & 0.17057311E-05_JPRB, 0.17050878E-05_JPRB, 0.17059115E-05_JPRB, 0.17091920E-05_JPRB, 0.17186538E-05_JPRB, 0.17322768E-05_JPRB, &
  & 0.17406147E-05_JPRB, 0.17475809E-05_JPRB, 0.17542208E-05_JPRB, 0.17598785E-05_JPRB, 0.17634221E-05_JPRB, 0.17669246E-05_JPRB, &
  & 0.17712898E-05_JPRB, 0.17750362E-05_JPRB, 0.17814041E-05_JPRB, 0.17861596E-05_JPRB, 0.17900012E-05_JPRB, 0.17947875E-05_JPRB, &
  & 0.17999916E-05_JPRB, 0.18057830E-05_JPRB, 0.18108925E-05_JPRB, 0.18171598E-05_JPRB, 0.18204703E-05_JPRB, 0.18214888E-05_JPRB, &
  & 0.18228149E-05_JPRB, 0.18227578E-05_JPRB, 0.18235433E-05_JPRB, 0.18256366E-05_JPRB  /)

RGHG2(:,80, 5) = (/ &
  & 0.16859526E-05_JPRB, 0.16858631E-05_JPRB, 0.16857970E-05_JPRB, 0.16858661E-05_JPRB, 0.16860343E-05_JPRB, 0.16860835E-05_JPRB, &
  & 0.16861856E-05_JPRB, 0.16862645E-05_JPRB, 0.16863829E-05_JPRB, 0.16868967E-05_JPRB, 0.16874499E-05_JPRB, 0.16880028E-05_JPRB, &
  & 0.16885491E-05_JPRB, 0.16890563E-05_JPRB, 0.16896721E-05_JPRB, 0.16905083E-05_JPRB, 0.16912186E-05_JPRB, 0.16920642E-05_JPRB, &
  & 0.16929362E-05_JPRB, 0.16938551E-05_JPRB, 0.16948298E-05_JPRB, 0.16955112E-05_JPRB, 0.16957549E-05_JPRB, 0.16955746E-05_JPRB, &
  & 0.16957594E-05_JPRB, 0.16962009E-05_JPRB, 0.16970601E-05_JPRB, 0.16978074E-05_JPRB, 0.16990100E-05_JPRB, 0.17038057E-05_JPRB, &
  & 0.17068714E-05_JPRB, 0.17098359E-05_JPRB, 0.17104811E-05_JPRB, 0.17097727E-05_JPRB, 0.17090086E-05_JPRB, 0.17081272E-05_JPRB, &
  & 0.17064506E-05_JPRB, 0.17061319E-05_JPRB, 0.17070484E-05_JPRB, 0.17103541E-05_JPRB, 0.17204309E-05_JPRB, 0.17342640E-05_JPRB, &
  & 0.17426082E-05_JPRB, 0.17494707E-05_JPRB, 0.17560378E-05_JPRB, 0.17614339E-05_JPRB, 0.17650327E-05_JPRB, 0.17687273E-05_JPRB, &
  & 0.17729171E-05_JPRB, 0.17766925E-05_JPRB, 0.17832366E-05_JPRB, 0.17881596E-05_JPRB, 0.17921199E-05_JPRB, 0.17969047E-05_JPRB, &
  & 0.18027090E-05_JPRB, 0.18091972E-05_JPRB, 0.18145358E-05_JPRB, 0.18208488E-05_JPRB, 0.18240140E-05_JPRB, 0.18249327E-05_JPRB, &
  & 0.18265384E-05_JPRB, 0.18263643E-05_JPRB, 0.18270624E-05_JPRB, 0.18284262E-05_JPRB  /)

RGHG2(:,81, 5) = (/ &
  & 0.16857781E-05_JPRB, 0.16857370E-05_JPRB, 0.16856938E-05_JPRB, 0.16857679E-05_JPRB, 0.16859132E-05_JPRB, 0.16859727E-05_JPRB, &
  & 0.16860722E-05_JPRB, 0.16861613E-05_JPRB, 0.16862924E-05_JPRB, 0.16867884E-05_JPRB, 0.16873340E-05_JPRB, 0.16879072E-05_JPRB, &
  & 0.16884714E-05_JPRB, 0.16889658E-05_JPRB, 0.16895739E-05_JPRB, 0.16904127E-05_JPRB, 0.16911943E-05_JPRB, 0.16920807E-05_JPRB, &
  & 0.16929960E-05_JPRB, 0.16938894E-05_JPRB, 0.16948463E-05_JPRB, 0.16955429E-05_JPRB, 0.16957815E-05_JPRB, 0.16955300E-05_JPRB, &
  & 0.16956791E-05_JPRB, 0.16961002E-05_JPRB, 0.16969696E-05_JPRB, 0.16977220E-05_JPRB, 0.16988457E-05_JPRB, 0.17037509E-05_JPRB, &
  & 0.17070458E-05_JPRB, 0.17101708E-05_JPRB, 0.17108287E-05_JPRB, 0.17101636E-05_JPRB, 0.17094199E-05_JPRB, 0.17087346E-05_JPRB, &
  & 0.17071242E-05_JPRB, 0.17070170E-05_JPRB, 0.17081092E-05_JPRB, 0.17113971E-05_JPRB, 0.17218432E-05_JPRB, 0.17360736E-05_JPRB, &
  & 0.17443058E-05_JPRB, 0.17510714E-05_JPRB, 0.17574603E-05_JPRB, 0.17625940E-05_JPRB, 0.17661724E-05_JPRB, 0.17700937E-05_JPRB, &
  & 0.17741231E-05_JPRB, 0.17779800E-05_JPRB, 0.17846183E-05_JPRB, 0.17897374E-05_JPRB, 0.17940085E-05_JPRB, 0.17987042E-05_JPRB, &
  & 0.18050739E-05_JPRB, 0.18121913E-05_JPRB, 0.18182100E-05_JPRB, 0.18246682E-05_JPRB, 0.18274589E-05_JPRB, 0.18283699E-05_JPRB, &
  & 0.18297846E-05_JPRB, 0.18295724E-05_JPRB, 0.18302678E-05_JPRB, 0.18310178E-05_JPRB  /)

RGHG2(:,82, 5) = (/ &
  & 0.16856363E-05_JPRB, 0.16856310E-05_JPRB, 0.16856070E-05_JPRB, 0.16856880E-05_JPRB, 0.16858140E-05_JPRB, 0.16858889E-05_JPRB, &
  & 0.16859789E-05_JPRB, 0.16860833E-05_JPRB, 0.16862324E-05_JPRB, 0.16867089E-05_JPRB, 0.16872556E-05_JPRB, 0.16878421E-05_JPRB, &
  & 0.16884222E-05_JPRB, 0.16889128E-05_JPRB, 0.16895203E-05_JPRB, 0.16903757E-05_JPRB, 0.16912317E-05_JPRB, 0.16921410E-05_JPRB, &
  & 0.16930905E-05_JPRB, 0.16939569E-05_JPRB, 0.16949154E-05_JPRB, 0.16956149E-05_JPRB, 0.16958555E-05_JPRB, 0.16955418E-05_JPRB, &
  & 0.16956450E-05_JPRB, 0.16960511E-05_JPRB, 0.16969394E-05_JPRB, 0.16977021E-05_JPRB, 0.16987701E-05_JPRB, 0.17038105E-05_JPRB, &
  & 0.17072999E-05_JPRB, 0.17105299E-05_JPRB, 0.17111162E-05_JPRB, 0.17105064E-05_JPRB, 0.17097970E-05_JPRB, 0.17093434E-05_JPRB, &
  & 0.17077708E-05_JPRB, 0.17078824E-05_JPRB, 0.17090369E-05_JPRB, 0.17123229E-05_JPRB, 0.17230939E-05_JPRB, 0.17375892E-05_JPRB, &
  & 0.17457328E-05_JPRB, 0.17524251E-05_JPRB, 0.17586526E-05_JPRB, 0.17636310E-05_JPRB, 0.17671611E-05_JPRB, 0.17711742E-05_JPRB, &
  & 0.17750950E-05_JPRB, 0.17789680E-05_JPRB, 0.17857210E-05_JPRB, 0.17909508E-05_JPRB, 0.17956148E-05_JPRB, 0.18002694E-05_JPRB, &
  & 0.18071605E-05_JPRB, 0.18149609E-05_JPRB, 0.18216992E-05_JPRB, 0.18280613E-05_JPRB, 0.18304730E-05_JPRB, 0.18316432E-05_JPRB, &
  & 0.18327118E-05_JPRB, 0.18324669E-05_JPRB, 0.18331528E-05_JPRB, 0.18337193E-05_JPRB  /)

RGHG2(:,83, 5) = (/ &
  & 0.16855280E-05_JPRB, 0.16855431E-05_JPRB, 0.16855368E-05_JPRB, 0.16856233E-05_JPRB, 0.16857366E-05_JPRB, 0.16858320E-05_JPRB, &
  & 0.16859084E-05_JPRB, 0.16860266E-05_JPRB, 0.16862015E-05_JPRB, 0.16866541E-05_JPRB, 0.16872068E-05_JPRB, 0.16878014E-05_JPRB, &
  & 0.16883995E-05_JPRB, 0.16888939E-05_JPRB, 0.16895050E-05_JPRB, 0.16903839E-05_JPRB, 0.16912967E-05_JPRB, 0.16922230E-05_JPRB, &
  & 0.16932065E-05_JPRB, 0.16940501E-05_JPRB, 0.16950294E-05_JPRB, 0.16957186E-05_JPRB, 0.16959564E-05_JPRB, 0.16955987E-05_JPRB, &
  & 0.16956624E-05_JPRB, 0.16960588E-05_JPRB, 0.16969745E-05_JPRB, 0.16977624E-05_JPRB, 0.16987979E-05_JPRB, 0.17039916E-05_JPRB, &
  & 0.17076359E-05_JPRB, 0.17109073E-05_JPRB, 0.17113351E-05_JPRB, 0.17108021E-05_JPRB, 0.17101319E-05_JPRB, 0.17099437E-05_JPRB, &
  & 0.17083874E-05_JPRB, 0.17087082E-05_JPRB, 0.17098607E-05_JPRB, 0.17131478E-05_JPRB, 0.17242341E-05_JPRB, 0.17388439E-05_JPRB, &
  & 0.17469437E-05_JPRB, 0.17535577E-05_JPRB, 0.17596759E-05_JPRB, 0.17646036E-05_JPRB, 0.17680657E-05_JPRB, 0.17720474E-05_JPRB, &
  & 0.17758828E-05_JPRB, 0.17797724E-05_JPRB, 0.17866397E-05_JPRB, 0.17919179E-05_JPRB, 0.17969629E-05_JPRB, 0.18016421E-05_JPRB, &
  & 0.18089879E-05_JPRB, 0.18175047E-05_JPRB, 0.18249855E-05_JPRB, 0.18309144E-05_JPRB, 0.18330444E-05_JPRB, 0.18343455E-05_JPRB, &
  & 0.18351503E-05_JPRB, 0.18349180E-05_JPRB, 0.18357712E-05_JPRB, 0.18362592E-05_JPRB  /)

RGHG2(:,84, 5) = (/ &
  & 0.16854522E-05_JPRB, 0.16854717E-05_JPRB, 0.16854826E-05_JPRB, 0.16855713E-05_JPRB, 0.16856803E-05_JPRB, 0.16858001E-05_JPRB, &
  & 0.16858632E-05_JPRB, 0.16859879E-05_JPRB, 0.16861970E-05_JPRB, 0.16866195E-05_JPRB, 0.16871793E-05_JPRB, 0.16877789E-05_JPRB, &
  & 0.16883991E-05_JPRB, 0.16889035E-05_JPRB, 0.16895194E-05_JPRB, 0.16904235E-05_JPRB, 0.16913623E-05_JPRB, 0.16923082E-05_JPRB, &
  & 0.16933322E-05_JPRB, 0.16941623E-05_JPRB, 0.16951785E-05_JPRB, 0.16958461E-05_JPRB, 0.16960698E-05_JPRB, 0.16956903E-05_JPRB, &
  & 0.16957323E-05_JPRB, 0.16961230E-05_JPRB, 0.16970734E-05_JPRB, 0.16979074E-05_JPRB, 0.16989274E-05_JPRB, 0.17042904E-05_JPRB, &
  & 0.17080529E-05_JPRB, 0.17113109E-05_JPRB, 0.17115067E-05_JPRB, 0.17110599E-05_JPRB, 0.17104283E-05_JPRB, 0.17105310E-05_JPRB, &
  & 0.17089662E-05_JPRB, 0.17094695E-05_JPRB, 0.17106032E-05_JPRB, 0.17138877E-05_JPRB, 0.17253108E-05_JPRB, 0.17399006E-05_JPRB, &
  & 0.17479957E-05_JPRB, 0.17545208E-05_JPRB, 0.17605936E-05_JPRB, 0.17655651E-05_JPRB, 0.17689507E-05_JPRB, 0.17727963E-05_JPRB, &
  & 0.17765409E-05_JPRB, 0.17804931E-05_JPRB, 0.17874607E-05_JPRB, 0.17927576E-05_JPRB, 0.17980982E-05_JPRB, 0.18028692E-05_JPRB, &
  & 0.18105874E-05_JPRB, 0.18198337E-05_JPRB, 0.18280729E-05_JPRB, 0.18331718E-05_JPRB, 0.18351549E-05_JPRB, 0.18361942E-05_JPRB, &
  & 0.18369707E-05_JPRB, 0.18368178E-05_JPRB, 0.18380895E-05_JPRB, 0.18383979E-05_JPRB  /)

RGHG2(:,85, 5) = (/ &
  & 0.16854053E-05_JPRB, 0.16854197E-05_JPRB, 0.16854486E-05_JPRB, 0.16855348E-05_JPRB, 0.16856488E-05_JPRB, 0.16857891E-05_JPRB, &
  & 0.16858626E-05_JPRB, 0.16859795E-05_JPRB, 0.16862169E-05_JPRB, 0.16866035E-05_JPRB, 0.16871632E-05_JPRB, 0.16877706E-05_JPRB, &
  & 0.16884113E-05_JPRB, 0.16889259E-05_JPRB, 0.16895470E-05_JPRB, 0.16904845E-05_JPRB, 0.16914310E-05_JPRB, 0.16923923E-05_JPRB, &
  & 0.16934727E-05_JPRB, 0.16943106E-05_JPRB, 0.16953627E-05_JPRB, 0.16960175E-05_JPRB, 0.16962386E-05_JPRB, 0.16958437E-05_JPRB, &
  & 0.16958729E-05_JPRB, 0.16962456E-05_JPRB, 0.16972319E-05_JPRB, 0.16981378E-05_JPRB, 0.16990937E-05_JPRB, 0.17047262E-05_JPRB, &
  & 0.17086428E-05_JPRB, 0.17119882E-05_JPRB, 0.17119888E-05_JPRB, 0.17113931E-05_JPRB, 0.17108257E-05_JPRB, 0.17112133E-05_JPRB, &
  & 0.17094688E-05_JPRB, 0.17100748E-05_JPRB, 0.17112830E-05_JPRB, 0.17146009E-05_JPRB, 0.17264964E-05_JPRB, 0.17412171E-05_JPRB, &
  & 0.17490786E-05_JPRB, 0.17557064E-05_JPRB, 0.17616431E-05_JPRB, 0.17667250E-05_JPRB, 0.17700721E-05_JPRB, 0.17736995E-05_JPRB, &
  & 0.17772438E-05_JPRB, 0.17812730E-05_JPRB, 0.17883664E-05_JPRB, 0.17938199E-05_JPRB, 0.17993326E-05_JPRB, 0.18041652E-05_JPRB, &
  & 0.18121736E-05_JPRB, 0.18222132E-05_JPRB, 0.18314179E-05_JPRB, 0.18350121E-05_JPRB, 0.18365177E-05_JPRB, 0.18370973E-05_JPRB, &
  & 0.18378662E-05_JPRB, 0.18377979E-05_JPRB, 0.18390851E-05_JPRB, 0.18396502E-05_JPRB  /)

RGHG2(:,86, 5) = (/ &
  & 0.16853731E-05_JPRB, 0.16853822E-05_JPRB, 0.16854272E-05_JPRB, 0.16855088E-05_JPRB, 0.16856381E-05_JPRB, 0.16857970E-05_JPRB, &
  & 0.16858868E-05_JPRB, 0.16859920E-05_JPRB, 0.16862457E-05_JPRB, 0.16865962E-05_JPRB, 0.16871539E-05_JPRB, 0.16877650E-05_JPRB, &
  & 0.16884304E-05_JPRB, 0.16889533E-05_JPRB, 0.16895775E-05_JPRB, 0.16905506E-05_JPRB, 0.16915048E-05_JPRB, 0.16924735E-05_JPRB, &
  & 0.16936389E-05_JPRB, 0.16945347E-05_JPRB, 0.16956089E-05_JPRB, 0.16962950E-05_JPRB, 0.16964714E-05_JPRB, 0.16960850E-05_JPRB, &
  & 0.16961134E-05_JPRB, 0.16964600E-05_JPRB, 0.16974463E-05_JPRB, 0.16984686E-05_JPRB, 0.16993098E-05_JPRB, 0.17053378E-05_JPRB, &
  & 0.17095499E-05_JPRB, 0.17129950E-05_JPRB, 0.17129884E-05_JPRB, 0.17118593E-05_JPRB, 0.17113785E-05_JPRB, 0.17119802E-05_JPRB, &
  & 0.17099988E-05_JPRB, 0.17106980E-05_JPRB, 0.17119228E-05_JPRB, 0.17153184E-05_JPRB, 0.17279640E-05_JPRB, 0.17429329E-05_JPRB, &
  & 0.17504631E-05_JPRB, 0.17573367E-05_JPRB, 0.17629880E-05_JPRB, 0.17682050E-05_JPRB, 0.17715234E-05_JPRB, 0.17747606E-05_JPRB, &
  & 0.17780615E-05_JPRB, 0.17821058E-05_JPRB, 0.17894020E-05_JPRB, 0.17951496E-05_JPRB, 0.18007990E-05_JPRB, 0.18056594E-05_JPRB, &
  & 0.18139212E-05_JPRB, 0.18243665E-05_JPRB, 0.18348066E-05_JPRB, 0.18364727E-05_JPRB, 0.18374119E-05_JPRB, 0.18376723E-05_JPRB, &
  & 0.18384555E-05_JPRB, 0.18383719E-05_JPRB, 0.18395601E-05_JPRB, 0.18403531E-05_JPRB  /)

RGHG2(:,87, 5) = (/ &
  & 0.16853537E-05_JPRB, 0.16853590E-05_JPRB, 0.16854143E-05_JPRB, 0.16854893E-05_JPRB, 0.16856370E-05_JPRB, 0.16858116E-05_JPRB, &
  & 0.16859358E-05_JPRB, 0.16860131E-05_JPRB, 0.16862826E-05_JPRB, 0.16865951E-05_JPRB, 0.16871501E-05_JPRB, 0.16877638E-05_JPRB, &
  & 0.16884621E-05_JPRB, 0.16889862E-05_JPRB, 0.16896105E-05_JPRB, 0.16906309E-05_JPRB, 0.16915769E-05_JPRB, 0.16925562E-05_JPRB, &
  & 0.16938481E-05_JPRB, 0.16948520E-05_JPRB, 0.16959245E-05_JPRB, 0.16967073E-05_JPRB, 0.16968140E-05_JPRB, 0.16964340E-05_JPRB, &
  & 0.16964677E-05_JPRB, 0.16968296E-05_JPRB, 0.16977653E-05_JPRB, 0.16989267E-05_JPRB, 0.16996033E-05_JPRB, 0.17063795E-05_JPRB, &
  & 0.17108881E-05_JPRB, 0.17145572E-05_JPRB, 0.17147823E-05_JPRB, 0.17126768E-05_JPRB, 0.17122409E-05_JPRB, 0.17129456E-05_JPRB, &
  & 0.17107287E-05_JPRB, 0.17114380E-05_JPRB, 0.17125799E-05_JPRB, 0.17161207E-05_JPRB, 0.17297508E-05_JPRB, 0.17454080E-05_JPRB, &
  & 0.17525151E-05_JPRB, 0.17595900E-05_JPRB, 0.17647426E-05_JPRB, 0.17701973E-05_JPRB, 0.17735122E-05_JPRB, 0.17760698E-05_JPRB, &
  & 0.17790523E-05_JPRB, 0.17830887E-05_JPRB, 0.17907025E-05_JPRB, 0.17969300E-05_JPRB, 0.18024965E-05_JPRB, 0.18074408E-05_JPRB, &
  & 0.18160172E-05_JPRB, 0.18265258E-05_JPRB, 0.18381435E-05_JPRB, 0.18377419E-05_JPRB, 0.18380274E-05_JPRB, 0.18380743E-05_JPRB, &
  & 0.18388865E-05_JPRB, 0.18387544E-05_JPRB, 0.18397741E-05_JPRB, 0.18406762E-05_JPRB  /)

RGHG2(:,88, 5) = (/ &
  & 0.16853460E-05_JPRB, 0.16853493E-05_JPRB, 0.16854078E-05_JPRB, 0.16854730E-05_JPRB, 0.16856399E-05_JPRB, 0.16858282E-05_JPRB, &
  & 0.16860014E-05_JPRB, 0.16860348E-05_JPRB, 0.16863290E-05_JPRB, 0.16865987E-05_JPRB, 0.16871503E-05_JPRB, 0.16877667E-05_JPRB, &
  & 0.16885054E-05_JPRB, 0.16890272E-05_JPRB, 0.16896486E-05_JPRB, 0.16907453E-05_JPRB, 0.16916516E-05_JPRB, 0.16926466E-05_JPRB, &
  & 0.16941181E-05_JPRB, 0.16952838E-05_JPRB, 0.16963406E-05_JPRB, 0.16973072E-05_JPRB, 0.16973398E-05_JPRB, 0.16969548E-05_JPRB, &
  & 0.16969966E-05_JPRB, 0.16974396E-05_JPRB, 0.16982487E-05_JPRB, 0.16996310E-05_JPRB, 0.17000512E-05_JPRB, 0.17082728E-05_JPRB, &
  & 0.17129038E-05_JPRB, 0.17170155E-05_JPRB, 0.17177709E-05_JPRB, 0.17140923E-05_JPRB, 0.17135816E-05_JPRB, 0.17142613E-05_JPRB, &
  & 0.17118557E-05_JPRB, 0.17124115E-05_JPRB, 0.17134052E-05_JPRB, 0.17172286E-05_JPRB, 0.17321111E-05_JPRB, 0.17492037E-05_JPRB, &
  & 0.17558218E-05_JPRB, 0.17627969E-05_JPRB, 0.17672178E-05_JPRB, 0.17731422E-05_JPRB, 0.17763783E-05_JPRB, 0.17778236E-05_JPRB, &
  & 0.17803970E-05_JPRB, 0.17844354E-05_JPRB, 0.17925487E-05_JPRB, 0.17994363E-05_JPRB, 0.18045502E-05_JPRB, 0.18096933E-05_JPRB, &
  & 0.18186859E-05_JPRB, 0.18289444E-05_JPRB, 0.18414252E-05_JPRB, 0.18388830E-05_JPRB, 0.18384671E-05_JPRB, 0.18383840E-05_JPRB, &
  & 0.18392394E-05_JPRB, 0.18390429E-05_JPRB, 0.18398670E-05_JPRB, 0.18407652E-05_JPRB  /)

RGHG2(:,89, 5) = (/ &
  & 0.16853467E-05_JPRB, 0.16853500E-05_JPRB, 0.16854056E-05_JPRB, 0.16854564E-05_JPRB, 0.16856430E-05_JPRB, 0.16858469E-05_JPRB, &
  & 0.16860636E-05_JPRB, 0.16860491E-05_JPRB, 0.16863843E-05_JPRB, 0.16866048E-05_JPRB, 0.16871513E-05_JPRB, 0.16877703E-05_JPRB, &
  & 0.16885500E-05_JPRB, 0.16890786E-05_JPRB, 0.16896950E-05_JPRB, 0.16909157E-05_JPRB, 0.16917371E-05_JPRB, 0.16927468E-05_JPRB, &
  & 0.16944567E-05_JPRB, 0.16958157E-05_JPRB, 0.16968898E-05_JPRB, 0.16981285E-05_JPRB, 0.16981201E-05_JPRB, 0.16976947E-05_JPRB, &
  & 0.16978544E-05_JPRB, 0.16983236E-05_JPRB, 0.16989224E-05_JPRB, 0.17007535E-05_JPRB, 0.17007523E-05_JPRB, 0.17116161E-05_JPRB, &
  & 0.17158950E-05_JPRB, 0.17207641E-05_JPRB, 0.17222758E-05_JPRB, 0.17162364E-05_JPRB, 0.17154724E-05_JPRB, 0.17160898E-05_JPRB, &
  & 0.17135662E-05_JPRB, 0.17137155E-05_JPRB, 0.17146340E-05_JPRB, 0.17189789E-05_JPRB, 0.17355216E-05_JPRB, 0.17550498E-05_JPRB, &
  & 0.17610369E-05_JPRB, 0.17673613E-05_JPRB, 0.17708532E-05_JPRB, 0.17777302E-05_JPRB, 0.17805678E-05_JPRB, 0.17803351E-05_JPRB, &
  & 0.17823700E-05_JPRB, 0.17865405E-05_JPRB, 0.17953293E-05_JPRB, 0.18029480E-05_JPRB, 0.18071532E-05_JPRB, 0.18126407E-05_JPRB, &
  & 0.18220925E-05_JPRB, 0.18318905E-05_JPRB, 0.18446005E-05_JPRB, 0.18398231E-05_JPRB, 0.18387898E-05_JPRB, 0.18386379E-05_JPRB, &
  & 0.18395500E-05_JPRB, 0.18392559E-05_JPRB, 0.18399240E-05_JPRB, 0.18408081E-05_JPRB  /)

RGHG2(:,90, 5) = (/ &
  & 0.16853471E-05_JPRB, 0.16853505E-05_JPRB, 0.16854030E-05_JPRB, 0.16854392E-05_JPRB, 0.16856436E-05_JPRB, 0.16858716E-05_JPRB, &
  & 0.16861362E-05_JPRB, 0.16860586E-05_JPRB, 0.16864411E-05_JPRB, 0.16866084E-05_JPRB, 0.16871548E-05_JPRB, 0.16877736E-05_JPRB, &
  & 0.16886017E-05_JPRB, 0.16891451E-05_JPRB, 0.16897409E-05_JPRB, 0.16911164E-05_JPRB, 0.16918185E-05_JPRB, 0.16928447E-05_JPRB, &
  & 0.16948933E-05_JPRB, 0.16963767E-05_JPRB, 0.16975927E-05_JPRB, 0.16991320E-05_JPRB, 0.16991512E-05_JPRB, 0.16984526E-05_JPRB, &
  & 0.16996130E-05_JPRB, 0.16992354E-05_JPRB, 0.16996827E-05_JPRB, 0.17022702E-05_JPRB, 0.17016694E-05_JPRB, 0.17168544E-05_JPRB, &
  & 0.17200444E-05_JPRB, 0.17262254E-05_JPRB, 0.17281027E-05_JPRB, 0.17185778E-05_JPRB, 0.17176098E-05_JPRB, 0.17186213E-05_JPRB, &
  & 0.17158730E-05_JPRB, 0.17153826E-05_JPRB, 0.17163554E-05_JPRB, 0.17214609E-05_JPRB, 0.17408503E-05_JPRB, 0.17638112E-05_JPRB, &
  & 0.17680647E-05_JPRB, 0.17738642E-05_JPRB, 0.17760275E-05_JPRB, 0.17848283E-05_JPRB, 0.17868269E-05_JPRB, 0.17842369E-05_JPRB, &
  & 0.17852274E-05_JPRB, 0.17901826E-05_JPRB, 0.17993602E-05_JPRB, 0.18077123E-05_JPRB, 0.18107223E-05_JPRB, 0.18167138E-05_JPRB, &
  & 0.18264683E-05_JPRB, 0.18358416E-05_JPRB, 0.18479548E-05_JPRB, 0.18405783E-05_JPRB, 0.18390464E-05_JPRB, 0.18388635E-05_JPRB, &
  & 0.18398282E-05_JPRB, 0.18393922E-05_JPRB, 0.18399542E-05_JPRB, 0.18408265E-05_JPRB  /)

RGHG2(:,91, 5) = (/ &
  & 0.16853436E-05_JPRB, 0.16853502E-05_JPRB, 0.16853996E-05_JPRB, 0.16854325E-05_JPRB, 0.16856465E-05_JPRB, 0.16859000E-05_JPRB, &
  & 0.16862029E-05_JPRB, 0.16860679E-05_JPRB, 0.16864663E-05_JPRB, 0.16866144E-05_JPRB, 0.16871577E-05_JPRB, 0.16877734E-05_JPRB, &
  & 0.16886524E-05_JPRB, 0.16892022E-05_JPRB, 0.16897949E-05_JPRB, 0.16913554E-05_JPRB, 0.16919777E-05_JPRB, 0.16929720E-05_JPRB, &
  & 0.16956685E-05_JPRB, 0.16972093E-05_JPRB, 0.16986678E-05_JPRB, 0.17005708E-05_JPRB, 0.17010910E-05_JPRB, 0.16992341E-05_JPRB, &
  & 0.17047949E-05_JPRB, 0.17008210E-05_JPRB, 0.17014597E-05_JPRB, 0.17042451E-05_JPRB, 0.17028689E-05_JPRB, 0.17224256E-05_JPRB, &
  & 0.17256060E-05_JPRB, 0.17351407E-05_JPRB, 0.17378701E-05_JPRB, 0.17217078E-05_JPRB, 0.17200155E-05_JPRB, 0.17216716E-05_JPRB, &
  & 0.17187414E-05_JPRB, 0.17180500E-05_JPRB, 0.17183463E-05_JPRB, 0.17249738E-05_JPRB, 0.17493571E-05_JPRB, 0.17749059E-05_JPRB, &
  & 0.17775991E-05_JPRB, 0.17823105E-05_JPRB, 0.17834431E-05_JPRB, 0.17939095E-05_JPRB, 0.17954997E-05_JPRB, 0.17904558E-05_JPRB, &
  & 0.17900838E-05_JPRB, 0.17964973E-05_JPRB, 0.18062460E-05_JPRB, 0.18141642E-05_JPRB, 0.18165775E-05_JPRB, 0.18232742E-05_JPRB, &
  & 0.18330031E-05_JPRB, 0.18419617E-05_JPRB, 0.18527442E-05_JPRB, 0.18412768E-05_JPRB, 0.18393014E-05_JPRB, 0.18390611E-05_JPRB, &
  & 0.18400257E-05_JPRB, 0.18394430E-05_JPRB, 0.18399731E-05_JPRB, 0.18408390E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ---GEMS----

RGHG2(:, 1, 6) = (/ &
  & 0.23358084E-06_JPRB, 0.23383271E-06_JPRB, 0.23377015E-06_JPRB, 0.23304254E-06_JPRB, 0.23223262E-06_JPRB, 0.23128935E-06_JPRB, &
  & 0.23004813E-06_JPRB, 0.22897975E-06_JPRB, 0.22832128E-06_JPRB, 0.22723974E-06_JPRB, 0.22623062E-06_JPRB, 0.22523139E-06_JPRB, &
  & 0.22421899E-06_JPRB, 0.22272260E-06_JPRB, 0.22093155E-06_JPRB, 0.21870591E-06_JPRB, 0.21650825E-06_JPRB, 0.21465629E-06_JPRB, &
  & 0.21310559E-06_JPRB, 0.21176724E-06_JPRB, 0.21065771E-06_JPRB, 0.20992351E-06_JPRB, 0.20940990E-06_JPRB, 0.20879423E-06_JPRB, &
  & 0.20803204E-06_JPRB, 0.20730443E-06_JPRB, 0.20635623E-06_JPRB, 0.20459975E-06_JPRB, 0.20231484E-06_JPRB, 0.19952620E-06_JPRB, &
  & 0.19657789E-06_JPRB, 0.19350611E-06_JPRB, 0.19042115E-06_JPRB, 0.18771812E-06_JPRB, 0.18526366E-06_JPRB, 0.18281742E-06_JPRB, &
  & 0.18050618E-06_JPRB, 0.17862294E-06_JPRB, 0.17725002E-06_JPRB, 0.17602526E-06_JPRB, 0.17448114E-06_JPRB, 0.17252712E-06_JPRB, &
  & 0.17068998E-06_JPRB, 0.16949649E-06_JPRB, 0.16934669E-06_JPRB, 0.17039366E-06_JPRB, 0.17265223E-06_JPRB, 0.17583266E-06_JPRB, &
  & 0.17967650E-06_JPRB, 0.18372941E-06_JPRB, 0.18755021E-06_JPRB, 0.19088373E-06_JPRB, 0.19376949E-06_JPRB, 0.19634742E-06_JPRB, &
  & 0.19859117E-06_JPRB, 0.20049910E-06_JPRB, 0.20202018E-06_JPRB, 0.20330914E-06_JPRB, 0.20460633E-06_JPRB, 0.20592493E-06_JPRB, &
  & 0.20714640E-06_JPRB, 0.20816209E-06_JPRB, 0.20924693E-06_JPRB, 0.21053919E-06_JPRB  /)

RGHG2(:, 2, 6) = (/ &
  & 0.23358084E-06_JPRB, 0.23383271E-06_JPRB, 0.23377015E-06_JPRB, 0.23304254E-06_JPRB, 0.23223262E-06_JPRB, 0.23128935E-06_JPRB, &
  & 0.23004813E-06_JPRB, 0.22897975E-06_JPRB, 0.22832128E-06_JPRB, 0.22723974E-06_JPRB, 0.22623062E-06_JPRB, 0.22523139E-06_JPRB, &
  & 0.22421899E-06_JPRB, 0.22272260E-06_JPRB, 0.22093155E-06_JPRB, 0.21870591E-06_JPRB, 0.21650825E-06_JPRB, 0.21465629E-06_JPRB, &
  & 0.21310559E-06_JPRB, 0.21176724E-06_JPRB, 0.21065771E-06_JPRB, 0.20992351E-06_JPRB, 0.20940990E-06_JPRB, 0.20879423E-06_JPRB, &
  & 0.20803204E-06_JPRB, 0.20730443E-06_JPRB, 0.20635623E-06_JPRB, 0.20459975E-06_JPRB, 0.20231484E-06_JPRB, 0.19952620E-06_JPRB, &
  & 0.19657789E-06_JPRB, 0.19350611E-06_JPRB, 0.19042115E-06_JPRB, 0.18771812E-06_JPRB, 0.18526366E-06_JPRB, 0.18281742E-06_JPRB, &
  & 0.18050618E-06_JPRB, 0.17862294E-06_JPRB, 0.17725002E-06_JPRB, 0.17602526E-06_JPRB, 0.17448114E-06_JPRB, 0.17252712E-06_JPRB, &
  & 0.17068998E-06_JPRB, 0.16949649E-06_JPRB, 0.16934669E-06_JPRB, 0.17039366E-06_JPRB, 0.17265223E-06_JPRB, 0.17583266E-06_JPRB, &
  & 0.17967650E-06_JPRB, 0.18372941E-06_JPRB, 0.18755021E-06_JPRB, 0.19088373E-06_JPRB, 0.19376949E-06_JPRB, 0.19634742E-06_JPRB, &
  & 0.19859117E-06_JPRB, 0.20049910E-06_JPRB, 0.20202018E-06_JPRB, 0.20330914E-06_JPRB, 0.20460633E-06_JPRB, 0.20592493E-06_JPRB, &
  & 0.20714640E-06_JPRB, 0.20816209E-06_JPRB, 0.20924693E-06_JPRB, 0.21053919E-06_JPRB  /)

RGHG2(:, 3, 6) = (/ &
  & 0.23358084E-06_JPRB, 0.23383271E-06_JPRB, 0.23377015E-06_JPRB, 0.23304254E-06_JPRB, 0.23223262E-06_JPRB, 0.23128935E-06_JPRB, &
  & 0.23004813E-06_JPRB, 0.22897975E-06_JPRB, 0.22832128E-06_JPRB, 0.22723974E-06_JPRB, 0.22623062E-06_JPRB, 0.22523139E-06_JPRB, &
  & 0.22421899E-06_JPRB, 0.22272260E-06_JPRB, 0.22093155E-06_JPRB, 0.21870591E-06_JPRB, 0.21650825E-06_JPRB, 0.21465629E-06_JPRB, &
  & 0.21310559E-06_JPRB, 0.21176724E-06_JPRB, 0.21065771E-06_JPRB, 0.20992351E-06_JPRB, 0.20940990E-06_JPRB, 0.20879423E-06_JPRB, &
  & 0.20803204E-06_JPRB, 0.20730443E-06_JPRB, 0.20635623E-06_JPRB, 0.20459975E-06_JPRB, 0.20231484E-06_JPRB, 0.19952620E-06_JPRB, &
  & 0.19657789E-06_JPRB, 0.19350611E-06_JPRB, 0.19042115E-06_JPRB, 0.18771812E-06_JPRB, 0.18526366E-06_JPRB, 0.18281742E-06_JPRB, &
  & 0.18050618E-06_JPRB, 0.17862294E-06_JPRB, 0.17725002E-06_JPRB, 0.17602526E-06_JPRB, 0.17448114E-06_JPRB, 0.17252712E-06_JPRB, &
  & 0.17068998E-06_JPRB, 0.16949649E-06_JPRB, 0.16934669E-06_JPRB, 0.17039366E-06_JPRB, 0.17265223E-06_JPRB, 0.17583266E-06_JPRB, &
  & 0.17967650E-06_JPRB, 0.18372941E-06_JPRB, 0.18755021E-06_JPRB, 0.19088373E-06_JPRB, 0.19376949E-06_JPRB, 0.19634742E-06_JPRB, &
  & 0.19859117E-06_JPRB, 0.20049910E-06_JPRB, 0.20202018E-06_JPRB, 0.20330914E-06_JPRB, 0.20460633E-06_JPRB, 0.20592493E-06_JPRB, &
  & 0.20714640E-06_JPRB, 0.20816209E-06_JPRB, 0.20924693E-06_JPRB, 0.21053919E-06_JPRB  /)

RGHG2(:, 4, 6) = (/ &
  & 0.23359177E-06_JPRB, 0.23384009E-06_JPRB, 0.23377589E-06_JPRB, 0.23305043E-06_JPRB, 0.23224206E-06_JPRB, 0.23130119E-06_JPRB, &
  & 0.23006452E-06_JPRB, 0.22899939E-06_JPRB, 0.22834084E-06_JPRB, 0.22726271E-06_JPRB, 0.22625483E-06_JPRB, 0.22525536E-06_JPRB, &
  & 0.22424128E-06_JPRB, 0.22274548E-06_JPRB, 0.22095370E-06_JPRB, 0.21872859E-06_JPRB, 0.21652969E-06_JPRB, 0.21467734E-06_JPRB, &
  & 0.21312840E-06_JPRB, 0.21179541E-06_JPRB, 0.21069551E-06_JPRB, 0.20997081E-06_JPRB, 0.20946477E-06_JPRB, 0.20885843E-06_JPRB, &
  & 0.20810716E-06_JPRB, 0.20738821E-06_JPRB, 0.20644716E-06_JPRB, 0.20470012E-06_JPRB, 0.20242485E-06_JPRB, 0.19964515E-06_JPRB, &
  & 0.19670322E-06_JPRB, 0.19363459E-06_JPRB, 0.19054891E-06_JPRB, 0.18783918E-06_JPRB, 0.18537094E-06_JPRB, 0.18290578E-06_JPRB, &
  & 0.18057873E-06_JPRB, 0.17868561E-06_JPRB, 0.17730782E-06_JPRB, 0.17608093E-06_JPRB, 0.17453381E-06_JPRB, 0.17257280E-06_JPRB, &
  & 0.17072207E-06_JPRB, 0.16950925E-06_JPRB, 0.16933511E-06_JPRB, 0.17035506E-06_JPRB, 0.17258846E-06_JPRB, 0.17575018E-06_JPRB, &
  & 0.17958618E-06_JPRB, 0.18364277E-06_JPRB, 0.18747640E-06_JPRB, 0.19082589E-06_JPRB, 0.19372566E-06_JPRB, 0.19631467E-06_JPRB, &
  & 0.19857028E-06_JPRB, 0.20049216E-06_JPRB, 0.20202674E-06_JPRB, 0.20332760E-06_JPRB, 0.20463510E-06_JPRB, 0.20596282E-06_JPRB, &
  & 0.20719329E-06_JPRB, 0.20821700E-06_JPRB, 0.20930433E-06_JPRB, 0.21059319E-06_JPRB  /)

RGHG2(:, 5, 6) = (/ &
  & 0.23411043E-06_JPRB, 0.23419049E-06_JPRB, 0.23404818E-06_JPRB, 0.23342487E-06_JPRB, 0.23269041E-06_JPRB, 0.23186311E-06_JPRB, &
  & 0.23084277E-06_JPRB, 0.22993147E-06_JPRB, 0.22926932E-06_JPRB, 0.22835344E-06_JPRB, 0.22740384E-06_JPRB, 0.22639295E-06_JPRB, &
  & 0.22529955E-06_JPRB, 0.22383140E-06_JPRB, 0.22200476E-06_JPRB, 0.21980489E-06_JPRB, 0.21754710E-06_JPRB, 0.21567612E-06_JPRB, &
  & 0.21421131E-06_JPRB, 0.21313250E-06_JPRB, 0.21248990E-06_JPRB, 0.21221588E-06_JPRB, 0.21206918E-06_JPRB, 0.21190571E-06_JPRB, &
  & 0.21167242E-06_JPRB, 0.21136510E-06_JPRB, 0.21076356E-06_JPRB, 0.20946419E-06_JPRB, 0.20764621E-06_JPRB, 0.20529075E-06_JPRB, &
  & 0.20265228E-06_JPRB, 0.19973328E-06_JPRB, 0.19661274E-06_JPRB, 0.19358574E-06_JPRB, 0.19046311E-06_JPRB, 0.18709959E-06_JPRB, &
  & 0.18402261E-06_JPRB, 0.18166018E-06_JPRB, 0.18005104E-06_JPRB, 0.17872320E-06_JPRB, 0.17703366E-06_JPRB, 0.17474095E-06_JPRB, &
  & 0.17224545E-06_JPRB, 0.17011504E-06_JPRB, 0.16878535E-06_JPRB, 0.16852297E-06_JPRB, 0.16956176E-06_JPRB, 0.17183534E-06_JPRB, &
  & 0.17529877E-06_JPRB, 0.17953023E-06_JPRB, 0.18397318E-06_JPRB, 0.18808042E-06_JPRB, 0.19164479E-06_JPRB, 0.19476020E-06_JPRB, &
  & 0.19757886E-06_JPRB, 0.20016294E-06_JPRB, 0.20233808E-06_JPRB, 0.20420380E-06_JPRB, 0.20600044E-06_JPRB, 0.20776141E-06_JPRB, &
  & 0.20941913E-06_JPRB, 0.21082321E-06_JPRB, 0.21202892E-06_JPRB, 0.21315674E-06_JPRB  /)

RGHG2(:, 6, 6) = (/ &
  & 0.23488860E-06_JPRB, 0.23471622E-06_JPRB, 0.23445670E-06_JPRB, 0.23398666E-06_JPRB, 0.23336310E-06_JPRB, 0.23270620E-06_JPRB, &
  & 0.23201042E-06_JPRB, 0.23132992E-06_JPRB, 0.23066236E-06_JPRB, 0.22998990E-06_JPRB, 0.22912776E-06_JPRB, 0.22809974E-06_JPRB, &
  & 0.22688734E-06_JPRB, 0.22546065E-06_JPRB, 0.22358172E-06_JPRB, 0.22141972E-06_JPRB, 0.21907357E-06_JPRB, 0.21717465E-06_JPRB, &
  & 0.21583606E-06_JPRB, 0.21513861E-06_JPRB, 0.21518211E-06_JPRB, 0.21558426E-06_JPRB, 0.21597671E-06_JPRB, 0.21647769E-06_JPRB, &
  & 0.21702156E-06_JPRB, 0.21733182E-06_JPRB, 0.21723967E-06_JPRB, 0.21661197E-06_JPRB, 0.21548008E-06_JPRB, 0.21376113E-06_JPRB, &
  & 0.21157796E-06_JPRB, 0.20888345E-06_JPRB, 0.20571062E-06_JPRB, 0.20220759E-06_JPRB, 0.19810314E-06_JPRB, 0.19339177E-06_JPRB, &
  & 0.18918963E-06_JPRB, 0.18612307E-06_JPRB, 0.18416683E-06_JPRB, 0.18268752E-06_JPRB, 0.18078431E-06_JPRB, 0.17799393E-06_JPRB, &
  & 0.17453104E-06_JPRB, 0.17102394E-06_JPRB, 0.16796053E-06_JPRB, 0.16577419E-06_JPRB, 0.16502066E-06_JPRB, 0.16596171E-06_JPRB, &
  & 0.16886617E-06_JPRB, 0.17335998E-06_JPRB, 0.17871713E-06_JPRB, 0.18396125E-06_JPRB, 0.18852276E-06_JPRB, 0.19242794E-06_JPRB, &
  & 0.19609138E-06_JPRB, 0.19966899E-06_JPRB, 0.20280521E-06_JPRB, 0.20551840E-06_JPRB, 0.20804892E-06_JPRB, 0.21045993E-06_JPRB, &
  & 0.21275866E-06_JPRB, 0.21473344E-06_JPRB, 0.21611676E-06_JPRB, 0.21700296E-06_JPRB  /)

RGHG2(:, 7, 6) = (/ &
  & 0.23644856E-06_JPRB, 0.23622715E-06_JPRB, 0.23607300E-06_JPRB, 0.23581554E-06_JPRB, 0.23537371E-06_JPRB, 0.23489793E-06_JPRB, &
  & 0.23444375E-06_JPRB, 0.23393464E-06_JPRB, 0.23339692E-06_JPRB, 0.23294912E-06_JPRB, 0.23238257E-06_JPRB, 0.23158042E-06_JPRB, &
  & 0.23045049E-06_JPRB, 0.22910184E-06_JPRB, 0.22734287E-06_JPRB, 0.22525734E-06_JPRB, 0.22300328E-06_JPRB, 0.22104166E-06_JPRB, &
  & 0.21971936E-06_JPRB, 0.21926044E-06_JPRB, 0.21990770E-06_JPRB, 0.22105516E-06_JPRB, 0.22215962E-06_JPRB, 0.22337026E-06_JPRB, &
  & 0.22463605E-06_JPRB, 0.22582916E-06_JPRB, 0.22679855E-06_JPRB, 0.22736399E-06_JPRB, 0.22733579E-06_JPRB, 0.22678636E-06_JPRB, &
  & 0.22618970E-06_JPRB, 0.22533310E-06_JPRB, 0.22385508E-06_JPRB, 0.22123333E-06_JPRB, 0.21675679E-06_JPRB, 0.21069742E-06_JPRB, &
  & 0.20436290E-06_JPRB, 0.19903795E-06_JPRB, 0.19533604E-06_JPRB, 0.19277727E-06_JPRB, 0.19018363E-06_JPRB, 0.18662967E-06_JPRB, &
  & 0.18195020E-06_JPRB, 0.17647269E-06_JPRB, 0.17062577E-06_JPRB, 0.16509338E-06_JPRB, 0.16096767E-06_JPRB, 0.15920513E-06_JPRB, &
  & 0.16066024E-06_JPRB, 0.16518190E-06_JPRB, 0.17199065E-06_JPRB, 0.17936474E-06_JPRB, 0.18577462E-06_JPRB, 0.19089732E-06_JPRB, &
  & 0.19544680E-06_JPRB, 0.20027668E-06_JPRB, 0.20516860E-06_JPRB, 0.20949240E-06_JPRB, 0.21332797E-06_JPRB, 0.21683742E-06_JPRB, &
  & 0.22014483E-06_JPRB, 0.22308822E-06_JPRB, 0.22522770E-06_JPRB, 0.22641720E-06_JPRB  /)

RGHG2(:, 8, 6) = (/ &
  & 0.23930568E-06_JPRB, 0.23917724E-06_JPRB, 0.23921926E-06_JPRB, 0.23917047E-06_JPRB, 0.23890985E-06_JPRB, 0.23862014E-06_JPRB, &
  & 0.23839197E-06_JPRB, 0.23812547E-06_JPRB, 0.23789296E-06_JPRB, 0.23782721E-06_JPRB, 0.23778812E-06_JPRB, 0.23752755E-06_JPRB, &
  & 0.23684268E-06_JPRB, 0.23593357E-06_JPRB, 0.23470324E-06_JPRB, 0.23302243E-06_JPRB, 0.23118305E-06_JPRB, 0.22951264E-06_JPRB, &
  & 0.22831849E-06_JPRB, 0.22792488E-06_JPRB, 0.22878625E-06_JPRB, 0.23034965E-06_JPRB, 0.23201594E-06_JPRB, 0.23375300E-06_JPRB, &
  & 0.23560223E-06_JPRB, 0.23761200E-06_JPRB, 0.23947388E-06_JPRB, 0.24099516E-06_JPRB, 0.24198234E-06_JPRB, 0.24266761E-06_JPRB, &
  & 0.24371086E-06_JPRB, 0.24521247E-06_JPRB, 0.24678709E-06_JPRB, 0.24691600E-06_JPRB, 0.24387434E-06_JPRB, 0.23789439E-06_JPRB, &
  & 0.23031396E-06_JPRB, 0.22291913E-06_JPRB, 0.21682620E-06_JPRB, 0.21195963E-06_JPRB, 0.20746671E-06_JPRB, 0.20191922E-06_JPRB, &
  & 0.19481749E-06_JPRB, 0.18622725E-06_JPRB, 0.17645075E-06_JPRB, 0.16655613E-06_JPRB, 0.15809753E-06_JPRB, 0.15284741E-06_JPRB, &
  & 0.15246030E-06_JPRB, 0.15695125E-06_JPRB, 0.16541792E-06_JPRB, 0.17535597E-06_JPRB, 0.18425997E-06_JPRB, 0.19120310E-06_JPRB, &
  & 0.19678184E-06_JPRB, 0.20275714E-06_JPRB, 0.20989438E-06_JPRB, 0.21656179E-06_JPRB, 0.22227894E-06_JPRB, 0.22750048E-06_JPRB, &
  & 0.23227576E-06_JPRB, 0.23638510E-06_JPRB, 0.23947756E-06_JPRB, 0.24130446E-06_JPRB  /)

RGHG2(:, 9, 6) = (/ &
  & 0.24449971E-06_JPRB, 0.24442650E-06_JPRB, 0.24456272E-06_JPRB, 0.24461786E-06_JPRB, 0.24452911E-06_JPRB, 0.24445008E-06_JPRB, &
  & 0.24450333E-06_JPRB, 0.24468908E-06_JPRB, 0.24511142E-06_JPRB, 0.24585815E-06_JPRB, 0.24679816E-06_JPRB, 0.24765921E-06_JPRB, &
  & 0.24819148E-06_JPRB, 0.24862370E-06_JPRB, 0.24914268E-06_JPRB, 0.24919595E-06_JPRB, 0.24882935E-06_JPRB, 0.24827860E-06_JPRB, &
  & 0.24752348E-06_JPRB, 0.24675685E-06_JPRB, 0.24680169E-06_JPRB, 0.24765487E-06_JPRB, 0.24902265E-06_JPRB, 0.25062002E-06_JPRB, &
  & 0.25243866E-06_JPRB, 0.25466196E-06_JPRB, 0.25677695E-06_JPRB, 0.25856143E-06_JPRB, 0.26020307E-06_JPRB, 0.26205445E-06_JPRB, &
  & 0.26449804E-06_JPRB, 0.26829635E-06_JPRB, 0.27354611E-06_JPRB, 0.27807771E-06_JPRB, 0.27907367E-06_JPRB, 0.27607145E-06_JPRB, &
  & 0.27008267E-06_JPRB, 0.26296117E-06_JPRB, 0.25528671E-06_JPRB, 0.24702451E-06_JPRB, 0.23832448E-06_JPRB, 0.22813962E-06_JPRB, &
  & 0.21606642E-06_JPRB, 0.20205714E-06_JPRB, 0.18646516E-06_JPRB, 0.17093497E-06_JPRB, 0.15736865E-06_JPRB, 0.14830042E-06_JPRB, &
  & 0.14620402E-06_JPRB, 0.15089600E-06_JPRB, 0.16098178E-06_JPRB, 0.17332633E-06_JPRB, 0.18494707E-06_JPRB, 0.19424479E-06_JPRB, &
  & 0.20095936E-06_JPRB, 0.20750348E-06_JPRB, 0.21666348E-06_JPRB, 0.22614849E-06_JPRB, 0.23436632E-06_JPRB, 0.24222434E-06_JPRB, &
  & 0.24927563E-06_JPRB, 0.25482834E-06_JPRB, 0.25908916E-06_JPRB, 0.26197029E-06_JPRB  /)

RGHG2(:,10, 6) = (/ &
  & 0.25290681E-06_JPRB, 0.25247738E-06_JPRB, 0.25237472E-06_JPRB, 0.25245795E-06_JPRB, 0.25268778E-06_JPRB, 0.25293115E-06_JPRB, &
  & 0.25341690E-06_JPRB, 0.25454389E-06_JPRB, 0.25626983E-06_JPRB, 0.25859651E-06_JPRB, 0.26138689E-06_JPRB, 0.26439188E-06_JPRB, &
  & 0.26768191E-06_JPRB, 0.27169226E-06_JPRB, 0.27680231E-06_JPRB, 0.28156805E-06_JPRB, 0.28503995E-06_JPRB, 0.28709178E-06_JPRB, &
  & 0.28723166E-06_JPRB, 0.28557594E-06_JPRB, 0.28327960E-06_JPRB, 0.28126860E-06_JPRB, 0.28020512E-06_JPRB, 0.28012096E-06_JPRB, &
  & 0.28067751E-06_JPRB, 0.28187344E-06_JPRB, 0.28336295E-06_JPRB, 0.28482043E-06_JPRB, 0.28672757E-06_JPRB, 0.28949143E-06_JPRB, &
  & 0.29329220E-06_JPRB, 0.29912825E-06_JPRB, 0.30734640E-06_JPRB, 0.31643862E-06_JPRB, 0.32325866E-06_JPRB, 0.32608180E-06_JPRB, &
  & 0.32527289E-06_JPRB, 0.32234463E-06_JPRB, 0.31603801E-06_JPRB, 0.30506605E-06_JPRB, 0.29000467E-06_JPRB, 0.27150291E-06_JPRB, &
  & 0.24975893E-06_JPRB, 0.22552866E-06_JPRB, 0.20044873E-06_JPRB, 0.17712510E-06_JPRB, 0.15822905E-06_JPRB, 0.14625364E-06_JPRB, &
  & 0.14356635E-06_JPRB, 0.14903884E-06_JPRB, 0.16037061E-06_JPRB, 0.17405620E-06_JPRB, 0.18700129E-06_JPRB, 0.19800801E-06_JPRB, &
  & 0.20621672E-06_JPRB, 0.21293510E-06_JPRB, 0.22257288E-06_JPRB, 0.23424371E-06_JPRB, 0.24530814E-06_JPRB, 0.25675810E-06_JPRB, &
  & 0.26719719E-06_JPRB, 0.27497870E-06_JPRB, 0.28101900E-06_JPRB, 0.28530851E-06_JPRB  /)

RGHG2(:,11, 6) = (/ &
  & 0.26192322E-06_JPRB, 0.26124448E-06_JPRB, 0.26128046E-06_JPRB, 0.26182975E-06_JPRB, 0.26268206E-06_JPRB, 0.26343390E-06_JPRB, &
  & 0.26458338E-06_JPRB, 0.26730502E-06_JPRB, 0.27150951E-06_JPRB, 0.27687456E-06_JPRB, 0.28301661E-06_JPRB, 0.29006803E-06_JPRB, &
  & 0.29892667E-06_JPRB, 0.31067894E-06_JPRB, 0.32438914E-06_JPRB, 0.33671812E-06_JPRB, 0.34697459E-06_JPRB, 0.35364298E-06_JPRB, &
  & 0.35522028E-06_JPRB, 0.35170103E-06_JPRB, 0.34568283E-06_JPRB, 0.33864851E-06_JPRB, 0.33244185E-06_JPRB, 0.32809842E-06_JPRB, &
  & 0.32564720E-06_JPRB, 0.32450299E-06_JPRB, 0.32453280E-06_JPRB, 0.32568891E-06_JPRB, 0.32789951E-06_JPRB, 0.33143496E-06_JPRB, &
  & 0.33703323E-06_JPRB, 0.34567378E-06_JPRB, 0.35656383E-06_JPRB, 0.36954435E-06_JPRB, 0.38176113E-06_JPRB, 0.39043845E-06_JPRB, &
  & 0.39570969E-06_JPRB, 0.39828659E-06_JPRB, 0.39534041E-06_JPRB, 0.38397827E-06_JPRB, 0.36363235E-06_JPRB, 0.33531584E-06_JPRB, &
  & 0.29842938E-06_JPRB, 0.25689089E-06_JPRB, 0.21678998E-06_JPRB, 0.18305029E-06_JPRB, 0.15995098E-06_JPRB, 0.14758227E-06_JPRB, &
  & 0.14593456E-06_JPRB, 0.15224025E-06_JPRB, 0.16370476E-06_JPRB, 0.17677556E-06_JPRB, 0.18706641E-06_JPRB, 0.19609047E-06_JPRB, &
  & 0.20630008E-06_JPRB, 0.21464594E-06_JPRB, 0.22329624E-06_JPRB, 0.23556095E-06_JPRB, 0.24901152E-06_JPRB, 0.26432435E-06_JPRB, &
  & 0.27916981E-06_JPRB, 0.29042115E-06_JPRB, 0.29887493E-06_JPRB, 0.30445918E-06_JPRB  /)

RGHG2(:,12, 6) = (/ &
  & 0.26510577E-06_JPRB, 0.26541476E-06_JPRB, 0.26677148E-06_JPRB, 0.26878853E-06_JPRB, 0.27052738E-06_JPRB, 0.27220960E-06_JPRB, &
  & 0.27473574E-06_JPRB, 0.27986090E-06_JPRB, 0.28855498E-06_JPRB, 0.29983034E-06_JPRB, 0.31192332E-06_JPRB, 0.32584494E-06_JPRB, &
  & 0.34437599E-06_JPRB, 0.36812578E-06_JPRB, 0.39293024E-06_JPRB, 0.41483423E-06_JPRB, 0.43447969E-06_JPRB, 0.44688437E-06_JPRB, &
  & 0.44998984E-06_JPRB, 0.44321812E-06_JPRB, 0.43262474E-06_JPRB, 0.42023317E-06_JPRB, 0.40754486E-06_JPRB, 0.39652970E-06_JPRB, &
  & 0.38908954E-06_JPRB, 0.38449801E-06_JPRB, 0.38257430E-06_JPRB, 0.38363577E-06_JPRB, 0.38742313E-06_JPRB, 0.39370881E-06_JPRB, &
  & 0.40276966E-06_JPRB, 0.41550857E-06_JPRB, 0.42963390E-06_JPRB, 0.44479172E-06_JPRB, 0.45947133E-06_JPRB, 0.47137323E-06_JPRB, &
  & 0.48010280E-06_JPRB, 0.48527199E-06_JPRB, 0.48385102E-06_JPRB, 0.47224840E-06_JPRB, 0.44828041E-06_JPRB, 0.41185058E-06_JPRB, &
  & 0.35894248E-06_JPRB, 0.29628566E-06_JPRB, 0.23715348E-06_JPRB, 0.19172073E-06_JPRB, 0.16512429E-06_JPRB, 0.15344688E-06_JPRB, &
  & 0.15282902E-06_JPRB, 0.15875914E-06_JPRB, 0.16869267E-06_JPRB, 0.17913576E-06_JPRB, 0.18278936E-06_JPRB, 0.18449774E-06_JPRB, &
  & 0.19500108E-06_JPRB, 0.20733415E-06_JPRB, 0.21650409E-06_JPRB, 0.22894433E-06_JPRB, 0.24443806E-06_JPRB, 0.26409372E-06_JPRB, &
  & 0.28524843E-06_JPRB, 0.30111728E-06_JPRB, 0.31118079E-06_JPRB, 0.31718121E-06_JPRB  /)

RGHG2(:,13, 6) = (/ &
  & 0.26093398E-06_JPRB, 0.26184603E-06_JPRB, 0.26430875E-06_JPRB, 0.26801627E-06_JPRB, 0.27149079E-06_JPRB, 0.27532937E-06_JPRB, &
  & 0.28032580E-06_JPRB, 0.28931155E-06_JPRB, 0.30465650E-06_JPRB, 0.32419853E-06_JPRB, 0.34587810E-06_JPRB, 0.37006676E-06_JPRB, &
  & 0.40210505E-06_JPRB, 0.44079826E-06_JPRB, 0.47958769E-06_JPRB, 0.51480454E-06_JPRB, 0.54447271E-06_JPRB, 0.56086516E-06_JPRB, &
  & 0.56387100E-06_JPRB, 0.55527292E-06_JPRB, 0.54124479E-06_JPRB, 0.52431973E-06_JPRB, 0.50675516E-06_JPRB, 0.49085669E-06_JPRB, &
  & 0.47883110E-06_JPRB, 0.47083203E-06_JPRB, 0.46663251E-06_JPRB, 0.46699463E-06_JPRB, 0.47306005E-06_JPRB, 0.48415469E-06_JPRB, &
  & 0.49837198E-06_JPRB, 0.51397814E-06_JPRB, 0.52910058E-06_JPRB, 0.54368062E-06_JPRB, 0.55785230E-06_JPRB, 0.56919922E-06_JPRB, &
  & 0.57653465E-06_JPRB, 0.57971067E-06_JPRB, 0.57598628E-06_JPRB, 0.56081810E-06_JPRB, 0.53081645E-06_JPRB, 0.48724273E-06_JPRB, &
  & 0.42241861E-06_JPRB, 0.34142286E-06_JPRB, 0.26433023E-06_JPRB, 0.20795876E-06_JPRB, 0.17687299E-06_JPRB, 0.16421611E-06_JPRB, &
  & 0.16286700E-06_JPRB, 0.16697178E-06_JPRB, 0.17405378E-06_JPRB, 0.18009788E-06_JPRB, 0.17644960E-06_JPRB, 0.16921554E-06_JPRB, &
  & 0.17535072E-06_JPRB, 0.19116761E-06_JPRB, 0.20417343E-06_JPRB, 0.21861951E-06_JPRB, 0.23717649E-06_JPRB, 0.26204480E-06_JPRB, &
  & 0.29128492E-06_JPRB, 0.31146579E-06_JPRB, 0.32175908E-06_JPRB, 0.32705130E-06_JPRB  /)

RGHG2(:,14, 6) = (/ &
  & 0.25266729E-06_JPRB, 0.25344576E-06_JPRB, 0.25656865E-06_JPRB, 0.26107024E-06_JPRB, 0.26639253E-06_JPRB, 0.27278458E-06_JPRB, &
  & 0.28128646E-06_JPRB, 0.29568641E-06_JPRB, 0.31810872E-06_JPRB, 0.34705739E-06_JPRB, 0.38118252E-06_JPRB, 0.42009065E-06_JPRB, &
  & 0.46868590E-06_JPRB, 0.52646611E-06_JPRB, 0.58312584E-06_JPRB, 0.63148824E-06_JPRB, 0.66796727E-06_JPRB, 0.68623942E-06_JPRB, &
  & 0.68968713E-06_JPRB, 0.68221613E-06_JPRB, 0.66888880E-06_JPRB, 0.65290893E-06_JPRB, 0.63572368E-06_JPRB, 0.61908081E-06_JPRB, &
  & 0.60530118E-06_JPRB, 0.59527183E-06_JPRB, 0.59041155E-06_JPRB, 0.59105082E-06_JPRB, 0.59792308E-06_JPRB, 0.61050141E-06_JPRB, &
  & 0.62708057E-06_JPRB, 0.64152542E-06_JPRB, 0.65263035E-06_JPRB, 0.66350052E-06_JPRB, 0.67447647E-06_JPRB, 0.68153411E-06_JPRB, &
  & 0.68273319E-06_JPRB, 0.67857530E-06_JPRB, 0.66643269E-06_JPRB, 0.64123173E-06_JPRB, 0.60044719E-06_JPRB, 0.55013659E-06_JPRB, &
  & 0.47978174E-06_JPRB, 0.38748754E-06_JPRB, 0.29694795E-06_JPRB, 0.23125112E-06_JPRB, 0.19562803E-06_JPRB, 0.18048882E-06_JPRB, &
  & 0.17629246E-06_JPRB, 0.17770116E-06_JPRB, 0.18134694E-06_JPRB, 0.18199399E-06_JPRB, 0.17266323E-06_JPRB, 0.15933787E-06_JPRB, &
  & 0.15743254E-06_JPRB, 0.17418192E-06_JPRB, 0.19298310E-06_JPRB, 0.21285084E-06_JPRB, 0.23674861E-06_JPRB, 0.26756723E-06_JPRB, &
  & 0.29986461E-06_JPRB, 0.31966094E-06_JPRB, 0.32892267E-06_JPRB, 0.33224414E-06_JPRB  /)

RGHG2(:,15, 6) = (/ &
  & 0.24576611E-06_JPRB, 0.24765979E-06_JPRB, 0.25147099E-06_JPRB, 0.25562393E-06_JPRB, 0.26192528E-06_JPRB, 0.27003306E-06_JPRB, &
  & 0.28210773E-06_JPRB, 0.30217876E-06_JPRB, 0.33134381E-06_JPRB, 0.36966411E-06_JPRB, 0.41738448E-06_JPRB, 0.47333102E-06_JPRB, &
  & 0.54262624E-06_JPRB, 0.62180985E-06_JPRB, 0.69437792E-06_JPRB, 0.75236705E-06_JPRB, 0.79245436E-06_JPRB, 0.81329619E-06_JPRB, &
  & 0.82087471E-06_JPRB, 0.82024955E-06_JPRB, 0.81475838E-06_JPRB, 0.80744751E-06_JPRB, 0.79975237E-06_JPRB, 0.79096014E-06_JPRB, &
  & 0.77939300E-06_JPRB, 0.76812188E-06_JPRB, 0.76215582E-06_JPRB, 0.76224769E-06_JPRB, 0.76481122E-06_JPRB, 0.77022372E-06_JPRB, &
  & 0.77862430E-06_JPRB, 0.78290633E-06_JPRB, 0.78558939E-06_JPRB, 0.79268385E-06_JPRB, 0.80036075E-06_JPRB, 0.80195463E-06_JPRB, &
  & 0.79380716E-06_JPRB, 0.77565802E-06_JPRB, 0.74563596E-06_JPRB, 0.70141876E-06_JPRB, 0.64665766E-06_JPRB, 0.59129836E-06_JPRB, &
  & 0.52308472E-06_JPRB, 0.42985224E-06_JPRB, 0.33137998E-06_JPRB, 0.25850279E-06_JPRB, 0.21978997E-06_JPRB, 0.20211519E-06_JPRB, &
  & 0.19373631E-06_JPRB, 0.19200456E-06_JPRB, 0.19256804E-06_JPRB, 0.18783567E-06_JPRB, 0.17413142E-06_JPRB, 0.15670808E-06_JPRB, &
  & 0.14838500E-06_JPRB, 0.16575926E-06_JPRB, 0.19102804E-06_JPRB, 0.21690303E-06_JPRB, 0.24915787E-06_JPRB, 0.28515725E-06_JPRB, &
  & 0.31231016E-06_JPRB, 0.32571382E-06_JPRB, 0.33001988E-06_JPRB, 0.33128128E-06_JPRB  /)

RGHG2(:,16, 6) = (/ &
  & 0.25121548E-06_JPRB, 0.25380042E-06_JPRB, 0.25735922E-06_JPRB, 0.26110456E-06_JPRB, 0.26691185E-06_JPRB, 0.27734488E-06_JPRB, &
  & 0.29265338E-06_JPRB, 0.31601049E-06_JPRB, 0.35079607E-06_JPRB, 0.39807973E-06_JPRB, 0.45787319E-06_JPRB, 0.53056736E-06_JPRB, &
  & 0.62080735E-06_JPRB, 0.71464421E-06_JPRB, 0.79655902E-06_JPRB, 0.85853701E-06_JPRB, 0.90100802E-06_JPRB, 0.92627694E-06_JPRB, &
  & 0.94161195E-06_JPRB, 0.95319141E-06_JPRB, 0.96193876E-06_JPRB, 0.96845239E-06_JPRB, 0.97707170E-06_JPRB, 0.98323067E-06_JPRB, &
  & 0.98226426E-06_JPRB, 0.97894314E-06_JPRB, 0.97614285E-06_JPRB, 0.97198679E-06_JPRB, 0.96158078E-06_JPRB, 0.94713975E-06_JPRB, &
  & 0.93362128E-06_JPRB, 0.91843125E-06_JPRB, 0.91285919E-06_JPRB, 0.91808959E-06_JPRB, 0.92358968E-06_JPRB, 0.91874417E-06_JPRB, &
  & 0.89807547E-06_JPRB, 0.86067116E-06_JPRB, 0.80406471E-06_JPRB, 0.73672027E-06_JPRB, 0.67002067E-06_JPRB, 0.61184923E-06_JPRB, &
  & 0.55126108E-06_JPRB, 0.46523046E-06_JPRB, 0.36531193E-06_JPRB, 0.28810847E-06_JPRB, 0.24750570E-06_JPRB, 0.22765998E-06_JPRB, &
  & 0.21507797E-06_JPRB, 0.21000205E-06_JPRB, 0.20735269E-06_JPRB, 0.19845825E-06_JPRB, 0.18099179E-06_JPRB, 0.16038155E-06_JPRB, &
  & 0.14998968E-06_JPRB, 0.16793459E-06_JPRB, 0.20027071E-06_JPRB, 0.23160034E-06_JPRB, 0.27123900E-06_JPRB, 0.30867617E-06_JPRB, &
  & 0.33067665E-06_JPRB, 0.33559814E-06_JPRB, 0.33418826E-06_JPRB, 0.33574925E-06_JPRB  /)

RGHG2(:,17, 6) = (/ &
  & 0.28065395E-06_JPRB, 0.28305620E-06_JPRB, 0.28503358E-06_JPRB, 0.28807560E-06_JPRB, 0.29300831E-06_JPRB, 0.30343918E-06_JPRB, &
  & 0.32009426E-06_JPRB, 0.34568614E-06_JPRB, 0.38345105E-06_JPRB, 0.43690911E-06_JPRB, 0.50489892E-06_JPRB, 0.59167837E-06_JPRB, &
  & 0.69567019E-06_JPRB, 0.79370308E-06_JPRB, 0.87623417E-06_JPRB, 0.93817359E-06_JPRB, 0.98496445E-06_JPRB, 0.10143002E-05_JPRB, &
  & 0.10352452E-05_JPRB, 0.10584695E-05_JPRB, 0.10811646E-05_JPRB, 0.11038400E-05_JPRB, 0.11257523E-05_JPRB, 0.11452935E-05_JPRB, &
  & 0.11631256E-05_JPRB, 0.11761095E-05_JPRB, 0.11817381E-05_JPRB, 0.11754705E-05_JPRB, 0.11523764E-05_JPRB, 0.11187180E-05_JPRB, &
  & 0.10832275E-05_JPRB, 0.10527528E-05_JPRB, 0.10392615E-05_JPRB, 0.10372813E-05_JPRB, 0.10342409E-05_JPRB, 0.10170769E-05_JPRB, &
  & 0.98108091E-06_JPRB, 0.92453877E-06_JPRB, 0.84103023E-06_JPRB, 0.75381083E-06_JPRB, 0.68012636E-06_JPRB, 0.62296220E-06_JPRB, &
  & 0.57082282E-06_JPRB, 0.49423450E-06_JPRB, 0.39832878E-06_JPRB, 0.32111276E-06_JPRB, 0.28085284E-06_JPRB, 0.25856508E-06_JPRB, &
  & 0.24148774E-06_JPRB, 0.23217976E-06_JPRB, 0.22615365E-06_JPRB, 0.21524398E-06_JPRB, 0.19524295E-06_JPRB, 0.17368755E-06_JPRB, &
  & 0.16326937E-06_JPRB, 0.18063344E-06_JPRB, 0.21920776E-06_JPRB, 0.25759767E-06_JPRB, 0.30036539E-06_JPRB, 0.33588150E-06_JPRB, &
  & 0.35449120E-06_JPRB, 0.35518597E-06_JPRB, 0.35197235E-06_JPRB, 0.35346321E-06_JPRB  /)

RGHG2(:,18, 6) = (/ &
  & 0.33625542E-06_JPRB, 0.33770276E-06_JPRB, 0.33868790E-06_JPRB, 0.34065315E-06_JPRB, 0.34481671E-06_JPRB, 0.35341529E-06_JPRB, &
  & 0.36896814E-06_JPRB, 0.39423807E-06_JPRB, 0.43243261E-06_JPRB, 0.48708953E-06_JPRB, 0.55902543E-06_JPRB, 0.65228963E-06_JPRB, &
  & 0.75930972E-06_JPRB, 0.85483115E-06_JPRB, 0.93287888E-06_JPRB, 0.99313426E-06_JPRB, 0.10415790E-05_JPRB, 0.10739034E-05_JPRB, &
  & 0.10966355E-05_JPRB, 0.11234281E-05_JPRB, 0.11561997E-05_JPRB, 0.11896713E-05_JPRB, 0.12183881E-05_JPRB, 0.12477354E-05_JPRB, &
  & 0.12820486E-05_JPRB, 0.13129431E-05_JPRB, 0.13303537E-05_JPRB, 0.13324232E-05_JPRB, 0.13150469E-05_JPRB, 0.12802402E-05_JPRB, &
  & 0.12362314E-05_JPRB, 0.11956606E-05_JPRB, 0.11676344E-05_JPRB, 0.11475545E-05_JPRB, 0.11245749E-05_JPRB, 0.10872293E-05_JPRB, &
  & 0.10345041E-05_JPRB, 0.96047901E-06_JPRB, 0.85754411E-06_JPRB, 0.75838205E-06_JPRB, 0.68380757E-06_JPRB, 0.63064633E-06_JPRB, &
  & 0.58607830E-06_JPRB, 0.51918935E-06_JPRB, 0.42890948E-06_JPRB, 0.35659834E-06_JPRB, 0.31937974E-06_JPRB, 0.29446272E-06_JPRB, &
  & 0.27330757E-06_JPRB, 0.25927175E-06_JPRB, 0.24939272E-06_JPRB, 0.23808722E-06_JPRB, 0.21833378E-06_JPRB, 0.19707293E-06_JPRB, &
  & 0.18629977E-06_JPRB, 0.20370122E-06_JPRB, 0.24575960E-06_JPRB, 0.29008349E-06_JPRB, 0.33367222E-06_JPRB, 0.36632888E-06_JPRB, &
  & 0.38112363E-06_JPRB, 0.38231906E-06_JPRB, 0.38107540E-06_JPRB, 0.38140154E-06_JPRB  /)

RGHG2(:,19, 6) = (/ &
  & 0.41236030E-06_JPRB, 0.41334818E-06_JPRB, 0.41376661E-06_JPRB, 0.41517269E-06_JPRB, 0.41859064E-06_JPRB, 0.42610103E-06_JPRB, &
  & 0.43947291E-06_JPRB, 0.46245218E-06_JPRB, 0.49838377E-06_JPRB, 0.55032335E-06_JPRB, 0.62053205E-06_JPRB, 0.71132572E-06_JPRB, &
  & 0.81478855E-06_JPRB, 0.90437831E-06_JPRB, 0.97549835E-06_JPRB, 0.10315706E-05_JPRB, 0.10775279E-05_JPRB, 0.11095536E-05_JPRB, &
  & 0.11324851E-05_JPRB, 0.11574598E-05_JPRB, 0.11910499E-05_JPRB, 0.12285322E-05_JPRB, 0.12610029E-05_JPRB, 0.12978434E-05_JPRB, &
  & 0.13434102E-05_JPRB, 0.13871554E-05_JPRB, 0.14186309E-05_JPRB, 0.14393195E-05_JPRB, 0.14418295E-05_JPRB, 0.14220003E-05_JPRB, &
  & 0.13835096E-05_JPRB, 0.13371659E-05_JPRB, 0.12892756E-05_JPRB, 0.12405655E-05_JPRB, 0.11899479E-05_JPRB, 0.11308014E-05_JPRB, &
  & 0.10610207E-05_JPRB, 0.97154686E-06_JPRB, 0.85767579E-06_JPRB, 0.75628355E-06_JPRB, 0.68550749E-06_JPRB, 0.63695518E-06_JPRB, &
  & 0.59869074E-06_JPRB, 0.54038088E-06_JPRB, 0.45785551E-06_JPRB, 0.39398078E-06_JPRB, 0.36111006E-06_JPRB, 0.33428489E-06_JPRB, &
  & 0.31060417E-06_JPRB, 0.29251833E-06_JPRB, 0.27887055E-06_JPRB, 0.26812702E-06_JPRB, 0.24917230E-06_JPRB, 0.22877871E-06_JPRB, &
  & 0.21637107E-06_JPRB, 0.23438313E-06_JPRB, 0.27799979E-06_JPRB, 0.32531311E-06_JPRB, 0.36783511E-06_JPRB, 0.39689601E-06_JPRB, &
  & 0.40942459E-06_JPRB, 0.41206737E-06_JPRB, 0.41322805E-06_JPRB, 0.41373793E-06_JPRB  /)

RGHG2(:,20, 6) = (/ &
  & 0.50171387E-06_JPRB, 0.50275129E-06_JPRB, 0.50317509E-06_JPRB, 0.50470462E-06_JPRB, 0.50801059E-06_JPRB, 0.51514114E-06_JPRB, &
  & 0.52655152E-06_JPRB, 0.54697628E-06_JPRB, 0.57869553E-06_JPRB, 0.62469576E-06_JPRB, 0.68849400E-06_JPRB, 0.77111610E-06_JPRB, &
  & 0.86622729E-06_JPRB, 0.94752445E-06_JPRB, 0.10103745E-05_JPRB, 0.10604206E-05_JPRB, 0.11007710E-05_JPRB, 0.11305111E-05_JPRB, &
  & 0.11525434E-05_JPRB, 0.11743257E-05_JPRB, 0.12022868E-05_JPRB, 0.12357318E-05_JPRB, 0.12693082E-05_JPRB, 0.13123823E-05_JPRB, &
  & 0.13666501E-05_JPRB, 0.14201067E-05_JPRB, 0.14665745E-05_JPRB, 0.15084693E-05_JPRB, 0.15337143E-05_JPRB, 0.15331646E-05_JPRB, &
  & 0.15056385E-05_JPRB, 0.14565097E-05_JPRB, 0.13891944E-05_JPRB, 0.13110622E-05_JPRB, 0.12343588E-05_JPRB, 0.11559406E-05_JPRB, &
  & 0.10704958E-05_JPRB, 0.96872066E-06_JPRB, 0.85133707E-06_JPRB, 0.75443874E-06_JPRB, 0.68918744E-06_JPRB, 0.64391823E-06_JPRB, &
  & 0.60962405E-06_JPRB, 0.55906089E-06_JPRB, 0.48701805E-06_JPRB, 0.43368964E-06_JPRB, 0.40504542E-06_JPRB, 0.37745731E-06_JPRB, &
  & 0.35202678E-06_JPRB, 0.33196193E-06_JPRB, 0.31650928E-06_JPRB, 0.30584013E-06_JPRB, 0.28662067E-06_JPRB, 0.26705218E-06_JPRB, &
  & 0.25317511E-06_JPRB, 0.27028847E-06_JPRB, 0.31301163E-06_JPRB, 0.35943652E-06_JPRB, 0.39901583E-06_JPRB, 0.42569397E-06_JPRB, &
  & 0.43858511E-06_JPRB, 0.44251335E-06_JPRB, 0.44477460E-06_JPRB, 0.44699302E-06_JPRB  /)

RGHG2(:,21, 6) = (/ &
  & 0.59847181E-06_JPRB, 0.59965493E-06_JPRB, 0.60041680E-06_JPRB, 0.60265907E-06_JPRB, 0.60658196E-06_JPRB, 0.61382944E-06_JPRB, &
  & 0.62424774E-06_JPRB, 0.64263902E-06_JPRB, 0.66926404E-06_JPRB, 0.70749337E-06_JPRB, 0.76218191E-06_JPRB, 0.83352676E-06_JPRB, &
  & 0.91666670E-06_JPRB, 0.98771087E-06_JPRB, 0.10415932E-05_JPRB, 0.10846002E-05_JPRB, 0.11182423E-05_JPRB, 0.11448365E-05_JPRB, &
  & 0.11651714E-05_JPRB, 0.11837880E-05_JPRB, 0.12037538E-05_JPRB, 0.12280290E-05_JPRB, 0.12596905E-05_JPRB, 0.13079731E-05_JPRB, &
  & 0.13706703E-05_JPRB, 0.14327107E-05_JPRB, 0.14939553E-05_JPRB, 0.15542683E-05_JPRB, 0.15968315E-05_JPRB, 0.16101130E-05_JPRB, &
  & 0.15917073E-05_JPRB, 0.15414838E-05_JPRB, 0.14597027E-05_JPRB, 0.13593175E-05_JPRB, 0.12634247E-05_JPRB, 0.11705825E-05_JPRB, &
  & 0.10727209E-05_JPRB, 0.96249110E-06_JPRB, 0.84683939E-06_JPRB, 0.75762584E-06_JPRB, 0.69731848E-06_JPRB, 0.65364242E-06_JPRB, &
  & 0.62103167E-06_JPRB, 0.57682087E-06_JPRB, 0.51709346E-06_JPRB, 0.47572857E-06_JPRB, 0.45119545E-06_JPRB, 0.42386102E-06_JPRB, &
  & 0.39661144E-06_JPRB, 0.37686821E-06_JPRB, 0.36229907E-06_JPRB, 0.35105919E-06_JPRB, 0.33068868E-06_JPRB, 0.31166999E-06_JPRB, &
  & 0.29703158E-06_JPRB, 0.31098018E-06_JPRB, 0.34935786E-06_JPRB, 0.39085271E-06_JPRB, 0.42607829E-06_JPRB, 0.45182356E-06_JPRB, &
  & 0.46704344E-06_JPRB, 0.47275726E-06_JPRB, 0.47503354E-06_JPRB, 0.47858959E-06_JPRB  /)

RGHG2(:,22, 6) = (/ &
  & 0.69680831E-06_JPRB, 0.69768561E-06_JPRB, 0.69863862E-06_JPRB, 0.70208507E-06_JPRB, 0.70719304E-06_JPRB, 0.71505217E-06_JPRB, &
  & 0.72612035E-06_JPRB, 0.74334567E-06_JPRB, 0.76519216E-06_JPRB, 0.79562293E-06_JPRB, 0.84071619E-06_JPRB, 0.89942662E-06_JPRB, &
  & 0.96782957E-06_JPRB, 0.10267936E-05_JPRB, 0.10716159E-05_JPRB, 0.11073595E-05_JPRB, 0.11356688E-05_JPRB, 0.11589562E-05_JPRB, &
  & 0.11771121E-05_JPRB, 0.11926322E-05_JPRB, 0.12063477E-05_JPRB, 0.12212570E-05_JPRB, 0.12470695E-05_JPRB, 0.12991368E-05_JPRB, &
  & 0.13716013E-05_JPRB, 0.14422239E-05_JPRB, 0.15166955E-05_JPRB, 0.15881138E-05_JPRB, 0.16348439E-05_JPRB, 0.16469594E-05_JPRB, &
  & 0.16290698E-05_JPRB, 0.15783685E-05_JPRB, 0.14918280E-05_JPRB, 0.13844660E-05_JPRB, 0.12806600E-05_JPRB, 0.11808794E-05_JPRB, &
  & 0.10765190E-05_JPRB, 0.96281044E-06_JPRB, 0.85203283E-06_JPRB, 0.77035024E-06_JPRB, 0.71226011E-06_JPRB, 0.66866051E-06_JPRB, &
  & 0.63583951E-06_JPRB, 0.59505013E-06_JPRB, 0.54776601E-06_JPRB, 0.51945605E-06_JPRB, 0.49964412E-06_JPRB, 0.47332274E-06_JPRB, &
  & 0.44343541E-06_JPRB, 0.42621525E-06_JPRB, 0.41560272E-06_JPRB, 0.40369385E-06_JPRB, 0.38229118E-06_JPRB, 0.36346363E-06_JPRB, &
  & 0.34874876E-06_JPRB, 0.35709693E-06_JPRB, 0.38605135E-06_JPRB, 0.41825674E-06_JPRB, 0.44835974E-06_JPRB, 0.47395210E-06_JPRB, &
  & 0.49213467E-06_JPRB, 0.50161397E-06_JPRB, 0.50383290E-06_JPRB, 0.50530552E-06_JPRB  /)

RGHG2(:,23, 6) = (/ &
  & 0.78260661E-06_JPRB, 0.78384479E-06_JPRB, 0.78541232E-06_JPRB, 0.78989151E-06_JPRB, 0.79683591E-06_JPRB, 0.80629963E-06_JPRB, &
  & 0.81849015E-06_JPRB, 0.83566016E-06_JPRB, 0.85575200E-06_JPRB, 0.88200485E-06_JPRB, 0.91935752E-06_JPRB, 0.96698967E-06_JPRB, &
  & 0.10204283E-05_JPRB, 0.10683309E-05_JPRB, 0.11057010E-05_JPRB, 0.11351223E-05_JPRB, 0.11595314E-05_JPRB, 0.11806065E-05_JPRB, &
  & 0.11965100E-05_JPRB, 0.12095981E-05_JPRB, 0.12206329E-05_JPRB, 0.12312334E-05_JPRB, 0.12555965E-05_JPRB, 0.13123626E-05_JPRB, &
  & 0.13898046E-05_JPRB, 0.14687834E-05_JPRB, 0.15485767E-05_JPRB, 0.16173230E-05_JPRB, 0.16535749E-05_JPRB, 0.16568315E-05_JPRB, &
  & 0.16338152E-05_JPRB, 0.15806880E-05_JPRB, 0.14964091E-05_JPRB, 0.13941456E-05_JPRB, 0.12930974E-05_JPRB, 0.11957587E-05_JPRB, &
  & 0.10933423E-05_JPRB, 0.98082316E-06_JPRB, 0.87486716E-06_JPRB, 0.79626799E-06_JPRB, 0.73822996E-06_JPRB, 0.69418283E-06_JPRB, &
  & 0.65916384E-06_JPRB, 0.61973298E-06_JPRB, 0.58169622E-06_JPRB, 0.56318909E-06_JPRB, 0.54853126E-06_JPRB, 0.52354038E-06_JPRB, &
  & 0.49405535E-06_JPRB, 0.48031242E-06_JPRB, 0.47341463E-06_JPRB, 0.46247954E-06_JPRB, 0.44213138E-06_JPRB, 0.42411601E-06_JPRB, &
  & 0.40841941E-06_JPRB, 0.40842785E-06_JPRB, 0.42587506E-06_JPRB, 0.44783510E-06_JPRB, 0.47156802E-06_JPRB, 0.49236882E-06_JPRB, &
  & 0.50977515E-06_JPRB, 0.52212659E-06_JPRB, 0.52630050E-06_JPRB, 0.52668695E-06_JPRB  /)

RGHG2(:,24, 6) = (/ &
  & 0.86347129E-06_JPRB, 0.86522434E-06_JPRB, 0.86769466E-06_JPRB, 0.87337643E-06_JPRB, 0.88224401E-06_JPRB, 0.89344911E-06_JPRB, &
  & 0.90711963E-06_JPRB, 0.92484946E-06_JPRB, 0.94453099E-06_JPRB, 0.96818389E-06_JPRB, 0.99909993E-06_JPRB, 0.10365896E-05_JPRB, &
  & 0.10762171E-05_JPRB, 0.11139379E-05_JPRB, 0.11449731E-05_JPRB, 0.11690590E-05_JPRB, 0.11893438E-05_JPRB, 0.12080931E-05_JPRB, &
  & 0.12224082E-05_JPRB, 0.12343803E-05_JPRB, 0.12438609E-05_JPRB, 0.12527192E-05_JPRB, 0.12781937E-05_JPRB, 0.13374894E-05_JPRB, &
  & 0.14169462E-05_JPRB, 0.15019353E-05_JPRB, 0.15830100E-05_JPRB, 0.16434982E-05_JPRB, 0.16664726E-05_JPRB, 0.16598507E-05_JPRB, &
  & 0.16304754E-05_JPRB, 0.15756410E-05_JPRB, 0.14968627E-05_JPRB, 0.14035759E-05_JPRB, 0.13088060E-05_JPRB, 0.12167281E-05_JPRB, &
  & 0.11187979E-05_JPRB, 0.10092695E-05_JPRB, 0.90774113E-06_JPRB, 0.83115827E-06_JPRB, 0.77269080E-06_JPRB, 0.72743183E-06_JPRB, &
  & 0.69023348E-06_JPRB, 0.65242267E-06_JPRB, 0.62144782E-06_JPRB, 0.61021061E-06_JPRB, 0.59965521E-06_JPRB, 0.57678874E-06_JPRB, &
  & 0.54998669E-06_JPRB, 0.53932332E-06_JPRB, 0.53513371E-06_JPRB, 0.52567268E-06_JPRB, 0.50721387E-06_JPRB, 0.49059005E-06_JPRB, &
  & 0.47392583E-06_JPRB, 0.46540674E-06_JPRB, 0.47176474E-06_JPRB, 0.48359603E-06_JPRB, 0.50000858E-06_JPRB, 0.51463238E-06_JPRB, &
  & 0.52919153E-06_JPRB, 0.54213152E-06_JPRB, 0.54806201E-06_JPRB, 0.54819862E-06_JPRB  /)

RGHG2(:,25, 6) = (/ &
  & 0.93477464E-06_JPRB, 0.93714228E-06_JPRB, 0.94089031E-06_JPRB, 0.94806005E-06_JPRB, 0.95877140E-06_JPRB, 0.97165856E-06_JPRB, &
  & 0.98726990E-06_JPRB, 0.10063745E-05_JPRB, 0.10273661E-05_JPRB, 0.10505176E-05_JPRB, 0.10771800E-05_JPRB, 0.11062917E-05_JPRB, &
  & 0.11348242E-05_JPRB, 0.11641509E-05_JPRB, 0.11907546E-05_JPRB, 0.12112823E-05_JPRB, 0.12269092E-05_JPRB, 0.12429898E-05_JPRB, &
  & 0.12569814E-05_JPRB, 0.12700695E-05_JPRB, 0.12792590E-05_JPRB, 0.12898640E-05_JPRB, 0.13199480E-05_JPRB, 0.13776102E-05_JPRB, &
  & 0.14548188E-05_JPRB, 0.15414414E-05_JPRB, 0.16183595E-05_JPRB, 0.16641622E-05_JPRB, 0.16727906E-05_JPRB, 0.16566587E-05_JPRB, &
  & 0.16202964E-05_JPRB, 0.15655429E-05_JPRB, 0.14961776E-05_JPRB, 0.14156194E-05_JPRB, 0.13306830E-05_JPRB, 0.12465139E-05_JPRB, &
  & 0.11554737E-05_JPRB, 0.10509429E-05_JPRB, 0.95295655E-06_JPRB, 0.87740880E-06_JPRB, 0.81816499E-06_JPRB, 0.77051234E-06_JPRB, &
  & 0.73171281E-06_JPRB, 0.69637655E-06_JPRB, 0.66899223E-06_JPRB, 0.66094121E-06_JPRB, 0.65234280E-06_JPRB, 0.63284043E-06_JPRB, &
  & 0.61195790E-06_JPRB, 0.60331622E-06_JPRB, 0.59998381E-06_JPRB, 0.59244743E-06_JPRB, 0.57680282E-06_JPRB, 0.56239477E-06_JPRB, &
  & 0.54503509E-06_JPRB, 0.52865566E-06_JPRB, 0.52563301E-06_JPRB, 0.52821302E-06_JPRB, 0.53623150E-06_JPRB, 0.54354486E-06_JPRB, &
  & 0.55255649E-06_JPRB, 0.56221325E-06_JPRB, 0.56901711E-06_JPRB, 0.57017266E-06_JPRB  /)

RGHG2(:,26, 6) = (/ &
  & 0.99817531E-06_JPRB, 0.10008424E-05_JPRB, 0.10053085E-05_JPRB, 0.10135817E-05_JPRB, 0.10255322E-05_JPRB, 0.10398400E-05_JPRB, &
  & 0.10575577E-05_JPRB, 0.10782582E-05_JPRB, 0.11006049E-05_JPRB, 0.11238276E-05_JPRB, 0.11480978E-05_JPRB, 0.11718624E-05_JPRB, &
  & 0.11942298E-05_JPRB, 0.12180026E-05_JPRB, 0.12419757E-05_JPRB, 0.12604424E-05_JPRB, 0.12725697E-05_JPRB, 0.12858952E-05_JPRB, &
  & 0.12995998E-05_JPRB, 0.13136938E-05_JPRB, 0.13239152E-05_JPRB, 0.13368529E-05_JPRB, 0.13691238E-05_JPRB, 0.14221284E-05_JPRB, &
  & 0.14920038E-05_JPRB, 0.15708818E-05_JPRB, 0.16396794E-05_JPRB, 0.16747542E-05_JPRB, 0.16762386E-05_JPRB, 0.16566367E-05_JPRB, &
  & 0.16193935E-05_JPRB, 0.15680708E-05_JPRB, 0.15074669E-05_JPRB, 0.14382962E-05_JPRB, 0.13631050E-05_JPRB, 0.12854389E-05_JPRB, &
  & 0.12001555E-05_JPRB, 0.11017811E-05_JPRB, 0.10084299E-05_JPRB, 0.93528418E-06_JPRB, 0.87645512E-06_JPRB, 0.82813317E-06_JPRB, &
  & 0.78938327E-06_JPRB, 0.75521695E-06_JPRB, 0.72879394E-06_JPRB, 0.71875349E-06_JPRB, 0.70927163E-06_JPRB, 0.69404892E-06_JPRB, &
  & 0.67888221E-06_JPRB, 0.67068457E-06_JPRB, 0.66629797E-06_JPRB, 0.65914826E-06_JPRB, 0.64561490E-06_JPRB, 0.63236231E-06_JPRB, &
  & 0.61532134E-06_JPRB, 0.59693734E-06_JPRB, 0.58715423E-06_JPRB, 0.58342320E-06_JPRB, 0.58502475E-06_JPRB, 0.58808014E-06_JPRB, &
  & 0.59230442E-06_JPRB, 0.59692489E-06_JPRB, 0.60194360E-06_JPRB, 0.60474040E-06_JPRB  /)

RGHG2(:,27, 6) = (/ &
  & 0.10615319E-05_JPRB, 0.10643951E-05_JPRB, 0.10694045E-05_JPRB, 0.10786887E-05_JPRB, 0.10917107E-05_JPRB, 0.11074069E-05_JPRB, &
  & 0.11273882E-05_JPRB, 0.11498392E-05_JPRB, 0.11736196E-05_JPRB, 0.11971290E-05_JPRB, 0.12195883E-05_JPRB, 0.12388860E-05_JPRB, &
  & 0.12566356E-05_JPRB, 0.12756548E-05_JPRB, 0.12975454E-05_JPRB, 0.13144125E-05_JPRB, 0.13233103E-05_JPRB, 0.13337234E-05_JPRB, &
  & 0.13471412E-05_JPRB, 0.13622463E-05_JPRB, 0.13740372E-05_JPRB, 0.13896308E-05_JPRB, 0.14232901E-05_JPRB, 0.14703036E-05_JPRB, &
  & 0.15306266E-05_JPRB, 0.15979299E-05_JPRB, 0.16567676E-05_JPRB, 0.16820939E-05_JPRB, 0.16787794E-05_JPRB, 0.16577892E-05_JPRB, &
  & 0.16218891E-05_JPRB, 0.15753953E-05_JPRB, 0.15237101E-05_JPRB, 0.14659480E-05_JPRB, 0.14009129E-05_JPRB, 0.13295246E-05_JPRB, &
  & 0.12498398E-05_JPRB, 0.11583317E-05_JPRB, 0.10702321E-05_JPRB, 0.10001045E-05_JPRB, 0.94215073E-06_JPRB, 0.89376842E-06_JPRB, &
  & 0.85568251E-06_JPRB, 0.82225563E-06_JPRB, 0.79586280E-06_JPRB, 0.78182331E-06_JPRB, 0.77036456E-06_JPRB, 0.75995580E-06_JPRB, &
  & 0.75068957E-06_JPRB, 0.74237121E-06_JPRB, 0.73617372E-06_JPRB, 0.72885801E-06_JPRB, 0.71727136E-06_JPRB, 0.70483367E-06_JPRB, &
  & 0.68850197E-06_JPRB, 0.67019342E-06_JPRB, 0.65431364E-06_JPRB, 0.64507449E-06_JPRB, 0.64070009E-06_JPRB, 0.64043552E-06_JPRB, &
  & 0.63993639E-06_JPRB, 0.63864128E-06_JPRB, 0.64080785E-06_JPRB, 0.64555135E-06_JPRB  /)

RGHG2(:,28, 6) = (/ &
  & 0.11223775E-05_JPRB, 0.11237336E-05_JPRB, 0.11280257E-05_JPRB, 0.11371369E-05_JPRB, 0.11500258E-05_JPRB, 0.11662146E-05_JPRB, &
  & 0.11865854E-05_JPRB, 0.12095058E-05_JPRB, 0.12332424E-05_JPRB, 0.12561872E-05_JPRB, 0.12783125E-05_JPRB, 0.12973344E-05_JPRB, &
  & 0.13142891E-05_JPRB, 0.13319822E-05_JPRB, 0.13512495E-05_JPRB, 0.13664514E-05_JPRB, 0.13750345E-05_JPRB, 0.13843816E-05_JPRB, &
  & 0.13971872E-05_JPRB, 0.14118939E-05_JPRB, 0.14248231E-05_JPRB, 0.14409217E-05_JPRB, 0.14721694E-05_JPRB, 0.15130885E-05_JPRB, &
  & 0.15611681E-05_JPRB, 0.16130312E-05_JPRB, 0.16601353E-05_JPRB, 0.16832755E-05_JPRB, 0.16835407E-05_JPRB, 0.16683046E-05_JPRB, &
  & 0.16381158E-05_JPRB, 0.15961685E-05_JPRB, 0.15493281E-05_JPRB, 0.14987622E-05_JPRB, 0.14417129E-05_JPRB, 0.13766305E-05_JPRB, &
  & 0.13030998E-05_JPRB, 0.12204621E-05_JPRB, 0.11420458E-05_JPRB, 0.10790224E-05_JPRB, 0.10252217E-05_JPRB, 0.97987913E-06_JPRB, &
  & 0.94211978E-06_JPRB, 0.90718214E-06_JPRB, 0.87844946E-06_JPRB, 0.85943298E-06_JPRB, 0.84550540E-06_JPRB, 0.83467245E-06_JPRB, &
  & 0.82545041E-06_JPRB, 0.81651387E-06_JPRB, 0.80797927E-06_JPRB, 0.79785280E-06_JPRB, 0.78482788E-06_JPRB, 0.77095752E-06_JPRB, &
  & 0.75506682E-06_JPRB, 0.73934014E-06_JPRB, 0.72383412E-06_JPRB, 0.71531735E-06_JPRB, 0.71113367E-06_JPRB, 0.70989982E-06_JPRB, &
  & 0.70765014E-06_JPRB, 0.70568432E-06_JPRB, 0.70777632E-06_JPRB, 0.71289680E-06_JPRB  /)

RGHG2(:,29, 6) = (/ &
  & 0.11867395E-05_JPRB, 0.11864250E-05_JPRB, 0.11899024E-05_JPRB, 0.11987789E-05_JPRB, 0.12114744E-05_JPRB, 0.12281466E-05_JPRB, &
  & 0.12488487E-05_JPRB, 0.12722110E-05_JPRB, 0.12958371E-05_JPRB, 0.13181468E-05_JPRB, 0.13399821E-05_JPRB, 0.13588935E-05_JPRB, &
  & 0.13751716E-05_JPRB, 0.13916083E-05_JPRB, 0.14080727E-05_JPRB, 0.14215071E-05_JPRB, 0.14298831E-05_JPRB, 0.14381808E-05_JPRB, &
  & 0.14503237E-05_JPRB, 0.14645471E-05_JPRB, 0.14786638E-05_JPRB, 0.14952042E-05_JPRB, 0.15237318E-05_JPRB, 0.15581890E-05_JPRB, &
  & 0.15931789E-05_JPRB, 0.16285143E-05_JPRB, 0.16631087E-05_JPRB, 0.16842606E-05_JPRB, 0.16886818E-05_JPRB, 0.16798525E-05_JPRB, &
  & 0.16559048E-05_JPRB, 0.16187625E-05_JPRB, 0.15768791E-05_JPRB, 0.15337555E-05_JPRB, 0.14850736E-05_JPRB, 0.14266741E-05_JPRB, &
  & 0.13596882E-05_JPRB, 0.12865363E-05_JPRB, 0.12185724E-05_JPRB, 0.11632536E-05_JPRB, 0.11139957E-05_JPRB, 0.10720083E-05_JPRB, &
  & 0.10345804E-05_JPRB, 0.99794440E-06_JPRB, 0.96662970E-06_JPRB, 0.94229728E-06_JPRB, 0.92573244E-06_JPRB, 0.91422292E-06_JPRB, &
  & 0.90479376E-06_JPRB, 0.89518065E-06_JPRB, 0.88414687E-06_JPRB, 0.87092749E-06_JPRB, 0.85623185E-06_JPRB, 0.84074600E-06_JPRB, &
  & 0.82531095E-06_JPRB, 0.81242864E-06_JPRB, 0.79759919E-06_JPRB, 0.79011799E-06_JPRB, 0.78640378E-06_JPRB, 0.78424481E-06_JPRB, &
  & 0.78026918E-06_JPRB, 0.77782010E-06_JPRB, 0.77995351E-06_JPRB, 0.78540538E-06_JPRB  /)

RGHG2(:,30, 6) = (/ &
  & 0.12508025E-05_JPRB, 0.12490672E-05_JPRB, 0.12509064E-05_JPRB, 0.12585818E-05_JPRB, 0.12705009E-05_JPRB, 0.12853358E-05_JPRB, &
  & 0.13035456E-05_JPRB, 0.13246278E-05_JPRB, 0.13464708E-05_JPRB, 0.13679308E-05_JPRB, 0.13899902E-05_JPRB, 0.14091503E-05_JPRB, &
  & 0.14255308E-05_JPRB, 0.14414994E-05_JPRB, 0.14557233E-05_JPRB, 0.14670213E-05_JPRB, 0.14748634E-05_JPRB, 0.14835362E-05_JPRB, &
  & 0.14959150E-05_JPRB, 0.15102957E-05_JPRB, 0.15253413E-05_JPRB, 0.15423371E-05_JPRB, 0.15667744E-05_JPRB, 0.15939601E-05_JPRB, &
  & 0.16206415E-05_JPRB, 0.16456942E-05_JPRB, 0.16700579E-05_JPRB, 0.16868656E-05_JPRB, 0.16933769E-05_JPRB, 0.16893689E-05_JPRB, &
  & 0.16706001E-05_JPRB, 0.16366341E-05_JPRB, 0.15977027E-05_JPRB, 0.15608751E-05_JPRB, 0.15209947E-05_JPRB, 0.14730450E-05_JPRB, &
  & 0.14169757E-05_JPRB, 0.13564716E-05_JPRB, 0.13013018E-05_JPRB, 0.12550570E-05_JPRB, 0.12122501E-05_JPRB, 0.11730557E-05_JPRB, &
  & 0.11357432E-05_JPRB, 0.11001246E-05_JPRB, 0.10679585E-05_JPRB, 0.10408254E-05_JPRB, 0.10187634E-05_JPRB, 0.10002908E-05_JPRB, &
  & 0.98537878E-06_JPRB, 0.97216252E-06_JPRB, 0.95873086E-06_JPRB, 0.94394396E-06_JPRB, 0.92635993E-06_JPRB, 0.90867713E-06_JPRB, &
  & 0.89256930E-06_JPRB, 0.88062960E-06_JPRB, 0.86953067E-06_JPRB, 0.86457946E-06_JPRB, 0.86277004E-06_JPRB, 0.86087103E-06_JPRB, &
  & 0.85509258E-06_JPRB, 0.85008367E-06_JPRB, 0.85154999E-06_JPRB, 0.85591654E-06_JPRB  /)

RGHG2(:,31, 6) = (/ &
  & 0.13183023E-05_JPRB, 0.13150704E-05_JPRB, 0.13151827E-05_JPRB, 0.13215916E-05_JPRB, 0.13326920E-05_JPRB, 0.13455889E-05_JPRB, &
  & 0.13611699E-05_JPRB, 0.13798473E-05_JPRB, 0.13998098E-05_JPRB, 0.14203744E-05_JPRB, 0.14426704E-05_JPRB, 0.14620927E-05_JPRB, &
  & 0.14785820E-05_JPRB, 0.14940580E-05_JPRB, 0.15059218E-05_JPRB, 0.15149684E-05_JPRB, 0.15222477E-05_JPRB, 0.15313170E-05_JPRB, &
  & 0.15439453E-05_JPRB, 0.15584923E-05_JPRB, 0.15745165E-05_JPRB, 0.15919919E-05_JPRB, 0.16121184E-05_JPRB, 0.16316416E-05_JPRB, &
  & 0.16495732E-05_JPRB, 0.16637974E-05_JPRB, 0.16773838E-05_JPRB, 0.16896119E-05_JPRB, 0.16983234E-05_JPRB, 0.16993939E-05_JPRB, &
  & 0.16860809E-05_JPRB, 0.16554600E-05_JPRB, 0.16196371E-05_JPRB, 0.15894422E-05_JPRB, 0.15588361E-05_JPRB, 0.15219003E-05_JPRB, &
  & 0.14773376E-05_JPRB, 0.14301628E-05_JPRB, 0.13884759E-05_JPRB, 0.13517932E-05_JPRB, 0.13157853E-05_JPRB, 0.12795330E-05_JPRB, &
  & 0.12423421E-05_JPRB, 0.12077980E-05_JPRB, 0.11747364E-05_JPRB, 0.11446547E-05_JPRB, 0.11167979E-05_JPRB, 0.10909827E-05_JPRB, &
  & 0.10702886E-05_JPRB, 0.10532731E-05_JPRB, 0.10373150E-05_JPRB, 0.10208780E-05_JPRB, 0.10002494E-05_JPRB, 0.98025125E-06_JPRB, &
  & 0.96343345E-06_JPRB, 0.95248514E-06_JPRB, 0.94531977E-06_JPRB, 0.94303571E-06_JPRB, 0.94323465E-06_JPRB, 0.94161068E-06_JPRB, &
  & 0.93393260E-06_JPRB, 0.92622456E-06_JPRB, 0.92698732E-06_JPRB, 0.93020898E-06_JPRB  /)

RGHG2(:,32, 6) = (/ &
  & 0.13796758E-05_JPRB, 0.13769474E-05_JPRB, 0.13761681E-05_JPRB, 0.13808768E-05_JPRB, 0.13908310E-05_JPRB, 0.14010006E-05_JPRB, &
  & 0.14126657E-05_JPRB, 0.14278278E-05_JPRB, 0.14449510E-05_JPRB, 0.14638100E-05_JPRB, 0.14846906E-05_JPRB, 0.15034109E-05_JPRB, &
  & 0.15194643E-05_JPRB, 0.15341186E-05_JPRB, 0.15445058E-05_JPRB, 0.15522115E-05_JPRB, 0.15593254E-05_JPRB, 0.15682688E-05_JPRB, &
  & 0.15805797E-05_JPRB, 0.15946200E-05_JPRB, 0.16101553E-05_JPRB, 0.16268292E-05_JPRB, 0.16436463E-05_JPRB, 0.16586753E-05_JPRB, &
  & 0.16717401E-05_JPRB, 0.16812018E-05_JPRB, 0.16895268E-05_JPRB, 0.16974170E-05_JPRB, 0.17041480E-05_JPRB, 0.17058016E-05_JPRB, &
  & 0.16955696E-05_JPRB, 0.16693456E-05_JPRB, 0.16379139E-05_JPRB, 0.16124697E-05_JPRB, 0.15890232E-05_JPRB, 0.15622869E-05_JPRB, &
  & 0.15302693E-05_JPRB, 0.14960168E-05_JPRB, 0.14655082E-05_JPRB, 0.14370827E-05_JPRB, 0.14081403E-05_JPRB, 0.13767602E-05_JPRB, &
  & 0.13413540E-05_JPRB, 0.13063729E-05_JPRB, 0.12715233E-05_JPRB, 0.12384119E-05_JPRB, 0.12068960E-05_JPRB, 0.11769052E-05_JPRB, &
  & 0.11518070E-05_JPRB, 0.11311217E-05_JPRB, 0.11126750E-05_JPRB, 0.10940007E-05_JPRB, 0.10726539E-05_JPRB, 0.10521727E-05_JPRB, &
  & 0.10347717E-05_JPRB, 0.10231043E-05_JPRB, 0.10165188E-05_JPRB, 0.10137631E-05_JPRB, 0.10131187E-05_JPRB, 0.10112420E-05_JPRB, &
  & 0.10027666E-05_JPRB, 0.99246833E-06_JPRB, 0.98902388E-06_JPRB, 0.98966278E-06_JPRB  /)

RGHG2(:,33, 6) = (/ &
  & 0.14426648E-05_JPRB, 0.14407187E-05_JPRB, 0.14391211E-05_JPRB, 0.14420064E-05_JPRB, 0.14507271E-05_JPRB, 0.14579602E-05_JPRB, &
  & 0.14653891E-05_JPRB, 0.14767542E-05_JPRB, 0.14908025E-05_JPRB, 0.15077841E-05_JPRB, 0.15269799E-05_JPRB, 0.15448456E-05_JPRB, &
  & 0.15603755E-05_JPRB, 0.15741332E-05_JPRB, 0.15831004E-05_JPRB, 0.15895304E-05_JPRB, 0.15965239E-05_JPRB, 0.16052687E-05_JPRB, &
  & 0.16171765E-05_JPRB, 0.16306030E-05_JPRB, 0.16454403E-05_JPRB, 0.16611153E-05_JPRB, 0.16746228E-05_JPRB, 0.16853916E-05_JPRB, &
  & 0.16939011E-05_JPRB, 0.16991988E-05_JPRB, 0.17027701E-05_JPRB, 0.17061833E-05_JPRB, 0.17103148E-05_JPRB, 0.17119925E-05_JPRB, &
  & 0.17046549E-05_JPRB, 0.16831364E-05_JPRB, 0.16564344E-05_JPRB, 0.16356838E-05_JPRB, 0.16194040E-05_JPRB, 0.16031620E-05_JPRB, &
  & 0.15843165E-05_JPRB, 0.15634406E-05_JPRB, 0.15442508E-05_JPRB, 0.15242376E-05_JPRB, 0.15026725E-05_JPRB, 0.14766058E-05_JPRB, &
  & 0.14432695E-05_JPRB, 0.14076385E-05_JPRB, 0.13708153E-05_JPRB, 0.13345447E-05_JPRB, 0.12995027E-05_JPRB, 0.12655825E-05_JPRB, &
  & 0.12360855E-05_JPRB, 0.12116033E-05_JPRB, 0.11905751E-05_JPRB, 0.11694999E-05_JPRB, 0.11477078E-05_JPRB, 0.11269619E-05_JPRB, &
  & 0.11089711E-05_JPRB, 0.10963349E-05_JPRB, 0.10899179E-05_JPRB, 0.10862656E-05_JPRB, 0.10843756E-05_JPRB, 0.10821680E-05_JPRB, &
  & 0.10730065E-05_JPRB, 0.10600306E-05_JPRB, 0.10517602E-05_JPRB, 0.10495288E-05_JPRB  /)

RGHG2(:,34, 6) = (/ &
  & 0.14965163E-05_JPRB, 0.14951059E-05_JPRB, 0.14928989E-05_JPRB, 0.14944310E-05_JPRB, 0.15014077E-05_JPRB, 0.15061090E-05_JPRB, &
  & 0.15104609E-05_JPRB, 0.15186744E-05_JPRB, 0.15295652E-05_JPRB, 0.15439183E-05_JPRB, 0.15608902E-05_JPRB, 0.15774136E-05_JPRB, &
  & 0.15920012E-05_JPRB, 0.16046778E-05_JPRB, 0.16124512E-05_JPRB, 0.16181123E-05_JPRB, 0.16247542E-05_JPRB, 0.16329583E-05_JPRB, &
  & 0.16439421E-05_JPRB, 0.16562295E-05_JPRB, 0.16693999E-05_JPRB, 0.16827244E-05_JPRB, 0.16933512E-05_JPRB, 0.17011111E-05_JPRB, &
  & 0.17066876E-05_JPRB, 0.17097331E-05_JPRB, 0.17112000E-05_JPRB, 0.17124778E-05_JPRB, 0.17147186E-05_JPRB, 0.17155855E-05_JPRB, &
  & 0.17100194E-05_JPRB, 0.16936180E-05_JPRB, 0.16727547E-05_JPRB, 0.16563817E-05_JPRB, 0.16447812E-05_JPRB, 0.16349858E-05_JPRB, &
  & 0.16244420E-05_JPRB, 0.16120772E-05_JPRB, 0.16001916E-05_JPRB, 0.15863302E-05_JPRB, 0.15702066E-05_JPRB, 0.15486984E-05_JPRB, &
  & 0.15188192E-05_JPRB, 0.14846927E-05_JPRB, 0.14484586E-05_JPRB, 0.14118318E-05_JPRB, 0.13754274E-05_JPRB, 0.13400469E-05_JPRB, &
  & 0.13087811E-05_JPRB, 0.12827413E-05_JPRB, 0.12603102E-05_JPRB, 0.12382292E-05_JPRB, 0.12163975E-05_JPRB, 0.11959112E-05_JPRB, &
  & 0.11777241E-05_JPRB, 0.11640879E-05_JPRB, 0.11564771E-05_JPRB, 0.11514684E-05_JPRB, 0.11478523E-05_JPRB, 0.11448642E-05_JPRB, &
  & 0.11357860E-05_JPRB, 0.11224438E-05_JPRB, 0.11106719E-05_JPRB, 0.11060213E-05_JPRB  /)

RGHG2(:,35, 6) = (/ &
  & 0.15471937E-05_JPRB, 0.15462077E-05_JPRB, 0.15434815E-05_JPRB, 0.15438632E-05_JPRB, 0.15487851E-05_JPRB, 0.15510910E-05_JPRB, &
  & 0.15528744E-05_JPRB, 0.15581787E-05_JPRB, 0.15657807E-05_JPRB, 0.15770459E-05_JPRB, 0.15914549E-05_JPRB, 0.16063478E-05_JPRB, &
  & 0.16197516E-05_JPRB, 0.16312222E-05_JPRB, 0.16378844E-05_JPRB, 0.16430150E-05_JPRB, 0.16491768E-05_JPRB, 0.16566494E-05_JPRB, &
  & 0.16664159E-05_JPRB, 0.16772627E-05_JPRB, 0.16882219E-05_JPRB, 0.16984362E-05_JPRB, 0.17063214E-05_JPRB, 0.17116300E-05_JPRB, &
  & 0.17150232E-05_JPRB, 0.17167342E-05_JPRB, 0.17173970E-05_JPRB, 0.17176810E-05_JPRB, 0.17183416E-05_JPRB, 0.17179466E-05_JPRB, &
  & 0.17136256E-05_JPRB, 0.17026963E-05_JPRB, 0.16884051E-05_JPRB, 0.16763708E-05_JPRB, 0.16683047E-05_JPRB, 0.16630601E-05_JPRB, &
  & 0.16585523E-05_JPRB, 0.16524414E-05_JPRB, 0.16460056E-05_JPRB, 0.16373092E-05_JPRB, 0.16257866E-05_JPRB, 0.16085780E-05_JPRB, &
  & 0.15829647E-05_JPRB, 0.15514905E-05_JPRB, 0.15171772E-05_JPRB, 0.14816226E-05_JPRB, 0.14449277E-05_JPRB, 0.14093127E-05_JPRB, &
  & 0.13775779E-05_JPRB, 0.13510858E-05_JPRB, 0.13278171E-05_JPRB, 0.13054178E-05_JPRB, 0.12837537E-05_JPRB, 0.12638034E-05_JPRB, &
  & 0.12456163E-05_JPRB, 0.12309359E-05_JPRB, 0.12213988E-05_JPRB, 0.12147596E-05_JPRB, 0.12091222E-05_JPRB, 0.12051011E-05_JPRB, &
  & 0.11965030E-05_JPRB, 0.11839705E-05_JPRB, 0.11692784E-05_JPRB, 0.11623719E-05_JPRB  /)

RGHG2(:,36, 6) = (/ &
  & 0.15931638E-05_JPRB, 0.15923952E-05_JPRB, 0.15892629E-05_JPRB, 0.15887334E-05_JPRB, 0.15916871E-05_JPRB, 0.15919395E-05_JPRB, &
  & 0.15916750E-05_JPRB, 0.15944743E-05_JPRB, 0.15991222E-05_JPRB, 0.16074245E-05_JPRB, 0.16192726E-05_JPRB, 0.16324068E-05_JPRB, &
  & 0.16445158E-05_JPRB, 0.16547370E-05_JPRB, 0.16604144E-05_JPRB, 0.16649747E-05_JPRB, 0.16705283E-05_JPRB, 0.16771803E-05_JPRB, &
  & 0.16856536E-05_JPRB, 0.16949714E-05_JPRB, 0.17037342E-05_JPRB, 0.17110934E-05_JPRB, 0.17164800E-05_JPRB, 0.17196636E-05_JPRB, &
  & 0.17212736E-05_JPRB, 0.17219034E-05_JPRB, 0.17219261E-05_JPRB, 0.17214704E-05_JPRB, 0.17209792E-05_JPRB, 0.17197572E-05_JPRB, &
  & 0.17166079E-05_JPRB, 0.17102500E-05_JPRB, 0.17015238E-05_JPRB, 0.16932961E-05_JPRB, 0.16882396E-05_JPRB, 0.16865813E-05_JPRB, &
  & 0.16864739E-05_JPRB, 0.16849705E-05_JPRB, 0.16826410E-05_JPRB, 0.16780363E-05_JPRB, 0.16704787E-05_JPRB, 0.16573228E-05_JPRB, &
  & 0.16361899E-05_JPRB, 0.16083835E-05_JPRB, 0.15770307E-05_JPRB, 0.15434089E-05_JPRB, 0.15073409E-05_JPRB, 0.14720118E-05_JPRB, &
  & 0.14402337E-05_JPRB, 0.14137908E-05_JPRB, 0.13903274E-05_JPRB, 0.13682368E-05_JPRB, 0.13471430E-05_JPRB, 0.13279490E-05_JPRB, &
  & 0.13099901E-05_JPRB, 0.12945941E-05_JPRB, 0.12838478E-05_JPRB, 0.12758727E-05_JPRB, 0.12686699E-05_JPRB, 0.12638933E-05_JPRB, &
  & 0.12559432E-05_JPRB, 0.12444154E-05_JPRB, 0.12277495E-05_JPRB, 0.12193992E-05_JPRB  /)

RGHG2(:,37, 6) = (/ &
  & 0.16254811E-05_JPRB, 0.16244419E-05_JPRB, 0.16211884E-05_JPRB, 0.16203522E-05_JPRB, 0.16216591E-05_JPRB, 0.16207697E-05_JPRB, &
  & 0.16197784E-05_JPRB, 0.16211550E-05_JPRB, 0.16238004E-05_JPRB, 0.16296104E-05_JPRB, 0.16390616E-05_JPRB, 0.16502525E-05_JPRB, &
  & 0.16608924E-05_JPRB, 0.16698431E-05_JPRB, 0.16748864E-05_JPRB, 0.16788204E-05_JPRB, 0.16835107E-05_JPRB, 0.16891884E-05_JPRB, &
  & 0.16962751E-05_JPRB, 0.17039564E-05_JPRB, 0.17106934E-05_JPRB, 0.17159598E-05_JPRB, 0.17195603E-05_JPRB, 0.17214991E-05_JPRB, &
  & 0.17223539E-05_JPRB, 0.17225507E-05_JPRB, 0.17223493E-05_JPRB, 0.17217827E-05_JPRB, 0.17211935E-05_JPRB, 0.17201932E-05_JPRB, &
  & 0.17179744E-05_JPRB, 0.17138380E-05_JPRB, 0.17080216E-05_JPRB, 0.17021445E-05_JPRB, 0.16987065E-05_JPRB, 0.16982003E-05_JPRB, &
  & 0.16984691E-05_JPRB, 0.16975121E-05_JPRB, 0.16959533E-05_JPRB, 0.16927248E-05_JPRB, 0.16874275E-05_JPRB, 0.16775061E-05_JPRB, &
  & 0.16610665E-05_JPRB, 0.16390282E-05_JPRB, 0.16128351E-05_JPRB, 0.15829993E-05_JPRB, 0.15496221E-05_JPRB, 0.15157543E-05_JPRB, &
  & 0.14849117E-05_JPRB, 0.14596647E-05_JPRB, 0.14374925E-05_JPRB, 0.14171287E-05_JPRB, 0.13974937E-05_JPRB, 0.13795136E-05_JPRB, &
  & 0.13622918E-05_JPRB, 0.13469783E-05_JPRB, 0.13367423E-05_JPRB, 0.13281899E-05_JPRB, 0.13205644E-05_JPRB, 0.13157157E-05_JPRB, &
  & 0.13087578E-05_JPRB, 0.12986191E-05_JPRB, 0.12822729E-05_JPRB, 0.12744303E-05_JPRB  /)

RGHG2(:,38, 6) = (/ &
  & 0.16613400E-05_JPRB, 0.16600005E-05_JPRB, 0.16566126E-05_JPRB, 0.16554361E-05_JPRB, 0.16549156E-05_JPRB, 0.16527593E-05_JPRB, &
  & 0.16509616E-05_JPRB, 0.16507597E-05_JPRB, 0.16511830E-05_JPRB, 0.16542276E-05_JPRB, 0.16610192E-05_JPRB, 0.16700539E-05_JPRB, &
  & 0.16790637E-05_JPRB, 0.16866046E-05_JPRB, 0.16909444E-05_JPRB, 0.16941835E-05_JPRB, 0.16979157E-05_JPRB, 0.17025124E-05_JPRB, &
  & 0.17080607E-05_JPRB, 0.17139260E-05_JPRB, 0.17184152E-05_JPRB, 0.17213595E-05_JPRB, 0.17229782E-05_JPRB, 0.17235357E-05_JPRB, &
  & 0.17235526E-05_JPRB, 0.17232690E-05_JPRB, 0.17228188E-05_JPRB, 0.17221292E-05_JPRB, 0.17214314E-05_JPRB, 0.17206770E-05_JPRB, &
  & 0.17194905E-05_JPRB, 0.17178193E-05_JPRB, 0.17152315E-05_JPRB, 0.17119625E-05_JPRB, 0.17103205E-05_JPRB, 0.17110925E-05_JPRB, &
  & 0.17117789E-05_JPRB, 0.17114282E-05_JPRB, 0.17107244E-05_JPRB, 0.17090230E-05_JPRB, 0.17062337E-05_JPRB, 0.16999013E-05_JPRB, &
  & 0.16886693E-05_JPRB, 0.16730311E-05_JPRB, 0.16525632E-05_JPRB, 0.16269284E-05_JPRB, 0.15965367E-05_JPRB, 0.15642904E-05_JPRB, &
  & 0.15344860E-05_JPRB, 0.15105659E-05_JPRB, 0.14898265E-05_JPRB, 0.14713786E-05_JPRB, 0.14533623E-05_JPRB, 0.14367291E-05_JPRB, &
  & 0.14203252E-05_JPRB, 0.14051032E-05_JPRB, 0.13954334E-05_JPRB, 0.13862405E-05_JPRB, 0.13781459E-05_JPRB, 0.13732172E-05_JPRB, &
  & 0.13673603E-05_JPRB, 0.13587630E-05_JPRB, 0.13427714E-05_JPRB, 0.13354922E-05_JPRB  /)

RGHG2(:,39, 6) = (/ &
  & 0.16782493E-05_JPRB, 0.16770952E-05_JPRB, 0.16741558E-05_JPRB, 0.16728677E-05_JPRB, 0.16718397E-05_JPRB, 0.16695203E-05_JPRB, &
  & 0.16677000E-05_JPRB, 0.16670601E-05_JPRB, 0.16667776E-05_JPRB, 0.16684143E-05_JPRB, 0.16734304E-05_JPRB, 0.16808149E-05_JPRB, &
  & 0.16884076E-05_JPRB, 0.16948277E-05_JPRB, 0.16986351E-05_JPRB, 0.17014066E-05_JPRB, 0.17045198E-05_JPRB, 0.17083487E-05_JPRB, &
  & 0.17128509E-05_JPRB, 0.17174718E-05_JPRB, 0.17208324E-05_JPRB, 0.17227995E-05_JPRB, 0.17236100E-05_JPRB, 0.17235871E-05_JPRB, &
  & 0.17232053E-05_JPRB, 0.17226408E-05_JPRB, 0.17220038E-05_JPRB, 0.17212601E-05_JPRB, 0.17205983E-05_JPRB, 0.17200221E-05_JPRB, &
  & 0.17193096E-05_JPRB, 0.17184480E-05_JPRB, 0.17168127E-05_JPRB, 0.17145642E-05_JPRB, 0.17135203E-05_JPRB, 0.17143315E-05_JPRB, &
  & 0.17152192E-05_JPRB, 0.17154095E-05_JPRB, 0.17151044E-05_JPRB, 0.17139293E-05_JPRB, 0.17119920E-05_JPRB, 0.17070345E-05_JPRB, &
  & 0.16979864E-05_JPRB, 0.16854453E-05_JPRB, 0.16685740E-05_JPRB, 0.16467463E-05_JPRB, 0.16199286E-05_JPRB, 0.15906205E-05_JPRB, &
  & 0.15629197E-05_JPRB, 0.15404413E-05_JPRB, 0.15211792E-05_JPRB, 0.15041999E-05_JPRB, 0.14877844E-05_JPRB, 0.14725769E-05_JPRB, &
  & 0.14575977E-05_JPRB, 0.14434277E-05_JPRB, 0.14349893E-05_JPRB, 0.14263495E-05_JPRB, 0.14189113E-05_JPRB, 0.14147112E-05_JPRB, &
  & 0.14098118E-05_JPRB, 0.14021806E-05_JPRB, 0.13877606E-05_JPRB, 0.13818461E-05_JPRB  /)

RGHG2(:,40, 6) = (/ &
  & 0.16949936E-05_JPRB, 0.16941366E-05_JPRB, 0.16918187E-05_JPRB, 0.16904371E-05_JPRB, 0.16890296E-05_JPRB, 0.16866992E-05_JPRB, &
  & 0.16849806E-05_JPRB, 0.16840135E-05_JPRB, 0.16831506E-05_JPRB, 0.16833571E-05_JPRB, 0.16864341E-05_JPRB, 0.16919649E-05_JPRB, &
  & 0.16979293E-05_JPRB, 0.17030814E-05_JPRB, 0.17062920E-05_JPRB, 0.17085519E-05_JPRB, 0.17109939E-05_JPRB, 0.17139729E-05_JPRB, &
  & 0.17173283E-05_JPRB, 0.17205821E-05_JPRB, 0.17228013E-05_JPRB, 0.17238415E-05_JPRB, 0.17238957E-05_JPRB, 0.17233227E-05_JPRB, &
  & 0.17225449E-05_JPRB, 0.17216833E-05_JPRB, 0.17208372E-05_JPRB, 0.17200413E-05_JPRB, 0.17194455E-05_JPRB, 0.17190673E-05_JPRB, &
  & 0.17188196E-05_JPRB, 0.17186374E-05_JPRB, 0.17177475E-05_JPRB, 0.17164368E-05_JPRB, 0.17158991E-05_JPRB, 0.17165535E-05_JPRB, &
  & 0.17176419E-05_JPRB, 0.17184566E-05_JPRB, 0.17185449E-05_JPRB, 0.17178236E-05_JPRB, 0.17166151E-05_JPRB, 0.17129091E-05_JPRB, &
  & 0.17059293E-05_JPRB, 0.16964824E-05_JPRB, 0.16834838E-05_JPRB, 0.16660595E-05_JPRB, 0.16435325E-05_JPRB, 0.16178880E-05_JPRB, &
  & 0.15928304E-05_JPRB, 0.15720628E-05_JPRB, 0.15545417E-05_JPRB, 0.15392127E-05_JPRB, 0.15246730E-05_JPRB, 0.15111515E-05_JPRB, &
  & 0.14979436E-05_JPRB, 0.14851653E-05_JPRB, 0.14782809E-05_JPRB, 0.14704855E-05_JPRB, 0.14640017E-05_JPRB, 0.14607890E-05_JPRB, &
  & 0.14569898E-05_JPRB, 0.14503982E-05_JPRB, 0.14380219E-05_JPRB, 0.14338402E-05_JPRB  /)

RGHG2(:,41, 6) = (/ &
  & 0.17154660E-05_JPRB, 0.17149721E-05_JPRB, 0.17134143E-05_JPRB, 0.17119183E-05_JPRB, 0.17100468E-05_JPRB, 0.17077028E-05_JPRB, &
  & 0.17061087E-05_JPRB, 0.17047414E-05_JPRB, 0.17031690E-05_JPRB, 0.17016268E-05_JPRB, 0.17023331E-05_JPRB, 0.17055972E-05_JPRB, &
  & 0.17095709E-05_JPRB, 0.17131728E-05_JPRB, 0.17156536E-05_JPRB, 0.17172880E-05_JPRB, 0.17189095E-05_JPRB, 0.17208494E-05_JPRB, &
  & 0.17228024E-05_JPRB, 0.17243850E-05_JPRB, 0.17252086E-05_JPRB, 0.17251155E-05_JPRB, 0.17242449E-05_JPRB, 0.17229994E-05_JPRB, &
  & 0.17217373E-05_JPRB, 0.17205125E-05_JPRB, 0.17194109E-05_JPRB, 0.17185511E-05_JPRB, 0.17180360E-05_JPRB, 0.17179000E-05_JPRB, &
  & 0.17182206E-05_JPRB, 0.17188690E-05_JPRB, 0.17188904E-05_JPRB, 0.17187264E-05_JPRB, 0.17188074E-05_JPRB, 0.17192702E-05_JPRB, &
  & 0.17206041E-05_JPRB, 0.17221822E-05_JPRB, 0.17227513E-05_JPRB, 0.17225849E-05_JPRB, 0.17222675E-05_JPRB, 0.17200916E-05_JPRB, &
  & 0.17156407E-05_JPRB, 0.17099769E-05_JPRB, 0.17017131E-05_JPRB, 0.16896728E-05_JPRB, 0.16723918E-05_JPRB, 0.16512265E-05_JPRB, &
  & 0.16294006E-05_JPRB, 0.16107247E-05_JPRB, 0.15953322E-05_JPRB, 0.15820209E-05_JPRB, 0.15697747E-05_JPRB, 0.15583145E-05_JPRB, &
  & 0.15472723E-05_JPRB, 0.15361956E-05_JPRB, 0.15312112E-05_JPRB, 0.15244481E-05_JPRB, 0.15191313E-05_JPRB, 0.15171258E-05_JPRB, &
  & 0.15146717E-05_JPRB, 0.15093513E-05_JPRB, 0.14994735E-05_JPRB, 0.14974104E-05_JPRB  /)

RGHG2(:,42, 6) = (/ &
  & 0.17128364E-05_JPRB, 0.17127294E-05_JPRB, 0.17115458E-05_JPRB, 0.17103328E-05_JPRB, 0.17090909E-05_JPRB, 0.17073914E-05_JPRB, &
  & 0.17061294E-05_JPRB, 0.17052743E-05_JPRB, 0.17043109E-05_JPRB, 0.17034441E-05_JPRB, 0.17041210E-05_JPRB, 0.17068577E-05_JPRB, &
  & 0.17101902E-05_JPRB, 0.17132796E-05_JPRB, 0.17153300E-05_JPRB, 0.17167849E-05_JPRB, 0.17182643E-05_JPRB, 0.17200069E-05_JPRB, &
  & 0.17218357E-05_JPRB, 0.17234246E-05_JPRB, 0.17242754E-05_JPRB, 0.17241803E-05_JPRB, 0.17232603E-05_JPRB, 0.17219501E-05_JPRB, &
  & 0.17206636E-05_JPRB, 0.17195592E-05_JPRB, 0.17186653E-05_JPRB, 0.17179193E-05_JPRB, 0.17175770E-05_JPRB, 0.17176685E-05_JPRB, &
  & 0.17179175E-05_JPRB, 0.17180726E-05_JPRB, 0.17177043E-05_JPRB, 0.17169925E-05_JPRB, 0.17166036E-05_JPRB, 0.17170440E-05_JPRB, &
  & 0.17185130E-05_JPRB, 0.17204129E-05_JPRB, 0.17214788E-05_JPRB, 0.17218652E-05_JPRB, 0.17216930E-05_JPRB, 0.17195520E-05_JPRB, &
  & 0.17149632E-05_JPRB, 0.17091719E-05_JPRB, 0.17009118E-05_JPRB, 0.16892999E-05_JPRB, 0.16737248E-05_JPRB, 0.16553632E-05_JPRB, &
  & 0.16364092E-05_JPRB, 0.16196884E-05_JPRB, 0.16057011E-05_JPRB, 0.15932236E-05_JPRB, 0.15814576E-05_JPRB, 0.15700509E-05_JPRB, &
  & 0.15599727E-05_JPRB, 0.15502753E-05_JPRB, 0.15453785E-05_JPRB, 0.15390976E-05_JPRB, 0.15348994E-05_JPRB, 0.15337754E-05_JPRB, &
  & 0.15320287E-05_JPRB, 0.15276833E-05_JPRB, 0.15185562E-05_JPRB, 0.15139728E-05_JPRB  /)

RGHG2(:,43, 6) = (/ &
  & 0.17192434E-05_JPRB, 0.17196456E-05_JPRB, 0.17191304E-05_JPRB, 0.17181264E-05_JPRB, 0.17172593E-05_JPRB, 0.17161419E-05_JPRB, &
  & 0.17152366E-05_JPRB, 0.17146767E-05_JPRB, 0.17139637E-05_JPRB, 0.17129609E-05_JPRB, 0.17125913E-05_JPRB, 0.17138717E-05_JPRB, &
  & 0.17157629E-05_JPRB, 0.17177178E-05_JPRB, 0.17190617E-05_JPRB, 0.17200837E-05_JPRB, 0.17210804E-05_JPRB, 0.17221961E-05_JPRB, &
  & 0.17233085E-05_JPRB, 0.17241841E-05_JPRB, 0.17244594E-05_JPRB, 0.17238750E-05_JPRB, 0.17225122E-05_JPRB, 0.17208537E-05_JPRB, &
  & 0.17193367E-05_JPRB, 0.17181858E-05_JPRB, 0.17173715E-05_JPRB, 0.17167018E-05_JPRB, 0.17165519E-05_JPRB, 0.17169552E-05_JPRB, &
  & 0.17173834E-05_JPRB, 0.17174455E-05_JPRB, 0.17171137E-05_JPRB, 0.17163953E-05_JPRB, 0.17158439E-05_JPRB, 0.17161814E-05_JPRB, &
  & 0.17178794E-05_JPRB, 0.17204012E-05_JPRB, 0.17221272E-05_JPRB, 0.17232566E-05_JPRB, 0.17236003E-05_JPRB, 0.17221492E-05_JPRB, &
  & 0.17185224E-05_JPRB, 0.17142421E-05_JPRB, 0.17080220E-05_JPRB, 0.16991169E-05_JPRB, 0.16873549E-05_JPRB, 0.16734781E-05_JPRB, &
  & 0.16585345E-05_JPRB, 0.16444973E-05_JPRB, 0.16327076E-05_JPRB, 0.16218588E-05_JPRB, 0.16115176E-05_JPRB, 0.16010463E-05_JPRB, &
  & 0.15927793E-05_JPRB, 0.15850721E-05_JPRB, 0.15810726E-05_JPRB, 0.15756758E-05_JPRB, 0.15730001E-05_JPRB, 0.15731997E-05_JPRB, &
  & 0.15726770E-05_JPRB, 0.15697679E-05_JPRB, 0.15624006E-05_JPRB, 0.15564289E-05_JPRB  /)

RGHG2(:,44, 6) = (/ &
  & 0.17197596E-05_JPRB, 0.17198881E-05_JPRB, 0.17194859E-05_JPRB, 0.17187787E-05_JPRB, 0.17181243E-05_JPRB, 0.17172653E-05_JPRB, &
  & 0.17165818E-05_JPRB, 0.17161635E-05_JPRB, 0.17156856E-05_JPRB, 0.17150351E-05_JPRB, 0.17147830E-05_JPRB, 0.17156921E-05_JPRB, &
  & 0.17171346E-05_JPRB, 0.17186754E-05_JPRB, 0.17197376E-05_JPRB, 0.17205305E-05_JPRB, 0.17213222E-05_JPRB, 0.17222174E-05_JPRB, &
  & 0.17231306E-05_JPRB, 0.17238182E-05_JPRB, 0.17239116E-05_JPRB, 0.17231515E-05_JPRB, 0.17216307E-05_JPRB, 0.17199294E-05_JPRB, &
  & 0.17184323E-05_JPRB, 0.17174465E-05_JPRB, 0.17167763E-05_JPRB, 0.17162910E-05_JPRB, 0.17162741E-05_JPRB, 0.17166885E-05_JPRB, &
  & 0.17170139E-05_JPRB, 0.17169006E-05_JPRB, 0.17162890E-05_JPRB, 0.17154627E-05_JPRB, 0.17149165E-05_JPRB, 0.17153484E-05_JPRB, &
  & 0.17171680E-05_JPRB, 0.17198509E-05_JPRB, 0.17218465E-05_JPRB, 0.17233564E-05_JPRB, 0.17241315E-05_JPRB, 0.17232524E-05_JPRB, &
  & 0.17201532E-05_JPRB, 0.17165410E-05_JPRB, 0.17111433E-05_JPRB, 0.17034737E-05_JPRB, 0.16934545E-05_JPRB, 0.16817274E-05_JPRB, &
  & 0.16688863E-05_JPRB, 0.16567301E-05_JPRB, 0.16465595E-05_JPRB, 0.16368016E-05_JPRB, 0.16271481E-05_JPRB, 0.16172587E-05_JPRB, &
  & 0.16091880E-05_JPRB, 0.16025729E-05_JPRB, 0.15988397E-05_JPRB, 0.15940105E-05_JPRB, 0.15914387E-05_JPRB, 0.15917929E-05_JPRB, &
  & 0.15917059E-05_JPRB, 0.15889617E-05_JPRB, 0.15817406E-05_JPRB, 0.15750229E-05_JPRB  /)

RGHG2(:,45, 6) = (/ &
  & 0.17211566E-05_JPRB, 0.17210379E-05_JPRB, 0.17208488E-05_JPRB, 0.17205059E-05_JPRB, 0.17201410E-05_JPRB, 0.17196495E-05_JPRB, &
  & 0.17192637E-05_JPRB, 0.17190438E-05_JPRB, 0.17188652E-05_JPRB, 0.17185985E-05_JPRB, 0.17183481E-05_JPRB, 0.17186505E-05_JPRB, &
  & 0.17194002E-05_JPRB, 0.17203261E-05_JPRB, 0.17209785E-05_JPRB, 0.17214558E-05_JPRB, 0.17219531E-05_JPRB, 0.17225181E-05_JPRB, &
  & 0.17231142E-05_JPRB, 0.17234977E-05_JPRB, 0.17233113E-05_JPRB, 0.17222893E-05_JPRB, 0.17205327E-05_JPRB, 0.17187387E-05_JPRB, &
  & 0.17172350E-05_JPRB, 0.17164314E-05_JPRB, 0.17159353E-05_JPRB, 0.17156695E-05_JPRB, 0.17158282E-05_JPRB, 0.17162948E-05_JPRB, &
  & 0.17165258E-05_JPRB, 0.17162011E-05_JPRB, 0.17152756E-05_JPRB, 0.17143257E-05_JPRB, 0.17137648E-05_JPRB, 0.17142910E-05_JPRB, &
  & 0.17162782E-05_JPRB, 0.17192229E-05_JPRB, 0.17216089E-05_JPRB, 0.17236458E-05_JPRB, 0.17249771E-05_JPRB, 0.17248365E-05_JPRB, &
  & 0.17224594E-05_JPRB, 0.17197987E-05_JPRB, 0.17155948E-05_JPRB, 0.17096737E-05_JPRB, 0.17021203E-05_JPRB, 0.16934071E-05_JPRB, &
  & 0.16834659E-05_JPRB, 0.16737901E-05_JPRB, 0.16657405E-05_JPRB, 0.16574302E-05_JPRB, 0.16487395E-05_JPRB, 0.16396309E-05_JPRB, &
  & 0.16320123E-05_JPRB, 0.16268919E-05_JPRB, 0.16235751E-05_JPRB, 0.16195038E-05_JPRB, 0.16172428E-05_JPRB, 0.16179401E-05_JPRB, &
  & 0.16185037E-05_JPRB, 0.16161287E-05_JPRB, 0.16092964E-05_JPRB, 0.16015540E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART12',0,ZHOOK_HANDLE)



RGHG2(:,46, 6) = (/ &
  & 0.17210990E-05_JPRB, 0.17208891E-05_JPRB, 0.17207263E-05_JPRB, 0.17205119E-05_JPRB, 0.17202581E-05_JPRB, 0.17199395E-05_JPRB, &
  & 0.17196820E-05_JPRB, 0.17195741E-05_JPRB, 0.17195068E-05_JPRB, 0.17194237E-05_JPRB, 0.17193082E-05_JPRB, 0.17194712E-05_JPRB, &
  & 0.17199459E-05_JPRB, 0.17205756E-05_JPRB, 0.17210014E-05_JPRB, 0.17212832E-05_JPRB, 0.17215992E-05_JPRB, 0.17219529E-05_JPRB, &
  & 0.17223567E-05_JPRB, 0.17225843E-05_JPRB, 0.17222971E-05_JPRB, 0.17211996E-05_JPRB, 0.17194626E-05_JPRB, 0.17177447E-05_JPRB, &
  & 0.17164306E-05_JPRB, 0.17158221E-05_JPRB, 0.17154843E-05_JPRB, 0.17153253E-05_JPRB, 0.17155382E-05_JPRB, 0.17159351E-05_JPRB, &
  & 0.17160290E-05_JPRB, 0.17154977E-05_JPRB, 0.17144849E-05_JPRB, 0.17135199E-05_JPRB, 0.17129688E-05_JPRB, 0.17135717E-05_JPRB, &
  & 0.17156421E-05_JPRB, 0.17186985E-05_JPRB, 0.17213183E-05_JPRB, 0.17235757E-05_JPRB, 0.17252113E-05_JPRB, 0.17256128E-05_JPRB, &
  & 0.17238177E-05_JPRB, 0.17217705E-05_JPRB, 0.17186031E-05_JPRB, 0.17141964E-05_JPRB, 0.17085326E-05_JPRB, 0.17017920E-05_JPRB, &
  & 0.16938032E-05_JPRB, 0.16859973E-05_JPRB, 0.16794712E-05_JPRB, 0.16722890E-05_JPRB, 0.16642788E-05_JPRB, 0.16559138E-05_JPRB, &
  & 0.16485890E-05_JPRB, 0.16442790E-05_JPRB, 0.16410086E-05_JPRB, 0.16376135E-05_JPRB, 0.16354666E-05_JPRB, 0.16358751E-05_JPRB, &
  & 0.16364825E-05_JPRB, 0.16339839E-05_JPRB, 0.16271530E-05_JPRB, 0.16195318E-05_JPRB  /)

RGHG2(:,47, 6) = (/ &
  & 0.17207401E-05_JPRB, 0.17204543E-05_JPRB, 0.17202850E-05_JPRB, 0.17201742E-05_JPRB, 0.17200150E-05_JPRB, 0.17198603E-05_JPRB, &
  & 0.17197194E-05_JPRB, 0.17197256E-05_JPRB, 0.17197513E-05_JPRB, 0.17198435E-05_JPRB, 0.17199131E-05_JPRB, 0.17200059E-05_JPRB, &
  & 0.17202417E-05_JPRB, 0.17205877E-05_JPRB, 0.17207844E-05_JPRB, 0.17208607E-05_JPRB, 0.17209868E-05_JPRB, 0.17211162E-05_JPRB, &
  & 0.17213195E-05_JPRB, 0.17213937E-05_JPRB, 0.17210242E-05_JPRB, 0.17198753E-05_JPRB, 0.17182125E-05_JPRB, 0.17166177E-05_JPRB, &
  & 0.17155654E-05_JPRB, 0.17151885E-05_JPRB, 0.17150332E-05_JPRB, 0.17149770E-05_JPRB, 0.17152290E-05_JPRB, 0.17155200E-05_JPRB, &
  & 0.17154442E-05_JPRB, 0.17146716E-05_JPRB, 0.17136017E-05_JPRB, 0.17126408E-05_JPRB, 0.17121060E-05_JPRB, 0.17127953E-05_JPRB, &
  & 0.17149464E-05_JPRB, 0.17181040E-05_JPRB, 0.17209668E-05_JPRB, 0.17234214E-05_JPRB, 0.17253636E-05_JPRB, 0.17263620E-05_JPRB, &
  & 0.17252216E-05_JPRB, 0.17238267E-05_JPRB, 0.17218439E-05_JPRB, 0.17191674E-05_JPRB, 0.17156056E-05_JPRB, 0.17109710E-05_JPRB, &
  & 0.17050834E-05_JPRB, 0.16993492E-05_JPRB, 0.16944914E-05_JPRB, 0.16885689E-05_JPRB, 0.16813007E-05_JPRB, 0.16738008E-05_JPRB, &
  & 0.16667891E-05_JPRB, 0.16632928E-05_JPRB, 0.16600028E-05_JPRB, 0.16573847E-05_JPRB, 0.16553324E-05_JPRB, 0.16552753E-05_JPRB, &
  & 0.16558126E-05_JPRB, 0.16530702E-05_JPRB, 0.16461635E-05_JPRB, 0.16389142E-05_JPRB  /)

RGHG2(:,48, 6) = (/ &
  & 0.17198089E-05_JPRB, 0.17194735E-05_JPRB, 0.17192407E-05_JPRB, 0.17191680E-05_JPRB, 0.17190773E-05_JPRB, 0.17189901E-05_JPRB, &
  & 0.17188861E-05_JPRB, 0.17189119E-05_JPRB, 0.17189807E-05_JPRB, 0.17192225E-05_JPRB, 0.17194158E-05_JPRB, 0.17195025E-05_JPRB, &
  & 0.17196117E-05_JPRB, 0.17197594E-05_JPRB, 0.17197975E-05_JPRB, 0.17197642E-05_JPRB, 0.17197618E-05_JPRB, 0.17197352E-05_JPRB, &
  & 0.17198080E-05_JPRB, 0.17198270E-05_JPRB, 0.17195313E-05_JPRB, 0.17185290E-05_JPRB, 0.17170768E-05_JPRB, 0.17156775E-05_JPRB, &
  & 0.17148661E-05_JPRB, 0.17146527E-05_JPRB, 0.17146356E-05_JPRB, 0.17146711E-05_JPRB, 0.17149195E-05_JPRB, 0.17150693E-05_JPRB, &
  & 0.17148724E-05_JPRB, 0.17140217E-05_JPRB, 0.17129296E-05_JPRB, 0.17119849E-05_JPRB, 0.17114731E-05_JPRB, 0.17122129E-05_JPRB, &
  & 0.17144074E-05_JPRB, 0.17176300E-05_JPRB, 0.17206535E-05_JPRB, 0.17231809E-05_JPRB, 0.17252581E-05_JPRB, 0.17265828E-05_JPRB, &
  & 0.17259407E-05_JPRB, 0.17250253E-05_JPRB, 0.17240018E-05_JPRB, 0.17227251E-05_JPRB, 0.17208851E-05_JPRB, 0.17180704E-05_JPRB, &
  & 0.17139625E-05_JPRB, 0.17099997E-05_JPRB, 0.17064991E-05_JPRB, 0.17017644E-05_JPRB, 0.16954121E-05_JPRB, 0.16886241E-05_JPRB, &
  & 0.16821501E-05_JPRB, 0.16789811E-05_JPRB, 0.16757691E-05_JPRB, 0.16737128E-05_JPRB, 0.16718988E-05_JPRB, 0.16714629E-05_JPRB, &
  & 0.16715907E-05_JPRB, 0.16688802E-05_JPRB, 0.16623039E-05_JPRB, 0.16557684E-05_JPRB  /)

RGHG2(:,49, 6) = (/ &
  & 0.17185175E-05_JPRB, 0.17181390E-05_JPRB, 0.17178099E-05_JPRB, 0.17177499E-05_JPRB, 0.17177232E-05_JPRB, 0.17176669E-05_JPRB, &
  & 0.17175675E-05_JPRB, 0.17175720E-05_JPRB, 0.17176659E-05_JPRB, 0.17180616E-05_JPRB, 0.17183642E-05_JPRB, 0.17184730E-05_JPRB, &
  & 0.17184931E-05_JPRB, 0.17184600E-05_JPRB, 0.17183547E-05_JPRB, 0.17182435E-05_JPRB, 0.17181269E-05_JPRB, 0.17179585E-05_JPRB, &
  & 0.17179188E-05_JPRB, 0.17179209E-05_JPRB, 0.17177780E-05_JPRB, 0.17170279E-05_JPRB, 0.17158712E-05_JPRB, 0.17147213E-05_JPRB, &
  & 0.17141671E-05_JPRB, 0.17141040E-05_JPRB, 0.17142195E-05_JPRB, 0.17143517E-05_JPRB, 0.17145766E-05_JPRB, 0.17145540E-05_JPRB, &
  & 0.17142450E-05_JPRB, 0.17133822E-05_JPRB, 0.17122813E-05_JPRB, 0.17113600E-05_JPRB, 0.17108766E-05_JPRB, 0.17116563E-05_JPRB, &
  & 0.17138817E-05_JPRB, 0.17171599E-05_JPRB, 0.17203240E-05_JPRB, 0.17228752E-05_JPRB, 0.17250240E-05_JPRB, 0.17265872E-05_JPRB, &
  & 0.17264259E-05_JPRB, 0.17259627E-05_JPRB, 0.17258990E-05_JPRB, 0.17260223E-05_JPRB, 0.17259162E-05_JPRB, 0.17249868E-05_JPRB, &
  & 0.17227036E-05_JPRB, 0.17205659E-05_JPRB, 0.17184267E-05_JPRB, 0.17149749E-05_JPRB, 0.17097158E-05_JPRB, 0.17036466E-05_JPRB, &
  & 0.16978700E-05_JPRB, 0.16948426E-05_JPRB, 0.16917610E-05_JPRB, 0.16902290E-05_JPRB, 0.16887443E-05_JPRB, 0.16879285E-05_JPRB, &
  & 0.16874483E-05_JPRB, 0.16848985E-05_JPRB, 0.16788728E-05_JPRB, 0.16732833E-05_JPRB  /)

RGHG2(:,50, 6) = (/ &
  & 0.17168440E-05_JPRB, 0.17163924E-05_JPRB, 0.17159848E-05_JPRB, 0.17159220E-05_JPRB, 0.17159557E-05_JPRB, 0.17159504E-05_JPRB, &
  & 0.17158598E-05_JPRB, 0.17157959E-05_JPRB, 0.17158669E-05_JPRB, 0.17163552E-05_JPRB, 0.17167479E-05_JPRB, 0.17168944E-05_JPRB, &
  & 0.17168758E-05_JPRB, 0.17167426E-05_JPRB, 0.17165685E-05_JPRB, 0.17164401E-05_JPRB, 0.17162973E-05_JPRB, 0.17160727E-05_JPRB, &
  & 0.17160013E-05_JPRB, 0.17160720E-05_JPRB, 0.17161500E-05_JPRB, 0.17157259E-05_JPRB, 0.17148754E-05_JPRB, 0.17139707E-05_JPRB, &
  & 0.17135831E-05_JPRB, 0.17135966E-05_JPRB, 0.17138169E-05_JPRB, 0.17140179E-05_JPRB, 0.17142475E-05_JPRB, 0.17141162E-05_JPRB, &
  & 0.17137398E-05_JPRB, 0.17128995E-05_JPRB, 0.17117960E-05_JPRB, 0.17108997E-05_JPRB, 0.17104278E-05_JPRB, 0.17112346E-05_JPRB, &
  & 0.17134696E-05_JPRB, 0.17167832E-05_JPRB, 0.17199987E-05_JPRB, 0.17225090E-05_JPRB, 0.17247013E-05_JPRB, 0.17263567E-05_JPRB, &
  & 0.17265617E-05_JPRB, 0.17264868E-05_JPRB, 0.17271033E-05_JPRB, 0.17282622E-05_JPRB, 0.17293744E-05_JPRB, 0.17298198E-05_JPRB, &
  & 0.17288816E-05_JPRB, 0.17282085E-05_JPRB, 0.17274054E-05_JPRB, 0.17250992E-05_JPRB, 0.17210863E-05_JPRB, 0.17159647E-05_JPRB, &
  & 0.17107694E-05_JPRB, 0.17079035E-05_JPRB, 0.17050664E-05_JPRB, 0.17038742E-05_JPRB, 0.17028444E-05_JPRB, 0.17020050E-05_JPRB, &
  & 0.17013287E-05_JPRB, 0.16992418E-05_JPRB, 0.16940847E-05_JPRB, 0.16895287E-05_JPRB  /)

RGHG2(:,51, 6) = (/ &
  & 0.17148330E-05_JPRB, 0.17142865E-05_JPRB, 0.17138034E-05_JPRB, 0.17137297E-05_JPRB, 0.17138267E-05_JPRB, 0.17138870E-05_JPRB, &
  & 0.17138082E-05_JPRB, 0.17136455E-05_JPRB, 0.17136667E-05_JPRB, 0.17142227E-05_JPRB, 0.17147028E-05_JPRB, 0.17148983E-05_JPRB, &
  & 0.17148644E-05_JPRB, 0.17146651E-05_JPRB, 0.17144562E-05_JPRB, 0.17143408E-05_JPRB, 0.17142159E-05_JPRB, 0.17139756E-05_JPRB, &
  & 0.17139125E-05_JPRB, 0.17141021E-05_JPRB, 0.17144550E-05_JPRB, 0.17144220E-05_JPRB, 0.17139085E-05_JPRB, 0.17132670E-05_JPRB, &
  & 0.17130118E-05_JPRB, 0.17130694E-05_JPRB, 0.17133885E-05_JPRB, 0.17136494E-05_JPRB, 0.17138986E-05_JPRB, 0.17136835E-05_JPRB, &
  & 0.17132577E-05_JPRB, 0.17124597E-05_JPRB, 0.17113567E-05_JPRB, 0.17104884E-05_JPRB, 0.17100200E-05_JPRB, 0.17108495E-05_JPRB, &
  & 0.17130836E-05_JPRB, 0.17164247E-05_JPRB, 0.17196490E-05_JPRB, 0.17220811E-05_JPRB, 0.17243057E-05_JPRB, 0.17259838E-05_JPRB, &
  & 0.17265249E-05_JPRB, 0.17268364E-05_JPRB, 0.17280416E-05_JPRB, 0.17301293E-05_JPRB, 0.17322883E-05_JPRB, 0.17339522E-05_JPRB, &
  & 0.17342168E-05_JPRB, 0.17349384E-05_JPRB, 0.17355671E-05_JPRB, 0.17344279E-05_JPRB, 0.17318433E-05_JPRB, 0.17278668E-05_JPRB, &
  & 0.17232393E-05_JPRB, 0.17205587E-05_JPRB, 0.17180459E-05_JPRB, 0.17171242E-05_JPRB, 0.17166525E-05_JPRB, 0.17159749E-05_JPRB, &
  & 0.17153029E-05_JPRB, 0.17138755E-05_JPRB, 0.17098251E-05_JPRB, 0.17064330E-05_JPRB  /)

RGHG2(:,52, 6) = (/ &
  & 0.17127475E-05_JPRB, 0.17121613E-05_JPRB, 0.17116446E-05_JPRB, 0.17115649E-05_JPRB, 0.17117067E-05_JPRB, 0.17118282E-05_JPRB, &
  & 0.17117809E-05_JPRB, 0.17115427E-05_JPRB, 0.17115156E-05_JPRB, 0.17120711E-05_JPRB, 0.17125928E-05_JPRB, 0.17128201E-05_JPRB, &
  & 0.17128464E-05_JPRB, 0.17126756E-05_JPRB, 0.17125054E-05_JPRB, 0.17124388E-05_JPRB, 0.17123734E-05_JPRB, 0.17122019E-05_JPRB, &
  & 0.17121979E-05_JPRB, 0.17125274E-05_JPRB, 0.17130864E-05_JPRB, 0.17133489E-05_JPRB, 0.17131328E-05_JPRB, 0.17127242E-05_JPRB, &
  & 0.17125690E-05_JPRB, 0.17126550E-05_JPRB, 0.17130368E-05_JPRB, 0.17133422E-05_JPRB, 0.17136009E-05_JPRB, 0.17134358E-05_JPRB, &
  & 0.17129952E-05_JPRB, 0.17122506E-05_JPRB, 0.17111571E-05_JPRB, 0.17102257E-05_JPRB, 0.17097350E-05_JPRB, 0.17105708E-05_JPRB, &
  & 0.17127533E-05_JPRB, 0.17160507E-05_JPRB, 0.17191445E-05_JPRB, 0.17215605E-05_JPRB, 0.17238271E-05_JPRB, 0.17255518E-05_JPRB, &
  & 0.17262823E-05_JPRB, 0.17268822E-05_JPRB, 0.17285672E-05_JPRB, 0.17312995E-05_JPRB, 0.17340954E-05_JPRB, 0.17364629E-05_JPRB, &
  & 0.17375169E-05_JPRB, 0.17391978E-05_JPRB, 0.17407258E-05_JPRB, 0.17404185E-05_JPRB, 0.17388722E-05_JPRB, 0.17357626E-05_JPRB, &
  & 0.17318372E-05_JPRB, 0.17296440E-05_JPRB, 0.17275990E-05_JPRB, 0.17270752E-05_JPRB, 0.17271621E-05_JPRB, 0.17267156E-05_JPRB, &
  & 0.17263609E-05_JPRB, 0.17253529E-05_JPRB, 0.17221613E-05_JPRB, 0.17192417E-05_JPRB  /)

RGHG2(:,53, 6) = (/ &
  & 0.17104479E-05_JPRB, 0.17098395E-05_JPRB, 0.17093025E-05_JPRB, 0.17092182E-05_JPRB, 0.17094015E-05_JPRB, 0.17095880E-05_JPRB, &
  & 0.17095827E-05_JPRB, 0.17092711E-05_JPRB, 0.17091919E-05_JPRB, 0.17097207E-05_JPRB, 0.17102700E-05_JPRB, 0.17105255E-05_JPRB, &
  & 0.17106463E-05_JPRB, 0.17105429E-05_JPRB, 0.17104432E-05_JPRB, 0.17104435E-05_JPRB, 0.17104588E-05_JPRB, 0.17103948E-05_JPRB, &
  & 0.17104747E-05_JPRB, 0.17109647E-05_JPRB, 0.17117215E-05_JPRB, 0.17122691E-05_JPRB, 0.17123615E-05_JPRB, 0.17121950E-05_JPRB, &
  & 0.17121362E-05_JPRB, 0.17122472E-05_JPRB, 0.17126834E-05_JPRB, 0.17130312E-05_JPRB, 0.17132963E-05_JPRB, 0.17132373E-05_JPRB, &
  & 0.17127940E-05_JPRB, 0.17121116E-05_JPRB, 0.17110319E-05_JPRB, 0.17099968E-05_JPRB, 0.17094720E-05_JPRB, 0.17103082E-05_JPRB, &
  & 0.17124151E-05_JPRB, 0.17156372E-05_JPRB, 0.17185355E-05_JPRB, 0.17209580E-05_JPRB, 0.17232739E-05_JPRB, 0.17250586E-05_JPRB, &
  & 0.17259390E-05_JPRB, 0.17268151E-05_JPRB, 0.17289807E-05_JPRB, 0.17323056E-05_JPRB, 0.17356374E-05_JPRB, 0.17385732E-05_JPRB, &
  & 0.17403277E-05_JPRB, 0.17428858E-05_JPRB, 0.17451881E-05_JPRB, 0.17456579E-05_JPRB, 0.17450921E-05_JPRB, 0.17428196E-05_JPRB, &
  & 0.17397105E-05_JPRB, 0.17381644E-05_JPRB, 0.17366838E-05_JPRB, 0.17366425E-05_JPRB, 0.17373377E-05_JPRB, 0.17371698E-05_JPRB, &
  & 0.17372809E-05_JPRB, 0.17366372E-05_JPRB, 0.17342854E-05_JPRB, 0.17316144E-05_JPRB  /)

RGHG2(:,54, 6) = (/ &
  & 0.17085060E-05_JPRB, 0.17079304E-05_JPRB, 0.17074145E-05_JPRB, 0.17073388E-05_JPRB, 0.17075368E-05_JPRB, 0.17077495E-05_JPRB, &
  & 0.17077846E-05_JPRB, 0.17074649E-05_JPRB, 0.17073619E-05_JPRB, 0.17078555E-05_JPRB, 0.17083865E-05_JPRB, 0.17086469E-05_JPRB, &
  & 0.17088524E-05_JPRB, 0.17088552E-05_JPRB, 0.17088562E-05_JPRB, 0.17089256E-05_JPRB, 0.17090253E-05_JPRB, 0.17090844E-05_JPRB, &
  & 0.17092566E-05_JPRB, 0.17098568E-05_JPRB, 0.17107108E-05_JPRB, 0.17114308E-05_JPRB, 0.17117055E-05_JPRB, 0.17117598E-05_JPRB, &
  & 0.17117516E-05_JPRB, 0.17119066E-05_JPRB, 0.17123632E-05_JPRB, 0.17127759E-05_JPRB, 0.17130911E-05_JPRB, 0.17131002E-05_JPRB, &
  & 0.17127648E-05_JPRB, 0.17121305E-05_JPRB, 0.17110992E-05_JPRB, 0.17100120E-05_JPRB, 0.17093924E-05_JPRB, 0.17101532E-05_JPRB, &
  & 0.17120902E-05_JPRB, 0.17150501E-05_JPRB, 0.17177579E-05_JPRB, 0.17203157E-05_JPRB, 0.17227079E-05_JPRB, 0.17246004E-05_JPRB, &
  & 0.17254573E-05_JPRB, 0.17265589E-05_JPRB, 0.17291609E-05_JPRB, 0.17328299E-05_JPRB, 0.17364677E-05_JPRB, 0.17397457E-05_JPRB, &
  & 0.17418427E-05_JPRB, 0.17448263E-05_JPRB, 0.17474015E-05_JPRB, 0.17482918E-05_JPRB, 0.17481957E-05_JPRB, 0.17463607E-05_JPRB, &
  & 0.17439696E-05_JPRB, 0.17428456E-05_JPRB, 0.17418079E-05_JPRB, 0.17421475E-05_JPRB, 0.17432460E-05_JPRB, 0.17432499E-05_JPRB, &
  & 0.17437306E-05_JPRB, 0.17432820E-05_JPRB, 0.17414588E-05_JPRB, 0.17391099E-05_JPRB  /)

RGHG2(:,55, 6) = (/ &
  & 0.17064019E-05_JPRB, 0.17058698E-05_JPRB, 0.17053829E-05_JPRB, 0.17053184E-05_JPRB, 0.17055291E-05_JPRB, 0.17057658E-05_JPRB, &
  & 0.17058455E-05_JPRB, 0.17055252E-05_JPRB, 0.17053998E-05_JPRB, 0.17058532E-05_JPRB, 0.17063578E-05_JPRB, 0.17066206E-05_JPRB, &
  & 0.17069186E-05_JPRB, 0.17070443E-05_JPRB, 0.17071607E-05_JPRB, 0.17073070E-05_JPRB, 0.17075006E-05_JPRB, 0.17076981E-05_JPRB, &
  & 0.17079736E-05_JPRB, 0.17086893E-05_JPRB, 0.17096378E-05_JPRB, 0.17105339E-05_JPRB, 0.17109941E-05_JPRB, 0.17112901E-05_JPRB, &
  & 0.17113318E-05_JPRB, 0.17115382E-05_JPRB, 0.17120129E-05_JPRB, 0.17125005E-05_JPRB, 0.17128769E-05_JPRB, 0.17129564E-05_JPRB, &
  & 0.17127551E-05_JPRB, 0.17121721E-05_JPRB, 0.17111991E-05_JPRB, 0.17100610E-05_JPRB, 0.17093283E-05_JPRB, 0.17099957E-05_JPRB, &
  & 0.17117321E-05_JPRB, 0.17143768E-05_JPRB, 0.17168742E-05_JPRB, 0.17195989E-05_JPRB, 0.17220791E-05_JPRB, 0.17240974E-05_JPRB, &
  & 0.17249054E-05_JPRB, 0.17262502E-05_JPRB, 0.17293298E-05_JPRB, 0.17333471E-05_JPRB, 0.17372937E-05_JPRB, 0.17409211E-05_JPRB, &
  & 0.17433504E-05_JPRB, 0.17467460E-05_JPRB, 0.17495576E-05_JPRB, 0.17508668E-05_JPRB, 0.17512238E-05_JPRB, 0.17498208E-05_JPRB, &
  & 0.17482123E-05_JPRB, 0.17475262E-05_JPRB, 0.17469632E-05_JPRB, 0.17477113E-05_JPRB, 0.17492297E-05_JPRB, 0.17494097E-05_JPRB, &
  & 0.17502873E-05_JPRB, 0.17500325E-05_JPRB, 0.17487539E-05_JPRB, 0.17467715E-05_JPRB  /)

RGHG2(:,56, 6) = (/ &
  & 0.17049652E-05_JPRB, 0.17044800E-05_JPRB, 0.17040443E-05_JPRB, 0.17039925E-05_JPRB, 0.17042110E-05_JPRB, 0.17044468E-05_JPRB, &
  & 0.17045632E-05_JPRB, 0.17043099E-05_JPRB, 0.17042019E-05_JPRB, 0.17046196E-05_JPRB, 0.17050919E-05_JPRB, 0.17053503E-05_JPRB, &
  & 0.17056911E-05_JPRB, 0.17059012E-05_JPRB, 0.17061020E-05_JPRB, 0.17063138E-05_JPRB, 0.17065756E-05_JPRB, 0.17068572E-05_JPRB, &
  & 0.17071804E-05_JPRB, 0.17079365E-05_JPRB, 0.17089171E-05_JPRB, 0.17098962E-05_JPRB, 0.17104216E-05_JPRB, 0.17108175E-05_JPRB, &
  & 0.17109443E-05_JPRB, 0.17111976E-05_JPRB, 0.17116173E-05_JPRB, 0.17121284E-05_JPRB, 0.17126335E-05_JPRB, 0.17128229E-05_JPRB, &
  & 0.17127328E-05_JPRB, 0.17121288E-05_JPRB, 0.17112436E-05_JPRB, 0.17102168E-05_JPRB, 0.17094189E-05_JPRB, 0.17098843E-05_JPRB, &
  & 0.17113928E-05_JPRB, 0.17136026E-05_JPRB, 0.17160557E-05_JPRB, 0.17189048E-05_JPRB, 0.17214958E-05_JPRB, 0.17235751E-05_JPRB, &
  & 0.17242889E-05_JPRB, 0.17259063E-05_JPRB, 0.17293698E-05_JPRB, 0.17335077E-05_JPRB, 0.17377438E-05_JPRB, 0.17415250E-05_JPRB, &
  & 0.17440288E-05_JPRB, 0.17474989E-05_JPRB, 0.17502559E-05_JPRB, 0.17517682E-05_JPRB, 0.17521736E-05_JPRB, 0.17509900E-05_JPRB, &
  & 0.17497397E-05_JPRB, 0.17490752E-05_JPRB, 0.17486975E-05_JPRB, 0.17494834E-05_JPRB, 0.17511991E-05_JPRB, 0.17516042E-05_JPRB, &
  & 0.17525602E-05_JPRB, 0.17524379E-05_JPRB, 0.17511660E-05_JPRB, 0.17493913E-05_JPRB  /)

RGHG2(:,57, 6) = (/ &
  & 0.17035344E-05_JPRB, 0.17030927E-05_JPRB, 0.17027074E-05_JPRB, 0.17026718E-05_JPRB, 0.17028968E-05_JPRB, 0.17031327E-05_JPRB, &
  & 0.17032881E-05_JPRB, 0.17031015E-05_JPRB, 0.17030196E-05_JPRB, 0.17034008E-05_JPRB, 0.17038404E-05_JPRB, 0.17040982E-05_JPRB, &
  & 0.17044850E-05_JPRB, 0.17047753E-05_JPRB, 0.17050584E-05_JPRB, 0.17053330E-05_JPRB, 0.17056588E-05_JPRB, 0.17060168E-05_JPRB, &
  & 0.17063868E-05_JPRB, 0.17071731E-05_JPRB, 0.17081801E-05_JPRB, 0.17092463E-05_JPRB, 0.17098490E-05_JPRB, 0.17103221E-05_JPRB, &
  & 0.17105502E-05_JPRB, 0.17108239E-05_JPRB, 0.17111951E-05_JPRB, 0.17117236E-05_JPRB, 0.17123078E-05_JPRB, 0.17126057E-05_JPRB, &
  & 0.17126410E-05_JPRB, 0.17120544E-05_JPRB, 0.17112466E-05_JPRB, 0.17103341E-05_JPRB, 0.17094824E-05_JPRB, 0.17097500E-05_JPRB, &
  & 0.17110188E-05_JPRB, 0.17128218E-05_JPRB, 0.17152045E-05_JPRB, 0.17181101E-05_JPRB, 0.17208465E-05_JPRB, 0.17230153E-05_JPRB, &
  & 0.17236715E-05_JPRB, 0.17255967E-05_JPRB, 0.17294222E-05_JPRB, 0.17337083E-05_JPRB, 0.17382302E-05_JPRB, 0.17421422E-05_JPRB, &
  & 0.17447483E-05_JPRB, 0.17482676E-05_JPRB, 0.17509860E-05_JPRB, 0.17527162E-05_JPRB, 0.17531567E-05_JPRB, 0.17521858E-05_JPRB, &
  & 0.17512686E-05_JPRB, 0.17506278E-05_JPRB, 0.17504028E-05_JPRB, 0.17512342E-05_JPRB, 0.17531440E-05_JPRB, 0.17537909E-05_JPRB, &
  & 0.17548578E-05_JPRB, 0.17548519E-05_JPRB, 0.17535567E-05_JPRB, 0.17519856E-05_JPRB  /)

RGHG2(:,58, 6) = (/ &
  & 0.17023537E-05_JPRB, 0.17019470E-05_JPRB, 0.17016110E-05_JPRB, 0.17015962E-05_JPRB, 0.17018243E-05_JPRB, 0.17020571E-05_JPRB, &
  & 0.17022506E-05_JPRB, 0.17021376E-05_JPRB, 0.17021020E-05_JPRB, 0.17024491E-05_JPRB, 0.17028568E-05_JPRB, 0.17031191E-05_JPRB, &
  & 0.17035445E-05_JPRB, 0.17038942E-05_JPRB, 0.17042439E-05_JPRB, 0.17045693E-05_JPRB, 0.17049418E-05_JPRB, 0.17053471E-05_JPRB, &
  & 0.17057480E-05_JPRB, 0.17065308E-05_JPRB, 0.17075408E-05_JPRB, 0.17086766E-05_JPRB, 0.17093483E-05_JPRB, 0.17098276E-05_JPRB, &
  & 0.17101827E-05_JPRB, 0.17104294E-05_JPRB, 0.17107534E-05_JPRB, 0.17112778E-05_JPRB, 0.17118635E-05_JPRB, 0.17122666E-05_JPRB, &
  & 0.17124370E-05_JPRB, 0.17119174E-05_JPRB, 0.17111691E-05_JPRB, 0.17103967E-05_JPRB, 0.17095242E-05_JPRB, 0.17095968E-05_JPRB, &
  & 0.17106198E-05_JPRB, 0.17120738E-05_JPRB, 0.17143788E-05_JPRB, 0.17172138E-05_JPRB, 0.17201468E-05_JPRB, 0.17224334E-05_JPRB, &
  & 0.17230901E-05_JPRB, 0.17253633E-05_JPRB, 0.17294671E-05_JPRB, 0.17338933E-05_JPRB, 0.17386682E-05_JPRB, 0.17426249E-05_JPRB, &
  & 0.17453240E-05_JPRB, 0.17487823E-05_JPRB, 0.17514377E-05_JPRB, 0.17533528E-05_JPRB, 0.17537273E-05_JPRB, 0.17529012E-05_JPRB, &
  & 0.17521678E-05_JPRB, 0.17514742E-05_JPRB, 0.17512807E-05_JPRB, 0.17520974E-05_JPRB, 0.17541387E-05_JPRB, 0.17550451E-05_JPRB, &
  & 0.17562090E-05_JPRB, 0.17562718E-05_JPRB, 0.17548033E-05_JPRB, 0.17533831E-05_JPRB  /)

RGHG2(:,59, 6) = (/ &
  & 0.17014184E-05_JPRB, 0.17010381E-05_JPRB, 0.17007462E-05_JPRB, 0.17007489E-05_JPRB, 0.17009785E-05_JPRB, 0.17012083E-05_JPRB, &
  & 0.17014352E-05_JPRB, 0.17013862E-05_JPRB, 0.17013994E-05_JPRB, 0.17017251E-05_JPRB, 0.17021062E-05_JPRB, 0.17023775E-05_JPRB, &
  & 0.17028263E-05_JPRB, 0.17032208E-05_JPRB, 0.17036218E-05_JPRB, 0.17039837E-05_JPRB, 0.17043862E-05_JPRB, 0.17048145E-05_JPRB, &
  & 0.17052377E-05_JPRB, 0.17059983E-05_JPRB, 0.17069941E-05_JPRB, 0.17081748E-05_JPRB, 0.17089245E-05_JPRB, 0.17093941E-05_JPRB, &
  & 0.17098140E-05_JPRB, 0.17100094E-05_JPRB, 0.17102686E-05_JPRB, 0.17107581E-05_JPRB, 0.17113939E-05_JPRB, 0.17118329E-05_JPRB, &
  & 0.17122317E-05_JPRB, 0.17118345E-05_JPRB, 0.17111168E-05_JPRB, 0.17103185E-05_JPRB, 0.17093788E-05_JPRB, 0.17094162E-05_JPRB, &
  & 0.17102279E-05_JPRB, 0.17113728E-05_JPRB, 0.17135648E-05_JPRB, 0.17162766E-05_JPRB, 0.17193863E-05_JPRB, 0.17218656E-05_JPRB, &
  & 0.17227023E-05_JPRB, 0.17253024E-05_JPRB, 0.17295329E-05_JPRB, 0.17341533E-05_JPRB, 0.17390906E-05_JPRB, 0.17430469E-05_JPRB, &
  & 0.17458272E-05_JPRB, 0.17491709E-05_JPRB, 0.17518050E-05_JPRB, 0.17538452E-05_JPRB, 0.17541024E-05_JPRB, 0.17533287E-05_JPRB, &
  & 0.17526815E-05_JPRB, 0.17519304E-05_JPRB, 0.17516986E-05_JPRB, 0.17525599E-05_JPRB, 0.17547019E-05_JPRB, 0.17557376E-05_JPRB, &
  & 0.17569435E-05_JPRB, 0.17569420E-05_JPRB, 0.17554207E-05_JPRB, 0.17540331E-05_JPRB  /)

RGHG2(:,60, 6) = (/ &
  & 0.17005656E-05_JPRB, 0.17002109E-05_JPRB, 0.16999615E-05_JPRB, 0.16999811E-05_JPRB, 0.17002115E-05_JPRB, 0.17004374E-05_JPRB, &
  & 0.17006949E-05_JPRB, 0.17007075E-05_JPRB, 0.17007697E-05_JPRB, 0.17010806E-05_JPRB, 0.17014393E-05_JPRB, 0.17017211E-05_JPRB, &
  & 0.17021872E-05_JPRB, 0.17026208E-05_JPRB, 0.17030648E-05_JPRB, 0.17034591E-05_JPRB, 0.17038842E-05_JPRB, 0.17043282E-05_JPRB, &
  & 0.17047709E-05_JPRB, 0.17055006E-05_JPRB, 0.17064729E-05_JPRB, 0.17076838E-05_JPRB, 0.17085162E-05_JPRB, 0.17089810E-05_JPRB, &
  & 0.17094359E-05_JPRB, 0.17095871E-05_JPRB, 0.17097659E-05_JPRB, 0.17101973E-05_JPRB, 0.17108962E-05_JPRB, 0.17113694E-05_JPRB, &
  & 0.17120165E-05_JPRB, 0.17117531E-05_JPRB, 0.17110613E-05_JPRB, 0.17101481E-05_JPRB, 0.17091109E-05_JPRB, 0.17091802E-05_JPRB, &
  & 0.17098168E-05_JPRB, 0.17106707E-05_JPRB, 0.17127098E-05_JPRB, 0.17152998E-05_JPRB, 0.17185810E-05_JPRB, 0.17212984E-05_JPRB, &
  & 0.17224057E-05_JPRB, 0.17253155E-05_JPRB, 0.17296065E-05_JPRB, 0.17344577E-05_JPRB, 0.17395217E-05_JPRB, 0.17434667E-05_JPRB, &
  & 0.17463079E-05_JPRB, 0.17495194E-05_JPRB, 0.17521561E-05_JPRB, 0.17542918E-05_JPRB, 0.17544012E-05_JPRB, 0.17536361E-05_JPRB, &
  & 0.17530319E-05_JPRB, 0.17522135E-05_JPRB, 0.17519230E-05_JPRB, 0.17528590E-05_JPRB, 0.17550901E-05_JPRB, 0.17561936E-05_JPRB, &
  & 0.17574159E-05_JPRB, 0.17572870E-05_JPRB, 0.17557434E-05_JPRB, 0.17543242E-05_JPRB  /)

RGHG2(:,61, 6) = (/ &
  & 0.16998755E-05_JPRB, 0.16995494E-05_JPRB, 0.16993363E-05_JPRB, 0.16993713E-05_JPRB, 0.16996018E-05_JPRB, 0.16998210E-05_JPRB, &
  & 0.17000984E-05_JPRB, 0.17001650E-05_JPRB, 0.17002657E-05_JPRB, 0.17005755E-05_JPRB, 0.17009254E-05_JPRB, 0.17012172E-05_JPRB, &
  & 0.17016920E-05_JPRB, 0.17021531E-05_JPRB, 0.17026192E-05_JPRB, 0.17030421E-05_JPRB, 0.17034771E-05_JPRB, 0.17039355E-05_JPRB, &
  & 0.17043936E-05_JPRB, 0.17050847E-05_JPRB, 0.17060218E-05_JPRB, 0.17072294E-05_JPRB, 0.17081400E-05_JPRB, 0.17086400E-05_JPRB, &
  & 0.17090818E-05_JPRB, 0.17092561E-05_JPRB, 0.17093258E-05_JPRB, 0.17096526E-05_JPRB, 0.17103967E-05_JPRB, 0.17109789E-05_JPRB, &
  & 0.17117966E-05_JPRB, 0.17116225E-05_JPRB, 0.17109692E-05_JPRB, 0.17098072E-05_JPRB, 0.17086235E-05_JPRB, 0.17087908E-05_JPRB, &
  & 0.17093844E-05_JPRB, 0.17100169E-05_JPRB, 0.17118104E-05_JPRB, 0.17143707E-05_JPRB, 0.17177995E-05_JPRB, 0.17208065E-05_JPRB, &
  & 0.17222839E-05_JPRB, 0.17254096E-05_JPRB, 0.17296730E-05_JPRB, 0.17347996E-05_JPRB, 0.17399386E-05_JPRB, 0.17438868E-05_JPRB, &
  & 0.17467115E-05_JPRB, 0.17498085E-05_JPRB, 0.17524914E-05_JPRB, 0.17546624E-05_JPRB, 0.17545889E-05_JPRB, 0.17537687E-05_JPRB, &
  & 0.17531480E-05_JPRB, 0.17522393E-05_JPRB, 0.17519048E-05_JPRB, 0.17529509E-05_JPRB, 0.17552492E-05_JPRB, 0.17563229E-05_JPRB, &
  & 0.17575255E-05_JPRB, 0.17571994E-05_JPRB, 0.17556095E-05_JPRB, 0.17540515E-05_JPRB  /)

RGHG2(:,62, 6) = (/ &
  & 0.16992610E-05_JPRB, 0.16989710E-05_JPRB, 0.16987873E-05_JPRB, 0.16988406E-05_JPRB, 0.16990727E-05_JPRB, 0.16992835E-05_JPRB, &
  & 0.16995658E-05_JPRB, 0.16996840E-05_JPRB, 0.16998147E-05_JPRB, 0.17001283E-05_JPRB, 0.17004789E-05_JPRB, 0.17007833E-05_JPRB, &
  & 0.17012615E-05_JPRB, 0.17017389E-05_JPRB, 0.17022236E-05_JPRB, 0.17026736E-05_JPRB, 0.17031172E-05_JPRB, 0.17035961E-05_JPRB, &
  & 0.17040636E-05_JPRB, 0.17047133E-05_JPRB, 0.17056083E-05_JPRB, 0.17067693E-05_JPRB, 0.17077344E-05_JPRB, 0.17082872E-05_JPRB, &
  & 0.17087283E-05_JPRB, 0.17089330E-05_JPRB, 0.17089252E-05_JPRB, 0.17091555E-05_JPRB, 0.17098907E-05_JPRB, 0.17106230E-05_JPRB, &
  & 0.17115044E-05_JPRB, 0.17114476E-05_JPRB, 0.17107558E-05_JPRB, 0.17093189E-05_JPRB, 0.17079295E-05_JPRB, 0.17082314E-05_JPRB, &
  & 0.17088206E-05_JPRB, 0.17093201E-05_JPRB, 0.17109139E-05_JPRB, 0.17135242E-05_JPRB, 0.17171330E-05_JPRB, 0.17204309E-05_JPRB, &
  & 0.17222844E-05_JPRB, 0.17255065E-05_JPRB, 0.17297399E-05_JPRB, 0.17351580E-05_JPRB, 0.17403595E-05_JPRB, 0.17442916E-05_JPRB, &
  & 0.17470773E-05_JPRB, 0.17501098E-05_JPRB, 0.17528348E-05_JPRB, 0.17549752E-05_JPRB, 0.17546895E-05_JPRB, 0.17538377E-05_JPRB, &
  & 0.17531420E-05_JPRB, 0.17521524E-05_JPRB, 0.17517268E-05_JPRB, 0.17529004E-05_JPRB, 0.17552737E-05_JPRB, 0.17563290E-05_JPRB, &
  & 0.17574777E-05_JPRB, 0.17569783E-05_JPRB, 0.17552257E-05_JPRB, 0.17534617E-05_JPRB  /)

RGHG2(:,63, 6) = (/ &
  & 0.16986939E-05_JPRB, 0.16984434E-05_JPRB, 0.16982833E-05_JPRB, 0.16983581E-05_JPRB, 0.16985929E-05_JPRB, 0.16987935E-05_JPRB, &
  & 0.16990709E-05_JPRB, 0.16992361E-05_JPRB, 0.16993914E-05_JPRB, 0.16997137E-05_JPRB, 0.17000676E-05_JPRB, 0.17003866E-05_JPRB, &
  & 0.17008660E-05_JPRB, 0.17013519E-05_JPRB, 0.17018494E-05_JPRB, 0.17023291E-05_JPRB, 0.17027848E-05_JPRB, 0.17032838E-05_JPRB, &
  & 0.17037600E-05_JPRB, 0.17043651E-05_JPRB, 0.17052099E-05_JPRB, 0.17062943E-05_JPRB, 0.17072909E-05_JPRB, 0.17078973E-05_JPRB, &
  & 0.17083442E-05_JPRB, 0.17085786E-05_JPRB, 0.17085333E-05_JPRB, 0.17086980E-05_JPRB, 0.17093868E-05_JPRB, 0.17102705E-05_JPRB, &
  & 0.17111793E-05_JPRB, 0.17112176E-05_JPRB, 0.17104113E-05_JPRB, 0.17086917E-05_JPRB, 0.17070896E-05_JPRB, 0.17074950E-05_JPRB, &
  & 0.17081174E-05_JPRB, 0.17085767E-05_JPRB, 0.17100251E-05_JPRB, 0.17127207E-05_JPRB, 0.17165169E-05_JPRB, 0.17201149E-05_JPRB, &
  & 0.17223416E-05_JPRB, 0.17255991E-05_JPRB, 0.17298432E-05_JPRB, 0.17355312E-05_JPRB, 0.17407900E-05_JPRB, 0.17446802E-05_JPRB, &
  & 0.17474373E-05_JPRB, 0.17504456E-05_JPRB, 0.17531889E-05_JPRB, 0.17552361E-05_JPRB, 0.17547486E-05_JPRB, 0.17538678E-05_JPRB, &
  & 0.17530790E-05_JPRB, 0.17519957E-05_JPRB, 0.17514414E-05_JPRB, 0.17527552E-05_JPRB, 0.17552125E-05_JPRB, 0.17562732E-05_JPRB, &
  & 0.17573205E-05_JPRB, 0.17566819E-05_JPRB, 0.17546789E-05_JPRB, 0.17526796E-05_JPRB  /)

RGHG2(:,64, 6) = (/ &
  & 0.16981899E-05_JPRB, 0.16979778E-05_JPRB, 0.16978334E-05_JPRB, 0.16979335E-05_JPRB, 0.16981720E-05_JPRB, 0.16983605E-05_JPRB, &
  & 0.16986234E-05_JPRB, 0.16988247E-05_JPRB, 0.16989994E-05_JPRB, 0.16993373E-05_JPRB, 0.16996912E-05_JPRB, 0.17000259E-05_JPRB, &
  & 0.17005065E-05_JPRB, 0.17009936E-05_JPRB, 0.17014923E-05_JPRB, 0.17020081E-05_JPRB, 0.17024855E-05_JPRB, 0.17029965E-05_JPRB, &
  & 0.17034861E-05_JPRB, 0.17040429E-05_JPRB, 0.17048263E-05_JPRB, 0.17058071E-05_JPRB, 0.17068000E-05_JPRB, 0.17074426E-05_JPRB, &
  & 0.17078979E-05_JPRB, 0.17081516E-05_JPRB, 0.17081377E-05_JPRB, 0.17083084E-05_JPRB, 0.17089140E-05_JPRB, 0.17099050E-05_JPRB, &
  & 0.17108596E-05_JPRB, 0.17109051E-05_JPRB, 0.17098784E-05_JPRB, 0.17078937E-05_JPRB, 0.17061314E-05_JPRB, 0.17065211E-05_JPRB, &
  & 0.17072290E-05_JPRB, 0.17077907E-05_JPRB, 0.17091873E-05_JPRB, 0.17119709E-05_JPRB, 0.17159321E-05_JPRB, 0.17198409E-05_JPRB, &
  & 0.17224121E-05_JPRB, 0.17256745E-05_JPRB, 0.17300330E-05_JPRB, 0.17359102E-05_JPRB, 0.17412232E-05_JPRB, 0.17450290E-05_JPRB, &
  & 0.17478078E-05_JPRB, 0.17508414E-05_JPRB, 0.17535473E-05_JPRB, 0.17554163E-05_JPRB, 0.17547914E-05_JPRB, 0.17538648E-05_JPRB, &
  & 0.17530014E-05_JPRB, 0.17517867E-05_JPRB, 0.17510638E-05_JPRB, 0.17525258E-05_JPRB, 0.17550783E-05_JPRB, 0.17561920E-05_JPRB, &
  & 0.17570586E-05_JPRB, 0.17563465E-05_JPRB, 0.17540038E-05_JPRB, 0.17517744E-05_JPRB  /)

RGHG2(:,65, 6) = (/ &
  & 0.16977589E-05_JPRB, 0.16975734E-05_JPRB, 0.16974380E-05_JPRB, 0.16975625E-05_JPRB, 0.16978045E-05_JPRB, 0.16979832E-05_JPRB, &
  & 0.16982248E-05_JPRB, 0.16984424E-05_JPRB, 0.16986309E-05_JPRB, 0.16989902E-05_JPRB, 0.16993396E-05_JPRB, 0.16996810E-05_JPRB, &
  & 0.17001707E-05_JPRB, 0.17006568E-05_JPRB, 0.17011568E-05_JPRB, 0.17017067E-05_JPRB, 0.17022059E-05_JPRB, 0.17027190E-05_JPRB, &
  & 0.17032118E-05_JPRB, 0.17037279E-05_JPRB, 0.17044539E-05_JPRB, 0.17053326E-05_JPRB, 0.17062781E-05_JPRB, 0.17069279E-05_JPRB, &
  & 0.17073862E-05_JPRB, 0.17076424E-05_JPRB, 0.17076926E-05_JPRB, 0.17079120E-05_JPRB, 0.17084417E-05_JPRB, 0.17095138E-05_JPRB, &
  & 0.17104797E-05_JPRB, 0.17105101E-05_JPRB, 0.17092579E-05_JPRB, 0.17070443E-05_JPRB, 0.17052596E-05_JPRB, 0.17054777E-05_JPRB, &
  & 0.17062269E-05_JPRB, 0.17069075E-05_JPRB, 0.17082901E-05_JPRB, 0.17110781E-05_JPRB, 0.17152628E-05_JPRB, 0.17195375E-05_JPRB, &
  & 0.17223729E-05_JPRB, 0.17256816E-05_JPRB, 0.17303416E-05_JPRB, 0.17363297E-05_JPRB, 0.17416525E-05_JPRB, 0.17452635E-05_JPRB, &
  & 0.17481908E-05_JPRB, 0.17512645E-05_JPRB, 0.17539328E-05_JPRB, 0.17555739E-05_JPRB, 0.17548700E-05_JPRB, 0.17538525E-05_JPRB, &
  & 0.17529811E-05_JPRB, 0.17516117E-05_JPRB, 0.17507155E-05_JPRB, 0.17522841E-05_JPRB, 0.17549673E-05_JPRB, 0.17560368E-05_JPRB, &
  & 0.17566328E-05_JPRB, 0.17558691E-05_JPRB, 0.17533623E-05_JPRB, 0.17509773E-05_JPRB  /)

RGHG2(:,66, 6) = (/ &
  & 0.16973731E-05_JPRB, 0.16972035E-05_JPRB, 0.16970725E-05_JPRB, 0.16972216E-05_JPRB, 0.16974639E-05_JPRB, 0.16976327E-05_JPRB, &
  & 0.16978500E-05_JPRB, 0.16980746E-05_JPRB, 0.16982738E-05_JPRB, 0.16986524E-05_JPRB, 0.16989969E-05_JPRB, 0.16993410E-05_JPRB, &
  & 0.16998391E-05_JPRB, 0.17003247E-05_JPRB, 0.17008280E-05_JPRB, 0.17014053E-05_JPRB, 0.17019232E-05_JPRB, 0.17024347E-05_JPRB, &
  & 0.17029271E-05_JPRB, 0.17034089E-05_JPRB, 0.17040827E-05_JPRB, 0.17048685E-05_JPRB, 0.17057617E-05_JPRB, 0.17063888E-05_JPRB, &
  & 0.17068347E-05_JPRB, 0.17070816E-05_JPRB, 0.17071924E-05_JPRB, 0.17074853E-05_JPRB, 0.17079485E-05_JPRB, 0.17090865E-05_JPRB, &
  & 0.17100561E-05_JPRB, 0.17100919E-05_JPRB, 0.17086403E-05_JPRB, 0.17062613E-05_JPRB, 0.17044832E-05_JPRB, 0.17044639E-05_JPRB, &
  & 0.17051602E-05_JPRB, 0.17059535E-05_JPRB, 0.17073024E-05_JPRB, 0.17101268E-05_JPRB, 0.17144752E-05_JPRB, 0.17192010E-05_JPRB, &
  & 0.17223002E-05_JPRB, 0.17256757E-05_JPRB, 0.17307015E-05_JPRB, 0.17368358E-05_JPRB, 0.17421231E-05_JPRB, 0.17455025E-05_JPRB, &
  & 0.17486109E-05_JPRB, 0.17517342E-05_JPRB, 0.17543671E-05_JPRB, 0.17557900E-05_JPRB, 0.17549878E-05_JPRB, 0.17538134E-05_JPRB, &
  & 0.17529734E-05_JPRB, 0.17514855E-05_JPRB, 0.17504323E-05_JPRB, 0.17520434E-05_JPRB, 0.17547999E-05_JPRB, 0.17557487E-05_JPRB, &
  & 0.17560987E-05_JPRB, 0.17552760E-05_JPRB, 0.17527887E-05_JPRB, 0.17502106E-05_JPRB  /)

RGHG2(:,67, 6) = (/ &
  & 0.16970339E-05_JPRB, 0.16968686E-05_JPRB, 0.16967382E-05_JPRB, 0.16969118E-05_JPRB, 0.16971521E-05_JPRB, 0.16973093E-05_JPRB, &
  & 0.16974994E-05_JPRB, 0.16977228E-05_JPRB, 0.16979292E-05_JPRB, 0.16983237E-05_JPRB, 0.16986656E-05_JPRB, 0.16990106E-05_JPRB, &
  & 0.16995119E-05_JPRB, 0.16999984E-05_JPRB, 0.17005066E-05_JPRB, 0.17011036E-05_JPRB, 0.17016367E-05_JPRB, 0.17021417E-05_JPRB, &
  & 0.17026329E-05_JPRB, 0.17030886E-05_JPRB, 0.17037197E-05_JPRB, 0.17044252E-05_JPRB, 0.17052580E-05_JPRB, 0.17058433E-05_JPRB, &
  & 0.17062627E-05_JPRB, 0.17064809E-05_JPRB, 0.17066483E-05_JPRB, 0.17070085E-05_JPRB, 0.17074234E-05_JPRB, 0.17086115E-05_JPRB, &
  & 0.17096022E-05_JPRB, 0.17096633E-05_JPRB, 0.17080080E-05_JPRB, 0.17055319E-05_JPRB, 0.17037858E-05_JPRB, 0.17035015E-05_JPRB, &
  & 0.17040687E-05_JPRB, 0.17049497E-05_JPRB, 0.17062693E-05_JPRB, 0.17091465E-05_JPRB, 0.17135861E-05_JPRB, 0.17188391E-05_JPRB, &
  & 0.17222227E-05_JPRB, 0.17257225E-05_JPRB, 0.17310984E-05_JPRB, 0.17374405E-05_JPRB, 0.17426609E-05_JPRB, 0.17457869E-05_JPRB, &
  & 0.17490927E-05_JPRB, 0.17522670E-05_JPRB, 0.17548668E-05_JPRB, 0.17560820E-05_JPRB, 0.17551491E-05_JPRB, 0.17537851E-05_JPRB, &
  & 0.17529836E-05_JPRB, 0.17514077E-05_JPRB, 0.17502240E-05_JPRB, 0.17518195E-05_JPRB, 0.17545566E-05_JPRB, 0.17553312E-05_JPRB, &
  & 0.17555116E-05_JPRB, 0.17546304E-05_JPRB, 0.17522970E-05_JPRB, 0.17495082E-05_JPRB  /)

RGHG2(:,68, 6) = (/ &
  & 0.16967432E-05_JPRB, 0.16965679E-05_JPRB, 0.16964363E-05_JPRB, 0.16966334E-05_JPRB, 0.16968737E-05_JPRB, 0.16970136E-05_JPRB, &
  & 0.16971727E-05_JPRB, 0.16973875E-05_JPRB, 0.16975964E-05_JPRB, 0.16980020E-05_JPRB, 0.16983489E-05_JPRB, 0.16986975E-05_JPRB, &
  & 0.16991890E-05_JPRB, 0.16996792E-05_JPRB, 0.17001924E-05_JPRB, 0.17008005E-05_JPRB, 0.17013459E-05_JPRB, 0.17018361E-05_JPRB, &
  & 0.17023298E-05_JPRB, 0.17027706E-05_JPRB, 0.17033770E-05_JPRB, 0.17040182E-05_JPRB, 0.17047681E-05_JPRB, 0.17053163E-05_JPRB, &
  & 0.17056998E-05_JPRB, 0.17058537E-05_JPRB, 0.17060805E-05_JPRB, 0.17064395E-05_JPRB, 0.17068407E-05_JPRB, 0.17080609E-05_JPRB, &
  & 0.17091395E-05_JPRB, 0.17092352E-05_JPRB, 0.17072967E-05_JPRB, 0.17047921E-05_JPRB, 0.17031166E-05_JPRB, 0.17026022E-05_JPRB, &
  & 0.17030160E-05_JPRB, 0.17039254E-05_JPRB, 0.17052833E-05_JPRB, 0.17081729E-05_JPRB, 0.17126323E-05_JPRB, 0.17184654E-05_JPRB, &
  & 0.17221868E-05_JPRB, 0.17259525E-05_JPRB, 0.17315177E-05_JPRB, 0.17381640E-05_JPRB, 0.17433177E-05_JPRB, 0.17461839E-05_JPRB, &
  & 0.17496889E-05_JPRB, 0.17528990E-05_JPRB, 0.17554667E-05_JPRB, 0.17564716E-05_JPRB, 0.17553630E-05_JPRB, 0.17538518E-05_JPRB, &
  & 0.17530305E-05_JPRB, 0.17513705E-05_JPRB, 0.17500977E-05_JPRB, 0.17516400E-05_JPRB, 0.17542114E-05_JPRB, 0.17548054E-05_JPRB, &
  & 0.17549759E-05_JPRB, 0.17540589E-05_JPRB, 0.17518999E-05_JPRB, 0.17489466E-05_JPRB  /)

RGHG2(:,69, 6) = (/ &
  & 0.16964842E-05_JPRB, 0.16962923E-05_JPRB, 0.16961606E-05_JPRB, 0.16963745E-05_JPRB, 0.16966204E-05_JPRB, 0.16967418E-05_JPRB, &
  & 0.16968735E-05_JPRB, 0.16970739E-05_JPRB, 0.16972774E-05_JPRB, 0.16976930E-05_JPRB, 0.16980460E-05_JPRB, 0.16984017E-05_JPRB, &
  & 0.16988653E-05_JPRB, 0.16993592E-05_JPRB, 0.16998773E-05_JPRB, 0.17004909E-05_JPRB, 0.17010386E-05_JPRB, 0.17015174E-05_JPRB, &
  & 0.17020180E-05_JPRB, 0.17024597E-05_JPRB, 0.17030448E-05_JPRB, 0.17036329E-05_JPRB, 0.17042875E-05_JPRB, 0.17047806E-05_JPRB, &
  & 0.17051237E-05_JPRB, 0.17052133E-05_JPRB, 0.17054781E-05_JPRB, 0.17058066E-05_JPRB, 0.17061807E-05_JPRB, 0.17075018E-05_JPRB, &
  & 0.17086637E-05_JPRB, 0.17086972E-05_JPRB, 0.17064901E-05_JPRB, 0.17040516E-05_JPRB, 0.17025141E-05_JPRB, 0.17019543E-05_JPRB, &
  & 0.17020999E-05_JPRB, 0.17028700E-05_JPRB, 0.17044195E-05_JPRB, 0.17072313E-05_JPRB, 0.17118467E-05_JPRB, 0.17182801E-05_JPRB, &
  & 0.17222851E-05_JPRB, 0.17262874E-05_JPRB, 0.17320351E-05_JPRB, 0.17389519E-05_JPRB, 0.17441367E-05_JPRB, 0.17467556E-05_JPRB, &
  & 0.17504473E-05_JPRB, 0.17536393E-05_JPRB, 0.17561748E-05_JPRB, 0.17569931E-05_JPRB, 0.17556244E-05_JPRB, 0.17540663E-05_JPRB, &
  & 0.17530676E-05_JPRB, 0.17513707E-05_JPRB, 0.17500089E-05_JPRB, 0.17515735E-05_JPRB, 0.17538170E-05_JPRB, 0.17542643E-05_JPRB, &
  & 0.17546331E-05_JPRB, 0.17537275E-05_JPRB, 0.17515808E-05_JPRB, 0.17486532E-05_JPRB  /)

RGHG2(:,70, 6) = (/ &
  & 0.16962393E-05_JPRB, 0.16960344E-05_JPRB, 0.16959034E-05_JPRB, 0.16961269E-05_JPRB, 0.16963812E-05_JPRB, 0.16964876E-05_JPRB, &
  & 0.16965905E-05_JPRB, 0.16967776E-05_JPRB, 0.16969741E-05_JPRB, 0.16973982E-05_JPRB, 0.16977523E-05_JPRB, 0.16981134E-05_JPRB, &
  & 0.16985486E-05_JPRB, 0.16990434E-05_JPRB, 0.16995600E-05_JPRB, 0.17001742E-05_JPRB, 0.17007202E-05_JPRB, 0.17011958E-05_JPRB, &
  & 0.17017096E-05_JPRB, 0.17021596E-05_JPRB, 0.17027113E-05_JPRB, 0.17032467E-05_JPRB, 0.17038262E-05_JPRB, 0.17042443E-05_JPRB, &
  & 0.17045300E-05_JPRB, 0.17045408E-05_JPRB, 0.17048149E-05_JPRB, 0.17051222E-05_JPRB, 0.17054893E-05_JPRB, 0.17069815E-05_JPRB, &
  & 0.17082329E-05_JPRB, 0.17082182E-05_JPRB, 0.17058499E-05_JPRB, 0.17034129E-05_JPRB, 0.17020276E-05_JPRB, 0.17014966E-05_JPRB, &
  & 0.17013938E-05_JPRB, 0.17019194E-05_JPRB, 0.17035780E-05_JPRB, 0.17063491E-05_JPRB, 0.17112558E-05_JPRB, 0.17182129E-05_JPRB, &
  & 0.17224097E-05_JPRB, 0.17266771E-05_JPRB, 0.17326645E-05_JPRB, 0.17398475E-05_JPRB, 0.17451048E-05_JPRB, 0.17474692E-05_JPRB, &
  & 0.17512807E-05_JPRB, 0.17544419E-05_JPRB, 0.17569171E-05_JPRB, 0.17575479E-05_JPRB, 0.17559219E-05_JPRB, 0.17543072E-05_JPRB, &
  & 0.17530655E-05_JPRB, 0.17514047E-05_JPRB, 0.17499444E-05_JPRB, 0.17515566E-05_JPRB, 0.17534758E-05_JPRB, 0.17538080E-05_JPRB, &
  & 0.17544580E-05_JPRB, 0.17536074E-05_JPRB, 0.17513865E-05_JPRB, 0.17484870E-05_JPRB  /)

RGHG2(:,71, 6) = (/ &
  & 0.16960053E-05_JPRB, 0.16957942E-05_JPRB, 0.16956644E-05_JPRB, 0.16958903E-05_JPRB, 0.16961555E-05_JPRB, 0.16962505E-05_JPRB, &
  & 0.16963239E-05_JPRB, 0.16964971E-05_JPRB, 0.16966874E-05_JPRB, 0.16971189E-05_JPRB, 0.16974693E-05_JPRB, 0.16978331E-05_JPRB, &
  & 0.16982424E-05_JPRB, 0.16987359E-05_JPRB, 0.16992429E-05_JPRB, 0.16998503E-05_JPRB, 0.17003954E-05_JPRB, 0.17008756E-05_JPRB, &
  & 0.17014024E-05_JPRB, 0.17018726E-05_JPRB, 0.17023822E-05_JPRB, 0.17028618E-05_JPRB, 0.17033849E-05_JPRB, 0.17037129E-05_JPRB, &
  & 0.17039233E-05_JPRB, 0.17038302E-05_JPRB, 0.17040878E-05_JPRB, 0.17043923E-05_JPRB, 0.17048031E-05_JPRB, 0.17065130E-05_JPRB, &
  & 0.17078483E-05_JPRB, 0.17078357E-05_JPRB, 0.17054838E-05_JPRB, 0.17029621E-05_JPRB, 0.17016871E-05_JPRB, 0.17012289E-05_JPRB, &
  & 0.17009149E-05_JPRB, 0.17011472E-05_JPRB, 0.17027931E-05_JPRB, 0.17055789E-05_JPRB, 0.17108261E-05_JPRB, 0.17182254E-05_JPRB, &
  & 0.17225679E-05_JPRB, 0.17271250E-05_JPRB, 0.17334261E-05_JPRB, 0.17408718E-05_JPRB, 0.17462099E-05_JPRB, 0.17483530E-05_JPRB, &
  & 0.17521815E-05_JPRB, 0.17553127E-05_JPRB, 0.17576909E-05_JPRB, 0.17581315E-05_JPRB, 0.17562539E-05_JPRB, 0.17545283E-05_JPRB, &
  & 0.17530122E-05_JPRB, 0.17514594E-05_JPRB, 0.17499071E-05_JPRB, 0.17515704E-05_JPRB, 0.17532259E-05_JPRB, 0.17534952E-05_JPRB, &
  & 0.17544386E-05_JPRB, 0.17536666E-05_JPRB, 0.17513250E-05_JPRB, 0.17484192E-05_JPRB  /)

RGHG2(:,72, 6) = (/ &
  & 0.16957791E-05_JPRB, 0.16955730E-05_JPRB, 0.16954445E-05_JPRB, 0.16956655E-05_JPRB, 0.16959442E-05_JPRB, 0.16960305E-05_JPRB, &
  & 0.16960755E-05_JPRB, 0.16962301E-05_JPRB, 0.16964179E-05_JPRB, 0.16968569E-05_JPRB, 0.16971999E-05_JPRB, 0.16975637E-05_JPRB, &
  & 0.16979506E-05_JPRB, 0.16984429E-05_JPRB, 0.16989301E-05_JPRB, 0.16995177E-05_JPRB, 0.17000702E-05_JPRB, 0.17005615E-05_JPRB, &
  & 0.17010883E-05_JPRB, 0.17016019E-05_JPRB, 0.17020694E-05_JPRB, 0.17024858E-05_JPRB, 0.17029619E-05_JPRB, 0.17031933E-05_JPRB, &
  & 0.17033108E-05_JPRB, 0.17030704E-05_JPRB, 0.17032921E-05_JPRB, 0.17036226E-05_JPRB, 0.17041808E-05_JPRB, 0.17061111E-05_JPRB, &
  & 0.17074996E-05_JPRB, 0.17075873E-05_JPRB, 0.17055511E-05_JPRB, 0.17028474E-05_JPRB, 0.17015427E-05_JPRB, 0.17011675E-05_JPRB, &
  & 0.17006851E-05_JPRB, 0.17006697E-05_JPRB, 0.17021509E-05_JPRB, 0.17050173E-05_JPRB, 0.17104898E-05_JPRB, 0.17182605E-05_JPRB, &
  & 0.17227987E-05_JPRB, 0.17276517E-05_JPRB, 0.17343627E-05_JPRB, 0.17420634E-05_JPRB, 0.17474386E-05_JPRB, 0.17494766E-05_JPRB, &
  & 0.17531589E-05_JPRB, 0.17562777E-05_JPRB, 0.17585098E-05_JPRB, 0.17587585E-05_JPRB, 0.17566221E-05_JPRB, 0.17546662E-05_JPRB, &
  & 0.17528888E-05_JPRB, 0.17515106E-05_JPRB, 0.17499063E-05_JPRB, 0.17515919E-05_JPRB, 0.17531212E-05_JPRB, 0.17534201E-05_JPRB, &
  & 0.17545604E-05_JPRB, 0.17538541E-05_JPRB, 0.17514047E-05_JPRB, 0.17484258E-05_JPRB  /)

RGHG2(:,73, 6) = (/ &
  & 0.16955648E-05_JPRB, 0.16953705E-05_JPRB, 0.16952444E-05_JPRB, 0.16954546E-05_JPRB, 0.16957448E-05_JPRB, 0.16958281E-05_JPRB, &
  & 0.16958491E-05_JPRB, 0.16959815E-05_JPRB, 0.16961600E-05_JPRB, 0.16966121E-05_JPRB, 0.16969500E-05_JPRB, 0.16973080E-05_JPRB, &
  & 0.16976771E-05_JPRB, 0.16981670E-05_JPRB, 0.16986262E-05_JPRB, 0.16991870E-05_JPRB, 0.16997539E-05_JPRB, 0.17002542E-05_JPRB, &
  & 0.17007913E-05_JPRB, 0.17013323E-05_JPRB, 0.17017862E-05_JPRB, 0.17021437E-05_JPRB, 0.17025484E-05_JPRB, 0.17026953E-05_JPRB, &
  & 0.17027182E-05_JPRB, 0.17023549E-05_JPRB, 0.17025554E-05_JPRB, 0.17029282E-05_JPRB, 0.17035943E-05_JPRB, 0.17057440E-05_JPRB, &
  & 0.17071734E-05_JPRB, 0.17075183E-05_JPRB, 0.17059273E-05_JPRB, 0.17032186E-05_JPRB, 0.17017461E-05_JPRB, 0.17013601E-05_JPRB, &
  & 0.17006669E-05_JPRB, 0.17004875E-05_JPRB, 0.17016916E-05_JPRB, 0.17045757E-05_JPRB, 0.17102910E-05_JPRB, 0.17184813E-05_JPRB, &
  & 0.17232795E-05_JPRB, 0.17284060E-05_JPRB, 0.17355326E-05_JPRB, 0.17434520E-05_JPRB, 0.17488255E-05_JPRB, 0.17507541E-05_JPRB, &
  & 0.17542608E-05_JPRB, 0.17574246E-05_JPRB, 0.17594040E-05_JPRB, 0.17594930E-05_JPRB, 0.17571204E-05_JPRB, 0.17549398E-05_JPRB, &
  & 0.17529399E-05_JPRB, 0.17515637E-05_JPRB, 0.17499841E-05_JPRB, 0.17516737E-05_JPRB, 0.17532035E-05_JPRB, 0.17536484E-05_JPRB, &
  & 0.17549098E-05_JPRB, 0.17542568E-05_JPRB, 0.17516151E-05_JPRB, 0.17484892E-05_JPRB  /)

RGHG2(:,74, 6) = (/ &
  & 0.16953609E-05_JPRB, 0.16951843E-05_JPRB, 0.16950621E-05_JPRB, 0.16952604E-05_JPRB, 0.16955551E-05_JPRB, 0.16956374E-05_JPRB, &
  & 0.16956400E-05_JPRB, 0.16957485E-05_JPRB, 0.16959148E-05_JPRB, 0.16963836E-05_JPRB, 0.16967187E-05_JPRB, 0.16970713E-05_JPRB, &
  & 0.16974200E-05_JPRB, 0.16979074E-05_JPRB, 0.16983312E-05_JPRB, 0.16988601E-05_JPRB, 0.16994405E-05_JPRB, 0.16999577E-05_JPRB, &
  & 0.17005090E-05_JPRB, 0.17010829E-05_JPRB, 0.17015218E-05_JPRB, 0.17018231E-05_JPRB, 0.17021618E-05_JPRB, 0.17022215E-05_JPRB, &
  & 0.17021544E-05_JPRB, 0.17017488E-05_JPRB, 0.17019153E-05_JPRB, 0.17023114E-05_JPRB, 0.17030402E-05_JPRB, 0.17054194E-05_JPRB, &
  & 0.17069223E-05_JPRB, 0.17075111E-05_JPRB, 0.17063412E-05_JPRB, 0.17037158E-05_JPRB, 0.17021575E-05_JPRB, 0.17017162E-05_JPRB, &
  & 0.17008239E-05_JPRB, 0.17005326E-05_JPRB, 0.17014646E-05_JPRB, 0.17043357E-05_JPRB, 0.17102635E-05_JPRB, 0.17189563E-05_JPRB, &
  & 0.17239994E-05_JPRB, 0.17293389E-05_JPRB, 0.17367900E-05_JPRB, 0.17448769E-05_JPRB, 0.17502746E-05_JPRB, 0.17520608E-05_JPRB, &
  & 0.17554530E-05_JPRB, 0.17585081E-05_JPRB, 0.17602979E-05_JPRB, 0.17602854E-05_JPRB, 0.17576870E-05_JPRB, 0.17553459E-05_JPRB, &
  & 0.17531860E-05_JPRB, 0.17516830E-05_JPRB, 0.17501667E-05_JPRB, 0.17517795E-05_JPRB, 0.17534379E-05_JPRB, 0.17540750E-05_JPRB, &
  & 0.17554277E-05_JPRB, 0.17548741E-05_JPRB, 0.17519847E-05_JPRB, 0.17486653E-05_JPRB  /)

RGHG2(:,75, 6) = (/ &
  & 0.16951684E-05_JPRB, 0.16950154E-05_JPRB, 0.16948996E-05_JPRB, 0.16950855E-05_JPRB, 0.16953767E-05_JPRB, 0.16954583E-05_JPRB, &
  & 0.16954494E-05_JPRB, 0.16955338E-05_JPRB, 0.16956854E-05_JPRB, 0.16961711E-05_JPRB, 0.16965056E-05_JPRB, 0.16968553E-05_JPRB, &
  & 0.16971824E-05_JPRB, 0.16976666E-05_JPRB, 0.16980541E-05_JPRB, 0.16985479E-05_JPRB, 0.16991349E-05_JPRB, 0.16996734E-05_JPRB, &
  & 0.17002395E-05_JPRB, 0.17008605E-05_JPRB, 0.17012842E-05_JPRB, 0.17015312E-05_JPRB, 0.17018114E-05_JPRB, 0.17018024E-05_JPRB, &
  & 0.17016583E-05_JPRB, 0.17012640E-05_JPRB, 0.17013839E-05_JPRB, 0.17017745E-05_JPRB, 0.17025354E-05_JPRB, 0.17051244E-05_JPRB, &
  & 0.17067219E-05_JPRB, 0.17075232E-05_JPRB, 0.17067307E-05_JPRB, 0.17042769E-05_JPRB, 0.17027142E-05_JPRB, 0.17022147E-05_JPRB, &
  & 0.17011489E-05_JPRB, 0.17007536E-05_JPRB, 0.17014467E-05_JPRB, 0.17042952E-05_JPRB, 0.17103912E-05_JPRB, 0.17196253E-05_JPRB, &
  & 0.17248609E-05_JPRB, 0.17303845E-05_JPRB, 0.17380529E-05_JPRB, 0.17462432E-05_JPRB, 0.17517227E-05_JPRB, 0.17533803E-05_JPRB, &
  & 0.17567256E-05_JPRB, 0.17595360E-05_JPRB, 0.17611928E-05_JPRB, 0.17611171E-05_JPRB, 0.17583059E-05_JPRB, 0.17558499E-05_JPRB, &
  & 0.17535943E-05_JPRB, 0.17519359E-05_JPRB, 0.17504546E-05_JPRB, 0.17518986E-05_JPRB, 0.17538142E-05_JPRB, 0.17546639E-05_JPRB, &
  & 0.17560827E-05_JPRB, 0.17556690E-05_JPRB, 0.17525130E-05_JPRB, 0.17490284E-05_JPRB  /)

RGHG2(:,76, 6) = (/ &
  & 0.16949890E-05_JPRB, 0.16948656E-05_JPRB, 0.16947598E-05_JPRB, 0.16949333E-05_JPRB, 0.16952121E-05_JPRB, 0.16952913E-05_JPRB, &
  & 0.16952799E-05_JPRB, 0.16953420E-05_JPRB, 0.16954762E-05_JPRB, 0.16959743E-05_JPRB, 0.16963101E-05_JPRB, 0.16966623E-05_JPRB, &
  & 0.16969695E-05_JPRB, 0.16974488E-05_JPRB, 0.16978091E-05_JPRB, 0.16982670E-05_JPRB, 0.16988452E-05_JPRB, 0.16994023E-05_JPRB, &
  & 0.16999795E-05_JPRB, 0.17006737E-05_JPRB, 0.17010874E-05_JPRB, 0.17012811E-05_JPRB, 0.17015094E-05_JPRB, 0.17014855E-05_JPRB, &
  & 0.17012906E-05_JPRB, 0.17009112E-05_JPRB, 0.17009766E-05_JPRB, 0.17013214E-05_JPRB, 0.17021070E-05_JPRB, 0.17048372E-05_JPRB, &
  & 0.17065263E-05_JPRB, 0.17075048E-05_JPRB, 0.17070367E-05_JPRB, 0.17048592E-05_JPRB, 0.17033423E-05_JPRB, 0.17028403E-05_JPRB, &
  & 0.17016407E-05_JPRB, 0.17010845E-05_JPRB, 0.17015992E-05_JPRB, 0.17044440E-05_JPRB, 0.17106478E-05_JPRB, 0.17203897E-05_JPRB, &
  & 0.17257169E-05_JPRB, 0.17314510E-05_JPRB, 0.17392160E-05_JPRB, 0.17474261E-05_JPRB, 0.17530877E-05_JPRB, 0.17547094E-05_JPRB, &
  & 0.17580732E-05_JPRB, 0.17605579E-05_JPRB, 0.17621045E-05_JPRB, 0.17619693E-05_JPRB, 0.17589637E-05_JPRB, 0.17564012E-05_JPRB, &
  & 0.17541147E-05_JPRB, 0.17524241E-05_JPRB, 0.17508486E-05_JPRB, 0.17520202E-05_JPRB, 0.17543258E-05_JPRB, 0.17553786E-05_JPRB, &
  & 0.17568383E-05_JPRB, 0.17565893E-05_JPRB, 0.17532005E-05_JPRB, 0.17496936E-05_JPRB  /)

RGHG2(:,77, 6) = (/ &
  & 0.16948275E-05_JPRB, 0.16947390E-05_JPRB, 0.16946480E-05_JPRB, 0.16948089E-05_JPRB, 0.16950633E-05_JPRB, 0.16951387E-05_JPRB, &
  & 0.16951296E-05_JPRB, 0.16951750E-05_JPRB, 0.16952905E-05_JPRB, 0.16957917E-05_JPRB, 0.16961311E-05_JPRB, 0.16964917E-05_JPRB, &
  & 0.16967800E-05_JPRB, 0.16972567E-05_JPRB, 0.16976096E-05_JPRB, 0.16980501E-05_JPRB, 0.16986148E-05_JPRB, 0.16991848E-05_JPRB, &
  & 0.16997769E-05_JPRB, 0.17005380E-05_JPRB, 0.17009452E-05_JPRB, 0.17011255E-05_JPRB, 0.17013462E-05_JPRB, 0.17012965E-05_JPRB, &
  & 0.17010799E-05_JPRB, 0.17006882E-05_JPRB, 0.17006733E-05_JPRB, 0.17009824E-05_JPRB, 0.17017657E-05_JPRB, 0.17045521E-05_JPRB, &
  & 0.17063521E-05_JPRB, 0.17074982E-05_JPRB, 0.17074475E-05_JPRB, 0.17055167E-05_JPRB, 0.17040010E-05_JPRB, 0.17035370E-05_JPRB, &
  & 0.17023971E-05_JPRB, 0.17016990E-05_JPRB, 0.17020948E-05_JPRB, 0.17047428E-05_JPRB, 0.17111226E-05_JPRB, 0.17211818E-05_JPRB, &
  & 0.17266341E-05_JPRB, 0.17324960E-05_JPRB, 0.17402339E-05_JPRB, 0.17483712E-05_JPRB, 0.17541948E-05_JPRB, 0.17559647E-05_JPRB, &
  & 0.17592926E-05_JPRB, 0.17615577E-05_JPRB, 0.17629842E-05_JPRB, 0.17627065E-05_JPRB, 0.17594536E-05_JPRB, 0.17567879E-05_JPRB, &
  & 0.17546331E-05_JPRB, 0.17530623E-05_JPRB, 0.17513641E-05_JPRB, 0.17520889E-05_JPRB, 0.17549129E-05_JPRB, 0.17562718E-05_JPRB, &
  & 0.17577753E-05_JPRB, 0.17576100E-05_JPRB, 0.17540029E-05_JPRB, 0.17507081E-05_JPRB  /)

RGHG2(:,78, 6) = (/ &
  & 0.16946806E-05_JPRB, 0.16946288E-05_JPRB, 0.16945560E-05_JPRB, 0.16947068E-05_JPRB, 0.16949322E-05_JPRB, 0.16950014E-05_JPRB, &
  & 0.16949964E-05_JPRB, 0.16950295E-05_JPRB, 0.16951286E-05_JPRB, 0.16956267E-05_JPRB, 0.16959691E-05_JPRB, 0.16963329E-05_JPRB, &
  & 0.16966048E-05_JPRB, 0.16970997E-05_JPRB, 0.16974463E-05_JPRB, 0.16978777E-05_JPRB, 0.16984335E-05_JPRB, 0.16990112E-05_JPRB, &
  & 0.16996199E-05_JPRB, 0.17004458E-05_JPRB, 0.17008579E-05_JPRB, 0.17010564E-05_JPRB, 0.17012602E-05_JPRB, 0.17011746E-05_JPRB, &
  & 0.17009348E-05_JPRB, 0.17005309E-05_JPRB, 0.17004561E-05_JPRB, 0.17007189E-05_JPRB, 0.17014690E-05_JPRB, 0.17042852E-05_JPRB, &
  & 0.17062078E-05_JPRB, 0.17075652E-05_JPRB, 0.17079664E-05_JPRB, 0.17061937E-05_JPRB, 0.17046465E-05_JPRB, 0.17042362E-05_JPRB, &
  & 0.17032039E-05_JPRB, 0.17024158E-05_JPRB, 0.17027162E-05_JPRB, 0.17050412E-05_JPRB, 0.17115586E-05_JPRB, 0.17220167E-05_JPRB, &
  & 0.17276050E-05_JPRB, 0.17335339E-05_JPRB, 0.17411374E-05_JPRB, 0.17491787E-05_JPRB, 0.17550613E-05_JPRB, 0.17570553E-05_JPRB, &
  & 0.17603053E-05_JPRB, 0.17624181E-05_JPRB, 0.17637442E-05_JPRB, 0.17632905E-05_JPRB, 0.17598362E-05_JPRB, 0.17570901E-05_JPRB, &
  & 0.17550948E-05_JPRB, 0.17536948E-05_JPRB, 0.17519244E-05_JPRB, 0.17522544E-05_JPRB, 0.17555158E-05_JPRB, 0.17571853E-05_JPRB, &
  & 0.17587774E-05_JPRB, 0.17586854E-05_JPRB, 0.17549788E-05_JPRB, 0.17520335E-05_JPRB  /)

RGHG2(:,79, 6) = (/ &
  & 0.16945490E-05_JPRB, 0.16945329E-05_JPRB, 0.16944808E-05_JPRB, 0.16946241E-05_JPRB, 0.16948187E-05_JPRB, 0.16948805E-05_JPRB, &
  & 0.16948828E-05_JPRB, 0.16949052E-05_JPRB, 0.16949913E-05_JPRB, 0.16954808E-05_JPRB, 0.16958292E-05_JPRB, 0.16961950E-05_JPRB, &
  & 0.16964607E-05_JPRB, 0.16969847E-05_JPRB, 0.16973323E-05_JPRB, 0.16977571E-05_JPRB, 0.16983042E-05_JPRB, 0.16988877E-05_JPRB, &
  & 0.16995131E-05_JPRB, 0.17004025E-05_JPRB, 0.17008323E-05_JPRB, 0.17010680E-05_JPRB, 0.17012394E-05_JPRB, 0.17011087E-05_JPRB, &
  & 0.17008348E-05_JPRB, 0.17004233E-05_JPRB, 0.17003175E-05_JPRB, 0.17005121E-05_JPRB, 0.17011960E-05_JPRB, 0.17040289E-05_JPRB, &
  & 0.17060905E-05_JPRB, 0.17076969E-05_JPRB, 0.17085029E-05_JPRB, 0.17068520E-05_JPRB, 0.17052550E-05_JPRB, 0.17049046E-05_JPRB, &
  & 0.17040021E-05_JPRB, 0.17031264E-05_JPRB, 0.17033907E-05_JPRB, 0.17053528E-05_JPRB, 0.17119649E-05_JPRB, 0.17228699E-05_JPRB, &
  & 0.17285550E-05_JPRB, 0.17345413E-05_JPRB, 0.17419328E-05_JPRB, 0.17498241E-05_JPRB, 0.17556993E-05_JPRB, 0.17579472E-05_JPRB, &
  & 0.17610829E-05_JPRB, 0.17631080E-05_JPRB, 0.17643953E-05_JPRB, 0.17637648E-05_JPRB, 0.17601458E-05_JPRB, 0.17573125E-05_JPRB, &
  & 0.17554894E-05_JPRB, 0.17543263E-05_JPRB, 0.17525163E-05_JPRB, 0.17525705E-05_JPRB, 0.17562765E-05_JPRB, 0.17582077E-05_JPRB, &
  & 0.17599432E-05_JPRB, 0.17599623E-05_JPRB, 0.17563565E-05_JPRB, 0.17539119E-05_JPRB  /)

RGHG2(:,80, 6) = (/ &
  & 0.16944330E-05_JPRB, 0.16944490E-05_JPRB, 0.16944192E-05_JPRB, 0.16945576E-05_JPRB, 0.16947225E-05_JPRB, 0.16947769E-05_JPRB, &
  & 0.16947915E-05_JPRB, 0.16948014E-05_JPRB, 0.16948788E-05_JPRB, 0.16953547E-05_JPRB, 0.16957167E-05_JPRB, 0.16960884E-05_JPRB, &
  & 0.16963663E-05_JPRB, 0.16969174E-05_JPRB, 0.16972810E-05_JPRB, 0.16976958E-05_JPRB, 0.16982294E-05_JPRB, 0.16988204E-05_JPRB, &
  & 0.16994599E-05_JPRB, 0.17004128E-05_JPRB, 0.17008735E-05_JPRB, 0.17011518E-05_JPRB, 0.17012724E-05_JPRB, 0.17010890E-05_JPRB, &
  & 0.17007619E-05_JPRB, 0.17003505E-05_JPRB, 0.17002483E-05_JPRB, 0.17003416E-05_JPRB, 0.17009256E-05_JPRB, 0.17037726E-05_JPRB, &
  & 0.17059939E-05_JPRB, 0.17078772E-05_JPRB, 0.17089541E-05_JPRB, 0.17074523E-05_JPRB, 0.17058035E-05_JPRB, 0.17055089E-05_JPRB, &
  & 0.17047392E-05_JPRB, 0.17037202E-05_JPRB, 0.17040491E-05_JPRB, 0.17057015E-05_JPRB, 0.17123663E-05_JPRB, 0.17237108E-05_JPRB, &
  & 0.17293991E-05_JPRB, 0.17354905E-05_JPRB, 0.17426263E-05_JPRB, 0.17502757E-05_JPRB, 0.17561270E-05_JPRB, 0.17586135E-05_JPRB, &
  & 0.17616043E-05_JPRB, 0.17636048E-05_JPRB, 0.17649580E-05_JPRB, 0.17641823E-05_JPRB, 0.17604172E-05_JPRB, 0.17574564E-05_JPRB, &
  & 0.17558096E-05_JPRB, 0.17549719E-05_JPRB, 0.17531259E-05_JPRB, 0.17530772E-05_JPRB, 0.17573479E-05_JPRB, 0.17594345E-05_JPRB, &
  & 0.17613793E-05_JPRB, 0.17615997E-05_JPRB, 0.17583765E-05_JPRB, 0.17566071E-05_JPRB  /)

RGHG2(:,81, 6) = (/ &
  & 0.16943376E-05_JPRB, 0.16943893E-05_JPRB, 0.16943735E-05_JPRB, 0.16945055E-05_JPRB, 0.16946487E-05_JPRB, 0.16946942E-05_JPRB, &
  & 0.16947292E-05_JPRB, 0.16947340E-05_JPRB, 0.16948101E-05_JPRB, 0.16952708E-05_JPRB, 0.16956531E-05_JPRB, 0.16960465E-05_JPRB, &
  & 0.16963486E-05_JPRB, 0.16969328E-05_JPRB, 0.16973142E-05_JPRB, 0.16977303E-05_JPRB, 0.16982473E-05_JPRB, 0.16988383E-05_JPRB, &
  & 0.16995441E-05_JPRB, 0.17005173E-05_JPRB, 0.17010009E-05_JPRB, 0.17012741E-05_JPRB, 0.17013553E-05_JPRB, 0.17010916E-05_JPRB, &
  & 0.17007276E-05_JPRB, 0.17002971E-05_JPRB, 0.17002089E-05_JPRB, 0.17002067E-05_JPRB, 0.17006939E-05_JPRB, 0.17036147E-05_JPRB, &
  & 0.17060539E-05_JPRB, 0.17080696E-05_JPRB, 0.17092586E-05_JPRB, 0.17079338E-05_JPRB, 0.17062302E-05_JPRB, 0.17060693E-05_JPRB, &
  & 0.17053773E-05_JPRB, 0.17042233E-05_JPRB, 0.17045727E-05_JPRB, 0.17061206E-05_JPRB, 0.17129714E-05_JPRB, 0.17245400E-05_JPRB, &
  & 0.17301696E-05_JPRB, 0.17363540E-05_JPRB, 0.17432479E-05_JPRB, 0.17506642E-05_JPRB, 0.17563092E-05_JPRB, 0.17590134E-05_JPRB, &
  & 0.17618922E-05_JPRB, 0.17638596E-05_JPRB, 0.17653415E-05_JPRB, 0.17646013E-05_JPRB, 0.17607191E-05_JPRB, 0.17575685E-05_JPRB, &
  & 0.17561064E-05_JPRB, 0.17555247E-05_JPRB, 0.17538672E-05_JPRB, 0.17541662E-05_JPRB, 0.17589450E-05_JPRB, 0.17615054E-05_JPRB, &
  & 0.17633967E-05_JPRB, 0.17634948E-05_JPRB, 0.17605441E-05_JPRB, 0.17590282E-05_JPRB  /)

RGHG2(:,82, 6) = (/ &
  & 0.16942700E-05_JPRB, 0.16943519E-05_JPRB, 0.16943412E-05_JPRB, 0.16944642E-05_JPRB, 0.16945912E-05_JPRB, 0.16946314E-05_JPRB, &
  & 0.16946857E-05_JPRB, 0.16946899E-05_JPRB, 0.16947709E-05_JPRB, 0.16952128E-05_JPRB, 0.16956110E-05_JPRB, 0.16960285E-05_JPRB, &
  & 0.16963582E-05_JPRB, 0.16969797E-05_JPRB, 0.16973657E-05_JPRB, 0.16977979E-05_JPRB, 0.16983187E-05_JPRB, 0.16989140E-05_JPRB, &
  & 0.16996953E-05_JPRB, 0.17006563E-05_JPRB, 0.17011618E-05_JPRB, 0.17014054E-05_JPRB, 0.17014473E-05_JPRB, 0.17011303E-05_JPRB, &
  & 0.17007295E-05_JPRB, 0.17002775E-05_JPRB, 0.17002137E-05_JPRB, 0.17001420E-05_JPRB, 0.17005716E-05_JPRB, 0.17036045E-05_JPRB, &
  & 0.17062161E-05_JPRB, 0.17082977E-05_JPRB, 0.17094804E-05_JPRB, 0.17083263E-05_JPRB, 0.17066034E-05_JPRB, 0.17065824E-05_JPRB, &
  & 0.17059728E-05_JPRB, 0.17047040E-05_JPRB, 0.17050648E-05_JPRB, 0.17065555E-05_JPRB, 0.17136743E-05_JPRB, 0.17253727E-05_JPRB, &
  & 0.17309433E-05_JPRB, 0.17371876E-05_JPRB, 0.17438182E-05_JPRB, 0.17510582E-05_JPRB, 0.17565649E-05_JPRB, 0.17594135E-05_JPRB, &
  & 0.17621335E-05_JPRB, 0.17641497E-05_JPRB, 0.17657032E-05_JPRB, 0.17650590E-05_JPRB, 0.17610174E-05_JPRB, 0.17577528E-05_JPRB, &
  & 0.17564172E-05_JPRB, 0.17561302E-05_JPRB, 0.17547372E-05_JPRB, 0.17555264E-05_JPRB, 0.17604697E-05_JPRB, 0.17633946E-05_JPRB, &
  & 0.17651143E-05_JPRB, 0.17649857E-05_JPRB, 0.17622549E-05_JPRB, 0.17608548E-05_JPRB  /)

RGHG2(:,83, 6) = (/ &
  & 0.16942325E-05_JPRB, 0.16943342E-05_JPRB, 0.16943224E-05_JPRB, 0.16944339E-05_JPRB, 0.16945495E-05_JPRB, 0.16945893E-05_JPRB, &
  & 0.16946620E-05_JPRB, 0.16946703E-05_JPRB, 0.16947608E-05_JPRB, 0.16951758E-05_JPRB, 0.16955849E-05_JPRB, 0.16960256E-05_JPRB, &
  & 0.16963836E-05_JPRB, 0.16970474E-05_JPRB, 0.16974278E-05_JPRB, 0.16978783E-05_JPRB, 0.16984242E-05_JPRB, 0.16990360E-05_JPRB, &
  & 0.16998881E-05_JPRB, 0.17008189E-05_JPRB, 0.17013554E-05_JPRB, 0.17015632E-05_JPRB, 0.17015604E-05_JPRB, 0.17012044E-05_JPRB, &
  & 0.17007701E-05_JPRB, 0.17003009E-05_JPRB, 0.17002635E-05_JPRB, 0.17001555E-05_JPRB, 0.17005649E-05_JPRB, 0.17037233E-05_JPRB, &
  & 0.17064717E-05_JPRB, 0.17085843E-05_JPRB, 0.17096287E-05_JPRB, 0.17086283E-05_JPRB, 0.17069235E-05_JPRB, 0.17070598E-05_JPRB, &
  & 0.17065280E-05_JPRB, 0.17051713E-05_JPRB, 0.17055537E-05_JPRB, 0.17070391E-05_JPRB, 0.17144998E-05_JPRB, 0.17262490E-05_JPRB, &
  & 0.17317460E-05_JPRB, 0.17380569E-05_JPRB, 0.17444344E-05_JPRB, 0.17515375E-05_JPRB, 0.17569509E-05_JPRB, 0.17598383E-05_JPRB, &
  & 0.17623679E-05_JPRB, 0.17644657E-05_JPRB, 0.17660564E-05_JPRB, 0.17656118E-05_JPRB, 0.17613776E-05_JPRB, 0.17580226E-05_JPRB, &
  & 0.17568062E-05_JPRB, 0.17567568E-05_JPRB, 0.17556968E-05_JPRB, 0.17569711E-05_JPRB, 0.17619301E-05_JPRB, 0.17650611E-05_JPRB, &
  & 0.17664921E-05_JPRB, 0.17660798E-05_JPRB, 0.17635015E-05_JPRB, 0.17620355E-05_JPRB  /)

RGHG2(:,84, 6) = (/ &
  & 0.16942252E-05_JPRB, 0.16943329E-05_JPRB, 0.16943161E-05_JPRB, 0.16944139E-05_JPRB, 0.16945223E-05_JPRB, 0.16945681E-05_JPRB, &
  & 0.16946583E-05_JPRB, 0.16946749E-05_JPRB, 0.16947776E-05_JPRB, 0.16951547E-05_JPRB, 0.16955697E-05_JPRB, 0.16960295E-05_JPRB, &
  & 0.16964145E-05_JPRB, 0.16971249E-05_JPRB, 0.16974941E-05_JPRB, 0.16979563E-05_JPRB, 0.16985449E-05_JPRB, 0.16991897E-05_JPRB, &
  & 0.17000992E-05_JPRB, 0.17009957E-05_JPRB, 0.17015777E-05_JPRB, 0.17017586E-05_JPRB, 0.17017033E-05_JPRB, 0.17013113E-05_JPRB, &
  & 0.17008487E-05_JPRB, 0.17003710E-05_JPRB, 0.17003546E-05_JPRB, 0.17002464E-05_JPRB, 0.17006657E-05_JPRB, 0.17039477E-05_JPRB, &
  & 0.17068122E-05_JPRB, 0.17089540E-05_JPRB, 0.17097357E-05_JPRB, 0.17088533E-05_JPRB, 0.17072068E-05_JPRB, 0.17075262E-05_JPRB, &
  & 0.17070449E-05_JPRB, 0.17056314E-05_JPRB, 0.17060584E-05_JPRB, 0.17075909E-05_JPRB, 0.17154564E-05_JPRB, 0.17272069E-05_JPRB, &
  & 0.17326023E-05_JPRB, 0.17390196E-05_JPRB, 0.17451780E-05_JPRB, 0.17521691E-05_JPRB, 0.17575102E-05_JPRB, 0.17603099E-05_JPRB, &
  & 0.17626352E-05_JPRB, 0.17648080E-05_JPRB, 0.17664239E-05_JPRB, 0.17663052E-05_JPRB, 0.17618575E-05_JPRB, 0.17583922E-05_JPRB, &
  & 0.17573231E-05_JPRB, 0.17573872E-05_JPRB, 0.17566973E-05_JPRB, 0.17583357E-05_JPRB, 0.17633131E-05_JPRB, 0.17664686E-05_JPRB, &
  & 0.17675211E-05_JPRB, 0.17668030E-05_JPRB, 0.17642933E-05_JPRB, 0.17625906E-05_JPRB  /)

RGHG2(:,85, 6) = (/ &
  & 0.16942526E-05_JPRB, 0.16943449E-05_JPRB, 0.16943230E-05_JPRB, 0.16944041E-05_JPRB, 0.16945087E-05_JPRB, 0.16945776E-05_JPRB, &
  & 0.16946883E-05_JPRB, 0.16947088E-05_JPRB, 0.16948218E-05_JPRB, 0.16951462E-05_JPRB, 0.16955624E-05_JPRB, 0.16960313E-05_JPRB, &
  & 0.16964407E-05_JPRB, 0.16971934E-05_JPRB, 0.16975703E-05_JPRB, 0.16980530E-05_JPRB, 0.16986570E-05_JPRB, 0.16993494E-05_JPRB, &
  & 0.17003269E-05_JPRB, 0.17012118E-05_JPRB, 0.17018362E-05_JPRB, 0.17020145E-05_JPRB, 0.17019156E-05_JPRB, 0.17014659E-05_JPRB, &
  & 0.17009750E-05_JPRB, 0.17004922E-05_JPRB, 0.17004757E-05_JPRB, 0.17004035E-05_JPRB, 0.17008138E-05_JPRB, 0.17042820E-05_JPRB, &
  & 0.17073417E-05_JPRB, 0.17096220E-05_JPRB, 0.17101252E-05_JPRB, 0.17091580E-05_JPRB, 0.17076720E-05_JPRB, 0.17082405E-05_JPRB, &
  & 0.17075550E-05_JPRB, 0.17061249E-05_JPRB, 0.17066173E-05_JPRB, 0.17082576E-05_JPRB, 0.17166469E-05_JPRB, 0.17285361E-05_JPRB, &
  & 0.17337261E-05_JPRB, 0.17403720E-05_JPRB, 0.17463364E-05_JPRB, 0.17532416E-05_JPRB, 0.17584594E-05_JPRB, 0.17609754E-05_JPRB, &
  & 0.17631236E-05_JPRB, 0.17653476E-05_JPRB, 0.17670355E-05_JPRB, 0.17673828E-05_JPRB, 0.17627194E-05_JPRB, 0.17590603E-05_JPRB, &
  & 0.17581439E-05_JPRB, 0.17582068E-05_JPRB, 0.17576516E-05_JPRB, 0.17594634E-05_JPRB, 0.17644575E-05_JPRB, 0.17674974E-05_JPRB, &
  & 0.17683124E-05_JPRB, 0.17671745E-05_JPRB, 0.17645120E-05_JPRB, 0.17628273E-05_JPRB  /)

RGHG2(:,86, 6) = (/ &
  & 0.16942963E-05_JPRB, 0.16943631E-05_JPRB, 0.16943320E-05_JPRB, 0.16943973E-05_JPRB, 0.16945031E-05_JPRB, 0.16945942E-05_JPRB, &
  & 0.16947366E-05_JPRB, 0.16947519E-05_JPRB, 0.16948732E-05_JPRB, 0.16951428E-05_JPRB, 0.16955603E-05_JPRB, 0.16960351E-05_JPRB, &
  & 0.16964670E-05_JPRB, 0.16972533E-05_JPRB, 0.16976370E-05_JPRB, 0.16981604E-05_JPRB, 0.16987678E-05_JPRB, 0.16995039E-05_JPRB, &
  & 0.17005558E-05_JPRB, 0.17015095E-05_JPRB, 0.17021644E-05_JPRB, 0.17023452E-05_JPRB, 0.17021833E-05_JPRB, 0.17016926E-05_JPRB, &
  & 0.17011774E-05_JPRB, 0.17006783E-05_JPRB, 0.17006458E-05_JPRB, 0.17006409E-05_JPRB, 0.17010039E-05_JPRB, 0.17047557E-05_JPRB, &
  & 0.17081420E-05_JPRB, 0.17105216E-05_JPRB, 0.17109909E-05_JPRB, 0.17096371E-05_JPRB, 0.17083024E-05_JPRB, 0.17090689E-05_JPRB, &
  & 0.17081391E-05_JPRB, 0.17067153E-05_JPRB, 0.17072234E-05_JPRB, 0.17089319E-05_JPRB, 0.17180937E-05_JPRB, 0.17305141E-05_JPRB, &
  & 0.17352575E-05_JPRB, 0.17423139E-05_JPRB, 0.17479630E-05_JPRB, 0.17548027E-05_JPRB, 0.17599771E-05_JPRB, 0.17620100E-05_JPRB, &
  & 0.17639027E-05_JPRB, 0.17660328E-05_JPRB, 0.17678933E-05_JPRB, 0.17688165E-05_JPRB, 0.17639203E-05_JPRB, 0.17600482E-05_JPRB, &
  & 0.17593236E-05_JPRB, 0.17593058E-05_JPRB, 0.17587365E-05_JPRB, 0.17605426E-05_JPRB, 0.17654349E-05_JPRB, 0.17683767E-05_JPRB, &
  & 0.17689511E-05_JPRB, 0.17674394E-05_JPRB, 0.17646164E-05_JPRB, 0.17629758E-05_JPRB  /)

RGHG2(:,87, 6) = (/ &
  & 0.16943443E-05_JPRB, 0.16943830E-05_JPRB, 0.16943401E-05_JPRB, 0.16943930E-05_JPRB, 0.16945047E-05_JPRB, 0.16946134E-05_JPRB, &
  & 0.16947912E-05_JPRB, 0.16947967E-05_JPRB, 0.16949224E-05_JPRB, 0.16951444E-05_JPRB, 0.16955605E-05_JPRB, 0.16960379E-05_JPRB, &
  & 0.16964968E-05_JPRB, 0.16973105E-05_JPRB, 0.16976987E-05_JPRB, 0.16982800E-05_JPRB, 0.16988781E-05_JPRB, 0.16996574E-05_JPRB, &
  & 0.17008114E-05_JPRB, 0.17018969E-05_JPRB, 0.17025425E-05_JPRB, 0.17027834E-05_JPRB, 0.17025307E-05_JPRB, 0.17020260E-05_JPRB, &
  & 0.17015233E-05_JPRB, 0.17009906E-05_JPRB, 0.17009023E-05_JPRB, 0.17009861E-05_JPRB, 0.17012901E-05_JPRB, 0.17055812E-05_JPRB, &
  & 0.17093832E-05_JPRB, 0.17117703E-05_JPRB, 0.17126763E-05_JPRB, 0.17104222E-05_JPRB, 0.17092695E-05_JPRB, 0.17101051E-05_JPRB, &
  & 0.17088389E-05_JPRB, 0.17074175E-05_JPRB, 0.17078707E-05_JPRB, 0.17096462E-05_JPRB, 0.17197962E-05_JPRB, 0.17334485E-05_JPRB, &
  & 0.17375253E-05_JPRB, 0.17449183E-05_JPRB, 0.17500370E-05_JPRB, 0.17569135E-05_JPRB, 0.17621578E-05_JPRB, 0.17633941E-05_JPRB, &
  & 0.17649543E-05_JPRB, 0.17669300E-05_JPRB, 0.17690237E-05_JPRB, 0.17706090E-05_JPRB, 0.17655272E-05_JPRB, 0.17614524E-05_JPRB, &
  & 0.17608198E-05_JPRB, 0.17607179E-05_JPRB, 0.17600708E-05_JPRB, 0.17615504E-05_JPRB, 0.17662208E-05_JPRB, 0.17691379E-05_JPRB, &
  & 0.17694531E-05_JPRB, 0.17676420E-05_JPRB, 0.17646653E-05_JPRB, 0.17631052E-05_JPRB  /)

RGHG2(:,88, 6) = (/ &
  & 0.16943855E-05_JPRB, 0.16944001E-05_JPRB, 0.16943458E-05_JPRB, 0.16943907E-05_JPRB, 0.16945116E-05_JPRB, 0.16946349E-05_JPRB, &
  & 0.16948505E-05_JPRB, 0.16948361E-05_JPRB, 0.16949652E-05_JPRB, 0.16951491E-05_JPRB, 0.16955619E-05_JPRB, 0.16960397E-05_JPRB, &
  & 0.16965339E-05_JPRB, 0.16973732E-05_JPRB, 0.16977597E-05_JPRB, 0.16984199E-05_JPRB, 0.16989972E-05_JPRB, 0.16998175E-05_JPRB, &
  & 0.17011349E-05_JPRB, 0.17024148E-05_JPRB, 0.17029960E-05_JPRB, 0.17033931E-05_JPRB, 0.17030312E-05_JPRB, 0.17025494E-05_JPRB, &
  & 0.17021352E-05_JPRB, 0.17015313E-05_JPRB, 0.17013200E-05_JPRB, 0.17015259E-05_JPRB, 0.17017662E-05_JPRB, 0.17071844E-05_JPRB, &
  & 0.17112943E-05_JPRB, 0.17136571E-05_JPRB, 0.17159013E-05_JPRB, 0.17117507E-05_JPRB, 0.17107533E-05_JPRB, 0.17115443E-05_JPRB, &
  & 0.17096987E-05_JPRB, 0.17082612E-05_JPRB, 0.17085751E-05_JPRB, 0.17104935E-05_JPRB, 0.17218803E-05_JPRB, 0.17377355E-05_JPRB, &
  & 0.17413233E-05_JPRB, 0.17485870E-05_JPRB, 0.17526887E-05_JPRB, 0.17598758E-05_JPRB, 0.17653042E-05_JPRB, 0.17652182E-05_JPRB, &
  & 0.17663838E-05_JPRB, 0.17682139E-05_JPRB, 0.17705637E-05_JPRB, 0.17728714E-05_JPRB, 0.17676640E-05_JPRB, 0.17634083E-05_JPRB, &
  & 0.17626848E-05_JPRB, 0.17627061E-05_JPRB, 0.17617950E-05_JPRB, 0.17624802E-05_JPRB, 0.17668281E-05_JPRB, 0.17698254E-05_JPRB, &
  & 0.17698468E-05_JPRB, 0.17677998E-05_JPRB, 0.17646928E-05_JPRB, 0.17632243E-05_JPRB  /)

RGHG2(:,89, 6) = (/ &
  & 0.16944052E-05_JPRB, 0.16944079E-05_JPRB, 0.16943486E-05_JPRB, 0.16943900E-05_JPRB, 0.16945191E-05_JPRB, 0.16946598E-05_JPRB, &
  & 0.16949160E-05_JPRB, 0.16948608E-05_JPRB, 0.16949993E-05_JPRB, 0.16951527E-05_JPRB, 0.16955639E-05_JPRB, 0.16960431E-05_JPRB, &
  & 0.16965816E-05_JPRB, 0.16974471E-05_JPRB, 0.16978223E-05_JPRB, 0.16985896E-05_JPRB, 0.16991363E-05_JPRB, 0.16999843E-05_JPRB, &
  & 0.17015841E-05_JPRB, 0.17031048E-05_JPRB, 0.17035729E-05_JPRB, 0.17042288E-05_JPRB, 0.17037935E-05_JPRB, 0.17033744E-05_JPRB, &
  & 0.17032351E-05_JPRB, 0.17024114E-05_JPRB, 0.17019957E-05_JPRB, 0.17024161E-05_JPRB, 0.17025671E-05_JPRB, 0.17103069E-05_JPRB, &
  & 0.17140697E-05_JPRB, 0.17165885E-05_JPRB, 0.17215880E-05_JPRB, 0.17138225E-05_JPRB, 0.17128090E-05_JPRB, 0.17136041E-05_JPRB, &
  & 0.17106968E-05_JPRB, 0.17092486E-05_JPRB, 0.17093286E-05_JPRB, 0.17115877E-05_JPRB, 0.17245081E-05_JPRB, 0.17435326E-05_JPRB, &
  & 0.17475809E-05_JPRB, 0.17539616E-05_JPRB, 0.17561566E-05_JPRB, 0.17641274E-05_JPRB, 0.17696898E-05_JPRB, 0.17675983E-05_JPRB, &
  & 0.17683763E-05_JPRB, 0.17701947E-05_JPRB, 0.17727423E-05_JPRB, 0.17757302E-05_JPRB, 0.17703485E-05_JPRB, 0.17659591E-05_JPRB, &
  & 0.17649735E-05_JPRB, 0.17656634E-05_JPRB, 0.17639819E-05_JPRB, 0.17633035E-05_JPRB, 0.17672922E-05_JPRB, 0.17704660E-05_JPRB, &
  & 0.17701675E-05_JPRB, 0.17679110E-05_JPRB, 0.17647206E-05_JPRB, 0.17632891E-05_JPRB  /)

RGHG2(:,90, 6) = (/ &
  & 0.16944075E-05_JPRB, 0.16944056E-05_JPRB, 0.16943464E-05_JPRB, 0.16943891E-05_JPRB, 0.16945243E-05_JPRB, 0.16946849E-05_JPRB, &
  & 0.16949751E-05_JPRB, 0.16948734E-05_JPRB, 0.16950269E-05_JPRB, 0.16951565E-05_JPRB, 0.16955647E-05_JPRB, 0.16960453E-05_JPRB, &
  & 0.16966398E-05_JPRB, 0.16975156E-05_JPRB, 0.16978876E-05_JPRB, 0.16988062E-05_JPRB, 0.16992877E-05_JPRB, 0.17001350E-05_JPRB, &
  & 0.17022405E-05_JPRB, 0.17039736E-05_JPRB, 0.17043213E-05_JPRB, 0.17052432E-05_JPRB, 0.17048993E-05_JPRB, 0.17045225E-05_JPRB, &
  & 0.17053631E-05_JPRB, 0.17035882E-05_JPRB, 0.17029756E-05_JPRB, 0.17038918E-05_JPRB, 0.17038109E-05_JPRB, 0.17158842E-05_JPRB, &
  & 0.17177477E-05_JPRB, 0.17208597E-05_JPRB, 0.17295245E-05_JPRB, 0.17161290E-05_JPRB, 0.17150574E-05_JPRB, 0.17161999E-05_JPRB, &
  & 0.17116927E-05_JPRB, 0.17104270E-05_JPRB, 0.17100998E-05_JPRB, 0.17129102E-05_JPRB, 0.17279201E-05_JPRB, 0.17502516E-05_JPRB, &
  & 0.17551917E-05_JPRB, 0.17617884E-05_JPRB, 0.17612532E-05_JPRB, 0.17700605E-05_JPRB, 0.17750096E-05_JPRB, 0.17708091E-05_JPRB, &
  & 0.17712843E-05_JPRB, 0.17734968E-05_JPRB, 0.17760643E-05_JPRB, 0.17794857E-05_JPRB, 0.17733911E-05_JPRB, 0.17690431E-05_JPRB, &
  & 0.17679417E-05_JPRB, 0.17696387E-05_JPRB, 0.17666298E-05_JPRB, 0.17640660E-05_JPRB, 0.17676310E-05_JPRB, 0.17709736E-05_JPRB, &
  & 0.17704055E-05_JPRB, 0.17679963E-05_JPRB, 0.17647377E-05_JPRB, 0.17633120E-05_JPRB  /)

RGHG2(:,91, 6) = (/ &
  & 0.16944138E-05_JPRB, 0.16944039E-05_JPRB, 0.16943479E-05_JPRB, 0.16943874E-05_JPRB, 0.16945290E-05_JPRB, 0.16947183E-05_JPRB, &
  & 0.16950245E-05_JPRB, 0.16948813E-05_JPRB, 0.16950475E-05_JPRB, 0.16951628E-05_JPRB, 0.16955694E-05_JPRB, 0.16960468E-05_JPRB, &
  & 0.16967513E-05_JPRB, 0.16976288E-05_JPRB, 0.16979498E-05_JPRB, 0.16991268E-05_JPRB, 0.16995301E-05_JPRB, 0.17003120E-05_JPRB, &
  & 0.17030381E-05_JPRB, 0.17054876E-05_JPRB, 0.17055354E-05_JPRB, 0.17065610E-05_JPRB, 0.17068457E-05_JPRB, 0.17055930E-05_JPRB, &
  & 0.17112312E-05_JPRB, 0.17055634E-05_JPRB, 0.17050465E-05_JPRB, 0.17060424E-05_JPRB, 0.17052292E-05_JPRB, 0.17227479E-05_JPRB, &
  & 0.17227989E-05_JPRB, 0.17283680E-05_JPRB, 0.17403259E-05_JPRB, 0.17193518E-05_JPRB, 0.17179180E-05_JPRB, 0.17194769E-05_JPRB, &
  & 0.17127951E-05_JPRB, 0.17119012E-05_JPRB, 0.17110666E-05_JPRB, 0.17145104E-05_JPRB, 0.17335090E-05_JPRB, 0.17576849E-05_JPRB, &
  & 0.17639173E-05_JPRB, 0.17720314E-05_JPRB, 0.17683291E-05_JPRB, 0.17771938E-05_JPRB, 0.17818525E-05_JPRB, 0.17762209E-05_JPRB, &
  & 0.17766275E-05_JPRB, 0.17796697E-05_JPRB, 0.17822180E-05_JPRB, 0.17843136E-05_JPRB, 0.17776877E-05_JPRB, 0.17739986E-05_JPRB, &
  & 0.17727903E-05_JPRB, 0.17749978E-05_JPRB, 0.17704461E-05_JPRB, 0.17648030E-05_JPRB, 0.17679851E-05_JPRB, 0.17714075E-05_JPRB, &
  & 0.17705762E-05_JPRB, 0.17680888E-05_JPRB, 0.17647503E-05_JPRB, 0.17633231E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ---GEMS----

RGHG2(:, 1, 7) = (/ &
  & 0.20203911E-06_JPRB, 0.20204816E-06_JPRB, 0.20186955E-06_JPRB, 0.20129585E-06_JPRB, 0.20082093E-06_JPRB, 0.20040033E-06_JPRB, &
  & 0.20003652E-06_JPRB, 0.19974515E-06_JPRB, 0.19945871E-06_JPRB, 0.19913359E-06_JPRB, 0.19880765E-06_JPRB, 0.19846359E-06_JPRB, &
  & 0.19805616E-06_JPRB, 0.19750222E-06_JPRB, 0.19684457E-06_JPRB, 0.19620667E-06_JPRB, 0.19560581E-06_JPRB, 0.19516875E-06_JPRB, &
  & 0.19485351E-06_JPRB, 0.19482799E-06_JPRB, 0.19485022E-06_JPRB, 0.19483046E-06_JPRB, 0.19454238E-06_JPRB, 0.19384357E-06_JPRB, &
  & 0.19293570E-06_JPRB, 0.19179572E-06_JPRB, 0.19042856E-06_JPRB, 0.18861776E-06_JPRB, 0.18634931E-06_JPRB, 0.18400021E-06_JPRB, &
  & 0.18171859E-06_JPRB, 0.17965428E-06_JPRB, 0.17785582E-06_JPRB, 0.17622034E-06_JPRB, 0.17468527E-06_JPRB, 0.17312633E-06_JPRB, &
  & 0.17170073E-06_JPRB, 0.17053030E-06_JPRB, 0.16988828E-06_JPRB, 0.16943147E-06_JPRB, 0.16893926E-06_JPRB, 0.16849150E-06_JPRB, &
  & 0.16795649E-06_JPRB, 0.16748897E-06_JPRB, 0.16734081E-06_JPRB, 0.16753753E-06_JPRB, 0.16808983E-06_JPRB, 0.16910305E-06_JPRB, &
  & 0.17052700E-06_JPRB, 0.17210323E-06_JPRB, 0.17361854E-06_JPRB, 0.17503179E-06_JPRB, 0.17638825E-06_JPRB, 0.17770684E-06_JPRB, &
  & 0.17900486E-06_JPRB, 0.18024279E-06_JPRB, 0.18126754E-06_JPRB, 0.18203466E-06_JPRB, 0.18265363E-06_JPRB, 0.18322321E-06_JPRB, &
  & 0.18376974E-06_JPRB, 0.18426195E-06_JPRB, 0.18445126E-06_JPRB, 0.18417388E-06_JPRB  /)

RGHG2(:, 2, 7) = (/ &
  & 0.20203911E-06_JPRB, 0.20204816E-06_JPRB, 0.20186955E-06_JPRB, 0.20129585E-06_JPRB, 0.20082093E-06_JPRB, 0.20040033E-06_JPRB, &
  & 0.20003652E-06_JPRB, 0.19974515E-06_JPRB, 0.19945871E-06_JPRB, 0.19913359E-06_JPRB, 0.19880765E-06_JPRB, 0.19846359E-06_JPRB, &
  & 0.19805616E-06_JPRB, 0.19750222E-06_JPRB, 0.19684457E-06_JPRB, 0.19620667E-06_JPRB, 0.19560581E-06_JPRB, 0.19516875E-06_JPRB, &
  & 0.19485351E-06_JPRB, 0.19482799E-06_JPRB, 0.19485022E-06_JPRB, 0.19483046E-06_JPRB, 0.19454238E-06_JPRB, 0.19384357E-06_JPRB, &
  & 0.19293570E-06_JPRB, 0.19179572E-06_JPRB, 0.19042856E-06_JPRB, 0.18861776E-06_JPRB, 0.18634931E-06_JPRB, 0.18400021E-06_JPRB, &
  & 0.18171859E-06_JPRB, 0.17965428E-06_JPRB, 0.17785582E-06_JPRB, 0.17622034E-06_JPRB, 0.17468527E-06_JPRB, 0.17312633E-06_JPRB, &
  & 0.17170073E-06_JPRB, 0.17053030E-06_JPRB, 0.16988828E-06_JPRB, 0.16943147E-06_JPRB, 0.16893926E-06_JPRB, 0.16849150E-06_JPRB, &
  & 0.16795649E-06_JPRB, 0.16748897E-06_JPRB, 0.16734081E-06_JPRB, 0.16753753E-06_JPRB, 0.16808983E-06_JPRB, 0.16910305E-06_JPRB, &
  & 0.17052700E-06_JPRB, 0.17210323E-06_JPRB, 0.17361854E-06_JPRB, 0.17503179E-06_JPRB, 0.17638825E-06_JPRB, 0.17770684E-06_JPRB, &
  & 0.17900486E-06_JPRB, 0.18024279E-06_JPRB, 0.18126754E-06_JPRB, 0.18203466E-06_JPRB, 0.18265363E-06_JPRB, 0.18322321E-06_JPRB, &
  & 0.18376974E-06_JPRB, 0.18426195E-06_JPRB, 0.18445126E-06_JPRB, 0.18417388E-06_JPRB  /)

RGHG2(:, 3, 7) = (/ &
  & 0.20203911E-06_JPRB, 0.20204816E-06_JPRB, 0.20186955E-06_JPRB, 0.20129585E-06_JPRB, 0.20082093E-06_JPRB, 0.20040033E-06_JPRB, &
  & 0.20003652E-06_JPRB, 0.19974515E-06_JPRB, 0.19945871E-06_JPRB, 0.19913359E-06_JPRB, 0.19880765E-06_JPRB, 0.19846359E-06_JPRB, &
  & 0.19805616E-06_JPRB, 0.19750222E-06_JPRB, 0.19684457E-06_JPRB, 0.19620667E-06_JPRB, 0.19560581E-06_JPRB, 0.19516875E-06_JPRB, &
  & 0.19485351E-06_JPRB, 0.19482799E-06_JPRB, 0.19485022E-06_JPRB, 0.19483046E-06_JPRB, 0.19454238E-06_JPRB, 0.19384357E-06_JPRB, &
  & 0.19293570E-06_JPRB, 0.19179572E-06_JPRB, 0.19042856E-06_JPRB, 0.18861776E-06_JPRB, 0.18634931E-06_JPRB, 0.18400021E-06_JPRB, &
  & 0.18171859E-06_JPRB, 0.17965428E-06_JPRB, 0.17785582E-06_JPRB, 0.17622034E-06_JPRB, 0.17468527E-06_JPRB, 0.17312633E-06_JPRB, &
  & 0.17170073E-06_JPRB, 0.17053030E-06_JPRB, 0.16988828E-06_JPRB, 0.16943147E-06_JPRB, 0.16893926E-06_JPRB, 0.16849150E-06_JPRB, &
  & 0.16795649E-06_JPRB, 0.16748897E-06_JPRB, 0.16734081E-06_JPRB, 0.16753753E-06_JPRB, 0.16808983E-06_JPRB, 0.16910305E-06_JPRB, &
  & 0.17052700E-06_JPRB, 0.17210323E-06_JPRB, 0.17361854E-06_JPRB, 0.17503179E-06_JPRB, 0.17638825E-06_JPRB, 0.17770684E-06_JPRB, &
  & 0.17900486E-06_JPRB, 0.18024279E-06_JPRB, 0.18126754E-06_JPRB, 0.18203466E-06_JPRB, 0.18265363E-06_JPRB, 0.18322321E-06_JPRB, &
  & 0.18376974E-06_JPRB, 0.18426195E-06_JPRB, 0.18445126E-06_JPRB, 0.18417388E-06_JPRB  /)

RGHG2(:, 4, 7) = (/ &
  & 0.20203344E-06_JPRB, 0.20204239E-06_JPRB, 0.20186413E-06_JPRB, 0.20129300E-06_JPRB, 0.20081959E-06_JPRB, 0.20040026E-06_JPRB, &
  & 0.20003722E-06_JPRB, 0.19974675E-06_JPRB, 0.19946144E-06_JPRB, 0.19913721E-06_JPRB, 0.19881211E-06_JPRB, 0.19846858E-06_JPRB, &
  & 0.19806236E-06_JPRB, 0.19750997E-06_JPRB, 0.19685469E-06_JPRB, 0.19622051E-06_JPRB, 0.19562430E-06_JPRB, 0.19519187E-06_JPRB, &
  & 0.19488159E-06_JPRB, 0.19485911E-06_JPRB, 0.19488436E-06_JPRB, 0.19486725E-06_JPRB, 0.19458245E-06_JPRB, 0.19388831E-06_JPRB, &
  & 0.19298482E-06_JPRB, 0.19184939E-06_JPRB, 0.19048686E-06_JPRB, 0.18868238E-06_JPRB, 0.18642199E-06_JPRB, 0.18408142E-06_JPRB, &
  & 0.18180730E-06_JPRB, 0.17974772E-06_JPRB, 0.17794923E-06_JPRB, 0.17630881E-06_JPRB, 0.17476417E-06_JPRB, 0.17319423E-06_JPRB, &
  & 0.17175777E-06_JPRB, 0.17057734E-06_JPRB, 0.16992832E-06_JPRB, 0.16946941E-06_JPRB, 0.16897631E-06_JPRB, 0.16852566E-06_JPRB, &
  & 0.16798742E-06_JPRB, 0.16751586E-06_JPRB, 0.16736093E-06_JPRB, 0.16754806E-06_JPRB, 0.16808861E-06_JPRB, 0.16908933E-06_JPRB, &
  & 0.17050305E-06_JPRB, 0.17207321E-06_JPRB, 0.17358650E-06_JPRB, 0.17500055E-06_JPRB, 0.17636035E-06_JPRB, 0.17768260E-06_JPRB, &
  & 0.17898321E-06_JPRB, 0.18022296E-06_JPRB, 0.18124935E-06_JPRB, 0.18201765E-06_JPRB, 0.18263667E-06_JPRB, 0.18320496E-06_JPRB, &
  & 0.18374910E-06_JPRB, 0.18423841E-06_JPRB, 0.18442471E-06_JPRB, 0.18414577E-06_JPRB  /)

RGHG2(:, 5, 7) = (/ &
  & 0.20176442E-06_JPRB, 0.20176857E-06_JPRB, 0.20160683E-06_JPRB, 0.20115769E-06_JPRB, 0.20075608E-06_JPRB, 0.20039715E-06_JPRB, &
  & 0.20007015E-06_JPRB, 0.19982296E-06_JPRB, 0.19959113E-06_JPRB, 0.19930926E-06_JPRB, 0.19902381E-06_JPRB, 0.19870553E-06_JPRB, &
  & 0.19835639E-06_JPRB, 0.19787792E-06_JPRB, 0.19733531E-06_JPRB, 0.19687749E-06_JPRB, 0.19650182E-06_JPRB, 0.19628901E-06_JPRB, &
  & 0.19621459E-06_JPRB, 0.19633603E-06_JPRB, 0.19650520E-06_JPRB, 0.19661337E-06_JPRB, 0.19648451E-06_JPRB, 0.19601181E-06_JPRB, &
  & 0.19531623E-06_JPRB, 0.19439682E-06_JPRB, 0.19325393E-06_JPRB, 0.19174991E-06_JPRB, 0.18987139E-06_JPRB, 0.18793613E-06_JPRB, &
  & 0.18601775E-06_JPRB, 0.18418321E-06_JPRB, 0.18238292E-06_JPRB, 0.18050845E-06_JPRB, 0.17850952E-06_JPRB, 0.17641709E-06_JPRB, &
  & 0.17446505E-06_JPRB, 0.17281020E-06_JPRB, 0.17182858E-06_JPRB, 0.17127052E-06_JPRB, 0.17073506E-06_JPRB, 0.17014740E-06_JPRB, &
  & 0.16945593E-06_JPRB, 0.16879207E-06_JPRB, 0.16831596E-06_JPRB, 0.16804790E-06_JPRB, 0.16803112E-06_JPRB, 0.16843814E-06_JPRB, &
  & 0.16936602E-06_JPRB, 0.17064834E-06_JPRB, 0.17206579E-06_JPRB, 0.17351770E-06_JPRB, 0.17503644E-06_JPRB, 0.17653174E-06_JPRB, &
  & 0.17795554E-06_JPRB, 0.17928152E-06_JPRB, 0.18038573E-06_JPRB, 0.18120991E-06_JPRB, 0.18183164E-06_JPRB, 0.18233894E-06_JPRB, &
  & 0.18276920E-06_JPRB, 0.18312121E-06_JPRB, 0.18316419E-06_JPRB, 0.18281134E-06_JPRB  /)

RGHG2(:, 6, 7) = (/ &
  & 0.20136080E-06_JPRB, 0.20135773E-06_JPRB, 0.20122079E-06_JPRB, 0.20095466E-06_JPRB, 0.20066080E-06_JPRB, 0.20039247E-06_JPRB, &
  & 0.20011957E-06_JPRB, 0.19993729E-06_JPRB, 0.19978570E-06_JPRB, 0.19956739E-06_JPRB, 0.19934145E-06_JPRB, 0.19906103E-06_JPRB, &
  & 0.19879754E-06_JPRB, 0.19842996E-06_JPRB, 0.19805640E-06_JPRB, 0.19786319E-06_JPRB, 0.19781839E-06_JPRB, 0.19793511E-06_JPRB, &
  & 0.19821456E-06_JPRB, 0.19855192E-06_JPRB, 0.19893702E-06_JPRB, 0.19923317E-06_JPRB, 0.19933827E-06_JPRB, 0.19919779E-06_JPRB, &
  & 0.19881416E-06_JPRB, 0.19821887E-06_JPRB, 0.19740550E-06_JPRB, 0.19635226E-06_JPRB, 0.19504669E-06_JPRB, 0.19371955E-06_JPRB, &
  & 0.19233490E-06_JPRB, 0.19083800E-06_JPRB, 0.18903500E-06_JPRB, 0.18680936E-06_JPRB, 0.18412885E-06_JPRB, 0.18125250E-06_JPRB, &
  & 0.17852691E-06_JPRB, 0.17616027E-06_JPRB, 0.17467963E-06_JPRB, 0.17397281E-06_JPRB, 0.17337379E-06_JPRB, 0.17258057E-06_JPRB, &
  & 0.17165920E-06_JPRB, 0.17070684E-06_JPRB, 0.16974884E-06_JPRB, 0.16879784E-06_JPRB, 0.16794485E-06_JPRB, 0.16746112E-06_JPRB, &
  & 0.16766008E-06_JPRB, 0.16851055E-06_JPRB, 0.16978419E-06_JPRB, 0.17129290E-06_JPRB, 0.17305011E-06_JPRB, 0.17480506E-06_JPRB, &
  & 0.17641369E-06_JPRB, 0.17786904E-06_JPRB, 0.17909000E-06_JPRB, 0.17999803E-06_JPRB, 0.18062381E-06_JPRB, 0.18103961E-06_JPRB, &
  & 0.18129902E-06_JPRB, 0.18144502E-06_JPRB, 0.18127297E-06_JPRB, 0.18080923E-06_JPRB  /)

RGHG2(:, 7, 7) = (/ &
  & 0.20130361E-06_JPRB, 0.20126349E-06_JPRB, 0.20121296E-06_JPRB, 0.20107990E-06_JPRB, 0.20090405E-06_JPRB, 0.20067872E-06_JPRB, &
  & 0.20049392E-06_JPRB, 0.20041519E-06_JPRB, 0.20041053E-06_JPRB, 0.20037736E-06_JPRB, 0.20038534E-06_JPRB, 0.20037119E-06_JPRB, &
  & 0.20042206E-06_JPRB, 0.20036839E-06_JPRB, 0.20045400E-06_JPRB, 0.20086399E-06_JPRB, 0.20147624E-06_JPRB, 0.20221947E-06_JPRB, &
  & 0.20301839E-06_JPRB, 0.20381043E-06_JPRB, 0.20454939E-06_JPRB, 0.20503128E-06_JPRB, 0.20524650E-06_JPRB, 0.20529576E-06_JPRB, &
  & 0.20518222E-06_JPRB, 0.20491332E-06_JPRB, 0.20458965E-06_JPRB, 0.20430502E-06_JPRB, 0.20414429E-06_JPRB, 0.20413117E-06_JPRB, &
  & 0.20446634E-06_JPRB, 0.20480991E-06_JPRB, 0.20441371E-06_JPRB, 0.20274805E-06_JPRB, 0.19978691E-06_JPRB, 0.19595929E-06_JPRB, &
  & 0.19174185E-06_JPRB, 0.18758580E-06_JPRB, 0.18432866E-06_JPRB, 0.18258701E-06_JPRB, 0.18147882E-06_JPRB, 0.18011260E-06_JPRB, &
  & 0.17853394E-06_JPRB, 0.17693891E-06_JPRB, 0.17507458E-06_JPRB, 0.17286245E-06_JPRB, 0.17047146E-06_JPRB, 0.16831837E-06_JPRB, &
  & 0.16710397E-06_JPRB, 0.16700446E-06_JPRB, 0.16785140E-06_JPRB, 0.16929739E-06_JPRB, 0.17125436E-06_JPRB, 0.17342457E-06_JPRB, &
  & 0.17549363E-06_JPRB, 0.17735867E-06_JPRB, 0.17889851E-06_JPRB, 0.17988251E-06_JPRB, 0.18030212E-06_JPRB, 0.18031887E-06_JPRB, &
  & 0.18011885E-06_JPRB, 0.17987025E-06_JPRB, 0.17945761E-06_JPRB, 0.17898392E-06_JPRB  /)

RGHG2(:, 8, 7) = (/ &
  & 0.20225930E-06_JPRB, 0.20218307E-06_JPRB, 0.20218856E-06_JPRB, 0.20211348E-06_JPRB, 0.20200910E-06_JPRB, 0.20182622E-06_JPRB, &
  & 0.20173866E-06_JPRB, 0.20182388E-06_JPRB, 0.20205323E-06_JPRB, 0.20238590E-06_JPRB, 0.20295293E-06_JPRB, 0.20352398E-06_JPRB, &
  & 0.20411820E-06_JPRB, 0.20475412E-06_JPRB, 0.20578061E-06_JPRB, 0.20728135E-06_JPRB, 0.20896555E-06_JPRB, 0.21047885E-06_JPRB, &
  & 0.21194539E-06_JPRB, 0.21328933E-06_JPRB, 0.21454496E-06_JPRB, 0.21539520E-06_JPRB, 0.21579479E-06_JPRB, 0.21602822E-06_JPRB, &
  & 0.21613364E-06_JPRB, 0.21604764E-06_JPRB, 0.21615762E-06_JPRB, 0.21681815E-06_JPRB, 0.21827657E-06_JPRB, 0.22053392E-06_JPRB, &
  & 0.22407483E-06_JPRB, 0.22807096E-06_JPRB, 0.23093717E-06_JPRB, 0.23154403E-06_JPRB, 0.22932525E-06_JPRB, 0.22498343E-06_JPRB, &
  & 0.21909098E-06_JPRB, 0.21226729E-06_JPRB, 0.20572758E-06_JPRB, 0.20132213E-06_JPRB, 0.19846205E-06_JPRB, 0.19543586E-06_JPRB, &
  & 0.19203238E-06_JPRB, 0.18845430E-06_JPRB, 0.18447777E-06_JPRB, 0.18006432E-06_JPRB, 0.17539241E-06_JPRB, 0.17095827E-06_JPRB, &
  & 0.16794813E-06_JPRB, 0.16669365E-06_JPRB, 0.16700514E-06_JPRB, 0.16834196E-06_JPRB, 0.17045010E-06_JPRB, 0.17300904E-06_JPRB, &
  & 0.17570570E-06_JPRB, 0.17831065E-06_JPRB, 0.18045444E-06_JPRB, 0.18152876E-06_JPRB, 0.18144691E-06_JPRB, 0.18061085E-06_JPRB, &
  & 0.17959152E-06_JPRB, 0.17866375E-06_JPRB, 0.17777747E-06_JPRB, 0.17712048E-06_JPRB  /)

RGHG2(:, 9, 7) = (/ &
  & 0.20530043E-06_JPRB, 0.20524051E-06_JPRB, 0.20525249E-06_JPRB, 0.20521182E-06_JPRB, 0.20515176E-06_JPRB, 0.20501592E-06_JPRB, &
  & 0.20501113E-06_JPRB, 0.20528449E-06_JPRB, 0.20582545E-06_JPRB, 0.20677982E-06_JPRB, 0.20837595E-06_JPRB, 0.20991652E-06_JPRB, &
  & 0.21148097E-06_JPRB, 0.21330038E-06_JPRB, 0.21580732E-06_JPRB, 0.21898566E-06_JPRB, 0.22201994E-06_JPRB, 0.22445747E-06_JPRB, &
  & 0.22657186E-06_JPRB, 0.22845101E-06_JPRB, 0.23036476E-06_JPRB, 0.23185369E-06_JPRB, 0.23263757E-06_JPRB, 0.23312059E-06_JPRB, &
  & 0.23352195E-06_JPRB, 0.23375131E-06_JPRB, 0.23446134E-06_JPRB, 0.23655464E-06_JPRB, 0.24052210E-06_JPRB, 0.24655985E-06_JPRB, &
  & 0.25543219E-06_JPRB, 0.26556824E-06_JPRB, 0.27413567E-06_JPRB, 0.27922023E-06_JPRB, 0.27946511E-06_JPRB, 0.27582318E-06_JPRB, &
  & 0.26873843E-06_JPRB, 0.25847843E-06_JPRB, 0.24710334E-06_JPRB, 0.23779677E-06_JPRB, 0.23069595E-06_JPRB, 0.22332579E-06_JPRB, &
  & 0.21519614E-06_JPRB, 0.20670376E-06_JPRB, 0.19815917E-06_JPRB, 0.18989867E-06_JPRB, 0.18196892E-06_JPRB, 0.17488135E-06_JPRB, &
  & 0.17016934E-06_JPRB, 0.16811235E-06_JPRB, 0.16823374E-06_JPRB, 0.16958794E-06_JPRB, 0.17169204E-06_JPRB, 0.17433948E-06_JPRB, &
  & 0.17751952E-06_JPRB, 0.18105609E-06_JPRB, 0.18416158E-06_JPRB, 0.18549244E-06_JPRB, 0.18474784E-06_JPRB, 0.18266981E-06_JPRB, &
  & 0.18037354E-06_JPRB, 0.17822848E-06_JPRB, 0.17626002E-06_JPRB, 0.17484121E-06_JPRB  /)

RGHG2(:,10, 7) = (/ &
  & 0.21066674E-06_JPRB, 0.21073782E-06_JPRB, 0.21083827E-06_JPRB, 0.21098355E-06_JPRB, 0.21110523E-06_JPRB, 0.21109389E-06_JPRB, &
  & 0.21119087E-06_JPRB, 0.21170149E-06_JPRB, 0.21271526E-06_JPRB, 0.21462732E-06_JPRB, 0.21770033E-06_JPRB, 0.22077871E-06_JPRB, &
  & 0.22405136E-06_JPRB, 0.22758520E-06_JPRB, 0.23191343E-06_JPRB, 0.23702387E-06_JPRB, 0.24134365E-06_JPRB, 0.24466699E-06_JPRB, &
  & 0.24728708E-06_JPRB, 0.24973920E-06_JPRB, 0.25195319E-06_JPRB, 0.25382293E-06_JPRB, 0.25516728E-06_JPRB, 0.25618111E-06_JPRB, &
  & 0.25736774E-06_JPRB, 0.25862730E-06_JPRB, 0.26074727E-06_JPRB, 0.26538998E-06_JPRB, 0.27382666E-06_JPRB, 0.28612930E-06_JPRB, &
  & 0.30255931E-06_JPRB, 0.32119855E-06_JPRB, 0.33795755E-06_JPRB, 0.34954953E-06_JPRB, 0.35430057E-06_JPRB, 0.35283166E-06_JPRB, &
  & 0.34535127E-06_JPRB, 0.33175627E-06_JPRB, 0.31511079E-06_JPRB, 0.29909928E-06_JPRB, 0.28403366E-06_JPRB, 0.26737150E-06_JPRB, &
  & 0.24936127E-06_JPRB, 0.23108357E-06_JPRB, 0.21393313E-06_JPRB, 0.19924326E-06_JPRB, 0.18708790E-06_JPRB, 0.17791542E-06_JPRB, &
  & 0.17292169E-06_JPRB, 0.17163006E-06_JPRB, 0.17266645E-06_JPRB, 0.17431335E-06_JPRB, 0.17600400E-06_JPRB, 0.17799463E-06_JPRB, &
  & 0.18078459E-06_JPRB, 0.18471506E-06_JPRB, 0.18894801E-06_JPRB, 0.19104474E-06_JPRB, 0.19017239E-06_JPRB, 0.18725638E-06_JPRB, &
  & 0.18363890E-06_JPRB, 0.17985656E-06_JPRB, 0.17625445E-06_JPRB, 0.17356034E-06_JPRB  /)

RGHG2(:,11, 7) = (/ &
  & 0.21672626E-06_JPRB, 0.21710612E-06_JPRB, 0.21749325E-06_JPRB, 0.21800859E-06_JPRB, 0.21852126E-06_JPRB, 0.21890687E-06_JPRB, &
  & 0.21936521E-06_JPRB, 0.22039530E-06_JPRB, 0.22241738E-06_JPRB, 0.22597589E-06_JPRB, 0.23101374E-06_JPRB, 0.23683206E-06_JPRB, &
  & 0.24285941E-06_JPRB, 0.24901942E-06_JPRB, 0.25554600E-06_JPRB, 0.26233600E-06_JPRB, 0.26803967E-06_JPRB, 0.27189825E-06_JPRB, &
  & 0.27462959E-06_JPRB, 0.27677544E-06_JPRB, 0.27795827E-06_JPRB, 0.27893700E-06_JPRB, 0.28062942E-06_JPRB, 0.28273429E-06_JPRB, &
  & 0.28541488E-06_JPRB, 0.28823583E-06_JPRB, 0.29249301E-06_JPRB, 0.30105267E-06_JPRB, 0.31704444E-06_JPRB, 0.33926284E-06_JPRB, &
  & 0.36545234E-06_JPRB, 0.39380331E-06_JPRB, 0.41987046E-06_JPRB, 0.43871238E-06_JPRB, 0.44889789E-06_JPRB, 0.44984852E-06_JPRB, &
  & 0.44188582E-06_JPRB, 0.42629064E-06_JPRB, 0.40593154E-06_JPRB, 0.38335488E-06_JPRB, 0.35756124E-06_JPRB, 0.32671230E-06_JPRB, &
  & 0.29327333E-06_JPRB, 0.25972160E-06_JPRB, 0.22938054E-06_JPRB, 0.20572467E-06_JPRB, 0.18978908E-06_JPRB, 0.18085044E-06_JPRB, &
  & 0.17849983E-06_JPRB, 0.18026591E-06_JPRB, 0.18319869E-06_JPRB, 0.18497557E-06_JPRB, 0.18529996E-06_JPRB, 0.18543686E-06_JPRB, &
  & 0.18651808E-06_JPRB, 0.18940887E-06_JPRB, 0.19427107E-06_JPRB, 0.19802712E-06_JPRB, 0.19860166E-06_JPRB, 0.19651353E-06_JPRB, &
  & 0.19290788E-06_JPRB, 0.18842036E-06_JPRB, 0.18389747E-06_JPRB, 0.18055872E-06_JPRB  /)

RGHG2(:,12, 7) = (/ &
  & 0.22492876E-06_JPRB, 0.22557087E-06_JPRB, 0.22622876E-06_JPRB, 0.22707761E-06_JPRB, 0.22798760E-06_JPRB, 0.22874277E-06_JPRB, &
  & 0.22973854E-06_JPRB, 0.23160779E-06_JPRB, 0.23534363E-06_JPRB, 0.24182577E-06_JPRB, 0.25009270E-06_JPRB, 0.26013032E-06_JPRB, &
  & 0.27053251E-06_JPRB, 0.28109817E-06_JPRB, 0.29091196E-06_JPRB, 0.29955174E-06_JPRB, 0.30698935E-06_JPRB, 0.31125795E-06_JPRB, &
  & 0.31256528E-06_JPRB, 0.31149850E-06_JPRB, 0.30981535E-06_JPRB, 0.30905034E-06_JPRB, 0.31026126E-06_JPRB, 0.31321328E-06_JPRB, &
  & 0.31757190E-06_JPRB, 0.32264645E-06_JPRB, 0.32980191E-06_JPRB, 0.34407056E-06_JPRB, 0.36971535E-06_JPRB, 0.40449728E-06_JPRB, &
  & 0.44394199E-06_JPRB, 0.48250639E-06_JPRB, 0.51443767E-06_JPRB, 0.53703642E-06_JPRB, 0.54994061E-06_JPRB, 0.55193221E-06_JPRB, &
  & 0.54309613E-06_JPRB, 0.52665330E-06_JPRB, 0.50429391E-06_JPRB, 0.47668123E-06_JPRB, 0.44134959E-06_JPRB, 0.39621416E-06_JPRB, &
  & 0.34465675E-06_JPRB, 0.29265031E-06_JPRB, 0.24715514E-06_JPRB, 0.21476628E-06_JPRB, 0.19749093E-06_JPRB, 0.19136592E-06_JPRB, &
  & 0.19333633E-06_JPRB, 0.19869627E-06_JPRB, 0.20331941E-06_JPRB, 0.20462381E-06_JPRB, 0.20225147E-06_JPRB, 0.19938359E-06_JPRB, &
  & 0.19856248E-06_JPRB, 0.19980408E-06_JPRB, 0.20417248E-06_JPRB, 0.20978221E-06_JPRB, 0.21374950E-06_JPRB, 0.21487986E-06_JPRB, &
  & 0.21377278E-06_JPRB, 0.21073364E-06_JPRB, 0.20655039E-06_JPRB, 0.20320627E-06_JPRB  /)

RGHG2(:,13, 7) = (/ &
  & 0.23859282E-06_JPRB, 0.23916071E-06_JPRB, 0.23990277E-06_JPRB, 0.24103791E-06_JPRB, 0.24205303E-06_JPRB, 0.24272507E-06_JPRB, &
  & 0.24399580E-06_JPRB, 0.24713878E-06_JPRB, 0.25346600E-06_JPRB, 0.26428837E-06_JPRB, 0.27765261E-06_JPRB, 0.29328913E-06_JPRB, &
  & 0.31054757E-06_JPRB, 0.32798285E-06_JPRB, 0.34335640E-06_JPRB, 0.35531710E-06_JPRB, 0.36427911E-06_JPRB, 0.36731945E-06_JPRB, &
  & 0.36476684E-06_JPRB, 0.35962082E-06_JPRB, 0.35487275E-06_JPRB, 0.35222993E-06_JPRB, 0.35188370E-06_JPRB, 0.35413632E-06_JPRB, &
  & 0.35934311E-06_JPRB, 0.36697234E-06_JPRB, 0.37910617E-06_JPRB, 0.40205268E-06_JPRB, 0.43792801E-06_JPRB, 0.48686074E-06_JPRB, &
  & 0.54161184E-06_JPRB, 0.58759876E-06_JPRB, 0.61826874E-06_JPRB, 0.63753953E-06_JPRB, 0.64790297E-06_JPRB, 0.64936462E-06_JPRB, &
  & 0.64015580E-06_JPRB, 0.62246590E-06_JPRB, 0.59636330E-06_JPRB, 0.56239938E-06_JPRB, 0.51967885E-06_JPRB, 0.46424677E-06_JPRB, &
  & 0.39762117E-06_JPRB, 0.32925419E-06_JPRB, 0.27136178E-06_JPRB, 0.23307029E-06_JPRB, 0.21591006E-06_JPRB, 0.21264073E-06_JPRB, &
  & 0.21782972E-06_JPRB, 0.22533515E-06_JPRB, 0.23076301E-06_JPRB, 0.23114865E-06_JPRB, 0.22528530E-06_JPRB, 0.21867962E-06_JPRB, &
  & 0.21666156E-06_JPRB, 0.21746907E-06_JPRB, 0.22115222E-06_JPRB, 0.22717564E-06_JPRB, 0.23428561E-06_JPRB, 0.23901865E-06_JPRB, &
  & 0.24083610E-06_JPRB, 0.24077116E-06_JPRB, 0.23852423E-06_JPRB, 0.23565505E-06_JPRB  /)

RGHG2(:,14, 7) = (/ &
  & 0.25372425E-06_JPRB, 0.25453152E-06_JPRB, 0.25549755E-06_JPRB, 0.25717180E-06_JPRB, 0.25832573E-06_JPRB, 0.25916007E-06_JPRB, &
  & 0.26105117E-06_JPRB, 0.26626705E-06_JPRB, 0.27654371E-06_JPRB, 0.29327989E-06_JPRB, 0.31364466E-06_JPRB, 0.33736683E-06_JPRB, &
  & 0.36494769E-06_JPRB, 0.39279808E-06_JPRB, 0.41663306E-06_JPRB, 0.43397185E-06_JPRB, 0.44392471E-06_JPRB, 0.44439134E-06_JPRB, &
  & 0.43724698E-06_JPRB, 0.42936252E-06_JPRB, 0.42355437E-06_JPRB, 0.42022952E-06_JPRB, 0.41917261E-06_JPRB, 0.42101633E-06_JPRB, &
  & 0.42733132E-06_JPRB, 0.43735537E-06_JPRB, 0.45444400E-06_JPRB, 0.48444292E-06_JPRB, 0.52930595E-06_JPRB, 0.59162023E-06_JPRB, &
  & 0.65944802E-06_JPRB, 0.70701898E-06_JPRB, 0.72947857E-06_JPRB, 0.73905626E-06_JPRB, 0.74354928E-06_JPRB, 0.74364374E-06_JPRB, &
  & 0.73408024E-06_JPRB, 0.71150015E-06_JPRB, 0.67644762E-06_JPRB, 0.63231477E-06_JPRB, 0.58067099E-06_JPRB, 0.51735850E-06_JPRB, &
  & 0.44339732E-06_JPRB, 0.36636904E-06_JPRB, 0.30087869E-06_JPRB, 0.25925843E-06_JPRB, 0.24202939E-06_JPRB, 0.23973144E-06_JPRB, &
  & 0.24559260E-06_JPRB, 0.25304275E-06_JPRB, 0.25834817E-06_JPRB, 0.25787382E-06_JPRB, 0.24927616E-06_JPRB, 0.23890070E-06_JPRB, &
  & 0.23488676E-06_JPRB, 0.23619227E-06_JPRB, 0.24051956E-06_JPRB, 0.24701237E-06_JPRB, 0.25447144E-06_JPRB, 0.25927134E-06_JPRB, &
  & 0.26160454E-06_JPRB, 0.26307700E-06_JPRB, 0.26272471E-06_JPRB, 0.25964411E-06_JPRB  /)

RGHG2(:,15, 7) = (/ &
  & 0.26479302E-06_JPRB, 0.26557041E-06_JPRB, 0.26755403E-06_JPRB, 0.27023150E-06_JPRB, 0.27216471E-06_JPRB, 0.27420325E-06_JPRB, &
  & 0.27806402E-06_JPRB, 0.28637298E-06_JPRB, 0.30170717E-06_JPRB, 0.32591742E-06_JPRB, 0.35592094E-06_JPRB, 0.39221700E-06_JPRB, &
  & 0.43421908E-06_JPRB, 0.47703726E-06_JPRB, 0.51224487E-06_JPRB, 0.53611730E-06_JPRB, 0.54924062E-06_JPRB, 0.54948103E-06_JPRB, &
  & 0.54068539E-06_JPRB, 0.53208386E-06_JPRB, 0.52728030E-06_JPRB, 0.52561327E-06_JPRB, 0.52771598E-06_JPRB, 0.53325701E-06_JPRB, &
  & 0.54324747E-06_JPRB, 0.55781257E-06_JPRB, 0.57956335E-06_JPRB, 0.60951047E-06_JPRB, 0.65403025E-06_JPRB, 0.71834402E-06_JPRB, &
  & 0.78577124E-06_JPRB, 0.82637635E-06_JPRB, 0.83900882E-06_JPRB, 0.83961219E-06_JPRB, 0.83852062E-06_JPRB, 0.83666688E-06_JPRB, &
  & 0.82379304E-06_JPRB, 0.79189724E-06_JPRB, 0.74309627E-06_JPRB, 0.68473993E-06_JPRB, 0.61953843E-06_JPRB, 0.55043664E-06_JPRB, &
  & 0.47879739E-06_JPRB, 0.40096158E-06_JPRB, 0.33222157E-06_JPRB, 0.28978915E-06_JPRB, 0.27286219E-06_JPRB, 0.26999506E-06_JPRB, &
  & 0.27370791E-06_JPRB, 0.27869746E-06_JPRB, 0.28295918E-06_JPRB, 0.28225857E-06_JPRB, 0.27303769E-06_JPRB, 0.26040077E-06_JPRB, &
  & 0.25269388E-06_JPRB, 0.25329975E-06_JPRB, 0.25971952E-06_JPRB, 0.26803648E-06_JPRB, 0.27380033E-06_JPRB, 0.27630722E-06_JPRB, &
  & 0.27764231E-06_JPRB, 0.27793253E-06_JPRB, 0.27625713E-06_JPRB, 0.27110916E-06_JPRB  /)

RGHG2(:,16, 7) = (/ &
  & 0.27275500E-06_JPRB, 0.27374838E-06_JPRB, 0.27740194E-06_JPRB, 0.28068921E-06_JPRB, 0.28335764E-06_JPRB, 0.28694523E-06_JPRB, &
  & 0.29398885E-06_JPRB, 0.30644689E-06_JPRB, 0.32725857E-06_JPRB, 0.36013361E-06_JPRB, 0.40316117E-06_JPRB, 0.45675266E-06_JPRB, &
  & 0.51653296E-06_JPRB, 0.57717144E-06_JPRB, 0.62724050E-06_JPRB, 0.66018728E-06_JPRB, 0.67884592E-06_JPRB, 0.68267446E-06_JPRB, &
  & 0.67684061E-06_JPRB, 0.66931293E-06_JPRB, 0.66728472E-06_JPRB, 0.67151441E-06_JPRB, 0.68243856E-06_JPRB, 0.69870218E-06_JPRB, &
  & 0.71796404E-06_JPRB, 0.73983403E-06_JPRB, 0.76531514E-06_JPRB, 0.79316047E-06_JPRB, 0.82605543E-06_JPRB, 0.86833405E-06_JPRB, &
  & 0.90931112E-06_JPRB, 0.93288822E-06_JPRB, 0.93822020E-06_JPRB, 0.93546583E-06_JPRB, 0.93164387E-06_JPRB, 0.92648338E-06_JPRB, &
  & 0.90558399E-06_JPRB, 0.86092690E-06_JPRB, 0.79805355E-06_JPRB, 0.72171355E-06_JPRB, 0.64110315E-06_JPRB, 0.57055463E-06_JPRB, &
  & 0.50671590E-06_JPRB, 0.43312816E-06_JPRB, 0.36439794E-06_JPRB, 0.32356945E-06_JPRB, 0.30812388E-06_JPRB, 0.30367580E-06_JPRB, &
  & 0.30294490E-06_JPRB, 0.30335636E-06_JPRB, 0.30535314E-06_JPRB, 0.30444868E-06_JPRB, 0.29652059E-06_JPRB, 0.28388573E-06_JPRB, &
  & 0.27354924E-06_JPRB, 0.27221328E-06_JPRB, 0.27944487E-06_JPRB, 0.28754376E-06_JPRB, 0.29103533E-06_JPRB, 0.29195725E-06_JPRB, &
  & 0.29395415E-06_JPRB, 0.29374647E-06_JPRB, 0.28802130E-06_JPRB, 0.27900942E-06_JPRB  /)

RGHG2(:,17, 7) = (/ &
  & 0.28237483E-06_JPRB, 0.28416490E-06_JPRB, 0.28839784E-06_JPRB, 0.29181080E-06_JPRB, 0.29549822E-06_JPRB, 0.30137792E-06_JPRB, &
  & 0.31095713E-06_JPRB, 0.32759163E-06_JPRB, 0.35404766E-06_JPRB, 0.39589966E-06_JPRB, 0.45457489E-06_JPRB, 0.52751493E-06_JPRB, &
  & 0.60671729E-06_JPRB, 0.68484141E-06_JPRB, 0.74989641E-06_JPRB, 0.79340739E-06_JPRB, 0.81867972E-06_JPRB, 0.82832973E-06_JPRB, &
  & 0.82820434E-06_JPRB, 0.82425147E-06_JPRB, 0.82564557E-06_JPRB, 0.83864482E-06_JPRB, 0.86088928E-06_JPRB, 0.88818687E-06_JPRB, &
  & 0.92019700E-06_JPRB, 0.95342576E-06_JPRB, 0.98492013E-06_JPRB, 0.10115468E-05_JPRB, 0.10263329E-05_JPRB, 0.10312011E-05_JPRB, &
  & 0.10338060E-05_JPRB, 0.10342022E-05_JPRB, 0.10316379E-05_JPRB, 0.10279319E-05_JPRB, 0.10226759E-05_JPRB, 0.10095114E-05_JPRB, &
  & 0.97497755E-06_JPRB, 0.91659516E-06_JPRB, 0.84184303E-06_JPRB, 0.74837676E-06_JPRB, 0.65472440E-06_JPRB, 0.58627395E-06_JPRB, &
  & 0.53253958E-06_JPRB, 0.46501737E-06_JPRB, 0.39905720E-06_JPRB, 0.36150391E-06_JPRB, 0.34696382E-06_JPRB, 0.33997170E-06_JPRB, &
  & 0.33411669E-06_JPRB, 0.32910470E-06_JPRB, 0.32744579E-06_JPRB, 0.32600272E-06_JPRB, 0.31983791E-06_JPRB, 0.30807864E-06_JPRB, &
  & 0.29813376E-06_JPRB, 0.29504565E-06_JPRB, 0.29965285E-06_JPRB, 0.30496755E-06_JPRB, 0.30622300E-06_JPRB, 0.30720008E-06_JPRB, &
  & 0.31141043E-06_JPRB, 0.31140502E-06_JPRB, 0.30195184E-06_JPRB, 0.28925579E-06_JPRB  /)

RGHG2(:,18, 7) = (/ &
  & 0.30264030E-06_JPRB, 0.30422899E-06_JPRB, 0.30651178E-06_JPRB, 0.30979224E-06_JPRB, 0.31500640E-06_JPRB, 0.32330618E-06_JPRB, &
  & 0.33476585E-06_JPRB, 0.35390538E-06_JPRB, 0.38479748E-06_JPRB, 0.43473722E-06_JPRB, 0.50793338E-06_JPRB, 0.59845841E-06_JPRB, &
  & 0.69590859E-06_JPRB, 0.78883567E-06_JPRB, 0.86380774E-06_JPRB, 0.91553549E-06_JPRB, 0.94797942E-06_JPRB, 0.96365564E-06_JPRB, &
  & 0.96963925E-06_JPRB, 0.96975262E-06_JPRB, 0.97485530E-06_JPRB, 0.99234035E-06_JPRB, 0.10188941E-05_JPRB, 0.10547985E-05_JPRB, &
  & 0.11010324E-05_JPRB, 0.11466171E-05_JPRB, 0.11862911E-05_JPRB, 0.12087438E-05_JPRB, 0.12051360E-05_JPRB, 0.11841112E-05_JPRB, &
  & 0.11608242E-05_JPRB, 0.11425286E-05_JPRB, 0.11294305E-05_JPRB, 0.11197470E-05_JPRB, 0.11069768E-05_JPRB, 0.10804653E-05_JPRB, &
  & 0.10299505E-05_JPRB, 0.95878454E-06_JPRB, 0.87215852E-06_JPRB, 0.76501870E-06_JPRB, 0.66417061E-06_JPRB, 0.60142421E-06_JPRB, &
  & 0.55589685E-06_JPRB, 0.49454933E-06_JPRB, 0.43608398E-06_JPRB, 0.40274421E-06_JPRB, 0.38870024E-06_JPRB, 0.37918291E-06_JPRB, &
  & 0.36836905E-06_JPRB, 0.35812262E-06_JPRB, 0.35287090E-06_JPRB, 0.35105894E-06_JPRB, 0.34623756E-06_JPRB, 0.33558046E-06_JPRB, &
  & 0.32718333E-06_JPRB, 0.32267767E-06_JPRB, 0.32429233E-06_JPRB, 0.32718966E-06_JPRB, 0.32613322E-06_JPRB, 0.32594424E-06_JPRB, &
  & 0.32948400E-06_JPRB, 0.32963343E-06_JPRB, 0.32165547E-06_JPRB, 0.31144304E-06_JPRB  /)

RGHG2(:,19, 7) = (/ &
  & 0.34100147E-06_JPRB, 0.34135145E-06_JPRB, 0.34197792E-06_JPRB, 0.34441167E-06_JPRB, 0.34964357E-06_JPRB, 0.35823363E-06_JPRB, &
  & 0.37059939E-06_JPRB, 0.39071213E-06_JPRB, 0.42391133E-06_JPRB, 0.47944395E-06_JPRB, 0.56201822E-06_JPRB, 0.66572031E-06_JPRB, &
  & 0.77658327E-06_JPRB, 0.87896111E-06_JPRB, 0.95914101E-06_JPRB, 0.10143001E-05_JPRB, 0.10496099E-05_JPRB, 0.10701218E-05_JPRB, &
  & 0.10808851E-05_JPRB, 0.10845835E-05_JPRB, 0.10909934E-05_JPRB, 0.11075228E-05_JPRB, 0.11341488E-05_JPRB, 0.11759027E-05_JPRB, &
  & 0.12312690E-05_JPRB, 0.12850916E-05_JPRB, 0.13327700E-05_JPRB, 0.13539302E-05_JPRB, 0.13462421E-05_JPRB, 0.13213993E-05_JPRB, &
  & 0.12887912E-05_JPRB, 0.12578105E-05_JPRB, 0.12309706E-05_JPRB, 0.12065589E-05_JPRB, 0.11772132E-05_JPRB, 0.11334463E-05_JPRB, &
  & 0.10684211E-05_JPRB, 0.98675025E-06_JPRB, 0.88700668E-06_JPRB, 0.76958697E-06_JPRB, 0.67182591E-06_JPRB, 0.61571298E-06_JPRB, &
  & 0.57392469E-06_JPRB, 0.52078671E-06_JPRB, 0.47235239E-06_JPRB, 0.44444583E-06_JPRB, 0.43227243E-06_JPRB, 0.42223062E-06_JPRB, &
  & 0.40802260E-06_JPRB, 0.39341039E-06_JPRB, 0.38495427E-06_JPRB, 0.38197231E-06_JPRB, 0.37827429E-06_JPRB, 0.36964020E-06_JPRB, &
  & 0.36216938E-06_JPRB, 0.35651707E-06_JPRB, 0.35625135E-06_JPRB, 0.35649676E-06_JPRB, 0.35178800E-06_JPRB, 0.34862957E-06_JPRB, &
  & 0.34919816E-06_JPRB, 0.34828053E-06_JPRB, 0.34499779E-06_JPRB, 0.34287461E-06_JPRB  /)

RGHG2(:,20, 7) = (/ &
  & 0.39912751E-06_JPRB, 0.39850472E-06_JPRB, 0.39825408E-06_JPRB, 0.39961996E-06_JPRB, 0.40358134E-06_JPRB, 0.41058156E-06_JPRB, &
  & 0.42214759E-06_JPRB, 0.44154310E-06_JPRB, 0.47477624E-06_JPRB, 0.53227183E-06_JPRB, 0.61854944E-06_JPRB, 0.72964516E-06_JPRB, &
  & 0.84683232E-06_JPRB, 0.95168706E-06_JPRB, 0.10321472E-05_JPRB, 0.10863796E-05_JPRB, 0.11218500E-05_JPRB, 0.11446951E-05_JPRB, &
  & 0.11576075E-05_JPRB, 0.11634658E-05_JPRB, 0.11686788E-05_JPRB, 0.11819860E-05_JPRB, 0.12082566E-05_JPRB, 0.12521944E-05_JPRB, &
  & 0.13101750E-05_JPRB, 0.13683833E-05_JPRB, 0.14226968E-05_JPRB, 0.14493419E-05_JPRB, 0.14510475E-05_JPRB, 0.14368204E-05_JPRB, &
  & 0.14071194E-05_JPRB, 0.13688154E-05_JPRB, 0.13254467E-05_JPRB, 0.12789716E-05_JPRB, 0.12274647E-05_JPRB, 0.11661550E-05_JPRB, &
  & 0.10902196E-05_JPRB, 0.99889121E-06_JPRB, 0.88755062E-06_JPRB, 0.76810426E-06_JPRB, 0.68030766E-06_JPRB, 0.62894328E-06_JPRB, &
  & 0.58854848E-06_JPRB, 0.54440591E-06_JPRB, 0.50628409E-06_JPRB, 0.48569790E-06_JPRB, 0.47775679E-06_JPRB, 0.46968092E-06_JPRB, &
  & 0.45486262E-06_JPRB, 0.43762691E-06_JPRB, 0.42561158E-06_JPRB, 0.41938607E-06_JPRB, 0.41602691E-06_JPRB, 0.40951796E-06_JPRB, &
  & 0.40218553E-06_JPRB, 0.39521862E-06_JPRB, 0.39253204E-06_JPRB, 0.38908622E-06_JPRB, 0.38004924E-06_JPRB, 0.37327825E-06_JPRB, &
  & 0.37063212E-06_JPRB, 0.36868168E-06_JPRB, 0.36946165E-06_JPRB, 0.37313602E-06_JPRB  /)

RGHG2(:,21, 7) = (/ &
  & 0.47530954E-06_JPRB, 0.47439488E-06_JPRB, 0.47390769E-06_JPRB, 0.47416255E-06_JPRB, 0.47625590E-06_JPRB, 0.48076719E-06_JPRB, &
  & 0.49008508E-06_JPRB, 0.50726196E-06_JPRB, 0.53844183E-06_JPRB, 0.59438719E-06_JPRB, 0.67965387E-06_JPRB, 0.79197539E-06_JPRB, &
  & 0.90826212E-06_JPRB, 0.10092506E-05_JPRB, 0.10855285E-05_JPRB, 0.11361089E-05_JPRB, 0.11700059E-05_JPRB, 0.11925694E-05_JPRB, &
  & 0.12054650E-05_JPRB, 0.12117899E-05_JPRB, 0.12146562E-05_JPRB, 0.12251198E-05_JPRB, 0.12504667E-05_JPRB, 0.12935178E-05_JPRB, &
  & 0.13510631E-05_JPRB, 0.14119336E-05_JPRB, 0.14715067E-05_JPRB, 0.15084984E-05_JPRB, 0.15257760E-05_JPRB, 0.15268604E-05_JPRB, &
  & 0.15052695E-05_JPRB, 0.14629782E-05_JPRB, 0.14034454E-05_JPRB, 0.13333658E-05_JPRB, 0.12595363E-05_JPRB, 0.11830617E-05_JPRB, &
  & 0.10989984E-05_JPRB, 0.99880158E-06_JPRB, 0.88005538E-06_JPRB, 0.76705260E-06_JPRB, 0.69167915E-06_JPRB, 0.64286734E-06_JPRB, &
  & 0.60319515E-06_JPRB, 0.56718758E-06_JPRB, 0.53874343E-06_JPRB, 0.52730382E-06_JPRB, 0.52552941E-06_JPRB, 0.52120629E-06_JPRB, &
  & 0.50843131E-06_JPRB, 0.49065417E-06_JPRB, 0.47531931E-06_JPRB, 0.46451994E-06_JPRB, 0.45994982E-06_JPRB, 0.45439570E-06_JPRB, &
  & 0.44634446E-06_JPRB, 0.43761428E-06_JPRB, 0.43094535E-06_JPRB, 0.42242745E-06_JPRB, 0.40932794E-06_JPRB, 0.39906388E-06_JPRB, &
  & 0.39387966E-06_JPRB, 0.39144535E-06_JPRB, 0.39425642E-06_JPRB, 0.39973475E-06_JPRB  /)

RGHG2(:,22, 7) = (/ &
  & 0.56774396E-06_JPRB, 0.56715424E-06_JPRB, 0.56691553E-06_JPRB, 0.56594709E-06_JPRB, 0.56630106E-06_JPRB, 0.56855688E-06_JPRB, &
  & 0.57487386E-06_JPRB, 0.58859108E-06_JPRB, 0.61568053E-06_JPRB, 0.66686648E-06_JPRB, 0.74729729E-06_JPRB, 0.85380812E-06_JPRB, &
  & 0.96185667E-06_JPRB, 0.10536322E-05_JPRB, 0.11216718E-05_JPRB, 0.11677222E-05_JPRB, 0.11981405E-05_JPRB, 0.12179897E-05_JPRB, &
  & 0.12298532E-05_JPRB, 0.12348019E-05_JPRB, 0.12360626E-05_JPRB, 0.12463542E-05_JPRB, 0.12677636E-05_JPRB, 0.13079857E-05_JPRB, &
  & 0.13675953E-05_JPRB, 0.14319447E-05_JPRB, 0.14956655E-05_JPRB, 0.15433229E-05_JPRB, 0.15730055E-05_JPRB, 0.15844307E-05_JPRB, &
  & 0.15683255E-05_JPRB, 0.15230906E-05_JPRB, 0.14529113E-05_JPRB, 0.13660878E-05_JPRB, 0.12764700E-05_JPRB, 0.11899222E-05_JPRB, &
  & 0.10986529E-05_JPRB, 0.99159414E-06_JPRB, 0.87280971E-06_JPRB, 0.77297655E-06_JPRB, 0.70805853E-06_JPRB, 0.66031710E-06_JPRB, &
  & 0.62171530E-06_JPRB, 0.59105968E-06_JPRB, 0.57115955E-06_JPRB, 0.57030915E-06_JPRB, 0.57564519E-06_JPRB, 0.57577566E-06_JPRB, &
  & 0.56716755E-06_JPRB, 0.55128271E-06_JPRB, 0.53443783E-06_JPRB, 0.51956716E-06_JPRB, 0.51117422E-06_JPRB, 0.50374692E-06_JPRB, &
  & 0.49384160E-06_JPRB, 0.48268393E-06_JPRB, 0.46984114E-06_JPRB, 0.45463331E-06_JPRB, 0.43881959E-06_JPRB, 0.42570753E-06_JPRB, &
  & 0.41905152E-06_JPRB, 0.41667456E-06_JPRB, 0.41916068E-06_JPRB, 0.42414205E-06_JPRB  /)

RGHG2(:,23, 7) = (/ &
  & 0.66797440E-06_JPRB, 0.66647858E-06_JPRB, 0.66541639E-06_JPRB, 0.66382360E-06_JPRB, 0.66323659E-06_JPRB, 0.66469098E-06_JPRB, &
  & 0.66939271E-06_JPRB, 0.68050032E-06_JPRB, 0.70332779E-06_JPRB, 0.74819976E-06_JPRB, 0.82045299E-06_JPRB, 0.91499686E-06_JPRB, &
  & 0.10101360E-05_JPRB, 0.10901543E-05_JPRB, 0.11490401E-05_JPRB, 0.11896082E-05_JPRB, 0.12158942E-05_JPRB, 0.12326552E-05_JPRB, &
  & 0.12429579E-05_JPRB, 0.12467025E-05_JPRB, 0.12490748E-05_JPRB, 0.12601377E-05_JPRB, 0.12791572E-05_JPRB, 0.13164912E-05_JPRB, &
  & 0.13779298E-05_JPRB, 0.14492091E-05_JPRB, 0.15210604E-05_JPRB, 0.15709227E-05_JPRB, 0.15997676E-05_JPRB, 0.16076745E-05_JPRB, &
  & 0.15879450E-05_JPRB, 0.15407365E-05_JPRB, 0.14696316E-05_JPRB, 0.13809980E-05_JPRB, 0.12880356E-05_JPRB, 0.11976772E-05_JPRB, &
  & 0.11027072E-05_JPRB, 0.99411524E-06_JPRB, 0.88102833E-06_JPRB, 0.79291152E-06_JPRB, 0.73405200E-06_JPRB, 0.68802766E-06_JPRB, &
  & 0.65047393E-06_JPRB, 0.62188084E-06_JPRB, 0.60935958E-06_JPRB, 0.61719800E-06_JPRB, 0.62780522E-06_JPRB, 0.63135669E-06_JPRB, &
  & 0.62621331E-06_JPRB, 0.61358261E-06_JPRB, 0.59933492E-06_JPRB, 0.58455302E-06_JPRB, 0.57068145E-06_JPRB, 0.55682435E-06_JPRB, &
  & 0.54262007E-06_JPRB, 0.52788950E-06_JPRB, 0.50988103E-06_JPRB, 0.48897803E-06_JPRB, 0.46996965E-06_JPRB, 0.45448412E-06_JPRB, &
  & 0.44594418E-06_JPRB, 0.44384736E-06_JPRB, 0.44752848E-06_JPRB, 0.45459775E-06_JPRB  /)

RGHG2(:,24, 7) = (/ &
  & 0.76995150E-06_JPRB, 0.76726715E-06_JPRB, 0.76512476E-06_JPRB, 0.76335954E-06_JPRB, 0.76259470E-06_JPRB, 0.76393888E-06_JPRB, &
  & 0.76793074E-06_JPRB, 0.77722890E-06_JPRB, 0.79623490E-06_JPRB, 0.83466952E-06_JPRB, 0.89756714E-06_JPRB, 0.97833497E-06_JPRB, &
  & 0.10591785E-05_JPRB, 0.11270590E-05_JPRB, 0.11764694E-05_JPRB, 0.12109707E-05_JPRB, 0.12332960E-05_JPRB, 0.12471831E-05_JPRB, &
  & 0.12560485E-05_JPRB, 0.12595349E-05_JPRB, 0.12637018E-05_JPRB, 0.12756757E-05_JPRB, 0.12937921E-05_JPRB, 0.13299146E-05_JPRB, &
  & 0.13920775E-05_JPRB, 0.14702203E-05_JPRB, 0.15492491E-05_JPRB, 0.15965247E-05_JPRB, 0.16197412E-05_JPRB, 0.16208677E-05_JPRB, &
  & 0.15959856E-05_JPRB, 0.15472246E-05_JPRB, 0.14782596E-05_JPRB, 0.13930387E-05_JPRB, 0.13016817E-05_JPRB, 0.12106981E-05_JPRB, &
  & 0.11140872E-05_JPRB, 0.10064569E-05_JPRB, 0.90096756E-06_JPRB, 0.82333330E-06_JPRB, 0.76909170E-06_JPRB, 0.72495412E-06_JPRB, &
  & 0.68848882E-06_JPRB, 0.66154586E-06_JPRB, 0.65501025E-06_JPRB, 0.66949435E-06_JPRB, 0.68379610E-06_JPRB, 0.68981746E-06_JPRB, &
  & 0.68753179E-06_JPRB, 0.67856325E-06_JPRB, 0.66750448E-06_JPRB, 0.65360383E-06_JPRB, 0.63477833E-06_JPRB, 0.61359753E-06_JPRB, &
  & 0.59372915E-06_JPRB, 0.57458960E-06_JPRB, 0.55259004E-06_JPRB, 0.52778377E-06_JPRB, 0.50614984E-06_JPRB, 0.48878754E-06_JPRB, &
  & 0.47844378E-06_JPRB, 0.47589494E-06_JPRB, 0.48073889E-06_JPRB, 0.49008981E-06_JPRB  /)

RGHG2(:,25, 7) = (/ &
  & 0.86867994E-06_JPRB, 0.86463700E-06_JPRB, 0.86124925E-06_JPRB, 0.85998541E-06_JPRB, 0.86022333E-06_JPRB, 0.86236002E-06_JPRB, &
  & 0.86696647E-06_JPRB, 0.87576325E-06_JPRB, 0.89193888E-06_JPRB, 0.92435694E-06_JPRB, 0.97698436E-06_JPRB, 0.10427755E-05_JPRB, &
  & 0.11085615E-05_JPRB, 0.11647485E-05_JPRB, 0.12047458E-05_JPRB, 0.12326322E-05_JPRB, 0.12516257E-05_JPRB, 0.12632324E-05_JPRB, &
  & 0.12710627E-05_JPRB, 0.12759400E-05_JPRB, 0.12824197E-05_JPRB, 0.12952994E-05_JPRB, 0.13148390E-05_JPRB, 0.13527891E-05_JPRB, &
  & 0.14137390E-05_JPRB, 0.14975426E-05_JPRB, 0.15808411E-05_JPRB, 0.16190596E-05_JPRB, 0.16313913E-05_JPRB, 0.16233797E-05_JPRB, &
  & 0.15929177E-05_JPRB, 0.15432025E-05_JPRB, 0.14795263E-05_JPRB, 0.14034596E-05_JPRB, 0.13196071E-05_JPRB, 0.12322626E-05_JPRB, &
  & 0.11369455E-05_JPRB, 0.10334557E-05_JPRB, 0.93729846E-06_JPRB, 0.86781567E-06_JPRB, 0.81642061E-06_JPRB, 0.77424003E-06_JPRB, &
  & 0.73889070E-06_JPRB, 0.71353275E-06_JPRB, 0.71050680E-06_JPRB, 0.72814474E-06_JPRB, 0.74359481E-06_JPRB, 0.75052189E-06_JPRB, &
  & 0.75004766E-06_JPRB, 0.74499311E-06_JPRB, 0.73710436E-06_JPRB, 0.72451377E-06_JPRB, 0.70225947E-06_JPRB, 0.67352563E-06_JPRB, &
  & 0.64637915E-06_JPRB, 0.62180530E-06_JPRB, 0.59784874E-06_JPRB, 0.57226613E-06_JPRB, 0.54924128E-06_JPRB, 0.53086005E-06_JPRB, &
  & 0.51902832E-06_JPRB, 0.51470039E-06_JPRB, 0.52025598E-06_JPRB, 0.53154773E-06_JPRB  /)

RGHG2(:,26, 7) = (/ &
  & 0.95490665E-06_JPRB, 0.95073180E-06_JPRB, 0.94726307E-06_JPRB, 0.94642883E-06_JPRB, 0.94803739E-06_JPRB, 0.95170277E-06_JPRB, &
  & 0.95779134E-06_JPRB, 0.96724533E-06_JPRB, 0.98231769E-06_JPRB, 0.10100813E-05_JPRB, 0.10536803E-05_JPRB, 0.11063233E-05_JPRB, &
  & 0.11593130E-05_JPRB, 0.12051826E-05_JPRB, 0.12369193E-05_JPRB, 0.12594832E-05_JPRB, 0.12762726E-05_JPRB, 0.12866962E-05_JPRB, &
  & 0.12950759E-05_JPRB, 0.13020435E-05_JPRB, 0.13105458E-05_JPRB, 0.13249518E-05_JPRB, 0.13474746E-05_JPRB, 0.13861056E-05_JPRB, &
  & 0.14443511E-05_JPRB, 0.15257050E-05_JPRB, 0.16028654E-05_JPRB, 0.16338967E-05_JPRB, 0.16389249E-05_JPRB, 0.16251647E-05_JPRB, &
  & 0.15923362E-05_JPRB, 0.15456316E-05_JPRB, 0.14897756E-05_JPRB, 0.14241926E-05_JPRB, 0.13491559E-05_JPRB, 0.12671326E-05_JPRB, &
  & 0.11762671E-05_JPRB, 0.10796895E-05_JPRB, 0.99339132E-06_JPRB, 0.93026195E-06_JPRB, 0.88156198E-06_JPRB, 0.84173704E-06_JPRB, &
  & 0.80793717E-06_JPRB, 0.78411294E-06_JPRB, 0.78118539E-06_JPRB, 0.79621810E-06_JPRB, 0.80890017E-06_JPRB, 0.81401862E-06_JPRB, &
  & 0.81481774E-06_JPRB, 0.81176814E-06_JPRB, 0.80453881E-06_JPRB, 0.79191827E-06_JPRB, 0.76806309E-06_JPRB, 0.73552986E-06_JPRB, &
  & 0.70294053E-06_JPRB, 0.67408844E-06_JPRB, 0.64952365E-06_JPRB, 0.62584748E-06_JPRB, 0.60426983E-06_JPRB, 0.58622917E-06_JPRB, &
  & 0.57333663E-06_JPRB, 0.56736024E-06_JPRB, 0.57148257E-06_JPRB, 0.58184401E-06_JPRB  /)

RGHG2(:,27, 7) = (/ &
  & 0.10404230E-05_JPRB, 0.10365651E-05_JPRB, 0.10334434E-05_JPRB, 0.10330317E-05_JPRB, 0.10362097E-05_JPRB, 0.10417464E-05_JPRB, &
  & 0.10497062E-05_JPRB, 0.10602769E-05_JPRB, 0.10748362E-05_JPRB, 0.10982386E-05_JPRB, 0.11328586E-05_JPRB, 0.11724330E-05_JPRB, &
  & 0.12128822E-05_JPRB, 0.12484751E-05_JPRB, 0.12720024E-05_JPRB, 0.12894807E-05_JPRB, 0.13043837E-05_JPRB, 0.13139774E-05_JPRB, &
  & 0.13235191E-05_JPRB, 0.13329313E-05_JPRB, 0.13434407E-05_JPRB, 0.13596727E-05_JPRB, 0.13858927E-05_JPRB, 0.14248104E-05_JPRB, &
  & 0.14796757E-05_JPRB, 0.15554611E-05_JPRB, 0.16223446E-05_JPRB, 0.16465549E-05_JPRB, 0.16452752E-05_JPRB, 0.16267614E-05_JPRB, &
  & 0.15926502E-05_JPRB, 0.15505634E-05_JPRB, 0.15038221E-05_JPRB, 0.14496930E-05_JPRB, 0.13843597E-05_JPRB, 0.13085236E-05_JPRB, &
  & 0.12234832E-05_JPRB, 0.11351602E-05_JPRB, 0.10593652E-05_JPRB, 0.10022117E-05_JPRB, 0.95627337E-06_JPRB, 0.91905914E-06_JPRB, &
  & 0.88703997E-06_JPRB, 0.86480027E-06_JPRB, 0.86071073E-06_JPRB, 0.87088422E-06_JPRB, 0.87922016E-06_JPRB, 0.88144118E-06_JPRB, &
  & 0.88337211E-06_JPRB, 0.88171085E-06_JPRB, 0.87424008E-06_JPRB, 0.86109136E-06_JPRB, 0.83624019E-06_JPRB, 0.80112644E-06_JPRB, &
  & 0.76352698E-06_JPRB, 0.73063056E-06_JPRB, 0.70592995E-06_JPRB, 0.68524176E-06_JPRB, 0.66622953E-06_JPRB, 0.64904905E-06_JPRB, &
  & 0.63520579E-06_JPRB, 0.62755432E-06_JPRB, 0.62938286E-06_JPRB, 0.63770705E-06_JPRB  /)

RGHG2(:,28, 7) = (/ &
  & 0.11108629E-05_JPRB, 0.11077810E-05_JPRB, 0.11053240E-05_JPRB, 0.11053420E-05_JPRB, 0.11087069E-05_JPRB, 0.11152811E-05_JPRB, &
  & 0.11250546E-05_JPRB, 0.11374844E-05_JPRB, 0.11525118E-05_JPRB, 0.11735895E-05_JPRB, 0.12020477E-05_JPRB, 0.12335470E-05_JPRB, &
  & 0.12658541E-05_JPRB, 0.12942077E-05_JPRB, 0.13126676E-05_JPRB, 0.13268789E-05_JPRB, 0.13407563E-05_JPRB, 0.13515191E-05_JPRB, &
  & 0.13628466E-05_JPRB, 0.13741702E-05_JPRB, 0.13870495E-05_JPRB, 0.14044675E-05_JPRB, 0.14316215E-05_JPRB, 0.14673707E-05_JPRB, &
  & 0.15146668E-05_JPRB, 0.15758240E-05_JPRB, 0.16303230E-05_JPRB, 0.16531634E-05_JPRB, 0.16533258E-05_JPRB, 0.16377549E-05_JPRB, &
  & 0.16087385E-05_JPRB, 0.15723791E-05_JPRB, 0.15320428E-05_JPRB, 0.14852870E-05_JPRB, 0.14280718E-05_JPRB, 0.13598400E-05_JPRB, &
  & 0.12841674E-05_JPRB, 0.12071229E-05_JPRB, 0.11419312E-05_JPRB, 0.10917354E-05_JPRB, 0.10497990E-05_JPRB, 0.10144275E-05_JPRB, &
  & 0.98425600E-06_JPRB, 0.96309262E-06_JPRB, 0.95452571E-06_JPRB, 0.95573242E-06_JPRB, 0.95639867E-06_JPRB, 0.95387379E-06_JPRB, &
  & 0.95328284E-06_JPRB, 0.94959802E-06_JPRB, 0.93951382E-06_JPRB, 0.92416605E-06_JPRB, 0.89942595E-06_JPRB, 0.86568798E-06_JPRB, &
  & 0.82916850E-06_JPRB, 0.79722728E-06_JPRB, 0.77409871E-06_JPRB, 0.75566871E-06_JPRB, 0.73798419E-06_JPRB, 0.72100027E-06_JPRB, &
  & 0.70601797E-06_JPRB, 0.69699869E-06_JPRB, 0.69761036E-06_JPRB, 0.70390150E-06_JPRB  /)

RGHG2(:,29, 7) = (/ &
  & 0.11848460E-05_JPRB, 0.11826064E-05_JPRB, 0.11808674E-05_JPRB, 0.11813411E-05_JPRB, 0.11848441E-05_JPRB, 0.11924814E-05_JPRB, &
  & 0.12041742E-05_JPRB, 0.12186061E-05_JPRB, 0.12341720E-05_JPRB, 0.12528748E-05_JPRB, 0.12749262E-05_JPRB, 0.12980857E-05_JPRB, &
  & 0.13219564E-05_JPRB, 0.13427710E-05_JPRB, 0.13559978E-05_JPRB, 0.13668262E-05_JPRB, 0.13796542E-05_JPRB, 0.13917426E-05_JPRB, &
  & 0.14049894E-05_JPRB, 0.14183151E-05_JPRB, 0.14337211E-05_JPRB, 0.14523680E-05_JPRB, 0.14803919E-05_JPRB, 0.15126339E-05_JPRB, &
  & 0.15517283E-05_JPRB, 0.15969930E-05_JPRB, 0.16382781E-05_JPRB, 0.16599034E-05_JPRB, 0.16619299E-05_JPRB, 0.16498108E-05_JPRB, &
  & 0.16264694E-05_JPRB, 0.15962268E-05_JPRB, 0.15625596E-05_JPRB, 0.15234393E-05_JPRB, 0.14747572E-05_JPRB, 0.14146444E-05_JPRB, &
  & 0.13490513E-05_JPRB, 0.12840885E-05_JPRB, 0.12301362E-05_JPRB, 0.11873551E-05_JPRB, 0.11497128E-05_JPRB, 0.11162606E-05_JPRB, &
  & 0.10880498E-05_JPRB, 0.10680048E-05_JPRB, 0.10545500E-05_JPRB, 0.10460776E-05_JPRB, 0.10384731E-05_JPRB, 0.10308394E-05_JPRB, &
  & 0.10274179E-05_JPRB, 0.10214410E-05_JPRB, 0.10084848E-05_JPRB, 0.99073449E-06_JPRB, 0.96616009E-06_JPRB, 0.93405142E-06_JPRB, &
  & 0.89894031E-06_JPRB, 0.86822797E-06_JPRB, 0.84683916E-06_JPRB, 0.83077027E-06_JPRB, 0.81443889E-06_JPRB, 0.79763447E-06_JPRB, &
  & 0.78143710E-06_JPRB, 0.77098182E-06_JPRB, 0.77035081E-06_JPRB, 0.77448796E-06_JPRB  /)

RGHG2(:,30, 7) = (/ &
  & 0.12509765E-05_JPRB, 0.12482828E-05_JPRB, 0.12457924E-05_JPRB, 0.12457024E-05_JPRB, 0.12483625E-05_JPRB, 0.12551275E-05_JPRB, &
  & 0.12667916E-05_JPRB, 0.12818804E-05_JPRB, 0.12979986E-05_JPRB, 0.13156137E-05_JPRB, 0.13344935E-05_JPRB, 0.13537821E-05_JPRB, &
  & 0.13736000E-05_JPRB, 0.13903807E-05_JPRB, 0.14011284E-05_JPRB, 0.14099462E-05_JPRB, 0.14216573E-05_JPRB, 0.14343837E-05_JPRB, &
  & 0.14491121E-05_JPRB, 0.14643076E-05_JPRB, 0.14819538E-05_JPRB, 0.15008808E-05_JPRB, 0.15251513E-05_JPRB, 0.15531751E-05_JPRB, &
  & 0.15846567E-05_JPRB, 0.16182382E-05_JPRB, 0.16485825E-05_JPRB, 0.16664769E-05_JPRB, 0.16702577E-05_JPRB, 0.16620658E-05_JPRB, &
  & 0.16438725E-05_JPRB, 0.16183478E-05_JPRB, 0.15899206E-05_JPRB, 0.15571571E-05_JPRB, 0.15162640E-05_JPRB, 0.14662322E-05_JPRB, &
  & 0.14126627E-05_JPRB, 0.13607200E-05_JPRB, 0.13170578E-05_JPRB, 0.12820160E-05_JPRB, 0.12503879E-05_JPRB, 0.12205036E-05_JPRB, &
  & 0.11946356E-05_JPRB, 0.11739063E-05_JPRB, 0.11554982E-05_JPRB, 0.11396300E-05_JPRB, 0.11253103E-05_JPRB, 0.11116738E-05_JPRB, &
  & 0.11016087E-05_JPRB, 0.10901956E-05_JPRB, 0.10739012E-05_JPRB, 0.10534862E-05_JPRB, 0.10286815E-05_JPRB, 0.99974016E-06_JPRB, &
  & 0.96935486E-06_JPRB, 0.94227649E-06_JPRB, 0.92261774E-06_JPRB, 0.90673292E-06_JPRB, 0.89003887E-06_JPRB, 0.87233094E-06_JPRB, &
  & 0.85554418E-06_JPRB, 0.84365024E-06_JPRB, 0.84256324E-06_JPRB, 0.84709874E-06_JPRB  /)

RGHG2(:,31, 7) = (/ &
  & 0.13206476E-05_JPRB, 0.13174742E-05_JPRB, 0.13141907E-05_JPRB, 0.13135059E-05_JPRB, 0.13152769E-05_JPRB, 0.13211209E-05_JPRB, &
  & 0.13327531E-05_JPRB, 0.13485326E-05_JPRB, 0.13652329E-05_JPRB, 0.13817030E-05_JPRB, 0.13972441E-05_JPRB, 0.14124585E-05_JPRB, &
  & 0.14280102E-05_JPRB, 0.14405439E-05_JPRB, 0.14486820E-05_JPRB, 0.14553827E-05_JPRB, 0.14659170E-05_JPRB, 0.14793150E-05_JPRB, &
  & 0.14956039E-05_JPRB, 0.15127694E-05_JPRB, 0.15327758E-05_JPRB, 0.15519970E-05_JPRB, 0.15723083E-05_JPRB, 0.15958869E-05_JPRB, &
  & 0.16193479E-05_JPRB, 0.16406234E-05_JPRB, 0.16594420E-05_JPRB, 0.16734028E-05_JPRB, 0.16790321E-05_JPRB, 0.16749784E-05_JPRB, &
  & 0.16622090E-05_JPRB, 0.16416540E-05_JPRB, 0.16187466E-05_JPRB, 0.15926798E-05_JPRB, 0.15599927E-05_JPRB, 0.15205848E-05_JPRB, &
  & 0.14796859E-05_JPRB, 0.14414627E-05_JPRB, 0.14086418E-05_JPRB, 0.13817550E-05_JPRB, 0.13564654E-05_JPRB, 0.13303419E-05_JPRB, &
  & 0.13069428E-05_JPRB, 0.12854907E-05_JPRB, 0.12618634E-05_JPRB, 0.12382049E-05_JPRB, 0.12168111E-05_JPRB, 0.11968490E-05_JPRB, &
  & 0.11797802E-05_JPRB, 0.11626362E-05_JPRB, 0.11428240E-05_JPRB, 0.11196012E-05_JPRB, 0.10945534E-05_JPRB, 0.10689508E-05_JPRB, &
  & 0.10435480E-05_JPRB, 0.10203009E-05_JPRB, 0.10024650E-05_JPRB, 0.98677205E-06_JPRB, 0.96969423E-06_JPRB, 0.95103330E-06_JPRB, &
  & 0.93362612E-06_JPRB, 0.92021631E-06_JPRB, 0.91864961E-06_JPRB, 0.92360725E-06_JPRB  /)

RGHG2(:,32, 7) = (/ &
  & 0.13818043E-05_JPRB, 0.13790103E-05_JPRB, 0.13752527E-05_JPRB, 0.13733178E-05_JPRB, 0.13736569E-05_JPRB, 0.13778232E-05_JPRB, &
  & 0.13873255E-05_JPRB, 0.14016215E-05_JPRB, 0.14174852E-05_JPRB, 0.14329996E-05_JPRB, 0.14471411E-05_JPRB, 0.14607199E-05_JPRB, &
  & 0.14739712E-05_JPRB, 0.14839749E-05_JPRB, 0.14905213E-05_JPRB, 0.14963439E-05_JPRB, 0.15056666E-05_JPRB, 0.15188301E-05_JPRB, &
  & 0.15356008E-05_JPRB, 0.15532832E-05_JPRB, 0.15733708E-05_JPRB, 0.15916309E-05_JPRB, 0.16089962E-05_JPRB, 0.16277934E-05_JPRB, &
  & 0.16456497E-05_JPRB, 0.16610517E-05_JPRB, 0.16736610E-05_JPRB, 0.16829023E-05_JPRB, 0.16870219E-05_JPRB, 0.16845799E-05_JPRB, &
  & 0.16752586E-05_JPRB, 0.16586780E-05_JPRB, 0.16400428E-05_JPRB, 0.16197327E-05_JPRB, 0.15947150E-05_JPRB, 0.15647014E-05_JPRB, &
  & 0.15341082E-05_JPRB, 0.15059363E-05_JPRB, 0.14815915E-05_JPRB, 0.14615960E-05_JPRB, 0.14426773E-05_JPRB, 0.14217485E-05_JPRB, &
  & 0.13998174E-05_JPRB, 0.13769312E-05_JPRB, 0.13511656E-05_JPRB, 0.13247081E-05_JPRB, 0.12992201E-05_JPRB, 0.12743918E-05_JPRB, &
  & 0.12522068E-05_JPRB, 0.12306334E-05_JPRB, 0.12083874E-05_JPRB, 0.11836385E-05_JPRB, 0.11586976E-05_JPRB, 0.11344895E-05_JPRB, &
  & 0.11120946E-05_JPRB, 0.10911666E-05_JPRB, 0.10737232E-05_JPRB, 0.10580412E-05_JPRB, 0.10414821E-05_JPRB, 0.10231017E-05_JPRB, &
  & 0.10066607E-05_JPRB, 0.99446797E-06_JPRB, 0.99297684E-06_JPRB, 0.10008233E-05_JPRB  /)

RGHG2(:,33, 7) = (/ &
  & 0.14442588E-05_JPRB, 0.14419702E-05_JPRB, 0.14377614E-05_JPRB, 0.14344425E-05_JPRB, 0.14332230E-05_JPRB, 0.14355481E-05_JPRB, &
  & 0.14425652E-05_JPRB, 0.14550379E-05_JPRB, 0.14698486E-05_JPRB, 0.14843942E-05_JPRB, 0.14973322E-05_JPRB, 0.15095270E-05_JPRB, &
  & 0.15206421E-05_JPRB, 0.15282389E-05_JPRB, 0.15332629E-05_JPRB, 0.15383333E-05_JPRB, 0.15463923E-05_JPRB, 0.15591948E-05_JPRB, &
  & 0.15763266E-05_JPRB, 0.15943579E-05_JPRB, 0.16142349E-05_JPRB, 0.16313337E-05_JPRB, 0.16457685E-05_JPRB, 0.16595533E-05_JPRB, &
  & 0.16718976E-05_JPRB, 0.16820284E-05_JPRB, 0.16888730E-05_JPRB, 0.16931079E-05_JPRB, 0.16952237E-05_JPRB, 0.16941296E-05_JPRB, &
  & 0.16881358E-05_JPRB, 0.16755568E-05_JPRB, 0.16612000E-05_JPRB, 0.16467509E-05_JPRB, 0.16296340E-05_JPRB, 0.16092241E-05_JPRB, &
  & 0.15890350E-05_JPRB, 0.15708338E-05_JPRB, 0.15549916E-05_JPRB, 0.15419944E-05_JPRB, 0.15297008E-05_JPRB, 0.15143561E-05_JPRB, &
  & 0.14938211E-05_JPRB, 0.14693523E-05_JPRB, 0.14417634E-05_JPRB, 0.14130434E-05_JPRB, 0.13836862E-05_JPRB, 0.13539899E-05_JPRB, &
  & 0.13267322E-05_JPRB, 0.13007240E-05_JPRB, 0.12760891E-05_JPRB, 0.12499200E-05_JPRB, 0.12251357E-05_JPRB, 0.12021250E-05_JPRB, &
  & 0.11826004E-05_JPRB, 0.11638868E-05_JPRB, 0.11466660E-05_JPRB, 0.11309720E-05_JPRB, 0.11150688E-05_JPRB, 0.10971397E-05_JPRB, &
  & 0.10819082E-05_JPRB, 0.10713341E-05_JPRB, 0.10699935E-05_JPRB, 0.10811615E-05_JPRB  /)

RGHG2(:,34, 7) = (/ &
  & 0.14970258E-05_JPRB, 0.14953692E-05_JPRB, 0.14910137E-05_JPRB, 0.14868682E-05_JPRB, 0.14845502E-05_JPRB, 0.14852224E-05_JPRB, &
  & 0.14895463E-05_JPRB, 0.14993362E-05_JPRB, 0.15122529E-05_JPRB, 0.15253710E-05_JPRB, 0.15373178E-05_JPRB, 0.15485301E-05_JPRB, &
  & 0.15578906E-05_JPRB, 0.15638601E-05_JPRB, 0.15679642E-05_JPRB, 0.15723749E-05_JPRB, 0.15794552E-05_JPRB, 0.15913730E-05_JPRB, &
  & 0.16076505E-05_JPRB, 0.16250047E-05_JPRB, 0.16432900E-05_JPRB, 0.16584877E-05_JPRB, 0.16704144E-05_JPRB, 0.16805052E-05_JPRB, &
  & 0.16889603E-05_JPRB, 0.16955681E-05_JPRB, 0.16992944E-05_JPRB, 0.17008842E-05_JPRB, 0.17015286E-05_JPRB, 0.17006841E-05_JPRB, &
  & 0.16965264E-05_JPRB, 0.16873084E-05_JPRB, 0.16766982E-05_JPRB, 0.16665734E-05_JPRB, 0.16551265E-05_JPRB, 0.16417035E-05_JPRB, &
  & 0.16285467E-05_JPRB, 0.16167446E-05_JPRB, 0.16067401E-05_JPRB, 0.15986052E-05_JPRB, 0.15904991E-05_JPRB, 0.15786547E-05_JPRB, &
  & 0.15603886E-05_JPRB, 0.15373710E-05_JPRB, 0.15114430E-05_JPRB, 0.14832087E-05_JPRB, 0.14527409E-05_JPRB, 0.14213405E-05_JPRB, &
  & 0.13915281E-05_JPRB, 0.13627718E-05_JPRB, 0.13363561E-05_JPRB, 0.13098628E-05_JPRB, 0.12854747E-05_JPRB, 0.12633481E-05_JPRB, &
  & 0.12447176E-05_JPRB, 0.12274368E-05_JPRB, 0.12109133E-05_JPRB, 0.11956391E-05_JPRB, 0.11801644E-05_JPRB, 0.11634688E-05_JPRB, &
  & 0.11502847E-05_JPRB, 0.11413980E-05_JPRB, 0.11407414E-05_JPRB, 0.11531857E-05_JPRB  /)

RGHG2(:,35, 7) = (/ &
  & 0.15463060E-05_JPRB, 0.15453642E-05_JPRB, 0.15410143E-05_JPRB, 0.15363048E-05_JPRB, 0.15330933E-05_JPRB, 0.15321631E-05_JPRB, &
  & 0.15336113E-05_JPRB, 0.15402016E-05_JPRB, 0.15507397E-05_JPRB, 0.15621547E-05_JPRB, 0.15731914E-05_JPRB, 0.15835997E-05_JPRB, &
  & 0.15913520E-05_JPRB, 0.15960484E-05_JPRB, 0.15995160E-05_JPRB, 0.16032956E-05_JPRB, 0.16095161E-05_JPRB, 0.16202557E-05_JPRB, &
  & 0.16350312E-05_JPRB, 0.16511625E-05_JPRB, 0.16671026E-05_JPRB, 0.16799663E-05_JPRB, 0.16895311E-05_JPRB, 0.16965005E-05_JPRB, &
  & 0.17017896E-05_JPRB, 0.17056726E-05_JPRB, 0.17075506E-05_JPRB, 0.17076329E-05_JPRB, 0.17070376E-05_JPRB, 0.17058860E-05_JPRB, &
  & 0.17028506E-05_JPRB, 0.16967596E-05_JPRB, 0.16897286E-05_JPRB, 0.16832611E-05_JPRB, 0.16764990E-05_JPRB, 0.16689166E-05_JPRB, &
  & 0.16612599E-05_JPRB, 0.16542040E-05_JPRB, 0.16488341E-05_JPRB, 0.16446022E-05_JPRB, 0.16395504E-05_JPRB, 0.16302354E-05_JPRB, &
  & 0.16147501E-05_JPRB, 0.15947812E-05_JPRB, 0.15723487E-05_JPRB, 0.15460240E-05_JPRB, 0.15158298E-05_JPRB, 0.14843010E-05_JPRB, &
  & 0.14531541E-05_JPRB, 0.14224378E-05_JPRB, 0.13945034E-05_JPRB, 0.13682390E-05_JPRB, 0.13443813E-05_JPRB, 0.13230030E-05_JPRB, &
  & 0.13042775E-05_JPRB, 0.12880689E-05_JPRB, 0.12725057E-05_JPRB, 0.12578849E-05_JPRB, 0.12427340E-05_JPRB, 0.12277080E-05_JPRB, &
  & 0.12170590E-05_JPRB, 0.12099423E-05_JPRB, 0.12102629E-05_JPRB, 0.12229695E-05_JPRB  /)

RGHG2(:,36, 7) = (/ &
  & 0.15913070E-05_JPRB, 0.15908046E-05_JPRB, 0.15866087E-05_JPRB, 0.15816050E-05_JPRB, 0.15777611E-05_JPRB, 0.15754805E-05_JPRB, &
  & 0.15744674E-05_JPRB, 0.15780475E-05_JPRB, 0.15860820E-05_JPRB, 0.15956764E-05_JPRB, 0.16056387E-05_JPRB, 0.16151118E-05_JPRB, &
  & 0.16214556E-05_JPRB, 0.16250689E-05_JPRB, 0.16279945E-05_JPRB, 0.16312107E-05_JPRB, 0.16365712E-05_JPRB, 0.16460263E-05_JPRB, &
  & 0.16590704E-05_JPRB, 0.16735703E-05_JPRB, 0.16870187E-05_JPRB, 0.16974545E-05_JPRB, 0.17046872E-05_JPRB, 0.17089731E-05_JPRB, &
  & 0.17116722E-05_JPRB, 0.17133851E-05_JPRB, 0.17138445E-05_JPRB, 0.17128935E-05_JPRB, 0.17114751E-05_JPRB, 0.17101446E-05_JPRB, &
  & 0.17080693E-05_JPRB, 0.17045533E-05_JPRB, 0.17004973E-05_JPRB, 0.16970475E-05_JPRB, 0.16940674E-05_JPRB, 0.16911440E-05_JPRB, &
  & 0.16879747E-05_JPRB, 0.16848672E-05_JPRB, 0.16832476E-05_JPRB, 0.16822126E-05_JPRB, 0.16797832E-05_JPRB, 0.16729089E-05_JPRB, &
  & 0.16602881E-05_JPRB, 0.16437004E-05_JPRB, 0.16248480E-05_JPRB, 0.16010036E-05_JPRB, 0.15720175E-05_JPRB, 0.15410917E-05_JPRB, &
  & 0.15095689E-05_JPRB, 0.14779563E-05_JPRB, 0.14492272E-05_JPRB, 0.14234492E-05_JPRB, 0.14001698E-05_JPRB, 0.13797326E-05_JPRB, &
  & 0.13612652E-05_JPRB, 0.13460576E-05_JPRB, 0.13314976E-05_JPRB, 0.13173930E-05_JPRB, 0.13028111E-05_JPRB, 0.12892508E-05_JPRB, &
  & 0.12809202E-05_JPRB, 0.12753430E-05_JPRB, 0.12761768E-05_JPRB, 0.12883158E-05_JPRB  /)

RGHG2(:,37, 7) = (/ &
  & 0.16236972E-05_JPRB, 0.16229757E-05_JPRB, 0.16192643E-05_JPRB, 0.16146034E-05_JPRB, 0.16107647E-05_JPRB, 0.16077959E-05_JPRB, &
  & 0.16054246E-05_JPRB, 0.16066155E-05_JPRB, 0.16120160E-05_JPRB, 0.16196337E-05_JPRB, 0.16282120E-05_JPRB, 0.16365071E-05_JPRB, &
  & 0.16419876E-05_JPRB, 0.16450210E-05_JPRB, 0.16476554E-05_JPRB, 0.16504979E-05_JPRB, 0.16550517E-05_JPRB, 0.16630583E-05_JPRB, &
  & 0.16739529E-05_JPRB, 0.16859864E-05_JPRB, 0.16967621E-05_JPRB, 0.17047056E-05_JPRB, 0.17098198E-05_JPRB, 0.17125928E-05_JPRB, &
  & 0.17141836E-05_JPRB, 0.17151337E-05_JPRB, 0.17152477E-05_JPRB, 0.17144152E-05_JPRB, 0.17131799E-05_JPRB, 0.17119757E-05_JPRB, &
  & 0.17104287E-05_JPRB, 0.17080622E-05_JPRB, 0.17054108E-05_JPRB, 0.17033245E-05_JPRB, 0.17018212E-05_JPRB, 0.17005575E-05_JPRB, &
  & 0.16992748E-05_JPRB, 0.16980410E-05_JPRB, 0.16979110E-05_JPRB, 0.16982549E-05_JPRB, 0.16972946E-05_JPRB, 0.16925053E-05_JPRB, &
  & 0.16827634E-05_JPRB, 0.16701087E-05_JPRB, 0.16548078E-05_JPRB, 0.16345974E-05_JPRB, 0.16088870E-05_JPRB, 0.15802035E-05_JPRB, &
  & 0.15505260E-05_JPRB, 0.15205114E-05_JPRB, 0.14926972E-05_JPRB, 0.14679655E-05_JPRB, 0.14453383E-05_JPRB, 0.14262258E-05_JPRB, &
  & 0.14088100E-05_JPRB, 0.13943781E-05_JPRB, 0.13808567E-05_JPRB, 0.13669223E-05_JPRB, 0.13534357E-05_JPRB, 0.13407826E-05_JPRB, &
  & 0.13341299E-05_JPRB, 0.13294676E-05_JPRB, 0.13297189E-05_JPRB, 0.13394224E-05_JPRB  /)

RGHG2(:,38, 7) = (/ &
  & 0.16596370E-05_JPRB, 0.16586724E-05_JPRB, 0.16554986E-05_JPRB, 0.16512181E-05_JPRB, 0.16473851E-05_JPRB, 0.16436528E-05_JPRB, &
  & 0.16397744E-05_JPRB, 0.16383143E-05_JPRB, 0.16407921E-05_JPRB, 0.16462163E-05_JPRB, 0.16532589E-05_JPRB, 0.16602472E-05_JPRB, &
  & 0.16647696E-05_JPRB, 0.16671596E-05_JPRB, 0.16694709E-05_JPRB, 0.16718987E-05_JPRB, 0.16755574E-05_JPRB, 0.16819568E-05_JPRB, &
  & 0.16904664E-05_JPRB, 0.16997631E-05_JPRB, 0.17075732E-05_JPRB, 0.17127514E-05_JPRB, 0.17155148E-05_JPRB, 0.17166092E-05_JPRB, &
  & 0.17169703E-05_JPRB, 0.17170739E-05_JPRB, 0.17168047E-05_JPRB, 0.17161038E-05_JPRB, 0.17150715E-05_JPRB, 0.17140074E-05_JPRB, &
  & 0.17130467E-05_JPRB, 0.17119556E-05_JPRB, 0.17108628E-05_JPRB, 0.17102892E-05_JPRB, 0.17104246E-05_JPRB, 0.17110026E-05_JPRB, &
  & 0.17118132E-05_JPRB, 0.17126585E-05_JPRB, 0.17141815E-05_JPRB, 0.17160553E-05_JPRB, 0.17167250E-05_JPRB, 0.17142493E-05_JPRB, &
  & 0.17077017E-05_JPRB, 0.16994110E-05_JPRB, 0.16880508E-05_JPRB, 0.16718726E-05_JPRB, 0.16497971E-05_JPRB, 0.16236015E-05_JPRB, &
  & 0.15959716E-05_JPRB, 0.15677300E-05_JPRB, 0.15409310E-05_JPRB, 0.15173604E-05_JPRB, 0.14954567E-05_JPRB, 0.14778141E-05_JPRB, &
  & 0.14615651E-05_JPRB, 0.14479940E-05_JPRB, 0.14356251E-05_JPRB, 0.14218794E-05_JPRB, 0.14096082E-05_JPRB, 0.13979617E-05_JPRB, &
  & 0.13931707E-05_JPRB, 0.13895237E-05_JPRB, 0.13891287E-05_JPRB, 0.13961296E-05_JPRB  /)

RGHG2(:,39, 7) = (/ &
  & 0.16769477E-05_JPRB, 0.16758650E-05_JPRB, 0.16733926E-05_JPRB, 0.16697386E-05_JPRB, 0.16663259E-05_JPRB, 0.16627182E-05_JPRB, &
  & 0.16588262E-05_JPRB, 0.16564946E-05_JPRB, 0.16574630E-05_JPRB, 0.16613086E-05_JPRB, 0.16670258E-05_JPRB, 0.16728813E-05_JPRB, &
  & 0.16767887E-05_JPRB, 0.16788964E-05_JPRB, 0.16809501E-05_JPRB, 0.16831215E-05_JPRB, 0.16862305E-05_JPRB, 0.16914768E-05_JPRB, &
  & 0.16983062E-05_JPRB, 0.17055937E-05_JPRB, 0.17114799E-05_JPRB, 0.17151225E-05_JPRB, 0.17168332E-05_JPRB, 0.17173149E-05_JPRB, &
  & 0.17173035E-05_JPRB, 0.17170999E-05_JPRB, 0.17166707E-05_JPRB, 0.17159612E-05_JPRB, 0.17150175E-05_JPRB, 0.17140630E-05_JPRB, &
  & 0.17133510E-05_JPRB, 0.17126525E-05_JPRB, 0.17120425E-05_JPRB, 0.17119995E-05_JPRB, 0.17126686E-05_JPRB, 0.17137702E-05_JPRB, &
  & 0.17151249E-05_JPRB, 0.17166709E-05_JPRB, 0.17188712E-05_JPRB, 0.17215225E-05_JPRB, 0.17230746E-05_JPRB, 0.17219391E-05_JPRB, &
  & 0.17169569E-05_JPRB, 0.17105083E-05_JPRB, 0.17014938E-05_JPRB, 0.16881579E-05_JPRB, 0.16695795E-05_JPRB, 0.16465782E-05_JPRB, &
  & 0.16217227E-05_JPRB, 0.15959688E-05_JPRB, 0.15711308E-05_JPRB, 0.15492758E-05_JPRB, 0.15287276E-05_JPRB, 0.15123098E-05_JPRB, &
  & 0.14975796E-05_JPRB, 0.14849263E-05_JPRB, 0.14734882E-05_JPRB, 0.14602963E-05_JPRB, 0.14487868E-05_JPRB, 0.14377818E-05_JPRB, &
  & 0.14336361E-05_JPRB, 0.14303313E-05_JPRB, 0.14289933E-05_JPRB, 0.14341374E-05_JPRB  /)

RGHG2(:,40, 7) = (/ &
  & 0.16942156E-05_JPRB, 0.16930146E-05_JPRB, 0.16913921E-05_JPRB, 0.16885138E-05_JPRB, 0.16856622E-05_JPRB, 0.16823460E-05_JPRB, &
  & 0.16786822E-05_JPRB, 0.16756190E-05_JPRB, 0.16750472E-05_JPRB, 0.16771408E-05_JPRB, 0.16813370E-05_JPRB, 0.16858915E-05_JPRB, &
  & 0.16891333E-05_JPRB, 0.16909687E-05_JPRB, 0.16927308E-05_JPRB, 0.16946272E-05_JPRB, 0.16971476E-05_JPRB, 0.17011150E-05_JPRB, &
  & 0.17060878E-05_JPRB, 0.17111365E-05_JPRB, 0.17149350E-05_JPRB, 0.17169769E-05_JPRB, 0.17176645E-05_JPRB, 0.17176016E-05_JPRB, &
  & 0.17172931E-05_JPRB, 0.17168172E-05_JPRB, 0.17162367E-05_JPRB, 0.17154942E-05_JPRB, 0.17146358E-05_JPRB, 0.17138051E-05_JPRB, &
  & 0.17133296E-05_JPRB, 0.17129474E-05_JPRB, 0.17127279E-05_JPRB, 0.17131471E-05_JPRB, 0.17142617E-05_JPRB, 0.17157621E-05_JPRB, &
  & 0.17175018E-05_JPRB, 0.17196447E-05_JPRB, 0.17224804E-05_JPRB, 0.17259211E-05_JPRB, 0.17283863E-05_JPRB, 0.17286646E-05_JPRB, &
  & 0.17252528E-05_JPRB, 0.17205535E-05_JPRB, 0.17140309E-05_JPRB, 0.17038361E-05_JPRB, 0.16893393E-05_JPRB, 0.16702024E-05_JPRB, &
  & 0.16487216E-05_JPRB, 0.16260043E-05_JPRB, 0.16036224E-05_JPRB, 0.15838715E-05_JPRB, 0.15650176E-05_JPRB, 0.15499970E-05_JPRB, &
  & 0.15371068E-05_JPRB, 0.15255399E-05_JPRB, 0.15151581E-05_JPRB, 0.15026758E-05_JPRB, 0.14919859E-05_JPRB, 0.14816740E-05_JPRB, &
  & 0.14780867E-05_JPRB, 0.14750734E-05_JPRB, 0.14725802E-05_JPRB, 0.14756835E-05_JPRB  /)

RGHG2(:,41, 7) = (/ &
  & 0.17153281E-05_JPRB, 0.17139825E-05_JPRB, 0.17133991E-05_JPRB, 0.17114691E-05_JPRB, 0.17093035E-05_JPRB, 0.17063438E-05_JPRB, &
  & 0.17029591E-05_JPRB, 0.16990014E-05_JPRB, 0.16965464E-05_JPRB, 0.16964979E-05_JPRB, 0.16988345E-05_JPRB, 0.17017984E-05_JPRB, &
  & 0.17042264E-05_JPRB, 0.17057288E-05_JPRB, 0.17071345E-05_JPRB, 0.17086946E-05_JPRB, 0.17104953E-05_JPRB, 0.17128990E-05_JPRB, &
  & 0.17156019E-05_JPRB, 0.17179133E-05_JPRB, 0.17191595E-05_JPRB, 0.17192442E-05_JPRB, 0.17186808E-05_JPRB, 0.17179520E-05_JPRB, &
  & 0.17172804E-05_JPRB, 0.17164715E-05_JPRB, 0.17157061E-05_JPRB, 0.17149232E-05_JPRB, 0.17141691E-05_JPRB, 0.17134897E-05_JPRB, &
  & 0.17133034E-05_JPRB, 0.17133080E-05_JPRB, 0.17135660E-05_JPRB, 0.17145501E-05_JPRB, 0.17162095E-05_JPRB, 0.17181975E-05_JPRB, &
  & 0.17204081E-05_JPRB, 0.17232806E-05_JPRB, 0.17268931E-05_JPRB, 0.17312990E-05_JPRB, 0.17348807E-05_JPRB, 0.17368874E-05_JPRB, &
  & 0.17353958E-05_JPRB, 0.17328352E-05_JPRB, 0.17293594E-05_JPRB, 0.17230049E-05_JPRB, 0.17134985E-05_JPRB, 0.16990864E-05_JPRB, &
  & 0.16817318E-05_JPRB, 0.16627270E-05_JPRB, 0.16433481E-05_JPRB, 0.16261698E-05_JPRB, 0.16093874E-05_JPRB, 0.15960751E-05_JPRB, &
  & 0.15854346E-05_JPRB, 0.15751960E-05_JPRB, 0.15661055E-05_JPRB, 0.15544908E-05_JPRB, 0.15448030E-05_JPRB, 0.15353386E-05_JPRB, &
  & 0.15324339E-05_JPRB, 0.15297771E-05_JPRB, 0.15258715E-05_JPRB, 0.15264796E-05_JPRB  /)

RGHG2(:,42, 7) = (/ &
  & 0.17113041E-05_JPRB, 0.17104793E-05_JPRB, 0.17098277E-05_JPRB, 0.17083577E-05_JPRB, 0.17067594E-05_JPRB, 0.17047514E-05_JPRB, &
  & 0.17023404E-05_JPRB, 0.16996588E-05_JPRB, 0.16980462E-05_JPRB, 0.16982041E-05_JPRB, 0.17000032E-05_JPRB, 0.17024590E-05_JPRB, &
  & 0.17045581E-05_JPRB, 0.17059430E-05_JPRB, 0.17072477E-05_JPRB, 0.17085646E-05_JPRB, 0.17101574E-05_JPRB, 0.17123094E-05_JPRB, &
  & 0.17147100E-05_JPRB, 0.17168994E-05_JPRB, 0.17182001E-05_JPRB, 0.17184695E-05_JPRB, 0.17179796E-05_JPRB, 0.17172175E-05_JPRB, &
  & 0.17164026E-05_JPRB, 0.17154344E-05_JPRB, 0.17146308E-05_JPRB, 0.17138124E-05_JPRB, 0.17130618E-05_JPRB, 0.17125347E-05_JPRB, &
  & 0.17124157E-05_JPRB, 0.17123924E-05_JPRB, 0.17126580E-05_JPRB, 0.17135593E-05_JPRB, 0.17149092E-05_JPRB, 0.17165000E-05_JPRB, &
  & 0.17185904E-05_JPRB, 0.17216571E-05_JPRB, 0.17254396E-05_JPRB, 0.17298958E-05_JPRB, 0.17334165E-05_JPRB, 0.17350955E-05_JPRB, &
  & 0.17337366E-05_JPRB, 0.17311421E-05_JPRB, 0.17274024E-05_JPRB, 0.17212623E-05_JPRB, 0.17123118E-05_JPRB, 0.16995514E-05_JPRB, &
  & 0.16837563E-05_JPRB, 0.16669786E-05_JPRB, 0.16502505E-05_JPRB, 0.16346551E-05_JPRB, 0.16197664E-05_JPRB, 0.16073412E-05_JPRB, &
  & 0.15974452E-05_JPRB, 0.15884473E-05_JPRB, 0.15799095E-05_JPRB, 0.15702035E-05_JPRB, 0.15613994E-05_JPRB, 0.15520626E-05_JPRB, &
  & 0.15477363E-05_JPRB, 0.15445261E-05_JPRB, 0.15413536E-05_JPRB, 0.15435889E-05_JPRB  /)

RGHG2(:,43, 7) = (/ &
  & 0.17167141E-05_JPRB, 0.17163023E-05_JPRB, 0.17160355E-05_JPRB, 0.17153931E-05_JPRB, 0.17146075E-05_JPRB, 0.17136212E-05_JPRB, &
  & 0.17122186E-05_JPRB, 0.17103166E-05_JPRB, 0.17086625E-05_JPRB, 0.17080873E-05_JPRB, 0.17085960E-05_JPRB, 0.17099041E-05_JPRB, &
  & 0.17113530E-05_JPRB, 0.17124874E-05_JPRB, 0.17135467E-05_JPRB, 0.17144970E-05_JPRB, 0.17155907E-05_JPRB, 0.17168404E-05_JPRB, &
  & 0.17179888E-05_JPRB, 0.17188895E-05_JPRB, 0.17191419E-05_JPRB, 0.17187379E-05_JPRB, 0.17177770E-05_JPRB, 0.17166981E-05_JPRB, &
  & 0.17155963E-05_JPRB, 0.17143395E-05_JPRB, 0.17134214E-05_JPRB, 0.17125533E-05_JPRB, 0.17118508E-05_JPRB, 0.17115277E-05_JPRB, &
  & 0.17115944E-05_JPRB, 0.17117121E-05_JPRB, 0.17121900E-05_JPRB, 0.17132589E-05_JPRB, 0.17145606E-05_JPRB, 0.17159989E-05_JPRB, &
  & 0.17181822E-05_JPRB, 0.17217397E-05_JPRB, 0.17260115E-05_JPRB, 0.17309288E-05_JPRB, 0.17348741E-05_JPRB, 0.17369976E-05_JPRB, &
  & 0.17365858E-05_JPRB, 0.17348802E-05_JPRB, 0.17322103E-05_JPRB, 0.17279179E-05_JPRB, 0.17216211E-05_JPRB, 0.17124001E-05_JPRB, &
  & 0.16998027E-05_JPRB, 0.16866540E-05_JPRB, 0.16736361E-05_JPRB, 0.16605917E-05_JPRB, 0.16483219E-05_JPRB, 0.16374407E-05_JPRB, &
  & 0.16291917E-05_JPRB, 0.16218972E-05_JPRB, 0.16144193E-05_JPRB, 0.16068280E-05_JPRB, 0.15992611E-05_JPRB, 0.15904053E-05_JPRB, &
  & 0.15850756E-05_JPRB, 0.15815137E-05_JPRB, 0.15784027E-05_JPRB, 0.15810493E-05_JPRB  /)

RGHG2(:,44, 7) = (/ &
  & 0.17159990E-05_JPRB, 0.17156399E-05_JPRB, 0.17154004E-05_JPRB, 0.17148991E-05_JPRB, 0.17143434E-05_JPRB, 0.17136809E-05_JPRB, &
  & 0.17127736E-05_JPRB, 0.17114751E-05_JPRB, 0.17103443E-05_JPRB, 0.17099833E-05_JPRB, 0.17103909E-05_JPRB, 0.17113749E-05_JPRB, &
  & 0.17125445E-05_JPRB, 0.17134695E-05_JPRB, 0.17144131E-05_JPRB, 0.17152627E-05_JPRB, 0.17161860E-05_JPRB, 0.17172230E-05_JPRB, &
  & 0.17181360E-05_JPRB, 0.17188282E-05_JPRB, 0.17189512E-05_JPRB, 0.17184348E-05_JPRB, 0.17173504E-05_JPRB, 0.17161238E-05_JPRB, &
  & 0.17149395E-05_JPRB, 0.17137061E-05_JPRB, 0.17128336E-05_JPRB, 0.17120239E-05_JPRB, 0.17114760E-05_JPRB, 0.17112961E-05_JPRB, &
  & 0.17113693E-05_JPRB, 0.17115171E-05_JPRB, 0.17119114E-05_JPRB, 0.17128117E-05_JPRB, 0.17139659E-05_JPRB, 0.17153968E-05_JPRB, &
  & 0.17176098E-05_JPRB, 0.17212614E-05_JPRB, 0.17257104E-05_JPRB, 0.17308494E-05_JPRB, 0.17348976E-05_JPRB, 0.17371875E-05_JPRB, &
  & 0.17370378E-05_JPRB, 0.17357108E-05_JPRB, 0.17333665E-05_JPRB, 0.17296306E-05_JPRB, 0.17240480E-05_JPRB, 0.17159501E-05_JPRB, &
  & 0.17051310E-05_JPRB, 0.16937398E-05_JPRB, 0.16826347E-05_JPRB, 0.16709088E-05_JPRB, 0.16602614E-05_JPRB, 0.16506662E-05_JPRB, &
  & 0.16429931E-05_JPRB, 0.16362496E-05_JPRB, 0.16292599E-05_JPRB, 0.16226912E-05_JPRB, 0.16159257E-05_JPRB, 0.16077724E-05_JPRB, &
  & 0.16013238E-05_JPRB, 0.15976310E-05_JPRB, 0.15951960E-05_JPRB, 0.15984999E-05_JPRB  /)

RGHG2(:,45, 7) = (/ &
  & 0.17158683E-05_JPRB, 0.17156215E-05_JPRB, 0.17154617E-05_JPRB, 0.17152255E-05_JPRB, 0.17150341E-05_JPRB, 0.17148693E-05_JPRB, &
  & 0.17146533E-05_JPRB, 0.17141404E-05_JPRB, 0.17135999E-05_JPRB, 0.17133902E-05_JPRB, 0.17135196E-05_JPRB, 0.17139897E-05_JPRB, &
  & 0.17147592E-05_JPRB, 0.17154142E-05_JPRB, 0.17161952E-05_JPRB, 0.17168837E-05_JPRB, 0.17175500E-05_JPRB, 0.17182308E-05_JPRB, &
  & 0.17187177E-05_JPRB, 0.17190098E-05_JPRB, 0.17188530E-05_JPRB, 0.17181236E-05_JPRB, 0.17168391E-05_JPRB, 0.17154043E-05_JPRB, &
  & 0.17140899E-05_JPRB, 0.17128468E-05_JPRB, 0.17120117E-05_JPRB, 0.17112621E-05_JPRB, 0.17108964E-05_JPRB, 0.17109051E-05_JPRB, &
  & 0.17110093E-05_JPRB, 0.17112091E-05_JPRB, 0.17115351E-05_JPRB, 0.17122646E-05_JPRB, 0.17132448E-05_JPRB, 0.17146481E-05_JPRB, &
  & 0.17169066E-05_JPRB, 0.17207274E-05_JPRB, 0.17254399E-05_JPRB, 0.17308895E-05_JPRB, 0.17351085E-05_JPRB, 0.17376440E-05_JPRB, &
  & 0.17379123E-05_JPRB, 0.17371285E-05_JPRB, 0.17352901E-05_JPRB, 0.17324211E-05_JPRB, 0.17279867E-05_JPRB, 0.17216146E-05_JPRB, &
  & 0.17132238E-05_JPRB, 0.17042919E-05_JPRB, 0.16958331E-05_JPRB, 0.16859304E-05_JPRB, 0.16774610E-05_JPRB, 0.16695248E-05_JPRB, &
  & 0.16627153E-05_JPRB, 0.16568143E-05_JPRB, 0.16505143E-05_JPRB, 0.16453769E-05_JPRB, 0.16396800E-05_JPRB, 0.16323870E-05_JPRB, &
  & 0.16245381E-05_JPRB, 0.16206517E-05_JPRB, 0.16189942E-05_JPRB, 0.16230983E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART14',0,ZHOOK_HANDLE)



RGHG2(:,46, 7) = (/ &
  & 0.17150047E-05_JPRB, 0.17148122E-05_JPRB, 0.17147222E-05_JPRB, 0.17146368E-05_JPRB, 0.17145953E-05_JPRB, 0.17146177E-05_JPRB, &
  & 0.17146312E-05_JPRB, 0.17144305E-05_JPRB, 0.17141862E-05_JPRB, 0.17141565E-05_JPRB, 0.17142994E-05_JPRB, 0.17146499E-05_JPRB, &
  & 0.17152495E-05_JPRB, 0.17157755E-05_JPRB, 0.17164188E-05_JPRB, 0.17170002E-05_JPRB, 0.17175442E-05_JPRB, 0.17181089E-05_JPRB, &
  & 0.17184725E-05_JPRB, 0.17186499E-05_JPRB, 0.17184025E-05_JPRB, 0.17175790E-05_JPRB, 0.17162523E-05_JPRB, 0.17148038E-05_JPRB, &
  & 0.17134847E-05_JPRB, 0.17123672E-05_JPRB, 0.17116105E-05_JPRB, 0.17109492E-05_JPRB, 0.17106908E-05_JPRB, 0.17106701E-05_JPRB, &
  & 0.17107045E-05_JPRB, 0.17108235E-05_JPRB, 0.17110333E-05_JPRB, 0.17116649E-05_JPRB, 0.17126286E-05_JPRB, 0.17140486E-05_JPRB, &
  & 0.17163429E-05_JPRB, 0.17202287E-05_JPRB, 0.17250574E-05_JPRB, 0.17306265E-05_JPRB, 0.17349742E-05_JPRB, 0.17377616E-05_JPRB, &
  & 0.17382654E-05_JPRB, 0.17377650E-05_JPRB, 0.17364513E-05_JPRB, 0.17341729E-05_JPRB, 0.17304788E-05_JPRB, 0.17253334E-05_JPRB, &
  & 0.17189669E-05_JPRB, 0.17121035E-05_JPRB, 0.17052812E-05_JPRB, 0.16967478E-05_JPRB, 0.16894606E-05_JPRB, 0.16827457E-05_JPRB, &
  & 0.16764503E-05_JPRB, 0.16709221E-05_JPRB, 0.16648074E-05_JPRB, 0.16599096E-05_JPRB, 0.16547051E-05_JPRB, 0.16477880E-05_JPRB, &
  & 0.16400418E-05_JPRB, 0.16362346E-05_JPRB, 0.16347866E-05_JPRB, 0.16384964E-05_JPRB  /)

RGHG2(:,47, 7) = (/ &
  & 0.17138444E-05_JPRB, 0.17137041E-05_JPRB, 0.17136940E-05_JPRB, 0.17137628E-05_JPRB, 0.17138541E-05_JPRB, 0.17140339E-05_JPRB, &
  & 0.17142244E-05_JPRB, 0.17142951E-05_JPRB, 0.17143395E-05_JPRB, 0.17145266E-05_JPRB, 0.17147437E-05_JPRB, 0.17150331E-05_JPRB, &
  & 0.17154794E-05_JPRB, 0.17158824E-05_JPRB, 0.17163691E-05_JPRB, 0.17168355E-05_JPRB, 0.17172629E-05_JPRB, 0.17177396E-05_JPRB, &
  & 0.17180192E-05_JPRB, 0.17181191E-05_JPRB, 0.17178032E-05_JPRB, 0.17168933E-05_JPRB, 0.17155487E-05_JPRB, 0.17141230E-05_JPRB, &
  & 0.17128234E-05_JPRB, 0.17118804E-05_JPRB, 0.17112240E-05_JPRB, 0.17106720E-05_JPRB, 0.17105245E-05_JPRB, 0.17104255E-05_JPRB, &
  & 0.17103580E-05_JPRB, 0.17103555E-05_JPRB, 0.17104194E-05_JPRB, 0.17109507E-05_JPRB, 0.17119266E-05_JPRB, 0.17133752E-05_JPRB, &
  & 0.17157093E-05_JPRB, 0.17196506E-05_JPRB, 0.17245861E-05_JPRB, 0.17302572E-05_JPRB, 0.17347476E-05_JPRB, 0.17378318E-05_JPRB, &
  & 0.17385752E-05_JPRB, 0.17383553E-05_JPRB, 0.17376613E-05_JPRB, 0.17360205E-05_JPRB, 0.17331132E-05_JPRB, 0.17293074E-05_JPRB, &
  & 0.17252353E-05_JPRB, 0.17207209E-05_JPRB, 0.17156165E-05_JPRB, 0.17085988E-05_JPRB, 0.17024997E-05_JPRB, 0.16971300E-05_JPRB, &
  & 0.16913679E-05_JPRB, 0.16861829E-05_JPRB, 0.16801849E-05_JPRB, 0.16753295E-05_JPRB, 0.16705872E-05_JPRB, 0.16640143E-05_JPRB, &
  & 0.16566895E-05_JPRB, 0.16530299E-05_JPRB, 0.16517140E-05_JPRB, 0.16547218E-05_JPRB  /)

RGHG2(:,48, 7) = (/ &
  & 0.17128500E-05_JPRB, 0.17127431E-05_JPRB, 0.17127332E-05_JPRB, 0.17128479E-05_JPRB, 0.17129704E-05_JPRB, 0.17132099E-05_JPRB, &
  & 0.17134706E-05_JPRB, 0.17136440E-05_JPRB, 0.17138120E-05_JPRB, 0.17141142E-05_JPRB, 0.17144118E-05_JPRB, 0.17147060E-05_JPRB, &
  & 0.17150760E-05_JPRB, 0.17153949E-05_JPRB, 0.17157541E-05_JPRB, 0.17161314E-05_JPRB, 0.17164761E-05_JPRB, 0.17168885E-05_JPRB, &
  & 0.17171571E-05_JPRB, 0.17172677E-05_JPRB, 0.17169758E-05_JPRB, 0.17160793E-05_JPRB, 0.17148007E-05_JPRB, 0.17134674E-05_JPRB, &
  & 0.17122699E-05_JPRB, 0.17115041E-05_JPRB, 0.17109396E-05_JPRB, 0.17104858E-05_JPRB, 0.17103556E-05_JPRB, 0.17101925E-05_JPRB, &
  & 0.17100220E-05_JPRB, 0.17099365E-05_JPRB, 0.17099466E-05_JPRB, 0.17103989E-05_JPRB, 0.17113725E-05_JPRB, 0.17128368E-05_JPRB, &
  & 0.17152143E-05_JPRB, 0.17191937E-05_JPRB, 0.17241511E-05_JPRB, 0.17297779E-05_JPRB, 0.17343447E-05_JPRB, 0.17377113E-05_JPRB, &
  & 0.17386027E-05_JPRB, 0.17385721E-05_JPRB, 0.17383907E-05_JPRB, 0.17372938E-05_JPRB, 0.17350965E-05_JPRB, 0.17327093E-05_JPRB, &
  & 0.17308778E-05_JPRB, 0.17285739E-05_JPRB, 0.17250795E-05_JPRB, 0.17195069E-05_JPRB, 0.17145051E-05_JPRB, 0.17100794E-05_JPRB, &
  & 0.17050017E-05_JPRB, 0.17000983E-05_JPRB, 0.16940367E-05_JPRB, 0.16889739E-05_JPRB, 0.16842527E-05_JPRB, 0.16780017E-05_JPRB, &
  & 0.16710289E-05_JPRB, 0.16675242E-05_JPRB, 0.16659543E-05_JPRB, 0.16680993E-05_JPRB  /)

RGHG2(:,49, 7) = (/ &
  & 0.17118241E-05_JPRB, 0.17117457E-05_JPRB, 0.17116998E-05_JPRB, 0.17118161E-05_JPRB, 0.17119270E-05_JPRB, 0.17121882E-05_JPRB, &
  & 0.17124782E-05_JPRB, 0.17126884E-05_JPRB, 0.17129184E-05_JPRB, 0.17133017E-05_JPRB, 0.17136914E-05_JPRB, 0.17140207E-05_JPRB, &
  & 0.17143414E-05_JPRB, 0.17145849E-05_JPRB, 0.17148161E-05_JPRB, 0.17151063E-05_JPRB, 0.17153749E-05_JPRB, 0.17157271E-05_JPRB, &
  & 0.17160166E-05_JPRB, 0.17161790E-05_JPRB, 0.17159558E-05_JPRB, 0.17151196E-05_JPRB, 0.17139522E-05_JPRB, 0.17127528E-05_JPRB, &
  & 0.17117060E-05_JPRB, 0.17111376E-05_JPRB, 0.17106710E-05_JPRB, 0.17103210E-05_JPRB, 0.17101674E-05_JPRB, 0.17099399E-05_JPRB, &
  & 0.17096547E-05_JPRB, 0.17094947E-05_JPRB, 0.17094873E-05_JPRB, 0.17098617E-05_JPRB, 0.17108261E-05_JPRB, 0.17123022E-05_JPRB, &
  & 0.17147290E-05_JPRB, 0.17187427E-05_JPRB, 0.17236859E-05_JPRB, 0.17291972E-05_JPRB, 0.17338184E-05_JPRB, 0.17374913E-05_JPRB, &
  & 0.17385049E-05_JPRB, 0.17386425E-05_JPRB, 0.17389798E-05_JPRB, 0.17384428E-05_JPRB, 0.17369970E-05_JPRB, 0.17362164E-05_JPRB, &
  & 0.17368418E-05_JPRB, 0.17369228E-05_JPRB, 0.17351622E-05_JPRB, 0.17311578E-05_JPRB, 0.17273300E-05_JPRB, 0.17237670E-05_JPRB, &
  & 0.17195162E-05_JPRB, 0.17148964E-05_JPRB, 0.17086825E-05_JPRB, 0.17032766E-05_JPRB, 0.16983780E-05_JPRB, 0.16924734E-05_JPRB, &
  & 0.16858588E-05_JPRB, 0.16825290E-05_JPRB, 0.16805021E-05_JPRB, 0.16816188E-05_JPRB  /)

RGHG2(:,50, 7) = (/ &
  & 0.17107224E-05_JPRB, 0.17106280E-05_JPRB, 0.17105412E-05_JPRB, 0.17106494E-05_JPRB, 0.17107461E-05_JPRB, 0.17110128E-05_JPRB, &
  & 0.17112942E-05_JPRB, 0.17115072E-05_JPRB, 0.17117498E-05_JPRB, 0.17121733E-05_JPRB, 0.17126164E-05_JPRB, 0.17129885E-05_JPRB, &
  & 0.17132900E-05_JPRB, 0.17134780E-05_JPRB, 0.17136382E-05_JPRB, 0.17138782E-05_JPRB, 0.17140973E-05_JPRB, 0.17144203E-05_JPRB, &
  & 0.17147670E-05_JPRB, 0.17150233E-05_JPRB, 0.17148919E-05_JPRB, 0.17141784E-05_JPRB, 0.17131813E-05_JPRB, 0.17121553E-05_JPRB, &
  & 0.17112586E-05_JPRB, 0.17108376E-05_JPRB, 0.17104631E-05_JPRB, 0.17101894E-05_JPRB, 0.17099667E-05_JPRB, 0.17096316E-05_JPRB, &
  & 0.17092712E-05_JPRB, 0.17090947E-05_JPRB, 0.17091049E-05_JPRB, 0.17094435E-05_JPRB, 0.17103916E-05_JPRB, 0.17119020E-05_JPRB, &
  & 0.17143822E-05_JPRB, 0.17184074E-05_JPRB, 0.17232657E-05_JPRB, 0.17286397E-05_JPRB, 0.17333170E-05_JPRB, 0.17371330E-05_JPRB, &
  & 0.17381768E-05_JPRB, 0.17384611E-05_JPRB, 0.17391815E-05_JPRB, 0.17391305E-05_JPRB, 0.17383715E-05_JPRB, 0.17391309E-05_JPRB, &
  & 0.17417177E-05_JPRB, 0.17436737E-05_JPRB, 0.17433890E-05_JPRB, 0.17406009E-05_JPRB, 0.17380077E-05_JPRB, 0.17353612E-05_JPRB, &
  & 0.17319423E-05_JPRB, 0.17277772E-05_JPRB, 0.17218379E-05_JPRB, 0.17164028E-05_JPRB, 0.17114056E-05_JPRB, 0.17058112E-05_JPRB, &
  & 0.16995641E-05_JPRB, 0.16959081E-05_JPRB, 0.16937003E-05_JPRB, 0.16941807E-05_JPRB  /)

RGHG2(:,51, 7) = (/ &
  & 0.17094908E-05_JPRB, 0.17093558E-05_JPRB, 0.17092223E-05_JPRB, 0.17093165E-05_JPRB, 0.17093965E-05_JPRB, 0.17096606E-05_JPRB, &
  & 0.17099127E-05_JPRB, 0.17101108E-05_JPRB, 0.17103412E-05_JPRB, 0.17107866E-05_JPRB, 0.17112673E-05_JPRB, 0.17116896E-05_JPRB, &
  & 0.17119864E-05_JPRB, 0.17121245E-05_JPRB, 0.17122379E-05_JPRB, 0.17124429E-05_JPRB, 0.17126228E-05_JPRB, 0.17129305E-05_JPRB, &
  & 0.17133580E-05_JPRB, 0.17137380E-05_JPRB, 0.17137180E-05_JPRB, 0.17131702E-05_JPRB, 0.17123881E-05_JPRB, 0.17115707E-05_JPRB, &
  & 0.17108361E-05_JPRB, 0.17105479E-05_JPRB, 0.17102700E-05_JPRB, 0.17100645E-05_JPRB, 0.17097430E-05_JPRB, 0.17092689E-05_JPRB, &
  & 0.17088477E-05_JPRB, 0.17086839E-05_JPRB, 0.17087317E-05_JPRB, 0.17090538E-05_JPRB, 0.17099804E-05_JPRB, 0.17115397E-05_JPRB, &
  & 0.17140798E-05_JPRB, 0.17181055E-05_JPRB, 0.17228349E-05_JPRB, 0.17280489E-05_JPRB, 0.17327878E-05_JPRB, 0.17366729E-05_JPRB, &
  & 0.17377010E-05_JPRB, 0.17381325E-05_JPRB, 0.17391961E-05_JPRB, 0.17396320E-05_JPRB, 0.17395819E-05_JPRB, 0.17419720E-05_JPRB, &
  & 0.17464197E-05_JPRB, 0.17501358E-05_JPRB, 0.17513118E-05_JPRB, 0.17496544E-05_JPRB, 0.17484283E-05_JPRB, 0.17468015E-05_JPRB, &
  & 0.17442851E-05_JPRB, 0.17407018E-05_JPRB, 0.17352839E-05_JPRB, 0.17299821E-05_JPRB, 0.17249198E-05_JPRB, 0.17196418E-05_JPRB, &
  & 0.17137973E-05_JPRB, 0.17095250E-05_JPRB, 0.17072665E-05_JPRB, 0.17072648E-05_JPRB  /)

RGHG2(:,52, 7) = (/ &
  & 0.17083157E-05_JPRB, 0.17081584E-05_JPRB, 0.17080036E-05_JPRB, 0.17080904E-05_JPRB, 0.17081699E-05_JPRB, 0.17084151E-05_JPRB, &
  & 0.17086342E-05_JPRB, 0.17088110E-05_JPRB, 0.17090187E-05_JPRB, 0.17094479E-05_JPRB, 0.17099234E-05_JPRB, 0.17103723E-05_JPRB, &
  & 0.17106712E-05_JPRB, 0.17107938E-05_JPRB, 0.17109079E-05_JPRB, 0.17111082E-05_JPRB, 0.17112878E-05_JPRB, 0.17116162E-05_JPRB, &
  & 0.17121102E-05_JPRB, 0.17126048E-05_JPRB, 0.17126924E-05_JPRB, 0.17122890E-05_JPRB, 0.17116944E-05_JPRB, 0.17110663E-05_JPRB, &
  & 0.17104752E-05_JPRB, 0.17102448E-05_JPRB, 0.17100463E-05_JPRB, 0.17098843E-05_JPRB, 0.17095150E-05_JPRB, 0.17089496E-05_JPRB, &
  & 0.17084784E-05_JPRB, 0.17083320E-05_JPRB, 0.17083727E-05_JPRB, 0.17086930E-05_JPRB, 0.17096099E-05_JPRB, 0.17112165E-05_JPRB, &
  & 0.17138194E-05_JPRB, 0.17177992E-05_JPRB, 0.17223481E-05_JPRB, 0.17274798E-05_JPRB, 0.17322194E-05_JPRB, 0.17360161E-05_JPRB, &
  & 0.17370651E-05_JPRB, 0.17375955E-05_JPRB, 0.17388798E-05_JPRB, 0.17397100E-05_JPRB, 0.17403457E-05_JPRB, 0.17439830E-05_JPRB, &
  & 0.17495782E-05_JPRB, 0.17543668E-05_JPRB, 0.17565500E-05_JPRB, 0.17557777E-05_JPRB, 0.17556120E-05_JPRB, 0.17547406E-05_JPRB, &
  & 0.17529401E-05_JPRB, 0.17499627E-05_JPRB, 0.17452321E-05_JPRB, 0.17404179E-05_JPRB, 0.17356456E-05_JPRB, 0.17306155E-05_JPRB, &
  & 0.17253827E-05_JPRB, 0.17211035E-05_JPRB, 0.17187485E-05_JPRB, 0.17187339E-05_JPRB  /)

RGHG2(:,53, 7) = (/ &
  & 0.17070576E-05_JPRB, 0.17068832E-05_JPRB, 0.17067151E-05_JPRB, 0.17067964E-05_JPRB, 0.17068814E-05_JPRB, 0.17070999E-05_JPRB, &
  & 0.17072816E-05_JPRB, 0.17074325E-05_JPRB, 0.17076117E-05_JPRB, 0.17080086E-05_JPRB, 0.17084620E-05_JPRB, 0.17089307E-05_JPRB, &
  & 0.17092347E-05_JPRB, 0.17093536E-05_JPRB, 0.17094866E-05_JPRB, 0.17096933E-05_JPRB, 0.17098876E-05_JPRB, 0.17102525E-05_JPRB, &
  & 0.17108133E-05_JPRB, 0.17114293E-05_JPRB, 0.17116327E-05_JPRB, 0.17113782E-05_JPRB, 0.17109773E-05_JPRB, 0.17105480E-05_JPRB, &
  & 0.17101058E-05_JPRB, 0.17099096E-05_JPRB, 0.17097908E-05_JPRB, 0.17096666E-05_JPRB, 0.17092651E-05_JPRB, 0.17086185E-05_JPRB, &
  & 0.17080971E-05_JPRB, 0.17079714E-05_JPRB, 0.17079872E-05_JPRB, 0.17083111E-05_JPRB, 0.17092221E-05_JPRB, 0.17108794E-05_JPRB, &
  & 0.17135520E-05_JPRB, 0.17174639E-05_JPRB, 0.17217966E-05_JPRB, 0.17268683E-05_JPRB, 0.17315854E-05_JPRB, 0.17352253E-05_JPRB, &
  & 0.17363111E-05_JPRB, 0.17369305E-05_JPRB, 0.17384080E-05_JPRB, 0.17396321E-05_JPRB, 0.17410057E-05_JPRB, 0.17458537E-05_JPRB, &
  & 0.17524238E-05_JPRB, 0.17581159E-05_JPRB, 0.17612215E-05_JPRB, 0.17613185E-05_JPRB, 0.17621896E-05_JPRB, 0.17620390E-05_JPRB, &
  & 0.17609465E-05_JPRB, 0.17586383E-05_JPRB, 0.17547198E-05_JPRB, 0.17505730E-05_JPRB, 0.17462531E-05_JPRB, 0.17414665E-05_JPRB, &
  & 0.17369804E-05_JPRB, 0.17329281E-05_JPRB, 0.17304505E-05_JPRB, 0.17306023E-05_JPRB  /)

RGHG2(:,54, 7) = (/ &
  & 0.17061621E-05_JPRB, 0.17059954E-05_JPRB, 0.17058203E-05_JPRB, 0.17058963E-05_JPRB, 0.17059834E-05_JPRB, 0.17061588E-05_JPRB, &
  & 0.17063066E-05_JPRB, 0.17064397E-05_JPRB, 0.17065954E-05_JPRB, 0.17069422E-05_JPRB, 0.17073482E-05_JPRB, 0.17078025E-05_JPRB, &
  & 0.17081189E-05_JPRB, 0.17082476E-05_JPRB, 0.17083984E-05_JPRB, 0.17086319E-05_JPRB, 0.17088839E-05_JPRB, 0.17092834E-05_JPRB, &
  & 0.17098632E-05_JPRB, 0.17105165E-05_JPRB, 0.17108135E-05_JPRB, 0.17106554E-05_JPRB, 0.17103809E-05_JPRB, 0.17100935E-05_JPRB, &
  & 0.17097643E-05_JPRB, 0.17095977E-05_JPRB, 0.17095087E-05_JPRB, 0.17093728E-05_JPRB, 0.17090413E-05_JPRB, 0.17083845E-05_JPRB, &
  & 0.17078427E-05_JPRB, 0.17077050E-05_JPRB, 0.17077190E-05_JPRB, 0.17080204E-05_JPRB, 0.17089260E-05_JPRB, 0.17105776E-05_JPRB, &
  & 0.17132449E-05_JPRB, 0.17170818E-05_JPRB, 0.17212485E-05_JPRB, 0.17262246E-05_JPRB, 0.17307506E-05_JPRB, 0.17341164E-05_JPRB, &
  & 0.17354312E-05_JPRB, 0.17362140E-05_JPRB, 0.17378329E-05_JPRB, 0.17392907E-05_JPRB, 0.17413152E-05_JPRB, 0.17470363E-05_JPRB, &
  & 0.17540092E-05_JPRB, 0.17601068E-05_JPRB, 0.17636656E-05_JPRB, 0.17643564E-05_JPRB, 0.17657497E-05_JPRB, 0.17658099E-05_JPRB, &
  & 0.17650776E-05_JPRB, 0.17633238E-05_JPRB, 0.17600750E-05_JPRB, 0.17565077E-05_JPRB, 0.17526417E-05_JPRB, 0.17483532E-05_JPRB, &
  & 0.17443064E-05_JPRB, 0.17406336E-05_JPRB, 0.17384446E-05_JPRB, 0.17386576E-05_JPRB  /)

RGHG2(:,55, 7) = (/ &
  & 0.17052178E-05_JPRB, 0.17050629E-05_JPRB, 0.17048809E-05_JPRB, 0.17049510E-05_JPRB, 0.17050401E-05_JPRB, 0.17051656E-05_JPRB, &
  & 0.17052762E-05_JPRB, 0.17053907E-05_JPRB, 0.17055209E-05_JPRB, 0.17058100E-05_JPRB, 0.17061603E-05_JPRB, 0.17065939E-05_JPRB, &
  & 0.17069250E-05_JPRB, 0.17070665E-05_JPRB, 0.17072369E-05_JPRB, 0.17075026E-05_JPRB, 0.17078241E-05_JPRB, 0.17082618E-05_JPRB, &
  & 0.17088563E-05_JPRB, 0.17095399E-05_JPRB, 0.17099377E-05_JPRB, 0.17098794E-05_JPRB, 0.17097361E-05_JPRB, 0.17095984E-05_JPRB, &
  & 0.17093895E-05_JPRB, 0.17092553E-05_JPRB, 0.17091927E-05_JPRB, 0.17090372E-05_JPRB, 0.17087967E-05_JPRB, 0.17081380E-05_JPRB, &
  & 0.17075776E-05_JPRB, 0.17074223E-05_JPRB, 0.17074373E-05_JPRB, 0.17077103E-05_JPRB, 0.17086100E-05_JPRB, 0.17102479E-05_JPRB, &
  & 0.17128996E-05_JPRB, 0.17166523E-05_JPRB, 0.17206419E-05_JPRB, 0.17255074E-05_JPRB, 0.17297994E-05_JPRB, 0.17328462E-05_JPRB, &
  & 0.17344399E-05_JPRB, 0.17354136E-05_JPRB, 0.17371822E-05_JPRB, 0.17388778E-05_JPRB, 0.17416118E-05_JPRB, 0.17482558E-05_JPRB, &
  & 0.17555997E-05_JPRB, 0.17620809E-05_JPRB, 0.17660801E-05_JPRB, 0.17673924E-05_JPRB, 0.17692966E-05_JPRB, 0.17695231E-05_JPRB, &
  & 0.17691442E-05_JPRB, 0.17679892E-05_JPRB, 0.17654637E-05_JPRB, 0.17625266E-05_JPRB, 0.17591637E-05_JPRB, 0.17554604E-05_JPRB, &
  & 0.17518600E-05_JPRB, 0.17486275E-05_JPRB, 0.17468124E-05_JPRB, 0.17470792E-05_JPRB  /)

RGHG2(:,56, 7) = (/ &
  & 0.17047152E-05_JPRB, 0.17045578E-05_JPRB, 0.17043746E-05_JPRB, 0.17044412E-05_JPRB, 0.17045249E-05_JPRB, 0.17046200E-05_JPRB, &
  & 0.17047102E-05_JPRB, 0.17048166E-05_JPRB, 0.17049311E-05_JPRB, 0.17051783E-05_JPRB, 0.17054771E-05_JPRB, 0.17058684E-05_JPRB, &
  & 0.17061945E-05_JPRB, 0.17063469E-05_JPRB, 0.17065326E-05_JPRB, 0.17068215E-05_JPRB, 0.17071918E-05_JPRB, 0.17076728E-05_JPRB, &
  & 0.17082549E-05_JPRB, 0.17089024E-05_JPRB, 0.17093576E-05_JPRB, 0.17093589E-05_JPRB, 0.17092567E-05_JPRB, 0.17092079E-05_JPRB, &
  & 0.17091115E-05_JPRB, 0.17089649E-05_JPRB, 0.17088886E-05_JPRB, 0.17086373E-05_JPRB, 0.17084878E-05_JPRB, 0.17079683E-05_JPRB, &
  & 0.17075126E-05_JPRB, 0.17072812E-05_JPRB, 0.17072667E-05_JPRB, 0.17075611E-05_JPRB, 0.17084250E-05_JPRB, 0.17100186E-05_JPRB, &
  & 0.17125772E-05_JPRB, 0.17161888E-05_JPRB, 0.17200251E-05_JPRB, 0.17246244E-05_JPRB, 0.17285475E-05_JPRB, 0.17313165E-05_JPRB, &
  & 0.17332662E-05_JPRB, 0.17346152E-05_JPRB, 0.17365500E-05_JPRB, 0.17384552E-05_JPRB, 0.17418884E-05_JPRB, 0.17489583E-05_JPRB, &
  & 0.17563541E-05_JPRB, 0.17629911E-05_JPRB, 0.17670012E-05_JPRB, 0.17686590E-05_JPRB, 0.17706311E-05_JPRB, 0.17708828E-05_JPRB, &
  & 0.17707042E-05_JPRB, 0.17697754E-05_JPRB, 0.17675984E-05_JPRB, 0.17649159E-05_JPRB, 0.17618768E-05_JPRB, 0.17585570E-05_JPRB, &
  & 0.17553542E-05_JPRB, 0.17524900E-05_JPRB, 0.17509071E-05_JPRB, 0.17512622E-05_JPRB  /)

RGHG2(:,57, 7) = (/ &
  & 0.17042084E-05_JPRB, 0.17040438E-05_JPRB, 0.17038617E-05_JPRB, 0.17039255E-05_JPRB, 0.17040070E-05_JPRB, 0.17040752E-05_JPRB, &
  & 0.17041470E-05_JPRB, 0.17042451E-05_JPRB, 0.17043442E-05_JPRB, 0.17045573E-05_JPRB, 0.17048094E-05_JPRB, 0.17051546E-05_JPRB, &
  & 0.17054688E-05_JPRB, 0.17056359E-05_JPRB, 0.17058396E-05_JPRB, 0.17061469E-05_JPRB, 0.17065568E-05_JPRB, 0.17070760E-05_JPRB, &
  & 0.17076502E-05_JPRB, 0.17082642E-05_JPRB, 0.17087761E-05_JPRB, 0.17088465E-05_JPRB, 0.17087825E-05_JPRB, 0.17088093E-05_JPRB, &
  & 0.17088022E-05_JPRB, 0.17086636E-05_JPRB, 0.17085536E-05_JPRB, 0.17082396E-05_JPRB, 0.17081315E-05_JPRB, 0.17077243E-05_JPRB, &
  & 0.17073914E-05_JPRB, 0.17071375E-05_JPRB, 0.17070906E-05_JPRB, 0.17074325E-05_JPRB, 0.17082894E-05_JPRB, 0.17098063E-05_JPRB, &
  & 0.17122420E-05_JPRB, 0.17156442E-05_JPRB, 0.17193085E-05_JPRB, 0.17236150E-05_JPRB, 0.17271475E-05_JPRB, 0.17296495E-05_JPRB, &
  & 0.17319577E-05_JPRB, 0.17337661E-05_JPRB, 0.17358872E-05_JPRB, 0.17380536E-05_JPRB, 0.17422277E-05_JPRB, 0.17496964E-05_JPRB, &
  & 0.17571584E-05_JPRB, 0.17639329E-05_JPRB, 0.17679626E-05_JPRB, 0.17699909E-05_JPRB, 0.17719893E-05_JPRB, 0.17722601E-05_JPRB, &
  & 0.17722900E-05_JPRB, 0.17715889E-05_JPRB, 0.17697292E-05_JPRB, 0.17672977E-05_JPRB, 0.17645874E-05_JPRB, 0.17616029E-05_JPRB, &
  & 0.17588021E-05_JPRB, 0.17563076E-05_JPRB, 0.17549740E-05_JPRB, 0.17553578E-05_JPRB  /)

RGHG2(:,58, 7) = (/ &
  & 0.17038181E-05_JPRB, 0.17036361E-05_JPRB, 0.17034602E-05_JPRB, 0.17035230E-05_JPRB, 0.17036065E-05_JPRB, 0.17036595E-05_JPRB, &
  & 0.17037211E-05_JPRB, 0.17038131E-05_JPRB, 0.17039000E-05_JPRB, 0.17040978E-05_JPRB, 0.17043165E-05_JPRB, 0.17046089E-05_JPRB, &
  & 0.17048966E-05_JPRB, 0.17050830E-05_JPRB, 0.17053070E-05_JPRB, 0.17056214E-05_JPRB, 0.17060486E-05_JPRB, 0.17065952E-05_JPRB, &
  & 0.17071644E-05_JPRB, 0.17077398E-05_JPRB, 0.17082943E-05_JPRB, 0.17084369E-05_JPRB, 0.17083860E-05_JPRB, 0.17084484E-05_JPRB, &
  & 0.17084830E-05_JPRB, 0.17083779E-05_JPRB, 0.17081958E-05_JPRB, 0.17078655E-05_JPRB, 0.17077117E-05_JPRB, 0.17073888E-05_JPRB, &
  & 0.17072225E-05_JPRB, 0.17070275E-05_JPRB, 0.17069400E-05_JPRB, 0.17073795E-05_JPRB, 0.17082729E-05_JPRB, 0.17096588E-05_JPRB, &
  & 0.17119167E-05_JPRB, 0.17149999E-05_JPRB, 0.17184794E-05_JPRB, 0.17224425E-05_JPRB, 0.17255533E-05_JPRB, 0.17278360E-05_JPRB, &
  & 0.17304926E-05_JPRB, 0.17329004E-05_JPRB, 0.17352297E-05_JPRB, 0.17377181E-05_JPRB, 0.17426419E-05_JPRB, 0.17503381E-05_JPRB, &
  & 0.17578256E-05_JPRB, 0.17646529E-05_JPRB, 0.17686349E-05_JPRB, 0.17709943E-05_JPRB, 0.17728637E-05_JPRB, 0.17731152E-05_JPRB, &
  & 0.17733219E-05_JPRB, 0.17727630E-05_JPRB, 0.17710719E-05_JPRB, 0.17687948E-05_JPRB, 0.17663618E-05_JPRB, 0.17635663E-05_JPRB, &
  & 0.17611332E-05_JPRB, 0.17589678E-05_JPRB, 0.17578659E-05_JPRB, 0.17581817E-05_JPRB  /)

RGHG2(:,59, 7) = (/ &
  & 0.17034720E-05_JPRB, 0.17032836E-05_JPRB, 0.17031257E-05_JPRB, 0.17031929E-05_JPRB, 0.17032793E-05_JPRB, 0.17033287E-05_JPRB, &
  & 0.17033903E-05_JPRB, 0.17034800E-05_JPRB, 0.17035608E-05_JPRB, 0.17037575E-05_JPRB, 0.17039555E-05_JPRB, 0.17042039E-05_JPRB, &
  & 0.17044617E-05_JPRB, 0.17046621E-05_JPRB, 0.17049059E-05_JPRB, 0.17052196E-05_JPRB, 0.17056399E-05_JPRB, 0.17061875E-05_JPRB, &
  & 0.17067475E-05_JPRB, 0.17073004E-05_JPRB, 0.17078698E-05_JPRB, 0.17080996E-05_JPRB, 0.17080740E-05_JPRB, 0.17081495E-05_JPRB, &
  & 0.17082034E-05_JPRB, 0.17081205E-05_JPRB, 0.17078850E-05_JPRB, 0.17075154E-05_JPRB, 0.17073594E-05_JPRB, 0.17071330E-05_JPRB, &
  & 0.17070717E-05_JPRB, 0.17069569E-05_JPRB, 0.17068692E-05_JPRB, 0.17073365E-05_JPRB, 0.17082891E-05_JPRB, 0.17095832E-05_JPRB, &
  & 0.17114969E-05_JPRB, 0.17142206E-05_JPRB, 0.17174835E-05_JPRB, 0.17210530E-05_JPRB, 0.17238312E-05_JPRB, 0.17261761E-05_JPRB, &
  & 0.17290376E-05_JPRB, 0.17320662E-05_JPRB, 0.17347020E-05_JPRB, 0.17376342E-05_JPRB, 0.17431017E-05_JPRB, 0.17509560E-05_JPRB, &
  & 0.17584825E-05_JPRB, 0.17653177E-05_JPRB, 0.17692568E-05_JPRB, 0.17718651E-05_JPRB, 0.17734634E-05_JPRB, 0.17737158E-05_JPRB, &
  & 0.17740653E-05_JPRB, 0.17735946E-05_JPRB, 0.17719900E-05_JPRB, 0.17697819E-05_JPRB, 0.17675361E-05_JPRB, 0.17648863E-05_JPRB, &
  & 0.17627068E-05_JPRB, 0.17608316E-05_JPRB, 0.17599534E-05_JPRB, 0.17601378E-05_JPRB  /)

RGHG2(:,60, 7) = (/ &
  & 0.17031430E-05_JPRB, 0.17029536E-05_JPRB, 0.17028186E-05_JPRB, 0.17028917E-05_JPRB, 0.17029808E-05_JPRB, 0.17030308E-05_JPRB, &
  & 0.17030968E-05_JPRB, 0.17031853E-05_JPRB, 0.17032622E-05_JPRB, 0.17034625E-05_JPRB, 0.17036449E-05_JPRB, 0.17038548E-05_JPRB, &
  & 0.17040807E-05_JPRB, 0.17042925E-05_JPRB, 0.17045546E-05_JPRB, 0.17048635E-05_JPRB, 0.17052651E-05_JPRB, 0.17058004E-05_JPRB, &
  & 0.17063470E-05_JPRB, 0.17068815E-05_JPRB, 0.17074522E-05_JPRB, 0.17077736E-05_JPRB, 0.17077878E-05_JPRB, 0.17078680E-05_JPRB, &
  & 0.17079329E-05_JPRB, 0.17078632E-05_JPRB, 0.17075820E-05_JPRB, 0.17071637E-05_JPRB, 0.17070163E-05_JPRB, 0.17069008E-05_JPRB, &
  & 0.17069509E-05_JPRB, 0.17069275E-05_JPRB, 0.17068401E-05_JPRB, 0.17072918E-05_JPRB, 0.17083073E-05_JPRB, 0.17095022E-05_JPRB, &
  & 0.17109847E-05_JPRB, 0.17133350E-05_JPRB, 0.17163283E-05_JPRB, 0.17194615E-05_JPRB, 0.17219868E-05_JPRB, 0.17245383E-05_JPRB, &
  & 0.17275470E-05_JPRB, 0.17312066E-05_JPRB, 0.17342296E-05_JPRB, 0.17376824E-05_JPRB, 0.17436202E-05_JPRB, 0.17516137E-05_JPRB, &
  & 0.17591905E-05_JPRB, 0.17660076E-05_JPRB, 0.17698936E-05_JPRB, 0.17726965E-05_JPRB, 0.17739722E-05_JPRB, 0.17742394E-05_JPRB, &
  & 0.17747217E-05_JPRB, 0.17743086E-05_JPRB, 0.17727629E-05_JPRB, 0.17705930E-05_JPRB, 0.17684947E-05_JPRB, 0.17659806E-05_JPRB, &
  & 0.17640166E-05_JPRB, 0.17624123E-05_JPRB, 0.17617370E-05_JPRB, 0.17617791E-05_JPRB  /)

RGHG2(:,61, 7) = (/ &
  & 0.17028803E-05_JPRB, 0.17026986E-05_JPRB, 0.17025879E-05_JPRB, 0.17026643E-05_JPRB, 0.17027545E-05_JPRB, 0.17028079E-05_JPRB, &
  & 0.17028827E-05_JPRB, 0.17029689E-05_JPRB, 0.17030436E-05_JPRB, 0.17032494E-05_JPRB, 0.17034219E-05_JPRB, 0.17036120E-05_JPRB, &
  & 0.17038070E-05_JPRB, 0.17040244E-05_JPRB, 0.17042964E-05_JPRB, 0.17045943E-05_JPRB, 0.17049628E-05_JPRB, 0.17054673E-05_JPRB, &
  & 0.17059896E-05_JPRB, 0.17065054E-05_JPRB, 0.17070574E-05_JPRB, 0.17074537E-05_JPRB, 0.17075461E-05_JPRB, 0.17076241E-05_JPRB, &
  & 0.17076923E-05_JPRB, 0.17076115E-05_JPRB, 0.17072995E-05_JPRB, 0.17068316E-05_JPRB, 0.17066798E-05_JPRB, 0.17067009E-05_JPRB, &
  & 0.17069493E-05_JPRB, 0.17070218E-05_JPRB, 0.17068848E-05_JPRB, 0.17072340E-05_JPRB, 0.17082892E-05_JPRB, 0.17093211E-05_JPRB, &
  & 0.17102969E-05_JPRB, 0.17123289E-05_JPRB, 0.17149190E-05_JPRB, 0.17175765E-05_JPRB, 0.17201017E-05_JPRB, 0.17230586E-05_JPRB, &
  & 0.17261378E-05_JPRB, 0.17303415E-05_JPRB, 0.17338943E-05_JPRB, 0.17379430E-05_JPRB, 0.17442376E-05_JPRB, 0.17523589E-05_JPRB, &
  & 0.17600062E-05_JPRB, 0.17667594E-05_JPRB, 0.17705529E-05_JPRB, 0.17734021E-05_JPRB, 0.17743771E-05_JPRB, 0.17746872E-05_JPRB, &
  & 0.17752830E-05_JPRB, 0.17748621E-05_JPRB, 0.17733572E-05_JPRB, 0.17712027E-05_JPRB, 0.17691805E-05_JPRB, 0.17667941E-05_JPRB, &
  & 0.17649997E-05_JPRB, 0.17635936E-05_JPRB, 0.17630142E-05_JPRB, 0.17629715E-05_JPRB  /)

RGHG2(:,62, 7) = (/ &
  & 0.17026546E-05_JPRB, 0.17024817E-05_JPRB, 0.17023919E-05_JPRB, 0.17024725E-05_JPRB, 0.17025655E-05_JPRB, 0.17026198E-05_JPRB, &
  & 0.17027013E-05_JPRB, 0.17027877E-05_JPRB, 0.17028609E-05_JPRB, 0.17030684E-05_JPRB, 0.17032347E-05_JPRB, 0.17034141E-05_JPRB, &
  & 0.17035838E-05_JPRB, 0.17038060E-05_JPRB, 0.17040850E-05_JPRB, 0.17043691E-05_JPRB, 0.17047035E-05_JPRB, 0.17051713E-05_JPRB, &
  & 0.17056702E-05_JPRB, 0.17061585E-05_JPRB, 0.17066782E-05_JPRB, 0.17071167E-05_JPRB, 0.17073200E-05_JPRB, 0.17074079E-05_JPRB, &
  & 0.17074640E-05_JPRB, 0.17073197E-05_JPRB, 0.17070020E-05_JPRB, 0.17065017E-05_JPRB, 0.17063119E-05_JPRB, 0.17064438E-05_JPRB, &
  & 0.17069326E-05_JPRB, 0.17070852E-05_JPRB, 0.17069428E-05_JPRB, 0.17071023E-05_JPRB, 0.17080516E-05_JPRB, 0.17088966E-05_JPRB, &
  & 0.17094922E-05_JPRB, 0.17112162E-05_JPRB, 0.17133716E-05_JPRB, 0.17157174E-05_JPRB, 0.17183298E-05_JPRB, 0.17216283E-05_JPRB, &
  & 0.17249214E-05_JPRB, 0.17295137E-05_JPRB, 0.17337142E-05_JPRB, 0.17383672E-05_JPRB, 0.17449975E-05_JPRB, 0.17533321E-05_JPRB, &
  & 0.17610384E-05_JPRB, 0.17675617E-05_JPRB, 0.17712353E-05_JPRB, 0.17740205E-05_JPRB, 0.17748157E-05_JPRB, 0.17751758E-05_JPRB, &
  & 0.17758357E-05_JPRB, 0.17753376E-05_JPRB, 0.17739195E-05_JPRB, 0.17717957E-05_JPRB, 0.17697548E-05_JPRB, 0.17674725E-05_JPRB, &
  & 0.17657985E-05_JPRB, 0.17645286E-05_JPRB, 0.17639771E-05_JPRB, 0.17639039E-05_JPRB  /)

RGHG2(:,63, 7) = (/ &
  & 0.17024582E-05_JPRB, 0.17022912E-05_JPRB, 0.17022207E-05_JPRB, 0.17023047E-05_JPRB, 0.17024026E-05_JPRB, 0.17024552E-05_JPRB, &
  & 0.17025404E-05_JPRB, 0.17026273E-05_JPRB, 0.17026998E-05_JPRB, 0.17029065E-05_JPRB, 0.17030691E-05_JPRB, 0.17032412E-05_JPRB, &
  & 0.17033911E-05_JPRB, 0.17036166E-05_JPRB, 0.17039015E-05_JPRB, 0.17041696E-05_JPRB, 0.17044710E-05_JPRB, 0.17048997E-05_JPRB, &
  & 0.17053733E-05_JPRB, 0.17058291E-05_JPRB, 0.17063077E-05_JPRB, 0.17067611E-05_JPRB, 0.17070837E-05_JPRB, 0.17072006E-05_JPRB, &
  & 0.17072326E-05_JPRB, 0.17070125E-05_JPRB, 0.17066950E-05_JPRB, 0.17061513E-05_JPRB, 0.17059200E-05_JPRB, 0.17061328E-05_JPRB, &
  & 0.17068528E-05_JPRB, 0.17070809E-05_JPRB, 0.17069559E-05_JPRB, 0.17068741E-05_JPRB, 0.17076312E-05_JPRB, 0.17083198E-05_JPRB, &
  & 0.17086302E-05_JPRB, 0.17100186E-05_JPRB, 0.17117859E-05_JPRB, 0.17139657E-05_JPRB, 0.17166954E-05_JPRB, 0.17203691E-05_JPRB, &
  & 0.17239064E-05_JPRB, 0.17287620E-05_JPRB, 0.17337084E-05_JPRB, 0.17389437E-05_JPRB, 0.17459171E-05_JPRB, 0.17545100E-05_JPRB, &
  & 0.17622152E-05_JPRB, 0.17684016E-05_JPRB, 0.17719382E-05_JPRB, 0.17745929E-05_JPRB, 0.17752928E-05_JPRB, 0.17756873E-05_JPRB, &
  & 0.17763916E-05_JPRB, 0.17757745E-05_JPRB, 0.17744685E-05_JPRB, 0.17723660E-05_JPRB, 0.17702326E-05_JPRB, 0.17680185E-05_JPRB, &
  & 0.17664056E-05_JPRB, 0.17652252E-05_JPRB, 0.17646455E-05_JPRB, 0.17645738E-05_JPRB  /)

RGHG2(:,64, 7) = (/ &
  & 0.17023044E-05_JPRB, 0.17021351E-05_JPRB, 0.17020826E-05_JPRB, 0.17021666E-05_JPRB, 0.17022729E-05_JPRB, 0.17023195E-05_JPRB, &
  & 0.17024035E-05_JPRB, 0.17024892E-05_JPRB, 0.17025617E-05_JPRB, 0.17027660E-05_JPRB, 0.17029274E-05_JPRB, 0.17030910E-05_JPRB, &
  & 0.17032301E-05_JPRB, 0.17034557E-05_JPRB, 0.17037466E-05_JPRB, 0.17039965E-05_JPRB, 0.17042703E-05_JPRB, 0.17046617E-05_JPRB, &
  & 0.17051052E-05_JPRB, 0.17055260E-05_JPRB, 0.17059576E-05_JPRB, 0.17063905E-05_JPRB, 0.17068155E-05_JPRB, 0.17069951E-05_JPRB, &
  & 0.17069897E-05_JPRB, 0.17067203E-05_JPRB, 0.17063919E-05_JPRB, 0.17057615E-05_JPRB, 0.17055156E-05_JPRB, 0.17057586E-05_JPRB, &
  & 0.17066340E-05_JPRB, 0.17069392E-05_JPRB, 0.17068431E-05_JPRB, 0.17064903E-05_JPRB, 0.17069968E-05_JPRB, 0.17076360E-05_JPRB, &
  & 0.17077789E-05_JPRB, 0.17087662E-05_JPRB, 0.17103095E-05_JPRB, 0.17125242E-05_JPRB, 0.17153514E-05_JPRB, 0.17195347E-05_JPRB, &
  & 0.17232359E-05_JPRB, 0.17281915E-05_JPRB, 0.17339774E-05_JPRB, 0.17397092E-05_JPRB, 0.17470523E-05_JPRB, 0.17559175E-05_JPRB, &
  & 0.17634842E-05_JPRB, 0.17692502E-05_JPRB, 0.17726410E-05_JPRB, 0.17751174E-05_JPRB, 0.17758124E-05_JPRB, 0.17761937E-05_JPRB, &
  & 0.17769426E-05_JPRB, 0.17761786E-05_JPRB, 0.17749954E-05_JPRB, 0.17728748E-05_JPRB, 0.17705656E-05_JPRB, 0.17683515E-05_JPRB, &
  & 0.17667000E-05_JPRB, 0.17655533E-05_JPRB, 0.17648760E-05_JPRB, 0.17648296E-05_JPRB  /)

RGHG2(:,65, 7) = (/ &
  & 0.17021744E-05_JPRB, 0.17020015E-05_JPRB, 0.17019628E-05_JPRB, 0.17020445E-05_JPRB, 0.17021627E-05_JPRB, 0.17022021E-05_JPRB, &
  & 0.17022793E-05_JPRB, 0.17023615E-05_JPRB, 0.17024340E-05_JPRB, 0.17026325E-05_JPRB, 0.17027938E-05_JPRB, 0.17029523E-05_JPRB, &
  & 0.17030894E-05_JPRB, 0.17033094E-05_JPRB, 0.17036041E-05_JPRB, 0.17038482E-05_JPRB, 0.17041008E-05_JPRB, 0.17044623E-05_JPRB, &
  & 0.17048766E-05_JPRB, 0.17052600E-05_JPRB, 0.17056431E-05_JPRB, 0.17060397E-05_JPRB, 0.17064805E-05_JPRB, 0.17067467E-05_JPRB, &
  & 0.17067531E-05_JPRB, 0.17064428E-05_JPRB, 0.17060418E-05_JPRB, 0.17053487E-05_JPRB, 0.17051354E-05_JPRB, 0.17054210E-05_JPRB, &
  & 0.17063262E-05_JPRB, 0.17067360E-05_JPRB, 0.17066030E-05_JPRB, 0.17061160E-05_JPRB, 0.17064587E-05_JPRB, 0.17070952E-05_JPRB, &
  & 0.17069494E-05_JPRB, 0.17076054E-05_JPRB, 0.17091280E-05_JPRB, 0.17114060E-05_JPRB, 0.17143528E-05_JPRB, 0.17190731E-05_JPRB, &
  & 0.17229405E-05_JPRB, 0.17280406E-05_JPRB, 0.17345336E-05_JPRB, 0.17407150E-05_JPRB, 0.17484857E-05_JPRB, 0.17574481E-05_JPRB, &
  & 0.17647182E-05_JPRB, 0.17700874E-05_JPRB, 0.17733684E-05_JPRB, 0.17757021E-05_JPRB, 0.17763968E-05_JPRB, 0.17766840E-05_JPRB, &
  & 0.17774767E-05_JPRB, 0.17766060E-05_JPRB, 0.17754121E-05_JPRB, 0.17731893E-05_JPRB, 0.17706961E-05_JPRB, 0.17684136E-05_JPRB, &
  & 0.17666605E-05_JPRB, 0.17653818E-05_JPRB, 0.17645389E-05_JPRB, 0.17646750E-05_JPRB  /)

RGHG2(:,66, 7) = (/ &
  & 0.17020577E-05_JPRB, 0.17018825E-05_JPRB, 0.17018545E-05_JPRB, 0.17019324E-05_JPRB, 0.17020608E-05_JPRB, 0.17020942E-05_JPRB, &
  & 0.17021633E-05_JPRB, 0.17022390E-05_JPRB, 0.17023086E-05_JPRB, 0.17025003E-05_JPRB, 0.17026630E-05_JPRB, 0.17028222E-05_JPRB, &
  & 0.17029575E-05_JPRB, 0.17031712E-05_JPRB, 0.17034661E-05_JPRB, 0.17037060E-05_JPRB, 0.17039468E-05_JPRB, 0.17042852E-05_JPRB, &
  & 0.17046720E-05_JPRB, 0.17050165E-05_JPRB, 0.17053519E-05_JPRB, 0.17057222E-05_JPRB, 0.17061406E-05_JPRB, 0.17064684E-05_JPRB, &
  & 0.17064858E-05_JPRB, 0.17061328E-05_JPRB, 0.17056332E-05_JPRB, 0.17049174E-05_JPRB, 0.17047686E-05_JPRB, 0.17050978E-05_JPRB, &
  & 0.17060786E-05_JPRB, 0.17065176E-05_JPRB, 0.17063351E-05_JPRB, 0.17058227E-05_JPRB, 0.17060503E-05_JPRB, 0.17066647E-05_JPRB, &
  & 0.17061984E-05_JPRB, 0.17066197E-05_JPRB, 0.17080532E-05_JPRB, 0.17104203E-05_JPRB, 0.17135001E-05_JPRB, 0.17187071E-05_JPRB, &
  & 0.17228802E-05_JPRB, 0.17282188E-05_JPRB, 0.17353417E-05_JPRB, 0.17419418E-05_JPRB, 0.17501495E-05_JPRB, 0.17590409E-05_JPRB, &
  & 0.17660457E-05_JPRB, 0.17710190E-05_JPRB, 0.17741620E-05_JPRB, 0.17763902E-05_JPRB, 0.17770785E-05_JPRB, 0.17772126E-05_JPRB, &
  & 0.17780574E-05_JPRB, 0.17770884E-05_JPRB, 0.17757509E-05_JPRB, 0.17733819E-05_JPRB, 0.17706768E-05_JPRB, 0.17683566E-05_JPRB, &
  & 0.17664719E-05_JPRB, 0.17649975E-05_JPRB, 0.17639668E-05_JPRB, 0.17643809E-05_JPRB  /)

RGHG2(:,67, 7) = (/ &
  & 0.17019473E-05_JPRB, 0.17017747E-05_JPRB, 0.17017539E-05_JPRB, 0.17018280E-05_JPRB, 0.17019642E-05_JPRB, 0.17019941E-05_JPRB, &
  & 0.17020546E-05_JPRB, 0.17021207E-05_JPRB, 0.17021836E-05_JPRB, 0.17023672E-05_JPRB, 0.17025316E-05_JPRB, 0.17026969E-05_JPRB, &
  & 0.17028321E-05_JPRB, 0.17030399E-05_JPRB, 0.17033315E-05_JPRB, 0.17035673E-05_JPRB, 0.17038050E-05_JPRB, 0.17041290E-05_JPRB, &
  & 0.17044901E-05_JPRB, 0.17047965E-05_JPRB, 0.17050818E-05_JPRB, 0.17054330E-05_JPRB, 0.17058049E-05_JPRB, 0.17061569E-05_JPRB, &
  & 0.17061860E-05_JPRB, 0.17057905E-05_JPRB, 0.17051868E-05_JPRB, 0.17044575E-05_JPRB, 0.17044045E-05_JPRB, 0.17047894E-05_JPRB, &
  & 0.17058892E-05_JPRB, 0.17062747E-05_JPRB, 0.17060538E-05_JPRB, 0.17055989E-05_JPRB, 0.17057653E-05_JPRB, 0.17063414E-05_JPRB, &
  & 0.17055881E-05_JPRB, 0.17058743E-05_JPRB, 0.17071021E-05_JPRB, 0.17095550E-05_JPRB, 0.17127536E-05_JPRB, 0.17183773E-05_JPRB, &
  & 0.17230017E-05_JPRB, 0.17286771E-05_JPRB, 0.17363612E-05_JPRB, 0.17433841E-05_JPRB, 0.17519981E-05_JPRB, 0.17606605E-05_JPRB, &
  & 0.17674822E-05_JPRB, 0.17721002E-05_JPRB, 0.17750503E-05_JPRB, 0.17771897E-05_JPRB, 0.17778672E-05_JPRB, 0.17777912E-05_JPRB, &
  & 0.17786972E-05_JPRB, 0.17776347E-05_JPRB, 0.17760297E-05_JPRB, 0.17734587E-05_JPRB, 0.17705015E-05_JPRB, 0.17681849E-05_JPRB, &
  & 0.17661455E-05_JPRB, 0.17644485E-05_JPRB, 0.17632492E-05_JPRB, 0.17639865E-05_JPRB  /)

RGHG2(:,68, 7) = (/ &
  & 0.17018278E-05_JPRB, 0.17016701E-05_JPRB, 0.17016517E-05_JPRB, 0.17017258E-05_JPRB, 0.17018669E-05_JPRB, 0.17018981E-05_JPRB, &
  & 0.17019499E-05_JPRB, 0.17020037E-05_JPRB, 0.17020542E-05_JPRB, 0.17022279E-05_JPRB, 0.17023910E-05_JPRB, 0.17025663E-05_JPRB, &
  & 0.17027088E-05_JPRB, 0.17029117E-05_JPRB, 0.17031971E-05_JPRB, 0.17034280E-05_JPRB, 0.17036681E-05_JPRB, 0.17039909E-05_JPRB, &
  & 0.17043273E-05_JPRB, 0.17046002E-05_JPRB, 0.17048262E-05_JPRB, 0.17051527E-05_JPRB, 0.17054764E-05_JPRB, 0.17057999E-05_JPRB, &
  & 0.17058537E-05_JPRB, 0.17054223E-05_JPRB, 0.17047457E-05_JPRB, 0.17039409E-05_JPRB, 0.17040166E-05_JPRB, 0.17044954E-05_JPRB, &
  & 0.17057190E-05_JPRB, 0.17059758E-05_JPRB, 0.17057673E-05_JPRB, 0.17053990E-05_JPRB, 0.17055728E-05_JPRB, 0.17061142E-05_JPRB, &
  & 0.17052274E-05_JPRB, 0.17054715E-05_JPRB, 0.17063294E-05_JPRB, 0.17088034E-05_JPRB, 0.17120503E-05_JPRB, 0.17180030E-05_JPRB, &
  & 0.17232088E-05_JPRB, 0.17293183E-05_JPRB, 0.17375133E-05_JPRB, 0.17450421E-05_JPRB, 0.17539617E-05_JPRB, 0.17622629E-05_JPRB, &
  & 0.17690499E-05_JPRB, 0.17734379E-05_JPRB, 0.17760948E-05_JPRB, 0.17781154E-05_JPRB, 0.17787830E-05_JPRB, 0.17784399E-05_JPRB, &
  & 0.17794163E-05_JPRB, 0.17782623E-05_JPRB, 0.17762887E-05_JPRB, 0.17734258E-05_JPRB, 0.17701519E-05_JPRB, 0.17678810E-05_JPRB, &
  & 0.17656722E-05_JPRB, 0.17637847E-05_JPRB, 0.17625137E-05_JPRB, 0.17635231E-05_JPRB  /)

RGHG2(:,69, 7) = (/ &
  & 0.17017075E-05_JPRB, 0.17015759E-05_JPRB, 0.17015600E-05_JPRB, 0.17016319E-05_JPRB, 0.17017734E-05_JPRB, 0.17018092E-05_JPRB, &
  & 0.17018512E-05_JPRB, 0.17018960E-05_JPRB, 0.17019319E-05_JPRB, 0.17020957E-05_JPRB, 0.17022542E-05_JPRB, 0.17024394E-05_JPRB, &
  & 0.17025916E-05_JPRB, 0.17027929E-05_JPRB, 0.17030721E-05_JPRB, 0.17033003E-05_JPRB, 0.17035429E-05_JPRB, 0.17038678E-05_JPRB, &
  & 0.17041907E-05_JPRB, 0.17044371E-05_JPRB, 0.17046126E-05_JPRB, 0.17048840E-05_JPRB, 0.17051460E-05_JPRB, 0.17054264E-05_JPRB, &
  & 0.17055015E-05_JPRB, 0.17050456E-05_JPRB, 0.17042701E-05_JPRB, 0.17034259E-05_JPRB, 0.17035807E-05_JPRB, 0.17041951E-05_JPRB, &
  & 0.17055142E-05_JPRB, 0.17056604E-05_JPRB, 0.17054080E-05_JPRB, 0.17050925E-05_JPRB, 0.17053818E-05_JPRB, 0.17060428E-05_JPRB, &
  & 0.17051699E-05_JPRB, 0.17054474E-05_JPRB, 0.17060290E-05_JPRB, 0.17081389E-05_JPRB, 0.17114622E-05_JPRB, 0.17177957E-05_JPRB, &
  & 0.17236571E-05_JPRB, 0.17300814E-05_JPRB, 0.17387410E-05_JPRB, 0.17467891E-05_JPRB, 0.17558543E-05_JPRB, 0.17637527E-05_JPRB, &
  & 0.17707100E-05_JPRB, 0.17749478E-05_JPRB, 0.17773409E-05_JPRB, 0.17792406E-05_JPRB, 0.17798217E-05_JPRB, 0.17791991E-05_JPRB, &
  & 0.17801875E-05_JPRB, 0.17788879E-05_JPRB, 0.17765322E-05_JPRB, 0.17732457E-05_JPRB, 0.17695855E-05_JPRB, 0.17673232E-05_JPRB, &
  & 0.17649551E-05_JPRB, 0.17629221E-05_JPRB, 0.17617741E-05_JPRB, 0.17630038E-05_JPRB  /)

RGHG2(:,70, 7) = (/ &
  & 0.17015984E-05_JPRB, 0.17014948E-05_JPRB, 0.17014821E-05_JPRB, 0.17015472E-05_JPRB, 0.17016873E-05_JPRB, 0.17017266E-05_JPRB, &
  & 0.17017580E-05_JPRB, 0.17017963E-05_JPRB, 0.17018173E-05_JPRB, 0.17019712E-05_JPRB, 0.17021269E-05_JPRB, 0.17023205E-05_JPRB, &
  & 0.17024826E-05_JPRB, 0.17026842E-05_JPRB, 0.17029579E-05_JPRB, 0.17031872E-05_JPRB, 0.17034280E-05_JPRB, 0.17037568E-05_JPRB, &
  & 0.17040759E-05_JPRB, 0.17043049E-05_JPRB, 0.17044344E-05_JPRB, 0.17046447E-05_JPRB, 0.17048298E-05_JPRB, 0.17050549E-05_JPRB, &
  & 0.17051446E-05_JPRB, 0.17046679E-05_JPRB, 0.17037729E-05_JPRB, 0.17029509E-05_JPRB, 0.17031585E-05_JPRB, 0.17039138E-05_JPRB, &
  & 0.17053481E-05_JPRB, 0.17053629E-05_JPRB, 0.17049804E-05_JPRB, 0.17046829E-05_JPRB, 0.17051683E-05_JPRB, 0.17060708E-05_JPRB, &
  & 0.17052983E-05_JPRB, 0.17055548E-05_JPRB, 0.17059931E-05_JPRB, 0.17076514E-05_JPRB, 0.17110188E-05_JPRB, 0.17178395E-05_JPRB, &
  & 0.17243773E-05_JPRB, 0.17310765E-05_JPRB, 0.17400469E-05_JPRB, 0.17487036E-05_JPRB, 0.17577394E-05_JPRB, 0.17653099E-05_JPRB, &
  & 0.17724343E-05_JPRB, 0.17765512E-05_JPRB, 0.17786397E-05_JPRB, 0.17804323E-05_JPRB, 0.17808826E-05_JPRB, 0.17800016E-05_JPRB, &
  & 0.17809595E-05_JPRB, 0.17794434E-05_JPRB, 0.17767388E-05_JPRB, 0.17729616E-05_JPRB, 0.17689239E-05_JPRB, 0.17666219E-05_JPRB, &
  & 0.17641039E-05_JPRB, 0.17619505E-05_JPRB, 0.17610341E-05_JPRB, 0.17624924E-05_JPRB  /)

RGHG2(:,71, 7) = (/ &
  & 0.17015045E-05_JPRB, 0.17014275E-05_JPRB, 0.17014173E-05_JPRB, 0.17014724E-05_JPRB, 0.17016094E-05_JPRB, 0.17016503E-05_JPRB, &
  & 0.17016708E-05_JPRB, 0.17017044E-05_JPRB, 0.17017112E-05_JPRB, 0.17018555E-05_JPRB, 0.17020093E-05_JPRB, 0.17022107E-05_JPRB, &
  & 0.17023818E-05_JPRB, 0.17025843E-05_JPRB, 0.17028540E-05_JPRB, 0.17030889E-05_JPRB, 0.17033231E-05_JPRB, 0.17036557E-05_JPRB, &
  & 0.17039820E-05_JPRB, 0.17042013E-05_JPRB, 0.17042910E-05_JPRB, 0.17044402E-05_JPRB, 0.17045382E-05_JPRB, 0.17046948E-05_JPRB, &
  & 0.17047776E-05_JPRB, 0.17042814E-05_JPRB, 0.17032946E-05_JPRB, 0.17025552E-05_JPRB, 0.17028146E-05_JPRB, 0.17037230E-05_JPRB, &
  & 0.17052400E-05_JPRB, 0.17051398E-05_JPRB, 0.17045540E-05_JPRB, 0.17042225E-05_JPRB, 0.17049383E-05_JPRB, 0.17061982E-05_JPRB, &
  & 0.17055737E-05_JPRB, 0.17057699E-05_JPRB, 0.17061443E-05_JPRB, 0.17074070E-05_JPRB, 0.17108154E-05_JPRB, 0.17181947E-05_JPRB, &
  & 0.17253862E-05_JPRB, 0.17323338E-05_JPRB, 0.17414946E-05_JPRB, 0.17507547E-05_JPRB, 0.17595972E-05_JPRB, 0.17669777E-05_JPRB, &
  & 0.17742414E-05_JPRB, 0.17781897E-05_JPRB, 0.17799748E-05_JPRB, 0.17816452E-05_JPRB, 0.17819312E-05_JPRB, 0.17808504E-05_JPRB, &
  & 0.17817217E-05_JPRB, 0.17799133E-05_JPRB, 0.17768940E-05_JPRB, 0.17725731E-05_JPRB, 0.17682047E-05_JPRB, 0.17657963E-05_JPRB, &
  & 0.17631535E-05_JPRB, 0.17608938E-05_JPRB, 0.17602715E-05_JPRB, 0.17619505E-05_JPRB  /)

RGHG2(:,72, 7) = (/ &
  & 0.17014308E-05_JPRB, 0.17013748E-05_JPRB, 0.17013634E-05_JPRB, 0.17014086E-05_JPRB, 0.17015407E-05_JPRB, 0.17015803E-05_JPRB, &
  & 0.17015909E-05_JPRB, 0.17016209E-05_JPRB, 0.17016152E-05_JPRB, 0.17017509E-05_JPRB, 0.17019010E-05_JPRB, 0.17021110E-05_JPRB, &
  & 0.17022883E-05_JPRB, 0.17024908E-05_JPRB, 0.17027592E-05_JPRB, 0.17030053E-05_JPRB, 0.17032284E-05_JPRB, 0.17035609E-05_JPRB, &
  & 0.17039083E-05_JPRB, 0.17041227E-05_JPRB, 0.17041826E-05_JPRB, 0.17042774E-05_JPRB, 0.17042875E-05_JPRB, 0.17043599E-05_JPRB, &
  & 0.17043857E-05_JPRB, 0.17038673E-05_JPRB, 0.17029102E-05_JPRB, 0.17023069E-05_JPRB, 0.17026617E-05_JPRB, 0.17037583E-05_JPRB, &
  & 0.17052134E-05_JPRB, 0.17050946E-05_JPRB, 0.17042611E-05_JPRB, 0.17038095E-05_JPRB, 0.17047074E-05_JPRB, 0.17064403E-05_JPRB, &
  & 0.17059508E-05_JPRB, 0.17061024E-05_JPRB, 0.17063814E-05_JPRB, 0.17075203E-05_JPRB, 0.17110364E-05_JPRB, 0.17189692E-05_JPRB, &
  & 0.17267204E-05_JPRB, 0.17338996E-05_JPRB, 0.17432164E-05_JPRB, 0.17528764E-05_JPRB, 0.17613821E-05_JPRB, 0.17688108E-05_JPRB, &
  & 0.17761823E-05_JPRB, 0.17797740E-05_JPRB, 0.17813523E-05_JPRB, 0.17828246E-05_JPRB, 0.17829261E-05_JPRB, 0.17817698E-05_JPRB, &
  & 0.17824665E-05_JPRB, 0.17802817E-05_JPRB, 0.17769738E-05_JPRB, 0.17720660E-05_JPRB, 0.17674710E-05_JPRB, 0.17648534E-05_JPRB, &
  & 0.17621425E-05_JPRB, 0.17597739E-05_JPRB, 0.17594388E-05_JPRB, 0.17612874E-05_JPRB  /)

RGHG2(:,73, 7) = (/ &
  & 0.17013734E-05_JPRB, 0.17013329E-05_JPRB, 0.17013179E-05_JPRB, 0.17013543E-05_JPRB, 0.17014803E-05_JPRB, 0.17015198E-05_JPRB, &
  & 0.17015193E-05_JPRB, 0.17015420E-05_JPRB, 0.17015309E-05_JPRB, 0.17016578E-05_JPRB, 0.17018007E-05_JPRB, 0.17020172E-05_JPRB, &
  & 0.17021984E-05_JPRB, 0.17024043E-05_JPRB, 0.17026715E-05_JPRB, 0.17029242E-05_JPRB, 0.17031372E-05_JPRB, 0.17034721E-05_JPRB, &
  & 0.17038498E-05_JPRB, 0.17040948E-05_JPRB, 0.17041283E-05_JPRB, 0.17041763E-05_JPRB, 0.17041336E-05_JPRB, 0.17041179E-05_JPRB, &
  & 0.17040542E-05_JPRB, 0.17035030E-05_JPRB, 0.17026620E-05_JPRB, 0.17022544E-05_JPRB, 0.17026602E-05_JPRB, 0.17039093E-05_JPRB, &
  & 0.17052539E-05_JPRB, 0.17051935E-05_JPRB, 0.17042546E-05_JPRB, 0.17036304E-05_JPRB, 0.17045666E-05_JPRB, 0.17068407E-05_JPRB, &
  & 0.17064743E-05_JPRB, 0.17065960E-05_JPRB, 0.17068309E-05_JPRB, 0.17080705E-05_JPRB, 0.17117271E-05_JPRB, 0.17202913E-05_JPRB, &
  & 0.17283733E-05_JPRB, 0.17356819E-05_JPRB, 0.17452016E-05_JPRB, 0.17550041E-05_JPRB, 0.17631986E-05_JPRB, 0.17706599E-05_JPRB, &
  & 0.17780949E-05_JPRB, 0.17812716E-05_JPRB, 0.17827741E-05_JPRB, 0.17839632E-05_JPRB, 0.17838838E-05_JPRB, 0.17827607E-05_JPRB, &
  & 0.17831784E-05_JPRB, 0.17804494E-05_JPRB, 0.17769261E-05_JPRB, 0.17714809E-05_JPRB, 0.17667648E-05_JPRB, 0.17638229E-05_JPRB, &
  & 0.17611159E-05_JPRB, 0.17586216E-05_JPRB, 0.17584329E-05_JPRB, 0.17602775E-05_JPRB  /)

RGHG2(:,74, 7) = (/ &
  & 0.17013259E-05_JPRB, 0.17012974E-05_JPRB, 0.17012787E-05_JPRB, 0.17013078E-05_JPRB, 0.17014283E-05_JPRB, 0.17014678E-05_JPRB, &
  & 0.17014569E-05_JPRB, 0.17014692E-05_JPRB, 0.17014575E-05_JPRB, 0.17015757E-05_JPRB, 0.17017119E-05_JPRB, 0.17019316E-05_JPRB, &
  & 0.17021173E-05_JPRB, 0.17023277E-05_JPRB, 0.17025937E-05_JPRB, 0.17028511E-05_JPRB, 0.17030512E-05_JPRB, 0.17033832E-05_JPRB, &
  & 0.17038033E-05_JPRB, 0.17040932E-05_JPRB, 0.17041042E-05_JPRB, 0.17041152E-05_JPRB, 0.17040474E-05_JPRB, 0.17039313E-05_JPRB, &
  & 0.17037688E-05_JPRB, 0.17032386E-05_JPRB, 0.17025178E-05_JPRB, 0.17022642E-05_JPRB, 0.17026860E-05_JPRB, 0.17040179E-05_JPRB, &
  & 0.17053100E-05_JPRB, 0.17052933E-05_JPRB, 0.17043777E-05_JPRB, 0.17035963E-05_JPRB, 0.17045414E-05_JPRB, 0.17073066E-05_JPRB, &
  & 0.17072072E-05_JPRB, 0.17072405E-05_JPRB, 0.17074437E-05_JPRB, 0.17088529E-05_JPRB, 0.17126706E-05_JPRB, 0.17218377E-05_JPRB, &
  & 0.17301254E-05_JPRB, 0.17375458E-05_JPRB, 0.17472026E-05_JPRB, 0.17569845E-05_JPRB, 0.17651029E-05_JPRB, 0.17725242E-05_JPRB, &
  & 0.17798807E-05_JPRB, 0.17826663E-05_JPRB, 0.17842110E-05_JPRB, 0.17851378E-05_JPRB, 0.17848480E-05_JPRB, 0.17837739E-05_JPRB, &
  & 0.17838271E-05_JPRB, 0.17805569E-05_JPRB, 0.17768043E-05_JPRB, 0.17708997E-05_JPRB, 0.17660933E-05_JPRB, 0.17628433E-05_JPRB, &
  & 0.17601081E-05_JPRB, 0.17574517E-05_JPRB, 0.17573511E-05_JPRB, 0.17591134E-05_JPRB  /)

RGHG2(:,75, 7) = (/ &
  & 0.17012857E-05_JPRB, 0.17012664E-05_JPRB, 0.17012447E-05_JPRB, 0.17012687E-05_JPRB, 0.17013831E-05_JPRB, 0.17014244E-05_JPRB, &
  & 0.17014039E-05_JPRB, 0.17014044E-05_JPRB, 0.17013962E-05_JPRB, 0.17015044E-05_JPRB, 0.17016337E-05_JPRB, 0.17018540E-05_JPRB, &
  & 0.17020481E-05_JPRB, 0.17022610E-05_JPRB, 0.17025257E-05_JPRB, 0.17027862E-05_JPRB, 0.17029762E-05_JPRB, 0.17033045E-05_JPRB, &
  & 0.17037694E-05_JPRB, 0.17041083E-05_JPRB, 0.17041039E-05_JPRB, 0.17040948E-05_JPRB, 0.17040180E-05_JPRB, 0.17037956E-05_JPRB, &
  & 0.17035353E-05_JPRB, 0.17030707E-05_JPRB, 0.17024637E-05_JPRB, 0.17022953E-05_JPRB, 0.17027128E-05_JPRB, 0.17040653E-05_JPRB, &
  & 0.17053545E-05_JPRB, 0.17053917E-05_JPRB, 0.17045817E-05_JPRB, 0.17036879E-05_JPRB, 0.17046246E-05_JPRB, 0.17078210E-05_JPRB, &
  & 0.17081636E-05_JPRB, 0.17080653E-05_JPRB, 0.17082208E-05_JPRB, 0.17098331E-05_JPRB, 0.17138367E-05_JPRB, 0.17235479E-05_JPRB, &
  & 0.17319120E-05_JPRB, 0.17394300E-05_JPRB, 0.17491359E-05_JPRB, 0.17588136E-05_JPRB, 0.17670733E-05_JPRB, 0.17743837E-05_JPRB, &
  & 0.17815115E-05_JPRB, 0.17839452E-05_JPRB, 0.17856158E-05_JPRB, 0.17863284E-05_JPRB, 0.17858210E-05_JPRB, 0.17847441E-05_JPRB, &
  & 0.17844162E-05_JPRB, 0.17806498E-05_JPRB, 0.17766374E-05_JPRB, 0.17703460E-05_JPRB, 0.17654666E-05_JPRB, 0.17619707E-05_JPRB, &
  & 0.17591441E-05_JPRB, 0.17562959E-05_JPRB, 0.17562431E-05_JPRB, 0.17579053E-05_JPRB  /)

RGHG2(:,76, 7) = (/ &
  & 0.17012497E-05_JPRB, 0.17012378E-05_JPRB, 0.17012148E-05_JPRB, 0.17012363E-05_JPRB, 0.17013421E-05_JPRB, 0.17013895E-05_JPRB, &
  & 0.17013604E-05_JPRB, 0.17013510E-05_JPRB, 0.17013490E-05_JPRB, 0.17014436E-05_JPRB, 0.17015642E-05_JPRB, 0.17017832E-05_JPRB, &
  & 0.17019947E-05_JPRB, 0.17022039E-05_JPRB, 0.17024674E-05_JPRB, 0.17027291E-05_JPRB, 0.17029215E-05_JPRB, 0.17032523E-05_JPRB, &
  & 0.17037494E-05_JPRB, 0.17041292E-05_JPRB, 0.17041211E-05_JPRB, 0.17041207E-05_JPRB, 0.17040339E-05_JPRB, 0.17037100E-05_JPRB, &
  & 0.17033654E-05_JPRB, 0.17029888E-05_JPRB, 0.17024846E-05_JPRB, 0.17023026E-05_JPRB, 0.17027176E-05_JPRB, 0.17040441E-05_JPRB, &
  & 0.17053519E-05_JPRB, 0.17055055E-05_JPRB, 0.17048144E-05_JPRB, 0.17038908E-05_JPRB, 0.17048040E-05_JPRB, 0.17083732E-05_JPRB, &
  & 0.17093648E-05_JPRB, 0.17091253E-05_JPRB, 0.17091768E-05_JPRB, 0.17109934E-05_JPRB, 0.17152175E-05_JPRB, 0.17253820E-05_JPRB, &
  & 0.17336680E-05_JPRB, 0.17412628E-05_JPRB, 0.17509093E-05_JPRB, 0.17605090E-05_JPRB, 0.17690745E-05_JPRB, 0.17762116E-05_JPRB, &
  & 0.17829579E-05_JPRB, 0.17850906E-05_JPRB, 0.17869210E-05_JPRB, 0.17874962E-05_JPRB, 0.17868030E-05_JPRB, 0.17855762E-05_JPRB, &
  & 0.17849560E-05_JPRB, 0.17807797E-05_JPRB, 0.17764613E-05_JPRB, 0.17698443E-05_JPRB, 0.17648993E-05_JPRB, 0.17612745E-05_JPRB, &
  & 0.17582572E-05_JPRB, 0.17551996E-05_JPRB, 0.17551704E-05_JPRB, 0.17567955E-05_JPRB  /)

RGHG2(:,77, 7) = (/ &
  & 0.17012108E-05_JPRB, 0.17012028E-05_JPRB, 0.17011846E-05_JPRB, 0.17012083E-05_JPRB, 0.17013077E-05_JPRB, 0.17013614E-05_JPRB, &
  & 0.17013294E-05_JPRB, 0.17013112E-05_JPRB, 0.17013155E-05_JPRB, 0.17013939E-05_JPRB, 0.17015033E-05_JPRB, 0.17017199E-05_JPRB, &
  & 0.17019525E-05_JPRB, 0.17021520E-05_JPRB, 0.17024202E-05_JPRB, 0.17026902E-05_JPRB, 0.17028960E-05_JPRB, 0.17032328E-05_JPRB, &
  & 0.17037518E-05_JPRB, 0.17041790E-05_JPRB, 0.17041899E-05_JPRB, 0.17041970E-05_JPRB, 0.17041086E-05_JPRB, 0.17036912E-05_JPRB, &
  & 0.17033207E-05_JPRB, 0.17029618E-05_JPRB, 0.17025166E-05_JPRB, 0.17022684E-05_JPRB, 0.17026379E-05_JPRB, 0.17039464E-05_JPRB, &
  & 0.17052909E-05_JPRB, 0.17056948E-05_JPRB, 0.17050874E-05_JPRB, 0.17041956E-05_JPRB, 0.17050850E-05_JPRB, 0.17088976E-05_JPRB, &
  & 0.17105701E-05_JPRB, 0.17105507E-05_JPRB, 0.17105063E-05_JPRB, 0.17123741E-05_JPRB, 0.17168754E-05_JPRB, 0.17271196E-05_JPRB, &
  & 0.17352896E-05_JPRB, 0.17428681E-05_JPRB, 0.17525270E-05_JPRB, 0.17620964E-05_JPRB, 0.17708685E-05_JPRB, 0.17778845E-05_JPRB, &
  & 0.17841677E-05_JPRB, 0.17861512E-05_JPRB, 0.17879924E-05_JPRB, 0.17884567E-05_JPRB, 0.17876025E-05_JPRB, 0.17863071E-05_JPRB, &
  & 0.17854763E-05_JPRB, 0.17810795E-05_JPRB, 0.17763162E-05_JPRB, 0.17694093E-05_JPRB, 0.17643691E-05_JPRB, 0.17607519E-05_JPRB, &
  & 0.17575733E-05_JPRB, 0.17543428E-05_JPRB, 0.17542505E-05_JPRB, 0.17558867E-05_JPRB  /)

RGHG2(:,78, 7) = (/ &
  & 0.17011707E-05_JPRB, 0.17011665E-05_JPRB, 0.17011556E-05_JPRB, 0.17011835E-05_JPRB, 0.17012814E-05_JPRB, 0.17013422E-05_JPRB, &
  & 0.17013100E-05_JPRB, 0.17012855E-05_JPRB, 0.17012896E-05_JPRB, 0.17013509E-05_JPRB, 0.17014531E-05_JPRB, 0.17016695E-05_JPRB, &
  & 0.17019226E-05_JPRB, 0.17021113E-05_JPRB, 0.17023885E-05_JPRB, 0.17026674E-05_JPRB, 0.17028884E-05_JPRB, 0.17032411E-05_JPRB, &
  & 0.17037878E-05_JPRB, 0.17042738E-05_JPRB, 0.17043158E-05_JPRB, 0.17043337E-05_JPRB, 0.17042296E-05_JPRB, 0.17037203E-05_JPRB, &
  & 0.17033274E-05_JPRB, 0.17029559E-05_JPRB, 0.17025296E-05_JPRB, 0.17022308E-05_JPRB, 0.17025264E-05_JPRB, 0.17038062E-05_JPRB, &
  & 0.17051843E-05_JPRB, 0.17058976E-05_JPRB, 0.17053995E-05_JPRB, 0.17045253E-05_JPRB, 0.17054371E-05_JPRB, 0.17094222E-05_JPRB, &
  & 0.17116543E-05_JPRB, 0.17118008E-05_JPRB, 0.17118175E-05_JPRB, 0.17137302E-05_JPRB, 0.17184750E-05_JPRB, 0.17287597E-05_JPRB, &
  & 0.17367729E-05_JPRB, 0.17443915E-05_JPRB, 0.17540962E-05_JPRB, 0.17635997E-05_JPRB, 0.17724519E-05_JPRB, 0.17793517E-05_JPRB, &
  & 0.17852192E-05_JPRB, 0.17871470E-05_JPRB, 0.17889652E-05_JPRB, 0.17892607E-05_JPRB, 0.17882043E-05_JPRB, 0.17869359E-05_JPRB, &
  & 0.17858742E-05_JPRB, 0.17813696E-05_JPRB, 0.17761738E-05_JPRB, 0.17689250E-05_JPRB, 0.17639032E-05_JPRB, 0.17603792E-05_JPRB, &
  & 0.17571189E-05_JPRB, 0.17537683E-05_JPRB, 0.17535318E-05_JPRB, 0.17551922E-05_JPRB  /)

RGHG2(:,79, 7) = (/ &
  & 0.17011299E-05_JPRB, 0.17011291E-05_JPRB, 0.17011277E-05_JPRB, 0.17011622E-05_JPRB, 0.17012625E-05_JPRB, 0.17013327E-05_JPRB, &
  & 0.17013003E-05_JPRB, 0.17012735E-05_JPRB, 0.17012743E-05_JPRB, 0.17013181E-05_JPRB, 0.17014153E-05_JPRB, 0.17016326E-05_JPRB, &
  & 0.17019037E-05_JPRB, 0.17020867E-05_JPRB, 0.17023783E-05_JPRB, 0.17026643E-05_JPRB, 0.17029000E-05_JPRB, 0.17032818E-05_JPRB, &
  & 0.17038604E-05_JPRB, 0.17044131E-05_JPRB, 0.17044957E-05_JPRB, 0.17045201E-05_JPRB, 0.17043776E-05_JPRB, 0.17037929E-05_JPRB, &
  & 0.17033700E-05_JPRB, 0.17029687E-05_JPRB, 0.17025343E-05_JPRB, 0.17021989E-05_JPRB, 0.17023878E-05_JPRB, 0.17036331E-05_JPRB, &
  & 0.17050578E-05_JPRB, 0.17060860E-05_JPRB, 0.17057392E-05_JPRB, 0.17048676E-05_JPRB, 0.17058344E-05_JPRB, 0.17099616E-05_JPRB, &
  & 0.17126122E-05_JPRB, 0.17128760E-05_JPRB, 0.17130732E-05_JPRB, 0.17150491E-05_JPRB, 0.17199750E-05_JPRB, 0.17303461E-05_JPRB, &
  & 0.17381287E-05_JPRB, 0.17457971E-05_JPRB, 0.17555533E-05_JPRB, 0.17649859E-05_JPRB, 0.17737587E-05_JPRB, 0.17805805E-05_JPRB, &
  & 0.17860769E-05_JPRB, 0.17880124E-05_JPRB, 0.17898237E-05_JPRB, 0.17899305E-05_JPRB, 0.17886491E-05_JPRB, 0.17874378E-05_JPRB, &
  & 0.17861426E-05_JPRB, 0.17815921E-05_JPRB, 0.17760265E-05_JPRB, 0.17684077E-05_JPRB, 0.17634849E-05_JPRB, 0.17601488E-05_JPRB, &
  & 0.17568761E-05_JPRB, 0.17534362E-05_JPRB, 0.17530044E-05_JPRB, 0.17547055E-05_JPRB  /)

RGHG2(:,80, 7) = (/ &
  & 0.17010891E-05_JPRB, 0.17010907E-05_JPRB, 0.17011004E-05_JPRB, 0.17011448E-05_JPRB, 0.17012500E-05_JPRB, 0.17013337E-05_JPRB, &
  & 0.17012976E-05_JPRB, 0.17012744E-05_JPRB, 0.17012727E-05_JPRB, 0.17012993E-05_JPRB, 0.17013916E-05_JPRB, 0.17016089E-05_JPRB, &
  & 0.17018935E-05_JPRB, 0.17020826E-05_JPRB, 0.17023951E-05_JPRB, 0.17026847E-05_JPRB, 0.17029313E-05_JPRB, 0.17033588E-05_JPRB, &
  & 0.17039703E-05_JPRB, 0.17045938E-05_JPRB, 0.17047237E-05_JPRB, 0.17047424E-05_JPRB, 0.17045310E-05_JPRB, 0.17039040E-05_JPRB, &
  & 0.17034351E-05_JPRB, 0.17029995E-05_JPRB, 0.17025452E-05_JPRB, 0.17021802E-05_JPRB, 0.17022246E-05_JPRB, 0.17034353E-05_JPRB, &
  & 0.17049387E-05_JPRB, 0.17062332E-05_JPRB, 0.17060933E-05_JPRB, 0.17052132E-05_JPRB, 0.17062482E-05_JPRB, 0.17105289E-05_JPRB, &
  & 0.17134476E-05_JPRB, 0.17138153E-05_JPRB, 0.17142578E-05_JPRB, 0.17163327E-05_JPRB, 0.17213502E-05_JPRB, 0.17319262E-05_JPRB, &
  & 0.17393706E-05_JPRB, 0.17470358E-05_JPRB, 0.17568199E-05_JPRB, 0.17662155E-05_JPRB, 0.17747192E-05_JPRB, 0.17815428E-05_JPRB, &
  & 0.17867010E-05_JPRB, 0.17886750E-05_JPRB, 0.17905425E-05_JPRB, 0.17904897E-05_JPRB, 0.17889862E-05_JPRB, 0.17877863E-05_JPRB, &
  & 0.17862833E-05_JPRB, 0.17816950E-05_JPRB, 0.17758686E-05_JPRB, 0.17678859E-05_JPRB, 0.17630929E-05_JPRB, 0.17600513E-05_JPRB, &
  & 0.17568185E-05_JPRB, 0.17532929E-05_JPRB, 0.17526435E-05_JPRB, 0.17544091E-05_JPRB  /)

RGHG2(:,81, 7) = (/ &
  & 0.17010494E-05_JPRB, 0.17010523E-05_JPRB, 0.17010773E-05_JPRB, 0.17011305E-05_JPRB, 0.17012434E-05_JPRB, 0.17013513E-05_JPRB, &
  & 0.17013088E-05_JPRB, 0.17012920E-05_JPRB, 0.17012979E-05_JPRB, 0.17013004E-05_JPRB, 0.17013837E-05_JPRB, 0.17016010E-05_JPRB, &
  & 0.17018984E-05_JPRB, 0.17021078E-05_JPRB, 0.17024408E-05_JPRB, 0.17027468E-05_JPRB, 0.17030189E-05_JPRB, 0.17034872E-05_JPRB, &
  & 0.17041700E-05_JPRB, 0.17048329E-05_JPRB, 0.17049731E-05_JPRB, 0.17049446E-05_JPRB, 0.17046543E-05_JPRB, 0.17040057E-05_JPRB, &
  & 0.17035189E-05_JPRB, 0.17030311E-05_JPRB, 0.17025704E-05_JPRB, 0.17021672E-05_JPRB, 0.17020767E-05_JPRB, 0.17033637E-05_JPRB, &
  & 0.17049678E-05_JPRB, 0.17063451E-05_JPRB, 0.17063439E-05_JPRB, 0.17055504E-05_JPRB, 0.17066211E-05_JPRB, 0.17111247E-05_JPRB, &
  & 0.17141746E-05_JPRB, 0.17146365E-05_JPRB, 0.17152420E-05_JPRB, 0.17173946E-05_JPRB, 0.17226885E-05_JPRB, 0.17334619E-05_JPRB, &
  & 0.17404682E-05_JPRB, 0.17480900E-05_JPRB, 0.17579429E-05_JPRB, 0.17674010E-05_JPRB, 0.17755366E-05_JPRB, 0.17822112E-05_JPRB, &
  & 0.17870370E-05_JPRB, 0.17891282E-05_JPRB, 0.17912121E-05_JPRB, 0.17910282E-05_JPRB, 0.17893005E-05_JPRB, 0.17880854E-05_JPRB, &
  & 0.17863124E-05_JPRB, 0.17817521E-05_JPRB, 0.17757003E-05_JPRB, 0.17673393E-05_JPRB, 0.17627590E-05_JPRB, 0.17599504E-05_JPRB, &
  & 0.17568259E-05_JPRB, 0.17532570E-05_JPRB, 0.17529476E-05_JPRB, 0.17546394E-05_JPRB  /)

RGHG2(:,82, 7) = (/ &
  & 0.17010126E-05_JPRB, 0.17010159E-05_JPRB, 0.17010569E-05_JPRB, 0.17011182E-05_JPRB, 0.17012387E-05_JPRB, 0.17013776E-05_JPRB, &
  & 0.17013305E-05_JPRB, 0.17013201E-05_JPRB, 0.17013397E-05_JPRB, 0.17013146E-05_JPRB, 0.17013821E-05_JPRB, 0.17015985E-05_JPRB, &
  & 0.17019129E-05_JPRB, 0.17021532E-05_JPRB, 0.17025081E-05_JPRB, 0.17028341E-05_JPRB, 0.17031324E-05_JPRB, 0.17036254E-05_JPRB, &
  & 0.17043843E-05_JPRB, 0.17050707E-05_JPRB, 0.17051876E-05_JPRB, 0.17051123E-05_JPRB, 0.17047777E-05_JPRB, 0.17041094E-05_JPRB, &
  & 0.17036198E-05_JPRB, 0.17030757E-05_JPRB, 0.17026219E-05_JPRB, 0.17021921E-05_JPRB, 0.17020218E-05_JPRB, 0.17034068E-05_JPRB, &
  & 0.17050932E-05_JPRB, 0.17065124E-05_JPRB, 0.17065316E-05_JPRB, 0.17058461E-05_JPRB, 0.17069812E-05_JPRB, 0.17116614E-05_JPRB, &
  & 0.17148189E-05_JPRB, 0.17153884E-05_JPRB, 0.17161156E-05_JPRB, 0.17184199E-05_JPRB, 0.17240463E-05_JPRB, 0.17349351E-05_JPRB, &
  & 0.17414710E-05_JPRB, 0.17490753E-05_JPRB, 0.17589307E-05_JPRB, 0.17685324E-05_JPRB, 0.17764217E-05_JPRB, 0.17828104E-05_JPRB, &
  & 0.17873867E-05_JPRB, 0.17895539E-05_JPRB, 0.17917968E-05_JPRB, 0.17915036E-05_JPRB, 0.17895848E-05_JPRB, 0.17883817E-05_JPRB, &
  & 0.17863720E-05_JPRB, 0.17818282E-05_JPRB, 0.17755287E-05_JPRB, 0.17668559E-05_JPRB, 0.17623869E-05_JPRB, 0.17599020E-05_JPRB, &
  & 0.17568763E-05_JPRB, 0.17532924E-05_JPRB, 0.17532069E-05_JPRB, 0.17547375E-05_JPRB  /)

RGHG2(:,83, 7) = (/ &
  & 0.17009796E-05_JPRB, 0.17009838E-05_JPRB, 0.17010417E-05_JPRB, 0.17011070E-05_JPRB, 0.17012355E-05_JPRB, 0.17014117E-05_JPRB, &
  & 0.17013658E-05_JPRB, 0.17013577E-05_JPRB, 0.17013922E-05_JPRB, 0.17013368E-05_JPRB, 0.17013859E-05_JPRB, 0.17016021E-05_JPRB, &
  & 0.17019334E-05_JPRB, 0.17022155E-05_JPRB, 0.17025916E-05_JPRB, 0.17029331E-05_JPRB, 0.17032563E-05_JPRB, 0.17037610E-05_JPRB, &
  & 0.17045982E-05_JPRB, 0.17053077E-05_JPRB, 0.17053874E-05_JPRB, 0.17052609E-05_JPRB, 0.17048969E-05_JPRB, 0.17042151E-05_JPRB, &
  & 0.17037317E-05_JPRB, 0.17031382E-05_JPRB, 0.17027013E-05_JPRB, 0.17022604E-05_JPRB, 0.17020534E-05_JPRB, 0.17035489E-05_JPRB, &
  & 0.17053176E-05_JPRB, 0.17067378E-05_JPRB, 0.17066557E-05_JPRB, 0.17060849E-05_JPRB, 0.17073213E-05_JPRB, 0.17121591E-05_JPRB, &
  & 0.17153573E-05_JPRB, 0.17160587E-05_JPRB, 0.17168848E-05_JPRB, 0.17193695E-05_JPRB, 0.17254312E-05_JPRB, 0.17363417E-05_JPRB, &
  & 0.17424230E-05_JPRB, 0.17500069E-05_JPRB, 0.17598476E-05_JPRB, 0.17696207E-05_JPRB, 0.17773724E-05_JPRB, 0.17833400E-05_JPRB, &
  & 0.17877217E-05_JPRB, 0.17899924E-05_JPRB, 0.17922760E-05_JPRB, 0.17919736E-05_JPRB, 0.17898533E-05_JPRB, 0.17886633E-05_JPRB, &
  & 0.17864804E-05_JPRB, 0.17819314E-05_JPRB, 0.17754041E-05_JPRB, 0.17664347E-05_JPRB, 0.17620089E-05_JPRB, 0.17598800E-05_JPRB, &
  & 0.17568939E-05_JPRB, 0.17533659E-05_JPRB, 0.17533220E-05_JPRB, 0.17546183E-05_JPRB  /)

RGHG2(:,84, 7) = (/ &
  & 0.17009508E-05_JPRB, 0.17009577E-05_JPRB, 0.17010326E-05_JPRB, 0.17010967E-05_JPRB, 0.17012339E-05_JPRB, 0.17014520E-05_JPRB, &
  & 0.17014158E-05_JPRB, 0.17014041E-05_JPRB, 0.17014507E-05_JPRB, 0.17013628E-05_JPRB, 0.17013942E-05_JPRB, 0.17016114E-05_JPRB, &
  & 0.17019567E-05_JPRB, 0.17022898E-05_JPRB, 0.17026848E-05_JPRB, 0.17030328E-05_JPRB, 0.17033769E-05_JPRB, 0.17038848E-05_JPRB, &
  & 0.17048003E-05_JPRB, 0.17055439E-05_JPRB, 0.17055893E-05_JPRB, 0.17054048E-05_JPRB, 0.17050098E-05_JPRB, 0.17043241E-05_JPRB, &
  & 0.17038511E-05_JPRB, 0.17032214E-05_JPRB, 0.17028074E-05_JPRB, 0.17023734E-05_JPRB, 0.17021601E-05_JPRB, 0.17037743E-05_JPRB, &
  & 0.17056362E-05_JPRB, 0.17070295E-05_JPRB, 0.17067370E-05_JPRB, 0.17062685E-05_JPRB, 0.17076452E-05_JPRB, 0.17126487E-05_JPRB, &
  & 0.17157860E-05_JPRB, 0.17166411E-05_JPRB, 0.17175559E-05_JPRB, 0.17202151E-05_JPRB, 0.17268434E-05_JPRB, 0.17376950E-05_JPRB, &
  & 0.17433667E-05_JPRB, 0.17509180E-05_JPRB, 0.17607569E-05_JPRB, 0.17706935E-05_JPRB, 0.17783910E-05_JPRB, 0.17838226E-05_JPRB, &
  & 0.17880373E-05_JPRB, 0.17904732E-05_JPRB, 0.17926523E-05_JPRB, 0.17924932E-05_JPRB, 0.17901331E-05_JPRB, 0.17889340E-05_JPRB, &
  & 0.17866604E-05_JPRB, 0.17820772E-05_JPRB, 0.17753683E-05_JPRB, 0.17660772E-05_JPRB, 0.17616622E-05_JPRB, 0.17598662E-05_JPRB, &
  & 0.17568281E-05_JPRB, 0.17534420E-05_JPRB, 0.17532320E-05_JPRB, 0.17542400E-05_JPRB  /)

RGHG2(:,85, 7) = (/ &
  & 0.17009262E-05_JPRB, 0.17009382E-05_JPRB, 0.17010273E-05_JPRB, 0.17010887E-05_JPRB, 0.17012363E-05_JPRB, 0.17014954E-05_JPRB, &
  & 0.17014862E-05_JPRB, 0.17014719E-05_JPRB, 0.17015275E-05_JPRB, 0.17013998E-05_JPRB, 0.17014068E-05_JPRB, 0.17016228E-05_JPRB, &
  & 0.17019872E-05_JPRB, 0.17023589E-05_JPRB, 0.17027796E-05_JPRB, 0.17031392E-05_JPRB, 0.17034832E-05_JPRB, 0.17040052E-05_JPRB, &
  & 0.17050081E-05_JPRB, 0.17057992E-05_JPRB, 0.17058317E-05_JPRB, 0.17055907E-05_JPRB, 0.17051418E-05_JPRB, 0.17044689E-05_JPRB, &
  & 0.17040139E-05_JPRB, 0.17033432E-05_JPRB, 0.17029433E-05_JPRB, 0.17025465E-05_JPRB, 0.17023447E-05_JPRB, 0.17041399E-05_JPRB, &
  & 0.17060853E-05_JPRB, 0.17075723E-05_JPRB, 0.17070411E-05_JPRB, 0.17065559E-05_JPRB, 0.17081059E-05_JPRB, 0.17133969E-05_JPRB, &
  & 0.17162531E-05_JPRB, 0.17171762E-05_JPRB, 0.17181372E-05_JPRB, 0.17209992E-05_JPRB, 0.17284119E-05_JPRB, 0.17393457E-05_JPRB, &
  & 0.17445308E-05_JPRB, 0.17521978E-05_JPRB, 0.17619481E-05_JPRB, 0.17721363E-05_JPRB, 0.17797221E-05_JPRB, 0.17845888E-05_JPRB, &
  & 0.17885917E-05_JPRB, 0.17910737E-05_JPRB, 0.17931361E-05_JPRB, 0.17933172E-05_JPRB, 0.17906900E-05_JPRB, 0.17893972E-05_JPRB, &
  & 0.17871198E-05_JPRB, 0.17824506E-05_JPRB, 0.17755376E-05_JPRB, 0.17658317E-05_JPRB, 0.17615015E-05_JPRB, 0.17598967E-05_JPRB, &
  & 0.17567072E-05_JPRB, 0.17534059E-05_JPRB, 0.17529596E-05_JPRB, 0.17536454E-05_JPRB  /)

RGHG2(:,86, 7) = (/ &
  & 0.17009067E-05_JPRB, 0.17009249E-05_JPRB, 0.17010231E-05_JPRB, 0.17010830E-05_JPRB, 0.17012429E-05_JPRB, 0.17015313E-05_JPRB, &
  & 0.17015622E-05_JPRB, 0.17015453E-05_JPRB, 0.17016110E-05_JPRB, 0.17014322E-05_JPRB, 0.17014167E-05_JPRB, 0.17016344E-05_JPRB, &
  & 0.17020172E-05_JPRB, 0.17024206E-05_JPRB, 0.17028670E-05_JPRB, 0.17032654E-05_JPRB, 0.17035943E-05_JPRB, 0.17041195E-05_JPRB, &
  & 0.17052281E-05_JPRB, 0.17061132E-05_JPRB, 0.17061228E-05_JPRB, 0.17058471E-05_JPRB, 0.17053340E-05_JPRB, 0.17046680E-05_JPRB, &
  & 0.17042461E-05_JPRB, 0.17035019E-05_JPRB, 0.17031323E-05_JPRB, 0.17027830E-05_JPRB, 0.17026190E-05_JPRB, 0.17046935E-05_JPRB, &
  & 0.17067479E-05_JPRB, 0.17083341E-05_JPRB, 0.17076302E-05_JPRB, 0.17069936E-05_JPRB, 0.17087700E-05_JPRB, 0.17142597E-05_JPRB, &
  & 0.17167800E-05_JPRB, 0.17177675E-05_JPRB, 0.17187247E-05_JPRB, 0.17218238E-05_JPRB, 0.17302670E-05_JPRB, 0.17414541E-05_JPRB, &
  & 0.17461221E-05_JPRB, 0.17539724E-05_JPRB, 0.17634489E-05_JPRB, 0.17740105E-05_JPRB, 0.17814770E-05_JPRB, 0.17855801E-05_JPRB, &
  & 0.17894415E-05_JPRB, 0.17918062E-05_JPRB, 0.17938405E-05_JPRB, 0.17944992E-05_JPRB, 0.17915936E-05_JPRB, 0.17902578E-05_JPRB, &
  & 0.17879604E-05_JPRB, 0.17831184E-05_JPRB, 0.17759671E-05_JPRB, 0.17658063E-05_JPRB, 0.17615793E-05_JPRB, 0.17601206E-05_JPRB, &
  & 0.17569637E-05_JPRB, 0.17534280E-05_JPRB, 0.17526419E-05_JPRB, 0.17529726E-05_JPRB  /)

RGHG2(:,87, 7) = (/ &
  & 0.17008929E-05_JPRB, 0.17009177E-05_JPRB, 0.17010211E-05_JPRB, 0.17010790E-05_JPRB, 0.17012526E-05_JPRB, 0.17015606E-05_JPRB, &
  & 0.17016360E-05_JPRB, 0.17016152E-05_JPRB, 0.17016947E-05_JPRB, 0.17014595E-05_JPRB, 0.17014231E-05_JPRB, 0.17016447E-05_JPRB, &
  & 0.17020492E-05_JPRB, 0.17024780E-05_JPRB, 0.17029427E-05_JPRB, 0.17034049E-05_JPRB, 0.17037109E-05_JPRB, 0.17042400E-05_JPRB, &
  & 0.17054708E-05_JPRB, 0.17065181E-05_JPRB, 0.17064928E-05_JPRB, 0.17061937E-05_JPRB, 0.17055976E-05_JPRB, 0.17049429E-05_JPRB, &
  & 0.17045784E-05_JPRB, 0.17037263E-05_JPRB, 0.17033901E-05_JPRB, 0.17030885E-05_JPRB, 0.17030178E-05_JPRB, 0.17055930E-05_JPRB, &
  & 0.17078060E-05_JPRB, 0.17094631E-05_JPRB, 0.17087563E-05_JPRB, 0.17077284E-05_JPRB, 0.17098048E-05_JPRB, 0.17153978E-05_JPRB, &
  & 0.17174480E-05_JPRB, 0.17184609E-05_JPRB, 0.17194004E-05_JPRB, 0.17227404E-05_JPRB, 0.17324861E-05_JPRB, 0.17442455E-05_JPRB, &
  & 0.17483593E-05_JPRB, 0.17563385E-05_JPRB, 0.17653837E-05_JPRB, 0.17763956E-05_JPRB, 0.17838118E-05_JPRB, 0.17868761E-05_JPRB, &
  & 0.17905848E-05_JPRB, 0.17927885E-05_JPRB, 0.17948730E-05_JPRB, 0.17960518E-05_JPRB, 0.17929455E-05_JPRB, 0.17916699E-05_JPRB, &
  & 0.17893001E-05_JPRB, 0.17840810E-05_JPRB, 0.17766673E-05_JPRB, 0.17660061E-05_JPRB, 0.17619266E-05_JPRB, 0.17606423E-05_JPRB, &
  & 0.17574595E-05_JPRB, 0.17535180E-05_JPRB, 0.17523966E-05_JPRB, 0.17524507E-05_JPRB  /)

RGHG2(:,88, 7) = (/ &
  & 0.17008862E-05_JPRB, 0.17009166E-05_JPRB, 0.17010208E-05_JPRB, 0.17010775E-05_JPRB, 0.17012647E-05_JPRB, 0.17015855E-05_JPRB, &
  & 0.17017080E-05_JPRB, 0.17016766E-05_JPRB, 0.17017724E-05_JPRB, 0.17014799E-05_JPRB, 0.17014269E-05_JPRB, 0.17016521E-05_JPRB, &
  & 0.17020834E-05_JPRB, 0.17025370E-05_JPRB, 0.17030110E-05_JPRB, 0.17035767E-05_JPRB, 0.17038414E-05_JPRB, 0.17043741E-05_JPRB, &
  & 0.17057670E-05_JPRB, 0.17070546E-05_JPRB, 0.17069800E-05_JPRB, 0.17066744E-05_JPRB, 0.17059981E-05_JPRB, 0.17053510E-05_JPRB, &
  & 0.17050755E-05_JPRB, 0.17040672E-05_JPRB, 0.17037564E-05_JPRB, 0.17035209E-05_JPRB, 0.17036380E-05_JPRB, 0.17071304E-05_JPRB, &
  & 0.17095479E-05_JPRB, 0.17112084E-05_JPRB, 0.17108863E-05_JPRB, 0.17090027E-05_JPRB, 0.17114202E-05_JPRB, 0.17170098E-05_JPRB, &
  & 0.17183825E-05_JPRB, 0.17193677E-05_JPRB, 0.17202589E-05_JPRB, 0.17238589E-05_JPRB, 0.17352441E-05_JPRB, 0.17481533E-05_JPRB, &
  & 0.17516545E-05_JPRB, 0.17594063E-05_JPRB, 0.17679658E-05_JPRB, 0.17796156E-05_JPRB, 0.17870642E-05_JPRB, 0.17887004E-05_JPRB, &
  & 0.17921415E-05_JPRB, 0.17941988E-05_JPRB, 0.17964811E-05_JPRB, 0.17981513E-05_JPRB, 0.17949818E-05_JPRB, 0.17938964E-05_JPRB, &
  & 0.17913161E-05_JPRB, 0.17854638E-05_JPRB, 0.17777520E-05_JPRB, 0.17664841E-05_JPRB, 0.17625573E-05_JPRB, 0.17614190E-05_JPRB, &
  & 0.17580681E-05_JPRB, 0.17536652E-05_JPRB, 0.17522737E-05_JPRB, 0.17521679E-05_JPRB  /)

RGHG2(:,89, 7) = (/ &
  & 0.17008879E-05_JPRB, 0.17009205E-05_JPRB, 0.17010205E-05_JPRB, 0.17010800E-05_JPRB, 0.17012774E-05_JPRB, 0.17016107E-05_JPRB, &
  & 0.17017825E-05_JPRB, 0.17017233E-05_JPRB, 0.17018315E-05_JPRB, 0.17014906E-05_JPRB, 0.17014308E-05_JPRB, 0.17016549E-05_JPRB, &
  & 0.17021162E-05_JPRB, 0.17026025E-05_JPRB, 0.17030842E-05_JPRB, 0.17038095E-05_JPRB, 0.17039966E-05_JPRB, 0.17045256E-05_JPRB, &
  & 0.17061555E-05_JPRB, 0.17077419E-05_JPRB, 0.17076202E-05_JPRB, 0.17073481E-05_JPRB, 0.17066722E-05_JPRB, 0.17059595E-05_JPRB, &
  & 0.17058604E-05_JPRB, 0.17045806E-05_JPRB, 0.17042813E-05_JPRB, 0.17041868E-05_JPRB, 0.17046163E-05_JPRB, 0.17096660E-05_JPRB, &
  & 0.17122910E-05_JPRB, 0.17138400E-05_JPRB, 0.17145651E-05_JPRB, 0.17110567E-05_JPRB, 0.17137154E-05_JPRB, 0.17192895E-05_JPRB, &
  & 0.17196940E-05_JPRB, 0.17206173E-05_JPRB, 0.17213775E-05_JPRB, 0.17252965E-05_JPRB, 0.17386092E-05_JPRB, 0.17535422E-05_JPRB, &
  & 0.17563370E-05_JPRB, 0.17631892E-05_JPRB, 0.17714052E-05_JPRB, 0.17841562E-05_JPRB, 0.17916440E-05_JPRB, 0.17913698E-05_JPRB, &
  & 0.17942930E-05_JPRB, 0.17963315E-05_JPRB, 0.17990700E-05_JPRB, 0.18011778E-05_JPRB, 0.17979443E-05_JPRB, 0.17972733E-05_JPRB, &
  & 0.17942035E-05_JPRB, 0.17874894E-05_JPRB, 0.17793911E-05_JPRB, 0.17672806E-05_JPRB, 0.17633827E-05_JPRB, 0.17621898E-05_JPRB, &
  & 0.17585898E-05_JPRB, 0.17538257E-05_JPRB, 0.17522604E-05_JPRB, 0.17520896E-05_JPRB  /)

RGHG2(:,90, 7) = (/ &
  & 0.17008931E-05_JPRB, 0.17009227E-05_JPRB, 0.17010199E-05_JPRB, 0.17010808E-05_JPRB, 0.17012901E-05_JPRB, 0.17016434E-05_JPRB, &
  & 0.17018604E-05_JPRB, 0.17017478E-05_JPRB, 0.17018648E-05_JPRB, 0.17014974E-05_JPRB, 0.17014331E-05_JPRB, 0.17016586E-05_JPRB, &
  & 0.17021499E-05_JPRB, 0.17026683E-05_JPRB, 0.17031702E-05_JPRB, 0.17040693E-05_JPRB, 0.17041807E-05_JPRB, 0.17047430E-05_JPRB, &
  & 0.17066465E-05_JPRB, 0.17085738E-05_JPRB, 0.17085151E-05_JPRB, 0.17083340E-05_JPRB, 0.17078655E-05_JPRB, 0.17067291E-05_JPRB, &
  & 0.17073224E-05_JPRB, 0.17052652E-05_JPRB, 0.17050226E-05_JPRB, 0.17052163E-05_JPRB, 0.17060170E-05_JPRB, 0.17131776E-05_JPRB, &
  & 0.17160367E-05_JPRB, 0.17173891E-05_JPRB, 0.17195141E-05_JPRB, 0.17136151E-05_JPRB, 0.17162135E-05_JPRB, 0.17224285E-05_JPRB, &
  & 0.17212579E-05_JPRB, 0.17221625E-05_JPRB, 0.17227741E-05_JPRB, 0.17270553E-05_JPRB, 0.17422788E-05_JPRB, 0.17599313E-05_JPRB, &
  & 0.17617143E-05_JPRB, 0.17682007E-05_JPRB, 0.17760253E-05_JPRB, 0.17905607E-05_JPRB, 0.17979733E-05_JPRB, 0.17951797E-05_JPRB, &
  & 0.17973295E-05_JPRB, 0.18000326E-05_JPRB, 0.18033114E-05_JPRB, 0.18061601E-05_JPRB, 0.18017577E-05_JPRB, 0.18023644E-05_JPRB, &
  & 0.17985238E-05_JPRB, 0.17905503E-05_JPRB, 0.17817132E-05_JPRB, 0.17682574E-05_JPRB, 0.17641876E-05_JPRB, 0.17628679E-05_JPRB, &
  & 0.17590010E-05_JPRB, 0.17539997E-05_JPRB, 0.17522658E-05_JPRB, 0.17520846E-05_JPRB  /)

RGHG2(:,91, 7) = (/ &
  & 0.17008947E-05_JPRB, 0.17009243E-05_JPRB, 0.17010231E-05_JPRB, 0.17010823E-05_JPRB, 0.17012996E-05_JPRB, 0.17016849E-05_JPRB, &
  & 0.17019449E-05_JPRB, 0.17017606E-05_JPRB, 0.17018824E-05_JPRB, 0.17015038E-05_JPRB, 0.17014379E-05_JPRB, 0.17016618E-05_JPRB, &
  & 0.17021754E-05_JPRB, 0.17027417E-05_JPRB, 0.17032389E-05_JPRB, 0.17045097E-05_JPRB, 0.17043945E-05_JPRB, 0.17050398E-05_JPRB, &
  & 0.17074267E-05_JPRB, 0.17097018E-05_JPRB, 0.17099717E-05_JPRB, 0.17099454E-05_JPRB, 0.17097577E-05_JPRB, 0.17074136E-05_JPRB, &
  & 0.17116541E-05_JPRB, 0.17063501E-05_JPRB, 0.17066069E-05_JPRB, 0.17067321E-05_JPRB, 0.17079140E-05_JPRB, 0.17169845E-05_JPRB, &
  & 0.17205040E-05_JPRB, 0.17221436E-05_JPRB, 0.17264896E-05_JPRB, 0.17166322E-05_JPRB, 0.17189402E-05_JPRB, 0.17266805E-05_JPRB, &
  & 0.17229634E-05_JPRB, 0.17237404E-05_JPRB, 0.17242244E-05_JPRB, 0.17291103E-05_JPRB, 0.17470142E-05_JPRB, 0.17676343E-05_JPRB, &
  & 0.17676113E-05_JPRB, 0.17749401E-05_JPRB, 0.17826179E-05_JPRB, 0.17975554E-05_JPRB, 0.18068267E-05_JPRB, 0.18010256E-05_JPRB, &
  & 0.18028100E-05_JPRB, 0.18076926E-05_JPRB, 0.18111661E-05_JPRB, 0.18124830E-05_JPRB, 0.18069782E-05_JPRB, 0.18096351E-05_JPRB, &
  & 0.18065172E-05_JPRB, 0.17951421E-05_JPRB, 0.17842740E-05_JPRB, 0.17692147E-05_JPRB, 0.17649247E-05_JPRB, 0.17635189E-05_JPRB, &
  & 0.17592882E-05_JPRB, 0.17541257E-05_JPRB, 0.17522754E-05_JPRB, 0.17520878E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ---GEMS----

RGHG2(:, 1, 8) = (/ &
  & 0.18794303E-06_JPRB, 0.18798912E-06_JPRB, 0.18803768E-06_JPRB, 0.18811258E-06_JPRB, 0.18810353E-06_JPRB, 0.18800064E-06_JPRB, &
  & 0.18785907E-06_JPRB, 0.18766235E-06_JPRB, 0.18752819E-06_JPRB, 0.18743683E-06_JPRB, 0.18733805E-06_JPRB, 0.18713722E-06_JPRB, &
  & 0.18694379E-06_JPRB, 0.18677177E-06_JPRB, 0.18658986E-06_JPRB, 0.18642689E-06_JPRB, 0.18629108E-06_JPRB, 0.18621700E-06_JPRB, &
  & 0.18625240E-06_JPRB, 0.18628861E-06_JPRB, 0.18644418E-06_JPRB, 0.18670510E-06_JPRB, 0.18694544E-06_JPRB, 0.18711088E-06_JPRB, &
  & 0.18711170E-06_JPRB, 0.18700059E-06_JPRB, 0.18685490E-06_JPRB, 0.18674625E-06_JPRB, 0.18665160E-06_JPRB, 0.18652566E-06_JPRB, &
  & 0.18625075E-06_JPRB, 0.18578735E-06_JPRB, 0.18507784E-06_JPRB, 0.18399054E-06_JPRB, 0.18256741E-06_JPRB, 0.18100929E-06_JPRB, &
  & 0.17940673E-06_JPRB, 0.17779512E-06_JPRB, 0.17617692E-06_JPRB, 0.17474391E-06_JPRB, 0.17344837E-06_JPRB, 0.17240057E-06_JPRB, &
  & 0.17172316E-06_JPRB, 0.17125647E-06_JPRB, 0.17055849E-06_JPRB, 0.16947283E-06_JPRB, 0.16794681E-06_JPRB, 0.16614095E-06_JPRB, &
  & 0.16433755E-06_JPRB, 0.16249053E-06_JPRB, 0.16046079E-06_JPRB, 0.15828947E-06_JPRB, 0.15609510E-06_JPRB, 0.15392872E-06_JPRB, &
  & 0.15188334E-06_JPRB, 0.14994742E-06_JPRB, 0.14793167E-06_JPRB, 0.14579081E-06_JPRB, 0.14388288E-06_JPRB, 0.14239308E-06_JPRB, &
  & 0.14130824E-06_JPRB, 0.14048680E-06_JPRB, 0.13987030E-06_JPRB, 0.13945299E-06_JPRB  /)

RGHG2(:, 2, 8) = (/ &
  & 0.18794303E-06_JPRB, 0.18798912E-06_JPRB, 0.18803768E-06_JPRB, 0.18811258E-06_JPRB, 0.18810353E-06_JPRB, 0.18800064E-06_JPRB, &
  & 0.18785907E-06_JPRB, 0.18766235E-06_JPRB, 0.18752819E-06_JPRB, 0.18743683E-06_JPRB, 0.18733805E-06_JPRB, 0.18713722E-06_JPRB, &
  & 0.18694379E-06_JPRB, 0.18677177E-06_JPRB, 0.18658986E-06_JPRB, 0.18642689E-06_JPRB, 0.18629108E-06_JPRB, 0.18621700E-06_JPRB, &
  & 0.18625240E-06_JPRB, 0.18628861E-06_JPRB, 0.18644418E-06_JPRB, 0.18670510E-06_JPRB, 0.18694544E-06_JPRB, 0.18711088E-06_JPRB, &
  & 0.18711170E-06_JPRB, 0.18700059E-06_JPRB, 0.18685490E-06_JPRB, 0.18674625E-06_JPRB, 0.18665160E-06_JPRB, 0.18652566E-06_JPRB, &
  & 0.18625075E-06_JPRB, 0.18578735E-06_JPRB, 0.18507784E-06_JPRB, 0.18399054E-06_JPRB, 0.18256741E-06_JPRB, 0.18100929E-06_JPRB, &
  & 0.17940673E-06_JPRB, 0.17779512E-06_JPRB, 0.17617692E-06_JPRB, 0.17474391E-06_JPRB, 0.17344837E-06_JPRB, 0.17240057E-06_JPRB, &
  & 0.17172316E-06_JPRB, 0.17125647E-06_JPRB, 0.17055849E-06_JPRB, 0.16947283E-06_JPRB, 0.16794681E-06_JPRB, 0.16614095E-06_JPRB, &
  & 0.16433755E-06_JPRB, 0.16249053E-06_JPRB, 0.16046079E-06_JPRB, 0.15828947E-06_JPRB, 0.15609510E-06_JPRB, 0.15392872E-06_JPRB, &
  & 0.15188334E-06_JPRB, 0.14994742E-06_JPRB, 0.14793167E-06_JPRB, 0.14579081E-06_JPRB, 0.14388288E-06_JPRB, 0.14239308E-06_JPRB, &
  & 0.14130824E-06_JPRB, 0.14048680E-06_JPRB, 0.13987030E-06_JPRB, 0.13945299E-06_JPRB  /)

RGHG2(:, 3, 8) = (/ &
  & 0.18794303E-06_JPRB, 0.18798912E-06_JPRB, 0.18803768E-06_JPRB, 0.18811258E-06_JPRB, 0.18810353E-06_JPRB, 0.18800064E-06_JPRB, &
  & 0.18785907E-06_JPRB, 0.18766235E-06_JPRB, 0.18752819E-06_JPRB, 0.18743683E-06_JPRB, 0.18733805E-06_JPRB, 0.18713722E-06_JPRB, &
  & 0.18694379E-06_JPRB, 0.18677177E-06_JPRB, 0.18658986E-06_JPRB, 0.18642689E-06_JPRB, 0.18629108E-06_JPRB, 0.18621700E-06_JPRB, &
  & 0.18625240E-06_JPRB, 0.18628861E-06_JPRB, 0.18644418E-06_JPRB, 0.18670510E-06_JPRB, 0.18694544E-06_JPRB, 0.18711088E-06_JPRB, &
  & 0.18711170E-06_JPRB, 0.18700059E-06_JPRB, 0.18685490E-06_JPRB, 0.18674625E-06_JPRB, 0.18665160E-06_JPRB, 0.18652566E-06_JPRB, &
  & 0.18625075E-06_JPRB, 0.18578735E-06_JPRB, 0.18507784E-06_JPRB, 0.18399054E-06_JPRB, 0.18256741E-06_JPRB, 0.18100929E-06_JPRB, &
  & 0.17940673E-06_JPRB, 0.17779512E-06_JPRB, 0.17617692E-06_JPRB, 0.17474391E-06_JPRB, 0.17344837E-06_JPRB, 0.17240057E-06_JPRB, &
  & 0.17172316E-06_JPRB, 0.17125647E-06_JPRB, 0.17055849E-06_JPRB, 0.16947283E-06_JPRB, 0.16794681E-06_JPRB, 0.16614095E-06_JPRB, &
  & 0.16433755E-06_JPRB, 0.16249053E-06_JPRB, 0.16046079E-06_JPRB, 0.15828947E-06_JPRB, 0.15609510E-06_JPRB, 0.15392872E-06_JPRB, &
  & 0.15188334E-06_JPRB, 0.14994742E-06_JPRB, 0.14793167E-06_JPRB, 0.14579081E-06_JPRB, 0.14388288E-06_JPRB, 0.14239308E-06_JPRB, &
  & 0.14130824E-06_JPRB, 0.14048680E-06_JPRB, 0.13987030E-06_JPRB, 0.13945299E-06_JPRB  /)

RGHG2(:, 4, 8) = (/ &
  & 0.18794390E-06_JPRB, 0.18798998E-06_JPRB, 0.18803827E-06_JPRB, 0.18811271E-06_JPRB, 0.18810368E-06_JPRB, 0.18800124E-06_JPRB, &
  & 0.18786042E-06_JPRB, 0.18766465E-06_JPRB, 0.18753114E-06_JPRB, 0.18744047E-06_JPRB, 0.18734242E-06_JPRB, 0.18714343E-06_JPRB, &
  & 0.18695183E-06_JPRB, 0.18678181E-06_JPRB, 0.18660196E-06_JPRB, 0.18644044E-06_JPRB, 0.18630566E-06_JPRB, 0.18623253E-06_JPRB, &
  & 0.18626858E-06_JPRB, 0.18630598E-06_JPRB, 0.18646287E-06_JPRB, 0.18672429E-06_JPRB, 0.18696501E-06_JPRB, 0.18713126E-06_JPRB, &
  & 0.18713490E-06_JPRB, 0.18702816E-06_JPRB, 0.18688882E-06_JPRB, 0.18678894E-06_JPRB, 0.18670421E-06_JPRB, 0.18658798E-06_JPRB, &
  & 0.18632157E-06_JPRB, 0.18586616E-06_JPRB, 0.18516514E-06_JPRB, 0.18408488E-06_JPRB, 0.18266425E-06_JPRB, 0.18110468E-06_JPRB, &
  & 0.17949644E-06_JPRB, 0.17787481E-06_JPRB, 0.17624607E-06_JPRB, 0.17480326E-06_JPRB, 0.17350169E-06_JPRB, 0.17245132E-06_JPRB, &
  & 0.17177196E-06_JPRB, 0.17130310E-06_JPRB, 0.17060455E-06_JPRB, 0.16952024E-06_JPRB, 0.16799509E-06_JPRB, 0.16618870E-06_JPRB, &
  & 0.16438373E-06_JPRB, 0.16253510E-06_JPRB, 0.16050456E-06_JPRB, 0.15833272E-06_JPRB, 0.15613680E-06_JPRB, 0.15396643E-06_JPRB, &
  & 0.15191580E-06_JPRB, 0.14997420E-06_JPRB, 0.14795298E-06_JPRB, 0.14580710E-06_JPRB, 0.14389213E-06_JPRB, 0.14239346E-06_JPRB, &
  & 0.14130017E-06_JPRB, 0.14047135E-06_JPRB, 0.13984810E-06_JPRB, 0.13942495E-06_JPRB  /)

RGHG2(:, 5, 8) = (/ &
  & 0.18798548E-06_JPRB, 0.18803096E-06_JPRB, 0.18806633E-06_JPRB, 0.18811884E-06_JPRB, 0.18811070E-06_JPRB, 0.18802960E-06_JPRB, &
  & 0.18792423E-06_JPRB, 0.18777383E-06_JPRB, 0.18767127E-06_JPRB, 0.18761334E-06_JPRB, 0.18754954E-06_JPRB, 0.18743829E-06_JPRB, &
  & 0.18733352E-06_JPRB, 0.18725875E-06_JPRB, 0.18717594E-06_JPRB, 0.18708352E-06_JPRB, 0.18699772E-06_JPRB, 0.18696966E-06_JPRB, &
  & 0.18703665E-06_JPRB, 0.18713054E-06_JPRB, 0.18735022E-06_JPRB, 0.18763538E-06_JPRB, 0.18789413E-06_JPRB, 0.18809853E-06_JPRB, &
  & 0.18823588E-06_JPRB, 0.18833675E-06_JPRB, 0.18849876E-06_JPRB, 0.18881532E-06_JPRB, 0.18920139E-06_JPRB, 0.18954576E-06_JPRB, &
  & 0.18968316E-06_JPRB, 0.18960723E-06_JPRB, 0.18930881E-06_JPRB, 0.18856296E-06_JPRB, 0.18726101E-06_JPRB, 0.18563203E-06_JPRB, &
  & 0.18375428E-06_JPRB, 0.18165734E-06_JPRB, 0.17952865E-06_JPRB, 0.17762043E-06_JPRB, 0.17603283E-06_JPRB, 0.17486017E-06_JPRB, &
  & 0.17408797E-06_JPRB, 0.17351666E-06_JPRB, 0.17279107E-06_JPRB, 0.17177075E-06_JPRB, 0.17028646E-06_JPRB, 0.16845544E-06_JPRB, &
  & 0.16657566E-06_JPRB, 0.16465071E-06_JPRB, 0.16258231E-06_JPRB, 0.16038584E-06_JPRB, 0.15811600E-06_JPRB, 0.15575635E-06_JPRB, &
  & 0.15345664E-06_JPRB, 0.15124523E-06_JPRB, 0.14896473E-06_JPRB, 0.14658058E-06_JPRB, 0.14433151E-06_JPRB, 0.14241160E-06_JPRB, &
  & 0.14091690E-06_JPRB, 0.13973836E-06_JPRB, 0.13879452E-06_JPRB, 0.13809405E-06_JPRB  /)

RGHG2(:, 6, 8) = (/ &
  & 0.18804786E-06_JPRB, 0.18809243E-06_JPRB, 0.18810842E-06_JPRB, 0.18812802E-06_JPRB, 0.18812124E-06_JPRB, 0.18807214E-06_JPRB, &
  & 0.18801996E-06_JPRB, 0.18793763E-06_JPRB, 0.18788150E-06_JPRB, 0.18787271E-06_JPRB, 0.18786030E-06_JPRB, 0.18788068E-06_JPRB, &
  & 0.18790619E-06_JPRB, 0.18797431E-06_JPRB, 0.18803711E-06_JPRB, 0.18804837E-06_JPRB, 0.18803605E-06_JPRB, 0.18807561E-06_JPRB, &
  & 0.18818903E-06_JPRB, 0.18836767E-06_JPRB, 0.18868156E-06_JPRB, 0.18900233E-06_JPRB, 0.18928813E-06_JPRB, 0.18954978E-06_JPRB, &
  & 0.18988772E-06_JPRB, 0.19030009E-06_JPRB, 0.19091424E-06_JPRB, 0.19185559E-06_JPRB, 0.19294804E-06_JPRB, 0.19398346E-06_JPRB, &
  & 0.19472672E-06_JPRB, 0.19522013E-06_JPRB, 0.19552577E-06_JPRB, 0.19528164E-06_JPRB, 0.19415775E-06_JPRB, 0.19242464E-06_JPRB, &
  & 0.19014254E-06_JPRB, 0.18733245E-06_JPRB, 0.18445365E-06_JPRB, 0.18184717E-06_JPRB, 0.17983042E-06_JPRB, 0.17847429E-06_JPRB, &
  & 0.17756280E-06_JPRB, 0.17683777E-06_JPRB, 0.17607161E-06_JPRB, 0.17514731E-06_JPRB, 0.17372433E-06_JPRB, 0.17185634E-06_JPRB, &
  & 0.16986431E-06_JPRB, 0.16782487E-06_JPRB, 0.16569967E-06_JPRB, 0.16346623E-06_JPRB, 0.16108550E-06_JPRB, 0.15844185E-06_JPRB, &
  & 0.15576844E-06_JPRB, 0.15315223E-06_JPRB, 0.15048269E-06_JPRB, 0.14774107E-06_JPRB, 0.14499073E-06_JPRB, 0.14243882E-06_JPRB, &
  & 0.14034187E-06_JPRB, 0.13863861E-06_JPRB, 0.13721379E-06_JPRB, 0.13609724E-06_JPRB  /)

RGHG2(:, 7, 8) = (/ &
  & 0.18831016E-06_JPRB, 0.18832992E-06_JPRB, 0.18832561E-06_JPRB, 0.18833322E-06_JPRB, 0.18835029E-06_JPRB, 0.18834699E-06_JPRB, &
  & 0.18836735E-06_JPRB, 0.18842556E-06_JPRB, 0.18856236E-06_JPRB, 0.18881170E-06_JPRB, 0.18912462E-06_JPRB, 0.18953341E-06_JPRB, &
  & 0.18999754E-06_JPRB, 0.19047630E-06_JPRB, 0.19089765E-06_JPRB, 0.19118321E-06_JPRB, 0.19138626E-06_JPRB, 0.19153748E-06_JPRB, &
  & 0.19164737E-06_JPRB, 0.19174369E-06_JPRB, 0.19194373E-06_JPRB, 0.19220178E-06_JPRB, 0.19233413E-06_JPRB, 0.19248272E-06_JPRB, &
  & 0.19277576E-06_JPRB, 0.19340107E-06_JPRB, 0.19459835E-06_JPRB, 0.19659641E-06_JPRB, 0.19935715E-06_JPRB, 0.20244127E-06_JPRB, &
  & 0.20509948E-06_JPRB, 0.20717335E-06_JPRB, 0.20910668E-06_JPRB, 0.21059160E-06_JPRB, 0.21075780E-06_JPRB, 0.20959383E-06_JPRB, &
  & 0.20691247E-06_JPRB, 0.20279932E-06_JPRB, 0.19825309E-06_JPRB, 0.19398157E-06_JPRB, 0.19062897E-06_JPRB, 0.18844691E-06_JPRB, &
  & 0.18700805E-06_JPRB, 0.18588625E-06_JPRB, 0.18497841E-06_JPRB, 0.18388085E-06_JPRB, 0.18222813E-06_JPRB, 0.17995052E-06_JPRB, &
  & 0.17737847E-06_JPRB, 0.17474017E-06_JPRB, 0.17202964E-06_JPRB, 0.16921890E-06_JPRB, 0.16609892E-06_JPRB, 0.16262399E-06_JPRB, &
  & 0.15918135E-06_JPRB, 0.15575641E-06_JPRB, 0.15229793E-06_JPRB, 0.14886556E-06_JPRB, 0.14551054E-06_JPRB, 0.14221461E-06_JPRB, &
  & 0.13910639E-06_JPRB, 0.13637948E-06_JPRB, 0.13415543E-06_JPRB, 0.13257929E-06_JPRB  /)

RGHG2(:, 8, 8) = (/ &
  & 0.18904560E-06_JPRB, 0.18902451E-06_JPRB, 0.18902233E-06_JPRB, 0.18904942E-06_JPRB, 0.18909334E-06_JPRB, 0.18915861E-06_JPRB, &
  & 0.18931453E-06_JPRB, 0.18966307E-06_JPRB, 0.19028416E-06_JPRB, 0.19115782E-06_JPRB, 0.19221921E-06_JPRB, 0.19352409E-06_JPRB, &
  & 0.19503949E-06_JPRB, 0.19650104E-06_JPRB, 0.19774431E-06_JPRB, 0.19874017E-06_JPRB, 0.19940963E-06_JPRB, 0.19969858E-06_JPRB, &
  & 0.19978221E-06_JPRB, 0.19972208E-06_JPRB, 0.19968271E-06_JPRB, 0.19962787E-06_JPRB, 0.19937947E-06_JPRB, 0.19916521E-06_JPRB, &
  & 0.19935356E-06_JPRB, 0.20007878E-06_JPRB, 0.20175622E-06_JPRB, 0.20491559E-06_JPRB, 0.21011669E-06_JPRB, 0.21698324E-06_JPRB, &
  & 0.22355249E-06_JPRB, 0.22850630E-06_JPRB, 0.23300731E-06_JPRB, 0.23736019E-06_JPRB, 0.24028845E-06_JPRB, 0.24096083E-06_JPRB, &
  & 0.23852342E-06_JPRB, 0.23304037E-06_JPRB, 0.22590047E-06_JPRB, 0.21879649E-06_JPRB, 0.21275732E-06_JPRB, 0.20851839E-06_JPRB, &
  & 0.20554154E-06_JPRB, 0.20312872E-06_JPRB, 0.20129842E-06_JPRB, 0.19927430E-06_JPRB, 0.19652880E-06_JPRB, 0.19297869E-06_JPRB, &
  & 0.18909717E-06_JPRB, 0.18519999E-06_JPRB, 0.18124854E-06_JPRB, 0.17708472E-06_JPRB, 0.17259151E-06_JPRB, 0.16806309E-06_JPRB, &
  & 0.16373622E-06_JPRB, 0.15935697E-06_JPRB, 0.15488628E-06_JPRB, 0.15046072E-06_JPRB, 0.14618268E-06_JPRB, 0.14182603E-06_JPRB, &
  & 0.13734166E-06_JPRB, 0.13310913E-06_JPRB, 0.12971783E-06_JPRB, 0.12762326E-06_JPRB  /)

RGHG2(:, 9, 8) = (/ &
  & 0.19083796E-06_JPRB, 0.19079956E-06_JPRB, 0.19081035E-06_JPRB, 0.19085561E-06_JPRB, 0.19094105E-06_JPRB, 0.19108099E-06_JPRB, &
  & 0.19142683E-06_JPRB, 0.19225393E-06_JPRB, 0.19377460E-06_JPRB, 0.19588001E-06_JPRB, 0.19834654E-06_JPRB, 0.20146359E-06_JPRB, &
  & 0.20498802E-06_JPRB, 0.20830561E-06_JPRB, 0.21113602E-06_JPRB, 0.21338944E-06_JPRB, 0.21481620E-06_JPRB, 0.21543369E-06_JPRB, &
  & 0.21557624E-06_JPRB, 0.21535590E-06_JPRB, 0.21500463E-06_JPRB, 0.21440883E-06_JPRB, 0.21366894E-06_JPRB, 0.21318594E-06_JPRB, &
  & 0.21350225E-06_JPRB, 0.21461206E-06_JPRB, 0.21714731E-06_JPRB, 0.22201198E-06_JPRB, 0.23059680E-06_JPRB, 0.24300174E-06_JPRB, &
  & 0.25590844E-06_JPRB, 0.26562625E-06_JPRB, 0.27358911E-06_JPRB, 0.28179789E-06_JPRB, 0.28894256E-06_JPRB, 0.29265342E-06_JPRB, &
  & 0.29128501E-06_JPRB, 0.28475486E-06_JPRB, 0.27457409E-06_JPRB, 0.26356723E-06_JPRB, 0.25291866E-06_JPRB, 0.24439158E-06_JPRB, &
  & 0.23754362E-06_JPRB, 0.23149965E-06_JPRB, 0.22650445E-06_JPRB, 0.22167512E-06_JPRB, 0.21630399E-06_JPRB, 0.21031392E-06_JPRB, &
  & 0.20426007E-06_JPRB, 0.19828928E-06_JPRB, 0.19230249E-06_JPRB, 0.18611691E-06_JPRB, 0.18007795E-06_JPRB, 0.17470240E-06_JPRB, &
  & 0.16973507E-06_JPRB, 0.16456060E-06_JPRB, 0.15903913E-06_JPRB, 0.15339629E-06_JPRB, 0.14786417E-06_JPRB, 0.14204076E-06_JPRB, &
  & 0.13570588E-06_JPRB, 0.12935207E-06_JPRB, 0.12409132E-06_JPRB, 0.12097413E-06_JPRB  /)

RGHG2(:,10, 8) = (/ &
  & 0.19404344E-06_JPRB, 0.19403715E-06_JPRB, 0.19399558E-06_JPRB, 0.19401733E-06_JPRB, 0.19416278E-06_JPRB, 0.19438643E-06_JPRB, &
  & 0.19490869E-06_JPRB, 0.19634929E-06_JPRB, 0.19922461E-06_JPRB, 0.20331383E-06_JPRB, 0.20801415E-06_JPRB, 0.21412738E-06_JPRB, &
  & 0.22070036E-06_JPRB, 0.22661797E-06_JPRB, 0.23166503E-06_JPRB, 0.23548509E-06_JPRB, 0.23790530E-06_JPRB, 0.23930828E-06_JPRB, &
  & 0.23997406E-06_JPRB, 0.23973478E-06_JPRB, 0.23900739E-06_JPRB, 0.23811740E-06_JPRB, 0.23748540E-06_JPRB, 0.23752104E-06_JPRB, &
  & 0.23875906E-06_JPRB, 0.24166680E-06_JPRB, 0.24749135E-06_JPRB, 0.25703889E-06_JPRB, 0.27097321E-06_JPRB, 0.28993344E-06_JPRB, &
  & 0.31048072E-06_JPRB, 0.32649814E-06_JPRB, 0.33867235E-06_JPRB, 0.35106502E-06_JPRB, 0.36235184E-06_JPRB, 0.36840569E-06_JPRB, &
  & 0.36739814E-06_JPRB, 0.35996689E-06_JPRB, 0.34766452E-06_JPRB, 0.33273880E-06_JPRB, 0.31628403E-06_JPRB, 0.30068688E-06_JPRB, &
  & 0.28582869E-06_JPRB, 0.27101651E-06_JPRB, 0.25746300E-06_JPRB, 0.24591931E-06_JPRB, 0.23598925E-06_JPRB, 0.22696334E-06_JPRB, &
  & 0.21871588E-06_JPRB, 0.21077467E-06_JPRB, 0.20316277E-06_JPRB, 0.19590992E-06_JPRB, 0.18938099E-06_JPRB, 0.18376709E-06_JPRB, &
  & 0.17854097E-06_JPRB, 0.17282258E-06_JPRB, 0.16645231E-06_JPRB, 0.15964761E-06_JPRB, 0.15276118E-06_JPRB, 0.14516683E-06_JPRB, &
  & 0.13636822E-06_JPRB, 0.12726894E-06_JPRB, 0.11941177E-06_JPRB, 0.11459030E-06_JPRB  /)

RGHG2(:,11, 8) = (/ &
  & 0.19732388E-06_JPRB, 0.19733313E-06_JPRB, 0.19720410E-06_JPRB, 0.19719597E-06_JPRB, 0.19738315E-06_JPRB, 0.19780712E-06_JPRB, &
  & 0.19856328E-06_JPRB, 0.20075567E-06_JPRB, 0.20545360E-06_JPRB, 0.21218854E-06_JPRB, 0.21998200E-06_JPRB, 0.22981493E-06_JPRB, &
  & 0.23998955E-06_JPRB, 0.24889245E-06_JPRB, 0.25610056E-06_JPRB, 0.26136525E-06_JPRB, 0.26504388E-06_JPRB, 0.26789401E-06_JPRB, &
  & 0.26966836E-06_JPRB, 0.26968591E-06_JPRB, 0.26873353E-06_JPRB, 0.26804804E-06_JPRB, 0.26824590E-06_JPRB, 0.26967974E-06_JPRB, &
  & 0.27325587E-06_JPRB, 0.28080980E-06_JPRB, 0.29489177E-06_JPRB, 0.31555647E-06_JPRB, 0.33989570E-06_JPRB, 0.36748085E-06_JPRB, &
  & 0.39518366E-06_JPRB, 0.41728359E-06_JPRB, 0.43387765E-06_JPRB, 0.44939031E-06_JPRB, 0.46189583E-06_JPRB, 0.46648213E-06_JPRB, &
  & 0.46214064E-06_JPRB, 0.45218336E-06_JPRB, 0.43823449E-06_JPRB, 0.42071431E-06_JPRB, 0.39974103E-06_JPRB, 0.37528733E-06_JPRB, &
  & 0.34771484E-06_JPRB, 0.31712460E-06_JPRB, 0.28751912E-06_JPRB, 0.26457436E-06_JPRB, 0.24914890E-06_JPRB, 0.23830704E-06_JPRB, &
  & 0.22988154E-06_JPRB, 0.22268446E-06_JPRB, 0.21660642E-06_JPRB, 0.21105913E-06_JPRB, 0.20536778E-06_JPRB, 0.19958955E-06_JPRB, &
  & 0.19375228E-06_JPRB, 0.18710001E-06_JPRB, 0.17994230E-06_JPRB, 0.17238129E-06_JPRB, 0.16469704E-06_JPRB, 0.15567825E-06_JPRB, &
  & 0.14436309E-06_JPRB, 0.13243718E-06_JPRB, 0.12208293E-06_JPRB, 0.11563418E-06_JPRB  /)

RGHG2(:,12, 8) = (/ &
  & 0.19895685E-06_JPRB, 0.19912577E-06_JPRB, 0.19899727E-06_JPRB, 0.19895776E-06_JPRB, 0.19922942E-06_JPRB, 0.19992363E-06_JPRB, &
  & 0.20117938E-06_JPRB, 0.20438739E-06_JPRB, 0.21112569E-06_JPRB, 0.22110000E-06_JPRB, 0.23276541E-06_JPRB, 0.24649939E-06_JPRB, &
  & 0.26055487E-06_JPRB, 0.27277742E-06_JPRB, 0.28216296E-06_JPRB, 0.28919660E-06_JPRB, 0.29475846E-06_JPRB, 0.29899335E-06_JPRB, &
  & 0.30102527E-06_JPRB, 0.30112971E-06_JPRB, 0.30006904E-06_JPRB, 0.29912108E-06_JPRB, 0.29975243E-06_JPRB, 0.30335599E-06_JPRB, &
  & 0.31087675E-06_JPRB, 0.32623530E-06_JPRB, 0.35309305E-06_JPRB, 0.39105135E-06_JPRB, 0.43186189E-06_JPRB, 0.47209269E-06_JPRB, &
  & 0.50916991E-06_JPRB, 0.53790835E-06_JPRB, 0.55723709E-06_JPRB, 0.57218053E-06_JPRB, 0.58094621E-06_JPRB, 0.57932900E-06_JPRB, &
  & 0.56808282E-06_JPRB, 0.55144949E-06_JPRB, 0.53201891E-06_JPRB, 0.51127341E-06_JPRB, 0.48617557E-06_JPRB, 0.45232710E-06_JPRB, &
  & 0.41075573E-06_JPRB, 0.36270083E-06_JPRB, 0.31569929E-06_JPRB, 0.28151648E-06_JPRB, 0.26242370E-06_JPRB, 0.25194035E-06_JPRB, &
  & 0.24587539E-06_JPRB, 0.24274765E-06_JPRB, 0.24088967E-06_JPRB, 0.23817524E-06_JPRB, 0.23346427E-06_JPRB, 0.22699680E-06_JPRB, &
  & 0.21981240E-06_JPRB, 0.21171760E-06_JPRB, 0.20350237E-06_JPRB, 0.19590242E-06_JPRB, 0.18893527E-06_JPRB, 0.18004409E-06_JPRB, &
  & 0.16783765E-06_JPRB, 0.15423889E-06_JPRB, 0.14160236E-06_JPRB, 0.13330947E-06_JPRB  /)

RGHG2(:,13, 8) = (/ &
  & 0.20053987E-06_JPRB, 0.20077853E-06_JPRB, 0.20063823E-06_JPRB, 0.20061593E-06_JPRB, 0.20089356E-06_JPRB, 0.20169233E-06_JPRB, &
  & 0.20347802E-06_JPRB, 0.20792692E-06_JPRB, 0.21672984E-06_JPRB, 0.23051465E-06_JPRB, 0.24728575E-06_JPRB, 0.26589923E-06_JPRB, &
  & 0.28423692E-06_JPRB, 0.29991839E-06_JPRB, 0.31165032E-06_JPRB, 0.32071688E-06_JPRB, 0.32774941E-06_JPRB, 0.33179295E-06_JPRB, &
  & 0.33248148E-06_JPRB, 0.33177110E-06_JPRB, 0.32999427E-06_JPRB, 0.32897486E-06_JPRB, 0.33008836E-06_JPRB, 0.33497855E-06_JPRB, &
  & 0.34702769E-06_JPRB, 0.37071794E-06_JPRB, 0.41106585E-06_JPRB, 0.46650204E-06_JPRB, 0.52711803E-06_JPRB, 0.58649641E-06_JPRB, &
  & 0.63983445E-06_JPRB, 0.67594511E-06_JPRB, 0.69433204E-06_JPRB, 0.70309541E-06_JPRB, 0.70385628E-06_JPRB, 0.69564776E-06_JPRB, &
  & 0.67874636E-06_JPRB, 0.65250305E-06_JPRB, 0.62158957E-06_JPRB, 0.59113408E-06_JPRB, 0.55759701E-06_JPRB, 0.51501230E-06_JPRB, &
  & 0.46253512E-06_JPRB, 0.40198960E-06_JPRB, 0.34504566E-06_JPRB, 0.30591074E-06_JPRB, 0.28546764E-06_JPRB, 0.27551394E-06_JPRB, &
  & 0.27268690E-06_JPRB, 0.27458050E-06_JPRB, 0.27632056E-06_JPRB, 0.27570460E-06_JPRB, 0.27196477E-06_JPRB, 0.26507363E-06_JPRB, &
  & 0.25631239E-06_JPRB, 0.24701336E-06_JPRB, 0.23833870E-06_JPRB, 0.23077807E-06_JPRB, 0.22433227E-06_JPRB, 0.21651097E-06_JPRB, &
  & 0.20534276E-06_JPRB, 0.19181933E-06_JPRB, 0.17771747E-06_JPRB, 0.16722911E-06_JPRB  /)

RGHG2(:,14, 8) = (/ &
  & 0.20434818E-06_JPRB, 0.20453533E-06_JPRB, 0.20463979E-06_JPRB, 0.20477206E-06_JPRB, 0.20493917E-06_JPRB, 0.20552435E-06_JPRB, &
  & 0.20759253E-06_JPRB, 0.21319726E-06_JPRB, 0.22470710E-06_JPRB, 0.24305224E-06_JPRB, 0.26675239E-06_JPRB, 0.29195755E-06_JPRB, &
  & 0.31523201E-06_JPRB, 0.33403568E-06_JPRB, 0.34742898E-06_JPRB, 0.35744229E-06_JPRB, 0.36405459E-06_JPRB, 0.36707105E-06_JPRB, &
  & 0.36653027E-06_JPRB, 0.36507917E-06_JPRB, 0.36411069E-06_JPRB, 0.36406981E-06_JPRB, 0.36592622E-06_JPRB, 0.37152277E-06_JPRB, &
  & 0.38550345E-06_JPRB, 0.41299465E-06_JPRB, 0.46001784E-06_JPRB, 0.52811637E-06_JPRB, 0.61099077E-06_JPRB, 0.69559050E-06_JPRB, &
  & 0.76747856E-06_JPRB, 0.80934833E-06_JPRB, 0.82354498E-06_JPRB, 0.82274522E-06_JPRB, 0.81508581E-06_JPRB, 0.80370719E-06_JPRB, &
  & 0.78451597E-06_JPRB, 0.74955287E-06_JPRB, 0.70437730E-06_JPRB, 0.65791478E-06_JPRB, 0.60998759E-06_JPRB, 0.55732484E-06_JPRB, &
  & 0.49667259E-06_JPRB, 0.43084011E-06_JPRB, 0.37447762E-06_JPRB, 0.33665195E-06_JPRB, 0.31564343E-06_JPRB, 0.30592697E-06_JPRB, &
  & 0.30635350E-06_JPRB, 0.31137740E-06_JPRB, 0.31453276E-06_JPRB, 0.31519059E-06_JPRB, 0.31253806E-06_JPRB, 0.30610195E-06_JPRB, &
  & 0.29652732E-06_JPRB, 0.28677094E-06_JPRB, 0.27811581E-06_JPRB, 0.26883613E-06_JPRB, 0.26108100E-06_JPRB, 0.25350928E-06_JPRB, &
  & 0.24258434E-06_JPRB, 0.22876578E-06_JPRB, 0.21463125E-06_JPRB, 0.20145225E-06_JPRB  /)

RGHG2(:,15, 8) = (/ &
  & 0.21072562E-06_JPRB, 0.21118992E-06_JPRB, 0.21214257E-06_JPRB, 0.21297859E-06_JPRB, 0.21328674E-06_JPRB, 0.21362690E-06_JPRB, &
  & 0.21572236E-06_JPRB, 0.22247484E-06_JPRB, 0.23757057E-06_JPRB, 0.26257291E-06_JPRB, 0.29523033E-06_JPRB, 0.32868174E-06_JPRB, &
  & 0.35852519E-06_JPRB, 0.38005222E-06_JPRB, 0.39454724E-06_JPRB, 0.40502447E-06_JPRB, 0.41114944E-06_JPRB, 0.41347634E-06_JPRB, &
  & 0.41295029E-06_JPRB, 0.41305250E-06_JPRB, 0.41489865E-06_JPRB, 0.41843042E-06_JPRB, 0.42336120E-06_JPRB, 0.43052754E-06_JPRB, &
  & 0.44358536E-06_JPRB, 0.46785966E-06_JPRB, 0.51266286E-06_JPRB, 0.58751142E-06_JPRB, 0.68754045E-06_JPRB, 0.78763064E-06_JPRB, &
  & 0.86817061E-06_JPRB, 0.91312202E-06_JPRB, 0.92525685E-06_JPRB, 0.91962245E-06_JPRB, 0.90790371E-06_JPRB, 0.89513880E-06_JPRB, &
  & 0.87413323E-06_JPRB, 0.83141233E-06_JPRB, 0.77346256E-06_JPRB, 0.71061777E-06_JPRB, 0.64431035E-06_JPRB, 0.57873552E-06_JPRB, &
  & 0.51448669E-06_JPRB, 0.45293663E-06_JPRB, 0.40377139E-06_JPRB, 0.36958653E-06_JPRB, 0.34902554E-06_JPRB, 0.34009393E-06_JPRB, &
  & 0.34199591E-06_JPRB, 0.34663163E-06_JPRB, 0.35032207E-06_JPRB, 0.35170444E-06_JPRB, 0.34956983E-06_JPRB, 0.34393813E-06_JPRB, &
  & 0.33471494E-06_JPRB, 0.32504514E-06_JPRB, 0.31500484E-06_JPRB, 0.30248654E-06_JPRB, 0.29255766E-06_JPRB, 0.28393400E-06_JPRB, &
  & 0.27125945E-06_JPRB, 0.25526021E-06_JPRB, 0.23991223E-06_JPRB, 0.22431483E-06_JPRB  /)

RGHG2(:,16, 8) = (/ &
  & 0.22111365E-06_JPRB, 0.22175907E-06_JPRB, 0.22351336E-06_JPRB, 0.22548632E-06_JPRB, 0.22651628E-06_JPRB, 0.22692901E-06_JPRB, &
  & 0.22933707E-06_JPRB, 0.23745595E-06_JPRB, 0.25679728E-06_JPRB, 0.29100072E-06_JPRB, 0.33533985E-06_JPRB, 0.38005184E-06_JPRB, &
  & 0.41926862E-06_JPRB, 0.44644150E-06_JPRB, 0.46451387E-06_JPRB, 0.47570077E-06_JPRB, 0.48260662E-06_JPRB, 0.48500467E-06_JPRB, &
  & 0.48647352E-06_JPRB, 0.49058320E-06_JPRB, 0.49796332E-06_JPRB, 0.50828224E-06_JPRB, 0.51896584E-06_JPRB, 0.53126786E-06_JPRB, &
  & 0.54886269E-06_JPRB, 0.57674460E-06_JPRB, 0.62266338E-06_JPRB, 0.70066056E-06_JPRB, 0.79620579E-06_JPRB, 0.88082178E-06_JPRB, &
  & 0.94749177E-06_JPRB, 0.98796771E-06_JPRB, 0.10006043E-05_JPRB, 0.99653103E-06_JPRB, 0.98525417E-06_JPRB, 0.97134640E-06_JPRB, &
  & 0.94476723E-06_JPRB, 0.89276083E-06_JPRB, 0.82552541E-06_JPRB, 0.75036207E-06_JPRB, 0.66540465E-06_JPRB, 0.58901311E-06_JPRB, &
  & 0.52699561E-06_JPRB, 0.47527974E-06_JPRB, 0.43408904E-06_JPRB, 0.40375256E-06_JPRB, 0.38486769E-06_JPRB, 0.37636926E-06_JPRB, &
  & 0.37643905E-06_JPRB, 0.37908463E-06_JPRB, 0.38316305E-06_JPRB, 0.38499830E-06_JPRB, 0.38306141E-06_JPRB, 0.37742041E-06_JPRB, &
  & 0.36830278E-06_JPRB, 0.35808171E-06_JPRB, 0.34493845E-06_JPRB, 0.32940075E-06_JPRB, 0.31645515E-06_JPRB, 0.30577647E-06_JPRB, &
  & 0.29168748E-06_JPRB, 0.27197992E-06_JPRB, 0.25211690E-06_JPRB, 0.23527124E-06_JPRB  /)

RGHG2(:,17, 8) = (/ &
  & 0.23576809E-06_JPRB, 0.23716784E-06_JPRB, 0.23932111E-06_JPRB, 0.24185202E-06_JPRB, 0.24390642E-06_JPRB, 0.24516178E-06_JPRB, &
  & 0.24844364E-06_JPRB, 0.25878256E-06_JPRB, 0.28290699E-06_JPRB, 0.32735793E-06_JPRB, 0.38682620E-06_JPRB, 0.44714650E-06_JPRB, &
  & 0.49994075E-06_JPRB, 0.53799763E-06_JPRB, 0.56365596E-06_JPRB, 0.57822684E-06_JPRB, 0.58600585E-06_JPRB, 0.58897182E-06_JPRB, &
  & 0.59298081E-06_JPRB, 0.60023503E-06_JPRB, 0.61212630E-06_JPRB, 0.62892447E-06_JPRB, 0.64716902E-06_JPRB, 0.66941463E-06_JPRB, &
  & 0.70141041E-06_JPRB, 0.74868880E-06_JPRB, 0.81944769E-06_JPRB, 0.90410263E-06_JPRB, 0.97145856E-06_JPRB, 0.10129309E-05_JPRB, &
  & 0.10398608E-05_JPRB, 0.10596168E-05_JPRB, 0.10675866E-05_JPRB, 0.10649741E-05_JPRB, 0.10552378E-05_JPRB, 0.10390496E-05_JPRB, &
  & 0.10028246E-05_JPRB, 0.94012842E-06_JPRB, 0.86580358E-06_JPRB, 0.77992003E-06_JPRB, 0.68120822E-06_JPRB, 0.60054082E-06_JPRB, &
  & 0.54293084E-06_JPRB, 0.50112455E-06_JPRB, 0.46647114E-06_JPRB, 0.43986152E-06_JPRB, 0.42334516E-06_JPRB, 0.41474978E-06_JPRB, &
  & 0.41053268E-06_JPRB, 0.41043725E-06_JPRB, 0.41447664E-06_JPRB, 0.41715747E-06_JPRB, 0.41473668E-06_JPRB, 0.40756968E-06_JPRB, &
  & 0.39724025E-06_JPRB, 0.38496430E-06_JPRB, 0.36846528E-06_JPRB, 0.35082347E-06_JPRB, 0.33494054E-06_JPRB, 0.32165659E-06_JPRB, &
  & 0.30601209E-06_JPRB, 0.28314521E-06_JPRB, 0.25829234E-06_JPRB, 0.24088151E-06_JPRB  /)

RGHG2(:,18, 8) = (/ &
  & 0.25492546E-06_JPRB, 0.25773973E-06_JPRB, 0.25992878E-06_JPRB, 0.26259497E-06_JPRB, 0.26547861E-06_JPRB, 0.26832531E-06_JPRB, &
  & 0.27307702E-06_JPRB, 0.28625890E-06_JPRB, 0.31556601E-06_JPRB, 0.37050747E-06_JPRB, 0.44645158E-06_JPRB, 0.52657942E-06_JPRB, &
  & 0.59589815E-06_JPRB, 0.64816104E-06_JPRB, 0.68410932E-06_JPRB, 0.70462344E-06_JPRB, 0.71541482E-06_JPRB, 0.71926731E-06_JPRB, &
  & 0.72299488E-06_JPRB, 0.73038700E-06_JPRB, 0.74247315E-06_JPRB, 0.76097315E-06_JPRB, 0.78333646E-06_JPRB, 0.81525358E-06_JPRB, &
  & 0.86119699E-06_JPRB, 0.93219282E-06_JPRB, 0.10375812E-05_JPRB, 0.11256916E-05_JPRB, 0.11590730E-05_JPRB, 0.11601712E-05_JPRB, &
  & 0.11507857E-05_JPRB, 0.11452050E-05_JPRB, 0.11406901E-05_JPRB, 0.11326635E-05_JPRB, 0.11203387E-05_JPRB, 0.10980653E-05_JPRB, &
  & 0.10515584E-05_JPRB, 0.97999360E-06_JPRB, 0.89630268E-06_JPRB, 0.79908018E-06_JPRB, 0.69494524E-06_JPRB, 0.61601341E-06_JPRB, &
  & 0.56397176E-06_JPRB, 0.52907187E-06_JPRB, 0.49949340E-06_JPRB, 0.47728058E-06_JPRB, 0.46522321E-06_JPRB, 0.45681552E-06_JPRB, &
  & 0.44804485E-06_JPRB, 0.44495066E-06_JPRB, 0.44809838E-06_JPRB, 0.45035693E-06_JPRB, 0.44658571E-06_JPRB, 0.43752858E-06_JPRB, &
  & 0.42462200E-06_JPRB, 0.40910708E-06_JPRB, 0.39028667E-06_JPRB, 0.37182518E-06_JPRB, 0.35473293E-06_JPRB, 0.33725888E-06_JPRB, &
  & 0.31896446E-06_JPRB, 0.29494810E-06_JPRB, 0.26728032E-06_JPRB, 0.24768112E-06_JPRB  /)

RGHG2(:,19, 8) = (/ &
  & 0.27987910E-06_JPRB, 0.28380626E-06_JPRB, 0.28661741E-06_JPRB, 0.28981387E-06_JPRB, 0.29343831E-06_JPRB, 0.29783924E-06_JPRB, &
  & 0.30434050E-06_JPRB, 0.32028701E-06_JPRB, 0.35480746E-06_JPRB, 0.41987475E-06_JPRB, 0.51149157E-06_JPRB, 0.61135968E-06_JPRB, &
  & 0.69791485E-06_JPRB, 0.76408601E-06_JPRB, 0.80933396E-06_JPRB, 0.83520546E-06_JPRB, 0.84932101E-06_JPRB, 0.85437397E-06_JPRB, &
  & 0.85893305E-06_JPRB, 0.86589343E-06_JPRB, 0.87578879E-06_JPRB, 0.89098940E-06_JPRB, 0.91066109E-06_JPRB, 0.94508600E-06_JPRB, &
  & 0.99850783E-06_JPRB, 0.10839508E-05_JPRB, 0.12088674E-05_JPRB, 0.12978239E-05_JPRB, 0.13150856E-05_JPRB, 0.12980514E-05_JPRB, &
  & 0.12692917E-05_JPRB, 0.12426689E-05_JPRB, 0.12195135E-05_JPRB, 0.11990607E-05_JPRB, 0.11780490E-05_JPRB, 0.11446592E-05_JPRB, &
  & 0.10876126E-05_JPRB, 0.10088502E-05_JPRB, 0.91432685E-06_JPRB, 0.80758731E-06_JPRB, 0.70579418E-06_JPRB, 0.63327806E-06_JPRB, &
  & 0.58661849E-06_JPRB, 0.55594124E-06_JPRB, 0.53148875E-06_JPRB, 0.51614798E-06_JPRB, 0.51084579E-06_JPRB, 0.50345031E-06_JPRB, &
  & 0.49236262E-06_JPRB, 0.48626378E-06_JPRB, 0.48638139E-06_JPRB, 0.48593909E-06_JPRB, 0.48012620E-06_JPRB, 0.46950594E-06_JPRB, &
  & 0.45390840E-06_JPRB, 0.43521631E-06_JPRB, 0.41524860E-06_JPRB, 0.39646248E-06_JPRB, 0.37832549E-06_JPRB, 0.35682881E-06_JPRB, &
  & 0.33568376E-06_JPRB, 0.31102426E-06_JPRB, 0.28316386E-06_JPRB, 0.26449152E-06_JPRB  /)

RGHG2(:,20, 8) = (/ &
  & 0.31414263E-06_JPRB, 0.31844761E-06_JPRB, 0.32248699E-06_JPRB, 0.32649476E-06_JPRB, 0.33074842E-06_JPRB, 0.33617951E-06_JPRB, &
  & 0.34419709E-06_JPRB, 0.36223368E-06_JPRB, 0.40102605E-06_JPRB, 0.47478569E-06_JPRB, 0.57960425E-06_JPRB, 0.69579699E-06_JPRB, &
  & 0.79762038E-06_JPRB, 0.87502041E-06_JPRB, 0.92720148E-06_JPRB, 0.95669245E-06_JPRB, 0.97198622E-06_JPRB, 0.97794800E-06_JPRB, &
  & 0.98368242E-06_JPRB, 0.99190561E-06_JPRB, 0.10001410E-05_JPRB, 0.10112313E-05_JPRB, 0.10240475E-05_JPRB, 0.10537401E-05_JPRB, &
  & 0.11063975E-05_JPRB, 0.11937506E-05_JPRB, 0.13229682E-05_JPRB, 0.14128463E-05_JPRB, 0.14308953E-05_JPRB, 0.14139564E-05_JPRB, &
  & 0.13805177E-05_JPRB, 0.13389121E-05_JPRB, 0.12952292E-05_JPRB, 0.12580522E-05_JPRB, 0.12236905E-05_JPRB, 0.11761247E-05_JPRB, &
  & 0.11092563E-05_JPRB, 0.10241726E-05_JPRB, 0.92002038E-06_JPRB, 0.80957906E-06_JPRB, 0.71588967E-06_JPRB, 0.65137501E-06_JPRB, &
  & 0.60892731E-06_JPRB, 0.58175178E-06_JPRB, 0.56362361E-06_JPRB, 0.55707201E-06_JPRB, 0.55939596E-06_JPRB, 0.55448078E-06_JPRB, &
  & 0.54402676E-06_JPRB, 0.53493539E-06_JPRB, 0.52991586E-06_JPRB, 0.52497960E-06_JPRB, 0.51612783E-06_JPRB, 0.50348649E-06_JPRB, &
  & 0.48594202E-06_JPRB, 0.46499302E-06_JPRB, 0.44473785E-06_JPRB, 0.42539298E-06_JPRB, 0.40570588E-06_JPRB, 0.38228034E-06_JPRB, &
  & 0.35754040E-06_JPRB, 0.33179381E-06_JPRB, 0.30611961E-06_JPRB, 0.29214670E-06_JPRB  /)

RGHG2(:,21, 8) = (/ &
  & 0.36228658E-06_JPRB, 0.36551182E-06_JPRB, 0.37027457E-06_JPRB, 0.37481582E-06_JPRB, 0.37933581E-06_JPRB, 0.38521038E-06_JPRB, &
  & 0.39421634E-06_JPRB, 0.41323486E-06_JPRB, 0.45467424E-06_JPRB, 0.53492209E-06_JPRB, 0.64946280E-06_JPRB, 0.77732532E-06_JPRB, &
  & 0.89074297E-06_JPRB, 0.97549132E-06_JPRB, 0.10317617E-05_JPRB, 0.10629256E-05_JPRB, 0.10775221E-05_JPRB, 0.10837297E-05_JPRB, &
  & 0.10900224E-05_JPRB, 0.11008556E-05_JPRB, 0.11087698E-05_JPRB, 0.11168381E-05_JPRB, 0.11225263E-05_JPRB, 0.11440522E-05_JPRB, &
  & 0.11892853E-05_JPRB, 0.12695233E-05_JPRB, 0.13932806E-05_JPRB, 0.14840494E-05_JPRB, 0.15109761E-05_JPRB, 0.15030996E-05_JPRB, &
  & 0.14730706E-05_JPRB, 0.14220314E-05_JPRB, 0.13605428E-05_JPRB, 0.13062559E-05_JPRB, 0.12566782E-05_JPRB, 0.11948235E-05_JPRB, &
  & 0.11196126E-05_JPRB, 0.10289564E-05_JPRB, 0.91849160E-06_JPRB, 0.81105528E-06_JPRB, 0.72819028E-06_JPRB, 0.67120577E-06_JPRB, &
  & 0.63209556E-06_JPRB, 0.60867768E-06_JPRB, 0.59743496E-06_JPRB, 0.60047619E-06_JPRB, 0.61057575E-06_JPRB, 0.60981398E-06_JPRB, &
  & 0.60204208E-06_JPRB, 0.59007318E-06_JPRB, 0.57885891E-06_JPRB, 0.56830196E-06_JPRB, 0.55529778E-06_JPRB, 0.53991872E-06_JPRB, &
  & 0.52124422E-06_JPRB, 0.49922190E-06_JPRB, 0.47887480E-06_JPRB, 0.45861570E-06_JPRB, 0.43713175E-06_JPRB, 0.41334749E-06_JPRB, &
  & 0.38521304E-06_JPRB, 0.35811399E-06_JPRB, 0.33524900E-06_JPRB, 0.32663650E-06_JPRB  /)

RGHG2(:,22, 8) = (/ &
  & 0.43087832E-06_JPRB, 0.43037630E-06_JPRB, 0.43353346E-06_JPRB, 0.43752041E-06_JPRB, 0.44150520E-06_JPRB, 0.44728420E-06_JPRB, &
  & 0.45648130E-06_JPRB, 0.47481172E-06_JPRB, 0.51648046E-06_JPRB, 0.59997771E-06_JPRB, 0.71935429E-06_JPRB, 0.85312308E-06_JPRB, &
  & 0.97250432E-06_JPRB, 0.10592979E-05_JPRB, 0.11161034E-05_JPRB, 0.11467895E-05_JPRB, 0.11604112E-05_JPRB, 0.11658925E-05_JPRB, &
  & 0.11713824E-05_JPRB, 0.11845284E-05_JPRB, 0.11932836E-05_JPRB, 0.11999948E-05_JPRB, 0.12027012E-05_JPRB, 0.12179003E-05_JPRB, &
  & 0.12514547E-05_JPRB, 0.13210079E-05_JPRB, 0.14349023E-05_JPRB, 0.15246963E-05_JPRB, 0.15580072E-05_JPRB, 0.15584644E-05_JPRB, &
  & 0.15327934E-05_JPRB, 0.14776064E-05_JPRB, 0.14066373E-05_JPRB, 0.13397350E-05_JPRB, 0.12765290E-05_JPRB, 0.12039130E-05_JPRB, &
  & 0.11227958E-05_JPRB, 0.10277816E-05_JPRB, 0.91672430E-06_JPRB, 0.81901706E-06_JPRB, 0.74616785E-06_JPRB, 0.69459263E-06_JPRB, &
  & 0.65877005E-06_JPRB, 0.63971018E-06_JPRB, 0.63423992E-06_JPRB, 0.64636036E-06_JPRB, 0.66404822E-06_JPRB, 0.66925006E-06_JPRB, &
  & 0.66474666E-06_JPRB, 0.65025471E-06_JPRB, 0.63330620E-06_JPRB, 0.61661362E-06_JPRB, 0.59827661E-06_JPRB, 0.57953346E-06_JPRB, &
  & 0.56036199E-06_JPRB, 0.53862639E-06_JPRB, 0.51753383E-06_JPRB, 0.49616611E-06_JPRB, 0.47332506E-06_JPRB, 0.44904384E-06_JPRB, &
  & 0.41980077E-06_JPRB, 0.39182247E-06_JPRB, 0.36974116E-06_JPRB, 0.36212260E-06_JPRB  /)

RGHG2(:,23, 8) = (/ &
  & 0.51904419E-06_JPRB, 0.51602405E-06_JPRB, 0.51580733E-06_JPRB, 0.51767917E-06_JPRB, 0.51993114E-06_JPRB, 0.52422450E-06_JPRB, &
  & 0.53215072E-06_JPRB, 0.54838137E-06_JPRB, 0.58739990E-06_JPRB, 0.66930173E-06_JPRB, 0.78668383E-06_JPRB, 0.91816816E-06_JPRB, &
  & 0.10349825E-05_JPRB, 0.11188743E-05_JPRB, 0.11720453E-05_JPRB, 0.12000623E-05_JPRB, 0.12127227E-05_JPRB, 0.12183350E-05_JPRB, &
  & 0.12230503E-05_JPRB, 0.12368066E-05_JPRB, 0.12459758E-05_JPRB, 0.12522909E-05_JPRB, 0.12571246E-05_JPRB, 0.12712917E-05_JPRB, &
  & 0.12993797E-05_JPRB, 0.13658591E-05_JPRB, 0.14721500E-05_JPRB, 0.15515101E-05_JPRB, 0.15799903E-05_JPRB, 0.15796073E-05_JPRB, &
  & 0.15538038E-05_JPRB, 0.15003239E-05_JPRB, 0.14317535E-05_JPRB, 0.13627916E-05_JPRB, 0.12929720E-05_JPRB, 0.12160421E-05_JPRB, &
  & 0.11324806E-05_JPRB, 0.10367475E-05_JPRB, 0.93112756E-06_JPRB, 0.84298535E-06_JPRB, 0.77675331E-06_JPRB, 0.72920851E-06_JPRB, &
  & 0.69611302E-06_JPRB, 0.67895811E-06_JPRB, 0.67809135E-06_JPRB, 0.69801587E-06_JPRB, 0.72020768E-06_JPRB, 0.72918306E-06_JPRB, &
  & 0.72672038E-06_JPRB, 0.71159451E-06_JPRB, 0.68995558E-06_JPRB, 0.66832970E-06_JPRB, 0.64610773E-06_JPRB, 0.62491777E-06_JPRB, &
  & 0.60538623E-06_JPRB, 0.58388059E-06_JPRB, 0.56238476E-06_JPRB, 0.54016233E-06_JPRB, 0.51567833E-06_JPRB, 0.49006391E-06_JPRB, &
  & 0.46169949E-06_JPRB, 0.43746899E-06_JPRB, 0.41200924E-06_JPRB, 0.39542532E-06_JPRB  /)

RGHG2(:,24, 8) = (/ &
  & 0.61630120E-06_JPRB, 0.61160221E-06_JPRB, 0.60825848E-06_JPRB, 0.60809342E-06_JPRB, 0.60854531E-06_JPRB, 0.61077409E-06_JPRB, &
  & 0.61658547E-06_JPRB, 0.63017871E-06_JPRB, 0.66536931E-06_JPRB, 0.74295823E-06_JPRB, 0.85513574E-06_JPRB, 0.98009471E-06_JPRB, &
  & 0.10905518E-05_JPRB, 0.11691309E-05_JPRB, 0.12172951E-05_JPRB, 0.12420506E-05_JPRB, 0.12536545E-05_JPRB, 0.12597371E-05_JPRB, &
  & 0.12642242E-05_JPRB, 0.12777620E-05_JPRB, 0.12870820E-05_JPRB, 0.12935511E-05_JPRB, 0.13018789E-05_JPRB, 0.13172179E-05_JPRB, &
  & 0.13443363E-05_JPRB, 0.14110357E-05_JPRB, 0.15085096E-05_JPRB, 0.15738743E-05_JPRB, 0.15950461E-05_JPRB, 0.15919725E-05_JPRB, &
  & 0.15657897E-05_JPRB, 0.15157940E-05_JPRB, 0.14526566E-05_JPRB, 0.13852141E-05_JPRB, 0.13124645E-05_JPRB, 0.12339038E-05_JPRB, &
  & 0.11496209E-05_JPRB, 0.10552866E-05_JPRB, 0.95708390E-06_JPRB, 0.87809117E-06_JPRB, 0.81798411E-06_JPRB, 0.77388161E-06_JPRB, &
  & 0.74248817E-06_JPRB, 0.72658818E-06_JPRB, 0.73007535E-06_JPRB, 0.75615784E-06_JPRB, 0.78028636E-06_JPRB, 0.79068494E-06_JPRB, &
  & 0.78935804E-06_JPRB, 0.77358462E-06_JPRB, 0.74834346E-06_JPRB, 0.72328496E-06_JPRB, 0.69829029E-06_JPRB, 0.67522430E-06_JPRB, &
  & 0.65492441E-06_JPRB, 0.63406766E-06_JPRB, 0.61306755E-06_JPRB, 0.58990736E-06_JPRB, 0.56472368E-06_JPRB, 0.53825704E-06_JPRB, &
  & 0.50998690E-06_JPRB, 0.48968838E-06_JPRB, 0.46031403E-06_JPRB, 0.43513763E-06_JPRB  /)

RGHG2(:,25, 8) = (/ &
  & 0.72088628E-06_JPRB, 0.71579913E-06_JPRB, 0.71030432E-06_JPRB, 0.70868364E-06_JPRB, 0.70756670E-06_JPRB, 0.70711067E-06_JPRB, &
  & 0.70973586E-06_JPRB, 0.72017526E-06_JPRB, 0.75027120E-06_JPRB, 0.82001594E-06_JPRB, 0.92307158E-06_JPRB, 0.10361268E-05_JPRB, &
  & 0.11357152E-05_JPRB, 0.12060620E-05_JPRB, 0.12479509E-05_JPRB, 0.12690350E-05_JPRB, 0.12794583E-05_JPRB, 0.12863981E-05_JPRB, &
  & 0.12916291E-05_JPRB, 0.13038731E-05_JPRB, 0.13129666E-05_JPRB, 0.13203415E-05_JPRB, 0.13332787E-05_JPRB, 0.13524509E-05_JPRB, &
  & 0.13852138E-05_JPRB, 0.14562478E-05_JPRB, 0.15426427E-05_JPRB, 0.15904591E-05_JPRB, 0.16027840E-05_JPRB, 0.15959258E-05_JPRB, &
  & 0.15699533E-05_JPRB, 0.15251169E-05_JPRB, 0.14698722E-05_JPRB, 0.14078478E-05_JPRB, 0.13372493E-05_JPRB, 0.12604354E-05_JPRB, &
  & 0.11777375E-05_JPRB, 0.10876730E-05_JPRB, 0.99870538E-06_JPRB, 0.92775090E-06_JPRB, 0.87338545E-06_JPRB, 0.83183836E-06_JPRB, &
  & 0.80038024E-06_JPRB, 0.78507866E-06_JPRB, 0.79254453E-06_JPRB, 0.82187790E-06_JPRB, 0.84400090E-06_JPRB, 0.85208666E-06_JPRB, &
  & 0.85051716E-06_JPRB, 0.83367629E-06_JPRB, 0.80668839E-06_JPRB, 0.78074034E-06_JPRB, 0.75474291E-06_JPRB, 0.73069033E-06_JPRB, &
  & 0.70890247E-06_JPRB, 0.68942047E-06_JPRB, 0.67040971E-06_JPRB, 0.64614972E-06_JPRB, 0.62203350E-06_JPRB, 0.59579329E-06_JPRB, &
  & 0.56577640E-06_JPRB, 0.54851851E-06_JPRB, 0.51539189E-06_JPRB, 0.48491057E-06_JPRB  /)

RGHG2(:,26, 8) = (/ &
  & 0.82395138E-06_JPRB, 0.81933797E-06_JPRB, 0.81312019E-06_JPRB, 0.81026603E-06_JPRB, 0.80820562E-06_JPRB, 0.80599186E-06_JPRB, &
  & 0.80603550E-06_JPRB, 0.81326251E-06_JPRB, 0.83813560E-06_JPRB, 0.89804861E-06_JPRB, 0.98915864E-06_JPRB, 0.10880376E-05_JPRB, &
  & 0.11743388E-05_JPRB, 0.12352637E-05_JPRB, 0.12716206E-05_JPRB, 0.12896338E-05_JPRB, 0.12991726E-05_JPRB, 0.13068909E-05_JPRB, &
  & 0.13134888E-05_JPRB, 0.13246268E-05_JPRB, 0.13333308E-05_JPRB, 0.13418378E-05_JPRB, 0.13579316E-05_JPRB, 0.13817939E-05_JPRB, &
  & 0.14210850E-05_JPRB, 0.14906007E-05_JPRB, 0.15646549E-05_JPRB, 0.16019423E-05_JPRB, 0.16101398E-05_JPRB, 0.16022482E-05_JPRB, &
  & 0.15781846E-05_JPRB, 0.15393552E-05_JPRB, 0.14921649E-05_JPRB, 0.14368225E-05_JPRB, 0.13708893E-05_JPRB, 0.12974095E-05_JPRB, &
  & 0.12187493E-05_JPRB, 0.11356948E-05_JPRB, 0.10567846E-05_JPRB, 0.99377343E-06_JPRB, 0.94465102E-06_JPRB, 0.90482779E-06_JPRB, &
  & 0.87342731E-06_JPRB, 0.85880450E-06_JPRB, 0.86799390E-06_JPRB, 0.89494990E-06_JPRB, 0.91099661E-06_JPRB, 0.91371411E-06_JPRB, &
  & 0.90874609E-06_JPRB, 0.89024062E-06_JPRB, 0.86454283E-06_JPRB, 0.83980032E-06_JPRB, 0.81421163E-06_JPRB, 0.79031631E-06_JPRB, &
  & 0.76882082E-06_JPRB, 0.75083881E-06_JPRB, 0.73304143E-06_JPRB, 0.70962294E-06_JPRB, 0.68772538E-06_JPRB, 0.66289763E-06_JPRB, &
  & 0.62969577E-06_JPRB, 0.61022922E-06_JPRB, 0.57496952E-06_JPRB, 0.54423946E-06_JPRB  /)

RGHG2(:,27, 8) = (/ &
  & 0.93114457E-06_JPRB, 0.92734606E-06_JPRB, 0.92090192E-06_JPRB, 0.91684050E-06_JPRB, 0.91402555E-06_JPRB, 0.91031781E-06_JPRB, &
  & 0.90788656E-06_JPRB, 0.91173324E-06_JPRB, 0.93109820E-06_JPRB, 0.97999497E-06_JPRB, 0.10575686E-05_JPRB, 0.11407834E-05_JPRB, &
  & 0.12122956E-05_JPRB, 0.12629286E-05_JPRB, 0.12937773E-05_JPRB, 0.13088026E-05_JPRB, 0.13175265E-05_JPRB, 0.13260295E-05_JPRB, &
  & 0.13342874E-05_JPRB, 0.13443389E-05_JPRB, 0.13525750E-05_JPRB, 0.13623496E-05_JPRB, 0.13812051E-05_JPRB, 0.14102888E-05_JPRB, &
  & 0.14567329E-05_JPRB, 0.15224910E-05_JPRB, 0.15831748E-05_JPRB, 0.16120567E-05_JPRB, 0.16176887E-05_JPRB, 0.16097367E-05_JPRB, &
  & 0.15882989E-05_JPRB, 0.15560642E-05_JPRB, 0.15173549E-05_JPRB, 0.14694673E-05_JPRB, 0.14093441E-05_JPRB, 0.13399388E-05_JPRB, &
  & 0.12664094E-05_JPRB, 0.11917001E-05_JPRB, 0.11236100E-05_JPRB, 0.10688686E-05_JPRB, 0.10250430E-05_JPRB, 0.98671377E-06_JPRB, &
  & 0.95541893E-06_JPRB, 0.94153557E-06_JPRB, 0.95169078E-06_JPRB, 0.97407428E-06_JPRB, 0.98225871E-06_JPRB, 0.97823064E-06_JPRB, &
  & 0.96853921E-06_JPRB, 0.94807194E-06_JPRB, 0.92484903E-06_JPRB, 0.90214377E-06_JPRB, 0.87750581E-06_JPRB, 0.85419902E-06_JPRB, &
  & 0.83366934E-06_JPRB, 0.81730204E-06_JPRB, 0.80048556E-06_JPRB, 0.77866669E-06_JPRB, 0.75951565E-06_JPRB, 0.73660443E-06_JPRB, &
  & 0.69953934E-06_JPRB, 0.67581719E-06_JPRB, 0.63892769E-06_JPRB, 0.60981233E-06_JPRB  /)

RGHG2(:,28, 8) = (/ &
  & 0.10258288E-05_JPRB, 0.10231515E-05_JPRB, 0.10174120E-05_JPRB, 0.10125896E-05_JPRB, 0.10088812E-05_JPRB, 0.10048893E-05_JPRB, &
  & 0.10020353E-05_JPRB, 0.10040090E-05_JPRB, 0.10187007E-05_JPRB, 0.10581507E-05_JPRB, 0.11223603E-05_JPRB, 0.11909006E-05_JPRB, &
  & 0.12496005E-05_JPRB, 0.12916540E-05_JPRB, 0.13181174E-05_JPRB, 0.13316732E-05_JPRB, 0.13403025E-05_JPRB, 0.13496501E-05_JPRB, &
  & 0.13590498E-05_JPRB, 0.13686330E-05_JPRB, 0.13783154E-05_JPRB, 0.13900302E-05_JPRB, 0.14092071E-05_JPRB, 0.14390343E-05_JPRB, &
  & 0.14844076E-05_JPRB, 0.15420935E-05_JPRB, 0.15940644E-05_JPRB, 0.16211386E-05_JPRB, 0.16288230E-05_JPRB, 0.16244741E-05_JPRB, &
  & 0.16082097E-05_JPRB, 0.15822558E-05_JPRB, 0.15491504E-05_JPRB, 0.15069515E-05_JPRB, 0.14532535E-05_JPRB, 0.13897921E-05_JPRB, &
  & 0.13236503E-05_JPRB, 0.12593218E-05_JPRB, 0.12026110E-05_JPRB, 0.11561317E-05_JPRB, 0.11170963E-05_JPRB, 0.10809540E-05_JPRB, &
  & 0.10515662E-05_JPRB, 0.10380123E-05_JPRB, 0.10429476E-05_JPRB, 0.10555243E-05_JPRB, 0.10543610E-05_JPRB, 0.10428318E-05_JPRB, &
  & 0.10277844E-05_JPRB, 0.10074528E-05_JPRB, 0.98562915E-06_JPRB, 0.96344214E-06_JPRB, 0.94055663E-06_JPRB, 0.91963906E-06_JPRB, &
  & 0.90175128E-06_JPRB, 0.88584806E-06_JPRB, 0.86883228E-06_JPRB, 0.84895413E-06_JPRB, 0.83058708E-06_JPRB, 0.80807669E-06_JPRB, &
  & 0.77189880E-06_JPRB, 0.74595626E-06_JPRB, 0.70901521E-06_JPRB, 0.68509608E-06_JPRB  /)

RGHG2(:,29, 8) = (/ &
  & 0.11256123E-05_JPRB, 0.11241362E-05_JPRB, 0.11191838E-05_JPRB, 0.11135743E-05_JPRB, 0.11089131E-05_JPRB, 0.11046728E-05_JPRB, &
  & 0.11014597E-05_JPRB, 0.11015142E-05_JPRB, 0.11112903E-05_JPRB, 0.11407989E-05_JPRB, 0.11908557E-05_JPRB, 0.12438900E-05_JPRB, &
  & 0.12890998E-05_JPRB, 0.13221370E-05_JPRB, 0.13440025E-05_JPRB, 0.13560671E-05_JPRB, 0.13646273E-05_JPRB, 0.13748723E-05_JPRB, &
  & 0.13854595E-05_JPRB, 0.13945732E-05_JPRB, 0.14058712E-05_JPRB, 0.14196709E-05_JPRB, 0.14390825E-05_JPRB, 0.14695035E-05_JPRB, &
  & 0.15133856E-05_JPRB, 0.15623312E-05_JPRB, 0.16052719E-05_JPRB, 0.16307168E-05_JPRB, 0.16407761E-05_JPRB, 0.16404038E-05_JPRB, &
  & 0.16297315E-05_JPRB, 0.16104191E-05_JPRB, 0.15831267E-05_JPRB, 0.15468789E-05_JPRB, 0.15000157E-05_JPRB, 0.14429334E-05_JPRB, &
  & 0.13847172E-05_JPRB, 0.13314761E-05_JPRB, 0.12868471E-05_JPRB, 0.12491218E-05_JPRB, 0.12151400E-05_JPRB, 0.11813450E-05_JPRB, &
  & 0.11540559E-05_JPRB, 0.11408334E-05_JPRB, 0.11399695E-05_JPRB, 0.11419281E-05_JPRB, 0.11307957E-05_JPRB, 0.11112857E-05_JPRB, &
  & 0.10905358E-05_JPRB, 0.10704389E-05_JPRB, 0.10500513E-05_JPRB, 0.10283475E-05_JPRB, 0.10073537E-05_JPRB, 0.98904573E-06_JPRB, &
  & 0.97402993E-06_JPRB, 0.95856856E-06_JPRB, 0.94129044E-06_JPRB, 0.92348343E-06_JPRB, 0.90586199E-06_JPRB, 0.88371060E-06_JPRB, &
  & 0.84867874E-06_JPRB, 0.82047175E-06_JPRB, 0.78354450E-06_JPRB, 0.76528651E-06_JPRB  /)

RGHG2(:,30, 8) = (/ &
  & 0.12043399E-05_JPRB, 0.12041567E-05_JPRB, 0.12012792E-05_JPRB, 0.11967061E-05_JPRB, 0.11916741E-05_JPRB, 0.11873122E-05_JPRB, &
  & 0.11841535E-05_JPRB, 0.11842425E-05_JPRB, 0.11912912E-05_JPRB, 0.12138708E-05_JPRB, 0.12530526E-05_JPRB, 0.12951198E-05_JPRB, &
  & 0.13310382E-05_JPRB, 0.13580691E-05_JPRB, 0.13768009E-05_JPRB, 0.13878817E-05_JPRB, 0.13964358E-05_JPRB, 0.14068454E-05_JPRB, &
  & 0.14181372E-05_JPRB, 0.14293974E-05_JPRB, 0.14433714E-05_JPRB, 0.14601085E-05_JPRB, 0.14799994E-05_JPRB, 0.15065212E-05_JPRB, &
  & 0.15426510E-05_JPRB, 0.15823884E-05_JPRB, 0.16185403E-05_JPRB, 0.16416852E-05_JPRB, 0.16528323E-05_JPRB, 0.16547500E-05_JPRB, &
  & 0.16476610E-05_JPRB, 0.16326060E-05_JPRB, 0.16098372E-05_JPRB, 0.15792958E-05_JPRB, 0.15402624E-05_JPRB, 0.14926410E-05_JPRB, &
  & 0.14443541E-05_JPRB, 0.14020338E-05_JPRB, 0.13674044E-05_JPRB, 0.13373348E-05_JPRB, 0.13085066E-05_JPRB, 0.12790380E-05_JPRB, &
  & 0.12547469E-05_JPRB, 0.12393111E-05_JPRB, 0.12313520E-05_JPRB, 0.12231060E-05_JPRB, 0.12039105E-05_JPRB, 0.11791411E-05_JPRB, &
  & 0.11556690E-05_JPRB, 0.11340986E-05_JPRB, 0.11127964E-05_JPRB, 0.10922879E-05_JPRB, 0.10728301E-05_JPRB, 0.10556587E-05_JPRB, &
  & 0.10410700E-05_JPRB, 0.10263550E-05_JPRB, 0.10097499E-05_JPRB, 0.99164755E-06_JPRB, 0.97419053E-06_JPRB, 0.95230025E-06_JPRB, &
  & 0.92129651E-06_JPRB, 0.89539213E-06_JPRB, 0.86073923E-06_JPRB, 0.84476066E-06_JPRB  /)

RGHG2(:,31, 8) = (/ &
  & 0.12872715E-05_JPRB, 0.12884507E-05_JPRB, 0.12877606E-05_JPRB, 0.12842812E-05_JPRB, 0.12788591E-05_JPRB, 0.12743693E-05_JPRB, &
  & 0.12712681E-05_JPRB, 0.12713956E-05_JPRB, 0.12755724E-05_JPRB, 0.12908541E-05_JPRB, 0.13185806E-05_JPRB, 0.13490965E-05_JPRB, &
  & 0.13752290E-05_JPRB, 0.13959342E-05_JPRB, 0.14113657E-05_JPRB, 0.14214103E-05_JPRB, 0.14299580E-05_JPRB, 0.14405403E-05_JPRB, &
  & 0.14525740E-05_JPRB, 0.14660984E-05_JPRB, 0.14828931E-05_JPRB, 0.15027258E-05_JPRB, 0.15231221E-05_JPRB, 0.15455312E-05_JPRB, &
  & 0.15734869E-05_JPRB, 0.16035214E-05_JPRB, 0.16325226E-05_JPRB, 0.16532434E-05_JPRB, 0.16655354E-05_JPRB, 0.16698644E-05_JPRB, &
  & 0.16665491E-05_JPRB, 0.16559777E-05_JPRB, 0.16379739E-05_JPRB, 0.16134448E-05_JPRB, 0.15826624E-05_JPRB, 0.15450124E-05_JPRB, &
  & 0.15071894E-05_JPRB, 0.14763755E-05_JPRB, 0.14522804E-05_JPRB, 0.14302763E-05_JPRB, 0.14068783E-05_JPRB, 0.13819701E-05_JPRB, &
  & 0.13608386E-05_JPRB, 0.13430682E-05_JPRB, 0.13276322E-05_JPRB, 0.13086345E-05_JPRB, 0.12809450E-05_JPRB, 0.12506366E-05_JPRB, &
  & 0.12242990E-05_JPRB, 0.12011744E-05_JPRB, 0.11789064E-05_JPRB, 0.11596579E-05_JPRB, 0.11418184E-05_JPRB, 0.11258430E-05_JPRB, &
  & 0.11117021E-05_JPRB, 0.10977738E-05_JPRB, 0.10818786E-05_JPRB, 0.10634629E-05_JPRB, 0.10461785E-05_JPRB, 0.10245633E-05_JPRB, &
  & 0.99780652E-06_JPRB, 0.97433264E-06_JPRB, 0.94207826E-06_JPRB, 0.92849820E-06_JPRB  /)

RGHG2(:,32, 8) = (/ &
  & 0.13534443E-05_JPRB, 0.13548670E-05_JPRB, 0.13554954E-05_JPRB, 0.13538053E-05_JPRB, 0.13490454E-05_JPRB, 0.13446495E-05_JPRB, &
  & 0.13411788E-05_JPRB, 0.13412179E-05_JPRB, 0.13443094E-05_JPRB, 0.13552506E-05_JPRB, 0.13756481E-05_JPRB, 0.13988191E-05_JPRB, &
  & 0.14188939E-05_JPRB, 0.14355980E-05_JPRB, 0.14484757E-05_JPRB, 0.14572727E-05_JPRB, 0.14655005E-05_JPRB, 0.14761328E-05_JPRB, &
  & 0.14890262E-05_JPRB, 0.15046705E-05_JPRB, 0.15233737E-05_JPRB, 0.15441106E-05_JPRB, 0.15642951E-05_JPRB, 0.15838750E-05_JPRB, &
  & 0.16056683E-05_JPRB, 0.16279502E-05_JPRB, 0.16493063E-05_JPRB, 0.16652276E-05_JPRB, 0.16754840E-05_JPRB, 0.16797815E-05_JPRB, &
  & 0.16782383E-05_JPRB, 0.16705372E-05_JPRB, 0.16566345E-05_JPRB, 0.16381106E-05_JPRB, 0.16151209E-05_JPRB, 0.15870246E-05_JPRB, &
  & 0.15588664E-05_JPRB, 0.15367620E-05_JPRB, 0.15198373E-05_JPRB, 0.15039372E-05_JPRB, 0.14859085E-05_JPRB, 0.14660775E-05_JPRB, &
  & 0.14468149E-05_JPRB, 0.14269581E-05_JPRB, 0.14060394E-05_JPRB, 0.13813042E-05_JPRB, 0.13508460E-05_JPRB, 0.13197747E-05_JPRB, &
  & 0.12923783E-05_JPRB, 0.12679179E-05_JPRB, 0.12446470E-05_JPRB, 0.12249409E-05_JPRB, 0.12070231E-05_JPRB, 0.11913090E-05_JPRB, &
  & 0.11772640E-05_JPRB, 0.11636030E-05_JPRB, 0.11477556E-05_JPRB, 0.11299642E-05_JPRB, 0.11144238E-05_JPRB, 0.10943270E-05_JPRB, &
  & 0.10707232E-05_JPRB, 0.10466587E-05_JPRB, 0.10202049E-05_JPRB, 0.10098047E-05_JPRB  /)

RGHG2(:,33, 8) = (/ &
  & 0.14200443E-05_JPRB, 0.14215754E-05_JPRB, 0.14234614E-05_JPRB, 0.14237210E-05_JPRB, 0.14197854E-05_JPRB, 0.14155159E-05_JPRB, &
  & 0.14116059E-05_JPRB, 0.14115367E-05_JPRB, 0.14137316E-05_JPRB, 0.14205449E-05_JPRB, 0.14338599E-05_JPRB, 0.14499425E-05_JPRB, &
  & 0.14642044E-05_JPRB, 0.14770514E-05_JPRB, 0.14873716E-05_JPRB, 0.14948449E-05_JPRB, 0.15026996E-05_JPRB, 0.15133680E-05_JPRB, &
  & 0.15271700E-05_JPRB, 0.15449986E-05_JPRB, 0.15655672E-05_JPRB, 0.15869600E-05_JPRB, 0.16068316E-05_JPRB, 0.16236375E-05_JPRB, &
  & 0.16392871E-05_JPRB, 0.16537643E-05_JPRB, 0.16671113E-05_JPRB, 0.16777373E-05_JPRB, 0.16854664E-05_JPRB, 0.16894149E-05_JPRB, &
  & 0.16894543E-05_JPRB, 0.16845272E-05_JPRB, 0.16748006E-05_JPRB, 0.16625167E-05_JPRB, 0.16475662E-05_JPRB, 0.16293445E-05_JPRB, &
  & 0.16111270E-05_JPRB, 0.15977117E-05_JPRB, 0.15878033E-05_JPRB, 0.15779927E-05_JPRB, 0.15655362E-05_JPRB, 0.15510486E-05_JPRB, &
  & 0.15335612E-05_JPRB, 0.15115682E-05_JPRB, 0.14852097E-05_JPRB, 0.14551612E-05_JPRB, 0.14225668E-05_JPRB, 0.13913211E-05_JPRB, &
  & 0.13630581E-05_JPRB, 0.13372378E-05_JPRB, 0.13129199E-05_JPRB, 0.12925157E-05_JPRB, 0.12742971E-05_JPRB, 0.12587334E-05_JPRB, &
  & 0.12447425E-05_JPRB, 0.12312922E-05_JPRB, 0.12154087E-05_JPRB, 0.11983875E-05_JPRB, 0.11848630E-05_JPRB, 0.11665052E-05_JPRB, &
  & 0.11460364E-05_JPRB, 0.11209671E-05_JPRB, 0.11009819E-05_JPRB, 0.10939876E-05_JPRB  /)

RGHG2(:,34, 8) = (/ &
  & 0.14749579E-05_JPRB, 0.14763566E-05_JPRB, 0.14787790E-05_JPRB, 0.14799558E-05_JPRB, 0.14768436E-05_JPRB, 0.14727303E-05_JPRB, &
  & 0.14684640E-05_JPRB, 0.14678007E-05_JPRB, 0.14693058E-05_JPRB, 0.14738065E-05_JPRB, 0.14828144E-05_JPRB, 0.14940572E-05_JPRB, &
  & 0.15042844E-05_JPRB, 0.15141408E-05_JPRB, 0.15223344E-05_JPRB, 0.15287819E-05_JPRB, 0.15362587E-05_JPRB, 0.15469084E-05_JPRB, &
  & 0.15610600E-05_JPRB, 0.15795325E-05_JPRB, 0.15999849E-05_JPRB, 0.16203462E-05_JPRB, 0.16384398E-05_JPRB, 0.16523423E-05_JPRB, &
  & 0.16636839E-05_JPRB, 0.16732243E-05_JPRB, 0.16814122E-05_JPRB, 0.16879222E-05_JPRB, 0.16929586E-05_JPRB, 0.16958780E-05_JPRB, &
  & 0.16965185E-05_JPRB, 0.16936942E-05_JPRB, 0.16873867E-05_JPRB, 0.16796548E-05_JPRB, 0.16704313E-05_JPRB, 0.16592938E-05_JPRB, &
  & 0.16482787E-05_JPRB, 0.16406546E-05_JPRB, 0.16355601E-05_JPRB, 0.16304760E-05_JPRB, 0.16227058E-05_JPRB, 0.16119645E-05_JPRB, &
  & 0.15962346E-05_JPRB, 0.15746408E-05_JPRB, 0.15476197E-05_JPRB, 0.15170757E-05_JPRB, 0.14855706E-05_JPRB, 0.14551507E-05_JPRB, &
  & 0.14262026E-05_JPRB, 0.13993208E-05_JPRB, 0.13738736E-05_JPRB, 0.13520796E-05_JPRB, 0.13333315E-05_JPRB, 0.13178233E-05_JPRB, &
  & 0.13042671E-05_JPRB, 0.12913832E-05_JPRB, 0.12763626E-05_JPRB, 0.12605543E-05_JPRB, 0.12482551E-05_JPRB, 0.12320595E-05_JPRB, &
  & 0.12134207E-05_JPRB, 0.11882649E-05_JPRB, 0.11727321E-05_JPRB, 0.11664949E-05_JPRB  /)

RGHG2(:,35, 8) = (/ &
  & 0.15254195E-05_JPRB, 0.15265586E-05_JPRB, 0.15291625E-05_JPRB, 0.15307524E-05_JPRB, 0.15284861E-05_JPRB, 0.15245487E-05_JPRB, &
  & 0.15199586E-05_JPRB, 0.15184354E-05_JPRB, 0.15193375E-05_JPRB, 0.15223919E-05_JPRB, 0.15283958E-05_JPRB, 0.15358165E-05_JPRB, &
  & 0.15428079E-05_JPRB, 0.15500344E-05_JPRB, 0.15562625E-05_JPRB, 0.15618081E-05_JPRB, 0.15688941E-05_JPRB, 0.15794963E-05_JPRB, &
  & 0.15937205E-05_JPRB, 0.16120646E-05_JPRB, 0.16313807E-05_JPRB, 0.16498156E-05_JPRB, 0.16653295E-05_JPRB, 0.16761805E-05_JPRB, &
  & 0.16840350E-05_JPRB, 0.16899710E-05_JPRB, 0.16943173E-05_JPRB, 0.16972007E-05_JPRB, 0.16993837E-05_JPRB, 0.17008960E-05_JPRB, &
  & 0.17016510E-05_JPRB, 0.17006442E-05_JPRB, 0.16974637E-05_JPRB, 0.16935454E-05_JPRB, 0.16890235E-05_JPRB, 0.16837378E-05_JPRB, &
  & 0.16787225E-05_JPRB, 0.16755653E-05_JPRB, 0.16742902E-05_JPRB, 0.16733660E-05_JPRB, 0.16699595E-05_JPRB, 0.16622502E-05_JPRB, &
  & 0.16483183E-05_JPRB, 0.16284359E-05_JPRB, 0.16031849E-05_JPRB, 0.15746035E-05_JPRB, 0.15458736E-05_JPRB, 0.15168162E-05_JPRB, &
  & 0.14872566E-05_JPRB, 0.14594368E-05_JPRB, 0.14327863E-05_JPRB, 0.14092082E-05_JPRB, 0.13897985E-05_JPRB, 0.13742986E-05_JPRB, &
  & 0.13613846E-05_JPRB, 0.13492657E-05_JPRB, 0.13355935E-05_JPRB, 0.13212593E-05_JPRB, 0.13098145E-05_JPRB, 0.12960590E-05_JPRB, &
  & 0.12786318E-05_JPRB, 0.12538586E-05_JPRB, 0.12418687E-05_JPRB, 0.12350508E-05_JPRB  /)

RGHG2(:,36, 8) = (/ &
  & 0.15716755E-05_JPRB, 0.15725904E-05_JPRB, 0.15751595E-05_JPRB, 0.15768752E-05_JPRB, 0.15752492E-05_JPRB, 0.15715324E-05_JPRB, &
  & 0.15667020E-05_JPRB, 0.15642925E-05_JPRB, 0.15645232E-05_JPRB, 0.15664540E-05_JPRB, 0.15700634E-05_JPRB, 0.15743271E-05_JPRB, &
  & 0.15785377E-05_JPRB, 0.15833895E-05_JPRB, 0.15878485E-05_JPRB, 0.15925483E-05_JPRB, 0.15991886E-05_JPRB, 0.16095034E-05_JPRB, &
  & 0.16234441E-05_JPRB, 0.16410500E-05_JPRB, 0.16586757E-05_JPRB, 0.16746934E-05_JPRB, 0.16873346E-05_JPRB, 0.16952771E-05_JPRB, &
  & 0.17001048E-05_JPRB, 0.17030791E-05_JPRB, 0.17044588E-05_JPRB, 0.17046645E-05_JPRB, 0.17047157E-05_JPRB, 0.17051000E-05_JPRB, &
  & 0.17059028E-05_JPRB, 0.17063399E-05_JPRB, 0.17057272E-05_JPRB, 0.17049177E-05_JPRB, 0.17042263E-05_JPRB, 0.17036386E-05_JPRB, &
  & 0.17035124E-05_JPRB, 0.17041862E-05_JPRB, 0.17060692E-05_JPRB, 0.17084906E-05_JPRB, 0.17087532E-05_JPRB, 0.17039551E-05_JPRB, &
  & 0.16922542E-05_JPRB, 0.16748446E-05_JPRB, 0.16520713E-05_JPRB, 0.16259998E-05_JPRB, 0.16000236E-05_JPRB, 0.15725722E-05_JPRB, &
  & 0.15430478E-05_JPRB, 0.15148047E-05_JPRB, 0.14874072E-05_JPRB, 0.14625486E-05_JPRB, 0.14427219E-05_JPRB, 0.14273134E-05_JPRB, &
  & 0.14149332E-05_JPRB, 0.14035144E-05_JPRB, 0.13912452E-05_JPRB, 0.13784941E-05_JPRB, 0.13678368E-05_JPRB, 0.13559646E-05_JPRB, &
  & 0.13395434E-05_JPRB, 0.13158290E-05_JPRB, 0.13062929E-05_JPRB, 0.12987382E-05_JPRB  /)

RGHG2(:,37, 8) = (/ &
  & 0.16054114E-05_JPRB, 0.16061974E-05_JPRB, 0.16082382E-05_JPRB, 0.16094127E-05_JPRB, 0.16079155E-05_JPRB, 0.16045079E-05_JPRB, &
  & 0.15996440E-05_JPRB, 0.15963428E-05_JPRB, 0.15957875E-05_JPRB, 0.15974038E-05_JPRB, 0.16001652E-05_JPRB, 0.16029934E-05_JPRB, &
  & 0.16056396E-05_JPRB, 0.16088497E-05_JPRB, 0.16120999E-05_JPRB, 0.16161348E-05_JPRB, 0.16222313E-05_JPRB, 0.16317265E-05_JPRB, &
  & 0.16445847E-05_JPRB, 0.16601004E-05_JPRB, 0.16748704E-05_JPRB, 0.16874965E-05_JPRB, 0.16967717E-05_JPRB, 0.17023147E-05_JPRB, &
  & 0.17053589E-05_JPRB, 0.17070290E-05_JPRB, 0.17076330E-05_JPRB, 0.17075037E-05_JPRB, 0.17072095E-05_JPRB, 0.17071763E-05_JPRB, &
  & 0.17078708E-05_JPRB, 0.17088053E-05_JPRB, 0.17093189E-05_JPRB, 0.17098084E-05_JPRB, 0.17107123E-05_JPRB, 0.17118849E-05_JPRB, &
  & 0.17137974E-05_JPRB, 0.17166051E-05_JPRB, 0.17199341E-05_JPRB, 0.17236261E-05_JPRB, 0.17257366E-05_JPRB, 0.17233921E-05_JPRB, &
  & 0.17147763E-05_JPRB, 0.17014311E-05_JPRB, 0.16826036E-05_JPRB, 0.16601403E-05_JPRB, 0.16366977E-05_JPRB, 0.16113106E-05_JPRB, &
  & 0.15833017E-05_JPRB, 0.15558421E-05_JPRB, 0.15287899E-05_JPRB, 0.15038849E-05_JPRB, 0.14842284E-05_JPRB, 0.14690956E-05_JPRB, &
  & 0.14569680E-05_JPRB, 0.14460569E-05_JPRB, 0.14352285E-05_JPRB, 0.14242119E-05_JPRB, 0.14141396E-05_JPRB, 0.14027571E-05_JPRB, &
  & 0.13868076E-05_JPRB, 0.13656370E-05_JPRB, 0.13559050E-05_JPRB, 0.13473013E-05_JPRB  /)

RGHG2(:,38, 8) = (/ &
  & 0.16428444E-05_JPRB, 0.16434874E-05_JPRB, 0.16449419E-05_JPRB, 0.16455159E-05_JPRB, 0.16441617E-05_JPRB, 0.16410973E-05_JPRB, &
  & 0.16361962E-05_JPRB, 0.16319055E-05_JPRB, 0.16304779E-05_JPRB, 0.16317454E-05_JPRB, 0.16335660E-05_JPRB, 0.16348012E-05_JPRB, &
  & 0.16357116E-05_JPRB, 0.16371000E-05_JPRB, 0.16390090E-05_JPRB, 0.16423061E-05_JPRB, 0.16477991E-05_JPRB, 0.16563850E-05_JPRB, &
  & 0.16680420E-05_JPRB, 0.16812385E-05_JPRB, 0.16928400E-05_JPRB, 0.17017025E-05_JPRB, 0.17072429E-05_JPRB, 0.17101235E-05_JPRB, &
  & 0.17111887E-05_JPRB, 0.17114119E-05_JPRB, 0.17111550E-05_JPRB, 0.17106540E-05_JPRB, 0.17099765E-05_JPRB, 0.17094801E-05_JPRB, &
  & 0.17100545E-05_JPRB, 0.17115410E-05_JPRB, 0.17133042E-05_JPRB, 0.17152350E-05_JPRB, 0.17179091E-05_JPRB, 0.17210350E-05_JPRB, &
  & 0.17252095E-05_JPRB, 0.17303851E-05_JPRB, 0.17353183E-05_JPRB, 0.17404202E-05_JPRB, 0.17445811E-05_JPRB, 0.17449592E-05_JPRB, &
  & 0.17397665E-05_JPRB, 0.17309311E-05_JPRB, 0.17164819E-05_JPRB, 0.16980223E-05_JPRB, 0.16773907E-05_JPRB, 0.16542943E-05_JPRB, &
  & 0.16279669E-05_JPRB, 0.16013767E-05_JPRB, 0.15747078E-05_JPRB, 0.15497513E-05_JPRB, 0.15302835E-05_JPRB, 0.15154567E-05_JPRB, &
  & 0.15036094E-05_JPRB, 0.14932617E-05_JPRB, 0.14840318E-05_JPRB, 0.14749399E-05_JPRB, 0.14655167E-05_JPRB, 0.14546776E-05_JPRB, &
  & 0.14392514E-05_JPRB, 0.14209033E-05_JPRB, 0.14109540E-05_JPRB, 0.14011864E-05_JPRB  /)

RGHG2(:,39, 8) = (/ &
  & 0.16621644E-05_JPRB, 0.16626583E-05_JPRB, 0.16637202E-05_JPRB, 0.16639224E-05_JPRB, 0.16625198E-05_JPRB, 0.16598656E-05_JPRB, &
  & 0.16554351E-05_JPRB, 0.16510234E-05_JPRB, 0.16490346E-05_JPRB, 0.16499816E-05_JPRB, 0.16515781E-05_JPRB, 0.16524786E-05_JPRB, &
  & 0.16529997E-05_JPRB, 0.16538011E-05_JPRB, 0.16551491E-05_JPRB, 0.16578416E-05_JPRB, 0.16625636E-05_JPRB, 0.16700673E-05_JPRB, &
  & 0.16800697E-05_JPRB, 0.16909276E-05_JPRB, 0.16999919E-05_JPRB, 0.17064133E-05_JPRB, 0.17101371E-05_JPRB, 0.17118733E-05_JPRB, &
  & 0.17122460E-05_JPRB, 0.17121152E-05_JPRB, 0.17117365E-05_JPRB, 0.17113011E-05_JPRB, 0.17107639E-05_JPRB, 0.17104165E-05_JPRB, &
  & 0.17111531E-05_JPRB, 0.17128614E-05_JPRB, 0.17149112E-05_JPRB, 0.17171088E-05_JPRB, 0.17199749E-05_JPRB, 0.17234055E-05_JPRB, &
  & 0.17281015E-05_JPRB, 0.17337726E-05_JPRB, 0.17393361E-05_JPRB, 0.17450465E-05_JPRB, 0.17500980E-05_JPRB, 0.17519528E-05_JPRB, &
  & 0.17482752E-05_JPRB, 0.17413080E-05_JPRB, 0.17294863E-05_JPRB, 0.17138943E-05_JPRB, 0.16955978E-05_JPRB, 0.16749537E-05_JPRB, &
  & 0.16511954E-05_JPRB, 0.16266718E-05_JPRB, 0.16016623E-05_JPRB, 0.15779604E-05_JPRB, 0.15597868E-05_JPRB, 0.15456783E-05_JPRB, &
  & 0.15342499E-05_JPRB, 0.15243599E-05_JPRB, 0.15157329E-05_JPRB, 0.15075696E-05_JPRB, 0.14985796E-05_JPRB, 0.14878317E-05_JPRB, &
  & 0.14729302E-05_JPRB, 0.14564908E-05_JPRB, 0.14468008E-05_JPRB, 0.14372466E-05_JPRB  /)

RGHG2(:,40, 8) = (/ &
  & 0.16818746E-05_JPRB, 0.16821925E-05_JPRB, 0.16828254E-05_JPRB, 0.16826288E-05_JPRB, 0.16811382E-05_JPRB, 0.16789763E-05_JPRB, &
  & 0.16751812E-05_JPRB, 0.16707694E-05_JPRB, 0.16681728E-05_JPRB, 0.16687485E-05_JPRB, 0.16701992E-05_JPRB, 0.16709127E-05_JPRB, &
  & 0.16711972E-05_JPRB, 0.16715118E-05_JPRB, 0.16723290E-05_JPRB, 0.16743339E-05_JPRB, 0.16781235E-05_JPRB, 0.16843290E-05_JPRB, &
  & 0.16923153E-05_JPRB, 0.17004255E-05_JPRB, 0.17066156E-05_JPRB, 0.17103883E-05_JPRB, 0.17122940E-05_JPRB, 0.17129356E-05_JPRB, &
  & 0.17127059E-05_JPRB, 0.17123385E-05_JPRB, 0.17119379E-05_JPRB, 0.17116510E-05_JPRB, 0.17113641E-05_JPRB, 0.17112917E-05_JPRB, &
  & 0.17122649E-05_JPRB, 0.17141794E-05_JPRB, 0.17164081E-05_JPRB, 0.17187267E-05_JPRB, 0.17215597E-05_JPRB, 0.17250784E-05_JPRB, &
  & 0.17301017E-05_JPRB, 0.17360478E-05_JPRB, 0.17421916E-05_JPRB, 0.17484852E-05_JPRB, 0.17543920E-05_JPRB, 0.17577761E-05_JPRB, &
  & 0.17555644E-05_JPRB, 0.17503575E-05_JPRB, 0.17413330E-05_JPRB, 0.17289206E-05_JPRB, 0.17132865E-05_JPRB, 0.16955469E-05_JPRB, &
  & 0.16749489E-05_JPRB, 0.16530464E-05_JPRB, 0.16301933E-05_JPRB, 0.16081774E-05_JPRB, 0.15917036E-05_JPRB, 0.15785055E-05_JPRB, &
  & 0.15675914E-05_JPRB, 0.15582212E-05_JPRB, 0.15501388E-05_JPRB, 0.15429024E-05_JPRB, 0.15343855E-05_JPRB, 0.15236706E-05_JPRB, &
  & 0.15093852E-05_JPRB, 0.14950361E-05_JPRB, 0.14857285E-05_JPRB, 0.14766501E-05_JPRB  /)

RGHG2(:,41, 8) = (/ &
  & 0.17059733E-05_JPRB, 0.17060760E-05_JPRB, 0.17061842E-05_JPRB, 0.17055000E-05_JPRB, 0.17039019E-05_JPRB, 0.17023419E-05_JPRB, &
  & 0.16993236E-05_JPRB, 0.16949118E-05_JPRB, 0.16915720E-05_JPRB, 0.16916938E-05_JPRB, 0.16929662E-05_JPRB, 0.16934510E-05_JPRB, &
  & 0.16934464E-05_JPRB, 0.16931657E-05_JPRB, 0.16933339E-05_JPRB, 0.16944981E-05_JPRB, 0.16971477E-05_JPRB, 0.17017659E-05_JPRB, &
  & 0.17072873E-05_JPRB, 0.17120380E-05_JPRB, 0.17147140E-05_JPRB, 0.17152483E-05_JPRB, 0.17149312E-05_JPRB, 0.17142344E-05_JPRB, &
  & 0.17132682E-05_JPRB, 0.17126117E-05_JPRB, 0.17121841E-05_JPRB, 0.17120788E-05_JPRB, 0.17120980E-05_JPRB, 0.17123619E-05_JPRB, &
  & 0.17136242E-05_JPRB, 0.17157910E-05_JPRB, 0.17182382E-05_JPRB, 0.17207048E-05_JPRB, 0.17234974E-05_JPRB, 0.17271237E-05_JPRB, &
  & 0.17325472E-05_JPRB, 0.17388296E-05_JPRB, 0.17456830E-05_JPRB, 0.17526894E-05_JPRB, 0.17596421E-05_JPRB, 0.17648959E-05_JPRB, &
  & 0.17644766E-05_JPRB, 0.17614219E-05_JPRB, 0.17558174E-05_JPRB, 0.17472924E-05_JPRB, 0.17349135E-05_JPRB, 0.17207251E-05_JPRB, &
  & 0.17039909E-05_JPRB, 0.16852932E-05_JPRB, 0.16650765E-05_JPRB, 0.16451221E-05_JPRB, 0.16307265E-05_JPRB, 0.16186415E-05_JPRB, &
  & 0.16083563E-05_JPRB, 0.15996216E-05_JPRB, 0.15922051E-05_JPRB, 0.15861019E-05_JPRB, 0.15781634E-05_JPRB, 0.15674889E-05_JPRB, &
  & 0.15539568E-05_JPRB, 0.15421634E-05_JPRB, 0.15333232E-05_JPRB, 0.15248266E-05_JPRB  /)

RGHG2(:,42, 8) = (/ &
  & 0.17033556E-05_JPRB, 0.17033707E-05_JPRB, 0.17034099E-05_JPRB, 0.17029647E-05_JPRB, 0.17017772E-05_JPRB, 0.17005133E-05_JPRB, &
  & 0.16983122E-05_JPRB, 0.16951256E-05_JPRB, 0.16924870E-05_JPRB, 0.16923320E-05_JPRB, 0.16934449E-05_JPRB, 0.16942084E-05_JPRB, &
  & 0.16947255E-05_JPRB, 0.16950509E-05_JPRB, 0.16956304E-05_JPRB, 0.16967565E-05_JPRB, 0.16989183E-05_JPRB, 0.17025434E-05_JPRB, &
  & 0.17069019E-05_JPRB, 0.17107841E-05_JPRB, 0.17131282E-05_JPRB, 0.17139331E-05_JPRB, 0.17139350E-05_JPRB, 0.17134184E-05_JPRB, &
  & 0.17125631E-05_JPRB, 0.17120192E-05_JPRB, 0.17117953E-05_JPRB, 0.17116916E-05_JPRB, 0.17116992E-05_JPRB, 0.17122063E-05_JPRB, &
  & 0.17137722E-05_JPRB, 0.17159055E-05_JPRB, 0.17181787E-05_JPRB, 0.17201829E-05_JPRB, 0.17224038E-05_JPRB, 0.17256467E-05_JPRB, &
  & 0.17307197E-05_JPRB, 0.17365382E-05_JPRB, 0.17429444E-05_JPRB, 0.17502000E-05_JPRB, 0.17571396E-05_JPRB, 0.17620336E-05_JPRB, &
  & 0.17618127E-05_JPRB, 0.17587395E-05_JPRB, 0.17525934E-05_JPRB, 0.17438625E-05_JPRB, 0.17318359E-05_JPRB, 0.17183455E-05_JPRB, &
  & 0.17033436E-05_JPRB, 0.16873124E-05_JPRB, 0.16697302E-05_JPRB, 0.16521559E-05_JPRB, 0.16395728E-05_JPRB, 0.16293243E-05_JPRB, &
  & 0.16198824E-05_JPRB, 0.16118971E-05_JPRB, 0.16048265E-05_JPRB, 0.15985999E-05_JPRB, 0.15912122E-05_JPRB, 0.15808203E-05_JPRB, &
  & 0.15689182E-05_JPRB, 0.15568833E-05_JPRB, 0.15481863E-05_JPRB, 0.15425876E-05_JPRB  /)

RGHG2(:,43, 8) = (/ &
  & 0.17113332E-05_JPRB, 0.17111758E-05_JPRB, 0.17109265E-05_JPRB, 0.17104895E-05_JPRB, 0.17096304E-05_JPRB, 0.17088957E-05_JPRB, &
  & 0.17077743E-05_JPRB, 0.17057056E-05_JPRB, 0.17033871E-05_JPRB, 0.17027843E-05_JPRB, 0.17036749E-05_JPRB, 0.17045943E-05_JPRB, &
  & 0.17054630E-05_JPRB, 0.17060853E-05_JPRB, 0.17067610E-05_JPRB, 0.17074907E-05_JPRB, 0.17087170E-05_JPRB, 0.17107532E-05_JPRB, &
  & 0.17129904E-05_JPRB, 0.17146352E-05_JPRB, 0.17151648E-05_JPRB, 0.17148236E-05_JPRB, 0.17141605E-05_JPRB, 0.17132325E-05_JPRB, &
  & 0.17121616E-05_JPRB, 0.17115962E-05_JPRB, 0.17115464E-05_JPRB, 0.17115223E-05_JPRB, 0.17116510E-05_JPRB, 0.17125246E-05_JPRB, &
  & 0.17144919E-05_JPRB, 0.17167031E-05_JPRB, 0.17189117E-05_JPRB, 0.17205577E-05_JPRB, 0.17222395E-05_JPRB, 0.17251788E-05_JPRB, &
  & 0.17301043E-05_JPRB, 0.17356441E-05_JPRB, 0.17419474E-05_JPRB, 0.17497372E-05_JPRB, 0.17571146E-05_JPRB, 0.17624846E-05_JPRB, &
  & 0.17632158E-05_JPRB, 0.17610515E-05_JPRB, 0.17558822E-05_JPRB, 0.17486358E-05_JPRB, 0.17383308E-05_JPRB, 0.17270048E-05_JPRB, &
  & 0.17152454E-05_JPRB, 0.17030256E-05_JPRB, 0.16889811E-05_JPRB, 0.16744653E-05_JPRB, 0.16644297E-05_JPRB, 0.16563358E-05_JPRB, &
  & 0.16479338E-05_JPRB, 0.16409055E-05_JPRB, 0.16344369E-05_JPRB, 0.16285852E-05_JPRB, 0.16219488E-05_JPRB, 0.16118323E-05_JPRB, &
  & 0.16017413E-05_JPRB, 0.15905855E-05_JPRB, 0.15822202E-05_JPRB, 0.15795156E-05_JPRB  /)

RGHG2(:,44, 8) = (/ &
  & 0.17107329E-05_JPRB, 0.17106103E-05_JPRB, 0.17104487E-05_JPRB, 0.17101880E-05_JPRB, 0.17096154E-05_JPRB, 0.17091319E-05_JPRB, &
  & 0.17083679E-05_JPRB, 0.17070253E-05_JPRB, 0.17053884E-05_JPRB, 0.17049182E-05_JPRB, 0.17056049E-05_JPRB, 0.17064627E-05_JPRB, &
  & 0.17073495E-05_JPRB, 0.17080731E-05_JPRB, 0.17088554E-05_JPRB, 0.17095862E-05_JPRB, 0.17105963E-05_JPRB, 0.17121644E-05_JPRB, &
  & 0.17138155E-05_JPRB, 0.17149671E-05_JPRB, 0.17151679E-05_JPRB, 0.17146710E-05_JPRB, 0.17139431E-05_JPRB, 0.17129708E-05_JPRB, &
  & 0.17120452E-05_JPRB, 0.17115422E-05_JPRB, 0.17114245E-05_JPRB, 0.17113630E-05_JPRB, 0.17116897E-05_JPRB, 0.17127770E-05_JPRB, &
  & 0.17147083E-05_JPRB, 0.17167809E-05_JPRB, 0.17187681E-05_JPRB, 0.17201909E-05_JPRB, 0.17217068E-05_JPRB, 0.17246227E-05_JPRB, &
  & 0.17294516E-05_JPRB, 0.17349795E-05_JPRB, 0.17411028E-05_JPRB, 0.17490119E-05_JPRB, 0.17564750E-05_JPRB, 0.17618407E-05_JPRB, &
  & 0.17627849E-05_JPRB, 0.17608241E-05_JPRB, 0.17558650E-05_JPRB, 0.17488910E-05_JPRB, 0.17392836E-05_JPRB, 0.17291634E-05_JPRB, &
  & 0.17187472E-05_JPRB, 0.17082033E-05_JPRB, 0.16963193E-05_JPRB, 0.16837715E-05_JPRB, 0.16751920E-05_JPRB, 0.16682920E-05_JPRB, &
  & 0.16610247E-05_JPRB, 0.16547431E-05_JPRB, 0.16488964E-05_JPRB, 0.16432502E-05_JPRB, 0.16373734E-05_JPRB, 0.16284379E-05_JPRB, &
  & 0.16189932E-05_JPRB, 0.16078570E-05_JPRB, 0.15997092E-05_JPRB, 0.15976379E-05_JPRB  /)

RGHG2(:,45, 8) = (/ &
  & 0.17110571E-05_JPRB, 0.17109525E-05_JPRB, 0.17108543E-05_JPRB, 0.17107953E-05_JPRB, 0.17105902E-05_JPRB, 0.17104597E-05_JPRB, &
  & 0.17102390E-05_JPRB, 0.17098641E-05_JPRB, 0.17090437E-05_JPRB, 0.17086678E-05_JPRB, 0.17090943E-05_JPRB, 0.17099017E-05_JPRB, &
  & 0.17108536E-05_JPRB, 0.17117301E-05_JPRB, 0.17126457E-05_JPRB, 0.17133277E-05_JPRB, 0.17139735E-05_JPRB, 0.17148081E-05_JPRB, &
  & 0.17155239E-05_JPRB, 0.17158314E-05_JPRB, 0.17154288E-05_JPRB, 0.17146098E-05_JPRB, 0.17137242E-05_JPRB, 0.17126493E-05_JPRB, &
  & 0.17118620E-05_JPRB, 0.17114274E-05_JPRB, 0.17112544E-05_JPRB, 0.17111603E-05_JPRB, 0.17117277E-05_JPRB, 0.17131045E-05_JPRB, &
  & 0.17150456E-05_JPRB, 0.17169702E-05_JPRB, 0.17186971E-05_JPRB, 0.17198206E-05_JPRB, 0.17210796E-05_JPRB, 0.17239304E-05_JPRB, &
  & 0.17286309E-05_JPRB, 0.17341099E-05_JPRB, 0.17400153E-05_JPRB, 0.17481277E-05_JPRB, 0.17557437E-05_JPRB, 0.17611647E-05_JPRB, &
  & 0.17624716E-05_JPRB, 0.17608572E-05_JPRB, 0.17562608E-05_JPRB, 0.17497846E-05_JPRB, 0.17411888E-05_JPRB, 0.17327146E-05_JPRB, &
  & 0.17242372E-05_JPRB, 0.17160826E-05_JPRB, 0.17071052E-05_JPRB, 0.16971841E-05_JPRB, 0.16905840E-05_JPRB, 0.16853154E-05_JPRB, &
  & 0.16794713E-05_JPRB, 0.16741607E-05_JPRB, 0.16690979E-05_JPRB, 0.16637332E-05_JPRB, 0.16588160E-05_JPRB, 0.16512597E-05_JPRB, &
  & 0.16427795E-05_JPRB, 0.16317767E-05_JPRB, 0.16239184E-05_JPRB, 0.16229336E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART16',0,ZHOOK_HANDLE)



RGHG2(:,46, 8) = (/ &
  & 0.17106359E-05_JPRB, 0.17105612E-05_JPRB, 0.17104990E-05_JPRB, 0.17105026E-05_JPRB, 0.17104289E-05_JPRB, 0.17104187E-05_JPRB, &
  & 0.17103727E-05_JPRB, 0.17102974E-05_JPRB, 0.17099048E-05_JPRB, 0.17097266E-05_JPRB, 0.17101044E-05_JPRB, 0.17108605E-05_JPRB, &
  & 0.17117703E-05_JPRB, 0.17126323E-05_JPRB, 0.17135258E-05_JPRB, 0.17141977E-05_JPRB, 0.17147476E-05_JPRB, 0.17153649E-05_JPRB, &
  & 0.17157959E-05_JPRB, 0.17158468E-05_JPRB, 0.17152595E-05_JPRB, 0.17143722E-05_JPRB, 0.17134712E-05_JPRB, 0.17124378E-05_JPRB, &
  & 0.17117455E-05_JPRB, 0.17112484E-05_JPRB, 0.17110447E-05_JPRB, 0.17110718E-05_JPRB, 0.17117698E-05_JPRB, 0.17132565E-05_JPRB, &
  & 0.17150465E-05_JPRB, 0.17168254E-05_JPRB, 0.17183892E-05_JPRB, 0.17193516E-05_JPRB, 0.17206175E-05_JPRB, 0.17234333E-05_JPRB, &
  & 0.17279768E-05_JPRB, 0.17333573E-05_JPRB, 0.17393686E-05_JPRB, 0.17475646E-05_JPRB, 0.17552688E-05_JPRB, 0.17607134E-05_JPRB, &
  & 0.17622767E-05_JPRB, 0.17608381E-05_JPRB, 0.17564453E-05_JPRB, 0.17504132E-05_JPRB, 0.17426683E-05_JPRB, 0.17355416E-05_JPRB, &
  & 0.17287340E-05_JPRB, 0.17223202E-05_JPRB, 0.17152059E-05_JPRB, 0.17070929E-05_JPRB, 0.17015008E-05_JPRB, 0.16969051E-05_JPRB, &
  & 0.16916389E-05_JPRB, 0.16869614E-05_JPRB, 0.16825643E-05_JPRB, 0.16777884E-05_JPRB, 0.16735293E-05_JPRB, 0.16669220E-05_JPRB, &
  & 0.16588750E-05_JPRB, 0.16487487E-05_JPRB, 0.16412953E-05_JPRB, 0.16400706E-05_JPRB  /)

RGHG2(:,47, 8) = (/ &
  & 0.17099923E-05_JPRB, 0.17099550E-05_JPRB, 0.17099295E-05_JPRB, 0.17099788E-05_JPRB, 0.17100119E-05_JPRB, 0.17100963E-05_JPRB, &
  & 0.17101816E-05_JPRB, 0.17103240E-05_JPRB, 0.17103553E-05_JPRB, 0.17104299E-05_JPRB, 0.17107931E-05_JPRB, 0.17114889E-05_JPRB, &
  & 0.17123277E-05_JPRB, 0.17131391E-05_JPRB, 0.17139755E-05_JPRB, 0.17146434E-05_JPRB, 0.17151346E-05_JPRB, 0.17156002E-05_JPRB, &
  & 0.17158274E-05_JPRB, 0.17156948E-05_JPRB, 0.17149746E-05_JPRB, 0.17140580E-05_JPRB, 0.17131676E-05_JPRB, 0.17122117E-05_JPRB, &
  & 0.17116221E-05_JPRB, 0.17110255E-05_JPRB, 0.17107908E-05_JPRB, 0.17109908E-05_JPRB, 0.17118201E-05_JPRB, 0.17133997E-05_JPRB, &
  & 0.17149801E-05_JPRB, 0.17165887E-05_JPRB, 0.17179804E-05_JPRB, 0.17187813E-05_JPRB, 0.17201085E-05_JPRB, 0.17228892E-05_JPRB, &
  & 0.17272427E-05_JPRB, 0.17324976E-05_JPRB, 0.17386981E-05_JPRB, 0.17469683E-05_JPRB, 0.17547630E-05_JPRB, 0.17602288E-05_JPRB, &
  & 0.17620717E-05_JPRB, 0.17608051E-05_JPRB, 0.17566195E-05_JPRB, 0.17510978E-05_JPRB, 0.17443191E-05_JPRB, 0.17387138E-05_JPRB, &
  & 0.17338117E-05_JPRB, 0.17293107E-05_JPRB, 0.17241736E-05_JPRB, 0.17180183E-05_JPRB, 0.17134144E-05_JPRB, 0.17094163E-05_JPRB, &
  & 0.17046589E-05_JPRB, 0.17006565E-05_JPRB, 0.16970169E-05_JPRB, 0.16929935E-05_JPRB, 0.16894462E-05_JPRB, 0.16838662E-05_JPRB, &
  & 0.16762212E-05_JPRB, 0.16672723E-05_JPRB, 0.16603170E-05_JPRB, 0.16585453E-05_JPRB  /)

RGHG2(:,48, 8) = (/ &
  & 0.17094040E-05_JPRB, 0.17093573E-05_JPRB, 0.17093200E-05_JPRB, 0.17093761E-05_JPRB, 0.17094628E-05_JPRB, 0.17095785E-05_JPRB, &
  & 0.17097089E-05_JPRB, 0.17099201E-05_JPRB, 0.17101107E-05_JPRB, 0.17103312E-05_JPRB, 0.17107066E-05_JPRB, 0.17113425E-05_JPRB, &
  & 0.17121136E-05_JPRB, 0.17128600E-05_JPRB, 0.17136160E-05_JPRB, 0.17142377E-05_JPRB, 0.17147032E-05_JPRB, 0.17151172E-05_JPRB, &
  & 0.17153151E-05_JPRB, 0.17151676E-05_JPRB, 0.17144778E-05_JPRB, 0.17136282E-05_JPRB, 0.17128149E-05_JPRB, 0.17119597E-05_JPRB, &
  & 0.17114327E-05_JPRB, 0.17108569E-05_JPRB, 0.17106481E-05_JPRB, 0.17109771E-05_JPRB, 0.17118757E-05_JPRB, 0.17134604E-05_JPRB, &
  & 0.17148550E-05_JPRB, 0.17162854E-05_JPRB, 0.17175086E-05_JPRB, 0.17182069E-05_JPRB, 0.17196182E-05_JPRB, 0.17224177E-05_JPRB, &
  & 0.17266178E-05_JPRB, 0.17317821E-05_JPRB, 0.17381834E-05_JPRB, 0.17465973E-05_JPRB, 0.17544548E-05_JPRB, 0.17599610E-05_JPRB, &
  & 0.17620172E-05_JPRB, 0.17609662E-05_JPRB, 0.17569635E-05_JPRB, 0.17518014E-05_JPRB, 0.17459377E-05_JPRB, 0.17418011E-05_JPRB, &
  & 0.17388378E-05_JPRB, 0.17361477E-05_JPRB, 0.17327009E-05_JPRB, 0.17279592E-05_JPRB, 0.17239729E-05_JPRB, 0.17203255E-05_JPRB, &
  & 0.17158068E-05_JPRB, 0.17121213E-05_JPRB, 0.17087884E-05_JPRB, 0.17055091E-05_JPRB, 0.17024636E-05_JPRB, 0.16975255E-05_JPRB, &
  & 0.16906307E-05_JPRB, 0.16827798E-05_JPRB, 0.16763494E-05_JPRB, 0.16735179E-05_JPRB  /)

RGHG2(:,49, 8) = (/ &
  & 0.17087776E-05_JPRB, 0.17086991E-05_JPRB, 0.17086267E-05_JPRB, 0.17086728E-05_JPRB, 0.17087946E-05_JPRB, 0.17089162E-05_JPRB, &
  & 0.17090575E-05_JPRB, 0.17092770E-05_JPRB, 0.17095237E-05_JPRB, 0.17098571E-05_JPRB, 0.17102585E-05_JPRB, 0.17108283E-05_JPRB, &
  & 0.17115257E-05_JPRB, 0.17121934E-05_JPRB, 0.17128499E-05_JPRB, 0.17134013E-05_JPRB, 0.17138535E-05_JPRB, 0.17142557E-05_JPRB, &
  & 0.17145004E-05_JPRB, 0.17144133E-05_JPRB, 0.17138314E-05_JPRB, 0.17130998E-05_JPRB, 0.17124019E-05_JPRB, 0.17116689E-05_JPRB, &
  & 0.17111929E-05_JPRB, 0.17106950E-05_JPRB, 0.17105406E-05_JPRB, 0.17109926E-05_JPRB, 0.17119397E-05_JPRB, 0.17134901E-05_JPRB, &
  & 0.17146898E-05_JPRB, 0.17159193E-05_JPRB, 0.17169576E-05_JPRB, 0.17175688E-05_JPRB, 0.17190839E-05_JPRB, 0.17219286E-05_JPRB, &
  & 0.17259756E-05_JPRB, 0.17310554E-05_JPRB, 0.17376842E-05_JPRB, 0.17462890E-05_JPRB, 0.17542033E-05_JPRB, 0.17597631E-05_JPRB, &
  & 0.17620251E-05_JPRB, 0.17612327E-05_JPRB, 0.17574217E-05_JPRB, 0.17525893E-05_JPRB, 0.17477155E-05_JPRB, 0.17451814E-05_JPRB, &
  & 0.17443804E-05_JPRB, 0.17436492E-05_JPRB, 0.17419438E-05_JPRB, 0.17385200E-05_JPRB, 0.17350492E-05_JPRB, 0.17316780E-05_JPRB, &
  & 0.17273007E-05_JPRB, 0.17238035E-05_JPRB, 0.17206054E-05_JPRB, 0.17181461E-05_JPRB, 0.17155609E-05_JPRB, 0.17111583E-05_JPRB, &
  & 0.17052526E-05_JPRB, 0.16985816E-05_JPRB, 0.16927445E-05_JPRB, 0.16885063E-05_JPRB  /)

RGHG2(:,50, 8) = (/ &
  & 0.17081720E-05_JPRB, 0.17080451E-05_JPRB, 0.17079285E-05_JPRB, 0.17079762E-05_JPRB, 0.17081247E-05_JPRB, 0.17082466E-05_JPRB, &
  & 0.17083909E-05_JPRB, 0.17085914E-05_JPRB, 0.17088357E-05_JPRB, 0.17092012E-05_JPRB, 0.17096030E-05_JPRB, 0.17100946E-05_JPRB, &
  & 0.17106928E-05_JPRB, 0.17112636E-05_JPRB, 0.17118043E-05_JPRB, 0.17122517E-05_JPRB, 0.17126489E-05_JPRB, 0.17130456E-05_JPRB, &
  & 0.17133552E-05_JPRB, 0.17133834E-05_JPRB, 0.17130087E-05_JPRB, 0.17124680E-05_JPRB, 0.17119547E-05_JPRB, 0.17113503E-05_JPRB, &
  & 0.17109514E-05_JPRB, 0.17106073E-05_JPRB, 0.17104821E-05_JPRB, 0.17110134E-05_JPRB, 0.17119563E-05_JPRB, 0.17134031E-05_JPRB, &
  & 0.17145134E-05_JPRB, 0.17155859E-05_JPRB, 0.17164288E-05_JPRB, 0.17169904E-05_JPRB, 0.17185813E-05_JPRB, 0.17214891E-05_JPRB, &
  & 0.17254534E-05_JPRB, 0.17304169E-05_JPRB, 0.17372230E-05_JPRB, 0.17460348E-05_JPRB, 0.17539699E-05_JPRB, 0.17595989E-05_JPRB, &
  & 0.17619908E-05_JPRB, 0.17613993E-05_JPRB, 0.17577521E-05_JPRB, 0.17531189E-05_JPRB, 0.17491736E-05_JPRB, 0.17481371E-05_JPRB, &
  & 0.17489602E-05_JPRB, 0.17497001E-05_JPRB, 0.17493061E-05_JPRB, 0.17469616E-05_JPRB, 0.17441646E-05_JPRB, 0.17412150E-05_JPRB, &
  & 0.17372928E-05_JPRB, 0.17340927E-05_JPRB, 0.17312296E-05_JPRB, 0.17293730E-05_JPRB, 0.17272026E-05_JPRB, 0.17235060E-05_JPRB, &
  & 0.17183382E-05_JPRB, 0.17125588E-05_JPRB, 0.17071680E-05_JPRB, 0.17020239E-05_JPRB  /)

RGHG2(:,51, 8) = (/ &
  & 0.17075278E-05_JPRB, 0.17073397E-05_JPRB, 0.17071706E-05_JPRB, 0.17072262E-05_JPRB, 0.17073993E-05_JPRB, 0.17075185E-05_JPRB, &
  & 0.17076619E-05_JPRB, 0.17078274E-05_JPRB, 0.17080386E-05_JPRB, 0.17083962E-05_JPRB, 0.17087848E-05_JPRB, 0.17091855E-05_JPRB, &
  & 0.17096632E-05_JPRB, 0.17101194E-05_JPRB, 0.17105264E-05_JPRB, 0.17108435E-05_JPRB, 0.17111594E-05_JPRB, 0.17115535E-05_JPRB, &
  & 0.17119427E-05_JPRB, 0.17121247E-05_JPRB, 0.17120263E-05_JPRB, 0.17117303E-05_JPRB, 0.17114530E-05_JPRB, 0.17109911E-05_JPRB, &
  & 0.17106892E-05_JPRB, 0.17105514E-05_JPRB, 0.17104445E-05_JPRB, 0.17110388E-05_JPRB, 0.17119494E-05_JPRB, 0.17132475E-05_JPRB, &
  & 0.17143167E-05_JPRB, 0.17152424E-05_JPRB, 0.17158685E-05_JPRB, 0.17163960E-05_JPRB, 0.17180542E-05_JPRB, 0.17210399E-05_JPRB, &
  & 0.17249517E-05_JPRB, 0.17297727E-05_JPRB, 0.17367440E-05_JPRB, 0.17457884E-05_JPRB, 0.17537270E-05_JPRB, 0.17594390E-05_JPRB, &
  & 0.17619314E-05_JPRB, 0.17615270E-05_JPRB, 0.17580424E-05_JPRB, 0.17535560E-05_JPRB, 0.17505828E-05_JPRB, 0.17511110E-05_JPRB, &
  & 0.17534079E-05_JPRB, 0.17554826E-05_JPRB, 0.17562808E-05_JPRB, 0.17549783E-05_JPRB, 0.17529934E-05_JPRB, 0.17505761E-05_JPRB, &
  & 0.17473113E-05_JPRB, 0.17444897E-05_JPRB, 0.17420942E-05_JPRB, 0.17407752E-05_JPRB, 0.17390296E-05_JPRB, 0.17361862E-05_JPRB, &
  & 0.17316845E-05_JPRB, 0.17267181E-05_JPRB, 0.17217329E-05_JPRB, 0.17158719E-05_JPRB  /)

RGHG2(:,52, 8) = (/ &
  & 0.17069323E-05_JPRB, 0.17067226E-05_JPRB, 0.17065398E-05_JPRB, 0.17066156E-05_JPRB, 0.17068019E-05_JPRB, 0.17069236E-05_JPRB, &
  & 0.17070668E-05_JPRB, 0.17072044E-05_JPRB, 0.17073643E-05_JPRB, 0.17076805E-05_JPRB, 0.17080382E-05_JPRB, 0.17083644E-05_JPRB, &
  & 0.17087336E-05_JPRB, 0.17090748E-05_JPRB, 0.17093711E-05_JPRB, 0.17095816E-05_JPRB, 0.17097975E-05_JPRB, 0.17101458E-05_JPRB, &
  & 0.17105413E-05_JPRB, 0.17108368E-05_JPRB, 0.17109901E-05_JPRB, 0.17109144E-05_JPRB, 0.17108428E-05_JPRB, 0.17105776E-05_JPRB, &
  & 0.17103768E-05_JPRB, 0.17104093E-05_JPRB, 0.17103804E-05_JPRB, 0.17109699E-05_JPRB, 0.17117969E-05_JPRB, 0.17129580E-05_JPRB, &
  & 0.17140402E-05_JPRB, 0.17149182E-05_JPRB, 0.17153970E-05_JPRB, 0.17159287E-05_JPRB, 0.17175550E-05_JPRB, 0.17205948E-05_JPRB, &
  & 0.17245568E-05_JPRB, 0.17292386E-05_JPRB, 0.17363049E-05_JPRB, 0.17454356E-05_JPRB, 0.17533620E-05_JPRB, 0.17591840E-05_JPRB, &
  & 0.17617014E-05_JPRB, 0.17613345E-05_JPRB, 0.17580570E-05_JPRB, 0.17537204E-05_JPRB, 0.17515992E-05_JPRB, 0.17532538E-05_JPRB, &
  & 0.17563060E-05_JPRB, 0.17591510E-05_JPRB, 0.17606962E-05_JPRB, 0.17602991E-05_JPRB, 0.17590963E-05_JPRB, 0.17573462E-05_JPRB, &
  & 0.17548502E-05_JPRB, 0.17526869E-05_JPRB, 0.17509036E-05_JPRB, 0.17499934E-05_JPRB, 0.17485403E-05_JPRB, 0.17465442E-05_JPRB, &
  & 0.17426101E-05_JPRB, 0.17384812E-05_JPRB, 0.17340600E-05_JPRB, 0.17282623E-05_JPRB  /)

RGHG2(:,53, 8) = (/ &
  & 0.17063026E-05_JPRB, 0.17060845E-05_JPRB, 0.17059018E-05_JPRB, 0.17060043E-05_JPRB, 0.17062008E-05_JPRB, 0.17063270E-05_JPRB, &
  & 0.17064703E-05_JPRB, 0.17065802E-05_JPRB, 0.17066774E-05_JPRB, 0.17069354E-05_JPRB, 0.17072525E-05_JPRB, 0.17075041E-05_JPRB, &
  & 0.17077598E-05_JPRB, 0.17079755E-05_JPRB, 0.17081602E-05_JPRB, 0.17082638E-05_JPRB, 0.17083634E-05_JPRB, 0.17086453E-05_JPRB, &
  & 0.17090196E-05_JPRB, 0.17094230E-05_JPRB, 0.17098410E-05_JPRB, 0.17099960E-05_JPRB, 0.17101364E-05_JPRB, 0.17101065E-05_JPRB, &
  & 0.17100173E-05_JPRB, 0.17102213E-05_JPRB, 0.17103004E-05_JPRB, 0.17108585E-05_JPRB, 0.17115748E-05_JPRB, 0.17125911E-05_JPRB, &
  & 0.17137084E-05_JPRB, 0.17145725E-05_JPRB, 0.17149176E-05_JPRB, 0.17154686E-05_JPRB, 0.17170221E-05_JPRB, 0.17201117E-05_JPRB, &
  & 0.17241678E-05_JPRB, 0.17286992E-05_JPRB, 0.17358421E-05_JPRB, 0.17450106E-05_JPRB, 0.17529177E-05_JPRB, 0.17588697E-05_JPRB, &
  & 0.17613852E-05_JPRB, 0.17610018E-05_JPRB, 0.17579668E-05_JPRB, 0.17537944E-05_JPRB, 0.17525551E-05_JPRB, 0.17552676E-05_JPRB, &
  & 0.17588658E-05_JPRB, 0.17623326E-05_JPRB, 0.17645197E-05_JPRB, 0.17650560E-05_JPRB, 0.17646936E-05_JPRB, 0.17637220E-05_JPRB, &
  & 0.17621059E-05_JPRB, 0.17607673E-05_JPRB, 0.17597062E-05_JPRB, 0.17591917E-05_JPRB, 0.17580061E-05_JPRB, 0.17569305E-05_JPRB, &
  & 0.17535766E-05_JPRB, 0.17503691E-05_JPRB, 0.17466232E-05_JPRB, 0.17411944E-05_JPRB  /)

RGHG2(:,54, 8) = (/ &
  & 0.17058506E-05_JPRB, 0.17056593E-05_JPRB, 0.17055058E-05_JPRB, 0.17056222E-05_JPRB, 0.17058016E-05_JPRB, 0.17059283E-05_JPRB, &
  & 0.17060700E-05_JPRB, 0.17061557E-05_JPRB, 0.17062115E-05_JPRB, 0.17064167E-05_JPRB, 0.17066853E-05_JPRB, 0.17068847E-05_JPRB, &
  & 0.17070707E-05_JPRB, 0.17072218E-05_JPRB, 0.17073402E-05_JPRB, 0.17073771E-05_JPRB, 0.17074051E-05_JPRB, 0.17076018E-05_JPRB, &
  & 0.17079099E-05_JPRB, 0.17083145E-05_JPRB, 0.17088112E-05_JPRB, 0.17090767E-05_JPRB, 0.17093612E-05_JPRB, 0.17095537E-05_JPRB, &
  & 0.17095703E-05_JPRB, 0.17098352E-05_JPRB, 0.17101192E-05_JPRB, 0.17106140E-05_JPRB, 0.17112554E-05_JPRB, 0.17121512E-05_JPRB, &
  & 0.17132209E-05_JPRB, 0.17141759E-05_JPRB, 0.17145274E-05_JPRB, 0.17150513E-05_JPRB, 0.17165457E-05_JPRB, 0.17197100E-05_JPRB, &
  & 0.17239103E-05_JPRB, 0.17283437E-05_JPRB, 0.17354592E-05_JPRB, 0.17444896E-05_JPRB, 0.17522659E-05_JPRB, 0.17582293E-05_JPRB, &
  & 0.17606530E-05_JPRB, 0.17602181E-05_JPRB, 0.17574355E-05_JPRB, 0.17535695E-05_JPRB, 0.17531306E-05_JPRB, 0.17564300E-05_JPRB, &
  & 0.17601857E-05_JPRB, 0.17640248E-05_JPRB, 0.17666513E-05_JPRB, 0.17677431E-05_JPRB, 0.17680440E-05_JPRB, 0.17675080E-05_JPRB, &
  & 0.17664702E-05_JPRB, 0.17656898E-05_JPRB, 0.17652179E-05_JPRB, 0.17650147E-05_JPRB, 0.17640319E-05_JPRB, 0.17633605E-05_JPRB, &
  & 0.17607907E-05_JPRB, 0.17584479E-05_JPRB, 0.17554401E-05_JPRB, 0.17505772E-05_JPRB  /)

RGHG2(:,55, 8) = (/ &
  & 0.17053733E-05_JPRB, 0.17052163E-05_JPRB, 0.17050990E-05_JPRB, 0.17052291E-05_JPRB, 0.17053860E-05_JPRB, 0.17055127E-05_JPRB, &
  & 0.17056524E-05_JPRB, 0.17057116E-05_JPRB, 0.17057244E-05_JPRB, 0.17058719E-05_JPRB, 0.17060857E-05_JPRB, 0.17062303E-05_JPRB, &
  & 0.17063448E-05_JPRB, 0.17064323E-05_JPRB, 0.17064832E-05_JPRB, 0.17064516E-05_JPRB, 0.17064062E-05_JPRB, 0.17065060E-05_JPRB, &
  & 0.17067348E-05_JPRB, 0.17071267E-05_JPRB, 0.17076860E-05_JPRB, 0.17080582E-05_JPRB, 0.17084935E-05_JPRB, 0.17089306E-05_JPRB, &
  & 0.17090637E-05_JPRB, 0.17093814E-05_JPRB, 0.17099052E-05_JPRB, 0.17103256E-05_JPRB, 0.17108887E-05_JPRB, 0.17116544E-05_JPRB, &
  & 0.17126605E-05_JPRB, 0.17137300E-05_JPRB, 0.17141068E-05_JPRB, 0.17145945E-05_JPRB, 0.17160253E-05_JPRB, 0.17192758E-05_JPRB, &
  & 0.17236425E-05_JPRB, 0.17279741E-05_JPRB, 0.17350455E-05_JPRB, 0.17438998E-05_JPRB, 0.17515165E-05_JPRB, 0.17574770E-05_JPRB, &
  & 0.17597872E-05_JPRB, 0.17592906E-05_JPRB, 0.17567889E-05_JPRB, 0.17532811E-05_JPRB, 0.17537181E-05_JPRB, 0.17576057E-05_JPRB, &
  & 0.17614847E-05_JPRB, 0.17657036E-05_JPRB, 0.17687900E-05_JPRB, 0.17704475E-05_JPRB, 0.17714599E-05_JPRB, 0.17713614E-05_JPRB, &
  & 0.17709245E-05_JPRB, 0.17707273E-05_JPRB, 0.17708906E-05_JPRB, 0.17710211E-05_JPRB, 0.17702547E-05_JPRB, 0.17699630E-05_JPRB, &
  & 0.17682887E-05_JPRB, 0.17668961E-05_JPRB, 0.17647143E-05_JPRB, 0.17605042E-05_JPRB  /)

RGHG2(:,56, 8) = (/ &
  & 0.17051421E-05_JPRB, 0.17050153E-05_JPRB, 0.17049373E-05_JPRB, 0.17050699E-05_JPRB, 0.17051878E-05_JPRB, 0.17052947E-05_JPRB, &
  & 0.17054305E-05_JPRB, 0.17054753E-05_JPRB, 0.17054714E-05_JPRB, 0.17055886E-05_JPRB, 0.17057590E-05_JPRB, 0.17058718E-05_JPRB, &
  & 0.17059535E-05_JPRB, 0.17060155E-05_JPRB, 0.17060445E-05_JPRB, 0.17059880E-05_JPRB, 0.17059079E-05_JPRB, 0.17059488E-05_JPRB, &
  & 0.17060935E-05_JPRB, 0.17064054E-05_JPRB, 0.17069015E-05_JPRB, 0.17072593E-05_JPRB, 0.17077239E-05_JPRB, 0.17082882E-05_JPRB, &
  & 0.17084799E-05_JPRB, 0.17088265E-05_JPRB, 0.17093591E-05_JPRB, 0.17098524E-05_JPRB, 0.17102843E-05_JPRB, 0.17109764E-05_JPRB, &
  & 0.17120468E-05_JPRB, 0.17132723E-05_JPRB, 0.17137578E-05_JPRB, 0.17142500E-05_JPRB, 0.17156282E-05_JPRB, 0.17189316E-05_JPRB, &
  & 0.17234249E-05_JPRB, 0.17276709E-05_JPRB, 0.17347970E-05_JPRB, 0.17432835E-05_JPRB, 0.17504312E-05_JPRB, 0.17559626E-05_JPRB, &
  & 0.17583341E-05_JPRB, 0.17580363E-05_JPRB, 0.17557002E-05_JPRB, 0.17528174E-05_JPRB, 0.17540237E-05_JPRB, 0.17581409E-05_JPRB, &
  & 0.17621424E-05_JPRB, 0.17665896E-05_JPRB, 0.17699038E-05_JPRB, 0.17717823E-05_JPRB, 0.17730579E-05_JPRB, 0.17731190E-05_JPRB, &
  & 0.17730406E-05_JPRB, 0.17731551E-05_JPRB, 0.17735556E-05_JPRB, 0.17738420E-05_JPRB, 0.17733703E-05_JPRB, 0.17731576E-05_JPRB, &
  & 0.17719190E-05_JPRB, 0.17712384E-05_JPRB, 0.17698384E-05_JPRB, 0.17664265E-05_JPRB  /)

RGHG2(:,57, 8) = (/ &
  & 0.17049162E-05_JPRB, 0.17048166E-05_JPRB, 0.17047764E-05_JPRB, 0.17049137E-05_JPRB, 0.17049951E-05_JPRB, 0.17050816E-05_JPRB, &
  & 0.17052107E-05_JPRB, 0.17052413E-05_JPRB, 0.17052218E-05_JPRB, 0.17053098E-05_JPRB, 0.17054374E-05_JPRB, 0.17055194E-05_JPRB, &
  & 0.17055696E-05_JPRB, 0.17056058E-05_JPRB, 0.17056165E-05_JPRB, 0.17055404E-05_JPRB, 0.17054238E-05_JPRB, 0.17054074E-05_JPRB, &
  & 0.17054691E-05_JPRB, 0.17056972E-05_JPRB, 0.17061158E-05_JPRB, 0.17064660E-05_JPRB, 0.17069462E-05_JPRB, 0.17076049E-05_JPRB, &
  & 0.17078374E-05_JPRB, 0.17081979E-05_JPRB, 0.17087667E-05_JPRB, 0.17093388E-05_JPRB, 0.17096906E-05_JPRB, 0.17102847E-05_JPRB, &
  & 0.17114180E-05_JPRB, 0.17127555E-05_JPRB, 0.17133194E-05_JPRB, 0.17138739E-05_JPRB, 0.17152717E-05_JPRB, 0.17185873E-05_JPRB, &
  & 0.17231630E-05_JPRB, 0.17273997E-05_JPRB, 0.17345680E-05_JPRB, 0.17425884E-05_JPRB, 0.17490722E-05_JPRB, 0.17542116E-05_JPRB, &
  & 0.17567931E-05_JPRB, 0.17566588E-05_JPRB, 0.17545436E-05_JPRB, 0.17523567E-05_JPRB, 0.17543460E-05_JPRB, 0.17587260E-05_JPRB, &
  & 0.17628661E-05_JPRB, 0.17675208E-05_JPRB, 0.17710374E-05_JPRB, 0.17731276E-05_JPRB, 0.17746604E-05_JPRB, 0.17748837E-05_JPRB, &
  & 0.17751511E-05_JPRB, 0.17755547E-05_JPRB, 0.17762200E-05_JPRB, 0.17766488E-05_JPRB, 0.17764590E-05_JPRB, 0.17763058E-05_JPRB, &
  & 0.17754551E-05_JPRB, 0.17754528E-05_JPRB, 0.17748216E-05_JPRB, 0.17721735E-05_JPRB  /)

RGHG2(:,58, 8) = (/ &
  & 0.17047635E-05_JPRB, 0.17046832E-05_JPRB, 0.17046755E-05_JPRB, 0.17048189E-05_JPRB, 0.17048678E-05_JPRB, 0.17049310E-05_JPRB, &
  & 0.17050488E-05_JPRB, 0.17050694E-05_JPRB, 0.17050416E-05_JPRB, 0.17051104E-05_JPRB, 0.17052014E-05_JPRB, 0.17052610E-05_JPRB, &
  & 0.17052919E-05_JPRB, 0.17053109E-05_JPRB, 0.17053196E-05_JPRB, 0.17052424E-05_JPRB, 0.17050963E-05_JPRB, 0.17050373E-05_JPRB, &
  & 0.17050239E-05_JPRB, 0.17051554E-05_JPRB, 0.17054552E-05_JPRB, 0.17057871E-05_JPRB, 0.17062358E-05_JPRB, 0.17069036E-05_JPRB, &
  & 0.17071331E-05_JPRB, 0.17074764E-05_JPRB, 0.17080817E-05_JPRB, 0.17087635E-05_JPRB, 0.17091184E-05_JPRB, 0.17095915E-05_JPRB, &
  & 0.17108041E-05_JPRB, 0.17121782E-05_JPRB, 0.17127786E-05_JPRB, 0.17134957E-05_JPRB, 0.17150357E-05_JPRB, 0.17182873E-05_JPRB, &
  & 0.17228569E-05_JPRB, 0.17272165E-05_JPRB, 0.17344214E-05_JPRB, 0.17418109E-05_JPRB, 0.17472972E-05_JPRB, 0.17520587E-05_JPRB, &
  & 0.17551176E-05_JPRB, 0.17551225E-05_JPRB, 0.17532826E-05_JPRB, 0.17519054E-05_JPRB, 0.17546180E-05_JPRB, 0.17592286E-05_JPRB, &
  & 0.17635231E-05_JPRB, 0.17683048E-05_JPRB, 0.17719209E-05_JPRB, 0.17741259E-05_JPRB, 0.17758009E-05_JPRB, 0.17761258E-05_JPRB, &
  & 0.17766441E-05_JPRB, 0.17772244E-05_JPRB, 0.17781051E-05_JPRB, 0.17786091E-05_JPRB, 0.17786712E-05_JPRB, 0.17784835E-05_JPRB, &
  & 0.17778228E-05_JPRB, 0.17783426E-05_JPRB, 0.17783879E-05_JPRB, 0.17764113E-05_JPRB  /)

RGHG2(:,59, 8) = (/ &
  & 0.17046518E-05_JPRB, 0.17045863E-05_JPRB, 0.17046045E-05_JPRB, 0.17047509E-05_JPRB, 0.17047802E-05_JPRB, 0.17048276E-05_JPRB, &
  & 0.17049286E-05_JPRB, 0.17049428E-05_JPRB, 0.17049116E-05_JPRB, 0.17049655E-05_JPRB, 0.17050313E-05_JPRB, 0.17050738E-05_JPRB, &
  & 0.17050930E-05_JPRB, 0.17051008E-05_JPRB, 0.17051184E-05_JPRB, 0.17050498E-05_JPRB, 0.17048959E-05_JPRB, 0.17047960E-05_JPRB, &
  & 0.17047371E-05_JPRB, 0.17047811E-05_JPRB, 0.17049668E-05_JPRB, 0.17052289E-05_JPRB, 0.17055999E-05_JPRB, 0.17062517E-05_JPRB, &
  & 0.17065066E-05_JPRB, 0.17067803E-05_JPRB, 0.17073257E-05_JPRB, 0.17080667E-05_JPRB, 0.17084609E-05_JPRB, 0.17088943E-05_JPRB, &
  & 0.17101785E-05_JPRB, 0.17115857E-05_JPRB, 0.17121617E-05_JPRB, 0.17129449E-05_JPRB, 0.17148372E-05_JPRB, 0.17180894E-05_JPRB, &
  & 0.17225401E-05_JPRB, 0.17272166E-05_JPRB, 0.17341786E-05_JPRB, 0.17406505E-05_JPRB, 0.17452843E-05_JPRB, 0.17499160E-05_JPRB, &
  & 0.17535645E-05_JPRB, 0.17535235E-05_JPRB, 0.17520351E-05_JPRB, 0.17515635E-05_JPRB, 0.17548979E-05_JPRB, 0.17597052E-05_JPRB, &
  & 0.17642176E-05_JPRB, 0.17690255E-05_JPRB, 0.17726581E-05_JPRB, 0.17749739E-05_JPRB, 0.17766984E-05_JPRB, 0.17770742E-05_JPRB, &
  & 0.17777648E-05_JPRB, 0.17784707E-05_JPRB, 0.17795152E-05_JPRB, 0.17801253E-05_JPRB, 0.17802724E-05_JPRB, 0.17799117E-05_JPRB, &
  & 0.17793717E-05_JPRB, 0.17802527E-05_JPRB, 0.17806982E-05_JPRB, 0.17790425E-05_JPRB  /)

RGHG2(:,60, 8) = (/ &
  & 0.17045591E-05_JPRB, 0.17045062E-05_JPRB, 0.17045471E-05_JPRB, 0.17046937E-05_JPRB, 0.17047089E-05_JPRB, 0.17047433E-05_JPRB, &
  & 0.17048246E-05_JPRB, 0.17048334E-05_JPRB, 0.17048009E-05_JPRB, 0.17048417E-05_JPRB, 0.17048872E-05_JPRB, 0.17049153E-05_JPRB, &
  & 0.17049252E-05_JPRB, 0.17049235E-05_JPRB, 0.17049530E-05_JPRB, 0.17048982E-05_JPRB, 0.17047477E-05_JPRB, 0.17046070E-05_JPRB, &
  & 0.17045134E-05_JPRB, 0.17044741E-05_JPRB, 0.17045480E-05_JPRB, 0.17047134E-05_JPRB, 0.17049772E-05_JPRB, 0.17055908E-05_JPRB, &
  & 0.17058802E-05_JPRB, 0.17060773E-05_JPRB, 0.17065247E-05_JPRB, 0.17072787E-05_JPRB, 0.17077120E-05_JPRB, 0.17081457E-05_JPRB, &
  & 0.17094773E-05_JPRB, 0.17109116E-05_JPRB, 0.17114848E-05_JPRB, 0.17123347E-05_JPRB, 0.17146167E-05_JPRB, 0.17179090E-05_JPRB, &
  & 0.17222344E-05_JPRB, 0.17272555E-05_JPRB, 0.17337595E-05_JPRB, 0.17392172E-05_JPRB, 0.17431114E-05_JPRB, 0.17477313E-05_JPRB, &
  & 0.17519986E-05_JPRB, 0.17518741E-05_JPRB, 0.17507657E-05_JPRB, 0.17512659E-05_JPRB, 0.17551834E-05_JPRB, 0.17601739E-05_JPRB, &
  & 0.17649520E-05_JPRB, 0.17697509E-05_JPRB, 0.17733780E-05_JPRB, 0.17758060E-05_JPRB, 0.17775324E-05_JPRB, 0.17779501E-05_JPRB, &
  & 0.17787759E-05_JPRB, 0.17795957E-05_JPRB, 0.17807726E-05_JPRB, 0.17815061E-05_JPRB, 0.17816433E-05_JPRB, 0.17810678E-05_JPRB, &
  & 0.17806428E-05_JPRB, 0.17818066E-05_JPRB, 0.17824842E-05_JPRB, 0.17810192E-05_JPRB  /)

RGHG2(:,61, 8) = (/ &
  & 0.17045072E-05_JPRB, 0.17044608E-05_JPRB, 0.17045172E-05_JPRB, 0.17046561E-05_JPRB, 0.17046646E-05_JPRB, 0.17046902E-05_JPRB, &
  & 0.17047506E-05_JPRB, 0.17047539E-05_JPRB, 0.17047236E-05_JPRB, 0.17047545E-05_JPRB, 0.17047890E-05_JPRB, 0.17048093E-05_JPRB, &
  & 0.17048116E-05_JPRB, 0.17048010E-05_JPRB, 0.17048382E-05_JPRB, 0.17048055E-05_JPRB, 0.17046759E-05_JPRB, 0.17044989E-05_JPRB, &
  & 0.17043821E-05_JPRB, 0.17042789E-05_JPRB, 0.17042625E-05_JPRB, 0.17043024E-05_JPRB, 0.17044142E-05_JPRB, 0.17049364E-05_JPRB, &
  & 0.17052566E-05_JPRB, 0.17054273E-05_JPRB, 0.17057590E-05_JPRB, 0.17063995E-05_JPRB, 0.17068185E-05_JPRB, 0.17073128E-05_JPRB, &
  & 0.17085948E-05_JPRB, 0.17100313E-05_JPRB, 0.17107687E-05_JPRB, 0.17117992E-05_JPRB, 0.17142937E-05_JPRB, 0.17176995E-05_JPRB, &
  & 0.17220370E-05_JPRB, 0.17272134E-05_JPRB, 0.17328087E-05_JPRB, 0.17373853E-05_JPRB, 0.17409359E-05_JPRB, 0.17457133E-05_JPRB, &
  & 0.17504773E-05_JPRB, 0.17503638E-05_JPRB, 0.17495936E-05_JPRB, 0.17510575E-05_JPRB, 0.17554355E-05_JPRB, 0.17605680E-05_JPRB, &
  & 0.17656832E-05_JPRB, 0.17704589E-05_JPRB, 0.17740971E-05_JPRB, 0.17766297E-05_JPRB, 0.17782812E-05_JPRB, 0.17787617E-05_JPRB, &
  & 0.17796491E-05_JPRB, 0.17805824E-05_JPRB, 0.17818078E-05_JPRB, 0.17826757E-05_JPRB, 0.17826289E-05_JPRB, 0.17818783E-05_JPRB, &
  & 0.17816141E-05_JPRB, 0.17828990E-05_JPRB, 0.17834356E-05_JPRB, 0.17820445E-05_JPRB  /)

RGHG2(:,62, 8) = (/ &
  & 0.17044780E-05_JPRB, 0.17044344E-05_JPRB, 0.17045018E-05_JPRB, 0.17046279E-05_JPRB, 0.17046296E-05_JPRB, 0.17046502E-05_JPRB, &
  & 0.17046923E-05_JPRB, 0.17046898E-05_JPRB, 0.17046643E-05_JPRB, 0.17046874E-05_JPRB, 0.17047138E-05_JPRB, 0.17047294E-05_JPRB, &
  & 0.17047262E-05_JPRB, 0.17047073E-05_JPRB, 0.17047411E-05_JPRB, 0.17047351E-05_JPRB, 0.17046329E-05_JPRB, 0.17044354E-05_JPRB, &
  & 0.17042956E-05_JPRB, 0.17041363E-05_JPRB, 0.17040503E-05_JPRB, 0.17039639E-05_JPRB, 0.17039246E-05_JPRB, 0.17043124E-05_JPRB, &
  & 0.17046082E-05_JPRB, 0.17047500E-05_JPRB, 0.17050203E-05_JPRB, 0.17055747E-05_JPRB, 0.17059634E-05_JPRB, 0.17064901E-05_JPRB, &
  & 0.17077087E-05_JPRB, 0.17091972E-05_JPRB, 0.17101912E-05_JPRB, 0.17114807E-05_JPRB, 0.17139858E-05_JPRB, 0.17175177E-05_JPRB, &
  & 0.17219190E-05_JPRB, 0.17267004E-05_JPRB, 0.17312944E-05_JPRB, 0.17352781E-05_JPRB, 0.17387709E-05_JPRB, 0.17438568E-05_JPRB, &
  & 0.17489932E-05_JPRB, 0.17490419E-05_JPRB, 0.17485684E-05_JPRB, 0.17508882E-05_JPRB, 0.17556507E-05_JPRB, 0.17609511E-05_JPRB, &
  & 0.17663716E-05_JPRB, 0.17711904E-05_JPRB, 0.17748896E-05_JPRB, 0.17775115E-05_JPRB, 0.17790719E-05_JPRB, 0.17796335E-05_JPRB, &
  & 0.17805364E-05_JPRB, 0.17815655E-05_JPRB, 0.17828059E-05_JPRB, 0.17837472E-05_JPRB, 0.17834772E-05_JPRB, 0.17826029E-05_JPRB, &
  & 0.17825218E-05_JPRB, 0.17838787E-05_JPRB, 0.17841149E-05_JPRB, 0.17826695E-05_JPRB  /)

RGHG2(:,63, 8) = (/ &
  & 0.17044659E-05_JPRB, 0.17044231E-05_JPRB, 0.17044978E-05_JPRB, 0.17046071E-05_JPRB, 0.17046004E-05_JPRB, 0.17046185E-05_JPRB, &
  & 0.17046446E-05_JPRB, 0.17046363E-05_JPRB, 0.17046170E-05_JPRB, 0.17046340E-05_JPRB, 0.17046537E-05_JPRB, 0.17046662E-05_JPRB, &
  & 0.17046592E-05_JPRB, 0.17046335E-05_JPRB, 0.17046559E-05_JPRB, 0.17046759E-05_JPRB, 0.17046030E-05_JPRB, 0.17044008E-05_JPRB, &
  & 0.17042405E-05_JPRB, 0.17040290E-05_JPRB, 0.17038795E-05_JPRB, 0.17036675E-05_JPRB, 0.17034858E-05_JPRB, 0.17037134E-05_JPRB, &
  & 0.17039560E-05_JPRB, 0.17040643E-05_JPRB, 0.17042840E-05_JPRB, 0.17047391E-05_JPRB, 0.17051082E-05_JPRB, 0.17056550E-05_JPRB, &
  & 0.17068587E-05_JPRB, 0.17084550E-05_JPRB, 0.17097527E-05_JPRB, 0.17112855E-05_JPRB, 0.17136675E-05_JPRB, 0.17173691E-05_JPRB, &
  & 0.17216735E-05_JPRB, 0.17257125E-05_JPRB, 0.17293882E-05_JPRB, 0.17329803E-05_JPRB, 0.17366200E-05_JPRB, 0.17420815E-05_JPRB, &
  & 0.17475310E-05_JPRB, 0.17478384E-05_JPRB, 0.17476808E-05_JPRB, 0.17507671E-05_JPRB, 0.17558618E-05_JPRB, 0.17613690E-05_JPRB, &
  & 0.17670732E-05_JPRB, 0.17719831E-05_JPRB, 0.17757773E-05_JPRB, 0.17784791E-05_JPRB, 0.17799288E-05_JPRB, 0.17805886E-05_JPRB, &
  & 0.17814660E-05_JPRB, 0.17825615E-05_JPRB, 0.17837933E-05_JPRB, 0.17847580E-05_JPRB, 0.17842750E-05_JPRB, 0.17832724E-05_JPRB, &
  & 0.17833771E-05_JPRB, 0.17847592E-05_JPRB, 0.17846650E-05_JPRB, 0.17830766E-05_JPRB  /)

RGHG2(:,64, 8) = (/ &
  & 0.17044729E-05_JPRB, 0.17044301E-05_JPRB, 0.17045073E-05_JPRB, 0.17045962E-05_JPRB, 0.17045773E-05_JPRB, 0.17045954E-05_JPRB, &
  & 0.17046095E-05_JPRB, 0.17045952E-05_JPRB, 0.17045831E-05_JPRB, 0.17045965E-05_JPRB, 0.17046102E-05_JPRB, 0.17046202E-05_JPRB, &
  & 0.17046121E-05_JPRB, 0.17045827E-05_JPRB, 0.17045859E-05_JPRB, 0.17046240E-05_JPRB, 0.17045775E-05_JPRB, 0.17043934E-05_JPRB, &
  & 0.17042199E-05_JPRB, 0.17039602E-05_JPRB, 0.17037432E-05_JPRB, 0.17034131E-05_JPRB, 0.17031158E-05_JPRB, 0.17031688E-05_JPRB, &
  & 0.17033451E-05_JPRB, 0.17034124E-05_JPRB, 0.17035550E-05_JPRB, 0.17038535E-05_JPRB, 0.17042467E-05_JPRB, 0.17048116E-05_JPRB, &
  & 0.17061358E-05_JPRB, 0.17079236E-05_JPRB, 0.17095357E-05_JPRB, 0.17111830E-05_JPRB, 0.17133204E-05_JPRB, 0.17172810E-05_JPRB, &
  & 0.17210385E-05_JPRB, 0.17240632E-05_JPRB, 0.17271582E-05_JPRB, 0.17305805E-05_JPRB, 0.17345779E-05_JPRB, 0.17404129E-05_JPRB, &
  & 0.17461431E-05_JPRB, 0.17467841E-05_JPRB, 0.17470205E-05_JPRB, 0.17507308E-05_JPRB, 0.17560917E-05_JPRB, 0.17618688E-05_JPRB, &
  & 0.17678236E-05_JPRB, 0.17728732E-05_JPRB, 0.17767915E-05_JPRB, 0.17795632E-05_JPRB, 0.17808743E-05_JPRB, 0.17816521E-05_JPRB, &
  & 0.17824501E-05_JPRB, 0.17835540E-05_JPRB, 0.17847533E-05_JPRB, 0.17856782E-05_JPRB, 0.17850567E-05_JPRB, 0.17838662E-05_JPRB, &
  & 0.17841335E-05_JPRB, 0.17854734E-05_JPRB, 0.17851503E-05_JPRB, 0.17833355E-05_JPRB  /)

RGHG2(:,65, 8) = (/ &
  & 0.17044871E-05_JPRB, 0.17044443E-05_JPRB, 0.17045194E-05_JPRB, 0.17045921E-05_JPRB, 0.17045611E-05_JPRB, 0.17045781E-05_JPRB, &
  & 0.17045845E-05_JPRB, 0.17045675E-05_JPRB, 0.17045627E-05_JPRB, 0.17045747E-05_JPRB, 0.17045812E-05_JPRB, 0.17045922E-05_JPRB, &
  & 0.17045828E-05_JPRB, 0.17045532E-05_JPRB, 0.17045380E-05_JPRB, 0.17045843E-05_JPRB, 0.17045555E-05_JPRB, 0.17044075E-05_JPRB, &
  & 0.17042274E-05_JPRB, 0.17039293E-05_JPRB, 0.17036342E-05_JPRB, 0.17032255E-05_JPRB, 0.17028128E-05_JPRB, 0.17027425E-05_JPRB, &
  & 0.17028015E-05_JPRB, 0.17028030E-05_JPRB, 0.17028656E-05_JPRB, 0.17030141E-05_JPRB, 0.17034641E-05_JPRB, 0.17041011E-05_JPRB, &
  & 0.17056363E-05_JPRB, 0.17075880E-05_JPRB, 0.17093813E-05_JPRB, 0.17109510E-05_JPRB, 0.17130293E-05_JPRB, 0.17172149E-05_JPRB, &
  & 0.17200278E-05_JPRB, 0.17222782E-05_JPRB, 0.17249473E-05_JPRB, 0.17284900E-05_JPRB, 0.17328356E-05_JPRB, 0.17391781E-05_JPRB, &
  & 0.17449736E-05_JPRB, 0.17460697E-05_JPRB, 0.17467277E-05_JPRB, 0.17508425E-05_JPRB, 0.17564795E-05_JPRB, 0.17625667E-05_JPRB, &
  & 0.17687100E-05_JPRB, 0.17739228E-05_JPRB, 0.17779740E-05_JPRB, 0.17807769E-05_JPRB, 0.17819260E-05_JPRB, 0.17827723E-05_JPRB, &
  & 0.17834677E-05_JPRB, 0.17845543E-05_JPRB, 0.17856648E-05_JPRB, 0.17865104E-05_JPRB, 0.17857931E-05_JPRB, 0.17843672E-05_JPRB, &
  & 0.17847020E-05_JPRB, 0.17859725E-05_JPRB, 0.17856048E-05_JPRB, 0.17838332E-05_JPRB  /)

RGHG2(:,66, 8) = (/ &
  & 0.17045025E-05_JPRB, 0.17044625E-05_JPRB, 0.17045330E-05_JPRB, 0.17045897E-05_JPRB, 0.17045492E-05_JPRB, 0.17045643E-05_JPRB, &
  & 0.17045662E-05_JPRB, 0.17045481E-05_JPRB, 0.17045478E-05_JPRB, 0.17045608E-05_JPRB, 0.17045619E-05_JPRB, 0.17045749E-05_JPRB, &
  & 0.17045636E-05_JPRB, 0.17045332E-05_JPRB, 0.17045067E-05_JPRB, 0.17045582E-05_JPRB, 0.17045474E-05_JPRB, 0.17044305E-05_JPRB, &
  & 0.17042605E-05_JPRB, 0.17039334E-05_JPRB, 0.17035610E-05_JPRB, 0.17031022E-05_JPRB, 0.17025640E-05_JPRB, 0.17023737E-05_JPRB, &
  & 0.17023146E-05_JPRB, 0.17022167E-05_JPRB, 0.17021585E-05_JPRB, 0.17022036E-05_JPRB, 0.17026970E-05_JPRB, 0.17034998E-05_JPRB, &
  & 0.17053457E-05_JPRB, 0.17073877E-05_JPRB, 0.17091951E-05_JPRB, 0.17106072E-05_JPRB, 0.17127901E-05_JPRB, 0.17169419E-05_JPRB, &
  & 0.17188752E-05_JPRB, 0.17206251E-05_JPRB, 0.17230734E-05_JPRB, 0.17268177E-05_JPRB, 0.17313720E-05_JPRB, 0.17381993E-05_JPRB, &
  & 0.17440654E-05_JPRB, 0.17455625E-05_JPRB, 0.17467159E-05_JPRB, 0.17511177E-05_JPRB, 0.17570546E-05_JPRB, 0.17634672E-05_JPRB, &
  & 0.17697321E-05_JPRB, 0.17750842E-05_JPRB, 0.17792849E-05_JPRB, 0.17820455E-05_JPRB, 0.17830390E-05_JPRB, 0.17839131E-05_JPRB, &
  & 0.17845308E-05_JPRB, 0.17855992E-05_JPRB, 0.17865689E-05_JPRB, 0.17872814E-05_JPRB, 0.17864867E-05_JPRB, 0.17848437E-05_JPRB, &
  & 0.17852098E-05_JPRB, 0.17863774E-05_JPRB, 0.17859540E-05_JPRB, 0.17844600E-05_JPRB  /)

RGHG2(:,67, 8) = (/ &
  & 0.17045172E-05_JPRB, 0.17044833E-05_JPRB, 0.17045459E-05_JPRB, 0.17045880E-05_JPRB, 0.17045407E-05_JPRB, 0.17045541E-05_JPRB, &
  & 0.17045535E-05_JPRB, 0.17045357E-05_JPRB, 0.17045374E-05_JPRB, 0.17045528E-05_JPRB, 0.17045505E-05_JPRB, 0.17045666E-05_JPRB, &
  & 0.17045525E-05_JPRB, 0.17045206E-05_JPRB, 0.17044899E-05_JPRB, 0.17045446E-05_JPRB, 0.17045529E-05_JPRB, 0.17044630E-05_JPRB, &
  & 0.17043197E-05_JPRB, 0.17039813E-05_JPRB, 0.17035368E-05_JPRB, 0.17030493E-05_JPRB, 0.17023850E-05_JPRB, 0.17020650E-05_JPRB, &
  & 0.17019000E-05_JPRB, 0.17016649E-05_JPRB, 0.17014491E-05_JPRB, 0.17014246E-05_JPRB, 0.17019734E-05_JPRB, 0.17030150E-05_JPRB, &
  & 0.17052615E-05_JPRB, 0.17073182E-05_JPRB, 0.17089840E-05_JPRB, 0.17101422E-05_JPRB, 0.17125189E-05_JPRB, 0.17163808E-05_JPRB, &
  & 0.17176165E-05_JPRB, 0.17191928E-05_JPRB, 0.17216348E-05_JPRB, 0.17256251E-05_JPRB, 0.17302765E-05_JPRB, 0.17374810E-05_JPRB, &
  & 0.17434846E-05_JPRB, 0.17453195E-05_JPRB, 0.17470077E-05_JPRB, 0.17516012E-05_JPRB, 0.17578519E-05_JPRB, 0.17645958E-05_JPRB, &
  & 0.17709189E-05_JPRB, 0.17763412E-05_JPRB, 0.17807020E-05_JPRB, 0.17833458E-05_JPRB, 0.17842044E-05_JPRB, 0.17850645E-05_JPRB, &
  & 0.17856456E-05_JPRB, 0.17866859E-05_JPRB, 0.17874580E-05_JPRB, 0.17879772E-05_JPRB, 0.17871247E-05_JPRB, 0.17853205E-05_JPRB, &
  & 0.17856846E-05_JPRB, 0.17866641E-05_JPRB, 0.17861438E-05_JPRB, 0.17850904E-05_JPRB  /)

RGHG2(:,68, 8) = (/ &
  & 0.17045284E-05_JPRB, 0.17045045E-05_JPRB, 0.17045535E-05_JPRB, 0.17045856E-05_JPRB, 0.17045334E-05_JPRB, 0.17045481E-05_JPRB, &
  & 0.17045450E-05_JPRB, 0.17045285E-05_JPRB, 0.17045301E-05_JPRB, 0.17045480E-05_JPRB, 0.17045433E-05_JPRB, 0.17045642E-05_JPRB, &
  & 0.17045465E-05_JPRB, 0.17045121E-05_JPRB, 0.17044839E-05_JPRB, 0.17045398E-05_JPRB, 0.17045692E-05_JPRB, 0.17045089E-05_JPRB, &
  & 0.17044064E-05_JPRB, 0.17040916E-05_JPRB, 0.17035851E-05_JPRB, 0.17030767E-05_JPRB, 0.17023060E-05_JPRB, 0.17018264E-05_JPRB, &
  & 0.17015847E-05_JPRB, 0.17011665E-05_JPRB, 0.17007726E-05_JPRB, 0.17006739E-05_JPRB, 0.17013551E-05_JPRB, 0.17026539E-05_JPRB, &
  & 0.17053692E-05_JPRB, 0.17073740E-05_JPRB, 0.17087801E-05_JPRB, 0.17095326E-05_JPRB, 0.17120305E-05_JPRB, 0.17154075E-05_JPRB, &
  & 0.17162721E-05_JPRB, 0.17180908E-05_JPRB, 0.17207406E-05_JPRB, 0.17249833E-05_JPRB, 0.17297139E-05_JPRB, 0.17370445E-05_JPRB, &
  & 0.17433413E-05_JPRB, 0.17454743E-05_JPRB, 0.17476572E-05_JPRB, 0.17523831E-05_JPRB, 0.17589419E-05_JPRB, 0.17660110E-05_JPRB, &
  & 0.17723416E-05_JPRB, 0.17776810E-05_JPRB, 0.17821989E-05_JPRB, 0.17846583E-05_JPRB, 0.17854254E-05_JPRB, 0.17862274E-05_JPRB, &
  & 0.17868357E-05_JPRB, 0.17878141E-05_JPRB, 0.17883203E-05_JPRB, 0.17885761E-05_JPRB, 0.17876901E-05_JPRB, 0.17858451E-05_JPRB, &
  & 0.17861697E-05_JPRB, 0.17867670E-05_JPRB, 0.17860821E-05_JPRB, 0.17854802E-05_JPRB  /)

RGHG2(:,69, 8) = (/ &
  & 0.17045441E-05_JPRB, 0.17045267E-05_JPRB, 0.17045587E-05_JPRB, 0.17045832E-05_JPRB, 0.17045316E-05_JPRB, 0.17045476E-05_JPRB, &
  & 0.17045420E-05_JPRB, 0.17045278E-05_JPRB, 0.17045283E-05_JPRB, 0.17045476E-05_JPRB, 0.17045415E-05_JPRB, 0.17045663E-05_JPRB, &
  & 0.17045437E-05_JPRB, 0.17045057E-05_JPRB, 0.17044822E-05_JPRB, 0.17045337E-05_JPRB, 0.17045841E-05_JPRB, 0.17045659E-05_JPRB, &
  & 0.17045178E-05_JPRB, 0.17042557E-05_JPRB, 0.17037223E-05_JPRB, 0.17031816E-05_JPRB, 0.17023698E-05_JPRB, 0.17017341E-05_JPRB, &
  & 0.17013617E-05_JPRB, 0.17007076E-05_JPRB, 0.17001817E-05_JPRB, 0.17000561E-05_JPRB, 0.17009878E-05_JPRB, 0.17024482E-05_JPRB, &
  & 0.17053980E-05_JPRB, 0.17071989E-05_JPRB, 0.17082721E-05_JPRB, 0.17087900E-05_JPRB, 0.17112819E-05_JPRB, 0.17144173E-05_JPRB, &
  & 0.17151338E-05_JPRB, 0.17173367E-05_JPRB, 0.17202056E-05_JPRB, 0.17247411E-05_JPRB, 0.17296792E-05_JPRB, 0.17369457E-05_JPRB, &
  & 0.17436357E-05_JPRB, 0.17461536E-05_JPRB, 0.17486296E-05_JPRB, 0.17535452E-05_JPRB, 0.17604784E-05_JPRB, 0.17677861E-05_JPRB, &
  & 0.17740802E-05_JPRB, 0.17792794E-05_JPRB, 0.17837865E-05_JPRB, 0.17860156E-05_JPRB, 0.17867520E-05_JPRB, 0.17874192E-05_JPRB, &
  & 0.17880829E-05_JPRB, 0.17889590E-05_JPRB, 0.17891610E-05_JPRB, 0.17890869E-05_JPRB, 0.17881822E-05_JPRB, 0.17864044E-05_JPRB, &
  & 0.17866117E-05_JPRB, 0.17866996E-05_JPRB, 0.17857343E-05_JPRB, 0.17853002E-05_JPRB  /)

RGHG2(:,70, 8) = (/ &
  & 0.17045668E-05_JPRB, 0.17045513E-05_JPRB, 0.17045666E-05_JPRB, 0.17045851E-05_JPRB, 0.17045370E-05_JPRB, 0.17045520E-05_JPRB, &
  & 0.17045447E-05_JPRB, 0.17045330E-05_JPRB, 0.17045315E-05_JPRB, 0.17045513E-05_JPRB, 0.17045461E-05_JPRB, 0.17045725E-05_JPRB, &
  & 0.17045471E-05_JPRB, 0.17045068E-05_JPRB, 0.17044869E-05_JPRB, 0.17045298E-05_JPRB, 0.17045963E-05_JPRB, 0.17046185E-05_JPRB, &
  & 0.17046269E-05_JPRB, 0.17044313E-05_JPRB, 0.17039104E-05_JPRB, 0.17033233E-05_JPRB, 0.17025070E-05_JPRB, 0.17017475E-05_JPRB, &
  & 0.17012114E-05_JPRB, 0.17003106E-05_JPRB, 0.16996715E-05_JPRB, 0.16996012E-05_JPRB, 0.17008064E-05_JPRB, 0.17024314E-05_JPRB, &
  & 0.17052726E-05_JPRB, 0.17066571E-05_JPRB, 0.17075074E-05_JPRB, 0.17079841E-05_JPRB, 0.17105272E-05_JPRB, 0.17137039E-05_JPRB, &
  & 0.17143983E-05_JPRB, 0.17167429E-05_JPRB, 0.17198489E-05_JPRB, 0.17246379E-05_JPRB, 0.17299202E-05_JPRB, 0.17371232E-05_JPRB, &
  & 0.17442315E-05_JPRB, 0.17471937E-05_JPRB, 0.17498071E-05_JPRB, 0.17550572E-05_JPRB, 0.17623843E-05_JPRB, 0.17698097E-05_JPRB, &
  & 0.17760132E-05_JPRB, 0.17811071E-05_JPRB, 0.17854799E-05_JPRB, 0.17874498E-05_JPRB, 0.17881470E-05_JPRB, 0.17886409E-05_JPRB, &
  & 0.17893477E-05_JPRB, 0.17900762E-05_JPRB, 0.17899797E-05_JPRB, 0.17895664E-05_JPRB, 0.17885947E-05_JPRB, 0.17869943E-05_JPRB, &
  & 0.17870390E-05_JPRB, 0.17866162E-05_JPRB, 0.17852599E-05_JPRB, 0.17847114E-05_JPRB  /)

RGHG2(:,71, 8) = (/ &
  & 0.17045963E-05_JPRB, 0.17045782E-05_JPRB, 0.17045781E-05_JPRB, 0.17045913E-05_JPRB, 0.17045491E-05_JPRB, 0.17045607E-05_JPRB, &
  & 0.17045518E-05_JPRB, 0.17045432E-05_JPRB, 0.17045396E-05_JPRB, 0.17045594E-05_JPRB, 0.17045564E-05_JPRB, 0.17045830E-05_JPRB, &
  & 0.17045576E-05_JPRB, 0.17045168E-05_JPRB, 0.17044990E-05_JPRB, 0.17045314E-05_JPRB, 0.17046068E-05_JPRB, 0.17046641E-05_JPRB, &
  & 0.17047294E-05_JPRB, 0.17046073E-05_JPRB, 0.17041322E-05_JPRB, 0.17034956E-05_JPRB, 0.17027013E-05_JPRB, 0.17018601E-05_JPRB, &
  & 0.17011447E-05_JPRB, 0.17000142E-05_JPRB, 0.16992782E-05_JPRB, 0.16993238E-05_JPRB, 0.17008330E-05_JPRB, 0.17025894E-05_JPRB, &
  & 0.17050050E-05_JPRB, 0.17058538E-05_JPRB, 0.17066080E-05_JPRB, 0.17071773E-05_JPRB, 0.17097971E-05_JPRB, 0.17133075E-05_JPRB, &
  & 0.17140966E-05_JPRB, 0.17163290E-05_JPRB, 0.17196697E-05_JPRB, 0.17246337E-05_JPRB, 0.17304059E-05_JPRB, 0.17375867E-05_JPRB, &
  & 0.17451017E-05_JPRB, 0.17485577E-05_JPRB, 0.17512198E-05_JPRB, 0.17569186E-05_JPRB, 0.17646175E-05_JPRB, 0.17720498E-05_JPRB, &
  & 0.17781520E-05_JPRB, 0.17831612E-05_JPRB, 0.17873016E-05_JPRB, 0.17889960E-05_JPRB, 0.17896190E-05_JPRB, 0.17898959E-05_JPRB, &
  & 0.17906112E-05_JPRB, 0.17911451E-05_JPRB, 0.17907534E-05_JPRB, 0.17900130E-05_JPRB, 0.17889245E-05_JPRB, 0.17875762E-05_JPRB, &
  & 0.17874326E-05_JPRB, 0.17864976E-05_JPRB, 0.17846599E-05_JPRB, 0.17837880E-05_JPRB  /)

RGHG2(:,72, 8) = (/ &
  & 0.17046315E-05_JPRB, 0.17046073E-05_JPRB, 0.17045935E-05_JPRB, 0.17046006E-05_JPRB, 0.17045670E-05_JPRB, 0.17045724E-05_JPRB, &
  & 0.17045611E-05_JPRB, 0.17045574E-05_JPRB, 0.17045525E-05_JPRB, 0.17045723E-05_JPRB, 0.17045705E-05_JPRB, 0.17045984E-05_JPRB, &
  & 0.17045767E-05_JPRB, 0.17045371E-05_JPRB, 0.17045206E-05_JPRB, 0.17045443E-05_JPRB, 0.17046185E-05_JPRB, 0.17047005E-05_JPRB, &
  & 0.17048228E-05_JPRB, 0.17047713E-05_JPRB, 0.17043643E-05_JPRB, 0.17036967E-05_JPRB, 0.17029383E-05_JPRB, 0.17020712E-05_JPRB, &
  & 0.17011886E-05_JPRB, 0.16998897E-05_JPRB, 0.16990744E-05_JPRB, 0.16992488E-05_JPRB, 0.17011295E-05_JPRB, 0.17028921E-05_JPRB, &
  & 0.17046304E-05_JPRB, 0.17050123E-05_JPRB, 0.17057938E-05_JPRB, 0.17064733E-05_JPRB, 0.17090955E-05_JPRB, 0.17132499E-05_JPRB, &
  & 0.17142569E-05_JPRB, 0.17161760E-05_JPRB, 0.17197086E-05_JPRB, 0.17247086E-05_JPRB, 0.17311370E-05_JPRB, 0.17383772E-05_JPRB, &
  & 0.17462327E-05_JPRB, 0.17502212E-05_JPRB, 0.17529625E-05_JPRB, 0.17591504E-05_JPRB, 0.17671291E-05_JPRB, 0.17744822E-05_JPRB, &
  & 0.17805571E-05_JPRB, 0.17854549E-05_JPRB, 0.17893018E-05_JPRB, 0.17907239E-05_JPRB, 0.17911995E-05_JPRB, 0.17911966E-05_JPRB, &
  & 0.17918500E-05_JPRB, 0.17921375E-05_JPRB, 0.17914386E-05_JPRB, 0.17904122E-05_JPRB, 0.17891652E-05_JPRB, 0.17880782E-05_JPRB, &
  & 0.17877501E-05_JPRB, 0.17862728E-05_JPRB, 0.17838964E-05_JPRB, 0.17826284E-05_JPRB  /)

RGHG2(:,73, 8) = (/ &
  & 0.17046677E-05_JPRB, 0.17046372E-05_JPRB, 0.17046109E-05_JPRB, 0.17046152E-05_JPRB, 0.17045915E-05_JPRB, 0.17045872E-05_JPRB, &
  & 0.17045723E-05_JPRB, 0.17045747E-05_JPRB, 0.17045686E-05_JPRB, 0.17045884E-05_JPRB, 0.17045867E-05_JPRB, 0.17046182E-05_JPRB, &
  & 0.17046071E-05_JPRB, 0.17045710E-05_JPRB, 0.17045511E-05_JPRB, 0.17045719E-05_JPRB, 0.17046414E-05_JPRB, 0.17047391E-05_JPRB, &
  & 0.17049141E-05_JPRB, 0.17049198E-05_JPRB, 0.17045709E-05_JPRB, 0.17039285E-05_JPRB, 0.17032212E-05_JPRB, 0.17023486E-05_JPRB, &
  & 0.17013737E-05_JPRB, 0.16999916E-05_JPRB, 0.16990874E-05_JPRB, 0.16993729E-05_JPRB, 0.17014515E-05_JPRB, 0.17030536E-05_JPRB, &
  & 0.17042704E-05_JPRB, 0.17044943E-05_JPRB, 0.17053446E-05_JPRB, 0.17059350E-05_JPRB, 0.17084631E-05_JPRB, 0.17134375E-05_JPRB, &
  & 0.17147889E-05_JPRB, 0.17164596E-05_JPRB, 0.17200807E-05_JPRB, 0.17249306E-05_JPRB, 0.17319915E-05_JPRB, 0.17396087E-05_JPRB, &
  & 0.17476055E-05_JPRB, 0.17520307E-05_JPRB, 0.17550586E-05_JPRB, 0.17617568E-05_JPRB, 0.17698860E-05_JPRB, 0.17771950E-05_JPRB, &
  & 0.17833103E-05_JPRB, 0.17880742E-05_JPRB, 0.17915179E-05_JPRB, 0.17926901E-05_JPRB, 0.17929015E-05_JPRB, 0.17926194E-05_JPRB, &
  & 0.17930910E-05_JPRB, 0.17930111E-05_JPRB, 0.17920046E-05_JPRB, 0.17906824E-05_JPRB, 0.17893116E-05_JPRB, 0.17884391E-05_JPRB, &
  & 0.17877945E-05_JPRB, 0.17859268E-05_JPRB, 0.17828846E-05_JPRB, 0.17812283E-05_JPRB  /)

RGHG2(:,74, 8) = (/ &
  & 0.17046993E-05_JPRB, 0.17046671E-05_JPRB, 0.17046299E-05_JPRB, 0.17046309E-05_JPRB, 0.17046149E-05_JPRB, 0.17046029E-05_JPRB, &
  & 0.17045850E-05_JPRB, 0.17045951E-05_JPRB, 0.17045863E-05_JPRB, 0.17046061E-05_JPRB, 0.17046074E-05_JPRB, 0.17046396E-05_JPRB, &
  & 0.17046442E-05_JPRB, 0.17046156E-05_JPRB, 0.17045890E-05_JPRB, 0.17046125E-05_JPRB, 0.17046718E-05_JPRB, 0.17047822E-05_JPRB, &
  & 0.17050050E-05_JPRB, 0.17050607E-05_JPRB, 0.17047542E-05_JPRB, 0.17041768E-05_JPRB, 0.17035045E-05_JPRB, 0.17026236E-05_JPRB, &
  & 0.17015973E-05_JPRB, 0.17001834E-05_JPRB, 0.16992240E-05_JPRB, 0.16995592E-05_JPRB, 0.17016973E-05_JPRB, 0.17031043E-05_JPRB, &
  & 0.17040032E-05_JPRB, 0.17042028E-05_JPRB, 0.17050475E-05_JPRB, 0.17054678E-05_JPRB, 0.17079268E-05_JPRB, 0.17136775E-05_JPRB, &
  & 0.17155130E-05_JPRB, 0.17170554E-05_JPRB, 0.17206544E-05_JPRB, 0.17253395E-05_JPRB, 0.17328747E-05_JPRB, 0.17411255E-05_JPRB, &
  & 0.17491930E-05_JPRB, 0.17539379E-05_JPRB, 0.17572800E-05_JPRB, 0.17644935E-05_JPRB, 0.17728069E-05_JPRB, 0.17800225E-05_JPRB, &
  & 0.17862123E-05_JPRB, 0.17908181E-05_JPRB, 0.17939201E-05_JPRB, 0.17947743E-05_JPRB, 0.17946289E-05_JPRB, 0.17941180E-05_JPRB, &
  & 0.17943090E-05_JPRB, 0.17938864E-05_JPRB, 0.17925477E-05_JPRB, 0.17909122E-05_JPRB, 0.17894147E-05_JPRB, 0.17887189E-05_JPRB, &
  & 0.17876429E-05_JPRB, 0.17854550E-05_JPRB, 0.17817720E-05_JPRB, 0.17797227E-05_JPRB  /)

RGHG2(:,75, 8) = (/ &
  & 0.17047271E-05_JPRB, 0.17046962E-05_JPRB, 0.17046504E-05_JPRB, 0.17046477E-05_JPRB, 0.17046365E-05_JPRB, 0.17046194E-05_JPRB, &
  & 0.17045989E-05_JPRB, 0.17046175E-05_JPRB, 0.17046063E-05_JPRB, 0.17046250E-05_JPRB, 0.17046320E-05_JPRB, 0.17046626E-05_JPRB, &
  & 0.17046852E-05_JPRB, 0.17046672E-05_JPRB, 0.17046329E-05_JPRB, 0.17046636E-05_JPRB, 0.17047103E-05_JPRB, 0.17048336E-05_JPRB, &
  & 0.17051004E-05_JPRB, 0.17052003E-05_JPRB, 0.17049195E-05_JPRB, 0.17044234E-05_JPRB, 0.17037727E-05_JPRB, 0.17028937E-05_JPRB, &
  & 0.17018381E-05_JPRB, 0.17004317E-05_JPRB, 0.16994534E-05_JPRB, 0.16997683E-05_JPRB, 0.17018478E-05_JPRB, 0.17030489E-05_JPRB, &
  & 0.17038201E-05_JPRB, 0.17040614E-05_JPRB, 0.17048569E-05_JPRB, 0.17050642E-05_JPRB, 0.17075045E-05_JPRB, 0.17139265E-05_JPRB, &
  & 0.17163717E-05_JPRB, 0.17179223E-05_JPRB, 0.17213905E-05_JPRB, 0.17259203E-05_JPRB, 0.17338230E-05_JPRB, 0.17428634E-05_JPRB, &
  & 0.17509845E-05_JPRB, 0.17559888E-05_JPRB, 0.17595576E-05_JPRB, 0.17672597E-05_JPRB, 0.17758206E-05_JPRB, 0.17829272E-05_JPRB, &
  & 0.17891723E-05_JPRB, 0.17936241E-05_JPRB, 0.17964309E-05_JPRB, 0.17969355E-05_JPRB, 0.17963699E-05_JPRB, 0.17956525E-05_JPRB, &
  & 0.17955372E-05_JPRB, 0.17948216E-05_JPRB, 0.17930736E-05_JPRB, 0.17911250E-05_JPRB, 0.17894708E-05_JPRB, 0.17889076E-05_JPRB, &
  & 0.17873306E-05_JPRB, 0.17848650E-05_JPRB, 0.17805783E-05_JPRB, 0.17781635E-05_JPRB  /)

RGHG2(:,76, 8) = (/ &
  & 0.17047533E-05_JPRB, 0.17047236E-05_JPRB, 0.17046728E-05_JPRB, 0.17046665E-05_JPRB, 0.17046565E-05_JPRB, 0.17046369E-05_JPRB, &
  & 0.17046140E-05_JPRB, 0.17046399E-05_JPRB, 0.17046300E-05_JPRB, 0.17046450E-05_JPRB, 0.17046594E-05_JPRB, 0.17046875E-05_JPRB, &
  & 0.17047262E-05_JPRB, 0.17047206E-05_JPRB, 0.17046814E-05_JPRB, 0.17047220E-05_JPRB, 0.17047587E-05_JPRB, 0.17048994E-05_JPRB, &
  & 0.17052083E-05_JPRB, 0.17053478E-05_JPRB, 0.17050757E-05_JPRB, 0.17046428E-05_JPRB, 0.17040082E-05_JPRB, 0.17031651E-05_JPRB, &
  & 0.17020786E-05_JPRB, 0.17007055E-05_JPRB, 0.16997433E-05_JPRB, 0.16999592E-05_JPRB, 0.17018851E-05_JPRB, 0.17028881E-05_JPRB, &
  & 0.17036977E-05_JPRB, 0.17039662E-05_JPRB, 0.17047332E-05_JPRB, 0.17047263E-05_JPRB, 0.17072223E-05_JPRB, 0.17141446E-05_JPRB, &
  & 0.17173057E-05_JPRB, 0.17190222E-05_JPRB, 0.17222514E-05_JPRB, 0.17266487E-05_JPRB, 0.17349118E-05_JPRB, 0.17447535E-05_JPRB, &
  & 0.17529774E-05_JPRB, 0.17582728E-05_JPRB, 0.17618230E-05_JPRB, 0.17699400E-05_JPRB, 0.17788365E-05_JPRB, 0.17858836E-05_JPRB, &
  & 0.17920854E-05_JPRB, 0.17964319E-05_JPRB, 0.17989415E-05_JPRB, 0.17991340E-05_JPRB, 0.17981250E-05_JPRB, 0.17971711E-05_JPRB, &
  & 0.17968353E-05_JPRB, 0.17958955E-05_JPRB, 0.17935779E-05_JPRB, 0.17913457E-05_JPRB, 0.17894660E-05_JPRB, 0.17889796E-05_JPRB, &
  & 0.17868973E-05_JPRB, 0.17841654E-05_JPRB, 0.17793078E-05_JPRB, 0.17766081E-05_JPRB  /)

RGHG2(:,77, 8) = (/ &
  & 0.17047763E-05_JPRB, 0.17047454E-05_JPRB, 0.17046932E-05_JPRB, 0.17046854E-05_JPRB, 0.17046756E-05_JPRB, 0.17046570E-05_JPRB, &
  & 0.17046304E-05_JPRB, 0.17046627E-05_JPRB, 0.17046552E-05_JPRB, 0.17046652E-05_JPRB, 0.17046908E-05_JPRB, 0.17047152E-05_JPRB, &
  & 0.17047750E-05_JPRB, 0.17047784E-05_JPRB, 0.17047400E-05_JPRB, 0.17047895E-05_JPRB, 0.17048234E-05_JPRB, 0.17049804E-05_JPRB, &
  & 0.17053261E-05_JPRB, 0.17055046E-05_JPRB, 0.17052437E-05_JPRB, 0.17048569E-05_JPRB, 0.17042410E-05_JPRB, 0.17034403E-05_JPRB, &
  & 0.17023093E-05_JPRB, 0.17009940E-05_JPRB, 0.17000422E-05_JPRB, 0.17001540E-05_JPRB, 0.17019515E-05_JPRB, 0.17027297E-05_JPRB, &
  & 0.17036175E-05_JPRB, 0.17037791E-05_JPRB, 0.17044838E-05_JPRB, 0.17044800E-05_JPRB, 0.17070826E-05_JPRB, 0.17143849E-05_JPRB, &
  & 0.17181899E-05_JPRB, 0.17203297E-05_JPRB, 0.17233378E-05_JPRB, 0.17275995E-05_JPRB, 0.17361793E-05_JPRB, 0.17467755E-05_JPRB, &
  & 0.17551286E-05_JPRB, 0.17605453E-05_JPRB, 0.17640111E-05_JPRB, 0.17723487E-05_JPRB, 0.17815059E-05_JPRB, 0.17886500E-05_JPRB, &
  & 0.17945815E-05_JPRB, 0.17988760E-05_JPRB, 0.18013021E-05_JPRB, 0.18011982E-05_JPRB, 0.17997229E-05_JPRB, 0.17985159E-05_JPRB, &
  & 0.17980661E-05_JPRB, 0.17970836E-05_JPRB, 0.17939975E-05_JPRB, 0.17915599E-05_JPRB, 0.17894492E-05_JPRB, 0.17889323E-05_JPRB, &
  & 0.17864125E-05_JPRB, 0.17834654E-05_JPRB, 0.17780381E-05_JPRB, 0.17754165E-05_JPRB  /)

RGHG2(:,78, 8) = (/ &
  & 0.17047986E-05_JPRB, 0.17047641E-05_JPRB, 0.17047114E-05_JPRB, 0.17047024E-05_JPRB, 0.17046949E-05_JPRB, 0.17046800E-05_JPRB, &
  & 0.17046480E-05_JPRB, 0.17046850E-05_JPRB, 0.17046840E-05_JPRB, 0.17046898E-05_JPRB, 0.17047242E-05_JPRB, 0.17047473E-05_JPRB, &
  & 0.17048236E-05_JPRB, 0.17048341E-05_JPRB, 0.17047987E-05_JPRB, 0.17048553E-05_JPRB, 0.17048938E-05_JPRB, 0.17050568E-05_JPRB, &
  & 0.17054404E-05_JPRB, 0.17056537E-05_JPRB, 0.17054296E-05_JPRB, 0.17050664E-05_JPRB, 0.17044478E-05_JPRB, 0.17036673E-05_JPRB, &
  & 0.17025359E-05_JPRB, 0.17012811E-05_JPRB, 0.17003576E-05_JPRB, 0.17004038E-05_JPRB, 0.17020500E-05_JPRB, 0.17025597E-05_JPRB, &
  & 0.17035540E-05_JPRB, 0.17036901E-05_JPRB, 0.17042320E-05_JPRB, 0.17043135E-05_JPRB, 0.17070369E-05_JPRB, 0.17146308E-05_JPRB, &
  & 0.17189974E-05_JPRB, 0.17215284E-05_JPRB, 0.17244426E-05_JPRB, 0.17285802E-05_JPRB, 0.17375067E-05_JPRB, 0.17487808E-05_JPRB, &
  & 0.17572196E-05_JPRB, 0.17626280E-05_JPRB, 0.17660197E-05_JPRB, 0.17745809E-05_JPRB, 0.17838675E-05_JPRB, 0.17910307E-05_JPRB, &
  & 0.17966867E-05_JPRB, 0.18009683E-05_JPRB, 0.18032520E-05_JPRB, 0.18029001E-05_JPRB, 0.18010234E-05_JPRB, 0.17995730E-05_JPRB, &
  & 0.17991200E-05_JPRB, 0.17981680E-05_JPRB, 0.17943699E-05_JPRB, 0.17917710E-05_JPRB, 0.17893708E-05_JPRB, 0.17886900E-05_JPRB, &
  & 0.17859758E-05_JPRB, 0.17828177E-05_JPRB, 0.17769691E-05_JPRB, 0.17745664E-05_JPRB  /)

RGHG2(:,79, 8) = (/ &
  & 0.17048192E-05_JPRB, 0.17047786E-05_JPRB, 0.17047267E-05_JPRB, 0.17047172E-05_JPRB, 0.17047139E-05_JPRB, 0.17047059E-05_JPRB, &
  & 0.17046673E-05_JPRB, 0.17047084E-05_JPRB, 0.17047157E-05_JPRB, 0.17047198E-05_JPRB, 0.17047597E-05_JPRB, 0.17047824E-05_JPRB, &
  & 0.17048708E-05_JPRB, 0.17048895E-05_JPRB, 0.17048578E-05_JPRB, 0.17049211E-05_JPRB, 0.17049683E-05_JPRB, 0.17051329E-05_JPRB, &
  & 0.17055527E-05_JPRB, 0.17057977E-05_JPRB, 0.17056187E-05_JPRB, 0.17052599E-05_JPRB, 0.17046271E-05_JPRB, 0.17038502E-05_JPRB, &
  & 0.17027476E-05_JPRB, 0.17015467E-05_JPRB, 0.17006686E-05_JPRB, 0.17006803E-05_JPRB, 0.17021760E-05_JPRB, 0.17023811E-05_JPRB, &
  & 0.17035069E-05_JPRB, 0.17036850E-05_JPRB, 0.17040634E-05_JPRB, 0.17042364E-05_JPRB, 0.17070711E-05_JPRB, 0.17148888E-05_JPRB, &
  & 0.17197386E-05_JPRB, 0.17225956E-05_JPRB, 0.17255323E-05_JPRB, 0.17295619E-05_JPRB, 0.17388267E-05_JPRB, 0.17507329E-05_JPRB, &
  & 0.17591878E-05_JPRB, 0.17645433E-05_JPRB, 0.17678685E-05_JPRB, 0.17766070E-05_JPRB, 0.17859342E-05_JPRB, 0.17930408E-05_JPRB, &
  & 0.17983924E-05_JPRB, 0.18026890E-05_JPRB, 0.18048003E-05_JPRB, 0.18042665E-05_JPRB, 0.18020659E-05_JPRB, 0.18003907E-05_JPRB, &
  & 0.17999898E-05_JPRB, 0.17990752E-05_JPRB, 0.17947217E-05_JPRB, 0.17919511E-05_JPRB, 0.17892517E-05_JPRB, 0.17883379E-05_JPRB, &
  & 0.17855643E-05_JPRB, 0.17822216E-05_JPRB, 0.17761034E-05_JPRB, 0.17739221E-05_JPRB  /)

RGHG2(:,80, 8) = (/ &
  & 0.17048370E-05_JPRB, 0.17047877E-05_JPRB, 0.17047382E-05_JPRB, 0.17047300E-05_JPRB, 0.17047315E-05_JPRB, 0.17047347E-05_JPRB, &
  & 0.17046886E-05_JPRB, 0.17047347E-05_JPRB, 0.17047493E-05_JPRB, 0.17047559E-05_JPRB, 0.17047972E-05_JPRB, 0.17048186E-05_JPRB, &
  & 0.17049154E-05_JPRB, 0.17049466E-05_JPRB, 0.17049186E-05_JPRB, 0.17049892E-05_JPRB, 0.17050453E-05_JPRB, 0.17052147E-05_JPRB, &
  & 0.17056653E-05_JPRB, 0.17059401E-05_JPRB, 0.17057933E-05_JPRB, 0.17054247E-05_JPRB, 0.17047797E-05_JPRB, 0.17039978E-05_JPRB, &
  & 0.17029324E-05_JPRB, 0.17017697E-05_JPRB, 0.17009506E-05_JPRB, 0.17009469E-05_JPRB, 0.17023222E-05_JPRB, 0.17021969E-05_JPRB, &
  & 0.17034774E-05_JPRB, 0.17037341E-05_JPRB, 0.17040644E-05_JPRB, 0.17042577E-05_JPRB, 0.17071700E-05_JPRB, 0.17151663E-05_JPRB, &
  & 0.17204272E-05_JPRB, 0.17235282E-05_JPRB, 0.17265812E-05_JPRB, 0.17305218E-05_JPRB, 0.17400679E-05_JPRB, 0.17525964E-05_JPRB, &
  & 0.17609775E-05_JPRB, 0.17663285E-05_JPRB, 0.17695874E-05_JPRB, 0.17783890E-05_JPRB, 0.17877220E-05_JPRB, 0.17947181E-05_JPRB, &
  & 0.17996957E-05_JPRB, 0.18040233E-05_JPRB, 0.18059819E-05_JPRB, 0.18053479E-05_JPRB, 0.18029083E-05_JPRB, 0.18010358E-05_JPRB, &
  & 0.18006788E-05_JPRB, 0.17997419E-05_JPRB, 0.17950807E-05_JPRB, 0.17920689E-05_JPRB, 0.17891188E-05_JPRB, 0.17879785E-05_JPRB, &
  & 0.17851461E-05_JPRB, 0.17816732E-05_JPRB, 0.17754290E-05_JPRB, 0.17733289E-05_JPRB  /)

RGHG2(:,81, 8) = (/ &
  & 0.17048474E-05_JPRB, 0.17047905E-05_JPRB, 0.17047448E-05_JPRB, 0.17047391E-05_JPRB, 0.17047471E-05_JPRB, 0.17047642E-05_JPRB, &
  & 0.17047169E-05_JPRB, 0.17047629E-05_JPRB, 0.17047941E-05_JPRB, 0.17047957E-05_JPRB, 0.17048280E-05_JPRB, 0.17048494E-05_JPRB, &
  & 0.17049704E-05_JPRB, 0.17050080E-05_JPRB, 0.17049813E-05_JPRB, 0.17050672E-05_JPRB, 0.17051194E-05_JPRB, 0.17053002E-05_JPRB, &
  & 0.17057890E-05_JPRB, 0.17060715E-05_JPRB, 0.17059464E-05_JPRB, 0.17055638E-05_JPRB, 0.17048984E-05_JPRB, 0.17041089E-05_JPRB, &
  & 0.17030702E-05_JPRB, 0.17019508E-05_JPRB, 0.17012106E-05_JPRB, 0.17012401E-05_JPRB, 0.17025517E-05_JPRB, 0.17021692E-05_JPRB, &
  & 0.17034751E-05_JPRB, 0.17037394E-05_JPRB, 0.17041156E-05_JPRB, 0.17043916E-05_JPRB, 0.17072874E-05_JPRB, 0.17154900E-05_JPRB, &
  & 0.17210527E-05_JPRB, 0.17243244E-05_JPRB, 0.17275621E-05_JPRB, 0.17315371E-05_JPRB, 0.17413646E-05_JPRB, 0.17544917E-05_JPRB, &
  & 0.17625697E-05_JPRB, 0.17679806E-05_JPRB, 0.17711541E-05_JPRB, 0.17799952E-05_JPRB, 0.17892633E-05_JPRB, 0.17960046E-05_JPRB, &
  & 0.18006104E-05_JPRB, 0.18049596E-05_JPRB, 0.18069462E-05_JPRB, 0.18063275E-05_JPRB, 0.18036128E-05_JPRB, 0.18015302E-05_JPRB, &
  & 0.18011579E-05_JPRB, 0.18001063E-05_JPRB, 0.17953789E-05_JPRB, 0.17921685E-05_JPRB, 0.17890936E-05_JPRB, 0.17877737E-05_JPRB, &
  & 0.17847465E-05_JPRB, 0.17810952E-05_JPRB, 0.17747338E-05_JPRB, 0.17727318E-05_JPRB  /)

RGHG2(:,82, 8) = (/ &
  & 0.17048435E-05_JPRB, 0.17047869E-05_JPRB, 0.17047469E-05_JPRB, 0.17047454E-05_JPRB, 0.17047597E-05_JPRB, 0.17047960E-05_JPRB, &
  & 0.17047500E-05_JPRB, 0.17047970E-05_JPRB, 0.17048446E-05_JPRB, 0.17048315E-05_JPRB, 0.17048523E-05_JPRB, 0.17048790E-05_JPRB, &
  & 0.17050170E-05_JPRB, 0.17050609E-05_JPRB, 0.17050451E-05_JPRB, 0.17051365E-05_JPRB, 0.17051946E-05_JPRB, 0.17053877E-05_JPRB, &
  & 0.17059084E-05_JPRB, 0.17061782E-05_JPRB, 0.17060825E-05_JPRB, 0.17056930E-05_JPRB, 0.17050100E-05_JPRB, 0.17042129E-05_JPRB, &
  & 0.17031885E-05_JPRB, 0.17021060E-05_JPRB, 0.17014346E-05_JPRB, 0.17015084E-05_JPRB, 0.17028278E-05_JPRB, 0.17022686E-05_JPRB, &
  & 0.17035516E-05_JPRB, 0.17038262E-05_JPRB, 0.17042356E-05_JPRB, 0.17045579E-05_JPRB, 0.17074398E-05_JPRB, 0.17158396E-05_JPRB, &
  & 0.17216241E-05_JPRB, 0.17250671E-05_JPRB, 0.17284480E-05_JPRB, 0.17324413E-05_JPRB, 0.17425906E-05_JPRB, 0.17562659E-05_JPRB, &
  & 0.17640103E-05_JPRB, 0.17694464E-05_JPRB, 0.17726001E-05_JPRB, 0.17814252E-05_JPRB, 0.17905962E-05_JPRB, 0.17970775E-05_JPRB, &
  & 0.18013137E-05_JPRB, 0.18056792E-05_JPRB, 0.18077735E-05_JPRB, 0.18071963E-05_JPRB, 0.18042478E-05_JPRB, 0.18019581E-05_JPRB, &
  & 0.18015794E-05_JPRB, 0.18004341E-05_JPRB, 0.17956733E-05_JPRB, 0.17923410E-05_JPRB, 0.17891385E-05_JPRB, 0.17876648E-05_JPRB, &
  & 0.17844571E-05_JPRB, 0.17806208E-05_JPRB, 0.17741606E-05_JPRB, 0.17721577E-05_JPRB  /)

RGHG2(:,83, 8) = (/ &
  & 0.17048283E-05_JPRB, 0.17047789E-05_JPRB, 0.17047451E-05_JPRB, 0.17047487E-05_JPRB, 0.17047711E-05_JPRB, 0.17048302E-05_JPRB, &
  & 0.17047877E-05_JPRB, 0.17048369E-05_JPRB, 0.17048999E-05_JPRB, 0.17048655E-05_JPRB, 0.17048719E-05_JPRB, 0.17049046E-05_JPRB, &
  & 0.17050594E-05_JPRB, 0.17051115E-05_JPRB, 0.17051068E-05_JPRB, 0.17052044E-05_JPRB, 0.17052652E-05_JPRB, 0.17054684E-05_JPRB, &
  & 0.17060242E-05_JPRB, 0.17062791E-05_JPRB, 0.17062097E-05_JPRB, 0.17058189E-05_JPRB, 0.17051176E-05_JPRB, 0.17043134E-05_JPRB, &
  & 0.17033013E-05_JPRB, 0.17022438E-05_JPRB, 0.17016234E-05_JPRB, 0.17017601E-05_JPRB, 0.17031749E-05_JPRB, 0.17024717E-05_JPRB, &
  & 0.17037030E-05_JPRB, 0.17039816E-05_JPRB, 0.17044094E-05_JPRB, 0.17047336E-05_JPRB, 0.17076550E-05_JPRB, 0.17162394E-05_JPRB, &
  & 0.17221159E-05_JPRB, 0.17257397E-05_JPRB, 0.17292297E-05_JPRB, 0.17332805E-05_JPRB, 0.17437674E-05_JPRB, 0.17578304E-05_JPRB, &
  & 0.17653108E-05_JPRB, 0.17707701E-05_JPRB, 0.17739277E-05_JPRB, 0.17827020E-05_JPRB, 0.17917660E-05_JPRB, 0.17979736E-05_JPRB, &
  & 0.18018667E-05_JPRB, 0.18062489E-05_JPRB, 0.18084948E-05_JPRB, 0.18079654E-05_JPRB, 0.18048276E-05_JPRB, 0.18023596E-05_JPRB, &
  & 0.18019624E-05_JPRB, 0.18007340E-05_JPRB, 0.17959811E-05_JPRB, 0.17925750E-05_JPRB, 0.17892290E-05_JPRB, 0.17876281E-05_JPRB, &
  & 0.17841977E-05_JPRB, 0.17801977E-05_JPRB, 0.17737390E-05_JPRB, 0.17716436E-05_JPRB  /)

RGHG2(:,84, 8) = (/ &
  & 0.17048050E-05_JPRB, 0.17047681E-05_JPRB, 0.17047404E-05_JPRB, 0.17047488E-05_JPRB, 0.17047827E-05_JPRB, 0.17048667E-05_JPRB, &
  & 0.17048295E-05_JPRB, 0.17048823E-05_JPRB, 0.17049585E-05_JPRB, 0.17048988E-05_JPRB, 0.17048880E-05_JPRB, 0.17049242E-05_JPRB, &
  & 0.17051000E-05_JPRB, 0.17051639E-05_JPRB, 0.17051639E-05_JPRB, 0.17052757E-05_JPRB, 0.17053266E-05_JPRB, 0.17055363E-05_JPRB, &
  & 0.17061376E-05_JPRB, 0.17063901E-05_JPRB, 0.17063358E-05_JPRB, 0.17059472E-05_JPRB, 0.17052249E-05_JPRB, 0.17044156E-05_JPRB, &
  & 0.17034208E-05_JPRB, 0.17023729E-05_JPRB, 0.17017819E-05_JPRB, 0.17020072E-05_JPRB, 0.17036259E-05_JPRB, 0.17027610E-05_JPRB, &
  & 0.17039269E-05_JPRB, 0.17042051E-05_JPRB, 0.17046341E-05_JPRB, 0.17049097E-05_JPRB, 0.17079516E-05_JPRB, 0.17167148E-05_JPRB, &
  & 0.17225212E-05_JPRB, 0.17263370E-05_JPRB, 0.17299081E-05_JPRB, 0.17340912E-05_JPRB, 0.17449268E-05_JPRB, 0.17591661E-05_JPRB, &
  & 0.17664949E-05_JPRB, 0.17719956E-05_JPRB, 0.17751488E-05_JPRB, 0.17838603E-05_JPRB, 0.17928312E-05_JPRB, 0.17987419E-05_JPRB, &
  & 0.18023407E-05_JPRB, 0.18067395E-05_JPRB, 0.18091484E-05_JPRB, 0.18086636E-05_JPRB, 0.18053767E-05_JPRB, 0.18027772E-05_JPRB, &
  & 0.18023307E-05_JPRB, 0.18010205E-05_JPRB, 0.17963164E-05_JPRB, 0.17928554E-05_JPRB, 0.17893465E-05_JPRB, 0.17876507E-05_JPRB, &
  & 0.17839234E-05_JPRB, 0.17797832E-05_JPRB, 0.17734535E-05_JPRB, 0.17712020E-05_JPRB  /)

RGHG2(:,85, 8) = (/ &
  & 0.17047775E-05_JPRB, 0.17047573E-05_JPRB, 0.17047334E-05_JPRB, 0.17047457E-05_JPRB, 0.17047950E-05_JPRB, 0.17049072E-05_JPRB, &
  & 0.17048816E-05_JPRB, 0.17049370E-05_JPRB, 0.17050209E-05_JPRB, 0.17049265E-05_JPRB, 0.17049003E-05_JPRB, 0.17049365E-05_JPRB, &
  & 0.17051328E-05_JPRB, 0.17052198E-05_JPRB, 0.17052198E-05_JPRB, 0.17053560E-05_JPRB, 0.17053787E-05_JPRB, 0.17055973E-05_JPRB, &
  & 0.17062615E-05_JPRB, 0.17065526E-05_JPRB, 0.17064996E-05_JPRB, 0.17061084E-05_JPRB, 0.17053656E-05_JPRB, 0.17045666E-05_JPRB, &
  & 0.17035910E-05_JPRB, 0.17025277E-05_JPRB, 0.17019623E-05_JPRB, 0.17023507E-05_JPRB, 0.17045278E-05_JPRB, 0.17032662E-05_JPRB, &
  & 0.17043295E-05_JPRB, 0.17047167E-05_JPRB, 0.17051072E-05_JPRB, 0.17052301E-05_JPRB, 0.17084042E-05_JPRB, 0.17174807E-05_JPRB, &
  & 0.17229892E-05_JPRB, 0.17269694E-05_JPRB, 0.17305764E-05_JPRB, 0.17349546E-05_JPRB, 0.17464039E-05_JPRB, 0.17609154E-05_JPRB, &
  & 0.17678025E-05_JPRB, 0.17733174E-05_JPRB, 0.17764552E-05_JPRB, 0.17851641E-05_JPRB, 0.17941491E-05_JPRB, 0.17996335E-05_JPRB, &
  & 0.18030436E-05_JPRB, 0.18073911E-05_JPRB, 0.18099463E-05_JPRB, 0.18095861E-05_JPRB, 0.18061143E-05_JPRB, 0.18034301E-05_JPRB, &
  & 0.18028398E-05_JPRB, 0.18014218E-05_JPRB, 0.17967575E-05_JPRB, 0.17931732E-05_JPRB, 0.17895398E-05_JPRB, 0.17878684E-05_JPRB, &
  & 0.17838317E-05_JPRB, 0.17793051E-05_JPRB, 0.17728637E-05_JPRB, 0.17706199E-05_JPRB  /)

RGHG2(:,86, 8) = (/ &
  & 0.17047501E-05_JPRB, 0.17047477E-05_JPRB, 0.17047266E-05_JPRB, 0.17047418E-05_JPRB, 0.17048065E-05_JPRB, 0.17049472E-05_JPRB, &
  & 0.17049382E-05_JPRB, 0.17049942E-05_JPRB, 0.17050798E-05_JPRB, 0.17049435E-05_JPRB, 0.17049079E-05_JPRB, 0.17049461E-05_JPRB, &
  & 0.17051570E-05_JPRB, 0.17052733E-05_JPRB, 0.17052733E-05_JPRB, 0.17054470E-05_JPRB, 0.17054454E-05_JPRB, 0.17056599E-05_JPRB, &
  & 0.17064025E-05_JPRB, 0.17067844E-05_JPRB, 0.17067358E-05_JPRB, 0.17063380E-05_JPRB, 0.17055685E-05_JPRB, 0.17047717E-05_JPRB, &
  & 0.17038527E-05_JPRB, 0.17027217E-05_JPRB, 0.17021821E-05_JPRB, 0.17027977E-05_JPRB, 0.17063347E-05_JPRB, 0.17039742E-05_JPRB, &
  & 0.17049423E-05_JPRB, 0.17054121E-05_JPRB, 0.17061235E-05_JPRB, 0.17056659E-05_JPRB, 0.17090221E-05_JPRB, 0.17185078E-05_JPRB, &
  & 0.17235724E-05_JPRB, 0.17277257E-05_JPRB, 0.17313227E-05_JPRB, 0.17359352E-05_JPRB, 0.17484172E-05_JPRB, 0.17632705E-05_JPRB, &
  & 0.17694043E-05_JPRB, 0.17749123E-05_JPRB, 0.17778919E-05_JPRB, 0.17867630E-05_JPRB, 0.17959441E-05_JPRB, 0.18007470E-05_JPRB, &
  & 0.18040729E-05_JPRB, 0.18083366E-05_JPRB, 0.18110108E-05_JPRB, 0.18108149E-05_JPRB, 0.18070709E-05_JPRB, 0.18043236E-05_JPRB, &
  & 0.18035607E-05_JPRB, 0.18019740E-05_JPRB, 0.17973126E-05_JPRB, 0.17935059E-05_JPRB, 0.17899654E-05_JPRB, 0.17883999E-05_JPRB, &
  & 0.17839668E-05_JPRB, 0.17791372E-05_JPRB, 0.17723375E-05_JPRB, 0.17701597E-05_JPRB  /)

RGHG2(:,87, 8) = (/ &
  & 0.17047275E-05_JPRB, 0.17047394E-05_JPRB, 0.17047210E-05_JPRB, 0.17047388E-05_JPRB, 0.17048206E-05_JPRB, 0.17049847E-05_JPRB, &
  & 0.17049954E-05_JPRB, 0.17050500E-05_JPRB, 0.17051343E-05_JPRB, 0.17049562E-05_JPRB, 0.17049113E-05_JPRB, 0.17049508E-05_JPRB, &
  & 0.17051762E-05_JPRB, 0.17053226E-05_JPRB, 0.17053293E-05_JPRB, 0.17055596E-05_JPRB, 0.17055224E-05_JPRB, 0.17057264E-05_JPRB, &
  & 0.17065608E-05_JPRB, 0.17070998E-05_JPRB, 0.17070363E-05_JPRB, 0.17066373E-05_JPRB, 0.17058457E-05_JPRB, 0.17050382E-05_JPRB, &
  & 0.17042168E-05_JPRB, 0.17029859E-05_JPRB, 0.17024778E-05_JPRB, 0.17034079E-05_JPRB, 0.17091977E-05_JPRB, 0.17050091E-05_JPRB, &
  & 0.17059176E-05_JPRB, 0.17064688E-05_JPRB, 0.17080355E-05_JPRB, 0.17063579E-05_JPRB, 0.17099695E-05_JPRB, 0.17198540E-05_JPRB, &
  & 0.17243322E-05_JPRB, 0.17286637E-05_JPRB, 0.17322277E-05_JPRB, 0.17371013E-05_JPRB, 0.17510893E-05_JPRB, 0.17664487E-05_JPRB, &
  & 0.17715529E-05_JPRB, 0.17770625E-05_JPRB, 0.17796597E-05_JPRB, 0.17888461E-05_JPRB, 0.17984139E-05_JPRB, 0.18021611E-05_JPRB, &
  & 0.18054815E-05_JPRB, 0.18096014E-05_JPRB, 0.18124124E-05_JPRB, 0.18124254E-05_JPRB, 0.18083145E-05_JPRB, 0.18055336E-05_JPRB, &
  & 0.18045538E-05_JPRB, 0.18027249E-05_JPRB, 0.17980128E-05_JPRB, 0.17939747E-05_JPRB, 0.17907184E-05_JPRB, 0.17892733E-05_JPRB, &
  & 0.17844023E-05_JPRB, 0.17792910E-05_JPRB, 0.17719933E-05_JPRB, 0.17698378E-05_JPRB  /)

RGHG2(:,88, 8) = (/ &
  & 0.17047115E-05_JPRB, 0.17047329E-05_JPRB, 0.17047172E-05_JPRB, 0.17047369E-05_JPRB, 0.17048380E-05_JPRB, 0.17050197E-05_JPRB, &
  & 0.17050539E-05_JPRB, 0.17051011E-05_JPRB, 0.17051842E-05_JPRB, 0.17049665E-05_JPRB, 0.17049130E-05_JPRB, 0.17049525E-05_JPRB, &
  & 0.17051927E-05_JPRB, 0.17053694E-05_JPRB, 0.17053890E-05_JPRB, 0.17057045E-05_JPRB, 0.17056139E-05_JPRB, 0.17058113E-05_JPRB, &
  & 0.17067501E-05_JPRB, 0.17075047E-05_JPRB, 0.17074206E-05_JPRB, 0.17070318E-05_JPRB, 0.17062411E-05_JPRB, 0.17054275E-05_JPRB, &
  & 0.17047386E-05_JPRB, 0.17033711E-05_JPRB, 0.17029070E-05_JPRB, 0.17043075E-05_JPRB, 0.17137660E-05_JPRB, 0.17066029E-05_JPRB, &
  & 0.17074468E-05_JPRB, 0.17081676E-05_JPRB, 0.17112575E-05_JPRB, 0.17075818E-05_JPRB, 0.17114959E-05_JPRB, 0.17216471E-05_JPRB, &
  & 0.17254408E-05_JPRB, 0.17298688E-05_JPRB, 0.17333937E-05_JPRB, 0.17386428E-05_JPRB, 0.17546971E-05_JPRB, 0.17709081E-05_JPRB, &
  & 0.17747286E-05_JPRB, 0.17802957E-05_JPRB, 0.17821726E-05_JPRB, 0.17919160E-05_JPRB, 0.18020104E-05_JPRB, 0.18040964E-05_JPRB, &
  & 0.18073801E-05_JPRB, 0.18112964E-05_JPRB, 0.18143262E-05_JPRB, 0.18146049E-05_JPRB, 0.18099844E-05_JPRB, 0.18072037E-05_JPRB, &
  & 0.18059433E-05_JPRB, 0.18038220E-05_JPRB, 0.17989648E-05_JPRB, 0.17946738E-05_JPRB, 0.17918534E-05_JPRB, 0.17904603E-05_JPRB, &
  & 0.17852092E-05_JPRB, 0.17797188E-05_JPRB, 0.17718498E-05_JPRB, 0.17696575E-05_JPRB  /)

RGHG2(:,89, 8) = (/ &
  & 0.17047021E-05_JPRB, 0.17047288E-05_JPRB, 0.17047157E-05_JPRB, 0.17047358E-05_JPRB, 0.17048554E-05_JPRB, 0.17050523E-05_JPRB, &
  & 0.17051164E-05_JPRB, 0.17051393E-05_JPRB, 0.17052260E-05_JPRB, 0.17049736E-05_JPRB, 0.17049169E-05_JPRB, 0.17049564E-05_JPRB, &
  & 0.17052092E-05_JPRB, 0.17054178E-05_JPRB, 0.17054512E-05_JPRB, 0.17058884E-05_JPRB, 0.17057286E-05_JPRB, 0.17059368E-05_JPRB, &
  & 0.17069945E-05_JPRB, 0.17079654E-05_JPRB, 0.17079108E-05_JPRB, 0.17075440E-05_JPRB, 0.17068135E-05_JPRB, 0.17060445E-05_JPRB, &
  & 0.17055642E-05_JPRB, 0.17039356E-05_JPRB, 0.17035360E-05_JPRB, 0.17057255E-05_JPRB, 0.17207377E-05_JPRB, 0.17089527E-05_JPRB, &
  & 0.17096742E-05_JPRB, 0.17107666E-05_JPRB, 0.17159760E-05_JPRB, 0.17096313E-05_JPRB, 0.17137746E-05_JPRB, 0.17240094E-05_JPRB, &
  & 0.17271194E-05_JPRB, 0.17313621E-05_JPRB, 0.17348716E-05_JPRB, 0.17408150E-05_JPRB, 0.17594266E-05_JPRB, 0.17771367E-05_JPRB, &
  & 0.17795878E-05_JPRB, 0.17852825E-05_JPRB, 0.17860562E-05_JPRB, 0.17968357E-05_JPRB, 0.18073857E-05_JPRB, 0.18068771E-05_JPRB, &
  & 0.18098286E-05_JPRB, 0.18135747E-05_JPRB, 0.18169874E-05_JPRB, 0.18175879E-05_JPRB, 0.18122323E-05_JPRB, 0.18095132E-05_JPRB, &
  & 0.18078570E-05_JPRB, 0.18055324E-05_JPRB, 0.18003432E-05_JPRB, 0.17956331E-05_JPRB, 0.17932370E-05_JPRB, 0.17917194E-05_JPRB, &
  & 0.17863351E-05_JPRB, 0.17802276E-05_JPRB, 0.17718219E-05_JPRB, 0.17695984E-05_JPRB  /)

RGHG2(:,90, 8) = (/ &
  & 0.17046983E-05_JPRB, 0.17047279E-05_JPRB, 0.17047146E-05_JPRB, 0.17047377E-05_JPRB, 0.17048663E-05_JPRB, 0.17050845E-05_JPRB, &
  & 0.17051876E-05_JPRB, 0.17051562E-05_JPRB, 0.17052519E-05_JPRB, 0.17049817E-05_JPRB, 0.17049188E-05_JPRB, 0.17049583E-05_JPRB, &
  & 0.17052326E-05_JPRB, 0.17054770E-05_JPRB, 0.17055414E-05_JPRB, 0.17061326E-05_JPRB, 0.17058793E-05_JPRB, 0.17060968E-05_JPRB, &
  & 0.17073556E-05_JPRB, 0.17084517E-05_JPRB, 0.17085152E-05_JPRB, 0.17081616E-05_JPRB, 0.17076022E-05_JPRB, 0.17069327E-05_JPRB, &
  & 0.17072713E-05_JPRB, 0.17047202E-05_JPRB, 0.17044369E-05_JPRB, 0.17081578E-05_JPRB, 0.17289896E-05_JPRB, 0.17116376E-05_JPRB, &
  & 0.17125356E-05_JPRB, 0.17139767E-05_JPRB, 0.17214595E-05_JPRB, 0.17120646E-05_JPRB, 0.17162106E-05_JPRB, 0.17271384E-05_JPRB, &
  & 0.17292775E-05_JPRB, 0.17329705E-05_JPRB, 0.17365551E-05_JPRB, 0.17436947E-05_JPRB, 0.17650396E-05_JPRB, 0.17854024E-05_JPRB, &
  & 0.17866964E-05_JPRB, 0.17922598E-05_JPRB, 0.17919662E-05_JPRB, 0.18048201E-05_JPRB, 0.18153649E-05_JPRB, 0.18109421E-05_JPRB, &
  & 0.18129344E-05_JPRB, 0.18168636E-05_JPRB, 0.18208401E-05_JPRB, 0.18217815E-05_JPRB, 0.18152848E-05_JPRB, 0.18128711E-05_JPRB, &
  & 0.18104565E-05_JPRB, 0.18083668E-05_JPRB, 0.18024190E-05_JPRB, 0.17967684E-05_JPRB, 0.17943922E-05_JPRB, 0.17926381E-05_JPRB, &
  & 0.17873408E-05_JPRB, 0.17806036E-05_JPRB, 0.17718299E-05_JPRB, 0.17695976E-05_JPRB  /)

RGHG2(:,91, 8) = (/ &
  & 0.17047027E-05_JPRB, 0.17047291E-05_JPRB, 0.17047126E-05_JPRB, 0.17047389E-05_JPRB, 0.17048739E-05_JPRB, 0.17051176E-05_JPRB, &
  & 0.17052558E-05_JPRB, 0.17051669E-05_JPRB, 0.17052690E-05_JPRB, 0.17049924E-05_JPRB, 0.17049200E-05_JPRB, 0.17049595E-05_JPRB, &
  & 0.17052657E-05_JPRB, 0.17055324E-05_JPRB, 0.17056575E-05_JPRB, 0.17064115E-05_JPRB, 0.17060592E-05_JPRB, 0.17063884E-05_JPRB, &
  & 0.17080972E-05_JPRB, 0.17091836E-05_JPRB, 0.17093812E-05_JPRB, 0.17089861E-05_JPRB, 0.17088511E-05_JPRB, 0.17077284E-05_JPRB, &
  & 0.17127164E-05_JPRB, 0.17059308E-05_JPRB, 0.17063687E-05_JPRB, 0.17113500E-05_JPRB, 0.17408134E-05_JPRB, 0.17145107E-05_JPRB, &
  & 0.17160054E-05_JPRB, 0.17188665E-05_JPRB, 0.17289148E-05_JPRB, 0.17150078E-05_JPRB, 0.17188731E-05_JPRB, 0.17316804E-05_JPRB, &
  & 0.17310944E-05_JPRB, 0.17347555E-05_JPRB, 0.17383145E-05_JPRB, 0.17465455E-05_JPRB, 0.17714292E-05_JPRB, 0.17983015E-05_JPRB, &
  & 0.17959738E-05_JPRB, 0.18017223E-05_JPRB, 0.18009947E-05_JPRB, 0.18175948E-05_JPRB, 0.18260463E-05_JPRB, 0.18177529E-05_JPRB, &
  & 0.18183093E-05_JPRB, 0.18224873E-05_JPRB, 0.18275839E-05_JPRB, 0.18284136E-05_JPRB, 0.18197151E-05_JPRB, 0.18179109E-05_JPRB, &
  & 0.18151453E-05_JPRB, 0.18131896E-05_JPRB, 0.18053176E-05_JPRB, 0.17980875E-05_JPRB, 0.17953219E-05_JPRB, 0.17933860E-05_JPRB, &
  & 0.17878845E-05_JPRB, 0.17808059E-05_JPRB, 0.17718375E-05_JPRB, 0.17696052E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ---GEMS----

RGHG2(:, 1, 9) = (/ &
  & 0.18281403E-06_JPRB, 0.18263953E-06_JPRB, 0.18268892E-06_JPRB, 0.18280086E-06_JPRB, 0.18286835E-06_JPRB, 0.18295395E-06_JPRB, &
  & 0.18302968E-06_JPRB, 0.18322887E-06_JPRB, 0.18349720E-06_JPRB, 0.18374577E-06_JPRB, 0.18406348E-06_JPRB, 0.18454911E-06_JPRB, &
  & 0.18514997E-06_JPRB, 0.18582984E-06_JPRB, 0.18662989E-06_JPRB, 0.18774600E-06_JPRB, 0.18913703E-06_JPRB, 0.19051653E-06_JPRB, &
  & 0.19181372E-06_JPRB, 0.19316360E-06_JPRB, 0.19454475E-06_JPRB, 0.19578432E-06_JPRB, 0.19691690E-06_JPRB, 0.19786016E-06_JPRB, &
  & 0.19873429E-06_JPRB, 0.19976645E-06_JPRB, 0.20087268E-06_JPRB, 0.20233779E-06_JPRB, 0.20452557E-06_JPRB, 0.20745742E-06_JPRB, &
  & 0.21061645E-06_JPRB, 0.21291947E-06_JPRB, 0.21387755E-06_JPRB, 0.21327833E-06_JPRB, 0.21126999E-06_JPRB, 0.20848629E-06_JPRB, &
  & 0.20527952E-06_JPRB, 0.20174681E-06_JPRB, 0.19812849E-06_JPRB, 0.19462705E-06_JPRB, 0.19134127E-06_JPRB, 0.18838637E-06_JPRB, &
  & 0.18590886E-06_JPRB, 0.18383631E-06_JPRB, 0.18193990E-06_JPRB, 0.17984925E-06_JPRB, 0.17723675E-06_JPRB, 0.17416497E-06_JPRB, &
  & 0.17100923E-06_JPRB, 0.16794733E-06_JPRB, 0.16486896E-06_JPRB, 0.16156342E-06_JPRB, 0.15785127E-06_JPRB, 0.15381977E-06_JPRB, &
  & 0.14971089E-06_JPRB, 0.14561024E-06_JPRB, 0.14175981E-06_JPRB, 0.13817771E-06_JPRB, 0.13437338E-06_JPRB, 0.13078469E-06_JPRB, &
  & 0.12785119E-06_JPRB, 0.12572103E-06_JPRB, 0.12412752E-06_JPRB, 0.12306738E-06_JPRB  /)

RGHG2(:, 2, 9) = (/ &
  & 0.18281403E-06_JPRB, 0.18263953E-06_JPRB, 0.18268892E-06_JPRB, 0.18280086E-06_JPRB, 0.18286835E-06_JPRB, 0.18295395E-06_JPRB, &
  & 0.18302968E-06_JPRB, 0.18322887E-06_JPRB, 0.18349720E-06_JPRB, 0.18374577E-06_JPRB, 0.18406348E-06_JPRB, 0.18454911E-06_JPRB, &
  & 0.18514997E-06_JPRB, 0.18582984E-06_JPRB, 0.18662989E-06_JPRB, 0.18774600E-06_JPRB, 0.18913703E-06_JPRB, 0.19051653E-06_JPRB, &
  & 0.19181372E-06_JPRB, 0.19316360E-06_JPRB, 0.19454475E-06_JPRB, 0.19578432E-06_JPRB, 0.19691690E-06_JPRB, 0.19786016E-06_JPRB, &
  & 0.19873429E-06_JPRB, 0.19976645E-06_JPRB, 0.20087268E-06_JPRB, 0.20233779E-06_JPRB, 0.20452557E-06_JPRB, 0.20745742E-06_JPRB, &
  & 0.21061645E-06_JPRB, 0.21291947E-06_JPRB, 0.21387755E-06_JPRB, 0.21327833E-06_JPRB, 0.21126999E-06_JPRB, 0.20848629E-06_JPRB, &
  & 0.20527952E-06_JPRB, 0.20174681E-06_JPRB, 0.19812849E-06_JPRB, 0.19462705E-06_JPRB, 0.19134127E-06_JPRB, 0.18838637E-06_JPRB, &
  & 0.18590886E-06_JPRB, 0.18383631E-06_JPRB, 0.18193990E-06_JPRB, 0.17984925E-06_JPRB, 0.17723675E-06_JPRB, 0.17416497E-06_JPRB, &
  & 0.17100923E-06_JPRB, 0.16794733E-06_JPRB, 0.16486896E-06_JPRB, 0.16156342E-06_JPRB, 0.15785127E-06_JPRB, 0.15381977E-06_JPRB, &
  & 0.14971089E-06_JPRB, 0.14561024E-06_JPRB, 0.14175981E-06_JPRB, 0.13817771E-06_JPRB, 0.13437338E-06_JPRB, 0.13078469E-06_JPRB, &
  & 0.12785119E-06_JPRB, 0.12572103E-06_JPRB, 0.12412752E-06_JPRB, 0.12306738E-06_JPRB  /)

RGHG2(:, 3, 9) = (/ &
  & 0.18281403E-06_JPRB, 0.18263953E-06_JPRB, 0.18268892E-06_JPRB, 0.18280086E-06_JPRB, 0.18286835E-06_JPRB, 0.18295395E-06_JPRB, &
  & 0.18302968E-06_JPRB, 0.18322887E-06_JPRB, 0.18349720E-06_JPRB, 0.18374577E-06_JPRB, 0.18406348E-06_JPRB, 0.18454911E-06_JPRB, &
  & 0.18514997E-06_JPRB, 0.18582984E-06_JPRB, 0.18662989E-06_JPRB, 0.18774600E-06_JPRB, 0.18913703E-06_JPRB, 0.19051653E-06_JPRB, &
  & 0.19181372E-06_JPRB, 0.19316360E-06_JPRB, 0.19454475E-06_JPRB, 0.19578432E-06_JPRB, 0.19691690E-06_JPRB, 0.19786016E-06_JPRB, &
  & 0.19873429E-06_JPRB, 0.19976645E-06_JPRB, 0.20087268E-06_JPRB, 0.20233779E-06_JPRB, 0.20452557E-06_JPRB, 0.20745742E-06_JPRB, &
  & 0.21061645E-06_JPRB, 0.21291947E-06_JPRB, 0.21387755E-06_JPRB, 0.21327833E-06_JPRB, 0.21126999E-06_JPRB, 0.20848629E-06_JPRB, &
  & 0.20527952E-06_JPRB, 0.20174681E-06_JPRB, 0.19812849E-06_JPRB, 0.19462705E-06_JPRB, 0.19134127E-06_JPRB, 0.18838637E-06_JPRB, &
  & 0.18590886E-06_JPRB, 0.18383631E-06_JPRB, 0.18193990E-06_JPRB, 0.17984925E-06_JPRB, 0.17723675E-06_JPRB, 0.17416497E-06_JPRB, &
  & 0.17100923E-06_JPRB, 0.16794733E-06_JPRB, 0.16486896E-06_JPRB, 0.16156342E-06_JPRB, 0.15785127E-06_JPRB, 0.15381977E-06_JPRB, &
  & 0.14971089E-06_JPRB, 0.14561024E-06_JPRB, 0.14175981E-06_JPRB, 0.13817771E-06_JPRB, 0.13437338E-06_JPRB, 0.13078469E-06_JPRB, &
  & 0.12785119E-06_JPRB, 0.12572103E-06_JPRB, 0.12412752E-06_JPRB, 0.12306738E-06_JPRB  /)

RGHG2(:, 4, 9) = (/ &
  & 0.18282046E-06_JPRB, 0.18264785E-06_JPRB, 0.18269727E-06_JPRB, 0.18280894E-06_JPRB, 0.18287743E-06_JPRB, 0.18296340E-06_JPRB, &
  & 0.18303897E-06_JPRB, 0.18323764E-06_JPRB, 0.18350561E-06_JPRB, 0.18375407E-06_JPRB, 0.18407121E-06_JPRB, 0.18455619E-06_JPRB, &
  & 0.18515638E-06_JPRB, 0.18583512E-06_JPRB, 0.18663390E-06_JPRB, 0.18774843E-06_JPRB, 0.18913756E-06_JPRB, 0.19051642E-06_JPRB, &
  & 0.19181365E-06_JPRB, 0.19316359E-06_JPRB, 0.19454481E-06_JPRB, 0.19578542E-06_JPRB, 0.19691967E-06_JPRB, 0.19786750E-06_JPRB, &
  & 0.19874827E-06_JPRB, 0.19978684E-06_JPRB, 0.20090051E-06_JPRB, 0.20237373E-06_JPRB, 0.20456813E-06_JPRB, 0.20750407E-06_JPRB, &
  & 0.21066702E-06_JPRB, 0.21297869E-06_JPRB, 0.21394975E-06_JPRB, 0.21336348E-06_JPRB, 0.21136456E-06_JPRB, 0.20858551E-06_JPRB, &
  & 0.20537894E-06_JPRB, 0.20184281E-06_JPRB, 0.19821810E-06_JPRB, 0.19470875E-06_JPRB, 0.19141362E-06_JPRB, 0.18845077E-06_JPRB, &
  & 0.18596758E-06_JPRB, 0.18388984E-06_JPRB, 0.18198664E-06_JPRB, 0.17988926E-06_JPRB, 0.17727200E-06_JPRB, 0.17419694E-06_JPRB, &
  & 0.17103904E-06_JPRB, 0.16797664E-06_JPRB, 0.16489812E-06_JPRB, 0.16159123E-06_JPRB, 0.15787598E-06_JPRB, 0.15384324E-06_JPRB, &
  & 0.14973460E-06_JPRB, 0.14563375E-06_JPRB, 0.14177938E-06_JPRB, 0.13818884E-06_JPRB, 0.13437832E-06_JPRB, 0.13078308E-06_JPRB, &
  & 0.12784113E-06_JPRB, 0.12570180E-06_JPRB, 0.12410051E-06_JPRB, 0.12303592E-06_JPRB  /)

RGHG2(:, 5, 9) = (/ &
  & 0.18312591E-06_JPRB, 0.18304284E-06_JPRB, 0.18309345E-06_JPRB, 0.18319251E-06_JPRB, 0.18330847E-06_JPRB, 0.18341187E-06_JPRB, &
  & 0.18348023E-06_JPRB, 0.18365426E-06_JPRB, 0.18390480E-06_JPRB, 0.18414785E-06_JPRB, 0.18443795E-06_JPRB, 0.18489228E-06_JPRB, &
  & 0.18546062E-06_JPRB, 0.18608589E-06_JPRB, 0.18682458E-06_JPRB, 0.18786400E-06_JPRB, 0.18916299E-06_JPRB, 0.19051120E-06_JPRB, &
  & 0.19181023E-06_JPRB, 0.19316317E-06_JPRB, 0.19454800E-06_JPRB, 0.19583728E-06_JPRB, 0.19705146E-06_JPRB, 0.19821561E-06_JPRB, &
  & 0.19941186E-06_JPRB, 0.20075509E-06_JPRB, 0.20222150E-06_JPRB, 0.20407990E-06_JPRB, 0.20658857E-06_JPRB, 0.20971800E-06_JPRB, &
  & 0.21306723E-06_JPRB, 0.21578993E-06_JPRB, 0.21737691E-06_JPRB, 0.21740477E-06_JPRB, 0.21585353E-06_JPRB, 0.21329501E-06_JPRB, &
  & 0.21009806E-06_JPRB, 0.20639968E-06_JPRB, 0.20247152E-06_JPRB, 0.19858660E-06_JPRB, 0.19484800E-06_JPRB, 0.19150778E-06_JPRB, &
  & 0.18875478E-06_JPRB, 0.18643067E-06_JPRB, 0.18420477E-06_JPRB, 0.18178831E-06_JPRB, 0.17894512E-06_JPRB, 0.17571442E-06_JPRB, &
  & 0.17245376E-06_JPRB, 0.16936793E-06_JPRB, 0.16628220E-06_JPRB, 0.16291101E-06_JPRB, 0.15904854E-06_JPRB, 0.15495751E-06_JPRB, &
  & 0.15086029E-06_JPRB, 0.14674983E-06_JPRB, 0.14270797E-06_JPRB, 0.13871723E-06_JPRB, 0.13461286E-06_JPRB, 0.13070635E-06_JPRB, &
  & 0.12736360E-06_JPRB, 0.12478921E-06_JPRB, 0.12281836E-06_JPRB, 0.12154285E-06_JPRB  /)

RGHG2(:, 6, 9) = (/ &
  & 0.18358419E-06_JPRB, 0.18363545E-06_JPRB, 0.18368787E-06_JPRB, 0.18376799E-06_JPRB, 0.18395518E-06_JPRB, 0.18408472E-06_JPRB, &
  & 0.18414226E-06_JPRB, 0.18427933E-06_JPRB, 0.18450372E-06_JPRB, 0.18473866E-06_JPRB, 0.18498819E-06_JPRB, 0.18539654E-06_JPRB, &
  & 0.18591710E-06_JPRB, 0.18646213E-06_JPRB, 0.18711066E-06_JPRB, 0.18803738E-06_JPRB, 0.18920114E-06_JPRB, 0.19050337E-06_JPRB, &
  & 0.19180511E-06_JPRB, 0.19316255E-06_JPRB, 0.19455279E-06_JPRB, 0.19591510E-06_JPRB, 0.19724919E-06_JPRB, 0.19873790E-06_JPRB, &
  & 0.20040747E-06_JPRB, 0.20220781E-06_JPRB, 0.20420343E-06_JPRB, 0.20663974E-06_JPRB, 0.20961994E-06_JPRB, 0.21303967E-06_JPRB, &
  & 0.21666839E-06_JPRB, 0.22000776E-06_JPRB, 0.22251886E-06_JPRB, 0.22346812E-06_JPRB, 0.22258856E-06_JPRB, 0.22036091E-06_JPRB, &
  & 0.21717839E-06_JPRB, 0.21323658E-06_JPRB, 0.20885312E-06_JPRB, 0.20440472E-06_JPRB, 0.20000077E-06_JPRB, 0.19609436E-06_JPRB, &
  & 0.19293655E-06_JPRB, 0.19024279E-06_JPRB, 0.18753276E-06_JPRB, 0.18463756E-06_JPRB, 0.18145537E-06_JPRB, 0.17799117E-06_JPRB, &
  & 0.17457635E-06_JPRB, 0.17145535E-06_JPRB, 0.16835880E-06_JPRB, 0.16489114E-06_JPRB, 0.16080778E-06_JPRB, 0.15662931E-06_JPRB, &
  & 0.15254922E-06_JPRB, 0.14842433E-06_JPRB, 0.14410118E-06_JPRB, 0.13950999E-06_JPRB, 0.13496476E-06_JPRB, 0.13059123E-06_JPRB, &
  & 0.12664713E-06_JPRB, 0.12342000E-06_JPRB, 0.12089469E-06_JPRB, 0.11930273E-06_JPRB  /)

RGHG2(:, 7, 9) = (/ &
  & 0.18370532E-06_JPRB, 0.18391498E-06_JPRB, 0.18403555E-06_JPRB, 0.18421475E-06_JPRB, 0.18449253E-06_JPRB, 0.18474211E-06_JPRB, &
  & 0.18495443E-06_JPRB, 0.18521162E-06_JPRB, 0.18551656E-06_JPRB, 0.18582644E-06_JPRB, 0.18610299E-06_JPRB, 0.18653963E-06_JPRB, &
  & 0.18709439E-06_JPRB, 0.18760101E-06_JPRB, 0.18820352E-06_JPRB, 0.18906551E-06_JPRB, 0.19006663E-06_JPRB, 0.19127269E-06_JPRB, &
  & 0.19258408E-06_JPRB, 0.19388766E-06_JPRB, 0.19525709E-06_JPRB, 0.19656211E-06_JPRB, 0.19780151E-06_JPRB, 0.19918619E-06_JPRB, &
  & 0.20095953E-06_JPRB, 0.20331595E-06_JPRB, 0.20640171E-06_JPRB, 0.21033024E-06_JPRB, 0.21505773E-06_JPRB, 0.22020767E-06_JPRB, &
  & 0.22552800E-06_JPRB, 0.23085692E-06_JPRB, 0.23548454E-06_JPRB, 0.23835552E-06_JPRB, 0.23885631E-06_JPRB, 0.23724252E-06_JPRB, &
  & 0.23424107E-06_JPRB, 0.23020217E-06_JPRB, 0.22536885E-06_JPRB, 0.21996008E-06_JPRB, 0.21406456E-06_JPRB, 0.20857094E-06_JPRB, &
  & 0.20376400E-06_JPRB, 0.19951366E-06_JPRB, 0.19561100E-06_JPRB, 0.19186959E-06_JPRB, 0.18806517E-06_JPRB, 0.18414837E-06_JPRB, &
  & 0.18021327E-06_JPRB, 0.17659238E-06_JPRB, 0.17308074E-06_JPRB, 0.16906519E-06_JPRB, 0.16419470E-06_JPRB, 0.15933284E-06_JPRB, &
  & 0.15480160E-06_JPRB, 0.15027858E-06_JPRB, 0.14542594E-06_JPRB, 0.14024550E-06_JPRB, 0.13510951E-06_JPRB, 0.13015172E-06_JPRB, &
  & 0.12557606E-06_JPRB, 0.12163070E-06_JPRB, 0.11842097E-06_JPRB, 0.11644047E-06_JPRB  /)

RGHG2(:, 8, 9) = (/ &
  & 0.18376621E-06_JPRB, 0.18403990E-06_JPRB, 0.18431276E-06_JPRB, 0.18463787E-06_JPRB, 0.18516754E-06_JPRB, 0.18577094E-06_JPRB, &
  & 0.18638347E-06_JPRB, 0.18701936E-06_JPRB, 0.18771399E-06_JPRB, 0.18843985E-06_JPRB, 0.18906481E-06_JPRB, 0.18982135E-06_JPRB, &
  & 0.19061941E-06_JPRB, 0.19129735E-06_JPRB, 0.19209424E-06_JPRB, 0.19305361E-06_JPRB, 0.19388710E-06_JPRB, 0.19498590E-06_JPRB, &
  & 0.19613778E-06_JPRB, 0.19730454E-06_JPRB, 0.19877699E-06_JPRB, 0.20014089E-06_JPRB, 0.20112114E-06_JPRB, 0.20205665E-06_JPRB, &
  & 0.20348815E-06_JPRB, 0.20618163E-06_JPRB, 0.21065937E-06_JPRB, 0.21704679E-06_JPRB, 0.22495473E-06_JPRB, 0.23347805E-06_JPRB, &
  & 0.24221645E-06_JPRB, 0.25117534E-06_JPRB, 0.25929645E-06_JPRB, 0.26506685E-06_JPRB, 0.26773408E-06_JPRB, 0.26747115E-06_JPRB, &
  & 0.26517793E-06_JPRB, 0.26142914E-06_JPRB, 0.25624948E-06_JPRB, 0.24949098E-06_JPRB, 0.24124720E-06_JPRB, 0.23280836E-06_JPRB, &
  & 0.22472091E-06_JPRB, 0.21734218E-06_JPRB, 0.21100954E-06_JPRB, 0.20543675E-06_JPRB, 0.20018346E-06_JPRB, 0.19528516E-06_JPRB, &
  & 0.19042808E-06_JPRB, 0.18567888E-06_JPRB, 0.18101930E-06_JPRB, 0.17583710E-06_JPRB, 0.16980251E-06_JPRB, 0.16389113E-06_JPRB, &
  & 0.15858939E-06_JPRB, 0.15322635E-06_JPRB, 0.14749149E-06_JPRB, 0.14149367E-06_JPRB, 0.13551805E-06_JPRB, 0.12974911E-06_JPRB, &
  & 0.12441998E-06_JPRB, 0.11958437E-06_JPRB, 0.11562551E-06_JPRB, 0.11326538E-06_JPRB  /)

RGHG2(:, 9, 9) = (/ &
  & 0.18394262E-06_JPRB, 0.18419760E-06_JPRB, 0.18467962E-06_JPRB, 0.18526230E-06_JPRB, 0.18631771E-06_JPRB, 0.18763951E-06_JPRB, &
  & 0.18902727E-06_JPRB, 0.19050141E-06_JPRB, 0.19224300E-06_JPRB, 0.19404777E-06_JPRB, 0.19565827E-06_JPRB, 0.19726787E-06_JPRB, &
  & 0.19879413E-06_JPRB, 0.20017664E-06_JPRB, 0.20156307E-06_JPRB, 0.20303996E-06_JPRB, 0.20396334E-06_JPRB, 0.20482581E-06_JPRB, &
  & 0.20544298E-06_JPRB, 0.20635249E-06_JPRB, 0.20798003E-06_JPRB, 0.20980160E-06_JPRB, 0.21094755E-06_JPRB, 0.21152652E-06_JPRB, &
  & 0.21234738E-06_JPRB, 0.21482432E-06_JPRB, 0.22092330E-06_JPRB, 0.23119573E-06_JPRB, 0.24426236E-06_JPRB, 0.25849309E-06_JPRB, &
  & 0.27296302E-06_JPRB, 0.28741040E-06_JPRB, 0.30038862E-06_JPRB, 0.30975845E-06_JPRB, 0.31498582E-06_JPRB, 0.31671076E-06_JPRB, &
  & 0.31582626E-06_JPRB, 0.31282443E-06_JPRB, 0.30709705E-06_JPRB, 0.29829320E-06_JPRB, 0.28674348E-06_JPRB, 0.27378905E-06_JPRB, &
  & 0.26033198E-06_JPRB, 0.24761892E-06_JPRB, 0.23694241E-06_JPRB, 0.22783011E-06_JPRB, 0.21961618E-06_JPRB, 0.21232878E-06_JPRB, &
  & 0.20527207E-06_JPRB, 0.19873678E-06_JPRB, 0.19257215E-06_JPRB, 0.18561317E-06_JPRB, 0.17814098E-06_JPRB, 0.17123965E-06_JPRB, &
  & 0.16509518E-06_JPRB, 0.15846917E-06_JPRB, 0.15142095E-06_JPRB, 0.14429936E-06_JPRB, 0.13717429E-06_JPRB, 0.13031986E-06_JPRB, &
  & 0.12407522E-06_JPRB, 0.11822888E-06_JPRB, 0.11343775E-06_JPRB, 0.11073434E-06_JPRB  /)

RGHG2(:,10, 9) = (/ &
  & 0.18477400E-06_JPRB, 0.18505115E-06_JPRB, 0.18575067E-06_JPRB, 0.18686809E-06_JPRB, 0.18868837E-06_JPRB, 0.19118172E-06_JPRB, &
  & 0.19376837E-06_JPRB, 0.19674029E-06_JPRB, 0.20048059E-06_JPRB, 0.20422540E-06_JPRB, 0.20758330E-06_JPRB, 0.21079752E-06_JPRB, &
  & 0.21403137E-06_JPRB, 0.21716046E-06_JPRB, 0.21989516E-06_JPRB, 0.22231125E-06_JPRB, 0.22370881E-06_JPRB, 0.22417679E-06_JPRB, &
  & 0.22395778E-06_JPRB, 0.22432186E-06_JPRB, 0.22580954E-06_JPRB, 0.22841646E-06_JPRB, 0.23086295E-06_JPRB, 0.23209432E-06_JPRB, &
  & 0.23296994E-06_JPRB, 0.23513679E-06_JPRB, 0.24334360E-06_JPRB, 0.25984281E-06_JPRB, 0.28110700E-06_JPRB, 0.30387138E-06_JPRB, &
  & 0.32615722E-06_JPRB, 0.34730441E-06_JPRB, 0.36560049E-06_JPRB, 0.37854168E-06_JPRB, 0.38576998E-06_JPRB, 0.38913198E-06_JPRB, &
  & 0.38952601E-06_JPRB, 0.38638564E-06_JPRB, 0.37840515E-06_JPRB, 0.36598313E-06_JPRB, 0.35023429E-06_JPRB, 0.33204304E-06_JPRB, &
  & 0.31170401E-06_JPRB, 0.29172143E-06_JPRB, 0.27426538E-06_JPRB, 0.25923799E-06_JPRB, 0.24577314E-06_JPRB, 0.23361513E-06_JPRB, &
  & 0.22185944E-06_JPRB, 0.21349944E-06_JPRB, 0.20654789E-06_JPRB, 0.19774148E-06_JPRB, 0.18920101E-06_JPRB, 0.18229575E-06_JPRB, &
  & 0.17576287E-06_JPRB, 0.16778884E-06_JPRB, 0.15909831E-06_JPRB, 0.15060943E-06_JPRB, 0.14219770E-06_JPRB, 0.13408740E-06_JPRB, &
  & 0.12673005E-06_JPRB, 0.11987438E-06_JPRB, 0.11395814E-06_JPRB, 0.11060402E-06_JPRB  /)

RGHG2(:,11, 9) = (/ &
  & 0.18699250E-06_JPRB, 0.18744450E-06_JPRB, 0.18843491E-06_JPRB, 0.19032915E-06_JPRB, 0.19307019E-06_JPRB, 0.19701052E-06_JPRB, &
  & 0.20124989E-06_JPRB, 0.20658102E-06_JPRB, 0.21312698E-06_JPRB, 0.21951013E-06_JPRB, 0.22546587E-06_JPRB, 0.23135871E-06_JPRB, &
  & 0.23762102E-06_JPRB, 0.24380432E-06_JPRB, 0.24895763E-06_JPRB, 0.25221757E-06_JPRB, 0.25404467E-06_JPRB, 0.25434099E-06_JPRB, &
  & 0.25364678E-06_JPRB, 0.25306345E-06_JPRB, 0.25383207E-06_JPRB, 0.25649433E-06_JPRB, 0.26013922E-06_JPRB, 0.26291239E-06_JPRB, &
  & 0.26569400E-06_JPRB, 0.26957306E-06_JPRB, 0.28155699E-06_JPRB, 0.30728532E-06_JPRB, 0.34146996E-06_JPRB, 0.37605567E-06_JPRB, &
  & 0.40678774E-06_JPRB, 0.43407145E-06_JPRB, 0.45652989E-06_JPRB, 0.47211247E-06_JPRB, 0.48056569E-06_JPRB, 0.48451697E-06_JPRB, &
  & 0.48383211E-06_JPRB, 0.47658888E-06_JPRB, 0.46260066E-06_JPRB, 0.44419378E-06_JPRB, 0.42366965E-06_JPRB, 0.40096298E-06_JPRB, &
  & 0.37424243E-06_JPRB, 0.34662684E-06_JPRB, 0.31991810E-06_JPRB, 0.29623781E-06_JPRB, 0.27482359E-06_JPRB, 0.25547373E-06_JPRB, &
  & 0.23778759E-06_JPRB, 0.22860076E-06_JPRB, 0.22137683E-06_JPRB, 0.21176498E-06_JPRB, 0.20372489E-06_JPRB, 0.19795776E-06_JPRB, &
  & 0.19157549E-06_JPRB, 0.18250204E-06_JPRB, 0.17218992E-06_JPRB, 0.16244343E-06_JPRB, 0.15301470E-06_JPRB, 0.14366060E-06_JPRB, &
  & 0.13494925E-06_JPRB, 0.12691109E-06_JPRB, 0.11986032E-06_JPRB, 0.11554937E-06_JPRB  /)

RGHG2(:,12, 9) = (/ &
  & 0.19047406E-06_JPRB, 0.19144366E-06_JPRB, 0.19297785E-06_JPRB, 0.19568167E-06_JPRB, 0.19950075E-06_JPRB, 0.20468418E-06_JPRB, &
  & 0.21129091E-06_JPRB, 0.21976091E-06_JPRB, 0.22949086E-06_JPRB, 0.23933024E-06_JPRB, 0.24928603E-06_JPRB, 0.25931348E-06_JPRB, &
  & 0.26974412E-06_JPRB, 0.27933731E-06_JPRB, 0.28706253E-06_JPRB, 0.29188765E-06_JPRB, 0.29433768E-06_JPRB, 0.29471864E-06_JPRB, &
  & 0.29391626E-06_JPRB, 0.29274588E-06_JPRB, 0.29235859E-06_JPRB, 0.29351786E-06_JPRB, 0.29694575E-06_JPRB, 0.30154569E-06_JPRB, &
  & 0.30814592E-06_JPRB, 0.31748123E-06_JPRB, 0.33526448E-06_JPRB, 0.37115966E-06_JPRB, 0.42155225E-06_JPRB, 0.47141956E-06_JPRB, &
  & 0.51179882E-06_JPRB, 0.54408474E-06_JPRB, 0.56927212E-06_JPRB, 0.58574017E-06_JPRB, 0.59375414E-06_JPRB, 0.59524175E-06_JPRB, &
  & 0.58904177E-06_JPRB, 0.57312456E-06_JPRB, 0.54963361E-06_JPRB, 0.52362145E-06_JPRB, 0.49870883E-06_JPRB, 0.47191094E-06_JPRB, &
  & 0.43987337E-06_JPRB, 0.40517622E-06_JPRB, 0.36885916E-06_JPRB, 0.33482997E-06_JPRB, 0.30347194E-06_JPRB, 0.27603935E-06_JPRB, &
  & 0.25488757E-06_JPRB, 0.24599568E-06_JPRB, 0.23861662E-06_JPRB, 0.23057004E-06_JPRB, 0.22431646E-06_JPRB, 0.21939199E-06_JPRB, &
  & 0.21322772E-06_JPRB, 0.20331135E-06_JPRB, 0.19166735E-06_JPRB, 0.18145216E-06_JPRB, 0.17178177E-06_JPRB, 0.16103596E-06_JPRB, &
  & 0.14968753E-06_JPRB, 0.13996802E-06_JPRB, 0.13316232E-06_JPRB, 0.12940513E-06_JPRB  /)

RGHG2(:,13, 9) = (/ &
  & 0.19398311E-06_JPRB, 0.19583627E-06_JPRB, 0.19836001E-06_JPRB, 0.20201336E-06_JPRB, 0.20714037E-06_JPRB, 0.21374531E-06_JPRB, &
  & 0.22322339E-06_JPRB, 0.23504888E-06_JPRB, 0.24814214E-06_JPRB, 0.26237177E-06_JPRB, 0.27735315E-06_JPRB, 0.29260438E-06_JPRB, &
  & 0.30746694E-06_JPRB, 0.32008742E-06_JPRB, 0.33112491E-06_JPRB, 0.33853860E-06_JPRB, 0.34173074E-06_JPRB, 0.34309477E-06_JPRB, &
  & 0.34252204E-06_JPRB, 0.34125428E-06_JPRB, 0.34009616E-06_JPRB, 0.33904146E-06_JPRB, 0.34165061E-06_JPRB, 0.34761587E-06_JPRB, &
  & 0.35743016E-06_JPRB, 0.37326166E-06_JPRB, 0.39755337E-06_JPRB, 0.44280882E-06_JPRB, 0.51231314E-06_JPRB, 0.58297752E-06_JPRB, &
  & 0.63882474E-06_JPRB, 0.67831436E-06_JPRB, 0.70400826E-06_JPRB, 0.71650723E-06_JPRB, 0.71743926E-06_JPRB, 0.70972320E-06_JPRB, &
  & 0.69373002E-06_JPRB, 0.66777483E-06_JPRB, 0.63364191E-06_JPRB, 0.59942089E-06_JPRB, 0.56957653E-06_JPRB, 0.53809460E-06_JPRB, &
  & 0.50037192E-06_JPRB, 0.45851156E-06_JPRB, 0.41472283E-06_JPRB, 0.37162237E-06_JPRB, 0.33073786E-06_JPRB, 0.29762885E-06_JPRB, &
  & 0.27727025E-06_JPRB, 0.26833004E-06_JPRB, 0.26224687E-06_JPRB, 0.25760568E-06_JPRB, 0.25322970E-06_JPRB, 0.24822556E-06_JPRB, &
  & 0.24188323E-06_JPRB, 0.23170618E-06_JPRB, 0.21946877E-06_JPRB, 0.20947798E-06_JPRB, 0.20029295E-06_JPRB, 0.18773566E-06_JPRB, &
  & 0.17244900E-06_JPRB, 0.16116110E-06_JPRB, 0.15487979E-06_JPRB, 0.15233756E-06_JPRB  /)

RGHG2(:,14, 9) = (/ &
  & 0.19647119E-06_JPRB, 0.19888309E-06_JPRB, 0.20253317E-06_JPRB, 0.20749448E-06_JPRB, 0.21456390E-06_JPRB, 0.22355296E-06_JPRB, &
  & 0.23600543E-06_JPRB, 0.25100927E-06_JPRB, 0.26759459E-06_JPRB, 0.28604205E-06_JPRB, 0.30555199E-06_JPRB, 0.32617030E-06_JPRB, &
  & 0.34512859E-06_JPRB, 0.36133388E-06_JPRB, 0.37636284E-06_JPRB, 0.38703229E-06_JPRB, 0.39165586E-06_JPRB, 0.39510980E-06_JPRB, &
  & 0.39632216E-06_JPRB, 0.39501077E-06_JPRB, 0.39323190E-06_JPRB, 0.39056691E-06_JPRB, 0.39239165E-06_JPRB, 0.39838670E-06_JPRB, &
  & 0.40791183E-06_JPRB, 0.42607484E-06_JPRB, 0.45498255E-06_JPRB, 0.50975657E-06_JPRB, 0.60184798E-06_JPRB, 0.70273041E-06_JPRB, &
  & 0.78265276E-06_JPRB, 0.83063549E-06_JPRB, 0.84964976E-06_JPRB, 0.84874744E-06_JPRB, 0.83668724E-06_JPRB, 0.81758810E-06_JPRB, &
  & 0.79100412E-06_JPRB, 0.75524830E-06_JPRB, 0.71238613E-06_JPRB, 0.67038669E-06_JPRB, 0.63200180E-06_JPRB, 0.59363100E-06_JPRB, &
  & 0.54958556E-06_JPRB, 0.50040580E-06_JPRB, 0.45065471E-06_JPRB, 0.40109429E-06_JPRB, 0.35483697E-06_JPRB, 0.32233529E-06_JPRB, &
  & 0.30592559E-06_JPRB, 0.29682547E-06_JPRB, 0.29322524E-06_JPRB, 0.29237401E-06_JPRB, 0.28947666E-06_JPRB, 0.28411479E-06_JPRB, &
  & 0.27724064E-06_JPRB, 0.26784811E-06_JPRB, 0.25657145E-06_JPRB, 0.24642146E-06_JPRB, 0.23576658E-06_JPRB, 0.22089339E-06_JPRB, &
  & 0.20341829E-06_JPRB, 0.19096542E-06_JPRB, 0.18322641E-06_JPRB, 0.17968552E-06_JPRB  /)

RGHG2(:,15, 9) = (/ &
  & 0.19900574E-06_JPRB, 0.20129499E-06_JPRB, 0.20558519E-06_JPRB, 0.21189818E-06_JPRB, 0.22134805E-06_JPRB, 0.23368912E-06_JPRB, &
  & 0.24942981E-06_JPRB, 0.26756360E-06_JPRB, 0.28768331E-06_JPRB, 0.30924043E-06_JPRB, 0.33176231E-06_JPRB, 0.35729234E-06_JPRB, &
  & 0.38045943E-06_JPRB, 0.40173267E-06_JPRB, 0.42169687E-06_JPRB, 0.43609011E-06_JPRB, 0.44382939E-06_JPRB, 0.44906734E-06_JPRB, &
  & 0.45228809E-06_JPRB, 0.45203251E-06_JPRB, 0.45015793E-06_JPRB, 0.44770084E-06_JPRB, 0.45019131E-06_JPRB, 0.45769364E-06_JPRB, &
  & 0.46747664E-06_JPRB, 0.48748659E-06_JPRB, 0.52028585E-06_JPRB, 0.58129405E-06_JPRB, 0.68876626E-06_JPRB, 0.81033892E-06_JPRB, &
  & 0.90852269E-06_JPRB, 0.96023718E-06_JPRB, 0.97041705E-06_JPRB, 0.95879619E-06_JPRB, 0.93854012E-06_JPRB, 0.91159020E-06_JPRB, &
  & 0.87647527E-06_JPRB, 0.83227641E-06_JPRB, 0.78424912E-06_JPRB, 0.73471922E-06_JPRB, 0.68487880E-06_JPRB, 0.63529352E-06_JPRB, &
  & 0.58220385E-06_JPRB, 0.52665728E-06_JPRB, 0.47337677E-06_JPRB, 0.42201698E-06_JPRB, 0.37804909E-06_JPRB, 0.35067611E-06_JPRB, &
  & 0.33803881E-06_JPRB, 0.33021001E-06_JPRB, 0.32822170E-06_JPRB, 0.33060779E-06_JPRB, 0.32905709E-06_JPRB, 0.32395784E-06_JPRB, &
  & 0.31746787E-06_JPRB, 0.30922031E-06_JPRB, 0.29875880E-06_JPRB, 0.28757122E-06_JPRB, 0.27336838E-06_JPRB, 0.25527488E-06_JPRB, &
  & 0.23786216E-06_JPRB, 0.22431987E-06_JPRB, 0.21382662E-06_JPRB, 0.20775041E-06_JPRB  /)

RGHG2(:,16, 9) = (/ &
  & 0.20287927E-06_JPRB, 0.20516858E-06_JPRB, 0.20936953E-06_JPRB, 0.21651123E-06_JPRB, 0.22830725E-06_JPRB, 0.24426574E-06_JPRB, &
  & 0.26417663E-06_JPRB, 0.28591435E-06_JPRB, 0.31012719E-06_JPRB, 0.33445317E-06_JPRB, 0.35902662E-06_JPRB, 0.38874757E-06_JPRB, &
  & 0.41825626E-06_JPRB, 0.44527425E-06_JPRB, 0.47063593E-06_JPRB, 0.48999209E-06_JPRB, 0.50123253E-06_JPRB, 0.50768420E-06_JPRB, &
  & 0.51293259E-06_JPRB, 0.51450548E-06_JPRB, 0.51536585E-06_JPRB, 0.51882856E-06_JPRB, 0.52595354E-06_JPRB, 0.53913064E-06_JPRB, &
  & 0.55879165E-06_JPRB, 0.58777911E-06_JPRB, 0.62723872E-06_JPRB, 0.69324108E-06_JPRB, 0.79338039E-06_JPRB, 0.89832216E-06_JPRB, &
  & 0.98904386E-06_JPRB, 0.10422331E-05_JPRB, 0.10505247E-05_JPRB, 0.10383191E-05_JPRB, 0.10182945E-05_JPRB, 0.98887146E-06_JPRB, &
  & 0.94862872E-06_JPRB, 0.90006019E-06_JPRB, 0.84782377E-06_JPRB, 0.78856282E-06_JPRB, 0.72625462E-06_JPRB, 0.66226249E-06_JPRB, &
  & 0.59931855E-06_JPRB, 0.53913745E-06_JPRB, 0.48666124E-06_JPRB, 0.44019776E-06_JPRB, 0.40424341E-06_JPRB, 0.38185546E-06_JPRB, &
  & 0.37150356E-06_JPRB, 0.36431010E-06_JPRB, 0.36319127E-06_JPRB, 0.36732981E-06_JPRB, 0.36768458E-06_JPRB, 0.36419811E-06_JPRB, &
  & 0.35879833E-06_JPRB, 0.35063652E-06_JPRB, 0.33848188E-06_JPRB, 0.32458384E-06_JPRB, 0.30683768E-06_JPRB, 0.28597092E-06_JPRB, &
  & 0.26881784E-06_JPRB, 0.25424289E-06_JPRB, 0.24232032E-06_JPRB, 0.23423180E-06_JPRB  /)

RGHG2(:,17, 9) = (/ &
  & 0.21106129E-06_JPRB, 0.21279683E-06_JPRB, 0.21633611E-06_JPRB, 0.22313443E-06_JPRB, 0.23678652E-06_JPRB, 0.25628073E-06_JPRB, &
  & 0.28144632E-06_JPRB, 0.30837821E-06_JPRB, 0.33714211E-06_JPRB, 0.36539639E-06_JPRB, 0.39304744E-06_JPRB, 0.42745517E-06_JPRB, &
  & 0.46450210E-06_JPRB, 0.49785908E-06_JPRB, 0.52878909E-06_JPRB, 0.55340950E-06_JPRB, 0.56841909E-06_JPRB, 0.57770934E-06_JPRB, &
  & 0.58582070E-06_JPRB, 0.59228309E-06_JPRB, 0.59938900E-06_JPRB, 0.61015504E-06_JPRB, 0.62373399E-06_JPRB, 0.64572005E-06_JPRB, &
  & 0.68430979E-06_JPRB, 0.73473737E-06_JPRB, 0.79499384E-06_JPRB, 0.87184167E-06_JPRB, 0.94927840E-06_JPRB, 0.10084478E-05_JPRB, &
  & 0.10588931E-05_JPRB, 0.10969823E-05_JPRB, 0.11053143E-05_JPRB, 0.10977092E-05_JPRB, 0.10819634E-05_JPRB, 0.10544233E-05_JPRB, &
  & 0.10144324E-05_JPRB, 0.96281387E-06_JPRB, 0.90315288E-06_JPRB, 0.82973239E-06_JPRB, 0.75582722E-06_JPRB, 0.68132764E-06_JPRB, &
  & 0.60931753E-06_JPRB, 0.54918280E-06_JPRB, 0.50265686E-06_JPRB, 0.46317515E-06_JPRB, 0.43541266E-06_JPRB, 0.41666268E-06_JPRB, &
  & 0.40661008E-06_JPRB, 0.39868303E-06_JPRB, 0.39793062E-06_JPRB, 0.40143309E-06_JPRB, 0.40337133E-06_JPRB, 0.40218061E-06_JPRB, &
  & 0.39720919E-06_JPRB, 0.38765423E-06_JPRB, 0.37199346E-06_JPRB, 0.35368136E-06_JPRB, 0.33246719E-06_JPRB, 0.31160291E-06_JPRB, &
  & 0.29512961E-06_JPRB, 0.27962646E-06_JPRB, 0.26923584E-06_JPRB, 0.26286809E-06_JPRB  /)

RGHG2(:,18, 9) = (/ &
  & 0.22557603E-06_JPRB, 0.22631221E-06_JPRB, 0.22900356E-06_JPRB, 0.23488471E-06_JPRB, 0.24903204E-06_JPRB, 0.27165809E-06_JPRB, &
  & 0.30200989E-06_JPRB, 0.33654717E-06_JPRB, 0.37093544E-06_JPRB, 0.40386212E-06_JPRB, 0.43667257E-06_JPRB, 0.47750329E-06_JPRB, &
  & 0.52326505E-06_JPRB, 0.56511978E-06_JPRB, 0.60225087E-06_JPRB, 0.63083918E-06_JPRB, 0.64874725E-06_JPRB, 0.66165500E-06_JPRB, &
  & 0.67350059E-06_JPRB, 0.68436634E-06_JPRB, 0.69750516E-06_JPRB, 0.71482074E-06_JPRB, 0.73142325E-06_JPRB, 0.75963656E-06_JPRB, &
  & 0.81745968E-06_JPRB, 0.89231926E-06_JPRB, 0.98351537E-06_JPRB, 0.10737960E-05_JPRB, 0.11258687E-05_JPRB, 0.11413700E-05_JPRB, &
  & 0.11480468E-05_JPRB, 0.11559262E-05_JPRB, 0.11558851E-05_JPRB, 0.11492335E-05_JPRB, 0.11360522E-05_JPRB, 0.11123404E-05_JPRB, &
  & 0.10744884E-05_JPRB, 0.10185154E-05_JPRB, 0.94664093E-06_JPRB, 0.85932774E-06_JPRB, 0.77595063E-06_JPRB, 0.69500367E-06_JPRB, &
  & 0.61909085E-06_JPRB, 0.56459172E-06_JPRB, 0.52565771E-06_JPRB, 0.49318457E-06_JPRB, 0.47188697E-06_JPRB, 0.45575597E-06_JPRB, &
  & 0.44459250E-06_JPRB, 0.43588212E-06_JPRB, 0.43359132E-06_JPRB, 0.43473241E-06_JPRB, 0.43666072E-06_JPRB, 0.43660630E-06_JPRB, &
  & 0.43098341E-06_JPRB, 0.41914547E-06_JPRB, 0.40005137E-06_JPRB, 0.37739158E-06_JPRB, 0.35321762E-06_JPRB, 0.33392212E-06_JPRB, &
  & 0.31868812E-06_JPRB, 0.30315117E-06_JPRB, 0.29542560E-06_JPRB, 0.29251529E-06_JPRB  /)

RGHG2(:,19, 9) = (/ &
  & 0.24769785E-06_JPRB, 0.24753049E-06_JPRB, 0.24924975E-06_JPRB, 0.25442575E-06_JPRB, 0.26787575E-06_JPRB, 0.29282729E-06_JPRB, &
  & 0.32791443E-06_JPRB, 0.37024276E-06_JPRB, 0.41175470E-06_JPRB, 0.45074866E-06_JPRB, 0.49009136E-06_JPRB, 0.54037237E-06_JPRB, &
  & 0.59647729E-06_JPRB, 0.64781887E-06_JPRB, 0.69157674E-06_JPRB, 0.72264881E-06_JPRB, 0.74247771E-06_JPRB, 0.75648659E-06_JPRB, &
  & 0.77015906E-06_JPRB, 0.78269918E-06_JPRB, 0.79963645E-06_JPRB, 0.82108079E-06_JPRB, 0.83888215E-06_JPRB, 0.86687859E-06_JPRB, &
  & 0.93325942E-06_JPRB, 0.10262093E-05_JPRB, 0.11448761E-05_JPRB, 0.12450771E-05_JPRB, 0.12801927E-05_JPRB, 0.12685320E-05_JPRB, &
  & 0.12452383E-05_JPRB, 0.12271555E-05_JPRB, 0.12125938E-05_JPRB, 0.11992754E-05_JPRB, 0.11834353E-05_JPRB, 0.11603034E-05_JPRB, &
  & 0.11225075E-05_JPRB, 0.10605854E-05_JPRB, 0.97504206E-06_JPRB, 0.87736335E-06_JPRB, 0.78753129E-06_JPRB, 0.70486995E-06_JPRB, &
  & 0.63157557E-06_JPRB, 0.58484497E-06_JPRB, 0.55356256E-06_JPRB, 0.52831856E-06_JPRB, 0.51241312E-06_JPRB, 0.49887321E-06_JPRB, &
  & 0.48724139E-06_JPRB, 0.47713813E-06_JPRB, 0.47140537E-06_JPRB, 0.46925772E-06_JPRB, 0.46959814E-06_JPRB, 0.46882853E-06_JPRB, &
  & 0.46193852E-06_JPRB, 0.44756568E-06_JPRB, 0.42613033E-06_JPRB, 0.40024426E-06_JPRB, 0.37602830E-06_JPRB, 0.35871570E-06_JPRB, &
  & 0.34418614E-06_JPRB, 0.32941264E-06_JPRB, 0.32305450E-06_JPRB, 0.32148038E-06_JPRB  /)

RGHG2(:,20, 9) = (/ &
  & 0.27799964E-06_JPRB, 0.27753625E-06_JPRB, 0.27848649E-06_JPRB, 0.28299300E-06_JPRB, 0.29529398E-06_JPRB, 0.32127490E-06_JPRB, &
  & 0.36049159E-06_JPRB, 0.41021310E-06_JPRB, 0.45887086E-06_JPRB, 0.50510917E-06_JPRB, 0.55226680E-06_JPRB, 0.61360652E-06_JPRB, &
  & 0.68168443E-06_JPRB, 0.74262159E-06_JPRB, 0.79171385E-06_JPRB, 0.82444469E-06_JPRB, 0.84475747E-06_JPRB, 0.85780970E-06_JPRB, &
  & 0.87107554E-06_JPRB, 0.88363395E-06_JPRB, 0.90207803E-06_JPRB, 0.92432783E-06_JPRB, 0.94093887E-06_JPRB, 0.96505398E-06_JPRB, &
  & 0.10285382E-05_JPRB, 0.11270864E-05_JPRB, 0.12633523E-05_JPRB, 0.13702853E-05_JPRB, 0.13983369E-05_JPRB, 0.13783579E-05_JPRB, &
  & 0.13415156E-05_JPRB, 0.13053655E-05_JPRB, 0.12740496E-05_JPRB, 0.12483441E-05_JPRB, 0.12244866E-05_JPRB, 0.11972396E-05_JPRB, &
  & 0.11562111E-05_JPRB, 0.10873310E-05_JPRB, 0.98984569E-06_JPRB, 0.88640033E-06_JPRB, 0.79444846E-06_JPRB, 0.71418462E-06_JPRB, &
  & 0.64796218E-06_JPRB, 0.60886480E-06_JPRB, 0.58483772E-06_JPRB, 0.56648626E-06_JPRB, 0.55592349E-06_JPRB, 0.54521916E-06_JPRB, &
  & 0.53412638E-06_JPRB, 0.52186551E-06_JPRB, 0.51175304E-06_JPRB, 0.50608387E-06_JPRB, 0.50424830E-06_JPRB, 0.50150310E-06_JPRB, &
  & 0.49272525E-06_JPRB, 0.47640019E-06_JPRB, 0.45327968E-06_JPRB, 0.42650162E-06_JPRB, 0.40482210E-06_JPRB, 0.38980753E-06_JPRB, &
  & 0.37562884E-06_JPRB, 0.36177149E-06_JPRB, 0.35477586E-06_JPRB, 0.35206821E-06_JPRB  /)

RGHG2(:,21, 9) = (/ &
  & 0.31743421E-06_JPRB, 0.31703601E-06_JPRB, 0.31750700E-06_JPRB, 0.32115452E-06_JPRB, 0.33212721E-06_JPRB, 0.35789946E-06_JPRB, &
  & 0.40014243E-06_JPRB, 0.45671454E-06_JPRB, 0.51225977E-06_JPRB, 0.56602997E-06_JPRB, 0.62181179E-06_JPRB, 0.69435878E-06_JPRB, &
  & 0.77499236E-06_JPRB, 0.84464086E-06_JPRB, 0.89696037E-06_JPRB, 0.93065903E-06_JPRB, 0.95052760E-06_JPRB, 0.96211265E-06_JPRB, &
  & 0.97362618E-06_JPRB, 0.98526438E-06_JPRB, 0.10033931E-05_JPRB, 0.10237265E-05_JPRB, 0.10369419E-05_JPRB, 0.10560291E-05_JPRB, &
  & 0.11093563E-05_JPRB, 0.12024349E-05_JPRB, 0.13452714E-05_JPRB, 0.14548186E-05_JPRB, 0.14825107E-05_JPRB, 0.14670224E-05_JPRB, &
  & 0.14291878E-05_JPRB, 0.13822586E-05_JPRB, 0.13351505E-05_JPRB, 0.12947643E-05_JPRB, 0.12596210E-05_JPRB, 0.12247522E-05_JPRB, &
  & 0.11779404E-05_JPRB, 0.11018763E-05_JPRB, 0.99632734E-06_JPRB, 0.89149519E-06_JPRB, 0.80117322E-06_JPRB, 0.72642696E-06_JPRB, &
  & 0.66927236E-06_JPRB, 0.63709132E-06_JPRB, 0.61936772E-06_JPRB, 0.60708827E-06_JPRB, 0.60221665E-06_JPRB, 0.59461292E-06_JPRB, &
  & 0.58461558E-06_JPRB, 0.56974940E-06_JPRB, 0.55508327E-06_JPRB, 0.54616365E-06_JPRB, 0.54218284E-06_JPRB, 0.53696900E-06_JPRB, &
  & 0.52567558E-06_JPRB, 0.50774411E-06_JPRB, 0.48378303E-06_JPRB, 0.45851813E-06_JPRB, 0.44066053E-06_JPRB, 0.42829239E-06_JPRB, &
  & 0.41422935E-06_JPRB, 0.40115934E-06_JPRB, 0.39229060E-06_JPRB, 0.38682006E-06_JPRB  /)

RGHG2(:,22, 9) = (/ &
  & 0.36800567E-06_JPRB, 0.36739722E-06_JPRB, 0.36765795E-06_JPRB, 0.37006305E-06_JPRB, 0.37950661E-06_JPRB, 0.40403644E-06_JPRB, &
  & 0.44725424E-06_JPRB, 0.50986640E-06_JPRB, 0.57244562E-06_JPRB, 0.63271462E-06_JPRB, 0.69711690E-06_JPRB, 0.77952678E-06_JPRB, &
  & 0.87151414E-06_JPRB, 0.94754676E-06_JPRB, 0.10004015E-05_JPRB, 0.10340428E-05_JPRB, 0.10535482E-05_JPRB, 0.10650185E-05_JPRB, &
  & 0.10746589E-05_JPRB, 0.10845959E-05_JPRB, 0.11009661E-05_JPRB, 0.11177253E-05_JPRB, 0.11259519E-05_JPRB, 0.11407384E-05_JPRB, &
  & 0.11821192E-05_JPRB, 0.12626781E-05_JPRB, 0.14003537E-05_JPRB, 0.15054474E-05_JPRB, 0.15352612E-05_JPRB, 0.15286036E-05_JPRB, &
  & 0.14975737E-05_JPRB, 0.14468981E-05_JPRB, 0.13883214E-05_JPRB, 0.13348994E-05_JPRB, 0.12881157E-05_JPRB, 0.12441294E-05_JPRB, &
  & 0.11903409E-05_JPRB, 0.11078354E-05_JPRB, 0.10005662E-05_JPRB, 0.89860116E-06_JPRB, 0.81242695E-06_JPRB, 0.74553659E-06_JPRB, &
  & 0.69702157E-06_JPRB, 0.67101439E-06_JPRB, 0.65766792E-06_JPRB, 0.65003320E-06_JPRB, 0.65122075E-06_JPRB, 0.64692376E-06_JPRB, &
  & 0.63786301E-06_JPRB, 0.62047377E-06_JPRB, 0.60175545E-06_JPRB, 0.59038922E-06_JPRB, 0.58470726E-06_JPRB, 0.57731441E-06_JPRB, &
  & 0.56286716E-06_JPRB, 0.54287137E-06_JPRB, 0.51973219E-06_JPRB, 0.49811809E-06_JPRB, 0.48383483E-06_JPRB, 0.47448672E-06_JPRB, &
  & 0.46023253E-06_JPRB, 0.44773595E-06_JPRB, 0.43710871E-06_JPRB, 0.42829320E-06_JPRB  /)

RGHG2(:,23, 9) = (/ &
  & 0.43387630E-06_JPRB, 0.43227105E-06_JPRB, 0.43130692E-06_JPRB, 0.43211240E-06_JPRB, 0.43961995E-06_JPRB, 0.46171389E-06_JPRB, &
  & 0.50362744E-06_JPRB, 0.56816677E-06_JPRB, 0.63702729E-06_JPRB, 0.70319799E-06_JPRB, 0.77342167E-06_JPRB, 0.86209698E-06_JPRB, &
  & 0.95984870E-06_JPRB, 0.10372238E-05_JPRB, 0.10873411E-05_JPRB, 0.11189842E-05_JPRB, 0.11382814E-05_JPRB, 0.11496932E-05_JPRB, &
  & 0.11586360E-05_JPRB, 0.11680773E-05_JPRB, 0.11825769E-05_JPRB, 0.11960901E-05_JPRB, 0.12022495E-05_JPRB, 0.12163843E-05_JPRB, &
  & 0.12505808E-05_JPRB, 0.13220814E-05_JPRB, 0.14473159E-05_JPRB, 0.15357603E-05_JPRB, 0.15613276E-05_JPRB, 0.15577630E-05_JPRB, &
  & 0.15319394E-05_JPRB, 0.14842021E-05_JPRB, 0.14248506E-05_JPRB, 0.13668584E-05_JPRB, 0.13139435E-05_JPRB, 0.12641102E-05_JPRB, &
  & 0.12044879E-05_JPRB, 0.11189000E-05_JPRB, 0.10143715E-05_JPRB, 0.91835527E-06_JPRB, 0.83911035E-06_JPRB, 0.77944534E-06_JPRB, &
  & 0.73740768E-06_JPRB, 0.71522814E-06_JPRB, 0.70267882E-06_JPRB, 0.69854746E-06_JPRB, 0.70484214E-06_JPRB, 0.70275743E-06_JPRB, &
  & 0.69255538E-06_JPRB, 0.67363513E-06_JPRB, 0.65263578E-06_JPRB, 0.63997523E-06_JPRB, 0.63280923E-06_JPRB, 0.62320950E-06_JPRB, &
  & 0.60553327E-06_JPRB, 0.58376925E-06_JPRB, 0.56342913E-06_JPRB, 0.54540408E-06_JPRB, 0.53439717E-06_JPRB, 0.52728986E-06_JPRB, &
  & 0.51245156E-06_JPRB, 0.49811895E-06_JPRB, 0.48644216E-06_JPRB, 0.47759958E-06_JPRB  /)

RGHG2(:,24, 9) = (/ &
  & 0.51096560E-06_JPRB, 0.50828596E-06_JPRB, 0.50583132E-06_JPRB, 0.50482060E-06_JPRB, 0.50973767E-06_JPRB, 0.52857860E-06_JPRB, &
  & 0.56797388E-06_JPRB, 0.63173582E-06_JPRB, 0.70479961E-06_JPRB, 0.77629801E-06_JPRB, 0.85098092E-06_JPRB, 0.94351966E-06_JPRB, &
  & 0.10436781E-05_JPRB, 0.11199321E-05_JPRB, 0.11661857E-05_JPRB, 0.11949289E-05_JPRB, 0.12131428E-05_JPRB, 0.12242544E-05_JPRB, &
  & 0.12328705E-05_JPRB, 0.12419349E-05_JPRB, 0.12547056E-05_JPRB, 0.12659291E-05_JPRB, 0.12714429E-05_JPRB, 0.12858052E-05_JPRB, &
  & 0.13143502E-05_JPRB, 0.13789217E-05_JPRB, 0.14897481E-05_JPRB, 0.15596718E-05_JPRB, 0.15795643E-05_JPRB, 0.15773167E-05_JPRB, &
  & 0.15560966E-05_JPRB, 0.15135542E-05_JPRB, 0.14573511E-05_JPRB, 0.13986118E-05_JPRB, 0.13422030E-05_JPRB, 0.12879387E-05_JPRB, &
  & 0.12237776E-05_JPRB, 0.11373299E-05_JPRB, 0.10376313E-05_JPRB, 0.94893152E-06_JPRB, 0.87797136E-06_JPRB, 0.82506077E-06_JPRB, &
  & 0.78810346E-06_JPRB, 0.76800995E-06_JPRB, 0.75549945E-06_JPRB, 0.75455273E-06_JPRB, 0.76366633E-06_JPRB, 0.76228233E-06_JPRB, &
  & 0.75032506E-06_JPRB, 0.72961994E-06_JPRB, 0.70726670E-06_JPRB, 0.69371189E-06_JPRB, 0.68509533E-06_JPRB, 0.67347805E-06_JPRB, &
  & 0.65317554E-06_JPRB, 0.63055389E-06_JPRB, 0.61315648E-06_JPRB, 0.59852014E-06_JPRB, 0.59101733E-06_JPRB, 0.58539667E-06_JPRB, &
  & 0.56998034E-06_JPRB, 0.55320615E-06_JPRB, 0.54061523E-06_JPRB, 0.53208211E-06_JPRB  /)

RGHG2(:,25, 9) = (/ &
  & 0.60102197E-06_JPRB, 0.59735576E-06_JPRB, 0.59323524E-06_JPRB, 0.59018666E-06_JPRB, 0.59156172E-06_JPRB, 0.60611666E-06_JPRB, &
  & 0.64146855E-06_JPRB, 0.70062103E-06_JPRB, 0.77418620E-06_JPRB, 0.84988972E-06_JPRB, 0.92704719E-06_JPRB, 0.10198285E-05_JPRB, &
  & 0.11175933E-05_JPRB, 0.11895451E-05_JPRB, 0.12308497E-05_JPRB, 0.12556627E-05_JPRB, 0.12712565E-05_JPRB, 0.12816402E-05_JPRB, &
  & 0.12903372E-05_JPRB, 0.12989811E-05_JPRB, 0.13103771E-05_JPRB, 0.13210345E-05_JPRB, 0.13277936E-05_JPRB, 0.13431102E-05_JPRB, &
  & 0.13679029E-05_JPRB, 0.14288516E-05_JPRB, 0.15240704E-05_JPRB, 0.15757342E-05_JPRB, 0.15891088E-05_JPRB, 0.15862628E-05_JPRB, &
  & 0.15687302E-05_JPRB, 0.15336438E-05_JPRB, 0.14849938E-05_JPRB, 0.14304111E-05_JPRB, 0.13740993E-05_JPRB, 0.13173767E-05_JPRB, &
  & 0.12509189E-05_JPRB, 0.11668326E-05_JPRB, 0.10744443E-05_JPRB, 0.99446213E-06_JPRB, 0.93318993E-06_JPRB, 0.88603711E-06_JPRB, &
  & 0.85194252E-06_JPRB, 0.83128294E-06_JPRB, 0.81827106E-06_JPRB, 0.82005767E-06_JPRB, 0.82802294E-06_JPRB, 0.82487604E-06_JPRB, &
  & 0.81062212E-06_JPRB, 0.78753948E-06_JPRB, 0.76513773E-06_JPRB, 0.75117857E-06_JPRB, 0.74118727E-06_JPRB, 0.72798498E-06_JPRB, &
  & 0.70625920E-06_JPRB, 0.68436535E-06_JPRB, 0.66958806E-06_JPRB, 0.65784678E-06_JPRB, 0.65416093E-06_JPRB, 0.64879905E-06_JPRB, &
  & 0.63292986E-06_JPRB, 0.61329296E-06_JPRB, 0.59990953E-06_JPRB, 0.59152197E-06_JPRB  /)

RGHG2(:,26, 9) = (/ &
  & 0.70246548E-06_JPRB, 0.69779512E-06_JPRB, 0.69194923E-06_JPRB, 0.68651317E-06_JPRB, 0.68405212E-06_JPRB, 0.69330825E-06_JPRB, &
  & 0.72257244E-06_JPRB, 0.77443418E-06_JPRB, 0.84327194E-06_JPRB, 0.91887235E-06_JPRB, 0.99575068E-06_JPRB, 0.10854310E-05_JPRB, &
  & 0.11771031E-05_JPRB, 0.12423880E-05_JPRB, 0.12786464E-05_JPRB, 0.12995003E-05_JPRB, 0.13125649E-05_JPRB, 0.13218098E-05_JPRB, &
  & 0.13299419E-05_JPRB, 0.13380389E-05_JPRB, 0.13486487E-05_JPRB, 0.13596055E-05_JPRB, 0.13681397E-05_JPRB, 0.13833438E-05_JPRB, &
  & 0.14056732E-05_JPRB, 0.14619974E-05_JPRB, 0.15446915E-05_JPRB, 0.15863219E-05_JPRB, 0.15970418E-05_JPRB, 0.15951366E-05_JPRB, &
  & 0.15816487E-05_JPRB, 0.15541934E-05_JPRB, 0.15143293E-05_JPRB, 0.14658640E-05_JPRB, 0.14115807E-05_JPRB, 0.13542464E-05_JPRB, &
  & 0.12885832E-05_JPRB, 0.12100909E-05_JPRB, 0.11280659E-05_JPRB, 0.10585064E-05_JPRB, 0.10053111E-05_JPRB, 0.96220153E-06_JPRB, &
  & 0.92945308E-06_JPRB, 0.90754783E-06_JPRB, 0.89371212E-06_JPRB, 0.89342272E-06_JPRB, 0.89582380E-06_JPRB, 0.88801731E-06_JPRB, &
  & 0.87060494E-06_JPRB, 0.84572782E-06_JPRB, 0.82474113E-06_JPRB, 0.81095315E-06_JPRB, 0.79933400E-06_JPRB, 0.78490697E-06_JPRB, &
  & 0.76418307E-06_JPRB, 0.74441897E-06_JPRB, 0.73114805E-06_JPRB, 0.72273255E-06_JPRB, 0.72085576E-06_JPRB, 0.71446416E-06_JPRB, &
  & 0.69921160E-06_JPRB, 0.67945389E-06_JPRB, 0.66709896E-06_JPRB, 0.65954863E-06_JPRB  /)

RGHG2(:,27, 9) = (/ &
  & 0.81274909E-06_JPRB, 0.80702238E-06_JPRB, 0.79935051E-06_JPRB, 0.79128865E-06_JPRB, 0.78470783E-06_JPRB, 0.78804838E-06_JPRB, &
  & 0.81018973E-06_JPRB, 0.85343465E-06_JPRB, 0.91539103E-06_JPRB, 0.98928618E-06_JPRB, 0.10648516E-05_JPRB, 0.11500500E-05_JPRB, &
  & 0.12339805E-05_JPRB, 0.12914182E-05_JPRB, 0.13223646E-05_JPRB, 0.13390686E-05_JPRB, 0.13495225E-05_JPRB, 0.13574243E-05_JPRB, &
  & 0.13647265E-05_JPRB, 0.13722047E-05_JPRB, 0.13822109E-05_JPRB, 0.13938015E-05_JPRB, 0.14043881E-05_JPRB, 0.14190791E-05_JPRB, &
  & 0.14393108E-05_JPRB, 0.14904287E-05_JPRB, 0.15611709E-05_JPRB, 0.15953617E-05_JPRB, 0.16047384E-05_JPRB, 0.16043876E-05_JPRB, &
  & 0.15952609E-05_JPRB, 0.15758490E-05_JPRB, 0.15456278E-05_JPRB, 0.15042854E-05_JPRB, 0.14528392E-05_JPRB, 0.13955502E-05_JPRB, &
  & 0.13318639E-05_JPRB, 0.12604189E-05_JPRB, 0.11903609E-05_JPRB, 0.11323307E-05_JPRB, 0.10869826E-05_JPRB, 0.10474647E-05_JPRB, &
  & 0.10155613E-05_JPRB, 0.99210170E-06_JPRB, 0.97728509E-06_JPRB, 0.97304191E-06_JPRB, 0.96798816E-06_JPRB, 0.95423591E-06_JPRB, &
  & 0.93320176E-06_JPRB, 0.90666466E-06_JPRB, 0.88770012E-06_JPRB, 0.87430451E-06_JPRB, 0.86088955E-06_JPRB, 0.84531563E-06_JPRB, &
  & 0.82653844E-06_JPRB, 0.80952085E-06_JPRB, 0.79741192E-06_JPRB, 0.79263330E-06_JPRB, 0.79190340E-06_JPRB, 0.78395745E-06_JPRB, &
  & 0.76974616E-06_JPRB, 0.75087880E-06_JPRB, 0.74027439E-06_JPRB, 0.73385587E-06_JPRB  /)

RGHG2(:,28, 9) = (/ &
  & 0.92456949E-06_JPRB, 0.91806264E-06_JPRB, 0.90854756E-06_JPRB, 0.89818541E-06_JPRB, 0.88824405E-06_JPRB, 0.88580618E-06_JPRB, &
  & 0.90003724E-06_JPRB, 0.93376079E-06_JPRB, 0.98529381E-06_JPRB, 0.10515856E-05_JPRB, 0.11220981E-05_JPRB, 0.12001409E-05_JPRB, &
  & 0.12748725E-05_JPRB, 0.13249410E-05_JPRB, 0.13512406E-05_JPRB, 0.13644765E-05_JPRB, 0.13734569E-05_JPRB, 0.13805673E-05_JPRB, &
  & 0.13876428E-05_JPRB, 0.13956664E-05_JPRB, 0.14058429E-05_JPRB, 0.14186977E-05_JPRB, 0.14306920E-05_JPRB, 0.14442111E-05_JPRB, &
  & 0.14633902E-05_JPRB, 0.15072490E-05_JPRB, 0.15679569E-05_JPRB, 0.16016611E-05_JPRB, 0.16143777E-05_JPRB, 0.16180815E-05_JPRB, &
  & 0.16141213E-05_JPRB, 0.16008719E-05_JPRB, 0.15772518E-05_JPRB, 0.15419856E-05_JPRB, 0.14955709E-05_JPRB, 0.14420017E-05_JPRB, &
  & 0.13836385E-05_JPRB, 0.13220727E-05_JPRB, 0.12648788E-05_JPRB, 0.12171668E-05_JPRB, 0.11781612E-05_JPRB, 0.11417703E-05_JPRB, &
  & 0.11111896E-05_JPRB, 0.10867863E-05_JPRB, 0.10668672E-05_JPRB, 0.10542437E-05_JPRB, 0.10406782E-05_JPRB, 0.10208772E-05_JPRB, &
  & 0.99607015E-06_JPRB, 0.97020641E-06_JPRB, 0.95218518E-06_JPRB, 0.93878620E-06_JPRB, 0.92458707E-06_JPRB, 0.90931234E-06_JPRB, &
  & 0.89272737E-06_JPRB, 0.87705086E-06_JPRB, 0.86657126E-06_JPRB, 0.86326261E-06_JPRB, 0.86182040E-06_JPRB, 0.85316237E-06_JPRB, &
  & 0.84028771E-06_JPRB, 0.82309533E-06_JPRB, 0.81479437E-06_JPRB, 0.81197571E-06_JPRB  /)

RGHG2(:,29, 9) = (/ &
  & 0.10431191E-05_JPRB, 0.10357976E-05_JPRB, 0.10243288E-05_JPRB, 0.10115434E-05_JPRB, 0.99807416E-06_JPRB, 0.98951950E-06_JPRB, &
  & 0.99533482E-06_JPRB, 0.10189305E-05_JPRB, 0.10592655E-05_JPRB, 0.11172451E-05_JPRB, 0.11822414E-05_JPRB, 0.12525866E-05_JPRB, &
  & 0.13175078E-05_JPRB, 0.13597888E-05_JPRB, 0.13811936E-05_JPRB, 0.13907843E-05_JPRB, 0.13982528E-05_JPRB, 0.14045485E-05_JPRB, &
  & 0.14114100E-05_JPRB, 0.14200618E-05_JPRB, 0.14304523E-05_JPRB, 0.14446741E-05_JPRB, 0.14581320E-05_JPRB, 0.14703808E-05_JPRB, &
  & 0.14884898E-05_JPRB, 0.15245680E-05_JPRB, 0.15747269E-05_JPRB, 0.16082171E-05_JPRB, 0.16246756E-05_JPRB, 0.16327840E-05_JPRB, &
  & 0.16343330E-05_JPRB, 0.16275318E-05_JPRB, 0.16107740E-05_JPRB, 0.15819008E-05_JPRB, 0.15409124E-05_JPRB, 0.14914442E-05_JPRB, &
  & 0.14388664E-05_JPRB, 0.13878910E-05_JPRB, 0.13443667E-05_JPRB, 0.13075350E-05_JPRB, 0.12751848E-05_JPRB, 0.12420869E-05_JPRB, &
  & 0.12129284E-05_JPRB, 0.11875517E-05_JPRB, 0.11620474E-05_JPRB, 0.11403523E-05_JPRB, 0.11177221E-05_JPRB, 0.10915074E-05_JPRB, &
  & 0.10626962E-05_JPRB, 0.10376471E-05_JPRB, 0.10205786E-05_JPRB, 0.10071589E-05_JPRB, 0.99217275E-06_JPRB, 0.97727773E-06_JPRB, &
  & 0.96302624E-06_JPRB, 0.94870979E-06_JPRB, 0.93997685E-06_JPRB, 0.93813181E-06_JPRB, 0.93585424E-06_JPRB, 0.92647821E-06_JPRB, &
  & 0.91503265E-06_JPRB, 0.89964906E-06_JPRB, 0.89381276E-06_JPRB, 0.89491547E-06_JPRB  /)

RGHG2(:,30, 9) = (/ &
  & 0.11453940E-05_JPRB, 0.11381567E-05_JPRB, 0.11261827E-05_JPRB, 0.11118182E-05_JPRB, 0.10963808E-05_JPRB, 0.10845759E-05_JPRB, &
  & 0.10838943E-05_JPRB, 0.10989111E-05_JPRB, 0.11289500E-05_JPRB, 0.11759811E-05_JPRB, 0.12327060E-05_JPRB, 0.12949415E-05_JPRB, &
  & 0.13511993E-05_JPRB, 0.13876086E-05_JPRB, 0.14054550E-05_JPRB, 0.14133442E-05_JPRB, 0.14202837E-05_JPRB, 0.14271609E-05_JPRB, &
  & 0.14352595E-05_JPRB, 0.14455251E-05_JPRB, 0.14571470E-05_JPRB, 0.14719644E-05_JPRB, 0.14865880E-05_JPRB, 0.14996423E-05_JPRB, &
  & 0.15165313E-05_JPRB, 0.15463860E-05_JPRB, 0.15868013E-05_JPRB, 0.16178956E-05_JPRB, 0.16365287E-05_JPRB, 0.16469943E-05_JPRB, &
  & 0.16509803E-05_JPRB, 0.16475387E-05_JPRB, 0.16350568E-05_JPRB, 0.16116598E-05_JPRB, 0.15778269E-05_JPRB, 0.15369866E-05_JPRB, &
  & 0.14941845E-05_JPRB, 0.14543962E-05_JPRB, 0.14206244E-05_JPRB, 0.13914504E-05_JPRB, 0.13638186E-05_JPRB, 0.13342959E-05_JPRB, &
  & 0.13072553E-05_JPRB, 0.12801856E-05_JPRB, 0.12495515E-05_JPRB, 0.12223958E-05_JPRB, 0.11950693E-05_JPRB, 0.11650765E-05_JPRB, &
  & 0.11341996E-05_JPRB, 0.11082112E-05_JPRB, 0.10900883E-05_JPRB, 0.10760318E-05_JPRB, 0.10612996E-05_JPRB, 0.10470054E-05_JPRB, &
  & 0.10328773E-05_JPRB, 0.10185802E-05_JPRB, 0.10093698E-05_JPRB, 0.10067194E-05_JPRB, 0.10029491E-05_JPRB, 0.99273549E-06_JPRB, &
  & 0.98170969E-06_JPRB, 0.96855354E-06_JPRB, 0.96503625E-06_JPRB, 0.96847140E-06_JPRB  /)

RGHG2(:,31, 9) = (/ &
  & 0.12531408E-05_JPRB, 0.12459930E-05_JPRB, 0.12334882E-05_JPRB, 0.12174608E-05_JPRB, 0.11999510E-05_JPRB, 0.11847243E-05_JPRB, &
  & 0.11771988E-05_JPRB, 0.11831781E-05_JPRB, 0.12023693E-05_JPRB, 0.12378619E-05_JPRB, 0.12858690E-05_JPRB, 0.13395594E-05_JPRB, &
  & 0.13866901E-05_JPRB, 0.14169144E-05_JPRB, 0.14310127E-05_JPRB, 0.14371110E-05_JPRB, 0.14434940E-05_JPRB, 0.14509853E-05_JPRB, &
  & 0.14603886E-05_JPRB, 0.14723556E-05_JPRB, 0.14852759E-05_JPRB, 0.15007201E-05_JPRB, 0.15165718E-05_JPRB, 0.15304767E-05_JPRB, &
  & 0.15460801E-05_JPRB, 0.15693789E-05_JPRB, 0.15995285E-05_JPRB, 0.16280964E-05_JPRB, 0.16490193E-05_JPRB, 0.16619665E-05_JPRB, &
  & 0.16685173E-05_JPRB, 0.16686128E-05_JPRB, 0.16606337E-05_JPRB, 0.16430059E-05_JPRB, 0.16167139E-05_JPRB, 0.15849688E-05_JPRB, &
  & 0.15524708E-05_JPRB, 0.15244704E-05_JPRB, 0.15009706E-05_JPRB, 0.14798620E-05_JPRB, 0.14571999E-05_JPRB, 0.14314445E-05_JPRB, &
  & 0.14066361E-05_JPRB, 0.13777819E-05_JPRB, 0.13417431E-05_JPRB, 0.13088374E-05_JPRB, 0.12765668E-05_JPRB, 0.12425957E-05_JPRB, &
  & 0.12095441E-05_JPRB, 0.11825643E-05_JPRB, 0.11633285E-05_JPRB, 0.11486004E-05_JPRB, 0.11341369E-05_JPRB, 0.11204758E-05_JPRB, &
  & 0.11064756E-05_JPRB, 0.10921978E-05_JPRB, 0.10824820E-05_JPRB, 0.10789810E-05_JPRB, 0.10736373E-05_JPRB, 0.10625410E-05_JPRB, &
  & 0.10519565E-05_JPRB, 0.10411477E-05_JPRB, 0.10400737E-05_JPRB, 0.10459650E-05_JPRB  /)

RGHG2(:,32, 9) = (/ &
  & 0.13369220E-05_JPRB, 0.13311022E-05_JPRB, 0.13192336E-05_JPRB, 0.13030323E-05_JPRB, 0.12851179E-05_JPRB, 0.12684154E-05_JPRB, &
  & 0.12573824E-05_JPRB, 0.12574743E-05_JPRB, 0.12684204E-05_JPRB, 0.12939180E-05_JPRB, 0.13330561E-05_JPRB, 0.13790345E-05_JPRB, &
  & 0.14190477E-05_JPRB, 0.14445502E-05_JPRB, 0.14567350E-05_JPRB, 0.14625526E-05_JPRB, 0.14693940E-05_JPRB, 0.14781477E-05_JPRB, &
  & 0.14893278E-05_JPRB, 0.15022967E-05_JPRB, 0.15164112E-05_JPRB, 0.15324860E-05_JPRB, 0.15489783E-05_JPRB, 0.15637807E-05_JPRB, &
  & 0.15791181E-05_JPRB, 0.15983079E-05_JPRB, 0.16208741E-05_JPRB, 0.16432772E-05_JPRB, 0.16614262E-05_JPRB, 0.16731656E-05_JPRB, &
  & 0.16796916E-05_JPRB, 0.16812447E-05_JPRB, 0.16764108E-05_JPRB, 0.16643547E-05_JPRB, 0.16457149E-05_JPRB, 0.16234521E-05_JPRB, &
  & 0.16005137E-05_JPRB, 0.15806155E-05_JPRB, 0.15632583E-05_JPRB, 0.15467811E-05_JPRB, 0.15278154E-05_JPRB, 0.15059784E-05_JPRB, &
  & 0.14832605E-05_JPRB, 0.14552178E-05_JPRB, 0.14205935E-05_JPRB, 0.13881526E-05_JPRB, 0.13547627E-05_JPRB, 0.13195940E-05_JPRB, &
  & 0.12847930E-05_JPRB, 0.12552835E-05_JPRB, 0.12334530E-05_JPRB, 0.12175744E-05_JPRB, 0.12031149E-05_JPRB, 0.11891172E-05_JPRB, &
  & 0.11743744E-05_JPRB, 0.11588166E-05_JPRB, 0.11475981E-05_JPRB, 0.11422677E-05_JPRB, 0.11348344E-05_JPRB, 0.11232593E-05_JPRB, &
  & 0.11130069E-05_JPRB, 0.11049244E-05_JPRB, 0.11052744E-05_JPRB, 0.11106139E-05_JPRB  /)

RGHG2(:,33, 9) = (/ &
  & 0.14208885E-05_JPRB, 0.14166092E-05_JPRB, 0.14055529E-05_JPRB, 0.13893636E-05_JPRB, 0.13712447E-05_JPRB, 0.13532605E-05_JPRB, &
  & 0.13390142E-05_JPRB, 0.13333956E-05_JPRB, 0.13361099E-05_JPRB, 0.13514200E-05_JPRB, 0.13813215E-05_JPRB, 0.14193930E-05_JPRB, &
  & 0.14522695E-05_JPRB, 0.14730545E-05_JPRB, 0.14834882E-05_JPRB, 0.14892095E-05_JPRB, 0.14966586E-05_JPRB, 0.15068084E-05_JPRB, &
  & 0.15198960E-05_JPRB, 0.15338156E-05_JPRB, 0.15491576E-05_JPRB, 0.15658884E-05_JPRB, 0.15829704E-05_JPRB, 0.15987115E-05_JPRB, &
  & 0.16139045E-05_JPRB, 0.16291409E-05_JPRB, 0.16441733E-05_JPRB, 0.16596985E-05_JPRB, 0.16743093E-05_JPRB, 0.16843157E-05_JPRB, &
  & 0.16904807E-05_JPRB, 0.16932793E-05_JPRB, 0.16915384E-05_JPRB, 0.16852469E-05_JPRB, 0.16745742E-05_JPRB, 0.16622160E-05_JPRB, &
  & 0.16491161E-05_JPRB, 0.16371608E-05_JPRB, 0.16256524E-05_JPRB, 0.16135439E-05_JPRB, 0.15982548E-05_JPRB, 0.15805096E-05_JPRB, &
  & 0.15599460E-05_JPRB, 0.15330827E-05_JPRB, 0.15008111E-05_JPRB, 0.14696580E-05_JPRB, 0.14356002E-05_JPRB, 0.13995469E-05_JPRB, &
  & 0.13629828E-05_JPRB, 0.13306451E-05_JPRB, 0.13059263E-05_JPRB, 0.12887901E-05_JPRB, 0.12743005E-05_JPRB, 0.12598274E-05_JPRB, &
  & 0.12442000E-05_JPRB, 0.12271440E-05_JPRB, 0.12142345E-05_JPRB, 0.12068763E-05_JPRB, 0.11972045E-05_JPRB, 0.11851841E-05_JPRB, &
  & 0.11752627E-05_JPRB, 0.11700625E-05_JPRB, 0.11717604E-05_JPRB, 0.11761371E-05_JPRB  /)

RGHG2(:,34, 9) = (/ &
  & 0.14865588E-05_JPRB, 0.14829427E-05_JPRB, 0.14727492E-05_JPRB, 0.14574533E-05_JPRB, 0.14401050E-05_JPRB, 0.14221070E-05_JPRB, &
  & 0.14062765E-05_JPRB, 0.13974072E-05_JPRB, 0.13949137E-05_JPRB, 0.14026930E-05_JPRB, 0.14246773E-05_JPRB, 0.14557182E-05_JPRB, &
  & 0.14828839E-05_JPRB, 0.15002306E-05_JPRB, 0.15097970E-05_JPRB, 0.15160985E-05_JPRB, 0.15241322E-05_JPRB, 0.15353282E-05_JPRB, &
  & 0.15491650E-05_JPRB, 0.15634791E-05_JPRB, 0.15792787E-05_JPRB, 0.15959434E-05_JPRB, 0.16128559E-05_JPRB, 0.16283534E-05_JPRB, &
  & 0.16420147E-05_JPRB, 0.16537014E-05_JPRB, 0.16637022E-05_JPRB, 0.16739759E-05_JPRB, 0.16844398E-05_JPRB, 0.16921701E-05_JPRB, &
  & 0.16975302E-05_JPRB, 0.17010333E-05_JPRB, 0.17016029E-05_JPRB, 0.16992829E-05_JPRB, 0.16941719E-05_JPRB, 0.16882849E-05_JPRB, &
  & 0.16815706E-05_JPRB, 0.16749516E-05_JPRB, 0.16677907E-05_JPRB, 0.16592885E-05_JPRB, 0.16476472E-05_JPRB, 0.16337533E-05_JPRB, &
  & 0.16163468E-05_JPRB, 0.15929302E-05_JPRB, 0.15645993E-05_JPRB, 0.15355776E-05_JPRB, 0.15027249E-05_JPRB, 0.14674603E-05_JPRB, &
  & 0.14301842E-05_JPRB, 0.13962728E-05_JPRB, 0.13697210E-05_JPRB, 0.13516715E-05_JPRB, 0.13364619E-05_JPRB, 0.13212817E-05_JPRB, &
  & 0.13052312E-05_JPRB, 0.12877216E-05_JPRB, 0.12737365E-05_JPRB, 0.12646616E-05_JPRB, 0.12536703E-05_JPRB, 0.12419654E-05_JPRB, &
  & 0.12328552E-05_JPRB, 0.12288320E-05_JPRB, 0.12308862E-05_JPRB, 0.12357485E-05_JPRB  /)

RGHG2(:,35, 9) = (/ &
  & 0.15446879E-05_JPRB, 0.15413035E-05_JPRB, 0.15320230E-05_JPRB, 0.15180979E-05_JPRB, 0.15020422E-05_JPRB, 0.14846808E-05_JPRB, &
  & 0.14680574E-05_JPRB, 0.14571081E-05_JPRB, 0.14508121E-05_JPRB, 0.14522119E-05_JPRB, 0.14667335E-05_JPRB, 0.14909957E-05_JPRB, &
  & 0.15130215E-05_JPRB, 0.15274898E-05_JPRB, 0.15366179E-05_JPRB, 0.15438630E-05_JPRB, 0.15524858E-05_JPRB, 0.15645780E-05_JPRB, &
  & 0.15785906E-05_JPRB, 0.15930248E-05_JPRB, 0.16088998E-05_JPRB, 0.16251262E-05_JPRB, 0.16414747E-05_JPRB, 0.16561151E-05_JPRB, &
  & 0.16674899E-05_JPRB, 0.16757341E-05_JPRB, 0.16818459E-05_JPRB, 0.16875548E-05_JPRB, 0.16934429E-05_JPRB, 0.16985543E-05_JPRB, &
  & 0.17028590E-05_JPRB, 0.17068089E-05_JPRB, 0.17093523E-05_JPRB, 0.17101956E-05_JPRB, 0.17095683E-05_JPRB, 0.17085727E-05_JPRB, &
  & 0.17066521E-05_JPRB, 0.17041818E-05_JPRB, 0.17007202E-05_JPRB, 0.16955348E-05_JPRB, 0.16876290E-05_JPRB, 0.16775711E-05_JPRB, &
  & 0.16639254E-05_JPRB, 0.16452159E-05_JPRB, 0.16217512E-05_JPRB, 0.15953539E-05_JPRB, 0.15647012E-05_JPRB, 0.15311062E-05_JPRB, &
  & 0.14936375E-05_JPRB, 0.14587516E-05_JPRB, 0.14308569E-05_JPRB, 0.14120453E-05_JPRB, 0.13957412E-05_JPRB, 0.13797151E-05_JPRB, &
  & 0.13634664E-05_JPRB, 0.13460265E-05_JPRB, 0.13312514E-05_JPRB, 0.13205711E-05_JPRB, 0.13086948E-05_JPRB, 0.12977047E-05_JPRB, &
  & 0.12896749E-05_JPRB, 0.12859867E-05_JPRB, 0.12878986E-05_JPRB, 0.12940032E-05_JPRB  /)

RGHG2(:,36, 9) = (/ &
  & 0.15960104E-05_JPRB, 0.15927210E-05_JPRB, 0.15844698E-05_JPRB, 0.15720753E-05_JPRB, 0.15575600E-05_JPRB, 0.15412735E-05_JPRB, &
  & 0.15244304E-05_JPRB, 0.15120744E-05_JPRB, 0.15029600E-05_JPRB, 0.14991373E-05_JPRB, 0.15069377E-05_JPRB, 0.15248173E-05_JPRB, &
  & 0.15421351E-05_JPRB, 0.15540682E-05_JPRB, 0.15627759E-05_JPRB, 0.15708312E-05_JPRB, 0.15798983E-05_JPRB, 0.15924049E-05_JPRB, &
  & 0.16062790E-05_JPRB, 0.16204952E-05_JPRB, 0.16359131E-05_JPRB, 0.16512381E-05_JPRB, 0.16663462E-05_JPRB, 0.16793906E-05_JPRB, &
  & 0.16882977E-05_JPRB, 0.16934431E-05_JPRB, 0.16962921E-05_JPRB, 0.16983920E-05_JPRB, 0.17007940E-05_JPRB, 0.17038474E-05_JPRB, &
  & 0.17072627E-05_JPRB, 0.17114754E-05_JPRB, 0.17154899E-05_JPRB, 0.17188334E-05_JPRB, 0.17217497E-05_JPRB, 0.17246396E-05_JPRB, &
  & 0.17265855E-05_JPRB, 0.17275742E-05_JPRB, 0.17274128E-05_JPRB, 0.17254023E-05_JPRB, 0.17208378E-05_JPRB, 0.17140920E-05_JPRB, &
  & 0.17039314E-05_JPRB, 0.16897314E-05_JPRB, 0.16708732E-05_JPRB, 0.16472806E-05_JPRB, 0.16192463E-05_JPRB, 0.15877465E-05_JPRB, &
  & 0.15511710E-05_JPRB, 0.15163229E-05_JPRB, 0.14878852E-05_JPRB, 0.14684632E-05_JPRB, 0.14513321E-05_JPRB, 0.14348740E-05_JPRB, &
  & 0.14188452E-05_JPRB, 0.14017365E-05_JPRB, 0.13864964E-05_JPRB, 0.13746903E-05_JPRB, 0.13623104E-05_JPRB, 0.13520389E-05_JPRB, &
  & 0.13448868E-05_JPRB, 0.13413582E-05_JPRB, 0.13432552E-05_JPRB, 0.13500030E-05_JPRB  /)

RGHG2(:,37, 9) = (/ &
  & 0.16285342E-05_JPRB, 0.16250206E-05_JPRB, 0.16180013E-05_JPRB, 0.16074083E-05_JPRB, 0.15949060E-05_JPRB, 0.15806323E-05_JPRB, &
  & 0.15648974E-05_JPRB, 0.15527657E-05_JPRB, 0.15432646E-05_JPRB, 0.15371972E-05_JPRB, 0.15403944E-05_JPRB, 0.15531968E-05_JPRB, &
  & 0.15670893E-05_JPRB, 0.15774323E-05_JPRB, 0.15857868E-05_JPRB, 0.15942957E-05_JPRB, 0.16034479E-05_JPRB, 0.16152380E-05_JPRB, &
  & 0.16282616E-05_JPRB, 0.16414984E-05_JPRB, 0.16552669E-05_JPRB, 0.16686846E-05_JPRB, 0.16810789E-05_JPRB, 0.16909326E-05_JPRB, &
  & 0.16971103E-05_JPRB, 0.17001371E-05_JPRB, 0.17013625E-05_JPRB, 0.17022691E-05_JPRB, 0.17039004E-05_JPRB, 0.17063095E-05_JPRB, &
  & 0.17092712E-05_JPRB, 0.17133086E-05_JPRB, 0.17175499E-05_JPRB, 0.17217182E-05_JPRB, 0.17258020E-05_JPRB, 0.17300295E-05_JPRB, &
  & 0.17334754E-05_JPRB, 0.17361264E-05_JPRB, 0.17381455E-05_JPRB, 0.17387871E-05_JPRB, 0.17364519E-05_JPRB, 0.17316107E-05_JPRB, &
  & 0.17240867E-05_JPRB, 0.17136624E-05_JPRB, 0.16985284E-05_JPRB, 0.16779797E-05_JPRB, 0.16533603E-05_JPRB, 0.16248012E-05_JPRB, &
  & 0.15915530E-05_JPRB, 0.15590605E-05_JPRB, 0.15319476E-05_JPRB, 0.15123014E-05_JPRB, 0.14950079E-05_JPRB, 0.14790936E-05_JPRB, &
  & 0.14642297E-05_JPRB, 0.14480308E-05_JPRB, 0.14331000E-05_JPRB, 0.14213378E-05_JPRB, 0.14093598E-05_JPRB, 0.13997713E-05_JPRB, &
  & 0.13929775E-05_JPRB, 0.13891963E-05_JPRB, 0.13913717E-05_JPRB, 0.13973489E-05_JPRB  /)

RGHG2(:,38, 9) = (/ &
  & 0.16646222E-05_JPRB, 0.16608598E-05_JPRB, 0.16552075E-05_JPRB, 0.16466135E-05_JPRB, 0.16363446E-05_JPRB, 0.16243044E-05_JPRB, &
  & 0.16097992E-05_JPRB, 0.15979162E-05_JPRB, 0.15879862E-05_JPRB, 0.15794279E-05_JPRB, 0.15775177E-05_JPRB, 0.15846864E-05_JPRB, &
  & 0.15947782E-05_JPRB, 0.16033567E-05_JPRB, 0.16113195E-05_JPRB, 0.16203317E-05_JPRB, 0.16295783E-05_JPRB, 0.16405733E-05_JPRB, &
  & 0.16526533E-05_JPRB, 0.16648034E-05_JPRB, 0.16767416E-05_JPRB, 0.16880431E-05_JPRB, 0.16974260E-05_JPRB, 0.17037394E-05_JPRB, &
  & 0.17068887E-05_JPRB, 0.17075648E-05_JPRB, 0.17069884E-05_JPRB, 0.17065710E-05_JPRB, 0.17073472E-05_JPRB, 0.17090414E-05_JPRB, &
  & 0.17114998E-05_JPRB, 0.17153427E-05_JPRB, 0.17198357E-05_JPRB, 0.17249191E-05_JPRB, 0.17302983E-05_JPRB, 0.17360101E-05_JPRB, &
  & 0.17411204E-05_JPRB, 0.17456159E-05_JPRB, 0.17500544E-05_JPRB, 0.17536386E-05_JPRB, 0.17537771E-05_JPRB, 0.17510493E-05_JPRB, &
  & 0.17464508E-05_JPRB, 0.17402161E-05_JPRB, 0.17292144E-05_JPRB, 0.17120430E-05_JPRB, 0.16912128E-05_JPRB, 0.16659167E-05_JPRB, &
  & 0.16363604E-05_JPRB, 0.16064817E-05_JPRB, 0.15808387E-05_JPRB, 0.15609437E-05_JPRB, 0.15434701E-05_JPRB, 0.15281592E-05_JPRB, &
  & 0.15145879E-05_JPRB, 0.14993985E-05_JPRB, 0.14848108E-05_JPRB, 0.14730972E-05_JPRB, 0.14615654E-05_JPRB, 0.14527348E-05_JPRB, &
  & 0.14463384E-05_JPRB, 0.14422770E-05_JPRB, 0.14447612E-05_JPRB, 0.14498834E-05_JPRB  /)

RGHG2(:,39, 9) = (/ &
  & 0.16795980E-05_JPRB, 0.16765539E-05_JPRB, 0.16722412E-05_JPRB, 0.16653110E-05_JPRB, 0.16568909E-05_JPRB, 0.16468209E-05_JPRB, &
  & 0.16343976E-05_JPRB, 0.16236003E-05_JPRB, 0.16146216E-05_JPRB, 0.16060712E-05_JPRB, 0.16021908E-05_JPRB, 0.16062678E-05_JPRB, &
  & 0.16140105E-05_JPRB, 0.16213653E-05_JPRB, 0.16286775E-05_JPRB, 0.16372062E-05_JPRB, 0.16458452E-05_JPRB, 0.16558688E-05_JPRB, &
  & 0.16668377E-05_JPRB, 0.16774644E-05_JPRB, 0.16874941E-05_JPRB, 0.16964654E-05_JPRB, 0.17033387E-05_JPRB, 0.17075137E-05_JPRB, &
  & 0.17092249E-05_JPRB, 0.17090334E-05_JPRB, 0.17080227E-05_JPRB, 0.17074659E-05_JPRB, 0.17081972E-05_JPRB, 0.17096784E-05_JPRB, &
  & 0.17118613E-05_JPRB, 0.17154233E-05_JPRB, 0.17198154E-05_JPRB, 0.17248771E-05_JPRB, 0.17303799E-05_JPRB, 0.17363761E-05_JPRB, &
  & 0.17419512E-05_JPRB, 0.17473553E-05_JPRB, 0.17528549E-05_JPRB, 0.17573463E-05_JPRB, 0.17588344E-05_JPRB, 0.17571756E-05_JPRB, &
  & 0.17535870E-05_JPRB, 0.17489983E-05_JPRB, 0.17401333E-05_JPRB, 0.17254773E-05_JPRB, 0.17071902E-05_JPRB, 0.16846032E-05_JPRB, &
  & 0.16588966E-05_JPRB, 0.16327377E-05_JPRB, 0.16097037E-05_JPRB, 0.15909199E-05_JPRB, 0.15746275E-05_JPRB, 0.15604847E-05_JPRB, &
  & 0.15481432E-05_JPRB, 0.15341243E-05_JPRB, 0.15204116E-05_JPRB, 0.15093539E-05_JPRB, 0.14984568E-05_JPRB, 0.14899985E-05_JPRB, &
  & 0.14835912E-05_JPRB, 0.14795613E-05_JPRB, 0.14818673E-05_JPRB, 0.14859449E-05_JPRB  /)

RGHG2(:,40, 9) = (/ &
  & 0.16937193E-05_JPRB, 0.16916763E-05_JPRB, 0.16889314E-05_JPRB, 0.16838990E-05_JPRB, 0.16775858E-05_JPRB, 0.16697849E-05_JPRB, &
  & 0.16599443E-05_JPRB, 0.16505579E-05_JPRB, 0.16429214E-05_JPRB, 0.16347891E-05_JPRB, 0.16291100E-05_JPRB, 0.16299744E-05_JPRB, &
  & 0.16351977E-05_JPRB, 0.16412048E-05_JPRB, 0.16477111E-05_JPRB, 0.16555109E-05_JPRB, 0.16633220E-05_JPRB, 0.16721767E-05_JPRB, &
  & 0.16818144E-05_JPRB, 0.16905818E-05_JPRB, 0.16983588E-05_JPRB, 0.17045605E-05_JPRB, 0.17085705E-05_JPRB, 0.17104654E-05_JPRB, &
  & 0.17107492E-05_JPRB, 0.17097820E-05_JPRB, 0.17084853E-05_JPRB, 0.17079587E-05_JPRB, 0.17087698E-05_JPRB, 0.17100832E-05_JPRB, &
  & 0.17119801E-05_JPRB, 0.17151983E-05_JPRB, 0.17194144E-05_JPRB, 0.17242973E-05_JPRB, 0.17297533E-05_JPRB, 0.17358870E-05_JPRB, &
  & 0.17418114E-05_JPRB, 0.17481287E-05_JPRB, 0.17546515E-05_JPRB, 0.17598745E-05_JPRB, 0.17627626E-05_JPRB, 0.17621874E-05_JPRB, &
  & 0.17594708E-05_JPRB, 0.17563975E-05_JPRB, 0.17497136E-05_JPRB, 0.17378685E-05_JPRB, 0.17223622E-05_JPRB, 0.17028639E-05_JPRB, &
  & 0.16817010E-05_JPRB, 0.16600887E-05_JPRB, 0.16403029E-05_JPRB, 0.16230456E-05_JPRB, 0.16083622E-05_JPRB, 0.15956826E-05_JPRB, &
  & 0.15847741E-05_JPRB, 0.15721552E-05_JPRB, 0.15595565E-05_JPRB, 0.15493679E-05_JPRB, 0.15392464E-05_JPRB, 0.15311622E-05_JPRB, &
  & 0.15246751E-05_JPRB, 0.15207332E-05_JPRB, 0.15227504E-05_JPRB, 0.15255710E-05_JPRB  /)

RGHG2(:,41, 9) = (/ &
  & 0.17109846E-05_JPRB, 0.17101657E-05_JPRB, 0.17093376E-05_JPRB, 0.17066256E-05_JPRB, 0.17028883E-05_JPRB, 0.16978617E-05_JPRB, &
  & 0.16911788E-05_JPRB, 0.16835175E-05_JPRB, 0.16775221E-05_JPRB, 0.16699009E-05_JPRB, 0.16620225E-05_JPRB, 0.16589591E-05_JPRB, &
  & 0.16611022E-05_JPRB, 0.16654614E-05_JPRB, 0.16709824E-05_JPRB, 0.16778911E-05_JPRB, 0.16846900E-05_JPRB, 0.16921155E-05_JPRB, &
  & 0.17001256E-05_JPRB, 0.17066197E-05_JPRB, 0.17116426E-05_JPRB, 0.17144579E-05_JPRB, 0.17149672E-05_JPRB, 0.17140744E-05_JPRB, &
  & 0.17126128E-05_JPRB, 0.17106973E-05_JPRB, 0.17090509E-05_JPRB, 0.17085613E-05_JPRB, 0.17094699E-05_JPRB, 0.17105782E-05_JPRB, &
  & 0.17121253E-05_JPRB, 0.17149232E-05_JPRB, 0.17189240E-05_JPRB, 0.17235883E-05_JPRB, 0.17289872E-05_JPRB, 0.17352891E-05_JPRB, &
  & 0.17416405E-05_JPRB, 0.17490743E-05_JPRB, 0.17568480E-05_JPRB, 0.17629655E-05_JPRB, 0.17675653E-05_JPRB, 0.17683151E-05_JPRB, &
  & 0.17666645E-05_JPRB, 0.17654441E-05_JPRB, 0.17614269E-05_JPRB, 0.17530187E-05_JPRB, 0.17409121E-05_JPRB, 0.17251903E-05_JPRB, &
  & 0.17095828E-05_JPRB, 0.16935292E-05_JPRB, 0.16777149E-05_JPRB, 0.16623239E-05_JPRB, 0.16496078E-05_JPRB, 0.16387173E-05_JPRB, &
  & 0.16295608E-05_JPRB, 0.16186535E-05_JPRB, 0.16074167E-05_JPRB, 0.15982908E-05_JPRB, 0.15891176E-05_JPRB, 0.15814908E-05_JPRB, &
  & 0.15749062E-05_JPRB, 0.15710719E-05_JPRB, 0.15727360E-05_JPRB, 0.15740198E-05_JPRB  /)

RGHG2(:,42, 9) = (/ &
  & 0.17072431E-05_JPRB, 0.17068142E-05_JPRB, 0.17060404E-05_JPRB, 0.17038651E-05_JPRB, 0.17008057E-05_JPRB, 0.16966726E-05_JPRB, &
  & 0.16913531E-05_JPRB, 0.16852981E-05_JPRB, 0.16803559E-05_JPRB, 0.16745951E-05_JPRB, 0.16686843E-05_JPRB, 0.16663802E-05_JPRB, &
  & 0.16681831E-05_JPRB, 0.16719285E-05_JPRB, 0.16766797E-05_JPRB, 0.16824125E-05_JPRB, 0.16882289E-05_JPRB, 0.16945212E-05_JPRB, &
  & 0.17011191E-05_JPRB, 0.17065854E-05_JPRB, 0.17107271E-05_JPRB, 0.17129775E-05_JPRB, 0.17134122E-05_JPRB, 0.17128374E-05_JPRB, &
  & 0.17120696E-05_JPRB, 0.17108648E-05_JPRB, 0.17094996E-05_JPRB, 0.17089053E-05_JPRB, 0.17094389E-05_JPRB, 0.17105803E-05_JPRB, &
  & 0.17123541E-05_JPRB, 0.17153647E-05_JPRB, 0.17193543E-05_JPRB, 0.17237654E-05_JPRB, 0.17287240E-05_JPRB, 0.17344667E-05_JPRB, &
  & 0.17404241E-05_JPRB, 0.17471025E-05_JPRB, 0.17541646E-05_JPRB, 0.17604876E-05_JPRB, 0.17646876E-05_JPRB, 0.17652672E-05_JPRB, &
  & 0.17635957E-05_JPRB, 0.17621871E-05_JPRB, 0.17577089E-05_JPRB, 0.17494455E-05_JPRB, 0.17380901E-05_JPRB, 0.17240327E-05_JPRB, &
  & 0.17098544E-05_JPRB, 0.16955502E-05_JPRB, 0.16817010E-05_JPRB, 0.16685441E-05_JPRB, 0.16575072E-05_JPRB, 0.16476220E-05_JPRB, &
  & 0.16395446E-05_JPRB, 0.16298700E-05_JPRB, 0.16196308E-05_JPRB, 0.16108801E-05_JPRB, 0.16022923E-05_JPRB, 0.15951061E-05_JPRB, &
  & 0.15894546E-05_JPRB, 0.15868693E-05_JPRB, 0.15880564E-05_JPRB, 0.15885450E-05_JPRB  /)

RGHG2(:,43, 9) = (/ &
  & 0.17112561E-05_JPRB, 0.17117096E-05_JPRB, 0.17118098E-05_JPRB, 0.17111222E-05_JPRB, 0.17097894E-05_JPRB, 0.17076648E-05_JPRB, &
  & 0.17049477E-05_JPRB, 0.17011002E-05_JPRB, 0.16978249E-05_JPRB, 0.16939814E-05_JPRB, 0.16889198E-05_JPRB, 0.16856189E-05_JPRB, &
  & 0.16857864E-05_JPRB, 0.16882631E-05_JPRB, 0.16918881E-05_JPRB, 0.16961646E-05_JPRB, 0.17006492E-05_JPRB, 0.17052929E-05_JPRB, &
  & 0.17099021E-05_JPRB, 0.17134528E-05_JPRB, 0.17156059E-05_JPRB, 0.17158842E-05_JPRB, 0.17147449E-05_JPRB, 0.17132612E-05_JPRB, &
  & 0.17123757E-05_JPRB, 0.17114114E-05_JPRB, 0.17101523E-05_JPRB, 0.17094784E-05_JPRB, 0.17097118E-05_JPRB, 0.17107951E-05_JPRB, &
  & 0.17126253E-05_JPRB, 0.17156492E-05_JPRB, 0.17195360E-05_JPRB, 0.17236220E-05_JPRB, 0.17281543E-05_JPRB, 0.17334591E-05_JPRB, &
  & 0.17392408E-05_JPRB, 0.17457102E-05_JPRB, 0.17526612E-05_JPRB, 0.17595564E-05_JPRB, 0.17641279E-05_JPRB, 0.17651221E-05_JPRB, &
  & 0.17638901E-05_JPRB, 0.17631068E-05_JPRB, 0.17593551E-05_JPRB, 0.17527021E-05_JPRB, 0.17434946E-05_JPRB, 0.17325802E-05_JPRB, &
  & 0.17220956E-05_JPRB, 0.17117786E-05_JPRB, 0.17014306E-05_JPRB, 0.16911148E-05_JPRB, 0.16824564E-05_JPRB, 0.16742579E-05_JPRB, &
  & 0.16679187E-05_JPRB, 0.16601050E-05_JPRB, 0.16513619E-05_JPRB, 0.16434106E-05_JPRB, 0.16357649E-05_JPRB, 0.16291775E-05_JPRB, &
  & 0.16243353E-05_JPRB, 0.16229359E-05_JPRB, 0.16235358E-05_JPRB, 0.16226379E-05_JPRB  /)

RGHG2(:,44, 9) = (/ &
  & 0.17111588E-05_JPRB, 0.17114208E-05_JPRB, 0.17114798E-05_JPRB, 0.17109871E-05_JPRB, 0.17100635E-05_JPRB, 0.17085390E-05_JPRB, &
  & 0.17065689E-05_JPRB, 0.17038430E-05_JPRB, 0.17014186E-05_JPRB, 0.16985782E-05_JPRB, 0.16948354E-05_JPRB, 0.16922280E-05_JPRB, &
  & 0.16923326E-05_JPRB, 0.16943243E-05_JPRB, 0.16973192E-05_JPRB, 0.17008023E-05_JPRB, 0.17044717E-05_JPRB, 0.17081625E-05_JPRB, &
  & 0.17118151E-05_JPRB, 0.17146125E-05_JPRB, 0.17162369E-05_JPRB, 0.17162276E-05_JPRB, 0.17150586E-05_JPRB, 0.17135865E-05_JPRB, &
  & 0.17128298E-05_JPRB, 0.17118281E-05_JPRB, 0.17106122E-05_JPRB, 0.17098079E-05_JPRB, 0.17099495E-05_JPRB, 0.17109764E-05_JPRB, &
  & 0.17129476E-05_JPRB, 0.17159850E-05_JPRB, 0.17197553E-05_JPRB, 0.17236380E-05_JPRB, 0.17280248E-05_JPRB, 0.17332103E-05_JPRB, &
  & 0.17389151E-05_JPRB, 0.17452504E-05_JPRB, 0.17519481E-05_JPRB, 0.17587547E-05_JPRB, 0.17631036E-05_JPRB, 0.17641925E-05_JPRB, &
  & 0.17629825E-05_JPRB, 0.17622027E-05_JPRB, 0.17584261E-05_JPRB, 0.17520637E-05_JPRB, 0.17439530E-05_JPRB, 0.17343964E-05_JPRB, &
  & 0.17252493E-05_JPRB, 0.17163464E-05_JPRB, 0.17073823E-05_JPRB, 0.16986165E-05_JPRB, 0.16912914E-05_JPRB, 0.16843373E-05_JPRB, &
  & 0.16788661E-05_JPRB, 0.16718988E-05_JPRB, 0.16641334E-05_JPRB, 0.16567485E-05_JPRB, 0.16498469E-05_JPRB, 0.16439088E-05_JPRB, &
  & 0.16396276E-05_JPRB, 0.16391717E-05_JPRB, 0.16393982E-05_JPRB, 0.16384341E-05_JPRB  /)

RGHG2(:,45, 9) = (/ &
  & 0.17115550E-05_JPRB, 0.17117105E-05_JPRB, 0.17118329E-05_JPRB, 0.17117501E-05_JPRB, 0.17115104E-05_JPRB, 0.17109228E-05_JPRB, &
  & 0.17101319E-05_JPRB, 0.17089617E-05_JPRB, 0.17077165E-05_JPRB, 0.17062603E-05_JPRB, 0.17041260E-05_JPRB, 0.17021822E-05_JPRB, &
  & 0.17020088E-05_JPRB, 0.17032880E-05_JPRB, 0.17054234E-05_JPRB, 0.17078191E-05_JPRB, 0.17103922E-05_JPRB, 0.17127900E-05_JPRB, &
  & 0.17151024E-05_JPRB, 0.17168003E-05_JPRB, 0.17175716E-05_JPRB, 0.17169857E-05_JPRB, 0.17155841E-05_JPRB, 0.17140104E-05_JPRB, &
  & 0.17133854E-05_JPRB, 0.17123715E-05_JPRB, 0.17112182E-05_JPRB, 0.17102553E-05_JPRB, 0.17102546E-05_JPRB, 0.17112100E-05_JPRB, &
  & 0.17133486E-05_JPRB, 0.17164031E-05_JPRB, 0.17200278E-05_JPRB, 0.17236382E-05_JPRB, 0.17278054E-05_JPRB, 0.17327998E-05_JPRB, &
  & 0.17383947E-05_JPRB, 0.17445512E-05_JPRB, 0.17509463E-05_JPRB, 0.17577245E-05_JPRB, 0.17618668E-05_JPRB, 0.17631159E-05_JPRB, &
  & 0.17619864E-05_JPRB, 0.17612895E-05_JPRB, 0.17575764E-05_JPRB, 0.17517483E-05_JPRB, 0.17451576E-05_JPRB, 0.17375438E-05_JPRB, &
  & 0.17303859E-05_JPRB, 0.17235966E-05_JPRB, 0.17166502E-05_JPRB, 0.17100077E-05_JPRB, 0.17045011E-05_JPRB, 0.16991767E-05_JPRB, &
  & 0.16949131E-05_JPRB, 0.16891446E-05_JPRB, 0.16826811E-05_JPRB, 0.16760420E-05_JPRB, 0.16701065E-05_JPRB, 0.16649833E-05_JPRB, &
  & 0.16614430E-05_JPRB, 0.16622110E-05_JPRB, 0.16619382E-05_JPRB, 0.16607236E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART18',0,ZHOOK_HANDLE)



RGHG2(:,46, 9) = (/ &
  & 0.17113239E-05_JPRB, 0.17113872E-05_JPRB, 0.17115041E-05_JPRB, 0.17115279E-05_JPRB, 0.17114711E-05_JPRB, 0.17112105E-05_JPRB, &
  & 0.17108314E-05_JPRB, 0.17102780E-05_JPRB, 0.17096374E-05_JPRB, 0.17088240E-05_JPRB, 0.17075356E-05_JPRB, 0.17062620E-05_JPRB, &
  & 0.17061827E-05_JPRB, 0.17072002E-05_JPRB, 0.17088309E-05_JPRB, 0.17106876E-05_JPRB, 0.17126463E-05_JPRB, 0.17143629E-05_JPRB, &
  & 0.17160721E-05_JPRB, 0.17172909E-05_JPRB, 0.17177462E-05_JPRB, 0.17170661E-05_JPRB, 0.17157256E-05_JPRB, 0.17143073E-05_JPRB, &
  & 0.17135781E-05_JPRB, 0.17125060E-05_JPRB, 0.17114296E-05_JPRB, 0.17104536E-05_JPRB, 0.17104298E-05_JPRB, 0.17112738E-05_JPRB, &
  & 0.17135111E-05_JPRB, 0.17165265E-05_JPRB, 0.17200814E-05_JPRB, 0.17235404E-05_JPRB, 0.17275402E-05_JPRB, 0.17323952E-05_JPRB, &
  & 0.17379688E-05_JPRB, 0.17441087E-05_JPRB, 0.17504407E-05_JPRB, 0.17571269E-05_JPRB, 0.17610794E-05_JPRB, 0.17623454E-05_JPRB, &
  & 0.17613896E-05_JPRB, 0.17606787E-05_JPRB, 0.17570341E-05_JPRB, 0.17515119E-05_JPRB, 0.17458408E-05_JPRB, 0.17395377E-05_JPRB, &
  & 0.17335590E-05_JPRB, 0.17280080E-05_JPRB, 0.17222454E-05_JPRB, 0.17168966E-05_JPRB, 0.17124950E-05_JPRB, 0.17082084E-05_JPRB, &
  & 0.17045156E-05_JPRB, 0.16994703E-05_JPRB, 0.16939017E-05_JPRB, 0.16878533E-05_JPRB, 0.16827502E-05_JPRB, 0.16783927E-05_JPRB, &
  & 0.16752150E-05_JPRB, 0.16758903E-05_JPRB, 0.16753660E-05_JPRB, 0.16740698E-05_JPRB  /)

RGHG2(:,47, 9) = (/ &
  & 0.17109269E-05_JPRB, 0.17108851E-05_JPRB, 0.17109816E-05_JPRB, 0.17110698E-05_JPRB, 0.17111272E-05_JPRB, 0.17111284E-05_JPRB, &
  & 0.17110786E-05_JPRB, 0.17110609E-05_JPRB, 0.17110147E-05_JPRB, 0.17108071E-05_JPRB, 0.17103585E-05_JPRB, 0.17098725E-05_JPRB, &
  & 0.17099783E-05_JPRB, 0.17107789E-05_JPRB, 0.17118886E-05_JPRB, 0.17132227E-05_JPRB, 0.17145568E-05_JPRB, 0.17155966E-05_JPRB, &
  & 0.17167457E-05_JPRB, 0.17175267E-05_JPRB, 0.17177186E-05_JPRB, 0.17170246E-05_JPRB, 0.17158146E-05_JPRB, 0.17146304E-05_JPRB, &
  & 0.17137315E-05_JPRB, 0.17125820E-05_JPRB, 0.17115985E-05_JPRB, 0.17106364E-05_JPRB, 0.17106093E-05_JPRB, 0.17113148E-05_JPRB, &
  & 0.17136539E-05_JPRB, 0.17166123E-05_JPRB, 0.17201003E-05_JPRB, 0.17234060E-05_JPRB, 0.17272200E-05_JPRB, 0.17319216E-05_JPRB, &
  & 0.17374879E-05_JPRB, 0.17436408E-05_JPRB, 0.17499467E-05_JPRB, 0.17565123E-05_JPRB, 0.17602454E-05_JPRB, 0.17615024E-05_JPRB, &
  & 0.17607693E-05_JPRB, 0.17600225E-05_JPRB, 0.17564595E-05_JPRB, 0.17512504E-05_JPRB, 0.17465381E-05_JPRB, 0.17416464E-05_JPRB, &
  & 0.17368890E-05_JPRB, 0.17326157E-05_JPRB, 0.17280753E-05_JPRB, 0.17240784E-05_JPRB, 0.17208305E-05_JPRB, 0.17176429E-05_JPRB, &
  & 0.17144923E-05_JPRB, 0.17102004E-05_JPRB, 0.17056005E-05_JPRB, 0.17002141E-05_JPRB, 0.16960609E-05_JPRB, 0.16925921E-05_JPRB, &
  & 0.16897642E-05_JPRB, 0.16900669E-05_JPRB, 0.16892972E-05_JPRB, 0.16879390E-05_JPRB  /)

RGHG2(:,48, 9) = (/ &
  & 0.17103130E-05_JPRB, 0.17102111E-05_JPRB, 0.17102888E-05_JPRB, 0.17104092E-05_JPRB, 0.17105255E-05_JPRB, 0.17106615E-05_JPRB, &
  & 0.17107673E-05_JPRB, 0.17109771E-05_JPRB, 0.17112086E-05_JPRB, 0.17113455E-05_JPRB, 0.17113311E-05_JPRB, 0.17112690E-05_JPRB, &
  & 0.17115055E-05_JPRB, 0.17121742E-05_JPRB, 0.17129718E-05_JPRB, 0.17139585E-05_JPRB, 0.17149266E-05_JPRB, 0.17156349E-05_JPRB, &
  & 0.17164957E-05_JPRB, 0.17170645E-05_JPRB, 0.17171744E-05_JPRB, 0.17165830E-05_JPRB, 0.17154975E-05_JPRB, 0.17144907E-05_JPRB, &
  & 0.17135958E-05_JPRB, 0.17124976E-05_JPRB, 0.17115811E-05_JPRB, 0.17106940E-05_JPRB, 0.17106700E-05_JPRB, 0.17112914E-05_JPRB, &
  & 0.17136281E-05_JPRB, 0.17165832E-05_JPRB, 0.17199982E-05_JPRB, 0.17231996E-05_JPRB, 0.17269032E-05_JPRB, 0.17315578E-05_JPRB, &
  & 0.17370919E-05_JPRB, 0.17432302E-05_JPRB, 0.17496089E-05_JPRB, 0.17560967E-05_JPRB, 0.17597465E-05_JPRB, 0.17610258E-05_JPRB, &
  & 0.17605406E-05_JPRB, 0.17597017E-05_JPRB, 0.17563137E-05_JPRB, 0.17514647E-05_JPRB, 0.17474777E-05_JPRB, 0.17437503E-05_JPRB, &
  & 0.17399535E-05_JPRB, 0.17366713E-05_JPRB, 0.17331529E-05_JPRB, 0.17301593E-05_JPRB, 0.17277403E-05_JPRB, 0.17253548E-05_JPRB, &
  & 0.17225924E-05_JPRB, 0.17189496E-05_JPRB, 0.17149777E-05_JPRB, 0.17102675E-05_JPRB, 0.17068480E-05_JPRB, 0.17040523E-05_JPRB, &
  & 0.17014467E-05_JPRB, 0.17012721E-05_JPRB, 0.17004767E-05_JPRB, 0.16991426E-05_JPRB  /)

RGHG2(:,49, 9) = (/ &
  & 0.17095345E-05_JPRB, 0.17093866E-05_JPRB, 0.17094442E-05_JPRB, 0.17095855E-05_JPRB, 0.17097420E-05_JPRB, 0.17099696E-05_JPRB, &
  & 0.17101687E-05_JPRB, 0.17104903E-05_JPRB, 0.17108853E-05_JPRB, 0.17112850E-05_JPRB, 0.17115668E-05_JPRB, 0.17118089E-05_JPRB, &
  & 0.17121655E-05_JPRB, 0.17127266E-05_JPRB, 0.17132736E-05_JPRB, 0.17139553E-05_JPRB, 0.17146355E-05_JPRB, 0.17151339E-05_JPRB, &
  & 0.17157988E-05_JPRB, 0.17162354E-05_JPRB, 0.17163369E-05_JPRB, 0.17159121E-05_JPRB, 0.17149617E-05_JPRB, 0.17141255E-05_JPRB, &
  & 0.17133139E-05_JPRB, 0.17123312E-05_JPRB, 0.17114770E-05_JPRB, 0.17107008E-05_JPRB, 0.17106831E-05_JPRB, 0.17112363E-05_JPRB, &
  & 0.17135228E-05_JPRB, 0.17164989E-05_JPRB, 0.17198302E-05_JPRB, 0.17229382E-05_JPRB, 0.17265540E-05_JPRB, 0.17312049E-05_JPRB, &
  & 0.17366921E-05_JPRB, 0.17428015E-05_JPRB, 0.17493057E-05_JPRB, 0.17557270E-05_JPRB, 0.17593462E-05_JPRB, 0.17606644E-05_JPRB, &
  & 0.17604655E-05_JPRB, 0.17594989E-05_JPRB, 0.17563474E-05_JPRB, 0.17519184E-05_JPRB, 0.17486285E-05_JPRB, 0.17460780E-05_JPRB, &
  & 0.17432264E-05_JPRB, 0.17409116E-05_JPRB, 0.17384337E-05_JPRB, 0.17363928E-05_JPRB, 0.17347441E-05_JPRB, 0.17331117E-05_JPRB, &
  & 0.17307091E-05_JPRB, 0.17277379E-05_JPRB, 0.17243066E-05_JPRB, 0.17203516E-05_JPRB, 0.17176462E-05_JPRB, 0.17154978E-05_JPRB, &
  & 0.17130806E-05_JPRB, 0.17123298E-05_JPRB, 0.17116060E-05_JPRB, 0.17103375E-05_JPRB  /)

RGHG2(:,50, 9) = (/ &
  & 0.17087388E-05_JPRB, 0.17085671E-05_JPRB, 0.17086108E-05_JPRB, 0.17087573E-05_JPRB, 0.17089294E-05_JPRB, 0.17091921E-05_JPRB, &
  & 0.17094365E-05_JPRB, 0.17097923E-05_JPRB, 0.17102398E-05_JPRB, 0.17107657E-05_JPRB, 0.17111968E-05_JPRB, 0.17115825E-05_JPRB, &
  & 0.17119797E-05_JPRB, 0.17124287E-05_JPRB, 0.17127910E-05_JPRB, 0.17132739E-05_JPRB, 0.17137667E-05_JPRB, 0.17141441E-05_JPRB, &
  & 0.17147148E-05_JPRB, 0.17151292E-05_JPRB, 0.17153117E-05_JPRB, 0.17150893E-05_JPRB, 0.17142953E-05_JPRB, 0.17135982E-05_JPRB, &
  & 0.17129319E-05_JPRB, 0.17121077E-05_JPRB, 0.17114047E-05_JPRB, 0.17107531E-05_JPRB, 0.17107432E-05_JPRB, 0.17112444E-05_JPRB, &
  & 0.17133544E-05_JPRB, 0.17162834E-05_JPRB, 0.17195239E-05_JPRB, 0.17225631E-05_JPRB, 0.17261608E-05_JPRB, 0.17308800E-05_JPRB, &
  & 0.17363419E-05_JPRB, 0.17424601E-05_JPRB, 0.17491641E-05_JPRB, 0.17555797E-05_JPRB, 0.17590924E-05_JPRB, 0.17605096E-05_JPRB, &
  & 0.17605464E-05_JPRB, 0.17594783E-05_JPRB, 0.17566270E-05_JPRB, 0.17525630E-05_JPRB, 0.17499319E-05_JPRB, 0.17483349E-05_JPRB, &
  & 0.17462875E-05_JPRB, 0.17446662E-05_JPRB, 0.17430228E-05_JPRB, 0.17418936E-05_JPRB, 0.17409406E-05_JPRB, 0.17400252E-05_JPRB, &
  & 0.17380737E-05_JPRB, 0.17357267E-05_JPRB, 0.17328423E-05_JPRB, 0.17296090E-05_JPRB, 0.17274331E-05_JPRB, 0.17257487E-05_JPRB, &
  & 0.17236250E-05_JPRB, 0.17226750E-05_JPRB, 0.17221467E-05_JPRB, 0.17211226E-05_JPRB  /)

RGHG2(:,51, 9) = (/ &
  & 0.17078690E-05_JPRB, 0.17076834E-05_JPRB, 0.17077153E-05_JPRB, 0.17078592E-05_JPRB, 0.17080351E-05_JPRB, 0.17083062E-05_JPRB, &
  & 0.17085741E-05_JPRB, 0.17089265E-05_JPRB, 0.17093723E-05_JPRB, 0.17099628E-05_JPRB, 0.17104783E-05_JPRB, 0.17109347E-05_JPRB, &
  & 0.17113342E-05_JPRB, 0.17116595E-05_JPRB, 0.17118565E-05_JPRB, 0.17121804E-05_JPRB, 0.17125232E-05_JPRB, 0.17128168E-05_JPRB, &
  & 0.17133389E-05_JPRB, 0.17137870E-05_JPRB, 0.17141041E-05_JPRB, 0.17141194E-05_JPRB, 0.17135060E-05_JPRB, 0.17129426E-05_JPRB, &
  & 0.17124659E-05_JPRB, 0.17118358E-05_JPRB, 0.17113431E-05_JPRB, 0.17108335E-05_JPRB, 0.17108328E-05_JPRB, 0.17112864E-05_JPRB, &
  & 0.17131389E-05_JPRB, 0.17159814E-05_JPRB, 0.17191201E-05_JPRB, 0.17220977E-05_JPRB, 0.17257123E-05_JPRB, 0.17305435E-05_JPRB, &
  & 0.17359892E-05_JPRB, 0.17421366E-05_JPRB, 0.17490959E-05_JPRB, 0.17555373E-05_JPRB, 0.17588949E-05_JPRB, 0.17604506E-05_JPRB, &
  & 0.17607160E-05_JPRB, 0.17595517E-05_JPRB, 0.17570589E-05_JPRB, 0.17533607E-05_JPRB, 0.17514218E-05_JPRB, 0.17507388E-05_JPRB, &
  & 0.17494873E-05_JPRB, 0.17484722E-05_JPRB, 0.17476229E-05_JPRB, 0.17474583E-05_JPRB, 0.17472186E-05_JPRB, 0.17470598E-05_JPRB, &
  & 0.17456441E-05_JPRB, 0.17439475E-05_JPRB, 0.17416579E-05_JPRB, 0.17391878E-05_JPRB, 0.17374874E-05_JPRB, 0.17362086E-05_JPRB, &
  & 0.17344577E-05_JPRB, 0.17334902E-05_JPRB, 0.17332385E-05_JPRB, 0.17325729E-05_JPRB  /)

RGHG2(:,52, 9) = (/ &
  & 0.17071563E-05_JPRB, 0.17069833E-05_JPRB, 0.17070099E-05_JPRB, 0.17071362E-05_JPRB, 0.17072953E-05_JPRB, 0.17075398E-05_JPRB, &
  & 0.17077917E-05_JPRB, 0.17081115E-05_JPRB, 0.17085064E-05_JPRB, 0.17090845E-05_JPRB, 0.17096085E-05_JPRB, 0.17100718E-05_JPRB, &
  & 0.17104562E-05_JPRB, 0.17107148E-05_JPRB, 0.17108390E-05_JPRB, 0.17110540E-05_JPRB, 0.17112955E-05_JPRB, 0.17115596E-05_JPRB, &
  & 0.17120562E-05_JPRB, 0.17125591E-05_JPRB, 0.17129952E-05_JPRB, 0.17132078E-05_JPRB, 0.17127642E-05_JPRB, 0.17123046E-05_JPRB, &
  & 0.17120480E-05_JPRB, 0.17116644E-05_JPRB, 0.17112935E-05_JPRB, 0.17109431E-05_JPRB, 0.17109610E-05_JPRB, 0.17113083E-05_JPRB, &
  & 0.17128561E-05_JPRB, 0.17155433E-05_JPRB, 0.17186494E-05_JPRB, 0.17215740E-05_JPRB, 0.17252266E-05_JPRB, 0.17302525E-05_JPRB, &
  & 0.17357719E-05_JPRB, 0.17420065E-05_JPRB, 0.17491995E-05_JPRB, 0.17555594E-05_JPRB, 0.17586837E-05_JPRB, 0.17603757E-05_JPRB, &
  & 0.17608363E-05_JPRB, 0.17597155E-05_JPRB, 0.17575024E-05_JPRB, 0.17540734E-05_JPRB, 0.17527146E-05_JPRB, 0.17526895E-05_JPRB, &
  & 0.17519487E-05_JPRB, 0.17514114E-05_JPRB, 0.17511343E-05_JPRB, 0.17518230E-05_JPRB, 0.17523037E-05_JPRB, 0.17528515E-05_JPRB, &
  & 0.17519726E-05_JPRB, 0.17508353E-05_JPRB, 0.17491157E-05_JPRB, 0.17473152E-05_JPRB, 0.17461386E-05_JPRB, 0.17453033E-05_JPRB, &
  & 0.17438604E-05_JPRB, 0.17430157E-05_JPRB, 0.17430878E-05_JPRB, 0.17427164E-05_JPRB  /)

RGHG2(:,53, 9) = (/ &
  & 0.17064405E-05_JPRB, 0.17062915E-05_JPRB, 0.17063149E-05_JPRB, 0.17064163E-05_JPRB, 0.17065491E-05_JPRB, 0.17067512E-05_JPRB, &
  & 0.17069703E-05_JPRB, 0.17072436E-05_JPRB, 0.17075642E-05_JPRB, 0.17080989E-05_JPRB, 0.17086031E-05_JPRB, 0.17090494E-05_JPRB, &
  & 0.17094107E-05_JPRB, 0.17096185E-05_JPRB, 0.17096989E-05_JPRB, 0.17098148E-05_JPRB, 0.17099645E-05_JPRB, 0.17102175E-05_JPRB, &
  & 0.17106953E-05_JPRB, 0.17112659E-05_JPRB, 0.17118256E-05_JPRB, 0.17122374E-05_JPRB, 0.17119746E-05_JPRB, 0.17116165E-05_JPRB, &
  & 0.17116112E-05_JPRB, 0.17115164E-05_JPRB, 0.17112441E-05_JPRB, 0.17110736E-05_JPRB, 0.17111155E-05_JPRB, 0.17113244E-05_JPRB, &
  & 0.17125221E-05_JPRB, 0.17150138E-05_JPRB, 0.17181112E-05_JPRB, 0.17209814E-05_JPRB, 0.17246833E-05_JPRB, 0.17299532E-05_JPRB, &
  & 0.17355875E-05_JPRB, 0.17419392E-05_JPRB, 0.17493785E-05_JPRB, 0.17556083E-05_JPRB, 0.17584485E-05_JPRB, 0.17602881E-05_JPRB, &
  & 0.17609484E-05_JPRB, 0.17599286E-05_JPRB, 0.17579899E-05_JPRB, 0.17548168E-05_JPRB, 0.17540465E-05_JPRB, 0.17546394E-05_JPRB, &
  & 0.17543451E-05_JPRB, 0.17542786E-05_JPRB, 0.17545393E-05_JPRB, 0.17561144E-05_JPRB, 0.17573824E-05_JPRB, 0.17586806E-05_JPRB, &
  & 0.17583864E-05_JPRB, 0.17578233E-05_JPRB, 0.17567148E-05_JPRB, 0.17556074E-05_JPRB, 0.17550198E-05_JPRB, 0.17546822E-05_JPRB, &
  & 0.17535496E-05_JPRB, 0.17528926E-05_JPRB, 0.17533355E-05_JPRB, 0.17532597E-05_JPRB  /)

RGHG2(:,54, 9) = (/ &
  & 0.17059561E-05_JPRB, 0.17058309E-05_JPRB, 0.17058452E-05_JPRB, 0.17059251E-05_JPRB, 0.17060314E-05_JPRB, 0.17061895E-05_JPRB, &
  & 0.17063641E-05_JPRB, 0.17065866E-05_JPRB, 0.17068291E-05_JPRB, 0.17072881E-05_JPRB, 0.17077349E-05_JPRB, 0.17081486E-05_JPRB, &
  & 0.17084837E-05_JPRB, 0.17086775E-05_JPRB, 0.17087501E-05_JPRB, 0.17088404E-05_JPRB, 0.17089677E-05_JPRB, 0.17092117E-05_JPRB, &
  & 0.17096574E-05_JPRB, 0.17102653E-05_JPRB, 0.17109100E-05_JPRB, 0.17114353E-05_JPRB, 0.17113023E-05_JPRB, 0.17110678E-05_JPRB, &
  & 0.17112172E-05_JPRB, 0.17113370E-05_JPRB, 0.17111747E-05_JPRB, 0.17111323E-05_JPRB, 0.17111112E-05_JPRB, 0.17111688E-05_JPRB, &
  & 0.17121533E-05_JPRB, 0.17144583E-05_JPRB, 0.17175019E-05_JPRB, 0.17203426E-05_JPRB, 0.17241603E-05_JPRB, 0.17296575E-05_JPRB, &
  & 0.17355693E-05_JPRB, 0.17422153E-05_JPRB, 0.17497803E-05_JPRB, 0.17556994E-05_JPRB, 0.17582638E-05_JPRB, 0.17601783E-05_JPRB, &
  & 0.17609332E-05_JPRB, 0.17600434E-05_JPRB, 0.17584157E-05_JPRB, 0.17554270E-05_JPRB, 0.17549687E-05_JPRB, 0.17557954E-05_JPRB, &
  & 0.17557522E-05_JPRB, 0.17561377E-05_JPRB, 0.17569324E-05_JPRB, 0.17591204E-05_JPRB, 0.17608929E-05_JPRB, 0.17626766E-05_JPRB, &
  & 0.17628196E-05_JPRB, 0.17626571E-05_JPRB, 0.17620628E-05_JPRB, 0.17615194E-05_JPRB, 0.17614057E-05_JPRB, 0.17613846E-05_JPRB, &
  & 0.17604800E-05_JPRB, 0.17600388E-05_JPRB, 0.17607588E-05_JPRB, 0.17608787E-05_JPRB  /)

RGHG2(:,55, 9) = (/ &
  & 0.17054499E-05_JPRB, 0.17053511E-05_JPRB, 0.17053547E-05_JPRB, 0.17054110E-05_JPRB, 0.17054880E-05_JPRB, 0.17055971E-05_JPRB, &
  & 0.17057208E-05_JPRB, 0.17058866E-05_JPRB, 0.17060420E-05_JPRB, 0.17064129E-05_JPRB, 0.17067912E-05_JPRB, 0.17071667E-05_JPRB, &
  & 0.17074725E-05_JPRB, 0.17076555E-05_JPRB, 0.17077242E-05_JPRB, 0.17077960E-05_JPRB, 0.17079076E-05_JPRB, 0.17081418E-05_JPRB, &
  & 0.17085503E-05_JPRB, 0.17091953E-05_JPRB, 0.17099291E-05_JPRB, 0.17105690E-05_JPRB, 0.17105729E-05_JPRB, 0.17104784E-05_JPRB, &
  & 0.17107863E-05_JPRB, 0.17111341E-05_JPRB, 0.17110952E-05_JPRB, 0.17111878E-05_JPRB, 0.17110855E-05_JPRB, 0.17109738E-05_JPRB, &
  & 0.17117400E-05_JPRB, 0.17138396E-05_JPRB, 0.17168176E-05_JPRB, 0.17196289E-05_JPRB, 0.17235837E-05_JPRB, 0.17293304E-05_JPRB, &
  & 0.17355710E-05_JPRB, 0.17425664E-05_JPRB, 0.17502547E-05_JPRB, 0.17558058E-05_JPRB, 0.17580659E-05_JPRB, 0.17600537E-05_JPRB, &
  & 0.17608997E-05_JPRB, 0.17601576E-05_JPRB, 0.17588794E-05_JPRB, 0.17560854E-05_JPRB, 0.17559364E-05_JPRB, 0.17569715E-05_JPRB, &
  & 0.17571808E-05_JPRB, 0.17580644E-05_JPRB, 0.17594503E-05_JPRB, 0.17622813E-05_JPRB, 0.17645754E-05_JPRB, 0.17668622E-05_JPRB, &
  & 0.17674700E-05_JPRB, 0.17677284E-05_JPRB, 0.17676909E-05_JPRB, 0.17677552E-05_JPRB, 0.17681514E-05_JPRB, 0.17684573E-05_JPRB, &
  & 0.17677944E-05_JPRB, 0.17675959E-05_JPRB, 0.17686105E-05_JPRB, 0.17689339E-05_JPRB  /)

RGHG2(:,56, 9) = (/ &
  & 0.17051717E-05_JPRB, 0.17050916E-05_JPRB, 0.17050871E-05_JPRB, 0.17051297E-05_JPRB, 0.17051905E-05_JPRB, 0.17052681E-05_JPRB, &
  & 0.17053512E-05_JPRB, 0.17054749E-05_JPRB, 0.17055837E-05_JPRB, 0.17058810E-05_JPRB, 0.17061937E-05_JPRB, 0.17065154E-05_JPRB, &
  & 0.17067800E-05_JPRB, 0.17069466E-05_JPRB, 0.17070251E-05_JPRB, 0.17071065E-05_JPRB, 0.17072421E-05_JPRB, 0.17074921E-05_JPRB, &
  & 0.17078541E-05_JPRB, 0.17084798E-05_JPRB, 0.17092098E-05_JPRB, 0.17098928E-05_JPRB, 0.17099904E-05_JPRB, 0.17099244E-05_JPRB, &
  & 0.17101916E-05_JPRB, 0.17105758E-05_JPRB, 0.17106865E-05_JPRB, 0.17108134E-05_JPRB, 0.17106021E-05_JPRB, 0.17102598E-05_JPRB, &
  & 0.17109895E-05_JPRB, 0.17130792E-05_JPRB, 0.17159891E-05_JPRB, 0.17189640E-05_JPRB, 0.17231002E-05_JPRB, 0.17291657E-05_JPRB, &
  & 0.17357811E-05_JPRB, 0.17432940E-05_JPRB, 0.17508530E-05_JPRB, 0.17559652E-05_JPRB, 0.17578976E-05_JPRB, 0.17597510E-05_JPRB, &
  & 0.17604936E-05_JPRB, 0.17600016E-05_JPRB, 0.17591018E-05_JPRB, 0.17564528E-05_JPRB, 0.17563351E-05_JPRB, 0.17573327E-05_JPRB, &
  & 0.17578093E-05_JPRB, 0.17592054E-05_JPRB, 0.17610607E-05_JPRB, 0.17641448E-05_JPRB, 0.17666537E-05_JPRB, 0.17692173E-05_JPRB, &
  & 0.17700847E-05_JPRB, 0.17705997E-05_JPRB, 0.17709629E-05_JPRB, 0.17714362E-05_JPRB, 0.17721636E-05_JPRB, 0.17724203E-05_JPRB, &
  & 0.17718652E-05_JPRB, 0.17719101E-05_JPRB, 0.17729694E-05_JPRB, 0.17732736E-05_JPRB  /)

RGHG2(:,57, 9) = (/ &
  & 0.17048972E-05_JPRB, 0.17048348E-05_JPRB, 0.17048249E-05_JPRB, 0.17048527E-05_JPRB, 0.17048975E-05_JPRB, 0.17049464E-05_JPRB, &
  & 0.17049911E-05_JPRB, 0.17050733E-05_JPRB, 0.17051385E-05_JPRB, 0.17053626E-05_JPRB, 0.17056158E-05_JPRB, 0.17058829E-05_JPRB, &
  & 0.17061021E-05_JPRB, 0.17062515E-05_JPRB, 0.17063389E-05_JPRB, 0.17064273E-05_JPRB, 0.17065875E-05_JPRB, 0.17068568E-05_JPRB, &
  & 0.17071734E-05_JPRB, 0.17077662E-05_JPRB, 0.17084786E-05_JPRB, 0.17091787E-05_JPRB, 0.17093770E-05_JPRB, 0.17093449E-05_JPRB, &
  & 0.17095677E-05_JPRB, 0.17099716E-05_JPRB, 0.17101809E-05_JPRB, 0.17103120E-05_JPRB, 0.17100150E-05_JPRB, 0.17095211E-05_JPRB, &
  & 0.17102001E-05_JPRB, 0.17122437E-05_JPRB, 0.17151124E-05_JPRB, 0.17182533E-05_JPRB, 0.17226291E-05_JPRB, 0.17289954E-05_JPRB, &
  & 0.17359869E-05_JPRB, 0.17439948E-05_JPRB, 0.17513520E-05_JPRB, 0.17559908E-05_JPRB, 0.17576095E-05_JPRB, 0.17593405E-05_JPRB, &
  & 0.17600298E-05_JPRB, 0.17597691E-05_JPRB, 0.17592638E-05_JPRB, 0.17567394E-05_JPRB, 0.17566835E-05_JPRB, 0.17576636E-05_JPRB, &
  & 0.17584271E-05_JPRB, 0.17603743E-05_JPRB, 0.17626981E-05_JPRB, 0.17660492E-05_JPRB, 0.17687952E-05_JPRB, 0.17716286E-05_JPRB, &
  & 0.17727595E-05_JPRB, 0.17735246E-05_JPRB, 0.17742775E-05_JPRB, 0.17751455E-05_JPRB, 0.17761735E-05_JPRB, 0.17764067E-05_JPRB, &
  & 0.17759788E-05_JPRB, 0.17762479E-05_JPRB, 0.17773483E-05_JPRB, 0.17776215E-05_JPRB  /)

RGHG2(:,58, 9) = (/ &
  & 0.17046935E-05_JPRB, 0.17046443E-05_JPRB, 0.17046344E-05_JPRB, 0.17046491E-05_JPRB, 0.17046816E-05_JPRB, 0.17047123E-05_JPRB, &
  & 0.17047275E-05_JPRB, 0.17047752E-05_JPRB, 0.17048130E-05_JPRB, 0.17049730E-05_JPRB, 0.17051825E-05_JPRB, 0.17053947E-05_JPRB, &
  & 0.17055632E-05_JPRB, 0.17056943E-05_JPRB, 0.17057909E-05_JPRB, 0.17058863E-05_JPRB, 0.17060780E-05_JPRB, 0.17063758E-05_JPRB, &
  & 0.17066507E-05_JPRB, 0.17071795E-05_JPRB, 0.17078350E-05_JPRB, 0.17084935E-05_JPRB, 0.17087883E-05_JPRB, 0.17087755E-05_JPRB, &
  & 0.17089140E-05_JPRB, 0.17092722E-05_JPRB, 0.17094907E-05_JPRB, 0.17095557E-05_JPRB, 0.17092140E-05_JPRB, 0.17087029E-05_JPRB, &
  & 0.17093453E-05_JPRB, 0.17113218E-05_JPRB, 0.17141977E-05_JPRB, 0.17175315E-05_JPRB, 0.17222345E-05_JPRB, 0.17288598E-05_JPRB, &
  & 0.17362078E-05_JPRB, 0.17446648E-05_JPRB, 0.17516664E-05_JPRB, 0.17557983E-05_JPRB, 0.17571478E-05_JPRB, 0.17587477E-05_JPRB, &
  & 0.17594361E-05_JPRB, 0.17593754E-05_JPRB, 0.17592653E-05_JPRB, 0.17568121E-05_JPRB, 0.17568120E-05_JPRB, 0.17577636E-05_JPRB, &
  & 0.17588268E-05_JPRB, 0.17613490E-05_JPRB, 0.17640792E-05_JPRB, 0.17676263E-05_JPRB, 0.17705704E-05_JPRB, 0.17735979E-05_JPRB, &
  & 0.17749390E-05_JPRB, 0.17758920E-05_JPRB, 0.17769558E-05_JPRB, 0.17781255E-05_JPRB, 0.17793445E-05_JPRB, 0.17795289E-05_JPRB, &
  & 0.17792260E-05_JPRB, 0.17796688E-05_JPRB, 0.17807539E-05_JPRB, 0.17809367E-05_JPRB  /)

RGHG2(:,59, 9) = (/ &
  & 0.17045420E-05_JPRB, 0.17045053E-05_JPRB, 0.17044994E-05_JPRB, 0.17045038E-05_JPRB, 0.17045264E-05_JPRB, 0.17045464E-05_JPRB, &
  & 0.17045459E-05_JPRB, 0.17045697E-05_JPRB, 0.17045868E-05_JPRB, 0.17046985E-05_JPRB, 0.17048717E-05_JPRB, 0.17050401E-05_JPRB, &
  & 0.17051681E-05_JPRB, 0.17052736E-05_JPRB, 0.17053739E-05_JPRB, 0.17054821E-05_JPRB, 0.17056955E-05_JPRB, 0.17060118E-05_JPRB, &
  & 0.17062611E-05_JPRB, 0.17067171E-05_JPRB, 0.17072953E-05_JPRB, 0.17078879E-05_JPRB, 0.17082143E-05_JPRB, 0.17082565E-05_JPRB, &
  & 0.17082828E-05_JPRB, 0.17085805E-05_JPRB, 0.17088428E-05_JPRB, 0.17087802E-05_JPRB, 0.17083436E-05_JPRB, 0.17078875E-05_JPRB, &
  & 0.17084905E-05_JPRB, 0.17104495E-05_JPRB, 0.17134761E-05_JPRB, 0.17169764E-05_JPRB, 0.17219343E-05_JPRB, 0.17288119E-05_JPRB, &
  & 0.17364889E-05_JPRB, 0.17450185E-05_JPRB, 0.17514949E-05_JPRB, 0.17552985E-05_JPRB, 0.17565542E-05_JPRB, 0.17580079E-05_JPRB, &
  & 0.17587291E-05_JPRB, 0.17587357E-05_JPRB, 0.17590015E-05_JPRB, 0.17566858E-05_JPRB, 0.17567731E-05_JPRB, 0.17577551E-05_JPRB, &
  & 0.17592197E-05_JPRB, 0.17622111E-05_JPRB, 0.17652552E-05_JPRB, 0.17690018E-05_JPRB, 0.17721664E-05_JPRB, 0.17752391E-05_JPRB, &
  & 0.17767594E-05_JPRB, 0.17778871E-05_JPRB, 0.17791689E-05_JPRB, 0.17805292E-05_JPRB, 0.17818361E-05_JPRB, 0.17820752E-05_JPRB, &
  & 0.17819028E-05_JPRB, 0.17824270E-05_JPRB, 0.17834896E-05_JPRB, 0.17836250E-05_JPRB  /)

RGHG2(:,60, 9) = (/ &
  & 0.17044104E-05_JPRB, 0.17043876E-05_JPRB, 0.17043882E-05_JPRB, 0.17043831E-05_JPRB, 0.17043959E-05_JPRB, 0.17044084E-05_JPRB, &
  & 0.17043983E-05_JPRB, 0.17044025E-05_JPRB, 0.17044017E-05_JPRB, 0.17044711E-05_JPRB, 0.17046093E-05_JPRB, 0.17047369E-05_JPRB, &
  & 0.17048293E-05_JPRB, 0.17049051E-05_JPRB, 0.17050059E-05_JPRB, 0.17051267E-05_JPRB, 0.17053553E-05_JPRB, 0.17056836E-05_JPRB, &
  & 0.17059140E-05_JPRB, 0.17062965E-05_JPRB, 0.17067850E-05_JPRB, 0.17073093E-05_JPRB, 0.17076362E-05_JPRB, 0.17077430E-05_JPRB, &
  & 0.17076434E-05_JPRB, 0.17078705E-05_JPRB, 0.17081721E-05_JPRB, 0.17079709E-05_JPRB, 0.17074137E-05_JPRB, 0.17070384E-05_JPRB, &
  & 0.17076259E-05_JPRB, 0.17096161E-05_JPRB, 0.17128421E-05_JPRB, 0.17165272E-05_JPRB, 0.17217264E-05_JPRB, 0.17288344E-05_JPRB, &
  & 0.17368002E-05_JPRB, 0.17451903E-05_JPRB, 0.17510472E-05_JPRB, 0.17546273E-05_JPRB, 0.17558837E-05_JPRB, 0.17571679E-05_JPRB, &
  & 0.17579370E-05_JPRB, 0.17579748E-05_JPRB, 0.17585754E-05_JPRB, 0.17564618E-05_JPRB, 0.17566567E-05_JPRB, 0.17577117E-05_JPRB, &
  & 0.17596434E-05_JPRB, 0.17630704E-05_JPRB, 0.17664020E-05_JPRB, 0.17703521E-05_JPRB, 0.17737450E-05_JPRB, 0.17768018E-05_JPRB, &
  & 0.17784894E-05_JPRB, 0.17797830E-05_JPRB, 0.17812445E-05_JPRB, 0.17827562E-05_JPRB, 0.17841067E-05_JPRB, 0.17844594E-05_JPRB, &
  & 0.17844204E-05_JPRB, 0.17849945E-05_JPRB, 0.17860225E-05_JPRB, 0.17861349E-05_JPRB  /)

RGHG2(:,61, 9) = (/ &
  & 0.17043155E-05_JPRB, 0.17043103E-05_JPRB, 0.17043219E-05_JPRB, 0.17043080E-05_JPRB, 0.17043109E-05_JPRB, 0.17043201E-05_JPRB, &
  & 0.17043089E-05_JPRB, 0.17043009E-05_JPRB, 0.17042880E-05_JPRB, 0.17043266E-05_JPRB, 0.17044317E-05_JPRB, 0.17045230E-05_JPRB, &
  & 0.17045923E-05_JPRB, 0.17046362E-05_JPRB, 0.17047303E-05_JPRB, 0.17048544E-05_JPRB, 0.17050819E-05_JPRB, 0.17054059E-05_JPRB, &
  & 0.17056274E-05_JPRB, 0.17059559E-05_JPRB, 0.17063453E-05_JPRB, 0.17068333E-05_JPRB, 0.17071161E-05_JPRB, 0.17072702E-05_JPRB, &
  & 0.17070451E-05_JPRB, 0.17071907E-05_JPRB, 0.17074614E-05_JPRB, 0.17071777E-05_JPRB, 0.17064783E-05_JPRB, 0.17061846E-05_JPRB, &
  & 0.17068602E-05_JPRB, 0.17090123E-05_JPRB, 0.17124222E-05_JPRB, 0.17163717E-05_JPRB, 0.17218088E-05_JPRB, 0.17290291E-05_JPRB, &
  & 0.17371084E-05_JPRB, 0.17449929E-05_JPRB, 0.17501592E-05_JPRB, 0.17537536E-05_JPRB, 0.17551741E-05_JPRB, 0.17562403E-05_JPRB, &
  & 0.17570677E-05_JPRB, 0.17571540E-05_JPRB, 0.17578912E-05_JPRB, 0.17561267E-05_JPRB, 0.17564550E-05_JPRB, 0.17576707E-05_JPRB, &
  & 0.17601333E-05_JPRB, 0.17639239E-05_JPRB, 0.17675055E-05_JPRB, 0.17716384E-05_JPRB, 0.17752262E-05_JPRB, 0.17782092E-05_JPRB, &
  & 0.17800279E-05_JPRB, 0.17814415E-05_JPRB, 0.17830155E-05_JPRB, 0.17846351E-05_JPRB, 0.17859724E-05_JPRB, 0.17865300E-05_JPRB, &
  & 0.17866065E-05_JPRB, 0.17872116E-05_JPRB, 0.17881701E-05_JPRB, 0.17883089E-05_JPRB  /)

RGHG2(:,62, 9) = (/ &
  & 0.17042490E-05_JPRB, 0.17042580E-05_JPRB, 0.17042785E-05_JPRB, 0.17042596E-05_JPRB, 0.17042555E-05_JPRB, 0.17042621E-05_JPRB, &
  & 0.17042514E-05_JPRB, 0.17042366E-05_JPRB, 0.17042153E-05_JPRB, 0.17042294E-05_JPRB, 0.17043045E-05_JPRB, 0.17043623E-05_JPRB, &
  & 0.17044078E-05_JPRB, 0.17044317E-05_JPRB, 0.17045109E-05_JPRB, 0.17046270E-05_JPRB, 0.17048395E-05_JPRB, 0.17051467E-05_JPRB, &
  & 0.17053485E-05_JPRB, 0.17056466E-05_JPRB, 0.17059402E-05_JPRB, 0.17064013E-05_JPRB, 0.17066387E-05_JPRB, 0.17067813E-05_JPRB, &
  & 0.17064927E-05_JPRB, 0.17064636E-05_JPRB, 0.17066503E-05_JPRB, 0.17063001E-05_JPRB, 0.17055455E-05_JPRB, 0.17052616E-05_JPRB, &
  & 0.17061464E-05_JPRB, 0.17084794E-05_JPRB, 0.17121297E-05_JPRB, 0.17163870E-05_JPRB, 0.17221104E-05_JPRB, 0.17294206E-05_JPRB, &
  & 0.17373805E-05_JPRB, 0.17445256E-05_JPRB, 0.17490673E-05_JPRB, 0.17526178E-05_JPRB, 0.17543308E-05_JPRB, 0.17552990E-05_JPRB, &
  & 0.17561501E-05_JPRB, 0.17564397E-05_JPRB, 0.17571685E-05_JPRB, 0.17558223E-05_JPRB, 0.17563109E-05_JPRB, 0.17577415E-05_JPRB, &
  & 0.17607136E-05_JPRB, 0.17648441E-05_JPRB, 0.17686838E-05_JPRB, 0.17729565E-05_JPRB, 0.17766639E-05_JPRB, 0.17796083E-05_JPRB, &
  & 0.17814741E-05_JPRB, 0.17829342E-05_JPRB, 0.17846028E-05_JPRB, 0.17863648E-05_JPRB, 0.17876616E-05_JPRB, 0.17884134E-05_JPRB, &
  & 0.17885588E-05_JPRB, 0.17892348E-05_JPRB, 0.17901299E-05_JPRB, 0.17902960E-05_JPRB  /)

RGHG2(:,63, 9) = (/ &
  & 0.17042018E-05_JPRB, 0.17042217E-05_JPRB, 0.17042487E-05_JPRB, 0.17042277E-05_JPRB, 0.17042187E-05_JPRB, 0.17042233E-05_JPRB, &
  & 0.17042141E-05_JPRB, 0.17041953E-05_JPRB, 0.17041683E-05_JPRB, 0.17041625E-05_JPRB, 0.17042095E-05_JPRB, 0.17042364E-05_JPRB, &
  & 0.17042570E-05_JPRB, 0.17042688E-05_JPRB, 0.17043266E-05_JPRB, 0.17044277E-05_JPRB, 0.17046186E-05_JPRB, 0.17048999E-05_JPRB, &
  & 0.17050717E-05_JPRB, 0.17053430E-05_JPRB, 0.17055503E-05_JPRB, 0.17059822E-05_JPRB, 0.17061707E-05_JPRB, 0.17062649E-05_JPRB, &
  & 0.17059453E-05_JPRB, 0.17056862E-05_JPRB, 0.17057455E-05_JPRB, 0.17053675E-05_JPRB, 0.17045809E-05_JPRB, 0.17043220E-05_JPRB, &
  & 0.17054711E-05_JPRB, 0.17080622E-05_JPRB, 0.17120032E-05_JPRB, 0.17165473E-05_JPRB, 0.17224826E-05_JPRB, 0.17298324E-05_JPRB, &
  & 0.17374807E-05_JPRB, 0.17438035E-05_JPRB, 0.17477993E-05_JPRB, 0.17512428E-05_JPRB, 0.17533491E-05_JPRB, 0.17543666E-05_JPRB, &
  & 0.17551967E-05_JPRB, 0.17557771E-05_JPRB, 0.17564894E-05_JPRB, 0.17555757E-05_JPRB, 0.17562624E-05_JPRB, 0.17579433E-05_JPRB, &
  & 0.17613972E-05_JPRB, 0.17658297E-05_JPRB, 0.17699361E-05_JPRB, 0.17743143E-05_JPRB, 0.17780913E-05_JPRB, 0.17810077E-05_JPRB, &
  & 0.17828642E-05_JPRB, 0.17843244E-05_JPRB, 0.17860831E-05_JPRB, 0.17879943E-05_JPRB, 0.17892512E-05_JPRB, 0.17901737E-05_JPRB, &
  & 0.17903596E-05_JPRB, 0.17911354E-05_JPRB, 0.17919778E-05_JPRB, 0.17921704E-05_JPRB  /)

RGHG2(:,64, 9) = (/ &
  & 0.17041754E-05_JPRB, 0.17042013E-05_JPRB, 0.17042307E-05_JPRB, 0.17042109E-05_JPRB, 0.17041995E-05_JPRB, 0.17042029E-05_JPRB, &
  & 0.17041962E-05_JPRB, 0.17041749E-05_JPRB, 0.17041455E-05_JPRB, 0.17041252E-05_JPRB, 0.17041469E-05_JPRB, 0.17041473E-05_JPRB, &
  & 0.17041427E-05_JPRB, 0.17041496E-05_JPRB, 0.17041797E-05_JPRB, 0.17042603E-05_JPRB, 0.17044283E-05_JPRB, 0.17046747E-05_JPRB, &
  & 0.17048031E-05_JPRB, 0.17050334E-05_JPRB, 0.17051782E-05_JPRB, 0.17055667E-05_JPRB, 0.17057009E-05_JPRB, 0.17057168E-05_JPRB, &
  & 0.17053852E-05_JPRB, 0.17048623E-05_JPRB, 0.17047457E-05_JPRB, 0.17044207E-05_JPRB, 0.17035727E-05_JPRB, 0.17034487E-05_JPRB, &
  & 0.17048653E-05_JPRB, 0.17078767E-05_JPRB, 0.17121647E-05_JPRB, 0.17168871E-05_JPRB, 0.17227911E-05_JPRB, 0.17300770E-05_JPRB, &
  & 0.17371856E-05_JPRB, 0.17427519E-05_JPRB, 0.17463513E-05_JPRB, 0.17495949E-05_JPRB, 0.17521987E-05_JPRB, 0.17535065E-05_JPRB, &
  & 0.17542415E-05_JPRB, 0.17551603E-05_JPRB, 0.17559847E-05_JPRB, 0.17554517E-05_JPRB, 0.17563950E-05_JPRB, 0.17583494E-05_JPRB, &
  & 0.17622189E-05_JPRB, 0.17668706E-05_JPRB, 0.17712468E-05_JPRB, 0.17756853E-05_JPRB, 0.17794815E-05_JPRB, 0.17823618E-05_JPRB, &
  & 0.17841545E-05_JPRB, 0.17855749E-05_JPRB, 0.17874263E-05_JPRB, 0.17894629E-05_JPRB, 0.17907114E-05_JPRB, 0.17917494E-05_JPRB, &
  & 0.17919523E-05_JPRB, 0.17928545E-05_JPRB, 0.17936668E-05_JPRB, 0.17938823E-05_JPRB  /)

RGHG2(:,65, 9) = (/ &
  & 0.17041620E-05_JPRB, 0.17041895E-05_JPRB, 0.17042202E-05_JPRB, 0.17042016E-05_JPRB, 0.17041912E-05_JPRB, 0.17041956E-05_JPRB, &
  & 0.17041879E-05_JPRB, 0.17041676E-05_JPRB, 0.17041402E-05_JPRB, 0.17041121E-05_JPRB, 0.17041072E-05_JPRB, 0.17040898E-05_JPRB, &
  & 0.17040620E-05_JPRB, 0.17040562E-05_JPRB, 0.17040550E-05_JPRB, 0.17041139E-05_JPRB, 0.17042667E-05_JPRB, 0.17044778E-05_JPRB, &
  & 0.17045592E-05_JPRB, 0.17047146E-05_JPRB, 0.17048007E-05_JPRB, 0.17051209E-05_JPRB, 0.17052083E-05_JPRB, 0.17051151E-05_JPRB, &
  & 0.17047197E-05_JPRB, 0.17040902E-05_JPRB, 0.17038570E-05_JPRB, 0.17034664E-05_JPRB, 0.17025162E-05_JPRB, 0.17026257E-05_JPRB, &
  & 0.17044710E-05_JPRB, 0.17078567E-05_JPRB, 0.17123239E-05_JPRB, 0.17168503E-05_JPRB, 0.17224704E-05_JPRB, 0.17297885E-05_JPRB, &
  & 0.17362736E-05_JPRB, 0.17414297E-05_JPRB, 0.17448989E-05_JPRB, 0.17480127E-05_JPRB, 0.17508858E-05_JPRB, 0.17528337E-05_JPRB, &
  & 0.17534694E-05_JPRB, 0.17545959E-05_JPRB, 0.17556565E-05_JPRB, 0.17554835E-05_JPRB, 0.17567235E-05_JPRB, 0.17590229E-05_JPRB, &
  & 0.17632339E-05_JPRB, 0.17679798E-05_JPRB, 0.17725887E-05_JPRB, 0.17770822E-05_JPRB, 0.17808811E-05_JPRB, 0.17836218E-05_JPRB, &
  & 0.17853266E-05_JPRB, 0.17867092E-05_JPRB, 0.17886742E-05_JPRB, 0.17907126E-05_JPRB, 0.17919795E-05_JPRB, 0.17930668E-05_JPRB, &
  & 0.17933169E-05_JPRB, 0.17942894E-05_JPRB, 0.17950691E-05_JPRB, 0.17952875E-05_JPRB  /)

RGHG2(:,66, 9) = (/ &
  & 0.17041504E-05_JPRB, 0.17041819E-05_JPRB, 0.17042146E-05_JPRB, 0.17041965E-05_JPRB, 0.17041874E-05_JPRB, 0.17041930E-05_JPRB, &
  & 0.17041834E-05_JPRB, 0.17041657E-05_JPRB, 0.17041429E-05_JPRB, 0.17041095E-05_JPRB, 0.17040803E-05_JPRB, 0.17040479E-05_JPRB, &
  & 0.17039980E-05_JPRB, 0.17039745E-05_JPRB, 0.17039448E-05_JPRB, 0.17039730E-05_JPRB, 0.17041146E-05_JPRB, 0.17042886E-05_JPRB, &
  & 0.17043276E-05_JPRB, 0.17044070E-05_JPRB, 0.17044213E-05_JPRB, 0.17046588E-05_JPRB, 0.17047058E-05_JPRB, 0.17045127E-05_JPRB, &
  & 0.17040336E-05_JPRB, 0.17033014E-05_JPRB, 0.17029351E-05_JPRB, 0.17023680E-05_JPRB, 0.17014646E-05_JPRB, 0.17019463E-05_JPRB, &
  & 0.17042150E-05_JPRB, 0.17077771E-05_JPRB, 0.17122740E-05_JPRB, 0.17163653E-05_JPRB, 0.17218254E-05_JPRB, 0.17292767E-05_JPRB, &
  & 0.17352210E-05_JPRB, 0.17400413E-05_JPRB, 0.17435251E-05_JPRB, 0.17466341E-05_JPRB, 0.17495857E-05_JPRB, 0.17522057E-05_JPRB, &
  & 0.17528965E-05_JPRB, 0.17541222E-05_JPRB, 0.17553713E-05_JPRB, 0.17555722E-05_JPRB, 0.17571961E-05_JPRB, 0.17598768E-05_JPRB, &
  & 0.17643944E-05_JPRB, 0.17692006E-05_JPRB, 0.17739955E-05_JPRB, 0.17785261E-05_JPRB, 0.17823114E-05_JPRB, 0.17848574E-05_JPRB, &
  & 0.17864612E-05_JPRB, 0.17878367E-05_JPRB, 0.17898890E-05_JPRB, 0.17918771E-05_JPRB, 0.17931564E-05_JPRB, 0.17942655E-05_JPRB, &
  & 0.17945929E-05_JPRB, 0.17955578E-05_JPRB, 0.17962562E-05_JPRB, 0.17964454E-05_JPRB  /)

RGHG2(:,67, 9) = (/ &
  & 0.17041400E-05_JPRB, 0.17041789E-05_JPRB, 0.17042147E-05_JPRB, 0.17041969E-05_JPRB, 0.17041890E-05_JPRB, 0.17041950E-05_JPRB, &
  & 0.17041831E-05_JPRB, 0.17041698E-05_JPRB, 0.17041523E-05_JPRB, 0.17041155E-05_JPRB, 0.17040661E-05_JPRB, 0.17040206E-05_JPRB, &
  & 0.17039509E-05_JPRB, 0.17039048E-05_JPRB, 0.17038507E-05_JPRB, 0.17038411E-05_JPRB, 0.17039716E-05_JPRB, 0.17041061E-05_JPRB, &
  & 0.17041103E-05_JPRB, 0.17041178E-05_JPRB, 0.17040620E-05_JPRB, 0.17042025E-05_JPRB, 0.17042139E-05_JPRB, 0.17039331E-05_JPRB, &
  & 0.17033592E-05_JPRB, 0.17024787E-05_JPRB, 0.17019323E-05_JPRB, 0.17011543E-05_JPRB, 0.17004489E-05_JPRB, 0.17014249E-05_JPRB, &
  & 0.17040610E-05_JPRB, 0.17075842E-05_JPRB, 0.17119116E-05_JPRB, 0.17154980E-05_JPRB, 0.17210016E-05_JPRB, 0.17286166E-05_JPRB, &
  & 0.17340987E-05_JPRB, 0.17386447E-05_JPRB, 0.17422647E-05_JPRB, 0.17455011E-05_JPRB, 0.17484106E-05_JPRB, 0.17516250E-05_JPRB, &
  & 0.17525684E-05_JPRB, 0.17537965E-05_JPRB, 0.17551654E-05_JPRB, 0.17557369E-05_JPRB, 0.17578119E-05_JPRB, 0.17609073E-05_JPRB, &
  & 0.17657015E-05_JPRB, 0.17705635E-05_JPRB, 0.17754788E-05_JPRB, 0.17800174E-05_JPRB, 0.17837541E-05_JPRB, 0.17860716E-05_JPRB, &
  & 0.17875754E-05_JPRB, 0.17889697E-05_JPRB, 0.17910683E-05_JPRB, 0.17929675E-05_JPRB, 0.17942530E-05_JPRB, 0.17953524E-05_JPRB, &
  & 0.17957776E-05_JPRB, 0.17966698E-05_JPRB, 0.17972285E-05_JPRB, 0.17973625E-05_JPRB  /)

RGHG2(:,68, 9) = (/ &
  & 0.17041315E-05_JPRB, 0.17041816E-05_JPRB, 0.17042223E-05_JPRB, 0.17042057E-05_JPRB, 0.17041990E-05_JPRB, 0.17042025E-05_JPRB, &
  & 0.17041895E-05_JPRB, 0.17041823E-05_JPRB, 0.17041673E-05_JPRB, 0.17041280E-05_JPRB, 0.17040650E-05_JPRB, 0.17040084E-05_JPRB, &
  & 0.17039226E-05_JPRB, 0.17038493E-05_JPRB, 0.17037754E-05_JPRB, 0.17037262E-05_JPRB, 0.17038382E-05_JPRB, 0.17039293E-05_JPRB, &
  & 0.17039100E-05_JPRB, 0.17038532E-05_JPRB, 0.17037641E-05_JPRB, 0.17037907E-05_JPRB, 0.17037675E-05_JPRB, 0.17034075E-05_JPRB, &
  & 0.17027409E-05_JPRB, 0.17015883E-05_JPRB, 0.17007623E-05_JPRB, 0.16999051E-05_JPRB, 0.16995102E-05_JPRB, 0.17010589E-05_JPRB, &
  & 0.17039362E-05_JPRB, 0.17072083E-05_JPRB, 0.17110632E-05_JPRB, 0.17144145E-05_JPRB, 0.17202547E-05_JPRB, 0.17279092E-05_JPRB, &
  & 0.17329559E-05_JPRB, 0.17373077E-05_JPRB, 0.17411528E-05_JPRB, 0.17446490E-05_JPRB, 0.17475473E-05_JPRB, 0.17511143E-05_JPRB, &
  & 0.17525636E-05_JPRB, 0.17537237E-05_JPRB, 0.17551371E-05_JPRB, 0.17560377E-05_JPRB, 0.17585802E-05_JPRB, 0.17621283E-05_JPRB, &
  & 0.17671774E-05_JPRB, 0.17721383E-05_JPRB, 0.17770735E-05_JPRB, 0.17815712E-05_JPRB, 0.17851842E-05_JPRB, 0.17872754E-05_JPRB, &
  & 0.17887074E-05_JPRB, 0.17901289E-05_JPRB, 0.17922127E-05_JPRB, 0.17940005E-05_JPRB, 0.17952922E-05_JPRB, 0.17963360E-05_JPRB, &
  & 0.17968589E-05_JPRB, 0.17976484E-05_JPRB, 0.17979980E-05_JPRB, 0.17980665E-05_JPRB  /)

RGHG2(:,69, 9) = (/ &
  & 0.17041302E-05_JPRB, 0.17041948E-05_JPRB, 0.17042393E-05_JPRB, 0.17042217E-05_JPRB, 0.17042174E-05_JPRB, 0.17042173E-05_JPRB, &
  & 0.17042041E-05_JPRB, 0.17042009E-05_JPRB, 0.17041872E-05_JPRB, 0.17041432E-05_JPRB, 0.17040722E-05_JPRB, 0.17040113E-05_JPRB, &
  & 0.17039127E-05_JPRB, 0.17038077E-05_JPRB, 0.17037129E-05_JPRB, 0.17036388E-05_JPRB, 0.17037176E-05_JPRB, 0.17037722E-05_JPRB, &
  & 0.17037328E-05_JPRB, 0.17036173E-05_JPRB, 0.17035172E-05_JPRB, 0.17034493E-05_JPRB, 0.17033419E-05_JPRB, 0.17028960E-05_JPRB, &
  & 0.17020859E-05_JPRB, 0.17006511E-05_JPRB, 0.16995827E-05_JPRB, 0.16988187E-05_JPRB, 0.16986475E-05_JPRB, 0.17004615E-05_JPRB, &
  & 0.17035135E-05_JPRB, 0.17065953E-05_JPRB, 0.17100679E-05_JPRB, 0.17134398E-05_JPRB, 0.17195499E-05_JPRB, 0.17270751E-05_JPRB, &
  & 0.17318678E-05_JPRB, 0.17362506E-05_JPRB, 0.17403916E-05_JPRB, 0.17441758E-05_JPRB, 0.17471395E-05_JPRB, 0.17509024E-05_JPRB, &
  & 0.17529792E-05_JPRB, 0.17540577E-05_JPRB, 0.17554661E-05_JPRB, 0.17566394E-05_JPRB, 0.17595380E-05_JPRB, 0.17635297E-05_JPRB, &
  & 0.17688155E-05_JPRB, 0.17739373E-05_JPRB, 0.17788371E-05_JPRB, 0.17832456E-05_JPRB, 0.17866324E-05_JPRB, 0.17885187E-05_JPRB, &
  & 0.17899364E-05_JPRB, 0.17914223E-05_JPRB, 0.17933651E-05_JPRB, 0.17950281E-05_JPRB, 0.17962889E-05_JPRB, 0.17972398E-05_JPRB, &
  & 0.17978087E-05_JPRB, 0.17985147E-05_JPRB, 0.17986868E-05_JPRB, 0.17986661E-05_JPRB  /)

RGHG2(:,70, 9) = (/ &
  & 0.17041369E-05_JPRB, 0.17042170E-05_JPRB, 0.17042631E-05_JPRB, 0.17042435E-05_JPRB, 0.17042417E-05_JPRB, 0.17042372E-05_JPRB, &
  & 0.17042254E-05_JPRB, 0.17042252E-05_JPRB, 0.17042121E-05_JPRB, 0.17041617E-05_JPRB, 0.17040861E-05_JPRB, 0.17040221E-05_JPRB, &
  & 0.17039120E-05_JPRB, 0.17037791E-05_JPRB, 0.17036646E-05_JPRB, 0.17035727E-05_JPRB, 0.17036175E-05_JPRB, 0.17036390E-05_JPRB, &
  & 0.17035877E-05_JPRB, 0.17034054E-05_JPRB, 0.17032823E-05_JPRB, 0.17031307E-05_JPRB, 0.17029355E-05_JPRB, 0.17024036E-05_JPRB, &
  & 0.17014060E-05_JPRB, 0.16997650E-05_JPRB, 0.16985136E-05_JPRB, 0.16978828E-05_JPRB, 0.16978431E-05_JPRB, 0.16997330E-05_JPRB, &
  & 0.17029068E-05_JPRB, 0.17058306E-05_JPRB, 0.17090490E-05_JPRB, 0.17124531E-05_JPRB, 0.17187243E-05_JPRB, 0.17261910E-05_JPRB, &
  & 0.17308821E-05_JPRB, 0.17353786E-05_JPRB, 0.17399383E-05_JPRB, 0.17439842E-05_JPRB, 0.17471123E-05_JPRB, 0.17510878E-05_JPRB, &
  & 0.17536370E-05_JPRB, 0.17546915E-05_JPRB, 0.17561496E-05_JPRB, 0.17575294E-05_JPRB, 0.17607127E-05_JPRB, 0.17650862E-05_JPRB, &
  & 0.17705600E-05_JPRB, 0.17758232E-05_JPRB, 0.17806907E-05_JPRB, 0.17850101E-05_JPRB, 0.17881452E-05_JPRB, 0.17898232E-05_JPRB, &
  & 0.17912193E-05_JPRB, 0.17927841E-05_JPRB, 0.17945531E-05_JPRB, 0.17960811E-05_JPRB, 0.17972374E-05_JPRB, 0.17980788E-05_JPRB, &
  & 0.17986504E-05_JPRB, 0.17992890E-05_JPRB, 0.17993540E-05_JPRB, 0.17992322E-05_JPRB  /)

RGHG2(:,71, 9) = (/ &
  & 0.17041523E-05_JPRB, 0.17042476E-05_JPRB, 0.17042931E-05_JPRB, 0.17042714E-05_JPRB, 0.17042711E-05_JPRB, 0.17042622E-05_JPRB, &
  & 0.17042533E-05_JPRB, 0.17042553E-05_JPRB, 0.17042415E-05_JPRB, 0.17041836E-05_JPRB, 0.17041056E-05_JPRB, 0.17040395E-05_JPRB, &
  & 0.17039191E-05_JPRB, 0.17037648E-05_JPRB, 0.17036330E-05_JPRB, 0.17035300E-05_JPRB, 0.17035404E-05_JPRB, 0.17035334E-05_JPRB, &
  & 0.17034740E-05_JPRB, 0.17032279E-05_JPRB, 0.17030614E-05_JPRB, 0.17028367E-05_JPRB, 0.17025651E-05_JPRB, 0.17019530E-05_JPRB, &
  & 0.17007451E-05_JPRB, 0.16989838E-05_JPRB, 0.16976001E-05_JPRB, 0.16970975E-05_JPRB, 0.16971047E-05_JPRB, 0.16989503E-05_JPRB, &
  & 0.17021800E-05_JPRB, 0.17049485E-05_JPRB, 0.17080098E-05_JPRB, 0.17113882E-05_JPRB, 0.17177571E-05_JPRB, 0.17252908E-05_JPRB, &
  & 0.17300381E-05_JPRB, 0.17346745E-05_JPRB, 0.17397613E-05_JPRB, 0.17440980E-05_JPRB, 0.17475056E-05_JPRB, 0.17517420E-05_JPRB, &
  & 0.17545481E-05_JPRB, 0.17556567E-05_JPRB, 0.17572118E-05_JPRB, 0.17587315E-05_JPRB, 0.17621255E-05_JPRB, 0.17668315E-05_JPRB, &
  & 0.17724252E-05_JPRB, 0.17777737E-05_JPRB, 0.17826136E-05_JPRB, 0.17868681E-05_JPRB, 0.17897510E-05_JPRB, 0.17911947E-05_JPRB, &
  & 0.17925527E-05_JPRB, 0.17941874E-05_JPRB, 0.17957793E-05_JPRB, 0.17971529E-05_JPRB, 0.17981304E-05_JPRB, 0.17988418E-05_JPRB, &
  & 0.17993731E-05_JPRB, 0.17999600E-05_JPRB, 0.17999851E-05_JPRB, 0.17997758E-05_JPRB  /)

RGHG2(:,72, 9) = (/ &
  & 0.17041783E-05_JPRB, 0.17042860E-05_JPRB, 0.17043290E-05_JPRB, 0.17043061E-05_JPRB, 0.17043045E-05_JPRB, 0.17042932E-05_JPRB, &
  & 0.17042880E-05_JPRB, 0.17042912E-05_JPRB, 0.17042749E-05_JPRB, 0.17042096E-05_JPRB, 0.17041292E-05_JPRB, 0.17040618E-05_JPRB, &
  & 0.17039339E-05_JPRB, 0.17037685E-05_JPRB, 0.17036231E-05_JPRB, 0.17035164E-05_JPRB, 0.17034896E-05_JPRB, 0.17034616E-05_JPRB, &
  & 0.17033886E-05_JPRB, 0.17031066E-05_JPRB, 0.17028670E-05_JPRB, 0.17025804E-05_JPRB, 0.17022630E-05_JPRB, 0.17015865E-05_JPRB, &
  & 0.17001842E-05_JPRB, 0.16983907E-05_JPRB, 0.16969055E-05_JPRB, 0.16964660E-05_JPRB, 0.16964497E-05_JPRB, 0.16982371E-05_JPRB, &
  & 0.17014272E-05_JPRB, 0.17039913E-05_JPRB, 0.17069264E-05_JPRB, 0.17101364E-05_JPRB, 0.17166353E-05_JPRB, 0.17244203E-05_JPRB, &
  & 0.17294016E-05_JPRB, 0.17341259E-05_JPRB, 0.17398145E-05_JPRB, 0.17445921E-05_JPRB, 0.17484243E-05_JPRB, 0.17529976E-05_JPRB, &
  & 0.17557814E-05_JPRB, 0.17570497E-05_JPRB, 0.17587138E-05_JPRB, 0.17603065E-05_JPRB, 0.17638231E-05_JPRB, 0.17688473E-05_JPRB, &
  & 0.17744609E-05_JPRB, 0.17797834E-05_JPRB, 0.17845911E-05_JPRB, 0.17888418E-05_JPRB, 0.17915044E-05_JPRB, 0.17926471E-05_JPRB, &
  & 0.17939456E-05_JPRB, 0.17956002E-05_JPRB, 0.17970485E-05_JPRB, 0.17982290E-05_JPRB, 0.17989562E-05_JPRB, 0.17995055E-05_JPRB, &
  & 0.17999501E-05_JPRB, 0.18005011E-05_JPRB, 0.18005411E-05_JPRB, 0.18003045E-05_JPRB  /)

RGHG2(:,73, 9) = (/ &
  & 0.17042167E-05_JPRB, 0.17043288E-05_JPRB, 0.17043728E-05_JPRB, 0.17043474E-05_JPRB, 0.17043423E-05_JPRB, 0.17043296E-05_JPRB, &
  & 0.17043293E-05_JPRB, 0.17043349E-05_JPRB, 0.17043150E-05_JPRB, 0.17042411E-05_JPRB, 0.17041616E-05_JPRB, 0.17040918E-05_JPRB, &
  & 0.17039611E-05_JPRB, 0.17037937E-05_JPRB, 0.17036472E-05_JPRB, 0.17035356E-05_JPRB, 0.17034692E-05_JPRB, 0.17034349E-05_JPRB, &
  & 0.17033425E-05_JPRB, 0.17030623E-05_JPRB, 0.17027607E-05_JPRB, 0.17024268E-05_JPRB, 0.17020541E-05_JPRB, 0.17013266E-05_JPRB, &
  & 0.16997862E-05_JPRB, 0.16980626E-05_JPRB, 0.16965075E-05_JPRB, 0.16960040E-05_JPRB, 0.16959318E-05_JPRB, 0.16975250E-05_JPRB, &
  & 0.17006362E-05_JPRB, 0.17032029E-05_JPRB, 0.17059811E-05_JPRB, 0.17088539E-05_JPRB, 0.17154456E-05_JPRB, 0.17237535E-05_JPRB, &
  & 0.17290323E-05_JPRB, 0.17338657E-05_JPRB, 0.17400354E-05_JPRB, 0.17453621E-05_JPRB, 0.17498950E-05_JPRB, 0.17549196E-05_JPRB, &
  & 0.17576109E-05_JPRB, 0.17590985E-05_JPRB, 0.17608354E-05_JPRB, 0.17624775E-05_JPRB, 0.17659381E-05_JPRB, 0.17710640E-05_JPRB, &
  & 0.17768124E-05_JPRB, 0.17819306E-05_JPRB, 0.17867071E-05_JPRB, 0.17910288E-05_JPRB, 0.17934444E-05_JPRB, 0.17942604E-05_JPRB, &
  & 0.17954015E-05_JPRB, 0.17969966E-05_JPRB, 0.17983383E-05_JPRB, 0.17992809E-05_JPRB, 0.17997279E-05_JPRB, 0.18000462E-05_JPRB, &
  & 0.18003703E-05_JPRB, 0.18008955E-05_JPRB, 0.18009585E-05_JPRB, 0.18008083E-05_JPRB  /)

RGHG2(:,74, 9) = (/ &
  & 0.17042680E-05_JPRB, 0.17043741E-05_JPRB, 0.17044193E-05_JPRB, 0.17043930E-05_JPRB, 0.17043841E-05_JPRB, 0.17043717E-05_JPRB, &
  & 0.17043741E-05_JPRB, 0.17043822E-05_JPRB, 0.17043608E-05_JPRB, 0.17042782E-05_JPRB, 0.17042007E-05_JPRB, 0.17041291E-05_JPRB, &
  & 0.17039997E-05_JPRB, 0.17038370E-05_JPRB, 0.17036965E-05_JPRB, 0.17035784E-05_JPRB, 0.17034774E-05_JPRB, 0.17034367E-05_JPRB, &
  & 0.17033333E-05_JPRB, 0.17030640E-05_JPRB, 0.17027149E-05_JPRB, 0.17023507E-05_JPRB, 0.17019130E-05_JPRB, 0.17011439E-05_JPRB, &
  & 0.16995452E-05_JPRB, 0.16978955E-05_JPRB, 0.16963509E-05_JPRB, 0.16957794E-05_JPRB, 0.16956249E-05_JPRB, 0.16969439E-05_JPRB, &
  & 0.16998421E-05_JPRB, 0.17025020E-05_JPRB, 0.17051388E-05_JPRB, 0.17076591E-05_JPRB, 0.17143225E-05_JPRB, 0.17232713E-05_JPRB, &
  & 0.17288839E-05_JPRB, 0.17338438E-05_JPRB, 0.17402881E-05_JPRB, 0.17461963E-05_JPRB, 0.17516056E-05_JPRB, 0.17572359E-05_JPRB, &
  & 0.17597944E-05_JPRB, 0.17614492E-05_JPRB, 0.17632909E-05_JPRB, 0.17650050E-05_JPRB, 0.17683356E-05_JPRB, 0.17733946E-05_JPRB, &
  & 0.17792807E-05_JPRB, 0.17842546E-05_JPRB, 0.17890501E-05_JPRB, 0.17934063E-05_JPRB, 0.17954660E-05_JPRB, 0.17959654E-05_JPRB, &
  & 0.17969208E-05_JPRB, 0.17983722E-05_JPRB, 0.17995949E-05_JPRB, 0.18002818E-05_JPRB, 0.18004507E-05_JPRB, 0.18005325E-05_JPRB, &
  & 0.18007245E-05_JPRB, 0.18012113E-05_JPRB, 0.18012882E-05_JPRB, 0.18012667E-05_JPRB  /)

RGHG2(:,75, 9) = (/ &
  & 0.17043321E-05_JPRB, 0.17044216E-05_JPRB, 0.17044681E-05_JPRB, 0.17044421E-05_JPRB, 0.17044292E-05_JPRB, 0.17044190E-05_JPRB, &
  & 0.17044223E-05_JPRB, 0.17044329E-05_JPRB, 0.17044125E-05_JPRB, 0.17043216E-05_JPRB, 0.17042469E-05_JPRB, 0.17041741E-05_JPRB, &
  & 0.17040494E-05_JPRB, 0.17038971E-05_JPRB, 0.17037686E-05_JPRB, 0.17036434E-05_JPRB, 0.17035151E-05_JPRB, 0.17034660E-05_JPRB, &
  & 0.17033614E-05_JPRB, 0.17031098E-05_JPRB, 0.17027325E-05_JPRB, 0.17023525E-05_JPRB, 0.17018512E-05_JPRB, 0.17010335E-05_JPRB, &
  & 0.16994531E-05_JPRB, 0.16978619E-05_JPRB, 0.16964147E-05_JPRB, 0.16958042E-05_JPRB, 0.16955464E-05_JPRB, 0.16965475E-05_JPRB, &
  & 0.16991143E-05_JPRB, 0.17019067E-05_JPRB, 0.17044038E-05_JPRB, 0.17065620E-05_JPRB, 0.17132874E-05_JPRB, 0.17229484E-05_JPRB, &
  & 0.17289298E-05_JPRB, 0.17340427E-05_JPRB, 0.17405601E-05_JPRB, 0.17470795E-05_JPRB, 0.17534752E-05_JPRB, 0.17598999E-05_JPRB, &
  & 0.17622796E-05_JPRB, 0.17639802E-05_JPRB, 0.17658939E-05_JPRB, 0.17677921E-05_JPRB, 0.17710153E-05_JPRB, 0.17758739E-05_JPRB, &
  & 0.17818198E-05_JPRB, 0.17866812E-05_JPRB, 0.17916540E-05_JPRB, 0.17959252E-05_JPRB, 0.17975513E-05_JPRB, 0.17977887E-05_JPRB, &
  & 0.17985180E-05_JPRB, 0.17997557E-05_JPRB, 0.18008072E-05_JPRB, 0.18012385E-05_JPRB, 0.18011253E-05_JPRB, 0.18009918E-05_JPRB, &
  & 0.18010384E-05_JPRB, 0.18014736E-05_JPRB, 0.18015562E-05_JPRB, 0.18016805E-05_JPRB  /)

RGHG2(:,76, 9) = (/ &
  & 0.17044092E-05_JPRB, 0.17044715E-05_JPRB, 0.17045192E-05_JPRB, 0.17044944E-05_JPRB, 0.17044766E-05_JPRB, 0.17044714E-05_JPRB, &
  & 0.17044747E-05_JPRB, 0.17044877E-05_JPRB, 0.17044710E-05_JPRB, 0.17043727E-05_JPRB, 0.17043017E-05_JPRB, 0.17042277E-05_JPRB, &
  & 0.17041104E-05_JPRB, 0.17039730E-05_JPRB, 0.17038618E-05_JPRB, 0.17037304E-05_JPRB, 0.17035848E-05_JPRB, 0.17035245E-05_JPRB, &
  & 0.17034286E-05_JPRB, 0.17032017E-05_JPRB, 0.17028232E-05_JPRB, 0.17024382E-05_JPRB, 0.17018924E-05_JPRB, 0.17009929E-05_JPRB, &
  & 0.16995017E-05_JPRB, 0.16979365E-05_JPRB, 0.16966788E-05_JPRB, 0.16960931E-05_JPRB, 0.16957189E-05_JPRB, 0.16964054E-05_JPRB, &
  & 0.16985572E-05_JPRB, 0.17014587E-05_JPRB, 0.17037886E-05_JPRB, 0.17055603E-05_JPRB, 0.17123539E-05_JPRB, 0.17227505E-05_JPRB, &
  & 0.17291395E-05_JPRB, 0.17344480E-05_JPRB, 0.17408527E-05_JPRB, 0.17480223E-05_JPRB, 0.17554299E-05_JPRB, 0.17628936E-05_JPRB, &
  & 0.17650331E-05_JPRB, 0.17665615E-05_JPRB, 0.17684009E-05_JPRB, 0.17707339E-05_JPRB, 0.17740103E-05_JPRB, 0.17785804E-05_JPRB, &
  & 0.17843950E-05_JPRB, 0.17890966E-05_JPRB, 0.17945734E-05_JPRB, 0.17985214E-05_JPRB, 0.17996942E-05_JPRB, 0.17997905E-05_JPRB, &
  & 0.18002225E-05_JPRB, 0.18011976E-05_JPRB, 0.18019679E-05_JPRB, 0.18021677E-05_JPRB, 0.18017522E-05_JPRB, 0.18014578E-05_JPRB, &
  & 0.18013396E-05_JPRB, 0.18017117E-05_JPRB, 0.18017956E-05_JPRB, 0.18020536E-05_JPRB  /)

RGHG2(:,77, 9) = (/ &
  & 0.17044890E-05_JPRB, 0.17045237E-05_JPRB, 0.17045667E-05_JPRB, 0.17045456E-05_JPRB, 0.17045263E-05_JPRB, 0.17045297E-05_JPRB, &
  & 0.17045318E-05_JPRB, 0.17045485E-05_JPRB, 0.17045380E-05_JPRB, 0.17044333E-05_JPRB, 0.17043649E-05_JPRB, 0.17042896E-05_JPRB, &
  & 0.17041811E-05_JPRB, 0.17040694E-05_JPRB, 0.17039746E-05_JPRB, 0.17038465E-05_JPRB, 0.17036845E-05_JPRB, 0.17036212E-05_JPRB, &
  & 0.17035412E-05_JPRB, 0.17033336E-05_JPRB, 0.17029585E-05_JPRB, 0.17025924E-05_JPRB, 0.17020144E-05_JPRB, 0.17010785E-05_JPRB, &
  & 0.16996968E-05_JPRB, 0.16982199E-05_JPRB, 0.16970388E-05_JPRB, 0.16965450E-05_JPRB, 0.16960789E-05_JPRB, 0.16964022E-05_JPRB, &
  & 0.16982548E-05_JPRB, 0.17010702E-05_JPRB, 0.17031996E-05_JPRB, 0.17046306E-05_JPRB, 0.17115004E-05_JPRB, 0.17226266E-05_JPRB, &
  & 0.17294538E-05_JPRB, 0.17349025E-05_JPRB, 0.17413560E-05_JPRB, 0.17490112E-05_JPRB, 0.17575475E-05_JPRB, 0.17660330E-05_JPRB, &
  & 0.17679502E-05_JPRB, 0.17689979E-05_JPRB, 0.17707798E-05_JPRB, 0.17735822E-05_JPRB, 0.17770270E-05_JPRB, 0.17814641E-05_JPRB, &
  & 0.17870395E-05_JPRB, 0.17918495E-05_JPRB, 0.17975481E-05_JPRB, 0.18011373E-05_JPRB, 0.18019027E-05_JPRB, 0.18018403E-05_JPRB, &
  & 0.18020411E-05_JPRB, 0.18026808E-05_JPRB, 0.18031791E-05_JPRB, 0.18031666E-05_JPRB, 0.18023243E-05_JPRB, 0.18018951E-05_JPRB, &
  & 0.18016528E-05_JPRB, 0.18019358E-05_JPRB, 0.18020138E-05_JPRB, 0.18023729E-05_JPRB  /)

RGHG2(:,78, 9) = (/ &
  & 0.17045608E-05_JPRB, 0.17045735E-05_JPRB, 0.17046107E-05_JPRB, 0.17045941E-05_JPRB, 0.17045744E-05_JPRB, 0.17045921E-05_JPRB, &
  & 0.17045882E-05_JPRB, 0.17046119E-05_JPRB, 0.17046108E-05_JPRB, 0.17045030E-05_JPRB, 0.17044332E-05_JPRB, 0.17043542E-05_JPRB, &
  & 0.17042505E-05_JPRB, 0.17041628E-05_JPRB, 0.17040866E-05_JPRB, 0.17039607E-05_JPRB, 0.17037928E-05_JPRB, 0.17037262E-05_JPRB, &
  & 0.17036673E-05_JPRB, 0.17034664E-05_JPRB, 0.17030983E-05_JPRB, 0.17027490E-05_JPRB, 0.17021645E-05_JPRB, 0.17012466E-05_JPRB, &
  & 0.16999440E-05_JPRB, 0.16985873E-05_JPRB, 0.16974604E-05_JPRB, 0.16970370E-05_JPRB, 0.16965916E-05_JPRB, 0.16965417E-05_JPRB, &
  & 0.16981088E-05_JPRB, 0.17007417E-05_JPRB, 0.17026581E-05_JPRB, 0.17038480E-05_JPRB, 0.17107886E-05_JPRB, 0.17225415E-05_JPRB, &
  & 0.17298071E-05_JPRB, 0.17353676E-05_JPRB, 0.17418843E-05_JPRB, 0.17500413E-05_JPRB, 0.17595571E-05_JPRB, 0.17692327E-05_JPRB, &
  & 0.17706200E-05_JPRB, 0.17712602E-05_JPRB, 0.17729099E-05_JPRB, 0.17761047E-05_JPRB, 0.17797555E-05_JPRB, 0.17841443E-05_JPRB, &
  & 0.17895648E-05_JPRB, 0.17944888E-05_JPRB, 0.18002261E-05_JPRB, 0.18035452E-05_JPRB, 0.18038387E-05_JPRB, 0.18036906E-05_JPRB, &
  & 0.18037740E-05_JPRB, 0.18042000E-05_JPRB, 0.18043870E-05_JPRB, 0.18041514E-05_JPRB, 0.18029073E-05_JPRB, 0.18022512E-05_JPRB, &
  & 0.18019025E-05_JPRB, 0.18021001E-05_JPRB, 0.18021695E-05_JPRB, 0.18026044E-05_JPRB  /)

RGHG2(:,79, 9) = (/ &
  & 0.17046228E-05_JPRB, 0.17046189E-05_JPRB, 0.17046510E-05_JPRB, 0.17046394E-05_JPRB, 0.17046212E-05_JPRB, 0.17046564E-05_JPRB, &
  & 0.17046442E-05_JPRB, 0.17046794E-05_JPRB, 0.17046891E-05_JPRB, 0.17045789E-05_JPRB, 0.17045049E-05_JPRB, 0.17044218E-05_JPRB, &
  & 0.17043205E-05_JPRB, 0.17042528E-05_JPRB, 0.17041895E-05_JPRB, 0.17040652E-05_JPRB, 0.17039020E-05_JPRB, 0.17038305E-05_JPRB, &
  & 0.17037940E-05_JPRB, 0.17035932E-05_JPRB, 0.17032350E-05_JPRB, 0.17028967E-05_JPRB, 0.17023188E-05_JPRB, 0.17014586E-05_JPRB, &
  & 0.17002238E-05_JPRB, 0.16989882E-05_JPRB, 0.16979125E-05_JPRB, 0.16975622E-05_JPRB, 0.16972317E-05_JPRB, 0.16968087E-05_JPRB, &
  & 0.16980793E-05_JPRB, 0.17004527E-05_JPRB, 0.17022048E-05_JPRB, 0.17032460E-05_JPRB, 0.17102276E-05_JPRB, 0.17225104E-05_JPRB, &
  & 0.17301897E-05_JPRB, 0.17358418E-05_JPRB, 0.17423868E-05_JPRB, 0.17510397E-05_JPRB, 0.17613304E-05_JPRB, 0.17723256E-05_JPRB, &
  & 0.17729674E-05_JPRB, 0.17733102E-05_JPRB, 0.17747943E-05_JPRB, 0.17782948E-05_JPRB, 0.17821317E-05_JPRB, 0.17864877E-05_JPRB, &
  & 0.17918180E-05_JPRB, 0.17968229E-05_JPRB, 0.18025149E-05_JPRB, 0.18056481E-05_JPRB, 0.18055120E-05_JPRB, 0.18053310E-05_JPRB, &
  & 0.18053867E-05_JPRB, 0.18056817E-05_JPRB, 0.18055787E-05_JPRB, 0.18050693E-05_JPRB, 0.18034781E-05_JPRB, 0.18025303E-05_JPRB, &
  & 0.18020821E-05_JPRB, 0.18022014E-05_JPRB, 0.18022576E-05_JPRB, 0.18027144E-05_JPRB  /)

RGHG2(:,80, 9) = (/ &
  & 0.17046740E-05_JPRB, 0.17046576E-05_JPRB, 0.17046872E-05_JPRB, 0.17046806E-05_JPRB, 0.17046673E-05_JPRB, 0.17047198E-05_JPRB, &
  & 0.17047000E-05_JPRB, 0.17047525E-05_JPRB, 0.17047721E-05_JPRB, 0.17046570E-05_JPRB, 0.17045782E-05_JPRB, 0.17044926E-05_JPRB, &
  & 0.17043936E-05_JPRB, 0.17043408E-05_JPRB, 0.17042750E-05_JPRB, 0.17041532E-05_JPRB, 0.17040050E-05_JPRB, 0.17039261E-05_JPRB, &
  & 0.17039095E-05_JPRB, 0.17037086E-05_JPRB, 0.17033627E-05_JPRB, 0.17030268E-05_JPRB, 0.17024538E-05_JPRB, 0.17016730E-05_JPRB, &
  & 0.17005195E-05_JPRB, 0.16993725E-05_JPRB, 0.16983611E-05_JPRB, 0.16981186E-05_JPRB, 0.16979701E-05_JPRB, 0.16971831E-05_JPRB, &
  & 0.16981250E-05_JPRB, 0.17001792E-05_JPRB, 0.17018825E-05_JPRB, 0.17028531E-05_JPRB, 0.17098202E-05_JPRB, 0.17225505E-05_JPRB, &
  & 0.17305943E-05_JPRB, 0.17363244E-05_JPRB, 0.17428168E-05_JPRB, 0.17519252E-05_JPRB, 0.17627436E-05_JPRB, 0.17751292E-05_JPRB, &
  & 0.17749411E-05_JPRB, 0.17751105E-05_JPRB, 0.17764475E-05_JPRB, 0.17801672E-05_JPRB, 0.17841117E-05_JPRB, 0.17883766E-05_JPRB, &
  & 0.17936453E-05_JPRB, 0.17986727E-05_JPRB, 0.18043418E-05_JPRB, 0.18073571E-05_JPRB, 0.18069596E-05_JPRB, 0.18067686E-05_JPRB, &
  & 0.18068542E-05_JPRB, 0.18070430E-05_JPRB, 0.18067405E-05_JPRB, 0.18058666E-05_JPRB, 0.18040071E-05_JPRB, 0.18027426E-05_JPRB, &
  & 0.18021909E-05_JPRB, 0.18022420E-05_JPRB, 0.18022791E-05_JPRB, 0.18026724E-05_JPRB  /)

RGHG2(:,81, 9) = (/ &
  & 0.17047101E-05_JPRB, 0.17046886E-05_JPRB, 0.17047183E-05_JPRB, 0.17047142E-05_JPRB, 0.17047086E-05_JPRB, 0.17047814E-05_JPRB, &
  & 0.17047616E-05_JPRB, 0.17048344E-05_JPRB, 0.17048643E-05_JPRB, 0.17047339E-05_JPRB, 0.17046373E-05_JPRB, 0.17045567E-05_JPRB, &
  & 0.17044731E-05_JPRB, 0.17044279E-05_JPRB, 0.17043596E-05_JPRB, 0.17042403E-05_JPRB, 0.17040946E-05_JPRB, 0.17040030E-05_JPRB, &
  & 0.17040042E-05_JPRB, 0.17038059E-05_JPRB, 0.17034778E-05_JPRB, 0.17031470E-05_JPRB, 0.17025817E-05_JPRB, 0.17018492E-05_JPRB, &
  & 0.17007874E-05_JPRB, 0.16997424E-05_JPRB, 0.16987895E-05_JPRB, 0.16987228E-05_JPRB, 0.16986023E-05_JPRB, 0.16975554E-05_JPRB, &
  & 0.16981993E-05_JPRB, 0.16999989E-05_JPRB, 0.17016054E-05_JPRB, 0.17026345E-05_JPRB, 0.17095659E-05_JPRB, 0.17226758E-05_JPRB, &
  & 0.17309488E-05_JPRB, 0.17368368E-05_JPRB, 0.17433420E-05_JPRB, 0.17525853E-05_JPRB, 0.17639693E-05_JPRB, 0.17774730E-05_JPRB, &
  & 0.17765030E-05_JPRB, 0.17765526E-05_JPRB, 0.17778667E-05_JPRB, 0.17816399E-05_JPRB, 0.17855665E-05_JPRB, 0.17897220E-05_JPRB, &
  & 0.17949168E-05_JPRB, 0.17999493E-05_JPRB, 0.18056489E-05_JPRB, 0.18087000E-05_JPRB, 0.18082362E-05_JPRB, 0.18080452E-05_JPRB, &
  & 0.18081283E-05_JPRB, 0.18082279E-05_JPRB, 0.18078923E-05_JPRB, 0.18065930E-05_JPRB, 0.18044023E-05_JPRB, 0.18028831E-05_JPRB, &
  & 0.18022092E-05_JPRB, 0.18021177E-05_JPRB, 0.18020835E-05_JPRB, 0.18023520E-05_JPRB  /)

RGHG2(:,82, 9) = (/ &
  & 0.17047334E-05_JPRB, 0.17047156E-05_JPRB, 0.17047400E-05_JPRB, 0.17047420E-05_JPRB, 0.17047492E-05_JPRB, 0.17048440E-05_JPRB, &
  & 0.17048278E-05_JPRB, 0.17049208E-05_JPRB, 0.17049625E-05_JPRB, 0.17048030E-05_JPRB, 0.17046834E-05_JPRB, 0.17046044E-05_JPRB, &
  & 0.17045481E-05_JPRB, 0.17045211E-05_JPRB, 0.17044467E-05_JPRB, 0.17043265E-05_JPRB, 0.17041728E-05_JPRB, 0.17040668E-05_JPRB, &
  & 0.17040980E-05_JPRB, 0.17039022E-05_JPRB, 0.17035936E-05_JPRB, 0.17032678E-05_JPRB, 0.17027048E-05_JPRB, 0.17020099E-05_JPRB, &
  & 0.17010393E-05_JPRB, 0.17000709E-05_JPRB, 0.16991674E-05_JPRB, 0.16993139E-05_JPRB, 0.16992266E-05_JPRB, 0.16979286E-05_JPRB, &
  & 0.16984063E-05_JPRB, 0.16999825E-05_JPRB, 0.17014701E-05_JPRB, 0.17025504E-05_JPRB, 0.17094692E-05_JPRB, 0.17228701E-05_JPRB, &
  & 0.17312656E-05_JPRB, 0.17373404E-05_JPRB, 0.17439196E-05_JPRB, 0.17532041E-05_JPRB, 0.17650552E-05_JPRB, 0.17794769E-05_JPRB, &
  & 0.17778773E-05_JPRB, 0.17778571E-05_JPRB, 0.17791554E-05_JPRB, 0.17829098E-05_JPRB, 0.17867872E-05_JPRB, 0.17907794E-05_JPRB, &
  & 0.17959289E-05_JPRB, 0.18009647E-05_JPRB, 0.18066754E-05_JPRB, 0.18098110E-05_JPRB, 0.18093568E-05_JPRB, 0.18091168E-05_JPRB, &
  & 0.18091692E-05_JPRB, 0.18092768E-05_JPRB, 0.18089433E-05_JPRB, 0.18072302E-05_JPRB, 0.18047351E-05_JPRB, 0.18030102E-05_JPRB, &
  & 0.18022060E-05_JPRB, 0.18019114E-05_JPRB, 0.18017238E-05_JPRB, 0.18018261E-05_JPRB  /)

RGHG2(:,83, 9) = (/ &
  & 0.17047475E-05_JPRB, 0.17047382E-05_JPRB, 0.17047550E-05_JPRB, 0.17047655E-05_JPRB, 0.17047897E-05_JPRB, 0.17049091E-05_JPRB, &
  & 0.17049017E-05_JPRB, 0.17050100E-05_JPRB, 0.17050604E-05_JPRB, 0.17048628E-05_JPRB, 0.17047171E-05_JPRB, 0.17046390E-05_JPRB, &
  & 0.17046174E-05_JPRB, 0.17046149E-05_JPRB, 0.17045359E-05_JPRB, 0.17044131E-05_JPRB, 0.17042440E-05_JPRB, 0.17041278E-05_JPRB, &
  & 0.17041970E-05_JPRB, 0.17040008E-05_JPRB, 0.17037113E-05_JPRB, 0.17033964E-05_JPRB, 0.17028266E-05_JPRB, 0.17021643E-05_JPRB, &
  & 0.17012734E-05_JPRB, 0.17003712E-05_JPRB, 0.16995080E-05_JPRB, 0.16999102E-05_JPRB, 0.16999182E-05_JPRB, 0.16982819E-05_JPRB, &
  & 0.16986867E-05_JPRB, 0.17001052E-05_JPRB, 0.17014608E-05_JPRB, 0.17026180E-05_JPRB, 0.17096121E-05_JPRB, 0.17231998E-05_JPRB, &
  & 0.17315783E-05_JPRB, 0.17378066E-05_JPRB, 0.17444755E-05_JPRB, 0.17537736E-05_JPRB, 0.17659772E-05_JPRB, 0.17811313E-05_JPRB, &
  & 0.17790654E-05_JPRB, 0.17790432E-05_JPRB, 0.17803115E-05_JPRB, 0.17840215E-05_JPRB, 0.17878342E-05_JPRB, 0.17916368E-05_JPRB, &
  & 0.17967692E-05_JPRB, 0.18018162E-05_JPRB, 0.18075159E-05_JPRB, 0.18107773E-05_JPRB, 0.18103337E-05_JPRB, 0.18100234E-05_JPRB, &
  & 0.18100361E-05_JPRB, 0.18101656E-05_JPRB, 0.18098974E-05_JPRB, 0.18077612E-05_JPRB, 0.18050382E-05_JPRB, 0.18031689E-05_JPRB, &
  & 0.18022133E-05_JPRB, 0.18016815E-05_JPRB, 0.18012901E-05_JPRB, 0.18012161E-05_JPRB  /)

RGHG2(:,84, 9) = (/ &
  & 0.17047554E-05_JPRB, 0.17047560E-05_JPRB, 0.17047655E-05_JPRB, 0.17047860E-05_JPRB, 0.17048300E-05_JPRB, 0.17049770E-05_JPRB, &
  & 0.17049851E-05_JPRB, 0.17051001E-05_JPRB, 0.17051530E-05_JPRB, 0.17049122E-05_JPRB, 0.17047396E-05_JPRB, 0.17046642E-05_JPRB, &
  & 0.17046798E-05_JPRB, 0.17047048E-05_JPRB, 0.17046255E-05_JPRB, 0.17045004E-05_JPRB, 0.17043121E-05_JPRB, 0.17041933E-05_JPRB, &
  & 0.17043055E-05_JPRB, 0.17041051E-05_JPRB, 0.17038326E-05_JPRB, 0.17035363E-05_JPRB, 0.17029501E-05_JPRB, 0.17023202E-05_JPRB, &
  & 0.17014899E-05_JPRB, 0.17006534E-05_JPRB, 0.16998239E-05_JPRB, 0.17005370E-05_JPRB, 0.17007396E-05_JPRB, 0.16986049E-05_JPRB, &
  & 0.16989933E-05_JPRB, 0.17003442E-05_JPRB, 0.17015648E-05_JPRB, 0.17028320E-05_JPRB, 0.17100218E-05_JPRB, 0.17237079E-05_JPRB, &
  & 0.17319104E-05_JPRB, 0.17382204E-05_JPRB, 0.17449578E-05_JPRB, 0.17542953E-05_JPRB, 0.17667594E-05_JPRB, 0.17824857E-05_JPRB, &
  & 0.17800918E-05_JPRB, 0.17801323E-05_JPRB, 0.17813473E-05_JPRB, 0.17850241E-05_JPRB, 0.17887720E-05_JPRB, 0.17923792E-05_JPRB, &
  & 0.17975189E-05_JPRB, 0.18025879E-05_JPRB, 0.18082545E-05_JPRB, 0.18116745E-05_JPRB, 0.18111863E-05_JPRB, 0.18108085E-05_JPRB, &
  & 0.18107849E-05_JPRB, 0.18108865E-05_JPRB, 0.18107561E-05_JPRB, 0.18081812E-05_JPRB, 0.18053411E-05_JPRB, 0.18033927E-05_JPRB, &
  & 0.18022559E-05_JPRB, 0.18014798E-05_JPRB, 0.18008691E-05_JPRB, 0.18006377E-05_JPRB  /)

RGHG2(:,85, 9) = (/ &
  & 0.17047576E-05_JPRB, 0.17047685E-05_JPRB, 0.17047702E-05_JPRB, 0.17048035E-05_JPRB, 0.17048681E-05_JPRB, 0.17050511E-05_JPRB, &
  & 0.17050849E-05_JPRB, 0.17051947E-05_JPRB, 0.17052528E-05_JPRB, 0.17049477E-05_JPRB, 0.17047520E-05_JPRB, 0.17046817E-05_JPRB, &
  & 0.17047384E-05_JPRB, 0.17047969E-05_JPRB, 0.17047124E-05_JPRB, 0.17045873E-05_JPRB, 0.17043887E-05_JPRB, 0.17042648E-05_JPRB, &
  & 0.17044360E-05_JPRB, 0.17042433E-05_JPRB, 0.17039837E-05_JPRB, 0.17036874E-05_JPRB, 0.17030986E-05_JPRB, 0.17025073E-05_JPRB, &
  & 0.17017206E-05_JPRB, 0.17009354E-05_JPRB, 0.17001650E-05_JPRB, 0.17014609E-05_JPRB, 0.17019691E-05_JPRB, 0.16989871E-05_JPRB, &
  & 0.16993729E-05_JPRB, 0.17007957E-05_JPRB, 0.17018931E-05_JPRB, 0.17030986E-05_JPRB, 0.17104964E-05_JPRB, 0.17245086E-05_JPRB, &
  & 0.17322900E-05_JPRB, 0.17386847E-05_JPRB, 0.17454426E-05_JPRB, 0.17548957E-05_JPRB, 0.17679529E-05_JPRB, 0.17842082E-05_JPRB, &
  & 0.17812571E-05_JPRB, 0.17812591E-05_JPRB, 0.17824767E-05_JPRB, 0.17861407E-05_JPRB, 0.17898526E-05_JPRB, 0.17932184E-05_JPRB, &
  & 0.17983632E-05_JPRB, 0.18034117E-05_JPRB, 0.18090295E-05_JPRB, 0.18126575E-05_JPRB, 0.18120435E-05_JPRB, 0.18116246E-05_JPRB, &
  & 0.18115368E-05_JPRB, 0.18115203E-05_JPRB, 0.18115208E-05_JPRB, 0.18085556E-05_JPRB, 0.18057361E-05_JPRB, 0.18037440E-05_JPRB, &
  & 0.18023710E-05_JPRB, 0.18013895E-05_JPRB, 0.18006428E-05_JPRB, 0.18003394E-05_JPRB  /)

RGHG2(:,86, 9) = (/ &
  & 0.17047585E-05_JPRB, 0.17047777E-05_JPRB, 0.17047777E-05_JPRB, 0.17048179E-05_JPRB, 0.17049052E-05_JPRB, 0.17051243E-05_JPRB, &
  & 0.17051879E-05_JPRB, 0.17052865E-05_JPRB, 0.17053377E-05_JPRB, 0.17049721E-05_JPRB, 0.17047612E-05_JPRB, 0.17046941E-05_JPRB, &
  & 0.17047841E-05_JPRB, 0.17048801E-05_JPRB, 0.17047925E-05_JPRB, 0.17046734E-05_JPRB, 0.17044685E-05_JPRB, 0.17043454E-05_JPRB, &
  & 0.17045840E-05_JPRB, 0.17044473E-05_JPRB, 0.17041644E-05_JPRB, 0.17038781E-05_JPRB, 0.17033029E-05_JPRB, 0.17027161E-05_JPRB, &
  & 0.17019712E-05_JPRB, 0.17012076E-05_JPRB, 0.17005106E-05_JPRB, 0.17026736E-05_JPRB, 0.17038525E-05_JPRB, 0.16995066E-05_JPRB, &
  & 0.16999280E-05_JPRB, 0.17014712E-05_JPRB, 0.17025894E-05_JPRB, 0.17035221E-05_JPRB, 0.17110646E-05_JPRB, 0.17254929E-05_JPRB, &
  & 0.17327969E-05_JPRB, 0.17393792E-05_JPRB, 0.17460573E-05_JPRB, 0.17557490E-05_JPRB, 0.17697982E-05_JPRB, 0.17868181E-05_JPRB, &
  & 0.17827525E-05_JPRB, 0.17826194E-05_JPRB, 0.17837290E-05_JPRB, 0.17875328E-05_JPRB, 0.17912508E-05_JPRB, 0.17941912E-05_JPRB, &
  & 0.17992829E-05_JPRB, 0.18043449E-05_JPRB, 0.18100121E-05_JPRB, 0.18138190E-05_JPRB, 0.18130122E-05_JPRB, 0.18125541E-05_JPRB, &
  & 0.18123757E-05_JPRB, 0.18121902E-05_JPRB, 0.18122982E-05_JPRB, 0.18089287E-05_JPRB, 0.18061801E-05_JPRB, 0.18041401E-05_JPRB, &
  & 0.18025538E-05_JPRB, 0.18013960E-05_JPRB, 0.18005547E-05_JPRB, 0.18001569E-05_JPRB  /)

RGHG2(:,87, 9) = (/ &
  & 0.17047605E-05_JPRB, 0.17047863E-05_JPRB, 0.17047849E-05_JPRB, 0.17048291E-05_JPRB, 0.17049399E-05_JPRB, 0.17051930E-05_JPRB, &
  & 0.17052881E-05_JPRB, 0.17053669E-05_JPRB, 0.17054143E-05_JPRB, 0.17049898E-05_JPRB, 0.17047685E-05_JPRB, 0.17047026E-05_JPRB, &
  & 0.17048227E-05_JPRB, 0.17049567E-05_JPRB, 0.17048611E-05_JPRB, 0.17047632E-05_JPRB, 0.17045518E-05_JPRB, 0.17044367E-05_JPRB, &
  & 0.17047594E-05_JPRB, 0.17047269E-05_JPRB, 0.17043818E-05_JPRB, 0.17041087E-05_JPRB, 0.17035518E-05_JPRB, 0.17029531E-05_JPRB, &
  & 0.17022528E-05_JPRB, 0.17015090E-05_JPRB, 0.17008920E-05_JPRB, 0.17041453E-05_JPRB, 0.17066028E-05_JPRB, 0.17002072E-05_JPRB, &
  & 0.17007694E-05_JPRB, 0.17025680E-05_JPRB, 0.17039337E-05_JPRB, 0.17042300E-05_JPRB, 0.17118728E-05_JPRB, 0.17266945E-05_JPRB, &
  & 0.17335727E-05_JPRB, 0.17404381E-05_JPRB, 0.17469486E-05_JPRB, 0.17570827E-05_JPRB, 0.17726309E-05_JPRB, 0.17904479E-05_JPRB, &
  & 0.17848561E-05_JPRB, 0.17844548E-05_JPRB, 0.17852624E-05_JPRB, 0.17894703E-05_JPRB, 0.17932254E-05_JPRB, 0.17954254E-05_JPRB, &
  & 0.18004102E-05_JPRB, 0.18055145E-05_JPRB, 0.18113446E-05_JPRB, 0.18152790E-05_JPRB, 0.18141704E-05_JPRB, 0.18136248E-05_JPRB, &
  & 0.18133494E-05_JPRB, 0.18129806E-05_JPRB, 0.18131680E-05_JPRB, 0.18093296E-05_JPRB, 0.18066326E-05_JPRB, 0.18045696E-05_JPRB, &
  & 0.18027723E-05_JPRB, 0.18014602E-05_JPRB, 0.18005470E-05_JPRB, 0.18000538E-05_JPRB  /)

RGHG2(:,88, 9) = (/ &
  & 0.17047631E-05_JPRB, 0.17047943E-05_JPRB, 0.17047910E-05_JPRB, 0.17048363E-05_JPRB, 0.17049726E-05_JPRB, 0.17052539E-05_JPRB, &
  & 0.17053843E-05_JPRB, 0.17054293E-05_JPRB, 0.17054850E-05_JPRB, 0.17050025E-05_JPRB, 0.17047738E-05_JPRB, 0.17047087E-05_JPRB, &
  & 0.17048582E-05_JPRB, 0.17050290E-05_JPRB, 0.17049189E-05_JPRB, 0.17048670E-05_JPRB, 0.17046450E-05_JPRB, 0.17045523E-05_JPRB, &
  & 0.17049806E-05_JPRB, 0.17050948E-05_JPRB, 0.17046563E-05_JPRB, 0.17043977E-05_JPRB, 0.17038655E-05_JPRB, 0.17032104E-05_JPRB, &
  & 0.17026165E-05_JPRB, 0.17018740E-05_JPRB, 0.17013429E-05_JPRB, 0.17058648E-05_JPRB, 0.17103229E-05_JPRB, 0.17011764E-05_JPRB, &
  & 0.17020916E-05_JPRB, 0.17043951E-05_JPRB, 0.17063075E-05_JPRB, 0.17054351E-05_JPRB, 0.17131991E-05_JPRB, 0.17282938E-05_JPRB, &
  & 0.17348307E-05_JPRB, 0.17420375E-05_JPRB, 0.17483510E-05_JPRB, 0.17592742E-05_JPRB, 0.17772600E-05_JPRB, 0.17959178E-05_JPRB, &
  & 0.17881397E-05_JPRB, 0.17872110E-05_JPRB, 0.17875291E-05_JPRB, 0.17926260E-05_JPRB, 0.17962838E-05_JPRB, 0.17971655E-05_JPRB, &
  & 0.18019997E-05_JPRB, 0.18071174E-05_JPRB, 0.18132778E-05_JPRB, 0.18172463E-05_JPRB, 0.18156804E-05_JPRB, 0.18149118E-05_JPRB, &
  & 0.18145147E-05_JPRB, 0.18140102E-05_JPRB, 0.18142351E-05_JPRB, 0.18097737E-05_JPRB, 0.18070904E-05_JPRB, 0.18050239E-05_JPRB, &
  & 0.18030129E-05_JPRB, 0.18015726E-05_JPRB, 0.18005821E-05_JPRB, 0.18000051E-05_JPRB  /)

RGHG2(:,89, 9) = (/ &
  & 0.17047629E-05_JPRB, 0.17047995E-05_JPRB, 0.17047958E-05_JPRB, 0.17048390E-05_JPRB, 0.17050029E-05_JPRB, 0.17053015E-05_JPRB, &
  & 0.17054757E-05_JPRB, 0.17054664E-05_JPRB, 0.17055470E-05_JPRB, 0.17050109E-05_JPRB, 0.17047764E-05_JPRB, 0.17047139E-05_JPRB, &
  & 0.17048925E-05_JPRB, 0.17050989E-05_JPRB, 0.17049727E-05_JPRB, 0.17049982E-05_JPRB, 0.17047582E-05_JPRB, 0.17047133E-05_JPRB, &
  & 0.17052736E-05_JPRB, 0.17055420E-05_JPRB, 0.17050178E-05_JPRB, 0.17047644E-05_JPRB, 0.17042830E-05_JPRB, 0.17034509E-05_JPRB, &
  & 0.17032141E-05_JPRB, 0.17023218E-05_JPRB, 0.17018789E-05_JPRB, 0.17077072E-05_JPRB, 0.17146966E-05_JPRB, 0.17024743E-05_JPRB, &
  & 0.17041766E-05_JPRB, 0.17072927E-05_JPRB, 0.17100352E-05_JPRB, 0.17072892E-05_JPRB, 0.17152973E-05_JPRB, 0.17305631E-05_JPRB, &
  & 0.17368238E-05_JPRB, 0.17443617E-05_JPRB, 0.17505381E-05_JPRB, 0.17628269E-05_JPRB, 0.17848883E-05_JPRB, 0.18045910E-05_JPRB, &
  & 0.17935814E-05_JPRB, 0.17916029E-05_JPRB, 0.17914250E-05_JPRB, 0.17981952E-05_JPRB, 0.18013755E-05_JPRB, 0.17997956E-05_JPRB, &
  & 0.18043900E-05_JPRB, 0.18094457E-05_JPRB, 0.18161827E-05_JPRB, 0.18199482E-05_JPRB, 0.18177487E-05_JPRB, 0.18165106E-05_JPRB, &
  & 0.18159011E-05_JPRB, 0.18153975E-05_JPRB, 0.18155993E-05_JPRB, 0.18102333E-05_JPRB, 0.18075477E-05_JPRB, 0.18054539E-05_JPRB, &
  & 0.18032603E-05_JPRB, 0.18017317E-05_JPRB, 0.18006200E-05_JPRB, 0.17999848E-05_JPRB  /)

RGHG2(:,90, 9) = (/ &
  & 0.17047618E-05_JPRB, 0.17048013E-05_JPRB, 0.17047948E-05_JPRB, 0.17048409E-05_JPRB, 0.17050256E-05_JPRB, 0.17053428E-05_JPRB, &
  & 0.17055673E-05_JPRB, 0.17054833E-05_JPRB, 0.17056025E-05_JPRB, 0.17050189E-05_JPRB, 0.17047785E-05_JPRB, 0.17047158E-05_JPRB, &
  & 0.17049273E-05_JPRB, 0.17051795E-05_JPRB, 0.17050436E-05_JPRB, 0.17051697E-05_JPRB, 0.17049072E-05_JPRB, 0.17049242E-05_JPRB, &
  & 0.17057078E-05_JPRB, 0.17060715E-05_JPRB, 0.17055389E-05_JPRB, 0.17052093E-05_JPRB, 0.17048529E-05_JPRB, 0.17036783E-05_JPRB, &
  & 0.17045427E-05_JPRB, 0.17028736E-05_JPRB, 0.17025107E-05_JPRB, 0.17096538E-05_JPRB, 0.17193631E-05_JPRB, 0.17039904E-05_JPRB, &
  & 0.17074521E-05_JPRB, 0.17112941E-05_JPRB, 0.17148307E-05_JPRB, 0.17092408E-05_JPRB, 0.17175086E-05_JPRB, 0.17337047E-05_JPRB, &
  & 0.17396761E-05_JPRB, 0.17476920E-05_JPRB, 0.17535296E-05_JPRB, 0.17681643E-05_JPRB, 0.17962728E-05_JPRB, 0.18173375E-05_JPRB, &
  & 0.18027660E-05_JPRB, 0.17988314E-05_JPRB, 0.17984668E-05_JPRB, 0.18078088E-05_JPRB, 0.18106014E-05_JPRB, 0.18039880E-05_JPRB, &
  & 0.18078144E-05_JPRB, 0.18132015E-05_JPRB, 0.18207748E-05_JPRB, 0.18236027E-05_JPRB, 0.18205970E-05_JPRB, 0.18186989E-05_JPRB, &
  & 0.18176874E-05_JPRB, 0.18172128E-05_JPRB, 0.18173650E-05_JPRB, 0.18106522E-05_JPRB, 0.18079449E-05_JPRB, 0.18057711E-05_JPRB, &
  & 0.18035232E-05_JPRB, 0.18019045E-05_JPRB, 0.18006425E-05_JPRB, 0.17999839E-05_JPRB  /)

RGHG2(:,91, 9) = (/ &
  & 0.17047597E-05_JPRB, 0.17047992E-05_JPRB, 0.17047959E-05_JPRB, 0.17048420E-05_JPRB, 0.17050363E-05_JPRB, 0.17053886E-05_JPRB, &
  & 0.17056322E-05_JPRB, 0.17054972E-05_JPRB, 0.17056355E-05_JPRB, 0.17050264E-05_JPRB, 0.17047828E-05_JPRB, 0.17047169E-05_JPRB, &
  & 0.17049540E-05_JPRB, 0.17052667E-05_JPRB, 0.17051021E-05_JPRB, 0.17053622E-05_JPRB, 0.17051285E-05_JPRB, 0.17051614E-05_JPRB, &
  & 0.17063598E-05_JPRB, 0.17068767E-05_JPRB, 0.17062643E-05_JPRB, 0.17059252E-05_JPRB, 0.17056454E-05_JPRB, 0.17039761E-05_JPRB, &
  & 0.17070743E-05_JPRB, 0.17036469E-05_JPRB, 0.17037786E-05_JPRB, 0.17140936E-05_JPRB, 0.17277438E-05_JPRB, 0.17057178E-05_JPRB, &
  & 0.17119206E-05_JPRB, 0.17172049E-05_JPRB, 0.17206586E-05_JPRB, 0.17121840E-05_JPRB, 0.17202635E-05_JPRB, 0.17384571E-05_JPRB, &
  & 0.17429479E-05_JPRB, 0.17510373E-05_JPRB, 0.17559495E-05_JPRB, 0.17744197E-05_JPRB, 0.18077582E-05_JPRB, 0.18325564E-05_JPRB, &
  & 0.18151002E-05_JPRB, 0.18102275E-05_JPRB, 0.18096810E-05_JPRB, 0.18244604E-05_JPRB, 0.18247897E-05_JPRB, 0.18109518E-05_JPRB, &
  & 0.18144879E-05_JPRB, 0.18209343E-05_JPRB, 0.18287438E-05_JPRB, 0.18298007E-05_JPRB, 0.18249378E-05_JPRB, 0.18217442E-05_JPRB, &
  & 0.18202923E-05_JPRB, 0.18199071E-05_JPRB, 0.18198742E-05_JPRB, 0.18111000E-05_JPRB, 0.18082587E-05_JPRB, 0.18059573E-05_JPRB, &
  & 0.18038370E-05_JPRB, 0.18020460E-05_JPRB, 0.18006500E-05_JPRB, 0.17999850E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ---GEMS----

RGHG2(:, 1,10) = (/ &
  & 0.17885115E-06_JPRB, 0.17866348E-06_JPRB, 0.17856965E-06_JPRB, 0.17849557E-06_JPRB, 0.17839186E-06_JPRB, 0.17829474E-06_JPRB, &
  & 0.17824206E-06_JPRB, 0.17826840E-06_JPRB, 0.17830132E-06_JPRB, 0.17843795E-06_JPRB, 0.17865031E-06_JPRB, 0.17891864E-06_JPRB, &
  & 0.17916063E-06_JPRB, 0.17941085E-06_JPRB, 0.17956394E-06_JPRB, 0.17974832E-06_JPRB, 0.18017303E-06_JPRB, 0.18102740E-06_JPRB, &
  & 0.18241843E-06_JPRB, 0.18426545E-06_JPRB, 0.18638409E-06_JPRB, 0.18874472E-06_JPRB, 0.19129960E-06_JPRB, 0.19393350E-06_JPRB, &
  & 0.19651471E-06_JPRB, 0.19902515E-06_JPRB, 0.20156357E-06_JPRB, 0.20438348E-06_JPRB, 0.20779273E-06_JPRB, 0.21202837E-06_JPRB, &
  & 0.21710849E-06_JPRB, 0.22279442E-06_JPRB, 0.22852150E-06_JPRB, 0.23337610E-06_JPRB, 0.23664213E-06_JPRB, 0.23832288E-06_JPRB, &
  & 0.23867681E-06_JPRB, 0.23793274E-06_JPRB, 0.23625034E-06_JPRB, 0.23378929E-06_JPRB, 0.23074879E-06_JPRB, 0.22738892E-06_JPRB, &
  & 0.22357800E-06_JPRB, 0.21908885E-06_JPRB, 0.21406634E-06_JPRB, 0.20891378E-06_JPRB, 0.20371678E-06_JPRB, 0.19874859E-06_JPRB, &
  & 0.19403062E-06_JPRB, 0.18970115E-06_JPRB, 0.18554783E-06_JPRB, 0.18127433E-06_JPRB, 0.17745683E-06_JPRB, 0.17417433E-06_JPRB, &
  & 0.17084245E-06_JPRB, 0.16793529E-06_JPRB, 0.16519110E-06_JPRB, 0.16251440E-06_JPRB, 0.16004842E-06_JPRB, 0.15791661E-06_JPRB, &
  & 0.15616507E-06_JPRB, 0.15479873E-06_JPRB, 0.15405301E-06_JPRB, 0.15313444E-06_JPRB  /)

RGHG2(:, 2,10) = (/ &
  & 0.17885115E-06_JPRB, 0.17866348E-06_JPRB, 0.17856965E-06_JPRB, 0.17849557E-06_JPRB, 0.17839186E-06_JPRB, 0.17829474E-06_JPRB, &
  & 0.17824206E-06_JPRB, 0.17826840E-06_JPRB, 0.17830132E-06_JPRB, 0.17843795E-06_JPRB, 0.17865031E-06_JPRB, 0.17891864E-06_JPRB, &
  & 0.17916063E-06_JPRB, 0.17941085E-06_JPRB, 0.17956394E-06_JPRB, 0.17974832E-06_JPRB, 0.18017303E-06_JPRB, 0.18102740E-06_JPRB, &
  & 0.18241843E-06_JPRB, 0.18426545E-06_JPRB, 0.18638409E-06_JPRB, 0.18874472E-06_JPRB, 0.19129960E-06_JPRB, 0.19393350E-06_JPRB, &
  & 0.19651471E-06_JPRB, 0.19902515E-06_JPRB, 0.20156357E-06_JPRB, 0.20438348E-06_JPRB, 0.20779273E-06_JPRB, 0.21202837E-06_JPRB, &
  & 0.21710849E-06_JPRB, 0.22279442E-06_JPRB, 0.22852150E-06_JPRB, 0.23337610E-06_JPRB, 0.23664213E-06_JPRB, 0.23832288E-06_JPRB, &
  & 0.23867681E-06_JPRB, 0.23793274E-06_JPRB, 0.23625034E-06_JPRB, 0.23378929E-06_JPRB, 0.23074879E-06_JPRB, 0.22738892E-06_JPRB, &
  & 0.22357800E-06_JPRB, 0.21908885E-06_JPRB, 0.21406634E-06_JPRB, 0.20891378E-06_JPRB, 0.20371678E-06_JPRB, 0.19874859E-06_JPRB, &
  & 0.19403062E-06_JPRB, 0.18970115E-06_JPRB, 0.18554783E-06_JPRB, 0.18127433E-06_JPRB, 0.17745683E-06_JPRB, 0.17417433E-06_JPRB, &
  & 0.17084245E-06_JPRB, 0.16793529E-06_JPRB, 0.16519110E-06_JPRB, 0.16251440E-06_JPRB, 0.16004842E-06_JPRB, 0.15791661E-06_JPRB, &
  & 0.15616507E-06_JPRB, 0.15479873E-06_JPRB, 0.15405301E-06_JPRB, 0.15313444E-06_JPRB  /)

RGHG2(:, 3,10) = (/ &
  & 0.17885115E-06_JPRB, 0.17866348E-06_JPRB, 0.17856965E-06_JPRB, 0.17849557E-06_JPRB, 0.17839186E-06_JPRB, 0.17829474E-06_JPRB, &
  & 0.17824206E-06_JPRB, 0.17826840E-06_JPRB, 0.17830132E-06_JPRB, 0.17843795E-06_JPRB, 0.17865031E-06_JPRB, 0.17891864E-06_JPRB, &
  & 0.17916063E-06_JPRB, 0.17941085E-06_JPRB, 0.17956394E-06_JPRB, 0.17974832E-06_JPRB, 0.18017303E-06_JPRB, 0.18102740E-06_JPRB, &
  & 0.18241843E-06_JPRB, 0.18426545E-06_JPRB, 0.18638409E-06_JPRB, 0.18874472E-06_JPRB, 0.19129960E-06_JPRB, 0.19393350E-06_JPRB, &
  & 0.19651471E-06_JPRB, 0.19902515E-06_JPRB, 0.20156357E-06_JPRB, 0.20438348E-06_JPRB, 0.20779273E-06_JPRB, 0.21202837E-06_JPRB, &
  & 0.21710849E-06_JPRB, 0.22279442E-06_JPRB, 0.22852150E-06_JPRB, 0.23337610E-06_JPRB, 0.23664213E-06_JPRB, 0.23832288E-06_JPRB, &
  & 0.23867681E-06_JPRB, 0.23793274E-06_JPRB, 0.23625034E-06_JPRB, 0.23378929E-06_JPRB, 0.23074879E-06_JPRB, 0.22738892E-06_JPRB, &
  & 0.22357800E-06_JPRB, 0.21908885E-06_JPRB, 0.21406634E-06_JPRB, 0.20891378E-06_JPRB, 0.20371678E-06_JPRB, 0.19874859E-06_JPRB, &
  & 0.19403062E-06_JPRB, 0.18970115E-06_JPRB, 0.18554783E-06_JPRB, 0.18127433E-06_JPRB, 0.17745683E-06_JPRB, 0.17417433E-06_JPRB, &
  & 0.17084245E-06_JPRB, 0.16793529E-06_JPRB, 0.16519110E-06_JPRB, 0.16251440E-06_JPRB, 0.16004842E-06_JPRB, 0.15791661E-06_JPRB, &
  & 0.15616507E-06_JPRB, 0.15479873E-06_JPRB, 0.15405301E-06_JPRB, 0.15313444E-06_JPRB  /)

RGHG2(:, 4,10) = (/ &
  & 0.17886597E-06_JPRB, 0.17867871E-06_JPRB, 0.17858473E-06_JPRB, 0.17851025E-06_JPRB, 0.17840675E-06_JPRB, 0.17830932E-06_JPRB, &
  & 0.17825633E-06_JPRB, 0.17828181E-06_JPRB, 0.17831383E-06_JPRB, 0.17844921E-06_JPRB, 0.17866076E-06_JPRB, 0.17892810E-06_JPRB, &
  & 0.17916897E-06_JPRB, 0.17941780E-06_JPRB, 0.17957010E-06_JPRB, 0.17975270E-06_JPRB, 0.18017493E-06_JPRB, 0.18102619E-06_JPRB, &
  & 0.18241393E-06_JPRB, 0.18425911E-06_JPRB, 0.18637864E-06_JPRB, 0.18874224E-06_JPRB, 0.19130024E-06_JPRB, 0.19393713E-06_JPRB, &
  & 0.19652307E-06_JPRB, 0.19903973E-06_JPRB, 0.20158594E-06_JPRB, 0.20441522E-06_JPRB, 0.20783475E-06_JPRB, 0.21208315E-06_JPRB, &
  & 0.21717905E-06_JPRB, 0.22287800E-06_JPRB, 0.22860932E-06_JPRB, 0.23346186E-06_JPRB, 0.23672478E-06_JPRB, 0.23840059E-06_JPRB, &
  & 0.23874803E-06_JPRB, 0.23799646E-06_JPRB, 0.23630374E-06_JPRB, 0.23383037E-06_JPRB, 0.23077564E-06_JPRB, 0.22739875E-06_JPRB, &
  & 0.22357160E-06_JPRB, 0.21907043E-06_JPRB, 0.21404275E-06_JPRB, 0.20888791E-06_JPRB, 0.20368975E-06_JPRB, 0.19872215E-06_JPRB, &
  & 0.19400632E-06_JPRB, 0.18967844E-06_JPRB, 0.18552646E-06_JPRB, 0.18125722E-06_JPRB, 0.17744340E-06_JPRB, 0.17416270E-06_JPRB, &
  & 0.17083396E-06_JPRB, 0.16792693E-06_JPRB, 0.16518447E-06_JPRB, 0.16250844E-06_JPRB, 0.16004082E-06_JPRB, 0.15790586E-06_JPRB, &
  & 0.15615012E-06_JPRB, 0.15477943E-06_JPRB, 0.15402845E-06_JPRB, 0.15310637E-06_JPRB  /)

RGHG2(:, 5,10) = (/ &
  & 0.17956979E-06_JPRB, 0.17940176E-06_JPRB, 0.17930056E-06_JPRB, 0.17920685E-06_JPRB, 0.17911357E-06_JPRB, 0.17900172E-06_JPRB, &
  & 0.17893370E-06_JPRB, 0.17891832E-06_JPRB, 0.17890768E-06_JPRB, 0.17898357E-06_JPRB, 0.17915666E-06_JPRB, 0.17937713E-06_JPRB, &
  & 0.17956512E-06_JPRB, 0.17974785E-06_JPRB, 0.17986229E-06_JPRB, 0.17996076E-06_JPRB, 0.18026522E-06_JPRB, 0.18096865E-06_JPRB, &
  & 0.18220015E-06_JPRB, 0.18395821E-06_JPRB, 0.18611980E-06_JPRB, 0.18862461E-06_JPRB, 0.19133043E-06_JPRB, 0.19410974E-06_JPRB, &
  & 0.19691982E-06_JPRB, 0.19973213E-06_JPRB, 0.20264789E-06_JPRB, 0.20592185E-06_JPRB, 0.20982932E-06_JPRB, 0.21468343E-06_JPRB, &
  & 0.22052806E-06_JPRB, 0.22684535E-06_JPRB, 0.23277797E-06_JPRB, 0.23753256E-06_JPRB, 0.24064765E-06_JPRB, 0.24208912E-06_JPRB, &
  & 0.24212829E-06_JPRB, 0.24102098E-06_JPRB, 0.23883852E-06_JPRB, 0.23578047E-06_JPRB, 0.23205032E-06_JPRB, 0.22786520E-06_JPRB, &
  & 0.22326769E-06_JPRB, 0.21819565E-06_JPRB, 0.21292281E-06_JPRB, 0.20765980E-06_JPRB, 0.20240696E-06_JPRB, 0.19746700E-06_JPRB, &
  & 0.19285272E-06_JPRB, 0.18860057E-06_JPRB, 0.18451228E-06_JPRB, 0.18044494E-06_JPRB, 0.17680598E-06_JPRB, 0.17361062E-06_JPRB, &
  & 0.17043090E-06_JPRB, 0.16752988E-06_JPRB, 0.16486974E-06_JPRB, 0.16222557E-06_JPRB, 0.15968043E-06_JPRB, 0.15739584E-06_JPRB, &
  & 0.15544060E-06_JPRB, 0.15386319E-06_JPRB, 0.15286284E-06_JPRB, 0.15177431E-06_JPRB  /)

RGHG2(:, 6,10) = (/ &
  & 0.18062575E-06_JPRB, 0.18048657E-06_JPRB, 0.18037456E-06_JPRB, 0.18025200E-06_JPRB, 0.18017404E-06_JPRB, 0.18004055E-06_JPRB, &
  & 0.17995000E-06_JPRB, 0.17987331E-06_JPRB, 0.17979866E-06_JPRB, 0.17978529E-06_JPRB, 0.17990068E-06_JPRB, 0.18005083E-06_JPRB, &
  & 0.18015948E-06_JPRB, 0.18024304E-06_JPRB, 0.18030068E-06_JPRB, 0.18027293E-06_JPRB, 0.18040068E-06_JPRB, 0.18088233E-06_JPRB, &
  & 0.18187942E-06_JPRB, 0.18350674E-06_JPRB, 0.18573144E-06_JPRB, 0.18844813E-06_JPRB, 0.19137574E-06_JPRB, 0.19436872E-06_JPRB, &
  & 0.19751509E-06_JPRB, 0.20077097E-06_JPRB, 0.20424120E-06_JPRB, 0.20818231E-06_JPRB, 0.21282186E-06_JPRB, 0.21858475E-06_JPRB, &
  & 0.22555275E-06_JPRB, 0.23279775E-06_JPRB, 0.23903240E-06_JPRB, 0.24364003E-06_JPRB, 0.24653334E-06_JPRB, 0.24762319E-06_JPRB, &
  & 0.24719985E-06_JPRB, 0.24555882E-06_JPRB, 0.24264158E-06_JPRB, 0.23870630E-06_JPRB, 0.23396278E-06_JPRB, 0.22856505E-06_JPRB, &
  & 0.22281172E-06_JPRB, 0.21688319E-06_JPRB, 0.21124250E-06_JPRB, 0.20581722E-06_JPRB, 0.20048233E-06_JPRB, 0.19558384E-06_JPRB, &
  & 0.19112193E-06_JPRB, 0.18698337E-06_JPRB, 0.18299065E-06_JPRB, 0.17922624E-06_JPRB, 0.17584964E-06_JPRB, 0.17278230E-06_JPRB, &
  & 0.16982617E-06_JPRB, 0.16693416E-06_JPRB, 0.16439755E-06_JPRB, 0.16180115E-06_JPRB, 0.15913971E-06_JPRB, 0.15663063E-06_JPRB, &
  & 0.15437606E-06_JPRB, 0.15248852E-06_JPRB, 0.15111402E-06_JPRB, 0.14977575E-06_JPRB  /)

RGHG2(:, 7,10) = (/ &
  & 0.18148264E-06_JPRB, 0.18132297E-06_JPRB, 0.18119601E-06_JPRB, 0.18109291E-06_JPRB, 0.18099044E-06_JPRB, 0.18082192E-06_JPRB, &
  & 0.18069209E-06_JPRB, 0.18061677E-06_JPRB, 0.18050093E-06_JPRB, 0.18046430E-06_JPRB, 0.18055793E-06_JPRB, 0.18068654E-06_JPRB, &
  & 0.18080527E-06_JPRB, 0.18088881E-06_JPRB, 0.18097934E-06_JPRB, 0.18093942E-06_JPRB, 0.18091804E-06_JPRB, 0.18112366E-06_JPRB, &
  & 0.18179352E-06_JPRB, 0.18311690E-06_JPRB, 0.18513991E-06_JPRB, 0.18779378E-06_JPRB, 0.19084414E-06_JPRB, 0.19420867E-06_JPRB, &
  & 0.19797893E-06_JPRB, 0.20200802E-06_JPRB, 0.20630667E-06_JPRB, 0.21128598E-06_JPRB, 0.21736197E-06_JPRB, 0.22543256E-06_JPRB, &
  & 0.23510459E-06_JPRB, 0.24403873E-06_JPRB, 0.25087275E-06_JPRB, 0.25573059E-06_JPRB, 0.25862869E-06_JPRB, 0.25945039E-06_JPRB, &
  & 0.25843316E-06_JPRB, 0.25571263E-06_JPRB, 0.25112402E-06_JPRB, 0.24515412E-06_JPRB, 0.23828727E-06_JPRB, 0.23086789E-06_JPRB, &
  & 0.22342724E-06_JPRB, 0.21621493E-06_JPRB, 0.20961865E-06_JPRB, 0.20372129E-06_JPRB, 0.19816464E-06_JPRB, 0.19307467E-06_JPRB, &
  & 0.18846107E-06_JPRB, 0.18426290E-06_JPRB, 0.18045174E-06_JPRB, 0.17695149E-06_JPRB, 0.17375087E-06_JPRB, 0.17079060E-06_JPRB, &
  & 0.16795749E-06_JPRB, 0.16505239E-06_JPRB, 0.16245555E-06_JPRB, 0.15978689E-06_JPRB, 0.15699231E-06_JPRB, 0.15419550E-06_JPRB, &
  & 0.15162997E-06_JPRB, 0.14943402E-06_JPRB, 0.14768625E-06_JPRB, 0.14620367E-06_JPRB  /)

RGHG2(:, 8,10) = (/ &
  & 0.18237256E-06_JPRB, 0.18214453E-06_JPRB, 0.18198575E-06_JPRB, 0.18199501E-06_JPRB, 0.18196571E-06_JPRB, 0.18192972E-06_JPRB, &
  & 0.18199390E-06_JPRB, 0.18212403E-06_JPRB, 0.18213924E-06_JPRB, 0.18218566E-06_JPRB, 0.18228316E-06_JPRB, 0.18237821E-06_JPRB, &
  & 0.18246827E-06_JPRB, 0.18259912E-06_JPRB, 0.18279912E-06_JPRB, 0.18293838E-06_JPRB, 0.18293212E-06_JPRB, 0.18296313E-06_JPRB, &
  & 0.18337668E-06_JPRB, 0.18438030E-06_JPRB, 0.18611164E-06_JPRB, 0.18861415E-06_JPRB, 0.19176942E-06_JPRB, 0.19581421E-06_JPRB, &
  & 0.20061820E-06_JPRB, 0.20573155E-06_JPRB, 0.21112603E-06_JPRB, 0.21761915E-06_JPRB, 0.22604316E-06_JPRB, 0.23761774E-06_JPRB, &
  & 0.25107398E-06_JPRB, 0.26257998E-06_JPRB, 0.27099216E-06_JPRB, 0.27711941E-06_JPRB, 0.28047100E-06_JPRB, 0.28053931E-06_JPRB, &
  & 0.27851738E-06_JPRB, 0.27453065E-06_JPRB, 0.26803616E-06_JPRB, 0.25975844E-06_JPRB, 0.25025242E-06_JPRB, 0.23999273E-06_JPRB, &
  & 0.22983466E-06_JPRB, 0.22029952E-06_JPRB, 0.21164930E-06_JPRB, 0.20437035E-06_JPRB, 0.19801704E-06_JPRB, 0.19238618E-06_JPRB, &
  & 0.18732023E-06_JPRB, 0.18273880E-06_JPRB, 0.17881267E-06_JPRB, 0.17530330E-06_JPRB, 0.17203672E-06_JPRB, 0.16893772E-06_JPRB, &
  & 0.16593143E-06_JPRB, 0.16287344E-06_JPRB, 0.16004081E-06_JPRB, 0.15710005E-06_JPRB, 0.15406021E-06_JPRB, 0.15097046E-06_JPRB, &
  & 0.14810459E-06_JPRB, 0.14555574E-06_JPRB, 0.14339496E-06_JPRB, 0.14176873E-06_JPRB  /)

RGHG2(:, 9,10) = (/ &
  & 0.18399458E-06_JPRB, 0.18375272E-06_JPRB, 0.18366618E-06_JPRB, 0.18400518E-06_JPRB, 0.18436499E-06_JPRB, 0.18492838E-06_JPRB, &
  & 0.18576237E-06_JPRB, 0.18663531E-06_JPRB, 0.18725166E-06_JPRB, 0.18770504E-06_JPRB, 0.18803114E-06_JPRB, 0.18808537E-06_JPRB, &
  & 0.18799638E-06_JPRB, 0.18812895E-06_JPRB, 0.18849610E-06_JPRB, 0.18895190E-06_JPRB, 0.18923124E-06_JPRB, 0.18935763E-06_JPRB, &
  & 0.18967132E-06_JPRB, 0.19044444E-06_JPRB, 0.19200276E-06_JPRB, 0.19454797E-06_JPRB, 0.19819889E-06_JPRB, 0.20379701E-06_JPRB, &
  & 0.21063496E-06_JPRB, 0.21746658E-06_JPRB, 0.22458511E-06_JPRB, 0.23341503E-06_JPRB, 0.24530019E-06_JPRB, 0.26106116E-06_JPRB, &
  & 0.27895627E-06_JPRB, 0.29413288E-06_JPRB, 0.30551001E-06_JPRB, 0.31399291E-06_JPRB, 0.31799534E-06_JPRB, 0.31690390E-06_JPRB, &
  & 0.31359400E-06_JPRB, 0.30845051E-06_JPRB, 0.30036972E-06_JPRB, 0.29001518E-06_JPRB, 0.27754965E-06_JPRB, 0.26363412E-06_JPRB, &
  & 0.24951997E-06_JPRB, 0.23609904E-06_JPRB, 0.22347478E-06_JPRB, 0.21270266E-06_JPRB, 0.20396107E-06_JPRB, 0.19699179E-06_JPRB, &
  & 0.19095729E-06_JPRB, 0.18557343E-06_JPRB, 0.18094769E-06_JPRB, 0.17679804E-06_JPRB, 0.17297376E-06_JPRB, 0.16935633E-06_JPRB, &
  & 0.16578710E-06_JPRB, 0.16230175E-06_JPRB, 0.15889719E-06_JPRB, 0.15545064E-06_JPRB, 0.15196219E-06_JPRB, 0.14851238E-06_JPRB, &
  & 0.14526741E-06_JPRB, 0.14219414E-06_JPRB, 0.13957876E-06_JPRB, 0.13779379E-06_JPRB  /)

RGHG2(:,10,10) = (/ &
  & 0.18860152E-06_JPRB, 0.18866333E-06_JPRB, 0.18895500E-06_JPRB, 0.18992068E-06_JPRB, 0.19122154E-06_JPRB, 0.19318142E-06_JPRB, &
  & 0.19574557E-06_JPRB, 0.19834981E-06_JPRB, 0.20051800E-06_JPRB, 0.20215951E-06_JPRB, 0.20326535E-06_JPRB, 0.20340346E-06_JPRB, &
  & 0.20310803E-06_JPRB, 0.20331893E-06_JPRB, 0.20387528E-06_JPRB, 0.20456215E-06_JPRB, 0.20515707E-06_JPRB, 0.20534755E-06_JPRB, &
  & 0.20563640E-06_JPRB, 0.20659867E-06_JPRB, 0.20846904E-06_JPRB, 0.21165160E-06_JPRB, 0.21656067E-06_JPRB, 0.22446762E-06_JPRB, &
  & 0.23476199E-06_JPRB, 0.24524382E-06_JPRB, 0.25627760E-06_JPRB, 0.26930208E-06_JPRB, 0.28595605E-06_JPRB, 0.30630540E-06_JPRB, &
  & 0.32861816E-06_JPRB, 0.34863451E-06_JPRB, 0.36387884E-06_JPRB, 0.37449499E-06_JPRB, 0.37882787E-06_JPRB, 0.37691359E-06_JPRB, &
  & 0.37213285E-06_JPRB, 0.36547922E-06_JPRB, 0.35598094E-06_JPRB, 0.34351321E-06_JPRB, 0.32737993E-06_JPRB, 0.30881275E-06_JPRB, &
  & 0.28978276E-06_JPRB, 0.27113004E-06_JPRB, 0.25241839E-06_JPRB, 0.23522486E-06_JPRB, 0.22131912E-06_JPRB, 0.21123280E-06_JPRB, &
  & 0.20329768E-06_JPRB, 0.19674760E-06_JPRB, 0.19091015E-06_JPRB, 0.18546660E-06_JPRB, 0.18038880E-06_JPRB, 0.17573477E-06_JPRB, &
  & 0.17128276E-06_JPRB, 0.16701001E-06_JPRB, 0.16260551E-06_JPRB, 0.15832723E-06_JPRB, 0.15411750E-06_JPRB, 0.15004924E-06_JPRB, &
  & 0.14613154E-06_JPRB, 0.14230179E-06_JPRB, 0.13906261E-06_JPRB, 0.13704239E-06_JPRB  /)

RGHG2(:,11,10) = (/ &
  & 0.19890904E-06_JPRB, 0.19967617E-06_JPRB, 0.20084447E-06_JPRB, 0.20290692E-06_JPRB, 0.20570603E-06_JPRB, 0.20976091E-06_JPRB, &
  & 0.21486813E-06_JPRB, 0.21992138E-06_JPRB, 0.22455140E-06_JPRB, 0.22829162E-06_JPRB, 0.23086477E-06_JPRB, 0.23193029E-06_JPRB, &
  & 0.23221400E-06_JPRB, 0.23325355E-06_JPRB, 0.23433495E-06_JPRB, 0.23522111E-06_JPRB, 0.23563927E-06_JPRB, 0.23517194E-06_JPRB, &
  & 0.23527571E-06_JPRB, 0.23699958E-06_JPRB, 0.23932622E-06_JPRB, 0.24317564E-06_JPRB, 0.24889130E-06_JPRB, 0.25726160E-06_JPRB, &
  & 0.27086113E-06_JPRB, 0.28831335E-06_JPRB, 0.30830700E-06_JPRB, 0.33020986E-06_JPRB, 0.35510839E-06_JPRB, 0.38321514E-06_JPRB, &
  & 0.41068734E-06_JPRB, 0.43549282E-06_JPRB, 0.45423398E-06_JPRB, 0.46506521E-06_JPRB, 0.46896447E-06_JPRB, 0.46631432E-06_JPRB, &
  & 0.45895811E-06_JPRB, 0.44876584E-06_JPRB, 0.43598573E-06_JPRB, 0.41890303E-06_JPRB, 0.39677398E-06_JPRB, 0.37204535E-06_JPRB, &
  & 0.34719038E-06_JPRB, 0.32299680E-06_JPRB, 0.29798771E-06_JPRB, 0.27349058E-06_JPRB, 0.25272671E-06_JPRB, 0.23735413E-06_JPRB, &
  & 0.22647512E-06_JPRB, 0.21840458E-06_JPRB, 0.21125748E-06_JPRB, 0.20443948E-06_JPRB, 0.19767988E-06_JPRB, 0.19133257E-06_JPRB, &
  & 0.18554035E-06_JPRB, 0.18004235E-06_JPRB, 0.17456950E-06_JPRB, 0.16885083E-06_JPRB, 0.16324490E-06_JPRB, 0.15790854E-06_JPRB, &
  & 0.15298500E-06_JPRB, 0.14843081E-06_JPRB, 0.14440635E-06_JPRB, 0.14190675E-06_JPRB  /)

RGHG2(:,12,10) = (/ &
  & 0.21496065E-06_JPRB, 0.21710995E-06_JPRB, 0.21985923E-06_JPRB, 0.22374295E-06_JPRB, 0.22876860E-06_JPRB, 0.23502039E-06_JPRB, &
  & 0.24241849E-06_JPRB, 0.24969109E-06_JPRB, 0.25677949E-06_JPRB, 0.26276224E-06_JPRB, 0.26745699E-06_JPRB, 0.27099146E-06_JPRB, &
  & 0.27324965E-06_JPRB, 0.27587608E-06_JPRB, 0.27847032E-06_JPRB, 0.28043487E-06_JPRB, 0.28054230E-06_JPRB, 0.27923275E-06_JPRB, &
  & 0.27885332E-06_JPRB, 0.28037204E-06_JPRB, 0.28228148E-06_JPRB, 0.28496899E-06_JPRB, 0.29006283E-06_JPRB, 0.29669097E-06_JPRB, &
  & 0.31054617E-06_JPRB, 0.33513904E-06_JPRB, 0.36917313E-06_JPRB, 0.40758310E-06_JPRB, 0.44780396E-06_JPRB, 0.48844962E-06_JPRB, &
  & 0.52451817E-06_JPRB, 0.55385334E-06_JPRB, 0.57488170E-06_JPRB, 0.58465145E-06_JPRB, 0.58562010E-06_JPRB, 0.57911844E-06_JPRB, &
  & 0.56690214E-06_JPRB, 0.55040134E-06_JPRB, 0.53015661E-06_JPRB, 0.50386397E-06_JPRB, 0.47226269E-06_JPRB, 0.43946176E-06_JPRB, &
  & 0.40707204E-06_JPRB, 0.37801951E-06_JPRB, 0.34873907E-06_JPRB, 0.31924738E-06_JPRB, 0.29362241E-06_JPRB, 0.27352019E-06_JPRB, &
  & 0.25999358E-06_JPRB, 0.25009854E-06_JPRB, 0.24135960E-06_JPRB, 0.23277100E-06_JPRB, 0.22460056E-06_JPRB, 0.21631145E-06_JPRB, &
  & 0.20846450E-06_JPRB, 0.20148063E-06_JPRB, 0.19494922E-06_JPRB, 0.18782216E-06_JPRB, 0.17982207E-06_JPRB, 0.17178368E-06_JPRB, &
  & 0.16474350E-06_JPRB, 0.15924289E-06_JPRB, 0.15452846E-06_JPRB, 0.15149141E-06_JPRB  /)

RGHG2(:,13,10) = (/ &
  & 0.23533647E-06_JPRB, 0.23950077E-06_JPRB, 0.24421309E-06_JPRB, 0.25048507E-06_JPRB, 0.25783182E-06_JPRB, 0.26650924E-06_JPRB, &
  & 0.27561236E-06_JPRB, 0.28512778E-06_JPRB, 0.29452575E-06_JPRB, 0.30273390E-06_JPRB, 0.30971783E-06_JPRB, 0.31592717E-06_JPRB, &
  & 0.32116496E-06_JPRB, 0.32622670E-06_JPRB, 0.33118737E-06_JPRB, 0.33523154E-06_JPRB, 0.33664773E-06_JPRB, 0.33496768E-06_JPRB, &
  & 0.33346685E-06_JPRB, 0.33331064E-06_JPRB, 0.33440476E-06_JPRB, 0.33478553E-06_JPRB, 0.33801118E-06_JPRB, 0.34429304E-06_JPRB, &
  & 0.35638365E-06_JPRB, 0.38547811E-06_JPRB, 0.43414084E-06_JPRB, 0.49309611E-06_JPRB, 0.55200376E-06_JPRB, 0.60586221E-06_JPRB, &
  & 0.65471415E-06_JPRB, 0.69268128E-06_JPRB, 0.71459101E-06_JPRB, 0.72205371E-06_JPRB, 0.71653035E-06_JPRB, 0.70109809E-06_JPRB, &
  & 0.68000054E-06_JPRB, 0.65431813E-06_JPRB, 0.62380171E-06_JPRB, 0.58734319E-06_JPRB, 0.54520458E-06_JPRB, 0.50176859E-06_JPRB, &
  & 0.46099671E-06_JPRB, 0.42838360E-06_JPRB, 0.39668191E-06_JPRB, 0.36504205E-06_JPRB, 0.33744066E-06_JPRB, 0.31525489E-06_JPRB, &
  & 0.30077517E-06_JPRB, 0.28964640E-06_JPRB, 0.27876081E-06_JPRB, 0.26739357E-06_JPRB, 0.25829747E-06_JPRB, 0.24886945E-06_JPRB, &
  & 0.23857353E-06_JPRB, 0.22959913E-06_JPRB, 0.22156381E-06_JPRB, 0.21350164E-06_JPRB, 0.20371749E-06_JPRB, 0.19236745E-06_JPRB, &
  & 0.18141031E-06_JPRB, 0.17344348E-06_JPRB, 0.16761688E-06_JPRB, 0.16390065E-06_JPRB  /)

RGHG2(:,14,10) = (/ &
  & 0.25760501E-06_JPRB, 0.26343199E-06_JPRB, 0.27028235E-06_JPRB, 0.27908164E-06_JPRB, 0.28857350E-06_JPRB, 0.30033340E-06_JPRB, &
  & 0.31154139E-06_JPRB, 0.32376867E-06_JPRB, 0.33595497E-06_JPRB, 0.34724690E-06_JPRB, 0.35667758E-06_JPRB, 0.36448014E-06_JPRB, &
  & 0.37264157E-06_JPRB, 0.38103548E-06_JPRB, 0.38854342E-06_JPRB, 0.39451993E-06_JPRB, 0.39834671E-06_JPRB, 0.39796441E-06_JPRB, &
  & 0.39570089E-06_JPRB, 0.39440724E-06_JPRB, 0.39500077E-06_JPRB, 0.39438417E-06_JPRB, 0.39418740E-06_JPRB, 0.40008021E-06_JPRB, &
  & 0.41169569E-06_JPRB, 0.44421069E-06_JPRB, 0.50329088E-06_JPRB, 0.57852624E-06_JPRB, 0.65408374E-06_JPRB, 0.72302721E-06_JPRB, &
  & 0.78552407E-06_JPRB, 0.83413356E-06_JPRB, 0.85603866E-06_JPRB, 0.85597812E-06_JPRB, 0.84135155E-06_JPRB, 0.81554866E-06_JPRB, &
  & 0.78280437E-06_JPRB, 0.74696487E-06_JPRB, 0.70755049E-06_JPRB, 0.66344214E-06_JPRB, 0.61258961E-06_JPRB, 0.55848272E-06_JPRB, &
  & 0.51047342E-06_JPRB, 0.47366802E-06_JPRB, 0.43874538E-06_JPRB, 0.40654059E-06_JPRB, 0.37780747E-06_JPRB, 0.35463040E-06_JPRB, &
  & 0.34043411E-06_JPRB, 0.32960422E-06_JPRB, 0.31660224E-06_JPRB, 0.30295626E-06_JPRB, 0.29367660E-06_JPRB, 0.28499580E-06_JPRB, &
  & 0.27424026E-06_JPRB, 0.26276553E-06_JPRB, 0.25218239E-06_JPRB, 0.24272414E-06_JPRB, 0.23178373E-06_JPRB, 0.21850691E-06_JPRB, &
  & 0.20383803E-06_JPRB, 0.19165401E-06_JPRB, 0.18356252E-06_JPRB, 0.17903196E-06_JPRB  /)

RGHG2(:,15,10) = (/ &
  & 0.27741456E-06_JPRB, 0.28509977E-06_JPRB, 0.29422230E-06_JPRB, 0.30587144E-06_JPRB, 0.31849247E-06_JPRB, 0.33273642E-06_JPRB, &
  & 0.34717747E-06_JPRB, 0.36377596E-06_JPRB, 0.37956817E-06_JPRB, 0.39435726E-06_JPRB, 0.40704826E-06_JPRB, 0.41576979E-06_JPRB, &
  & 0.42679283E-06_JPRB, 0.43852285E-06_JPRB, 0.44838136E-06_JPRB, 0.45653387E-06_JPRB, 0.46198029E-06_JPRB, 0.46279372E-06_JPRB, &
  & 0.46186083E-06_JPRB, 0.46194160E-06_JPRB, 0.46362305E-06_JPRB, 0.46353006E-06_JPRB, 0.46236477E-06_JPRB, 0.46951643E-06_JPRB, &
  & 0.48591392E-06_JPRB, 0.52318734E-06_JPRB, 0.58852038E-06_JPRB, 0.67067653E-06_JPRB, 0.75721741E-06_JPRB, 0.83721156E-06_JPRB, &
  & 0.90310104E-06_JPRB, 0.95482804E-06_JPRB, 0.97511632E-06_JPRB, 0.96668729E-06_JPRB, 0.94455137E-06_JPRB, 0.91125450E-06_JPRB, &
  & 0.86865864E-06_JPRB, 0.82602944E-06_JPRB, 0.78312606E-06_JPRB, 0.73458324E-06_JPRB, 0.67598295E-06_JPRB, 0.61160897E-06_JPRB, &
  & 0.55583224E-06_JPRB, 0.51338552E-06_JPRB, 0.47434469E-06_JPRB, 0.44121787E-06_JPRB, 0.41200459E-06_JPRB, 0.38757040E-06_JPRB, &
  & 0.37336092E-06_JPRB, 0.36382197E-06_JPRB, 0.34997524E-06_JPRB, 0.33561452E-06_JPRB, 0.32750954E-06_JPRB, 0.32053749E-06_JPRB, &
  & 0.31150158E-06_JPRB, 0.29937025E-06_JPRB, 0.28630591E-06_JPRB, 0.27405135E-06_JPRB, 0.26197539E-06_JPRB, 0.24772569E-06_JPRB, &
  & 0.23095316E-06_JPRB, 0.21506950E-06_JPRB, 0.20380041E-06_JPRB, 0.19868204E-06_JPRB  /)

RGHG2(:,16,10) = (/ &
  & 0.29029486E-06_JPRB, 0.29848542E-06_JPRB, 0.31147339E-06_JPRB, 0.32642751E-06_JPRB, 0.34357968E-06_JPRB, 0.36088111E-06_JPRB, &
  & 0.37970677E-06_JPRB, 0.40188710E-06_JPRB, 0.42180560E-06_JPRB, 0.43942832E-06_JPRB, 0.45564465E-06_JPRB, 0.46815199E-06_JPRB, &
  & 0.48272769E-06_JPRB, 0.49783658E-06_JPRB, 0.50937528E-06_JPRB, 0.51925027E-06_JPRB, 0.52623668E-06_JPRB, 0.52924866E-06_JPRB, &
  & 0.53074517E-06_JPRB, 0.53335347E-06_JPRB, 0.53879642E-06_JPRB, 0.54204527E-06_JPRB, 0.54375851E-06_JPRB, 0.55569699E-06_JPRB, &
  & 0.58179730E-06_JPRB, 0.63173678E-06_JPRB, 0.70636195E-06_JPRB, 0.78904214E-06_JPRB, 0.87073547E-06_JPRB, 0.94221078E-06_JPRB, &
  & 0.99881676E-06_JPRB, 0.10455567E-05_JPRB, 0.10610612E-05_JPRB, 0.10464367E-05_JPRB, 0.10187891E-05_JPRB, 0.98177608E-06_JPRB, &
  & 0.93619272E-06_JPRB, 0.89154159E-06_JPRB, 0.85035449E-06_JPRB, 0.80034035E-06_JPRB, 0.73562900E-06_JPRB, 0.66260152E-06_JPRB, &
  & 0.59692474E-06_JPRB, 0.54534302E-06_JPRB, 0.50311840E-06_JPRB, 0.46888794E-06_JPRB, 0.43915525E-06_JPRB, 0.41477430E-06_JPRB, &
  & 0.40065999E-06_JPRB, 0.39154803E-06_JPRB, 0.37854717E-06_JPRB, 0.36639901E-06_JPRB, 0.35983402E-06_JPRB, 0.35374039E-06_JPRB, &
  & 0.34610083E-06_JPRB, 0.33489984E-06_JPRB, 0.32119888E-06_JPRB, 0.30687020E-06_JPRB, 0.29285094E-06_JPRB, 0.27796571E-06_JPRB, &
  & 0.26008521E-06_JPRB, 0.24268632E-06_JPRB, 0.22906530E-06_JPRB, 0.22252447E-06_JPRB  /)

RGHG2(:,17,10) = (/ &
  & 0.29172143E-06_JPRB, 0.30028666E-06_JPRB, 0.31928795E-06_JPRB, 0.33909850E-06_JPRB, 0.36094730E-06_JPRB, 0.38388803E-06_JPRB, &
  & 0.40843861E-06_JPRB, 0.43599946E-06_JPRB, 0.46023846E-06_JPRB, 0.48129143E-06_JPRB, 0.50271530E-06_JPRB, 0.52249339E-06_JPRB, &
  & 0.54260855E-06_JPRB, 0.56028382E-06_JPRB, 0.57412947E-06_JPRB, 0.58587563E-06_JPRB, 0.59516464E-06_JPRB, 0.60090136E-06_JPRB, &
  & 0.60509044E-06_JPRB, 0.61015569E-06_JPRB, 0.61935230E-06_JPRB, 0.62784057E-06_JPRB, 0.63581566E-06_JPRB, 0.65407565E-06_JPRB, &
  & 0.69123289E-06_JPRB, 0.76483869E-06_JPRB, 0.85947389E-06_JPRB, 0.93920998E-06_JPRB, 0.10000001E-05_JPRB, 0.10458749E-05_JPRB, &
  & 0.10815507E-05_JPRB, 0.11137904E-05_JPRB, 0.11223502E-05_JPRB, 0.11051020E-05_JPRB, 0.10743376E-05_JPRB, 0.10349120E-05_JPRB, &
  & 0.99064220E-06_JPRB, 0.94822876E-06_JPRB, 0.90682519E-06_JPRB, 0.85459574E-06_JPRB, 0.78799375E-06_JPRB, 0.70996392E-06_JPRB, &
  & 0.63440220E-06_JPRB, 0.57182627E-06_JPRB, 0.52591472E-06_JPRB, 0.49048314E-06_JPRB, 0.46090384E-06_JPRB, 0.43832399E-06_JPRB, &
  & 0.42527347E-06_JPRB, 0.41535259E-06_JPRB, 0.40392746E-06_JPRB, 0.39614081E-06_JPRB, 0.39138037E-06_JPRB, 0.38555723E-06_JPRB, &
  & 0.37820961E-06_JPRB, 0.36737254E-06_JPRB, 0.35411165E-06_JPRB, 0.33950939E-06_JPRB, 0.32362325E-06_JPRB, 0.30773930E-06_JPRB, &
  & 0.29021626E-06_JPRB, 0.27302674E-06_JPRB, 0.25873866E-06_JPRB, 0.25151895E-06_JPRB  /)

RGHG2(:,18,10) = (/ &
  & 0.28267857E-06_JPRB, 0.29383526E-06_JPRB, 0.31858043E-06_JPRB, 0.34550217E-06_JPRB, 0.37374869E-06_JPRB, 0.40368447E-06_JPRB, &
  & 0.43475508E-06_JPRB, 0.46781145E-06_JPRB, 0.49692506E-06_JPRB, 0.52451058E-06_JPRB, 0.55270190E-06_JPRB, 0.58020058E-06_JPRB, &
  & 0.60585571E-06_JPRB, 0.62819438E-06_JPRB, 0.64486174E-06_JPRB, 0.65916415E-06_JPRB, 0.67121332E-06_JPRB, 0.67877470E-06_JPRB, &
  & 0.68472053E-06_JPRB, 0.69202208E-06_JPRB, 0.70306298E-06_JPRB, 0.71561390E-06_JPRB, 0.73159133E-06_JPRB, 0.75788199E-06_JPRB, &
  & 0.80770491E-06_JPRB, 0.90516506E-06_JPRB, 0.10211034E-05_JPRB, 0.10966822E-05_JPRB, 0.11331809E-05_JPRB, 0.11517248E-05_JPRB, &
  & 0.11630258E-05_JPRB, 0.11736682E-05_JPRB, 0.11716498E-05_JPRB, 0.11541080E-05_JPRB, 0.11245345E-05_JPRB, 0.10844050E-05_JPRB, &
  & 0.10410580E-05_JPRB, 0.99944014E-06_JPRB, 0.95576700E-06_JPRB, 0.89895949E-06_JPRB, 0.82881994E-06_JPRB, 0.74761325E-06_JPRB, &
  & 0.66611091E-06_JPRB, 0.59638939E-06_JPRB, 0.54586246E-06_JPRB, 0.50939638E-06_JPRB, 0.48078775E-06_JPRB, 0.45982680E-06_JPRB, &
  & 0.44772079E-06_JPRB, 0.43789079E-06_JPRB, 0.42958351E-06_JPRB, 0.42546438E-06_JPRB, 0.42226755E-06_JPRB, 0.41676019E-06_JPRB, &
  & 0.40931486E-06_JPRB, 0.39816714E-06_JPRB, 0.38468410E-06_JPRB, 0.36975826E-06_JPRB, 0.35302336E-06_JPRB, 0.33612713E-06_JPRB, &
  & 0.31895160E-06_JPRB, 0.30311789E-06_JPRB, 0.28968632E-06_JPRB, 0.28368287E-06_JPRB  /)

RGHG2(:,19,10) = (/ &
  & 0.27182522E-06_JPRB, 0.28566139E-06_JPRB, 0.31482593E-06_JPRB, 0.34944350E-06_JPRB, 0.38578577E-06_JPRB, 0.42379740E-06_JPRB, &
  & 0.46193817E-06_JPRB, 0.50036001E-06_JPRB, 0.53568619E-06_JPRB, 0.57074174E-06_JPRB, 0.60604124E-06_JPRB, 0.64029752E-06_JPRB, &
  & 0.67207472E-06_JPRB, 0.69990808E-06_JPRB, 0.72130506E-06_JPRB, 0.73828867E-06_JPRB, 0.75284599E-06_JPRB, 0.76173133E-06_JPRB, &
  & 0.76881917E-06_JPRB, 0.77752347E-06_JPRB, 0.78961249E-06_JPRB, 0.80488430E-06_JPRB, 0.82650222E-06_JPRB, 0.86117535E-06_JPRB, &
  & 0.92651510E-06_JPRB, 0.10393760E-05_JPRB, 0.11619137E-05_JPRB, 0.12299462E-05_JPRB, 0.12500615E-05_JPRB, 0.12494892E-05_JPRB, &
  & 0.12402105E-05_JPRB, 0.12305961E-05_JPRB, 0.12179174E-05_JPRB, 0.12004250E-05_JPRB, 0.11748468E-05_JPRB, 0.11373641E-05_JPRB, &
  & 0.10928063E-05_JPRB, 0.10468158E-05_JPRB, 0.99909249E-06_JPRB, 0.93642947E-06_JPRB, 0.85892595E-06_JPRB, 0.77660713E-06_JPRB, &
  & 0.69408359E-06_JPRB, 0.62037930E-06_JPRB, 0.56683375E-06_JPRB, 0.53123569E-06_JPRB, 0.50368445E-06_JPRB, 0.48215975E-06_JPRB, &
  & 0.46967231E-06_JPRB, 0.46187429E-06_JPRB, 0.45779872E-06_JPRB, 0.45645052E-06_JPRB, 0.45410924E-06_JPRB, 0.44846959E-06_JPRB, &
  & 0.44084129E-06_JPRB, 0.42975903E-06_JPRB, 0.41565169E-06_JPRB, 0.39966806E-06_JPRB, 0.38249528E-06_JPRB, 0.36510189E-06_JPRB, &
  & 0.34743223E-06_JPRB, 0.33220153E-06_JPRB, 0.32006826E-06_JPRB, 0.31431658E-06_JPRB  /)

RGHG2(:,20,10) = (/ &
  & 0.26613568E-06_JPRB, 0.28173209E-06_JPRB, 0.31351421E-06_JPRB, 0.35493912E-06_JPRB, 0.39921867E-06_JPRB, 0.44616644E-06_JPRB, &
  & 0.49250603E-06_JPRB, 0.53635956E-06_JPRB, 0.57778940E-06_JPRB, 0.61979614E-06_JPRB, 0.66231149E-06_JPRB, 0.70295252E-06_JPRB, &
  & 0.74082948E-06_JPRB, 0.77409577E-06_JPRB, 0.80116985E-06_JPRB, 0.82148977E-06_JPRB, 0.83804356E-06_JPRB, 0.84821312E-06_JPRB, &
  & 0.85618346E-06_JPRB, 0.86544696E-06_JPRB, 0.87829052E-06_JPRB, 0.89545061E-06_JPRB, 0.91832625E-06_JPRB, 0.95883745E-06_JPRB, &
  & 0.10386177E-05_JPRB, 0.11577004E-05_JPRB, 0.12741108E-05_JPRB, 0.13322460E-05_JPRB, 0.13449232E-05_JPRB, 0.13343181E-05_JPRB, &
  & 0.13107697E-05_JPRB, 0.12864780E-05_JPRB, 0.12656546E-05_JPRB, 0.12476199E-05_JPRB, 0.12256250E-05_JPRB, 0.11916209E-05_JPRB, &
  & 0.11450012E-05_JPRB, 0.10919153E-05_JPRB, 0.10382654E-05_JPRB, 0.96902227E-06_JPRB, 0.88379192E-06_JPRB, 0.80093157E-06_JPRB, &
  & 0.71988573E-06_JPRB, 0.64595582E-06_JPRB, 0.59324272E-06_JPRB, 0.55853034E-06_JPRB, 0.53068002E-06_JPRB, 0.50812180E-06_JPRB, &
  & 0.49518988E-06_JPRB, 0.48999193E-06_JPRB, 0.48900685E-06_JPRB, 0.48922232E-06_JPRB, 0.48754921E-06_JPRB, 0.48205014E-06_JPRB, &
  & 0.47379449E-06_JPRB, 0.46279992E-06_JPRB, 0.44828766E-06_JPRB, 0.43151858E-06_JPRB, 0.41379500E-06_JPRB, 0.39604016E-06_JPRB, &
  & 0.37768785E-06_JPRB, 0.36186663E-06_JPRB, 0.34994153E-06_JPRB, 0.34308881E-06_JPRB  /)

RGHG2(:,21,10) = (/ &
  & 0.26984294E-06_JPRB, 0.28606855E-06_JPRB, 0.31854398E-06_JPRB, 0.36480079E-06_JPRB, 0.41597012E-06_JPRB, 0.47190358E-06_JPRB, &
  & 0.52736754E-06_JPRB, 0.57709479E-06_JPRB, 0.62395647E-06_JPRB, 0.67211711E-06_JPRB, 0.72143159E-06_JPRB, 0.76833828E-06_JPRB, &
  & 0.81179814E-06_JPRB, 0.85024967E-06_JPRB, 0.88275431E-06_JPRB, 0.90682016E-06_JPRB, 0.92503514E-06_JPRB, 0.93660353E-06_JPRB, &
  & 0.94549336E-06_JPRB, 0.95488836E-06_JPRB, 0.96829195E-06_JPRB, 0.98621110E-06_JPRB, 0.10063453E-05_JPRB, 0.10488483E-05_JPRB, &
  & 0.11385523E-05_JPRB, 0.12558913E-05_JPRB, 0.13590295E-05_JPRB, 0.14081353E-05_JPRB, 0.14202902E-05_JPRB, 0.14074293E-05_JPRB, &
  & 0.13766181E-05_JPRB, 0.13438182E-05_JPRB, 0.13174385E-05_JPRB, 0.12976130E-05_JPRB, 0.12767119E-05_JPRB, 0.12447521E-05_JPRB, &
  & 0.11957232E-05_JPRB, 0.11347966E-05_JPRB, 0.10740727E-05_JPRB, 0.99821151E-06_JPRB, 0.90624704E-06_JPRB, 0.82289222E-06_JPRB, &
  & 0.74416885E-06_JPRB, 0.67435259E-06_JPRB, 0.62637081E-06_JPRB, 0.59203200E-06_JPRB, 0.56239767E-06_JPRB, 0.53942226E-06_JPRB, &
  & 0.52667863E-06_JPRB, 0.52332033E-06_JPRB, 0.52352366E-06_JPRB, 0.52395374E-06_JPRB, 0.52271367E-06_JPRB, 0.51783116E-06_JPRB, &
  & 0.50888508E-06_JPRB, 0.49783989E-06_JPRB, 0.48342463E-06_JPRB, 0.46636304E-06_JPRB, 0.44791741E-06_JPRB, 0.42959119E-06_JPRB, &
  & 0.41087139E-06_JPRB, 0.39388455E-06_JPRB, 0.38088763E-06_JPRB, 0.37206535E-06_JPRB  /)

RGHG2(:,22,10) = (/ &
  & 0.28745853E-06_JPRB, 0.30309161E-06_JPRB, 0.33407614E-06_JPRB, 0.38184296E-06_JPRB, 0.43834513E-06_JPRB, 0.50198157E-06_JPRB, &
  & 0.56675410E-06_JPRB, 0.62322864E-06_JPRB, 0.67477328E-06_JPRB, 0.72834321E-06_JPRB, 0.78304787E-06_JPRB, 0.83589905E-06_JPRB, &
  & 0.88392718E-06_JPRB, 0.92732926E-06_JPRB, 0.96371407E-06_JPRB, 0.99112489E-06_JPRB, 0.10109837E-05_JPRB, 0.10240621E-05_JPRB, &
  & 0.10341943E-05_JPRB, 0.10438569E-05_JPRB, 0.10575472E-05_JPRB, 0.10741093E-05_JPRB, 0.10885283E-05_JPRB, 0.11282216E-05_JPRB, &
  & 0.12195885E-05_JPRB, 0.13277909E-05_JPRB, 0.14160202E-05_JPRB, 0.14615898E-05_JPRB, 0.14781601E-05_JPRB, 0.14701351E-05_JPRB, &
  & 0.14403370E-05_JPRB, 0.14052243E-05_JPRB, 0.13751173E-05_JPRB, 0.13514499E-05_JPRB, 0.13273185E-05_JPRB, 0.12938295E-05_JPRB, &
  & 0.12418761E-05_JPRB, 0.11736862E-05_JPRB, 0.11059666E-05_JPRB, 0.10244285E-05_JPRB, 0.92674886E-06_JPRB, 0.84312645E-06_JPRB, &
  & 0.76660120E-06_JPRB, 0.70624642E-06_JPRB, 0.66623523E-06_JPRB, 0.63222136E-06_JPRB, 0.59979637E-06_JPRB, 0.57758552E-06_JPRB, &
  & 0.56595051E-06_JPRB, 0.56234373E-06_JPRB, 0.56172516E-06_JPRB, 0.56079813E-06_JPRB, 0.55925224E-06_JPRB, 0.55532543E-06_JPRB, &
  & 0.54651315E-06_JPRB, 0.53533416E-06_JPRB, 0.52168347E-06_JPRB, 0.50454541E-06_JPRB, 0.48537345E-06_JPRB, 0.46597685E-06_JPRB, &
  & 0.44758198E-06_JPRB, 0.42990703E-06_JPRB, 0.41497959E-06_JPRB, 0.40397830E-06_JPRB  /)

RGHG2(:,23,10) = (/ &
  & 0.32807290E-06_JPRB, 0.33965555E-06_JPRB, 0.36709665E-06_JPRB, 0.41253997E-06_JPRB, 0.47009899E-06_JPRB, 0.53802422E-06_JPRB, &
  & 0.60989684E-06_JPRB, 0.67309173E-06_JPRB, 0.72899550E-06_JPRB, 0.78659585E-06_JPRB, 0.84507029E-06_JPRB, 0.90146480E-06_JPRB, &
  & 0.95355025E-06_JPRB, 0.10001860E-05_JPRB, 0.10386348E-05_JPRB, 0.10676692E-05_JPRB, 0.10883518E-05_JPRB, 0.11023453E-05_JPRB, &
  & 0.11136363E-05_JPRB, 0.11237547E-05_JPRB, 0.11370060E-05_JPRB, 0.11512409E-05_JPRB, 0.11609717E-05_JPRB, 0.11921834E-05_JPRB, &
  & 0.12750556E-05_JPRB, 0.13738510E-05_JPRB, 0.14519925E-05_JPRB, 0.14969358E-05_JPRB, 0.15184281E-05_JPRB, 0.15182765E-05_JPRB, &
  & 0.14967728E-05_JPRB, 0.14649575E-05_JPRB, 0.14330014E-05_JPRB, 0.14038836E-05_JPRB, 0.13728198E-05_JPRB, 0.13326814E-05_JPRB, &
  & 0.12771903E-05_JPRB, 0.12055974E-05_JPRB, 0.11320873E-05_JPRB, 0.10444664E-05_JPRB, 0.94413597E-06_JPRB, 0.86344837E-06_JPRB, &
  & 0.79597436E-06_JPRB, 0.74542815E-06_JPRB, 0.71072421E-06_JPRB, 0.67887563E-06_JPRB, 0.64656203E-06_JPRB, 0.62525836E-06_JPRB, &
  & 0.61348975E-06_JPRB, 0.60790875E-06_JPRB, 0.60550985E-06_JPRB, 0.60240771E-06_JPRB, 0.59895717E-06_JPRB, 0.59484912E-06_JPRB, &
  & 0.58696420E-06_JPRB, 0.57657600E-06_JPRB, 0.56407578E-06_JPRB, 0.54737005E-06_JPRB, 0.52702151E-06_JPRB, 0.50669848E-06_JPRB, &
  & 0.48865953E-06_JPRB, 0.47204743E-06_JPRB, 0.45743470E-06_JPRB, 0.44523005E-06_JPRB  /)

RGHG2(:,24,10) = (/ &
  & 0.38288118E-06_JPRB, 0.38992749E-06_JPRB, 0.41250656E-06_JPRB, 0.45398866E-06_JPRB, 0.50993627E-06_JPRB, 0.57961341E-06_JPRB, &
  & 0.65661134E-06_JPRB, 0.72587897E-06_JPRB, 0.78594083E-06_JPRB, 0.84709617E-06_JPRB, 0.90861604E-06_JPRB, 0.96780884E-06_JPRB, &
  & 0.10234434E-05_JPRB, 0.10721397E-05_JPRB, 0.11118273E-05_JPRB, 0.11416383E-05_JPRB, 0.11624029E-05_JPRB, 0.11767166E-05_JPRB, &
  & 0.11887298E-05_JPRB, 0.11994744E-05_JPRB, 0.12123449E-05_JPRB, 0.12239912E-05_JPRB, 0.12301375E-05_JPRB, 0.12529859E-05_JPRB, &
  & 0.13254377E-05_JPRB, 0.14143972E-05_JPRB, 0.14838311E-05_JPRB, 0.15270890E-05_JPRB, 0.15518925E-05_JPRB, 0.15588869E-05_JPRB, &
  & 0.15465465E-05_JPRB, 0.15199285E-05_JPRB, 0.14878510E-05_JPRB, 0.14544362E-05_JPRB, 0.14167891E-05_JPRB, 0.13698376E-05_JPRB, &
  & 0.13114219E-05_JPRB, 0.12383395E-05_JPRB, 0.11597369E-05_JPRB, 0.10667480E-05_JPRB, 0.96702381E-06_JPRB, 0.89153819E-06_JPRB, &
  & 0.83475754E-06_JPRB, 0.79293252E-06_JPRB, 0.76196161E-06_JPRB, 0.73244285E-06_JPRB, 0.70096889E-06_JPRB, 0.68033763E-06_JPRB, &
  & 0.66762648E-06_JPRB, 0.65923242E-06_JPRB, 0.65432244E-06_JPRB, 0.64899806E-06_JPRB, 0.64336545E-06_JPRB, 0.63847647E-06_JPRB, &
  & 0.63139008E-06_JPRB, 0.62217917E-06_JPRB, 0.61058289E-06_JPRB, 0.59443730E-06_JPRB, 0.57343539E-06_JPRB, 0.55246294E-06_JPRB, &
  & 0.53484166E-06_JPRB, 0.51950946E-06_JPRB, 0.50576685E-06_JPRB, 0.49321069E-06_JPRB  /)

RGHG2(:,25,10) = (/ &
  & 0.45519935E-06_JPRB, 0.45783028E-06_JPRB, 0.47389141E-06_JPRB, 0.50955104E-06_JPRB, 0.56019373E-06_JPRB, 0.62781682E-06_JPRB, &
  & 0.70670706E-06_JPRB, 0.78063267E-06_JPRB, 0.84438210E-06_JPRB, 0.90840016E-06_JPRB, 0.97190938E-06_JPRB, 0.10329945E-05_JPRB, &
  & 0.10912330E-05_JPRB, 0.11402042E-05_JPRB, 0.11800212E-05_JPRB, 0.12094602E-05_JPRB, 0.12291736E-05_JPRB, 0.12428727E-05_JPRB, &
  & 0.12548212E-05_JPRB, 0.12664230E-05_JPRB, 0.12791964E-05_JPRB, 0.12881255E-05_JPRB, 0.12925736E-05_JPRB, 0.13089203E-05_JPRB, &
  & 0.13702932E-05_JPRB, 0.14491604E-05_JPRB, 0.15116397E-05_JPRB, 0.15507571E-05_JPRB, 0.15757547E-05_JPRB, 0.15876012E-05_JPRB, &
  & 0.15839136E-05_JPRB, 0.15643635E-05_JPRB, 0.15348091E-05_JPRB, 0.14996961E-05_JPRB, 0.14572131E-05_JPRB, 0.14046169E-05_JPRB, &
  & 0.13446324E-05_JPRB, 0.12726498E-05_JPRB, 0.11901494E-05_JPRB, 0.10933921E-05_JPRB, 0.99932863E-06_JPRB, 0.93210769E-06_JPRB, &
  & 0.88690730E-06_JPRB, 0.85140614E-06_JPRB, 0.82180998E-06_JPRB, 0.79439378E-06_JPRB, 0.76435926E-06_JPRB, 0.74392209E-06_JPRB, &
  & 0.72915690E-06_JPRB, 0.71697823E-06_JPRB, 0.70859093E-06_JPRB, 0.70124486E-06_JPRB, 0.69339648E-06_JPRB, 0.68695484E-06_JPRB, &
  & 0.68022426E-06_JPRB, 0.67261454E-06_JPRB, 0.66135790E-06_JPRB, 0.64585925E-06_JPRB, 0.62526168E-06_JPRB, 0.60412749E-06_JPRB, &
  & 0.58700760E-06_JPRB, 0.57288841E-06_JPRB, 0.56045585E-06_JPRB, 0.54885394E-06_JPRB  /)

RGHG2(:,26,10) = (/ &
  & 0.54186886E-06_JPRB, 0.54182019E-06_JPRB, 0.55185966E-06_JPRB, 0.58078468E-06_JPRB, 0.62357098E-06_JPRB, 0.68482806E-06_JPRB, &
  & 0.76052709E-06_JPRB, 0.83578936E-06_JPRB, 0.90188935E-06_JPRB, 0.96709372E-06_JPRB, 0.10309959E-05_JPRB, 0.10924805E-05_JPRB, &
  & 0.11508041E-05_JPRB, 0.11989096E-05_JPRB, 0.12378441E-05_JPRB, 0.12658326E-05_JPRB, 0.12838323E-05_JPRB, 0.12966247E-05_JPRB, &
  & 0.13084497E-05_JPRB, 0.13202439E-05_JPRB, 0.13316175E-05_JPRB, 0.13386312E-05_JPRB, 0.13419741E-05_JPRB, 0.13556490E-05_JPRB, &
  & 0.14090604E-05_JPRB, 0.14781359E-05_JPRB, 0.15344047E-05_JPRB, 0.15692203E-05_JPRB, 0.15927663E-05_JPRB, 0.16064265E-05_JPRB, &
  & 0.16082434E-05_JPRB, 0.15953596E-05_JPRB, 0.15707597E-05_JPRB, 0.15377060E-05_JPRB, 0.14950545E-05_JPRB, 0.14415986E-05_JPRB, &
  & 0.13814910E-05_JPRB, 0.13119060E-05_JPRB, 0.12305055E-05_JPRB, 0.11377801E-05_JPRB, 0.10535734E-05_JPRB, 0.99374776E-06_JPRB, &
  & 0.95426413E-06_JPRB, 0.92208073E-06_JPRB, 0.89216256E-06_JPRB, 0.86390102E-06_JPRB, 0.83481871E-06_JPRB, 0.81408074E-06_JPRB, &
  & 0.79646567E-06_JPRB, 0.78122912E-06_JPRB, 0.76889480E-06_JPRB, 0.75859012E-06_JPRB, 0.74942646E-06_JPRB, 0.74154480E-06_JPRB, &
  & 0.73398040E-06_JPRB, 0.72682182E-06_JPRB, 0.71603768E-06_JPRB, 0.70113460E-06_JPRB, 0.68158052E-06_JPRB, 0.66139491E-06_JPRB, &
  & 0.64507754E-06_JPRB, 0.63131854E-06_JPRB, 0.62034772E-06_JPRB, 0.61023161E-06_JPRB  /)

RGHG2(:,27,10) = (/ &
  & 0.63780506E-06_JPRB, 0.63559840E-06_JPRB, 0.63952612E-06_JPRB, 0.66107176E-06_JPRB, 0.69469797E-06_JPRB, 0.74770040E-06_JPRB, &
  & 0.81817803E-06_JPRB, 0.89360630E-06_JPRB, 0.96166808E-06_JPRB, 0.10274912E-05_JPRB, 0.10912123E-05_JPRB, 0.11525610E-05_JPRB, &
  & 0.12100395E-05_JPRB, 0.12568171E-05_JPRB, 0.12944538E-05_JPRB, 0.13205257E-05_JPRB, 0.13364882E-05_JPRB, 0.13482242E-05_JPRB, &
  & 0.13598983E-05_JPRB, 0.13716473E-05_JPRB, 0.13810741E-05_JPRB, 0.13863826E-05_JPRB, 0.13887899E-05_JPRB, 0.14010915E-05_JPRB, &
  & 0.14473348E-05_JPRB, 0.15062844E-05_JPRB, 0.15563358E-05_JPRB, 0.15865940E-05_JPRB, 0.16080122E-05_JPRB, 0.16224421E-05_JPRB, &
  & 0.16288465E-05_JPRB, 0.16227838E-05_JPRB, 0.16042654E-05_JPRB, 0.15747581E-05_JPRB, 0.15336609E-05_JPRB, 0.14810802E-05_JPRB, &
  & 0.14213801E-05_JPRB, 0.13547831E-05_JPRB, 0.12763856E-05_JPRB, 0.11907680E-05_JPRB, 0.11184226E-05_JPRB, 0.10660066E-05_JPRB, &
  & 0.10303258E-05_JPRB, 0.10004966E-05_JPRB, 0.96961258E-06_JPRB, 0.93937414E-06_JPRB, 0.91110674E-06_JPRB, 0.88987077E-06_JPRB, &
  & 0.86898101E-06_JPRB, 0.85081685E-06_JPRB, 0.83418167E-06_JPRB, 0.82043629E-06_JPRB, 0.81023137E-06_JPRB, 0.80088590E-06_JPRB, &
  & 0.79200860E-06_JPRB, 0.78489530E-06_JPRB, 0.77465443E-06_JPRB, 0.76035498E-06_JPRB, 0.74212889E-06_JPRB, 0.72334671E-06_JPRB, &
  & 0.70798006E-06_JPRB, 0.69428142E-06_JPRB, 0.68489514E-06_JPRB, 0.67652955E-06_JPRB  /)

RGHG2(:,28,10) = (/ &
  & 0.74331868E-06_JPRB, 0.73991927E-06_JPRB, 0.73926266E-06_JPRB, 0.75335739E-06_JPRB, 0.77879918E-06_JPRB, 0.82134932E-06_JPRB, &
  & 0.88116839E-06_JPRB, 0.95070678E-06_JPRB, 0.10173559E-05_JPRB, 0.10811315E-05_JPRB, 0.11427422E-05_JPRB, 0.12013941E-05_JPRB, &
  & 0.12547833E-05_JPRB, 0.12988922E-05_JPRB, 0.13342057E-05_JPRB, 0.13580928E-05_JPRB, 0.13727671E-05_JPRB, 0.13839108E-05_JPRB, &
  & 0.13950782E-05_JPRB, 0.14053794E-05_JPRB, 0.14130585E-05_JPRB, 0.14182874E-05_JPRB, 0.14216094E-05_JPRB, 0.14343703E-05_JPRB, &
  & 0.14738219E-05_JPRB, 0.15242988E-05_JPRB, 0.15688040E-05_JPRB, 0.15972807E-05_JPRB, 0.16177514E-05_JPRB, 0.16324807E-05_JPRB, &
  & 0.16410309E-05_JPRB, 0.16396993E-05_JPRB, 0.16271975E-05_JPRB, 0.16034881E-05_JPRB, 0.15677350E-05_JPRB, 0.15197331E-05_JPRB, &
  & 0.14637046E-05_JPRB, 0.14026707E-05_JPRB, 0.13340309E-05_JPRB, 0.12621880E-05_JPRB, 0.12019954E-05_JPRB, 0.11542960E-05_JPRB, &
  & 0.11186583E-05_JPRB, 0.10870689E-05_JPRB, 0.10528983E-05_JPRB, 0.10211111E-05_JPRB, 0.99281316E-06_JPRB, 0.96954833E-06_JPRB, &
  & 0.94642040E-06_JPRB, 0.92513036E-06_JPRB, 0.90491470E-06_JPRB, 0.88846769E-06_JPRB, 0.87640033E-06_JPRB, 0.86556390E-06_JPRB, &
  & 0.85504509E-06_JPRB, 0.84706976E-06_JPRB, 0.83668750E-06_JPRB, 0.82323803E-06_JPRB, 0.80610321E-06_JPRB, 0.78845909E-06_JPRB, &
  & 0.77413133E-06_JPRB, 0.76130513E-06_JPRB, 0.75262586E-06_JPRB, 0.74566235E-06_JPRB  /)

RGHG2(:,29,10) = (/ &
  & 0.85553438E-06_JPRB, 0.85091299E-06_JPRB, 0.84546514E-06_JPRB, 0.85166190E-06_JPRB, 0.86847393E-06_JPRB, 0.89985370E-06_JPRB, &
  & 0.94814340E-06_JPRB, 0.10111784E-05_JPRB, 0.10761844E-05_JPRB, 0.11376748E-05_JPRB, 0.11969659E-05_JPRB, 0.12526492E-05_JPRB, &
  & 0.13015647E-05_JPRB, 0.13427877E-05_JPRB, 0.13755952E-05_JPRB, 0.13971557E-05_JPRB, 0.14104976E-05_JPRB, 0.14210337E-05_JPRB, &
  & 0.14316488E-05_JPRB, 0.14403553E-05_JPRB, 0.14461910E-05_JPRB, 0.14514062E-05_JPRB, 0.14557775E-05_JPRB, 0.14691045E-05_JPRB, &
  & 0.15013762E-05_JPRB, 0.15429471E-05_JPRB, 0.15816048E-05_JPRB, 0.16083141E-05_JPRB, 0.16278321E-05_JPRB, 0.16428582E-05_JPRB, &
  & 0.16535762E-05_JPRB, 0.16571671E-05_JPRB, 0.16510375E-05_JPRB, 0.16335692E-05_JPRB, 0.16036429E-05_JPRB, 0.15606532E-05_JPRB, &
  & 0.15086564E-05_JPRB, 0.14536289E-05_JPRB, 0.13956209E-05_JPRB, 0.13386627E-05_JPRB, 0.12913595E-05_JPRB, 0.12485411E-05_JPRB, &
  & 0.12127861E-05_JPRB, 0.11791530E-05_JPRB, 0.11413994E-05_JPRB, 0.11079898E-05_JPRB, 0.10796228E-05_JPRB, 0.10541419E-05_JPRB, &
  & 0.10286874E-05_JPRB, 0.10040766E-05_JPRB, 0.98009834E-06_JPRB, 0.96082077E-06_JPRB, 0.94674440E-06_JPRB, 0.93432700E-06_JPRB, &
  & 0.92205462E-06_JPRB, 0.91312657E-06_JPRB, 0.90256481E-06_JPRB, 0.89002664E-06_JPRB, 0.87403786E-06_JPRB, 0.85758810E-06_JPRB, &
  & 0.84436494E-06_JPRB, 0.83249837E-06_JPRB, 0.82453020E-06_JPRB, 0.81903720E-06_JPRB  /)

RGHG2(:,30,10) = (/ &
  & 0.96740929E-06_JPRB, 0.96012432E-06_JPRB, 0.95091192E-06_JPRB, 0.95123078E-06_JPRB, 0.96177608E-06_JPRB, 0.98344804E-06_JPRB, &
  & 0.10198826E-05_JPRB, 0.10716857E-05_JPRB, 0.11302736E-05_JPRB, 0.11873952E-05_JPRB, 0.12420385E-05_JPRB, 0.12930977E-05_JPRB, &
  & 0.13375211E-05_JPRB, 0.13748419E-05_JPRB, 0.14045418E-05_JPRB, 0.14237774E-05_JPRB, 0.14361113E-05_JPRB, 0.14461921E-05_JPRB, &
  & 0.14562123E-05_JPRB, 0.14648264E-05_JPRB, 0.14714428E-05_JPRB, 0.14784349E-05_JPRB, 0.14857426E-05_JPRB, 0.14995189E-05_JPRB, &
  & 0.15264107E-05_JPRB, 0.15606593E-05_JPRB, 0.15939504E-05_JPRB, 0.16188690E-05_JPRB, 0.16376947E-05_JPRB, 0.16525210E-05_JPRB, &
  & 0.16638595E-05_JPRB, 0.16695472E-05_JPRB, 0.16671048E-05_JPRB, 0.16547608E-05_JPRB, 0.16310805E-05_JPRB, 0.15953792E-05_JPRB, &
  & 0.15519619E-05_JPRB, 0.15070196E-05_JPRB, 0.14613936E-05_JPRB, 0.14163844E-05_JPRB, 0.13766557E-05_JPRB, 0.13386875E-05_JPRB, &
  & 0.13034904E-05_JPRB, 0.12691459E-05_JPRB, 0.12311828E-05_JPRB, 0.11969227E-05_JPRB, 0.11664694E-05_JPRB, 0.11371837E-05_JPRB, &
  & 0.11090768E-05_JPRB, 0.10813881E-05_JPRB, 0.10556234E-05_JPRB, 0.10350575E-05_JPRB, 0.10187293E-05_JPRB, 0.10039997E-05_JPRB, &
  & 0.98991238E-06_JPRB, 0.98041943E-06_JPRB, 0.96970588E-06_JPRB, 0.95769618E-06_JPRB, 0.94248473E-06_JPRB, 0.92658189E-06_JPRB, &
  & 0.91379034E-06_JPRB, 0.90320432E-06_JPRB, 0.89607980E-06_JPRB, 0.89191634E-06_JPRB  /)

RGHG2(:,31,10) = (/ &
  & 0.10852864E-05_JPRB, 0.10751935E-05_JPRB, 0.10620156E-05_JPRB, 0.10561431E-05_JPRB, 0.10600876E-05_JPRB, 0.10715323E-05_JPRB, &
  & 0.10954755E-05_JPRB, 0.11354394E-05_JPRB, 0.11872604E-05_JPRB, 0.12397768E-05_JPRB, 0.12895207E-05_JPRB, 0.13357061E-05_JPRB, &
  & 0.13753965E-05_JPRB, 0.14086046E-05_JPRB, 0.14350298E-05_JPRB, 0.14518157E-05_JPRB, 0.14630878E-05_JPRB, 0.14726889E-05_JPRB, &
  & 0.14820823E-05_JPRB, 0.14906004E-05_JPRB, 0.14980420E-05_JPRB, 0.15069081E-05_JPRB, 0.15173115E-05_JPRB, 0.15315611E-05_JPRB, &
  & 0.15527860E-05_JPRB, 0.15793210E-05_JPRB, 0.16069579E-05_JPRB, 0.16299897E-05_JPRB, 0.16480863E-05_JPRB, 0.16627015E-05_JPRB, &
  & 0.16746924E-05_JPRB, 0.16825867E-05_JPRB, 0.16840267E-05_JPRB, 0.16770810E-05_JPRB, 0.16599822E-05_JPRB, 0.16319626E-05_JPRB, &
  & 0.15975892E-05_JPRB, 0.15632772E-05_JPRB, 0.15306991E-05_JPRB, 0.14982773E-05_JPRB, 0.14665245E-05_JPRB, 0.14336668E-05_JPRB, &
  & 0.13990580E-05_JPRB, 0.13639653E-05_JPRB, 0.13257847E-05_JPRB, 0.12906292E-05_JPRB, 0.12579755E-05_JPRB, 0.12246796E-05_JPRB, &
  & 0.11937776E-05_JPRB, 0.11628461E-05_JPRB, 0.11352010E-05_JPRB, 0.11132791E-05_JPRB, 0.10945779E-05_JPRB, 0.10774115E-05_JPRB, &
  & 0.10614117E-05_JPRB, 0.10513240E-05_JPRB, 0.10404505E-05_JPRB, 0.10289973E-05_JPRB, 0.10146045E-05_JPRB, 0.99927731E-06_JPRB, &
  & 0.98693988E-06_JPRB, 0.97770343E-06_JPRB, 0.97146796E-06_JPRB, 0.96870523E-06_JPRB  /)

RGHG2(:,32,10) = (/ &
  & 0.11878145E-05_JPRB, 0.11771481E-05_JPRB, 0.11617236E-05_JPRB, 0.11518031E-05_JPRB, 0.11509593E-05_JPRB, 0.11552882E-05_JPRB, &
  & 0.11693830E-05_JPRB, 0.11983610E-05_JPRB, 0.12409421E-05_JPRB, 0.12868678E-05_JPRB, 0.13312086E-05_JPRB, 0.13725548E-05_JPRB, &
  & 0.14076894E-05_JPRB, 0.14371468E-05_JPRB, 0.14606194E-05_JPRB, 0.14760063E-05_JPRB, 0.14867438E-05_JPRB, 0.14962711E-05_JPRB, &
  & 0.15058268E-05_JPRB, 0.15152405E-05_JPRB, 0.15248226E-05_JPRB, 0.15359919E-05_JPRB, 0.15484630E-05_JPRB, 0.15628629E-05_JPRB, &
  & 0.15807311E-05_JPRB, 0.16016336E-05_JPRB, 0.16235779E-05_JPRB, 0.16430797E-05_JPRB, 0.16591133E-05_JPRB, 0.16721811E-05_JPRB, &
  & 0.16833588E-05_JPRB, 0.16916520E-05_JPRB, 0.16948349E-05_JPRB, 0.16912418E-05_JPRB, 0.16799797E-05_JPRB, 0.16602457E-05_JPRB, &
  & 0.16354366E-05_JPRB, 0.16108027E-05_JPRB, 0.15867598E-05_JPRB, 0.15618131E-05_JPRB, 0.15359741E-05_JPRB, 0.15083009E-05_JPRB, &
  & 0.14774490E-05_JPRB, 0.14452493E-05_JPRB, 0.14095932E-05_JPRB, 0.13745445E-05_JPRB, 0.13397215E-05_JPRB, 0.13036695E-05_JPRB, &
  & 0.12704550E-05_JPRB, 0.12380882E-05_JPRB, 0.12101575E-05_JPRB, 0.11869527E-05_JPRB, 0.11666500E-05_JPRB, 0.11477977E-05_JPRB, &
  & 0.11307108E-05_JPRB, 0.11200783E-05_JPRB, 0.11091820E-05_JPRB, 0.10972961E-05_JPRB, 0.10830713E-05_JPRB, 0.10680138E-05_JPRB, &
  & 0.10562673E-05_JPRB, 0.10478806E-05_JPRB, 0.10427476E-05_JPRB, 0.10401400E-05_JPRB  /)

RGHG2(:,33,10) = (/ &
  & 0.12923794E-05_JPRB, 0.12814060E-05_JPRB, 0.12638695E-05_JPRB, 0.12500196E-05_JPRB, 0.12444341E-05_JPRB, 0.12417708E-05_JPRB, &
  & 0.12459731E-05_JPRB, 0.12636444E-05_JPRB, 0.12963028E-05_JPRB, 0.13351219E-05_JPRB, 0.13737823E-05_JPRB, 0.14101040E-05_JPRB, &
  & 0.14405270E-05_JPRB, 0.14661332E-05_JPRB, 0.14865791E-05_JPRB, 0.15006482E-05_JPRB, 0.15108983E-05_JPRB, 0.15204015E-05_JPRB, &
  & 0.15302280E-05_JPRB, 0.15407007E-05_JPRB, 0.15526778E-05_JPRB, 0.15662962E-05_JPRB, 0.15807831E-05_JPRB, 0.15952973E-05_JPRB, &
  & 0.16099764E-05_JPRB, 0.16252947E-05_JPRB, 0.16413179E-05_JPRB, 0.16569385E-05_JPRB, 0.16706554E-05_JPRB, 0.16819420E-05_JPRB, &
  & 0.16920847E-05_JPRB, 0.17005584E-05_JPRB, 0.17052758E-05_JPRB, 0.17049020E-05_JPRB, 0.16996091E-05_JPRB, 0.16885643E-05_JPRB, &
  & 0.16737620E-05_JPRB, 0.16590628E-05_JPRB, 0.16433059E-05_JPRB, 0.16254658E-05_JPRB, 0.16055058E-05_JPRB, 0.15832302E-05_JPRB, &
  & 0.15566927E-05_JPRB, 0.15279710E-05_JPRB, 0.14952936E-05_JPRB, 0.14604855E-05_JPRB, 0.14234120E-05_JPRB, 0.13846582E-05_JPRB, &
  & 0.13491029E-05_JPRB, 0.13154785E-05_JPRB, 0.12874576E-05_JPRB, 0.12629290E-05_JPRB, 0.12410618E-05_JPRB, 0.12205547E-05_JPRB, &
  & 0.12024448E-05_JPRB, 0.11912527E-05_JPRB, 0.11803504E-05_JPRB, 0.11678868E-05_JPRB, 0.11537523E-05_JPRB, 0.11389355E-05_JPRB, &
  & 0.11278208E-05_JPRB, 0.11202524E-05_JPRB, 0.11162928E-05_JPRB, 0.11136853E-05_JPRB  /)

RGHG2(:,34,10) = (/ &
  & 0.13769251E-05_JPRB, 0.13670052E-05_JPRB, 0.13492981E-05_JPRB, 0.13331220E-05_JPRB, 0.13244398E-05_JPRB, 0.13175466E-05_JPRB, &
  & 0.13150389E-05_JPRB, 0.13242869E-05_JPRB, 0.13479502E-05_JPRB, 0.13794002E-05_JPRB, 0.14124777E-05_JPRB, 0.14442030E-05_JPRB, &
  & 0.14706590E-05_JPRB, 0.14930521E-05_JPRB, 0.15109505E-05_JPRB, 0.15239071E-05_JPRB, 0.15339333E-05_JPRB, 0.15437437E-05_JPRB, &
  & 0.15543305E-05_JPRB, 0.15658804E-05_JPRB, 0.15793214E-05_JPRB, 0.15939943E-05_JPRB, 0.16088299E-05_JPRB, 0.16224620E-05_JPRB, &
  & 0.16346518E-05_JPRB, 0.16461801E-05_JPRB, 0.16577394E-05_JPRB, 0.16694159E-05_JPRB, 0.16802566E-05_JPRB, 0.16895120E-05_JPRB, &
  & 0.16983464E-05_JPRB, 0.17063947E-05_JPRB, 0.17119092E-05_JPRB, 0.17138100E-05_JPRB, 0.17126274E-05_JPRB, 0.17077361E-05_JPRB, &
  & 0.16999390E-05_JPRB, 0.16915906E-05_JPRB, 0.16814145E-05_JPRB, 0.16689474E-05_JPRB, 0.16539408E-05_JPRB, 0.16364330E-05_JPRB, &
  & 0.16148098E-05_JPRB, 0.15901408E-05_JPRB, 0.15611142E-05_JPRB, 0.15280962E-05_JPRB, 0.14909908E-05_JPRB, 0.14516998E-05_JPRB, &
  & 0.14157456E-05_JPRB, 0.13826263E-05_JPRB, 0.13549412E-05_JPRB, 0.13298631E-05_JPRB, 0.13074134E-05_JPRB, 0.12859968E-05_JPRB, &
  & 0.12674232E-05_JPRB, 0.12555267E-05_JPRB, 0.12447636E-05_JPRB, 0.12320063E-05_JPRB, 0.12178728E-05_JPRB, 0.12036107E-05_JPRB, &
  & 0.11929383E-05_JPRB, 0.11861206E-05_JPRB, 0.11830987E-05_JPRB, 0.11807266E-05_JPRB  /)

RGHG2(:,35,10) = (/ &
  & 0.14535764E-05_JPRB, 0.14454378E-05_JPRB, 0.14285514E-05_JPRB, 0.14108063E-05_JPRB, 0.13997845E-05_JPRB, 0.13899598E-05_JPRB, &
  & 0.13821866E-05_JPRB, 0.13842539E-05_JPRB, 0.13991451E-05_JPRB, 0.14228839E-05_JPRB, 0.14502715E-05_JPRB, 0.14774907E-05_JPRB, &
  & 0.15002502E-05_JPRB, 0.15196671E-05_JPRB, 0.15351925E-05_JPRB, 0.15471105E-05_JPRB, 0.15570418E-05_JPRB, 0.15673379E-05_JPRB, &
  & 0.15789578E-05_JPRB, 0.15916244E-05_JPRB, 0.16060928E-05_JPRB, 0.16211342E-05_JPRB, 0.16354729E-05_JPRB, 0.16476867E-05_JPRB, &
  & 0.16576766E-05_JPRB, 0.16662286E-05_JPRB, 0.16739463E-05_JPRB, 0.16815355E-05_JPRB, 0.16891320E-05_JPRB, 0.16961706E-05_JPRB, &
  & 0.17035197E-05_JPRB, 0.17108199E-05_JPRB, 0.17167755E-05_JPRB, 0.17205301E-05_JPRB, 0.17226196E-05_JPRB, 0.17227537E-05_JPRB, &
  & 0.17206186E-05_JPRB, 0.17169605E-05_JPRB, 0.17111342E-05_JPRB, 0.17033015E-05_JPRB, 0.16929127E-05_JPRB, 0.16799836E-05_JPRB, &
  & 0.16637209E-05_JPRB, 0.16435133E-05_JPRB, 0.16185852E-05_JPRB, 0.15882028E-05_JPRB, 0.15522029E-05_JPRB, 0.15134703E-05_JPRB, &
  & 0.14781024E-05_JPRB, 0.14464070E-05_JPRB, 0.14192858E-05_JPRB, 0.13940403E-05_JPRB, 0.13714957E-05_JPRB, 0.13495262E-05_JPRB, &
  & 0.13307627E-05_JPRB, 0.13180677E-05_JPRB, 0.13075225E-05_JPRB, 0.12946088E-05_JPRB, 0.12804306E-05_JPRB, 0.12669001E-05_JPRB, &
  & 0.12565850E-05_JPRB, 0.12505043E-05_JPRB, 0.12483256E-05_JPRB, 0.12463165E-05_JPRB  /)

RGHG2(:,36,10) = (/ &
  & 0.15226416E-05_JPRB, 0.15160448E-05_JPRB, 0.15004741E-05_JPRB, 0.14819784E-05_JPRB, 0.14690872E-05_JPRB, 0.14571684E-05_JPRB, &
  & 0.14454261E-05_JPRB, 0.14414821E-05_JPRB, 0.14486046E-05_JPRB, 0.14651195E-05_JPRB, 0.14869077E-05_JPRB, 0.15096659E-05_JPRB, &
  & 0.15289452E-05_JPRB, 0.15455758E-05_JPRB, 0.15589135E-05_JPRB, 0.15698662E-05_JPRB, 0.15797070E-05_JPRB, 0.15904014E-05_JPRB, &
  & 0.16026938E-05_JPRB, 0.16159855E-05_JPRB, 0.16307889E-05_JPRB, 0.16454951E-05_JPRB, 0.16587232E-05_JPRB, 0.16691948E-05_JPRB, &
  & 0.16769819E-05_JPRB, 0.16828186E-05_JPRB, 0.16873072E-05_JPRB, 0.16915696E-05_JPRB, 0.16964744E-05_JPRB, 0.17016756E-05_JPRB, &
  & 0.17077560E-05_JPRB, 0.17143193E-05_JPRB, 0.17204603E-05_JPRB, 0.17256702E-05_JPRB, 0.17304434E-05_JPRB, 0.17346099E-05_JPRB, &
  & 0.17368873E-05_JPRB, 0.17369617E-05_JPRB, 0.17347594E-05_JPRB, 0.17308438E-05_JPRB, 0.17243889E-05_JPRB, 0.17155063E-05_JPRB, &
  & 0.17039080E-05_JPRB, 0.16879070E-05_JPRB, 0.16670157E-05_JPRB, 0.16398002E-05_JPRB, 0.16060418E-05_JPRB, 0.15691471E-05_JPRB, &
  & 0.15352252E-05_JPRB, 0.15052360E-05_JPRB, 0.14789029E-05_JPRB, 0.14539868E-05_JPRB, 0.14317522E-05_JPRB, 0.14097877E-05_JPRB, &
  & 0.13910682E-05_JPRB, 0.13777395E-05_JPRB, 0.13673560E-05_JPRB, 0.13546744E-05_JPRB, 0.13408227E-05_JPRB, 0.13280195E-05_JPRB, &
  & 0.13181144E-05_JPRB, 0.13126319E-05_JPRB, 0.13110308E-05_JPRB, 0.13096016E-05_JPRB  /)

RGHG2(:,37,10) = (/ &
  & 0.15700171E-05_JPRB, 0.15643172E-05_JPRB, 0.15511151E-05_JPRB, 0.15337921E-05_JPRB, 0.15202256E-05_JPRB, 0.15082630E-05_JPRB, &
  & 0.14957707E-05_JPRB, 0.14888705E-05_JPRB, 0.14910085E-05_JPRB, 0.15018662E-05_JPRB, 0.15186106E-05_JPRB, 0.15372890E-05_JPRB, &
  & 0.15538003E-05_JPRB, 0.15682530E-05_JPRB, 0.15799644E-05_JPRB, 0.15901800E-05_JPRB, 0.15999461E-05_JPRB, 0.16108132E-05_JPRB, &
  & 0.16229096E-05_JPRB, 0.16356601E-05_JPRB, 0.16491904E-05_JPRB, 0.16619687E-05_JPRB, 0.16727484E-05_JPRB, 0.16808437E-05_JPRB, &
  & 0.16865586E-05_JPRB, 0.16904469E-05_JPRB, 0.16933118E-05_JPRB, 0.16961979E-05_JPRB, 0.16998449E-05_JPRB, 0.17041931E-05_JPRB, &
  & 0.17095802E-05_JPRB, 0.17154786E-05_JPRB, 0.17212072E-05_JPRB, 0.17268681E-05_JPRB, 0.17328088E-05_JPRB, 0.17384805E-05_JPRB, &
  & 0.17420310E-05_JPRB, 0.17434096E-05_JPRB, 0.17429418E-05_JPRB, 0.17410545E-05_JPRB, 0.17367207E-05_JPRB, 0.17304129E-05_JPRB, &
  & 0.17215929E-05_JPRB, 0.17089528E-05_JPRB, 0.16917058E-05_JPRB, 0.16686784E-05_JPRB, 0.16396262E-05_JPRB, 0.16073886E-05_JPRB, &
  & 0.15767941E-05_JPRB, 0.15490523E-05_JPRB, 0.15239717E-05_JPRB, 0.15005041E-05_JPRB, 0.14794885E-05_JPRB, 0.14588075E-05_JPRB, &
  & 0.14406653E-05_JPRB, 0.14271202E-05_JPRB, 0.14167598E-05_JPRB, 0.14051865E-05_JPRB, 0.13924920E-05_JPRB, 0.13803615E-05_JPRB, &
  & 0.13709615E-05_JPRB, 0.13657213E-05_JPRB, 0.13640532E-05_JPRB, 0.13636652E-05_JPRB  /)

RGHG2(:,38,10) = (/ &
  & 0.16225845E-05_JPRB, 0.16178797E-05_JPRB, 0.16073057E-05_JPRB, 0.15912839E-05_JPRB, 0.15769681E-05_JPRB, 0.15649569E-05_JPRB, &
  & 0.15516325E-05_JPRB, 0.15414521E-05_JPRB, 0.15380594E-05_JPRB, 0.15426400E-05_JPRB, 0.15537879E-05_JPRB, 0.15679392E-05_JPRB, &
  & 0.15813791E-05_JPRB, 0.15934154E-05_JPRB, 0.16033223E-05_JPRB, 0.16127200E-05_JPRB, 0.16224031E-05_JPRB, 0.16334618E-05_JPRB, &
  & 0.16453409E-05_JPRB, 0.16574908E-05_JPRB, 0.16696084E-05_JPRB, 0.16802477E-05_JPRB, 0.16883105E-05_JPRB, 0.16937692E-05_JPRB, &
  & 0.16971849E-05_JPRB, 0.16989112E-05_JPRB, 0.16999745E-05_JPRB, 0.17013334E-05_JPRB, 0.17035849E-05_JPRB, 0.17069865E-05_JPRB, &
  & 0.17116044E-05_JPRB, 0.17167649E-05_JPRB, 0.17220360E-05_JPRB, 0.17281973E-05_JPRB, 0.17354335E-05_JPRB, 0.17427753E-05_JPRB, &
  & 0.17477385E-05_JPRB, 0.17505641E-05_JPRB, 0.17520209E-05_JPRB, 0.17523843E-05_JPRB, 0.17504041E-05_JPRB, 0.17469531E-05_JPRB, &
  & 0.17412160E-05_JPRB, 0.17323049E-05_JPRB, 0.17191016E-05_JPRB, 0.17007213E-05_JPRB, 0.16768910E-05_JPRB, 0.16498210E-05_JPRB, &
  & 0.16229184E-05_JPRB, 0.15976703E-05_JPRB, 0.15739796E-05_JPRB, 0.15521191E-05_JPRB, 0.15324562E-05_JPRB, 0.15131994E-05_JPRB, &
  & 0.14956978E-05_JPRB, 0.14819124E-05_JPRB, 0.14715778E-05_JPRB, 0.14612342E-05_JPRB, 0.14498237E-05_JPRB, 0.14384396E-05_JPRB, &
  & 0.14296001E-05_JPRB, 0.14246287E-05_JPRB, 0.14228862E-05_JPRB, 0.14236536E-05_JPRB  /)

RGHG2(:,39,10) = (/ &
  & 0.16488937E-05_JPRB, 0.16449998E-05_JPRB, 0.16361604E-05_JPRB, 0.16222888E-05_JPRB, 0.16090518E-05_JPRB, 0.15978039E-05_JPRB, &
  & 0.15853917E-05_JPRB, 0.15748820E-05_JPRB, 0.15696196E-05_JPRB, 0.15713774E-05_JPRB, 0.15789711E-05_JPRB, 0.15897651E-05_JPRB, &
  & 0.16008649E-05_JPRB, 0.16113035E-05_JPRB, 0.16201031E-05_JPRB, 0.16287323E-05_JPRB, 0.16378725E-05_JPRB, 0.16481298E-05_JPRB, &
  & 0.16589375E-05_JPRB, 0.16696172E-05_JPRB, 0.16798403E-05_JPRB, 0.16883564E-05_JPRB, 0.16942953E-05_JPRB, 0.16979567E-05_JPRB, &
  & 0.17002189E-05_JPRB, 0.17011665E-05_JPRB, 0.17016267E-05_JPRB, 0.17026116E-05_JPRB, 0.17045423E-05_JPRB, 0.17076655E-05_JPRB, &
  & 0.17119157E-05_JPRB, 0.17165211E-05_JPRB, 0.17213372E-05_JPRB, 0.17273602E-05_JPRB, 0.17347323E-05_JPRB, 0.17425705E-05_JPRB, &
  & 0.17480891E-05_JPRB, 0.17514147E-05_JPRB, 0.17536007E-05_JPRB, 0.17545911E-05_JPRB, 0.17536126E-05_JPRB, 0.17513401E-05_JPRB, &
  & 0.17468255E-05_JPRB, 0.17397591E-05_JPRB, 0.17290807E-05_JPRB, 0.17138380E-05_JPRB, 0.16937915E-05_JPRB, 0.16709163E-05_JPRB, &
  & 0.16476968E-05_JPRB, 0.16252138E-05_JPRB, 0.16033880E-05_JPRB, 0.15833060E-05_JPRB, 0.15652648E-05_JPRB, 0.15479779E-05_JPRB, &
  & 0.15321364E-05_JPRB, 0.15193995E-05_JPRB, 0.15093066E-05_JPRB, 0.14998416E-05_JPRB, 0.14897689E-05_JPRB, 0.14794572E-05_JPRB, &
  & 0.14717230E-05_JPRB, 0.14667557E-05_JPRB, 0.14647676E-05_JPRB, 0.14652258E-05_JPRB  /)

RGHG2(:,40,10) = (/ &
  & 0.16754739E-05_JPRB, 0.16725014E-05_JPRB, 0.16655516E-05_JPRB, 0.16543424E-05_JPRB, 0.16426704E-05_JPRB, 0.16324512E-05_JPRB, &
  & 0.16213949E-05_JPRB, 0.16109815E-05_JPRB, 0.16041239E-05_JPRB, 0.16031339E-05_JPRB, 0.16068908E-05_JPRB, 0.16139359E-05_JPRB, &
  & 0.16224090E-05_JPRB, 0.16311066E-05_JPRB, 0.16387208E-05_JPRB, 0.16464561E-05_JPRB, 0.16548839E-05_JPRB, 0.16640383E-05_JPRB, &
  & 0.16734487E-05_JPRB, 0.16822610E-05_JPRB, 0.16901819E-05_JPRB, 0.16962089E-05_JPRB, 0.16997521E-05_JPRB, 0.17014414E-05_JPRB, &
  & 0.17025374E-05_JPRB, 0.17027974E-05_JPRB, 0.17027461E-05_JPRB, 0.17034807E-05_JPRB, 0.17052105E-05_JPRB, 0.17081165E-05_JPRB, &
  & 0.17120009E-05_JPRB, 0.17159847E-05_JPRB, 0.17202672E-05_JPRB, 0.17260234E-05_JPRB, 0.17333652E-05_JPRB, 0.17415940E-05_JPRB, &
  & 0.17476242E-05_JPRB, 0.17513816E-05_JPRB, 0.17542277E-05_JPRB, 0.17556884E-05_JPRB, 0.17556643E-05_JPRB, 0.17545003E-05_JPRB, &
  & 0.17511161E-05_JPRB, 0.17459062E-05_JPRB, 0.17379425E-05_JPRB, 0.17261352E-05_JPRB, 0.17102941E-05_JPRB, 0.16921827E-05_JPRB, &
  & 0.16732841E-05_JPRB, 0.16540907E-05_JPRB, 0.16345312E-05_JPRB, 0.16165643E-05_JPRB, 0.16004705E-05_JPRB, 0.15855847E-05_JPRB, &
  & 0.15718583E-05_JPRB, 0.15605626E-05_JPRB, 0.15507887E-05_JPRB, 0.15422974E-05_JPRB, 0.15338035E-05_JPRB, 0.15248037E-05_JPRB, &
  & 0.15184557E-05_JPRB, 0.15134499E-05_JPRB, 0.15111455E-05_JPRB, 0.15110014E-05_JPRB  /)

RGHG2(:,41,10) = (/ &
  & 0.17079721E-05_JPRB, 0.17061261E-05_JPRB, 0.17014866E-05_JPRB, 0.16935326E-05_JPRB, 0.16837740E-05_JPRB, 0.16748125E-05_JPRB, &
  & 0.16654141E-05_JPRB, 0.16551184E-05_JPRB, 0.16463103E-05_JPRB, 0.16419609E-05_JPRB, 0.16410267E-05_JPRB, 0.16434883E-05_JPRB, &
  & 0.16487499E-05_JPRB, 0.16553188E-05_JPRB, 0.16614836E-05_JPRB, 0.16681260E-05_JPRB, 0.16756829E-05_JPRB, 0.16834888E-05_JPRB, &
  & 0.16911908E-05_JPRB, 0.16977197E-05_JPRB, 0.17028260E-05_JPRB, 0.17058096E-05_JPRB, 0.17064239E-05_JPRB, 0.17057020E-05_JPRB, &
  & 0.17053722E-05_JPRB, 0.17047914E-05_JPRB, 0.17041146E-05_JPRB, 0.17045432E-05_JPRB, 0.17060276E-05_JPRB, 0.17086679E-05_JPRB, &
  & 0.17121050E-05_JPRB, 0.17153288E-05_JPRB, 0.17189589E-05_JPRB, 0.17243890E-05_JPRB, 0.17316938E-05_JPRB, 0.17404001E-05_JPRB, &
  & 0.17470558E-05_JPRB, 0.17513412E-05_JPRB, 0.17549943E-05_JPRB, 0.17570301E-05_JPRB, 0.17581729E-05_JPRB, 0.17583640E-05_JPRB, &
  & 0.17563620E-05_JPRB, 0.17534220E-05_JPRB, 0.17487774E-05_JPRB, 0.17411702E-05_JPRB, 0.17304709E-05_JPRB, 0.17181839E-05_JPRB, &
  & 0.17045683E-05_JPRB, 0.16893968E-05_JPRB, 0.16726083E-05_JPRB, 0.16572274E-05_JPRB, 0.16435144E-05_JPRB, 0.16315644E-05_JPRB, &
  & 0.16204240E-05_JPRB, 0.16108904E-05_JPRB, 0.16015067E-05_JPRB, 0.15942057E-05_JPRB, 0.15876421E-05_JPRB, 0.15802464E-05_JPRB, &
  & 0.15755933E-05_JPRB, 0.15705403E-05_JPRB, 0.15678492E-05_JPRB, 0.15669687E-05_JPRB  /)

RGHG2(:,42,10) = (/ &
  & 0.17043681E-05_JPRB, 0.17029581E-05_JPRB, 0.16991417E-05_JPRB, 0.16927525E-05_JPRB, 0.16849131E-05_JPRB, 0.16776819E-05_JPRB, &
  & 0.16700450E-05_JPRB, 0.16617407E-05_JPRB, 0.16549792E-05_JPRB, 0.16517591E-05_JPRB, 0.16510915E-05_JPRB, 0.16530181E-05_JPRB, &
  & 0.16572180E-05_JPRB, 0.16629962E-05_JPRB, 0.16684319E-05_JPRB, 0.16742080E-05_JPRB, 0.16806267E-05_JPRB, 0.16871251E-05_JPRB, &
  & 0.16934221E-05_JPRB, 0.16985970E-05_JPRB, 0.17026035E-05_JPRB, 0.17048423E-05_JPRB, 0.17050541E-05_JPRB, 0.17046019E-05_JPRB, &
  & 0.17045153E-05_JPRB, 0.17040928E-05_JPRB, 0.17036418E-05_JPRB, 0.17040329E-05_JPRB, 0.17054930E-05_JPRB, 0.17082658E-05_JPRB, &
  & 0.17117302E-05_JPRB, 0.17151432E-05_JPRB, 0.17190318E-05_JPRB, 0.17242994E-05_JPRB, 0.17312744E-05_JPRB, 0.17391157E-05_JPRB, &
  & 0.17452584E-05_JPRB, 0.17495911E-05_JPRB, 0.17533328E-05_JPRB, 0.17552738E-05_JPRB, 0.17565063E-05_JPRB, 0.17566275E-05_JPRB, &
  & 0.17545356E-05_JPRB, 0.17513562E-05_JPRB, 0.17469665E-05_JPRB, 0.17397114E-05_JPRB, 0.17293929E-05_JPRB, 0.17180211E-05_JPRB, &
  & 0.17060122E-05_JPRB, 0.16927093E-05_JPRB, 0.16783500E-05_JPRB, 0.16649366E-05_JPRB, 0.16528534E-05_JPRB, 0.16424314E-05_JPRB, &
  & 0.16331513E-05_JPRB, 0.16254173E-05_JPRB, 0.16171640E-05_JPRB, 0.16104161E-05_JPRB, 0.16039022E-05_JPRB, 0.15976445E-05_JPRB, &
  & 0.15942683E-05_JPRB, 0.15902374E-05_JPRB, 0.15875177E-05_JPRB, 0.15863899E-05_JPRB  /)

RGHG2(:,43,10) = (/ &
  & 0.17150590E-05_JPRB, 0.17145313E-05_JPRB, 0.17124598E-05_JPRB, 0.17088985E-05_JPRB, 0.17036332E-05_JPRB, 0.16985215E-05_JPRB, &
  & 0.16932050E-05_JPRB, 0.16867683E-05_JPRB, 0.16810351E-05_JPRB, 0.16774004E-05_JPRB, 0.16749581E-05_JPRB, 0.16744251E-05_JPRB, &
  & 0.16762747E-05_JPRB, 0.16804159E-05_JPRB, 0.16845629E-05_JPRB, 0.16890784E-05_JPRB, 0.16940841E-05_JPRB, 0.16988094E-05_JPRB, &
  & 0.17030896E-05_JPRB, 0.17060470E-05_JPRB, 0.17078393E-05_JPRB, 0.17080894E-05_JPRB, 0.17066743E-05_JPRB, 0.17054309E-05_JPRB, &
  & 0.17049528E-05_JPRB, 0.17043130E-05_JPRB, 0.17037990E-05_JPRB, 0.17040243E-05_JPRB, 0.17053567E-05_JPRB, 0.17081362E-05_JPRB, &
  & 0.17114330E-05_JPRB, 0.17146918E-05_JPRB, 0.17185356E-05_JPRB, 0.17235146E-05_JPRB, 0.17301728E-05_JPRB, 0.17374303E-05_JPRB, &
  & 0.17433739E-05_JPRB, 0.17479770E-05_JPRB, 0.17521466E-05_JPRB, 0.17542485E-05_JPRB, 0.17560648E-05_JPRB, 0.17567052E-05_JPRB, &
  & 0.17551257E-05_JPRB, 0.17527043E-05_JPRB, 0.17499748E-05_JPRB, 0.17448477E-05_JPRB, 0.17370884E-05_JPRB, 0.17290569E-05_JPRB, &
  & 0.17207865E-05_JPRB, 0.17109185E-05_JPRB, 0.16999676E-05_JPRB, 0.16894616E-05_JPRB, 0.16798895E-05_JPRB, 0.16721246E-05_JPRB, &
  & 0.16656541E-05_JPRB, 0.16603201E-05_JPRB, 0.16532659E-05_JPRB, 0.16475347E-05_JPRB, 0.16418966E-05_JPRB, 0.16373671E-05_JPRB, &
  & 0.16358850E-05_JPRB, 0.16327663E-05_JPRB, 0.16298542E-05_JPRB, 0.16281841E-05_JPRB  /)

RGHG2(:,44,10) = (/ &
  & 0.17145884E-05_JPRB, 0.17142201E-05_JPRB, 0.17127993E-05_JPRB, 0.17101800E-05_JPRB, 0.17062242E-05_JPRB, 0.17023283E-05_JPRB, &
  & 0.16982823E-05_JPRB, 0.16933156E-05_JPRB, 0.16888628E-05_JPRB, 0.16858727E-05_JPRB, 0.16839145E-05_JPRB, 0.16833458E-05_JPRB, &
  & 0.16846490E-05_JPRB, 0.16879317E-05_JPRB, 0.16913373E-05_JPRB, 0.16950727E-05_JPRB, 0.16991928E-05_JPRB, 0.17029598E-05_JPRB, &
  & 0.17061287E-05_JPRB, 0.17080734E-05_JPRB, 0.17088784E-05_JPRB, 0.17083349E-05_JPRB, 0.17066016E-05_JPRB, 0.17053124E-05_JPRB, &
  & 0.17048414E-05_JPRB, 0.17041221E-05_JPRB, 0.17036001E-05_JPRB, 0.17038230E-05_JPRB, 0.17051510E-05_JPRB, 0.17078691E-05_JPRB, &
  & 0.17113481E-05_JPRB, 0.17146025E-05_JPRB, 0.17184363E-05_JPRB, 0.17233437E-05_JPRB, 0.17298657E-05_JPRB, 0.17369600E-05_JPRB, &
  & 0.17427958E-05_JPRB, 0.17472682E-05_JPRB, 0.17513345E-05_JPRB, 0.17535529E-05_JPRB, 0.17553465E-05_JPRB, 0.17562050E-05_JPRB, &
  & 0.17547373E-05_JPRB, 0.17524740E-05_JPRB, 0.17500310E-05_JPRB, 0.17453949E-05_JPRB, 0.17386140E-05_JPRB, 0.17318206E-05_JPRB, &
  & 0.17248676E-05_JPRB, 0.17166765E-05_JPRB, 0.17074741E-05_JPRB, 0.16987464E-05_JPRB, 0.16908508E-05_JPRB, 0.16843898E-05_JPRB, &
  & 0.16790184E-05_JPRB, 0.16747804E-05_JPRB, 0.16689332E-05_JPRB, 0.16639279E-05_JPRB, 0.16588834E-05_JPRB, 0.16552237E-05_JPRB, &
  & 0.16540693E-05_JPRB, 0.16516537E-05_JPRB, 0.16493288E-05_JPRB, 0.16478817E-05_JPRB  /)

RGHG2(:,45,10) = (/ &
  & 0.17154033E-05_JPRB, 0.17153276E-05_JPRB, 0.17148681E-05_JPRB, 0.17136785E-05_JPRB, 0.17115387E-05_JPRB, 0.17092944E-05_JPRB, &
  & 0.17069880E-05_JPRB, 0.17039308E-05_JPRB, 0.17010654E-05_JPRB, 0.16987568E-05_JPRB, 0.16971255E-05_JPRB, 0.16962055E-05_JPRB, &
  & 0.16965897E-05_JPRB, 0.16986884E-05_JPRB, 0.17010872E-05_JPRB, 0.17037751E-05_JPRB, 0.17067088E-05_JPRB, 0.17091607E-05_JPRB, &
  & 0.17108096E-05_JPRB, 0.17113215E-05_JPRB, 0.17107228E-05_JPRB, 0.17090244E-05_JPRB, 0.17067235E-05_JPRB, 0.17052823E-05_JPRB, &
  & 0.17047698E-05_JPRB, 0.17039326E-05_JPRB, 0.17033935E-05_JPRB, 0.17035928E-05_JPRB, 0.17048997E-05_JPRB, 0.17075486E-05_JPRB, &
  & 0.17112138E-05_JPRB, 0.17144439E-05_JPRB, 0.17182606E-05_JPRB, 0.17230501E-05_JPRB, 0.17293769E-05_JPRB, 0.17362118E-05_JPRB, &
  & 0.17418995E-05_JPRB, 0.17462572E-05_JPRB, 0.17502601E-05_JPRB, 0.17526314E-05_JPRB, 0.17544731E-05_JPRB, 0.17556455E-05_JPRB, &
  & 0.17543697E-05_JPRB, 0.17523820E-05_JPRB, 0.17504750E-05_JPRB, 0.17466668E-05_JPRB, 0.17413228E-05_JPRB, 0.17363608E-05_JPRB, &
  & 0.17313800E-05_JPRB, 0.17255318E-05_JPRB, 0.17187505E-05_JPRB, 0.17124145E-05_JPRB, 0.17067448E-05_JPRB, 0.17021038E-05_JPRB, &
  & 0.16983385E-05_JPRB, 0.16956513E-05_JPRB, 0.16913299E-05_JPRB, 0.16872793E-05_JPRB, 0.16830212E-05_JPRB, 0.16805700E-05_JPRB, &
  & 0.16800280E-05_JPRB, 0.16785281E-05_JPRB, 0.16768472E-05_JPRB, 0.16755856E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART20',0,ZHOOK_HANDLE)



RGHG2(:,46,10) = (/ &
  & 0.17149958E-05_JPRB, 0.17149655E-05_JPRB, 0.17147554E-05_JPRB, 0.17141221E-05_JPRB, 0.17128059E-05_JPRB, 0.17113951E-05_JPRB, &
  & 0.17099349E-05_JPRB, 0.17079209E-05_JPRB, 0.17059337E-05_JPRB, 0.17042162E-05_JPRB, 0.17030724E-05_JPRB, 0.17024273E-05_JPRB, &
  & 0.17026633E-05_JPRB, 0.17041590E-05_JPRB, 0.17059430E-05_JPRB, 0.17079368E-05_JPRB, 0.17101004E-05_JPRB, 0.17117160E-05_JPRB, &
  & 0.17124676E-05_JPRB, 0.17122499E-05_JPRB, 0.17110575E-05_JPRB, 0.17089255E-05_JPRB, 0.17065278E-05_JPRB, 0.17050958E-05_JPRB, &
  & 0.17046533E-05_JPRB, 0.17037493E-05_JPRB, 0.17032395E-05_JPRB, 0.17035259E-05_JPRB, 0.17049231E-05_JPRB, 0.17075368E-05_JPRB, &
  & 0.17112339E-05_JPRB, 0.17144699E-05_JPRB, 0.17182286E-05_JPRB, 0.17228425E-05_JPRB, 0.17290348E-05_JPRB, 0.17357803E-05_JPRB, &
  & 0.17414420E-05_JPRB, 0.17457892E-05_JPRB, 0.17495496E-05_JPRB, 0.17519942E-05_JPRB, 0.17537987E-05_JPRB, 0.17551510E-05_JPRB, &
  & 0.17539863E-05_JPRB, 0.17521747E-05_JPRB, 0.17505458E-05_JPRB, 0.17471747E-05_JPRB, 0.17427902E-05_JPRB, 0.17388042E-05_JPRB, &
  & 0.17348814E-05_JPRB, 0.17303580E-05_JPRB, 0.17249968E-05_JPRB, 0.17200540E-05_JPRB, 0.17157374E-05_JPRB, 0.17122058E-05_JPRB, &
  & 0.17092107E-05_JPRB, 0.17071414E-05_JPRB, 0.17038036E-05_JPRB, 0.17005677E-05_JPRB, 0.16970723E-05_JPRB, 0.16951030E-05_JPRB, &
  & 0.16945980E-05_JPRB, 0.16935703E-05_JPRB, 0.16923389E-05_JPRB, 0.16914058E-05_JPRB  /)

RGHG2(:,47,10) = (/ &
  & 0.17142728E-05_JPRB, 0.17142463E-05_JPRB, 0.17141861E-05_JPRB, 0.17140306E-05_JPRB, 0.17134820E-05_JPRB, 0.17128854E-05_JPRB, &
  & 0.17122394E-05_JPRB, 0.17112759E-05_JPRB, 0.17101770E-05_JPRB, 0.17091351E-05_JPRB, 0.17085954E-05_JPRB, 0.17083983E-05_JPRB, &
  & 0.17086147E-05_JPRB, 0.17095194E-05_JPRB, 0.17106604E-05_JPRB, 0.17119107E-05_JPRB, 0.17132540E-05_JPRB, 0.17139842E-05_JPRB, &
  & 0.17138074E-05_JPRB, 0.17128747E-05_JPRB, 0.17111479E-05_JPRB, 0.17086513E-05_JPRB, 0.17062346E-05_JPRB, 0.17048458E-05_JPRB, &
  & 0.17045076E-05_JPRB, 0.17035355E-05_JPRB, 0.17030693E-05_JPRB, 0.17034801E-05_JPRB, 0.17050058E-05_JPRB, 0.17075847E-05_JPRB, &
  & 0.17112884E-05_JPRB, 0.17145374E-05_JPRB, 0.17182199E-05_JPRB, 0.17226160E-05_JPRB, 0.17286629E-05_JPRB, 0.17353374E-05_JPRB, &
  & 0.17409930E-05_JPRB, 0.17453488E-05_JPRB, 0.17487887E-05_JPRB, 0.17513035E-05_JPRB, 0.17530472E-05_JPRB, 0.17545837E-05_JPRB, &
  & 0.17535332E-05_JPRB, 0.17519084E-05_JPRB, 0.17505543E-05_JPRB, 0.17476177E-05_JPRB, 0.17442634E-05_JPRB, 0.17412514E-05_JPRB, &
  & 0.17383868E-05_JPRB, 0.17352141E-05_JPRB, 0.17313189E-05_JPRB, 0.17278106E-05_JPRB, 0.17249070E-05_JPRB, 0.17225349E-05_JPRB, &
  & 0.17202760E-05_JPRB, 0.17187449E-05_JPRB, 0.17164527E-05_JPRB, 0.17141447E-05_JPRB, 0.17115397E-05_JPRB, 0.17099903E-05_JPRB, &
  & 0.17094136E-05_JPRB, 0.17088510E-05_JPRB, 0.17081080E-05_JPRB, 0.17075891E-05_JPRB  /)

RGHG2(:,48,10) = (/ &
  & 0.17133467E-05_JPRB, 0.17132641E-05_JPRB, 0.17132378E-05_JPRB, 0.17132789E-05_JPRB, 0.17131458E-05_JPRB, 0.17130168E-05_JPRB, &
  & 0.17128268E-05_JPRB, 0.17124726E-05_JPRB, 0.17119408E-05_JPRB, 0.17113516E-05_JPRB, 0.17111602E-05_JPRB, 0.17112262E-05_JPRB, &
  & 0.17114953E-05_JPRB, 0.17120808E-05_JPRB, 0.17127945E-05_JPRB, 0.17135318E-05_JPRB, 0.17142777E-05_JPRB, 0.17144124E-05_JPRB, &
  & 0.17137246E-05_JPRB, 0.17124387E-05_JPRB, 0.17106050E-05_JPRB, 0.17080833E-05_JPRB, 0.17058181E-05_JPRB, 0.17046013E-05_JPRB, &
  & 0.17043414E-05_JPRB, 0.17034372E-05_JPRB, 0.17030412E-05_JPRB, 0.17035321E-05_JPRB, 0.17051669E-05_JPRB, 0.17077508E-05_JPRB, &
  & 0.17114012E-05_JPRB, 0.17146155E-05_JPRB, 0.17182230E-05_JPRB, 0.17224390E-05_JPRB, 0.17283843E-05_JPRB, 0.17350146E-05_JPRB, &
  & 0.17407206E-05_JPRB, 0.17450411E-05_JPRB, 0.17482970E-05_JPRB, 0.17507708E-05_JPRB, 0.17525030E-05_JPRB, 0.17541211E-05_JPRB, &
  & 0.17533601E-05_JPRB, 0.17519549E-05_JPRB, 0.17509063E-05_JPRB, 0.17485379E-05_JPRB, 0.17459224E-05_JPRB, 0.17435456E-05_JPRB, &
  & 0.17413831E-05_JPRB, 0.17391017E-05_JPRB, 0.17361357E-05_JPRB, 0.17335866E-05_JPRB, 0.17315298E-05_JPRB, 0.17298535E-05_JPRB, &
  & 0.17280706E-05_JPRB, 0.17268902E-05_JPRB, 0.17252223E-05_JPRB, 0.17235164E-05_JPRB, 0.17215020E-05_JPRB, 0.17201377E-05_JPRB, &
  & 0.17195460E-05_JPRB, 0.17191550E-05_JPRB, 0.17187443E-05_JPRB, 0.17185621E-05_JPRB  /)

RGHG2(:,49,10) = (/ &
  & 0.17122287E-05_JPRB, 0.17120570E-05_JPRB, 0.17120152E-05_JPRB, 0.17121463E-05_JPRB, 0.17123132E-05_JPRB, 0.17125444E-05_JPRB, &
  & 0.17126967E-05_JPRB, 0.17128165E-05_JPRB, 0.17127667E-05_JPRB, 0.17125775E-05_JPRB, 0.17126556E-05_JPRB, 0.17129286E-05_JPRB, &
  & 0.17132890E-05_JPRB, 0.17136448E-05_JPRB, 0.17139831E-05_JPRB, 0.17142573E-05_JPRB, 0.17144430E-05_JPRB, 0.17140500E-05_JPRB, &
  & 0.17129862E-05_JPRB, 0.17114734E-05_JPRB, 0.17097159E-05_JPRB, 0.17073205E-05_JPRB, 0.17053010E-05_JPRB, 0.17043331E-05_JPRB, &
  & 0.17041481E-05_JPRB, 0.17033807E-05_JPRB, 0.17030747E-05_JPRB, 0.17036342E-05_JPRB, 0.17053812E-05_JPRB, 0.17079885E-05_JPRB, &
  & 0.17115527E-05_JPRB, 0.17147067E-05_JPRB, 0.17182318E-05_JPRB, 0.17222654E-05_JPRB, 0.17281181E-05_JPRB, 0.17347116E-05_JPRB, &
  & 0.17404993E-05_JPRB, 0.17447608E-05_JPRB, 0.17478749E-05_JPRB, 0.17502528E-05_JPRB, 0.17519946E-05_JPRB, 0.17536562E-05_JPRB, &
  & 0.17532956E-05_JPRB, 0.17521486E-05_JPRB, 0.17514523E-05_JPRB, 0.17497739E-05_JPRB, 0.17478441E-05_JPRB, 0.17460166E-05_JPRB, &
  & 0.17444696E-05_JPRB, 0.17429665E-05_JPRB, 0.17407854E-05_JPRB, 0.17390823E-05_JPRB, 0.17377058E-05_JPRB, 0.17365893E-05_JPRB, &
  & 0.17352152E-05_JPRB, 0.17343382E-05_JPRB, 0.17331698E-05_JPRB, 0.17319828E-05_JPRB, 0.17304859E-05_JPRB, 0.17292199E-05_JPRB, &
  & 0.17286375E-05_JPRB, 0.17283029E-05_JPRB, 0.17281893E-05_JPRB, 0.17283447E-05_JPRB  /)

RGHG2(:,50,10) = (/ &
  & 0.17110681E-05_JPRB, 0.17108175E-05_JPRB, 0.17107591E-05_JPRB, 0.17109025E-05_JPRB, 0.17112227E-05_JPRB, 0.17116280E-05_JPRB, &
  & 0.17119744E-05_JPRB, 0.17123137E-05_JPRB, 0.17124982E-05_JPRB, 0.17125725E-05_JPRB, 0.17127861E-05_JPRB, 0.17131198E-05_JPRB, &
  & 0.17134767E-05_JPRB, 0.17136709E-05_JPRB, 0.17137512E-05_JPRB, 0.17136946E-05_JPRB, 0.17135274E-05_JPRB, 0.17128515E-05_JPRB, &
  & 0.17116219E-05_JPRB, 0.17101022E-05_JPRB, 0.17085648E-05_JPRB, 0.17064571E-05_JPRB, 0.17047401E-05_JPRB, 0.17040701E-05_JPRB, &
  & 0.17039362E-05_JPRB, 0.17033626E-05_JPRB, 0.17031455E-05_JPRB, 0.17037851E-05_JPRB, 0.17055878E-05_JPRB, 0.17081954E-05_JPRB, &
  & 0.17116537E-05_JPRB, 0.17147442E-05_JPRB, 0.17182579E-05_JPRB, 0.17221809E-05_JPRB, 0.17279964E-05_JPRB, 0.17345311E-05_JPRB, &
  & 0.17403922E-05_JPRB, 0.17445917E-05_JPRB, 0.17476175E-05_JPRB, 0.17498513E-05_JPRB, 0.17516715E-05_JPRB, 0.17534140E-05_JPRB, &
  & 0.17534848E-05_JPRB, 0.17526857E-05_JPRB, 0.17522022E-05_JPRB, 0.17511280E-05_JPRB, 0.17499400E-05_JPRB, 0.17485956E-05_JPRB, &
  & 0.17473940E-05_JPRB, 0.17464902E-05_JPRB, 0.17449473E-05_JPRB, 0.17438445E-05_JPRB, 0.17429589E-05_JPRB, 0.17422145E-05_JPRB, &
  & 0.17411682E-05_JPRB, 0.17405261E-05_JPRB, 0.17397087E-05_JPRB, 0.17388072E-05_JPRB, 0.17376563E-05_JPRB, 0.17365405E-05_JPRB, &
  & 0.17360372E-05_JPRB, 0.17357361E-05_JPRB, 0.17358037E-05_JPRB, 0.17361356E-05_JPRB  /)

RGHG2(:,51,10) = (/ &
  & 0.17097902E-05_JPRB, 0.17094596E-05_JPRB, 0.17093829E-05_JPRB, 0.17094988E-05_JPRB, 0.17099077E-05_JPRB, 0.17104035E-05_JPRB, &
  & 0.17108818E-05_JPRB, 0.17113247E-05_JPRB, 0.17116325E-05_JPRB, 0.17119201E-05_JPRB, 0.17122097E-05_JPRB, 0.17125320E-05_JPRB, &
  & 0.17128357E-05_JPRB, 0.17128909E-05_JPRB, 0.17127534E-05_JPRB, 0.17124089E-05_JPRB, 0.17119689E-05_JPRB, 0.17111156E-05_JPRB, &
  & 0.17098174E-05_JPRB, 0.17084056E-05_JPRB, 0.17071820E-05_JPRB, 0.17054703E-05_JPRB, 0.17041104E-05_JPRB, 0.17037883E-05_JPRB, &
  & 0.17036972E-05_JPRB, 0.17033631E-05_JPRB, 0.17032418E-05_JPRB, 0.17039740E-05_JPRB, 0.17058073E-05_JPRB, 0.17084031E-05_JPRB, &
  & 0.17117364E-05_JPRB, 0.17147566E-05_JPRB, 0.17182951E-05_JPRB, 0.17221364E-05_JPRB, 0.17279405E-05_JPRB, 0.17344001E-05_JPRB, &
  & 0.17403363E-05_JPRB, 0.17444672E-05_JPRB, 0.17474257E-05_JPRB, 0.17494781E-05_JPRB, 0.17514195E-05_JPRB, 0.17532690E-05_JPRB, &
  & 0.17538228E-05_JPRB, 0.17534472E-05_JPRB, 0.17531206E-05_JPRB, 0.17526548E-05_JPRB, 0.17522985E-05_JPRB, 0.17514419E-05_JPRB, &
  & 0.17504719E-05_JPRB, 0.17501223E-05_JPRB, 0.17491926E-05_JPRB, 0.17486099E-05_JPRB, 0.17481557E-05_JPRB, 0.17477151E-05_JPRB, &
  & 0.17469809E-05_JPRB, 0.17465569E-05_JPRB, 0.17460411E-05_JPRB, 0.17453258E-05_JPRB, 0.17444589E-05_JPRB, 0.17435328E-05_JPRB, &
  & 0.17431519E-05_JPRB, 0.17428748E-05_JPRB, 0.17430774E-05_JPRB, 0.17435156E-05_JPRB  /)

RGHG2(:,52,10) = (/ &
  & 0.17086905E-05_JPRB, 0.17083406E-05_JPRB, 0.17082625E-05_JPRB, 0.17083367E-05_JPRB, 0.17087548E-05_JPRB, 0.17092250E-05_JPRB, &
  & 0.17096981E-05_JPRB, 0.17101045E-05_JPRB, 0.17104185E-05_JPRB, 0.17107627E-05_JPRB, 0.17110315E-05_JPRB, 0.17113051E-05_JPRB, &
  & 0.17115166E-05_JPRB, 0.17114476E-05_JPRB, 0.17111682E-05_JPRB, 0.17106684E-05_JPRB, 0.17100968E-05_JPRB, 0.17092206E-05_JPRB, &
  & 0.17080187E-05_JPRB, 0.17067794E-05_JPRB, 0.17057945E-05_JPRB, 0.17045305E-05_JPRB, 0.17035031E-05_JPRB, 0.17034105E-05_JPRB, &
  & 0.17033666E-05_JPRB, 0.17032346E-05_JPRB, 0.17033239E-05_JPRB, 0.17041181E-05_JPRB, 0.17059309E-05_JPRB, 0.17083935E-05_JPRB, &
  & 0.17117022E-05_JPRB, 0.17147563E-05_JPRB, 0.17182960E-05_JPRB, 0.17221282E-05_JPRB, 0.17279688E-05_JPRB, 0.17343843E-05_JPRB, &
  & 0.17403602E-05_JPRB, 0.17444604E-05_JPRB, 0.17473747E-05_JPRB, 0.17493171E-05_JPRB, 0.17513749E-05_JPRB, 0.17532902E-05_JPRB, &
  & 0.17543087E-05_JPRB, 0.17543623E-05_JPRB, 0.17541709E-05_JPRB, 0.17540331E-05_JPRB, 0.17542793E-05_JPRB, 0.17538661E-05_JPRB, &
  & 0.17531722E-05_JPRB, 0.17532317E-05_JPRB, 0.17528630E-05_JPRB, 0.17527086E-05_JPRB, 0.17526791E-05_JPRB, 0.17525753E-05_JPRB, &
  & 0.17521613E-05_JPRB, 0.17519714E-05_JPRB, 0.17517393E-05_JPRB, 0.17512591E-05_JPRB, 0.17506214E-05_JPRB, 0.17499103E-05_JPRB, &
  & 0.17496890E-05_JPRB, 0.17495957E-05_JPRB, 0.17499891E-05_JPRB, 0.17505426E-05_JPRB  /)

RGHG2(:,53,10) = (/ &
  & 0.17075614E-05_JPRB, 0.17072138E-05_JPRB, 0.17071408E-05_JPRB, 0.17071643E-05_JPRB, 0.17075616E-05_JPRB, 0.17079595E-05_JPRB, &
  & 0.17083739E-05_JPRB, 0.17086868E-05_JPRB, 0.17089624E-05_JPRB, 0.17093080E-05_JPRB, 0.17095168E-05_JPRB, 0.17097232E-05_JPRB, &
  & 0.17098194E-05_JPRB, 0.17096208E-05_JPRB, 0.17092160E-05_JPRB, 0.17085980E-05_JPRB, 0.17079374E-05_JPRB, 0.17070959E-05_JPRB, &
  & 0.17060623E-05_JPRB, 0.17050356E-05_JPRB, 0.17042818E-05_JPRB, 0.17035250E-05_JPRB, 0.17028505E-05_JPRB, 0.17029621E-05_JPRB, &
  & 0.17029713E-05_JPRB, 0.17030450E-05_JPRB, 0.17034077E-05_JPRB, 0.17042578E-05_JPRB, 0.17060286E-05_JPRB, 0.17082993E-05_JPRB, &
  & 0.17116201E-05_JPRB, 0.17147512E-05_JPRB, 0.17182831E-05_JPRB, 0.17221332E-05_JPRB, 0.17280319E-05_JPRB, 0.17344114E-05_JPRB, &
  & 0.17404169E-05_JPRB, 0.17444981E-05_JPRB, 0.17473732E-05_JPRB, 0.17492235E-05_JPRB, 0.17514062E-05_JPRB, 0.17533773E-05_JPRB, &
  & 0.17548948E-05_JPRB, 0.17554179E-05_JPRB, 0.17553653E-05_JPRB, 0.17554771E-05_JPRB, 0.17562909E-05_JPRB, 0.17563436E-05_JPRB, &
  & 0.17559674E-05_JPRB, 0.17564166E-05_JPRB, 0.17566387E-05_JPRB, 0.17569156E-05_JPRB, 0.17573458E-05_JPRB, 0.17576216E-05_JPRB, &
  & 0.17575596E-05_JPRB, 0.17576306E-05_JPRB, 0.17577006E-05_JPRB, 0.17574953E-05_JPRB, 0.17570859E-05_JPRB, 0.17566188E-05_JPRB, &
  & 0.17565857E-05_JPRB, 0.17567538E-05_JPRB, 0.17573764E-05_JPRB, 0.17580590E-05_JPRB  /)

RGHG2(:,54,10) = (/ &
  & 0.17067151E-05_JPRB, 0.17064002E-05_JPRB, 0.17063388E-05_JPRB, 0.17063506E-05_JPRB, 0.17066833E-05_JPRB, 0.17069716E-05_JPRB, &
  & 0.17072811E-05_JPRB, 0.17074711E-05_JPRB, 0.17076574E-05_JPRB, 0.17079383E-05_JPRB, 0.17080603E-05_JPRB, 0.17081844E-05_JPRB, &
  & 0.17081847E-05_JPRB, 0.17079321E-05_JPRB, 0.17074594E-05_JPRB, 0.17068084E-05_JPRB, 0.17061597E-05_JPRB, 0.17054308E-05_JPRB, &
  & 0.17045581E-05_JPRB, 0.17036897E-05_JPRB, 0.17030434E-05_JPRB, 0.17026200E-05_JPRB, 0.17022214E-05_JPRB, 0.17024787E-05_JPRB, &
  & 0.17025559E-05_JPRB, 0.17027817E-05_JPRB, 0.17033709E-05_JPRB, 0.17042949E-05_JPRB, 0.17059625E-05_JPRB, 0.17080549E-05_JPRB, &
  & 0.17113872E-05_JPRB, 0.17146275E-05_JPRB, 0.17181468E-05_JPRB, 0.17221568E-05_JPRB, 0.17281761E-05_JPRB, 0.17345818E-05_JPRB, &
  & 0.17405920E-05_JPRB, 0.17445899E-05_JPRB, 0.17474577E-05_JPRB, 0.17494039E-05_JPRB, 0.17515573E-05_JPRB, 0.17536062E-05_JPRB, &
  & 0.17554799E-05_JPRB, 0.17563853E-05_JPRB, 0.17565014E-05_JPRB, 0.17567218E-05_JPRB, 0.17577460E-05_JPRB, 0.17580968E-05_JPRB, &
  & 0.17580466E-05_JPRB, 0.17588514E-05_JPRB, 0.17595421E-05_JPRB, 0.17602115E-05_JPRB, 0.17610372E-05_JPRB, 0.17616273E-05_JPRB, &
  & 0.17618585E-05_JPRB, 0.17622234E-05_JPRB, 0.17625702E-05_JPRB, 0.17626270E-05_JPRB, 0.17624337E-05_JPRB, 0.17621995E-05_JPRB, &
  & 0.17623766E-05_JPRB, 0.17627423E-05_JPRB, 0.17635132E-05_JPRB, 0.17642404E-05_JPRB  /)

RGHG2(:,55,10) = (/ &
  & 0.17058149E-05_JPRB, 0.17055400E-05_JPRB, 0.17054924E-05_JPRB, 0.17054963E-05_JPRB, 0.17057517E-05_JPRB, 0.17059137E-05_JPRB, &
  & 0.17061009E-05_JPRB, 0.17061510E-05_JPRB, 0.17062316E-05_JPRB, 0.17064323E-05_JPRB, 0.17064544E-05_JPRB, 0.17064856E-05_JPRB, &
  & 0.17063821E-05_JPRB, 0.17060795E-05_JPRB, 0.17055394E-05_JPRB, 0.17048629E-05_JPRB, 0.17042407E-05_JPRB, 0.17036468E-05_JPRB, &
  & 0.17029512E-05_JPRB, 0.17022512E-05_JPRB, 0.17017076E-05_JPRB, 0.17016307E-05_JPRB, 0.17015277E-05_JPRB, 0.17019386E-05_JPRB, &
  & 0.17020931E-05_JPRB, 0.17024804E-05_JPRB, 0.17033143E-05_JPRB, 0.17043224E-05_JPRB, 0.17058677E-05_JPRB, 0.17077644E-05_JPRB, &
  & 0.17111094E-05_JPRB, 0.17144750E-05_JPRB, 0.17179795E-05_JPRB, 0.17221853E-05_JPRB, 0.17283466E-05_JPRB, 0.17347894E-05_JPRB, &
  & 0.17408015E-05_JPRB, 0.17446986E-05_JPRB, 0.17475625E-05_JPRB, 0.17496399E-05_JPRB, 0.17517404E-05_JPRB, 0.17538784E-05_JPRB, &
  & 0.17561279E-05_JPRB, 0.17574453E-05_JPRB, 0.17577523E-05_JPRB, 0.17580745E-05_JPRB, 0.17592846E-05_JPRB, 0.17599437E-05_JPRB, &
  & 0.17602556E-05_JPRB, 0.17614499E-05_JPRB, 0.17626437E-05_JPRB, 0.17637426E-05_JPRB, 0.17649980E-05_JPRB, 0.17659277E-05_JPRB, &
  & 0.17664760E-05_JPRB, 0.17671707E-05_JPRB, 0.17678209E-05_JPRB, 0.17681665E-05_JPRB, 0.17682110E-05_JPRB, 0.17682331E-05_JPRB, &
  & 0.17686461E-05_JPRB, 0.17692222E-05_JPRB, 0.17701468E-05_JPRB, 0.17709121E-05_JPRB  /)

RGHG2(:,56,10) = (/ &
  & 0.17052709E-05_JPRB, 0.17050433E-05_JPRB, 0.17050012E-05_JPRB, 0.17050020E-05_JPRB, 0.17051960E-05_JPRB, 0.17052828E-05_JPRB, &
  & 0.17053714E-05_JPRB, 0.17053480E-05_JPRB, 0.17053405E-05_JPRB, 0.17054603E-05_JPRB, 0.17054218E-05_JPRB, 0.17053935E-05_JPRB, &
  & 0.17052414E-05_JPRB, 0.17049137E-05_JPRB, 0.17043799E-05_JPRB, 0.17037359E-05_JPRB, 0.17031510E-05_JPRB, 0.17026270E-05_JPRB, &
  & 0.17019688E-05_JPRB, 0.17013533E-05_JPRB, 0.17008325E-05_JPRB, 0.17008209E-05_JPRB, 0.17009098E-05_JPRB, 0.17014521E-05_JPRB, &
  & 0.17016690E-05_JPRB, 0.17021918E-05_JPRB, 0.17031278E-05_JPRB, 0.17041662E-05_JPRB, 0.17054990E-05_JPRB, 0.17073083E-05_JPRB, &
  & 0.17106454E-05_JPRB, 0.17140456E-05_JPRB, 0.17176836E-05_JPRB, 0.17221313E-05_JPRB, 0.17285329E-05_JPRB, 0.17350788E-05_JPRB, &
  & 0.17410990E-05_JPRB, 0.17448164E-05_JPRB, 0.17477571E-05_JPRB, 0.17499383E-05_JPRB, 0.17518176E-05_JPRB, 0.17541305E-05_JPRB, &
  & 0.17566172E-05_JPRB, 0.17582217E-05_JPRB, 0.17585894E-05_JPRB, 0.17589971E-05_JPRB, 0.17602269E-05_JPRB, 0.17609509E-05_JPRB, &
  & 0.17616648E-05_JPRB, 0.17632012E-05_JPRB, 0.17647438E-05_JPRB, 0.17661893E-05_JPRB, 0.17676449E-05_JPRB, 0.17688331E-05_JPRB, &
  & 0.17696176E-05_JPRB, 0.17704456E-05_JPRB, 0.17712523E-05_JPRB, 0.17717425E-05_JPRB, 0.17720227E-05_JPRB, 0.17722448E-05_JPRB, &
  & 0.17728028E-05_JPRB, 0.17734269E-05_JPRB, 0.17741693E-05_JPRB, 0.17747940E-05_JPRB  /)

RGHG2(:,57,10) = (/ &
  & 0.17047371E-05_JPRB, 0.17045590E-05_JPRB, 0.17045200E-05_JPRB, 0.17045144E-05_JPRB, 0.17046531E-05_JPRB, 0.17046744E-05_JPRB, &
  & 0.17046753E-05_JPRB, 0.17045852E-05_JPRB, 0.17045002E-05_JPRB, 0.17045463E-05_JPRB, 0.17044485E-05_JPRB, 0.17043689E-05_JPRB, &
  & 0.17041668E-05_JPRB, 0.17038137E-05_JPRB, 0.17032814E-05_JPRB, 0.17026635E-05_JPRB, 0.17021057E-05_JPRB, 0.17016491E-05_JPRB, &
  & 0.17010186E-05_JPRB, 0.17004650E-05_JPRB, 0.16999525E-05_JPRB, 0.16999953E-05_JPRB, 0.17002872E-05_JPRB, 0.17009121E-05_JPRB, &
  & 0.17012064E-05_JPRB, 0.17018036E-05_JPRB, 0.17028690E-05_JPRB, 0.17039541E-05_JPRB, 0.17051372E-05_JPRB, 0.17068588E-05_JPRB, &
  & 0.17101417E-05_JPRB, 0.17135765E-05_JPRB, 0.17173300E-05_JPRB, 0.17220067E-05_JPRB, 0.17286538E-05_JPRB, 0.17353718E-05_JPRB, &
  & 0.17413528E-05_JPRB, 0.17449433E-05_JPRB, 0.17479913E-05_JPRB, 0.17501964E-05_JPRB, 0.17518730E-05_JPRB, 0.17543911E-05_JPRB, &
  & 0.17571380E-05_JPRB, 0.17589926E-05_JPRB, 0.17593740E-05_JPRB, 0.17598850E-05_JPRB, 0.17611456E-05_JPRB, 0.17619623E-05_JPRB, &
  & 0.17630866E-05_JPRB, 0.17649714E-05_JPRB, 0.17668623E-05_JPRB, 0.17686741E-05_JPRB, 0.17703295E-05_JPRB, 0.17717599E-05_JPRB, &
  & 0.17727701E-05_JPRB, 0.17737313E-05_JPRB, 0.17746674E-05_JPRB, 0.17753243E-05_JPRB, 0.17758558E-05_JPRB, 0.17762683E-05_JPRB, &
  & 0.17769641E-05_JPRB, 0.17776374E-05_JPRB, 0.17782261E-05_JPRB, 0.17787379E-05_JPRB  /)

RGHG2(:,58,10) = (/ &
  & 0.17043302E-05_JPRB, 0.17042029E-05_JPRB, 0.17041608E-05_JPRB, 0.17041451E-05_JPRB, 0.17042462E-05_JPRB, 0.17042330E-05_JPRB, &
  & 0.17041759E-05_JPRB, 0.17040482E-05_JPRB, 0.17039135E-05_JPRB, 0.17039037E-05_JPRB, 0.17037612E-05_JPRB, 0.17036541E-05_JPRB, &
  & 0.17034145E-05_JPRB, 0.17030421E-05_JPRB, 0.17025169E-05_JPRB, 0.17019234E-05_JPRB, 0.17013747E-05_JPRB, 0.17009639E-05_JPRB, &
  & 0.17003161E-05_JPRB, 0.16997655E-05_JPRB, 0.16992215E-05_JPRB, 0.16992430E-05_JPRB, 0.16997208E-05_JPRB, 0.17003356E-05_JPRB, &
  & 0.17007233E-05_JPRB, 0.17012809E-05_JPRB, 0.17024844E-05_JPRB, 0.17036305E-05_JPRB, 0.17047648E-05_JPRB, 0.17064254E-05_JPRB, &
  & 0.17095763E-05_JPRB, 0.17130264E-05_JPRB, 0.17168835E-05_JPRB, 0.17217572E-05_JPRB, 0.17286573E-05_JPRB, 0.17356628E-05_JPRB, &
  & 0.17415290E-05_JPRB, 0.17450768E-05_JPRB, 0.17482904E-05_JPRB, 0.17503777E-05_JPRB, 0.17518674E-05_JPRB, 0.17546414E-05_JPRB, &
  & 0.17576403E-05_JPRB, 0.17596391E-05_JPRB, 0.17599291E-05_JPRB, 0.17605620E-05_JPRB, 0.17618388E-05_JPRB, 0.17627419E-05_JPRB, &
  & 0.17642654E-05_JPRB, 0.17664723E-05_JPRB, 0.17686537E-05_JPRB, 0.17708200E-05_JPRB, 0.17726157E-05_JPRB, 0.17742258E-05_JPRB, &
  & 0.17754108E-05_JPRB, 0.17764573E-05_JPRB, 0.17774391E-05_JPRB, 0.17782596E-05_JPRB, 0.17790481E-05_JPRB, 0.17796088E-05_JPRB, &
  & 0.17804022E-05_JPRB, 0.17810928E-05_JPRB, 0.17815250E-05_JPRB, 0.17819464E-05_JPRB  /)

RGHG2(:,59,10) = (/ &
  & 0.17040297E-05_JPRB, 0.17039436E-05_JPRB, 0.17039024E-05_JPRB, 0.17038764E-05_JPRB, 0.17039520E-05_JPRB, 0.17039227E-05_JPRB, &
  & 0.17038346E-05_JPRB, 0.17036901E-05_JPRB, 0.17035349E-05_JPRB, 0.17034921E-05_JPRB, 0.17033343E-05_JPRB, 0.17032128E-05_JPRB, &
  & 0.17029453E-05_JPRB, 0.17025534E-05_JPRB, 0.17020260E-05_JPRB, 0.17014485E-05_JPRB, 0.17009067E-05_JPRB, 0.17005138E-05_JPRB, &
  & 0.16998272E-05_JPRB, 0.16992521E-05_JPRB, 0.16986486E-05_JPRB, 0.16985555E-05_JPRB, 0.16991317E-05_JPRB, 0.16997110E-05_JPRB, &
  & 0.17001911E-05_JPRB, 0.17007369E-05_JPRB, 0.17020686E-05_JPRB, 0.17032284E-05_JPRB, 0.17043574E-05_JPRB, 0.17060059E-05_JPRB, &
  & 0.17090639E-05_JPRB, 0.17124979E-05_JPRB, 0.17164648E-05_JPRB, 0.17215185E-05_JPRB, 0.17286245E-05_JPRB, 0.17359236E-05_JPRB, &
  & 0.17416838E-05_JPRB, 0.17454273E-05_JPRB, 0.17486580E-05_JPRB, 0.17504722E-05_JPRB, 0.17519112E-05_JPRB, 0.17548958E-05_JPRB, &
  & 0.17579781E-05_JPRB, 0.17601365E-05_JPRB, 0.17602881E-05_JPRB, 0.17610090E-05_JPRB, 0.17623000E-05_JPRB, 0.17633781E-05_JPRB, &
  & 0.17652312E-05_JPRB, 0.17677503E-05_JPRB, 0.17701812E-05_JPRB, 0.17726508E-05_JPRB, 0.17745475E-05_JPRB, 0.17762862E-05_JPRB, &
  & 0.17775844E-05_JPRB, 0.17786834E-05_JPRB, 0.17796974E-05_JPRB, 0.17806592E-05_JPRB, 0.17816088E-05_JPRB, 0.17822812E-05_JPRB, &
  & 0.17831844E-05_JPRB, 0.17839588E-05_JPRB, 0.17843160E-05_JPRB, 0.17847223E-05_JPRB  /)

RGHG2(:,60,10) = (/ &
  & 0.17037719E-05_JPRB, 0.17037234E-05_JPRB, 0.17036857E-05_JPRB, 0.17036509E-05_JPRB, 0.17037034E-05_JPRB, 0.17036635E-05_JPRB, &
  & 0.17035560E-05_JPRB, 0.17034047E-05_JPRB, 0.17032415E-05_JPRB, 0.17031741E-05_JPRB, 0.17030121E-05_JPRB, 0.17028809E-05_JPRB, &
  & 0.17025906E-05_JPRB, 0.17021801E-05_JPRB, 0.17016463E-05_JPRB, 0.17010836E-05_JPRB, 0.17005445E-05_JPRB, 0.17001551E-05_JPRB, &
  & 0.16994218E-05_JPRB, 0.16988108E-05_JPRB, 0.16981339E-05_JPRB, 0.16978842E-05_JPRB, 0.16984953E-05_JPRB, 0.16990329E-05_JPRB, &
  & 0.16995947E-05_JPRB, 0.17001654E-05_JPRB, 0.17016003E-05_JPRB, 0.17027496E-05_JPRB, 0.17038870E-05_JPRB, 0.17055746E-05_JPRB, &
  & 0.17085730E-05_JPRB, 0.17119885E-05_JPRB, 0.17160601E-05_JPRB, 0.17212820E-05_JPRB, 0.17285790E-05_JPRB, 0.17361901E-05_JPRB, &
  & 0.17418846E-05_JPRB, 0.17458732E-05_JPRB, 0.17490404E-05_JPRB, 0.17505417E-05_JPRB, 0.17520076E-05_JPRB, 0.17551637E-05_JPRB, &
  & 0.17582406E-05_JPRB, 0.17605483E-05_JPRB, 0.17605677E-05_JPRB, 0.17613612E-05_JPRB, 0.17626792E-05_JPRB, 0.17639794E-05_JPRB, &
  & 0.17661356E-05_JPRB, 0.17689730E-05_JPRB, 0.17716535E-05_JPRB, 0.17743959E-05_JPRB, 0.17763872E-05_JPRB, 0.17782319E-05_JPRB, &
  & 0.17796208E-05_JPRB, 0.17807658E-05_JPRB, 0.17818174E-05_JPRB, 0.17829055E-05_JPRB, 0.17839743E-05_JPRB, 0.17847451E-05_JPRB, &
  & 0.17857708E-05_JPRB, 0.17866671E-05_JPRB, 0.17869968E-05_JPRB, 0.17874131E-05_JPRB  /)

RGHG2(:,61,10) = (/ &
  & 0.17035951E-05_JPRB, 0.17035752E-05_JPRB, 0.17035463E-05_JPRB, 0.17035104E-05_JPRB, 0.17035375E-05_JPRB, 0.17034877E-05_JPRB, &
  & 0.17033781E-05_JPRB, 0.17032356E-05_JPRB, 0.17030789E-05_JPRB, 0.17029962E-05_JPRB, 0.17028385E-05_JPRB, 0.17027018E-05_JPRB, &
  & 0.17024005E-05_JPRB, 0.17019790E-05_JPRB, 0.17014354E-05_JPRB, 0.17008903E-05_JPRB, 0.17003390E-05_JPRB, 0.16999286E-05_JPRB, &
  & 0.16991513E-05_JPRB, 0.16984985E-05_JPRB, 0.16977390E-05_JPRB, 0.16973053E-05_JPRB, 0.16977963E-05_JPRB, 0.16983065E-05_JPRB, &
  & 0.16988947E-05_JPRB, 0.16996009E-05_JPRB, 0.17010324E-05_JPRB, 0.17021343E-05_JPRB, 0.17032795E-05_JPRB, 0.17051466E-05_JPRB, &
  & 0.17081814E-05_JPRB, 0.17116112E-05_JPRB, 0.17157422E-05_JPRB, 0.17210787E-05_JPRB, 0.17285354E-05_JPRB, 0.17364747E-05_JPRB, &
  & 0.17422684E-05_JPRB, 0.17463616E-05_JPRB, 0.17493338E-05_JPRB, 0.17506083E-05_JPRB, 0.17522405E-05_JPRB, 0.17554384E-05_JPRB, &
  & 0.17583622E-05_JPRB, 0.17607338E-05_JPRB, 0.17607267E-05_JPRB, 0.17615610E-05_JPRB, 0.17629572E-05_JPRB, 0.17645240E-05_JPRB, &
  & 0.17669137E-05_JPRB, 0.17700562E-05_JPRB, 0.17729988E-05_JPRB, 0.17759109E-05_JPRB, 0.17780046E-05_JPRB, 0.17799110E-05_JPRB, &
  & 0.17813627E-05_JPRB, 0.17825605E-05_JPRB, 0.17836838E-05_JPRB, 0.17848445E-05_JPRB, 0.17859640E-05_JPRB, 0.17868097E-05_JPRB, &
  & 0.17879742E-05_JPRB, 0.17890445E-05_JPRB, 0.17894414E-05_JPRB, 0.17898732E-05_JPRB  /)

RGHG2(:,62,10) = (/ &
  & 0.17034652E-05_JPRB, 0.17034634E-05_JPRB, 0.17034461E-05_JPRB, 0.17034172E-05_JPRB, 0.17034223E-05_JPRB, 0.17033557E-05_JPRB, &
  & 0.17032471E-05_JPRB, 0.17031210E-05_JPRB, 0.17029736E-05_JPRB, 0.17028790E-05_JPRB, 0.17027251E-05_JPRB, 0.17025843E-05_JPRB, &
  & 0.17022839E-05_JPRB, 0.17018486E-05_JPRB, 0.17012947E-05_JPRB, 0.17007751E-05_JPRB, 0.17002122E-05_JPRB, 0.16997778E-05_JPRB, &
  & 0.16989770E-05_JPRB, 0.16982630E-05_JPRB, 0.16974191E-05_JPRB, 0.16968014E-05_JPRB, 0.16971310E-05_JPRB, 0.16975295E-05_JPRB, &
  & 0.16981768E-05_JPRB, 0.16989690E-05_JPRB, 0.17002780E-05_JPRB, 0.17013001E-05_JPRB, 0.17025250E-05_JPRB, 0.17046311E-05_JPRB, &
  & 0.17080003E-05_JPRB, 0.17115150E-05_JPRB, 0.17155541E-05_JPRB, 0.17208188E-05_JPRB, 0.17285145E-05_JPRB, 0.17368578E-05_JPRB, &
  & 0.17426795E-05_JPRB, 0.17466581E-05_JPRB, 0.17495653E-05_JPRB, 0.17508511E-05_JPRB, 0.17525277E-05_JPRB, 0.17557296E-05_JPRB, &
  & 0.17585322E-05_JPRB, 0.17608026E-05_JPRB, 0.17608457E-05_JPRB, 0.17617171E-05_JPRB, 0.17631956E-05_JPRB, 0.17650456E-05_JPRB, &
  & 0.17676746E-05_JPRB, 0.17711434E-05_JPRB, 0.17742962E-05_JPRB, 0.17773139E-05_JPRB, 0.17795215E-05_JPRB, 0.17814704E-05_JPRB, &
  & 0.17829991E-05_JPRB, 0.17842751E-05_JPRB, 0.17854910E-05_JPRB, 0.17867447E-05_JPRB, 0.17878659E-05_JPRB, 0.17887758E-05_JPRB, &
  & 0.17900689E-05_JPRB, 0.17912772E-05_JPRB, 0.17917556E-05_JPRB, 0.17921878E-05_JPRB  /)

RGHG2(:,63,10) = (/ &
  & 0.17033625E-05_JPRB, 0.17033707E-05_JPRB, 0.17033646E-05_JPRB, 0.17033484E-05_JPRB, 0.17033350E-05_JPRB, 0.17032502E-05_JPRB, &
  & 0.17031428E-05_JPRB, 0.17030372E-05_JPRB, 0.17028994E-05_JPRB, 0.17027952E-05_JPRB, 0.17026462E-05_JPRB, 0.17025037E-05_JPRB, &
  & 0.17022119E-05_JPRB, 0.17017623E-05_JPRB, 0.17011978E-05_JPRB, 0.17007063E-05_JPRB, 0.17001341E-05_JPRB, 0.16996807E-05_JPRB, &
  & 0.16988712E-05_JPRB, 0.16980787E-05_JPRB, 0.16971339E-05_JPRB, 0.16963445E-05_JPRB, 0.16964913E-05_JPRB, 0.16967302E-05_JPRB, &
  & 0.16974351E-05_JPRB, 0.16982275E-05_JPRB, 0.16993535E-05_JPRB, 0.17002814E-05_JPRB, 0.17016260E-05_JPRB, 0.17040362E-05_JPRB, &
  & 0.17078492E-05_JPRB, 0.17114981E-05_JPRB, 0.17153405E-05_JPRB, 0.17204680E-05_JPRB, 0.17284526E-05_JPRB, 0.17372707E-05_JPRB, &
  & 0.17430470E-05_JPRB, 0.17467740E-05_JPRB, 0.17497354E-05_JPRB, 0.17511740E-05_JPRB, 0.17528187E-05_JPRB, 0.17559993E-05_JPRB, &
  & 0.17587210E-05_JPRB, 0.17607949E-05_JPRB, 0.17609246E-05_JPRB, 0.17618361E-05_JPRB, 0.17634080E-05_JPRB, 0.17655731E-05_JPRB, &
  & 0.17684683E-05_JPRB, 0.17722594E-05_JPRB, 0.17755806E-05_JPRB, 0.17786829E-05_JPRB, 0.17809914E-05_JPRB, 0.17829809E-05_JPRB, &
  & 0.17846019E-05_JPRB, 0.17859736E-05_JPRB, 0.17872860E-05_JPRB, 0.17886613E-05_JPRB, 0.17897479E-05_JPRB, 0.17907104E-05_JPRB, &
  & 0.17921285E-05_JPRB, 0.17934368E-05_JPRB, 0.17940046E-05_JPRB, 0.17944399E-05_JPRB  /)

RGHG2(:,64,10) = (/ &
  & 0.17032835E-05_JPRB, 0.17032917E-05_JPRB, 0.17032928E-05_JPRB, 0.17032947E-05_JPRB, 0.17032693E-05_JPRB, 0.17031700E-05_JPRB, &
  & 0.17030615E-05_JPRB, 0.17029775E-05_JPRB, 0.17028469E-05_JPRB, 0.17027355E-05_JPRB, 0.17025949E-05_JPRB, 0.17024548E-05_JPRB, &
  & 0.17021787E-05_JPRB, 0.17017170E-05_JPRB, 0.17011417E-05_JPRB, 0.17006755E-05_JPRB, 0.17000996E-05_JPRB, 0.16996438E-05_JPRB, &
  & 0.16988416E-05_JPRB, 0.16979504E-05_JPRB, 0.16968694E-05_JPRB, 0.16959463E-05_JPRB, 0.16959063E-05_JPRB, 0.16959586E-05_JPRB, &
  & 0.16966815E-05_JPRB, 0.16973113E-05_JPRB, 0.16982325E-05_JPRB, 0.16990676E-05_JPRB, 0.17005532E-05_JPRB, 0.17033561E-05_JPRB, &
  & 0.17075631E-05_JPRB, 0.17113915E-05_JPRB, 0.17149386E-05_JPRB, 0.17199625E-05_JPRB, 0.17282676E-05_JPRB, 0.17376411E-05_JPRB, &
  & 0.17432631E-05_JPRB, 0.17466324E-05_JPRB, 0.17498094E-05_JPRB, 0.17515034E-05_JPRB, 0.17530517E-05_JPRB, 0.17561878E-05_JPRB, &
  & 0.17588998E-05_JPRB, 0.17607172E-05_JPRB, 0.17609420E-05_JPRB, 0.17619028E-05_JPRB, 0.17635881E-05_JPRB, 0.17661182E-05_JPRB, &
  & 0.17693302E-05_JPRB, 0.17733996E-05_JPRB, 0.17768316E-05_JPRB, 0.17800278E-05_JPRB, 0.17823893E-05_JPRB, 0.17844330E-05_JPRB, &
  & 0.17861661E-05_JPRB, 0.17876474E-05_JPRB, 0.17890405E-05_JPRB, 0.17905833E-05_JPRB, 0.17915964E-05_JPRB, 0.17925915E-05_JPRB, &
  & 0.17941312E-05_JPRB, 0.17954781E-05_JPRB, 0.17961362E-05_JPRB, 0.17965968E-05_JPRB  /)

RGHG2(:,65,10) = (/ &
  & 0.17032184E-05_JPRB, 0.17032210E-05_JPRB, 0.17032226E-05_JPRB, 0.17032394E-05_JPRB, 0.17032086E-05_JPRB, 0.17031036E-05_JPRB, &
  & 0.17029939E-05_JPRB, 0.17029239E-05_JPRB, 0.17028039E-05_JPRB, 0.17026931E-05_JPRB, 0.17025622E-05_JPRB, 0.17024301E-05_JPRB, &
  & 0.17021675E-05_JPRB, 0.17017061E-05_JPRB, 0.17011321E-05_JPRB, 0.17006713E-05_JPRB, 0.17001097E-05_JPRB, 0.16996593E-05_JPRB, &
  & 0.16988643E-05_JPRB, 0.16978512E-05_JPRB, 0.16966218E-05_JPRB, 0.16955786E-05_JPRB, 0.16953538E-05_JPRB, 0.16952908E-05_JPRB, &
  & 0.16958783E-05_JPRB, 0.16961794E-05_JPRB, 0.16968942E-05_JPRB, 0.16975709E-05_JPRB, 0.16992029E-05_JPRB, 0.17024027E-05_JPRB, &
  & 0.17069034E-05_JPRB, 0.17106335E-05_JPRB, 0.17140694E-05_JPRB, 0.17190797E-05_JPRB, 0.17277301E-05_JPRB, 0.17377394E-05_JPRB, &
  & 0.17431130E-05_JPRB, 0.17463853E-05_JPRB, 0.17495901E-05_JPRB, 0.17516155E-05_JPRB, 0.17531843E-05_JPRB, 0.17563047E-05_JPRB, &
  & 0.17589431E-05_JPRB, 0.17604514E-05_JPRB, 0.17607474E-05_JPRB, 0.17618265E-05_JPRB, 0.17637177E-05_JPRB, 0.17667266E-05_JPRB, &
  & 0.17702927E-05_JPRB, 0.17745225E-05_JPRB, 0.17780908E-05_JPRB, 0.17814143E-05_JPRB, 0.17837911E-05_JPRB, 0.17858210E-05_JPRB, &
  & 0.17876882E-05_JPRB, 0.17892733E-05_JPRB, 0.17907443E-05_JPRB, 0.17924502E-05_JPRB, 0.17933949E-05_JPRB, 0.17944216E-05_JPRB, &
  & 0.17959786E-05_JPRB, 0.17973183E-05_JPRB, 0.17980720E-05_JPRB, 0.17985245E-05_JPRB  /)

RGHG2(:,66,10) = (/ &
  & 0.17031574E-05_JPRB, 0.17031567E-05_JPRB, 0.17031576E-05_JPRB, 0.17031835E-05_JPRB, 0.17031513E-05_JPRB, 0.17030422E-05_JPRB, &
  & 0.17029340E-05_JPRB, 0.17028733E-05_JPRB, 0.17027645E-05_JPRB, 0.17026605E-05_JPRB, 0.17025387E-05_JPRB, 0.17024138E-05_JPRB, &
  & 0.17021556E-05_JPRB, 0.17017081E-05_JPRB, 0.17011437E-05_JPRB, 0.17006774E-05_JPRB, 0.17001424E-05_JPRB, 0.16996854E-05_JPRB, &
  & 0.16989014E-05_JPRB, 0.16977633E-05_JPRB, 0.16964157E-05_JPRB, 0.16952172E-05_JPRB, 0.16947996E-05_JPRB, 0.16946095E-05_JPRB, &
  & 0.16949762E-05_JPRB, 0.16949393E-05_JPRB, 0.16954780E-05_JPRB, 0.16959834E-05_JPRB, 0.16976783E-05_JPRB, 0.17011853E-05_JPRB, &
  & 0.17059133E-05_JPRB, 0.17096000E-05_JPRB, 0.17130220E-05_JPRB, 0.17180085E-05_JPRB, 0.17270548E-05_JPRB, 0.17375898E-05_JPRB, &
  & 0.17427057E-05_JPRB, 0.17459758E-05_JPRB, 0.17490615E-05_JPRB, 0.17514659E-05_JPRB, 0.17532909E-05_JPRB, 0.17563666E-05_JPRB, &
  & 0.17587964E-05_JPRB, 0.17600175E-05_JPRB, 0.17603992E-05_JPRB, 0.17616922E-05_JPRB, 0.17638969E-05_JPRB, 0.17674418E-05_JPRB, &
  & 0.17713317E-05_JPRB, 0.17756753E-05_JPRB, 0.17794003E-05_JPRB, 0.17828442E-05_JPRB, 0.17852290E-05_JPRB, 0.17872315E-05_JPRB, &
  & 0.17892055E-05_JPRB, 0.17908861E-05_JPRB, 0.17924621E-05_JPRB, 0.17943061E-05_JPRB, 0.17951769E-05_JPRB, 0.17962222E-05_JPRB, &
  & 0.17976881E-05_JPRB, 0.17989964E-05_JPRB, 0.17998579E-05_JPRB, 0.18002428E-05_JPRB  /)

RGHG2(:,67,10) = (/ &
  & 0.17031017E-05_JPRB, 0.17031009E-05_JPRB, 0.17031009E-05_JPRB, 0.17031300E-05_JPRB, 0.17030996E-05_JPRB, 0.17029883E-05_JPRB, &
  & 0.17028823E-05_JPRB, 0.17028281E-05_JPRB, 0.17027292E-05_JPRB, 0.17026373E-05_JPRB, 0.17025244E-05_JPRB, 0.17024028E-05_JPRB, &
  & 0.17021415E-05_JPRB, 0.17017199E-05_JPRB, 0.17011698E-05_JPRB, 0.17006949E-05_JPRB, 0.17001943E-05_JPRB, 0.16997201E-05_JPRB, &
  & 0.16989446E-05_JPRB, 0.16976975E-05_JPRB, 0.16962565E-05_JPRB, 0.16948732E-05_JPRB, 0.16942644E-05_JPRB, 0.16939085E-05_JPRB, &
  & 0.16940116E-05_JPRB, 0.16936515E-05_JPRB, 0.16939913E-05_JPRB, 0.16943318E-05_JPRB, 0.16960534E-05_JPRB, 0.16997486E-05_JPRB, &
  & 0.17046589E-05_JPRB, 0.17084417E-05_JPRB, 0.17118899E-05_JPRB, 0.17168548E-05_JPRB, 0.17263123E-05_JPRB, 0.17372033E-05_JPRB, &
  & 0.17420984E-05_JPRB, 0.17454164E-05_JPRB, 0.17482949E-05_JPRB, 0.17510796E-05_JPRB, 0.17533326E-05_JPRB, 0.17563277E-05_JPRB, &
  & 0.17584433E-05_JPRB, 0.17594363E-05_JPRB, 0.17599338E-05_JPRB, 0.17615370E-05_JPRB, 0.17641522E-05_JPRB, 0.17682517E-05_JPRB, &
  & 0.17724328E-05_JPRB, 0.17768699E-05_JPRB, 0.17807645E-05_JPRB, 0.17843100E-05_JPRB, 0.17867037E-05_JPRB, 0.17886811E-05_JPRB, &
  & 0.17907256E-05_JPRB, 0.17924864E-05_JPRB, 0.17941862E-05_JPRB, 0.17961327E-05_JPRB, 0.17969106E-05_JPRB, 0.17979568E-05_JPRB, &
  & 0.17992437E-05_JPRB, 0.18005123E-05_JPRB, 0.18014810E-05_JPRB, 0.18017467E-05_JPRB  /)

RGHG2(:,68,10) = (/ &
  & 0.17030543E-05_JPRB, 0.17030573E-05_JPRB, 0.17030573E-05_JPRB, 0.17030838E-05_JPRB, 0.17030572E-05_JPRB, 0.17029483E-05_JPRB, &
  & 0.17028399E-05_JPRB, 0.17027931E-05_JPRB, 0.17027004E-05_JPRB, 0.17026233E-05_JPRB, 0.17025203E-05_JPRB, 0.17023925E-05_JPRB, &
  & 0.17021263E-05_JPRB, 0.17017381E-05_JPRB, 0.17012003E-05_JPRB, 0.17007292E-05_JPRB, 0.17002619E-05_JPRB, 0.16997667E-05_JPRB, &
  & 0.16989838E-05_JPRB, 0.16976786E-05_JPRB, 0.16961460E-05_JPRB, 0.16945698E-05_JPRB, 0.16937915E-05_JPRB, 0.16931882E-05_JPRB, &
  & 0.16930637E-05_JPRB, 0.16924117E-05_JPRB, 0.16924064E-05_JPRB, 0.16926157E-05_JPRB, 0.16944524E-05_JPRB, 0.16981798E-05_JPRB, &
  & 0.17032731E-05_JPRB, 0.17074035E-05_JPRB, 0.17108084E-05_JPRB, 0.17158005E-05_JPRB, 0.17256068E-05_JPRB, 0.17366067E-05_JPRB, &
  & 0.17413967E-05_JPRB, 0.17447455E-05_JPRB, 0.17474509E-05_JPRB, 0.17505263E-05_JPRB, 0.17532134E-05_JPRB, 0.17560885E-05_JPRB, &
  & 0.17578640E-05_JPRB, 0.17587494E-05_JPRB, 0.17594188E-05_JPRB, 0.17614240E-05_JPRB, 0.17645217E-05_JPRB, 0.17691283E-05_JPRB, &
  & 0.17735816E-05_JPRB, 0.17781374E-05_JPRB, 0.17822015E-05_JPRB, 0.17858138E-05_JPRB, 0.17882285E-05_JPRB, 0.17902071E-05_JPRB, &
  & 0.17922789E-05_JPRB, 0.17940916E-05_JPRB, 0.17959114E-05_JPRB, 0.17979086E-05_JPRB, 0.17985467E-05_JPRB, 0.17995694E-05_JPRB, &
  & 0.18006362E-05_JPRB, 0.18018887E-05_JPRB, 0.18029353E-05_JPRB, 0.18030538E-05_JPRB  /)

RGHG2(:,69,10) = (/ &
  & 0.17030192E-05_JPRB, 0.17030270E-05_JPRB, 0.17030270E-05_JPRB, 0.17030465E-05_JPRB, 0.17030225E-05_JPRB, 0.17029228E-05_JPRB, &
  & 0.17028119E-05_JPRB, 0.17027703E-05_JPRB, 0.17026736E-05_JPRB, 0.17026092E-05_JPRB, 0.17025139E-05_JPRB, 0.17023787E-05_JPRB, &
  & 0.17021233E-05_JPRB, 0.17017628E-05_JPRB, 0.17012419E-05_JPRB, 0.17007621E-05_JPRB, 0.17003249E-05_JPRB, 0.16998323E-05_JPRB, &
  & 0.16990329E-05_JPRB, 0.16977046E-05_JPRB, 0.16960782E-05_JPRB, 0.16943721E-05_JPRB, 0.16934188E-05_JPRB, 0.16925162E-05_JPRB, &
  & 0.16922273E-05_JPRB, 0.16913667E-05_JPRB, 0.16908734E-05_JPRB, 0.16909133E-05_JPRB, 0.16928752E-05_JPRB, 0.16966977E-05_JPRB, &
  & 0.17021115E-05_JPRB, 0.17065500E-05_JPRB, 0.17098789E-05_JPRB, 0.17148577E-05_JPRB, 0.17247696E-05_JPRB, 0.17358716E-05_JPRB, &
  & 0.17407782E-05_JPRB, 0.17443235E-05_JPRB, 0.17469841E-05_JPRB, 0.17501688E-05_JPRB, 0.17530593E-05_JPRB, 0.17557795E-05_JPRB, &
  & 0.17572295E-05_JPRB, 0.17581143E-05_JPRB, 0.17590535E-05_JPRB, 0.17614843E-05_JPRB, 0.17650553E-05_JPRB, 0.17700857E-05_JPRB, &
  & 0.17748088E-05_JPRB, 0.17795577E-05_JPRB, 0.17837743E-05_JPRB, 0.17873836E-05_JPRB, 0.17898407E-05_JPRB, 0.17918464E-05_JPRB, &
  & 0.17939319E-05_JPRB, 0.17957470E-05_JPRB, 0.17976541E-05_JPRB, 0.17995974E-05_JPRB, 0.18000495E-05_JPRB, 0.18010499E-05_JPRB, &
  & 0.18019595E-05_JPRB, 0.18031971E-05_JPRB, 0.18042574E-05_JPRB, 0.18042885E-05_JPRB  /)

RGHG2(:,70,10) = (/ &
  & 0.17029907E-05_JPRB, 0.17030035E-05_JPRB, 0.17030064E-05_JPRB, 0.17030185E-05_JPRB, 0.17029926E-05_JPRB, 0.17029072E-05_JPRB, &
  & 0.17027967E-05_JPRB, 0.17027557E-05_JPRB, 0.17026526E-05_JPRB, 0.17025963E-05_JPRB, 0.17025084E-05_JPRB, 0.17023715E-05_JPRB, &
  & 0.17021314E-05_JPRB, 0.17017982E-05_JPRB, 0.17012961E-05_JPRB, 0.17007963E-05_JPRB, 0.17003845E-05_JPRB, 0.16999127E-05_JPRB, &
  & 0.16991046E-05_JPRB, 0.16977564E-05_JPRB, 0.16960689E-05_JPRB, 0.16942504E-05_JPRB, 0.16931053E-05_JPRB, 0.16919497E-05_JPRB, &
  & 0.16915021E-05_JPRB, 0.16904608E-05_JPRB, 0.16894989E-05_JPRB, 0.16893524E-05_JPRB, 0.16912840E-05_JPRB, 0.16953189E-05_JPRB, &
  & 0.17009507E-05_JPRB, 0.17056251E-05_JPRB, 0.17089624E-05_JPRB, 0.17138376E-05_JPRB, 0.17237939E-05_JPRB, 0.17352333E-05_JPRB, &
  & 0.17403693E-05_JPRB, 0.17441234E-05_JPRB, 0.17468768E-05_JPRB, 0.17500929E-05_JPRB, 0.17531082E-05_JPRB, 0.17557288E-05_JPRB, &
  & 0.17567851E-05_JPRB, 0.17576510E-05_JPRB, 0.17589149E-05_JPRB, 0.17617630E-05_JPRB, 0.17657297E-05_JPRB, 0.17711491E-05_JPRB, &
  & 0.17761610E-05_JPRB, 0.17811337E-05_JPRB, 0.17854454E-05_JPRB, 0.17890089E-05_JPRB, 0.17915163E-05_JPRB, 0.17935691E-05_JPRB, &
  & 0.17956597E-05_JPRB, 0.17974666E-05_JPRB, 0.17994134E-05_JPRB, 0.18012620E-05_JPRB, 0.18015047E-05_JPRB, 0.18024382E-05_JPRB, &
  & 0.18032829E-05_JPRB, 0.18044725E-05_JPRB, 0.18054943E-05_JPRB, 0.18054651E-05_JPRB  /)

RGHG2(:,71,10) = (/ &
  & 0.17029691E-05_JPRB, 0.17029849E-05_JPRB, 0.17029940E-05_JPRB, 0.17029999E-05_JPRB, 0.17029691E-05_JPRB, 0.17029010E-05_JPRB, &
  & 0.17027936E-05_JPRB, 0.17027496E-05_JPRB, 0.17026390E-05_JPRB, 0.17025857E-05_JPRB, 0.17025053E-05_JPRB, 0.17023703E-05_JPRB, &
  & 0.17021469E-05_JPRB, 0.17018428E-05_JPRB, 0.17013618E-05_JPRB, 0.17008391E-05_JPRB, 0.17004471E-05_JPRB, 0.17000069E-05_JPRB, &
  & 0.16992007E-05_JPRB, 0.16978420E-05_JPRB, 0.16961342E-05_JPRB, 0.16942122E-05_JPRB, 0.16928589E-05_JPRB, 0.16915188E-05_JPRB, &
  & 0.16908921E-05_JPRB, 0.16896692E-05_JPRB, 0.16883298E-05_JPRB, 0.16879912E-05_JPRB, 0.16897373E-05_JPRB, 0.16940446E-05_JPRB, &
  & 0.16997904E-05_JPRB, 0.17045570E-05_JPRB, 0.17079831E-05_JPRB, 0.17127178E-05_JPRB, 0.17227151E-05_JPRB, 0.17347605E-05_JPRB, &
  & 0.17402488E-05_JPRB, 0.17441911E-05_JPRB, 0.17471566E-05_JPRB, 0.17503665E-05_JPRB, 0.17534811E-05_JPRB, 0.17560222E-05_JPRB, &
  & 0.17566012E-05_JPRB, 0.17574350E-05_JPRB, 0.17590532E-05_JPRB, 0.17623096E-05_JPRB, 0.17665834E-05_JPRB, 0.17723572E-05_JPRB, &
  & 0.17776695E-05_JPRB, 0.17828689E-05_JPRB, 0.17872002E-05_JPRB, 0.17906861E-05_JPRB, 0.17932581E-05_JPRB, 0.17953903E-05_JPRB, &
  & 0.17974635E-05_JPRB, 0.17992580E-05_JPRB, 0.18011817E-05_JPRB, 0.18029119E-05_JPRB, 0.18029303E-05_JPRB, 0.18037472E-05_JPRB, &
  & 0.18045982E-05_JPRB, 0.18057010E-05_JPRB, 0.18066334E-05_JPRB, 0.18065777E-05_JPRB  /)

RGHG2(:,72,10) = (/ &
  & 0.17029555E-05_JPRB, 0.17029689E-05_JPRB, 0.17029879E-05_JPRB, 0.17029914E-05_JPRB, 0.17029555E-05_JPRB, 0.17029048E-05_JPRB, &
  & 0.17028023E-05_JPRB, 0.17027533E-05_JPRB, 0.17026354E-05_JPRB, 0.17025796E-05_JPRB, 0.17025066E-05_JPRB, 0.17023716E-05_JPRB, &
  & 0.17021630E-05_JPRB, 0.17018937E-05_JPRB, 0.17014374E-05_JPRB, 0.17009048E-05_JPRB, 0.17005252E-05_JPRB, 0.17001147E-05_JPRB, &
  & 0.16993233E-05_JPRB, 0.16979820E-05_JPRB, 0.16963039E-05_JPRB, 0.16942804E-05_JPRB, 0.16927042E-05_JPRB, 0.16912725E-05_JPRB, &
  & 0.16904055E-05_JPRB, 0.16889548E-05_JPRB, 0.16874346E-05_JPRB, 0.16869153E-05_JPRB, 0.16883518E-05_JPRB, 0.16928721E-05_JPRB, &
  & 0.16986723E-05_JPRB, 0.17032533E-05_JPRB, 0.17068180E-05_JPRB, 0.17114883E-05_JPRB, 0.17215971E-05_JPRB, 0.17345389E-05_JPRB, &
  & 0.17405497E-05_JPRB, 0.17446283E-05_JPRB, 0.17478910E-05_JPRB, 0.17511132E-05_JPRB, 0.17543714E-05_JPRB, 0.17567664E-05_JPRB, &
  & 0.17567684E-05_JPRB, 0.17575923E-05_JPRB, 0.17595573E-05_JPRB, 0.17632198E-05_JPRB, 0.17677041E-05_JPRB, 0.17737874E-05_JPRB, &
  & 0.17793944E-05_JPRB, 0.17847795E-05_JPRB, 0.17890266E-05_JPRB, 0.17924185E-05_JPRB, 0.17950846E-05_JPRB, 0.17973554E-05_JPRB, &
  & 0.17993593E-05_JPRB, 0.18011414E-05_JPRB, 0.18029512E-05_JPRB, 0.18045576E-05_JPRB, 0.18043481E-05_JPRB, 0.18049966E-05_JPRB, &
  & 0.18058798E-05_JPRB, 0.18068513E-05_JPRB, 0.18076426E-05_JPRB, 0.18076142E-05_JPRB  /)

RGHG2(:,73,10) = (/ &
  & 0.17029396E-05_JPRB, 0.17029597E-05_JPRB, 0.17029909E-05_JPRB, 0.17029919E-05_JPRB, 0.17029557E-05_JPRB, 0.17029178E-05_JPRB, &
  & 0.17028272E-05_JPRB, 0.17027709E-05_JPRB, 0.17026409E-05_JPRB, 0.17025827E-05_JPRB, 0.17025102E-05_JPRB, 0.17023729E-05_JPRB, &
  & 0.17021793E-05_JPRB, 0.17019356E-05_JPRB, 0.17015111E-05_JPRB, 0.17009985E-05_JPRB, 0.17006336E-05_JPRB, 0.17002277E-05_JPRB, &
  & 0.16994674E-05_JPRB, 0.16981872E-05_JPRB, 0.16965711E-05_JPRB, 0.16944937E-05_JPRB, 0.16926842E-05_JPRB, 0.16911397E-05_JPRB, &
  & 0.16900541E-05_JPRB, 0.16883558E-05_JPRB, 0.16868101E-05_JPRB, 0.16861411E-05_JPRB, 0.16871421E-05_JPRB, 0.16916882E-05_JPRB, &
  & 0.16975731E-05_JPRB, 0.17018408E-05_JPRB, 0.17053842E-05_JPRB, 0.17101644E-05_JPRB, 0.17206174E-05_JPRB, 0.17346241E-05_JPRB, &
  & 0.17413351E-05_JPRB, 0.17455805E-05_JPRB, 0.17490709E-05_JPRB, 0.17526504E-05_JPRB, 0.17560254E-05_JPRB, 0.17581287E-05_JPRB, &
  & 0.17575595E-05_JPRB, 0.17583137E-05_JPRB, 0.17605630E-05_JPRB, 0.17646707E-05_JPRB, 0.17692450E-05_JPRB, 0.17755661E-05_JPRB, &
  & 0.17813339E-05_JPRB, 0.17868851E-05_JPRB, 0.17909579E-05_JPRB, 0.17942321E-05_JPRB, 0.17970297E-05_JPRB, 0.17994813E-05_JPRB, &
  & 0.18014522E-05_JPRB, 0.18031851E-05_JPRB, 0.18047677E-05_JPRB, 0.18061416E-05_JPRB, 0.18057535E-05_JPRB, 0.18062188E-05_JPRB, &
  & 0.18070447E-05_JPRB, 0.18078866E-05_JPRB, 0.18085543E-05_JPRB, 0.18086268E-05_JPRB  /)

RGHG2(:,74,10) = (/ &
  & 0.17029252E-05_JPRB, 0.17029587E-05_JPRB, 0.17030024E-05_JPRB, 0.17030009E-05_JPRB, 0.17029662E-05_JPRB, 0.17029347E-05_JPRB, &
  & 0.17028566E-05_JPRB, 0.17027974E-05_JPRB, 0.17026579E-05_JPRB, 0.17025941E-05_JPRB, 0.17025217E-05_JPRB, 0.17023819E-05_JPRB, &
  & 0.17021973E-05_JPRB, 0.17019785E-05_JPRB, 0.17015848E-05_JPRB, 0.17011050E-05_JPRB, 0.17007776E-05_JPRB, 0.17003547E-05_JPRB, &
  & 0.16996312E-05_JPRB, 0.16984247E-05_JPRB, 0.16968614E-05_JPRB, 0.16948030E-05_JPRB, 0.16927625E-05_JPRB, 0.16910870E-05_JPRB, &
  & 0.16897998E-05_JPRB, 0.16878960E-05_JPRB, 0.16863453E-05_JPRB, 0.16856087E-05_JPRB, 0.16862209E-05_JPRB, 0.16905362E-05_JPRB, &
  & 0.16964320E-05_JPRB, 0.17004344E-05_JPRB, 0.17039085E-05_JPRB, 0.17088176E-05_JPRB, 0.17197866E-05_JPRB, 0.17348996E-05_JPRB, &
  & 0.17423400E-05_JPRB, 0.17467607E-05_JPRB, 0.17504083E-05_JPRB, 0.17545501E-05_JPRB, 0.17581249E-05_JPRB, 0.17599170E-05_JPRB, &
  & 0.17588017E-05_JPRB, 0.17594872E-05_JPRB, 0.17619913E-05_JPRB, 0.17664799E-05_JPRB, 0.17711263E-05_JPRB, 0.17775518E-05_JPRB, &
  & 0.17834301E-05_JPRB, 0.17891067E-05_JPRB, 0.17929858E-05_JPRB, 0.17961047E-05_JPRB, 0.17990501E-05_JPRB, 0.18016426E-05_JPRB, &
  & 0.18036136E-05_JPRB, 0.18052658E-05_JPRB, 0.18065775E-05_JPRB, 0.18076665E-05_JPRB, 0.18071490E-05_JPRB, 0.18074436E-05_JPRB, &
  & 0.18081210E-05_JPRB, 0.18088843E-05_JPRB, 0.18094464E-05_JPRB, 0.18096020E-05_JPRB  /)

RGHG2(:,75,10) = (/ &
  & 0.17029157E-05_JPRB, 0.17029659E-05_JPRB, 0.17030220E-05_JPRB, 0.17030194E-05_JPRB, 0.17029872E-05_JPRB, 0.17029575E-05_JPRB, &
  & 0.17028898E-05_JPRB, 0.17028319E-05_JPRB, 0.17026884E-05_JPRB, 0.17026158E-05_JPRB, 0.17025441E-05_JPRB, 0.17024025E-05_JPRB, &
  & 0.17022214E-05_JPRB, 0.17020261E-05_JPRB, 0.17016622E-05_JPRB, 0.17012249E-05_JPRB, 0.17009489E-05_JPRB, 0.17005010E-05_JPRB, &
  & 0.16998200E-05_JPRB, 0.16986936E-05_JPRB, 0.16971736E-05_JPRB, 0.16951839E-05_JPRB, 0.16929266E-05_JPRB, 0.16911247E-05_JPRB, &
  & 0.16896601E-05_JPRB, 0.16876170E-05_JPRB, 0.16860471E-05_JPRB, 0.16853278E-05_JPRB, 0.16856325E-05_JPRB, 0.16895251E-05_JPRB, &
  & 0.16952899E-05_JPRB, 0.16990692E-05_JPRB, 0.17024542E-05_JPRB, 0.17074620E-05_JPRB, 0.17190769E-05_JPRB, 0.17353038E-05_JPRB, &
  & 0.17434953E-05_JPRB, 0.17480844E-05_JPRB, 0.17518634E-05_JPRB, 0.17567131E-05_JPRB, 0.17605910E-05_JPRB, 0.17621185E-05_JPRB, &
  & 0.17604840E-05_JPRB, 0.17611070E-05_JPRB, 0.17638330E-05_JPRB, 0.17686190E-05_JPRB, 0.17733283E-05_JPRB, 0.17797353E-05_JPRB, &
  & 0.17857001E-05_JPRB, 0.17914506E-05_JPRB, 0.17951287E-05_JPRB, 0.17980784E-05_JPRB, 0.18011438E-05_JPRB, 0.18038255E-05_JPRB, &
  & 0.18058087E-05_JPRB, 0.18073547E-05_JPRB, 0.18083680E-05_JPRB, 0.18091346E-05_JPRB, 0.18085363E-05_JPRB, 0.18086737E-05_JPRB, &
  & 0.18091338E-05_JPRB, 0.18098627E-05_JPRB, 0.18103346E-05_JPRB, 0.18105702E-05_JPRB  /)

RGHG2(:,76,10) = (/ &
  & 0.17029161E-05_JPRB, 0.17029811E-05_JPRB, 0.17030496E-05_JPRB, 0.17030495E-05_JPRB, 0.17030197E-05_JPRB, 0.17029901E-05_JPRB, &
  & 0.17029273E-05_JPRB, 0.17028744E-05_JPRB, 0.17027358E-05_JPRB, 0.17026509E-05_JPRB, 0.17025816E-05_JPRB, 0.17024400E-05_JPRB, &
  & 0.17022589E-05_JPRB, 0.17020834E-05_JPRB, 0.17017493E-05_JPRB, 0.17013615E-05_JPRB, 0.17011351E-05_JPRB, 0.17006748E-05_JPRB, &
  & 0.17000433E-05_JPRB, 0.16989987E-05_JPRB, 0.16975183E-05_JPRB, 0.16956079E-05_JPRB, 0.16931648E-05_JPRB, 0.16912762E-05_JPRB, &
  & 0.16896703E-05_JPRB, 0.16875852E-05_JPRB, 0.16859459E-05_JPRB, 0.16853282E-05_JPRB, 0.16854372E-05_JPRB, 0.16888220E-05_JPRB, &
  & 0.16942178E-05_JPRB, 0.16977815E-05_JPRB, 0.17010848E-05_JPRB, 0.17061050E-05_JPRB, 0.17184432E-05_JPRB, 0.17357600E-05_JPRB, &
  & 0.17447367E-05_JPRB, 0.17494670E-05_JPRB, 0.17534218E-05_JPRB, 0.17590568E-05_JPRB, 0.17633606E-05_JPRB, 0.17647569E-05_JPRB, &
  & 0.17626295E-05_JPRB, 0.17631955E-05_JPRB, 0.17660999E-05_JPRB, 0.17710840E-05_JPRB, 0.17758454E-05_JPRB, 0.17821334E-05_JPRB, &
  & 0.17881899E-05_JPRB, 0.17939479E-05_JPRB, 0.17974252E-05_JPRB, 0.18002313E-05_JPRB, 0.18033215E-05_JPRB, 0.18060329E-05_JPRB, &
  & 0.18080087E-05_JPRB, 0.18094309E-05_JPRB, 0.18101320E-05_JPRB, 0.18105518E-05_JPRB, 0.18099214E-05_JPRB, 0.18099126E-05_JPRB, &
  & 0.18101200E-05_JPRB, 0.18108415E-05_JPRB, 0.18112341E-05_JPRB, 0.18115837E-05_JPRB  /)

RGHG2(:,77,10) = (/ &
  & 0.17029255E-05_JPRB, 0.17030056E-05_JPRB, 0.17030867E-05_JPRB, 0.17030891E-05_JPRB, 0.17030666E-05_JPRB, 0.17030322E-05_JPRB, &
  & 0.17029744E-05_JPRB, 0.17029289E-05_JPRB, 0.17028025E-05_JPRB, 0.17027050E-05_JPRB, 0.17026335E-05_JPRB, 0.17024919E-05_JPRB, &
  & 0.17023108E-05_JPRB, 0.17021506E-05_JPRB, 0.17018538E-05_JPRB, 0.17015186E-05_JPRB, 0.17013281E-05_JPRB, 0.17008720E-05_JPRB, &
  & 0.17002860E-05_JPRB, 0.16993433E-05_JPRB, 0.16979127E-05_JPRB, 0.16960588E-05_JPRB, 0.16935083E-05_JPRB, 0.16915127E-05_JPRB, &
  & 0.16898709E-05_JPRB, 0.16878074E-05_JPRB, 0.16861287E-05_JPRB, 0.16855211E-05_JPRB, 0.16854436E-05_JPRB, 0.16886207E-05_JPRB, &
  & 0.16935420E-05_JPRB, 0.16966894E-05_JPRB, 0.16999598E-05_JPRB, 0.17049425E-05_JPRB, 0.17178642E-05_JPRB, 0.17360982E-05_JPRB, &
  & 0.17458809E-05_JPRB, 0.17507878E-05_JPRB, 0.17550639E-05_JPRB, 0.17614524E-05_JPRB, 0.17661455E-05_JPRB, 0.17678017E-05_JPRB, &
  & 0.17653698E-05_JPRB, 0.17657564E-05_JPRB, 0.17686654E-05_JPRB, 0.17740054E-05_JPRB, 0.17788005E-05_JPRB, 0.17847773E-05_JPRB, &
  & 0.17909148E-05_JPRB, 0.17965040E-05_JPRB, 0.17999613E-05_JPRB, 0.18027813E-05_JPRB, 0.18058371E-05_JPRB, 0.18085167E-05_JPRB, &
  & 0.18104015E-05_JPRB, 0.18116457E-05_JPRB, 0.18119779E-05_JPRB, 0.18119792E-05_JPRB, 0.18112780E-05_JPRB, 0.18111233E-05_JPRB, &
  & 0.18111103E-05_JPRB, 0.18117861E-05_JPRB, 0.18120935E-05_JPRB, 0.18125349E-05_JPRB  /)

RGHG2(:,78,10) = (/ &
  & 0.17029441E-05_JPRB, 0.17030345E-05_JPRB, 0.17031264E-05_JPRB, 0.17031345E-05_JPRB, 0.17031180E-05_JPRB, 0.17030833E-05_JPRB, &
  & 0.17030290E-05_JPRB, 0.17029957E-05_JPRB, 0.17028819E-05_JPRB, 0.17027718E-05_JPRB, 0.17026962E-05_JPRB, 0.17025515E-05_JPRB, &
  & 0.17023704E-05_JPRB, 0.17022268E-05_JPRB, 0.17019644E-05_JPRB, 0.17016850E-05_JPRB, 0.17015152E-05_JPRB, 0.17010736E-05_JPRB, &
  & 0.17005248E-05_JPRB, 0.16996784E-05_JPRB, 0.16983011E-05_JPRB, 0.16964928E-05_JPRB, 0.16939034E-05_JPRB, 0.16918192E-05_JPRB, &
  & 0.16901776E-05_JPRB, 0.16881359E-05_JPRB, 0.16864484E-05_JPRB, 0.16858060E-05_JPRB, 0.16855143E-05_JPRB, 0.16884676E-05_JPRB, &
  & 0.16930014E-05_JPRB, 0.16958538E-05_JPRB, 0.16990909E-05_JPRB, 0.17040016E-05_JPRB, 0.17173518E-05_JPRB, 0.17363800E-05_JPRB, &
  & 0.17468822E-05_JPRB, 0.17519877E-05_JPRB, 0.17565968E-05_JPRB, 0.17636975E-05_JPRB, 0.17688546E-05_JPRB, 0.17711918E-05_JPRB, &
  & 0.17681461E-05_JPRB, 0.17684048E-05_JPRB, 0.17712386E-05_JPRB, 0.17770471E-05_JPRB, 0.17819529E-05_JPRB, 0.17875996E-05_JPRB, &
  & 0.17938060E-05_JPRB, 0.17991360E-05_JPRB, 0.18026918E-05_JPRB, 0.18055758E-05_JPRB, 0.18086052E-05_JPRB, 0.18113135E-05_JPRB, &
  & 0.18129516E-05_JPRB, 0.18140250E-05_JPRB, 0.18138540E-05_JPRB, 0.18133612E-05_JPRB, 0.18125043E-05_JPRB, 0.18121837E-05_JPRB, &
  & 0.18120612E-05_JPRB, 0.18126223E-05_JPRB, 0.18128670E-05_JPRB, 0.18133187E-05_JPRB  /)

RGHG2(:,79,10) = (/ &
  & 0.17029718E-05_JPRB, 0.17030657E-05_JPRB, 0.17031677E-05_JPRB, 0.17031824E-05_JPRB, 0.17031724E-05_JPRB, 0.17031411E-05_JPRB, &
  & 0.17030900E-05_JPRB, 0.17030725E-05_JPRB, 0.17029727E-05_JPRB, 0.17028495E-05_JPRB, 0.17027688E-05_JPRB, 0.17026167E-05_JPRB, &
  & 0.17024380E-05_JPRB, 0.17023111E-05_JPRB, 0.17020803E-05_JPRB, 0.17018526E-05_JPRB, 0.17016969E-05_JPRB, 0.17012768E-05_JPRB, &
  & 0.17007564E-05_JPRB, 0.16999847E-05_JPRB, 0.16986654E-05_JPRB, 0.16969025E-05_JPRB, 0.16943273E-05_JPRB, 0.16921762E-05_JPRB, &
  & 0.16905425E-05_JPRB, 0.16885311E-05_JPRB, 0.16868432E-05_JPRB, 0.16861561E-05_JPRB, 0.16856781E-05_JPRB, 0.16883524E-05_JPRB, &
  & 0.16925285E-05_JPRB, 0.16952228E-05_JPRB, 0.16984465E-05_JPRB, 0.17032779E-05_JPRB, 0.17169035E-05_JPRB, 0.17366219E-05_JPRB, &
  & 0.17477394E-05_JPRB, 0.17530454E-05_JPRB, 0.17579685E-05_JPRB, 0.17657418E-05_JPRB, 0.17713824E-05_JPRB, 0.17745032E-05_JPRB, &
  & 0.17706946E-05_JPRB, 0.17708912E-05_JPRB, 0.17736986E-05_JPRB, 0.17799987E-05_JPRB, 0.17850724E-05_JPRB, 0.17905282E-05_JPRB, &
  & 0.17967906E-05_JPRB, 0.18018405E-05_JPRB, 0.18056336E-05_JPRB, 0.18086008E-05_JPRB, 0.18115673E-05_JPRB, 0.18143150E-05_JPRB, &
  & 0.18156797E-05_JPRB, 0.18165442E-05_JPRB, 0.18157071E-05_JPRB, 0.18146517E-05_JPRB, 0.18135820E-05_JPRB, 0.18130630E-05_JPRB, &
  & 0.18129225E-05_JPRB, 0.18133150E-05_JPRB, 0.18135170E-05_JPRB, 0.18139323E-05_JPRB  /)

RGHG2(:,80,10) = (/ &
  & 0.17030085E-05_JPRB, 0.17030974E-05_JPRB, 0.17032093E-05_JPRB, 0.17032290E-05_JPRB, 0.17032290E-05_JPRB, 0.17032025E-05_JPRB, &
  & 0.17031563E-05_JPRB, 0.17031561E-05_JPRB, 0.17030736E-05_JPRB, 0.17029356E-05_JPRB, 0.17028502E-05_JPRB, 0.17026856E-05_JPRB, &
  & 0.17025141E-05_JPRB, 0.17024022E-05_JPRB, 0.17022011E-05_JPRB, 0.17020129E-05_JPRB, 0.17018748E-05_JPRB, 0.17014793E-05_JPRB, &
  & 0.17009784E-05_JPRB, 0.17002441E-05_JPRB, 0.16989890E-05_JPRB, 0.16972834E-05_JPRB, 0.16947572E-05_JPRB, 0.16925609E-05_JPRB, &
  & 0.16909146E-05_JPRB, 0.16889552E-05_JPRB, 0.16872508E-05_JPRB, 0.16865451E-05_JPRB, 0.16859732E-05_JPRB, 0.16882907E-05_JPRB, &
  & 0.16920609E-05_JPRB, 0.16947287E-05_JPRB, 0.16979850E-05_JPRB, 0.17027589E-05_JPRB, 0.17165145E-05_JPRB, 0.17368397E-05_JPRB, &
  & 0.17484583E-05_JPRB, 0.17539429E-05_JPRB, 0.17591367E-05_JPRB, 0.17675464E-05_JPRB, 0.17736190E-05_JPRB, 0.17772650E-05_JPRB, &
  & 0.17727593E-05_JPRB, 0.17729632E-05_JPRB, 0.17759307E-05_JPRB, 0.17826478E-05_JPRB, 0.17879168E-05_JPRB, 0.17934845E-05_JPRB, &
  & 0.17997865E-05_JPRB, 0.18046046E-05_JPRB, 0.18087977E-05_JPRB, 0.18118326E-05_JPRB, 0.18146486E-05_JPRB, 0.18173827E-05_JPRB, &
  & 0.18185985E-05_JPRB, 0.18191643E-05_JPRB, 0.18174774E-05_JPRB, 0.18158031E-05_JPRB, 0.18144994E-05_JPRB, 0.18137394E-05_JPRB, &
  & 0.18136439E-05_JPRB, 0.18138333E-05_JPRB, 0.18140079E-05_JPRB, 0.18143835E-05_JPRB  /)

RGHG2(:,81,10) = (/ &
  & 0.17030517E-05_JPRB, 0.17031356E-05_JPRB, 0.17032525E-05_JPRB, 0.17032773E-05_JPRB, 0.17032798E-05_JPRB, 0.17032686E-05_JPRB, &
  & 0.17032250E-05_JPRB, 0.17032426E-05_JPRB, 0.17031754E-05_JPRB, 0.17030170E-05_JPRB, 0.17029113E-05_JPRB, 0.17027492E-05_JPRB, &
  & 0.17025981E-05_JPRB, 0.17024862E-05_JPRB, 0.17023105E-05_JPRB, 0.17021606E-05_JPRB, 0.17020122E-05_JPRB, 0.17016499E-05_JPRB, &
  & 0.17011821E-05_JPRB, 0.17004605E-05_JPRB, 0.16992665E-05_JPRB, 0.16975686E-05_JPRB, 0.16951264E-05_JPRB, 0.16929480E-05_JPRB, &
  & 0.16913144E-05_JPRB, 0.16893907E-05_JPRB, 0.16876022E-05_JPRB, 0.16869907E-05_JPRB, 0.16863348E-05_JPRB, 0.16884053E-05_JPRB, &
  & 0.16918647E-05_JPRB, 0.16944561E-05_JPRB, 0.16976971E-05_JPRB, 0.17024736E-05_JPRB, 0.17162266E-05_JPRB, 0.17369822E-05_JPRB, &
  & 0.17488887E-05_JPRB, 0.17546815E-05_JPRB, 0.17600052E-05_JPRB, 0.17688785E-05_JPRB, 0.17753815E-05_JPRB, 0.17791905E-05_JPRB, &
  & 0.17742748E-05_JPRB, 0.17744991E-05_JPRB, 0.17776550E-05_JPRB, 0.17845911E-05_JPRB, 0.17900258E-05_JPRB, 0.17958456E-05_JPRB, &
  & 0.18023870E-05_JPRB, 0.18073681E-05_JPRB, 0.18119459E-05_JPRB, 0.18155794E-05_JPRB, 0.18180438E-05_JPRB, 0.18206531E-05_JPRB, &
  & 0.18217925E-05_JPRB, 0.18218540E-05_JPRB, 0.18191763E-05_JPRB, 0.18168346E-05_JPRB, 0.18152457E-05_JPRB, 0.18141673E-05_JPRB, &
  & 0.18140793E-05_JPRB, 0.18141211E-05_JPRB, 0.18142855E-05_JPRB, 0.18146382E-05_JPRB  /)

RGHG2(:,82,10) = (/ &
  & 0.17030944E-05_JPRB, 0.17031697E-05_JPRB, 0.17032917E-05_JPRB, 0.17033215E-05_JPRB, 0.17033301E-05_JPRB, 0.17033305E-05_JPRB, &
  & 0.17032930E-05_JPRB, 0.17033196E-05_JPRB, 0.17032710E-05_JPRB, 0.17030889E-05_JPRB, 0.17029611E-05_JPRB, 0.17027963E-05_JPRB, &
  & 0.17026602E-05_JPRB, 0.17025553E-05_JPRB, 0.17023944E-05_JPRB, 0.17022737E-05_JPRB, 0.17021310E-05_JPRB, 0.17017892E-05_JPRB, &
  & 0.17013597E-05_JPRB, 0.17006490E-05_JPRB, 0.16995069E-05_JPRB, 0.16978201E-05_JPRB, 0.16954544E-05_JPRB, 0.16933183E-05_JPRB, &
  & 0.16917132E-05_JPRB, 0.16898143E-05_JPRB, 0.16879423E-05_JPRB, 0.16874315E-05_JPRB, 0.16866816E-05_JPRB, 0.16885978E-05_JPRB, &
  & 0.16919011E-05_JPRB, 0.16943481E-05_JPRB, 0.16975810E-05_JPRB, 0.17023582E-05_JPRB, 0.17160894E-05_JPRB, 0.17371605E-05_JPRB, &
  & 0.17491476E-05_JPRB, 0.17552396E-05_JPRB, 0.17607082E-05_JPRB, 0.17699070E-05_JPRB, 0.17767306E-05_JPRB, 0.17806963E-05_JPRB, &
  & 0.17755083E-05_JPRB, 0.17757528E-05_JPRB, 0.17790504E-05_JPRB, 0.17861586E-05_JPRB, 0.17916577E-05_JPRB, 0.17976684E-05_JPRB, &
  & 0.18044495E-05_JPRB, 0.18096961E-05_JPRB, 0.18147437E-05_JPRB, 0.18189755E-05_JPRB, 0.18212767E-05_JPRB, 0.18236058E-05_JPRB, &
  & 0.18245026E-05_JPRB, 0.18242454E-05_JPRB, 0.18207429E-05_JPRB, 0.18177118E-05_JPRB, 0.18158377E-05_JPRB, 0.18144956E-05_JPRB, &
  & 0.18143608E-05_JPRB, 0.18143207E-05_JPRB, 0.18144346E-05_JPRB, 0.18147716E-05_JPRB  /)

RGHG2(:,83,10) = (/ &
  & 0.17031348E-05_JPRB, 0.17032001E-05_JPRB, 0.17033252E-05_JPRB, 0.17033610E-05_JPRB, 0.17033771E-05_JPRB, 0.17033915E-05_JPRB, &
  & 0.17033586E-05_JPRB, 0.17033872E-05_JPRB, 0.17033578E-05_JPRB, 0.17031476E-05_JPRB, 0.17029983E-05_JPRB, 0.17028294E-05_JPRB, &
  & 0.17027078E-05_JPRB, 0.17026129E-05_JPRB, 0.17024591E-05_JPRB, 0.17023616E-05_JPRB, 0.17022314E-05_JPRB, 0.17019057E-05_JPRB, &
  & 0.17015173E-05_JPRB, 0.17008185E-05_JPRB, 0.16997145E-05_JPRB, 0.16980490E-05_JPRB, 0.16957483E-05_JPRB, 0.16936542E-05_JPRB, &
  & 0.16920851E-05_JPRB, 0.16902005E-05_JPRB, 0.16882632E-05_JPRB, 0.16878679E-05_JPRB, 0.16869977E-05_JPRB, 0.16888448E-05_JPRB, &
  & 0.16920963E-05_JPRB, 0.16943963E-05_JPRB, 0.16976213E-05_JPRB, 0.17024714E-05_JPRB, 0.17161696E-05_JPRB, 0.17373836E-05_JPRB, &
  & 0.17492731E-05_JPRB, 0.17556054E-05_JPRB, 0.17611662E-05_JPRB, 0.17706372E-05_JPRB, 0.17777300E-05_JPRB, 0.17818954E-05_JPRB, &
  & 0.17765335E-05_JPRB, 0.17767942E-05_JPRB, 0.17801938E-05_JPRB, 0.17874321E-05_JPRB, 0.17929679E-05_JPRB, 0.17990600E-05_JPRB, &
  & 0.18060543E-05_JPRB, 0.18116018E-05_JPRB, 0.18171558E-05_JPRB, 0.18219444E-05_JPRB, 0.18242071E-05_JPRB, 0.18261618E-05_JPRB, &
  & 0.18267662E-05_JPRB, 0.18263013E-05_JPRB, 0.18221938E-05_JPRB, 0.18184812E-05_JPRB, 0.18163011E-05_JPRB, 0.18147624E-05_JPRB, &
  & 0.18145506E-05_JPRB, 0.18144606E-05_JPRB, 0.18145078E-05_JPRB, 0.18147855E-05_JPRB  /)

RGHG2(:,84,10) = (/ &
  & 0.17031717E-05_JPRB, 0.17032271E-05_JPRB, 0.17033520E-05_JPRB, 0.17033951E-05_JPRB, 0.17034188E-05_JPRB, 0.17034531E-05_JPRB, &
  & 0.17034202E-05_JPRB, 0.17034465E-05_JPRB, 0.17034343E-05_JPRB, 0.17031916E-05_JPRB, 0.17030225E-05_JPRB, 0.17028513E-05_JPRB, &
  & 0.17027467E-05_JPRB, 0.17026619E-05_JPRB, 0.17025110E-05_JPRB, 0.17024331E-05_JPRB, 0.17023150E-05_JPRB, 0.17020069E-05_JPRB, &
  & 0.17016605E-05_JPRB, 0.17009777E-05_JPRB, 0.16998938E-05_JPRB, 0.16982637E-05_JPRB, 0.16960129E-05_JPRB, 0.16939454E-05_JPRB, &
  & 0.16924137E-05_JPRB, 0.16905329E-05_JPRB, 0.16885577E-05_JPRB, 0.16882994E-05_JPRB, 0.16872729E-05_JPRB, 0.16891236E-05_JPRB, &
  & 0.16923866E-05_JPRB, 0.16945857E-05_JPRB, 0.16978008E-05_JPRB, 0.17028199E-05_JPRB, 0.17164855E-05_JPRB, 0.17376588E-05_JPRB, &
  & 0.17493188E-05_JPRB, 0.17558047E-05_JPRB, 0.17613598E-05_JPRB, 0.17711052E-05_JPRB, 0.17784647E-05_JPRB, 0.17829066E-05_JPRB, &
  & 0.17774232E-05_JPRB, 0.17776880E-05_JPRB, 0.17811603E-05_JPRB, 0.17884968E-05_JPRB, 0.17940949E-05_JPRB, 0.18001322E-05_JPRB, &
  & 0.18072907E-05_JPRB, 0.18131213E-05_JPRB, 0.18191718E-05_JPRB, 0.18244496E-05_JPRB, 0.18267178E-05_JPRB, 0.18282712E-05_JPRB, &
  & 0.18286300E-05_JPRB, 0.18280128E-05_JPRB, 0.18235451E-05_JPRB, 0.18191776E-05_JPRB, 0.18166636E-05_JPRB, 0.18149999E-05_JPRB, &
  & 0.18147034E-05_JPRB, 0.18145677E-05_JPRB, 0.18145538E-05_JPRB, 0.18147002E-05_JPRB  /)

RGHG2(:,85,10) = (/ &
  & 0.17032054E-05_JPRB, 0.17032505E-05_JPRB, 0.17033729E-05_JPRB, 0.17034211E-05_JPRB, 0.17034551E-05_JPRB, 0.17035125E-05_JPRB, &
  & 0.17034796E-05_JPRB, 0.17035059E-05_JPRB, 0.17035091E-05_JPRB, 0.17032279E-05_JPRB, 0.17030382E-05_JPRB, 0.17028670E-05_JPRB, &
  & 0.17027753E-05_JPRB, 0.17027033E-05_JPRB, 0.17025627E-05_JPRB, 0.17025027E-05_JPRB, 0.17023924E-05_JPRB, 0.17021074E-05_JPRB, &
  & 0.17018046E-05_JPRB, 0.17011552E-05_JPRB, 0.17000584E-05_JPRB, 0.16984771E-05_JPRB, 0.16962469E-05_JPRB, 0.16942358E-05_JPRB, &
  & 0.16927479E-05_JPRB, 0.16908516E-05_JPRB, 0.16888250E-05_JPRB, 0.16887619E-05_JPRB, 0.16875274E-05_JPRB, 0.16894397E-05_JPRB, &
  & 0.16928183E-05_JPRB, 0.16949583E-05_JPRB, 0.16982016E-05_JPRB, 0.17031360E-05_JPRB, 0.17168401E-05_JPRB, 0.17380699E-05_JPRB, &
  & 0.17495373E-05_JPRB, 0.17561876E-05_JPRB, 0.17616477E-05_JPRB, 0.17715574E-05_JPRB, 0.17792661E-05_JPRB, 0.17841008E-05_JPRB, &
  & 0.17783710E-05_JPRB, 0.17785484E-05_JPRB, 0.17821133E-05_JPRB, 0.17895781E-05_JPRB, 0.17952480E-05_JPRB, 0.18011057E-05_JPRB, &
  & 0.18083334E-05_JPRB, 0.18144362E-05_JPRB, 0.18209129E-05_JPRB, 0.18266888E-05_JPRB, 0.18286233E-05_JPRB, 0.18299456E-05_JPRB, &
  & 0.18301940E-05_JPRB, 0.18295512E-05_JPRB, 0.18249191E-05_JPRB, 0.18198044E-05_JPRB, 0.18169823E-05_JPRB, 0.18152468E-05_JPRB, &
  & 0.18148912E-05_JPRB, 0.18146887E-05_JPRB, 0.18146619E-05_JPRB, 0.18146697E-05_JPRB  /)

RGHG2(:,86,10) = (/ &
  & 0.17032335E-05_JPRB, 0.17032722E-05_JPRB, 0.17033880E-05_JPRB, 0.17034414E-05_JPRB, 0.17034857E-05_JPRB, 0.17035663E-05_JPRB, &
  & 0.17035354E-05_JPRB, 0.17035577E-05_JPRB, 0.17035804E-05_JPRB, 0.17032545E-05_JPRB, 0.17030502E-05_JPRB, 0.17028790E-05_JPRB, &
  & 0.17028001E-05_JPRB, 0.17027451E-05_JPRB, 0.17026048E-05_JPRB, 0.17025669E-05_JPRB, 0.17024643E-05_JPRB, 0.17022045E-05_JPRB, &
  & 0.17019477E-05_JPRB, 0.17013720E-05_JPRB, 0.17002281E-05_JPRB, 0.16986918E-05_JPRB, 0.16964923E-05_JPRB, 0.16945099E-05_JPRB, &
  & 0.16930437E-05_JPRB, 0.16911299E-05_JPRB, 0.16890799E-05_JPRB, 0.16892610E-05_JPRB, 0.16878095E-05_JPRB, 0.16898440E-05_JPRB, &
  & 0.16934774E-05_JPRB, 0.16955420E-05_JPRB, 0.16989523E-05_JPRB, 0.17035283E-05_JPRB, 0.17172932E-05_JPRB, 0.17386622E-05_JPRB, &
  & 0.17498938E-05_JPRB, 0.17568438E-05_JPRB, 0.17621060E-05_JPRB, 0.17721688E-05_JPRB, 0.17803450E-05_JPRB, 0.17857775E-05_JPRB, &
  & 0.17795588E-05_JPRB, 0.17795320E-05_JPRB, 0.17831415E-05_JPRB, 0.17908800E-05_JPRB, 0.17965559E-05_JPRB, 0.18021344E-05_JPRB, &
  & 0.18093716E-05_JPRB, 0.18157379E-05_JPRB, 0.18225646E-05_JPRB, 0.18287447E-05_JPRB, 0.18301247E-05_JPRB, 0.18313654E-05_JPRB, &
  & 0.18315672E-05_JPRB, 0.18309126E-05_JPRB, 0.18263003E-05_JPRB, 0.18204748E-05_JPRB, 0.18172968E-05_JPRB, 0.18155091E-05_JPRB, &
  & 0.18151142E-05_JPRB, 0.18148346E-05_JPRB, 0.18148392E-05_JPRB, 0.18147498E-05_JPRB  /)

RGHG2(:,87,10) = (/ &
  & 0.17032551E-05_JPRB, 0.17032899E-05_JPRB, 0.17034005E-05_JPRB, 0.17034565E-05_JPRB, 0.17035126E-05_JPRB, 0.17036168E-05_JPRB, &
  & 0.17035925E-05_JPRB, 0.17036029E-05_JPRB, 0.17036479E-05_JPRB, 0.17032735E-05_JPRB, 0.17030587E-05_JPRB, 0.17028875E-05_JPRB, &
  & 0.17028205E-05_JPRB, 0.17027877E-05_JPRB, 0.17026475E-05_JPRB, 0.17026292E-05_JPRB, 0.17025371E-05_JPRB, 0.17022996E-05_JPRB, &
  & 0.17021019E-05_JPRB, 0.17016568E-05_JPRB, 0.17004259E-05_JPRB, 0.16989328E-05_JPRB, 0.16967500E-05_JPRB, 0.16947631E-05_JPRB, &
  & 0.16933942E-05_JPRB, 0.16913845E-05_JPRB, 0.16893375E-05_JPRB, 0.16898196E-05_JPRB, 0.16881493E-05_JPRB, 0.16904337E-05_JPRB, &
  & 0.16944020E-05_JPRB, 0.16964388E-05_JPRB, 0.17002943E-05_JPRB, 0.17041303E-05_JPRB, 0.17179795E-05_JPRB, 0.17396420E-05_JPRB, &
  & 0.17505203E-05_JPRB, 0.17578792E-05_JPRB, 0.17629041E-05_JPRB, 0.17732339E-05_JPRB, 0.17821969E-05_JPRB, 0.17882844E-05_JPRB, &
  & 0.17812601E-05_JPRB, 0.17808289E-05_JPRB, 0.17845006E-05_JPRB, 0.17927115E-05_JPRB, 0.17982217E-05_JPRB, 0.18033640E-05_JPRB, &
  & 0.18105103E-05_JPRB, 0.18171640E-05_JPRB, 0.18243210E-05_JPRB, 0.18307660E-05_JPRB, 0.18314915E-05_JPRB, 0.18326407E-05_JPRB, &
  & 0.18329327E-05_JPRB, 0.18321993E-05_JPRB, 0.18276470E-05_JPRB, 0.18211688E-05_JPRB, 0.18176080E-05_JPRB, 0.18157717E-05_JPRB, &
  & 0.18153468E-05_JPRB, 0.18150061E-05_JPRB, 0.18150270E-05_JPRB, 0.18148445E-05_JPRB  /)

RGHG2(:,88,10) = (/ &
  & 0.17032715E-05_JPRB, 0.17033028E-05_JPRB, 0.17034107E-05_JPRB, 0.17034674E-05_JPRB, 0.17035365E-05_JPRB, 0.17036638E-05_JPRB, &
  & 0.17036537E-05_JPRB, 0.17036409E-05_JPRB, 0.17037121E-05_JPRB, 0.17032864E-05_JPRB, 0.17030650E-05_JPRB, 0.17028938E-05_JPRB, &
  & 0.17028393E-05_JPRB, 0.17028316E-05_JPRB, 0.17026949E-05_JPRB, 0.17026986E-05_JPRB, 0.17026187E-05_JPRB, 0.17023987E-05_JPRB, &
  & 0.17022800E-05_JPRB, 0.17019947E-05_JPRB, 0.17006636E-05_JPRB, 0.16992096E-05_JPRB, 0.16970371E-05_JPRB, 0.16949971E-05_JPRB, &
  & 0.16939805E-05_JPRB, 0.16916485E-05_JPRB, 0.16896211E-05_JPRB, 0.16904359E-05_JPRB, 0.16885777E-05_JPRB, 0.16913244E-05_JPRB, &
  & 0.16957485E-05_JPRB, 0.16979097E-05_JPRB, 0.17024228E-05_JPRB, 0.17051254E-05_JPRB, 0.17191073E-05_JPRB, 0.17412854E-05_JPRB, &
  & 0.17517240E-05_JPRB, 0.17594885E-05_JPRB, 0.17644888E-05_JPRB, 0.17755065E-05_JPRB, 0.17860963E-05_JPRB, 0.17926978E-05_JPRB, &
  & 0.17840698E-05_JPRB, 0.17828568E-05_JPRB, 0.17866657E-05_JPRB, 0.17956990E-05_JPRB, 0.18006795E-05_JPRB, 0.18050160E-05_JPRB, &
  & 0.18119452E-05_JPRB, 0.18188897E-05_JPRB, 0.18264443E-05_JPRB, 0.18329955E-05_JPRB, 0.18329259E-05_JPRB, 0.18338636E-05_JPRB, &
  & 0.18344773E-05_JPRB, 0.18335159E-05_JPRB, 0.18289892E-05_JPRB, 0.18218954E-05_JPRB, 0.18179145E-05_JPRB, 0.18160190E-05_JPRB, &
  & 0.18155840E-05_JPRB, 0.18152049E-05_JPRB, 0.18151880E-05_JPRB, 0.18149138E-05_JPRB  /)

RGHG2(:,89,10) = (/ &
  & 0.17032848E-05_JPRB, 0.17033111E-05_JPRB, 0.17034165E-05_JPRB, 0.17034754E-05_JPRB, 0.17035559E-05_JPRB, 0.17037045E-05_JPRB, &
  & 0.17037177E-05_JPRB, 0.17036686E-05_JPRB, 0.17037729E-05_JPRB, 0.17032954E-05_JPRB, 0.17030708E-05_JPRB, 0.17028996E-05_JPRB, &
  & 0.17028616E-05_JPRB, 0.17028748E-05_JPRB, 0.17027461E-05_JPRB, 0.17027887E-05_JPRB, 0.17027147E-05_JPRB, 0.17025096E-05_JPRB, &
  & 0.17024902E-05_JPRB, 0.17023055E-05_JPRB, 0.17009326E-05_JPRB, 0.16995056E-05_JPRB, 0.16973865E-05_JPRB, 0.16952214E-05_JPRB, &
  & 0.16950706E-05_JPRB, 0.16919771E-05_JPRB, 0.16899644E-05_JPRB, 0.16910871E-05_JPRB, 0.16891140E-05_JPRB, 0.16925911E-05_JPRB, &
  & 0.16977449E-05_JPRB, 0.17002909E-05_JPRB, 0.17053909E-05_JPRB, 0.17066631E-05_JPRB, 0.17208619E-05_JPRB, 0.17438957E-05_JPRB, &
  & 0.17539935E-05_JPRB, 0.17618594E-05_JPRB, 0.17675737E-05_JPRB, 0.17806461E-05_JPRB, 0.17950709E-05_JPRB, 0.18015771E-05_JPRB, &
  & 0.17891244E-05_JPRB, 0.17864693E-05_JPRB, 0.17905426E-05_JPRB, 0.18009059E-05_JPRB, 0.18047295E-05_JPRB, 0.18073952E-05_JPRB, &
  & 0.18139648E-05_JPRB, 0.18210953E-05_JPRB, 0.18292175E-05_JPRB, 0.18357477E-05_JPRB, 0.18345617E-05_JPRB, 0.18350936E-05_JPRB, &
  & 0.18362908E-05_JPRB, 0.18349362E-05_JPRB, 0.18303538E-05_JPRB, 0.18226402E-05_JPRB, 0.18181972E-05_JPRB, 0.18162212E-05_JPRB, &
  & 0.18158245E-05_JPRB, 0.18154198E-05_JPRB, 0.18152866E-05_JPRB, 0.18149536E-05_JPRB  /)

RGHG2(:,90,10) = (/ &
  & 0.17032890E-05_JPRB, 0.17033155E-05_JPRB, 0.17034207E-05_JPRB, 0.17034768E-05_JPRB, 0.17035692E-05_JPRB, 0.17037483E-05_JPRB, &
  & 0.17037884E-05_JPRB, 0.17036878E-05_JPRB, 0.17038369E-05_JPRB, 0.17033058E-05_JPRB, 0.17030751E-05_JPRB, 0.17029040E-05_JPRB, &
  & 0.17028780E-05_JPRB, 0.17029183E-05_JPRB, 0.17028134E-05_JPRB, 0.17029089E-05_JPRB, 0.17028234E-05_JPRB, 0.17026356E-05_JPRB, &
  & 0.17027575E-05_JPRB, 0.17025971E-05_JPRB, 0.17012500E-05_JPRB, 0.16998387E-05_JPRB, 0.16978892E-05_JPRB, 0.16955178E-05_JPRB, &
  & 0.16966822E-05_JPRB, 0.16924544E-05_JPRB, 0.16904718E-05_JPRB, 0.16920340E-05_JPRB, 0.16898248E-05_JPRB, 0.16941262E-05_JPRB, &
  & 0.17005899E-05_JPRB, 0.17035556E-05_JPRB, 0.17093320E-05_JPRB, 0.17084789E-05_JPRB, 0.17229238E-05_JPRB, 0.17477118E-05_JPRB, &
  & 0.17576350E-05_JPRB, 0.17649620E-05_JPRB, 0.17724062E-05_JPRB, 0.17918583E-05_JPRB, 0.18159039E-05_JPRB, 0.18207115E-05_JPRB, &
  & 0.17986564E-05_JPRB, 0.17935597E-05_JPRB, 0.17979894E-05_JPRB, 0.18098741E-05_JPRB, 0.18119443E-05_JPRB, 0.18110218E-05_JPRB, &
  & 0.18169529E-05_JPRB, 0.18240391E-05_JPRB, 0.18328274E-05_JPRB, 0.18393844E-05_JPRB, 0.18364883E-05_JPRB, 0.18364323E-05_JPRB, &
  & 0.18380068E-05_JPRB, 0.18365173E-05_JPRB, 0.18317325E-05_JPRB, 0.18233354E-05_JPRB, 0.18184561E-05_JPRB, 0.18163958E-05_JPRB, &
  & 0.18160683E-05_JPRB, 0.18156340E-05_JPRB, 0.18153324E-05_JPRB, 0.18149700E-05_JPRB  /)

RGHG2(:,91,10) = (/ &
  & 0.17032842E-05_JPRB, 0.17033139E-05_JPRB, 0.17034159E-05_JPRB, 0.17034752E-05_JPRB, 0.17035740E-05_JPRB, 0.17037945E-05_JPRB, &
  & 0.17038538E-05_JPRB, 0.17036958E-05_JPRB, 0.17038736E-05_JPRB, 0.17033106E-05_JPRB, 0.17030735E-05_JPRB, 0.17029056E-05_JPRB, &
  & 0.17028891E-05_JPRB, 0.17029550E-05_JPRB, 0.17028661E-05_JPRB, 0.17030636E-05_JPRB, 0.17029813E-05_JPRB, 0.17027904E-05_JPRB, &
  & 0.17032250E-05_JPRB, 0.17030933E-05_JPRB, 0.17017302E-05_JPRB, 0.17003540E-05_JPRB, 0.16985992E-05_JPRB, 0.16958896E-05_JPRB, &
  & 0.16978485E-05_JPRB, 0.16931931E-05_JPRB, 0.16916062E-05_JPRB, 0.16940491E-05_JPRB, 0.16911123E-05_JPRB, 0.16961892E-05_JPRB, &
  & 0.17047493E-05_JPRB, 0.17093521E-05_JPRB, 0.17145540E-05_JPRB, 0.17112024E-05_JPRB, 0.17255835E-05_JPRB, 0.17545102E-05_JPRB, &
  & 0.17621518E-05_JPRB, 0.17694214E-05_JPRB, 0.17782186E-05_JPRB, 0.18095093E-05_JPRB, 0.18481057E-05_JPRB, 0.18486885E-05_JPRB, &
  & 0.18175295E-05_JPRB, 0.18071453E-05_JPRB, 0.18113102E-05_JPRB, 0.18252435E-05_JPRB, 0.18252172E-05_JPRB, 0.18176447E-05_JPRB, &
  & 0.18217569E-05_JPRB, 0.18284635E-05_JPRB, 0.18380047E-05_JPRB, 0.18450372E-05_JPRB, 0.18394830E-05_JPRB, 0.18382879E-05_JPRB, &
  & 0.18398847E-05_JPRB, 0.18385612E-05_JPRB, 0.18337444E-05_JPRB, 0.18239529E-05_JPRB, 0.18186588E-05_JPRB, 0.18165154E-05_JPRB, &
  & 0.18163475E-05_JPRB, 0.18157154E-05_JPRB, 0.18153499E-05_JPRB, 0.18149812E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ---GEMS----

RGHG2(:, 1,11) = (/ &
  & 0.15376462E-06_JPRB, 0.15389796E-06_JPRB, 0.15411361E-06_JPRB, 0.15443626E-06_JPRB, 0.15489884E-06_JPRB, 0.15556555E-06_JPRB, &
  & 0.15643967E-06_JPRB, 0.15745372E-06_JPRB, 0.15830480E-06_JPRB, 0.15890236E-06_JPRB, 0.15934025E-06_JPRB, 0.15967442E-06_JPRB, &
  & 0.15992464E-06_JPRB, 0.16014194E-06_JPRB, 0.16040039E-06_JPRB, 0.16074938E-06_JPRB, 0.16122348E-06_JPRB, 0.16183422E-06_JPRB, &
  & 0.16254702E-06_JPRB, 0.16332237E-06_JPRB, 0.16410925E-06_JPRB, 0.16490435E-06_JPRB, 0.16575708E-06_JPRB, 0.16675796E-06_JPRB, &
  & 0.16798108E-06_JPRB, 0.16955483E-06_JPRB, 0.17154671E-06_JPRB, 0.17397813E-06_JPRB, 0.17674866E-06_JPRB, 0.17984019E-06_JPRB, &
  & 0.18337620E-06_JPRB, 0.18750319E-06_JPRB, 0.19248619E-06_JPRB, 0.19831698E-06_JPRB, 0.20399632E-06_JPRB, 0.20883446E-06_JPRB, &
  & 0.21286267E-06_JPRB, 0.21616163E-06_JPRB, 0.21866054E-06_JPRB, 0.22041043E-06_JPRB, 0.22136193E-06_JPRB, 0.22171257E-06_JPRB, &
  & 0.22170927E-06_JPRB, 0.22158416E-06_JPRB, 0.22164672E-06_JPRB, 0.22148539E-06_JPRB, 0.22081046E-06_JPRB, 0.21983756E-06_JPRB, &
  & 0.21854037E-06_JPRB, 0.21720037E-06_JPRB, 0.21553443E-06_JPRB, 0.21351621E-06_JPRB, 0.21165437E-06_JPRB, 0.20949129E-06_JPRB, &
  & 0.20732655E-06_JPRB, 0.20520956E-06_JPRB, 0.20325224E-06_JPRB, 0.20146284E-06_JPRB, 0.19980842E-06_JPRB, 0.19862317E-06_JPRB, &
  & 0.19748895E-06_JPRB, 0.19578350E-06_JPRB, 0.19419987E-06_JPRB, 0.19379326E-06_JPRB  /)

RGHG2(:, 2,11) = (/ &
  & 0.15376462E-06_JPRB, 0.15389796E-06_JPRB, 0.15411361E-06_JPRB, 0.15443626E-06_JPRB, 0.15489884E-06_JPRB, 0.15556555E-06_JPRB, &
  & 0.15643967E-06_JPRB, 0.15745372E-06_JPRB, 0.15830480E-06_JPRB, 0.15890236E-06_JPRB, 0.15934025E-06_JPRB, 0.15967442E-06_JPRB, &
  & 0.15992464E-06_JPRB, 0.16014194E-06_JPRB, 0.16040039E-06_JPRB, 0.16074938E-06_JPRB, 0.16122348E-06_JPRB, 0.16183422E-06_JPRB, &
  & 0.16254702E-06_JPRB, 0.16332237E-06_JPRB, 0.16410925E-06_JPRB, 0.16490435E-06_JPRB, 0.16575708E-06_JPRB, 0.16675796E-06_JPRB, &
  & 0.16798108E-06_JPRB, 0.16955483E-06_JPRB, 0.17154671E-06_JPRB, 0.17397813E-06_JPRB, 0.17674866E-06_JPRB, 0.17984019E-06_JPRB, &
  & 0.18337620E-06_JPRB, 0.18750319E-06_JPRB, 0.19248619E-06_JPRB, 0.19831698E-06_JPRB, 0.20399632E-06_JPRB, 0.20883446E-06_JPRB, &
  & 0.21286267E-06_JPRB, 0.21616163E-06_JPRB, 0.21866054E-06_JPRB, 0.22041043E-06_JPRB, 0.22136193E-06_JPRB, 0.22171257E-06_JPRB, &
  & 0.22170927E-06_JPRB, 0.22158416E-06_JPRB, 0.22164672E-06_JPRB, 0.22148539E-06_JPRB, 0.22081046E-06_JPRB, 0.21983756E-06_JPRB, &
  & 0.21854037E-06_JPRB, 0.21720037E-06_JPRB, 0.21553443E-06_JPRB, 0.21351621E-06_JPRB, 0.21165437E-06_JPRB, 0.20949129E-06_JPRB, &
  & 0.20732655E-06_JPRB, 0.20520956E-06_JPRB, 0.20325224E-06_JPRB, 0.20146284E-06_JPRB, 0.19980842E-06_JPRB, 0.19862317E-06_JPRB, &
  & 0.19748895E-06_JPRB, 0.19578350E-06_JPRB, 0.19419987E-06_JPRB, 0.19379326E-06_JPRB  /)

RGHG2(:, 3,11) = (/ &
  & 0.15376462E-06_JPRB, 0.15389796E-06_JPRB, 0.15411361E-06_JPRB, 0.15443626E-06_JPRB, 0.15489884E-06_JPRB, 0.15556555E-06_JPRB, &
  & 0.15643967E-06_JPRB, 0.15745372E-06_JPRB, 0.15830480E-06_JPRB, 0.15890236E-06_JPRB, 0.15934025E-06_JPRB, 0.15967442E-06_JPRB, &
  & 0.15992464E-06_JPRB, 0.16014194E-06_JPRB, 0.16040039E-06_JPRB, 0.16074938E-06_JPRB, 0.16122348E-06_JPRB, 0.16183422E-06_JPRB, &
  & 0.16254702E-06_JPRB, 0.16332237E-06_JPRB, 0.16410925E-06_JPRB, 0.16490435E-06_JPRB, 0.16575708E-06_JPRB, 0.16675796E-06_JPRB, &
  & 0.16798108E-06_JPRB, 0.16955483E-06_JPRB, 0.17154671E-06_JPRB, 0.17397813E-06_JPRB, 0.17674866E-06_JPRB, 0.17984019E-06_JPRB, &
  & 0.18337620E-06_JPRB, 0.18750319E-06_JPRB, 0.19248619E-06_JPRB, 0.19831698E-06_JPRB, 0.20399632E-06_JPRB, 0.20883446E-06_JPRB, &
  & 0.21286267E-06_JPRB, 0.21616163E-06_JPRB, 0.21866054E-06_JPRB, 0.22041043E-06_JPRB, 0.22136193E-06_JPRB, 0.22171257E-06_JPRB, &
  & 0.22170927E-06_JPRB, 0.22158416E-06_JPRB, 0.22164672E-06_JPRB, 0.22148539E-06_JPRB, 0.22081046E-06_JPRB, 0.21983756E-06_JPRB, &
  & 0.21854037E-06_JPRB, 0.21720037E-06_JPRB, 0.21553443E-06_JPRB, 0.21351621E-06_JPRB, 0.21165437E-06_JPRB, 0.20949129E-06_JPRB, &
  & 0.20732655E-06_JPRB, 0.20520956E-06_JPRB, 0.20325224E-06_JPRB, 0.20146284E-06_JPRB, 0.19980842E-06_JPRB, 0.19862317E-06_JPRB, &
  & 0.19748895E-06_JPRB, 0.19578350E-06_JPRB, 0.19419987E-06_JPRB, 0.19379326E-06_JPRB  /)

RGHG2(:, 4,11) = (/ &
  & 0.15376585E-06_JPRB, 0.15389936E-06_JPRB, 0.15411576E-06_JPRB, 0.15443974E-06_JPRB, 0.15490383E-06_JPRB, 0.15557184E-06_JPRB, &
  & 0.15644626E-06_JPRB, 0.15745933E-06_JPRB, 0.15830894E-06_JPRB, 0.15890532E-06_JPRB, 0.15934272E-06_JPRB, 0.15967708E-06_JPRB, &
  & 0.15992826E-06_JPRB, 0.16014706E-06_JPRB, 0.16040689E-06_JPRB, 0.16075687E-06_JPRB, 0.16123216E-06_JPRB, 0.16184430E-06_JPRB, &
  & 0.16255842E-06_JPRB, 0.16333506E-06_JPRB, 0.16412351E-06_JPRB, 0.16492073E-06_JPRB, 0.16577600E-06_JPRB, 0.16678003E-06_JPRB, &
  & 0.16800838E-06_JPRB, 0.16959024E-06_JPRB, 0.17159259E-06_JPRB, 0.17403623E-06_JPRB, 0.17682007E-06_JPRB, 0.17992586E-06_JPRB, &
  & 0.18347512E-06_JPRB, 0.18761127E-06_JPRB, 0.19259930E-06_JPRB, 0.19843172E-06_JPRB, 0.20410654E-06_JPRB, 0.20893370E-06_JPRB, &
  & 0.21294839E-06_JPRB, 0.21623345E-06_JPRB, 0.21872110E-06_JPRB, 0.22046199E-06_JPRB, 0.22140517E-06_JPRB, 0.22174926E-06_JPRB, &
  & 0.22174271E-06_JPRB, 0.22161538E-06_JPRB, 0.22167266E-06_JPRB, 0.22150445E-06_JPRB, 0.22082210E-06_JPRB, 0.21984050E-06_JPRB, &
  & 0.21853673E-06_JPRB, 0.21719238E-06_JPRB, 0.21552284E-06_JPRB, 0.21350437E-06_JPRB, 0.21164144E-06_JPRB, 0.20947657E-06_JPRB, &
  & 0.20731010E-06_JPRB, 0.20519192E-06_JPRB, 0.20323553E-06_JPRB, 0.20144694E-06_JPRB, 0.19979245E-06_JPRB, 0.19860490E-06_JPRB, &
  & 0.19747050E-06_JPRB, 0.19576909E-06_JPRB, 0.19418781E-06_JPRB, 0.19377989E-06_JPRB  /)

RGHG2(:, 5,11) = (/ &
  & 0.15382444E-06_JPRB, 0.15396576E-06_JPRB, 0.15421761E-06_JPRB, 0.15460469E-06_JPRB, 0.15514089E-06_JPRB, 0.15587080E-06_JPRB, &
  & 0.15675903E-06_JPRB, 0.15772584E-06_JPRB, 0.15850574E-06_JPRB, 0.15904563E-06_JPRB, 0.15946020E-06_JPRB, 0.15980297E-06_JPRB, &
  & 0.16009982E-06_JPRB, 0.16039013E-06_JPRB, 0.16071546E-06_JPRB, 0.16111231E-06_JPRB, 0.16164409E-06_JPRB, 0.16232293E-06_JPRB, &
  & 0.16309954E-06_JPRB, 0.16393747E-06_JPRB, 0.16480043E-06_JPRB, 0.16569800E-06_JPRB, 0.16667406E-06_JPRB, 0.16782771E-06_JPRB, &
  & 0.16930423E-06_JPRB, 0.17127128E-06_JPRB, 0.17376998E-06_JPRB, 0.17679410E-06_JPRB, 0.18020949E-06_JPRB, 0.18399190E-06_JPRB, &
  & 0.18817031E-06_JPRB, 0.19274152E-06_JPRB, 0.19796811E-06_JPRB, 0.20387805E-06_JPRB, 0.20933835E-06_JPRB, 0.21364452E-06_JPRB, &
  & 0.21701683E-06_JPRB, 0.21964271E-06_JPRB, 0.22159554E-06_JPRB, 0.22290919E-06_JPRB, 0.22345757E-06_JPRB, 0.22349099E-06_JPRB, &
  & 0.22333001E-06_JPRB, 0.22309691E-06_JPRB, 0.22290423E-06_JPRB, 0.22240912E-06_JPRB, 0.22137463E-06_JPRB, 0.21998021E-06_JPRB, &
  & 0.21836397E-06_JPRB, 0.21681290E-06_JPRB, 0.21497271E-06_JPRB, 0.21294222E-06_JPRB, 0.21102761E-06_JPRB, 0.20877801E-06_JPRB, &
  & 0.20652922E-06_JPRB, 0.20435455E-06_JPRB, 0.20244203E-06_JPRB, 0.20069250E-06_JPRB, 0.19903441E-06_JPRB, 0.19773748E-06_JPRB, &
  & 0.19659467E-06_JPRB, 0.19508495E-06_JPRB, 0.19361545E-06_JPRB, 0.19314503E-06_JPRB  /)

RGHG2(:, 6,11) = (/ &
  & 0.15391234E-06_JPRB, 0.15406538E-06_JPRB, 0.15437043E-06_JPRB, 0.15485217E-06_JPRB, 0.15549656E-06_JPRB, 0.15631933E-06_JPRB, &
  & 0.15722830E-06_JPRB, 0.15812568E-06_JPRB, 0.15880101E-06_JPRB, 0.15925615E-06_JPRB, 0.15963646E-06_JPRB, 0.15999185E-06_JPRB, &
  & 0.16035722E-06_JPRB, 0.16075481E-06_JPRB, 0.16117842E-06_JPRB, 0.16164559E-06_JPRB, 0.16226211E-06_JPRB, 0.16304103E-06_JPRB, &
  & 0.16391140E-06_JPRB, 0.16484130E-06_JPRB, 0.16581605E-06_JPRB, 0.16686419E-06_JPRB, 0.16802146E-06_JPRB, 0.16939961E-06_JPRB, &
  & 0.17124847E-06_JPRB, 0.17379343E-06_JPRB, 0.17703682E-06_JPRB, 0.18093186E-06_JPRB, 0.18529480E-06_JPRB, 0.19009239E-06_JPRB, &
  & 0.19521475E-06_JPRB, 0.20043869E-06_JPRB, 0.20602321E-06_JPRB, 0.21204945E-06_JPRB, 0.21718788E-06_JPRB, 0.22071240E-06_JPRB, &
  & 0.22312093E-06_JPRB, 0.22475777E-06_JPRB, 0.22590821E-06_JPRB, 0.22658084E-06_JPRB, 0.22653689E-06_JPRB, 0.22610420E-06_JPRB, &
  & 0.22571151E-06_JPRB, 0.22531974E-06_JPRB, 0.22475200E-06_JPRB, 0.22376643E-06_JPRB, 0.22220363E-06_JPRB, 0.22018983E-06_JPRB, &
  & 0.21810476E-06_JPRB, 0.21624356E-06_JPRB, 0.21414732E-06_JPRB, 0.21209880E-06_JPRB, 0.21010666E-06_JPRB, 0.20772994E-06_JPRB, &
  & 0.20535763E-06_JPRB, 0.20309821E-06_JPRB, 0.20125150E-06_JPRB, 0.19956058E-06_JPRB, 0.19789707E-06_JPRB, 0.19643607E-06_JPRB, &
  & 0.19528063E-06_JPRB, 0.19405851E-06_JPRB, 0.19275670E-06_JPRB, 0.19219252E-06_JPRB  /)

RGHG2(:, 7,11) = (/ &
  & 0.15402709E-06_JPRB, 0.15435361E-06_JPRB, 0.15485257E-06_JPRB, 0.15547357E-06_JPRB, 0.15617998E-06_JPRB, 0.15694218E-06_JPRB, &
  & 0.15772867E-06_JPRB, 0.15851001E-06_JPRB, 0.15910430E-06_JPRB, 0.15955227E-06_JPRB, 0.16003046E-06_JPRB, 0.16057387E-06_JPRB, &
  & 0.16117139E-06_JPRB, 0.16171625E-06_JPRB, 0.16215619E-06_JPRB, 0.16261918E-06_JPRB, 0.16330769E-06_JPRB, 0.16425133E-06_JPRB, &
  & 0.16537809E-06_JPRB, 0.16666390E-06_JPRB, 0.16805710E-06_JPRB, 0.16955916E-06_JPRB, 0.17119125E-06_JPRB, 0.17314310E-06_JPRB, &
  & 0.17586593E-06_JPRB, 0.17967166E-06_JPRB, 0.18452923E-06_JPRB, 0.19030780E-06_JPRB, 0.19676599E-06_JPRB, 0.20374476E-06_JPRB, &
  & 0.21057302E-06_JPRB, 0.21659338E-06_JPRB, 0.22182875E-06_JPRB, 0.22648733E-06_JPRB, 0.22987245E-06_JPRB, 0.23170849E-06_JPRB, &
  & 0.23287011E-06_JPRB, 0.23371103E-06_JPRB, 0.23380980E-06_JPRB, 0.23299852E-06_JPRB, 0.23175547E-06_JPRB, 0.23042697E-06_JPRB, &
  & 0.22930936E-06_JPRB, 0.22811583E-06_JPRB, 0.22646698E-06_JPRB, 0.22433005E-06_JPRB, 0.22173895E-06_JPRB, 0.21879369E-06_JPRB, &
  & 0.21618376E-06_JPRB, 0.21379401E-06_JPRB, 0.21142705E-06_JPRB, 0.20934710E-06_JPRB, 0.20717088E-06_JPRB, 0.20465636E-06_JPRB, &
  & 0.20210357E-06_JPRB, 0.19983081E-06_JPRB, 0.19805333E-06_JPRB, 0.19645528E-06_JPRB, 0.19474881E-06_JPRB, 0.19337093E-06_JPRB, &
  & 0.19242350E-06_JPRB, 0.19141497E-06_JPRB, 0.19016119E-06_JPRB, 0.18958030E-06_JPRB  /)

RGHG2(:, 8,11) = (/ &
  & 0.15612421E-06_JPRB, 0.15652041E-06_JPRB, 0.15708876E-06_JPRB, 0.15769959E-06_JPRB, 0.15831185E-06_JPRB, 0.15892103E-06_JPRB, &
  & 0.15959500E-06_JPRB, 0.16045401E-06_JPRB, 0.16119094E-06_JPRB, 0.16173866E-06_JPRB, 0.16236634E-06_JPRB, 0.16319105E-06_JPRB, &
  & 0.16414948E-06_JPRB, 0.16480239E-06_JPRB, 0.16506660E-06_JPRB, 0.16537670E-06_JPRB, 0.16608318E-06_JPRB, 0.16726866E-06_JPRB, &
  & 0.16888096E-06_JPRB, 0.17085274E-06_JPRB, 0.17295360E-06_JPRB, 0.17513884E-06_JPRB, 0.17766104E-06_JPRB, 0.18083666E-06_JPRB, &
  & 0.18507254E-06_JPRB, 0.19086140E-06_JPRB, 0.19848636E-06_JPRB, 0.20743208E-06_JPRB, 0.21702468E-06_JPRB, 0.22732483E-06_JPRB, &
  & 0.23727935E-06_JPRB, 0.24511205E-06_JPRB, 0.24973629E-06_JPRB, 0.25123564E-06_JPRB, 0.25034401E-06_JPRB, 0.24868351E-06_JPRB, &
  & 0.24750322E-06_JPRB, 0.24653172E-06_JPRB, 0.24467798E-06_JPRB, 0.24189566E-06_JPRB, 0.23902155E-06_JPRB, 0.23638770E-06_JPRB, &
  & 0.23401118E-06_JPRB, 0.23144380E-06_JPRB, 0.22813918E-06_JPRB, 0.22435600E-06_JPRB, 0.22028433E-06_JPRB, 0.21612012E-06_JPRB, &
  & 0.21264414E-06_JPRB, 0.20955074E-06_JPRB, 0.20680493E-06_JPRB, 0.20446827E-06_JPRB, 0.20213253E-06_JPRB, 0.19952928E-06_JPRB, &
  & 0.19686553E-06_JPRB, 0.19459587E-06_JPRB, 0.19278729E-06_JPRB, 0.19126961E-06_JPRB, 0.18971182E-06_JPRB, 0.18858107E-06_JPRB, &
  & 0.18775442E-06_JPRB, 0.18678359E-06_JPRB, 0.18563398E-06_JPRB, 0.18507948E-06_JPRB  /)

RGHG2(:, 9,11) = (/ &
  & 0.16312303E-06_JPRB, 0.16345719E-06_JPRB, 0.16398599E-06_JPRB, 0.16462033E-06_JPRB, 0.16521067E-06_JPRB, 0.16575112E-06_JPRB, &
  & 0.16648586E-06_JPRB, 0.16773291E-06_JPRB, 0.16897773E-06_JPRB, 0.16979151E-06_JPRB, 0.17059115E-06_JPRB, 0.17163118E-06_JPRB, &
  & 0.17288010E-06_JPRB, 0.17345041E-06_JPRB, 0.17332847E-06_JPRB, 0.17327785E-06_JPRB, 0.17376278E-06_JPRB, 0.17516096E-06_JPRB, &
  & 0.17749511E-06_JPRB, 0.18054852E-06_JPRB, 0.18384236E-06_JPRB, 0.18712510E-06_JPRB, 0.19115534E-06_JPRB, 0.19672150E-06_JPRB, &
  & 0.20360781E-06_JPRB, 0.21241471E-06_JPRB, 0.22417443E-06_JPRB, 0.23787973E-06_JPRB, 0.25165927E-06_JPRB, 0.26642496E-06_JPRB, &
  & 0.28115047E-06_JPRB, 0.29203789E-06_JPRB, 0.29554633E-06_JPRB, 0.29119267E-06_JPRB, 0.28271807E-06_JPRB, 0.27530379E-06_JPRB, &
  & 0.26995146E-06_JPRB, 0.26541202E-06_JPRB, 0.26050831E-06_JPRB, 0.25534376E-06_JPRB, 0.25029059E-06_JPRB, 0.24587246E-06_JPRB, &
  & 0.24159337E-06_JPRB, 0.23697741E-06_JPRB, 0.23131271E-06_JPRB, 0.22523428E-06_JPRB, 0.21915205E-06_JPRB, 0.21331225E-06_JPRB, &
  & 0.20845268E-06_JPRB, 0.20446834E-06_JPRB, 0.20108298E-06_JPRB, 0.19820819E-06_JPRB, 0.19572623E-06_JPRB, 0.19315694E-06_JPRB, &
  & 0.19055310E-06_JPRB, 0.18826178E-06_JPRB, 0.18636363E-06_JPRB, 0.18484518E-06_JPRB, 0.18353548E-06_JPRB, 0.18254112E-06_JPRB, &
  & 0.18153563E-06_JPRB, 0.18039851E-06_JPRB, 0.17941166E-06_JPRB, 0.17888909E-06_JPRB  /)

RGHG2(:,10,11) = (/ &
  & 0.17916366E-06_JPRB, 0.17968469E-06_JPRB, 0.18066904E-06_JPRB, 0.18199039E-06_JPRB, 0.18313036E-06_JPRB, 0.18398404E-06_JPRB, &
  & 0.18497698E-06_JPRB, 0.18653906E-06_JPRB, 0.18841901E-06_JPRB, 0.18980861E-06_JPRB, 0.19109765E-06_JPRB, 0.19223591E-06_JPRB, &
  & 0.19323604E-06_JPRB, 0.19325883E-06_JPRB, 0.19264265E-06_JPRB, 0.19187766E-06_JPRB, 0.19144298E-06_JPRB, 0.19275863E-06_JPRB, &
  & 0.19595245E-06_JPRB, 0.20038327E-06_JPRB, 0.20549715E-06_JPRB, 0.21048200E-06_JPRB, 0.21676821E-06_JPRB, 0.22627448E-06_JPRB, &
  & 0.23742580E-06_JPRB, 0.25093570E-06_JPRB, 0.26840223E-06_JPRB, 0.28805622E-06_JPRB, 0.30707476E-06_JPRB, 0.32699695E-06_JPRB, &
  & 0.34707226E-06_JPRB, 0.36073573E-06_JPRB, 0.36106493E-06_JPRB, 0.34803859E-06_JPRB, 0.33061945E-06_JPRB, 0.31672156E-06_JPRB, &
  & 0.30576987E-06_JPRB, 0.29633404E-06_JPRB, 0.28785324E-06_JPRB, 0.27957825E-06_JPRB, 0.27142266E-06_JPRB, 0.26399967E-06_JPRB, &
  & 0.25679651E-06_JPRB, 0.24937548E-06_JPRB, 0.24088959E-06_JPRB, 0.23192118E-06_JPRB, 0.22320723E-06_JPRB, 0.21507780E-06_JPRB, &
  & 0.20814517E-06_JPRB, 0.20265583E-06_JPRB, 0.19803549E-06_JPRB, 0.19443674E-06_JPRB, 0.19168990E-06_JPRB, 0.18920472E-06_JPRB, &
  & 0.18679047E-06_JPRB, 0.18451480E-06_JPRB, 0.18257556E-06_JPRB, 0.18090824E-06_JPRB, 0.17957658E-06_JPRB, 0.17824969E-06_JPRB, &
  & 0.17684302E-06_JPRB, 0.17546299E-06_JPRB, 0.17446413E-06_JPRB, 0.17394193E-06_JPRB  /)

RGHG2(:,11,11) = (/ &
  & 0.20840187E-06_JPRB, 0.20907456E-06_JPRB, 0.21055268E-06_JPRB, 0.21256574E-06_JPRB, 0.21446905E-06_JPRB, 0.21605453E-06_JPRB, &
  & 0.21750536E-06_JPRB, 0.21922041E-06_JPRB, 0.22169482E-06_JPRB, 0.22416816E-06_JPRB, 0.22665732E-06_JPRB, 0.22826212E-06_JPRB, &
  & 0.22872276E-06_JPRB, 0.22783613E-06_JPRB, 0.22623588E-06_JPRB, 0.22373859E-06_JPRB, 0.22131726E-06_JPRB, 0.22202986E-06_JPRB, &
  & 0.22601186E-06_JPRB, 0.23193366E-06_JPRB, 0.23892063E-06_JPRB, 0.24579134E-06_JPRB, 0.25488067E-06_JPRB, 0.26945575E-06_JPRB, &
  & 0.28656908E-06_JPRB, 0.30720972E-06_JPRB, 0.33207083E-06_JPRB, 0.35746993E-06_JPRB, 0.38218689E-06_JPRB, 0.40738679E-06_JPRB, &
  & 0.43194939E-06_JPRB, 0.44620309E-06_JPRB, 0.44075935E-06_JPRB, 0.41928887E-06_JPRB, 0.39600604E-06_JPRB, 0.37802039E-06_JPRB, &
  & 0.36307736E-06_JPRB, 0.35009899E-06_JPRB, 0.33824825E-06_JPRB, 0.32612174E-06_JPRB, 0.31280864E-06_JPRB, 0.29836807E-06_JPRB, &
  & 0.28558755E-06_JPRB, 0.27394139E-06_JPRB, 0.26270248E-06_JPRB, 0.25093557E-06_JPRB, 0.23932278E-06_JPRB, 0.22886770E-06_JPRB, &
  & 0.21904869E-06_JPRB, 0.21054361E-06_JPRB, 0.20399131E-06_JPRB, 0.19972828E-06_JPRB, 0.19663357E-06_JPRB, 0.19393573E-06_JPRB, &
  & 0.19150733E-06_JPRB, 0.18915051E-06_JPRB, 0.18703145E-06_JPRB, 0.18478411E-06_JPRB, 0.18260509E-06_JPRB, 0.18054774E-06_JPRB, &
  & 0.17864929E-06_JPRB, 0.17687023E-06_JPRB, 0.17544815E-06_JPRB, 0.17469490E-06_JPRB  /)

RGHG2(:,12,11) = (/ &
  & 0.25184649E-06_JPRB, 0.25161178E-06_JPRB, 0.25212829E-06_JPRB, 0.25334128E-06_JPRB, 0.25516342E-06_JPRB, 0.25743306E-06_JPRB, &
  & 0.25983303E-06_JPRB, 0.26283685E-06_JPRB, 0.26644914E-06_JPRB, 0.26988277E-06_JPRB, 0.27304834E-06_JPRB, 0.27530895E-06_JPRB, &
  & 0.27631952E-06_JPRB, 0.27509663E-06_JPRB, 0.27146748E-06_JPRB, 0.26574675E-06_JPRB, 0.26082963E-06_JPRB, 0.26048900E-06_JPRB, &
  & 0.26476908E-06_JPRB, 0.27146088E-06_JPRB, 0.27912215E-06_JPRB, 0.28766677E-06_JPRB, 0.29927176E-06_JPRB, 0.31861236E-06_JPRB, &
  & 0.34377877E-06_JPRB, 0.37301083E-06_JPRB, 0.40486362E-06_JPRB, 0.43610791E-06_JPRB, 0.46627783E-06_JPRB, 0.49663689E-06_JPRB, &
  & 0.52558156E-06_JPRB, 0.54101956E-06_JPRB, 0.53279086E-06_JPRB, 0.50838738E-06_JPRB, 0.48494847E-06_JPRB, 0.46674265E-06_JPRB, &
  & 0.45181246E-06_JPRB, 0.43891471E-06_JPRB, 0.42530330E-06_JPRB, 0.40910987E-06_JPRB, 0.38613642E-06_JPRB, 0.35725201E-06_JPRB, &
  & 0.33303068E-06_JPRB, 0.31385229E-06_JPRB, 0.29831422E-06_JPRB, 0.28408250E-06_JPRB, 0.27073340E-06_JPRB, 0.25826845E-06_JPRB, &
  & 0.24561970E-06_JPRB, 0.23374440E-06_JPRB, 0.22550848E-06_JPRB, 0.22082018E-06_JPRB, 0.21734404E-06_JPRB, 0.21384292E-06_JPRB, &
  & 0.21064603E-06_JPRB, 0.20737934E-06_JPRB, 0.20430289E-06_JPRB, 0.20065318E-06_JPRB, 0.19555990E-06_JPRB, 0.19104006E-06_JPRB, &
  & 0.18771435E-06_JPRB, 0.18496429E-06_JPRB, 0.18282337E-06_JPRB, 0.18137177E-06_JPRB  /)

RGHG2(:,13,11) = (/ &
  & 0.30633256E-06_JPRB, 0.30488804E-06_JPRB, 0.30460528E-06_JPRB, 0.30499363E-06_JPRB, 0.30636016E-06_JPRB, 0.30898117E-06_JPRB, &
  & 0.31197199E-06_JPRB, 0.31597633E-06_JPRB, 0.32059656E-06_JPRB, 0.32445952E-06_JPRB, 0.32720628E-06_JPRB, 0.32912887E-06_JPRB, &
  & 0.33070464E-06_JPRB, 0.32997577E-06_JPRB, 0.32475874E-06_JPRB, 0.31615847E-06_JPRB, 0.30942036E-06_JPRB, 0.30851731E-06_JPRB, &
  & 0.31275438E-06_JPRB, 0.31858332E-06_JPRB, 0.32489950E-06_JPRB, 0.33455960E-06_JPRB, 0.34848063E-06_JPRB, 0.37119458E-06_JPRB, &
  & 0.40349411E-06_JPRB, 0.43979569E-06_JPRB, 0.47628897E-06_JPRB, 0.51433823E-06_JPRB, 0.55509309E-06_JPRB, 0.59716820E-06_JPRB, &
  & 0.63460950E-06_JPRB, 0.65448390E-06_JPRB, 0.64873607E-06_JPRB, 0.62816915E-06_JPRB, 0.60577187E-06_JPRB, 0.58729584E-06_JPRB, &
  & 0.57402964E-06_JPRB, 0.56203534E-06_JPRB, 0.54713831E-06_JPRB, 0.52450511E-06_JPRB, 0.48767931E-06_JPRB, 0.43905764E-06_JPRB, &
  & 0.39678409E-06_JPRB, 0.36676660E-06_JPRB, 0.34641250E-06_JPRB, 0.33032674E-06_JPRB, 0.31592856E-06_JPRB, 0.30092736E-06_JPRB, &
  & 0.28706015E-06_JPRB, 0.27460601E-06_JPRB, 0.26580987E-06_JPRB, 0.25989995E-06_JPRB, 0.25529448E-06_JPRB, 0.25063097E-06_JPRB, &
  & 0.24569706E-06_JPRB, 0.24058495E-06_JPRB, 0.23490625E-06_JPRB, 0.22921347E-06_JPRB, 0.22068077E-06_JPRB, 0.21044425E-06_JPRB, &
  & 0.20299553E-06_JPRB, 0.19827434E-06_JPRB, 0.19490976E-06_JPRB, 0.19302007E-06_JPRB  /)

RGHG2(:,14,11) = (/ &
  & 0.36845293E-06_JPRB, 0.36540692E-06_JPRB, 0.36503949E-06_JPRB, 0.36550230E-06_JPRB, 0.36707062E-06_JPRB, 0.37008758E-06_JPRB, &
  & 0.37267820E-06_JPRB, 0.37579739E-06_JPRB, 0.38004123E-06_JPRB, 0.38405996E-06_JPRB, 0.38687456E-06_JPRB, 0.38772083E-06_JPRB, &
  & 0.38807532E-06_JPRB, 0.38796964E-06_JPRB, 0.38434512E-06_JPRB, 0.37592844E-06_JPRB, 0.36858281E-06_JPRB, 0.36746079E-06_JPRB, &
  & 0.37191396E-06_JPRB, 0.37683557E-06_JPRB, 0.38148038E-06_JPRB, 0.39032903E-06_JPRB, 0.40631156E-06_JPRB, 0.43047986E-06_JPRB, &
  & 0.46424453E-06_JPRB, 0.50381901E-06_JPRB, 0.54376569E-06_JPRB, 0.59004032E-06_JPRB, 0.64885233E-06_JPRB, 0.71363115E-06_JPRB, &
  & 0.76990982E-06_JPRB, 0.79880533E-06_JPRB, 0.79828499E-06_JPRB, 0.77994792E-06_JPRB, 0.75318051E-06_JPRB, 0.72459801E-06_JPRB, &
  & 0.70297465E-06_JPRB, 0.68519994E-06_JPRB, 0.66308885E-06_JPRB, 0.62988347E-06_JPRB, 0.57937419E-06_JPRB, 0.51671114E-06_JPRB, &
  & 0.46097974E-06_JPRB, 0.42406841E-06_JPRB, 0.40025288E-06_JPRB, 0.38243145E-06_JPRB, 0.36681864E-06_JPRB, 0.35001445E-06_JPRB, &
  & 0.33707770E-06_JPRB, 0.32770360E-06_JPRB, 0.32008512E-06_JPRB, 0.31171298E-06_JPRB, 0.30417509E-06_JPRB, 0.29772390E-06_JPRB, &
  & 0.29028606E-06_JPRB, 0.28233346E-06_JPRB, 0.27293475E-06_JPRB, 0.26332711E-06_JPRB, 0.25321768E-06_JPRB, 0.23923927E-06_JPRB, &
  & 0.22463252E-06_JPRB, 0.21577292E-06_JPRB, 0.21082142E-06_JPRB, 0.20822825E-06_JPRB  /)

RGHG2(:,15,11) = (/ &
  & 0.42935689E-06_JPRB, 0.42730346E-06_JPRB, 0.42824403E-06_JPRB, 0.42978553E-06_JPRB, 0.43229481E-06_JPRB, 0.43573954E-06_JPRB, &
  & 0.43795730E-06_JPRB, 0.43968373E-06_JPRB, 0.44240165E-06_JPRB, 0.44602329E-06_JPRB, 0.44953723E-06_JPRB, 0.44972616E-06_JPRB, &
  & 0.44809629E-06_JPRB, 0.44867946E-06_JPRB, 0.44916229E-06_JPRB, 0.44450488E-06_JPRB, 0.43768681E-06_JPRB, 0.43480020E-06_JPRB, &
  & 0.43858254E-06_JPRB, 0.44391275E-06_JPRB, 0.44967296E-06_JPRB, 0.45831627E-06_JPRB, 0.47538123E-06_JPRB, 0.50230620E-06_JPRB, &
  & 0.53502718E-06_JPRB, 0.57599962E-06_JPRB, 0.62231320E-06_JPRB, 0.68127053E-06_JPRB, 0.75510974E-06_JPRB, 0.83547540E-06_JPRB, &
  & 0.90445643E-06_JPRB, 0.94245054E-06_JPRB, 0.94804225E-06_JPRB, 0.92746983E-06_JPRB, 0.88995606E-06_JPRB, 0.84559709E-06_JPRB, &
  & 0.80525169E-06_JPRB, 0.77061498E-06_JPRB, 0.73597489E-06_JPRB, 0.69365891E-06_JPRB, 0.63844021E-06_JPRB, 0.57411741E-06_JPRB, &
  & 0.51776169E-06_JPRB, 0.47989379E-06_JPRB, 0.45326152E-06_JPRB, 0.43336295E-06_JPRB, 0.41655351E-06_JPRB, 0.40025715E-06_JPRB, &
  & 0.39052880E-06_JPRB, 0.38513355E-06_JPRB, 0.37947053E-06_JPRB, 0.36883162E-06_JPRB, 0.35718783E-06_JPRB, 0.34772860E-06_JPRB, &
  & 0.33696486E-06_JPRB, 0.32458211E-06_JPRB, 0.31208710E-06_JPRB, 0.29808335E-06_JPRB, 0.28619859E-06_JPRB, 0.27251280E-06_JPRB, &
  & 0.25301699E-06_JPRB, 0.23755348E-06_JPRB, 0.23040939E-06_JPRB, 0.22674571E-06_JPRB  /)

RGHG2(:,16,11) = (/ &
  & 0.48610661E-06_JPRB, 0.48656720E-06_JPRB, 0.48778217E-06_JPRB, 0.49068701E-06_JPRB, 0.49438300E-06_JPRB, 0.49853740E-06_JPRB, &
  & 0.50170214E-06_JPRB, 0.50353619E-06_JPRB, 0.50601749E-06_JPRB, 0.50947769E-06_JPRB, 0.51267427E-06_JPRB, 0.51394163E-06_JPRB, &
  & 0.51256908E-06_JPRB, 0.51404910E-06_JPRB, 0.51766733E-06_JPRB, 0.51767065E-06_JPRB, 0.51211187E-06_JPRB, 0.50638217E-06_JPRB, &
  & 0.50656597E-06_JPRB, 0.51223126E-06_JPRB, 0.52278585E-06_JPRB, 0.53657287E-06_JPRB, 0.55747799E-06_JPRB, 0.59156491E-06_JPRB, &
  & 0.62884703E-06_JPRB, 0.67420170E-06_JPRB, 0.72811859E-06_JPRB, 0.79045788E-06_JPRB, 0.86211235E-06_JPRB, 0.94002765E-06_JPRB, &
  & 0.10075181E-05_JPRB, 0.10466997E-05_JPRB, 0.10577264E-05_JPRB, 0.10384717E-05_JPRB, 0.99180044E-06_JPRB, 0.92945971E-06_JPRB, &
  & 0.86600353E-06_JPRB, 0.81616305E-06_JPRB, 0.77724385E-06_JPRB, 0.73652358E-06_JPRB, 0.68654757E-06_JPRB, 0.62706479E-06_JPRB, &
  & 0.57263561E-06_JPRB, 0.53165521E-06_JPRB, 0.50139019E-06_JPRB, 0.47939458E-06_JPRB, 0.46208410E-06_JPRB, 0.44749248E-06_JPRB, &
  & 0.44165789E-06_JPRB, 0.43849206E-06_JPRB, 0.43415140E-06_JPRB, 0.42286372E-06_JPRB, 0.40818868E-06_JPRB, 0.39487484E-06_JPRB, &
  & 0.38078665E-06_JPRB, 0.36405287E-06_JPRB, 0.34760350E-06_JPRB, 0.33102913E-06_JPRB, 0.31777972E-06_JPRB, 0.30455126E-06_JPRB, &
  & 0.28394817E-06_JPRB, 0.26267545E-06_JPRB, 0.25249653E-06_JPRB, 0.24753289E-06_JPRB  /)

RGHG2(:,17,11) = (/ &
  & 0.54269793E-06_JPRB, 0.54375179E-06_JPRB, 0.54357508E-06_JPRB, 0.54699628E-06_JPRB, 0.55139137E-06_JPRB, 0.55632371E-06_JPRB, &
  & 0.56116336E-06_JPRB, 0.56546414E-06_JPRB, 0.56979318E-06_JPRB, 0.57338258E-06_JPRB, 0.57721503E-06_JPRB, 0.58150342E-06_JPRB, &
  & 0.58365959E-06_JPRB, 0.58625601E-06_JPRB, 0.59082119E-06_JPRB, 0.59415661E-06_JPRB, 0.58932989E-06_JPRB, 0.58124454E-06_JPRB, &
  & 0.57766130E-06_JPRB, 0.58145101E-06_JPRB, 0.59757534E-06_JPRB, 0.62366191E-06_JPRB, 0.65492304E-06_JPRB, 0.70089428E-06_JPRB, &
  & 0.75007665E-06_JPRB, 0.80365553E-06_JPRB, 0.86019411E-06_JPRB, 0.91435875E-06_JPRB, 0.97162367E-06_JPRB, 0.10358954E-05_JPRB, &
  & 0.10906082E-05_JPRB, 0.11225748E-05_JPRB, 0.11334299E-05_JPRB, 0.11135218E-05_JPRB, 0.10606480E-05_JPRB, 0.99018196E-06_JPRB, &
  & 0.91559225E-06_JPRB, 0.85998546E-06_JPRB, 0.82292583E-06_JPRB, 0.78663407E-06_JPRB, 0.74414050E-06_JPRB, 0.69030060E-06_JPRB, &
  & 0.63145413E-06_JPRB, 0.57968892E-06_JPRB, 0.54211521E-06_JPRB, 0.51618670E-06_JPRB, 0.49802014E-06_JPRB, 0.48664255E-06_JPRB, &
  & 0.48315145E-06_JPRB, 0.48186300E-06_JPRB, 0.47620938E-06_JPRB, 0.46511527E-06_JPRB, 0.44969779E-06_JPRB, 0.43390147E-06_JPRB, &
  & 0.41720710E-06_JPRB, 0.39784455E-06_JPRB, 0.37847218E-06_JPRB, 0.36164951E-06_JPRB, 0.34852730E-06_JPRB, 0.33479869E-06_JPRB, &
  & 0.31342925E-06_JPRB, 0.28931363E-06_JPRB, 0.27661326E-06_JPRB, 0.27028053E-06_JPRB  /)

RGHG2(:,18,11) = (/ &
  & 0.59944835E-06_JPRB, 0.59636955E-06_JPRB, 0.59649316E-06_JPRB, 0.59994939E-06_JPRB, 0.60475525E-06_JPRB, 0.61046299E-06_JPRB, &
  & 0.61744847E-06_JPRB, 0.62563320E-06_JPRB, 0.63177532E-06_JPRB, 0.63839945E-06_JPRB, 0.64439596E-06_JPRB, 0.65080754E-06_JPRB, &
  & 0.65686743E-06_JPRB, 0.66171972E-06_JPRB, 0.66734591E-06_JPRB, 0.67256312E-06_JPRB, 0.67116604E-06_JPRB, 0.66240046E-06_JPRB, &
  & 0.65555423E-06_JPRB, 0.65645775E-06_JPRB, 0.67435512E-06_JPRB, 0.71564458E-06_JPRB, 0.76190045E-06_JPRB, 0.82309939E-06_JPRB, &
  & 0.88565065E-06_JPRB, 0.94465316E-06_JPRB, 0.99877886E-06_JPRB, 0.10436137E-05_JPRB, 0.10848582E-05_JPRB, 0.11301779E-05_JPRB, &
  & 0.11686474E-05_JPRB, 0.11897133E-05_JPRB, 0.11894694E-05_JPRB, 0.11621485E-05_JPRB, 0.11094455E-05_JPRB, 0.10440573E-05_JPRB, &
  & 0.97474533E-06_JPRB, 0.92255307E-06_JPRB, 0.88635830E-06_JPRB, 0.84855014E-06_JPRB, 0.80738286E-06_JPRB, 0.75224670E-06_JPRB, &
  & 0.68508023E-06_JPRB, 0.61852032E-06_JPRB, 0.57173942E-06_JPRB, 0.54365391E-06_JPRB, 0.52430789E-06_JPRB, 0.51525876E-06_JPRB, &
  & 0.51348145E-06_JPRB, 0.51218172E-06_JPRB, 0.50502151E-06_JPRB, 0.49471820E-06_JPRB, 0.48068744E-06_JPRB, 0.46477897E-06_JPRB, &
  & 0.44669722E-06_JPRB, 0.42570906E-06_JPRB, 0.40622736E-06_JPRB, 0.39060714E-06_JPRB, 0.37866550E-06_JPRB, 0.36344836E-06_JPRB, &
  & 0.34109996E-06_JPRB, 0.31593938E-06_JPRB, 0.30303050E-06_JPRB, 0.29621706E-06_JPRB  /)

RGHG2(:,19,11) = (/ &
  & 0.64909292E-06_JPRB, 0.64434902E-06_JPRB, 0.64607627E-06_JPRB, 0.65041486E-06_JPRB, 0.65546193E-06_JPRB, 0.66259545E-06_JPRB, &
  & 0.67248043E-06_JPRB, 0.68432083E-06_JPRB, 0.69421158E-06_JPRB, 0.70346821E-06_JPRB, 0.71156615E-06_JPRB, 0.71919066E-06_JPRB, &
  & 0.72788439E-06_JPRB, 0.73628072E-06_JPRB, 0.74510835E-06_JPRB, 0.75309693E-06_JPRB, 0.75636637E-06_JPRB, 0.75160209E-06_JPRB, &
  & 0.74353615E-06_JPRB, 0.74070068E-06_JPRB, 0.75612123E-06_JPRB, 0.80710519E-06_JPRB, 0.86912001E-06_JPRB, 0.94413807E-06_JPRB, &
  & 0.10174890E-05_JPRB, 0.10772328E-05_JPRB, 0.11259408E-05_JPRB, 0.11635834E-05_JPRB, 0.11942475E-05_JPRB, 0.12229769E-05_JPRB, &
  & 0.12437206E-05_JPRB, 0.12491442E-05_JPRB, 0.12348021E-05_JPRB, 0.12011643E-05_JPRB, 0.11523419E-05_JPRB, 0.10961380E-05_JPRB, &
  & 0.10395560E-05_JPRB, 0.99385658E-06_JPRB, 0.95473269E-06_JPRB, 0.91259682E-06_JPRB, 0.86600791E-06_JPRB, 0.80383701E-06_JPRB, &
  & 0.72581851E-06_JPRB, 0.64401946E-06_JPRB, 0.59035769E-06_JPRB, 0.56419119E-06_JPRB, 0.54324294E-06_JPRB, 0.53527823E-06_JPRB, &
  & 0.53410598E-06_JPRB, 0.53133829E-06_JPRB, 0.52447971E-06_JPRB, 0.51559257E-06_JPRB, 0.50427802E-06_JPRB, 0.49011609E-06_JPRB, &
  & 0.47245519E-06_JPRB, 0.45236078E-06_JPRB, 0.43461019E-06_JPRB, 0.42028756E-06_JPRB, 0.40844181E-06_JPRB, 0.39170435E-06_JPRB, &
  & 0.36818444E-06_JPRB, 0.34347793E-06_JPRB, 0.33196334E-06_JPRB, 0.32682245E-06_JPRB  /)

RGHG2(:,20,11) = (/ &
  & 0.68865839E-06_JPRB, 0.68802405E-06_JPRB, 0.69203352E-06_JPRB, 0.69733241E-06_JPRB, 0.70397136E-06_JPRB, 0.71378696E-06_JPRB, &
  & 0.72626399E-06_JPRB, 0.74084082E-06_JPRB, 0.75427862E-06_JPRB, 0.76559045E-06_JPRB, 0.77591056E-06_JPRB, 0.78497967E-06_JPRB, &
  & 0.79588366E-06_JPRB, 0.80845058E-06_JPRB, 0.82226885E-06_JPRB, 0.83508132E-06_JPRB, 0.84367037E-06_JPRB, 0.84447431E-06_JPRB, &
  & 0.83836061E-06_JPRB, 0.83279409E-06_JPRB, 0.84275225E-06_JPRB, 0.89599145E-06_JPRB, 0.96990166E-06_JPRB, 0.10547745E-05_JPRB, &
  & 0.11336267E-05_JPRB, 0.11931410E-05_JPRB, 0.12370648E-05_JPRB, 0.12692000E-05_JPRB, 0.12918253E-05_JPRB, 0.13072442E-05_JPRB, &
  & 0.13116543E-05_JPRB, 0.13019495E-05_JPRB, 0.12769052E-05_JPRB, 0.12417248E-05_JPRB, 0.11996880E-05_JPRB, 0.11535699E-05_JPRB, &
  & 0.11088755E-05_JPRB, 0.10682077E-05_JPRB, 0.10257214E-05_JPRB, 0.97872706E-06_JPRB, 0.92349866E-06_JPRB, 0.84994871E-06_JPRB, &
  & 0.75874349E-06_JPRB, 0.66349923E-06_JPRB, 0.60536913E-06_JPRB, 0.58100695E-06_JPRB, 0.55954647E-06_JPRB, 0.55067448E-06_JPRB, &
  & 0.54867884E-06_JPRB, 0.54511526E-06_JPRB, 0.53992954E-06_JPRB, 0.53314395E-06_JPRB, 0.52472823E-06_JPRB, 0.51304307E-06_JPRB, &
  & 0.49721930E-06_JPRB, 0.47992769E-06_JPRB, 0.46454438E-06_JPRB, 0.45086273E-06_JPRB, 0.43804857E-06_JPRB, 0.42018990E-06_JPRB, &
  & 0.39626188E-06_JPRB, 0.37329685E-06_JPRB, 0.36283875E-06_JPRB, 0.35969830E-06_JPRB  /)

RGHG2(:,21,11) = (/ &
  & 0.71950245E-06_JPRB, 0.72680501E-06_JPRB, 0.73398810E-06_JPRB, 0.74101806E-06_JPRB, 0.75095152E-06_JPRB, 0.76399213E-06_JPRB, &
  & 0.77821943E-06_JPRB, 0.79422730E-06_JPRB, 0.80990423E-06_JPRB, 0.82321641E-06_JPRB, 0.83593997E-06_JPRB, 0.84762293E-06_JPRB, &
  & 0.86192526E-06_JPRB, 0.87928568E-06_JPRB, 0.89884416E-06_JPRB, 0.91765910E-06_JPRB, 0.93162439E-06_JPRB, 0.93793633E-06_JPRB, &
  & 0.93601415E-06_JPRB, 0.92906557E-06_JPRB, 0.93229404E-06_JPRB, 0.98139986E-06_JPRB, 0.10610633E-05_JPRB, 0.11515492E-05_JPRB, &
  & 0.12311133E-05_JPRB, 0.12909111E-05_JPRB, 0.13316964E-05_JPRB, 0.13599424E-05_JPRB, 0.13759875E-05_JPRB, 0.13808220E-05_JPRB, &
  & 0.13722136E-05_JPRB, 0.13512492E-05_JPRB, 0.13211717E-05_JPRB, 0.12891631E-05_JPRB, 0.12554621E-05_JPRB, 0.12185797E-05_JPRB, &
  & 0.11818702E-05_JPRB, 0.11431351E-05_JPRB, 0.10971311E-05_JPRB, 0.10455530E-05_JPRB, 0.98079252E-06_JPRB, 0.89417804E-06_JPRB, &
  & 0.78969415E-06_JPRB, 0.68516132E-06_JPRB, 0.62339375E-06_JPRB, 0.59781638E-06_JPRB, 0.57697753E-06_JPRB, 0.56564567E-06_JPRB, &
  & 0.56157323E-06_JPRB, 0.55820708E-06_JPRB, 0.55527302E-06_JPRB, 0.55095118E-06_JPRB, 0.54515026E-06_JPRB, 0.53620209E-06_JPRB, &
  & 0.52308026E-06_JPRB, 0.50889111E-06_JPRB, 0.49565719E-06_JPRB, 0.48221843E-06_JPRB, 0.46803153E-06_JPRB, 0.44946141E-06_JPRB, &
  & 0.42619661E-06_JPRB, 0.40567025E-06_JPRB, 0.39556525E-06_JPRB, 0.39344159E-06_JPRB  /)

RGHG2(:,22,11) = (/ &
  & 0.74334364E-06_JPRB, 0.75821539E-06_JPRB, 0.77023435E-06_JPRB, 0.78162233E-06_JPRB, 0.79633432E-06_JPRB, 0.81166862E-06_JPRB, &
  & 0.82650758E-06_JPRB, 0.84209493E-06_JPRB, 0.85828794E-06_JPRB, 0.87412318E-06_JPRB, 0.88923601E-06_JPRB, 0.90564015E-06_JPRB, &
  & 0.92659419E-06_JPRB, 0.94982264E-06_JPRB, 0.97459928E-06_JPRB, 0.99870883E-06_JPRB, 0.10172615E-05_JPRB, 0.10286005E-05_JPRB, &
  & 0.10312466E-05_JPRB, 0.10238201E-05_JPRB, 0.10209512E-05_JPRB, 0.10608631E-05_JPRB, 0.11380990E-05_JPRB, 0.12300186E-05_JPRB, &
  & 0.13070787E-05_JPRB, 0.13676028E-05_JPRB, 0.14066487E-05_JPRB, 0.14333465E-05_JPRB, 0.14453394E-05_JPRB, 0.14420886E-05_JPRB, &
  & 0.14258537E-05_JPRB, 0.14001298E-05_JPRB, 0.13719447E-05_JPRB, 0.13467598E-05_JPRB, 0.13210486E-05_JPRB, 0.12905884E-05_JPRB, &
  & 0.12567843E-05_JPRB, 0.12160995E-05_JPRB, 0.11644760E-05_JPRB, 0.11089030E-05_JPRB, 0.10352354E-05_JPRB, 0.93745829E-06_JPRB, &
  & 0.82345557E-06_JPRB, 0.71725981E-06_JPRB, 0.65061814E-06_JPRB, 0.61858020E-06_JPRB, 0.59871617E-06_JPRB, 0.58438340E-06_JPRB, &
  & 0.57727181E-06_JPRB, 0.57442175E-06_JPRB, 0.57353289E-06_JPRB, 0.57148563E-06_JPRB, 0.56784461E-06_JPRB, 0.56180178E-06_JPRB, &
  & 0.55173821E-06_JPRB, 0.53886793E-06_JPRB, 0.52678086E-06_JPRB, 0.51391553E-06_JPRB, 0.49877292E-06_JPRB, 0.47980140E-06_JPRB, &
  & 0.45829510E-06_JPRB, 0.44011977E-06_JPRB, 0.43014857E-06_JPRB, 0.42706921E-06_JPRB  /)

RGHG2(:,23,11) = (/ &
  & 0.76754820E-06_JPRB, 0.78509715E-06_JPRB, 0.80156849E-06_JPRB, 0.81794801E-06_JPRB, 0.83500766E-06_JPRB, 0.85032664E-06_JPRB, &
  & 0.86464150E-06_JPRB, 0.88034874E-06_JPRB, 0.89614374E-06_JPRB, 0.91510650E-06_JPRB, 0.93617508E-06_JPRB, 0.95922340E-06_JPRB, &
  & 0.98668936E-06_JPRB, 0.10157029E-05_JPRB, 0.10445492E-05_JPRB, 0.10716575E-05_JPRB, 0.10924603E-05_JPRB, 0.11073913E-05_JPRB, &
  & 0.11139274E-05_JPRB, 0.11073747E-05_JPRB, 0.10992726E-05_JPRB, 0.11286459E-05_JPRB, 0.11939766E-05_JPRB, 0.12784552E-05_JPRB, &
  & 0.13520859E-05_JPRB, 0.14130720E-05_JPRB, 0.14540202E-05_JPRB, 0.14819728E-05_JPRB, 0.14949689E-05_JPRB, 0.14927232E-05_JPRB, &
  & 0.14786550E-05_JPRB, 0.14568501E-05_JPRB, 0.14342150E-05_JPRB, 0.14132655E-05_JPRB, 0.13890320E-05_JPRB, 0.13584438E-05_JPRB, &
  & 0.13231728E-05_JPRB, 0.12790754E-05_JPRB, 0.12182585E-05_JPRB, 0.11507254E-05_JPRB, 0.10654262E-05_JPRB, 0.96560107E-06_JPRB, &
  & 0.85835665E-06_JPRB, 0.75995613E-06_JPRB, 0.69072798E-06_JPRB, 0.65162187E-06_JPRB, 0.62824888E-06_JPRB, 0.61252894E-06_JPRB, &
  & 0.60353932E-06_JPRB, 0.59954620E-06_JPRB, 0.59967838E-06_JPRB, 0.59858676E-06_JPRB, 0.59587325E-06_JPRB, 0.59154134E-06_JPRB, &
  & 0.58335795E-06_JPRB, 0.57112279E-06_JPRB, 0.55948420E-06_JPRB, 0.54744371E-06_JPRB, 0.53202619E-06_JPRB, 0.51323753E-06_JPRB, &
  & 0.49323693E-06_JPRB, 0.47541766E-06_JPRB, 0.46521826E-06_JPRB, 0.46168153E-06_JPRB  /)

RGHG2(:,24,11) = (/ &
  & 0.79489530E-06_JPRB, 0.81363799E-06_JPRB, 0.83317838E-06_JPRB, 0.85237910E-06_JPRB, 0.86986215E-06_JPRB, 0.88434608E-06_JPRB, &
  & 0.89809030E-06_JPRB, 0.91428775E-06_JPRB, 0.93078668E-06_JPRB, 0.95432855E-06_JPRB, 0.98239045E-06_JPRB, 0.10123405E-05_JPRB, &
  & 0.10456989E-05_JPRB, 0.10797398E-05_JPRB, 0.11120255E-05_JPRB, 0.11414505E-05_JPRB, 0.11638963E-05_JPRB, 0.11812268E-05_JPRB, &
  & 0.11908100E-05_JPRB, 0.11857253E-05_JPRB, 0.11745018E-05_JPRB, 0.11939803E-05_JPRB, 0.12453190E-05_JPRB, 0.13175342E-05_JPRB, &
  & 0.13860962E-05_JPRB, 0.14472242E-05_JPRB, 0.14918264E-05_JPRB, 0.15223558E-05_JPRB, 0.15377732E-05_JPRB, 0.15397832E-05_JPRB, &
  & 0.15314894E-05_JPRB, 0.15162979E-05_JPRB, 0.14996586E-05_JPRB, 0.14812418E-05_JPRB, 0.14555334E-05_JPRB, 0.14225305E-05_JPRB, &
  & 0.13841604E-05_JPRB, 0.13353523E-05_JPRB, 0.12646845E-05_JPRB, 0.11852473E-05_JPRB, 0.10887905E-05_JPRB, 0.99018945E-06_JPRB, &
  & 0.89527456E-06_JPRB, 0.80744066E-06_JPRB, 0.73827451E-06_JPRB, 0.69331552E-06_JPRB, 0.66563782E-06_JPRB, 0.64873445E-06_JPRB, &
  & 0.63845421E-06_JPRB, 0.63302397E-06_JPRB, 0.63280393E-06_JPRB, 0.63172032E-06_JPRB, 0.62920536E-06_JPRB, 0.62563161E-06_JPRB, &
  & 0.61864987E-06_JPRB, 0.60709128E-06_JPRB, 0.59614321E-06_JPRB, 0.58477804E-06_JPRB, 0.56928550E-06_JPRB, 0.55103159E-06_JPRB, &
  & 0.53192920E-06_JPRB, 0.51358955E-06_JPRB, 0.50255957E-06_JPRB, 0.49852358E-06_JPRB  /)

RGHG2(:,25,11) = (/ &
  & 0.82649796E-06_JPRB, 0.84485249E-06_JPRB, 0.86495895E-06_JPRB, 0.88286578E-06_JPRB, 0.89789046E-06_JPRB, 0.91064382E-06_JPRB, &
  & 0.92401605E-06_JPRB, 0.94121626E-06_JPRB, 0.96054556E-06_JPRB, 0.99089649E-06_JPRB, 0.10266732E-05_JPRB, 0.10632382E-05_JPRB, &
  & 0.11011575E-05_JPRB, 0.11386757E-05_JPRB, 0.11733875E-05_JPRB, 0.12043328E-05_JPRB, 0.12277975E-05_JPRB, 0.12456294E-05_JPRB, &
  & 0.12567815E-05_JPRB, 0.12538478E-05_JPRB, 0.12431904E-05_JPRB, 0.12546630E-05_JPRB, 0.12910735E-05_JPRB, 0.13450288E-05_JPRB, &
  & 0.14060539E-05_JPRB, 0.14668099E-05_JPRB, 0.15171861E-05_JPRB, 0.15518883E-05_JPRB, 0.15709932E-05_JPRB, 0.15807827E-05_JPRB, &
  & 0.15821930E-05_JPRB, 0.15761395E-05_JPRB, 0.15651934E-05_JPRB, 0.15467604E-05_JPRB, 0.15158764E-05_JPRB, 0.14779891E-05_JPRB, &
  & 0.14347508E-05_JPRB, 0.13794733E-05_JPRB, 0.12990367E-05_JPRB, 0.12101217E-05_JPRB, 0.11044622E-05_JPRB, 0.10107779E-05_JPRB, &
  & 0.93384802E-06_JPRB, 0.85888826E-06_JPRB, 0.79395958E-06_JPRB, 0.74570119E-06_JPRB, 0.71351107E-06_JPRB, 0.69547555E-06_JPRB, &
  & 0.68474245E-06_JPRB, 0.67779190E-06_JPRB, 0.67503261E-06_JPRB, 0.67257425E-06_JPRB, 0.66923444E-06_JPRB, 0.66496522E-06_JPRB, &
  & 0.65819374E-06_JPRB, 0.64750852E-06_JPRB, 0.63780582E-06_JPRB, 0.62676412E-06_JPRB, 0.61140097E-06_JPRB, 0.59414981E-06_JPRB, &
  & 0.57488569E-06_JPRB, 0.55494486E-06_JPRB, 0.54213579E-06_JPRB, 0.53743669E-06_JPRB  /)

RGHG2(:,26,11) = (/ &
  & 0.86147122E-06_JPRB, 0.87709235E-06_JPRB, 0.89434231E-06_JPRB, 0.90851147E-06_JPRB, 0.92076155E-06_JPRB, 0.93138902E-06_JPRB, &
  & 0.94513267E-06_JPRB, 0.96488623E-06_JPRB, 0.99015614E-06_JPRB, 0.10265410E-05_JPRB, 0.10681519E-05_JPRB, 0.11095174E-05_JPRB, &
  & 0.11505273E-05_JPRB, 0.11897976E-05_JPRB, 0.12253683E-05_JPRB, 0.12563920E-05_JPRB, 0.12805283E-05_JPRB, 0.12980333E-05_JPRB, &
  & 0.13089781E-05_JPRB, 0.13082911E-05_JPRB, 0.13013193E-05_JPRB, 0.13086609E-05_JPRB, 0.13330228E-05_JPRB, 0.13724696E-05_JPRB, &
  & 0.14247131E-05_JPRB, 0.14824842E-05_JPRB, 0.15355121E-05_JPRB, 0.15726279E-05_JPRB, 0.15949038E-05_JPRB, 0.16108215E-05_JPRB, &
  & 0.16197162E-05_JPRB, 0.16209031E-05_JPRB, 0.16145267E-05_JPRB, 0.15966009E-05_JPRB, 0.15629982E-05_JPRB, 0.15215307E-05_JPRB, &
  & 0.14740024E-05_JPRB, 0.14129504E-05_JPRB, 0.13271115E-05_JPRB, 0.12355235E-05_JPRB, 0.11320896E-05_JPRB, 0.10467994E-05_JPRB, &
  & 0.98059797E-06_JPRB, 0.91516723E-06_JPRB, 0.85540746E-06_JPRB, 0.80720162E-06_JPRB, 0.77361705E-06_JPRB, 0.75389998E-06_JPRB, &
  & 0.74173777E-06_JPRB, 0.73370728E-06_JPRB, 0.72823746E-06_JPRB, 0.72338409E-06_JPRB, 0.71843253E-06_JPRB, 0.71248955E-06_JPRB, &
  & 0.70497399E-06_JPRB, 0.69415515E-06_JPRB, 0.68552433E-06_JPRB, 0.67522793E-06_JPRB, 0.66023961E-06_JPRB, 0.64305919E-06_JPRB, &
  & 0.62304950E-06_JPRB, 0.60193297E-06_JPRB, 0.58725168E-06_JPRB, 0.58238963E-06_JPRB  /)

RGHG2(:,27,11) = (/ &
  & 0.89928630E-06_JPRB, 0.91118001E-06_JPRB, 0.92417438E-06_JPRB, 0.93352959E-06_JPRB, 0.94276152E-06_JPRB, 0.95101974E-06_JPRB, &
  & 0.96542739E-06_JPRB, 0.98842545E-06_JPRB, 0.10210597E-05_JPRB, 0.10634657E-05_JPRB, 0.11104791E-05_JPRB, 0.11561907E-05_JPRB, &
  & 0.11998869E-05_JPRB, 0.12403493E-05_JPRB, 0.12762369E-05_JPRB, 0.13068079E-05_JPRB, 0.13315176E-05_JPRB, 0.13483737E-05_JPRB, &
  & 0.13584433E-05_JPRB, 0.13601406E-05_JPRB, 0.13581789E-05_JPRB, 0.13626382E-05_JPRB, 0.13754707E-05_JPRB, 0.14011397E-05_JPRB, &
  & 0.14437402E-05_JPRB, 0.14974217E-05_JPRB, 0.15520643E-05_JPRB, 0.15910514E-05_JPRB, 0.16164510E-05_JPRB, 0.16381636E-05_JPRB, &
  & 0.16540605E-05_JPRB, 0.16621136E-05_JPRB, 0.16600985E-05_JPRB, 0.16428970E-05_JPRB, 0.16073626E-05_JPRB, 0.15626355E-05_JPRB, &
  & 0.15108366E-05_JPRB, 0.14440048E-05_JPRB, 0.13541366E-05_JPRB, 0.12622770E-05_JPRB, 0.11654076E-05_JPRB, 0.10901829E-05_JPRB, &
  & 0.10325078E-05_JPRB, 0.97579954E-06_JPRB, 0.92178935E-06_JPRB, 0.87488131E-06_JPRB, 0.84099492E-06_JPRB, 0.81931606E-06_JPRB, &
  & 0.80529768E-06_JPRB, 0.79630138E-06_JPRB, 0.78793414E-06_JPRB, 0.78019844E-06_JPRB, 0.77326999E-06_JPRB, 0.76521430E-06_JPRB, &
  & 0.75656694E-06_JPRB, 0.74523501E-06_JPRB, 0.73766054E-06_JPRB, 0.72829977E-06_JPRB, 0.71379435E-06_JPRB, 0.69634229E-06_JPRB, &
  & 0.67533661E-06_JPRB, 0.65314865E-06_JPRB, 0.63647537E-06_JPRB, 0.63162841E-06_JPRB  /)

RGHG2(:,28,11) = (/ &
  & 0.93812794E-06_JPRB, 0.94415397E-06_JPRB, 0.95232401E-06_JPRB, 0.95944939E-06_JPRB, 0.96768635E-06_JPRB, 0.97638974E-06_JPRB, &
  & 0.99250103E-06_JPRB, 0.10190944E-05_JPRB, 0.10554107E-05_JPRB, 0.11000315E-05_JPRB, 0.11494105E-05_JPRB, 0.11965073E-05_JPRB, &
  & 0.12407221E-05_JPRB, 0.12811188E-05_JPRB, 0.13162426E-05_JPRB, 0.13451559E-05_JPRB, 0.13686738E-05_JPRB, 0.13843151E-05_JPRB, &
  & 0.13942376E-05_JPRB, 0.13983321E-05_JPRB, 0.13991839E-05_JPRB, 0.14045188E-05_JPRB, 0.14139311E-05_JPRB, 0.14326738E-05_JPRB, &
  & 0.14679222E-05_JPRB, 0.15153212E-05_JPRB, 0.15649070E-05_JPRB, 0.16025906E-05_JPRB, 0.16286889E-05_JPRB, 0.16510675E-05_JPRB, &
  & 0.16686542E-05_JPRB, 0.16792433E-05_JPRB, 0.16799158E-05_JPRB, 0.16656472E-05_JPRB, 0.16340430E-05_JPRB, 0.15915037E-05_JPRB, &
  & 0.15399501E-05_JPRB, 0.14743683E-05_JPRB, 0.13907013E-05_JPRB, 0.13074690E-05_JPRB, 0.12247162E-05_JPRB, 0.11587631E-05_JPRB, &
  & 0.11037892E-05_JPRB, 0.10486632E-05_JPRB, 0.99629367E-06_JPRB, 0.95206562E-06_JPRB, 0.91829256E-06_JPRB, 0.89478392E-06_JPRB, &
  & 0.87792590E-06_JPRB, 0.86792768E-06_JPRB, 0.85819464E-06_JPRB, 0.84805467E-06_JPRB, 0.83808152E-06_JPRB, 0.82772693E-06_JPRB, &
  & 0.81797096E-06_JPRB, 0.80559232E-06_JPRB, 0.79794671E-06_JPRB, 0.78849752E-06_JPRB, 0.77378575E-06_JPRB, 0.75437007E-06_JPRB, &
  & 0.73226113E-06_JPRB, 0.71137056E-06_JPRB, 0.69607117E-06_JPRB, 0.69049871E-06_JPRB  /)

RGHG2(:,29,11) = (/ &
  & 0.97932838E-06_JPRB, 0.97904433E-06_JPRB, 0.98207793E-06_JPRB, 0.98695267E-06_JPRB, 0.99422309E-06_JPRB, 0.10035202E-05_JPRB, &
  & 0.10214817E-05_JPRB, 0.10518998E-05_JPRB, 0.10919580E-05_JPRB, 0.11387604E-05_JPRB, 0.11905143E-05_JPRB, 0.12389504E-05_JPRB, &
  & 0.12836209E-05_JPRB, 0.13238933E-05_JPRB, 0.13581611E-05_JPRB, 0.13852655E-05_JPRB, 0.14074441E-05_JPRB, 0.14217737E-05_JPRB, &
  & 0.14315719E-05_JPRB, 0.14382070E-05_JPRB, 0.14419446E-05_JPRB, 0.14483703E-05_JPRB, 0.14545102E-05_JPRB, 0.14662111E-05_JPRB, &
  & 0.14937685E-05_JPRB, 0.15344156E-05_JPRB, 0.15783541E-05_JPRB, 0.16145189E-05_JPRB, 0.16412524E-05_JPRB, 0.16641142E-05_JPRB, &
  & 0.16832612E-05_JPRB, 0.16963494E-05_JPRB, 0.16997973E-05_JPRB, 0.16887320E-05_JPRB, 0.16615463E-05_JPRB, 0.16215614E-05_JPRB, &
  & 0.15704634E-05_JPRB, 0.15065109E-05_JPRB, 0.14298582E-05_JPRB, 0.13561532E-05_JPRB, 0.12886854E-05_JPRB, 0.12325219E-05_JPRB, &
  & 0.11801577E-05_JPRB, 0.11263986E-05_JPRB, 0.10755893E-05_JPRB, 0.10342609E-05_JPRB, 0.10006259E-05_JPRB, 0.97518421E-06_JPRB, &
  & 0.95527470E-06_JPRB, 0.94421329E-06_JPRB, 0.93309949E-06_JPRB, 0.92043272E-06_JPRB, 0.90718717E-06_JPRB, 0.89438863E-06_JPRB, &
  & 0.88345902E-06_JPRB, 0.86994815E-06_JPRB, 0.86217826E-06_JPRB, 0.85259100E-06_JPRB, 0.83763069E-06_JPRB, 0.81606102E-06_JPRB, &
  & 0.79277843E-06_JPRB, 0.77336528E-06_JPRB, 0.75966758E-06_JPRB, 0.75329427E-06_JPRB  /)

RGHG2(:,30,11) = (/ &
  & 0.10200807E-05_JPRB, 0.10163764E-05_JPRB, 0.10178528E-05_JPRB, 0.10240234E-05_JPRB, 0.10321117E-05_JPRB, 0.10440779E-05_JPRB, &
  & 0.10643943E-05_JPRB, 0.10944276E-05_JPRB, 0.11322755E-05_JPRB, 0.11777638E-05_JPRB, 0.12286222E-05_JPRB, 0.12763015E-05_JPRB, &
  & 0.13196927E-05_JPRB, 0.13584063E-05_JPRB, 0.13908599E-05_JPRB, 0.14159067E-05_JPRB, 0.14358583E-05_JPRB, 0.14494892E-05_JPRB, &
  & 0.14599423E-05_JPRB, 0.14683871E-05_JPRB, 0.14742681E-05_JPRB, 0.14814408E-05_JPRB, 0.14889909E-05_JPRB, 0.15005519E-05_JPRB, &
  & 0.15237782E-05_JPRB, 0.15575902E-05_JPRB, 0.15939728E-05_JPRB, 0.16249932E-05_JPRB, 0.16491557E-05_JPRB, 0.16700833E-05_JPRB, &
  & 0.16880915E-05_JPRB, 0.17010000E-05_JPRB, 0.17056270E-05_JPRB, 0.16979549E-05_JPRB, 0.16760435E-05_JPRB, 0.16421683E-05_JPRB, &
  & 0.15983061E-05_JPRB, 0.15440892E-05_JPRB, 0.14817499E-05_JPRB, 0.14220755E-05_JPRB, 0.13672545E-05_JPRB, 0.13186567E-05_JPRB, &
  & 0.12692545E-05_JPRB, 0.12178680E-05_JPRB, 0.11661080E-05_JPRB, 0.11221621E-05_JPRB, 0.10853068E-05_JPRB, 0.10575526E-05_JPRB, &
  & 0.10350385E-05_JPRB, 0.10206162E-05_JPRB, 0.10074391E-05_JPRB, 0.99304160E-06_JPRB, 0.97856193E-06_JPRB, 0.96523961E-06_JPRB, &
  & 0.95393898E-06_JPRB, 0.94076673E-06_JPRB, 0.93132282E-06_JPRB, 0.92128057E-06_JPRB, 0.90425192E-06_JPRB, 0.88106098E-06_JPRB, &
  & 0.85716478E-06_JPRB, 0.83816537E-06_JPRB, 0.82743484E-06_JPRB, 0.82065446E-06_JPRB  /)

RGHG2(:,31,11) = (/ &
  & 0.10630191E-05_JPRB, 0.10557138E-05_JPRB, 0.10555528E-05_JPRB, 0.10630922E-05_JPRB, 0.10720439E-05_JPRB, 0.10868244E-05_JPRB, &
  & 0.11096224E-05_JPRB, 0.11392464E-05_JPRB, 0.11747598E-05_JPRB, 0.12188601E-05_JPRB, 0.12687719E-05_JPRB, 0.13156517E-05_JPRB, &
  & 0.13576933E-05_JPRB, 0.13947631E-05_JPRB, 0.14253043E-05_JPRB, 0.14481828E-05_JPRB, 0.14657871E-05_JPRB, 0.14786825E-05_JPRB, &
  & 0.14898264E-05_JPRB, 0.15001771E-05_JPRB, 0.15083160E-05_JPRB, 0.15162754E-05_JPRB, 0.15253157E-05_JPRB, 0.15367361E-05_JPRB, &
  & 0.15554020E-05_JPRB, 0.15820121E-05_JPRB, 0.16104316E-05_JPRB, 0.16360281E-05_JPRB, 0.16574787E-05_JPRB, 0.16763659E-05_JPRB, &
  & 0.16931717E-05_JPRB, 0.17058883E-05_JPRB, 0.17117562E-05_JPRB, 0.17076595E-05_JPRB, 0.16913062E-05_JPRB, 0.16638718E-05_JPRB, &
  & 0.16276401E-05_JPRB, 0.15836889E-05_JPRB, 0.15364378E-05_JPRB, 0.14915510E-05_JPRB, 0.14500530E-05_JPRB, 0.14094247E-05_JPRB, &
  & 0.13631437E-05_JPRB, 0.13142581E-05_JPRB, 0.12614939E-05_JPRB, 0.12147850E-05_JPRB, 0.11745333E-05_JPRB, 0.11443423E-05_JPRB, &
  & 0.11190843E-05_JPRB, 0.11011186E-05_JPRB, 0.10857668E-05_JPRB, 0.10695464E-05_JPRB, 0.10537683E-05_JPRB, 0.10398960E-05_JPRB, &
  & 0.10282052E-05_JPRB, 0.10153911E-05_JPRB, 0.10041819E-05_JPRB, 0.99365994E-06_JPRB, 0.97445023E-06_JPRB, 0.94955155E-06_JPRB, &
  & 0.92500935E-06_JPRB, 0.90644488E-06_JPRB, 0.89884201E-06_JPRB, 0.89163310E-06_JPRB  /)

RGHG2(:,32,11) = (/ &
  & 0.11101784E-05_JPRB, 0.11028038E-05_JPRB, 0.11023635E-05_JPRB, 0.11116300E-05_JPRB, 0.11236328E-05_JPRB, 0.11401615E-05_JPRB, &
  & 0.11626012E-05_JPRB, 0.11897960E-05_JPRB, 0.12213539E-05_JPRB, 0.12610167E-05_JPRB, 0.13073432E-05_JPRB, 0.13520491E-05_JPRB, &
  & 0.13923864E-05_JPRB, 0.14265813E-05_JPRB, 0.14540891E-05_JPRB, 0.14752755E-05_JPRB, 0.14919865E-05_JPRB, 0.15049239E-05_JPRB, &
  & 0.15166283E-05_JPRB, 0.15281891E-05_JPRB, 0.15382153E-05_JPRB, 0.15472710E-05_JPRB, 0.15572385E-05_JPRB, 0.15690191E-05_JPRB, &
  & 0.15851461E-05_JPRB, 0.16057015E-05_JPRB, 0.16273178E-05_JPRB, 0.16475716E-05_JPRB, 0.16652052E-05_JPRB, 0.16814259E-05_JPRB, &
  & 0.16965693E-05_JPRB, 0.17087343E-05_JPRB, 0.17152957E-05_JPRB, 0.17134949E-05_JPRB, 0.17015262E-05_JPRB, 0.16808654E-05_JPRB, &
  & 0.16544789E-05_JPRB, 0.16226986E-05_JPRB, 0.15885080E-05_JPRB, 0.15549904E-05_JPRB, 0.15227893E-05_JPRB, 0.14886713E-05_JPRB, &
  & 0.14479569E-05_JPRB, 0.14019227E-05_JPRB, 0.13495003E-05_JPRB, 0.12998286E-05_JPRB, 0.12561012E-05_JPRB, 0.12233130E-05_JPRB, &
  & 0.11967007E-05_JPRB, 0.11762984E-05_JPRB, 0.11595833E-05_JPRB, 0.11424813E-05_JPRB, 0.11260548E-05_JPRB, 0.11117045E-05_JPRB, &
  & 0.11000889E-05_JPRB, 0.10880147E-05_JPRB, 0.10757192E-05_JPRB, 0.10642740E-05_JPRB, 0.10442614E-05_JPRB, 0.10191581E-05_JPRB, &
  & 0.99546084E-06_JPRB, 0.97670770E-06_JPRB, 0.96876139E-06_JPRB, 0.96344092E-06_JPRB  /)

RGHG2(:,33,11) = (/ &
  & 0.11597351E-05_JPRB, 0.11527455E-05_JPRB, 0.11521910E-05_JPRB, 0.11632988E-05_JPRB, 0.11787556E-05_JPRB, 0.11969631E-05_JPRB, &
  & 0.12186626E-05_JPRB, 0.12430714E-05_JPRB, 0.12703088E-05_JPRB, 0.13049652E-05_JPRB, 0.13472239E-05_JPRB, 0.13894928E-05_JPRB, &
  & 0.14280128E-05_JPRB, 0.14590606E-05_JPRB, 0.14832709E-05_JPRB, 0.15027604E-05_JPRB, 0.15187312E-05_JPRB, 0.15318131E-05_JPRB, &
  & 0.15440831E-05_JPRB, 0.15568113E-05_JPRB, 0.15687510E-05_JPRB, 0.15789862E-05_JPRB, 0.15898442E-05_JPRB, 0.16020641E-05_JPRB, &
  & 0.16158142E-05_JPRB, 0.16302258E-05_JPRB, 0.16449222E-05_JPRB, 0.16596339E-05_JPRB, 0.16731576E-05_JPRB, 0.16865261E-05_JPRB, &
  & 0.16998823E-05_JPRB, 0.17114276E-05_JPRB, 0.17186388E-05_JPRB, 0.17190585E-05_JPRB, 0.17114945E-05_JPRB, 0.16979161E-05_JPRB, &
  & 0.16820481E-05_JPRB, 0.16631630E-05_JPRB, 0.16422828E-05_JPRB, 0.16201382E-05_JPRB, 0.15970774E-05_JPRB, 0.15695365E-05_JPRB, &
  & 0.15349237E-05_JPRB, 0.14918982E-05_JPRB, 0.14400054E-05_JPRB, 0.13872286E-05_JPRB, 0.13398788E-05_JPRB, 0.13043707E-05_JPRB, &
  & 0.12765308E-05_JPRB, 0.12537396E-05_JPRB, 0.12357127E-05_JPRB, 0.12178165E-05_JPRB, 0.12008003E-05_JPRB, 0.11859625E-05_JPRB, &
  & 0.11744853E-05_JPRB, 0.11632295E-05_JPRB, 0.11498930E-05_JPRB, 0.11374309E-05_JPRB, 0.11167624E-05_JPRB, 0.10916411E-05_JPRB, &
  & 0.10690149E-05_JPRB, 0.10499849E-05_JPRB, 0.10412323E-05_JPRB, 0.10381744E-05_JPRB  /)

RGHG2(:,34,11) = (/ &
  & 0.12097554E-05_JPRB, 0.12051367E-05_JPRB, 0.12056273E-05_JPRB, 0.12182176E-05_JPRB, 0.12355018E-05_JPRB, 0.12538879E-05_JPRB, &
  & 0.12740549E-05_JPRB, 0.12952609E-05_JPRB, 0.13184116E-05_JPRB, 0.13481696E-05_JPRB, 0.13854693E-05_JPRB, 0.14242894E-05_JPRB, &
  & 0.14597010E-05_JPRB, 0.14877266E-05_JPRB, 0.15098500E-05_JPRB, 0.15284086E-05_JPRB, 0.15437490E-05_JPRB, 0.15566072E-05_JPRB, &
  & 0.15688808E-05_JPRB, 0.15817440E-05_JPRB, 0.15943064E-05_JPRB, 0.16051008E-05_JPRB, 0.16160706E-05_JPRB, 0.16276071E-05_JPRB, &
  & 0.16390914E-05_JPRB, 0.16496606E-05_JPRB, 0.16598395E-05_JPRB, 0.16702426E-05_JPRB, 0.16804236E-05_JPRB, 0.16913027E-05_JPRB, &
  & 0.17029191E-05_JPRB, 0.17137001E-05_JPRB, 0.17213016E-05_JPRB, 0.17234930E-05_JPRB, 0.17198735E-05_JPRB, 0.17121673E-05_JPRB, &
  & 0.17032827E-05_JPRB, 0.16923246E-05_JPRB, 0.16792416E-05_JPRB, 0.16642852E-05_JPRB, 0.16474122E-05_JPRB, 0.16253505E-05_JPRB, &
  & 0.15964536E-05_JPRB, 0.15581830E-05_JPRB, 0.15102415E-05_JPRB, 0.14582931E-05_JPRB, 0.14103205E-05_JPRB, 0.13744938E-05_JPRB, &
  & 0.13468394E-05_JPRB, 0.13235065E-05_JPRB, 0.13043726E-05_JPRB, 0.12855851E-05_JPRB, 0.12684596E-05_JPRB, 0.12535066E-05_JPRB, &
  & 0.12420248E-05_JPRB, 0.12314653E-05_JPRB, 0.12175721E-05_JPRB, 0.12040541E-05_JPRB, 0.11836382E-05_JPRB, 0.11599020E-05_JPRB, &
  & 0.11384005E-05_JPRB, 0.11201805E-05_JPRB, 0.11103986E-05_JPRB, 0.11067607E-05_JPRB  /)

RGHG2(:,35,11) = (/ &
  & 0.12614208E-05_JPRB, 0.12602584E-05_JPRB, 0.12624186E-05_JPRB, 0.12763490E-05_JPRB, 0.12946773E-05_JPRB, 0.13124772E-05_JPRB, &
  & 0.13306619E-05_JPRB, 0.13483613E-05_JPRB, 0.13674303E-05_JPRB, 0.13922076E-05_JPRB, 0.14239514E-05_JPRB, 0.14587065E-05_JPRB, &
  & 0.14902597E-05_JPRB, 0.15152421E-05_JPRB, 0.15358412E-05_JPRB, 0.15538359E-05_JPRB, 0.15685843E-05_JPRB, 0.15810238E-05_JPRB, &
  & 0.15930126E-05_JPRB, 0.16054849E-05_JPRB, 0.16180250E-05_JPRB, 0.16290762E-05_JPRB, 0.16397612E-05_JPRB, 0.16500191E-05_JPRB, &
  & 0.16592308E-05_JPRB, 0.16670304E-05_JPRB, 0.16737976E-05_JPRB, 0.16804037E-05_JPRB, 0.16875416E-05_JPRB, 0.16960476E-05_JPRB, &
  & 0.17058995E-05_JPRB, 0.17158206E-05_JPRB, 0.17236901E-05_JPRB, 0.17274729E-05_JPRB, 0.17276728E-05_JPRB, 0.17253828E-05_JPRB, &
  & 0.17218642E-05_JPRB, 0.17165067E-05_JPRB, 0.17086109E-05_JPRB, 0.16988977E-05_JPRB, 0.16868714E-05_JPRB, 0.16698798E-05_JPRB, &
  & 0.16466616E-05_JPRB, 0.16141759E-05_JPRB, 0.15720526E-05_JPRB, 0.15229743E-05_JPRB, 0.14759007E-05_JPRB, 0.14409785E-05_JPRB, &
  & 0.14142399E-05_JPRB, 0.13912978E-05_JPRB, 0.13711309E-05_JPRB, 0.13513775E-05_JPRB, 0.13343859E-05_JPRB, 0.13195056E-05_JPRB, &
  & 0.13079456E-05_JPRB, 0.12980394E-05_JPRB, 0.12838223E-05_JPRB, 0.12691987E-05_JPRB, 0.12495087E-05_JPRB, 0.12279167E-05_JPRB, &
  & 0.12075989E-05_JPRB, 0.11907693E-05_JPRB, 0.11798148E-05_JPRB, 0.11741221E-05_JPRB  /)

RGHG2(:,36,11) = (/ &
  & 0.13141832E-05_JPRB, 0.13159349E-05_JPRB, 0.13199127E-05_JPRB, 0.13344679E-05_JPRB, 0.13528863E-05_JPRB, 0.13695440E-05_JPRB, &
  & 0.13855656E-05_JPRB, 0.13999937E-05_JPRB, 0.14152667E-05_JPRB, 0.14353618E-05_JPRB, 0.14617266E-05_JPRB, 0.14920833E-05_JPRB, &
  & 0.15196448E-05_JPRB, 0.15418109E-05_JPRB, 0.15610034E-05_JPRB, 0.15782492E-05_JPRB, 0.15922297E-05_JPRB, 0.16040305E-05_JPRB, &
  & 0.16154239E-05_JPRB, 0.16272104E-05_JPRB, 0.16392415E-05_JPRB, 0.16499525E-05_JPRB, 0.16598913E-05_JPRB, 0.16686816E-05_JPRB, &
  & 0.16758504E-05_JPRB, 0.16813470E-05_JPRB, 0.16853866E-05_JPRB, 0.16889540E-05_JPRB, 0.16935723E-05_JPRB, 0.17000446E-05_JPRB, &
  & 0.17083483E-05_JPRB, 0.17174469E-05_JPRB, 0.17253974E-05_JPRB, 0.17305346E-05_JPRB, 0.17337929E-05_JPRB, 0.17357194E-05_JPRB, &
  & 0.17363020E-05_JPRB, 0.17352032E-05_JPRB, 0.17314102E-05_JPRB, 0.17259670E-05_JPRB, 0.17180889E-05_JPRB, 0.17056928E-05_JPRB, &
  & 0.16878412E-05_JPRB, 0.16611834E-05_JPRB, 0.16251592E-05_JPRB, 0.15800086E-05_JPRB, 0.15351678E-05_JPRB, 0.15019735E-05_JPRB, &
  & 0.14765565E-05_JPRB, 0.14543952E-05_JPRB, 0.14336644E-05_JPRB, 0.14134311E-05_JPRB, 0.13967972E-05_JPRB, 0.13822707E-05_JPRB, &
  & 0.13706656E-05_JPRB, 0.13611920E-05_JPRB, 0.13468870E-05_JPRB, 0.13315338E-05_JPRB, 0.13130292E-05_JPRB, 0.12939163E-05_JPRB, &
  & 0.12747856E-05_JPRB, 0.12593097E-05_JPRB, 0.12478190E-05_JPRB, 0.12397633E-05_JPRB  /)

RGHG2(:,37,11) = (/ &
  & 0.13661781E-05_JPRB, 0.13694196E-05_JPRB, 0.13754411E-05_JPRB, 0.13889422E-05_JPRB, 0.14052575E-05_JPRB, 0.14195699E-05_JPRB, &
  & 0.14331482E-05_JPRB, 0.14450480E-05_JPRB, 0.14574163E-05_JPRB, 0.14738053E-05_JPRB, 0.14955309E-05_JPRB, 0.15209985E-05_JPRB, &
  & 0.15445110E-05_JPRB, 0.15645560E-05_JPRB, 0.15826995E-05_JPRB, 0.15988190E-05_JPRB, 0.16116759E-05_JPRB, 0.16223736E-05_JPRB, &
  & 0.16324963E-05_JPRB, 0.16429632E-05_JPRB, 0.16534016E-05_JPRB, 0.16624245E-05_JPRB, 0.16706055E-05_JPRB, 0.16775865E-05_JPRB, &
  & 0.16833662E-05_JPRB, 0.16877726E-05_JPRB, 0.16908225E-05_JPRB, 0.16932791E-05_JPRB, 0.16967350E-05_JPRB, 0.17020785E-05_JPRB, &
  & 0.17094260E-05_JPRB, 0.17178391E-05_JPRB, 0.17254364E-05_JPRB, 0.17313004E-05_JPRB, 0.17356824E-05_JPRB, 0.17388126E-05_JPRB, &
  & 0.17403410E-05_JPRB, 0.17401597E-05_JPRB, 0.17377275E-05_JPRB, 0.17340575E-05_JPRB, 0.17284681E-05_JPRB, 0.17192936E-05_JPRB, &
  & 0.17057590E-05_JPRB, 0.16846656E-05_JPRB, 0.16550048E-05_JPRB, 0.16159624E-05_JPRB, 0.15762736E-05_JPRB, 0.15465870E-05_JPRB, &
  & 0.15233401E-05_JPRB, 0.15028051E-05_JPRB, 0.14826206E-05_JPRB, 0.14630524E-05_JPRB, 0.14472663E-05_JPRB, 0.14337167E-05_JPRB, &
  & 0.14221451E-05_JPRB, 0.14125709E-05_JPRB, 0.13987248E-05_JPRB, 0.13835494E-05_JPRB, 0.13672097E-05_JPRB, 0.13511895E-05_JPRB, &
  & 0.13331800E-05_JPRB, 0.13188897E-05_JPRB, 0.13083552E-05_JPRB, 0.12973768E-05_JPRB  /)

RGHG2(:,38,11) = (/ &
  & 0.14238711E-05_JPRB, 0.14287655E-05_JPRB, 0.14370548E-05_JPRB, 0.14493862E-05_JPRB, 0.14633680E-05_JPRB, 0.14750780E-05_JPRB, &
  & 0.14859453E-05_JPRB, 0.14950396E-05_JPRB, 0.15041851E-05_JPRB, 0.15164617E-05_JPRB, 0.15330398E-05_JPRB, 0.15530824E-05_JPRB, &
  & 0.15721023E-05_JPRB, 0.15897937E-05_JPRB, 0.16067733E-05_JPRB, 0.16216431E-05_JPRB, 0.16332531E-05_JPRB, 0.16427268E-05_JPRB, &
  & 0.16514397E-05_JPRB, 0.16604424E-05_JPRB, 0.16691134E-05_JPRB, 0.16762632E-05_JPRB, 0.16824939E-05_JPRB, 0.16874674E-05_JPRB, &
  & 0.16917056E-05_JPRB, 0.16949023E-05_JPRB, 0.16968541E-05_JPRB, 0.16980782E-05_JPRB, 0.17002443E-05_JPRB, 0.17043352E-05_JPRB, &
  & 0.17106218E-05_JPRB, 0.17182741E-05_JPRB, 0.17254797E-05_JPRB, 0.17321501E-05_JPRB, 0.17377790E-05_JPRB, 0.17422447E-05_JPRB, &
  & 0.17448226E-05_JPRB, 0.17456594E-05_JPRB, 0.17447372E-05_JPRB, 0.17430346E-05_JPRB, 0.17399847E-05_JPRB, 0.17343849E-05_JPRB, &
  & 0.17256403E-05_JPRB, 0.17107212E-05_JPRB, 0.16881211E-05_JPRB, 0.16558563E-05_JPRB, 0.16218842E-05_JPRB, 0.15960897E-05_JPRB, &
  & 0.15752507E-05_JPRB, 0.15565202E-05_JPRB, 0.15369420E-05_JPRB, 0.15181115E-05_JPRB, 0.15032664E-05_JPRB, 0.14908005E-05_JPRB, &
  & 0.14792661E-05_JPRB, 0.14695804E-05_JPRB, 0.14562433E-05_JPRB, 0.14412652E-05_JPRB, 0.14273277E-05_JPRB, 0.14147393E-05_JPRB, &
  & 0.13979738E-05_JPRB, 0.13849989E-05_JPRB, 0.13755254E-05_JPRB, 0.13613040E-05_JPRB  /)

RGHG2(:,39,11) = (/ &
  & 0.14720684E-05_JPRB, 0.14764163E-05_JPRB, 0.14836584E-05_JPRB, 0.14931749E-05_JPRB, 0.15042939E-05_JPRB, 0.15135895E-05_JPRB, &
  & 0.15222945E-05_JPRB, 0.15295255E-05_JPRB, 0.15365633E-05_JPRB, 0.15463889E-05_JPRB, 0.15598133E-05_JPRB, 0.15759444E-05_JPRB, &
  & 0.15919093E-05_JPRB, 0.16075562E-05_JPRB, 0.16228404E-05_JPRB, 0.16360579E-05_JPRB, 0.16463778E-05_JPRB, 0.16546158E-05_JPRB, &
  & 0.16619262E-05_JPRB, 0.16693181E-05_JPRB, 0.16762652E-05_JPRB, 0.16818097E-05_JPRB, 0.16865410E-05_JPRB, 0.16904152E-05_JPRB, &
  & 0.16940226E-05_JPRB, 0.16968533E-05_JPRB, 0.16985884E-05_JPRB, 0.16994622E-05_JPRB, 0.17009687E-05_JPRB, 0.17045238E-05_JPRB, &
  & 0.17101375E-05_JPRB, 0.17172566E-05_JPRB, 0.17243772E-05_JPRB, 0.17311730E-05_JPRB, 0.17370223E-05_JPRB, 0.17417995E-05_JPRB, &
  & 0.17446416E-05_JPRB, 0.17458313E-05_JPRB, 0.17454990E-05_JPRB, 0.17445699E-05_JPRB, 0.17425156E-05_JPRB, 0.17384824E-05_JPRB, &
  & 0.17318748E-05_JPRB, 0.17201011E-05_JPRB, 0.17016497E-05_JPRB, 0.16744987E-05_JPRB, 0.16454303E-05_JPRB, 0.16230862E-05_JPRB, &
  & 0.16045905E-05_JPRB, 0.15877839E-05_JPRB, 0.15697979E-05_JPRB, 0.15524893E-05_JPRB, 0.15393389E-05_JPRB, 0.15282666E-05_JPRB, &
  & 0.15171913E-05_JPRB, 0.15076318E-05_JPRB, 0.14950851E-05_JPRB, 0.14813344E-05_JPRB, 0.14695215E-05_JPRB, 0.14588956E-05_JPRB, &
  & 0.14438023E-05_JPRB, 0.14321814E-05_JPRB, 0.14247855E-05_JPRB, 0.14124773E-05_JPRB  /)

RGHG2(:,40,11) = (/ &
  & 0.15270785E-05_JPRB, 0.15304252E-05_JPRB, 0.15358961E-05_JPRB, 0.15418397E-05_JPRB, 0.15495124E-05_JPRB, 0.15560053E-05_JPRB, &
  & 0.15622623E-05_JPRB, 0.15674608E-05_JPRB, 0.15722074E-05_JPRB, 0.15794284E-05_JPRB, 0.15894781E-05_JPRB, 0.16012662E-05_JPRB, &
  & 0.16138810E-05_JPRB, 0.16271790E-05_JPRB, 0.16403867E-05_JPRB, 0.16515990E-05_JPRB, 0.16603980E-05_JPRB, 0.16671837E-05_JPRB, &
  & 0.16728494E-05_JPRB, 0.16783270E-05_JPRB, 0.16832580E-05_JPRB, 0.16869625E-05_JPRB, 0.16900077E-05_JPRB, 0.16927405E-05_JPRB, &
  & 0.16957565E-05_JPRB, 0.16982957E-05_JPRB, 0.16999208E-05_JPRB, 0.17005278E-05_JPRB, 0.17013632E-05_JPRB, 0.17044067E-05_JPRB, &
  & 0.17092943E-05_JPRB, 0.17158248E-05_JPRB, 0.17228959E-05_JPRB, 0.17297275E-05_JPRB, 0.17356675E-05_JPRB, 0.17406427E-05_JPRB, &
  & 0.17436663E-05_JPRB, 0.17451613E-05_JPRB, 0.17453709E-05_JPRB, 0.17451542E-05_JPRB, 0.17440157E-05_JPRB, 0.17414925E-05_JPRB, &
  & 0.17369588E-05_JPRB, 0.17283811E-05_JPRB, 0.17143222E-05_JPRB, 0.16929003E-05_JPRB, 0.16694538E-05_JPRB, 0.16510869E-05_JPRB, &
  & 0.16353306E-05_JPRB, 0.16208014E-05_JPRB, 0.16048452E-05_JPRB, 0.15894509E-05_JPRB, 0.15784129E-05_JPRB, 0.15690266E-05_JPRB, &
  & 0.15585591E-05_JPRB, 0.15491867E-05_JPRB, 0.15376137E-05_JPRB, 0.15254720E-05_JPRB, 0.15161070E-05_JPRB, 0.15075439E-05_JPRB, &
  & 0.14944832E-05_JPRB, 0.14844575E-05_JPRB, 0.14796663E-05_JPRB, 0.14704468E-05_JPRB  /)

RGHG2(:,41,11) = (/ &
  & 0.15943363E-05_JPRB, 0.15964590E-05_JPRB, 0.15997641E-05_JPRB, 0.16013395E-05_JPRB, 0.16047985E-05_JPRB, 0.16078647E-05_JPRB, &
  & 0.16111289E-05_JPRB, 0.16138422E-05_JPRB, 0.16157876E-05_JPRB, 0.16198240E-05_JPRB, 0.16257475E-05_JPRB, 0.16322257E-05_JPRB, &
  & 0.16407446E-05_JPRB, 0.16511708E-05_JPRB, 0.16618395E-05_JPRB, 0.16706004E-05_JPRB, 0.16775397E-05_JPRB, 0.16825499E-05_JPRB, &
  & 0.16862045E-05_JPRB, 0.16893417E-05_JPRB, 0.16918077E-05_JPRB, 0.16932625E-05_JPRB, 0.16942463E-05_JPRB, 0.16955835E-05_JPRB, &
  & 0.16978765E-05_JPRB, 0.17000592E-05_JPRB, 0.17015498E-05_JPRB, 0.17018306E-05_JPRB, 0.17018455E-05_JPRB, 0.17042635E-05_JPRB, &
  & 0.17082633E-05_JPRB, 0.17140742E-05_JPRB, 0.17210847E-05_JPRB, 0.17279600E-05_JPRB, 0.17340111E-05_JPRB, 0.17392284E-05_JPRB, &
  & 0.17424739E-05_JPRB, 0.17443422E-05_JPRB, 0.17452142E-05_JPRB, 0.17458685E-05_JPRB, 0.17458499E-05_JPRB, 0.17451729E-05_JPRB, &
  & 0.17431747E-05_JPRB, 0.17385046E-05_JPRB, 0.17298161E-05_JPRB, 0.17153990E-05_JPRB, 0.16988261E-05_JPRB, 0.16853218E-05_JPRB, &
  & 0.16729149E-05_JPRB, 0.16611701E-05_JPRB, 0.16476957E-05_JPRB, 0.16346419E-05_JPRB, 0.16261865E-05_JPRB, 0.16188616E-05_JPRB, &
  & 0.16091373E-05_JPRB, 0.15999936E-05_JPRB, 0.15896110E-05_JPRB, 0.15794366E-05_JPRB, 0.15730644E-05_JPRB, 0.15670234E-05_JPRB, &
  & 0.15564479E-05_JPRB, 0.15483727E-05_JPRB, 0.15467661E-05_JPRB, 0.15413230E-05_JPRB  /)

RGHG2(:,42,11) = (/ &
  & 0.16161066E-05_JPRB, 0.16171412E-05_JPRB, 0.16184370E-05_JPRB, 0.16183816E-05_JPRB, 0.16198134E-05_JPRB, 0.16218447E-05_JPRB, &
  & 0.16243458E-05_JPRB, 0.16266384E-05_JPRB, 0.16284738E-05_JPRB, 0.16316865E-05_JPRB, 0.16366322E-05_JPRB, 0.16425489E-05_JPRB, &
  & 0.16499522E-05_JPRB, 0.16589310E-05_JPRB, 0.16678518E-05_JPRB, 0.16751926E-05_JPRB, 0.16809927E-05_JPRB, 0.16849912E-05_JPRB, &
  & 0.16875925E-05_JPRB, 0.16896044E-05_JPRB, 0.16910639E-05_JPRB, 0.16918051E-05_JPRB, 0.16927046E-05_JPRB, 0.16943980E-05_JPRB, &
  & 0.16968047E-05_JPRB, 0.16991045E-05_JPRB, 0.17006513E-05_JPRB, 0.17009641E-05_JPRB, 0.17012476E-05_JPRB, 0.17037660E-05_JPRB, &
  & 0.17079135E-05_JPRB, 0.17138946E-05_JPRB, 0.17209827E-05_JPRB, 0.17277375E-05_JPRB, 0.17337416E-05_JPRB, 0.17389393E-05_JPRB, &
  & 0.17420294E-05_JPRB, 0.17437344E-05_JPRB, 0.17446176E-05_JPRB, 0.17453503E-05_JPRB, 0.17452273E-05_JPRB, 0.17440980E-05_JPRB, &
  & 0.17416970E-05_JPRB, 0.17370952E-05_JPRB, 0.17288833E-05_JPRB, 0.17158320E-05_JPRB, 0.17010557E-05_JPRB, 0.16891673E-05_JPRB, &
  & 0.16786515E-05_JPRB, 0.16682335E-05_JPRB, 0.16564994E-05_JPRB, 0.16450635E-05_JPRB, 0.16372756E-05_JPRB, 0.16308602E-05_JPRB, &
  & 0.16228925E-05_JPRB, 0.16150079E-05_JPRB, 0.16060019E-05_JPRB, 0.15976631E-05_JPRB, 0.15926449E-05_JPRB, 0.15862020E-05_JPRB, &
  & 0.15763090E-05_JPRB, 0.15714171E-05_JPRB, 0.15699269E-05_JPRB, 0.15660883E-05_JPRB  /)

RGHG2(:,43,11) = (/ &
  & 0.16649005E-05_JPRB, 0.16644159E-05_JPRB, 0.16629469E-05_JPRB, 0.16595245E-05_JPRB, 0.16572942E-05_JPRB, 0.16569074E-05_JPRB, &
  & 0.16574247E-05_JPRB, 0.16582644E-05_JPRB, 0.16587945E-05_JPRB, 0.16598859E-05_JPRB, 0.16621646E-05_JPRB, 0.16652850E-05_JPRB, &
  & 0.16699085E-05_JPRB, 0.16763315E-05_JPRB, 0.16825654E-05_JPRB, 0.16875559E-05_JPRB, 0.16915167E-05_JPRB, 0.16938284E-05_JPRB, &
  & 0.16946036E-05_JPRB, 0.16945821E-05_JPRB, 0.16940630E-05_JPRB, 0.16931853E-05_JPRB, 0.16931212E-05_JPRB, 0.16945393E-05_JPRB, &
  & 0.16967387E-05_JPRB, 0.16989921E-05_JPRB, 0.17005322E-05_JPRB, 0.17007338E-05_JPRB, 0.17009095E-05_JPRB, 0.17032505E-05_JPRB, &
  & 0.17071509E-05_JPRB, 0.17129777E-05_JPRB, 0.17201106E-05_JPRB, 0.17267742E-05_JPRB, 0.17327833E-05_JPRB, 0.17380672E-05_JPRB, &
  & 0.17411108E-05_JPRB, 0.17428274E-05_JPRB, 0.17440059E-05_JPRB, 0.17451847E-05_JPRB, 0.17454482E-05_JPRB, 0.17447004E-05_JPRB, &
  & 0.17430225E-05_JPRB, 0.17401639E-05_JPRB, 0.17346969E-05_JPRB, 0.17259048E-05_JPRB, 0.17157245E-05_JPRB, 0.17074020E-05_JPRB, &
  & 0.17000524E-05_JPRB, 0.16920426E-05_JPRB, 0.16829639E-05_JPRB, 0.16740109E-05_JPRB, 0.16679429E-05_JPRB, 0.16632443E-05_JPRB, &
  & 0.16571988E-05_JPRB, 0.16505615E-05_JPRB, 0.16433235E-05_JPRB, 0.16375057E-05_JPRB, 0.16350102E-05_JPRB, 0.16292854E-05_JPRB, &
  & 0.16210842E-05_JPRB, 0.16199357E-05_JPRB, 0.16199217E-05_JPRB, 0.16191713E-05_JPRB  /)

RGHG2(:,44,11) = (/ &
  & 0.16794285E-05_JPRB, 0.16786595E-05_JPRB, 0.16769901E-05_JPRB, 0.16735828E-05_JPRB, 0.16708452E-05_JPRB, 0.16696858E-05_JPRB, &
  & 0.16695704E-05_JPRB, 0.16701891E-05_JPRB, 0.16707711E-05_JPRB, 0.16713472E-05_JPRB, 0.16731346E-05_JPRB, 0.16756137E-05_JPRB, &
  & 0.16791370E-05_JPRB, 0.16842291E-05_JPRB, 0.16888795E-05_JPRB, 0.16925171E-05_JPRB, 0.16951926E-05_JPRB, 0.16964163E-05_JPRB, &
  & 0.16963469E-05_JPRB, 0.16953767E-05_JPRB, 0.16940662E-05_JPRB, 0.16926718E-05_JPRB, 0.16925553E-05_JPRB, 0.16940396E-05_JPRB, &
  & 0.16963963E-05_JPRB, 0.16987098E-05_JPRB, 0.17002392E-05_JPRB, 0.17005040E-05_JPRB, 0.17008566E-05_JPRB, 0.17032487E-05_JPRB, &
  & 0.17072301E-05_JPRB, 0.17129797E-05_JPRB, 0.17199084E-05_JPRB, 0.17265528E-05_JPRB, 0.17323892E-05_JPRB, 0.17375771E-05_JPRB, &
  & 0.17406994E-05_JPRB, 0.17426269E-05_JPRB, 0.17438891E-05_JPRB, 0.17450820E-05_JPRB, 0.17454826E-05_JPRB, 0.17447017E-05_JPRB, &
  & 0.17430607E-05_JPRB, 0.17406209E-05_JPRB, 0.17361831E-05_JPRB, 0.17290764E-05_JPRB, 0.17208099E-05_JPRB, 0.17140105E-05_JPRB, &
  & 0.17079976E-05_JPRB, 0.17011800E-05_JPRB, 0.16935068E-05_JPRB, 0.16860942E-05_JPRB, 0.16807755E-05_JPRB, 0.16766450E-05_JPRB, &
  & 0.16716149E-05_JPRB, 0.16662565E-05_JPRB, 0.16604767E-05_JPRB, 0.16561230E-05_JPRB, 0.16541726E-05_JPRB, 0.16489304E-05_JPRB, &
  & 0.16430088E-05_JPRB, 0.16425729E-05_JPRB, 0.16421565E-05_JPRB, 0.16412549E-05_JPRB  /)

RGHG2(:,45,11) = (/ &
  & 0.17021313E-05_JPRB, 0.17008468E-05_JPRB, 0.16986000E-05_JPRB, 0.16947844E-05_JPRB, 0.16910066E-05_JPRB, 0.16886624E-05_JPRB, &
  & 0.16875759E-05_JPRB, 0.16877595E-05_JPRB, 0.16882359E-05_JPRB, 0.16879572E-05_JPRB, 0.16888484E-05_JPRB, 0.16902443E-05_JPRB, &
  & 0.16921638E-05_JPRB, 0.16954180E-05_JPRB, 0.16979264E-05_JPRB, 0.16997269E-05_JPRB, 0.17007067E-05_JPRB, 0.17004788E-05_JPRB, &
  & 0.16992172E-05_JPRB, 0.16969100E-05_JPRB, 0.16944488E-05_JPRB, 0.16922614E-05_JPRB, 0.16919636E-05_JPRB, 0.16934886E-05_JPRB, &
  & 0.16959981E-05_JPRB, 0.16983743E-05_JPRB, 0.16998907E-05_JPRB, 0.17002132E-05_JPRB, 0.17007537E-05_JPRB, 0.17031816E-05_JPRB, &
  & 0.17072239E-05_JPRB, 0.17128662E-05_JPRB, 0.17195680E-05_JPRB, 0.17261790E-05_JPRB, 0.17318195E-05_JPRB, 0.17369090E-05_JPRB, &
  & 0.17401151E-05_JPRB, 0.17422841E-05_JPRB, 0.17436788E-05_JPRB, 0.17449441E-05_JPRB, 0.17455496E-05_JPRB, 0.17447793E-05_JPRB, &
  & 0.17432717E-05_JPRB, 0.17415288E-05_JPRB, 0.17386093E-05_JPRB, 0.17339595E-05_JPRB, 0.17284523E-05_JPRB, 0.17238372E-05_JPRB, &
  & 0.17197461E-05_JPRB, 0.17145899E-05_JPRB, 0.17088522E-05_JPRB, 0.17035069E-05_JPRB, 0.16992584E-05_JPRB, 0.16959915E-05_JPRB, &
  & 0.16923602E-05_JPRB, 0.16886153E-05_JPRB, 0.16847190E-05_JPRB, 0.16823504E-05_JPRB, 0.16813393E-05_JPRB, 0.16767371E-05_JPRB, &
  & 0.16736245E-05_JPRB, 0.16744727E-05_JPRB, 0.16737847E-05_JPRB, 0.16731010E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART22',0,ZHOOK_HANDLE)



RGHG2(:,46,11) = (/ &
  & 0.17093781E-05_JPRB, 0.17082689E-05_JPRB, 0.17063806E-05_JPRB, 0.17032391E-05_JPRB, 0.16999803E-05_JPRB, 0.16977737E-05_JPRB, &
  & 0.16965119E-05_JPRB, 0.16964789E-05_JPRB, 0.16968621E-05_JPRB, 0.16966190E-05_JPRB, 0.16972816E-05_JPRB, 0.16981373E-05_JPRB, &
  & 0.16991897E-05_JPRB, 0.17012340E-05_JPRB, 0.17024513E-05_JPRB, 0.17030247E-05_JPRB, 0.17028807E-05_JPRB, 0.17016719E-05_JPRB, &
  & 0.16998412E-05_JPRB, 0.16969104E-05_JPRB, 0.16939782E-05_JPRB, 0.16916609E-05_JPRB, 0.16915129E-05_JPRB, 0.16931697E-05_JPRB, &
  & 0.16957953E-05_JPRB, 0.16981503E-05_JPRB, 0.16996927E-05_JPRB, 0.17001910E-05_JPRB, 0.17009186E-05_JPRB, 0.17033344E-05_JPRB, &
  & 0.17073970E-05_JPRB, 0.17129316E-05_JPRB, 0.17193641E-05_JPRB, 0.17259156E-05_JPRB, 0.17314218E-05_JPRB, 0.17363878E-05_JPRB, &
  & 0.17396376E-05_JPRB, 0.17420614E-05_JPRB, 0.17435942E-05_JPRB, 0.17448991E-05_JPRB, 0.17456544E-05_JPRB, 0.17449284E-05_JPRB, &
  & 0.17435037E-05_JPRB, 0.17421450E-05_JPRB, 0.17400190E-05_JPRB, 0.17367679E-05_JPRB, 0.17328744E-05_JPRB, 0.17295448E-05_JPRB, &
  & 0.17264627E-05_JPRB, 0.17223275E-05_JPRB, 0.17177831E-05_JPRB, 0.17136307E-05_JPRB, 0.17100831E-05_JPRB, 0.17074057E-05_JPRB, &
  & 0.17045090E-05_JPRB, 0.17017068E-05_JPRB, 0.16989856E-05_JPRB, 0.16975326E-05_JPRB, 0.16966419E-05_JPRB, 0.16931402E-05_JPRB, &
  & 0.16914343E-05_JPRB, 0.16923385E-05_JPRB, 0.16915480E-05_JPRB, 0.16910860E-05_JPRB  /)

RGHG2(:,47,11) = (/ &
  & 0.17147856E-05_JPRB, 0.17140204E-05_JPRB, 0.17127404E-05_JPRB, 0.17106066E-05_JPRB, 0.17082692E-05_JPRB, 0.17064890E-05_JPRB, &
  & 0.17051807E-05_JPRB, 0.17049374E-05_JPRB, 0.17052137E-05_JPRB, 0.17051908E-05_JPRB, 0.17057189E-05_JPRB, 0.17060495E-05_JPRB, &
  & 0.17062319E-05_JPRB, 0.17069822E-05_JPRB, 0.17068550E-05_JPRB, 0.17061109E-05_JPRB, 0.17047625E-05_JPRB, 0.17024971E-05_JPRB, &
  & 0.17001233E-05_JPRB, 0.16966039E-05_JPRB, 0.16932550E-05_JPRB, 0.16909182E-05_JPRB, 0.16910123E-05_JPRB, 0.16928420E-05_JPRB, &
  & 0.16955964E-05_JPRB, 0.16979099E-05_JPRB, 0.16994906E-05_JPRB, 0.17002188E-05_JPRB, 0.17011657E-05_JPRB, 0.17035579E-05_JPRB, &
  & 0.17076359E-05_JPRB, 0.17130442E-05_JPRB, 0.17191522E-05_JPRB, 0.17256287E-05_JPRB, 0.17309898E-05_JPRB, 0.17358057E-05_JPRB, &
  & 0.17390987E-05_JPRB, 0.17418242E-05_JPRB, 0.17435201E-05_JPRB, 0.17448649E-05_JPRB, 0.17457849E-05_JPRB, 0.17451176E-05_JPRB, &
  & 0.17437802E-05_JPRB, 0.17428095E-05_JPRB, 0.17414696E-05_JPRB, 0.17396477E-05_JPRB, 0.17374184E-05_JPRB, 0.17354169E-05_JPRB, &
  & 0.17333361E-05_JPRB, 0.17302707E-05_JPRB, 0.17269779E-05_JPRB, 0.17240501E-05_JPRB, 0.17212510E-05_JPRB, 0.17192104E-05_JPRB, &
  & 0.17170426E-05_JPRB, 0.17152123E-05_JPRB, 0.17137279E-05_JPRB, 0.17131352E-05_JPRB, 0.17122216E-05_JPRB, 0.17101035E-05_JPRB, &
  & 0.17097674E-05_JPRB, 0.17104915E-05_JPRB, 0.17096145E-05_JPRB, 0.17094135E-05_JPRB  /)

RGHG2(:,48,11) = (/ &
  & 0.17161708E-05_JPRB, 0.17156198E-05_JPRB, 0.17147231E-05_JPRB, 0.17133129E-05_JPRB, 0.17117584E-05_JPRB, 0.17105722E-05_JPRB, &
  & 0.17095776E-05_JPRB, 0.17093813E-05_JPRB, 0.17095424E-05_JPRB, 0.17096613E-05_JPRB, 0.17101470E-05_JPRB, 0.17101941E-05_JPRB, &
  & 0.17098458E-05_JPRB, 0.17096843E-05_JPRB, 0.17086922E-05_JPRB, 0.17070567E-05_JPRB, 0.17049137E-05_JPRB, 0.17021120E-05_JPRB, &
  & 0.16994864E-05_JPRB, 0.16958605E-05_JPRB, 0.16925162E-05_JPRB, 0.16903499E-05_JPRB, 0.16906763E-05_JPRB, 0.16926907E-05_JPRB, &
  & 0.16955105E-05_JPRB, 0.16977347E-05_JPRB, 0.16993448E-05_JPRB, 0.17002594E-05_JPRB, 0.17013537E-05_JPRB, 0.17037706E-05_JPRB, &
  & 0.17077900E-05_JPRB, 0.17130522E-05_JPRB, 0.17189430E-05_JPRB, 0.17253431E-05_JPRB, 0.17306640E-05_JPRB, 0.17353699E-05_JPRB, &
  & 0.17387210E-05_JPRB, 0.17415477E-05_JPRB, 0.17433853E-05_JPRB, 0.17448253E-05_JPRB, 0.17459181E-05_JPRB, 0.17454323E-05_JPRB, &
  & 0.17440994E-05_JPRB, 0.17434652E-05_JPRB, 0.17426834E-05_JPRB, 0.17419103E-05_JPRB, 0.17408275E-05_JPRB, 0.17397692E-05_JPRB, &
  & 0.17383515E-05_JPRB, 0.17360667E-05_JPRB, 0.17336546E-05_JPRB, 0.17314733E-05_JPRB, 0.17292226E-05_JPRB, 0.17276496E-05_JPRB, &
  & 0.17259768E-05_JPRB, 0.17247203E-05_JPRB, 0.17239077E-05_JPRB, 0.17237132E-05_JPRB, 0.17230158E-05_JPRB, 0.17218014E-05_JPRB, &
  & 0.17218907E-05_JPRB, 0.17223497E-05_JPRB, 0.17217353E-05_JPRB, 0.17217944E-05_JPRB  /)

RGHG2(:,49,11) = (/ &
  & 0.17158760E-05_JPRB, 0.17155033E-05_JPRB, 0.17149288E-05_JPRB, 0.17141904E-05_JPRB, 0.17134402E-05_JPRB, 0.17129878E-05_JPRB, &
  & 0.17125045E-05_JPRB, 0.17124772E-05_JPRB, 0.17125070E-05_JPRB, 0.17127472E-05_JPRB, 0.17132279E-05_JPRB, 0.17130708E-05_JPRB, &
  & 0.17122890E-05_JPRB, 0.17112916E-05_JPRB, 0.17095597E-05_JPRB, 0.17071309E-05_JPRB, 0.17042943E-05_JPRB, 0.17011352E-05_JPRB, &
  & 0.16983632E-05_JPRB, 0.16948385E-05_JPRB, 0.16916909E-05_JPRB, 0.16897999E-05_JPRB, 0.16903790E-05_JPRB, 0.16926035E-05_JPRB, &
  & 0.16954668E-05_JPRB, 0.16975705E-05_JPRB, 0.16992090E-05_JPRB, 0.17003102E-05_JPRB, 0.17015351E-05_JPRB, 0.17040014E-05_JPRB, &
  & 0.17079220E-05_JPRB, 0.17130135E-05_JPRB, 0.17187127E-05_JPRB, 0.17250274E-05_JPRB, 0.17303517E-05_JPRB, 0.17349538E-05_JPRB, &
  & 0.17383760E-05_JPRB, 0.17412237E-05_JPRB, 0.17432085E-05_JPRB, 0.17447791E-05_JPRB, 0.17460669E-05_JPRB, 0.17458380E-05_JPRB, &
  & 0.17444724E-05_JPRB, 0.17441871E-05_JPRB, 0.17439200E-05_JPRB, 0.17441351E-05_JPRB, 0.17440866E-05_JPRB, 0.17438977E-05_JPRB, &
  & 0.17430609E-05_JPRB, 0.17415091E-05_JPRB, 0.17399036E-05_JPRB, 0.17383315E-05_JPRB, 0.17365971E-05_JPRB, 0.17354652E-05_JPRB, &
  & 0.17342342E-05_JPRB, 0.17334321E-05_JPRB, 0.17331065E-05_JPRB, 0.17331429E-05_JPRB, 0.17327937E-05_JPRB, 0.17323617E-05_JPRB, &
  & 0.17324928E-05_JPRB, 0.17326196E-05_JPRB, 0.17324545E-05_JPRB, 0.17328016E-05_JPRB  /)

RGHG2(:,50,11) = (/ &
  & 0.17148407E-05_JPRB, 0.17145388E-05_JPRB, 0.17140386E-05_JPRB, 0.17135473E-05_JPRB, 0.17131769E-05_JPRB, 0.17131315E-05_JPRB, &
  & 0.17130248E-05_JPRB, 0.17131589E-05_JPRB, 0.17131724E-05_JPRB, 0.17134381E-05_JPRB, 0.17138573E-05_JPRB, 0.17135486E-05_JPRB, &
  & 0.17125000E-05_JPRB, 0.17110257E-05_JPRB, 0.17088426E-05_JPRB, 0.17059721E-05_JPRB, 0.17028210E-05_JPRB, 0.16995919E-05_JPRB, &
  & 0.16968644E-05_JPRB, 0.16936932E-05_JPRB, 0.16909351E-05_JPRB, 0.16893343E-05_JPRB, 0.16900799E-05_JPRB, 0.16924731E-05_JPRB, &
  & 0.16953854E-05_JPRB, 0.16973758E-05_JPRB, 0.16989969E-05_JPRB, 0.17002733E-05_JPRB, 0.17016111E-05_JPRB, 0.17041642E-05_JPRB, &
  & 0.17079883E-05_JPRB, 0.17129593E-05_JPRB, 0.17185637E-05_JPRB, 0.17248397E-05_JPRB, 0.17301906E-05_JPRB, 0.17347452E-05_JPRB, &
  & 0.17381798E-05_JPRB, 0.17409592E-05_JPRB, 0.17430140E-05_JPRB, 0.17447589E-05_JPRB, 0.17461653E-05_JPRB, 0.17461635E-05_JPRB, &
  & 0.17449700E-05_JPRB, 0.17449767E-05_JPRB, 0.17451504E-05_JPRB, 0.17461455E-05_JPRB, 0.17468295E-05_JPRB, 0.17472856E-05_JPRB, &
  & 0.17468921E-05_JPRB, 0.17459047E-05_JPRB, 0.17448595E-05_JPRB, 0.17437172E-05_JPRB, 0.17423969E-05_JPRB, 0.17415821E-05_JPRB, &
  & 0.17406974E-05_JPRB, 0.17401407E-05_JPRB, 0.17400772E-05_JPRB, 0.17402920E-05_JPRB, 0.17402415E-05_JPRB, 0.17401795E-05_JPRB, &
  & 0.17402918E-05_JPRB, 0.17403088E-05_JPRB, 0.17403886E-05_JPRB, 0.17407438E-05_JPRB  /)

RGHG2(:,51,11) = (/ &
  & 0.17133316E-05_JPRB, 0.17130498E-05_JPRB, 0.17124998E-05_JPRB, 0.17120522E-05_JPRB, 0.17118698E-05_JPRB, 0.17120927E-05_JPRB, &
  & 0.17123226E-05_JPRB, 0.17126271E-05_JPRB, 0.17126834E-05_JPRB, 0.17129264E-05_JPRB, 0.17132494E-05_JPRB, 0.17128044E-05_JPRB, &
  & 0.17115547E-05_JPRB, 0.17097535E-05_JPRB, 0.17072338E-05_JPRB, 0.17040706E-05_JPRB, 0.17007787E-05_JPRB, 0.16976248E-05_JPRB, &
  & 0.16950459E-05_JPRB, 0.16923895E-05_JPRB, 0.16901542E-05_JPRB, 0.16888751E-05_JPRB, 0.16897552E-05_JPRB, 0.16923093E-05_JPRB, &
  & 0.16952776E-05_JPRB, 0.16971490E-05_JPRB, 0.16987274E-05_JPRB, 0.17001874E-05_JPRB, 0.17016378E-05_JPRB, 0.17043046E-05_JPRB, &
  & 0.17080256E-05_JPRB, 0.17128925E-05_JPRB, 0.17184454E-05_JPRB, 0.17247038E-05_JPRB, 0.17300959E-05_JPRB, 0.17346286E-05_JPRB, &
  & 0.17380457E-05_JPRB, 0.17407045E-05_JPRB, 0.17427943E-05_JPRB, 0.17447507E-05_JPRB, 0.17462454E-05_JPRB, 0.17464735E-05_JPRB, &
  & 0.17455737E-05_JPRB, 0.17458662E-05_JPRB, 0.17464778E-05_JPRB, 0.17482072E-05_JPRB, 0.17495250E-05_JPRB, 0.17505606E-05_JPRB, &
  & 0.17505744E-05_JPRB, 0.17501090E-05_JPRB, 0.17495401E-05_JPRB, 0.17487684E-05_JPRB, 0.17478424E-05_JPRB, 0.17473056E-05_JPRB, &
  & 0.17467452E-05_JPRB, 0.17463441E-05_JPRB, 0.17464458E-05_JPRB, 0.17468258E-05_JPRB, 0.17470725E-05_JPRB, 0.17471941E-05_JPRB, &
  & 0.17472539E-05_JPRB, 0.17472692E-05_JPRB, 0.17475063E-05_JPRB, 0.17477234E-05_JPRB  /)

RGHG2(:,52,11) = (/ &
  & 0.17118371E-05_JPRB, 0.17115637E-05_JPRB, 0.17109300E-05_JPRB, 0.17104380E-05_JPRB, 0.17102828E-05_JPRB, 0.17105151E-05_JPRB, &
  & 0.17107846E-05_JPRB, 0.17110209E-05_JPRB, 0.17109576E-05_JPRB, 0.17111465E-05_JPRB, 0.17113543E-05_JPRB, 0.17108192E-05_JPRB, &
  & 0.17094832E-05_JPRB, 0.17075360E-05_JPRB, 0.17048959E-05_JPRB, 0.17017288E-05_JPRB, 0.16985867E-05_JPRB, 0.16956051E-05_JPRB, &
  & 0.16932972E-05_JPRB, 0.16911715E-05_JPRB, 0.16894362E-05_JPRB, 0.16884351E-05_JPRB, 0.16893836E-05_JPRB, 0.16920848E-05_JPRB, &
  & 0.16951334E-05_JPRB, 0.16969294E-05_JPRB, 0.16984027E-05_JPRB, 0.16999988E-05_JPRB, 0.17014524E-05_JPRB, 0.17041689E-05_JPRB, &
  & 0.17078792E-05_JPRB, 0.17128160E-05_JPRB, 0.17185564E-05_JPRB, 0.17247821E-05_JPRB, 0.17301673E-05_JPRB, 0.17346831E-05_JPRB, &
  & 0.17380530E-05_JPRB, 0.17405714E-05_JPRB, 0.17426722E-05_JPRB, 0.17447101E-05_JPRB, 0.17462899E-05_JPRB, 0.17467106E-05_JPRB, &
  & 0.17462856E-05_JPRB, 0.17468618E-05_JPRB, 0.17478356E-05_JPRB, 0.17500308E-05_JPRB, 0.17518032E-05_JPRB, 0.17532298E-05_JPRB, &
  & 0.17536216E-05_JPRB, 0.17535985E-05_JPRB, 0.17534112E-05_JPRB, 0.17529604E-05_JPRB, 0.17524052E-05_JPRB, 0.17520955E-05_JPRB, &
  & 0.17517869E-05_JPRB, 0.17515985E-05_JPRB, 0.17518861E-05_JPRB, 0.17524769E-05_JPRB, 0.17529389E-05_JPRB, 0.17532424E-05_JPRB, &
  & 0.17533385E-05_JPRB, 0.17534792E-05_JPRB, 0.17538187E-05_JPRB, 0.17539153E-05_JPRB  /)

RGHG2(:,53,11) = (/ &
  & 0.17102152E-05_JPRB, 0.17099464E-05_JPRB, 0.17092084E-05_JPRB, 0.17086344E-05_JPRB, 0.17084469E-05_JPRB, 0.17085897E-05_JPRB, &
  & 0.17087882E-05_JPRB, 0.17088585E-05_JPRB, 0.17086024E-05_JPRB, 0.17087202E-05_JPRB, 0.17087952E-05_JPRB, 0.17081799E-05_JPRB, &
  & 0.17067941E-05_JPRB, 0.17047574E-05_JPRB, 0.17020693E-05_JPRB, 0.16990092E-05_JPRB, 0.16961420E-05_JPRB, 0.16933855E-05_JPRB, &
  & 0.16914198E-05_JPRB, 0.16898779E-05_JPRB, 0.16886786E-05_JPRB, 0.16879634E-05_JPRB, 0.16889608E-05_JPRB, 0.16918169E-05_JPRB, &
  & 0.16949624E-05_JPRB, 0.16966929E-05_JPRB, 0.16980278E-05_JPRB, 0.16997540E-05_JPRB, 0.17011689E-05_JPRB, 0.17039149E-05_JPRB, &
  & 0.17076492E-05_JPRB, 0.17127290E-05_JPRB, 0.17187654E-05_JPRB, 0.17249496E-05_JPRB, 0.17303090E-05_JPRB, 0.17348082E-05_JPRB, &
  & 0.17381154E-05_JPRB, 0.17404733E-05_JPRB, 0.17425769E-05_JPRB, 0.17446535E-05_JPRB, 0.17463246E-05_JPRB, 0.17469409E-05_JPRB, &
  & 0.17471025E-05_JPRB, 0.17479867E-05_JPRB, 0.17493258E-05_JPRB, 0.17519251E-05_JPRB, 0.17541236E-05_JPRB, 0.17559035E-05_JPRB, &
  & 0.17566956E-05_JPRB, 0.17571235E-05_JPRB, 0.17573153E-05_JPRB, 0.17571947E-05_JPRB, 0.17570343E-05_JPRB, 0.17569525E-05_JPRB, &
  & 0.17568901E-05_JPRB, 0.17569554E-05_JPRB, 0.17574532E-05_JPRB, 0.17582913E-05_JPRB, 0.17589562E-05_JPRB, 0.17594571E-05_JPRB, &
  & 0.17596270E-05_JPRB, 0.17599530E-05_JPRB, 0.17603830E-05_JPRB, 0.17603550E-05_JPRB  /)

RGHG2(:,54,11) = (/ &
  & 0.17088749E-05_JPRB, 0.17085276E-05_JPRB, 0.17076625E-05_JPRB, 0.17070411E-05_JPRB, 0.17067032E-05_JPRB, 0.17066257E-05_JPRB, &
  & 0.17066517E-05_JPRB, 0.17064603E-05_JPRB, 0.17059603E-05_JPRB, 0.17059758E-05_JPRB, 0.17059641E-05_JPRB, 0.17053307E-05_JPRB, &
  & 0.17040155E-05_JPRB, 0.17020229E-05_JPRB, 0.16994498E-05_JPRB, 0.16966309E-05_JPRB, 0.16940890E-05_JPRB, 0.16915830E-05_JPRB, &
  & 0.16899087E-05_JPRB, 0.16887929E-05_JPRB, 0.16879718E-05_JPRB, 0.16874678E-05_JPRB, 0.16885288E-05_JPRB, 0.16914535E-05_JPRB, &
  & 0.16946677E-05_JPRB, 0.16963399E-05_JPRB, 0.16976870E-05_JPRB, 0.16993741E-05_JPRB, 0.17007012E-05_JPRB, 0.17033911E-05_JPRB, &
  & 0.17073459E-05_JPRB, 0.17127417E-05_JPRB, 0.17190765E-05_JPRB, 0.17253242E-05_JPRB, 0.17305577E-05_JPRB, 0.17351411E-05_JPRB, &
  & 0.17383319E-05_JPRB, 0.17405883E-05_JPRB, 0.17426408E-05_JPRB, 0.17446853E-05_JPRB, 0.17462950E-05_JPRB, 0.17470963E-05_JPRB, &
  & 0.17477877E-05_JPRB, 0.17489589E-05_JPRB, 0.17505776E-05_JPRB, 0.17534400E-05_JPRB, 0.17559641E-05_JPRB, 0.17579655E-05_JPRB, &
  & 0.17591247E-05_JPRB, 0.17599155E-05_JPRB, 0.17604312E-05_JPRB, 0.17606299E-05_JPRB, 0.17607680E-05_JPRB, 0.17608999E-05_JPRB, &
  & 0.17610398E-05_JPRB, 0.17614060E-05_JPRB, 0.17621773E-05_JPRB, 0.17632540E-05_JPRB, 0.17640628E-05_JPRB, 0.17648066E-05_JPRB, &
  & 0.17650728E-05_JPRB, 0.17655322E-05_JPRB, 0.17660768E-05_JPRB, 0.17659930E-05_JPRB  /)

RGHG2(:,55,11) = (/ &
  & 0.17074273E-05_JPRB, 0.17069821E-05_JPRB, 0.17059732E-05_JPRB, 0.17053038E-05_JPRB, 0.17047839E-05_JPRB, 0.17044451E-05_JPRB, &
  & 0.17042664E-05_JPRB, 0.17037727E-05_JPRB, 0.17029957E-05_JPRB, 0.17028938E-05_JPRB, 0.17027920E-05_JPRB, 0.17021469E-05_JPRB, &
  & 0.17009256E-05_JPRB, 0.16989996E-05_JPRB, 0.16965753E-05_JPRB, 0.16940411E-05_JPRB, 0.16918663E-05_JPRB, 0.16896411E-05_JPRB, &
  & 0.16882830E-05_JPRB, 0.16876183E-05_JPRB, 0.16871955E-05_JPRB, 0.16869157E-05_JPRB, 0.16880491E-05_JPRB, 0.16910384E-05_JPRB, &
  & 0.16943250E-05_JPRB, 0.16959336E-05_JPRB, 0.16973140E-05_JPRB, 0.16989355E-05_JPRB, 0.17001588E-05_JPRB, 0.17027753E-05_JPRB, &
  & 0.17070002E-05_JPRB, 0.17127689E-05_JPRB, 0.17194345E-05_JPRB, 0.17257663E-05_JPRB, 0.17308472E-05_JPRB, 0.17355373E-05_JPRB, &
  & 0.17385921E-05_JPRB, 0.17407437E-05_JPRB, 0.17427326E-05_JPRB, 0.17447321E-05_JPRB, 0.17462537E-05_JPRB, 0.17472586E-05_JPRB, &
  & 0.17485293E-05_JPRB, 0.17500157E-05_JPRB, 0.17519329E-05_JPRB, 0.17550684E-05_JPRB, 0.17579399E-05_JPRB, 0.17601693E-05_JPRB, &
  & 0.17617307E-05_JPRB, 0.17629121E-05_JPRB, 0.17637790E-05_JPRB, 0.17643300E-05_JPRB, 0.17647862E-05_JPRB, 0.17651530E-05_JPRB, &
  & 0.17655112E-05_JPRB, 0.17662170E-05_JPRB, 0.17672995E-05_JPRB, 0.17686395E-05_JPRB, 0.17696000E-05_JPRB, 0.17706188E-05_JPRB, &
  & 0.17709946E-05_JPRB, 0.17715950E-05_JPRB, 0.17722697E-05_JPRB, 0.17721330E-05_JPRB  /)

RGHG2(:,56,11) = (/ &
  & 0.17062734E-05_JPRB, 0.17057589E-05_JPRB, 0.17046885E-05_JPRB, 0.17039792E-05_JPRB, 0.17033295E-05_JPRB, 0.17027892E-05_JPRB, &
  & 0.17024429E-05_JPRB, 0.17017988E-05_JPRB, 0.17009822E-05_JPRB, 0.17007570E-05_JPRB, 0.17005599E-05_JPRB, 0.16998682E-05_JPRB, &
  & 0.16987355E-05_JPRB, 0.16969350E-05_JPRB, 0.16947041E-05_JPRB, 0.16923664E-05_JPRB, 0.16904299E-05_JPRB, 0.16884120E-05_JPRB, &
  & 0.16871607E-05_JPRB, 0.16866977E-05_JPRB, 0.16864060E-05_JPRB, 0.16863730E-05_JPRB, 0.16875004E-05_JPRB, 0.16903762E-05_JPRB, &
  & 0.16935827E-05_JPRB, 0.16953518E-05_JPRB, 0.16967729E-05_JPRB, 0.16982940E-05_JPRB, 0.16994905E-05_JPRB, 0.17019961E-05_JPRB, &
  & 0.17065331E-05_JPRB, 0.17126564E-05_JPRB, 0.17197028E-05_JPRB, 0.17262049E-05_JPRB, 0.17313800E-05_JPRB, 0.17360202E-05_JPRB, &
  & 0.17388820E-05_JPRB, 0.17410425E-05_JPRB, 0.17429631E-05_JPRB, 0.17449911E-05_JPRB, 0.17462322E-05_JPRB, 0.17473789E-05_JPRB, &
  & 0.17490819E-05_JPRB, 0.17507975E-05_JPRB, 0.17528843E-05_JPRB, 0.17561884E-05_JPRB, 0.17593091E-05_JPRB, 0.17617158E-05_JPRB, &
  & 0.17636188E-05_JPRB, 0.17650544E-05_JPRB, 0.17661220E-05_JPRB, 0.17669936E-05_JPRB, 0.17676880E-05_JPRB, 0.17682720E-05_JPRB, &
  & 0.17687920E-05_JPRB, 0.17697532E-05_JPRB, 0.17710205E-05_JPRB, 0.17725261E-05_JPRB, 0.17735847E-05_JPRB, 0.17747582E-05_JPRB, &
  & 0.17752144E-05_JPRB, 0.17758640E-05_JPRB, 0.17765758E-05_JPRB, 0.17763998E-05_JPRB  /)

RGHG2(:,57,11) = (/ &
  & 0.17051177E-05_JPRB, 0.17045474E-05_JPRB, 0.17034336E-05_JPRB, 0.17026919E-05_JPRB, 0.17019435E-05_JPRB, 0.17012394E-05_JPRB, &
  & 0.17007424E-05_JPRB, 0.16999796E-05_JPRB, 0.16991319E-05_JPRB, 0.16987787E-05_JPRB, 0.16984774E-05_JPRB, 0.16977355E-05_JPRB, &
  & 0.16966625E-05_JPRB, 0.16949775E-05_JPRB, 0.16929318E-05_JPRB, 0.16907739E-05_JPRB, 0.16890364E-05_JPRB, 0.16871997E-05_JPRB, &
  & 0.16860357E-05_JPRB, 0.16857353E-05_JPRB, 0.16855788E-05_JPRB, 0.16857760E-05_JPRB, 0.16868745E-05_JPRB, 0.16896077E-05_JPRB, &
  & 0.16927523E-05_JPRB, 0.16946808E-05_JPRB, 0.16961562E-05_JPRB, 0.16975719E-05_JPRB, 0.16987760E-05_JPRB, 0.17011653E-05_JPRB, &
  & 0.17059780E-05_JPRB, 0.17124398E-05_JPRB, 0.17198222E-05_JPRB, 0.17266289E-05_JPRB, 0.17319824E-05_JPRB, 0.17365000E-05_JPRB, &
  & 0.17391860E-05_JPRB, 0.17413398E-05_JPRB, 0.17431951E-05_JPRB, 0.17452157E-05_JPRB, 0.17462684E-05_JPRB, 0.17475128E-05_JPRB, &
  & 0.17496781E-05_JPRB, 0.17516319E-05_JPRB, 0.17538677E-05_JPRB, 0.17573197E-05_JPRB, 0.17606862E-05_JPRB, 0.17633159E-05_JPRB, &
  & 0.17655577E-05_JPRB, 0.17672382E-05_JPRB, 0.17685411E-05_JPRB, 0.17697480E-05_JPRB, 0.17706624E-05_JPRB, 0.17714643E-05_JPRB, &
  & 0.17721562E-05_JPRB, 0.17733624E-05_JPRB, 0.17748066E-05_JPRB, 0.17764561E-05_JPRB, 0.17776424E-05_JPRB, 0.17789599E-05_JPRB, &
  & 0.17795095E-05_JPRB, 0.17802253E-05_JPRB, 0.17809977E-05_JPRB, 0.17808116E-05_JPRB  /)

RGHG2(:,58,11) = (/ &
  & 0.17041070E-05_JPRB, 0.17035133E-05_JPRB, 0.17024056E-05_JPRB, 0.17016487E-05_JPRB, 0.17008718E-05_JPRB, 0.17000915E-05_JPRB, &
  & 0.16994919E-05_JPRB, 0.16987017E-05_JPRB, 0.16978845E-05_JPRB, 0.16974043E-05_JPRB, 0.16969913E-05_JPRB, 0.16961904E-05_JPRB, &
  & 0.16951225E-05_JPRB, 0.16935381E-05_JPRB, 0.16916569E-05_JPRB, 0.16896199E-05_JPRB, 0.16879749E-05_JPRB, 0.16862469E-05_JPRB, &
  & 0.16850910E-05_JPRB, 0.16848272E-05_JPRB, 0.16847520E-05_JPRB, 0.16851370E-05_JPRB, 0.16861553E-05_JPRB, 0.16886752E-05_JPRB, &
  & 0.16917649E-05_JPRB, 0.16938804E-05_JPRB, 0.16954300E-05_JPRB, 0.16967339E-05_JPRB, 0.16980172E-05_JPRB, 0.17002836E-05_JPRB, &
  & 0.17052965E-05_JPRB, 0.17120386E-05_JPRB, 0.17196638E-05_JPRB, 0.17269936E-05_JPRB, 0.17326997E-05_JPRB, 0.17369521E-05_JPRB, &
  & 0.17394949E-05_JPRB, 0.17416375E-05_JPRB, 0.17434369E-05_JPRB, 0.17454037E-05_JPRB, 0.17464025E-05_JPRB, 0.17476510E-05_JPRB, &
  & 0.17502643E-05_JPRB, 0.17524365E-05_JPRB, 0.17547506E-05_JPRB, 0.17582838E-05_JPRB, 0.17618525E-05_JPRB, 0.17647544E-05_JPRB, &
  & 0.17672918E-05_JPRB, 0.17691561E-05_JPRB, 0.17707059E-05_JPRB, 0.17722400E-05_JPRB, 0.17733108E-05_JPRB, 0.17743108E-05_JPRB, &
  & 0.17751673E-05_JPRB, 0.17765654E-05_JPRB, 0.17781356E-05_JPRB, 0.17798623E-05_JPRB, 0.17812061E-05_JPRB, 0.17826150E-05_JPRB, &
  & 0.17832672E-05_JPRB, 0.17840551E-05_JPRB, 0.17849057E-05_JPRB, 0.17847623E-05_JPRB  /)

RGHG2(:,59,11) = (/ &
  & 0.17032790E-05_JPRB, 0.17026995E-05_JPRB, 0.17016342E-05_JPRB, 0.17009052E-05_JPRB, 0.17001453E-05_JPRB, 0.16993808E-05_JPRB, &
  & 0.16987396E-05_JPRB, 0.16979767E-05_JPRB, 0.16972283E-05_JPRB, 0.16966249E-05_JPRB, 0.16961247E-05_JPRB, 0.16952838E-05_JPRB, &
  & 0.16941950E-05_JPRB, 0.16926305E-05_JPRB, 0.16908594E-05_JPRB, 0.16888912E-05_JPRB, 0.16872555E-05_JPRB, 0.16855612E-05_JPRB, &
  & 0.16843702E-05_JPRB, 0.16839865E-05_JPRB, 0.16839494E-05_JPRB, 0.16844414E-05_JPRB, 0.16853633E-05_JPRB, 0.16877262E-05_JPRB, &
  & 0.16908131E-05_JPRB, 0.16929848E-05_JPRB, 0.16946111E-05_JPRB, 0.16957694E-05_JPRB, 0.16971701E-05_JPRB, 0.16995122E-05_JPRB, &
  & 0.17044827E-05_JPRB, 0.17112676E-05_JPRB, 0.17192350E-05_JPRB, 0.17272339E-05_JPRB, 0.17333058E-05_JPRB, 0.17374433E-05_JPRB, &
  & 0.17399040E-05_JPRB, 0.17419202E-05_JPRB, 0.17437260E-05_JPRB, 0.17455294E-05_JPRB, 0.17465952E-05_JPRB, 0.17478825E-05_JPRB, &
  & 0.17509174E-05_JPRB, 0.17531524E-05_JPRB, 0.17555032E-05_JPRB, 0.17590841E-05_JPRB, 0.17628616E-05_JPRB, 0.17660504E-05_JPRB, &
  & 0.17687975E-05_JPRB, 0.17708182E-05_JPRB, 0.17726450E-05_JPRB, 0.17744490E-05_JPRB, 0.17756452E-05_JPRB, 0.17768002E-05_JPRB, &
  & 0.17777919E-05_JPRB, 0.17793366E-05_JPRB, 0.17809903E-05_JPRB, 0.17827234E-05_JPRB, 0.17842710E-05_JPRB, 0.17857441E-05_JPRB, &
  & 0.17865200E-05_JPRB, 0.17873605E-05_JPRB, 0.17883227E-05_JPRB, 0.17882619E-05_JPRB  /)

RGHG2(:,60,11) = (/ &
  & 0.17025277E-05_JPRB, 0.17019846E-05_JPRB, 0.17009836E-05_JPRB, 0.17003014E-05_JPRB, 0.16995726E-05_JPRB, 0.16988624E-05_JPRB, &
  & 0.16982097E-05_JPRB, 0.16975018E-05_JPRB, 0.16968315E-05_JPRB, 0.16961090E-05_JPRB, 0.16955334E-05_JPRB, 0.16946633E-05_JPRB, &
  & 0.16935420E-05_JPRB, 0.16919626E-05_JPRB, 0.16902663E-05_JPRB, 0.16883367E-05_JPRB, 0.16866850E-05_JPRB, 0.16849948E-05_JPRB, &
  & 0.16837528E-05_JPRB, 0.16831743E-05_JPRB, 0.16831069E-05_JPRB, 0.16836500E-05_JPRB, 0.16844662E-05_JPRB, 0.16866965E-05_JPRB, &
  & 0.16897924E-05_JPRB, 0.16919923E-05_JPRB, 0.16936948E-05_JPRB, 0.16947185E-05_JPRB, 0.16962546E-05_JPRB, 0.16987800E-05_JPRB, &
  & 0.17036733E-05_JPRB, 0.17104580E-05_JPRB, 0.17187990E-05_JPRB, 0.17273987E-05_JPRB, 0.17338431E-05_JPRB, 0.17379649E-05_JPRB, &
  & 0.17403852E-05_JPRB, 0.17422379E-05_JPRB, 0.17440522E-05_JPRB, 0.17456355E-05_JPRB, 0.17467923E-05_JPRB, 0.17481840E-05_JPRB, &
  & 0.17516179E-05_JPRB, 0.17538517E-05_JPRB, 0.17562343E-05_JPRB, 0.17598483E-05_JPRB, 0.17638529E-05_JPRB, 0.17673305E-05_JPRB, &
  & 0.17702493E-05_JPRB, 0.17724275E-05_JPRB, 0.17745495E-05_JPRB, 0.17766010E-05_JPRB, 0.17779203E-05_JPRB, 0.17792087E-05_JPRB, &
  & 0.17803287E-05_JPRB, 0.17820093E-05_JPRB, 0.17837343E-05_JPRB, 0.17854566E-05_JPRB, 0.17872235E-05_JPRB, 0.17887396E-05_JPRB, &
  & 0.17896457E-05_JPRB, 0.17905199E-05_JPRB, 0.17916155E-05_JPRB, 0.17916553E-05_JPRB  /)

RGHG2(:,61,11) = (/ &
  & 0.17019784E-05_JPRB, 0.17015092E-05_JPRB, 0.17006051E-05_JPRB, 0.16999846E-05_JPRB, 0.16992822E-05_JPRB, 0.16986580E-05_JPRB, &
  & 0.16980416E-05_JPRB, 0.16974229E-05_JPRB, 0.16968077E-05_JPRB, 0.16959971E-05_JPRB, 0.16953752E-05_JPRB, 0.16945007E-05_JPRB, &
  & 0.16933375E-05_JPRB, 0.16917064E-05_JPRB, 0.16899979E-05_JPRB, 0.16880430E-05_JPRB, 0.16863803E-05_JPRB, 0.16846681E-05_JPRB, &
  & 0.16833732E-05_JPRB, 0.16825237E-05_JPRB, 0.16822052E-05_JPRB, 0.16826668E-05_JPRB, 0.16833762E-05_JPRB, 0.16855239E-05_JPRB, &
  & 0.16886087E-05_JPRB, 0.16908847E-05_JPRB, 0.16926455E-05_JPRB, 0.16936439E-05_JPRB, 0.16953188E-05_JPRB, 0.16981856E-05_JPRB, &
  & 0.17031802E-05_JPRB, 0.17100905E-05_JPRB, 0.17187465E-05_JPRB, 0.17273870E-05_JPRB, 0.17341542E-05_JPRB, 0.17384775E-05_JPRB, &
  & 0.17409561E-05_JPRB, 0.17426668E-05_JPRB, 0.17444172E-05_JPRB, 0.17457229E-05_JPRB, 0.17469017E-05_JPRB, 0.17486052E-05_JPRB, &
  & 0.17523144E-05_JPRB, 0.17544833E-05_JPRB, 0.17569253E-05_JPRB, 0.17605503E-05_JPRB, 0.17648115E-05_JPRB, 0.17685204E-05_JPRB, &
  & 0.17715373E-05_JPRB, 0.17738873E-05_JPRB, 0.17762935E-05_JPRB, 0.17785334E-05_JPRB, 0.17799859E-05_JPRB, 0.17813525E-05_JPRB, &
  & 0.17825893E-05_JPRB, 0.17843988E-05_JPRB, 0.17861877E-05_JPRB, 0.17879198E-05_JPRB, 0.17898762E-05_JPRB, 0.17913758E-05_JPRB, &
  & 0.17923910E-05_JPRB, 0.17932409E-05_JPRB, 0.17944951E-05_JPRB, 0.17946418E-05_JPRB  /)

RGHG2(:,62,11) = (/ &
  & 0.17016350E-05_JPRB, 0.17012395E-05_JPRB, 0.17004273E-05_JPRB, 0.16998492E-05_JPRB, 0.16991823E-05_JPRB, 0.16986189E-05_JPRB, &
  & 0.16980507E-05_JPRB, 0.16975314E-05_JPRB, 0.16969534E-05_JPRB, 0.16960959E-05_JPRB, 0.16954377E-05_JPRB, 0.16945684E-05_JPRB, &
  & 0.16933702E-05_JPRB, 0.16916735E-05_JPRB, 0.16898995E-05_JPRB, 0.16878753E-05_JPRB, 0.16861979E-05_JPRB, 0.16844662E-05_JPRB, &
  & 0.16831167E-05_JPRB, 0.16820122E-05_JPRB, 0.16813138E-05_JPRB, 0.16815592E-05_JPRB, 0.16820467E-05_JPRB, 0.16840479E-05_JPRB, &
  & 0.16870595E-05_JPRB, 0.16894864E-05_JPRB, 0.16913491E-05_JPRB, 0.16924232E-05_JPRB, 0.16941777E-05_JPRB, 0.16974589E-05_JPRB, &
  & 0.17028532E-05_JPRB, 0.17099208E-05_JPRB, 0.17187893E-05_JPRB, 0.17275395E-05_JPRB, 0.17343584E-05_JPRB, 0.17389509E-05_JPRB, &
  & 0.17415248E-05_JPRB, 0.17432837E-05_JPRB, 0.17448541E-05_JPRB, 0.17458212E-05_JPRB, 0.17469363E-05_JPRB, 0.17491237E-05_JPRB, &
  & 0.17529915E-05_JPRB, 0.17551854E-05_JPRB, 0.17576709E-05_JPRB, 0.17613056E-05_JPRB, 0.17657787E-05_JPRB, 0.17696594E-05_JPRB, &
  & 0.17727489E-05_JPRB, 0.17752925E-05_JPRB, 0.17779691E-05_JPRB, 0.17803666E-05_JPRB, 0.17819445E-05_JPRB, 0.17833893E-05_JPRB, &
  & 0.17847303E-05_JPRB, 0.17866752E-05_JPRB, 0.17885349E-05_JPRB, 0.17903074E-05_JPRB, 0.17923811E-05_JPRB, 0.17938366E-05_JPRB, &
  & 0.17948950E-05_JPRB, 0.17957118E-05_JPRB, 0.17970775E-05_JPRB, 0.17973580E-05_JPRB  /)

RGHG2(:,63,11) = (/ &
  & 0.17014197E-05_JPRB, 0.17010906E-05_JPRB, 0.17003614E-05_JPRB, 0.16998152E-05_JPRB, 0.16991947E-05_JPRB, 0.16986742E-05_JPRB, &
  & 0.16981629E-05_JPRB, 0.16977464E-05_JPRB, 0.16971983E-05_JPRB, 0.16963297E-05_JPRB, 0.16956419E-05_JPRB, 0.16947877E-05_JPRB, &
  & 0.16935579E-05_JPRB, 0.16917852E-05_JPRB, 0.16899111E-05_JPRB, 0.16877874E-05_JPRB, 0.16860719E-05_JPRB, 0.16843298E-05_JPRB, &
  & 0.16829090E-05_JPRB, 0.16815691E-05_JPRB, 0.16804425E-05_JPRB, 0.16803635E-05_JPRB, 0.16805407E-05_JPRB, 0.16823336E-05_JPRB, &
  & 0.16852479E-05_JPRB, 0.16878556E-05_JPRB, 0.16898480E-05_JPRB, 0.16910138E-05_JPRB, 0.16927866E-05_JPRB, 0.16964945E-05_JPRB, &
  & 0.17024788E-05_JPRB, 0.17097782E-05_JPRB, 0.17188583E-05_JPRB, 0.17277815E-05_JPRB, 0.17345181E-05_JPRB, 0.17394199E-05_JPRB, &
  & 0.17420812E-05_JPRB, 0.17439782E-05_JPRB, 0.17453373E-05_JPRB, 0.17459505E-05_JPRB, 0.17469788E-05_JPRB, 0.17496985E-05_JPRB, &
  & 0.17536984E-05_JPRB, 0.17559902E-05_JPRB, 0.17584953E-05_JPRB, 0.17621144E-05_JPRB, 0.17667654E-05_JPRB, 0.17707706E-05_JPRB, &
  & 0.17739405E-05_JPRB, 0.17766959E-05_JPRB, 0.17796173E-05_JPRB, 0.17821502E-05_JPRB, 0.17838497E-05_JPRB, 0.17853810E-05_JPRB, &
  & 0.17868269E-05_JPRB, 0.17889126E-05_JPRB, 0.17908548E-05_JPRB, 0.17926838E-05_JPRB, 0.17948101E-05_JPRB, 0.17962048E-05_JPRB, &
  & 0.17972553E-05_JPRB, 0.17980511E-05_JPRB, 0.17994749E-05_JPRB, 0.17999033E-05_JPRB  /)

RGHG2(:,64,11) = (/ &
  & 0.17013211E-05_JPRB, 0.17010377E-05_JPRB, 0.17003712E-05_JPRB, 0.16998491E-05_JPRB, 0.16992912E-05_JPRB, 0.16987924E-05_JPRB, &
  & 0.16983462E-05_JPRB, 0.16980260E-05_JPRB, 0.16975069E-05_JPRB, 0.16966744E-05_JPRB, 0.16959649E-05_JPRB, 0.16951396E-05_JPRB, &
  & 0.16938809E-05_JPRB, 0.16920239E-05_JPRB, 0.16900220E-05_JPRB, 0.16877731E-05_JPRB, 0.16859661E-05_JPRB, 0.16842335E-05_JPRB, &
  & 0.16827043E-05_JPRB, 0.16811717E-05_JPRB, 0.16796452E-05_JPRB, 0.16791229E-05_JPRB, 0.16789001E-05_JPRB, 0.16804039E-05_JPRB, &
  & 0.16832290E-05_JPRB, 0.16860078E-05_JPRB, 0.16881495E-05_JPRB, 0.16893395E-05_JPRB, 0.16910375E-05_JPRB, 0.16951117E-05_JPRB, &
  & 0.17018309E-05_JPRB, 0.17095061E-05_JPRB, 0.17188922E-05_JPRB, 0.17280683E-05_JPRB, 0.17346700E-05_JPRB, 0.17398995E-05_JPRB, &
  & 0.17425873E-05_JPRB, 0.17446458E-05_JPRB, 0.17458434E-05_JPRB, 0.17461410E-05_JPRB, 0.17471163E-05_JPRB, 0.17502914E-05_JPRB, &
  & 0.17544719E-05_JPRB, 0.17569469E-05_JPRB, 0.17594279E-05_JPRB, 0.17629698E-05_JPRB, 0.17677533E-05_JPRB, 0.17718212E-05_JPRB, &
  & 0.17751140E-05_JPRB, 0.17780959E-05_JPRB, 0.17812028E-05_JPRB, 0.17838417E-05_JPRB, 0.17856568E-05_JPRB, 0.17872917E-05_JPRB, &
  & 0.17888533E-05_JPRB, 0.17910812E-05_JPRB, 0.17931246E-05_JPRB, 0.17950162E-05_JPRB, 0.17971063E-05_JPRB, 0.17984288E-05_JPRB, &
  & 0.17994118E-05_JPRB, 0.18002268E-05_JPRB, 0.18016217E-05_JPRB, 0.18021996E-05_JPRB  /)

RGHG2(:,65,11) = (/ &
  & 0.17012539E-05_JPRB, 0.17009987E-05_JPRB, 0.17003863E-05_JPRB, 0.16998930E-05_JPRB, 0.16993959E-05_JPRB, 0.16989257E-05_JPRB, &
  & 0.16985496E-05_JPRB, 0.16982973E-05_JPRB, 0.16978253E-05_JPRB, 0.16970606E-05_JPRB, 0.16963383E-05_JPRB, 0.16955398E-05_JPRB, &
  & 0.16942542E-05_JPRB, 0.16923481E-05_JPRB, 0.16902131E-05_JPRB, 0.16878290E-05_JPRB, 0.16858803E-05_JPRB, 0.16840947E-05_JPRB, &
  & 0.16824563E-05_JPRB, 0.16807452E-05_JPRB, 0.16789345E-05_JPRB, 0.16779386E-05_JPRB, 0.16773016E-05_JPRB, 0.16783616E-05_JPRB, &
  & 0.16811103E-05_JPRB, 0.16840435E-05_JPRB, 0.16861362E-05_JPRB, 0.16875388E-05_JPRB, 0.16892827E-05_JPRB, 0.16937124E-05_JPRB, &
  & 0.17008469E-05_JPRB, 0.17089636E-05_JPRB, 0.17187073E-05_JPRB, 0.17281182E-05_JPRB, 0.17349001E-05_JPRB, 0.17402669E-05_JPRB, &
  & 0.17430375E-05_JPRB, 0.17452026E-05_JPRB, 0.17461838E-05_JPRB, 0.17463292E-05_JPRB, 0.17473991E-05_JPRB, 0.17509366E-05_JPRB, &
  & 0.17554540E-05_JPRB, 0.17580462E-05_JPRB, 0.17604244E-05_JPRB, 0.17637945E-05_JPRB, 0.17687160E-05_JPRB, 0.17728380E-05_JPRB, &
  & 0.17763331E-05_JPRB, 0.17795320E-05_JPRB, 0.17827429E-05_JPRB, 0.17854236E-05_JPRB, 0.17873440E-05_JPRB, 0.17891573E-05_JPRB, &
  & 0.17908309E-05_JPRB, 0.17931863E-05_JPRB, 0.17953160E-05_JPRB, 0.17972146E-05_JPRB, 0.17991831E-05_JPRB, 0.18004283E-05_JPRB, &
  & 0.18013075E-05_JPRB, 0.18022182E-05_JPRB, 0.18035413E-05_JPRB, 0.18043437E-05_JPRB  /)

RGHG2(:,66,11) = (/ &
  & 0.17011796E-05_JPRB, 0.17009458E-05_JPRB, 0.17003890E-05_JPRB, 0.16999323E-05_JPRB, 0.16994898E-05_JPRB, 0.16990618E-05_JPRB, &
  & 0.16987528E-05_JPRB, 0.16985501E-05_JPRB, 0.16981287E-05_JPRB, 0.16974355E-05_JPRB, 0.16967037E-05_JPRB, 0.16959295E-05_JPRB, &
  & 0.16946295E-05_JPRB, 0.16927218E-05_JPRB, 0.16904740E-05_JPRB, 0.16879774E-05_JPRB, 0.16858894E-05_JPRB, 0.16839868E-05_JPRB, &
  & 0.16822036E-05_JPRB, 0.16803212E-05_JPRB, 0.16782634E-05_JPRB, 0.16768158E-05_JPRB, 0.16757662E-05_JPRB, 0.16764763E-05_JPRB, &
  & 0.16791006E-05_JPRB, 0.16820166E-05_JPRB, 0.16838436E-05_JPRB, 0.16857433E-05_JPRB, 0.16876653E-05_JPRB, 0.16924545E-05_JPRB, &
  & 0.16999986E-05_JPRB, 0.17084809E-05_JPRB, 0.17184602E-05_JPRB, 0.17280877E-05_JPRB, 0.17350605E-05_JPRB, 0.17404756E-05_JPRB, &
  & 0.17433518E-05_JPRB, 0.17455906E-05_JPRB, 0.17463689E-05_JPRB, 0.17464870E-05_JPRB, 0.17476624E-05_JPRB, 0.17516258E-05_JPRB, &
  & 0.17565247E-05_JPRB, 0.17591482E-05_JPRB, 0.17613860E-05_JPRB, 0.17645879E-05_JPRB, 0.17696399E-05_JPRB, 0.17738825E-05_JPRB, &
  & 0.17776261E-05_JPRB, 0.17810258E-05_JPRB, 0.17842900E-05_JPRB, 0.17869978E-05_JPRB, 0.17890113E-05_JPRB, 0.17910415E-05_JPRB, &
  & 0.17928199E-05_JPRB, 0.17952822E-05_JPRB, 0.17974627E-05_JPRB, 0.17993666E-05_JPRB, 0.18011552E-05_JPRB, 0.18022933E-05_JPRB, &
  & 0.18030825E-05_JPRB, 0.18041602E-05_JPRB, 0.18054013E-05_JPRB, 0.18064461E-05_JPRB  /)

RGHG2(:,67,11) = (/ &
  & 0.17010951E-05_JPRB, 0.17008787E-05_JPRB, 0.17003812E-05_JPRB, 0.16999666E-05_JPRB, 0.16995706E-05_JPRB, 0.16991976E-05_JPRB, &
  & 0.16989489E-05_JPRB, 0.16987797E-05_JPRB, 0.16984098E-05_JPRB, 0.16977842E-05_JPRB, 0.16970491E-05_JPRB, 0.16962930E-05_JPRB, &
  & 0.16949976E-05_JPRB, 0.16931346E-05_JPRB, 0.16908087E-05_JPRB, 0.16882317E-05_JPRB, 0.16860238E-05_JPRB, 0.16839537E-05_JPRB, &
  & 0.16819668E-05_JPRB, 0.16799036E-05_JPRB, 0.16776359E-05_JPRB, 0.16757915E-05_JPRB, 0.16743417E-05_JPRB, 0.16748385E-05_JPRB, &
  & 0.16772775E-05_JPRB, 0.16799657E-05_JPRB, 0.16814256E-05_JPRB, 0.16839341E-05_JPRB, 0.16862423E-05_JPRB, 0.16914301E-05_JPRB, &
  & 0.16993761E-05_JPRB, 0.17081223E-05_JPRB, 0.17182027E-05_JPRB, 0.17279777E-05_JPRB, 0.17351241E-05_JPRB, 0.17405484E-05_JPRB, &
  & 0.17435077E-05_JPRB, 0.17457741E-05_JPRB, 0.17464047E-05_JPRB, 0.17465887E-05_JPRB, 0.17479052E-05_JPRB, 0.17523333E-05_JPRB, &
  & 0.17576263E-05_JPRB, 0.17602040E-05_JPRB, 0.17622825E-05_JPRB, 0.17653665E-05_JPRB, 0.17705262E-05_JPRB, 0.17749599E-05_JPRB, &
  & 0.17789892E-05_JPRB, 0.17825682E-05_JPRB, 0.17858421E-05_JPRB, 0.17885810E-05_JPRB, 0.17906793E-05_JPRB, 0.17929383E-05_JPRB, &
  & 0.17948158E-05_JPRB, 0.17973470E-05_JPRB, 0.17995350E-05_JPRB, 0.18014338E-05_JPRB, 0.18030110E-05_JPRB, 0.18040258E-05_JPRB, &
  & 0.18047436E-05_JPRB, 0.18060516E-05_JPRB, 0.18071930E-05_JPRB, 0.18084551E-05_JPRB  /)

RGHG2(:,68,11) = (/ &
  & 0.17010009E-05_JPRB, 0.17008018E-05_JPRB, 0.17003711E-05_JPRB, 0.16999986E-05_JPRB, 0.16996397E-05_JPRB, 0.16993310E-05_JPRB, &
  & 0.16991292E-05_JPRB, 0.16989824E-05_JPRB, 0.16986619E-05_JPRB, 0.16980907E-05_JPRB, 0.16973655E-05_JPRB, 0.16966144E-05_JPRB, &
  & 0.16953536E-05_JPRB, 0.16935748E-05_JPRB, 0.16912291E-05_JPRB, 0.16886150E-05_JPRB, 0.16863303E-05_JPRB, 0.16840722E-05_JPRB, &
  & 0.16817786E-05_JPRB, 0.16794877E-05_JPRB, 0.16770592E-05_JPRB, 0.16749254E-05_JPRB, 0.16731020E-05_JPRB, 0.16735568E-05_JPRB, &
  & 0.16757335E-05_JPRB, 0.16779368E-05_JPRB, 0.16791840E-05_JPRB, 0.16820190E-05_JPRB, 0.16850793E-05_JPRB, 0.16907817E-05_JPRB, &
  & 0.16990617E-05_JPRB, 0.17079514E-05_JPRB, 0.17180144E-05_JPRB, 0.17277623E-05_JPRB, 0.17350670E-05_JPRB, 0.17405531E-05_JPRB, &
  & 0.17434827E-05_JPRB, 0.17456996E-05_JPRB, 0.17463105E-05_JPRB, 0.17465885E-05_JPRB, 0.17481622E-05_JPRB, 0.17530134E-05_JPRB, &
  & 0.17586700E-05_JPRB, 0.17611513E-05_JPRB, 0.17630838E-05_JPRB, 0.17661778E-05_JPRB, 0.17713944E-05_JPRB, 0.17760829E-05_JPRB, &
  & 0.17804239E-05_JPRB, 0.17841538E-05_JPRB, 0.17874054E-05_JPRB, 0.17902111E-05_JPRB, 0.17923960E-05_JPRB, 0.17948480E-05_JPRB, &
  & 0.17968244E-05_JPRB, 0.17993532E-05_JPRB, 0.18014941E-05_JPRB, 0.18033484E-05_JPRB, 0.18047351E-05_JPRB, 0.18056435E-05_JPRB, &
  & 0.18063069E-05_JPRB, 0.18078920E-05_JPRB, 0.18088923E-05_JPRB, 0.18102682E-05_JPRB  /)

RGHG2(:,69,11) = (/ &
  & 0.17009044E-05_JPRB, 0.17007226E-05_JPRB, 0.17003564E-05_JPRB, 0.17000215E-05_JPRB, 0.16997019E-05_JPRB, 0.16994553E-05_JPRB, &
  & 0.16992893E-05_JPRB, 0.16991579E-05_JPRB, 0.16988757E-05_JPRB, 0.16983566E-05_JPRB, 0.16976481E-05_JPRB, 0.16968997E-05_JPRB, &
  & 0.16957118E-05_JPRB, 0.16940193E-05_JPRB, 0.16917349E-05_JPRB, 0.16891130E-05_JPRB, 0.16867854E-05_JPRB, 0.16844136E-05_JPRB, &
  & 0.16817570E-05_JPRB, 0.16791643E-05_JPRB, 0.16766223E-05_JPRB, 0.16742621E-05_JPRB, 0.16721035E-05_JPRB, 0.16725883E-05_JPRB, &
  & 0.16744083E-05_JPRB, 0.16761560E-05_JPRB, 0.16773255E-05_JPRB, 0.16802146E-05_JPRB, 0.16841395E-05_JPRB, 0.16904238E-05_JPRB, &
  & 0.16989364E-05_JPRB, 0.17076679E-05_JPRB, 0.17176866E-05_JPRB, 0.17274095E-05_JPRB, 0.17348072E-05_JPRB, 0.17404925E-05_JPRB, &
  & 0.17433542E-05_JPRB, 0.17454856E-05_JPRB, 0.17460857E-05_JPRB, 0.17464396E-05_JPRB, 0.17485431E-05_JPRB, 0.17539771E-05_JPRB, &
  & 0.17597001E-05_JPRB, 0.17619183E-05_JPRB, 0.17638895E-05_JPRB, 0.17670676E-05_JPRB, 0.17723299E-05_JPRB, 0.17773295E-05_JPRB, &
  & 0.17819551E-05_JPRB, 0.17858089E-05_JPRB, 0.17890404E-05_JPRB, 0.17919692E-05_JPRB, 0.17942452E-05_JPRB, 0.17968361E-05_JPRB, &
  & 0.17988281E-05_JPRB, 0.18013274E-05_JPRB, 0.18033291E-05_JPRB, 0.18051276E-05_JPRB, 0.18063351E-05_JPRB, 0.18072294E-05_JPRB, &
  & 0.18078721E-05_JPRB, 0.18096217E-05_JPRB, 0.18104968E-05_JPRB, 0.18117793E-05_JPRB  /)

RGHG2(:,70,11) = (/ &
  & 0.17008171E-05_JPRB, 0.17006570E-05_JPRB, 0.17003466E-05_JPRB, 0.17000460E-05_JPRB, 0.16997646E-05_JPRB, 0.16995742E-05_JPRB, &
  & 0.16994444E-05_JPRB, 0.16993250E-05_JPRB, 0.16990698E-05_JPRB, 0.16985986E-05_JPRB, 0.16979160E-05_JPRB, 0.16971787E-05_JPRB, &
  & 0.16960748E-05_JPRB, 0.16944604E-05_JPRB, 0.16922713E-05_JPRB, 0.16896573E-05_JPRB, 0.16873247E-05_JPRB, 0.16849339E-05_JPRB, &
  & 0.16819497E-05_JPRB, 0.16790329E-05_JPRB, 0.16763387E-05_JPRB, 0.16738010E-05_JPRB, 0.16714095E-05_JPRB, 0.16717489E-05_JPRB, &
  & 0.16732078E-05_JPRB, 0.16746631E-05_JPRB, 0.16757178E-05_JPRB, 0.16785177E-05_JPRB, 0.16831819E-05_JPRB, 0.16902229E-05_JPRB, &
  & 0.16988220E-05_JPRB, 0.17072601E-05_JPRB, 0.17172547E-05_JPRB, 0.17269600E-05_JPRB, 0.17344100E-05_JPRB, 0.17404163E-05_JPRB, &
  & 0.17431874E-05_JPRB, 0.17450844E-05_JPRB, 0.17457479E-05_JPRB, 0.17463516E-05_JPRB, 0.17491248E-05_JPRB, 0.17553441E-05_JPRB, &
  & 0.17607405E-05_JPRB, 0.17626038E-05_JPRB, 0.17647399E-05_JPRB, 0.17680443E-05_JPRB, 0.17733468E-05_JPRB, 0.17787412E-05_JPRB, &
  & 0.17836106E-05_JPRB, 0.17875499E-05_JPRB, 0.17907832E-05_JPRB, 0.17938250E-05_JPRB, 0.17961856E-05_JPRB, 0.17988729E-05_JPRB, &
  & 0.18008451E-05_JPRB, 0.18033078E-05_JPRB, 0.18051406E-05_JPRB, 0.18068778E-05_JPRB, 0.18079428E-05_JPRB, 0.18088552E-05_JPRB, &
  & 0.18094777E-05_JPRB, 0.18113047E-05_JPRB, 0.18121177E-05_JPRB, 0.18131655E-05_JPRB  /)

RGHG2(:,71,11) = (/ &
  & 0.17007392E-05_JPRB, 0.17006039E-05_JPRB, 0.17003425E-05_JPRB, 0.17000740E-05_JPRB, 0.16998280E-05_JPRB, 0.16996878E-05_JPRB, &
  & 0.16995938E-05_JPRB, 0.16994850E-05_JPRB, 0.16992472E-05_JPRB, 0.16988168E-05_JPRB, 0.16981689E-05_JPRB, 0.16974539E-05_JPRB, &
  & 0.16964374E-05_JPRB, 0.16948924E-05_JPRB, 0.16928110E-05_JPRB, 0.16902319E-05_JPRB, 0.16879340E-05_JPRB, 0.16856110E-05_JPRB, &
  & 0.16823674E-05_JPRB, 0.16791278E-05_JPRB, 0.16762409E-05_JPRB, 0.16735689E-05_JPRB, 0.16710412E-05_JPRB, 0.16710220E-05_JPRB, &
  & 0.16721259E-05_JPRB, 0.16733840E-05_JPRB, 0.16743150E-05_JPRB, 0.16769271E-05_JPRB, 0.16821452E-05_JPRB, 0.16900704E-05_JPRB, &
  & 0.16986683E-05_JPRB, 0.17067777E-05_JPRB, 0.17167549E-05_JPRB, 0.17264304E-05_JPRB, 0.17339407E-05_JPRB, 0.17403366E-05_JPRB, &
  & 0.17429967E-05_JPRB, 0.17445772E-05_JPRB, 0.17454065E-05_JPRB, 0.17464025E-05_JPRB, 0.17499958E-05_JPRB, 0.17571676E-05_JPRB, &
  & 0.17618096E-05_JPRB, 0.17632933E-05_JPRB, 0.17656760E-05_JPRB, 0.17691427E-05_JPRB, 0.17744712E-05_JPRB, 0.17803329E-05_JPRB, &
  & 0.17853980E-05_JPRB, 0.17893948E-05_JPRB, 0.17926592E-05_JPRB, 0.17957889E-05_JPRB, 0.17982269E-05_JPRB, 0.18009643E-05_JPRB, &
  & 0.18028825E-05_JPRB, 0.18052987E-05_JPRB, 0.18069494E-05_JPRB, 0.18086340E-05_JPRB, 0.18096087E-05_JPRB, 0.18105383E-05_JPRB, &
  & 0.18111316E-05_JPRB, 0.18129566E-05_JPRB, 0.18137691E-05_JPRB, 0.18145115E-05_JPRB  /)

RGHG2(:,72,11) = (/ &
  & 0.17006687E-05_JPRB, 0.17005581E-05_JPRB, 0.17003437E-05_JPRB, 0.17001075E-05_JPRB, 0.16998912E-05_JPRB, 0.16997955E-05_JPRB, &
  & 0.16997337E-05_JPRB, 0.16996373E-05_JPRB, 0.16994094E-05_JPRB, 0.16990087E-05_JPRB, 0.16984029E-05_JPRB, 0.16977251E-05_JPRB, &
  & 0.16967903E-05_JPRB, 0.16953072E-05_JPRB, 0.16933150E-05_JPRB, 0.16908225E-05_JPRB, 0.16886039E-05_JPRB, 0.16864170E-05_JPRB, &
  & 0.16830274E-05_JPRB, 0.16795005E-05_JPRB, 0.16763932E-05_JPRB, 0.16736221E-05_JPRB, 0.16710325E-05_JPRB, 0.16704140E-05_JPRB, &
  & 0.16711688E-05_JPRB, 0.16721668E-05_JPRB, 0.16730557E-05_JPRB, 0.16754375E-05_JPRB, 0.16809553E-05_JPRB, 0.16897844E-05_JPRB, &
  & 0.16984145E-05_JPRB, 0.17063158E-05_JPRB, 0.17162460E-05_JPRB, 0.17258397E-05_JPRB, 0.17335085E-05_JPRB, 0.17402660E-05_JPRB, &
  & 0.17427949E-05_JPRB, 0.17441278E-05_JPRB, 0.17452690E-05_JPRB, 0.17467034E-05_JPRB, 0.17513219E-05_JPRB, 0.17595437E-05_JPRB, &
  & 0.17629426E-05_JPRB, 0.17641340E-05_JPRB, 0.17667743E-05_JPRB, 0.17704367E-05_JPRB, 0.17757577E-05_JPRB, 0.17821345E-05_JPRB, &
  & 0.17873358E-05_JPRB, 0.17913846E-05_JPRB, 0.17947208E-05_JPRB, 0.17978976E-05_JPRB, 0.18004074E-05_JPRB, 0.18031373E-05_JPRB, &
  & 0.18049589E-05_JPRB, 0.18073083E-05_JPRB, 0.18087807E-05_JPRB, 0.18104480E-05_JPRB, 0.18114103E-05_JPRB, 0.18123052E-05_JPRB, &
  & 0.18128490E-05_JPRB, 0.18145997E-05_JPRB, 0.18154618E-05_JPRB, 0.18159491E-05_JPRB  /)

RGHG2(:,73,11) = (/ &
  & 0.17005955E-05_JPRB, 0.17005144E-05_JPRB, 0.17003496E-05_JPRB, 0.17001435E-05_JPRB, 0.16999570E-05_JPRB, 0.16998970E-05_JPRB, &
  & 0.16998585E-05_JPRB, 0.16997814E-05_JPRB, 0.16995634E-05_JPRB, 0.16991696E-05_JPRB, 0.16986108E-05_JPRB, 0.16979795E-05_JPRB, &
  & 0.16971246E-05_JPRB, 0.16957015E-05_JPRB, 0.16937760E-05_JPRB, 0.16914350E-05_JPRB, 0.16893237E-05_JPRB, 0.16872325E-05_JPRB, &
  & 0.16838337E-05_JPRB, 0.16801559E-05_JPRB, 0.16768521E-05_JPRB, 0.16739837E-05_JPRB, 0.16711871E-05_JPRB, 0.16700830E-05_JPRB, &
  & 0.16702429E-05_JPRB, 0.16708645E-05_JPRB, 0.16718444E-05_JPRB, 0.16741095E-05_JPRB, 0.16794138E-05_JPRB, 0.16891681E-05_JPRB, &
  & 0.16979386E-05_JPRB, 0.17058491E-05_JPRB, 0.17156813E-05_JPRB, 0.17251768E-05_JPRB, 0.17333268E-05_JPRB, 0.17404985E-05_JPRB, &
  & 0.17430378E-05_JPRB, 0.17442642E-05_JPRB, 0.17456503E-05_JPRB, 0.17476152E-05_JPRB, 0.17533867E-05_JPRB, 0.17626164E-05_JPRB, &
  & 0.17644384E-05_JPRB, 0.17654440E-05_JPRB, 0.17682376E-05_JPRB, 0.17720829E-05_JPRB, 0.17774034E-05_JPRB, 0.17842018E-05_JPRB, &
  & 0.17894665E-05_JPRB, 0.17935791E-05_JPRB, 0.17969715E-05_JPRB, 0.18001404E-05_JPRB, 0.18027224E-05_JPRB, 0.18053966E-05_JPRB, &
  & 0.18071188E-05_JPRB, 0.18093733E-05_JPRB, 0.18106411E-05_JPRB, 0.18123806E-05_JPRB, 0.18133925E-05_JPRB, 0.18141859E-05_JPRB, &
  & 0.18146615E-05_JPRB, 0.18162318E-05_JPRB, 0.18172034E-05_JPRB, 0.18176272E-05_JPRB  /)

RGHG2(:,74,11) = (/ &
  & 0.17005271E-05_JPRB, 0.17004819E-05_JPRB, 0.17003684E-05_JPRB, 0.17001921E-05_JPRB, 0.17000281E-05_JPRB, 0.16999955E-05_JPRB, &
  & 0.16999763E-05_JPRB, 0.16999161E-05_JPRB, 0.16997096E-05_JPRB, 0.16993178E-05_JPRB, 0.16988018E-05_JPRB, 0.16982208E-05_JPRB, &
  & 0.16974471E-05_JPRB, 0.16960897E-05_JPRB, 0.16942274E-05_JPRB, 0.16920582E-05_JPRB, 0.16900564E-05_JPRB, 0.16880349E-05_JPRB, &
  & 0.16846835E-05_JPRB, 0.16809798E-05_JPRB, 0.16774685E-05_JPRB, 0.16745135E-05_JPRB, 0.16714663E-05_JPRB, 0.16699093E-05_JPRB, &
  & 0.16694618E-05_JPRB, 0.16696796E-05_JPRB, 0.16707301E-05_JPRB, 0.16729390E-05_JPRB, 0.16777402E-05_JPRB, 0.16881409E-05_JPRB, &
  & 0.16972581E-05_JPRB, 0.17052917E-05_JPRB, 0.17150084E-05_JPRB, 0.17244238E-05_JPRB, 0.17332520E-05_JPRB, 0.17411246E-05_JPRB, &
  & 0.17437028E-05_JPRB, 0.17449407E-05_JPRB, 0.17465868E-05_JPRB, 0.17491895E-05_JPRB, 0.17560234E-05_JPRB, 0.17658241E-05_JPRB, &
  & 0.17662912E-05_JPRB, 0.17671440E-05_JPRB, 0.17700117E-05_JPRB, 0.17740268E-05_JPRB, 0.17793667E-05_JPRB, 0.17864123E-05_JPRB, &
  & 0.17917313E-05_JPRB, 0.17958847E-05_JPRB, 0.17992989E-05_JPRB, 0.18024360E-05_JPRB, 0.18050618E-05_JPRB, 0.18077106E-05_JPRB, &
  & 0.18093407E-05_JPRB, 0.18114862E-05_JPRB, 0.18125398E-05_JPRB, 0.18143874E-05_JPRB, 0.18155079E-05_JPRB, 0.18161853E-05_JPRB, &
  & 0.18165583E-05_JPRB, 0.18178826E-05_JPRB, 0.18189792E-05_JPRB, 0.18194574E-05_JPRB  /)

RGHG2(:,75,11) = (/ &
  & 0.17004696E-05_JPRB, 0.17004648E-05_JPRB, 0.17004007E-05_JPRB, 0.17002535E-05_JPRB, 0.17001035E-05_JPRB, 0.17000925E-05_JPRB, &
  & 0.17000893E-05_JPRB, 0.17000434E-05_JPRB, 0.16998513E-05_JPRB, 0.16994609E-05_JPRB, 0.16989819E-05_JPRB, 0.16984496E-05_JPRB, &
  & 0.16977530E-05_JPRB, 0.16964713E-05_JPRB, 0.16946738E-05_JPRB, 0.16926817E-05_JPRB, 0.16907809E-05_JPRB, 0.16888058E-05_JPRB, &
  & 0.16855567E-05_JPRB, 0.16819158E-05_JPRB, 0.16782028E-05_JPRB, 0.16751931E-05_JPRB, 0.16718877E-05_JPRB, 0.16698861E-05_JPRB, &
  & 0.16688940E-05_JPRB, 0.16686828E-05_JPRB, 0.16697487E-05_JPRB, 0.16718920E-05_JPRB, 0.16760594E-05_JPRB, 0.16867000E-05_JPRB, &
  & 0.16962418E-05_JPRB, 0.17045404E-05_JPRB, 0.17141975E-05_JPRB, 0.17236041E-05_JPRB, 0.17332506E-05_JPRB, 0.17420932E-05_JPRB, &
  & 0.17448328E-05_JPRB, 0.17461869E-05_JPRB, 0.17480924E-05_JPRB, 0.17514409E-05_JPRB, 0.17591829E-05_JPRB, 0.17690643E-05_JPRB, &
  & 0.17684133E-05_JPRB, 0.17692324E-05_JPRB, 0.17721184E-05_JPRB, 0.17762455E-05_JPRB, 0.17815951E-05_JPRB, 0.17887718E-05_JPRB, &
  & 0.17941449E-05_JPRB, 0.17982800E-05_JPRB, 0.18016750E-05_JPRB, 0.18047660E-05_JPRB, 0.18074111E-05_JPRB, 0.18100760E-05_JPRB, &
  & 0.18116288E-05_JPRB, 0.18136459E-05_JPRB, 0.18144811E-05_JPRB, 0.18164779E-05_JPRB, 0.18177376E-05_JPRB, 0.18183023E-05_JPRB, &
  & 0.18185354E-05_JPRB, 0.18195485E-05_JPRB, 0.18207582E-05_JPRB, 0.18213910E-05_JPRB  /)

RGHG2(:,76,11) = (/ &
  & 0.17004315E-05_JPRB, 0.17004688E-05_JPRB, 0.17004469E-05_JPRB, 0.17003269E-05_JPRB, 0.17001818E-05_JPRB, 0.17001906E-05_JPRB, &
  & 0.17001999E-05_JPRB, 0.17001663E-05_JPRB, 0.16999941E-05_JPRB, 0.16996086E-05_JPRB, 0.16991593E-05_JPRB, 0.16986666E-05_JPRB, &
  & 0.16980344E-05_JPRB, 0.16968444E-05_JPRB, 0.16951187E-05_JPRB, 0.16932926E-05_JPRB, 0.16914711E-05_JPRB, 0.16895207E-05_JPRB, &
  & 0.16864401E-05_JPRB, 0.16828958E-05_JPRB, 0.16790193E-05_JPRB, 0.16760194E-05_JPRB, 0.16724887E-05_JPRB, 0.16700239E-05_JPRB, &
  & 0.16686355E-05_JPRB, 0.16679586E-05_JPRB, 0.16689502E-05_JPRB, 0.16709152E-05_JPRB, 0.16745326E-05_JPRB, 0.16848388E-05_JPRB, &
  & 0.16946679E-05_JPRB, 0.17034372E-05_JPRB, 0.17132033E-05_JPRB, 0.17227535E-05_JPRB, 0.17332918E-05_JPRB, 0.17433208E-05_JPRB, &
  & 0.17465138E-05_JPRB, 0.17480735E-05_JPRB, 0.17502018E-05_JPRB, 0.17544074E-05_JPRB, 0.17628331E-05_JPRB, 0.17722661E-05_JPRB, &
  & 0.17706788E-05_JPRB, 0.17717332E-05_JPRB, 0.17746143E-05_JPRB, 0.17787241E-05_JPRB, 0.17840241E-05_JPRB, 0.17913172E-05_JPRB, &
  & 0.17967498E-05_JPRB, 0.18007536E-05_JPRB, 0.18040792E-05_JPRB, 0.18071207E-05_JPRB, 0.18097708E-05_JPRB, 0.18125001E-05_JPRB, &
  & 0.18140008E-05_JPRB, 0.18158594E-05_JPRB, 0.18164766E-05_JPRB, 0.18186815E-05_JPRB, 0.18200676E-05_JPRB, 0.18205431E-05_JPRB, &
  & 0.18205953E-05_JPRB, 0.18212245E-05_JPRB, 0.18224986E-05_JPRB, 0.18233716E-05_JPRB  /)

RGHG2(:,77,11) = (/ &
  & 0.17004239E-05_JPRB, 0.17004920E-05_JPRB, 0.17005009E-05_JPRB, 0.17004038E-05_JPRB, 0.17002637E-05_JPRB, 0.17002903E-05_JPRB, &
  & 0.17003121E-05_JPRB, 0.17002910E-05_JPRB, 0.17001461E-05_JPRB, 0.16997799E-05_JPRB, 0.16993607E-05_JPRB, 0.16988892E-05_JPRB, &
  & 0.16983033E-05_JPRB, 0.16971943E-05_JPRB, 0.16955653E-05_JPRB, 0.16938813E-05_JPRB, 0.16921068E-05_JPRB, 0.16902054E-05_JPRB, &
  & 0.16873504E-05_JPRB, 0.16838350E-05_JPRB, 0.16798904E-05_JPRB, 0.16769220E-05_JPRB, 0.16731936E-05_JPRB, 0.16705259E-05_JPRB, &
  & 0.16687855E-05_JPRB, 0.16677268E-05_JPRB, 0.16683857E-05_JPRB, 0.16702294E-05_JPRB, 0.16733582E-05_JPRB, 0.16828558E-05_JPRB, &
  & 0.16925594E-05_JPRB, 0.17017751E-05_JPRB, 0.17119805E-05_JPRB, 0.17218647E-05_JPRB, 0.17333742E-05_JPRB, 0.17446614E-05_JPRB, &
  & 0.17483522E-05_JPRB, 0.17506923E-05_JPRB, 0.17533565E-05_JPRB, 0.17586530E-05_JPRB, 0.17669476E-05_JPRB, 0.17754470E-05_JPRB, &
  & 0.17731388E-05_JPRB, 0.17742722E-05_JPRB, 0.17771912E-05_JPRB, 0.17813262E-05_JPRB, 0.17867166E-05_JPRB, 0.17941897E-05_JPRB, &
  & 0.17996493E-05_JPRB, 0.18034389E-05_JPRB, 0.18066013E-05_JPRB, 0.18095186E-05_JPRB, 0.18123524E-05_JPRB, 0.18151470E-05_JPRB, &
  & 0.18166617E-05_JPRB, 0.18182428E-05_JPRB, 0.18185150E-05_JPRB, 0.18208618E-05_JPRB, 0.18225142E-05_JPRB, 0.18228945E-05_JPRB, &
  & 0.18227896E-05_JPRB, 0.18230055E-05_JPRB, 0.18241924E-05_JPRB, 0.18252234E-05_JPRB  /)

RGHG2(:,78,11) = (/ &
  & 0.17004338E-05_JPRB, 0.17005256E-05_JPRB, 0.17005517E-05_JPRB, 0.17004756E-05_JPRB, 0.17003421E-05_JPRB, 0.17003894E-05_JPRB, &
  & 0.17004269E-05_JPRB, 0.17004152E-05_JPRB, 0.17002978E-05_JPRB, 0.16999501E-05_JPRB, 0.16995690E-05_JPRB, 0.16991127E-05_JPRB, &
  & 0.16985543E-05_JPRB, 0.16975159E-05_JPRB, 0.16959894E-05_JPRB, 0.16944345E-05_JPRB, 0.16926987E-05_JPRB, 0.16908506E-05_JPRB, &
  & 0.16881741E-05_JPRB, 0.16847300E-05_JPRB, 0.16807627E-05_JPRB, 0.16777503E-05_JPRB, 0.16739238E-05_JPRB, 0.16711240E-05_JPRB, &
  & 0.16690881E-05_JPRB, 0.16677670E-05_JPRB, 0.16679813E-05_JPRB, 0.16698221E-05_JPRB, 0.16725440E-05_JPRB, 0.16812116E-05_JPRB, &
  & 0.16905584E-05_JPRB, 0.16999781E-05_JPRB, 0.17105980E-05_JPRB, 0.17209338E-05_JPRB, 0.17334423E-05_JPRB, 0.17458674E-05_JPRB, &
  & 0.17500152E-05_JPRB, 0.17535824E-05_JPRB, 0.17570530E-05_JPRB, 0.17632545E-05_JPRB, 0.17712573E-05_JPRB, 0.17786036E-05_JPRB, &
  & 0.17756607E-05_JPRB, 0.17768148E-05_JPRB, 0.17798951E-05_JPRB, 0.17840370E-05_JPRB, 0.17895633E-05_JPRB, 0.17971763E-05_JPRB, &
  & 0.18026816E-05_JPRB, 0.18063155E-05_JPRB, 0.18093435E-05_JPRB, 0.18121363E-05_JPRB, 0.18151455E-05_JPRB, 0.18179909E-05_JPRB, &
  & 0.18194465E-05_JPRB, 0.18206488E-05_JPRB, 0.18205863E-05_JPRB, 0.18230198E-05_JPRB, 0.18249038E-05_JPRB, 0.18251570E-05_JPRB, &
  & 0.18248967E-05_JPRB, 0.18247265E-05_JPRB, 0.18258198E-05_JPRB, 0.18269924E-05_JPRB  /)

RGHG2(:,79,11) = (/ &
  & 0.17004590E-05_JPRB, 0.17005644E-05_JPRB, 0.17005973E-05_JPRB, 0.17005411E-05_JPRB, 0.17004166E-05_JPRB, 0.17004832E-05_JPRB, &
  & 0.17005397E-05_JPRB, 0.17005387E-05_JPRB, 0.17004447E-05_JPRB, 0.17001128E-05_JPRB, 0.16997709E-05_JPRB, 0.16993263E-05_JPRB, &
  & 0.16987798E-05_JPRB, 0.16978013E-05_JPRB, 0.16963731E-05_JPRB, 0.16949253E-05_JPRB, 0.16932387E-05_JPRB, 0.16914437E-05_JPRB, &
  & 0.16889263E-05_JPRB, 0.16855880E-05_JPRB, 0.16815890E-05_JPRB, 0.16784695E-05_JPRB, 0.16746221E-05_JPRB, 0.16717425E-05_JPRB, &
  & 0.16694855E-05_JPRB, 0.16680231E-05_JPRB, 0.16677828E-05_JPRB, 0.16696088E-05_JPRB, 0.16719854E-05_JPRB, 0.16798894E-05_JPRB, &
  & 0.16887971E-05_JPRB, 0.16982586E-05_JPRB, 0.17091353E-05_JPRB, 0.17200208E-05_JPRB, 0.17334803E-05_JPRB, 0.17468922E-05_JPRB, &
  & 0.17514703E-05_JPRB, 0.17564139E-05_JPRB, 0.17609368E-05_JPRB, 0.17676406E-05_JPRB, 0.17752172E-05_JPRB, 0.17816278E-05_JPRB, &
  & 0.17781366E-05_JPRB, 0.17792856E-05_JPRB, 0.17825959E-05_JPRB, 0.17867757E-05_JPRB, 0.17925345E-05_JPRB, 0.18002040E-05_JPRB, &
  & 0.18058167E-05_JPRB, 0.18093509E-05_JPRB, 0.18123279E-05_JPRB, 0.18149581E-05_JPRB, 0.18181380E-05_JPRB, 0.18209741E-05_JPRB, &
  & 0.18222498E-05_JPRB, 0.18230377E-05_JPRB, 0.18226887E-05_JPRB, 0.18251644E-05_JPRB, 0.18271725E-05_JPRB, 0.18272351E-05_JPRB, &
  & 0.18268204E-05_JPRB, 0.18263609E-05_JPRB, 0.18273818E-05_JPRB, 0.18287057E-05_JPRB  /)

RGHG2(:,80,11) = (/ &
  & 0.17004973E-05_JPRB, 0.17006029E-05_JPRB, 0.17006358E-05_JPRB, 0.17005995E-05_JPRB, 0.17004873E-05_JPRB, 0.17005662E-05_JPRB, &
  & 0.17006449E-05_JPRB, 0.17006613E-05_JPRB, 0.17005822E-05_JPRB, 0.17002628E-05_JPRB, 0.16999532E-05_JPRB, 0.16995184E-05_JPRB, &
  & 0.16989721E-05_JPRB, 0.16980433E-05_JPRB, 0.16966993E-05_JPRB, 0.16953261E-05_JPRB, 0.16937187E-05_JPRB, 0.16919728E-05_JPRB, &
  & 0.16896328E-05_JPRB, 0.16864179E-05_JPRB, 0.16823200E-05_JPRB, 0.16790516E-05_JPRB, 0.16752296E-05_JPRB, 0.16723126E-05_JPRB, &
  & 0.16699260E-05_JPRB, 0.16684403E-05_JPRB, 0.16678390E-05_JPRB, 0.16694875E-05_JPRB, 0.16715557E-05_JPRB, 0.16788344E-05_JPRB, &
  & 0.16873750E-05_JPRB, 0.16968250E-05_JPRB, 0.17076784E-05_JPRB, 0.17191924E-05_JPRB, 0.17334751E-05_JPRB, 0.17477027E-05_JPRB, &
  & 0.17527060E-05_JPRB, 0.17588458E-05_JPRB, 0.17646384E-05_JPRB, 0.17712320E-05_JPRB, 0.17782408E-05_JPRB, 0.17844009E-05_JPRB, &
  & 0.17804532E-05_JPRB, 0.17816020E-05_JPRB, 0.17851430E-05_JPRB, 0.17894488E-05_JPRB, 0.17955942E-05_JPRB, 0.18031976E-05_JPRB, &
  & 0.18090185E-05_JPRB, 0.18124972E-05_JPRB, 0.18155564E-05_JPRB, 0.18179366E-05_JPRB, 0.18213021E-05_JPRB, 0.18240248E-05_JPRB, &
  & 0.18249572E-05_JPRB, 0.18253703E-05_JPRB, 0.18248153E-05_JPRB, 0.18273041E-05_JPRB, 0.18292608E-05_JPRB, 0.18290352E-05_JPRB, &
  & 0.18284675E-05_JPRB, 0.18278898E-05_JPRB, 0.18288806E-05_JPRB, 0.18303888E-05_JPRB  /)

RGHG2(:,81,11) = (/ &
  & 0.17005473E-05_JPRB, 0.17006400E-05_JPRB, 0.17006704E-05_JPRB, 0.17006418E-05_JPRB, 0.17005500E-05_JPRB, 0.17006390E-05_JPRB, &
  & 0.17007432E-05_JPRB, 0.17007698E-05_JPRB, 0.17006958E-05_JPRB, 0.17003789E-05_JPRB, 0.17000795E-05_JPRB, 0.16996600E-05_JPRB, &
  & 0.16990933E-05_JPRB, 0.16981926E-05_JPRB, 0.16969097E-05_JPRB, 0.16955644E-05_JPRB, 0.16940106E-05_JPRB, 0.16923487E-05_JPRB, &
  & 0.16902074E-05_JPRB, 0.16871224E-05_JPRB, 0.16829303E-05_JPRB, 0.16795829E-05_JPRB, 0.16757253E-05_JPRB, 0.16728082E-05_JPRB, &
  & 0.16703911E-05_JPRB, 0.16689691E-05_JPRB, 0.16682710E-05_JPRB, 0.16697310E-05_JPRB, 0.16714782E-05_JPRB, 0.16779954E-05_JPRB, &
  & 0.16865207E-05_JPRB, 0.16958918E-05_JPRB, 0.17066075E-05_JPRB, 0.17186182E-05_JPRB, 0.17334104E-05_JPRB, 0.17483537E-05_JPRB, &
  & 0.17537238E-05_JPRB, 0.17607219E-05_JPRB, 0.17674927E-05_JPRB, 0.17738953E-05_JPRB, 0.17801450E-05_JPRB, 0.17865700E-05_JPRB, &
  & 0.17823650E-05_JPRB, 0.17835266E-05_JPRB, 0.17872001E-05_JPRB, 0.17918369E-05_JPRB, 0.17986446E-05_JPRB, 0.18061385E-05_JPRB, &
  & 0.18125045E-05_JPRB, 0.18158252E-05_JPRB, 0.18191061E-05_JPRB, 0.18215015E-05_JPRB, 0.18248110E-05_JPRB, 0.18269987E-05_JPRB, &
  & 0.18275975E-05_JPRB, 0.18276082E-05_JPRB, 0.18269386E-05_JPRB, 0.18291727E-05_JPRB, 0.18310453E-05_JPRB, 0.18306873E-05_JPRB, &
  & 0.18299692E-05_JPRB, 0.18292413E-05_JPRB, 0.18302499E-05_JPRB, 0.18320077E-05_JPRB  /)

RGHG2(:,82,11) = (/ &
  & 0.17005938E-05_JPRB, 0.17006704E-05_JPRB, 0.17006983E-05_JPRB, 0.17006755E-05_JPRB, 0.17006057E-05_JPRB, 0.17007066E-05_JPRB, &
  & 0.17008274E-05_JPRB, 0.17008623E-05_JPRB, 0.17007951E-05_JPRB, 0.17004702E-05_JPRB, 0.17001792E-05_JPRB, 0.16997731E-05_JPRB, &
  & 0.16991845E-05_JPRB, 0.16982835E-05_JPRB, 0.16970455E-05_JPRB, 0.16957439E-05_JPRB, 0.16942485E-05_JPRB, 0.16926473E-05_JPRB, &
  & 0.16906490E-05_JPRB, 0.16876579E-05_JPRB, 0.16834301E-05_JPRB, 0.16800359E-05_JPRB, 0.16761621E-05_JPRB, 0.16732380E-05_JPRB, &
  & 0.16708256E-05_JPRB, 0.16693897E-05_JPRB, 0.16686358E-05_JPRB, 0.16700032E-05_JPRB, 0.16715334E-05_JPRB, 0.16776413E-05_JPRB, &
  & 0.16860180E-05_JPRB, 0.16953352E-05_JPRB, 0.17058652E-05_JPRB, 0.17182308E-05_JPRB, 0.17333536E-05_JPRB, 0.17488431E-05_JPRB, &
  & 0.17545917E-05_JPRB, 0.17622251E-05_JPRB, 0.17695027E-05_JPRB, 0.17759313E-05_JPRB, 0.17816041E-05_JPRB, 0.17883011E-05_JPRB, &
  & 0.17839352E-05_JPRB, 0.17850639E-05_JPRB, 0.17888040E-05_JPRB, 0.17938418E-05_JPRB, 0.18012829E-05_JPRB, 0.18089382E-05_JPRB, &
  & 0.18158932E-05_JPRB, 0.18192817E-05_JPRB, 0.18227335E-05_JPRB, 0.18250828E-05_JPRB, 0.18282032E-05_JPRB, 0.18297875E-05_JPRB, &
  & 0.18300407E-05_JPRB, 0.18296252E-05_JPRB, 0.18290014E-05_JPRB, 0.18307964E-05_JPRB, 0.18325750E-05_JPRB, 0.18321187E-05_JPRB, &
  & 0.18312671E-05_JPRB, 0.18305390E-05_JPRB, 0.18315478E-05_JPRB, 0.18334132E-05_JPRB  /)

RGHG2(:,83,11) = (/ &
  & 0.17006364E-05_JPRB, 0.17006955E-05_JPRB, 0.17007198E-05_JPRB, 0.17007020E-05_JPRB, 0.17006548E-05_JPRB, 0.17007674E-05_JPRB, &
  & 0.17009006E-05_JPRB, 0.17009411E-05_JPRB, 0.17008815E-05_JPRB, 0.17005431E-05_JPRB, 0.17002586E-05_JPRB, 0.16998622E-05_JPRB, &
  & 0.16992587E-05_JPRB, 0.16983529E-05_JPRB, 0.16971516E-05_JPRB, 0.16958944E-05_JPRB, 0.16944485E-05_JPRB, 0.16928858E-05_JPRB, &
  & 0.16909734E-05_JPRB, 0.16880631E-05_JPRB, 0.16838271E-05_JPRB, 0.16804188E-05_JPRB, 0.16765423E-05_JPRB, 0.16735995E-05_JPRB, &
  & 0.16712159E-05_JPRB, 0.16697585E-05_JPRB, 0.16689689E-05_JPRB, 0.16703270E-05_JPRB, 0.16716787E-05_JPRB, 0.16776449E-05_JPRB, &
  & 0.16858363E-05_JPRB, 0.16950661E-05_JPRB, 0.17054652E-05_JPRB, 0.17180392E-05_JPRB, 0.17333596E-05_JPRB, 0.17491930E-05_JPRB, &
  & 0.17552336E-05_JPRB, 0.17633209E-05_JPRB, 0.17708417E-05_JPRB, 0.17773917E-05_JPRB, 0.17827324E-05_JPRB, 0.17897137E-05_JPRB, &
  & 0.17852328E-05_JPRB, 0.17862854E-05_JPRB, 0.17900564E-05_JPRB, 0.17954708E-05_JPRB, 0.18035488E-05_JPRB, 0.18114574E-05_JPRB, &
  & 0.18190619E-05_JPRB, 0.18227113E-05_JPRB, 0.18262957E-05_JPRB, 0.18284273E-05_JPRB, 0.18313289E-05_JPRB, 0.18322804E-05_JPRB, &
  & 0.18322470E-05_JPRB, 0.18314887E-05_JPRB, 0.18310153E-05_JPRB, 0.18322865E-05_JPRB, 0.18338720E-05_JPRB, 0.18333338E-05_JPRB, &
  & 0.18323898E-05_JPRB, 0.18317289E-05_JPRB, 0.18327856E-05_JPRB, 0.18346058E-05_JPRB  /)

RGHG2(:,84,11) = (/ &
  & 0.17006744E-05_JPRB, 0.17007160E-05_JPRB, 0.17007356E-05_JPRB, 0.17007228E-05_JPRB, 0.17006976E-05_JPRB, 0.17008204E-05_JPRB, &
  & 0.17009656E-05_JPRB, 0.17010080E-05_JPRB, 0.17009563E-05_JPRB, 0.17006025E-05_JPRB, 0.17003229E-05_JPRB, 0.16999311E-05_JPRB, &
  & 0.16993255E-05_JPRB, 0.16984279E-05_JPRB, 0.16972605E-05_JPRB, 0.16960374E-05_JPRB, 0.16946231E-05_JPRB, 0.16930791E-05_JPRB, &
  & 0.16912025E-05_JPRB, 0.16883766E-05_JPRB, 0.16841353E-05_JPRB, 0.16807462E-05_JPRB, 0.16768689E-05_JPRB, 0.16738942E-05_JPRB, &
  & 0.16715575E-05_JPRB, 0.16701215E-05_JPRB, 0.16692917E-05_JPRB, 0.16707112E-05_JPRB, 0.16718733E-05_JPRB, 0.16778820E-05_JPRB, &
  & 0.16859311E-05_JPRB, 0.16950071E-05_JPRB, 0.17053945E-05_JPRB, 0.17180347E-05_JPRB, 0.17334608E-05_JPRB, 0.17494449E-05_JPRB, &
  & 0.17556213E-05_JPRB, 0.17640236E-05_JPRB, 0.17716907E-05_JPRB, 0.17783628E-05_JPRB, 0.17836375E-05_JPRB, 0.17909191E-05_JPRB, &
  & 0.17863246E-05_JPRB, 0.17872707E-05_JPRB, 0.17910582E-05_JPRB, 0.17967572E-05_JPRB, 0.18054818E-05_JPRB, 0.18135921E-05_JPRB, &
  & 0.18218854E-05_JPRB, 0.18259491E-05_JPRB, 0.18296518E-05_JPRB, 0.18313336E-05_JPRB, 0.18340528E-05_JPRB, 0.18343938E-05_JPRB, &
  & 0.18341942E-05_JPRB, 0.18332475E-05_JPRB, 0.18329883E-05_JPRB, 0.18337302E-05_JPRB, 0.18349597E-05_JPRB, 0.18343372E-05_JPRB, &
  & 0.18333545E-05_JPRB, 0.18327655E-05_JPRB, 0.18339542E-05_JPRB, 0.18355757E-05_JPRB  /)

RGHG2(:,85,11) = (/ &
  & 0.17007079E-05_JPRB, 0.17007289E-05_JPRB, 0.17007460E-05_JPRB, 0.17007382E-05_JPRB, 0.17007337E-05_JPRB, 0.17008718E-05_JPRB, &
  & 0.17010221E-05_JPRB, 0.17010595E-05_JPRB, 0.17010231E-05_JPRB, 0.17006436E-05_JPRB, 0.17003692E-05_JPRB, 0.16999774E-05_JPRB, &
  & 0.16993744E-05_JPRB, 0.16984973E-05_JPRB, 0.16973530E-05_JPRB, 0.16961582E-05_JPRB, 0.16947669E-05_JPRB, 0.16932255E-05_JPRB, &
  & 0.16914055E-05_JPRB, 0.16886720E-05_JPRB, 0.16844178E-05_JPRB, 0.16811186E-05_JPRB, 0.16771488E-05_JPRB, 0.16741459E-05_JPRB, &
  & 0.16719350E-05_JPRB, 0.16705453E-05_JPRB, 0.16695486E-05_JPRB, 0.16711400E-05_JPRB, 0.16720814E-05_JPRB, 0.16782570E-05_JPRB, &
  & 0.16862932E-05_JPRB, 0.16952408E-05_JPRB, 0.17056282E-05_JPRB, 0.17181708E-05_JPRB, 0.17336201E-05_JPRB, 0.17498738E-05_JPRB, &
  & 0.17559937E-05_JPRB, 0.17646194E-05_JPRB, 0.17723276E-05_JPRB, 0.17791383E-05_JPRB, 0.17844746E-05_JPRB, 0.17921234E-05_JPRB, &
  & 0.17873364E-05_JPRB, 0.17882465E-05_JPRB, 0.17920006E-05_JPRB, 0.17979178E-05_JPRB, 0.18071354E-05_JPRB, 0.18153201E-05_JPRB, &
  & 0.18239960E-05_JPRB, 0.18286272E-05_JPRB, 0.18326406E-05_JPRB, 0.18337062E-05_JPRB, 0.18360890E-05_JPRB, 0.18360757E-05_JPRB, &
  & 0.18360070E-05_JPRB, 0.18349756E-05_JPRB, 0.18351169E-05_JPRB, 0.18352708E-05_JPRB, 0.18358636E-05_JPRB, 0.18350716E-05_JPRB, &
  & 0.18340633E-05_JPRB, 0.18335898E-05_JPRB, 0.18348915E-05_JPRB, 0.18360996E-05_JPRB  /)

RGHG2(:,86,11) = (/ &
  & 0.17007313E-05_JPRB, 0.17007397E-05_JPRB, 0.17007542E-05_JPRB, 0.17007496E-05_JPRB, 0.17007637E-05_JPRB, 0.17009253E-05_JPRB, &
  & 0.17010768E-05_JPRB, 0.17011050E-05_JPRB, 0.17010821E-05_JPRB, 0.17006788E-05_JPRB, 0.17004015E-05_JPRB, 0.17000117E-05_JPRB, &
  & 0.16994152E-05_JPRB, 0.16985568E-05_JPRB, 0.16974237E-05_JPRB, 0.16962532E-05_JPRB, 0.16948812E-05_JPRB, 0.16933424E-05_JPRB, &
  & 0.16915791E-05_JPRB, 0.16889546E-05_JPRB, 0.16846855E-05_JPRB, 0.16815530E-05_JPRB, 0.16774179E-05_JPRB, 0.16743685E-05_JPRB, &
  & 0.16724228E-05_JPRB, 0.16708564E-05_JPRB, 0.16697664E-05_JPRB, 0.16715849E-05_JPRB, 0.16722763E-05_JPRB, 0.16787542E-05_JPRB, &
  & 0.16869162E-05_JPRB, 0.16958271E-05_JPRB, 0.17062387E-05_JPRB, 0.17184642E-05_JPRB, 0.17339628E-05_JPRB, 0.17504614E-05_JPRB, &
  & 0.17564200E-05_JPRB, 0.17652320E-05_JPRB, 0.17729594E-05_JPRB, 0.17799677E-05_JPRB, 0.17853821E-05_JPRB, 0.17935446E-05_JPRB, &
  & 0.17884816E-05_JPRB, 0.17893476E-05_JPRB, 0.17929998E-05_JPRB, 0.17991545E-05_JPRB, 0.18087369E-05_JPRB, 0.18168317E-05_JPRB, &
  & 0.18256992E-05_JPRB, 0.18306174E-05_JPRB, 0.18352103E-05_JPRB, 0.18360524E-05_JPRB, 0.18377475E-05_JPRB, 0.18375368E-05_JPRB, &
  & 0.18378147E-05_JPRB, 0.18366841E-05_JPRB, 0.18373044E-05_JPRB, 0.18367508E-05_JPRB, 0.18365709E-05_JPRB, 0.18356448E-05_JPRB, &
  & 0.18346307E-05_JPRB, 0.18341709E-05_JPRB, 0.18356605E-05_JPRB, 0.18363466E-05_JPRB  /)

RGHG2(:,87,11) = (/ &
  & 0.17007486E-05_JPRB, 0.17007492E-05_JPRB, 0.17007611E-05_JPRB, 0.17007578E-05_JPRB, 0.17007889E-05_JPRB, 0.17009781E-05_JPRB, &
  & 0.17011309E-05_JPRB, 0.17011432E-05_JPRB, 0.17011374E-05_JPRB, 0.17007079E-05_JPRB, 0.17004227E-05_JPRB, 0.17000369E-05_JPRB, &
  & 0.16994483E-05_JPRB, 0.16986068E-05_JPRB, 0.16974776E-05_JPRB, 0.16963320E-05_JPRB, 0.16949730E-05_JPRB, 0.16934422E-05_JPRB, &
  & 0.16917365E-05_JPRB, 0.16892032E-05_JPRB, 0.16849198E-05_JPRB, 0.16819986E-05_JPRB, 0.16776829E-05_JPRB, 0.16745677E-05_JPRB, &
  & 0.16730128E-05_JPRB, 0.16711078E-05_JPRB, 0.16699737E-05_JPRB, 0.16720507E-05_JPRB, 0.16724947E-05_JPRB, 0.16795473E-05_JPRB, &
  & 0.16878637E-05_JPRB, 0.16967949E-05_JPRB, 0.17074172E-05_JPRB, 0.17190126E-05_JPRB, 0.17345528E-05_JPRB, 0.17513286E-05_JPRB, &
  & 0.17570318E-05_JPRB, 0.17660769E-05_JPRB, 0.17737906E-05_JPRB, 0.17811409E-05_JPRB, 0.17867421E-05_JPRB, 0.17956006E-05_JPRB, &
  & 0.17899620E-05_JPRB, 0.17907005E-05_JPRB, 0.17942563E-05_JPRB, 0.18007296E-05_JPRB, 0.18105071E-05_JPRB, 0.18183225E-05_JPRB, &
  & 0.18272166E-05_JPRB, 0.18322695E-05_JPRB, 0.18374947E-05_JPRB, 0.18383792E-05_JPRB, 0.18391639E-05_JPRB, 0.18387638E-05_JPRB, &
  & 0.18398371E-05_JPRB, 0.18385281E-05_JPRB, 0.18395043E-05_JPRB, 0.18381062E-05_JPRB, 0.18371020E-05_JPRB, 0.18360849E-05_JPRB, &
  & 0.18350962E-05_JPRB, 0.18345217E-05_JPRB, 0.18362236E-05_JPRB, 0.18364920E-05_JPRB  /)

RGHG2(:,88,11) = (/ &
  & 0.17007616E-05_JPRB, 0.17007576E-05_JPRB, 0.17007674E-05_JPRB, 0.17007634E-05_JPRB, 0.17008109E-05_JPRB, 0.17010327E-05_JPRB, &
  & 0.17011882E-05_JPRB, 0.17011762E-05_JPRB, 0.17011916E-05_JPRB, 0.17007311E-05_JPRB, 0.17004365E-05_JPRB, 0.17000546E-05_JPRB, &
  & 0.16994734E-05_JPRB, 0.16986493E-05_JPRB, 0.16975200E-05_JPRB, 0.16964019E-05_JPRB, 0.16950503E-05_JPRB, 0.16935308E-05_JPRB, &
  & 0.16918887E-05_JPRB, 0.16894079E-05_JPRB, 0.16851194E-05_JPRB, 0.16824042E-05_JPRB, 0.16779650E-05_JPRB, 0.16747572E-05_JPRB, &
  & 0.16736502E-05_JPRB, 0.16713716E-05_JPRB, 0.16702140E-05_JPRB, 0.16725825E-05_JPRB, 0.16727829E-05_JPRB, 0.16809187E-05_JPRB, &
  & 0.16892615E-05_JPRB, 0.16982908E-05_JPRB, 0.17094118E-05_JPRB, 0.17200121E-05_JPRB, 0.17354856E-05_JPRB, 0.17527130E-05_JPRB, &
  & 0.17580567E-05_JPRB, 0.17674840E-05_JPRB, 0.17753012E-05_JPRB, 0.17831718E-05_JPRB, 0.17897624E-05_JPRB, 0.17992235E-05_JPRB, &
  & 0.17921669E-05_JPRB, 0.17926787E-05_JPRB, 0.17962165E-05_JPRB, 0.18031435E-05_JPRB, 0.18128264E-05_JPRB, 0.18200461E-05_JPRB, &
  & 0.18288344E-05_JPRB, 0.18338932E-05_JPRB, 0.18397770E-05_JPRB, 0.18406944E-05_JPRB, 0.18404330E-05_JPRB, 0.18398319E-05_JPRB, &
  & 0.18423095E-05_JPRB, 0.18406938E-05_JPRB, 0.18416469E-05_JPRB, 0.18393016E-05_JPRB, 0.18374944E-05_JPRB, 0.18364350E-05_JPRB, &
  & 0.18354930E-05_JPRB, 0.18347060E-05_JPRB, 0.18365638E-05_JPRB, 0.18366057E-05_JPRB  /)

RGHG2(:,89,11) = (/ &
  & 0.17007702E-05_JPRB, 0.17007636E-05_JPRB, 0.17007731E-05_JPRB, 0.17007669E-05_JPRB, 0.17008309E-05_JPRB, 0.17010937E-05_JPRB, &
  & 0.17012521E-05_JPRB, 0.17012077E-05_JPRB, 0.17012433E-05_JPRB, 0.17007486E-05_JPRB, 0.17004479E-05_JPRB, 0.17000660E-05_JPRB, &
  & 0.16994905E-05_JPRB, 0.16986858E-05_JPRB, 0.16975561E-05_JPRB, 0.16964690E-05_JPRB, 0.16951228E-05_JPRB, 0.16936080E-05_JPRB, &
  & 0.16920425E-05_JPRB, 0.16895696E-05_JPRB, 0.16852995E-05_JPRB, 0.16827140E-05_JPRB, 0.16782927E-05_JPRB, 0.16749616E-05_JPRB, &
  & 0.16742179E-05_JPRB, 0.16717564E-05_JPRB, 0.16705549E-05_JPRB, 0.16732683E-05_JPRB, 0.16732041E-05_JPRB, 0.16831032E-05_JPRB, &
  & 0.16912591E-05_JPRB, 0.17005591E-05_JPRB, 0.17124274E-05_JPRB, 0.17216431E-05_JPRB, 0.17368365E-05_JPRB, 0.17550085E-05_JPRB, &
  & 0.17598717E-05_JPRB, 0.17699697E-05_JPRB, 0.17784075E-05_JPRB, 0.17876408E-05_JPRB, 0.17974429E-05_JPRB, 0.18065127E-05_JPRB, &
  & 0.17959016E-05_JPRB, 0.17961303E-05_JPRB, 0.17999408E-05_JPRB, 0.18072708E-05_JPRB, 0.18163926E-05_JPRB, 0.18223576E-05_JPRB, &
  & 0.18309705E-05_JPRB, 0.18358685E-05_JPRB, 0.18424573E-05_JPRB, 0.18429406E-05_JPRB, 0.18416171E-05_JPRB, 0.18408518E-05_JPRB, &
  & 0.18452689E-05_JPRB, 0.18431669E-05_JPRB, 0.18434949E-05_JPRB, 0.18402815E-05_JPRB, 0.18378081E-05_JPRB, 0.18367475E-05_JPRB, &
  & 0.18358553E-05_JPRB, 0.18348638E-05_JPRB, 0.18366987E-05_JPRB, 0.18366833E-05_JPRB  /)

RGHG2(:,90,11) = (/ &
  & 0.17007732E-05_JPRB, 0.17007664E-05_JPRB, 0.17007732E-05_JPRB, 0.17007697E-05_JPRB, 0.17008460E-05_JPRB, 0.17011567E-05_JPRB, &
  & 0.17013190E-05_JPRB, 0.17012348E-05_JPRB, 0.17012911E-05_JPRB, 0.17007636E-05_JPRB, 0.17004540E-05_JPRB, 0.17000720E-05_JPRB, &
  & 0.16995029E-05_JPRB, 0.16987129E-05_JPRB, 0.16975805E-05_JPRB, 0.16965427E-05_JPRB, 0.16951989E-05_JPRB, 0.16936804E-05_JPRB, &
  & 0.16922112E-05_JPRB, 0.16897646E-05_JPRB, 0.16855207E-05_JPRB, 0.16831189E-05_JPRB, 0.16786918E-05_JPRB, 0.16752361E-05_JPRB, &
  & 0.16749149E-05_JPRB, 0.16723464E-05_JPRB, 0.16710897E-05_JPRB, 0.16743001E-05_JPRB, 0.16738694E-05_JPRB, 0.16854684E-05_JPRB, &
  & 0.16941492E-05_JPRB, 0.17041152E-05_JPRB, 0.17165246E-05_JPRB, 0.17234922E-05_JPRB, 0.17386358E-05_JPRB, 0.17588915E-05_JPRB, &
  & 0.17630146E-05_JPRB, 0.17741991E-05_JPRB, 0.17843262E-05_JPRB, 0.18004665E-05_JPRB, 0.18164231E-05_JPRB, 0.18224380E-05_JPRB, &
  & 0.18033715E-05_JPRB, 0.18030721E-05_JPRB, 0.18082943E-05_JPRB, 0.18145275E-05_JPRB, 0.18227521E-05_JPRB, 0.18258668E-05_JPRB, &
  & 0.18341751E-05_JPRB, 0.18388079E-05_JPRB, 0.18456825E-05_JPRB, 0.18454670E-05_JPRB, 0.18429046E-05_JPRB, 0.18416864E-05_JPRB, &
  & 0.18479958E-05_JPRB, 0.18450641E-05_JPRB, 0.18449326E-05_JPRB, 0.18411346E-05_JPRB, 0.18380693E-05_JPRB, 0.18369812E-05_JPRB, &
  & 0.18362479E-05_JPRB, 0.18350408E-05_JPRB, 0.18367524E-05_JPRB, 0.18367191E-05_JPRB  /)

RGHG2(:,91,11) = (/ &
  & 0.17007780E-05_JPRB, 0.17007648E-05_JPRB, 0.17007780E-05_JPRB, 0.17007681E-05_JPRB, 0.17008603E-05_JPRB, 0.17012093E-05_JPRB, &
  & 0.17014036E-05_JPRB, 0.17012587E-05_JPRB, 0.17013278E-05_JPRB, 0.17007780E-05_JPRB, 0.17004619E-05_JPRB, 0.17000800E-05_JPRB, &
  & 0.16995236E-05_JPRB, 0.16987400E-05_JPRB, 0.16976140E-05_JPRB, 0.16966560E-05_JPRB, 0.16952962E-05_JPRB, 0.16937554E-05_JPRB, &
  & 0.16924681E-05_JPRB, 0.16901140E-05_JPRB, 0.16858702E-05_JPRB, 0.16838289E-05_JPRB, 0.16791274E-05_JPRB, 0.16756078E-05_JPRB, &
  & 0.16755387E-05_JPRB, 0.16733723E-05_JPRB, 0.16719401E-05_JPRB, 0.16760918E-05_JPRB, 0.16750580E-05_JPRB, 0.16886259E-05_JPRB, &
  & 0.16983054E-05_JPRB, 0.17100329E-05_JPRB, 0.17218360E-05_JPRB, 0.17259317E-05_JPRB, 0.17413433E-05_JPRB, 0.17653644E-05_JPRB, &
  & 0.17671357E-05_JPRB, 0.17792648E-05_JPRB, 0.17933200E-05_JPRB, 0.18290817E-05_JPRB, 0.18532806E-05_JPRB, 0.18506862E-05_JPRB, &
  & 0.18211405E-05_JPRB, 0.18159781E-05_JPRB, 0.18256708E-05_JPRB, 0.18262272E-05_JPRB, 0.18340466E-05_JPRB, 0.18326045E-05_JPRB, &
  & 0.18394132E-05_JPRB, 0.18432290E-05_JPRB, 0.18500047E-05_JPRB, 0.18490170E-05_JPRB, 0.18446612E-05_JPRB, 0.18425113E-05_JPRB, &
  & 0.18504130E-05_JPRB, 0.18468144E-05_JPRB, 0.18462745E-05_JPRB, 0.18418956E-05_JPRB, 0.18382081E-05_JPRB, 0.18371711E-05_JPRB, &
  & 0.18365685E-05_JPRB, 0.18351923E-05_JPRB, 0.18367891E-05_JPRB, 0.18367430E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ---GEMS----

RGHG2(:, 1,12) = (/ &
  & 0.14567598E-06_JPRB, 0.14562331E-06_JPRB, 0.14560520E-06_JPRB, 0.14561919E-06_JPRB, 0.14569162E-06_JPRB, 0.14586200E-06_JPRB, &
  & 0.14617149E-06_JPRB, 0.14657645E-06_JPRB, 0.14700363E-06_JPRB, 0.14743493E-06_JPRB, 0.14785965E-06_JPRB, 0.14826955E-06_JPRB, &
  & 0.14866793E-06_JPRB, 0.14904326E-06_JPRB, 0.14935850E-06_JPRB, 0.14961777E-06_JPRB, 0.14985729E-06_JPRB, 0.15014291E-06_JPRB, &
  & 0.15051824E-06_JPRB, 0.15104419E-06_JPRB, 0.15179979E-06_JPRB, 0.15282454E-06_JPRB, 0.15403696E-06_JPRB, 0.15540329E-06_JPRB, &
  & 0.15689391E-06_JPRB, 0.15849071E-06_JPRB, 0.16012949E-06_JPRB, 0.16182259E-06_JPRB, 0.16342927E-06_JPRB, 0.16490096E-06_JPRB, &
  & 0.16644837E-06_JPRB, 0.16809374E-06_JPRB, 0.16981071E-06_JPRB, 0.17214253E-06_JPRB, 0.17546453E-06_JPRB, 0.17919232E-06_JPRB, &
  & 0.18288389E-06_JPRB, 0.18619272E-06_JPRB, 0.18867517E-06_JPRB, 0.19073208E-06_JPRB, 0.19238485E-06_JPRB, 0.19370344E-06_JPRB, &
  & 0.19459732E-06_JPRB, 0.19500064E-06_JPRB, 0.19497183E-06_JPRB, 0.19485989E-06_JPRB, 0.19481050E-06_JPRB, 0.19494055E-06_JPRB, &
  & 0.19520147E-06_JPRB, 0.19566405E-06_JPRB, 0.19624680E-06_JPRB, 0.19677687E-06_JPRB, 0.19715549E-06_JPRB, 0.19760737E-06_JPRB, &
  & 0.19796953E-06_JPRB, 0.19831358E-06_JPRB, 0.19858191E-06_JPRB, 0.19882719E-06_JPRB, 0.19904202E-06_JPRB, 0.19915232E-06_JPRB, &
  & 0.19930953E-06_JPRB, 0.19944287E-06_JPRB, 0.19940500E-06_JPRB, 0.19933586E-06_JPRB  /)

RGHG2(:, 2,12) = (/ &
  & 0.14567598E-06_JPRB, 0.14562331E-06_JPRB, 0.14560520E-06_JPRB, 0.14561919E-06_JPRB, 0.14569162E-06_JPRB, 0.14586200E-06_JPRB, &
  & 0.14617149E-06_JPRB, 0.14657645E-06_JPRB, 0.14700363E-06_JPRB, 0.14743493E-06_JPRB, 0.14785965E-06_JPRB, 0.14826955E-06_JPRB, &
  & 0.14866793E-06_JPRB, 0.14904326E-06_JPRB, 0.14935850E-06_JPRB, 0.14961777E-06_JPRB, 0.14985729E-06_JPRB, 0.15014291E-06_JPRB, &
  & 0.15051824E-06_JPRB, 0.15104419E-06_JPRB, 0.15179979E-06_JPRB, 0.15282454E-06_JPRB, 0.15403696E-06_JPRB, 0.15540329E-06_JPRB, &
  & 0.15689391E-06_JPRB, 0.15849071E-06_JPRB, 0.16012949E-06_JPRB, 0.16182259E-06_JPRB, 0.16342927E-06_JPRB, 0.16490096E-06_JPRB, &
  & 0.16644837E-06_JPRB, 0.16809374E-06_JPRB, 0.16981071E-06_JPRB, 0.17214253E-06_JPRB, 0.17546453E-06_JPRB, 0.17919232E-06_JPRB, &
  & 0.18288389E-06_JPRB, 0.18619272E-06_JPRB, 0.18867517E-06_JPRB, 0.19073208E-06_JPRB, 0.19238485E-06_JPRB, 0.19370344E-06_JPRB, &
  & 0.19459732E-06_JPRB, 0.19500064E-06_JPRB, 0.19497183E-06_JPRB, 0.19485989E-06_JPRB, 0.19481050E-06_JPRB, 0.19494055E-06_JPRB, &
  & 0.19520147E-06_JPRB, 0.19566405E-06_JPRB, 0.19624680E-06_JPRB, 0.19677687E-06_JPRB, 0.19715549E-06_JPRB, 0.19760737E-06_JPRB, &
  & 0.19796953E-06_JPRB, 0.19831358E-06_JPRB, 0.19858191E-06_JPRB, 0.19882719E-06_JPRB, 0.19904202E-06_JPRB, 0.19915232E-06_JPRB, &
  & 0.19930953E-06_JPRB, 0.19944287E-06_JPRB, 0.19940500E-06_JPRB, 0.19933586E-06_JPRB  /)

RGHG2(:, 3,12) = (/ &
  & 0.14567598E-06_JPRB, 0.14562331E-06_JPRB, 0.14560520E-06_JPRB, 0.14561919E-06_JPRB, 0.14569162E-06_JPRB, 0.14586200E-06_JPRB, &
  & 0.14617149E-06_JPRB, 0.14657645E-06_JPRB, 0.14700363E-06_JPRB, 0.14743493E-06_JPRB, 0.14785965E-06_JPRB, 0.14826955E-06_JPRB, &
  & 0.14866793E-06_JPRB, 0.14904326E-06_JPRB, 0.14935850E-06_JPRB, 0.14961777E-06_JPRB, 0.14985729E-06_JPRB, 0.15014291E-06_JPRB, &
  & 0.15051824E-06_JPRB, 0.15104419E-06_JPRB, 0.15179979E-06_JPRB, 0.15282454E-06_JPRB, 0.15403696E-06_JPRB, 0.15540329E-06_JPRB, &
  & 0.15689391E-06_JPRB, 0.15849071E-06_JPRB, 0.16012949E-06_JPRB, 0.16182259E-06_JPRB, 0.16342927E-06_JPRB, 0.16490096E-06_JPRB, &
  & 0.16644837E-06_JPRB, 0.16809374E-06_JPRB, 0.16981071E-06_JPRB, 0.17214253E-06_JPRB, 0.17546453E-06_JPRB, 0.17919232E-06_JPRB, &
  & 0.18288389E-06_JPRB, 0.18619272E-06_JPRB, 0.18867517E-06_JPRB, 0.19073208E-06_JPRB, 0.19238485E-06_JPRB, 0.19370344E-06_JPRB, &
  & 0.19459732E-06_JPRB, 0.19500064E-06_JPRB, 0.19497183E-06_JPRB, 0.19485989E-06_JPRB, 0.19481050E-06_JPRB, 0.19494055E-06_JPRB, &
  & 0.19520147E-06_JPRB, 0.19566405E-06_JPRB, 0.19624680E-06_JPRB, 0.19677687E-06_JPRB, 0.19715549E-06_JPRB, 0.19760737E-06_JPRB, &
  & 0.19796953E-06_JPRB, 0.19831358E-06_JPRB, 0.19858191E-06_JPRB, 0.19882719E-06_JPRB, 0.19904202E-06_JPRB, 0.19915232E-06_JPRB, &
  & 0.19930953E-06_JPRB, 0.19944287E-06_JPRB, 0.19940500E-06_JPRB, 0.19933586E-06_JPRB  /)

RGHG2(:, 4,12) = (/ &
  & 0.14571924E-06_JPRB, 0.14566590E-06_JPRB, 0.14564690E-06_JPRB, 0.14566036E-06_JPRB, 0.14573223E-06_JPRB, 0.14590190E-06_JPRB, &
  & 0.14621043E-06_JPRB, 0.14661413E-06_JPRB, 0.14703847E-06_JPRB, 0.14746623E-06_JPRB, 0.14788838E-06_JPRB, 0.14829659E-06_JPRB, &
  & 0.14869366E-06_JPRB, 0.14906754E-06_JPRB, 0.14938124E-06_JPRB, 0.14963922E-06_JPRB, 0.14987790E-06_JPRB, 0.15016335E-06_JPRB, &
  & 0.15053954E-06_JPRB, 0.15106784E-06_JPRB, 0.15182676E-06_JPRB, 0.15285488E-06_JPRB, 0.15407047E-06_JPRB, 0.15543986E-06_JPRB, &
  & 0.15693370E-06_JPRB, 0.15853410E-06_JPRB, 0.16017688E-06_JPRB, 0.16187403E-06_JPRB, 0.16348490E-06_JPRB, 0.16496041E-06_JPRB, &
  & 0.16650894E-06_JPRB, 0.16815491E-06_JPRB, 0.16987510E-06_JPRB, 0.17221148E-06_JPRB, 0.17553565E-06_JPRB, 0.17926386E-06_JPRB, &
  & 0.18295149E-06_JPRB, 0.18625219E-06_JPRB, 0.18872967E-06_JPRB, 0.19078346E-06_JPRB, 0.19243450E-06_JPRB, 0.19375066E-06_JPRB, &
  & 0.19464156E-06_JPRB, 0.19504353E-06_JPRB, 0.19501517E-06_JPRB, 0.19490343E-06_JPRB, 0.19485318E-06_JPRB, 0.19498136E-06_JPRB, &
  & 0.19523977E-06_JPRB, 0.19569874E-06_JPRB, 0.19627806E-06_JPRB, 0.19680532E-06_JPRB, 0.19718116E-06_JPRB, 0.19762957E-06_JPRB, &
  & 0.19798872E-06_JPRB, 0.19832993E-06_JPRB, 0.19859626E-06_JPRB, 0.19883940E-06_JPRB, 0.19905269E-06_JPRB, 0.19916212E-06_JPRB, &
  & 0.19931841E-06_JPRB, 0.19945090E-06_JPRB, 0.19941427E-06_JPRB, 0.19934636E-06_JPRB  /)

RGHG2(:, 5,12) = (/ &
  & 0.14777247E-06_JPRB, 0.14768788E-06_JPRB, 0.14762621E-06_JPRB, 0.14761444E-06_JPRB, 0.14765956E-06_JPRB, 0.14779589E-06_JPRB, &
  & 0.14805905E-06_JPRB, 0.14840296E-06_JPRB, 0.14869209E-06_JPRB, 0.14895160E-06_JPRB, 0.14925237E-06_JPRB, 0.14958005E-06_JPRB, &
  & 0.14991523E-06_JPRB, 0.15022000E-06_JPRB, 0.15046039E-06_JPRB, 0.15065708E-06_JPRB, 0.15085580E-06_JPRB, 0.15113374E-06_JPRB, &
  & 0.15155080E-06_JPRB, 0.15219026E-06_JPRB, 0.15310692E-06_JPRB, 0.15429488E-06_JPRB, 0.15566130E-06_JPRB, 0.15717551E-06_JPRB, &
  & 0.15882197E-06_JPRB, 0.16059364E-06_JPRB, 0.16242631E-06_JPRB, 0.16431575E-06_JPRB, 0.16612521E-06_JPRB, 0.16778250E-06_JPRB, &
  & 0.16938391E-06_JPRB, 0.17105842E-06_JPRB, 0.17293154E-06_JPRB, 0.17548425E-06_JPRB, 0.17891117E-06_JPRB, 0.18265982E-06_JPRB, &
  & 0.18616026E-06_JPRB, 0.18907488E-06_JPRB, 0.19131650E-06_JPRB, 0.19322247E-06_JPRB, 0.19479118E-06_JPRB, 0.19599197E-06_JPRB, &
  & 0.19674166E-06_JPRB, 0.19707963E-06_JPRB, 0.19707230E-06_JPRB, 0.19697048E-06_JPRB, 0.19687876E-06_JPRB, 0.19691831E-06_JPRB, &
  & 0.19705774E-06_JPRB, 0.19734545E-06_JPRB, 0.19776193E-06_JPRB, 0.19815579E-06_JPRB, 0.19839942E-06_JPRB, 0.19868318E-06_JPRB, &
  & 0.19889962E-06_JPRB, 0.19910562E-06_JPRB, 0.19927731E-06_JPRB, 0.19941890E-06_JPRB, 0.19955918E-06_JPRB, 0.19962745E-06_JPRB, &
  & 0.19973987E-06_JPRB, 0.19983210E-06_JPRB, 0.19985406E-06_JPRB, 0.19984444E-06_JPRB  /)

RGHG2(:, 6,12) = (/ &
  & 0.15085303E-06_JPRB, 0.15072156E-06_JPRB, 0.15059588E-06_JPRB, 0.15054624E-06_JPRB, 0.15055124E-06_JPRB, 0.15063753E-06_JPRB, &
  & 0.15083262E-06_JPRB, 0.15108683E-06_JPRB, 0.15117311E-06_JPRB, 0.15118017E-06_JPRB, 0.15129883E-06_JPRB, 0.15150570E-06_JPRB, &
  & 0.15174802E-06_JPRB, 0.15194910E-06_JPRB, 0.15207950E-06_JPRB, 0.15218423E-06_JPRB, 0.15232300E-06_JPRB, 0.15258967E-06_JPRB, &
  & 0.15306803E-06_JPRB, 0.15387429E-06_JPRB, 0.15502761E-06_JPRB, 0.15645539E-06_JPRB, 0.15804810E-06_JPRB, 0.15977958E-06_JPRB, &
  & 0.16165505E-06_JPRB, 0.16368367E-06_JPRB, 0.16580123E-06_JPRB, 0.16797917E-06_JPRB, 0.17008660E-06_JPRB, 0.17201662E-06_JPRB, &
  & 0.17369737E-06_JPRB, 0.17541470E-06_JPRB, 0.17751728E-06_JPRB, 0.18039455E-06_JPRB, 0.18397564E-06_JPRB, 0.18775494E-06_JPRB, &
  & 0.19097455E-06_JPRB, 0.19330990E-06_JPRB, 0.19519766E-06_JPRB, 0.19688184E-06_JPRB, 0.19832704E-06_JPRB, 0.19935472E-06_JPRB, &
  & 0.19989254E-06_JPRB, 0.20013450E-06_JPRB, 0.20015872E-06_JPRB, 0.20007178E-06_JPRB, 0.19991785E-06_JPRB, 0.19982441E-06_JPRB, &
  & 0.19978534E-06_JPRB, 0.19981610E-06_JPRB, 0.19998825E-06_JPRB, 0.20018196E-06_JPRB, 0.20022725E-06_JPRB, 0.20026398E-06_JPRB, &
  & 0.20026629E-06_JPRB, 0.20026944E-06_JPRB, 0.20029913E-06_JPRB, 0.20028836E-06_JPRB, 0.20031909E-06_JPRB, 0.20032560E-06_JPRB, &
  & 0.20037221E-06_JPRB, 0.20040403E-06_JPRB, 0.20051390E-06_JPRB, 0.20059173E-06_JPRB  /)

RGHG2(:, 7,12) = (/ &
  & 0.15730823E-06_JPRB, 0.15698685E-06_JPRB, 0.15673305E-06_JPRB, 0.15669848E-06_JPRB, 0.15679949E-06_JPRB, 0.15694794E-06_JPRB, &
  & 0.15716091E-06_JPRB, 0.15733367E-06_JPRB, 0.15705204E-06_JPRB, 0.15660272E-06_JPRB, 0.15634774E-06_JPRB, 0.15628606E-06_JPRB, &
  & 0.15632047E-06_JPRB, 0.15629561E-06_JPRB, 0.15616109E-06_JPRB, 0.15595517E-06_JPRB, 0.15584040E-06_JPRB, 0.15607149E-06_JPRB, &
  & 0.15685553E-06_JPRB, 0.15840248E-06_JPRB, 0.16055971E-06_JPRB, 0.16303968E-06_JPRB, 0.16567336E-06_JPRB, 0.16848410E-06_JPRB, &
  & 0.17154288E-06_JPRB, 0.17491317E-06_JPRB, 0.17851174E-06_JPRB, 0.18213830E-06_JPRB, 0.18539175E-06_JPRB, 0.18805060E-06_JPRB, &
  & 0.19014869E-06_JPRB, 0.19207231E-06_JPRB, 0.19421750E-06_JPRB, 0.19663894E-06_JPRB, 0.19912584E-06_JPRB, 0.20134811E-06_JPRB, &
  & 0.20275967E-06_JPRB, 0.20374096E-06_JPRB, 0.20461755E-06_JPRB, 0.20543990E-06_JPRB, 0.20616097E-06_JPRB, 0.20655351E-06_JPRB, &
  & 0.20648038E-06_JPRB, 0.20617142E-06_JPRB, 0.20580111E-06_JPRB, 0.20546637E-06_JPRB, 0.20518253E-06_JPRB, 0.20493913E-06_JPRB, &
  & 0.20455831E-06_JPRB, 0.20427914E-06_JPRB, 0.20406089E-06_JPRB, 0.20387782E-06_JPRB, 0.20355431E-06_JPRB, 0.20320488E-06_JPRB, &
  & 0.20293486E-06_JPRB, 0.20277274E-06_JPRB, 0.20257709E-06_JPRB, 0.20234924E-06_JPRB, 0.20209095E-06_JPRB, 0.20183080E-06_JPRB, &
  & 0.20162251E-06_JPRB, 0.20147788E-06_JPRB, 0.20137525E-06_JPRB, 0.20132898E-06_JPRB  /)

RGHG2(:, 8,12) = (/ &
  & 0.16902054E-06_JPRB, 0.16845243E-06_JPRB, 0.16810314E-06_JPRB, 0.16818464E-06_JPRB, 0.16862004E-06_JPRB, 0.16907674E-06_JPRB, &
  & 0.16944951E-06_JPRB, 0.16944216E-06_JPRB, 0.16850120E-06_JPRB, 0.16731216E-06_JPRB, 0.16652272E-06_JPRB, 0.16608283E-06_JPRB, &
  & 0.16576110E-06_JPRB, 0.16526763E-06_JPRB, 0.16450222E-06_JPRB, 0.16353898E-06_JPRB, 0.16276122E-06_JPRB, 0.16271541E-06_JPRB, &
  & 0.16382892E-06_JPRB, 0.16645733E-06_JPRB, 0.17025836E-06_JPRB, 0.17469823E-06_JPRB, 0.17947363E-06_JPRB, 0.18461939E-06_JPRB, &
  & 0.19040626E-06_JPRB, 0.19724674E-06_JPRB, 0.20503244E-06_JPRB, 0.21298995E-06_JPRB, 0.21994315E-06_JPRB, 0.22524526E-06_JPRB, &
  & 0.22895619E-06_JPRB, 0.23129400E-06_JPRB, 0.23253874E-06_JPRB, 0.23247553E-06_JPRB, 0.23086177E-06_JPRB, 0.22836013E-06_JPRB, &
  & 0.22540721E-06_JPRB, 0.22305498E-06_JPRB, 0.22129468E-06_JPRB, 0.22007464E-06_JPRB, 0.21915869E-06_JPRB, 0.21807938E-06_JPRB, &
  & 0.21661105E-06_JPRB, 0.21512652E-06_JPRB, 0.21399502E-06_JPRB, 0.21332247E-06_JPRB, 0.21294191E-06_JPRB, 0.21248215E-06_JPRB, &
  & 0.21160281E-06_JPRB, 0.21075252E-06_JPRB, 0.21001711E-06_JPRB, 0.20925355E-06_JPRB, 0.20838949E-06_JPRB, 0.20753237E-06_JPRB, &
  & 0.20691826E-06_JPRB, 0.20650361E-06_JPRB, 0.20598395E-06_JPRB, 0.20542531E-06_JPRB, 0.20474914E-06_JPRB, 0.20406291E-06_JPRB, &
  & 0.20335266E-06_JPRB, 0.20272520E-06_JPRB, 0.20216277E-06_JPRB, 0.20183510E-06_JPRB  /)

RGHG2(:, 9,12) = (/ &
  & 0.18903232E-06_JPRB, 0.18823863E-06_JPRB, 0.18795757E-06_JPRB, 0.18843270E-06_JPRB, 0.18954724E-06_JPRB, 0.19062141E-06_JPRB, &
  & 0.19122743E-06_JPRB, 0.19074373E-06_JPRB, 0.18873857E-06_JPRB, 0.18658856E-06_JPRB, 0.18525339E-06_JPRB, 0.18442487E-06_JPRB, &
  & 0.18359238E-06_JPRB, 0.18227082E-06_JPRB, 0.18035223E-06_JPRB, 0.17805451E-06_JPRB, 0.17607743E-06_JPRB, 0.17545429E-06_JPRB, &
  & 0.17689783E-06_JPRB, 0.18081131E-06_JPRB, 0.18667706E-06_JPRB, 0.19393029E-06_JPRB, 0.20207490E-06_JPRB, 0.21112882E-06_JPRB, &
  & 0.22166664E-06_JPRB, 0.23474317E-06_JPRB, 0.25041890E-06_JPRB, 0.26688442E-06_JPRB, 0.28121016E-06_JPRB, 0.29188696E-06_JPRB, &
  & 0.29839041E-06_JPRB, 0.30063250E-06_JPRB, 0.29869523E-06_JPRB, 0.29187277E-06_JPRB, 0.28117367E-06_JPRB, 0.26997649E-06_JPRB, &
  & 0.25967813E-06_JPRB, 0.25137107E-06_JPRB, 0.24491215E-06_JPRB, 0.24024084E-06_JPRB, 0.23682960E-06_JPRB, 0.23349014E-06_JPRB, &
  & 0.22988115E-06_JPRB, 0.22681175E-06_JPRB, 0.22500539E-06_JPRB, 0.22424949E-06_JPRB, 0.22369860E-06_JPRB, 0.22288282E-06_JPRB, &
  & 0.22146661E-06_JPRB, 0.21972964E-06_JPRB, 0.21811047E-06_JPRB, 0.21645417E-06_JPRB, 0.21486340E-06_JPRB, 0.21344772E-06_JPRB, &
  & 0.21236207E-06_JPRB, 0.21147330E-06_JPRB, 0.21047151E-06_JPRB, 0.20946477E-06_JPRB, 0.20834710E-06_JPRB, 0.20709404E-06_JPRB, &
  & 0.20556357E-06_JPRB, 0.20402063E-06_JPRB, 0.20273046E-06_JPRB, 0.20186224E-06_JPRB  /)

RGHG2(:,10,12) = (/ &
  & 0.21942281E-06_JPRB, 0.21854119E-06_JPRB, 0.21873178E-06_JPRB, 0.22014546E-06_JPRB, 0.22212275E-06_JPRB, 0.22372772E-06_JPRB, &
  & 0.22434027E-06_JPRB, 0.22308605E-06_JPRB, 0.21980627E-06_JPRB, 0.21678318E-06_JPRB, 0.21513953E-06_JPRB, 0.21409167E-06_JPRB, &
  & 0.21274064E-06_JPRB, 0.21040631E-06_JPRB, 0.20706994E-06_JPRB, 0.20310658E-06_JPRB, 0.19959889E-06_JPRB, 0.19836136E-06_JPRB, &
  & 0.20026415E-06_JPRB, 0.20535852E-06_JPRB, 0.21306293E-06_JPRB, 0.22330613E-06_JPRB, 0.23541885E-06_JPRB, 0.24944578E-06_JPRB, &
  & 0.26615305E-06_JPRB, 0.28702104E-06_JPRB, 0.31247724E-06_JPRB, 0.33997687E-06_JPRB, 0.36434438E-06_JPRB, 0.38225967E-06_JPRB, &
  & 0.39108618E-06_JPRB, 0.39033612E-06_JPRB, 0.38029382E-06_JPRB, 0.36084112E-06_JPRB, 0.33759924E-06_JPRB, 0.31669941E-06_JPRB, &
  & 0.29887491E-06_JPRB, 0.28412055E-06_JPRB, 0.27298010E-06_JPRB, 0.26450364E-06_JPRB, 0.25789681E-06_JPRB, 0.25202374E-06_JPRB, &
  & 0.24680783E-06_JPRB, 0.24299853E-06_JPRB, 0.24113808E-06_JPRB, 0.24054363E-06_JPRB, 0.23940766E-06_JPRB, 0.23782180E-06_JPRB, &
  & 0.23569429E-06_JPRB, 0.23269585E-06_JPRB, 0.22925240E-06_JPRB, 0.22594012E-06_JPRB, 0.22330767E-06_JPRB, 0.22130448E-06_JPRB, &
  & 0.21954132E-06_JPRB, 0.21789150E-06_JPRB, 0.21628347E-06_JPRB, 0.21481850E-06_JPRB, 0.21329909E-06_JPRB, 0.21137434E-06_JPRB, &
  & 0.20875400E-06_JPRB, 0.20594421E-06_JPRB, 0.20352655E-06_JPRB, 0.20179122E-06_JPRB  /)

RGHG2(:,11,12) = (/ &
  & 0.25687515E-06_JPRB, 0.25636387E-06_JPRB, 0.25757783E-06_JPRB, 0.26029142E-06_JPRB, 0.26283021E-06_JPRB, 0.26428623E-06_JPRB, &
  & 0.26467164E-06_JPRB, 0.26326944E-06_JPRB, 0.25940675E-06_JPRB, 0.25592425E-06_JPRB, 0.25418307E-06_JPRB, 0.25312322E-06_JPRB, &
  & 0.25157498E-06_JPRB, 0.24868399E-06_JPRB, 0.24444730E-06_JPRB, 0.23917916E-06_JPRB, 0.23446988E-06_JPRB, 0.23298594E-06_JPRB, &
  & 0.23545597E-06_JPRB, 0.24146359E-06_JPRB, 0.25060532E-06_JPRB, 0.26318500E-06_JPRB, 0.27846936E-06_JPRB, 0.29697141E-06_JPRB, &
  & 0.31951482E-06_JPRB, 0.34741133E-06_JPRB, 0.38099097E-06_JPRB, 0.41831080E-06_JPRB, 0.45338053E-06_JPRB, 0.47887320E-06_JPRB, &
  & 0.48935289E-06_JPRB, 0.48267337E-06_JPRB, 0.45945414E-06_JPRB, 0.42566502E-06_JPRB, 0.39279811E-06_JPRB, 0.36601469E-06_JPRB, &
  & 0.34457532E-06_JPRB, 0.32567463E-06_JPRB, 0.31041316E-06_JPRB, 0.29795751E-06_JPRB, 0.28698140E-06_JPRB, 0.27852103E-06_JPRB, &
  & 0.27299316E-06_JPRB, 0.26981222E-06_JPRB, 0.26808677E-06_JPRB, 0.26694625E-06_JPRB, 0.26449724E-06_JPRB, 0.26123645E-06_JPRB, &
  & 0.25729038E-06_JPRB, 0.25206669E-06_JPRB, 0.24569668E-06_JPRB, 0.23939235E-06_JPRB, 0.23492568E-06_JPRB, 0.23187174E-06_JPRB, &
  & 0.22923257E-06_JPRB, 0.22670436E-06_JPRB, 0.22455165E-06_JPRB, 0.22253860E-06_JPRB, 0.22057491E-06_JPRB, 0.21777335E-06_JPRB, &
  & 0.21376293E-06_JPRB, 0.20943112E-06_JPRB, 0.20513372E-06_JPRB, 0.20226796E-06_JPRB  /)

RGHG2(:,12,12) = (/ &
  & 0.29617564E-06_JPRB, 0.29677871E-06_JPRB, 0.29935907E-06_JPRB, 0.30302239E-06_JPRB, 0.30578026E-06_JPRB, 0.30692770E-06_JPRB, &
  & 0.30735532E-06_JPRB, 0.30670300E-06_JPRB, 0.30347283E-06_JPRB, 0.30027917E-06_JPRB, 0.29852800E-06_JPRB, 0.29731437E-06_JPRB, &
  & 0.29568044E-06_JPRB, 0.29279425E-06_JPRB, 0.28861309E-06_JPRB, 0.28314019E-06_JPRB, 0.27818789E-06_JPRB, 0.27671893E-06_JPRB, &
  & 0.27956616E-06_JPRB, 0.28651882E-06_JPRB, 0.29707726E-06_JPRB, 0.31080265E-06_JPRB, 0.32722724E-06_JPRB, 0.34826519E-06_JPRB, &
  & 0.37524185E-06_JPRB, 0.40948259E-06_JPRB, 0.45107322E-06_JPRB, 0.49819134E-06_JPRB, 0.54402679E-06_JPRB, 0.57786832E-06_JPRB, &
  & 0.59307838E-06_JPRB, 0.58346112E-06_JPRB, 0.55021257E-06_JPRB, 0.50698650E-06_JPRB, 0.46863012E-06_JPRB, 0.43870060E-06_JPRB, &
  & 0.41419274E-06_JPRB, 0.39098412E-06_JPRB, 0.36884538E-06_JPRB, 0.34900098E-06_JPRB, 0.33278581E-06_JPRB, 0.32109726E-06_JPRB, &
  & 0.31347430E-06_JPRB, 0.30945609E-06_JPRB, 0.30740850E-06_JPRB, 0.30526232E-06_JPRB, 0.30071169E-06_JPRB, 0.29509433E-06_JPRB, &
  & 0.28784086E-06_JPRB, 0.27858101E-06_JPRB, 0.26843499E-06_JPRB, 0.25835046E-06_JPRB, 0.25088475E-06_JPRB, 0.24567078E-06_JPRB, &
  & 0.24176915E-06_JPRB, 0.23851990E-06_JPRB, 0.23584333E-06_JPRB, 0.23272415E-06_JPRB, 0.23003615E-06_JPRB, 0.22622535E-06_JPRB, &
  & 0.22025785E-06_JPRB, 0.21373765E-06_JPRB, 0.20695518E-06_JPRB, 0.20275722E-06_JPRB  /)

RGHG2(:,13,12) = (/ &
  & 0.33975420E-06_JPRB, 0.34180815E-06_JPRB, 0.34537871E-06_JPRB, 0.34905029E-06_JPRB, 0.35241499E-06_JPRB, 0.35433374E-06_JPRB, &
  & 0.35518736E-06_JPRB, 0.35485812E-06_JPRB, 0.35240163E-06_JPRB, 0.35022332E-06_JPRB, 0.34831293E-06_JPRB, 0.34616869E-06_JPRB, &
  & 0.34412418E-06_JPRB, 0.34163221E-06_JPRB, 0.33827483E-06_JPRB, 0.33357873E-06_JPRB, 0.32927825E-06_JPRB, 0.32822014E-06_JPRB, &
  & 0.33175900E-06_JPRB, 0.33973598E-06_JPRB, 0.35102304E-06_JPRB, 0.36483594E-06_JPRB, 0.38120829E-06_JPRB, 0.40378889E-06_JPRB, &
  & 0.43545547E-06_JPRB, 0.47803619E-06_JPRB, 0.53106416E-06_JPRB, 0.59037641E-06_JPRB, 0.64675609E-06_JPRB, 0.68889946E-06_JPRB, &
  & 0.70991273E-06_JPRB, 0.70352813E-06_JPRB, 0.66991999E-06_JPRB, 0.62105570E-06_JPRB, 0.57368120E-06_JPRB, 0.53477788E-06_JPRB, &
  & 0.50361650E-06_JPRB, 0.47677486E-06_JPRB, 0.44979694E-06_JPRB, 0.42286170E-06_JPRB, 0.40054864E-06_JPRB, 0.38348457E-06_JPRB, &
  & 0.37118412E-06_JPRB, 0.36387307E-06_JPRB, 0.35940582E-06_JPRB, 0.35540545E-06_JPRB, 0.34813581E-06_JPRB, 0.33902536E-06_JPRB, &
  & 0.32696517E-06_JPRB, 0.31099224E-06_JPRB, 0.29548513E-06_JPRB, 0.28085610E-06_JPRB, 0.27029598E-06_JPRB, 0.26245469E-06_JPRB, &
  & 0.25694281E-06_JPRB, 0.25293738E-06_JPRB, 0.24969605E-06_JPRB, 0.24565946E-06_JPRB, 0.24154354E-06_JPRB, 0.23647378E-06_JPRB, &
  & 0.22822209E-06_JPRB, 0.21845829E-06_JPRB, 0.20896087E-06_JPRB, 0.20371186E-06_JPRB  /)

RGHG2(:,14,12) = (/ &
  & 0.39137303E-06_JPRB, 0.39412734E-06_JPRB, 0.39686257E-06_JPRB, 0.40007755E-06_JPRB, 0.40459813E-06_JPRB, 0.40832675E-06_JPRB, &
  & 0.41001884E-06_JPRB, 0.40997009E-06_JPRB, 0.40785799E-06_JPRB, 0.40608215E-06_JPRB, 0.40365446E-06_JPRB, 0.40008429E-06_JPRB, &
  & 0.39826175E-06_JPRB, 0.39703750E-06_JPRB, 0.39467060E-06_JPRB, 0.39090847E-06_JPRB, 0.38820351E-06_JPRB, 0.38911910E-06_JPRB, &
  & 0.39449449E-06_JPRB, 0.40313408E-06_JPRB, 0.41393076E-06_JPRB, 0.42750309E-06_JPRB, 0.44475227E-06_JPRB, 0.47081153E-06_JPRB, &
  & 0.50971099E-06_JPRB, 0.56190453E-06_JPRB, 0.62797883E-06_JPRB, 0.69900597E-06_JPRB, 0.76016933E-06_JPRB, 0.80522443E-06_JPRB, &
  & 0.83106300E-06_JPRB, 0.83140213E-06_JPRB, 0.80355815E-06_JPRB, 0.75207960E-06_JPRB, 0.69131923E-06_JPRB, 0.63726954E-06_JPRB, &
  & 0.59591954E-06_JPRB, 0.56632580E-06_JPRB, 0.53677125E-06_JPRB, 0.50627234E-06_JPRB, 0.48001473E-06_JPRB, 0.45759408E-06_JPRB, &
  & 0.44066201E-06_JPRB, 0.42917580E-06_JPRB, 0.42039580E-06_JPRB, 0.41232768E-06_JPRB, 0.40080712E-06_JPRB, 0.38588144E-06_JPRB, &
  & 0.36651028E-06_JPRB, 0.34343285E-06_JPRB, 0.32304203E-06_JPRB, 0.30503670E-06_JPRB, 0.29220110E-06_JPRB, 0.28154450E-06_JPRB, &
  & 0.27439648E-06_JPRB, 0.26953186E-06_JPRB, 0.26551565E-06_JPRB, 0.26111721E-06_JPRB, 0.25575991E-06_JPRB, 0.24909638E-06_JPRB, &
  & 0.23844781E-06_JPRB, 0.22419633E-06_JPRB, 0.21270517E-06_JPRB, 0.20645235E-06_JPRB  /)

RGHG2(:,15,12) = (/ &
  & 0.45019324E-06_JPRB, 0.45161190E-06_JPRB, 0.45335146E-06_JPRB, 0.45753550E-06_JPRB, 0.46261626E-06_JPRB, 0.46726015E-06_JPRB, &
  & 0.47040153E-06_JPRB, 0.47131429E-06_JPRB, 0.46937498E-06_JPRB, 0.46671218E-06_JPRB, 0.46300413E-06_JPRB, 0.45872710E-06_JPRB, &
  & 0.45767837E-06_JPRB, 0.45816628E-06_JPRB, 0.45715815E-06_JPRB, 0.45495082E-06_JPRB, 0.45507779E-06_JPRB, 0.45931813E-06_JPRB, &
  & 0.46661577E-06_JPRB, 0.47433242E-06_JPRB, 0.48430855E-06_JPRB, 0.49971142E-06_JPRB, 0.52169241E-06_JPRB, 0.55683918E-06_JPRB, &
  & 0.60487103E-06_JPRB, 0.66573415E-06_JPRB, 0.74388745E-06_JPRB, 0.81906583E-06_JPRB, 0.87098902E-06_JPRB, 0.90844369E-06_JPRB, &
  & 0.93348654E-06_JPRB, 0.93678893E-06_JPRB, 0.91779977E-06_JPRB, 0.87380702E-06_JPRB, 0.80425989E-06_JPRB, 0.73475918E-06_JPRB, &
  & 0.67884638E-06_JPRB, 0.64048324E-06_JPRB, 0.61039437E-06_JPRB, 0.58098828E-06_JPRB, 0.55215895E-06_JPRB, 0.52643012E-06_JPRB, &
  & 0.50552854E-06_JPRB, 0.48968407E-06_JPRB, 0.47666011E-06_JPRB, 0.46377429E-06_JPRB, 0.44673676E-06_JPRB, 0.42511067E-06_JPRB, &
  & 0.39912696E-06_JPRB, 0.37341347E-06_JPRB, 0.35267714E-06_JPRB, 0.33431398E-06_JPRB, 0.31937730E-06_JPRB, 0.30628059E-06_JPRB, &
  & 0.29663394E-06_JPRB, 0.29003015E-06_JPRB, 0.28520227E-06_JPRB, 0.28058770E-06_JPRB, 0.27368888E-06_JPRB, 0.26455283E-06_JPRB, &
  & 0.25131655E-06_JPRB, 0.23346423E-06_JPRB, 0.22076629E-06_JPRB, 0.21346181E-06_JPRB  /)

RGHG2(:,16,12) = (/ &
  & 0.51006187E-06_JPRB, 0.51061115E-06_JPRB, 0.51300639E-06_JPRB, 0.51877577E-06_JPRB, 0.52371748E-06_JPRB, 0.52863754E-06_JPRB, &
  & 0.53318748E-06_JPRB, 0.53496376E-06_JPRB, 0.53350011E-06_JPRB, 0.52991189E-06_JPRB, 0.52459136E-06_JPRB, 0.51987199E-06_JPRB, &
  & 0.51930931E-06_JPRB, 0.52161196E-06_JPRB, 0.52324475E-06_JPRB, 0.52438202E-06_JPRB, 0.52841801E-06_JPRB, 0.53543156E-06_JPRB, &
  & 0.54235716E-06_JPRB, 0.54695864E-06_JPRB, 0.55727177E-06_JPRB, 0.57915121E-06_JPRB, 0.61214901E-06_JPRB, 0.66031376E-06_JPRB, &
  & 0.71651911E-06_JPRB, 0.78370752E-06_JPRB, 0.86714158E-06_JPRB, 0.93401163E-06_JPRB, 0.96826895E-06_JPRB, 0.99463396E-06_JPRB, &
  & 0.10135264E-05_JPRB, 0.10166319E-05_JPRB, 0.10082944E-05_JPRB, 0.97288439E-06_JPRB, 0.89629893E-06_JPRB, 0.81630376E-06_JPRB, &
  & 0.74616630E-06_JPRB, 0.69575472E-06_JPRB, 0.66358334E-06_JPRB, 0.63819229E-06_JPRB, 0.61050236E-06_JPRB, 0.58243659E-06_JPRB, &
  & 0.55697231E-06_JPRB, 0.53680239E-06_JPRB, 0.51894548E-06_JPRB, 0.50192765E-06_JPRB, 0.48159952E-06_JPRB, 0.45637658E-06_JPRB, &
  & 0.42856281E-06_JPRB, 0.40617526E-06_JPRB, 0.38980021E-06_JPRB, 0.37167259E-06_JPRB, 0.35419485E-06_JPRB, 0.33915066E-06_JPRB, &
  & 0.32731199E-06_JPRB, 0.31844950E-06_JPRB, 0.31135052E-06_JPRB, 0.30530131E-06_JPRB, 0.29682784E-06_JPRB, 0.28383551E-06_JPRB, &
  & 0.26730323E-06_JPRB, 0.24866807E-06_JPRB, 0.23456144E-06_JPRB, 0.22671208E-06_JPRB  /)

RGHG2(:,17,12) = (/ &
  & 0.57264059E-06_JPRB, 0.57346375E-06_JPRB, 0.57603068E-06_JPRB, 0.58201169E-06_JPRB, 0.58656644E-06_JPRB, 0.59210728E-06_JPRB, &
  & 0.59734839E-06_JPRB, 0.59930794E-06_JPRB, 0.59830260E-06_JPRB, 0.59468782E-06_JPRB, 0.58883027E-06_JPRB, 0.58418033E-06_JPRB, &
  & 0.58407051E-06_JPRB, 0.58825739E-06_JPRB, 0.59328786E-06_JPRB, 0.59868292E-06_JPRB, 0.60672522E-06_JPRB, 0.61509033E-06_JPRB, &
  & 0.61881440E-06_JPRB, 0.61902383E-06_JPRB, 0.63110082E-06_JPRB, 0.66262220E-06_JPRB, 0.71132749E-06_JPRB, 0.77337829E-06_JPRB, &
  & 0.83554726E-06_JPRB, 0.90558804E-06_JPRB, 0.98366376E-06_JPRB, 0.10364532E-05_JPRB, 0.10578582E-05_JPRB, 0.10759253E-05_JPRB, &
  & 0.10870677E-05_JPRB, 0.10897076E-05_JPRB, 0.10827733E-05_JPRB, 0.10434472E-05_JPRB, 0.96191064E-06_JPRB, 0.87710836E-06_JPRB, &
  & 0.80459581E-06_JPRB, 0.74977852E-06_JPRB, 0.71701571E-06_JPRB, 0.69600961E-06_JPRB, 0.67263870E-06_JPRB, 0.63914334E-06_JPRB, &
  & 0.60555621E-06_JPRB, 0.57988399E-06_JPRB, 0.55770467E-06_JPRB, 0.53696682E-06_JPRB, 0.51546950E-06_JPRB, 0.49036877E-06_JPRB, &
  & 0.46564620E-06_JPRB, 0.44775538E-06_JPRB, 0.43442000E-06_JPRB, 0.41594132E-06_JPRB, 0.39582241E-06_JPRB, 0.37876006E-06_JPRB, &
  & 0.36444460E-06_JPRB, 0.35342816E-06_JPRB, 0.34366522E-06_JPRB, 0.33437307E-06_JPRB, 0.32382756E-06_JPRB, 0.30834731E-06_JPRB, &
  & 0.28887910E-06_JPRB, 0.26932452E-06_JPRB, 0.25420963E-06_JPRB, 0.24531345E-06_JPRB  /)

RGHG2(:,18,12) = (/ &
  & 0.63997523E-06_JPRB, 0.64029051E-06_JPRB, 0.64164083E-06_JPRB, 0.64553017E-06_JPRB, 0.64980847E-06_JPRB, 0.65609857E-06_JPRB, &
  & 0.66152162E-06_JPRB, 0.66384580E-06_JPRB, 0.66304120E-06_JPRB, 0.65957636E-06_JPRB, 0.65455566E-06_JPRB, 0.65262797E-06_JPRB, &
  & 0.65485245E-06_JPRB, 0.66038520E-06_JPRB, 0.66754302E-06_JPRB, 0.67642634E-06_JPRB, 0.68738384E-06_JPRB, 0.69599681E-06_JPRB, &
  & 0.69615040E-06_JPRB, 0.69248167E-06_JPRB, 0.70644658E-06_JPRB, 0.74661814E-06_JPRB, 0.81053807E-06_JPRB, 0.88791482E-06_JPRB, &
  & 0.95641284E-06_JPRB, 0.10215974E-05_JPRB, 0.10860160E-05_JPRB, 0.11262731E-05_JPRB, 0.11426832E-05_JPRB, 0.11551937E-05_JPRB, &
  & 0.11627522E-05_JPRB, 0.11638564E-05_JPRB, 0.11484711E-05_JPRB, 0.10975189E-05_JPRB, 0.10095854E-05_JPRB, 0.92824464E-06_JPRB, &
  & 0.86544019E-06_JPRB, 0.81805294E-06_JPRB, 0.79151215E-06_JPRB, 0.77564502E-06_JPRB, 0.75314611E-06_JPRB, 0.71322865E-06_JPRB, &
  & 0.66898903E-06_JPRB, 0.63349168E-06_JPRB, 0.60547122E-06_JPRB, 0.58035000E-06_JPRB, 0.55648959E-06_JPRB, 0.53172844E-06_JPRB, &
  & 0.50978261E-06_JPRB, 0.49454700E-06_JPRB, 0.48109296E-06_JPRB, 0.46298406E-06_JPRB, 0.44079834E-06_JPRB, 0.42096740E-06_JPRB, &
  & 0.40462311E-06_JPRB, 0.39162386E-06_JPRB, 0.37964576E-06_JPRB, 0.36736232E-06_JPRB, 0.35518593E-06_JPRB, 0.33750100E-06_JPRB, &
  & 0.31553421E-06_JPRB, 0.29540768E-06_JPRB, 0.27929870E-06_JPRB, 0.26850015E-06_JPRB  /)

RGHG2(:,19,12) = (/ &
  & 0.71184371E-06_JPRB, 0.71012670E-06_JPRB, 0.70946635E-06_JPRB, 0.71014352E-06_JPRB, 0.71363405E-06_JPRB, 0.72004764E-06_JPRB, &
  & 0.72558205E-06_JPRB, 0.72841643E-06_JPRB, 0.72801445E-06_JPRB, 0.72533054E-06_JPRB, 0.72289877E-06_JPRB, 0.72522679E-06_JPRB, &
  & 0.73066360E-06_JPRB, 0.73736614E-06_JPRB, 0.74520181E-06_JPRB, 0.75577617E-06_JPRB, 0.76789498E-06_JPRB, 0.77640258E-06_JPRB, &
  & 0.77556640E-06_JPRB, 0.77003601E-06_JPRB, 0.78483161E-06_JPRB, 0.83106957E-06_JPRB, 0.90491875E-06_JPRB, 0.99537535E-06_JPRB, &
  & 0.10718780E-05_JPRB, 0.11295556E-05_JPRB, 0.11780989E-05_JPRB, 0.12076018E-05_JPRB, 0.12215561E-05_JPRB, 0.12304574E-05_JPRB, &
  & 0.12362430E-05_JPRB, 0.12335889E-05_JPRB, 0.12054216E-05_JPRB, 0.11394066E-05_JPRB, 0.10492192E-05_JPRB, 0.97990551E-06_JPRB, &
  & 0.93377085E-06_JPRB, 0.90002420E-06_JPRB, 0.88164732E-06_JPRB, 0.86782203E-06_JPRB, 0.84063770E-06_JPRB, 0.79411747E-06_JPRB, &
  & 0.74082268E-06_JPRB, 0.69378893E-06_JPRB, 0.65814436E-06_JPRB, 0.62811131E-06_JPRB, 0.60118180E-06_JPRB, 0.57595941E-06_JPRB, &
  & 0.55515451E-06_JPRB, 0.54121730E-06_JPRB, 0.52729744E-06_JPRB, 0.50940661E-06_JPRB, 0.48620243E-06_JPRB, 0.46424353E-06_JPRB, &
  & 0.44659054E-06_JPRB, 0.43211812E-06_JPRB, 0.41889985E-06_JPRB, 0.40445744E-06_JPRB, 0.39079175E-06_JPRB, 0.37128226E-06_JPRB, &
  & 0.34688406E-06_JPRB, 0.32666229E-06_JPRB, 0.30958209E-06_JPRB, 0.29645697E-06_JPRB  /)

RGHG2(:,20,12) = (/ &
  & 0.78249617E-06_JPRB, 0.77839544E-06_JPRB, 0.77625383E-06_JPRB, 0.77530223E-06_JPRB, 0.77802109E-06_JPRB, 0.78393529E-06_JPRB, &
  & 0.78912661E-06_JPRB, 0.79239893E-06_JPRB, 0.79336974E-06_JPRB, 0.79329548E-06_JPRB, 0.79447768E-06_JPRB, 0.79966527E-06_JPRB, &
  & 0.80667874E-06_JPRB, 0.81397412E-06_JPRB, 0.82233224E-06_JPRB, 0.83434060E-06_JPRB, 0.84726216E-06_JPRB, 0.85557848E-06_JPRB, &
  & 0.85574841E-06_JPRB, 0.85163800E-06_JPRB, 0.86650541E-06_JPRB, 0.91520565E-06_JPRB, 0.99225800E-06_JPRB, 0.10899683E-05_JPRB, &
  & 0.11729753E-05_JPRB, 0.12260134E-05_JPRB, 0.12625532E-05_JPRB, 0.12839965E-05_JPRB, 0.12949858E-05_JPRB, 0.13004849E-05_JPRB, &
  & 0.13036734E-05_JPRB, 0.12962413E-05_JPRB, 0.12569415E-05_JPRB, 0.11807174E-05_JPRB, 0.10960184E-05_JPRB, 0.10409800E-05_JPRB, &
  & 0.10089707E-05_JPRB, 0.98600394E-06_JPRB, 0.97097136E-06_JPRB, 0.95475369E-06_JPRB, 0.92232328E-06_JPRB, 0.87120224E-06_JPRB, &
  & 0.80968053E-06_JPRB, 0.75141159E-06_JPRB, 0.70800514E-06_JPRB, 0.67439747E-06_JPRB, 0.64552180E-06_JPRB, 0.61955804E-06_JPRB, &
  & 0.59973534E-06_JPRB, 0.58677300E-06_JPRB, 0.57252073E-06_JPRB, 0.55468925E-06_JPRB, 0.53174053E-06_JPRB, 0.50869547E-06_JPRB, &
  & 0.49017781E-06_JPRB, 0.47534745E-06_JPRB, 0.46153563E-06_JPRB, 0.44497658E-06_JPRB, 0.42966123E-06_JPRB, 0.40844936E-06_JPRB, &
  & 0.38213452E-06_JPRB, 0.36215684E-06_JPRB, 0.34496667E-06_JPRB, 0.32996977E-06_JPRB  /)

RGHG2(:,21,12) = (/ &
  & 0.84745791E-06_JPRB, 0.84231760E-06_JPRB, 0.84047409E-06_JPRB, 0.84037501E-06_JPRB, 0.84294447E-06_JPRB, 0.84811180E-06_JPRB, &
  & 0.85258107E-06_JPRB, 0.85625250E-06_JPRB, 0.85944545E-06_JPRB, 0.86362394E-06_JPRB, 0.86851583E-06_JPRB, 0.87429058E-06_JPRB, &
  & 0.88039086E-06_JPRB, 0.88738129E-06_JPRB, 0.89643601E-06_JPRB, 0.91006997E-06_JPRB, 0.92441755E-06_JPRB, 0.93327239E-06_JPRB, &
  & 0.93569563E-06_JPRB, 0.93567723E-06_JPRB, 0.95019588E-06_JPRB, 0.99760724E-06_JPRB, 0.10721431E-05_JPRB, 0.11703973E-05_JPRB, &
  & 0.12561570E-05_JPRB, 0.13081282E-05_JPRB, 0.13387873E-05_JPRB, 0.13563583E-05_JPRB, 0.13645193E-05_JPRB, 0.13661955E-05_JPRB, &
  & 0.13649370E-05_JPRB, 0.13522224E-05_JPRB, 0.13067751E-05_JPRB, 0.12297592E-05_JPRB, 0.11572860E-05_JPRB, 0.11143364E-05_JPRB, &
  & 0.10896846E-05_JPRB, 0.10710577E-05_JPRB, 0.10534019E-05_JPRB, 0.10310098E-05_JPRB, 0.99427255E-06_JPRB, 0.93940643E-06_JPRB, &
  & 0.86953212E-06_JPRB, 0.80158337E-06_JPRB, 0.75229659E-06_JPRB, 0.71729458E-06_JPRB, 0.68811348E-06_JPRB, 0.66155464E-06_JPRB, &
  & 0.64303985E-06_JPRB, 0.63099101E-06_JPRB, 0.61650146E-06_JPRB, 0.59857869E-06_JPRB, 0.57675631E-06_JPRB, 0.55375881E-06_JPRB, &
  & 0.53494495E-06_JPRB, 0.52067563E-06_JPRB, 0.50665724E-06_JPRB, 0.48803410E-06_JPRB, 0.47069304E-06_JPRB, 0.44779480E-06_JPRB, &
  & 0.42070053E-06_JPRB, 0.40116733E-06_JPRB, 0.38489757E-06_JPRB, 0.36919695E-06_JPRB  /)

RGHG2(:,22,12) = (/ &
  & 0.90130841E-06_JPRB, 0.89863381E-06_JPRB, 0.90036465E-06_JPRB, 0.90376345E-06_JPRB, 0.90747975E-06_JPRB, 0.91216924E-06_JPRB, &
  & 0.91591217E-06_JPRB, 0.92011879E-06_JPRB, 0.92581569E-06_JPRB, 0.93502119E-06_JPRB, 0.94266551E-06_JPRB, 0.94677734E-06_JPRB, &
  & 0.94926504E-06_JPRB, 0.95470724E-06_JPRB, 0.96433538E-06_JPRB, 0.97942201E-06_JPRB, 0.99652203E-06_JPRB, 0.10079764E-05_JPRB, &
  & 0.10134770E-05_JPRB, 0.10188488E-05_JPRB, 0.10327940E-05_JPRB, 0.10749490E-05_JPRB, 0.11426229E-05_JPRB, 0.12342636E-05_JPRB, &
  & 0.13169459E-05_JPRB, 0.13700257E-05_JPRB, 0.14021757E-05_JPRB, 0.14225374E-05_JPRB, 0.14305837E-05_JPRB, 0.14280548E-05_JPRB, &
  & 0.14200681E-05_JPRB, 0.14015237E-05_JPRB, 0.13578158E-05_JPRB, 0.12932049E-05_JPRB, 0.12370553E-05_JPRB, 0.12003942E-05_JPRB, &
  & 0.11740603E-05_JPRB, 0.11518400E-05_JPRB, 0.11268062E-05_JPRB, 0.10955642E-05_JPRB, 0.10546792E-05_JPRB, 0.99384946E-06_JPRB, &
  & 0.91495329E-06_JPRB, 0.84027637E-06_JPRB, 0.78957516E-06_JPRB, 0.75587291E-06_JPRB, 0.72799157E-06_JPRB, 0.70129893E-06_JPRB, &
  & 0.68417946E-06_JPRB, 0.67278050E-06_JPRB, 0.65808070E-06_JPRB, 0.63981388E-06_JPRB, 0.61932948E-06_JPRB, 0.59770820E-06_JPRB, &
  & 0.57965890E-06_JPRB, 0.56630706E-06_JPRB, 0.55236513E-06_JPRB, 0.53234666E-06_JPRB, 0.51238696E-06_JPRB, 0.48786402E-06_JPRB, &
  & 0.46199306E-06_JPRB, 0.44299506E-06_JPRB, 0.42854113E-06_JPRB, 0.41412116E-06_JPRB  /)

RGHG2(:,23,12) = (/ &
  & 0.94701444E-06_JPRB, 0.94761295E-06_JPRB, 0.95444472E-06_JPRB, 0.96095920E-06_JPRB, 0.96612752E-06_JPRB, 0.97169067E-06_JPRB, &
  & 0.97621847E-06_JPRB, 0.98206669E-06_JPRB, 0.98939887E-06_JPRB, 0.99901858E-06_JPRB, 0.10073379E-05_JPRB, 0.10114600E-05_JPRB, &
  & 0.10134040E-05_JPRB, 0.10185349E-05_JPRB, 0.10280908E-05_JPRB, 0.10419574E-05_JPRB, 0.10589874E-05_JPRB, 0.10734562E-05_JPRB, &
  & 0.10829070E-05_JPRB, 0.10921398E-05_JPRB, 0.11045152E-05_JPRB, 0.11396008E-05_JPRB, 0.11998420E-05_JPRB, 0.12803376E-05_JPRB, &
  & 0.13558158E-05_JPRB, 0.14102826E-05_JPRB, 0.14478614E-05_JPRB, 0.14740112E-05_JPRB, 0.14853593E-05_JPRB, 0.14821894E-05_JPRB, &
  & 0.14706775E-05_JPRB, 0.14500624E-05_JPRB, 0.14135446E-05_JPRB, 0.13654448E-05_JPRB, 0.13238451E-05_JPRB, 0.12891696E-05_JPRB, &
  & 0.12571573E-05_JPRB, 0.12272338E-05_JPRB, 0.11946180E-05_JPRB, 0.11540468E-05_JPRB, 0.11050618E-05_JPRB, 0.10332058E-05_JPRB, &
  & 0.94328854E-06_JPRB, 0.86639407E-06_JPRB, 0.81855930E-06_JPRB, 0.78784677E-06_JPRB, 0.75999020E-06_JPRB, 0.73311524E-06_JPRB, &
  & 0.71685237E-06_JPRB, 0.70589153E-06_JPRB, 0.69212596E-06_JPRB, 0.67503677E-06_JPRB, 0.65573702E-06_JPRB, 0.63592809E-06_JPRB, &
  & 0.61875557E-06_JPRB, 0.60530941E-06_JPRB, 0.59256208E-06_JPRB, 0.57474319E-06_JPRB, 0.55327213E-06_JPRB, 0.52833811E-06_JPRB, &
  & 0.50484006E-06_JPRB, 0.48631287E-06_JPRB, 0.47378164E-06_JPRB, 0.46338317E-06_JPRB  /)

RGHG2(:,24,12) = (/ &
  & 0.98998464E-06_JPRB, 0.99361287E-06_JPRB, 0.10057356E-05_JPRB, 0.10152810E-05_JPRB, 0.10219222E-05_JPRB, 0.10286805E-05_JPRB, &
  & 0.10347504E-05_JPRB, 0.10419405E-05_JPRB, 0.10495340E-05_JPRB, 0.10582891E-05_JPRB, 0.10673739E-05_JPRB, 0.10729931E-05_JPRB, &
  & 0.10766755E-05_JPRB, 0.10829992E-05_JPRB, 0.10927277E-05_JPRB, 0.11053143E-05_JPRB, 0.11209982E-05_JPRB, 0.11364577E-05_JPRB, &
  & 0.11486125E-05_JPRB, 0.11604000E-05_JPRB, 0.11717028E-05_JPRB, 0.12000405E-05_JPRB, 0.12521725E-05_JPRB, 0.13210904E-05_JPRB, &
  & 0.13884511E-05_JPRB, 0.14435394E-05_JPRB, 0.14869931E-05_JPRB, 0.15193636E-05_JPRB, 0.15348411E-05_JPRB, 0.15334823E-05_JPRB, &
  & 0.15215396E-05_JPRB, 0.15017276E-05_JPRB, 0.14735285E-05_JPRB, 0.14406477E-05_JPRB, 0.14108235E-05_JPRB, 0.13773502E-05_JPRB, &
  & 0.13390824E-05_JPRB, 0.13007719E-05_JPRB, 0.12603952E-05_JPRB, 0.12088530E-05_JPRB, 0.11489703E-05_JPRB, 0.10653149E-05_JPRB, &
  & 0.96679623E-06_JPRB, 0.89104522E-06_JPRB, 0.84716990E-06_JPRB, 0.81902581E-06_JPRB, 0.79038621E-06_JPRB, 0.76302104E-06_JPRB, &
  & 0.74726441E-06_JPRB, 0.73642844E-06_JPRB, 0.72424213E-06_JPRB, 0.70874948E-06_JPRB, 0.69106093E-06_JPRB, 0.67323668E-06_JPRB, &
  & 0.65693376E-06_JPRB, 0.64321237E-06_JPRB, 0.63211048E-06_JPRB, 0.61755355E-06_JPRB, 0.59560695E-06_JPRB, 0.57133628E-06_JPRB, &
  & 0.55029937E-06_JPRB, 0.53253544E-06_JPRB, 0.52179024E-06_JPRB, 0.51557734E-06_JPRB  /)

RGHG2(:,25,12) = (/ &
  & 0.10280051E-05_JPRB, 0.10339138E-05_JPRB, 0.10510827E-05_JPRB, 0.10634585E-05_JPRB, 0.10714744E-05_JPRB, 0.10796398E-05_JPRB, &
  & 0.10881843E-05_JPRB, 0.10958757E-05_JPRB, 0.11014799E-05_JPRB, 0.11081810E-05_JPRB, 0.11186243E-05_JPRB, 0.11279311E-05_JPRB, &
  & 0.11366273E-05_JPRB, 0.11464768E-05_JPRB, 0.11569494E-05_JPRB, 0.11688081E-05_JPRB, 0.11815808E-05_JPRB, 0.11943069E-05_JPRB, &
  & 0.12066397E-05_JPRB, 0.12188962E-05_JPRB, 0.12302798E-05_JPRB, 0.12531509E-05_JPRB, 0.12964683E-05_JPRB, 0.13545823E-05_JPRB, &
  & 0.14135003E-05_JPRB, 0.14677638E-05_JPRB, 0.15167327E-05_JPRB, 0.15551359E-05_JPRB, 0.15752553E-05_JPRB, 0.15791690E-05_JPRB, &
  & 0.15715770E-05_JPRB, 0.15567788E-05_JPRB, 0.15372972E-05_JPRB, 0.15157379E-05_JPRB, 0.14926419E-05_JPRB, 0.14598964E-05_JPRB, &
  & 0.14155313E-05_JPRB, 0.13689236E-05_JPRB, 0.13208645E-05_JPRB, 0.12560439E-05_JPRB, 0.11816858E-05_JPRB, 0.10865310E-05_JPRB, &
  & 0.98453507E-06_JPRB, 0.91481680E-06_JPRB, 0.87569650E-06_JPRB, 0.84887863E-06_JPRB, 0.81834673E-06_JPRB, 0.78997880E-06_JPRB, &
  & 0.77420599E-06_JPRB, 0.76298186E-06_JPRB, 0.75318923E-06_JPRB, 0.73962123E-06_JPRB, 0.72426168E-06_JPRB, 0.70853999E-06_JPRB, &
  & 0.69302957E-06_JPRB, 0.67895236E-06_JPRB, 0.66996921E-06_JPRB, 0.65960123E-06_JPRB, 0.63878677E-06_JPRB, 0.61678040E-06_JPRB, &
  & 0.59799162E-06_JPRB, 0.58148922E-06_JPRB, 0.57218347E-06_JPRB, 0.56964196E-06_JPRB  /)

RGHG2(:,26,12) = (/ &
  & 0.10521691E-05_JPRB, 0.10633204E-05_JPRB, 0.10847192E-05_JPRB, 0.10995408E-05_JPRB, 0.11101435E-05_JPRB, 0.11196043E-05_JPRB, &
  & 0.11289670E-05_JPRB, 0.11347227E-05_JPRB, 0.11391774E-05_JPRB, 0.11477381E-05_JPRB, 0.11619573E-05_JPRB, 0.11756924E-05_JPRB, &
  & 0.11889190E-05_JPRB, 0.12018866E-05_JPRB, 0.12136407E-05_JPRB, 0.12252982E-05_JPRB, 0.12355507E-05_JPRB, 0.12446311E-05_JPRB, &
  & 0.12547090E-05_JPRB, 0.12659695E-05_JPRB, 0.12783226E-05_JPRB, 0.12985585E-05_JPRB, 0.13333244E-05_JPRB, 0.13819399E-05_JPRB, &
  & 0.14343431E-05_JPRB, 0.14863875E-05_JPRB, 0.15370454E-05_JPRB, 0.15790097E-05_JPRB, 0.16035301E-05_JPRB, 0.16136723E-05_JPRB, &
  & 0.16128131E-05_JPRB, 0.16048894E-05_JPRB, 0.15925701E-05_JPRB, 0.15767237E-05_JPRB, 0.15548777E-05_JPRB, 0.15215663E-05_JPRB, &
  & 0.14758711E-05_JPRB, 0.14227974E-05_JPRB, 0.13634253E-05_JPRB, 0.12867642E-05_JPRB, 0.12039070E-05_JPRB, 0.11043352E-05_JPRB, &
  & 0.10092816E-05_JPRB, 0.94716272E-06_JPRB, 0.91083225E-06_JPRB, 0.88290186E-06_JPRB, 0.85137378E-06_JPRB, 0.82281791E-06_JPRB, &
  & 0.80578358E-06_JPRB, 0.79353084E-06_JPRB, 0.78419440E-06_JPRB, 0.77276049E-06_JPRB, 0.75971546E-06_JPRB, 0.74551382E-06_JPRB, &
  & 0.73048791E-06_JPRB, 0.71772400E-06_JPRB, 0.71021186E-06_JPRB, 0.70328463E-06_JPRB, 0.68408780E-06_JPRB, 0.66570023E-06_JPRB, &
  & 0.64878925E-06_JPRB, 0.63343756E-06_JPRB, 0.62561677E-06_JPRB, 0.62667886E-06_JPRB  /)

RGHG2(:,27,12) = (/ &
  & 0.10722953E-05_JPRB, 0.10900262E-05_JPRB, 0.11155447E-05_JPRB, 0.11327808E-05_JPRB, 0.11465375E-05_JPRB, 0.11573112E-05_JPRB, &
  & 0.11669154E-05_JPRB, 0.11697434E-05_JPRB, 0.11733078E-05_JPRB, 0.11852639E-05_JPRB, 0.12043273E-05_JPRB, 0.12229668E-05_JPRB, &
  & 0.12407509E-05_JPRB, 0.12568271E-05_JPRB, 0.12701205E-05_JPRB, 0.12817629E-05_JPRB, 0.12895254E-05_JPRB, 0.12944559E-05_JPRB, &
  & 0.13012741E-05_JPRB, 0.13109502E-05_JPRB, 0.13246463E-05_JPRB, 0.13431769E-05_JPRB, 0.13690997E-05_JPRB, 0.14082684E-05_JPRB, &
  & 0.14545749E-05_JPRB, 0.15037823E-05_JPRB, 0.15547872E-05_JPRB, 0.15995585E-05_JPRB, 0.16285910E-05_JPRB, 0.16455994E-05_JPRB, &
  & 0.16526629E-05_JPRB, 0.16526166E-05_JPRB, 0.16472088E-05_JPRB, 0.16352559E-05_JPRB, 0.16126855E-05_JPRB, 0.15783026E-05_JPRB, &
  & 0.15329848E-05_JPRB, 0.14738295E-05_JPRB, 0.14012831E-05_JPRB, 0.13127758E-05_JPRB, 0.12232484E-05_JPRB, 0.11216847E-05_JPRB, &
  & 0.10377529E-05_JPRB, 0.98416036E-06_JPRB, 0.95001806E-06_JPRB, 0.92002023E-06_JPRB, 0.88778288E-06_JPRB, 0.85933265E-06_JPRB, &
  & 0.84051761E-06_JPRB, 0.82695198E-06_JPRB, 0.81737409E-06_JPRB, 0.80824905E-06_JPRB, 0.79761855E-06_JPRB, 0.78479017E-06_JPRB, &
  & 0.77015662E-06_JPRB, 0.75938469E-06_JPRB, 0.75317035E-06_JPRB, 0.74956309E-06_JPRB, 0.73223751E-06_JPRB, 0.71813572E-06_JPRB, &
  & 0.70305072E-06_JPRB, 0.68886102E-06_JPRB, 0.68260967E-06_JPRB, 0.68741427E-06_JPRB  /)

RGHG2(:,28,12) = (/ &
  & 0.10849585E-05_JPRB, 0.11079430E-05_JPRB, 0.11342620E-05_JPRB, 0.11526196E-05_JPRB, 0.11686910E-05_JPRB, 0.11815444E-05_JPRB, &
  & 0.11905698E-05_JPRB, 0.11953858E-05_JPRB, 0.12016068E-05_JPRB, 0.12176524E-05_JPRB, 0.12393223E-05_JPRB, 0.12606710E-05_JPRB, &
  & 0.12807874E-05_JPRB, 0.12978121E-05_JPRB, 0.13106903E-05_JPRB, 0.13210051E-05_JPRB, 0.13287949E-05_JPRB, 0.13349143E-05_JPRB, &
  & 0.13422554E-05_JPRB, 0.13520694E-05_JPRB, 0.13654803E-05_JPRB, 0.13821663E-05_JPRB, 0.14035100E-05_JPRB, 0.14355972E-05_JPRB, &
  & 0.14757050E-05_JPRB, 0.15207322E-05_JPRB, 0.15678449E-05_JPRB, 0.16102102E-05_JPRB, 0.16399334E-05_JPRB, 0.16601036E-05_JPRB, &
  & 0.16719728E-05_JPRB, 0.16767305E-05_JPRB, 0.16746490E-05_JPRB, 0.16637755E-05_JPRB, 0.16412518E-05_JPRB, 0.16077532E-05_JPRB, &
  & 0.15639775E-05_JPRB, 0.15048710E-05_JPRB, 0.14274377E-05_JPRB, 0.13388152E-05_JPRB, 0.12531318E-05_JPRB, 0.11643091E-05_JPRB, &
  & 0.10940972E-05_JPRB, 0.10429179E-05_JPRB, 0.10058696E-05_JPRB, 0.97194721E-06_JPRB, 0.93871802E-06_JPRB, 0.91012171E-06_JPRB, &
  & 0.89000982E-06_JPRB, 0.87515320E-06_JPRB, 0.86393836E-06_JPRB, 0.85415296E-06_JPRB, 0.84411813E-06_JPRB, 0.83173181E-06_JPRB, &
  & 0.81775215E-06_JPRB, 0.80907408E-06_JPRB, 0.80408754E-06_JPRB, 0.80014759E-06_JPRB, 0.78466074E-06_JPRB, 0.77328128E-06_JPRB, &
  & 0.76052148E-06_JPRB, 0.74890627E-06_JPRB, 0.74475720E-06_JPRB, 0.75207500E-06_JPRB  /)

RGHG2(:,29,12) = (/ &
  & 0.10980526E-05_JPRB, 0.11265464E-05_JPRB, 0.11535695E-05_JPRB, 0.11730594E-05_JPRB, 0.11915471E-05_JPRB, 0.12066373E-05_JPRB, &
  & 0.12150137E-05_JPRB, 0.12221495E-05_JPRB, 0.12313391E-05_JPRB, 0.12517479E-05_JPRB, 0.12760827E-05_JPRB, 0.13002067E-05_JPRB, &
  & 0.13226980E-05_JPRB, 0.13406340E-05_JPRB, 0.13529875E-05_JPRB, 0.13618387E-05_JPRB, 0.13697666E-05_JPRB, 0.13773772E-05_JPRB, &
  & 0.13854363E-05_JPRB, 0.13954713E-05_JPRB, 0.14085094E-05_JPRB, 0.14232346E-05_JPRB, 0.14399114E-05_JPRB, 0.14645977E-05_JPRB, &
  & 0.14981331E-05_JPRB, 0.15386728E-05_JPRB, 0.15814775E-05_JPRB, 0.16210675E-05_JPRB, 0.16513568E-05_JPRB, 0.16747165E-05_JPRB, &
  & 0.16915427E-05_JPRB, 0.17012573E-05_JPRB, 0.17025449E-05_JPRB, 0.16926932E-05_JPRB, 0.16702523E-05_JPRB, 0.16377754E-05_JPRB, &
  & 0.15956843E-05_JPRB, 0.15368954E-05_JPRB, 0.14546431E-05_JPRB, 0.13664073E-05_JPRB, 0.12852528E-05_JPRB, 0.12105691E-05_JPRB, &
  & 0.11550071E-05_JPRB, 0.11061199E-05_JPRB, 0.10657716E-05_JPRB, 0.10276102E-05_JPRB, 0.99331784E-06_JPRB, 0.96455584E-06_JPRB, &
  & 0.94309080E-06_JPRB, 0.92686723E-06_JPRB, 0.91385740E-06_JPRB, 0.90324354E-06_JPRB, 0.89376101E-06_JPRB, 0.88180274E-06_JPRB, &
  & 0.86852726E-06_JPRB, 0.86207222E-06_JPRB, 0.85838359E-06_JPRB, 0.85393277E-06_JPRB, 0.84039279E-06_JPRB, 0.83183009E-06_JPRB, &
  & 0.82155565E-06_JPRB, 0.81272959E-06_JPRB, 0.81083116E-06_JPRB, 0.82075860E-06_JPRB  /)

RGHG2(:,30,12) = (/ &
  & 0.11173873E-05_JPRB, 0.11443699E-05_JPRB, 0.11716544E-05_JPRB, 0.11908238E-05_JPRB, 0.12104540E-05_JPRB, 0.12276993E-05_JPRB, &
  & 0.12375427E-05_JPRB, 0.12464152E-05_JPRB, 0.12595860E-05_JPRB, 0.12822185E-05_JPRB, 0.13081932E-05_JPRB, 0.13328534E-05_JPRB, &
  & 0.13538125E-05_JPRB, 0.13707243E-05_JPRB, 0.13831319E-05_JPRB, 0.13935405E-05_JPRB, 0.14037913E-05_JPRB, 0.14135988E-05_JPRB, &
  & 0.14244544E-05_JPRB, 0.14364667E-05_JPRB, 0.14498441E-05_JPRB, 0.14634092E-05_JPRB, 0.14785292E-05_JPRB, 0.14994789E-05_JPRB, &
  & 0.15275985E-05_JPRB, 0.15617600E-05_JPRB, 0.15972587E-05_JPRB, 0.16303264E-05_JPRB, 0.16572017E-05_JPRB, 0.16792968E-05_JPRB, &
  & 0.16963275E-05_JPRB, 0.17068654E-05_JPRB, 0.17092598E-05_JPRB, 0.17012527E-05_JPRB, 0.16820506E-05_JPRB, 0.16538625E-05_JPRB, &
  & 0.16168370E-05_JPRB, 0.15638647E-05_JPRB, 0.14943079E-05_JPRB, 0.14211558E-05_JPRB, 0.13507463E-05_JPRB, 0.12869740E-05_JPRB, &
  & 0.12365438E-05_JPRB, 0.11874283E-05_JPRB, 0.11429468E-05_JPRB, 0.10996992E-05_JPRB, 0.10624402E-05_JPRB, 0.10311793E-05_JPRB, &
  & 0.10080998E-05_JPRB, 0.99054070E-06_JPRB, 0.97617679E-06_JPRB, 0.96337276E-06_JPRB, 0.95281118E-06_JPRB, 0.94088362E-06_JPRB, &
  & 0.92858522E-06_JPRB, 0.92272654E-06_JPRB, 0.91916644E-06_JPRB, 0.91258032E-06_JPRB, 0.90000034E-06_JPRB, 0.89270167E-06_JPRB, &
  & 0.88357574E-06_JPRB, 0.87817885E-06_JPRB, 0.87912687E-06_JPRB, 0.89040306E-06_JPRB  /)

RGHG2(:,31,12) = (/ &
  & 0.11377654E-05_JPRB, 0.11631489E-05_JPRB, 0.11907085E-05_JPRB, 0.12095389E-05_JPRB, 0.12303715E-05_JPRB, 0.12498874E-05_JPRB, &
  & 0.12612787E-05_JPRB, 0.12719804E-05_JPRB, 0.12893471E-05_JPRB, 0.13143205E-05_JPRB, 0.13420221E-05_JPRB, 0.13672452E-05_JPRB, &
  & 0.13865860E-05_JPRB, 0.14024170E-05_JPRB, 0.14148821E-05_JPRB, 0.14269344E-05_JPRB, 0.14396350E-05_JPRB, 0.14517578E-05_JPRB, &
  & 0.14655620E-05_JPRB, 0.14796594E-05_JPRB, 0.14933950E-05_JPRB, 0.15057385E-05_JPRB, 0.15192211E-05_JPRB, 0.15362372E-05_JPRB, &
  & 0.15586516E-05_JPRB, 0.15860908E-05_JPRB, 0.16138887E-05_JPRB, 0.16400806E-05_JPRB, 0.16633549E-05_JPRB, 0.16841133E-05_JPRB, &
  & 0.17013551E-05_JPRB, 0.17127564E-05_JPRB, 0.17163149E-05_JPRB, 0.17102522E-05_JPRB, 0.16944656E-05_JPRB, 0.16707995E-05_JPRB, &
  & 0.16391147E-05_JPRB, 0.15922761E-05_JPRB, 0.15361127E-05_JPRB, 0.14788675E-05_JPRB, 0.14197855E-05_JPRB, 0.13675068E-05_JPRB, &
  & 0.13224749E-05_JPRB, 0.12731163E-05_JPRB, 0.12242791E-05_JPRB, 0.11756717E-05_JPRB, 0.11352850E-05_JPRB, 0.11013889E-05_JPRB, &
  & 0.10766080E-05_JPRB, 0.10576418E-05_JPRB, 0.10418516E-05_JPRB, 0.10267386E-05_JPRB, 0.10150385E-05_JPRB, 0.10031429E-05_JPRB, &
  & 0.99187432E-06_JPRB, 0.98664244E-06_JPRB, 0.98321667E-06_JPRB, 0.97437913E-06_JPRB, 0.96280973E-06_JPRB, 0.95684144E-06_JPRB, &
  & 0.94892436E-06_JPRB, 0.94714123E-06_JPRB, 0.95108900E-06_JPRB, 0.96378511E-06_JPRB  /)

RGHG2(:,32,12) = (/ &
  & 0.11672826E-05_JPRB, 0.11893534E-05_JPRB, 0.12147038E-05_JPRB, 0.12337026E-05_JPRB, 0.12557445E-05_JPRB, 0.12766137E-05_JPRB, &
  & 0.12895049E-05_JPRB, 0.12988800E-05_JPRB, 0.13167012E-05_JPRB, 0.13417177E-05_JPRB, 0.13691421E-05_JPRB, 0.13940929E-05_JPRB, &
  & 0.14139290E-05_JPRB, 0.14311178E-05_JPRB, 0.14453347E-05_JPRB, 0.14591138E-05_JPRB, 0.14733781E-05_JPRB, 0.14876212E-05_JPRB, &
  & 0.15030341E-05_JPRB, 0.15178104E-05_JPRB, 0.15316629E-05_JPRB, 0.15435518E-05_JPRB, 0.15558593E-05_JPRB, 0.15707767E-05_JPRB, &
  & 0.15890579E-05_JPRB, 0.16101558E-05_JPRB, 0.16311692E-05_JPRB, 0.16511624E-05_JPRB, 0.16698004E-05_JPRB, 0.16873935E-05_JPRB, &
  & 0.17029751E-05_JPRB, 0.17140293E-05_JPRB, 0.17184324E-05_JPRB, 0.17140834E-05_JPRB, 0.17015430E-05_JPRB, 0.16828212E-05_JPRB, &
  & 0.16584574E-05_JPRB, 0.16244081E-05_JPRB, 0.15848090E-05_JPRB, 0.15422235E-05_JPRB, 0.14947915E-05_JPRB, 0.14495115E-05_JPRB, &
  & 0.14059323E-05_JPRB, 0.13560061E-05_JPRB, 0.13046630E-05_JPRB, 0.12524652E-05_JPRB, 0.12094460E-05_JPRB, 0.11726322E-05_JPRB, &
  & 0.11455519E-05_JPRB, 0.11248182E-05_JPRB, 0.11074181E-05_JPRB, 0.10920441E-05_JPRB, 0.10798421E-05_JPRB, 0.10677286E-05_JPRB, &
  & 0.10568676E-05_JPRB, 0.10520552E-05_JPRB, 0.10481552E-05_JPRB, 0.10380900E-05_JPRB, 0.10273122E-05_JPRB, 0.10219547E-05_JPRB, &
  & 0.10157882E-05_JPRB, 0.10145599E-05_JPRB, 0.10188914E-05_JPRB, 0.10312815E-05_JPRB  /)

RGHG2(:,33,12) = (/ &
  & 0.11991415E-05_JPRB, 0.12175477E-05_JPRB, 0.12402806E-05_JPRB, 0.12595201E-05_JPRB, 0.12828196E-05_JPRB, 0.13049765E-05_JPRB, &
  & 0.13194202E-05_JPRB, 0.13270082E-05_JPRB, 0.13448173E-05_JPRB, 0.13695811E-05_JPRB, 0.13964579E-05_JPRB, 0.14210175E-05_JPRB, &
  & 0.14416419E-05_JPRB, 0.14605578E-05_JPRB, 0.14768146E-05_JPRB, 0.14923988E-05_JPRB, 0.15081735E-05_JPRB, 0.15245949E-05_JPRB, &
  & 0.15415061E-05_JPRB, 0.15568060E-05_JPRB, 0.15707487E-05_JPRB, 0.15822646E-05_JPRB, 0.15934107E-05_JPRB, 0.16063844E-05_JPRB, &
  & 0.16205738E-05_JPRB, 0.16351308E-05_JPRB, 0.16492122E-05_JPRB, 0.16628511E-05_JPRB, 0.16765368E-05_JPRB, 0.16906037E-05_JPRB, &
  & 0.17042176E-05_JPRB, 0.17147542E-05_JPRB, 0.17199938E-05_JPRB, 0.17173959E-05_JPRB, 0.17082071E-05_JPRB, 0.16946783E-05_JPRB, &
  & 0.16781792E-05_JPRB, 0.16582829E-05_JPRB, 0.16363087E-05_JPRB, 0.16087967E-05_JPRB, 0.15735139E-05_JPRB, 0.15349251E-05_JPRB, &
  & 0.14923449E-05_JPRB, 0.14417869E-05_JPRB, 0.13880789E-05_JPRB, 0.13323790E-05_JPRB, 0.12866881E-05_JPRB, 0.12468054E-05_JPRB, &
  & 0.12172580E-05_JPRB, 0.11946409E-05_JPRB, 0.11755438E-05_JPRB, 0.11601638E-05_JPRB, 0.11475225E-05_JPRB, 0.11351503E-05_JPRB, &
  & 0.11246323E-05_JPRB, 0.11202291E-05_JPRB, 0.11157574E-05_JPRB, 0.11045489E-05_JPRB, 0.10945654E-05_JPRB, 0.10897494E-05_JPRB, &
  & 0.10854724E-05_JPRB, 0.10844246E-05_JPRB, 0.10888164E-05_JPRB, 0.11006648E-05_JPRB  /)

RGHG2(:,34,12) = (/ &
  & 0.12364927E-05_JPRB, 0.12527550E-05_JPRB, 0.12722036E-05_JPRB, 0.12904871E-05_JPRB, 0.13124265E-05_JPRB, 0.13346028E-05_JPRB, &
  & 0.13498459E-05_JPRB, 0.13559803E-05_JPRB, 0.13724486E-05_JPRB, 0.13959653E-05_JPRB, 0.14214425E-05_JPRB, 0.14457596E-05_JPRB, &
  & 0.14676101E-05_JPRB, 0.14875429E-05_JPRB, 0.15049716E-05_JPRB, 0.15214358E-05_JPRB, 0.15379814E-05_JPRB, 0.15552838E-05_JPRB, &
  & 0.15721179E-05_JPRB, 0.15868131E-05_JPRB, 0.15998476E-05_JPRB, 0.16104204E-05_JPRB, 0.16203539E-05_JPRB, 0.16313872E-05_JPRB, &
  & 0.16422905E-05_JPRB, 0.16527063E-05_JPRB, 0.16626720E-05_JPRB, 0.16723947E-05_JPRB, 0.16824862E-05_JPRB, 0.16936401E-05_JPRB, &
  & 0.17053382E-05_JPRB, 0.17154163E-05_JPRB, 0.17211481E-05_JPRB, 0.17203939E-05_JPRB, 0.17145998E-05_JPRB, 0.17058178E-05_JPRB, &
  & 0.16954078E-05_JPRB, 0.16839477E-05_JPRB, 0.16712940E-05_JPRB, 0.16530501E-05_JPRB, 0.16268659E-05_JPRB, 0.15952074E-05_JPRB, &
  & 0.15569920E-05_JPRB, 0.15096726E-05_JPRB, 0.14568945E-05_JPRB, 0.14009633E-05_JPRB, 0.13535496E-05_JPRB, 0.13116562E-05_JPRB, &
  & 0.12805555E-05_JPRB, 0.12566774E-05_JPRB, 0.12367038E-05_JPRB, 0.12218254E-05_JPRB, 0.12100160E-05_JPRB, 0.11979308E-05_JPRB, &
  & 0.11873820E-05_JPRB, 0.11833216E-05_JPRB, 0.11792972E-05_JPRB, 0.11682986E-05_JPRB, 0.11585107E-05_JPRB, 0.11530816E-05_JPRB, &
  & 0.11505676E-05_JPRB, 0.11502465E-05_JPRB, 0.11547380E-05_JPRB, 0.11662540E-05_JPRB  /)

RGHG2(:,35,12) = (/ &
  & 0.12777129E-05_JPRB, 0.12925514E-05_JPRB, 0.13082811E-05_JPRB, 0.13249676E-05_JPRB, 0.13441654E-05_JPRB, 0.13657107E-05_JPRB, &
  & 0.13813894E-05_JPRB, 0.13862004E-05_JPRB, 0.14006083E-05_JPRB, 0.14223326E-05_JPRB, 0.14459337E-05_JPRB, 0.14700777E-05_JPRB, &
  & 0.14934135E-05_JPRB, 0.15140275E-05_JPRB, 0.15322156E-05_JPRB, 0.15491098E-05_JPRB, 0.15660685E-05_JPRB, 0.15836111E-05_JPRB, &
  & 0.15995573E-05_JPRB, 0.16130520E-05_JPRB, 0.16246403E-05_JPRB, 0.16339512E-05_JPRB, 0.16426116E-05_JPRB, 0.16516515E-05_JPRB, &
  & 0.16595898E-05_JPRB, 0.16669791E-05_JPRB, 0.16741586E-05_JPRB, 0.16811062E-05_JPRB, 0.16881991E-05_JPRB, 0.16966729E-05_JPRB, &
  & 0.17064277E-05_JPRB, 0.17160648E-05_JPRB, 0.17221260E-05_JPRB, 0.17233150E-05_JPRB, 0.17210330E-05_JPRB, 0.17169023E-05_JPRB, &
  & 0.17118416E-05_JPRB, 0.17061216E-05_JPRB, 0.16987892E-05_JPRB, 0.16870951E-05_JPRB, 0.16687003E-05_JPRB, 0.16442896E-05_JPRB, &
  & 0.16122889E-05_JPRB, 0.15702852E-05_JPRB, 0.15201538E-05_JPRB, 0.14656633E-05_JPRB, 0.14169653E-05_JPRB, 0.13735475E-05_JPRB, &
  & 0.13413189E-05_JPRB, 0.13164636E-05_JPRB, 0.12960098E-05_JPRB, 0.12819076E-05_JPRB, 0.12716058E-05_JPRB, 0.12600958E-05_JPRB, &
  & 0.12493236E-05_JPRB, 0.12455815E-05_JPRB, 0.12425398E-05_JPRB, 0.12324514E-05_JPRB, 0.12225574E-05_JPRB, 0.12159055E-05_JPRB, &
  & 0.12151392E-05_JPRB, 0.12158455E-05_JPRB, 0.12204598E-05_JPRB, 0.12317413E-05_JPRB  /)

RGHG2(:,36,12) = (/ &
  & 0.13198277E-05_JPRB, 0.13339899E-05_JPRB, 0.13465403E-05_JPRB, 0.13612079E-05_JPRB, 0.13775329E-05_JPRB, 0.13980927E-05_JPRB, &
  & 0.14134142E-05_JPRB, 0.14170747E-05_JPRB, 0.14295663E-05_JPRB, 0.14492933E-05_JPRB, 0.14709303E-05_JPRB, 0.14945972E-05_JPRB, &
  & 0.15187349E-05_JPRB, 0.15395341E-05_JPRB, 0.15579085E-05_JPRB, 0.15748820E-05_JPRB, 0.15918317E-05_JPRB, 0.16089774E-05_JPRB, &
  & 0.16237255E-05_JPRB, 0.16358273E-05_JPRB, 0.16458156E-05_JPRB, 0.16537171E-05_JPRB, 0.16610383E-05_JPRB, 0.16681895E-05_JPRB, &
  & 0.16736487E-05_JPRB, 0.16785455E-05_JPRB, 0.16834091E-05_JPRB, 0.16880968E-05_JPRB, 0.16927777E-05_JPRB, 0.16991315E-05_JPRB, &
  & 0.17073708E-05_JPRB, 0.17165592E-05_JPRB, 0.17228335E-05_JPRB, 0.17256249E-05_JPRB, 0.17261467E-05_JPRB, 0.17255819E-05_JPRB, &
  & 0.17245889E-05_JPRB, 0.17231909E-05_JPRB, 0.17200412E-05_JPRB, 0.17137039E-05_JPRB, 0.17018976E-05_JPRB, 0.16840356E-05_JPRB, &
  & 0.16582988E-05_JPRB, 0.16221964E-05_JPRB, 0.15758788E-05_JPRB, 0.15239330E-05_JPRB, 0.14751397E-05_JPRB, 0.14310836E-05_JPRB, &
  & 0.13981582E-05_JPRB, 0.13728408E-05_JPRB, 0.13525520E-05_JPRB, 0.13394481E-05_JPRB, 0.13307229E-05_JPRB, 0.13201428E-05_JPRB, &
  & 0.13094539E-05_JPRB, 0.13059472E-05_JPRB, 0.13036349E-05_JPRB, 0.12944222E-05_JPRB, 0.12846428E-05_JPRB, 0.12769108E-05_JPRB, &
  & 0.12779051E-05_JPRB, 0.12794602E-05_JPRB, 0.12842311E-05_JPRB, 0.12951092E-05_JPRB  /)

RGHG2(:,37,12) = (/ &
  & 0.13613735E-05_JPRB, 0.13766156E-05_JPRB, 0.13874211E-05_JPRB, 0.13992279E-05_JPRB, 0.14125580E-05_JPRB, 0.14313807E-05_JPRB, &
  & 0.14445503E-05_JPRB, 0.14475277E-05_JPRB, 0.14585529E-05_JPRB, 0.14759371E-05_JPRB, 0.14955302E-05_JPRB, 0.15180528E-05_JPRB, &
  & 0.15413762E-05_JPRB, 0.15612114E-05_JPRB, 0.15784466E-05_JPRB, 0.15946908E-05_JPRB, 0.16106636E-05_JPRB, 0.16259769E-05_JPRB, &
  & 0.16388899E-05_JPRB, 0.16492443E-05_JPRB, 0.16573795E-05_JPRB, 0.16636213E-05_JPRB, 0.16695353E-05_JPRB, 0.16751556E-05_JPRB, &
  & 0.16794034E-05_JPRB, 0.16831868E-05_JPRB, 0.16869577E-05_JPRB, 0.16907072E-05_JPRB, 0.16944706E-05_JPRB, 0.17001207E-05_JPRB, &
  & 0.17079194E-05_JPRB, 0.17166696E-05_JPRB, 0.17228769E-05_JPRB, 0.17263899E-05_JPRB, 0.17279170E-05_JPRB, 0.17282078E-05_JPRB, &
  & 0.17280911E-05_JPRB, 0.17274945E-05_JPRB, 0.17256567E-05_JPRB, 0.17216081E-05_JPRB, 0.17132271E-05_JPRB, 0.16999037E-05_JPRB, &
  & 0.16801540E-05_JPRB, 0.16509278E-05_JPRB, 0.16108628E-05_JPRB, 0.15638344E-05_JPRB, 0.15176777E-05_JPRB, 0.14750546E-05_JPRB, &
  & 0.14424643E-05_JPRB, 0.14178943E-05_JPRB, 0.13992395E-05_JPRB, 0.13875815E-05_JPRB, 0.13804929E-05_JPRB, 0.13715983E-05_JPRB, &
  & 0.13616903E-05_JPRB, 0.13582146E-05_JPRB, 0.13560054E-05_JPRB, 0.13475349E-05_JPRB, 0.13383689E-05_JPRB, 0.13299513E-05_JPRB, &
  & 0.13326260E-05_JPRB, 0.13345678E-05_JPRB, 0.13395629E-05_JPRB, 0.13496755E-05_JPRB  /)

RGHG2(:,38,12) = (/ &
  & 0.14074722E-05_JPRB, 0.14239125E-05_JPRB, 0.14327820E-05_JPRB, 0.14414145E-05_JPRB, 0.14514216E-05_JPRB, 0.14683168E-05_JPRB, &
  & 0.14790985E-05_JPRB, 0.14813181E-05_JPRB, 0.14907160E-05_JPRB, 0.15055007E-05_JPRB, 0.15228261E-05_JPRB, 0.15440790E-05_JPRB, &
  & 0.15664986E-05_JPRB, 0.15852643E-05_JPRB, 0.16012355E-05_JPRB, 0.16166704E-05_JPRB, 0.16315594E-05_JPRB, 0.16448394E-05_JPRB, &
  & 0.16557163E-05_JPRB, 0.16641317E-05_JPRB, 0.16702108E-05_JPRB, 0.16746108E-05_JPRB, 0.16789634E-05_JPRB, 0.16828851E-05_JPRB, &
  & 0.16857888E-05_JPRB, 0.16883367E-05_JPRB, 0.16908951E-05_JPRB, 0.16936037E-05_JPRB, 0.16963490E-05_JPRB, 0.17012184E-05_JPRB, &
  & 0.17085281E-05_JPRB, 0.17167921E-05_JPRB, 0.17229250E-05_JPRB, 0.17272388E-05_JPRB, 0.17298812E-05_JPRB, 0.17311214E-05_JPRB, &
  & 0.17319770E-05_JPRB, 0.17322699E-05_JPRB, 0.17318877E-05_JPRB, 0.17303785E-05_JPRB, 0.17257981E-05_JPRB, 0.17175107E-05_JPRB, &
  & 0.17044042E-05_JPRB, 0.16828078E-05_JPRB, 0.16496806E-05_JPRB, 0.16081086E-05_JPRB, 0.15648774E-05_JPRB, 0.15238443E-05_JPRB, &
  & 0.14916258E-05_JPRB, 0.14678851E-05_JPRB, 0.14510434E-05_JPRB, 0.14409897E-05_JPRB, 0.14357171E-05_JPRB, 0.14286928E-05_JPRB, &
  & 0.14196513E-05_JPRB, 0.14162098E-05_JPRB, 0.14141151E-05_JPRB, 0.14064682E-05_JPRB, 0.13979828E-05_JPRB, 0.13888045E-05_JPRB, &
  & 0.13933438E-05_JPRB, 0.13957145E-05_JPRB, 0.14009584E-05_JPRB, 0.14102217E-05_JPRB  /)

RGHG2(:,39,12) = (/ &
  & 0.14464445E-05_JPRB, 0.14619022E-05_JPRB, 0.14690662E-05_JPRB, 0.14757512E-05_JPRB, 0.14841053E-05_JPRB, 0.14989978E-05_JPRB, &
  & 0.15081894E-05_JPRB, 0.15104788E-05_JPRB, 0.15183674E-05_JPRB, 0.15310261E-05_JPRB, 0.15462474E-05_JPRB, 0.15649939E-05_JPRB, &
  & 0.15849376E-05_JPRB, 0.16017912E-05_JPRB, 0.16161864E-05_JPRB, 0.16301133E-05_JPRB, 0.16432694E-05_JPRB, 0.16547024E-05_JPRB, &
  & 0.16640220E-05_JPRB, 0.16708139E-05_JPRB, 0.16753435E-05_JPRB, 0.16785803E-05_JPRB, 0.16821680E-05_JPRB, 0.16854354E-05_JPRB, &
  & 0.16877654E-05_JPRB, 0.16897405E-05_JPRB, 0.16918914E-05_JPRB, 0.16942752E-05_JPRB, 0.16967108E-05_JPRB, 0.17012955E-05_JPRB, &
  & 0.17085761E-05_JPRB, 0.17163323E-05_JPRB, 0.17223985E-05_JPRB, 0.17270160E-05_JPRB, 0.17299984E-05_JPRB, 0.17316531E-05_JPRB, &
  & 0.17327325E-05_JPRB, 0.17332103E-05_JPRB, 0.17331728E-05_JPRB, 0.17325379E-05_JPRB, 0.17294756E-05_JPRB, 0.17231599E-05_JPRB, &
  & 0.17129663E-05_JPRB, 0.16958062E-05_JPRB, 0.16679974E-05_JPRB, 0.16315092E-05_JPRB, 0.15920442E-05_JPRB, 0.15539351E-05_JPRB, &
  & 0.15237717E-05_JPRB, 0.15020721E-05_JPRB, 0.14874494E-05_JPRB, 0.14787727E-05_JPRB, 0.14741295E-05_JPRB, 0.14683604E-05_JPRB, &
  & 0.14603999E-05_JPRB, 0.14571910E-05_JPRB, 0.14548881E-05_JPRB, 0.14482264E-05_JPRB, 0.14402089E-05_JPRB, 0.14316678E-05_JPRB, &
  & 0.14369268E-05_JPRB, 0.14396276E-05_JPRB, 0.14446511E-05_JPRB, 0.14522616E-05_JPRB  /)

RGHG2(:,40,12) = (/ &
  & 0.14910159E-05_JPRB, 0.15049636E-05_JPRB, 0.15101638E-05_JPRB, 0.15147639E-05_JPRB, 0.15214512E-05_JPRB, 0.15339811E-05_JPRB, &
  & 0.15414372E-05_JPRB, 0.15439439E-05_JPRB, 0.15500805E-05_JPRB, 0.15603215E-05_JPRB, 0.15731005E-05_JPRB, 0.15887032E-05_JPRB, &
  & 0.16054839E-05_JPRB, 0.16199555E-05_JPRB, 0.16324502E-05_JPRB, 0.16444930E-05_JPRB, 0.16555093E-05_JPRB, 0.16648052E-05_JPRB, &
  & 0.16723755E-05_JPRB, 0.16773137E-05_JPRB, 0.16801077E-05_JPRB, 0.16820903E-05_JPRB, 0.16849106E-05_JPRB, 0.16875812E-05_JPRB, &
  & 0.16893638E-05_JPRB, 0.16907751E-05_JPRB, 0.16925794E-05_JPRB, 0.16946991E-05_JPRB, 0.16968872E-05_JPRB, 0.17012189E-05_JPRB, &
  & 0.17085408E-05_JPRB, 0.17156974E-05_JPRB, 0.17216866E-05_JPRB, 0.17265791E-05_JPRB, 0.17298338E-05_JPRB, 0.17318873E-05_JPRB, &
  & 0.17331070E-05_JPRB, 0.17336866E-05_JPRB, 0.17338718E-05_JPRB, 0.17339906E-05_JPRB, 0.17323365E-05_JPRB, 0.17278333E-05_JPRB, &
  & 0.17204479E-05_JPRB, 0.17079719E-05_JPRB, 0.16861398E-05_JPRB, 0.16555568E-05_JPRB, 0.16206493E-05_JPRB, 0.15861900E-05_JPRB, &
  & 0.15587138E-05_JPRB, 0.15396078E-05_JPRB, 0.15276559E-05_JPRB, 0.15205579E-05_JPRB, 0.15164593E-05_JPRB, 0.15120627E-05_JPRB, &
  & 0.15054059E-05_JPRB, 0.15025023E-05_JPRB, 0.14999023E-05_JPRB, 0.14944233E-05_JPRB, 0.14869202E-05_JPRB, 0.14793555E-05_JPRB, &
  & 0.14852718E-05_JPRB, 0.14883439E-05_JPRB, 0.14930318E-05_JPRB, 0.14985713E-05_JPRB  /)

RGHG2(:,41,12) = (/ &
  & 0.15455109E-05_JPRB, 0.15576125E-05_JPRB, 0.15604116E-05_JPRB, 0.15624627E-05_JPRB, 0.15671121E-05_JPRB, 0.15767534E-05_JPRB, &
  & 0.15820875E-05_JPRB, 0.15848598E-05_JPRB, 0.15888543E-05_JPRB, 0.15961394E-05_JPRB, 0.16059322E-05_JPRB, 0.16176912E-05_JPRB, &
  & 0.16306046E-05_JPRB, 0.16421641E-05_JPRB, 0.16523351E-05_JPRB, 0.16620744E-05_JPRB, 0.16704744E-05_JPRB, 0.16771574E-05_JPRB, &
  & 0.16825890E-05_JPRB, 0.16852605E-05_JPRB, 0.16859326E-05_JPRB, 0.16863818E-05_JPRB, 0.16882639E-05_JPRB, 0.16902047E-05_JPRB, &
  & 0.16913181E-05_JPRB, 0.16920401E-05_JPRB, 0.16934207E-05_JPRB, 0.16952175E-05_JPRB, 0.16971030E-05_JPRB, 0.17011252E-05_JPRB, &
  & 0.17084976E-05_JPRB, 0.17149211E-05_JPRB, 0.17208161E-05_JPRB, 0.17260449E-05_JPRB, 0.17296325E-05_JPRB, 0.17321737E-05_JPRB, &
  & 0.17335649E-05_JPRB, 0.17342688E-05_JPRB, 0.17347265E-05_JPRB, 0.17357667E-05_JPRB, 0.17358344E-05_JPRB, 0.17335473E-05_JPRB, &
  & 0.17295953E-05_JPRB, 0.17228461E-05_JPRB, 0.17083215E-05_JPRB, 0.16849584E-05_JPRB, 0.16556231E-05_JPRB, 0.16256263E-05_JPRB, &
  & 0.16014355E-05_JPRB, 0.15855008E-05_JPRB, 0.15768141E-05_JPRB, 0.15716464E-05_JPRB, 0.15682136E-05_JPRB, 0.15654950E-05_JPRB, &
  & 0.15604322E-05_JPRB, 0.15579019E-05_JPRB, 0.15549387E-05_JPRB, 0.15509058E-05_JPRB, 0.15440314E-05_JPRB, 0.15376605E-05_JPRB, &
  & 0.15443806E-05_JPRB, 0.15479067E-05_JPRB, 0.15521843E-05_JPRB, 0.15551916E-05_JPRB  /)

RGHG2(:,42,12) = (/ &
  & 0.15716574E-05_JPRB, 0.15804265E-05_JPRB, 0.15825325E-05_JPRB, 0.15842566E-05_JPRB, 0.15886434E-05_JPRB, 0.15964125E-05_JPRB, &
  & 0.16017872E-05_JPRB, 0.16043998E-05_JPRB, 0.16076354E-05_JPRB, 0.16135965E-05_JPRB, 0.16212814E-05_JPRB, 0.16304025E-05_JPRB, &
  & 0.16404655E-05_JPRB, 0.16500477E-05_JPRB, 0.16582929E-05_JPRB, 0.16660824E-05_JPRB, 0.16728274E-05_JPRB, 0.16782464E-05_JPRB, &
  & 0.16824885E-05_JPRB, 0.16845453E-05_JPRB, 0.16849853E-05_JPRB, 0.16857393E-05_JPRB, 0.16877547E-05_JPRB, 0.16898124E-05_JPRB, &
  & 0.16908704E-05_JPRB, 0.16917065E-05_JPRB, 0.16931069E-05_JPRB, 0.16949124E-05_JPRB, 0.16968314E-05_JPRB, 0.17007614E-05_JPRB, &
  & 0.17076846E-05_JPRB, 0.17140829E-05_JPRB, 0.17201314E-05_JPRB, 0.17253761E-05_JPRB, 0.17291922E-05_JPRB, 0.17318706E-05_JPRB, &
  & 0.17335827E-05_JPRB, 0.17343353E-05_JPRB, 0.17346445E-05_JPRB, 0.17352285E-05_JPRB, 0.17352297E-05_JPRB, 0.17330122E-05_JPRB, &
  & 0.17285722E-05_JPRB, 0.17217880E-05_JPRB, 0.17085247E-05_JPRB, 0.16877093E-05_JPRB, 0.16617894E-05_JPRB, 0.16353459E-05_JPRB, &
  & 0.16145834E-05_JPRB, 0.16014909E-05_JPRB, 0.15938698E-05_JPRB, 0.15890609E-05_JPRB, 0.15863467E-05_JPRB, 0.15835951E-05_JPRB, &
  & 0.15796622E-05_JPRB, 0.15772013E-05_JPRB, 0.15746730E-05_JPRB, 0.15712908E-05_JPRB, 0.15649544E-05_JPRB, 0.15594713E-05_JPRB, &
  & 0.15654579E-05_JPRB, 0.15696026E-05_JPRB, 0.15735155E-05_JPRB, 0.15767277E-05_JPRB  /)

RGHG2(:,43,12) = (/ &
  & 0.16189543E-05_JPRB, 0.16238888E-05_JPRB, 0.16243296E-05_JPRB, 0.16246588E-05_JPRB, 0.16279293E-05_JPRB, 0.16327479E-05_JPRB, &
  & 0.16372469E-05_JPRB, 0.16398279E-05_JPRB, 0.16414497E-05_JPRB, 0.16449312E-05_JPRB, 0.16494085E-05_JPRB, 0.16544694E-05_JPRB, &
  & 0.16602682E-05_JPRB, 0.16667936E-05_JPRB, 0.16722823E-05_JPRB, 0.16773020E-05_JPRB, 0.16814114E-05_JPRB, 0.16845532E-05_JPRB, &
  & 0.16867901E-05_JPRB, 0.16873111E-05_JPRB, 0.16866266E-05_JPRB, 0.16869991E-05_JPRB, 0.16887325E-05_JPRB, 0.16905829E-05_JPRB, &
  & 0.16913026E-05_JPRB, 0.16919463E-05_JPRB, 0.16931825E-05_JPRB, 0.16948569E-05_JPRB, 0.16966764E-05_JPRB, 0.17003892E-05_JPRB, &
  & 0.17069242E-05_JPRB, 0.17129842E-05_JPRB, 0.17191322E-05_JPRB, 0.17245362E-05_JPRB, 0.17287038E-05_JPRB, 0.17317173E-05_JPRB, &
  & 0.17337960E-05_JPRB, 0.17346464E-05_JPRB, 0.17349374E-05_JPRB, 0.17355014E-05_JPRB, 0.17361827E-05_JPRB, 0.17349819E-05_JPRB, &
  & 0.17315735E-05_JPRB, 0.17272208E-05_JPRB, 0.17182515E-05_JPRB, 0.17028663E-05_JPRB, 0.16824595E-05_JPRB, 0.16611775E-05_JPRB, &
  & 0.16449562E-05_JPRB, 0.16358211E-05_JPRB, 0.16305767E-05_JPRB, 0.16269255E-05_JPRB, 0.16251534E-05_JPRB, 0.16230934E-05_JPRB, &
  & 0.16208771E-05_JPRB, 0.16186401E-05_JPRB, 0.16163522E-05_JPRB, 0.16141858E-05_JPRB, 0.16086107E-05_JPRB, 0.16044511E-05_JPRB, &
  & 0.16101143E-05_JPRB, 0.16150186E-05_JPRB, 0.16184224E-05_JPRB, 0.16207323E-05_JPRB  /)

RGHG2(:,44,12) = (/ &
  & 0.16407907E-05_JPRB, 0.16440576E-05_JPRB, 0.16443324E-05_JPRB, 0.16445928E-05_JPRB, 0.16470828E-05_JPRB, 0.16507279E-05_JPRB, &
  & 0.16544847E-05_JPRB, 0.16568028E-05_JPRB, 0.16579179E-05_JPRB, 0.16601472E-05_JPRB, 0.16630731E-05_JPRB, 0.16664200E-05_JPRB, &
  & 0.16703425E-05_JPRB, 0.16749440E-05_JPRB, 0.16784505E-05_JPRB, 0.16817088E-05_JPRB, 0.16843162E-05_JPRB, 0.16861276E-05_JPRB, &
  & 0.16872726E-05_JPRB, 0.16872218E-05_JPRB, 0.16863670E-05_JPRB, 0.16869219E-05_JPRB, 0.16887752E-05_JPRB, 0.16905885E-05_JPRB, &
  & 0.16912572E-05_JPRB, 0.16917873E-05_JPRB, 0.16930845E-05_JPRB, 0.16946592E-05_JPRB, 0.16965305E-05_JPRB, 0.17001580E-05_JPRB, &
  & 0.17062297E-05_JPRB, 0.17122593E-05_JPRB, 0.17184513E-05_JPRB, 0.17239198E-05_JPRB, 0.17281741E-05_JPRB, 0.17313162E-05_JPRB, &
  & 0.17335049E-05_JPRB, 0.17347073E-05_JPRB, 0.17352518E-05_JPRB, 0.17359124E-05_JPRB, 0.17366975E-05_JPRB, 0.17359303E-05_JPRB, &
  & 0.17328118E-05_JPRB, 0.17288715E-05_JPRB, 0.17214323E-05_JPRB, 0.17086913E-05_JPRB, 0.16914753E-05_JPRB, 0.16735810E-05_JPRB, &
  & 0.16603304E-05_JPRB, 0.16529249E-05_JPRB, 0.16489584E-05_JPRB, 0.16459802E-05_JPRB, 0.16446915E-05_JPRB, 0.16430534E-05_JPRB, &
  & 0.16412953E-05_JPRB, 0.16393377E-05_JPRB, 0.16371518E-05_JPRB, 0.16349176E-05_JPRB, 0.16304952E-05_JPRB, 0.16276104E-05_JPRB, &
  & 0.16319408E-05_JPRB, 0.16359222E-05_JPRB, 0.16390596E-05_JPRB, 0.16414531E-05_JPRB  /)

RGHG2(:,45,12) = (/ &
  & 0.16716244E-05_JPRB, 0.16725086E-05_JPRB, 0.16723841E-05_JPRB, 0.16723899E-05_JPRB, 0.16738504E-05_JPRB, 0.16757869E-05_JPRB, &
  & 0.16785881E-05_JPRB, 0.16806028E-05_JPRB, 0.16809373E-05_JPRB, 0.16814278E-05_JPRB, 0.16821824E-05_JPRB, 0.16830652E-05_JPRB, &
  & 0.16843129E-05_JPRB, 0.16863380E-05_JPRB, 0.16872397E-05_JPRB, 0.16881428E-05_JPRB, 0.16887074E-05_JPRB, 0.16887167E-05_JPRB, &
  & 0.16883653E-05_JPRB, 0.16874695E-05_JPRB, 0.16862789E-05_JPRB, 0.16869932E-05_JPRB, 0.16889473E-05_JPRB, 0.16906923E-05_JPRB, &
  & 0.16912602E-05_JPRB, 0.16916365E-05_JPRB, 0.16929826E-05_JPRB, 0.16944271E-05_JPRB, 0.16963448E-05_JPRB, 0.16998479E-05_JPRB, &
  & 0.17053430E-05_JPRB, 0.17112953E-05_JPRB, 0.17175499E-05_JPRB, 0.17231119E-05_JPRB, 0.17275094E-05_JPRB, 0.17308401E-05_JPRB, &
  & 0.17332004E-05_JPRB, 0.17348160E-05_JPRB, 0.17356467E-05_JPRB, 0.17364146E-05_JPRB, 0.17374039E-05_JPRB, 0.17372588E-05_JPRB, &
  & 0.17346006E-05_JPRB, 0.17314370E-05_JPRB, 0.17262822E-05_JPRB, 0.17172374E-05_JPRB, 0.17043503E-05_JPRB, 0.16909645E-05_JPRB, &
  & 0.16816695E-05_JPRB, 0.16767331E-05_JPRB, 0.16745215E-05_JPRB, 0.16724558E-05_JPRB, 0.16718364E-05_JPRB, 0.16707659E-05_JPRB, &
  & 0.16697463E-05_JPRB, 0.16681352E-05_JPRB, 0.16660956E-05_JPRB, 0.16639378E-05_JPRB, 0.16609240E-05_JPRB, 0.16596575E-05_JPRB, &
  & 0.16624297E-05_JPRB, 0.16654564E-05_JPRB, 0.16682262E-05_JPRB, 0.16706011E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART24',0,ZHOOK_HANDLE)



RGHG2(:,46,12) = (/ &
  & 0.16864320E-05_JPRB, 0.16870654E-05_JPRB, 0.16869206E-05_JPRB, 0.16868787E-05_JPRB, 0.16879006E-05_JPRB, 0.16890704E-05_JPRB, &
  & 0.16912212E-05_JPRB, 0.16927881E-05_JPRB, 0.16927701E-05_JPRB, 0.16925323E-05_JPRB, 0.16923892E-05_JPRB, 0.16921838E-05_JPRB, &
  & 0.16921108E-05_JPRB, 0.16924866E-05_JPRB, 0.16917567E-05_JPRB, 0.16911584E-05_JPRB, 0.16904945E-05_JPRB, 0.16894925E-05_JPRB, &
  & 0.16882713E-05_JPRB, 0.16869870E-05_JPRB, 0.16857931E-05_JPRB, 0.16866772E-05_JPRB, 0.16887226E-05_JPRB, 0.16905550E-05_JPRB, &
  & 0.16912090E-05_JPRB, 0.16915000E-05_JPRB, 0.16929583E-05_JPRB, 0.16943031E-05_JPRB, 0.16962026E-05_JPRB, 0.16997042E-05_JPRB, &
  & 0.17049977E-05_JPRB, 0.17108218E-05_JPRB, 0.17171253E-05_JPRB, 0.17225935E-05_JPRB, 0.17269306E-05_JPRB, 0.17303945E-05_JPRB, &
  & 0.17327780E-05_JPRB, 0.17346420E-05_JPRB, 0.17357251E-05_JPRB, 0.17367307E-05_JPRB, 0.17379616E-05_JPRB, 0.17383293E-05_JPRB, &
  & 0.17360616E-05_JPRB, 0.17333502E-05_JPRB, 0.17295404E-05_JPRB, 0.17227653E-05_JPRB, 0.17127613E-05_JPRB, 0.17022955E-05_JPRB, &
  & 0.16953306E-05_JPRB, 0.16918332E-05_JPRB, 0.16904141E-05_JPRB, 0.16890637E-05_JPRB, 0.16886985E-05_JPRB, 0.16879144E-05_JPRB, &
  & 0.16870630E-05_JPRB, 0.16856484E-05_JPRB, 0.16837346E-05_JPRB, 0.16819168E-05_JPRB, 0.16797524E-05_JPRB, 0.16791183E-05_JPRB, &
  & 0.16809102E-05_JPRB, 0.16831014E-05_JPRB, 0.16854573E-05_JPRB, 0.16874455E-05_JPRB  /)

RGHG2(:,47,12) = (/ &
  & 0.17005971E-05_JPRB, 0.17013634E-05_JPRB, 0.17012709E-05_JPRB, 0.17012142E-05_JPRB, 0.17018399E-05_JPRB, 0.17022987E-05_JPRB, &
  & 0.17037475E-05_JPRB, 0.17047600E-05_JPRB, 0.17044142E-05_JPRB, 0.17035242E-05_JPRB, 0.17025828E-05_JPRB, 0.17013761E-05_JPRB, &
  & 0.17000247E-05_JPRB, 0.16986507E-05_JPRB, 0.16962013E-05_JPRB, 0.16940123E-05_JPRB, 0.16920698E-05_JPRB, 0.16900397E-05_JPRB, &
  & 0.16879232E-05_JPRB, 0.16862745E-05_JPRB, 0.16851434E-05_JPRB, 0.16862288E-05_JPRB, 0.16883794E-05_JPRB, 0.16903456E-05_JPRB, &
  & 0.16911382E-05_JPRB, 0.16913428E-05_JPRB, 0.16929453E-05_JPRB, 0.16941793E-05_JPRB, 0.16960445E-05_JPRB, 0.16995689E-05_JPRB, &
  & 0.17047010E-05_JPRB, 0.17103645E-05_JPRB, 0.17167227E-05_JPRB, 0.17220433E-05_JPRB, 0.17262686E-05_JPRB, 0.17298776E-05_JPRB, &
  & 0.17322587E-05_JPRB, 0.17343812E-05_JPRB, 0.17357538E-05_JPRB, 0.17370643E-05_JPRB, 0.17385862E-05_JPRB, 0.17395336E-05_JPRB, &
  & 0.17377104E-05_JPRB, 0.17354645E-05_JPRB, 0.17330449E-05_JPRB, 0.17286473E-05_JPRB, 0.17217367E-05_JPRB, 0.17143791E-05_JPRB, &
  & 0.17098227E-05_JPRB, 0.17078076E-05_JPRB, 0.17071255E-05_JPRB, 0.17065750E-05_JPRB, 0.17064251E-05_JPRB, 0.17059207E-05_JPRB, &
  & 0.17051524E-05_JPRB, 0.17039384E-05_JPRB, 0.17021681E-05_JPRB, 0.17008020E-05_JPRB, 0.16995222E-05_JPRB, 0.16994329E-05_JPRB, &
  & 0.17001900E-05_JPRB, 0.17014248E-05_JPRB, 0.17032858E-05_JPRB, 0.17047464E-05_JPRB  /)

RGHG2(:,48,12) = (/ &
  & 0.17079061E-05_JPRB, 0.17087845E-05_JPRB, 0.17087136E-05_JPRB, 0.17087153E-05_JPRB, 0.17090816E-05_JPRB, 0.17091277E-05_JPRB, &
  & 0.17100310E-05_JPRB, 0.17105044E-05_JPRB, 0.17098639E-05_JPRB, 0.17086833E-05_JPRB, 0.17074046E-05_JPRB, 0.17057726E-05_JPRB, &
  & 0.17036805E-05_JPRB, 0.17012471E-05_JPRB, 0.16978964E-05_JPRB, 0.16947333E-05_JPRB, 0.16920936E-05_JPRB, 0.16895505E-05_JPRB, &
  & 0.16871477E-05_JPRB, 0.16854250E-05_JPRB, 0.16844354E-05_JPRB, 0.16856738E-05_JPRB, 0.16879193E-05_JPRB, 0.16899618E-05_JPRB, &
  & 0.16909362E-05_JPRB, 0.16911934E-05_JPRB, 0.16929311E-05_JPRB, 0.16941532E-05_JPRB, 0.16959431E-05_JPRB, 0.16994677E-05_JPRB, &
  & 0.17045790E-05_JPRB, 0.17102012E-05_JPRB, 0.17164938E-05_JPRB, 0.17216820E-05_JPRB, 0.17258320E-05_JPRB, 0.17294880E-05_JPRB, &
  & 0.17319000E-05_JPRB, 0.17341266E-05_JPRB, 0.17356558E-05_JPRB, 0.17372115E-05_JPRB, 0.17390228E-05_JPRB, 0.17404807E-05_JPRB, &
  & 0.17391098E-05_JPRB, 0.17372967E-05_JPRB, 0.17359343E-05_JPRB, 0.17332991E-05_JPRB, 0.17286710E-05_JPRB, 0.17234720E-05_JPRB, &
  & 0.17204390E-05_JPRB, 0.17192507E-05_JPRB, 0.17190258E-05_JPRB, 0.17188769E-05_JPRB, 0.17188652E-05_JPRB, 0.17185584E-05_JPRB, &
  & 0.17178464E-05_JPRB, 0.17167229E-05_JPRB, 0.17151600E-05_JPRB, 0.17141830E-05_JPRB, 0.17133391E-05_JPRB, 0.17132572E-05_JPRB, &
  & 0.17134587E-05_JPRB, 0.17142212E-05_JPRB, 0.17156403E-05_JPRB, 0.17167535E-05_JPRB  /)

RGHG2(:,49,12) = (/ &
  & 0.17128830E-05_JPRB, 0.17138761E-05_JPRB, 0.17138152E-05_JPRB, 0.17139148E-05_JPRB, 0.17140559E-05_JPRB, 0.17137808E-05_JPRB, &
  & 0.17141510E-05_JPRB, 0.17140344E-05_JPRB, 0.17130827E-05_JPRB, 0.17117448E-05_JPRB, 0.17103020E-05_JPRB, 0.17084609E-05_JPRB, &
  & 0.17057930E-05_JPRB, 0.17025002E-05_JPRB, 0.16985236E-05_JPRB, 0.16945622E-05_JPRB, 0.16914146E-05_JPRB, 0.16885376E-05_JPRB, &
  & 0.16860946E-05_JPRB, 0.16844221E-05_JPRB, 0.16836250E-05_JPRB, 0.16850106E-05_JPRB, 0.16873565E-05_JPRB, 0.16894577E-05_JPRB, &
  & 0.16906530E-05_JPRB, 0.16910314E-05_JPRB, 0.16929148E-05_JPRB, 0.16941687E-05_JPRB, 0.16958565E-05_JPRB, 0.16993711E-05_JPRB, &
  & 0.17045234E-05_JPRB, 0.17101539E-05_JPRB, 0.17163193E-05_JPRB, 0.17213678E-05_JPRB, 0.17254508E-05_JPRB, 0.17291144E-05_JPRB, &
  & 0.17315757E-05_JPRB, 0.17338475E-05_JPRB, 0.17354897E-05_JPRB, 0.17372897E-05_JPRB, 0.17394207E-05_JPRB, 0.17414125E-05_JPRB, &
  & 0.17405462E-05_JPRB, 0.17391975E-05_JPRB, 0.17388543E-05_JPRB, 0.17378910E-05_JPRB, 0.17354219E-05_JPRB, 0.17321819E-05_JPRB, &
  & 0.17304333E-05_JPRB, 0.17298626E-05_JPRB, 0.17300169E-05_JPRB, 0.17301315E-05_JPRB, 0.17302378E-05_JPRB, 0.17301125E-05_JPRB, &
  & 0.17294508E-05_JPRB, 0.17283775E-05_JPRB, 0.17270731E-05_JPRB, 0.17264987E-05_JPRB, 0.17259334E-05_JPRB, 0.17256155E-05_JPRB, &
  & 0.17254196E-05_JPRB, 0.17258792E-05_JPRB, 0.17268330E-05_JPRB, 0.17276432E-05_JPRB  /)

RGHG2(:,50,12) = (/ &
  & 0.17145254E-05_JPRB, 0.17152563E-05_JPRB, 0.17151513E-05_JPRB, 0.17153847E-05_JPRB, 0.17154560E-05_JPRB, 0.17149643E-05_JPRB, &
  & 0.17148964E-05_JPRB, 0.17143150E-05_JPRB, 0.17130482E-05_JPRB, 0.17115996E-05_JPRB, 0.17100901E-05_JPRB, 0.17081784E-05_JPRB, &
  & 0.17052826E-05_JPRB, 0.17016092E-05_JPRB, 0.16973468E-05_JPRB, 0.16930243E-05_JPRB, 0.16897366E-05_JPRB, 0.16868842E-05_JPRB, &
  & 0.16847207E-05_JPRB, 0.16832985E-05_JPRB, 0.16828020E-05_JPRB, 0.16842869E-05_JPRB, 0.16867369E-05_JPRB, 0.16888866E-05_JPRB, &
  & 0.16903445E-05_JPRB, 0.16909149E-05_JPRB, 0.16929024E-05_JPRB, 0.16942515E-05_JPRB, 0.16958809E-05_JPRB, 0.16992563E-05_JPRB, &
  & 0.17044943E-05_JPRB, 0.17101368E-05_JPRB, 0.17161867E-05_JPRB, 0.17211856E-05_JPRB, 0.17252914E-05_JPRB, 0.17289242E-05_JPRB, &
  & 0.17314284E-05_JPRB, 0.17336872E-05_JPRB, 0.17354115E-05_JPRB, 0.17374301E-05_JPRB, 0.17397733E-05_JPRB, 0.17421268E-05_JPRB, &
  & 0.17417279E-05_JPRB, 0.17409129E-05_JPRB, 0.17414017E-05_JPRB, 0.17417205E-05_JPRB, 0.17408118E-05_JPRB, 0.17389973E-05_JPRB, &
  & 0.17381316E-05_JPRB, 0.17379788E-05_JPRB, 0.17384147E-05_JPRB, 0.17387096E-05_JPRB, 0.17389002E-05_JPRB, 0.17389437E-05_JPRB, &
  & 0.17383587E-05_JPRB, 0.17374003E-05_JPRB, 0.17362430E-05_JPRB, 0.17357371E-05_JPRB, 0.17352026E-05_JPRB, 0.17347330E-05_JPRB, &
  & 0.17343516E-05_JPRB, 0.17346610E-05_JPRB, 0.17354491E-05_JPRB, 0.17362326E-05_JPRB  /)

RGHG2(:,51,12) = (/ &
  & 0.17145491E-05_JPRB, 0.17147983E-05_JPRB, 0.17146173E-05_JPRB, 0.17150141E-05_JPRB, 0.17150916E-05_JPRB, 0.17144206E-05_JPRB, &
  & 0.17139288E-05_JPRB, 0.17129103E-05_JPRB, 0.17113009E-05_JPRB, 0.17097570E-05_JPRB, 0.17082265E-05_JPRB, 0.17063113E-05_JPRB, &
  & 0.17033517E-05_JPRB, 0.16995183E-05_JPRB, 0.16951257E-05_JPRB, 0.16906423E-05_JPRB, 0.16873966E-05_JPRB, 0.16847593E-05_JPRB, &
  & 0.16830660E-05_JPRB, 0.16820197E-05_JPRB, 0.16819052E-05_JPRB, 0.16834723E-05_JPRB, 0.16860368E-05_JPRB, 0.16882336E-05_JPRB, &
  & 0.16899975E-05_JPRB, 0.16908127E-05_JPRB, 0.16928911E-05_JPRB, 0.16943766E-05_JPRB, 0.16959658E-05_JPRB, 0.16991226E-05_JPRB, &
  & 0.17044769E-05_JPRB, 0.17101343E-05_JPRB, 0.17160652E-05_JPRB, 0.17210581E-05_JPRB, 0.17252355E-05_JPRB, 0.17288150E-05_JPRB, &
  & 0.17313620E-05_JPRB, 0.17335763E-05_JPRB, 0.17353731E-05_JPRB, 0.17376146E-05_JPRB, 0.17401309E-05_JPRB, 0.17427850E-05_JPRB, &
  & 0.17428722E-05_JPRB, 0.17426708E-05_JPRB, 0.17439612E-05_JPRB, 0.17454618E-05_JPRB, 0.17459264E-05_JPRB, 0.17453733E-05_JPRB, &
  & 0.17452515E-05_JPRB, 0.17454457E-05_JPRB, 0.17461351E-05_JPRB, 0.17465812E-05_JPRB, 0.17468452E-05_JPRB, 0.17470644E-05_JPRB, &
  & 0.17465765E-05_JPRB, 0.17457763E-05_JPRB, 0.17447195E-05_JPRB, 0.17441122E-05_JPRB, 0.17434807E-05_JPRB, 0.17428914E-05_JPRB, &
  & 0.17424208E-05_JPRB, 0.17426480E-05_JPRB, 0.17434143E-05_JPRB, 0.17443140E-05_JPRB  /)

RGHG2(:,52,12) = (/ &
  & 0.17129611E-05_JPRB, 0.17127792E-05_JPRB, 0.17124669E-05_JPRB, 0.17129177E-05_JPRB, 0.17129936E-05_JPRB, 0.17120718E-05_JPRB, &
  & 0.17110299E-05_JPRB, 0.17095012E-05_JPRB, 0.17076452E-05_JPRB, 0.17061459E-05_JPRB, 0.17046238E-05_JPRB, 0.17028822E-05_JPRB, &
  & 0.17001513E-05_JPRB, 0.16965058E-05_JPRB, 0.16922495E-05_JPRB, 0.16879050E-05_JPRB, 0.16848881E-05_JPRB, 0.16825797E-05_JPRB, &
  & 0.16813366E-05_JPRB, 0.16806832E-05_JPRB, 0.16809601E-05_JPRB, 0.16825868E-05_JPRB, 0.16853070E-05_JPRB, 0.16876063E-05_JPRB, &
  & 0.16896347E-05_JPRB, 0.16907772E-05_JPRB, 0.16929401E-05_JPRB, 0.16945401E-05_JPRB, 0.16961238E-05_JPRB, 0.16990364E-05_JPRB, &
  & 0.17043566E-05_JPRB, 0.17101117E-05_JPRB, 0.17160993E-05_JPRB, 0.17211863E-05_JPRB, 0.17254093E-05_JPRB, 0.17289749E-05_JPRB, &
  & 0.17314712E-05_JPRB, 0.17335830E-05_JPRB, 0.17354206E-05_JPRB, 0.17377629E-05_JPRB, 0.17403526E-05_JPRB, 0.17432048E-05_JPRB, &
  & 0.17437330E-05_JPRB, 0.17441356E-05_JPRB, 0.17461823E-05_JPRB, 0.17486311E-05_JPRB, 0.17500751E-05_JPRB, 0.17503901E-05_JPRB, &
  & 0.17508443E-05_JPRB, 0.17514934E-05_JPRB, 0.17524386E-05_JPRB, 0.17530394E-05_JPRB, 0.17534039E-05_JPRB, 0.17537585E-05_JPRB, &
  & 0.17534448E-05_JPRB, 0.17527510E-05_JPRB, 0.17517712E-05_JPRB, 0.17511356E-05_JPRB, 0.17504237E-05_JPRB, 0.17498431E-05_JPRB, &
  & 0.17493299E-05_JPRB, 0.17496189E-05_JPRB, 0.17505421E-05_JPRB, 0.17515480E-05_JPRB  /)

RGHG2(:,53,12) = (/ &
  & 0.17106119E-05_JPRB, 0.17099798E-05_JPRB, 0.17095033E-05_JPRB, 0.17099707E-05_JPRB, 0.17100420E-05_JPRB, 0.17088195E-05_JPRB, &
  & 0.17071301E-05_JPRB, 0.17050175E-05_JPRB, 0.17029300E-05_JPRB, 0.17015331E-05_JPRB, 0.17000312E-05_JPRB, 0.16985471E-05_JPRB, &
  & 0.16961777E-05_JPRB, 0.16928708E-05_JPRB, 0.16888653E-05_JPRB, 0.16847874E-05_JPRB, 0.16820915E-05_JPRB, 0.16801853E-05_JPRB, &
  & 0.16794246E-05_JPRB, 0.16792056E-05_JPRB, 0.16799123E-05_JPRB, 0.16815953E-05_JPRB, 0.16845009E-05_JPRB, 0.16869330E-05_JPRB, &
  & 0.16892335E-05_JPRB, 0.16907644E-05_JPRB, 0.16930168E-05_JPRB, 0.16947329E-05_JPRB, 0.16963240E-05_JPRB, 0.16989608E-05_JPRB, &
  & 0.17041860E-05_JPRB, 0.17100795E-05_JPRB, 0.17161962E-05_JPRB, 0.17214243E-05_JPRB, 0.17256870E-05_JPRB, 0.17292526E-05_JPRB, &
  & 0.17316575E-05_JPRB, 0.17336356E-05_JPRB, 0.17355056E-05_JPRB, 0.17379106E-05_JPRB, 0.17405417E-05_JPRB, 0.17435701E-05_JPRB, &
  & 0.17445613E-05_JPRB, 0.17456179E-05_JPRB, 0.17484708E-05_JPRB, 0.17518623E-05_JPRB, 0.17542213E-05_JPRB, 0.17553305E-05_JPRB, &
  & 0.17563473E-05_JPRB, 0.17575332E-05_JPRB, 0.17587580E-05_JPRB, 0.17595285E-05_JPRB, 0.17600129E-05_JPRB, 0.17604993E-05_JPRB, &
  & 0.17604052E-05_JPRB, 0.17598074E-05_JPRB, 0.17589023E-05_JPRB, 0.17582638E-05_JPRB, 0.17574708E-05_JPRB, 0.17569492E-05_JPRB, &
  & 0.17564074E-05_JPRB, 0.17568191E-05_JPRB, 0.17579822E-05_JPRB, 0.17590996E-05_JPRB  /)

RGHG2(:,54,12) = (/ &
  & 0.17074563E-05_JPRB, 0.17065206E-05_JPRB, 0.17058561E-05_JPRB, 0.17061468E-05_JPRB, 0.17061284E-05_JPRB, 0.17047145E-05_JPRB, &
  & 0.17025141E-05_JPRB, 0.17000860E-05_JPRB, 0.16979937E-05_JPRB, 0.16967047E-05_JPRB, 0.16952627E-05_JPRB, 0.16940672E-05_JPRB, &
  & 0.16920395E-05_JPRB, 0.16892234E-05_JPRB, 0.16856631E-05_JPRB, 0.16819981E-05_JPRB, 0.16796679E-05_JPRB, 0.16781384E-05_JPRB, &
  & 0.16777203E-05_JPRB, 0.16778539E-05_JPRB, 0.16788952E-05_JPRB, 0.16807176E-05_JPRB, 0.16837345E-05_JPRB, 0.16862818E-05_JPRB, &
  & 0.16887581E-05_JPRB, 0.16906697E-05_JPRB, 0.16930832E-05_JPRB, 0.16949420E-05_JPRB, 0.16965481E-05_JPRB, 0.16990490E-05_JPRB, &
  & 0.17041062E-05_JPRB, 0.17101992E-05_JPRB, 0.17165941E-05_JPRB, 0.17217954E-05_JPRB, 0.17262171E-05_JPRB, 0.17296413E-05_JPRB, &
  & 0.17318841E-05_JPRB, 0.17337146E-05_JPRB, 0.17355247E-05_JPRB, 0.17379254E-05_JPRB, 0.17404014E-05_JPRB, 0.17435211E-05_JPRB, &
  & 0.17450993E-05_JPRB, 0.17469336E-05_JPRB, 0.17504375E-05_JPRB, 0.17545782E-05_JPRB, 0.17575958E-05_JPRB, 0.17592836E-05_JPRB, &
  & 0.17608277E-05_JPRB, 0.17623912E-05_JPRB, 0.17637807E-05_JPRB, 0.17646616E-05_JPRB, 0.17652511E-05_JPRB, 0.17658092E-05_JPRB, &
  & 0.17659074E-05_JPRB, 0.17653821E-05_JPRB, 0.17646279E-05_JPRB, 0.17641929E-05_JPRB, 0.17635270E-05_JPRB, 0.17630434E-05_JPRB, &
  & 0.17625553E-05_JPRB, 0.17631214E-05_JPRB, 0.17643558E-05_JPRB, 0.17653745E-05_JPRB  /)

RGHG2(:,55,12) = (/ &
  & 0.17038547E-05_JPRB, 0.17026018E-05_JPRB, 0.17017260E-05_JPRB, 0.17017955E-05_JPRB, 0.17016665E-05_JPRB, 0.17000549E-05_JPRB, &
  & 0.16973065E-05_JPRB, 0.16945642E-05_JPRB, 0.16924964E-05_JPRB, 0.16913278E-05_JPRB, 0.16899572E-05_JPRB, 0.16890857E-05_JPRB, &
  & 0.16874337E-05_JPRB, 0.16851813E-05_JPRB, 0.16821397E-05_JPRB, 0.16789513E-05_JPRB, 0.16770322E-05_JPRB, 0.16759167E-05_JPRB, &
  & 0.16758597E-05_JPRB, 0.16763730E-05_JPRB, 0.16777725E-05_JPRB, 0.16797604E-05_JPRB, 0.16828908E-05_JPRB, 0.16855634E-05_JPRB, &
  & 0.16882216E-05_JPRB, 0.16905541E-05_JPRB, 0.16931555E-05_JPRB, 0.16951758E-05_JPRB, 0.16967995E-05_JPRB, 0.16991683E-05_JPRB, &
  & 0.17040298E-05_JPRB, 0.17103517E-05_JPRB, 0.17170745E-05_JPRB, 0.17222239E-05_JPRB, 0.17268374E-05_JPRB, 0.17300865E-05_JPRB, &
  & 0.17321404E-05_JPRB, 0.17338055E-05_JPRB, 0.17355373E-05_JPRB, 0.17379242E-05_JPRB, 0.17402026E-05_JPRB, 0.17434124E-05_JPRB, &
  & 0.17456570E-05_JPRB, 0.17483692E-05_JPRB, 0.17525738E-05_JPRB, 0.17575190E-05_JPRB, 0.17612324E-05_JPRB, 0.17635329E-05_JPRB, &
  & 0.17656564E-05_JPRB, 0.17676172E-05_JPRB, 0.17691740E-05_JPRB, 0.17701694E-05_JPRB, 0.17708735E-05_JPRB, 0.17715030E-05_JPRB, &
  & 0.17718107E-05_JPRB, 0.17713627E-05_JPRB, 0.17707856E-05_JPRB, 0.17706031E-05_JPRB, 0.17701056E-05_JPRB, 0.17696610E-05_JPRB, &
  & 0.17692435E-05_JPRB, 0.17699847E-05_JPRB, 0.17712758E-05_JPRB, 0.17721576E-05_JPRB  /)

RGHG2(:,56,12) = (/ &
  & 0.17001973E-05_JPRB, 0.16988931E-05_JPRB, 0.16980615E-05_JPRB, 0.16979779E-05_JPRB, 0.16977435E-05_JPRB, 0.16962600E-05_JPRB, &
  & 0.16935393E-05_JPRB, 0.16908812E-05_JPRB, 0.16890109E-05_JPRB, 0.16879004E-05_JPRB, 0.16865784E-05_JPRB, 0.16857280E-05_JPRB, &
  & 0.16842141E-05_JPRB, 0.16821870E-05_JPRB, 0.16795874E-05_JPRB, 0.16767751E-05_JPRB, 0.16751379E-05_JPRB, 0.16743406E-05_JPRB, &
  & 0.16744622E-05_JPRB, 0.16750534E-05_JPRB, 0.16765879E-05_JPRB, 0.16786753E-05_JPRB, 0.16818730E-05_JPRB, 0.16848204E-05_JPRB, &
  & 0.16876126E-05_JPRB, 0.16902008E-05_JPRB, 0.16929104E-05_JPRB, 0.16950797E-05_JPRB, 0.16968715E-05_JPRB, 0.16994428E-05_JPRB, &
  & 0.17042911E-05_JPRB, 0.17109240E-05_JPRB, 0.17177313E-05_JPRB, 0.17227753E-05_JPRB, 0.17272625E-05_JPRB, 0.17303945E-05_JPRB, &
  & 0.17321868E-05_JPRB, 0.17337837E-05_JPRB, 0.17355285E-05_JPRB, 0.17377750E-05_JPRB, 0.17399098E-05_JPRB, 0.17433434E-05_JPRB, &
  & 0.17460659E-05_JPRB, 0.17497384E-05_JPRB, 0.17543612E-05_JPRB, 0.17597617E-05_JPRB, 0.17640130E-05_JPRB, 0.17668044E-05_JPRB, &
  & 0.17692055E-05_JPRB, 0.17712484E-05_JPRB, 0.17727989E-05_JPRB, 0.17738176E-05_JPRB, 0.17745962E-05_JPRB, 0.17752220E-05_JPRB, &
  & 0.17755944E-05_JPRB, 0.17752778E-05_JPRB, 0.17749356E-05_JPRB, 0.17749901E-05_JPRB, 0.17746941E-05_JPRB, 0.17743555E-05_JPRB, &
  & 0.17740399E-05_JPRB, 0.17747728E-05_JPRB, 0.17758050E-05_JPRB, 0.17764876E-05_JPRB  /)

RGHG2(:,57,12) = (/ &
  & 0.16965900E-05_JPRB, 0.16952802E-05_JPRB, 0.16945410E-05_JPRB, 0.16943525E-05_JPRB, 0.16940270E-05_JPRB, 0.16926961E-05_JPRB, &
  & 0.16900746E-05_JPRB, 0.16875152E-05_JPRB, 0.16858266E-05_JPRB, 0.16847640E-05_JPRB, 0.16834809E-05_JPRB, 0.16826439E-05_JPRB, &
  & 0.16812227E-05_JPRB, 0.16793830E-05_JPRB, 0.16771662E-05_JPRB, 0.16746810E-05_JPRB, 0.16732738E-05_JPRB, 0.16727638E-05_JPRB, &
  & 0.16730281E-05_JPRB, 0.16736521E-05_JPRB, 0.16752694E-05_JPRB, 0.16774291E-05_JPRB, 0.16807193E-05_JPRB, 0.16839733E-05_JPRB, &
  & 0.16869215E-05_JPRB, 0.16897378E-05_JPRB, 0.16925854E-05_JPRB, 0.16949025E-05_JPRB, 0.16969480E-05_JPRB, 0.16997522E-05_JPRB, &
  & 0.17045874E-05_JPRB, 0.17115559E-05_JPRB, 0.17184225E-05_JPRB, 0.17233122E-05_JPRB, 0.17276704E-05_JPRB, 0.17306765E-05_JPRB, &
  & 0.17322870E-05_JPRB, 0.17338269E-05_JPRB, 0.17355506E-05_JPRB, 0.17376923E-05_JPRB, 0.17398004E-05_JPRB, 0.17434090E-05_JPRB, &
  & 0.17465986E-05_JPRB, 0.17511536E-05_JPRB, 0.17561902E-05_JPRB, 0.17620809E-05_JPRB, 0.17668714E-05_JPRB, 0.17701138E-05_JPRB, &
  & 0.17727690E-05_JPRB, 0.17748787E-05_JPRB, 0.17764240E-05_JPRB, 0.17774574E-05_JPRB, 0.17782988E-05_JPRB, 0.17789175E-05_JPRB, &
  & 0.17793375E-05_JPRB, 0.17791601E-05_JPRB, 0.17790695E-05_JPRB, 0.17793607E-05_JPRB, 0.17792458E-05_JPRB, 0.17790242E-05_JPRB, &
  & 0.17788016E-05_JPRB, 0.17795003E-05_JPRB, 0.17802781E-05_JPRB, 0.17807548E-05_JPRB  /)

RGHG2(:,58,12) = (/ &
  & 0.16933469E-05_JPRB, 0.16921591E-05_JPRB, 0.16916342E-05_JPRB, 0.16914437E-05_JPRB, 0.16910593E-05_JPRB, 0.16899712E-05_JPRB, &
  & 0.16876697E-05_JPRB, 0.16853002E-05_JPRB, 0.16837843E-05_JPRB, 0.16827370E-05_JPRB, 0.16814691E-05_JPRB, 0.16805741E-05_JPRB, &
  & 0.16791174E-05_JPRB, 0.16773224E-05_JPRB, 0.16753433E-05_JPRB, 0.16730572E-05_JPRB, 0.16717496E-05_JPRB, 0.16714336E-05_JPRB, &
  & 0.16717344E-05_JPRB, 0.16722559E-05_JPRB, 0.16738194E-05_JPRB, 0.16759871E-05_JPRB, 0.16793962E-05_JPRB, 0.16830139E-05_JPRB, &
  & 0.16861338E-05_JPRB, 0.16890821E-05_JPRB, 0.16920923E-05_JPRB, 0.16945404E-05_JPRB, 0.16969923E-05_JPRB, 0.17001245E-05_JPRB, &
  & 0.17049821E-05_JPRB, 0.17123164E-05_JPRB, 0.17191494E-05_JPRB, 0.17238045E-05_JPRB, 0.17279798E-05_JPRB, 0.17308660E-05_JPRB, &
  & 0.17324308E-05_JPRB, 0.17339555E-05_JPRB, 0.17356192E-05_JPRB, 0.17377010E-05_JPRB, 0.17399919E-05_JPRB, 0.17437042E-05_JPRB, &
  & 0.17472696E-05_JPRB, 0.17525205E-05_JPRB, 0.17578771E-05_JPRB, 0.17642117E-05_JPRB, 0.17694705E-05_JPRB, 0.17730380E-05_JPRB, &
  & 0.17758304E-05_JPRB, 0.17779167E-05_JPRB, 0.17794264E-05_JPRB, 0.17804415E-05_JPRB, 0.17813134E-05_JPRB, 0.17819057E-05_JPRB, &
  & 0.17823135E-05_JPRB, 0.17822875E-05_JPRB, 0.17824671E-05_JPRB, 0.17829726E-05_JPRB, 0.17829959E-05_JPRB, 0.17829135E-05_JPRB, &
  & 0.17827670E-05_JPRB, 0.17833560E-05_JPRB, 0.17838484E-05_JPRB, 0.17841128E-05_JPRB  /)

RGHG2(:,59,12) = (/ &
  & 0.16908993E-05_JPRB, 0.16899186E-05_JPRB, 0.16896023E-05_JPRB, 0.16894697E-05_JPRB, 0.16890492E-05_JPRB, 0.16881906E-05_JPRB, &
  & 0.16862268E-05_JPRB, 0.16840963E-05_JPRB, 0.16827254E-05_JPRB, 0.16816565E-05_JPRB, 0.16803765E-05_JPRB, 0.16794000E-05_JPRB, &
  & 0.16779112E-05_JPRB, 0.16761125E-05_JPRB, 0.16742087E-05_JPRB, 0.16719715E-05_JPRB, 0.16706086E-05_JPRB, 0.16703465E-05_JPRB, &
  & 0.16705488E-05_JPRB, 0.16708614E-05_JPRB, 0.16722607E-05_JPRB, 0.16743704E-05_JPRB, 0.16778219E-05_JPRB, 0.16817513E-05_JPRB, &
  & 0.16851012E-05_JPRB, 0.16881124E-05_JPRB, 0.16913835E-05_JPRB, 0.16940960E-05_JPRB, 0.16969140E-05_JPRB, 0.17004269E-05_JPRB, &
  & 0.17054585E-05_JPRB, 0.17130246E-05_JPRB, 0.17196683E-05_JPRB, 0.17239886E-05_JPRB, 0.17279596E-05_JPRB, 0.17310303E-05_JPRB, &
  & 0.17327137E-05_JPRB, 0.17342032E-05_JPRB, 0.17358401E-05_JPRB, 0.17379092E-05_JPRB, 0.17404281E-05_JPRB, 0.17441665E-05_JPRB, &
  & 0.17481207E-05_JPRB, 0.17536864E-05_JPRB, 0.17593743E-05_JPRB, 0.17661706E-05_JPRB, 0.17717503E-05_JPRB, 0.17754391E-05_JPRB, &
  & 0.17783065E-05_JPRB, 0.17803668E-05_JPRB, 0.17818113E-05_JPRB, 0.17828000E-05_JPRB, 0.17836570E-05_JPRB, 0.17842162E-05_JPRB, &
  & 0.17846196E-05_JPRB, 0.17847383E-05_JPRB, 0.17851570E-05_JPRB, 0.17858396E-05_JPRB, 0.17859728E-05_JPRB, 0.17860133E-05_JPRB, &
  & 0.17859007E-05_JPRB, 0.17863848E-05_JPRB, 0.17866802E-05_JPRB, 0.17867854E-05_JPRB  /)

RGHG2(:,60,12) = (/ &
  & 0.16888059E-05_JPRB, 0.16880713E-05_JPRB, 0.16879537E-05_JPRB, 0.16879024E-05_JPRB, 0.16874584E-05_JPRB, 0.16868158E-05_JPRB, &
  & 0.16851922E-05_JPRB, 0.16833255E-05_JPRB, 0.16820888E-05_JPRB, 0.16809773E-05_JPRB, 0.16796814E-05_JPRB, 0.16786128E-05_JPRB, &
  & 0.16770921E-05_JPRB, 0.16752713E-05_JPRB, 0.16733710E-05_JPRB, 0.16711149E-05_JPRB, 0.16696252E-05_JPRB, 0.16693305E-05_JPRB, &
  & 0.16693513E-05_JPRB, 0.16694042E-05_JPRB, 0.16705941E-05_JPRB, 0.16725908E-05_JPRB, 0.16760559E-05_JPRB, 0.16802776E-05_JPRB, &
  & 0.16838781E-05_JPRB, 0.16869414E-05_JPRB, 0.16904959E-05_JPRB, 0.16935366E-05_JPRB, 0.16967060E-05_JPRB, 0.17006336E-05_JPRB, &
  & 0.17060092E-05_JPRB, 0.17137389E-05_JPRB, 0.17200987E-05_JPRB, 0.17240653E-05_JPRB, 0.17278824E-05_JPRB, 0.17312428E-05_JPRB, &
  & 0.17330833E-05_JPRB, 0.17345340E-05_JPRB, 0.17361572E-05_JPRB, 0.17382281E-05_JPRB, 0.17409664E-05_JPRB, 0.17447110E-05_JPRB, &
  & 0.17490845E-05_JPRB, 0.17548114E-05_JPRB, 0.17608689E-05_JPRB, 0.17681284E-05_JPRB, 0.17739419E-05_JPRB, 0.17776721E-05_JPRB, &
  & 0.17805854E-05_JPRB, 0.17826175E-05_JPRB, 0.17839896E-05_JPRB, 0.17849494E-05_JPRB, 0.17857747E-05_JPRB, 0.17863017E-05_JPRB, &
  & 0.17867105E-05_JPRB, 0.17869779E-05_JPRB, 0.17876192E-05_JPRB, 0.17884578E-05_JPRB, 0.17887001E-05_JPRB, 0.17888657E-05_JPRB, &
  & 0.17887765E-05_JPRB, 0.17891664E-05_JPRB, 0.17893054E-05_JPRB, 0.17892735E-05_JPRB  /)

RGHG2(:,61,12) = (/ &
  & 0.16874856E-05_JPRB, 0.16870087E-05_JPRB, 0.16870255E-05_JPRB, 0.16870624E-05_JPRB, 0.16866206E-05_JPRB, 0.16861212E-05_JPRB, &
  & 0.16847707E-05_JPRB, 0.16831639E-05_JPRB, 0.16820308E-05_JPRB, 0.16808443E-05_JPRB, 0.16795551E-05_JPRB, 0.16783962E-05_JPRB, &
  & 0.16768446E-05_JPRB, 0.16749907E-05_JPRB, 0.16730068E-05_JPRB, 0.16706494E-05_JPRB, 0.16689569E-05_JPRB, 0.16684596E-05_JPRB, &
  & 0.16681610E-05_JPRB, 0.16679231E-05_JPRB, 0.16688927E-05_JPRB, 0.16706537E-05_JPRB, 0.16741100E-05_JPRB, 0.16785630E-05_JPRB, &
  & 0.16823838E-05_JPRB, 0.16855352E-05_JPRB, 0.16892946E-05_JPRB, 0.16927009E-05_JPRB, 0.16961567E-05_JPRB, 0.17005051E-05_JPRB, &
  & 0.17066715E-05_JPRB, 0.17144299E-05_JPRB, 0.17203623E-05_JPRB, 0.17240821E-05_JPRB, 0.17280028E-05_JPRB, 0.17316496E-05_JPRB, &
  & 0.17335716E-05_JPRB, 0.17350003E-05_JPRB, 0.17366234E-05_JPRB, 0.17386943E-05_JPRB, 0.17415251E-05_JPRB, 0.17452918E-05_JPRB, &
  & 0.17501257E-05_JPRB, 0.17558438E-05_JPRB, 0.17623529E-05_JPRB, 0.17699847E-05_JPRB, 0.17758269E-05_JPRB, 0.17795240E-05_JPRB, &
  & 0.17824351E-05_JPRB, 0.17844386E-05_JPRB, 0.17857578E-05_JPRB, 0.17866933E-05_JPRB, 0.17874812E-05_JPRB, 0.17879927E-05_JPRB, &
  & 0.17884368E-05_JPRB, 0.17888541E-05_JPRB, 0.17896539E-05_JPRB, 0.17905850E-05_JPRB, 0.17909507E-05_JPRB, 0.17912507E-05_JPRB, &
  & 0.17911923E-05_JPRB, 0.17915403E-05_JPRB, 0.17916023E-05_JPRB, 0.17914778E-05_JPRB  /)

RGHG2(:,62,12) = (/ &
  & 0.16866451E-05_JPRB, 0.16864016E-05_JPRB, 0.16864935E-05_JPRB, 0.16866196E-05_JPRB, 0.16862143E-05_JPRB, 0.16857910E-05_JPRB, &
  & 0.16846652E-05_JPRB, 0.16832941E-05_JPRB, 0.16822597E-05_JPRB, 0.16810138E-05_JPRB, 0.16797151E-05_JPRB, 0.16784956E-05_JPRB, &
  & 0.16768926E-05_JPRB, 0.16749835E-05_JPRB, 0.16728871E-05_JPRB, 0.16703876E-05_JPRB, 0.16685088E-05_JPRB, 0.16676997E-05_JPRB, &
  & 0.16670225E-05_JPRB, 0.16664601E-05_JPRB, 0.16671567E-05_JPRB, 0.16686240E-05_JPRB, 0.16720418E-05_JPRB, 0.16766372E-05_JPRB, &
  & 0.16805793E-05_JPRB, 0.16838576E-05_JPRB, 0.16877778E-05_JPRB, 0.16914098E-05_JPRB, 0.16951791E-05_JPRB, 0.17000154E-05_JPRB, &
  & 0.17070795E-05_JPRB, 0.17150517E-05_JPRB, 0.17207094E-05_JPRB, 0.17244552E-05_JPRB, 0.17284158E-05_JPRB, 0.17320955E-05_JPRB, &
  & 0.17340723E-05_JPRB, 0.17355614E-05_JPRB, 0.17372466E-05_JPRB, 0.17394023E-05_JPRB, 0.17422160E-05_JPRB, 0.17459467E-05_JPRB, &
  & 0.17512068E-05_JPRB, 0.17569729E-05_JPRB, 0.17639006E-05_JPRB, 0.17718073E-05_JPRB, 0.17775209E-05_JPRB, 0.17811822E-05_JPRB, &
  & 0.17840715E-05_JPRB, 0.17860504E-05_JPRB, 0.17873427E-05_JPRB, 0.17882646E-05_JPRB, 0.17890319E-05_JPRB, 0.17895519E-05_JPRB, &
  & 0.17900275E-05_JPRB, 0.17905781E-05_JPRB, 0.17915074E-05_JPRB, 0.17925307E-05_JPRB, 0.17930205E-05_JPRB, 0.17934493E-05_JPRB, &
  & 0.17934765E-05_JPRB, 0.17938352E-05_JPRB, 0.17938241E-05_JPRB, 0.17935112E-05_JPRB  /)

RGHG2(:,63,12) = (/ &
  & 0.16861172E-05_JPRB, 0.16860942E-05_JPRB, 0.16862191E-05_JPRB, 0.16864324E-05_JPRB, 0.16860888E-05_JPRB, 0.16856940E-05_JPRB, &
  & 0.16847657E-05_JPRB, 0.16836091E-05_JPRB, 0.16826744E-05_JPRB, 0.16813939E-05_JPRB, 0.16800702E-05_JPRB, 0.16787984E-05_JPRB, &
  & 0.16771341E-05_JPRB, 0.16751463E-05_JPRB, 0.16729232E-05_JPRB, 0.16702797E-05_JPRB, 0.16682184E-05_JPRB, 0.16670211E-05_JPRB, &
  & 0.16659360E-05_JPRB, 0.16650247E-05_JPRB, 0.16653879E-05_JPRB, 0.16665561E-05_JPRB, 0.16698899E-05_JPRB, 0.16745004E-05_JPRB, &
  & 0.16784622E-05_JPRB, 0.16819000E-05_JPRB, 0.16859428E-05_JPRB, 0.16897701E-05_JPRB, 0.16938343E-05_JPRB, 0.16992096E-05_JPRB, &
  & 0.17071389E-05_JPRB, 0.17154453E-05_JPRB, 0.17209865E-05_JPRB, 0.17249436E-05_JPRB, 0.17289100E-05_JPRB, 0.17325445E-05_JPRB, &
  & 0.17346031E-05_JPRB, 0.17362050E-05_JPRB, 0.17380042E-05_JPRB, 0.17403552E-05_JPRB, 0.17430187E-05_JPRB, 0.17467194E-05_JPRB, &
  & 0.17523823E-05_JPRB, 0.17582271E-05_JPRB, 0.17655010E-05_JPRB, 0.17735925E-05_JPRB, 0.17791079E-05_JPRB, 0.17827336E-05_JPRB, &
  & 0.17855922E-05_JPRB, 0.17875545E-05_JPRB, 0.17888310E-05_JPRB, 0.17897470E-05_JPRB, 0.17905077E-05_JPRB, 0.17910501E-05_JPRB, &
  & 0.17915459E-05_JPRB, 0.17922172E-05_JPRB, 0.17932683E-05_JPRB, 0.17943859E-05_JPRB, 0.17949968E-05_JPRB, 0.17955372E-05_JPRB, &
  & 0.17956970E-05_JPRB, 0.17960922E-05_JPRB, 0.17959940E-05_JPRB, 0.17954245E-05_JPRB  /)

RGHG2(:,64,12) = (/ &
  & 0.16858967E-05_JPRB, 0.16860785E-05_JPRB, 0.16861913E-05_JPRB, 0.16864817E-05_JPRB, 0.16862248E-05_JPRB, 0.16858084E-05_JPRB, &
  & 0.16850511E-05_JPRB, 0.16840728E-05_JPRB, 0.16832417E-05_JPRB, 0.16819732E-05_JPRB, 0.16806038E-05_JPRB, 0.16792718E-05_JPRB, &
  & 0.16775448E-05_JPRB, 0.16754462E-05_JPRB, 0.16730954E-05_JPRB, 0.16703507E-05_JPRB, 0.16681062E-05_JPRB, 0.16664585E-05_JPRB, &
  & 0.16649685E-05_JPRB, 0.16636958E-05_JPRB, 0.16636423E-05_JPRB, 0.16645695E-05_JPRB, 0.16677395E-05_JPRB, 0.16721379E-05_JPRB, &
  & 0.16759673E-05_JPRB, 0.16796002E-05_JPRB, 0.16837105E-05_JPRB, 0.16877931E-05_JPRB, 0.16920670E-05_JPRB, 0.16980181E-05_JPRB, &
  & 0.17065883E-05_JPRB, 0.17153260E-05_JPRB, 0.17209924E-05_JPRB, 0.17253350E-05_JPRB, 0.17292870E-05_JPRB, 0.17329431E-05_JPRB, &
  & 0.17351752E-05_JPRB, 0.17369313E-05_JPRB, 0.17389064E-05_JPRB, 0.17416332E-05_JPRB, 0.17439329E-05_JPRB, 0.17476794E-05_JPRB, &
  & 0.17537061E-05_JPRB, 0.17596449E-05_JPRB, 0.17671043E-05_JPRB, 0.17752489E-05_JPRB, 0.17805619E-05_JPRB, 0.17841563E-05_JPRB, &
  & 0.17869835E-05_JPRB, 0.17889458E-05_JPRB, 0.17902079E-05_JPRB, 0.17911262E-05_JPRB, 0.17918990E-05_JPRB, 0.17924728E-05_JPRB, &
  & 0.17929637E-05_JPRB, 0.17937362E-05_JPRB, 0.17949150E-05_JPRB, 0.17961290E-05_JPRB, 0.17968483E-05_JPRB, 0.17974586E-05_JPRB, &
  & 0.17978063E-05_JPRB, 0.17982473E-05_JPRB, 0.17980262E-05_JPRB, 0.17971387E-05_JPRB  /)

RGHG2(:,65,12) = (/ &
  & 0.16859275E-05_JPRB, 0.16862775E-05_JPRB, 0.16863783E-05_JPRB, 0.16866903E-05_JPRB, 0.16865253E-05_JPRB, 0.16860690E-05_JPRB, &
  & 0.16854438E-05_JPRB, 0.16846383E-05_JPRB, 0.16839162E-05_JPRB, 0.16826553E-05_JPRB, 0.16812465E-05_JPRB, 0.16798291E-05_JPRB, &
  & 0.16780278E-05_JPRB, 0.16758130E-05_JPRB, 0.16733739E-05_JPRB, 0.16705968E-05_JPRB, 0.16681118E-05_JPRB, 0.16660347E-05_JPRB, &
  & 0.16641436E-05_JPRB, 0.16625673E-05_JPRB, 0.16621140E-05_JPRB, 0.16628051E-05_JPRB, 0.16656486E-05_JPRB, 0.16696562E-05_JPRB, &
  & 0.16733857E-05_JPRB, 0.16770673E-05_JPRB, 0.16810998E-05_JPRB, 0.16854218E-05_JPRB, 0.16898239E-05_JPRB, 0.16962633E-05_JPRB, &
  & 0.17054949E-05_JPRB, 0.17144250E-05_JPRB, 0.17207424E-05_JPRB, 0.17254241E-05_JPRB, 0.17294579E-05_JPRB, 0.17332100E-05_JPRB, &
  & 0.17357626E-05_JPRB, 0.17377032E-05_JPRB, 0.17398152E-05_JPRB, 0.17428826E-05_JPRB, 0.17449749E-05_JPRB, 0.17489335E-05_JPRB, &
  & 0.17553447E-05_JPRB, 0.17613176E-05_JPRB, 0.17686769E-05_JPRB, 0.17766820E-05_JPRB, 0.17818830E-05_JPRB, 0.17854750E-05_JPRB, &
  & 0.17882999E-05_JPRB, 0.17902330E-05_JPRB, 0.17914962E-05_JPRB, 0.17923968E-05_JPRB, 0.17932064E-05_JPRB, 0.17938117E-05_JPRB, &
  & 0.17942888E-05_JPRB, 0.17951319E-05_JPRB, 0.17964573E-05_JPRB, 0.17977505E-05_JPRB, 0.17985431E-05_JPRB, 0.17991947E-05_JPRB, &
  & 0.17997497E-05_JPRB, 0.18002502E-05_JPRB, 0.17998426E-05_JPRB, 0.17987310E-05_JPRB  /)

RGHG2(:,66,12) = (/ &
  & 0.16860923E-05_JPRB, 0.16865731E-05_JPRB, 0.16866728E-05_JPRB, 0.16869766E-05_JPRB, 0.16868882E-05_JPRB, 0.16864071E-05_JPRB, &
  & 0.16858799E-05_JPRB, 0.16852549E-05_JPRB, 0.16846351E-05_JPRB, 0.16833689E-05_JPRB, 0.16819278E-05_JPRB, 0.16804330E-05_JPRB, &
  & 0.16785497E-05_JPRB, 0.16762196E-05_JPRB, 0.16737168E-05_JPRB, 0.16708943E-05_JPRB, 0.16681535E-05_JPRB, 0.16656938E-05_JPRB, &
  & 0.16634091E-05_JPRB, 0.16615638E-05_JPRB, 0.16606854E-05_JPRB, 0.16611010E-05_JPRB, 0.16635926E-05_JPRB, 0.16671989E-05_JPRB, &
  & 0.16709344E-05_JPRB, 0.16745229E-05_JPRB, 0.16784191E-05_JPRB, 0.16828539E-05_JPRB, 0.16874243E-05_JPRB, 0.16942270E-05_JPRB, &
  & 0.17037778E-05_JPRB, 0.17130423E-05_JPRB, 0.17203254E-05_JPRB, 0.17254812E-05_JPRB, 0.17295708E-05_JPRB, 0.17334248E-05_JPRB, &
  & 0.17362908E-05_JPRB, 0.17384394E-05_JPRB, 0.17406331E-05_JPRB, 0.17438394E-05_JPRB, 0.17460201E-05_JPRB, 0.17503716E-05_JPRB, &
  & 0.17571743E-05_JPRB, 0.17631217E-05_JPRB, 0.17702410E-05_JPRB, 0.17779995E-05_JPRB, 0.17831455E-05_JPRB, 0.17867487E-05_JPRB, &
  & 0.17896033E-05_JPRB, 0.17915058E-05_JPRB, 0.17927573E-05_JPRB, 0.17936397E-05_JPRB, 0.17944774E-05_JPRB, 0.17951175E-05_JPRB, &
  & 0.17955968E-05_JPRB, 0.17964989E-05_JPRB, 0.17979816E-05_JPRB, 0.17993522E-05_JPRB, 0.18001767E-05_JPRB, 0.18008747E-05_JPRB, &
  & 0.18016415E-05_JPRB, 0.18022290E-05_JPRB, 0.18016311E-05_JPRB, 0.18003752E-05_JPRB  /)

RGHG2(:,67,12) = (/ &
  & 0.16863695E-05_JPRB, 0.16869429E-05_JPRB, 0.16870542E-05_JPRB, 0.16873260E-05_JPRB, 0.16872961E-05_JPRB, 0.16868079E-05_JPRB, &
  & 0.16863484E-05_JPRB, 0.16858990E-05_JPRB, 0.16853746E-05_JPRB, 0.16840941E-05_JPRB, 0.16826222E-05_JPRB, 0.16810706E-05_JPRB, &
  & 0.16791096E-05_JPRB, 0.16766679E-05_JPRB, 0.16741134E-05_JPRB, 0.16712231E-05_JPRB, 0.16682215E-05_JPRB, 0.16654337E-05_JPRB, &
  & 0.16627854E-05_JPRB, 0.16606938E-05_JPRB, 0.16593691E-05_JPRB, 0.16594741E-05_JPRB, 0.16616240E-05_JPRB, 0.16648245E-05_JPRB, &
  & 0.16686323E-05_JPRB, 0.16720445E-05_JPRB, 0.16757268E-05_JPRB, 0.16801838E-05_JPRB, 0.16849769E-05_JPRB, 0.16920580E-05_JPRB, &
  & 0.17015971E-05_JPRB, 0.17113167E-05_JPRB, 0.17197404E-05_JPRB, 0.17255614E-05_JPRB, 0.17296503E-05_JPRB, 0.17336220E-05_JPRB, &
  & 0.17367678E-05_JPRB, 0.17391518E-05_JPRB, 0.17413256E-05_JPRB, 0.17444992E-05_JPRB, 0.17470601E-05_JPRB, 0.17519703E-05_JPRB, &
  & 0.17591465E-05_JPRB, 0.17650163E-05_JPRB, 0.17717819E-05_JPRB, 0.17792301E-05_JPRB, 0.17843486E-05_JPRB, 0.17879830E-05_JPRB, &
  & 0.17908847E-05_JPRB, 0.17927557E-05_JPRB, 0.17939856E-05_JPRB, 0.17948602E-05_JPRB, 0.17957123E-05_JPRB, 0.17963920E-05_JPRB, &
  & 0.17968945E-05_JPRB, 0.17978492E-05_JPRB, 0.17994768E-05_JPRB, 0.18009355E-05_JPRB, 0.18017613E-05_JPRB, 0.18025095E-05_JPRB, &
  & 0.18034791E-05_JPRB, 0.18041833E-05_JPRB, 0.18034276E-05_JPRB, 0.18021118E-05_JPRB  /)

RGHG2(:,68,12) = (/ &
  & 0.16867330E-05_JPRB, 0.16873633E-05_JPRB, 0.16874994E-05_JPRB, 0.16877242E-05_JPRB, 0.16877338E-05_JPRB, 0.16872555E-05_JPRB, &
  & 0.16868430E-05_JPRB, 0.16865371E-05_JPRB, 0.16861042E-05_JPRB, 0.16848114E-05_JPRB, 0.16832974E-05_JPRB, 0.16817285E-05_JPRB, &
  & 0.16797180E-05_JPRB, 0.16771725E-05_JPRB, 0.16745511E-05_JPRB, 0.16715668E-05_JPRB, 0.16683104E-05_JPRB, 0.16652530E-05_JPRB, &
  & 0.16623127E-05_JPRB, 0.16599712E-05_JPRB, 0.16581914E-05_JPRB, 0.16579674E-05_JPRB, 0.16598302E-05_JPRB, 0.16625954E-05_JPRB, &
  & 0.16664377E-05_JPRB, 0.16697188E-05_JPRB, 0.16730524E-05_JPRB, 0.16775464E-05_JPRB, 0.16826241E-05_JPRB, 0.16900020E-05_JPRB, &
  & 0.16993135E-05_JPRB, 0.17094858E-05_JPRB, 0.17189683E-05_JPRB, 0.17257320E-05_JPRB, 0.17297244E-05_JPRB, 0.17338643E-05_JPRB, &
  & 0.17372352E-05_JPRB, 0.17398939E-05_JPRB, 0.17418524E-05_JPRB, 0.17449295E-05_JPRB, 0.17481164E-05_JPRB, 0.17537143E-05_JPRB, &
  & 0.17611997E-05_JPRB, 0.17669582E-05_JPRB, 0.17732859E-05_JPRB, 0.17804372E-05_JPRB, 0.17854963E-05_JPRB, 0.17891975E-05_JPRB, &
  & 0.17921315E-05_JPRB, 0.17939653E-05_JPRB, 0.17951754E-05_JPRB, 0.17960722E-05_JPRB, 0.17969219E-05_JPRB, 0.17976486E-05_JPRB, &
  & 0.17982006E-05_JPRB, 0.17992097E-05_JPRB, 0.18009239E-05_JPRB, 0.18025063E-05_JPRB, 0.18033296E-05_JPRB, 0.18041224E-05_JPRB, &
  & 0.18052627E-05_JPRB, 0.18061152E-05_JPRB, 0.18052977E-05_JPRB, 0.18040141E-05_JPRB  /)

RGHG2(:,69,12) = (/ &
  & 0.16871656E-05_JPRB, 0.16878100E-05_JPRB, 0.16879911E-05_JPRB, 0.16881509E-05_JPRB, 0.16881798E-05_JPRB, 0.16877182E-05_JPRB, &
  & 0.16873460E-05_JPRB, 0.16871452E-05_JPRB, 0.16867746E-05_JPRB, 0.16854829E-05_JPRB, 0.16839201E-05_JPRB, 0.16823699E-05_JPRB, &
  & 0.16803595E-05_JPRB, 0.16777235E-05_JPRB, 0.16750332E-05_JPRB, 0.16719301E-05_JPRB, 0.16684257E-05_JPRB, 0.16651977E-05_JPRB, &
  & 0.16620174E-05_JPRB, 0.16594621E-05_JPRB, 0.16573014E-05_JPRB, 0.16567417E-05_JPRB, 0.16583041E-05_JPRB, 0.16605911E-05_JPRB, &
  & 0.16641574E-05_JPRB, 0.16674380E-05_JPRB, 0.16704002E-05_JPRB, 0.16751566E-05_JPRB, 0.16805750E-05_JPRB, 0.16884343E-05_JPRB, &
  & 0.16982568E-05_JPRB, 0.17087377E-05_JPRB, 0.17186259E-05_JPRB, 0.17258230E-05_JPRB, 0.17298068E-05_JPRB, 0.17341779E-05_JPRB, &
  & 0.17378167E-05_JPRB, 0.17406306E-05_JPRB, 0.17424933E-05_JPRB, 0.17455978E-05_JPRB, 0.17494149E-05_JPRB, 0.17555946E-05_JPRB, &
  & 0.17632835E-05_JPRB, 0.17688811E-05_JPRB, 0.17747530E-05_JPRB, 0.17817155E-05_JPRB, 0.17866703E-05_JPRB, 0.17904022E-05_JPRB, &
  & 0.17933863E-05_JPRB, 0.17951808E-05_JPRB, 0.17963801E-05_JPRB, 0.17973037E-05_JPRB, 0.17981689E-05_JPRB, 0.17989741E-05_JPRB, &
  & 0.17995553E-05_JPRB, 0.18006121E-05_JPRB, 0.18023273E-05_JPRB, 0.18040559E-05_JPRB, 0.18049060E-05_JPRB, 0.18057681E-05_JPRB, &
  & 0.18070092E-05_JPRB, 0.18080350E-05_JPRB, 0.18072975E-05_JPRB, 0.18059830E-05_JPRB  /)

RGHG2(:,70,12) = (/ &
  & 0.16876320E-05_JPRB, 0.16882749E-05_JPRB, 0.16884901E-05_JPRB, 0.16885945E-05_JPRB, 0.16886221E-05_JPRB, 0.16881807E-05_JPRB, &
  & 0.16878567E-05_JPRB, 0.16877447E-05_JPRB, 0.16873918E-05_JPRB, 0.16861156E-05_JPRB, 0.16845104E-05_JPRB, 0.16829911E-05_JPRB, &
  & 0.16810015E-05_JPRB, 0.16782979E-05_JPRB, 0.16755510E-05_JPRB, 0.16723366E-05_JPRB, 0.16686318E-05_JPRB, 0.16652815E-05_JPRB, &
  & 0.16618815E-05_JPRB, 0.16591242E-05_JPRB, 0.16566008E-05_JPRB, 0.16557112E-05_JPRB, 0.16569468E-05_JPRB, 0.16587347E-05_JPRB, &
  & 0.16617996E-05_JPRB, 0.16651285E-05_JPRB, 0.16678517E-05_JPRB, 0.16729304E-05_JPRB, 0.16789071E-05_JPRB, 0.16874713E-05_JPRB, &
  & 0.16980238E-05_JPRB, 0.17087392E-05_JPRB, 0.17184261E-05_JPRB, 0.17258061E-05_JPRB, 0.17300012E-05_JPRB, 0.17346778E-05_JPRB, &
  & 0.17386079E-05_JPRB, 0.17414951E-05_JPRB, 0.17433497E-05_JPRB, 0.17465773E-05_JPRB, 0.17509804E-05_JPRB, 0.17576334E-05_JPRB, &
  & 0.17653890E-05_JPRB, 0.17707430E-05_JPRB, 0.17761894E-05_JPRB, 0.17830799E-05_JPRB, 0.17878897E-05_JPRB, 0.17916489E-05_JPRB, &
  & 0.17946692E-05_JPRB, 0.17964471E-05_JPRB, 0.17976408E-05_JPRB, 0.17986060E-05_JPRB, 0.17994929E-05_JPRB, 0.18003755E-05_JPRB, &
  & 0.18009552E-05_JPRB, 0.18020361E-05_JPRB, 0.18037266E-05_JPRB, 0.18055824E-05_JPRB, 0.18065240E-05_JPRB, 0.18074738E-05_JPRB, &
  & 0.18087545E-05_JPRB, 0.18099332E-05_JPRB, 0.18093028E-05_JPRB, 0.18078275E-05_JPRB  /)

RGHG2(:,71,12) = (/ &
  & 0.16881144E-05_JPRB, 0.16887517E-05_JPRB, 0.16889755E-05_JPRB, 0.16890397E-05_JPRB, 0.16890505E-05_JPRB, 0.16886395E-05_JPRB, &
  & 0.16883713E-05_JPRB, 0.16883299E-05_JPRB, 0.16879546E-05_JPRB, 0.16867057E-05_JPRB, 0.16850720E-05_JPRB, 0.16835937E-05_JPRB, &
  & 0.16816400E-05_JPRB, 0.16788899E-05_JPRB, 0.16761042E-05_JPRB, 0.16728068E-05_JPRB, 0.16689516E-05_JPRB, 0.16655152E-05_JPRB, &
  & 0.16619152E-05_JPRB, 0.16589302E-05_JPRB, 0.16560624E-05_JPRB, 0.16548737E-05_JPRB, 0.16557642E-05_JPRB, 0.16570379E-05_JPRB, &
  & 0.16594522E-05_JPRB, 0.16628174E-05_JPRB, 0.16654616E-05_JPRB, 0.16709041E-05_JPRB, 0.16776563E-05_JPRB, 0.16870737E-05_JPRB, &
  & 0.16984109E-05_JPRB, 0.17093028E-05_JPRB, 0.17184023E-05_JPRB, 0.17257540E-05_JPRB, 0.17303689E-05_JPRB, 0.17354530E-05_JPRB, &
  & 0.17396399E-05_JPRB, 0.17425781E-05_JPRB, 0.17444716E-05_JPRB, 0.17478720E-05_JPRB, 0.17527785E-05_JPRB, 0.17598573E-05_JPRB, &
  & 0.17674822E-05_JPRB, 0.17725188E-05_JPRB, 0.17776149E-05_JPRB, 0.17845128E-05_JPRB, 0.17891559E-05_JPRB, 0.17929449E-05_JPRB, &
  & 0.17959969E-05_JPRB, 0.17977891E-05_JPRB, 0.17989828E-05_JPRB, 0.18000038E-05_JPRB, 0.18009248E-05_JPRB, 0.18018625E-05_JPRB, &
  & 0.18024130E-05_JPRB, 0.18034827E-05_JPRB, 0.18051466E-05_JPRB, 0.18071001E-05_JPRB, 0.18081806E-05_JPRB, 0.18092363E-05_JPRB, &
  & 0.18105083E-05_JPRB, 0.18118389E-05_JPRB, 0.18113213E-05_JPRB, 0.18095763E-05_JPRB  /)

RGHG2(:,72,12) = (/ &
  & 0.16885876E-05_JPRB, 0.16892323E-05_JPRB, 0.16894165E-05_JPRB, 0.16894608E-05_JPRB, 0.16894494E-05_JPRB, 0.16890928E-05_JPRB, &
  & 0.16888841E-05_JPRB, 0.16888872E-05_JPRB, 0.16884600E-05_JPRB, 0.16872457E-05_JPRB, 0.16856096E-05_JPRB, 0.16841832E-05_JPRB, &
  & 0.16822766E-05_JPRB, 0.16794968E-05_JPRB, 0.16766962E-05_JPRB, 0.16733790E-05_JPRB, 0.16694198E-05_JPRB, 0.16659215E-05_JPRB, &
  & 0.16621456E-05_JPRB, 0.16588388E-05_JPRB, 0.16556564E-05_JPRB, 0.16542449E-05_JPRB, 0.16547887E-05_JPRB, 0.16555373E-05_JPRB, &
  & 0.16572755E-05_JPRB, 0.16605640E-05_JPRB, 0.16633147E-05_JPRB, 0.16691634E-05_JPRB, 0.16768814E-05_JPRB, 0.16871531E-05_JPRB, &
  & 0.16991243E-05_JPRB, 0.17101499E-05_JPRB, 0.17186848E-05_JPRB, 0.17258136E-05_JPRB, 0.17310130E-05_JPRB, 0.17366616E-05_JPRB, &
  & 0.17409625E-05_JPRB, 0.17440368E-05_JPRB, 0.17459453E-05_JPRB, 0.17494868E-05_JPRB, 0.17547499E-05_JPRB, 0.17623265E-05_JPRB, &
  & 0.17695056E-05_JPRB, 0.17741732E-05_JPRB, 0.17790712E-05_JPRB, 0.17859840E-05_JPRB, 0.17904735E-05_JPRB, 0.17942997E-05_JPRB, &
  & 0.17974036E-05_JPRB, 0.17992528E-05_JPRB, 0.18004539E-05_JPRB, 0.18015418E-05_JPRB, 0.18025247E-05_JPRB, 0.18034599E-05_JPRB, &
  & 0.18039609E-05_JPRB, 0.18049637E-05_JPRB, 0.18066326E-05_JPRB, 0.18086431E-05_JPRB, 0.18098697E-05_JPRB, 0.18110517E-05_JPRB, &
  & 0.18122890E-05_JPRB, 0.18138178E-05_JPRB, 0.18134016E-05_JPRB, 0.18113298E-05_JPRB  /)

RGHG2(:,73,12) = (/ &
  & 0.16890432E-05_JPRB, 0.16896678E-05_JPRB, 0.16897938E-05_JPRB, 0.16898113E-05_JPRB, 0.16898073E-05_JPRB, 0.16895378E-05_JPRB, &
  & 0.16893796E-05_JPRB, 0.16894023E-05_JPRB, 0.16889250E-05_JPRB, 0.16877272E-05_JPRB, 0.16861277E-05_JPRB, 0.16847582E-05_JPRB, &
  & 0.16829035E-05_JPRB, 0.16801375E-05_JPRB, 0.16773449E-05_JPRB, 0.16740837E-05_JPRB, 0.16701003E-05_JPRB, 0.16665259E-05_JPRB, &
  & 0.16626123E-05_JPRB, 0.16588966E-05_JPRB, 0.16554876E-05_JPRB, 0.16539231E-05_JPRB, 0.16541688E-05_JPRB, 0.16543618E-05_JPRB, &
  & 0.16556452E-05_JPRB, 0.16585876E-05_JPRB, 0.16615258E-05_JPRB, 0.16675738E-05_JPRB, 0.16762173E-05_JPRB, 0.16872242E-05_JPRB, &
  & 0.16997640E-05_JPRB, 0.17109725E-05_JPRB, 0.17191325E-05_JPRB, 0.17257453E-05_JPRB, 0.17316772E-05_JPRB, 0.17383811E-05_JPRB, &
  & 0.17427459E-05_JPRB, 0.17459849E-05_JPRB, 0.17479358E-05_JPRB, 0.17513895E-05_JPRB, 0.17568826E-05_JPRB, 0.17650724E-05_JPRB, &
  & 0.17713779E-05_JPRB, 0.17756905E-05_JPRB, 0.17807110E-05_JPRB, 0.17875491E-05_JPRB, 0.17919210E-05_JPRB, 0.17957891E-05_JPRB, &
  & 0.17989316E-05_JPRB, 0.18009024E-05_JPRB, 0.18020973E-05_JPRB, 0.18032777E-05_JPRB, 0.18043389E-05_JPRB, 0.18051958E-05_JPRB, &
  & 0.18056240E-05_JPRB, 0.18065687E-05_JPRB, 0.18083069E-05_JPRB, 0.18104046E-05_JPRB, 0.18117276E-05_JPRB, 0.18129263E-05_JPRB, &
  & 0.18141724E-05_JPRB, 0.18159142E-05_JPRB, 0.18156347E-05_JPRB, 0.18134133E-05_JPRB  /)

RGHG2(:,74,12) = (/ &
  & 0.16894860E-05_JPRB, 0.16900553E-05_JPRB, 0.16901349E-05_JPRB, 0.16901221E-05_JPRB, 0.16901445E-05_JPRB, 0.16899661E-05_JPRB, &
  & 0.16898397E-05_JPRB, 0.16898754E-05_JPRB, 0.16893633E-05_JPRB, 0.16881714E-05_JPRB, 0.16866282E-05_JPRB, 0.16853160E-05_JPRB, &
  & 0.16835255E-05_JPRB, 0.16807964E-05_JPRB, 0.16780421E-05_JPRB, 0.16748521E-05_JPRB, 0.16709021E-05_JPRB, 0.16672671E-05_JPRB, &
  & 0.16632579E-05_JPRB, 0.16591369E-05_JPRB, 0.16555941E-05_JPRB, 0.16539201E-05_JPRB, 0.16538571E-05_JPRB, 0.16535149E-05_JPRB, &
  & 0.16544405E-05_JPRB, 0.16569860E-05_JPRB, 0.16600631E-05_JPRB, 0.16661492E-05_JPRB, 0.16752891E-05_JPRB, 0.16870039E-05_JPRB, &
  & 0.17001797E-05_JPRB, 0.17116166E-05_JPRB, 0.17192971E-05_JPRB, 0.17253562E-05_JPRB, 0.17324198E-05_JPRB, 0.17403146E-05_JPRB, &
  & 0.17448260E-05_JPRB, 0.17482691E-05_JPRB, 0.17503591E-05_JPRB, 0.17536354E-05_JPRB, 0.17593834E-05_JPRB, 0.17678756E-05_JPRB, &
  & 0.17731679E-05_JPRB, 0.17772989E-05_JPRB, 0.17825076E-05_JPRB, 0.17891709E-05_JPRB, 0.17934791E-05_JPRB, 0.17973731E-05_JPRB, &
  & 0.18005634E-05_JPRB, 0.18026268E-05_JPRB, 0.18038096E-05_JPRB, 0.18050817E-05_JPRB, 0.18062465E-05_JPRB, 0.18070217E-05_JPRB, &
  & 0.18073693E-05_JPRB, 0.18082822E-05_JPRB, 0.18101055E-05_JPRB, 0.18123362E-05_JPRB, 0.18136899E-05_JPRB, 0.18148872E-05_JPRB, &
  & 0.18162235E-05_JPRB, 0.18181883E-05_JPRB, 0.18181484E-05_JPRB, 0.18157567E-05_JPRB  /)

RGHG2(:,75,12) = (/ &
  & 0.16899017E-05_JPRB, 0.16903907E-05_JPRB, 0.16904351E-05_JPRB, 0.16904023E-05_JPRB, 0.16904634E-05_JPRB, 0.16903699E-05_JPRB, &
  & 0.16902566E-05_JPRB, 0.16903035E-05_JPRB, 0.16897742E-05_JPRB, 0.16885803E-05_JPRB, 0.16871040E-05_JPRB, 0.16858448E-05_JPRB, &
  & 0.16841305E-05_JPRB, 0.16814606E-05_JPRB, 0.16787690E-05_JPRB, 0.16756580E-05_JPRB, 0.16717819E-05_JPRB, 0.16681232E-05_JPRB, &
  & 0.16640651E-05_JPRB, 0.16595853E-05_JPRB, 0.16559730E-05_JPRB, 0.16542078E-05_JPRB, 0.16538283E-05_JPRB, 0.16530009E-05_JPRB, &
  & 0.16536136E-05_JPRB, 0.16556738E-05_JPRB, 0.16588143E-05_JPRB, 0.16648530E-05_JPRB, 0.16740355E-05_JPRB, 0.16863104E-05_JPRB, &
  & 0.17002224E-05_JPRB, 0.17120091E-05_JPRB, 0.17191625E-05_JPRB, 0.17247496E-05_JPRB, 0.17332534E-05_JPRB, 0.17424160E-05_JPRB, &
  & 0.17471296E-05_JPRB, 0.17508128E-05_JPRB, 0.17531258E-05_JPRB, 0.17563096E-05_JPRB, 0.17622644E-05_JPRB, 0.17707198E-05_JPRB, &
  & 0.17749485E-05_JPRB, 0.17790413E-05_JPRB, 0.17844252E-05_JPRB, 0.17908471E-05_JPRB, 0.17951598E-05_JPRB, 0.17990701E-05_JPRB, &
  & 0.18023239E-05_JPRB, 0.18044012E-05_JPRB, 0.18055774E-05_JPRB, 0.18069450E-05_JPRB, 0.18082612E-05_JPRB, 0.18089673E-05_JPRB, &
  & 0.18092243E-05_JPRB, 0.18101106E-05_JPRB, 0.18120395E-05_JPRB, 0.18144528E-05_JPRB, 0.18157953E-05_JPRB, 0.18169755E-05_JPRB, &
  & 0.18184547E-05_JPRB, 0.18206774E-05_JPRB, 0.18209243E-05_JPRB, 0.18183184E-05_JPRB  /)

RGHG2(:,76,12) = (/ &
  & 0.16902681E-05_JPRB, 0.16906679E-05_JPRB, 0.16906826E-05_JPRB, 0.16906622E-05_JPRB, 0.16907653E-05_JPRB, 0.16907388E-05_JPRB, &
  & 0.16906205E-05_JPRB, 0.16906823E-05_JPRB, 0.16901554E-05_JPRB, 0.16889541E-05_JPRB, 0.16875447E-05_JPRB, 0.16863276E-05_JPRB, &
  & 0.16847000E-05_JPRB, 0.16821143E-05_JPRB, 0.16794995E-05_JPRB, 0.16764727E-05_JPRB, 0.16726882E-05_JPRB, 0.16690742E-05_JPRB, &
  & 0.16650210E-05_JPRB, 0.16602836E-05_JPRB, 0.16566218E-05_JPRB, 0.16547475E-05_JPRB, 0.16540560E-05_JPRB, 0.16528322E-05_JPRB, &
  & 0.16531130E-05_JPRB, 0.16545044E-05_JPRB, 0.16576078E-05_JPRB, 0.16636241E-05_JPRB, 0.16724030E-05_JPRB, 0.16848835E-05_JPRB, &
  & 0.16996698E-05_JPRB, 0.17120510E-05_JPRB, 0.17187610E-05_JPRB, 0.17241103E-05_JPRB, 0.17341945E-05_JPRB, 0.17446649E-05_JPRB, &
  & 0.17495766E-05_JPRB, 0.17535298E-05_JPRB, 0.17561227E-05_JPRB, 0.17595567E-05_JPRB, 0.17655313E-05_JPRB, 0.17736201E-05_JPRB, &
  & 0.17768308E-05_JPRB, 0.17809608E-05_JPRB, 0.17864189E-05_JPRB, 0.17925857E-05_JPRB, 0.17969926E-05_JPRB, 0.18009226E-05_JPRB, &
  & 0.18042631E-05_JPRB, 0.18062092E-05_JPRB, 0.18074003E-05_JPRB, 0.18088793E-05_JPRB, 0.18104309E-05_JPRB, 0.18110948E-05_JPRB, &
  & 0.18112453E-05_JPRB, 0.18120746E-05_JPRB, 0.18141447E-05_JPRB, 0.18167958E-05_JPRB, 0.18181234E-05_JPRB, 0.18192615E-05_JPRB, &
  & 0.18208869E-05_JPRB, 0.18234440E-05_JPRB, 0.18239287E-05_JPRB, 0.18210553E-05_JPRB  /)

RGHG2(:,77,12) = (/ &
  & 0.16905078E-05_JPRB, 0.16908576E-05_JPRB, 0.16908589E-05_JPRB, 0.16908916E-05_JPRB, 0.16910374E-05_JPRB, 0.16910763E-05_JPRB, &
  & 0.16909626E-05_JPRB, 0.16910251E-05_JPRB, 0.16905150E-05_JPRB, 0.16893228E-05_JPRB, 0.16879718E-05_JPRB, 0.16868070E-05_JPRB, &
  & 0.16852505E-05_JPRB, 0.16828099E-05_JPRB, 0.16802753E-05_JPRB, 0.16773005E-05_JPRB, 0.16736329E-05_JPRB, 0.16699902E-05_JPRB, &
  & 0.16660802E-05_JPRB, 0.16613103E-05_JPRB, 0.16575125E-05_JPRB, 0.16554824E-05_JPRB, 0.16544433E-05_JPRB, 0.16530249E-05_JPRB, &
  & 0.16527736E-05_JPRB, 0.16536035E-05_JPRB, 0.16565810E-05_JPRB, 0.16625247E-05_JPRB, 0.16708916E-05_JPRB, 0.16828301E-05_JPRB, &
  & 0.16982484E-05_JPRB, 0.17113206E-05_JPRB, 0.17183053E-05_JPRB, 0.17236017E-05_JPRB, 0.17349742E-05_JPRB, 0.17467402E-05_JPRB, &
  & 0.17520125E-05_JPRB, 0.17564730E-05_JPRB, 0.17593165E-05_JPRB, 0.17633378E-05_JPRB, 0.17693564E-05_JPRB, 0.17765896E-05_JPRB, &
  & 0.17789226E-05_JPRB, 0.17832737E-05_JPRB, 0.17886238E-05_JPRB, 0.17944579E-05_JPRB, 0.17990889E-05_JPRB, 0.18030248E-05_JPRB, &
  & 0.18064628E-05_JPRB, 0.18081994E-05_JPRB, 0.18093937E-05_JPRB, 0.18109810E-05_JPRB, 0.18128236E-05_JPRB, 0.18135664E-05_JPRB, &
  & 0.18135540E-05_JPRB, 0.18143137E-05_JPRB, 0.18165246E-05_JPRB, 0.18194073E-05_JPRB, 0.18206174E-05_JPRB, 0.18217080E-05_JPRB, &
  & 0.18235221E-05_JPRB, 0.18264446E-05_JPRB, 0.18269084E-05_JPRB, 0.18237446E-05_JPRB  /)

RGHG2(:,78,12) = (/ &
  & 0.16906462E-05_JPRB, 0.16909963E-05_JPRB, 0.16909930E-05_JPRB, 0.16910855E-05_JPRB, 0.16912660E-05_JPRB, 0.16913732E-05_JPRB, &
  & 0.16912900E-05_JPRB, 0.16913509E-05_JPRB, 0.16908632E-05_JPRB, 0.16896858E-05_JPRB, 0.16883876E-05_JPRB, 0.16872849E-05_JPRB, &
  & 0.16857891E-05_JPRB, 0.16835122E-05_JPRB, 0.16810737E-05_JPRB, 0.16781203E-05_JPRB, 0.16745752E-05_JPRB, 0.16709318E-05_JPRB, &
  & 0.16671179E-05_JPRB, 0.16623901E-05_JPRB, 0.16585174E-05_JPRB, 0.16562530E-05_JPRB, 0.16549312E-05_JPRB, 0.16532820E-05_JPRB, &
  & 0.16525869E-05_JPRB, 0.16529845E-05_JPRB, 0.16557041E-05_JPRB, 0.16615966E-05_JPRB, 0.16696771E-05_JPRB, 0.16811126E-05_JPRB, &
  & 0.16965297E-05_JPRB, 0.17100422E-05_JPRB, 0.17177021E-05_JPRB, 0.17231394E-05_JPRB, 0.17356326E-05_JPRB, 0.17485387E-05_JPRB, &
  & 0.17542750E-05_JPRB, 0.17593083E-05_JPRB, 0.17627380E-05_JPRB, 0.17675417E-05_JPRB, 0.17734378E-05_JPRB, 0.17797328E-05_JPRB, &
  & 0.17814016E-05_JPRB, 0.17858125E-05_JPRB, 0.17909571E-05_JPRB, 0.17965082E-05_JPRB, 0.18013920E-05_JPRB, 0.18053265E-05_JPRB, &
  & 0.18088239E-05_JPRB, 0.18103748E-05_JPRB, 0.18115412E-05_JPRB, 0.18132234E-05_JPRB, 0.18153193E-05_JPRB, 0.18162127E-05_JPRB, &
  & 0.18160557E-05_JPRB, 0.18167516E-05_JPRB, 0.18190597E-05_JPRB, 0.18221075E-05_JPRB, 0.18231709E-05_JPRB, 0.18242362E-05_JPRB, &
  & 0.18261769E-05_JPRB, 0.18292896E-05_JPRB, 0.18296195E-05_JPRB, 0.18262608E-05_JPRB  /)

RGHG2(:,79,12) = (/ &
  & 0.16907107E-05_JPRB, 0.16910882E-05_JPRB, 0.16910921E-05_JPRB, 0.16912501E-05_JPRB, 0.16914557E-05_JPRB, 0.16916271E-05_JPRB, &
  & 0.16915895E-05_JPRB, 0.16916520E-05_JPRB, 0.16911947E-05_JPRB, 0.16900347E-05_JPRB, 0.16887840E-05_JPRB, 0.16877462E-05_JPRB, &
  & 0.16863011E-05_JPRB, 0.16841858E-05_JPRB, 0.16818536E-05_JPRB, 0.16789171E-05_JPRB, 0.16754545E-05_JPRB, 0.16718476E-05_JPRB, &
  & 0.16680889E-05_JPRB, 0.16634178E-05_JPRB, 0.16595077E-05_JPRB, 0.16569865E-05_JPRB, 0.16554436E-05_JPRB, 0.16535457E-05_JPRB, &
  & 0.16525614E-05_JPRB, 0.16526565E-05_JPRB, 0.16550353E-05_JPRB, 0.16608340E-05_JPRB, 0.16687122E-05_JPRB, 0.16797688E-05_JPRB, &
  & 0.16948251E-05_JPRB, 0.17084274E-05_JPRB, 0.17168229E-05_JPRB, 0.17226601E-05_JPRB, 0.17361808E-05_JPRB, 0.17500690E-05_JPRB, &
  & 0.17563115E-05_JPRB, 0.17619484E-05_JPRB, 0.17661680E-05_JPRB, 0.17718043E-05_JPRB, 0.17775504E-05_JPRB, 0.17830678E-05_JPRB, &
  & 0.17842061E-05_JPRB, 0.17884978E-05_JPRB, 0.17934169E-05_JPRB, 0.17987887E-05_JPRB, 0.18039397E-05_JPRB, 0.18078057E-05_JPRB, &
  & 0.18113047E-05_JPRB, 0.18126607E-05_JPRB, 0.18138172E-05_JPRB, 0.18155827E-05_JPRB, 0.18178999E-05_JPRB, 0.18189554E-05_JPRB, &
  & 0.18187173E-05_JPRB, 0.18193605E-05_JPRB, 0.18217171E-05_JPRB, 0.18248458E-05_JPRB, 0.18257736E-05_JPRB, 0.18267630E-05_JPRB, &
  & 0.18287234E-05_JPRB, 0.18318694E-05_JPRB, 0.18320131E-05_JPRB, 0.18285467E-05_JPRB  /)

RGHG2(:,80,12) = (/ &
  & 0.16907323E-05_JPRB, 0.16911371E-05_JPRB, 0.16911632E-05_JPRB, 0.16913931E-05_JPRB, 0.16916133E-05_JPRB, 0.16918368E-05_JPRB, &
  & 0.16918462E-05_JPRB, 0.16919183E-05_JPRB, 0.16915031E-05_JPRB, 0.16903603E-05_JPRB, 0.16891516E-05_JPRB, 0.16881732E-05_JPRB, &
  & 0.16867704E-05_JPRB, 0.16847938E-05_JPRB, 0.16825709E-05_JPRB, 0.16796768E-05_JPRB, 0.16762063E-05_JPRB, 0.16726760E-05_JPRB, &
  & 0.16689514E-05_JPRB, 0.16642933E-05_JPRB, 0.16603466E-05_JPRB, 0.16576122E-05_JPRB, 0.16558989E-05_JPRB, 0.16537692E-05_JPRB, &
  & 0.16527016E-05_JPRB, 0.16526210E-05_JPRB, 0.16546353E-05_JPRB, 0.16602206E-05_JPRB, 0.16679258E-05_JPRB, 0.16787661E-05_JPRB, &
  & 0.16934425E-05_JPRB, 0.17067064E-05_JPRB, 0.17155411E-05_JPRB, 0.17220999E-05_JPRB, 0.17366311E-05_JPRB, 0.17513522E-05_JPRB, &
  & 0.17580772E-05_JPRB, 0.17643173E-05_JPRB, 0.17693505E-05_JPRB, 0.17757203E-05_JPRB, 0.17814606E-05_JPRB, 0.17865990E-05_JPRB, &
  & 0.17872421E-05_JPRB, 0.17912448E-05_JPRB, 0.17959985E-05_JPRB, 0.18013408E-05_JPRB, 0.18067648E-05_JPRB, 0.18104297E-05_JPRB, &
  & 0.18138548E-05_JPRB, 0.18149627E-05_JPRB, 0.18161835E-05_JPRB, 0.18180232E-05_JPRB, 0.18205422E-05_JPRB, 0.18217074E-05_JPRB, &
  & 0.18214970E-05_JPRB, 0.18221026E-05_JPRB, 0.18244595E-05_JPRB, 0.18275692E-05_JPRB, 0.18284141E-05_JPRB, 0.18291965E-05_JPRB, &
  & 0.18310298E-05_JPRB, 0.18340886E-05_JPRB, 0.18340543E-05_JPRB, 0.18305478E-05_JPRB  /)

RGHG2(:,81,12) = (/ &
  & 0.16907558E-05_JPRB, 0.16911733E-05_JPRB, 0.16912173E-05_JPRB, 0.16914981E-05_JPRB, 0.16917463E-05_JPRB, 0.16920029E-05_JPRB, &
  & 0.16920556E-05_JPRB, 0.16921481E-05_JPRB, 0.16917685E-05_JPRB, 0.16906512E-05_JPRB, 0.16894807E-05_JPRB, 0.16885431E-05_JPRB, &
  & 0.16871607E-05_JPRB, 0.16852809E-05_JPRB, 0.16831038E-05_JPRB, 0.16802199E-05_JPRB, 0.16767825E-05_JPRB, 0.16733210E-05_JPRB, &
  & 0.16696753E-05_JPRB, 0.16649663E-05_JPRB, 0.16609508E-05_JPRB, 0.16580890E-05_JPRB, 0.16562051E-05_JPRB, 0.16540347E-05_JPRB, &
  & 0.16530434E-05_JPRB, 0.16528152E-05_JPRB, 0.16546154E-05_JPRB, 0.16600760E-05_JPRB, 0.16674195E-05_JPRB, 0.16783846E-05_JPRB, &
  & 0.16928700E-05_JPRB, 0.17054054E-05_JPRB, 0.17138606E-05_JPRB, 0.17214790E-05_JPRB, 0.17369373E-05_JPRB, 0.17524022E-05_JPRB, &
  & 0.17595118E-05_JPRB, 0.17664804E-05_JPRB, 0.17724000E-05_JPRB, 0.17788512E-05_JPRB, 0.17844489E-05_JPRB, 0.17899464E-05_JPRB, &
  & 0.17902228E-05_JPRB, 0.17937466E-05_JPRB, 0.17985436E-05_JPRB, 0.18042578E-05_JPRB, 0.18098346E-05_JPRB, 0.18131837E-05_JPRB, &
  & 0.18165272E-05_JPRB, 0.18174951E-05_JPRB, 0.18187694E-05_JPRB, 0.18206702E-05_JPRB, 0.18234312E-05_JPRB, 0.18246244E-05_JPRB, &
  & 0.18243860E-05_JPRB, 0.18250069E-05_JPRB, 0.18271269E-05_JPRB, 0.18303741E-05_JPRB, 0.18310433E-05_JPRB, 0.18313800E-05_JPRB, &
  & 0.18329840E-05_JPRB, 0.18360326E-05_JPRB, 0.18358353E-05_JPRB, 0.18323440E-05_JPRB  /)

RGHG2(:,82,12) = (/ &
  & 0.16907868E-05_JPRB, 0.16912135E-05_JPRB, 0.16912629E-05_JPRB, 0.16915802E-05_JPRB, 0.16918511E-05_JPRB, 0.16921406E-05_JPRB, &
  & 0.16922345E-05_JPRB, 0.16923526E-05_JPRB, 0.16920119E-05_JPRB, 0.16909129E-05_JPRB, 0.16897575E-05_JPRB, 0.16888464E-05_JPRB, &
  & 0.16874877E-05_JPRB, 0.16856971E-05_JPRB, 0.16835305E-05_JPRB, 0.16806321E-05_JPRB, 0.16772311E-05_JPRB, 0.16738063E-05_JPRB, &
  & 0.16701830E-05_JPRB, 0.16654970E-05_JPRB, 0.16614641E-05_JPRB, 0.16585144E-05_JPRB, 0.16564767E-05_JPRB, 0.16543307E-05_JPRB, &
  & 0.16533873E-05_JPRB, 0.16530491E-05_JPRB, 0.16547157E-05_JPRB, 0.16601014E-05_JPRB, 0.16671382E-05_JPRB, 0.16782835E-05_JPRB, &
  & 0.16925562E-05_JPRB, 0.17045977E-05_JPRB, 0.17126284E-05_JPRB, 0.17209434E-05_JPRB, 0.17371668E-05_JPRB, 0.17532478E-05_JPRB, &
  & 0.17606342E-05_JPRB, 0.17680915E-05_JPRB, 0.17748234E-05_JPRB, 0.17814382E-05_JPRB, 0.17866221E-05_JPRB, 0.17926326E-05_JPRB, &
  & 0.17927007E-05_JPRB, 0.17958558E-05_JPRB, 0.18005765E-05_JPRB, 0.18068269E-05_JPRB, 0.18128679E-05_JPRB, 0.18159330E-05_JPRB, &
  & 0.18193132E-05_JPRB, 0.18201190E-05_JPRB, 0.18215342E-05_JPRB, 0.18234536E-05_JPRB, 0.18264165E-05_JPRB, 0.18274024E-05_JPRB, &
  & 0.18271466E-05_JPRB, 0.18277985E-05_JPRB, 0.18296972E-05_JPRB, 0.18330793E-05_JPRB, 0.18335072E-05_JPRB, 0.18333553E-05_JPRB, &
  & 0.18347790E-05_JPRB, 0.18377490E-05_JPRB, 0.18372687E-05_JPRB, 0.18339856E-05_JPRB  /)

RGHG2(:,83,12) = (/ &
  & 0.16908127E-05_JPRB, 0.16912537E-05_JPRB, 0.16912983E-05_JPRB, 0.16916428E-05_JPRB, 0.16919328E-05_JPRB, 0.16922559E-05_JPRB, &
  & 0.16923870E-05_JPRB, 0.16925327E-05_JPRB, 0.16922283E-05_JPRB, 0.16911531E-05_JPRB, 0.16900027E-05_JPRB, 0.16891000E-05_JPRB, &
  & 0.16877597E-05_JPRB, 0.16860485E-05_JPRB, 0.16838575E-05_JPRB, 0.16809301E-05_JPRB, 0.16775755E-05_JPRB, 0.16741821E-05_JPRB, &
  & 0.16705542E-05_JPRB, 0.16659196E-05_JPRB, 0.16618868E-05_JPRB, 0.16588989E-05_JPRB, 0.16567235E-05_JPRB, 0.16546214E-05_JPRB, &
  & 0.16537589E-05_JPRB, 0.16533482E-05_JPRB, 0.16549024E-05_JPRB, 0.16602471E-05_JPRB, 0.16670242E-05_JPRB, 0.16783445E-05_JPRB, &
  & 0.16923449E-05_JPRB, 0.17041422E-05_JPRB, 0.17118129E-05_JPRB, 0.17205662E-05_JPRB, 0.17373115E-05_JPRB, 0.17538330E-05_JPRB, &
  & 0.17614168E-05_JPRB, 0.17692088E-05_JPRB, 0.17765189E-05_JPRB, 0.17834028E-05_JPRB, 0.17881856E-05_JPRB, 0.17946965E-05_JPRB, &
  & 0.17946441E-05_JPRB, 0.17975495E-05_JPRB, 0.18021694E-05_JPRB, 0.18090042E-05_JPRB, 0.18157689E-05_JPRB, 0.18186044E-05_JPRB, &
  & 0.18221025E-05_JPRB, 0.18227649E-05_JPRB, 0.18243475E-05_JPRB, 0.18262330E-05_JPRB, 0.18292906E-05_JPRB, 0.18300095E-05_JPRB, &
  & 0.18297189E-05_JPRB, 0.18303929E-05_JPRB, 0.18322610E-05_JPRB, 0.18356147E-05_JPRB, 0.18358956E-05_JPRB, 0.18352004E-05_JPRB, &
  & 0.18364174E-05_JPRB, 0.18391997E-05_JPRB, 0.18384090E-05_JPRB, 0.18354841E-05_JPRB  /)

RGHG2(:,84,12) = (/ &
  & 0.16908242E-05_JPRB, 0.16912904E-05_JPRB, 0.16913226E-05_JPRB, 0.16916891E-05_JPRB, 0.16919962E-05_JPRB, 0.16923538E-05_JPRB, &
  & 0.16925170E-05_JPRB, 0.16926889E-05_JPRB, 0.16924142E-05_JPRB, 0.16913764E-05_JPRB, 0.16902310E-05_JPRB, 0.16893170E-05_JPRB, &
  & 0.16879822E-05_JPRB, 0.16863394E-05_JPRB, 0.16840947E-05_JPRB, 0.16811343E-05_JPRB, 0.16778393E-05_JPRB, 0.16744904E-05_JPRB, &
  & 0.16708540E-05_JPRB, 0.16662666E-05_JPRB, 0.16622243E-05_JPRB, 0.16592569E-05_JPRB, 0.16569531E-05_JPRB, 0.16548795E-05_JPRB, &
  & 0.16541675E-05_JPRB, 0.16537179E-05_JPRB, 0.16551381E-05_JPRB, 0.16604680E-05_JPRB, 0.16670251E-05_JPRB, 0.16784719E-05_JPRB, &
  & 0.16921511E-05_JPRB, 0.17039285E-05_JPRB, 0.17113819E-05_JPRB, 0.17203966E-05_JPRB, 0.17373823E-05_JPRB, 0.17541554E-05_JPRB, &
  & 0.17618728E-05_JPRB, 0.17699194E-05_JPRB, 0.17774775E-05_JPRB, 0.17847298E-05_JPRB, 0.17893285E-05_JPRB, 0.17962056E-05_JPRB, &
  & 0.17960598E-05_JPRB, 0.17988397E-05_JPRB, 0.18034079E-05_JPRB, 0.18107811E-05_JPRB, 0.18184507E-05_JPRB, 0.18211272E-05_JPRB, &
  & 0.18247934E-05_JPRB, 0.18253566E-05_JPRB, 0.18270892E-05_JPRB, 0.18288890E-05_JPRB, 0.18318931E-05_JPRB, 0.18324122E-05_JPRB, &
  & 0.18320579E-05_JPRB, 0.18327156E-05_JPRB, 0.18348684E-05_JPRB, 0.18379245E-05_JPRB, 0.18382487E-05_JPRB, 0.18369589E-05_JPRB, &
  & 0.18378933E-05_JPRB, 0.18403508E-05_JPRB, 0.18393057E-05_JPRB, 0.18368357E-05_JPRB  /)

RGHG2(:,85,12) = (/ &
  & 0.16908153E-05_JPRB, 0.16913149E-05_JPRB, 0.16913342E-05_JPRB, 0.16917187E-05_JPRB, 0.16920413E-05_JPRB, 0.16924322E-05_JPRB, &
  & 0.16926262E-05_JPRB, 0.16928110E-05_JPRB, 0.16925671E-05_JPRB, 0.16915730E-05_JPRB, 0.16904326E-05_JPRB, 0.16894853E-05_JPRB, &
  & 0.16881274E-05_JPRB, 0.16865411E-05_JPRB, 0.16842527E-05_JPRB, 0.16812820E-05_JPRB, 0.16780538E-05_JPRB, 0.16747511E-05_JPRB, &
  & 0.16710864E-05_JPRB, 0.16665915E-05_JPRB, 0.16625055E-05_JPRB, 0.16596870E-05_JPRB, 0.16571779E-05_JPRB, 0.16551145E-05_JPRB, &
  & 0.16545541E-05_JPRB, 0.16540736E-05_JPRB, 0.16553474E-05_JPRB, 0.16607800E-05_JPRB, 0.16671497E-05_JPRB, 0.16786941E-05_JPRB, &
  & 0.16924734E-05_JPRB, 0.17041507E-05_JPRB, 0.17115399E-05_JPRB, 0.17205033E-05_JPRB, 0.17375506E-05_JPRB, 0.17545727E-05_JPRB, &
  & 0.17622362E-05_JPRB, 0.17705036E-05_JPRB, 0.17780977E-05_JPRB, 0.17856118E-05_JPRB, 0.17901977E-05_JPRB, 0.17973392E-05_JPRB, &
  & 0.17970676E-05_JPRB, 0.17999220E-05_JPRB, 0.18045185E-05_JPRB, 0.18123590E-05_JPRB, 0.18208836E-05_JPRB, 0.18235010E-05_JPRB, &
  & 0.18274189E-05_JPRB, 0.18278742E-05_JPRB, 0.18297866E-05_JPRB, 0.18315119E-05_JPRB, 0.18343209E-05_JPRB, 0.18346012E-05_JPRB, &
  & 0.18342674E-05_JPRB, 0.18346914E-05_JPRB, 0.18376094E-05_JPRB, 0.18400724E-05_JPRB, 0.18404223E-05_JPRB, 0.18385393E-05_JPRB, &
  & 0.18391322E-05_JPRB, 0.18410069E-05_JPRB, 0.18399387E-05_JPRB, 0.18378975E-05_JPRB  /)

RGHG2(:,86,12) = (/ &
  & 0.16907951E-05_JPRB, 0.16913363E-05_JPRB, 0.16913407E-05_JPRB, 0.16917373E-05_JPRB, 0.16920853E-05_JPRB, 0.16925118E-05_JPRB, &
  & 0.16927147E-05_JPRB, 0.16929063E-05_JPRB, 0.16926834E-05_JPRB, 0.16917230E-05_JPRB, 0.16905758E-05_JPRB, 0.16896231E-05_JPRB, &
  & 0.16882399E-05_JPRB, 0.16866943E-05_JPRB, 0.16843701E-05_JPRB, 0.16813971E-05_JPRB, 0.16782159E-05_JPRB, 0.16749436E-05_JPRB, &
  & 0.16712807E-05_JPRB, 0.16668787E-05_JPRB, 0.16627870E-05_JPRB, 0.16601624E-05_JPRB, 0.16574246E-05_JPRB, 0.16553435E-05_JPRB, &
  & 0.16549956E-05_JPRB, 0.16544038E-05_JPRB, 0.16555787E-05_JPRB, 0.16611789E-05_JPRB, 0.16673179E-05_JPRB, 0.16791352E-05_JPRB, &
  & 0.16931638E-05_JPRB, 0.17048369E-05_JPRB, 0.17121455E-05_JPRB, 0.17208021E-05_JPRB, 0.17378712E-05_JPRB, 0.17550994E-05_JPRB, &
  & 0.17626103E-05_JPRB, 0.17710674E-05_JPRB, 0.17786735E-05_JPRB, 0.17863887E-05_JPRB, 0.17910058E-05_JPRB, 0.17984694E-05_JPRB, &
  & 0.17980352E-05_JPRB, 0.18010166E-05_JPRB, 0.18056475E-05_JPRB, 0.18139316E-05_JPRB, 0.18231046E-05_JPRB, 0.18257490E-05_JPRB, &
  & 0.18298254E-05_JPRB, 0.18300316E-05_JPRB, 0.18323698E-05_JPRB, 0.18340866E-05_JPRB, 0.18365508E-05_JPRB, 0.18366011E-05_JPRB, &
  & 0.18363904E-05_JPRB, 0.18364390E-05_JPRB, 0.18403510E-05_JPRB, 0.18419446E-05_JPRB, 0.18420772E-05_JPRB, 0.18397468E-05_JPRB, &
  & 0.18399764E-05_JPRB, 0.18413677E-05_JPRB, 0.18403708E-05_JPRB, 0.18387505E-05_JPRB  /)

RGHG2(:,87,12) = (/ &
  & 0.16907774E-05_JPRB, 0.16913524E-05_JPRB, 0.16913424E-05_JPRB, 0.16917481E-05_JPRB, 0.16921236E-05_JPRB, 0.16925868E-05_JPRB, &
  & 0.16927869E-05_JPRB, 0.16929812E-05_JPRB, 0.16927739E-05_JPRB, 0.16918263E-05_JPRB, 0.16906700E-05_JPRB, 0.16897225E-05_JPRB, &
  & 0.16883185E-05_JPRB, 0.16868029E-05_JPRB, 0.16844566E-05_JPRB, 0.16814783E-05_JPRB, 0.16783390E-05_JPRB, 0.16750876E-05_JPRB, &
  & 0.16714431E-05_JPRB, 0.16671141E-05_JPRB, 0.16630357E-05_JPRB, 0.16605913E-05_JPRB, 0.16576820E-05_JPRB, 0.16555786E-05_JPRB, &
  & 0.16554987E-05_JPRB, 0.16546971E-05_JPRB, 0.16558257E-05_JPRB, 0.16616413E-05_JPRB, 0.16675366E-05_JPRB, 0.16799959E-05_JPRB, &
  & 0.16941562E-05_JPRB, 0.17060067E-05_JPRB, 0.17132863E-05_JPRB, 0.17213035E-05_JPRB, 0.17384205E-05_JPRB, 0.17558212E-05_JPRB, &
  & 0.17630897E-05_JPRB, 0.17716969E-05_JPRB, 0.17793604E-05_JPRB, 0.17873593E-05_JPRB, 0.17920718E-05_JPRB, 0.17999256E-05_JPRB, &
  & 0.17991686E-05_JPRB, 0.18022528E-05_JPRB, 0.18070073E-05_JPRB, 0.18157035E-05_JPRB, 0.18254032E-05_JPRB, 0.18280064E-05_JPRB, &
  & 0.18320693E-05_JPRB, 0.18319499E-05_JPRB, 0.18348407E-05_JPRB, 0.18367192E-05_JPRB, 0.18385387E-05_JPRB, 0.18385819E-05_JPRB, &
  & 0.18386128E-05_JPRB, 0.18380521E-05_JPRB, 0.18429089E-05_JPRB, 0.18435219E-05_JPRB, 0.18433649E-05_JPRB, 0.18406671E-05_JPRB, &
  & 0.18405661E-05_JPRB, 0.18415643E-05_JPRB, 0.18406871E-05_JPRB, 0.18394566E-05_JPRB  /)

RGHG2(:,88,12) = (/ &
  & 0.16907677E-05_JPRB, 0.16913627E-05_JPRB, 0.16913406E-05_JPRB, 0.16917545E-05_JPRB, 0.16921567E-05_JPRB, 0.16926536E-05_JPRB, &
  & 0.16928510E-05_JPRB, 0.16930421E-05_JPRB, 0.16928485E-05_JPRB, 0.16918891E-05_JPRB, 0.16907221E-05_JPRB, 0.16897829E-05_JPRB, &
  & 0.16883672E-05_JPRB, 0.16868755E-05_JPRB, 0.16845175E-05_JPRB, 0.16815392E-05_JPRB, 0.16784328E-05_JPRB, 0.16751931E-05_JPRB, &
  & 0.16715793E-05_JPRB, 0.16672964E-05_JPRB, 0.16632447E-05_JPRB, 0.16609469E-05_JPRB, 0.16579464E-05_JPRB, 0.16558365E-05_JPRB, &
  & 0.16560122E-05_JPRB, 0.16550085E-05_JPRB, 0.16561186E-05_JPRB, 0.16621883E-05_JPRB, 0.16678335E-05_JPRB, 0.16816889E-05_JPRB, &
  & 0.16955514E-05_JPRB, 0.17078640E-05_JPRB, 0.17151980E-05_JPRB, 0.17221983E-05_JPRB, 0.17393550E-05_JPRB, 0.17569525E-05_JPRB, &
  & 0.17638155E-05_JPRB, 0.17725605E-05_JPRB, 0.17804773E-05_JPRB, 0.17889655E-05_JPRB, 0.17942250E-05_JPRB, 0.18023883E-05_JPRB, &
  & 0.18008529E-05_JPRB, 0.18039318E-05_JPRB, 0.18090470E-05_JPRB, 0.18181670E-05_JPRB, 0.18282111E-05_JPRB, 0.18304644E-05_JPRB, &
  & 0.18343163E-05_JPRB, 0.18337382E-05_JPRB, 0.18372118E-05_JPRB, 0.18394921E-05_JPRB, 0.18403119E-05_JPRB, 0.18405537E-05_JPRB, &
  & 0.18414760E-05_JPRB, 0.18397206E-05_JPRB, 0.18452619E-05_JPRB, 0.18448876E-05_JPRB, 0.18444199E-05_JPRB, 0.18413936E-05_JPRB, &
  & 0.18410080E-05_JPRB, 0.18416742E-05_JPRB, 0.18409226E-05_JPRB, 0.18400006E-05_JPRB  /)

RGHG2(:,89,12) = (/ &
  & 0.16907657E-05_JPRB, 0.16913682E-05_JPRB, 0.16913386E-05_JPRB, 0.16917600E-05_JPRB, 0.16921881E-05_JPRB, 0.16927076E-05_JPRB, &
  & 0.16929180E-05_JPRB, 0.16930965E-05_JPRB, 0.16929154E-05_JPRB, 0.16919268E-05_JPRB, 0.16907441E-05_JPRB, 0.16898128E-05_JPRB, &
  & 0.16883978E-05_JPRB, 0.16869280E-05_JPRB, 0.16845560E-05_JPRB, 0.16816094E-05_JPRB, 0.16785062E-05_JPRB, 0.16752650E-05_JPRB, &
  & 0.16716951E-05_JPRB, 0.16674385E-05_JPRB, 0.16634293E-05_JPRB, 0.16612631E-05_JPRB, 0.16582149E-05_JPRB, 0.16561271E-05_JPRB, &
  & 0.16564243E-05_JPRB, 0.16554589E-05_JPRB, 0.16565181E-05_JPRB, 0.16628723E-05_JPRB, 0.16682642E-05_JPRB, 0.16846902E-05_JPRB, &
  & 0.16975465E-05_JPRB, 0.17106593E-05_JPRB, 0.17181007E-05_JPRB, 0.17237689E-05_JPRB, 0.17408952E-05_JPRB, 0.17589240E-05_JPRB, &
  & 0.17649800E-05_JPRB, 0.17739136E-05_JPRB, 0.17826164E-05_JPRB, 0.17921779E-05_JPRB, 0.17992946E-05_JPRB, 0.18073209E-05_JPRB, &
  & 0.18038878E-05_JPRB, 0.18067253E-05_JPRB, 0.18127365E-05_JPRB, 0.18221611E-05_JPRB, 0.18322322E-05_JPRB, 0.18333914E-05_JPRB, &
  & 0.18368127E-05_JPRB, 0.18355005E-05_JPRB, 0.18394105E-05_JPRB, 0.18422514E-05_JPRB, 0.18419044E-05_JPRB, 0.18422149E-05_JPRB, &
  & 0.18457186E-05_JPRB, 0.18416650E-05_JPRB, 0.18474705E-05_JPRB, 0.18461759E-05_JPRB, 0.18453498E-05_JPRB, 0.18420314E-05_JPRB, &
  & 0.18414118E-05_JPRB, 0.18417614E-05_JPRB, 0.18410773E-05_JPRB, 0.18402923E-05_JPRB  /)

RGHG2(:,90,12) = (/ &
  & 0.16907663E-05_JPRB, 0.16913688E-05_JPRB, 0.16913392E-05_JPRB, 0.16917607E-05_JPRB, 0.16922158E-05_JPRB, 0.16927568E-05_JPRB, &
  & 0.16929905E-05_JPRB, 0.16931488E-05_JPRB, 0.16929672E-05_JPRB, 0.16919455E-05_JPRB, 0.16907568E-05_JPRB, 0.16898283E-05_JPRB, &
  & 0.16884195E-05_JPRB, 0.16869647E-05_JPRB, 0.16845806E-05_JPRB, 0.16816890E-05_JPRB, 0.16785703E-05_JPRB, 0.16753173E-05_JPRB, &
  & 0.16718225E-05_JPRB, 0.16675961E-05_JPRB, 0.16636481E-05_JPRB, 0.16617034E-05_JPRB, 0.16585461E-05_JPRB, 0.16564530E-05_JPRB, &
  & 0.16569482E-05_JPRB, 0.16561147E-05_JPRB, 0.16570809E-05_JPRB, 0.16638452E-05_JPRB, 0.16689940E-05_JPRB, 0.16884615E-05_JPRB, &
  & 0.17003405E-05_JPRB, 0.17143110E-05_JPRB, 0.17217109E-05_JPRB, 0.17257504E-05_JPRB, 0.17432474E-05_JPRB, 0.17626001E-05_JPRB, &
  & 0.17667521E-05_JPRB, 0.17759667E-05_JPRB, 0.17866251E-05_JPRB, 0.17996912E-05_JPRB, 0.18105611E-05_JPRB, 0.18179699E-05_JPRB, &
  & 0.18102908E-05_JPRB, 0.18124061E-05_JPRB, 0.18203453E-05_JPRB, 0.18286158E-05_JPRB, 0.18388697E-05_JPRB, 0.18375665E-05_JPRB, &
  & 0.18399077E-05_JPRB, 0.18375779E-05_JPRB, 0.18415521E-05_JPRB, 0.18444788E-05_JPRB, 0.18433980E-05_JPRB, 0.18431099E-05_JPRB, &
  & 0.18508186E-05_JPRB, 0.18437529E-05_JPRB, 0.18498451E-05_JPRB, 0.18473166E-05_JPRB, 0.18460383E-05_JPRB, 0.18425662E-05_JPRB, &
  & 0.18418386E-05_JPRB, 0.18418766E-05_JPRB, 0.18411699E-05_JPRB, 0.18403990E-05_JPRB  /)

RGHG2(:,91,12) = (/ &
  & 0.16907654E-05_JPRB, 0.16913679E-05_JPRB, 0.16913383E-05_JPRB, 0.16917630E-05_JPRB, 0.16922437E-05_JPRB, 0.16928165E-05_JPRB, &
  & 0.16930470E-05_JPRB, 0.16932149E-05_JPRB, 0.16930174E-05_JPRB, 0.16919605E-05_JPRB, 0.16907687E-05_JPRB, 0.16898369E-05_JPRB, &
  & 0.16884410E-05_JPRB, 0.16869989E-05_JPRB, 0.16846021E-05_JPRB, 0.16817838E-05_JPRB, 0.16786396E-05_JPRB, 0.16753834E-05_JPRB, &
  & 0.16720450E-05_JPRB, 0.16678505E-05_JPRB, 0.16639918E-05_JPRB, 0.16624971E-05_JPRB, 0.16590302E-05_JPRB, 0.16568606E-05_JPRB, &
  & 0.16577100E-05_JPRB, 0.16571700E-05_JPRB, 0.16578713E-05_JPRB, 0.16654174E-05_JPRB, 0.16704482E-05_JPRB, 0.16924972E-05_JPRB, &
  & 0.17044847E-05_JPRB, 0.17197284E-05_JPRB, 0.17264646E-05_JPRB, 0.17281140E-05_JPRB, 0.17468970E-05_JPRB, 0.17683271E-05_JPRB, &
  & 0.17688604E-05_JPRB, 0.17792972E-05_JPRB, 0.17929902E-05_JPRB, 0.18143050E-05_JPRB, 0.18287552E-05_JPRB, 0.18386817E-05_JPRB, &
  & 0.18274383E-05_JPRB, 0.18255616E-05_JPRB, 0.18344741E-05_JPRB, 0.18391196E-05_JPRB, 0.18503532E-05_JPRB, 0.18443018E-05_JPRB, &
  & 0.18440615E-05_JPRB, 0.18401106E-05_JPRB, 0.18439923E-05_JPRB, 0.18464978E-05_JPRB, 0.18452829E-05_JPRB, 0.18436993E-05_JPRB, &
  & 0.18541427E-05_JPRB, 0.18455134E-05_JPRB, 0.18522693E-05_JPRB, 0.18482922E-05_JPRB, 0.18464682E-05_JPRB, 0.18429355E-05_JPRB, &
  & 0.18422079E-05_JPRB, 0.18419906E-05_JPRB, 0.18412169E-05_JPRB, 0.18404300E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCH4CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24




END SUBROUTINE SU_GCH4CLIM
