!option! -Nv -NO                                            
#ifdef RS6K                                                 
@PROCESS NOOPTIMIZE                                         
#endif                                                      
!pgi$r opt=0                                                
SUBROUTINE SU_GCO2CLIM
                                                            
                                                            
!**   CARBON DIOXIDE FROM GEMS reana*              
                                                            
!     PURPOSE.                                              
!     --------                                              
                                                            
!**   INTERFACE.                                            
!     ----------                                            
!        CALL *SU_GCO2CLIM* FROM *SUECRAD*                   
                                                            
!        EXPLICIT ARGUMENTS :                               
!        --------------------                               
!     ==== INPUTS ===                                       
!     ==== OUTPUTS ===                                      
                                                            
!        IMPLICIT ARGUMENTS :   NONE                        
!        --------------------                               
                                                            
!     METHOD.                                               
!     -------                                               
                                                            
!     EXTERNALS.                                            
!     ----------                                            
                                                            
!          NONE                                             
                                                            
!     REFERENCE.                                            
!     ----------                                            
                                                            
!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION A
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F
                                                           
!     AUTHOR.                                               
!     -------                                               
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423               
                                                            
!     MODIFICATIONS.                                        
!     --------------                                        
!        Same history as suecaesu                           
!        M.Hamrud      01-Oct-2003 CY28 Cleaning            
!     R. Elkhatib 12-10-2005 Split for faster and more robus
                                                            
!-----------------------------------------------------------
                                                            
USE PARKIND1  ,ONLY : JPRB                        
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK                      
USE YOMCLIM   ,ONLY : RGHG1
                                                            
IMPLICIT NONE                                               

                                                            
!     ------------------------------------------------------
                                                            
!*       0.1   ARGUMENTS.                                   
!              ----------                                   
! REAL(KIND=JPRB),INTENT(OUT) :: PCLCO2(64,91,12)             
                                                            
!     ------------------------------------------------------
                                                            
!*       0.2   LOCAL ARRAYS.                                
!              -------------                                
                                                            
! REAL(KIND=JPRB),SAVE :: ZGHG1(64,91,12)                     
                                                            
LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.                        
                                                            
REAL(KIND=JPRB) :: ZHOOK_HANDLE                             
!     ------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM',0,ZHOOK_HANDLE)        
                                                            
IF(LLFIRSTCALL) THEN                                        

  ALLOCATE(RGHG1(64,91,12))                                         

  CALL PART1                                                
  CALL PART2                                                
  CALL PART3                                                
  CALL PART4                                                
  CALL PART5                                                
  CALL PART6                                                
  CALL PART7                                                
  CALL PART8                                                
  CALL PART9                                                
  CALL PART10                                               
  CALL PART11                                               
  CALL PART12                                               
  CALL PART13                                               
  CALL PART14                                               
  CALL PART15                                               
  CALL PART16                                               
  CALL PART17                                               
  CALL PART18                                               
  CALL PART19                                               
  CALL PART20                                               
  CALL PART21                                               
  CALL PART22                                               
  CALL PART23                                               
  CALL PART24                                               
                                                            
ENDIF                                                       
                                                            
! PCLCO2(:,:,:)=ZGHG1(:,:,:)                                  
                                                            
!     ------------------------------------------------------
                                                            
LLFIRSTCALL = .FALSE.                                       
                                                            
IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM',1,ZHOOK_HANDLE)        
                                                            
!-----------------------------------------------------------
                                                            
CONTAINS                                                    
                                                            


SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ---GEMS----

RGHG1(:, 1, 1) = (/ &
  & 0.37130213E-03_JPRB, 0.37130410E-03_JPRB, 0.37130680E-03_JPRB, 0.37130931E-03_JPRB, 0.37131007E-03_JPRB, 0.37130382E-03_JPRB, &
  & 0.37128738E-03_JPRB, 0.37126027E-03_JPRB, 0.37122442E-03_JPRB, 0.37118308E-03_JPRB, 0.37113756E-03_JPRB, 0.37108311E-03_JPRB, &
  & 0.37101825E-03_JPRB, 0.37094609E-03_JPRB, 0.37087238E-03_JPRB, 0.37080376E-03_JPRB, 0.37074828E-03_JPRB, 0.37071240E-03_JPRB, &
  & 0.37069467E-03_JPRB, 0.37069260E-03_JPRB, 0.37070124E-03_JPRB, 0.37071695E-03_JPRB, 0.37073411E-03_JPRB, 0.37074946E-03_JPRB, &
  & 0.37076293E-03_JPRB, 0.37077447E-03_JPRB, 0.37078467E-03_JPRB, 0.37079403E-03_JPRB, 0.37080206E-03_JPRB, 0.37080906E-03_JPRB, &
  & 0.37081500E-03_JPRB, 0.37081944E-03_JPRB, 0.37082168E-03_JPRB, 0.37082580E-03_JPRB, 0.37083514E-03_JPRB, 0.37085553E-03_JPRB, &
  & 0.37088891E-03_JPRB, 0.37092651E-03_JPRB, 0.37096537E-03_JPRB, 0.37100266E-03_JPRB, 0.37103183E-03_JPRB, 0.37105145E-03_JPRB, &
  & 0.37106673E-03_JPRB, 0.37108180E-03_JPRB, 0.37109740E-03_JPRB, 0.37110821E-03_JPRB, 0.37111410E-03_JPRB, 0.37111988E-03_JPRB, &
  & 0.37112614E-03_JPRB, 0.37113297E-03_JPRB, 0.37113878E-03_JPRB, 0.37114323E-03_JPRB, 0.37114512E-03_JPRB, 0.37114710E-03_JPRB, &
  & 0.37114878E-03_JPRB, 0.37114849E-03_JPRB, 0.37114783E-03_JPRB, 0.37114827E-03_JPRB, 0.37114852E-03_JPRB, 0.37114874E-03_JPRB, &
  & 0.37115307E-03_JPRB, 0.37115779E-03_JPRB, 0.37116205E-03_JPRB, 0.37116206E-03_JPRB  /)

RGHG1(:, 2, 1) = (/ &
  & 0.37130213E-03_JPRB, 0.37130410E-03_JPRB, 0.37130680E-03_JPRB, 0.37130931E-03_JPRB, 0.37131007E-03_JPRB, 0.37130382E-03_JPRB, &
  & 0.37128738E-03_JPRB, 0.37126027E-03_JPRB, 0.37122442E-03_JPRB, 0.37118308E-03_JPRB, 0.37113756E-03_JPRB, 0.37108311E-03_JPRB, &
  & 0.37101825E-03_JPRB, 0.37094609E-03_JPRB, 0.37087238E-03_JPRB, 0.37080376E-03_JPRB, 0.37074828E-03_JPRB, 0.37071240E-03_JPRB, &
  & 0.37069467E-03_JPRB, 0.37069260E-03_JPRB, 0.37070124E-03_JPRB, 0.37071695E-03_JPRB, 0.37073411E-03_JPRB, 0.37074946E-03_JPRB, &
  & 0.37076293E-03_JPRB, 0.37077447E-03_JPRB, 0.37078467E-03_JPRB, 0.37079403E-03_JPRB, 0.37080206E-03_JPRB, 0.37080906E-03_JPRB, &
  & 0.37081500E-03_JPRB, 0.37081944E-03_JPRB, 0.37082168E-03_JPRB, 0.37082580E-03_JPRB, 0.37083514E-03_JPRB, 0.37085553E-03_JPRB, &
  & 0.37088891E-03_JPRB, 0.37092651E-03_JPRB, 0.37096537E-03_JPRB, 0.37100266E-03_JPRB, 0.37103183E-03_JPRB, 0.37105145E-03_JPRB, &
  & 0.37106673E-03_JPRB, 0.37108180E-03_JPRB, 0.37109740E-03_JPRB, 0.37110821E-03_JPRB, 0.37111410E-03_JPRB, 0.37111988E-03_JPRB, &
  & 0.37112614E-03_JPRB, 0.37113297E-03_JPRB, 0.37113878E-03_JPRB, 0.37114323E-03_JPRB, 0.37114512E-03_JPRB, 0.37114710E-03_JPRB, &
  & 0.37114878E-03_JPRB, 0.37114849E-03_JPRB, 0.37114783E-03_JPRB, 0.37114827E-03_JPRB, 0.37114852E-03_JPRB, 0.37114874E-03_JPRB, &
  & 0.37115307E-03_JPRB, 0.37115779E-03_JPRB, 0.37116205E-03_JPRB, 0.37116206E-03_JPRB  /)

RGHG1(:, 3, 1) = (/ &
  & 0.37130213E-03_JPRB, 0.37130410E-03_JPRB, 0.37130680E-03_JPRB, 0.37130931E-03_JPRB, 0.37131007E-03_JPRB, 0.37130382E-03_JPRB, &
  & 0.37128738E-03_JPRB, 0.37126027E-03_JPRB, 0.37122442E-03_JPRB, 0.37118308E-03_JPRB, 0.37113756E-03_JPRB, 0.37108311E-03_JPRB, &
  & 0.37101825E-03_JPRB, 0.37094609E-03_JPRB, 0.37087238E-03_JPRB, 0.37080376E-03_JPRB, 0.37074828E-03_JPRB, 0.37071240E-03_JPRB, &
  & 0.37069467E-03_JPRB, 0.37069260E-03_JPRB, 0.37070124E-03_JPRB, 0.37071695E-03_JPRB, 0.37073411E-03_JPRB, 0.37074946E-03_JPRB, &
  & 0.37076293E-03_JPRB, 0.37077447E-03_JPRB, 0.37078467E-03_JPRB, 0.37079403E-03_JPRB, 0.37080206E-03_JPRB, 0.37080906E-03_JPRB, &
  & 0.37081500E-03_JPRB, 0.37081944E-03_JPRB, 0.37082168E-03_JPRB, 0.37082580E-03_JPRB, 0.37083514E-03_JPRB, 0.37085553E-03_JPRB, &
  & 0.37088891E-03_JPRB, 0.37092651E-03_JPRB, 0.37096537E-03_JPRB, 0.37100266E-03_JPRB, 0.37103183E-03_JPRB, 0.37105145E-03_JPRB, &
  & 0.37106673E-03_JPRB, 0.37108180E-03_JPRB, 0.37109740E-03_JPRB, 0.37110821E-03_JPRB, 0.37111410E-03_JPRB, 0.37111988E-03_JPRB, &
  & 0.37112614E-03_JPRB, 0.37113297E-03_JPRB, 0.37113878E-03_JPRB, 0.37114323E-03_JPRB, 0.37114512E-03_JPRB, 0.37114710E-03_JPRB, &
  & 0.37114878E-03_JPRB, 0.37114849E-03_JPRB, 0.37114783E-03_JPRB, 0.37114827E-03_JPRB, 0.37114852E-03_JPRB, 0.37114874E-03_JPRB, &
  & 0.37115307E-03_JPRB, 0.37115779E-03_JPRB, 0.37116205E-03_JPRB, 0.37116206E-03_JPRB  /)

RGHG1(:, 4, 1) = (/ &
  & 0.37130305E-03_JPRB, 0.37130500E-03_JPRB, 0.37130769E-03_JPRB, 0.37131021E-03_JPRB, 0.37131097E-03_JPRB, 0.37130463E-03_JPRB, &
  & 0.37128797E-03_JPRB, 0.37126053E-03_JPRB, 0.37122436E-03_JPRB, 0.37118276E-03_JPRB, 0.37113696E-03_JPRB, 0.37108220E-03_JPRB, &
  & 0.37101707E-03_JPRB, 0.37094478E-03_JPRB, 0.37087109E-03_JPRB, 0.37080265E-03_JPRB, 0.37074747E-03_JPRB, 0.37071191E-03_JPRB, &
  & 0.37069449E-03_JPRB, 0.37069264E-03_JPRB, 0.37070146E-03_JPRB, 0.37071730E-03_JPRB, 0.37073455E-03_JPRB, 0.37074996E-03_JPRB, &
  & 0.37076350E-03_JPRB, 0.37077509E-03_JPRB, 0.37078530E-03_JPRB, 0.37079462E-03_JPRB, 0.37080256E-03_JPRB, 0.37080947E-03_JPRB, &
  & 0.37081536E-03_JPRB, 0.37081975E-03_JPRB, 0.37082199E-03_JPRB, 0.37082615E-03_JPRB, 0.37083559E-03_JPRB, 0.37085611E-03_JPRB, &
  & 0.37088964E-03_JPRB, 0.37092735E-03_JPRB, 0.37096628E-03_JPRB, 0.37100358E-03_JPRB, 0.37103273E-03_JPRB, 0.37105233E-03_JPRB, &
  & 0.37106755E-03_JPRB, 0.37108256E-03_JPRB, 0.37109808E-03_JPRB, 0.37110881E-03_JPRB, 0.37111463E-03_JPRB, 0.37112034E-03_JPRB, &
  & 0.37112654E-03_JPRB, 0.37113331E-03_JPRB, 0.37113908E-03_JPRB, 0.37114351E-03_JPRB, 0.37114538E-03_JPRB, 0.37114736E-03_JPRB, &
  & 0.37114904E-03_JPRB, 0.37114875E-03_JPRB, 0.37114810E-03_JPRB, 0.37114855E-03_JPRB, 0.37114882E-03_JPRB, 0.37114907E-03_JPRB, &
  & 0.37115340E-03_JPRB, 0.37115810E-03_JPRB, 0.37116232E-03_JPRB, 0.37116236E-03_JPRB  /)

RGHG1(:, 5, 1) = (/ &
  & 0.37134647E-03_JPRB, 0.37134732E-03_JPRB, 0.37134962E-03_JPRB, 0.37135298E-03_JPRB, 0.37135376E-03_JPRB, 0.37134349E-03_JPRB, &
  & 0.37131613E-03_JPRB, 0.37127298E-03_JPRB, 0.37122160E-03_JPRB, 0.37116740E-03_JPRB, 0.37110841E-03_JPRB, 0.37103895E-03_JPRB, &
  & 0.37096144E-03_JPRB, 0.37088285E-03_JPRB, 0.37081008E-03_JPRB, 0.37075002E-03_JPRB, 0.37070859E-03_JPRB, 0.37068881E-03_JPRB, &
  & 0.37068576E-03_JPRB, 0.37069473E-03_JPRB, 0.37071184E-03_JPRB, 0.37073384E-03_JPRB, 0.37075518E-03_JPRB, 0.37077369E-03_JPRB, &
  & 0.37079036E-03_JPRB, 0.37080453E-03_JPRB, 0.37081518E-03_JPRB, 0.37082251E-03_JPRB, 0.37082638E-03_JPRB, 0.37082905E-03_JPRB, &
  & 0.37083211E-03_JPRB, 0.37083465E-03_JPRB, 0.37083676E-03_JPRB, 0.37084269E-03_JPRB, 0.37085673E-03_JPRB, 0.37088390E-03_JPRB, &
  & 0.37092412E-03_JPRB, 0.37096731E-03_JPRB, 0.37100959E-03_JPRB, 0.37104720E-03_JPRB, 0.37107543E-03_JPRB, 0.37109389E-03_JPRB, &
  & 0.37110678E-03_JPRB, 0.37111874E-03_JPRB, 0.37113033E-03_JPRB, 0.37113736E-03_JPRB, 0.37113982E-03_JPRB, 0.37114238E-03_JPRB, &
  & 0.37114539E-03_JPRB, 0.37114948E-03_JPRB, 0.37115355E-03_JPRB, 0.37115658E-03_JPRB, 0.37115781E-03_JPRB, 0.37115954E-03_JPRB, &
  & 0.37116111E-03_JPRB, 0.37116098E-03_JPRB, 0.37116102E-03_JPRB, 0.37116194E-03_JPRB, 0.37116316E-03_JPRB, 0.37116488E-03_JPRB, &
  & 0.37116898E-03_JPRB, 0.37117277E-03_JPRB, 0.37117549E-03_JPRB, 0.37117699E-03_JPRB  /)

RGHG1(:, 6, 1) = (/ &
  & 0.37141162E-03_JPRB, 0.37141083E-03_JPRB, 0.37141254E-03_JPRB, 0.37141715E-03_JPRB, 0.37141797E-03_JPRB, 0.37140180E-03_JPRB, &
  & 0.37135838E-03_JPRB, 0.37129166E-03_JPRB, 0.37121746E-03_JPRB, 0.37114437E-03_JPRB, 0.37106557E-03_JPRB, 0.37097406E-03_JPRB, &
  & 0.37087798E-03_JPRB, 0.37078994E-03_JPRB, 0.37071854E-03_JPRB, 0.37067104E-03_JPRB, 0.37065027E-03_JPRB, 0.37065416E-03_JPRB, &
  & 0.37067267E-03_JPRB, 0.37069787E-03_JPRB, 0.37072741E-03_JPRB, 0.37075866E-03_JPRB, 0.37078614E-03_JPRB, 0.37080929E-03_JPRB, &
  & 0.37083065E-03_JPRB, 0.37084870E-03_JPRB, 0.37086000E-03_JPRB, 0.37086436E-03_JPRB, 0.37086211E-03_JPRB, 0.37085844E-03_JPRB, &
  & 0.37085724E-03_JPRB, 0.37085701E-03_JPRB, 0.37085893E-03_JPRB, 0.37086751E-03_JPRB, 0.37088845E-03_JPRB, 0.37092559E-03_JPRB, &
  & 0.37097585E-03_JPRB, 0.37102727E-03_JPRB, 0.37107456E-03_JPRB, 0.37111264E-03_JPRB, 0.37113948E-03_JPRB, 0.37115626E-03_JPRB, &
  & 0.37116563E-03_JPRB, 0.37117302E-03_JPRB, 0.37117870E-03_JPRB, 0.37118020E-03_JPRB, 0.37117760E-03_JPRB, 0.37117545E-03_JPRB, &
  & 0.37117368E-03_JPRB, 0.37117374E-03_JPRB, 0.37117525E-03_JPRB, 0.37117618E-03_JPRB, 0.37117646E-03_JPRB, 0.37117781E-03_JPRB, &
  & 0.37117922E-03_JPRB, 0.37117933E-03_JPRB, 0.37118041E-03_JPRB, 0.37118203E-03_JPRB, 0.37118468E-03_JPRB, 0.37118859E-03_JPRB, &
  & 0.37119235E-03_JPRB, 0.37119477E-03_JPRB, 0.37119525E-03_JPRB, 0.37119894E-03_JPRB  /)

RGHG1(:, 7, 1) = (/ &
  & 0.37151533E-03_JPRB, 0.37151550E-03_JPRB, 0.37151983E-03_JPRB, 0.37152898E-03_JPRB, 0.37153443E-03_JPRB, 0.37151463E-03_JPRB, &
  & 0.37145029E-03_JPRB, 0.37135449E-03_JPRB, 0.37124995E-03_JPRB, 0.37113350E-03_JPRB, 0.37099981E-03_JPRB, 0.37086325E-03_JPRB, &
  & 0.37074697E-03_JPRB, 0.37066121E-03_JPRB, 0.37060512E-03_JPRB, 0.37058326E-03_JPRB, 0.37059601E-03_JPRB, 0.37063719E-03_JPRB, &
  & 0.37069065E-03_JPRB, 0.37074499E-03_JPRB, 0.37079765E-03_JPRB, 0.37084452E-03_JPRB, 0.37088422E-03_JPRB, 0.37091946E-03_JPRB, &
  & 0.37095373E-03_JPRB, 0.37098440E-03_JPRB, 0.37100418E-03_JPRB, 0.37100909E-03_JPRB, 0.37099926E-03_JPRB, 0.37098222E-03_JPRB, &
  & 0.37096632E-03_JPRB, 0.37095674E-03_JPRB, 0.37095864E-03_JPRB, 0.37097589E-03_JPRB, 0.37101128E-03_JPRB, 0.37106512E-03_JPRB, &
  & 0.37112912E-03_JPRB, 0.37118910E-03_JPRB, 0.37123891E-03_JPRB, 0.37127592E-03_JPRB, 0.37129968E-03_JPRB, 0.37131131E-03_JPRB, &
  & 0.37131179E-03_JPRB, 0.37130485E-03_JPRB, 0.37129105E-03_JPRB, 0.37127474E-03_JPRB, 0.37125782E-03_JPRB, 0.37124455E-03_JPRB, &
  & 0.37123468E-03_JPRB, 0.37122861E-03_JPRB, 0.37122564E-03_JPRB, 0.37122338E-03_JPRB, 0.37122140E-03_JPRB, 0.37122212E-03_JPRB, &
  & 0.37122418E-03_JPRB, 0.37122741E-03_JPRB, 0.37123181E-03_JPRB, 0.37123609E-03_JPRB, 0.37123993E-03_JPRB, 0.37124587E-03_JPRB, &
  & 0.37125016E-03_JPRB, 0.37125198E-03_JPRB, 0.37125171E-03_JPRB, 0.37125241E-03_JPRB  /)

RGHG1(:, 8, 1) = (/ &
  & 0.37165715E-03_JPRB, 0.37166349E-03_JPRB, 0.37167062E-03_JPRB, 0.37168471E-03_JPRB, 0.37170099E-03_JPRB, 0.37168666E-03_JPRB, &
  & 0.37160941E-03_JPRB, 0.37148120E-03_JPRB, 0.37132378E-03_JPRB, 0.37113534E-03_JPRB, 0.37093440E-03_JPRB, 0.37075824E-03_JPRB, &
  & 0.37063143E-03_JPRB, 0.37055625E-03_JPRB, 0.37051819E-03_JPRB, 0.37051612E-03_JPRB, 0.37055163E-03_JPRB, 0.37062364E-03_JPRB, &
  & 0.37071510E-03_JPRB, 0.37080917E-03_JPRB, 0.37089905E-03_JPRB, 0.37097755E-03_JPRB, 0.37104466E-03_JPRB, 0.37110753E-03_JPRB, &
  & 0.37117199E-03_JPRB, 0.37123604E-03_JPRB, 0.37129044E-03_JPRB, 0.37132566E-03_JPRB, 0.37133736E-03_JPRB, 0.37133058E-03_JPRB, &
  & 0.37131588E-03_JPRB, 0.37130571E-03_JPRB, 0.37131125E-03_JPRB, 0.37133802E-03_JPRB, 0.37138462E-03_JPRB, 0.37144691E-03_JPRB, &
  & 0.37151165E-03_JPRB, 0.37156506E-03_JPRB, 0.37159891E-03_JPRB, 0.37161713E-03_JPRB, 0.37161859E-03_JPRB, 0.37160621E-03_JPRB, &
  & 0.37157894E-03_JPRB, 0.37153714E-03_JPRB, 0.37148600E-03_JPRB, 0.37143607E-03_JPRB, 0.37139349E-03_JPRB, 0.37136273E-03_JPRB, &
  & 0.37134092E-03_JPRB, 0.37132616E-03_JPRB, 0.37131525E-03_JPRB, 0.37130724E-03_JPRB, 0.37130153E-03_JPRB, 0.37130047E-03_JPRB, &
  & 0.37130347E-03_JPRB, 0.37131022E-03_JPRB, 0.37131876E-03_JPRB, 0.37132671E-03_JPRB, 0.37133161E-03_JPRB, 0.37133904E-03_JPRB, &
  & 0.37134290E-03_JPRB, 0.37134267E-03_JPRB, 0.37134009E-03_JPRB, 0.37133878E-03_JPRB  /)

RGHG1(:, 9, 1) = (/ &
  & 0.37183508E-03_JPRB, 0.37185274E-03_JPRB, 0.37185908E-03_JPRB, 0.37187271E-03_JPRB, 0.37189884E-03_JPRB, 0.37189591E-03_JPRB, &
  & 0.37181644E-03_JPRB, 0.37165576E-03_JPRB, 0.37143089E-03_JPRB, 0.37115859E-03_JPRB, 0.37089624E-03_JPRB, 0.37069748E-03_JPRB, &
  & 0.37057206E-03_JPRB, 0.37050999E-03_JPRB, 0.37048448E-03_JPRB, 0.37048889E-03_JPRB, 0.37052921E-03_JPRB, 0.37061589E-03_JPRB, &
  & 0.37073745E-03_JPRB, 0.37087395E-03_JPRB, 0.37101202E-03_JPRB, 0.37114089E-03_JPRB, 0.37125743E-03_JPRB, 0.37137074E-03_JPRB, &
  & 0.37149134E-03_JPRB, 0.37162333E-03_JPRB, 0.37175998E-03_JPRB, 0.37188788E-03_JPRB, 0.37199288E-03_JPRB, 0.37207059E-03_JPRB, &
  & 0.37212471E-03_JPRB, 0.37216167E-03_JPRB, 0.37219032E-03_JPRB, 0.37221611E-03_JPRB, 0.37223767E-03_JPRB, 0.37225476E-03_JPRB, &
  & 0.37226126E-03_JPRB, 0.37225279E-03_JPRB, 0.37221949E-03_JPRB, 0.37217277E-03_JPRB, 0.37211202E-03_JPRB, 0.37204075E-03_JPRB, &
  & 0.37195883E-03_JPRB, 0.37185908E-03_JPRB, 0.37175535E-03_JPRB, 0.37166187E-03_JPRB, 0.37159029E-03_JPRB, 0.37154107E-03_JPRB, &
  & 0.37150555E-03_JPRB, 0.37147907E-03_JPRB, 0.37145625E-03_JPRB, 0.37143726E-03_JPRB, 0.37142518E-03_JPRB, 0.37142051E-03_JPRB, &
  & 0.37142511E-03_JPRB, 0.37143395E-03_JPRB, 0.37144440E-03_JPRB, 0.37145550E-03_JPRB, 0.37146282E-03_JPRB, 0.37147084E-03_JPRB, &
  & 0.37147439E-03_JPRB, 0.37147235E-03_JPRB, 0.37146907E-03_JPRB, 0.37147001E-03_JPRB  /)

RGHG1(:,10, 1) = (/ &
  & 0.37204500E-03_JPRB, 0.37207025E-03_JPRB, 0.37207126E-03_JPRB, 0.37207411E-03_JPRB, 0.37208953E-03_JPRB, 0.37207936E-03_JPRB, &
  & 0.37199270E-03_JPRB, 0.37180566E-03_JPRB, 0.37153290E-03_JPRB, 0.37120348E-03_JPRB, 0.37090090E-03_JPRB, 0.37069025E-03_JPRB, &
  & 0.37056709E-03_JPRB, 0.37051012E-03_JPRB, 0.37048843E-03_JPRB, 0.37049475E-03_JPRB, 0.37053610E-03_JPRB, 0.37062749E-03_JPRB, &
  & 0.37076341E-03_JPRB, 0.37092788E-03_JPRB, 0.37110633E-03_JPRB, 0.37128816E-03_JPRB, 0.37146791E-03_JPRB, 0.37165097E-03_JPRB, &
  & 0.37185305E-03_JPRB, 0.37209056E-03_JPRB, 0.37236219E-03_JPRB, 0.37265089E-03_JPRB, 0.37292902E-03_JPRB, 0.37317178E-03_JPRB, &
  & 0.37336101E-03_JPRB, 0.37347808E-03_JPRB, 0.37351979E-03_JPRB, 0.37349555E-03_JPRB, 0.37342020E-03_JPRB, 0.37331522E-03_JPRB, &
  & 0.37319299E-03_JPRB, 0.37306009E-03_JPRB, 0.37291014E-03_JPRB, 0.37275637E-03_JPRB, 0.37260603E-03_JPRB, 0.37245614E-03_JPRB, &
  & 0.37230966E-03_JPRB, 0.37215494E-03_JPRB, 0.37201120E-03_JPRB, 0.37189336E-03_JPRB, 0.37181117E-03_JPRB, 0.37175611E-03_JPRB, &
  & 0.37170989E-03_JPRB, 0.37166982E-03_JPRB, 0.37163396E-03_JPRB, 0.37160027E-03_JPRB, 0.37157685E-03_JPRB, 0.37156630E-03_JPRB, &
  & 0.37157253E-03_JPRB, 0.37158245E-03_JPRB, 0.37158986E-03_JPRB, 0.37160116E-03_JPRB, 0.37161507E-03_JPRB, 0.37162631E-03_JPRB, &
  & 0.37163296E-03_JPRB, 0.37163494E-03_JPRB, 0.37163793E-03_JPRB, 0.37164217E-03_JPRB  /)

RGHG1(:,11, 1) = (/ &
  & 0.37230195E-03_JPRB, 0.37232015E-03_JPRB, 0.37231763E-03_JPRB, 0.37230863E-03_JPRB, 0.37228836E-03_JPRB, 0.37223203E-03_JPRB, &
  & 0.37211272E-03_JPRB, 0.37189997E-03_JPRB, 0.37160589E-03_JPRB, 0.37125324E-03_JPRB, 0.37093355E-03_JPRB, 0.37071718E-03_JPRB, &
  & 0.37059446E-03_JPRB, 0.37053993E-03_JPRB, 0.37052425E-03_JPRB, 0.37054067E-03_JPRB, 0.37059033E-03_JPRB, 0.37068608E-03_JPRB, &
  & 0.37082649E-03_JPRB, 0.37099924E-03_JPRB, 0.37119405E-03_JPRB, 0.37140733E-03_JPRB, 0.37163820E-03_JPRB, 0.37188988E-03_JPRB, &
  & 0.37218089E-03_JPRB, 0.37253806E-03_JPRB, 0.37295817E-03_JPRB, 0.37340008E-03_JPRB, 0.37381309E-03_JPRB, 0.37414516E-03_JPRB, &
  & 0.37436285E-03_JPRB, 0.37445384E-03_JPRB, 0.37442667E-03_JPRB, 0.37431022E-03_JPRB, 0.37413784E-03_JPRB, 0.37393216E-03_JPRB, &
  & 0.37370618E-03_JPRB, 0.37346924E-03_JPRB, 0.37323278E-03_JPRB, 0.37301306E-03_JPRB, 0.37281506E-03_JPRB, 0.37262677E-03_JPRB, &
  & 0.37245149E-03_JPRB, 0.37228591E-03_JPRB, 0.37214881E-03_JPRB, 0.37204791E-03_JPRB, 0.37198184E-03_JPRB, 0.37193494E-03_JPRB, &
  & 0.37188424E-03_JPRB, 0.37183328E-03_JPRB, 0.37178710E-03_JPRB, 0.37174439E-03_JPRB, 0.37170994E-03_JPRB, 0.37169228E-03_JPRB, &
  & 0.37169881E-03_JPRB, 0.37171195E-03_JPRB, 0.37171647E-03_JPRB, 0.37172857E-03_JPRB, 0.37174977E-03_JPRB, 0.37176973E-03_JPRB, &
  & 0.37178432E-03_JPRB, 0.37179751E-03_JPRB, 0.37180789E-03_JPRB, 0.37181088E-03_JPRB  /)

RGHG1(:,12, 1) = (/ &
  & 0.37264656E-03_JPRB, 0.37265644E-03_JPRB, 0.37265131E-03_JPRB, 0.37264454E-03_JPRB, 0.37259893E-03_JPRB, 0.37248071E-03_JPRB, &
  & 0.37228703E-03_JPRB, 0.37200551E-03_JPRB, 0.37168658E-03_JPRB, 0.37133362E-03_JPRB, 0.37101674E-03_JPRB, 0.37079964E-03_JPRB, &
  & 0.37068377E-03_JPRB, 0.37064244E-03_JPRB, 0.37064278E-03_JPRB, 0.37067629E-03_JPRB, 0.37073843E-03_JPRB, 0.37083871E-03_JPRB, &
  & 0.37098032E-03_JPRB, 0.37115474E-03_JPRB, 0.37135433E-03_JPRB, 0.37158076E-03_JPRB, 0.37183927E-03_JPRB, 0.37213711E-03_JPRB, &
  & 0.37250078E-03_JPRB, 0.37296690E-03_JPRB, 0.37350306E-03_JPRB, 0.37400906E-03_JPRB, 0.37441229E-03_JPRB, 0.37467137E-03_JPRB, &
  & 0.37478515E-03_JPRB, 0.37478488E-03_JPRB, 0.37469394E-03_JPRB, 0.37454262E-03_JPRB, 0.37435789E-03_JPRB, 0.37412370E-03_JPRB, &
  & 0.37382366E-03_JPRB, 0.37349616E-03_JPRB, 0.37319968E-03_JPRB, 0.37295703E-03_JPRB, 0.37274394E-03_JPRB, 0.37255627E-03_JPRB, &
  & 0.37240079E-03_JPRB, 0.37226804E-03_JPRB, 0.37216911E-03_JPRB, 0.37210103E-03_JPRB, 0.37206028E-03_JPRB, 0.37201871E-03_JPRB, &
  & 0.37196874E-03_JPRB, 0.37191326E-03_JPRB, 0.37185961E-03_JPRB, 0.37181213E-03_JPRB, 0.37177790E-03_JPRB, 0.37175841E-03_JPRB, &
  & 0.37176537E-03_JPRB, 0.37178156E-03_JPRB, 0.37178954E-03_JPRB, 0.37181250E-03_JPRB, 0.37184135E-03_JPRB, 0.37186769E-03_JPRB, &
  & 0.37189365E-03_JPRB, 0.37191966E-03_JPRB, 0.37193647E-03_JPRB, 0.37194177E-03_JPRB  /)

RGHG1(:,13, 1) = (/ &
  & 0.37317366E-03_JPRB, 0.37318377E-03_JPRB, 0.37316803E-03_JPRB, 0.37316881E-03_JPRB, 0.37313433E-03_JPRB, 0.37295593E-03_JPRB, &
  & 0.37263689E-03_JPRB, 0.37223668E-03_JPRB, 0.37187552E-03_JPRB, 0.37152761E-03_JPRB, 0.37121976E-03_JPRB, 0.37101329E-03_JPRB, &
  & 0.37091693E-03_JPRB, 0.37089744E-03_JPRB, 0.37091711E-03_JPRB, 0.37096648E-03_JPRB, 0.37103855E-03_JPRB, 0.37113953E-03_JPRB, &
  & 0.37127467E-03_JPRB, 0.37144214E-03_JPRB, 0.37163962E-03_JPRB, 0.37186837E-03_JPRB, 0.37213386E-03_JPRB, 0.37244835E-03_JPRB, &
  & 0.37286419E-03_JPRB, 0.37343420E-03_JPRB, 0.37405089E-03_JPRB, 0.37453865E-03_JPRB, 0.37484236E-03_JPRB, 0.37498778E-03_JPRB, &
  & 0.37501707E-03_JPRB, 0.37496582E-03_JPRB, 0.37485265E-03_JPRB, 0.37469763E-03_JPRB, 0.37452482E-03_JPRB, 0.37429869E-03_JPRB, &
  & 0.37394991E-03_JPRB, 0.37352950E-03_JPRB, 0.37316975E-03_JPRB, 0.37289406E-03_JPRB, 0.37266347E-03_JPRB, 0.37247545E-03_JPRB, &
  & 0.37233340E-03_JPRB, 0.37222698E-03_JPRB, 0.37215105E-03_JPRB, 0.37209864E-03_JPRB, 0.37206974E-03_JPRB, 0.37202463E-03_JPRB, &
  & 0.37197282E-03_JPRB, 0.37191632E-03_JPRB, 0.37185802E-03_JPRB, 0.37180406E-03_JPRB, 0.37177180E-03_JPRB, 0.37175873E-03_JPRB, &
  & 0.37176620E-03_JPRB, 0.37178268E-03_JPRB, 0.37179746E-03_JPRB, 0.37183379E-03_JPRB, 0.37187762E-03_JPRB, 0.37191640E-03_JPRB, &
  & 0.37195325E-03_JPRB, 0.37198850E-03_JPRB, 0.37201951E-03_JPRB, 0.37203569E-03_JPRB  /)

RGHG1(:,14, 1) = (/ &
  & 0.37380944E-03_JPRB, 0.37382047E-03_JPRB, 0.37379030E-03_JPRB, 0.37378572E-03_JPRB, 0.37377466E-03_JPRB, 0.37356036E-03_JPRB, &
  & 0.37311939E-03_JPRB, 0.37261585E-03_JPRB, 0.37220825E-03_JPRB, 0.37185606E-03_JPRB, 0.37155539E-03_JPRB, 0.37137431E-03_JPRB, &
  & 0.37130313E-03_JPRB, 0.37130227E-03_JPRB, 0.37133478E-03_JPRB, 0.37139080E-03_JPRB, 0.37146222E-03_JPRB, 0.37155209E-03_JPRB, &
  & 0.37166693E-03_JPRB, 0.37180999E-03_JPRB, 0.37198753E-03_JPRB, 0.37220713E-03_JPRB, 0.37246823E-03_JPRB, 0.37278532E-03_JPRB, &
  & 0.37324716E-03_JPRB, 0.37391293E-03_JPRB, 0.37457822E-03_JPRB, 0.37500778E-03_JPRB, 0.37521537E-03_JPRB, 0.37529259E-03_JPRB, &
  & 0.37529277E-03_JPRB, 0.37523051E-03_JPRB, 0.37510426E-03_JPRB, 0.37493428E-03_JPRB, 0.37474734E-03_JPRB, 0.37451457E-03_JPRB, &
  & 0.37415094E-03_JPRB, 0.37368689E-03_JPRB, 0.37328549E-03_JPRB, 0.37297717E-03_JPRB, 0.37272647E-03_JPRB, 0.37251887E-03_JPRB, &
  & 0.37236226E-03_JPRB, 0.37224717E-03_JPRB, 0.37216731E-03_JPRB, 0.37210134E-03_JPRB, 0.37205139E-03_JPRB, 0.37200212E-03_JPRB, &
  & 0.37194605E-03_JPRB, 0.37188669E-03_JPRB, 0.37182187E-03_JPRB, 0.37175946E-03_JPRB, 0.37172622E-03_JPRB, 0.37172076E-03_JPRB, &
  & 0.37172978E-03_JPRB, 0.37174485E-03_JPRB, 0.37176604E-03_JPRB, 0.37180910E-03_JPRB, 0.37186531E-03_JPRB, 0.37192577E-03_JPRB, &
  & 0.37197900E-03_JPRB, 0.37202110E-03_JPRB, 0.37206736E-03_JPRB, 0.37210133E-03_JPRB  /)

RGHG1(:,15, 1) = (/ &
  & 0.37424183E-03_JPRB, 0.37427942E-03_JPRB, 0.37427988E-03_JPRB, 0.37428201E-03_JPRB, 0.37427303E-03_JPRB, 0.37405505E-03_JPRB, &
  & 0.37357896E-03_JPRB, 0.37303234E-03_JPRB, 0.37260358E-03_JPRB, 0.37224029E-03_JPRB, 0.37194165E-03_JPRB, 0.37177425E-03_JPRB, &
  & 0.37171590E-03_JPRB, 0.37172492E-03_JPRB, 0.37176163E-03_JPRB, 0.37181268E-03_JPRB, 0.37186981E-03_JPRB, 0.37193403E-03_JPRB, &
  & 0.37201543E-03_JPRB, 0.37212274E-03_JPRB, 0.37227560E-03_JPRB, 0.37249325E-03_JPRB, 0.37275995E-03_JPRB, 0.37309190E-03_JPRB, &
  & 0.37361109E-03_JPRB, 0.37436293E-03_JPRB, 0.37502940E-03_JPRB, 0.37538690E-03_JPRB, 0.37554222E-03_JPRB, 0.37561026E-03_JPRB, &
  & 0.37562456E-03_JPRB, 0.37557007E-03_JPRB, 0.37543796E-03_JPRB, 0.37522740E-03_JPRB, 0.37497249E-03_JPRB, 0.37468380E-03_JPRB, &
  & 0.37429852E-03_JPRB, 0.37386673E-03_JPRB, 0.37348821E-03_JPRB, 0.37317749E-03_JPRB, 0.37290342E-03_JPRB, 0.37265477E-03_JPRB, &
  & 0.37246291E-03_JPRB, 0.37232084E-03_JPRB, 0.37222759E-03_JPRB, 0.37214002E-03_JPRB, 0.37205418E-03_JPRB, 0.37199198E-03_JPRB, &
  & 0.37192502E-03_JPRB, 0.37185974E-03_JPRB, 0.37179090E-03_JPRB, 0.37172042E-03_JPRB, 0.37168287E-03_JPRB, 0.37167500E-03_JPRB, &
  & 0.37168265E-03_JPRB, 0.37169906E-03_JPRB, 0.37172319E-03_JPRB, 0.37177266E-03_JPRB, 0.37183820E-03_JPRB, 0.37191562E-03_JPRB, &
  & 0.37199152E-03_JPRB, 0.37205000E-03_JPRB, 0.37210545E-03_JPRB, 0.37215248E-03_JPRB  /)

RGHG1(:,16, 1) = (/ &
  & 0.37437384E-03_JPRB, 0.37453148E-03_JPRB, 0.37458514E-03_JPRB, 0.37456559E-03_JPRB, 0.37452118E-03_JPRB, 0.37430895E-03_JPRB, &
  & 0.37386624E-03_JPRB, 0.37334878E-03_JPRB, 0.37293045E-03_JPRB, 0.37255388E-03_JPRB, 0.37224546E-03_JPRB, 0.37207297E-03_JPRB, &
  & 0.37200781E-03_JPRB, 0.37201382E-03_JPRB, 0.37204527E-03_JPRB, 0.37208077E-03_JPRB, 0.37211633E-03_JPRB, 0.37215576E-03_JPRB, &
  & 0.37220828E-03_JPRB, 0.37229503E-03_JPRB, 0.37244708E-03_JPRB, 0.37268825E-03_JPRB, 0.37298716E-03_JPRB, 0.37336723E-03_JPRB, &
  & 0.37396517E-03_JPRB, 0.37477228E-03_JPRB, 0.37540147E-03_JPRB, 0.37571898E-03_JPRB, 0.37586832E-03_JPRB, 0.37595216E-03_JPRB, &
  & 0.37598191E-03_JPRB, 0.37594516E-03_JPRB, 0.37581869E-03_JPRB, 0.37555607E-03_JPRB, 0.37520743E-03_JPRB, 0.37484690E-03_JPRB, &
  & 0.37446827E-03_JPRB, 0.37409174E-03_JPRB, 0.37372958E-03_JPRB, 0.37340760E-03_JPRB, 0.37310388E-03_JPRB, 0.37281647E-03_JPRB, &
  & 0.37258560E-03_JPRB, 0.37241177E-03_JPRB, 0.37231652E-03_JPRB, 0.37222379E-03_JPRB, 0.37210900E-03_JPRB, 0.37201687E-03_JPRB, &
  & 0.37193393E-03_JPRB, 0.37185927E-03_JPRB, 0.37178609E-03_JPRB, 0.37170536E-03_JPRB, 0.37165548E-03_JPRB, 0.37163561E-03_JPRB, &
  & 0.37164079E-03_JPRB, 0.37165221E-03_JPRB, 0.37167966E-03_JPRB, 0.37173511E-03_JPRB, 0.37180911E-03_JPRB, 0.37189808E-03_JPRB, &
  & 0.37199113E-03_JPRB, 0.37206702E-03_JPRB, 0.37212719E-03_JPRB, 0.37216744E-03_JPRB  /)

RGHG1(:,17, 1) = (/ &
  & 0.37427963E-03_JPRB, 0.37455980E-03_JPRB, 0.37467210E-03_JPRB, 0.37465878E-03_JPRB, 0.37460111E-03_JPRB, 0.37439652E-03_JPRB, &
  & 0.37400718E-03_JPRB, 0.37353617E-03_JPRB, 0.37311670E-03_JPRB, 0.37272187E-03_JPRB, 0.37239733E-03_JPRB, 0.37221425E-03_JPRB, &
  & 0.37213860E-03_JPRB, 0.37213255E-03_JPRB, 0.37215130E-03_JPRB, 0.37217146E-03_JPRB, 0.37219527E-03_JPRB, 0.37222882E-03_JPRB, &
  & 0.37227684E-03_JPRB, 0.37236675E-03_JPRB, 0.37253607E-03_JPRB, 0.37281412E-03_JPRB, 0.37317540E-03_JPRB, 0.37364479E-03_JPRB, &
  & 0.37432969E-03_JPRB, 0.37515613E-03_JPRB, 0.37577490E-03_JPRB, 0.37609193E-03_JPRB, 0.37624121E-03_JPRB, 0.37633085E-03_JPRB, &
  & 0.37636207E-03_JPRB, 0.37633909E-03_JPRB, 0.37623095E-03_JPRB, 0.37594972E-03_JPRB, 0.37552249E-03_JPRB, 0.37510983E-03_JPRB, &
  & 0.37475460E-03_JPRB, 0.37441307E-03_JPRB, 0.37404161E-03_JPRB, 0.37367190E-03_JPRB, 0.37330637E-03_JPRB, 0.37296968E-03_JPRB, &
  & 0.37271956E-03_JPRB, 0.37253978E-03_JPRB, 0.37244078E-03_JPRB, 0.37233910E-03_JPRB, 0.37220090E-03_JPRB, 0.37207893E-03_JPRB, &
  & 0.37198120E-03_JPRB, 0.37189712E-03_JPRB, 0.37181409E-03_JPRB, 0.37172004E-03_JPRB, 0.37164283E-03_JPRB, 0.37160824E-03_JPRB, &
  & 0.37160722E-03_JPRB, 0.37160955E-03_JPRB, 0.37163621E-03_JPRB, 0.37169462E-03_JPRB, 0.37177375E-03_JPRB, 0.37186421E-03_JPRB, &
  & 0.37196465E-03_JPRB, 0.37205346E-03_JPRB, 0.37212414E-03_JPRB, 0.37214784E-03_JPRB  /)

RGHG1(:,18, 1) = (/ &
  & 0.37406440E-03_JPRB, 0.37436578E-03_JPRB, 0.37454749E-03_JPRB, 0.37459563E-03_JPRB, 0.37455585E-03_JPRB, 0.37437300E-03_JPRB, &
  & 0.37404321E-03_JPRB, 0.37361582E-03_JPRB, 0.37317981E-03_JPRB, 0.37277255E-03_JPRB, 0.37244389E-03_JPRB, 0.37226290E-03_JPRB, &
  & 0.37219361E-03_JPRB, 0.37218524E-03_JPRB, 0.37219760E-03_JPRB, 0.37221202E-03_JPRB, 0.37223476E-03_JPRB, 0.37227380E-03_JPRB, &
  & 0.37232659E-03_JPRB, 0.37242251E-03_JPRB, 0.37260724E-03_JPRB, 0.37292286E-03_JPRB, 0.37337017E-03_JPRB, 0.37396471E-03_JPRB, &
  & 0.37473730E-03_JPRB, 0.37556379E-03_JPRB, 0.37619906E-03_JPRB, 0.37652913E-03_JPRB, 0.37667956E-03_JPRB, 0.37675941E-03_JPRB, &
  & 0.37677670E-03_JPRB, 0.37676388E-03_JPRB, 0.37667762E-03_JPRB, 0.37640379E-03_JPRB, 0.37594311E-03_JPRB, 0.37550215E-03_JPRB, &
  & 0.37516212E-03_JPRB, 0.37483527E-03_JPRB, 0.37444698E-03_JPRB, 0.37401383E-03_JPRB, 0.37357144E-03_JPRB, 0.37318272E-03_JPRB, &
  & 0.37292013E-03_JPRB, 0.37274902E-03_JPRB, 0.37262678E-03_JPRB, 0.37249175E-03_JPRB, 0.37232034E-03_JPRB, 0.37217095E-03_JPRB, &
  & 0.37205717E-03_JPRB, 0.37196374E-03_JPRB, 0.37187206E-03_JPRB, 0.37176354E-03_JPRB, 0.37165689E-03_JPRB, 0.37159776E-03_JPRB, &
  & 0.37158637E-03_JPRB, 0.37158209E-03_JPRB, 0.37160132E-03_JPRB, 0.37165691E-03_JPRB, 0.37173265E-03_JPRB, 0.37182642E-03_JPRB, &
  & 0.37192100E-03_JPRB, 0.37201199E-03_JPRB, 0.37210107E-03_JPRB, 0.37213053E-03_JPRB  /)

RGHG1(:,19, 1) = (/ &
  & 0.37392233E-03_JPRB, 0.37415132E-03_JPRB, 0.37433026E-03_JPRB, 0.37440136E-03_JPRB, 0.37438818E-03_JPRB, 0.37426136E-03_JPRB, &
  & 0.37400700E-03_JPRB, 0.37363611E-03_JPRB, 0.37320555E-03_JPRB, 0.37280308E-03_JPRB, 0.37248934E-03_JPRB, 0.37232244E-03_JPRB, &
  & 0.37226624E-03_JPRB, 0.37226445E-03_JPRB, 0.37228122E-03_JPRB, 0.37230259E-03_JPRB, 0.37233422E-03_JPRB, 0.37238186E-03_JPRB, &
  & 0.37244078E-03_JPRB, 0.37254003E-03_JPRB, 0.37273019E-03_JPRB, 0.37307609E-03_JPRB, 0.37361410E-03_JPRB, 0.37435240E-03_JPRB, &
  & 0.37521210E-03_JPRB, 0.37603352E-03_JPRB, 0.37667805E-03_JPRB, 0.37702158E-03_JPRB, 0.37718219E-03_JPRB, 0.37724790E-03_JPRB, &
  & 0.37724593E-03_JPRB, 0.37723158E-03_JPRB, 0.37714511E-03_JPRB, 0.37686590E-03_JPRB, 0.37641790E-03_JPRB, 0.37599022E-03_JPRB, &
  & 0.37567066E-03_JPRB, 0.37536373E-03_JPRB, 0.37497241E-03_JPRB, 0.37448968E-03_JPRB, 0.37397726E-03_JPRB, 0.37354772E-03_JPRB, &
  & 0.37325696E-03_JPRB, 0.37305553E-03_JPRB, 0.37288082E-03_JPRB, 0.37268921E-03_JPRB, 0.37249245E-03_JPRB, 0.37231376E-03_JPRB, &
  & 0.37217184E-03_JPRB, 0.37206843E-03_JPRB, 0.37196625E-03_JPRB, 0.37183746E-03_JPRB, 0.37170712E-03_JPRB, 0.37162567E-03_JPRB, &
  & 0.37159732E-03_JPRB, 0.37158155E-03_JPRB, 0.37158991E-03_JPRB, 0.37163379E-03_JPRB, 0.37170055E-03_JPRB, 0.37179284E-03_JPRB, &
  & 0.37187940E-03_JPRB, 0.37195688E-03_JPRB, 0.37204438E-03_JPRB, 0.37213034E-03_JPRB  /)

RGHG1(:,20, 1) = (/ &
  & 0.37388664E-03_JPRB, 0.37401760E-03_JPRB, 0.37414919E-03_JPRB, 0.37419744E-03_JPRB, 0.37420162E-03_JPRB, 0.37413339E-03_JPRB, &
  & 0.37394598E-03_JPRB, 0.37363416E-03_JPRB, 0.37324610E-03_JPRB, 0.37288000E-03_JPRB, 0.37260142E-03_JPRB, 0.37245760E-03_JPRB, &
  & 0.37241292E-03_JPRB, 0.37241821E-03_JPRB, 0.37244522E-03_JPRB, 0.37248231E-03_JPRB, 0.37253065E-03_JPRB, 0.37259007E-03_JPRB, &
  & 0.37265644E-03_JPRB, 0.37275829E-03_JPRB, 0.37294785E-03_JPRB, 0.37331072E-03_JPRB, 0.37392416E-03_JPRB, 0.37480052E-03_JPRB, &
  & 0.37574694E-03_JPRB, 0.37655783E-03_JPRB, 0.37719465E-03_JPRB, 0.37755030E-03_JPRB, 0.37772785E-03_JPRB, 0.37778958E-03_JPRB, &
  & 0.37777572E-03_JPRB, 0.37774982E-03_JPRB, 0.37764058E-03_JPRB, 0.37733932E-03_JPRB, 0.37692688E-03_JPRB, 0.37655640E-03_JPRB, &
  & 0.37628518E-03_JPRB, 0.37602946E-03_JPRB, 0.37567274E-03_JPRB, 0.37517267E-03_JPRB, 0.37459732E-03_JPRB, 0.37409670E-03_JPRB, &
  & 0.37373759E-03_JPRB, 0.37344598E-03_JPRB, 0.37319180E-03_JPRB, 0.37294510E-03_JPRB, 0.37273031E-03_JPRB, 0.37252513E-03_JPRB, &
  & 0.37234777E-03_JPRB, 0.37222423E-03_JPRB, 0.37211210E-03_JPRB, 0.37195986E-03_JPRB, 0.37181348E-03_JPRB, 0.37171433E-03_JPRB, &
  & 0.37166808E-03_JPRB, 0.37163725E-03_JPRB, 0.37163027E-03_JPRB, 0.37165350E-03_JPRB, 0.37170765E-03_JPRB, 0.37178839E-03_JPRB, &
  & 0.37186207E-03_JPRB, 0.37191971E-03_JPRB, 0.37198992E-03_JPRB, 0.37212011E-03_JPRB  /)

RGHG1(:,21, 1) = (/ &
  & 0.37392056E-03_JPRB, 0.37396879E-03_JPRB, 0.37404279E-03_JPRB, 0.37405403E-03_JPRB, 0.37406545E-03_JPRB, 0.37403153E-03_JPRB, &
  & 0.37388948E-03_JPRB, 0.37363343E-03_JPRB, 0.37331646E-03_JPRB, 0.37301636E-03_JPRB, 0.37279253E-03_JPRB, 0.37267873E-03_JPRB, &
  & 0.37264197E-03_JPRB, 0.37265132E-03_JPRB, 0.37268880E-03_JPRB, 0.37274386E-03_JPRB, 0.37281160E-03_JPRB, 0.37288550E-03_JPRB, &
  & 0.37296254E-03_JPRB, 0.37307054E-03_JPRB, 0.37326018E-03_JPRB, 0.37363148E-03_JPRB, 0.37429989E-03_JPRB, 0.37528975E-03_JPRB, &
  & 0.37631564E-03_JPRB, 0.37711821E-03_JPRB, 0.37773580E-03_JPRB, 0.37810606E-03_JPRB, 0.37830335E-03_JPRB, 0.37837083E-03_JPRB, &
  & 0.37835219E-03_JPRB, 0.37830784E-03_JPRB, 0.37816657E-03_JPRB, 0.37785011E-03_JPRB, 0.37749332E-03_JPRB, 0.37720976E-03_JPRB, &
  & 0.37701113E-03_JPRB, 0.37683487E-03_JPRB, 0.37654422E-03_JPRB, 0.37605837E-03_JPRB, 0.37542739E-03_JPRB, 0.37480470E-03_JPRB, &
  & 0.37432120E-03_JPRB, 0.37389791E-03_JPRB, 0.37355660E-03_JPRB, 0.37326445E-03_JPRB, 0.37303212E-03_JPRB, 0.37280574E-03_JPRB, &
  & 0.37259295E-03_JPRB, 0.37243809E-03_JPRB, 0.37231151E-03_JPRB, 0.37213965E-03_JPRB, 0.37198542E-03_JPRB, 0.37187329E-03_JPRB, &
  & 0.37181018E-03_JPRB, 0.37176595E-03_JPRB, 0.37174114E-03_JPRB, 0.37173873E-03_JPRB, 0.37177711E-03_JPRB, 0.37183784E-03_JPRB, &
  & 0.37188980E-03_JPRB, 0.37192254E-03_JPRB, 0.37197073E-03_JPRB, 0.37210685E-03_JPRB  /)

RGHG1(:,22, 1) = (/ &
  & 0.37397014E-03_JPRB, 0.37397847E-03_JPRB, 0.37401377E-03_JPRB, 0.37401945E-03_JPRB, 0.37403465E-03_JPRB, 0.37398551E-03_JPRB, &
  & 0.37385891E-03_JPRB, 0.37365288E-03_JPRB, 0.37341852E-03_JPRB, 0.37320570E-03_JPRB, 0.37305691E-03_JPRB, 0.37297902E-03_JPRB, &
  & 0.37294694E-03_JPRB, 0.37295628E-03_JPRB, 0.37299877E-03_JPRB, 0.37306617E-03_JPRB, 0.37314903E-03_JPRB, 0.37323871E-03_JPRB, &
  & 0.37333243E-03_JPRB, 0.37345600E-03_JPRB, 0.37365420E-03_JPRB, 0.37403506E-03_JPRB, 0.37473694E-03_JPRB, 0.37579384E-03_JPRB, &
  & 0.37687821E-03_JPRB, 0.37768923E-03_JPRB, 0.37828669E-03_JPRB, 0.37868052E-03_JPRB, 0.37889615E-03_JPRB, 0.37897142E-03_JPRB, &
  & 0.37894833E-03_JPRB, 0.37888119E-03_JPRB, 0.37871735E-03_JPRB, 0.37843113E-03_JPRB, 0.37816272E-03_JPRB, 0.37797567E-03_JPRB, &
  & 0.37785697E-03_JPRB, 0.37777166E-03_JPRB, 0.37755828E-03_JPRB, 0.37711212E-03_JPRB, 0.37643689E-03_JPRB, 0.37563031E-03_JPRB, &
  & 0.37494825E-03_JPRB, 0.37438643E-03_JPRB, 0.37397997E-03_JPRB, 0.37365146E-03_JPRB, 0.37339345E-03_JPRB, 0.37315284E-03_JPRB, &
  & 0.37291292E-03_JPRB, 0.37271893E-03_JPRB, 0.37256278E-03_JPRB, 0.37238524E-03_JPRB, 0.37223290E-03_JPRB, 0.37211332E-03_JPRB, &
  & 0.37203409E-03_JPRB, 0.37198542E-03_JPRB, 0.37194449E-03_JPRB, 0.37191739E-03_JPRB, 0.37193643E-03_JPRB, 0.37197314E-03_JPRB, &
  & 0.37198997E-03_JPRB, 0.37198791E-03_JPRB, 0.37202143E-03_JPRB, 0.37212086E-03_JPRB  /)

RGHG1(:,23, 1) = (/ &
  & 0.37397228E-03_JPRB, 0.37398796E-03_JPRB, 0.37400405E-03_JPRB, 0.37401733E-03_JPRB, 0.37401394E-03_JPRB, 0.37395211E-03_JPRB, &
  & 0.37383910E-03_JPRB, 0.37368559E-03_JPRB, 0.37352978E-03_JPRB, 0.37339710E-03_JPRB, 0.37330885E-03_JPRB, 0.37326437E-03_JPRB, &
  & 0.37324555E-03_JPRB, 0.37325542E-03_JPRB, 0.37329237E-03_JPRB, 0.37335382E-03_JPRB, 0.37343167E-03_JPRB, 0.37352534E-03_JPRB, &
  & 0.37363403E-03_JPRB, 0.37378048E-03_JPRB, 0.37400600E-03_JPRB, 0.37441482E-03_JPRB, 0.37513728E-03_JPRB, 0.37619899E-03_JPRB, &
  & 0.37728640E-03_JPRB, 0.37812464E-03_JPRB, 0.37875574E-03_JPRB, 0.37919097E-03_JPRB, 0.37944334E-03_JPRB, 0.37953310E-03_JPRB, &
  & 0.37950721E-03_JPRB, 0.37943175E-03_JPRB, 0.37928854E-03_JPRB, 0.37907648E-03_JPRB, 0.37888940E-03_JPRB, 0.37876169E-03_JPRB, &
  & 0.37867914E-03_JPRB, 0.37862406E-03_JPRB, 0.37846608E-03_JPRB, 0.37803581E-03_JPRB, 0.37729102E-03_JPRB, 0.37632364E-03_JPRB, &
  & 0.37543676E-03_JPRB, 0.37480964E-03_JPRB, 0.37437196E-03_JPRB, 0.37402415E-03_JPRB, 0.37375466E-03_JPRB, 0.37350865E-03_JPRB, &
  & 0.37326965E-03_JPRB, 0.37305887E-03_JPRB, 0.37286896E-03_JPRB, 0.37267832E-03_JPRB, 0.37252424E-03_JPRB, 0.37241010E-03_JPRB, &
  & 0.37232322E-03_JPRB, 0.37226591E-03_JPRB, 0.37221591E-03_JPRB, 0.37218303E-03_JPRB, 0.37219060E-03_JPRB, 0.37219816E-03_JPRB, &
  & 0.37216557E-03_JPRB, 0.37211830E-03_JPRB, 0.37215352E-03_JPRB, 0.37225244E-03_JPRB  /)

RGHG1(:,24, 1) = (/ &
  & 0.37398845E-03_JPRB, 0.37400739E-03_JPRB, 0.37400632E-03_JPRB, 0.37401938E-03_JPRB, 0.37399859E-03_JPRB, 0.37393331E-03_JPRB, &
  & 0.37383819E-03_JPRB, 0.37373542E-03_JPRB, 0.37364958E-03_JPRB, 0.37358463E-03_JPRB, 0.37354512E-03_JPRB, 0.37352908E-03_JPRB, &
  & 0.37352479E-03_JPRB, 0.37353636E-03_JPRB, 0.37356539E-03_JPRB, 0.37361753E-03_JPRB, 0.37368676E-03_JPRB, 0.37377937E-03_JPRB, &
  & 0.37389960E-03_JPRB, 0.37407123E-03_JPRB, 0.37433144E-03_JPRB, 0.37477492E-03_JPRB, 0.37551516E-03_JPRB, 0.37656058E-03_JPRB, &
  & 0.37762764E-03_JPRB, 0.37849712E-03_JPRB, 0.37917804E-03_JPRB, 0.37966478E-03_JPRB, 0.37996500E-03_JPRB, 0.38008602E-03_JPRB, &
  & 0.38007280E-03_JPRB, 0.38000144E-03_JPRB, 0.37988990E-03_JPRB, 0.37975211E-03_JPRB, 0.37963344E-03_JPRB, 0.37954387E-03_JPRB, &
  & 0.37946379E-03_JPRB, 0.37939609E-03_JPRB, 0.37925343E-03_JPRB, 0.37881364E-03_JPRB, 0.37799388E-03_JPRB, 0.37689479E-03_JPRB, &
  & 0.37586155E-03_JPRB, 0.37520299E-03_JPRB, 0.37473907E-03_JPRB, 0.37437987E-03_JPRB, 0.37410907E-03_JPRB, 0.37387000E-03_JPRB, &
  & 0.37364544E-03_JPRB, 0.37342942E-03_JPRB, 0.37321427E-03_JPRB, 0.37300414E-03_JPRB, 0.37284205E-03_JPRB, 0.37273051E-03_JPRB, &
  & 0.37263908E-03_JPRB, 0.37257215E-03_JPRB, 0.37251360E-03_JPRB, 0.37248056E-03_JPRB, 0.37248153E-03_JPRB, 0.37246180E-03_JPRB, &
  & 0.37237874E-03_JPRB, 0.37228876E-03_JPRB, 0.37231872E-03_JPRB, 0.37241595E-03_JPRB  /)

RGHG1(:,25, 1) = (/ &
  & 0.37403944E-03_JPRB, 0.37404361E-03_JPRB, 0.37402542E-03_JPRB, 0.37402145E-03_JPRB, 0.37399115E-03_JPRB, 0.37393839E-03_JPRB, &
  & 0.37386839E-03_JPRB, 0.37381040E-03_JPRB, 0.37377705E-03_JPRB, 0.37375641E-03_JPRB, 0.37374578E-03_JPRB, 0.37374865E-03_JPRB, &
  & 0.37375856E-03_JPRB, 0.37377371E-03_JPRB, 0.37379334E-03_JPRB, 0.37383475E-03_JPRB, 0.37389392E-03_JPRB, 0.37397918E-03_JPRB, &
  & 0.37410478E-03_JPRB, 0.37430285E-03_JPRB, 0.37460501E-03_JPRB, 0.37508932E-03_JPRB, 0.37584452E-03_JPRB, 0.37685099E-03_JPRB, &
  & 0.37786960E-03_JPRB, 0.37877182E-03_JPRB, 0.37951690E-03_JPRB, 0.38006677E-03_JPRB, 0.38042822E-03_JPRB, 0.38060729E-03_JPRB, &
  & 0.38063320E-03_JPRB, 0.38058452E-03_JPRB, 0.38051305E-03_JPRB, 0.38043650E-03_JPRB, 0.38036186E-03_JPRB, 0.38027953E-03_JPRB, &
  & 0.38015194E-03_JPRB, 0.38000992E-03_JPRB, 0.37981580E-03_JPRB, 0.37932728E-03_JPRB, 0.37843198E-03_JPRB, 0.37725350E-03_JPRB, &
  & 0.37618544E-03_JPRB, 0.37554044E-03_JPRB, 0.37505262E-03_JPRB, 0.37469276E-03_JPRB, 0.37443551E-03_JPRB, 0.37422297E-03_JPRB, &
  & 0.37402983E-03_JPRB, 0.37382425E-03_JPRB, 0.37360101E-03_JPRB, 0.37336266E-03_JPRB, 0.37318260E-03_JPRB, 0.37306561E-03_JPRB, &
  & 0.37297342E-03_JPRB, 0.37289652E-03_JPRB, 0.37282913E-03_JPRB, 0.37280163E-03_JPRB, 0.37280317E-03_JPRB, 0.37276180E-03_JPRB, &
  & 0.37263189E-03_JPRB, 0.37250796E-03_JPRB, 0.37251685E-03_JPRB, 0.37260222E-03_JPRB  /)

RGHG1(:,26, 1) = (/ &
  & 0.37417271E-03_JPRB, 0.37415362E-03_JPRB, 0.37410250E-03_JPRB, 0.37407808E-03_JPRB, 0.37404895E-03_JPRB, 0.37400721E-03_JPRB, &
  & 0.37396034E-03_JPRB, 0.37393291E-03_JPRB, 0.37392631E-03_JPRB, 0.37392564E-03_JPRB, 0.37392599E-03_JPRB, 0.37393541E-03_JPRB, &
  & 0.37395202E-03_JPRB, 0.37397449E-03_JPRB, 0.37399741E-03_JPRB, 0.37403825E-03_JPRB, 0.37410284E-03_JPRB, 0.37419554E-03_JPRB, &
  & 0.37433122E-03_JPRB, 0.37455195E-03_JPRB, 0.37489150E-03_JPRB, 0.37540496E-03_JPRB, 0.37615417E-03_JPRB, 0.37711437E-03_JPRB, &
  & 0.37807946E-03_JPRB, 0.37898969E-03_JPRB, 0.37978683E-03_JPRB, 0.38039852E-03_JPRB, 0.38083260E-03_JPRB, 0.38108741E-03_JPRB, &
  & 0.38118672E-03_JPRB, 0.38119170E-03_JPRB, 0.38115136E-03_JPRB, 0.38108520E-03_JPRB, 0.38098843E-03_JPRB, 0.38084912E-03_JPRB, &
  & 0.38064055E-03_JPRB, 0.38039367E-03_JPRB, 0.38009913E-03_JPRB, 0.37951698E-03_JPRB, 0.37856570E-03_JPRB, 0.37743182E-03_JPRB, &
  & 0.37645462E-03_JPRB, 0.37583559E-03_JPRB, 0.37534412E-03_JPRB, 0.37497926E-03_JPRB, 0.37474285E-03_JPRB, 0.37456160E-03_JPRB, &
  & 0.37438394E-03_JPRB, 0.37419269E-03_JPRB, 0.37397755E-03_JPRB, 0.37373938E-03_JPRB, 0.37354929E-03_JPRB, 0.37342194E-03_JPRB, &
  & 0.37331840E-03_JPRB, 0.37322073E-03_JPRB, 0.37314439E-03_JPRB, 0.37311810E-03_JPRB, 0.37310460E-03_JPRB, 0.37303594E-03_JPRB, &
  & 0.37287945E-03_JPRB, 0.37271253E-03_JPRB, 0.37268424E-03_JPRB, 0.37272845E-03_JPRB  /)

RGHG1(:,27, 1) = (/ &
  & 0.37434256E-03_JPRB, 0.37429599E-03_JPRB, 0.37420458E-03_JPRB, 0.37415752E-03_JPRB, 0.37413357E-03_JPRB, 0.37410280E-03_JPRB, &
  & 0.37407936E-03_JPRB, 0.37407862E-03_JPRB, 0.37409046E-03_JPRB, 0.37410163E-03_JPRB, 0.37410681E-03_JPRB, 0.37411851E-03_JPRB, &
  & 0.37413934E-03_JPRB, 0.37417085E-03_JPRB, 0.37420193E-03_JPRB, 0.37424593E-03_JPRB, 0.37432193E-03_JPRB, 0.37442789E-03_JPRB, &
  & 0.37457586E-03_JPRB, 0.37481888E-03_JPRB, 0.37519582E-03_JPRB, 0.37573544E-03_JPRB, 0.37647060E-03_JPRB, 0.37737972E-03_JPRB, &
  & 0.37828696E-03_JPRB, 0.37919640E-03_JPRB, 0.38004349E-03_JPRB, 0.38071935E-03_JPRB, 0.38123356E-03_JPRB, 0.38157413E-03_JPRB, &
  & 0.38176288E-03_JPRB, 0.38183545E-03_JPRB, 0.38182434E-03_JPRB, 0.38175020E-03_JPRB, 0.38160576E-03_JPRB, 0.38138307E-03_JPRB, &
  & 0.38107742E-03_JPRB, 0.38070958E-03_JPRB, 0.38029189E-03_JPRB, 0.37959519E-03_JPRB, 0.37859265E-03_JPRB, 0.37755137E-03_JPRB, &
  & 0.37671575E-03_JPRB, 0.37612850E-03_JPRB, 0.37564072E-03_JPRB, 0.37526901E-03_JPRB, 0.37505709E-03_JPRB, 0.37491034E-03_JPRB, &
  & 0.37474295E-03_JPRB, 0.37456811E-03_JPRB, 0.37436746E-03_JPRB, 0.37413999E-03_JPRB, 0.37394235E-03_JPRB, 0.37380236E-03_JPRB, &
  & 0.37368302E-03_JPRB, 0.37355963E-03_JPRB, 0.37347390E-03_JPRB, 0.37344726E-03_JPRB, 0.37341226E-03_JPRB, 0.37331296E-03_JPRB, &
  & 0.37313619E-03_JPRB, 0.37292100E-03_JPRB, 0.37284785E-03_JPRB, 0.37283817E-03_JPRB  /)

RGHG1(:,28, 1) = (/ &
  & 0.37455909E-03_JPRB, 0.37452164E-03_JPRB, 0.37442231E-03_JPRB, 0.37435244E-03_JPRB, 0.37431712E-03_JPRB, 0.37428970E-03_JPRB, &
  & 0.37427606E-03_JPRB, 0.37427753E-03_JPRB, 0.37428398E-03_JPRB, 0.37429140E-03_JPRB, 0.37429479E-03_JPRB, 0.37431445E-03_JPRB, &
  & 0.37434804E-03_JPRB, 0.37439745E-03_JPRB, 0.37445544E-03_JPRB, 0.37452621E-03_JPRB, 0.37462487E-03_JPRB, 0.37476433E-03_JPRB, &
  & 0.37495953E-03_JPRB, 0.37524960E-03_JPRB, 0.37564104E-03_JPRB, 0.37617966E-03_JPRB, 0.37689278E-03_JPRB, 0.37775103E-03_JPRB, &
  & 0.37861493E-03_JPRB, 0.37949536E-03_JPRB, 0.38033800E-03_JPRB, 0.38104165E-03_JPRB, 0.38159346E-03_JPRB, 0.38197883E-03_JPRB, &
  & 0.38221581E-03_JPRB, 0.38231579E-03_JPRB, 0.38229564E-03_JPRB, 0.38217108E-03_JPRB, 0.38194620E-03_JPRB, 0.38163016E-03_JPRB, &
  & 0.38124052E-03_JPRB, 0.38079227E-03_JPRB, 0.38025971E-03_JPRB, 0.37952654E-03_JPRB, 0.37863529E-03_JPRB, 0.37776360E-03_JPRB, &
  & 0.37704729E-03_JPRB, 0.37648525E-03_JPRB, 0.37601013E-03_JPRB, 0.37564252E-03_JPRB, 0.37541765E-03_JPRB, 0.37524867E-03_JPRB, &
  & 0.37507636E-03_JPRB, 0.37488914E-03_JPRB, 0.37469364E-03_JPRB, 0.37448844E-03_JPRB, 0.37430223E-03_JPRB, 0.37414164E-03_JPRB, &
  & 0.37401812E-03_JPRB, 0.37387974E-03_JPRB, 0.37377849E-03_JPRB, 0.37372540E-03_JPRB, 0.37367681E-03_JPRB, 0.37356065E-03_JPRB, &
  & 0.37335855E-03_JPRB, 0.37311794E-03_JPRB, 0.37299606E-03_JPRB, 0.37295557E-03_JPRB  /)

RGHG1(:,29, 1) = (/ &
  & 0.37479056E-03_JPRB, 0.37476435E-03_JPRB, 0.37465803E-03_JPRB, 0.37456399E-03_JPRB, 0.37451589E-03_JPRB, 0.37449168E-03_JPRB, &
  & 0.37448784E-03_JPRB, 0.37449060E-03_JPRB, 0.37449030E-03_JPRB, 0.37449306E-03_JPRB, 0.37449429E-03_JPRB, 0.37452263E-03_JPRB, &
  & 0.37457011E-03_JPRB, 0.37463888E-03_JPRB, 0.37472617E-03_JPRB, 0.37482634E-03_JPRB, 0.37494950E-03_JPRB, 0.37512534E-03_JPRB, &
  & 0.37537210E-03_JPRB, 0.37571309E-03_JPRB, 0.37611891E-03_JPRB, 0.37665527E-03_JPRB, 0.37734470E-03_JPRB, 0.37814907E-03_JPRB, &
  & 0.37896767E-03_JPRB, 0.37981613E-03_JPRB, 0.38065170E-03_JPRB, 0.38138322E-03_JPRB, 0.38197302E-03_JPRB, 0.38240409E-03_JPRB, &
  & 0.38269038E-03_JPRB, 0.38281767E-03_JPRB, 0.38278627E-03_JPRB, 0.38260646E-03_JPRB, 0.38229492E-03_JPRB, 0.38187953E-03_JPRB, &
  & 0.38140146E-03_JPRB, 0.38086977E-03_JPRB, 0.38021586E-03_JPRB, 0.37944743E-03_JPRB, 0.37868115E-03_JPRB, 0.37799249E-03_JPRB, &
  & 0.37740163E-03_JPRB, 0.37686601E-03_JPRB, 0.37640470E-03_JPRB, 0.37604192E-03_JPRB, 0.37580171E-03_JPRB, 0.37560670E-03_JPRB, &
  & 0.37542854E-03_JPRB, 0.37522693E-03_JPRB, 0.37503650E-03_JPRB, 0.37485539E-03_JPRB, 0.37468211E-03_JPRB, 0.37449936E-03_JPRB, &
  & 0.37437190E-03_JPRB, 0.37421809E-03_JPRB, 0.37410014E-03_JPRB, 0.37401790E-03_JPRB, 0.37395525E-03_JPRB, 0.37382183E-03_JPRB, &
  & 0.37359266E-03_JPRB, 0.37332611E-03_JPRB, 0.37315243E-03_JPRB, 0.37308030E-03_JPRB  /)

RGHG1(:,30, 1) = (/ &
  & 0.37493752E-03_JPRB, 0.37495647E-03_JPRB, 0.37487872E-03_JPRB, 0.37480328E-03_JPRB, 0.37476717E-03_JPRB, 0.37475073E-03_JPRB, &
  & 0.37474937E-03_JPRB, 0.37473731E-03_JPRB, 0.37472607E-03_JPRB, 0.37473376E-03_JPRB, 0.37474684E-03_JPRB, 0.37479282E-03_JPRB, &
  & 0.37486924E-03_JPRB, 0.37497810E-03_JPRB, 0.37511630E-03_JPRB, 0.37527900E-03_JPRB, 0.37547266E-03_JPRB, 0.37571733E-03_JPRB, &
  & 0.37603328E-03_JPRB, 0.37643978E-03_JPRB, 0.37688068E-03_JPRB, 0.37739313E-03_JPRB, 0.37800620E-03_JPRB, 0.37874250E-03_JPRB, &
  & 0.37951837E-03_JPRB, 0.38031432E-03_JPRB, 0.38108554E-03_JPRB, 0.38177002E-03_JPRB, 0.38232204E-03_JPRB, 0.38272352E-03_JPRB, &
  & 0.38299115E-03_JPRB, 0.38310506E-03_JPRB, 0.38304797E-03_JPRB, 0.38282500E-03_JPRB, 0.38247374E-03_JPRB, 0.38202975E-03_JPRB, &
  & 0.38153891E-03_JPRB, 0.38099493E-03_JPRB, 0.38037605E-03_JPRB, 0.37972759E-03_JPRB, 0.37910769E-03_JPRB, 0.37854111E-03_JPRB, &
  & 0.37799467E-03_JPRB, 0.37746451E-03_JPRB, 0.37699919E-03_JPRB, 0.37660099E-03_JPRB, 0.37630489E-03_JPRB, 0.37605490E-03_JPRB, &
  & 0.37583150E-03_JPRB, 0.37560731E-03_JPRB, 0.37540376E-03_JPRB, 0.37520800E-03_JPRB, 0.37502449E-03_JPRB, 0.37482691E-03_JPRB, &
  & 0.37467129E-03_JPRB, 0.37450442E-03_JPRB, 0.37439133E-03_JPRB, 0.37431548E-03_JPRB, 0.37423278E-03_JPRB, 0.37408847E-03_JPRB, &
  & 0.37385145E-03_JPRB, 0.37360097E-03_JPRB, 0.37342625E-03_JPRB, 0.37333483E-03_JPRB  /)

RGHG1(:,31, 1) = (/ &
  & 0.37509228E-03_JPRB, 0.37515886E-03_JPRB, 0.37511124E-03_JPRB, 0.37505545E-03_JPRB, 0.37503198E-03_JPRB, 0.37502372E-03_JPRB, &
  & 0.37502497E-03_JPRB, 0.37499728E-03_JPRB, 0.37497451E-03_JPRB, 0.37498741E-03_JPRB, 0.37501299E-03_JPRB, 0.37507757E-03_JPRB, &
  & 0.37518450E-03_JPRB, 0.37533563E-03_JPRB, 0.37552747E-03_JPRB, 0.37575610E-03_JPRB, 0.37602409E-03_JPRB, 0.37634130E-03_JPRB, &
  & 0.37673017E-03_JPRB, 0.37720572E-03_JPRB, 0.37768360E-03_JPRB, 0.37817082E-03_JPRB, 0.37870338E-03_JPRB, 0.37936796E-03_JPRB, &
  & 0.38009882E-03_JPRB, 0.38083940E-03_JPRB, 0.38154277E-03_JPRB, 0.38217762E-03_JPRB, 0.38268975E-03_JPRB, 0.38305998E-03_JPRB, &
  & 0.38330790E-03_JPRB, 0.38340767E-03_JPRB, 0.38332350E-03_JPRB, 0.38305507E-03_JPRB, 0.38266199E-03_JPRB, 0.38218794E-03_JPRB, &
  & 0.38168370E-03_JPRB, 0.38112686E-03_JPRB, 0.38054502E-03_JPRB, 0.38002314E-03_JPRB, 0.37955747E-03_JPRB, 0.37911947E-03_JPRB, &
  & 0.37861976E-03_JPRB, 0.37809532E-03_JPRB, 0.37762577E-03_JPRB, 0.37719021E-03_JPRB, 0.37683518E-03_JPRB, 0.37652723E-03_JPRB, &
  & 0.37625614E-03_JPRB, 0.37600814E-03_JPRB, 0.37579074E-03_JPRB, 0.37557951E-03_JPRB, 0.37538521E-03_JPRB, 0.37517200E-03_JPRB, &
  & 0.37498670E-03_JPRB, 0.37480607E-03_JPRB, 0.37469810E-03_JPRB, 0.37462902E-03_JPRB, 0.37452520E-03_JPRB, 0.37436943E-03_JPRB, &
  & 0.37412415E-03_JPRB, 0.37389063E-03_JPRB, 0.37371487E-03_JPRB, 0.37360314E-03_JPRB  /)

RGHG1(:,32, 1) = (/ &
  & 0.37548114E-03_JPRB, 0.37554706E-03_JPRB, 0.37549739E-03_JPRB, 0.37543545E-03_JPRB, 0.37541363E-03_JPRB, 0.37539136E-03_JPRB, &
  & 0.37538193E-03_JPRB, 0.37535227E-03_JPRB, 0.37533032E-03_JPRB, 0.37535943E-03_JPRB, 0.37540502E-03_JPRB, 0.37550215E-03_JPRB, &
  & 0.37565499E-03_JPRB, 0.37586326E-03_JPRB, 0.37611801E-03_JPRB, 0.37643084E-03_JPRB, 0.37678445E-03_JPRB, 0.37718990E-03_JPRB, &
  & 0.37764220E-03_JPRB, 0.37814019E-03_JPRB, 0.37863361E-03_JPRB, 0.37909851E-03_JPRB, 0.37956202E-03_JPRB, 0.38011712E-03_JPRB, &
  & 0.38074884E-03_JPRB, 0.38140788E-03_JPRB, 0.38202796E-03_JPRB, 0.38257855E-03_JPRB, 0.38301846E-03_JPRB, 0.38334618E-03_JPRB, &
  & 0.38357557E-03_JPRB, 0.38366209E-03_JPRB, 0.38354790E-03_JPRB, 0.38325527E-03_JPRB, 0.38287636E-03_JPRB, 0.38245121E-03_JPRB, &
  & 0.38202198E-03_JPRB, 0.38157236E-03_JPRB, 0.38112149E-03_JPRB, 0.38070898E-03_JPRB, 0.38031760E-03_JPRB, 0.37990361E-03_JPRB, &
  & 0.37940278E-03_JPRB, 0.37887155E-03_JPRB, 0.37836864E-03_JPRB, 0.37787014E-03_JPRB, 0.37746072E-03_JPRB, 0.37709945E-03_JPRB, &
  & 0.37676905E-03_JPRB, 0.37647247E-03_JPRB, 0.37624072E-03_JPRB, 0.37602071E-03_JPRB, 0.37580336E-03_JPRB, 0.37557074E-03_JPRB, &
  & 0.37535664E-03_JPRB, 0.37517005E-03_JPRB, 0.37505708E-03_JPRB, 0.37498067E-03_JPRB, 0.37487372E-03_JPRB, 0.37471693E-03_JPRB, &
  & 0.37449187E-03_JPRB, 0.37430186E-03_JPRB, 0.37415952E-03_JPRB, 0.37407627E-03_JPRB  /)

RGHG1(:,33, 1) = (/ &
  & 0.37591557E-03_JPRB, 0.37597456E-03_JPRB, 0.37591859E-03_JPRB, 0.37584691E-03_JPRB, 0.37582537E-03_JPRB, 0.37578567E-03_JPRB, &
  & 0.37576344E-03_JPRB, 0.37573350E-03_JPRB, 0.37571399E-03_JPRB, 0.37576138E-03_JPRB, 0.37582874E-03_JPRB, 0.37596150E-03_JPRB, &
  & 0.37616403E-03_JPRB, 0.37643363E-03_JPRB, 0.37675495E-03_JPRB, 0.37715767E-03_JPRB, 0.37760172E-03_JPRB, 0.37810090E-03_JPRB, &
  & 0.37861787E-03_JPRB, 0.37913316E-03_JPRB, 0.37963994E-03_JPRB, 0.38008202E-03_JPRB, 0.38047525E-03_JPRB, 0.38091170E-03_JPRB, &
  & 0.38143338E-03_JPRB, 0.38200429E-03_JPRB, 0.38253582E-03_JPRB, 0.38299436E-03_JPRB, 0.38335503E-03_JPRB, 0.38363710E-03_JPRB, &
  & 0.38384738E-03_JPRB, 0.38392025E-03_JPRB, 0.38377450E-03_JPRB, 0.38345946E-03_JPRB, 0.38310254E-03_JPRB, 0.38273843E-03_JPRB, &
  & 0.38239858E-03_JPRB, 0.38207595E-03_JPRB, 0.38177334E-03_JPRB, 0.38147227E-03_JPRB, 0.38114775E-03_JPRB, 0.38074516E-03_JPRB, &
  & 0.38023698E-03_JPRB, 0.37969708E-03_JPRB, 0.37915574E-03_JPRB, 0.37858849E-03_JPRB, 0.37812314E-03_JPRB, 0.37770706E-03_JPRB, &
  & 0.37731352E-03_JPRB, 0.37696325E-03_JPRB, 0.37671652E-03_JPRB, 0.37648824E-03_JPRB, 0.37624534E-03_JPRB, 0.37599208E-03_JPRB, &
  & 0.37574815E-03_JPRB, 0.37555638E-03_JPRB, 0.37543691E-03_JPRB, 0.37535104E-03_JPRB, 0.37524319E-03_JPRB, 0.37508667E-03_JPRB, &
  & 0.37488633E-03_JPRB, 0.37474497E-03_JPRB, 0.37464183E-03_JPRB, 0.37459449E-03_JPRB  /)

RGHG1(:,34, 1) = (/ &
  & 0.37635909E-03_JPRB, 0.37640916E-03_JPRB, 0.37639269E-03_JPRB, 0.37630497E-03_JPRB, 0.37626961E-03_JPRB, 0.37622807E-03_JPRB, &
  & 0.37619857E-03_JPRB, 0.37618279E-03_JPRB, 0.37619196E-03_JPRB, 0.37626974E-03_JPRB, 0.37636914E-03_JPRB, 0.37653576E-03_JPRB, &
  & 0.37678190E-03_JPRB, 0.37710061E-03_JPRB, 0.37747688E-03_JPRB, 0.37794223E-03_JPRB, 0.37844146E-03_JPRB, 0.37896553E-03_JPRB, &
  & 0.37948140E-03_JPRB, 0.37999027E-03_JPRB, 0.38047592E-03_JPRB, 0.38087332E-03_JPRB, 0.38120800E-03_JPRB, 0.38156562E-03_JPRB, &
  & 0.38200173E-03_JPRB, 0.38248493E-03_JPRB, 0.38293716E-03_JPRB, 0.38333551E-03_JPRB, 0.38366167E-03_JPRB, 0.38392829E-03_JPRB, &
  & 0.38411982E-03_JPRB, 0.38417736E-03_JPRB, 0.38400474E-03_JPRB, 0.38369851E-03_JPRB, 0.38339312E-03_JPRB, 0.38309948E-03_JPRB, &
  & 0.38283407E-03_JPRB, 0.38258136E-03_JPRB, 0.38234392E-03_JPRB, 0.38208927E-03_JPRB, 0.38179408E-03_JPRB, 0.38141679E-03_JPRB, &
  & 0.38094637E-03_JPRB, 0.38043505E-03_JPRB, 0.37988598E-03_JPRB, 0.37929116E-03_JPRB, 0.37877538E-03_JPRB, 0.37830295E-03_JPRB, &
  & 0.37786322E-03_JPRB, 0.37748719E-03_JPRB, 0.37722183E-03_JPRB, 0.37698717E-03_JPRB, 0.37673071E-03_JPRB, 0.37647213E-03_JPRB, &
  & 0.37621347E-03_JPRB, 0.37602061E-03_JPRB, 0.37589340E-03_JPRB, 0.37580119E-03_JPRB, 0.37569745E-03_JPRB, 0.37555414E-03_JPRB, &
  & 0.37538495E-03_JPRB, 0.37530952E-03_JPRB, 0.37525180E-03_JPRB, 0.37522926E-03_JPRB  /)

RGHG1(:,35, 1) = (/ &
  & 0.37681977E-03_JPRB, 0.37685964E-03_JPRB, 0.37690728E-03_JPRB, 0.37679981E-03_JPRB, 0.37674302E-03_JPRB, 0.37670758E-03_JPRB, &
  & 0.37667347E-03_JPRB, 0.37667965E-03_JPRB, 0.37673175E-03_JPRB, 0.37684702E-03_JPRB, 0.37698460E-03_JPRB, 0.37718513E-03_JPRB, &
  & 0.37747297E-03_JPRB, 0.37783592E-03_JPRB, 0.37826273E-03_JPRB, 0.37877848E-03_JPRB, 0.37931637E-03_JPRB, 0.37983069E-03_JPRB, &
  & 0.38031168E-03_JPRB, 0.38080177E-03_JPRB, 0.38124800E-03_JPRB, 0.38158823E-03_JPRB, 0.38186874E-03_JPRB, 0.38216576E-03_JPRB, &
  & 0.38252646E-03_JPRB, 0.38291969E-03_JPRB, 0.38329514E-03_JPRB, 0.38364796E-03_JPRB, 0.38396157E-03_JPRB, 0.38422781E-03_JPRB, &
  & 0.38440024E-03_JPRB, 0.38444115E-03_JPRB, 0.38424332E-03_JPRB, 0.38396217E-03_JPRB, 0.38372492E-03_JPRB, 0.38350858E-03_JPRB, &
  & 0.38331203E-03_JPRB, 0.38310192E-03_JPRB, 0.38288884E-03_JPRB, 0.38264855E-03_JPRB, 0.38236427E-03_JPRB, 0.38202011E-03_JPRB, &
  & 0.38161166E-03_JPRB, 0.38114887E-03_JPRB, 0.38060758E-03_JPRB, 0.38000556E-03_JPRB, 0.37944073E-03_JPRB, 0.37890958E-03_JPRB, &
  & 0.37843107E-03_JPRB, 0.37804290E-03_JPRB, 0.37775649E-03_JPRB, 0.37751625E-03_JPRB, 0.37725199E-03_JPRB, 0.37699581E-03_JPRB, &
  & 0.37672975E-03_JPRB, 0.37653786E-03_JPRB, 0.37640208E-03_JPRB, 0.37630493E-03_JPRB, 0.37620801E-03_JPRB, 0.37608490E-03_JPRB, &
  & 0.37595105E-03_JPRB, 0.37595226E-03_JPRB, 0.37594444E-03_JPRB, 0.37594171E-03_JPRB  /)

RGHG1(:,36, 1) = (/ &
  & 0.37737721E-03_JPRB, 0.37742401E-03_JPRB, 0.37753162E-03_JPRB, 0.37738715E-03_JPRB, 0.37730560E-03_JPRB, 0.37726683E-03_JPRB, &
  & 0.37722476E-03_JPRB, 0.37724770E-03_JPRB, 0.37733813E-03_JPRB, 0.37749345E-03_JPRB, 0.37766271E-03_JPRB, 0.37789343E-03_JPRB, &
  & 0.37821668E-03_JPRB, 0.37861185E-03_JPRB, 0.37906625E-03_JPRB, 0.37960367E-03_JPRB, 0.38014989E-03_JPRB, 0.38063218E-03_JPRB, &
  & 0.38106020E-03_JPRB, 0.38150959E-03_JPRB, 0.38190589E-03_JPRB, 0.38219394E-03_JPRB, 0.38242954E-03_JPRB, 0.38267755E-03_JPRB, &
  & 0.38297216E-03_JPRB, 0.38328998E-03_JPRB, 0.38359973E-03_JPRB, 0.38391635E-03_JPRB, 0.38422419E-03_JPRB, 0.38449263E-03_JPRB, &
  & 0.38465631E-03_JPRB, 0.38468980E-03_JPRB, 0.38447248E-03_JPRB, 0.38421200E-03_JPRB, 0.38402477E-03_JPRB, 0.38387063E-03_JPRB, &
  & 0.38373170E-03_JPRB, 0.38355602E-03_JPRB, 0.38335685E-03_JPRB, 0.38312534E-03_JPRB, 0.38285228E-03_JPRB, 0.38254485E-03_JPRB, &
  & 0.38220302E-03_JPRB, 0.38179728E-03_JPRB, 0.38127376E-03_JPRB, 0.38067967E-03_JPRB, 0.38008337E-03_JPRB, 0.37950470E-03_JPRB, &
  & 0.37899439E-03_JPRB, 0.37859850E-03_JPRB, 0.37830261E-03_JPRB, 0.37806000E-03_JPRB, 0.37779335E-03_JPRB, 0.37754363E-03_JPRB, &
  & 0.37727840E-03_JPRB, 0.37709628E-03_JPRB, 0.37695744E-03_JPRB, 0.37686231E-03_JPRB, 0.37677928E-03_JPRB, 0.37668103E-03_JPRB, &
  & 0.37658508E-03_JPRB, 0.37665859E-03_JPRB, 0.37671720E-03_JPRB, 0.37673411E-03_JPRB  /)

RGHG1(:,37, 1) = (/ &
  & 0.37812185E-03_JPRB, 0.37821440E-03_JPRB, 0.37836872E-03_JPRB, 0.37815001E-03_JPRB, 0.37803765E-03_JPRB, 0.37797411E-03_JPRB, &
  & 0.37791687E-03_JPRB, 0.37794365E-03_JPRB, 0.37805944E-03_JPRB, 0.37825824E-03_JPRB, 0.37844225E-03_JPRB, 0.37869275E-03_JPRB, &
  & 0.37903477E-03_JPRB, 0.37943265E-03_JPRB, 0.37986030E-03_JPRB, 0.38035214E-03_JPRB, 0.38083666E-03_JPRB, 0.38123782E-03_JPRB, &
  & 0.38157470E-03_JPRB, 0.38193564E-03_JPRB, 0.38226106E-03_JPRB, 0.38251157E-03_JPRB, 0.38272630E-03_JPRB, 0.38295495E-03_JPRB, &
  & 0.38320896E-03_JPRB, 0.38348942E-03_JPRB, 0.38376295E-03_JPRB, 0.38406704E-03_JPRB, 0.38438495E-03_JPRB, 0.38466143E-03_JPRB, &
  & 0.38484064E-03_JPRB, 0.38488828E-03_JPRB, 0.38466574E-03_JPRB, 0.38441456E-03_JPRB, 0.38423273E-03_JPRB, 0.38410227E-03_JPRB, &
  & 0.38399165E-03_JPRB, 0.38382945E-03_JPRB, 0.38361937E-03_JPRB, 0.38338337E-03_JPRB, 0.38312152E-03_JPRB, 0.38285678E-03_JPRB, &
  & 0.38258811E-03_JPRB, 0.38225540E-03_JPRB, 0.38177140E-03_JPRB, 0.38121947E-03_JPRB, 0.38063397E-03_JPRB, 0.38003641E-03_JPRB, &
  & 0.37951224E-03_JPRB, 0.37911929E-03_JPRB, 0.37884103E-03_JPRB, 0.37860358E-03_JPRB, 0.37834706E-03_JPRB, 0.37811269E-03_JPRB, &
  & 0.37786713E-03_JPRB, 0.37771433E-03_JPRB, 0.37758526E-03_JPRB, 0.37750801E-03_JPRB, 0.37745418E-03_JPRB, 0.37738993E-03_JPRB, &
  & 0.37733542E-03_JPRB, 0.37746673E-03_JPRB, 0.37762560E-03_JPRB, 0.37766050E-03_JPRB  /)

RGHG1(:,38, 1) = (/ &
  & 0.37894809E-03_JPRB, 0.37909141E-03_JPRB, 0.37929756E-03_JPRB, 0.37899648E-03_JPRB, 0.37884991E-03_JPRB, 0.37875890E-03_JPRB, &
  & 0.37868482E-03_JPRB, 0.37871586E-03_JPRB, 0.37885980E-03_JPRB, 0.37910683E-03_JPRB, 0.37930721E-03_JPRB, 0.37957968E-03_JPRB, &
  & 0.37994252E-03_JPRB, 0.38034339E-03_JPRB, 0.38074136E-03_JPRB, 0.38118264E-03_JPRB, 0.38159869E-03_JPRB, 0.38190983E-03_JPRB, &
  & 0.38214557E-03_JPRB, 0.38240837E-03_JPRB, 0.38265515E-03_JPRB, 0.38286401E-03_JPRB, 0.38305559E-03_JPRB, 0.38326274E-03_JPRB, &
  & 0.38347171E-03_JPRB, 0.38371072E-03_JPRB, 0.38394406E-03_JPRB, 0.38423424E-03_JPRB, 0.38456333E-03_JPRB, 0.38484873E-03_JPRB, &
  & 0.38504517E-03_JPRB, 0.38510852E-03_JPRB, 0.38488019E-03_JPRB, 0.38463932E-03_JPRB, 0.38446347E-03_JPRB, 0.38435930E-03_JPRB, &
  & 0.38428008E-03_JPRB, 0.38413286E-03_JPRB, 0.38391066E-03_JPRB, 0.38366967E-03_JPRB, 0.38342027E-03_JPRB, 0.38320290E-03_JPRB, &
  & 0.38301541E-03_JPRB, 0.38276374E-03_JPRB, 0.38232358E-03_JPRB, 0.38181842E-03_JPRB, 0.38124490E-03_JPRB, 0.38062638E-03_JPRB, &
  & 0.38008684E-03_JPRB, 0.37969716E-03_JPRB, 0.37943845E-03_JPRB, 0.37920672E-03_JPRB, 0.37896145E-03_JPRB, 0.37874412E-03_JPRB, &
  & 0.37852038E-03_JPRB, 0.37840011E-03_JPRB, 0.37828189E-03_JPRB, 0.37822447E-03_JPRB, 0.37820304E-03_JPRB, 0.37817651E-03_JPRB, &
  & 0.37816798E-03_JPRB, 0.37836343E-03_JPRB, 0.37863355E-03_JPRB, 0.37868841E-03_JPRB  /)

RGHG1(:,39, 1) = (/ &
  & 0.37997439E-03_JPRB, 0.38016220E-03_JPRB, 0.38038168E-03_JPRB, 0.37999611E-03_JPRB, 0.37978754E-03_JPRB, 0.37965345E-03_JPRB, &
  & 0.37954314E-03_JPRB, 0.37954838E-03_JPRB, 0.37970098E-03_JPRB, 0.37996918E-03_JPRB, 0.38017017E-03_JPRB, 0.38043106E-03_JPRB, &
  & 0.38076262E-03_JPRB, 0.38108862E-03_JPRB, 0.38138587E-03_JPRB, 0.38172429E-03_JPRB, 0.38203534E-03_JPRB, 0.38227167E-03_JPRB, &
  & 0.38244341E-03_JPRB, 0.38264663E-03_JPRB, 0.38283402E-03_JPRB, 0.38302237E-03_JPRB, 0.38319298E-03_JPRB, 0.38337065E-03_JPRB, &
  & 0.38355932E-03_JPRB, 0.38379015E-03_JPRB, 0.38404078E-03_JPRB, 0.38432103E-03_JPRB, 0.38464010E-03_JPRB, 0.38494262E-03_JPRB, &
  & 0.38518424E-03_JPRB, 0.38528396E-03_JPRB, 0.38509737E-03_JPRB, 0.38485967E-03_JPRB, 0.38464834E-03_JPRB, 0.38452010E-03_JPRB, &
  & 0.38443386E-03_JPRB, 0.38429536E-03_JPRB, 0.38406025E-03_JPRB, 0.38380443E-03_JPRB, 0.38355071E-03_JPRB, 0.38336699E-03_JPRB, &
  & 0.38323356E-03_JPRB, 0.38304047E-03_JPRB, 0.38265325E-03_JPRB, 0.38218535E-03_JPRB, 0.38164732E-03_JPRB, 0.38107227E-03_JPRB, &
  & 0.38053042E-03_JPRB, 0.38015520E-03_JPRB, 0.37994551E-03_JPRB, 0.37973903E-03_JPRB, 0.37951226E-03_JPRB, 0.37930792E-03_JPRB, &
  & 0.37912117E-03_JPRB, 0.37903101E-03_JPRB, 0.37894044E-03_JPRB, 0.37891746E-03_JPRB, 0.37894579E-03_JPRB, 0.37897351E-03_JPRB, &
  & 0.37899649E-03_JPRB, 0.37921252E-03_JPRB, 0.37958100E-03_JPRB, 0.37980192E-03_JPRB  /)

RGHG1(:,40, 1) = (/ &
  & 0.38121156E-03_JPRB, 0.38145056E-03_JPRB, 0.38167938E-03_JPRB, 0.38119431E-03_JPRB, 0.38090844E-03_JPRB, 0.38072123E-03_JPRB, &
  & 0.38056523E-03_JPRB, 0.38053527E-03_JPRB, 0.38069485E-03_JPRB, 0.38098346E-03_JPRB, 0.38118260E-03_JPRB, 0.38142442E-03_JPRB, &
  & 0.38171073E-03_JPRB, 0.38193614E-03_JPRB, 0.38210355E-03_JPRB, 0.38231271E-03_JPRB, 0.38249455E-03_JPRB, 0.38264558E-03_JPRB, &
  & 0.38274827E-03_JPRB, 0.38288788E-03_JPRB, 0.38300872E-03_JPRB, 0.38317646E-03_JPRB, 0.38332282E-03_JPRB, 0.38346459E-03_JPRB, &
  & 0.38363349E-03_JPRB, 0.38386016E-03_JPRB, 0.38414048E-03_JPRB, 0.38440972E-03_JPRB, 0.38471356E-03_JPRB, 0.38503752E-03_JPRB, &
  & 0.38533673E-03_JPRB, 0.38548253E-03_JPRB, 0.38535270E-03_JPRB, 0.38511756E-03_JPRB, 0.38485778E-03_JPRB, 0.38469307E-03_JPRB, &
  & 0.38459231E-03_JPRB, 0.38446302E-03_JPRB, 0.38421261E-03_JPRB, 0.38393779E-03_JPRB, 0.38367627E-03_JPRB, 0.38352979E-03_JPRB, &
  & 0.38345535E-03_JPRB, 0.38332735E-03_JPRB, 0.38300374E-03_JPRB, 0.38257801E-03_JPRB, 0.38208547E-03_JPRB, 0.38157199E-03_JPRB, &
  & 0.38102956E-03_JPRB, 0.38067316E-03_JPRB, 0.38052579E-03_JPRB, 0.38035214E-03_JPRB, 0.38014829E-03_JPRB, 0.37995854E-03_JPRB, &
  & 0.37981766E-03_JPRB, 0.37976245E-03_JPRB, 0.37970707E-03_JPRB, 0.37972690E-03_JPRB, 0.37981648E-03_JPRB, 0.37991056E-03_JPRB, &
  & 0.37996816E-03_JPRB, 0.38020121E-03_JPRB, 0.38068302E-03_JPRB, 0.38112273E-03_JPRB  /)

RGHG1(:,41, 1) = (/ &
  & 0.38272418E-03_JPRB, 0.38302578E-03_JPRB, 0.38326602E-03_JPRB, 0.38265928E-03_JPRB, 0.38227890E-03_JPRB, 0.38202675E-03_JPRB, &
  & 0.38181489E-03_JPRB, 0.38174190E-03_JPRB, 0.38191000E-03_JPRB, 0.38222357E-03_JPRB, 0.38242044E-03_JPRB, 0.38263895E-03_JPRB, &
  & 0.38286994E-03_JPRB, 0.38297236E-03_JPRB, 0.38298101E-03_JPRB, 0.38303213E-03_JPRB, 0.38305601E-03_JPRB, 0.38310274E-03_JPRB, &
  & 0.38312100E-03_JPRB, 0.38318285E-03_JPRB, 0.38322231E-03_JPRB, 0.38336486E-03_JPRB, 0.38348157E-03_JPRB, 0.38357945E-03_JPRB, &
  & 0.38372417E-03_JPRB, 0.38394575E-03_JPRB, 0.38426238E-03_JPRB, 0.38451816E-03_JPRB, 0.38480338E-03_JPRB, 0.38515355E-03_JPRB, &
  & 0.38552318E-03_JPRB, 0.38572531E-03_JPRB, 0.38566488E-03_JPRB, 0.38543287E-03_JPRB, 0.38511387E-03_JPRB, 0.38490455E-03_JPRB, &
  & 0.38478603E-03_JPRB, 0.38466801E-03_JPRB, 0.38439890E-03_JPRB, 0.38410085E-03_JPRB, 0.38382978E-03_JPRB, 0.38372883E-03_JPRB, &
  & 0.38372653E-03_JPRB, 0.38367810E-03_JPRB, 0.38343226E-03_JPRB, 0.38305809E-03_JPRB, 0.38262119E-03_JPRB, 0.38218297E-03_JPRB, &
  & 0.38163984E-03_JPRB, 0.38130644E-03_JPRB, 0.38123528E-03_JPRB, 0.38110176E-03_JPRB, 0.38092592E-03_JPRB, 0.38075401E-03_JPRB, &
  & 0.38066923E-03_JPRB, 0.38065674E-03_JPRB, 0.38064439E-03_JPRB, 0.38071656E-03_JPRB, 0.38088101E-03_JPRB, 0.38105623E-03_JPRB, &
  & 0.38115616E-03_JPRB, 0.38141002E-03_JPRB, 0.38203040E-03_JPRB, 0.38273761E-03_JPRB  /)

RGHG1(:,42, 1) = (/ &
  & 0.38395210E-03_JPRB, 0.38415521E-03_JPRB, 0.38430163E-03_JPRB, 0.38362206E-03_JPRB, 0.38312700E-03_JPRB, 0.38279052E-03_JPRB, &
  & 0.38250619E-03_JPRB, 0.38242803E-03_JPRB, 0.38257680E-03_JPRB, 0.38287175E-03_JPRB, 0.38306728E-03_JPRB, 0.38319383E-03_JPRB, &
  & 0.38327344E-03_JPRB, 0.38321819E-03_JPRB, 0.38311580E-03_JPRB, 0.38306269E-03_JPRB, 0.38300824E-03_JPRB, 0.38304417E-03_JPRB, &
  & 0.38310007E-03_JPRB, 0.38315709E-03_JPRB, 0.38318907E-03_JPRB, 0.38333661E-03_JPRB, 0.38344369E-03_JPRB, 0.38354865E-03_JPRB, &
  & 0.38370865E-03_JPRB, 0.38395848E-03_JPRB, 0.38426776E-03_JPRB, 0.38451352E-03_JPRB, 0.38480751E-03_JPRB, 0.38516292E-03_JPRB, &
  & 0.38550126E-03_JPRB, 0.38571324E-03_JPRB, 0.38573289E-03_JPRB, 0.38554361E-03_JPRB, 0.38527608E-03_JPRB, 0.38501581E-03_JPRB, &
  & 0.38483101E-03_JPRB, 0.38467423E-03_JPRB, 0.38442257E-03_JPRB, 0.38414341E-03_JPRB, 0.38386517E-03_JPRB, 0.38375215E-03_JPRB, &
  & 0.38372921E-03_JPRB, 0.38369545E-03_JPRB, 0.38350916E-03_JPRB, 0.38316199E-03_JPRB, 0.38277938E-03_JPRB, 0.38238862E-03_JPRB, &
  & 0.38190076E-03_JPRB, 0.38162719E-03_JPRB, 0.38162351E-03_JPRB, 0.38153058E-03_JPRB, 0.38140087E-03_JPRB, 0.38129161E-03_JPRB, &
  & 0.38122229E-03_JPRB, 0.38123923E-03_JPRB, 0.38127681E-03_JPRB, 0.38141210E-03_JPRB, 0.38160757E-03_JPRB, 0.38176018E-03_JPRB, &
  & 0.38193422E-03_JPRB, 0.38217311E-03_JPRB, 0.38266815E-03_JPRB, 0.38317595E-03_JPRB  /)

RGHG1(:,43, 1) = (/ &
  & 0.38572310E-03_JPRB, 0.38586327E-03_JPRB, 0.38592900E-03_JPRB, 0.38513066E-03_JPRB, 0.38449031E-03_JPRB, 0.38404894E-03_JPRB, &
  & 0.38367447E-03_JPRB, 0.38357308E-03_JPRB, 0.38370788E-03_JPRB, 0.38399658E-03_JPRB, 0.38418991E-03_JPRB, 0.38422254E-03_JPRB, &
  & 0.38414023E-03_JPRB, 0.38388821E-03_JPRB, 0.38361622E-03_JPRB, 0.38340003E-03_JPRB, 0.38320616E-03_JPRB, 0.38318737E-03_JPRB, &
  & 0.38324131E-03_JPRB, 0.38326047E-03_JPRB, 0.38325062E-03_JPRB, 0.38339187E-03_JPRB, 0.38347741E-03_JPRB, 0.38356995E-03_JPRB, &
  & 0.38373350E-03_JPRB, 0.38400691E-03_JPRB, 0.38432510E-03_JPRB, 0.38455593E-03_JPRB, 0.38484992E-03_JPRB, 0.38522138E-03_JPRB, &
  & 0.38556146E-03_JPRB, 0.38580667E-03_JPRB, 0.38592923E-03_JPRB, 0.38578028E-03_JPRB, 0.38553424E-03_JPRB, 0.38520829E-03_JPRB, &
  & 0.38495538E-03_JPRB, 0.38476808E-03_JPRB, 0.38452429E-03_JPRB, 0.38425239E-03_JPRB, 0.38396349E-03_JPRB, 0.38385904E-03_JPRB, &
  & 0.38384829E-03_JPRB, 0.38386215E-03_JPRB, 0.38376366E-03_JPRB, 0.38346329E-03_JPRB, 0.38315416E-03_JPRB, 0.38283907E-03_JPRB, &
  & 0.38240134E-03_JPRB, 0.38219225E-03_JPRB, 0.38228292E-03_JPRB, 0.38224429E-03_JPRB, 0.38216871E-03_JPRB, 0.38212428E-03_JPRB, &
  & 0.38209321E-03_JPRB, 0.38215537E-03_JPRB, 0.38225701E-03_JPRB, 0.38247241E-03_JPRB, 0.38272839E-03_JPRB, 0.38289528E-03_JPRB, &
  & 0.38315513E-03_JPRB, 0.38338932E-03_JPRB, 0.38382960E-03_JPRB, 0.38427052E-03_JPRB  /)

RGHG1(:,44, 1) = (/ &
  & 0.38685117E-03_JPRB, 0.38683620E-03_JPRB, 0.38681313E-03_JPRB, 0.38597179E-03_JPRB, 0.38517933E-03_JPRB, 0.38458506E-03_JPRB, &
  & 0.38413549E-03_JPRB, 0.38401726E-03_JPRB, 0.38412410E-03_JPRB, 0.38440452E-03_JPRB, 0.38460398E-03_JPRB, 0.38455355E-03_JPRB, &
  & 0.38436874E-03_JPRB, 0.38399931E-03_JPRB, 0.38364087E-03_JPRB, 0.38335961E-03_JPRB, 0.38314348E-03_JPRB, 0.38310816E-03_JPRB, &
  & 0.38317498E-03_JPRB, 0.38319006E-03_JPRB, 0.38319503E-03_JPRB, 0.38333594E-03_JPRB, 0.38343425E-03_JPRB, 0.38354332E-03_JPRB, &
  & 0.38372390E-03_JPRB, 0.38402497E-03_JPRB, 0.38435510E-03_JPRB, 0.38459613E-03_JPRB, 0.38487650E-03_JPRB, 0.38522862E-03_JPRB, &
  & 0.38554932E-03_JPRB, 0.38582565E-03_JPRB, 0.38600026E-03_JPRB, 0.38587651E-03_JPRB, 0.38565704E-03_JPRB, 0.38535806E-03_JPRB, &
  & 0.38506341E-03_JPRB, 0.38484455E-03_JPRB, 0.38458473E-03_JPRB, 0.38429973E-03_JPRB, 0.38401800E-03_JPRB, 0.38388089E-03_JPRB, &
  & 0.38385582E-03_JPRB, 0.38387836E-03_JPRB, 0.38381882E-03_JPRB, 0.38356814E-03_JPRB, 0.38331853E-03_JPRB, 0.38304042E-03_JPRB, &
  & 0.38269748E-03_JPRB, 0.38258272E-03_JPRB, 0.38271687E-03_JPRB, 0.38271207E-03_JPRB, 0.38267367E-03_JPRB, 0.38266479E-03_JPRB, &
  & 0.38267578E-03_JPRB, 0.38278013E-03_JPRB, 0.38297324E-03_JPRB, 0.38322464E-03_JPRB, 0.38350268E-03_JPRB, 0.38369452E-03_JPRB, &
  & 0.38391167E-03_JPRB, 0.38404486E-03_JPRB, 0.38442271E-03_JPRB, 0.38485474E-03_JPRB  /)

RGHG1(:,45, 1) = (/ &
  & 0.38835911E-03_JPRB, 0.38815959E-03_JPRB, 0.38802522E-03_JPRB, 0.38711992E-03_JPRB, 0.38613595E-03_JPRB, 0.38535435E-03_JPRB, &
  & 0.38480791E-03_JPRB, 0.38466758E-03_JPRB, 0.38474081E-03_JPRB, 0.38501102E-03_JPRB, 0.38521717E-03_JPRB, 0.38506034E-03_JPRB, &
  & 0.38473839E-03_JPRB, 0.38421043E-03_JPRB, 0.38373214E-03_JPRB, 0.38335620E-03_JPRB, 0.38309712E-03_JPRB, 0.38303607E-03_JPRB, &
  & 0.38311731E-03_JPRB, 0.38312297E-03_JPRB, 0.38313951E-03_JPRB, 0.38327925E-03_JPRB, 0.38338937E-03_JPRB, 0.38351569E-03_JPRB, &
  & 0.38371610E-03_JPRB, 0.38405165E-03_JPRB, 0.38439650E-03_JPRB, 0.38464726E-03_JPRB, 0.38491211E-03_JPRB, 0.38524425E-03_JPRB, &
  & 0.38554312E-03_JPRB, 0.38585907E-03_JPRB, 0.38610591E-03_JPRB, 0.38601596E-03_JPRB, 0.38582945E-03_JPRB, 0.38555287E-03_JPRB, &
  & 0.38520210E-03_JPRB, 0.38494347E-03_JPRB, 0.38466640E-03_JPRB, 0.38436739E-03_JPRB, 0.38409247E-03_JPRB, 0.38391926E-03_JPRB, &
  & 0.38387943E-03_JPRB, 0.38391787E-03_JPRB, 0.38391377E-03_JPRB, 0.38372556E-03_JPRB, 0.38355300E-03_JPRB, 0.38332655E-03_JPRB, &
  & 0.38309785E-03_JPRB, 0.38309863E-03_JPRB, 0.38329420E-03_JPRB, 0.38333477E-03_JPRB, 0.38334552E-03_JPRB, 0.38338531E-03_JPRB, &
  & 0.38344901E-03_JPRB, 0.38360709E-03_JPRB, 0.38391245E-03_JPRB, 0.38421493E-03_JPRB, 0.38452575E-03_JPRB, 0.38474778E-03_JPRB, &
  & 0.38492717E-03_JPRB, 0.38494479E-03_JPRB, 0.38524464E-03_JPRB, 0.38565809E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART2',0,ZHOOK_HANDLE)



RGHG1(:,46, 1) = (/ &
  & 0.38913567E-03_JPRB, 0.38871127E-03_JPRB, 0.38850239E-03_JPRB, 0.38769167E-03_JPRB, 0.38658830E-03_JPRB, 0.38566483E-03_JPRB, &
  & 0.38500279E-03_JPRB, 0.38480688E-03_JPRB, 0.38482676E-03_JPRB, 0.38509830E-03_JPRB, 0.38529405E-03_JPRB, 0.38510303E-03_JPRB, &
  & 0.38471700E-03_JPRB, 0.38410909E-03_JPRB, 0.38358632E-03_JPRB, 0.38319408E-03_JPRB, 0.38294382E-03_JPRB, 0.38289580E-03_JPRB, &
  & 0.38297743E-03_JPRB, 0.38299078E-03_JPRB, 0.38303050E-03_JPRB, 0.38318658E-03_JPRB, 0.38333167E-03_JPRB, 0.38348653E-03_JPRB, &
  & 0.38370248E-03_JPRB, 0.38405813E-03_JPRB, 0.38443071E-03_JPRB, 0.38469238E-03_JPRB, 0.38494337E-03_JPRB, 0.38525520E-03_JPRB, &
  & 0.38552371E-03_JPRB, 0.38585289E-03_JPRB, 0.38615291E-03_JPRB, 0.38610070E-03_JPRB, 0.38593723E-03_JPRB, 0.38568374E-03_JPRB, &
  & 0.38529778E-03_JPRB, 0.38501838E-03_JPRB, 0.38472465E-03_JPRB, 0.38436202E-03_JPRB, 0.38410311E-03_JPRB, 0.38391905E-03_JPRB, &
  & 0.38386338E-03_JPRB, 0.38388667E-03_JPRB, 0.38390237E-03_JPRB, 0.38377067E-03_JPRB, 0.38365016E-03_JPRB, 0.38348034E-03_JPRB, &
  & 0.38336586E-03_JPRB, 0.38345628E-03_JPRB, 0.38368809E-03_JPRB, 0.38376190E-03_JPRB, 0.38380678E-03_JPRB, 0.38389100E-03_JPRB, &
  & 0.38401078E-03_JPRB, 0.38422586E-03_JPRB, 0.38460497E-03_JPRB, 0.38493562E-03_JPRB, 0.38523304E-03_JPRB, 0.38547146E-03_JPRB, &
  & 0.38559464E-03_JPRB, 0.38552067E-03_JPRB, 0.38568973E-03_JPRB, 0.38609312E-03_JPRB  /)

RGHG1(:,47, 1) = (/ &
  & 0.38990039E-03_JPRB, 0.38920403E-03_JPRB, 0.38891511E-03_JPRB, 0.38824712E-03_JPRB, 0.38701809E-03_JPRB, 0.38593724E-03_JPRB, &
  & 0.38513581E-03_JPRB, 0.38486796E-03_JPRB, 0.38482130E-03_JPRB, 0.38509670E-03_JPRB, 0.38527682E-03_JPRB, 0.38506015E-03_JPRB, &
  & 0.38461357E-03_JPRB, 0.38392759E-03_JPRB, 0.38336771E-03_JPRB, 0.38297206E-03_JPRB, 0.38274251E-03_JPRB, 0.38271756E-03_JPRB, &
  & 0.38279684E-03_JPRB, 0.38282263E-03_JPRB, 0.38289187E-03_JPRB, 0.38307064E-03_JPRB, 0.38326141E-03_JPRB, 0.38345201E-03_JPRB, &
  & 0.38368533E-03_JPRB, 0.38406170E-03_JPRB, 0.38446941E-03_JPRB, 0.38474413E-03_JPRB, 0.38497919E-03_JPRB, 0.38526712E-03_JPRB, &
  & 0.38549829E-03_JPRB, 0.38583772E-03_JPRB, 0.38619632E-03_JPRB, 0.38618917E-03_JPRB, 0.38605074E-03_JPRB, 0.38582450E-03_JPRB, &
  & 0.38540143E-03_JPRB, 0.38510147E-03_JPRB, 0.38478831E-03_JPRB, 0.38434107E-03_JPRB, 0.38410281E-03_JPRB, 0.38391109E-03_JPRB, &
  & 0.38383659E-03_JPRB, 0.38383591E-03_JPRB, 0.38386769E-03_JPRB, 0.38380110E-03_JPRB, 0.38373667E-03_JPRB, 0.38363431E-03_JPRB, &
  & 0.38365383E-03_JPRB, 0.38384426E-03_JPRB, 0.38411355E-03_JPRB, 0.38422394E-03_JPRB, 0.38430585E-03_JPRB, 0.38444136E-03_JPRB, &
  & 0.38462761E-03_JPRB, 0.38491023E-03_JPRB, 0.38536818E-03_JPRB, 0.38572728E-03_JPRB, 0.38599974E-03_JPRB, 0.38625462E-03_JPRB, &
  & 0.38630814E-03_JPRB, 0.38613151E-03_JPRB, 0.38613651E-03_JPRB, 0.38652981E-03_JPRB  /)

RGHG1(:,48, 1) = (/ &
  & 0.38988341E-03_JPRB, 0.38899817E-03_JPRB, 0.38864072E-03_JPRB, 0.38820114E-03_JPRB, 0.38702372E-03_JPRB, 0.38586133E-03_JPRB, &
  & 0.38494280E-03_JPRB, 0.38459478E-03_JPRB, 0.38452900E-03_JPRB, 0.38479227E-03_JPRB, 0.38495069E-03_JPRB, 0.38474440E-03_JPRB, &
  & 0.38429266E-03_JPRB, 0.38362443E-03_JPRB, 0.38308551E-03_JPRB, 0.38272397E-03_JPRB, 0.38253135E-03_JPRB, 0.38254309E-03_JPRB, &
  & 0.38262507E-03_JPRB, 0.38267502E-03_JPRB, 0.38276023E-03_JPRB, 0.38296276E-03_JPRB, 0.38320616E-03_JPRB, 0.38343089E-03_JPRB, &
  & 0.38368004E-03_JPRB, 0.38407525E-03_JPRB, 0.38451094E-03_JPRB, 0.38479579E-03_JPRB, 0.38500831E-03_JPRB, 0.38526889E-03_JPRB, &
  & 0.38548740E-03_JPRB, 0.38582402E-03_JPRB, 0.38621050E-03_JPRB, 0.38624334E-03_JPRB, 0.38612387E-03_JPRB, 0.38590511E-03_JPRB, &
  & 0.38546191E-03_JPRB, 0.38513966E-03_JPRB, 0.38481233E-03_JPRB, 0.38433134E-03_JPRB, 0.38409584E-03_JPRB, 0.38389655E-03_JPRB, &
  & 0.38378577E-03_JPRB, 0.38376375E-03_JPRB, 0.38379348E-03_JPRB, 0.38377774E-03_JPRB, 0.38374963E-03_JPRB, 0.38371805E-03_JPRB, &
  & 0.38383591E-03_JPRB, 0.38408297E-03_JPRB, 0.38436731E-03_JPRB, 0.38451457E-03_JPRB, 0.38463617E-03_JPRB, 0.38480546E-03_JPRB, &
  & 0.38505374E-03_JPRB, 0.38538093E-03_JPRB, 0.38587305E-03_JPRB, 0.38623664E-03_JPRB, 0.38649381E-03_JPRB, 0.38673948E-03_JPRB, &
  & 0.38670746E-03_JPRB, 0.38644231E-03_JPRB, 0.38628969E-03_JPRB, 0.38660292E-03_JPRB  /)

RGHG1(:,49, 1) = (/ &
  & 0.38950921E-03_JPRB, 0.38845256E-03_JPRB, 0.38802448E-03_JPRB, 0.38787678E-03_JPRB, 0.38683713E-03_JPRB, 0.38561889E-03_JPRB, &
  & 0.38458082E-03_JPRB, 0.38414029E-03_JPRB, 0.38407490E-03_JPRB, 0.38431745E-03_JPRB, 0.38444908E-03_JPRB, 0.38427067E-03_JPRB, &
  & 0.38383840E-03_JPRB, 0.38323341E-03_JPRB, 0.38274409E-03_JPRB, 0.38243738E-03_JPRB, 0.38229305E-03_JPRB, 0.38235159E-03_JPRB, &
  & 0.38243886E-03_JPRB, 0.38252091E-03_JPRB, 0.38261764E-03_JPRB, 0.38284695E-03_JPRB, 0.38315180E-03_JPRB, 0.38341360E-03_JPRB, &
  & 0.38367958E-03_JPRB, 0.38409480E-03_JPRB, 0.38455821E-03_JPRB, 0.38485295E-03_JPRB, 0.38503751E-03_JPRB, 0.38526624E-03_JPRB, &
  & 0.38548195E-03_JPRB, 0.38580954E-03_JPRB, 0.38621291E-03_JPRB, 0.38628773E-03_JPRB, 0.38618648E-03_JPRB, 0.38596702E-03_JPRB, &
  & 0.38550926E-03_JPRB, 0.38516155E-03_JPRB, 0.38482089E-03_JPRB, 0.38432565E-03_JPRB, 0.38408509E-03_JPRB, 0.38387747E-03_JPRB, &
  & 0.38371856E-03_JPRB, 0.38367411E-03_JPRB, 0.38369333E-03_JPRB, 0.38372744E-03_JPRB, 0.38373055E-03_JPRB, 0.38377888E-03_JPRB, &
  & 0.38398940E-03_JPRB, 0.38427945E-03_JPRB, 0.38457026E-03_JPRB, 0.38475848E-03_JPRB, 0.38492525E-03_JPRB, 0.38512398E-03_JPRB, &
  & 0.38543892E-03_JPRB, 0.38580505E-03_JPRB, 0.38631469E-03_JPRB, 0.38667237E-03_JPRB, 0.38691700E-03_JPRB, 0.38714078E-03_JPRB, &
  & 0.38700682E-03_JPRB, 0.38665009E-03_JPRB, 0.38632582E-03_JPRB, 0.38651858E-03_JPRB  /)

RGHG1(:,50, 1) = (/ &
  & 0.38853885E-03_JPRB, 0.38743733E-03_JPRB, 0.38684422E-03_JPRB, 0.38686765E-03_JPRB, 0.38605992E-03_JPRB, 0.38491569E-03_JPRB, &
  & 0.38389612E-03_JPRB, 0.38346451E-03_JPRB, 0.38342971E-03_JPRB, 0.38367076E-03_JPRB, 0.38379064E-03_JPRB, 0.38367222E-03_JPRB, &
  & 0.38331459E-03_JPRB, 0.38282943E-03_JPRB, 0.38243722E-03_JPRB, 0.38219677E-03_JPRB, 0.38210422E-03_JPRB, 0.38220175E-03_JPRB, &
  & 0.38230539E-03_JPRB, 0.38240648E-03_JPRB, 0.38250359E-03_JPRB, 0.38275204E-03_JPRB, 0.38310325E-03_JPRB, 0.38339099E-03_JPRB, &
  & 0.38368135E-03_JPRB, 0.38411648E-03_JPRB, 0.38460403E-03_JPRB, 0.38491062E-03_JPRB, 0.38506731E-03_JPRB, 0.38526062E-03_JPRB, &
  & 0.38549019E-03_JPRB, 0.38582237E-03_JPRB, 0.38622615E-03_JPRB, 0.38631597E-03_JPRB, 0.38622073E-03_JPRB, 0.38600488E-03_JPRB, &
  & 0.38554570E-03_JPRB, 0.38515671E-03_JPRB, 0.38479408E-03_JPRB, 0.38431635E-03_JPRB, 0.38407561E-03_JPRB, 0.38386217E-03_JPRB, &
  & 0.38365822E-03_JPRB, 0.38359145E-03_JPRB, 0.38359888E-03_JPRB, 0.38365500E-03_JPRB, 0.38368630E-03_JPRB, 0.38379209E-03_JPRB, &
  & 0.38405190E-03_JPRB, 0.38436077E-03_JPRB, 0.38465551E-03_JPRB, 0.38487272E-03_JPRB, 0.38507921E-03_JPRB, 0.38531470E-03_JPRB, &
  & 0.38566288E-03_JPRB, 0.38606245E-03_JPRB, 0.38657271E-03_JPRB, 0.38694201E-03_JPRB, 0.38713385E-03_JPRB, 0.38727050E-03_JPRB, &
  & 0.38707279E-03_JPRB, 0.38662026E-03_JPRB, 0.38617421E-03_JPRB, 0.38626804E-03_JPRB  /)

RGHG1(:,51, 1) = (/ &
  & 0.38717589E-03_JPRB, 0.38609235E-03_JPRB, 0.38527113E-03_JPRB, 0.38541618E-03_JPRB, 0.38490880E-03_JPRB, 0.38391288E-03_JPRB, &
  & 0.38298589E-03_JPRB, 0.38261724E-03_JPRB, 0.38263141E-03_JPRB, 0.38288092E-03_JPRB, 0.38299600E-03_JPRB, 0.38295934E-03_JPRB, &
  & 0.38271145E-03_JPRB, 0.38238566E-03_JPRB, 0.38212345E-03_JPRB, 0.38196069E-03_JPRB, 0.38192598E-03_JPRB, 0.38206158E-03_JPRB, &
  & 0.38218873E-03_JPRB, 0.38230357E-03_JPRB, 0.38239523E-03_JPRB, 0.38266036E-03_JPRB, 0.38305379E-03_JPRB, 0.38336374E-03_JPRB, &
  & 0.38368444E-03_JPRB, 0.38414104E-03_JPRB, 0.38465285E-03_JPRB, 0.38497326E-03_JPRB, 0.38509985E-03_JPRB, 0.38525297E-03_JPRB, &
  & 0.38550630E-03_JPRB, 0.38585059E-03_JPRB, 0.38624616E-03_JPRB, 0.38633801E-03_JPRB, 0.38624285E-03_JPRB, 0.38603319E-03_JPRB, &
  & 0.38557938E-03_JPRB, 0.38513743E-03_JPRB, 0.38474649E-03_JPRB, 0.38430439E-03_JPRB, 0.38406601E-03_JPRB, 0.38384761E-03_JPRB, &
  & 0.38359655E-03_JPRB, 0.38350571E-03_JPRB, 0.38349971E-03_JPRB, 0.38356503E-03_JPRB, 0.38362521E-03_JPRB, 0.38378135E-03_JPRB, &
  & 0.38407167E-03_JPRB, 0.38438818E-03_JPRB, 0.38468586E-03_JPRB, 0.38492812E-03_JPRB, 0.38517472E-03_JPRB, 0.38545381E-03_JPRB, &
  & 0.38582037E-03_JPRB, 0.38625321E-03_JPRB, 0.38675526E-03_JPRB, 0.38714636E-03_JPRB, 0.38725994E-03_JPRB, 0.38726806E-03_JPRB, &
  & 0.38702146E-03_JPRB, 0.38646309E-03_JPRB, 0.38591153E-03_JPRB, 0.38590969E-03_JPRB  /)

RGHG1(:,52, 1) = (/ &
  & 0.38556406E-03_JPRB, 0.38451048E-03_JPRB, 0.38366753E-03_JPRB, 0.38387438E-03_JPRB, 0.38354525E-03_JPRB, 0.38277566E-03_JPRB, &
  & 0.38205061E-03_JPRB, 0.38179853E-03_JPRB, 0.38189970E-03_JPRB, 0.38216819E-03_JPRB, 0.38230602E-03_JPRB, 0.38234190E-03_JPRB, &
  & 0.38220078E-03_JPRB, 0.38200967E-03_JPRB, 0.38187296E-03_JPRB, 0.38177930E-03_JPRB, 0.38178654E-03_JPRB, 0.38195194E-03_JPRB, &
  & 0.38210836E-03_JPRB, 0.38222923E-03_JPRB, 0.38231119E-03_JPRB, 0.38258079E-03_JPRB, 0.38299404E-03_JPRB, 0.38331760E-03_JPRB, &
  & 0.38366125E-03_JPRB, 0.38412596E-03_JPRB, 0.38466699E-03_JPRB, 0.38501926E-03_JPRB, 0.38512873E-03_JPRB, 0.38526321E-03_JPRB, &
  & 0.38552157E-03_JPRB, 0.38588056E-03_JPRB, 0.38627807E-03_JPRB, 0.38636037E-03_JPRB, 0.38625282E-03_JPRB, 0.38604623E-03_JPRB, &
  & 0.38558678E-03_JPRB, 0.38510077E-03_JPRB, 0.38467862E-03_JPRB, 0.38427646E-03_JPRB, 0.38405669E-03_JPRB, 0.38383338E-03_JPRB, &
  & 0.38354795E-03_JPRB, 0.38344104E-03_JPRB, 0.38343987E-03_JPRB, 0.38350304E-03_JPRB, 0.38360489E-03_JPRB, 0.38377260E-03_JPRB, &
  & 0.38407765E-03_JPRB, 0.38439971E-03_JPRB, 0.38470432E-03_JPRB, 0.38494602E-03_JPRB, 0.38523344E-03_JPRB, 0.38554837E-03_JPRB, &
  & 0.38593843E-03_JPRB, 0.38638701E-03_JPRB, 0.38687555E-03_JPRB, 0.38722604E-03_JPRB, 0.38728599E-03_JPRB, 0.38721588E-03_JPRB, &
  & 0.38691515E-03_JPRB, 0.38633259E-03_JPRB, 0.38581645E-03_JPRB, 0.38579319E-03_JPRB  /)

RGHG1(:,53, 1) = (/ &
  & 0.38371304E-03_JPRB, 0.38269673E-03_JPRB, 0.38190948E-03_JPRB, 0.38216063E-03_JPRB, 0.38197863E-03_JPRB, 0.38148554E-03_JPRB, &
  & 0.38102248E-03_JPRB, 0.38091796E-03_JPRB, 0.38112850E-03_JPRB, 0.38142171E-03_JPRB, 0.38159490E-03_JPRB, 0.38170624E-03_JPRB, &
  & 0.38168023E-03_JPRB, 0.38162630E-03_JPRB, 0.38162454E-03_JPRB, 0.38160281E-03_JPRB, 0.38164962E-03_JPRB, 0.38184430E-03_JPRB, &
  & 0.38203479E-03_JPRB, 0.38215927E-03_JPRB, 0.38222904E-03_JPRB, 0.38249881E-03_JPRB, 0.38292503E-03_JPRB, 0.38326008E-03_JPRB, &
  & 0.38362588E-03_JPRB, 0.38409429E-03_JPRB, 0.38466905E-03_JPRB, 0.38506295E-03_JPRB, 0.38515878E-03_JPRB, 0.38528123E-03_JPRB, &
  & 0.38553788E-03_JPRB, 0.38591387E-03_JPRB, 0.38631738E-03_JPRB, 0.38638483E-03_JPRB, 0.38625900E-03_JPRB, 0.38605456E-03_JPRB, &
  & 0.38558472E-03_JPRB, 0.38505415E-03_JPRB, 0.38459690E-03_JPRB, 0.38423989E-03_JPRB, 0.38404664E-03_JPRB, 0.38381802E-03_JPRB, &
  & 0.38350005E-03_JPRB, 0.38337871E-03_JPRB, 0.38338982E-03_JPRB, 0.38344630E-03_JPRB, 0.38359845E-03_JPRB, 0.38376385E-03_JPRB, &
  & 0.38407885E-03_JPRB, 0.38440615E-03_JPRB, 0.38471986E-03_JPRB, 0.38495108E-03_JPRB, 0.38528322E-03_JPRB, 0.38563422E-03_JPRB, &
  & 0.38605183E-03_JPRB, 0.38651080E-03_JPRB, 0.38698260E-03_JPRB, 0.38726484E-03_JPRB, 0.38727586E-03_JPRB, 0.38713991E-03_JPRB, &
  & 0.38677823E-03_JPRB, 0.38620073E-03_JPRB, 0.38577739E-03_JPRB, 0.38575937E-03_JPRB  /)

RGHG1(:,54, 1) = (/ &
  & 0.38214371E-03_JPRB, 0.38135954E-03_JPRB, 0.38077782E-03_JPRB, 0.38101934E-03_JPRB, 0.38093248E-03_JPRB, 0.38064813E-03_JPRB, &
  & 0.38041455E-03_JPRB, 0.38043116E-03_JPRB, 0.38073804E-03_JPRB, 0.38103872E-03_JPRB, 0.38122001E-03_JPRB, 0.38136015E-03_JPRB, &
  & 0.38137495E-03_JPRB, 0.38137990E-03_JPRB, 0.38144368E-03_JPRB, 0.38146251E-03_JPRB, 0.38152786E-03_JPRB, 0.38173689E-03_JPRB, &
  & 0.38194445E-03_JPRB, 0.38208952E-03_JPRB, 0.38216072E-03_JPRB, 0.38242044E-03_JPRB, 0.38282943E-03_JPRB, 0.38318445E-03_JPRB, &
  & 0.38356701E-03_JPRB, 0.38402574E-03_JPRB, 0.38462539E-03_JPRB, 0.38507781E-03_JPRB, 0.38519166E-03_JPRB, 0.38532460E-03_JPRB, &
  & 0.38557158E-03_JPRB, 0.38593975E-03_JPRB, 0.38634787E-03_JPRB, 0.38638185E-03_JPRB, 0.38623916E-03_JPRB, 0.38601348E-03_JPRB, &
  & 0.38551931E-03_JPRB, 0.38498012E-03_JPRB, 0.38453428E-03_JPRB, 0.38421888E-03_JPRB, 0.38403668E-03_JPRB, 0.38379912E-03_JPRB, &
  & 0.38347483E-03_JPRB, 0.38336887E-03_JPRB, 0.38339215E-03_JPRB, 0.38346886E-03_JPRB, 0.38366266E-03_JPRB, 0.38381650E-03_JPRB, &
  & 0.38415048E-03_JPRB, 0.38449634E-03_JPRB, 0.38483557E-03_JPRB, 0.38507670E-03_JPRB, 0.38542521E-03_JPRB, 0.38580942E-03_JPRB, &
  & 0.38626767E-03_JPRB, 0.38672509E-03_JPRB, 0.38716807E-03_JPRB, 0.38737655E-03_JPRB, 0.38734938E-03_JPRB, 0.38719461E-03_JPRB, &
  & 0.38684733E-03_JPRB, 0.38630006E-03_JPRB, 0.38601342E-03_JPRB, 0.38601403E-03_JPRB  /)

RGHG1(:,55, 1) = (/ &
  & 0.38044232E-03_JPRB, 0.37994096E-03_JPRB, 0.37960661E-03_JPRB, 0.37983037E-03_JPRB, 0.37984206E-03_JPRB, 0.37978004E-03_JPRB, &
  & 0.37979639E-03_JPRB, 0.37994369E-03_JPRB, 0.38035559E-03_JPRB, 0.38066229E-03_JPRB, 0.38084895E-03_JPRB, 0.38101486E-03_JPRB, &
  & 0.38106510E-03_JPRB, 0.38112496E-03_JPRB, 0.38125223E-03_JPRB, 0.38131187E-03_JPRB, 0.38139497E-03_JPRB, 0.38161794E-03_JPRB, &
  & 0.38184216E-03_JPRB, 0.38201228E-03_JPRB, 0.38208685E-03_JPRB, 0.38233410E-03_JPRB, 0.38272005E-03_JPRB, 0.38309829E-03_JPRB, &
  & 0.38349869E-03_JPRB, 0.38394495E-03_JPRB, 0.38457101E-03_JPRB, 0.38509047E-03_JPRB, 0.38522845E-03_JPRB, 0.38537597E-03_JPRB, &
  & 0.38561120E-03_JPRB, 0.38596744E-03_JPRB, 0.38638047E-03_JPRB, 0.38637492E-03_JPRB, 0.38621374E-03_JPRB, 0.38596147E-03_JPRB, &
  & 0.38543852E-03_JPRB, 0.38489451E-03_JPRB, 0.38446742E-03_JPRB, 0.38419766E-03_JPRB, 0.38402566E-03_JPRB, 0.38377771E-03_JPRB, &
  & 0.38344987E-03_JPRB, 0.38336486E-03_JPRB, 0.38340162E-03_JPRB, 0.38350429E-03_JPRB, 0.38374309E-03_JPRB, 0.38388289E-03_JPRB, &
  & 0.38423911E-03_JPRB, 0.38460728E-03_JPRB, 0.38497693E-03_JPRB, 0.38523172E-03_JPRB, 0.38559462E-03_JPRB, 0.38601526E-03_JPRB, &
  & 0.38652023E-03_JPRB, 0.38697437E-03_JPRB, 0.38738384E-03_JPRB, 0.38750990E-03_JPRB, 0.38744182E-03_JPRB, 0.38727239E-03_JPRB, &
  & 0.38695098E-03_JPRB, 0.38644051E-03_JPRB, 0.38631107E-03_JPRB, 0.38633409E-03_JPRB  /)

RGHG1(:,56, 1) = (/ &
  & 0.37969875E-03_JPRB, 0.37947604E-03_JPRB, 0.37926745E-03_JPRB, 0.37945453E-03_JPRB, 0.37950341E-03_JPRB, 0.37956192E-03_JPRB, &
  & 0.37972003E-03_JPRB, 0.37994164E-03_JPRB, 0.38036649E-03_JPRB, 0.38064122E-03_JPRB, 0.38079862E-03_JPRB, 0.38094441E-03_JPRB, &
  & 0.38098030E-03_JPRB, 0.38101940E-03_JPRB, 0.38112902E-03_JPRB, 0.38119844E-03_JPRB, 0.38128302E-03_JPRB, 0.38150415E-03_JPRB, &
  & 0.38173271E-03_JPRB, 0.38192878E-03_JPRB, 0.38201148E-03_JPRB, 0.38224288E-03_JPRB, 0.38258727E-03_JPRB, 0.38297108E-03_JPRB, &
  & 0.38340678E-03_JPRB, 0.38385362E-03_JPRB, 0.38447318E-03_JPRB, 0.38507751E-03_JPRB, 0.38526752E-03_JPRB, 0.38543392E-03_JPRB, &
  & 0.38567694E-03_JPRB, 0.38600676E-03_JPRB, 0.38636055E-03_JPRB, 0.38629120E-03_JPRB, 0.38611570E-03_JPRB, 0.38583592E-03_JPRB, &
  & 0.38532376E-03_JPRB, 0.38482663E-03_JPRB, 0.38445584E-03_JPRB, 0.38419176E-03_JPRB, 0.38400691E-03_JPRB, 0.38373400E-03_JPRB, &
  & 0.38345250E-03_JPRB, 0.38341077E-03_JPRB, 0.38346034E-03_JPRB, 0.38361840E-03_JPRB, 0.38389260E-03_JPRB, 0.38404369E-03_JPRB, &
  & 0.38441755E-03_JPRB, 0.38481911E-03_JPRB, 0.38522472E-03_JPRB, 0.38551865E-03_JPRB, 0.38589521E-03_JPRB, 0.38633698E-03_JPRB, &
  & 0.38683991E-03_JPRB, 0.38732839E-03_JPRB, 0.38768662E-03_JPRB, 0.38778699E-03_JPRB, 0.38769087E-03_JPRB, 0.38753756E-03_JPRB, &
  & 0.38723237E-03_JPRB, 0.38675590E-03_JPRB, 0.38669094E-03_JPRB, 0.38675706E-03_JPRB  /)

RGHG1(:,57, 1) = (/ &
  & 0.37907804E-03_JPRB, 0.37909282E-03_JPRB, 0.37898769E-03_JPRB, 0.37914347E-03_JPRB, 0.37921612E-03_JPRB, 0.37938158E-03_JPRB, &
  & 0.37966123E-03_JPRB, 0.37994541E-03_JPRB, 0.38037706E-03_JPRB, 0.38061879E-03_JPRB, 0.38075303E-03_JPRB, 0.38088298E-03_JPRB, &
  & 0.38090653E-03_JPRB, 0.38092448E-03_JPRB, 0.38101596E-03_JPRB, 0.38108619E-03_JPRB, 0.38116681E-03_JPRB, 0.38138476E-03_JPRB, &
  & 0.38162275E-03_JPRB, 0.38183707E-03_JPRB, 0.38192887E-03_JPRB, 0.38214887E-03_JPRB, 0.38245405E-03_JPRB, 0.38283207E-03_JPRB, &
  & 0.38328920E-03_JPRB, 0.38374595E-03_JPRB, 0.38435943E-03_JPRB, 0.38504153E-03_JPRB, 0.38529569E-03_JPRB, 0.38548801E-03_JPRB, &
  & 0.38573985E-03_JPRB, 0.38605342E-03_JPRB, 0.38632762E-03_JPRB, 0.38619966E-03_JPRB, 0.38600427E-03_JPRB, 0.38571457E-03_JPRB, &
  & 0.38521123E-03_JPRB, 0.38475898E-03_JPRB, 0.38443969E-03_JPRB, 0.38418360E-03_JPRB, 0.38398387E-03_JPRB, 0.38369158E-03_JPRB, &
  & 0.38346194E-03_JPRB, 0.38346104E-03_JPRB, 0.38352899E-03_JPRB, 0.38374222E-03_JPRB, 0.38405712E-03_JPRB, 0.38422800E-03_JPRB, &
  & 0.38462090E-03_JPRB, 0.38505676E-03_JPRB, 0.38549371E-03_JPRB, 0.38582188E-03_JPRB, 0.38621176E-03_JPRB, 0.38666852E-03_JPRB, &
  & 0.38716573E-03_JPRB, 0.38767737E-03_JPRB, 0.38799206E-03_JPRB, 0.38807042E-03_JPRB, 0.38795459E-03_JPRB, 0.38781814E-03_JPRB, &
  & 0.38753432E-03_JPRB, 0.38709037E-03_JPRB, 0.38706919E-03_JPRB, 0.38717952E-03_JPRB  /)

RGHG1(:,58, 1) = (/ &
  & 0.37889435E-03_JPRB, 0.37905717E-03_JPRB, 0.37898675E-03_JPRB, 0.37911927E-03_JPRB, 0.37917963E-03_JPRB, 0.37940144E-03_JPRB, &
  & 0.37973838E-03_JPRB, 0.38004968E-03_JPRB, 0.38045997E-03_JPRB, 0.38066247E-03_JPRB, 0.38077922E-03_JPRB, 0.38089329E-03_JPRB, &
  & 0.38089954E-03_JPRB, 0.38088316E-03_JPRB, 0.38094194E-03_JPRB, 0.38099193E-03_JPRB, 0.38105667E-03_JPRB, 0.38126649E-03_JPRB, &
  & 0.38151941E-03_JPRB, 0.38173770E-03_JPRB, 0.38184038E-03_JPRB, 0.38205678E-03_JPRB, 0.38232642E-03_JPRB, 0.38267665E-03_JPRB, &
  & 0.38313330E-03_JPRB, 0.38361738E-03_JPRB, 0.38421979E-03_JPRB, 0.38496477E-03_JPRB, 0.38530363E-03_JPRB, 0.38553244E-03_JPRB, &
  & 0.38579780E-03_JPRB, 0.38611090E-03_JPRB, 0.38626550E-03_JPRB, 0.38608792E-03_JPRB, 0.38586557E-03_JPRB, 0.38559630E-03_JPRB, &
  & 0.38510516E-03_JPRB, 0.38470045E-03_JPRB, 0.38442749E-03_JPRB, 0.38417519E-03_JPRB, 0.38395400E-03_JPRB, 0.38365055E-03_JPRB, &
  & 0.38348727E-03_JPRB, 0.38352400E-03_JPRB, 0.38361814E-03_JPRB, 0.38388724E-03_JPRB, 0.38424667E-03_JPRB, 0.38445490E-03_JPRB, &
  & 0.38486680E-03_JPRB, 0.38533783E-03_JPRB, 0.38579681E-03_JPRB, 0.38615296E-03_JPRB, 0.38655437E-03_JPRB, 0.38701170E-03_JPRB, &
  & 0.38748830E-03_JPRB, 0.38800940E-03_JPRB, 0.38829374E-03_JPRB, 0.38836869E-03_JPRB, 0.38825126E-03_JPRB, 0.38813730E-03_JPRB, &
  & 0.38788006E-03_JPRB, 0.38746296E-03_JPRB, 0.38742967E-03_JPRB, 0.38758642E-03_JPRB  /)

RGHG1(:,59, 1) = (/ &
  & 0.37899059E-03_JPRB, 0.37922749E-03_JPRB, 0.37917689E-03_JPRB, 0.37928856E-03_JPRB, 0.37931386E-03_JPRB, 0.37954507E-03_JPRB, &
  & 0.37989479E-03_JPRB, 0.38018941E-03_JPRB, 0.38056917E-03_JPRB, 0.38073528E-03_JPRB, 0.38083966E-03_JPRB, 0.38093683E-03_JPRB, &
  & 0.38093017E-03_JPRB, 0.38088364E-03_JPRB, 0.38090684E-03_JPRB, 0.38092290E-03_JPRB, 0.38096993E-03_JPRB, 0.38116256E-03_JPRB, &
  & 0.38142548E-03_JPRB, 0.38163422E-03_JPRB, 0.38174454E-03_JPRB, 0.38195936E-03_JPRB, 0.38219143E-03_JPRB, 0.38252604E-03_JPRB, &
  & 0.38296996E-03_JPRB, 0.38347145E-03_JPRB, 0.38405429E-03_JPRB, 0.38482540E-03_JPRB, 0.38525444E-03_JPRB, 0.38555068E-03_JPRB, &
  & 0.38583708E-03_JPRB, 0.38613327E-03_JPRB, 0.38619331E-03_JPRB, 0.38598774E-03_JPRB, 0.38573229E-03_JPRB, 0.38546434E-03_JPRB, &
  & 0.38500199E-03_JPRB, 0.38465590E-03_JPRB, 0.38438798E-03_JPRB, 0.38413951E-03_JPRB, 0.38391140E-03_JPRB, 0.38362240E-03_JPRB, &
  & 0.38353232E-03_JPRB, 0.38359464E-03_JPRB, 0.38372133E-03_JPRB, 0.38404346E-03_JPRB, 0.38444493E-03_JPRB, 0.38469981E-03_JPRB, &
  & 0.38513236E-03_JPRB, 0.38562215E-03_JPRB, 0.38608452E-03_JPRB, 0.38645560E-03_JPRB, 0.38686268E-03_JPRB, 0.38730943E-03_JPRB, &
  & 0.38775883E-03_JPRB, 0.38826096E-03_JPRB, 0.38851704E-03_JPRB, 0.38859853E-03_JPRB, 0.38850112E-03_JPRB, 0.38840879E-03_JPRB, &
  & 0.38820202E-03_JPRB, 0.38782086E-03_JPRB, 0.38774735E-03_JPRB, 0.38791166E-03_JPRB  /)

RGHG1(:,60, 1) = (/ &
  & 0.37921190E-03_JPRB, 0.37949239E-03_JPRB, 0.37945610E-03_JPRB, 0.37955076E-03_JPRB, 0.37953216E-03_JPRB, 0.37974909E-03_JPRB, &
  & 0.38009094E-03_JPRB, 0.38034985E-03_JPRB, 0.38069411E-03_JPRB, 0.38082814E-03_JPRB, 0.38092024E-03_JPRB, 0.38099765E-03_JPRB, &
  & 0.38097854E-03_JPRB, 0.38090303E-03_JPRB, 0.38088904E-03_JPRB, 0.38086644E-03_JPRB, 0.38089639E-03_JPRB, 0.38106622E-03_JPRB, &
  & 0.38133258E-03_JPRB, 0.38152920E-03_JPRB, 0.38164502E-03_JPRB, 0.38185780E-03_JPRB, 0.38205126E-03_JPRB, 0.38237305E-03_JPRB, &
  & 0.38279944E-03_JPRB, 0.38331297E-03_JPRB, 0.38387645E-03_JPRB, 0.38465798E-03_JPRB, 0.38517298E-03_JPRB, 0.38554773E-03_JPRB, &
  & 0.38585743E-03_JPRB, 0.38613413E-03_JPRB, 0.38611546E-03_JPRB, 0.38589302E-03_JPRB, 0.38560434E-03_JPRB, 0.38532490E-03_JPRB, &
  & 0.38489850E-03_JPRB, 0.38461247E-03_JPRB, 0.38433440E-03_JPRB, 0.38408964E-03_JPRB, 0.38386505E-03_JPRB, 0.38360530E-03_JPRB, &
  & 0.38358825E-03_JPRB, 0.38367101E-03_JPRB, 0.38383449E-03_JPRB, 0.38421124E-03_JPRB, 0.38465306E-03_JPRB, 0.38496016E-03_JPRB, &
  & 0.38541268E-03_JPRB, 0.38591366E-03_JPRB, 0.38637210E-03_JPRB, 0.38675245E-03_JPRB, 0.38716156E-03_JPRB, 0.38759301E-03_JPRB, &
  & 0.38801205E-03_JPRB, 0.38848334E-03_JPRB, 0.38871214E-03_JPRB, 0.38880636E-03_JPRB, 0.38873929E-03_JPRB, 0.38866878E-03_JPRB, &
  & 0.38852107E-03_JPRB, 0.38818162E-03_JPRB, 0.38805817E-03_JPRB, 0.38821136E-03_JPRB  /)

RGHG1(:,61, 1) = (/ &
  & 0.37955314E-03_JPRB, 0.37983958E-03_JPRB, 0.37981170E-03_JPRB, 0.37990471E-03_JPRB, 0.37984204E-03_JPRB, 0.38000986E-03_JPRB, &
  & 0.38031727E-03_JPRB, 0.38052411E-03_JPRB, 0.38082993E-03_JPRB, 0.38095105E-03_JPRB, 0.38102664E-03_JPRB, 0.38107709E-03_JPRB, &
  & 0.38104384E-03_JPRB, 0.38094352E-03_JPRB, 0.38089529E-03_JPRB, 0.38083835E-03_JPRB, 0.38085887E-03_JPRB, 0.38099816E-03_JPRB, &
  & 0.38124689E-03_JPRB, 0.38144002E-03_JPRB, 0.38155584E-03_JPRB, 0.38176247E-03_JPRB, 0.38192179E-03_JPRB, 0.38222883E-03_JPRB, &
  & 0.38263645E-03_JPRB, 0.38315070E-03_JPRB, 0.38370967E-03_JPRB, 0.38448239E-03_JPRB, 0.38504536E-03_JPRB, 0.38549186E-03_JPRB, &
  & 0.38582084E-03_JPRB, 0.38609159E-03_JPRB, 0.38603981E-03_JPRB, 0.38582116E-03_JPRB, 0.38551188E-03_JPRB, 0.38519472E-03_JPRB, &
  & 0.38480666E-03_JPRB, 0.38456286E-03_JPRB, 0.38426664E-03_JPRB, 0.38402445E-03_JPRB, 0.38382702E-03_JPRB, 0.38361975E-03_JPRB, &
  & 0.38365457E-03_JPRB, 0.38374881E-03_JPRB, 0.38395237E-03_JPRB, 0.38438509E-03_JPRB, 0.38485705E-03_JPRB, 0.38521889E-03_JPRB, &
  & 0.38568330E-03_JPRB, 0.38618356E-03_JPRB, 0.38663247E-03_JPRB, 0.38701405E-03_JPRB, 0.38741742E-03_JPRB, 0.38783093E-03_JPRB, &
  & 0.38821994E-03_JPRB, 0.38865288E-03_JPRB, 0.38886016E-03_JPRB, 0.38897775E-03_JPRB, 0.38895086E-03_JPRB, 0.38890055E-03_JPRB, &
  & 0.38880706E-03_JPRB, 0.38851467E-03_JPRB, 0.38834529E-03_JPRB, 0.38846219E-03_JPRB  /)

RGHG1(:,62, 1) = (/ &
  & 0.37994132E-03_JPRB, 0.38021849E-03_JPRB, 0.38019025E-03_JPRB, 0.38028529E-03_JPRB, 0.38019208E-03_JPRB, 0.38028457E-03_JPRB, &
  & 0.38054240E-03_JPRB, 0.38071084E-03_JPRB, 0.38096940E-03_JPRB, 0.38108804E-03_JPRB, 0.38114630E-03_JPRB, 0.38116977E-03_JPRB, &
  & 0.38111691E-03_JPRB, 0.38099638E-03_JPRB, 0.38091168E-03_JPRB, 0.38082902E-03_JPRB, 0.38083943E-03_JPRB, 0.38095000E-03_JPRB, &
  & 0.38117220E-03_JPRB, 0.38136507E-03_JPRB, 0.38148469E-03_JPRB, 0.38167639E-03_JPRB, 0.38182569E-03_JPRB, 0.38210451E-03_JPRB, &
  & 0.38250553E-03_JPRB, 0.38300261E-03_JPRB, 0.38356307E-03_JPRB, 0.38432480E-03_JPRB, 0.38493727E-03_JPRB, 0.38542366E-03_JPRB, &
  & 0.38574839E-03_JPRB, 0.38602387E-03_JPRB, 0.38597829E-03_JPRB, 0.38578495E-03_JPRB, 0.38545798E-03_JPRB, 0.38509552E-03_JPRB, &
  & 0.38473510E-03_JPRB, 0.38449572E-03_JPRB, 0.38420120E-03_JPRB, 0.38396977E-03_JPRB, 0.38380067E-03_JPRB, 0.38364734E-03_JPRB, &
  & 0.38371860E-03_JPRB, 0.38383016E-03_JPRB, 0.38407538E-03_JPRB, 0.38456077E-03_JPRB, 0.38505973E-03_JPRB, 0.38547077E-03_JPRB, &
  & 0.38594327E-03_JPRB, 0.38643415E-03_JPRB, 0.38687230E-03_JPRB, 0.38725591E-03_JPRB, 0.38763848E-03_JPRB, 0.38803333E-03_JPRB, &
  & 0.38839954E-03_JPRB, 0.38880135E-03_JPRB, 0.38900266E-03_JPRB, 0.38915461E-03_JPRB, 0.38916311E-03_JPRB, 0.38913371E-03_JPRB, &
  & 0.38906917E-03_JPRB, 0.38881804E-03_JPRB, 0.38861091E-03_JPRB, 0.38869841E-03_JPRB  /)

RGHG1(:,63, 1) = (/ &
  & 0.38035287E-03_JPRB, 0.38061195E-03_JPRB, 0.38058150E-03_JPRB, 0.38067422E-03_JPRB, 0.38056046E-03_JPRB, 0.38056586E-03_JPRB, &
  & 0.38076305E-03_JPRB, 0.38090714E-03_JPRB, 0.38111576E-03_JPRB, 0.38123329E-03_JPRB, 0.38127395E-03_JPRB, 0.38127076E-03_JPRB, &
  & 0.38119530E-03_JPRB, 0.38105821E-03_JPRB, 0.38093630E-03_JPRB, 0.38083228E-03_JPRB, 0.38082941E-03_JPRB, 0.38091181E-03_JPRB, &
  & 0.38110356E-03_JPRB, 0.38129686E-03_JPRB, 0.38142440E-03_JPRB, 0.38159571E-03_JPRB, 0.38175133E-03_JPRB, 0.38200482E-03_JPRB, &
  & 0.38239601E-03_JPRB, 0.38286648E-03_JPRB, 0.38342783E-03_JPRB, 0.38417643E-03_JPRB, 0.38483704E-03_JPRB, 0.38534747E-03_JPRB, &
  & 0.38566250E-03_JPRB, 0.38594166E-03_JPRB, 0.38592309E-03_JPRB, 0.38577058E-03_JPRB, 0.38543264E-03_JPRB, 0.38501948E-03_JPRB, &
  & 0.38467809E-03_JPRB, 0.38442206E-03_JPRB, 0.38413820E-03_JPRB, 0.38392350E-03_JPRB, 0.38378504E-03_JPRB, 0.38368398E-03_JPRB, &
  & 0.38378499E-03_JPRB, 0.38392317E-03_JPRB, 0.38420900E-03_JPRB, 0.38474120E-03_JPRB, 0.38526654E-03_JPRB, 0.38571875E-03_JPRB, &
  & 0.38619649E-03_JPRB, 0.38667349E-03_JPRB, 0.38710013E-03_JPRB, 0.38748494E-03_JPRB, 0.38783985E-03_JPRB, 0.38821436E-03_JPRB, &
  & 0.38856588E-03_JPRB, 0.38894329E-03_JPRB, 0.38914871E-03_JPRB, 0.38934194E-03_JPRB, 0.38937739E-03_JPRB, 0.38936534E-03_JPRB, &
  & 0.38931398E-03_JPRB, 0.38909981E-03_JPRB, 0.38886747E-03_JPRB, 0.38892827E-03_JPRB  /)

RGHG1(:,64, 1) = (/ &
  & 0.38075838E-03_JPRB, 0.38099369E-03_JPRB, 0.38096548E-03_JPRB, 0.38104139E-03_JPRB, 0.38091888E-03_JPRB, 0.38083818E-03_JPRB, &
  & 0.38096507E-03_JPRB, 0.38110681E-03_JPRB, 0.38126981E-03_JPRB, 0.38137892E-03_JPRB, 0.38140288E-03_JPRB, 0.38137491E-03_JPRB, &
  & 0.38127591E-03_JPRB, 0.38112727E-03_JPRB, 0.38097005E-03_JPRB, 0.38084753E-03_JPRB, 0.38082470E-03_JPRB, 0.38087952E-03_JPRB, &
  & 0.38104145E-03_JPRB, 0.38123351E-03_JPRB, 0.38137507E-03_JPRB, 0.38152216E-03_JPRB, 0.38169987E-03_JPRB, 0.38195000E-03_JPRB, &
  & 0.38231125E-03_JPRB, 0.38275101E-03_JPRB, 0.38330551E-03_JPRB, 0.38403842E-03_JPRB, 0.38474028E-03_JPRB, 0.38526697E-03_JPRB, &
  & 0.38558324E-03_JPRB, 0.38585242E-03_JPRB, 0.38587129E-03_JPRB, 0.38577462E-03_JPRB, 0.38543993E-03_JPRB, 0.38497240E-03_JPRB, &
  & 0.38463874E-03_JPRB, 0.38435300E-03_JPRB, 0.38408135E-03_JPRB, 0.38388919E-03_JPRB, 0.38378470E-03_JPRB, 0.38372826E-03_JPRB, &
  & 0.38385697E-03_JPRB, 0.38403798E-03_JPRB, 0.38435856E-03_JPRB, 0.38492450E-03_JPRB, 0.38547686E-03_JPRB, 0.38595430E-03_JPRB, &
  & 0.38643383E-03_JPRB, 0.38689525E-03_JPRB, 0.38731011E-03_JPRB, 0.38769325E-03_JPRB, 0.38801990E-03_JPRB, 0.38837143E-03_JPRB, &
  & 0.38872160E-03_JPRB, 0.38908500E-03_JPRB, 0.38930353E-03_JPRB, 0.38954239E-03_JPRB, 0.38958760E-03_JPRB, 0.38958262E-03_JPRB, &
  & 0.38953058E-03_JPRB, 0.38934713E-03_JPRB, 0.38911345E-03_JPRB, 0.38914823E-03_JPRB  /)

RGHG1(:,65, 1) = (/ &
  & 0.38111920E-03_JPRB, 0.38133525E-03_JPRB, 0.38131588E-03_JPRB, 0.38135730E-03_JPRB, 0.38123392E-03_JPRB, 0.38109818E-03_JPRB, &
  & 0.38114923E-03_JPRB, 0.38129643E-03_JPRB, 0.38144141E-03_JPRB, 0.38153015E-03_JPRB, 0.38153029E-03_JPRB, 0.38148653E-03_JPRB, &
  & 0.38136465E-03_JPRB, 0.38120709E-03_JPRB, 0.38102148E-03_JPRB, 0.38088313E-03_JPRB, 0.38083300E-03_JPRB, 0.38085492E-03_JPRB, &
  & 0.38099202E-03_JPRB, 0.38118523E-03_JPRB, 0.38133350E-03_JPRB, 0.38146747E-03_JPRB, 0.38166920E-03_JPRB, 0.38193159E-03_JPRB, &
  & 0.38223013E-03_JPRB, 0.38264123E-03_JPRB, 0.38318508E-03_JPRB, 0.38392878E-03_JPRB, 0.38465542E-03_JPRB, 0.38520902E-03_JPRB, &
  & 0.38554386E-03_JPRB, 0.38579714E-03_JPRB, 0.38584508E-03_JPRB, 0.38578651E-03_JPRB, 0.38548316E-03_JPRB, 0.38497973E-03_JPRB, &
  & 0.38464897E-03_JPRB, 0.38432735E-03_JPRB, 0.38405966E-03_JPRB, 0.38389302E-03_JPRB, 0.38381400E-03_JPRB, 0.38379907E-03_JPRB, &
  & 0.38396132E-03_JPRB, 0.38419091E-03_JPRB, 0.38454223E-03_JPRB, 0.38512329E-03_JPRB, 0.38569328E-03_JPRB, 0.38617505E-03_JPRB, &
  & 0.38665410E-03_JPRB, 0.38710263E-03_JPRB, 0.38750720E-03_JPRB, 0.38788780E-03_JPRB, 0.38820790E-03_JPRB, 0.38853711E-03_JPRB, &
  & 0.38889187E-03_JPRB, 0.38925670E-03_JPRB, 0.38949241E-03_JPRB, 0.38976034E-03_JPRB, 0.38980036E-03_JPRB, 0.38979174E-03_JPRB, &
  & 0.38973496E-03_JPRB, 0.38958173E-03_JPRB, 0.38937664E-03_JPRB, 0.38937082E-03_JPRB  /)

RGHG1(:,66, 1) = (/ &
  & 0.38144661E-03_JPRB, 0.38164347E-03_JPRB, 0.38162959E-03_JPRB, 0.38163819E-03_JPRB, 0.38151866E-03_JPRB, 0.38134973E-03_JPRB, &
  & 0.38132863E-03_JPRB, 0.38147866E-03_JPRB, 0.38162197E-03_JPRB, 0.38168321E-03_JPRB, 0.38165498E-03_JPRB, 0.38160585E-03_JPRB, &
  & 0.38146410E-03_JPRB, 0.38129614E-03_JPRB, 0.38108733E-03_JPRB, 0.38093212E-03_JPRB, 0.38085106E-03_JPRB, 0.38083759E-03_JPRB, &
  & 0.38095730E-03_JPRB, 0.38115005E-03_JPRB, 0.38130286E-03_JPRB, 0.38143596E-03_JPRB, 0.38165334E-03_JPRB, 0.38191923E-03_JPRB, &
  & 0.38215556E-03_JPRB, 0.38252976E-03_JPRB, 0.38306980E-03_JPRB, 0.38383732E-03_JPRB, 0.38458571E-03_JPRB, 0.38517092E-03_JPRB, &
  & 0.38553044E-03_JPRB, 0.38576408E-03_JPRB, 0.38583514E-03_JPRB, 0.38580455E-03_JPRB, 0.38553391E-03_JPRB, 0.38502233E-03_JPRB, &
  & 0.38469198E-03_JPRB, 0.38434641E-03_JPRB, 0.38407042E-03_JPRB, 0.38392287E-03_JPRB, 0.38386427E-03_JPRB, 0.38389335E-03_JPRB, &
  & 0.38409790E-03_JPRB, 0.38437578E-03_JPRB, 0.38475622E-03_JPRB, 0.38533894E-03_JPRB, 0.38591574E-03_JPRB, 0.38639528E-03_JPRB, &
  & 0.38687154E-03_JPRB, 0.38730987E-03_JPRB, 0.38770754E-03_JPRB, 0.38808479E-03_JPRB, 0.38841368E-03_JPRB, 0.38872229E-03_JPRB, &
  & 0.38907833E-03_JPRB, 0.38945458E-03_JPRB, 0.38970635E-03_JPRB, 0.38998618E-03_JPRB, 0.39002013E-03_JPRB, 0.39000969E-03_JPRB, &
  & 0.38995083E-03_JPRB, 0.38982406E-03_JPRB, 0.38966225E-03_JPRB, 0.38962369E-03_JPRB  /)

RGHG1(:,67, 1) = (/ &
  & 0.38173265E-03_JPRB, 0.38190943E-03_JPRB, 0.38189745E-03_JPRB, 0.38187969E-03_JPRB, 0.38176629E-03_JPRB, 0.38158581E-03_JPRB, &
  & 0.38150403E-03_JPRB, 0.38165212E-03_JPRB, 0.38180557E-03_JPRB, 0.38183433E-03_JPRB, 0.38177628E-03_JPRB, 0.38173122E-03_JPRB, &
  & 0.38157432E-03_JPRB, 0.38139461E-03_JPRB, 0.38116749E-03_JPRB, 0.38099282E-03_JPRB, 0.38087804E-03_JPRB, 0.38082949E-03_JPRB, &
  & 0.38093744E-03_JPRB, 0.38112890E-03_JPRB, 0.38128641E-03_JPRB, 0.38143042E-03_JPRB, 0.38165096E-03_JPRB, 0.38190815E-03_JPRB, &
  & 0.38209471E-03_JPRB, 0.38242260E-03_JPRB, 0.38296333E-03_JPRB, 0.38376283E-03_JPRB, 0.38453339E-03_JPRB, 0.38514913E-03_JPRB, &
  & 0.38553472E-03_JPRB, 0.38574968E-03_JPRB, 0.38584055E-03_JPRB, 0.38583068E-03_JPRB, 0.38559242E-03_JPRB, 0.38509723E-03_JPRB, &
  & 0.38476192E-03_JPRB, 0.38440681E-03_JPRB, 0.38411626E-03_JPRB, 0.38397830E-03_JPRB, 0.38393805E-03_JPRB, 0.38401240E-03_JPRB, &
  & 0.38426763E-03_JPRB, 0.38459365E-03_JPRB, 0.38499737E-03_JPRB, 0.38557024E-03_JPRB, 0.38614333E-03_JPRB, 0.38661810E-03_JPRB, &
  & 0.38708921E-03_JPRB, 0.38752076E-03_JPRB, 0.38791555E-03_JPRB, 0.38828933E-03_JPRB, 0.38863812E-03_JPRB, 0.38892979E-03_JPRB, &
  & 0.38928036E-03_JPRB, 0.38967436E-03_JPRB, 0.38993841E-03_JPRB, 0.39021608E-03_JPRB, 0.39024454E-03_JPRB, 0.39023486E-03_JPRB, &
  & 0.39017707E-03_JPRB, 0.39007319E-03_JPRB, 0.38996286E-03_JPRB, 0.38990646E-03_JPRB  /)

RGHG1(:,68, 1) = (/ &
  & 0.38196381E-03_JPRB, 0.38211825E-03_JPRB, 0.38210616E-03_JPRB, 0.38207447E-03_JPRB, 0.38196475E-03_JPRB, 0.38179440E-03_JPRB, &
  & 0.38167717E-03_JPRB, 0.38181617E-03_JPRB, 0.38198331E-03_JPRB, 0.38197823E-03_JPRB, 0.38189486E-03_JPRB, 0.38186050E-03_JPRB, &
  & 0.38169588E-03_JPRB, 0.38150409E-03_JPRB, 0.38126269E-03_JPRB, 0.38106316E-03_JPRB, 0.38091269E-03_JPRB, 0.38083432E-03_JPRB, &
  & 0.38093122E-03_JPRB, 0.38112314E-03_JPRB, 0.38128963E-03_JPRB, 0.38145459E-03_JPRB, 0.38165959E-03_JPRB, 0.38189376E-03_JPRB, &
  & 0.38206110E-03_JPRB, 0.38233257E-03_JPRB, 0.38287112E-03_JPRB, 0.38370274E-03_JPRB, 0.38450104E-03_JPRB, 0.38513532E-03_JPRB, &
  & 0.38554047E-03_JPRB, 0.38574726E-03_JPRB, 0.38586047E-03_JPRB, 0.38586936E-03_JPRB, 0.38566529E-03_JPRB, 0.38520106E-03_JPRB, &
  & 0.38484884E-03_JPRB, 0.38449948E-03_JPRB, 0.38420225E-03_JPRB, 0.38406015E-03_JPRB, 0.38404235E-03_JPRB, 0.38416010E-03_JPRB, &
  & 0.38447312E-03_JPRB, 0.38484933E-03_JPRB, 0.38526146E-03_JPRB, 0.38581671E-03_JPRB, 0.38637690E-03_JPRB, 0.38685041E-03_JPRB, &
  & 0.38731392E-03_JPRB, 0.38774352E-03_JPRB, 0.38814015E-03_JPRB, 0.38851185E-03_JPRB, 0.38888333E-03_JPRB, 0.38916532E-03_JPRB, &
  & 0.38949828E-03_JPRB, 0.38990932E-03_JPRB, 0.39017752E-03_JPRB, 0.39044655E-03_JPRB, 0.39047040E-03_JPRB, 0.39046314E-03_JPRB, &
  & 0.39040903E-03_JPRB, 0.39032611E-03_JPRB, 0.39026459E-03_JPRB, 0.39021510E-03_JPRB  /)

RGHG1(:,69, 1) = (/ &
  & 0.38212725E-03_JPRB, 0.38226156E-03_JPRB, 0.38225773E-03_JPRB, 0.38222479E-03_JPRB, 0.38211415E-03_JPRB, 0.38196556E-03_JPRB, &
  & 0.38184776E-03_JPRB, 0.38196918E-03_JPRB, 0.38213734E-03_JPRB, 0.38210659E-03_JPRB, 0.38201184E-03_JPRB, 0.38198871E-03_JPRB, &
  & 0.38182518E-03_JPRB, 0.38162664E-03_JPRB, 0.38137559E-03_JPRB, 0.38115077E-03_JPRB, 0.38096735E-03_JPRB, 0.38086514E-03_JPRB, &
  & 0.38093768E-03_JPRB, 0.38111864E-03_JPRB, 0.38130449E-03_JPRB, 0.38148589E-03_JPRB, 0.38167200E-03_JPRB, 0.38188346E-03_JPRB, &
  & 0.38204949E-03_JPRB, 0.38227735E-03_JPRB, 0.38279087E-03_JPRB, 0.38364287E-03_JPRB, 0.38445717E-03_JPRB, 0.38511679E-03_JPRB, &
  & 0.38554591E-03_JPRB, 0.38574820E-03_JPRB, 0.38588310E-03_JPRB, 0.38591735E-03_JPRB, 0.38575732E-03_JPRB, 0.38532489E-03_JPRB, &
  & 0.38495397E-03_JPRB, 0.38461613E-03_JPRB, 0.38432480E-03_JPRB, 0.38418001E-03_JPRB, 0.38419441E-03_JPRB, 0.38434141E-03_JPRB, &
  & 0.38471283E-03_JPRB, 0.38513440E-03_JPRB, 0.38553754E-03_JPRB, 0.38608241E-03_JPRB, 0.38662102E-03_JPRB, 0.38709881E-03_JPRB, &
  & 0.38755630E-03_JPRB, 0.38798939E-03_JPRB, 0.38839352E-03_JPRB, 0.38876828E-03_JPRB, 0.38915216E-03_JPRB, 0.38943245E-03_JPRB, &
  & 0.38972779E-03_JPRB, 0.39014487E-03_JPRB, 0.39040893E-03_JPRB, 0.39068075E-03_JPRB, 0.39070052E-03_JPRB, 0.39068771E-03_JPRB, &
  & 0.39063676E-03_JPRB, 0.39057447E-03_JPRB, 0.39055494E-03_JPRB, 0.39053467E-03_JPRB  /)

RGHG1(:,70, 1) = (/ &
  & 0.38224947E-03_JPRB, 0.38237139E-03_JPRB, 0.38238316E-03_JPRB, 0.38235216E-03_JPRB, 0.38224027E-03_JPRB, 0.38211503E-03_JPRB, &
  & 0.38201202E-03_JPRB, 0.38211192E-03_JPRB, 0.38227148E-03_JPRB, 0.38222191E-03_JPRB, 0.38212468E-03_JPRB, 0.38210897E-03_JPRB, &
  & 0.38195189E-03_JPRB, 0.38175388E-03_JPRB, 0.38149801E-03_JPRB, 0.38125351E-03_JPRB, 0.38104436E-03_JPRB, 0.38091906E-03_JPRB, &
  & 0.38095692E-03_JPRB, 0.38111901E-03_JPRB, 0.38132139E-03_JPRB, 0.38150751E-03_JPRB, 0.38167898E-03_JPRB, 0.38187073E-03_JPRB, &
  & 0.38203582E-03_JPRB, 0.38223549E-03_JPRB, 0.38271753E-03_JPRB, 0.38356691E-03_JPRB, 0.38438585E-03_JPRB, 0.38508392E-03_JPRB, &
  & 0.38555501E-03_JPRB, 0.38575589E-03_JPRB, 0.38590191E-03_JPRB, 0.38596376E-03_JPRB, 0.38584440E-03_JPRB, 0.38544713E-03_JPRB, &
  & 0.38506499E-03_JPRB, 0.38474414E-03_JPRB, 0.38446277E-03_JPRB, 0.38432147E-03_JPRB, 0.38437503E-03_JPRB, 0.38454874E-03_JPRB, &
  & 0.38497092E-03_JPRB, 0.38542710E-03_JPRB, 0.38581690E-03_JPRB, 0.38635450E-03_JPRB, 0.38687416E-03_JPRB, 0.38735840E-03_JPRB, &
  & 0.38781997E-03_JPRB, 0.38825088E-03_JPRB, 0.38866268E-03_JPRB, 0.38904470E-03_JPRB, 0.38943572E-03_JPRB, 0.38971635E-03_JPRB, &
  & 0.38996553E-03_JPRB, 0.39037398E-03_JPRB, 0.39063101E-03_JPRB, 0.39090602E-03_JPRB, 0.39092557E-03_JPRB, 0.39090855E-03_JPRB, &
  & 0.39086253E-03_JPRB, 0.39082282E-03_JPRB, 0.39083941E-03_JPRB, 0.39085310E-03_JPRB  /)

RGHG1(:,71, 1) = (/ &
  & 0.38234021E-03_JPRB, 0.38245724E-03_JPRB, 0.38248810E-03_JPRB, 0.38245931E-03_JPRB, 0.38234638E-03_JPRB, 0.38224394E-03_JPRB, &
  & 0.38216559E-03_JPRB, 0.38224231E-03_JPRB, 0.38238604E-03_JPRB, 0.38232516E-03_JPRB, 0.38223150E-03_JPRB, 0.38221884E-03_JPRB, &
  & 0.38207243E-03_JPRB, 0.38188121E-03_JPRB, 0.38162698E-03_JPRB, 0.38136891E-03_JPRB, 0.38114228E-03_JPRB, 0.38099528E-03_JPRB, &
  & 0.38099252E-03_JPRB, 0.38113010E-03_JPRB, 0.38134037E-03_JPRB, 0.38151810E-03_JPRB, 0.38167728E-03_JPRB, 0.38185034E-03_JPRB, &
  & 0.38201355E-03_JPRB, 0.38219938E-03_JPRB, 0.38264663E-03_JPRB, 0.38347093E-03_JPRB, 0.38428856E-03_JPRB, 0.38503643E-03_JPRB, &
  & 0.38556323E-03_JPRB, 0.38576750E-03_JPRB, 0.38591483E-03_JPRB, 0.38600700E-03_JPRB, 0.38592399E-03_JPRB, 0.38556469E-03_JPRB, &
  & 0.38517797E-03_JPRB, 0.38487823E-03_JPRB, 0.38461024E-03_JPRB, 0.38447916E-03_JPRB, 0.38457629E-03_JPRB, 0.38478070E-03_JPRB, &
  & 0.38524470E-03_JPRB, 0.38572307E-03_JPRB, 0.38609765E-03_JPRB, 0.38662965E-03_JPRB, 0.38713689E-03_JPRB, 0.38763014E-03_JPRB, &
  & 0.38810422E-03_JPRB, 0.38852508E-03_JPRB, 0.38894228E-03_JPRB, 0.38933457E-03_JPRB, 0.38973104E-03_JPRB, 0.39001193E-03_JPRB, &
  & 0.39021318E-03_JPRB, 0.39059617E-03_JPRB, 0.39084390E-03_JPRB, 0.39112211E-03_JPRB, 0.39114762E-03_JPRB, 0.39112834E-03_JPRB, &
  & 0.39109022E-03_JPRB, 0.39107560E-03_JPRB, 0.39112088E-03_JPRB, 0.39116498E-03_JPRB  /)

RGHG1(:,72, 1) = (/ &
  & 0.38241235E-03_JPRB, 0.38253053E-03_JPRB, 0.38257683E-03_JPRB, 0.38254689E-03_JPRB, 0.38243327E-03_JPRB, 0.38235111E-03_JPRB, &
  & 0.38230110E-03_JPRB, 0.38235639E-03_JPRB, 0.38248076E-03_JPRB, 0.38241780E-03_JPRB, 0.38232945E-03_JPRB, 0.38231518E-03_JPRB, &
  & 0.38218237E-03_JPRB, 0.38200197E-03_JPRB, 0.38175904E-03_JPRB, 0.38149336E-03_JPRB, 0.38125867E-03_JPRB, 0.38109369E-03_JPRB, &
  & 0.38105198E-03_JPRB, 0.38116283E-03_JPRB, 0.38136364E-03_JPRB, 0.38151833E-03_JPRB, 0.38166230E-03_JPRB, 0.38181323E-03_JPRB, &
  & 0.38197484E-03_JPRB, 0.38215882E-03_JPRB, 0.38257034E-03_JPRB, 0.38334994E-03_JPRB, 0.38417056E-03_JPRB, 0.38497536E-03_JPRB, &
  & 0.38556093E-03_JPRB, 0.38577695E-03_JPRB, 0.38591921E-03_JPRB, 0.38604641E-03_JPRB, 0.38599635E-03_JPRB, 0.38567647E-03_JPRB, &
  & 0.38528836E-03_JPRB, 0.38501144E-03_JPRB, 0.38476097E-03_JPRB, 0.38464718E-03_JPRB, 0.38478809E-03_JPRB, 0.38503767E-03_JPRB, &
  & 0.38553370E-03_JPRB, 0.38601969E-03_JPRB, 0.38637905E-03_JPRB, 0.38690529E-03_JPRB, 0.38741183E-03_JPRB, 0.38791822E-03_JPRB, &
  & 0.38840844E-03_JPRB, 0.38880925E-03_JPRB, 0.38922599E-03_JPRB, 0.38962957E-03_JPRB, 0.39003572E-03_JPRB, 0.39031385E-03_JPRB, &
  & 0.39047592E-03_JPRB, 0.39081258E-03_JPRB, 0.39104879E-03_JPRB, 0.39133184E-03_JPRB, 0.39137348E-03_JPRB, 0.39135304E-03_JPRB, &
  & 0.39132783E-03_JPRB, 0.39134157E-03_JPRB, 0.39140482E-03_JPRB, 0.39146344E-03_JPRB  /)

RGHG1(:,73, 1) = (/ &
  & 0.38248266E-03_JPRB, 0.38259494E-03_JPRB, 0.38264137E-03_JPRB, 0.38260471E-03_JPRB, 0.38249830E-03_JPRB, 0.38243526E-03_JPRB, &
  & 0.38240906E-03_JPRB, 0.38245285E-03_JPRB, 0.38255240E-03_JPRB, 0.38249163E-03_JPRB, 0.38241246E-03_JPRB, 0.38239528E-03_JPRB, &
  & 0.38227486E-03_JPRB, 0.38210857E-03_JPRB, 0.38188683E-03_JPRB, 0.38162185E-03_JPRB, 0.38138867E-03_JPRB, 0.38121352E-03_JPRB, &
  & 0.38113713E-03_JPRB, 0.38121660E-03_JPRB, 0.38139101E-03_JPRB, 0.38151589E-03_JPRB, 0.38164070E-03_JPRB, 0.38176982E-03_JPRB, &
  & 0.38192573E-03_JPRB, 0.38211621E-03_JPRB, 0.38248409E-03_JPRB, 0.38323113E-03_JPRB, 0.38406247E-03_JPRB, 0.38490719E-03_JPRB, &
  & 0.38554332E-03_JPRB, 0.38577223E-03_JPRB, 0.38591538E-03_JPRB, 0.38608252E-03_JPRB, 0.38607117E-03_JPRB, 0.38579649E-03_JPRB, &
  & 0.38540656E-03_JPRB, 0.38515494E-03_JPRB, 0.38493236E-03_JPRB, 0.38485306E-03_JPRB, 0.38502797E-03_JPRB, 0.38532769E-03_JPRB, &
  & 0.38585209E-03_JPRB, 0.38633332E-03_JPRB, 0.38668380E-03_JPRB, 0.38720639E-03_JPRB, 0.38771950E-03_JPRB, 0.38823033E-03_JPRB, &
  & 0.38873015E-03_JPRB, 0.38911100E-03_JPRB, 0.38952172E-03_JPRB, 0.38993067E-03_JPRB, 0.39034870E-03_JPRB, 0.39061762E-03_JPRB, &
  & 0.39075269E-03_JPRB, 0.39102992E-03_JPRB, 0.39125155E-03_JPRB, 0.39154054E-03_JPRB, 0.39161338E-03_JPRB, 0.39159114E-03_JPRB, &
  & 0.39157763E-03_JPRB, 0.39162544E-03_JPRB, 0.39168902E-03_JPRB, 0.39175861E-03_JPRB  /)

RGHG1(:,74, 1) = (/ &
  & 0.38255413E-03_JPRB, 0.38265033E-03_JPRB, 0.38268933E-03_JPRB, 0.38264604E-03_JPRB, 0.38255030E-03_JPRB, 0.38250584E-03_JPRB, &
  & 0.38250026E-03_JPRB, 0.38253853E-03_JPRB, 0.38261046E-03_JPRB, 0.38255211E-03_JPRB, 0.38248341E-03_JPRB, 0.38246252E-03_JPRB, &
  & 0.38235605E-03_JPRB, 0.38220371E-03_JPRB, 0.38200467E-03_JPRB, 0.38174832E-03_JPRB, 0.38152093E-03_JPRB, 0.38134478E-03_JPRB, &
  & 0.38123785E-03_JPRB, 0.38128586E-03_JPRB, 0.38142468E-03_JPRB, 0.38152102E-03_JPRB, 0.38162498E-03_JPRB, 0.38173747E-03_JPRB, &
  & 0.38188652E-03_JPRB, 0.38207583E-03_JPRB, 0.38239919E-03_JPRB, 0.38310970E-03_JPRB, 0.38394906E-03_JPRB, 0.38482055E-03_JPRB, &
  & 0.38550328E-03_JPRB, 0.38575686E-03_JPRB, 0.38590669E-03_JPRB, 0.38610801E-03_JPRB, 0.38614598E-03_JPRB, 0.38591262E-03_JPRB, &
  & 0.38553128E-03_JPRB, 0.38530987E-03_JPRB, 0.38513953E-03_JPRB, 0.38510853E-03_JPRB, 0.38531044E-03_JPRB, 0.38565288E-03_JPRB, &
  & 0.38619056E-03_JPRB, 0.38665876E-03_JPRB, 0.38700675E-03_JPRB, 0.38752753E-03_JPRB, 0.38805075E-03_JPRB, 0.38855972E-03_JPRB, &
  & 0.38906175E-03_JPRB, 0.38942268E-03_JPRB, 0.38982357E-03_JPRB, 0.39024309E-03_JPRB, 0.39066913E-03_JPRB, 0.39092791E-03_JPRB, &
  & 0.39103424E-03_JPRB, 0.39125004E-03_JPRB, 0.39146087E-03_JPRB, 0.39175783E-03_JPRB, 0.39186701E-03_JPRB, 0.39184472E-03_JPRB, &
  & 0.39183667E-03_JPRB, 0.39191635E-03_JPRB, 0.39197195E-03_JPRB, 0.39204441E-03_JPRB  /)

RGHG1(:,75, 1) = (/ &
  & 0.38262289E-03_JPRB, 0.38269361E-03_JPRB, 0.38272131E-03_JPRB, 0.38267453E-03_JPRB, 0.38259088E-03_JPRB, 0.38256499E-03_JPRB, &
  & 0.38257660E-03_JPRB, 0.38261298E-03_JPRB, 0.38265663E-03_JPRB, 0.38260014E-03_JPRB, 0.38254094E-03_JPRB, 0.38251666E-03_JPRB, &
  & 0.38242546E-03_JPRB, 0.38228745E-03_JPRB, 0.38211076E-03_JPRB, 0.38187016E-03_JPRB, 0.38165304E-03_JPRB, 0.38148341E-03_JPRB, &
  & 0.38135172E-03_JPRB, 0.38137128E-03_JPRB, 0.38146918E-03_JPRB, 0.38154023E-03_JPRB, 0.38162184E-03_JPRB, 0.38171950E-03_JPRB, &
  & 0.38185707E-03_JPRB, 0.38203662E-03_JPRB, 0.38231877E-03_JPRB, 0.38298622E-03_JPRB, 0.38382446E-03_JPRB, 0.38471126E-03_JPRB, &
  & 0.38543516E-03_JPRB, 0.38573187E-03_JPRB, 0.38589474E-03_JPRB, 0.38612406E-03_JPRB, 0.38621756E-03_JPRB, 0.38601630E-03_JPRB, &
  & 0.38565682E-03_JPRB, 0.38547200E-03_JPRB, 0.38536700E-03_JPRB, 0.38539359E-03_JPRB, 0.38562182E-03_JPRB, 0.38600737E-03_JPRB, &
  & 0.38654507E-03_JPRB, 0.38699509E-03_JPRB, 0.38734434E-03_JPRB, 0.38786436E-03_JPRB, 0.38840158E-03_JPRB, 0.38890456E-03_JPRB, &
  & 0.38940064E-03_JPRB, 0.38974048E-03_JPRB, 0.39013236E-03_JPRB, 0.39056595E-03_JPRB, 0.39099679E-03_JPRB, 0.39124690E-03_JPRB, &
  & 0.39131980E-03_JPRB, 0.39147354E-03_JPRB, 0.39167827E-03_JPRB, 0.39198658E-03_JPRB, 0.39213106E-03_JPRB, 0.39211159E-03_JPRB, &
  & 0.39210129E-03_JPRB, 0.39220615E-03_JPRB, 0.39224864E-03_JPRB, 0.39231438E-03_JPRB  /)

RGHG1(:,76, 1) = (/ &
  & 0.38268248E-03_JPRB, 0.38271977E-03_JPRB, 0.38273687E-03_JPRB, 0.38269378E-03_JPRB, 0.38262120E-03_JPRB, 0.38261467E-03_JPRB, &
  & 0.38263941E-03_JPRB, 0.38267442E-03_JPRB, 0.38269202E-03_JPRB, 0.38263622E-03_JPRB, 0.38258232E-03_JPRB, 0.38255665E-03_JPRB, &
  & 0.38248136E-03_JPRB, 0.38235949E-03_JPRB, 0.38220308E-03_JPRB, 0.38198439E-03_JPRB, 0.38178317E-03_JPRB, 0.38162507E-03_JPRB, &
  & 0.38147701E-03_JPRB, 0.38147537E-03_JPRB, 0.38153177E-03_JPRB, 0.38158277E-03_JPRB, 0.38164040E-03_JPRB, 0.38171892E-03_JPRB, &
  & 0.38183437E-03_JPRB, 0.38199616E-03_JPRB, 0.38224604E-03_JPRB, 0.38286186E-03_JPRB, 0.38368096E-03_JPRB, 0.38457352E-03_JPRB, &
  & 0.38533016E-03_JPRB, 0.38569810E-03_JPRB, 0.38588148E-03_JPRB, 0.38613339E-03_JPRB, 0.38628130E-03_JPRB, 0.38609571E-03_JPRB, &
  & 0.38577473E-03_JPRB, 0.38563510E-03_JPRB, 0.38558911E-03_JPRB, 0.38567633E-03_JPRB, 0.38593983E-03_JPRB, 0.38638323E-03_JPRB, &
  & 0.38691195E-03_JPRB, 0.38734283E-03_JPRB, 0.38769301E-03_JPRB, 0.38821211E-03_JPRB, 0.38876846E-03_JPRB, 0.38926429E-03_JPRB, &
  & 0.38974493E-03_JPRB, 0.39006056E-03_JPRB, 0.39045129E-03_JPRB, 0.39089825E-03_JPRB, 0.39133255E-03_JPRB, 0.39157850E-03_JPRB, &
  & 0.39161037E-03_JPRB, 0.39170188E-03_JPRB, 0.39190568E-03_JPRB, 0.39223082E-03_JPRB, 0.39240135E-03_JPRB, 0.39238902E-03_JPRB, &
  & 0.39236696E-03_JPRB, 0.39248428E-03_JPRB, 0.39251202E-03_JPRB, 0.39255954E-03_JPRB  /)

RGHG1(:,77, 1) = (/ &
  & 0.38270988E-03_JPRB, 0.38271438E-03_JPRB, 0.38273159E-03_JPRB, 0.38270266E-03_JPRB, 0.38264285E-03_JPRB, 0.38265197E-03_JPRB, &
  & 0.38268783E-03_JPRB, 0.38272231E-03_JPRB, 0.38272059E-03_JPRB, 0.38266194E-03_JPRB, 0.38260832E-03_JPRB, 0.38258236E-03_JPRB, &
  & 0.38251966E-03_JPRB, 0.38241105E-03_JPRB, 0.38227588E-03_JPRB, 0.38208051E-03_JPRB, 0.38189431E-03_JPRB, 0.38175589E-03_JPRB, &
  & 0.38160875E-03_JPRB, 0.38159623E-03_JPRB, 0.38162364E-03_JPRB, 0.38164209E-03_JPRB, 0.38167275E-03_JPRB, 0.38172809E-03_JPRB, &
  & 0.38182442E-03_JPRB, 0.38196976E-03_JPRB, 0.38219400E-03_JPRB, 0.38273660E-03_JPRB, 0.38351457E-03_JPRB, 0.38440433E-03_JPRB, &
  & 0.38519949E-03_JPRB, 0.38564855E-03_JPRB, 0.38586338E-03_JPRB, 0.38612823E-03_JPRB, 0.38632532E-03_JPRB, 0.38615719E-03_JPRB, &
  & 0.38587903E-03_JPRB, 0.38578056E-03_JPRB, 0.38577182E-03_JPRB, 0.38592274E-03_JPRB, 0.38624796E-03_JPRB, 0.38674562E-03_JPRB, &
  & 0.38729027E-03_JPRB, 0.38769621E-03_JPRB, 0.38804731E-03_JPRB, 0.38856880E-03_JPRB, 0.38914190E-03_JPRB, 0.38963270E-03_JPRB, &
  & 0.39009501E-03_JPRB, 0.39038654E-03_JPRB, 0.39077388E-03_JPRB, 0.39122908E-03_JPRB, 0.39166689E-03_JPRB, 0.39191972E-03_JPRB, &
  & 0.39191019E-03_JPRB, 0.39194633E-03_JPRB, 0.39214055E-03_JPRB, 0.39248009E-03_JPRB, 0.39266108E-03_JPRB, 0.39266066E-03_JPRB, &
  & 0.39262246E-03_JPRB, 0.39273622E-03_JPRB, 0.39274899E-03_JPRB, 0.39277117E-03_JPRB  /)

RGHG1(:,78, 1) = (/ &
  & 0.38270608E-03_JPRB, 0.38268715E-03_JPRB, 0.38271352E-03_JPRB, 0.38270210E-03_JPRB, 0.38265794E-03_JPRB, 0.38268155E-03_JPRB, &
  & 0.38272421E-03_JPRB, 0.38275600E-03_JPRB, 0.38273866E-03_JPRB, 0.38267683E-03_JPRB, 0.38262351E-03_JPRB, 0.38259613E-03_JPRB, &
  & 0.38254341E-03_JPRB, 0.38244577E-03_JPRB, 0.38232825E-03_JPRB, 0.38215159E-03_JPRB, 0.38198254E-03_JPRB, 0.38186046E-03_JPRB, &
  & 0.38171889E-03_JPRB, 0.38170369E-03_JPRB, 0.38171001E-03_JPRB, 0.38169462E-03_JPRB, 0.38170655E-03_JPRB, 0.38174348E-03_JPRB, &
  & 0.38181736E-03_JPRB, 0.38194772E-03_JPRB, 0.38215317E-03_JPRB, 0.38263188E-03_JPRB, 0.38335978E-03_JPRB, 0.38425177E-03_JPRB, &
  & 0.38507895E-03_JPRB, 0.38558948E-03_JPRB, 0.38584323E-03_JPRB, 0.38611731E-03_JPRB, 0.38635541E-03_JPRB, 0.38621723E-03_JPRB, &
  & 0.38596815E-03_JPRB, 0.38590811E-03_JPRB, 0.38593734E-03_JPRB, 0.38614063E-03_JPRB, 0.38653399E-03_JPRB, 0.38708015E-03_JPRB, &
  & 0.38763716E-03_JPRB, 0.38803588E-03_JPRB, 0.38838911E-03_JPRB, 0.38891019E-03_JPRB, 0.38950816E-03_JPRB, 0.39000416E-03_JPRB, &
  & 0.39045726E-03_JPRB, 0.39072537E-03_JPRB, 0.39110387E-03_JPRB, 0.39156209E-03_JPRB, 0.39200652E-03_JPRB, 0.39226918E-03_JPRB, &
  & 0.39221245E-03_JPRB, 0.39219677E-03_JPRB, 0.39237489E-03_JPRB, 0.39272152E-03_JPRB, 0.39289083E-03_JPRB, 0.39290491E-03_JPRB, &
  & 0.39285812E-03_JPRB, 0.39296581E-03_JPRB, 0.39296559E-03_JPRB, 0.39296376E-03_JPRB  /)

RGHG1(:,79, 1) = (/ &
  & 0.38267389E-03_JPRB, 0.38264426E-03_JPRB, 0.38268654E-03_JPRB, 0.38269332E-03_JPRB, 0.38266646E-03_JPRB, 0.38270370E-03_JPRB, &
  & 0.38275001E-03_JPRB, 0.38277801E-03_JPRB, 0.38274810E-03_JPRB, 0.38268355E-03_JPRB, 0.38263002E-03_JPRB, 0.38260019E-03_JPRB, &
  & 0.38255220E-03_JPRB, 0.38246260E-03_JPRB, 0.38235869E-03_JPRB, 0.38219596E-03_JPRB, 0.38204375E-03_JPRB, 0.38193581E-03_JPRB, &
  & 0.38180434E-03_JPRB, 0.38179216E-03_JPRB, 0.38178319E-03_JPRB, 0.38174007E-03_JPRB, 0.38173971E-03_JPRB, 0.38176259E-03_JPRB, &
  & 0.38181301E-03_JPRB, 0.38192989E-03_JPRB, 0.38212300E-03_JPRB, 0.38255514E-03_JPRB, 0.38324209E-03_JPRB, 0.38413690E-03_JPRB, &
  & 0.38498171E-03_JPRB, 0.38552849E-03_JPRB, 0.38582350E-03_JPRB, 0.38610603E-03_JPRB, 0.38637832E-03_JPRB, 0.38627812E-03_JPRB, &
  & 0.38604563E-03_JPRB, 0.38602105E-03_JPRB, 0.38609064E-03_JPRB, 0.38633709E-03_JPRB, 0.38678579E-03_JPRB, 0.38737384E-03_JPRB, &
  & 0.38794183E-03_JPRB, 0.38835044E-03_JPRB, 0.38871037E-03_JPRB, 0.38922626E-03_JPRB, 0.38985752E-03_JPRB, 0.39037439E-03_JPRB, &
  & 0.39082895E-03_JPRB, 0.39107285E-03_JPRB, 0.39144278E-03_JPRB, 0.39189842E-03_JPRB, 0.39235075E-03_JPRB, 0.39262167E-03_JPRB, &
  & 0.39251292E-03_JPRB, 0.39244709E-03_JPRB, 0.39260322E-03_JPRB, 0.39294836E-03_JPRB, 0.39309224E-03_JPRB, 0.39311788E-03_JPRB, &
  & 0.39307171E-03_JPRB, 0.39317067E-03_JPRB, 0.39315937E-03_JPRB, 0.39313695E-03_JPRB  /)

RGHG1(:,80, 1) = (/ &
  & 0.38261722E-03_JPRB, 0.38259242E-03_JPRB, 0.38265475E-03_JPRB, 0.38267788E-03_JPRB, 0.38266850E-03_JPRB, 0.38271863E-03_JPRB, &
  & 0.38276702E-03_JPRB, 0.38279157E-03_JPRB, 0.38275148E-03_JPRB, 0.38268533E-03_JPRB, 0.38263019E-03_JPRB, 0.38259721E-03_JPRB, &
  & 0.38254577E-03_JPRB, 0.38246058E-03_JPRB, 0.38236615E-03_JPRB, 0.38221284E-03_JPRB, 0.38207429E-03_JPRB, 0.38198035E-03_JPRB, &
  & 0.38186398E-03_JPRB, 0.38185782E-03_JPRB, 0.38183692E-03_JPRB, 0.38177973E-03_JPRB, 0.38177060E-03_JPRB, 0.38178265E-03_JPRB, &
  & 0.38181167E-03_JPRB, 0.38191655E-03_JPRB, 0.38210314E-03_JPRB, 0.38251259E-03_JPRB, 0.38318709E-03_JPRB, 0.38407933E-03_JPRB, &
  & 0.38491961E-03_JPRB, 0.38547378E-03_JPRB, 0.38580674E-03_JPRB, 0.38609986E-03_JPRB, 0.38640131E-03_JPRB, 0.38634114E-03_JPRB, &
  & 0.38611555E-03_JPRB, 0.38612323E-03_JPRB, 0.38623581E-03_JPRB, 0.38651986E-03_JPRB, 0.38699125E-03_JPRB, 0.38761402E-03_JPRB, &
  & 0.38819591E-03_JPRB, 0.38862890E-03_JPRB, 0.38900358E-03_JPRB, 0.38950760E-03_JPRB, 0.39017980E-03_JPRB, 0.39073831E-03_JPRB, &
  & 0.39120553E-03_JPRB, 0.39142243E-03_JPRB, 0.39179065E-03_JPRB, 0.39223800E-03_JPRB, 0.39269724E-03_JPRB, 0.39297025E-03_JPRB, &
  & 0.39280655E-03_JPRB, 0.39269043E-03_JPRB, 0.39281963E-03_JPRB, 0.39315392E-03_JPRB, 0.39326884E-03_JPRB, 0.39329708E-03_JPRB, &
  & 0.39326176E-03_JPRB, 0.39334812E-03_JPRB, 0.39332739E-03_JPRB, 0.39328944E-03_JPRB  /)

RGHG1(:,81, 1) = (/ &
  & 0.38254516E-03_JPRB, 0.38254453E-03_JPRB, 0.38262086E-03_JPRB, 0.38265749E-03_JPRB, 0.38266329E-03_JPRB, 0.38272361E-03_JPRB, &
  & 0.38277389E-03_JPRB, 0.38279536E-03_JPRB, 0.38275148E-03_JPRB, 0.38268225E-03_JPRB, 0.38262569E-03_JPRB, 0.38258393E-03_JPRB, &
  & 0.38252941E-03_JPRB, 0.38244447E-03_JPRB, 0.38235501E-03_JPRB, 0.38221094E-03_JPRB, 0.38207713E-03_JPRB, 0.38199812E-03_JPRB, &
  & 0.38190143E-03_JPRB, 0.38189835E-03_JPRB, 0.38188220E-03_JPRB, 0.38181600E-03_JPRB, 0.38180236E-03_JPRB, 0.38180611E-03_JPRB, &
  & 0.38181712E-03_JPRB, 0.38191395E-03_JPRB, 0.38210125E-03_JPRB, 0.38250358E-03_JPRB, 0.38316908E-03_JPRB, 0.38406250E-03_JPRB, &
  & 0.38489306E-03_JPRB, 0.38543182E-03_JPRB, 0.38579844E-03_JPRB, 0.38610081E-03_JPRB, 0.38643212E-03_JPRB, 0.38640680E-03_JPRB, &
  & 0.38618738E-03_JPRB, 0.38621876E-03_JPRB, 0.38637140E-03_JPRB, 0.38667963E-03_JPRB, 0.38714011E-03_JPRB, 0.38777521E-03_JPRB, &
  & 0.38838010E-03_JPRB, 0.38883513E-03_JPRB, 0.38923945E-03_JPRB, 0.38974512E-03_JPRB, 0.39047255E-03_JPRB, 0.39108748E-03_JPRB, &
  & 0.39158363E-03_JPRB, 0.39180360E-03_JPRB, 0.39217869E-03_JPRB, 0.39260092E-03_JPRB, 0.39306514E-03_JPRB, 0.39333767E-03_JPRB, &
  & 0.39310475E-03_JPRB, 0.39293719E-03_JPRB, 0.39302349E-03_JPRB, 0.39333242E-03_JPRB, 0.39342078E-03_JPRB, 0.39344476E-03_JPRB, &
  & 0.39341631E-03_JPRB, 0.39350623E-03_JPRB, 0.39347697E-03_JPRB, 0.39343546E-03_JPRB  /)

RGHG1(:,82, 1) = (/ &
  & 0.38247911E-03_JPRB, 0.38250561E-03_JPRB, 0.38259028E-03_JPRB, 0.38263871E-03_JPRB, 0.38265598E-03_JPRB, 0.38272529E-03_JPRB, &
  & 0.38277648E-03_JPRB, 0.38279799E-03_JPRB, 0.38275050E-03_JPRB, 0.38267984E-03_JPRB, 0.38262203E-03_JPRB, 0.38257238E-03_JPRB, &
  & 0.38251447E-03_JPRB, 0.38242878E-03_JPRB, 0.38234165E-03_JPRB, 0.38220514E-03_JPRB, 0.38207473E-03_JPRB, 0.38200860E-03_JPRB, &
  & 0.38193310E-03_JPRB, 0.38193618E-03_JPRB, 0.38192555E-03_JPRB, 0.38185563E-03_JPRB, 0.38183915E-03_JPRB, 0.38183694E-03_JPRB, &
  & 0.38183217E-03_JPRB, 0.38192034E-03_JPRB, 0.38211080E-03_JPRB, 0.38250459E-03_JPRB, 0.38315836E-03_JPRB, 0.38405149E-03_JPRB, &
  & 0.38487305E-03_JPRB, 0.38540189E-03_JPRB, 0.38579641E-03_JPRB, 0.38610845E-03_JPRB, 0.38646127E-03_JPRB, 0.38646829E-03_JPRB, &
  & 0.38625613E-03_JPRB, 0.38630307E-03_JPRB, 0.38648800E-03_JPRB, 0.38681454E-03_JPRB, 0.38726059E-03_JPRB, 0.38790353E-03_JPRB, &
  & 0.38852505E-03_JPRB, 0.38899220E-03_JPRB, 0.38942693E-03_JPRB, 0.38995173E-03_JPRB, 0.39074008E-03_JPRB, 0.39139817E-03_JPRB, &
  & 0.39192958E-03_JPRB, 0.39218463E-03_JPRB, 0.39257423E-03_JPRB, 0.39296772E-03_JPRB, 0.39342725E-03_JPRB, 0.39368740E-03_JPRB, &
  & 0.39339207E-03_JPRB, 0.39317405E-03_JPRB, 0.39321380E-03_JPRB, 0.39348609E-03_JPRB, 0.39355592E-03_JPRB, 0.39357059E-03_JPRB, &
  & 0.39354342E-03_JPRB, 0.39363230E-03_JPRB, 0.39360207E-03_JPRB, 0.39355458E-03_JPRB  /)

RGHG1(:,83, 1) = (/ &
  & 0.38242039E-03_JPRB, 0.38247461E-03_JPRB, 0.38256448E-03_JPRB, 0.38262217E-03_JPRB, 0.38264799E-03_JPRB, 0.38272380E-03_JPRB, &
  & 0.38277618E-03_JPRB, 0.38279918E-03_JPRB, 0.38274801E-03_JPRB, 0.38267638E-03_JPRB, 0.38261795E-03_JPRB, 0.38256190E-03_JPRB, &
  & 0.38250112E-03_JPRB, 0.38241472E-03_JPRB, 0.38232714E-03_JPRB, 0.38219766E-03_JPRB, 0.38206970E-03_JPRB, 0.38201521E-03_JPRB, &
  & 0.38196387E-03_JPRB, 0.38197605E-03_JPRB, 0.38197398E-03_JPRB, 0.38190067E-03_JPRB, 0.38188443E-03_JPRB, 0.38188167E-03_JPRB, &
  & 0.38186164E-03_JPRB, 0.38193930E-03_JPRB, 0.38213288E-03_JPRB, 0.38251603E-03_JPRB, 0.38315695E-03_JPRB, 0.38404915E-03_JPRB, &
  & 0.38486279E-03_JPRB, 0.38538750E-03_JPRB, 0.38580127E-03_JPRB, 0.38612140E-03_JPRB, 0.38648854E-03_JPRB, 0.38652625E-03_JPRB, &
  & 0.38631999E-03_JPRB, 0.38637423E-03_JPRB, 0.38658608E-03_JPRB, 0.38692519E-03_JPRB, 0.38735599E-03_JPRB, 0.38800459E-03_JPRB, &
  & 0.38863782E-03_JPRB, 0.38911484E-03_JPRB, 0.38957646E-03_JPRB, 0.39012671E-03_JPRB, 0.39097930E-03_JPRB, 0.39167289E-03_JPRB, &
  & 0.39224612E-03_JPRB, 0.39255189E-03_JPRB, 0.39297624E-03_JPRB, 0.39333699E-03_JPRB, 0.39377172E-03_JPRB, 0.39402005E-03_JPRB, &
  & 0.39367540E-03_JPRB, 0.39340365E-03_JPRB, 0.39339290E-03_JPRB, 0.39362041E-03_JPRB, 0.39367248E-03_JPRB, 0.39366983E-03_JPRB, &
  & 0.39363996E-03_JPRB, 0.39372363E-03_JPRB, 0.39369618E-03_JPRB, 0.39364295E-03_JPRB  /)

RGHG1(:,84, 1) = (/ &
  & 0.38237050E-03_JPRB, 0.38245048E-03_JPRB, 0.38254440E-03_JPRB, 0.38260838E-03_JPRB, 0.38264053E-03_JPRB, 0.38271967E-03_JPRB, &
  & 0.38277439E-03_JPRB, 0.38279892E-03_JPRB, 0.38274383E-03_JPRB, 0.38267088E-03_JPRB, 0.38261269E-03_JPRB, 0.38255195E-03_JPRB, &
  & 0.38248939E-03_JPRB, 0.38240298E-03_JPRB, 0.38231247E-03_JPRB, 0.38219033E-03_JPRB, 0.38206425E-03_JPRB, 0.38202096E-03_JPRB, &
  & 0.38199772E-03_JPRB, 0.38202123E-03_JPRB, 0.38203246E-03_JPRB, 0.38195268E-03_JPRB, 0.38194030E-03_JPRB, 0.38194461E-03_JPRB, &
  & 0.38190873E-03_JPRB, 0.38197408E-03_JPRB, 0.38216909E-03_JPRB, 0.38253941E-03_JPRB, 0.38316783E-03_JPRB, 0.38405980E-03_JPRB, &
  & 0.38486708E-03_JPRB, 0.38539229E-03_JPRB, 0.38581488E-03_JPRB, 0.38613957E-03_JPRB, 0.38651498E-03_JPRB, 0.38658185E-03_JPRB, &
  & 0.38637747E-03_JPRB, 0.38643198E-03_JPRB, 0.38666714E-03_JPRB, 0.38701352E-03_JPRB, 0.38743092E-03_JPRB, 0.38808484E-03_JPRB, &
  & 0.38872566E-03_JPRB, 0.38921574E-03_JPRB, 0.38969798E-03_JPRB, 0.39027101E-03_JPRB, 0.39118807E-03_JPRB, 0.39191444E-03_JPRB, &
  & 0.39253450E-03_JPRB, 0.39289444E-03_JPRB, 0.39337924E-03_JPRB, 0.39370306E-03_JPRB, 0.39408657E-03_JPRB, 0.39433426E-03_JPRB, &
  & 0.39395834E-03_JPRB, 0.39362796E-03_JPRB, 0.39356248E-03_JPRB, 0.39373990E-03_JPRB, 0.39376873E-03_JPRB, 0.39373977E-03_JPRB, &
  & 0.39370536E-03_JPRB, 0.39378008E-03_JPRB, 0.39375625E-03_JPRB, 0.39369972E-03_JPRB  /)

RGHG1(:,85, 1) = (/ &
  & 0.38233789E-03_JPRB, 0.38243340E-03_JPRB, 0.38252994E-03_JPRB, 0.38259798E-03_JPRB, 0.38263491E-03_JPRB, 0.38271548E-03_JPRB, &
  & 0.38277332E-03_JPRB, 0.38279808E-03_JPRB, 0.38273893E-03_JPRB, 0.38266550E-03_JPRB, 0.38260779E-03_JPRB, 0.38254084E-03_JPRB, &
  & 0.38247732E-03_JPRB, 0.38239092E-03_JPRB, 0.38229825E-03_JPRB, 0.38218328E-03_JPRB, 0.38205983E-03_JPRB, 0.38203040E-03_JPRB, &
  & 0.38204396E-03_JPRB, 0.38207631E-03_JPRB, 0.38211144E-03_JPRB, 0.38202448E-03_JPRB, 0.38201521E-03_JPRB, 0.38204031E-03_JPRB, &
  & 0.38198866E-03_JPRB, 0.38205018E-03_JPRB, 0.38224759E-03_JPRB, 0.38260548E-03_JPRB, 0.38322339E-03_JPRB, 0.38412611E-03_JPRB, &
  & 0.38493172E-03_JPRB, 0.38544713E-03_JPRB, 0.38586566E-03_JPRB, 0.38618341E-03_JPRB, 0.38656003E-03_JPRB, 0.38664864E-03_JPRB, &
  & 0.38642873E-03_JPRB, 0.38648777E-03_JPRB, 0.38674086E-03_JPRB, 0.38708963E-03_JPRB, 0.38750321E-03_JPRB, 0.38816310E-03_JPRB, &
  & 0.38880081E-03_JPRB, 0.38930356E-03_JPRB, 0.38980563E-03_JPRB, 0.39039491E-03_JPRB, 0.39136812E-03_JPRB, 0.39213368E-03_JPRB, &
  & 0.39279293E-03_JPRB, 0.39322838E-03_JPRB, 0.39377077E-03_JPRB, 0.39404751E-03_JPRB, 0.39434715E-03_JPRB, 0.39462758E-03_JPRB, &
  & 0.39425238E-03_JPRB, 0.39386943E-03_JPRB, 0.39373370E-03_JPRB, 0.39384970E-03_JPRB, 0.39383289E-03_JPRB, 0.39377549E-03_JPRB, &
  & 0.39374466E-03_JPRB, 0.39380338E-03_JPRB, 0.39378576E-03_JPRB, 0.39373186E-03_JPRB  /)

RGHG1(:,86, 1) = (/ &
  & 0.38231679E-03_JPRB, 0.38242100E-03_JPRB, 0.38251943E-03_JPRB, 0.38259006E-03_JPRB, 0.38263123E-03_JPRB, 0.38271250E-03_JPRB, &
  & 0.38277233E-03_JPRB, 0.38279715E-03_JPRB, 0.38273242E-03_JPRB, 0.38265888E-03_JPRB, 0.38260202E-03_JPRB, 0.38252996E-03_JPRB, &
  & 0.38246678E-03_JPRB, 0.38237982E-03_JPRB, 0.38228611E-03_JPRB, 0.38217798E-03_JPRB, 0.38205660E-03_JPRB, 0.38204465E-03_JPRB, &
  & 0.38210511E-03_JPRB, 0.38213532E-03_JPRB, 0.38219409E-03_JPRB, 0.38211376E-03_JPRB, 0.38210817E-03_JPRB, 0.38215547E-03_JPRB, &
  & 0.38210612E-03_JPRB, 0.38217071E-03_JPRB, 0.38237800E-03_JPRB, 0.38274172E-03_JPRB, 0.38334514E-03_JPRB, 0.38426877E-03_JPRB, &
  & 0.38508447E-03_JPRB, 0.38559097E-03_JPRB, 0.38599719E-03_JPRB, 0.38628816E-03_JPRB, 0.38665513E-03_JPRB, 0.38673194E-03_JPRB, &
  & 0.38649156E-03_JPRB, 0.38655629E-03_JPRB, 0.38682738E-03_JPRB, 0.38717482E-03_JPRB, 0.38759278E-03_JPRB, 0.38825625E-03_JPRB, &
  & 0.38888204E-03_JPRB, 0.38939042E-03_JPRB, 0.38991654E-03_JPRB, 0.39051504E-03_JPRB, 0.39153983E-03_JPRB, 0.39233319E-03_JPRB, &
  & 0.39302321E-03_JPRB, 0.39354671E-03_JPRB, 0.39413857E-03_JPRB, 0.39434967E-03_JPRB, 0.39457361E-03_JPRB, 0.39491424E-03_JPRB, &
  & 0.39454911E-03_JPRB, 0.39412623E-03_JPRB, 0.39391185E-03_JPRB, 0.39394669E-03_JPRB, 0.39387522E-03_JPRB, 0.39379559E-03_JPRB, &
  & 0.39377043E-03_JPRB, 0.39381118E-03_JPRB, 0.39380205E-03_JPRB, 0.39375434E-03_JPRB  /)

RGHG1(:,87, 1) = (/ &
  & 0.38230329E-03_JPRB, 0.38241220E-03_JPRB, 0.38251210E-03_JPRB, 0.38258405E-03_JPRB, 0.38262887E-03_JPRB, 0.38271050E-03_JPRB, &
  & 0.38277129E-03_JPRB, 0.38279611E-03_JPRB, 0.38272541E-03_JPRB, 0.38265212E-03_JPRB, 0.38259624E-03_JPRB, 0.38251954E-03_JPRB, &
  & 0.38245772E-03_JPRB, 0.38236977E-03_JPRB, 0.38227534E-03_JPRB, 0.38217403E-03_JPRB, 0.38205847E-03_JPRB, 0.38206642E-03_JPRB, &
  & 0.38217239E-03_JPRB, 0.38219026E-03_JPRB, 0.38227380E-03_JPRB, 0.38220745E-03_JPRB, 0.38220688E-03_JPRB, 0.38227898E-03_JPRB, &
  & 0.38226047E-03_JPRB, 0.38233890E-03_JPRB, 0.38258067E-03_JPRB, 0.38294565E-03_JPRB, 0.38354379E-03_JPRB, 0.38449182E-03_JPRB, &
  & 0.38532978E-03_JPRB, 0.38584131E-03_JPRB, 0.38624996E-03_JPRB, 0.38647713E-03_JPRB, 0.38680377E-03_JPRB, 0.38683597E-03_JPRB, &
  & 0.38657538E-03_JPRB, 0.38665081E-03_JPRB, 0.38694805E-03_JPRB, 0.38728570E-03_JPRB, 0.38771472E-03_JPRB, 0.38837763E-03_JPRB, &
  & 0.38897958E-03_JPRB, 0.38948850E-03_JPRB, 0.39004820E-03_JPRB, 0.39064817E-03_JPRB, 0.39171945E-03_JPRB, 0.39252225E-03_JPRB, &
  & 0.39324081E-03_JPRB, 0.39384467E-03_JPRB, 0.39447636E-03_JPRB, 0.39461788E-03_JPRB, 0.39477838E-03_JPRB, 0.39520423E-03_JPRB, &
  & 0.39486161E-03_JPRB, 0.39440389E-03_JPRB, 0.39410781E-03_JPRB, 0.39404313E-03_JPRB, 0.39390502E-03_JPRB, 0.39380927E-03_JPRB, &
  & 0.39378646E-03_JPRB, 0.39381167E-03_JPRB, 0.39381069E-03_JPRB, 0.39376980E-03_JPRB  /)

RGHG1(:,88, 1) = (/ &
  & 0.38229492E-03_JPRB, 0.38240650E-03_JPRB, 0.38250745E-03_JPRB, 0.38257984E-03_JPRB, 0.38262754E-03_JPRB, 0.38270935E-03_JPRB, &
  & 0.38277033E-03_JPRB, 0.38279507E-03_JPRB, 0.38271831E-03_JPRB, 0.38264575E-03_JPRB, 0.38259082E-03_JPRB, 0.38250989E-03_JPRB, &
  & 0.38244975E-03_JPRB, 0.38236060E-03_JPRB, 0.38226547E-03_JPRB, 0.38217132E-03_JPRB, 0.38206609E-03_JPRB, 0.38209748E-03_JPRB, &
  & 0.38224302E-03_JPRB, 0.38224162E-03_JPRB, 0.38235199E-03_JPRB, 0.38230661E-03_JPRB, 0.38230986E-03_JPRB, 0.38241208E-03_JPRB, &
  & 0.38244786E-03_JPRB, 0.38256345E-03_JPRB, 0.38287961E-03_JPRB, 0.38323694E-03_JPRB, 0.38385299E-03_JPRB, 0.38483492E-03_JPRB, &
  & 0.38570260E-03_JPRB, 0.38623374E-03_JPRB, 0.38668269E-03_JPRB, 0.38677971E-03_JPRB, 0.38701830E-03_JPRB, 0.38697862E-03_JPRB, &
  & 0.38669695E-03_JPRB, 0.38679485E-03_JPRB, 0.38714558E-03_JPRB, 0.38746016E-03_JPRB, 0.38791731E-03_JPRB, 0.38855730E-03_JPRB, &
  & 0.38911280E-03_JPRB, 0.38961843E-03_JPRB, 0.39022918E-03_JPRB, 0.39081958E-03_JPRB, 0.39192836E-03_JPRB, 0.39271958E-03_JPRB, &
  & 0.39346351E-03_JPRB, 0.39412551E-03_JPRB, 0.39479012E-03_JPRB, 0.39486186E-03_JPRB, 0.39497450E-03_JPRB, 0.39550247E-03_JPRB, &
  & 0.39519991E-03_JPRB, 0.39471314E-03_JPRB, 0.39434001E-03_JPRB, 0.39414644E-03_JPRB, 0.39392637E-03_JPRB, 0.39381960E-03_JPRB, &
  & 0.39379489E-03_JPRB, 0.39380957E-03_JPRB, 0.39381475E-03_JPRB, 0.39377970E-03_JPRB  /)

RGHG1(:,89, 1) = (/ &
  & 0.38228970E-03_JPRB, 0.38240355E-03_JPRB, 0.38250497E-03_JPRB, 0.38257759E-03_JPRB, 0.38262706E-03_JPRB, 0.38270890E-03_JPRB, &
  & 0.38276981E-03_JPRB, 0.38279429E-03_JPRB, 0.38271144E-03_JPRB, 0.38264022E-03_JPRB, 0.38258599E-03_JPRB, 0.38250175E-03_JPRB, &
  & 0.38244238E-03_JPRB, 0.38235212E-03_JPRB, 0.38225642E-03_JPRB, 0.38216994E-03_JPRB, 0.38207617E-03_JPRB, 0.38213370E-03_JPRB, &
  & 0.38231468E-03_JPRB, 0.38229597E-03_JPRB, 0.38243437E-03_JPRB, 0.38242185E-03_JPRB, 0.38242454E-03_JPRB, 0.38256416E-03_JPRB, &
  & 0.38265866E-03_JPRB, 0.38285377E-03_JPRB, 0.38329254E-03_JPRB, 0.38366114E-03_JPRB, 0.38433444E-03_JPRB, 0.38538681E-03_JPRB, &
  & 0.38625508E-03_JPRB, 0.38681277E-03_JPRB, 0.38733899E-03_JPRB, 0.38721077E-03_JPRB, 0.38731101E-03_JPRB, 0.38719611E-03_JPRB, &
  & 0.38688140E-03_JPRB, 0.38701715E-03_JPRB, 0.38749446E-03_JPRB, 0.38779140E-03_JPRB, 0.38830674E-03_JPRB, 0.38885494E-03_JPRB, &
  & 0.38931673E-03_JPRB, 0.38981749E-03_JPRB, 0.39050196E-03_JPRB, 0.39106687E-03_JPRB, 0.39219332E-03_JPRB, 0.39295516E-03_JPRB, &
  & 0.39370988E-03_JPRB, 0.39439564E-03_JPRB, 0.39509002E-03_JPRB, 0.39508699E-03_JPRB, 0.39517326E-03_JPRB, 0.39578982E-03_JPRB, &
  & 0.39555264E-03_JPRB, 0.39505633E-03_JPRB, 0.39462439E-03_JPRB, 0.39425602E-03_JPRB, 0.39393955E-03_JPRB, 0.39382490E-03_JPRB, &
  & 0.39379774E-03_JPRB, 0.39380829E-03_JPRB, 0.39381650E-03_JPRB, 0.39378504E-03_JPRB  /)

RGHG1(:,90, 1) = (/ &
  & 0.38228709E-03_JPRB, 0.38240232E-03_JPRB, 0.38250375E-03_JPRB, 0.38257636E-03_JPRB, 0.38262691E-03_JPRB, 0.38270904E-03_JPRB, &
  & 0.38276939E-03_JPRB, 0.38279359E-03_JPRB, 0.38270483E-03_JPRB, 0.38263502E-03_JPRB, 0.38258078E-03_JPRB, 0.38249427E-03_JPRB, &
  & 0.38243548E-03_JPRB, 0.38234378E-03_JPRB, 0.38224721E-03_JPRB, 0.38217019E-03_JPRB, 0.38208626E-03_JPRB, 0.38215503E-03_JPRB, &
  & 0.38238847E-03_JPRB, 0.38236009E-03_JPRB, 0.38252829E-03_JPRB, 0.38257132E-03_JPRB, 0.38258896E-03_JPRB, 0.38276788E-03_JPRB, &
  & 0.38296695E-03_JPRB, 0.38328013E-03_JPRB, 0.38387525E-03_JPRB, 0.38438269E-03_JPRB, 0.38516496E-03_JPRB, 0.38638775E-03_JPRB, &
  & 0.38707042E-03_JPRB, 0.38768380E-03_JPRB, 0.38815841E-03_JPRB, 0.38775065E-03_JPRB, 0.38772058E-03_JPRB, 0.38756463E-03_JPRB, &
  & 0.38717060E-03_JPRB, 0.38732738E-03_JPRB, 0.38811100E-03_JPRB, 0.38854895E-03_JPRB, 0.38910063E-03_JPRB, 0.38940654E-03_JPRB, &
  & 0.38967889E-03_JPRB, 0.39017223E-03_JPRB, 0.39093352E-03_JPRB, 0.39145613E-03_JPRB, 0.39256975E-03_JPRB, 0.39329031E-03_JPRB, &
  & 0.39402021E-03_JPRB, 0.39471065E-03_JPRB, 0.39541843E-03_JPRB, 0.39530880E-03_JPRB, 0.39539832E-03_JPRB, 0.39603787E-03_JPRB, &
  & 0.39590844E-03_JPRB, 0.39545220E-03_JPRB, 0.39496800E-03_JPRB, 0.39437310E-03_JPRB, 0.39394435E-03_JPRB, 0.39382443E-03_JPRB, &
  & 0.39379814E-03_JPRB, 0.39380731E-03_JPRB, 0.39381746E-03_JPRB, 0.39378683E-03_JPRB  /)

RGHG1(:,91, 1) = (/ &
  & 0.38228620E-03_JPRB, 0.38240202E-03_JPRB, 0.38250375E-03_JPRB, 0.38257606E-03_JPRB, 0.38262662E-03_JPRB, 0.38270904E-03_JPRB, &
  & 0.38276909E-03_JPRB, 0.38279299E-03_JPRB, 0.38269770E-03_JPRB, 0.38262968E-03_JPRB, 0.38257514E-03_JPRB, 0.38248536E-03_JPRB, &
  & 0.38242776E-03_JPRB, 0.38233339E-03_JPRB, 0.38223503E-03_JPRB, 0.38217405E-03_JPRB, 0.38210052E-03_JPRB, 0.38216394E-03_JPRB, &
  & 0.38249241E-03_JPRB, 0.38246759E-03_JPRB, 0.38269311E-03_JPRB, 0.38281751E-03_JPRB, 0.38286959E-03_JPRB, 0.38310583E-03_JPRB, &
  & 0.38355257E-03_JPRB, 0.38405967E-03_JPRB, 0.38490811E-03_JPRB, 0.38586991E-03_JPRB, 0.38711576E-03_JPRB, 0.38846149E-03_JPRB, &
  & 0.38859447E-03_JPRB, 0.38907154E-03_JPRB, 0.38924680E-03_JPRB, 0.38835884E-03_JPRB, 0.38835639E-03_JPRB, 0.38811402E-03_JPRB, &
  & 0.38756587E-03_JPRB, 0.38777729E-03_JPRB, 0.38918277E-03_JPRB, 0.39021198E-03_JPRB, 0.39071050E-03_JPRB, 0.39038357E-03_JPRB, &
  & 0.39055822E-03_JPRB, 0.39086922E-03_JPRB, 0.39172286E-03_JPRB, 0.39214540E-03_JPRB, 0.39320556E-03_JPRB, 0.39395196E-03_JPRB, &
  & 0.39456753E-03_JPRB, 0.39517452E-03_JPRB, 0.39591081E-03_JPRB, 0.39560042E-03_JPRB, 0.39574933E-03_JPRB, 0.39634345E-03_JPRB, &
  & 0.39629688E-03_JPRB, 0.39595616E-03_JPRB, 0.39545978E-03_JPRB, 0.39453168E-03_JPRB, 0.39394583E-03_JPRB, 0.39382235E-03_JPRB, &
  & 0.39379784E-03_JPRB, 0.39380642E-03_JPRB, 0.39381776E-03_JPRB, 0.39378742E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ---GEMS----

RGHG1(:, 1, 2) = (/ &
  & 0.37189857E-03_JPRB, 0.37190029E-03_JPRB, 0.37189531E-03_JPRB, 0.37188093E-03_JPRB, 0.37185529E-03_JPRB, 0.37180837E-03_JPRB, &
  & 0.37174391E-03_JPRB, 0.37167072E-03_JPRB, 0.37158236E-03_JPRB, 0.37147693E-03_JPRB, 0.37136345E-03_JPRB, 0.37124885E-03_JPRB, &
  & 0.37114219E-03_JPRB, 0.37104877E-03_JPRB, 0.37096905E-03_JPRB, 0.37091110E-03_JPRB, 0.37087810E-03_JPRB, 0.37086602E-03_JPRB, &
  & 0.37086742E-03_JPRB, 0.37087699E-03_JPRB, 0.37088894E-03_JPRB, 0.37090357E-03_JPRB, 0.37092248E-03_JPRB, 0.37094726E-03_JPRB, &
  & 0.37097493E-03_JPRB, 0.37100134E-03_JPRB, 0.37102614E-03_JPRB, 0.37104921E-03_JPRB, 0.37106922E-03_JPRB, 0.37108303E-03_JPRB, &
  & 0.37108935E-03_JPRB, 0.37108874E-03_JPRB, 0.37108225E-03_JPRB, 0.37107374E-03_JPRB, 0.37106804E-03_JPRB, 0.37106857E-03_JPRB, &
  & 0.37107951E-03_JPRB, 0.37109964E-03_JPRB, 0.37112417E-03_JPRB, 0.37115002E-03_JPRB, 0.37117177E-03_JPRB, 0.37119451E-03_JPRB, &
  & 0.37121582E-03_JPRB, 0.37123227E-03_JPRB, 0.37124997E-03_JPRB, 0.37126519E-03_JPRB, 0.37127436E-03_JPRB, 0.37128112E-03_JPRB, &
  & 0.37128294E-03_JPRB, 0.37128108E-03_JPRB, 0.37127432E-03_JPRB, 0.37126375E-03_JPRB, 0.37125148E-03_JPRB, 0.37123878E-03_JPRB, &
  & 0.37122741E-03_JPRB, 0.37121888E-03_JPRB, 0.37121161E-03_JPRB, 0.37120569E-03_JPRB, 0.37120213E-03_JPRB, 0.37119958E-03_JPRB, &
  & 0.37119891E-03_JPRB, 0.37119872E-03_JPRB, 0.37119809E-03_JPRB, 0.37119751E-03_JPRB  /)

RGHG1(:, 2, 2) = (/ &
  & 0.37189857E-03_JPRB, 0.37190029E-03_JPRB, 0.37189531E-03_JPRB, 0.37188093E-03_JPRB, 0.37185529E-03_JPRB, 0.37180837E-03_JPRB, &
  & 0.37174391E-03_JPRB, 0.37167072E-03_JPRB, 0.37158236E-03_JPRB, 0.37147693E-03_JPRB, 0.37136345E-03_JPRB, 0.37124885E-03_JPRB, &
  & 0.37114219E-03_JPRB, 0.37104877E-03_JPRB, 0.37096905E-03_JPRB, 0.37091110E-03_JPRB, 0.37087810E-03_JPRB, 0.37086602E-03_JPRB, &
  & 0.37086742E-03_JPRB, 0.37087699E-03_JPRB, 0.37088894E-03_JPRB, 0.37090357E-03_JPRB, 0.37092248E-03_JPRB, 0.37094726E-03_JPRB, &
  & 0.37097493E-03_JPRB, 0.37100134E-03_JPRB, 0.37102614E-03_JPRB, 0.37104921E-03_JPRB, 0.37106922E-03_JPRB, 0.37108303E-03_JPRB, &
  & 0.37108935E-03_JPRB, 0.37108874E-03_JPRB, 0.37108225E-03_JPRB, 0.37107374E-03_JPRB, 0.37106804E-03_JPRB, 0.37106857E-03_JPRB, &
  & 0.37107951E-03_JPRB, 0.37109964E-03_JPRB, 0.37112417E-03_JPRB, 0.37115002E-03_JPRB, 0.37117177E-03_JPRB, 0.37119451E-03_JPRB, &
  & 0.37121582E-03_JPRB, 0.37123227E-03_JPRB, 0.37124997E-03_JPRB, 0.37126519E-03_JPRB, 0.37127436E-03_JPRB, 0.37128112E-03_JPRB, &
  & 0.37128294E-03_JPRB, 0.37128108E-03_JPRB, 0.37127432E-03_JPRB, 0.37126375E-03_JPRB, 0.37125148E-03_JPRB, 0.37123878E-03_JPRB, &
  & 0.37122741E-03_JPRB, 0.37121888E-03_JPRB, 0.37121161E-03_JPRB, 0.37120569E-03_JPRB, 0.37120213E-03_JPRB, 0.37119958E-03_JPRB, &
  & 0.37119891E-03_JPRB, 0.37119872E-03_JPRB, 0.37119809E-03_JPRB, 0.37119751E-03_JPRB  /)

RGHG1(:, 3, 2) = (/ &
  & 0.37189857E-03_JPRB, 0.37190029E-03_JPRB, 0.37189531E-03_JPRB, 0.37188093E-03_JPRB, 0.37185529E-03_JPRB, 0.37180837E-03_JPRB, &
  & 0.37174391E-03_JPRB, 0.37167072E-03_JPRB, 0.37158236E-03_JPRB, 0.37147693E-03_JPRB, 0.37136345E-03_JPRB, 0.37124885E-03_JPRB, &
  & 0.37114219E-03_JPRB, 0.37104877E-03_JPRB, 0.37096905E-03_JPRB, 0.37091110E-03_JPRB, 0.37087810E-03_JPRB, 0.37086602E-03_JPRB, &
  & 0.37086742E-03_JPRB, 0.37087699E-03_JPRB, 0.37088894E-03_JPRB, 0.37090357E-03_JPRB, 0.37092248E-03_JPRB, 0.37094726E-03_JPRB, &
  & 0.37097493E-03_JPRB, 0.37100134E-03_JPRB, 0.37102614E-03_JPRB, 0.37104921E-03_JPRB, 0.37106922E-03_JPRB, 0.37108303E-03_JPRB, &
  & 0.37108935E-03_JPRB, 0.37108874E-03_JPRB, 0.37108225E-03_JPRB, 0.37107374E-03_JPRB, 0.37106804E-03_JPRB, 0.37106857E-03_JPRB, &
  & 0.37107951E-03_JPRB, 0.37109964E-03_JPRB, 0.37112417E-03_JPRB, 0.37115002E-03_JPRB, 0.37117177E-03_JPRB, 0.37119451E-03_JPRB, &
  & 0.37121582E-03_JPRB, 0.37123227E-03_JPRB, 0.37124997E-03_JPRB, 0.37126519E-03_JPRB, 0.37127436E-03_JPRB, 0.37128112E-03_JPRB, &
  & 0.37128294E-03_JPRB, 0.37128108E-03_JPRB, 0.37127432E-03_JPRB, 0.37126375E-03_JPRB, 0.37125148E-03_JPRB, 0.37123878E-03_JPRB, &
  & 0.37122741E-03_JPRB, 0.37121888E-03_JPRB, 0.37121161E-03_JPRB, 0.37120569E-03_JPRB, 0.37120213E-03_JPRB, 0.37119958E-03_JPRB, &
  & 0.37119891E-03_JPRB, 0.37119872E-03_JPRB, 0.37119809E-03_JPRB, 0.37119751E-03_JPRB  /)

RGHG1(:, 4, 2) = (/ &
  & 0.37190006E-03_JPRB, 0.37190165E-03_JPRB, 0.37189649E-03_JPRB, 0.37188190E-03_JPRB, 0.37185606E-03_JPRB, 0.37180891E-03_JPRB, &
  & 0.37174412E-03_JPRB, 0.37167054E-03_JPRB, 0.37158174E-03_JPRB, 0.37147589E-03_JPRB, 0.37136208E-03_JPRB, 0.37124724E-03_JPRB, &
  & 0.37114043E-03_JPRB, 0.37104706E-03_JPRB, 0.37096759E-03_JPRB, 0.37091009E-03_JPRB, 0.37087758E-03_JPRB, 0.37086590E-03_JPRB, &
  & 0.37086759E-03_JPRB, 0.37087736E-03_JPRB, 0.37088947E-03_JPRB, 0.37090421E-03_JPRB, 0.37092321E-03_JPRB, 0.37094808E-03_JPRB, &
  & 0.37097584E-03_JPRB, 0.37100232E-03_JPRB, 0.37102713E-03_JPRB, 0.37105016E-03_JPRB, 0.37107006E-03_JPRB, 0.37108373E-03_JPRB, &
  & 0.37108989E-03_JPRB, 0.37108912E-03_JPRB, 0.37108251E-03_JPRB, 0.37107398E-03_JPRB, 0.37106835E-03_JPRB, 0.37106908E-03_JPRB, &
  & 0.37108026E-03_JPRB, 0.37110062E-03_JPRB, 0.37112529E-03_JPRB, 0.37115117E-03_JPRB, 0.37117292E-03_JPRB, 0.37119562E-03_JPRB, &
  & 0.37121689E-03_JPRB, 0.37123329E-03_JPRB, 0.37125090E-03_JPRB, 0.37126600E-03_JPRB, 0.37127504E-03_JPRB, 0.37128166E-03_JPRB, &
  & 0.37128332E-03_JPRB, 0.37128131E-03_JPRB, 0.37127440E-03_JPRB, 0.37126372E-03_JPRB, 0.37125139E-03_JPRB, 0.37123868E-03_JPRB, &
  & 0.37122730E-03_JPRB, 0.37121878E-03_JPRB, 0.37121151E-03_JPRB, 0.37120561E-03_JPRB, 0.37120206E-03_JPRB, 0.37119952E-03_JPRB, &
  & 0.37119885E-03_JPRB, 0.37119865E-03_JPRB, 0.37119803E-03_JPRB, 0.37119746E-03_JPRB  /)

RGHG1(:, 5, 2) = (/ &
  & 0.37197113E-03_JPRB, 0.37196614E-03_JPRB, 0.37195240E-03_JPRB, 0.37192816E-03_JPRB, 0.37189288E-03_JPRB, 0.37183478E-03_JPRB, &
  & 0.37175399E-03_JPRB, 0.37166225E-03_JPRB, 0.37155241E-03_JPRB, 0.37142635E-03_JPRB, 0.37129683E-03_JPRB, 0.37117050E-03_JPRB, &
  & 0.37105724E-03_JPRB, 0.37096564E-03_JPRB, 0.37089813E-03_JPRB, 0.37086195E-03_JPRB, 0.37085256E-03_JPRB, 0.37086022E-03_JPRB, &
  & 0.37087583E-03_JPRB, 0.37089490E-03_JPRB, 0.37091423E-03_JPRB, 0.37093454E-03_JPRB, 0.37095794E-03_JPRB, 0.37098713E-03_JPRB, &
  & 0.37101933E-03_JPRB, 0.37104907E-03_JPRB, 0.37107445E-03_JPRB, 0.37109511E-03_JPRB, 0.37110970E-03_JPRB, 0.37111679E-03_JPRB, &
  & 0.37111565E-03_JPRB, 0.37110721E-03_JPRB, 0.37109512E-03_JPRB, 0.37108503E-03_JPRB, 0.37108299E-03_JPRB, 0.37109323E-03_JPRB, &
  & 0.37111608E-03_JPRB, 0.37114715E-03_JPRB, 0.37117844E-03_JPRB, 0.37120587E-03_JPRB, 0.37122751E-03_JPRB, 0.37124863E-03_JPRB, &
  & 0.37126754E-03_JPRB, 0.37128170E-03_JPRB, 0.37129513E-03_JPRB, 0.37130430E-03_JPRB, 0.37130735E-03_JPRB, 0.37130718E-03_JPRB, &
  & 0.37130139E-03_JPRB, 0.37129178E-03_JPRB, 0.37127791E-03_JPRB, 0.37126205E-03_JPRB, 0.37124707E-03_JPRB, 0.37123369E-03_JPRB, &
  & 0.37122237E-03_JPRB, 0.37121372E-03_JPRB, 0.37120688E-03_JPRB, 0.37120177E-03_JPRB, 0.37119865E-03_JPRB, 0.37119645E-03_JPRB, &
  & 0.37119575E-03_JPRB, 0.37119556E-03_JPRB, 0.37119519E-03_JPRB, 0.37119491E-03_JPRB  /)

RGHG1(:, 6, 2) = (/ &
  & 0.37207775E-03_JPRB, 0.37206291E-03_JPRB, 0.37203628E-03_JPRB, 0.37199756E-03_JPRB, 0.37194811E-03_JPRB, 0.37187359E-03_JPRB, &
  & 0.37176880E-03_JPRB, 0.37164981E-03_JPRB, 0.37150840E-03_JPRB, 0.37135202E-03_JPRB, 0.37119895E-03_JPRB, 0.37105538E-03_JPRB, &
  & 0.37093242E-03_JPRB, 0.37084348E-03_JPRB, 0.37079392E-03_JPRB, 0.37078973E-03_JPRB, 0.37081502E-03_JPRB, 0.37085171E-03_JPRB, &
  & 0.37088820E-03_JPRB, 0.37092122E-03_JPRB, 0.37095139E-03_JPRB, 0.37098005E-03_JPRB, 0.37101004E-03_JPRB, 0.37104571E-03_JPRB, &
  & 0.37108458E-03_JPRB, 0.37111922E-03_JPRB, 0.37114545E-03_JPRB, 0.37116255E-03_JPRB, 0.37116918E-03_JPRB, 0.37116640E-03_JPRB, &
  & 0.37115429E-03_JPRB, 0.37113435E-03_JPRB, 0.37111403E-03_JPRB, 0.37110161E-03_JPRB, 0.37110496E-03_JPRB, 0.37112947E-03_JPRB, &
  & 0.37116982E-03_JPRB, 0.37121697E-03_JPRB, 0.37125819E-03_JPRB, 0.37128792E-03_JPRB, 0.37130940E-03_JPRB, 0.37132816E-03_JPRB, &
  & 0.37134354E-03_JPRB, 0.37135433E-03_JPRB, 0.37136148E-03_JPRB, 0.37136178E-03_JPRB, 0.37135581E-03_JPRB, 0.37134546E-03_JPRB, &
  & 0.37132851E-03_JPRB, 0.37130749E-03_JPRB, 0.37128319E-03_JPRB, 0.37125954E-03_JPRB, 0.37124059E-03_JPRB, 0.37122621E-03_JPRB, &
  & 0.37121498E-03_JPRB, 0.37120612E-03_JPRB, 0.37119994E-03_JPRB, 0.37119601E-03_JPRB, 0.37119354E-03_JPRB, 0.37119186E-03_JPRB, &
  & 0.37119110E-03_JPRB, 0.37119091E-03_JPRB, 0.37119093E-03_JPRB, 0.37119110E-03_JPRB  /)

RGHG1(:, 7, 2) = (/ &
  & 0.37222261E-03_JPRB, 0.37221516E-03_JPRB, 0.37219238E-03_JPRB, 0.37214720E-03_JPRB, 0.37208051E-03_JPRB, 0.37198259E-03_JPRB, &
  & 0.37185136E-03_JPRB, 0.37169139E-03_JPRB, 0.37149667E-03_JPRB, 0.37128940E-03_JPRB, 0.37109117E-03_JPRB, 0.37091534E-03_JPRB, &
  & 0.37078370E-03_JPRB, 0.37070970E-03_JPRB, 0.37069017E-03_JPRB, 0.37072790E-03_JPRB, 0.37079822E-03_JPRB, 0.37087428E-03_JPRB, &
  & 0.37094507E-03_JPRB, 0.37100876E-03_JPRB, 0.37106375E-03_JPRB, 0.37111186E-03_JPRB, 0.37115729E-03_JPRB, 0.37120529E-03_JPRB, &
  & 0.37125415E-03_JPRB, 0.37129503E-03_JPRB, 0.37132155E-03_JPRB, 0.37133215E-03_JPRB, 0.37132626E-03_JPRB, 0.37130730E-03_JPRB, &
  & 0.37127607E-03_JPRB, 0.37123635E-03_JPRB, 0.37120150E-03_JPRB, 0.37118427E-03_JPRB, 0.37119750E-03_JPRB, 0.37124617E-03_JPRB, &
  & 0.37131762E-03_JPRB, 0.37139257E-03_JPRB, 0.37144938E-03_JPRB, 0.37148291E-03_JPRB, 0.37150120E-03_JPRB, 0.37151297E-03_JPRB, &
  & 0.37151740E-03_JPRB, 0.37151490E-03_JPRB, 0.37150671E-03_JPRB, 0.37148697E-03_JPRB, 0.37145744E-03_JPRB, 0.37141961E-03_JPRB, &
  & 0.37137552E-03_JPRB, 0.37133134E-03_JPRB, 0.37128886E-03_JPRB, 0.37125417E-03_JPRB, 0.37123179E-03_JPRB, 0.37121709E-03_JPRB, &
  & 0.37120649E-03_JPRB, 0.37119892E-03_JPRB, 0.37119443E-03_JPRB, 0.37119216E-03_JPRB, 0.37119077E-03_JPRB, 0.37118985E-03_JPRB, &
  & 0.37118961E-03_JPRB, 0.37119000E-03_JPRB, 0.37119067E-03_JPRB, 0.37119143E-03_JPRB  /)

RGHG1(:, 8, 2) = (/ &
  & 0.37243944E-03_JPRB, 0.37243837E-03_JPRB, 0.37241845E-03_JPRB, 0.37237062E-03_JPRB, 0.37229446E-03_JPRB, 0.37218019E-03_JPRB, &
  & 0.37202243E-03_JPRB, 0.37181176E-03_JPRB, 0.37154387E-03_JPRB, 0.37126020E-03_JPRB, 0.37099961E-03_JPRB, 0.37079091E-03_JPRB, &
  & 0.37065807E-03_JPRB, 0.37060566E-03_JPRB, 0.37061534E-03_JPRB, 0.37068540E-03_JPRB, 0.37079492E-03_JPRB, 0.37091468E-03_JPRB, &
  & 0.37103092E-03_JPRB, 0.37114079E-03_JPRB, 0.37123897E-03_JPRB, 0.37132583E-03_JPRB, 0.37140624E-03_JPRB, 0.37148476E-03_JPRB, &
  & 0.37156107E-03_JPRB, 0.37162679E-03_JPRB, 0.37167115E-03_JPRB, 0.37168792E-03_JPRB, 0.37167562E-03_JPRB, 0.37164088E-03_JPRB, &
  & 0.37158911E-03_JPRB, 0.37153011E-03_JPRB, 0.37148189E-03_JPRB, 0.37146029E-03_JPRB, 0.37148262E-03_JPRB, 0.37155102E-03_JPRB, &
  & 0.37164765E-03_JPRB, 0.37173576E-03_JPRB, 0.37179423E-03_JPRB, 0.37182342E-03_JPRB, 0.37183424E-03_JPRB, 0.37183603E-03_JPRB, &
  & 0.37182504E-03_JPRB, 0.37180023E-03_JPRB, 0.37176387E-03_JPRB, 0.37170619E-03_JPRB, 0.37162928E-03_JPRB, 0.37153999E-03_JPRB, &
  & 0.37144936E-03_JPRB, 0.37136670E-03_JPRB, 0.37130103E-03_JPRB, 0.37125529E-03_JPRB, 0.37123106E-03_JPRB, 0.37121715E-03_JPRB, &
  & 0.37120907E-03_JPRB, 0.37120458E-03_JPRB, 0.37120308E-03_JPRB, 0.37120329E-03_JPRB, 0.37120387E-03_JPRB, 0.37120460E-03_JPRB, &
  & 0.37120558E-03_JPRB, 0.37120684E-03_JPRB, 0.37120876E-03_JPRB, 0.37121030E-03_JPRB  /)

RGHG1(:, 9, 2) = (/ &
  & 0.37271424E-03_JPRB, 0.37271229E-03_JPRB, 0.37269562E-03_JPRB, 0.37265642E-03_JPRB, 0.37258488E-03_JPRB, 0.37246253E-03_JPRB, &
  & 0.37227890E-03_JPRB, 0.37201522E-03_JPRB, 0.37166654E-03_JPRB, 0.37128885E-03_JPRB, 0.37095653E-03_JPRB, 0.37072338E-03_JPRB, &
  & 0.37059584E-03_JPRB, 0.37056175E-03_JPRB, 0.37059048E-03_JPRB, 0.37067522E-03_JPRB, 0.37080785E-03_JPRB, 0.37096736E-03_JPRB, &
  & 0.37113506E-03_JPRB, 0.37130343E-03_JPRB, 0.37146128E-03_JPRB, 0.37160759E-03_JPRB, 0.37174754E-03_JPRB, 0.37188477E-03_JPRB, &
  & 0.37202172E-03_JPRB, 0.37215177E-03_JPRB, 0.37225740E-03_JPRB, 0.37232345E-03_JPRB, 0.37234286E-03_JPRB, 0.37232168E-03_JPRB, &
  & 0.37227281E-03_JPRB, 0.37221445E-03_JPRB, 0.37216527E-03_JPRB, 0.37213810E-03_JPRB, 0.37214943E-03_JPRB, 0.37219808E-03_JPRB, &
  & 0.37226938E-03_JPRB, 0.37232197E-03_JPRB, 0.37234684E-03_JPRB, 0.37235114E-03_JPRB, 0.37234215E-03_JPRB, 0.37232535E-03_JPRB, &
  & 0.37229341E-03_JPRB, 0.37223814E-03_JPRB, 0.37215918E-03_JPRB, 0.37203982E-03_JPRB, 0.37188243E-03_JPRB, 0.37170934E-03_JPRB, &
  & 0.37154743E-03_JPRB, 0.37141501E-03_JPRB, 0.37132850E-03_JPRB, 0.37127792E-03_JPRB, 0.37125553E-03_JPRB, 0.37124515E-03_JPRB, &
  & 0.37124184E-03_JPRB, 0.37124206E-03_JPRB, 0.37124448E-03_JPRB, 0.37124776E-03_JPRB, 0.37125128E-03_JPRB, 0.37125465E-03_JPRB, &
  & 0.37125734E-03_JPRB, 0.37125963E-03_JPRB, 0.37126262E-03_JPRB, 0.37126503E-03_JPRB  /)

RGHG1(:,10, 2) = (/ &
  & 0.37296814E-03_JPRB, 0.37297232E-03_JPRB, 0.37298385E-03_JPRB, 0.37297569E-03_JPRB, 0.37291334E-03_JPRB, 0.37276934E-03_JPRB, &
  & 0.37254317E-03_JPRB, 0.37221559E-03_JPRB, 0.37179569E-03_JPRB, 0.37134490E-03_JPRB, 0.37095948E-03_JPRB, 0.37071695E-03_JPRB, &
  & 0.37059346E-03_JPRB, 0.37056393E-03_JPRB, 0.37060216E-03_JPRB, 0.37069775E-03_JPRB, 0.37084139E-03_JPRB, 0.37102466E-03_JPRB, &
  & 0.37123413E-03_JPRB, 0.37145838E-03_JPRB, 0.37167583E-03_JPRB, 0.37188789E-03_JPRB, 0.37209872E-03_JPRB, 0.37231802E-03_JPRB, &
  & 0.37255346E-03_JPRB, 0.37279863E-03_JPRB, 0.37303061E-03_JPRB, 0.37322367E-03_JPRB, 0.37335649E-03_JPRB, 0.37342222E-03_JPRB, &
  & 0.37343533E-03_JPRB, 0.37341670E-03_JPRB, 0.37337941E-03_JPRB, 0.37332910E-03_JPRB, 0.37327745E-03_JPRB, 0.37322448E-03_JPRB, &
  & 0.37317170E-03_JPRB, 0.37311249E-03_JPRB, 0.37305189E-03_JPRB, 0.37299575E-03_JPRB, 0.37294743E-03_JPRB, 0.37290210E-03_JPRB, &
  & 0.37284498E-03_JPRB, 0.37275488E-03_JPRB, 0.37262232E-03_JPRB, 0.37242654E-03_JPRB, 0.37216824E-03_JPRB, 0.37189349E-03_JPRB, &
  & 0.37165134E-03_JPRB, 0.37147996E-03_JPRB, 0.37138687E-03_JPRB, 0.37134205E-03_JPRB, 0.37132492E-03_JPRB, 0.37131961E-03_JPRB, &
  & 0.37132098E-03_JPRB, 0.37132511E-03_JPRB, 0.37133006E-03_JPRB, 0.37133548E-03_JPRB, 0.37134165E-03_JPRB, 0.37134704E-03_JPRB, &
  & 0.37135050E-03_JPRB, 0.37135365E-03_JPRB, 0.37135714E-03_JPRB, 0.37136093E-03_JPRB  /)

RGHG1(:,11, 2) = (/ &
  & 0.37318338E-03_JPRB, 0.37320788E-03_JPRB, 0.37326912E-03_JPRB, 0.37330167E-03_JPRB, 0.37324275E-03_JPRB, 0.37305157E-03_JPRB, &
  & 0.37274623E-03_JPRB, 0.37231672E-03_JPRB, 0.37182472E-03_JPRB, 0.37135552E-03_JPRB, 0.37096701E-03_JPRB, 0.37073662E-03_JPRB, &
  & 0.37062296E-03_JPRB, 0.37059744E-03_JPRB, 0.37064501E-03_JPRB, 0.37075973E-03_JPRB, 0.37091241E-03_JPRB, 0.37109388E-03_JPRB, &
  & 0.37131683E-03_JPRB, 0.37157397E-03_JPRB, 0.37183511E-03_JPRB, 0.37209986E-03_JPRB, 0.37236820E-03_JPRB, 0.37266786E-03_JPRB, &
  & 0.37301490E-03_JPRB, 0.37340082E-03_JPRB, 0.37379705E-03_JPRB, 0.37416429E-03_JPRB, 0.37445519E-03_JPRB, 0.37463942E-03_JPRB, &
  & 0.37472554E-03_JPRB, 0.37472760E-03_JPRB, 0.37465580E-03_JPRB, 0.37453281E-03_JPRB, 0.37437322E-03_JPRB, 0.37418145E-03_JPRB, &
  & 0.37398132E-03_JPRB, 0.37379910E-03_JPRB, 0.37364342E-03_JPRB, 0.37351606E-03_JPRB, 0.37342622E-03_JPRB, 0.37335586E-03_JPRB, &
  & 0.37327456E-03_JPRB, 0.37314815E-03_JPRB, 0.37295806E-03_JPRB, 0.37269065E-03_JPRB, 0.37235827E-03_JPRB, 0.37201729E-03_JPRB, &
  & 0.37173758E-03_JPRB, 0.37156531E-03_JPRB, 0.37148367E-03_JPRB, 0.37144815E-03_JPRB, 0.37143458E-03_JPRB, 0.37143070E-03_JPRB, &
  & 0.37143278E-03_JPRB, 0.37143613E-03_JPRB, 0.37143931E-03_JPRB, 0.37144483E-03_JPRB, 0.37145245E-03_JPRB, 0.37145691E-03_JPRB, &
  & 0.37145919E-03_JPRB, 0.37146333E-03_JPRB, 0.37146880E-03_JPRB, 0.37147422E-03_JPRB  /)

RGHG1(:,12, 2) = (/ &
  & 0.37351896E-03_JPRB, 0.37355121E-03_JPRB, 0.37360097E-03_JPRB, 0.37360532E-03_JPRB, 0.37354026E-03_JPRB, 0.37331757E-03_JPRB, &
  & 0.37293760E-03_JPRB, 0.37241920E-03_JPRB, 0.37184686E-03_JPRB, 0.37137124E-03_JPRB, 0.37100157E-03_JPRB, 0.37079579E-03_JPRB, &
  & 0.37070836E-03_JPRB, 0.37070240E-03_JPRB, 0.37076066E-03_JPRB, 0.37088912E-03_JPRB, 0.37104919E-03_JPRB, 0.37121506E-03_JPRB, &
  & 0.37142827E-03_JPRB, 0.37168866E-03_JPRB, 0.37196941E-03_JPRB, 0.37226433E-03_JPRB, 0.37256921E-03_JPRB, 0.37293416E-03_JPRB, &
  & 0.37338272E-03_JPRB, 0.37389708E-03_JPRB, 0.37442133E-03_JPRB, 0.37489537E-03_JPRB, 0.37525090E-03_JPRB, 0.37544555E-03_JPRB, &
  & 0.37550076E-03_JPRB, 0.37543310E-03_JPRB, 0.37526387E-03_JPRB, 0.37505407E-03_JPRB, 0.37482103E-03_JPRB, 0.37457373E-03_JPRB, &
  & 0.37433982E-03_JPRB, 0.37413215E-03_JPRB, 0.37394455E-03_JPRB, 0.37378579E-03_JPRB, 0.37366268E-03_JPRB, 0.37356001E-03_JPRB, &
  & 0.37344775E-03_JPRB, 0.37328776E-03_JPRB, 0.37305143E-03_JPRB, 0.37273182E-03_JPRB, 0.37237896E-03_JPRB, 0.37204158E-03_JPRB, &
  & 0.37179270E-03_JPRB, 0.37165517E-03_JPRB, 0.37159308E-03_JPRB, 0.37156403E-03_JPRB, 0.37155128E-03_JPRB, 0.37154565E-03_JPRB, &
  & 0.37154361E-03_JPRB, 0.37154126E-03_JPRB, 0.37154093E-03_JPRB, 0.37154743E-03_JPRB, 0.37155684E-03_JPRB, 0.37155955E-03_JPRB, &
  & 0.37156100E-03_JPRB, 0.37156618E-03_JPRB, 0.37157496E-03_JPRB, 0.37158225E-03_JPRB  /)

RGHG1(:,13, 2) = (/ &
  & 0.37413530E-03_JPRB, 0.37415531E-03_JPRB, 0.37413847E-03_JPRB, 0.37400980E-03_JPRB, 0.37385191E-03_JPRB, 0.37361201E-03_JPRB, &
  & 0.37322959E-03_JPRB, 0.37272718E-03_JPRB, 0.37212137E-03_JPRB, 0.37157645E-03_JPRB, 0.37117322E-03_JPRB, 0.37097961E-03_JPRB, &
  & 0.37092796E-03_JPRB, 0.37095313E-03_JPRB, 0.37102404E-03_JPRB, 0.37115063E-03_JPRB, 0.37130373E-03_JPRB, 0.37145016E-03_JPRB, &
  & 0.37164179E-03_JPRB, 0.37188801E-03_JPRB, 0.37215893E-03_JPRB, 0.37245417E-03_JPRB, 0.37277927E-03_JPRB, 0.37319815E-03_JPRB, &
  & 0.37373569E-03_JPRB, 0.37434377E-03_JPRB, 0.37491577E-03_JPRB, 0.37537527E-03_JPRB, 0.37566599E-03_JPRB, 0.37578171E-03_JPRB, &
  & 0.37576456E-03_JPRB, 0.37562877E-03_JPRB, 0.37540419E-03_JPRB, 0.37516591E-03_JPRB, 0.37493947E-03_JPRB, 0.37473286E-03_JPRB, &
  & 0.37453435E-03_JPRB, 0.37431861E-03_JPRB, 0.37409646E-03_JPRB, 0.37388112E-03_JPRB, 0.37369909E-03_JPRB, 0.37354975E-03_JPRB, &
  & 0.37340333E-03_JPRB, 0.37321793E-03_JPRB, 0.37296542E-03_JPRB, 0.37263986E-03_JPRB, 0.37230754E-03_JPRB, 0.37202505E-03_JPRB, &
  & 0.37184356E-03_JPRB, 0.37174542E-03_JPRB, 0.37169778E-03_JPRB, 0.37167187E-03_JPRB, 0.37165698E-03_JPRB, 0.37164715E-03_JPRB, &
  & 0.37163950E-03_JPRB, 0.37163239E-03_JPRB, 0.37163296E-03_JPRB, 0.37164347E-03_JPRB, 0.37165511E-03_JPRB, 0.37165916E-03_JPRB, &
  & 0.37166282E-03_JPRB, 0.37166720E-03_JPRB, 0.37167955E-03_JPRB, 0.37168711E-03_JPRB  /)

RGHG1(:,14, 2) = (/ &
  & 0.37486380E-03_JPRB, 0.37486610E-03_JPRB, 0.37477789E-03_JPRB, 0.37453589E-03_JPRB, 0.37424635E-03_JPRB, 0.37393990E-03_JPRB, &
  & 0.37362558E-03_JPRB, 0.37324622E-03_JPRB, 0.37270462E-03_JPRB, 0.37211215E-03_JPRB, 0.37159680E-03_JPRB, 0.37134890E-03_JPRB, &
  & 0.37130479E-03_JPRB, 0.37135210E-03_JPRB, 0.37143055E-03_JPRB, 0.37154185E-03_JPRB, 0.37167008E-03_JPRB, 0.37178910E-03_JPRB, &
  & 0.37194624E-03_JPRB, 0.37216452E-03_JPRB, 0.37240794E-03_JPRB, 0.37267486E-03_JPRB, 0.37300172E-03_JPRB, 0.37345808E-03_JPRB, &
  & 0.37406780E-03_JPRB, 0.37472481E-03_JPRB, 0.37529226E-03_JPRB, 0.37569942E-03_JPRB, 0.37592016E-03_JPRB, 0.37598912E-03_JPRB, &
  & 0.37593568E-03_JPRB, 0.37575485E-03_JPRB, 0.37550523E-03_JPRB, 0.37526809E-03_JPRB, 0.37506716E-03_JPRB, 0.37489857E-03_JPRB, &
  & 0.37471636E-03_JPRB, 0.37448076E-03_JPRB, 0.37419422E-03_JPRB, 0.37387867E-03_JPRB, 0.37360073E-03_JPRB, 0.37339158E-03_JPRB, &
  & 0.37321027E-03_JPRB, 0.37301308E-03_JPRB, 0.37277492E-03_JPRB, 0.37249189E-03_JPRB, 0.37222114E-03_JPRB, 0.37201659E-03_JPRB, &
  & 0.37189904E-03_JPRB, 0.37183040E-03_JPRB, 0.37179217E-03_JPRB, 0.37176683E-03_JPRB, 0.37174855E-03_JPRB, 0.37173476E-03_JPRB, &
  & 0.37172345E-03_JPRB, 0.37171661E-03_JPRB, 0.37172185E-03_JPRB, 0.37173696E-03_JPRB, 0.37175130E-03_JPRB, 0.37176148E-03_JPRB, &
  & 0.37177180E-03_JPRB, 0.37177788E-03_JPRB, 0.37178753E-03_JPRB, 0.37179561E-03_JPRB  /)

RGHG1(:,15, 2) = (/ &
  & 0.37531728E-03_JPRB, 0.37530690E-03_JPRB, 0.37519084E-03_JPRB, 0.37491857E-03_JPRB, 0.37458665E-03_JPRB, 0.37426260E-03_JPRB, &
  & 0.37400528E-03_JPRB, 0.37373598E-03_JPRB, 0.37330144E-03_JPRB, 0.37279570E-03_JPRB, 0.37223852E-03_JPRB, 0.37185958E-03_JPRB, &
  & 0.37174208E-03_JPRB, 0.37177622E-03_JPRB, 0.37184915E-03_JPRB, 0.37193665E-03_JPRB, 0.37203556E-03_JPRB, 0.37213021E-03_JPRB, &
  & 0.37224451E-03_JPRB, 0.37241790E-03_JPRB, 0.37263558E-03_JPRB, 0.37287730E-03_JPRB, 0.37319546E-03_JPRB, 0.37367499E-03_JPRB, &
  & 0.37432958E-03_JPRB, 0.37500942E-03_JPRB, 0.37556960E-03_JPRB, 0.37597029E-03_JPRB, 0.37619236E-03_JPRB, 0.37625341E-03_JPRB, &
  & 0.37617978E-03_JPRB, 0.37595083E-03_JPRB, 0.37566569E-03_JPRB, 0.37542904E-03_JPRB, 0.37522384E-03_JPRB, 0.37501984E-03_JPRB, &
  & 0.37479185E-03_JPRB, 0.37452996E-03_JPRB, 0.37419125E-03_JPRB, 0.37379860E-03_JPRB, 0.37343039E-03_JPRB, 0.37315124E-03_JPRB, &
  & 0.37293313E-03_JPRB, 0.37273023E-03_JPRB, 0.37251816E-03_JPRB, 0.37231132E-03_JPRB, 0.37213947E-03_JPRB, 0.37201743E-03_JPRB, &
  & 0.37194767E-03_JPRB, 0.37190382E-03_JPRB, 0.37187520E-03_JPRB, 0.37185270E-03_JPRB, 0.37183250E-03_JPRB, 0.37181748E-03_JPRB, &
  & 0.37180920E-03_JPRB, 0.37180812E-03_JPRB, 0.37181839E-03_JPRB, 0.37183595E-03_JPRB, 0.37185414E-03_JPRB, 0.37187262E-03_JPRB, &
  & 0.37189222E-03_JPRB, 0.37189970E-03_JPRB, 0.37189757E-03_JPRB, 0.37190165E-03_JPRB  /)

RGHG1(:,16, 2) = (/ &
  & 0.37537898E-03_JPRB, 0.37530963E-03_JPRB, 0.37518225E-03_JPRB, 0.37495618E-03_JPRB, 0.37468239E-03_JPRB, 0.37444085E-03_JPRB, &
  & 0.37422791E-03_JPRB, 0.37399980E-03_JPRB, 0.37364006E-03_JPRB, 0.37325808E-03_JPRB, 0.37281946E-03_JPRB, 0.37236084E-03_JPRB, &
  & 0.37211811E-03_JPRB, 0.37207684E-03_JPRB, 0.37211863E-03_JPRB, 0.37218052E-03_JPRB, 0.37225780E-03_JPRB, 0.37234103E-03_JPRB, &
  & 0.37243281E-03_JPRB, 0.37257314E-03_JPRB, 0.37278268E-03_JPRB, 0.37303484E-03_JPRB, 0.37336786E-03_JPRB, 0.37386851E-03_JPRB, &
  & 0.37454330E-03_JPRB, 0.37522577E-03_JPRB, 0.37580171E-03_JPRB, 0.37625873E-03_JPRB, 0.37650285E-03_JPRB, 0.37655418E-03_JPRB, &
  & 0.37647450E-03_JPRB, 0.37623253E-03_JPRB, 0.37593451E-03_JPRB, 0.37565825E-03_JPRB, 0.37536651E-03_JPRB, 0.37506659E-03_JPRB, &
  & 0.37476455E-03_JPRB, 0.37444618E-03_JPRB, 0.37407225E-03_JPRB, 0.37365228E-03_JPRB, 0.37325590E-03_JPRB, 0.37293876E-03_JPRB, &
  & 0.37269533E-03_JPRB, 0.37248078E-03_JPRB, 0.37230313E-03_JPRB, 0.37217185E-03_JPRB, 0.37208210E-03_JPRB, 0.37202594E-03_JPRB, &
  & 0.37198810E-03_JPRB, 0.37196108E-03_JPRB, 0.37194081E-03_JPRB, 0.37192380E-03_JPRB, 0.37190694E-03_JPRB, 0.37190021E-03_JPRB, &
  & 0.37190427E-03_JPRB, 0.37191485E-03_JPRB, 0.37193549E-03_JPRB, 0.37195151E-03_JPRB, 0.37197391E-03_JPRB, 0.37199758E-03_JPRB, &
  & 0.37201777E-03_JPRB, 0.37201902E-03_JPRB, 0.37200102E-03_JPRB, 0.37198803E-03_JPRB  /)

RGHG1(:,17, 2) = (/ &
  & 0.37503003E-03_JPRB, 0.37498716E-03_JPRB, 0.37488675E-03_JPRB, 0.37472616E-03_JPRB, 0.37454635E-03_JPRB, 0.37439418E-03_JPRB, &
  & 0.37423710E-03_JPRB, 0.37405748E-03_JPRB, 0.37377316E-03_JPRB, 0.37344249E-03_JPRB, 0.37311587E-03_JPRB, 0.37270392E-03_JPRB, &
  & 0.37237193E-03_JPRB, 0.37223189E-03_JPRB, 0.37220925E-03_JPRB, 0.37224711E-03_JPRB, 0.37231389E-03_JPRB, 0.37239860E-03_JPRB, &
  & 0.37249732E-03_JPRB, 0.37264004E-03_JPRB, 0.37287085E-03_JPRB, 0.37317537E-03_JPRB, 0.37356371E-03_JPRB, 0.37409355E-03_JPRB, &
  & 0.37475509E-03_JPRB, 0.37543552E-03_JPRB, 0.37606293E-03_JPRB, 0.37658529E-03_JPRB, 0.37682815E-03_JPRB, 0.37687870E-03_JPRB, &
  & 0.37682176E-03_JPRB, 0.37660806E-03_JPRB, 0.37629718E-03_JPRB, 0.37595234E-03_JPRB, 0.37556196E-03_JPRB, 0.37517410E-03_JPRB, &
  & 0.37479688E-03_JPRB, 0.37442876E-03_JPRB, 0.37403217E-03_JPRB, 0.37361034E-03_JPRB, 0.37320867E-03_JPRB, 0.37286884E-03_JPRB, &
  & 0.37259688E-03_JPRB, 0.37237620E-03_JPRB, 0.37221555E-03_JPRB, 0.37212264E-03_JPRB, 0.37207292E-03_JPRB, 0.37204312E-03_JPRB, &
  & 0.37201528E-03_JPRB, 0.37198887E-03_JPRB, 0.37196562E-03_JPRB, 0.37195069E-03_JPRB, 0.37194661E-03_JPRB, 0.37195788E-03_JPRB, &
  & 0.37198127E-03_JPRB, 0.37201244E-03_JPRB, 0.37204137E-03_JPRB, 0.37205481E-03_JPRB, 0.37207486E-03_JPRB, 0.37209245E-03_JPRB, &
  & 0.37210181E-03_JPRB, 0.37208977E-03_JPRB, 0.37205955E-03_JPRB, 0.37203915E-03_JPRB  /)

RGHG1(:,18, 2) = (/ &
  & 0.37453150E-03_JPRB, 0.37451940E-03_JPRB, 0.37447048E-03_JPRB, 0.37438301E-03_JPRB, 0.37429009E-03_JPRB, 0.37419830E-03_JPRB, &
  & 0.37408867E-03_JPRB, 0.37395678E-03_JPRB, 0.37375677E-03_JPRB, 0.37346833E-03_JPRB, 0.37318235E-03_JPRB, 0.37286052E-03_JPRB, &
  & 0.37252758E-03_JPRB, 0.37232724E-03_JPRB, 0.37224185E-03_JPRB, 0.37225600E-03_JPRB, 0.37231775E-03_JPRB, 0.37240564E-03_JPRB, &
  & 0.37251603E-03_JPRB, 0.37268138E-03_JPRB, 0.37295693E-03_JPRB, 0.37334275E-03_JPRB, 0.37381592E-03_JPRB, 0.37437064E-03_JPRB, &
  & 0.37499999E-03_JPRB, 0.37567781E-03_JPRB, 0.37636672E-03_JPRB, 0.37694130E-03_JPRB, 0.37718870E-03_JPRB, 0.37725214E-03_JPRB, &
  & 0.37723095E-03_JPRB, 0.37706142E-03_JPRB, 0.37675522E-03_JPRB, 0.37636090E-03_JPRB, 0.37590096E-03_JPRB, 0.37544263E-03_JPRB, &
  & 0.37502158E-03_JPRB, 0.37463895E-03_JPRB, 0.37425580E-03_JPRB, 0.37384595E-03_JPRB, 0.37341742E-03_JPRB, 0.37302927E-03_JPRB, &
  & 0.37271082E-03_JPRB, 0.37245615E-03_JPRB, 0.37227369E-03_JPRB, 0.37217943E-03_JPRB, 0.37212423E-03_JPRB, 0.37209012E-03_JPRB, &
  & 0.37204565E-03_JPRB, 0.37200936E-03_JPRB, 0.37198168E-03_JPRB, 0.37197150E-03_JPRB, 0.37197539E-03_JPRB, 0.37200096E-03_JPRB, &
  & 0.37204332E-03_JPRB, 0.37209007E-03_JPRB, 0.37212378E-03_JPRB, 0.37214016E-03_JPRB, 0.37215012E-03_JPRB, 0.37215345E-03_JPRB, &
  & 0.37214887E-03_JPRB, 0.37212208E-03_JPRB, 0.37209490E-03_JPRB, 0.37208209E-03_JPRB  /)

RGHG1(:,19, 2) = (/ &
  & 0.37411948E-03_JPRB, 0.37411029E-03_JPRB, 0.37409117E-03_JPRB, 0.37405422E-03_JPRB, 0.37402901E-03_JPRB, 0.37399022E-03_JPRB, &
  & 0.37390991E-03_JPRB, 0.37379592E-03_JPRB, 0.37364497E-03_JPRB, 0.37342183E-03_JPRB, 0.37317522E-03_JPRB, 0.37292467E-03_JPRB, &
  & 0.37265374E-03_JPRB, 0.37243767E-03_JPRB, 0.37231639E-03_JPRB, 0.37230744E-03_JPRB, 0.37236629E-03_JPRB, 0.37245921E-03_JPRB, &
  & 0.37258004E-03_JPRB, 0.37276578E-03_JPRB, 0.37308859E-03_JPRB, 0.37356170E-03_JPRB, 0.37413472E-03_JPRB, 0.37471908E-03_JPRB, &
  & 0.37531498E-03_JPRB, 0.37598018E-03_JPRB, 0.37672191E-03_JPRB, 0.37733606E-03_JPRB, 0.37760428E-03_JPRB, 0.37767904E-03_JPRB, &
  & 0.37768163E-03_JPRB, 0.37754907E-03_JPRB, 0.37726082E-03_JPRB, 0.37684332E-03_JPRB, 0.37635884E-03_JPRB, 0.37588810E-03_JPRB, &
  & 0.37548820E-03_JPRB, 0.37514922E-03_JPRB, 0.37480883E-03_JPRB, 0.37440611E-03_JPRB, 0.37393766E-03_JPRB, 0.37347334E-03_JPRB, &
  & 0.37307356E-03_JPRB, 0.37275013E-03_JPRB, 0.37251289E-03_JPRB, 0.37236581E-03_JPRB, 0.37227196E-03_JPRB, 0.37221064E-03_JPRB, &
  & 0.37214346E-03_JPRB, 0.37209263E-03_JPRB, 0.37206373E-03_JPRB, 0.37205035E-03_JPRB, 0.37205439E-03_JPRB, 0.37208114E-03_JPRB, &
  & 0.37212617E-03_JPRB, 0.37218346E-03_JPRB, 0.37222474E-03_JPRB, 0.37224301E-03_JPRB, 0.37224390E-03_JPRB, 0.37223186E-03_JPRB, &
  & 0.37221465E-03_JPRB, 0.37218158E-03_JPRB, 0.37216048E-03_JPRB, 0.37215800E-03_JPRB  /)

RGHG1(:,20, 2) = (/ &
  & 0.37386530E-03_JPRB, 0.37385701E-03_JPRB, 0.37384270E-03_JPRB, 0.37383174E-03_JPRB, 0.37384337E-03_JPRB, 0.37383934E-03_JPRB, &
  & 0.37377350E-03_JPRB, 0.37366130E-03_JPRB, 0.37353408E-03_JPRB, 0.37337618E-03_JPRB, 0.37318925E-03_JPRB, 0.37299996E-03_JPRB, &
  & 0.37280587E-03_JPRB, 0.37261790E-03_JPRB, 0.37248555E-03_JPRB, 0.37246213E-03_JPRB, 0.37252054E-03_JPRB, 0.37262055E-03_JPRB, &
  & 0.37275018E-03_JPRB, 0.37294444E-03_JPRB, 0.37329603E-03_JPRB, 0.37383962E-03_JPRB, 0.37451042E-03_JPRB, 0.37514108E-03_JPRB, &
  & 0.37572274E-03_JPRB, 0.37637096E-03_JPRB, 0.37712763E-03_JPRB, 0.37776485E-03_JPRB, 0.37805701E-03_JPRB, 0.37814427E-03_JPRB, &
  & 0.37815926E-03_JPRB, 0.37806000E-03_JPRB, 0.37779289E-03_JPRB, 0.37737117E-03_JPRB, 0.37690576E-03_JPRB, 0.37649409E-03_JPRB, &
  & 0.37617233E-03_JPRB, 0.37591079E-03_JPRB, 0.37561912E-03_JPRB, 0.37521507E-03_JPRB, 0.37470474E-03_JPRB, 0.37415888E-03_JPRB, &
  & 0.37366577E-03_JPRB, 0.37325278E-03_JPRB, 0.37294002E-03_JPRB, 0.37271010E-03_JPRB, 0.37255957E-03_JPRB, 0.37246069E-03_JPRB, &
  & 0.37236629E-03_JPRB, 0.37229670E-03_JPRB, 0.37225581E-03_JPRB, 0.37222987E-03_JPRB, 0.37222602E-03_JPRB, 0.37224330E-03_JPRB, &
  & 0.37227948E-03_JPRB, 0.37233707E-03_JPRB, 0.37238122E-03_JPRB, 0.37239889E-03_JPRB, 0.37239317E-03_JPRB, 0.37236511E-03_JPRB, &
  & 0.37233441E-03_JPRB, 0.37230233E-03_JPRB, 0.37228971E-03_JPRB, 0.37229481E-03_JPRB  /)

RGHG1(:,21, 2) = (/ &
  & 0.37375542E-03_JPRB, 0.37374815E-03_JPRB, 0.37372938E-03_JPRB, 0.37373444E-03_JPRB, 0.37375821E-03_JPRB, 0.37376497E-03_JPRB, &
  & 0.37370326E-03_JPRB, 0.37359149E-03_JPRB, 0.37347757E-03_JPRB, 0.37337171E-03_JPRB, 0.37325422E-03_JPRB, 0.37312514E-03_JPRB, &
  & 0.37300054E-03_JPRB, 0.37286882E-03_JPRB, 0.37275201E-03_JPRB, 0.37272550E-03_JPRB, 0.37278635E-03_JPRB, 0.37289665E-03_JPRB, &
  & 0.37303574E-03_JPRB, 0.37323154E-03_JPRB, 0.37359068E-03_JPRB, 0.37417738E-03_JPRB, 0.37492842E-03_JPRB, 0.37562587E-03_JPRB, &
  & 0.37622564E-03_JPRB, 0.37686223E-03_JPRB, 0.37759262E-03_JPRB, 0.37823163E-03_JPRB, 0.37854025E-03_JPRB, 0.37863676E-03_JPRB, &
  & 0.37865635E-03_JPRB, 0.37858692E-03_JPRB, 0.37834671E-03_JPRB, 0.37794765E-03_JPRB, 0.37754299E-03_JPRB, 0.37723494E-03_JPRB, &
  & 0.37701196E-03_JPRB, 0.37683262E-03_JPRB, 0.37659016E-03_JPRB, 0.37618834E-03_JPRB, 0.37564232E-03_JPRB, 0.37501932E-03_JPRB, &
  & 0.37443129E-03_JPRB, 0.37391776E-03_JPRB, 0.37351470E-03_JPRB, 0.37319587E-03_JPRB, 0.37298422E-03_JPRB, 0.37284887E-03_JPRB, &
  & 0.37272567E-03_JPRB, 0.37262821E-03_JPRB, 0.37256057E-03_JPRB, 0.37251825E-03_JPRB, 0.37249962E-03_JPRB, 0.37249985E-03_JPRB, &
  & 0.37252141E-03_JPRB, 0.37256752E-03_JPRB, 0.37260466E-03_JPRB, 0.37261903E-03_JPRB, 0.37260694E-03_JPRB, 0.37256382E-03_JPRB, &
  & 0.37252091E-03_JPRB, 0.37249170E-03_JPRB, 0.37248859E-03_JPRB, 0.37250326E-03_JPRB  /)

RGHG1(:,22, 2) = (/ &
  & 0.37376465E-03_JPRB, 0.37374271E-03_JPRB, 0.37373227E-03_JPRB, 0.37376390E-03_JPRB, 0.37378834E-03_JPRB, 0.37377842E-03_JPRB, &
  & 0.37371338E-03_JPRB, 0.37361284E-03_JPRB, 0.37351359E-03_JPRB, 0.37344009E-03_JPRB, 0.37337807E-03_JPRB, 0.37331048E-03_JPRB, &
  & 0.37323824E-03_JPRB, 0.37316901E-03_JPRB, 0.37310444E-03_JPRB, 0.37308716E-03_JPRB, 0.37315391E-03_JPRB, 0.37327977E-03_JPRB, &
  & 0.37343265E-03_JPRB, 0.37363423E-03_JPRB, 0.37398370E-03_JPRB, 0.37457707E-03_JPRB, 0.37537158E-03_JPRB, 0.37615764E-03_JPRB, &
  & 0.37682200E-03_JPRB, 0.37746448E-03_JPRB, 0.37813395E-03_JPRB, 0.37874528E-03_JPRB, 0.37905356E-03_JPRB, 0.37914485E-03_JPRB, &
  & 0.37916321E-03_JPRB, 0.37911502E-03_JPRB, 0.37891817E-03_JPRB, 0.37859027E-03_JPRB, 0.37829223E-03_JPRB, 0.37808824E-03_JPRB, &
  & 0.37793485E-03_JPRB, 0.37781233E-03_JPRB, 0.37762434E-03_JPRB, 0.37724920E-03_JPRB, 0.37668240E-03_JPRB, 0.37598980E-03_JPRB, &
  & 0.37530693E-03_JPRB, 0.37468834E-03_JPRB, 0.37418199E-03_JPRB, 0.37379268E-03_JPRB, 0.37352933E-03_JPRB, 0.37337063E-03_JPRB, &
  & 0.37322308E-03_JPRB, 0.37307993E-03_JPRB, 0.37297215E-03_JPRB, 0.37291816E-03_JPRB, 0.37287896E-03_JPRB, 0.37285640E-03_JPRB, &
  & 0.37286162E-03_JPRB, 0.37288405E-03_JPRB, 0.37290006E-03_JPRB, 0.37290799E-03_JPRB, 0.37288611E-03_JPRB, 0.37283231E-03_JPRB, &
  & 0.37278418E-03_JPRB, 0.37275286E-03_JPRB, 0.37275709E-03_JPRB, 0.37279355E-03_JPRB  /)

RGHG1(:,23, 2) = (/ &
  & 0.37379266E-03_JPRB, 0.37377163E-03_JPRB, 0.37376850E-03_JPRB, 0.37380940E-03_JPRB, 0.37383825E-03_JPRB, 0.37383061E-03_JPRB, &
  & 0.37376625E-03_JPRB, 0.37368272E-03_JPRB, 0.37360600E-03_JPRB, 0.37355790E-03_JPRB, 0.37352858E-03_JPRB, 0.37350045E-03_JPRB, &
  & 0.37347100E-03_JPRB, 0.37344152E-03_JPRB, 0.37341813E-03_JPRB, 0.37342312E-03_JPRB, 0.37349548E-03_JPRB, 0.37363769E-03_JPRB, &
  & 0.37381078E-03_JPRB, 0.37403494E-03_JPRB, 0.37438580E-03_JPRB, 0.37496329E-03_JPRB, 0.37576297E-03_JPRB, 0.37662746E-03_JPRB, &
  & 0.37737879E-03_JPRB, 0.37806252E-03_JPRB, 0.37870806E-03_JPRB, 0.37926674E-03_JPRB, 0.37956605E-03_JPRB, 0.37965074E-03_JPRB, &
  & 0.37966463E-03_JPRB, 0.37962997E-03_JPRB, 0.37949240E-03_JPRB, 0.37926785E-03_JPRB, 0.37907274E-03_JPRB, 0.37891947E-03_JPRB, &
  & 0.37876473E-03_JPRB, 0.37863649E-03_JPRB, 0.37846180E-03_JPRB, 0.37811028E-03_JPRB, 0.37750929E-03_JPRB, 0.37673438E-03_JPRB, &
  & 0.37601032E-03_JPRB, 0.37535009E-03_JPRB, 0.37476277E-03_JPRB, 0.37433147E-03_JPRB, 0.37404779E-03_JPRB, 0.37388593E-03_JPRB, &
  & 0.37372025E-03_JPRB, 0.37354693E-03_JPRB, 0.37340553E-03_JPRB, 0.37333130E-03_JPRB, 0.37328854E-03_JPRB, 0.37324573E-03_JPRB, &
  & 0.37322451E-03_JPRB, 0.37322597E-03_JPRB, 0.37322545E-03_JPRB, 0.37322487E-03_JPRB, 0.37319712E-03_JPRB, 0.37315070E-03_JPRB, &
  & 0.37311224E-03_JPRB, 0.37306936E-03_JPRB, 0.37307530E-03_JPRB, 0.37314313E-03_JPRB  /)

RGHG1(:,24, 2) = (/ &
  & 0.37383970E-03_JPRB, 0.37382314E-03_JPRB, 0.37382550E-03_JPRB, 0.37386689E-03_JPRB, 0.37389715E-03_JPRB, 0.37389749E-03_JPRB, &
  & 0.37383740E-03_JPRB, 0.37377319E-03_JPRB, 0.37372038E-03_JPRB, 0.37369417E-03_JPRB, 0.37368908E-03_JPRB, 0.37368917E-03_JPRB, &
  & 0.37369307E-03_JPRB, 0.37369649E-03_JPRB, 0.37370632E-03_JPRB, 0.37373403E-03_JPRB, 0.37381367E-03_JPRB, 0.37396823E-03_JPRB, &
  & 0.37416564E-03_JPRB, 0.37442397E-03_JPRB, 0.37478944E-03_JPRB, 0.37535369E-03_JPRB, 0.37614753E-03_JPRB, 0.37706739E-03_JPRB, &
  & 0.37790228E-03_JPRB, 0.37863503E-03_JPRB, 0.37927403E-03_JPRB, 0.37978369E-03_JPRB, 0.38007636E-03_JPRB, 0.38016495E-03_JPRB, &
  & 0.38018033E-03_JPRB, 0.38015783E-03_JPRB, 0.38007430E-03_JPRB, 0.37994644E-03_JPRB, 0.37984133E-03_JPRB, 0.37973039E-03_JPRB, &
  & 0.37956025E-03_JPRB, 0.37939164E-03_JPRB, 0.37918463E-03_JPRB, 0.37882908E-03_JPRB, 0.37817628E-03_JPRB, 0.37734288E-03_JPRB, &
  & 0.37660869E-03_JPRB, 0.37593512E-03_JPRB, 0.37530344E-03_JPRB, 0.37484990E-03_JPRB, 0.37455225E-03_JPRB, 0.37438742E-03_JPRB, &
  & 0.37420964E-03_JPRB, 0.37400940E-03_JPRB, 0.37383683E-03_JPRB, 0.37374077E-03_JPRB, 0.37369103E-03_JPRB, 0.37363579E-03_JPRB, &
  & 0.37359757E-03_JPRB, 0.37358034E-03_JPRB, 0.37356373E-03_JPRB, 0.37355745E-03_JPRB, 0.37352282E-03_JPRB, 0.37348534E-03_JPRB, &
  & 0.37345780E-03_JPRB, 0.37341012E-03_JPRB, 0.37341878E-03_JPRB, 0.37350727E-03_JPRB  /)

RGHG1(:,25, 2) = (/ &
  & 0.37391411E-03_JPRB, 0.37390461E-03_JPRB, 0.37390922E-03_JPRB, 0.37393943E-03_JPRB, 0.37396489E-03_JPRB, 0.37397868E-03_JPRB, &
  & 0.37392808E-03_JPRB, 0.37388514E-03_JPRB, 0.37385585E-03_JPRB, 0.37384592E-03_JPRB, 0.37385409E-03_JPRB, 0.37386613E-03_JPRB, &
  & 0.37388733E-03_JPRB, 0.37391512E-03_JPRB, 0.37394508E-03_JPRB, 0.37399236E-03_JPRB, 0.37408197E-03_JPRB, 0.37424104E-03_JPRB, &
  & 0.37446753E-03_JPRB, 0.37477525E-03_JPRB, 0.37517562E-03_JPRB, 0.37573695E-03_JPRB, 0.37651432E-03_JPRB, 0.37744849E-03_JPRB, &
  & 0.37835215E-03_JPRB, 0.37913749E-03_JPRB, 0.37979276E-03_JPRB, 0.38026761E-03_JPRB, 0.38055999E-03_JPRB, 0.38067126E-03_JPRB, &
  & 0.38069934E-03_JPRB, 0.38068775E-03_JPRB, 0.38064298E-03_JPRB, 0.38058841E-03_JPRB, 0.38054717E-03_JPRB, 0.38047376E-03_JPRB, &
  & 0.38028002E-03_JPRB, 0.38002551E-03_JPRB, 0.37971605E-03_JPRB, 0.37930839E-03_JPRB, 0.37857789E-03_JPRB, 0.37773366E-03_JPRB, &
  & 0.37703278E-03_JPRB, 0.37638235E-03_JPRB, 0.37576817E-03_JPRB, 0.37532196E-03_JPRB, 0.37501519E-03_JPRB, 0.37484331E-03_JPRB, &
  & 0.37466327E-03_JPRB, 0.37443960E-03_JPRB, 0.37424013E-03_JPRB, 0.37412233E-03_JPRB, 0.37405604E-03_JPRB, 0.37400221E-03_JPRB, &
  & 0.37396671E-03_JPRB, 0.37393509E-03_JPRB, 0.37390287E-03_JPRB, 0.37389659E-03_JPRB, 0.37385274E-03_JPRB, 0.37382250E-03_JPRB, &
  & 0.37380428E-03_JPRB, 0.37376610E-03_JPRB, 0.37378040E-03_JPRB, 0.37386748E-03_JPRB  /)

RGHG1(:,26, 2) = (/ &
  & 0.37403393E-03_JPRB, 0.37403892E-03_JPRB, 0.37405038E-03_JPRB, 0.37407301E-03_JPRB, 0.37408798E-03_JPRB, 0.37410058E-03_JPRB, &
  & 0.37405297E-03_JPRB, 0.37402588E-03_JPRB, 0.37401439E-03_JPRB, 0.37401486E-03_JPRB, 0.37402954E-03_JPRB, 0.37404837E-03_JPRB, &
  & 0.37407863E-03_JPRB, 0.37412184E-03_JPRB, 0.37417269E-03_JPRB, 0.37424505E-03_JPRB, 0.37435835E-03_JPRB, 0.37452857E-03_JPRB, &
  & 0.37477859E-03_JPRB, 0.37513724E-03_JPRB, 0.37558970E-03_JPRB, 0.37616632E-03_JPRB, 0.37691583E-03_JPRB, 0.37781469E-03_JPRB, &
  & 0.37872576E-03_JPRB, 0.37952641E-03_JPRB, 0.38018496E-03_JPRB, 0.38066265E-03_JPRB, 0.38098006E-03_JPRB, 0.38114003E-03_JPRB, &
  & 0.38121922E-03_JPRB, 0.38124122E-03_JPRB, 0.38121912E-03_JPRB, 0.38117840E-03_JPRB, 0.38112984E-03_JPRB, 0.38103131E-03_JPRB, &
  & 0.38080529E-03_JPRB, 0.38047469E-03_JPRB, 0.38006943E-03_JPRB, 0.37955423E-03_JPRB, 0.37877457E-03_JPRB, 0.37799581E-03_JPRB, &
  & 0.37736846E-03_JPRB, 0.37677020E-03_JPRB, 0.37620759E-03_JPRB, 0.37576745E-03_JPRB, 0.37542798E-03_JPRB, 0.37522475E-03_JPRB, &
  & 0.37503433E-03_JPRB, 0.37479784E-03_JPRB, 0.37458450E-03_JPRB, 0.37445842E-03_JPRB, 0.37438172E-03_JPRB, 0.37432881E-03_JPRB, &
  & 0.37429868E-03_JPRB, 0.37426397E-03_JPRB, 0.37422692E-03_JPRB, 0.37422157E-03_JPRB, 0.37416507E-03_JPRB, 0.37412155E-03_JPRB, &
  & 0.37410124E-03_JPRB, 0.37408085E-03_JPRB, 0.37410004E-03_JPRB, 0.37416135E-03_JPRB  /)

RGHG1(:,27, 2) = (/ &
  & 0.37417604E-03_JPRB, 0.37419893E-03_JPRB, 0.37421927E-03_JPRB, 0.37423531E-03_JPRB, 0.37423720E-03_JPRB, 0.37424313E-03_JPRB, &
  & 0.37419622E-03_JPRB, 0.37418370E-03_JPRB, 0.37418872E-03_JPRB, 0.37419788E-03_JPRB, 0.37421686E-03_JPRB, 0.37424086E-03_JPRB, &
  & 0.37427753E-03_JPRB, 0.37433356E-03_JPRB, 0.37440653E-03_JPRB, 0.37450715E-03_JPRB, 0.37465029E-03_JPRB, 0.37483465E-03_JPRB, &
  & 0.37510723E-03_JPRB, 0.37551968E-03_JPRB, 0.37603297E-03_JPRB, 0.37663232E-03_JPRB, 0.37734848E-03_JPRB, 0.37819204E-03_JPRB, &
  & 0.37908810E-03_JPRB, 0.37989095E-03_JPRB, 0.38054809E-03_JPRB, 0.38104273E-03_JPRB, 0.38139569E-03_JPRB, 0.38161622E-03_JPRB, &
  & 0.38176308E-03_JPRB, 0.38182863E-03_JPRB, 0.38182425E-03_JPRB, 0.38177598E-03_JPRB, 0.38169337E-03_JPRB, 0.38154533E-03_JPRB, &
  & 0.38128235E-03_JPRB, 0.38087583E-03_JPRB, 0.38037287E-03_JPRB, 0.37972469E-03_JPRB, 0.37890421E-03_JPRB, 0.37822218E-03_JPRB, &
  & 0.37768665E-03_JPRB, 0.37715370E-03_JPRB, 0.37665762E-03_JPRB, 0.37622336E-03_JPRB, 0.37584097E-03_JPRB, 0.37559596E-03_JPRB, &
  & 0.37539167E-03_JPRB, 0.37514569E-03_JPRB, 0.37492270E-03_JPRB, 0.37479293E-03_JPRB, 0.37470763E-03_JPRB, 0.37465551E-03_JPRB, &
  & 0.37463197E-03_JPRB, 0.37459822E-03_JPRB, 0.37456012E-03_JPRB, 0.37455608E-03_JPRB, 0.37448511E-03_JPRB, 0.37442007E-03_JPRB, &
  & 0.37439336E-03_JPRB, 0.37439466E-03_JPRB, 0.37441867E-03_JPRB, 0.37444399E-03_JPRB  /)

RGHG1(:,28, 2) = (/ &
  & 0.37438763E-03_JPRB, 0.37439695E-03_JPRB, 0.37443045E-03_JPRB, 0.37445417E-03_JPRB, 0.37445489E-03_JPRB, 0.37443325E-03_JPRB, &
  & 0.37437749E-03_JPRB, 0.37436481E-03_JPRB, 0.37437521E-03_JPRB, 0.37439236E-03_JPRB, 0.37442578E-03_JPRB, 0.37446681E-03_JPRB, &
  & 0.37452179E-03_JPRB, 0.37460024E-03_JPRB, 0.37470197E-03_JPRB, 0.37484578E-03_JPRB, 0.37504195E-03_JPRB, 0.37526968E-03_JPRB, &
  & 0.37557846E-03_JPRB, 0.37602572E-03_JPRB, 0.37656623E-03_JPRB, 0.37719015E-03_JPRB, 0.37787732E-03_JPRB, 0.37864232E-03_JPRB, &
  & 0.37946002E-03_JPRB, 0.38020856E-03_JPRB, 0.38083710E-03_JPRB, 0.38134013E-03_JPRB, 0.38172951E-03_JPRB, 0.38200900E-03_JPRB, &
  & 0.38221896E-03_JPRB, 0.38232561E-03_JPRB, 0.38231618E-03_JPRB, 0.38220842E-03_JPRB, 0.38203395E-03_JPRB, 0.38179360E-03_JPRB, &
  & 0.38146647E-03_JPRB, 0.38100789E-03_JPRB, 0.38044837E-03_JPRB, 0.37979889E-03_JPRB, 0.37909463E-03_JPRB, 0.37849701E-03_JPRB, &
  & 0.37802815E-03_JPRB, 0.37755602E-03_JPRB, 0.37709874E-03_JPRB, 0.37664032E-03_JPRB, 0.37620855E-03_JPRB, 0.37590247E-03_JPRB, &
  & 0.37566924E-03_JPRB, 0.37539930E-03_JPRB, 0.37516486E-03_JPRB, 0.37502395E-03_JPRB, 0.37494996E-03_JPRB, 0.37490821E-03_JPRB, &
  & 0.37488587E-03_JPRB, 0.37484897E-03_JPRB, 0.37482342E-03_JPRB, 0.37481361E-03_JPRB, 0.37473099E-03_JPRB, 0.37463730E-03_JPRB, &
  & 0.37460131E-03_JPRB, 0.37462828E-03_JPRB, 0.37463720E-03_JPRB, 0.37462032E-03_JPRB  /)

RGHG1(:,29, 2) = (/ &
  & 0.37461484E-03_JPRB, 0.37460842E-03_JPRB, 0.37465605E-03_JPRB, 0.37468852E-03_JPRB, 0.37468852E-03_JPRB, 0.37463677E-03_JPRB, &
  & 0.37457120E-03_JPRB, 0.37455772E-03_JPRB, 0.37457334E-03_JPRB, 0.37459892E-03_JPRB, 0.37464809E-03_JPRB, 0.37470766E-03_JPRB, &
  & 0.37478256E-03_JPRB, 0.37488519E-03_JPRB, 0.37501768E-03_JPRB, 0.37520791E-03_JPRB, 0.37546126E-03_JPRB, 0.37573622E-03_JPRB, &
  & 0.37608395E-03_JPRB, 0.37656727E-03_JPRB, 0.37713517E-03_JPRB, 0.37778519E-03_JPRB, 0.37844184E-03_JPRB, 0.37912259E-03_JPRB, &
  & 0.37985452E-03_JPRB, 0.38054307E-03_JPRB, 0.38114012E-03_JPRB, 0.38165166E-03_JPRB, 0.38207967E-03_JPRB, 0.38242157E-03_JPRB, &
  & 0.38269819E-03_JPRB, 0.38284829E-03_JPRB, 0.38283251E-03_JPRB, 0.38265945E-03_JPRB, 0.38238516E-03_JPRB, 0.38204514E-03_JPRB, &
  & 0.38164887E-03_JPRB, 0.38113615E-03_JPRB, 0.38051848E-03_JPRB, 0.37987334E-03_JPRB, 0.37929902E-03_JPRB, 0.37879031E-03_JPRB, &
  & 0.37839100E-03_JPRB, 0.37798312E-03_JPRB, 0.37756576E-03_JPRB, 0.37708044E-03_JPRB, 0.37659606E-03_JPRB, 0.37622445E-03_JPRB, &
  & 0.37595990E-03_JPRB, 0.37566393E-03_JPRB, 0.37541729E-03_JPRB, 0.37526425E-03_JPRB, 0.37520311E-03_JPRB, 0.37517277E-03_JPRB, &
  & 0.37515147E-03_JPRB, 0.37511103E-03_JPRB, 0.37509937E-03_JPRB, 0.37508314E-03_JPRB, 0.37498832E-03_JPRB, 0.37486394E-03_JPRB, &
  & 0.37481799E-03_JPRB, 0.37487235E-03_JPRB, 0.37486440E-03_JPRB, 0.37480255E-03_JPRB  /)

RGHG1(:,30, 2) = (/ &
  & 0.37476109E-03_JPRB, 0.37476058E-03_JPRB, 0.37482135E-03_JPRB, 0.37487711E-03_JPRB, 0.37487591E-03_JPRB, 0.37481566E-03_JPRB, &
  & 0.37476286E-03_JPRB, 0.37476765E-03_JPRB, 0.37479661E-03_JPRB, 0.37484499E-03_JPRB, 0.37492098E-03_JPRB, 0.37501789E-03_JPRB, &
  & 0.37513296E-03_JPRB, 0.37527511E-03_JPRB, 0.37545187E-03_JPRB, 0.37569323E-03_JPRB, 0.37600949E-03_JPRB, 0.37635716E-03_JPRB, &
  & 0.37675932E-03_JPRB, 0.37728614E-03_JPRB, 0.37787226E-03_JPRB, 0.37848378E-03_JPRB, 0.37910964E-03_JPRB, 0.37972471E-03_JPRB, &
  & 0.38038311E-03_JPRB, 0.38100465E-03_JPRB, 0.38155031E-03_JPRB, 0.38202863E-03_JPRB, 0.38243445E-03_JPRB, 0.38276363E-03_JPRB, &
  & 0.38302500E-03_JPRB, 0.38316237E-03_JPRB, 0.38312415E-03_JPRB, 0.38292020E-03_JPRB, 0.38261230E-03_JPRB, 0.38223854E-03_JPRB, &
  & 0.38181603E-03_JPRB, 0.38130411E-03_JPRB, 0.38077289E-03_JPRB, 0.38027522E-03_JPRB, 0.37981637E-03_JPRB, 0.37936989E-03_JPRB, &
  & 0.37897453E-03_JPRB, 0.37855428E-03_JPRB, 0.37810048E-03_JPRB, 0.37758494E-03_JPRB, 0.37704527E-03_JPRB, 0.37658336E-03_JPRB, &
  & 0.37624449E-03_JPRB, 0.37590913E-03_JPRB, 0.37564244E-03_JPRB, 0.37546801E-03_JPRB, 0.37538438E-03_JPRB, 0.37534897E-03_JPRB, &
  & 0.37532852E-03_JPRB, 0.37529809E-03_JPRB, 0.37528772E-03_JPRB, 0.37526372E-03_JPRB, 0.37515971E-03_JPRB, 0.37501612E-03_JPRB, &
  & 0.37493566E-03_JPRB, 0.37496302E-03_JPRB, 0.37492945E-03_JPRB, 0.37483884E-03_JPRB  /)

RGHG1(:,31, 2) = (/ &
  & 0.37491511E-03_JPRB, 0.37492085E-03_JPRB, 0.37499546E-03_JPRB, 0.37507577E-03_JPRB, 0.37507331E-03_JPRB, 0.37500413E-03_JPRB, &
  & 0.37496480E-03_JPRB, 0.37498886E-03_JPRB, 0.37503189E-03_JPRB, 0.37510429E-03_JPRB, 0.37520856E-03_JPRB, 0.37534483E-03_JPRB, &
  & 0.37550223E-03_JPRB, 0.37568606E-03_JPRB, 0.37590947E-03_JPRB, 0.37620469E-03_JPRB, 0.37658725E-03_JPRB, 0.37701156E-03_JPRB, &
  & 0.37747109E-03_JPRB, 0.37804374E-03_JPRB, 0.37864906E-03_JPRB, 0.37921995E-03_JPRB, 0.37981338E-03_JPRB, 0.38035924E-03_JPRB, &
  & 0.38094019E-03_JPRB, 0.38149111E-03_JPRB, 0.38198261E-03_JPRB, 0.38242588E-03_JPRB, 0.38280827E-03_JPRB, 0.38312398E-03_JPRB, &
  & 0.38336920E-03_JPRB, 0.38349311E-03_JPRB, 0.38343123E-03_JPRB, 0.38319476E-03_JPRB, 0.38285152E-03_JPRB, 0.38244226E-03_JPRB, &
  & 0.38199215E-03_JPRB, 0.38148112E-03_JPRB, 0.38104113E-03_JPRB, 0.38069896E-03_JPRB, 0.38036176E-03_JPRB, 0.37998084E-03_JPRB, &
  & 0.37958957E-03_JPRB, 0.37915623E-03_JPRB, 0.37866396E-03_JPRB, 0.37811657E-03_JPRB, 0.37751864E-03_JPRB, 0.37696157E-03_JPRB, &
  & 0.37654435E-03_JPRB, 0.37616747E-03_JPRB, 0.37587965E-03_JPRB, 0.37568268E-03_JPRB, 0.37557531E-03_JPRB, 0.37553453E-03_JPRB, &
  & 0.37551498E-03_JPRB, 0.37549512E-03_JPRB, 0.37548608E-03_JPRB, 0.37545390E-03_JPRB, 0.37534022E-03_JPRB, 0.37517639E-03_JPRB, &
  & 0.37505955E-03_JPRB, 0.37505841E-03_JPRB, 0.37499783E-03_JPRB, 0.37487693E-03_JPRB  /)

RGHG1(:,32, 2) = (/ &
  & 0.37513450E-03_JPRB, 0.37518585E-03_JPRB, 0.37528691E-03_JPRB, 0.37539019E-03_JPRB, 0.37538932E-03_JPRB, 0.37532275E-03_JPRB, &
  & 0.37529976E-03_JPRB, 0.37534621E-03_JPRB, 0.37542487E-03_JPRB, 0.37554163E-03_JPRB, 0.37568586E-03_JPRB, 0.37584986E-03_JPRB, &
  & 0.37604010E-03_JPRB, 0.37626914E-03_JPRB, 0.37654396E-03_JPRB, 0.37689505E-03_JPRB, 0.37733784E-03_JPRB, 0.37782904E-03_JPRB, &
  & 0.37833727E-03_JPRB, 0.37891194E-03_JPRB, 0.37950238E-03_JPRB, 0.38003433E-03_JPRB, 0.38055001E-03_JPRB, 0.38101100E-03_JPRB, &
  & 0.38151958E-03_JPRB, 0.38202770E-03_JPRB, 0.38247397E-03_JPRB, 0.38286867E-03_JPRB, 0.38319671E-03_JPRB, 0.38345727E-03_JPRB, &
  & 0.38365944E-03_JPRB, 0.38374561E-03_JPRB, 0.38367051E-03_JPRB, 0.38344595E-03_JPRB, 0.38313318E-03_JPRB, 0.38277276E-03_JPRB, &
  & 0.38238259E-03_JPRB, 0.38196546E-03_JPRB, 0.38162662E-03_JPRB, 0.38135133E-03_JPRB, 0.38105151E-03_JPRB, 0.38070145E-03_JPRB, &
  & 0.38031560E-03_JPRB, 0.37986236E-03_JPRB, 0.37933133E-03_JPRB, 0.37873016E-03_JPRB, 0.37806834E-03_JPRB, 0.37743544E-03_JPRB, &
  & 0.37694233E-03_JPRB, 0.37650581E-03_JPRB, 0.37618025E-03_JPRB, 0.37594676E-03_JPRB, 0.37581262E-03_JPRB, 0.37576017E-03_JPRB, &
  & 0.37573443E-03_JPRB, 0.37570346E-03_JPRB, 0.37568385E-03_JPRB, 0.37564321E-03_JPRB, 0.37552457E-03_JPRB, 0.37534041E-03_JPRB, &
  & 0.37515467E-03_JPRB, 0.37508401E-03_JPRB, 0.37499282E-03_JPRB, 0.37488529E-03_JPRB  /)

RGHG1(:,33, 2) = (/ &
  & 0.37537096E-03_JPRB, 0.37547482E-03_JPRB, 0.37560500E-03_JPRB, 0.37573194E-03_JPRB, 0.37573310E-03_JPRB, 0.37567073E-03_JPRB, &
  & 0.37566510E-03_JPRB, 0.37573520E-03_JPRB, 0.37585370E-03_JPRB, 0.37601917E-03_JPRB, 0.37620646E-03_JPRB, 0.37639776E-03_JPRB, &
  & 0.37662090E-03_JPRB, 0.37689741E-03_JPRB, 0.37722626E-03_JPRB, 0.37763566E-03_JPRB, 0.37814026E-03_JPRB, 0.37869971E-03_JPRB, &
  & 0.37925744E-03_JPRB, 0.37982854E-03_JPRB, 0.38039910E-03_JPRB, 0.38089079E-03_JPRB, 0.38131981E-03_JPRB, 0.38169058E-03_JPRB, &
  & 0.38212460E-03_JPRB, 0.38259184E-03_JPRB, 0.38299226E-03_JPRB, 0.38333474E-03_JPRB, 0.38360230E-03_JPRB, 0.38380013E-03_JPRB, &
  & 0.38395407E-03_JPRB, 0.38399789E-03_JPRB, 0.38391040E-03_JPRB, 0.38370398E-03_JPRB, 0.38343138E-03_JPRB, 0.38313263E-03_JPRB, &
  & 0.38281611E-03_JPRB, 0.38250860E-03_JPRB, 0.38227616E-03_JPRB, 0.38205890E-03_JPRB, 0.38178701E-03_JPRB, 0.38146453E-03_JPRB, &
  & 0.38108449E-03_JPRB, 0.38060969E-03_JPRB, 0.38003834E-03_JPRB, 0.37937844E-03_JPRB, 0.37864949E-03_JPRB, 0.37794028E-03_JPRB, &
  & 0.37736864E-03_JPRB, 0.37686779E-03_JPRB, 0.37650085E-03_JPRB, 0.37622760E-03_JPRB, 0.37606525E-03_JPRB, 0.37599986E-03_JPRB, &
  & 0.37596676E-03_JPRB, 0.37592144E-03_JPRB, 0.37588931E-03_JPRB, 0.37583985E-03_JPRB, 0.37571665E-03_JPRB, 0.37551135E-03_JPRB, &
  & 0.37524980E-03_JPRB, 0.37510158E-03_JPRB, 0.37497812E-03_JPRB, 0.37489012E-03_JPRB  /)

RGHG1(:,34, 2) = (/ &
  & 0.37578879E-03_JPRB, 0.37592235E-03_JPRB, 0.37608527E-03_JPRB, 0.37622544E-03_JPRB, 0.37622303E-03_JPRB, 0.37617200E-03_JPRB, &
  & 0.37618361E-03_JPRB, 0.37627727E-03_JPRB, 0.37643452E-03_JPRB, 0.37663312E-03_JPRB, 0.37683790E-03_JPRB, 0.37703985E-03_JPRB, &
  & 0.37728081E-03_JPRB, 0.37758884E-03_JPRB, 0.37797219E-03_JPRB, 0.37843590E-03_JPRB, 0.37898076E-03_JPRB, 0.37956516E-03_JPRB, &
  & 0.38011551E-03_JPRB, 0.38064488E-03_JPRB, 0.38115302E-03_JPRB, 0.38158589E-03_JPRB, 0.38193725E-03_JPRB, 0.38223165E-03_JPRB, &
  & 0.38259429E-03_JPRB, 0.38301319E-03_JPRB, 0.38338709E-03_JPRB, 0.38369963E-03_JPRB, 0.38392631E-03_JPRB, 0.38409386E-03_JPRB, &
  & 0.38422795E-03_JPRB, 0.38424946E-03_JPRB, 0.38415835E-03_JPRB, 0.38397924E-03_JPRB, 0.38374185E-03_JPRB, 0.38348926E-03_JPRB, &
  & 0.38322511E-03_JPRB, 0.38297639E-03_JPRB, 0.38278363E-03_JPRB, 0.38259370E-03_JPRB, 0.38235391E-03_JPRB, 0.38206063E-03_JPRB, &
  & 0.38170158E-03_JPRB, 0.38123629E-03_JPRB, 0.38065738E-03_JPRB, 0.37998269E-03_JPRB, 0.37923623E-03_JPRB, 0.37849897E-03_JPRB, &
  & 0.37787344E-03_JPRB, 0.37731792E-03_JPRB, 0.37689359E-03_JPRB, 0.37658342E-03_JPRB, 0.37639730E-03_JPRB, 0.37630880E-03_JPRB, &
  & 0.37626512E-03_JPRB, 0.37620445E-03_JPRB, 0.37616371E-03_JPRB, 0.37610301E-03_JPRB, 0.37596444E-03_JPRB, 0.37572918E-03_JPRB, &
  & 0.37539944E-03_JPRB, 0.37517533E-03_JPRB, 0.37504555E-03_JPRB, 0.37499776E-03_JPRB  /)

RGHG1(:,35, 2) = (/ &
  & 0.37631143E-03_JPRB, 0.37646383E-03_JPRB, 0.37666229E-03_JPRB, 0.37681071E-03_JPRB, 0.37680173E-03_JPRB, 0.37676603E-03_JPRB, &
  & 0.37679531E-03_JPRB, 0.37691314E-03_JPRB, 0.37710969E-03_JPRB, 0.37733433E-03_JPRB, 0.37754398E-03_JPRB, 0.37774833E-03_JPRB, &
  & 0.37799988E-03_JPRB, 0.37833214E-03_JPRB, 0.37877174E-03_JPRB, 0.37928924E-03_JPRB, 0.37986443E-03_JPRB, 0.38045228E-03_JPRB, &
  & 0.38096586E-03_JPRB, 0.38143274E-03_JPRB, 0.38185488E-03_JPRB, 0.38221772E-03_JPRB, 0.38249386E-03_JPRB, 0.38271688E-03_JPRB, &
  & 0.38300774E-03_JPRB, 0.38337312E-03_JPRB, 0.38372967E-03_JPRB, 0.38402285E-03_JPRB, 0.38421758E-03_JPRB, 0.38437064E-03_JPRB, &
  & 0.38449889E-03_JPRB, 0.38450772E-03_JPRB, 0.38441739E-03_JPRB, 0.38427109E-03_JPRB, 0.38406735E-03_JPRB, 0.38385425E-03_JPRB, &
  & 0.38363304E-03_JPRB, 0.38341869E-03_JPRB, 0.38323248E-03_JPRB, 0.38305490E-03_JPRB, 0.38285025E-03_JPRB, 0.38258782E-03_JPRB, &
  & 0.38225813E-03_JPRB, 0.38181857E-03_JPRB, 0.38124868E-03_JPRB, 0.38058133E-03_JPRB, 0.37984234E-03_JPRB, 0.37910099E-03_JPRB, &
  & 0.37843272E-03_JPRB, 0.37782595E-03_JPRB, 0.37733439E-03_JPRB, 0.37698771E-03_JPRB, 0.37677945E-03_JPRB, 0.37666197E-03_JPRB, &
  & 0.37660576E-03_JPRB, 0.37652878E-03_JPRB, 0.37648122E-03_JPRB, 0.37640773E-03_JPRB, 0.37624778E-03_JPRB, 0.37597718E-03_JPRB, &
  & 0.37558125E-03_JPRB, 0.37527997E-03_JPRB, 0.37515702E-03_JPRB, 0.37516119E-03_JPRB  /)

RGHG1(:,36, 2) = (/ &
  & 0.37694608E-03_JPRB, 0.37713991E-03_JPRB, 0.37736452E-03_JPRB, 0.37750012E-03_JPRB, 0.37747060E-03_JPRB, 0.37743934E-03_JPRB, &
  & 0.37748608E-03_JPRB, 0.37762976E-03_JPRB, 0.37785761E-03_JPRB, 0.37809200E-03_JPRB, 0.37829703E-03_JPRB, 0.37850634E-03_JPRB, &
  & 0.37876401E-03_JPRB, 0.37911222E-03_JPRB, 0.37959368E-03_JPRB, 0.38013811E-03_JPRB, 0.38070829E-03_JPRB, 0.38126575E-03_JPRB, &
  & 0.38172831E-03_JPRB, 0.38213074E-03_JPRB, 0.38247025E-03_JPRB, 0.38276012E-03_JPRB, 0.38296476E-03_JPRB, 0.38312128E-03_JPRB, &
  & 0.38335084E-03_JPRB, 0.38367025E-03_JPRB, 0.38401167E-03_JPRB, 0.38429572E-03_JPRB, 0.38447361E-03_JPRB, 0.38463414E-03_JPRB, &
  & 0.38477431E-03_JPRB, 0.38478311E-03_JPRB, 0.38469864E-03_JPRB, 0.38457510E-03_JPRB, 0.38439292E-03_JPRB, 0.38419578E-03_JPRB, &
  & 0.38400042E-03_JPRB, 0.38381079E-03_JPRB, 0.38363047E-03_JPRB, 0.38346609E-03_JPRB, 0.38329080E-03_JPRB, 0.38305768E-03_JPRB, &
  & 0.38275515E-03_JPRB, 0.38234365E-03_JPRB, 0.38179114E-03_JPRB, 0.38114045E-03_JPRB, 0.38042317E-03_JPRB, 0.37969345E-03_JPRB, &
  & 0.37900258E-03_JPRB, 0.37836131E-03_JPRB, 0.37781629E-03_JPRB, 0.37743993E-03_JPRB, 0.37721491E-03_JPRB, 0.37706824E-03_JPRB, &
  & 0.37700081E-03_JPRB, 0.37690923E-03_JPRB, 0.37685062E-03_JPRB, 0.37676205E-03_JPRB, 0.37658343E-03_JPRB, 0.37628729E-03_JPRB, &
  & 0.37584053E-03_JPRB, 0.37547098E-03_JPRB, 0.37534647E-03_JPRB, 0.37539037E-03_JPRB  /)

RGHG1(:,37, 2) = (/ &
  & 0.37779806E-03_JPRB, 0.37808255E-03_JPRB, 0.37831016E-03_JPRB, 0.37838543E-03_JPRB, 0.37830458E-03_JPRB, 0.37825251E-03_JPRB, &
  & 0.37831515E-03_JPRB, 0.37848695E-03_JPRB, 0.37872584E-03_JPRB, 0.37893198E-03_JPRB, 0.37911093E-03_JPRB, 0.37933073E-03_JPRB, &
  & 0.37958391E-03_JPRB, 0.37992810E-03_JPRB, 0.38041579E-03_JPRB, 0.38092395E-03_JPRB, 0.38140838E-03_JPRB, 0.38185975E-03_JPRB, &
  & 0.38224178E-03_JPRB, 0.38257927E-03_JPRB, 0.38284905E-03_JPRB, 0.38306372E-03_JPRB, 0.38320983E-03_JPRB, 0.38331520E-03_JPRB, &
  & 0.38351130E-03_JPRB, 0.38380493E-03_JPRB, 0.38413724E-03_JPRB, 0.38443616E-03_JPRB, 0.38463294E-03_JPRB, 0.38485079E-03_JPRB, &
  & 0.38504289E-03_JPRB, 0.38508059E-03_JPRB, 0.38501327E-03_JPRB, 0.38488805E-03_JPRB, 0.38469837E-03_JPRB, 0.38446226E-03_JPRB, &
  & 0.38425197E-03_JPRB, 0.38406342E-03_JPRB, 0.38388705E-03_JPRB, 0.38373707E-03_JPRB, 0.38357605E-03_JPRB, 0.38336686E-03_JPRB, &
  & 0.38308478E-03_JPRB, 0.38270493E-03_JPRB, 0.38218786E-03_JPRB, 0.38157417E-03_JPRB, 0.38090990E-03_JPRB, 0.38022713E-03_JPRB, &
  & 0.37956127E-03_JPRB, 0.37892606E-03_JPRB, 0.37836244E-03_JPRB, 0.37797391E-03_JPRB, 0.37774553E-03_JPRB, 0.37757098E-03_JPRB, &
  & 0.37749606E-03_JPRB, 0.37739471E-03_JPRB, 0.37731600E-03_JPRB, 0.37720806E-03_JPRB, 0.37701811E-03_JPRB, 0.37672047E-03_JPRB, &
  & 0.37626130E-03_JPRB, 0.37584809E-03_JPRB, 0.37570296E-03_JPRB, 0.37575604E-03_JPRB  /)

RGHG1(:,38, 2) = (/ &
  & 0.37874340E-03_JPRB, 0.37912850E-03_JPRB, 0.37935943E-03_JPRB, 0.37936777E-03_JPRB, 0.37922996E-03_JPRB, 0.37915480E-03_JPRB, &
  & 0.37923507E-03_JPRB, 0.37943808E-03_JPRB, 0.37968921E-03_JPRB, 0.37986402E-03_JPRB, 0.38001402E-03_JPRB, 0.38024546E-03_JPRB, &
  & 0.38049365E-03_JPRB, 0.38083338E-03_JPRB, 0.38132800E-03_JPRB, 0.38179590E-03_JPRB, 0.38218518E-03_JPRB, 0.38251886E-03_JPRB, &
  & 0.38281153E-03_JPRB, 0.38307696E-03_JPRB, 0.38326935E-03_JPRB, 0.38340059E-03_JPRB, 0.38348177E-03_JPRB, 0.38353038E-03_JPRB, &
  & 0.38368935E-03_JPRB, 0.38395437E-03_JPRB, 0.38427657E-03_JPRB, 0.38459198E-03_JPRB, 0.38480972E-03_JPRB, 0.38509119E-03_JPRB, &
  & 0.38534091E-03_JPRB, 0.38541067E-03_JPRB, 0.38536238E-03_JPRB, 0.38523530E-03_JPRB, 0.38503731E-03_JPRB, 0.38475795E-03_JPRB, &
  & 0.38453109E-03_JPRB, 0.38434373E-03_JPRB, 0.38417176E-03_JPRB, 0.38403775E-03_JPRB, 0.38389256E-03_JPRB, 0.38370992E-03_JPRB, &
  & 0.38345053E-03_JPRB, 0.38310581E-03_JPRB, 0.38262806E-03_JPRB, 0.38205543E-03_JPRB, 0.38144997E-03_JPRB, 0.38081930E-03_JPRB, &
  & 0.38018119E-03_JPRB, 0.37955269E-03_JPRB, 0.37896845E-03_JPRB, 0.37856641E-03_JPRB, 0.37833431E-03_JPRB, 0.37812882E-03_JPRB, &
  & 0.37804558E-03_JPRB, 0.37793338E-03_JPRB, 0.37783239E-03_JPRB, 0.37770296E-03_JPRB, 0.37750043E-03_JPRB, 0.37720112E-03_JPRB, &
  & 0.37672819E-03_JPRB, 0.37626654E-03_JPRB, 0.37609852E-03_JPRB, 0.37616177E-03_JPRB  /)

RGHG1(:,39, 2) = (/ &
  & 0.37984145E-03_JPRB, 0.38035946E-03_JPRB, 0.38053595E-03_JPRB, 0.38048045E-03_JPRB, 0.38030562E-03_JPRB, 0.38021246E-03_JPRB, &
  & 0.38026531E-03_JPRB, 0.38046434E-03_JPRB, 0.38068739E-03_JPRB, 0.38081328E-03_JPRB, 0.38094051E-03_JPRB, 0.38114256E-03_JPRB, &
  & 0.38134472E-03_JPRB, 0.38161892E-03_JPRB, 0.38201794E-03_JPRB, 0.38236951E-03_JPRB, 0.38263537E-03_JPRB, 0.38286424E-03_JPRB, &
  & 0.38308587E-03_JPRB, 0.38329822E-03_JPRB, 0.38343597E-03_JPRB, 0.38351890E-03_JPRB, 0.38356375E-03_JPRB, 0.38358279E-03_JPRB, &
  & 0.38372023E-03_JPRB, 0.38400620E-03_JPRB, 0.38434960E-03_JPRB, 0.38468068E-03_JPRB, 0.38490797E-03_JPRB, 0.38522373E-03_JPRB, &
  & 0.38551251E-03_JPRB, 0.38562717E-03_JPRB, 0.38560461E-03_JPRB, 0.38547524E-03_JPRB, 0.38528422E-03_JPRB, 0.38497914E-03_JPRB, &
  & 0.38470273E-03_JPRB, 0.38449848E-03_JPRB, 0.38431886E-03_JPRB, 0.38419020E-03_JPRB, 0.38404863E-03_JPRB, 0.38388469E-03_JPRB, &
  & 0.38365636E-03_JPRB, 0.38334671E-03_JPRB, 0.38290479E-03_JPRB, 0.38235957E-03_JPRB, 0.38178634E-03_JPRB, 0.38121703E-03_JPRB, &
  & 0.38063629E-03_JPRB, 0.38006533E-03_JPRB, 0.37951666E-03_JPRB, 0.37914082E-03_JPRB, 0.37892209E-03_JPRB, 0.37872507E-03_JPRB, &
  & 0.37864148E-03_JPRB, 0.37851197E-03_JPRB, 0.37838648E-03_JPRB, 0.37824489E-03_JPRB, 0.37805155E-03_JPRB, 0.37778056E-03_JPRB, &
  & 0.37734633E-03_JPRB, 0.37687512E-03_JPRB, 0.37664955E-03_JPRB, 0.37670012E-03_JPRB  /)

RGHG1(:,40, 2) = (/ &
  & 0.38115509E-03_JPRB, 0.38183436E-03_JPRB, 0.38193752E-03_JPRB, 0.38180759E-03_JPRB, 0.38159257E-03_JPRB, 0.38147914E-03_JPRB, &
  & 0.38149244E-03_JPRB, 0.38168103E-03_JPRB, 0.38186454E-03_JPRB, 0.38193015E-03_JPRB, 0.38203165E-03_JPRB, 0.38219248E-03_JPRB, &
  & 0.38233392E-03_JPRB, 0.38252121E-03_JPRB, 0.38279130E-03_JPRB, 0.38299389E-03_JPRB, 0.38311026E-03_JPRB, 0.38321825E-03_JPRB, &
  & 0.38335950E-03_JPRB, 0.38351266E-03_JPRB, 0.38359000E-03_JPRB, 0.38362199E-03_JPRB, 0.38362890E-03_JPRB, 0.38361767E-03_JPRB, &
  & 0.38373239E-03_JPRB, 0.38405106E-03_JPRB, 0.38442448E-03_JPRB, 0.38477379E-03_JPRB, 0.38501042E-03_JPRB, 0.38536163E-03_JPRB, &
  & 0.38569323E-03_JPRB, 0.38586266E-03_JPRB, 0.38587140E-03_JPRB, 0.38573927E-03_JPRB, 0.38555894E-03_JPRB, 0.38522653E-03_JPRB, &
  & 0.38488658E-03_JPRB, 0.38465955E-03_JPRB, 0.38446899E-03_JPRB, 0.38434487E-03_JPRB, 0.38420554E-03_JPRB, 0.38406227E-03_JPRB, &
  & 0.38387176E-03_JPRB, 0.38360326E-03_JPRB, 0.38320280E-03_JPRB, 0.38268753E-03_JPRB, 0.38214777E-03_JPRB, 0.38165199E-03_JPRB, &
  & 0.38114343E-03_JPRB, 0.38064830E-03_JPRB, 0.38015057E-03_JPRB, 0.37981198E-03_JPRB, 0.37961174E-03_JPRB, 0.37943110E-03_JPRB, &
  & 0.37934840E-03_JPRB, 0.37919752E-03_JPRB, 0.37904291E-03_JPRB, 0.37888859E-03_JPRB, 0.37870958E-03_JPRB, 0.37847673E-03_JPRB, &
  & 0.37809651E-03_JPRB, 0.37762044E-03_JPRB, 0.37732166E-03_JPRB, 0.37735361E-03_JPRB  /)

RGHG1(:,41, 2) = (/ &
  & 0.38276121E-03_JPRB, 0.38363764E-03_JPRB, 0.38365114E-03_JPRB, 0.38343022E-03_JPRB, 0.38316606E-03_JPRB, 0.38302782E-03_JPRB, &
  & 0.38299277E-03_JPRB, 0.38316861E-03_JPRB, 0.38330377E-03_JPRB, 0.38329568E-03_JPRB, 0.38336572E-03_JPRB, 0.38347617E-03_JPRB, &
  & 0.38354335E-03_JPRB, 0.38362440E-03_JPRB, 0.38373683E-03_JPRB, 0.38375728E-03_JPRB, 0.38369088E-03_JPRB, 0.38365107E-03_JPRB, &
  & 0.38369406E-03_JPRB, 0.38377484E-03_JPRB, 0.38377832E-03_JPRB, 0.38374804E-03_JPRB, 0.38370855E-03_JPRB, 0.38366031E-03_JPRB, &
  & 0.38374725E-03_JPRB, 0.38410591E-03_JPRB, 0.38451602E-03_JPRB, 0.38488763E-03_JPRB, 0.38513569E-03_JPRB, 0.38553024E-03_JPRB, &
  & 0.38591418E-03_JPRB, 0.38615059E-03_JPRB, 0.38619758E-03_JPRB, 0.38606209E-03_JPRB, 0.38589483E-03_JPRB, 0.38552901E-03_JPRB, &
  & 0.38511137E-03_JPRB, 0.38485648E-03_JPRB, 0.38465254E-03_JPRB, 0.38453398E-03_JPRB, 0.38439739E-03_JPRB, 0.38427939E-03_JPRB, &
  & 0.38413511E-03_JPRB, 0.38391693E-03_JPRB, 0.38356717E-03_JPRB, 0.38308851E-03_JPRB, 0.38258967E-03_JPRB, 0.38218379E-03_JPRB, &
  & 0.38176349E-03_JPRB, 0.38136107E-03_JPRB, 0.38092562E-03_JPRB, 0.38063256E-03_JPRB, 0.38045494E-03_JPRB, 0.38029432E-03_JPRB, &
  & 0.38021272E-03_JPRB, 0.38003571E-03_JPRB, 0.37984550E-03_JPRB, 0.37967561E-03_JPRB, 0.37951413E-03_JPRB, 0.37932791E-03_JPRB, &
  & 0.37901372E-03_JPRB, 0.37853170E-03_JPRB, 0.37814342E-03_JPRB, 0.37815260E-03_JPRB  /)

RGHG1(:,42, 2) = (/ &
  & 0.38411854E-03_JPRB, 0.38492410E-03_JPRB, 0.38485933E-03_JPRB, 0.38459739E-03_JPRB, 0.38430997E-03_JPRB, 0.38406644E-03_JPRB, &
  & 0.38388027E-03_JPRB, 0.38397854E-03_JPRB, 0.38405428E-03_JPRB, 0.38401868E-03_JPRB, 0.38404637E-03_JPRB, 0.38406029E-03_JPRB, &
  & 0.38401749E-03_JPRB, 0.38396651E-03_JPRB, 0.38392335E-03_JPRB, 0.38382573E-03_JPRB, 0.38367556E-03_JPRB, 0.38361958E-03_JPRB, &
  & 0.38364486E-03_JPRB, 0.38369378E-03_JPRB, 0.38365764E-03_JPRB, 0.38364319E-03_JPRB, 0.38361179E-03_JPRB, 0.38356906E-03_JPRB, &
  & 0.38369423E-03_JPRB, 0.38409401E-03_JPRB, 0.38453452E-03_JPRB, 0.38489173E-03_JPRB, 0.38514007E-03_JPRB, 0.38550049E-03_JPRB, &
  & 0.38586990E-03_JPRB, 0.38609842E-03_JPRB, 0.38614894E-03_JPRB, 0.38602511E-03_JPRB, 0.38590963E-03_JPRB, 0.38559813E-03_JPRB, &
  & 0.38514868E-03_JPRB, 0.38484594E-03_JPRB, 0.38459595E-03_JPRB, 0.38446876E-03_JPRB, 0.38436387E-03_JPRB, 0.38426711E-03_JPRB, &
  & 0.38415315E-03_JPRB, 0.38395776E-03_JPRB, 0.38362555E-03_JPRB, 0.38315729E-03_JPRB, 0.38269127E-03_JPRB, 0.38233342E-03_JPRB, &
  & 0.38199231E-03_JPRB, 0.38169921E-03_JPRB, 0.38134647E-03_JPRB, 0.38113980E-03_JPRB, 0.38099719E-03_JPRB, 0.38088634E-03_JPRB, &
  & 0.38079585E-03_JPRB, 0.38064106E-03_JPRB, 0.38044936E-03_JPRB, 0.38029011E-03_JPRB, 0.38019057E-03_JPRB, 0.38003769E-03_JPRB, &
  & 0.37976799E-03_JPRB, 0.37933378E-03_JPRB, 0.37894278E-03_JPRB, 0.37890839E-03_JPRB  /)

RGHG1(:,43, 2) = (/ &
  & 0.38604784E-03_JPRB, 0.38687354E-03_JPRB, 0.38669878E-03_JPRB, 0.38636029E-03_JPRB, 0.38603049E-03_JPRB, 0.38568022E-03_JPRB, &
  & 0.38533538E-03_JPRB, 0.38535740E-03_JPRB, 0.38535812E-03_JPRB, 0.38526572E-03_JPRB, 0.38524124E-03_JPRB, 0.38514541E-03_JPRB, &
  & 0.38497033E-03_JPRB, 0.38475319E-03_JPRB, 0.38450026E-03_JPRB, 0.38421656E-03_JPRB, 0.38391134E-03_JPRB, 0.38377702E-03_JPRB, &
  & 0.38374388E-03_JPRB, 0.38373260E-03_JPRB, 0.38362855E-03_JPRB, 0.38360175E-03_JPRB, 0.38355776E-03_JPRB, 0.38350416E-03_JPRB, &
  & 0.38365224E-03_JPRB, 0.38410674E-03_JPRB, 0.38459079E-03_JPRB, 0.38494444E-03_JPRB, 0.38519796E-03_JPRB, 0.38554587E-03_JPRB, &
  & 0.38592454E-03_JPRB, 0.38617467E-03_JPRB, 0.38624487E-03_JPRB, 0.38613023E-03_JPRB, 0.38606761E-03_JPRB, 0.38579131E-03_JPRB, &
  & 0.38527942E-03_JPRB, 0.38492104E-03_JPRB, 0.38462327E-03_JPRB, 0.38449060E-03_JPRB, 0.38441581E-03_JPRB, 0.38434931E-03_JPRB, &
  & 0.38428288E-03_JPRB, 0.38412995E-03_JPRB, 0.38383555E-03_JPRB, 0.38339253E-03_JPRB, 0.38297405E-03_JPRB, 0.38269871E-03_JPRB, &
  & 0.38246780E-03_JPRB, 0.38231431E-03_JPRB, 0.38206384E-03_JPRB, 0.38195557E-03_JPRB, 0.38185463E-03_JPRB, 0.38179781E-03_JPRB, &
  & 0.38169968E-03_JPRB, 0.38155392E-03_JPRB, 0.38134555E-03_JPRB, 0.38118931E-03_JPRB, 0.38115383E-03_JPRB, 0.38105142E-03_JPRB, &
  & 0.38085072E-03_JPRB, 0.38045756E-03_JPRB, 0.38002558E-03_JPRB, 0.37994164E-03_JPRB  /)

RGHG1(:,44, 2) = (/ &
  & 0.38716519E-03_JPRB, 0.38803479E-03_JPRB, 0.38781500E-03_JPRB, 0.38734094E-03_JPRB, 0.38686473E-03_JPRB, 0.38638443E-03_JPRB, &
  & 0.38593240E-03_JPRB, 0.38587008E-03_JPRB, 0.38584422E-03_JPRB, 0.38575825E-03_JPRB, 0.38572361E-03_JPRB, 0.38558092E-03_JPRB, &
  & 0.38530411E-03_JPRB, 0.38495888E-03_JPRB, 0.38459088E-03_JPRB, 0.38421096E-03_JPRB, 0.38385865E-03_JPRB, 0.38369506E-03_JPRB, &
  & 0.38362685E-03_JPRB, 0.38356987E-03_JPRB, 0.38345447E-03_JPRB, 0.38344632E-03_JPRB, 0.38342222E-03_JPRB, 0.38341935E-03_JPRB, &
  & 0.38361542E-03_JPRB, 0.38410752E-03_JPRB, 0.38460675E-03_JPRB, 0.38496406E-03_JPRB, 0.38520762E-03_JPRB, 0.38556749E-03_JPRB, &
  & 0.38594195E-03_JPRB, 0.38618083E-03_JPRB, 0.38625391E-03_JPRB, 0.38615154E-03_JPRB, 0.38611882E-03_JPRB, 0.38591287E-03_JPRB, &
  & 0.38540685E-03_JPRB, 0.38498364E-03_JPRB, 0.38464610E-03_JPRB, 0.38446597E-03_JPRB, 0.38437873E-03_JPRB, 0.38433580E-03_JPRB, &
  & 0.38429734E-03_JPRB, 0.38414136E-03_JPRB, 0.38385267E-03_JPRB, 0.38344003E-03_JPRB, 0.38307258E-03_JPRB, 0.38287032E-03_JPRB, &
  & 0.38272997E-03_JPRB, 0.38266895E-03_JPRB, 0.38249475E-03_JPRB, 0.38247029E-03_JPRB, 0.38242583E-03_JPRB, 0.38239812E-03_JPRB, &
  & 0.38232165E-03_JPRB, 0.38220633E-03_JPRB, 0.38201031E-03_JPRB, 0.38187834E-03_JPRB, 0.38183455E-03_JPRB, 0.38177680E-03_JPRB, &
  & 0.38164477E-03_JPRB, 0.38131759E-03_JPRB, 0.38095079E-03_JPRB, 0.38077396E-03_JPRB  /)

RGHG1(:,45, 2) = (/ &
  & 0.38868092E-03_JPRB, 0.38960305E-03_JPRB, 0.38931809E-03_JPRB, 0.38868002E-03_JPRB, 0.38803178E-03_JPRB, 0.38738998E-03_JPRB, &
  & 0.38679589E-03_JPRB, 0.38662791E-03_JPRB, 0.38656231E-03_JPRB, 0.38647650E-03_JPRB, 0.38642369E-03_JPRB, 0.38621380E-03_JPRB, &
  & 0.38580446E-03_JPRB, 0.38529242E-03_JPRB, 0.38476692E-03_JPRB, 0.38425395E-03_JPRB, 0.38382845E-03_JPRB, 0.38362165E-03_JPRB, &
  & 0.38350614E-03_JPRB, 0.38338951E-03_JPRB, 0.38325262E-03_JPRB, 0.38326415E-03_JPRB, 0.38326108E-03_JPRB, 0.38331460E-03_JPRB, &
  & 0.38356819E-03_JPRB, 0.38411002E-03_JPRB, 0.38463203E-03_JPRB, 0.38499304E-03_JPRB, 0.38522594E-03_JPRB, 0.38559784E-03_JPRB, &
  & 0.38596866E-03_JPRB, 0.38619748E-03_JPRB, 0.38627631E-03_JPRB, 0.38618908E-03_JPRB, 0.38619708E-03_JPRB, 0.38607567E-03_JPRB, &
  & 0.38556844E-03_JPRB, 0.38506440E-03_JPRB, 0.38467554E-03_JPRB, 0.38444070E-03_JPRB, 0.38434309E-03_JPRB, 0.38433080E-03_JPRB, &
  & 0.38433019E-03_JPRB, 0.38417610E-03_JPRB, 0.38389869E-03_JPRB, 0.38352381E-03_JPRB, 0.38322046E-03_JPRB, 0.38311183E-03_JPRB, &
  & 0.38308848E-03_JPRB, 0.38315038E-03_JPRB, 0.38307593E-03_JPRB, 0.38315933E-03_JPRB, 0.38318442E-03_JPRB, 0.38319667E-03_JPRB, &
  & 0.38314389E-03_JPRB, 0.38306436E-03_JPRB, 0.38288031E-03_JPRB, 0.38277634E-03_JPRB, 0.38273119E-03_JPRB, 0.38273066E-03_JPRB, &
  & 0.38268551E-03_JPRB, 0.38243863E-03_JPRB, 0.38214085E-03_JPRB, 0.38185201E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART4',0,ZHOOK_HANDLE)



RGHG1(:,46, 2) = (/ &
  & 0.38952584E-03_JPRB, 0.39039785E-03_JPRB, 0.39018918E-03_JPRB, 0.38938170E-03_JPRB, 0.38855266E-03_JPRB, 0.38771364E-03_JPRB, &
  & 0.38701604E-03_JPRB, 0.38676184E-03_JPRB, 0.38667879E-03_JPRB, 0.38666939E-03_JPRB, 0.38660769E-03_JPRB, 0.38636187E-03_JPRB, &
  & 0.38587317E-03_JPRB, 0.38526384E-03_JPRB, 0.38466257E-03_JPRB, 0.38410494E-03_JPRB, 0.38367369E-03_JPRB, 0.38344203E-03_JPRB, &
  & 0.38330388E-03_JPRB, 0.38317983E-03_JPRB, 0.38306151E-03_JPRB, 0.38310496E-03_JPRB, 0.38312242E-03_JPRB, 0.38323431E-03_JPRB, &
  & 0.38353402E-03_JPRB, 0.38408790E-03_JPRB, 0.38463367E-03_JPRB, 0.38500837E-03_JPRB, 0.38523651E-03_JPRB, 0.38559746E-03_JPRB, &
  & 0.38598316E-03_JPRB, 0.38620985E-03_JPRB, 0.38628803E-03_JPRB, 0.38621758E-03_JPRB, 0.38622534E-03_JPRB, 0.38613846E-03_JPRB, &
  & 0.38564779E-03_JPRB, 0.38512760E-03_JPRB, 0.38471817E-03_JPRB, 0.38444690E-03_JPRB, 0.38431430E-03_JPRB, 0.38429329E-03_JPRB, &
  & 0.38429438E-03_JPRB, 0.38412836E-03_JPRB, 0.38385353E-03_JPRB, 0.38351161E-03_JPRB, 0.38326948E-03_JPRB, 0.38325277E-03_JPRB, &
  & 0.38334735E-03_JPRB, 0.38350610E-03_JPRB, 0.38351342E-03_JPRB, 0.38367131E-03_JPRB, 0.38375433E-03_JPRB, 0.38381682E-03_JPRB, &
  & 0.38380632E-03_JPRB, 0.38375228E-03_JPRB, 0.38360046E-03_JPRB, 0.38350549E-03_JPRB, 0.38342551E-03_JPRB, 0.38345614E-03_JPRB, &
  & 0.38346796E-03_JPRB, 0.38332089E-03_JPRB, 0.38310753E-03_JPRB, 0.38280815E-03_JPRB  /)

RGHG1(:,47, 2) = (/ &
  & 0.39038291E-03_JPRB, 0.39117555E-03_JPRB, 0.39108472E-03_JPRB, 0.39007737E-03_JPRB, 0.38903442E-03_JPRB, 0.38795683E-03_JPRB, &
  & 0.38714549E-03_JPRB, 0.38679401E-03_JPRB, 0.38669495E-03_JPRB, 0.38679050E-03_JPRB, 0.38672022E-03_JPRB, 0.38643851E-03_JPRB, &
  & 0.38586732E-03_JPRB, 0.38515776E-03_JPRB, 0.38448394E-03_JPRB, 0.38389164E-03_JPRB, 0.38346715E-03_JPRB, 0.38320999E-03_JPRB, &
  & 0.38305021E-03_JPRB, 0.38292791E-03_JPRB, 0.38283941E-03_JPRB, 0.38292278E-03_JPRB, 0.38296421E-03_JPRB, 0.38314500E-03_JPRB, &
  & 0.38349653E-03_JPRB, 0.38405702E-03_JPRB, 0.38463086E-03_JPRB, 0.38502363E-03_JPRB, 0.38524736E-03_JPRB, 0.38559086E-03_JPRB, &
  & 0.38599773E-03_JPRB, 0.38622351E-03_JPRB, 0.38629964E-03_JPRB, 0.38624923E-03_JPRB, 0.38624848E-03_JPRB, 0.38619211E-03_JPRB, &
  & 0.38572443E-03_JPRB, 0.38519824E-03_JPRB, 0.38477083E-03_JPRB, 0.38446048E-03_JPRB, 0.38428190E-03_JPRB, 0.38424275E-03_JPRB, &
  & 0.38423861E-03_JPRB, 0.38405581E-03_JPRB, 0.38378228E-03_JPRB, 0.38347807E-03_JPRB, 0.38330720E-03_JPRB, 0.38339800E-03_JPRB, &
  & 0.38363114E-03_JPRB, 0.38389832E-03_JPRB, 0.38399799E-03_JPRB, 0.38423662E-03_JPRB, 0.38438528E-03_JPRB, 0.38450877E-03_JPRB, &
  & 0.38455161E-03_JPRB, 0.38452543E-03_JPRB, 0.38441550E-03_JPRB, 0.38432728E-03_JPRB, 0.38419972E-03_JPRB, 0.38426168E-03_JPRB, &
  & 0.38433436E-03_JPRB, 0.38430833E-03_JPRB, 0.38419710E-03_JPRB, 0.38390568E-03_JPRB  /)

RGHG1(:,48, 2) = (/ &
  & 0.39085278E-03_JPRB, 0.39138914E-03_JPRB, 0.39136267E-03_JPRB, 0.39026380E-03_JPRB, 0.38903251E-03_JPRB, 0.38778941E-03_JPRB, &
  & 0.38684694E-03_JPRB, 0.38647253E-03_JPRB, 0.38636228E-03_JPRB, 0.38653110E-03_JPRB, 0.38650255E-03_JPRB, 0.38621463E-03_JPRB, &
  & 0.38561126E-03_JPRB, 0.38488154E-03_JPRB, 0.38420217E-03_JPRB, 0.38362969E-03_JPRB, 0.38324365E-03_JPRB, 0.38298974E-03_JPRB, &
  & 0.38284047E-03_JPRB, 0.38273847E-03_JPRB, 0.38268273E-03_JPRB, 0.38278599E-03_JPRB, 0.38284846E-03_JPRB, 0.38307214E-03_JPRB, &
  & 0.38345800E-03_JPRB, 0.38401677E-03_JPRB, 0.38462955E-03_JPRB, 0.38503300E-03_JPRB, 0.38526433E-03_JPRB, 0.38559019E-03_JPRB, &
  & 0.38600601E-03_JPRB, 0.38624264E-03_JPRB, 0.38632525E-03_JPRB, 0.38629682E-03_JPRB, 0.38627491E-03_JPRB, 0.38620887E-03_JPRB, &
  & 0.38573976E-03_JPRB, 0.38522125E-03_JPRB, 0.38480067E-03_JPRB, 0.38448089E-03_JPRB, 0.38428478E-03_JPRB, 0.38421498E-03_JPRB, &
  & 0.38417626E-03_JPRB, 0.38397881E-03_JPRB, 0.38371318E-03_JPRB, 0.38344268E-03_JPRB, 0.38332400E-03_JPRB, 0.38350778E-03_JPRB, &
  & 0.38384023E-03_JPRB, 0.38419979E-03_JPRB, 0.38435850E-03_JPRB, 0.38463120E-03_JPRB, 0.38482393E-03_JPRB, 0.38499500E-03_JPRB, &
  & 0.38507326E-03_JPRB, 0.38506540E-03_JPRB, 0.38501019E-03_JPRB, 0.38494408E-03_JPRB, 0.38479125E-03_JPRB, 0.38485431E-03_JPRB, &
  & 0.38496948E-03_JPRB, 0.38504049E-03_JPRB, 0.38499125E-03_JPRB, 0.38475106E-03_JPRB  /)

RGHG1(:,49, 2) = (/ &
  & 0.39119708E-03_JPRB, 0.39136921E-03_JPRB, 0.39138970E-03_JPRB, 0.39023872E-03_JPRB, 0.38881048E-03_JPRB, 0.38741731E-03_JPRB, &
  & 0.38632173E-03_JPRB, 0.38595574E-03_JPRB, 0.38583529E-03_JPRB, 0.38607084E-03_JPRB, 0.38611137E-03_JPRB, 0.38583007E-03_JPRB, &
  & 0.38521393E-03_JPRB, 0.38449831E-03_JPRB, 0.38384323E-03_JPRB, 0.38331748E-03_JPRB, 0.38298845E-03_JPRB, 0.38275120E-03_JPRB, &
  & 0.38262818E-03_JPRB, 0.38255709E-03_JPRB, 0.38253897E-03_JPRB, 0.38265516E-03_JPRB, 0.38273959E-03_JPRB, 0.38299894E-03_JPRB, &
  & 0.38341486E-03_JPRB, 0.38396794E-03_JPRB, 0.38462877E-03_JPRB, 0.38504071E-03_JPRB, 0.38528590E-03_JPRB, 0.38559213E-03_JPRB, &
  & 0.38601232E-03_JPRB, 0.38626632E-03_JPRB, 0.38635999E-03_JPRB, 0.38635679E-03_JPRB, 0.38630567E-03_JPRB, 0.38621066E-03_JPRB, &
  & 0.38572886E-03_JPRB, 0.38522506E-03_JPRB, 0.38482333E-03_JPRB, 0.38450659E-03_JPRB, 0.38430402E-03_JPRB, 0.38419458E-03_JPRB, &
  & 0.38410422E-03_JPRB, 0.38389151E-03_JPRB, 0.38363764E-03_JPRB, 0.38340266E-03_JPRB, 0.38333312E-03_JPRB, 0.38361322E-03_JPRB, &
  & 0.38403780E-03_JPRB, 0.38449238E-03_JPRB, 0.38470131E-03_JPRB, 0.38499052E-03_JPRB, 0.38522227E-03_JPRB, 0.38543991E-03_JPRB, &
  & 0.38554925E-03_JPRB, 0.38555735E-03_JPRB, 0.38556857E-03_JPRB, 0.38553392E-03_JPRB, 0.38536326E-03_JPRB, 0.38541378E-03_JPRB, &
  & 0.38556766E-03_JPRB, 0.38573524E-03_JPRB, 0.38573638E-03_JPRB, 0.38557259E-03_JPRB  /)

RGHG1(:,50, 2) = (/ &
  & 0.39075692E-03_JPRB, 0.39071665E-03_JPRB, 0.39074557E-03_JPRB, 0.38958874E-03_JPRB, 0.38809426E-03_JPRB, 0.38669321E-03_JPRB, &
  & 0.38559757E-03_JPRB, 0.38524349E-03_JPRB, 0.38512081E-03_JPRB, 0.38536827E-03_JPRB, 0.38549410E-03_JPRB, 0.38526366E-03_JPRB, &
  & 0.38470615E-03_JPRB, 0.38406878E-03_JPRB, 0.38349489E-03_JPRB, 0.38304739E-03_JPRB, 0.38278154E-03_JPRB, 0.38257814E-03_JPRB, &
  & 0.38247868E-03_JPRB, 0.38242894E-03_JPRB, 0.38243815E-03_JPRB, 0.38255502E-03_JPRB, 0.38265215E-03_JPRB, 0.38292869E-03_JPRB, &
  & 0.38336329E-03_JPRB, 0.38391330E-03_JPRB, 0.38460948E-03_JPRB, 0.38505325E-03_JPRB, 0.38530216E-03_JPRB, 0.38560654E-03_JPRB, &
  & 0.38603341E-03_JPRB, 0.38630858E-03_JPRB, 0.38641381E-03_JPRB, 0.38642686E-03_JPRB, 0.38637981E-03_JPRB, 0.38621864E-03_JPRB, &
  & 0.38572200E-03_JPRB, 0.38521416E-03_JPRB, 0.38481854E-03_JPRB, 0.38453382E-03_JPRB, 0.38434230E-03_JPRB, 0.38420025E-03_JPRB, &
  & 0.38407732E-03_JPRB, 0.38386423E-03_JPRB, 0.38362827E-03_JPRB, 0.38342413E-03_JPRB, 0.38338696E-03_JPRB, 0.38372171E-03_JPRB, &
  & 0.38419413E-03_JPRB, 0.38467705E-03_JPRB, 0.38490084E-03_JPRB, 0.38518811E-03_JPRB, 0.38542093E-03_JPRB, 0.38564514E-03_JPRB, &
  & 0.38576884E-03_JPRB, 0.38579553E-03_JPRB, 0.38586208E-03_JPRB, 0.38585604E-03_JPRB, 0.38570982E-03_JPRB, 0.38574930E-03_JPRB, &
  & 0.38591776E-03_JPRB, 0.38616627E-03_JPRB, 0.38616319E-03_JPRB, 0.38608598E-03_JPRB  /)

RGHG1(:,51, 2) = (/ &
  & 0.38986849E-03_JPRB, 0.38967829E-03_JPRB, 0.38969606E-03_JPRB, 0.38855720E-03_JPRB, 0.38705980E-03_JPRB, 0.38572497E-03_JPRB, &
  & 0.38470970E-03_JPRB, 0.38437035E-03_JPRB, 0.38424946E-03_JPRB, 0.38448098E-03_JPRB, 0.38470760E-03_JPRB, 0.38455542E-03_JPRB, &
  & 0.38409887E-03_JPRB, 0.38357986E-03_JPRB, 0.38312369E-03_JPRB, 0.38277738E-03_JPRB, 0.38258312E-03_JPRB, 0.38242536E-03_JPRB, &
  & 0.38234998E-03_JPRB, 0.38231830E-03_JPRB, 0.38235167E-03_JPRB, 0.38246285E-03_JPRB, 0.38256885E-03_JPRB, 0.38285425E-03_JPRB, &
  & 0.38330309E-03_JPRB, 0.38385115E-03_JPRB, 0.38457889E-03_JPRB, 0.38506936E-03_JPRB, 0.38531697E-03_JPRB, 0.38562866E-03_JPRB, &
  & 0.38606400E-03_JPRB, 0.38636406E-03_JPRB, 0.38648206E-03_JPRB, 0.38650797E-03_JPRB, 0.38648280E-03_JPRB, 0.38623052E-03_JPRB, &
  & 0.38571671E-03_JPRB, 0.38519464E-03_JPRB, 0.38479894E-03_JPRB, 0.38456408E-03_JPRB, 0.38439371E-03_JPRB, 0.38422010E-03_JPRB, &
  & 0.38407195E-03_JPRB, 0.38386626E-03_JPRB, 0.38365292E-03_JPRB, 0.38347970E-03_JPRB, 0.38346872E-03_JPRB, 0.38384064E-03_JPRB, &
  & 0.38434154E-03_JPRB, 0.38482006E-03_JPRB, 0.38504133E-03_JPRB, 0.38531681E-03_JPRB, 0.38553083E-03_JPRB, 0.38574113E-03_JPRB, &
  & 0.38587159E-03_JPRB, 0.38591975E-03_JPRB, 0.38604032E-03_JPRB, 0.38606373E-03_JPRB, 0.38596615E-03_JPRB, 0.38599450E-03_JPRB, &
  & 0.38616604E-03_JPRB, 0.38649387E-03_JPRB, 0.38645752E-03_JPRB, 0.38647931E-03_JPRB  /)

RGHG1(:,52, 2) = (/ &
  & 0.38839087E-03_JPRB, 0.38813933E-03_JPRB, 0.38812944E-03_JPRB, 0.38716545E-03_JPRB, 0.38582500E-03_JPRB, 0.38465063E-03_JPRB, &
  & 0.38379579E-03_JPRB, 0.38352351E-03_JPRB, 0.38343088E-03_JPRB, 0.38368089E-03_JPRB, 0.38394850E-03_JPRB, 0.38388379E-03_JPRB, &
  & 0.38352932E-03_JPRB, 0.38313442E-03_JPRB, 0.38278781E-03_JPRB, 0.38254295E-03_JPRB, 0.38241587E-03_JPRB, 0.38229565E-03_JPRB, &
  & 0.38224150E-03_JPRB, 0.38222962E-03_JPRB, 0.38226837E-03_JPRB, 0.38236507E-03_JPRB, 0.38247179E-03_JPRB, 0.38276504E-03_JPRB, &
  & 0.38321952E-03_JPRB, 0.38377691E-03_JPRB, 0.38449990E-03_JPRB, 0.38505970E-03_JPRB, 0.38533039E-03_JPRB, 0.38564455E-03_JPRB, &
  & 0.38609004E-03_JPRB, 0.38642185E-03_JPRB, 0.38657855E-03_JPRB, 0.38659732E-03_JPRB, 0.38657420E-03_JPRB, 0.38622281E-03_JPRB, &
  & 0.38568973E-03_JPRB, 0.38517111E-03_JPRB, 0.38480390E-03_JPRB, 0.38458704E-03_JPRB, 0.38443116E-03_JPRB, 0.38424523E-03_JPRB, &
  & 0.38410206E-03_JPRB, 0.38390981E-03_JPRB, 0.38371661E-03_JPRB, 0.38357100E-03_JPRB, 0.38357135E-03_JPRB, 0.38394791E-03_JPRB, &
  & 0.38445391E-03_JPRB, 0.38490784E-03_JPRB, 0.38509927E-03_JPRB, 0.38536307E-03_JPRB, 0.38555335E-03_JPRB, 0.38573436E-03_JPRB, &
  & 0.38584138E-03_JPRB, 0.38591953E-03_JPRB, 0.38605688E-03_JPRB, 0.38609497E-03_JPRB, 0.38606316E-03_JPRB, 0.38612838E-03_JPRB, &
  & 0.38630163E-03_JPRB, 0.38668060E-03_JPRB, 0.38653345E-03_JPRB, 0.38666043E-03_JPRB  /)

RGHG1(:,53, 2) = (/ &
  & 0.38655509E-03_JPRB, 0.38627085E-03_JPRB, 0.38622447E-03_JPRB, 0.38551128E-03_JPRB, 0.38440324E-03_JPRB, 0.38343987E-03_JPRB, &
  & 0.38279054E-03_JPRB, 0.38261143E-03_JPRB, 0.38255975E-03_JPRB, 0.38284315E-03_JPRB, 0.38313240E-03_JPRB, 0.38316650E-03_JPRB, &
  & 0.38292362E-03_JPRB, 0.38266606E-03_JPRB, 0.38243565E-03_JPRB, 0.38230135E-03_JPRB, 0.38224573E-03_JPRB, 0.38216329E-03_JPRB, &
  & 0.38213115E-03_JPRB, 0.38214151E-03_JPRB, 0.38217888E-03_JPRB, 0.38225644E-03_JPRB, 0.38236079E-03_JPRB, 0.38266220E-03_JPRB, &
  & 0.38311951E-03_JPRB, 0.38369141E-03_JPRB, 0.38439526E-03_JPRB, 0.38503927E-03_JPRB, 0.38534447E-03_JPRB, 0.38565944E-03_JPRB, &
  & 0.38611666E-03_JPRB, 0.38648568E-03_JPRB, 0.38669448E-03_JPRB, 0.38669780E-03_JPRB, 0.38666927E-03_JPRB, 0.38620689E-03_JPRB, &
  & 0.38565200E-03_JPRB, 0.38514394E-03_JPRB, 0.38481875E-03_JPRB, 0.38460923E-03_JPRB, 0.38446657E-03_JPRB, 0.38427464E-03_JPRB, &
  & 0.38414850E-03_JPRB, 0.38397320E-03_JPRB, 0.38380100E-03_JPRB, 0.38368419E-03_JPRB, 0.38369114E-03_JPRB, 0.38406024E-03_JPRB, &
  & 0.38456280E-03_JPRB, 0.38498218E-03_JPRB, 0.38513060E-03_JPRB, 0.38538174E-03_JPRB, 0.38554425E-03_JPRB, 0.38568745E-03_JPRB, &
  & 0.38575734E-03_JPRB, 0.38587142E-03_JPRB, 0.38601271E-03_JPRB, 0.38606110E-03_JPRB, 0.38610750E-03_JPRB, 0.38623134E-03_JPRB, &
  & 0.38640593E-03_JPRB, 0.38682975E-03_JPRB, 0.38653212E-03_JPRB, 0.38677602E-03_JPRB  /)

RGHG1(:,54, 2) = (/ &
  & 0.38494126E-03_JPRB, 0.38463605E-03_JPRB, 0.38454928E-03_JPRB, 0.38401149E-03_JPRB, 0.38325079E-03_JPRB, 0.38251141E-03_JPRB, &
  & 0.38207660E-03_JPRB, 0.38201215E-03_JPRB, 0.38204249E-03_JPRB, 0.38232393E-03_JPRB, 0.38259563E-03_JPRB, 0.38267115E-03_JPRB, &
  & 0.38249341E-03_JPRB, 0.38232010E-03_JPRB, 0.38215644E-03_JPRB, 0.38209671E-03_JPRB, 0.38208245E-03_JPRB, 0.38202165E-03_JPRB, &
  & 0.38201849E-03_JPRB, 0.38205054E-03_JPRB, 0.38208277E-03_JPRB, 0.38214632E-03_JPRB, 0.38225332E-03_JPRB, 0.38254148E-03_JPRB, &
  & 0.38299057E-03_JPRB, 0.38359054E-03_JPRB, 0.38428883E-03_JPRB, 0.38495170E-03_JPRB, 0.38533721E-03_JPRB, 0.38568443E-03_JPRB, &
  & 0.38616394E-03_JPRB, 0.38656062E-03_JPRB, 0.38679979E-03_JPRB, 0.38678685E-03_JPRB, 0.38670240E-03_JPRB, 0.38616871E-03_JPRB, &
  & 0.38557829E-03_JPRB, 0.38513403E-03_JPRB, 0.38486038E-03_JPRB, 0.38464264E-03_JPRB, 0.38449139E-03_JPRB, 0.38430513E-03_JPRB, &
  & 0.38418695E-03_JPRB, 0.38403575E-03_JPRB, 0.38389278E-03_JPRB, 0.38381331E-03_JPRB, 0.38383516E-03_JPRB, 0.38420853E-03_JPRB, &
  & 0.38469286E-03_JPRB, 0.38509620E-03_JPRB, 0.38523491E-03_JPRB, 0.38546916E-03_JPRB, 0.38562641E-03_JPRB, 0.38577158E-03_JPRB, &
  & 0.38582258E-03_JPRB, 0.38596983E-03_JPRB, 0.38610427E-03_JPRB, 0.38618241E-03_JPRB, 0.38625511E-03_JPRB, 0.38637511E-03_JPRB, &
  & 0.38658640E-03_JPRB, 0.38697776E-03_JPRB, 0.38662403E-03_JPRB, 0.38679633E-03_JPRB  /)

RGHG1(:,55, 2) = (/ &
  & 0.38318272E-03_JPRB, 0.38285584E-03_JPRB, 0.38272380E-03_JPRB, 0.38237040E-03_JPRB, 0.38200959E-03_JPRB, 0.38152005E-03_JPRB, &
  & 0.38132404E-03_JPRB, 0.38138943E-03_JPRB, 0.38151605E-03_JPRB, 0.38179065E-03_JPRB, 0.38203776E-03_JPRB, 0.38215163E-03_JPRB, &
  & 0.38203992E-03_JPRB, 0.38195295E-03_JPRB, 0.38185674E-03_JPRB, 0.38187488E-03_JPRB, 0.38190248E-03_JPRB, 0.38186354E-03_JPRB, &
  & 0.38189340E-03_JPRB, 0.38194939E-03_JPRB, 0.38197543E-03_JPRB, 0.38202413E-03_JPRB, 0.38213474E-03_JPRB, 0.38240541E-03_JPRB, &
  & 0.38284393E-03_JPRB, 0.38347678E-03_JPRB, 0.38417070E-03_JPRB, 0.38484587E-03_JPRB, 0.38532638E-03_JPRB, 0.38571344E-03_JPRB, &
  & 0.38621905E-03_JPRB, 0.38664509E-03_JPRB, 0.38691505E-03_JPRB, 0.38688399E-03_JPRB, 0.38673095E-03_JPRB, 0.38612349E-03_JPRB, &
  & 0.38549190E-03_JPRB, 0.38512534E-03_JPRB, 0.38491002E-03_JPRB, 0.38468112E-03_JPRB, 0.38451748E-03_JPRB, 0.38433906E-03_JPRB, &
  & 0.38422848E-03_JPRB, 0.38410492E-03_JPRB, 0.38399543E-03_JPRB, 0.38395845E-03_JPRB, 0.38399787E-03_JPRB, 0.38437753E-03_JPRB, &
  & 0.38483973E-03_JPRB, 0.38522772E-03_JPRB, 0.38536005E-03_JPRB, 0.38557504E-03_JPRB, 0.38572942E-03_JPRB, 0.38588202E-03_JPRB, &
  & 0.38591448E-03_JPRB, 0.38609812E-03_JPRB, 0.38622354E-03_JPRB, 0.38633720E-03_JPRB, 0.38643222E-03_JPRB, 0.38653974E-03_JPRB, &
  & 0.38679634E-03_JPRB, 0.38714157E-03_JPRB, 0.38673811E-03_JPRB, 0.38680631E-03_JPRB  /)

RGHG1(:,56, 2) = (/ &
  & 0.38222858E-03_JPRB, 0.38194222E-03_JPRB, 0.38181389E-03_JPRB, 0.38156941E-03_JPRB, 0.38138659E-03_JPRB, 0.38108395E-03_JPRB, &
  & 0.38105231E-03_JPRB, 0.38117062E-03_JPRB, 0.38134900E-03_JPRB, 0.38159149E-03_JPRB, 0.38181931E-03_JPRB, 0.38191799E-03_JPRB, &
  & 0.38182496E-03_JPRB, 0.38175289E-03_JPRB, 0.38166984E-03_JPRB, 0.38170257E-03_JPRB, 0.38174594E-03_JPRB, 0.38171147E-03_JPRB, &
  & 0.38175791E-03_JPRB, 0.38183202E-03_JPRB, 0.38186340E-03_JPRB, 0.38193146E-03_JPRB, 0.38203986E-03_JPRB, 0.38228277E-03_JPRB, &
  & 0.38269451E-03_JPRB, 0.38333230E-03_JPRB, 0.38403221E-03_JPRB, 0.38474620E-03_JPRB, 0.38527474E-03_JPRB, 0.38574239E-03_JPRB, &
  & 0.38630697E-03_JPRB, 0.38673324E-03_JPRB, 0.38694626E-03_JPRB, 0.38686884E-03_JPRB, 0.38660740E-03_JPRB, 0.38599417E-03_JPRB, &
  & 0.38538426E-03_JPRB, 0.38508169E-03_JPRB, 0.38488155E-03_JPRB, 0.38467427E-03_JPRB, 0.38448817E-03_JPRB, 0.38433871E-03_JPRB, &
  & 0.38425752E-03_JPRB, 0.38417378E-03_JPRB, 0.38410853E-03_JPRB, 0.38410854E-03_JPRB, 0.38417397E-03_JPRB, 0.38459037E-03_JPRB, &
  & 0.38505310E-03_JPRB, 0.38543814E-03_JPRB, 0.38561133E-03_JPRB, 0.38583427E-03_JPRB, 0.38600262E-03_JPRB, 0.38619620E-03_JPRB, &
  & 0.38624604E-03_JPRB, 0.38644079E-03_JPRB, 0.38661732E-03_JPRB, 0.38674123E-03_JPRB, 0.38676938E-03_JPRB, 0.38690209E-03_JPRB, &
  & 0.38717793E-03_JPRB, 0.38750762E-03_JPRB, 0.38714255E-03_JPRB, 0.38721305E-03_JPRB  /)

RGHG1(:,57, 2) = (/ &
  & 0.38136121E-03_JPRB, 0.38112668E-03_JPRB, 0.38100545E-03_JPRB, 0.38085371E-03_JPRB, 0.38081842E-03_JPRB, 0.38068662E-03_JPRB, &
  & 0.38079918E-03_JPRB, 0.38096813E-03_JPRB, 0.38118743E-03_JPRB, 0.38140000E-03_JPRB, 0.38161085E-03_JPRB, 0.38169854E-03_JPRB, &
  & 0.38162508E-03_JPRB, 0.38156173E-03_JPRB, 0.38148530E-03_JPRB, 0.38153109E-03_JPRB, 0.38158582E-03_JPRB, 0.38155936E-03_JPRB, &
  & 0.38161491E-03_JPRB, 0.38170533E-03_JPRB, 0.38174695E-03_JPRB, 0.38183770E-03_JPRB, 0.38194335E-03_JPRB, 0.38216561E-03_JPRB, &
  & 0.38254451E-03_JPRB, 0.38318188E-03_JPRB, 0.38388725E-03_JPRB, 0.38464831E-03_JPRB, 0.38522579E-03_JPRB, 0.38577277E-03_JPRB, &
  & 0.38639079E-03_JPRB, 0.38680792E-03_JPRB, 0.38695537E-03_JPRB, 0.38681126E-03_JPRB, 0.38645868E-03_JPRB, 0.38584860E-03_JPRB, &
  & 0.38528267E-03_JPRB, 0.38503264E-03_JPRB, 0.38484992E-03_JPRB, 0.38466364E-03_JPRB, 0.38445972E-03_JPRB, 0.38433729E-03_JPRB, &
  & 0.38428135E-03_JPRB, 0.38424079E-03_JPRB, 0.38422606E-03_JPRB, 0.38426488E-03_JPRB, 0.38436158E-03_JPRB, 0.38481973E-03_JPRB, &
  & 0.38528897E-03_JPRB, 0.38567647E-03_JPRB, 0.38589330E-03_JPRB, 0.38612592E-03_JPRB, 0.38630815E-03_JPRB, 0.38653876E-03_JPRB, &
  & 0.38660540E-03_JPRB, 0.38681720E-03_JPRB, 0.38704047E-03_JPRB, 0.38717019E-03_JPRB, 0.38714312E-03_JPRB, 0.38729896E-03_JPRB, &
  & 0.38760790E-03_JPRB, 0.38791889E-03_JPRB, 0.38757234E-03_JPRB, 0.38763832E-03_JPRB  /)

RGHG1(:,58, 2) = (/ &
  & 0.38086100E-03_JPRB, 0.38070484E-03_JPRB, 0.38060507E-03_JPRB, 0.38049710E-03_JPRB, 0.38050445E-03_JPRB, 0.38049083E-03_JPRB, &
  & 0.38068800E-03_JPRB, 0.38088521E-03_JPRB, 0.38111548E-03_JPRB, 0.38129951E-03_JPRB, 0.38149967E-03_JPRB, 0.38157431E-03_JPRB, &
  & 0.38151144E-03_JPRB, 0.38143230E-03_JPRB, 0.38134075E-03_JPRB, 0.38138407E-03_JPRB, 0.38143692E-03_JPRB, 0.38142058E-03_JPRB, &
  & 0.38146875E-03_JPRB, 0.38157004E-03_JPRB, 0.38163152E-03_JPRB, 0.38175516E-03_JPRB, 0.38185628E-03_JPRB, 0.38206965E-03_JPRB, &
  & 0.38240506E-03_JPRB, 0.38302778E-03_JPRB, 0.38373920E-03_JPRB, 0.38456246E-03_JPRB, 0.38517767E-03_JPRB, 0.38580312E-03_JPRB, &
  & 0.38646708E-03_JPRB, 0.38685452E-03_JPRB, 0.38691065E-03_JPRB, 0.38666557E-03_JPRB, 0.38625088E-03_JPRB, 0.38567153E-03_JPRB, &
  & 0.38519550E-03_JPRB, 0.38497185E-03_JPRB, 0.38480086E-03_JPRB, 0.38463896E-03_JPRB, 0.38442465E-03_JPRB, 0.38432774E-03_JPRB, &
  & 0.38429213E-03_JPRB, 0.38429921E-03_JPRB, 0.38434357E-03_JPRB, 0.38442011E-03_JPRB, 0.38455605E-03_JPRB, 0.38506677E-03_JPRB, &
  & 0.38555633E-03_JPRB, 0.38595753E-03_JPRB, 0.38622807E-03_JPRB, 0.38647761E-03_JPRB, 0.38667563E-03_JPRB, 0.38693989E-03_JPRB, &
  & 0.38702771E-03_JPRB, 0.38726050E-03_JPRB, 0.38753066E-03_JPRB, 0.38765348E-03_JPRB, 0.38757858E-03_JPRB, 0.38775928E-03_JPRB, &
  & 0.38811719E-03_JPRB, 0.38841135E-03_JPRB, 0.38806480E-03_JPRB, 0.38813503E-03_JPRB  /)

RGHG1(:,59, 2) = (/ &
  & 0.38068183E-03_JPRB, 0.38059379E-03_JPRB, 0.38051460E-03_JPRB, 0.38041165E-03_JPRB, 0.38040783E-03_JPRB, 0.38044036E-03_JPRB, &
  & 0.38066546E-03_JPRB, 0.38087069E-03_JPRB, 0.38109695E-03_JPRB, 0.38125248E-03_JPRB, 0.38143999E-03_JPRB, 0.38150177E-03_JPRB, &
  & 0.38144464E-03_JPRB, 0.38134304E-03_JPRB, 0.38123161E-03_JPRB, 0.38126298E-03_JPRB, 0.38130694E-03_JPRB, 0.38130334E-03_JPRB, &
  & 0.38133729E-03_JPRB, 0.38144791E-03_JPRB, 0.38152525E-03_JPRB, 0.38167842E-03_JPRB, 0.38179380E-03_JPRB, 0.38199531E-03_JPRB, &
  & 0.38229714E-03_JPRB, 0.38285980E-03_JPRB, 0.38359012E-03_JPRB, 0.38446065E-03_JPRB, 0.38513602E-03_JPRB, 0.38580731E-03_JPRB, &
  & 0.38649156E-03_JPRB, 0.38684246E-03_JPRB, 0.38684288E-03_JPRB, 0.38652689E-03_JPRB, 0.38607618E-03_JPRB, 0.38552555E-03_JPRB, &
  & 0.38511788E-03_JPRB, 0.38490651E-03_JPRB, 0.38474783E-03_JPRB, 0.38461175E-03_JPRB, 0.38440635E-03_JPRB, 0.38431865E-03_JPRB, &
  & 0.38429579E-03_JPRB, 0.38434815E-03_JPRB, 0.38444996E-03_JPRB, 0.38456202E-03_JPRB, 0.38475018E-03_JPRB, 0.38531608E-03_JPRB, &
  & 0.38583498E-03_JPRB, 0.38625756E-03_JPRB, 0.38655690E-03_JPRB, 0.38682484E-03_JPRB, 0.38704613E-03_JPRB, 0.38732336E-03_JPRB, &
  & 0.38743895E-03_JPRB, 0.38769081E-03_JPRB, 0.38797957E-03_JPRB, 0.38810802E-03_JPRB, 0.38801502E-03_JPRB, 0.38821608E-03_JPRB, &
  & 0.38861099E-03_JPRB, 0.38890395E-03_JPRB, 0.38857450E-03_JPRB, 0.38863407E-03_JPRB  /)

RGHG1(:,60, 2) = (/ &
  & 0.38064264E-03_JPRB, 0.38061492E-03_JPRB, 0.38055357E-03_JPRB, 0.38044267E-03_JPRB, 0.38040566E-03_JPRB, 0.38045201E-03_JPRB, &
  & 0.38068186E-03_JPRB, 0.38088799E-03_JPRB, 0.38110416E-03_JPRB, 0.38123026E-03_JPRB, 0.38140282E-03_JPRB, 0.38145186E-03_JPRB, &
  & 0.38139585E-03_JPRB, 0.38126949E-03_JPRB, 0.38113797E-03_JPRB, 0.38115216E-03_JPRB, 0.38118419E-03_JPRB, 0.38119152E-03_JPRB, &
  & 0.38121202E-03_JPRB, 0.38133003E-03_JPRB, 0.38142349E-03_JPRB, 0.38160270E-03_JPRB, 0.38173915E-03_JPRB, 0.38192711E-03_JPRB, &
  & 0.38220306E-03_JPRB, 0.38269600E-03_JPRB, 0.38344182E-03_JPRB, 0.38434754E-03_JPRB, 0.38509544E-03_JPRB, 0.38580098E-03_JPRB, &
  & 0.38649106E-03_JPRB, 0.38680525E-03_JPRB, 0.38676531E-03_JPRB, 0.38639736E-03_JPRB, 0.38592511E-03_JPRB, 0.38540178E-03_JPRB, &
  & 0.38504686E-03_JPRB, 0.38483934E-03_JPRB, 0.38468985E-03_JPRB, 0.38457914E-03_JPRB, 0.38438890E-03_JPRB, 0.38430736E-03_JPRB, &
  & 0.38429671E-03_JPRB, 0.38439679E-03_JPRB, 0.38455534E-03_JPRB, 0.38470328E-03_JPRB, 0.38495515E-03_JPRB, 0.38557516E-03_JPRB, &
  & 0.38612721E-03_JPRB, 0.38657518E-03_JPRB, 0.38689165E-03_JPRB, 0.38717877E-03_JPRB, 0.38742509E-03_JPRB, 0.38770675E-03_JPRB, &
  & 0.38785173E-03_JPRB, 0.38812129E-03_JPRB, 0.38841863E-03_JPRB, 0.38856010E-03_JPRB, 0.38846788E-03_JPRB, 0.38868716E-03_JPRB, &
  & 0.38910870E-03_JPRB, 0.38940595E-03_JPRB, 0.38910470E-03_JPRB, 0.38915160E-03_JPRB  /)

RGHG1(:,61, 2) = (/ &
  & 0.38077395E-03_JPRB, 0.38077801E-03_JPRB, 0.38072158E-03_JPRB, 0.38060022E-03_JPRB, 0.38051370E-03_JPRB, 0.38053105E-03_JPRB, &
  & 0.38074224E-03_JPRB, 0.38094570E-03_JPRB, 0.38114752E-03_JPRB, 0.38124502E-03_JPRB, 0.38139820E-03_JPRB, 0.38143680E-03_JPRB, &
  & 0.38136899E-03_JPRB, 0.38122090E-03_JPRB, 0.38107769E-03_JPRB, 0.38106821E-03_JPRB, 0.38108671E-03_JPRB, 0.38109239E-03_JPRB, &
  & 0.38111351E-03_JPRB, 0.38123172E-03_JPRB, 0.38134487E-03_JPRB, 0.38153597E-03_JPRB, 0.38169405E-03_JPRB, 0.38186755E-03_JPRB, &
  & 0.38214063E-03_JPRB, 0.38259329E-03_JPRB, 0.38332189E-03_JPRB, 0.38422679E-03_JPRB, 0.38505751E-03_JPRB, 0.38578591E-03_JPRB, &
  & 0.38645436E-03_JPRB, 0.38674580E-03_JPRB, 0.38668945E-03_JPRB, 0.38631720E-03_JPRB, 0.38585284E-03_JPRB, 0.38534919E-03_JPRB, &
  & 0.38500206E-03_JPRB, 0.38478132E-03_JPRB, 0.38462599E-03_JPRB, 0.38453291E-03_JPRB, 0.38435640E-03_JPRB, 0.38428829E-03_JPRB, &
  & 0.38429538E-03_JPRB, 0.38444845E-03_JPRB, 0.38465375E-03_JPRB, 0.38483612E-03_JPRB, 0.38517185E-03_JPRB, 0.38582958E-03_JPRB, &
  & 0.38641361E-03_JPRB, 0.38688957E-03_JPRB, 0.38720430E-03_JPRB, 0.38750884E-03_JPRB, 0.38777392E-03_JPRB, 0.38805066E-03_JPRB, &
  & 0.38821850E-03_JPRB, 0.38849974E-03_JPRB, 0.38879924E-03_JPRB, 0.38896592E-03_JPRB, 0.38891379E-03_JPRB, 0.38914537E-03_JPRB, &
  & 0.38956198E-03_JPRB, 0.38986549E-03_JPRB, 0.38961149E-03_JPRB, 0.38965849E-03_JPRB  /)

RGHG1(:,62, 2) = (/ &
  & 0.38096993E-03_JPRB, 0.38099669E-03_JPRB, 0.38093607E-03_JPRB, 0.38080158E-03_JPRB, 0.38065782E-03_JPRB, 0.38063552E-03_JPRB, &
  & 0.38082321E-03_JPRB, 0.38102506E-03_JPRB, 0.38120865E-03_JPRB, 0.38127991E-03_JPRB, 0.38140976E-03_JPRB, 0.38143878E-03_JPRB, &
  & 0.38135797E-03_JPRB, 0.38119110E-03_JPRB, 0.38103743E-03_JPRB, 0.38100373E-03_JPRB, 0.38100971E-03_JPRB, 0.38100339E-03_JPRB, &
  & 0.38103478E-03_JPRB, 0.38115161E-03_JPRB, 0.38127945E-03_JPRB, 0.38147644E-03_JPRB, 0.38164007E-03_JPRB, 0.38181831E-03_JPRB, &
  & 0.38208942E-03_JPRB, 0.38253246E-03_JPRB, 0.38322651E-03_JPRB, 0.38411296E-03_JPRB, 0.38502581E-03_JPRB, 0.38579009E-03_JPRB, &
  & 0.38643060E-03_JPRB, 0.38670243E-03_JPRB, 0.38663265E-03_JPRB, 0.38628388E-03_JPRB, 0.38582850E-03_JPRB, 0.38532893E-03_JPRB, &
  & 0.38496669E-03_JPRB, 0.38474422E-03_JPRB, 0.38458157E-03_JPRB, 0.38448445E-03_JPRB, 0.38432363E-03_JPRB, 0.38427181E-03_JPRB, &
  & 0.38430994E-03_JPRB, 0.38451079E-03_JPRB, 0.38475605E-03_JPRB, 0.38497723E-03_JPRB, 0.38540548E-03_JPRB, 0.38609106E-03_JPRB, &
  & 0.38669170E-03_JPRB, 0.38719547E-03_JPRB, 0.38750840E-03_JPRB, 0.38782933E-03_JPRB, 0.38810967E-03_JPRB, 0.38838498E-03_JPRB, &
  & 0.38856722E-03_JPRB, 0.38885346E-03_JPRB, 0.38914827E-03_JPRB, 0.38934895E-03_JPRB, 0.38936025E-03_JPRB, 0.38959823E-03_JPRB, &
  & 0.39000483E-03_JPRB, 0.39030091E-03_JPRB, 0.39007032E-03_JPRB, 0.39013617E-03_JPRB  /)

RGHG1(:,63, 2) = (/ &
  & 0.38120232E-03_JPRB, 0.38124809E-03_JPRB, 0.38117763E-03_JPRB, 0.38102542E-03_JPRB, 0.38082269E-03_JPRB, 0.38075663E-03_JPRB, &
  & 0.38091705E-03_JPRB, 0.38111676E-03_JPRB, 0.38127978E-03_JPRB, 0.38132850E-03_JPRB, 0.38143235E-03_JPRB, 0.38145147E-03_JPRB, &
  & 0.38135979E-03_JPRB, 0.38117628E-03_JPRB, 0.38100944E-03_JPRB, 0.38095231E-03_JPRB, 0.38094572E-03_JPRB, 0.38092186E-03_JPRB, &
  & 0.38096567E-03_JPRB, 0.38108159E-03_JPRB, 0.38122095E-03_JPRB, 0.38142419E-03_JPRB, 0.38158500E-03_JPRB, 0.38177805E-03_JPRB, &
  & 0.38204734E-03_JPRB, 0.38248885E-03_JPRB, 0.38314302E-03_JPRB, 0.38400783E-03_JPRB, 0.38499526E-03_JPRB, 0.38580039E-03_JPRB, &
  & 0.38642033E-03_JPRB, 0.38667685E-03_JPRB, 0.38659693E-03_JPRB, 0.38627902E-03_JPRB, 0.38583037E-03_JPRB, 0.38531831E-03_JPRB, &
  & 0.38493220E-03_JPRB, 0.38471989E-03_JPRB, 0.38455577E-03_JPRB, 0.38444296E-03_JPRB, 0.38430184E-03_JPRB, 0.38426957E-03_JPRB, &
  & 0.38434527E-03_JPRB, 0.38458795E-03_JPRB, 0.38486894E-03_JPRB, 0.38513206E-03_JPRB, 0.38565589E-03_JPRB, 0.38636289E-03_JPRB, &
  & 0.38696825E-03_JPRB, 0.38749845E-03_JPRB, 0.38781143E-03_JPRB, 0.38814641E-03_JPRB, 0.38844332E-03_JPRB, 0.38871788E-03_JPRB, &
  & 0.38891369E-03_JPRB, 0.38919834E-03_JPRB, 0.38948245E-03_JPRB, 0.38972003E-03_JPRB, 0.38980543E-03_JPRB, 0.39004802E-03_JPRB, &
  & 0.39044813E-03_JPRB, 0.39072266E-03_JPRB, 0.39050089E-03_JPRB, 0.39058582E-03_JPRB  /)

RGHG1(:,64, 2) = (/ &
  & 0.38144997E-03_JPRB, 0.38151413E-03_JPRB, 0.38142943E-03_JPRB, 0.38125155E-03_JPRB, 0.38099579E-03_JPRB, 0.38088836E-03_JPRB, &
  & 0.38101818E-03_JPRB, 0.38121340E-03_JPRB, 0.38135478E-03_JPRB, 0.38138871E-03_JPRB, 0.38146498E-03_JPRB, 0.38147289E-03_JPRB, &
  & 0.38137728E-03_JPRB, 0.38118009E-03_JPRB, 0.38099262E-03_JPRB, 0.38091542E-03_JPRB, 0.38089560E-03_JPRB, 0.38085179E-03_JPRB, &
  & 0.38090300E-03_JPRB, 0.38102082E-03_JPRB, 0.38116848E-03_JPRB, 0.38138473E-03_JPRB, 0.38153847E-03_JPRB, 0.38175114E-03_JPRB, &
  & 0.38201819E-03_JPRB, 0.38244692E-03_JPRB, 0.38306723E-03_JPRB, 0.38392139E-03_JPRB, 0.38496242E-03_JPRB, 0.38580577E-03_JPRB, &
  & 0.38643075E-03_JPRB, 0.38668011E-03_JPRB, 0.38659558E-03_JPRB, 0.38629718E-03_JPRB, 0.38584831E-03_JPRB, 0.38529903E-03_JPRB, &
  & 0.38489162E-03_JPRB, 0.38470688E-03_JPRB, 0.38455745E-03_JPRB, 0.38442278E-03_JPRB, 0.38430857E-03_JPRB, 0.38430029E-03_JPRB, &
  & 0.38441467E-03_JPRB, 0.38468807E-03_JPRB, 0.38499977E-03_JPRB, 0.38530650E-03_JPRB, 0.38592093E-03_JPRB, 0.38664261E-03_JPRB, &
  & 0.38723867E-03_JPRB, 0.38779095E-03_JPRB, 0.38810864E-03_JPRB, 0.38845236E-03_JPRB, 0.38877203E-03_JPRB, 0.38904401E-03_JPRB, &
  & 0.38925944E-03_JPRB, 0.38953299E-03_JPRB, 0.38979883E-03_JPRB, 0.39007016E-03_JPRB, 0.39022933E-03_JPRB, 0.39047797E-03_JPRB, &
  & 0.39088582E-03_JPRB, 0.39111853E-03_JPRB, 0.39089328E-03_JPRB, 0.39097788E-03_JPRB  /)

RGHG1(:,65, 2) = (/ &
  & 0.38168794E-03_JPRB, 0.38177584E-03_JPRB, 0.38166625E-03_JPRB, 0.38145843E-03_JPRB, 0.38116479E-03_JPRB, 0.38102934E-03_JPRB, &
  & 0.38112571E-03_JPRB, 0.38131161E-03_JPRB, 0.38144027E-03_JPRB, 0.38146763E-03_JPRB, 0.38151924E-03_JPRB, 0.38151064E-03_JPRB, &
  & 0.38141953E-03_JPRB, 0.38120856E-03_JPRB, 0.38099133E-03_JPRB, 0.38089652E-03_JPRB, 0.38086879E-03_JPRB, 0.38080863E-03_JPRB, &
  & 0.38085290E-03_JPRB, 0.38097274E-03_JPRB, 0.38113398E-03_JPRB, 0.38136270E-03_JPRB, 0.38151882E-03_JPRB, 0.38173342E-03_JPRB, &
  & 0.38199028E-03_JPRB, 0.38239006E-03_JPRB, 0.38299942E-03_JPRB, 0.38386779E-03_JPRB, 0.38492358E-03_JPRB, 0.38580764E-03_JPRB, &
  & 0.38643781E-03_JPRB, 0.38670310E-03_JPRB, 0.38661677E-03_JPRB, 0.38631235E-03_JPRB, 0.38585950E-03_JPRB, 0.38528628E-03_JPRB, &
  & 0.38486972E-03_JPRB, 0.38471256E-03_JPRB, 0.38459368E-03_JPRB, 0.38444293E-03_JPRB, 0.38435688E-03_JPRB, 0.38438133E-03_JPRB, &
  & 0.38453061E-03_JPRB, 0.38482078E-03_JPRB, 0.38515509E-03_JPRB, 0.38551588E-03_JPRB, 0.38620051E-03_JPRB, 0.38692060E-03_JPRB, &
  & 0.38751136E-03_JPRB, 0.38807765E-03_JPRB, 0.38841156E-03_JPRB, 0.38876076E-03_JPRB, 0.38909804E-03_JPRB, 0.38937504E-03_JPRB, &
  & 0.38961514E-03_JPRB, 0.38986697E-03_JPRB, 0.39011199E-03_JPRB, 0.39041263E-03_JPRB, 0.39061316E-03_JPRB, 0.39087667E-03_JPRB, &
  & 0.39130785E-03_JPRB, 0.39150438E-03_JPRB, 0.39128888E-03_JPRB, 0.39131856E-03_JPRB  /)

RGHG1(:,66, 2) = (/ &
  & 0.38191271E-03_JPRB, 0.38202500E-03_JPRB, 0.38188797E-03_JPRB, 0.38165114E-03_JPRB, 0.38132984E-03_JPRB, 0.38117475E-03_JPRB, &
  & 0.38124039E-03_JPRB, 0.38141078E-03_JPRB, 0.38153360E-03_JPRB, 0.38155711E-03_JPRB, 0.38158554E-03_JPRB, 0.38156264E-03_JPRB, &
  & 0.38147563E-03_JPRB, 0.38125475E-03_JPRB, 0.38100842E-03_JPRB, 0.38089530E-03_JPRB, 0.38085870E-03_JPRB, 0.38078647E-03_JPRB, &
  & 0.38081855E-03_JPRB, 0.38093927E-03_JPRB, 0.38110854E-03_JPRB, 0.38134697E-03_JPRB, 0.38151524E-03_JPRB, 0.38172031E-03_JPRB, &
  & 0.38196564E-03_JPRB, 0.38234273E-03_JPRB, 0.38294490E-03_JPRB, 0.38383200E-03_JPRB, 0.38488620E-03_JPRB, 0.38579478E-03_JPRB, &
  & 0.38643102E-03_JPRB, 0.38673203E-03_JPRB, 0.38665198E-03_JPRB, 0.38634483E-03_JPRB, 0.38589683E-03_JPRB, 0.38531295E-03_JPRB, &
  & 0.38489116E-03_JPRB, 0.38473804E-03_JPRB, 0.38464240E-03_JPRB, 0.38448846E-03_JPRB, 0.38442961E-03_JPRB, 0.38449061E-03_JPRB, &
  & 0.38467404E-03_JPRB, 0.38497936E-03_JPRB, 0.38533668E-03_JPRB, 0.38575593E-03_JPRB, 0.38648870E-03_JPRB, 0.38720122E-03_JPRB, &
  & 0.38779587E-03_JPRB, 0.38837134E-03_JPRB, 0.38872951E-03_JPRB, 0.38908214E-03_JPRB, 0.38943329E-03_JPRB, 0.38971825E-03_JPRB, &
  & 0.38997445E-03_JPRB, 0.39019877E-03_JPRB, 0.39042799E-03_JPRB, 0.39075258E-03_JPRB, 0.39097744E-03_JPRB, 0.39125860E-03_JPRB, &
  & 0.39171070E-03_JPRB, 0.39188455E-03_JPRB, 0.39167900E-03_JPRB, 0.39165117E-03_JPRB  /)

RGHG1(:,67, 2) = (/ &
  & 0.38211575E-03_JPRB, 0.38225048E-03_JPRB, 0.38208954E-03_JPRB, 0.38182699E-03_JPRB, 0.38148678E-03_JPRB, 0.38132129E-03_JPRB, &
  & 0.38135936E-03_JPRB, 0.38151060E-03_JPRB, 0.38163211E-03_JPRB, 0.38165303E-03_JPRB, 0.38166040E-03_JPRB, 0.38162756E-03_JPRB, &
  & 0.38154194E-03_JPRB, 0.38131814E-03_JPRB, 0.38104626E-03_JPRB, 0.38091353E-03_JPRB, 0.38086413E-03_JPRB, 0.38078469E-03_JPRB, &
  & 0.38080261E-03_JPRB, 0.38092139E-03_JPRB, 0.38109389E-03_JPRB, 0.38133788E-03_JPRB, 0.38152516E-03_JPRB, 0.38171278E-03_JPRB, &
  & 0.38194840E-03_JPRB, 0.38231100E-03_JPRB, 0.38290496E-03_JPRB, 0.38380413E-03_JPRB, 0.38485353E-03_JPRB, 0.38576655E-03_JPRB, &
  & 0.38640924E-03_JPRB, 0.38675362E-03_JPRB, 0.38669439E-03_JPRB, 0.38639829E-03_JPRB, 0.38596731E-03_JPRB, 0.38538655E-03_JPRB, &
  & 0.38496054E-03_JPRB, 0.38478793E-03_JPRB, 0.38470461E-03_JPRB, 0.38455989E-03_JPRB, 0.38452870E-03_JPRB, 0.38462802E-03_JPRB, &
  & 0.38484377E-03_JPRB, 0.38516417E-03_JPRB, 0.38554429E-03_JPRB, 0.38602343E-03_JPRB, 0.38678347E-03_JPRB, 0.38748510E-03_JPRB, &
  & 0.38809162E-03_JPRB, 0.38867376E-03_JPRB, 0.38905959E-03_JPRB, 0.38941640E-03_JPRB, 0.38977707E-03_JPRB, 0.39007049E-03_JPRB, &
  & 0.39032947E-03_JPRB, 0.39052439E-03_JPRB, 0.39074048E-03_JPRB, 0.39108711E-03_JPRB, 0.39132057E-03_JPRB, 0.39161825E-03_JPRB, &
  & 0.39208404E-03_JPRB, 0.39225016E-03_JPRB, 0.39205488E-03_JPRB, 0.39198005E-03_JPRB  /)

RGHG1(:,68, 2) = (/ &
  & 0.38228314E-03_JPRB, 0.38243398E-03_JPRB, 0.38226383E-03_JPRB, 0.38198240E-03_JPRB, 0.38162907E-03_JPRB, 0.38146473E-03_JPRB, &
  & 0.38147771E-03_JPRB, 0.38161191E-03_JPRB, 0.38173157E-03_JPRB, 0.38174904E-03_JPRB, 0.38173868E-03_JPRB, 0.38170308E-03_JPRB, &
  & 0.38161308E-03_JPRB, 0.38139896E-03_JPRB, 0.38110889E-03_JPRB, 0.38095428E-03_JPRB, 0.38088301E-03_JPRB, 0.38080196E-03_JPRB, &
  & 0.38080905E-03_JPRB, 0.38091978E-03_JPRB, 0.38109481E-03_JPRB, 0.38133788E-03_JPRB, 0.38154450E-03_JPRB, 0.38171347E-03_JPRB, &
  & 0.38194656E-03_JPRB, 0.38230202E-03_JPRB, 0.38288010E-03_JPRB, 0.38376476E-03_JPRB, 0.38483051E-03_JPRB, 0.38572419E-03_JPRB, &
  & 0.38637264E-03_JPRB, 0.38674234E-03_JPRB, 0.38673100E-03_JPRB, 0.38647634E-03_JPRB, 0.38607898E-03_JPRB, 0.38551548E-03_JPRB, &
  & 0.38508142E-03_JPRB, 0.38487150E-03_JPRB, 0.38478704E-03_JPRB, 0.38466097E-03_JPRB, 0.38466177E-03_JPRB, 0.38479817E-03_JPRB, &
  & 0.38504200E-03_JPRB, 0.38537852E-03_JPRB, 0.38577844E-03_JPRB, 0.38631445E-03_JPRB, 0.38708532E-03_JPRB, 0.38777658E-03_JPRB, &
  & 0.38839899E-03_JPRB, 0.38898988E-03_JPRB, 0.38939758E-03_JPRB, 0.38976521E-03_JPRB, 0.39012979E-03_JPRB, 0.39042782E-03_JPRB, &
  & 0.39066930E-03_JPRB, 0.39084028E-03_JPRB, 0.39103887E-03_JPRB, 0.39141382E-03_JPRB, 0.39164083E-03_JPRB, 0.39194680E-03_JPRB, &
  & 0.39241282E-03_JPRB, 0.39258677E-03_JPRB, 0.39240508E-03_JPRB, 0.39231091E-03_JPRB  /)

RGHG1(:,69, 2) = (/ &
  & 0.38239224E-03_JPRB, 0.38255919E-03_JPRB, 0.38240121E-03_JPRB, 0.38211201E-03_JPRB, 0.38175519E-03_JPRB, 0.38160144E-03_JPRB, &
  & 0.38159603E-03_JPRB, 0.38171655E-03_JPRB, 0.38182452E-03_JPRB, 0.38183728E-03_JPRB, 0.38181611E-03_JPRB, 0.38177900E-03_JPRB, &
  & 0.38168652E-03_JPRB, 0.38148981E-03_JPRB, 0.38119392E-03_JPRB, 0.38101514E-03_JPRB, 0.38091572E-03_JPRB, 0.38083242E-03_JPRB, &
  & 0.38083855E-03_JPRB, 0.38094520E-03_JPRB, 0.38111983E-03_JPRB, 0.38135171E-03_JPRB, 0.38156069E-03_JPRB, 0.38173239E-03_JPRB, &
  & 0.38195038E-03_JPRB, 0.38229954E-03_JPRB, 0.38285754E-03_JPRB, 0.38370675E-03_JPRB, 0.38482174E-03_JPRB, 0.38569461E-03_JPRB, &
  & 0.38634253E-03_JPRB, 0.38672017E-03_JPRB, 0.38675293E-03_JPRB, 0.38655521E-03_JPRB, 0.38620487E-03_JPRB, 0.38566577E-03_JPRB, &
  & 0.38522218E-03_JPRB, 0.38498734E-03_JPRB, 0.38489900E-03_JPRB, 0.38479576E-03_JPRB, 0.38482731E-03_JPRB, 0.38499804E-03_JPRB, &
  & 0.38527037E-03_JPRB, 0.38562741E-03_JPRB, 0.38604419E-03_JPRB, 0.38662239E-03_JPRB, 0.38740135E-03_JPRB, 0.38808267E-03_JPRB, &
  & 0.38871804E-03_JPRB, 0.38931222E-03_JPRB, 0.38974410E-03_JPRB, 0.39012025E-03_JPRB, 0.39049272E-03_JPRB, 0.39078320E-03_JPRB, &
  & 0.39099482E-03_JPRB, 0.39114793E-03_JPRB, 0.39132484E-03_JPRB, 0.39172182E-03_JPRB, 0.39194846E-03_JPRB, 0.39224972E-03_JPRB, &
  & 0.39270906E-03_JPRB, 0.39289607E-03_JPRB, 0.39276023E-03_JPRB, 0.39266580E-03_JPRB  /)

RGHG1(:,70, 2) = (/ &
  & 0.38246770E-03_JPRB, 0.38264746E-03_JPRB, 0.38251421E-03_JPRB, 0.38222287E-03_JPRB, 0.38187115E-03_JPRB, 0.38173334E-03_JPRB, &
  & 0.38171632E-03_JPRB, 0.38181945E-03_JPRB, 0.38191099E-03_JPRB, 0.38191851E-03_JPRB, 0.38188919E-03_JPRB, 0.38185258E-03_JPRB, &
  & 0.38175885E-03_JPRB, 0.38158385E-03_JPRB, 0.38129124E-03_JPRB, 0.38108908E-03_JPRB, 0.38095922E-03_JPRB, 0.38087161E-03_JPRB, &
  & 0.38088108E-03_JPRB, 0.38098712E-03_JPRB, 0.38115504E-03_JPRB, 0.38136934E-03_JPRB, 0.38157085E-03_JPRB, 0.38174967E-03_JPRB, &
  & 0.38195128E-03_JPRB, 0.38228899E-03_JPRB, 0.38283062E-03_JPRB, 0.38364745E-03_JPRB, 0.38479843E-03_JPRB, 0.38566343E-03_JPRB, &
  & 0.38632063E-03_JPRB, 0.38670530E-03_JPRB, 0.38676664E-03_JPRB, 0.38662550E-03_JPRB, 0.38631811E-03_JPRB, 0.38580950E-03_JPRB, &
  & 0.38536184E-03_JPRB, 0.38510806E-03_JPRB, 0.38502694E-03_JPRB, 0.38495342E-03_JPRB, 0.38501016E-03_JPRB, 0.38521597E-03_JPRB, &
  & 0.38552065E-03_JPRB, 0.38590094E-03_JPRB, 0.38633327E-03_JPRB, 0.38694226E-03_JPRB, 0.38772665E-03_JPRB, 0.38840019E-03_JPRB, &
  & 0.38904758E-03_JPRB, 0.38964480E-03_JPRB, 0.39009563E-03_JPRB, 0.39048089E-03_JPRB, 0.39085953E-03_JPRB, 0.39113629E-03_JPRB, &
  & 0.39131316E-03_JPRB, 0.39145152E-03_JPRB, 0.39160708E-03_JPRB, 0.39201802E-03_JPRB, 0.39224676E-03_JPRB, 0.39254270E-03_JPRB, &
  & 0.39299412E-03_JPRB, 0.39319434E-03_JPRB, 0.39313332E-03_JPRB, 0.39304050E-03_JPRB  /)

RGHG1(:,71, 2) = (/ &
  & 0.38251815E-03_JPRB, 0.38270498E-03_JPRB, 0.38260414E-03_JPRB, 0.38231686E-03_JPRB, 0.38197864E-03_JPRB, 0.38186067E-03_JPRB, &
  & 0.38183744E-03_JPRB, 0.38191754E-03_JPRB, 0.38198901E-03_JPRB, 0.38199203E-03_JPRB, 0.38195754E-03_JPRB, 0.38192312E-03_JPRB, &
  & 0.38182980E-03_JPRB, 0.38167867E-03_JPRB, 0.38139836E-03_JPRB, 0.38117458E-03_JPRB, 0.38101492E-03_JPRB, 0.38092068E-03_JPRB, &
  & 0.38093586E-03_JPRB, 0.38104270E-03_JPRB, 0.38119787E-03_JPRB, 0.38138903E-03_JPRB, 0.38157258E-03_JPRB, 0.38175744E-03_JPRB, &
  & 0.38194505E-03_JPRB, 0.38226505E-03_JPRB, 0.38279428E-03_JPRB, 0.38359116E-03_JPRB, 0.38475696E-03_JPRB, 0.38562543E-03_JPRB, &
  & 0.38630191E-03_JPRB, 0.38669511E-03_JPRB, 0.38677259E-03_JPRB, 0.38668645E-03_JPRB, 0.38641607E-03_JPRB, 0.38593962E-03_JPRB, &
  & 0.38549469E-03_JPRB, 0.38522725E-03_JPRB, 0.38516559E-03_JPRB, 0.38512632E-03_JPRB, 0.38520596E-03_JPRB, 0.38545112E-03_JPRB, &
  & 0.38579178E-03_JPRB, 0.38619670E-03_JPRB, 0.38664494E-03_JPRB, 0.38727491E-03_JPRB, 0.38805945E-03_JPRB, 0.38872874E-03_JPRB, &
  & 0.38938754E-03_JPRB, 0.38998636E-03_JPRB, 0.39044941E-03_JPRB, 0.39084406E-03_JPRB, 0.39122539E-03_JPRB, 0.39148538E-03_JPRB, &
  & 0.39162622E-03_JPRB, 0.39175114E-03_JPRB, 0.39188838E-03_JPRB, 0.39230327E-03_JPRB, 0.39253333E-03_JPRB, 0.39282900E-03_JPRB, &
  & 0.39327050E-03_JPRB, 0.39348451E-03_JPRB, 0.39351736E-03_JPRB, 0.39342267E-03_JPRB  /)

RGHG1(:,72, 2) = (/ &
  & 0.38255468E-03_JPRB, 0.38273874E-03_JPRB, 0.38267063E-03_JPRB, 0.38239602E-03_JPRB, 0.38207993E-03_JPRB, 0.38198386E-03_JPRB, &
  & 0.38195717E-03_JPRB, 0.38200616E-03_JPRB, 0.38205481E-03_JPRB, 0.38205645E-03_JPRB, 0.38202126E-03_JPRB, 0.38199007E-03_JPRB, &
  & 0.38189975E-03_JPRB, 0.38177143E-03_JPRB, 0.38151325E-03_JPRB, 0.38127081E-03_JPRB, 0.38108671E-03_JPRB, 0.38098325E-03_JPRB, &
  & 0.38100397E-03_JPRB, 0.38110919E-03_JPRB, 0.38124661E-03_JPRB, 0.38140966E-03_JPRB, 0.38156164E-03_JPRB, 0.38174441E-03_JPRB, &
  & 0.38192512E-03_JPRB, 0.38221999E-03_JPRB, 0.38273978E-03_JPRB, 0.38354242E-03_JPRB, 0.38469577E-03_JPRB, 0.38557323E-03_JPRB, &
  & 0.38627621E-03_JPRB, 0.38668071E-03_JPRB, 0.38677017E-03_JPRB, 0.38673865E-03_JPRB, 0.38649939E-03_JPRB, 0.38604851E-03_JPRB, &
  & 0.38561442E-03_JPRB, 0.38533868E-03_JPRB, 0.38530837E-03_JPRB, 0.38530298E-03_JPRB, 0.38541050E-03_JPRB, 0.38570567E-03_JPRB, &
  & 0.38608506E-03_JPRB, 0.38651371E-03_JPRB, 0.38698131E-03_JPRB, 0.38762465E-03_JPRB, 0.38839882E-03_JPRB, 0.38906972E-03_JPRB, &
  & 0.38973958E-03_JPRB, 0.39033518E-03_JPRB, 0.39080214E-03_JPRB, 0.39120532E-03_JPRB, 0.39158366E-03_JPRB, 0.39182843E-03_JPRB, &
  & 0.39193724E-03_JPRB, 0.39204718E-03_JPRB, 0.39217336E-03_JPRB, 0.39257856E-03_JPRB, 0.39280355E-03_JPRB, 0.39311260E-03_JPRB, &
  & 0.39353934E-03_JPRB, 0.39376971E-03_JPRB, 0.39389775E-03_JPRB, 0.39379084E-03_JPRB  /)

RGHG1(:,73, 2) = (/ &
  & 0.38258458E-03_JPRB, 0.38275366E-03_JPRB, 0.38271098E-03_JPRB, 0.38246046E-03_JPRB, 0.38217518E-03_JPRB, 0.38209535E-03_JPRB, &
  & 0.38207010E-03_JPRB, 0.38208288E-03_JPRB, 0.38210794E-03_JPRB, 0.38210947E-03_JPRB, 0.38207809E-03_JPRB, 0.38204928E-03_JPRB, &
  & 0.38196625E-03_JPRB, 0.38185853E-03_JPRB, 0.38163116E-03_JPRB, 0.38138063E-03_JPRB, 0.38118010E-03_JPRB, 0.38106886E-03_JPRB, &
  & 0.38108915E-03_JPRB, 0.38118355E-03_JPRB, 0.38129970E-03_JPRB, 0.38142976E-03_JPRB, 0.38153865E-03_JPRB, 0.38171035E-03_JPRB, &
  & 0.38187940E-03_JPRB, 0.38214815E-03_JPRB, 0.38265757E-03_JPRB, 0.38349189E-03_JPRB, 0.38462268E-03_JPRB, 0.38550319E-03_JPRB, &
  & 0.38623368E-03_JPRB, 0.38665039E-03_JPRB, 0.38675811E-03_JPRB, 0.38677747E-03_JPRB, 0.38658447E-03_JPRB, 0.38614478E-03_JPRB, &
  & 0.38573313E-03_JPRB, 0.38546296E-03_JPRB, 0.38546908E-03_JPRB, 0.38549349E-03_JPRB, 0.38564746E-03_JPRB, 0.38599700E-03_JPRB, &
  & 0.38641725E-03_JPRB, 0.38687855E-03_JPRB, 0.38736648E-03_JPRB, 0.38801085E-03_JPRB, 0.38876967E-03_JPRB, 0.38944284E-03_JPRB, &
  & 0.39012062E-03_JPRB, 0.39070441E-03_JPRB, 0.39116077E-03_JPRB, 0.39156697E-03_JPRB, 0.39194101E-03_JPRB, 0.39217390E-03_JPRB, &
  & 0.39225670E-03_JPRB, 0.39234579E-03_JPRB, 0.39246405E-03_JPRB, 0.39284540E-03_JPRB, 0.39305823E-03_JPRB, 0.39338308E-03_JPRB, &
  & 0.39378343E-03_JPRB, 0.39404438E-03_JPRB, 0.39423329E-03_JPRB, 0.39412137E-03_JPRB  /)

RGHG1(:,74, 2) = (/ &
  & 0.38261242E-03_JPRB, 0.38276023E-03_JPRB, 0.38273775E-03_JPRB, 0.38251656E-03_JPRB, 0.38226446E-03_JPRB, 0.38219440E-03_JPRB, &
  & 0.38217128E-03_JPRB, 0.38215288E-03_JPRB, 0.38215529E-03_JPRB, 0.38215626E-03_JPRB, 0.38212933E-03_JPRB, 0.38210270E-03_JPRB, &
  & 0.38202690E-03_JPRB, 0.38193692E-03_JPRB, 0.38174398E-03_JPRB, 0.38149434E-03_JPRB, 0.38128473E-03_JPRB, 0.38117170E-03_JPRB, &
  & 0.38118410E-03_JPRB, 0.38126650E-03_JPRB, 0.38136096E-03_JPRB, 0.38145377E-03_JPRB, 0.38151502E-03_JPRB, 0.38166934E-03_JPRB, &
  & 0.38181576E-03_JPRB, 0.38205764E-03_JPRB, 0.38255817E-03_JPRB, 0.38342408E-03_JPRB, 0.38452563E-03_JPRB, 0.38540326E-03_JPRB, &
  & 0.38617190E-03_JPRB, 0.38660576E-03_JPRB, 0.38673446E-03_JPRB, 0.38680085E-03_JPRB, 0.38667162E-03_JPRB, 0.38624343E-03_JPRB, &
  & 0.38586548E-03_JPRB, 0.38562095E-03_JPRB, 0.38566168E-03_JPRB, 0.38572052E-03_JPRB, 0.38592468E-03_JPRB, 0.38632262E-03_JPRB, &
  & 0.38678500E-03_JPRB, 0.38728077E-03_JPRB, 0.38778436E-03_JPRB, 0.38842288E-03_JPRB, 0.38916859E-03_JPRB, 0.38983809E-03_JPRB, &
  & 0.39052226E-03_JPRB, 0.39109452E-03_JPRB, 0.39152988E-03_JPRB, 0.39193403E-03_JPRB, 0.39230144E-03_JPRB, 0.39252679E-03_JPRB, &
  & 0.39257979E-03_JPRB, 0.39264298E-03_JPRB, 0.39275512E-03_JPRB, 0.39310658E-03_JPRB, 0.39330946E-03_JPRB, 0.39364249E-03_JPRB, &
  & 0.39401801E-03_JPRB, 0.39431000E-03_JPRB, 0.39452955E-03_JPRB, 0.39441782E-03_JPRB  /)

RGHG1(:,75, 2) = (/ &
  & 0.38263696E-03_JPRB, 0.38276152E-03_JPRB, 0.38275479E-03_JPRB, 0.38256412E-03_JPRB, 0.38234539E-03_JPRB, 0.38227900E-03_JPRB, &
  & 0.38225762E-03_JPRB, 0.38221632E-03_JPRB, 0.38219798E-03_JPRB, 0.38219682E-03_JPRB, 0.38217329E-03_JPRB, 0.38214861E-03_JPRB, &
  & 0.38208026E-03_JPRB, 0.38200578E-03_JPRB, 0.38184828E-03_JPRB, 0.38160909E-03_JPRB, 0.38139755E-03_JPRB, 0.38128959E-03_JPRB, &
  & 0.38128881E-03_JPRB, 0.38135686E-03_JPRB, 0.38142954E-03_JPRB, 0.38148241E-03_JPRB, 0.38149580E-03_JPRB, 0.38162776E-03_JPRB, &
  & 0.38174422E-03_JPRB, 0.38195877E-03_JPRB, 0.38245080E-03_JPRB, 0.38333348E-03_JPRB, 0.38439988E-03_JPRB, 0.38527519E-03_JPRB, &
  & 0.38608645E-03_JPRB, 0.38654748E-03_JPRB, 0.38670115E-03_JPRB, 0.38681021E-03_JPRB, 0.38675469E-03_JPRB, 0.38634727E-03_JPRB, &
  & 0.38600694E-03_JPRB, 0.38580372E-03_JPRB, 0.38588241E-03_JPRB, 0.38598702E-03_JPRB, 0.38624487E-03_JPRB, 0.38668803E-03_JPRB, &
  & 0.38718836E-03_JPRB, 0.38771345E-03_JPRB, 0.38822007E-03_JPRB, 0.38885067E-03_JPRB, 0.38959055E-03_JPRB, 0.39025185E-03_JPRB, &
  & 0.39093825E-03_JPRB, 0.39150125E-03_JPRB, 0.39191180E-03_JPRB, 0.39230666E-03_JPRB, 0.39266713E-03_JPRB, 0.39288450E-03_JPRB, &
  & 0.39290575E-03_JPRB, 0.39293827E-03_JPRB, 0.39304335E-03_JPRB, 0.39336114E-03_JPRB, 0.39355701E-03_JPRB, 0.39388966E-03_JPRB, &
  & 0.39424259E-03_JPRB, 0.39456412E-03_JPRB, 0.39478855E-03_JPRB, 0.39467610E-03_JPRB  /)

RGHG1(:,76, 2) = (/ &
  & 0.38265552E-03_JPRB, 0.38276071E-03_JPRB, 0.38276620E-03_JPRB, 0.38260182E-03_JPRB, 0.38241420E-03_JPRB, 0.38234597E-03_JPRB, &
  & 0.38232481E-03_JPRB, 0.38227268E-03_JPRB, 0.38223683E-03_JPRB, 0.38223036E-03_JPRB, 0.38220706E-03_JPRB, 0.38218400E-03_JPRB, &
  & 0.38212440E-03_JPRB, 0.38206421E-03_JPRB, 0.38193992E-03_JPRB, 0.38172216E-03_JPRB, 0.38151569E-03_JPRB, 0.38142064E-03_JPRB, &
  & 0.38140488E-03_JPRB, 0.38145310E-03_JPRB, 0.38150389E-03_JPRB, 0.38151642E-03_JPRB, 0.38148738E-03_JPRB, 0.38159352E-03_JPRB, &
  & 0.38167910E-03_JPRB, 0.38186621E-03_JPRB, 0.38234811E-03_JPRB, 0.38321280E-03_JPRB, 0.38423863E-03_JPRB, 0.38512246E-03_JPRB, &
  & 0.38596993E-03_JPRB, 0.38647590E-03_JPRB, 0.38666115E-03_JPRB, 0.38680779E-03_JPRB, 0.38682396E-03_JPRB, 0.38645895E-03_JPRB, &
  & 0.38614882E-03_JPRB, 0.38599517E-03_JPRB, 0.38612458E-03_JPRB, 0.38629604E-03_JPRB, 0.38661313E-03_JPRB, 0.38710424E-03_JPRB, &
  & 0.38762993E-03_JPRB, 0.38816908E-03_JPRB, 0.38865403E-03_JPRB, 0.38928141E-03_JPRB, 0.39002981E-03_JPRB, 0.39068143E-03_JPRB, &
  & 0.39136138E-03_JPRB, 0.39191930E-03_JPRB, 0.39231095E-03_JPRB, 0.39268552E-03_JPRB, 0.39304208E-03_JPRB, 0.39324331E-03_JPRB, &
  & 0.39323505E-03_JPRB, 0.39323230E-03_JPRB, 0.39332517E-03_JPRB, 0.39360768E-03_JPRB, 0.39379940E-03_JPRB, 0.39412284E-03_JPRB, &
  & 0.39445456E-03_JPRB, 0.39480306E-03_JPRB, 0.39501251E-03_JPRB, 0.39488899E-03_JPRB  /)

RGHG1(:,77, 2) = (/ &
  & 0.38266880E-03_JPRB, 0.38275923E-03_JPRB, 0.38276779E-03_JPRB, 0.38262452E-03_JPRB, 0.38246448E-03_JPRB, 0.38239571E-03_JPRB, &
  & 0.38237168E-03_JPRB, 0.38231676E-03_JPRB, 0.38226647E-03_JPRB, 0.38225418E-03_JPRB, 0.38222757E-03_JPRB, 0.38220193E-03_JPRB, &
  & 0.38215366E-03_JPRB, 0.38210907E-03_JPRB, 0.38200979E-03_JPRB, 0.38181578E-03_JPRB, 0.38163175E-03_JPRB, 0.38153981E-03_JPRB, &
  & 0.38151506E-03_JPRB, 0.38154185E-03_JPRB, 0.38157375E-03_JPRB, 0.38155179E-03_JPRB, 0.38149127E-03_JPRB, 0.38157211E-03_JPRB, &
  & 0.38164387E-03_JPRB, 0.38180227E-03_JPRB, 0.38227277E-03_JPRB, 0.38309949E-03_JPRB, 0.38408328E-03_JPRB, 0.38497909E-03_JPRB, &
  & 0.38585040E-03_JPRB, 0.38640042E-03_JPRB, 0.38662081E-03_JPRB, 0.38679869E-03_JPRB, 0.38687160E-03_JPRB, 0.38656780E-03_JPRB, &
  & 0.38627056E-03_JPRB, 0.38615254E-03_JPRB, 0.38634381E-03_JPRB, 0.38658862E-03_JPRB, 0.38696691E-03_JPRB, 0.38750421E-03_JPRB, &
  & 0.38806117E-03_JPRB, 0.38860793E-03_JPRB, 0.38906114E-03_JPRB, 0.38968569E-03_JPRB, 0.39046581E-03_JPRB, 0.39113022E-03_JPRB, &
  & 0.39180274E-03_JPRB, 0.39234265E-03_JPRB, 0.39270227E-03_JPRB, 0.39306758E-03_JPRB, 0.39342415E-03_JPRB, 0.39359948E-03_JPRB, &
  & 0.39356040E-03_JPRB, 0.39352565E-03_JPRB, 0.39359393E-03_JPRB, 0.39383823E-03_JPRB, 0.39402441E-03_JPRB, 0.39433295E-03_JPRB, &
  & 0.39464848E-03_JPRB, 0.39499906E-03_JPRB, 0.39518422E-03_JPRB, 0.39504371E-03_JPRB  /)

RGHG1(:,78, 2) = (/ &
  & 0.38268225E-03_JPRB, 0.38275199E-03_JPRB, 0.38276238E-03_JPRB, 0.38263630E-03_JPRB, 0.38250071E-03_JPRB, 0.38243459E-03_JPRB, &
  & 0.38240902E-03_JPRB, 0.38235310E-03_JPRB, 0.38229126E-03_JPRB, 0.38227107E-03_JPRB, 0.38223992E-03_JPRB, 0.38221118E-03_JPRB, &
  & 0.38217137E-03_JPRB, 0.38213899E-03_JPRB, 0.38205884E-03_JPRB, 0.38188549E-03_JPRB, 0.38172046E-03_JPRB, 0.38163109E-03_JPRB, &
  & 0.38160009E-03_JPRB, 0.38161345E-03_JPRB, 0.38162907E-03_JPRB, 0.38158332E-03_JPRB, 0.38150108E-03_JPRB, 0.38156120E-03_JPRB, &
  & 0.38161999E-03_JPRB, 0.38175863E-03_JPRB, 0.38221948E-03_JPRB, 0.38301886E-03_JPRB, 0.38397642E-03_JPRB, 0.38487871E-03_JPRB, &
  & 0.38576434E-03_JPRB, 0.38633458E-03_JPRB, 0.38658661E-03_JPRB, 0.38678858E-03_JPRB, 0.38691201E-03_JPRB, 0.38667483E-03_JPRB, &
  & 0.38638012E-03_JPRB, 0.38629862E-03_JPRB, 0.38654649E-03_JPRB, 0.38685657E-03_JPRB, 0.38728584E-03_JPRB, 0.38785526E-03_JPRB, &
  & 0.38843300E-03_JPRB, 0.38899485E-03_JPRB, 0.38943327E-03_JPRB, 0.39006304E-03_JPRB, 0.39087662E-03_JPRB, 0.39156616E-03_JPRB, &
  & 0.39224264E-03_JPRB, 0.39276183E-03_JPRB, 0.39308807E-03_JPRB, 0.39344252E-03_JPRB, 0.39380126E-03_JPRB, 0.39395336E-03_JPRB, &
  & 0.39388114E-03_JPRB, 0.39381498E-03_JPRB, 0.39385006E-03_JPRB, 0.39406162E-03_JPRB, 0.39423820E-03_JPRB, 0.39452401E-03_JPRB, &
  & 0.39482815E-03_JPRB, 0.39515552E-03_JPRB, 0.39530795E-03_JPRB, 0.39515109E-03_JPRB  /)

RGHG1(:,79, 2) = (/ &
  & 0.38269531E-03_JPRB, 0.38273687E-03_JPRB, 0.38274931E-03_JPRB, 0.38263859E-03_JPRB, 0.38252440E-03_JPRB, 0.38246364E-03_JPRB, &
  & 0.38243760E-03_JPRB, 0.38238167E-03_JPRB, 0.38231060E-03_JPRB, 0.38228203E-03_JPRB, 0.38224445E-03_JPRB, 0.38221239E-03_JPRB, &
  & 0.38217716E-03_JPRB, 0.38215254E-03_JPRB, 0.38208418E-03_JPRB, 0.38192488E-03_JPRB, 0.38177653E-03_JPRB, 0.38169164E-03_JPRB, &
  & 0.38166065E-03_JPRB, 0.38166933E-03_JPRB, 0.38167270E-03_JPRB, 0.38161036E-03_JPRB, 0.38151380E-03_JPRB, 0.38155975E-03_JPRB, &
  & 0.38160459E-03_JPRB, 0.38173062E-03_JPRB, 0.38218489E-03_JPRB, 0.38297080E-03_JPRB, 0.38391468E-03_JPRB, 0.38482074E-03_JPRB, &
  & 0.38571091E-03_JPRB, 0.38628040E-03_JPRB, 0.38655959E-03_JPRB, 0.38677951E-03_JPRB, 0.38694795E-03_JPRB, 0.38677645E-03_JPRB, &
  & 0.38647712E-03_JPRB, 0.38643406E-03_JPRB, 0.38673473E-03_JPRB, 0.38710162E-03_JPRB, 0.38756707E-03_JPRB, 0.38815004E-03_JPRB, &
  & 0.38874423E-03_JPRB, 0.38932682E-03_JPRB, 0.38976738E-03_JPRB, 0.39041029E-03_JPRB, 0.39125498E-03_JPRB, 0.39197701E-03_JPRB, &
  & 0.39267058E-03_JPRB, 0.39317315E-03_JPRB, 0.39346651E-03_JPRB, 0.39381045E-03_JPRB, 0.39417022E-03_JPRB, 0.39430040E-03_JPRB, &
  & 0.39419645E-03_JPRB, 0.39409537E-03_JPRB, 0.39409474E-03_JPRB, 0.39428107E-03_JPRB, 0.39443991E-03_JPRB, 0.39469897E-03_JPRB, &
  & 0.39499496E-03_JPRB, 0.39528097E-03_JPRB, 0.39539541E-03_JPRB, 0.39523113E-03_JPRB  /)

RGHG1(:,80, 2) = (/ &
  & 0.38270706E-03_JPRB, 0.38271207E-03_JPRB, 0.38272796E-03_JPRB, 0.38263307E-03_JPRB, 0.38253726E-03_JPRB, 0.38248387E-03_JPRB, &
  & 0.38245778E-03_JPRB, 0.38240232E-03_JPRB, 0.38232364E-03_JPRB, 0.38228818E-03_JPRB, 0.38224141E-03_JPRB, 0.38220594E-03_JPRB, &
  & 0.38217070E-03_JPRB, 0.38214864E-03_JPRB, 0.38208311E-03_JPRB, 0.38192774E-03_JPRB, 0.38179644E-03_JPRB, 0.38172000E-03_JPRB, &
  & 0.38169925E-03_JPRB, 0.38171204E-03_JPRB, 0.38170869E-03_JPRB, 0.38163252E-03_JPRB, 0.38152623E-03_JPRB, 0.38156639E-03_JPRB, &
  & 0.38159541E-03_JPRB, 0.38171320E-03_JPRB, 0.38216507E-03_JPRB, 0.38295272E-03_JPRB, 0.38389042E-03_JPRB, 0.38480131E-03_JPRB, &
  & 0.38568589E-03_JPRB, 0.38623893E-03_JPRB, 0.38654022E-03_JPRB, 0.38677331E-03_JPRB, 0.38698149E-03_JPRB, 0.38686856E-03_JPRB, &
  & 0.38656054E-03_JPRB, 0.38655816E-03_JPRB, 0.38691058E-03_JPRB, 0.38732657E-03_JPRB, 0.38780956E-03_JPRB, 0.38838350E-03_JPRB, &
  & 0.38899786E-03_JPRB, 0.38960386E-03_JPRB, 0.39006142E-03_JPRB, 0.39072455E-03_JPRB, 0.39159467E-03_JPRB, 0.39235129E-03_JPRB, &
  & 0.39307582E-03_JPRB, 0.39357267E-03_JPRB, 0.39383449E-03_JPRB, 0.39417125E-03_JPRB, 0.39452756E-03_JPRB, 0.39463469E-03_JPRB, &
  & 0.39450487E-03_JPRB, 0.39436099E-03_JPRB, 0.39432900E-03_JPRB, 0.39449934E-03_JPRB, 0.39462817E-03_JPRB, 0.39486094E-03_JPRB, &
  & 0.39515035E-03_JPRB, 0.39538545E-03_JPRB, 0.39546046E-03_JPRB, 0.39530626E-03_JPRB  /)

RGHG1(:,81, 2) = (/ &
  & 0.38270576E-03_JPRB, 0.38267663E-03_JPRB, 0.38269631E-03_JPRB, 0.38261896E-03_JPRB, 0.38254046E-03_JPRB, 0.38249300E-03_JPRB, &
  & 0.38247094E-03_JPRB, 0.38241524E-03_JPRB, 0.38233158E-03_JPRB, 0.38228901E-03_JPRB, 0.38223323E-03_JPRB, 0.38219137E-03_JPRB, &
  & 0.38215707E-03_JPRB, 0.38213477E-03_JPRB, 0.38206569E-03_JPRB, 0.38191198E-03_JPRB, 0.38179419E-03_JPRB, 0.38172937E-03_JPRB, &
  & 0.38172710E-03_JPRB, 0.38174630E-03_JPRB, 0.38174129E-03_JPRB, 0.38165469E-03_JPRB, 0.38154626E-03_JPRB, 0.38158429E-03_JPRB, &
  & 0.38159506E-03_JPRB, 0.38170241E-03_JPRB, 0.38216022E-03_JPRB, 0.38295782E-03_JPRB, 0.38388769E-03_JPRB, 0.38480238E-03_JPRB, &
  & 0.38568791E-03_JPRB, 0.38621724E-03_JPRB, 0.38653608E-03_JPRB, 0.38677674E-03_JPRB, 0.38702475E-03_JPRB, 0.38695117E-03_JPRB, &
  & 0.38665003E-03_JPRB, 0.38666709E-03_JPRB, 0.38706597E-03_JPRB, 0.38751680E-03_JPRB, 0.38799126E-03_JPRB, 0.38856188E-03_JPRB, &
  & 0.38920065E-03_JPRB, 0.38981211E-03_JPRB, 0.39028674E-03_JPRB, 0.39096931E-03_JPRB, 0.39187095E-03_JPRB, 0.39266976E-03_JPRB, &
  & 0.39342938E-03_JPRB, 0.39393784E-03_JPRB, 0.39421270E-03_JPRB, 0.39454733E-03_JPRB, 0.39488206E-03_JPRB, 0.39497307E-03_JPRB, &
  & 0.39480960E-03_JPRB, 0.39462992E-03_JPRB, 0.39455739E-03_JPRB, 0.39470403E-03_JPRB, 0.39479541E-03_JPRB, 0.39501111E-03_JPRB, &
  & 0.39528701E-03_JPRB, 0.39546356E-03_JPRB, 0.39549282E-03_JPRB, 0.39537062E-03_JPRB  /)

RGHG1(:,82, 2) = (/ &
  & 0.38269189E-03_JPRB, 0.38264142E-03_JPRB, 0.38266242E-03_JPRB, 0.38260217E-03_JPRB, 0.38253858E-03_JPRB, 0.38249815E-03_JPRB, &
  & 0.38247944E-03_JPRB, 0.38242351E-03_JPRB, 0.38233653E-03_JPRB, 0.38228559E-03_JPRB, 0.38222396E-03_JPRB, 0.38217802E-03_JPRB, &
  & 0.38214450E-03_JPRB, 0.38212409E-03_JPRB, 0.38205229E-03_JPRB, 0.38189958E-03_JPRB, 0.38179015E-03_JPRB, 0.38173589E-03_JPRB, &
  & 0.38175331E-03_JPRB, 0.38178066E-03_JPRB, 0.38177775E-03_JPRB, 0.38168145E-03_JPRB, 0.38157645E-03_JPRB, 0.38161301E-03_JPRB, &
  & 0.38160385E-03_JPRB, 0.38169970E-03_JPRB, 0.38215718E-03_JPRB, 0.38296076E-03_JPRB, 0.38388286E-03_JPRB, 0.38479952E-03_JPRB, &
  & 0.38569546E-03_JPRB, 0.38621121E-03_JPRB, 0.38654028E-03_JPRB, 0.38679094E-03_JPRB, 0.38706676E-03_JPRB, 0.38703097E-03_JPRB, &
  & 0.38673519E-03_JPRB, 0.38676862E-03_JPRB, 0.38719374E-03_JPRB, 0.38767233E-03_JPRB, 0.38813799E-03_JPRB, 0.38870744E-03_JPRB, &
  & 0.38936328E-03_JPRB, 0.38998064E-03_JPRB, 0.39046831E-03_JPRB, 0.39116432E-03_JPRB, 0.39210774E-03_JPRB, 0.39294995E-03_JPRB, &
  & 0.39375095E-03_JPRB, 0.39427439E-03_JPRB, 0.39457085E-03_JPRB, 0.39490957E-03_JPRB, 0.39522140E-03_JPRB, 0.39529623E-03_JPRB, &
  & 0.39509751E-03_JPRB, 0.39488521E-03_JPRB, 0.39477110E-03_JPRB, 0.39488569E-03_JPRB, 0.39494737E-03_JPRB, 0.39514105E-03_JPRB, &
  & 0.39539405E-03_JPRB, 0.39551406E-03_JPRB, 0.39550292E-03_JPRB, 0.39540925E-03_JPRB  /)

RGHG1(:,83, 2) = (/ &
  & 0.38266810E-03_JPRB, 0.38260750E-03_JPRB, 0.38262909E-03_JPRB, 0.38258439E-03_JPRB, 0.38253340E-03_JPRB, 0.38250018E-03_JPRB, &
  & 0.38248423E-03_JPRB, 0.38242816E-03_JPRB, 0.38233879E-03_JPRB, 0.38228033E-03_JPRB, 0.38221472E-03_JPRB, 0.38216602E-03_JPRB, &
  & 0.38213365E-03_JPRB, 0.38211559E-03_JPRB, 0.38204173E-03_JPRB, 0.38189071E-03_JPRB, 0.38178564E-03_JPRB, 0.38174187E-03_JPRB, &
  & 0.38178191E-03_JPRB, 0.38181777E-03_JPRB, 0.38182267E-03_JPRB, 0.38172064E-03_JPRB, 0.38162176E-03_JPRB, 0.38165815E-03_JPRB, &
  & 0.38163178E-03_JPRB, 0.38171382E-03_JPRB, 0.38215795E-03_JPRB, 0.38296211E-03_JPRB, 0.38387876E-03_JPRB, 0.38479795E-03_JPRB, &
  & 0.38570991E-03_JPRB, 0.38622252E-03_JPRB, 0.38655426E-03_JPRB, 0.38681327E-03_JPRB, 0.38710735E-03_JPRB, 0.38710295E-03_JPRB, &
  & 0.38680686E-03_JPRB, 0.38685976E-03_JPRB, 0.38729854E-03_JPRB, 0.38779714E-03_JPRB, 0.38825600E-03_JPRB, 0.38882512E-03_JPRB, &
  & 0.38949077E-03_JPRB, 0.39011701E-03_JPRB, 0.39061471E-03_JPRB, 0.39132092E-03_JPRB, 0.39230917E-03_JPRB, 0.39319162E-03_JPRB, &
  & 0.39403690E-03_JPRB, 0.39457949E-03_JPRB, 0.39490697E-03_JPRB, 0.39525038E-03_JPRB, 0.39554075E-03_JPRB, 0.39559775E-03_JPRB, &
  & 0.39536953E-03_JPRB, 0.39512436E-03_JPRB, 0.39497070E-03_JPRB, 0.39504482E-03_JPRB, 0.39507762E-03_JPRB, 0.39524363E-03_JPRB, &
  & 0.39547366E-03_JPRB, 0.39554293E-03_JPRB, 0.39550038E-03_JPRB, 0.39542733E-03_JPRB  /)

RGHG1(:,84, 2) = (/ &
  & 0.38263726E-03_JPRB, 0.38257589E-03_JPRB, 0.38259878E-03_JPRB, 0.38256726E-03_JPRB, 0.38252669E-03_JPRB, 0.38250007E-03_JPRB, &
  & 0.38248635E-03_JPRB, 0.38243021E-03_JPRB, 0.38233873E-03_JPRB, 0.38227502E-03_JPRB, 0.38220624E-03_JPRB, 0.38215536E-03_JPRB, &
  & 0.38212484E-03_JPRB, 0.38210836E-03_JPRB, 0.38203289E-03_JPRB, 0.38188522E-03_JPRB, 0.38178166E-03_JPRB, 0.38174901E-03_JPRB, &
  & 0.38181628E-03_JPRB, 0.38185975E-03_JPRB, 0.38187916E-03_JPRB, 0.38177778E-03_JPRB, 0.38168467E-03_JPRB, 0.38172336E-03_JPRB, &
  & 0.38168539E-03_JPRB, 0.38175135E-03_JPRB, 0.38216679E-03_JPRB, 0.38296610E-03_JPRB, 0.38388082E-03_JPRB, 0.38480462E-03_JPRB, &
  & 0.38573445E-03_JPRB, 0.38625301E-03_JPRB, 0.38657942E-03_JPRB, 0.38684314E-03_JPRB, 0.38714857E-03_JPRB, 0.38716469E-03_JPRB, &
  & 0.38685960E-03_JPRB, 0.38693873E-03_JPRB, 0.38738584E-03_JPRB, 0.38789657E-03_JPRB, 0.38835245E-03_JPRB, 0.38892068E-03_JPRB, &
  & 0.38958912E-03_JPRB, 0.39022893E-03_JPRB, 0.39073513E-03_JPRB, 0.39144956E-03_JPRB, 0.39248024E-03_JPRB, 0.39339587E-03_JPRB, &
  & 0.39428472E-03_JPRB, 0.39485307E-03_JPRB, 0.39521898E-03_JPRB, 0.39556308E-03_JPRB, 0.39583431E-03_JPRB, 0.39587156E-03_JPRB, &
  & 0.39562460E-03_JPRB, 0.39534440E-03_JPRB, 0.39515604E-03_JPRB, 0.39518210E-03_JPRB, 0.39518170E-03_JPRB, 0.39531470E-03_JPRB, &
  & 0.39552877E-03_JPRB, 0.39555606E-03_JPRB, 0.39549301E-03_JPRB, 0.39543080E-03_JPRB  /)

RGHG1(:,85, 2) = (/ &
  & 0.38259998E-03_JPRB, 0.38254746E-03_JPRB, 0.38257393E-03_JPRB, 0.38255340E-03_JPRB, 0.38252096E-03_JPRB, 0.38250007E-03_JPRB, &
  & 0.38248755E-03_JPRB, 0.38243021E-03_JPRB, 0.38233586E-03_JPRB, 0.38226737E-03_JPRB, 0.38219620E-03_JPRB, 0.38214509E-03_JPRB, &
  & 0.38211647E-03_JPRB, 0.38210119E-03_JPRB, 0.38202405E-03_JPRB, 0.38188188E-03_JPRB, 0.38177831E-03_JPRB, 0.38175833E-03_JPRB, &
  & 0.38186933E-03_JPRB, 0.38191734E-03_JPRB, 0.38195897E-03_JPRB, 0.38186859E-03_JPRB, 0.38177093E-03_JPRB, 0.38182635E-03_JPRB, &
  & 0.38177858E-03_JPRB, 0.38183570E-03_JPRB, 0.38222988E-03_JPRB, 0.38302752E-03_JPRB, 0.38393864E-03_JPRB, 0.38486747E-03_JPRB, &
  & 0.38581092E-03_JPRB, 0.38633138E-03_JPRB, 0.38663366E-03_JPRB, 0.38691124E-03_JPRB, 0.38722599E-03_JPRB, 0.38723494E-03_JPRB, &
  & 0.38690572E-03_JPRB, 0.38701185E-03_JPRB, 0.38747545E-03_JPRB, 0.38799048E-03_JPRB, 0.38845066E-03_JPRB, 0.38901125E-03_JPRB, &
  & 0.38967228E-03_JPRB, 0.39033311E-03_JPRB, 0.39085509E-03_JPRB, 0.39156259E-03_JPRB, 0.39263818E-03_JPRB, 0.39357078E-03_JPRB, &
  & 0.39449500E-03_JPRB, 0.39512954E-03_JPRB, 0.39551695E-03_JPRB, 0.39585102E-03_JPRB, 0.39608737E-03_JPRB, 0.39611219E-03_JPRB, &
  & 0.39585495E-03_JPRB, 0.39554154E-03_JPRB, 0.39532880E-03_JPRB, 0.39529871E-03_JPRB, 0.39525578E-03_JPRB, 0.39535317E-03_JPRB, &
  & 0.39556031E-03_JPRB, 0.39555726E-03_JPRB, 0.39547986E-03_JPRB, 0.39543295E-03_JPRB  /)

RGHG1(:,86, 2) = (/ &
  & 0.38256261E-03_JPRB, 0.38252327E-03_JPRB, 0.38255503E-03_JPRB, 0.38254368E-03_JPRB, 0.38251659E-03_JPRB, 0.38250035E-03_JPRB, &
  & 0.38248847E-03_JPRB, 0.38242899E-03_JPRB, 0.38233139E-03_JPRB, 0.38225959E-03_JPRB, 0.38218752E-03_JPRB, 0.38213616E-03_JPRB, &
  & 0.38211003E-03_JPRB, 0.38209483E-03_JPRB, 0.38201544E-03_JPRB, 0.38188179E-03_JPRB, 0.38177729E-03_JPRB, 0.38177340E-03_JPRB, &
  & 0.38193601E-03_JPRB, 0.38199607E-03_JPRB, 0.38205162E-03_JPRB, 0.38197771E-03_JPRB, 0.38188222E-03_JPRB, 0.38195744E-03_JPRB, &
  & 0.38191479E-03_JPRB, 0.38197518E-03_JPRB, 0.38236032E-03_JPRB, 0.38313926E-03_JPRB, 0.38405389E-03_JPRB, 0.38500290E-03_JPRB, &
  & 0.38596304E-03_JPRB, 0.38647906E-03_JPRB, 0.38675540E-03_JPRB, 0.38706542E-03_JPRB, 0.38737346E-03_JPRB, 0.38732976E-03_JPRB, &
  & 0.38696320E-03_JPRB, 0.38709179E-03_JPRB, 0.38757608E-03_JPRB, 0.38808907E-03_JPRB, 0.38856106E-03_JPRB, 0.38911358E-03_JPRB, &
  & 0.38976044E-03_JPRB, 0.39044315E-03_JPRB, 0.39098117E-03_JPRB, 0.39167441E-03_JPRB, 0.39279366E-03_JPRB, 0.39373097E-03_JPRB, &
  & 0.39466810E-03_JPRB, 0.39536394E-03_JPRB, 0.39578063E-03_JPRB, 0.39609433E-03_JPRB, 0.39628813E-03_JPRB, 0.39633001E-03_JPRB, &
  & 0.39605908E-03_JPRB, 0.39572125E-03_JPRB, 0.39548832E-03_JPRB, 0.39539880E-03_JPRB, 0.39531031E-03_JPRB, 0.39537548E-03_JPRB, &
  & 0.39557939E-03_JPRB, 0.39555855E-03_JPRB, 0.39546806E-03_JPRB, 0.39544886E-03_JPRB  /)

RGHG1(:,87, 2) = (/ &
  & 0.38252823E-03_JPRB, 0.38250328E-03_JPRB, 0.38254076E-03_JPRB, 0.38253670E-03_JPRB, 0.38251363E-03_JPRB, 0.38250103E-03_JPRB, &
  & 0.38248926E-03_JPRB, 0.38242697E-03_JPRB, 0.38232608E-03_JPRB, 0.38225235E-03_JPRB, 0.38217991E-03_JPRB, 0.38212856E-03_JPRB, &
  & 0.38210536E-03_JPRB, 0.38208979E-03_JPRB, 0.38200697E-03_JPRB, 0.38188594E-03_JPRB, 0.38178022E-03_JPRB, 0.38179739E-03_JPRB, &
  & 0.38200953E-03_JPRB, 0.38208660E-03_JPRB, 0.38215012E-03_JPRB, 0.38210072E-03_JPRB, 0.38201972E-03_JPRB, 0.38210994E-03_JPRB, &
  & 0.38208302E-03_JPRB, 0.38216680E-03_JPRB, 0.38255978E-03_JPRB, 0.38330236E-03_JPRB, 0.38423506E-03_JPRB, 0.38523796E-03_JPRB, &
  & 0.38621328E-03_JPRB, 0.38672247E-03_JPRB, 0.38699314E-03_JPRB, 0.38730797E-03_JPRB, 0.38757080E-03_JPRB, 0.38745267E-03_JPRB, &
  & 0.38704066E-03_JPRB, 0.38719645E-03_JPRB, 0.38771824E-03_JPRB, 0.38821613E-03_JPRB, 0.38870488E-03_JPRB, 0.38924376E-03_JPRB, &
  & 0.38986780E-03_JPRB, 0.39056884E-03_JPRB, 0.39113316E-03_JPRB, 0.39180620E-03_JPRB, 0.39295828E-03_JPRB, 0.39389083E-03_JPRB, &
  & 0.39483057E-03_JPRB, 0.39556435E-03_JPRB, 0.39601399E-03_JPRB, 0.39629930E-03_JPRB, 0.39645682E-03_JPRB, 0.39652518E-03_JPRB, &
  & 0.39625269E-03_JPRB, 0.39590226E-03_JPRB, 0.39565093E-03_JPRB, 0.39548748E-03_JPRB, 0.39535204E-03_JPRB, 0.39538724E-03_JPRB, &
  & 0.39558809E-03_JPRB, 0.39555809E-03_JPRB, 0.39545828E-03_JPRB, 0.39546842E-03_JPRB  /)

RGHG1(:,88, 2) = (/ &
  & 0.38249924E-03_JPRB, 0.38248800E-03_JPRB, 0.38253048E-03_JPRB, 0.38253160E-03_JPRB, 0.38251173E-03_JPRB, 0.38250183E-03_JPRB, &
  & 0.38248981E-03_JPRB, 0.38242442E-03_JPRB, 0.38232050E-03_JPRB, 0.38224589E-03_JPRB, 0.38217320E-03_JPRB, 0.38212203E-03_JPRB, &
  & 0.38210245E-03_JPRB, 0.38208600E-03_JPRB, 0.38199894E-03_JPRB, 0.38189596E-03_JPRB, 0.38179117E-03_JPRB, 0.38183797E-03_JPRB, &
  & 0.38209318E-03_JPRB, 0.38218612E-03_JPRB, 0.38225821E-03_JPRB, 0.38223744E-03_JPRB, 0.38218486E-03_JPRB, 0.38229214E-03_JPRB, &
  & 0.38229657E-03_JPRB, 0.38243097E-03_JPRB, 0.38285971E-03_JPRB, 0.38355400E-03_JPRB, 0.38451576E-03_JPRB, 0.38562469E-03_JPRB, &
  & 0.38660786E-03_JPRB, 0.38712652E-03_JPRB, 0.38740863E-03_JPRB, 0.38766534E-03_JPRB, 0.38782368E-03_JPRB, 0.38762634E-03_JPRB, &
  & 0.38715569E-03_JPRB, 0.38734748E-03_JPRB, 0.38794425E-03_JPRB, 0.38841815E-03_JPRB, 0.38891950E-03_JPRB, 0.38943731E-03_JPRB, &
  & 0.39002109E-03_JPRB, 0.39073470E-03_JPRB, 0.39133878E-03_JPRB, 0.39198800E-03_JPRB, 0.39315774E-03_JPRB, 0.39407136E-03_JPRB, &
  & 0.39500812E-03_JPRB, 0.39575259E-03_JPRB, 0.39623502E-03_JPRB, 0.39648724E-03_JPRB, 0.39661383E-03_JPRB, 0.39670569E-03_JPRB, &
  & 0.39644937E-03_JPRB, 0.39609712E-03_JPRB, 0.39582747E-03_JPRB, 0.39557208E-03_JPRB, 0.39538531E-03_JPRB, 0.39539212E-03_JPRB, &
  & 0.39558896E-03_JPRB, 0.39555572E-03_JPRB, 0.39544882E-03_JPRB, 0.39548283E-03_JPRB  /)

RGHG1(:,89, 2) = (/ &
  & 0.38247955E-03_JPRB, 0.38247881E-03_JPRB, 0.38252399E-03_JPRB, 0.38252781E-03_JPRB, 0.38251018E-03_JPRB, 0.38250208E-03_JPRB, &
  & 0.38248975E-03_JPRB, 0.38242176E-03_JPRB, 0.38231540E-03_JPRB, 0.38224043E-03_JPRB, 0.38216751E-03_JPRB, 0.38211623E-03_JPRB, &
  & 0.38210113E-03_JPRB, 0.38208284E-03_JPRB, 0.38199224E-03_JPRB, 0.38191260E-03_JPRB, 0.38181565E-03_JPRB, 0.38190340E-03_JPRB, &
  & 0.38219261E-03_JPRB, 0.38228994E-03_JPRB, 0.38238305E-03_JPRB, 0.38238588E-03_JPRB, 0.38237567E-03_JPRB, 0.38251961E-03_JPRB, &
  & 0.38259468E-03_JPRB, 0.38281469E-03_JPRB, 0.38332906E-03_JPRB, 0.38398592E-03_JPRB, 0.38497774E-03_JPRB, 0.38624965E-03_JPRB, &
  & 0.38721343E-03_JPRB, 0.38777762E-03_JPRB, 0.38805005E-03_JPRB, 0.38815834E-03_JPRB, 0.38815080E-03_JPRB, 0.38789545E-03_JPRB, &
  & 0.38733606E-03_JPRB, 0.38756478E-03_JPRB, 0.38830611E-03_JPRB, 0.38878904E-03_JPRB, 0.38927948E-03_JPRB, 0.38976370E-03_JPRB, &
  & 0.39026481E-03_JPRB, 0.39098822E-03_JPRB, 0.39163994E-03_JPRB, 0.39226501E-03_JPRB, 0.39343198E-03_JPRB, 0.39430251E-03_JPRB, &
  & 0.39523004E-03_JPRB, 0.39596934E-03_JPRB, 0.39648008E-03_JPRB, 0.39669381E-03_JPRB, 0.39678284E-03_JPRB, 0.39688215E-03_JPRB, &
  & 0.39665371E-03_JPRB, 0.39630376E-03_JPRB, 0.39601528E-03_JPRB, 0.39566063E-03_JPRB, 0.39541262E-03_JPRB, 0.39539377E-03_JPRB, &
  & 0.39558669E-03_JPRB, 0.39555309E-03_JPRB, 0.39543709E-03_JPRB, 0.39548368E-03_JPRB  /)

RGHG1(:,90, 2) = (/ &
  & 0.38247118E-03_JPRB, 0.38247429E-03_JPRB, 0.38252056E-03_JPRB, 0.38252545E-03_JPRB, 0.38250894E-03_JPRB, 0.38250221E-03_JPRB, &
  & 0.38248934E-03_JPRB, 0.38241910E-03_JPRB, 0.38230992E-03_JPRB, 0.38223578E-03_JPRB, 0.38216285E-03_JPRB, 0.38211072E-03_JPRB, &
  & 0.38209987E-03_JPRB, 0.38207980E-03_JPRB, 0.38198498E-03_JPRB, 0.38192994E-03_JPRB, 0.38184939E-03_JPRB, 0.38198066E-03_JPRB, &
  & 0.38229472E-03_JPRB, 0.38239514E-03_JPRB, 0.38252204E-03_JPRB, 0.38256788E-03_JPRB, 0.38264166E-03_JPRB, 0.38282035E-03_JPRB, &
  & 0.38308425E-03_JPRB, 0.38345798E-03_JPRB, 0.38415059E-03_JPRB, 0.38482757E-03_JPRB, 0.38589531E-03_JPRB, 0.38732998E-03_JPRB, &
  & 0.38816392E-03_JPRB, 0.38870952E-03_JPRB, 0.38888351E-03_JPRB, 0.38875020E-03_JPRB, 0.38859648E-03_JPRB, 0.38833848E-03_JPRB, &
  & 0.38762600E-03_JPRB, 0.38785200E-03_JPRB, 0.38884767E-03_JPRB, 0.38953217E-03_JPRB, 0.38997915E-03_JPRB, 0.39036606E-03_JPRB, &
  & 0.39067878E-03_JPRB, 0.39143016E-03_JPRB, 0.39213403E-03_JPRB, 0.39271896E-03_JPRB, 0.39383720E-03_JPRB, 0.39464144E-03_JPRB, &
  & 0.39554676E-03_JPRB, 0.39627623E-03_JPRB, 0.39682444E-03_JPRB, 0.39694256E-03_JPRB, 0.39699331E-03_JPRB, 0.39706667E-03_JPRB, &
  & 0.39686532E-03_JPRB, 0.39651397E-03_JPRB, 0.39620544E-03_JPRB, 0.39575758E-03_JPRB, 0.39543434E-03_JPRB, 0.39539393E-03_JPRB, &
  & 0.39558341E-03_JPRB, 0.39555069E-03_JPRB, 0.39543093E-03_JPRB, 0.39548492E-03_JPRB  /)

RGHG1(:,91, 2) = (/ &
  & 0.38246851E-03_JPRB, 0.38247311E-03_JPRB, 0.38251937E-03_JPRB, 0.38252397E-03_JPRB, 0.38250834E-03_JPRB, 0.38250221E-03_JPRB, &
  & 0.38248904E-03_JPRB, 0.38241673E-03_JPRB, 0.38230428E-03_JPRB, 0.38223043E-03_JPRB, 0.38215751E-03_JPRB, 0.38210389E-03_JPRB, &
  & 0.38209868E-03_JPRB, 0.38207386E-03_JPRB, 0.38197459E-03_JPRB, 0.38193291E-03_JPRB, 0.38187255E-03_JPRB, 0.38206589E-03_JPRB, &
  & 0.38241826E-03_JPRB, 0.38256441E-03_JPRB, 0.38271210E-03_JPRB, 0.38288920E-03_JPRB, 0.38314413E-03_JPRB, 0.38330530E-03_JPRB, &
  & 0.38393834E-03_JPRB, 0.38470496E-03_JPRB, 0.38575838E-03_JPRB, 0.38670977E-03_JPRB, 0.38798687E-03_JPRB, 0.38956884E-03_JPRB, &
  & 0.38982101E-03_JPRB, 0.39020922E-03_JPRB, 0.39006337E-03_JPRB, 0.38944689E-03_JPRB, 0.38918062E-03_JPRB, 0.38901884E-03_JPRB, &
  & 0.38812996E-03_JPRB, 0.38823628E-03_JPRB, 0.38974808E-03_JPRB, 0.39089526E-03_JPRB, 0.39128225E-03_JPRB, 0.39136774E-03_JPRB, &
  & 0.39158988E-03_JPRB, 0.39224712E-03_JPRB, 0.39301068E-03_JPRB, 0.39346079E-03_JPRB, 0.39458408E-03_JPRB, 0.39525112E-03_JPRB, &
  & 0.39612407E-03_JPRB, 0.39678345E-03_JPRB, 0.39739136E-03_JPRB, 0.39732150E-03_JPRB, 0.39733008E-03_JPRB, 0.39733008E-03_JPRB, &
  & 0.39719495E-03_JPRB, 0.39680827E-03_JPRB, 0.39643262E-03_JPRB, 0.39587251E-03_JPRB, 0.39547265E-03_JPRB, 0.39539482E-03_JPRB, &
  & 0.39557836E-03_JPRB, 0.39554772E-03_JPRB, 0.39542945E-03_JPRB, 0.39548521E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ---GEMS----

RGHG1(:, 1, 3) = (/ &
  & 0.37190803E-03_JPRB, 0.37188340E-03_JPRB, 0.37185192E-03_JPRB, 0.37180609E-03_JPRB, 0.37174870E-03_JPRB, 0.37167234E-03_JPRB, &
  & 0.37158151E-03_JPRB, 0.37146991E-03_JPRB, 0.37134035E-03_JPRB, 0.37121992E-03_JPRB, 0.37112606E-03_JPRB, 0.37105911E-03_JPRB, &
  & 0.37101189E-03_JPRB, 0.37098462E-03_JPRB, 0.37097250E-03_JPRB, 0.37097884E-03_JPRB, 0.37101273E-03_JPRB, 0.37107206E-03_JPRB, &
  & 0.37113646E-03_JPRB, 0.37119165E-03_JPRB, 0.37123746E-03_JPRB, 0.37127649E-03_JPRB, 0.37130939E-03_JPRB, 0.37133727E-03_JPRB, &
  & 0.37136412E-03_JPRB, 0.37139463E-03_JPRB, 0.37142889E-03_JPRB, 0.37146376E-03_JPRB, 0.37149325E-03_JPRB, 0.37151098E-03_JPRB, &
  & 0.37151478E-03_JPRB, 0.37150836E-03_JPRB, 0.37149896E-03_JPRB, 0.37149191E-03_JPRB, 0.37148871E-03_JPRB, 0.37148858E-03_JPRB, &
  & 0.37149091E-03_JPRB, 0.37149653E-03_JPRB, 0.37150530E-03_JPRB, 0.37151690E-03_JPRB, 0.37153157E-03_JPRB, 0.37154522E-03_JPRB, &
  & 0.37155474E-03_JPRB, 0.37156066E-03_JPRB, 0.37156397E-03_JPRB, 0.37156598E-03_JPRB, 0.37156612E-03_JPRB, 0.37156380E-03_JPRB, &
  & 0.37156039E-03_JPRB, 0.37155398E-03_JPRB, 0.37154277E-03_JPRB, 0.37153040E-03_JPRB, 0.37151592E-03_JPRB, 0.37150076E-03_JPRB, &
  & 0.37148278E-03_JPRB, 0.37146391E-03_JPRB, 0.37144367E-03_JPRB, 0.37142364E-03_JPRB, 0.37140533E-03_JPRB, 0.37139051E-03_JPRB, &
  & 0.37137714E-03_JPRB, 0.37136558E-03_JPRB, 0.37135667E-03_JPRB, 0.37135305E-03_JPRB  /)

RGHG1(:, 2, 3) = (/ &
  & 0.37190803E-03_JPRB, 0.37188340E-03_JPRB, 0.37185192E-03_JPRB, 0.37180609E-03_JPRB, 0.37174870E-03_JPRB, 0.37167234E-03_JPRB, &
  & 0.37158151E-03_JPRB, 0.37146991E-03_JPRB, 0.37134035E-03_JPRB, 0.37121992E-03_JPRB, 0.37112606E-03_JPRB, 0.37105911E-03_JPRB, &
  & 0.37101189E-03_JPRB, 0.37098462E-03_JPRB, 0.37097250E-03_JPRB, 0.37097884E-03_JPRB, 0.37101273E-03_JPRB, 0.37107206E-03_JPRB, &
  & 0.37113646E-03_JPRB, 0.37119165E-03_JPRB, 0.37123746E-03_JPRB, 0.37127649E-03_JPRB, 0.37130939E-03_JPRB, 0.37133727E-03_JPRB, &
  & 0.37136412E-03_JPRB, 0.37139463E-03_JPRB, 0.37142889E-03_JPRB, 0.37146376E-03_JPRB, 0.37149325E-03_JPRB, 0.37151098E-03_JPRB, &
  & 0.37151478E-03_JPRB, 0.37150836E-03_JPRB, 0.37149896E-03_JPRB, 0.37149191E-03_JPRB, 0.37148871E-03_JPRB, 0.37148858E-03_JPRB, &
  & 0.37149091E-03_JPRB, 0.37149653E-03_JPRB, 0.37150530E-03_JPRB, 0.37151690E-03_JPRB, 0.37153157E-03_JPRB, 0.37154522E-03_JPRB, &
  & 0.37155474E-03_JPRB, 0.37156066E-03_JPRB, 0.37156397E-03_JPRB, 0.37156598E-03_JPRB, 0.37156612E-03_JPRB, 0.37156380E-03_JPRB, &
  & 0.37156039E-03_JPRB, 0.37155398E-03_JPRB, 0.37154277E-03_JPRB, 0.37153040E-03_JPRB, 0.37151592E-03_JPRB, 0.37150076E-03_JPRB, &
  & 0.37148278E-03_JPRB, 0.37146391E-03_JPRB, 0.37144367E-03_JPRB, 0.37142364E-03_JPRB, 0.37140533E-03_JPRB, 0.37139051E-03_JPRB, &
  & 0.37137714E-03_JPRB, 0.37136558E-03_JPRB, 0.37135667E-03_JPRB, 0.37135305E-03_JPRB  /)

RGHG1(:, 3, 3) = (/ &
  & 0.37190803E-03_JPRB, 0.37188340E-03_JPRB, 0.37185192E-03_JPRB, 0.37180609E-03_JPRB, 0.37174870E-03_JPRB, 0.37167234E-03_JPRB, &
  & 0.37158151E-03_JPRB, 0.37146991E-03_JPRB, 0.37134035E-03_JPRB, 0.37121992E-03_JPRB, 0.37112606E-03_JPRB, 0.37105911E-03_JPRB, &
  & 0.37101189E-03_JPRB, 0.37098462E-03_JPRB, 0.37097250E-03_JPRB, 0.37097884E-03_JPRB, 0.37101273E-03_JPRB, 0.37107206E-03_JPRB, &
  & 0.37113646E-03_JPRB, 0.37119165E-03_JPRB, 0.37123746E-03_JPRB, 0.37127649E-03_JPRB, 0.37130939E-03_JPRB, 0.37133727E-03_JPRB, &
  & 0.37136412E-03_JPRB, 0.37139463E-03_JPRB, 0.37142889E-03_JPRB, 0.37146376E-03_JPRB, 0.37149325E-03_JPRB, 0.37151098E-03_JPRB, &
  & 0.37151478E-03_JPRB, 0.37150836E-03_JPRB, 0.37149896E-03_JPRB, 0.37149191E-03_JPRB, 0.37148871E-03_JPRB, 0.37148858E-03_JPRB, &
  & 0.37149091E-03_JPRB, 0.37149653E-03_JPRB, 0.37150530E-03_JPRB, 0.37151690E-03_JPRB, 0.37153157E-03_JPRB, 0.37154522E-03_JPRB, &
  & 0.37155474E-03_JPRB, 0.37156066E-03_JPRB, 0.37156397E-03_JPRB, 0.37156598E-03_JPRB, 0.37156612E-03_JPRB, 0.37156380E-03_JPRB, &
  & 0.37156039E-03_JPRB, 0.37155398E-03_JPRB, 0.37154277E-03_JPRB, 0.37153040E-03_JPRB, 0.37151592E-03_JPRB, 0.37150076E-03_JPRB, &
  & 0.37148278E-03_JPRB, 0.37146391E-03_JPRB, 0.37144367E-03_JPRB, 0.37142364E-03_JPRB, 0.37140533E-03_JPRB, 0.37139051E-03_JPRB, &
  & 0.37137714E-03_JPRB, 0.37136558E-03_JPRB, 0.37135667E-03_JPRB, 0.37135305E-03_JPRB  /)

RGHG1(:, 4, 3) = (/ &
  & 0.37190840E-03_JPRB, 0.37188385E-03_JPRB, 0.37185239E-03_JPRB, 0.37180658E-03_JPRB, 0.37174916E-03_JPRB, 0.37167275E-03_JPRB, &
  & 0.37158174E-03_JPRB, 0.37146985E-03_JPRB, 0.37134009E-03_JPRB, 0.37121954E-03_JPRB, 0.37112557E-03_JPRB, 0.37105857E-03_JPRB, &
  & 0.37101137E-03_JPRB, 0.37098419E-03_JPRB, 0.37097224E-03_JPRB, 0.37097882E-03_JPRB, 0.37101297E-03_JPRB, 0.37107252E-03_JPRB, &
  & 0.37113710E-03_JPRB, 0.37119241E-03_JPRB, 0.37123830E-03_JPRB, 0.37127740E-03_JPRB, 0.37131036E-03_JPRB, 0.37133830E-03_JPRB, &
  & 0.37136522E-03_JPRB, 0.37139581E-03_JPRB, 0.37143015E-03_JPRB, 0.37146500E-03_JPRB, 0.37149437E-03_JPRB, 0.37151196E-03_JPRB, &
  & 0.37151562E-03_JPRB, 0.37150911E-03_JPRB, 0.37149962E-03_JPRB, 0.37149251E-03_JPRB, 0.37148931E-03_JPRB, 0.37148924E-03_JPRB, &
  & 0.37149166E-03_JPRB, 0.37149734E-03_JPRB, 0.37150617E-03_JPRB, 0.37151780E-03_JPRB, 0.37153244E-03_JPRB, 0.37154604E-03_JPRB, &
  & 0.37155550E-03_JPRB, 0.37156137E-03_JPRB, 0.37156463E-03_JPRB, 0.37156659E-03_JPRB, 0.37156666E-03_JPRB, 0.37156427E-03_JPRB, &
  & 0.37156078E-03_JPRB, 0.37155428E-03_JPRB, 0.37154299E-03_JPRB, 0.37153053E-03_JPRB, 0.37151597E-03_JPRB, 0.37150071E-03_JPRB, &
  & 0.37148266E-03_JPRB, 0.37146374E-03_JPRB, 0.37144347E-03_JPRB, 0.37142342E-03_JPRB, 0.37140511E-03_JPRB, 0.37139028E-03_JPRB, &
  & 0.37137691E-03_JPRB, 0.37136535E-03_JPRB, 0.37135644E-03_JPRB, 0.37135280E-03_JPRB  /)

RGHG1(:, 5, 3) = (/ &
  & 0.37192626E-03_JPRB, 0.37190519E-03_JPRB, 0.37187477E-03_JPRB, 0.37182964E-03_JPRB, 0.37177098E-03_JPRB, 0.37169182E-03_JPRB, &
  & 0.37159226E-03_JPRB, 0.37146722E-03_JPRB, 0.37132751E-03_JPRB, 0.37120165E-03_JPRB, 0.37110237E-03_JPRB, 0.37103272E-03_JPRB, &
  & 0.37098685E-03_JPRB, 0.37096379E-03_JPRB, 0.37095998E-03_JPRB, 0.37097814E-03_JPRB, 0.37102452E-03_JPRB, 0.37109442E-03_JPRB, &
  & 0.37116732E-03_JPRB, 0.37122848E-03_JPRB, 0.37127837E-03_JPRB, 0.37132071E-03_JPRB, 0.37135637E-03_JPRB, 0.37138709E-03_JPRB, &
  & 0.37141733E-03_JPRB, 0.37145198E-03_JPRB, 0.37148990E-03_JPRB, 0.37152366E-03_JPRB, 0.37154749E-03_JPRB, 0.37155807E-03_JPRB, &
  & 0.37155588E-03_JPRB, 0.37154475E-03_JPRB, 0.37153091E-03_JPRB, 0.37152089E-03_JPRB, 0.37151769E-03_JPRB, 0.37152054E-03_JPRB, &
  & 0.37152694E-03_JPRB, 0.37153610E-03_JPRB, 0.37154753E-03_JPRB, 0.37156033E-03_JPRB, 0.37157388E-03_JPRB, 0.37158490E-03_JPRB, &
  & 0.37159152E-03_JPRB, 0.37159488E-03_JPRB, 0.37159589E-03_JPRB, 0.37159512E-03_JPRB, 0.37159215E-03_JPRB, 0.37158666E-03_JPRB, &
  & 0.37157933E-03_JPRB, 0.37156884E-03_JPRB, 0.37155329E-03_JPRB, 0.37153657E-03_JPRB, 0.37151803E-03_JPRB, 0.37149866E-03_JPRB, &
  & 0.37147732E-03_JPRB, 0.37145549E-03_JPRB, 0.37143379E-03_JPRB, 0.37141310E-03_JPRB, 0.37139459E-03_JPRB, 0.37137925E-03_JPRB, &
  & 0.37136588E-03_JPRB, 0.37135458E-03_JPRB, 0.37134553E-03_JPRB, 0.37134100E-03_JPRB  /)

RGHG1(:, 6, 3) = (/ &
  & 0.37195304E-03_JPRB, 0.37193721E-03_JPRB, 0.37190834E-03_JPRB, 0.37186424E-03_JPRB, 0.37180373E-03_JPRB, 0.37172043E-03_JPRB, &
  & 0.37160806E-03_JPRB, 0.37146326E-03_JPRB, 0.37130863E-03_JPRB, 0.37117481E-03_JPRB, 0.37106756E-03_JPRB, 0.37099393E-03_JPRB, &
  & 0.37095006E-03_JPRB, 0.37093319E-03_JPRB, 0.37094158E-03_JPRB, 0.37097711E-03_JPRB, 0.37104183E-03_JPRB, 0.37112728E-03_JPRB, &
  & 0.37121268E-03_JPRB, 0.37128258E-03_JPRB, 0.37133849E-03_JPRB, 0.37138568E-03_JPRB, 0.37142540E-03_JPRB, 0.37146028E-03_JPRB, &
  & 0.37149550E-03_JPRB, 0.37153625E-03_JPRB, 0.37157955E-03_JPRB, 0.37161168E-03_JPRB, 0.37162719E-03_JPRB, 0.37162726E-03_JPRB, &
  & 0.37161628E-03_JPRB, 0.37159822E-03_JPRB, 0.37157787E-03_JPRB, 0.37156347E-03_JPRB, 0.37156027E-03_JPRB, 0.37156751E-03_JPRB, &
  & 0.37157987E-03_JPRB, 0.37159426E-03_JPRB, 0.37160959E-03_JPRB, 0.37162415E-03_JPRB, 0.37163606E-03_JPRB, 0.37164319E-03_JPRB, &
  & 0.37164557E-03_JPRB, 0.37164516E-03_JPRB, 0.37164280E-03_JPRB, 0.37163793E-03_JPRB, 0.37163040E-03_JPRB, 0.37162026E-03_JPRB, &
  & 0.37160715E-03_JPRB, 0.37159069E-03_JPRB, 0.37156875E-03_JPRB, 0.37154563E-03_JPRB, 0.37152112E-03_JPRB, 0.37149558E-03_JPRB, &
  & 0.37146931E-03_JPRB, 0.37144311E-03_JPRB, 0.37141926E-03_JPRB, 0.37139762E-03_JPRB, 0.37137880E-03_JPRB, 0.37136271E-03_JPRB, &
  & 0.37134933E-03_JPRB, 0.37133841E-03_JPRB, 0.37132916E-03_JPRB, 0.37132328E-03_JPRB  /)

RGHG1(:, 7, 3) = (/ &
  & 0.37202680E-03_JPRB, 0.37201418E-03_JPRB, 0.37198716E-03_JPRB, 0.37194268E-03_JPRB, 0.37187600E-03_JPRB, 0.37178107E-03_JPRB, &
  & 0.37164907E-03_JPRB, 0.37147766E-03_JPRB, 0.37130125E-03_JPRB, 0.37115533E-03_JPRB, 0.37103977E-03_JPRB, 0.37095863E-03_JPRB, &
  & 0.37091363E-03_JPRB, 0.37090386E-03_JPRB, 0.37093055E-03_JPRB, 0.37099469E-03_JPRB, 0.37109247E-03_JPRB, 0.37120686E-03_JPRB, &
  & 0.37131399E-03_JPRB, 0.37140315E-03_JPRB, 0.37147553E-03_JPRB, 0.37153799E-03_JPRB, 0.37158961E-03_JPRB, 0.37163327E-03_JPRB, &
  & 0.37167698E-03_JPRB, 0.37172526E-03_JPRB, 0.37177102E-03_JPRB, 0.37180192E-03_JPRB, 0.37181315E-03_JPRB, 0.37180478E-03_JPRB, &
  & 0.37177859E-03_JPRB, 0.37174065E-03_JPRB, 0.37170237E-03_JPRB, 0.37167811E-03_JPRB, 0.37167730E-03_JPRB, 0.37169759E-03_JPRB, &
  & 0.37172652E-03_JPRB, 0.37175681E-03_JPRB, 0.37178334E-03_JPRB, 0.37180006E-03_JPRB, 0.37180796E-03_JPRB, 0.37180785E-03_JPRB, &
  & 0.37180035E-03_JPRB, 0.37178937E-03_JPRB, 0.37177505E-03_JPRB, 0.37175599E-03_JPRB, 0.37173221E-03_JPRB, 0.37170455E-03_JPRB, &
  & 0.37167140E-03_JPRB, 0.37163535E-03_JPRB, 0.37159536E-03_JPRB, 0.37155701E-03_JPRB, 0.37151918E-03_JPRB, 0.37148242E-03_JPRB, &
  & 0.37144766E-03_JPRB, 0.37141578E-03_JPRB, 0.37139009E-03_JPRB, 0.37136814E-03_JPRB, 0.37134918E-03_JPRB, 0.37133407E-03_JPRB, &
  & 0.37132261E-03_JPRB, 0.37131322E-03_JPRB, 0.37130507E-03_JPRB, 0.37129916E-03_JPRB  /)

RGHG1(:, 8, 3) = (/ &
  & 0.37218355E-03_JPRB, 0.37217115E-03_JPRB, 0.37214066E-03_JPRB, 0.37208487E-03_JPRB, 0.37200140E-03_JPRB, 0.37188583E-03_JPRB, &
  & 0.37172662E-03_JPRB, 0.37152318E-03_JPRB, 0.37131830E-03_JPRB, 0.37115019E-03_JPRB, 0.37102222E-03_JPRB, 0.37093574E-03_JPRB, &
  & 0.37089250E-03_JPRB, 0.37089541E-03_JPRB, 0.37094658E-03_JPRB, 0.37104685E-03_JPRB, 0.37118616E-03_JPRB, 0.37133793E-03_JPRB, &
  & 0.37147620E-03_JPRB, 0.37159864E-03_JPRB, 0.37171009E-03_JPRB, 0.37181284E-03_JPRB, 0.37189917E-03_JPRB, 0.37197049E-03_JPRB, &
  & 0.37203488E-03_JPRB, 0.37209270E-03_JPRB, 0.37213277E-03_JPRB, 0.37215519E-03_JPRB, 0.37215717E-03_JPRB, 0.37213667E-03_JPRB, &
  & 0.37209162E-03_JPRB, 0.37202848E-03_JPRB, 0.37196637E-03_JPRB, 0.37192782E-03_JPRB, 0.37192966E-03_JPRB, 0.37196746E-03_JPRB, &
  & 0.37201928E-03_JPRB, 0.37207111E-03_JPRB, 0.37211125E-03_JPRB, 0.37213222E-03_JPRB, 0.37213908E-03_JPRB, 0.37213397E-03_JPRB, &
  & 0.37211508E-03_JPRB, 0.37208532E-03_JPRB, 0.37204427E-03_JPRB, 0.37199356E-03_JPRB, 0.37193399E-03_JPRB, 0.37186468E-03_JPRB, &
  & 0.37178621E-03_JPRB, 0.37170602E-03_JPRB, 0.37163161E-03_JPRB, 0.37156705E-03_JPRB, 0.37150965E-03_JPRB, 0.37145868E-03_JPRB, &
  & 0.37141555E-03_JPRB, 0.37138046E-03_JPRB, 0.37135439E-03_JPRB, 0.37133316E-03_JPRB, 0.37131565E-03_JPRB, 0.37130292E-03_JPRB, &
  & 0.37129426E-03_JPRB, 0.37128728E-03_JPRB, 0.37128154E-03_JPRB, 0.37127736E-03_JPRB  /)

RGHG1(:, 9, 3) = (/ &
  & 0.37245011E-03_JPRB, 0.37243155E-03_JPRB, 0.37238791E-03_JPRB, 0.37230694E-03_JPRB, 0.37219149E-03_JPRB, 0.37204297E-03_JPRB, &
  & 0.37185061E-03_JPRB, 0.37161522E-03_JPRB, 0.37137550E-03_JPRB, 0.37117063E-03_JPRB, 0.37102021E-03_JPRB, 0.37093243E-03_JPRB, &
  & 0.37089722E-03_JPRB, 0.37091889E-03_JPRB, 0.37099949E-03_JPRB, 0.37113842E-03_JPRB, 0.37131847E-03_JPRB, 0.37150575E-03_JPRB, &
  & 0.37168331E-03_JPRB, 0.37185791E-03_JPRB, 0.37204263E-03_JPRB, 0.37222635E-03_JPRB, 0.37238407E-03_JPRB, 0.37251575E-03_JPRB, &
  & 0.37262388E-03_JPRB, 0.37269984E-03_JPRB, 0.37273305E-03_JPRB, 0.37274011E-03_JPRB, 0.37272546E-03_JPRB, 0.37268901E-03_JPRB, &
  & 0.37262904E-03_JPRB, 0.37254686E-03_JPRB, 0.37246068E-03_JPRB, 0.37240518E-03_JPRB, 0.37240679E-03_JPRB, 0.37245301E-03_JPRB, &
  & 0.37251926E-03_JPRB, 0.37258557E-03_JPRB, 0.37263731E-03_JPRB, 0.37266356E-03_JPRB, 0.37267026E-03_JPRB, 0.37265784E-03_JPRB, &
  & 0.37262438E-03_JPRB, 0.37256604E-03_JPRB, 0.37248327E-03_JPRB, 0.37238048E-03_JPRB, 0.37225574E-03_JPRB, 0.37210617E-03_JPRB, &
  & 0.37194620E-03_JPRB, 0.37179264E-03_JPRB, 0.37166589E-03_JPRB, 0.37156621E-03_JPRB, 0.37148799E-03_JPRB, 0.37142451E-03_JPRB, &
  & 0.37137722E-03_JPRB, 0.37134374E-03_JPRB, 0.37132035E-03_JPRB, 0.37130203E-03_JPRB, 0.37128827E-03_JPRB, 0.37127952E-03_JPRB, &
  & 0.37127468E-03_JPRB, 0.37127138E-03_JPRB, 0.37126934E-03_JPRB, 0.37126825E-03_JPRB  /)

RGHG1(:,10, 3) = (/ &
  & 0.37277782E-03_JPRB, 0.37274255E-03_JPRB, 0.37267728E-03_JPRB, 0.37256628E-03_JPRB, 0.37241139E-03_JPRB, 0.37222317E-03_JPRB, &
  & 0.37200001E-03_JPRB, 0.37174071E-03_JPRB, 0.37146408E-03_JPRB, 0.37121342E-03_JPRB, 0.37102750E-03_JPRB, 0.37093602E-03_JPRB, &
  & 0.37091515E-03_JPRB, 0.37095776E-03_JPRB, 0.37106753E-03_JPRB, 0.37123877E-03_JPRB, 0.37144348E-03_JPRB, 0.37165498E-03_JPRB, &
  & 0.37187460E-03_JPRB, 0.37211294E-03_JPRB, 0.37239357E-03_JPRB, 0.37269424E-03_JPRB, 0.37296333E-03_JPRB, 0.37319246E-03_JPRB, &
  & 0.37337347E-03_JPRB, 0.37349057E-03_JPRB, 0.37354277E-03_JPRB, 0.37355176E-03_JPRB, 0.37353165E-03_JPRB, 0.37348883E-03_JPRB, &
  & 0.37342732E-03_JPRB, 0.37334137E-03_JPRB, 0.37323515E-03_JPRB, 0.37315767E-03_JPRB, 0.37314045E-03_JPRB, 0.37315757E-03_JPRB, &
  & 0.37320118E-03_JPRB, 0.37325297E-03_JPRB, 0.37330101E-03_JPRB, 0.37332341E-03_JPRB, 0.37331958E-03_JPRB, 0.37328506E-03_JPRB, &
  & 0.37322409E-03_JPRB, 0.37312765E-03_JPRB, 0.37299478E-03_JPRB, 0.37283075E-03_JPRB, 0.37262093E-03_JPRB, 0.37235524E-03_JPRB, &
  & 0.37208694E-03_JPRB, 0.37185151E-03_JPRB, 0.37167449E-03_JPRB, 0.37154652E-03_JPRB, 0.37145663E-03_JPRB, 0.37138873E-03_JPRB, &
  & 0.37134424E-03_JPRB, 0.37131623E-03_JPRB, 0.37129836E-03_JPRB, 0.37128550E-03_JPRB, 0.37127700E-03_JPRB, 0.37127327E-03_JPRB, &
  & 0.37127337E-03_JPRB, 0.37127473E-03_JPRB, 0.37127654E-03_JPRB, 0.37127834E-03_JPRB  /)

RGHG1(:,11, 3) = (/ &
  & 0.37301167E-03_JPRB, 0.37296293E-03_JPRB, 0.37288042E-03_JPRB, 0.37274788E-03_JPRB, 0.37257001E-03_JPRB, 0.37236020E-03_JPRB, &
  & 0.37212326E-03_JPRB, 0.37185110E-03_JPRB, 0.37155072E-03_JPRB, 0.37126735E-03_JPRB, 0.37104462E-03_JPRB, 0.37093334E-03_JPRB, &
  & 0.37092372E-03_JPRB, 0.37098553E-03_JPRB, 0.37111724E-03_JPRB, 0.37130349E-03_JPRB, 0.37150954E-03_JPRB, 0.37174163E-03_JPRB, &
  & 0.37200083E-03_JPRB, 0.37229177E-03_JPRB, 0.37264592E-03_JPRB, 0.37305402E-03_JPRB, 0.37345009E-03_JPRB, 0.37379807E-03_JPRB, &
  & 0.37407780E-03_JPRB, 0.37427244E-03_JPRB, 0.37439164E-03_JPRB, 0.37445810E-03_JPRB, 0.37448439E-03_JPRB, 0.37447219E-03_JPRB, &
  & 0.37442510E-03_JPRB, 0.37433498E-03_JPRB, 0.37419788E-03_JPRB, 0.37406819E-03_JPRB, 0.37397647E-03_JPRB, 0.37390747E-03_JPRB, &
  & 0.37388309E-03_JPRB, 0.37389021E-03_JPRB, 0.37390568E-03_JPRB, 0.37390199E-03_JPRB, 0.37387065E-03_JPRB, 0.37380199E-03_JPRB, &
  & 0.37369907E-03_JPRB, 0.37355689E-03_JPRB, 0.37336771E-03_JPRB, 0.37314324E-03_JPRB, 0.37285269E-03_JPRB, 0.37247659E-03_JPRB, &
  & 0.37211994E-03_JPRB, 0.37183455E-03_JPRB, 0.37164322E-03_JPRB, 0.37151304E-03_JPRB, 0.37142587E-03_JPRB, 0.37136383E-03_JPRB, &
  & 0.37132744E-03_JPRB, 0.37130681E-03_JPRB, 0.37129471E-03_JPRB, 0.37128775E-03_JPRB, 0.37128401E-03_JPRB, 0.37128417E-03_JPRB, &
  & 0.37128787E-03_JPRB, 0.37129230E-03_JPRB, 0.37129607E-03_JPRB, 0.37129955E-03_JPRB  /)

RGHG1(:,12, 3) = (/ &
  & 0.37307706E-03_JPRB, 0.37302910E-03_JPRB, 0.37293650E-03_JPRB, 0.37280362E-03_JPRB, 0.37264311E-03_JPRB, 0.37245170E-03_JPRB, &
  & 0.37222664E-03_JPRB, 0.37195438E-03_JPRB, 0.37165268E-03_JPRB, 0.37136470E-03_JPRB, 0.37111901E-03_JPRB, 0.37097065E-03_JPRB, &
  & 0.37094893E-03_JPRB, 0.37101955E-03_JPRB, 0.37116955E-03_JPRB, 0.37135344E-03_JPRB, 0.37154618E-03_JPRB, 0.37179028E-03_JPRB, &
  & 0.37208374E-03_JPRB, 0.37240900E-03_JPRB, 0.37279085E-03_JPRB, 0.37325320E-03_JPRB, 0.37374883E-03_JPRB, 0.37420761E-03_JPRB, &
  & 0.37460307E-03_JPRB, 0.37490262E-03_JPRB, 0.37511836E-03_JPRB, 0.37527809E-03_JPRB, 0.37538549E-03_JPRB, 0.37542872E-03_JPRB, &
  & 0.37540415E-03_JPRB, 0.37529700E-03_JPRB, 0.37510551E-03_JPRB, 0.37487896E-03_JPRB, 0.37465799E-03_JPRB, 0.37447592E-03_JPRB, &
  & 0.37436955E-03_JPRB, 0.37433346E-03_JPRB, 0.37431688E-03_JPRB, 0.37428350E-03_JPRB, 0.37421664E-03_JPRB, 0.37411417E-03_JPRB, &
  & 0.37397372E-03_JPRB, 0.37378797E-03_JPRB, 0.37354234E-03_JPRB, 0.37325283E-03_JPRB, 0.37287511E-03_JPRB, 0.37243125E-03_JPRB, &
  & 0.37204255E-03_JPRB, 0.37175811E-03_JPRB, 0.37158551E-03_JPRB, 0.37147417E-03_JPRB, 0.37140341E-03_JPRB, 0.37135769E-03_JPRB, &
  & 0.37133328E-03_JPRB, 0.37132101E-03_JPRB, 0.37131515E-03_JPRB, 0.37131220E-03_JPRB, 0.37131083E-03_JPRB, 0.37131174E-03_JPRB, &
  & 0.37131402E-03_JPRB, 0.37131813E-03_JPRB, 0.37132184E-03_JPRB, 0.37132451E-03_JPRB  /)

RGHG1(:,13, 3) = (/ &
  & 0.37312196E-03_JPRB, 0.37305304E-03_JPRB, 0.37294442E-03_JPRB, 0.37284103E-03_JPRB, 0.37274306E-03_JPRB, 0.37261015E-03_JPRB, &
  & 0.37242558E-03_JPRB, 0.37217719E-03_JPRB, 0.37188684E-03_JPRB, 0.37160128E-03_JPRB, 0.37134516E-03_JPRB, 0.37115855E-03_JPRB, &
  & 0.37109168E-03_JPRB, 0.37114947E-03_JPRB, 0.37131211E-03_JPRB, 0.37149300E-03_JPRB, 0.37166334E-03_JPRB, 0.37189955E-03_JPRB, &
  & 0.37221171E-03_JPRB, 0.37254713E-03_JPRB, 0.37292336E-03_JPRB, 0.37338881E-03_JPRB, 0.37393453E-03_JPRB, 0.37446877E-03_JPRB, &
  & 0.37495448E-03_JPRB, 0.37534028E-03_JPRB, 0.37563798E-03_JPRB, 0.37587167E-03_JPRB, 0.37603044E-03_JPRB, 0.37610361E-03_JPRB, &
  & 0.37608537E-03_JPRB, 0.37595749E-03_JPRB, 0.37571713E-03_JPRB, 0.37540554E-03_JPRB, 0.37508428E-03_JPRB, 0.37482846E-03_JPRB, &
  & 0.37466376E-03_JPRB, 0.37458810E-03_JPRB, 0.37455692E-03_JPRB, 0.37451289E-03_JPRB, 0.37442532E-03_JPRB, 0.37429931E-03_JPRB, &
  & 0.37413237E-03_JPRB, 0.37391228E-03_JPRB, 0.37362007E-03_JPRB, 0.37326023E-03_JPRB, 0.37280119E-03_JPRB, 0.37233325E-03_JPRB, &
  & 0.37195586E-03_JPRB, 0.37170511E-03_JPRB, 0.37156118E-03_JPRB, 0.37147462E-03_JPRB, 0.37142560E-03_JPRB, 0.37139758E-03_JPRB, &
  & 0.37138474E-03_JPRB, 0.37137939E-03_JPRB, 0.37137662E-03_JPRB, 0.37137398E-03_JPRB, 0.37137249E-03_JPRB, 0.37137198E-03_JPRB, &
  & 0.37137071E-03_JPRB, 0.37137245E-03_JPRB, 0.37137588E-03_JPRB, 0.37137749E-03_JPRB  /)

RGHG1(:,14, 3) = (/ &
  & 0.37328671E-03_JPRB, 0.37318352E-03_JPRB, 0.37305640E-03_JPRB, 0.37299401E-03_JPRB, 0.37298475E-03_JPRB, 0.37291126E-03_JPRB, &
  & 0.37278020E-03_JPRB, 0.37259573E-03_JPRB, 0.37235533E-03_JPRB, 0.37208361E-03_JPRB, 0.37180503E-03_JPRB, 0.37157794E-03_JPRB, &
  & 0.37144700E-03_JPRB, 0.37145584E-03_JPRB, 0.37159748E-03_JPRB, 0.37177007E-03_JPRB, 0.37191380E-03_JPRB, 0.37211229E-03_JPRB, &
  & 0.37240585E-03_JPRB, 0.37272187E-03_JPRB, 0.37307300E-03_JPRB, 0.37350950E-03_JPRB, 0.37404949E-03_JPRB, 0.37461202E-03_JPRB, &
  & 0.37513549E-03_JPRB, 0.37557244E-03_JPRB, 0.37592455E-03_JPRB, 0.37619545E-03_JPRB, 0.37637606E-03_JPRB, 0.37645868E-03_JPRB, &
  & 0.37643050E-03_JPRB, 0.37626797E-03_JPRB, 0.37597857E-03_JPRB, 0.37562607E-03_JPRB, 0.37527945E-03_JPRB, 0.37499179E-03_JPRB, &
  & 0.37480425E-03_JPRB, 0.37470427E-03_JPRB, 0.37465459E-03_JPRB, 0.37461179E-03_JPRB, 0.37452620E-03_JPRB, 0.37439107E-03_JPRB, &
  & 0.37420417E-03_JPRB, 0.37395667E-03_JPRB, 0.37363304E-03_JPRB, 0.37321530E-03_JPRB, 0.37272778E-03_JPRB, 0.37228258E-03_JPRB, &
  & 0.37194813E-03_JPRB, 0.37173706E-03_JPRB, 0.37162199E-03_JPRB, 0.37155874E-03_JPRB, 0.37152703E-03_JPRB, 0.37151048E-03_JPRB, &
  & 0.37150267E-03_JPRB, 0.37149848E-03_JPRB, 0.37149304E-03_JPRB, 0.37148465E-03_JPRB, 0.37148082E-03_JPRB, 0.37147794E-03_JPRB, &
  & 0.37147615E-03_JPRB, 0.37147689E-03_JPRB, 0.37147869E-03_JPRB, 0.37147898E-03_JPRB  /)

RGHG1(:,15, 3) = (/ &
  & 0.37356727E-03_JPRB, 0.37343715E-03_JPRB, 0.37329853E-03_JPRB, 0.37324084E-03_JPRB, 0.37328276E-03_JPRB, 0.37324010E-03_JPRB, &
  & 0.37314451E-03_JPRB, 0.37305834E-03_JPRB, 0.37293726E-03_JPRB, 0.37274422E-03_JPRB, 0.37247853E-03_JPRB, 0.37219141E-03_JPRB, &
  & 0.37197834E-03_JPRB, 0.37189632E-03_JPRB, 0.37196988E-03_JPRB, 0.37210890E-03_JPRB, 0.37222870E-03_JPRB, 0.37236512E-03_JPRB, &
  & 0.37260515E-03_JPRB, 0.37287971E-03_JPRB, 0.37319025E-03_JPRB, 0.37359278E-03_JPRB, 0.37409908E-03_JPRB, 0.37466244E-03_JPRB, &
  & 0.37521113E-03_JPRB, 0.37568310E-03_JPRB, 0.37607104E-03_JPRB, 0.37636732E-03_JPRB, 0.37655435E-03_JPRB, 0.37663431E-03_JPRB, &
  & 0.37659186E-03_JPRB, 0.37639057E-03_JPRB, 0.37604387E-03_JPRB, 0.37565056E-03_JPRB, 0.37528693E-03_JPRB, 0.37498378E-03_JPRB, &
  & 0.37478566E-03_JPRB, 0.37467778E-03_JPRB, 0.37462198E-03_JPRB, 0.37456770E-03_JPRB, 0.37447109E-03_JPRB, 0.37431889E-03_JPRB, &
  & 0.37410653E-03_JPRB, 0.37383922E-03_JPRB, 0.37349293E-03_JPRB, 0.37307806E-03_JPRB, 0.37264018E-03_JPRB, 0.37226541E-03_JPRB, &
  & 0.37200030E-03_JPRB, 0.37184336E-03_JPRB, 0.37176271E-03_JPRB, 0.37172156E-03_JPRB, 0.37170307E-03_JPRB, 0.37169317E-03_JPRB, &
  & 0.37168664E-03_JPRB, 0.37167915E-03_JPRB, 0.37166799E-03_JPRB, 0.37165500E-03_JPRB, 0.37164799E-03_JPRB, 0.37164733E-03_JPRB, &
  & 0.37165046E-03_JPRB, 0.37165197E-03_JPRB, 0.37164968E-03_JPRB, 0.37164717E-03_JPRB  /)

RGHG1(:,16, 3) = (/ &
  & 0.37375806E-03_JPRB, 0.37363086E-03_JPRB, 0.37350274E-03_JPRB, 0.37343407E-03_JPRB, 0.37344443E-03_JPRB, 0.37342264E-03_JPRB, &
  & 0.37334151E-03_JPRB, 0.37332489E-03_JPRB, 0.37333725E-03_JPRB, 0.37327144E-03_JPRB, 0.37311314E-03_JPRB, 0.37283876E-03_JPRB, &
  & 0.37252344E-03_JPRB, 0.37231357E-03_JPRB, 0.37228603E-03_JPRB, 0.37236499E-03_JPRB, 0.37246197E-03_JPRB, 0.37255320E-03_JPRB, &
  & 0.37272466E-03_JPRB, 0.37296234E-03_JPRB, 0.37325565E-03_JPRB, 0.37364953E-03_JPRB, 0.37414149E-03_JPRB, 0.37471063E-03_JPRB, &
  & 0.37527501E-03_JPRB, 0.37577106E-03_JPRB, 0.37619426E-03_JPRB, 0.37651663E-03_JPRB, 0.37671658E-03_JPRB, 0.37680213E-03_JPRB, &
  & 0.37674157E-03_JPRB, 0.37651197E-03_JPRB, 0.37612485E-03_JPRB, 0.37566570E-03_JPRB, 0.37526059E-03_JPRB, 0.37493213E-03_JPRB, &
  & 0.37469846E-03_JPRB, 0.37454374E-03_JPRB, 0.37443532E-03_JPRB, 0.37432797E-03_JPRB, 0.37419631E-03_JPRB, 0.37402588E-03_JPRB, &
  & 0.37380297E-03_JPRB, 0.37352648E-03_JPRB, 0.37319783E-03_JPRB, 0.37284676E-03_JPRB, 0.37251050E-03_JPRB, 0.37224530E-03_JPRB, &
  & 0.37207436E-03_JPRB, 0.37198438E-03_JPRB, 0.37194191E-03_JPRB, 0.37192176E-03_JPRB, 0.37191304E-03_JPRB, 0.37190721E-03_JPRB, &
  & 0.37190092E-03_JPRB, 0.37189022E-03_JPRB, 0.37187772E-03_JPRB, 0.37186958E-03_JPRB, 0.37186806E-03_JPRB, 0.37187598E-03_JPRB, &
  & 0.37188514E-03_JPRB, 0.37189139E-03_JPRB, 0.37188884E-03_JPRB, 0.37188060E-03_JPRB  /)

RGHG1(:,17, 3) = (/ &
  & 0.37370277E-03_JPRB, 0.37363731E-03_JPRB, 0.37353583E-03_JPRB, 0.37346566E-03_JPRB, 0.37342939E-03_JPRB, 0.37342299E-03_JPRB, &
  & 0.37336119E-03_JPRB, 0.37335605E-03_JPRB, 0.37342998E-03_JPRB, 0.37348275E-03_JPRB, 0.37344170E-03_JPRB, 0.37325369E-03_JPRB, &
  & 0.37293422E-03_JPRB, 0.37261318E-03_JPRB, 0.37247081E-03_JPRB, 0.37248113E-03_JPRB, 0.37255390E-03_JPRB, 0.37263152E-03_JPRB, &
  & 0.37275626E-03_JPRB, 0.37297481E-03_JPRB, 0.37329701E-03_JPRB, 0.37374043E-03_JPRB, 0.37426088E-03_JPRB, 0.37484673E-03_JPRB, &
  & 0.37540265E-03_JPRB, 0.37589611E-03_JPRB, 0.37635868E-03_JPRB, 0.37671921E-03_JPRB, 0.37695040E-03_JPRB, 0.37703576E-03_JPRB, &
  & 0.37695094E-03_JPRB, 0.37669193E-03_JPRB, 0.37626763E-03_JPRB, 0.37575385E-03_JPRB, 0.37531548E-03_JPRB, 0.37496472E-03_JPRB, &
  & 0.37467365E-03_JPRB, 0.37444168E-03_JPRB, 0.37423530E-03_JPRB, 0.37403404E-03_JPRB, 0.37383417E-03_JPRB, 0.37362145E-03_JPRB, &
  & 0.37339583E-03_JPRB, 0.37314321E-03_JPRB, 0.37287772E-03_JPRB, 0.37261720E-03_JPRB, 0.37239130E-03_JPRB, 0.37223210E-03_JPRB, &
  & 0.37214608E-03_JPRB, 0.37211056E-03_JPRB, 0.37209753E-03_JPRB, 0.37209349E-03_JPRB, 0.37209327E-03_JPRB, 0.37208984E-03_JPRB, &
  & 0.37208093E-03_JPRB, 0.37206802E-03_JPRB, 0.37206031E-03_JPRB, 0.37206316E-03_JPRB, 0.37207537E-03_JPRB, 0.37208814E-03_JPRB, &
  & 0.37210156E-03_JPRB, 0.37211968E-03_JPRB, 0.37212651E-03_JPRB, 0.37211603E-03_JPRB  /)

RGHG1(:,18, 3) = (/ &
  & 0.37356566E-03_JPRB, 0.37351808E-03_JPRB, 0.37342029E-03_JPRB, 0.37334795E-03_JPRB, 0.37329805E-03_JPRB, 0.37328548E-03_JPRB, &
  & 0.37325733E-03_JPRB, 0.37324958E-03_JPRB, 0.37332761E-03_JPRB, 0.37342345E-03_JPRB, 0.37348387E-03_JPRB, 0.37337804E-03_JPRB, &
  & 0.37312424E-03_JPRB, 0.37281405E-03_JPRB, 0.37259642E-03_JPRB, 0.37253735E-03_JPRB, 0.37257639E-03_JPRB, 0.37265088E-03_JPRB, &
  & 0.37276480E-03_JPRB, 0.37298673E-03_JPRB, 0.37335446E-03_JPRB, 0.37387143E-03_JPRB, 0.37446184E-03_JPRB, 0.37507694E-03_JPRB, &
  & 0.37560707E-03_JPRB, 0.37606938E-03_JPRB, 0.37656929E-03_JPRB, 0.37698398E-03_JPRB, 0.37725915E-03_JPRB, 0.37734566E-03_JPRB, &
  & 0.37726763E-03_JPRB, 0.37700787E-03_JPRB, 0.37655658E-03_JPRB, 0.37598065E-03_JPRB, 0.37550360E-03_JPRB, 0.37512795E-03_JPRB, &
  & 0.37477842E-03_JPRB, 0.37448602E-03_JPRB, 0.37420321E-03_JPRB, 0.37390529E-03_JPRB, 0.37362118E-03_JPRB, 0.37335717E-03_JPRB, &
  & 0.37311832E-03_JPRB, 0.37288947E-03_JPRB, 0.37267762E-03_JPRB, 0.37249586E-03_JPRB, 0.37235711E-03_JPRB, 0.37227139E-03_JPRB, &
  & 0.37223609E-03_JPRB, 0.37223223E-03_JPRB, 0.37223718E-03_JPRB, 0.37224341E-03_JPRB, 0.37224538E-03_JPRB, 0.37224016E-03_JPRB, &
  & 0.37222963E-03_JPRB, 0.37221359E-03_JPRB, 0.37220464E-03_JPRB, 0.37221370E-03_JPRB, 0.37223494E-03_JPRB, 0.37224719E-03_JPRB, &
  & 0.37226137E-03_JPRB, 0.37228315E-03_JPRB, 0.37229509E-03_JPRB, 0.37229212E-03_JPRB  /)

RGHG1(:,19, 3) = (/ &
  & 0.37344172E-03_JPRB, 0.37339262E-03_JPRB, 0.37330263E-03_JPRB, 0.37323295E-03_JPRB, 0.37317905E-03_JPRB, 0.37314457E-03_JPRB, &
  & 0.37312546E-03_JPRB, 0.37312582E-03_JPRB, 0.37318619E-03_JPRB, 0.37327275E-03_JPRB, 0.37336926E-03_JPRB, 0.37333656E-03_JPRB, &
  & 0.37316410E-03_JPRB, 0.37293180E-03_JPRB, 0.37272765E-03_JPRB, 0.37263069E-03_JPRB, 0.37262716E-03_JPRB, 0.37269895E-03_JPRB, &
  & 0.37282126E-03_JPRB, 0.37306841E-03_JPRB, 0.37348014E-03_JPRB, 0.37406081E-03_JPRB, 0.37472075E-03_JPRB, 0.37537509E-03_JPRB, &
  & 0.37589904E-03_JPRB, 0.37633440E-03_JPRB, 0.37684770E-03_JPRB, 0.37729989E-03_JPRB, 0.37762159E-03_JPRB, 0.37774223E-03_JPRB, &
  & 0.37770087E-03_JPRB, 0.37746923E-03_JPRB, 0.37700692E-03_JPRB, 0.37637679E-03_JPRB, 0.37585414E-03_JPRB, 0.37545010E-03_JPRB, &
  & 0.37506935E-03_JPRB, 0.37475259E-03_JPRB, 0.37443707E-03_JPRB, 0.37409261E-03_JPRB, 0.37374541E-03_JPRB, 0.37342154E-03_JPRB, &
  & 0.37313808E-03_JPRB, 0.37289511E-03_JPRB, 0.37270060E-03_JPRB, 0.37255799E-03_JPRB, 0.37246777E-03_JPRB, 0.37241913E-03_JPRB, &
  & 0.37240728E-03_JPRB, 0.37241634E-03_JPRB, 0.37242930E-03_JPRB, 0.37243883E-03_JPRB, 0.37243941E-03_JPRB, 0.37242374E-03_JPRB, &
  & 0.37240348E-03_JPRB, 0.37238309E-03_JPRB, 0.37236182E-03_JPRB, 0.37235713E-03_JPRB, 0.37237659E-03_JPRB, 0.37238892E-03_JPRB, &
  & 0.37239771E-03_JPRB, 0.37240889E-03_JPRB, 0.37241713E-03_JPRB, 0.37242200E-03_JPRB  /)

RGHG1(:,20, 3) = (/ &
  & 0.37335987E-03_JPRB, 0.37332089E-03_JPRB, 0.37326270E-03_JPRB, 0.37320320E-03_JPRB, 0.37314357E-03_JPRB, 0.37308921E-03_JPRB, &
  & 0.37305802E-03_JPRB, 0.37306221E-03_JPRB, 0.37310104E-03_JPRB, 0.37315689E-03_JPRB, 0.37324015E-03_JPRB, 0.37324773E-03_JPRB, &
  & 0.37316180E-03_JPRB, 0.37302634E-03_JPRB, 0.37289226E-03_JPRB, 0.37280388E-03_JPRB, 0.37277776E-03_JPRB, 0.37284113E-03_JPRB, &
  & 0.37297171E-03_JPRB, 0.37324749E-03_JPRB, 0.37370039E-03_JPRB, 0.37432717E-03_JPRB, 0.37503096E-03_JPRB, 0.37573749E-03_JPRB, &
  & 0.37629843E-03_JPRB, 0.37672665E-03_JPRB, 0.37722226E-03_JPRB, 0.37767752E-03_JPRB, 0.37802143E-03_JPRB, 0.37819389E-03_JPRB, &
  & 0.37820271E-03_JPRB, 0.37800736E-03_JPRB, 0.37755633E-03_JPRB, 0.37690803E-03_JPRB, 0.37637240E-03_JPRB, 0.37597112E-03_JPRB, &
  & 0.37561168E-03_JPRB, 0.37532183E-03_JPRB, 0.37503070E-03_JPRB, 0.37469941E-03_JPRB, 0.37430228E-03_JPRB, 0.37388720E-03_JPRB, &
  & 0.37351003E-03_JPRB, 0.37320878E-03_JPRB, 0.37299694E-03_JPRB, 0.37284665E-03_JPRB, 0.37276783E-03_JPRB, 0.37272939E-03_JPRB, &
  & 0.37272166E-03_JPRB, 0.37272894E-03_JPRB, 0.37273525E-03_JPRB, 0.37273304E-03_JPRB, 0.37272494E-03_JPRB, 0.37269532E-03_JPRB, &
  & 0.37265514E-03_JPRB, 0.37262140E-03_JPRB, 0.37257995E-03_JPRB, 0.37254548E-03_JPRB, 0.37254254E-03_JPRB, 0.37255041E-03_JPRB, &
  & 0.37255221E-03_JPRB, 0.37254373E-03_JPRB, 0.37254035E-03_JPRB, 0.37254739E-03_JPRB  /)

RGHG1(:,21, 3) = (/ &
  & 0.37334603E-03_JPRB, 0.37332861E-03_JPRB, 0.37331356E-03_JPRB, 0.37327063E-03_JPRB, 0.37320446E-03_JPRB, 0.37313613E-03_JPRB, &
  & 0.37308627E-03_JPRB, 0.37308522E-03_JPRB, 0.37310350E-03_JPRB, 0.37312757E-03_JPRB, 0.37317727E-03_JPRB, 0.37319570E-03_JPRB, &
  & 0.37318545E-03_JPRB, 0.37314519E-03_JPRB, 0.37310007E-03_JPRB, 0.37305394E-03_JPRB, 0.37303610E-03_JPRB, 0.37309424E-03_JPRB, &
  & 0.37322855E-03_JPRB, 0.37352371E-03_JPRB, 0.37401189E-03_JPRB, 0.37467507E-03_JPRB, 0.37540554E-03_JPRB, 0.37617289E-03_JPRB, &
  & 0.37680012E-03_JPRB, 0.37724583E-03_JPRB, 0.37770252E-03_JPRB, 0.37812863E-03_JPRB, 0.37846138E-03_JPRB, 0.37867574E-03_JPRB, &
  & 0.37873279E-03_JPRB, 0.37857692E-03_JPRB, 0.37816577E-03_JPRB, 0.37755006E-03_JPRB, 0.37704746E-03_JPRB, 0.37668892E-03_JPRB, &
  & 0.37639940E-03_JPRB, 0.37617846E-03_JPRB, 0.37595429E-03_JPRB, 0.37566400E-03_JPRB, 0.37521650E-03_JPRB, 0.37469049E-03_JPRB, &
  & 0.37419054E-03_JPRB, 0.37379834E-03_JPRB, 0.37354129E-03_JPRB, 0.37335071E-03_JPRB, 0.37325415E-03_JPRB, 0.37320702E-03_JPRB, &
  & 0.37319044E-03_JPRB, 0.37318227E-03_JPRB, 0.37316736E-03_JPRB, 0.37313778E-03_JPRB, 0.37310925E-03_JPRB, 0.37306231E-03_JPRB, &
  & 0.37299570E-03_JPRB, 0.37294016E-03_JPRB, 0.37287368E-03_JPRB, 0.37280268E-03_JPRB, 0.37275950E-03_JPRB, 0.37275194E-03_JPRB, &
  & 0.37274362E-03_JPRB, 0.37271363E-03_JPRB, 0.37269218E-03_JPRB, 0.37269374E-03_JPRB  /)

RGHG1(:,22, 3) = (/ &
  & 0.37344176E-03_JPRB, 0.37344123E-03_JPRB, 0.37345086E-03_JPRB, 0.37342862E-03_JPRB, 0.37336133E-03_JPRB, 0.37328144E-03_JPRB, &
  & 0.37322324E-03_JPRB, 0.37321074E-03_JPRB, 0.37320956E-03_JPRB, 0.37321696E-03_JPRB, 0.37324264E-03_JPRB, 0.37325952E-03_JPRB, &
  & 0.37328684E-03_JPRB, 0.37332986E-03_JPRB, 0.37335779E-03_JPRB, 0.37336413E-03_JPRB, 0.37338876E-03_JPRB, 0.37346336E-03_JPRB, &
  & 0.37359978E-03_JPRB, 0.37389472E-03_JPRB, 0.37440513E-03_JPRB, 0.37510800E-03_JPRB, 0.37587138E-03_JPRB, 0.37669921E-03_JPRB, &
  & 0.37739059E-03_JPRB, 0.37788266E-03_JPRB, 0.37829543E-03_JPRB, 0.37866807E-03_JPRB, 0.37895346E-03_JPRB, 0.37916559E-03_JPRB, &
  & 0.37925288E-03_JPRB, 0.37914471E-03_JPRB, 0.37881228E-03_JPRB, 0.37829418E-03_JPRB, 0.37787263E-03_JPRB, 0.37759358E-03_JPRB, &
  & 0.37740813E-03_JPRB, 0.37727946E-03_JPRB, 0.37713890E-03_JPRB, 0.37686717E-03_JPRB, 0.37635619E-03_JPRB, 0.37573234E-03_JPRB, &
  & 0.37512077E-03_JPRB, 0.37462117E-03_JPRB, 0.37429553E-03_JPRB, 0.37405359E-03_JPRB, 0.37391699E-03_JPRB, 0.37384641E-03_JPRB, &
  & 0.37381237E-03_JPRB, 0.37377285E-03_JPRB, 0.37372370E-03_JPRB, 0.37365365E-03_JPRB, 0.37358687E-03_JPRB, 0.37351548E-03_JPRB, &
  & 0.37342185E-03_JPRB, 0.37334118E-03_JPRB, 0.37324702E-03_JPRB, 0.37314345E-03_JPRB, 0.37305068E-03_JPRB, 0.37300888E-03_JPRB, &
  & 0.37298132E-03_JPRB, 0.37293588E-03_JPRB, 0.37289075E-03_JPRB, 0.37287796E-03_JPRB  /)

RGHG1(:,23, 3) = (/ &
  & 0.37359024E-03_JPRB, 0.37360374E-03_JPRB, 0.37360934E-03_JPRB, 0.37358827E-03_JPRB, 0.37353200E-03_JPRB, 0.37346115E-03_JPRB, &
  & 0.37340388E-03_JPRB, 0.37338726E-03_JPRB, 0.37337584E-03_JPRB, 0.37338578E-03_JPRB, 0.37341389E-03_JPRB, 0.37344403E-03_JPRB, &
  & 0.37348956E-03_JPRB, 0.37355805E-03_JPRB, 0.37361986E-03_JPRB, 0.37366537E-03_JPRB, 0.37372326E-03_JPRB, 0.37381810E-03_JPRB, &
  & 0.37397660E-03_JPRB, 0.37427851E-03_JPRB, 0.37478099E-03_JPRB, 0.37551247E-03_JPRB, 0.37635668E-03_JPRB, 0.37722626E-03_JPRB, &
  & 0.37796333E-03_JPRB, 0.37850547E-03_JPRB, 0.37890233E-03_JPRB, 0.37923684E-03_JPRB, 0.37948656E-03_JPRB, 0.37966571E-03_JPRB, &
  & 0.37975066E-03_JPRB, 0.37968695E-03_JPRB, 0.37943591E-03_JPRB, 0.37903361E-03_JPRB, 0.37871272E-03_JPRB, 0.37850294E-03_JPRB, &
  & 0.37836344E-03_JPRB, 0.37825781E-03_JPRB, 0.37811226E-03_JPRB, 0.37781096E-03_JPRB, 0.37728619E-03_JPRB, 0.37661860E-03_JPRB, &
  & 0.37598198E-03_JPRB, 0.37542182E-03_JPRB, 0.37501195E-03_JPRB, 0.37472159E-03_JPRB, 0.37456122E-03_JPRB, 0.37448020E-03_JPRB, &
  & 0.37443323E-03_JPRB, 0.37437073E-03_JPRB, 0.37429437E-03_JPRB, 0.37418465E-03_JPRB, 0.37407315E-03_JPRB, 0.37397317E-03_JPRB, &
  & 0.37386474E-03_JPRB, 0.37376046E-03_JPRB, 0.37364858E-03_JPRB, 0.37352967E-03_JPRB, 0.37340124E-03_JPRB, 0.37331349E-03_JPRB, &
  & 0.37324388E-03_JPRB, 0.37318157E-03_JPRB, 0.37311679E-03_JPRB, 0.37307833E-03_JPRB  /)

RGHG1(:,24, 3) = (/ &
  & 0.37374210E-03_JPRB, 0.37376509E-03_JPRB, 0.37376246E-03_JPRB, 0.37373852E-03_JPRB, 0.37369531E-03_JPRB, 0.37364032E-03_JPRB, &
  & 0.37358957E-03_JPRB, 0.37357368E-03_JPRB, 0.37356175E-03_JPRB, 0.37358096E-03_JPRB, 0.37361852E-03_JPRB, 0.37366451E-03_JPRB, &
  & 0.37372424E-03_JPRB, 0.37380441E-03_JPRB, 0.37388807E-03_JPRB, 0.37396631E-03_JPRB, 0.37405244E-03_JPRB, 0.37416141E-03_JPRB, &
  & 0.37434136E-03_JPRB, 0.37466142E-03_JPRB, 0.37515902E-03_JPRB, 0.37589894E-03_JPRB, 0.37682252E-03_JPRB, 0.37774256E-03_JPRB, &
  & 0.37851726E-03_JPRB, 0.37910868E-03_JPRB, 0.37950520E-03_JPRB, 0.37981845E-03_JPRB, 0.38004399E-03_JPRB, 0.38018859E-03_JPRB, &
  & 0.38025929E-03_JPRB, 0.38022735E-03_JPRB, 0.38005194E-03_JPRB, 0.37976440E-03_JPRB, 0.37953555E-03_JPRB, 0.37937660E-03_JPRB, &
  & 0.37925170E-03_JPRB, 0.37912840E-03_JPRB, 0.37893913E-03_JPRB, 0.37860640E-03_JPRB, 0.37807743E-03_JPRB, 0.37738477E-03_JPRB, &
  & 0.37674906E-03_JPRB, 0.37615259E-03_JPRB, 0.37567573E-03_JPRB, 0.37535243E-03_JPRB, 0.37517134E-03_JPRB, 0.37508152E-03_JPRB, &
  & 0.37502369E-03_JPRB, 0.37494597E-03_JPRB, 0.37484773E-03_JPRB, 0.37470457E-03_JPRB, 0.37455570E-03_JPRB, 0.37442957E-03_JPRB, &
  & 0.37430608E-03_JPRB, 0.37418116E-03_JPRB, 0.37405674E-03_JPRB, 0.37392838E-03_JPRB, 0.37377269E-03_JPRB, 0.37364141E-03_JPRB, &
  & 0.37352690E-03_JPRB, 0.37344185E-03_JPRB, 0.37335836E-03_JPRB, 0.37329042E-03_JPRB  /)

RGHG1(:,25, 3) = (/ &
  & 0.37388124E-03_JPRB, 0.37390592E-03_JPRB, 0.37389445E-03_JPRB, 0.37386495E-03_JPRB, 0.37383510E-03_JPRB, 0.37380269E-03_JPRB, &
  & 0.37376606E-03_JPRB, 0.37375778E-03_JPRB, 0.37376052E-03_JPRB, 0.37379620E-03_JPRB, 0.37384928E-03_JPRB, 0.37391164E-03_JPRB, &
  & 0.37398219E-03_JPRB, 0.37406208E-03_JPRB, 0.37415411E-03_JPRB, 0.37425521E-03_JPRB, 0.37436148E-03_JPRB, 0.37447223E-03_JPRB, &
  & 0.37466705E-03_JPRB, 0.37502266E-03_JPRB, 0.37552779E-03_JPRB, 0.37624250E-03_JPRB, 0.37722855E-03_JPRB, 0.37821641E-03_JPRB, &
  & 0.37901689E-03_JPRB, 0.37965319E-03_JPRB, 0.38007069E-03_JPRB, 0.38039005E-03_JPRB, 0.38061022E-03_JPRB, 0.38072594E-03_JPRB, &
  & 0.38076927E-03_JPRB, 0.38074588E-03_JPRB, 0.38063191E-03_JPRB, 0.38044804E-03_JPRB, 0.38028740E-03_JPRB, 0.38014660E-03_JPRB, &
  & 0.37999320E-03_JPRB, 0.37979642E-03_JPRB, 0.37951675E-03_JPRB, 0.37916153E-03_JPRB, 0.37863436E-03_JPRB, 0.37793869E-03_JPRB, &
  & 0.37733035E-03_JPRB, 0.37673161E-03_JPRB, 0.37622484E-03_JPRB, 0.37589684E-03_JPRB, 0.37569778E-03_JPRB, 0.37559950E-03_JPRB, &
  & 0.37553396E-03_JPRB, 0.37545360E-03_JPRB, 0.37534228E-03_JPRB, 0.37517804E-03_JPRB, 0.37500802E-03_JPRB, 0.37486213E-03_JPRB, &
  & 0.37472104E-03_JPRB, 0.37458136E-03_JPRB, 0.37445185E-03_JPRB, 0.37432104E-03_JPRB, 0.37415106E-03_JPRB, 0.37398516E-03_JPRB, &
  & 0.37382784E-03_JPRB, 0.37371100E-03_JPRB, 0.37361039E-03_JPRB, 0.37351009E-03_JPRB  /)

RGHG1(:,26, 3) = (/ &
  & 0.37400158E-03_JPRB, 0.37402472E-03_JPRB, 0.37401186E-03_JPRB, 0.37398265E-03_JPRB, 0.37396355E-03_JPRB, 0.37394547E-03_JPRB, &
  & 0.37392487E-03_JPRB, 0.37393433E-03_JPRB, 0.37396100E-03_JPRB, 0.37401964E-03_JPRB, 0.37409252E-03_JPRB, 0.37417175E-03_JPRB, &
  & 0.37425362E-03_JPRB, 0.37433889E-03_JPRB, 0.37444037E-03_JPRB, 0.37455780E-03_JPRB, 0.37467721E-03_JPRB, 0.37480541E-03_JPRB, &
  & 0.37500511E-03_JPRB, 0.37537196E-03_JPRB, 0.37588922E-03_JPRB, 0.37656987E-03_JPRB, 0.37755542E-03_JPRB, 0.37860678E-03_JPRB, &
  & 0.37944412E-03_JPRB, 0.38010778E-03_JPRB, 0.38056759E-03_JPRB, 0.38090671E-03_JPRB, 0.38112790E-03_JPRB, 0.38123104E-03_JPRB, &
  & 0.38126205E-03_JPRB, 0.38124172E-03_JPRB, 0.38116582E-03_JPRB, 0.38104182E-03_JPRB, 0.38091304E-03_JPRB, 0.38076795E-03_JPRB, &
  & 0.38057740E-03_JPRB, 0.38031521E-03_JPRB, 0.37994531E-03_JPRB, 0.37953903E-03_JPRB, 0.37897086E-03_JPRB, 0.37828146E-03_JPRB, &
  & 0.37772027E-03_JPRB, 0.37716879E-03_JPRB, 0.37668071E-03_JPRB, 0.37636430E-03_JPRB, 0.37614976E-03_JPRB, 0.37602279E-03_JPRB, &
  & 0.37593763E-03_JPRB, 0.37584927E-03_JPRB, 0.37573136E-03_JPRB, 0.37556310E-03_JPRB, 0.37539466E-03_JPRB, 0.37523852E-03_JPRB, &
  & 0.37507491E-03_JPRB, 0.37492114E-03_JPRB, 0.37478925E-03_JPRB, 0.37465253E-03_JPRB, 0.37447310E-03_JPRB, 0.37429337E-03_JPRB, &
  & 0.37411518E-03_JPRB, 0.37397148E-03_JPRB, 0.37385442E-03_JPRB, 0.37373090E-03_JPRB  /)

RGHG1(:,27, 3) = (/ &
  & 0.37412043E-03_JPRB, 0.37414076E-03_JPRB, 0.37412922E-03_JPRB, 0.37410246E-03_JPRB, 0.37409363E-03_JPRB, 0.37408750E-03_JPRB, &
  & 0.37408436E-03_JPRB, 0.37411611E-03_JPRB, 0.37417122E-03_JPRB, 0.37425628E-03_JPRB, 0.37435146E-03_JPRB, 0.37444851E-03_JPRB, &
  & 0.37454241E-03_JPRB, 0.37463540E-03_JPRB, 0.37474714E-03_JPRB, 0.37487924E-03_JPRB, 0.37500979E-03_JPRB, 0.37516205E-03_JPRB, &
  & 0.37536315E-03_JPRB, 0.37573272E-03_JPRB, 0.37626438E-03_JPRB, 0.37690614E-03_JPRB, 0.37786781E-03_JPRB, 0.37898395E-03_JPRB, &
  & 0.37986395E-03_JPRB, 0.38054974E-03_JPRB, 0.38106168E-03_JPRB, 0.38142652E-03_JPRB, 0.38165113E-03_JPRB, 0.38174717E-03_JPRB, &
  & 0.38177089E-03_JPRB, 0.38175170E-03_JPRB, 0.38170696E-03_JPRB, 0.38162931E-03_JPRB, 0.38152036E-03_JPRB, 0.38136246E-03_JPRB, &
  & 0.38112986E-03_JPRB, 0.38080228E-03_JPRB, 0.38033811E-03_JPRB, 0.37986784E-03_JPRB, 0.37924095E-03_JPRB, 0.37856156E-03_JPRB, &
  & 0.37805698E-03_JPRB, 0.37757326E-03_JPRB, 0.37712275E-03_JPRB, 0.37682451E-03_JPRB, 0.37659470E-03_JPRB, 0.37643025E-03_JPRB, &
  & 0.37632016E-03_JPRB, 0.37622145E-03_JPRB, 0.37609906E-03_JPRB, 0.37593291E-03_JPRB, 0.37577456E-03_JPRB, 0.37561122E-03_JPRB, &
  & 0.37542225E-03_JPRB, 0.37525399E-03_JPRB, 0.37512060E-03_JPRB, 0.37497643E-03_JPRB, 0.37478892E-03_JPRB, 0.37460243E-03_JPRB, &
  & 0.37441055E-03_JPRB, 0.37424060E-03_JPRB, 0.37410661E-03_JPRB, 0.37396219E-03_JPRB  /)

RGHG1(:,28, 3) = (/ &
  & 0.37426316E-03_JPRB, 0.37428404E-03_JPRB, 0.37427357E-03_JPRB, 0.37424808E-03_JPRB, 0.37424489E-03_JPRB, 0.37424592E-03_JPRB, &
  & 0.37425614E-03_JPRB, 0.37431069E-03_JPRB, 0.37439830E-03_JPRB, 0.37450646E-03_JPRB, 0.37462692E-03_JPRB, 0.37475306E-03_JPRB, &
  & 0.37487321E-03_JPRB, 0.37498282E-03_JPRB, 0.37510538E-03_JPRB, 0.37524111E-03_JPRB, 0.37537836E-03_JPRB, 0.37554867E-03_JPRB, &
  & 0.37578107E-03_JPRB, 0.37613203E-03_JPRB, 0.37664096E-03_JPRB, 0.37725650E-03_JPRB, 0.37814799E-03_JPRB, 0.37925946E-03_JPRB, &
  & 0.38019751E-03_JPRB, 0.38092275E-03_JPRB, 0.38146027E-03_JPRB, 0.38184337E-03_JPRB, 0.38208057E-03_JPRB, 0.38219963E-03_JPRB, &
  & 0.38224986E-03_JPRB, 0.38224964E-03_JPRB, 0.38220599E-03_JPRB, 0.38211566E-03_JPRB, 0.38197262E-03_JPRB, 0.38176681E-03_JPRB, &
  & 0.38148756E-03_JPRB, 0.38109930E-03_JPRB, 0.38057608E-03_JPRB, 0.38002487E-03_JPRB, 0.37938467E-03_JPRB, 0.37878068E-03_JPRB, &
  & 0.37834197E-03_JPRB, 0.37791181E-03_JPRB, 0.37752343E-03_JPRB, 0.37722744E-03_JPRB, 0.37697118E-03_JPRB, 0.37677584E-03_JPRB, &
  & 0.37663856E-03_JPRB, 0.37650674E-03_JPRB, 0.37635731E-03_JPRB, 0.37620412E-03_JPRB, 0.37605615E-03_JPRB, 0.37589668E-03_JPRB, &
  & 0.37569476E-03_JPRB, 0.37551013E-03_JPRB, 0.37536861E-03_JPRB, 0.37521519E-03_JPRB, 0.37500559E-03_JPRB, 0.37482291E-03_JPRB, &
  & 0.37463828E-03_JPRB, 0.37446643E-03_JPRB, 0.37433060E-03_JPRB, 0.37417663E-03_JPRB  /)

RGHG1(:,29, 3) = (/ &
  & 0.37441543E-03_JPRB, 0.37443703E-03_JPRB, 0.37442769E-03_JPRB, 0.37440348E-03_JPRB, 0.37440608E-03_JPRB, 0.37441450E-03_JPRB, &
  & 0.37443869E-03_JPRB, 0.37451742E-03_JPRB, 0.37463964E-03_JPRB, 0.37477214E-03_JPRB, 0.37491950E-03_JPRB, 0.37507696E-03_JPRB, &
  & 0.37522554E-03_JPRB, 0.37535314E-03_JPRB, 0.37548719E-03_JPRB, 0.37562629E-03_JPRB, 0.37577045E-03_JPRB, 0.37595964E-03_JPRB, &
  & 0.37622648E-03_JPRB, 0.37655681E-03_JPRB, 0.37704003E-03_JPRB, 0.37762835E-03_JPRB, 0.37844346E-03_JPRB, 0.37954698E-03_JPRB, &
  & 0.38054719E-03_JPRB, 0.38131500E-03_JPRB, 0.38187846E-03_JPRB, 0.38228060E-03_JPRB, 0.38253153E-03_JPRB, 0.38267628E-03_JPRB, &
  & 0.38275608E-03_JPRB, 0.38277674E-03_JPRB, 0.38273292E-03_JPRB, 0.38262661E-03_JPRB, 0.38244510E-03_JPRB, 0.38218701E-03_JPRB, &
  & 0.38185812E-03_JPRB, 0.38140577E-03_JPRB, 0.38082151E-03_JPRB, 0.38018381E-03_JPRB, 0.37953148E-03_JPRB, 0.37901022E-03_JPRB, &
  & 0.37864170E-03_JPRB, 0.37826768E-03_JPRB, 0.37794620E-03_JPRB, 0.37765190E-03_JPRB, 0.37736712E-03_JPRB, 0.37713934E-03_JPRB, &
  & 0.37697314E-03_JPRB, 0.37680526E-03_JPRB, 0.37662619E-03_JPRB, 0.37648723E-03_JPRB, 0.37635025E-03_JPRB, 0.37619536E-03_JPRB, &
  & 0.37598028E-03_JPRB, 0.37577822E-03_JPRB, 0.37562778E-03_JPRB, 0.37546448E-03_JPRB, 0.37523087E-03_JPRB, 0.37505269E-03_JPRB, &
  & 0.37487665E-03_JPRB, 0.37470384E-03_JPRB, 0.37456672E-03_JPRB, 0.37440311E-03_JPRB  /)

RGHG1(:,30, 3) = (/ &
  & 0.37457354E-03_JPRB, 0.37459437E-03_JPRB, 0.37458276E-03_JPRB, 0.37455969E-03_JPRB, 0.37457019E-03_JPRB, 0.37459731E-03_JPRB, &
  & 0.37464466E-03_JPRB, 0.37475826E-03_JPRB, 0.37492264E-03_JPRB, 0.37508980E-03_JPRB, 0.37527006E-03_JPRB, 0.37546572E-03_JPRB, &
  & 0.37565546E-03_JPRB, 0.37580911E-03_JPRB, 0.37595579E-03_JPRB, 0.37611014E-03_JPRB, 0.37628041E-03_JPRB, 0.37649297E-03_JPRB, &
  & 0.37677283E-03_JPRB, 0.37712007E-03_JPRB, 0.37758789E-03_JPRB, 0.37814274E-03_JPRB, 0.37887530E-03_JPRB, 0.37988329E-03_JPRB, &
  & 0.38088546E-03_JPRB, 0.38168216E-03_JPRB, 0.38226081E-03_JPRB, 0.38266621E-03_JPRB, 0.38292309E-03_JPRB, 0.38307668E-03_JPRB, &
  & 0.38316638E-03_JPRB, 0.38319870E-03_JPRB, 0.38315023E-03_JPRB, 0.38300701E-03_JPRB, 0.38277890E-03_JPRB, 0.38248590E-03_JPRB, &
  & 0.38210730E-03_JPRB, 0.38163542E-03_JPRB, 0.38106670E-03_JPRB, 0.38049622E-03_JPRB, 0.37995247E-03_JPRB, 0.37948370E-03_JPRB, &
  & 0.37911764E-03_JPRB, 0.37874939E-03_JPRB, 0.37841386E-03_JPRB, 0.37807835E-03_JPRB, 0.37775256E-03_JPRB, 0.37749582E-03_JPRB, &
  & 0.37731513E-03_JPRB, 0.37712817E-03_JPRB, 0.37691669E-03_JPRB, 0.37675156E-03_JPRB, 0.37660875E-03_JPRB, 0.37644447E-03_JPRB, &
  & 0.37622479E-03_JPRB, 0.37601686E-03_JPRB, 0.37585640E-03_JPRB, 0.37569061E-03_JPRB, 0.37544506E-03_JPRB, 0.37525277E-03_JPRB, &
  & 0.37509382E-03_JPRB, 0.37493681E-03_JPRB, 0.37481648E-03_JPRB, 0.37464200E-03_JPRB  /)

RGHG1(:,31, 3) = (/ &
  & 0.37474014E-03_JPRB, 0.37476014E-03_JPRB, 0.37474616E-03_JPRB, 0.37472427E-03_JPRB, 0.37474311E-03_JPRB, 0.37478995E-03_JPRB, &
  & 0.37486171E-03_JPRB, 0.37501206E-03_JPRB, 0.37522086E-03_JPRB, 0.37542455E-03_JPRB, 0.37563949E-03_JPRB, 0.37587540E-03_JPRB, &
  & 0.37610852E-03_JPRB, 0.37628963E-03_JPRB, 0.37644963E-03_JPRB, 0.37662005E-03_JPRB, 0.37681785E-03_JPRB, 0.37705503E-03_JPRB, &
  & 0.37734858E-03_JPRB, 0.37771368E-03_JPRB, 0.37816528E-03_JPRB, 0.37868487E-03_JPRB, 0.37933044E-03_JPRB, 0.38023769E-03_JPRB, &
  & 0.38124186E-03_JPRB, 0.38206900E-03_JPRB, 0.38266365E-03_JPRB, 0.38307247E-03_JPRB, 0.38333559E-03_JPRB, 0.38349849E-03_JPRB, &
  & 0.38359860E-03_JPRB, 0.38364320E-03_JPRB, 0.38358982E-03_JPRB, 0.38340768E-03_JPRB, 0.38313046E-03_JPRB, 0.38280071E-03_JPRB, &
  & 0.38236973E-03_JPRB, 0.38187731E-03_JPRB, 0.38132504E-03_JPRB, 0.38082555E-03_JPRB, 0.38039630E-03_JPRB, 0.37998281E-03_JPRB, &
  & 0.37961929E-03_JPRB, 0.37925706E-03_JPRB, 0.37890665E-03_JPRB, 0.37852769E-03_JPRB, 0.37815867E-03_JPRB, 0.37787142E-03_JPRB, &
  & 0.37767548E-03_JPRB, 0.37746843E-03_JPRB, 0.37722280E-03_JPRB, 0.37703007E-03_JPRB, 0.37688107E-03_JPRB, 0.37670690E-03_JPRB, &
  & 0.37648239E-03_JPRB, 0.37626828E-03_JPRB, 0.37609725E-03_JPRB, 0.37592886E-03_JPRB, 0.37567073E-03_JPRB, 0.37546356E-03_JPRB, &
  & 0.37532262E-03_JPRB, 0.37518227E-03_JPRB, 0.37507966E-03_JPRB, 0.37489371E-03_JPRB  /)

RGHG1(:,32, 3) = (/ &
  & 0.37504334E-03_JPRB, 0.37503366E-03_JPRB, 0.37499582E-03_JPRB, 0.37496406E-03_JPRB, 0.37498322E-03_JPRB, 0.37505585E-03_JPRB, &
  & 0.37516235E-03_JPRB, 0.37535876E-03_JPRB, 0.37561303E-03_JPRB, 0.37587594E-03_JPRB, 0.37614239E-03_JPRB, 0.37641247E-03_JPRB, &
  & 0.37667321E-03_JPRB, 0.37689402E-03_JPRB, 0.37709527E-03_JPRB, 0.37729711E-03_JPRB, 0.37753330E-03_JPRB, 0.37781898E-03_JPRB, &
  & 0.37814896E-03_JPRB, 0.37853107E-03_JPRB, 0.37896728E-03_JPRB, 0.37944768E-03_JPRB, 0.38000150E-03_JPRB, 0.38078055E-03_JPRB, &
  & 0.38167761E-03_JPRB, 0.38245242E-03_JPRB, 0.38303656E-03_JPRB, 0.38344636E-03_JPRB, 0.38370245E-03_JPRB, 0.38385440E-03_JPRB, &
  & 0.38394578E-03_JPRB, 0.38398947E-03_JPRB, 0.38394045E-03_JPRB, 0.38374927E-03_JPRB, 0.38346044E-03_JPRB, 0.38312350E-03_JPRB, &
  & 0.38270583E-03_JPRB, 0.38226960E-03_JPRB, 0.38182096E-03_JPRB, 0.38141930E-03_JPRB, 0.38105976E-03_JPRB, 0.38067444E-03_JPRB, &
  & 0.38029856E-03_JPRB, 0.37989836E-03_JPRB, 0.37948252E-03_JPRB, 0.37904831E-03_JPRB, 0.37863580E-03_JPRB, 0.37830439E-03_JPRB, &
  & 0.37808340E-03_JPRB, 0.37786598E-03_JPRB, 0.37760620E-03_JPRB, 0.37738190E-03_JPRB, 0.37720539E-03_JPRB, 0.37700796E-03_JPRB, &
  & 0.37678471E-03_JPRB, 0.37657525E-03_JPRB, 0.37640305E-03_JPRB, 0.37622652E-03_JPRB, 0.37597413E-03_JPRB, 0.37576190E-03_JPRB, &
  & 0.37562270E-03_JPRB, 0.37549996E-03_JPRB, 0.37542722E-03_JPRB, 0.37526115E-03_JPRB  /)

RGHG1(:,33, 3) = (/ &
  & 0.37537612E-03_JPRB, 0.37533187E-03_JPRB, 0.37526644E-03_JPRB, 0.37522299E-03_JPRB, 0.37524146E-03_JPRB, 0.37534166E-03_JPRB, &
  & 0.37548561E-03_JPRB, 0.37573110E-03_JPRB, 0.37603276E-03_JPRB, 0.37636013E-03_JPRB, 0.37668231E-03_JPRB, 0.37698711E-03_JPRB, &
  & 0.37727452E-03_JPRB, 0.37753817E-03_JPRB, 0.37778590E-03_JPRB, 0.37802240E-03_JPRB, 0.37829988E-03_JPRB, 0.37863904E-03_JPRB, &
  & 0.37900984E-03_JPRB, 0.37940952E-03_JPRB, 0.37982983E-03_JPRB, 0.38026900E-03_JPRB, 0.38072686E-03_JPRB, 0.38136912E-03_JPRB, &
  & 0.38214074E-03_JPRB, 0.38285045E-03_JPRB, 0.38342024E-03_JPRB, 0.38383074E-03_JPRB, 0.38407780E-03_JPRB, 0.38421575E-03_JPRB, &
  & 0.38429558E-03_JPRB, 0.38433660E-03_JPRB, 0.38429333E-03_JPRB, 0.38409662E-03_JPRB, 0.38380058E-03_JPRB, 0.38346000E-03_JPRB, &
  & 0.38306465E-03_JPRB, 0.38269674E-03_JPRB, 0.38236711E-03_JPRB, 0.38207059E-03_JPRB, 0.38177769E-03_JPRB, 0.38141813E-03_JPRB, &
  & 0.38102748E-03_JPRB, 0.38058214E-03_JPRB, 0.38009174E-03_JPRB, 0.37959859E-03_JPRB, 0.37914086E-03_JPRB, 0.37876178E-03_JPRB, &
  & 0.37851349E-03_JPRB, 0.37828655E-03_JPRB, 0.37801466E-03_JPRB, 0.37775704E-03_JPRB, 0.37754916E-03_JPRB, 0.37732584E-03_JPRB, &
  & 0.37710468E-03_JPRB, 0.37690145E-03_JPRB, 0.37672925E-03_JPRB, 0.37654356E-03_JPRB, 0.37629949E-03_JPRB, 0.37608327E-03_JPRB, &
  & 0.37594380E-03_JPRB, 0.37583947E-03_JPRB, 0.37579934E-03_JPRB, 0.37565798E-03_JPRB  /)

RGHG1(:,34, 3) = (/ &
  & 0.37583520E-03_JPRB, 0.37575318E-03_JPRB, 0.37564806E-03_JPRB, 0.37558285E-03_JPRB, 0.37560765E-03_JPRB, 0.37573811E-03_JPRB, &
  & 0.37591927E-03_JPRB, 0.37621224E-03_JPRB, 0.37655880E-03_JPRB, 0.37693516E-03_JPRB, 0.37729864E-03_JPRB, 0.37763288E-03_JPRB, &
  & 0.37794540E-03_JPRB, 0.37824050E-03_JPRB, 0.37853017E-03_JPRB, 0.37880050E-03_JPRB, 0.37910506E-03_JPRB, 0.37946197E-03_JPRB, &
  & 0.37983414E-03_JPRB, 0.38022652E-03_JPRB, 0.38063484E-03_JPRB, 0.38103626E-03_JPRB, 0.38141521E-03_JPRB, 0.38194269E-03_JPRB, &
  & 0.38258856E-03_JPRB, 0.38320060E-03_JPRB, 0.38371963E-03_JPRB, 0.38411402E-03_JPRB, 0.38435954E-03_JPRB, 0.38449894E-03_JPRB, &
  & 0.38458584E-03_JPRB, 0.38464529E-03_JPRB, 0.38461694E-03_JPRB, 0.38442345E-03_JPRB, 0.38413331E-03_JPRB, 0.38381601E-03_JPRB, &
  & 0.38345958E-03_JPRB, 0.38313709E-03_JPRB, 0.38286103E-03_JPRB, 0.38261658E-03_JPRB, 0.38237630E-03_JPRB, 0.38205898E-03_JPRB, &
  & 0.38168040E-03_JPRB, 0.38122167E-03_JPRB, 0.38069612E-03_JPRB, 0.38016275E-03_JPRB, 0.37965983E-03_JPRB, 0.37923208E-03_JPRB, &
  & 0.37895136E-03_JPRB, 0.37870789E-03_JPRB, 0.37842286E-03_JPRB, 0.37815099E-03_JPRB, 0.37791784E-03_JPRB, 0.37766975E-03_JPRB, &
  & 0.37744718E-03_JPRB, 0.37725092E-03_JPRB, 0.37708913E-03_JPRB, 0.37690822E-03_JPRB, 0.37668201E-03_JPRB, 0.37648191E-03_JPRB, &
  & 0.37635646E-03_JPRB, 0.37626260E-03_JPRB, 0.37623903E-03_JPRB, 0.37614657E-03_JPRB  /)

RGHG1(:,35, 3) = (/ &
  & 0.37637201E-03_JPRB, 0.37624952E-03_JPRB, 0.37609737E-03_JPRB, 0.37600461E-03_JPRB, 0.37603955E-03_JPRB, 0.37620249E-03_JPRB, &
  & 0.37642178E-03_JPRB, 0.37676275E-03_JPRB, 0.37715419E-03_JPRB, 0.37757297E-03_JPRB, 0.37797153E-03_JPRB, 0.37833331E-03_JPRB, &
  & 0.37867083E-03_JPRB, 0.37899244E-03_JPRB, 0.37932290E-03_JPRB, 0.37962760E-03_JPRB, 0.37995268E-03_JPRB, 0.38030953E-03_JPRB, &
  & 0.38066286E-03_JPRB, 0.38103497E-03_JPRB, 0.38143297E-03_JPRB, 0.38179736E-03_JPRB, 0.38210395E-03_JPRB, 0.38252471E-03_JPRB, &
  & 0.38304111E-03_JPRB, 0.38353604E-03_JPRB, 0.38398420E-03_JPRB, 0.38435338E-03_JPRB, 0.38460118E-03_JPRB, 0.38475000E-03_JPRB, &
  & 0.38485373E-03_JPRB, 0.38494292E-03_JPRB, 0.38493465E-03_JPRB, 0.38474895E-03_JPRB, 0.38447161E-03_JPRB, 0.38419204E-03_JPRB, &
  & 0.38388414E-03_JPRB, 0.38359659E-03_JPRB, 0.38334203E-03_JPRB, 0.38312389E-03_JPRB, 0.38293051E-03_JPRB, 0.38266510E-03_JPRB, &
  & 0.38231269E-03_JPRB, 0.38185649E-03_JPRB, 0.38131503E-03_JPRB, 0.38074989E-03_JPRB, 0.38020053E-03_JPRB, 0.37972225E-03_JPRB, &
  & 0.37940553E-03_JPRB, 0.37914147E-03_JPRB, 0.37884242E-03_JPRB, 0.37856567E-03_JPRB, 0.37830966E-03_JPRB, 0.37803669E-03_JPRB, &
  & 0.37781088E-03_JPRB, 0.37762214E-03_JPRB, 0.37747640E-03_JPRB, 0.37730757E-03_JPRB, 0.37710462E-03_JPRB, 0.37693141E-03_JPRB, &
  & 0.37682773E-03_JPRB, 0.37674056E-03_JPRB, 0.37672575E-03_JPRB, 0.37669597E-03_JPRB  /)

RGHG1(:,36, 3) = (/ &
  & 0.37700223E-03_JPRB, 0.37685553E-03_JPRB, 0.37665853E-03_JPRB, 0.37653530E-03_JPRB, 0.37657929E-03_JPRB, 0.37676522E-03_JPRB, &
  & 0.37701679E-03_JPRB, 0.37740012E-03_JPRB, 0.37783125E-03_JPRB, 0.37828641E-03_JPRB, 0.37870923E-03_JPRB, 0.37909011E-03_JPRB, &
  & 0.37944347E-03_JPRB, 0.37977886E-03_JPRB, 0.38013059E-03_JPRB, 0.38045024E-03_JPRB, 0.38077480E-03_JPRB, 0.38111048E-03_JPRB, &
  & 0.38143078E-03_JPRB, 0.38176533E-03_JPRB, 0.38213598E-03_JPRB, 0.38245892E-03_JPRB, 0.38270550E-03_JPRB, 0.38303973E-03_JPRB, &
  & 0.38344697E-03_JPRB, 0.38383692E-03_JPRB, 0.38421652E-03_JPRB, 0.38455779E-03_JPRB, 0.38481240E-03_JPRB, 0.38497920E-03_JPRB, &
  & 0.38511334E-03_JPRB, 0.38524778E-03_JPRB, 0.38525626E-03_JPRB, 0.38507440E-03_JPRB, 0.38480253E-03_JPRB, 0.38453833E-03_JPRB, &
  & 0.38425972E-03_JPRB, 0.38399727E-03_JPRB, 0.38376177E-03_JPRB, 0.38356247E-03_JPRB, 0.38340759E-03_JPRB, 0.38319795E-03_JPRB, &
  & 0.38288171E-03_JPRB, 0.38243398E-03_JPRB, 0.38188349E-03_JPRB, 0.38129463E-03_JPRB, 0.38071268E-03_JPRB, 0.38019356E-03_JPRB, &
  & 0.37984399E-03_JPRB, 0.37956547E-03_JPRB, 0.37925772E-03_JPRB, 0.37897707E-03_JPRB, 0.37870366E-03_JPRB, 0.37840859E-03_JPRB, &
  & 0.37818538E-03_JPRB, 0.37801012E-03_JPRB, 0.37788783E-03_JPRB, 0.37773992E-03_JPRB, 0.37756110E-03_JPRB, 0.37741817E-03_JPRB, &
  & 0.37734084E-03_JPRB, 0.37727023E-03_JPRB, 0.37726239E-03_JPRB, 0.37728859E-03_JPRB  /)

RGHG1(:,37, 3) = (/ &
  & 0.37780743E-03_JPRB, 0.37767530E-03_JPRB, 0.37744125E-03_JPRB, 0.37728270E-03_JPRB, 0.37733268E-03_JPRB, 0.37751843E-03_JPRB, &
  & 0.37778685E-03_JPRB, 0.37819699E-03_JPRB, 0.37865343E-03_JPRB, 0.37912885E-03_JPRB, 0.37954963E-03_JPRB, 0.37992907E-03_JPRB, &
  & 0.38027626E-03_JPRB, 0.38059539E-03_JPRB, 0.38092230E-03_JPRB, 0.38121148E-03_JPRB, 0.38148729E-03_JPRB, 0.38175474E-03_JPRB, &
  & 0.38201154E-03_JPRB, 0.38227118E-03_JPRB, 0.38257720E-03_JPRB, 0.38285108E-03_JPRB, 0.38306973E-03_JPRB, 0.38336911E-03_JPRB, &
  & 0.38372053E-03_JPRB, 0.38403984E-03_JPRB, 0.38436043E-03_JPRB, 0.38466932E-03_JPRB, 0.38494072E-03_JPRB, 0.38514405E-03_JPRB, &
  & 0.38533785E-03_JPRB, 0.38555024E-03_JPRB, 0.38556681E-03_JPRB, 0.38537950E-03_JPRB, 0.38509593E-03_JPRB, 0.38479485E-03_JPRB, &
  & 0.38449963E-03_JPRB, 0.38423815E-03_JPRB, 0.38401494E-03_JPRB, 0.38381618E-03_JPRB, 0.38367815E-03_JPRB, 0.38352967E-03_JPRB, &
  & 0.38327028E-03_JPRB, 0.38284408E-03_JPRB, 0.38230090E-03_JPRB, 0.38170827E-03_JPRB, 0.38112752E-03_JPRB, 0.38059232E-03_JPRB, &
  & 0.38021913E-03_JPRB, 0.37994108E-03_JPRB, 0.37963741E-03_JPRB, 0.37935532E-03_JPRB, 0.37907813E-03_JPRB, 0.37876874E-03_JPRB, &
  & 0.37856135E-03_JPRB, 0.37841236E-03_JPRB, 0.37832905E-03_JPRB, 0.37822102E-03_JPRB, 0.37806684E-03_JPRB, 0.37796007E-03_JPRB, &
  & 0.37791800E-03_JPRB, 0.37788552E-03_JPRB, 0.37788008E-03_JPRB, 0.37794340E-03_JPRB  /)

RGHG1(:,38, 3) = (/ &
  & 0.37870088E-03_JPRB, 0.37858491E-03_JPRB, 0.37830974E-03_JPRB, 0.37811200E-03_JPRB, 0.37816864E-03_JPRB, 0.37835419E-03_JPRB, &
  & 0.37864130E-03_JPRB, 0.37908118E-03_JPRB, 0.37956570E-03_JPRB, 0.38006361E-03_JPRB, 0.38048213E-03_JPRB, 0.38085997E-03_JPRB, &
  & 0.38120031E-03_JPRB, 0.38150141E-03_JPRB, 0.38180077E-03_JPRB, 0.38205616E-03_JPRB, 0.38227787E-03_JPRB, 0.38246960E-03_JPRB, &
  & 0.38265594E-03_JPRB, 0.38283248E-03_JPRB, 0.38306677E-03_JPRB, 0.38328623E-03_JPRB, 0.38347386E-03_JPRB, 0.38373460E-03_JPRB, &
  & 0.38402407E-03_JPRB, 0.38426499E-03_JPRB, 0.38452012E-03_JPRB, 0.38479308E-03_JPRB, 0.38508311E-03_JPRB, 0.38532695E-03_JPRB, &
  & 0.38558696E-03_JPRB, 0.38588584E-03_JPRB, 0.38591140E-03_JPRB, 0.38571804E-03_JPRB, 0.38542149E-03_JPRB, 0.38507949E-03_JPRB, &
  & 0.38476584E-03_JPRB, 0.38450542E-03_JPRB, 0.38429586E-03_JPRB, 0.38409769E-03_JPRB, 0.38397836E-03_JPRB, 0.38389775E-03_JPRB, &
  & 0.38370144E-03_JPRB, 0.38329911E-03_JPRB, 0.38276406E-03_JPRB, 0.38216723E-03_JPRB, 0.38158781E-03_JPRB, 0.38103479E-03_JPRB, &
  & 0.38063538E-03_JPRB, 0.38035786E-03_JPRB, 0.38005872E-03_JPRB, 0.37977503E-03_JPRB, 0.37949365E-03_JPRB, 0.37916835E-03_JPRB, &
  & 0.37897853E-03_JPRB, 0.37885868E-03_JPRB, 0.37881862E-03_JPRB, 0.37875483E-03_JPRB, 0.37862801E-03_JPRB, 0.37856136E-03_JPRB, &
  & 0.37855841E-03_JPRB, 0.37856825E-03_JPRB, 0.37856547E-03_JPRB, 0.37866997E-03_JPRB  /)

RGHG1(:,39, 3) = (/ &
  & 0.37977794E-03_JPRB, 0.37972181E-03_JPRB, 0.37945175E-03_JPRB, 0.37921213E-03_JPRB, 0.37922660E-03_JPRB, 0.37939074E-03_JPRB, &
  & 0.37967665E-03_JPRB, 0.38012232E-03_JPRB, 0.38059883E-03_JPRB, 0.38106255E-03_JPRB, 0.38142686E-03_JPRB, 0.38175239E-03_JPRB, &
  & 0.38202905E-03_JPRB, 0.38226014E-03_JPRB, 0.38248262E-03_JPRB, 0.38266644E-03_JPRB, 0.38281023E-03_JPRB, 0.38290837E-03_JPRB, &
  & 0.38301311E-03_JPRB, 0.38312756E-03_JPRB, 0.38329311E-03_JPRB, 0.38345853E-03_JPRB, 0.38361682E-03_JPRB, 0.38384085E-03_JPRB, &
  & 0.38409695E-03_JPRB, 0.38432145E-03_JPRB, 0.38456492E-03_JPRB, 0.38482296E-03_JPRB, 0.38510996E-03_JPRB, 0.38540212E-03_JPRB, &
  & 0.38572913E-03_JPRB, 0.38607856E-03_JPRB, 0.38613781E-03_JPRB, 0.38594897E-03_JPRB, 0.38563916E-03_JPRB, 0.38526602E-03_JPRB, &
  & 0.38491849E-03_JPRB, 0.38463738E-03_JPRB, 0.38443613E-03_JPRB, 0.38423177E-03_JPRB, 0.38412157E-03_JPRB, 0.38408027E-03_JPRB, &
  & 0.38392733E-03_JPRB, 0.38355798E-03_JPRB, 0.38303005E-03_JPRB, 0.38244113E-03_JPRB, 0.38186317E-03_JPRB, 0.38132222E-03_JPRB, &
  & 0.38092626E-03_JPRB, 0.38066316E-03_JPRB, 0.38038146E-03_JPRB, 0.38010911E-03_JPRB, 0.37982277E-03_JPRB, 0.37949505E-03_JPRB, &
  & 0.37934782E-03_JPRB, 0.37927389E-03_JPRB, 0.37928678E-03_JPRB, 0.37927339E-03_JPRB, 0.37918307E-03_JPRB, 0.37912487E-03_JPRB, &
  & 0.37913633E-03_JPRB, 0.37921121E-03_JPRB, 0.37921652E-03_JPRB, 0.37928318E-03_JPRB  /)

RGHG1(:,40, 3) = (/ &
  & 0.38107200E-03_JPRB, 0.38109324E-03_JPRB, 0.38083674E-03_JPRB, 0.38054753E-03_JPRB, 0.38050454E-03_JPRB, 0.38064007E-03_JPRB, &
  & 0.38092130E-03_JPRB, 0.38136986E-03_JPRB, 0.38183108E-03_JPRB, 0.38224539E-03_JPRB, 0.38253758E-03_JPRB, 0.38279342E-03_JPRB, &
  & 0.38298606E-03_JPRB, 0.38312647E-03_JPRB, 0.38325066E-03_JPRB, 0.38334432E-03_JPRB, 0.38339276E-03_JPRB, 0.38337814E-03_JPRB, &
  & 0.38338529E-03_JPRB, 0.38343031E-03_JPRB, 0.38351568E-03_JPRB, 0.38361775E-03_JPRB, 0.38374186E-03_JPRB, 0.38392315E-03_JPRB, &
  & 0.38414476E-03_JPRB, 0.38436010E-03_JPRB, 0.38459871E-03_JPRB, 0.38484267E-03_JPRB, 0.38512256E-03_JPRB, 0.38547270E-03_JPRB, &
  & 0.38587849E-03_JPRB, 0.38628135E-03_JPRB, 0.38638418E-03_JPRB, 0.38620238E-03_JPRB, 0.38587695E-03_JPRB, 0.38546888E-03_JPRB, &
  & 0.38507904E-03_JPRB, 0.38477010E-03_JPRB, 0.38457775E-03_JPRB, 0.38436501E-03_JPRB, 0.38426395E-03_JPRB, 0.38426412E-03_JPRB, &
  & 0.38415886E-03_JPRB, 0.38382970E-03_JPRB, 0.38330995E-03_JPRB, 0.38273230E-03_JPRB, 0.38215606E-03_JPRB, 0.38163418E-03_JPRB, &
  & 0.38124712E-03_JPRB, 0.38100322E-03_JPRB, 0.38074411E-03_JPRB, 0.38048718E-03_JPRB, 0.38019489E-03_JPRB, 0.37986653E-03_JPRB, &
  & 0.37977337E-03_JPRB, 0.37975607E-03_JPRB, 0.37983270E-03_JPRB, 0.37987947E-03_JPRB, 0.37983350E-03_JPRB, 0.37978003E-03_JPRB, &
  & 0.37980435E-03_JPRB, 0.37995929E-03_JPRB, 0.37997496E-03_JPRB, 0.37998428E-03_JPRB  /)

RGHG1(:,41, 3) = (/ &
  & 0.38265417E-03_JPRB, 0.38277001E-03_JPRB, 0.38253010E-03_JPRB, 0.38218025E-03_JPRB, 0.38206700E-03_JPRB, 0.38216755E-03_JPRB, &
  & 0.38244308E-03_JPRB, 0.38289515E-03_JPRB, 0.38333767E-03_JPRB, 0.38369159E-03_JPRB, 0.38389560E-03_JPRB, 0.38406624E-03_JPRB, &
  & 0.38415615E-03_JPRB, 0.38418569E-03_JPRB, 0.38418970E-03_JPRB, 0.38417312E-03_JPRB, 0.38410498E-03_JPRB, 0.38395251E-03_JPRB, &
  & 0.38384034E-03_JPRB, 0.38380047E-03_JPRB, 0.38378780E-03_JPRB, 0.38381241E-03_JPRB, 0.38389474E-03_JPRB, 0.38402377E-03_JPRB, &
  & 0.38420320E-03_JPRB, 0.38440735E-03_JPRB, 0.38464002E-03_JPRB, 0.38486677E-03_JPRB, 0.38513798E-03_JPRB, 0.38555900E-03_JPRB, &
  & 0.38606110E-03_JPRB, 0.38652930E-03_JPRB, 0.38668541E-03_JPRB, 0.38651221E-03_JPRB, 0.38616769E-03_JPRB, 0.38571690E-03_JPRB, &
  & 0.38527535E-03_JPRB, 0.38493237E-03_JPRB, 0.38475090E-03_JPRB, 0.38452790E-03_JPRB, 0.38443804E-03_JPRB, 0.38448890E-03_JPRB, &
  & 0.38444193E-03_JPRB, 0.38416191E-03_JPRB, 0.38365217E-03_JPRB, 0.38308829E-03_JPRB, 0.38251417E-03_JPRB, 0.38201561E-03_JPRB, &
  & 0.38163941E-03_JPRB, 0.38141899E-03_JPRB, 0.38118750E-03_JPRB, 0.38094943E-03_JPRB, 0.38064986E-03_JPRB, 0.38032071E-03_JPRB, &
  & 0.38029367E-03_JPRB, 0.38034561E-03_JPRB, 0.38050017E-03_JPRB, 0.38062048E-03_JPRB, 0.38062873E-03_JPRB, 0.38058106E-03_JPRB, &
  & 0.38062110E-03_JPRB, 0.38087392E-03_JPRB, 0.38090226E-03_JPRB, 0.38084148E-03_JPRB  /)

RGHG1(:,42, 3) = (/ &
  & 0.38397035E-03_JPRB, 0.38402112E-03_JPRB, 0.38381315E-03_JPRB, 0.38341127E-03_JPRB, 0.38326102E-03_JPRB, 0.38332334E-03_JPRB, &
  & 0.38352728E-03_JPRB, 0.38394902E-03_JPRB, 0.38427821E-03_JPRB, 0.38451672E-03_JPRB, 0.38459846E-03_JPRB, 0.38463459E-03_JPRB, &
  & 0.38457795E-03_JPRB, 0.38448297E-03_JPRB, 0.38435941E-03_JPRB, 0.38424161E-03_JPRB, 0.38410231E-03_JPRB, 0.38392305E-03_JPRB, &
  & 0.38378864E-03_JPRB, 0.38372763E-03_JPRB, 0.38370315E-03_JPRB, 0.38374770E-03_JPRB, 0.38382977E-03_JPRB, 0.38394943E-03_JPRB, &
  & 0.38416795E-03_JPRB, 0.38438643E-03_JPRB, 0.38463002E-03_JPRB, 0.38487385E-03_JPRB, 0.38514205E-03_JPRB, 0.38551366E-03_JPRB, &
  & 0.38600758E-03_JPRB, 0.38645554E-03_JPRB, 0.38665183E-03_JPRB, 0.38652068E-03_JPRB, 0.38623896E-03_JPRB, 0.38584020E-03_JPRB, &
  & 0.38545627E-03_JPRB, 0.38505262E-03_JPRB, 0.38481137E-03_JPRB, 0.38459567E-03_JPRB, 0.38447524E-03_JPRB, 0.38448088E-03_JPRB, &
  & 0.38443857E-03_JPRB, 0.38421227E-03_JPRB, 0.38373893E-03_JPRB, 0.38319486E-03_JPRB, 0.38261898E-03_JPRB, 0.38213455E-03_JPRB, &
  & 0.38181540E-03_JPRB, 0.38162900E-03_JPRB, 0.38141875E-03_JPRB, 0.38119521E-03_JPRB, 0.38092504E-03_JPRB, 0.38063484E-03_JPRB, &
  & 0.38065013E-03_JPRB, 0.38074641E-03_JPRB, 0.38092208E-03_JPRB, 0.38106584E-03_JPRB, 0.38111679E-03_JPRB, 0.38110402E-03_JPRB, &
  & 0.38112668E-03_JPRB, 0.38141861E-03_JPRB, 0.38154054E-03_JPRB, 0.38149352E-03_JPRB  /)

RGHG1(:,43, 3) = (/ &
  & 0.38585179E-03_JPRB, 0.38588388E-03_JPRB, 0.38571218E-03_JPRB, 0.38523675E-03_JPRB, 0.38502252E-03_JPRB, 0.38503491E-03_JPRB, &
  & 0.38517109E-03_JPRB, 0.38556667E-03_JPRB, 0.38578441E-03_JPRB, 0.38589164E-03_JPRB, 0.38582389E-03_JPRB, 0.38570064E-03_JPRB, &
  & 0.38546612E-03_JPRB, 0.38520983E-03_JPRB, 0.38491817E-03_JPRB, 0.38466061E-03_JPRB, 0.38440624E-03_JPRB, 0.38414324E-03_JPRB, &
  & 0.38393720E-03_JPRB, 0.38382040E-03_JPRB, 0.38374298E-03_JPRB, 0.38377240E-03_JPRB, 0.38383626E-03_JPRB, 0.38392489E-03_JPRB, &
  & 0.38416093E-03_JPRB, 0.38438766E-03_JPRB, 0.38463866E-03_JPRB, 0.38489067E-03_JPRB, 0.38515239E-03_JPRB, 0.38550942E-03_JPRB, &
  & 0.38603729E-03_JPRB, 0.38649490E-03_JPRB, 0.38675078E-03_JPRB, 0.38666168E-03_JPRB, 0.38642905E-03_JPRB, 0.38605939E-03_JPRB, &
  & 0.38570579E-03_JPRB, 0.38523213E-03_JPRB, 0.38494103E-03_JPRB, 0.38472756E-03_JPRB, 0.38458406E-03_JPRB, 0.38457025E-03_JPRB, &
  & 0.38455727E-03_JPRB, 0.38440113E-03_JPRB, 0.38396529E-03_JPRB, 0.38344523E-03_JPRB, 0.38286865E-03_JPRB, 0.38240714E-03_JPRB, &
  & 0.38214472E-03_JPRB, 0.38199945E-03_JPRB, 0.38182046E-03_JPRB, 0.38161830E-03_JPRB, 0.38137182E-03_JPRB, 0.38111682E-03_JPRB, &
  & 0.38119918E-03_JPRB, 0.38136569E-03_JPRB, 0.38159415E-03_JPRB, 0.38179092E-03_JPRB, 0.38190415E-03_JPRB, 0.38192574E-03_JPRB, &
  & 0.38193928E-03_JPRB, 0.38230901E-03_JPRB, 0.38252178E-03_JPRB, 0.38245717E-03_JPRB  /)

RGHG1(:,44, 3) = (/ &
  & 0.38690617E-03_JPRB, 0.38687485E-03_JPRB, 0.38672113E-03_JPRB, 0.38621856E-03_JPRB, 0.38599269E-03_JPRB, 0.38593303E-03_JPRB, &
  & 0.38601756E-03_JPRB, 0.38633414E-03_JPRB, 0.38646366E-03_JPRB, 0.38648879E-03_JPRB, 0.38633863E-03_JPRB, 0.38610231E-03_JPRB, &
  & 0.38574465E-03_JPRB, 0.38537902E-03_JPRB, 0.38498747E-03_JPRB, 0.38463831E-03_JPRB, 0.38430756E-03_JPRB, 0.38400067E-03_JPRB, &
  & 0.38379121E-03_JPRB, 0.38367555E-03_JPRB, 0.38360865E-03_JPRB, 0.38365664E-03_JPRB, 0.38375283E-03_JPRB, 0.38388759E-03_JPRB, &
  & 0.38413498E-03_JPRB, 0.38438985E-03_JPRB, 0.38467793E-03_JPRB, 0.38494744E-03_JPRB, 0.38517504E-03_JPRB, 0.38551813E-03_JPRB, &
  & 0.38600946E-03_JPRB, 0.38644699E-03_JPRB, 0.38672112E-03_JPRB, 0.38665741E-03_JPRB, 0.38642943E-03_JPRB, 0.38610381E-03_JPRB, &
  & 0.38580036E-03_JPRB, 0.38537270E-03_JPRB, 0.38505914E-03_JPRB, 0.38479350E-03_JPRB, 0.38461280E-03_JPRB, 0.38457257E-03_JPRB, &
  & 0.38456471E-03_JPRB, 0.38445171E-03_JPRB, 0.38407035E-03_JPRB, 0.38357448E-03_JPRB, 0.38302370E-03_JPRB, 0.38260140E-03_JPRB, &
  & 0.38241346E-03_JPRB, 0.38230066E-03_JPRB, 0.38214133E-03_JPRB, 0.38195755E-03_JPRB, 0.38173483E-03_JPRB, 0.38152306E-03_JPRB, &
  & 0.38162590E-03_JPRB, 0.38179824E-03_JPRB, 0.38205954E-03_JPRB, 0.38230155E-03_JPRB, 0.38239465E-03_JPRB, 0.38244665E-03_JPRB, &
  & 0.38249797E-03_JPRB, 0.38283594E-03_JPRB, 0.38318209E-03_JPRB, 0.38313073E-03_JPRB  /)

RGHG1(:,45, 3) = (/ &
  & 0.38834418E-03_JPRB, 0.38823831E-03_JPRB, 0.38810964E-03_JPRB, 0.38756688E-03_JPRB, 0.38731966E-03_JPRB, 0.38717168E-03_JPRB, &
  & 0.38718886E-03_JPRB, 0.38741219E-03_JPRB, 0.38742720E-03_JPRB, 0.38734229E-03_JPRB, 0.38707943E-03_JPRB, 0.38669423E-03_JPRB, &
  & 0.38617393E-03_JPRB, 0.38566344E-03_JPRB, 0.38513695E-03_JPRB, 0.38466586E-03_JPRB, 0.38423362E-03_JPRB, 0.38386618E-03_JPRB, &
  & 0.38364378E-03_JPRB, 0.38352236E-03_JPRB, 0.38346077E-03_JPRB, 0.38352798E-03_JPRB, 0.38365868E-03_JPRB, 0.38384203E-03_JPRB, &
  & 0.38410455E-03_JPRB, 0.38439250E-03_JPRB, 0.38472372E-03_JPRB, 0.38501419E-03_JPRB, 0.38520214E-03_JPRB, 0.38552752E-03_JPRB, &
  & 0.38598153E-03_JPRB, 0.38639742E-03_JPRB, 0.38669985E-03_JPRB, 0.38667035E-03_JPRB, 0.38645388E-03_JPRB, 0.38618207E-03_JPRB, &
  & 0.38593955E-03_JPRB, 0.38555540E-03_JPRB, 0.38520998E-03_JPRB, 0.38488523E-03_JPRB, 0.38465927E-03_JPRB, 0.38458650E-03_JPRB, &
  & 0.38458817E-03_JPRB, 0.38453314E-03_JPRB, 0.38421854E-03_JPRB, 0.38375324E-03_JPRB, 0.38323176E-03_JPRB, 0.38285699E-03_JPRB, &
  & 0.38276101E-03_JPRB, 0.38269036E-03_JPRB, 0.38255737E-03_JPRB, 0.38239720E-03_JPRB, 0.38220453E-03_JPRB, 0.38204642E-03_JPRB, &
  & 0.38218104E-03_JPRB, 0.38236890E-03_JPRB, 0.38267425E-03_JPRB, 0.38297446E-03_JPRB, 0.38305250E-03_JPRB, 0.38314348E-03_JPRB, &
  & 0.38323665E-03_JPRB, 0.38354828E-03_JPRB, 0.38405776E-03_JPRB, 0.38401927E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART6',0,ZHOOK_HANDLE)



RGHG1(:,46, 3) = (/ &
  & 0.38894804E-03_JPRB, 0.38888725E-03_JPRB, 0.38875776E-03_JPRB, 0.38826979E-03_JPRB, 0.38803211E-03_JPRB, 0.38776773E-03_JPRB, &
  & 0.38769704E-03_JPRB, 0.38783171E-03_JPRB, 0.38778313E-03_JPRB, 0.38762257E-03_JPRB, 0.38728959E-03_JPRB, 0.38681695E-03_JPRB, &
  & 0.38621057E-03_JPRB, 0.38562482E-03_JPRB, 0.38503408E-03_JPRB, 0.38449842E-03_JPRB, 0.38401818E-03_JPRB, 0.38364783E-03_JPRB, &
  & 0.38342691E-03_JPRB, 0.38332050E-03_JPRB, 0.38328962E-03_JPRB, 0.38337648E-03_JPRB, 0.38354376E-03_JPRB, 0.38377937E-03_JPRB, &
  & 0.38406372E-03_JPRB, 0.38438963E-03_JPRB, 0.38477370E-03_JPRB, 0.38507696E-03_JPRB, 0.38522978E-03_JPRB, 0.38554584E-03_JPRB, &
  & 0.38596929E-03_JPRB, 0.38635953E-03_JPRB, 0.38666515E-03_JPRB, 0.38666621E-03_JPRB, 0.38648147E-03_JPRB, 0.38624623E-03_JPRB, &
  & 0.38603264E-03_JPRB, 0.38567882E-03_JPRB, 0.38532234E-03_JPRB, 0.38496572E-03_JPRB, 0.38468610E-03_JPRB, 0.38457571E-03_JPRB, &
  & 0.38458104E-03_JPRB, 0.38456474E-03_JPRB, 0.38429980E-03_JPRB, 0.38386283E-03_JPRB, 0.38339782E-03_JPRB, 0.38309974E-03_JPRB, &
  & 0.38308030E-03_JPRB, 0.38304717E-03_JPRB, 0.38294045E-03_JPRB, 0.38280554E-03_JPRB, 0.38263908E-03_JPRB, 0.38252761E-03_JPRB, &
  & 0.38266008E-03_JPRB, 0.38285711E-03_JPRB, 0.38317915E-03_JPRB, 0.38352503E-03_JPRB, 0.38356977E-03_JPRB, 0.38367544E-03_JPRB, &
  & 0.38378830E-03_JPRB, 0.38409161E-03_JPRB, 0.38455150E-03_JPRB, 0.38463033E-03_JPRB  /)

RGHG1(:,47, 3) = (/ &
  & 0.38948952E-03_JPRB, 0.38950560E-03_JPRB, 0.38936997E-03_JPRB, 0.38896531E-03_JPRB, 0.38874501E-03_JPRB, 0.38833843E-03_JPRB, &
  & 0.38816052E-03_JPRB, 0.38819206E-03_JPRB, 0.38807906E-03_JPRB, 0.38783662E-03_JPRB, 0.38742989E-03_JPRB, 0.38686696E-03_JPRB, &
  & 0.38617490E-03_JPRB, 0.38551479E-03_JPRB, 0.38486282E-03_JPRB, 0.38426289E-03_JPRB, 0.38373704E-03_JPRB, 0.38337481E-03_JPRB, &
  & 0.38315852E-03_JPRB, 0.38307389E-03_JPRB, 0.38308414E-03_JPRB, 0.38319414E-03_JPRB, 0.38340475E-03_JPRB, 0.38370243E-03_JPRB, &
  & 0.38401371E-03_JPRB, 0.38438515E-03_JPRB, 0.38483319E-03_JPRB, 0.38514980E-03_JPRB, 0.38526234E-03_JPRB, 0.38556914E-03_JPRB, &
  & 0.38595806E-03_JPRB, 0.38631742E-03_JPRB, 0.38662175E-03_JPRB, 0.38665794E-03_JPRB, 0.38651448E-03_JPRB, 0.38631869E-03_JPRB, &
  & 0.38613266E-03_JPRB, 0.38581176E-03_JPRB, 0.38544649E-03_JPRB, 0.38505792E-03_JPRB, 0.38471364E-03_JPRB, 0.38455811E-03_JPRB, &
  & 0.38456655E-03_JPRB, 0.38459183E-03_JPRB, 0.38438175E-03_JPRB, 0.38397756E-03_JPRB, 0.38358425E-03_JPRB, 0.38338201E-03_JPRB, &
  & 0.38344931E-03_JPRB, 0.38345928E-03_JPRB, 0.38338337E-03_JPRB, 0.38327843E-03_JPRB, 0.38314194E-03_JPRB, 0.38308382E-03_JPRB, &
  & 0.38320695E-03_JPRB, 0.38341347E-03_JPRB, 0.38374962E-03_JPRB, 0.38414657E-03_JPRB, 0.38414858E-03_JPRB, 0.38426663E-03_JPRB, &
  & 0.38439816E-03_JPRB, 0.38469532E-03_JPRB, 0.38505436E-03_JPRB, 0.38529178E-03_JPRB  /)

RGHG1(:,48, 3) = (/ &
  & 0.38963441E-03_JPRB, 0.38969041E-03_JPRB, 0.38958749E-03_JPRB, 0.38930196E-03_JPRB, 0.38907754E-03_JPRB, 0.38853550E-03_JPRB, &
  & 0.38821969E-03_JPRB, 0.38818727E-03_JPRB, 0.38803652E-03_JPRB, 0.38775504E-03_JPRB, 0.38729987E-03_JPRB, 0.38667845E-03_JPRB, &
  & 0.38594924E-03_JPRB, 0.38526061E-03_JPRB, 0.38460716E-03_JPRB, 0.38400459E-03_JPRB, 0.38347155E-03_JPRB, 0.38312334E-03_JPRB, &
  & 0.38292470E-03_JPRB, 0.38285200E-03_JPRB, 0.38289216E-03_JPRB, 0.38302520E-03_JPRB, 0.38328242E-03_JPRB, 0.38362405E-03_JPRB, &
  & 0.38395454E-03_JPRB, 0.38437373E-03_JPRB, 0.38487119E-03_JPRB, 0.38519917E-03_JPRB, 0.38528986E-03_JPRB, 0.38559068E-03_JPRB, &
  & 0.38595319E-03_JPRB, 0.38628597E-03_JPRB, 0.38658668E-03_JPRB, 0.38666596E-03_JPRB, 0.38655834E-03_JPRB, 0.38639149E-03_JPRB, &
  & 0.38623700E-03_JPRB, 0.38591502E-03_JPRB, 0.38553756E-03_JPRB, 0.38513441E-03_JPRB, 0.38475496E-03_JPRB, 0.38457886E-03_JPRB, &
  & 0.38458840E-03_JPRB, 0.38463426E-03_JPRB, 0.38445696E-03_JPRB, 0.38409411E-03_JPRB, 0.38377358E-03_JPRB, 0.38366096E-03_JPRB, &
  & 0.38377817E-03_JPRB, 0.38382377E-03_JPRB, 0.38376924E-03_JPRB, 0.38367228E-03_JPRB, 0.38355961E-03_JPRB, 0.38354380E-03_JPRB, &
  & 0.38367204E-03_JPRB, 0.38385265E-03_JPRB, 0.38420203E-03_JPRB, 0.38460033E-03_JPRB, 0.38459021E-03_JPRB, 0.38468209E-03_JPRB, &
  & 0.38478879E-03_JPRB, 0.38503311E-03_JPRB, 0.38518168E-03_JPRB, 0.38537173E-03_JPRB  /)

RGHG1(:,49, 3) = (/ &
  & 0.38961455E-03_JPRB, 0.38969797E-03_JPRB, 0.38964894E-03_JPRB, 0.38951161E-03_JPRB, 0.38927286E-03_JPRB, 0.38858386E-03_JPRB, &
  & 0.38810139E-03_JPRB, 0.38801594E-03_JPRB, 0.38783551E-03_JPRB, 0.38753029E-03_JPRB, 0.38703298E-03_JPRB, 0.38636125E-03_JPRB, &
  & 0.38561297E-03_JPRB, 0.38491359E-03_JPRB, 0.38428569E-03_JPRB, 0.38370818E-03_JPRB, 0.38318465E-03_JPRB, 0.38285466E-03_JPRB, &
  & 0.38268149E-03_JPRB, 0.38261751E-03_JPRB, 0.38268571E-03_JPRB, 0.38284422E-03_JPRB, 0.38315455E-03_JPRB, 0.38353659E-03_JPRB, &
  & 0.38388484E-03_JPRB, 0.38435792E-03_JPRB, 0.38490351E-03_JPRB, 0.38524317E-03_JPRB, 0.38531805E-03_JPRB, 0.38561373E-03_JPRB, &
  & 0.38595070E-03_JPRB, 0.38625598E-03_JPRB, 0.38655164E-03_JPRB, 0.38668223E-03_JPRB, 0.38661184E-03_JPRB, 0.38647225E-03_JPRB, &
  & 0.38635451E-03_JPRB, 0.38601587E-03_JPRB, 0.38562338E-03_JPRB, 0.38521197E-03_JPRB, 0.38480699E-03_JPRB, 0.38461928E-03_JPRB, &
  & 0.38462913E-03_JPRB, 0.38468823E-03_JPRB, 0.38453717E-03_JPRB, 0.38422401E-03_JPRB, 0.38398455E-03_JPRB, 0.38396834E-03_JPRB, &
  & 0.38412410E-03_JPRB, 0.38420576E-03_JPRB, 0.38417062E-03_JPRB, 0.38407249E-03_JPRB, 0.38398342E-03_JPRB, 0.38400942E-03_JPRB, &
  & 0.38414990E-03_JPRB, 0.38428572E-03_JPRB, 0.38464936E-03_JPRB, 0.38502655E-03_JPRB, 0.38501690E-03_JPRB, 0.38506229E-03_JPRB, &
  & 0.38512172E-03_JPRB, 0.38528629E-03_JPRB, 0.38515193E-03_JPRB, 0.38519588E-03_JPRB  /)

RGHG1(:,50, 3) = (/ &
  & 0.38924278E-03_JPRB, 0.38936193E-03_JPRB, 0.38931721E-03_JPRB, 0.38926131E-03_JPRB, 0.38905315E-03_JPRB, 0.38828461E-03_JPRB, &
  & 0.38771721E-03_JPRB, 0.38758997E-03_JPRB, 0.38740506E-03_JPRB, 0.38712147E-03_JPRB, 0.38664167E-03_JPRB, 0.38595434E-03_JPRB, &
  & 0.38522173E-03_JPRB, 0.38454885E-03_JPRB, 0.38398361E-03_JPRB, 0.38345536E-03_JPRB, 0.38296646E-03_JPRB, 0.38265519E-03_JPRB, &
  & 0.38248817E-03_JPRB, 0.38243448E-03_JPRB, 0.38251899E-03_JPRB, 0.38270313E-03_JPRB, 0.38305174E-03_JPRB, 0.38345500E-03_JPRB, &
  & 0.38381816E-03_JPRB, 0.38433068E-03_JPRB, 0.38490376E-03_JPRB, 0.38525690E-03_JPRB, 0.38532975E-03_JPRB, 0.38561944E-03_JPRB, &
  & 0.38595095E-03_JPRB, 0.38623692E-03_JPRB, 0.38653081E-03_JPRB, 0.38671074E-03_JPRB, 0.38665966E-03_JPRB, 0.38653318E-03_JPRB, &
  & 0.38641527E-03_JPRB, 0.38608029E-03_JPRB, 0.38567407E-03_JPRB, 0.38525257E-03_JPRB, 0.38485467E-03_JPRB, 0.38467370E-03_JPRB, &
  & 0.38469823E-03_JPRB, 0.38476859E-03_JPRB, 0.38464631E-03_JPRB, 0.38438766E-03_JPRB, 0.38421738E-03_JPRB, 0.38426398E-03_JPRB, &
  & 0.38442359E-03_JPRB, 0.38453066E-03_JPRB, 0.38450292E-03_JPRB, 0.38438791E-03_JPRB, 0.38429295E-03_JPRB, 0.38435814E-03_JPRB, &
  & 0.38449598E-03_JPRB, 0.38459524E-03_JPRB, 0.38491931E-03_JPRB, 0.38521727E-03_JPRB, 0.38522594E-03_JPRB, 0.38524256E-03_JPRB, &
  & 0.38523262E-03_JPRB, 0.38528174E-03_JPRB, 0.38490624E-03_JPRB, 0.38475831E-03_JPRB  /)

RGHG1(:,51, 3) = (/ &
  & 0.38865567E-03_JPRB, 0.38881786E-03_JPRB, 0.38875174E-03_JPRB, 0.38874879E-03_JPRB, 0.38859733E-03_JPRB, 0.38777820E-03_JPRB, &
  & 0.38716191E-03_JPRB, 0.38699537E-03_JPRB, 0.38681884E-03_JPRB, 0.38658252E-03_JPRB, 0.38615299E-03_JPRB, 0.38546705E-03_JPRB, &
  & 0.38476966E-03_JPRB, 0.38414503E-03_JPRB, 0.38366707E-03_JPRB, 0.38320480E-03_JPRB, 0.38276658E-03_JPRB, 0.38247581E-03_JPRB, &
  & 0.38230529E-03_JPRB, 0.38226356E-03_JPRB, 0.38235954E-03_JPRB, 0.38257151E-03_JPRB, 0.38295371E-03_JPRB, 0.38336982E-03_JPRB, &
  & 0.38374763E-03_JPRB, 0.38429521E-03_JPRB, 0.38488716E-03_JPRB, 0.38525585E-03_JPRB, 0.38533374E-03_JPRB, 0.38561651E-03_JPRB, &
  & 0.38595266E-03_JPRB, 0.38622203E-03_JPRB, 0.38651576E-03_JPRB, 0.38674800E-03_JPRB, 0.38670839E-03_JPRB, 0.38658866E-03_JPRB, &
  & 0.38645114E-03_JPRB, 0.38613080E-03_JPRB, 0.38571043E-03_JPRB, 0.38527706E-03_JPRB, 0.38490397E-03_JPRB, 0.38473992E-03_JPRB, &
  & 0.38478788E-03_JPRB, 0.38486938E-03_JPRB, 0.38477956E-03_JPRB, 0.38458242E-03_JPRB, 0.38448071E-03_JPRB, 0.38457759E-03_JPRB, &
  & 0.38472313E-03_JPRB, 0.38485208E-03_JPRB, 0.38482605E-03_JPRB, 0.38468452E-03_JPRB, 0.38456767E-03_JPRB, 0.38467386E-03_JPRB, &
  & 0.38480104E-03_JPRB, 0.38486509E-03_JPRB, 0.38511805E-03_JPRB, 0.38529976E-03_JPRB, 0.38533764E-03_JPRB, 0.38533245E-03_JPRB, &
  & 0.38523588E-03_JPRB, 0.38514132E-03_JPRB, 0.38452698E-03_JPRB, 0.38414745E-03_JPRB  /)

RGHG1(:,52, 3) = (/ &
  & 0.38797204E-03_JPRB, 0.38804766E-03_JPRB, 0.38783116E-03_JPRB, 0.38791846E-03_JPRB, 0.38786195E-03_JPRB, 0.38708197E-03_JPRB, &
  & 0.38647919E-03_JPRB, 0.38628550E-03_JPRB, 0.38614529E-03_JPRB, 0.38596761E-03_JPRB, 0.38561575E-03_JPRB, 0.38496541E-03_JPRB, &
  & 0.38432196E-03_JPRB, 0.38376764E-03_JPRB, 0.38337212E-03_JPRB, 0.38298002E-03_JPRB, 0.38260600E-03_JPRB, 0.38233118E-03_JPRB, &
  & 0.38216651E-03_JPRB, 0.38213978E-03_JPRB, 0.38223706E-03_JPRB, 0.38246247E-03_JPRB, 0.38285385E-03_JPRB, 0.38327512E-03_JPRB, &
  & 0.38365850E-03_JPRB, 0.38421145E-03_JPRB, 0.38482709E-03_JPRB, 0.38521212E-03_JPRB, 0.38531410E-03_JPRB, 0.38559903E-03_JPRB, &
  & 0.38596033E-03_JPRB, 0.38621587E-03_JPRB, 0.38650950E-03_JPRB, 0.38676390E-03_JPRB, 0.38673771E-03_JPRB, 0.38660407E-03_JPRB, &
  & 0.38643115E-03_JPRB, 0.38612623E-03_JPRB, 0.38568108E-03_JPRB, 0.38524757E-03_JPRB, 0.38491410E-03_JPRB, 0.38479722E-03_JPRB, &
  & 0.38487903E-03_JPRB, 0.38497358E-03_JPRB, 0.38491902E-03_JPRB, 0.38476176E-03_JPRB, 0.38471372E-03_JPRB, 0.38485046E-03_JPRB, &
  & 0.38500974E-03_JPRB, 0.38517277E-03_JPRB, 0.38514165E-03_JPRB, 0.38498627E-03_JPRB, 0.38484513E-03_JPRB, 0.38496604E-03_JPRB, &
  & 0.38507261E-03_JPRB, 0.38511942E-03_JPRB, 0.38525969E-03_JPRB, 0.38530400E-03_JPRB, 0.38535293E-03_JPRB, 0.38527513E-03_JPRB, &
  & 0.38508458E-03_JPRB, 0.38485909E-03_JPRB, 0.38413877E-03_JPRB, 0.38364512E-03_JPRB  /)

RGHG1(:,53, 3) = (/ &
  & 0.38719044E-03_JPRB, 0.38712194E-03_JPRB, 0.38669203E-03_JPRB, 0.38689196E-03_JPRB, 0.38695357E-03_JPRB, 0.38625076E-03_JPRB, &
  & 0.38568669E-03_JPRB, 0.38546811E-03_JPRB, 0.38537820E-03_JPRB, 0.38526877E-03_JPRB, 0.38501202E-03_JPRB, 0.38441362E-03_JPRB, &
  & 0.38383609E-03_JPRB, 0.38336684E-03_JPRB, 0.38305923E-03_JPRB, 0.38274515E-03_JPRB, 0.38244625E-03_JPRB, 0.38218706E-03_JPRB, &
  & 0.38203234E-03_JPRB, 0.38202312E-03_JPRB, 0.38211791E-03_JPRB, 0.38235242E-03_JPRB, 0.38274440E-03_JPRB, 0.38316834E-03_JPRB, &
  & 0.38355429E-03_JPRB, 0.38410166E-03_JPRB, 0.38474493E-03_JPRB, 0.38514808E-03_JPRB, 0.38528362E-03_JPRB, 0.38557440E-03_JPRB, &
  & 0.38597097E-03_JPRB, 0.38621252E-03_JPRB, 0.38650607E-03_JPRB, 0.38677300E-03_JPRB, 0.38676217E-03_JPRB, 0.38660545E-03_JPRB, &
  & 0.38638789E-03_JPRB, 0.38610005E-03_JPRB, 0.38562382E-03_JPRB, 0.38519469E-03_JPRB, 0.38491007E-03_JPRB, 0.38485619E-03_JPRB, &
  & 0.38497886E-03_JPRB, 0.38508835E-03_JPRB, 0.38507328E-03_JPRB, 0.38495113E-03_JPRB, 0.38495580E-03_JPRB, 0.38513193E-03_JPRB, &
  & 0.38531688E-03_JPRB, 0.38552172E-03_JPRB, 0.38548245E-03_JPRB, 0.38531685E-03_JPRB, 0.38514832E-03_JPRB, 0.38527516E-03_JPRB, &
  & 0.38535546E-03_JPRB, 0.38539043E-03_JPRB, 0.38539198E-03_JPRB, 0.38527850E-03_JPRB, 0.38533250E-03_JPRB, 0.38515606E-03_JPRB, &
  & 0.38486036E-03_JPRB, 0.38449718E-03_JPRB, 0.38371256E-03_JPRB, 0.38313985E-03_JPRB  /)

RGHG1(:,54, 3) = (/ &
  & 0.38643131E-03_JPRB, 0.38620702E-03_JPRB, 0.38575814E-03_JPRB, 0.38597847E-03_JPRB, 0.38610950E-03_JPRB, 0.38551987E-03_JPRB, &
  & 0.38500030E-03_JPRB, 0.38477264E-03_JPRB, 0.38472438E-03_JPRB, 0.38466272E-03_JPRB, 0.38447666E-03_JPRB, 0.38394400E-03_JPRB, &
  & 0.38342797E-03_JPRB, 0.38303088E-03_JPRB, 0.38278426E-03_JPRB, 0.38252925E-03_JPRB, 0.38229156E-03_JPRB, 0.38205306E-03_JPRB, &
  & 0.38192156E-03_JPRB, 0.38191711E-03_JPRB, 0.38201377E-03_JPRB, 0.38224097E-03_JPRB, 0.38263629E-03_JPRB, 0.38306852E-03_JPRB, &
  & 0.38344353E-03_JPRB, 0.38396981E-03_JPRB, 0.38461102E-03_JPRB, 0.38504379E-03_JPRB, 0.38523177E-03_JPRB, 0.38554106E-03_JPRB, &
  & 0.38598228E-03_JPRB, 0.38622290E-03_JPRB, 0.38652378E-03_JPRB, 0.38677088E-03_JPRB, 0.38676414E-03_JPRB, 0.38657811E-03_JPRB, &
  & 0.38633674E-03_JPRB, 0.38602506E-03_JPRB, 0.38552775E-03_JPRB, 0.38513124E-03_JPRB, 0.38491078E-03_JPRB, 0.38493345E-03_JPRB, &
  & 0.38507199E-03_JPRB, 0.38519629E-03_JPRB, 0.38520783E-03_JPRB, 0.38511641E-03_JPRB, 0.38517313E-03_JPRB, 0.38538185E-03_JPRB, &
  & 0.38560399E-03_JPRB, 0.38583866E-03_JPRB, 0.38581998E-03_JPRB, 0.38565925E-03_JPRB, 0.38551005E-03_JPRB, 0.38563626E-03_JPRB, &
  & 0.38569394E-03_JPRB, 0.38569277E-03_JPRB, 0.38561643E-03_JPRB, 0.38545192E-03_JPRB, 0.38544425E-03_JPRB, 0.38515313E-03_JPRB, &
  & 0.38473209E-03_JPRB, 0.38430939E-03_JPRB, 0.38356535E-03_JPRB, 0.38300681E-03_JPRB  /)

RGHG1(:,55, 3) = (/ &
  & 0.38559332E-03_JPRB, 0.38519493E-03_JPRB, 0.38475060E-03_JPRB, 0.38498141E-03_JPRB, 0.38518294E-03_JPRB, 0.38472341E-03_JPRB, &
  & 0.38425389E-03_JPRB, 0.38401827E-03_JPRB, 0.38401500E-03_JPRB, 0.38400357E-03_JPRB, 0.38389261E-03_JPRB, 0.38343458E-03_JPRB, &
  & 0.38298609E-03_JPRB, 0.38266724E-03_JPRB, 0.38248465E-03_JPRB, 0.38229258E-03_JPRB, 0.38212088E-03_JPRB, 0.38190597E-03_JPRB, &
  & 0.38180193E-03_JPRB, 0.38180107E-03_JPRB, 0.38190037E-03_JPRB, 0.38211733E-03_JPRB, 0.38251670E-03_JPRB, 0.38295886E-03_JPRB, &
  & 0.38331998E-03_JPRB, 0.38382085E-03_JPRB, 0.38445586E-03_JPRB, 0.38492297E-03_JPRB, 0.38517152E-03_JPRB, 0.38550299E-03_JPRB, &
  & 0.38599489E-03_JPRB, 0.38623620E-03_JPRB, 0.38654619E-03_JPRB, 0.38676705E-03_JPRB, 0.38676337E-03_JPRB, 0.38654404E-03_JPRB, &
  & 0.38627904E-03_JPRB, 0.38593557E-03_JPRB, 0.38541622E-03_JPRB, 0.38505956E-03_JPRB, 0.38491219E-03_JPRB, 0.38502143E-03_JPRB, &
  & 0.38517428E-03_JPRB, 0.38531497E-03_JPRB, 0.38535429E-03_JPRB, 0.38529634E-03_JPRB, 0.38541062E-03_JPRB, 0.38565455E-03_JPRB, &
  & 0.38591940E-03_JPRB, 0.38618554E-03_JPRB, 0.38619346E-03_JPRB, 0.38604010E-03_JPRB, 0.38591845E-03_JPRB, 0.38604312E-03_JPRB, &
  & 0.38607620E-03_JPRB, 0.38603182E-03_JPRB, 0.38587719E-03_JPRB, 0.38567020E-03_JPRB, 0.38558542E-03_JPRB, 0.38516515E-03_JPRB, &
  & 0.38460262E-03_JPRB, 0.38412427E-03_JPRB, 0.38343897E-03_JPRB, 0.38290840E-03_JPRB  /)

RGHG1(:,56, 3) = (/ &
  & 0.38490982E-03_JPRB, 0.38444814E-03_JPRB, 0.38418157E-03_JPRB, 0.38437888E-03_JPRB, 0.38457423E-03_JPRB, 0.38420848E-03_JPRB, &
  & 0.38378400E-03_JPRB, 0.38357723E-03_JPRB, 0.38357603E-03_JPRB, 0.38357530E-03_JPRB, 0.38349798E-03_JPRB, 0.38309350E-03_JPRB, &
  & 0.38269953E-03_JPRB, 0.38242585E-03_JPRB, 0.38226541E-03_JPRB, 0.38211672E-03_JPRB, 0.38196775E-03_JPRB, 0.38177148E-03_JPRB, &
  & 0.38169012E-03_JPRB, 0.38168984E-03_JPRB, 0.38179649E-03_JPRB, 0.38201293E-03_JPRB, 0.38240824E-03_JPRB, 0.38283545E-03_JPRB, &
  & 0.38321158E-03_JPRB, 0.38372048E-03_JPRB, 0.38431553E-03_JPRB, 0.38478088E-03_JPRB, 0.38508993E-03_JPRB, 0.38546865E-03_JPRB, &
  & 0.38599706E-03_JPRB, 0.38626332E-03_JPRB, 0.38655788E-03_JPRB, 0.38677599E-03_JPRB, 0.38673814E-03_JPRB, 0.38648597E-03_JPRB, &
  & 0.38621852E-03_JPRB, 0.38584411E-03_JPRB, 0.38536952E-03_JPRB, 0.38504974E-03_JPRB, 0.38493929E-03_JPRB, 0.38508425E-03_JPRB, &
  & 0.38523997E-03_JPRB, 0.38539077E-03_JPRB, 0.38545618E-03_JPRB, 0.38546412E-03_JPRB, 0.38564724E-03_JPRB, 0.38592144E-03_JPRB, &
  & 0.38622958E-03_JPRB, 0.38651711E-03_JPRB, 0.38655098E-03_JPRB, 0.38642918E-03_JPRB, 0.38632592E-03_JPRB, 0.38644562E-03_JPRB, &
  & 0.38649034E-03_JPRB, 0.38641435E-03_JPRB, 0.38626595E-03_JPRB, 0.38611487E-03_JPRB, 0.38597482E-03_JPRB, 0.38551661E-03_JPRB, &
  & 0.38495244E-03_JPRB, 0.38447656E-03_JPRB, 0.38390343E-03_JPRB, 0.38333223E-03_JPRB  /)

RGHG1(:,57, 3) = (/ &
  & 0.38424171E-03_JPRB, 0.38373888E-03_JPRB, 0.38360891E-03_JPRB, 0.38379292E-03_JPRB, 0.38398083E-03_JPRB, 0.38370425E-03_JPRB, &
  & 0.38332793E-03_JPRB, 0.38315136E-03_JPRB, 0.38315816E-03_JPRB, 0.38316905E-03_JPRB, 0.38312252E-03_JPRB, 0.38276694E-03_JPRB, &
  & 0.38242164E-03_JPRB, 0.38219223E-03_JPRB, 0.38205175E-03_JPRB, 0.38194097E-03_JPRB, 0.38181269E-03_JPRB, 0.38162975E-03_JPRB, &
  & 0.38156809E-03_JPRB, 0.38157126E-03_JPRB, 0.38168636E-03_JPRB, 0.38190335E-03_JPRB, 0.38229572E-03_JPRB, 0.38270521E-03_JPRB, &
  & 0.38309685E-03_JPRB, 0.38361039E-03_JPRB, 0.38417757E-03_JPRB, 0.38464253E-03_JPRB, 0.38500301E-03_JPRB, 0.38543119E-03_JPRB, &
  & 0.38599871E-03_JPRB, 0.38629217E-03_JPRB, 0.38657169E-03_JPRB, 0.38677560E-03_JPRB, 0.38670721E-03_JPRB, 0.38642643E-03_JPRB, &
  & 0.38614250E-03_JPRB, 0.38573952E-03_JPRB, 0.38530603E-03_JPRB, 0.38503046E-03_JPRB, 0.38496292E-03_JPRB, 0.38514093E-03_JPRB, &
  & 0.38530159E-03_JPRB, 0.38546744E-03_JPRB, 0.38556236E-03_JPRB, 0.38564201E-03_JPRB, 0.38589916E-03_JPRB, 0.38620585E-03_JPRB, &
  & 0.38655572E-03_JPRB, 0.38686791E-03_JPRB, 0.38692771E-03_JPRB, 0.38684070E-03_JPRB, 0.38675653E-03_JPRB, 0.38687551E-03_JPRB, &
  & 0.38693204E-03_JPRB, 0.38684001E-03_JPRB, 0.38670145E-03_JPRB, 0.38660527E-03_JPRB, 0.38641753E-03_JPRB, 0.38593426E-03_JPRB, &
  & 0.38538250E-03_JPRB, 0.38492083E-03_JPRB, 0.38443813E-03_JPRB, 0.38379154E-03_JPRB  /)

RGHG1(:,58, 3) = (/ &
  & 0.38368232E-03_JPRB, 0.38319981E-03_JPRB, 0.38315843E-03_JPRB, 0.38335605E-03_JPRB, 0.38352061E-03_JPRB, 0.38331144E-03_JPRB, &
  & 0.38298370E-03_JPRB, 0.38284410E-03_JPRB, 0.38286027E-03_JPRB, 0.38287598E-03_JPRB, 0.38284514E-03_JPRB, 0.38252274E-03_JPRB, &
  & 0.38220987E-03_JPRB, 0.38201346E-03_JPRB, 0.38187978E-03_JPRB, 0.38179093E-03_JPRB, 0.38167012E-03_JPRB, 0.38148955E-03_JPRB, &
  & 0.38144008E-03_JPRB, 0.38145072E-03_JPRB, 0.38157631E-03_JPRB, 0.38179747E-03_JPRB, 0.38218747E-03_JPRB, 0.38257134E-03_JPRB, &
  & 0.38298349E-03_JPRB, 0.38350186E-03_JPRB, 0.38405750E-03_JPRB, 0.38451764E-03_JPRB, 0.38491008E-03_JPRB, 0.38539214E-03_JPRB, &
  & 0.38599739E-03_JPRB, 0.38632422E-03_JPRB, 0.38658597E-03_JPRB, 0.38676189E-03_JPRB, 0.38666458E-03_JPRB, 0.38636469E-03_JPRB, &
  & 0.38604588E-03_JPRB, 0.38562078E-03_JPRB, 0.38523144E-03_JPRB, 0.38500834E-03_JPRB, 0.38498363E-03_JPRB, 0.38517799E-03_JPRB, &
  & 0.38534451E-03_JPRB, 0.38553135E-03_JPRB, 0.38565889E-03_JPRB, 0.38582041E-03_JPRB, 0.38615650E-03_JPRB, 0.38649590E-03_JPRB, &
  & 0.38688160E-03_JPRB, 0.38722007E-03_JPRB, 0.38730361E-03_JPRB, 0.38725857E-03_JPRB, 0.38719141E-03_JPRB, 0.38731626E-03_JPRB, &
  & 0.38739075E-03_JPRB, 0.38731243E-03_JPRB, 0.38720488E-03_JPRB, 0.38717592E-03_JPRB, 0.38696124E-03_JPRB, 0.38649375E-03_JPRB, &
  & 0.38600335E-03_JPRB, 0.38558545E-03_JPRB, 0.38515919E-03_JPRB, 0.38437173E-03_JPRB  /)

RGHG1(:,59, 3) = (/ &
  & 0.38326895E-03_JPRB, 0.38282547E-03_JPRB, 0.38282777E-03_JPRB, 0.38303640E-03_JPRB, 0.38317546E-03_JPRB, 0.38301713E-03_JPRB, &
  & 0.38274620E-03_JPRB, 0.38262806E-03_JPRB, 0.38266142E-03_JPRB, 0.38267489E-03_JPRB, 0.38265144E-03_JPRB, 0.38235299E-03_JPRB, &
  & 0.38206087E-03_JPRB, 0.38188234E-03_JPRB, 0.38174727E-03_JPRB, 0.38165899E-03_JPRB, 0.38154546E-03_JPRB, 0.38136647E-03_JPRB, &
  & 0.38132093E-03_JPRB, 0.38134493E-03_JPRB, 0.38147191E-03_JPRB, 0.38168693E-03_JPRB, 0.38207109E-03_JPRB, 0.38244882E-03_JPRB, &
  & 0.38287082E-03_JPRB, 0.38338850E-03_JPRB, 0.38393583E-03_JPRB, 0.38439893E-03_JPRB, 0.38482052E-03_JPRB, 0.38536615E-03_JPRB, &
  & 0.38599201E-03_JPRB, 0.38634297E-03_JPRB, 0.38659060E-03_JPRB, 0.38671644E-03_JPRB, 0.38658680E-03_JPRB, 0.38627292E-03_JPRB, &
  & 0.38593358E-03_JPRB, 0.38548576E-03_JPRB, 0.38517126E-03_JPRB, 0.38498548E-03_JPRB, 0.38499779E-03_JPRB, 0.38519757E-03_JPRB, &
  & 0.38538170E-03_JPRB, 0.38559685E-03_JPRB, 0.38576104E-03_JPRB, 0.38599598E-03_JPRB, 0.38639542E-03_JPRB, 0.38676834E-03_JPRB, &
  & 0.38718440E-03_JPRB, 0.38754547E-03_JPRB, 0.38765401E-03_JPRB, 0.38764175E-03_JPRB, 0.38760461E-03_JPRB, 0.38775653E-03_JPRB, &
  & 0.38784650E-03_JPRB, 0.38779778E-03_JPRB, 0.38771674E-03_JPRB, 0.38775729E-03_JPRB, 0.38755112E-03_JPRB, 0.38711644E-03_JPRB, &
  & 0.38671632E-03_JPRB, 0.38635834E-03_JPRB, 0.38595456E-03_JPRB, 0.38500703E-03_JPRB  /)

RGHG1(:,60, 3) = (/ &
  & 0.38291541E-03_JPRB, 0.38252000E-03_JPRB, 0.38254965E-03_JPRB, 0.38276678E-03_JPRB, 0.38287801E-03_JPRB, 0.38276324E-03_JPRB, &
  & 0.38255189E-03_JPRB, 0.38245029E-03_JPRB, 0.38250369E-03_JPRB, 0.38251056E-03_JPRB, 0.38249125E-03_JPRB, 0.38221421E-03_JPRB, &
  & 0.38193803E-03_JPRB, 0.38177009E-03_JPRB, 0.38162960E-03_JPRB, 0.38153325E-03_JPRB, 0.38142493E-03_JPRB, 0.38124802E-03_JPRB, &
  & 0.38120282E-03_JPRB, 0.38124253E-03_JPRB, 0.38136706E-03_JPRB, 0.38156992E-03_JPRB, 0.38194672E-03_JPRB, 0.38233009E-03_JPRB, &
  & 0.38276160E-03_JPRB, 0.38326794E-03_JPRB, 0.38380642E-03_JPRB, 0.38427539E-03_JPRB, 0.38473093E-03_JPRB, 0.38534462E-03_JPRB, &
  & 0.38598090E-03_JPRB, 0.38635527E-03_JPRB, 0.38659241E-03_JPRB, 0.38666570E-03_JPRB, 0.38649998E-03_JPRB, 0.38617160E-03_JPRB, &
  & 0.38581036E-03_JPRB, 0.38534952E-03_JPRB, 0.38512153E-03_JPRB, 0.38496643E-03_JPRB, 0.38501144E-03_JPRB, 0.38521405E-03_JPRB, &
  & 0.38542164E-03_JPRB, 0.38567008E-03_JPRB, 0.38587156E-03_JPRB, 0.38617646E-03_JPRB, 0.38663121E-03_JPRB, 0.38703901E-03_JPRB, &
  & 0.38748437E-03_JPRB, 0.38786609E-03_JPRB, 0.38800096E-03_JPRB, 0.38802064E-03_JPRB, 0.38802116E-03_JPRB, 0.38821240E-03_JPRB, &
  & 0.38831716E-03_JPRB, 0.38830327E-03_JPRB, 0.38824702E-03_JPRB, 0.38835852E-03_JPRB, 0.38817839E-03_JPRB, 0.38779452E-03_JPRB, &
  & 0.38749428E-03_JPRB, 0.38720257E-03_JPRB, 0.38680948E-03_JPRB, 0.38570902E-03_JPRB  /)

RGHG1(:,61, 3) = (/ &
  & 0.38267770E-03_JPRB, 0.38233590E-03_JPRB, 0.38237877E-03_JPRB, 0.38259610E-03_JPRB, 0.38267720E-03_JPRB, 0.38259020E-03_JPRB, &
  & 0.38242981E-03_JPRB, 0.38234163E-03_JPRB, 0.38241359E-03_JPRB, 0.38240600E-03_JPRB, 0.38238741E-03_JPRB, 0.38212974E-03_JPRB, &
  & 0.38186207E-03_JPRB, 0.38169249E-03_JPRB, 0.38154145E-03_JPRB, 0.38143002E-03_JPRB, 0.38131791E-03_JPRB, 0.38114572E-03_JPRB, &
  & 0.38109672E-03_JPRB, 0.38115171E-03_JPRB, 0.38127009E-03_JPRB, 0.38145111E-03_JPRB, 0.38182003E-03_JPRB, 0.38223158E-03_JPRB, &
  & 0.38268319E-03_JPRB, 0.38314350E-03_JPRB, 0.38366824E-03_JPRB, 0.38414408E-03_JPRB, 0.38465128E-03_JPRB, 0.38532822E-03_JPRB, &
  & 0.38595333E-03_JPRB, 0.38635609E-03_JPRB, 0.38659467E-03_JPRB, 0.38664182E-03_JPRB, 0.38643478E-03_JPRB, 0.38608570E-03_JPRB, &
  & 0.38568222E-03_JPRB, 0.38525080E-03_JPRB, 0.38510420E-03_JPRB, 0.38496694E-03_JPRB, 0.38502918E-03_JPRB, 0.38523742E-03_JPRB, &
  & 0.38547371E-03_JPRB, 0.38576110E-03_JPRB, 0.38599139E-03_JPRB, 0.38635155E-03_JPRB, 0.38683971E-03_JPRB, 0.38728133E-03_JPRB, &
  & 0.38775386E-03_JPRB, 0.38814962E-03_JPRB, 0.38831043E-03_JPRB, 0.38836516E-03_JPRB, 0.38841201E-03_JPRB, 0.38865933E-03_JPRB, &
  & 0.38877680E-03_JPRB, 0.38879336E-03_JPRB, 0.38875658E-03_JPRB, 0.38893061E-03_JPRB, 0.38879897E-03_JPRB, 0.38850971E-03_JPRB, &
  & 0.38829567E-03_JPRB, 0.38806506E-03_JPRB, 0.38767586E-03_JPRB, 0.38650068E-03_JPRB  /)

RGHG1(:,62, 3) = (/ &
  & 0.38252779E-03_JPRB, 0.38222416E-03_JPRB, 0.38227802E-03_JPRB, 0.38249193E-03_JPRB, 0.38253844E-03_JPRB, 0.38246956E-03_JPRB, &
  & 0.38234298E-03_JPRB, 0.38227086E-03_JPRB, 0.38235370E-03_JPRB, 0.38233742E-03_JPRB, 0.38231623E-03_JPRB, 0.38208083E-03_JPRB, &
  & 0.38181844E-03_JPRB, 0.38163746E-03_JPRB, 0.38147545E-03_JPRB, 0.38134855E-03_JPRB, 0.38122607E-03_JPRB, 0.38105373E-03_JPRB, &
  & 0.38099916E-03_JPRB, 0.38106399E-03_JPRB, 0.38118422E-03_JPRB, 0.38134605E-03_JPRB, 0.38170135E-03_JPRB, 0.38214996E-03_JPRB, &
  & 0.38261729E-03_JPRB, 0.38303155E-03_JPRB, 0.38354333E-03_JPRB, 0.38401131E-03_JPRB, 0.38457311E-03_JPRB, 0.38531244E-03_JPRB, &
  & 0.38593922E-03_JPRB, 0.38636726E-03_JPRB, 0.38661764E-03_JPRB, 0.38665587E-03_JPRB, 0.38642063E-03_JPRB, 0.38603394E-03_JPRB, &
  & 0.38559644E-03_JPRB, 0.38521845E-03_JPRB, 0.38510317E-03_JPRB, 0.38498348E-03_JPRB, 0.38506880E-03_JPRB, 0.38528749E-03_JPRB, &
  & 0.38554323E-03_JPRB, 0.38586732E-03_JPRB, 0.38611793E-03_JPRB, 0.38652227E-03_JPRB, 0.38703718E-03_JPRB, 0.38751082E-03_JPRB, &
  & 0.38800887E-03_JPRB, 0.38841108E-03_JPRB, 0.38859516E-03_JPRB, 0.38869040E-03_JPRB, 0.38878749E-03_JPRB, 0.38909547E-03_JPRB, &
  & 0.38922249E-03_JPRB, 0.38924906E-03_JPRB, 0.38923648E-03_JPRB, 0.38947398E-03_JPRB, 0.38940640E-03_JPRB, 0.38924164E-03_JPRB, &
  & 0.38909630E-03_JPRB, 0.38891659E-03_JPRB, 0.38851585E-03_JPRB, 0.38736631E-03_JPRB  /)

RGHG1(:,63, 3) = (/ &
  & 0.38243744E-03_JPRB, 0.38216239E-03_JPRB, 0.38222588E-03_JPRB, 0.38243117E-03_JPRB, 0.38244165E-03_JPRB, 0.38238505E-03_JPRB, &
  & 0.38228109E-03_JPRB, 0.38222429E-03_JPRB, 0.38230964E-03_JPRB, 0.38229400E-03_JPRB, 0.38226913E-03_JPRB, 0.38205667E-03_JPRB, &
  & 0.38179679E-03_JPRB, 0.38159932E-03_JPRB, 0.38142455E-03_JPRB, 0.38128227E-03_JPRB, 0.38114615E-03_JPRB, 0.38097096E-03_JPRB, &
  & 0.38091024E-03_JPRB, 0.38097968E-03_JPRB, 0.38110515E-03_JPRB, 0.38125293E-03_JPRB, 0.38159292E-03_JPRB, 0.38208341E-03_JPRB, &
  & 0.38255732E-03_JPRB, 0.38293606E-03_JPRB, 0.38342771E-03_JPRB, 0.38387884E-03_JPRB, 0.38449392E-03_JPRB, 0.38530100E-03_JPRB, &
  & 0.38593888E-03_JPRB, 0.38638703E-03_JPRB, 0.38664709E-03_JPRB, 0.38668940E-03_JPRB, 0.38643233E-03_JPRB, 0.38600439E-03_JPRB, &
  & 0.38554673E-03_JPRB, 0.38522930E-03_JPRB, 0.38511773E-03_JPRB, 0.38501723E-03_JPRB, 0.38512663E-03_JPRB, 0.38535770E-03_JPRB, &
  & 0.38562814E-03_JPRB, 0.38598494E-03_JPRB, 0.38625167E-03_JPRB, 0.38669453E-03_JPRB, 0.38723373E-03_JPRB, 0.38773821E-03_JPRB, &
  & 0.38825721E-03_JPRB, 0.38866279E-03_JPRB, 0.38886904E-03_JPRB, 0.38901098E-03_JPRB, 0.38915932E-03_JPRB, 0.38952518E-03_JPRB, &
  & 0.38966157E-03_JPRB, 0.38968608E-03_JPRB, 0.38970477E-03_JPRB, 0.39000624E-03_JPRB, 0.39001035E-03_JPRB, 0.38997504E-03_JPRB, &
  & 0.38988889E-03_JPRB, 0.38975210E-03_JPRB, 0.38933167E-03_JPRB, 0.38828779E-03_JPRB  /)

RGHG1(:,64, 3) = (/ &
  & 0.38240896E-03_JPRB, 0.38215330E-03_JPRB, 0.38222499E-03_JPRB, 0.38241278E-03_JPRB, 0.38238963E-03_JPRB, 0.38234020E-03_JPRB, &
  & 0.38224757E-03_JPRB, 0.38220097E-03_JPRB, 0.38227578E-03_JPRB, 0.38227808E-03_JPRB, 0.38225041E-03_JPRB, 0.38205869E-03_JPRB, &
  & 0.38179758E-03_JPRB, 0.38158160E-03_JPRB, 0.38139058E-03_JPRB, 0.38123418E-03_JPRB, 0.38108348E-03_JPRB, 0.38090381E-03_JPRB, &
  & 0.38083759E-03_JPRB, 0.38090400E-03_JPRB, 0.38103474E-03_JPRB, 0.38117916E-03_JPRB, 0.38150603E-03_JPRB, 0.38203969E-03_JPRB, &
  & 0.38250160E-03_JPRB, 0.38287249E-03_JPRB, 0.38332613E-03_JPRB, 0.38375384E-03_JPRB, 0.38441376E-03_JPRB, 0.38530021E-03_JPRB, &
  & 0.38595906E-03_JPRB, 0.38641685E-03_JPRB, 0.38667030E-03_JPRB, 0.38673122E-03_JPRB, 0.38645565E-03_JPRB, 0.38599631E-03_JPRB, &
  & 0.38554538E-03_JPRB, 0.38527930E-03_JPRB, 0.38515383E-03_JPRB, 0.38507609E-03_JPRB, 0.38520511E-03_JPRB, 0.38544795E-03_JPRB, &
  & 0.38573016E-03_JPRB, 0.38611073E-03_JPRB, 0.38639125E-03_JPRB, 0.38686830E-03_JPRB, 0.38743161E-03_JPRB, 0.38796456E-03_JPRB, &
  & 0.38849399E-03_JPRB, 0.38890294E-03_JPRB, 0.38913049E-03_JPRB, 0.38932713E-03_JPRB, 0.38952324E-03_JPRB, 0.38993305E-03_JPRB, &
  & 0.39008121E-03_JPRB, 0.39009462E-03_JPRB, 0.39015613E-03_JPRB, 0.39051938E-03_JPRB, 0.39059536E-03_JPRB, 0.39066610E-03_JPRB, &
  & 0.39063107E-03_JPRB, 0.39052613E-03_JPRB, 0.39008226E-03_JPRB, 0.38923638E-03_JPRB  /)

RGHG1(:,65, 3) = (/ &
  & 0.38241282E-03_JPRB, 0.38220238E-03_JPRB, 0.38226196E-03_JPRB, 0.38243015E-03_JPRB, 0.38238876E-03_JPRB, 0.38234103E-03_JPRB, &
  & 0.38224374E-03_JPRB, 0.38219908E-03_JPRB, 0.38225752E-03_JPRB, 0.38227831E-03_JPRB, 0.38225481E-03_JPRB, 0.38208003E-03_JPRB, &
  & 0.38181558E-03_JPRB, 0.38158849E-03_JPRB, 0.38137796E-03_JPRB, 0.38120982E-03_JPRB, 0.38105017E-03_JPRB, 0.38086275E-03_JPRB, &
  & 0.38079224E-03_JPRB, 0.38084257E-03_JPRB, 0.38097705E-03_JPRB, 0.38113154E-03_JPRB, 0.38145959E-03_JPRB, 0.38199939E-03_JPRB, &
  & 0.38245818E-03_JPRB, 0.38283066E-03_JPRB, 0.38322546E-03_JPRB, 0.38363091E-03_JPRB, 0.38435125E-03_JPRB, 0.38528346E-03_JPRB, &
  & 0.38597824E-03_JPRB, 0.38646214E-03_JPRB, 0.38671393E-03_JPRB, 0.38677972E-03_JPRB, 0.38649292E-03_JPRB, 0.38601823E-03_JPRB, &
  & 0.38558472E-03_JPRB, 0.38533918E-03_JPRB, 0.38522599E-03_JPRB, 0.38517421E-03_JPRB, 0.38530766E-03_JPRB, 0.38556257E-03_JPRB, &
  & 0.38585425E-03_JPRB, 0.38624666E-03_JPRB, 0.38654703E-03_JPRB, 0.38705352E-03_JPRB, 0.38764321E-03_JPRB, 0.38819765E-03_JPRB, &
  & 0.38872924E-03_JPRB, 0.38914084E-03_JPRB, 0.38939466E-03_JPRB, 0.38965071E-03_JPRB, 0.38989431E-03_JPRB, 0.39031804E-03_JPRB, &
  & 0.39048098E-03_JPRB, 0.39049939E-03_JPRB, 0.39061334E-03_JPRB, 0.39101347E-03_JPRB, 0.39115237E-03_JPRB, 0.39128647E-03_JPRB, &
  & 0.39128114E-03_JPRB, 0.39120359E-03_JPRB, 0.39077723E-03_JPRB, 0.39009870E-03_JPRB  /)

RGHG1(:,66, 3) = (/ &
  & 0.38243485E-03_JPRB, 0.38227617E-03_JPRB, 0.38232046E-03_JPRB, 0.38246221E-03_JPRB, 0.38241363E-03_JPRB, 0.38236013E-03_JPRB, &
  & 0.38225025E-03_JPRB, 0.38220665E-03_JPRB, 0.38225033E-03_JPRB, 0.38228413E-03_JPRB, 0.38226412E-03_JPRB, 0.38210599E-03_JPRB, &
  & 0.38184016E-03_JPRB, 0.38160760E-03_JPRB, 0.38137971E-03_JPRB, 0.38120422E-03_JPRB, 0.38103631E-03_JPRB, 0.38083989E-03_JPRB, &
  & 0.38075891E-03_JPRB, 0.38079155E-03_JPRB, 0.38092733E-03_JPRB, 0.38110375E-03_JPRB, 0.38144138E-03_JPRB, 0.38197065E-03_JPRB, &
  & 0.38241751E-03_JPRB, 0.38278944E-03_JPRB, 0.38312768E-03_JPRB, 0.38352145E-03_JPRB, 0.38430054E-03_JPRB, 0.38526210E-03_JPRB, &
  & 0.38599728E-03_JPRB, 0.38651671E-03_JPRB, 0.38677638E-03_JPRB, 0.38685062E-03_JPRB, 0.38656633E-03_JPRB, 0.38608479E-03_JPRB, &
  & 0.38566879E-03_JPRB, 0.38542931E-03_JPRB, 0.38532317E-03_JPRB, 0.38530060E-03_JPRB, 0.38543424E-03_JPRB, 0.38569674E-03_JPRB, &
  & 0.38599518E-03_JPRB, 0.38639255E-03_JPRB, 0.38672077E-03_JPRB, 0.38725455E-03_JPRB, 0.38787268E-03_JPRB, 0.38844562E-03_JPRB, &
  & 0.38897745E-03_JPRB, 0.38938886E-03_JPRB, 0.38967288E-03_JPRB, 0.38998593E-03_JPRB, 0.39027595E-03_JPRB, 0.39070593E-03_JPRB, &
  & 0.39087721E-03_JPRB, 0.39091913E-03_JPRB, 0.39108383E-03_JPRB, 0.39150532E-03_JPRB, 0.39169449E-03_JPRB, 0.39188099E-03_JPRB, &
  & 0.39188773E-03_JPRB, 0.39183500E-03_JPRB, 0.39145436E-03_JPRB, 0.39089623E-03_JPRB  /)

RGHG1(:,67, 3) = (/ &
  & 0.38247494E-03_JPRB, 0.38236483E-03_JPRB, 0.38239348E-03_JPRB, 0.38250328E-03_JPRB, 0.38245687E-03_JPRB, 0.38239159E-03_JPRB, &
  & 0.38226380E-03_JPRB, 0.38222163E-03_JPRB, 0.38225356E-03_JPRB, 0.38229384E-03_JPRB, 0.38227609E-03_JPRB, 0.38213466E-03_JPRB, &
  & 0.38187078E-03_JPRB, 0.38163666E-03_JPRB, 0.38139516E-03_JPRB, 0.38121636E-03_JPRB, 0.38103888E-03_JPRB, 0.38083540E-03_JPRB, &
  & 0.38073798E-03_JPRB, 0.38075448E-03_JPRB, 0.38088936E-03_JPRB, 0.38109612E-03_JPRB, 0.38144684E-03_JPRB, 0.38195865E-03_JPRB, &
  & 0.38237939E-03_JPRB, 0.38274039E-03_JPRB, 0.38303394E-03_JPRB, 0.38343369E-03_JPRB, 0.38426329E-03_JPRB, 0.38524375E-03_JPRB, &
  & 0.38601762E-03_JPRB, 0.38657981E-03_JPRB, 0.38685850E-03_JPRB, 0.38694445E-03_JPRB, 0.38667993E-03_JPRB, 0.38620562E-03_JPRB, &
  & 0.38579828E-03_JPRB, 0.38555558E-03_JPRB, 0.38544549E-03_JPRB, 0.38545160E-03_JPRB, 0.38558366E-03_JPRB, 0.38584709E-03_JPRB, &
  & 0.38615132E-03_JPRB, 0.38654898E-03_JPRB, 0.38691217E-03_JPRB, 0.38747287E-03_JPRB, 0.38811917E-03_JPRB, 0.38870821E-03_JPRB, &
  & 0.38924035E-03_JPRB, 0.38964934E-03_JPRB, 0.38996736E-03_JPRB, 0.39032981E-03_JPRB, 0.39066395E-03_JPRB, 0.39109745E-03_JPRB, &
  & 0.39127052E-03_JPRB, 0.39135162E-03_JPRB, 0.39156106E-03_JPRB, 0.39199206E-03_JPRB, 0.39221625E-03_JPRB, 0.39244575E-03_JPRB, &
  & 0.39245399E-03_JPRB, 0.39242281E-03_JPRB, 0.39210163E-03_JPRB, 0.39162181E-03_JPRB  /)

RGHG1(:,68, 3) = (/ &
  & 0.38253526E-03_JPRB, 0.38245393E-03_JPRB, 0.38246922E-03_JPRB, 0.38254518E-03_JPRB, 0.38250706E-03_JPRB, 0.38242773E-03_JPRB, &
  & 0.38228084E-03_JPRB, 0.38224166E-03_JPRB, 0.38226622E-03_JPRB, 0.38230581E-03_JPRB, 0.38228944E-03_JPRB, 0.38216505E-03_JPRB, &
  & 0.38190854E-03_JPRB, 0.38167304E-03_JPRB, 0.38142371E-03_JPRB, 0.38124422E-03_JPRB, 0.38105247E-03_JPRB, 0.38085014E-03_JPRB, &
  & 0.38073245E-03_JPRB, 0.38073859E-03_JPRB, 0.38087117E-03_JPRB, 0.38110948E-03_JPRB, 0.38146733E-03_JPRB, 0.38197201E-03_JPRB, &
  & 0.38234462E-03_JPRB, 0.38266902E-03_JPRB, 0.38294484E-03_JPRB, 0.38338096E-03_JPRB, 0.38424303E-03_JPRB, 0.38524237E-03_JPRB, &
  & 0.38604249E-03_JPRB, 0.38665141E-03_JPRB, 0.38696257E-03_JPRB, 0.38705934E-03_JPRB, 0.38683764E-03_JPRB, 0.38639763E-03_JPRB, &
  & 0.38597326E-03_JPRB, 0.38572665E-03_JPRB, 0.38559583E-03_JPRB, 0.38562221E-03_JPRB, 0.38575427E-03_JPRB, 0.38600849E-03_JPRB, &
  & 0.38632146E-03_JPRB, 0.38671889E-03_JPRB, 0.38712192E-03_JPRB, 0.38771301E-03_JPRB, 0.38838256E-03_JPRB, 0.38898610E-03_JPRB, &
  & 0.38952170E-03_JPRB, 0.38992793E-03_JPRB, 0.39028394E-03_JPRB, 0.39067931E-03_JPRB, 0.39105352E-03_JPRB, 0.39149439E-03_JPRB, &
  & 0.39166469E-03_JPRB, 0.39179368E-03_JPRB, 0.39203559E-03_JPRB, 0.39247119E-03_JPRB, 0.39271150E-03_JPRB, 0.39297277E-03_JPRB, &
  & 0.39298722E-03_JPRB, 0.39297285E-03_JPRB, 0.39269588E-03_JPRB, 0.39226947E-03_JPRB  /)

RGHG1(:,69, 3) = (/ &
  & 0.38260311E-03_JPRB, 0.38252667E-03_JPRB, 0.38253239E-03_JPRB, 0.38257786E-03_JPRB, 0.38254802E-03_JPRB, 0.38245864E-03_JPRB, &
  & 0.38230479E-03_JPRB, 0.38226504E-03_JPRB, 0.38228119E-03_JPRB, 0.38231841E-03_JPRB, 0.38230594E-03_JPRB, 0.38219439E-03_JPRB, &
  & 0.38195425E-03_JPRB, 0.38171884E-03_JPRB, 0.38146734E-03_JPRB, 0.38128653E-03_JPRB, 0.38108155E-03_JPRB, 0.38088687E-03_JPRB, &
  & 0.38075585E-03_JPRB, 0.38075247E-03_JPRB, 0.38088588E-03_JPRB, 0.38114295E-03_JPRB, 0.38149285E-03_JPRB, 0.38197216E-03_JPRB, &
  & 0.38230148E-03_JPRB, 0.38257985E-03_JPRB, 0.38285576E-03_JPRB, 0.38334166E-03_JPRB, 0.38424436E-03_JPRB, 0.38526320E-03_JPRB, &
  & 0.38608642E-03_JPRB, 0.38674249E-03_JPRB, 0.38707961E-03_JPRB, 0.38717882E-03_JPRB, 0.38699994E-03_JPRB, 0.38659423E-03_JPRB, &
  & 0.38615785E-03_JPRB, 0.38590984E-03_JPRB, 0.38577109E-03_JPRB, 0.38579970E-03_JPRB, 0.38593867E-03_JPRB, 0.38617677E-03_JPRB, &
  & 0.38650101E-03_JPRB, 0.38692272E-03_JPRB, 0.38736222E-03_JPRB, 0.38798223E-03_JPRB, 0.38866791E-03_JPRB, 0.38928344E-03_JPRB, &
  & 0.38983024E-03_JPRB, 0.39024230E-03_JPRB, 0.39063294E-03_JPRB, 0.39104635E-03_JPRB, 0.39145307E-03_JPRB, 0.39189145E-03_JPRB, &
  & 0.39206717E-03_JPRB, 0.39223859E-03_JPRB, 0.39250499E-03_JPRB, 0.39294415E-03_JPRB, 0.39319680E-03_JPRB, 0.39346616E-03_JPRB, &
  & 0.39350234E-03_JPRB, 0.39351063E-03_JPRB, 0.39325020E-03_JPRB, 0.39289313E-03_JPRB  /)

RGHG1(:,70, 3) = (/ &
  & 0.38266509E-03_JPRB, 0.38258985E-03_JPRB, 0.38258500E-03_JPRB, 0.38260293E-03_JPRB, 0.38257846E-03_JPRB, 0.38248460E-03_JPRB, &
  & 0.38233195E-03_JPRB, 0.38228886E-03_JPRB, 0.38229393E-03_JPRB, 0.38233009E-03_JPRB, 0.38232177E-03_JPRB, 0.38222174E-03_JPRB, &
  & 0.38200305E-03_JPRB, 0.38177041E-03_JPRB, 0.38152132E-03_JPRB, 0.38133992E-03_JPRB, 0.38112581E-03_JPRB, 0.38093716E-03_JPRB, &
  & 0.38080000E-03_JPRB, 0.38078917E-03_JPRB, 0.38092133E-03_JPRB, 0.38118402E-03_JPRB, 0.38151336E-03_JPRB, 0.38194913E-03_JPRB, &
  & 0.38224090E-03_JPRB, 0.38248252E-03_JPRB, 0.38275412E-03_JPRB, 0.38328373E-03_JPRB, 0.38422942E-03_JPRB, 0.38526532E-03_JPRB, &
  & 0.38612810E-03_JPRB, 0.38683962E-03_JPRB, 0.38718766E-03_JPRB, 0.38729076E-03_JPRB, 0.38714488E-03_JPRB, 0.38676163E-03_JPRB, &
  & 0.38633004E-03_JPRB, 0.38608784E-03_JPRB, 0.38595323E-03_JPRB, 0.38598030E-03_JPRB, 0.38612742E-03_JPRB, 0.38635363E-03_JPRB, &
  & 0.38669609E-03_JPRB, 0.38715433E-03_JPRB, 0.38762830E-03_JPRB, 0.38826991E-03_JPRB, 0.38897011E-03_JPRB, 0.38959914E-03_JPRB, &
  & 0.39015994E-03_JPRB, 0.39058739E-03_JPRB, 0.39100664E-03_JPRB, 0.39143198E-03_JPRB, 0.39186411E-03_JPRB, 0.39229167E-03_JPRB, &
  & 0.39247683E-03_JPRB, 0.39268113E-03_JPRB, 0.39296888E-03_JPRB, 0.39341217E-03_JPRB, 0.39367949E-03_JPRB, 0.39394311E-03_JPRB, &
  & 0.39401449E-03_JPRB, 0.39404635E-03_JPRB, 0.39380417E-03_JPRB, 0.39352055E-03_JPRB  /)

RGHG1(:,71, 3) = (/ &
  & 0.38271620E-03_JPRB, 0.38264386E-03_JPRB, 0.38262724E-03_JPRB, 0.38262143E-03_JPRB, 0.38259885E-03_JPRB, 0.38250552E-03_JPRB, &
  & 0.38235961E-03_JPRB, 0.38231146E-03_JPRB, 0.38230390E-03_JPRB, 0.38233919E-03_JPRB, 0.38233572E-03_JPRB, 0.38224670E-03_JPRB, &
  & 0.38205304E-03_JPRB, 0.38182710E-03_JPRB, 0.38158465E-03_JPRB, 0.38140378E-03_JPRB, 0.38118512E-03_JPRB, 0.38099980E-03_JPRB, &
  & 0.38086249E-03_JPRB, 0.38084653E-03_JPRB, 0.38097226E-03_JPRB, 0.38122685E-03_JPRB, 0.38152596E-03_JPRB, 0.38190162E-03_JPRB, &
  & 0.38216245E-03_JPRB, 0.38237384E-03_JPRB, 0.38263464E-03_JPRB, 0.38319767E-03_JPRB, 0.38418585E-03_JPRB, 0.38523581E-03_JPRB, &
  & 0.38615809E-03_JPRB, 0.38693102E-03_JPRB, 0.38727818E-03_JPRB, 0.38738769E-03_JPRB, 0.38726700E-03_JPRB, 0.38689718E-03_JPRB, &
  & 0.38648272E-03_JPRB, 0.38625559E-03_JPRB, 0.38613507E-03_JPRB, 0.38616274E-03_JPRB, 0.38631711E-03_JPRB, 0.38654158E-03_JPRB, &
  & 0.38691117E-03_JPRB, 0.38741451E-03_JPRB, 0.38792175E-03_JPRB, 0.38857649E-03_JPRB, 0.38928919E-03_JPRB, 0.38993316E-03_JPRB, &
  & 0.39050883E-03_JPRB, 0.39095906E-03_JPRB, 0.39139992E-03_JPRB, 0.39183576E-03_JPRB, 0.39228690E-03_JPRB, 0.39269600E-03_JPRB, &
  & 0.39289065E-03_JPRB, 0.39311603E-03_JPRB, 0.39342379E-03_JPRB, 0.39387244E-03_JPRB, 0.39415567E-03_JPRB, 0.39440313E-03_JPRB, &
  & 0.39452107E-03_JPRB, 0.39458016E-03_JPRB, 0.39436210E-03_JPRB, 0.39414578E-03_JPRB  /)

RGHG1(:,72, 3) = (/ &
  & 0.38274950E-03_JPRB, 0.38268799E-03_JPRB, 0.38265893E-03_JPRB, 0.38263491E-03_JPRB, 0.38261026E-03_JPRB, 0.38252108E-03_JPRB, &
  & 0.38238347E-03_JPRB, 0.38233024E-03_JPRB, 0.38231093E-03_JPRB, 0.38234276E-03_JPRB, 0.38234621E-03_JPRB, 0.38226871E-03_JPRB, &
  & 0.38210179E-03_JPRB, 0.38188875E-03_JPRB, 0.38165690E-03_JPRB, 0.38147810E-03_JPRB, 0.38125991E-03_JPRB, 0.38107482E-03_JPRB, &
  & 0.38094096E-03_JPRB, 0.38092247E-03_JPRB, 0.38103161E-03_JPRB, 0.38126292E-03_JPRB, 0.38152700E-03_JPRB, 0.38182845E-03_JPRB, &
  & 0.38206646E-03_JPRB, 0.38224489E-03_JPRB, 0.38248887E-03_JPRB, 0.38307080E-03_JPRB, 0.38409677E-03_JPRB, 0.38515734E-03_JPRB, &
  & 0.38616235E-03_JPRB, 0.38699682E-03_JPRB, 0.38733914E-03_JPRB, 0.38745763E-03_JPRB, 0.38736023E-03_JPRB, 0.38700262E-03_JPRB, &
  & 0.38660683E-03_JPRB, 0.38640736E-03_JPRB, 0.38630712E-03_JPRB, 0.38634607E-03_JPRB, 0.38650391E-03_JPRB, 0.38674612E-03_JPRB, &
  & 0.38715489E-03_JPRB, 0.38770778E-03_JPRB, 0.38824844E-03_JPRB, 0.38890663E-03_JPRB, 0.38962786E-03_JPRB, 0.39028727E-03_JPRB, &
  & 0.39087608E-03_JPRB, 0.39135236E-03_JPRB, 0.39180635E-03_JPRB, 0.39225856E-03_JPRB, 0.39272352E-03_JPRB, 0.39310727E-03_JPRB, &
  & 0.39330469E-03_JPRB, 0.39353560E-03_JPRB, 0.39386456E-03_JPRB, 0.39432082E-03_JPRB, 0.39461788E-03_JPRB, 0.39484298E-03_JPRB, &
  & 0.39501554E-03_JPRB, 0.39511220E-03_JPRB, 0.39492618E-03_JPRB, 0.39475364E-03_JPRB  /)

RGHG1(:,73, 3) = (/ &
  & 0.38275925E-03_JPRB, 0.38271249E-03_JPRB, 0.38268225E-03_JPRB, 0.38264313E-03_JPRB, 0.38261317E-03_JPRB, 0.38252774E-03_JPRB, &
  & 0.38239912E-03_JPRB, 0.38234421E-03_JPRB, 0.38231736E-03_JPRB, 0.38234229E-03_JPRB, 0.38235205E-03_JPRB, 0.38229149E-03_JPRB, &
  & 0.38214739E-03_JPRB, 0.38195418E-03_JPRB, 0.38173706E-03_JPRB, 0.38156013E-03_JPRB, 0.38135010E-03_JPRB, 0.38116589E-03_JPRB, &
  & 0.38103422E-03_JPRB, 0.38101232E-03_JPRB, 0.38109194E-03_JPRB, 0.38129085E-03_JPRB, 0.38151371E-03_JPRB, 0.38174009E-03_JPRB, &
  & 0.38195600E-03_JPRB, 0.38209573E-03_JPRB, 0.38232279E-03_JPRB, 0.38290982E-03_JPRB, 0.38396718E-03_JPRB, 0.38504611E-03_JPRB, &
  & 0.38612685E-03_JPRB, 0.38700182E-03_JPRB, 0.38734655E-03_JPRB, 0.38748285E-03_JPRB, 0.38744373E-03_JPRB, 0.38709670E-03_JPRB, &
  & 0.38670171E-03_JPRB, 0.38654738E-03_JPRB, 0.38647203E-03_JPRB, 0.38654524E-03_JPRB, 0.38670227E-03_JPRB, 0.38699121E-03_JPRB, &
  & 0.38745393E-03_JPRB, 0.38806051E-03_JPRB, 0.38862366E-03_JPRB, 0.38927656E-03_JPRB, 0.39000850E-03_JPRB, 0.39066997E-03_JPRB, &
  & 0.39126814E-03_JPRB, 0.39176997E-03_JPRB, 0.39223589E-03_JPRB, 0.39270092E-03_JPRB, 0.39317830E-03_JPRB, 0.39354297E-03_JPRB, &
  & 0.39373012E-03_JPRB, 0.39394541E-03_JPRB, 0.39430126E-03_JPRB, 0.39476325E-03_JPRB, 0.39507143E-03_JPRB, 0.39527491E-03_JPRB, &
  & 0.39546561E-03_JPRB, 0.39561738E-03_JPRB, 0.39547748E-03_JPRB, 0.39530556E-03_JPRB  /)

RGHG1(:,74, 3) = (/ &
  & 0.38275623E-03_JPRB, 0.38272633E-03_JPRB, 0.38269962E-03_JPRB, 0.38264817E-03_JPRB, 0.38261141E-03_JPRB, 0.38252996E-03_JPRB, &
  & 0.38241037E-03_JPRB, 0.38235575E-03_JPRB, 0.38232060E-03_JPRB, 0.38233807E-03_JPRB, 0.38235255E-03_JPRB, 0.38230937E-03_JPRB, &
  & 0.38218621E-03_JPRB, 0.38201576E-03_JPRB, 0.38181605E-03_JPRB, 0.38164641E-03_JPRB, 0.38144936E-03_JPRB, 0.38126997E-03_JPRB, &
  & 0.38113983E-03_JPRB, 0.38111056E-03_JPRB, 0.38115626E-03_JPRB, 0.38131842E-03_JPRB, 0.38150153E-03_JPRB, 0.38166258E-03_JPRB, &
  & 0.38184828E-03_JPRB, 0.38195136E-03_JPRB, 0.38215316E-03_JPRB, 0.38273926E-03_JPRB, 0.38380112E-03_JPRB, 0.38490253E-03_JPRB, &
  & 0.38605653E-03_JPRB, 0.38695961E-03_JPRB, 0.38731417E-03_JPRB, 0.38748682E-03_JPRB, 0.38752124E-03_JPRB, 0.38719646E-03_JPRB, &
  & 0.38680259E-03_JPRB, 0.38669497E-03_JPRB, 0.38665447E-03_JPRB, 0.38677425E-03_JPRB, 0.38694767E-03_JPRB, 0.38728405E-03_JPRB, &
  & 0.38780427E-03_JPRB, 0.38845467E-03_JPRB, 0.38902586E-03_JPRB, 0.38966592E-03_JPRB, 0.39041752E-03_JPRB, 0.39107602E-03_JPRB, &
  & 0.39167863E-03_JPRB, 0.39220344E-03_JPRB, 0.39268034E-03_JPRB, 0.39315969E-03_JPRB, 0.39364378E-03_JPRB, 0.39399562E-03_JPRB, &
  & 0.39416752E-03_JPRB, 0.39435890E-03_JPRB, 0.39473263E-03_JPRB, 0.39519279E-03_JPRB, 0.39551785E-03_JPRB, 0.39569269E-03_JPRB, &
  & 0.39587813E-03_JPRB, 0.39608100E-03_JPRB, 0.39599768E-03_JPRB, 0.39580466E-03_JPRB  /)

RGHG1(:,75, 3) = (/ &
  & 0.38274453E-03_JPRB, 0.38273234E-03_JPRB, 0.38271042E-03_JPRB, 0.38265032E-03_JPRB, 0.38260587E-03_JPRB, 0.38252922E-03_JPRB, &
  & 0.38241794E-03_JPRB, 0.38236598E-03_JPRB, 0.38232137E-03_JPRB, 0.38233096E-03_JPRB, 0.38234710E-03_JPRB, 0.38232105E-03_JPRB, &
  & 0.38221681E-03_JPRB, 0.38207049E-03_JPRB, 0.38189114E-03_JPRB, 0.38173618E-03_JPRB, 0.38155746E-03_JPRB, 0.38138470E-03_JPRB, &
  & 0.38125590E-03_JPRB, 0.38121599E-03_JPRB, 0.38122839E-03_JPRB, 0.38134978E-03_JPRB, 0.38149722E-03_JPRB, 0.38160284E-03_JPRB, &
  & 0.38174919E-03_JPRB, 0.38181968E-03_JPRB, 0.38199477E-03_JPRB, 0.38257007E-03_JPRB, 0.38360866E-03_JPRB, 0.38473128E-03_JPRB, &
  & 0.38595701E-03_JPRB, 0.38687977E-03_JPRB, 0.38725210E-03_JPRB, 0.38747594E-03_JPRB, 0.38759115E-03_JPRB, 0.38730560E-03_JPRB, &
  & 0.38691781E-03_JPRB, 0.38684945E-03_JPRB, 0.38686075E-03_JPRB, 0.38704092E-03_JPRB, 0.38725186E-03_JPRB, 0.38763337E-03_JPRB, &
  & 0.38820000E-03_JPRB, 0.38887709E-03_JPRB, 0.38944443E-03_JPRB, 0.39006869E-03_JPRB, 0.39084450E-03_JPRB, 0.39149994E-03_JPRB, &
  & 0.39210317E-03_JPRB, 0.39264400E-03_JPRB, 0.39313526E-03_JPRB, 0.39362875E-03_JPRB, 0.39411641E-03_JPRB, 0.39445956E-03_JPRB, &
  & 0.39461476E-03_JPRB, 0.39477852E-03_JPRB, 0.39515646E-03_JPRB, 0.39560495E-03_JPRB, 0.39595036E-03_JPRB, 0.39609058E-03_JPRB, &
  & 0.39625494E-03_JPRB, 0.39649829E-03_JPRB, 0.39647950E-03_JPRB, 0.39625836E-03_JPRB  /)

RGHG1(:,76, 3) = (/ &
  & 0.38272886E-03_JPRB, 0.38273349E-03_JPRB, 0.38271318E-03_JPRB, 0.38264963E-03_JPRB, 0.38259734E-03_JPRB, 0.38252714E-03_JPRB, &
  & 0.38242232E-03_JPRB, 0.38237635E-03_JPRB, 0.38232114E-03_JPRB, 0.38232220E-03_JPRB, 0.38233465E-03_JPRB, 0.38232520E-03_JPRB, &
  & 0.38223733E-03_JPRB, 0.38211475E-03_JPRB, 0.38195937E-03_JPRB, 0.38182908E-03_JPRB, 0.38167548E-03_JPRB, 0.38150733E-03_JPRB, &
  & 0.38138039E-03_JPRB, 0.38132803E-03_JPRB, 0.38131438E-03_JPRB, 0.38139059E-03_JPRB, 0.38150944E-03_JPRB, 0.38156826E-03_JPRB, &
  & 0.38166551E-03_JPRB, 0.38170949E-03_JPRB, 0.38186844E-03_JPRB, 0.38241562E-03_JPRB, 0.38340395E-03_JPRB, 0.38453856E-03_JPRB, &
  & 0.38583552E-03_JPRB, 0.38677442E-03_JPRB, 0.38717349E-03_JPRB, 0.38745657E-03_JPRB, 0.38765040E-03_JPRB, 0.38742801E-03_JPRB, &
  & 0.38705612E-03_JPRB, 0.38700759E-03_JPRB, 0.38709842E-03_JPRB, 0.38735720E-03_JPRB, 0.38763061E-03_JPRB, 0.38805431E-03_JPRB, &
  & 0.38863454E-03_JPRB, 0.38931140E-03_JPRB, 0.38986721E-03_JPRB, 0.39047972E-03_JPRB, 0.39127650E-03_JPRB, 0.39193539E-03_JPRB, &
  & 0.39253725E-03_JPRB, 0.39308038E-03_JPRB, 0.39359630E-03_JPRB, 0.39410040E-03_JPRB, 0.39459314E-03_JPRB, 0.39492845E-03_JPRB, &
  & 0.39506981E-03_JPRB, 0.39520753E-03_JPRB, 0.39557048E-03_JPRB, 0.39599430E-03_JPRB, 0.39635884E-03_JPRB, 0.39646103E-03_JPRB, &
  & 0.39659819E-03_JPRB, 0.39686390E-03_JPRB, 0.39691450E-03_JPRB, 0.39667814E-03_JPRB  /)

RGHG1(:,77, 3) = (/ &
  & 0.38271185E-03_JPRB, 0.38273045E-03_JPRB, 0.38270645E-03_JPRB, 0.38264472E-03_JPRB, 0.38258825E-03_JPRB, 0.38252260E-03_JPRB, &
  & 0.38242432E-03_JPRB, 0.38238399E-03_JPRB, 0.38232379E-03_JPRB, 0.38231398E-03_JPRB, 0.38232114E-03_JPRB, 0.38232209E-03_JPRB, &
  & 0.38224838E-03_JPRB, 0.38214412E-03_JPRB, 0.38201084E-03_JPRB, 0.38190668E-03_JPRB, 0.38178367E-03_JPRB, 0.38163039E-03_JPRB, &
  & 0.38150509E-03_JPRB, 0.38143989E-03_JPRB, 0.38140181E-03_JPRB, 0.38143375E-03_JPRB, 0.38152493E-03_JPRB, 0.38155537E-03_JPRB, &
  & 0.38161124E-03_JPRB, 0.38162811E-03_JPRB, 0.38177712E-03_JPRB, 0.38230043E-03_JPRB, 0.38323691E-03_JPRB, 0.38437103E-03_JPRB, &
  & 0.38573492E-03_JPRB, 0.38669152E-03_JPRB, 0.38710507E-03_JPRB, 0.38743095E-03_JPRB, 0.38768986E-03_JPRB, 0.38754574E-03_JPRB, &
  & 0.38719242E-03_JPRB, 0.38716289E-03_JPRB, 0.38734347E-03_JPRB, 0.38767621E-03_JPRB, 0.38800323E-03_JPRB, 0.38847770E-03_JPRB, &
  & 0.38907483E-03_JPRB, 0.38973261E-03_JPRB, 0.39027717E-03_JPRB, 0.39088729E-03_JPRB, 0.39170934E-03_JPRB, 0.39236820E-03_JPRB, &
  & 0.39296754E-03_JPRB, 0.39351234E-03_JPRB, 0.39404752E-03_JPRB, 0.39456348E-03_JPRB, 0.39506424E-03_JPRB, 0.39538983E-03_JPRB, &
  & 0.39551118E-03_JPRB, 0.39564309E-03_JPRB, 0.39596468E-03_JPRB, 0.39636682E-03_JPRB, 0.39672881E-03_JPRB, 0.39679264E-03_JPRB, &
  & 0.39690199E-03_JPRB, 0.39716820E-03_JPRB, 0.39728608E-03_JPRB, 0.39706932E-03_JPRB  /)

RGHG1(:,78, 3) = (/ &
  & 0.38269401E-03_JPRB, 0.38272028E-03_JPRB, 0.38269307E-03_JPRB, 0.38263565E-03_JPRB, 0.38257982E-03_JPRB, 0.38251712E-03_JPRB, &
  & 0.38242537E-03_JPRB, 0.38238900E-03_JPRB, 0.38232622E-03_JPRB, 0.38230634E-03_JPRB, 0.38230680E-03_JPRB, 0.38231258E-03_JPRB, &
  & 0.38224855E-03_JPRB, 0.38215897E-03_JPRB, 0.38204627E-03_JPRB, 0.38196258E-03_JPRB, 0.38186173E-03_JPRB, 0.38172785E-03_JPRB, &
  & 0.38160804E-03_JPRB, 0.38153224E-03_JPRB, 0.38147096E-03_JPRB, 0.38147012E-03_JPRB, 0.38153988E-03_JPRB, 0.38155165E-03_JPRB, &
  & 0.38157831E-03_JPRB, 0.38156413E-03_JPRB, 0.38170818E-03_JPRB, 0.38222072E-03_JPRB, 0.38311940E-03_JPRB, 0.38425413E-03_JPRB, &
  & 0.38566843E-03_JPRB, 0.38663874E-03_JPRB, 0.38705328E-03_JPRB, 0.38740885E-03_JPRB, 0.38771897E-03_JPRB, 0.38764220E-03_JPRB, &
  & 0.38730486E-03_JPRB, 0.38729882E-03_JPRB, 0.38756597E-03_JPRB, 0.38796116E-03_JPRB, 0.38833398E-03_JPRB, 0.38884153E-03_JPRB, &
  & 0.38945242E-03_JPRB, 0.39011702E-03_JPRB, 0.39066509E-03_JPRB, 0.39127008E-03_JPRB, 0.39211961E-03_JPRB, 0.39277868E-03_JPRB, &
  & 0.39338511E-03_JPRB, 0.39393392E-03_JPRB, 0.39447937E-03_JPRB, 0.39501019E-03_JPRB, 0.39551392E-03_JPRB, 0.39582763E-03_JPRB, &
  & 0.39593122E-03_JPRB, 0.39606560E-03_JPRB, 0.39633770E-03_JPRB, 0.39671631E-03_JPRB, 0.39706002E-03_JPRB, 0.39709022E-03_JPRB, &
  & 0.39717435E-03_JPRB, 0.39742769E-03_JPRB, 0.39760401E-03_JPRB, 0.39741776E-03_JPRB  /)

RGHG1(:,79, 3) = (/ &
  & 0.38267426E-03_JPRB, 0.38270322E-03_JPRB, 0.38267478E-03_JPRB, 0.38262278E-03_JPRB, 0.38257160E-03_JPRB, 0.38251069E-03_JPRB, &
  & 0.38242492E-03_JPRB, 0.38239082E-03_JPRB, 0.38232724E-03_JPRB, 0.38229882E-03_JPRB, 0.38229222E-03_JPRB, 0.38229875E-03_JPRB, &
  & 0.38224043E-03_JPRB, 0.38216013E-03_JPRB, 0.38206544E-03_JPRB, 0.38199713E-03_JPRB, 0.38191137E-03_JPRB, 0.38179698E-03_JPRB, &
  & 0.38168357E-03_JPRB, 0.38160145E-03_JPRB, 0.38152322E-03_JPRB, 0.38150135E-03_JPRB, 0.38155615E-03_JPRB, 0.38155690E-03_JPRB, &
  & 0.38156166E-03_JPRB, 0.38151609E-03_JPRB, 0.38165946E-03_JPRB, 0.38216947E-03_JPRB, 0.38304224E-03_JPRB, 0.38418068E-03_JPRB, &
  & 0.38563061E-03_JPRB, 0.38661125E-03_JPRB, 0.38701679E-03_JPRB, 0.38739214E-03_JPRB, 0.38774214E-03_JPRB, 0.38772020E-03_JPRB, &
  & 0.38739539E-03_JPRB, 0.38741701E-03_JPRB, 0.38776160E-03_JPRB, 0.38820684E-03_JPRB, 0.38861421E-03_JPRB, 0.38913997E-03_JPRB, &
  & 0.38976335E-03_JPRB, 0.39044480E-03_JPRB, 0.39100810E-03_JPRB, 0.39161278E-03_JPRB, 0.39249380E-03_JPRB, 0.39315621E-03_JPRB, &
  & 0.39377878E-03_JPRB, 0.39433670E-03_JPRB, 0.39488556E-03_JPRB, 0.39543121E-03_JPRB, 0.39593753E-03_JPRB, 0.39623930E-03_JPRB, &
  & 0.39632821E-03_JPRB, 0.39646753E-03_JPRB, 0.39668853E-03_JPRB, 0.39704189E-03_JPRB, 0.39735392E-03_JPRB, 0.39735528E-03_JPRB, &
  & 0.39742160E-03_JPRB, 0.39765131E-03_JPRB, 0.39787719E-03_JPRB, 0.39772723E-03_JPRB  /)

RGHG1(:,80, 3) = (/ &
  & 0.38265144E-03_JPRB, 0.38267994E-03_JPRB, 0.38265354E-03_JPRB, 0.38260660E-03_JPRB, 0.38256301E-03_JPRB, 0.38250323E-03_JPRB, &
  & 0.38242225E-03_JPRB, 0.38238886E-03_JPRB, 0.38232573E-03_JPRB, 0.38229088E-03_JPRB, 0.38227811E-03_JPRB, 0.38228308E-03_JPRB, &
  & 0.38222729E-03_JPRB, 0.38214881E-03_JPRB, 0.38206848E-03_JPRB, 0.38201167E-03_JPRB, 0.38193648E-03_JPRB, 0.38183706E-03_JPRB, &
  & 0.38172729E-03_JPRB, 0.38164512E-03_JPRB, 0.38156174E-03_JPRB, 0.38152992E-03_JPRB, 0.38157589E-03_JPRB, 0.38157130E-03_JPRB, &
  & 0.38155568E-03_JPRB, 0.38148271E-03_JPRB, 0.38162890E-03_JPRB, 0.38213847E-03_JPRB, 0.38299353E-03_JPRB, 0.38413998E-03_JPRB, &
  & 0.38561381E-03_JPRB, 0.38660249E-03_JPRB, 0.38699326E-03_JPRB, 0.38738209E-03_JPRB, 0.38776381E-03_JPRB, 0.38778414E-03_JPRB, &
  & 0.38746779E-03_JPRB, 0.38752053E-03_JPRB, 0.38792789E-03_JPRB, 0.38841059E-03_JPRB, 0.38883764E-03_JPRB, 0.38937200E-03_JPRB, &
  & 0.39000940E-03_JPRB, 0.39069665E-03_JPRB, 0.39128220E-03_JPRB, 0.39190072E-03_JPRB, 0.39281922E-03_JPRB, 0.39349076E-03_JPRB, &
  & 0.39413683E-03_JPRB, 0.39471161E-03_JPRB, 0.39525982E-03_JPRB, 0.39581675E-03_JPRB, 0.39633101E-03_JPRB, 0.39662302E-03_JPRB, &
  & 0.39670051E-03_JPRB, 0.39684139E-03_JPRB, 0.39701614E-03_JPRB, 0.39734315E-03_JPRB, 0.39761284E-03_JPRB, 0.39758968E-03_JPRB, &
  & 0.39765064E-03_JPRB, 0.39784862E-03_JPRB, 0.39811588E-03_JPRB, 0.39800370E-03_JPRB  /)

RGHG1(:,81, 3) = (/ &
  & 0.38262584E-03_JPRB, 0.38265339E-03_JPRB, 0.38263173E-03_JPRB, 0.38258977E-03_JPRB, 0.38255281E-03_JPRB, 0.38249541E-03_JPRB, &
  & 0.38242131E-03_JPRB, 0.38238791E-03_JPRB, 0.38232502E-03_JPRB, 0.38228354E-03_JPRB, 0.38226247E-03_JPRB, 0.38226222E-03_JPRB, &
  & 0.38220833E-03_JPRB, 0.38213293E-03_JPRB, 0.38205734E-03_JPRB, 0.38201072E-03_JPRB, 0.38194549E-03_JPRB, 0.38185863E-03_JPRB, &
  & 0.38175455E-03_JPRB, 0.38167712E-03_JPRB, 0.38159682E-03_JPRB, 0.38156144E-03_JPRB, 0.38160623E-03_JPRB, 0.38160094E-03_JPRB, &
  & 0.38155994E-03_JPRB, 0.38146540E-03_JPRB, 0.38160851E-03_JPRB, 0.38211666E-03_JPRB, 0.38295584E-03_JPRB, 0.38411178E-03_JPRB, &
  & 0.38560978E-03_JPRB, 0.38660557E-03_JPRB, 0.38698804E-03_JPRB, 0.38737617E-03_JPRB, 0.38778847E-03_JPRB, 0.38785052E-03_JPRB, &
  & 0.38754625E-03_JPRB, 0.38762127E-03_JPRB, 0.38806727E-03_JPRB, 0.38856609E-03_JPRB, 0.38899978E-03_JPRB, 0.38953438E-03_JPRB, &
  & 0.39016585E-03_JPRB, 0.39085452E-03_JPRB, 0.39146472E-03_JPRB, 0.39209249E-03_JPRB, 0.39304442E-03_JPRB, 0.39375009E-03_JPRB, &
  & 0.39443314E-03_JPRB, 0.39503636E-03_JPRB, 0.39557984E-03_JPRB, 0.39614625E-03_JPRB, 0.39667639E-03_JPRB, 0.39696863E-03_JPRB, &
  & 0.39704826E-03_JPRB, 0.39719459E-03_JPRB, 0.39731032E-03_JPRB, 0.39760580E-03_JPRB, 0.39782049E-03_JPRB, 0.39778690E-03_JPRB, &
  & 0.39784904E-03_JPRB, 0.39801740E-03_JPRB, 0.39830457E-03_JPRB, 0.39822036E-03_JPRB  /)

RGHG1(:,82, 3) = (/ &
  & 0.38260260E-03_JPRB, 0.38262808E-03_JPRB, 0.38261112E-03_JPRB, 0.38257508E-03_JPRB, 0.38254277E-03_JPRB, 0.38248902E-03_JPRB, &
  & 0.38242094E-03_JPRB, 0.38238607E-03_JPRB, 0.38232342E-03_JPRB, 0.38227681E-03_JPRB, 0.38225076E-03_JPRB, 0.38224713E-03_JPRB, &
  & 0.38219202E-03_JPRB, 0.38211740E-03_JPRB, 0.38204684E-03_JPRB, 0.38200725E-03_JPRB, 0.38195044E-03_JPRB, 0.38187426E-03_JPRB, &
  & 0.38177960E-03_JPRB, 0.38171096E-03_JPRB, 0.38163715E-03_JPRB, 0.38159857E-03_JPRB, 0.38164496E-03_JPRB, 0.38164009E-03_JPRB, &
  & 0.38157619E-03_JPRB, 0.38146005E-03_JPRB, 0.38158916E-03_JPRB, 0.38209981E-03_JPRB, 0.38291766E-03_JPRB, 0.38407991E-03_JPRB, &
  & 0.38560373E-03_JPRB, 0.38661117E-03_JPRB, 0.38698490E-03_JPRB, 0.38737689E-03_JPRB, 0.38781157E-03_JPRB, 0.38791720E-03_JPRB, &
  & 0.38762005E-03_JPRB, 0.38771443E-03_JPRB, 0.38818756E-03_JPRB, 0.38869259E-03_JPRB, 0.38912912E-03_JPRB, 0.38965710E-03_JPRB, &
  & 0.39028300E-03_JPRB, 0.39097701E-03_JPRB, 0.39160583E-03_JPRB, 0.39223886E-03_JPRB, 0.39322073E-03_JPRB, 0.39395771E-03_JPRB, &
  & 0.39466900E-03_JPRB, 0.39530245E-03_JPRB, 0.39585134E-03_JPRB, 0.39642244E-03_JPRB, 0.39696200E-03_JPRB, 0.39726296E-03_JPRB, &
  & 0.39735827E-03_JPRB, 0.39750871E-03_JPRB, 0.39756628E-03_JPRB, 0.39782896E-03_JPRB, 0.39798084E-03_JPRB, 0.39794538E-03_JPRB, &
  & 0.39800919E-03_JPRB, 0.39815595E-03_JPRB, 0.39844836E-03_JPRB, 0.39838689E-03_JPRB  /)

RGHG1(:,83, 3) = (/ &
  & 0.38258189E-03_JPRB, 0.38260488E-03_JPRB, 0.38259215E-03_JPRB, 0.38256251E-03_JPRB, 0.38253311E-03_JPRB, 0.38248375E-03_JPRB, &
  & 0.38242109E-03_JPRB, 0.38238358E-03_JPRB, 0.38232098E-03_JPRB, 0.38227020E-03_JPRB, 0.38224084E-03_JPRB, 0.38223554E-03_JPRB, &
  & 0.38217840E-03_JPRB, 0.38210291E-03_JPRB, 0.38203668E-03_JPRB, 0.38200288E-03_JPRB, 0.38195260E-03_JPRB, 0.38188704E-03_JPRB, &
  & 0.38180770E-03_JPRB, 0.38174894E-03_JPRB, 0.38168515E-03_JPRB, 0.38164444E-03_JPRB, 0.38169372E-03_JPRB, 0.38169124E-03_JPRB, &
  & 0.38160787E-03_JPRB, 0.38147396E-03_JPRB, 0.38157931E-03_JPRB, 0.38208910E-03_JPRB, 0.38288462E-03_JPRB, 0.38404726E-03_JPRB, &
  & 0.38559919E-03_JPRB, 0.38662777E-03_JPRB, 0.38698992E-03_JPRB, 0.38738676E-03_JPRB, 0.38783505E-03_JPRB, 0.38797886E-03_JPRB, &
  & 0.38768389E-03_JPRB, 0.38779572E-03_JPRB, 0.38829016E-03_JPRB, 0.38879734E-03_JPRB, 0.38923286E-03_JPRB, 0.38975099E-03_JPRB, &
  & 0.39037288E-03_JPRB, 0.39107616E-03_JPRB, 0.39172050E-03_JPRB, 0.39235513E-03_JPRB, 0.39336156E-03_JPRB, 0.39412309E-03_JPRB, &
  & 0.39485144E-03_JPRB, 0.39551382E-03_JPRB, 0.39607677E-03_JPRB, 0.39664636E-03_JPRB, 0.39718667E-03_JPRB, 0.39750743E-03_JPRB, &
  & 0.39762830E-03_JPRB, 0.39778342E-03_JPRB, 0.39779104E-03_JPRB, 0.39801405E-03_JPRB, 0.39810242E-03_JPRB, 0.39806412E-03_JPRB, &
  & 0.39813260E-03_JPRB, 0.39826083E-03_JPRB, 0.39855217E-03_JPRB, 0.39851708E-03_JPRB  /)

RGHG1(:,84, 3) = (/ &
  & 0.38256376E-03_JPRB, 0.38258450E-03_JPRB, 0.38257523E-03_JPRB, 0.38255197E-03_JPRB, 0.38252413E-03_JPRB, 0.38247933E-03_JPRB, &
  & 0.38242163E-03_JPRB, 0.38238068E-03_JPRB, 0.38231778E-03_JPRB, 0.38226337E-03_JPRB, 0.38223112E-03_JPRB, 0.38222562E-03_JPRB, &
  & 0.38216733E-03_JPRB, 0.38209003E-03_JPRB, 0.38202662E-03_JPRB, 0.38199887E-03_JPRB, 0.38195308E-03_JPRB, 0.38189964E-03_JPRB, &
  & 0.38184314E-03_JPRB, 0.38179269E-03_JPRB, 0.38174237E-03_JPRB, 0.38170102E-03_JPRB, 0.38175303E-03_JPRB, 0.38175516E-03_JPRB, &
  & 0.38165680E-03_JPRB, 0.38151226E-03_JPRB, 0.38158732E-03_JPRB, 0.38208816E-03_JPRB, 0.38286374E-03_JPRB, 0.38401954E-03_JPRB, &
  & 0.38560099E-03_JPRB, 0.38666196E-03_JPRB, 0.38700749E-03_JPRB, 0.38740876E-03_JPRB, 0.38786374E-03_JPRB, 0.38803308E-03_JPRB, &
  & 0.38773469E-03_JPRB, 0.38786274E-03_JPRB, 0.38837769E-03_JPRB, 0.38888696E-03_JPRB, 0.38931838E-03_JPRB, 0.38982659E-03_JPRB, &
  & 0.39044670E-03_JPRB, 0.39116261E-03_JPRB, 0.39182194E-03_JPRB, 0.39245455E-03_JPRB, 0.39347905E-03_JPRB, 0.39425568E-03_JPRB, &
  & 0.39498943E-03_JPRB, 0.39567689E-03_JPRB, 0.39626017E-03_JPRB, 0.39682165E-03_JPRB, 0.39735306E-03_JPRB, 0.39770527E-03_JPRB, &
  & 0.39785728E-03_JPRB, 0.39801940E-03_JPRB, 0.39799092E-03_JPRB, 0.39816388E-03_JPRB, 0.39819384E-03_JPRB, 0.39814473E-03_JPRB, &
  & 0.39822216E-03_JPRB, 0.39833181E-03_JPRB, 0.39862256E-03_JPRB, 0.39862487E-03_JPRB  /)

RGHG1(:,85, 3) = (/ &
  & 0.38254775E-03_JPRB, 0.38256682E-03_JPRB, 0.38256137E-03_JPRB, 0.38254360E-03_JPRB, 0.38251648E-03_JPRB, 0.38247574E-03_JPRB, &
  & 0.38242163E-03_JPRB, 0.38237733E-03_JPRB, 0.38231300E-03_JPRB, 0.38225573E-03_JPRB, 0.38222204E-03_JPRB, 0.38221677E-03_JPRB, &
  & 0.38215729E-03_JPRB, 0.38207856E-03_JPRB, 0.38201538E-03_JPRB, 0.38199505E-03_JPRB, 0.38195212E-03_JPRB, 0.38191708E-03_JPRB, &
  & 0.38189953E-03_JPRB, 0.38185100E-03_JPRB, 0.38182003E-03_JPRB, 0.38177892E-03_JPRB, 0.38182949E-03_JPRB, 0.38183665E-03_JPRB, &
  & 0.38173303E-03_JPRB, 0.38159494E-03_JPRB, 0.38165446E-03_JPRB, 0.38214288E-03_JPRB, 0.38289911E-03_JPRB, 0.38404535E-03_JPRB, &
  & 0.38564377E-03_JPRB, 0.38673365E-03_JPRB, 0.38704667E-03_JPRB, 0.38747160E-03_JPRB, 0.38795167E-03_JPRB, 0.38810405E-03_JPRB, &
  & 0.38778081E-03_JPRB, 0.38792367E-03_JPRB, 0.38846754E-03_JPRB, 0.38897203E-03_JPRB, 0.38940344E-03_JPRB, 0.38990473E-03_JPRB, &
  & 0.39052388E-03_JPRB, 0.39125246E-03_JPRB, 0.39193138E-03_JPRB, 0.39255180E-03_JPRB, 0.39358968E-03_JPRB, 0.39436966E-03_JPRB, &
  & 0.39510699E-03_JPRB, 0.39581309E-03_JPRB, 0.39641501E-03_JPRB, 0.39696359E-03_JPRB, 0.39747612E-03_JPRB, 0.39786680E-03_JPRB, &
  & 0.39804510E-03_JPRB, 0.39822299E-03_JPRB, 0.39817946E-03_JPRB, 0.39828813E-03_JPRB, 0.39826577E-03_JPRB, 0.39819467E-03_JPRB, &
  & 0.39828095E-03_JPRB, 0.39837960E-03_JPRB, 0.39867489E-03_JPRB, 0.39874674E-03_JPRB  /)

RGHG1(:,86, 3) = (/ &
  & 0.38253344E-03_JPRB, 0.38255138E-03_JPRB, 0.38254978E-03_JPRB, 0.38253660E-03_JPRB, 0.38251076E-03_JPRB, 0.38247205E-03_JPRB, &
  & 0.38242098E-03_JPRB, 0.38237444E-03_JPRB, 0.38230792E-03_JPRB, 0.38224870E-03_JPRB, 0.38221450E-03_JPRB, 0.38220985E-03_JPRB, &
  & 0.38214917E-03_JPRB, 0.38206899E-03_JPRB, 0.38200475E-03_JPRB, 0.38199261E-03_JPRB, 0.38195257E-03_JPRB, 0.38193695E-03_JPRB, &
  & 0.38196584E-03_JPRB, 0.38191811E-03_JPRB, 0.38190772E-03_JPRB, 0.38187077E-03_JPRB, 0.38192196E-03_JPRB, 0.38193995E-03_JPRB, &
  & 0.38184208E-03_JPRB, 0.38171702E-03_JPRB, 0.38179609E-03_JPRB, 0.38226304E-03_JPRB, 0.38300580E-03_JPRB, 0.38416375E-03_JPRB, &
  & 0.38576744E-03_JPRB, 0.38687367E-03_JPRB, 0.38714150E-03_JPRB, 0.38760872E-03_JPRB, 0.38809811E-03_JPRB, 0.38819829E-03_JPRB, &
  & 0.38783978E-03_JPRB, 0.38800071E-03_JPRB, 0.38856934E-03_JPRB, 0.38906005E-03_JPRB, 0.38951260E-03_JPRB, 0.39000169E-03_JPRB, &
  & 0.39061464E-03_JPRB, 0.39135893E-03_JPRB, 0.39205605E-03_JPRB, 0.39265787E-03_JPRB, 0.39370546E-03_JPRB, 0.39448356E-03_JPRB, &
  & 0.39522076E-03_JPRB, 0.39594129E-03_JPRB, 0.39655970E-03_JPRB, 0.39708727E-03_JPRB, 0.39758101E-03_JPRB, 0.39800718E-03_JPRB, &
  & 0.39820218E-03_JPRB, 0.39840264E-03_JPRB, 0.39835950E-03_JPRB, 0.39840301E-03_JPRB, 0.39831665E-03_JPRB, 0.39822140E-03_JPRB, &
  & 0.39830983E-03_JPRB, 0.39840043E-03_JPRB, 0.39870776E-03_JPRB, 0.39884333E-03_JPRB  /)

RGHG1(:,87, 3) = (/ &
  & 0.38252172E-03_JPRB, 0.38253769E-03_JPRB, 0.38254036E-03_JPRB, 0.38253082E-03_JPRB, 0.38250620E-03_JPRB, 0.38246870E-03_JPRB, &
  & 0.38242018E-03_JPRB, 0.38237194E-03_JPRB, 0.38230249E-03_JPRB, 0.38224231E-03_JPRB, 0.38220799E-03_JPRB, 0.38220382E-03_JPRB, &
  & 0.38214229E-03_JPRB, 0.38206090E-03_JPRB, 0.38199495E-03_JPRB, 0.38199159E-03_JPRB, 0.38195560E-03_JPRB, 0.38195961E-03_JPRB, &
  & 0.38204350E-03_JPRB, 0.38200049E-03_JPRB, 0.38200758E-03_JPRB, 0.38198609E-03_JPRB, 0.38203152E-03_JPRB, 0.38206258E-03_JPRB, &
  & 0.38198630E-03_JPRB, 0.38188832E-03_JPRB, 0.38201196E-03_JPRB, 0.38244219E-03_JPRB, 0.38319130E-03_JPRB, 0.38439444E-03_JPRB, &
  & 0.38600183E-03_JPRB, 0.38712098E-03_JPRB, 0.38732560E-03_JPRB, 0.38782269E-03_JPRB, 0.38829231E-03_JPRB, 0.38831250E-03_JPRB, &
  & 0.38792331E-03_JPRB, 0.38811670E-03_JPRB, 0.38870139E-03_JPRB, 0.38917290E-03_JPRB, 0.38966135E-03_JPRB, 0.39013629E-03_JPRB, &
  & 0.39073372E-03_JPRB, 0.39149347E-03_JPRB, 0.39221076E-03_JPRB, 0.39278960E-03_JPRB, 0.39384361E-03_JPRB, 0.39461269E-03_JPRB, &
  & 0.39534531E-03_JPRB, 0.39607527E-03_JPRB, 0.39671028E-03_JPRB, 0.39721331E-03_JPRB, 0.39768367E-03_JPRB, 0.39814098E-03_JPRB, &
  & 0.39834104E-03_JPRB, 0.39856775E-03_JPRB, 0.39853571E-03_JPRB, 0.39851251E-03_JPRB, 0.39835398E-03_JPRB, 0.39823411E-03_JPRB, &
  & 0.39831955E-03_JPRB, 0.39840121E-03_JPRB, 0.39872019E-03_JPRB, 0.39890686E-03_JPRB  /)

RGHG1(:,88, 3) = (/ &
  & 0.38251249E-03_JPRB, 0.38252584E-03_JPRB, 0.38253300E-03_JPRB, 0.38252601E-03_JPRB, 0.38250240E-03_JPRB, 0.38246586E-03_JPRB, &
  & 0.38241971E-03_JPRB, 0.38236987E-03_JPRB, 0.38229676E-03_JPRB, 0.38223654E-03_JPRB, 0.38220230E-03_JPRB, 0.38219817E-03_JPRB, &
  & 0.38213627E-03_JPRB, 0.38205386E-03_JPRB, 0.38198601E-03_JPRB, 0.38199211E-03_JPRB, 0.38196346E-03_JPRB, 0.38199053E-03_JPRB, &
  & 0.38214380E-03_JPRB, 0.38210970E-03_JPRB, 0.38212797E-03_JPRB, 0.38213272E-03_JPRB, 0.38216255E-03_JPRB, 0.38220846E-03_JPRB, &
  & 0.38217723E-03_JPRB, 0.38212615E-03_JPRB, 0.38231854E-03_JPRB, 0.38270279E-03_JPRB, 0.38349392E-03_JPRB, 0.38479168E-03_JPRB, &
  & 0.38638519E-03_JPRB, 0.38753134E-03_JPRB, 0.38766763E-03_JPRB, 0.38814902E-03_JPRB, 0.38854903E-03_JPRB, 0.38846533E-03_JPRB, &
  & 0.38804970E-03_JPRB, 0.38829565E-03_JPRB, 0.38889369E-03_JPRB, 0.38934828E-03_JPRB, 0.38987940E-03_JPRB, 0.39034361E-03_JPRB, &
  & 0.39091106E-03_JPRB, 0.39169005E-03_JPRB, 0.39242462E-03_JPRB, 0.39297186E-03_JPRB, 0.39402822E-03_JPRB, 0.39477870E-03_JPRB, &
  & 0.39550417E-03_JPRB, 0.39623692E-03_JPRB, 0.39689003E-03_JPRB, 0.39736208E-03_JPRB, 0.39780048E-03_JPRB, 0.39828457E-03_JPRB, &
  & 0.39847910E-03_JPRB, 0.39873027E-03_JPRB, 0.39871751E-03_JPRB, 0.39862309E-03_JPRB, 0.39838320E-03_JPRB, 0.39823848E-03_JPRB, &
  & 0.39831856E-03_JPRB, 0.39838997E-03_JPRB, 0.39871649E-03_JPRB, 0.39893701E-03_JPRB  /)

RGHG1(:,89, 3) = (/ &
  & 0.38250511E-03_JPRB, 0.38251703E-03_JPRB, 0.38252779E-03_JPRB, 0.38252194E-03_JPRB, 0.38249912E-03_JPRB, 0.38246362E-03_JPRB, &
  & 0.38241991E-03_JPRB, 0.38236833E-03_JPRB, 0.38229124E-03_JPRB, 0.38223160E-03_JPRB, 0.38219755E-03_JPRB, 0.38219295E-03_JPRB, &
  & 0.38213099E-03_JPRB, 0.38204755E-03_JPRB, 0.38197802E-03_JPRB, 0.38199429E-03_JPRB, 0.38197867E-03_JPRB, 0.38203832E-03_JPRB, &
  & 0.38228186E-03_JPRB, 0.38225420E-03_JPRB, 0.38227608E-03_JPRB, 0.38230697E-03_JPRB, 0.38232046E-03_JPRB, 0.38238481E-03_JPRB, &
  & 0.38243358E-03_JPRB, 0.38245643E-03_JPRB, 0.38273983E-03_JPRB, 0.38310828E-03_JPRB, 0.38400128E-03_JPRB, 0.38546316E-03_JPRB, &
  & 0.38696676E-03_JPRB, 0.38817093E-03_JPRB, 0.38825088E-03_JPRB, 0.38864197E-03_JPRB, 0.38889693E-03_JPRB, 0.38870311E-03_JPRB, &
  & 0.38824646E-03_JPRB, 0.38855371E-03_JPRB, 0.38918428E-03_JPRB, 0.38964843E-03_JPRB, 0.39021586E-03_JPRB, 0.39068966E-03_JPRB, &
  & 0.39120476E-03_JPRB, 0.39201542E-03_JPRB, 0.39274673E-03_JPRB, 0.39323965E-03_JPRB, 0.39429285E-03_JPRB, 0.39501584E-03_JPRB, &
  & 0.39573235E-03_JPRB, 0.39645567E-03_JPRB, 0.39712932E-03_JPRB, 0.39755418E-03_JPRB, 0.39794780E-03_JPRB, 0.39845711E-03_JPRB, &
  & 0.39864092E-03_JPRB, 0.39890314E-03_JPRB, 0.39891364E-03_JPRB, 0.39873892E-03_JPRB, 0.39840880E-03_JPRB, 0.39823982E-03_JPRB, &
  & 0.39831709E-03_JPRB, 0.39837992E-03_JPRB, 0.39870973E-03_JPRB, 0.39894369E-03_JPRB  /)

RGHG1(:,90, 3) = (/ &
  & 0.38250015E-03_JPRB, 0.38251182E-03_JPRB, 0.38252529E-03_JPRB, 0.38251918E-03_JPRB, 0.38249528E-03_JPRB, 0.38246253E-03_JPRB, &
  & 0.38241964E-03_JPRB, 0.38236720E-03_JPRB, 0.38228619E-03_JPRB, 0.38222738E-03_JPRB, 0.38219304E-03_JPRB, 0.38218845E-03_JPRB, &
  & 0.38212592E-03_JPRB, 0.38204163E-03_JPRB, 0.38196983E-03_JPRB, 0.38199903E-03_JPRB, 0.38199800E-03_JPRB, 0.38210149E-03_JPRB, &
  & 0.38245298E-03_JPRB, 0.38241745E-03_JPRB, 0.38244730E-03_JPRB, 0.38250057E-03_JPRB, 0.38254440E-03_JPRB, 0.38263413E-03_JPRB, &
  & 0.38282254E-03_JPRB, 0.38298606E-03_JPRB, 0.38336801E-03_JPRB, 0.38386672E-03_JPRB, 0.38497367E-03_JPRB, 0.38670288E-03_JPRB, &
  & 0.38792530E-03_JPRB, 0.38914086E-03_JPRB, 0.38905451E-03_JPRB, 0.38934632E-03_JPRB, 0.38938047E-03_JPRB, 0.38912005E-03_JPRB, &
  & 0.38857157E-03_JPRB, 0.38888530E-03_JPRB, 0.38960455E-03_JPRB, 0.39016776E-03_JPRB, 0.39077332E-03_JPRB, 0.39132878E-03_JPRB, &
  & 0.39175278E-03_JPRB, 0.39259846E-03_JPRB, 0.39328063E-03_JPRB, 0.39366248E-03_JPRB, 0.39470438E-03_JPRB, 0.39540656E-03_JPRB, &
  & 0.39608419E-03_JPRB, 0.39676427E-03_JPRB, 0.39746693E-03_JPRB, 0.39781730E-03_JPRB, 0.39814137E-03_JPRB, 0.39869066E-03_JPRB, &
  & 0.39886015E-03_JPRB, 0.39911244E-03_JPRB, 0.39914223E-03_JPRB, 0.39885935E-03_JPRB, 0.39843214E-03_JPRB, 0.39824125E-03_JPRB, &
  & 0.39831649E-03_JPRB, 0.39837214E-03_JPRB, 0.39870785E-03_JPRB, 0.39894317E-03_JPRB  /)

RGHG1(:,91, 3) = (/ &
  & 0.38249777E-03_JPRB, 0.38251033E-03_JPRB, 0.38252351E-03_JPRB, 0.38251799E-03_JPRB, 0.38249410E-03_JPRB, 0.38246223E-03_JPRB, &
  & 0.38241964E-03_JPRB, 0.38236571E-03_JPRB, 0.38228114E-03_JPRB, 0.38222293E-03_JPRB, 0.38218769E-03_JPRB, 0.38218340E-03_JPRB, &
  & 0.38212028E-03_JPRB, 0.38203510E-03_JPRB, 0.38196003E-03_JPRB, 0.38201151E-03_JPRB, 0.38201641E-03_JPRB, 0.38224315E-03_JPRB, &
  & 0.38269234E-03_JPRB, 0.38265710E-03_JPRB, 0.38268131E-03_JPRB, 0.38284891E-03_JPRB, 0.38294145E-03_JPRB, 0.38307810E-03_JPRB, &
  & 0.38350646E-03_JPRB, 0.38406228E-03_JPRB, 0.38469071E-03_JPRB, 0.38556182E-03_JPRB, 0.38719649E-03_JPRB, 0.38927790E-03_JPRB, &
  & 0.38984016E-03_JPRB, 0.39066194E-03_JPRB, 0.39031723E-03_JPRB, 0.39039077E-03_JPRB, 0.39016862E-03_JPRB, 0.38981258E-03_JPRB, &
  & 0.38918660E-03_JPRB, 0.38934501E-03_JPRB, 0.39029946E-03_JPRB, 0.39105659E-03_JPRB, 0.39166541E-03_JPRB, 0.39243143E-03_JPRB, &
  & 0.39284385E-03_JPRB, 0.39375724E-03_JPRB, 0.39426924E-03_JPRB, 0.39448924E-03_JPRB, 0.39538088E-03_JPRB, 0.39606049E-03_JPRB, &
  & 0.39668555E-03_JPRB, 0.39723586E-03_JPRB, 0.39797950E-03_JPRB, 0.39819950E-03_JPRB, 0.39847190E-03_JPRB, 0.39905682E-03_JPRB, &
  & 0.39923760E-03_JPRB, 0.39949345E-03_JPRB, 0.39950601E-03_JPRB, 0.39907643E-03_JPRB, 0.39848262E-03_JPRB, 0.39824362E-03_JPRB, &
  & 0.39831471E-03_JPRB, 0.39836649E-03_JPRB, 0.39870844E-03_JPRB, 0.39894376E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ---GEMS----

RGHG1(:, 1, 4) = (/ &
  & 0.37127953E-03_JPRB, 0.37128045E-03_JPRB, 0.37126036E-03_JPRB, 0.37124635E-03_JPRB, 0.37122926E-03_JPRB, 0.37121098E-03_JPRB, &
  & 0.37120335E-03_JPRB, 0.37120877E-03_JPRB, 0.37123334E-03_JPRB, 0.37127009E-03_JPRB, 0.37131739E-03_JPRB, 0.37137488E-03_JPRB, &
  & 0.37143752E-03_JPRB, 0.37150474E-03_JPRB, 0.37157983E-03_JPRB, 0.37165187E-03_JPRB, 0.37171183E-03_JPRB, 0.37176595E-03_JPRB, &
  & 0.37181946E-03_JPRB, 0.37186716E-03_JPRB, 0.37190613E-03_JPRB, 0.37194135E-03_JPRB, 0.37197542E-03_JPRB, 0.37200717E-03_JPRB, &
  & 0.37203521E-03_JPRB, 0.37205840E-03_JPRB, 0.37207605E-03_JPRB, 0.37208689E-03_JPRB, 0.37208915E-03_JPRB, 0.37207994E-03_JPRB, &
  & 0.37206073E-03_JPRB, 0.37203986E-03_JPRB, 0.37202404E-03_JPRB, 0.37201537E-03_JPRB, 0.37201175E-03_JPRB, 0.37201027E-03_JPRB, &
  & 0.37201033E-03_JPRB, 0.37201142E-03_JPRB, 0.37201096E-03_JPRB, 0.37200698E-03_JPRB, 0.37199815E-03_JPRB, 0.37198482E-03_JPRB, &
  & 0.37196804E-03_JPRB, 0.37194830E-03_JPRB, 0.37192635E-03_JPRB, 0.37190364E-03_JPRB, 0.37188053E-03_JPRB, 0.37185875E-03_JPRB, &
  & 0.37183890E-03_JPRB, 0.37181578E-03_JPRB, 0.37179251E-03_JPRB, 0.37176754E-03_JPRB, 0.37174508E-03_JPRB, 0.37172727E-03_JPRB, &
  & 0.37171323E-03_JPRB, 0.37169770E-03_JPRB, 0.37168025E-03_JPRB, 0.37166365E-03_JPRB, 0.37165026E-03_JPRB, 0.37163799E-03_JPRB, &
  & 0.37162857E-03_JPRB, 0.37162001E-03_JPRB, 0.37161091E-03_JPRB, 0.37160664E-03_JPRB  /)

RGHG1(:, 2, 4) = (/ &
  & 0.37127953E-03_JPRB, 0.37128045E-03_JPRB, 0.37126036E-03_JPRB, 0.37124635E-03_JPRB, 0.37122926E-03_JPRB, 0.37121098E-03_JPRB, &
  & 0.37120335E-03_JPRB, 0.37120877E-03_JPRB, 0.37123334E-03_JPRB, 0.37127009E-03_JPRB, 0.37131739E-03_JPRB, 0.37137488E-03_JPRB, &
  & 0.37143752E-03_JPRB, 0.37150474E-03_JPRB, 0.37157983E-03_JPRB, 0.37165187E-03_JPRB, 0.37171183E-03_JPRB, 0.37176595E-03_JPRB, &
  & 0.37181946E-03_JPRB, 0.37186716E-03_JPRB, 0.37190613E-03_JPRB, 0.37194135E-03_JPRB, 0.37197542E-03_JPRB, 0.37200717E-03_JPRB, &
  & 0.37203521E-03_JPRB, 0.37205840E-03_JPRB, 0.37207605E-03_JPRB, 0.37208689E-03_JPRB, 0.37208915E-03_JPRB, 0.37207994E-03_JPRB, &
  & 0.37206073E-03_JPRB, 0.37203986E-03_JPRB, 0.37202404E-03_JPRB, 0.37201537E-03_JPRB, 0.37201175E-03_JPRB, 0.37201027E-03_JPRB, &
  & 0.37201033E-03_JPRB, 0.37201142E-03_JPRB, 0.37201096E-03_JPRB, 0.37200698E-03_JPRB, 0.37199815E-03_JPRB, 0.37198482E-03_JPRB, &
  & 0.37196804E-03_JPRB, 0.37194830E-03_JPRB, 0.37192635E-03_JPRB, 0.37190364E-03_JPRB, 0.37188053E-03_JPRB, 0.37185875E-03_JPRB, &
  & 0.37183890E-03_JPRB, 0.37181578E-03_JPRB, 0.37179251E-03_JPRB, 0.37176754E-03_JPRB, 0.37174508E-03_JPRB, 0.37172727E-03_JPRB, &
  & 0.37171323E-03_JPRB, 0.37169770E-03_JPRB, 0.37168025E-03_JPRB, 0.37166365E-03_JPRB, 0.37165026E-03_JPRB, 0.37163799E-03_JPRB, &
  & 0.37162857E-03_JPRB, 0.37162001E-03_JPRB, 0.37161091E-03_JPRB, 0.37160664E-03_JPRB  /)

RGHG1(:, 3, 4) = (/ &
  & 0.37127953E-03_JPRB, 0.37128045E-03_JPRB, 0.37126036E-03_JPRB, 0.37124635E-03_JPRB, 0.37122926E-03_JPRB, 0.37121098E-03_JPRB, &
  & 0.37120335E-03_JPRB, 0.37120877E-03_JPRB, 0.37123334E-03_JPRB, 0.37127009E-03_JPRB, 0.37131739E-03_JPRB, 0.37137488E-03_JPRB, &
  & 0.37143752E-03_JPRB, 0.37150474E-03_JPRB, 0.37157983E-03_JPRB, 0.37165187E-03_JPRB, 0.37171183E-03_JPRB, 0.37176595E-03_JPRB, &
  & 0.37181946E-03_JPRB, 0.37186716E-03_JPRB, 0.37190613E-03_JPRB, 0.37194135E-03_JPRB, 0.37197542E-03_JPRB, 0.37200717E-03_JPRB, &
  & 0.37203521E-03_JPRB, 0.37205840E-03_JPRB, 0.37207605E-03_JPRB, 0.37208689E-03_JPRB, 0.37208915E-03_JPRB, 0.37207994E-03_JPRB, &
  & 0.37206073E-03_JPRB, 0.37203986E-03_JPRB, 0.37202404E-03_JPRB, 0.37201537E-03_JPRB, 0.37201175E-03_JPRB, 0.37201027E-03_JPRB, &
  & 0.37201033E-03_JPRB, 0.37201142E-03_JPRB, 0.37201096E-03_JPRB, 0.37200698E-03_JPRB, 0.37199815E-03_JPRB, 0.37198482E-03_JPRB, &
  & 0.37196804E-03_JPRB, 0.37194830E-03_JPRB, 0.37192635E-03_JPRB, 0.37190364E-03_JPRB, 0.37188053E-03_JPRB, 0.37185875E-03_JPRB, &
  & 0.37183890E-03_JPRB, 0.37181578E-03_JPRB, 0.37179251E-03_JPRB, 0.37176754E-03_JPRB, 0.37174508E-03_JPRB, 0.37172727E-03_JPRB, &
  & 0.37171323E-03_JPRB, 0.37169770E-03_JPRB, 0.37168025E-03_JPRB, 0.37166365E-03_JPRB, 0.37165026E-03_JPRB, 0.37163799E-03_JPRB, &
  & 0.37162857E-03_JPRB, 0.37162001E-03_JPRB, 0.37161091E-03_JPRB, 0.37160664E-03_JPRB  /)

RGHG1(:, 4, 4) = (/ &
  & 0.37127993E-03_JPRB, 0.37128075E-03_JPRB, 0.37126061E-03_JPRB, 0.37124645E-03_JPRB, 0.37122926E-03_JPRB, 0.37121088E-03_JPRB, &
  & 0.37120317E-03_JPRB, 0.37120849E-03_JPRB, 0.37123295E-03_JPRB, 0.37126962E-03_JPRB, 0.37131687E-03_JPRB, 0.37137432E-03_JPRB, &
  & 0.37143694E-03_JPRB, 0.37150415E-03_JPRB, 0.37157923E-03_JPRB, 0.37165133E-03_JPRB, 0.37171143E-03_JPRB, 0.37176567E-03_JPRB, &
  & 0.37181927E-03_JPRB, 0.37186709E-03_JPRB, 0.37190617E-03_JPRB, 0.37194147E-03_JPRB, 0.37197563E-03_JPRB, 0.37200748E-03_JPRB, &
  & 0.37203562E-03_JPRB, 0.37205891E-03_JPRB, 0.37207667E-03_JPRB, 0.37208759E-03_JPRB, 0.37208987E-03_JPRB, 0.37208063E-03_JPRB, &
  & 0.37206140E-03_JPRB, 0.37204052E-03_JPRB, 0.37202475E-03_JPRB, 0.37201620E-03_JPRB, 0.37201269E-03_JPRB, 0.37201127E-03_JPRB, &
  & 0.37201136E-03_JPRB, 0.37201246E-03_JPRB, 0.37201200E-03_JPRB, 0.37200800E-03_JPRB, 0.37199916E-03_JPRB, 0.37198581E-03_JPRB, &
  & 0.37196901E-03_JPRB, 0.37194923E-03_JPRB, 0.37192723E-03_JPRB, 0.37190441E-03_JPRB, 0.37188115E-03_JPRB, 0.37185919E-03_JPRB, &
  & 0.37183915E-03_JPRB, 0.37181588E-03_JPRB, 0.37179248E-03_JPRB, 0.37176744E-03_JPRB, 0.37174493E-03_JPRB, 0.37172709E-03_JPRB, &
  & 0.37171302E-03_JPRB, 0.37169747E-03_JPRB, 0.37168003E-03_JPRB, 0.37166344E-03_JPRB, 0.37165007E-03_JPRB, 0.37163784E-03_JPRB, &
  & 0.37162844E-03_JPRB, 0.37161990E-03_JPRB, 0.37161085E-03_JPRB, 0.37160660E-03_JPRB  /)

RGHG1(:, 5, 4) = (/ &
  & 0.37129880E-03_JPRB, 0.37129481E-03_JPRB, 0.37127217E-03_JPRB, 0.37125161E-03_JPRB, 0.37122919E-03_JPRB, 0.37120645E-03_JPRB, &
  & 0.37119462E-03_JPRB, 0.37119526E-03_JPRB, 0.37121436E-03_JPRB, 0.37124707E-03_JPRB, 0.37129186E-03_JPRB, 0.37134772E-03_JPRB, &
  & 0.37140938E-03_JPRB, 0.37147620E-03_JPRB, 0.37155071E-03_JPRB, 0.37162572E-03_JPRB, 0.37169253E-03_JPRB, 0.37175250E-03_JPRB, &
  & 0.37181049E-03_JPRB, 0.37186387E-03_JPRB, 0.37190819E-03_JPRB, 0.37194744E-03_JPRB, 0.37198586E-03_JPRB, 0.37202237E-03_JPRB, &
  & 0.37205513E-03_JPRB, 0.37208349E-03_JPRB, 0.37210605E-03_JPRB, 0.37212052E-03_JPRB, 0.37212403E-03_JPRB, 0.37211354E-03_JPRB, &
  & 0.37209308E-03_JPRB, 0.37207176E-03_JPRB, 0.37205837E-03_JPRB, 0.37205582E-03_JPRB, 0.37205736E-03_JPRB, 0.37205874E-03_JPRB, &
  & 0.37206014E-03_JPRB, 0.37206196E-03_JPRB, 0.37206124E-03_JPRB, 0.37205647E-03_JPRB, 0.37204701E-03_JPRB, 0.37203259E-03_JPRB, &
  & 0.37201458E-03_JPRB, 0.37199350E-03_JPRB, 0.37196888E-03_JPRB, 0.37194093E-03_JPRB, 0.37191051E-03_JPRB, 0.37187975E-03_JPRB, &
  & 0.37185119E-03_JPRB, 0.37182048E-03_JPRB, 0.37179108E-03_JPRB, 0.37176249E-03_JPRB, 0.37173771E-03_JPRB, 0.37171857E-03_JPRB, &
  & 0.37170279E-03_JPRB, 0.37168649E-03_JPRB, 0.37166923E-03_JPRB, 0.37165332E-03_JPRB, 0.37164094E-03_JPRB, 0.37163069E-03_JPRB, &
  & 0.37162235E-03_JPRB, 0.37161480E-03_JPRB, 0.37160818E-03_JPRB, 0.37160454E-03_JPRB  /)

RGHG1(:, 6, 4) = (/ &
  & 0.37132711E-03_JPRB, 0.37131592E-03_JPRB, 0.37128952E-03_JPRB, 0.37125935E-03_JPRB, 0.37122909E-03_JPRB, 0.37119980E-03_JPRB, &
  & 0.37118180E-03_JPRB, 0.37117541E-03_JPRB, 0.37118648E-03_JPRB, 0.37121323E-03_JPRB, 0.37125435E-03_JPRB, 0.37130782E-03_JPRB, &
  & 0.37136802E-03_JPRB, 0.37143427E-03_JPRB, 0.37150793E-03_JPRB, 0.37158729E-03_JPRB, 0.37166417E-03_JPRB, 0.37173274E-03_JPRB, &
  & 0.37179732E-03_JPRB, 0.37185904E-03_JPRB, 0.37191123E-03_JPRB, 0.37195638E-03_JPRB, 0.37200120E-03_JPRB, 0.37204471E-03_JPRB, &
  & 0.37208442E-03_JPRB, 0.37212037E-03_JPRB, 0.37215012E-03_JPRB, 0.37216994E-03_JPRB, 0.37217527E-03_JPRB, 0.37216291E-03_JPRB, &
  & 0.37214061E-03_JPRB, 0.37211863E-03_JPRB, 0.37210880E-03_JPRB, 0.37211527E-03_JPRB, 0.37212438E-03_JPRB, 0.37212997E-03_JPRB, &
  & 0.37213334E-03_JPRB, 0.37213621E-03_JPRB, 0.37213512E-03_JPRB, 0.37212920E-03_JPRB, 0.37211882E-03_JPRB, 0.37210279E-03_JPRB, &
  & 0.37208297E-03_JPRB, 0.37205993E-03_JPRB, 0.37203137E-03_JPRB, 0.37199572E-03_JPRB, 0.37195457E-03_JPRB, 0.37191061E-03_JPRB, &
  & 0.37186925E-03_JPRB, 0.37182738E-03_JPRB, 0.37178897E-03_JPRB, 0.37175506E-03_JPRB, 0.37172689E-03_JPRB, 0.37170580E-03_JPRB, &
  & 0.37168744E-03_JPRB, 0.37167001E-03_JPRB, 0.37165304E-03_JPRB, 0.37163815E-03_JPRB, 0.37162725E-03_JPRB, 0.37161996E-03_JPRB, &
  & 0.37161322E-03_JPRB, 0.37160716E-03_JPRB, 0.37160418E-03_JPRB, 0.37160146E-03_JPRB  /)

RGHG1(:, 7, 4) = (/ &
  & 0.37136183E-03_JPRB, 0.37134448E-03_JPRB, 0.37131597E-03_JPRB, 0.37127872E-03_JPRB, 0.37123810E-03_JPRB, 0.37119870E-03_JPRB, &
  & 0.37117108E-03_JPRB, 0.37115659E-03_JPRB, 0.37115763E-03_JPRB, 0.37117409E-03_JPRB, 0.37120561E-03_JPRB, 0.37125292E-03_JPRB, &
  & 0.37130941E-03_JPRB, 0.37137460E-03_JPRB, 0.37145101E-03_JPRB, 0.37154116E-03_JPRB, 0.37163386E-03_JPRB, 0.37172117E-03_JPRB, &
  & 0.37180532E-03_JPRB, 0.37188510E-03_JPRB, 0.37195312E-03_JPRB, 0.37201028E-03_JPRB, 0.37206336E-03_JPRB, 0.37211687E-03_JPRB, &
  & 0.37217226E-03_JPRB, 0.37222412E-03_JPRB, 0.37226803E-03_JPRB, 0.37229799E-03_JPRB, 0.37230712E-03_JPRB, 0.37229219E-03_JPRB, &
  & 0.37226374E-03_JPRB, 0.37223794E-03_JPRB, 0.37223445E-03_JPRB, 0.37225945E-03_JPRB, 0.37228566E-03_JPRB, 0.37230070E-03_JPRB, &
  & 0.37230949E-03_JPRB, 0.37231605E-03_JPRB, 0.37231773E-03_JPRB, 0.37231451E-03_JPRB, 0.37230614E-03_JPRB, 0.37228812E-03_JPRB, &
  & 0.37226331E-03_JPRB, 0.37223316E-03_JPRB, 0.37219313E-03_JPRB, 0.37214016E-03_JPRB, 0.37207233E-03_JPRB, 0.37199284E-03_JPRB, &
  & 0.37191476E-03_JPRB, 0.37184201E-03_JPRB, 0.37178398E-03_JPRB, 0.37174025E-03_JPRB, 0.37170647E-03_JPRB, 0.37168103E-03_JPRB, &
  & 0.37165888E-03_JPRB, 0.37163801E-03_JPRB, 0.37161871E-03_JPRB, 0.37160231E-03_JPRB, 0.37159070E-03_JPRB, 0.37158212E-03_JPRB, &
  & 0.37157417E-03_JPRB, 0.37156676E-03_JPRB, 0.37156228E-03_JPRB, 0.37155898E-03_JPRB  /)

RGHG1(:, 8, 4) = (/ &
  & 0.37141593E-03_JPRB, 0.37139678E-03_JPRB, 0.37136646E-03_JPRB, 0.37132461E-03_JPRB, 0.37127297E-03_JPRB, 0.37121969E-03_JPRB, &
  & 0.37117865E-03_JPRB, 0.37115224E-03_JPRB, 0.37113965E-03_JPRB, 0.37114244E-03_JPRB, 0.37116300E-03_JPRB, 0.37120346E-03_JPRB, &
  & 0.37125883E-03_JPRB, 0.37133018E-03_JPRB, 0.37141930E-03_JPRB, 0.37153035E-03_JPRB, 0.37164605E-03_JPRB, 0.37176006E-03_JPRB, &
  & 0.37187724E-03_JPRB, 0.37199251E-03_JPRB, 0.37209739E-03_JPRB, 0.37218429E-03_JPRB, 0.37225536E-03_JPRB, 0.37231993E-03_JPRB, &
  & 0.37239151E-03_JPRB, 0.37246164E-03_JPRB, 0.37251749E-03_JPRB, 0.37255006E-03_JPRB, 0.37255402E-03_JPRB, 0.37252966E-03_JPRB, &
  & 0.37248993E-03_JPRB, 0.37245901E-03_JPRB, 0.37246390E-03_JPRB, 0.37251385E-03_JPRB, 0.37256861E-03_JPRB, 0.37259931E-03_JPRB, &
  & 0.37261940E-03_JPRB, 0.37263813E-03_JPRB, 0.37264802E-03_JPRB, 0.37265002E-03_JPRB, 0.37264427E-03_JPRB, 0.37262547E-03_JPRB, &
  & 0.37259519E-03_JPRB, 0.37255091E-03_JPRB, 0.37248720E-03_JPRB, 0.37240341E-03_JPRB, 0.37228954E-03_JPRB, 0.37214653E-03_JPRB, &
  & 0.37200382E-03_JPRB, 0.37187427E-03_JPRB, 0.37177645E-03_JPRB, 0.37171285E-03_JPRB, 0.37166924E-03_JPRB, 0.37163802E-03_JPRB, &
  & 0.37161244E-03_JPRB, 0.37158887E-03_JPRB, 0.37156708E-03_JPRB, 0.37154786E-03_JPRB, 0.37153478E-03_JPRB, 0.37152397E-03_JPRB, &
  & 0.37151468E-03_JPRB, 0.37150588E-03_JPRB, 0.37149929E-03_JPRB, 0.37149544E-03_JPRB  /)

RGHG1(:, 9, 4) = (/ &
  & 0.37150924E-03_JPRB, 0.37149458E-03_JPRB, 0.37146455E-03_JPRB, 0.37141895E-03_JPRB, 0.37135682E-03_JPRB, 0.37128628E-03_JPRB, &
  & 0.37122440E-03_JPRB, 0.37117824E-03_JPRB, 0.37114592E-03_JPRB, 0.37113283E-03_JPRB, 0.37114409E-03_JPRB, 0.37118185E-03_JPRB, &
  & 0.37124533E-03_JPRB, 0.37133660E-03_JPRB, 0.37145306E-03_JPRB, 0.37159716E-03_JPRB, 0.37174320E-03_JPRB, 0.37189329E-03_JPRB, &
  & 0.37206219E-03_JPRB, 0.37223654E-03_JPRB, 0.37240770E-03_JPRB, 0.37255582E-03_JPRB, 0.37267257E-03_JPRB, 0.37276197E-03_JPRB, &
  & 0.37284838E-03_JPRB, 0.37292720E-03_JPRB, 0.37297619E-03_JPRB, 0.37298819E-03_JPRB, 0.37296605E-03_JPRB, 0.37291849E-03_JPRB, &
  & 0.37286066E-03_JPRB, 0.37282368E-03_JPRB, 0.37283774E-03_JPRB, 0.37291364E-03_JPRB, 0.37300066E-03_JPRB, 0.37304958E-03_JPRB, &
  & 0.37308587E-03_JPRB, 0.37312308E-03_JPRB, 0.37314590E-03_JPRB, 0.37315607E-03_JPRB, 0.37315378E-03_JPRB, 0.37313514E-03_JPRB, &
  & 0.37309707E-03_JPRB, 0.37302785E-03_JPRB, 0.37292094E-03_JPRB, 0.37278502E-03_JPRB, 0.37260605E-03_JPRB, 0.37237527E-03_JPRB, &
  & 0.37213987E-03_JPRB, 0.37192298E-03_JPRB, 0.37175866E-03_JPRB, 0.37166214E-03_JPRB, 0.37160507E-03_JPRB, 0.37156934E-03_JPRB, &
  & 0.37154291E-03_JPRB, 0.37151867E-03_JPRB, 0.37149540E-03_JPRB, 0.37147297E-03_JPRB, 0.37145729E-03_JPRB, 0.37144424E-03_JPRB, &
  & 0.37143410E-03_JPRB, 0.37142521E-03_JPRB, 0.37141810E-03_JPRB, 0.37141371E-03_JPRB  /)

RGHG1(:,10, 4) = (/ &
  & 0.37166631E-03_JPRB, 0.37165809E-03_JPRB, 0.37162902E-03_JPRB, 0.37157661E-03_JPRB, 0.37150324E-03_JPRB, 0.37141167E-03_JPRB, &
  & 0.37131769E-03_JPRB, 0.37123970E-03_JPRB, 0.37117925E-03_JPRB, 0.37114951E-03_JPRB, 0.37115497E-03_JPRB, 0.37120060E-03_JPRB, &
  & 0.37128741E-03_JPRB, 0.37141594E-03_JPRB, 0.37157394E-03_JPRB, 0.37175755E-03_JPRB, 0.37193745E-03_JPRB, 0.37213433E-03_JPRB, &
  & 0.37236996E-03_JPRB, 0.37261949E-03_JPRB, 0.37287596E-03_JPRB, 0.37312018E-03_JPRB, 0.37333064E-03_JPRB, 0.37348504E-03_JPRB, &
  & 0.37358995E-03_JPRB, 0.37365237E-03_JPRB, 0.37366141E-03_JPRB, 0.37362363E-03_JPRB, 0.37355452E-03_JPRB, 0.37347190E-03_JPRB, &
  & 0.37339354E-03_JPRB, 0.37335018E-03_JPRB, 0.37336829E-03_JPRB, 0.37345430E-03_JPRB, 0.37354883E-03_JPRB, 0.37360307E-03_JPRB, &
  & 0.37364887E-03_JPRB, 0.37369392E-03_JPRB, 0.37372075E-03_JPRB, 0.37373551E-03_JPRB, 0.37373499E-03_JPRB, 0.37371420E-03_JPRB, &
  & 0.37366271E-03_JPRB, 0.37355968E-03_JPRB, 0.37339436E-03_JPRB, 0.37318673E-03_JPRB, 0.37293536E-03_JPRB, 0.37262008E-03_JPRB, &
  & 0.37228599E-03_JPRB, 0.37196261E-03_JPRB, 0.37171383E-03_JPRB, 0.37157561E-03_JPRB, 0.37150522E-03_JPRB, 0.37147007E-03_JPRB, &
  & 0.37144854E-03_JPRB, 0.37142650E-03_JPRB, 0.37140358E-03_JPRB, 0.37137854E-03_JPRB, 0.37135848E-03_JPRB, 0.37134277E-03_JPRB, &
  & 0.37133193E-03_JPRB, 0.37132424E-03_JPRB, 0.37131923E-03_JPRB, 0.37131676E-03_JPRB  /)

RGHG1(:,11, 4) = (/ &
  & 0.37188439E-03_JPRB, 0.37187627E-03_JPRB, 0.37183973E-03_JPRB, 0.37177754E-03_JPRB, 0.37169116E-03_JPRB, 0.37157395E-03_JPRB, &
  & 0.37144015E-03_JPRB, 0.37132048E-03_JPRB, 0.37122602E-03_JPRB, 0.37117825E-03_JPRB, 0.37118190E-03_JPRB, 0.37124763E-03_JPRB, &
  & 0.37137130E-03_JPRB, 0.37154791E-03_JPRB, 0.37174859E-03_JPRB, 0.37196342E-03_JPRB, 0.37217595E-03_JPRB, 0.37241974E-03_JPRB, &
  & 0.37270902E-03_JPRB, 0.37302266E-03_JPRB, 0.37335121E-03_JPRB, 0.37370792E-03_JPRB, 0.37405117E-03_JPRB, 0.37430144E-03_JPRB, &
  & 0.37443614E-03_JPRB, 0.37447609E-03_JPRB, 0.37444229E-03_JPRB, 0.37436089E-03_JPRB, 0.37425765E-03_JPRB, 0.37415339E-03_JPRB, &
  & 0.37406708E-03_JPRB, 0.37401899E-03_JPRB, 0.37402338E-03_JPRB, 0.37407614E-03_JPRB, 0.37412530E-03_JPRB, 0.37415087E-03_JPRB, &
  & 0.37417479E-03_JPRB, 0.37419493E-03_JPRB, 0.37419774E-03_JPRB, 0.37419659E-03_JPRB, 0.37418401E-03_JPRB, 0.37415463E-03_JPRB, &
  & 0.37408855E-03_JPRB, 0.37395854E-03_JPRB, 0.37374643E-03_JPRB, 0.37347406E-03_JPRB, 0.37315481E-03_JPRB, 0.37278080E-03_JPRB, &
  & 0.37237500E-03_JPRB, 0.37195775E-03_JPRB, 0.37163560E-03_JPRB, 0.37145831E-03_JPRB, 0.37137819E-03_JPRB, 0.37134852E-03_JPRB, &
  & 0.37133843E-03_JPRB, 0.37132349E-03_JPRB, 0.37130336E-03_JPRB, 0.37127586E-03_JPRB, 0.37125010E-03_JPRB, 0.37122967E-03_JPRB, &
  & 0.37121617E-03_JPRB, 0.37120852E-03_JPRB, 0.37120663E-03_JPRB, 0.37121003E-03_JPRB  /)

RGHG1(:,12, 4) = (/ &
  & 0.37212101E-03_JPRB, 0.37210668E-03_JPRB, 0.37205943E-03_JPRB, 0.37198656E-03_JPRB, 0.37188900E-03_JPRB, 0.37174396E-03_JPRB, &
  & 0.37156838E-03_JPRB, 0.37140429E-03_JPRB, 0.37127443E-03_JPRB, 0.37120877E-03_JPRB, 0.37121684E-03_JPRB, 0.37131095E-03_JPRB, &
  & 0.37147677E-03_JPRB, 0.37169109E-03_JPRB, 0.37191479E-03_JPRB, 0.37214571E-03_JPRB, 0.37238224E-03_JPRB, 0.37264653E-03_JPRB, &
  & 0.37294858E-03_JPRB, 0.37328204E-03_JPRB, 0.37364831E-03_JPRB, 0.37412379E-03_JPRB, 0.37459926E-03_JPRB, 0.37492779E-03_JPRB, &
  & 0.37511383E-03_JPRB, 0.37517918E-03_JPRB, 0.37516106E-03_JPRB, 0.37509227E-03_JPRB, 0.37500238E-03_JPRB, 0.37491130E-03_JPRB, &
  & 0.37482860E-03_JPRB, 0.37476235E-03_JPRB, 0.37471879E-03_JPRB, 0.37469273E-03_JPRB, 0.37466158E-03_JPRB, 0.37462667E-03_JPRB, &
  & 0.37459114E-03_JPRB, 0.37455055E-03_JPRB, 0.37450702E-03_JPRB, 0.37447110E-03_JPRB, 0.37442907E-03_JPRB, 0.37438065E-03_JPRB, &
  & 0.37430087E-03_JPRB, 0.37415651E-03_JPRB, 0.37392271E-03_JPRB, 0.37361299E-03_JPRB, 0.37323857E-03_JPRB, 0.37282434E-03_JPRB, &
  & 0.37237664E-03_JPRB, 0.37191050E-03_JPRB, 0.37155963E-03_JPRB, 0.37136125E-03_JPRB, 0.37127968E-03_JPRB, 0.37125594E-03_JPRB, &
  & 0.37125468E-03_JPRB, 0.37124829E-03_JPRB, 0.37123261E-03_JPRB, 0.37120597E-03_JPRB, 0.37117396E-03_JPRB, 0.37114581E-03_JPRB, &
  & 0.37112537E-03_JPRB, 0.37111387E-03_JPRB, 0.37111207E-03_JPRB, 0.37111607E-03_JPRB  /)

RGHG1(:,13, 4) = (/ &
  & 0.37241534E-03_JPRB, 0.37237914E-03_JPRB, 0.37231836E-03_JPRB, 0.37223643E-03_JPRB, 0.37211972E-03_JPRB, 0.37194214E-03_JPRB, &
  & 0.37172904E-03_JPRB, 0.37152163E-03_JPRB, 0.37135551E-03_JPRB, 0.37127299E-03_JPRB, 0.37128814E-03_JPRB, 0.37140916E-03_JPRB, &
  & 0.37160717E-03_JPRB, 0.37184148E-03_JPRB, 0.37207203E-03_JPRB, 0.37230231E-03_JPRB, 0.37253991E-03_JPRB, 0.37279264E-03_JPRB, &
  & 0.37306013E-03_JPRB, 0.37336752E-03_JPRB, 0.37375347E-03_JPRB, 0.37432569E-03_JPRB, 0.37489125E-03_JPRB, 0.37528218E-03_JPRB, &
  & 0.37554066E-03_JPRB, 0.37568715E-03_JPRB, 0.37574775E-03_JPRB, 0.37574752E-03_JPRB, 0.37571745E-03_JPRB, 0.37566353E-03_JPRB, &
  & 0.37557337E-03_JPRB, 0.37545011E-03_JPRB, 0.37531650E-03_JPRB, 0.37520185E-03_JPRB, 0.37510561E-03_JPRB, 0.37501320E-03_JPRB, &
  & 0.37491960E-03_JPRB, 0.37481218E-03_JPRB, 0.37470897E-03_JPRB, 0.37462967E-03_JPRB, 0.37455295E-03_JPRB, 0.37448308E-03_JPRB, &
  & 0.37439187E-03_JPRB, 0.37423559E-03_JPRB, 0.37400119E-03_JPRB, 0.37367505E-03_JPRB, 0.37327504E-03_JPRB, 0.37283177E-03_JPRB, &
  & 0.37235915E-03_JPRB, 0.37189310E-03_JPRB, 0.37155880E-03_JPRB, 0.37136709E-03_JPRB, 0.37129272E-03_JPRB, 0.37127069E-03_JPRB, &
  & 0.37126827E-03_JPRB, 0.37126324E-03_JPRB, 0.37124790E-03_JPRB, 0.37122704E-03_JPRB, 0.37119507E-03_JPRB, 0.37115790E-03_JPRB, &
  & 0.37113014E-03_JPRB, 0.37111202E-03_JPRB, 0.37110433E-03_JPRB, 0.37110247E-03_JPRB  /)

RGHG1(:,14, 4) = (/ &
  & 0.37281175E-03_JPRB, 0.37275678E-03_JPRB, 0.37268165E-03_JPRB, 0.37257756E-03_JPRB, 0.37243074E-03_JPRB, 0.37222606E-03_JPRB, &
  & 0.37198425E-03_JPRB, 0.37173758E-03_JPRB, 0.37153225E-03_JPRB, 0.37142705E-03_JPRB, 0.37144128E-03_JPRB, 0.37157123E-03_JPRB, &
  & 0.37177663E-03_JPRB, 0.37201208E-03_JPRB, 0.37222666E-03_JPRB, 0.37243740E-03_JPRB, 0.37266513E-03_JPRB, 0.37289202E-03_JPRB, &
  & 0.37309830E-03_JPRB, 0.37336916E-03_JPRB, 0.37376135E-03_JPRB, 0.37435538E-03_JPRB, 0.37495584E-03_JPRB, 0.37540744E-03_JPRB, &
  & 0.37574578E-03_JPRB, 0.37599425E-03_JPRB, 0.37614968E-03_JPRB, 0.37623680E-03_JPRB, 0.37627911E-03_JPRB, 0.37625786E-03_JPRB, &
  & 0.37614614E-03_JPRB, 0.37594759E-03_JPRB, 0.37571052E-03_JPRB, 0.37551694E-03_JPRB, 0.37537358E-03_JPRB, 0.37524443E-03_JPRB, &
  & 0.37511126E-03_JPRB, 0.37496760E-03_JPRB, 0.37482652E-03_JPRB, 0.37470335E-03_JPRB, 0.37460239E-03_JPRB, 0.37452384E-03_JPRB, &
  & 0.37442269E-03_JPRB, 0.37426036E-03_JPRB, 0.37403159E-03_JPRB, 0.37370349E-03_JPRB, 0.37330256E-03_JPRB, 0.37285142E-03_JPRB, &
  & 0.37238136E-03_JPRB, 0.37195635E-03_JPRB, 0.37166378E-03_JPRB, 0.37150501E-03_JPRB, 0.37144933E-03_JPRB, 0.37143611E-03_JPRB, &
  & 0.37142986E-03_JPRB, 0.37141824E-03_JPRB, 0.37139475E-03_JPRB, 0.37137143E-03_JPRB, 0.37134780E-03_JPRB, 0.37131353E-03_JPRB, &
  & 0.37127944E-03_JPRB, 0.37125825E-03_JPRB, 0.37124500E-03_JPRB, 0.37123703E-03_JPRB  /)

RGHG1(:,15, 4) = (/ &
  & 0.37325919E-03_JPRB, 0.37320705E-03_JPRB, 0.37313753E-03_JPRB, 0.37301799E-03_JPRB, 0.37285303E-03_JPRB, 0.37264120E-03_JPRB, &
  & 0.37238246E-03_JPRB, 0.37209810E-03_JPRB, 0.37185084E-03_JPRB, 0.37171453E-03_JPRB, 0.37171024E-03_JPRB, 0.37181755E-03_JPRB, &
  & 0.37199597E-03_JPRB, 0.37220203E-03_JPRB, 0.37237844E-03_JPRB, 0.37256635E-03_JPRB, 0.37278403E-03_JPRB, 0.37297397E-03_JPRB, &
  & 0.37311530E-03_JPRB, 0.37335269E-03_JPRB, 0.37372442E-03_JPRB, 0.37427439E-03_JPRB, 0.37485960E-03_JPRB, 0.37536937E-03_JPRB, &
  & 0.37579839E-03_JPRB, 0.37614095E-03_JPRB, 0.37638286E-03_JPRB, 0.37654763E-03_JPRB, 0.37664164E-03_JPRB, 0.37664077E-03_JPRB, &
  & 0.37650780E-03_JPRB, 0.37624792E-03_JPRB, 0.37593001E-03_JPRB, 0.37565294E-03_JPRB, 0.37544725E-03_JPRB, 0.37528487E-03_JPRB, &
  & 0.37513117E-03_JPRB, 0.37497934E-03_JPRB, 0.37484691E-03_JPRB, 0.37471224E-03_JPRB, 0.37459214E-03_JPRB, 0.37450057E-03_JPRB, &
  & 0.37438050E-03_JPRB, 0.37421641E-03_JPRB, 0.37398439E-03_JPRB, 0.37365954E-03_JPRB, 0.37327699E-03_JPRB, 0.37285566E-03_JPRB, &
  & 0.37242048E-03_JPRB, 0.37205832E-03_JPRB, 0.37183605E-03_JPRB, 0.37173448E-03_JPRB, 0.37171177E-03_JPRB, 0.37171555E-03_JPRB, &
  & 0.37171028E-03_JPRB, 0.37169304E-03_JPRB, 0.37166204E-03_JPRB, 0.37163102E-03_JPRB, 0.37161170E-03_JPRB, 0.37159466E-03_JPRB, &
  & 0.37156471E-03_JPRB, 0.37154679E-03_JPRB, 0.37153840E-03_JPRB, 0.37153372E-03_JPRB  /)

RGHG1(:,16, 4) = (/ &
  & 0.37362898E-03_JPRB, 0.37360146E-03_JPRB, 0.37355800E-03_JPRB, 0.37346256E-03_JPRB, 0.37331866E-03_JPRB, 0.37312116E-03_JPRB, &
  & 0.37285637E-03_JPRB, 0.37254507E-03_JPRB, 0.37227403E-03_JPRB, 0.37211498E-03_JPRB, 0.37207677E-03_JPRB, 0.37213887E-03_JPRB, &
  & 0.37226210E-03_JPRB, 0.37241087E-03_JPRB, 0.37253604E-03_JPRB, 0.37269775E-03_JPRB, 0.37288598E-03_JPRB, 0.37302902E-03_JPRB, &
  & 0.37312200E-03_JPRB, 0.37333570E-03_JPRB, 0.37369514E-03_JPRB, 0.37418901E-03_JPRB, 0.37473329E-03_JPRB, 0.37527610E-03_JPRB, &
  & 0.37579190E-03_JPRB, 0.37621621E-03_JPRB, 0.37653278E-03_JPRB, 0.37675596E-03_JPRB, 0.37688185E-03_JPRB, 0.37689838E-03_JPRB, &
  & 0.37676754E-03_JPRB, 0.37647389E-03_JPRB, 0.37609020E-03_JPRB, 0.37572160E-03_JPRB, 0.37543004E-03_JPRB, 0.37522244E-03_JPRB, &
  & 0.37505928E-03_JPRB, 0.37491691E-03_JPRB, 0.37478623E-03_JPRB, 0.37463881E-03_JPRB, 0.37449436E-03_JPRB, 0.37437078E-03_JPRB, &
  & 0.37422175E-03_JPRB, 0.37405168E-03_JPRB, 0.37381111E-03_JPRB, 0.37350764E-03_JPRB, 0.37316632E-03_JPRB, 0.37279916E-03_JPRB, &
  & 0.37242681E-03_JPRB, 0.37214799E-03_JPRB, 0.37201918E-03_JPRB, 0.37198504E-03_JPRB, 0.37199430E-03_JPRB, 0.37200889E-03_JPRB, &
  & 0.37200489E-03_JPRB, 0.37198754E-03_JPRB, 0.37196025E-03_JPRB, 0.37192782E-03_JPRB, 0.37191234E-03_JPRB, 0.37191244E-03_JPRB, &
  & 0.37189821E-03_JPRB, 0.37188974E-03_JPRB, 0.37189642E-03_JPRB, 0.37190240E-03_JPRB  /)

RGHG1(:,17, 4) = (/ &
  & 0.37377319E-03_JPRB, 0.37377229E-03_JPRB, 0.37376510E-03_JPRB, 0.37372537E-03_JPRB, 0.37364050E-03_JPRB, 0.37347714E-03_JPRB, &
  & 0.37322198E-03_JPRB, 0.37292976E-03_JPRB, 0.37268481E-03_JPRB, 0.37252207E-03_JPRB, 0.37244746E-03_JPRB, 0.37246311E-03_JPRB, &
  & 0.37253075E-03_JPRB, 0.37260819E-03_JPRB, 0.37268765E-03_JPRB, 0.37281123E-03_JPRB, 0.37295292E-03_JPRB, 0.37304865E-03_JPRB, &
  & 0.37312624E-03_JPRB, 0.37335321E-03_JPRB, 0.37373226E-03_JPRB, 0.37418433E-03_JPRB, 0.37468276E-03_JPRB, 0.37524061E-03_JPRB, &
  & 0.37581123E-03_JPRB, 0.37629486E-03_JPRB, 0.37667212E-03_JPRB, 0.37694021E-03_JPRB, 0.37708401E-03_JPRB, 0.37711696E-03_JPRB, &
  & 0.37700652E-03_JPRB, 0.37671725E-03_JPRB, 0.37627950E-03_JPRB, 0.37580888E-03_JPRB, 0.37542768E-03_JPRB, 0.37516804E-03_JPRB, &
  & 0.37499415E-03_JPRB, 0.37485374E-03_JPRB, 0.37470426E-03_JPRB, 0.37451471E-03_JPRB, 0.37431051E-03_JPRB, 0.37412181E-03_JPRB, &
  & 0.37395339E-03_JPRB, 0.37377532E-03_JPRB, 0.37354939E-03_JPRB, 0.37329173E-03_JPRB, 0.37300101E-03_JPRB, 0.37268918E-03_JPRB, &
  & 0.37239662E-03_JPRB, 0.37222506E-03_JPRB, 0.37218069E-03_JPRB, 0.37219280E-03_JPRB, 0.37221888E-03_JPRB, 0.37223623E-03_JPRB, &
  & 0.37223212E-03_JPRB, 0.37221468E-03_JPRB, 0.37219641E-03_JPRB, 0.37217101E-03_JPRB, 0.37216595E-03_JPRB, 0.37217724E-03_JPRB, &
  & 0.37217919E-03_JPRB, 0.37218507E-03_JPRB, 0.37220516E-03_JPRB, 0.37221724E-03_JPRB  /)

RGHG1(:,18, 4) = (/ &
  & 0.37367824E-03_JPRB, 0.37369883E-03_JPRB, 0.37372822E-03_JPRB, 0.37375124E-03_JPRB, 0.37372466E-03_JPRB, 0.37360123E-03_JPRB, &
  & 0.37339404E-03_JPRB, 0.37317315E-03_JPRB, 0.37298106E-03_JPRB, 0.37282736E-03_JPRB, 0.37272930E-03_JPRB, 0.37271249E-03_JPRB, &
  & 0.37273605E-03_JPRB, 0.37275760E-03_JPRB, 0.37279861E-03_JPRB, 0.37288463E-03_JPRB, 0.37298062E-03_JPRB, 0.37304677E-03_JPRB, &
  & 0.37314113E-03_JPRB, 0.37342124E-03_JPRB, 0.37382583E-03_JPRB, 0.37425532E-03_JPRB, 0.37472664E-03_JPRB, 0.37528532E-03_JPRB, &
  & 0.37588286E-03_JPRB, 0.37640605E-03_JPRB, 0.37683348E-03_JPRB, 0.37713622E-03_JPRB, 0.37730296E-03_JPRB, 0.37737180E-03_JPRB, &
  & 0.37731589E-03_JPRB, 0.37706109E-03_JPRB, 0.37659422E-03_JPRB, 0.37601929E-03_JPRB, 0.37553824E-03_JPRB, 0.37521959E-03_JPRB, &
  & 0.37501342E-03_JPRB, 0.37486153E-03_JPRB, 0.37468973E-03_JPRB, 0.37444085E-03_JPRB, 0.37414635E-03_JPRB, 0.37389689E-03_JPRB, &
  & 0.37370986E-03_JPRB, 0.37353542E-03_JPRB, 0.37333379E-03_JPRB, 0.37311467E-03_JPRB, 0.37286435E-03_JPRB, 0.37260065E-03_JPRB, &
  & 0.37240707E-03_JPRB, 0.37232731E-03_JPRB, 0.37232830E-03_JPRB, 0.37235810E-03_JPRB, 0.37238793E-03_JPRB, 0.37240459E-03_JPRB, &
  & 0.37240440E-03_JPRB, 0.37238753E-03_JPRB, 0.37237659E-03_JPRB, 0.37235925E-03_JPRB, 0.37236262E-03_JPRB, 0.37237579E-03_JPRB, &
  & 0.37238622E-03_JPRB, 0.37240154E-03_JPRB, 0.37242926E-03_JPRB, 0.37244390E-03_JPRB  /)

RGHG1(:,19, 4) = (/ &
  & 0.37350483E-03_JPRB, 0.37353774E-03_JPRB, 0.37359619E-03_JPRB, 0.37365427E-03_JPRB, 0.37365579E-03_JPRB, 0.37357352E-03_JPRB, &
  & 0.37344031E-03_JPRB, 0.37329788E-03_JPRB, 0.37315673E-03_JPRB, 0.37301907E-03_JPRB, 0.37291824E-03_JPRB, 0.37288613E-03_JPRB, &
  & 0.37288059E-03_JPRB, 0.37287384E-03_JPRB, 0.37288872E-03_JPRB, 0.37294739E-03_JPRB, 0.37301011E-03_JPRB, 0.37306792E-03_JPRB, &
  & 0.37320080E-03_JPRB, 0.37354171E-03_JPRB, 0.37398356E-03_JPRB, 0.37441048E-03_JPRB, 0.37487719E-03_JPRB, 0.37543685E-03_JPRB, &
  & 0.37604466E-03_JPRB, 0.37659168E-03_JPRB, 0.37705571E-03_JPRB, 0.37738393E-03_JPRB, 0.37757438E-03_JPRB, 0.37769100E-03_JPRB, &
  & 0.37772001E-03_JPRB, 0.37753548E-03_JPRB, 0.37706472E-03_JPRB, 0.37640474E-03_JPRB, 0.37582480E-03_JPRB, 0.37544430E-03_JPRB, &
  & 0.37518621E-03_JPRB, 0.37502729E-03_JPRB, 0.37483639E-03_JPRB, 0.37454003E-03_JPRB, 0.37418444E-03_JPRB, 0.37387644E-03_JPRB, &
  & 0.37364986E-03_JPRB, 0.37346718E-03_JPRB, 0.37327032E-03_JPRB, 0.37305603E-03_JPRB, 0.37282874E-03_JPRB, 0.37262427E-03_JPRB, &
  & 0.37252526E-03_JPRB, 0.37250545E-03_JPRB, 0.37252465E-03_JPRB, 0.37255540E-03_JPRB, 0.37258048E-03_JPRB, 0.37259295E-03_JPRB, &
  & 0.37259138E-03_JPRB, 0.37257506E-03_JPRB, 0.37256434E-03_JPRB, 0.37254921E-03_JPRB, 0.37255409E-03_JPRB, 0.37256034E-03_JPRB, &
  & 0.37256609E-03_JPRB, 0.37258251E-03_JPRB, 0.37261010E-03_JPRB, 0.37262221E-03_JPRB  /)

RGHG1(:,20, 4) = (/ &
  & 0.37337881E-03_JPRB, 0.37341147E-03_JPRB, 0.37347809E-03_JPRB, 0.37353893E-03_JPRB, 0.37354945E-03_JPRB, 0.37350812E-03_JPRB, &
  & 0.37344400E-03_JPRB, 0.37336322E-03_JPRB, 0.37326234E-03_JPRB, 0.37314467E-03_JPRB, 0.37305785E-03_JPRB, 0.37302422E-03_JPRB, &
  & 0.37300778E-03_JPRB, 0.37299585E-03_JPRB, 0.37300223E-03_JPRB, 0.37304722E-03_JPRB, 0.37309234E-03_JPRB, 0.37315818E-03_JPRB, &
  & 0.37334088E-03_JPRB, 0.37372732E-03_JPRB, 0.37422905E-03_JPRB, 0.37467972E-03_JPRB, 0.37515088E-03_JPRB, 0.37572643E-03_JPRB, &
  & 0.37632820E-03_JPRB, 0.37688148E-03_JPRB, 0.37736617E-03_JPRB, 0.37771519E-03_JPRB, 0.37793063E-03_JPRB, 0.37808350E-03_JPRB, &
  & 0.37819545E-03_JPRB, 0.37809416E-03_JPRB, 0.37763847E-03_JPRB, 0.37693386E-03_JPRB, 0.37629123E-03_JPRB, 0.37587414E-03_JPRB, &
  & 0.37557836E-03_JPRB, 0.37542874E-03_JPRB, 0.37523990E-03_JPRB, 0.37493772E-03_JPRB, 0.37455881E-03_JPRB, 0.37417899E-03_JPRB, &
  & 0.37387512E-03_JPRB, 0.37364669E-03_JPRB, 0.37341661E-03_JPRB, 0.37317959E-03_JPRB, 0.37296616E-03_JPRB, 0.37282329E-03_JPRB, &
  & 0.37279757E-03_JPRB, 0.37281013E-03_JPRB, 0.37283636E-03_JPRB, 0.37286014E-03_JPRB, 0.37286946E-03_JPRB, 0.37286613E-03_JPRB, &
  & 0.37285276E-03_JPRB, 0.37283302E-03_JPRB, 0.37281623E-03_JPRB, 0.37279345E-03_JPRB, 0.37279041E-03_JPRB, 0.37278053E-03_JPRB, &
  & 0.37277030E-03_JPRB, 0.37278073E-03_JPRB, 0.37280019E-03_JPRB, 0.37280491E-03_JPRB  /)

RGHG1(:,21, 4) = (/ &
  & 0.37334849E-03_JPRB, 0.37336953E-03_JPRB, 0.37342120E-03_JPRB, 0.37346270E-03_JPRB, 0.37347289E-03_JPRB, 0.37346542E-03_JPRB, &
  & 0.37345130E-03_JPRB, 0.37341111E-03_JPRB, 0.37334050E-03_JPRB, 0.37324598E-03_JPRB, 0.37318372E-03_JPRB, 0.37316106E-03_JPRB, &
  & 0.37315194E-03_JPRB, 0.37315107E-03_JPRB, 0.37316596E-03_JPRB, 0.37321039E-03_JPRB, 0.37325462E-03_JPRB, 0.37334228E-03_JPRB, &
  & 0.37357782E-03_JPRB, 0.37399488E-03_JPRB, 0.37456498E-03_JPRB, 0.37505921E-03_JPRB, 0.37555902E-03_JPRB, 0.37616902E-03_JPRB, &
  & 0.37675292E-03_JPRB, 0.37729002E-03_JPRB, 0.37777476E-03_JPRB, 0.37814271E-03_JPRB, 0.37838152E-03_JPRB, 0.37854998E-03_JPRB, &
  & 0.37871921E-03_JPRB, 0.37869200E-03_JPRB, 0.37826859E-03_JPRB, 0.37756801E-03_JPRB, 0.37691364E-03_JPRB, 0.37650054E-03_JPRB, &
  & 0.37620659E-03_JPRB, 0.37608670E-03_JPRB, 0.37592469E-03_JPRB, 0.37565641E-03_JPRB, 0.37527881E-03_JPRB, 0.37480563E-03_JPRB, &
  & 0.37438791E-03_JPRB, 0.37407747E-03_JPRB, 0.37378075E-03_JPRB, 0.37350571E-03_JPRB, 0.37330283E-03_JPRB, 0.37321456E-03_JPRB, &
  & 0.37323375E-03_JPRB, 0.37325845E-03_JPRB, 0.37328336E-03_JPRB, 0.37329108E-03_JPRB, 0.37327371E-03_JPRB, 0.37324327E-03_JPRB, &
  & 0.37320824E-03_JPRB, 0.37317640E-03_JPRB, 0.37314673E-03_JPRB, 0.37310938E-03_JPRB, 0.37308998E-03_JPRB, 0.37305653E-03_JPRB, &
  & 0.37302339E-03_JPRB, 0.37302142E-03_JPRB, 0.37302778E-03_JPRB, 0.37302349E-03_JPRB  /)

RGHG1(:,22, 4) = (/ &
  & 0.37344077E-03_JPRB, 0.37344124E-03_JPRB, 0.37345611E-03_JPRB, 0.37346982E-03_JPRB, 0.37347512E-03_JPRB, 0.37348221E-03_JPRB, &
  & 0.37349111E-03_JPRB, 0.37347093E-03_JPRB, 0.37342288E-03_JPRB, 0.37335493E-03_JPRB, 0.37332192E-03_JPRB, 0.37332472E-03_JPRB, &
  & 0.37334183E-03_JPRB, 0.37336309E-03_JPRB, 0.37340177E-03_JPRB, 0.37345832E-03_JPRB, 0.37352145E-03_JPRB, 0.37364557E-03_JPRB, &
  & 0.37392870E-03_JPRB, 0.37437133E-03_JPRB, 0.37498890E-03_JPRB, 0.37553394E-03_JPRB, 0.37612347E-03_JPRB, 0.37678639E-03_JPRB, &
  & 0.37734739E-03_JPRB, 0.37783647E-03_JPRB, 0.37829118E-03_JPRB, 0.37867748E-03_JPRB, 0.37893174E-03_JPRB, 0.37909131E-03_JPRB, &
  & 0.37926954E-03_JPRB, 0.37928414E-03_JPRB, 0.37891343E-03_JPRB, 0.37827411E-03_JPRB, 0.37766865E-03_JPRB, 0.37731303E-03_JPRB, &
  & 0.37708568E-03_JPRB, 0.37701916E-03_JPRB, 0.37690651E-03_JPRB, 0.37669704E-03_JPRB, 0.37632766E-03_JPRB, 0.37573409E-03_JPRB, &
  & 0.37517338E-03_JPRB, 0.37475710E-03_JPRB, 0.37437333E-03_JPRB, 0.37405716E-03_JPRB, 0.37386451E-03_JPRB, 0.37381426E-03_JPRB, &
  & 0.37384223E-03_JPRB, 0.37386359E-03_JPRB, 0.37387327E-03_JPRB, 0.37384831E-03_JPRB, 0.37379436E-03_JPRB, 0.37373001E-03_JPRB, &
  & 0.37366574E-03_JPRB, 0.37360689E-03_JPRB, 0.37355487E-03_JPRB, 0.37350207E-03_JPRB, 0.37345976E-03_JPRB, 0.37339785E-03_JPRB, &
  & 0.37333970E-03_JPRB, 0.37331815E-03_JPRB, 0.37331095E-03_JPRB, 0.37330088E-03_JPRB  /)

RGHG1(:,23, 4) = (/ &
  & 0.37357754E-03_JPRB, 0.37355961E-03_JPRB, 0.37354477E-03_JPRB, 0.37353721E-03_JPRB, 0.37353259E-03_JPRB, 0.37353920E-03_JPRB, &
  & 0.37355290E-03_JPRB, 0.37354983E-03_JPRB, 0.37352839E-03_JPRB, 0.37349076E-03_JPRB, 0.37348828E-03_JPRB, 0.37352870E-03_JPRB, &
  & 0.37357999E-03_JPRB, 0.37362532E-03_JPRB, 0.37368313E-03_JPRB, 0.37376006E-03_JPRB, 0.37385176E-03_JPRB, 0.37401059E-03_JPRB, &
  & 0.37430650E-03_JPRB, 0.37475918E-03_JPRB, 0.37535247E-03_JPRB, 0.37597620E-03_JPRB, 0.37671265E-03_JPRB, 0.37744875E-03_JPRB, &
  & 0.37801257E-03_JPRB, 0.37845723E-03_JPRB, 0.37887327E-03_JPRB, 0.37926005E-03_JPRB, 0.37952003E-03_JPRB, 0.37965755E-03_JPRB, &
  & 0.37980248E-03_JPRB, 0.37981241E-03_JPRB, 0.37949574E-03_JPRB, 0.37895972E-03_JPRB, 0.37846803E-03_JPRB, 0.37820405E-03_JPRB, &
  & 0.37805142E-03_JPRB, 0.37800833E-03_JPRB, 0.37791309E-03_JPRB, 0.37771600E-03_JPRB, 0.37732907E-03_JPRB, 0.37666559E-03_JPRB, &
  & 0.37600644E-03_JPRB, 0.37548794E-03_JPRB, 0.37502892E-03_JPRB, 0.37471413E-03_JPRB, 0.37455031E-03_JPRB, 0.37451310E-03_JPRB, &
  & 0.37452658E-03_JPRB, 0.37452272E-03_JPRB, 0.37449831E-03_JPRB, 0.37442951E-03_JPRB, 0.37433669E-03_JPRB, 0.37424190E-03_JPRB, &
  & 0.37414497E-03_JPRB, 0.37405646E-03_JPRB, 0.37397733E-03_JPRB, 0.37391120E-03_JPRB, 0.37384597E-03_JPRB, 0.37375522E-03_JPRB, &
  & 0.37367965E-03_JPRB, 0.37363945E-03_JPRB, 0.37361798E-03_JPRB, 0.37360346E-03_JPRB  /)

RGHG1(:,24, 4) = (/ &
  & 0.37371749E-03_JPRB, 0.37368756E-03_JPRB, 0.37365104E-03_JPRB, 0.37362607E-03_JPRB, 0.37361220E-03_JPRB, 0.37361549E-03_JPRB, &
  & 0.37363223E-03_JPRB, 0.37364818E-03_JPRB, 0.37365470E-03_JPRB, 0.37364899E-03_JPRB, 0.37367794E-03_JPRB, 0.37375706E-03_JPRB, &
  & 0.37384353E-03_JPRB, 0.37391370E-03_JPRB, 0.37398911E-03_JPRB, 0.37408603E-03_JPRB, 0.37420131E-03_JPRB, 0.37438224E-03_JPRB, &
  & 0.37467286E-03_JPRB, 0.37512851E-03_JPRB, 0.37569162E-03_JPRB, 0.37639120E-03_JPRB, 0.37728200E-03_JPRB, 0.37811789E-03_JPRB, &
  & 0.37869532E-03_JPRB, 0.37910397E-03_JPRB, 0.37948348E-03_JPRB, 0.37986309E-03_JPRB, 0.38012550E-03_JPRB, 0.38023794E-03_JPRB, &
  & 0.38033615E-03_JPRB, 0.38032707E-03_JPRB, 0.38006403E-03_JPRB, 0.37964452E-03_JPRB, 0.37928146E-03_JPRB, 0.37910721E-03_JPRB, &
  & 0.37901194E-03_JPRB, 0.37895990E-03_JPRB, 0.37884264E-03_JPRB, 0.37862671E-03_JPRB, 0.37821251E-03_JPRB, 0.37752175E-03_JPRB, &
  & 0.37680179E-03_JPRB, 0.37619361E-03_JPRB, 0.37569194E-03_JPRB, 0.37539928E-03_JPRB, 0.37526443E-03_JPRB, 0.37522994E-03_JPRB, &
  & 0.37521722E-03_JPRB, 0.37517877E-03_JPRB, 0.37511883E-03_JPRB, 0.37501342E-03_JPRB, 0.37488048E-03_JPRB, 0.37475260E-03_JPRB, &
  & 0.37462631E-03_JPRB, 0.37450678E-03_JPRB, 0.37440061E-03_JPRB, 0.37432365E-03_JPRB, 0.37423684E-03_JPRB, 0.37411664E-03_JPRB, &
  & 0.37402769E-03_JPRB, 0.37396879E-03_JPRB, 0.37393206E-03_JPRB, 0.37391282E-03_JPRB  /)

RGHG1(:,25, 4) = (/ &
  & 0.37384675E-03_JPRB, 0.37381625E-03_JPRB, 0.37377165E-03_JPRB, 0.37373538E-03_JPRB, 0.37371502E-03_JPRB, 0.37371352E-03_JPRB, &
  & 0.37373411E-03_JPRB, 0.37377227E-03_JPRB, 0.37380701E-03_JPRB, 0.37383375E-03_JPRB, 0.37389403E-03_JPRB, 0.37400928E-03_JPRB, &
  & 0.37412933E-03_JPRB, 0.37422414E-03_JPRB, 0.37431470E-03_JPRB, 0.37442818E-03_JPRB, 0.37455494E-03_JPRB, 0.37473502E-03_JPRB, &
  & 0.37499638E-03_JPRB, 0.37544582E-03_JPRB, 0.37598579E-03_JPRB, 0.37674652E-03_JPRB, 0.37778502E-03_JPRB, 0.37875882E-03_JPRB, &
  & 0.37936259E-03_JPRB, 0.37975092E-03_JPRB, 0.38010127E-03_JPRB, 0.38046451E-03_JPRB, 0.38072560E-03_JPRB, 0.38081171E-03_JPRB, &
  & 0.38085102E-03_JPRB, 0.38080883E-03_JPRB, 0.38059593E-03_JPRB, 0.38030163E-03_JPRB, 0.38007320E-03_JPRB, 0.37997354E-03_JPRB, &
  & 0.37990047E-03_JPRB, 0.37978926E-03_JPRB, 0.37958827E-03_JPRB, 0.37930951E-03_JPRB, 0.37885786E-03_JPRB, 0.37820520E-03_JPRB, &
  & 0.37748383E-03_JPRB, 0.37681140E-03_JPRB, 0.37632412E-03_JPRB, 0.37607982E-03_JPRB, 0.37596867E-03_JPRB, 0.37592412E-03_JPRB, &
  & 0.37587085E-03_JPRB, 0.37578771E-03_JPRB, 0.37569551E-03_JPRB, 0.37557043E-03_JPRB, 0.37539752E-03_JPRB, 0.37523257E-03_JPRB, &
  & 0.37508483E-03_JPRB, 0.37493388E-03_JPRB, 0.37480306E-03_JPRB, 0.37471971E-03_JPRB, 0.37461464E-03_JPRB, 0.37446537E-03_JPRB, &
  & 0.37436909E-03_JPRB, 0.37429203E-03_JPRB, 0.37423912E-03_JPRB, 0.37421461E-03_JPRB  /)

RGHG1(:,26, 4) = (/ &
  & 0.37397367E-03_JPRB, 0.37394328E-03_JPRB, 0.37389389E-03_JPRB, 0.37385089E-03_JPRB, 0.37383199E-03_JPRB, 0.37383270E-03_JPRB, &
  & 0.37386651E-03_JPRB, 0.37392883E-03_JPRB, 0.37398955E-03_JPRB, 0.37404419E-03_JPRB, 0.37413374E-03_JPRB, 0.37427642E-03_JPRB, &
  & 0.37442162E-03_JPRB, 0.37453993E-03_JPRB, 0.37464326E-03_JPRB, 0.37476498E-03_JPRB, 0.37488780E-03_JPRB, 0.37505074E-03_JPRB, &
  & 0.37527872E-03_JPRB, 0.37570850E-03_JPRB, 0.37625846E-03_JPRB, 0.37706067E-03_JPRB, 0.37818630E-03_JPRB, 0.37926525E-03_JPRB, &
  & 0.37993975E-03_JPRB, 0.38034470E-03_JPRB, 0.38068165E-03_JPRB, 0.38103379E-03_JPRB, 0.38128227E-03_JPRB, 0.38134245E-03_JPRB, &
  & 0.38133616E-03_JPRB, 0.38127123E-03_JPRB, 0.38110591E-03_JPRB, 0.38090743E-03_JPRB, 0.38075626E-03_JPRB, 0.38068394E-03_JPRB, &
  & 0.38060863E-03_JPRB, 0.38043284E-03_JPRB, 0.38013817E-03_JPRB, 0.37978215E-03_JPRB, 0.37929182E-03_JPRB, 0.37866352E-03_JPRB, &
  & 0.37797177E-03_JPRB, 0.37732565E-03_JPRB, 0.37690654E-03_JPRB, 0.37668679E-03_JPRB, 0.37657516E-03_JPRB, 0.37650677E-03_JPRB, &
  & 0.37641357E-03_JPRB, 0.37628360E-03_JPRB, 0.37616559E-03_JPRB, 0.37602384E-03_JPRB, 0.37583972E-03_JPRB, 0.37565955E-03_JPRB, &
  & 0.37549721E-03_JPRB, 0.37532787E-03_JPRB, 0.37516977E-03_JPRB, 0.37507309E-03_JPRB, 0.37495761E-03_JPRB, 0.37479286E-03_JPRB, &
  & 0.37468672E-03_JPRB, 0.37458985E-03_JPRB, 0.37452062E-03_JPRB, 0.37448562E-03_JPRB  /)

RGHG1(:,27, 4) = (/ &
  & 0.37410551E-03_JPRB, 0.37407547E-03_JPRB, 0.37402231E-03_JPRB, 0.37397395E-03_JPRB, 0.37395953E-03_JPRB, 0.37396516E-03_JPRB, &
  & 0.37401626E-03_JPRB, 0.37410456E-03_JPRB, 0.37419161E-03_JPRB, 0.37427372E-03_JPRB, 0.37439312E-03_JPRB, 0.37456125E-03_JPRB, &
  & 0.37472963E-03_JPRB, 0.37487208E-03_JPRB, 0.37498787E-03_JPRB, 0.37511512E-03_JPRB, 0.37522811E-03_JPRB, 0.37536709E-03_JPRB, &
  & 0.37555864E-03_JPRB, 0.37596287E-03_JPRB, 0.37653557E-03_JPRB, 0.37737386E-03_JPRB, 0.37856813E-03_JPRB, 0.37974486E-03_JPRB, &
  & 0.38050977E-03_JPRB, 0.38094579E-03_JPRB, 0.38127458E-03_JPRB, 0.38161706E-03_JPRB, 0.38184816E-03_JPRB, 0.38188139E-03_JPRB, &
  & 0.38183236E-03_JPRB, 0.38174751E-03_JPRB, 0.38163099E-03_JPRB, 0.38152177E-03_JPRB, 0.38143012E-03_JPRB, 0.38136886E-03_JPRB, &
  & 0.38128214E-03_JPRB, 0.38103683E-03_JPRB, 0.38064051E-03_JPRB, 0.38019838E-03_JPRB, 0.37966715E-03_JPRB, 0.37905921E-03_JPRB, &
  & 0.37840995E-03_JPRB, 0.37782492E-03_JPRB, 0.37749701E-03_JPRB, 0.37729412E-03_JPRB, 0.37717300E-03_JPRB, 0.37707460E-03_JPRB, &
  & 0.37693988E-03_JPRB, 0.37676014E-03_JPRB, 0.37661756E-03_JPRB, 0.37645948E-03_JPRB, 0.37627430E-03_JPRB, 0.37608632E-03_JPRB, &
  & 0.37591125E-03_JPRB, 0.37572751E-03_JPRB, 0.37553993E-03_JPRB, 0.37542675E-03_JPRB, 0.37530327E-03_JPRB, 0.37512737E-03_JPRB, &
  & 0.37501000E-03_JPRB, 0.37489180E-03_JPRB, 0.37480546E-03_JPRB, 0.37475755E-03_JPRB  /)

RGHG1(:,28, 4) = (/ &
  & 0.37420907E-03_JPRB, 0.37416987E-03_JPRB, 0.37410687E-03_JPRB, 0.37405969E-03_JPRB, 0.37406299E-03_JPRB, 0.37409561E-03_JPRB, &
  & 0.37418285E-03_JPRB, 0.37430312E-03_JPRB, 0.37441786E-03_JPRB, 0.37452901E-03_JPRB, 0.37467230E-03_JPRB, 0.37484784E-03_JPRB, &
  & 0.37502791E-03_JPRB, 0.37519199E-03_JPRB, 0.37531774E-03_JPRB, 0.37544593E-03_JPRB, 0.37555584E-03_JPRB, 0.37568463E-03_JPRB, &
  & 0.37587031E-03_JPRB, 0.37622584E-03_JPRB, 0.37677606E-03_JPRB, 0.37762909E-03_JPRB, 0.37880312E-03_JPRB, 0.38001632E-03_JPRB, &
  & 0.38087930E-03_JPRB, 0.38138077E-03_JPRB, 0.38176057E-03_JPRB, 0.38211257E-03_JPRB, 0.38232391E-03_JPRB, 0.38236373E-03_JPRB, &
  & 0.38232140E-03_JPRB, 0.38224639E-03_JPRB, 0.38215706E-03_JPRB, 0.38206788E-03_JPRB, 0.38195861E-03_JPRB, 0.38185402E-03_JPRB, &
  & 0.38170845E-03_JPRB, 0.38140894E-03_JPRB, 0.38096820E-03_JPRB, 0.38047004E-03_JPRB, 0.37992031E-03_JPRB, 0.37934725E-03_JPRB, &
  & 0.37877204E-03_JPRB, 0.37828779E-03_JPRB, 0.37799834E-03_JPRB, 0.37779160E-03_JPRB, 0.37762700E-03_JPRB, 0.37748577E-03_JPRB, &
  & 0.37732145E-03_JPRB, 0.37711747E-03_JPRB, 0.37694399E-03_JPRB, 0.37677137E-03_JPRB, 0.37659976E-03_JPRB, 0.37643558E-03_JPRB, &
  & 0.37626467E-03_JPRB, 0.37607287E-03_JPRB, 0.37587182E-03_JPRB, 0.37573170E-03_JPRB, 0.37559386E-03_JPRB, 0.37543056E-03_JPRB, &
  & 0.37529308E-03_JPRB, 0.37516836E-03_JPRB, 0.37506372E-03_JPRB, 0.37500985E-03_JPRB  /)

RGHG1(:,29, 4) = (/ &
  & 0.37431758E-03_JPRB, 0.37426825E-03_JPRB, 0.37419457E-03_JPRB, 0.37414892E-03_JPRB, 0.37417157E-03_JPRB, 0.37423375E-03_JPRB, &
  & 0.37436011E-03_JPRB, 0.37451450E-03_JPRB, 0.37465864E-03_JPRB, 0.37480063E-03_JPRB, 0.37496898E-03_JPRB, 0.37515159E-03_JPRB, &
  & 0.37534354E-03_JPRB, 0.37553043E-03_JPRB, 0.37566662E-03_JPRB, 0.37579561E-03_JPRB, 0.37590255E-03_JPRB, 0.37602114E-03_JPRB, &
  & 0.37620192E-03_JPRB, 0.37650485E-03_JPRB, 0.37702928E-03_JPRB, 0.37789701E-03_JPRB, 0.37904575E-03_JPRB, 0.38029493E-03_JPRB, &
  & 0.38126215E-03_JPRB, 0.38183446E-03_JPRB, 0.38227088E-03_JPRB, 0.38263381E-03_JPRB, 0.38282410E-03_JPRB, 0.38287235E-03_JPRB, &
  & 0.38283925E-03_JPRB, 0.38277597E-03_JPRB, 0.38271451E-03_JPRB, 0.38264356E-03_JPRB, 0.38251229E-03_JPRB, 0.38235943E-03_JPRB, &
  & 0.38214945E-03_JPRB, 0.38179315E-03_JPRB, 0.38130785E-03_JPRB, 0.38075162E-03_JPRB, 0.38018326E-03_JPRB, 0.37964778E-03_JPRB, &
  & 0.37915240E-03_JPRB, 0.37877665E-03_JPRB, 0.37852567E-03_JPRB, 0.37831395E-03_JPRB, 0.37810181E-03_JPRB, 0.37791464E-03_JPRB, &
  & 0.37771949E-03_JPRB, 0.37749093E-03_JPRB, 0.37728444E-03_JPRB, 0.37709648E-03_JPRB, 0.37693989E-03_JPRB, 0.37680229E-03_JPRB, &
  & 0.37663652E-03_JPRB, 0.37643644E-03_JPRB, 0.37622182E-03_JPRB, 0.37605271E-03_JPRB, 0.37589937E-03_JPRB, 0.37575044E-03_JPRB, &
  & 0.37559129E-03_JPRB, 0.37546030E-03_JPRB, 0.37533623E-03_JPRB, 0.37527633E-03_JPRB  /)

RGHG1(:,30, 4) = (/ &
  & 0.37438322E-03_JPRB, 0.37433283E-03_JPRB, 0.37425046E-03_JPRB, 0.37421878E-03_JPRB, 0.37428068E-03_JPRB, 0.37439883E-03_JPRB, &
  & 0.37457806E-03_JPRB, 0.37477370E-03_JPRB, 0.37495271E-03_JPRB, 0.37512274E-03_JPRB, 0.37531150E-03_JPRB, 0.37550336E-03_JPRB, &
  & 0.37571219E-03_JPRB, 0.37591504E-03_JPRB, 0.37606492E-03_JPRB, 0.37621022E-03_JPRB, 0.37632886E-03_JPRB, 0.37647016E-03_JPRB, &
  & 0.37668354E-03_JPRB, 0.37699340E-03_JPRB, 0.37748536E-03_JPRB, 0.37823464E-03_JPRB, 0.37925480E-03_JPRB, 0.38046056E-03_JPRB, &
  & 0.38145956E-03_JPRB, 0.38212195E-03_JPRB, 0.38262171E-03_JPRB, 0.38300475E-03_JPRB, 0.38323292E-03_JPRB, 0.38334531E-03_JPRB, &
  & 0.38338129E-03_JPRB, 0.38336663E-03_JPRB, 0.38331070E-03_JPRB, 0.38319482E-03_JPRB, 0.38300454E-03_JPRB, 0.38277136E-03_JPRB, &
  & 0.38247637E-03_JPRB, 0.38207106E-03_JPRB, 0.38156913E-03_JPRB, 0.38103127E-03_JPRB, 0.38053513E-03_JPRB, 0.38007547E-03_JPRB, &
  & 0.37964126E-03_JPRB, 0.37929129E-03_JPRB, 0.37901671E-03_JPRB, 0.37876745E-03_JPRB, 0.37850707E-03_JPRB, 0.37828169E-03_JPRB, &
  & 0.37806831E-03_JPRB, 0.37783627E-03_JPRB, 0.37761706E-03_JPRB, 0.37740431E-03_JPRB, 0.37723038E-03_JPRB, 0.37710424E-03_JPRB, &
  & 0.37692986E-03_JPRB, 0.37671511E-03_JPRB, 0.37648989E-03_JPRB, 0.37631955E-03_JPRB, 0.37616027E-03_JPRB, 0.37602681E-03_JPRB, &
  & 0.37586086E-03_JPRB, 0.37573276E-03_JPRB, 0.37564105E-03_JPRB, 0.37560062E-03_JPRB  /)

RGHG1(:,31, 4) = (/ &
  & 0.37445234E-03_JPRB, 0.37440084E-03_JPRB, 0.37430932E-03_JPRB, 0.37429236E-03_JPRB, 0.37439564E-03_JPRB, 0.37457279E-03_JPRB, &
  & 0.37480776E-03_JPRB, 0.37504684E-03_JPRB, 0.37526261E-03_JPRB, 0.37546218E-03_JPRB, 0.37567244E-03_JPRB, 0.37587405E-03_JPRB, &
  & 0.37610066E-03_JPRB, 0.37632033E-03_JPRB, 0.37648465E-03_JPRB, 0.37664713E-03_JPRB, 0.37677813E-03_JPRB, 0.37694338E-03_JPRB, &
  & 0.37719113E-03_JPRB, 0.37750837E-03_JPRB, 0.37796610E-03_JPRB, 0.37859045E-03_JPRB, 0.37947505E-03_JPRB, 0.38063496E-03_JPRB, &
  & 0.38166737E-03_JPRB, 0.38242471E-03_JPRB, 0.38299121E-03_JPRB, 0.38339546E-03_JPRB, 0.38366358E-03_JPRB, 0.38384361E-03_JPRB, &
  & 0.38395243E-03_JPRB, 0.38398904E-03_JPRB, 0.38393891E-03_JPRB, 0.38377564E-03_JPRB, 0.38352316E-03_JPRB, 0.38320530E-03_JPRB, &
  & 0.38282072E-03_JPRB, 0.38236377E-03_JPRB, 0.38184436E-03_JPRB, 0.38132592E-03_JPRB, 0.38090597E-03_JPRB, 0.38052622E-03_JPRB, &
  & 0.38015645E-03_JPRB, 0.37983356E-03_JPRB, 0.37953405E-03_JPRB, 0.37924521E-03_JPRB, 0.37893402E-03_JPRB, 0.37866838E-03_JPRB, &
  & 0.37843580E-03_JPRB, 0.37820012E-03_JPRB, 0.37796751E-03_JPRB, 0.37772865E-03_JPRB, 0.37753642E-03_JPRB, 0.37742232E-03_JPRB, &
  & 0.37723887E-03_JPRB, 0.37700864E-03_JPRB, 0.37677226E-03_JPRB, 0.37660066E-03_JPRB, 0.37643513E-03_JPRB, 0.37631796E-03_JPRB, &
  & 0.37614487E-03_JPRB, 0.37601982E-03_JPRB, 0.37596226E-03_JPRB, 0.37594237E-03_JPRB  /)

RGHG1(:,32, 4) = (/ &
  & 0.37461926E-03_JPRB, 0.37457787E-03_JPRB, 0.37448869E-03_JPRB, 0.37448284E-03_JPRB, 0.37462088E-03_JPRB, 0.37485626E-03_JPRB, &
  & 0.37514256E-03_JPRB, 0.37541964E-03_JPRB, 0.37566914E-03_JPRB, 0.37589641E-03_JPRB, 0.37613302E-03_JPRB, 0.37635841E-03_JPRB, &
  & 0.37660974E-03_JPRB, 0.37684757E-03_JPRB, 0.37704721E-03_JPRB, 0.37725358E-03_JPRB, 0.37740703E-03_JPRB, 0.37759902E-03_JPRB, &
  & 0.37788747E-03_JPRB, 0.37824685E-03_JPRB, 0.37871367E-03_JPRB, 0.37928962E-03_JPRB, 0.38000730E-03_JPRB, 0.38097850E-03_JPRB, &
  & 0.38191381E-03_JPRB, 0.38267135E-03_JPRB, 0.38326609E-03_JPRB, 0.38370204E-03_JPRB, 0.38402281E-03_JPRB, 0.38426807E-03_JPRB, &
  & 0.38444779E-03_JPRB, 0.38454027E-03_JPRB, 0.38450713E-03_JPRB, 0.38431202E-03_JPRB, 0.38400874E-03_JPRB, 0.38364257E-03_JPRB, &
  & 0.38322753E-03_JPRB, 0.38277180E-03_JPRB, 0.38229268E-03_JPRB, 0.38184311E-03_JPRB, 0.38147186E-03_JPRB, 0.38112581E-03_JPRB, &
  & 0.38078469E-03_JPRB, 0.38044971E-03_JPRB, 0.38011216E-03_JPRB, 0.37977568E-03_JPRB, 0.37942927E-03_JPRB, 0.37912833E-03_JPRB, &
  & 0.37887374E-03_JPRB, 0.37861759E-03_JPRB, 0.37835475E-03_JPRB, 0.37808556E-03_JPRB, 0.37786075E-03_JPRB, 0.37772895E-03_JPRB, &
  & 0.37753371E-03_JPRB, 0.37728811E-03_JPRB, 0.37704336E-03_JPRB, 0.37688402E-03_JPRB, 0.37674457E-03_JPRB, 0.37665586E-03_JPRB, &
  & 0.37648168E-03_JPRB, 0.37638871E-03_JPRB, 0.37638363E-03_JPRB, 0.37637973E-03_JPRB  /)

RGHG1(:,33, 4) = (/ &
  & 0.37480540E-03_JPRB, 0.37477598E-03_JPRB, 0.37469072E-03_JPRB, 0.37469592E-03_JPRB, 0.37486924E-03_JPRB, 0.37516504E-03_JPRB, &
  & 0.37550412E-03_JPRB, 0.37581998E-03_JPRB, 0.37610412E-03_JPRB, 0.37635996E-03_JPRB, 0.37662457E-03_JPRB, 0.37687648E-03_JPRB, &
  & 0.37715442E-03_JPRB, 0.37741129E-03_JPRB, 0.37765034E-03_JPRB, 0.37790578E-03_JPRB, 0.37808387E-03_JPRB, 0.37830400E-03_JPRB, &
  & 0.37863557E-03_JPRB, 0.37904325E-03_JPRB, 0.37952512E-03_JPRB, 0.38006068E-03_JPRB, 0.38060084E-03_JPRB, 0.38135742E-03_JPRB, &
  & 0.38217491E-03_JPRB, 0.38292042E-03_JPRB, 0.38353952E-03_JPRB, 0.38400977E-03_JPRB, 0.38438688E-03_JPRB, 0.38469962E-03_JPRB, &
  & 0.38495278E-03_JPRB, 0.38510392E-03_JPRB, 0.38508989E-03_JPRB, 0.38486370E-03_JPRB, 0.38450911E-03_JPRB, 0.38409744E-03_JPRB, &
  & 0.38365839E-03_JPRB, 0.38321078E-03_JPRB, 0.38278101E-03_JPRB, 0.38240942E-03_JPRB, 0.38208521E-03_JPRB, 0.38176822E-03_JPRB, &
  & 0.38145222E-03_JPRB, 0.38109960E-03_JPRB, 0.38072082E-03_JPRB, 0.38033380E-03_JPRB, 0.37995281E-03_JPRB, 0.37961582E-03_JPRB, &
  & 0.37933799E-03_JPRB, 0.37905839E-03_JPRB, 0.37876194E-03_JPRB, 0.37846070E-03_JPRB, 0.37820019E-03_JPRB, 0.37804612E-03_JPRB, &
  & 0.37783829E-03_JPRB, 0.37757672E-03_JPRB, 0.37732365E-03_JPRB, 0.37717879E-03_JPRB, 0.37707063E-03_JPRB, 0.37701308E-03_JPRB, &
  & 0.37683854E-03_JPRB, 0.37678268E-03_JPRB, 0.37683451E-03_JPRB, 0.37684664E-03_JPRB  /)

RGHG1(:,34, 4) = (/ &
  & 0.37513174E-03_JPRB, 0.37510656E-03_JPRB, 0.37505059E-03_JPRB, 0.37507178E-03_JPRB, 0.37527422E-03_JPRB, 0.37561305E-03_JPRB, &
  & 0.37599575E-03_JPRB, 0.37633969E-03_JPRB, 0.37664043E-03_JPRB, 0.37691362E-03_JPRB, 0.37720120E-03_JPRB, 0.37747400E-03_JPRB, &
  & 0.37777083E-03_JPRB, 0.37803883E-03_JPRB, 0.37830399E-03_JPRB, 0.37858900E-03_JPRB, 0.37879468E-03_JPRB, 0.37902730E-03_JPRB, &
  & 0.37936632E-03_JPRB, 0.37979395E-03_JPRB, 0.38027931E-03_JPRB, 0.38080438E-03_JPRB, 0.38127338E-03_JPRB, 0.38185828E-03_JPRB, &
  & 0.38251206E-03_JPRB, 0.38316530E-03_JPRB, 0.38375222E-03_JPRB, 0.38423389E-03_JPRB, 0.38464250E-03_JPRB, 0.38500291E-03_JPRB, &
  & 0.38532055E-03_JPRB, 0.38553555E-03_JPRB, 0.38556506E-03_JPRB, 0.38533771E-03_JPRB, 0.38496452E-03_JPRB, 0.38453719E-03_JPRB, &
  & 0.38410001E-03_JPRB, 0.38368284E-03_JPRB, 0.38329976E-03_JPRB, 0.38297108E-03_JPRB, 0.38266497E-03_JPRB, 0.38235925E-03_JPRB, &
  & 0.38204310E-03_JPRB, 0.38167888E-03_JPRB, 0.38128174E-03_JPRB, 0.38086559E-03_JPRB, 0.38046600E-03_JPRB, 0.38011060E-03_JPRB, &
  & 0.37980893E-03_JPRB, 0.37950121E-03_JPRB, 0.37917403E-03_JPRB, 0.37883673E-03_JPRB, 0.37853804E-03_JPRB, 0.37834749E-03_JPRB, &
  & 0.37811851E-03_JPRB, 0.37785871E-03_JPRB, 0.37761500E-03_JPRB, 0.37748838E-03_JPRB, 0.37741879E-03_JPRB, 0.37741071E-03_JPRB, &
  & 0.37726952E-03_JPRB, 0.37724211E-03_JPRB, 0.37732343E-03_JPRB, 0.37732210E-03_JPRB  /)

RGHG1(:,35, 4) = (/ &
  & 0.37553922E-03_JPRB, 0.37551443E-03_JPRB, 0.37550159E-03_JPRB, 0.37554175E-03_JPRB, 0.37577094E-03_JPRB, 0.37614511E-03_JPRB, &
  & 0.37656795E-03_JPRB, 0.37693528E-03_JPRB, 0.37724382E-03_JPRB, 0.37752908E-03_JPRB, 0.37783771E-03_JPRB, 0.37812909E-03_JPRB, &
  & 0.37844138E-03_JPRB, 0.37871679E-03_JPRB, 0.37900195E-03_JPRB, 0.37930736E-03_JPRB, 0.37954292E-03_JPRB, 0.37978034E-03_JPRB, &
  & 0.38010871E-03_JPRB, 0.38054232E-03_JPRB, 0.38102535E-03_JPRB, 0.38155496E-03_JPRB, 0.38200538E-03_JPRB, 0.38243581E-03_JPRB, &
  & 0.38289770E-03_JPRB, 0.38341493E-03_JPRB, 0.38393976E-03_JPRB, 0.38442142E-03_JPRB, 0.38484964E-03_JPRB, 0.38524890E-03_JPRB, &
  & 0.38562825E-03_JPRB, 0.38591159E-03_JPRB, 0.38599839E-03_JPRB, 0.38578519E-03_JPRB, 0.38540967E-03_JPRB, 0.38498156E-03_JPRB, &
  & 0.38455958E-03_JPRB, 0.38418515E-03_JPRB, 0.38384871E-03_JPRB, 0.38354614E-03_JPRB, 0.38324380E-03_JPRB, 0.38294055E-03_JPRB, &
  & 0.38261128E-03_JPRB, 0.38223822E-03_JPRB, 0.38183394E-03_JPRB, 0.38139882E-03_JPRB, 0.38098832E-03_JPRB, 0.38062305E-03_JPRB, &
  & 0.38029657E-03_JPRB, 0.37995753E-03_JPRB, 0.37960021E-03_JPRB, 0.37922381E-03_JPRB, 0.37888459E-03_JPRB, 0.37864921E-03_JPRB, &
  & 0.37839412E-03_JPRB, 0.37814524E-03_JPRB, 0.37792023E-03_JPRB, 0.37781427E-03_JPRB, 0.37778807E-03_JPRB, 0.37784027E-03_JPRB, &
  & 0.37775066E-03_JPRB, 0.37774806E-03_JPRB, 0.37784562E-03_JPRB, 0.37781531E-03_JPRB  /)

RGHG1(:,36, 4) = (/ &
  & 0.37617297E-03_JPRB, 0.37611750E-03_JPRB, 0.37611108E-03_JPRB, 0.37614564E-03_JPRB, 0.37638709E-03_JPRB, 0.37678643E-03_JPRB, &
  & 0.37723760E-03_JPRB, 0.37761710E-03_JPRB, 0.37792092E-03_JPRB, 0.37820584E-03_JPRB, 0.37852205E-03_JPRB, 0.37882676E-03_JPRB, &
  & 0.37914779E-03_JPRB, 0.37942078E-03_JPRB, 0.37970892E-03_JPRB, 0.38001385E-03_JPRB, 0.38026141E-03_JPRB, 0.38049092E-03_JPRB, &
  & 0.38079810E-03_JPRB, 0.38121869E-03_JPRB, 0.38168229E-03_JPRB, 0.38220195E-03_JPRB, 0.38262997E-03_JPRB, 0.38294337E-03_JPRB, &
  & 0.38325150E-03_JPRB, 0.38364366E-03_JPRB, 0.38409512E-03_JPRB, 0.38456222E-03_JPRB, 0.38499599E-03_JPRB, 0.38544028E-03_JPRB, &
  & 0.38589182E-03_JPRB, 0.38624365E-03_JPRB, 0.38638493E-03_JPRB, 0.38620918E-03_JPRB, 0.38584497E-03_JPRB, 0.38540137E-03_JPRB, &
  & 0.38497738E-03_JPRB, 0.38462978E-03_JPRB, 0.38433494E-03_JPRB, 0.38405571E-03_JPRB, 0.38376106E-03_JPRB, 0.38346379E-03_JPRB, &
  & 0.38313098E-03_JPRB, 0.38275910E-03_JPRB, 0.38235445E-03_JPRB, 0.38191423E-03_JPRB, 0.38150040E-03_JPRB, 0.38112693E-03_JPRB, &
  & 0.38078388E-03_JPRB, 0.38042027E-03_JPRB, 0.38003676E-03_JPRB, 0.37962358E-03_JPRB, 0.37924731E-03_JPRB, 0.37897203E-03_JPRB, &
  & 0.37868694E-03_JPRB, 0.37844669E-03_JPRB, 0.37824248E-03_JPRB, 0.37815913E-03_JPRB, 0.37818467E-03_JPRB, 0.37830053E-03_JPRB, &
  & 0.37827253E-03_JPRB, 0.37828905E-03_JPRB, 0.37838497E-03_JPRB, 0.37832740E-03_JPRB  /)

RGHG1(:,37, 4) = (/ &
  & 0.37728609E-03_JPRB, 0.37713059E-03_JPRB, 0.37704605E-03_JPRB, 0.37701902E-03_JPRB, 0.37723870E-03_JPRB, 0.37763834E-03_JPRB, &
  & 0.37808897E-03_JPRB, 0.37845421E-03_JPRB, 0.37872492E-03_JPRB, 0.37898100E-03_JPRB, 0.37927346E-03_JPRB, 0.37957866E-03_JPRB, &
  & 0.37989249E-03_JPRB, 0.38014065E-03_JPRB, 0.38039258E-03_JPRB, 0.38064917E-03_JPRB, 0.38086699E-03_JPRB, 0.38105992E-03_JPRB, &
  & 0.38132309E-03_JPRB, 0.38168792E-03_JPRB, 0.38209413E-03_JPRB, 0.38257121E-03_JPRB, 0.38296943E-03_JPRB, 0.38325890E-03_JPRB, &
  & 0.38351024E-03_JPRB, 0.38381024E-03_JPRB, 0.38416708E-03_JPRB, 0.38458710E-03_JPRB, 0.38499383E-03_JPRB, 0.38549455E-03_JPRB, &
  & 0.38603784E-03_JPRB, 0.38645425E-03_JPRB, 0.38664014E-03_JPRB, 0.38655289E-03_JPRB, 0.38623060E-03_JPRB, 0.38573872E-03_JPRB, &
  & 0.38527342E-03_JPRB, 0.38491449E-03_JPRB, 0.38464711E-03_JPRB, 0.38438341E-03_JPRB, 0.38410495E-03_JPRB, 0.38382135E-03_JPRB, &
  & 0.38350720E-03_JPRB, 0.38315936E-03_JPRB, 0.38276995E-03_JPRB, 0.38235671E-03_JPRB, 0.38195715E-03_JPRB, 0.38157984E-03_JPRB, &
  & 0.38124015E-03_JPRB, 0.38086892E-03_JPRB, 0.38046995E-03_JPRB, 0.38002756E-03_JPRB, 0.37962454E-03_JPRB, 0.37932312E-03_JPRB, &
  & 0.37900097E-03_JPRB, 0.37876360E-03_JPRB, 0.37858368E-03_JPRB, 0.37852605E-03_JPRB, 0.37861923E-03_JPRB, 0.37880256E-03_JPRB, &
  & 0.37885532E-03_JPRB, 0.37887670E-03_JPRB, 0.37893010E-03_JPRB, 0.37885089E-03_JPRB  /)

RGHG1(:,38, 4) = (/ &
  & 0.37852119E-03_JPRB, 0.37825472E-03_JPRB, 0.37808347E-03_JPRB, 0.37798811E-03_JPRB, 0.37818364E-03_JPRB, 0.37858362E-03_JPRB, &
  & 0.37903364E-03_JPRB, 0.37938305E-03_JPRB, 0.37961704E-03_JPRB, 0.37984110E-03_JPRB, 0.38010722E-03_JPRB, 0.38041295E-03_JPRB, &
  & 0.38071880E-03_JPRB, 0.38093941E-03_JPRB, 0.38115115E-03_JPRB, 0.38135412E-03_JPRB, 0.38153894E-03_JPRB, 0.38169128E-03_JPRB, &
  & 0.38190561E-03_JPRB, 0.38220856E-03_JPRB, 0.38255110E-03_JPRB, 0.38298094E-03_JPRB, 0.38334609E-03_JPRB, 0.38360901E-03_JPRB, &
  & 0.38379735E-03_JPRB, 0.38399508E-03_JPRB, 0.38424692E-03_JPRB, 0.38461472E-03_JPRB, 0.38499144E-03_JPRB, 0.38555476E-03_JPRB, &
  & 0.38619985E-03_JPRB, 0.38668792E-03_JPRB, 0.38692331E-03_JPRB, 0.38693428E-03_JPRB, 0.38665849E-03_JPRB, 0.38611305E-03_JPRB, &
  & 0.38560191E-03_JPRB, 0.38523040E-03_JPRB, 0.38499350E-03_JPRB, 0.38474703E-03_JPRB, 0.38448654E-03_JPRB, 0.38421811E-03_JPRB, &
  & 0.38392464E-03_JPRB, 0.38360348E-03_JPRB, 0.38323097E-03_JPRB, 0.38284767E-03_JPRB, 0.38246395E-03_JPRB, 0.38208239E-03_JPRB, &
  & 0.38174642E-03_JPRB, 0.38136674E-03_JPRB, 0.38095060E-03_JPRB, 0.38047581E-03_JPRB, 0.38004312E-03_JPRB, 0.37971269E-03_JPRB, &
  & 0.37934942E-03_JPRB, 0.37911524E-03_JPRB, 0.37896226E-03_JPRB, 0.37893319E-03_JPRB, 0.37910141E-03_JPRB, 0.37935959E-03_JPRB, &
  & 0.37950198E-03_JPRB, 0.37952875E-03_JPRB, 0.37953498E-03_JPRB, 0.37943175E-03_JPRB  /)

RGHG1(:,39, 4) = (/ &
  & 0.37998883E-03_JPRB, 0.37971648E-03_JPRB, 0.37941379E-03_JPRB, 0.37920776E-03_JPRB, 0.37931984E-03_JPRB, 0.37965271E-03_JPRB, &
  & 0.38005553E-03_JPRB, 0.38034130E-03_JPRB, 0.38051289E-03_JPRB, 0.38068418E-03_JPRB, 0.38089764E-03_JPRB, 0.38115391E-03_JPRB, &
  & 0.38142360E-03_JPRB, 0.38159739E-03_JPRB, 0.38174358E-03_JPRB, 0.38187438E-03_JPRB, 0.38198246E-03_JPRB, 0.38207873E-03_JPRB, &
  & 0.38224196E-03_JPRB, 0.38248685E-03_JPRB, 0.38277489E-03_JPRB, 0.38313511E-03_JPRB, 0.38345266E-03_JPRB, 0.38366998E-03_JPRB, &
  & 0.38383171E-03_JPRB, 0.38400645E-03_JPRB, 0.38424410E-03_JPRB, 0.38461604E-03_JPRB, 0.38501675E-03_JPRB, 0.38560319E-03_JPRB, &
  & 0.38627749E-03_JPRB, 0.38681672E-03_JPRB, 0.38707923E-03_JPRB, 0.38715040E-03_JPRB, 0.38695295E-03_JPRB, 0.38643886E-03_JPRB, &
  & 0.38589703E-03_JPRB, 0.38544655E-03_JPRB, 0.38517270E-03_JPRB, 0.38493734E-03_JPRB, 0.38470498E-03_JPRB, 0.38447506E-03_JPRB, &
  & 0.38420361E-03_JPRB, 0.38390792E-03_JPRB, 0.38355657E-03_JPRB, 0.38319588E-03_JPRB, 0.38284655E-03_JPRB, 0.38246800E-03_JPRB, &
  & 0.38214211E-03_JPRB, 0.38177025E-03_JPRB, 0.38135273E-03_JPRB, 0.38088852E-03_JPRB, 0.38043641E-03_JPRB, 0.38008749E-03_JPRB, &
  & 0.37970891E-03_JPRB, 0.37946402E-03_JPRB, 0.37934008E-03_JPRB, 0.37935187E-03_JPRB, 0.37955307E-03_JPRB, 0.37982955E-03_JPRB, &
  & 0.37999070E-03_JPRB, 0.38001640E-03_JPRB, 0.37999777E-03_JPRB, 0.37990270E-03_JPRB  /)

RGHG1(:,40, 4) = (/ &
  & 0.38174927E-03_JPRB, 0.38148722E-03_JPRB, 0.38102295E-03_JPRB, 0.38068010E-03_JPRB, 0.38068455E-03_JPRB, 0.38092763E-03_JPRB, &
  & 0.38126742E-03_JPRB, 0.38147071E-03_JPRB, 0.38156487E-03_JPRB, 0.38167082E-03_JPRB, 0.38181818E-03_JPRB, 0.38200821E-03_JPRB, &
  & 0.38223087E-03_JPRB, 0.38234655E-03_JPRB, 0.38241167E-03_JPRB, 0.38245473E-03_JPRB, 0.38246561E-03_JPRB, 0.38249353E-03_JPRB, &
  & 0.38259641E-03_JPRB, 0.38277379E-03_JPRB, 0.38299937E-03_JPRB, 0.38327423E-03_JPRB, 0.38353355E-03_JPRB, 0.38369424E-03_JPRB, &
  & 0.38383068E-03_JPRB, 0.38399141E-03_JPRB, 0.38422727E-03_JPRB, 0.38461329E-03_JPRB, 0.38505098E-03_JPRB, 0.38565810E-03_JPRB, &
  & 0.38635479E-03_JPRB, 0.38695072E-03_JPRB, 0.38724138E-03_JPRB, 0.38737700E-03_JPRB, 0.38727669E-03_JPRB, 0.38681328E-03_JPRB, &
  & 0.38623792E-03_JPRB, 0.38568390E-03_JPRB, 0.38535565E-03_JPRB, 0.38513232E-03_JPRB, 0.38493465E-03_JPRB, 0.38475375E-03_JPRB, &
  & 0.38450834E-03_JPRB, 0.38424234E-03_JPRB, 0.38391653E-03_JPRB, 0.38358118E-03_JPRB, 0.38327524E-03_JPRB, 0.38290143E-03_JPRB, &
  & 0.38258839E-03_JPRB, 0.38222838E-03_JPRB, 0.38181181E-03_JPRB, 0.38136706E-03_JPRB, 0.38089383E-03_JPRB, 0.38052495E-03_JPRB, &
  & 0.38013260E-03_JPRB, 0.37987287E-03_JPRB, 0.37978336E-03_JPRB, 0.37984513E-03_JPRB, 0.38007813E-03_JPRB, 0.38036683E-03_JPRB, &
  & 0.38053842E-03_JPRB, 0.38056181E-03_JPRB, 0.38051765E-03_JPRB, 0.38043742E-03_JPRB  /)

RGHG1(:,41, 4) = (/ &
  & 0.38390166E-03_JPRB, 0.38365221E-03_JPRB, 0.38299038E-03_JPRB, 0.38248025E-03_JPRB, 0.38235310E-03_JPRB, 0.38248642E-03_JPRB, &
  & 0.38274913E-03_JPRB, 0.38285157E-03_JPRB, 0.38285106E-03_JPRB, 0.38287713E-03_JPRB, 0.38294367E-03_JPRB, 0.38305272E-03_JPRB, &
  & 0.38321787E-03_JPRB, 0.38326251E-03_JPRB, 0.38322849E-03_JPRB, 0.38316429E-03_JPRB, 0.38305632E-03_JPRB, 0.38300069E-03_JPRB, &
  & 0.38302979E-03_JPRB, 0.38312462E-03_JPRB, 0.38327384E-03_JPRB, 0.38344432E-03_JPRB, 0.38363244E-03_JPRB, 0.38372389E-03_JPRB, &
  & 0.38382943E-03_JPRB, 0.38397302E-03_JPRB, 0.38420670E-03_JPRB, 0.38460992E-03_JPRB, 0.38509284E-03_JPRB, 0.38572523E-03_JPRB, &
  & 0.38644930E-03_JPRB, 0.38711456E-03_JPRB, 0.38743964E-03_JPRB, 0.38765404E-03_JPRB, 0.38767250E-03_JPRB, 0.38727107E-03_JPRB, &
  & 0.38665471E-03_JPRB, 0.38597409E-03_JPRB, 0.38557934E-03_JPRB, 0.38537072E-03_JPRB, 0.38521545E-03_JPRB, 0.38509449E-03_JPRB, &
  & 0.38488092E-03_JPRB, 0.38465123E-03_JPRB, 0.38435663E-03_JPRB, 0.38405227E-03_JPRB, 0.38379937E-03_JPRB, 0.38343135E-03_JPRB, &
  & 0.38313404E-03_JPRB, 0.38278850E-03_JPRB, 0.38237311E-03_JPRB, 0.38195214E-03_JPRB, 0.38145309E-03_JPRB, 0.38105980E-03_JPRB, &
  & 0.38065063E-03_JPRB, 0.38037274E-03_JPRB, 0.38032533E-03_JPRB, 0.38044821E-03_JPRB, 0.38072009E-03_JPRB, 0.38102374E-03_JPRB, &
  & 0.38120808E-03_JPRB, 0.38122866E-03_JPRB, 0.38115327E-03_JPRB, 0.38109120E-03_JPRB  /)

RGHG1(:,42, 4) = (/ &
  & 0.38507640E-03_JPRB, 0.38489130E-03_JPRB, 0.38420284E-03_JPRB, 0.38363631E-03_JPRB, 0.38339653E-03_JPRB, 0.38341030E-03_JPRB, &
  & 0.38358611E-03_JPRB, 0.38359339E-03_JPRB, 0.38356435E-03_JPRB, 0.38352877E-03_JPRB, 0.38351067E-03_JPRB, 0.38352510E-03_JPRB, &
  & 0.38360706E-03_JPRB, 0.38358140E-03_JPRB, 0.38347468E-03_JPRB, 0.38333027E-03_JPRB, 0.38314469E-03_JPRB, 0.38305443E-03_JPRB, &
  & 0.38303576E-03_JPRB, 0.38309549E-03_JPRB, 0.38319875E-03_JPRB, 0.38334112E-03_JPRB, 0.38350808E-03_JPRB, 0.38360917E-03_JPRB, &
  & 0.38376523E-03_JPRB, 0.38397256E-03_JPRB, 0.38427333E-03_JPRB, 0.38469855E-03_JPRB, 0.38517385E-03_JPRB, 0.38575558E-03_JPRB, &
  & 0.38642420E-03_JPRB, 0.38706912E-03_JPRB, 0.38741816E-03_JPRB, 0.38766105E-03_JPRB, 0.38770126E-03_JPRB, 0.38739216E-03_JPRB, &
  & 0.38689114E-03_JPRB, 0.38621099E-03_JPRB, 0.38572689E-03_JPRB, 0.38544992E-03_JPRB, 0.38526908E-03_JPRB, 0.38516697E-03_JPRB, &
  & 0.38497790E-03_JPRB, 0.38477558E-03_JPRB, 0.38449215E-03_JPRB, 0.38419001E-03_JPRB, 0.38394586E-03_JPRB, 0.38359972E-03_JPRB, &
  & 0.38330701E-03_JPRB, 0.38298578E-03_JPRB, 0.38260899E-03_JPRB, 0.38223408E-03_JPRB, 0.38174771E-03_JPRB, 0.38134622E-03_JPRB, &
  & 0.38096909E-03_JPRB, 0.38071448E-03_JPRB, 0.38067869E-03_JPRB, 0.38084288E-03_JPRB, 0.38108264E-03_JPRB, 0.38134853E-03_JPRB, &
  & 0.38141334E-03_JPRB, 0.38134736E-03_JPRB, 0.38123434E-03_JPRB, 0.38121006E-03_JPRB  /)

RGHG1(:,43, 4) = (/ &
  & 0.38707407E-03_JPRB, 0.38695311E-03_JPRB, 0.38615536E-03_JPRB, 0.38546543E-03_JPRB, 0.38506627E-03_JPRB, 0.38492376E-03_JPRB, &
  & 0.38498712E-03_JPRB, 0.38486420E-03_JPRB, 0.38476840E-03_JPRB, 0.38464222E-03_JPRB, 0.38451213E-03_JPRB, 0.38440539E-03_JPRB, &
  & 0.38438671E-03_JPRB, 0.38426636E-03_JPRB, 0.38405066E-03_JPRB, 0.38378693E-03_JPRB, 0.38347941E-03_JPRB, 0.38332162E-03_JPRB, &
  & 0.38322762E-03_JPRB, 0.38321982E-03_JPRB, 0.38324829E-03_JPRB, 0.38332013E-03_JPRB, 0.38343715E-03_JPRB, 0.38351725E-03_JPRB, &
  & 0.38370611E-03_JPRB, 0.38396422E-03_JPRB, 0.38432527E-03_JPRB, 0.38477797E-03_JPRB, 0.38526577E-03_JPRB, 0.38581215E-03_JPRB, &
  & 0.38644195E-03_JPRB, 0.38709814E-03_JPRB, 0.38748384E-03_JPRB, 0.38778662E-03_JPRB, 0.38789775E-03_JPRB, 0.38769956E-03_JPRB, &
  & 0.38728613E-03_JPRB, 0.38655197E-03_JPRB, 0.38595773E-03_JPRB, 0.38562473E-03_JPRB, 0.38543879E-03_JPRB, 0.38537967E-03_JPRB, &
  & 0.38522664E-03_JPRB, 0.38506492E-03_JPRB, 0.38480511E-03_JPRB, 0.38451833E-03_JPRB, 0.38430496E-03_JPRB, 0.38398129E-03_JPRB, &
  & 0.38369954E-03_JPRB, 0.38340670E-03_JPRB, 0.38306566E-03_JPRB, 0.38274299E-03_JPRB, 0.38225708E-03_JPRB, 0.38183761E-03_JPRB, &
  & 0.38148247E-03_JPRB, 0.38124129E-03_JPRB, 0.38123421E-03_JPRB, 0.38146238E-03_JPRB, 0.38168957E-03_JPRB, 0.38192744E-03_JPRB, &
  & 0.38188868E-03_JPRB, 0.38174251E-03_JPRB, 0.38158171E-03_JPRB, 0.38159973E-03_JPRB  /)

RGHG1(:,44, 4) = (/ &
  & 0.38798658E-03_JPRB, 0.38781270E-03_JPRB, 0.38696179E-03_JPRB, 0.38624679E-03_JPRB, 0.38584763E-03_JPRB, 0.38561251E-03_JPRB, &
  & 0.38558570E-03_JPRB, 0.38540443E-03_JPRB, 0.38530879E-03_JPRB, 0.38515031E-03_JPRB, 0.38495420E-03_JPRB, 0.38476158E-03_JPRB, &
  & 0.38464338E-03_JPRB, 0.38445256E-03_JPRB, 0.38417409E-03_JPRB, 0.38385713E-03_JPRB, 0.38349818E-03_JPRB, 0.38328818E-03_JPRB, &
  & 0.38316093E-03_JPRB, 0.38313522E-03_JPRB, 0.38312659E-03_JPRB, 0.38319974E-03_JPRB, 0.38332841E-03_JPRB, 0.38345970E-03_JPRB, &
  & 0.38367929E-03_JPRB, 0.38398110E-03_JPRB, 0.38436571E-03_JPRB, 0.38479914E-03_JPRB, 0.38526627E-03_JPRB, 0.38581498E-03_JPRB, &
  & 0.38643227E-03_JPRB, 0.38706859E-03_JPRB, 0.38747469E-03_JPRB, 0.38779177E-03_JPRB, 0.38794688E-03_JPRB, 0.38780885E-03_JPRB, &
  & 0.38744833E-03_JPRB, 0.38672222E-03_JPRB, 0.38611055E-03_JPRB, 0.38573165E-03_JPRB, 0.38553577E-03_JPRB, 0.38544835E-03_JPRB, &
  & 0.38531911E-03_JPRB, 0.38517947E-03_JPRB, 0.38494104E-03_JPRB, 0.38466871E-03_JPRB, 0.38445951E-03_JPRB, 0.38415342E-03_JPRB, &
  & 0.38388920E-03_JPRB, 0.38361595E-03_JPRB, 0.38330697E-03_JPRB, 0.38299187E-03_JPRB, 0.38253583E-03_JPRB, 0.38213351E-03_JPRB, &
  & 0.38182686E-03_JPRB, 0.38159941E-03_JPRB, 0.38161766E-03_JPRB, 0.38182251E-03_JPRB, 0.38204139E-03_JPRB, 0.38228384E-03_JPRB, &
  & 0.38217752E-03_JPRB, 0.38194472E-03_JPRB, 0.38169322E-03_JPRB, 0.38175760E-03_JPRB  /)

RGHG1(:,45, 4) = (/ &
  & 0.38927776E-03_JPRB, 0.38905173E-03_JPRB, 0.38812650E-03_JPRB, 0.38736738E-03_JPRB, 0.38694809E-03_JPRB, 0.38658778E-03_JPRB, &
  & 0.38644411E-03_JPRB, 0.38617997E-03_JPRB, 0.38607608E-03_JPRB, 0.38586939E-03_JPRB, 0.38558397E-03_JPRB, 0.38527828E-03_JPRB, &
  & 0.38503406E-03_JPRB, 0.38475106E-03_JPRB, 0.38438737E-03_JPRB, 0.38399472E-03_JPRB, 0.38356183E-03_JPRB, 0.38328387E-03_JPRB, &
  & 0.38310923E-03_JPRB, 0.38305462E-03_JPRB, 0.38299429E-03_JPRB, 0.38306002E-03_JPRB, 0.38319566E-03_JPRB, 0.38338258E-03_JPRB, &
  & 0.38364130E-03_JPRB, 0.38399927E-03_JPRB, 0.38441831E-03_JPRB, 0.38483327E-03_JPRB, 0.38527846E-03_JPRB, 0.38582535E-03_JPRB, &
  & 0.38642349E-03_JPRB, 0.38703862E-03_JPRB, 0.38747257E-03_JPRB, 0.38781349E-03_JPRB, 0.38802764E-03_JPRB, 0.38797210E-03_JPRB, &
  & 0.38768288E-03_JPRB, 0.38695911E-03_JPRB, 0.38631369E-03_JPRB, 0.38587545E-03_JPRB, 0.38566761E-03_JPRB, 0.38555340E-03_JPRB, &
  & 0.38545579E-03_JPRB, 0.38534643E-03_JPRB, 0.38513532E-03_JPRB, 0.38488139E-03_JPRB, 0.38468081E-03_JPRB, 0.38439758E-03_JPRB, &
  & 0.38415470E-03_JPRB, 0.38390734E-03_JPRB, 0.38363938E-03_JPRB, 0.38333949E-03_JPRB, 0.38291750E-03_JPRB, 0.38253244E-03_JPRB, &
  & 0.38228376E-03_JPRB, 0.38207365E-03_JPRB, 0.38212437E-03_JPRB, 0.38231076E-03_JPRB, 0.38251858E-03_JPRB, 0.38276269E-03_JPRB, &
  & 0.38256639E-03_JPRB, 0.38222482E-03_JPRB, 0.38186404E-03_JPRB, 0.38198655E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART8',0,ZHOOK_HANDLE)



RGHG1(:,46, 4) = (/ &
  & 0.38990329E-03_JPRB, 0.38951996E-03_JPRB, 0.38863250E-03_JPRB, 0.38790589E-03_JPRB, 0.38744555E-03_JPRB, 0.38698170E-03_JPRB, &
  & 0.38673378E-03_JPRB, 0.38643336E-03_JPRB, 0.38633876E-03_JPRB, 0.38610554E-03_JPRB, 0.38577810E-03_JPRB, 0.38540394E-03_JPRB, &
  & 0.38505833E-03_JPRB, 0.38472223E-03_JPRB, 0.38431822E-03_JPRB, 0.38391271E-03_JPRB, 0.38346058E-03_JPRB, 0.38315178E-03_JPRB, &
  & 0.38296217E-03_JPRB, 0.38289588E-03_JPRB, 0.38283757E-03_JPRB, 0.38292978E-03_JPRB, 0.38308892E-03_JPRB, 0.38329809E-03_JPRB, &
  & 0.38358555E-03_JPRB, 0.38398518E-03_JPRB, 0.38442383E-03_JPRB, 0.38484084E-03_JPRB, 0.38526383E-03_JPRB, 0.38581073E-03_JPRB, &
  & 0.38641332E-03_JPRB, 0.38701072E-03_JPRB, 0.38745674E-03_JPRB, 0.38779948E-03_JPRB, 0.38803875E-03_JPRB, 0.38803678E-03_JPRB, &
  & 0.38781391E-03_JPRB, 0.38710855E-03_JPRB, 0.38646129E-03_JPRB, 0.38600258E-03_JPRB, 0.38578046E-03_JPRB, 0.38564688E-03_JPRB, &
  & 0.38555775E-03_JPRB, 0.38548048E-03_JPRB, 0.38529782E-03_JPRB, 0.38505380E-03_JPRB, 0.38485095E-03_JPRB, 0.38457928E-03_JPRB, &
  & 0.38434576E-03_JPRB, 0.38412343E-03_JPRB, 0.38389112E-03_JPRB, 0.38360726E-03_JPRB, 0.38323592E-03_JPRB, 0.38288303E-03_JPRB, &
  & 0.38268098E-03_JPRB, 0.38250736E-03_JPRB, 0.38254371E-03_JPRB, 0.38267653E-03_JPRB, 0.38284319E-03_JPRB, 0.38307672E-03_JPRB, &
  & 0.38286160E-03_JPRB, 0.38250076E-03_JPRB, 0.38210663E-03_JPRB, 0.38228888E-03_JPRB  /)

RGHG1(:,47, 4) = (/ &
  & 0.39050396E-03_JPRB, 0.38991500E-03_JPRB, 0.38909431E-03_JPRB, 0.38842120E-03_JPRB, 0.38790850E-03_JPRB, 0.38732749E-03_JPRB, &
  & 0.38695975E-03_JPRB, 0.38662610E-03_JPRB, 0.38654591E-03_JPRB, 0.38628591E-03_JPRB, 0.38591863E-03_JPRB, 0.38547307E-03_JPRB, &
  & 0.38501341E-03_JPRB, 0.38462282E-03_JPRB, 0.38418050E-03_JPRB, 0.38377248E-03_JPRB, 0.38330874E-03_JPRB, 0.38297118E-03_JPRB, &
  & 0.38277050E-03_JPRB, 0.38269396E-03_JPRB, 0.38264878E-03_JPRB, 0.38277886E-03_JPRB, 0.38296888E-03_JPRB, 0.38319747E-03_JPRB, &
  & 0.38351658E-03_JPRB, 0.38396219E-03_JPRB, 0.38442087E-03_JPRB, 0.38484441E-03_JPRB, 0.38524130E-03_JPRB, 0.38578858E-03_JPRB, &
  & 0.38640110E-03_JPRB, 0.38697840E-03_JPRB, 0.38743542E-03_JPRB, 0.38777588E-03_JPRB, 0.38803784E-03_JPRB, 0.38809293E-03_JPRB, &
  & 0.38794692E-03_JPRB, 0.38726638E-03_JPRB, 0.38662338E-03_JPRB, 0.38614842E-03_JPRB, 0.38590908E-03_JPRB, 0.38575425E-03_JPRB, &
  & 0.38567043E-03_JPRB, 0.38563118E-03_JPRB, 0.38548213E-03_JPRB, 0.38524806E-03_JPRB, 0.38504035E-03_JPRB, 0.38477998E-03_JPRB, &
  & 0.38455504E-03_JPRB, 0.38436193E-03_JPRB, 0.38417036E-03_JPRB, 0.38390547E-03_JPRB, 0.38359688E-03_JPRB, 0.38328475E-03_JPRB, &
  & 0.38313513E-03_JPRB, 0.38300817E-03_JPRB, 0.38301827E-03_JPRB, 0.38308120E-03_JPRB, 0.38319353E-03_JPRB, 0.38341219E-03_JPRB, &
  & 0.38318925E-03_JPRB, 0.38282370E-03_JPRB, 0.38240568E-03_JPRB, 0.38265834E-03_JPRB  /)

RGHG1(:,48, 4) = (/ &
  & 0.39059084E-03_JPRB, 0.38995370E-03_JPRB, 0.38921776E-03_JPRB, 0.38863993E-03_JPRB, 0.38798387E-03_JPRB, 0.38729432E-03_JPRB, &
  & 0.38677689E-03_JPRB, 0.38642170E-03_JPRB, 0.38636356E-03_JPRB, 0.38612951E-03_JPRB, 0.38575119E-03_JPRB, 0.38529361E-03_JPRB, &
  & 0.38478900E-03_JPRB, 0.38438564E-03_JPRB, 0.38395410E-03_JPRB, 0.38356405E-03_JPRB, 0.38311433E-03_JPRB, 0.38277987E-03_JPRB, &
  & 0.38256813E-03_JPRB, 0.38249625E-03_JPRB, 0.38248046E-03_JPRB, 0.38263751E-03_JPRB, 0.38285367E-03_JPRB, 0.38310332E-03_JPRB, &
  & 0.38344485E-03_JPRB, 0.38394572E-03_JPRB, 0.38441492E-03_JPRB, 0.38484246E-03_JPRB, 0.38522312E-03_JPRB, 0.38575665E-03_JPRB, &
  & 0.38637745E-03_JPRB, 0.38694356E-03_JPRB, 0.38741809E-03_JPRB, 0.38773965E-03_JPRB, 0.38800108E-03_JPRB, 0.38809736E-03_JPRB, &
  & 0.38800678E-03_JPRB, 0.38735908E-03_JPRB, 0.38673377E-03_JPRB, 0.38626202E-03_JPRB, 0.38601656E-03_JPRB, 0.38586163E-03_JPRB, &
  & 0.38579352E-03_JPRB, 0.38579395E-03_JPRB, 0.38567393E-03_JPRB, 0.38546040E-03_JPRB, 0.38525147E-03_JPRB, 0.38499859E-03_JPRB, &
  & 0.38479020E-03_JPRB, 0.38462010E-03_JPRB, 0.38447125E-03_JPRB, 0.38423840E-03_JPRB, 0.38396753E-03_JPRB, 0.38367692E-03_JPRB, &
  & 0.38354461E-03_JPRB, 0.38346070E-03_JPRB, 0.38342616E-03_JPRB, 0.38341685E-03_JPRB, 0.38345673E-03_JPRB, 0.38364354E-03_JPRB, &
  & 0.38350518E-03_JPRB, 0.38315207E-03_JPRB, 0.38280078E-03_JPRB, 0.38312150E-03_JPRB  /)

RGHG1(:,49, 4) = (/ &
  & 0.39045347E-03_JPRB, 0.38983454E-03_JPRB, 0.38920063E-03_JPRB, 0.38874733E-03_JPRB, 0.38789111E-03_JPRB, 0.38708530E-03_JPRB, &
  & 0.38638851E-03_JPRB, 0.38601479E-03_JPRB, 0.38598453E-03_JPRB, 0.38580320E-03_JPRB, 0.38542574E-03_JPRB, 0.38498187E-03_JPRB, &
  & 0.38445887E-03_JPRB, 0.38406035E-03_JPRB, 0.38366307E-03_JPRB, 0.38330223E-03_JPRB, 0.38287969E-03_JPRB, 0.38256314E-03_JPRB, &
  & 0.38233917E-03_JPRB, 0.38227920E-03_JPRB, 0.38230336E-03_JPRB, 0.38248534E-03_JPRB, 0.38272829E-03_JPRB, 0.38300201E-03_JPRB, &
  & 0.38336417E-03_JPRB, 0.38393046E-03_JPRB, 0.38440698E-03_JPRB, 0.38483778E-03_JPRB, 0.38520497E-03_JPRB, 0.38571686E-03_JPRB, &
  & 0.38634607E-03_JPRB, 0.38690384E-03_JPRB, 0.38740072E-03_JPRB, 0.38769378E-03_JPRB, 0.38794408E-03_JPRB, 0.38807875E-03_JPRB, &
  & 0.38803980E-03_JPRB, 0.38743213E-03_JPRB, 0.38683252E-03_JPRB, 0.38637315E-03_JPRB, 0.38612598E-03_JPRB, 0.38598055E-03_JPRB, &
  & 0.38593455E-03_JPRB, 0.38597968E-03_JPRB, 0.38588973E-03_JPRB, 0.38570376E-03_JPRB, 0.38549515E-03_JPRB, 0.38524881E-03_JPRB, &
  & 0.38506238E-03_JPRB, 0.38491494E-03_JPRB, 0.38481430E-03_JPRB, 0.38462288E-03_JPRB, 0.38438238E-03_JPRB, 0.38410688E-03_JPRB, &
  & 0.38397776E-03_JPRB, 0.38393988E-03_JPRB, 0.38384755E-03_JPRB, 0.38375717E-03_JPRB, 0.38370859E-03_JPRB, 0.38385241E-03_JPRB, &
  & 0.38384971E-03_JPRB, 0.38351817E-03_JPRB, 0.38328198E-03_JPRB, 0.38367700E-03_JPRB  /)

RGHG1(:,50, 4) = (/ &
  & 0.38996000E-03_JPRB, 0.38936571E-03_JPRB, 0.38884710E-03_JPRB, 0.38849678E-03_JPRB, 0.38750557E-03_JPRB, 0.38657863E-03_JPRB, &
  & 0.38579752E-03_JPRB, 0.38539223E-03_JPRB, 0.38536622E-03_JPRB, 0.38525979E-03_JPRB, 0.38493434E-03_JPRB, 0.38455088E-03_JPRB, &
  & 0.38407648E-03_JPRB, 0.38371066E-03_JPRB, 0.38335319E-03_JPRB, 0.38302826E-03_JPRB, 0.38266295E-03_JPRB, 0.38237362E-03_JPRB, &
  & 0.38215284E-03_JPRB, 0.38210072E-03_JPRB, 0.38214847E-03_JPRB, 0.38233865E-03_JPRB, 0.38260235E-03_JPRB, 0.38291431E-03_JPRB, &
  & 0.38329592E-03_JPRB, 0.38389247E-03_JPRB, 0.38438616E-03_JPRB, 0.38482178E-03_JPRB, 0.38518952E-03_JPRB, 0.38568289E-03_JPRB, &
  & 0.38630964E-03_JPRB, 0.38687603E-03_JPRB, 0.38738178E-03_JPRB, 0.38765094E-03_JPRB, 0.38788808E-03_JPRB, 0.38804502E-03_JPRB, &
  & 0.38801977E-03_JPRB, 0.38742798E-03_JPRB, 0.38687185E-03_JPRB, 0.38643758E-03_JPRB, 0.38622235E-03_JPRB, 0.38609288E-03_JPRB, &
  & 0.38607082E-03_JPRB, 0.38615360E-03_JPRB, 0.38609337E-03_JPRB, 0.38594112E-03_JPRB, 0.38574987E-03_JPRB, 0.38553471E-03_JPRB, &
  & 0.38537632E-03_JPRB, 0.38525603E-03_JPRB, 0.38519555E-03_JPRB, 0.38504299E-03_JPRB, 0.38480311E-03_JPRB, 0.38452805E-03_JPRB, &
  & 0.38437396E-03_JPRB, 0.38434754E-03_JPRB, 0.38418580E-03_JPRB, 0.38402315E-03_JPRB, 0.38392220E-03_JPRB, 0.38403035E-03_JPRB, &
  & 0.38411954E-03_JPRB, 0.38386334E-03_JPRB, 0.38373398E-03_JPRB, 0.38416215E-03_JPRB  /)

RGHG1(:,51, 4) = (/ &
  & 0.38923907E-03_JPRB, 0.38867480E-03_JPRB, 0.38828790E-03_JPRB, 0.38803764E-03_JPRB, 0.38693465E-03_JPRB, 0.38587413E-03_JPRB, &
  & 0.38505178E-03_JPRB, 0.38460548E-03_JPRB, 0.38457167E-03_JPRB, 0.38455790E-03_JPRB, 0.38431558E-03_JPRB, 0.38402201E-03_JPRB, &
  & 0.38363540E-03_JPRB, 0.38331961E-03_JPRB, 0.38300810E-03_JPRB, 0.38272556E-03_JPRB, 0.38243794E-03_JPRB, 0.38218293E-03_JPRB, &
  & 0.38197370E-03_JPRB, 0.38192793E-03_JPRB, 0.38199260E-03_JPRB, 0.38218286E-03_JPRB, 0.38246585E-03_JPRB, 0.38282661E-03_JPRB, &
  & 0.38322865E-03_JPRB, 0.38383943E-03_JPRB, 0.38435687E-03_JPRB, 0.38479851E-03_JPRB, 0.38517423E-03_JPRB, 0.38564921E-03_JPRB, &
  & 0.38626758E-03_JPRB, 0.38685219E-03_JPRB, 0.38736047E-03_JPRB, 0.38760620E-03_JPRB, 0.38782804E-03_JPRB, 0.38800061E-03_JPRB, &
  & 0.38797023E-03_JPRB, 0.38738291E-03_JPRB, 0.38688315E-03_JPRB, 0.38648273E-03_JPRB, 0.38631973E-03_JPRB, 0.38621092E-03_JPRB, &
  & 0.38621571E-03_JPRB, 0.38633550E-03_JPRB, 0.38630724E-03_JPRB, 0.38619469E-03_JPRB, 0.38603118E-03_JPRB, 0.38586272E-03_JPRB, &
  & 0.38573785E-03_JPRB, 0.38564928E-03_JPRB, 0.38562802E-03_JPRB, 0.38551613E-03_JPRB, 0.38526128E-03_JPRB, 0.38497898E-03_JPRB, &
  & 0.38478307E-03_JPRB, 0.38475088E-03_JPRB, 0.38450795E-03_JPRB, 0.38427176E-03_JPRB, 0.38413314E-03_JPRB, 0.38420655E-03_JPRB, &
  & 0.38437214E-03_JPRB, 0.38422568E-03_JPRB, 0.38420752E-03_JPRB, 0.38464993E-03_JPRB  /)

RGHG1(:,52, 4) = (/ &
  & 0.38814008E-03_JPRB, 0.38765605E-03_JPRB, 0.38739918E-03_JPRB, 0.38726358E-03_JPRB, 0.38624768E-03_JPRB, 0.38513562E-03_JPRB, &
  & 0.38431561E-03_JPRB, 0.38385878E-03_JPRB, 0.38383342E-03_JPRB, 0.38387663E-03_JPRB, 0.38371095E-03_JPRB, 0.38350189E-03_JPRB, &
  & 0.38320617E-03_JPRB, 0.38295115E-03_JPRB, 0.38269352E-03_JPRB, 0.38246415E-03_JPRB, 0.38223899E-03_JPRB, 0.38201467E-03_JPRB, &
  & 0.38183374E-03_JPRB, 0.38179125E-03_JPRB, 0.38186104E-03_JPRB, 0.38204689E-03_JPRB, 0.38233328E-03_JPRB, 0.38272438E-03_JPRB, &
  & 0.38315161E-03_JPRB, 0.38376937E-03_JPRB, 0.38430839E-03_JPRB, 0.38475656E-03_JPRB, 0.38513884E-03_JPRB, 0.38560389E-03_JPRB, &
  & 0.38623009E-03_JPRB, 0.38683216E-03_JPRB, 0.38733335E-03_JPRB, 0.38756306E-03_JPRB, 0.38777911E-03_JPRB, 0.38795255E-03_JPRB, &
  & 0.38789835E-03_JPRB, 0.38728418E-03_JPRB, 0.38684265E-03_JPRB, 0.38649627E-03_JPRB, 0.38637788E-03_JPRB, 0.38629725E-03_JPRB, &
  & 0.38633496E-03_JPRB, 0.38647199E-03_JPRB, 0.38646495E-03_JPRB, 0.38639993E-03_JPRB, 0.38629340E-03_JPRB, 0.38618781E-03_JPRB, &
  & 0.38610966E-03_JPRB, 0.38606323E-03_JPRB, 0.38607660E-03_JPRB, 0.38599223E-03_JPRB, 0.38573831E-03_JPRB, 0.38545755E-03_JPRB, &
  & 0.38521595E-03_JPRB, 0.38513577E-03_JPRB, 0.38483932E-03_JPRB, 0.38455253E-03_JPRB, 0.38436971E-03_JPRB, 0.38443749E-03_JPRB, &
  & 0.38461702E-03_JPRB, 0.38459946E-03_JPRB, 0.38467382E-03_JPRB, 0.38506473E-03_JPRB  /)

RGHG1(:,53, 4) = (/ &
  & 0.38679785E-03_JPRB, 0.38642053E-03_JPRB, 0.38630460E-03_JPRB, 0.38629949E-03_JPRB, 0.38545493E-03_JPRB, 0.38431832E-03_JPRB, &
  & 0.38351762E-03_JPRB, 0.38306105E-03_JPRB, 0.38305114E-03_JPRB, 0.38314268E-03_JPRB, 0.38305794E-03_JPRB, 0.38293886E-03_JPRB, &
  & 0.38274331E-03_JPRB, 0.38255859E-03_JPRB, 0.38236268E-03_JPRB, 0.38219538E-03_JPRB, 0.38203237E-03_JPRB, 0.38184007E-03_JPRB, &
  & 0.38169639E-03_JPRB, 0.38165631E-03_JPRB, 0.38172713E-03_JPRB, 0.38190646E-03_JPRB, 0.38219044E-03_JPRB, 0.38260747E-03_JPRB, &
  & 0.38306397E-03_JPRB, 0.38368653E-03_JPRB, 0.38424822E-03_JPRB, 0.38470368E-03_JPRB, 0.38509257E-03_JPRB, 0.38555007E-03_JPRB, &
  & 0.38619104E-03_JPRB, 0.38681182E-03_JPRB, 0.38730159E-03_JPRB, 0.38751671E-03_JPRB, 0.38773009E-03_JPRB, 0.38789881E-03_JPRB, &
  & 0.38781148E-03_JPRB, 0.38715602E-03_JPRB, 0.38677861E-03_JPRB, 0.38649884E-03_JPRB, 0.38642613E-03_JPRB, 0.38637905E-03_JPRB, &
  & 0.38645497E-03_JPRB, 0.38660316E-03_JPRB, 0.38661509E-03_JPRB, 0.38660483E-03_JPRB, 0.38657162E-03_JPRB, 0.38654071E-03_JPRB, &
  & 0.38651853E-03_JPRB, 0.38652197E-03_JPRB, 0.38657131E-03_JPRB, 0.38651183E-03_JPRB, 0.38626503E-03_JPRB, 0.38598934E-03_JPRB, &
  & 0.38569650E-03_JPRB, 0.38554781E-03_JPRB, 0.38520372E-03_JPRB, 0.38487066E-03_JPRB, 0.38463720E-03_JPRB, 0.38471004E-03_JPRB, &
  & 0.38488073E-03_JPRB, 0.38501090E-03_JPRB, 0.38517883E-03_JPRB, 0.38548836E-03_JPRB  /)

RGHG1(:,54, 4) = (/ &
  & 0.38552814E-03_JPRB, 0.38537733E-03_JPRB, 0.38534560E-03_JPRB, 0.38541055E-03_JPRB, 0.38474175E-03_JPRB, 0.38373614E-03_JPRB, &
  & 0.38298174E-03_JPRB, 0.38258245E-03_JPRB, 0.38259270E-03_JPRB, 0.38268275E-03_JPRB, 0.38263476E-03_JPRB, 0.38254896E-03_JPRB, &
  & 0.38240109E-03_JPRB, 0.38227366E-03_JPRB, 0.38213376E-03_JPRB, 0.38199885E-03_JPRB, 0.38186852E-03_JPRB, 0.38170115E-03_JPRB, &
  & 0.38158333E-03_JPRB, 0.38155159E-03_JPRB, 0.38162678E-03_JPRB, 0.38179108E-03_JPRB, 0.38207533E-03_JPRB, 0.38249319E-03_JPRB, &
  & 0.38294949E-03_JPRB, 0.38356978E-03_JPRB, 0.38416194E-03_JPRB, 0.38462479E-03_JPRB, 0.38501042E-03_JPRB, 0.38549409E-03_JPRB, &
  & 0.38616580E-03_JPRB, 0.38679371E-03_JPRB, 0.38726566E-03_JPRB, 0.38749363E-03_JPRB, 0.38770145E-03_JPRB, 0.38783358E-03_JPRB, &
  & 0.38765674E-03_JPRB, 0.38700829E-03_JPRB, 0.38668605E-03_JPRB, 0.38648611E-03_JPRB, 0.38644514E-03_JPRB, 0.38642919E-03_JPRB, &
  & 0.38652643E-03_JPRB, 0.38667830E-03_JPRB, 0.38671253E-03_JPRB, 0.38676012E-03_JPRB, 0.38680972E-03_JPRB, 0.38684120E-03_JPRB, &
  & 0.38688390E-03_JPRB, 0.38692622E-03_JPRB, 0.38701194E-03_JPRB, 0.38698259E-03_JPRB, 0.38679373E-03_JPRB, 0.38654775E-03_JPRB, &
  & 0.38623499E-03_JPRB, 0.38603478E-03_JPRB, 0.38565492E-03_JPRB, 0.38526918E-03_JPRB, 0.38502056E-03_JPRB, 0.38504066E-03_JPRB, &
  & 0.38525047E-03_JPRB, 0.38551038E-03_JPRB, 0.38574278E-03_JPRB, 0.38594842E-03_JPRB  /)

RGHG1(:,55, 4) = (/ &
  & 0.38413114E-03_JPRB, 0.38424702E-03_JPRB, 0.38430109E-03_JPRB, 0.38443572E-03_JPRB, 0.38396219E-03_JPRB, 0.38312217E-03_JPRB, &
  & 0.38242260E-03_JPRB, 0.38209426E-03_JPRB, 0.38212746E-03_JPRB, 0.38220932E-03_JPRB, 0.38219621E-03_JPRB, 0.38213983E-03_JPRB, &
  & 0.38203786E-03_JPRB, 0.38197218E-03_JPRB, 0.38189358E-03_JPRB, 0.38179064E-03_JPRB, 0.38169264E-03_JPRB, 0.38155196E-03_JPRB, &
  & 0.38146129E-03_JPRB, 0.38143956E-03_JPRB, 0.38152003E-03_JPRB, 0.38166658E-03_JPRB, 0.38195146E-03_JPRB, 0.38236696E-03_JPRB, &
  & 0.38281916E-03_JPRB, 0.38343598E-03_JPRB, 0.38406294E-03_JPRB, 0.38453399E-03_JPRB, 0.38491469E-03_JPRB, 0.38543179E-03_JPRB, &
  & 0.38613966E-03_JPRB, 0.38677395E-03_JPRB, 0.38722531E-03_JPRB, 0.38747114E-03_JPRB, 0.38767239E-03_JPRB, 0.38775980E-03_JPRB, &
  & 0.38747640E-03_JPRB, 0.38684207E-03_JPRB, 0.38657976E-03_JPRB, 0.38646999E-03_JPRB, 0.38646235E-03_JPRB, 0.38648056E-03_JPRB, &
  & 0.38659920E-03_JPRB, 0.38675417E-03_JPRB, 0.38681354E-03_JPRB, 0.38692561E-03_JPRB, 0.38706821E-03_JPRB, 0.38716718E-03_JPRB, &
  & 0.38728293E-03_JPRB, 0.38736687E-03_JPRB, 0.38749294E-03_JPRB, 0.38749765E-03_JPRB, 0.38737965E-03_JPRB, 0.38716983E-03_JPRB, &
  & 0.38683912E-03_JPRB, 0.38658409E-03_JPRB, 0.38616615E-03_JPRB, 0.38572121E-03_JPRB, 0.38546048E-03_JPRB, 0.38541455E-03_JPRB, &
  & 0.38567399E-03_JPRB, 0.38607526E-03_JPRB, 0.38637524E-03_JPRB, 0.38646284E-03_JPRB  /)

RGHG1(:,56, 4) = (/ &
  & 0.38342813E-03_JPRB, 0.38372335E-03_JPRB, 0.38379374E-03_JPRB, 0.38386697E-03_JPRB, 0.38350830E-03_JPRB, 0.38287037E-03_JPRB, &
  & 0.38224553E-03_JPRB, 0.38196930E-03_JPRB, 0.38200527E-03_JPRB, 0.38207192E-03_JPRB, 0.38205280E-03_JPRB, 0.38197777E-03_JPRB, &
  & 0.38187522E-03_JPRB, 0.38182615E-03_JPRB, 0.38176848E-03_JPRB, 0.38167827E-03_JPRB, 0.38158421E-03_JPRB, 0.38145255E-03_JPRB, &
  & 0.38136189E-03_JPRB, 0.38133336E-03_JPRB, 0.38141707E-03_JPRB, 0.38156427E-03_JPRB, 0.38185900E-03_JPRB, 0.38224669E-03_JPRB, &
  & 0.38266440E-03_JPRB, 0.38325744E-03_JPRB, 0.38391321E-03_JPRB, 0.38441153E-03_JPRB, 0.38482474E-03_JPRB, 0.38539338E-03_JPRB, &
  & 0.38612328E-03_JPRB, 0.38677369E-03_JPRB, 0.38718961E-03_JPRB, 0.38746471E-03_JPRB, 0.38764335E-03_JPRB, 0.38762900E-03_JPRB, &
  & 0.38728170E-03_JPRB, 0.38672533E-03_JPRB, 0.38651777E-03_JPRB, 0.38645382E-03_JPRB, 0.38646224E-03_JPRB, 0.38650059E-03_JPRB, &
  & 0.38662026E-03_JPRB, 0.38677902E-03_JPRB, 0.38687123E-03_JPRB, 0.38703515E-03_JPRB, 0.38724557E-03_JPRB, 0.38739066E-03_JPRB, &
  & 0.38755505E-03_JPRB, 0.38767434E-03_JPRB, 0.38783893E-03_JPRB, 0.38790444E-03_JPRB, 0.38783680E-03_JPRB, 0.38767945E-03_JPRB, &
  & 0.38738735E-03_JPRB, 0.38714247E-03_JPRB, 0.38670906E-03_JPRB, 0.38627647E-03_JPRB, 0.38609086E-03_JPRB, 0.38601554E-03_JPRB, &
  & 0.38631633E-03_JPRB, 0.38675304E-03_JPRB, 0.38703856E-03_JPRB, 0.38705232E-03_JPRB  /)

RGHG1(:,57, 4) = (/ &
  & 0.38281825E-03_JPRB, 0.38323881E-03_JPRB, 0.38330867E-03_JPRB, 0.38334660E-03_JPRB, 0.38309573E-03_JPRB, 0.38263724E-03_JPRB, &
  & 0.38208864E-03_JPRB, 0.38185649E-03_JPRB, 0.38188480E-03_JPRB, 0.38193967E-03_JPRB, 0.38191746E-03_JPRB, 0.38183001E-03_JPRB, &
  & 0.38172727E-03_JPRB, 0.38168947E-03_JPRB, 0.38164768E-03_JPRB, 0.38157007E-03_JPRB, 0.38147839E-03_JPRB, 0.38135111E-03_JPRB, &
  & 0.38126111E-03_JPRB, 0.38122537E-03_JPRB, 0.38130878E-03_JPRB, 0.38145241E-03_JPRB, 0.38175512E-03_JPRB, 0.38211830E-03_JPRB, &
  & 0.38250296E-03_JPRB, 0.38306807E-03_JPRB, 0.38374355E-03_JPRB, 0.38427240E-03_JPRB, 0.38472343E-03_JPRB, 0.38534744E-03_JPRB, &
  & 0.38610400E-03_JPRB, 0.38676589E-03_JPRB, 0.38715623E-03_JPRB, 0.38745667E-03_JPRB, 0.38760175E-03_JPRB, 0.38748204E-03_JPRB, &
  & 0.38709414E-03_JPRB, 0.38662256E-03_JPRB, 0.38646336E-03_JPRB, 0.38644418E-03_JPRB, 0.38646433E-03_JPRB, 0.38651824E-03_JPRB, &
  & 0.38664149E-03_JPRB, 0.38680313E-03_JPRB, 0.38693043E-03_JPRB, 0.38715086E-03_JPRB, 0.38742485E-03_JPRB, 0.38761678E-03_JPRB, &
  & 0.38782948E-03_JPRB, 0.38798639E-03_JPRB, 0.38818983E-03_JPRB, 0.38831631E-03_JPRB, 0.38830156E-03_JPRB, 0.38819390E-03_JPRB, &
  & 0.38795122E-03_JPRB, 0.38772553E-03_JPRB, 0.38728790E-03_JPRB, 0.38689155E-03_JPRB, 0.38676711E-03_JPRB, 0.38667764E-03_JPRB, &
  & 0.38700707E-03_JPRB, 0.38745636E-03_JPRB, 0.38769908E-03_JPRB, 0.38764543E-03_JPRB  /)

RGHG1(:,58, 4) = (/ &
  & 0.38254484E-03_JPRB, 0.38297306E-03_JPRB, 0.38300094E-03_JPRB, 0.38302592E-03_JPRB, 0.38284719E-03_JPRB, 0.38252228E-03_JPRB, &
  & 0.38205007E-03_JPRB, 0.38184136E-03_JPRB, 0.38184122E-03_JPRB, 0.38188975E-03_JPRB, 0.38186197E-03_JPRB, 0.38176459E-03_JPRB, &
  & 0.38165363E-03_JPRB, 0.38160873E-03_JPRB, 0.38156543E-03_JPRB, 0.38149557E-03_JPRB, 0.38139812E-03_JPRB, 0.38126376E-03_JPRB, &
  & 0.38117035E-03_JPRB, 0.38112412E-03_JPRB, 0.38120091E-03_JPRB, 0.38133754E-03_JPRB, 0.38164621E-03_JPRB, 0.38198764E-03_JPRB, &
  & 0.38233865E-03_JPRB, 0.38286727E-03_JPRB, 0.38354435E-03_JPRB, 0.38411036E-03_JPRB, 0.38461216E-03_JPRB, 0.38529696E-03_JPRB, &
  & 0.38608320E-03_JPRB, 0.38674963E-03_JPRB, 0.38713033E-03_JPRB, 0.38744958E-03_JPRB, 0.38754228E-03_JPRB, 0.38730894E-03_JPRB, &
  & 0.38693106E-03_JPRB, 0.38656092E-03_JPRB, 0.38643443E-03_JPRB, 0.38644636E-03_JPRB, 0.38646669E-03_JPRB, 0.38652458E-03_JPRB, &
  & 0.38665161E-03_JPRB, 0.38681447E-03_JPRB, 0.38697931E-03_JPRB, 0.38725722E-03_JPRB, 0.38757772E-03_JPRB, 0.38780992E-03_JPRB, &
  & 0.38806196E-03_JPRB, 0.38825612E-03_JPRB, 0.38849548E-03_JPRB, 0.38868331E-03_JPRB, 0.38871764E-03_JPRB, 0.38865403E-03_JPRB, &
  & 0.38848565E-03_JPRB, 0.38830506E-03_JPRB, 0.38788682E-03_JPRB, 0.38757753E-03_JPRB, 0.38750217E-03_JPRB, 0.38743226E-03_JPRB, &
  & 0.38776500E-03_JPRB, 0.38816740E-03_JPRB, 0.38830754E-03_JPRB, 0.38821107E-03_JPRB  /)

RGHG1(:,59, 4) = (/ &
  & 0.38247648E-03_JPRB, 0.38284194E-03_JPRB, 0.38283645E-03_JPRB, 0.38287260E-03_JPRB, 0.38273871E-03_JPRB, 0.38249105E-03_JPRB, &
  & 0.38207989E-03_JPRB, 0.38188276E-03_JPRB, 0.38184681E-03_JPRB, 0.38188012E-03_JPRB, 0.38185181E-03_JPRB, 0.38175025E-03_JPRB, &
  & 0.38163491E-03_JPRB, 0.38157293E-03_JPRB, 0.38151767E-03_JPRB, 0.38144099E-03_JPRB, 0.38133491E-03_JPRB, 0.38119453E-03_JPRB, &
  & 0.38109408E-03_JPRB, 0.38105240E-03_JPRB, 0.38110810E-03_JPRB, 0.38122289E-03_JPRB, 0.38152322E-03_JPRB, 0.38185524E-03_JPRB, &
  & 0.38219276E-03_JPRB, 0.38268198E-03_JPRB, 0.38333595E-03_JPRB, 0.38394739E-03_JPRB, 0.38451202E-03_JPRB, 0.38524169E-03_JPRB, &
  & 0.38605545E-03_JPRB, 0.38671400E-03_JPRB, 0.38711934E-03_JPRB, 0.38744584E-03_JPRB, 0.38747879E-03_JPRB, 0.38716463E-03_JPRB, &
  & 0.38680520E-03_JPRB, 0.38651966E-03_JPRB, 0.38642148E-03_JPRB, 0.38645524E-03_JPRB, 0.38646813E-03_JPRB, 0.38652373E-03_JPRB, &
  & 0.38665914E-03_JPRB, 0.38682979E-03_JPRB, 0.38703486E-03_JPRB, 0.38736008E-03_JPRB, 0.38771158E-03_JPRB, 0.38797894E-03_JPRB, &
  & 0.38826247E-03_JPRB, 0.38848674E-03_JPRB, 0.38875950E-03_JPRB, 0.38899792E-03_JPRB, 0.38908505E-03_JPRB, 0.38906829E-03_JPRB, &
  & 0.38897918E-03_JPRB, 0.38884671E-03_JPRB, 0.38848517E-03_JPRB, 0.38826089E-03_JPRB, 0.38819107E-03_JPRB, 0.38815479E-03_JPRB, &
  & 0.38847342E-03_JPRB, 0.38879036E-03_JPRB, 0.38884116E-03_JPRB, 0.38873012E-03_JPRB  /)

RGHG1(:,60, 4) = (/ &
  & 0.38248440E-03_JPRB, 0.38276620E-03_JPRB, 0.38273675E-03_JPRB, 0.38279157E-03_JPRB, 0.38269307E-03_JPRB, 0.38249870E-03_JPRB, &
  & 0.38214114E-03_JPRB, 0.38195033E-03_JPRB, 0.38187655E-03_JPRB, 0.38188919E-03_JPRB, 0.38186316E-03_JPRB, 0.38175968E-03_JPRB, &
  & 0.38163961E-03_JPRB, 0.38155656E-03_JPRB, 0.38148578E-03_JPRB, 0.38139497E-03_JPRB, 0.38127960E-03_JPRB, 0.38113366E-03_JPRB, &
  & 0.38102482E-03_JPRB, 0.38099393E-03_JPRB, 0.38102424E-03_JPRB, 0.38111215E-03_JPRB, 0.38139517E-03_JPRB, 0.38172051E-03_JPRB, &
  & 0.38204967E-03_JPRB, 0.38250259E-03_JPRB, 0.38312677E-03_JPRB, 0.38378390E-03_JPRB, 0.38441622E-03_JPRB, 0.38518417E-03_JPRB, &
  & 0.38602538E-03_JPRB, 0.38667430E-03_JPRB, 0.38711919E-03_JPRB, 0.38744357E-03_JPRB, 0.38741712E-03_JPRB, 0.38703964E-03_JPRB, &
  & 0.38669605E-03_JPRB, 0.38648590E-03_JPRB, 0.38641415E-03_JPRB, 0.38646494E-03_JPRB, 0.38647009E-03_JPRB, 0.38652147E-03_JPRB, &
  & 0.38666812E-03_JPRB, 0.38685234E-03_JPRB, 0.38709835E-03_JPRB, 0.38746536E-03_JPRB, 0.38784224E-03_JPRB, 0.38814347E-03_JPRB, &
  & 0.38845641E-03_JPRB, 0.38870901E-03_JPRB, 0.38901651E-03_JPRB, 0.38930116E-03_JPRB, 0.38944560E-03_JPRB, 0.38947933E-03_JPRB, &
  & 0.38947283E-03_JPRB, 0.38939130E-03_JPRB, 0.38910121E-03_JPRB, 0.38895539E-03_JPRB, 0.38887232E-03_JPRB, 0.38888126E-03_JPRB, &
  & 0.38917919E-03_JPRB, 0.38939867E-03_JPRB, 0.38935855E-03_JPRB, 0.38924136E-03_JPRB  /)

RGHG1(:,61, 4) = (/ &
  & 0.38254232E-03_JPRB, 0.38275800E-03_JPRB, 0.38273593E-03_JPRB, 0.38280643E-03_JPRB, 0.38273366E-03_JPRB, 0.38255765E-03_JPRB, &
  & 0.38223412E-03_JPRB, 0.38204218E-03_JPRB, 0.38193774E-03_JPRB, 0.38192209E-03_JPRB, 0.38190293E-03_JPRB, 0.38179986E-03_JPRB, &
  & 0.38166944E-03_JPRB, 0.38156517E-03_JPRB, 0.38148004E-03_JPRB, 0.38136607E-03_JPRB, 0.38124382E-03_JPRB, 0.38109368E-03_JPRB, &
  & 0.38097695E-03_JPRB, 0.38096143E-03_JPRB, 0.38097124E-03_JPRB, 0.38103486E-03_JPRB, 0.38128498E-03_JPRB, 0.38160017E-03_JPRB, &
  & 0.38191764E-03_JPRB, 0.38235652E-03_JPRB, 0.38295968E-03_JPRB, 0.38364572E-03_JPRB, 0.38433944E-03_JPRB, 0.38513282E-03_JPRB, &
  & 0.38599955E-03_JPRB, 0.38664898E-03_JPRB, 0.38714441E-03_JPRB, 0.38744336E-03_JPRB, 0.38737797E-03_JPRB, 0.38697711E-03_JPRB, &
  & 0.38662542E-03_JPRB, 0.38646233E-03_JPRB, 0.38641066E-03_JPRB, 0.38646792E-03_JPRB, 0.38647501E-03_JPRB, 0.38652290E-03_JPRB, &
  & 0.38668483E-03_JPRB, 0.38689580E-03_JPRB, 0.38717564E-03_JPRB, 0.38756796E-03_JPRB, 0.38796299E-03_JPRB, 0.38829385E-03_JPRB, &
  & 0.38863293E-03_JPRB, 0.38891105E-03_JPRB, 0.38925637E-03_JPRB, 0.38957578E-03_JPRB, 0.38978192E-03_JPRB, 0.38986936E-03_JPRB, &
  & 0.38993954E-03_JPRB, 0.38990844E-03_JPRB, 0.38969124E-03_JPRB, 0.38958703E-03_JPRB, 0.38947137E-03_JPRB, 0.38954776E-03_JPRB, &
  & 0.38982355E-03_JPRB, 0.38996123E-03_JPRB, 0.38982158E-03_JPRB, 0.38969762E-03_JPRB  /)

RGHG1(:,62, 4) = (/ &
  & 0.38259821E-03_JPRB, 0.38278908E-03_JPRB, 0.38278062E-03_JPRB, 0.38286313E-03_JPRB, 0.38281668E-03_JPRB, 0.38264359E-03_JPRB, &
  & 0.38233947E-03_JPRB, 0.38213581E-03_JPRB, 0.38201478E-03_JPRB, 0.38197016E-03_JPRB, 0.38195786E-03_JPRB, 0.38185430E-03_JPRB, &
  & 0.38171464E-03_JPRB, 0.38158969E-03_JPRB, 0.38149491E-03_JPRB, 0.38135741E-03_JPRB, 0.38122899E-03_JPRB, 0.38107004E-03_JPRB, &
  & 0.38094736E-03_JPRB, 0.38094065E-03_JPRB, 0.38094038E-03_JPRB, 0.38098933E-03_JPRB, 0.38120937E-03_JPRB, 0.38150748E-03_JPRB, &
  & 0.38180257E-03_JPRB, 0.38222848E-03_JPRB, 0.38283439E-03_JPRB, 0.38354312E-03_JPRB, 0.38427858E-03_JPRB, 0.38509796E-03_JPRB, &
  & 0.38598382E-03_JPRB, 0.38665063E-03_JPRB, 0.38717468E-03_JPRB, 0.38745370E-03_JPRB, 0.38736814E-03_JPRB, 0.38694696E-03_JPRB, &
  & 0.38659466E-03_JPRB, 0.38645447E-03_JPRB, 0.38641230E-03_JPRB, 0.38646871E-03_JPRB, 0.38648016E-03_JPRB, 0.38653296E-03_JPRB, &
  & 0.38671952E-03_JPRB, 0.38696197E-03_JPRB, 0.38726883E-03_JPRB, 0.38767908E-03_JPRB, 0.38809010E-03_JPRB, 0.38844523E-03_JPRB, &
  & 0.38881173E-03_JPRB, 0.38912030E-03_JPRB, 0.38949827E-03_JPRB, 0.38984769E-03_JPRB, 0.39010583E-03_JPRB, 0.39025613E-03_JPRB, &
  & 0.39038995E-03_JPRB, 0.39039920E-03_JPRB, 0.39025661E-03_JPRB, 0.39018252E-03_JPRB, 0.39005621E-03_JPRB, 0.39020106E-03_JPRB, &
  & 0.39046288E-03_JPRB, 0.39053930E-03_JPRB, 0.39025285E-03_JPRB, 0.39011735E-03_JPRB  /)

RGHG1(:,63, 4) = (/ &
  & 0.38265273E-03_JPRB, 0.38284454E-03_JPRB, 0.38285201E-03_JPRB, 0.38294320E-03_JPRB, 0.38292262E-03_JPRB, 0.38274568E-03_JPRB, &
  & 0.38245201E-03_JPRB, 0.38223257E-03_JPRB, 0.38210291E-03_JPRB, 0.38202982E-03_JPRB, 0.38202227E-03_JPRB, 0.38191653E-03_JPRB, &
  & 0.38176998E-03_JPRB, 0.38162597E-03_JPRB, 0.38152371E-03_JPRB, 0.38136397E-03_JPRB, 0.38122902E-03_JPRB, 0.38106000E-03_JPRB, &
  & 0.38093123E-03_JPRB, 0.38092650E-03_JPRB, 0.38092209E-03_JPRB, 0.38096217E-03_JPRB, 0.38115367E-03_JPRB, 0.38142850E-03_JPRB, &
  & 0.38169920E-03_JPRB, 0.38211012E-03_JPRB, 0.38273605E-03_JPRB, 0.38345981E-03_JPRB, 0.38422120E-03_JPRB, 0.38506387E-03_JPRB, &
  & 0.38596781E-03_JPRB, 0.38666337E-03_JPRB, 0.38720718E-03_JPRB, 0.38747247E-03_JPRB, 0.38737038E-03_JPRB, 0.38693197E-03_JPRB, &
  & 0.38658683E-03_JPRB, 0.38644918E-03_JPRB, 0.38641225E-03_JPRB, 0.38646879E-03_JPRB, 0.38648677E-03_JPRB, 0.38655379E-03_JPRB, &
  & 0.38677241E-03_JPRB, 0.38704268E-03_JPRB, 0.38737523E-03_JPRB, 0.38780292E-03_JPRB, 0.38822776E-03_JPRB, 0.38860408E-03_JPRB, &
  & 0.38899881E-03_JPRB, 0.38934272E-03_JPRB, 0.38974932E-03_JPRB, 0.39012449E-03_JPRB, 0.39042963E-03_JPRB, 0.39064605E-03_JPRB, &
  & 0.39083335E-03_JPRB, 0.39087793E-03_JPRB, 0.39080709E-03_JPRB, 0.39076055E-03_JPRB, 0.39064471E-03_JPRB, 0.39084856E-03_JPRB, &
  & 0.39109951E-03_JPRB, 0.39111456E-03_JPRB, 0.39068055E-03_JPRB, 0.39051888E-03_JPRB  /)

RGHG1(:,64, 4) = (/ &
  & 0.38270374E-03_JPRB, 0.38291831E-03_JPRB, 0.38294047E-03_JPRB, 0.38303547E-03_JPRB, 0.38303798E-03_JPRB, 0.38285634E-03_JPRB, &
  & 0.38256535E-03_JPRB, 0.38233145E-03_JPRB, 0.38219899E-03_JPRB, 0.38210045E-03_JPRB, 0.38209223E-03_JPRB, 0.38198111E-03_JPRB, &
  & 0.38183265E-03_JPRB, 0.38167384E-03_JPRB, 0.38156497E-03_JPRB, 0.38138740E-03_JPRB, 0.38124460E-03_JPRB, 0.38106751E-03_JPRB, &
  & 0.38093056E-03_JPRB, 0.38091742E-03_JPRB, 0.38091312E-03_JPRB, 0.38094927E-03_JPRB, 0.38111431E-03_JPRB, 0.38135843E-03_JPRB, &
  & 0.38161164E-03_JPRB, 0.38200205E-03_JPRB, 0.38266587E-03_JPRB, 0.38339131E-03_JPRB, 0.38415841E-03_JPRB, 0.38501611E-03_JPRB, &
  & 0.38594135E-03_JPRB, 0.38667559E-03_JPRB, 0.38723880E-03_JPRB, 0.38750073E-03_JPRB, 0.38737251E-03_JPRB, 0.38692210E-03_JPRB, &
  & 0.38659557E-03_JPRB, 0.38643438E-03_JPRB, 0.38640272E-03_JPRB, 0.38646935E-03_JPRB, 0.38649653E-03_JPRB, 0.38659179E-03_JPRB, &
  & 0.38685010E-03_JPRB, 0.38713316E-03_JPRB, 0.38749407E-03_JPRB, 0.38794485E-03_JPRB, 0.38837979E-03_JPRB, 0.38877426E-03_JPRB, &
  & 0.38919680E-03_JPRB, 0.38958186E-03_JPRB, 0.39001122E-03_JPRB, 0.39040533E-03_JPRB, 0.39075319E-03_JPRB, 0.39103183E-03_JPRB, &
  & 0.39125860E-03_JPRB, 0.39133490E-03_JPRB, 0.39132415E-03_JPRB, 0.39130945E-03_JPRB, 0.39123375E-03_JPRB, 0.39146966E-03_JPRB, &
  & 0.39170951E-03_JPRB, 0.39164429E-03_JPRB, 0.39111510E-03_JPRB, 0.39089670E-03_JPRB  /)

RGHG1(:,65, 4) = (/ &
  & 0.38275722E-03_JPRB, 0.38300297E-03_JPRB, 0.38303482E-03_JPRB, 0.38312906E-03_JPRB, 0.38314191E-03_JPRB, 0.38295907E-03_JPRB, &
  & 0.38267226E-03_JPRB, 0.38243933E-03_JPRB, 0.38229685E-03_JPRB, 0.38218612E-03_JPRB, 0.38217075E-03_JPRB, 0.38204983E-03_JPRB, &
  & 0.38190227E-03_JPRB, 0.38173064E-03_JPRB, 0.38160790E-03_JPRB, 0.38142770E-03_JPRB, 0.38126907E-03_JPRB, 0.38110033E-03_JPRB, &
  & 0.38095545E-03_JPRB, 0.38092663E-03_JPRB, 0.38091504E-03_JPRB, 0.38094526E-03_JPRB, 0.38107800E-03_JPRB, 0.38129972E-03_JPRB, &
  & 0.38154491E-03_JPRB, 0.38191266E-03_JPRB, 0.38259672E-03_JPRB, 0.38332771E-03_JPRB, 0.38409567E-03_JPRB, 0.38496308E-03_JPRB, &
  & 0.38590958E-03_JPRB, 0.38667621E-03_JPRB, 0.38726387E-03_JPRB, 0.38751928E-03_JPRB, 0.38736214E-03_JPRB, 0.38692312E-03_JPRB, &
  & 0.38660366E-03_JPRB, 0.38642353E-03_JPRB, 0.38640209E-03_JPRB, 0.38647555E-03_JPRB, 0.38652180E-03_JPRB, 0.38666578E-03_JPRB, &
  & 0.38695135E-03_JPRB, 0.38724394E-03_JPRB, 0.38763395E-03_JPRB, 0.38810926E-03_JPRB, 0.38854935E-03_JPRB, 0.38896568E-03_JPRB, &
  & 0.38941394E-03_JPRB, 0.38983742E-03_JPRB, 0.39028690E-03_JPRB, 0.39070939E-03_JPRB, 0.39109330E-03_JPRB, 0.39141804E-03_JPRB, &
  & 0.39166580E-03_JPRB, 0.39177459E-03_JPRB, 0.39180019E-03_JPRB, 0.39182946E-03_JPRB, 0.39181862E-03_JPRB, 0.39207933E-03_JPRB, &
  & 0.39227492E-03_JPRB, 0.39214426E-03_JPRB, 0.39155077E-03_JPRB, 0.39125205E-03_JPRB  /)

RGHG1(:,66, 4) = (/ &
  & 0.38281356E-03_JPRB, 0.38308807E-03_JPRB, 0.38312563E-03_JPRB, 0.38321952E-03_JPRB, 0.38323585E-03_JPRB, 0.38305302E-03_JPRB, &
  & 0.38277305E-03_JPRB, 0.38254689E-03_JPRB, 0.38239521E-03_JPRB, 0.38227957E-03_JPRB, 0.38225036E-03_JPRB, 0.38212465E-03_JPRB, &
  & 0.38197599E-03_JPRB, 0.38179337E-03_JPRB, 0.38165372E-03_JPRB, 0.38147373E-03_JPRB, 0.38130034E-03_JPRB, 0.38114488E-03_JPRB, &
  & 0.38099736E-03_JPRB, 0.38094942E-03_JPRB, 0.38092875E-03_JPRB, 0.38095396E-03_JPRB, 0.38105400E-03_JPRB, 0.38125490E-03_JPRB, &
  & 0.38148434E-03_JPRB, 0.38184643E-03_JPRB, 0.38253308E-03_JPRB, 0.38327253E-03_JPRB, 0.38404923E-03_JPRB, 0.38492223E-03_JPRB, &
  & 0.38588316E-03_JPRB, 0.38668198E-03_JPRB, 0.38729485E-03_JPRB, 0.38753773E-03_JPRB, 0.38736522E-03_JPRB, 0.38695116E-03_JPRB, &
  & 0.38663421E-03_JPRB, 0.38644200E-03_JPRB, 0.38642331E-03_JPRB, 0.38649868E-03_JPRB, 0.38657036E-03_JPRB, 0.38676689E-03_JPRB, &
  & 0.38707418E-03_JPRB, 0.38737827E-03_JPRB, 0.38779285E-03_JPRB, 0.38828696E-03_JPRB, 0.38873476E-03_JPRB, 0.38917749E-03_JPRB, &
  & 0.38965165E-03_JPRB, 0.39010755E-03_JPRB, 0.39057983E-03_JPRB, 0.39103083E-03_JPRB, 0.39144993E-03_JPRB, 0.39180559E-03_JPRB, &
  & 0.39206819E-03_JPRB, 0.39221091E-03_JPRB, 0.39226411E-03_JPRB, 0.39234635E-03_JPRB, 0.39239888E-03_JPRB, 0.39268885E-03_JPRB, &
  & 0.39282690E-03_JPRB, 0.39263733E-03_JPRB, 0.39198522E-03_JPRB, 0.39163174E-03_JPRB  /)

RGHG1(:,67, 4) = (/ &
  & 0.38287008E-03_JPRB, 0.38316926E-03_JPRB, 0.38320864E-03_JPRB, 0.38330227E-03_JPRB, 0.38331673E-03_JPRB, 0.38313636E-03_JPRB, &
  & 0.38286638E-03_JPRB, 0.38264996E-03_JPRB, 0.38249200E-03_JPRB, 0.38237640E-03_JPRB, 0.38232870E-03_JPRB, 0.38220479E-03_JPRB, &
  & 0.38205343E-03_JPRB, 0.38186207E-03_JPRB, 0.38170426E-03_JPRB, 0.38152376E-03_JPRB, 0.38134000E-03_JPRB, 0.38119755E-03_JPRB, &
  & 0.38105459E-03_JPRB, 0.38098633E-03_JPRB, 0.38095659E-03_JPRB, 0.38097759E-03_JPRB, 0.38104692E-03_JPRB, 0.38122782E-03_JPRB, &
  & 0.38143514E-03_JPRB, 0.38180715E-03_JPRB, 0.38247979E-03_JPRB, 0.38322240E-03_JPRB, 0.38402235E-03_JPRB, 0.38489833E-03_JPRB, &
  & 0.38586599E-03_JPRB, 0.38669807E-03_JPRB, 0.38733501E-03_JPRB, 0.38756068E-03_JPRB, 0.38739238E-03_JPRB, 0.38701402E-03_JPRB, &
  & 0.38669823E-03_JPRB, 0.38650054E-03_JPRB, 0.38647407E-03_JPRB, 0.38654305E-03_JPRB, 0.38664528E-03_JPRB, 0.38689129E-03_JPRB, &
  & 0.38721913E-03_JPRB, 0.38753569E-03_JPRB, 0.38796957E-03_JPRB, 0.38847614E-03_JPRB, 0.38893646E-03_JPRB, 0.38940957E-03_JPRB, &
  & 0.38990944E-03_JPRB, 0.39039212E-03_JPRB, 0.39088717E-03_JPRB, 0.39136467E-03_JPRB, 0.39181757E-03_JPRB, 0.39219051E-03_JPRB, &
  & 0.39246512E-03_JPRB, 0.39264248E-03_JPRB, 0.39271725E-03_JPRB, 0.39285610E-03_JPRB, 0.39296017E-03_JPRB, 0.39327949E-03_JPRB, &
  & 0.39335710E-03_JPRB, 0.39311519E-03_JPRB, 0.39242246E-03_JPRB, 0.39204210E-03_JPRB  /)

RGHG1(:,68, 4) = (/ &
  & 0.38292165E-03_JPRB, 0.38324040E-03_JPRB, 0.38327795E-03_JPRB, 0.38336973E-03_JPRB, 0.38337935E-03_JPRB, 0.38320704E-03_JPRB, &
  & 0.38295087E-03_JPRB, 0.38274298E-03_JPRB, 0.38258432E-03_JPRB, 0.38246965E-03_JPRB, 0.38240330E-03_JPRB, 0.38228906E-03_JPRB, &
  & 0.38213517E-03_JPRB, 0.38193805E-03_JPRB, 0.38176366E-03_JPRB, 0.38157672E-03_JPRB, 0.38139204E-03_JPRB, 0.38125350E-03_JPRB, &
  & 0.38112504E-03_JPRB, 0.38103928E-03_JPRB, 0.38100309E-03_JPRB, 0.38101973E-03_JPRB, 0.38106395E-03_JPRB, 0.38122506E-03_JPRB, &
  & 0.38141027E-03_JPRB, 0.38180025E-03_JPRB, 0.38244526E-03_JPRB, 0.38316829E-03_JPRB, 0.38401752E-03_JPRB, 0.38489718E-03_JPRB, &
  & 0.38586369E-03_JPRB, 0.38673215E-03_JPRB, 0.38738912E-03_JPRB, 0.38759637E-03_JPRB, 0.38746076E-03_JPRB, 0.38712454E-03_JPRB, &
  & 0.38681427E-03_JPRB, 0.38661635E-03_JPRB, 0.38656777E-03_JPRB, 0.38661535E-03_JPRB, 0.38675142E-03_JPRB, 0.38703289E-03_JPRB, &
  & 0.38738858E-03_JPRB, 0.38771551E-03_JPRB, 0.38816344E-03_JPRB, 0.38867668E-03_JPRB, 0.38915771E-03_JPRB, 0.38966399E-03_JPRB, &
  & 0.39018849E-03_JPRB, 0.39069442E-03_JPRB, 0.39120559E-03_JPRB, 0.39170520E-03_JPRB, 0.39218871E-03_JPRB, 0.39256949E-03_JPRB, &
  & 0.39285837E-03_JPRB, 0.39306980E-03_JPRB, 0.39316368E-03_JPRB, 0.39335226E-03_JPRB, 0.39348005E-03_JPRB, 0.39381732E-03_JPRB, &
  & 0.39384958E-03_JPRB, 0.39356254E-03_JPRB, 0.39287764E-03_JPRB, 0.39249175E-03_JPRB  /)

RGHG1(:,69, 4) = (/ &
  & 0.38296526E-03_JPRB, 0.38329581E-03_JPRB, 0.38333047E-03_JPRB, 0.38341831E-03_JPRB, 0.38342206E-03_JPRB, 0.38326325E-03_JPRB, &
  & 0.38302676E-03_JPRB, 0.38282969E-03_JPRB, 0.38267454E-03_JPRB, 0.38255387E-03_JPRB, 0.38247746E-03_JPRB, 0.38237562E-03_JPRB, &
  & 0.38222464E-03_JPRB, 0.38202638E-03_JPRB, 0.38183646E-03_JPRB, 0.38164014E-03_JPRB, 0.38145810E-03_JPRB, 0.38131949E-03_JPRB, &
  & 0.38120826E-03_JPRB, 0.38111276E-03_JPRB, 0.38107201E-03_JPRB, 0.38107107E-03_JPRB, 0.38110048E-03_JPRB, 0.38125080E-03_JPRB, &
  & 0.38142271E-03_JPRB, 0.38180759E-03_JPRB, 0.38241785E-03_JPRB, 0.38311943E-03_JPRB, 0.38402127E-03_JPRB, 0.38490336E-03_JPRB, &
  & 0.38587123E-03_JPRB, 0.38677250E-03_JPRB, 0.38744007E-03_JPRB, 0.38763917E-03_JPRB, 0.38754904E-03_JPRB, 0.38726458E-03_JPRB, &
  & 0.38696151E-03_JPRB, 0.38676357E-03_JPRB, 0.38670400E-03_JPRB, 0.38672304E-03_JPRB, 0.38689212E-03_JPRB, 0.38719290E-03_JPRB, &
  & 0.38757791E-03_JPRB, 0.38791624E-03_JPRB, 0.38837738E-03_JPRB, 0.38890107E-03_JPRB, 0.38940617E-03_JPRB, 0.38994685E-03_JPRB, &
  & 0.39049200E-03_JPRB, 0.39101888E-03_JPRB, 0.39153967E-03_JPRB, 0.39205592E-03_JPRB, 0.39256168E-03_JPRB, 0.39294776E-03_JPRB, &
  & 0.39325448E-03_JPRB, 0.39348887E-03_JPRB, 0.39359453E-03_JPRB, 0.39381648E-03_JPRB, 0.39395562E-03_JPRB, 0.39428486E-03_JPRB, &
  & 0.39430593E-03_JPRB, 0.39401819E-03_JPRB, 0.39335641E-03_JPRB, 0.39297779E-03_JPRB  /)

RGHG1(:,70, 4) = (/ &
  & 0.38300796E-03_JPRB, 0.38333915E-03_JPRB, 0.38337455E-03_JPRB, 0.38345704E-03_JPRB, 0.38345412E-03_JPRB, 0.38331246E-03_JPRB, &
  & 0.38309774E-03_JPRB, 0.38291482E-03_JPRB, 0.38276519E-03_JPRB, 0.38263622E-03_JPRB, 0.38255528E-03_JPRB, 0.38246384E-03_JPRB, &
  & 0.38232141E-03_JPRB, 0.38212380E-03_JPRB, 0.38192070E-03_JPRB, 0.38171496E-03_JPRB, 0.38153365E-03_JPRB, 0.38139632E-03_JPRB, &
  & 0.38129780E-03_JPRB, 0.38119692E-03_JPRB, 0.38114844E-03_JPRB, 0.38112698E-03_JPRB, 0.38114629E-03_JPRB, 0.38128348E-03_JPRB, &
  & 0.38144909E-03_JPRB, 0.38181361E-03_JPRB, 0.38238862E-03_JPRB, 0.38307253E-03_JPRB, 0.38401378E-03_JPRB, 0.38489965E-03_JPRB, &
  & 0.38587181E-03_JPRB, 0.38680252E-03_JPRB, 0.38747603E-03_JPRB, 0.38768150E-03_JPRB, 0.38763457E-03_JPRB, 0.38739785E-03_JPRB, &
  & 0.38710804E-03_JPRB, 0.38691185E-03_JPRB, 0.38684316E-03_JPRB, 0.38684776E-03_JPRB, 0.38705624E-03_JPRB, 0.38737198E-03_JPRB, &
  & 0.38777755E-03_JPRB, 0.38813129E-03_JPRB, 0.38860517E-03_JPRB, 0.38914639E-03_JPRB, 0.38967836E-03_JPRB, 0.39025029E-03_JPRB, &
  & 0.39081172E-03_JPRB, 0.39135829E-03_JPRB, 0.39188847E-03_JPRB, 0.39241900E-03_JPRB, 0.39294634E-03_JPRB, 0.39333442E-03_JPRB, &
  & 0.39365454E-03_JPRB, 0.39389720E-03_JPRB, 0.39400630E-03_JPRB, 0.39425781E-03_JPRB, 0.39440883E-03_JPRB, 0.39470767E-03_JPRB, &
  & 0.39474497E-03_JPRB, 0.39446976E-03_JPRB, 0.39384698E-03_JPRB, 0.39348545E-03_JPRB  /)

RGHG1(:,71, 4) = (/ &
  & 0.38305324E-03_JPRB, 0.38337101E-03_JPRB, 0.38341179E-03_JPRB, 0.38348695E-03_JPRB, 0.38347763E-03_JPRB, 0.38335622E-03_JPRB, &
  & 0.38316462E-03_JPRB, 0.38299790E-03_JPRB, 0.38285519E-03_JPRB, 0.38271834E-03_JPRB, 0.38263751E-03_JPRB, 0.38255322E-03_JPRB, &
  & 0.38242365E-03_JPRB, 0.38222863E-03_JPRB, 0.38201604E-03_JPRB, 0.38180148E-03_JPRB, 0.38161889E-03_JPRB, 0.38148375E-03_JPRB, &
  & 0.38139190E-03_JPRB, 0.38128965E-03_JPRB, 0.38122824E-03_JPRB, 0.38118649E-03_JPRB, 0.38119552E-03_JPRB, 0.38131644E-03_JPRB, &
  & 0.38148044E-03_JPRB, 0.38181248E-03_JPRB, 0.38235226E-03_JPRB, 0.38302385E-03_JPRB, 0.38398852E-03_JPRB, 0.38487668E-03_JPRB, &
  & 0.38585721E-03_JPRB, 0.38681596E-03_JPRB, 0.38749421E-03_JPRB, 0.38771918E-03_JPRB, 0.38771407E-03_JPRB, 0.38751658E-03_JPRB, &
  & 0.38724407E-03_JPRB, 0.38705180E-03_JPRB, 0.38697691E-03_JPRB, 0.38698414E-03_JPRB, 0.38723900E-03_JPRB, 0.38756869E-03_JPRB, &
  & 0.38798572E-03_JPRB, 0.38835879E-03_JPRB, 0.38884628E-03_JPRB, 0.38941150E-03_JPRB, 0.38997375E-03_JPRB, 0.39057300E-03_JPRB, &
  & 0.39114775E-03_JPRB, 0.39170946E-03_JPRB, 0.39225119E-03_JPRB, 0.39279562E-03_JPRB, 0.39334104E-03_JPRB, 0.39372866E-03_JPRB, &
  & 0.39405423E-03_JPRB, 0.39429260E-03_JPRB, 0.39439916E-03_JPRB, 0.39467539E-03_JPRB, 0.39483979E-03_JPRB, 0.39509457E-03_JPRB, &
  & 0.39516196E-03_JPRB, 0.39490560E-03_JPRB, 0.39434465E-03_JPRB, 0.39399516E-03_JPRB  /)

RGHG1(:,72, 4) = (/ &
  & 0.38310659E-03_JPRB, 0.38339164E-03_JPRB, 0.38344348E-03_JPRB, 0.38350804E-03_JPRB, 0.38349457E-03_JPRB, 0.38339597E-03_JPRB, &
  & 0.38322835E-03_JPRB, 0.38307730E-03_JPRB, 0.38294220E-03_JPRB, 0.38280211E-03_JPRB, 0.38272521E-03_JPRB, 0.38264322E-03_JPRB, &
  & 0.38252840E-03_JPRB, 0.38233891E-03_JPRB, 0.38212286E-03_JPRB, 0.38190069E-03_JPRB, 0.38171580E-03_JPRB, 0.38158182E-03_JPRB, &
  & 0.38148905E-03_JPRB, 0.38138956E-03_JPRB, 0.38130694E-03_JPRB, 0.38124906E-03_JPRB, 0.38123919E-03_JPRB, 0.38134145E-03_JPRB, &
  & 0.38150453E-03_JPRB, 0.38179601E-03_JPRB, 0.38230006E-03_JPRB, 0.38296658E-03_JPRB, 0.38393655E-03_JPRB, 0.38481941E-03_JPRB, &
  & 0.38581469E-03_JPRB, 0.38680386E-03_JPRB, 0.38749133E-03_JPRB, 0.38774580E-03_JPRB, 0.38778609E-03_JPRB, 0.38761349E-03_JPRB, &
  & 0.38735758E-03_JPRB, 0.38717199E-03_JPRB, 0.38709779E-03_JPRB, 0.38712646E-03_JPRB, 0.38743455E-03_JPRB, 0.38778130E-03_JPRB, &
  & 0.38820201E-03_JPRB, 0.38859767E-03_JPRB, 0.38910222E-03_JPRB, 0.38969624E-03_JPRB, 0.39029375E-03_JPRB, 0.39091582E-03_JPRB, &
  & 0.39150371E-03_JPRB, 0.39206934E-03_JPRB, 0.39262812E-03_JPRB, 0.39318937E-03_JPRB, 0.39374217E-03_JPRB, 0.39412863E-03_JPRB, &
  & 0.39444637E-03_JPRB, 0.39467253E-03_JPRB, 0.39477517E-03_JPRB, 0.39506661E-03_JPRB, 0.39524507E-03_JPRB, 0.39545791E-03_JPRB, &
  & 0.39554465E-03_JPRB, 0.39530696E-03_JPRB, 0.39484488E-03_JPRB, 0.39447396E-03_JPRB  /)

RGHG1(:,73, 4) = (/ &
  & 0.38316699E-03_JPRB, 0.38340543E-03_JPRB, 0.38346883E-03_JPRB, 0.38352080E-03_JPRB, 0.38350423E-03_JPRB, 0.38342965E-03_JPRB, &
  & 0.38328784E-03_JPRB, 0.38314935E-03_JPRB, 0.38301976E-03_JPRB, 0.38288327E-03_JPRB, 0.38280860E-03_JPRB, 0.38272999E-03_JPRB, &
  & 0.38262573E-03_JPRB, 0.38244866E-03_JPRB, 0.38223961E-03_JPRB, 0.38201728E-03_JPRB, 0.38183221E-03_JPRB, 0.38169468E-03_JPRB, &
  & 0.38159734E-03_JPRB, 0.38150299E-03_JPRB, 0.38139926E-03_JPRB, 0.38132815E-03_JPRB, 0.38129499E-03_JPRB, 0.38136863E-03_JPRB, &
  & 0.38151517E-03_JPRB, 0.38175815E-03_JPRB, 0.38221408E-03_JPRB, 0.38286822E-03_JPRB, 0.38382834E-03_JPRB, 0.38471721E-03_JPRB, &
  & 0.38572519E-03_JPRB, 0.38674260E-03_JPRB, 0.38745431E-03_JPRB, 0.38774808E-03_JPRB, 0.38784281E-03_JPRB, 0.38770038E-03_JPRB, &
  & 0.38744811E-03_JPRB, 0.38726860E-03_JPRB, 0.38721456E-03_JPRB, 0.38728511E-03_JPRB, 0.38763776E-03_JPRB, 0.38800851E-03_JPRB, &
  & 0.38843079E-03_JPRB, 0.38885023E-03_JPRB, 0.38938178E-03_JPRB, 0.39000157E-03_JPRB, 0.39063947E-03_JPRB, 0.39128277E-03_JPRB, &
  & 0.39188858E-03_JPRB, 0.39244938E-03_JPRB, 0.39301847E-03_JPRB, 0.39359344E-03_JPRB, 0.39414937E-03_JPRB, 0.39452805E-03_JPRB, &
  & 0.39482507E-03_JPRB, 0.39504194E-03_JPRB, 0.39515133E-03_JPRB, 0.39542855E-03_JPRB, 0.39561302E-03_JPRB, 0.39578923E-03_JPRB, &
  & 0.39587042E-03_JPRB, 0.39565643E-03_JPRB, 0.39530492E-03_JPRB, 0.39484869E-03_JPRB  /)

RGHG1(:,74, 4) = (/ &
  & 0.38323015E-03_JPRB, 0.38342309E-03_JPRB, 0.38348958E-03_JPRB, 0.38352811E-03_JPRB, 0.38351006E-03_JPRB, 0.38345847E-03_JPRB, &
  & 0.38334149E-03_JPRB, 0.38321319E-03_JPRB, 0.38309045E-03_JPRB, 0.38296051E-03_JPRB, 0.38288973E-03_JPRB, 0.38281488E-03_JPRB, &
  & 0.38271705E-03_JPRB, 0.38255406E-03_JPRB, 0.38235901E-03_JPRB, 0.38214438E-03_JPRB, 0.38196182E-03_JPRB, 0.38182160E-03_JPRB, &
  & 0.38172121E-03_JPRB, 0.38163037E-03_JPRB, 0.38150738E-03_JPRB, 0.38142301E-03_JPRB, 0.38136831E-03_JPRB, 0.38141016E-03_JPRB, &
  & 0.38152341E-03_JPRB, 0.38171491E-03_JPRB, 0.38210934E-03_JPRB, 0.38272616E-03_JPRB, 0.38366904E-03_JPRB, 0.38457195E-03_JPRB, &
  & 0.38559174E-03_JPRB, 0.38664609E-03_JPRB, 0.38739053E-03_JPRB, 0.38772828E-03_JPRB, 0.38788844E-03_JPRB, 0.38779189E-03_JPRB, &
  & 0.38754287E-03_JPRB, 0.38737161E-03_JPRB, 0.38735438E-03_JPRB, 0.38747919E-03_JPRB, 0.38786756E-03_JPRB, 0.38826872E-03_JPRB, &
  & 0.38868334E-03_JPRB, 0.38912024E-03_JPRB, 0.38968112E-03_JPRB, 0.39032361E-03_JPRB, 0.39099477E-03_JPRB, 0.39165554E-03_JPRB, &
  & 0.39228619E-03_JPRB, 0.39284309E-03_JPRB, 0.39342498E-03_JPRB, 0.39401227E-03_JPRB, 0.39455874E-03_JPRB, 0.39492615E-03_JPRB, &
  & 0.39519625E-03_JPRB, 0.39540602E-03_JPRB, 0.39552696E-03_JPRB, 0.39577859E-03_JPRB, 0.39595531E-03_JPRB, 0.39608968E-03_JPRB, &
  & 0.39616558E-03_JPRB, 0.39597596E-03_JPRB, 0.39571445E-03_JPRB, 0.39517460E-03_JPRB  /)

RGHG1(:,75, 4) = (/ &
  & 0.38329247E-03_JPRB, 0.38344464E-03_JPRB, 0.38350642E-03_JPRB, 0.38353103E-03_JPRB, 0.38351290E-03_JPRB, 0.38348189E-03_JPRB, &
  & 0.38338830E-03_JPRB, 0.38326884E-03_JPRB, 0.38315346E-03_JPRB, 0.38303319E-03_JPRB, 0.38296781E-03_JPRB, 0.38289574E-03_JPRB, &
  & 0.38280191E-03_JPRB, 0.38265403E-03_JPRB, 0.38247783E-03_JPRB, 0.38227842E-03_JPRB, 0.38210180E-03_JPRB, 0.38196114E-03_JPRB, &
  & 0.38186062E-03_JPRB, 0.38176961E-03_JPRB, 0.38162993E-03_JPRB, 0.38153344E-03_JPRB, 0.38145876E-03_JPRB, 0.38146632E-03_JPRB, &
  & 0.38153224E-03_JPRB, 0.38167019E-03_JPRB, 0.38199584E-03_JPRB, 0.38255374E-03_JPRB, 0.38346674E-03_JPRB, 0.38438773E-03_JPRB, &
  & 0.38542656E-03_JPRB, 0.38652225E-03_JPRB, 0.38730591E-03_JPRB, 0.38768844E-03_JPRB, 0.38792133E-03_JPRB, 0.38788880E-03_JPRB, &
  & 0.38764832E-03_JPRB, 0.38749028E-03_JPRB, 0.38752450E-03_JPRB, 0.38771125E-03_JPRB, 0.38812466E-03_JPRB, 0.38855860E-03_JPRB, &
  & 0.38896432E-03_JPRB, 0.38941050E-03_JPRB, 0.38999526E-03_JPRB, 0.39065516E-03_JPRB, 0.39135380E-03_JPRB, 0.39203183E-03_JPRB, &
  & 0.39269044E-03_JPRB, 0.39324387E-03_JPRB, 0.39383838E-03_JPRB, 0.39443416E-03_JPRB, 0.39496274E-03_JPRB, 0.39531775E-03_JPRB, &
  & 0.39556045E-03_JPRB, 0.39576522E-03_JPRB, 0.39589968E-03_JPRB, 0.39611778E-03_JPRB, 0.39627248E-03_JPRB, 0.39635903E-03_JPRB, &
  & 0.39643309E-03_JPRB, 0.39627077E-03_JPRB, 0.39608054E-03_JPRB, 0.39548724E-03_JPRB  /)

RGHG1(:,76, 4) = (/ &
  & 0.38334907E-03_JPRB, 0.38346873E-03_JPRB, 0.38352014E-03_JPRB, 0.38353068E-03_JPRB, 0.38351347E-03_JPRB, 0.38349883E-03_JPRB, &
  & 0.38342692E-03_JPRB, 0.38331645E-03_JPRB, 0.38320705E-03_JPRB, 0.38310062E-03_JPRB, 0.38304146E-03_JPRB, 0.38296916E-03_JPRB, &
  & 0.38287948E-03_JPRB, 0.38274750E-03_JPRB, 0.38259228E-03_JPRB, 0.38241524E-03_JPRB, 0.38224922E-03_JPRB, 0.38211178E-03_JPRB, &
  & 0.38201565E-03_JPRB, 0.38191795E-03_JPRB, 0.38176513E-03_JPRB, 0.38165988E-03_JPRB, 0.38156561E-03_JPRB, 0.38153629E-03_JPRB, &
  & 0.38154481E-03_JPRB, 0.38162766E-03_JPRB, 0.38188669E-03_JPRB, 0.38237128E-03_JPRB, 0.38323195E-03_JPRB, 0.38416931E-03_JPRB, &
  & 0.38524733E-03_JPRB, 0.38638060E-03_JPRB, 0.38720805E-03_JPRB, 0.38763092E-03_JPRB, 0.38793804E-03_JPRB, 0.38799058E-03_JPRB, &
  & 0.38777131E-03_JPRB, 0.38763563E-03_JPRB, 0.38773370E-03_JPRB, 0.38798408E-03_JPRB, 0.38840878E-03_JPRB, 0.38887177E-03_JPRB, &
  & 0.38928094E-03_JPRB, 0.38972620E-03_JPRB, 0.39031811E-03_JPRB, 0.39098654E-03_JPRB, 0.39171077E-03_JPRB, 0.39241184E-03_JPRB, &
  & 0.39309536E-03_JPRB, 0.39364349E-03_JPRB, 0.39424490E-03_JPRB, 0.39484114E-03_JPRB, 0.39535106E-03_JPRB, 0.39569570E-03_JPRB, &
  & 0.39591857E-03_JPRB, 0.39612034E-03_JPRB, 0.39626679E-03_JPRB, 0.39644593E-03_JPRB, 0.39656398E-03_JPRB, 0.39659682E-03_JPRB, &
  & 0.39667387E-03_JPRB, 0.39654613E-03_JPRB, 0.39641584E-03_JPRB, 0.39583544E-03_JPRB  /)

RGHG1(:,77, 4) = (/ &
  & 0.38339560E-03_JPRB, 0.38349117E-03_JPRB, 0.38353139E-03_JPRB, 0.38352723E-03_JPRB, 0.38351317E-03_JPRB, 0.38350803E-03_JPRB, &
  & 0.38345632E-03_JPRB, 0.38335364E-03_JPRB, 0.38325166E-03_JPRB, 0.38316280E-03_JPRB, 0.38310752E-03_JPRB, 0.38303388E-03_JPRB, &
  & 0.38295150E-03_JPRB, 0.38283877E-03_JPRB, 0.38270083E-03_JPRB, 0.38254380E-03_JPRB, 0.38238544E-03_JPRB, 0.38225416E-03_JPRB, &
  & 0.38216313E-03_JPRB, 0.38205932E-03_JPRB, 0.38189716E-03_JPRB, 0.38177482E-03_JPRB, 0.38166423E-03_JPRB, 0.38159040E-03_JPRB, &
  & 0.38154713E-03_JPRB, 0.38158896E-03_JPRB, 0.38180259E-03_JPRB, 0.38223921E-03_JPRB, 0.38302663E-03_JPRB, 0.38398236E-03_JPRB, &
  & 0.38511721E-03_JPRB, 0.38626042E-03_JPRB, 0.38710924E-03_JPRB, 0.38756948E-03_JPRB, 0.38794013E-03_JPRB, 0.38807651E-03_JPRB, &
  & 0.38789117E-03_JPRB, 0.38778482E-03_JPRB, 0.38793569E-03_JPRB, 0.38823130E-03_JPRB, 0.38869008E-03_JPRB, 0.38920537E-03_JPRB, &
  & 0.38961628E-03_JPRB, 0.39003310E-03_JPRB, 0.39063203E-03_JPRB, 0.39130846E-03_JPRB, 0.39205509E-03_JPRB, 0.39277400E-03_JPRB, &
  & 0.39346813E-03_JPRB, 0.39400866E-03_JPRB, 0.39462375E-03_JPRB, 0.39521580E-03_JPRB, 0.39570456E-03_JPRB, 0.39605309E-03_JPRB, &
  & 0.39626982E-03_JPRB, 0.39648031E-03_JPRB, 0.39662051E-03_JPRB, 0.39675814E-03_JPRB, 0.39681817E-03_JPRB, 0.39679653E-03_JPRB, &
  & 0.39687041E-03_JPRB, 0.39678440E-03_JPRB, 0.39674815E-03_JPRB, 0.39626933E-03_JPRB  /)

RGHG1(:,78, 4) = (/ &
  & 0.38343198E-03_JPRB, 0.38350995E-03_JPRB, 0.38353957E-03_JPRB, 0.38352250E-03_JPRB, 0.38351052E-03_JPRB, 0.38351284E-03_JPRB, &
  & 0.38347895E-03_JPRB, 0.38338278E-03_JPRB, 0.38328721E-03_JPRB, 0.38321236E-03_JPRB, 0.38315992E-03_JPRB, 0.38308235E-03_JPRB, &
  & 0.38300744E-03_JPRB, 0.38290990E-03_JPRB, 0.38278141E-03_JPRB, 0.38264019E-03_JPRB, 0.38249255E-03_JPRB, 0.38236637E-03_JPRB, &
  & 0.38227959E-03_JPRB, 0.38217164E-03_JPRB, 0.38200188E-03_JPRB, 0.38186472E-03_JPRB, 0.38173983E-03_JPRB, 0.38163178E-03_JPRB, &
  & 0.38155340E-03_JPRB, 0.38156137E-03_JPRB, 0.38174297E-03_JPRB, 0.38214137E-03_JPRB, 0.38287588E-03_JPRB, 0.38384498E-03_JPRB, &
  & 0.38502123E-03_JPRB, 0.38616616E-03_JPRB, 0.38702032E-03_JPRB, 0.38751451E-03_JPRB, 0.38793897E-03_JPRB, 0.38813624E-03_JPRB, &
  & 0.38798406E-03_JPRB, 0.38791519E-03_JPRB, 0.38812235E-03_JPRB, 0.38845460E-03_JPRB, 0.38894264E-03_JPRB, 0.38950344E-03_JPRB, &
  & 0.38992816E-03_JPRB, 0.39032064E-03_JPRB, 0.39091676E-03_JPRB, 0.39159458E-03_JPRB, 0.39237034E-03_JPRB, 0.39310154E-03_JPRB, &
  & 0.39379878E-03_JPRB, 0.39433310E-03_JPRB, 0.39496663E-03_JPRB, 0.39555781E-03_JPRB, 0.39601987E-03_JPRB, 0.39638375E-03_JPRB, &
  & 0.39660626E-03_JPRB, 0.39682815E-03_JPRB, 0.39695191E-03_JPRB, 0.39703691E-03_JPRB, 0.39703514E-03_JPRB, 0.39696690E-03_JPRB, &
  & 0.39703402E-03_JPRB, 0.39698388E-03_JPRB, 0.39703743E-03_JPRB, 0.39667270E-03_JPRB  /)

RGHG1(:,79, 4) = (/ &
  & 0.38345828E-03_JPRB, 0.38352409E-03_JPRB, 0.38354410E-03_JPRB, 0.38351757E-03_JPRB, 0.38350639E-03_JPRB, 0.38351395E-03_JPRB, &
  & 0.38349601E-03_JPRB, 0.38340592E-03_JPRB, 0.38331482E-03_JPRB, 0.38324921E-03_JPRB, 0.38319702E-03_JPRB, 0.38311434E-03_JPRB, &
  & 0.38304559E-03_JPRB, 0.38295703E-03_JPRB, 0.38283408E-03_JPRB, 0.38270557E-03_JPRB, 0.38256898E-03_JPRB, 0.38244706E-03_JPRB, &
  & 0.38236317E-03_JPRB, 0.38225428E-03_JPRB, 0.38208097E-03_JPRB, 0.38193326E-03_JPRB, 0.38179670E-03_JPRB, 0.38166533E-03_JPRB, &
  & 0.38156491E-03_JPRB, 0.38154636E-03_JPRB, 0.38170514E-03_JPRB, 0.38207170E-03_JPRB, 0.38277251E-03_JPRB, 0.38374842E-03_JPRB, &
  & 0.38495179E-03_JPRB, 0.38609633E-03_JPRB, 0.38694445E-03_JPRB, 0.38746738E-03_JPRB, 0.38793756E-03_JPRB, 0.38817772E-03_JPRB, &
  & 0.38805784E-03_JPRB, 0.38802827E-03_JPRB, 0.38828839E-03_JPRB, 0.38865198E-03_JPRB, 0.38916775E-03_JPRB, 0.38976256E-03_JPRB, &
  & 0.39020503E-03_JPRB, 0.39058292E-03_JPRB, 0.39116981E-03_JPRB, 0.39184575E-03_JPRB, 0.39265148E-03_JPRB, 0.39339121E-03_JPRB, &
  & 0.39408502E-03_JPRB, 0.39461460E-03_JPRB, 0.39526811E-03_JPRB, 0.39586171E-03_JPRB, 0.39630000E-03_JPRB, 0.39668144E-03_JPRB, &
  & 0.39692104E-03_JPRB, 0.39715574E-03_JPRB, 0.39725743E-03_JPRB, 0.39728155E-03_JPRB, 0.39721685E-03_JPRB, 0.39711138E-03_JPRB, &
  & 0.39716904E-03_JPRB, 0.39714462E-03_JPRB, 0.39727436E-03_JPRB, 0.39702032E-03_JPRB  /)

RGHG1(:,80, 4) = (/ &
  & 0.38347478E-03_JPRB, 0.38353278E-03_JPRB, 0.38354452E-03_JPRB, 0.38351355E-03_JPRB, 0.38350191E-03_JPRB, 0.38351203E-03_JPRB, &
  & 0.38350883E-03_JPRB, 0.38342541E-03_JPRB, 0.38333593E-03_JPRB, 0.38327402E-03_JPRB, 0.38321766E-03_JPRB, 0.38313043E-03_JPRB, &
  & 0.38306520E-03_JPRB, 0.38297758E-03_JPRB, 0.38286112E-03_JPRB, 0.38274365E-03_JPRB, 0.38261483E-03_JPRB, 0.38249682E-03_JPRB, &
  & 0.38241406E-03_JPRB, 0.38230859E-03_JPRB, 0.38213843E-03_JPRB, 0.38198587E-03_JPRB, 0.38184097E-03_JPRB, 0.38169642E-03_JPRB, &
  & 0.38158192E-03_JPRB, 0.38154477E-03_JPRB, 0.38168554E-03_JPRB, 0.38202372E-03_JPRB, 0.38270568E-03_JPRB, 0.38368070E-03_JPRB, &
  & 0.38490066E-03_JPRB, 0.38604838E-03_JPRB, 0.38688417E-03_JPRB, 0.38742883E-03_JPRB, 0.38793855E-03_JPRB, 0.38821088E-03_JPRB, &
  & 0.38812316E-03_JPRB, 0.38812743E-03_JPRB, 0.38842868E-03_JPRB, 0.38882161E-03_JPRB, 0.38936915E-03_JPRB, 0.38998337E-03_JPRB, &
  & 0.39043730E-03_JPRB, 0.39081459E-03_JPRB, 0.39139022E-03_JPRB, 0.39206529E-03_JPRB, 0.39289456E-03_JPRB, 0.39364112E-03_JPRB, &
  & 0.39432586E-03_JPRB, 0.39485204E-03_JPRB, 0.39552350E-03_JPRB, 0.39612212E-03_JPRB, 0.39654926E-03_JPRB, 0.39694011E-03_JPRB, &
  & 0.39720726E-03_JPRB, 0.39745513E-03_JPRB, 0.39753381E-03_JPRB, 0.39749293E-03_JPRB, 0.39736620E-03_JPRB, 0.39723377E-03_JPRB, &
  & 0.39728016E-03_JPRB, 0.39726751E-03_JPRB, 0.39745213E-03_JPRB, 0.39729252E-03_JPRB  /)

RGHG1(:,81, 4) = (/ &
  & 0.38348485E-03_JPRB, 0.38353480E-03_JPRB, 0.38353918E-03_JPRB, 0.38350987E-03_JPRB, 0.38349753E-03_JPRB, 0.38350741E-03_JPRB, &
  & 0.38351535E-03_JPRB, 0.38343810E-03_JPRB, 0.38334980E-03_JPRB, 0.38328954E-03_JPRB, 0.38323152E-03_JPRB, 0.38313577E-03_JPRB, &
  & 0.38306769E-03_JPRB, 0.38297912E-03_JPRB, 0.38286503E-03_JPRB, 0.38275775E-03_JPRB, 0.38263936E-03_JPRB, 0.38252514E-03_JPRB, &
  & 0.38244476E-03_JPRB, 0.38234451E-03_JPRB, 0.38218312E-03_JPRB, 0.38202842E-03_JPRB, 0.38188068E-03_JPRB, 0.38173067E-03_JPRB, &
  & 0.38160811E-03_JPRB, 0.38155129E-03_JPRB, 0.38168116E-03_JPRB, 0.38200226E-03_JPRB, 0.38266622E-03_JPRB, 0.38363862E-03_JPRB, &
  & 0.38486997E-03_JPRB, 0.38602385E-03_JPRB, 0.38684138E-03_JPRB, 0.38739671E-03_JPRB, 0.38794294E-03_JPRB, 0.38824632E-03_JPRB, &
  & 0.38819108E-03_JPRB, 0.38822284E-03_JPRB, 0.38854448E-03_JPRB, 0.38895329E-03_JPRB, 0.38952714E-03_JPRB, 0.39015132E-03_JPRB, &
  & 0.39061876E-03_JPRB, 0.39098751E-03_JPRB, 0.39157144E-03_JPRB, 0.39224130E-03_JPRB, 0.39308456E-03_JPRB, 0.39384391E-03_JPRB, &
  & 0.39450898E-03_JPRB, 0.39502852E-03_JPRB, 0.39571492E-03_JPRB, 0.39632183E-03_JPRB, 0.39674755E-03_JPRB, 0.39714883E-03_JPRB, &
  & 0.39744419E-03_JPRB, 0.39771861E-03_JPRB, 0.39777738E-03_JPRB, 0.39767107E-03_JPRB, 0.39748318E-03_JPRB, 0.39733084E-03_JPRB, &
  & 0.39736657E-03_JPRB, 0.39736150E-03_JPRB, 0.39758310E-03_JPRB, 0.39749768E-03_JPRB  /)

RGHG1(:,82, 4) = (/ &
  & 0.38349306E-03_JPRB, 0.38353451E-03_JPRB, 0.38353290E-03_JPRB, 0.38350655E-03_JPRB, 0.38349399E-03_JPRB, 0.38350216E-03_JPRB, &
  & 0.38351889E-03_JPRB, 0.38344792E-03_JPRB, 0.38336260E-03_JPRB, 0.38330285E-03_JPRB, 0.38324106E-03_JPRB, 0.38313584E-03_JPRB, &
  & 0.38306445E-03_JPRB, 0.38297510E-03_JPRB, 0.38286484E-03_JPRB, 0.38276654E-03_JPRB, 0.38265737E-03_JPRB, 0.38254725E-03_JPRB, &
  & 0.38247281E-03_JPRB, 0.38238019E-03_JPRB, 0.38222866E-03_JPRB, 0.38207364E-03_JPRB, 0.38192421E-03_JPRB, 0.38177320E-03_JPRB, &
  & 0.38164573E-03_JPRB, 0.38157083E-03_JPRB, 0.38169264E-03_JPRB, 0.38199859E-03_JPRB, 0.38263925E-03_JPRB, 0.38359926E-03_JPRB, &
  & 0.38484224E-03_JPRB, 0.38600062E-03_JPRB, 0.38680034E-03_JPRB, 0.38736594E-03_JPRB, 0.38794550E-03_JPRB, 0.38828496E-03_JPRB, &
  & 0.38825399E-03_JPRB, 0.38830703E-03_JPRB, 0.38865007E-03_JPRB, 0.38906992E-03_JPRB, 0.38965570E-03_JPRB, 0.39027900E-03_JPRB, &
  & 0.39075709E-03_JPRB, 0.39113598E-03_JPRB, 0.39173060E-03_JPRB, 0.39238956E-03_JPRB, 0.39324851E-03_JPRB, 0.39401699E-03_JPRB, &
  & 0.39466317E-03_JPRB, 0.39517546E-03_JPRB, 0.39587800E-03_JPRB, 0.39649234E-03_JPRB, 0.39691191E-03_JPRB, 0.39732127E-03_JPRB, &
  & 0.39763551E-03_JPRB, 0.39794398E-03_JPRB, 0.39798346E-03_JPRB, 0.39781623E-03_JPRB, 0.39757231E-03_JPRB, 0.39740083E-03_JPRB, &
  & 0.39743054E-03_JPRB, 0.39743758E-03_JPRB, 0.39767453E-03_JPRB, 0.39764813E-03_JPRB  /)

RGHG1(:,83, 4) = (/ &
  & 0.38349983E-03_JPRB, 0.38353291E-03_JPRB, 0.38352674E-03_JPRB, 0.38350344E-03_JPRB, 0.38349106E-03_JPRB, 0.38349663E-03_JPRB, &
  & 0.38352016E-03_JPRB, 0.38345586E-03_JPRB, 0.38337327E-03_JPRB, 0.38331271E-03_JPRB, 0.38324652E-03_JPRB, 0.38313285E-03_JPRB, &
  & 0.38305877E-03_JPRB, 0.38296936E-03_JPRB, 0.38286235E-03_JPRB, 0.38277174E-03_JPRB, 0.38267049E-03_JPRB, 0.38256457E-03_JPRB, &
  & 0.38249960E-03_JPRB, 0.38241689E-03_JPRB, 0.38227744E-03_JPRB, 0.38212261E-03_JPRB, 0.38197347E-03_JPRB, 0.38182547E-03_JPRB, &
  & 0.38169486E-03_JPRB, 0.38160811E-03_JPRB, 0.38172550E-03_JPRB, 0.38201339E-03_JPRB, 0.38262815E-03_JPRB, 0.38357013E-03_JPRB, &
  & 0.38482126E-03_JPRB, 0.38598626E-03_JPRB, 0.38677028E-03_JPRB, 0.38734221E-03_JPRB, 0.38795336E-03_JPRB, 0.38832600E-03_JPRB, &
  & 0.38830916E-03_JPRB, 0.38837875E-03_JPRB, 0.38874306E-03_JPRB, 0.38917396E-03_JPRB, 0.38976318E-03_JPRB, 0.39037697E-03_JPRB, &
  & 0.39086468E-03_JPRB, 0.39126903E-03_JPRB, 0.39187524E-03_JPRB, 0.39252007E-03_JPRB, 0.39339673E-03_JPRB, 0.39416915E-03_JPRB, &
  & 0.39479670E-03_JPRB, 0.39530233E-03_JPRB, 0.39602055E-03_JPRB, 0.39663882E-03_JPRB, 0.39705004E-03_JPRB, 0.39746468E-03_JPRB, &
  & 0.39778929E-03_JPRB, 0.39813228E-03_JPRB, 0.39815826E-03_JPRB, 0.39793223E-03_JPRB, 0.39763419E-03_JPRB, 0.39744294E-03_JPRB, &
  & 0.39747202E-03_JPRB, 0.39749271E-03_JPRB, 0.39773342E-03_JPRB, 0.39776065E-03_JPRB  /)

RGHG1(:,84, 4) = (/ &
  & 0.38350548E-03_JPRB, 0.38353083E-03_JPRB, 0.38352153E-03_JPRB, 0.38350050E-03_JPRB, 0.38348852E-03_JPRB, 0.38349118E-03_JPRB, &
  & 0.38351995E-03_JPRB, 0.38346263E-03_JPRB, 0.38338114E-03_JPRB, 0.38331847E-03_JPRB, 0.38324834E-03_JPRB, 0.38312863E-03_JPRB, &
  & 0.38305326E-03_JPRB, 0.38296469E-03_JPRB, 0.38285899E-03_JPRB, 0.38277487E-03_JPRB, 0.38268033E-03_JPRB, 0.38257864E-03_JPRB, &
  & 0.38252656E-03_JPRB, 0.38245596E-03_JPRB, 0.38233134E-03_JPRB, 0.38217620E-03_JPRB, 0.38202970E-03_JPRB, 0.38188830E-03_JPRB, &
  & 0.38175533E-03_JPRB, 0.38166590E-03_JPRB, 0.38178300E-03_JPRB, 0.38204765E-03_JPRB, 0.38263637E-03_JPRB, 0.38355799E-03_JPRB, &
  & 0.38481152E-03_JPRB, 0.38598697E-03_JPRB, 0.38675784E-03_JPRB, 0.38733197E-03_JPRB, 0.38797430E-03_JPRB, 0.38837015E-03_JPRB, &
  & 0.38835511E-03_JPRB, 0.38843793E-03_JPRB, 0.38882302E-03_JPRB, 0.38926761E-03_JPRB, 0.38985734E-03_JPRB, 0.39045568E-03_JPRB, &
  & 0.39095346E-03_JPRB, 0.39139414E-03_JPRB, 0.39201206E-03_JPRB, 0.39264145E-03_JPRB, 0.39353755E-03_JPRB, 0.39430805E-03_JPRB, &
  & 0.39491722E-03_JPRB, 0.39541763E-03_JPRB, 0.39614984E-03_JPRB, 0.39676652E-03_JPRB, 0.39716894E-03_JPRB, 0.39758594E-03_JPRB, &
  & 0.39791358E-03_JPRB, 0.39828539E-03_JPRB, 0.39830730E-03_JPRB, 0.39802311E-03_JPRB, 0.39767145E-03_JPRB, 0.39745929E-03_JPRB, &
  & 0.39749283E-03_JPRB, 0.39752583E-03_JPRB, 0.39776721E-03_JPRB, 0.39784873E-03_JPRB  /)

RGHG1(:,85, 4) = (/ &
  & 0.38350966E-03_JPRB, 0.38352856E-03_JPRB, 0.38351735E-03_JPRB, 0.38349823E-03_JPRB, 0.38348577E-03_JPRB, 0.38348676E-03_JPRB, &
  & 0.38352007E-03_JPRB, 0.38346753E-03_JPRB, 0.38338628E-03_JPRB, 0.38332098E-03_JPRB, 0.38324631E-03_JPRB, 0.38312302E-03_JPRB, &
  & 0.38304764E-03_JPRB, 0.38295884E-03_JPRB, 0.38285338E-03_JPRB, 0.38277666E-03_JPRB, 0.38268953E-03_JPRB, 0.38259357E-03_JPRB, &
  & 0.38256229E-03_JPRB, 0.38251009E-03_JPRB, 0.38240219E-03_JPRB, 0.38224537E-03_JPRB, 0.38210342E-03_JPRB, 0.38197492E-03_JPRB, &
  & 0.38184219E-03_JPRB, 0.38175849E-03_JPRB, 0.38188156E-03_JPRB, 0.38212949E-03_JPRB, 0.38269456E-03_JPRB, 0.38358965E-03_JPRB, &
  & 0.38484366E-03_JPRB, 0.38602055E-03_JPRB, 0.38677015E-03_JPRB, 0.38737366E-03_JPRB, 0.38805375E-03_JPRB, 0.38844411E-03_JPRB, &
  & 0.38839776E-03_JPRB, 0.38849229E-03_JPRB, 0.38890725E-03_JPRB, 0.38935686E-03_JPRB, 0.38995519E-03_JPRB, 0.39053705E-03_JPRB, &
  & 0.39104797E-03_JPRB, 0.39152568E-03_JPRB, 0.39216248E-03_JPRB, 0.39277204E-03_JPRB, 0.39368630E-03_JPRB, 0.39444987E-03_JPRB, &
  & 0.39504422E-03_JPRB, 0.39554033E-03_JPRB, 0.39628641E-03_JPRB, 0.39689090E-03_JPRB, 0.39727969E-03_JPRB, 0.39769646E-03_JPRB, &
  & 0.39802051E-03_JPRB, 0.39840499E-03_JPRB, 0.39843454E-03_JPRB, 0.39809133E-03_JPRB, 0.39769523E-03_JPRB, 0.39746538E-03_JPRB, &
  & 0.39750131E-03_JPRB, 0.39753789E-03_JPRB, 0.39778334E-03_JPRB, 0.39790620E-03_JPRB  /)

RGHG1(:,86, 4) = (/ &
  & 0.38351162E-03_JPRB, 0.38352647E-03_JPRB, 0.38351445E-03_JPRB, 0.38349632E-03_JPRB, 0.38348301E-03_JPRB, 0.38348362E-03_JPRB, &
  & 0.38351981E-03_JPRB, 0.38347077E-03_JPRB, 0.38338901E-03_JPRB, 0.38332201E-03_JPRB, 0.38324334E-03_JPRB, 0.38311831E-03_JPRB, &
  & 0.38304293E-03_JPRB, 0.38295333E-03_JPRB, 0.38284736E-03_JPRB, 0.38277809E-03_JPRB, 0.38269709E-03_JPRB, 0.38260989E-03_JPRB, &
  & 0.38261296E-03_JPRB, 0.38257870E-03_JPRB, 0.38249135E-03_JPRB, 0.38233154E-03_JPRB, 0.38219976E-03_JPRB, 0.38208947E-03_JPRB, &
  & 0.38197343E-03_JPRB, 0.38189662E-03_JPRB, 0.38203187E-03_JPRB, 0.38228486E-03_JPRB, 0.38282054E-03_JPRB, 0.38371515E-03_JPRB, &
  & 0.38496758E-03_JPRB, 0.38613713E-03_JPRB, 0.38687564E-03_JPRB, 0.38749953E-03_JPRB, 0.38819401E-03_JPRB, 0.38854518E-03_JPRB, &
  & 0.38845821E-03_JPRB, 0.38856581E-03_JPRB, 0.38900893E-03_JPRB, 0.38945516E-03_JPRB, 0.39007785E-03_JPRB, 0.39064051E-03_JPRB, &
  & 0.39115604E-03_JPRB, 0.39167023E-03_JPRB, 0.39233386E-03_JPRB, 0.39292741E-03_JPRB, 0.39385787E-03_JPRB, 0.39461092E-03_JPRB, &
  & 0.39518963E-03_JPRB, 0.39568366E-03_JPRB, 0.39644348E-03_JPRB, 0.39702507E-03_JPRB, 0.39739082E-03_JPRB, 0.39780622E-03_JPRB, &
  & 0.39812163E-03_JPRB, 0.39850612E-03_JPRB, 0.39853887E-03_JPRB, 0.39814213E-03_JPRB, 0.39771053E-03_JPRB, 0.39746496E-03_JPRB, &
  & 0.39750479E-03_JPRB, 0.39754329E-03_JPRB, 0.39778496E-03_JPRB, 0.39793423E-03_JPRB  /)

RGHG1(:,87, 4) = (/ &
  & 0.38351141E-03_JPRB, 0.38352458E-03_JPRB, 0.38351220E-03_JPRB, 0.38349456E-03_JPRB, 0.38348052E-03_JPRB, 0.38348138E-03_JPRB, &
  & 0.38351951E-03_JPRB, 0.38347301E-03_JPRB, 0.38339015E-03_JPRB, 0.38332206E-03_JPRB, 0.38323961E-03_JPRB, 0.38311398E-03_JPRB, &
  & 0.38303935E-03_JPRB, 0.38294802E-03_JPRB, 0.38284145E-03_JPRB, 0.38278111E-03_JPRB, 0.38270435E-03_JPRB, 0.38263039E-03_JPRB, &
  & 0.38267698E-03_JPRB, 0.38265765E-03_JPRB, 0.38259424E-03_JPRB, 0.38244198E-03_JPRB, 0.38232364E-03_JPRB, 0.38223970E-03_JPRB, &
  & 0.38215883E-03_JPRB, 0.38210352E-03_JPRB, 0.38226860E-03_JPRB, 0.38251862E-03_JPRB, 0.38303927E-03_JPRB, 0.38395490E-03_JPRB, &
  & 0.38520040E-03_JPRB, 0.38638099E-03_JPRB, 0.38711519E-03_JPRB, 0.38773235E-03_JPRB, 0.38839604E-03_JPRB, 0.38867305E-03_JPRB, &
  & 0.38854553E-03_JPRB, 0.38867787E-03_JPRB, 0.38914730E-03_JPRB, 0.38958145E-03_JPRB, 0.39024337E-03_JPRB, 0.39077994E-03_JPRB, &
  & 0.39129081E-03_JPRB, 0.39184619E-03_JPRB, 0.39254656E-03_JPRB, 0.39313159E-03_JPRB, 0.39406743E-03_JPRB, 0.39480529E-03_JPRB, &
  & 0.39536940E-03_JPRB, 0.39586135E-03_JPRB, 0.39663208E-03_JPRB, 0.39718023E-03_JPRB, 0.39751241E-03_JPRB, 0.39792611E-03_JPRB, &
  & 0.39822865E-03_JPRB, 0.39860338E-03_JPRB, 0.39863398E-03_JPRB, 0.39818455E-03_JPRB, 0.39772015E-03_JPRB, 0.39746171E-03_JPRB, &
  & 0.39750331E-03_JPRB, 0.39754353E-03_JPRB, 0.39778122E-03_JPRB, 0.39794720E-03_JPRB  /)

RGHG1(:,88, 4) = (/ &
  & 0.38350951E-03_JPRB, 0.38352291E-03_JPRB, 0.38351042E-03_JPRB, 0.38349295E-03_JPRB, 0.38347855E-03_JPRB, 0.38347985E-03_JPRB, &
  & 0.38351922E-03_JPRB, 0.38347440E-03_JPRB, 0.38339022E-03_JPRB, 0.38332151E-03_JPRB, 0.38323552E-03_JPRB, 0.38310990E-03_JPRB, &
  & 0.38303702E-03_JPRB, 0.38294314E-03_JPRB, 0.38283569E-03_JPRB, 0.38278755E-03_JPRB, 0.38271256E-03_JPRB, 0.38265980E-03_JPRB, &
  & 0.38275871E-03_JPRB, 0.38274704E-03_JPRB, 0.38271844E-03_JPRB, 0.38259281E-03_JPRB, 0.38249138E-03_JPRB, 0.38243979E-03_JPRB, &
  & 0.38241506E-03_JPRB, 0.38241118E-03_JPRB, 0.38263467E-03_JPRB, 0.38285507E-03_JPRB, 0.38340150E-03_JPRB, 0.38435859E-03_JPRB, &
  & 0.38559342E-03_JPRB, 0.38682200E-03_JPRB, 0.38756298E-03_JPRB, 0.38812136E-03_JPRB, 0.38868444E-03_JPRB, 0.38884503E-03_JPRB, &
  & 0.38867946E-03_JPRB, 0.38885421E-03_JPRB, 0.38934775E-03_JPRB, 0.38976167E-03_JPRB, 0.39048212E-03_JPRB, 0.39098812E-03_JPRB, &
  & 0.39147694E-03_JPRB, 0.39208786E-03_JPRB, 0.39283800E-03_JPRB, 0.39341772E-03_JPRB, 0.39434658E-03_JPRB, 0.39506605E-03_JPRB, &
  & 0.39561857E-03_JPRB, 0.39610439E-03_JPRB, 0.39688032E-03_JPRB, 0.39737771E-03_JPRB, 0.39765877E-03_JPRB, 0.39806906E-03_JPRB, &
  & 0.39835580E-03_JPRB, 0.39871300E-03_JPRB, 0.39873463E-03_JPRB, 0.39823032E-03_JPRB, 0.39772705E-03_JPRB, 0.39745814E-03_JPRB, &
  & 0.39749853E-03_JPRB, 0.39754028E-03_JPRB, 0.39777740E-03_JPRB, 0.39795204E-03_JPRB  /)

RGHG1(:,89, 4) = (/ &
  & 0.38350751E-03_JPRB, 0.38352157E-03_JPRB, 0.38350928E-03_JPRB, 0.38349182E-03_JPRB, 0.38347742E-03_JPRB, 0.38347902E-03_JPRB, &
  & 0.38351878E-03_JPRB, 0.38347476E-03_JPRB, 0.38338978E-03_JPRB, 0.38332084E-03_JPRB, 0.38323191E-03_JPRB, 0.38310635E-03_JPRB, &
  & 0.38303589E-03_JPRB, 0.38293943E-03_JPRB, 0.38283000E-03_JPRB, 0.38279891E-03_JPRB, 0.38272312E-03_JPRB, 0.38270442E-03_JPRB, &
  & 0.38286801E-03_JPRB, 0.38284918E-03_JPRB, 0.38287997E-03_JPRB, 0.38280746E-03_JPRB, 0.38272181E-03_JPRB, 0.38269729E-03_JPRB, &
  & 0.38275477E-03_JPRB, 0.38285097E-03_JPRB, 0.38316383E-03_JPRB, 0.38333233E-03_JPRB, 0.38397838E-03_JPRB, 0.38501406E-03_JPRB, &
  & 0.38623848E-03_JPRB, 0.38754825E-03_JPRB, 0.38831522E-03_JPRB, 0.38871808E-03_JPRB, 0.38909219E-03_JPRB, 0.38909388E-03_JPRB, &
  & 0.38889236E-03_JPRB, 0.38911892E-03_JPRB, 0.38963545E-03_JPRB, 0.39002465E-03_JPRB, 0.39083549E-03_JPRB, 0.39131989E-03_JPRB, &
  & 0.39175918E-03_JPRB, 0.39244992E-03_JPRB, 0.39326622E-03_JPRB, 0.39383437E-03_JPRB, 0.39475111E-03_JPRB, 0.39545142E-03_JPRB, &
  & 0.39599891E-03_JPRB, 0.39646814E-03_JPRB, 0.39722923E-03_JPRB, 0.39764457E-03_JPRB, 0.39784606E-03_JPRB, 0.39824706E-03_JPRB, &
  & 0.39851794E-03_JPRB, 0.39885301E-03_JPRB, 0.39885639E-03_JPRB, 0.39829478E-03_JPRB, 0.39773648E-03_JPRB, 0.39745650E-03_JPRB, &
  & 0.39749466E-03_JPRB, 0.39753664E-03_JPRB, 0.39777683E-03_JPRB, 0.39795230E-03_JPRB  /)

RGHG1(:,90, 4) = (/ &
  & 0.38350741E-03_JPRB, 0.38352115E-03_JPRB, 0.38350856E-03_JPRB, 0.38349112E-03_JPRB, 0.38347675E-03_JPRB, 0.38347888E-03_JPRB, &
  & 0.38351810E-03_JPRB, 0.38347489E-03_JPRB, 0.38338907E-03_JPRB, 0.38332014E-03_JPRB, 0.38322811E-03_JPRB, 0.38310310E-03_JPRB, &
  & 0.38303520E-03_JPRB, 0.38293676E-03_JPRB, 0.38282448E-03_JPRB, 0.38281452E-03_JPRB, 0.38273833E-03_JPRB, 0.38276970E-03_JPRB, &
  & 0.38303638E-03_JPRB, 0.38299200E-03_JPRB, 0.38310474E-03_JPRB, 0.38312657E-03_JPRB, 0.38302255E-03_JPRB, 0.38300810E-03_JPRB, &
  & 0.38321046E-03_JPRB, 0.38347802E-03_JPRB, 0.38387643E-03_JPRB, 0.38406628E-03_JPRB, 0.38487338E-03_JPRB, 0.38616061E-03_JPRB, &
  & 0.38735349E-03_JPRB, 0.38867351E-03_JPRB, 0.38946591E-03_JPRB, 0.38951914E-03_JPRB, 0.38964629E-03_JPRB, 0.38947162E-03_JPRB, &
  & 0.38923990E-03_JPRB, 0.38947203E-03_JPRB, 0.39003085E-03_JPRB, 0.39039448E-03_JPRB, 0.39137305E-03_JPRB, 0.39185693E-03_JPRB, &
  & 0.39224995E-03_JPRB, 0.39303155E-03_JPRB, 0.39394582E-03_JPRB, 0.39451705E-03_JPRB, 0.39542160E-03_JPRB, 0.39608734E-03_JPRB, &
  & 0.39664157E-03_JPRB, 0.39707976E-03_JPRB, 0.39773484E-03_JPRB, 0.39801241E-03_JPRB, 0.39809949E-03_JPRB, 0.39848081E-03_JPRB, &
  & 0.39873492E-03_JPRB, 0.39904243E-03_JPRB, 0.39900952E-03_JPRB, 0.39838201E-03_JPRB, 0.39775824E-03_JPRB, 0.39745564E-03_JPRB, &
  & 0.39749256E-03_JPRB, 0.39753458E-03_JPRB, 0.39777697E-03_JPRB, 0.39795166E-03_JPRB  /)

RGHG1(:,91, 4) = (/ &
  & 0.38350845E-03_JPRB, 0.38352071E-03_JPRB, 0.38350722E-03_JPRB, 0.38349068E-03_JPRB, 0.38347720E-03_JPRB, 0.38347873E-03_JPRB, &
  & 0.38351795E-03_JPRB, 0.38347474E-03_JPRB, 0.38338803E-03_JPRB, 0.38331940E-03_JPRB, 0.38322411E-03_JPRB, 0.38309909E-03_JPRB, &
  & 0.38303505E-03_JPRB, 0.38293394E-03_JPRB, 0.38281751E-03_JPRB, 0.38283160E-03_JPRB, 0.38276817E-03_JPRB, 0.38287082E-03_JPRB, &
  & 0.38330469E-03_JPRB, 0.38324280E-03_JPRB, 0.38341254E-03_JPRB, 0.38359118E-03_JPRB, 0.38355012E-03_JPRB, 0.38355318E-03_JPRB, &
  & 0.38390463E-03_JPRB, 0.38459864E-03_JPRB, 0.38512504E-03_JPRB, 0.38546515E-03_JPRB, 0.38648548E-03_JPRB, 0.38867995E-03_JPRB, &
  & 0.38977780E-03_JPRB, 0.39069365E-03_JPRB, 0.39144863E-03_JPRB, 0.39067925E-03_JPRB, 0.39056527E-03_JPRB, 0.39007165E-03_JPRB, &
  & 0.38977014E-03_JPRB, 0.38992090E-03_JPRB, 0.39062256E-03_JPRB, 0.39099362E-03_JPRB, 0.39225877E-03_JPRB, 0.39265771E-03_JPRB, &
  & 0.39312497E-03_JPRB, 0.39403071E-03_JPRB, 0.39515583E-03_JPRB, 0.39580694E-03_JPRB, 0.39655855E-03_JPRB, 0.39729882E-03_JPRB, &
  & 0.39792849E-03_JPRB, 0.39826155E-03_JPRB, 0.39859798E-03_JPRB, 0.39856581E-03_JPRB, 0.39847174E-03_JPRB, 0.39885781E-03_JPRB, &
  & 0.39910539E-03_JPRB, 0.39940904E-03_JPRB, 0.39928556E-03_JPRB, 0.39853272E-03_JPRB, 0.39781481E-03_JPRB, 0.39745846E-03_JPRB, &
  & 0.39749063E-03_JPRB, 0.39753384E-03_JPRB, 0.39777712E-03_JPRB, 0.39795300E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ---GEMS----

RGHG1(:, 1, 5) = (/ &
  & 0.37184581E-03_JPRB, 0.37185598E-03_JPRB, 0.37187394E-03_JPRB, 0.37190052E-03_JPRB, 0.37193534E-03_JPRB, 0.37196833E-03_JPRB, &
  & 0.37199445E-03_JPRB, 0.37202157E-03_JPRB, 0.37204570E-03_JPRB, 0.37207477E-03_JPRB, 0.37210997E-03_JPRB, 0.37216208E-03_JPRB, &
  & 0.37223186E-03_JPRB, 0.37230208E-03_JPRB, 0.37236407E-03_JPRB, 0.37241009E-03_JPRB, 0.37244569E-03_JPRB, 0.37247555E-03_JPRB, &
  & 0.37250148E-03_JPRB, 0.37252400E-03_JPRB, 0.37254148E-03_JPRB, 0.37255169E-03_JPRB, 0.37255644E-03_JPRB, 0.37256211E-03_JPRB, &
  & 0.37256944E-03_JPRB, 0.37257553E-03_JPRB, 0.37258158E-03_JPRB, 0.37259012E-03_JPRB, 0.37260047E-03_JPRB, 0.37260981E-03_JPRB, &
  & 0.37261743E-03_JPRB, 0.37262448E-03_JPRB, 0.37263015E-03_JPRB, 0.37263143E-03_JPRB, 0.37262645E-03_JPRB, 0.37261261E-03_JPRB, &
  & 0.37258844E-03_JPRB, 0.37255855E-03_JPRB, 0.37252455E-03_JPRB, 0.37248338E-03_JPRB, 0.37242987E-03_JPRB, 0.37236813E-03_JPRB, &
  & 0.37229992E-03_JPRB, 0.37222759E-03_JPRB, 0.37215468E-03_JPRB, 0.37208017E-03_JPRB, 0.37200453E-03_JPRB, 0.37193034E-03_JPRB, &
  & 0.37186498E-03_JPRB, 0.37181107E-03_JPRB, 0.37176817E-03_JPRB, 0.37173437E-03_JPRB, 0.37170911E-03_JPRB, 0.37169019E-03_JPRB, &
  & 0.37167826E-03_JPRB, 0.37167139E-03_JPRB, 0.37166779E-03_JPRB, 0.37166377E-03_JPRB, 0.37165779E-03_JPRB, 0.37164963E-03_JPRB, &
  & 0.37164329E-03_JPRB, 0.37164044E-03_JPRB, 0.37163791E-03_JPRB, 0.37163697E-03_JPRB  /)

RGHG1(:, 2, 5) = (/ &
  & 0.37184581E-03_JPRB, 0.37185598E-03_JPRB, 0.37187394E-03_JPRB, 0.37190052E-03_JPRB, 0.37193534E-03_JPRB, 0.37196833E-03_JPRB, &
  & 0.37199445E-03_JPRB, 0.37202157E-03_JPRB, 0.37204570E-03_JPRB, 0.37207477E-03_JPRB, 0.37210997E-03_JPRB, 0.37216208E-03_JPRB, &
  & 0.37223186E-03_JPRB, 0.37230208E-03_JPRB, 0.37236407E-03_JPRB, 0.37241009E-03_JPRB, 0.37244569E-03_JPRB, 0.37247555E-03_JPRB, &
  & 0.37250148E-03_JPRB, 0.37252400E-03_JPRB, 0.37254148E-03_JPRB, 0.37255169E-03_JPRB, 0.37255644E-03_JPRB, 0.37256211E-03_JPRB, &
  & 0.37256944E-03_JPRB, 0.37257553E-03_JPRB, 0.37258158E-03_JPRB, 0.37259012E-03_JPRB, 0.37260047E-03_JPRB, 0.37260981E-03_JPRB, &
  & 0.37261743E-03_JPRB, 0.37262448E-03_JPRB, 0.37263015E-03_JPRB, 0.37263143E-03_JPRB, 0.37262645E-03_JPRB, 0.37261261E-03_JPRB, &
  & 0.37258844E-03_JPRB, 0.37255855E-03_JPRB, 0.37252455E-03_JPRB, 0.37248338E-03_JPRB, 0.37242987E-03_JPRB, 0.37236813E-03_JPRB, &
  & 0.37229992E-03_JPRB, 0.37222759E-03_JPRB, 0.37215468E-03_JPRB, 0.37208017E-03_JPRB, 0.37200453E-03_JPRB, 0.37193034E-03_JPRB, &
  & 0.37186498E-03_JPRB, 0.37181107E-03_JPRB, 0.37176817E-03_JPRB, 0.37173437E-03_JPRB, 0.37170911E-03_JPRB, 0.37169019E-03_JPRB, &
  & 0.37167826E-03_JPRB, 0.37167139E-03_JPRB, 0.37166779E-03_JPRB, 0.37166377E-03_JPRB, 0.37165779E-03_JPRB, 0.37164963E-03_JPRB, &
  & 0.37164329E-03_JPRB, 0.37164044E-03_JPRB, 0.37163791E-03_JPRB, 0.37163697E-03_JPRB  /)

RGHG1(:, 3, 5) = (/ &
  & 0.37184581E-03_JPRB, 0.37185598E-03_JPRB, 0.37187394E-03_JPRB, 0.37190052E-03_JPRB, 0.37193534E-03_JPRB, 0.37196833E-03_JPRB, &
  & 0.37199445E-03_JPRB, 0.37202157E-03_JPRB, 0.37204570E-03_JPRB, 0.37207477E-03_JPRB, 0.37210997E-03_JPRB, 0.37216208E-03_JPRB, &
  & 0.37223186E-03_JPRB, 0.37230208E-03_JPRB, 0.37236407E-03_JPRB, 0.37241009E-03_JPRB, 0.37244569E-03_JPRB, 0.37247555E-03_JPRB, &
  & 0.37250148E-03_JPRB, 0.37252400E-03_JPRB, 0.37254148E-03_JPRB, 0.37255169E-03_JPRB, 0.37255644E-03_JPRB, 0.37256211E-03_JPRB, &
  & 0.37256944E-03_JPRB, 0.37257553E-03_JPRB, 0.37258158E-03_JPRB, 0.37259012E-03_JPRB, 0.37260047E-03_JPRB, 0.37260981E-03_JPRB, &
  & 0.37261743E-03_JPRB, 0.37262448E-03_JPRB, 0.37263015E-03_JPRB, 0.37263143E-03_JPRB, 0.37262645E-03_JPRB, 0.37261261E-03_JPRB, &
  & 0.37258844E-03_JPRB, 0.37255855E-03_JPRB, 0.37252455E-03_JPRB, 0.37248338E-03_JPRB, 0.37242987E-03_JPRB, 0.37236813E-03_JPRB, &
  & 0.37229992E-03_JPRB, 0.37222759E-03_JPRB, 0.37215468E-03_JPRB, 0.37208017E-03_JPRB, 0.37200453E-03_JPRB, 0.37193034E-03_JPRB, &
  & 0.37186498E-03_JPRB, 0.37181107E-03_JPRB, 0.37176817E-03_JPRB, 0.37173437E-03_JPRB, 0.37170911E-03_JPRB, 0.37169019E-03_JPRB, &
  & 0.37167826E-03_JPRB, 0.37167139E-03_JPRB, 0.37166779E-03_JPRB, 0.37166377E-03_JPRB, 0.37165779E-03_JPRB, 0.37164963E-03_JPRB, &
  & 0.37164329E-03_JPRB, 0.37164044E-03_JPRB, 0.37163791E-03_JPRB, 0.37163697E-03_JPRB  /)

RGHG1(:, 4, 5) = (/ &
  & 0.37184583E-03_JPRB, 0.37185587E-03_JPRB, 0.37187373E-03_JPRB, 0.37190020E-03_JPRB, 0.37193489E-03_JPRB, 0.37196781E-03_JPRB, &
  & 0.37199391E-03_JPRB, 0.37202100E-03_JPRB, 0.37204509E-03_JPRB, 0.37207412E-03_JPRB, 0.37210930E-03_JPRB, 0.37216143E-03_JPRB, &
  & 0.37223128E-03_JPRB, 0.37230161E-03_JPRB, 0.37236365E-03_JPRB, 0.37240973E-03_JPRB, 0.37244541E-03_JPRB, 0.37247537E-03_JPRB, &
  & 0.37250141E-03_JPRB, 0.37252404E-03_JPRB, 0.37254161E-03_JPRB, 0.37255192E-03_JPRB, 0.37255676E-03_JPRB, 0.37256248E-03_JPRB, &
  & 0.37256986E-03_JPRB, 0.37257602E-03_JPRB, 0.37258214E-03_JPRB, 0.37259074E-03_JPRB, 0.37260115E-03_JPRB, 0.37261058E-03_JPRB, &
  & 0.37261832E-03_JPRB, 0.37262553E-03_JPRB, 0.37263138E-03_JPRB, 0.37263279E-03_JPRB, 0.37262789E-03_JPRB, 0.37261410E-03_JPRB, &
  & 0.37258999E-03_JPRB, 0.37256013E-03_JPRB, 0.37252617E-03_JPRB, 0.37248505E-03_JPRB, 0.37243163E-03_JPRB, 0.37236995E-03_JPRB, &
  & 0.37230173E-03_JPRB, 0.37222935E-03_JPRB, 0.37215637E-03_JPRB, 0.37208176E-03_JPRB, 0.37200597E-03_JPRB, 0.37193152E-03_JPRB, &
  & 0.37186577E-03_JPRB, 0.37181146E-03_JPRB, 0.37176824E-03_JPRB, 0.37173421E-03_JPRB, 0.37170881E-03_JPRB, 0.37168980E-03_JPRB, &
  & 0.37167782E-03_JPRB, 0.37167092E-03_JPRB, 0.37166733E-03_JPRB, 0.37166332E-03_JPRB, 0.37165736E-03_JPRB, 0.37164921E-03_JPRB, &
  & 0.37164285E-03_JPRB, 0.37163997E-03_JPRB, 0.37163743E-03_JPRB, 0.37163648E-03_JPRB  /)

RGHG1(:, 5, 5) = (/ &
  & 0.37184663E-03_JPRB, 0.37185100E-03_JPRB, 0.37186390E-03_JPRB, 0.37188478E-03_JPRB, 0.37191364E-03_JPRB, 0.37194291E-03_JPRB, &
  & 0.37196836E-03_JPRB, 0.37199371E-03_JPRB, 0.37201616E-03_JPRB, 0.37204316E-03_JPRB, 0.37207783E-03_JPRB, 0.37213086E-03_JPRB, &
  & 0.37220364E-03_JPRB, 0.37227912E-03_JPRB, 0.37234365E-03_JPRB, 0.37239243E-03_JPRB, 0.37243202E-03_JPRB, 0.37246671E-03_JPRB, &
  & 0.37249799E-03_JPRB, 0.37252580E-03_JPRB, 0.37254781E-03_JPRB, 0.37256299E-03_JPRB, 0.37257225E-03_JPRB, 0.37258040E-03_JPRB, &
  & 0.37258994E-03_JPRB, 0.37259926E-03_JPRB, 0.37260869E-03_JPRB, 0.37262010E-03_JPRB, 0.37263366E-03_JPRB, 0.37264705E-03_JPRB, &
  & 0.37266030E-03_JPRB, 0.37267551E-03_JPRB, 0.37268977E-03_JPRB, 0.37269719E-03_JPRB, 0.37269594E-03_JPRB, 0.37268495E-03_JPRB, &
  & 0.37266338E-03_JPRB, 0.37263538E-03_JPRB, 0.37260298E-03_JPRB, 0.37256446E-03_JPRB, 0.37251490E-03_JPRB, 0.37245594E-03_JPRB, &
  & 0.37238762E-03_JPRB, 0.37231278E-03_JPRB, 0.37223643E-03_JPRB, 0.37215744E-03_JPRB, 0.37207456E-03_JPRB, 0.37198748E-03_JPRB, &
  & 0.37190349E-03_JPRB, 0.37183022E-03_JPRB, 0.37177136E-03_JPRB, 0.37172633E-03_JPRB, 0.37169427E-03_JPRB, 0.37167102E-03_JPRB, &
  & 0.37165661E-03_JPRB, 0.37164873E-03_JPRB, 0.37164544E-03_JPRB, 0.37164240E-03_JPRB, 0.37163711E-03_JPRB, 0.37162902E-03_JPRB, &
  & 0.37162196E-03_JPRB, 0.37161784E-03_JPRB, 0.37161461E-03_JPRB, 0.37161318E-03_JPRB  /)

RGHG1(:, 6, 5) = (/ &
  & 0.37184784E-03_JPRB, 0.37184369E-03_JPRB, 0.37184916E-03_JPRB, 0.37186164E-03_JPRB, 0.37188175E-03_JPRB, 0.37190555E-03_JPRB, &
  & 0.37193001E-03_JPRB, 0.37195278E-03_JPRB, 0.37197276E-03_JPRB, 0.37199670E-03_JPRB, 0.37203060E-03_JPRB, 0.37208498E-03_JPRB, &
  & 0.37216217E-03_JPRB, 0.37224538E-03_JPRB, 0.37231365E-03_JPRB, 0.37236649E-03_JPRB, 0.37241192E-03_JPRB, 0.37245373E-03_JPRB, &
  & 0.37249286E-03_JPRB, 0.37252846E-03_JPRB, 0.37255712E-03_JPRB, 0.37257959E-03_JPRB, 0.37259548E-03_JPRB, 0.37260728E-03_JPRB, &
  & 0.37262006E-03_JPRB, 0.37263414E-03_JPRB, 0.37264853E-03_JPRB, 0.37266415E-03_JPRB, 0.37268244E-03_JPRB, 0.37270176E-03_JPRB, &
  & 0.37272329E-03_JPRB, 0.37275049E-03_JPRB, 0.37277738E-03_JPRB, 0.37279382E-03_JPRB, 0.37279804E-03_JPRB, 0.37279126E-03_JPRB, &
  & 0.37277351E-03_JPRB, 0.37274829E-03_JPRB, 0.37271823E-03_JPRB, 0.37268359E-03_JPRB, 0.37263983E-03_JPRB, 0.37258497E-03_JPRB, &
  & 0.37251649E-03_JPRB, 0.37243795E-03_JPRB, 0.37235654E-03_JPRB, 0.37227099E-03_JPRB, 0.37217747E-03_JPRB, 0.37207145E-03_JPRB, &
  & 0.37196009E-03_JPRB, 0.37185836E-03_JPRB, 0.37177605E-03_JPRB, 0.37171451E-03_JPRB, 0.37167247E-03_JPRB, 0.37164285E-03_JPRB, &
  & 0.37162480E-03_JPRB, 0.37161544E-03_JPRB, 0.37161260E-03_JPRB, 0.37161101E-03_JPRB, 0.37160671E-03_JPRB, 0.37159873E-03_JPRB, &
  & 0.37159061E-03_JPRB, 0.37158462E-03_JPRB, 0.37158038E-03_JPRB, 0.37157821E-03_JPRB  /)

RGHG1(:, 7, 5) = (/ &
  & 0.37180177E-03_JPRB, 0.37179908E-03_JPRB, 0.37180413E-03_JPRB, 0.37181275E-03_JPRB, 0.37182588E-03_JPRB, 0.37184355E-03_JPRB, &
  & 0.37186062E-03_JPRB, 0.37187948E-03_JPRB, 0.37189685E-03_JPRB, 0.37191825E-03_JPRB, 0.37195117E-03_JPRB, 0.37200498E-03_JPRB, &
  & 0.37208274E-03_JPRB, 0.37217227E-03_JPRB, 0.37224666E-03_JPRB, 0.37230739E-03_JPRB, 0.37236224E-03_JPRB, 0.37241550E-03_JPRB, &
  & 0.37246880E-03_JPRB, 0.37251982E-03_JPRB, 0.37256401E-03_JPRB, 0.37259998E-03_JPRB, 0.37262935E-03_JPRB, 0.37265245E-03_JPRB, &
  & 0.37267496E-03_JPRB, 0.37270142E-03_JPRB, 0.37272810E-03_JPRB, 0.37275690E-03_JPRB, 0.37279260E-03_JPRB, 0.37282884E-03_JPRB, &
  & 0.37286834E-03_JPRB, 0.37291873E-03_JPRB, 0.37296574E-03_JPRB, 0.37299700E-03_JPRB, 0.37301320E-03_JPRB, 0.37301311E-03_JPRB, &
  & 0.37299871E-03_JPRB, 0.37297622E-03_JPRB, 0.37295147E-03_JPRB, 0.37292479E-03_JPRB, 0.37288784E-03_JPRB, 0.37283814E-03_JPRB, &
  & 0.37277087E-03_JPRB, 0.37267961E-03_JPRB, 0.37257237E-03_JPRB, 0.37245525E-03_JPRB, 0.37232070E-03_JPRB, 0.37216614E-03_JPRB, &
  & 0.37200962E-03_JPRB, 0.37187044E-03_JPRB, 0.37175617E-03_JPRB, 0.37167305E-03_JPRB, 0.37161916E-03_JPRB, 0.37158384E-03_JPRB, &
  & 0.37156309E-03_JPRB, 0.37155239E-03_JPRB, 0.37154910E-03_JPRB, 0.37154788E-03_JPRB, 0.37154489E-03_JPRB, 0.37153750E-03_JPRB, &
  & 0.37152784E-03_JPRB, 0.37152022E-03_JPRB, 0.37151575E-03_JPRB, 0.37151430E-03_JPRB  /)

RGHG1(:, 8, 5) = (/ &
  & 0.37172708E-03_JPRB, 0.37172777E-03_JPRB, 0.37173382E-03_JPRB, 0.37174017E-03_JPRB, 0.37174699E-03_JPRB, 0.37175851E-03_JPRB, &
  & 0.37176801E-03_JPRB, 0.37178129E-03_JPRB, 0.37179534E-03_JPRB, 0.37181519E-03_JPRB, 0.37184842E-03_JPRB, 0.37190180E-03_JPRB, &
  & 0.37197920E-03_JPRB, 0.37207418E-03_JPRB, 0.37215970E-03_JPRB, 0.37223476E-03_JPRB, 0.37230747E-03_JPRB, 0.37237982E-03_JPRB, &
  & 0.37245266E-03_JPRB, 0.37252487E-03_JPRB, 0.37259040E-03_JPRB, 0.37264499E-03_JPRB, 0.37269133E-03_JPRB, 0.37273178E-03_JPRB, &
  & 0.37277202E-03_JPRB, 0.37282021E-03_JPRB, 0.37287116E-03_JPRB, 0.37292906E-03_JPRB, 0.37299739E-03_JPRB, 0.37306431E-03_JPRB, &
  & 0.37313298E-03_JPRB, 0.37321042E-03_JPRB, 0.37327727E-03_JPRB, 0.37332046E-03_JPRB, 0.37334171E-03_JPRB, 0.37334454E-03_JPRB, &
  & 0.37333418E-03_JPRB, 0.37331666E-03_JPRB, 0.37329655E-03_JPRB, 0.37327189E-03_JPRB, 0.37323400E-03_JPRB, 0.37318329E-03_JPRB, &
  & 0.37311586E-03_JPRB, 0.37300959E-03_JPRB, 0.37286496E-03_JPRB, 0.37269673E-03_JPRB, 0.37249700E-03_JPRB, 0.37227183E-03_JPRB, &
  & 0.37205620E-03_JPRB, 0.37187081E-03_JPRB, 0.37171935E-03_JPRB, 0.37161004E-03_JPRB, 0.37154015E-03_JPRB, 0.37149804E-03_JPRB, &
  & 0.37147527E-03_JPRB, 0.37146305E-03_JPRB, 0.37145765E-03_JPRB, 0.37145498E-03_JPRB, 0.37145254E-03_JPRB, 0.37144643E-03_JPRB, &
  & 0.37143713E-03_JPRB, 0.37142867E-03_JPRB, 0.37142299E-03_JPRB, 0.37142077E-03_JPRB  /)

RGHG1(:, 9, 5) = (/ &
  & 0.37163581E-03_JPRB, 0.37163850E-03_JPRB, 0.37164347E-03_JPRB, 0.37164727E-03_JPRB, 0.37164948E-03_JPRB, 0.37165518E-03_JPRB, &
  & 0.37165925E-03_JPRB, 0.37166657E-03_JPRB, 0.37167790E-03_JPRB, 0.37169810E-03_JPRB, 0.37173331E-03_JPRB, 0.37178762E-03_JPRB, &
  & 0.37186618E-03_JPRB, 0.37196768E-03_JPRB, 0.37207197E-03_JPRB, 0.37217315E-03_JPRB, 0.37227837E-03_JPRB, 0.37238441E-03_JPRB, &
  & 0.37248593E-03_JPRB, 0.37258376E-03_JPRB, 0.37267225E-03_JPRB, 0.37274842E-03_JPRB, 0.37281462E-03_JPRB, 0.37287754E-03_JPRB, &
  & 0.37294245E-03_JPRB, 0.37301639E-03_JPRB, 0.37309972E-03_JPRB, 0.37319623E-03_JPRB, 0.37330367E-03_JPRB, 0.37341141E-03_JPRB, &
  & 0.37351551E-03_JPRB, 0.37361700E-03_JPRB, 0.37369861E-03_JPRB, 0.37374732E-03_JPRB, 0.37376364E-03_JPRB, 0.37376221E-03_JPRB, &
  & 0.37375564E-03_JPRB, 0.37374404E-03_JPRB, 0.37372467E-03_JPRB, 0.37369341E-03_JPRB, 0.37364557E-03_JPRB, 0.37358780E-03_JPRB, &
  & 0.37351807E-03_JPRB, 0.37339833E-03_JPRB, 0.37321131E-03_JPRB, 0.37297912E-03_JPRB, 0.37270155E-03_JPRB, 0.37239169E-03_JPRB, &
  & 0.37210048E-03_JPRB, 0.37185755E-03_JPRB, 0.37166600E-03_JPRB, 0.37152563E-03_JPRB, 0.37143532E-03_JPRB, 0.37138559E-03_JPRB, &
  & 0.37136216E-03_JPRB, 0.37134888E-03_JPRB, 0.37134038E-03_JPRB, 0.37133368E-03_JPRB, 0.37132928E-03_JPRB, 0.37132513E-03_JPRB, &
  & 0.37132023E-03_JPRB, 0.37131430E-03_JPRB, 0.37130839E-03_JPRB, 0.37130560E-03_JPRB  /)

RGHG1(:,10, 5) = (/ &
  & 0.37154377E-03_JPRB, 0.37154588E-03_JPRB, 0.37154598E-03_JPRB, 0.37154414E-03_JPRB, 0.37154237E-03_JPRB, 0.37154263E-03_JPRB, &
  & 0.37154329E-03_JPRB, 0.37154788E-03_JPRB, 0.37155892E-03_JPRB, 0.37158163E-03_JPRB, 0.37162047E-03_JPRB, 0.37167996E-03_JPRB, &
  & 0.37176654E-03_JPRB, 0.37188090E-03_JPRB, 0.37201424E-03_JPRB, 0.37216105E-03_JPRB, 0.37231932E-03_JPRB, 0.37248136E-03_JPRB, &
  & 0.37263016E-03_JPRB, 0.37276245E-03_JPRB, 0.37287961E-03_JPRB, 0.37298350E-03_JPRB, 0.37307762E-03_JPRB, 0.37316701E-03_JPRB, &
  & 0.37325506E-03_JPRB, 0.37334303E-03_JPRB, 0.37344444E-03_JPRB, 0.37355865E-03_JPRB, 0.37368118E-03_JPRB, 0.37381491E-03_JPRB, &
  & 0.37394181E-03_JPRB, 0.37405250E-03_JPRB, 0.37413608E-03_JPRB, 0.37418319E-03_JPRB, 0.37419568E-03_JPRB, 0.37418766E-03_JPRB, &
  & 0.37417876E-03_JPRB, 0.37416491E-03_JPRB, 0.37413797E-03_JPRB, 0.37409663E-03_JPRB, 0.37403718E-03_JPRB, 0.37397116E-03_JPRB, &
  & 0.37389582E-03_JPRB, 0.37376700E-03_JPRB, 0.37354743E-03_JPRB, 0.37326390E-03_JPRB, 0.37292034E-03_JPRB, 0.37252861E-03_JPRB, &
  & 0.37215047E-03_JPRB, 0.37184113E-03_JPRB, 0.37160429E-03_JPRB, 0.37142430E-03_JPRB, 0.37131058E-03_JPRB, 0.37125191E-03_JPRB, &
  & 0.37122771E-03_JPRB, 0.37121468E-03_JPRB, 0.37120523E-03_JPRB, 0.37119348E-03_JPRB, 0.37118305E-03_JPRB, 0.37117999E-03_JPRB, &
  & 0.37118267E-03_JPRB, 0.37118463E-03_JPRB, 0.37118416E-03_JPRB, 0.37118669E-03_JPRB  /)

RGHG1(:,11, 5) = (/ &
  & 0.37144212E-03_JPRB, 0.37144197E-03_JPRB, 0.37143808E-03_JPRB, 0.37143047E-03_JPRB, 0.37142465E-03_JPRB, 0.37142218E-03_JPRB, &
  & 0.37142258E-03_JPRB, 0.37142854E-03_JPRB, 0.37144158E-03_JPRB, 0.37146945E-03_JPRB, 0.37151761E-03_JPRB, 0.37159334E-03_JPRB, &
  & 0.37170085E-03_JPRB, 0.37184001E-03_JPRB, 0.37201137E-03_JPRB, 0.37221760E-03_JPRB, 0.37244264E-03_JPRB, 0.37267634E-03_JPRB, &
  & 0.37289567E-03_JPRB, 0.37309111E-03_JPRB, 0.37327582E-03_JPRB, 0.37344304E-03_JPRB, 0.37358953E-03_JPRB, 0.37371401E-03_JPRB, &
  & 0.37381470E-03_JPRB, 0.37389311E-03_JPRB, 0.37397328E-03_JPRB, 0.37405662E-03_JPRB, 0.37414451E-03_JPRB, 0.37425051E-03_JPRB, &
  & 0.37435971E-03_JPRB, 0.37445192E-03_JPRB, 0.37451610E-03_JPRB, 0.37455173E-03_JPRB, 0.37456345E-03_JPRB, 0.37455086E-03_JPRB, &
  & 0.37452567E-03_JPRB, 0.37449025E-03_JPRB, 0.37444388E-03_JPRB, 0.37438984E-03_JPRB, 0.37431954E-03_JPRB, 0.37424090E-03_JPRB, &
  & 0.37415338E-03_JPRB, 0.37401698E-03_JPRB, 0.37378783E-03_JPRB, 0.37348878E-03_JPRB, 0.37310068E-03_JPRB, 0.37264044E-03_JPRB, &
  & 0.37219657E-03_JPRB, 0.37183707E-03_JPRB, 0.37155167E-03_JPRB, 0.37132670E-03_JPRB, 0.37119216E-03_JPRB, 0.37112199E-03_JPRB, &
  & 0.37109248E-03_JPRB, 0.37108031E-03_JPRB, 0.37107446E-03_JPRB, 0.37105950E-03_JPRB, 0.37103880E-03_JPRB, 0.37103195E-03_JPRB, &
  & 0.37103947E-03_JPRB, 0.37105167E-03_JPRB, 0.37106195E-03_JPRB, 0.37106896E-03_JPRB  /)

RGHG1(:,12, 5) = (/ &
  & 0.37132277E-03_JPRB, 0.37131788E-03_JPRB, 0.37131448E-03_JPRB, 0.37130887E-03_JPRB, 0.37130554E-03_JPRB, 0.37130592E-03_JPRB, &
  & 0.37131071E-03_JPRB, 0.37132005E-03_JPRB, 0.37133868E-03_JPRB, 0.37137929E-03_JPRB, 0.37144964E-03_JPRB, 0.37155703E-03_JPRB, &
  & 0.37170055E-03_JPRB, 0.37187685E-03_JPRB, 0.37208340E-03_JPRB, 0.37233216E-03_JPRB, 0.37260998E-03_JPRB, 0.37290575E-03_JPRB, &
  & 0.37319613E-03_JPRB, 0.37348659E-03_JPRB, 0.37379867E-03_JPRB, 0.37408810E-03_JPRB, 0.37432596E-03_JPRB, 0.37450085E-03_JPRB, &
  & 0.37460728E-03_JPRB, 0.37466108E-03_JPRB, 0.37469235E-03_JPRB, 0.37471272E-03_JPRB, 0.37472900E-03_JPRB, 0.37475137E-03_JPRB, &
  & 0.37478459E-03_JPRB, 0.37482285E-03_JPRB, 0.37485138E-03_JPRB, 0.37486627E-03_JPRB, 0.37486352E-03_JPRB, 0.37483629E-03_JPRB, &
  & 0.37478632E-03_JPRB, 0.37471844E-03_JPRB, 0.37464480E-03_JPRB, 0.37456930E-03_JPRB, 0.37448867E-03_JPRB, 0.37439675E-03_JPRB, &
  & 0.37429198E-03_JPRB, 0.37414211E-03_JPRB, 0.37391265E-03_JPRB, 0.37361212E-03_JPRB, 0.37319703E-03_JPRB, 0.37269335E-03_JPRB, &
  & 0.37222584E-03_JPRB, 0.37185196E-03_JPRB, 0.37153822E-03_JPRB, 0.37128699E-03_JPRB, 0.37114136E-03_JPRB, 0.37106365E-03_JPRB, &
  & 0.37102956E-03_JPRB, 0.37102296E-03_JPRB, 0.37102607E-03_JPRB, 0.37100664E-03_JPRB, 0.37097139E-03_JPRB, 0.37095088E-03_JPRB, &
  & 0.37095466E-03_JPRB, 0.37097219E-03_JPRB, 0.37099062E-03_JPRB, 0.37099544E-03_JPRB  /)

RGHG1(:,13, 5) = (/ &
  & 0.37124317E-03_JPRB, 0.37124225E-03_JPRB, 0.37124572E-03_JPRB, 0.37124684E-03_JPRB, 0.37124920E-03_JPRB, 0.37125404E-03_JPRB, &
  & 0.37126177E-03_JPRB, 0.37127554E-03_JPRB, 0.37130373E-03_JPRB, 0.37136596E-03_JPRB, 0.37146666E-03_JPRB, 0.37161419E-03_JPRB, &
  & 0.37179924E-03_JPRB, 0.37201447E-03_JPRB, 0.37224412E-03_JPRB, 0.37251137E-03_JPRB, 0.37281107E-03_JPRB, 0.37312848E-03_JPRB, &
  & 0.37345089E-03_JPRB, 0.37382973E-03_JPRB, 0.37427927E-03_JPRB, 0.37470502E-03_JPRB, 0.37505322E-03_JPRB, 0.37528900E-03_JPRB, &
  & 0.37541148E-03_JPRB, 0.37545465E-03_JPRB, 0.37545582E-03_JPRB, 0.37542746E-03_JPRB, 0.37537987E-03_JPRB, 0.37531822E-03_JPRB, &
  & 0.37525709E-03_JPRB, 0.37521445E-03_JPRB, 0.37518658E-03_JPRB, 0.37516103E-03_JPRB, 0.37512952E-03_JPRB, 0.37508083E-03_JPRB, &
  & 0.37500835E-03_JPRB, 0.37491333E-03_JPRB, 0.37480817E-03_JPRB, 0.37470146E-03_JPRB, 0.37460690E-03_JPRB, 0.37450482E-03_JPRB, &
  & 0.37438445E-03_JPRB, 0.37422707E-03_JPRB, 0.37399035E-03_JPRB, 0.37366956E-03_JPRB, 0.37324170E-03_JPRB, 0.37274119E-03_JPRB, &
  & 0.37228964E-03_JPRB, 0.37193380E-03_JPRB, 0.37162960E-03_JPRB, 0.37138066E-03_JPRB, 0.37123290E-03_JPRB, 0.37115633E-03_JPRB, &
  & 0.37113242E-03_JPRB, 0.37114832E-03_JPRB, 0.37116275E-03_JPRB, 0.37113865E-03_JPRB, 0.37109502E-03_JPRB, 0.37105836E-03_JPRB, &
  & 0.37104809E-03_JPRB, 0.37105379E-03_JPRB, 0.37106265E-03_JPRB, 0.37106285E-03_JPRB  /)

RGHG1(:,14, 5) = (/ &
  & 0.37129836E-03_JPRB, 0.37130188E-03_JPRB, 0.37131074E-03_JPRB, 0.37131888E-03_JPRB, 0.37132273E-03_JPRB, 0.37132553E-03_JPRB, &
  & 0.37133034E-03_JPRB, 0.37134485E-03_JPRB, 0.37138147E-03_JPRB, 0.37145988E-03_JPRB, 0.37158092E-03_JPRB, 0.37175671E-03_JPRB, &
  & 0.37197364E-03_JPRB, 0.37221145E-03_JPRB, 0.37245317E-03_JPRB, 0.37273098E-03_JPRB, 0.37301197E-03_JPRB, 0.37329480E-03_JPRB, &
  & 0.37360513E-03_JPRB, 0.37402243E-03_JPRB, 0.37454669E-03_JPRB, 0.37507589E-03_JPRB, 0.37551749E-03_JPRB, 0.37581619E-03_JPRB, &
  & 0.37597325E-03_JPRB, 0.37603193E-03_JPRB, 0.37604141E-03_JPRB, 0.37600303E-03_JPRB, 0.37593203E-03_JPRB, 0.37583411E-03_JPRB, &
  & 0.37572172E-03_JPRB, 0.37561571E-03_JPRB, 0.37552828E-03_JPRB, 0.37544572E-03_JPRB, 0.37537185E-03_JPRB, 0.37529709E-03_JPRB, &
  & 0.37520075E-03_JPRB, 0.37507930E-03_JPRB, 0.37493944E-03_JPRB, 0.37480585E-03_JPRB, 0.37469225E-03_JPRB, 0.37457530E-03_JPRB, &
  & 0.37444672E-03_JPRB, 0.37429406E-03_JPRB, 0.37404854E-03_JPRB, 0.37370388E-03_JPRB, 0.37327434E-03_JPRB, 0.37280251E-03_JPRB, &
  & 0.37240252E-03_JPRB, 0.37209579E-03_JPRB, 0.37183682E-03_JPRB, 0.37162573E-03_JPRB, 0.37149583E-03_JPRB, 0.37142621E-03_JPRB, &
  & 0.37141909E-03_JPRB, 0.37146763E-03_JPRB, 0.37149741E-03_JPRB, 0.37148471E-03_JPRB, 0.37145575E-03_JPRB, 0.37142160E-03_JPRB, &
  & 0.37139729E-03_JPRB, 0.37138701E-03_JPRB, 0.37137042E-03_JPRB, 0.37135030E-03_JPRB  /)

RGHG1(:,15, 5) = (/ &
  & 0.37157367E-03_JPRB, 0.37157187E-03_JPRB, 0.37157466E-03_JPRB, 0.37157846E-03_JPRB, 0.37157110E-03_JPRB, 0.37155980E-03_JPRB, &
  & 0.37155476E-03_JPRB, 0.37155986E-03_JPRB, 0.37159012E-03_JPRB, 0.37166056E-03_JPRB, 0.37177542E-03_JPRB, 0.37194607E-03_JPRB, &
  & 0.37216327E-03_JPRB, 0.37240036E-03_JPRB, 0.37264191E-03_JPRB, 0.37290354E-03_JPRB, 0.37313094E-03_JPRB, 0.37335326E-03_JPRB, &
  & 0.37362551E-03_JPRB, 0.37402959E-03_JPRB, 0.37456657E-03_JPRB, 0.37515021E-03_JPRB, 0.37566564E-03_JPRB, 0.37602766E-03_JPRB, &
  & 0.37623838E-03_JPRB, 0.37633432E-03_JPRB, 0.37637148E-03_JPRB, 0.37636482E-03_JPRB, 0.37631271E-03_JPRB, 0.37622556E-03_JPRB, &
  & 0.37611209E-03_JPRB, 0.37598036E-03_JPRB, 0.37584064E-03_JPRB, 0.37570095E-03_JPRB, 0.37557287E-03_JPRB, 0.37545573E-03_JPRB, &
  & 0.37532381E-03_JPRB, 0.37516815E-03_JPRB, 0.37499998E-03_JPRB, 0.37484614E-03_JPRB, 0.37470613E-03_JPRB, 0.37456518E-03_JPRB, &
  & 0.37443121E-03_JPRB, 0.37426941E-03_JPRB, 0.37401721E-03_JPRB, 0.37367486E-03_JPRB, 0.37324842E-03_JPRB, 0.37281793E-03_JPRB, &
  & 0.37249546E-03_JPRB, 0.37225600E-03_JPRB, 0.37207177E-03_JPRB, 0.37193572E-03_JPRB, 0.37185376E-03_JPRB, 0.37180229E-03_JPRB, &
  & 0.37180074E-03_JPRB, 0.37186032E-03_JPRB, 0.37191050E-03_JPRB, 0.37192469E-03_JPRB, 0.37192450E-03_JPRB, 0.37190431E-03_JPRB, &
  & 0.37187873E-03_JPRB, 0.37185588E-03_JPRB, 0.37182008E-03_JPRB, 0.37180320E-03_JPRB  /)

RGHG1(:,16, 5) = (/ &
  & 0.37209249E-03_JPRB, 0.37208069E-03_JPRB, 0.37206110E-03_JPRB, 0.37203416E-03_JPRB, 0.37199520E-03_JPRB, 0.37195582E-03_JPRB, &
  & 0.37192334E-03_JPRB, 0.37190363E-03_JPRB, 0.37190443E-03_JPRB, 0.37194359E-03_JPRB, 0.37202564E-03_JPRB, 0.37216887E-03_JPRB, &
  & 0.37235900E-03_JPRB, 0.37257454E-03_JPRB, 0.37278920E-03_JPRB, 0.37300022E-03_JPRB, 0.37316944E-03_JPRB, 0.37334250E-03_JPRB, &
  & 0.37357783E-03_JPRB, 0.37395593E-03_JPRB, 0.37448472E-03_JPRB, 0.37508308E-03_JPRB, 0.37563273E-03_JPRB, 0.37603212E-03_JPRB, &
  & 0.37628797E-03_JPRB, 0.37643989E-03_JPRB, 0.37653309E-03_JPRB, 0.37658572E-03_JPRB, 0.37659464E-03_JPRB, 0.37655710E-03_JPRB, &
  & 0.37646648E-03_JPRB, 0.37631819E-03_JPRB, 0.37611914E-03_JPRB, 0.37591280E-03_JPRB, 0.37572268E-03_JPRB, 0.37555392E-03_JPRB, &
  & 0.37538782E-03_JPRB, 0.37520494E-03_JPRB, 0.37500248E-03_JPRB, 0.37480844E-03_JPRB, 0.37462657E-03_JPRB, 0.37445750E-03_JPRB, &
  & 0.37431470E-03_JPRB, 0.37413144E-03_JPRB, 0.37386677E-03_JPRB, 0.37353420E-03_JPRB, 0.37312698E-03_JPRB, 0.37276903E-03_JPRB, &
  & 0.37252413E-03_JPRB, 0.37235463E-03_JPRB, 0.37224348E-03_JPRB, 0.37218628E-03_JPRB, 0.37215460E-03_JPRB, 0.37212959E-03_JPRB, &
  & 0.37213405E-03_JPRB, 0.37217613E-03_JPRB, 0.37222677E-03_JPRB, 0.37226249E-03_JPRB, 0.37228396E-03_JPRB, 0.37227968E-03_JPRB, &
  & 0.37225980E-03_JPRB, 0.37223279E-03_JPRB, 0.37219827E-03_JPRB, 0.37220125E-03_JPRB  /)

RGHG1(:,17, 5) = (/ &
  & 0.37269081E-03_JPRB, 0.37266874E-03_JPRB, 0.37262997E-03_JPRB, 0.37256947E-03_JPRB, 0.37249714E-03_JPRB, 0.37241875E-03_JPRB, &
  & 0.37234421E-03_JPRB, 0.37228459E-03_JPRB, 0.37224570E-03_JPRB, 0.37224538E-03_JPRB, 0.37229400E-03_JPRB, 0.37240658E-03_JPRB, &
  & 0.37256307E-03_JPRB, 0.37273777E-03_JPRB, 0.37290981E-03_JPRB, 0.37306764E-03_JPRB, 0.37319917E-03_JPRB, 0.37334810E-03_JPRB, &
  & 0.37356784E-03_JPRB, 0.37393605E-03_JPRB, 0.37445073E-03_JPRB, 0.37501360E-03_JPRB, 0.37551089E-03_JPRB, 0.37589735E-03_JPRB, &
  & 0.37619499E-03_JPRB, 0.37642513E-03_JPRB, 0.37660994E-03_JPRB, 0.37676099E-03_JPRB, 0.37686564E-03_JPRB, 0.37691007E-03_JPRB, &
  & 0.37685041E-03_JPRB, 0.37666544E-03_JPRB, 0.37640864E-03_JPRB, 0.37614476E-03_JPRB, 0.37588309E-03_JPRB, 0.37564740E-03_JPRB, &
  & 0.37543418E-03_JPRB, 0.37521739E-03_JPRB, 0.37497794E-03_JPRB, 0.37473741E-03_JPRB, 0.37450333E-03_JPRB, 0.37430907E-03_JPRB, &
  & 0.37415406E-03_JPRB, 0.37395559E-03_JPRB, 0.37367935E-03_JPRB, 0.37333708E-03_JPRB, 0.37296692E-03_JPRB, 0.37268401E-03_JPRB, &
  & 0.37250690E-03_JPRB, 0.37239236E-03_JPRB, 0.37233817E-03_JPRB, 0.37232799E-03_JPRB, 0.37232749E-03_JPRB, 0.37232440E-03_JPRB, &
  & 0.37233578E-03_JPRB, 0.37236100E-03_JPRB, 0.37239599E-03_JPRB, 0.37243862E-03_JPRB, 0.37246742E-03_JPRB, 0.37247494E-03_JPRB, &
  & 0.37246998E-03_JPRB, 0.37245099E-03_JPRB, 0.37242470E-03_JPRB, 0.37242210E-03_JPRB  /)

RGHG1(:,18, 5) = (/ &
  & 0.37311649E-03_JPRB, 0.37309897E-03_JPRB, 0.37306583E-03_JPRB, 0.37300385E-03_JPRB, 0.37292243E-03_JPRB, 0.37282314E-03_JPRB, &
  & 0.37271805E-03_JPRB, 0.37262449E-03_JPRB, 0.37255552E-03_JPRB, 0.37252701E-03_JPRB, 0.37255426E-03_JPRB, 0.37263915E-03_JPRB, &
  & 0.37276218E-03_JPRB, 0.37289587E-03_JPRB, 0.37302750E-03_JPRB, 0.37315453E-03_JPRB, 0.37327103E-03_JPRB, 0.37340865E-03_JPRB, &
  & 0.37364116E-03_JPRB, 0.37400258E-03_JPRB, 0.37447175E-03_JPRB, 0.37494379E-03_JPRB, 0.37534492E-03_JPRB, 0.37568495E-03_JPRB, &
  & 0.37601397E-03_JPRB, 0.37632459E-03_JPRB, 0.37661927E-03_JPRB, 0.37689320E-03_JPRB, 0.37713679E-03_JPRB, 0.37731448E-03_JPRB, &
  & 0.37731493E-03_JPRB, 0.37710441E-03_JPRB, 0.37676591E-03_JPRB, 0.37641924E-03_JPRB, 0.37608545E-03_JPRB, 0.37577482E-03_JPRB, &
  & 0.37550247E-03_JPRB, 0.37524892E-03_JPRB, 0.37500229E-03_JPRB, 0.37474548E-03_JPRB, 0.37445783E-03_JPRB, 0.37423292E-03_JPRB, &
  & 0.37406430E-03_JPRB, 0.37384561E-03_JPRB, 0.37356196E-03_JPRB, 0.37320763E-03_JPRB, 0.37286977E-03_JPRB, 0.37263502E-03_JPRB, &
  & 0.37250155E-03_JPRB, 0.37242766E-03_JPRB, 0.37241102E-03_JPRB, 0.37242211E-03_JPRB, 0.37243649E-03_JPRB, 0.37244708E-03_JPRB, &
  & 0.37245725E-03_JPRB, 0.37247275E-03_JPRB, 0.37249410E-03_JPRB, 0.37252814E-03_JPRB, 0.37255688E-03_JPRB, 0.37257055E-03_JPRB, &
  & 0.37257807E-03_JPRB, 0.37256803E-03_JPRB, 0.37255053E-03_JPRB, 0.37253792E-03_JPRB  /)

RGHG1(:,19, 5) = (/ &
  & 0.37337405E-03_JPRB, 0.37336216E-03_JPRB, 0.37334301E-03_JPRB, 0.37329975E-03_JPRB, 0.37322952E-03_JPRB, 0.37313372E-03_JPRB, &
  & 0.37302307E-03_JPRB, 0.37291522E-03_JPRB, 0.37283289E-03_JPRB, 0.37279379E-03_JPRB, 0.37280937E-03_JPRB, 0.37287439E-03_JPRB, &
  & 0.37296599E-03_JPRB, 0.37306855E-03_JPRB, 0.37317893E-03_JPRB, 0.37329476E-03_JPRB, 0.37340245E-03_JPRB, 0.37354775E-03_JPRB, &
  & 0.37379494E-03_JPRB, 0.37412551E-03_JPRB, 0.37451986E-03_JPRB, 0.37489882E-03_JPRB, 0.37522685E-03_JPRB, 0.37552844E-03_JPRB, &
  & 0.37588152E-03_JPRB, 0.37625633E-03_JPRB, 0.37664551E-03_JPRB, 0.37703009E-03_JPRB, 0.37741183E-03_JPRB, 0.37772794E-03_JPRB, &
  & 0.37784918E-03_JPRB, 0.37768363E-03_JPRB, 0.37725937E-03_JPRB, 0.37678627E-03_JPRB, 0.37638030E-03_JPRB, 0.37600276E-03_JPRB, &
  & 0.37568025E-03_JPRB, 0.37540956E-03_JPRB, 0.37516561E-03_JPRB, 0.37491375E-03_JPRB, 0.37459590E-03_JPRB, 0.37432473E-03_JPRB, &
  & 0.37412446E-03_JPRB, 0.37388319E-03_JPRB, 0.37358928E-03_JPRB, 0.37322797E-03_JPRB, 0.37291555E-03_JPRB, 0.37271547E-03_JPRB, &
  & 0.37260835E-03_JPRB, 0.37256326E-03_JPRB, 0.37256592E-03_JPRB, 0.37258237E-03_JPRB, 0.37259738E-03_JPRB, 0.37261095E-03_JPRB, &
  & 0.37261435E-03_JPRB, 0.37262012E-03_JPRB, 0.37263036E-03_JPRB, 0.37264770E-03_JPRB, 0.37266835E-03_JPRB, 0.37268423E-03_JPRB, &
  & 0.37269467E-03_JPRB, 0.37269174E-03_JPRB, 0.37267766E-03_JPRB, 0.37266163E-03_JPRB  /)

RGHG1(:,20, 5) = (/ &
  & 0.37353108E-03_JPRB, 0.37352726E-03_JPRB, 0.37352390E-03_JPRB, 0.37350564E-03_JPRB, 0.37345772E-03_JPRB, 0.37337931E-03_JPRB, &
  & 0.37327960E-03_JPRB, 0.37317485E-03_JPRB, 0.37309371E-03_JPRB, 0.37305747E-03_JPRB, 0.37306857E-03_JPRB, 0.37312089E-03_JPRB, &
  & 0.37318911E-03_JPRB, 0.37327714E-03_JPRB, 0.37338501E-03_JPRB, 0.37349543E-03_JPRB, 0.37360306E-03_JPRB, 0.37376401E-03_JPRB, &
  & 0.37401848E-03_JPRB, 0.37430107E-03_JPRB, 0.37463153E-03_JPRB, 0.37496423E-03_JPRB, 0.37525912E-03_JPRB, 0.37554855E-03_JPRB, &
  & 0.37592233E-03_JPRB, 0.37632875E-03_JPRB, 0.37677140E-03_JPRB, 0.37724705E-03_JPRB, 0.37773195E-03_JPRB, 0.37815361E-03_JPRB, &
  & 0.37839747E-03_JPRB, 0.37831123E-03_JPRB, 0.37784980E-03_JPRB, 0.37725951E-03_JPRB, 0.37679003E-03_JPRB, 0.37638789E-03_JPRB, &
  & 0.37605372E-03_JPRB, 0.37578759E-03_JPRB, 0.37554718E-03_JPRB, 0.37529896E-03_JPRB, 0.37496717E-03_JPRB, 0.37465010E-03_JPRB, &
  & 0.37439443E-03_JPRB, 0.37412439E-03_JPRB, 0.37381829E-03_JPRB, 0.37346340E-03_JPRB, 0.37317385E-03_JPRB, 0.37300667E-03_JPRB, &
  & 0.37291376E-03_JPRB, 0.37288073E-03_JPRB, 0.37288240E-03_JPRB, 0.37289014E-03_JPRB, 0.37289475E-03_JPRB, 0.37290151E-03_JPRB, &
  & 0.37289723E-03_JPRB, 0.37289200E-03_JPRB, 0.37288603E-03_JPRB, 0.37288291E-03_JPRB, 0.37289121E-03_JPRB, 0.37290206E-03_JPRB, &
  & 0.37290680E-03_JPRB, 0.37290517E-03_JPRB, 0.37288936E-03_JPRB, 0.37287164E-03_JPRB  /)

RGHG1(:,21, 5) = (/ &
  & 0.37364574E-03_JPRB, 0.37365152E-03_JPRB, 0.37366178E-03_JPRB, 0.37366503E-03_JPRB, 0.37364041E-03_JPRB, 0.37358323E-03_JPRB, &
  & 0.37350205E-03_JPRB, 0.37341297E-03_JPRB, 0.37334533E-03_JPRB, 0.37332132E-03_JPRB, 0.37333520E-03_JPRB, 0.37338210E-03_JPRB, &
  & 0.37343800E-03_JPRB, 0.37352853E-03_JPRB, 0.37364495E-03_JPRB, 0.37375423E-03_JPRB, 0.37387163E-03_JPRB, 0.37405331E-03_JPRB, &
  & 0.37431452E-03_JPRB, 0.37455299E-03_JPRB, 0.37484900E-03_JPRB, 0.37518434E-03_JPRB, 0.37548977E-03_JPRB, 0.37579610E-03_JPRB, &
  & 0.37618373E-03_JPRB, 0.37659320E-03_JPRB, 0.37705072E-03_JPRB, 0.37759104E-03_JPRB, 0.37813646E-03_JPRB, 0.37861821E-03_JPRB, &
  & 0.37894442E-03_JPRB, 0.37893200E-03_JPRB, 0.37848451E-03_JPRB, 0.37782348E-03_JPRB, 0.37731617E-03_JPRB, 0.37694382E-03_JPRB, &
  & 0.37664506E-03_JPRB, 0.37639614E-03_JPRB, 0.37615481E-03_JPRB, 0.37590349E-03_JPRB, 0.37555946E-03_JPRB, 0.37520039E-03_JPRB, &
  & 0.37488238E-03_JPRB, 0.37457818E-03_JPRB, 0.37425863E-03_JPRB, 0.37391906E-03_JPRB, 0.37365148E-03_JPRB, 0.37351386E-03_JPRB, &
  & 0.37342265E-03_JPRB, 0.37338384E-03_JPRB, 0.37336807E-03_JPRB, 0.37335668E-03_JPRB, 0.37334443E-03_JPRB, 0.37333735E-03_JPRB, &
  & 0.37332301E-03_JPRB, 0.37330583E-03_JPRB, 0.37327886E-03_JPRB, 0.37325304E-03_JPRB, 0.37324644E-03_JPRB, 0.37324778E-03_JPRB, &
  & 0.37324118E-03_JPRB, 0.37323384E-03_JPRB, 0.37321366E-03_JPRB, 0.37319362E-03_JPRB  /)

RGHG1(:,22, 5) = (/ &
  & 0.37376359E-03_JPRB, 0.37377671E-03_JPRB, 0.37379386E-03_JPRB, 0.37380589E-03_JPRB, 0.37379417E-03_JPRB, 0.37375300E-03_JPRB, &
  & 0.37369094E-03_JPRB, 0.37362643E-03_JPRB, 0.37358447E-03_JPRB, 0.37357970E-03_JPRB, 0.37360603E-03_JPRB, 0.37365704E-03_JPRB, &
  & 0.37371461E-03_JPRB, 0.37382415E-03_JPRB, 0.37395091E-03_JPRB, 0.37407020E-03_JPRB, 0.37420684E-03_JPRB, 0.37441786E-03_JPRB, &
  & 0.37469986E-03_JPRB, 0.37492655E-03_JPRB, 0.37522667E-03_JPRB, 0.37559714E-03_JPRB, 0.37596417E-03_JPRB, 0.37631697E-03_JPRB, &
  & 0.37670237E-03_JPRB, 0.37709784E-03_JPRB, 0.37754346E-03_JPRB, 0.37810735E-03_JPRB, 0.37866900E-03_JPRB, 0.37915743E-03_JPRB, &
  & 0.37949131E-03_JPRB, 0.37950947E-03_JPRB, 0.37910589E-03_JPRB, 0.37845308E-03_JPRB, 0.37796001E-03_JPRB, 0.37767804E-03_JPRB, &
  & 0.37746467E-03_JPRB, 0.37723320E-03_JPRB, 0.37698075E-03_JPRB, 0.37672343E-03_JPRB, 0.37635250E-03_JPRB, 0.37595085E-03_JPRB, &
  & 0.37559315E-03_JPRB, 0.37525337E-03_JPRB, 0.37491892E-03_JPRB, 0.37459236E-03_JPRB, 0.37434524E-03_JPRB, 0.37422418E-03_JPRB, &
  & 0.37411718E-03_JPRB, 0.37405391E-03_JPRB, 0.37400990E-03_JPRB, 0.37397350E-03_JPRB, 0.37394280E-03_JPRB, 0.37391771E-03_JPRB, &
  & 0.37388569E-03_JPRB, 0.37385627E-03_JPRB, 0.37380852E-03_JPRB, 0.37375812E-03_JPRB, 0.37373418E-03_JPRB, 0.37372785E-03_JPRB, &
  & 0.37370735E-03_JPRB, 0.37368678E-03_JPRB, 0.37366271E-03_JPRB, 0.37363989E-03_JPRB  /)

RGHG1(:,23, 5) = (/ &
  & 0.37387468E-03_JPRB, 0.37388279E-03_JPRB, 0.37389691E-03_JPRB, 0.37390640E-03_JPRB, 0.37389445E-03_JPRB, 0.37386206E-03_JPRB, &
  & 0.37382003E-03_JPRB, 0.37378650E-03_JPRB, 0.37377644E-03_JPRB, 0.37380010E-03_JPRB, 0.37385038E-03_JPRB, 0.37391937E-03_JPRB, &
  & 0.37399225E-03_JPRB, 0.37411667E-03_JPRB, 0.37425397E-03_JPRB, 0.37440030E-03_JPRB, 0.37456785E-03_JPRB, 0.37479951E-03_JPRB, &
  & 0.37508624E-03_JPRB, 0.37531903E-03_JPRB, 0.37563996E-03_JPRB, 0.37608372E-03_JPRB, 0.37655320E-03_JPRB, 0.37697766E-03_JPRB, &
  & 0.37739925E-03_JPRB, 0.37781197E-03_JPRB, 0.37824228E-03_JPRB, 0.37876487E-03_JPRB, 0.37929961E-03_JPRB, 0.37973085E-03_JPRB, &
  & 0.38000820E-03_JPRB, 0.38000283E-03_JPRB, 0.37964063E-03_JPRB, 0.37908816E-03_JPRB, 0.37869212E-03_JPRB, 0.37849480E-03_JPRB, &
  & 0.37834278E-03_JPRB, 0.37810815E-03_JPRB, 0.37784923E-03_JPRB, 0.37758054E-03_JPRB, 0.37717394E-03_JPRB, 0.37672805E-03_JPRB, &
  & 0.37635004E-03_JPRB, 0.37600617E-03_JPRB, 0.37564537E-03_JPRB, 0.37530488E-03_JPRB, 0.37506750E-03_JPRB, 0.37494317E-03_JPRB, &
  & 0.37482007E-03_JPRB, 0.37472459E-03_JPRB, 0.37465777E-03_JPRB, 0.37460378E-03_JPRB, 0.37456702E-03_JPRB, 0.37452487E-03_JPRB, &
  & 0.37447149E-03_JPRB, 0.37442009E-03_JPRB, 0.37435814E-03_JPRB, 0.37429834E-03_JPRB, 0.37424990E-03_JPRB, 0.37422430E-03_JPRB, &
  & 0.37421011E-03_JPRB, 0.37418000E-03_JPRB, 0.37416204E-03_JPRB, 0.37414527E-03_JPRB  /)

RGHG1(:,24, 5) = (/ &
  & 0.37400041E-03_JPRB, 0.37399672E-03_JPRB, 0.37399974E-03_JPRB, 0.37399963E-03_JPRB, 0.37398193E-03_JPRB, 0.37395456E-03_JPRB, &
  & 0.37393116E-03_JPRB, 0.37392885E-03_JPRB, 0.37395193E-03_JPRB, 0.37400935E-03_JPRB, 0.37408978E-03_JPRB, 0.37418242E-03_JPRB, &
  & 0.37427293E-03_JPRB, 0.37440706E-03_JPRB, 0.37455688E-03_JPRB, 0.37473574E-03_JPRB, 0.37493365E-03_JPRB, 0.37516935E-03_JPRB, &
  & 0.37544686E-03_JPRB, 0.37568978E-03_JPRB, 0.37603371E-03_JPRB, 0.37654605E-03_JPRB, 0.37712594E-03_JPRB, 0.37765095E-03_JPRB, &
  & 0.37814590E-03_JPRB, 0.37860495E-03_JPRB, 0.37902454E-03_JPRB, 0.37948510E-03_JPRB, 0.37996795E-03_JPRB, 0.38032273E-03_JPRB, &
  & 0.38052531E-03_JPRB, 0.38048486E-03_JPRB, 0.38016688E-03_JPRB, 0.37974081E-03_JPRB, 0.37945756E-03_JPRB, 0.37932992E-03_JPRB, &
  & 0.37921565E-03_JPRB, 0.37897316E-03_JPRB, 0.37870089E-03_JPRB, 0.37840356E-03_JPRB, 0.37796147E-03_JPRB, 0.37748424E-03_JPRB, &
  & 0.37709165E-03_JPRB, 0.37674519E-03_JPRB, 0.37635666E-03_JPRB, 0.37600815E-03_JPRB, 0.37577713E-03_JPRB, 0.37564495E-03_JPRB, &
  & 0.37551046E-03_JPRB, 0.37538162E-03_JPRB, 0.37529307E-03_JPRB, 0.37522437E-03_JPRB, 0.37518048E-03_JPRB, 0.37512338E-03_JPRB, &
  & 0.37505344E-03_JPRB, 0.37497809E-03_JPRB, 0.37490235E-03_JPRB, 0.37483622E-03_JPRB, 0.37476850E-03_JPRB, 0.37472395E-03_JPRB, &
  & 0.37471714E-03_JPRB, 0.37468607E-03_JPRB, 0.37467135E-03_JPRB, 0.37466680E-03_JPRB  /)

RGHG1(:,25, 5) = (/ &
  & 0.37414792E-03_JPRB, 0.37412372E-03_JPRB, 0.37410407E-03_JPRB, 0.37408486E-03_JPRB, 0.37405484E-03_JPRB, 0.37402719E-03_JPRB, &
  & 0.37401893E-03_JPRB, 0.37404541E-03_JPRB, 0.37410095E-03_JPRB, 0.37419797E-03_JPRB, 0.37431556E-03_JPRB, 0.37443774E-03_JPRB, &
  & 0.37454612E-03_JPRB, 0.37468128E-03_JPRB, 0.37484653E-03_JPRB, 0.37506237E-03_JPRB, 0.37528568E-03_JPRB, 0.37549776E-03_JPRB, &
  & 0.37574536E-03_JPRB, 0.37600107E-03_JPRB, 0.37636711E-03_JPRB, 0.37692799E-03_JPRB, 0.37761823E-03_JPRB, 0.37828482E-03_JPRB, &
  & 0.37890706E-03_JPRB, 0.37945482E-03_JPRB, 0.37987310E-03_JPRB, 0.38025228E-03_JPRB, 0.38065103E-03_JPRB, 0.38091295E-03_JPRB, &
  & 0.38102625E-03_JPRB, 0.38094404E-03_JPRB, 0.38067384E-03_JPRB, 0.38039397E-03_JPRB, 0.38022775E-03_JPRB, 0.38014141E-03_JPRB, &
  & 0.38002676E-03_JPRB, 0.37977307E-03_JPRB, 0.37947485E-03_JPRB, 0.37912078E-03_JPRB, 0.37864708E-03_JPRB, 0.37816318E-03_JPRB, &
  & 0.37776240E-03_JPRB, 0.37740908E-03_JPRB, 0.37699420E-03_JPRB, 0.37665454E-03_JPRB, 0.37642606E-03_JPRB, 0.37628268E-03_JPRB, &
  & 0.37614575E-03_JPRB, 0.37598473E-03_JPRB, 0.37587614E-03_JPRB, 0.37579681E-03_JPRB, 0.37574145E-03_JPRB, 0.37567363E-03_JPRB, &
  & 0.37559719E-03_JPRB, 0.37549766E-03_JPRB, 0.37540800E-03_JPRB, 0.37533782E-03_JPRB, 0.37526258E-03_JPRB, 0.37520307E-03_JPRB, &
  & 0.37520069E-03_JPRB, 0.37518307E-03_JPRB, 0.37516411E-03_JPRB, 0.37518016E-03_JPRB  /)

RGHG1(:,26, 5) = (/ &
  & 0.37431017E-03_JPRB, 0.37427528E-03_JPRB, 0.37423383E-03_JPRB, 0.37418842E-03_JPRB, 0.37413795E-03_JPRB, 0.37410198E-03_JPRB, &
  & 0.37410308E-03_JPRB, 0.37415153E-03_JPRB, 0.37424191E-03_JPRB, 0.37437880E-03_JPRB, 0.37453159E-03_JPRB, 0.37468487E-03_JPRB, &
  & 0.37480828E-03_JPRB, 0.37494786E-03_JPRB, 0.37513135E-03_JPRB, 0.37537118E-03_JPRB, 0.37559766E-03_JPRB, 0.37578975E-03_JPRB, &
  & 0.37601432E-03_JPRB, 0.37624897E-03_JPRB, 0.37659501E-03_JPRB, 0.37715739E-03_JPRB, 0.37793682E-03_JPRB, 0.37877069E-03_JPRB, &
  & 0.37954177E-03_JPRB, 0.38019127E-03_JPRB, 0.38063586E-03_JPRB, 0.38096511E-03_JPRB, 0.38128878E-03_JPRB, 0.38147087E-03_JPRB, &
  & 0.38151370E-03_JPRB, 0.38140215E-03_JPRB, 0.38118487E-03_JPRB, 0.38100908E-03_JPRB, 0.38091087E-03_JPRB, 0.38083633E-03_JPRB, &
  & 0.38070206E-03_JPRB, 0.38043008E-03_JPRB, 0.38008186E-03_JPRB, 0.37966528E-03_JPRB, 0.37917550E-03_JPRB, 0.37870485E-03_JPRB, &
  & 0.37829833E-03_JPRB, 0.37792666E-03_JPRB, 0.37751946E-03_JPRB, 0.37721185E-03_JPRB, 0.37699922E-03_JPRB, 0.37685992E-03_JPRB, &
  & 0.37670499E-03_JPRB, 0.37652272E-03_JPRB, 0.37638459E-03_JPRB, 0.37629238E-03_JPRB, 0.37621895E-03_JPRB, 0.37614435E-03_JPRB, &
  & 0.37605860E-03_JPRB, 0.37595224E-03_JPRB, 0.37585671E-03_JPRB, 0.37578565E-03_JPRB, 0.37571817E-03_JPRB, 0.37565270E-03_JPRB, &
  & 0.37563709E-03_JPRB, 0.37562430E-03_JPRB, 0.37559363E-03_JPRB, 0.37562363E-03_JPRB  /)

RGHG1(:,27, 5) = (/ &
  & 0.37448529E-03_JPRB, 0.37444284E-03_JPRB, 0.37437892E-03_JPRB, 0.37430350E-03_JPRB, 0.37422862E-03_JPRB, 0.37418098E-03_JPRB, &
  & 0.37418971E-03_JPRB, 0.37425862E-03_JPRB, 0.37438630E-03_JPRB, 0.37456498E-03_JPRB, 0.37475384E-03_JPRB, 0.37494021E-03_JPRB, &
  & 0.37507828E-03_JPRB, 0.37522375E-03_JPRB, 0.37542733E-03_JPRB, 0.37568744E-03_JPRB, 0.37590901E-03_JPRB, 0.37608152E-03_JPRB, &
  & 0.37628459E-03_JPRB, 0.37648465E-03_JPRB, 0.37679418E-03_JPRB, 0.37734066E-03_JPRB, 0.37820550E-03_JPRB, 0.37922379E-03_JPRB, &
  & 0.38015848E-03_JPRB, 0.38091921E-03_JPRB, 0.38140154E-03_JPRB, 0.38169023E-03_JPRB, 0.38193877E-03_JPRB, 0.38204221E-03_JPRB, &
  & 0.38201833E-03_JPRB, 0.38188070E-03_JPRB, 0.38172065E-03_JPRB, 0.38163809E-03_JPRB, 0.38159281E-03_JPRB, 0.38151967E-03_JPRB, &
  & 0.38135775E-03_JPRB, 0.38106400E-03_JPRB, 0.38065460E-03_JPRB, 0.38017053E-03_JPRB, 0.37966968E-03_JPRB, 0.37922027E-03_JPRB, &
  & 0.37880866E-03_JPRB, 0.37841355E-03_JPRB, 0.37802698E-03_JPRB, 0.37776151E-03_JPRB, 0.37757039E-03_JPRB, 0.37744100E-03_JPRB, &
  & 0.37726149E-03_JPRB, 0.37706105E-03_JPRB, 0.37688852E-03_JPRB, 0.37678199E-03_JPRB, 0.37668723E-03_JPRB, 0.37660702E-03_JPRB, &
  & 0.37651047E-03_JPRB, 0.37640341E-03_JPRB, 0.37630472E-03_JPRB, 0.37623393E-03_JPRB, 0.37618022E-03_JPRB, 0.37611186E-03_JPRB, &
  & 0.37607589E-03_JPRB, 0.37606494E-03_JPRB, 0.37601926E-03_JPRB, 0.37606138E-03_JPRB  /)

RGHG1(:,28, 5) = (/ &
  & 0.37461902E-03_JPRB, 0.37457992E-03_JPRB, 0.37449858E-03_JPRB, 0.37440334E-03_JPRB, 0.37431636E-03_JPRB, 0.37426709E-03_JPRB, &
  & 0.37428596E-03_JPRB, 0.37437853E-03_JPRB, 0.37454482E-03_JPRB, 0.37475725E-03_JPRB, 0.37497950E-03_JPRB, 0.37519135E-03_JPRB, &
  & 0.37535293E-03_JPRB, 0.37550474E-03_JPRB, 0.37571749E-03_JPRB, 0.37597046E-03_JPRB, 0.37618215E-03_JPRB, 0.37636889E-03_JPRB, &
  & 0.37654141E-03_JPRB, 0.37670596E-03_JPRB, 0.37697451E-03_JPRB, 0.37747005E-03_JPRB, 0.37833003E-03_JPRB, 0.37941520E-03_JPRB, &
  & 0.38048354E-03_JPRB, 0.38133776E-03_JPRB, 0.38190021E-03_JPRB, 0.38222678E-03_JPRB, 0.38246457E-03_JPRB, 0.38255902E-03_JPRB, &
  & 0.38253063E-03_JPRB, 0.38240217E-03_JPRB, 0.38226309E-03_JPRB, 0.38219234E-03_JPRB, 0.38214150E-03_JPRB, 0.38204978E-03_JPRB, &
  & 0.38185582E-03_JPRB, 0.38151301E-03_JPRB, 0.38103931E-03_JPRB, 0.38050350E-03_JPRB, 0.38001380E-03_JPRB, 0.37959377E-03_JPRB, &
  & 0.37920235E-03_JPRB, 0.37882918E-03_JPRB, 0.37849250E-03_JPRB, 0.37825017E-03_JPRB, 0.37806681E-03_JPRB, 0.37792441E-03_JPRB, &
  & 0.37772005E-03_JPRB, 0.37750368E-03_JPRB, 0.37729535E-03_JPRB, 0.37716183E-03_JPRB, 0.37704905E-03_JPRB, 0.37695879E-03_JPRB, &
  & 0.37685890E-03_JPRB, 0.37675334E-03_JPRB, 0.37665925E-03_JPRB, 0.37659634E-03_JPRB, 0.37655170E-03_JPRB, 0.37647229E-03_JPRB, &
  & 0.37641237E-03_JPRB, 0.37640339E-03_JPRB, 0.37636425E-03_JPRB, 0.37643852E-03_JPRB  /)

RGHG1(:,29, 5) = (/ &
  & 0.37475892E-03_JPRB, 0.37472384E-03_JPRB, 0.37462427E-03_JPRB, 0.37450847E-03_JPRB, 0.37440921E-03_JPRB, 0.37435865E-03_JPRB, &
  & 0.37438836E-03_JPRB, 0.37450615E-03_JPRB, 0.37471340E-03_JPRB, 0.37496125E-03_JPRB, 0.37521875E-03_JPRB, 0.37545726E-03_JPRB, &
  & 0.37564415E-03_JPRB, 0.37580270E-03_JPRB, 0.37602469E-03_JPRB, 0.37626890E-03_JPRB, 0.37646991E-03_JPRB, 0.37667320E-03_JPRB, &
  & 0.37681295E-03_JPRB, 0.37693983E-03_JPRB, 0.37716477E-03_JPRB, 0.37760482E-03_JPRB, 0.37845572E-03_JPRB, 0.37960667E-03_JPRB, &
  & 0.38081531E-03_JPRB, 0.38176783E-03_JPRB, 0.38241703E-03_JPRB, 0.38278713E-03_JPRB, 0.38301633E-03_JPRB, 0.38310427E-03_JPRB, &
  & 0.38307378E-03_JPRB, 0.38295657E-03_JPRB, 0.38283813E-03_JPRB, 0.38277638E-03_JPRB, 0.38271710E-03_JPRB, 0.38260482E-03_JPRB, &
  & 0.38237673E-03_JPRB, 0.38198075E-03_JPRB, 0.38143878E-03_JPRB, 0.38084885E-03_JPRB, 0.38037192E-03_JPRB, 0.37998337E-03_JPRB, &
  & 0.37961444E-03_JPRB, 0.37926649E-03_JPRB, 0.37898394E-03_JPRB, 0.37876529E-03_JPRB, 0.37858956E-03_JPRB, 0.37843239E-03_JPRB, &
  & 0.37820169E-03_JPRB, 0.37796853E-03_JPRB, 0.37772222E-03_JPRB, 0.37755954E-03_JPRB, 0.37742780E-03_JPRB, 0.37732670E-03_JPRB, &
  & 0.37722360E-03_JPRB, 0.37711973E-03_JPRB, 0.37703086E-03_JPRB, 0.37697662E-03_JPRB, 0.37694138E-03_JPRB, 0.37684993E-03_JPRB, &
  & 0.37676446E-03_JPRB, 0.37675757E-03_JPRB, 0.37672631E-03_JPRB, 0.37683551E-03_JPRB  /)

RGHG1(:,30, 5) = (/ &
  & 0.37492556E-03_JPRB, 0.37489675E-03_JPRB, 0.37479195E-03_JPRB, 0.37466893E-03_JPRB, 0.37456691E-03_JPRB, 0.37452291E-03_JPRB, &
  & 0.37455623E-03_JPRB, 0.37469591E-03_JPRB, 0.37494243E-03_JPRB, 0.37522657E-03_JPRB, 0.37550873E-03_JPRB, 0.37576723E-03_JPRB, &
  & 0.37597389E-03_JPRB, 0.37613704E-03_JPRB, 0.37634309E-03_JPRB, 0.37657438E-03_JPRB, 0.37677736E-03_JPRB, 0.37700303E-03_JPRB, &
  & 0.37714931E-03_JPRB, 0.37729973E-03_JPRB, 0.37756816E-03_JPRB, 0.37799200E-03_JPRB, 0.37873388E-03_JPRB, 0.37976897E-03_JPRB, &
  & 0.38092962E-03_JPRB, 0.38192478E-03_JPRB, 0.38267212E-03_JPRB, 0.38313588E-03_JPRB, 0.38343958E-03_JPRB, 0.38360774E-03_JPRB, &
  & 0.38365232E-03_JPRB, 0.38358571E-03_JPRB, 0.38348005E-03_JPRB, 0.38338804E-03_JPRB, 0.38327069E-03_JPRB, 0.38309405E-03_JPRB, &
  & 0.38281336E-03_JPRB, 0.38236992E-03_JPRB, 0.38180017E-03_JPRB, 0.38122366E-03_JPRB, 0.38078554E-03_JPRB, 0.38042397E-03_JPRB, &
  & 0.38010755E-03_JPRB, 0.37980274E-03_JPRB, 0.37951381E-03_JPRB, 0.37926041E-03_JPRB, 0.37905110E-03_JPRB, 0.37885031E-03_JPRB, &
  & 0.37859088E-03_JPRB, 0.37834613E-03_JPRB, 0.37809096E-03_JPRB, 0.37789080E-03_JPRB, 0.37773364E-03_JPRB, 0.37760769E-03_JPRB, &
  & 0.37749619E-03_JPRB, 0.37738082E-03_JPRB, 0.37727574E-03_JPRB, 0.37721628E-03_JPRB, 0.37718641E-03_JPRB, 0.37710257E-03_JPRB, &
  & 0.37700847E-03_JPRB, 0.37701886E-03_JPRB, 0.37700638E-03_JPRB, 0.37712111E-03_JPRB  /)

RGHG1(:,31, 5) = (/ &
  & 0.37510116E-03_JPRB, 0.37507897E-03_JPRB, 0.37496867E-03_JPRB, 0.37483806E-03_JPRB, 0.37473313E-03_JPRB, 0.37469605E-03_JPRB, &
  & 0.37473317E-03_JPRB, 0.37489592E-03_JPRB, 0.37518380E-03_JPRB, 0.37550619E-03_JPRB, 0.37581431E-03_JPRB, 0.37609387E-03_JPRB, &
  & 0.37632137E-03_JPRB, 0.37648936E-03_JPRB, 0.37667859E-03_JPRB, 0.37689626E-03_JPRB, 0.37710133E-03_JPRB, 0.37735058E-03_JPRB, &
  & 0.37750378E-03_JPRB, 0.37767905E-03_JPRB, 0.37799339E-03_JPRB, 0.37840019E-03_JPRB, 0.37902712E-03_JPRB, 0.37993996E-03_JPRB, &
  & 0.38104986E-03_JPRB, 0.38208989E-03_JPRB, 0.38294065E-03_JPRB, 0.38350315E-03_JPRB, 0.38388542E-03_JPRB, 0.38413818E-03_JPRB, &
  & 0.38426193E-03_JPRB, 0.38424867E-03_JPRB, 0.38415648E-03_JPRB, 0.38403255E-03_JPRB, 0.38385396E-03_JPRB, 0.38360946E-03_JPRB, &
  & 0.38327334E-03_JPRB, 0.38277990E-03_JPRB, 0.38218090E-03_JPRB, 0.38161861E-03_JPRB, 0.38122141E-03_JPRB, 0.38088827E-03_JPRB, &
  & 0.38062721E-03_JPRB, 0.38036785E-03_JPRB, 0.38007216E-03_JPRB, 0.37978207E-03_JPRB, 0.37953735E-03_JPRB, 0.37929058E-03_JPRB, &
  & 0.37900085E-03_JPRB, 0.37874391E-03_JPRB, 0.37847944E-03_JPRB, 0.37823976E-03_JPRB, 0.37805582E-03_JPRB, 0.37790368E-03_JPRB, &
  & 0.37778333E-03_JPRB, 0.37765583E-03_JPRB, 0.37753363E-03_JPRB, 0.37746867E-03_JPRB, 0.37744445E-03_JPRB, 0.37736864E-03_JPRB, &
  & 0.37726547E-03_JPRB, 0.37729409E-03_JPRB, 0.37730140E-03_JPRB, 0.37742194E-03_JPRB  /)

RGHG1(:,32, 5) = (/ &
  & 0.37558300E-03_JPRB, 0.37555413E-03_JPRB, 0.37543770E-03_JPRB, 0.37527738E-03_JPRB, 0.37513374E-03_JPRB, 0.37505125E-03_JPRB, &
  & 0.37506381E-03_JPRB, 0.37524079E-03_JPRB, 0.37555476E-03_JPRB, 0.37590439E-03_JPRB, 0.37623144E-03_JPRB, 0.37652399E-03_JPRB, &
  & 0.37676362E-03_JPRB, 0.37694412E-03_JPRB, 0.37712304E-03_JPRB, 0.37732562E-03_JPRB, 0.37754001E-03_JPRB, 0.37781632E-03_JPRB, &
  & 0.37802197E-03_JPRB, 0.37824084E-03_JPRB, 0.37860118E-03_JPRB, 0.37905275E-03_JPRB, 0.37964340E-03_JPRB, 0.38044351E-03_JPRB, &
  & 0.38139662E-03_JPRB, 0.38231027E-03_JPRB, 0.38311511E-03_JPRB, 0.38375186E-03_JPRB, 0.38423076E-03_JPRB, 0.38456506E-03_JPRB, &
  & 0.38478066E-03_JPRB, 0.38486087E-03_JPRB, 0.38481869E-03_JPRB, 0.38467529E-03_JPRB, 0.38444272E-03_JPRB, 0.38414021E-03_JPRB, &
  & 0.38376573E-03_JPRB, 0.38328682E-03_JPRB, 0.38274609E-03_JPRB, 0.38225461E-03_JPRB, 0.38190657E-03_JPRB, 0.38158807E-03_JPRB, &
  & 0.38130367E-03_JPRB, 0.38100480E-03_JPRB, 0.38066193E-03_JPRB, 0.38034490E-03_JPRB, 0.38005367E-03_JPRB, 0.37975616E-03_JPRB, &
  & 0.37943116E-03_JPRB, 0.37916196E-03_JPRB, 0.37889017E-03_JPRB, 0.37861072E-03_JPRB, 0.37840513E-03_JPRB, 0.37823308E-03_JPRB, &
  & 0.37809197E-03_JPRB, 0.37794798E-03_JPRB, 0.37781514E-03_JPRB, 0.37774262E-03_JPRB, 0.37771028E-03_JPRB, 0.37764489E-03_JPRB, &
  & 0.37755556E-03_JPRB, 0.37760358E-03_JPRB, 0.37761176E-03_JPRB, 0.37768065E-03_JPRB  /)

RGHG1(:,33, 5) = (/ &
  & 0.37612341E-03_JPRB, 0.37608586E-03_JPRB, 0.37596299E-03_JPRB, 0.37576893E-03_JPRB, 0.37558042E-03_JPRB, 0.37544396E-03_JPRB, &
  & 0.37542732E-03_JPRB, 0.37561796E-03_JPRB, 0.37595706E-03_JPRB, 0.37633356E-03_JPRB, 0.37667938E-03_JPRB, 0.37698439E-03_JPRB, &
  & 0.37723550E-03_JPRB, 0.37743000E-03_JPRB, 0.37759905E-03_JPRB, 0.37778573E-03_JPRB, 0.37801077E-03_JPRB, 0.37831563E-03_JPRB, &
  & 0.37858170E-03_JPRB, 0.37884831E-03_JPRB, 0.37925646E-03_JPRB, 0.37976257E-03_JPRB, 0.38032570E-03_JPRB, 0.38100989E-03_JPRB, &
  & 0.38178632E-03_JPRB, 0.38254645E-03_JPRB, 0.38328423E-03_JPRB, 0.38399497E-03_JPRB, 0.38457663E-03_JPRB, 0.38499529E-03_JPRB, &
  & 0.38530797E-03_JPRB, 0.38549053E-03_JPRB, 0.38550505E-03_JPRB, 0.38534303E-03_JPRB, 0.38505530E-03_JPRB, 0.38469378E-03_JPRB, &
  & 0.38428164E-03_JPRB, 0.38382617E-03_JPRB, 0.38335734E-03_JPRB, 0.38294678E-03_JPRB, 0.38265089E-03_JPRB, 0.38234584E-03_JPRB, &
  & 0.38202700E-03_JPRB, 0.38167604E-03_JPRB, 0.38127892E-03_JPRB, 0.38093515E-03_JPRB, 0.38059415E-03_JPRB, 0.38024330E-03_JPRB, &
  & 0.37988099E-03_JPRB, 0.37959905E-03_JPRB, 0.37931991E-03_JPRB, 0.37899909E-03_JPRB, 0.37877165E-03_JPRB, 0.37857972E-03_JPRB, &
  & 0.37841552E-03_JPRB, 0.37825381E-03_JPRB, 0.37811075E-03_JPRB, 0.37803011E-03_JPRB, 0.37798756E-03_JPRB, 0.37793329E-03_JPRB, &
  & 0.37786133E-03_JPRB, 0.37792964E-03_JPRB, 0.37793628E-03_JPRB, 0.37794406E-03_JPRB  /)

RGHG1(:,34, 5) = (/ &
  & 0.37692278E-03_JPRB, 0.37686565E-03_JPRB, 0.37673094E-03_JPRB, 0.37648439E-03_JPRB, 0.37623436E-03_JPRB, 0.37603042E-03_JPRB, &
  & 0.37597359E-03_JPRB, 0.37615280E-03_JPRB, 0.37648294E-03_JPRB, 0.37687215E-03_JPRB, 0.37722809E-03_JPRB, 0.37753405E-03_JPRB, &
  & 0.37778097E-03_JPRB, 0.37798742E-03_JPRB, 0.37815829E-03_JPRB, 0.37833172E-03_JPRB, 0.37855503E-03_JPRB, 0.37886708E-03_JPRB, &
  & 0.37915773E-03_JPRB, 0.37945052E-03_JPRB, 0.37988765E-03_JPRB, 0.38043277E-03_JPRB, 0.38100601E-03_JPRB, 0.38162295E-03_JPRB, &
  & 0.38228340E-03_JPRB, 0.38291441E-03_JPRB, 0.38353584E-03_JPRB, 0.38420138E-03_JPRB, 0.38480916E-03_JPRB, 0.38527507E-03_JPRB, &
  & 0.38564643E-03_JPRB, 0.38591831E-03_JPRB, 0.38602314E-03_JPRB, 0.38591115E-03_JPRB, 0.38563640E-03_JPRB, 0.38526282E-03_JPRB, &
  & 0.38484598E-03_JPRB, 0.38442627E-03_JPRB, 0.38401167E-03_JPRB, 0.38363665E-03_JPRB, 0.38334030E-03_JPRB, 0.38302185E-03_JPRB, &
  & 0.38267085E-03_JPRB, 0.38228780E-03_JPRB, 0.38186735E-03_JPRB, 0.38149866E-03_JPRB, 0.38111572E-03_JPRB, 0.38072659E-03_JPRB, &
  & 0.38034039E-03_JPRB, 0.38003263E-03_JPRB, 0.37974700E-03_JPRB, 0.37941573E-03_JPRB, 0.37916796E-03_JPRB, 0.37897434E-03_JPRB, &
  & 0.37880013E-03_JPRB, 0.37862376E-03_JPRB, 0.37845918E-03_JPRB, 0.37836791E-03_JPRB, 0.37831032E-03_JPRB, 0.37825315E-03_JPRB, &
  & 0.37818882E-03_JPRB, 0.37826511E-03_JPRB, 0.37829071E-03_JPRB, 0.37824599E-03_JPRB  /)

RGHG1(:,35, 5) = (/ &
  & 0.37787752E-03_JPRB, 0.37779466E-03_JPRB, 0.37764501E-03_JPRB, 0.37733487E-03_JPRB, 0.37701307E-03_JPRB, 0.37673280E-03_JPRB, &
  & 0.37662901E-03_JPRB, 0.37678360E-03_JPRB, 0.37708704E-03_JPRB, 0.37748203E-03_JPRB, 0.37784395E-03_JPRB, 0.37814497E-03_JPRB, &
  & 0.37837955E-03_JPRB, 0.37859724E-03_JPRB, 0.37877596E-03_JPRB, 0.37893711E-03_JPRB, 0.37915230E-03_JPRB, 0.37946079E-03_JPRB, &
  & 0.37975832E-03_JPRB, 0.38006696E-03_JPRB, 0.38052423E-03_JPRB, 0.38110150E-03_JPRB, 0.38170443E-03_JPRB, 0.38227719E-03_JPRB, &
  & 0.38284956E-03_JPRB, 0.38336034E-03_JPRB, 0.38383685E-03_JPRB, 0.38439475E-03_JPRB, 0.38499006E-03_JPRB, 0.38548553E-03_JPRB, &
  & 0.38589749E-03_JPRB, 0.38625452E-03_JPRB, 0.38646946E-03_JPRB, 0.38644412E-03_JPRB, 0.38621770E-03_JPRB, 0.38585581E-03_JPRB, &
  & 0.38545106E-03_JPRB, 0.38507441E-03_JPRB, 0.38470651E-03_JPRB, 0.38434474E-03_JPRB, 0.38402092E-03_JPRB, 0.38367492E-03_JPRB, &
  & 0.38329203E-03_JPRB, 0.38288625E-03_JPRB, 0.38245768E-03_JPRB, 0.38206431E-03_JPRB, 0.38164226E-03_JPRB, 0.38122149E-03_JPRB, &
  & 0.38081763E-03_JPRB, 0.38047661E-03_JPRB, 0.38018474E-03_JPRB, 0.37985861E-03_JPRB, 0.37959070E-03_JPRB, 0.37940468E-03_JPRB, &
  & 0.37922690E-03_JPRB, 0.37903702E-03_JPRB, 0.37884450E-03_JPRB, 0.37874102E-03_JPRB, 0.37866550E-03_JPRB, 0.37859813E-03_JPRB, &
  & 0.37853666E-03_JPRB, 0.37861484E-03_JPRB, 0.37867044E-03_JPRB, 0.37857616E-03_JPRB  /)

RGHG1(:,36, 5) = (/ &
  & 0.37908818E-03_JPRB, 0.37895691E-03_JPRB, 0.37876245E-03_JPRB, 0.37835685E-03_JPRB, 0.37792972E-03_JPRB, 0.37755068E-03_JPRB, &
  & 0.37738495E-03_JPRB, 0.37749440E-03_JPRB, 0.37775836E-03_JPRB, 0.37814372E-03_JPRB, 0.37850173E-03_JPRB, 0.37878672E-03_JPRB, &
  & 0.37900249E-03_JPRB, 0.37922549E-03_JPRB, 0.37940775E-03_JPRB, 0.37955402E-03_JPRB, 0.37975402E-03_JPRB, 0.38004590E-03_JPRB, &
  & 0.38033774E-03_JPRB, 0.38064747E-03_JPRB, 0.38111109E-03_JPRB, 0.38170478E-03_JPRB, 0.38232285E-03_JPRB, 0.38285771E-03_JPRB, &
  & 0.38335129E-03_JPRB, 0.38375799E-03_JPRB, 0.38411134E-03_JPRB, 0.38457777E-03_JPRB, 0.38514598E-03_JPRB, 0.38565218E-03_JPRB, &
  & 0.38609517E-03_JPRB, 0.38652106E-03_JPRB, 0.38684266E-03_JPRB, 0.38692523E-03_JPRB, 0.38677719E-03_JPRB, 0.38644235E-03_JPRB, &
  & 0.38603603E-03_JPRB, 0.38567467E-03_JPRB, 0.38533252E-03_JPRB, 0.38497960E-03_JPRB, 0.38463898E-03_JPRB, 0.38427617E-03_JPRB, &
  & 0.38387196E-03_JPRB, 0.38345148E-03_JPRB, 0.38301968E-03_JPRB, 0.38260339E-03_JPRB, 0.38215457E-03_JPRB, 0.38171071E-03_JPRB, &
  & 0.38129432E-03_JPRB, 0.38092405E-03_JPRB, 0.38062886E-03_JPRB, 0.38031470E-03_JPRB, 0.38003716E-03_JPRB, 0.37985774E-03_JPRB, &
  & 0.37968089E-03_JPRB, 0.37948287E-03_JPRB, 0.37926123E-03_JPRB, 0.37914313E-03_JPRB, 0.37905824E-03_JPRB, 0.37898046E-03_JPRB, &
  & 0.37892558E-03_JPRB, 0.37900753E-03_JPRB, 0.37909379E-03_JPRB, 0.37896103E-03_JPRB  /)

RGHG1(:,37, 5) = (/ &
  & 0.38081030E-03_JPRB, 0.38058158E-03_JPRB, 0.38027661E-03_JPRB, 0.37970845E-03_JPRB, 0.37910562E-03_JPRB, 0.37858248E-03_JPRB, &
  & 0.37832436E-03_JPRB, 0.37834439E-03_JPRB, 0.37854204E-03_JPRB, 0.37888302E-03_JPRB, 0.37921470E-03_JPRB, 0.37945922E-03_JPRB, &
  & 0.37964255E-03_JPRB, 0.37985691E-03_JPRB, 0.38003258E-03_JPRB, 0.38015894E-03_JPRB, 0.38032848E-03_JPRB, 0.38057490E-03_JPRB, &
  & 0.38083257E-03_JPRB, 0.38110950E-03_JPRB, 0.38154745E-03_JPRB, 0.38212045E-03_JPRB, 0.38271939E-03_JPRB, 0.38323309E-03_JPRB, &
  & 0.38367408E-03_JPRB, 0.38402021E-03_JPRB, 0.38430797E-03_JPRB, 0.38472564E-03_JPRB, 0.38523491E-03_JPRB, 0.38570801E-03_JPRB, &
  & 0.38615820E-03_JPRB, 0.38661124E-03_JPRB, 0.38702502E-03_JPRB, 0.38725749E-03_JPRB, 0.38725187E-03_JPRB, 0.38697759E-03_JPRB, &
  & 0.38653853E-03_JPRB, 0.38612782E-03_JPRB, 0.38576174E-03_JPRB, 0.38540702E-03_JPRB, 0.38507516E-03_JPRB, 0.38472116E-03_JPRB, &
  & 0.38432121E-03_JPRB, 0.38390541E-03_JPRB, 0.38348177E-03_JPRB, 0.38304802E-03_JPRB, 0.38260238E-03_JPRB, 0.38215642E-03_JPRB, &
  & 0.38174009E-03_JPRB, 0.38135160E-03_JPRB, 0.38105994E-03_JPRB, 0.38077271E-03_JPRB, 0.38051022E-03_JPRB, 0.38033470E-03_JPRB, &
  & 0.38016906E-03_JPRB, 0.37997572E-03_JPRB, 0.37972404E-03_JPRB, 0.37958668E-03_JPRB, 0.37951265E-03_JPRB, 0.37942462E-03_JPRB, &
  & 0.37938449E-03_JPRB, 0.37947429E-03_JPRB, 0.37959077E-03_JPRB, 0.37944734E-03_JPRB  /)

RGHG1(:,38, 5) = (/ &
  & 0.38272114E-03_JPRB, 0.38238430E-03_JPRB, 0.38195670E-03_JPRB, 0.38120816E-03_JPRB, 0.38041039E-03_JPRB, 0.37972736E-03_JPRB, &
  & 0.37936671E-03_JPRB, 0.37928754E-03_JPRB, 0.37941159E-03_JPRB, 0.37970334E-03_JPRB, 0.38000581E-03_JPRB, 0.38020541E-03_JPRB, &
  & 0.38035276E-03_JPRB, 0.38055754E-03_JPRB, 0.38072588E-03_JPRB, 0.38083016E-03_JPRB, 0.38096589E-03_JPRB, 0.38116188E-03_JPRB, &
  & 0.38138162E-03_JPRB, 0.38162216E-03_JPRB, 0.38203163E-03_JPRB, 0.38258168E-03_JPRB, 0.38315939E-03_JPRB, 0.38364961E-03_JPRB, &
  & 0.38403224E-03_JPRB, 0.38431118E-03_JPRB, 0.38452614E-03_JPRB, 0.38488972E-03_JPRB, 0.38533358E-03_JPRB, 0.38576995E-03_JPRB, &
  & 0.38622812E-03_JPRB, 0.38671131E-03_JPRB, 0.38722735E-03_JPRB, 0.38762616E-03_JPRB, 0.38777857E-03_JPRB, 0.38757149E-03_JPRB, &
  & 0.38709610E-03_JPRB, 0.38663063E-03_JPRB, 0.38623801E-03_JPRB, 0.38588129E-03_JPRB, 0.38555914E-03_JPRB, 0.38521492E-03_JPRB, &
  & 0.38481970E-03_JPRB, 0.38440909E-03_JPRB, 0.38399449E-03_JPRB, 0.38354139E-03_JPRB, 0.38309927E-03_JPRB, 0.38265098E-03_JPRB, &
  & 0.38223472E-03_JPRB, 0.38182600E-03_JPRB, 0.38153827E-03_JPRB, 0.38128091E-03_JPRB, 0.38103512E-03_JPRB, 0.38086392E-03_JPRB, &
  & 0.38071073E-03_JPRB, 0.38052257E-03_JPRB, 0.38023756E-03_JPRB, 0.38007885E-03_JPRB, 0.38001686E-03_JPRB, 0.37991745E-03_JPRB, &
  & 0.37989369E-03_JPRB, 0.37999220E-03_JPRB, 0.38014222E-03_JPRB, 0.37998695E-03_JPRB  /)

RGHG1(:,39, 5) = (/ &
  & 0.38455318E-03_JPRB, 0.38408314E-03_JPRB, 0.38350262E-03_JPRB, 0.38261438E-03_JPRB, 0.38163602E-03_JPRB, 0.38085203E-03_JPRB, &
  & 0.38039503E-03_JPRB, 0.38020461E-03_JPRB, 0.38024133E-03_JPRB, 0.38043790E-03_JPRB, 0.38066726E-03_JPRB, 0.38080226E-03_JPRB, &
  & 0.38091079E-03_JPRB, 0.38110334E-03_JPRB, 0.38124888E-03_JPRB, 0.38131776E-03_JPRB, 0.38142046E-03_JPRB, 0.38157252E-03_JPRB, &
  & 0.38175340E-03_JPRB, 0.38195488E-03_JPRB, 0.38231416E-03_JPRB, 0.38283264E-03_JPRB, 0.38339432E-03_JPRB, 0.38384332E-03_JPRB, &
  & 0.38414416E-03_JPRB, 0.38436702E-03_JPRB, 0.38458379E-03_JPRB, 0.38495109E-03_JPRB, 0.38540815E-03_JPRB, 0.38581199E-03_JPRB, &
  & 0.38625448E-03_JPRB, 0.38676591E-03_JPRB, 0.38735007E-03_JPRB, 0.38783044E-03_JPRB, 0.38805989E-03_JPRB, 0.38794459E-03_JPRB, &
  & 0.38751013E-03_JPRB, 0.38699685E-03_JPRB, 0.38653742E-03_JPRB, 0.38615227E-03_JPRB, 0.38581873E-03_JPRB, 0.38548676E-03_JPRB, &
  & 0.38511303E-03_JPRB, 0.38474560E-03_JPRB, 0.38434364E-03_JPRB, 0.38388396E-03_JPRB, 0.38345395E-03_JPRB, 0.38303227E-03_JPRB, &
  & 0.38262329E-03_JPRB, 0.38220592E-03_JPRB, 0.38191656E-03_JPRB, 0.38168353E-03_JPRB, 0.38147367E-03_JPRB, 0.38130501E-03_JPRB, &
  & 0.38115516E-03_JPRB, 0.38099195E-03_JPRB, 0.38073100E-03_JPRB, 0.38056896E-03_JPRB, 0.38052529E-03_JPRB, 0.38044343E-03_JPRB, &
  & 0.38043943E-03_JPRB, 0.38054591E-03_JPRB, 0.38069984E-03_JPRB, 0.38056651E-03_JPRB  /)

RGHG1(:,40, 5) = (/ &
  & 0.38669035E-03_JPRB, 0.38605987E-03_JPRB, 0.38529492E-03_JPRB, 0.38424939E-03_JPRB, 0.38306146E-03_JPRB, 0.38216862E-03_JPRB, &
  & 0.38159957E-03_JPRB, 0.38127662E-03_JPRB, 0.38120858E-03_JPRB, 0.38128593E-03_JPRB, 0.38142231E-03_JPRB, 0.38147828E-03_JPRB, &
  & 0.38154080E-03_JPRB, 0.38171857E-03_JPRB, 0.38183479E-03_JPRB, 0.38185997E-03_JPRB, 0.38192402E-03_JPRB, 0.38202559E-03_JPRB, &
  & 0.38216071E-03_JPRB, 0.38231593E-03_JPRB, 0.38261275E-03_JPRB, 0.38309277E-03_JPRB, 0.38363646E-03_JPRB, 0.38403421E-03_JPRB, &
  & 0.38423523E-03_JPRB, 0.38439409E-03_JPRB, 0.38462520E-03_JPRB, 0.38500632E-03_JPRB, 0.38549173E-03_JPRB, 0.38585806E-03_JPRB, &
  & 0.38627829E-03_JPRB, 0.38682254E-03_JPRB, 0.38748106E-03_JPRB, 0.38804328E-03_JPRB, 0.38834991E-03_JPRB, 0.38834634E-03_JPRB, &
  & 0.38797254E-03_JPRB, 0.38740429E-03_JPRB, 0.38685988E-03_JPRB, 0.38643704E-03_JPRB, 0.38608667E-03_JPRB, 0.38576948E-03_JPRB, &
  & 0.38542371E-03_JPRB, 0.38511317E-03_JPRB, 0.38472664E-03_JPRB, 0.38426132E-03_JPRB, 0.38384693E-03_JPRB, 0.38346121E-03_JPRB, &
  & 0.38306196E-03_JPRB, 0.38263634E-03_JPRB, 0.38234416E-03_JPRB, 0.38213878E-03_JPRB, 0.38197422E-03_JPRB, 0.38180825E-03_JPRB, &
  & 0.38166083E-03_JPRB, 0.38153013E-03_JPRB, 0.38130680E-03_JPRB, 0.38114380E-03_JPRB, 0.38112266E-03_JPRB, 0.38106615E-03_JPRB, &
  & 0.38108589E-03_JPRB, 0.38120157E-03_JPRB, 0.38135525E-03_JPRB, 0.38125322E-03_JPRB  /)

RGHG1(:,41, 5) = (/ &
  & 0.38930334E-03_JPRB, 0.38847672E-03_JPRB, 0.38748628E-03_JPRB, 0.38624843E-03_JPRB, 0.38480426E-03_JPRB, 0.38377833E-03_JPRB, &
  & 0.38307229E-03_JPRB, 0.38258730E-03_JPRB, 0.38239118E-03_JPRB, 0.38232277E-03_JPRB, 0.38234547E-03_JPRB, 0.38230481E-03_JPRB, &
  & 0.38231108E-03_JPRB, 0.38247077E-03_JPRB, 0.38255116E-03_JPRB, 0.38252291E-03_JPRB, 0.38253969E-03_JPRB, 0.38257953E-03_JPRB, &
  & 0.38265871E-03_JPRB, 0.38275736E-03_JPRB, 0.38297782E-03_JPRB, 0.38341082E-03_JPRB, 0.38393253E-03_JPRB, 0.38426760E-03_JPRB, &
  & 0.38434656E-03_JPRB, 0.38442718E-03_JPRB, 0.38467582E-03_JPRB, 0.38507384E-03_JPRB, 0.38559391E-03_JPRB, 0.38591440E-03_JPRB, &
  & 0.38630739E-03_JPRB, 0.38689179E-03_JPRB, 0.38764122E-03_JPRB, 0.38830351E-03_JPRB, 0.38870449E-03_JPRB, 0.38883753E-03_JPRB, &
  & 0.38853791E-03_JPRB, 0.38790245E-03_JPRB, 0.38725414E-03_JPRB, 0.38678521E-03_JPRB, 0.38641426E-03_JPRB, 0.38611515E-03_JPRB, &
  & 0.38580357E-03_JPRB, 0.38556259E-03_JPRB, 0.38519491E-03_JPRB, 0.38472271E-03_JPRB, 0.38432740E-03_JPRB, 0.38398566E-03_JPRB, &
  & 0.38359830E-03_JPRB, 0.38316258E-03_JPRB, 0.38286696E-03_JPRB, 0.38269538E-03_JPRB, 0.38258622E-03_JPRB, 0.38242353E-03_JPRB, &
  & 0.38227909E-03_JPRB, 0.38218813E-03_JPRB, 0.38201081E-03_JPRB, 0.38184664E-03_JPRB, 0.38185303E-03_JPRB, 0.38182750E-03_JPRB, &
  & 0.38187627E-03_JPRB, 0.38200322E-03_JPRB, 0.38215659E-03_JPRB, 0.38209281E-03_JPRB  /)

RGHG1(:,42, 5) = (/ &
  & 0.39027996E-03_JPRB, 0.38938154E-03_JPRB, 0.38811405E-03_JPRB, 0.38686300E-03_JPRB, 0.38549066E-03_JPRB, 0.38448340E-03_JPRB, &
  & 0.38375270E-03_JPRB, 0.38322467E-03_JPRB, 0.38293913E-03_JPRB, 0.38276865E-03_JPRB, 0.38267729E-03_JPRB, 0.38255184E-03_JPRB, &
  & 0.38251366E-03_JPRB, 0.38264322E-03_JPRB, 0.38270895E-03_JPRB, 0.38266740E-03_JPRB, 0.38266417E-03_JPRB, 0.38269851E-03_JPRB, &
  & 0.38276076E-03_JPRB, 0.38281875E-03_JPRB, 0.38301363E-03_JPRB, 0.38342574E-03_JPRB, 0.38391712E-03_JPRB, 0.38420908E-03_JPRB, &
  & 0.38427132E-03_JPRB, 0.38437165E-03_JPRB, 0.38469205E-03_JPRB, 0.38514081E-03_JPRB, 0.38564191E-03_JPRB, 0.38598317E-03_JPRB, &
  & 0.38637538E-03_JPRB, 0.38694162E-03_JPRB, 0.38765715E-03_JPRB, 0.38827708E-03_JPRB, 0.38868273E-03_JPRB, 0.38883891E-03_JPRB, &
  & 0.38864152E-03_JPRB, 0.38807599E-03_JPRB, 0.38743589E-03_JPRB, 0.38696356E-03_JPRB, 0.38652584E-03_JPRB, 0.38617787E-03_JPRB, &
  & 0.38585812E-03_JPRB, 0.38562292E-03_JPRB, 0.38530733E-03_JPRB, 0.38487509E-03_JPRB, 0.38447781E-03_JPRB, 0.38413166E-03_JPRB, &
  & 0.38374986E-03_JPRB, 0.38331306E-03_JPRB, 0.38302211E-03_JPRB, 0.38282876E-03_JPRB, 0.38270033E-03_JPRB, 0.38256427E-03_JPRB, &
  & 0.38240666E-03_JPRB, 0.38232539E-03_JPRB, 0.38218728E-03_JPRB, 0.38205217E-03_JPRB, 0.38208973E-03_JPRB, 0.38207497E-03_JPRB, &
  & 0.38211403E-03_JPRB, 0.38225843E-03_JPRB, 0.38238681E-03_JPRB, 0.38231236E-03_JPRB  /)

RGHG1(:,43, 5) = (/ &
  & 0.39229499E-03_JPRB, 0.39124670E-03_JPRB, 0.38962944E-03_JPRB, 0.38828361E-03_JPRB, 0.38686658E-03_JPRB, 0.38581912E-03_JPRB, &
  & 0.38500700E-03_JPRB, 0.38436999E-03_JPRB, 0.38394776E-03_JPRB, 0.38362146E-03_JPRB, 0.38337714E-03_JPRB, 0.38313276E-03_JPRB, &
  & 0.38302982E-03_JPRB, 0.38312411E-03_JPRB, 0.38316106E-03_JPRB, 0.38308439E-03_JPRB, 0.38304257E-03_JPRB, 0.38304535E-03_JPRB, &
  & 0.38306808E-03_JPRB, 0.38306464E-03_JPRB, 0.38320333E-03_JPRB, 0.38357616E-03_JPRB, 0.38403042E-03_JPRB, 0.38425608E-03_JPRB, &
  & 0.38425056E-03_JPRB, 0.38433522E-03_JPRB, 0.38472863E-03_JPRB, 0.38523095E-03_JPRB, 0.38572967E-03_JPRB, 0.38607015E-03_JPRB, &
  & 0.38644994E-03_JPRB, 0.38701686E-03_JPRB, 0.38774058E-03_JPRB, 0.38836491E-03_JPRB, 0.38881540E-03_JPRB, 0.38905146E-03_JPRB, &
  & 0.38897925E-03_JPRB, 0.38844860E-03_JPRB, 0.38777130E-03_JPRB, 0.38727606E-03_JPRB, 0.38676857E-03_JPRB, 0.38638378E-03_JPRB, &
  & 0.38607128E-03_JPRB, 0.38587127E-03_JPRB, 0.38561134E-03_JPRB, 0.38521259E-03_JPRB, 0.38482171E-03_JPRB, 0.38449046E-03_JPRB, &
  & 0.38411885E-03_JPRB, 0.38367673E-03_JPRB, 0.38338855E-03_JPRB, 0.38318987E-03_JPRB, 0.38306770E-03_JPRB, 0.38295733E-03_JPRB, &
  & 0.38278900E-03_JPRB, 0.38273366E-03_JPRB, 0.38265112E-03_JPRB, 0.38254202E-03_JPRB, 0.38261987E-03_JPRB, 0.38262826E-03_JPRB, &
  & 0.38267095E-03_JPRB, 0.38283610E-03_JPRB, 0.38294157E-03_JPRB, 0.38287383E-03_JPRB  /)

RGHG1(:,44, 5) = (/ &
  & 0.39294849E-03_JPRB, 0.39174544E-03_JPRB, 0.38998397E-03_JPRB, 0.38865437E-03_JPRB, 0.38734834E-03_JPRB, 0.38632595E-03_JPRB, &
  & 0.38549574E-03_JPRB, 0.38480999E-03_JPRB, 0.38432455E-03_JPRB, 0.38394873E-03_JPRB, 0.38363654E-03_JPRB, 0.38332738E-03_JPRB, &
  & 0.38317984E-03_JPRB, 0.38321548E-03_JPRB, 0.38322796E-03_JPRB, 0.38314582E-03_JPRB, 0.38308668E-03_JPRB, 0.38307853E-03_JPRB, &
  & 0.38307035E-03_JPRB, 0.38304845E-03_JPRB, 0.38316493E-03_JPRB, 0.38352111E-03_JPRB, 0.38398521E-03_JPRB, 0.38420353E-03_JPRB, &
  & 0.38423391E-03_JPRB, 0.38435609E-03_JPRB, 0.38475648E-03_JPRB, 0.38526230E-03_JPRB, 0.38576494E-03_JPRB, 0.38611448E-03_JPRB, &
  & 0.38648182E-03_JPRB, 0.38702633E-03_JPRB, 0.38772627E-03_JPRB, 0.38834666E-03_JPRB, 0.38883312E-03_JPRB, 0.38912527E-03_JPRB, &
  & 0.38909808E-03_JPRB, 0.38860005E-03_JPRB, 0.38796890E-03_JPRB, 0.38747207E-03_JPRB, 0.38694520E-03_JPRB, 0.38652773E-03_JPRB, &
  & 0.38621530E-03_JPRB, 0.38601983E-03_JPRB, 0.38575950E-03_JPRB, 0.38538715E-03_JPRB, 0.38498692E-03_JPRB, 0.38464889E-03_JPRB, &
  & 0.38427928E-03_JPRB, 0.38383070E-03_JPRB, 0.38353537E-03_JPRB, 0.38330424E-03_JPRB, 0.38313324E-03_JPRB, 0.38301410E-03_JPRB, &
  & 0.38284450E-03_JPRB, 0.38278229E-03_JPRB, 0.38270296E-03_JPRB, 0.38258413E-03_JPRB, 0.38267393E-03_JPRB, 0.38269331E-03_JPRB, &
  & 0.38276259E-03_JPRB, 0.38294905E-03_JPRB, 0.38303438E-03_JPRB, 0.38287170E-03_JPRB  /)

RGHG1(:,45, 5) = (/ &
  & 0.39394700E-03_JPRB, 0.39254883E-03_JPRB, 0.39057900E-03_JPRB, 0.38925591E-03_JPRB, 0.38807060E-03_JPRB, 0.38707167E-03_JPRB, &
  & 0.38621058E-03_JPRB, 0.38545558E-03_JPRB, 0.38488091E-03_JPRB, 0.38442902E-03_JPRB, 0.38402026E-03_JPRB, 0.38362232E-03_JPRB, &
  & 0.38341582E-03_JPRB, 0.38338025E-03_JPRB, 0.38336124E-03_JPRB, 0.38326843E-03_JPRB, 0.38318469E-03_JPRB, 0.38316012E-03_JPRB, &
  & 0.38311175E-03_JPRB, 0.38306109E-03_JPRB, 0.38314518E-03_JPRB, 0.38347744E-03_JPRB, 0.38394804E-03_JPRB, 0.38414965E-03_JPRB, &
  & 0.38421234E-03_JPRB, 0.38437523E-03_JPRB, 0.38479281E-03_JPRB, 0.38530937E-03_JPRB, 0.38581617E-03_JPRB, 0.38617594E-03_JPRB, &
  & 0.38652753E-03_JPRB, 0.38704662E-03_JPRB, 0.38772052E-03_JPRB, 0.38833697E-03_JPRB, 0.38887006E-03_JPRB, 0.38923615E-03_JPRB, &
  & 0.38927601E-03_JPRB, 0.38881954E-03_JPRB, 0.38823621E-03_JPRB, 0.38773470E-03_JPRB, 0.38717695E-03_JPRB, 0.38671762E-03_JPRB, &
  & 0.38640617E-03_JPRB, 0.38622031E-03_JPRB, 0.38596657E-03_JPRB, 0.38562851E-03_JPRB, 0.38521844E-03_JPRB, 0.38487458E-03_JPRB, &
  & 0.38450852E-03_JPRB, 0.38405193E-03_JPRB, 0.38374880E-03_JPRB, 0.38348005E-03_JPRB, 0.38325426E-03_JPRB, 0.38312839E-03_JPRB, &
  & 0.38295598E-03_JPRB, 0.38288924E-03_JPRB, 0.38282058E-03_JPRB, 0.38269394E-03_JPRB, 0.38280244E-03_JPRB, 0.38283727E-03_JPRB, &
  & 0.38293727E-03_JPRB, 0.38315059E-03_JPRB, 0.38321012E-03_JPRB, 0.38294019E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART10',0,ZHOOK_HANDLE)



RGHG1(:,46, 5) = (/ &
  & 0.39407520E-03_JPRB, 0.39244487E-03_JPRB, 0.39049039E-03_JPRB, 0.38924801E-03_JPRB, 0.38819221E-03_JPRB, 0.38725150E-03_JPRB, &
  & 0.38641021E-03_JPRB, 0.38561871E-03_JPRB, 0.38499755E-03_JPRB, 0.38452761E-03_JPRB, 0.38410787E-03_JPRB, 0.38369267E-03_JPRB, &
  & 0.38345051E-03_JPRB, 0.38335240E-03_JPRB, 0.38329291E-03_JPRB, 0.38319169E-03_JPRB, 0.38310105E-03_JPRB, 0.38306138E-03_JPRB, &
  & 0.38299488E-03_JPRB, 0.38295175E-03_JPRB, 0.38302801E-03_JPRB, 0.38335645E-03_JPRB, 0.38383917E-03_JPRB, 0.38408153E-03_JPRB, &
  & 0.38420583E-03_JPRB, 0.38439565E-03_JPRB, 0.38481219E-03_JPRB, 0.38532524E-03_JPRB, 0.38582746E-03_JPRB, 0.38619401E-03_JPRB, &
  & 0.38654497E-03_JPRB, 0.38706211E-03_JPRB, 0.38772228E-03_JPRB, 0.38833451E-03_JPRB, 0.38889174E-03_JPRB, 0.38930452E-03_JPRB, &
  & 0.38937923E-03_JPRB, 0.38893357E-03_JPRB, 0.38837655E-03_JPRB, 0.38788187E-03_JPRB, 0.38732956E-03_JPRB, 0.38687109E-03_JPRB, &
  & 0.38658077E-03_JPRB, 0.38640283E-03_JPRB, 0.38615712E-03_JPRB, 0.38584968E-03_JPRB, 0.38542747E-03_JPRB, 0.38508188E-03_JPRB, &
  & 0.38470573E-03_JPRB, 0.38424222E-03_JPRB, 0.38389686E-03_JPRB, 0.38359070E-03_JPRB, 0.38332664E-03_JPRB, 0.38318665E-03_JPRB, &
  & 0.38302853E-03_JPRB, 0.38292356E-03_JPRB, 0.38283823E-03_JPRB, 0.38268250E-03_JPRB, 0.38276169E-03_JPRB, 0.38280871E-03_JPRB, &
  & 0.38295341E-03_JPRB, 0.38317120E-03_JPRB, 0.38322862E-03_JPRB, 0.38292328E-03_JPRB  /)

RGHG1(:,47, 5) = (/ &
  & 0.39405130E-03_JPRB, 0.39214112E-03_JPRB, 0.39024947E-03_JPRB, 0.38911666E-03_JPRB, 0.38821460E-03_JPRB, 0.38734916E-03_JPRB, &
  & 0.38654125E-03_JPRB, 0.38571349E-03_JPRB, 0.38504634E-03_JPRB, 0.38456684E-03_JPRB, 0.38415135E-03_JPRB, 0.38373023E-03_JPRB, &
  & 0.38345089E-03_JPRB, 0.38328115E-03_JPRB, 0.38317233E-03_JPRB, 0.38306170E-03_JPRB, 0.38296651E-03_JPRB, 0.38290939E-03_JPRB, &
  & 0.38282605E-03_JPRB, 0.38279900E-03_JPRB, 0.38287101E-03_JPRB, 0.38319900E-03_JPRB, 0.38369704E-03_JPRB, 0.38399874E-03_JPRB, &
  & 0.38420120E-03_JPRB, 0.38441985E-03_JPRB, 0.38483154E-03_JPRB, 0.38533761E-03_JPRB, 0.38583269E-03_JPRB, 0.38620653E-03_JPRB, &
  & 0.38655977E-03_JPRB, 0.38707934E-03_JPRB, 0.38772584E-03_JPRB, 0.38833306E-03_JPRB, 0.38891412E-03_JPRB, 0.38937623E-03_JPRB, &
  & 0.38948539E-03_JPRB, 0.38904625E-03_JPRB, 0.38851579E-03_JPRB, 0.38803143E-03_JPRB, 0.38749277E-03_JPRB, 0.38704387E-03_JPRB, &
  & 0.38678238E-03_JPRB, 0.38661340E-03_JPRB, 0.38637740E-03_JPRB, 0.38610517E-03_JPRB, 0.38566823E-03_JPRB, 0.38532143E-03_JPRB, &
  & 0.38493072E-03_JPRB, 0.38445931E-03_JPRB, 0.38405750E-03_JPRB, 0.38370748E-03_JPRB, 0.38340184E-03_JPRB, 0.38324378E-03_JPRB, &
  & 0.38310585E-03_JPRB, 0.38294928E-03_JPRB, 0.38283891E-03_JPRB, 0.38264479E-03_JPRB, 0.38267997E-03_JPRB, 0.38274065E-03_JPRB, &
  & 0.38294058E-03_JPRB, 0.38315914E-03_JPRB, 0.38321883E-03_JPRB, 0.38288633E-03_JPRB  /)

RGHG1(:,48, 5) = (/ &
  & 0.39334691E-03_JPRB, 0.39136584E-03_JPRB, 0.38954618E-03_JPRB, 0.38857893E-03_JPRB, 0.38783498E-03_JPRB, 0.38708592E-03_JPRB, &
  & 0.38635579E-03_JPRB, 0.38551413E-03_JPRB, 0.38482024E-03_JPRB, 0.38436453E-03_JPRB, 0.38398078E-03_JPRB, 0.38359653E-03_JPRB, &
  & 0.38329410E-03_JPRB, 0.38309474E-03_JPRB, 0.38297541E-03_JPRB, 0.38286847E-03_JPRB, 0.38279110E-03_JPRB, 0.38273288E-03_JPRB, &
  & 0.38264110E-03_JPRB, 0.38262860E-03_JPRB, 0.38271663E-03_JPRB, 0.38304922E-03_JPRB, 0.38356000E-03_JPRB, 0.38392643E-03_JPRB, &
  & 0.38417851E-03_JPRB, 0.38441723E-03_JPRB, 0.38484660E-03_JPRB, 0.38533682E-03_JPRB, 0.38583153E-03_JPRB, 0.38621611E-03_JPRB, &
  & 0.38656836E-03_JPRB, 0.38708515E-03_JPRB, 0.38772225E-03_JPRB, 0.38832282E-03_JPRB, 0.38891954E-03_JPRB, 0.38940502E-03_JPRB, &
  & 0.38952835E-03_JPRB, 0.38908368E-03_JPRB, 0.38856250E-03_JPRB, 0.38810447E-03_JPRB, 0.38758884E-03_JPRB, 0.38716964E-03_JPRB, &
  & 0.38694422E-03_JPRB, 0.38679160E-03_JPRB, 0.38658500E-03_JPRB, 0.38634371E-03_JPRB, 0.38593764E-03_JPRB, 0.38560215E-03_JPRB, &
  & 0.38519517E-03_JPRB, 0.38472267E-03_JPRB, 0.38428179E-03_JPRB, 0.38389109E-03_JPRB, 0.38354503E-03_JPRB, 0.38337713E-03_JPRB, &
  & 0.38325708E-03_JPRB, 0.38304242E-03_JPRB, 0.38287760E-03_JPRB, 0.38264204E-03_JPRB, 0.38261784E-03_JPRB, 0.38264570E-03_JPRB, &
  & 0.38290684E-03_JPRB, 0.38316943E-03_JPRB, 0.38320382E-03_JPRB, 0.38286405E-03_JPRB  /)

RGHG1(:,49, 5) = (/ &
  & 0.39225748E-03_JPRB, 0.39029293E-03_JPRB, 0.38855714E-03_JPRB, 0.38779867E-03_JPRB, 0.38723182E-03_JPRB, 0.38663034E-03_JPRB, &
  & 0.38600651E-03_JPRB, 0.38515963E-03_JPRB, 0.38444487E-03_JPRB, 0.38403067E-03_JPRB, 0.38369458E-03_JPRB, 0.38337061E-03_JPRB, &
  & 0.38304902E-03_JPRB, 0.38283596E-03_JPRB, 0.38272262E-03_JPRB, 0.38262572E-03_JPRB, 0.38257826E-03_JPRB, 0.38252628E-03_JPRB, &
  & 0.38242896E-03_JPRB, 0.38243188E-03_JPRB, 0.38254686E-03_JPRB, 0.38288685E-03_JPRB, 0.38341056E-03_JPRB, 0.38385113E-03_JPRB, &
  & 0.38414518E-03_JPRB, 0.38440212E-03_JPRB, 0.38486132E-03_JPRB, 0.38532997E-03_JPRB, 0.38582732E-03_JPRB, 0.38622538E-03_JPRB, &
  & 0.38657506E-03_JPRB, 0.38708639E-03_JPRB, 0.38771500E-03_JPRB, 0.38830748E-03_JPRB, 0.38891783E-03_JPRB, 0.38941741E-03_JPRB, &
  & 0.38954720E-03_JPRB, 0.38909093E-03_JPRB, 0.38857216E-03_JPRB, 0.38815058E-03_JPRB, 0.38766469E-03_JPRB, 0.38728754E-03_JPRB, &
  & 0.38710534E-03_JPRB, 0.38697422E-03_JPRB, 0.38680913E-03_JPRB, 0.38660016E-03_JPRB, 0.38624899E-03_JPRB, 0.38593172E-03_JPRB, &
  & 0.38550598E-03_JPRB, 0.38503535E-03_JPRB, 0.38455911E-03_JPRB, 0.38412480E-03_JPRB, 0.38373450E-03_JPRB, 0.38355944E-03_JPRB, &
  & 0.38345816E-03_JPRB, 0.38317621E-03_JPRB, 0.38293772E-03_JPRB, 0.38265489E-03_JPRB, 0.38255796E-03_JPRB, 0.38252834E-03_JPRB, &
  & 0.38285995E-03_JPRB, 0.38319101E-03_JPRB, 0.38318482E-03_JPRB, 0.38284606E-03_JPRB  /)

RGHG1(:,50, 5) = (/ &
  & 0.39075722E-03_JPRB, 0.38893305E-03_JPRB, 0.38736666E-03_JPRB, 0.38679998E-03_JPRB, 0.38638104E-03_JPRB, 0.38595182E-03_JPRB, &
  & 0.38545802E-03_JPRB, 0.38465473E-03_JPRB, 0.38394220E-03_JPRB, 0.38356709E-03_JPRB, 0.38328946E-03_JPRB, 0.38302513E-03_JPRB, &
  & 0.38273311E-03_JPRB, 0.38254426E-03_JPRB, 0.38246548E-03_JPRB, 0.38239981E-03_JPRB, 0.38238961E-03_JPRB, 0.38233911E-03_JPRB, &
  & 0.38225684E-03_JPRB, 0.38225878E-03_JPRB, 0.38239294E-03_JPRB, 0.38273510E-03_JPRB, 0.38326713E-03_JPRB, 0.38375807E-03_JPRB, &
  & 0.38409905E-03_JPRB, 0.38436934E-03_JPRB, 0.38483677E-03_JPRB, 0.38529245E-03_JPRB, 0.38578809E-03_JPRB, 0.38622527E-03_JPRB, &
  & 0.38658530E-03_JPRB, 0.38707946E-03_JPRB, 0.38769704E-03_JPRB, 0.38827812E-03_JPRB, 0.38889915E-03_JPRB, 0.38939726E-03_JPRB, &
  & 0.38951247E-03_JPRB, 0.38904835E-03_JPRB, 0.38853412E-03_JPRB, 0.38814090E-03_JPRB, 0.38769846E-03_JPRB, 0.38735971E-03_JPRB, &
  & 0.38721711E-03_JPRB, 0.38711675E-03_JPRB, 0.38699115E-03_JPRB, 0.38680804E-03_JPRB, 0.38651465E-03_JPRB, 0.38623837E-03_JPRB, &
  & 0.38583089E-03_JPRB, 0.38537230E-03_JPRB, 0.38489594E-03_JPRB, 0.38445177E-03_JPRB, 0.38404478E-03_JPRB, 0.38384966E-03_JPRB, &
  & 0.38374516E-03_JPRB, 0.38342156E-03_JPRB, 0.38311696E-03_JPRB, 0.38277389E-03_JPRB, 0.38260999E-03_JPRB, 0.38255024E-03_JPRB, &
  & 0.38287747E-03_JPRB, 0.38323587E-03_JPRB, 0.38318660E-03_JPRB, 0.38282672E-03_JPRB  /)

RGHG1(:,51, 5) = (/ &
  & 0.38891852E-03_JPRB, 0.38731132E-03_JPRB, 0.38597312E-03_JPRB, 0.38560493E-03_JPRB, 0.38533063E-03_JPRB, 0.38510073E-03_JPRB, &
  & 0.38476002E-03_JPRB, 0.38402954E-03_JPRB, 0.38333158E-03_JPRB, 0.38299747E-03_JPRB, 0.38278874E-03_JPRB, 0.38258860E-03_JPRB, &
  & 0.38235418E-03_JPRB, 0.38221145E-03_JPRB, 0.38218506E-03_JPRB, 0.38216430E-03_JPRB, 0.38219827E-03_JPRB, 0.38214687E-03_JPRB, &
  & 0.38209169E-03_JPRB, 0.38208396E-03_JPRB, 0.38223480E-03_JPRB, 0.38257655E-03_JPRB, 0.38311517E-03_JPRB, 0.38364808E-03_JPRB, &
  & 0.38404243E-03_JPRB, 0.38432460E-03_JPRB, 0.38478959E-03_JPRB, 0.38523575E-03_JPRB, 0.38572723E-03_JPRB, 0.38622023E-03_JPRB, &
  & 0.38659823E-03_JPRB, 0.38706767E-03_JPRB, 0.38767199E-03_JPRB, 0.38823899E-03_JPRB, 0.38887002E-03_JPRB, 0.38935838E-03_JPRB, &
  & 0.38944674E-03_JPRB, 0.38897611E-03_JPRB, 0.38846790E-03_JPRB, 0.38810112E-03_JPRB, 0.38771286E-03_JPRB, 0.38741373E-03_JPRB, &
  & 0.38731204E-03_JPRB, 0.38724984E-03_JPRB, 0.38716589E-03_JPRB, 0.38700735E-03_JPRB, 0.38677799E-03_JPRB, 0.38655800E-03_JPRB, &
  & 0.38618973E-03_JPRB, 0.38574953E-03_JPRB, 0.38529155E-03_JPRB, 0.38485446E-03_JPRB, 0.38444389E-03_JPRB, 0.38422029E-03_JPRB, &
  & 0.38410074E-03_JPRB, 0.38374558E-03_JPRB, 0.38337346E-03_JPRB, 0.38295839E-03_JPRB, 0.38272510E-03_JPRB, 0.38264713E-03_JPRB, &
  & 0.38293027E-03_JPRB, 0.38329664E-03_JPRB, 0.38319945E-03_JPRB, 0.38280508E-03_JPRB  /)

RGHG1(:,52, 5) = (/ &
  & 0.38721616E-03_JPRB, 0.38582176E-03_JPRB, 0.38477269E-03_JPRB, 0.38453502E-03_JPRB, 0.38436028E-03_JPRB, 0.38425068E-03_JPRB, &
  & 0.38402223E-03_JPRB, 0.38342230E-03_JPRB, 0.38277014E-03_JPRB, 0.38248138E-03_JPRB, 0.38233014E-03_JPRB, 0.38218607E-03_JPRB, &
  & 0.38201521E-03_JPRB, 0.38194050E-03_JPRB, 0.38194631E-03_JPRB, 0.38195510E-03_JPRB, 0.38200922E-03_JPRB, 0.38197081E-03_JPRB, &
  & 0.38194915E-03_JPRB, 0.38192893E-03_JPRB, 0.38207678E-03_JPRB, 0.38241970E-03_JPRB, 0.38296442E-03_JPRB, 0.38352203E-03_JPRB, &
  & 0.38395519E-03_JPRB, 0.38425775E-03_JPRB, 0.38469211E-03_JPRB, 0.38513940E-03_JPRB, 0.38562619E-03_JPRB, 0.38615478E-03_JPRB, &
  & 0.38657132E-03_JPRB, 0.38702259E-03_JPRB, 0.38760813E-03_JPRB, 0.38817792E-03_JPRB, 0.38883848E-03_JPRB, 0.38930675E-03_JPRB, &
  & 0.38935490E-03_JPRB, 0.38889061E-03_JPRB, 0.38837844E-03_JPRB, 0.38803208E-03_JPRB, 0.38769617E-03_JPRB, 0.38742841E-03_JPRB, &
  & 0.38736048E-03_JPRB, 0.38733223E-03_JPRB, 0.38728013E-03_JPRB, 0.38714629E-03_JPRB, 0.38697756E-03_JPRB, 0.38681444E-03_JPRB, &
  & 0.38651174E-03_JPRB, 0.38610762E-03_JPRB, 0.38568940E-03_JPRB, 0.38530739E-03_JPRB, 0.38491744E-03_JPRB, 0.38468944E-03_JPRB, &
  & 0.38457161E-03_JPRB, 0.38421479E-03_JPRB, 0.38383238E-03_JPRB, 0.38336485E-03_JPRB, 0.38304838E-03_JPRB, 0.38292249E-03_JPRB, &
  & 0.38314320E-03_JPRB, 0.38345667E-03_JPRB, 0.38332397E-03_JPRB, 0.38292431E-03_JPRB  /)

RGHG1(:,53, 5) = (/ &
  & 0.38541476E-03_JPRB, 0.38425050E-03_JPRB, 0.38353974E-03_JPRB, 0.38341804E-03_JPRB, 0.38333438E-03_JPRB, 0.38332538E-03_JPRB, &
  & 0.38320346E-03_JPRB, 0.38276792E-03_JPRB, 0.38217765E-03_JPRB, 0.38193998E-03_JPRB, 0.38184693E-03_JPRB, 0.38176081E-03_JPRB, &
  & 0.38166145E-03_JPRB, 0.38166924E-03_JPRB, 0.38170235E-03_JPRB, 0.38173740E-03_JPRB, 0.38180423E-03_JPRB, 0.38178531E-03_JPRB, &
  & 0.38180262E-03_JPRB, 0.38176771E-03_JPRB, 0.38190475E-03_JPRB, 0.38224957E-03_JPRB, 0.38280072E-03_JPRB, 0.38337859E-03_JPRB, &
  & 0.38384840E-03_JPRB, 0.38417646E-03_JPRB, 0.38456661E-03_JPRB, 0.38501922E-03_JPRB, 0.38550069E-03_JPRB, 0.38606026E-03_JPRB, &
  & 0.38652668E-03_JPRB, 0.38696070E-03_JPRB, 0.38752366E-03_JPRB, 0.38810298E-03_JPRB, 0.38880320E-03_JPRB, 0.38924563E-03_JPRB, &
  & 0.38924485E-03_JPRB, 0.38879241E-03_JPRB, 0.38827208E-03_JPRB, 0.38794564E-03_JPRB, 0.38766604E-03_JPRB, 0.38742927E-03_JPRB, &
  & 0.38739533E-03_JPRB, 0.38740245E-03_JPRB, 0.38738125E-03_JPRB, 0.38727436E-03_JPRB, 0.38717036E-03_JPRB, 0.38706939E-03_JPRB, &
  & 0.38684824E-03_JPRB, 0.38649022E-03_JPRB, 0.38612350E-03_JPRB, 0.38581995E-03_JPRB, 0.38546176E-03_JPRB, 0.38523823E-03_JPRB, &
  & 0.38512872E-03_JPRB, 0.38478161E-03_JPRB, 0.38441002E-03_JPRB, 0.38389286E-03_JPRB, 0.38348051E-03_JPRB, 0.38329101E-03_JPRB, &
  & 0.38343670E-03_JPRB, 0.38366913E-03_JPRB, 0.38350252E-03_JPRB, 0.38310836E-03_JPRB  /)

RGHG1(:,54, 5) = (/ &
  & 0.38413666E-03_JPRB, 0.38325361E-03_JPRB, 0.38280989E-03_JPRB, 0.38276908E-03_JPRB, 0.38272117E-03_JPRB, 0.38272139E-03_JPRB, &
  & 0.38263076E-03_JPRB, 0.38233210E-03_JPRB, 0.38182483E-03_JPRB, 0.38162396E-03_JPRB, 0.38156142E-03_JPRB, 0.38151239E-03_JPRB, &
  & 0.38145333E-03_JPRB, 0.38150816E-03_JPRB, 0.38154850E-03_JPRB, 0.38158289E-03_JPRB, 0.38164753E-03_JPRB, 0.38163781E-03_JPRB, &
  & 0.38165661E-03_JPRB, 0.38162419E-03_JPRB, 0.38174414E-03_JPRB, 0.38208761E-03_JPRB, 0.38263635E-03_JPRB, 0.38320536E-03_JPRB, &
  & 0.38368325E-03_JPRB, 0.38406744E-03_JPRB, 0.38443034E-03_JPRB, 0.38488402E-03_JPRB, 0.38535596E-03_JPRB, 0.38589509E-03_JPRB, &
  & 0.38637753E-03_JPRB, 0.38683691E-03_JPRB, 0.38740328E-03_JPRB, 0.38802197E-03_JPRB, 0.38875212E-03_JPRB, 0.38915338E-03_JPRB, &
  & 0.38912697E-03_JPRB, 0.38870269E-03_JPRB, 0.38818348E-03_JPRB, 0.38788252E-03_JPRB, 0.38763234E-03_JPRB, 0.38741804E-03_JPRB, &
  & 0.38740954E-03_JPRB, 0.38743195E-03_JPRB, 0.38743373E-03_JPRB, 0.38735256E-03_JPRB, 0.38730489E-03_JPRB, 0.38725645E-03_JPRB, &
  & 0.38710621E-03_JPRB, 0.38681077E-03_JPRB, 0.38651029E-03_JPRB, 0.38629687E-03_JPRB, 0.38600937E-03_JPRB, 0.38582938E-03_JPRB, &
  & 0.38574986E-03_JPRB, 0.38543200E-03_JPRB, 0.38508478E-03_JPRB, 0.38458213E-03_JPRB, 0.38410198E-03_JPRB, 0.38385766E-03_JPRB, &
  & 0.38395489E-03_JPRB, 0.38410699E-03_JPRB, 0.38391305E-03_JPRB, 0.38349602E-03_JPRB  /)

RGHG1(:,55, 5) = (/ &
  & 0.38278966E-03_JPRB, 0.38222486E-03_JPRB, 0.38206759E-03_JPRB, 0.38211175E-03_JPRB, 0.38209618E-03_JPRB, 0.38209457E-03_JPRB, &
  & 0.38202872E-03_JPRB, 0.38187807E-03_JPRB, 0.38146552E-03_JPRB, 0.38130354E-03_JPRB, 0.38127115E-03_JPRB, 0.38126046E-03_JPRB, &
  & 0.38124193E-03_JPRB, 0.38134422E-03_JPRB, 0.38138993E-03_JPRB, 0.38142004E-03_JPRB, 0.38148031E-03_JPRB, 0.38147942E-03_JPRB, &
  & 0.38149495E-03_JPRB, 0.38146754E-03_JPRB, 0.38156771E-03_JPRB, 0.38190927E-03_JPRB, 0.38245419E-03_JPRB, 0.38300953E-03_JPRB, &
  & 0.38349261E-03_JPRB, 0.38394302E-03_JPRB, 0.38427796E-03_JPRB, 0.38473228E-03_JPRB, 0.38519311E-03_JPRB, 0.38570282E-03_JPRB, &
  & 0.38619856E-03_JPRB, 0.38669163E-03_JPRB, 0.38726520E-03_JPRB, 0.38793144E-03_JPRB, 0.38869347E-03_JPRB, 0.38904709E-03_JPRB, &
  & 0.38899536E-03_JPRB, 0.38860441E-03_JPRB, 0.38808766E-03_JPRB, 0.38781567E-03_JPRB, 0.38759454E-03_JPRB, 0.38740402E-03_JPRB, &
  & 0.38742256E-03_JPRB, 0.38745928E-03_JPRB, 0.38748546E-03_JPRB, 0.38743262E-03_JPRB, 0.38744625E-03_JPRB, 0.38745473E-03_JPRB, &
  & 0.38738163E-03_JPRB, 0.38715769E-03_JPRB, 0.38693254E-03_JPRB, 0.38682049E-03_JPRB, 0.38661643E-03_JPRB, 0.38648980E-03_JPRB, &
  & 0.38644635E-03_JPRB, 0.38616347E-03_JPRB, 0.38584503E-03_JPRB, 0.38536688E-03_JPRB, 0.38481532E-03_JPRB, 0.38451143E-03_JPRB, &
  & 0.38455848E-03_JPRB, 0.38462169E-03_JPRB, 0.38439832E-03_JPRB, 0.38395225E-03_JPRB  /)

RGHG1(:,56, 5) = (/ &
  & 0.38224065E-03_JPRB, 0.38192557E-03_JPRB, 0.38191485E-03_JPRB, 0.38196406E-03_JPRB, 0.38197887E-03_JPRB, 0.38195629E-03_JPRB, &
  & 0.38186761E-03_JPRB, 0.38177578E-03_JPRB, 0.38142987E-03_JPRB, 0.38127286E-03_JPRB, 0.38122493E-03_JPRB, 0.38121423E-03_JPRB, &
  & 0.38119258E-03_JPRB, 0.38128680E-03_JPRB, 0.38132766E-03_JPRB, 0.38133419E-03_JPRB, 0.38138043E-03_JPRB, 0.38137416E-03_JPRB, &
  & 0.38138357E-03_JPRB, 0.38134980E-03_JPRB, 0.38143504E-03_JPRB, 0.38176702E-03_JPRB, 0.38227226E-03_JPRB, 0.38282950E-03_JPRB, &
  & 0.38328782E-03_JPRB, 0.38375602E-03_JPRB, 0.38414190E-03_JPRB, 0.38458399E-03_JPRB, 0.38506778E-03_JPRB, 0.38551767E-03_JPRB, &
  & 0.38598511E-03_JPRB, 0.38650801E-03_JPRB, 0.38712191E-03_JPRB, 0.38785669E-03_JPRB, 0.38860113E-03_JPRB, 0.38893726E-03_JPRB, &
  & 0.38888782E-03_JPRB, 0.38852431E-03_JPRB, 0.38803983E-03_JPRB, 0.38776839E-03_JPRB, 0.38755891E-03_JPRB, 0.38739449E-03_JPRB, &
  & 0.38742103E-03_JPRB, 0.38745684E-03_JPRB, 0.38749893E-03_JPRB, 0.38747260E-03_JPRB, 0.38752359E-03_JPRB, 0.38757709E-03_JPRB, &
  & 0.38756038E-03_JPRB, 0.38739635E-03_JPRB, 0.38723881E-03_JPRB, 0.38721095E-03_JPRB, 0.38707299E-03_JPRB, 0.38699979E-03_JPRB, &
  & 0.38698966E-03_JPRB, 0.38673838E-03_JPRB, 0.38642277E-03_JPRB, 0.38601419E-03_JPRB, 0.38551696E-03_JPRB, 0.38521662E-03_JPRB, &
  & 0.38524271E-03_JPRB, 0.38531089E-03_JPRB, 0.38515070E-03_JPRB, 0.38474102E-03_JPRB  /)

RGHG1(:,57, 5) = (/ &
  & 0.38175946E-03_JPRB, 0.38166697E-03_JPRB, 0.38178446E-03_JPRB, 0.38184401E-03_JPRB, 0.38189226E-03_JPRB, 0.38185698E-03_JPRB, &
  & 0.38174907E-03_JPRB, 0.38170558E-03_JPRB, 0.38141948E-03_JPRB, 0.38126475E-03_JPRB, 0.38120146E-03_JPRB, 0.38118074E-03_JPRB, &
  & 0.38115347E-03_JPRB, 0.38123614E-03_JPRB, 0.38126680E-03_JPRB, 0.38124879E-03_JPRB, 0.38127913E-03_JPRB, 0.38127014E-03_JPRB, &
  & 0.38127454E-03_JPRB, 0.38123239E-03_JPRB, 0.38129917E-03_JPRB, 0.38161694E-03_JPRB, 0.38207953E-03_JPRB, 0.38264381E-03_JPRB, &
  & 0.38309006E-03_JPRB, 0.38356623E-03_JPRB, 0.38398706E-03_JPRB, 0.38442002E-03_JPRB, 0.38492385E-03_JPRB, 0.38533419E-03_JPRB, &
  & 0.38577143E-03_JPRB, 0.38631714E-03_JPRB, 0.38697818E-03_JPRB, 0.38777530E-03_JPRB, 0.38851092E-03_JPRB, 0.38883063E-03_JPRB, &
  & 0.38878032E-03_JPRB, 0.38844787E-03_JPRB, 0.38799605E-03_JPRB, 0.38772130E-03_JPRB, 0.38752206E-03_JPRB, 0.38738376E-03_JPRB, &
  & 0.38741380E-03_JPRB, 0.38744924E-03_JPRB, 0.38750917E-03_JPRB, 0.38750702E-03_JPRB, 0.38759342E-03_JPRB, 0.38769482E-03_JPRB, &
  & 0.38773565E-03_JPRB, 0.38763872E-03_JPRB, 0.38754736E-03_JPRB, 0.38759652E-03_JPRB, 0.38752432E-03_JPRB, 0.38750423E-03_JPRB, &
  & 0.38752794E-03_JPRB, 0.38731241E-03_JPRB, 0.38700390E-03_JPRB, 0.38665101E-03_JPRB, 0.38620898E-03_JPRB, 0.38592619E-03_JPRB, &
  & 0.38595517E-03_JPRB, 0.38604816E-03_JPRB, 0.38593230E-03_JPRB, 0.38554362E-03_JPRB  /)

RGHG1(:,58, 5) = (/ &
  & 0.38158116E-03_JPRB, 0.38163464E-03_JPRB, 0.38181282E-03_JPRB, 0.38187587E-03_JPRB, 0.38195967E-03_JPRB, 0.38192306E-03_JPRB, &
  & 0.38179464E-03_JPRB, 0.38176117E-03_JPRB, 0.38151327E-03_JPRB, 0.38134974E-03_JPRB, 0.38126405E-03_JPRB, 0.38121005E-03_JPRB, &
  & 0.38116519E-03_JPRB, 0.38122091E-03_JPRB, 0.38123125E-03_JPRB, 0.38118545E-03_JPRB, 0.38119622E-03_JPRB, 0.38118657E-03_JPRB, &
  & 0.38118766E-03_JPRB, 0.38113227E-03_JPRB, 0.38117702E-03_JPRB, 0.38147248E-03_JPRB, 0.38188412E-03_JPRB, 0.38246645E-03_JPRB, &
  & 0.38291743E-03_JPRB, 0.38337526E-03_JPRB, 0.38381604E-03_JPRB, 0.38424342E-03_JPRB, 0.38476710E-03_JPRB, 0.38516959E-03_JPRB, &
  & 0.38556807E-03_JPRB, 0.38612220E-03_JPRB, 0.38684432E-03_JPRB, 0.38769220E-03_JPRB, 0.38842527E-03_JPRB, 0.38873732E-03_JPRB, &
  & 0.38868607E-03_JPRB, 0.38838718E-03_JPRB, 0.38797166E-03_JPRB, 0.38768197E-03_JPRB, 0.38748651E-03_JPRB, 0.38737270E-03_JPRB, &
  & 0.38739480E-03_JPRB, 0.38742797E-03_JPRB, 0.38750596E-03_JPRB, 0.38752177E-03_JPRB, 0.38763294E-03_JPRB, 0.38778104E-03_JPRB, &
  & 0.38787283E-03_JPRB, 0.38784756E-03_JPRB, 0.38781321E-03_JPRB, 0.38791786E-03_JPRB, 0.38790229E-03_JPRB, 0.38793051E-03_JPRB, &
  & 0.38798571E-03_JPRB, 0.38780941E-03_JPRB, 0.38750978E-03_JPRB, 0.38719311E-03_JPRB, 0.38682690E-03_JPRB, 0.38659573E-03_JPRB, &
  & 0.38667311E-03_JPRB, 0.38684003E-03_JPRB, 0.38675046E-03_JPRB, 0.38636735E-03_JPRB  /)

RGHG1(:,59, 5) = (/ &
  & 0.38160353E-03_JPRB, 0.38171283E-03_JPRB, 0.38190614E-03_JPRB, 0.38199410E-03_JPRB, 0.38210585E-03_JPRB, 0.38207003E-03_JPRB, &
  & 0.38193153E-03_JPRB, 0.38188590E-03_JPRB, 0.38165439E-03_JPRB, 0.38147117E-03_JPRB, 0.38136233E-03_JPRB, 0.38127608E-03_JPRB, &
  & 0.38120672E-03_JPRB, 0.38122751E-03_JPRB, 0.38120902E-03_JPRB, 0.38113982E-03_JPRB, 0.38113032E-03_JPRB, 0.38112462E-03_JPRB, &
  & 0.38111686E-03_JPRB, 0.38104982E-03_JPRB, 0.38106887E-03_JPRB, 0.38133570E-03_JPRB, 0.38171823E-03_JPRB, 0.38230080E-03_JPRB, &
  & 0.38277668E-03_JPRB, 0.38322135E-03_JPRB, 0.38363905E-03_JPRB, 0.38405836E-03_JPRB, 0.38458477E-03_JPRB, 0.38499340E-03_JPRB, &
  & 0.38537160E-03_JPRB, 0.38595576E-03_JPRB, 0.38674285E-03_JPRB, 0.38760256E-03_JPRB, 0.38835527E-03_JPRB, 0.38865032E-03_JPRB, &
  & 0.38860046E-03_JPRB, 0.38832670E-03_JPRB, 0.38793572E-03_JPRB, 0.38764674E-03_JPRB, 0.38745518E-03_JPRB, 0.38735914E-03_JPRB, &
  & 0.38737121E-03_JPRB, 0.38740297E-03_JPRB, 0.38749837E-03_JPRB, 0.38752270E-03_JPRB, 0.38765523E-03_JPRB, 0.38784802E-03_JPRB, &
  & 0.38797926E-03_JPRB, 0.38802295E-03_JPRB, 0.38803646E-03_JPRB, 0.38817680E-03_JPRB, 0.38822573E-03_JPRB, 0.38829528E-03_JPRB, &
  & 0.38837893E-03_JPRB, 0.38823469E-03_JPRB, 0.38796785E-03_JPRB, 0.38767730E-03_JPRB, 0.38736906E-03_JPRB, 0.38717758E-03_JPRB, &
  & 0.38733990E-03_JPRB, 0.38758505E-03_JPRB, 0.38750604E-03_JPRB, 0.38714414E-03_JPRB  /)

RGHG1(:,60, 5) = (/ &
  & 0.38171675E-03_JPRB, 0.38184073E-03_JPRB, 0.38203213E-03_JPRB, 0.38215349E-03_JPRB, 0.38228820E-03_JPRB, 0.38225185E-03_JPRB, &
  & 0.38210883E-03_JPRB, 0.38204340E-03_JPRB, 0.38182027E-03_JPRB, 0.38161148E-03_JPRB, 0.38147784E-03_JPRB, 0.38136072E-03_JPRB, &
  & 0.38126258E-03_JPRB, 0.38124391E-03_JPRB, 0.38119331E-03_JPRB, 0.38110209E-03_JPRB, 0.38107028E-03_JPRB, 0.38106797E-03_JPRB, &
  & 0.38104953E-03_JPRB, 0.38097428E-03_JPRB, 0.38096584E-03_JPRB, 0.38119894E-03_JPRB, 0.38156210E-03_JPRB, 0.38213248E-03_JPRB, &
  & 0.38263636E-03_JPRB, 0.38307083E-03_JPRB, 0.38345389E-03_JPRB, 0.38386650E-03_JPRB, 0.38439066E-03_JPRB, 0.38481060E-03_JPRB, &
  & 0.38517574E-03_JPRB, 0.38579484E-03_JPRB, 0.38664978E-03_JPRB, 0.38750954E-03_JPRB, 0.38829019E-03_JPRB, 0.38856665E-03_JPRB, &
  & 0.38851401E-03_JPRB, 0.38826007E-03_JPRB, 0.38789128E-03_JPRB, 0.38761000E-03_JPRB, 0.38742629E-03_JPRB, 0.38734562E-03_JPRB, &
  & 0.38734674E-03_JPRB, 0.38737801E-03_JPRB, 0.38748814E-03_JPRB, 0.38751897E-03_JPRB, 0.38767437E-03_JPRB, 0.38791061E-03_JPRB, &
  & 0.38807949E-03_JPRB, 0.38819092E-03_JPRB, 0.38824977E-03_JPRB, 0.38841911E-03_JPRB, 0.38853816E-03_JPRB, 0.38864778E-03_JPRB, &
  & 0.38875696E-03_JPRB, 0.38864647E-03_JPRB, 0.38842727E-03_JPRB, 0.38816284E-03_JPRB, 0.38790464E-03_JPRB, 0.38775252E-03_JPRB, &
  & 0.38801144E-03_JPRB, 0.38832928E-03_JPRB, 0.38825876E-03_JPRB, 0.38793292E-03_JPRB  /)

RGHG1(:,61, 5) = (/ &
  & 0.38192812E-03_JPRB, 0.38201079E-03_JPRB, 0.38218887E-03_JPRB, 0.38234579E-03_JPRB, 0.38248901E-03_JPRB, 0.38244415E-03_JPRB, &
  & 0.38230677E-03_JPRB, 0.38222166E-03_JPRB, 0.38200048E-03_JPRB, 0.38176012E-03_JPRB, 0.38159983E-03_JPRB, 0.38146117E-03_JPRB, &
  & 0.38133013E-03_JPRB, 0.38127004E-03_JPRB, 0.38118983E-03_JPRB, 0.38108015E-03_JPRB, 0.38102220E-03_JPRB, 0.38101456E-03_JPRB, &
  & 0.38098680E-03_JPRB, 0.38091667E-03_JPRB, 0.38088250E-03_JPRB, 0.38107450E-03_JPRB, 0.38143345E-03_JPRB, 0.38196540E-03_JPRB, &
  & 0.38247984E-03_JPRB, 0.38291123E-03_JPRB, 0.38327266E-03_JPRB, 0.38368845E-03_JPRB, 0.38421209E-03_JPRB, 0.38464495E-03_JPRB, &
  & 0.38500506E-03_JPRB, 0.38564610E-03_JPRB, 0.38656480E-03_JPRB, 0.38742599E-03_JPRB, 0.38823576E-03_JPRB, 0.38850207E-03_JPRB, &
  & 0.38842709E-03_JPRB, 0.38817879E-03_JPRB, 0.38783398E-03_JPRB, 0.38756776E-03_JPRB, 0.38740661E-03_JPRB, 0.38733763E-03_JPRB, &
  & 0.38732839E-03_JPRB, 0.38736202E-03_JPRB, 0.38747430E-03_JPRB, 0.38751436E-03_JPRB, 0.38769949E-03_JPRB, 0.38796965E-03_JPRB, &
  & 0.38817728E-03_JPRB, 0.38834406E-03_JPRB, 0.38844228E-03_JPRB, 0.38863376E-03_JPRB, 0.38882456E-03_JPRB, 0.38897160E-03_JPRB, &
  & 0.38909411E-03_JPRB, 0.38902800E-03_JPRB, 0.38887912E-03_JPRB, 0.38864944E-03_JPRB, 0.38842343E-03_JPRB, 0.38831815E-03_JPRB, &
  & 0.38865939E-03_JPRB, 0.38901013E-03_JPRB, 0.38895827E-03_JPRB, 0.38870346E-03_JPRB  /)

RGHG1(:,62, 5) = (/ &
  & 0.38217848E-03_JPRB, 0.38219394E-03_JPRB, 0.38235728E-03_JPRB, 0.38254514E-03_JPRB, 0.38268848E-03_JPRB, 0.38263173E-03_JPRB, &
  & 0.38249926E-03_JPRB, 0.38239908E-03_JPRB, 0.38218324E-03_JPRB, 0.38191190E-03_JPRB, 0.38172820E-03_JPRB, 0.38156779E-03_JPRB, &
  & 0.38140507E-03_JPRB, 0.38130157E-03_JPRB, 0.38119442E-03_JPRB, 0.38107269E-03_JPRB, 0.38098185E-03_JPRB, 0.38096871E-03_JPRB, &
  & 0.38093049E-03_JPRB, 0.38087323E-03_JPRB, 0.38082633E-03_JPRB, 0.38097060E-03_JPRB, 0.38131383E-03_JPRB, 0.38180087E-03_JPRB, &
  & 0.38230420E-03_JPRB, 0.38274548E-03_JPRB, 0.38311707E-03_JPRB, 0.38354463E-03_JPRB, 0.38407442E-03_JPRB, 0.38452061E-03_JPRB, &
  & 0.38489952E-03_JPRB, 0.38555636E-03_JPRB, 0.38649806E-03_JPRB, 0.38736695E-03_JPRB, 0.38818741E-03_JPRB, 0.38845949E-03_JPRB, &
  & 0.38835408E-03_JPRB, 0.38810082E-03_JPRB, 0.38778472E-03_JPRB, 0.38754156E-03_JPRB, 0.38740254E-03_JPRB, 0.38733765E-03_JPRB, &
  & 0.38732509E-03_JPRB, 0.38735766E-03_JPRB, 0.38746374E-03_JPRB, 0.38752652E-03_JPRB, 0.38774255E-03_JPRB, 0.38804021E-03_JPRB, &
  & 0.38829132E-03_JPRB, 0.38850611E-03_JPRB, 0.38864396E-03_JPRB, 0.38885821E-03_JPRB, 0.38910591E-03_JPRB, 0.38928716E-03_JPRB, &
  & 0.38943115E-03_JPRB, 0.38941571E-03_JPRB, 0.38933756E-03_JPRB, 0.38915809E-03_JPRB, 0.38896180E-03_JPRB, 0.38893248E-03_JPRB, &
  & 0.38932238E-03_JPRB, 0.38969690E-03_JPRB, 0.38964510E-03_JPRB, 0.38945987E-03_JPRB  /)

RGHG1(:,63, 5) = (/ &
  & 0.38244759E-03_JPRB, 0.38238794E-03_JPRB, 0.38253613E-03_JPRB, 0.38274894E-03_JPRB, 0.38288528E-03_JPRB, 0.38281638E-03_JPRB, &
  & 0.38268901E-03_JPRB, 0.38257614E-03_JPRB, 0.38236553E-03_JPRB, 0.38206674E-03_JPRB, 0.38186247E-03_JPRB, 0.38167973E-03_JPRB, &
  & 0.38148571E-03_JPRB, 0.38133904E-03_JPRB, 0.38120479E-03_JPRB, 0.38107525E-03_JPRB, 0.38094999E-03_JPRB, 0.38093043E-03_JPRB, &
  & 0.38088259E-03_JPRB, 0.38084064E-03_JPRB, 0.38078973E-03_JPRB, 0.38088206E-03_JPRB, 0.38120014E-03_JPRB, 0.38163756E-03_JPRB, &
  & 0.38211756E-03_JPRB, 0.38257501E-03_JPRB, 0.38297673E-03_JPRB, 0.38342570E-03_JPRB, 0.38396373E-03_JPRB, 0.38442401E-03_JPRB, &
  & 0.38483870E-03_JPRB, 0.38551188E-03_JPRB, 0.38644468E-03_JPRB, 0.38732340E-03_JPRB, 0.38814305E-03_JPRB, 0.38842649E-03_JPRB, &
  & 0.38829332E-03_JPRB, 0.38803226E-03_JPRB, 0.38774473E-03_JPRB, 0.38753017E-03_JPRB, 0.38740953E-03_JPRB, 0.38734745E-03_JPRB, &
  & 0.38733568E-03_JPRB, 0.38736326E-03_JPRB, 0.38746222E-03_JPRB, 0.38755661E-03_JPRB, 0.38780173E-03_JPRB, 0.38812441E-03_JPRB, &
  & 0.38842404E-03_JPRB, 0.38868248E-03_JPRB, 0.38886015E-03_JPRB, 0.38909736E-03_JPRB, 0.38939053E-03_JPRB, 0.38960272E-03_JPRB, &
  & 0.38977690E-03_JPRB, 0.38981287E-03_JPRB, 0.38980311E-03_JPRB, 0.38968658E-03_JPRB, 0.38952296E-03_JPRB, 0.38957956E-03_JPRB, &
  & 0.38999786E-03_JPRB, 0.39039045E-03_JPRB, 0.39032945E-03_JPRB, 0.39020447E-03_JPRB  /)

RGHG1(:,64, 5) = (/ &
  & 0.38271285E-03_JPRB, 0.38258795E-03_JPRB, 0.38272202E-03_JPRB, 0.38294861E-03_JPRB, 0.38306903E-03_JPRB, 0.38299127E-03_JPRB, &
  & 0.38287007E-03_JPRB, 0.38274621E-03_JPRB, 0.38253684E-03_JPRB, 0.38221988E-03_JPRB, 0.38199959E-03_JPRB, 0.38179420E-03_JPRB, &
  & 0.38156979E-03_JPRB, 0.38138434E-03_JPRB, 0.38122082E-03_JPRB, 0.38108780E-03_JPRB, 0.38093261E-03_JPRB, 0.38090475E-03_JPRB, &
  & 0.38085098E-03_JPRB, 0.38082181E-03_JPRB, 0.38077549E-03_JPRB, 0.38081424E-03_JPRB, 0.38109644E-03_JPRB, 0.38148105E-03_JPRB, &
  & 0.38193045E-03_JPRB, 0.38240584E-03_JPRB, 0.38285363E-03_JPRB, 0.38333837E-03_JPRB, 0.38388267E-03_JPRB, 0.38435798E-03_JPRB, &
  & 0.38482491E-03_JPRB, 0.38552141E-03_JPRB, 0.38640802E-03_JPRB, 0.38729504E-03_JPRB, 0.38810415E-03_JPRB, 0.38839611E-03_JPRB, &
  & 0.38825116E-03_JPRB, 0.38798641E-03_JPRB, 0.38772118E-03_JPRB, 0.38753970E-03_JPRB, 0.38742780E-03_JPRB, 0.38737301E-03_JPRB, &
  & 0.38736506E-03_JPRB, 0.38738154E-03_JPRB, 0.38747994E-03_JPRB, 0.38761301E-03_JPRB, 0.38788032E-03_JPRB, 0.38822744E-03_JPRB, &
  & 0.38858145E-03_JPRB, 0.38887845E-03_JPRB, 0.38909457E-03_JPRB, 0.38935364E-03_JPRB, 0.38967731E-03_JPRB, 0.38991440E-03_JPRB, &
  & 0.39013084E-03_JPRB, 0.39021165E-03_JPRB, 0.39026132E-03_JPRB, 0.39022113E-03_JPRB, 0.39009877E-03_JPRB, 0.39023284E-03_JPRB, &
  & 0.39066247E-03_JPRB, 0.39106750E-03_JPRB, 0.39099372E-03_JPRB, 0.39090484E-03_JPRB  /)

RGHG1(:,65, 5) = (/ &
  & 0.38295258E-03_JPRB, 0.38278719E-03_JPRB, 0.38291537E-03_JPRB, 0.38313927E-03_JPRB, 0.38323425E-03_JPRB, 0.38315206E-03_JPRB, &
  & 0.38303634E-03_JPRB, 0.38290517E-03_JPRB, 0.38269631E-03_JPRB, 0.38237274E-03_JPRB, 0.38213597E-03_JPRB, 0.38191382E-03_JPRB, &
  & 0.38166224E-03_JPRB, 0.38144250E-03_JPRB, 0.38124918E-03_JPRB, 0.38110859E-03_JPRB, 0.38094046E-03_JPRB, 0.38089986E-03_JPRB, &
  & 0.38084333E-03_JPRB, 0.38082057E-03_JPRB, 0.38078295E-03_JPRB, 0.38078001E-03_JPRB, 0.38102585E-03_JPRB, 0.38135423E-03_JPRB, &
  & 0.38177686E-03_JPRB, 0.38223756E-03_JPRB, 0.38273564E-03_JPRB, 0.38325798E-03_JPRB, 0.38381759E-03_JPRB, 0.38432577E-03_JPRB, &
  & 0.38481967E-03_JPRB, 0.38552298E-03_JPRB, 0.38639852E-03_JPRB, 0.38726469E-03_JPRB, 0.38805733E-03_JPRB, 0.38836330E-03_JPRB, &
  & 0.38821078E-03_JPRB, 0.38796744E-03_JPRB, 0.38772042E-03_JPRB, 0.38756026E-03_JPRB, 0.38745947E-03_JPRB, 0.38742235E-03_JPRB, &
  & 0.38741991E-03_JPRB, 0.38743762E-03_JPRB, 0.38754182E-03_JPRB, 0.38770082E-03_JPRB, 0.38798195E-03_JPRB, 0.38835807E-03_JPRB, &
  & 0.38877845E-03_JPRB, 0.38910743E-03_JPRB, 0.38935448E-03_JPRB, 0.38964006E-03_JPRB, 0.38998549E-03_JPRB, 0.39024264E-03_JPRB, &
  & 0.39049781E-03_JPRB, 0.39061024E-03_JPRB, 0.39071310E-03_JPRB, 0.39075433E-03_JPRB, 0.39068043E-03_JPRB, 0.39087096E-03_JPRB, &
  & 0.39129958E-03_JPRB, 0.39169701E-03_JPRB, 0.39164395E-03_JPRB, 0.39156599E-03_JPRB  /)

RGHG1(:,66, 5) = (/ &
  & 0.38318077E-03_JPRB, 0.38298785E-03_JPRB, 0.38310708E-03_JPRB, 0.38332081E-03_JPRB, 0.38338920E-03_JPRB, 0.38330262E-03_JPRB, &
  & 0.38319201E-03_JPRB, 0.38305426E-03_JPRB, 0.38285138E-03_JPRB, 0.38252681E-03_JPRB, 0.38227410E-03_JPRB, 0.38203913E-03_JPRB, &
  & 0.38176291E-03_JPRB, 0.38151194E-03_JPRB, 0.38129022E-03_JPRB, 0.38113964E-03_JPRB, 0.38096454E-03_JPRB, 0.38091183E-03_JPRB, &
  & 0.38085213E-03_JPRB, 0.38083072E-03_JPRB, 0.38080333E-03_JPRB, 0.38077136E-03_JPRB, 0.38097623E-03_JPRB, 0.38125257E-03_JPRB, &
  & 0.38165207E-03_JPRB, 0.38208315E-03_JPRB, 0.38262508E-03_JPRB, 0.38318530E-03_JPRB, 0.38376920E-03_JPRB, 0.38429972E-03_JPRB, &
  & 0.38480345E-03_JPRB, 0.38551647E-03_JPRB, 0.38639283E-03_JPRB, 0.38723591E-03_JPRB, 0.38800887E-03_JPRB, 0.38833122E-03_JPRB, &
  & 0.38817596E-03_JPRB, 0.38795475E-03_JPRB, 0.38773635E-03_JPRB, 0.38758815E-03_JPRB, 0.38750513E-03_JPRB, 0.38748890E-03_JPRB, &
  & 0.38749153E-03_JPRB, 0.38752061E-03_JPRB, 0.38763346E-03_JPRB, 0.38780952E-03_JPRB, 0.38810328E-03_JPRB, 0.38851354E-03_JPRB, &
  & 0.38899972E-03_JPRB, 0.38936358E-03_JPRB, 0.38963791E-03_JPRB, 0.38995117E-03_JPRB, 0.39031514E-03_JPRB, 0.39059421E-03_JPRB, &
  & 0.39087716E-03_JPRB, 0.39101475E-03_JPRB, 0.39116904E-03_JPRB, 0.39128600E-03_JPRB, 0.39126446E-03_JPRB, 0.39150638E-03_JPRB, &
  & 0.39192032E-03_JPRB, 0.39230362E-03_JPRB, 0.39228307E-03_JPRB, 0.39221431E-03_JPRB  /)

RGHG1(:,67, 5) = (/ &
  & 0.38339432E-03_JPRB, 0.38318661E-03_JPRB, 0.38329114E-03_JPRB, 0.38348834E-03_JPRB, 0.38353156E-03_JPRB, 0.38343876E-03_JPRB, &
  & 0.38333404E-03_JPRB, 0.38319090E-03_JPRB, 0.38299972E-03_JPRB, 0.38267918E-03_JPRB, 0.38241264E-03_JPRB, 0.38216797E-03_JPRB, &
  & 0.38187099E-03_JPRB, 0.38159210E-03_JPRB, 0.38134579E-03_JPRB, 0.38118252E-03_JPRB, 0.38100370E-03_JPRB, 0.38094108E-03_JPRB, &
  & 0.38087819E-03_JPRB, 0.38085354E-03_JPRB, 0.38083710E-03_JPRB, 0.38078758E-03_JPRB, 0.38094509E-03_JPRB, 0.38117754E-03_JPRB, &
  & 0.38155397E-03_JPRB, 0.38194995E-03_JPRB, 0.38252614E-03_JPRB, 0.38312593E-03_JPRB, 0.38373542E-03_JPRB, 0.38427375E-03_JPRB, &
  & 0.38477687E-03_JPRB, 0.38550395E-03_JPRB, 0.38638715E-03_JPRB, 0.38720969E-03_JPRB, 0.38796215E-03_JPRB, 0.38830297E-03_JPRB, &
  & 0.38815273E-03_JPRB, 0.38794833E-03_JPRB, 0.38776685E-03_JPRB, 0.38762672E-03_JPRB, 0.38756651E-03_JPRB, 0.38757181E-03_JPRB, &
  & 0.38758072E-03_JPRB, 0.38762800E-03_JPRB, 0.38775261E-03_JPRB, 0.38794062E-03_JPRB, 0.38824726E-03_JPRB, 0.38869314E-03_JPRB, &
  & 0.38924173E-03_JPRB, 0.38964298E-03_JPRB, 0.38994237E-03_JPRB, 0.39028374E-03_JPRB, 0.39066192E-03_JPRB, 0.39096499E-03_JPRB, &
  & 0.39126065E-03_JPRB, 0.39142015E-03_JPRB, 0.39162346E-03_JPRB, 0.39180700E-03_JPRB, 0.39183819E-03_JPRB, 0.39212490E-03_JPRB, &
  & 0.39251126E-03_JPRB, 0.39287742E-03_JPRB, 0.39289233E-03_JPRB, 0.39283391E-03_JPRB  /)

RGHG1(:,68, 5) = (/ &
  & 0.38358749E-03_JPRB, 0.38337863E-03_JPRB, 0.38345921E-03_JPRB, 0.38363431E-03_JPRB, 0.38365727E-03_JPRB, 0.38355319E-03_JPRB, &
  & 0.38345768E-03_JPRB, 0.38331177E-03_JPRB, 0.38313717E-03_JPRB, 0.38282538E-03_JPRB, 0.38255010E-03_JPRB, 0.38229714E-03_JPRB, &
  & 0.38198588E-03_JPRB, 0.38168259E-03_JPRB, 0.38141993E-03_JPRB, 0.38124031E-03_JPRB, 0.38105688E-03_JPRB, 0.38098874E-03_JPRB, &
  & 0.38092424E-03_JPRB, 0.38089268E-03_JPRB, 0.38088683E-03_JPRB, 0.38082764E-03_JPRB, 0.38092805E-03_JPRB, 0.38113080E-03_JPRB, &
  & 0.38147615E-03_JPRB, 0.38184841E-03_JPRB, 0.38244556E-03_JPRB, 0.38309048E-03_JPRB, 0.38371032E-03_JPRB, 0.38423968E-03_JPRB, &
  & 0.38474532E-03_JPRB, 0.38549014E-03_JPRB, 0.38637771E-03_JPRB, 0.38718690E-03_JPRB, 0.38792255E-03_JPRB, 0.38828409E-03_JPRB, &
  & 0.38815250E-03_JPRB, 0.38795178E-03_JPRB, 0.38780806E-03_JPRB, 0.38768405E-03_JPRB, 0.38764732E-03_JPRB, 0.38767082E-03_JPRB, &
  & 0.38769123E-03_JPRB, 0.38775670E-03_JPRB, 0.38789743E-03_JPRB, 0.38810018E-03_JPRB, 0.38842178E-03_JPRB, 0.38889713E-03_JPRB, &
  & 0.38950213E-03_JPRB, 0.38994090E-03_JPRB, 0.39026585E-03_JPRB, 0.39063531E-03_JPRB, 0.39102017E-03_JPRB, 0.39134879E-03_JPRB, &
  & 0.39163548E-03_JPRB, 0.39181985E-03_JPRB, 0.39206828E-03_JPRB, 0.39230524E-03_JPRB, 0.39238317E-03_JPRB, 0.39270257E-03_JPRB, &
  & 0.39305070E-03_JPRB, 0.39340168E-03_JPRB, 0.39344030E-03_JPRB, 0.39339500E-03_JPRB  /)

RGHG1(:,69, 5) = (/ &
  & 0.38375003E-03_JPRB, 0.38355049E-03_JPRB, 0.38361028E-03_JPRB, 0.38375281E-03_JPRB, 0.38376263E-03_JPRB, 0.38364580E-03_JPRB, &
  & 0.38356307E-03_JPRB, 0.38341964E-03_JPRB, 0.38326349E-03_JPRB, 0.38296150E-03_JPRB, 0.38268564E-03_JPRB, 0.38242334E-03_JPRB, &
  & 0.38210327E-03_JPRB, 0.38178646E-03_JPRB, 0.38151375E-03_JPRB, 0.38131423E-03_JPRB, 0.38112661E-03_JPRB, 0.38105379E-03_JPRB, &
  & 0.38099060E-03_JPRB, 0.38095487E-03_JPRB, 0.38095227E-03_JPRB, 0.38088844E-03_JPRB, 0.38092883E-03_JPRB, 0.38111529E-03_JPRB, &
  & 0.38141972E-03_JPRB, 0.38177959E-03_JPRB, 0.38238322E-03_JPRB, 0.38304685E-03_JPRB, 0.38367727E-03_JPRB, 0.38419723E-03_JPRB, &
  & 0.38470226E-03_JPRB, 0.38545998E-03_JPRB, 0.38634773E-03_JPRB, 0.38715279E-03_JPRB, 0.38788463E-03_JPRB, 0.38827799E-03_JPRB, &
  & 0.38817427E-03_JPRB, 0.38797682E-03_JPRB, 0.38785576E-03_JPRB, 0.38775206E-03_JPRB, 0.38773399E-03_JPRB, 0.38777881E-03_JPRB, &
  & 0.38781891E-03_JPRB, 0.38790005E-03_JPRB, 0.38806045E-03_JPRB, 0.38829092E-03_JPRB, 0.38863085E-03_JPRB, 0.38912833E-03_JPRB, &
  & 0.38977987E-03_JPRB, 0.39024737E-03_JPRB, 0.39060416E-03_JPRB, 0.39099709E-03_JPRB, 0.39138883E-03_JPRB, 0.39173630E-03_JPRB, &
  & 0.39199724E-03_JPRB, 0.39221674E-03_JPRB, 0.39249814E-03_JPRB, 0.39277090E-03_JPRB, 0.39288676E-03_JPRB, 0.39321580E-03_JPRB, &
  & 0.39353578E-03_JPRB, 0.39387868E-03_JPRB, 0.39392509E-03_JPRB, 0.39388139E-03_JPRB  /)

RGHG1(:,70, 5) = (/ &
  & 0.38388740E-03_JPRB, 0.38370091E-03_JPRB, 0.38374606E-03_JPRB, 0.38385411E-03_JPRB, 0.38385282E-03_JPRB, 0.38372735E-03_JPRB, &
  & 0.38365870E-03_JPRB, 0.38351947E-03_JPRB, 0.38338161E-03_JPRB, 0.38309194E-03_JPRB, 0.38282006E-03_JPRB, 0.38254871E-03_JPRB, &
  & 0.38222327E-03_JPRB, 0.38189910E-03_JPRB, 0.38161680E-03_JPRB, 0.38139938E-03_JPRB, 0.38121002E-03_JPRB, 0.38113138E-03_JPRB, &
  & 0.38106941E-03_JPRB, 0.38103417E-03_JPRB, 0.38102969E-03_JPRB, 0.38096265E-03_JPRB, 0.38095104E-03_JPRB, 0.38111769E-03_JPRB, &
  & 0.38137880E-03_JPRB, 0.38172696E-03_JPRB, 0.38231439E-03_JPRB, 0.38298160E-03_JPRB, 0.38362851E-03_JPRB, 0.38413674E-03_JPRB, &
  & 0.38463603E-03_JPRB, 0.38540300E-03_JPRB, 0.38628771E-03_JPRB, 0.38710225E-03_JPRB, 0.38784694E-03_JPRB, 0.38827355E-03_JPRB, &
  & 0.38819799E-03_JPRB, 0.38800631E-03_JPRB, 0.38790366E-03_JPRB, 0.38782005E-03_JPRB, 0.38782194E-03_JPRB, 0.38789433E-03_JPRB, &
  & 0.38795469E-03_JPRB, 0.38805383E-03_JPRB, 0.38823684E-03_JPRB, 0.38849851E-03_JPRB, 0.38886274E-03_JPRB, 0.38938288E-03_JPRB, &
  & 0.39006738E-03_JPRB, 0.39055275E-03_JPRB, 0.39094447E-03_JPRB, 0.39136501E-03_JPRB, 0.39176261E-03_JPRB, 0.39212201E-03_JPRB, &
  & 0.39235992E-03_JPRB, 0.39261630E-03_JPRB, 0.39292284E-03_JPRB, 0.39322038E-03_JPRB, 0.39336547E-03_JPRB, 0.39369587E-03_JPRB, &
  & 0.39400228E-03_JPRB, 0.39434797E-03_JPRB, 0.39440409E-03_JPRB, 0.39434653E-03_JPRB  /)

RGHG1(:,71, 5) = (/ &
  & 0.38399978E-03_JPRB, 0.38382869E-03_JPRB, 0.38386561E-03_JPRB, 0.38394127E-03_JPRB, 0.38392913E-03_JPRB, 0.38380028E-03_JPRB, &
  & 0.38374476E-03_JPRB, 0.38361189E-03_JPRB, 0.38349149E-03_JPRB, 0.38321752E-03_JPRB, 0.38295139E-03_JPRB, 0.38267256E-03_JPRB, &
  & 0.38234679E-03_JPRB, 0.38201939E-03_JPRB, 0.38172793E-03_JPRB, 0.38149622E-03_JPRB, 0.38130739E-03_JPRB, 0.38122101E-03_JPRB, &
  & 0.38115967E-03_JPRB, 0.38112905E-03_JPRB, 0.38111764E-03_JPRB, 0.38104743E-03_JPRB, 0.38099322E-03_JPRB, 0.38113200E-03_JPRB, &
  & 0.38135056E-03_JPRB, 0.38168726E-03_JPRB, 0.38223299E-03_JPRB, 0.38289240E-03_JPRB, 0.38355815E-03_JPRB, 0.38405085E-03_JPRB, &
  & 0.38454180E-03_JPRB, 0.38531278E-03_JPRB, 0.38619369E-03_JPRB, 0.38703306E-03_JPRB, 0.38780551E-03_JPRB, 0.38826690E-03_JPRB, &
  & 0.38821885E-03_JPRB, 0.38803448E-03_JPRB, 0.38794978E-03_JPRB, 0.38788560E-03_JPRB, 0.38791022E-03_JPRB, 0.38801664E-03_JPRB, &
  & 0.38809759E-03_JPRB, 0.38821813E-03_JPRB, 0.38842490E-03_JPRB, 0.38871885E-03_JPRB, 0.38911435E-03_JPRB, 0.38965801E-03_JPRB, &
  & 0.39036012E-03_JPRB, 0.39085442E-03_JPRB, 0.39128466E-03_JPRB, 0.39173588E-03_JPRB, 0.39213820E-03_JPRB, 0.39250418E-03_JPRB, &
  & 0.39272521E-03_JPRB, 0.39301681E-03_JPRB, 0.39334137E-03_JPRB, 0.39365400E-03_JPRB, 0.39382059E-03_JPRB, 0.39414956E-03_JPRB, &
  & 0.39445472E-03_JPRB, 0.39481224E-03_JPRB, 0.39487785E-03_JPRB, 0.39479364E-03_JPRB  /)

RGHG1(:,72, 5) = (/ &
  & 0.38408620E-03_JPRB, 0.38393171E-03_JPRB, 0.38396679E-03_JPRB, 0.38401801E-03_JPRB, 0.38399297E-03_JPRB, 0.38386711E-03_JPRB, &
  & 0.38381990E-03_JPRB, 0.38369716E-03_JPRB, 0.38359266E-03_JPRB, 0.38333921E-03_JPRB, 0.38307608E-03_JPRB, 0.38279355E-03_JPRB, &
  & 0.38247609E-03_JPRB, 0.38214684E-03_JPRB, 0.38184777E-03_JPRB, 0.38160731E-03_JPRB, 0.38142055E-03_JPRB, 0.38132334E-03_JPRB, &
  & 0.38126177E-03_JPRB, 0.38123852E-03_JPRB, 0.38121467E-03_JPRB, 0.38113938E-03_JPRB, 0.38105245E-03_JPRB, 0.38114974E-03_JPRB, &
  & 0.38133097E-03_JPRB, 0.38165776E-03_JPRB, 0.38213182E-03_JPRB, 0.38277670E-03_JPRB, 0.38345559E-03_JPRB, 0.38392640E-03_JPRB, &
  & 0.38441158E-03_JPRB, 0.38517795E-03_JPRB, 0.38605887E-03_JPRB, 0.38694134E-03_JPRB, 0.38775274E-03_JPRB, 0.38825285E-03_JPRB, &
  & 0.38823175E-03_JPRB, 0.38805384E-03_JPRB, 0.38799173E-03_JPRB, 0.38794644E-03_JPRB, 0.38799826E-03_JPRB, 0.38814525E-03_JPRB, &
  & 0.38824832E-03_JPRB, 0.38839490E-03_JPRB, 0.38862333E-03_JPRB, 0.38894817E-03_JPRB, 0.38938354E-03_JPRB, 0.38995071E-03_JPRB, &
  & 0.39065212E-03_JPRB, 0.39115034E-03_JPRB, 0.39162461E-03_JPRB, 0.39210579E-03_JPRB, 0.39251179E-03_JPRB, 0.39288191E-03_JPRB, &
  & 0.39309488E-03_JPRB, 0.39341529E-03_JPRB, 0.39375115E-03_JPRB, 0.39407023E-03_JPRB, 0.39425226E-03_JPRB, 0.39458446E-03_JPRB, &
  & 0.39489561E-03_JPRB, 0.39526995E-03_JPRB, 0.39533695E-03_JPRB, 0.39521886E-03_JPRB  /)

RGHG1(:,73, 5) = (/ &
  & 0.38414490E-03_JPRB, 0.38401052E-03_JPRB, 0.38405507E-03_JPRB, 0.38409007E-03_JPRB, 0.38405077E-03_JPRB, 0.38392856E-03_JPRB, &
  & 0.38388327E-03_JPRB, 0.38377565E-03_JPRB, 0.38368031E-03_JPRB, 0.38345026E-03_JPRB, 0.38319657E-03_JPRB, 0.38291675E-03_JPRB, &
  & 0.38261276E-03_JPRB, 0.38228765E-03_JPRB, 0.38198970E-03_JPRB, 0.38173936E-03_JPRB, 0.38155832E-03_JPRB, 0.38145535E-03_JPRB, &
  & 0.38139526E-03_JPRB, 0.38137344E-03_JPRB, 0.38133814E-03_JPRB, 0.38124941E-03_JPRB, 0.38112957E-03_JPRB, 0.38118321E-03_JPRB, &
  & 0.38133266E-03_JPRB, 0.38162958E-03_JPRB, 0.38202449E-03_JPRB, 0.38263210E-03_JPRB, 0.38330474E-03_JPRB, 0.38376379E-03_JPRB, &
  & 0.38424853E-03_JPRB, 0.38499828E-03_JPRB, 0.38588839E-03_JPRB, 0.38681485E-03_JPRB, 0.38766778E-03_JPRB, 0.38821860E-03_JPRB, &
  & 0.38823490E-03_JPRB, 0.38806283E-03_JPRB, 0.38802750E-03_JPRB, 0.38800144E-03_JPRB, 0.38809045E-03_JPRB, 0.38828401E-03_JPRB, &
  & 0.38841682E-03_JPRB, 0.38858767E-03_JPRB, 0.38883361E-03_JPRB, 0.38918802E-03_JPRB, 0.38966434E-03_JPRB, 0.39025280E-03_JPRB, &
  & 0.39094219E-03_JPRB, 0.39143001E-03_JPRB, 0.39194363E-03_JPRB, 0.39245260E-03_JPRB, 0.39287023E-03_JPRB, 0.39324987E-03_JPRB, &
  & 0.39346563E-03_JPRB, 0.39380496E-03_JPRB, 0.39414512E-03_JPRB, 0.39445679E-03_JPRB, 0.39465563E-03_JPRB, 0.39500113E-03_JPRB, &
  & 0.39531830E-03_JPRB, 0.39570187E-03_JPRB, 0.39575871E-03_JPRB, 0.39561424E-03_JPRB  /)

RGHG1(:,74, 5) = (/ &
  & 0.38418679E-03_JPRB, 0.38407878E-03_JPRB, 0.38413724E-03_JPRB, 0.38415894E-03_JPRB, 0.38410611E-03_JPRB, 0.38398553E-03_JPRB, &
  & 0.38394051E-03_JPRB, 0.38384842E-03_JPRB, 0.38375997E-03_JPRB, 0.38355161E-03_JPRB, 0.38331121E-03_JPRB, 0.38304104E-03_JPRB, &
  & 0.38275360E-03_JPRB, 0.38243994E-03_JPRB, 0.38214746E-03_JPRB, 0.38189147E-03_JPRB, 0.38171841E-03_JPRB, 0.38161039E-03_JPRB, &
  & 0.38155122E-03_JPRB, 0.38152532E-03_JPRB, 0.38147463E-03_JPRB, 0.38137010E-03_JPRB, 0.38122821E-03_JPRB, 0.38123793E-03_JPRB, &
  & 0.38135847E-03_JPRB, 0.38160830E-03_JPRB, 0.38192324E-03_JPRB, 0.38247889E-03_JPRB, 0.38312904E-03_JPRB, 0.38358152E-03_JPRB, &
  & 0.38405498E-03_JPRB, 0.38479033E-03_JPRB, 0.38570460E-03_JPRB, 0.38666672E-03_JPRB, 0.38756260E-03_JPRB, 0.38817831E-03_JPRB, &
  & 0.38824243E-03_JPRB, 0.38808563E-03_JPRB, 0.38807698E-03_JPRB, 0.38808309E-03_JPRB, 0.38821301E-03_JPRB, 0.38844581E-03_JPRB, &
  & 0.38860340E-03_JPRB, 0.38879209E-03_JPRB, 0.38904821E-03_JPRB, 0.38942995E-03_JPRB, 0.38994464E-03_JPRB, 0.39054583E-03_JPRB, &
  & 0.39121946E-03_JPRB, 0.39168568E-03_JPRB, 0.39223669E-03_JPRB, 0.39277141E-03_JPRB, 0.39321009E-03_JPRB, 0.39360359E-03_JPRB, &
  & 0.39383224E-03_JPRB, 0.39418519E-03_JPRB, 0.39452349E-03_JPRB, 0.39482088E-03_JPRB, 0.39503900E-03_JPRB, 0.39539320E-03_JPRB, &
  & 0.39571097E-03_JPRB, 0.39609991E-03_JPRB, 0.39613992E-03_JPRB, 0.39596153E-03_JPRB  /)

RGHG1(:,75, 5) = (/ &
  & 0.38421714E-03_JPRB, 0.38414080E-03_JPRB, 0.38421314E-03_JPRB, 0.38422312E-03_JPRB, 0.38415862E-03_JPRB, 0.38403751E-03_JPRB, &
  & 0.38399190E-03_JPRB, 0.38391395E-03_JPRB, 0.38383032E-03_JPRB, 0.38364178E-03_JPRB, 0.38341750E-03_JPRB, 0.38316317E-03_JPRB, &
  & 0.38289532E-03_JPRB, 0.38259787E-03_JPRB, 0.38231649E-03_JPRB, 0.38206099E-03_JPRB, 0.38189602E-03_JPRB, 0.38178334E-03_JPRB, &
  & 0.38172489E-03_JPRB, 0.38169013E-03_JPRB, 0.38162154E-03_JPRB, 0.38150225E-03_JPRB, 0.38134513E-03_JPRB, 0.38130941E-03_JPRB, &
  & 0.38139829E-03_JPRB, 0.38159375E-03_JPRB, 0.38183359E-03_JPRB, 0.38232588E-03_JPRB, 0.38293919E-03_JPRB, 0.38338146E-03_JPRB, &
  & 0.38383544E-03_JPRB, 0.38456205E-03_JPRB, 0.38551353E-03_JPRB, 0.38650486E-03_JPRB, 0.38744396E-03_JPRB, 0.38813544E-03_JPRB, &
  & 0.38825727E-03_JPRB, 0.38812769E-03_JPRB, 0.38814711E-03_JPRB, 0.38819548E-03_JPRB, 0.38836636E-03_JPRB, 0.38862993E-03_JPRB, &
  & 0.38880657E-03_JPRB, 0.38900589E-03_JPRB, 0.38926730E-03_JPRB, 0.38967294E-03_JPRB, 0.39022069E-03_JPRB, 0.39082401E-03_JPRB, &
  & 0.39147841E-03_JPRB, 0.39191217E-03_JPRB, 0.39250035E-03_JPRB, 0.39306263E-03_JPRB, 0.39352766E-03_JPRB, 0.39394095E-03_JPRB, &
  & 0.39418867E-03_JPRB, 0.39455416E-03_JPRB, 0.39488564E-03_JPRB, 0.39516322E-03_JPRB, 0.39540252E-03_JPRB, 0.39575798E-03_JPRB, &
  & 0.39607109E-03_JPRB, 0.39646179E-03_JPRB, 0.39648200E-03_JPRB, 0.39626344E-03_JPRB  /)

RGHG1(:,76, 5) = (/ &
  & 0.38424249E-03_JPRB, 0.38420143E-03_JPRB, 0.38428160E-03_JPRB, 0.38428006E-03_JPRB, 0.38420726E-03_JPRB, 0.38408361E-03_JPRB, &
  & 0.38403708E-03_JPRB, 0.38396973E-03_JPRB, 0.38388842E-03_JPRB, 0.38371831E-03_JPRB, 0.38351179E-03_JPRB, 0.38327843E-03_JPRB, &
  & 0.38303364E-03_JPRB, 0.38275301E-03_JPRB, 0.38249123E-03_JPRB, 0.38224472E-03_JPRB, 0.38208482E-03_JPRB, 0.38196799E-03_JPRB, &
  & 0.38191092E-03_JPRB, 0.38186348E-03_JPRB, 0.38177738E-03_JPRB, 0.38164886E-03_JPRB, 0.38147538E-03_JPRB, 0.38139033E-03_JPRB, &
  & 0.38143609E-03_JPRB, 0.38158499E-03_JPRB, 0.38176259E-03_JPRB, 0.38218364E-03_JPRB, 0.38274785E-03_JPRB, 0.38316292E-03_JPRB, &
  & 0.38359546E-03_JPRB, 0.38432254E-03_JPRB, 0.38532081E-03_JPRB, 0.38633911E-03_JPRB, 0.38732017E-03_JPRB, 0.38809325E-03_JPRB, &
  & 0.38828216E-03_JPRB, 0.38819478E-03_JPRB, 0.38824670E-03_JPRB, 0.38834140E-03_JPRB, 0.38854847E-03_JPRB, 0.38883441E-03_JPRB, &
  & 0.38902488E-03_JPRB, 0.38922696E-03_JPRB, 0.38949299E-03_JPRB, 0.38991730E-03_JPRB, 0.39048902E-03_JPRB, 0.39108127E-03_JPRB, &
  & 0.39171216E-03_JPRB, 0.39210235E-03_JPRB, 0.39272995E-03_JPRB, 0.39332773E-03_JPRB, 0.39381789E-03_JPRB, 0.39425976E-03_JPRB, &
  & 0.39452685E-03_JPRB, 0.39490986E-03_JPRB, 0.39523120E-03_JPRB, 0.39548434E-03_JPRB, 0.39574577E-03_JPRB, 0.39609247E-03_JPRB, &
  & 0.39639659E-03_JPRB, 0.39678522E-03_JPRB, 0.39678768E-03_JPRB, 0.39652669E-03_JPRB  /)

RGHG1(:,77, 5) = (/ &
  & 0.38427797E-03_JPRB, 0.38426359E-03_JPRB, 0.38433708E-03_JPRB, 0.38432451E-03_JPRB, 0.38424751E-03_JPRB, 0.38412372E-03_JPRB, &
  & 0.38407559E-03_JPRB, 0.38401412E-03_JPRB, 0.38393337E-03_JPRB, 0.38378441E-03_JPRB, 0.38359877E-03_JPRB, 0.38338270E-03_JPRB, &
  & 0.38316018E-03_JPRB, 0.38289728E-03_JPRB, 0.38265427E-03_JPRB, 0.38242464E-03_JPRB, 0.38226699E-03_JPRB, 0.38214307E-03_JPRB, &
  & 0.38207677E-03_JPRB, 0.38201137E-03_JPRB, 0.38191237E-03_JPRB, 0.38178271E-03_JPRB, 0.38159861E-03_JPRB, 0.38146641E-03_JPRB, &
  & 0.38146135E-03_JPRB, 0.38157300E-03_JPRB, 0.38171142E-03_JPRB, 0.38207420E-03_JPRB, 0.38258195E-03_JPRB, 0.38297520E-03_JPRB, &
  & 0.38341149E-03_JPRB, 0.38412019E-03_JPRB, 0.38514330E-03_JPRB, 0.38618675E-03_JPRB, 0.38721302E-03_JPRB, 0.38805179E-03_JPRB, &
  & 0.38831584E-03_JPRB, 0.38827612E-03_JPRB, 0.38836788E-03_JPRB, 0.38850603E-03_JPRB, 0.38875847E-03_JPRB, 0.38905865E-03_JPRB, &
  & 0.38926493E-03_JPRB, 0.38946050E-03_JPRB, 0.38972854E-03_JPRB, 0.39015161E-03_JPRB, 0.39072814E-03_JPRB, 0.39130185E-03_JPRB, &
  & 0.39190046E-03_JPRB, 0.39226753E-03_JPRB, 0.39292003E-03_JPRB, 0.39355138E-03_JPRB, 0.39407101E-03_JPRB, 0.39454010E-03_JPRB, &
  & 0.39482750E-03_JPRB, 0.39522872E-03_JPRB, 0.39554687E-03_JPRB, 0.39578742E-03_JPRB, 0.39605733E-03_JPRB, 0.39638250E-03_JPRB, &
  & 0.39667173E-03_JPRB, 0.39705959E-03_JPRB, 0.39705159E-03_JPRB, 0.39679127E-03_JPRB  /)

RGHG1(:,78, 5) = (/ &
  & 0.38431810E-03_JPRB, 0.38431884E-03_JPRB, 0.38438160E-03_JPRB, 0.38435957E-03_JPRB, 0.38428083E-03_JPRB, 0.38415838E-03_JPRB, &
  & 0.38410862E-03_JPRB, 0.38404977E-03_JPRB, 0.38397082E-03_JPRB, 0.38384085E-03_JPRB, 0.38367441E-03_JPRB, 0.38347670E-03_JPRB, &
  & 0.38327112E-03_JPRB, 0.38302461E-03_JPRB, 0.38279579E-03_JPRB, 0.38258133E-03_JPRB, 0.38241688E-03_JPRB, 0.38228232E-03_JPRB, &
  & 0.38220978E-03_JPRB, 0.38213050E-03_JPRB, 0.38202531E-03_JPRB, 0.38189450E-03_JPRB, 0.38170044E-03_JPRB, 0.38153414E-03_JPRB, &
  & 0.38148947E-03_JPRB, 0.38156407E-03_JPRB, 0.38167052E-03_JPRB, 0.38198990E-03_JPRB, 0.38246149E-03_JPRB, 0.38285437E-03_JPRB, &
  & 0.38328570E-03_JPRB, 0.38396644E-03_JPRB, 0.38499394E-03_JPRB, 0.38605803E-03_JPRB, 0.38712492E-03_JPRB, 0.38801372E-03_JPRB, &
  & 0.38834713E-03_JPRB, 0.38834659E-03_JPRB, 0.38847355E-03_JPRB, 0.38866018E-03_JPRB, 0.38895444E-03_JPRB, 0.38928174E-03_JPRB, &
  & 0.38950728E-03_JPRB, 0.38969854E-03_JPRB, 0.38995939E-03_JPRB, 0.39037404E-03_JPRB, 0.39094212E-03_JPRB, 0.39149784E-03_JPRB, &
  & 0.39206426E-03_JPRB, 0.39241268E-03_JPRB, 0.39308266E-03_JPRB, 0.39374630E-03_JPRB, 0.39429465E-03_JPRB, 0.39478826E-03_JPRB, &
  & 0.39509075E-03_JPRB, 0.39550956E-03_JPRB, 0.39583366E-03_JPRB, 0.39607139E-03_JPRB, 0.39633444E-03_JPRB, 0.39663197E-03_JPRB, &
  & 0.39690739E-03_JPRB, 0.39729113E-03_JPRB, 0.39727785E-03_JPRB, 0.39703897E-03_JPRB  /)

RGHG1(:,79, 5) = (/ &
  & 0.38435661E-03_JPRB, 0.38436365E-03_JPRB, 0.38441441E-03_JPRB, 0.38438549E-03_JPRB, 0.38430799E-03_JPRB, 0.38418725E-03_JPRB, &
  & 0.38413610E-03_JPRB, 0.38407751E-03_JPRB, 0.38400066E-03_JPRB, 0.38388610E-03_JPRB, 0.38373442E-03_JPRB, 0.38355298E-03_JPRB, &
  & 0.38336065E-03_JPRB, 0.38312701E-03_JPRB, 0.38290994E-03_JPRB, 0.38270939E-03_JPRB, 0.38253718E-03_JPRB, 0.38239224E-03_JPRB, &
  & 0.38231369E-03_JPRB, 0.38222437E-03_JPRB, 0.38211626E-03_JPRB, 0.38198295E-03_JPRB, 0.38178144E-03_JPRB, 0.38159381E-03_JPRB, &
  & 0.38152072E-03_JPRB, 0.38156110E-03_JPRB, 0.38164221E-03_JPRB, 0.38193196E-03_JPRB, 0.38238431E-03_JPRB, 0.38278893E-03_JPRB, &
  & 0.38320664E-03_JPRB, 0.38385919E-03_JPRB, 0.38487932E-03_JPRB, 0.38595727E-03_JPRB, 0.38705494E-03_JPRB, 0.38798185E-03_JPRB, &
  & 0.38837385E-03_JPRB, 0.38840813E-03_JPRB, 0.38857138E-03_JPRB, 0.38880526E-03_JPRB, 0.38913487E-03_JPRB, 0.38949480E-03_JPRB, &
  & 0.38974167E-03_JPRB, 0.38993309E-03_JPRB, 0.39018173E-03_JPRB, 0.39058219E-03_JPRB, 0.39113549E-03_JPRB, 0.39167093E-03_JPRB, &
  & 0.39220914E-03_JPRB, 0.39254448E-03_JPRB, 0.39322415E-03_JPRB, 0.39391526E-03_JPRB, 0.39449086E-03_JPRB, 0.39500557E-03_JPRB, &
  & 0.39532033E-03_JPRB, 0.39575623E-03_JPRB, 0.39609183E-03_JPRB, 0.39633379E-03_JPRB, 0.39657837E-03_JPRB, 0.39684263E-03_JPRB, &
  & 0.39710713E-03_JPRB, 0.39748204E-03_JPRB, 0.39747146E-03_JPRB, 0.39725969E-03_JPRB  /)

RGHG1(:,80, 5) = (/ &
  & 0.38438687E-03_JPRB, 0.38439485E-03_JPRB, 0.38443478E-03_JPRB, 0.38440261E-03_JPRB, 0.38432987E-03_JPRB, 0.38421005E-03_JPRB, &
  & 0.38415797E-03_JPRB, 0.38409825E-03_JPRB, 0.38402257E-03_JPRB, 0.38391863E-03_JPRB, 0.38377463E-03_JPRB, 0.38360360E-03_JPRB, &
  & 0.38342309E-03_JPRB, 0.38319660E-03_JPRB, 0.38299154E-03_JPRB, 0.38280478E-03_JPRB, 0.38263341E-03_JPRB, 0.38248263E-03_JPRB, &
  & 0.38239413E-03_JPRB, 0.38229766E-03_JPRB, 0.38218588E-03_JPRB, 0.38204770E-03_JPRB, 0.38184362E-03_JPRB, 0.38164604E-03_JPRB, &
  & 0.38155423E-03_JPRB, 0.38156670E-03_JPRB, 0.38162927E-03_JPRB, 0.38190143E-03_JPRB, 0.38234547E-03_JPRB, 0.38276223E-03_JPRB, &
  & 0.38316019E-03_JPRB, 0.38379426E-03_JPRB, 0.38480525E-03_JPRB, 0.38588801E-03_JPRB, 0.38700150E-03_JPRB, 0.38795893E-03_JPRB, &
  & 0.38839419E-03_JPRB, 0.38846469E-03_JPRB, 0.38867264E-03_JPRB, 0.38894502E-03_JPRB, 0.38930112E-03_JPRB, 0.38968937E-03_JPRB, &
  & 0.38995782E-03_JPRB, 0.39015557E-03_JPRB, 0.39039213E-03_JPRB, 0.39077358E-03_JPRB, 0.39131325E-03_JPRB, 0.39182241E-03_JPRB, &
  & 0.39234009E-03_JPRB, 0.39267021E-03_JPRB, 0.39335109E-03_JPRB, 0.39406087E-03_JPRB, 0.39466177E-03_JPRB, 0.39519349E-03_JPRB, &
  & 0.39552099E-03_JPRB, 0.39597367E-03_JPRB, 0.39632191E-03_JPRB, 0.39657232E-03_JPRB, 0.39679148E-03_JPRB, 0.39701704E-03_JPRB, &
  & 0.39727508E-03_JPRB, 0.39763531E-03_JPRB, 0.39763854E-03_JPRB, 0.39744338E-03_JPRB  /)

RGHG1(:,81, 5) = (/ &
  & 0.38440287E-03_JPRB, 0.38440967E-03_JPRB, 0.38444201E-03_JPRB, 0.38440960E-03_JPRB, 0.38434705E-03_JPRB, 0.38422795E-03_JPRB, &
  & 0.38417516E-03_JPRB, 0.38411330E-03_JPRB, 0.38403762E-03_JPRB, 0.38393890E-03_JPRB, 0.38379466E-03_JPRB, 0.38362813E-03_JPRB, &
  & 0.38345047E-03_JPRB, 0.38322919E-03_JPRB, 0.38303006E-03_JPRB, 0.38285610E-03_JPRB, 0.38269208E-03_JPRB, 0.38254414E-03_JPRB, &
  & 0.38245138E-03_JPRB, 0.38235088E-03_JPRB, 0.38223436E-03_JPRB, 0.38209546E-03_JPRB, 0.38189280E-03_JPRB, 0.38169096E-03_JPRB, &
  & 0.38158943E-03_JPRB, 0.38158436E-03_JPRB, 0.38164195E-03_JPRB, 0.38190818E-03_JPRB, 0.38234701E-03_JPRB, 0.38275997E-03_JPRB, &
  & 0.38313708E-03_JPRB, 0.38376190E-03_JPRB, 0.38475938E-03_JPRB, 0.38584807E-03_JPRB, 0.38696061E-03_JPRB, 0.38795052E-03_JPRB, &
  & 0.38842299E-03_JPRB, 0.38851649E-03_JPRB, 0.38875810E-03_JPRB, 0.38905726E-03_JPRB, 0.38943375E-03_JPRB, 0.38984452E-03_JPRB, &
  & 0.39013549E-03_JPRB, 0.39034911E-03_JPRB, 0.39058402E-03_JPRB, 0.39094247E-03_JPRB, 0.39147409E-03_JPRB, 0.39196546E-03_JPRB, &
  & 0.39246963E-03_JPRB, 0.39278956E-03_JPRB, 0.39346594E-03_JPRB, 0.39418900E-03_JPRB, 0.39481241E-03_JPRB, 0.39536073E-03_JPRB, &
  & 0.39569225E-03_JPRB, 0.39615988E-03_JPRB, 0.39652067E-03_JPRB, 0.39676468E-03_JPRB, 0.39695160E-03_JPRB, 0.39714777E-03_JPRB, &
  & 0.39740202E-03_JPRB, 0.39774495E-03_JPRB, 0.39776026E-03_JPRB, 0.39761441E-03_JPRB  /)

RGHG1(:,82, 5) = (/ &
  & 0.38441257E-03_JPRB, 0.38441671E-03_JPRB, 0.38444413E-03_JPRB, 0.38441198E-03_JPRB, 0.38436119E-03_JPRB, 0.38424312E-03_JPRB, &
  & 0.38418995E-03_JPRB, 0.38412565E-03_JPRB, 0.38404784E-03_JPRB, 0.38395267E-03_JPRB, 0.38380672E-03_JPRB, 0.38364255E-03_JPRB, &
  & 0.38346641E-03_JPRB, 0.38324933E-03_JPRB, 0.38305461E-03_JPRB, 0.38289011E-03_JPRB, 0.38273437E-03_JPRB, 0.38259106E-03_JPRB, &
  & 0.38249732E-03_JPRB, 0.38239461E-03_JPRB, 0.38227436E-03_JPRB, 0.38213803E-03_JPRB, 0.38194021E-03_JPRB, 0.38173624E-03_JPRB, &
  & 0.38162768E-03_JPRB, 0.38161318E-03_JPRB, 0.38167447E-03_JPRB, 0.38194282E-03_JPRB, 0.38238137E-03_JPRB, 0.38277750E-03_JPRB, &
  & 0.38312881E-03_JPRB, 0.38373824E-03_JPRB, 0.38471723E-03_JPRB, 0.38581394E-03_JPRB, 0.38692308E-03_JPRB, 0.38794950E-03_JPRB, &
  & 0.38845439E-03_JPRB, 0.38857073E-03_JPRB, 0.38884056E-03_JPRB, 0.38915409E-03_JPRB, 0.38953679E-03_JPRB, 0.38996112E-03_JPRB, &
  & 0.39027985E-03_JPRB, 0.39052118E-03_JPRB, 0.39076276E-03_JPRB, 0.39109706E-03_JPRB, 0.39161936E-03_JPRB, 0.39210647E-03_JPRB, &
  & 0.39259852E-03_JPRB, 0.39291028E-03_JPRB, 0.39358071E-03_JPRB, 0.39431206E-03_JPRB, 0.39495001E-03_JPRB, 0.39551171E-03_JPRB, &
  & 0.39584544E-03_JPRB, 0.39632398E-03_JPRB, 0.39669595E-03_JPRB, 0.39692021E-03_JPRB, 0.39707510E-03_JPRB, 0.39723978E-03_JPRB, &
  & 0.39749385E-03_JPRB, 0.39781844E-03_JPRB, 0.39784463E-03_JPRB, 0.39773453E-03_JPRB  /)

RGHG1(:,83, 5) = (/ &
  & 0.38441751E-03_JPRB, 0.38441848E-03_JPRB, 0.38444288E-03_JPRB, 0.38441083E-03_JPRB, 0.38437234E-03_JPRB, 0.38425607E-03_JPRB, &
  & 0.38420257E-03_JPRB, 0.38413615E-03_JPRB, 0.38405504E-03_JPRB, 0.38396141E-03_JPRB, 0.38381375E-03_JPRB, 0.38364990E-03_JPRB, &
  & 0.38347424E-03_JPRB, 0.38326053E-03_JPRB, 0.38306883E-03_JPRB, 0.38291227E-03_JPRB, 0.38276418E-03_JPRB, 0.38262614E-03_JPRB, &
  & 0.38253613E-03_JPRB, 0.38243365E-03_JPRB, 0.38231121E-03_JPRB, 0.38217822E-03_JPRB, 0.38198870E-03_JPRB, 0.38178718E-03_JPRB, &
  & 0.38167432E-03_JPRB, 0.38165696E-03_JPRB, 0.38173207E-03_JPRB, 0.38201127E-03_JPRB, 0.38244354E-03_JPRB, 0.38281598E-03_JPRB, &
  & 0.38313769E-03_JPRB, 0.38373040E-03_JPRB, 0.38468893E-03_JPRB, 0.38579361E-03_JPRB, 0.38690049E-03_JPRB, 0.38796045E-03_JPRB, &
  & 0.38848787E-03_JPRB, 0.38862071E-03_JPRB, 0.38891515E-03_JPRB, 0.38923601E-03_JPRB, 0.38961890E-03_JPRB, 0.39005144E-03_JPRB, &
  & 0.39039925E-03_JPRB, 0.39067971E-03_JPRB, 0.39093718E-03_JPRB, 0.39124750E-03_JPRB, 0.39175999E-03_JPRB, 0.39224891E-03_JPRB, &
  & 0.39273042E-03_JPRB, 0.39303584E-03_JPRB, 0.39369974E-03_JPRB, 0.39443743E-03_JPRB, 0.39508165E-03_JPRB, 0.39564920E-03_JPRB, &
  & 0.39598217E-03_JPRB, 0.39646656E-03_JPRB, 0.39684569E-03_JPRB, 0.39704141E-03_JPRB, 0.39716517E-03_JPRB, 0.39729934E-03_JPRB, &
  & 0.39755291E-03_JPRB, 0.39786470E-03_JPRB, 0.39790234E-03_JPRB, 0.39781684E-03_JPRB  /)

RGHG1(:,84, 5) = (/ &
  & 0.38441923E-03_JPRB, 0.38441724E-03_JPRB, 0.38443981E-03_JPRB, 0.38440732E-03_JPRB, 0.38438062E-03_JPRB, 0.38426727E-03_JPRB, &
  & 0.38421326E-03_JPRB, 0.38414548E-03_JPRB, 0.38406069E-03_JPRB, 0.38396655E-03_JPRB, 0.38381819E-03_JPRB, 0.38365295E-03_JPRB, &
  & 0.38347708E-03_JPRB, 0.38326607E-03_JPRB, 0.38307614E-03_JPRB, 0.38292742E-03_JPRB, 0.38278528E-03_JPRB, 0.38265222E-03_JPRB, &
  & 0.38257163E-03_JPRB, 0.38247225E-03_JPRB, 0.38234963E-03_JPRB, 0.38221913E-03_JPRB, 0.38204102E-03_JPRB, 0.38184790E-03_JPRB, &
  & 0.38173370E-03_JPRB, 0.38171850E-03_JPRB, 0.38181767E-03_JPRB, 0.38211559E-03_JPRB, 0.38252842E-03_JPRB, 0.38287586E-03_JPRB, &
  & 0.38316519E-03_JPRB, 0.38374280E-03_JPRB, 0.38468105E-03_JPRB, 0.38579291E-03_JPRB, 0.38690101E-03_JPRB, 0.38798726E-03_JPRB, &
  & 0.38852316E-03_JPRB, 0.38866194E-03_JPRB, 0.38897872E-03_JPRB, 0.38930474E-03_JPRB, 0.38968837E-03_JPRB, 0.39012721E-03_JPRB, &
  & 0.39050222E-03_JPRB, 0.39083163E-03_JPRB, 0.39111436E-03_JPRB, 0.39140224E-03_JPRB, 0.39190517E-03_JPRB, 0.39239599E-03_JPRB, &
  & 0.39286855E-03_JPRB, 0.39316987E-03_JPRB, 0.39382708E-03_JPRB, 0.39457081E-03_JPRB, 0.39521302E-03_JPRB, 0.39577584E-03_JPRB, &
  & 0.39610439E-03_JPRB, 0.39658896E-03_JPRB, 0.39696927E-03_JPRB, 0.39713189E-03_JPRB, 0.39722606E-03_JPRB, 0.39733327E-03_JPRB, &
  & 0.39758349E-03_JPRB, 0.39789185E-03_JPRB, 0.39794232E-03_JPRB, 0.39787280E-03_JPRB  /)

RGHG1(:,85, 5) = (/ &
  & 0.38441911E-03_JPRB, 0.38441449E-03_JPRB, 0.38443539E-03_JPRB, 0.38440266E-03_JPRB, 0.38438552E-03_JPRB, 0.38427766E-03_JPRB, &
  & 0.38422222E-03_JPRB, 0.38415349E-03_JPRB, 0.38406487E-03_JPRB, 0.38396954E-03_JPRB, 0.38382022E-03_JPRB, 0.38365355E-03_JPRB, &
  & 0.38347768E-03_JPRB, 0.38326834E-03_JPRB, 0.38307912E-03_JPRB, 0.38293877E-03_JPRB, 0.38280237E-03_JPRB, 0.38267313E-03_JPRB, &
  & 0.38261285E-03_JPRB, 0.38252207E-03_JPRB, 0.38240351E-03_JPRB, 0.38227875E-03_JPRB, 0.38211450E-03_JPRB, 0.38193523E-03_JPRB, &
  & 0.38182773E-03_JPRB, 0.38181970E-03_JPRB, 0.38195304E-03_JPRB, 0.38226793E-03_JPRB, 0.38265160E-03_JPRB, 0.38297826E-03_JPRB, &
  & 0.38322792E-03_JPRB, 0.38378043E-03_JPRB, 0.38469359E-03_JPRB, 0.38582457E-03_JPRB, 0.38693506E-03_JPRB, 0.38805285E-03_JPRB, &
  & 0.38856821E-03_JPRB, 0.38870149E-03_JPRB, 0.38903810E-03_JPRB, 0.38937440E-03_JPRB, 0.38976328E-03_JPRB, 0.39021359E-03_JPRB, &
  & 0.39061369E-03_JPRB, 0.39099997E-03_JPRB, 0.39132237E-03_JPRB, 0.39159257E-03_JPRB, 0.39208713E-03_JPRB, 0.39257723E-03_JPRB, &
  & 0.39304095E-03_JPRB, 0.39334944E-03_JPRB, 0.39399590E-03_JPRB, 0.39473605E-03_JPRB, 0.39536248E-03_JPRB, 0.39590404E-03_JPRB, &
  & 0.39622375E-03_JPRB, 0.39670043E-03_JPRB, 0.39707167E-03_JPRB, 0.39719701E-03_JPRB, 0.39726202E-03_JPRB, 0.39734820E-03_JPRB, &
  & 0.39759651E-03_JPRB, 0.39790177E-03_JPRB, 0.39796108E-03_JPRB, 0.39790231E-03_JPRB  /)

RGHG1(:,86, 5) = (/ &
  & 0.38441703E-03_JPRB, 0.38441088E-03_JPRB, 0.38443010E-03_JPRB, 0.38439788E-03_JPRB, 0.38438735E-03_JPRB, 0.38428690E-03_JPRB, &
  & 0.38422889E-03_JPRB, 0.38415957E-03_JPRB, 0.38406804E-03_JPRB, 0.38397151E-03_JPRB, 0.38382142E-03_JPRB, 0.38365369E-03_JPRB, &
  & 0.38347781E-03_JPRB, 0.38326903E-03_JPRB, 0.38307941E-03_JPRB, 0.38294971E-03_JPRB, 0.38281720E-03_JPRB, 0.38269087E-03_JPRB, &
  & 0.38266222E-03_JPRB, 0.38258795E-03_JPRB, 0.38248076E-03_JPRB, 0.38236233E-03_JPRB, 0.38220901E-03_JPRB, 0.38204536E-03_JPRB, &
  & 0.38195860E-03_JPRB, 0.38195703E-03_JPRB, 0.38213631E-03_JPRB, 0.38246825E-03_JPRB, 0.38283141E-03_JPRB, 0.38314727E-03_JPRB, &
  & 0.38335145E-03_JPRB, 0.38388586E-03_JPRB, 0.38479885E-03_JPRB, 0.38592268E-03_JPRB, 0.38704193E-03_JPRB, 0.38817422E-03_JPRB, &
  & 0.38863975E-03_JPRB, 0.38876489E-03_JPRB, 0.38911471E-03_JPRB, 0.38945740E-03_JPRB, 0.38986279E-03_JPRB, 0.39032986E-03_JPRB, &
  & 0.39074695E-03_JPRB, 0.39119264E-03_JPRB, 0.39155434E-03_JPRB, 0.39182341E-03_JPRB, 0.39231779E-03_JPRB, 0.39279726E-03_JPRB, &
  & 0.39325995E-03_JPRB, 0.39358611E-03_JPRB, 0.39421522E-03_JPRB, 0.39493831E-03_JPRB, 0.39553393E-03_JPRB, 0.39604644E-03_JPRB, &
  & 0.39634791E-03_JPRB, 0.39680938E-03_JPRB, 0.39716551E-03_JPRB, 0.39725357E-03_JPRB, 0.39728760E-03_JPRB, 0.39735601E-03_JPRB, &
  & 0.39760483E-03_JPRB, 0.39790678E-03_JPRB, 0.39796918E-03_JPRB, 0.39791785E-03_JPRB  /)

RGHG1(:,87, 5) = (/ &
  & 0.38441310E-03_JPRB, 0.38440636E-03_JPRB, 0.38442474E-03_JPRB, 0.38439325E-03_JPRB, 0.38438708E-03_JPRB, 0.38429430E-03_JPRB, &
  & 0.38423399E-03_JPRB, 0.38416394E-03_JPRB, 0.38407010E-03_JPRB, 0.38397272E-03_JPRB, 0.38382203E-03_JPRB, 0.38365331E-03_JPRB, &
  & 0.38347806E-03_JPRB, 0.38326915E-03_JPRB, 0.38307818E-03_JPRB, 0.38296093E-03_JPRB, 0.38283197E-03_JPRB, 0.38270795E-03_JPRB, &
  & 0.38271778E-03_JPRB, 0.38266863E-03_JPRB, 0.38257884E-03_JPRB, 0.38246824E-03_JPRB, 0.38232703E-03_JPRB, 0.38218619E-03_JPRB, &
  & 0.38213228E-03_JPRB, 0.38215485E-03_JPRB, 0.38238476E-03_JPRB, 0.38272679E-03_JPRB, 0.38308486E-03_JPRB, 0.38340761E-03_JPRB, &
  & 0.38355789E-03_JPRB, 0.38409998E-03_JPRB, 0.38503598E-03_JPRB, 0.38611716E-03_JPRB, 0.38724155E-03_JPRB, 0.38834089E-03_JPRB, &
  & 0.38873718E-03_JPRB, 0.38886363E-03_JPRB, 0.38922566E-03_JPRB, 0.38957172E-03_JPRB, 0.38999686E-03_JPRB, 0.39048721E-03_JPRB, &
  & 0.39091071E-03_JPRB, 0.39142622E-03_JPRB, 0.39183863E-03_JPRB, 0.39211037E-03_JPRB, 0.39261541E-03_JPRB, 0.39307935E-03_JPRB, &
  & 0.39355185E-03_JPRB, 0.39389887E-03_JPRB, 0.39449887E-03_JPRB, 0.39518231E-03_JPRB, 0.39573535E-03_JPRB, 0.39621379E-03_JPRB, &
  & 0.39648346E-03_JPRB, 0.39692562E-03_JPRB, 0.39725932E-03_JPRB, 0.39730634E-03_JPRB, 0.39730542E-03_JPRB, 0.39735900E-03_JPRB, &
  & 0.39761004E-03_JPRB, 0.39790770E-03_JPRB, 0.39797256E-03_JPRB, 0.39792533E-03_JPRB  /)

RGHG1(:,88, 5) = (/ &
  & 0.38440785E-03_JPRB, 0.38440125E-03_JPRB, 0.38441971E-03_JPRB, 0.38438898E-03_JPRB, 0.38438552E-03_JPRB, 0.38429988E-03_JPRB, &
  & 0.38423785E-03_JPRB, 0.38416685E-03_JPRB, 0.38407127E-03_JPRB, 0.38397338E-03_JPRB, 0.38382232E-03_JPRB, 0.38365258E-03_JPRB, &
  & 0.38347868E-03_JPRB, 0.38326926E-03_JPRB, 0.38307610E-03_JPRB, 0.38297379E-03_JPRB, 0.38284975E-03_JPRB, 0.38272955E-03_JPRB, &
  & 0.38278575E-03_JPRB, 0.38277118E-03_JPRB, 0.38270659E-03_JPRB, 0.38260655E-03_JPRB, 0.38248086E-03_JPRB, 0.38237624E-03_JPRB, &
  & 0.38236595E-03_JPRB, 0.38244700E-03_JPRB, 0.38273460E-03_JPRB, 0.38307370E-03_JPRB, 0.38345477E-03_JPRB, 0.38381659E-03_JPRB, &
  & 0.38392260E-03_JPRB, 0.38450004E-03_JPRB, 0.38545710E-03_JPRB, 0.38645727E-03_JPRB, 0.38756786E-03_JPRB, 0.38855706E-03_JPRB, &
  & 0.38887094E-03_JPRB, 0.38901621E-03_JPRB, 0.38939244E-03_JPRB, 0.38974165E-03_JPRB, 0.39019289E-03_JPRB, 0.39071001E-03_JPRB, &
  & 0.39113165E-03_JPRB, 0.39173630E-03_JPRB, 0.39222056E-03_JPRB, 0.39249828E-03_JPRB, 0.39303241E-03_JPRB, 0.39346880E-03_JPRB, &
  & 0.39397190E-03_JPRB, 0.39434056E-03_JPRB, 0.39489192E-03_JPRB, 0.39549200E-03_JPRB, 0.39598740E-03_JPRB, 0.39642667E-03_JPRB, &
  & 0.39665034E-03_JPRB, 0.39706611E-03_JPRB, 0.39736285E-03_JPRB, 0.39735966E-03_JPRB, 0.39731738E-03_JPRB, 0.39735856E-03_JPRB, &
  & 0.39761321E-03_JPRB, 0.39790580E-03_JPRB, 0.39797402E-03_JPRB, 0.39792828E-03_JPRB  /)

RGHG1(:,89, 5) = (/ &
  & 0.38440306E-03_JPRB, 0.38439686E-03_JPRB, 0.38441552E-03_JPRB, 0.38438542E-03_JPRB, 0.38438376E-03_JPRB, 0.38430404E-03_JPRB, &
  & 0.38424051E-03_JPRB, 0.38416874E-03_JPRB, 0.38407212E-03_JPRB, 0.38397376E-03_JPRB, 0.38382270E-03_JPRB, 0.38365190E-03_JPRB, &
  & 0.38347970E-03_JPRB, 0.38326978E-03_JPRB, 0.38307391E-03_JPRB, 0.38299040E-03_JPRB, 0.38287485E-03_JPRB, 0.38276467E-03_JPRB, &
  & 0.38288082E-03_JPRB, 0.38290658E-03_JPRB, 0.38288211E-03_JPRB, 0.38279323E-03_JPRB, 0.38268833E-03_JPRB, 0.38263896E-03_JPRB, &
  & 0.38268099E-03_JPRB, 0.38286596E-03_JPRB, 0.38323854E-03_JPRB, 0.38356609E-03_JPRB, 0.38401101E-03_JPRB, 0.38447619E-03_JPRB, &
  & 0.38459617E-03_JPRB, 0.38520531E-03_JPRB, 0.38611754E-03_JPRB, 0.38699788E-03_JPRB, 0.38805166E-03_JPRB, 0.38882478E-03_JPRB, &
  & 0.38906147E-03_JPRB, 0.38924132E-03_JPRB, 0.38963352E-03_JPRB, 0.38999145E-03_JPRB, 0.39049017E-03_JPRB, 0.39102982E-03_JPRB, &
  & 0.39145641E-03_JPRB, 0.39217620E-03_JPRB, 0.39275884E-03_JPRB, 0.39307396E-03_JPRB, 0.39365986E-03_JPRB, 0.39403794E-03_JPRB, &
  & 0.39461123E-03_JPRB, 0.39499816E-03_JPRB, 0.39546564E-03_JPRB, 0.39590610E-03_JPRB, 0.39631825E-03_JPRB, 0.39671802E-03_JPRB, &
  & 0.39688879E-03_JPRB, 0.39726097E-03_JPRB, 0.39748912E-03_JPRB, 0.39741744E-03_JPRB, 0.39732562E-03_JPRB, 0.39735630E-03_JPRB, &
  & 0.39761533E-03_JPRB, 0.39790361E-03_JPRB, 0.39797467E-03_JPRB, 0.39792959E-03_JPRB  /)

RGHG1(:,90, 5) = (/ &
  & 0.38440115E-03_JPRB, 0.38439440E-03_JPRB, 0.38441276E-03_JPRB, 0.38438210E-03_JPRB, 0.38438181E-03_JPRB, 0.38430650E-03_JPRB, &
  & 0.38424215E-03_JPRB, 0.38416984E-03_JPRB, 0.38407239E-03_JPRB, 0.38397404E-03_JPRB, 0.38382298E-03_JPRB, 0.38365103E-03_JPRB, &
  & 0.38348147E-03_JPRB, 0.38327114E-03_JPRB, 0.38307221E-03_JPRB, 0.38301522E-03_JPRB, 0.38291193E-03_JPRB, 0.38282235E-03_JPRB, &
  & 0.38303082E-03_JPRB, 0.38308906E-03_JPRB, 0.38314585E-03_JPRB, 0.38305022E-03_JPRB, 0.38298189E-03_JPRB, 0.38300796E-03_JPRB, &
  & 0.38312517E-03_JPRB, 0.38344862E-03_JPRB, 0.38401112E-03_JPRB, 0.38438245E-03_JPRB, 0.38489482E-03_JPRB, 0.38561338E-03_JPRB, &
  & 0.38584345E-03_JPRB, 0.38639057E-03_JPRB, 0.38713008E-03_JPRB, 0.38777819E-03_JPRB, 0.38871469E-03_JPRB, 0.38914288E-03_JPRB, &
  & 0.38935487E-03_JPRB, 0.38954564E-03_JPRB, 0.38995354E-03_JPRB, 0.39033074E-03_JPRB, 0.39091712E-03_JPRB, 0.39148531E-03_JPRB, &
  & 0.39196877E-03_JPRB, 0.39283528E-03_JPRB, 0.39354439E-03_JPRB, 0.39405138E-03_JPRB, 0.39467109E-03_JPRB, 0.39495221E-03_JPRB, &
  & 0.39565536E-03_JPRB, 0.39603302E-03_JPRB, 0.39632960E-03_JPRB, 0.39651283E-03_JPRB, 0.39678349E-03_JPRB, 0.39717521E-03_JPRB, &
  & 0.39729512E-03_JPRB, 0.39758708E-03_JPRB, 0.39767600E-03_JPRB, 0.39748868E-03_JPRB, 0.39733302E-03_JPRB, 0.39735399E-03_JPRB, &
  & 0.39761643E-03_JPRB, 0.39790196E-03_JPRB, 0.39797522E-03_JPRB, 0.39792987E-03_JPRB  /)

RGHG1(:,91, 5) = (/ &
  & 0.38440070E-03_JPRB, 0.38439365E-03_JPRB, 0.38441143E-03_JPRB, 0.38438017E-03_JPRB, 0.38438048E-03_JPRB, 0.38430694E-03_JPRB, &
  & 0.38424260E-03_JPRB, 0.38417028E-03_JPRB, 0.38407254E-03_JPRB, 0.38397418E-03_JPRB, 0.38382313E-03_JPRB, 0.38364940E-03_JPRB, &
  & 0.38348578E-03_JPRB, 0.38327129E-03_JPRB, 0.38306998E-03_JPRB, 0.38306110E-03_JPRB, 0.38297622E-03_JPRB, 0.38290238E-03_JPRB, &
  & 0.38329795E-03_JPRB, 0.38339539E-03_JPRB, 0.38359057E-03_JPRB, 0.38351305E-03_JPRB, 0.38349282E-03_JPRB, 0.38364511E-03_JPRB, &
  & 0.38385438E-03_JPRB, 0.38456953E-03_JPRB, 0.38539070E-03_JPRB, 0.38585735E-03_JPRB, 0.38630409E-03_JPRB, 0.38767985E-03_JPRB, &
  & 0.38816887E-03_JPRB, 0.38864472E-03_JPRB, 0.38912884E-03_JPRB, 0.38908441E-03_JPRB, 0.38970672E-03_JPRB, 0.38958017E-03_JPRB, &
  & 0.38973276E-03_JPRB, 0.38989087E-03_JPRB, 0.39041697E-03_JPRB, 0.39086217E-03_JPRB, 0.39152309E-03_JPRB, 0.39214295E-03_JPRB, &
  & 0.39274074E-03_JPRB, 0.39384840E-03_JPRB, 0.39473391E-03_JPRB, 0.39574841E-03_JPRB, 0.39644058E-03_JPRB, 0.39661064E-03_JPRB, &
  & 0.39748573E-03_JPRB, 0.39788804E-03_JPRB, 0.39779826E-03_JPRB, 0.39752832E-03_JPRB, 0.39755130E-03_JPRB, 0.39801489E-03_JPRB, &
  & 0.39808996E-03_JPRB, 0.39821651E-03_JPRB, 0.39801796E-03_JPRB, 0.39757673E-03_JPRB, 0.39734356E-03_JPRB, 0.39734969E-03_JPRB, &
  & 0.39761687E-03_JPRB, 0.39790122E-03_JPRB, 0.39797537E-03_JPRB, 0.39793002E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ---GEMS----

RGHG1(:, 1, 6) = (/ &
  & 0.37274854E-03_JPRB, 0.37275777E-03_JPRB, 0.37276121E-03_JPRB, 0.37277439E-03_JPRB, 0.37278795E-03_JPRB, 0.37280074E-03_JPRB, &
  & 0.37281391E-03_JPRB, 0.37282544E-03_JPRB, 0.37283709E-03_JPRB, 0.37285287E-03_JPRB, 0.37287688E-03_JPRB, 0.37291285E-03_JPRB, &
  & 0.37296011E-03_JPRB, 0.37300841E-03_JPRB, 0.37305096E-03_JPRB, 0.37308010E-03_JPRB, 0.37310155E-03_JPRB, 0.37311634E-03_JPRB, &
  & 0.37312568E-03_JPRB, 0.37313062E-03_JPRB, 0.37313587E-03_JPRB, 0.37313514E-03_JPRB, 0.37313032E-03_JPRB, 0.37312633E-03_JPRB, &
  & 0.37312174E-03_JPRB, 0.37311630E-03_JPRB, 0.37310630E-03_JPRB, 0.37309428E-03_JPRB, 0.37308206E-03_JPRB, 0.37306976E-03_JPRB, &
  & 0.37305375E-03_JPRB, 0.37302828E-03_JPRB, 0.37299354E-03_JPRB, 0.37295547E-03_JPRB, 0.37291101E-03_JPRB, 0.37285685E-03_JPRB, &
  & 0.37278971E-03_JPRB, 0.37270824E-03_JPRB, 0.37261337E-03_JPRB, 0.37250326E-03_JPRB, 0.37238131E-03_JPRB, 0.37224860E-03_JPRB, &
  & 0.37211163E-03_JPRB, 0.37198206E-03_JPRB, 0.37186639E-03_JPRB, 0.37176739E-03_JPRB, 0.37168569E-03_JPRB, 0.37161805E-03_JPRB, &
  & 0.37156267E-03_JPRB, 0.37151606E-03_JPRB, 0.37147711E-03_JPRB, 0.37144612E-03_JPRB, 0.37142437E-03_JPRB, 0.37140943E-03_JPRB, &
  & 0.37139763E-03_JPRB, 0.37138614E-03_JPRB, 0.37137615E-03_JPRB, 0.37136910E-03_JPRB, 0.37136404E-03_JPRB, 0.37135803E-03_JPRB, &
  & 0.37135022E-03_JPRB, 0.37134271E-03_JPRB, 0.37133628E-03_JPRB, 0.37133225E-03_JPRB  /)

RGHG1(:, 2, 6) = (/ &
  & 0.37274854E-03_JPRB, 0.37275777E-03_JPRB, 0.37276121E-03_JPRB, 0.37277439E-03_JPRB, 0.37278795E-03_JPRB, 0.37280074E-03_JPRB, &
  & 0.37281391E-03_JPRB, 0.37282544E-03_JPRB, 0.37283709E-03_JPRB, 0.37285287E-03_JPRB, 0.37287688E-03_JPRB, 0.37291285E-03_JPRB, &
  & 0.37296011E-03_JPRB, 0.37300841E-03_JPRB, 0.37305096E-03_JPRB, 0.37308010E-03_JPRB, 0.37310155E-03_JPRB, 0.37311634E-03_JPRB, &
  & 0.37312568E-03_JPRB, 0.37313062E-03_JPRB, 0.37313587E-03_JPRB, 0.37313514E-03_JPRB, 0.37313032E-03_JPRB, 0.37312633E-03_JPRB, &
  & 0.37312174E-03_JPRB, 0.37311630E-03_JPRB, 0.37310630E-03_JPRB, 0.37309428E-03_JPRB, 0.37308206E-03_JPRB, 0.37306976E-03_JPRB, &
  & 0.37305375E-03_JPRB, 0.37302828E-03_JPRB, 0.37299354E-03_JPRB, 0.37295547E-03_JPRB, 0.37291101E-03_JPRB, 0.37285685E-03_JPRB, &
  & 0.37278971E-03_JPRB, 0.37270824E-03_JPRB, 0.37261337E-03_JPRB, 0.37250326E-03_JPRB, 0.37238131E-03_JPRB, 0.37224860E-03_JPRB, &
  & 0.37211163E-03_JPRB, 0.37198206E-03_JPRB, 0.37186639E-03_JPRB, 0.37176739E-03_JPRB, 0.37168569E-03_JPRB, 0.37161805E-03_JPRB, &
  & 0.37156267E-03_JPRB, 0.37151606E-03_JPRB, 0.37147711E-03_JPRB, 0.37144612E-03_JPRB, 0.37142437E-03_JPRB, 0.37140943E-03_JPRB, &
  & 0.37139763E-03_JPRB, 0.37138614E-03_JPRB, 0.37137615E-03_JPRB, 0.37136910E-03_JPRB, 0.37136404E-03_JPRB, 0.37135803E-03_JPRB, &
  & 0.37135022E-03_JPRB, 0.37134271E-03_JPRB, 0.37133628E-03_JPRB, 0.37133225E-03_JPRB  /)

RGHG1(:, 3, 6) = (/ &
  & 0.37274854E-03_JPRB, 0.37275777E-03_JPRB, 0.37276121E-03_JPRB, 0.37277439E-03_JPRB, 0.37278795E-03_JPRB, 0.37280074E-03_JPRB, &
  & 0.37281391E-03_JPRB, 0.37282544E-03_JPRB, 0.37283709E-03_JPRB, 0.37285287E-03_JPRB, 0.37287688E-03_JPRB, 0.37291285E-03_JPRB, &
  & 0.37296011E-03_JPRB, 0.37300841E-03_JPRB, 0.37305096E-03_JPRB, 0.37308010E-03_JPRB, 0.37310155E-03_JPRB, 0.37311634E-03_JPRB, &
  & 0.37312568E-03_JPRB, 0.37313062E-03_JPRB, 0.37313587E-03_JPRB, 0.37313514E-03_JPRB, 0.37313032E-03_JPRB, 0.37312633E-03_JPRB, &
  & 0.37312174E-03_JPRB, 0.37311630E-03_JPRB, 0.37310630E-03_JPRB, 0.37309428E-03_JPRB, 0.37308206E-03_JPRB, 0.37306976E-03_JPRB, &
  & 0.37305375E-03_JPRB, 0.37302828E-03_JPRB, 0.37299354E-03_JPRB, 0.37295547E-03_JPRB, 0.37291101E-03_JPRB, 0.37285685E-03_JPRB, &
  & 0.37278971E-03_JPRB, 0.37270824E-03_JPRB, 0.37261337E-03_JPRB, 0.37250326E-03_JPRB, 0.37238131E-03_JPRB, 0.37224860E-03_JPRB, &
  & 0.37211163E-03_JPRB, 0.37198206E-03_JPRB, 0.37186639E-03_JPRB, 0.37176739E-03_JPRB, 0.37168569E-03_JPRB, 0.37161805E-03_JPRB, &
  & 0.37156267E-03_JPRB, 0.37151606E-03_JPRB, 0.37147711E-03_JPRB, 0.37144612E-03_JPRB, 0.37142437E-03_JPRB, 0.37140943E-03_JPRB, &
  & 0.37139763E-03_JPRB, 0.37138614E-03_JPRB, 0.37137615E-03_JPRB, 0.37136910E-03_JPRB, 0.37136404E-03_JPRB, 0.37135803E-03_JPRB, &
  & 0.37135022E-03_JPRB, 0.37134271E-03_JPRB, 0.37133628E-03_JPRB, 0.37133225E-03_JPRB  /)

RGHG1(:, 4, 6) = (/ &
  & 0.37274822E-03_JPRB, 0.37275742E-03_JPRB, 0.37276093E-03_JPRB, 0.37277409E-03_JPRB, 0.37278760E-03_JPRB, 0.37280035E-03_JPRB, &
  & 0.37281349E-03_JPRB, 0.37282499E-03_JPRB, 0.37283663E-03_JPRB, 0.37285241E-03_JPRB, 0.37287644E-03_JPRB, 0.37291247E-03_JPRB, &
  & 0.37295984E-03_JPRB, 0.37300825E-03_JPRB, 0.37305089E-03_JPRB, 0.37308017E-03_JPRB, 0.37310174E-03_JPRB, 0.37311666E-03_JPRB, &
  & 0.37312613E-03_JPRB, 0.37313117E-03_JPRB, 0.37313646E-03_JPRB, 0.37313578E-03_JPRB, 0.37313104E-03_JPRB, 0.37312713E-03_JPRB, &
  & 0.37312260E-03_JPRB, 0.37311723E-03_JPRB, 0.37310731E-03_JPRB, 0.37309536E-03_JPRB, 0.37308324E-03_JPRB, 0.37307112E-03_JPRB, &
  & 0.37305537E-03_JPRB, 0.37303016E-03_JPRB, 0.37299562E-03_JPRB, 0.37295765E-03_JPRB, 0.37291333E-03_JPRB, 0.37285935E-03_JPRB, &
  & 0.37279240E-03_JPRB, 0.37271113E-03_JPRB, 0.37261646E-03_JPRB, 0.37250655E-03_JPRB, 0.37238471E-03_JPRB, 0.37225197E-03_JPRB, &
  & 0.37211484E-03_JPRB, 0.37198494E-03_JPRB, 0.37186886E-03_JPRB, 0.37176944E-03_JPRB, 0.37168735E-03_JPRB, 0.37161936E-03_JPRB, &
  & 0.37156366E-03_JPRB, 0.37151676E-03_JPRB, 0.37147753E-03_JPRB, 0.37144629E-03_JPRB, 0.37142433E-03_JPRB, 0.37140926E-03_JPRB, &
  & 0.37139741E-03_JPRB, 0.37138588E-03_JPRB, 0.37137584E-03_JPRB, 0.37136874E-03_JPRB, 0.37136365E-03_JPRB, 0.37135759E-03_JPRB, &
  & 0.37134968E-03_JPRB, 0.37134205E-03_JPRB, 0.37133555E-03_JPRB, 0.37133150E-03_JPRB  /)

RGHG1(:, 5, 6) = (/ &
  & 0.37273336E-03_JPRB, 0.37274099E-03_JPRB, 0.37274749E-03_JPRB, 0.37275977E-03_JPRB, 0.37277126E-03_JPRB, 0.37278181E-03_JPRB, &
  & 0.37279310E-03_JPRB, 0.37280354E-03_JPRB, 0.37281497E-03_JPRB, 0.37283081E-03_JPRB, 0.37285547E-03_JPRB, 0.37289487E-03_JPRB, &
  & 0.37294725E-03_JPRB, 0.37300070E-03_JPRB, 0.37304793E-03_JPRB, 0.37308319E-03_JPRB, 0.37311072E-03_JPRB, 0.37313222E-03_JPRB, &
  & 0.37314764E-03_JPRB, 0.37315729E-03_JPRB, 0.37316453E-03_JPRB, 0.37316612E-03_JPRB, 0.37316532E-03_JPRB, 0.37316503E-03_JPRB, &
  & 0.37316379E-03_JPRB, 0.37316141E-03_JPRB, 0.37315541E-03_JPRB, 0.37314674E-03_JPRB, 0.37313927E-03_JPRB, 0.37313564E-03_JPRB, &
  & 0.37313191E-03_JPRB, 0.37311947E-03_JPRB, 0.37309403E-03_JPRB, 0.37306117E-03_JPRB, 0.37302373E-03_JPRB, 0.37297799E-03_JPRB, &
  & 0.37291997E-03_JPRB, 0.37284816E-03_JPRB, 0.37276314E-03_JPRB, 0.37266284E-03_JPRB, 0.37254613E-03_JPRB, 0.37241222E-03_JPRB, &
  & 0.37226699E-03_JPRB, 0.37212136E-03_JPRB, 0.37198587E-03_JPRB, 0.37186667E-03_JPRB, 0.37176596E-03_JPRB, 0.37168121E-03_JPRB, &
  & 0.37161052E-03_JPRB, 0.37154988E-03_JPRB, 0.37149762E-03_JPRB, 0.37145424E-03_JPRB, 0.37142268E-03_JPRB, 0.37140141E-03_JPRB, &
  & 0.37138663E-03_JPRB, 0.37137334E-03_JPRB, 0.37136106E-03_JPRB, 0.37135173E-03_JPRB, 0.37134500E-03_JPRB, 0.37133669E-03_JPRB, &
  & 0.37132424E-03_JPRB, 0.37131092E-03_JPRB, 0.37130094E-03_JPRB, 0.37129575E-03_JPRB  /)

RGHG1(:, 6, 6) = (/ &
  & 0.37271106E-03_JPRB, 0.37271635E-03_JPRB, 0.37272734E-03_JPRB, 0.37273829E-03_JPRB, 0.37274674E-03_JPRB, 0.37275400E-03_JPRB, &
  & 0.37276252E-03_JPRB, 0.37277137E-03_JPRB, 0.37278248E-03_JPRB, 0.37279840E-03_JPRB, 0.37282400E-03_JPRB, 0.37286846E-03_JPRB, &
  & 0.37292835E-03_JPRB, 0.37298937E-03_JPRB, 0.37304348E-03_JPRB, 0.37308772E-03_JPRB, 0.37312418E-03_JPRB, 0.37315557E-03_JPRB, &
  & 0.37317990E-03_JPRB, 0.37319647E-03_JPRB, 0.37320666E-03_JPRB, 0.37321164E-03_JPRB, 0.37321675E-03_JPRB, 0.37322190E-03_JPRB, &
  & 0.37322559E-03_JPRB, 0.37322769E-03_JPRB, 0.37322757E-03_JPRB, 0.37322383E-03_JPRB, 0.37322335E-03_JPRB, 0.37323245E-03_JPRB, &
  & 0.37324676E-03_JPRB, 0.37325347E-03_JPRB, 0.37324168E-03_JPRB, 0.37321648E-03_JPRB, 0.37318935E-03_JPRB, 0.37315600E-03_JPRB, &
  & 0.37311138E-03_JPRB, 0.37305374E-03_JPRB, 0.37298320E-03_JPRB, 0.37289734E-03_JPRB, 0.37278832E-03_JPRB, 0.37265265E-03_JPRB, &
  & 0.37249528E-03_JPRB, 0.37232605E-03_JPRB, 0.37216142E-03_JPRB, 0.37201256E-03_JPRB, 0.37188391E-03_JPRB, 0.37177401E-03_JPRB, &
  & 0.37168083E-03_JPRB, 0.37159957E-03_JPRB, 0.37152776E-03_JPRB, 0.37146618E-03_JPRB, 0.37142021E-03_JPRB, 0.37138962E-03_JPRB, &
  & 0.37137045E-03_JPRB, 0.37135452E-03_JPRB, 0.37133889E-03_JPRB, 0.37132620E-03_JPRB, 0.37131702E-03_JPRB, 0.37130533E-03_JPRB, &
  & 0.37128606E-03_JPRB, 0.37126420E-03_JPRB, 0.37124903E-03_JPRB, 0.37124212E-03_JPRB  /)

RGHG1(:, 7, 6) = (/ &
  & 0.37265785E-03_JPRB, 0.37266401E-03_JPRB, 0.37267676E-03_JPRB, 0.37268821E-03_JPRB, 0.37269509E-03_JPRB, 0.37270017E-03_JPRB, &
  & 0.37270796E-03_JPRB, 0.37271492E-03_JPRB, 0.37272429E-03_JPRB, 0.37273956E-03_JPRB, 0.37276486E-03_JPRB, 0.37280991E-03_JPRB, &
  & 0.37287563E-03_JPRB, 0.37294699E-03_JPRB, 0.37301261E-03_JPRB, 0.37307134E-03_JPRB, 0.37312547E-03_JPRB, 0.37317723E-03_JPRB, &
  & 0.37322298E-03_JPRB, 0.37325460E-03_JPRB, 0.37327639E-03_JPRB, 0.37329228E-03_JPRB, 0.37330586E-03_JPRB, 0.37331608E-03_JPRB, &
  & 0.37332745E-03_JPRB, 0.37334194E-03_JPRB, 0.37335892E-03_JPRB, 0.37337674E-03_JPRB, 0.37339833E-03_JPRB, 0.37343279E-03_JPRB, &
  & 0.37348265E-03_JPRB, 0.37352920E-03_JPRB, 0.37354040E-03_JPRB, 0.37353089E-03_JPRB, 0.37351826E-03_JPRB, 0.37349785E-03_JPRB, &
  & 0.37346524E-03_JPRB, 0.37342003E-03_JPRB, 0.37336319E-03_JPRB, 0.37329223E-03_JPRB, 0.37319633E-03_JPRB, 0.37306502E-03_JPRB, &
  & 0.37289169E-03_JPRB, 0.37268174E-03_JPRB, 0.37246029E-03_JPRB, 0.37225163E-03_JPRB, 0.37206940E-03_JPRB, 0.37191446E-03_JPRB, &
  & 0.37178126E-03_JPRB, 0.37166402E-03_JPRB, 0.37156149E-03_JPRB, 0.37147311E-03_JPRB, 0.37140563E-03_JPRB, 0.37135966E-03_JPRB, &
  & 0.37133285E-03_JPRB, 0.37131543E-03_JPRB, 0.37130067E-03_JPRB, 0.37128664E-03_JPRB, 0.37127382E-03_JPRB, 0.37125925E-03_JPRB, &
  & 0.37123753E-03_JPRB, 0.37121321E-03_JPRB, 0.37119584E-03_JPRB, 0.37118727E-03_JPRB  /)

RGHG1(:, 8, 6) = (/ &
  & 0.37258294E-03_JPRB, 0.37259001E-03_JPRB, 0.37260096E-03_JPRB, 0.37260996E-03_JPRB, 0.37261647E-03_JPRB, 0.37262105E-03_JPRB, &
  & 0.37262781E-03_JPRB, 0.37263468E-03_JPRB, 0.37264196E-03_JPRB, 0.37265547E-03_JPRB, 0.37267944E-03_JPRB, 0.37272403E-03_JPRB, &
  & 0.37279404E-03_JPRB, 0.37287558E-03_JPRB, 0.37295516E-03_JPRB, 0.37303471E-03_JPRB, 0.37311234E-03_JPRB, 0.37319237E-03_JPRB, &
  & 0.37326875E-03_JPRB, 0.37332760E-03_JPRB, 0.37337198E-03_JPRB, 0.37340474E-03_JPRB, 0.37343172E-03_JPRB, 0.37345385E-03_JPRB, &
  & 0.37347463E-03_JPRB, 0.37350546E-03_JPRB, 0.37355032E-03_JPRB, 0.37360806E-03_JPRB, 0.37367558E-03_JPRB, 0.37376466E-03_JPRB, &
  & 0.37387958E-03_JPRB, 0.37397965E-03_JPRB, 0.37401461E-03_JPRB, 0.37401516E-03_JPRB, 0.37400490E-03_JPRB, 0.37398258E-03_JPRB, &
  & 0.37394627E-03_JPRB, 0.37389590E-03_JPRB, 0.37383157E-03_JPRB, 0.37375332E-03_JPRB, 0.37365122E-03_JPRB, 0.37351013E-03_JPRB, &
  & 0.37331323E-03_JPRB, 0.37306183E-03_JPRB, 0.37278408E-03_JPRB, 0.37251511E-03_JPRB, 0.37227630E-03_JPRB, 0.37207195E-03_JPRB, &
  & 0.37189585E-03_JPRB, 0.37174017E-03_JPRB, 0.37160253E-03_JPRB, 0.37148218E-03_JPRB, 0.37138720E-03_JPRB, 0.37131936E-03_JPRB, &
  & 0.37128024E-03_JPRB, 0.37125904E-03_JPRB, 0.37124739E-03_JPRB, 0.37123539E-03_JPRB, 0.37121943E-03_JPRB, 0.37120131E-03_JPRB, &
  & 0.37117979E-03_JPRB, 0.37115834E-03_JPRB, 0.37114339E-03_JPRB, 0.37113594E-03_JPRB  /)

RGHG1(:, 9, 6) = (/ &
  & 0.37248986E-03_JPRB, 0.37249412E-03_JPRB, 0.37249935E-03_JPRB, 0.37250398E-03_JPRB, 0.37251054E-03_JPRB, 0.37251622E-03_JPRB, &
  & 0.37252155E-03_JPRB, 0.37252830E-03_JPRB, 0.37253369E-03_JPRB, 0.37254404E-03_JPRB, 0.37256550E-03_JPRB, 0.37260942E-03_JPRB, &
  & 0.37267970E-03_JPRB, 0.37276696E-03_JPRB, 0.37286016E-03_JPRB, 0.37296449E-03_JPRB, 0.37306992E-03_JPRB, 0.37318013E-03_JPRB, &
  & 0.37329128E-03_JPRB, 0.37338869E-03_JPRB, 0.37346422E-03_JPRB, 0.37351990E-03_JPRB, 0.37356636E-03_JPRB, 0.37360601E-03_JPRB, &
  & 0.37363769E-03_JPRB, 0.37368353E-03_JPRB, 0.37375600E-03_JPRB, 0.37385572E-03_JPRB, 0.37398397E-03_JPRB, 0.37415368E-03_JPRB, &
  & 0.37435628E-03_JPRB, 0.37451225E-03_JPRB, 0.37457023E-03_JPRB, 0.37457648E-03_JPRB, 0.37455960E-03_JPRB, 0.37452235E-03_JPRB, &
  & 0.37446365E-03_JPRB, 0.37438376E-03_JPRB, 0.37428407E-03_JPRB, 0.37416778E-03_JPRB, 0.37403008E-03_JPRB, 0.37386037E-03_JPRB, &
  & 0.37364140E-03_JPRB, 0.37336637E-03_JPRB, 0.37305421E-03_JPRB, 0.37274711E-03_JPRB, 0.37246577E-03_JPRB, 0.37221895E-03_JPRB, &
  & 0.37200871E-03_JPRB, 0.37182357E-03_JPRB, 0.37165507E-03_JPRB, 0.37150513E-03_JPRB, 0.37138003E-03_JPRB, 0.37128406E-03_JPRB, &
  & 0.37122727E-03_JPRB, 0.37119682E-03_JPRB, 0.37118561E-03_JPRB, 0.37117805E-03_JPRB, 0.37116072E-03_JPRB, 0.37113876E-03_JPRB, &
  & 0.37111846E-03_JPRB, 0.37110318E-03_JPRB, 0.37109496E-03_JPRB, 0.37109256E-03_JPRB  /)

RGHG1(:,10, 6) = (/ &
  & 0.37236583E-03_JPRB, 0.37236535E-03_JPRB, 0.37236653E-03_JPRB, 0.37236970E-03_JPRB, 0.37237600E-03_JPRB, 0.37238216E-03_JPRB, &
  & 0.37238670E-03_JPRB, 0.37239023E-03_JPRB, 0.37239385E-03_JPRB, 0.37240090E-03_JPRB, 0.37241969E-03_JPRB, 0.37246227E-03_JPRB, &
  & 0.37252708E-03_JPRB, 0.37261283E-03_JPRB, 0.37271643E-03_JPRB, 0.37284325E-03_JPRB, 0.37297927E-03_JPRB, 0.37311819E-03_JPRB, &
  & 0.37326174E-03_JPRB, 0.37339336E-03_JPRB, 0.37349542E-03_JPRB, 0.37357676E-03_JPRB, 0.37364283E-03_JPRB, 0.37369518E-03_JPRB, &
  & 0.37373774E-03_JPRB, 0.37379042E-03_JPRB, 0.37386816E-03_JPRB, 0.37397969E-03_JPRB, 0.37414880E-03_JPRB, 0.37439361E-03_JPRB, &
  & 0.37466844E-03_JPRB, 0.37485953E-03_JPRB, 0.37493840E-03_JPRB, 0.37495767E-03_JPRB, 0.37494922E-03_JPRB, 0.37491155E-03_JPRB, &
  & 0.37483690E-03_JPRB, 0.37472589E-03_JPRB, 0.37458731E-03_JPRB, 0.37442546E-03_JPRB, 0.37424263E-03_JPRB, 0.37404131E-03_JPRB, &
  & 0.37381335E-03_JPRB, 0.37353879E-03_JPRB, 0.37322483E-03_JPRB, 0.37291240E-03_JPRB, 0.37261174E-03_JPRB, 0.37233765E-03_JPRB, &
  & 0.37210890E-03_JPRB, 0.37190984E-03_JPRB, 0.37172358E-03_JPRB, 0.37155743E-03_JPRB, 0.37140785E-03_JPRB, 0.37127855E-03_JPRB, &
  & 0.37119926E-03_JPRB, 0.37115410E-03_JPRB, 0.37113574E-03_JPRB, 0.37113027E-03_JPRB, 0.37111207E-03_JPRB, 0.37108464E-03_JPRB, &
  & 0.37106032E-03_JPRB, 0.37104581E-03_JPRB, 0.37104154E-03_JPRB, 0.37104362E-03_JPRB  /)

RGHG1(:,11, 6) = (/ &
  & 0.37216385E-03_JPRB, 0.37216775E-03_JPRB, 0.37217387E-03_JPRB, 0.37217916E-03_JPRB, 0.37218649E-03_JPRB, 0.37219219E-03_JPRB, &
  & 0.37219781E-03_JPRB, 0.37220058E-03_JPRB, 0.37220382E-03_JPRB, 0.37221195E-03_JPRB, 0.37223237E-03_JPRB, 0.37227357E-03_JPRB, &
  & 0.37233275E-03_JPRB, 0.37241577E-03_JPRB, 0.37252797E-03_JPRB, 0.37267452E-03_JPRB, 0.37284403E-03_JPRB, 0.37301819E-03_JPRB, &
  & 0.37319123E-03_JPRB, 0.37334364E-03_JPRB, 0.37346417E-03_JPRB, 0.37356407E-03_JPRB, 0.37364128E-03_JPRB, 0.37370297E-03_JPRB, &
  & 0.37375567E-03_JPRB, 0.37381052E-03_JPRB, 0.37387574E-03_JPRB, 0.37397183E-03_JPRB, 0.37413778E-03_JPRB, 0.37441873E-03_JPRB, &
  & 0.37473332E-03_JPRB, 0.37493885E-03_JPRB, 0.37503129E-03_JPRB, 0.37506375E-03_JPRB, 0.37507691E-03_JPRB, 0.37506206E-03_JPRB, &
  & 0.37500108E-03_JPRB, 0.37488769E-03_JPRB, 0.37473310E-03_JPRB, 0.37454758E-03_JPRB, 0.37434065E-03_JPRB, 0.37412038E-03_JPRB, &
  & 0.37388741E-03_JPRB, 0.37361478E-03_JPRB, 0.37331590E-03_JPRB, 0.37302182E-03_JPRB, 0.37271758E-03_JPRB, 0.37243193E-03_JPRB, &
  & 0.37219557E-03_JPRB, 0.37199129E-03_JPRB, 0.37179823E-03_JPRB, 0.37162973E-03_JPRB, 0.37147159E-03_JPRB, 0.37131031E-03_JPRB, &
  & 0.37120609E-03_JPRB, 0.37115006E-03_JPRB, 0.37112694E-03_JPRB, 0.37112242E-03_JPRB, 0.37110122E-03_JPRB, 0.37106124E-03_JPRB, &
  & 0.37102011E-03_JPRB, 0.37099383E-03_JPRB, 0.37098318E-03_JPRB, 0.37098233E-03_JPRB  /)

RGHG1(:,12, 6) = (/ &
  & 0.37188038E-03_JPRB, 0.37188895E-03_JPRB, 0.37190155E-03_JPRB, 0.37191274E-03_JPRB, 0.37192170E-03_JPRB, 0.37192901E-03_JPRB, &
  & 0.37193881E-03_JPRB, 0.37194797E-03_JPRB, 0.37195882E-03_JPRB, 0.37197812E-03_JPRB, 0.37201099E-03_JPRB, 0.37206053E-03_JPRB, &
  & 0.37212740E-03_JPRB, 0.37221991E-03_JPRB, 0.37234786E-03_JPRB, 0.37251838E-03_JPRB, 0.37272318E-03_JPRB, 0.37294101E-03_JPRB, &
  & 0.37315403E-03_JPRB, 0.37334883E-03_JPRB, 0.37350578E-03_JPRB, 0.37362579E-03_JPRB, 0.37372654E-03_JPRB, 0.37381706E-03_JPRB, &
  & 0.37388893E-03_JPRB, 0.37394840E-03_JPRB, 0.37399973E-03_JPRB, 0.37406491E-03_JPRB, 0.37418645E-03_JPRB, 0.37443254E-03_JPRB, &
  & 0.37473999E-03_JPRB, 0.37495101E-03_JPRB, 0.37505244E-03_JPRB, 0.37508927E-03_JPRB, 0.37511544E-03_JPRB, 0.37512159E-03_JPRB, &
  & 0.37508386E-03_JPRB, 0.37498510E-03_JPRB, 0.37482430E-03_JPRB, 0.37462874E-03_JPRB, 0.37441864E-03_JPRB, 0.37419595E-03_JPRB, &
  & 0.37396354E-03_JPRB, 0.37369000E-03_JPRB, 0.37339444E-03_JPRB, 0.37312269E-03_JPRB, 0.37282219E-03_JPRB, 0.37253585E-03_JPRB, &
  & 0.37229384E-03_JPRB, 0.37208186E-03_JPRB, 0.37188295E-03_JPRB, 0.37170867E-03_JPRB, 0.37155220E-03_JPRB, 0.37138490E-03_JPRB, &
  & 0.37127400E-03_JPRB, 0.37122547E-03_JPRB, 0.37120919E-03_JPRB, 0.37121028E-03_JPRB, 0.37119120E-03_JPRB, 0.37113723E-03_JPRB, &
  & 0.37106219E-03_JPRB, 0.37100510E-03_JPRB, 0.37097421E-03_JPRB, 0.37096122E-03_JPRB  /)

RGHG1(:,13, 6) = (/ &
  & 0.37161086E-03_JPRB, 0.37161718E-03_JPRB, 0.37162897E-03_JPRB, 0.37164357E-03_JPRB, 0.37165310E-03_JPRB, 0.37166438E-03_JPRB, &
  & 0.37167903E-03_JPRB, 0.37169802E-03_JPRB, 0.37172390E-03_JPRB, 0.37175954E-03_JPRB, 0.37181220E-03_JPRB, 0.37188494E-03_JPRB, &
  & 0.37197871E-03_JPRB, 0.37210104E-03_JPRB, 0.37225941E-03_JPRB, 0.37245996E-03_JPRB, 0.37270509E-03_JPRB, 0.37299146E-03_JPRB, &
  & 0.37329104E-03_JPRB, 0.37357460E-03_JPRB, 0.37380972E-03_JPRB, 0.37400185E-03_JPRB, 0.37417868E-03_JPRB, 0.37431919E-03_JPRB, &
  & 0.37441068E-03_JPRB, 0.37445826E-03_JPRB, 0.37447263E-03_JPRB, 0.37449162E-03_JPRB, 0.37455085E-03_JPRB, 0.37469723E-03_JPRB, &
  & 0.37490208E-03_JPRB, 0.37505848E-03_JPRB, 0.37513740E-03_JPRB, 0.37516928E-03_JPRB, 0.37520042E-03_JPRB, 0.37521596E-03_JPRB, &
  & 0.37519216E-03_JPRB, 0.37510715E-03_JPRB, 0.37493812E-03_JPRB, 0.37473492E-03_JPRB, 0.37453488E-03_JPRB, 0.37432425E-03_JPRB, &
  & 0.37409677E-03_JPRB, 0.37381848E-03_JPRB, 0.37351930E-03_JPRB, 0.37325420E-03_JPRB, 0.37296961E-03_JPRB, 0.37269951E-03_JPRB, &
  & 0.37245936E-03_JPRB, 0.37224167E-03_JPRB, 0.37203528E-03_JPRB, 0.37184393E-03_JPRB, 0.37168973E-03_JPRB, 0.37155308E-03_JPRB, &
  & 0.37147630E-03_JPRB, 0.37146209E-03_JPRB, 0.37146534E-03_JPRB, 0.37148652E-03_JPRB, 0.37149403E-03_JPRB, 0.37144635E-03_JPRB, &
  & 0.37133408E-03_JPRB, 0.37123815E-03_JPRB, 0.37118123E-03_JPRB, 0.37113856E-03_JPRB  /)

RGHG1(:,14, 6) = (/ &
  & 0.37143536E-03_JPRB, 0.37144486E-03_JPRB, 0.37145757E-03_JPRB, 0.37147321E-03_JPRB, 0.37148739E-03_JPRB, 0.37150331E-03_JPRB, &
  & 0.37152246E-03_JPRB, 0.37154860E-03_JPRB, 0.37158604E-03_JPRB, 0.37163378E-03_JPRB, 0.37170276E-03_JPRB, 0.37180150E-03_JPRB, &
  & 0.37193016E-03_JPRB, 0.37209676E-03_JPRB, 0.37229655E-03_JPRB, 0.37253369E-03_JPRB, 0.37282041E-03_JPRB, 0.37317668E-03_JPRB, &
  & 0.37357458E-03_JPRB, 0.37395733E-03_JPRB, 0.37429171E-03_JPRB, 0.37461635E-03_JPRB, 0.37490541E-03_JPRB, 0.37509145E-03_JPRB, &
  & 0.37518639E-03_JPRB, 0.37521275E-03_JPRB, 0.37519752E-03_JPRB, 0.37518171E-03_JPRB, 0.37518129E-03_JPRB, 0.37521135E-03_JPRB, &
  & 0.37527793E-03_JPRB, 0.37532394E-03_JPRB, 0.37533979E-03_JPRB, 0.37535047E-03_JPRB, 0.37537277E-03_JPRB, 0.37537880E-03_JPRB, &
  & 0.37534385E-03_JPRB, 0.37524349E-03_JPRB, 0.37505916E-03_JPRB, 0.37486054E-03_JPRB, 0.37467701E-03_JPRB, 0.37447405E-03_JPRB, &
  & 0.37424367E-03_JPRB, 0.37395107E-03_JPRB, 0.37365318E-03_JPRB, 0.37339106E-03_JPRB, 0.37313012E-03_JPRB, 0.37288644E-03_JPRB, &
  & 0.37267104E-03_JPRB, 0.37247272E-03_JPRB, 0.37226112E-03_JPRB, 0.37204609E-03_JPRB, 0.37191326E-03_JPRB, 0.37183148E-03_JPRB, &
  & 0.37181059E-03_JPRB, 0.37184709E-03_JPRB, 0.37189163E-03_JPRB, 0.37195273E-03_JPRB, 0.37200106E-03_JPRB, 0.37198038E-03_JPRB, &
  & 0.37186027E-03_JPRB, 0.37175554E-03_JPRB, 0.37167827E-03_JPRB, 0.37159697E-03_JPRB  /)

RGHG1(:,15, 6) = (/ &
  & 0.37139793E-03_JPRB, 0.37141346E-03_JPRB, 0.37143275E-03_JPRB, 0.37145274E-03_JPRB, 0.37146984E-03_JPRB, 0.37148859E-03_JPRB, &
  & 0.37151021E-03_JPRB, 0.37153890E-03_JPRB, 0.37157907E-03_JPRB, 0.37163374E-03_JPRB, 0.37171249E-03_JPRB, 0.37182866E-03_JPRB, &
  & 0.37199101E-03_JPRB, 0.37220353E-03_JPRB, 0.37244739E-03_JPRB, 0.37271366E-03_JPRB, 0.37301657E-03_JPRB, 0.37339181E-03_JPRB, &
  & 0.37382133E-03_JPRB, 0.37425716E-03_JPRB, 0.37468411E-03_JPRB, 0.37511768E-03_JPRB, 0.37549921E-03_JPRB, 0.37573039E-03_JPRB, &
  & 0.37583410E-03_JPRB, 0.37586471E-03_JPRB, 0.37586281E-03_JPRB, 0.37584243E-03_JPRB, 0.37580820E-03_JPRB, 0.37577036E-03_JPRB, &
  & 0.37573696E-03_JPRB, 0.37568142E-03_JPRB, 0.37563466E-03_JPRB, 0.37561477E-03_JPRB, 0.37560714E-03_JPRB, 0.37557738E-03_JPRB, &
  & 0.37550182E-03_JPRB, 0.37535254E-03_JPRB, 0.37514804E-03_JPRB, 0.37495972E-03_JPRB, 0.37478097E-03_JPRB, 0.37456926E-03_JPRB, &
  & 0.37432554E-03_JPRB, 0.37401655E-03_JPRB, 0.37370942E-03_JPRB, 0.37344575E-03_JPRB, 0.37320877E-03_JPRB, 0.37299303E-03_JPRB, &
  & 0.37281753E-03_JPRB, 0.37265625E-03_JPRB, 0.37244900E-03_JPRB, 0.37224510E-03_JPRB, 0.37215997E-03_JPRB, 0.37213678E-03_JPRB, &
  & 0.37215952E-03_JPRB, 0.37223593E-03_JPRB, 0.37233235E-03_JPRB, 0.37242088E-03_JPRB, 0.37247986E-03_JPRB, 0.37247938E-03_JPRB, &
  & 0.37239555E-03_JPRB, 0.37231247E-03_JPRB, 0.37221639E-03_JPRB, 0.37212214E-03_JPRB  /)

RGHG1(:,16, 6) = (/ &
  & 0.37154393E-03_JPRB, 0.37155791E-03_JPRB, 0.37157574E-03_JPRB, 0.37158959E-03_JPRB, 0.37160037E-03_JPRB, 0.37161458E-03_JPRB, &
  & 0.37163213E-03_JPRB, 0.37165482E-03_JPRB, 0.37168956E-03_JPRB, 0.37174564E-03_JPRB, 0.37183100E-03_JPRB, 0.37196364E-03_JPRB, &
  & 0.37215612E-03_JPRB, 0.37240569E-03_JPRB, 0.37268166E-03_JPRB, 0.37295470E-03_JPRB, 0.37323512E-03_JPRB, 0.37357841E-03_JPRB, &
  & 0.37397672E-03_JPRB, 0.37440958E-03_JPRB, 0.37488548E-03_JPRB, 0.37537473E-03_JPRB, 0.37581459E-03_JPRB, 0.37607583E-03_JPRB, &
  & 0.37618618E-03_JPRB, 0.37623334E-03_JPRB, 0.37625403E-03_JPRB, 0.37626184E-03_JPRB, 0.37626361E-03_JPRB, 0.37624277E-03_JPRB, &
  & 0.37619179E-03_JPRB, 0.37609079E-03_JPRB, 0.37599252E-03_JPRB, 0.37592511E-03_JPRB, 0.37586333E-03_JPRB, 0.37577401E-03_JPRB, &
  & 0.37564250E-03_JPRB, 0.37544867E-03_JPRB, 0.37522520E-03_JPRB, 0.37502000E-03_JPRB, 0.37481319E-03_JPRB, 0.37457944E-03_JPRB, &
  & 0.37432510E-03_JPRB, 0.37399515E-03_JPRB, 0.37365843E-03_JPRB, 0.37338477E-03_JPRB, 0.37316153E-03_JPRB, 0.37297663E-03_JPRB, &
  & 0.37283565E-03_JPRB, 0.37270377E-03_JPRB, 0.37252577E-03_JPRB, 0.37237916E-03_JPRB, 0.37233702E-03_JPRB, 0.37234306E-03_JPRB, &
  & 0.37238499E-03_JPRB, 0.37247841E-03_JPRB, 0.37260131E-03_JPRB, 0.37268086E-03_JPRB, 0.37271605E-03_JPRB, 0.37272488E-03_JPRB, &
  & 0.37269121E-03_JPRB, 0.37262751E-03_JPRB, 0.37253297E-03_JPRB, 0.37244944E-03_JPRB  /)

RGHG1(:,17, 6) = (/ &
  & 0.37186083E-03_JPRB, 0.37186040E-03_JPRB, 0.37186509E-03_JPRB, 0.37186116E-03_JPRB, 0.37185841E-03_JPRB, 0.37185906E-03_JPRB, &
  & 0.37186423E-03_JPRB, 0.37187646E-03_JPRB, 0.37190323E-03_JPRB, 0.37195338E-03_JPRB, 0.37204093E-03_JPRB, 0.37218400E-03_JPRB, &
  & 0.37239484E-03_JPRB, 0.37266497E-03_JPRB, 0.37295319E-03_JPRB, 0.37320583E-03_JPRB, 0.37343737E-03_JPRB, 0.37373324E-03_JPRB, &
  & 0.37408270E-03_JPRB, 0.37447554E-03_JPRB, 0.37494785E-03_JPRB, 0.37546838E-03_JPRB, 0.37593106E-03_JPRB, 0.37620622E-03_JPRB, &
  & 0.37632548E-03_JPRB, 0.37639514E-03_JPRB, 0.37644204E-03_JPRB, 0.37650130E-03_JPRB, 0.37658999E-03_JPRB, 0.37666965E-03_JPRB, &
  & 0.37669717E-03_JPRB, 0.37659892E-03_JPRB, 0.37642119E-03_JPRB, 0.37625784E-03_JPRB, 0.37612494E-03_JPRB, 0.37598591E-03_JPRB, &
  & 0.37580432E-03_JPRB, 0.37557129E-03_JPRB, 0.37531525E-03_JPRB, 0.37506571E-03_JPRB, 0.37481459E-03_JPRB, 0.37455930E-03_JPRB, &
  & 0.37428891E-03_JPRB, 0.37392833E-03_JPRB, 0.37356117E-03_JPRB, 0.37326925E-03_JPRB, 0.37305087E-03_JPRB, 0.37289300E-03_JPRB, &
  & 0.37276727E-03_JPRB, 0.37265625E-03_JPRB, 0.37253069E-03_JPRB, 0.37244511E-03_JPRB, 0.37242480E-03_JPRB, 0.37243259E-03_JPRB, &
  & 0.37247607E-03_JPRB, 0.37256959E-03_JPRB, 0.37267807E-03_JPRB, 0.37273483E-03_JPRB, 0.37276245E-03_JPRB, 0.37276798E-03_JPRB, &
  & 0.37274912E-03_JPRB, 0.37269797E-03_JPRB, 0.37262410E-03_JPRB, 0.37255554E-03_JPRB  /)

RGHG1(:,18, 6) = (/ &
  & 0.37224777E-03_JPRB, 0.37223412E-03_JPRB, 0.37221841E-03_JPRB, 0.37219531E-03_JPRB, 0.37217724E-03_JPRB, 0.37216338E-03_JPRB, &
  & 0.37215641E-03_JPRB, 0.37216048E-03_JPRB, 0.37218252E-03_JPRB, 0.37223042E-03_JPRB, 0.37231737E-03_JPRB, 0.37246050E-03_JPRB, &
  & 0.37267036E-03_JPRB, 0.37294076E-03_JPRB, 0.37322124E-03_JPRB, 0.37344747E-03_JPRB, 0.37363209E-03_JPRB, 0.37386824E-03_JPRB, &
  & 0.37415485E-03_JPRB, 0.37449636E-03_JPRB, 0.37492789E-03_JPRB, 0.37544643E-03_JPRB, 0.37591216E-03_JPRB, 0.37619149E-03_JPRB, &
  & 0.37634353E-03_JPRB, 0.37645240E-03_JPRB, 0.37653845E-03_JPRB, 0.37665685E-03_JPRB, 0.37683709E-03_JPRB, 0.37706615E-03_JPRB, &
  & 0.37724969E-03_JPRB, 0.37721550E-03_JPRB, 0.37696068E-03_JPRB, 0.37665639E-03_JPRB, 0.37642356E-03_JPRB, 0.37623765E-03_JPRB, &
  & 0.37602334E-03_JPRB, 0.37575594E-03_JPRB, 0.37546069E-03_JPRB, 0.37516699E-03_JPRB, 0.37488026E-03_JPRB, 0.37460270E-03_JPRB, &
  & 0.37429652E-03_JPRB, 0.37390232E-03_JPRB, 0.37351171E-03_JPRB, 0.37320905E-03_JPRB, 0.37299371E-03_JPRB, 0.37285251E-03_JPRB, &
  & 0.37273630E-03_JPRB, 0.37263595E-03_JPRB, 0.37254144E-03_JPRB, 0.37249224E-03_JPRB, 0.37248580E-03_JPRB, 0.37248906E-03_JPRB, &
  & 0.37252708E-03_JPRB, 0.37261062E-03_JPRB, 0.37269258E-03_JPRB, 0.37273168E-03_JPRB, 0.37275039E-03_JPRB, 0.37274385E-03_JPRB, &
  & 0.37273094E-03_JPRB, 0.37270004E-03_JPRB, 0.37264912E-03_JPRB, 0.37259620E-03_JPRB  /)

RGHG1(:,19, 6) = (/ &
  & 0.37267682E-03_JPRB, 0.37265452E-03_JPRB, 0.37261860E-03_JPRB, 0.37257924E-03_JPRB, 0.37254423E-03_JPRB, 0.37251327E-03_JPRB, &
  & 0.37249126E-03_JPRB, 0.37248671E-03_JPRB, 0.37250750E-03_JPRB, 0.37255672E-03_JPRB, 0.37264391E-03_JPRB, 0.37278009E-03_JPRB, &
  & 0.37298045E-03_JPRB, 0.37324345E-03_JPRB, 0.37351437E-03_JPRB, 0.37371363E-03_JPRB, 0.37385154E-03_JPRB, 0.37401382E-03_JPRB, &
  & 0.37423156E-03_JPRB, 0.37451076E-03_JPRB, 0.37487770E-03_JPRB, 0.37535003E-03_JPRB, 0.37579535E-03_JPRB, 0.37608420E-03_JPRB, &
  & 0.37627823E-03_JPRB, 0.37643769E-03_JPRB, 0.37659025E-03_JPRB, 0.37678104E-03_JPRB, 0.37705272E-03_JPRB, 0.37744550E-03_JPRB, &
  & 0.37781117E-03_JPRB, 0.37786764E-03_JPRB, 0.37757722E-03_JPRB, 0.37717154E-03_JPRB, 0.37684128E-03_JPRB, 0.37659310E-03_JPRB, &
  & 0.37634371E-03_JPRB, 0.37604976E-03_JPRB, 0.37572612E-03_JPRB, 0.37539984E-03_JPRB, 0.37508787E-03_JPRB, 0.37478945E-03_JPRB, &
  & 0.37443753E-03_JPRB, 0.37400784E-03_JPRB, 0.37360219E-03_JPRB, 0.37330089E-03_JPRB, 0.37309248E-03_JPRB, 0.37296022E-03_JPRB, &
  & 0.37284557E-03_JPRB, 0.37274513E-03_JPRB, 0.37265902E-03_JPRB, 0.37262332E-03_JPRB, 0.37262613E-03_JPRB, 0.37263138E-03_JPRB, &
  & 0.37265885E-03_JPRB, 0.37271949E-03_JPRB, 0.37277323E-03_JPRB, 0.37279448E-03_JPRB, 0.37279824E-03_JPRB, 0.37278289E-03_JPRB, &
  & 0.37276981E-03_JPRB, 0.37275006E-03_JPRB, 0.37271759E-03_JPRB, 0.37268540E-03_JPRB  /)

RGHG1(:,20, 6) = (/ &
  & 0.37313591E-03_JPRB, 0.37310589E-03_JPRB, 0.37305683E-03_JPRB, 0.37300554E-03_JPRB, 0.37295168E-03_JPRB, 0.37290146E-03_JPRB, &
  & 0.37286169E-03_JPRB, 0.37284679E-03_JPRB, 0.37286506E-03_JPRB, 0.37291798E-03_JPRB, 0.37300598E-03_JPRB, 0.37313852E-03_JPRB, &
  & 0.37333429E-03_JPRB, 0.37359163E-03_JPRB, 0.37384773E-03_JPRB, 0.37402122E-03_JPRB, 0.37412543E-03_JPRB, 0.37422269E-03_JPRB, &
  & 0.37437189E-03_JPRB, 0.37458695E-03_JPRB, 0.37487781E-03_JPRB, 0.37526905E-03_JPRB, 0.37566730E-03_JPRB, 0.37596386E-03_JPRB, &
  & 0.37619626E-03_JPRB, 0.37641002E-03_JPRB, 0.37664024E-03_JPRB, 0.37691283E-03_JPRB, 0.37729334E-03_JPRB, 0.37786719E-03_JPRB, &
  & 0.37839106E-03_JPRB, 0.37851832E-03_JPRB, 0.37820700E-03_JPRB, 0.37774229E-03_JPRB, 0.37736293E-03_JPRB, 0.37707506E-03_JPRB, &
  & 0.37679331E-03_JPRB, 0.37647813E-03_JPRB, 0.37614828E-03_JPRB, 0.37580815E-03_JPRB, 0.37548344E-03_JPRB, 0.37516870E-03_JPRB, &
  & 0.37477443E-03_JPRB, 0.37430999E-03_JPRB, 0.37390275E-03_JPRB, 0.37361975E-03_JPRB, 0.37342655E-03_JPRB, 0.37328990E-03_JPRB, &
  & 0.37316545E-03_JPRB, 0.37305985E-03_JPRB, 0.37297422E-03_JPRB, 0.37293587E-03_JPRB, 0.37293656E-03_JPRB, 0.37294500E-03_JPRB, &
  & 0.37296452E-03_JPRB, 0.37299514E-03_JPRB, 0.37301609E-03_JPRB, 0.37301254E-03_JPRB, 0.37299599E-03_JPRB, 0.37296804E-03_JPRB, &
  & 0.37294496E-03_JPRB, 0.37292442E-03_JPRB, 0.37290318E-03_JPRB, 0.37289026E-03_JPRB  /)

RGHG1(:,21, 6) = (/ &
  & 0.37361181E-03_JPRB, 0.37357345E-03_JPRB, 0.37351636E-03_JPRB, 0.37345426E-03_JPRB, 0.37338067E-03_JPRB, 0.37331000E-03_JPRB, &
  & 0.37325180E-03_JPRB, 0.37322550E-03_JPRB, 0.37323936E-03_JPRB, 0.37329790E-03_JPRB, 0.37339000E-03_JPRB, 0.37352717E-03_JPRB, &
  & 0.37372738E-03_JPRB, 0.37398158E-03_JPRB, 0.37422104E-03_JPRB, 0.37437623E-03_JPRB, 0.37446598E-03_JPRB, 0.37451996E-03_JPRB, &
  & 0.37461220E-03_JPRB, 0.37477128E-03_JPRB, 0.37498616E-03_JPRB, 0.37528306E-03_JPRB, 0.37561489E-03_JPRB, 0.37591102E-03_JPRB, &
  & 0.37617834E-03_JPRB, 0.37644708E-03_JPRB, 0.37675167E-03_JPRB, 0.37711143E-03_JPRB, 0.37762426E-03_JPRB, 0.37837454E-03_JPRB, &
  & 0.37899522E-03_JPRB, 0.37915194E-03_JPRB, 0.37882469E-03_JPRB, 0.37833527E-03_JPRB, 0.37795567E-03_JPRB, 0.37766663E-03_JPRB, &
  & 0.37736846E-03_JPRB, 0.37704192E-03_JPRB, 0.37672235E-03_JPRB, 0.37639123E-03_JPRB, 0.37606829E-03_JPRB, 0.37573988E-03_JPRB, &
  & 0.37531070E-03_JPRB, 0.37481987E-03_JPRB, 0.37442283E-03_JPRB, 0.37416881E-03_JPRB, 0.37399178E-03_JPRB, 0.37383722E-03_JPRB, &
  & 0.37369474E-03_JPRB, 0.37358232E-03_JPRB, 0.37349563E-03_JPRB, 0.37344582E-03_JPRB, 0.37343270E-03_JPRB, 0.37343927E-03_JPRB, &
  & 0.37345152E-03_JPRB, 0.37345114E-03_JPRB, 0.37343720E-03_JPRB, 0.37340399E-03_JPRB, 0.37336356E-03_JPRB, 0.37331899E-03_JPRB, &
  & 0.37327917E-03_JPRB, 0.37325129E-03_JPRB, 0.37323345E-03_JPRB, 0.37323254E-03_JPRB  /)

RGHG1(:,22, 6) = (/ &
  & 0.37408387E-03_JPRB, 0.37403662E-03_JPRB, 0.37397053E-03_JPRB, 0.37389319E-03_JPRB, 0.37380092E-03_JPRB, 0.37370991E-03_JPRB, &
  & 0.37363559E-03_JPRB, 0.37359850E-03_JPRB, 0.37360803E-03_JPRB, 0.37367413E-03_JPRB, 0.37377901E-03_JPRB, 0.37393197E-03_JPRB, &
  & 0.37414597E-03_JPRB, 0.37439628E-03_JPRB, 0.37462706E-03_JPRB, 0.37478226E-03_JPRB, 0.37488112E-03_JPRB, 0.37492321E-03_JPRB, &
  & 0.37498776E-03_JPRB, 0.37511127E-03_JPRB, 0.37526355E-03_JPRB, 0.37548074E-03_JPRB, 0.37573863E-03_JPRB, 0.37602086E-03_JPRB, &
  & 0.37632565E-03_JPRB, 0.37664876E-03_JPRB, 0.37701116E-03_JPRB, 0.37745942E-03_JPRB, 0.37812779E-03_JPRB, 0.37900525E-03_JPRB, &
  & 0.37961748E-03_JPRB, 0.37974763E-03_JPRB, 0.37941571E-03_JPRB, 0.37893463E-03_JPRB, 0.37858461E-03_JPRB, 0.37833793E-03_JPRB, &
  & 0.37805811E-03_JPRB, 0.37774112E-03_JPRB, 0.37743545E-03_JPRB, 0.37714224E-03_JPRB, 0.37683953E-03_JPRB, 0.37649579E-03_JPRB, &
  & 0.37603981E-03_JPRB, 0.37554331E-03_JPRB, 0.37516384E-03_JPRB, 0.37493750E-03_JPRB, 0.37476302E-03_JPRB, 0.37457912E-03_JPRB, &
  & 0.37441640E-03_JPRB, 0.37429720E-03_JPRB, 0.37420884E-03_JPRB, 0.37414569E-03_JPRB, 0.37410966E-03_JPRB, 0.37410289E-03_JPRB, &
  & 0.37410069E-03_JPRB, 0.37407463E-03_JPRB, 0.37403067E-03_JPRB, 0.37396989E-03_JPRB, 0.37390411E-03_JPRB, 0.37384397E-03_JPRB, &
  & 0.37378748E-03_JPRB, 0.37375381E-03_JPRB, 0.37373053E-03_JPRB, 0.37372851E-03_JPRB  /)

RGHG1(:,23, 6) = (/ &
  & 0.37443076E-03_JPRB, 0.37437569E-03_JPRB, 0.37429842E-03_JPRB, 0.37420176E-03_JPRB, 0.37409775E-03_JPRB, 0.37399941E-03_JPRB, &
  & 0.37392309E-03_JPRB, 0.37388603E-03_JPRB, 0.37390055E-03_JPRB, 0.37398289E-03_JPRB, 0.37410947E-03_JPRB, 0.37428074E-03_JPRB, &
  & 0.37451239E-03_JPRB, 0.37476978E-03_JPRB, 0.37500569E-03_JPRB, 0.37516849E-03_JPRB, 0.37527076E-03_JPRB, 0.37532045E-03_JPRB, &
  & 0.37538710E-03_JPRB, 0.37552367E-03_JPRB, 0.37568606E-03_JPRB, 0.37588666E-03_JPRB, 0.37612835E-03_JPRB, 0.37643299E-03_JPRB, &
  & 0.37677348E-03_JPRB, 0.37711969E-03_JPRB, 0.37751620E-03_JPRB, 0.37802652E-03_JPRB, 0.37878511E-03_JPRB, 0.37964824E-03_JPRB, &
  & 0.38017506E-03_JPRB, 0.38024049E-03_JPRB, 0.37991839E-03_JPRB, 0.37950157E-03_JPRB, 0.37921634E-03_JPRB, 0.37901688E-03_JPRB, &
  & 0.37876867E-03_JPRB, 0.37847045E-03_JPRB, 0.37817687E-03_JPRB, 0.37792463E-03_JPRB, 0.37765339E-03_JPRB, 0.37728554E-03_JPRB, &
  & 0.37681637E-03_JPRB, 0.37633268E-03_JPRB, 0.37595147E-03_JPRB, 0.37572215E-03_JPRB, 0.37552125E-03_JPRB, 0.37531432E-03_JPRB, &
  & 0.37514817E-03_JPRB, 0.37502847E-03_JPRB, 0.37493205E-03_JPRB, 0.37485643E-03_JPRB, 0.37480757E-03_JPRB, 0.37477312E-03_JPRB, &
  & 0.37474258E-03_JPRB, 0.37469682E-03_JPRB, 0.37463869E-03_JPRB, 0.37456454E-03_JPRB, 0.37448724E-03_JPRB, 0.37442561E-03_JPRB, &
  & 0.37437158E-03_JPRB, 0.37433072E-03_JPRB, 0.37430018E-03_JPRB, 0.37429176E-03_JPRB  /)

RGHG1(:,24, 6) = (/ &
  & 0.37471325E-03_JPRB, 0.37465412E-03_JPRB, 0.37457002E-03_JPRB, 0.37445703E-03_JPRB, 0.37434106E-03_JPRB, 0.37423734E-03_JPRB, &
  & 0.37416351E-03_JPRB, 0.37413043E-03_JPRB, 0.37415490E-03_JPRB, 0.37425730E-03_JPRB, 0.37440654E-03_JPRB, 0.37460003E-03_JPRB, &
  & 0.37485047E-03_JPRB, 0.37511654E-03_JPRB, 0.37536123E-03_JPRB, 0.37552891E-03_JPRB, 0.37563073E-03_JPRB, 0.37569182E-03_JPRB, &
  & 0.37577274E-03_JPRB, 0.37594151E-03_JPRB, 0.37614296E-03_JPRB, 0.37635627E-03_JPRB, 0.37661887E-03_JPRB, 0.37697114E-03_JPRB, &
  & 0.37735632E-03_JPRB, 0.37772380E-03_JPRB, 0.37813741E-03_JPRB, 0.37867814E-03_JPRB, 0.37948320E-03_JPRB, 0.38029186E-03_JPRB, &
  & 0.38071360E-03_JPRB, 0.38071364E-03_JPRB, 0.38041295E-03_JPRB, 0.38007435E-03_JPRB, 0.37985828E-03_JPRB, 0.37970239E-03_JPRB, &
  & 0.37947978E-03_JPRB, 0.37919644E-03_JPRB, 0.37891781E-03_JPRB, 0.37870225E-03_JPRB, 0.37845134E-03_JPRB, 0.37806052E-03_JPRB, &
  & 0.37759153E-03_JPRB, 0.37711950E-03_JPRB, 0.37672623E-03_JPRB, 0.37647554E-03_JPRB, 0.37624435E-03_JPRB, 0.37602628E-03_JPRB, &
  & 0.37586423E-03_JPRB, 0.37574183E-03_JPRB, 0.37563185E-03_JPRB, 0.37554254E-03_JPRB, 0.37548054E-03_JPRB, 0.37541747E-03_JPRB, &
  & 0.37535874E-03_JPRB, 0.37529544E-03_JPRB, 0.37522916E-03_JPRB, 0.37515010E-03_JPRB, 0.37506838E-03_JPRB, 0.37501001E-03_JPRB, &
  & 0.37496433E-03_JPRB, 0.37492033E-03_JPRB, 0.37488515E-03_JPRB, 0.37487571E-03_JPRB  /)

RGHG1(:,25, 6) = (/ &
  & 0.37489707E-03_JPRB, 0.37484048E-03_JPRB, 0.37475808E-03_JPRB, 0.37463568E-03_JPRB, 0.37450635E-03_JPRB, 0.37439802E-03_JPRB, &
  & 0.37433134E-03_JPRB, 0.37430663E-03_JPRB, 0.37434728E-03_JPRB, 0.37447367E-03_JPRB, 0.37464427E-03_JPRB, 0.37486532E-03_JPRB, &
  & 0.37513486E-03_JPRB, 0.37540958E-03_JPRB, 0.37566603E-03_JPRB, 0.37583183E-03_JPRB, 0.37592763E-03_JPRB, 0.37600198E-03_JPRB, &
  & 0.37611141E-03_JPRB, 0.37633389E-03_JPRB, 0.37660759E-03_JPRB, 0.37687077E-03_JPRB, 0.37720608E-03_JPRB, 0.37764039E-03_JPRB, &
  & 0.37808455E-03_JPRB, 0.37847611E-03_JPRB, 0.37888125E-03_JPRB, 0.37940092E-03_JPRB, 0.38018754E-03_JPRB, 0.38090485E-03_JPRB, &
  & 0.38120871E-03_JPRB, 0.38115372E-03_JPRB, 0.38089075E-03_JPRB, 0.38063898E-03_JPRB, 0.38048876E-03_JPRB, 0.38036694E-03_JPRB, &
  & 0.38015514E-03_JPRB, 0.37987707E-03_JPRB, 0.37961820E-03_JPRB, 0.37942935E-03_JPRB, 0.37917562E-03_JPRB, 0.37876683E-03_JPRB, &
  & 0.37831863E-03_JPRB, 0.37785159E-03_JPRB, 0.37743282E-03_JPRB, 0.37713604E-03_JPRB, 0.37687559E-03_JPRB, 0.37666656E-03_JPRB, &
  & 0.37651795E-03_JPRB, 0.37638765E-03_JPRB, 0.37625641E-03_JPRB, 0.37615167E-03_JPRB, 0.37607434E-03_JPRB, 0.37598549E-03_JPRB, &
  & 0.37590325E-03_JPRB, 0.37582564E-03_JPRB, 0.37575871E-03_JPRB, 0.37568670E-03_JPRB, 0.37561025E-03_JPRB, 0.37556026E-03_JPRB, &
  & 0.37552868E-03_JPRB, 0.37548920E-03_JPRB, 0.37545458E-03_JPRB, 0.37545493E-03_JPRB  /)

RGHG1(:,26, 6) = (/ &
  & 0.37501739E-03_JPRB, 0.37498317E-03_JPRB, 0.37491403E-03_JPRB, 0.37479326E-03_JPRB, 0.37465225E-03_JPRB, 0.37452567E-03_JPRB, &
  & 0.37445238E-03_JPRB, 0.37443543E-03_JPRB, 0.37449396E-03_JPRB, 0.37463909E-03_JPRB, 0.37482928E-03_JPRB, 0.37507664E-03_JPRB, &
  & 0.37536041E-03_JPRB, 0.37564372E-03_JPRB, 0.37590411E-03_JPRB, 0.37606372E-03_JPRB, 0.37616060E-03_JPRB, 0.37624983E-03_JPRB, &
  & 0.37638693E-03_JPRB, 0.37664678E-03_JPRB, 0.37697515E-03_JPRB, 0.37729681E-03_JPRB, 0.37769325E-03_JPRB, 0.37821620E-03_JPRB, &
  & 0.37874789E-03_JPRB, 0.37918269E-03_JPRB, 0.37958834E-03_JPRB, 0.38007330E-03_JPRB, 0.38080551E-03_JPRB, 0.38145608E-03_JPRB, &
  & 0.38168149E-03_JPRB, 0.38159610E-03_JPRB, 0.38136811E-03_JPRB, 0.38117892E-03_JPRB, 0.38107104E-03_JPRB, 0.38096545E-03_JPRB, &
  & 0.38074960E-03_JPRB, 0.38046492E-03_JPRB, 0.38023204E-03_JPRB, 0.38004808E-03_JPRB, 0.37977087E-03_JPRB, 0.37936593E-03_JPRB, &
  & 0.37893501E-03_JPRB, 0.37846233E-03_JPRB, 0.37802115E-03_JPRB, 0.37769078E-03_JPRB, 0.37741617E-03_JPRB, 0.37721124E-03_JPRB, &
  & 0.37706126E-03_JPRB, 0.37691761E-03_JPRB, 0.37677213E-03_JPRB, 0.37665306E-03_JPRB, 0.37655703E-03_JPRB, 0.37645374E-03_JPRB, &
  & 0.37635958E-03_JPRB, 0.37628083E-03_JPRB, 0.37622278E-03_JPRB, 0.37615968E-03_JPRB, 0.37608343E-03_JPRB, 0.37602795E-03_JPRB, &
  & 0.37599585E-03_JPRB, 0.37595904E-03_JPRB, 0.37592655E-03_JPRB, 0.37594266E-03_JPRB  /)

RGHG1(:,27, 6) = (/ &
  & 0.37511965E-03_JPRB, 0.37511615E-03_JPRB, 0.37506518E-03_JPRB, 0.37495021E-03_JPRB, 0.37479761E-03_JPRB, 0.37464689E-03_JPRB, &
  & 0.37456157E-03_JPRB, 0.37455253E-03_JPRB, 0.37463036E-03_JPRB, 0.37479313E-03_JPRB, 0.37500316E-03_JPRB, 0.37527756E-03_JPRB, &
  & 0.37557441E-03_JPRB, 0.37586667E-03_JPRB, 0.37612829E-03_JPRB, 0.37627982E-03_JPRB, 0.37638048E-03_JPRB, 0.37648586E-03_JPRB, &
  & 0.37665158E-03_JPRB, 0.37694443E-03_JPRB, 0.37732345E-03_JPRB, 0.37770944E-03_JPRB, 0.37816548E-03_JPRB, 0.37878359E-03_JPRB, &
  & 0.37941736E-03_JPRB, 0.37990448E-03_JPRB, 0.38031399E-03_JPRB, 0.38075761E-03_JPRB, 0.38141960E-03_JPRB, 0.38200951E-03_JPRB, &
  & 0.38216751E-03_JPRB, 0.38205947E-03_JPRB, 0.38186703E-03_JPRB, 0.38173429E-03_JPRB, 0.38166196E-03_JPRB, 0.38156672E-03_JPRB, &
  & 0.38134113E-03_JPRB, 0.38104512E-03_JPRB, 0.38084174E-03_JPRB, 0.38065479E-03_JPRB, 0.38034537E-03_JPRB, 0.37995254E-03_JPRB, &
  & 0.37953838E-03_JPRB, 0.37905588E-03_JPRB, 0.37859240E-03_JPRB, 0.37823158E-03_JPRB, 0.37794775E-03_JPRB, 0.37774527E-03_JPRB, &
  & 0.37758836E-03_JPRB, 0.37742874E-03_JPRB, 0.37727096E-03_JPRB, 0.37713733E-03_JPRB, 0.37702049E-03_JPRB, 0.37690632E-03_JPRB, &
  & 0.37680399E-03_JPRB, 0.37672893E-03_JPRB, 0.37668369E-03_JPRB, 0.37663060E-03_JPRB, 0.37655268E-03_JPRB, 0.37648632E-03_JPRB, &
  & 0.37644825E-03_JPRB, 0.37641354E-03_JPRB, 0.37638386E-03_JPRB, 0.37641867E-03_JPRB  /)

RGHG1(:,28, 6) = (/ &
  & 0.37523647E-03_JPRB, 0.37525390E-03_JPRB, 0.37521705E-03_JPRB, 0.37510609E-03_JPRB, 0.37494780E-03_JPRB, 0.37478258E-03_JPRB, &
  & 0.37467829E-03_JPRB, 0.37467014E-03_JPRB, 0.37476024E-03_JPRB, 0.37493346E-03_JPRB, 0.37516299E-03_JPRB, 0.37545439E-03_JPRB, &
  & 0.37575671E-03_JPRB, 0.37605318E-03_JPRB, 0.37630932E-03_JPRB, 0.37645973E-03_JPRB, 0.37657226E-03_JPRB, 0.37669270E-03_JPRB, &
  & 0.37688101E-03_JPRB, 0.37721346E-03_JPRB, 0.37762404E-03_JPRB, 0.37802800E-03_JPRB, 0.37846316E-03_JPRB, 0.37907801E-03_JPRB, &
  & 0.37976356E-03_JPRB, 0.38034733E-03_JPRB, 0.38083848E-03_JPRB, 0.38132437E-03_JPRB, 0.38195586E-03_JPRB, 0.38250189E-03_JPRB, &
  & 0.38265512E-03_JPRB, 0.38255566E-03_JPRB, 0.38237547E-03_JPRB, 0.38224938E-03_JPRB, 0.38218529E-03_JPRB, 0.38209381E-03_JPRB, &
  & 0.38186449E-03_JPRB, 0.38155770E-03_JPRB, 0.38133159E-03_JPRB, 0.38111511E-03_JPRB, 0.38078985E-03_JPRB, 0.38040784E-03_JPRB, &
  & 0.37997978E-03_JPRB, 0.37949456E-03_JPRB, 0.37904389E-03_JPRB, 0.37868719E-03_JPRB, 0.37840664E-03_JPRB, 0.37819050E-03_JPRB, &
  & 0.37800557E-03_JPRB, 0.37782478E-03_JPRB, 0.37765706E-03_JPRB, 0.37752125E-03_JPRB, 0.37739667E-03_JPRB, 0.37728186E-03_JPRB, &
  & 0.37719021E-03_JPRB, 0.37711995E-03_JPRB, 0.37706284E-03_JPRB, 0.37699841E-03_JPRB, 0.37691242E-03_JPRB, 0.37683522E-03_JPRB, &
  & 0.37677252E-03_JPRB, 0.37671299E-03_JPRB, 0.37666792E-03_JPRB, 0.37669006E-03_JPRB  /)

RGHG1(:,29, 6) = (/ &
  & 0.37536087E-03_JPRB, 0.37540007E-03_JPRB, 0.37537800E-03_JPRB, 0.37527121E-03_JPRB, 0.37510714E-03_JPRB, 0.37492698E-03_JPRB, &
  & 0.37480230E-03_JPRB, 0.37479479E-03_JPRB, 0.37489758E-03_JPRB, 0.37508156E-03_JPRB, 0.37533172E-03_JPRB, 0.37564072E-03_JPRB, &
  & 0.37594850E-03_JPRB, 0.37624923E-03_JPRB, 0.37649926E-03_JPRB, 0.37664879E-03_JPRB, 0.37677425E-03_JPRB, 0.37691058E-03_JPRB, &
  & 0.37712260E-03_JPRB, 0.37749729E-03_JPRB, 0.37794048E-03_JPRB, 0.37836146E-03_JPRB, 0.37877100E-03_JPRB, 0.37937814E-03_JPRB, &
  & 0.38011638E-03_JPRB, 0.38080447E-03_JPRB, 0.38138549E-03_JPRB, 0.38191982E-03_JPRB, 0.38252070E-03_JPRB, 0.38302095E-03_JPRB, &
  & 0.38317186E-03_JPRB, 0.38308284E-03_JPRB, 0.38291461E-03_JPRB, 0.38279342E-03_JPRB, 0.38273688E-03_JPRB, 0.38264910E-03_JPRB, &
  & 0.38241608E-03_JPRB, 0.38209789E-03_JPRB, 0.38184543E-03_JPRB, 0.38159651E-03_JPRB, 0.38125519E-03_JPRB, 0.38088458E-03_JPRB, &
  & 0.38044046E-03_JPRB, 0.37995266E-03_JPRB, 0.37951710E-03_JPRB, 0.37916626E-03_JPRB, 0.37888972E-03_JPRB, 0.37865840E-03_JPRB, &
  & 0.37844287E-03_JPRB, 0.37823944E-03_JPRB, 0.37806127E-03_JPRB, 0.37792370E-03_JPRB, 0.37779149E-03_JPRB, 0.37767644E-03_JPRB, &
  & 0.37759692E-03_JPRB, 0.37753180E-03_JPRB, 0.37746103E-03_JPRB, 0.37738368E-03_JPRB, 0.37728885E-03_JPRB, 0.37720016E-03_JPRB, &
  & 0.37711056E-03_JPRB, 0.37702356E-03_JPRB, 0.37696138E-03_JPRB, 0.37696875E-03_JPRB  /)

RGHG1(:,30, 6) = (/ &
  & 0.37570599E-03_JPRB, 0.37573724E-03_JPRB, 0.37569246E-03_JPRB, 0.37555837E-03_JPRB, 0.37536946E-03_JPRB, 0.37516029E-03_JPRB, &
  & 0.37503262E-03_JPRB, 0.37502752E-03_JPRB, 0.37512763E-03_JPRB, 0.37531114E-03_JPRB, 0.37556802E-03_JPRB, 0.37588317E-03_JPRB, &
  & 0.37619822E-03_JPRB, 0.37650044E-03_JPRB, 0.37675201E-03_JPRB, 0.37692094E-03_JPRB, 0.37706264E-03_JPRB, 0.37720054E-03_JPRB, &
  & 0.37743000E-03_JPRB, 0.37785300E-03_JPRB, 0.37831512E-03_JPRB, 0.37873894E-03_JPRB, 0.37916842E-03_JPRB, 0.37971996E-03_JPRB, &
  & 0.38043137E-03_JPRB, 0.38115314E-03_JPRB, 0.38181452E-03_JPRB, 0.38242234E-03_JPRB, 0.38303414E-03_JPRB, 0.38350281E-03_JPRB, &
  & 0.38367932E-03_JPRB, 0.38363194E-03_JPRB, 0.38348559E-03_JPRB, 0.38336526E-03_JPRB, 0.38330061E-03_JPRB, 0.38321007E-03_JPRB, &
  & 0.38298503E-03_JPRB, 0.38265201E-03_JPRB, 0.38233984E-03_JPRB, 0.38203670E-03_JPRB, 0.38167893E-03_JPRB, 0.38129330E-03_JPRB, &
  & 0.38081707E-03_JPRB, 0.38033407E-03_JPRB, 0.37995432E-03_JPRB, 0.37963263E-03_JPRB, 0.37935983E-03_JPRB, 0.37911298E-03_JPRB, &
  & 0.37887640E-03_JPRB, 0.37864973E-03_JPRB, 0.37844404E-03_JPRB, 0.37828763E-03_JPRB, 0.37815139E-03_JPRB, 0.37803478E-03_JPRB, &
  & 0.37795118E-03_JPRB, 0.37787055E-03_JPRB, 0.37776096E-03_JPRB, 0.37764535E-03_JPRB, 0.37752929E-03_JPRB, 0.37741793E-03_JPRB, &
  & 0.37731554E-03_JPRB, 0.37722005E-03_JPRB, 0.37711750E-03_JPRB, 0.37706171E-03_JPRB  /)

RGHG1(:,31, 6) = (/ &
  & 0.37606984E-03_JPRB, 0.37609268E-03_JPRB, 0.37602394E-03_JPRB, 0.37586106E-03_JPRB, 0.37564595E-03_JPRB, 0.37540621E-03_JPRB, &
  & 0.37527541E-03_JPRB, 0.37527283E-03_JPRB, 0.37537012E-03_JPRB, 0.37555310E-03_JPRB, 0.37581706E-03_JPRB, 0.37613868E-03_JPRB, &
  & 0.37646139E-03_JPRB, 0.37676517E-03_JPRB, 0.37701839E-03_JPRB, 0.37720778E-03_JPRB, 0.37736659E-03_JPRB, 0.37750613E-03_JPRB, &
  & 0.37775397E-03_JPRB, 0.37822785E-03_JPRB, 0.37870992E-03_JPRB, 0.37913672E-03_JPRB, 0.37958725E-03_JPRB, 0.38008016E-03_JPRB, &
  & 0.38076322E-03_JPRB, 0.38152041E-03_JPRB, 0.38226647E-03_JPRB, 0.38295174E-03_JPRB, 0.38357507E-03_JPRB, 0.38401048E-03_JPRB, &
  & 0.38421400E-03_JPRB, 0.38421052E-03_JPRB, 0.38408724E-03_JPRB, 0.38396780E-03_JPRB, 0.38389459E-03_JPRB, 0.38380116E-03_JPRB, &
  & 0.38358452E-03_JPRB, 0.38323587E-03_JPRB, 0.38286076E-03_JPRB, 0.38250048E-03_JPRB, 0.38212536E-03_JPRB, 0.38172389E-03_JPRB, &
  & 0.38121380E-03_JPRB, 0.38073586E-03_JPRB, 0.38041497E-03_JPRB, 0.38012400E-03_JPRB, 0.37985516E-03_JPRB, 0.37959193E-03_JPRB, &
  & 0.37933317E-03_JPRB, 0.37908203E-03_JPRB, 0.37884732E-03_JPRB, 0.37867104E-03_JPRB, 0.37853056E-03_JPRB, 0.37841232E-03_JPRB, &
  & 0.37832440E-03_JPRB, 0.37822740E-03_JPRB, 0.37807689E-03_JPRB, 0.37792095E-03_JPRB, 0.37778249E-03_JPRB, 0.37764725E-03_JPRB, &
  & 0.37753139E-03_JPRB, 0.37742698E-03_JPRB, 0.37728186E-03_JPRB, 0.37715948E-03_JPRB  /)

RGHG1(:,32, 6) = (/ &
  & 0.37675366E-03_JPRB, 0.37674718E-03_JPRB, 0.37662236E-03_JPRB, 0.37643922E-03_JPRB, 0.37617318E-03_JPRB, 0.37587392E-03_JPRB, &
  & 0.37572325E-03_JPRB, 0.37570982E-03_JPRB, 0.37579224E-03_JPRB, 0.37595995E-03_JPRB, 0.37621210E-03_JPRB, 0.37653067E-03_JPRB, &
  & 0.37686028E-03_JPRB, 0.37717681E-03_JPRB, 0.37743542E-03_JPRB, 0.37765613E-03_JPRB, 0.37783457E-03_JPRB, 0.37799022E-03_JPRB, &
  & 0.37826064E-03_JPRB, 0.37875436E-03_JPRB, 0.37925402E-03_JPRB, 0.37970206E-03_JPRB, 0.38017798E-03_JPRB, 0.38067446E-03_JPRB, &
  & 0.38131580E-03_JPRB, 0.38201756E-03_JPRB, 0.38271292E-03_JPRB, 0.38339049E-03_JPRB, 0.38400120E-03_JPRB, 0.38443741E-03_JPRB, &
  & 0.38468897E-03_JPRB, 0.38476205E-03_JPRB, 0.38471242E-03_JPRB, 0.38462111E-03_JPRB, 0.38454552E-03_JPRB, 0.38444403E-03_JPRB, &
  & 0.38422257E-03_JPRB, 0.38387124E-03_JPRB, 0.38348262E-03_JPRB, 0.38310385E-03_JPRB, 0.38272011E-03_JPRB, 0.38232233E-03_JPRB, &
  & 0.38181065E-03_JPRB, 0.38133860E-03_JPRB, 0.38102063E-03_JPRB, 0.38073391E-03_JPRB, 0.38046849E-03_JPRB, 0.38018333E-03_JPRB, &
  & 0.37990038E-03_JPRB, 0.37962634E-03_JPRB, 0.37937080E-03_JPRB, 0.37916243E-03_JPRB, 0.37899465E-03_JPRB, 0.37884844E-03_JPRB, &
  & 0.37872386E-03_JPRB, 0.37858222E-03_JPRB, 0.37838831E-03_JPRB, 0.37819095E-03_JPRB, 0.37803341E-03_JPRB, 0.37789217E-03_JPRB, &
  & 0.37776152E-03_JPRB, 0.37763498E-03_JPRB, 0.37748215E-03_JPRB, 0.37735401E-03_JPRB  /)

RGHG1(:,33, 6) = (/ &
  & 0.37750576E-03_JPRB, 0.37746609E-03_JPRB, 0.37727883E-03_JPRB, 0.37707574E-03_JPRB, 0.37675356E-03_JPRB, 0.37638871E-03_JPRB, &
  & 0.37621522E-03_JPRB, 0.37618876E-03_JPRB, 0.37625418E-03_JPRB, 0.37640411E-03_JPRB, 0.37664156E-03_JPRB, 0.37695572E-03_JPRB, &
  & 0.37729240E-03_JPRB, 0.37762363E-03_JPRB, 0.37788833E-03_JPRB, 0.37814299E-03_JPRB, 0.37834215E-03_JPRB, 0.37851642E-03_JPRB, &
  & 0.37881085E-03_JPRB, 0.37932116E-03_JPRB, 0.37983881E-03_JPRB, 0.38031128E-03_JPRB, 0.38081415E-03_JPRB, 0.38132239E-03_JPRB, &
  & 0.38191865E-03_JPRB, 0.38255104E-03_JPRB, 0.38317619E-03_JPRB, 0.38383471E-03_JPRB, 0.38442918E-03_JPRB, 0.38487065E-03_JPRB, &
  & 0.38517485E-03_JPRB, 0.38533172E-03_JPRB, 0.38536518E-03_JPRB, 0.38530663E-03_JPRB, 0.38522936E-03_JPRB, 0.38511884E-03_JPRB, &
  & 0.38489066E-03_JPRB, 0.38453821E-03_JPRB, 0.38414196E-03_JPRB, 0.38374898E-03_JPRB, 0.38335740E-03_JPRB, 0.38296599E-03_JPRB, &
  & 0.38245683E-03_JPRB, 0.38199101E-03_JPRB, 0.38166884E-03_JPRB, 0.38138310E-03_JPRB, 0.38112119E-03_JPRB, 0.38081250E-03_JPRB, &
  & 0.38050414E-03_JPRB, 0.38020651E-03_JPRB, 0.37993039E-03_JPRB, 0.37968709E-03_JPRB, 0.37948795E-03_JPRB, 0.37930925E-03_JPRB, &
  & 0.37914240E-03_JPRB, 0.37895071E-03_JPRB, 0.37871136E-03_JPRB, 0.37847081E-03_JPRB, 0.37829389E-03_JPRB, 0.37814873E-03_JPRB, &
  & 0.37800254E-03_JPRB, 0.37785128E-03_JPRB, 0.37769496E-03_JPRB, 0.37756870E-03_JPRB  /)

RGHG1(:,34, 6) = (/ &
  & 0.37837602E-03_JPRB, 0.37831284E-03_JPRB, 0.37805974E-03_JPRB, 0.37783833E-03_JPRB, 0.37748856E-03_JPRB, 0.37707284E-03_JPRB, &
  & 0.37685766E-03_JPRB, 0.37680364E-03_JPRB, 0.37684666E-03_JPRB, 0.37697457E-03_JPRB, 0.37718302E-03_JPRB, 0.37747148E-03_JPRB, &
  & 0.37780659E-03_JPRB, 0.37815452E-03_JPRB, 0.37842689E-03_JPRB, 0.37870714E-03_JPRB, 0.37893229E-03_JPRB, 0.37914028E-03_JPRB, &
  & 0.37945792E-03_JPRB, 0.37995445E-03_JPRB, 0.38046613E-03_JPRB, 0.38095482E-03_JPRB, 0.38145293E-03_JPRB, 0.38193242E-03_JPRB, &
  & 0.38245964E-03_JPRB, 0.38301705E-03_JPRB, 0.38356450E-03_JPRB, 0.38414731E-03_JPRB, 0.38469419E-03_JPRB, 0.38513226E-03_JPRB, &
  & 0.38547447E-03_JPRB, 0.38572498E-03_JPRB, 0.38586323E-03_JPRB, 0.38588184E-03_JPRB, 0.38584388E-03_JPRB, 0.38574085E-03_JPRB, &
  & 0.38550454E-03_JPRB, 0.38516048E-03_JPRB, 0.38479153E-03_JPRB, 0.38443255E-03_JPRB, 0.38407009E-03_JPRB, 0.38369336E-03_JPRB, &
  & 0.38320628E-03_JPRB, 0.38273529E-03_JPRB, 0.38236595E-03_JPRB, 0.38203890E-03_JPRB, 0.38175640E-03_JPRB, 0.38143643E-03_JPRB, &
  & 0.38110527E-03_JPRB, 0.38077568E-03_JPRB, 0.38049491E-03_JPRB, 0.38022700E-03_JPRB, 0.37998644E-03_JPRB, 0.37976974E-03_JPRB, &
  & 0.37956538E-03_JPRB, 0.37934194E-03_JPRB, 0.37906741E-03_JPRB, 0.37878314E-03_JPRB, 0.37858345E-03_JPRB, 0.37843530E-03_JPRB, &
  & 0.37828853E-03_JPRB, 0.37812538E-03_JPRB, 0.37797653E-03_JPRB, 0.37788614E-03_JPRB  /)

RGHG1(:,35, 6) = (/ &
  & 0.37933141E-03_JPRB, 0.37924900E-03_JPRB, 0.37892646E-03_JPRB, 0.37868705E-03_JPRB, 0.37832358E-03_JPRB, 0.37786310E-03_JPRB, &
  & 0.37759537E-03_JPRB, 0.37750557E-03_JPRB, 0.37752279E-03_JPRB, 0.37762589E-03_JPRB, 0.37779719E-03_JPRB, 0.37804829E-03_JPRB, &
  & 0.37837737E-03_JPRB, 0.37874349E-03_JPRB, 0.37902456E-03_JPRB, 0.37932683E-03_JPRB, 0.37958140E-03_JPRB, 0.37983182E-03_JPRB, &
  & 0.38017290E-03_JPRB, 0.38063968E-03_JPRB, 0.38113291E-03_JPRB, 0.38163407E-03_JPRB, 0.38211101E-03_JPRB, 0.38254016E-03_JPRB, &
  & 0.38298410E-03_JPRB, 0.38346155E-03_JPRB, 0.38392527E-03_JPRB, 0.38440117E-03_JPRB, 0.38488302E-03_JPRB, 0.38531317E-03_JPRB, &
  & 0.38568695E-03_JPRB, 0.38603879E-03_JPRB, 0.38629591E-03_JPRB, 0.38641663E-03_JPRB, 0.38644012E-03_JPRB, 0.38635327E-03_JPRB, &
  & 0.38610786E-03_JPRB, 0.38577731E-03_JPRB, 0.38545435E-03_JPRB, 0.38515506E-03_JPRB, 0.38484152E-03_JPRB, 0.38448415E-03_JPRB, &
  & 0.38402980E-03_JPRB, 0.38354764E-03_JPRB, 0.38310776E-03_JPRB, 0.38271653E-03_JPRB, 0.38240051E-03_JPRB, 0.38207521E-03_JPRB, &
  & 0.38172197E-03_JPRB, 0.38135523E-03_JPRB, 0.38107783E-03_JPRB, 0.38078991E-03_JPRB, 0.38050161E-03_JPRB, 0.38024302E-03_JPRB, &
  & 0.38000254E-03_JPRB, 0.37975584E-03_JPRB, 0.37945039E-03_JPRB, 0.37912092E-03_JPRB, 0.37889609E-03_JPRB, 0.37874534E-03_JPRB, &
  & 0.37860565E-03_JPRB, 0.37843685E-03_JPRB, 0.37830131E-03_JPRB, 0.37826523E-03_JPRB  /)

RGHG1(:,36, 6) = (/ &
  & 0.38034832E-03_JPRB, 0.38025579E-03_JPRB, 0.37987706E-03_JPRB, 0.37959504E-03_JPRB, 0.37921269E-03_JPRB, 0.37871472E-03_JPRB, &
  & 0.37837981E-03_JPRB, 0.37824752E-03_JPRB, 0.37823447E-03_JPRB, 0.37830964E-03_JPRB, 0.37844241E-03_JPRB, 0.37865045E-03_JPRB, &
  & 0.37896555E-03_JPRB, 0.37934105E-03_JPRB, 0.37963463E-03_JPRB, 0.37995390E-03_JPRB, 0.38023554E-03_JPRB, 0.38051448E-03_JPRB, &
  & 0.38086424E-03_JPRB, 0.38129387E-03_JPRB, 0.38176354E-03_JPRB, 0.38226763E-03_JPRB, 0.38272023E-03_JPRB, 0.38309151E-03_JPRB, &
  & 0.38344265E-03_JPRB, 0.38383753E-03_JPRB, 0.38422356E-03_JPRB, 0.38460574E-03_JPRB, 0.38502730E-03_JPRB, 0.38544583E-03_JPRB, &
  & 0.38584595E-03_JPRB, 0.38628435E-03_JPRB, 0.38664570E-03_JPRB, 0.38686235E-03_JPRB, 0.38695633E-03_JPRB, 0.38690271E-03_JPRB, &
  & 0.38666907E-03_JPRB, 0.38635440E-03_JPRB, 0.38606357E-03_JPRB, 0.38580657E-03_JPRB, 0.38554283E-03_JPRB, 0.38521346E-03_JPRB, &
  & 0.38479691E-03_JPRB, 0.38431864E-03_JPRB, 0.38383095E-03_JPRB, 0.38338052E-03_JPRB, 0.38302420E-03_JPRB, 0.38268363E-03_JPRB, &
  & 0.38231156E-03_JPRB, 0.38192275E-03_JPRB, 0.38164670E-03_JPRB, 0.38134584E-03_JPRB, 0.38101822E-03_JPRB, 0.38073216E-03_JPRB, &
  & 0.38046129E-03_JPRB, 0.38018686E-03_JPRB, 0.37985618E-03_JPRB, 0.37949277E-03_JPRB, 0.37925043E-03_JPRB, 0.37909361E-03_JPRB, &
  & 0.37895835E-03_JPRB, 0.37878548E-03_JPRB, 0.37867192E-03_JPRB, 0.37869409E-03_JPRB  /)

RGHG1(:,37, 6) = (/ &
  & 0.38144303E-03_JPRB, 0.38136189E-03_JPRB, 0.38096086E-03_JPRB, 0.38058242E-03_JPRB, 0.38017050E-03_JPRB, 0.37965400E-03_JPRB, &
  & 0.37922254E-03_JPRB, 0.37903509E-03_JPRB, 0.37898337E-03_JPRB, 0.37902520E-03_JPRB, 0.37911869E-03_JPRB, 0.37927324E-03_JPRB, &
  & 0.37955704E-03_JPRB, 0.37992114E-03_JPRB, 0.38023517E-03_JPRB, 0.38055888E-03_JPRB, 0.38086049E-03_JPRB, 0.38113433E-03_JPRB, &
  & 0.38145837E-03_JPRB, 0.38183619E-03_JPRB, 0.38227204E-03_JPRB, 0.38275700E-03_JPRB, 0.38317956E-03_JPRB, 0.38347930E-03_JPRB, &
  & 0.38372154E-03_JPRB, 0.38403301E-03_JPRB, 0.38436004E-03_JPRB, 0.38468459E-03_JPRB, 0.38506046E-03_JPRB, 0.38545962E-03_JPRB, &
  & 0.38587245E-03_JPRB, 0.38635817E-03_JPRB, 0.38678368E-03_JPRB, 0.38707612E-03_JPRB, 0.38725693E-03_JPRB, 0.38727359E-03_JPRB, &
  & 0.38709884E-03_JPRB, 0.38680450E-03_JPRB, 0.38651198E-03_JPRB, 0.38625474E-03_JPRB, 0.38603976E-03_JPRB, 0.38575643E-03_JPRB, &
  & 0.38538696E-03_JPRB, 0.38494689E-03_JPRB, 0.38446645E-03_JPRB, 0.38397195E-03_JPRB, 0.38356226E-03_JPRB, 0.38318457E-03_JPRB, &
  & 0.38280231E-03_JPRB, 0.38242741E-03_JPRB, 0.38214794E-03_JPRB, 0.38185116E-03_JPRB, 0.38150597E-03_JPRB, 0.38122722E-03_JPRB, &
  & 0.38094101E-03_JPRB, 0.38063030E-03_JPRB, 0.38028900E-03_JPRB, 0.37991959E-03_JPRB, 0.37967833E-03_JPRB, 0.37950784E-03_JPRB, &
  & 0.37937066E-03_JPRB, 0.37919761E-03_JPRB, 0.37912453E-03_JPRB, 0.37921038E-03_JPRB  /)

RGHG1(:,38, 6) = (/ &
  & 0.38265771E-03_JPRB, 0.38258921E-03_JPRB, 0.38216343E-03_JPRB, 0.38167800E-03_JPRB, 0.38123328E-03_JPRB, 0.38069621E-03_JPRB, &
  & 0.38015764E-03_JPRB, 0.37990897E-03_JPRB, 0.37981434E-03_JPRB, 0.37981917E-03_JPRB, 0.37986908E-03_JPRB, 0.37996428E-03_JPRB, &
  & 0.38021335E-03_JPRB, 0.38056481E-03_JPRB, 0.38090153E-03_JPRB, 0.38123016E-03_JPRB, 0.38155392E-03_JPRB, 0.38182211E-03_JPRB, &
  & 0.38211760E-03_JPRB, 0.38243794E-03_JPRB, 0.38283626E-03_JPRB, 0.38330000E-03_JPRB, 0.38368923E-03_JPRB, 0.38390959E-03_JPRB, &
  & 0.38403100E-03_JPRB, 0.38424992E-03_JPRB, 0.38451148E-03_JPRB, 0.38477208E-03_JPRB, 0.38509725E-03_JPRB, 0.38547492E-03_JPRB, &
  & 0.38590186E-03_JPRB, 0.38644007E-03_JPRB, 0.38693678E-03_JPRB, 0.38731332E-03_JPRB, 0.38759047E-03_JPRB, 0.38768511E-03_JPRB, &
  & 0.38757570E-03_JPRB, 0.38730391E-03_JPRB, 0.38700953E-03_JPRB, 0.38675203E-03_JPRB, 0.38659114E-03_JPRB, 0.38635891E-03_JPRB, &
  & 0.38604168E-03_JPRB, 0.38564399E-03_JPRB, 0.38517160E-03_JPRB, 0.38462820E-03_JPRB, 0.38415929E-03_JPRB, 0.38374041E-03_JPRB, &
  & 0.38334684E-03_JPRB, 0.38298738E-03_JPRB, 0.38270411E-03_JPRB, 0.38241186E-03_JPRB, 0.38204717E-03_JPRB, 0.38177654E-03_JPRB, &
  & 0.38147329E-03_JPRB, 0.38112233E-03_JPRB, 0.38076926E-03_JPRB, 0.38039319E-03_JPRB, 0.38015313E-03_JPRB, 0.37996747E-03_JPRB, &
  & 0.37982816E-03_JPRB, 0.37965491E-03_JPRB, 0.37962675E-03_JPRB, 0.37978325E-03_JPRB  /)

RGHG1(:,39, 6) = (/ &
  & 0.38365242E-03_JPRB, 0.38356657E-03_JPRB, 0.38311808E-03_JPRB, 0.38257635E-03_JPRB, 0.38206316E-03_JPRB, 0.38150262E-03_JPRB, &
  & 0.38090954E-03_JPRB, 0.38060136E-03_JPRB, 0.38046774E-03_JPRB, 0.38044445E-03_JPRB, 0.38048243E-03_JPRB, 0.38054615E-03_JPRB, &
  & 0.38073852E-03_JPRB, 0.38105479E-03_JPRB, 0.38140209E-03_JPRB, 0.38173170E-03_JPRB, 0.38203382E-03_JPRB, 0.38226035E-03_JPRB, &
  & 0.38251636E-03_JPRB, 0.38281181E-03_JPRB, 0.38317668E-03_JPRB, 0.38359724E-03_JPRB, 0.38393310E-03_JPRB, 0.38409006E-03_JPRB, &
  & 0.38414563E-03_JPRB, 0.38433331E-03_JPRB, 0.38455881E-03_JPRB, 0.38482533E-03_JPRB, 0.38516962E-03_JPRB, 0.38553451E-03_JPRB, &
  & 0.38598413E-03_JPRB, 0.38652733E-03_JPRB, 0.38700777E-03_JPRB, 0.38740599E-03_JPRB, 0.38772025E-03_JPRB, 0.38785156E-03_JPRB, &
  & 0.38777723E-03_JPRB, 0.38754194E-03_JPRB, 0.38725978E-03_JPRB, 0.38699104E-03_JPRB, 0.38685266E-03_JPRB, 0.38665090E-03_JPRB, &
  & 0.38636441E-03_JPRB, 0.38600521E-03_JPRB, 0.38557157E-03_JPRB, 0.38505472E-03_JPRB, 0.38458202E-03_JPRB, 0.38414150E-03_JPRB, &
  & 0.38371553E-03_JPRB, 0.38336375E-03_JPRB, 0.38308394E-03_JPRB, 0.38282517E-03_JPRB, 0.38249322E-03_JPRB, 0.38222627E-03_JPRB, &
  & 0.38193036E-03_JPRB, 0.38158581E-03_JPRB, 0.38124217E-03_JPRB, 0.38086897E-03_JPRB, 0.38063863E-03_JPRB, 0.38047068E-03_JPRB, &
  & 0.38035093E-03_JPRB, 0.38018009E-03_JPRB, 0.38013967E-03_JPRB, 0.38026931E-03_JPRB  /)

RGHG1(:,40, 6) = (/ &
  & 0.38478381E-03_JPRB, 0.38467268E-03_JPRB, 0.38419790E-03_JPRB, 0.38359838E-03_JPRB, 0.38299899E-03_JPRB, 0.38241042E-03_JPRB, &
  & 0.38176198E-03_JPRB, 0.38138425E-03_JPRB, 0.38120551E-03_JPRB, 0.38115067E-03_JPRB, 0.38117982E-03_JPRB, 0.38121116E-03_JPRB, &
  & 0.38133339E-03_JPRB, 0.38160468E-03_JPRB, 0.38196241E-03_JPRB, 0.38229253E-03_JPRB, 0.38256208E-03_JPRB, 0.38273383E-03_JPRB, &
  & 0.38294172E-03_JPRB, 0.38321330E-03_JPRB, 0.38353959E-03_JPRB, 0.38390588E-03_JPRB, 0.38417582E-03_JPRB, 0.38426098E-03_JPRB, &
  & 0.38424827E-03_JPRB, 0.38440933E-03_JPRB, 0.38459734E-03_JPRB, 0.38488222E-03_JPRB, 0.38526036E-03_JPRB, 0.38561169E-03_JPRB, &
  & 0.38608934E-03_JPRB, 0.38663062E-03_JPRB, 0.38707765E-03_JPRB, 0.38749110E-03_JPRB, 0.38783921E-03_JPRB, 0.38800681E-03_JPRB, &
  & 0.38796869E-03_JPRB, 0.38777852E-03_JPRB, 0.38751299E-03_JPRB, 0.38722929E-03_JPRB, 0.38711215E-03_JPRB, 0.38694277E-03_JPRB, &
  & 0.38668885E-03_JPRB, 0.38637419E-03_JPRB, 0.38599104E-03_JPRB, 0.38551771E-03_JPRB, 0.38504961E-03_JPRB, 0.38458689E-03_JPRB, &
  & 0.38411945E-03_JPRB, 0.38377541E-03_JPRB, 0.38350085E-03_JPRB, 0.38328611E-03_JPRB, 0.38300113E-03_JPRB, 0.38273776E-03_JPRB, &
  & 0.38245446E-03_JPRB, 0.38212508E-03_JPRB, 0.38179596E-03_JPRB, 0.38142769E-03_JPRB, 0.38121015E-03_JPRB, 0.38106837E-03_JPRB, &
  & 0.38097511E-03_JPRB, 0.38080754E-03_JPRB, 0.38074337E-03_JPRB, 0.38082553E-03_JPRB  /)

RGHG1(:,41, 6) = (/ &
  & 0.38616710E-03_JPRB, 0.38602507E-03_JPRB, 0.38551812E-03_JPRB, 0.38484795E-03_JPRB, 0.38414317E-03_JPRB, 0.38352033E-03_JPRB, &
  & 0.38280422E-03_JPRB, 0.38234144E-03_JPRB, 0.38210754E-03_JPRB, 0.38201413E-03_JPRB, 0.38203248E-03_JPRB, 0.38202424E-03_JPRB, &
  & 0.38206072E-03_JPRB, 0.38227700E-03_JPRB, 0.38264748E-03_JPRB, 0.38297823E-03_JPRB, 0.38320795E-03_JPRB, 0.38331273E-03_JPRB, &
  & 0.38346178E-03_JPRB, 0.38370418E-03_JPRB, 0.38398329E-03_JPRB, 0.38428323E-03_JPRB, 0.38447259E-03_JPRB, 0.38446996E-03_JPRB, &
  & 0.38437377E-03_JPRB, 0.38450228E-03_JPRB, 0.38464444E-03_JPRB, 0.38495178E-03_JPRB, 0.38537130E-03_JPRB, 0.38570604E-03_JPRB, &
  & 0.38621796E-03_JPRB, 0.38675690E-03_JPRB, 0.38716308E-03_JPRB, 0.38759516E-03_JPRB, 0.38798466E-03_JPRB, 0.38819662E-03_JPRB, &
  & 0.38820279E-03_JPRB, 0.38806778E-03_JPRB, 0.38782259E-03_JPRB, 0.38752058E-03_JPRB, 0.38742941E-03_JPRB, 0.38729962E-03_JPRB, &
  & 0.38708553E-03_JPRB, 0.38682533E-03_JPRB, 0.38650390E-03_JPRB, 0.38608378E-03_JPRB, 0.38562131E-03_JPRB, 0.38513144E-03_JPRB, &
  & 0.38461331E-03_JPRB, 0.38427873E-03_JPRB, 0.38401059E-03_JPRB, 0.38384967E-03_JPRB, 0.38362213E-03_JPRB, 0.38336313E-03_JPRB, &
  & 0.38309525E-03_JPRB, 0.38278441E-03_JPRB, 0.38247305E-03_JPRB, 0.38211081E-03_JPRB, 0.38190891E-03_JPRB, 0.38179914E-03_JPRB, &
  & 0.38173827E-03_JPRB, 0.38157469E-03_JPRB, 0.38148149E-03_JPRB, 0.38150560E-03_JPRB  /)

RGHG1(:,42, 6) = (/ &
  & 0.38649110E-03_JPRB, 0.38615749E-03_JPRB, 0.38554940E-03_JPRB, 0.38505261E-03_JPRB, 0.38434237E-03_JPRB, 0.38371445E-03_JPRB, &
  & 0.38309691E-03_JPRB, 0.38257855E-03_JPRB, 0.38235315E-03_JPRB, 0.38229907E-03_JPRB, 0.38231464E-03_JPRB, 0.38232092E-03_JPRB, &
  & 0.38236103E-03_JPRB, 0.38251967E-03_JPRB, 0.38283694E-03_JPRB, 0.38311554E-03_JPRB, 0.38329459E-03_JPRB, 0.38335616E-03_JPRB, &
  & 0.38348830E-03_JPRB, 0.38373819E-03_JPRB, 0.38402711E-03_JPRB, 0.38431984E-03_JPRB, 0.38447716E-03_JPRB, 0.38447921E-03_JPRB, &
  & 0.38441890E-03_JPRB, 0.38460674E-03_JPRB, 0.38477711E-03_JPRB, 0.38510618E-03_JPRB, 0.38547396E-03_JPRB, 0.38582710E-03_JPRB, &
  & 0.38628116E-03_JPRB, 0.38672358E-03_JPRB, 0.38711257E-03_JPRB, 0.38755211E-03_JPRB, 0.38795601E-03_JPRB, 0.38820551E-03_JPRB, &
  & 0.38823157E-03_JPRB, 0.38807918E-03_JPRB, 0.38784183E-03_JPRB, 0.38754058E-03_JPRB, 0.38742930E-03_JPRB, 0.38729684E-03_JPRB, &
  & 0.38709501E-03_JPRB, 0.38681058E-03_JPRB, 0.38651495E-03_JPRB, 0.38611635E-03_JPRB, 0.38567846E-03_JPRB, 0.38521619E-03_JPRB, &
  & 0.38469870E-03_JPRB, 0.38432913E-03_JPRB, 0.38404688E-03_JPRB, 0.38388740E-03_JPRB, 0.38369029E-03_JPRB, 0.38346003E-03_JPRB, &
  & 0.38324849E-03_JPRB, 0.38301561E-03_JPRB, 0.38274849E-03_JPRB, 0.38239677E-03_JPRB, 0.38223258E-03_JPRB, 0.38214824E-03_JPRB, &
  & 0.38207413E-03_JPRB, 0.38193176E-03_JPRB, 0.38176555E-03_JPRB, 0.38180315E-03_JPRB  /)

RGHG1(:,43, 6) = (/ &
  & 0.38738173E-03_JPRB, 0.38686004E-03_JPRB, 0.38614583E-03_JPRB, 0.38577685E-03_JPRB, 0.38501629E-03_JPRB, 0.38436900E-03_JPRB, &
  & 0.38381227E-03_JPRB, 0.38320663E-03_JPRB, 0.38296524E-03_JPRB, 0.38293046E-03_JPRB, 0.38293886E-03_JPRB, 0.38294135E-03_JPRB, &
  & 0.38294789E-03_JPRB, 0.38303028E-03_JPRB, 0.38330448E-03_JPRB, 0.38353578E-03_JPRB, 0.38365146E-03_JPRB, 0.38364481E-03_JPRB, &
  & 0.38373619E-03_JPRB, 0.38398038E-03_JPRB, 0.38425795E-03_JPRB, 0.38451557E-03_JPRB, 0.38460898E-03_JPRB, 0.38457753E-03_JPRB, &
  & 0.38451406E-03_JPRB, 0.38474203E-03_JPRB, 0.38491843E-03_JPRB, 0.38527697E-03_JPRB, 0.38561535E-03_JPRB, 0.38597813E-03_JPRB, &
  & 0.38639415E-03_JPRB, 0.38674751E-03_JPRB, 0.38710323E-03_JPRB, 0.38755759E-03_JPRB, 0.38799244E-03_JPRB, 0.38829526E-03_JPRB, &
  & 0.38835853E-03_JPRB, 0.38821401E-03_JPRB, 0.38799256E-03_JPRB, 0.38768413E-03_JPRB, 0.38756568E-03_JPRB, 0.38744780E-03_JPRB, &
  & 0.38727430E-03_JPRB, 0.38699117E-03_JPRB, 0.38674563E-03_JPRB, 0.38638956E-03_JPRB, 0.38597652E-03_JPRB, 0.38552776E-03_JPRB, &
  & 0.38498904E-03_JPRB, 0.38459161E-03_JPRB, 0.38429925E-03_JPRB, 0.38416423E-03_JPRB, 0.38401961E-03_JPRB, 0.38381744E-03_JPRB, &
  & 0.38366393E-03_JPRB, 0.38351017E-03_JPRB, 0.38329105E-03_JPRB, 0.38295153E-03_JPRB, 0.38282847E-03_JPRB, 0.38278110E-03_JPRB, &
  & 0.38270884E-03_JPRB, 0.38258754E-03_JPRB, 0.38234222E-03_JPRB, 0.38236717E-03_JPRB  /)

RGHG1(:,44, 6) = (/ &
  & 0.38732631E-03_JPRB, 0.38679890E-03_JPRB, 0.38611648E-03_JPRB, 0.38573305E-03_JPRB, 0.38499595E-03_JPRB, 0.38439057E-03_JPRB, &
  & 0.38393433E-03_JPRB, 0.38335825E-03_JPRB, 0.38311060E-03_JPRB, 0.38308956E-03_JPRB, 0.38311538E-03_JPRB, 0.38314920E-03_JPRB, &
  & 0.38315521E-03_JPRB, 0.38319819E-03_JPRB, 0.38343037E-03_JPRB, 0.38360775E-03_JPRB, 0.38367828E-03_JPRB, 0.38365925E-03_JPRB, &
  & 0.38372391E-03_JPRB, 0.38396906E-03_JPRB, 0.38426969E-03_JPRB, 0.38453586E-03_JPRB, 0.38462014E-03_JPRB, 0.38459069E-03_JPRB, &
  & 0.38455070E-03_JPRB, 0.38480015E-03_JPRB, 0.38498306E-03_JPRB, 0.38531679E-03_JPRB, 0.38563477E-03_JPRB, 0.38601223E-03_JPRB, &
  & 0.38638267E-03_JPRB, 0.38670968E-03_JPRB, 0.38705474E-03_JPRB, 0.38752899E-03_JPRB, 0.38797843E-03_JPRB, 0.38831655E-03_JPRB, &
  & 0.38841318E-03_JPRB, 0.38829326E-03_JPRB, 0.38806898E-03_JPRB, 0.38775204E-03_JPRB, 0.38762713E-03_JPRB, 0.38751668E-03_JPRB, &
  & 0.38731829E-03_JPRB, 0.38702439E-03_JPRB, 0.38678200E-03_JPRB, 0.38645431E-03_JPRB, 0.38605707E-03_JPRB, 0.38560335E-03_JPRB, &
  & 0.38505442E-03_JPRB, 0.38463103E-03_JPRB, 0.38433613E-03_JPRB, 0.38417580E-03_JPRB, 0.38404224E-03_JPRB, 0.38385450E-03_JPRB, &
  & 0.38371975E-03_JPRB, 0.38358180E-03_JPRB, 0.38337485E-03_JPRB, 0.38308177E-03_JPRB, 0.38295402E-03_JPRB, 0.38296730E-03_JPRB, &
  & 0.38295779E-03_JPRB, 0.38288162E-03_JPRB, 0.38262188E-03_JPRB, 0.38269211E-03_JPRB  /)

RGHG1(:,45, 6) = (/ &
  & 0.38737574E-03_JPRB, 0.38681805E-03_JPRB, 0.38615841E-03_JPRB, 0.38577468E-03_JPRB, 0.38505794E-03_JPRB, 0.38449782E-03_JPRB, &
  & 0.38416365E-03_JPRB, 0.38361020E-03_JPRB, 0.38335339E-03_JPRB, 0.38335045E-03_JPRB, 0.38339518E-03_JPRB, 0.38346420E-03_JPRB, &
  & 0.38346537E-03_JPRB, 0.38345386E-03_JPRB, 0.38363275E-03_JPRB, 0.38374277E-03_JPRB, 0.38375388E-03_JPRB, 0.38371215E-03_JPRB, &
  & 0.38374124E-03_JPRB, 0.38398677E-03_JPRB, 0.38431223E-03_JPRB, 0.38458370E-03_JPRB, 0.38464951E-03_JPRB, 0.38461808E-03_JPRB, &
  & 0.38460444E-03_JPRB, 0.38488341E-03_JPRB, 0.38507448E-03_JPRB, 0.38538370E-03_JPRB, 0.38567473E-03_JPRB, 0.38607013E-03_JPRB, &
  & 0.38638388E-03_JPRB, 0.38666965E-03_JPRB, 0.38699835E-03_JPRB, 0.38749713E-03_JPRB, 0.38796707E-03_JPRB, 0.38835212E-03_JPRB, &
  & 0.38849144E-03_JPRB, 0.38840050E-03_JPRB, 0.38817501E-03_JPRB, 0.38784748E-03_JPRB, 0.38771432E-03_JPRB, 0.38761416E-03_JPRB, &
  & 0.38739103E-03_JPRB, 0.38708501E-03_JPRB, 0.38685253E-03_JPRB, 0.38656254E-03_JPRB, 0.38618641E-03_JPRB, 0.38572876E-03_JPRB, &
  & 0.38516553E-03_JPRB, 0.38470906E-03_JPRB, 0.38441000E-03_JPRB, 0.38422393E-03_JPRB, 0.38410960E-03_JPRB, 0.38394184E-03_JPRB, &
  & 0.38383578E-03_JPRB, 0.38372583E-03_JPRB, 0.38353878E-03_JPRB, 0.38330012E-03_JPRB, 0.38317222E-03_JPRB, 0.38325921E-03_JPRB, &
  & 0.38332138E-03_JPRB, 0.38329925E-03_JPRB, 0.38301309E-03_JPRB, 0.38313327E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART12',0,ZHOOK_HANDLE)



RGHG1(:,46, 6) = (/ &
  & 0.38696033E-03_JPRB, 0.38647816E-03_JPRB, 0.38594385E-03_JPRB, 0.38544778E-03_JPRB, 0.38475097E-03_JPRB, 0.38428798E-03_JPRB, &
  & 0.38404580E-03_JPRB, 0.38359281E-03_JPRB, 0.38334273E-03_JPRB, 0.38331282E-03_JPRB, 0.38339572E-03_JPRB, 0.38349997E-03_JPRB, &
  & 0.38350043E-03_JPRB, 0.38348097E-03_JPRB, 0.38361791E-03_JPRB, 0.38370391E-03_JPRB, 0.38368520E-03_JPRB, 0.38365353E-03_JPRB, &
  & 0.38368025E-03_JPRB, 0.38392484E-03_JPRB, 0.38425922E-03_JPRB, 0.38453682E-03_JPRB, 0.38460850E-03_JPRB, 0.38459115E-03_JPRB, &
  & 0.38462398E-03_JPRB, 0.38489488E-03_JPRB, 0.38507804E-03_JPRB, 0.38536561E-03_JPRB, 0.38565857E-03_JPRB, 0.38607035E-03_JPRB, &
  & 0.38636887E-03_JPRB, 0.38664078E-03_JPRB, 0.38696754E-03_JPRB, 0.38747668E-03_JPRB, 0.38795956E-03_JPRB, 0.38837570E-03_JPRB, &
  & 0.38853936E-03_JPRB, 0.38847093E-03_JPRB, 0.38824278E-03_JPRB, 0.38790917E-03_JPRB, 0.38777581E-03_JPRB, 0.38765997E-03_JPRB, &
  & 0.38742682E-03_JPRB, 0.38712114E-03_JPRB, 0.38688591E-03_JPRB, 0.38661699E-03_JPRB, 0.38627029E-03_JPRB, 0.38579720E-03_JPRB, &
  & 0.38522802E-03_JPRB, 0.38476993E-03_JPRB, 0.38447126E-03_JPRB, 0.38426912E-03_JPRB, 0.38414941E-03_JPRB, 0.38397054E-03_JPRB, &
  & 0.38386048E-03_JPRB, 0.38374230E-03_JPRB, 0.38355572E-03_JPRB, 0.38334593E-03_JPRB, 0.38318967E-03_JPRB, 0.38332608E-03_JPRB, &
  & 0.38349503E-03_JPRB, 0.38353994E-03_JPRB, 0.38331820E-03_JPRB, 0.38351140E-03_JPRB  /)

RGHG1(:,47, 6) = (/ &
  & 0.38637977E-03_JPRB, 0.38600739E-03_JPRB, 0.38564071E-03_JPRB, 0.38499038E-03_JPRB, 0.38431686E-03_JPRB, 0.38397824E-03_JPRB, &
  & 0.38383797E-03_JPRB, 0.38351845E-03_JPRB, 0.38327945E-03_JPRB, 0.38320886E-03_JPRB, 0.38334040E-03_JPRB, 0.38348601E-03_JPRB, &
  & 0.38348647E-03_JPRB, 0.38346701E-03_JPRB, 0.38355698E-03_JPRB, 0.38362348E-03_JPRB, 0.38357571E-03_JPRB, 0.38356240E-03_JPRB, &
  & 0.38359298E-03_JPRB, 0.38383621E-03_JPRB, 0.38417787E-03_JPRB, 0.38446283E-03_JPRB, 0.38454628E-03_JPRB, 0.38454865E-03_JPRB, &
  & 0.38464007E-03_JPRB, 0.38489397E-03_JPRB, 0.38506461E-03_JPRB, 0.38532737E-03_JPRB, 0.38562837E-03_JPRB, 0.38605904E-03_JPRB, &
  & 0.38634800E-03_JPRB, 0.38660913E-03_JPRB, 0.38693650E-03_JPRB, 0.38745498E-03_JPRB, 0.38795152E-03_JPRB, 0.38840097E-03_JPRB, &
  & 0.38858952E-03_JPRB, 0.38854621E-03_JPRB, 0.38831464E-03_JPRB, 0.38797481E-03_JPRB, 0.38784281E-03_JPRB, 0.38770337E-03_JPRB, &
  & 0.38746142E-03_JPRB, 0.38715862E-03_JPRB, 0.38691763E-03_JPRB, 0.38667010E-03_JPRB, 0.38635960E-03_JPRB, 0.38586610E-03_JPRB, &
  & 0.38529160E-03_JPRB, 0.38483792E-03_JPRB, 0.38454061E-03_JPRB, 0.38432155E-03_JPRB, 0.38419062E-03_JPRB, 0.38399247E-03_JPRB, &
  & 0.38387118E-03_JPRB, 0.38373608E-03_JPRB, 0.38354616E-03_JPRB, 0.38336513E-03_JPRB, 0.38316995E-03_JPRB, 0.38335947E-03_JPRB, &
  & 0.38366076E-03_JPRB, 0.38378693E-03_JPRB, 0.38365898E-03_JPRB, 0.38394248E-03_JPRB  /)

RGHG1(:,48, 6) = (/ &
  & 0.38569677E-03_JPRB, 0.38533028E-03_JPRB, 0.38513528E-03_JPRB, 0.38442958E-03_JPRB, 0.38377162E-03_JPRB, 0.38355011E-03_JPRB, &
  & 0.38346134E-03_JPRB, 0.38327764E-03_JPRB, 0.38307142E-03_JPRB, 0.38300226E-03_JPRB, 0.38314776E-03_JPRB, 0.38330745E-03_JPRB, &
  & 0.38332431E-03_JPRB, 0.38334175E-03_JPRB, 0.38340817E-03_JPRB, 0.38346874E-03_JPRB, 0.38341706E-03_JPRB, 0.38341966E-03_JPRB, &
  & 0.38346737E-03_JPRB, 0.38369549E-03_JPRB, 0.38403629E-03_JPRB, 0.38433271E-03_JPRB, 0.38443962E-03_JPRB, 0.38446783E-03_JPRB, &
  & 0.38460073E-03_JPRB, 0.38485302E-03_JPRB, 0.38501892E-03_JPRB, 0.38527665E-03_JPRB, 0.38558518E-03_JPRB, 0.38601477E-03_JPRB, &
  & 0.38629975E-03_JPRB, 0.38657131E-03_JPRB, 0.38690209E-03_JPRB, 0.38743276E-03_JPRB, 0.38795282E-03_JPRB, 0.38843106E-03_JPRB, &
  & 0.38863284E-03_JPRB, 0.38860531E-03_JPRB, 0.38836412E-03_JPRB, 0.38802079E-03_JPRB, 0.38787248E-03_JPRB, 0.38770743E-03_JPRB, &
  & 0.38746885E-03_JPRB, 0.38717776E-03_JPRB, 0.38693354E-03_JPRB, 0.38669942E-03_JPRB, 0.38640868E-03_JPRB, 0.38592345E-03_JPRB, &
  & 0.38537797E-03_JPRB, 0.38495796E-03_JPRB, 0.38466639E-03_JPRB, 0.38446400E-03_JPRB, 0.38433448E-03_JPRB, 0.38411850E-03_JPRB, &
  & 0.38396558E-03_JPRB, 0.38379574E-03_JPRB, 0.38358965E-03_JPRB, 0.38339635E-03_JPRB, 0.38316116E-03_JPRB, 0.38331829E-03_JPRB, &
  & 0.38365699E-03_JPRB, 0.38383355E-03_JPRB, 0.38381765E-03_JPRB, 0.38421881E-03_JPRB  /)

RGHG1(:,49, 6) = (/ &
  & 0.38489386E-03_JPRB, 0.38448664E-03_JPRB, 0.38448361E-03_JPRB, 0.38376155E-03_JPRB, 0.38311729E-03_JPRB, 0.38302218E-03_JPRB, &
  & 0.38296752E-03_JPRB, 0.38293529E-03_JPRB, 0.38277526E-03_JPRB, 0.38272681E-03_JPRB, 0.38287200E-03_JPRB, 0.38303488E-03_JPRB, &
  & 0.38307736E-03_JPRB, 0.38315243E-03_JPRB, 0.38320343E-03_JPRB, 0.38326361E-03_JPRB, 0.38321901E-03_JPRB, 0.38323813E-03_JPRB, &
  & 0.38331084E-03_JPRB, 0.38351599E-03_JPRB, 0.38385211E-03_JPRB, 0.38416310E-03_JPRB, 0.38430131E-03_JPRB, 0.38436091E-03_JPRB, &
  & 0.38453196E-03_JPRB, 0.38478948E-03_JPRB, 0.38495366E-03_JPRB, 0.38521482E-03_JPRB, 0.38553144E-03_JPRB, 0.38595075E-03_JPRB, &
  & 0.38623387E-03_JPRB, 0.38652660E-03_JPRB, 0.38686245E-03_JPRB, 0.38740792E-03_JPRB, 0.38795850E-03_JPRB, 0.38846657E-03_JPRB, &
  & 0.38867769E-03_JPRB, 0.38866341E-03_JPRB, 0.38840875E-03_JPRB, 0.38806276E-03_JPRB, 0.38788837E-03_JPRB, 0.38769403E-03_JPRB, &
  & 0.38746472E-03_JPRB, 0.38719061E-03_JPRB, 0.38694397E-03_JPRB, 0.38672107E-03_JPRB, 0.38644473E-03_JPRB, 0.38598170E-03_JPRB, &
  & 0.38548396E-03_JPRB, 0.38511458E-03_JPRB, 0.38483134E-03_JPRB, 0.38466266E-03_JPRB, 0.38454046E-03_JPRB, 0.38430541E-03_JPRB, &
  & 0.38410818E-03_JPRB, 0.38389176E-03_JPRB, 0.38366192E-03_JPRB, 0.38343637E-03_JPRB, 0.38315641E-03_JPRB, 0.38323877E-03_JPRB, &
  & 0.38357577E-03_JPRB, 0.38379406E-03_JPRB, 0.38391056E-03_JPRB, 0.38445447E-03_JPRB  /)

RGHG1(:,50, 6) = (/ &
  & 0.38404081E-03_JPRB, 0.38367195E-03_JPRB, 0.38377082E-03_JPRB, 0.38310056E-03_JPRB, 0.38250689E-03_JPRB, 0.38249315E-03_JPRB, &
  & 0.38248821E-03_JPRB, 0.38252967E-03_JPRB, 0.38245939E-03_JPRB, 0.38243685E-03_JPRB, 0.38256700E-03_JPRB, 0.38271605E-03_JPRB, &
  & 0.38278260E-03_JPRB, 0.38290517E-03_JPRB, 0.38296277E-03_JPRB, 0.38304054E-03_JPRB, 0.38301966E-03_JPRB, 0.38304499E-03_JPRB, &
  & 0.38312998E-03_JPRB, 0.38331465E-03_JPRB, 0.38364616E-03_JPRB, 0.38395624E-03_JPRB, 0.38413278E-03_JPRB, 0.38422957E-03_JPRB, &
  & 0.38443765E-03_JPRB, 0.38470856E-03_JPRB, 0.38489152E-03_JPRB, 0.38514844E-03_JPRB, 0.38547166E-03_JPRB, 0.38589099E-03_JPRB, &
  & 0.38616662E-03_JPRB, 0.38647316E-03_JPRB, 0.38682287E-03_JPRB, 0.38738866E-03_JPRB, 0.38797322E-03_JPRB, 0.38849605E-03_JPRB, &
  & 0.38870826E-03_JPRB, 0.38869430E-03_JPRB, 0.38842531E-03_JPRB, 0.38807963E-03_JPRB, 0.38788268E-03_JPRB, 0.38766121E-03_JPRB, &
  & 0.38743898E-03_JPRB, 0.38717679E-03_JPRB, 0.38693478E-03_JPRB, 0.38672117E-03_JPRB, 0.38645324E-03_JPRB, 0.38603704E-03_JPRB, &
  & 0.38561059E-03_JPRB, 0.38529456E-03_JPRB, 0.38502513E-03_JPRB, 0.38488191E-03_JPRB, 0.38478265E-03_JPRB, 0.38455573E-03_JPRB, &
  & 0.38431343E-03_JPRB, 0.38407951E-03_JPRB, 0.38383608E-03_JPRB, 0.38356223E-03_JPRB, 0.38322020E-03_JPRB, 0.38320092E-03_JPRB, &
  & 0.38347293E-03_JPRB, 0.38368428E-03_JPRB, 0.38388835E-03_JPRB, 0.38447318E-03_JPRB  /)

RGHG1(:,51, 6) = (/ &
  & 0.38309177E-03_JPRB, 0.38280596E-03_JPRB, 0.38296772E-03_JPRB, 0.38238930E-03_JPRB, 0.38186975E-03_JPRB, 0.38192036E-03_JPRB, &
  & 0.38197741E-03_JPRB, 0.38205767E-03_JPRB, 0.38210739E-03_JPRB, 0.38211560E-03_JPRB, 0.38222175E-03_JPRB, 0.38234688E-03_JPRB, &
  & 0.38243865E-03_JPRB, 0.38260726E-03_JPRB, 0.38268357E-03_JPRB, 0.38278981E-03_JPRB, 0.38280335E-03_JPRB, 0.38282997E-03_JPRB, &
  & 0.38292155E-03_JPRB, 0.38308540E-03_JPRB, 0.38341195E-03_JPRB, 0.38371292E-03_JPRB, 0.38393461E-03_JPRB, 0.38407468E-03_JPRB, &
  & 0.38432222E-03_JPRB, 0.38461192E-03_JPRB, 0.38482595E-03_JPRB, 0.38507424E-03_JPRB, 0.38540381E-03_JPRB, 0.38582860E-03_JPRB, &
  & 0.38609316E-03_JPRB, 0.38641077E-03_JPRB, 0.38678008E-03_JPRB, 0.38737076E-03_JPRB, 0.38799388E-03_JPRB, 0.38852477E-03_JPRB, &
  & 0.38873380E-03_JPRB, 0.38871342E-03_JPRB, 0.38842849E-03_JPRB, 0.38808467E-03_JPRB, 0.38786519E-03_JPRB, 0.38761549E-03_JPRB, &
  & 0.38739977E-03_JPRB, 0.38714783E-03_JPRB, 0.38691453E-03_JPRB, 0.38670994E-03_JPRB, 0.38644795E-03_JPRB, 0.38609537E-03_JPRB, &
  & 0.38575840E-03_JPRB, 0.38550151E-03_JPRB, 0.38524990E-03_JPRB, 0.38512986E-03_JPRB, 0.38506364E-03_JPRB, 0.38485982E-03_JPRB, &
  & 0.38456839E-03_JPRB, 0.38433081E-03_JPRB, 0.38407801E-03_JPRB, 0.38374348E-03_JPRB, 0.38332522E-03_JPRB, 0.38318189E-03_JPRB, &
  & 0.38335033E-03_JPRB, 0.38352857E-03_JPRB, 0.38380383E-03_JPRB, 0.38437938E-03_JPRB  /)

RGHG1(:,52, 6) = (/ &
  & 0.38241507E-03_JPRB, 0.38214465E-03_JPRB, 0.38233925E-03_JPRB, 0.38185867E-03_JPRB, 0.38142004E-03_JPRB, 0.38148261E-03_JPRB, &
  & 0.38160401E-03_JPRB, 0.38168211E-03_JPRB, 0.38182333E-03_JPRB, 0.38184615E-03_JPRB, 0.38192285E-03_JPRB, 0.38203941E-03_JPRB, &
  & 0.38213398E-03_JPRB, 0.38231198E-03_JPRB, 0.38242656E-03_JPRB, 0.38256336E-03_JPRB, 0.38260132E-03_JPRB, 0.38264063E-03_JPRB, &
  & 0.38271925E-03_JPRB, 0.38287254E-03_JPRB, 0.38319621E-03_JPRB, 0.38348974E-03_JPRB, 0.38374477E-03_JPRB, 0.38392339E-03_JPRB, &
  & 0.38418514E-03_JPRB, 0.38449867E-03_JPRB, 0.38475484E-03_JPRB, 0.38500804E-03_JPRB, 0.38532185E-03_JPRB, 0.38574591E-03_JPRB, &
  & 0.38601282E-03_JPRB, 0.38634450E-03_JPRB, 0.38674310E-03_JPRB, 0.38734926E-03_JPRB, 0.38799823E-03_JPRB, 0.38852242E-03_JPRB, &
  & 0.38872620E-03_JPRB, 0.38869569E-03_JPRB, 0.38839419E-03_JPRB, 0.38805960E-03_JPRB, 0.38782463E-03_JPRB, 0.38755800E-03_JPRB, &
  & 0.38734992E-03_JPRB, 0.38710648E-03_JPRB, 0.38688111E-03_JPRB, 0.38667765E-03_JPRB, 0.38642671E-03_JPRB, 0.38614316E-03_JPRB, &
  & 0.38588593E-03_JPRB, 0.38568043E-03_JPRB, 0.38544709E-03_JPRB, 0.38533311E-03_JPRB, 0.38529863E-03_JPRB, 0.38513364E-03_JPRB, &
  & 0.38483928E-03_JPRB, 0.38462218E-03_JPRB, 0.38436042E-03_JPRB, 0.38398273E-03_JPRB, 0.38352279E-03_JPRB, 0.38328614E-03_JPRB, &
  & 0.38338927E-03_JPRB, 0.38349555E-03_JPRB, 0.38377477E-03_JPRB, 0.38438116E-03_JPRB  /)

RGHG1(:,53, 6) = (/ &
  & 0.38178292E-03_JPRB, 0.38150324E-03_JPRB, 0.38172205E-03_JPRB, 0.38135032E-03_JPRB, 0.38100241E-03_JPRB, 0.38105786E-03_JPRB, &
  & 0.38125026E-03_JPRB, 0.38131024E-03_JPRB, 0.38154013E-03_JPRB, 0.38157266E-03_JPRB, 0.38161520E-03_JPRB, 0.38172832E-03_JPRB, &
  & 0.38181731E-03_JPRB, 0.38199145E-03_JPRB, 0.38215521E-03_JPRB, 0.38232609E-03_JPRB, 0.38238680E-03_JPRB, 0.38244431E-03_JPRB, &
  & 0.38250130E-03_JPRB, 0.38264703E-03_JPRB, 0.38296839E-03_JPRB, 0.38325444E-03_JPRB, 0.38354124E-03_JPRB, 0.38376004E-03_JPRB, &
  & 0.38402753E-03_JPRB, 0.38436897E-03_JPRB, 0.38467526E-03_JPRB, 0.38493903E-03_JPRB, 0.38522717E-03_JPRB, 0.38564805E-03_JPRB, &
  & 0.38592268E-03_JPRB, 0.38627085E-03_JPRB, 0.38670507E-03_JPRB, 0.38732445E-03_JPRB, 0.38799668E-03_JPRB, 0.38850792E-03_JPRB, &
  & 0.38870517E-03_JPRB, 0.38866221E-03_JPRB, 0.38834243E-03_JPRB, 0.38802072E-03_JPRB, 0.38777158E-03_JPRB, 0.38749087E-03_JPRB, &
  & 0.38729155E-03_JPRB, 0.38705670E-03_JPRB, 0.38683964E-03_JPRB, 0.38663439E-03_JPRB, 0.38639743E-03_JPRB, 0.38619114E-03_JPRB, &
  & 0.38601702E-03_JPRB, 0.38586447E-03_JPRB, 0.38565123E-03_JPRB, 0.38553724E-03_JPRB, 0.38553684E-03_JPRB, 0.38542018E-03_JPRB, &
  & 0.38514042E-03_JPRB, 0.38495491E-03_JPRB, 0.38468353E-03_JPRB, 0.38426558E-03_JPRB, 0.38377353E-03_JPRB, 0.38344709E-03_JPRB, &
  & 0.38349383E-03_JPRB, 0.38350680E-03_JPRB, 0.38376447E-03_JPRB, 0.38441988E-03_JPRB  /)

RGHG1(:,54, 6) = (/ &
  & 0.38151879E-03_JPRB, 0.38123085E-03_JPRB, 0.38142922E-03_JPRB, 0.38118193E-03_JPRB, 0.38090407E-03_JPRB, 0.38093855E-03_JPRB, &
  & 0.38114693E-03_JPRB, 0.38118398E-03_JPRB, 0.38142548E-03_JPRB, 0.38146749E-03_JPRB, 0.38148641E-03_JPRB, 0.38157616E-03_JPRB, &
  & 0.38164773E-03_JPRB, 0.38178986E-03_JPRB, 0.38196810E-03_JPRB, 0.38214980E-03_JPRB, 0.38223240E-03_JPRB, 0.38230456E-03_JPRB, &
  & 0.38234683E-03_JPRB, 0.38247552E-03_JPRB, 0.38277950E-03_JPRB, 0.38307160E-03_JPRB, 0.38336074E-03_JPRB, 0.38360365E-03_JPRB, &
  & 0.38388491E-03_JPRB, 0.38424217E-03_JPRB, 0.38456943E-03_JPRB, 0.38485953E-03_JPRB, 0.38513694E-03_JPRB, 0.38553638E-03_JPRB, &
  & 0.38582191E-03_JPRB, 0.38618491E-03_JPRB, 0.38664827E-03_JPRB, 0.38728867E-03_JPRB, 0.38796786E-03_JPRB, 0.38847463E-03_JPRB, &
  & 0.38866957E-03_JPRB, 0.38861067E-03_JPRB, 0.38827829E-03_JPRB, 0.38796779E-03_JPRB, 0.38769407E-03_JPRB, 0.38740732E-03_JPRB, &
  & 0.38721774E-03_JPRB, 0.38699497E-03_JPRB, 0.38677953E-03_JPRB, 0.38657313E-03_JPRB, 0.38635971E-03_JPRB, 0.38620652E-03_JPRB, &
  & 0.38608994E-03_JPRB, 0.38596904E-03_JPRB, 0.38577454E-03_JPRB, 0.38568010E-03_JPRB, 0.38570419E-03_JPRB, 0.38563044E-03_JPRB, &
  & 0.38541006E-03_JPRB, 0.38525532E-03_JPRB, 0.38500666E-03_JPRB, 0.38460972E-03_JPRB, 0.38413770E-03_JPRB, 0.38381834E-03_JPRB, &
  & 0.38386063E-03_JPRB, 0.38386524E-03_JPRB, 0.38403097E-03_JPRB, 0.38454775E-03_JPRB  /)

RGHG1(:,55, 6) = (/ &
  & 0.38127460E-03_JPRB, 0.38097764E-03_JPRB, 0.38114751E-03_JPRB, 0.38104012E-03_JPRB, 0.38083712E-03_JPRB, 0.38084656E-03_JPRB, &
  & 0.38106541E-03_JPRB, 0.38107641E-03_JPRB, 0.38132065E-03_JPRB, 0.38137313E-03_JPRB, 0.38136728E-03_JPRB, 0.38142852E-03_JPRB, &
  & 0.38147923E-03_JPRB, 0.38158220E-03_JPRB, 0.38177192E-03_JPRB, 0.38196254E-03_JPRB, 0.38206927E-03_JPRB, 0.38215719E-03_JPRB, &
  & 0.38218407E-03_JPRB, 0.38229263E-03_JPRB, 0.38257539E-03_JPRB, 0.38287596E-03_JPRB, 0.38316382E-03_JPRB, 0.38343132E-03_JPRB, &
  & 0.38372888E-03_JPRB, 0.38410208E-03_JPRB, 0.38444875E-03_JPRB, 0.38477009E-03_JPRB, 0.38503757E-03_JPRB, 0.38541088E-03_JPRB, &
  & 0.38570888E-03_JPRB, 0.38608809E-03_JPRB, 0.38658287E-03_JPRB, 0.38724759E-03_JPRB, 0.38793233E-03_JPRB, 0.38843528E-03_JPRB, &
  & 0.38862822E-03_JPRB, 0.38855119E-03_JPRB, 0.38820560E-03_JPRB, 0.38790731E-03_JPRB, 0.38760499E-03_JPRB, 0.38731259E-03_JPRB, &
  & 0.38713394E-03_JPRB, 0.38692502E-03_JPRB, 0.38671050E-03_JPRB, 0.38650291E-03_JPRB, 0.38631681E-03_JPRB, 0.38621928E-03_JPRB, &
  & 0.38616308E-03_JPRB, 0.38607442E-03_JPRB, 0.38590050E-03_JPRB, 0.38583030E-03_JPRB, 0.38588025E-03_JPRB, 0.38585331E-03_JPRB, &
  & 0.38570461E-03_JPRB, 0.38558384E-03_JPRB, 0.38536461E-03_JPRB, 0.38499899E-03_JPRB, 0.38455604E-03_JPRB, 0.38425726E-03_JPRB, &
  & 0.38430146E-03_JPRB, 0.38430798E-03_JPRB, 0.38436259E-03_JPRB, 0.38470113E-03_JPRB  /)

RGHG1(:,56, 6) = (/ &
  & 0.38136829E-03_JPRB, 0.38107382E-03_JPRB, 0.38120660E-03_JPRB, 0.38116876E-03_JPRB, 0.38104112E-03_JPRB, 0.38104220E-03_JPRB, &
  & 0.38123739E-03_JPRB, 0.38124007E-03_JPRB, 0.38143272E-03_JPRB, 0.38145910E-03_JPRB, 0.38144205E-03_JPRB, 0.38146621E-03_JPRB, &
  & 0.38148695E-03_JPRB, 0.38155251E-03_JPRB, 0.38171668E-03_JPRB, 0.38188402E-03_JPRB, 0.38198103E-03_JPRB, 0.38206270E-03_JPRB, &
  & 0.38208985E-03_JPRB, 0.38218361E-03_JPRB, 0.38241331E-03_JPRB, 0.38272235E-03_JPRB, 0.38301144E-03_JPRB, 0.38328054E-03_JPRB, &
  & 0.38360125E-03_JPRB, 0.38400824E-03_JPRB, 0.38433538E-03_JPRB, 0.38462150E-03_JPRB, 0.38495050E-03_JPRB, 0.38532795E-03_JPRB, &
  & 0.38561244E-03_JPRB, 0.38600800E-03_JPRB, 0.38648350E-03_JPRB, 0.38719321E-03_JPRB, 0.38788942E-03_JPRB, 0.38839624E-03_JPRB, &
  & 0.38858292E-03_JPRB, 0.38847889E-03_JPRB, 0.38813670E-03_JPRB, 0.38782288E-03_JPRB, 0.38751344E-03_JPRB, 0.38722621E-03_JPRB, &
  & 0.38705038E-03_JPRB, 0.38684235E-03_JPRB, 0.38662606E-03_JPRB, 0.38642252E-03_JPRB, 0.38626781E-03_JPRB, 0.38619649E-03_JPRB, &
  & 0.38616727E-03_JPRB, 0.38609773E-03_JPRB, 0.38594846E-03_JPRB, 0.38592288E-03_JPRB, 0.38599488E-03_JPRB, 0.38598106E-03_JPRB, &
  & 0.38588652E-03_JPRB, 0.38580390E-03_JPRB, 0.38566218E-03_JPRB, 0.38536713E-03_JPRB, 0.38497976E-03_JPRB, 0.38473413E-03_JPRB, &
  & 0.38484324E-03_JPRB, 0.38489425E-03_JPRB, 0.38483127E-03_JPRB, 0.38513237E-03_JPRB  /)

RGHG1(:,57, 6) = (/ &
  & 0.38147215E-03_JPRB, 0.38118633E-03_JPRB, 0.38128426E-03_JPRB, 0.38130768E-03_JPRB, 0.38125180E-03_JPRB, 0.38124404E-03_JPRB, &
  & 0.38141855E-03_JPRB, 0.38141656E-03_JPRB, 0.38156294E-03_JPRB, 0.38156066E-03_JPRB, 0.38152792E-03_JPRB, 0.38152339E-03_JPRB, &
  & 0.38151226E-03_JPRB, 0.38154180E-03_JPRB, 0.38167528E-03_JPRB, 0.38181453E-03_JPRB, 0.38189771E-03_JPRB, 0.38196959E-03_JPRB, &
  & 0.38199673E-03_JPRB, 0.38207590E-03_JPRB, 0.38225280E-03_JPRB, 0.38256152E-03_JPRB, 0.38285192E-03_JPRB, 0.38311873E-03_JPRB, &
  & 0.38345583E-03_JPRB, 0.38389103E-03_JPRB, 0.38420874E-03_JPRB, 0.38447224E-03_JPRB, 0.38484776E-03_JPRB, 0.38522075E-03_JPRB, &
  & 0.38549976E-03_JPRB, 0.38591522E-03_JPRB, 0.38637959E-03_JPRB, 0.38712417E-03_JPRB, 0.38784306E-03_JPRB, 0.38835275E-03_JPRB, &
  & 0.38852401E-03_JPRB, 0.38839345E-03_JPRB, 0.38805647E-03_JPRB, 0.38773612E-03_JPRB, 0.38742016E-03_JPRB, 0.38714094E-03_JPRB, &
  & 0.38696161E-03_JPRB, 0.38675064E-03_JPRB, 0.38653590E-03_JPRB, 0.38633919E-03_JPRB, 0.38621558E-03_JPRB, 0.38617338E-03_JPRB, &
  & 0.38616787E-03_JPRB, 0.38612314E-03_JPRB, 0.38600121E-03_JPRB, 0.38602074E-03_JPRB, 0.38611393E-03_JPRB, 0.38611504E-03_JPRB, &
  & 0.38607179E-03_JPRB, 0.38602815E-03_JPRB, 0.38595665E-03_JPRB, 0.38572988E-03_JPRB, 0.38540711E-03_JPRB, 0.38520634E-03_JPRB, &
  & 0.38537655E-03_JPRB, 0.38547284E-03_JPRB, 0.38529581E-03_JPRB, 0.38558018E-03_JPRB  /)

RGHG1(:,58, 6) = (/ &
  & 0.38164819E-03_JPRB, 0.38138288E-03_JPRB, 0.38145094E-03_JPRB, 0.38150348E-03_JPRB, 0.38150762E-03_JPRB, 0.38149400E-03_JPRB, &
  & 0.38164819E-03_JPRB, 0.38165140E-03_JPRB, 0.38175401E-03_JPRB, 0.38171419E-03_JPRB, 0.38166197E-03_JPRB, 0.38164365E-03_JPRB, &
  & 0.38159829E-03_JPRB, 0.38159739E-03_JPRB, 0.38168700E-03_JPRB, 0.38178626E-03_JPRB, 0.38184344E-03_JPRB, 0.38189623E-03_JPRB, &
  & 0.38192583E-03_JPRB, 0.38199289E-03_JPRB, 0.38211571E-03_JPRB, 0.38240931E-03_JPRB, 0.38270150E-03_JPRB, 0.38295537E-03_JPRB, &
  & 0.38329738E-03_JPRB, 0.38375243E-03_JPRB, 0.38407128E-03_JPRB, 0.38432278E-03_JPRB, 0.38472911E-03_JPRB, 0.38508915E-03_JPRB, &
  & 0.38537185E-03_JPRB, 0.38581160E-03_JPRB, 0.38627002E-03_JPRB, 0.38703341E-03_JPRB, 0.38779324E-03_JPRB, 0.38830529E-03_JPRB, &
  & 0.38844610E-03_JPRB, 0.38829031E-03_JPRB, 0.38796430E-03_JPRB, 0.38764791E-03_JPRB, 0.38733101E-03_JPRB, 0.38706597E-03_JPRB, &
  & 0.38687123E-03_JPRB, 0.38664863E-03_JPRB, 0.38644041E-03_JPRB, 0.38625571E-03_JPRB, 0.38616093E-03_JPRB, 0.38614492E-03_JPRB, &
  & 0.38614944E-03_JPRB, 0.38613467E-03_JPRB, 0.38604319E-03_JPRB, 0.38610885E-03_JPRB, 0.38621934E-03_JPRB, 0.38623095E-03_JPRB, &
  & 0.38622675E-03_JPRB, 0.38622110E-03_JPRB, 0.38621086E-03_JPRB, 0.38605037E-03_JPRB, 0.38580721E-03_JPRB, 0.38563981E-03_JPRB, &
  & 0.38587156E-03_JPRB, 0.38601881E-03_JPRB, 0.38574166E-03_JPRB, 0.38607208E-03_JPRB  /)

RGHG1(:,59, 6) = (/ &
  & 0.38181521E-03_JPRB, 0.38161274E-03_JPRB, 0.38166652E-03_JPRB, 0.38171973E-03_JPRB, 0.38174435E-03_JPRB, 0.38171891E-03_JPRB, &
  & 0.38187056E-03_JPRB, 0.38187566E-03_JPRB, 0.38194756E-03_JPRB, 0.38187191E-03_JPRB, 0.38180561E-03_JPRB, 0.38177601E-03_JPRB, &
  & 0.38170243E-03_JPRB, 0.38167391E-03_JPRB, 0.38172148E-03_JPRB, 0.38177339E-03_JPRB, 0.38180680E-03_JPRB, 0.38184273E-03_JPRB, &
  & 0.38186902E-03_JPRB, 0.38191846E-03_JPRB, 0.38200622E-03_JPRB, 0.38227275E-03_JPRB, 0.38256412E-03_JPRB, 0.38280823E-03_JPRB, &
  & 0.38312998E-03_JPRB, 0.38357337E-03_JPRB, 0.38393345E-03_JPRB, 0.38420903E-03_JPRB, 0.38459992E-03_JPRB, 0.38492489E-03_JPRB, &
  & 0.38520891E-03_JPRB, 0.38569955E-03_JPRB, 0.38617916E-03_JPRB, 0.38695229E-03_JPRB, 0.38773629E-03_JPRB, 0.38825536E-03_JPRB, &
  & 0.38834668E-03_JPRB, 0.38815848E-03_JPRB, 0.38785577E-03_JPRB, 0.38755236E-03_JPRB, 0.38724029E-03_JPRB, 0.38699220E-03_JPRB, &
  & 0.38678933E-03_JPRB, 0.38655729E-03_JPRB, 0.38634497E-03_JPRB, 0.38617875E-03_JPRB, 0.38611613E-03_JPRB, 0.38611652E-03_JPRB, &
  & 0.38612863E-03_JPRB, 0.38614592E-03_JPRB, 0.38608536E-03_JPRB, 0.38618875E-03_JPRB, 0.38631589E-03_JPRB, 0.38634107E-03_JPRB, &
  & 0.38637188E-03_JPRB, 0.38640072E-03_JPRB, 0.38643363E-03_JPRB, 0.38634045E-03_JPRB, 0.38617964E-03_JPRB, 0.38605208E-03_JPRB, &
  & 0.38633387E-03_JPRB, 0.38652417E-03_JPRB, 0.38619481E-03_JPRB, 0.38656557E-03_JPRB  /)

RGHG1(:,60, 6) = (/ &
  & 0.38198162E-03_JPRB, 0.38186074E-03_JPRB, 0.38190672E-03_JPRB, 0.38195013E-03_JPRB, 0.38197796E-03_JPRB, 0.38193669E-03_JPRB, &
  & 0.38209213E-03_JPRB, 0.38209610E-03_JPRB, 0.38214272E-03_JPRB, 0.38203245E-03_JPRB, 0.38195325E-03_JPRB, 0.38191231E-03_JPRB, &
  & 0.38181547E-03_JPRB, 0.38175860E-03_JPRB, 0.38176425E-03_JPRB, 0.38176492E-03_JPRB, 0.38177399E-03_JPRB, 0.38179665E-03_JPRB, &
  & 0.38181738E-03_JPRB, 0.38184571E-03_JPRB, 0.38190779E-03_JPRB, 0.38214004E-03_JPRB, 0.38242674E-03_JPRB, 0.38266290E-03_JPRB, &
  & 0.38296032E-03_JPRB, 0.38338696E-03_JPRB, 0.38379766E-03_JPRB, 0.38410464E-03_JPRB, 0.38446170E-03_JPRB, 0.38474623E-03_JPRB, &
  & 0.38503528E-03_JPRB, 0.38558198E-03_JPRB, 0.38609435E-03_JPRB, 0.38687379E-03_JPRB, 0.38767312E-03_JPRB, 0.38819707E-03_JPRB, &
  & 0.38823399E-03_JPRB, 0.38801032E-03_JPRB, 0.38773689E-03_JPRB, 0.38744930E-03_JPRB, 0.38714844E-03_JPRB, 0.38691998E-03_JPRB, &
  & 0.38671305E-03_JPRB, 0.38647146E-03_JPRB, 0.38624929E-03_JPRB, 0.38610771E-03_JPRB, 0.38607797E-03_JPRB, 0.38608994E-03_JPRB, &
  & 0.38611148E-03_JPRB, 0.38616092E-03_JPRB, 0.38613320E-03_JPRB, 0.38626942E-03_JPRB, 0.38641348E-03_JPRB, 0.38645397E-03_JPRB, &
  & 0.38652094E-03_JPRB, 0.38658294E-03_JPRB, 0.38665416E-03_JPRB, 0.38663315E-03_JPRB, 0.38655621E-03_JPRB, 0.38647615E-03_JPRB, &
  & 0.38680205E-03_JPRB, 0.38703200E-03_JPRB, 0.38668515E-03_JPRB, 0.38709451E-03_JPRB  /)

RGHG1(:,61, 6) = (/ &
  & 0.38213025E-03_JPRB, 0.38210071E-03_JPRB, 0.38214680E-03_JPRB, 0.38217534E-03_JPRB, 0.38218553E-03_JPRB, 0.38212213E-03_JPRB, &
  & 0.38228402E-03_JPRB, 0.38227887E-03_JPRB, 0.38230991E-03_JPRB, 0.38217340E-03_JPRB, 0.38208139E-03_JPRB, 0.38202742E-03_JPRB, &
  & 0.38192372E-03_JPRB, 0.38183651E-03_JPRB, 0.38180504E-03_JPRB, 0.38175621E-03_JPRB, 0.38173975E-03_JPRB, 0.38176313E-03_JPRB, &
  & 0.38177730E-03_JPRB, 0.38178061E-03_JPRB, 0.38183531E-03_JPRB, 0.38202451E-03_JPRB, 0.38229492E-03_JPRB, 0.38252770E-03_JPRB, &
  & 0.38282009E-03_JPRB, 0.38325186E-03_JPRB, 0.38369260E-03_JPRB, 0.38400992E-03_JPRB, 0.38432219E-03_JPRB, 0.38457894E-03_JPRB, &
  & 0.38489044E-03_JPRB, 0.38547148E-03_JPRB, 0.38602413E-03_JPRB, 0.38680635E-03_JPRB, 0.38760372E-03_JPRB, 0.38811712E-03_JPRB, &
  & 0.38811252E-03_JPRB, 0.38785563E-03_JPRB, 0.38761563E-03_JPRB, 0.38734146E-03_JPRB, 0.38706869E-03_JPRB, 0.38686422E-03_JPRB, &
  & 0.38666129E-03_JPRB, 0.38640842E-03_JPRB, 0.38616800E-03_JPRB, 0.38606404E-03_JPRB, 0.38606065E-03_JPRB, 0.38607497E-03_JPRB, &
  & 0.38611506E-03_JPRB, 0.38618921E-03_JPRB, 0.38619624E-03_JPRB, 0.38635071E-03_JPRB, 0.38651086E-03_JPRB, 0.38656745E-03_JPRB, &
  & 0.38667449E-03_JPRB, 0.38676346E-03_JPRB, 0.38687004E-03_JPRB, 0.38692816E-03_JPRB, 0.38692431E-03_JPRB, 0.38690719E-03_JPRB, &
  & 0.38726046E-03_JPRB, 0.38751983E-03_JPRB, 0.38723940E-03_JPRB, 0.38768126E-03_JPRB  /)

RGHG1(:,62, 6) = (/ &
  & 0.38228750E-03_JPRB, 0.38232147E-03_JPRB, 0.38236379E-03_JPRB, 0.38238519E-03_JPRB, 0.38237704E-03_JPRB, 0.38229246E-03_JPRB, &
  & 0.38245813E-03_JPRB, 0.38243711E-03_JPRB, 0.38245572E-03_JPRB, 0.38230010E-03_JPRB, 0.38219236E-03_JPRB, 0.38212504E-03_JPRB, &
  & 0.38202290E-03_JPRB, 0.38191007E-03_JPRB, 0.38184767E-03_JPRB, 0.38175154E-03_JPRB, 0.38170791E-03_JPRB, 0.38173340E-03_JPRB, &
  & 0.38173989E-03_JPRB, 0.38172809E-03_JPRB, 0.38177654E-03_JPRB, 0.38192640E-03_JPRB, 0.38217756E-03_JPRB, 0.38240601E-03_JPRB, &
  & 0.38269406E-03_JPRB, 0.38313809E-03_JPRB, 0.38358562E-03_JPRB, 0.38391416E-03_JPRB, 0.38419637E-03_JPRB, 0.38445837E-03_JPRB, &
  & 0.38479068E-03_JPRB, 0.38537081E-03_JPRB, 0.38595562E-03_JPRB, 0.38674008E-03_JPRB, 0.38753294E-03_JPRB, 0.38801799E-03_JPRB, &
  & 0.38798854E-03_JPRB, 0.38772136E-03_JPRB, 0.38750544E-03_JPRB, 0.38725014E-03_JPRB, 0.38701144E-03_JPRB, 0.38683893E-03_JPRB, &
  & 0.38664369E-03_JPRB, 0.38637114E-03_JPRB, 0.38611979E-03_JPRB, 0.38605229E-03_JPRB, 0.38606721E-03_JPRB, 0.38607964E-03_JPRB, &
  & 0.38614806E-03_JPRB, 0.38624117E-03_JPRB, 0.38628072E-03_JPRB, 0.38644726E-03_JPRB, 0.38662410E-03_JPRB, 0.38669357E-03_JPRB, &
  & 0.38684372E-03_JPRB, 0.38696126E-03_JPRB, 0.38710434E-03_JPRB, 0.38724336E-03_JPRB, 0.38729968E-03_JPRB, 0.38735599E-03_JPRB, &
  & 0.38773075E-03_JPRB, 0.38801881E-03_JPRB, 0.38783364E-03_JPRB, 0.38831199E-03_JPRB  /)

RGHG1(:,63, 6) = (/ &
  & 0.38245628E-03_JPRB, 0.38253257E-03_JPRB, 0.38256852E-03_JPRB, 0.38258216E-03_JPRB, 0.38255682E-03_JPRB, 0.38245471E-03_JPRB, &
  & 0.38262257E-03_JPRB, 0.38258398E-03_JPRB, 0.38258978E-03_JPRB, 0.38242118E-03_JPRB, 0.38229505E-03_JPRB, 0.38221332E-03_JPRB, &
  & 0.38211630E-03_JPRB, 0.38198272E-03_JPRB, 0.38189298E-03_JPRB, 0.38175236E-03_JPRB, 0.38168013E-03_JPRB, 0.38170654E-03_JPRB, &
  & 0.38170219E-03_JPRB, 0.38168129E-03_JPRB, 0.38172521E-03_JPRB, 0.38183923E-03_JPRB, 0.38206640E-03_JPRB, 0.38229350E-03_JPRB, &
  & 0.38257026E-03_JPRB, 0.38302950E-03_JPRB, 0.38347569E-03_JPRB, 0.38381898E-03_JPRB, 0.38408396E-03_JPRB, 0.38436643E-03_JPRB, &
  & 0.38471760E-03_JPRB, 0.38528377E-03_JPRB, 0.38589015E-03_JPRB, 0.38667625E-03_JPRB, 0.38746083E-03_JPRB, 0.38791000E-03_JPRB, &
  & 0.38786490E-03_JPRB, 0.38760753E-03_JPRB, 0.38741327E-03_JPRB, 0.38717628E-03_JPRB, 0.38697758E-03_JPRB, 0.38683697E-03_JPRB, &
  & 0.38665169E-03_JPRB, 0.38635884E-03_JPRB, 0.38610423E-03_JPRB, 0.38606710E-03_JPRB, 0.38609394E-03_JPRB, 0.38610420E-03_JPRB, &
  & 0.38620749E-03_JPRB, 0.38631519E-03_JPRB, 0.38638511E-03_JPRB, 0.38655941E-03_JPRB, 0.38675281E-03_JPRB, 0.38683570E-03_JPRB, &
  & 0.38702962E-03_JPRB, 0.38717749E-03_JPRB, 0.38736139E-03_JPRB, 0.38757657E-03_JPRB, 0.38768498E-03_JPRB, 0.38781522E-03_JPRB, &
  & 0.38820881E-03_JPRB, 0.38852473E-03_JPRB, 0.38844983E-03_JPRB, 0.38895694E-03_JPRB  /)

RGHG1(:,64, 6) = (/ &
  & 0.38263835E-03_JPRB, 0.38273101E-03_JPRB, 0.38275833E-03_JPRB, 0.38275504E-03_JPRB, 0.38271681E-03_JPRB, 0.38260595E-03_JPRB, &
  & 0.38277471E-03_JPRB, 0.38272188E-03_JPRB, 0.38271119E-03_JPRB, 0.38253811E-03_JPRB, 0.38239068E-03_JPRB, 0.38229280E-03_JPRB, &
  & 0.38220094E-03_JPRB, 0.38205469E-03_JPRB, 0.38194130E-03_JPRB, 0.38176268E-03_JPRB, 0.38166107E-03_JPRB, 0.38168401E-03_JPRB, &
  & 0.38166250E-03_JPRB, 0.38163768E-03_JPRB, 0.38168036E-03_JPRB, 0.38176490E-03_JPRB, 0.38196023E-03_JPRB, 0.38219439E-03_JPRB, &
  & 0.38244234E-03_JPRB, 0.38291615E-03_JPRB, 0.38336470E-03_JPRB, 0.38373007E-03_JPRB, 0.38399540E-03_JPRB, 0.38430151E-03_JPRB, &
  & 0.38466759E-03_JPRB, 0.38522401E-03_JPRB, 0.38583309E-03_JPRB, 0.38661974E-03_JPRB, 0.38738964E-03_JPRB, 0.38780383E-03_JPRB, &
  & 0.38774954E-03_JPRB, 0.38752815E-03_JPRB, 0.38735822E-03_JPRB, 0.38713189E-03_JPRB, 0.38698027E-03_JPRB, 0.38686197E-03_JPRB, &
  & 0.38668812E-03_JPRB, 0.38638283E-03_JPRB, 0.38613674E-03_JPRB, 0.38611474E-03_JPRB, 0.38614540E-03_JPRB, 0.38615723E-03_JPRB, &
  & 0.38630032E-03_JPRB, 0.38641699E-03_JPRB, 0.38651303E-03_JPRB, 0.38669036E-03_JPRB, 0.38689878E-03_JPRB, 0.38699916E-03_JPRB, &
  & 0.38723366E-03_JPRB, 0.38741337E-03_JPRB, 0.38764616E-03_JPRB, 0.38792087E-03_JPRB, 0.38807244E-03_JPRB, 0.38826412E-03_JPRB, &
  & 0.38867520E-03_JPRB, 0.38901657E-03_JPRB, 0.38905546E-03_JPRB, 0.38956683E-03_JPRB  /)

RGHG1(:,65, 6) = (/ &
  & 0.38283277E-03_JPRB, 0.38292512E-03_JPRB, 0.38294259E-03_JPRB, 0.38291494E-03_JPRB, 0.38286601E-03_JPRB, 0.38274978E-03_JPRB, &
  & 0.38291308E-03_JPRB, 0.38285623E-03_JPRB, 0.38282655E-03_JPRB, 0.38266168E-03_JPRB, 0.38249101E-03_JPRB, 0.38237707E-03_JPRB, &
  & 0.38228279E-03_JPRB, 0.38213014E-03_JPRB, 0.38199323E-03_JPRB, 0.38178945E-03_JPRB, 0.38165929E-03_JPRB, 0.38167278E-03_JPRB, &
  & 0.38163764E-03_JPRB, 0.38160500E-03_JPRB, 0.38164258E-03_JPRB, 0.38170534E-03_JPRB, 0.38186587E-03_JPRB, 0.38211738E-03_JPRB, &
  & 0.38233818E-03_JPRB, 0.38279683E-03_JPRB, 0.38327123E-03_JPRB, 0.38366188E-03_JPRB, 0.38395154E-03_JPRB, 0.38426845E-03_JPRB, &
  & 0.38465342E-03_JPRB, 0.38520502E-03_JPRB, 0.38582077E-03_JPRB, 0.38657575E-03_JPRB, 0.38732427E-03_JPRB, 0.38772033E-03_JPRB, &
  & 0.38766377E-03_JPRB, 0.38748229E-03_JPRB, 0.38734418E-03_JPRB, 0.38713306E-03_JPRB, 0.38701408E-03_JPRB, 0.38690876E-03_JPRB, &
  & 0.38674352E-03_JPRB, 0.38644436E-03_JPRB, 0.38622710E-03_JPRB, 0.38620982E-03_JPRB, 0.38623116E-03_JPRB, 0.38624896E-03_JPRB, &
  & 0.38642464E-03_JPRB, 0.38654763E-03_JPRB, 0.38666853E-03_JPRB, 0.38684797E-03_JPRB, 0.38706788E-03_JPRB, 0.38719173E-03_JPRB, &
  & 0.38746170E-03_JPRB, 0.38766785E-03_JPRB, 0.38795981E-03_JPRB, 0.38826748E-03_JPRB, 0.38846035E-03_JPRB, 0.38868618E-03_JPRB, &
  & 0.38910622E-03_JPRB, 0.38948252E-03_JPRB, 0.38960269E-03_JPRB, 0.39007515E-03_JPRB  /)

RGHG1(:,66, 6) = (/ &
  & 0.38303037E-03_JPRB, 0.38311752E-03_JPRB, 0.38312511E-03_JPRB, 0.38307278E-03_JPRB, 0.38301024E-03_JPRB, 0.38289261E-03_JPRB, &
  & 0.38304418E-03_JPRB, 0.38298872E-03_JPRB, 0.38294113E-03_JPRB, 0.38279006E-03_JPRB, 0.38259758E-03_JPRB, 0.38246875E-03_JPRB, &
  & 0.38236835E-03_JPRB, 0.38221309E-03_JPRB, 0.38205097E-03_JPRB, 0.38182890E-03_JPRB, 0.38167360E-03_JPRB, 0.38167432E-03_JPRB, &
  & 0.38162993E-03_JPRB, 0.38158661E-03_JPRB, 0.38161053E-03_JPRB, 0.38165423E-03_JPRB, 0.38179265E-03_JPRB, 0.38205393E-03_JPRB, &
  & 0.38225510E-03_JPRB, 0.38268686E-03_JPRB, 0.38319267E-03_JPRB, 0.38360049E-03_JPRB, 0.38392408E-03_JPRB, 0.38424262E-03_JPRB, &
  & 0.38464622E-03_JPRB, 0.38520518E-03_JPRB, 0.38582258E-03_JPRB, 0.38653470E-03_JPRB, 0.38726698E-03_JPRB, 0.38764686E-03_JPRB, &
  & 0.38759515E-03_JPRB, 0.38745165E-03_JPRB, 0.38734557E-03_JPRB, 0.38716059E-03_JPRB, 0.38706143E-03_JPRB, 0.38696678E-03_JPRB, &
  & 0.38681054E-03_JPRB, 0.38652516E-03_JPRB, 0.38634009E-03_JPRB, 0.38632381E-03_JPRB, 0.38633717E-03_JPRB, 0.38636204E-03_JPRB, &
  & 0.38656174E-03_JPRB, 0.38669144E-03_JPRB, 0.38684027E-03_JPRB, 0.38702407E-03_JPRB, 0.38725454E-03_JPRB, 0.38740669E-03_JPRB, &
  & 0.38770416E-03_JPRB, 0.38793720E-03_JPRB, 0.38828514E-03_JPRB, 0.38861648E-03_JPRB, 0.38884705E-03_JPRB, 0.38909199E-03_JPRB, &
  & 0.38951770E-03_JPRB, 0.38993520E-03_JPRB, 0.39009978E-03_JPRB, 0.39052067E-03_JPRB  /)

RGHG1(:,67, 6) = (/ &
  & 0.38322310E-03_JPRB, 0.38330282E-03_JPRB, 0.38330250E-03_JPRB, 0.38322556E-03_JPRB, 0.38314759E-03_JPRB, 0.38303206E-03_JPRB, &
  & 0.38316745E-03_JPRB, 0.38311783E-03_JPRB, 0.38305458E-03_JPRB, 0.38291952E-03_JPRB, 0.38270930E-03_JPRB, 0.38256684E-03_JPRB, &
  & 0.38245828E-03_JPRB, 0.38230390E-03_JPRB, 0.38211578E-03_JPRB, 0.38188163E-03_JPRB, 0.38170711E-03_JPRB, 0.38169080E-03_JPRB, &
  & 0.38164055E-03_JPRB, 0.38158625E-03_JPRB, 0.38158814E-03_JPRB, 0.38161519E-03_JPRB, 0.38174353E-03_JPRB, 0.38200366E-03_JPRB, &
  & 0.38219532E-03_JPRB, 0.38259111E-03_JPRB, 0.38312700E-03_JPRB, 0.38354230E-03_JPRB, 0.38390319E-03_JPRB, 0.38421792E-03_JPRB, &
  & 0.38463965E-03_JPRB, 0.38521775E-03_JPRB, 0.38583151E-03_JPRB, 0.38649612E-03_JPRB, 0.38721431E-03_JPRB, 0.38758439E-03_JPRB, &
  & 0.38754156E-03_JPRB, 0.38743223E-03_JPRB, 0.38735808E-03_JPRB, 0.38720795E-03_JPRB, 0.38711816E-03_JPRB, 0.38703654E-03_JPRB, &
  & 0.38688833E-03_JPRB, 0.38662130E-03_JPRB, 0.38646603E-03_JPRB, 0.38644879E-03_JPRB, 0.38645811E-03_JPRB, 0.38649180E-03_JPRB, &
  & 0.38670636E-03_JPRB, 0.38684396E-03_JPRB, 0.38702230E-03_JPRB, 0.38721371E-03_JPRB, 0.38745570E-03_JPRB, 0.38763901E-03_JPRB, &
  & 0.38795625E-03_JPRB, 0.38821705E-03_JPRB, 0.38861292E-03_JPRB, 0.38896433E-03_JPRB, 0.38922507E-03_JPRB, 0.38947753E-03_JPRB, &
  & 0.38990390E-03_JPRB, 0.39036483E-03_JPRB, 0.39054620E-03_JPRB, 0.39090505E-03_JPRB  /)

RGHG1(:,68, 6) = (/ &
  & 0.38339808E-03_JPRB, 0.38347170E-03_JPRB, 0.38346943E-03_JPRB, 0.38336693E-03_JPRB, 0.38327503E-03_JPRB, 0.38316387E-03_JPRB, &
  & 0.38328257E-03_JPRB, 0.38324193E-03_JPRB, 0.38316671E-03_JPRB, 0.38304396E-03_JPRB, 0.38282477E-03_JPRB, 0.38266964E-03_JPRB, &
  & 0.38255371E-03_JPRB, 0.38240336E-03_JPRB, 0.38219049E-03_JPRB, 0.38194978E-03_JPRB, 0.38176629E-03_JPRB, 0.38172614E-03_JPRB, &
  & 0.38167083E-03_JPRB, 0.38161054E-03_JPRB, 0.38158342E-03_JPRB, 0.38159619E-03_JPRB, 0.38172120E-03_JPRB, 0.38196601E-03_JPRB, &
  & 0.38216217E-03_JPRB, 0.38251501E-03_JPRB, 0.38306863E-03_JPRB, 0.38348129E-03_JPRB, 0.38387246E-03_JPRB, 0.38418545E-03_JPRB, &
  & 0.38462549E-03_JPRB, 0.38523179E-03_JPRB, 0.38583807E-03_JPRB, 0.38646021E-03_JPRB, 0.38715733E-03_JPRB, 0.38753604E-03_JPRB, &
  & 0.38749919E-03_JPRB, 0.38741807E-03_JPRB, 0.38737696E-03_JPRB, 0.38726436E-03_JPRB, 0.38717894E-03_JPRB, 0.38712161E-03_JPRB, &
  & 0.38697697E-03_JPRB, 0.38672836E-03_JPRB, 0.38659186E-03_JPRB, 0.38657427E-03_JPRB, 0.38658600E-03_JPRB, 0.38663236E-03_JPRB, &
  & 0.38685233E-03_JPRB, 0.38700017E-03_JPRB, 0.38720592E-03_JPRB, 0.38740965E-03_JPRB, 0.38766787E-03_JPRB, 0.38788133E-03_JPRB, &
  & 0.38821239E-03_JPRB, 0.38850197E-03_JPRB, 0.38893088E-03_JPRB, 0.38930819E-03_JPRB, 0.38958413E-03_JPRB, 0.38983843E-03_JPRB, &
  & 0.39025594E-03_JPRB, 0.39075474E-03_JPRB, 0.39094808E-03_JPRB, 0.39123279E-03_JPRB  /)

RGHG1(:,69, 6) = (/ &
  & 0.38353667E-03_JPRB, 0.38361100E-03_JPRB, 0.38361159E-03_JPRB, 0.38349025E-03_JPRB, 0.38338987E-03_JPRB, 0.38328330E-03_JPRB, &
  & 0.38339012E-03_JPRB, 0.38335637E-03_JPRB, 0.38327641E-03_JPRB, 0.38315759E-03_JPRB, 0.38294535E-03_JPRB, 0.38277913E-03_JPRB, &
  & 0.38265500E-03_JPRB, 0.38250752E-03_JPRB, 0.38227755E-03_JPRB, 0.38203688E-03_JPRB, 0.38185059E-03_JPRB, 0.38178421E-03_JPRB, &
  & 0.38172823E-03_JPRB, 0.38166427E-03_JPRB, 0.38161045E-03_JPRB, 0.38160863E-03_JPRB, 0.38171846E-03_JPRB, 0.38192575E-03_JPRB, &
  & 0.38213478E-03_JPRB, 0.38245475E-03_JPRB, 0.38301227E-03_JPRB, 0.38341830E-03_JPRB, 0.38382769E-03_JPRB, 0.38414755E-03_JPRB, &
  & 0.38459813E-03_JPRB, 0.38522310E-03_JPRB, 0.38581372E-03_JPRB, 0.38639946E-03_JPRB, 0.38708569E-03_JPRB, 0.38749126E-03_JPRB, &
  & 0.38746909E-03_JPRB, 0.38741240E-03_JPRB, 0.38739636E-03_JPRB, 0.38731060E-03_JPRB, 0.38723961E-03_JPRB, 0.38720918E-03_JPRB, &
  & 0.38706853E-03_JPRB, 0.38683865E-03_JPRB, 0.38671179E-03_JPRB, 0.38669459E-03_JPRB, 0.38670707E-03_JPRB, 0.38676933E-03_JPRB, &
  & 0.38698990E-03_JPRB, 0.38715008E-03_JPRB, 0.38737525E-03_JPRB, 0.38759328E-03_JPRB, 0.38787434E-03_JPRB, 0.38811481E-03_JPRB, &
  & 0.38845895E-03_JPRB, 0.38877866E-03_JPRB, 0.38922856E-03_JPRB, 0.38963481E-03_JPRB, 0.38991797E-03_JPRB, 0.39017883E-03_JPRB, &
  & 0.39057354E-03_JPRB, 0.39109104E-03_JPRB, 0.39132390E-03_JPRB, 0.39151134E-03_JPRB  /)

RGHG1(:,70, 6) = (/ &
  & 0.38365328E-03_JPRB, 0.38372760E-03_JPRB, 0.38373287E-03_JPRB, 0.38360066E-03_JPRB, 0.38349259E-03_JPRB, 0.38339538E-03_JPRB, &
  & 0.38348899E-03_JPRB, 0.38346393E-03_JPRB, 0.38338381E-03_JPRB, 0.38326503E-03_JPRB, 0.38306533E-03_JPRB, 0.38288909E-03_JPRB, &
  & 0.38275592E-03_JPRB, 0.38261062E-03_JPRB, 0.38237163E-03_JPRB, 0.38213506E-03_JPRB, 0.38194651E-03_JPRB, 0.38185789E-03_JPRB, &
  & 0.38180034E-03_JPRB, 0.38173218E-03_JPRB, 0.38165746E-03_JPRB, 0.38164508E-03_JPRB, 0.38173010E-03_JPRB, 0.38189138E-03_JPRB, &
  & 0.38210376E-03_JPRB, 0.38240356E-03_JPRB, 0.38294595E-03_JPRB, 0.38334829E-03_JPRB, 0.38376237E-03_JPRB, 0.38408662E-03_JPRB, &
  & 0.38453637E-03_JPRB, 0.38517254E-03_JPRB, 0.38574099E-03_JPRB, 0.38631146E-03_JPRB, 0.38699914E-03_JPRB, 0.38743778E-03_JPRB, &
  & 0.38743955E-03_JPRB, 0.38740608E-03_JPRB, 0.38740775E-03_JPRB, 0.38734575E-03_JPRB, 0.38729858E-03_JPRB, 0.38729149E-03_JPRB, &
  & 0.38715849E-03_JPRB, 0.38694968E-03_JPRB, 0.38682690E-03_JPRB, 0.38680756E-03_JPRB, 0.38682395E-03_JPRB, 0.38689445E-03_JPRB, &
  & 0.38711038E-03_JPRB, 0.38728694E-03_JPRB, 0.38752552E-03_JPRB, 0.38775909E-03_JPRB, 0.38806159E-03_JPRB, 0.38832421E-03_JPRB, &
  & 0.38868559E-03_JPRB, 0.38903824E-03_JPRB, 0.38950751E-03_JPRB, 0.38994105E-03_JPRB, 0.39023174E-03_JPRB, 0.39050090E-03_JPRB, &
  & 0.39087514E-03_JPRB, 0.39140452E-03_JPRB, 0.39167537E-03_JPRB, 0.39178344E-03_JPRB  /)

RGHG1(:,71, 6) = (/ &
  & 0.38375043E-03_JPRB, 0.38382287E-03_JPRB, 0.38383295E-03_JPRB, 0.38369851E-03_JPRB, 0.38358257E-03_JPRB, 0.38350039E-03_JPRB, &
  & 0.38357982E-03_JPRB, 0.38356450E-03_JPRB, 0.38348834E-03_JPRB, 0.38336664E-03_JPRB, 0.38318072E-03_JPRB, 0.38299778E-03_JPRB, &
  & 0.38285512E-03_JPRB, 0.38271129E-03_JPRB, 0.38247150E-03_JPRB, 0.38224178E-03_JPRB, 0.38205080E-03_JPRB, 0.38194530E-03_JPRB, &
  & 0.38188377E-03_JPRB, 0.38181027E-03_JPRB, 0.38172074E-03_JPRB, 0.38170231E-03_JPRB, 0.38175515E-03_JPRB, 0.38186801E-03_JPRB, &
  & 0.38207323E-03_JPRB, 0.38236060E-03_JPRB, 0.38286974E-03_JPRB, 0.38326904E-03_JPRB, 0.38367163E-03_JPRB, 0.38399467E-03_JPRB, &
  & 0.38443171E-03_JPRB, 0.38507045E-03_JPRB, 0.38562044E-03_JPRB, 0.38619507E-03_JPRB, 0.38689516E-03_JPRB, 0.38737355E-03_JPRB, &
  & 0.38740739E-03_JPRB, 0.38739618E-03_JPRB, 0.38741007E-03_JPRB, 0.38737256E-03_JPRB, 0.38735575E-03_JPRB, 0.38736640E-03_JPRB, &
  & 0.38724659E-03_JPRB, 0.38705774E-03_JPRB, 0.38693444E-03_JPRB, 0.38691178E-03_JPRB, 0.38693316E-03_JPRB, 0.38700471E-03_JPRB, &
  & 0.38720752E-03_JPRB, 0.38740195E-03_JPRB, 0.38764984E-03_JPRB, 0.38789784E-03_JPRB, 0.38821939E-03_JPRB, 0.38849985E-03_JPRB, &
  & 0.38888362E-03_JPRB, 0.38927290E-03_JPRB, 0.38976302E-03_JPRB, 0.39022302E-03_JPRB, 0.39052312E-03_JPRB, 0.39080169E-03_JPRB, &
  & 0.39116484E-03_JPRB, 0.39170084E-03_JPRB, 0.39199815E-03_JPRB, 0.39205001E-03_JPRB  /)

RGHG1(:,72, 6) = (/ &
  & 0.38382983E-03_JPRB, 0.38389788E-03_JPRB, 0.38391027E-03_JPRB, 0.38378344E-03_JPRB, 0.38365851E-03_JPRB, 0.38359800E-03_JPRB, &
  & 0.38366428E-03_JPRB, 0.38365749E-03_JPRB, 0.38358917E-03_JPRB, 0.38346240E-03_JPRB, 0.38328523E-03_JPRB, 0.38310345E-03_JPRB, &
  & 0.38295157E-03_JPRB, 0.38280843E-03_JPRB, 0.38257648E-03_JPRB, 0.38235436E-03_JPRB, 0.38216062E-03_JPRB, 0.38204498E-03_JPRB, &
  & 0.38197515E-03_JPRB, 0.38189450E-03_JPRB, 0.38179622E-03_JPRB, 0.38177641E-03_JPRB, 0.38179329E-03_JPRB, 0.38186398E-03_JPRB, &
  & 0.38205306E-03_JPRB, 0.38232568E-03_JPRB, 0.38278573E-03_JPRB, 0.38317674E-03_JPRB, 0.38354637E-03_JPRB, 0.38385881E-03_JPRB, &
  & 0.38427073E-03_JPRB, 0.38490048E-03_JPRB, 0.38545531E-03_JPRB, 0.38604745E-03_JPRB, 0.38676806E-03_JPRB, 0.38729668E-03_JPRB, &
  & 0.38736878E-03_JPRB, 0.38737878E-03_JPRB, 0.38740281E-03_JPRB, 0.38739641E-03_JPRB, 0.38741140E-03_JPRB, 0.38743151E-03_JPRB, &
  & 0.38733359E-03_JPRB, 0.38715650E-03_JPRB, 0.38702905E-03_JPRB, 0.38700524E-03_JPRB, 0.38702753E-03_JPRB, 0.38709610E-03_JPRB, &
  & 0.38727079E-03_JPRB, 0.38747927E-03_JPRB, 0.38773569E-03_JPRB, 0.38799267E-03_JPRB, 0.38833059E-03_JPRB, 0.38862603E-03_JPRB, &
  & 0.38903838E-03_JPRB, 0.38946960E-03_JPRB, 0.38998600E-03_JPRB, 0.39047435E-03_JPRB, 0.39078712E-03_JPRB, 0.39107560E-03_JPRB, &
  & 0.39144751E-03_JPRB, 0.39198513E-03_JPRB, 0.39228405E-03_JPRB, 0.39230456E-03_JPRB  /)

RGHG1(:,73, 6) = (/ &
  & 0.38389247E-03_JPRB, 0.38395676E-03_JPRB, 0.38397018E-03_JPRB, 0.38385528E-03_JPRB, 0.38372559E-03_JPRB, 0.38368494E-03_JPRB, &
  & 0.38373951E-03_JPRB, 0.38374129E-03_JPRB, 0.38368171E-03_JPRB, 0.38355412E-03_JPRB, 0.38338127E-03_JPRB, 0.38320898E-03_JPRB, &
  & 0.38305169E-03_JPRB, 0.38291031E-03_JPRB, 0.38269458E-03_JPRB, 0.38248204E-03_JPRB, 0.38228915E-03_JPRB, 0.38216844E-03_JPRB, &
  & 0.38208599E-03_JPRB, 0.38200201E-03_JPRB, 0.38189812E-03_JPRB, 0.38187200E-03_JPRB, 0.38185743E-03_JPRB, 0.38189297E-03_JPRB, &
  & 0.38205705E-03_JPRB, 0.38230372E-03_JPRB, 0.38270027E-03_JPRB, 0.38305705E-03_JPRB, 0.38337920E-03_JPRB, 0.38366087E-03_JPRB, &
  & 0.38404453E-03_JPRB, 0.38467743E-03_JPRB, 0.38525959E-03_JPRB, 0.38586229E-03_JPRB, 0.38660930E-03_JPRB, 0.38720665E-03_JPRB, &
  & 0.38732835E-03_JPRB, 0.38735625E-03_JPRB, 0.38739711E-03_JPRB, 0.38742393E-03_JPRB, 0.38746685E-03_JPRB, 0.38749303E-03_JPRB, &
  & 0.38741351E-03_JPRB, 0.38724075E-03_JPRB, 0.38710827E-03_JPRB, 0.38708266E-03_JPRB, 0.38709647E-03_JPRB, 0.38715089E-03_JPRB, &
  & 0.38729431E-03_JPRB, 0.38751566E-03_JPRB, 0.38776503E-03_JPRB, 0.38801352E-03_JPRB, 0.38837003E-03_JPRB, 0.38869466E-03_JPRB, &
  & 0.38913703E-03_JPRB, 0.38961044E-03_JPRB, 0.39016931E-03_JPRB, 0.39069195E-03_JPRB, 0.39102539E-03_JPRB, 0.39132832E-03_JPRB, &
  & 0.39172123E-03_JPRB, 0.39226753E-03_JPRB, 0.39257257E-03_JPRB, 0.39253461E-03_JPRB  /)

RGHG1(:,74, 6) = (/ &
  & 0.38394743E-03_JPRB, 0.38400858E-03_JPRB, 0.38402264E-03_JPRB, 0.38391877E-03_JPRB, 0.38378941E-03_JPRB, 0.38376442E-03_JPRB, &
  & 0.38381158E-03_JPRB, 0.38381679E-03_JPRB, 0.38376350E-03_JPRB, 0.38364046E-03_JPRB, 0.38347516E-03_JPRB, 0.38331432E-03_JPRB, &
  & 0.38315388E-03_JPRB, 0.38301686E-03_JPRB, 0.38282306E-03_JPRB, 0.38262288E-03_JPRB, 0.38243060E-03_JPRB, 0.38230345E-03_JPRB, &
  & 0.38221080E-03_JPRB, 0.38212757E-03_JPRB, 0.38202253E-03_JPRB, 0.38198176E-03_JPRB, 0.38193726E-03_JPRB, 0.38194162E-03_JPRB, &
  & 0.38208430E-03_JPRB, 0.38229797E-03_JPRB, 0.38261555E-03_JPRB, 0.38292107E-03_JPRB, 0.38318497E-03_JPRB, 0.38342961E-03_JPRB, &
  & 0.38379994E-03_JPRB, 0.38443270E-03_JPRB, 0.38504850E-03_JPRB, 0.38566437E-03_JPRB, 0.38643171E-03_JPRB, 0.38711052E-03_JPRB, &
  & 0.38730416E-03_JPRB, 0.38735329E-03_JPRB, 0.38740999E-03_JPRB, 0.38746600E-03_JPRB, 0.38753370E-03_JPRB, 0.38756846E-03_JPRB, &
  & 0.38749782E-03_JPRB, 0.38732459E-03_JPRB, 0.38718409E-03_JPRB, 0.38715552E-03_JPRB, 0.38715241E-03_JPRB, 0.38718356E-03_JPRB, &
  & 0.38730257E-03_JPRB, 0.38752399E-03_JPRB, 0.38776600E-03_JPRB, 0.38799367E-03_JPRB, 0.38836575E-03_JPRB, 0.38872309E-03_JPRB, &
  & 0.38919850E-03_JPRB, 0.38971422E-03_JPRB, 0.39032744E-03_JPRB, 0.39089054E-03_JPRB, 0.39124543E-03_JPRB, 0.39156751E-03_JPRB, &
  & 0.39197686E-03_JPRB, 0.39254411E-03_JPRB, 0.39285119E-03_JPRB, 0.39276102E-03_JPRB  /)

RGHG1(:,75, 6) = (/ &
  & 0.38399767E-03_JPRB, 0.38405560E-03_JPRB, 0.38406930E-03_JPRB, 0.38397469E-03_JPRB, 0.38384975E-03_JPRB, 0.38383611E-03_JPRB, &
  & 0.38387960E-03_JPRB, 0.38388386E-03_JPRB, 0.38383442E-03_JPRB, 0.38371968E-03_JPRB, 0.38356643E-03_JPRB, 0.38341784E-03_JPRB, &
  & 0.38325612E-03_JPRB, 0.38312395E-03_JPRB, 0.38295662E-03_JPRB, 0.38277060E-03_JPRB, 0.38257804E-03_JPRB, 0.38244517E-03_JPRB, &
  & 0.38234632E-03_JPRB, 0.38226530E-03_JPRB, 0.38216143E-03_JPRB, 0.38210168E-03_JPRB, 0.38203069E-03_JPRB, 0.38200770E-03_JPRB, &
  & 0.38212966E-03_JPRB, 0.38230476E-03_JPRB, 0.38253383E-03_JPRB, 0.38277439E-03_JPRB, 0.38297874E-03_JPRB, 0.38318992E-03_JPRB, &
  & 0.38355651E-03_JPRB, 0.38418211E-03_JPRB, 0.38483027E-03_JPRB, 0.38546292E-03_JPRB, 0.38624435E-03_JPRB, 0.38700991E-03_JPRB, &
  & 0.38730003E-03_JPRB, 0.38737789E-03_JPRB, 0.38745028E-03_JPRB, 0.38752516E-03_JPRB, 0.38761644E-03_JPRB, 0.38766587E-03_JPRB, &
  & 0.38759468E-03_JPRB, 0.38741567E-03_JPRB, 0.38726747E-03_JPRB, 0.38722984E-03_JPRB, 0.38720012E-03_JPRB, 0.38719994E-03_JPRB, &
  & 0.38730384E-03_JPRB, 0.38751318E-03_JPRB, 0.38774638E-03_JPRB, 0.38794737E-03_JPRB, 0.38833017E-03_JPRB, 0.38872317E-03_JPRB, &
  & 0.38922996E-03_JPRB, 0.38979052E-03_JPRB, 0.39046580E-03_JPRB, 0.39107520E-03_JPRB, 0.39145215E-03_JPRB, 0.39179618E-03_JPRB, &
  & 0.39221779E-03_JPRB, 0.39282142E-03_JPRB, 0.39313287E-03_JPRB, 0.39299887E-03_JPRB  /)

RGHG1(:,76, 6) = (/ &
  & 0.38404654E-03_JPRB, 0.38410009E-03_JPRB, 0.38411125E-03_JPRB, 0.38402356E-03_JPRB, 0.38390554E-03_JPRB, 0.38389904E-03_JPRB, &
  & 0.38394138E-03_JPRB, 0.38394218E-03_JPRB, 0.38389459E-03_JPRB, 0.38378930E-03_JPRB, 0.38365357E-03_JPRB, 0.38351719E-03_JPRB, &
  & 0.38335570E-03_JPRB, 0.38322538E-03_JPRB, 0.38308778E-03_JPRB, 0.38291606E-03_JPRB, 0.38272189E-03_JPRB, 0.38258833E-03_JPRB, &
  & 0.38248878E-03_JPRB, 0.38240730E-03_JPRB, 0.38230343E-03_JPRB, 0.38222709E-03_JPRB, 0.38213650E-03_JPRB, 0.38209022E-03_JPRB, &
  & 0.38218568E-03_JPRB, 0.38231813E-03_JPRB, 0.38245822E-03_JPRB, 0.38262363E-03_JPRB, 0.38278141E-03_JPRB, 0.38297622E-03_JPRB, &
  & 0.38333774E-03_JPRB, 0.38394536E-03_JPRB, 0.38461496E-03_JPRB, 0.38526836E-03_JPRB, 0.38605901E-03_JPRB, 0.38690595E-03_JPRB, &
  & 0.38731986E-03_JPRB, 0.38743991E-03_JPRB, 0.38753027E-03_JPRB, 0.38760446E-03_JPRB, 0.38772110E-03_JPRB, 0.38779635E-03_JPRB, &
  & 0.38771594E-03_JPRB, 0.38752448E-03_JPRB, 0.38737443E-03_JPRB, 0.38731375E-03_JPRB, 0.38724530E-03_JPRB, 0.38720686E-03_JPRB, &
  & 0.38730753E-03_JPRB, 0.38749497E-03_JPRB, 0.38771388E-03_JPRB, 0.38789158E-03_JPRB, 0.38827807E-03_JPRB, 0.38871049E-03_JPRB, &
  & 0.38923942E-03_JPRB, 0.38985137E-03_JPRB, 0.39059075E-03_JPRB, 0.39125201E-03_JPRB, 0.39165248E-03_JPRB, 0.39201841E-03_JPRB, &
  & 0.39245108E-03_JPRB, 0.39311119E-03_JPRB, 0.39344085E-03_JPRB, 0.39326996E-03_JPRB  /)

RGHG1(:,77, 6) = (/ &
  & 0.38410021E-03_JPRB, 0.38414333E-03_JPRB, 0.38414549E-03_JPRB, 0.38406504E-03_JPRB, 0.38395558E-03_JPRB, 0.38395123E-03_JPRB, &
  & 0.38399551E-03_JPRB, 0.38399036E-03_JPRB, 0.38394397E-03_JPRB, 0.38384872E-03_JPRB, 0.38372831E-03_JPRB, 0.38360300E-03_JPRB, &
  & 0.38343886E-03_JPRB, 0.38330908E-03_JPRB, 0.38319943E-03_JPRB, 0.38303776E-03_JPRB, 0.38285171E-03_JPRB, 0.38271412E-03_JPRB, &
  & 0.38260700E-03_JPRB, 0.38252528E-03_JPRB, 0.38241741E-03_JPRB, 0.38233333E-03_JPRB, 0.38223195E-03_JPRB, 0.38216428E-03_JPRB, &
  & 0.38222664E-03_JPRB, 0.38232338E-03_JPRB, 0.38239805E-03_JPRB, 0.38249433E-03_JPRB, 0.38262728E-03_JPRB, 0.38282988E-03_JPRB, &
  & 0.38319468E-03_JPRB, 0.38379538E-03_JPRB, 0.38444415E-03_JPRB, 0.38510994E-03_JPRB, 0.38591150E-03_JPRB, 0.38681347E-03_JPRB, &
  & 0.38734185E-03_JPRB, 0.38750757E-03_JPRB, 0.38761063E-03_JPRB, 0.38768678E-03_JPRB, 0.38782625E-03_JPRB, 0.38793634E-03_JPRB, &
  & 0.38784414E-03_JPRB, 0.38764958E-03_JPRB, 0.38750853E-03_JPRB, 0.38740872E-03_JPRB, 0.38729745E-03_JPRB, 0.38722862E-03_JPRB, &
  & 0.38733244E-03_JPRB, 0.38749390E-03_JPRB, 0.38769055E-03_JPRB, 0.38784886E-03_JPRB, 0.38824552E-03_JPRB, 0.38870794E-03_JPRB, &
  & 0.38924867E-03_JPRB, 0.38991920E-03_JPRB, 0.39071248E-03_JPRB, 0.39142436E-03_JPRB, 0.39185200E-03_JPRB, 0.39222018E-03_JPRB, &
  & 0.39266719E-03_JPRB, 0.39336484E-03_JPRB, 0.39369967E-03_JPRB, 0.39347563E-03_JPRB  /)

RGHG1(:,78, 6) = (/ &
  & 0.38415417E-03_JPRB, 0.38418062E-03_JPRB, 0.38417361E-03_JPRB, 0.38410038E-03_JPRB, 0.38400000E-03_JPRB, 0.38399350E-03_JPRB, &
  & 0.38403810E-03_JPRB, 0.38402970E-03_JPRB, 0.38398642E-03_JPRB, 0.38390074E-03_JPRB, 0.38379029E-03_JPRB, 0.38367430E-03_JPRB, &
  & 0.38350752E-03_JPRB, 0.38337702E-03_JPRB, 0.38328218E-03_JPRB, 0.38313596E-03_JPRB, 0.38295704E-03_JPRB, 0.38281749E-03_JPRB, &
  & 0.38270808E-03_JPRB, 0.38262330E-03_JPRB, 0.38251585E-03_JPRB, 0.38242720E-03_JPRB, 0.38231795E-03_JPRB, 0.38223114E-03_JPRB, &
  & 0.38226358E-03_JPRB, 0.38232749E-03_JPRB, 0.38235343E-03_JPRB, 0.38240240E-03_JPRB, 0.38252027E-03_JPRB, 0.38273864E-03_JPRB, &
  & 0.38310569E-03_JPRB, 0.38369771E-03_JPRB, 0.38431880E-03_JPRB, 0.38498653E-03_JPRB, 0.38579816E-03_JPRB, 0.38673362E-03_JPRB, &
  & 0.38736069E-03_JPRB, 0.38756200E-03_JPRB, 0.38767415E-03_JPRB, 0.38775388E-03_JPRB, 0.38792132E-03_JPRB, 0.38806052E-03_JPRB, &
  & 0.38796147E-03_JPRB, 0.38776777E-03_JPRB, 0.38764504E-03_JPRB, 0.38751219E-03_JPRB, 0.38735491E-03_JPRB, 0.38725935E-03_JPRB, &
  & 0.38737336E-03_JPRB, 0.38750321E-03_JPRB, 0.38767443E-03_JPRB, 0.38782268E-03_JPRB, 0.38823339E-03_JPRB, 0.38872074E-03_JPRB, &
  & 0.38926716E-03_JPRB, 0.38998960E-03_JPRB, 0.39082817E-03_JPRB, 0.39159219E-03_JPRB, 0.39204577E-03_JPRB, 0.39241616E-03_JPRB, &
  & 0.39288014E-03_JPRB, 0.39359872E-03_JPRB, 0.39393248E-03_JPRB, 0.39366973E-03_JPRB  /)

RGHG1(:,79, 6) = (/ &
  & 0.38420353E-03_JPRB, 0.38421093E-03_JPRB, 0.38419561E-03_JPRB, 0.38412957E-03_JPRB, 0.38403883E-03_JPRB, 0.38402734E-03_JPRB, &
  & 0.38406991E-03_JPRB, 0.38406048E-03_JPRB, 0.38402211E-03_JPRB, 0.38394319E-03_JPRB, 0.38383970E-03_JPRB, 0.38372991E-03_JPRB, &
  & 0.38356080E-03_JPRB, 0.38342817E-03_JPRB, 0.38333994E-03_JPRB, 0.38321108E-03_JPRB, 0.38303850E-03_JPRB, 0.38289677E-03_JPRB, &
  & 0.38279014E-03_JPRB, 0.38270302E-03_JPRB, 0.38259946E-03_JPRB, 0.38250744E-03_JPRB, 0.38239169E-03_JPRB, 0.38229050E-03_JPRB, &
  & 0.38229792E-03_JPRB, 0.38233312E-03_JPRB, 0.38232605E-03_JPRB, 0.38234549E-03_JPRB, 0.38245478E-03_JPRB, 0.38269004E-03_JPRB, &
  & 0.38305855E-03_JPRB, 0.38364083E-03_JPRB, 0.38423436E-03_JPRB, 0.38489631E-03_JPRB, 0.38571257E-03_JPRB, 0.38666814E-03_JPRB, &
  & 0.38737880E-03_JPRB, 0.38760654E-03_JPRB, 0.38772492E-03_JPRB, 0.38780920E-03_JPRB, 0.38800466E-03_JPRB, 0.38816752E-03_JPRB, &
  & 0.38806609E-03_JPRB, 0.38787605E-03_JPRB, 0.38777407E-03_JPRB, 0.38761897E-03_JPRB, 0.38741651E-03_JPRB, 0.38729815E-03_JPRB, &
  & 0.38742643E-03_JPRB, 0.38752462E-03_JPRB, 0.38767116E-03_JPRB, 0.38781328E-03_JPRB, 0.38823926E-03_JPRB, 0.38874745E-03_JPRB, &
  & 0.38929517E-03_JPRB, 0.39005910E-03_JPRB, 0.39093639E-03_JPRB, 0.39175216E-03_JPRB, 0.39222812E-03_JPRB, 0.39259967E-03_JPRB, &
  & 0.39308167E-03_JPRB, 0.39380447E-03_JPRB, 0.39412903E-03_JPRB, 0.39384968E-03_JPRB  /)

RGHG1(:,80, 6) = (/ &
  & 0.38424322E-03_JPRB, 0.38423354E-03_JPRB, 0.38421155E-03_JPRB, 0.38415263E-03_JPRB, 0.38407222E-03_JPRB, 0.38405451E-03_JPRB, &
  & 0.38409227E-03_JPRB, 0.38408307E-03_JPRB, 0.38405114E-03_JPRB, 0.38397359E-03_JPRB, 0.38387703E-03_JPRB, 0.38376891E-03_JPRB, &
  & 0.38359799E-03_JPRB, 0.38346164E-03_JPRB, 0.38337827E-03_JPRB, 0.38326420E-03_JPRB, 0.38309808E-03_JPRB, 0.38295097E-03_JPRB, &
  & 0.38285101E-03_JPRB, 0.38276644E-03_JPRB, 0.38266864E-03_JPRB, 0.38257245E-03_JPRB, 0.38245020E-03_JPRB, 0.38234209E-03_JPRB, &
  & 0.38233056E-03_JPRB, 0.38234272E-03_JPRB, 0.38231728E-03_JPRB, 0.38231892E-03_JPRB, 0.38242318E-03_JPRB, 0.38266972E-03_JPRB, &
  & 0.38303985E-03_JPRB, 0.38361306E-03_JPRB, 0.38418470E-03_JPRB, 0.38483657E-03_JPRB, 0.38564716E-03_JPRB, 0.38661851E-03_JPRB, &
  & 0.38739919E-03_JPRB, 0.38764630E-03_JPRB, 0.38776887E-03_JPRB, 0.38785804E-03_JPRB, 0.38807545E-03_JPRB, 0.38825780E-03_JPRB, &
  & 0.38815715E-03_JPRB, 0.38797261E-03_JPRB, 0.38788608E-03_JPRB, 0.38772316E-03_JPRB, 0.38748078E-03_JPRB, 0.38734393E-03_JPRB, &
  & 0.38748714E-03_JPRB, 0.38756000E-03_JPRB, 0.38768676E-03_JPRB, 0.38782007E-03_JPRB, 0.38825974E-03_JPRB, 0.38878560E-03_JPRB, &
  & 0.38933193E-03_JPRB, 0.39012393E-03_JPRB, 0.39103574E-03_JPRB, 0.39190039E-03_JPRB, 0.39239289E-03_JPRB, 0.39276206E-03_JPRB, &
  & 0.39326110E-03_JPRB, 0.39397175E-03_JPRB, 0.39427662E-03_JPRB, 0.39400869E-03_JPRB  /)

RGHG1(:,81, 6) = (/ &
  & 0.38426764E-03_JPRB, 0.38424729E-03_JPRB, 0.38422008E-03_JPRB, 0.38416804E-03_JPRB, 0.38409854E-03_JPRB, 0.38407631E-03_JPRB, &
  & 0.38410768E-03_JPRB, 0.38409942E-03_JPRB, 0.38407294E-03_JPRB, 0.38399777E-03_JPRB, 0.38390476E-03_JPRB, 0.38379309E-03_JPRB, &
  & 0.38361743E-03_JPRB, 0.38348108E-03_JPRB, 0.38339984E-03_JPRB, 0.38329359E-03_JPRB, 0.38313127E-03_JPRB, 0.38298677E-03_JPRB, &
  & 0.38289297E-03_JPRB, 0.38280863E-03_JPRB, 0.38271534E-03_JPRB, 0.38261726E-03_JPRB, 0.38249523E-03_JPRB, 0.38238286E-03_JPRB, &
  & 0.38236138E-03_JPRB, 0.38235670E-03_JPRB, 0.38233127E-03_JPRB, 0.38232437E-03_JPRB, 0.38242176E-03_JPRB, 0.38267801E-03_JPRB, &
  & 0.38304862E-03_JPRB, 0.38360216E-03_JPRB, 0.38415792E-03_JPRB, 0.38479770E-03_JPRB, 0.38559619E-03_JPRB, 0.38658935E-03_JPRB, &
  & 0.38742408E-03_JPRB, 0.38768423E-03_JPRB, 0.38780632E-03_JPRB, 0.38789502E-03_JPRB, 0.38812380E-03_JPRB, 0.38832773E-03_JPRB, &
  & 0.38823964E-03_JPRB, 0.38806198E-03_JPRB, 0.38798564E-03_JPRB, 0.38781561E-03_JPRB, 0.38754882E-03_JPRB, 0.38740295E-03_JPRB, &
  & 0.38756204E-03_JPRB, 0.38761475E-03_JPRB, 0.38772303E-03_JPRB, 0.38785445E-03_JPRB, 0.38829624E-03_JPRB, 0.38884201E-03_JPRB, &
  & 0.38938716E-03_JPRB, 0.39018437E-03_JPRB, 0.39112558E-03_JPRB, 0.39204333E-03_JPRB, 0.39255195E-03_JPRB, 0.39292515E-03_JPRB, &
  & 0.39345785E-03_JPRB, 0.39413484E-03_JPRB, 0.39441481E-03_JPRB, 0.39418315E-03_JPRB  /)

RGHG1(:,82, 6) = (/ &
  & 0.38428373E-03_JPRB, 0.38425752E-03_JPRB, 0.38422546E-03_JPRB, 0.38417959E-03_JPRB, 0.38411978E-03_JPRB, 0.38409423E-03_JPRB, &
  & 0.38412038E-03_JPRB, 0.38411241E-03_JPRB, 0.38408873E-03_JPRB, 0.38401722E-03_JPRB, 0.38392497E-03_JPRB, 0.38380731E-03_JPRB, &
  & 0.38362874E-03_JPRB, 0.38349174E-03_JPRB, 0.38341279E-03_JPRB, 0.38331300E-03_JPRB, 0.38315640E-03_JPRB, 0.38301515E-03_JPRB, &
  & 0.38292976E-03_JPRB, 0.38284321E-03_JPRB, 0.38275080E-03_JPRB, 0.38265589E-03_JPRB, 0.38253623E-03_JPRB, 0.38242255E-03_JPRB, &
  & 0.38239412E-03_JPRB, 0.38238236E-03_JPRB, 0.38236754E-03_JPRB, 0.38235837E-03_JPRB, 0.38244713E-03_JPRB, 0.38270831E-03_JPRB, &
  & 0.38307367E-03_JPRB, 0.38360047E-03_JPRB, 0.38413293E-03_JPRB, 0.38476315E-03_JPRB, 0.38554702E-03_JPRB, 0.38656397E-03_JPRB, &
  & 0.38744881E-03_JPRB, 0.38772257E-03_JPRB, 0.38784190E-03_JPRB, 0.38793013E-03_JPRB, 0.38816434E-03_JPRB, 0.38839019E-03_JPRB, &
  & 0.38831524E-03_JPRB, 0.38814833E-03_JPRB, 0.38808783E-03_JPRB, 0.38791759E-03_JPRB, 0.38762409E-03_JPRB, 0.38747875E-03_JPRB, &
  & 0.38765362E-03_JPRB, 0.38768925E-03_JPRB, 0.38778095E-03_JPRB, 0.38791587E-03_JPRB, 0.38835212E-03_JPRB, 0.38891963E-03_JPRB, &
  & 0.38945821E-03_JPRB, 0.39024737E-03_JPRB, 0.39120391E-03_JPRB, 0.39216478E-03_JPRB, 0.39268109E-03_JPRB, 0.39306139E-03_JPRB, &
  & 0.39361578E-03_JPRB, 0.39425459E-03_JPRB, 0.39451881E-03_JPRB, 0.39431813E-03_JPRB  /)

RGHG1(:,83, 6) = (/ &
  & 0.38429308E-03_JPRB, 0.38426513E-03_JPRB, 0.38422893E-03_JPRB, 0.38418836E-03_JPRB, 0.38413675E-03_JPRB, 0.38410903E-03_JPRB, &
  & 0.38413114E-03_JPRB, 0.38412245E-03_JPRB, 0.38410032E-03_JPRB, 0.38403120E-03_JPRB, 0.38393866E-03_JPRB, 0.38381463E-03_JPRB, &
  & 0.38363468E-03_JPRB, 0.38349702E-03_JPRB, 0.38342004E-03_JPRB, 0.38332582E-03_JPRB, 0.38317540E-03_JPRB, 0.38303675E-03_JPRB, &
  & 0.38296142E-03_JPRB, 0.38287396E-03_JPRB, 0.38278175E-03_JPRB, 0.38269240E-03_JPRB, 0.38257691E-03_JPRB, 0.38246595E-03_JPRB, &
  & 0.38243625E-03_JPRB, 0.38242594E-03_JPRB, 0.38242820E-03_JPRB, 0.38242266E-03_JPRB, 0.38250072E-03_JPRB, 0.38276317E-03_JPRB, &
  & 0.38311892E-03_JPRB, 0.38361516E-03_JPRB, 0.38411715E-03_JPRB, 0.38473688E-03_JPRB, 0.38551262E-03_JPRB, 0.38655147E-03_JPRB, &
  & 0.38747473E-03_JPRB, 0.38776218E-03_JPRB, 0.38787814E-03_JPRB, 0.38796680E-03_JPRB, 0.38820174E-03_JPRB, 0.38844828E-03_JPRB, &
  & 0.38838990E-03_JPRB, 0.38824351E-03_JPRB, 0.38820576E-03_JPRB, 0.38803370E-03_JPRB, 0.38771843E-03_JPRB, 0.38757577E-03_JPRB, &
  & 0.38776918E-03_JPRB, 0.38778871E-03_JPRB, 0.38786739E-03_JPRB, 0.38801086E-03_JPRB, 0.38843796E-03_JPRB, 0.38902627E-03_JPRB, &
  & 0.38955000E-03_JPRB, 0.39031561E-03_JPRB, 0.39127519E-03_JPRB, 0.39226800E-03_JPRB, 0.39278638E-03_JPRB, 0.39317238E-03_JPRB, &
  & 0.39373958E-03_JPRB, 0.39434135E-03_JPRB, 0.39459869E-03_JPRB, 0.39442270E-03_JPRB  /)

RGHG1(:,84, 6) = (/ &
  & 0.38429726E-03_JPRB, 0.38427086E-03_JPRB, 0.38423163E-03_JPRB, 0.38419529E-03_JPRB, 0.38415022E-03_JPRB, 0.38412141E-03_JPRB, &
  & 0.38414060E-03_JPRB, 0.38412999E-03_JPRB, 0.38410911E-03_JPRB, 0.38403952E-03_JPRB, 0.38394696E-03_JPRB, 0.38381782E-03_JPRB, &
  & 0.38363768E-03_JPRB, 0.38349983E-03_JPRB, 0.38342412E-03_JPRB, 0.38333504E-03_JPRB, 0.38319003E-03_JPRB, 0.38305242E-03_JPRB, &
  & 0.38298852E-03_JPRB, 0.38290422E-03_JPRB, 0.38281415E-03_JPRB, 0.38273027E-03_JPRB, 0.38262050E-03_JPRB, 0.38251696E-03_JPRB, &
  & 0.38249312E-03_JPRB, 0.38249130E-03_JPRB, 0.38251315E-03_JPRB, 0.38251700E-03_JPRB, 0.38258185E-03_JPRB, 0.38284294E-03_JPRB, &
  & 0.38318630E-03_JPRB, 0.38365119E-03_JPRB, 0.38411604E-03_JPRB, 0.38472249E-03_JPRB, 0.38550290E-03_JPRB, 0.38655888E-03_JPRB, &
  & 0.38750357E-03_JPRB, 0.38780352E-03_JPRB, 0.38791711E-03_JPRB, 0.38800781E-03_JPRB, 0.38824052E-03_JPRB, 0.38850544E-03_JPRB, &
  & 0.38846901E-03_JPRB, 0.38835757E-03_JPRB, 0.38835015E-03_JPRB, 0.38816870E-03_JPRB, 0.38784115E-03_JPRB, 0.38769801E-03_JPRB, &
  & 0.38791327E-03_JPRB, 0.38791696E-03_JPRB, 0.38798737E-03_JPRB, 0.38814418E-03_JPRB, 0.38856115E-03_JPRB, 0.38916591E-03_JPRB, &
  & 0.38966517E-03_JPRB, 0.39039118E-03_JPRB, 0.39134311E-03_JPRB, 0.39235552E-03_JPRB, 0.39287227E-03_JPRB, 0.39325901E-03_JPRB, &
  & 0.39383298E-03_JPRB, 0.39440353E-03_JPRB, 0.39466138E-03_JPRB, 0.39450368E-03_JPRB  /)

RGHG1(:,85, 6) = (/ &
  & 0.38429678E-03_JPRB, 0.38427468E-03_JPRB, 0.38423521E-03_JPRB, 0.38420103E-03_JPRB, 0.38416049E-03_JPRB, 0.38413169E-03_JPRB, &
  & 0.38414897E-03_JPRB, 0.38413500E-03_JPRB, 0.38411341E-03_JPRB, 0.38404335E-03_JPRB, 0.38395031E-03_JPRB, 0.38381878E-03_JPRB, &
  & 0.38363912E-03_JPRB, 0.38350174E-03_JPRB, 0.38342555E-03_JPRB, 0.38334292E-03_JPRB, 0.38320174E-03_JPRB, 0.38306365E-03_JPRB, &
  & 0.38301744E-03_JPRB, 0.38294269E-03_JPRB, 0.38286314E-03_JPRB, 0.38278045E-03_JPRB, 0.38267976E-03_JPRB, 0.38259199E-03_JPRB, &
  & 0.38257938E-03_JPRB, 0.38259334E-03_JPRB, 0.38263215E-03_JPRB, 0.38265942E-03_JPRB, 0.38270180E-03_JPRB, 0.38295835E-03_JPRB, &
  & 0.38328953E-03_JPRB, 0.38372479E-03_JPRB, 0.38413898E-03_JPRB, 0.38473635E-03_JPRB, 0.38553731E-03_JPRB, 0.38660523E-03_JPRB, &
  & 0.38755064E-03_JPRB, 0.38785036E-03_JPRB, 0.38796753E-03_JPRB, 0.38806349E-03_JPRB, 0.38829858E-03_JPRB, 0.38858215E-03_JPRB, &
  & 0.38857702E-03_JPRB, 0.38853368E-03_JPRB, 0.38857143E-03_JPRB, 0.38837348E-03_JPRB, 0.38803566E-03_JPRB, 0.38789181E-03_JPRB, &
  & 0.38811495E-03_JPRB, 0.38811362E-03_JPRB, 0.38818308E-03_JPRB, 0.38836426E-03_JPRB, 0.38875996E-03_JPRB, 0.38935827E-03_JPRB, &
  & 0.38982359E-03_JPRB, 0.39049034E-03_JPRB, 0.39141551E-03_JPRB, 0.39242363E-03_JPRB, 0.39292747E-03_JPRB, 0.39330489E-03_JPRB, &
  & 0.39388005E-03_JPRB, 0.39443053E-03_JPRB, 0.39468599E-03_JPRB, 0.39454525E-03_JPRB  /)

RGHG1(:,86, 6) = (/ &
  & 0.38429462E-03_JPRB, 0.38427703E-03_JPRB, 0.38423900E-03_JPRB, 0.38420623E-03_JPRB, 0.38416801E-03_JPRB, 0.38413996E-03_JPRB, &
  & 0.38415550E-03_JPRB, 0.38413911E-03_JPRB, 0.38411624E-03_JPRB, 0.38404513E-03_JPRB, 0.38395217E-03_JPRB, 0.38381880E-03_JPRB, &
  & 0.38364112E-03_JPRB, 0.38350366E-03_JPRB, 0.38342643E-03_JPRB, 0.38335159E-03_JPRB, 0.38321201E-03_JPRB, 0.38307438E-03_JPRB, &
  & 0.38305154E-03_JPRB, 0.38299052E-03_JPRB, 0.38292677E-03_JPRB, 0.38284565E-03_JPRB, 0.38275129E-03_JPRB, 0.38268236E-03_JPRB, &
  & 0.38268927E-03_JPRB, 0.38271477E-03_JPRB, 0.38277494E-03_JPRB, 0.38284033E-03_JPRB, 0.38286687E-03_JPRB, 0.38313606E-03_JPRB, &
  & 0.38346228E-03_JPRB, 0.38387486E-03_JPRB, 0.38425460E-03_JPRB, 0.38483293E-03_JPRB, 0.38565679E-03_JPRB, 0.38672550E-03_JPRB, &
  & 0.38762338E-03_JPRB, 0.38791875E-03_JPRB, 0.38803653E-03_JPRB, 0.38814413E-03_JPRB, 0.38838443E-03_JPRB, 0.38869122E-03_JPRB, &
  & 0.38871998E-03_JPRB, 0.38877313E-03_JPRB, 0.38886020E-03_JPRB, 0.38865148E-03_JPRB, 0.38831436E-03_JPRB, 0.38815277E-03_JPRB, &
  & 0.38839750E-03_JPRB, 0.38839635E-03_JPRB, 0.38847757E-03_JPRB, 0.38867520E-03_JPRB, 0.38903925E-03_JPRB, 0.38959200E-03_JPRB, &
  & 0.39001181E-03_JPRB, 0.39061002E-03_JPRB, 0.39149389E-03_JPRB, 0.39248515E-03_JPRB, 0.39296967E-03_JPRB, 0.39333062E-03_JPRB, &
  & 0.39390605E-03_JPRB, 0.39444570E-03_JPRB, 0.39470250E-03_JPRB, 0.39457208E-03_JPRB  /)

RGHG1(:,87, 6) = (/ &
  & 0.38429125E-03_JPRB, 0.38427830E-03_JPRB, 0.38424259E-03_JPRB, 0.38421079E-03_JPRB, 0.38417378E-03_JPRB, 0.38414608E-03_JPRB, &
  & 0.38416004E-03_JPRB, 0.38414245E-03_JPRB, 0.38411824E-03_JPRB, 0.38404629E-03_JPRB, 0.38395320E-03_JPRB, 0.38381825E-03_JPRB, &
  & 0.38364375E-03_JPRB, 0.38350618E-03_JPRB, 0.38342735E-03_JPRB, 0.38336105E-03_JPRB, 0.38322294E-03_JPRB, 0.38308555E-03_JPRB, &
  & 0.38309679E-03_JPRB, 0.38304940E-03_JPRB, 0.38300495E-03_JPRB, 0.38292492E-03_JPRB, 0.38283991E-03_JPRB, 0.38279422E-03_JPRB, &
  & 0.38282568E-03_JPRB, 0.38287002E-03_JPRB, 0.38296445E-03_JPRB, 0.38307799E-03_JPRB, 0.38310669E-03_JPRB, 0.38342220E-03_JPRB, &
  & 0.38373031E-03_JPRB, 0.38413897E-03_JPRB, 0.38449829E-03_JPRB, 0.38503650E-03_JPRB, 0.38586061E-03_JPRB, 0.38690684E-03_JPRB, &
  & 0.38772384E-03_JPRB, 0.38801721E-03_JPRB, 0.38813524E-03_JPRB, 0.38825551E-03_JPRB, 0.38850303E-03_JPRB, 0.38884067E-03_JPRB, &
  & 0.38890331E-03_JPRB, 0.38908834E-03_JPRB, 0.38923161E-03_JPRB, 0.38902246E-03_JPRB, 0.38870979E-03_JPRB, 0.38851556E-03_JPRB, &
  & 0.38878514E-03_JPRB, 0.38879330E-03_JPRB, 0.38890046E-03_JPRB, 0.38911062E-03_JPRB, 0.38943867E-03_JPRB, 0.38989277E-03_JPRB, &
  & 0.39024078E-03_JPRB, 0.39075745E-03_JPRB, 0.39158551E-03_JPRB, 0.39253936E-03_JPRB, 0.39299905E-03_JPRB, 0.39334109E-03_JPRB, &
  & 0.39391864E-03_JPRB, 0.39445261E-03_JPRB, 0.39471285E-03_JPRB, 0.39458773E-03_JPRB  /)

RGHG1(:,88, 6) = (/ &
  & 0.38428689E-03_JPRB, 0.38427835E-03_JPRB, 0.38424553E-03_JPRB, 0.38421442E-03_JPRB, 0.38417847E-03_JPRB, 0.38415015E-03_JPRB, &
  & 0.38416258E-03_JPRB, 0.38414502E-03_JPRB, 0.38411975E-03_JPRB, 0.38404729E-03_JPRB, 0.38395377E-03_JPRB, 0.38381735E-03_JPRB, &
  & 0.38364746E-03_JPRB, 0.38350959E-03_JPRB, 0.38342858E-03_JPRB, 0.38337162E-03_JPRB, 0.38323636E-03_JPRB, 0.38309908E-03_JPRB, &
  & 0.38316081E-03_JPRB, 0.38312538E-03_JPRB, 0.38310416E-03_JPRB, 0.38302361E-03_JPRB, 0.38295434E-03_JPRB, 0.38294242E-03_JPRB, &
  & 0.38300743E-03_JPRB, 0.38308951E-03_JPRB, 0.38324216E-03_JPRB, 0.38341493E-03_JPRB, 0.38347405E-03_JPRB, 0.38388532E-03_JPRB, &
  & 0.38414934E-03_JPRB, 0.38457669E-03_JPRB, 0.38492952E-03_JPRB, 0.38539364E-03_JPRB, 0.38617247E-03_JPRB, 0.38714985E-03_JPRB, &
  & 0.38785516E-03_JPRB, 0.38814851E-03_JPRB, 0.38827768E-03_JPRB, 0.38840793E-03_JPRB, 0.38866891E-03_JPRB, 0.38905054E-03_JPRB, &
  & 0.38915191E-03_JPRB, 0.38951596E-03_JPRB, 0.38973104E-03_JPRB, 0.38953841E-03_JPRB, 0.38929810E-03_JPRB, 0.38904463E-03_JPRB, &
  & 0.38936367E-03_JPRB, 0.38938008E-03_JPRB, 0.38952980E-03_JPRB, 0.38976157E-03_JPRB, 0.39004170E-03_JPRB, 0.39030507E-03_JPRB, &
  & 0.39055188E-03_JPRB, 0.39095826E-03_JPRB, 0.39170788E-03_JPRB, 0.39258915E-03_JPRB, 0.39301755E-03_JPRB, 0.39333944E-03_JPRB, &
  & 0.39392273E-03_JPRB, 0.39445434E-03_JPRB, 0.39471829E-03_JPRB, 0.39459503E-03_JPRB  /)

RGHG1(:,89, 6) = (/ &
  & 0.38428246E-03_JPRB, 0.38427691E-03_JPRB, 0.38424709E-03_JPRB, 0.38421645E-03_JPRB, 0.38418245E-03_JPRB, 0.38415255E-03_JPRB, &
  & 0.38416344E-03_JPRB, 0.38414666E-03_JPRB, 0.38412089E-03_JPRB, 0.38404789E-03_JPRB, 0.38395413E-03_JPRB, 0.38381642E-03_JPRB, &
  & 0.38365278E-03_JPRB, 0.38351363E-03_JPRB, 0.38342994E-03_JPRB, 0.38338344E-03_JPRB, 0.38325365E-03_JPRB, 0.38311695E-03_JPRB, &
  & 0.38325095E-03_JPRB, 0.38322564E-03_JPRB, 0.38323549E-03_JPRB, 0.38315076E-03_JPRB, 0.38310541E-03_JPRB, 0.38314859E-03_JPRB, &
  & 0.38326546E-03_JPRB, 0.38341294E-03_JPRB, 0.38366805E-03_JPRB, 0.38391034E-03_JPRB, 0.38404009E-03_JPRB, 0.38459698E-03_JPRB, &
  & 0.38481004E-03_JPRB, 0.38525801E-03_JPRB, 0.38562719E-03_JPRB, 0.38595879E-03_JPRB, 0.38662631E-03_JPRB, 0.38744827E-03_JPRB, &
  & 0.38801400E-03_JPRB, 0.38829965E-03_JPRB, 0.38847150E-03_JPRB, 0.38860657E-03_JPRB, 0.38889820E-03_JPRB, 0.38933908E-03_JPRB, &
  & 0.38949962E-03_JPRB, 0.39010156E-03_JPRB, 0.39041777E-03_JPRB, 0.39027646E-03_JPRB, 0.39019222E-03_JPRB, 0.38984088E-03_JPRB, &
  & 0.39027893E-03_JPRB, 0.39029065E-03_JPRB, 0.39048959E-03_JPRB, 0.39076096E-03_JPRB, 0.39096864E-03_JPRB, 0.39089378E-03_JPRB, &
  & 0.39102135E-03_JPRB, 0.39126108E-03_JPRB, 0.39188734E-03_JPRB, 0.39263911E-03_JPRB, 0.39302915E-03_JPRB, 0.39333017E-03_JPRB, &
  & 0.39392336E-03_JPRB, 0.39445505E-03_JPRB, 0.39472043E-03_JPRB, 0.39459783E-03_JPRB  /)

RGHG1(:,90, 6) = (/ &
  & 0.38428155E-03_JPRB, 0.38427568E-03_JPRB, 0.38424749E-03_JPRB, 0.38421684E-03_JPRB, 0.38418535E-03_JPRB, 0.38415407E-03_JPRB, &
  & 0.38416383E-03_JPRB, 0.38414762E-03_JPRB, 0.38412159E-03_JPRB, 0.38404804E-03_JPRB, 0.38395428E-03_JPRB, 0.38381543E-03_JPRB, &
  & 0.38365931E-03_JPRB, 0.38351716E-03_JPRB, 0.38343061E-03_JPRB, 0.38339758E-03_JPRB, 0.38327610E-03_JPRB, 0.38313654E-03_JPRB, &
  & 0.38337454E-03_JPRB, 0.38335859E-03_JPRB, 0.38342815E-03_JPRB, 0.38333104E-03_JPRB, 0.38332262E-03_JPRB, 0.38344960E-03_JPRB, &
  & 0.38364075E-03_JPRB, 0.38386854E-03_JPRB, 0.38432494E-03_JPRB, 0.38462537E-03_JPRB, 0.38488937E-03_JPRB, 0.38558047E-03_JPRB, &
  & 0.38589661E-03_JPRB, 0.38626967E-03_JPRB, 0.38673003E-03_JPRB, 0.38678618E-03_JPRB, 0.38727257E-03_JPRB, 0.38779863E-03_JPRB, &
  & 0.38820878E-03_JPRB, 0.38845997E-03_JPRB, 0.38870656E-03_JPRB, 0.38885067E-03_JPRB, 0.38920146E-03_JPRB, 0.38969411E-03_JPRB, &
  & 0.38996964E-03_JPRB, 0.39090027E-03_JPRB, 0.39136839E-03_JPRB, 0.39137832E-03_JPRB, 0.39155758E-03_JPRB, 0.39114337E-03_JPRB, &
  & 0.39172895E-03_JPRB, 0.39180646E-03_JPRB, 0.39199362E-03_JPRB, 0.39223520E-03_JPRB, 0.39236929E-03_JPRB, 0.39180265E-03_JPRB, &
  & 0.39178087E-03_JPRB, 0.39176469E-03_JPRB, 0.39215321E-03_JPRB, 0.39268765E-03_JPRB, 0.39303343E-03_JPRB, 0.39331799E-03_JPRB, &
  & 0.39392378E-03_JPRB, 0.39445601E-03_JPRB, 0.39472166E-03_JPRB, 0.39459880E-03_JPRB  /)

RGHG1(:,91, 6) = (/ &
  & 0.38428273E-03_JPRB, 0.38427538E-03_JPRB, 0.38424719E-03_JPRB, 0.38421624E-03_JPRB, 0.38418683E-03_JPRB, 0.38415496E-03_JPRB, &
  & 0.38416324E-03_JPRB, 0.38414792E-03_JPRB, 0.38412249E-03_JPRB, 0.38404833E-03_JPRB, 0.38395458E-03_JPRB, 0.38381424E-03_JPRB, &
  & 0.38367238E-03_JPRB, 0.38352132E-03_JPRB, 0.38343032E-03_JPRB, 0.38342817E-03_JPRB, 0.38331174E-03_JPRB, 0.38316742E-03_JPRB, &
  & 0.38356697E-03_JPRB, 0.38358934E-03_JPRB, 0.38379402E-03_JPRB, 0.38364940E-03_JPRB, 0.38367483E-03_JPRB, 0.38388288E-03_JPRB, &
  & 0.38419817E-03_JPRB, 0.38467095E-03_JPRB, 0.38539284E-03_JPRB, 0.38565972E-03_JPRB, 0.38612239E-03_JPRB, 0.38701127E-03_JPRB, &
  & 0.38775921E-03_JPRB, 0.38803130E-03_JPRB, 0.38866004E-03_JPRB, 0.38823628E-03_JPRB, 0.38817714E-03_JPRB, 0.38822923E-03_JPRB, &
  & 0.38846179E-03_JPRB, 0.38866280E-03_JPRB, 0.38901363E-03_JPRB, 0.38922842E-03_JPRB, 0.38957772E-03_JPRB, 0.39012680E-03_JPRB, &
  & 0.39063605E-03_JPRB, 0.39185830E-03_JPRB, 0.39273890E-03_JPRB, 0.39308085E-03_JPRB, 0.39386801E-03_JPRB, 0.39378313E-03_JPRB, &
  & 0.39437020E-03_JPRB, 0.39446642E-03_JPRB, 0.39448817E-03_JPRB, 0.39464719E-03_JPRB, 0.39436285E-03_JPRB, 0.39317584E-03_JPRB, &
  & 0.39309556E-03_JPRB, 0.39267609E-03_JPRB, 0.39266904E-03_JPRB, 0.39272358E-03_JPRB, 0.39303581E-03_JPRB, 0.39329809E-03_JPRB, &
  & 0.39392408E-03_JPRB, 0.39445630E-03_JPRB, 0.39472196E-03_JPRB, 0.39459940E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ---GEMS----

RGHG1(:, 1, 7) = (/ &
  & 0.37326774E-03_JPRB, 0.37327103E-03_JPRB, 0.37327797E-03_JPRB, 0.37328831E-03_JPRB, 0.37329777E-03_JPRB, 0.37330524E-03_JPRB, &
  & 0.37331025E-03_JPRB, 0.37331485E-03_JPRB, 0.37331887E-03_JPRB, 0.37332251E-03_JPRB, 0.37332588E-03_JPRB, 0.37333067E-03_JPRB, &
  & 0.37333921E-03_JPRB, 0.37335139E-03_JPRB, 0.37336433E-03_JPRB, 0.37337276E-03_JPRB, 0.37337582E-03_JPRB, 0.37337425E-03_JPRB, &
  & 0.37336939E-03_JPRB, 0.37336483E-03_JPRB, 0.37335629E-03_JPRB, 0.37334587E-03_JPRB, 0.37333373E-03_JPRB, 0.37331964E-03_JPRB, &
  & 0.37330439E-03_JPRB, 0.37328482E-03_JPRB, 0.37325701E-03_JPRB, 0.37322442E-03_JPRB, 0.37318639E-03_JPRB, 0.37313974E-03_JPRB, &
  & 0.37309320E-03_JPRB, 0.37304357E-03_JPRB, 0.37298569E-03_JPRB, 0.37292395E-03_JPRB, 0.37285689E-03_JPRB, 0.37278335E-03_JPRB, &
  & 0.37270143E-03_JPRB, 0.37260862E-03_JPRB, 0.37250199E-03_JPRB, 0.37238767E-03_JPRB, 0.37227280E-03_JPRB, 0.37215511E-03_JPRB, &
  & 0.37203994E-03_JPRB, 0.37192469E-03_JPRB, 0.37181285E-03_JPRB, 0.37170783E-03_JPRB, 0.37161154E-03_JPRB, 0.37152506E-03_JPRB, &
  & 0.37144884E-03_JPRB, 0.37138166E-03_JPRB, 0.37132471E-03_JPRB, 0.37127863E-03_JPRB, 0.37124244E-03_JPRB, 0.37121325E-03_JPRB, &
  & 0.37119027E-03_JPRB, 0.37117200E-03_JPRB, 0.37115722E-03_JPRB, 0.37114500E-03_JPRB, 0.37113493E-03_JPRB, 0.37112535E-03_JPRB, &
  & 0.37111471E-03_JPRB, 0.37110387E-03_JPRB, 0.37109628E-03_JPRB, 0.37109406E-03_JPRB  /)

RGHG1(:, 2, 7) = (/ &
  & 0.37326774E-03_JPRB, 0.37327103E-03_JPRB, 0.37327797E-03_JPRB, 0.37328831E-03_JPRB, 0.37329777E-03_JPRB, 0.37330524E-03_JPRB, &
  & 0.37331025E-03_JPRB, 0.37331485E-03_JPRB, 0.37331887E-03_JPRB, 0.37332251E-03_JPRB, 0.37332588E-03_JPRB, 0.37333067E-03_JPRB, &
  & 0.37333921E-03_JPRB, 0.37335139E-03_JPRB, 0.37336433E-03_JPRB, 0.37337276E-03_JPRB, 0.37337582E-03_JPRB, 0.37337425E-03_JPRB, &
  & 0.37336939E-03_JPRB, 0.37336483E-03_JPRB, 0.37335629E-03_JPRB, 0.37334587E-03_JPRB, 0.37333373E-03_JPRB, 0.37331964E-03_JPRB, &
  & 0.37330439E-03_JPRB, 0.37328482E-03_JPRB, 0.37325701E-03_JPRB, 0.37322442E-03_JPRB, 0.37318639E-03_JPRB, 0.37313974E-03_JPRB, &
  & 0.37309320E-03_JPRB, 0.37304357E-03_JPRB, 0.37298569E-03_JPRB, 0.37292395E-03_JPRB, 0.37285689E-03_JPRB, 0.37278335E-03_JPRB, &
  & 0.37270143E-03_JPRB, 0.37260862E-03_JPRB, 0.37250199E-03_JPRB, 0.37238767E-03_JPRB, 0.37227280E-03_JPRB, 0.37215511E-03_JPRB, &
  & 0.37203994E-03_JPRB, 0.37192469E-03_JPRB, 0.37181285E-03_JPRB, 0.37170783E-03_JPRB, 0.37161154E-03_JPRB, 0.37152506E-03_JPRB, &
  & 0.37144884E-03_JPRB, 0.37138166E-03_JPRB, 0.37132471E-03_JPRB, 0.37127863E-03_JPRB, 0.37124244E-03_JPRB, 0.37121325E-03_JPRB, &
  & 0.37119027E-03_JPRB, 0.37117200E-03_JPRB, 0.37115722E-03_JPRB, 0.37114500E-03_JPRB, 0.37113493E-03_JPRB, 0.37112535E-03_JPRB, &
  & 0.37111471E-03_JPRB, 0.37110387E-03_JPRB, 0.37109628E-03_JPRB, 0.37109406E-03_JPRB  /)

RGHG1(:, 3, 7) = (/ &
  & 0.37326774E-03_JPRB, 0.37327103E-03_JPRB, 0.37327797E-03_JPRB, 0.37328831E-03_JPRB, 0.37329777E-03_JPRB, 0.37330524E-03_JPRB, &
  & 0.37331025E-03_JPRB, 0.37331485E-03_JPRB, 0.37331887E-03_JPRB, 0.37332251E-03_JPRB, 0.37332588E-03_JPRB, 0.37333067E-03_JPRB, &
  & 0.37333921E-03_JPRB, 0.37335139E-03_JPRB, 0.37336433E-03_JPRB, 0.37337276E-03_JPRB, 0.37337582E-03_JPRB, 0.37337425E-03_JPRB, &
  & 0.37336939E-03_JPRB, 0.37336483E-03_JPRB, 0.37335629E-03_JPRB, 0.37334587E-03_JPRB, 0.37333373E-03_JPRB, 0.37331964E-03_JPRB, &
  & 0.37330439E-03_JPRB, 0.37328482E-03_JPRB, 0.37325701E-03_JPRB, 0.37322442E-03_JPRB, 0.37318639E-03_JPRB, 0.37313974E-03_JPRB, &
  & 0.37309320E-03_JPRB, 0.37304357E-03_JPRB, 0.37298569E-03_JPRB, 0.37292395E-03_JPRB, 0.37285689E-03_JPRB, 0.37278335E-03_JPRB, &
  & 0.37270143E-03_JPRB, 0.37260862E-03_JPRB, 0.37250199E-03_JPRB, 0.37238767E-03_JPRB, 0.37227280E-03_JPRB, 0.37215511E-03_JPRB, &
  & 0.37203994E-03_JPRB, 0.37192469E-03_JPRB, 0.37181285E-03_JPRB, 0.37170783E-03_JPRB, 0.37161154E-03_JPRB, 0.37152506E-03_JPRB, &
  & 0.37144884E-03_JPRB, 0.37138166E-03_JPRB, 0.37132471E-03_JPRB, 0.37127863E-03_JPRB, 0.37124244E-03_JPRB, 0.37121325E-03_JPRB, &
  & 0.37119027E-03_JPRB, 0.37117200E-03_JPRB, 0.37115722E-03_JPRB, 0.37114500E-03_JPRB, 0.37113493E-03_JPRB, 0.37112535E-03_JPRB, &
  & 0.37111471E-03_JPRB, 0.37110387E-03_JPRB, 0.37109628E-03_JPRB, 0.37109406E-03_JPRB  /)

RGHG1(:, 4, 7) = (/ &
  & 0.37326768E-03_JPRB, 0.37327098E-03_JPRB, 0.37327792E-03_JPRB, 0.37328823E-03_JPRB, 0.37329766E-03_JPRB, 0.37330509E-03_JPRB, &
  & 0.37331010E-03_JPRB, 0.37331470E-03_JPRB, 0.37331874E-03_JPRB, 0.37332238E-03_JPRB, 0.37332575E-03_JPRB, 0.37333056E-03_JPRB, &
  & 0.37333912E-03_JPRB, 0.37335134E-03_JPRB, 0.37336436E-03_JPRB, 0.37337289E-03_JPRB, 0.37337611E-03_JPRB, 0.37337476E-03_JPRB, &
  & 0.37337014E-03_JPRB, 0.37336577E-03_JPRB, 0.37335740E-03_JPRB, 0.37334713E-03_JPRB, 0.37333511E-03_JPRB, 0.37332111E-03_JPRB, &
  & 0.37330594E-03_JPRB, 0.37328644E-03_JPRB, 0.37325877E-03_JPRB, 0.37322632E-03_JPRB, 0.37318846E-03_JPRB, 0.37314207E-03_JPRB, &
  & 0.37309578E-03_JPRB, 0.37304634E-03_JPRB, 0.37298866E-03_JPRB, 0.37292705E-03_JPRB, 0.37286008E-03_JPRB, 0.37278656E-03_JPRB, &
  & 0.37270468E-03_JPRB, 0.37261199E-03_JPRB, 0.37250552E-03_JPRB, 0.37239128E-03_JPRB, 0.37227638E-03_JPRB, 0.37215859E-03_JPRB, &
  & 0.37204327E-03_JPRB, 0.37192785E-03_JPRB, 0.37181577E-03_JPRB, 0.37171045E-03_JPRB, 0.37161383E-03_JPRB, 0.37152702E-03_JPRB, &
  & 0.37145047E-03_JPRB, 0.37138295E-03_JPRB, 0.37132569E-03_JPRB, 0.37127934E-03_JPRB, 0.37124293E-03_JPRB, 0.37121357E-03_JPRB, &
  & 0.37119046E-03_JPRB, 0.37117209E-03_JPRB, 0.37115723E-03_JPRB, 0.37114495E-03_JPRB, 0.37113483E-03_JPRB, 0.37112522E-03_JPRB, &
  & 0.37111453E-03_JPRB, 0.37110361E-03_JPRB, 0.37109593E-03_JPRB, 0.37109363E-03_JPRB  /)

RGHG1(:, 5, 7) = (/ &
  & 0.37326483E-03_JPRB, 0.37326848E-03_JPRB, 0.37327565E-03_JPRB, 0.37328477E-03_JPRB, 0.37329248E-03_JPRB, 0.37329843E-03_JPRB, &
  & 0.37330306E-03_JPRB, 0.37330773E-03_JPRB, 0.37331237E-03_JPRB, 0.37331647E-03_JPRB, 0.37331978E-03_JPRB, 0.37332528E-03_JPRB, &
  & 0.37333500E-03_JPRB, 0.37334929E-03_JPRB, 0.37336563E-03_JPRB, 0.37337908E-03_JPRB, 0.37338984E-03_JPRB, 0.37339894E-03_JPRB, &
  & 0.37340568E-03_JPRB, 0.37341027E-03_JPRB, 0.37341021E-03_JPRB, 0.37340690E-03_JPRB, 0.37340047E-03_JPRB, 0.37339118E-03_JPRB, &
  & 0.37337932E-03_JPRB, 0.37336352E-03_JPRB, 0.37334210E-03_JPRB, 0.37331635E-03_JPRB, 0.37328690E-03_JPRB, 0.37325284E-03_JPRB, &
  & 0.37321808E-03_JPRB, 0.37317821E-03_JPRB, 0.37312935E-03_JPRB, 0.37307420E-03_JPRB, 0.37301141E-03_JPRB, 0.37293881E-03_JPRB, &
  & 0.37285903E-03_JPRB, 0.37277199E-03_JPRB, 0.37267293E-03_JPRB, 0.37256284E-03_JPRB, 0.37244602E-03_JPRB, 0.37232420E-03_JPRB, &
  & 0.37220179E-03_JPRB, 0.37207775E-03_JPRB, 0.37195433E-03_JPRB, 0.37183472E-03_JPRB, 0.37172258E-03_JPRB, 0.37162006E-03_JPRB, &
  & 0.37152760E-03_JPRB, 0.37144429E-03_JPRB, 0.37137225E-03_JPRB, 0.37131302E-03_JPRB, 0.37126628E-03_JPRB, 0.37122880E-03_JPRB, &
  & 0.37119954E-03_JPRB, 0.37117639E-03_JPRB, 0.37115781E-03_JPRB, 0.37114248E-03_JPRB, 0.37113013E-03_JPRB, 0.37111883E-03_JPRB, &
  & 0.37110591E-03_JPRB, 0.37109159E-03_JPRB, 0.37107935E-03_JPRB, 0.37107308E-03_JPRB  /)

RGHG1(:, 6, 7) = (/ &
  & 0.37326055E-03_JPRB, 0.37326472E-03_JPRB, 0.37327225E-03_JPRB, 0.37327956E-03_JPRB, 0.37328472E-03_JPRB, 0.37328842E-03_JPRB, &
  & 0.37329249E-03_JPRB, 0.37329726E-03_JPRB, 0.37330283E-03_JPRB, 0.37330760E-03_JPRB, 0.37331083E-03_JPRB, 0.37331738E-03_JPRB, &
  & 0.37332881E-03_JPRB, 0.37334621E-03_JPRB, 0.37336754E-03_JPRB, 0.37338838E-03_JPRB, 0.37341044E-03_JPRB, 0.37343520E-03_JPRB, &
  & 0.37345900E-03_JPRB, 0.37347704E-03_JPRB, 0.37348944E-03_JPRB, 0.37349657E-03_JPRB, 0.37349853E-03_JPRB, 0.37349632E-03_JPRB, &
  & 0.37348943E-03_JPRB, 0.37347916E-03_JPRB, 0.37346711E-03_JPRB, 0.37345144E-03_JPRB, 0.37343460E-03_JPRB, 0.37341904E-03_JPRB, &
  & 0.37340158E-03_JPRB, 0.37337606E-03_JPRB, 0.37334043E-03_JPRB, 0.37329498E-03_JPRB, 0.37323845E-03_JPRB, 0.37316724E-03_JPRB, &
  & 0.37309060E-03_JPRB, 0.37301204E-03_JPRB, 0.37292410E-03_JPRB, 0.37282024E-03_JPRB, 0.37270055E-03_JPRB, 0.37257266E-03_JPRB, &
  & 0.37243962E-03_JPRB, 0.37230266E-03_JPRB, 0.37216223E-03_JPRB, 0.37202118E-03_JPRB, 0.37188573E-03_JPRB, 0.37175966E-03_JPRB, &
  & 0.37164333E-03_JPRB, 0.37153631E-03_JPRB, 0.37144210E-03_JPRB, 0.37136355E-03_JPRB, 0.37130131E-03_JPRB, 0.37125164E-03_JPRB, &
  & 0.37121315E-03_JPRB, 0.37118283E-03_JPRB, 0.37115867E-03_JPRB, 0.37113876E-03_JPRB, 0.37112308E-03_JPRB, 0.37110924E-03_JPRB, &
  & 0.37109299E-03_JPRB, 0.37107355E-03_JPRB, 0.37105448E-03_JPRB, 0.37104224E-03_JPRB  /)

RGHG1(:, 7, 7) = (/ &
  & 0.37325287E-03_JPRB, 0.37325666E-03_JPRB, 0.37326157E-03_JPRB, 0.37326670E-03_JPRB, 0.37327017E-03_JPRB, 0.37327258E-03_JPRB, &
  & 0.37327594E-03_JPRB, 0.37328052E-03_JPRB, 0.37328601E-03_JPRB, 0.37329070E-03_JPRB, 0.37329397E-03_JPRB, 0.37330108E-03_JPRB, &
  & 0.37331341E-03_JPRB, 0.37333398E-03_JPRB, 0.37336222E-03_JPRB, 0.37339456E-03_JPRB, 0.37343184E-03_JPRB, 0.37347999E-03_JPRB, &
  & 0.37352972E-03_JPRB, 0.37357249E-03_JPRB, 0.37360520E-03_JPRB, 0.37362879E-03_JPRB, 0.37364166E-03_JPRB, 0.37364620E-03_JPRB, &
  & 0.37364676E-03_JPRB, 0.37364493E-03_JPRB, 0.37364585E-03_JPRB, 0.37364775E-03_JPRB, 0.37365313E-03_JPRB, 0.37367036E-03_JPRB, &
  & 0.37369133E-03_JPRB, 0.37370106E-03_JPRB, 0.37369473E-03_JPRB, 0.37367199E-03_JPRB, 0.37363102E-03_JPRB, 0.37357236E-03_JPRB, &
  & 0.37350377E-03_JPRB, 0.37343067E-03_JPRB, 0.37334999E-03_JPRB, 0.37325374E-03_JPRB, 0.37313866E-03_JPRB, 0.37300716E-03_JPRB, &
  & 0.37285716E-03_JPRB, 0.37269025E-03_JPRB, 0.37250812E-03_JPRB, 0.37231978E-03_JPRB, 0.37213793E-03_JPRB, 0.37196840E-03_JPRB, &
  & 0.37181250E-03_JPRB, 0.37167002E-03_JPRB, 0.37154334E-03_JPRB, 0.37143370E-03_JPRB, 0.37134498E-03_JPRB, 0.37127696E-03_JPRB, &
  & 0.37122832E-03_JPRB, 0.37119310E-03_JPRB, 0.37116583E-03_JPRB, 0.37114174E-03_JPRB, 0.37112151E-03_JPRB, 0.37110488E-03_JPRB, &
  & 0.37108793E-03_JPRB, 0.37106791E-03_JPRB, 0.37104564E-03_JPRB, 0.37102819E-03_JPRB  /)

RGHG1(:, 8, 7) = (/ &
  & 0.37323870E-03_JPRB, 0.37324201E-03_JPRB, 0.37324500E-03_JPRB, 0.37324759E-03_JPRB, 0.37325010E-03_JPRB, 0.37325229E-03_JPRB, &
  & 0.37325479E-03_JPRB, 0.37325875E-03_JPRB, 0.37326314E-03_JPRB, 0.37326718E-03_JPRB, 0.37327024E-03_JPRB, 0.37327735E-03_JPRB, &
  & 0.37329013E-03_JPRB, 0.37331515E-03_JPRB, 0.37335294E-03_JPRB, 0.37340165E-03_JPRB, 0.37346150E-03_JPRB, 0.37354367E-03_JPRB, &
  & 0.37362914E-03_JPRB, 0.37370324E-03_JPRB, 0.37376103E-03_JPRB, 0.37379995E-03_JPRB, 0.37382051E-03_JPRB, 0.37383052E-03_JPRB, &
  & 0.37383962E-03_JPRB, 0.37384884E-03_JPRB, 0.37386691E-03_JPRB, 0.37389321E-03_JPRB, 0.37393283E-03_JPRB, 0.37400077E-03_JPRB, &
  & 0.37408173E-03_JPRB, 0.37414455E-03_JPRB, 0.37417504E-03_JPRB, 0.37417526E-03_JPRB, 0.37415014E-03_JPRB, 0.37410357E-03_JPRB, &
  & 0.37403877E-03_JPRB, 0.37395922E-03_JPRB, 0.37386820E-03_JPRB, 0.37376476E-03_JPRB, 0.37364221E-03_JPRB, 0.37349596E-03_JPRB, &
  & 0.37331951E-03_JPRB, 0.37311433E-03_JPRB, 0.37288416E-03_JPRB, 0.37264407E-03_JPRB, 0.37241108E-03_JPRB, 0.37219443E-03_JPRB, &
  & 0.37199918E-03_JPRB, 0.37182284E-03_JPRB, 0.37166303E-03_JPRB, 0.37151756E-03_JPRB, 0.37139419E-03_JPRB, 0.37130199E-03_JPRB, &
  & 0.37124340E-03_JPRB, 0.37120673E-03_JPRB, 0.37118022E-03_JPRB, 0.37115434E-03_JPRB, 0.37112934E-03_JPRB, 0.37110919E-03_JPRB, &
  & 0.37109249E-03_JPRB, 0.37107226E-03_JPRB, 0.37104241E-03_JPRB, 0.37101576E-03_JPRB  /)

RGHG1(:, 9, 7) = (/ &
  & 0.37321111E-03_JPRB, 0.37321312E-03_JPRB, 0.37321576E-03_JPRB, 0.37321734E-03_JPRB, 0.37322055E-03_JPRB, 0.37322377E-03_JPRB, &
  & 0.37322587E-03_JPRB, 0.37322852E-03_JPRB, 0.37323088E-03_JPRB, 0.37323337E-03_JPRB, 0.37323527E-03_JPRB, 0.37324090E-03_JPRB, &
  & 0.37325360E-03_JPRB, 0.37328404E-03_JPRB, 0.37333405E-03_JPRB, 0.37340341E-03_JPRB, 0.37349357E-03_JPRB, 0.37361613E-03_JPRB, &
  & 0.37374428E-03_JPRB, 0.37385281E-03_JPRB, 0.37393499E-03_JPRB, 0.37398488E-03_JPRB, 0.37401023E-03_JPRB, 0.37402531E-03_JPRB, &
  & 0.37404225E-03_JPRB, 0.37406271E-03_JPRB, 0.37409832E-03_JPRB, 0.37415360E-03_JPRB, 0.37423961E-03_JPRB, 0.37437305E-03_JPRB, &
  & 0.37452281E-03_JPRB, 0.37463906E-03_JPRB, 0.37469928E-03_JPRB, 0.37471380E-03_JPRB, 0.37469770E-03_JPRB, 0.37465588E-03_JPRB, &
  & 0.37458526E-03_JPRB, 0.37448167E-03_JPRB, 0.37435434E-03_JPRB, 0.37421933E-03_JPRB, 0.37407182E-03_JPRB, 0.37390160E-03_JPRB, &
  & 0.37369840E-03_JPRB, 0.37346058E-03_JPRB, 0.37319317E-03_JPRB, 0.37291424E-03_JPRB, 0.37264015E-03_JPRB, 0.37238668E-03_JPRB, &
  & 0.37216546E-03_JPRB, 0.37196803E-03_JPRB, 0.37178448E-03_JPRB, 0.37160686E-03_JPRB, 0.37144462E-03_JPRB, 0.37132309E-03_JPRB, &
  & 0.37125480E-03_JPRB, 0.37122057E-03_JPRB, 0.37119963E-03_JPRB, 0.37117576E-03_JPRB, 0.37114690E-03_JPRB, 0.37112229E-03_JPRB, &
  & 0.37110549E-03_JPRB, 0.37108361E-03_JPRB, 0.37103854E-03_JPRB, 0.37099714E-03_JPRB  /)

RGHG1(:,10, 7) = (/ &
  & 0.37314731E-03_JPRB, 0.37314805E-03_JPRB, 0.37315164E-03_JPRB, 0.37315632E-03_JPRB, 0.37316304E-03_JPRB, 0.37316847E-03_JPRB, &
  & 0.37317074E-03_JPRB, 0.37317132E-03_JPRB, 0.37317053E-03_JPRB, 0.37316889E-03_JPRB, 0.37316687E-03_JPRB, 0.37316946E-03_JPRB, &
  & 0.37318275E-03_JPRB, 0.37321922E-03_JPRB, 0.37328399E-03_JPRB, 0.37337817E-03_JPRB, 0.37350240E-03_JPRB, 0.37365948E-03_JPRB, &
  & 0.37382385E-03_JPRB, 0.37396057E-03_JPRB, 0.37405808E-03_JPRB, 0.37411761E-03_JPRB, 0.37414968E-03_JPRB, 0.37416923E-03_JPRB, &
  & 0.37418984E-03_JPRB, 0.37421592E-03_JPRB, 0.37426012E-03_JPRB, 0.37433571E-03_JPRB, 0.37445600E-03_JPRB, 0.37463325E-03_JPRB, &
  & 0.37482428E-03_JPRB, 0.37497436E-03_JPRB, 0.37505640E-03_JPRB, 0.37508184E-03_JPRB, 0.37507146E-03_JPRB, 0.37503357E-03_JPRB, &
  & 0.37495893E-03_JPRB, 0.37482944E-03_JPRB, 0.37465646E-03_JPRB, 0.37447767E-03_JPRB, 0.37430197E-03_JPRB, 0.37411565E-03_JPRB, &
  & 0.37390136E-03_JPRB, 0.37365086E-03_JPRB, 0.37336806E-03_JPRB, 0.37307196E-03_JPRB, 0.37277712E-03_JPRB, 0.37250759E-03_JPRB, &
  & 0.37227859E-03_JPRB, 0.37207657E-03_JPRB, 0.37188490E-03_JPRB, 0.37168716E-03_JPRB, 0.37148989E-03_JPRB, 0.37133719E-03_JPRB, &
  & 0.37125733E-03_JPRB, 0.37122631E-03_JPRB, 0.37121437E-03_JPRB, 0.37119698E-03_JPRB, 0.37116704E-03_JPRB, 0.37113591E-03_JPRB, &
  & 0.37111304E-03_JPRB, 0.37108587E-03_JPRB, 0.37102866E-03_JPRB, 0.37097452E-03_JPRB  /)

RGHG1(:,11, 7) = (/ &
  & 0.37299253E-03_JPRB, 0.37299936E-03_JPRB, 0.37300786E-03_JPRB, 0.37301893E-03_JPRB, 0.37303161E-03_JPRB, 0.37304086E-03_JPRB, &
  & 0.37304358E-03_JPRB, 0.37304108E-03_JPRB, 0.37303412E-03_JPRB, 0.37302366E-03_JPRB, 0.37301539E-03_JPRB, 0.37301651E-03_JPRB, &
  & 0.37303482E-03_JPRB, 0.37308232E-03_JPRB, 0.37316670E-03_JPRB, 0.37329206E-03_JPRB, 0.37345132E-03_JPRB, 0.37363349E-03_JPRB, &
  & 0.37381494E-03_JPRB, 0.37396081E-03_JPRB, 0.37406082E-03_JPRB, 0.37412701E-03_JPRB, 0.37416592E-03_JPRB, 0.37418817E-03_JPRB, &
  & 0.37421050E-03_JPRB, 0.37423525E-03_JPRB, 0.37427267E-03_JPRB, 0.37433968E-03_JPRB, 0.37444390E-03_JPRB, 0.37460148E-03_JPRB, &
  & 0.37479468E-03_JPRB, 0.37498447E-03_JPRB, 0.37512225E-03_JPRB, 0.37517816E-03_JPRB, 0.37518259E-03_JPRB, 0.37516032E-03_JPRB, &
  & 0.37510258E-03_JPRB, 0.37497474E-03_JPRB, 0.37478366E-03_JPRB, 0.37458015E-03_JPRB, 0.37438806E-03_JPRB, 0.37419464E-03_JPRB, &
  & 0.37397474E-03_JPRB, 0.37371803E-03_JPRB, 0.37342838E-03_JPRB, 0.37312533E-03_JPRB, 0.37282769E-03_JPRB, 0.37256111E-03_JPRB, &
  & 0.37233577E-03_JPRB, 0.37213984E-03_JPRB, 0.37195125E-03_JPRB, 0.37174385E-03_JPRB, 0.37152395E-03_JPRB, 0.37134728E-03_JPRB, &
  & 0.37125687E-03_JPRB, 0.37122906E-03_JPRB, 0.37123085E-03_JPRB, 0.37122826E-03_JPRB, 0.37120311E-03_JPRB, 0.37116145E-03_JPRB, &
  & 0.37111929E-03_JPRB, 0.37107583E-03_JPRB, 0.37101973E-03_JPRB, 0.37097457E-03_JPRB  /)

RGHG1(:,12, 7) = (/ &
  & 0.37271132E-03_JPRB, 0.37272821E-03_JPRB, 0.37274256E-03_JPRB, 0.37275935E-03_JPRB, 0.37277708E-03_JPRB, 0.37279006E-03_JPRB, &
  & 0.37279484E-03_JPRB, 0.37279001E-03_JPRB, 0.37277809E-03_JPRB, 0.37276170E-03_JPRB, 0.37275247E-03_JPRB, 0.37276007E-03_JPRB, &
  & 0.37279372E-03_JPRB, 0.37286493E-03_JPRB, 0.37297788E-03_JPRB, 0.37313923E-03_JPRB, 0.37333829E-03_JPRB, 0.37355287E-03_JPRB, &
  & 0.37375207E-03_JPRB, 0.37390047E-03_JPRB, 0.37399589E-03_JPRB, 0.37405848E-03_JPRB, 0.37410154E-03_JPRB, 0.37413407E-03_JPRB, &
  & 0.37416558E-03_JPRB, 0.37419062E-03_JPRB, 0.37421638E-03_JPRB, 0.37425992E-03_JPRB, 0.37432739E-03_JPRB, 0.37444289E-03_JPRB, &
  & 0.37462410E-03_JPRB, 0.37485405E-03_JPRB, 0.37507023E-03_JPRB, 0.37517718E-03_JPRB, 0.37519927E-03_JPRB, 0.37518940E-03_JPRB, &
  & 0.37515289E-03_JPRB, 0.37504835E-03_JPRB, 0.37487619E-03_JPRB, 0.37467827E-03_JPRB, 0.37447711E-03_JPRB, 0.37426662E-03_JPRB, &
  & 0.37402644E-03_JPRB, 0.37375201E-03_JPRB, 0.37345313E-03_JPRB, 0.37314770E-03_JPRB, 0.37285999E-03_JPRB, 0.37260901E-03_JPRB, &
  & 0.37239454E-03_JPRB, 0.37220458E-03_JPRB, 0.37201877E-03_JPRB, 0.37180467E-03_JPRB, 0.37157586E-03_JPRB, 0.37139570E-03_JPRB, &
  & 0.37130891E-03_JPRB, 0.37129214E-03_JPRB, 0.37131867E-03_JPRB, 0.37134531E-03_JPRB, 0.37133430E-03_JPRB, 0.37128094E-03_JPRB, &
  & 0.37120514E-03_JPRB, 0.37112107E-03_JPRB, 0.37104087E-03_JPRB, 0.37099993E-03_JPRB  /)

RGHG1(:,13, 7) = (/ &
  & 0.37237348E-03_JPRB, 0.37238829E-03_JPRB, 0.37240138E-03_JPRB, 0.37241754E-03_JPRB, 0.37243544E-03_JPRB, 0.37244656E-03_JPRB, &
  & 0.37245025E-03_JPRB, 0.37244837E-03_JPRB, 0.37244127E-03_JPRB, 0.37243283E-03_JPRB, 0.37243513E-03_JPRB, 0.37246441E-03_JPRB, &
  & 0.37252681E-03_JPRB, 0.37263001E-03_JPRB, 0.37277551E-03_JPRB, 0.37297445E-03_JPRB, 0.37322534E-03_JPRB, 0.37350172E-03_JPRB, &
  & 0.37375436E-03_JPRB, 0.37393777E-03_JPRB, 0.37405016E-03_JPRB, 0.37412100E-03_JPRB, 0.37417021E-03_JPRB, 0.37421331E-03_JPRB, &
  & 0.37425164E-03_JPRB, 0.37427617E-03_JPRB, 0.37429526E-03_JPRB, 0.37432575E-03_JPRB, 0.37437082E-03_JPRB, 0.37445198E-03_JPRB, &
  & 0.37460280E-03_JPRB, 0.37483192E-03_JPRB, 0.37508290E-03_JPRB, 0.37523094E-03_JPRB, 0.37527593E-03_JPRB, 0.37527689E-03_JPRB, &
  & 0.37525626E-03_JPRB, 0.37517730E-03_JPRB, 0.37503851E-03_JPRB, 0.37486178E-03_JPRB, 0.37465304E-03_JPRB, 0.37440937E-03_JPRB, &
  & 0.37413256E-03_JPRB, 0.37383565E-03_JPRB, 0.37353340E-03_JPRB, 0.37324213E-03_JPRB, 0.37297872E-03_JPRB, 0.37274945E-03_JPRB, &
  & 0.37254224E-03_JPRB, 0.37234540E-03_JPRB, 0.37215550E-03_JPRB, 0.37194690E-03_JPRB, 0.37173282E-03_JPRB, 0.37158491E-03_JPRB, &
  & 0.37153177E-03_JPRB, 0.37154377E-03_JPRB, 0.37160654E-03_JPRB, 0.37167035E-03_JPRB, 0.37168481E-03_JPRB, 0.37163213E-03_JPRB, &
  & 0.37150972E-03_JPRB, 0.37136665E-03_JPRB, 0.37123402E-03_JPRB, 0.37116221E-03_JPRB  /)

RGHG1(:,14, 7) = (/ &
  & 0.37207575E-03_JPRB, 0.37207605E-03_JPRB, 0.37208521E-03_JPRB, 0.37210046E-03_JPRB, 0.37211595E-03_JPRB, 0.37212490E-03_JPRB, &
  & 0.37213097E-03_JPRB, 0.37213773E-03_JPRB, 0.37214376E-03_JPRB, 0.37215326E-03_JPRB, 0.37217879E-03_JPRB, 0.37223837E-03_JPRB, &
  & 0.37232993E-03_JPRB, 0.37245634E-03_JPRB, 0.37262516E-03_JPRB, 0.37285907E-03_JPRB, 0.37316635E-03_JPRB, 0.37352156E-03_JPRB, &
  & 0.37387081E-03_JPRB, 0.37415185E-03_JPRB, 0.37432564E-03_JPRB, 0.37443709E-03_JPRB, 0.37451110E-03_JPRB, 0.37456850E-03_JPRB, &
  & 0.37461554E-03_JPRB, 0.37464101E-03_JPRB, 0.37465643E-03_JPRB, 0.37468723E-03_JPRB, 0.37472393E-03_JPRB, 0.37477143E-03_JPRB, &
  & 0.37487977E-03_JPRB, 0.37506438E-03_JPRB, 0.37527727E-03_JPRB, 0.37541854E-03_JPRB, 0.37547553E-03_JPRB, 0.37548340E-03_JPRB, &
  & 0.37546487E-03_JPRB, 0.37539309E-03_JPRB, 0.37526699E-03_JPRB, 0.37509388E-03_JPRB, 0.37486570E-03_JPRB, 0.37458499E-03_JPRB, &
  & 0.37427925E-03_JPRB, 0.37397707E-03_JPRB, 0.37368783E-03_JPRB, 0.37342053E-03_JPRB, 0.37317900E-03_JPRB, 0.37296327E-03_JPRB, &
  & 0.37275660E-03_JPRB, 0.37255414E-03_JPRB, 0.37236644E-03_JPRB, 0.37218337E-03_JPRB, 0.37202578E-03_JPRB, 0.37195011E-03_JPRB, &
  & 0.37195790E-03_JPRB, 0.37201225E-03_JPRB, 0.37210624E-03_JPRB, 0.37219353E-03_JPRB, 0.37223375E-03_JPRB, 0.37219885E-03_JPRB, &
  & 0.37203809E-03_JPRB, 0.37185098E-03_JPRB, 0.37169792E-03_JPRB, 0.37161200E-03_JPRB  /)

RGHG1(:,15, 7) = (/ &
  & 0.37190210E-03_JPRB, 0.37189668E-03_JPRB, 0.37190578E-03_JPRB, 0.37191900E-03_JPRB, 0.37193435E-03_JPRB, 0.37194798E-03_JPRB, &
  & 0.37196187E-03_JPRB, 0.37197609E-03_JPRB, 0.37199100E-03_JPRB, 0.37201408E-03_JPRB, 0.37205826E-03_JPRB, 0.37213880E-03_JPRB, &
  & 0.37224565E-03_JPRB, 0.37238270E-03_JPRB, 0.37256945E-03_JPRB, 0.37283098E-03_JPRB, 0.37317049E-03_JPRB, 0.37358446E-03_JPRB, &
  & 0.37403231E-03_JPRB, 0.37443869E-03_JPRB, 0.37470192E-03_JPRB, 0.37487855E-03_JPRB, 0.37500227E-03_JPRB, 0.37508992E-03_JPRB, &
  & 0.37515381E-03_JPRB, 0.37519348E-03_JPRB, 0.37522110E-03_JPRB, 0.37526237E-03_JPRB, 0.37530736E-03_JPRB, 0.37534032E-03_JPRB, &
  & 0.37541302E-03_JPRB, 0.37552807E-03_JPRB, 0.37565212E-03_JPRB, 0.37574576E-03_JPRB, 0.37578858E-03_JPRB, 0.37578206E-03_JPRB, &
  & 0.37573525E-03_JPRB, 0.37563716E-03_JPRB, 0.37548564E-03_JPRB, 0.37528169E-03_JPRB, 0.37501845E-03_JPRB, 0.37471367E-03_JPRB, &
  & 0.37440371E-03_JPRB, 0.37410766E-03_JPRB, 0.37382564E-03_JPRB, 0.37356221E-03_JPRB, 0.37332365E-03_JPRB, 0.37311250E-03_JPRB, &
  & 0.37291138E-03_JPRB, 0.37272481E-03_JPRB, 0.37256379E-03_JPRB, 0.37242396E-03_JPRB, 0.37233597E-03_JPRB, 0.37233844E-03_JPRB, &
  & 0.37241307E-03_JPRB, 0.37251271E-03_JPRB, 0.37261998E-03_JPRB, 0.37270368E-03_JPRB, 0.37274245E-03_JPRB, 0.37271714E-03_JPRB, &
  & 0.37256433E-03_JPRB, 0.37238300E-03_JPRB, 0.37224164E-03_JPRB, 0.37214597E-03_JPRB  /)

RGHG1(:,16, 7) = (/ &
  & 0.37186078E-03_JPRB, 0.37187225E-03_JPRB, 0.37187989E-03_JPRB, 0.37189059E-03_JPRB, 0.37190557E-03_JPRB, 0.37192277E-03_JPRB, &
  & 0.37193966E-03_JPRB, 0.37195263E-03_JPRB, 0.37197107E-03_JPRB, 0.37200126E-03_JPRB, 0.37205685E-03_JPRB, 0.37214764E-03_JPRB, &
  & 0.37226346E-03_JPRB, 0.37241302E-03_JPRB, 0.37261925E-03_JPRB, 0.37289786E-03_JPRB, 0.37324258E-03_JPRB, 0.37367162E-03_JPRB, &
  & 0.37418303E-03_JPRB, 0.37467968E-03_JPRB, 0.37503259E-03_JPRB, 0.37527532E-03_JPRB, 0.37544244E-03_JPRB, 0.37556346E-03_JPRB, &
  & 0.37564001E-03_JPRB, 0.37569684E-03_JPRB, 0.37574824E-03_JPRB, 0.37582350E-03_JPRB, 0.37592092E-03_JPRB, 0.37600978E-03_JPRB, &
  & 0.37608113E-03_JPRB, 0.37612275E-03_JPRB, 0.37614988E-03_JPRB, 0.37617359E-03_JPRB, 0.37616818E-03_JPRB, 0.37611006E-03_JPRB, &
  & 0.37600119E-03_JPRB, 0.37584678E-03_JPRB, 0.37564298E-03_JPRB, 0.37538991E-03_JPRB, 0.37508618E-03_JPRB, 0.37476412E-03_JPRB, &
  & 0.37445574E-03_JPRB, 0.37415595E-03_JPRB, 0.37385659E-03_JPRB, 0.37357354E-03_JPRB, 0.37332867E-03_JPRB, 0.37311815E-03_JPRB, &
  & 0.37293006E-03_JPRB, 0.37277097E-03_JPRB, 0.37264810E-03_JPRB, 0.37255656E-03_JPRB, 0.37251947E-03_JPRB, 0.37255759E-03_JPRB, &
  & 0.37266096E-03_JPRB, 0.37279003E-03_JPRB, 0.37289687E-03_JPRB, 0.37295557E-03_JPRB, 0.37296567E-03_JPRB, 0.37292829E-03_JPRB, &
  & 0.37282264E-03_JPRB, 0.37268313E-03_JPRB, 0.37255437E-03_JPRB, 0.37245881E-03_JPRB  /)

RGHG1(:,17, 7) = (/ &
  & 0.37189855E-03_JPRB, 0.37191413E-03_JPRB, 0.37192373E-03_JPRB, 0.37193901E-03_JPRB, 0.37195307E-03_JPRB, 0.37196865E-03_JPRB, &
  & 0.37198485E-03_JPRB, 0.37199933E-03_JPRB, 0.37202105E-03_JPRB, 0.37205797E-03_JPRB, 0.37212695E-03_JPRB, 0.37223055E-03_JPRB, &
  & 0.37236350E-03_JPRB, 0.37253882E-03_JPRB, 0.37277271E-03_JPRB, 0.37306400E-03_JPRB, 0.37339627E-03_JPRB, 0.37381497E-03_JPRB, &
  & 0.37434042E-03_JPRB, 0.37486131E-03_JPRB, 0.37527120E-03_JPRB, 0.37554295E-03_JPRB, 0.37572519E-03_JPRB, 0.37586432E-03_JPRB, &
  & 0.37595956E-03_JPRB, 0.37603233E-03_JPRB, 0.37611597E-03_JPRB, 0.37624424E-03_JPRB, 0.37641836E-03_JPRB, 0.37661266E-03_JPRB, &
  & 0.37676727E-03_JPRB, 0.37680128E-03_JPRB, 0.37674682E-03_JPRB, 0.37667157E-03_JPRB, 0.37658068E-03_JPRB, 0.37644527E-03_JPRB, &
  & 0.37625588E-03_JPRB, 0.37602664E-03_JPRB, 0.37575929E-03_JPRB, 0.37545525E-03_JPRB, 0.37511670E-03_JPRB, 0.37477860E-03_JPRB, &
  & 0.37445944E-03_JPRB, 0.37413701E-03_JPRB, 0.37380202E-03_JPRB, 0.37349034E-03_JPRB, 0.37323299E-03_JPRB, 0.37301501E-03_JPRB, &
  & 0.37283968E-03_JPRB, 0.37270605E-03_JPRB, 0.37261495E-03_JPRB, 0.37256774E-03_JPRB, 0.37256584E-03_JPRB, 0.37261337E-03_JPRB, &
  & 0.37270590E-03_JPRB, 0.37282884E-03_JPRB, 0.37293056E-03_JPRB, 0.37297611E-03_JPRB, 0.37296813E-03_JPRB, 0.37292185E-03_JPRB, &
  & 0.37284736E-03_JPRB, 0.37274913E-03_JPRB, 0.37261442E-03_JPRB, 0.37249385E-03_JPRB  /)

RGHG1(:,18, 7) = (/ &
  & 0.37198286E-03_JPRB, 0.37199426E-03_JPRB, 0.37200945E-03_JPRB, 0.37203350E-03_JPRB, 0.37205090E-03_JPRB, 0.37206324E-03_JPRB, &
  & 0.37208314E-03_JPRB, 0.37210370E-03_JPRB, 0.37212828E-03_JPRB, 0.37217231E-03_JPRB, 0.37225477E-03_JPRB, 0.37237720E-03_JPRB, &
  & 0.37254062E-03_JPRB, 0.37276044E-03_JPRB, 0.37302988E-03_JPRB, 0.37333090E-03_JPRB, 0.37365207E-03_JPRB, 0.37404418E-03_JPRB, &
  & 0.37451827E-03_JPRB, 0.37499159E-03_JPRB, 0.37539065E-03_JPRB, 0.37565920E-03_JPRB, 0.37584090E-03_JPRB, 0.37598764E-03_JPRB, &
  & 0.37611269E-03_JPRB, 0.37621836E-03_JPRB, 0.37634182E-03_JPRB, 0.37652348E-03_JPRB, 0.37675103E-03_JPRB, 0.37704309E-03_JPRB, &
  & 0.37735317E-03_JPRB, 0.37748593E-03_JPRB, 0.37739004E-03_JPRB, 0.37721509E-03_JPRB, 0.37703621E-03_JPRB, 0.37682794E-03_JPRB, &
  & 0.37656326E-03_JPRB, 0.37625247E-03_JPRB, 0.37591997E-03_JPRB, 0.37557138E-03_JPRB, 0.37520632E-03_JPRB, 0.37484950E-03_JPRB, &
  & 0.37450463E-03_JPRB, 0.37414723E-03_JPRB, 0.37377071E-03_JPRB, 0.37343488E-03_JPRB, 0.37316294E-03_JPRB, 0.37293290E-03_JPRB, &
  & 0.37276322E-03_JPRB, 0.37264202E-03_JPRB, 0.37257012E-03_JPRB, 0.37255160E-03_JPRB, 0.37257002E-03_JPRB, 0.37262144E-03_JPRB, &
  & 0.37269544E-03_JPRB, 0.37279158E-03_JPRB, 0.37287430E-03_JPRB, 0.37291328E-03_JPRB, 0.37290018E-03_JPRB, 0.37285786E-03_JPRB, &
  & 0.37280999E-03_JPRB, 0.37273607E-03_JPRB, 0.37260512E-03_JPRB, 0.37247269E-03_JPRB  /)

RGHG1(:,19, 7) = (/ &
  & 0.37216395E-03_JPRB, 0.37217578E-03_JPRB, 0.37219708E-03_JPRB, 0.37222247E-03_JPRB, 0.37223885E-03_JPRB, 0.37225531E-03_JPRB, &
  & 0.37227888E-03_JPRB, 0.37229995E-03_JPRB, 0.37232236E-03_JPRB, 0.37236673E-03_JPRB, 0.37245625E-03_JPRB, 0.37259973E-03_JPRB, &
  & 0.37280149E-03_JPRB, 0.37307757E-03_JPRB, 0.37338546E-03_JPRB, 0.37369397E-03_JPRB, 0.37399611E-03_JPRB, 0.37433318E-03_JPRB, &
  & 0.37470843E-03_JPRB, 0.37508683E-03_JPRB, 0.37543083E-03_JPRB, 0.37567211E-03_JPRB, 0.37583827E-03_JPRB, 0.37599030E-03_JPRB, &
  & 0.37614197E-03_JPRB, 0.37629516E-03_JPRB, 0.37647573E-03_JPRB, 0.37670696E-03_JPRB, 0.37699079E-03_JPRB, 0.37739471E-03_JPRB, &
  & 0.37787246E-03_JPRB, 0.37813310E-03_JPRB, 0.37802544E-03_JPRB, 0.37777186E-03_JPRB, 0.37753682E-03_JPRB, 0.37729491E-03_JPRB, &
  & 0.37699227E-03_JPRB, 0.37661991E-03_JPRB, 0.37623114E-03_JPRB, 0.37584369E-03_JPRB, 0.37545291E-03_JPRB, 0.37507260E-03_JPRB, &
  & 0.37469377E-03_JPRB, 0.37429670E-03_JPRB, 0.37388407E-03_JPRB, 0.37352788E-03_JPRB, 0.37323830E-03_JPRB, 0.37299441E-03_JPRB, &
  & 0.37281939E-03_JPRB, 0.37270109E-03_JPRB, 0.37263860E-03_JPRB, 0.37263421E-03_JPRB, 0.37266685E-03_JPRB, 0.37271556E-03_JPRB, &
  & 0.37276997E-03_JPRB, 0.37283367E-03_JPRB, 0.37288785E-03_JPRB, 0.37291007E-03_JPRB, 0.37289451E-03_JPRB, 0.37286068E-03_JPRB, &
  & 0.37282640E-03_JPRB, 0.37276920E-03_JPRB, 0.37266791E-03_JPRB, 0.37255759E-03_JPRB  /)

RGHG1(:,20, 7) = (/ &
  & 0.37251101E-03_JPRB, 0.37251853E-03_JPRB, 0.37253599E-03_JPRB, 0.37254933E-03_JPRB, 0.37255739E-03_JPRB, 0.37257384E-03_JPRB, &
  & 0.37259257E-03_JPRB, 0.37260460E-03_JPRB, 0.37261582E-03_JPRB, 0.37265040E-03_JPRB, 0.37273955E-03_JPRB, 0.37290215E-03_JPRB, &
  & 0.37314531E-03_JPRB, 0.37347644E-03_JPRB, 0.37381667E-03_JPRB, 0.37412052E-03_JPRB, 0.37438635E-03_JPRB, 0.37464821E-03_JPRB, &
  & 0.37491644E-03_JPRB, 0.37518751E-03_JPRB, 0.37545556E-03_JPRB, 0.37565668E-03_JPRB, 0.37580290E-03_JPRB, 0.37594916E-03_JPRB, &
  & 0.37611595E-03_JPRB, 0.37631344E-03_JPRB, 0.37654202E-03_JPRB, 0.37681997E-03_JPRB, 0.37718761E-03_JPRB, 0.37773827E-03_JPRB, &
  & 0.37837901E-03_JPRB, 0.37875316E-03_JPRB, 0.37864410E-03_JPRB, 0.37832858E-03_JPRB, 0.37806741E-03_JPRB, 0.37782631E-03_JPRB, &
  & 0.37753385E-03_JPRB, 0.37714289E-03_JPRB, 0.37672883E-03_JPRB, 0.37631924E-03_JPRB, 0.37590458E-03_JPRB, 0.37549930E-03_JPRB, &
  & 0.37509062E-03_JPRB, 0.37466307E-03_JPRB, 0.37422641E-03_JPRB, 0.37385737E-03_JPRB, 0.37355619E-03_JPRB, 0.37330279E-03_JPRB, &
  & 0.37312066E-03_JPRB, 0.37299849E-03_JPRB, 0.37293474E-03_JPRB, 0.37293066E-03_JPRB, 0.37296715E-03_JPRB, 0.37300375E-03_JPRB, &
  & 0.37303535E-03_JPRB, 0.37306343E-03_JPRB, 0.37308211E-03_JPRB, 0.37307759E-03_JPRB, 0.37305393E-03_JPRB, 0.37302730E-03_JPRB, &
  & 0.37300294E-03_JPRB, 0.37296337E-03_JPRB, 0.37290057E-03_JPRB, 0.37282807E-03_JPRB  /)

RGHG1(:,21, 7) = (/ &
  & 0.37302904E-03_JPRB, 0.37302103E-03_JPRB, 0.37302229E-03_JPRB, 0.37301339E-03_JPRB, 0.37300460E-03_JPRB, 0.37300778E-03_JPRB, &
  & 0.37300801E-03_JPRB, 0.37300131E-03_JPRB, 0.37299341E-03_JPRB, 0.37301121E-03_JPRB, 0.37309602E-03_JPRB, 0.37327565E-03_JPRB, &
  & 0.37356007E-03_JPRB, 0.37393663E-03_JPRB, 0.37429757E-03_JPRB, 0.37458305E-03_JPRB, 0.37480322E-03_JPRB, 0.37498534E-03_JPRB, &
  & 0.37516001E-03_JPRB, 0.37533539E-03_JPRB, 0.37552788E-03_JPRB, 0.37568607E-03_JPRB, 0.37580782E-03_JPRB, 0.37593929E-03_JPRB, &
  & 0.37611269E-03_JPRB, 0.37633571E-03_JPRB, 0.37658699E-03_JPRB, 0.37690969E-03_JPRB, 0.37739428E-03_JPRB, 0.37812324E-03_JPRB, &
  & 0.37890643E-03_JPRB, 0.37935091E-03_JPRB, 0.37923684E-03_JPRB, 0.37888339E-03_JPRB, 0.37862184E-03_JPRB, 0.37840270E-03_JPRB, &
  & 0.37815308E-03_JPRB, 0.37778660E-03_JPRB, 0.37738690E-03_JPRB, 0.37697998E-03_JPRB, 0.37654981E-03_JPRB, 0.37612638E-03_JPRB, &
  & 0.37569678E-03_JPRB, 0.37524961E-03_JPRB, 0.37480235E-03_JPRB, 0.37442974E-03_JPRB, 0.37412676E-03_JPRB, 0.37387147E-03_JPRB, &
  & 0.37368441E-03_JPRB, 0.37355351E-03_JPRB, 0.37347856E-03_JPRB, 0.37346097E-03_JPRB, 0.37348716E-03_JPRB, 0.37350339E-03_JPRB, &
  & 0.37350853E-03_JPRB, 0.37350055E-03_JPRB, 0.37348155E-03_JPRB, 0.37344711E-03_JPRB, 0.37341283E-03_JPRB, 0.37339116E-03_JPRB, &
  & 0.37337532E-03_JPRB, 0.37335400E-03_JPRB, 0.37332472E-03_JPRB, 0.37329002E-03_JPRB  /)

RGHG1(:,22, 7) = (/ &
  & 0.37370267E-03_JPRB, 0.37366331E-03_JPRB, 0.37363700E-03_JPRB, 0.37360264E-03_JPRB, 0.37356650E-03_JPRB, 0.37353488E-03_JPRB, &
  & 0.37349786E-03_JPRB, 0.37346304E-03_JPRB, 0.37343112E-03_JPRB, 0.37343113E-03_JPRB, 0.37351283E-03_JPRB, 0.37370891E-03_JPRB, &
  & 0.37403113E-03_JPRB, 0.37443538E-03_JPRB, 0.37479977E-03_JPRB, 0.37505545E-03_JPRB, 0.37523815E-03_JPRB, 0.37535545E-03_JPRB, &
  & 0.37546497E-03_JPRB, 0.37557843E-03_JPRB, 0.37571922E-03_JPRB, 0.37584195E-03_JPRB, 0.37592711E-03_JPRB, 0.37604369E-03_JPRB, &
  & 0.37622276E-03_JPRB, 0.37643522E-03_JPRB, 0.37667160E-03_JPRB, 0.37703666E-03_JPRB, 0.37767022E-03_JPRB, 0.37859441E-03_JPRB, &
  & 0.37947356E-03_JPRB, 0.37991125E-03_JPRB, 0.37977661E-03_JPRB, 0.37943005E-03_JPRB, 0.37919497E-03_JPRB, 0.37900618E-03_JPRB, &
  & 0.37880659E-03_JPRB, 0.37850126E-03_JPRB, 0.37816159E-03_JPRB, 0.37779158E-03_JPRB, 0.37736497E-03_JPRB, 0.37694276E-03_JPRB, &
  & 0.37650327E-03_JPRB, 0.37604354E-03_JPRB, 0.37560005E-03_JPRB, 0.37523490E-03_JPRB, 0.37494137E-03_JPRB, 0.37469453E-03_JPRB, &
  & 0.37450513E-03_JPRB, 0.37436189E-03_JPRB, 0.37426660E-03_JPRB, 0.37421965E-03_JPRB, 0.37421693E-03_JPRB, 0.37420715E-03_JPRB, &
  & 0.37418316E-03_JPRB, 0.37414338E-03_JPRB, 0.37409148E-03_JPRB, 0.37403346E-03_JPRB, 0.37399530E-03_JPRB, 0.37397741E-03_JPRB, &
  & 0.37396479E-03_JPRB, 0.37395726E-03_JPRB, 0.37394521E-03_JPRB, 0.37393563E-03_JPRB  /)

RGHG1(:,23, 7) = (/ &
  & 0.37429567E-03_JPRB, 0.37424357E-03_JPRB, 0.37419337E-03_JPRB, 0.37413262E-03_JPRB, 0.37406722E-03_JPRB, 0.37399789E-03_JPRB, &
  & 0.37392590E-03_JPRB, 0.37386562E-03_JPRB, 0.37382313E-03_JPRB, 0.37382618E-03_JPRB, 0.37391735E-03_JPRB, 0.37413633E-03_JPRB, &
  & 0.37448607E-03_JPRB, 0.37490042E-03_JPRB, 0.37525476E-03_JPRB, 0.37549470E-03_JPRB, 0.37565762E-03_JPRB, 0.37575373E-03_JPRB, &
  & 0.37585318E-03_JPRB, 0.37596204E-03_JPRB, 0.37608569E-03_JPRB, 0.37617816E-03_JPRB, 0.37624204E-03_JPRB, 0.37634562E-03_JPRB, &
  & 0.37652100E-03_JPRB, 0.37671449E-03_JPRB, 0.37693761E-03_JPRB, 0.37733583E-03_JPRB, 0.37809522E-03_JPRB, 0.37915301E-03_JPRB, &
  & 0.38003536E-03_JPRB, 0.38038288E-03_JPRB, 0.38021248E-03_JPRB, 0.37992490E-03_JPRB, 0.37974356E-03_JPRB, 0.37958720E-03_JPRB, &
  & 0.37941482E-03_JPRB, 0.37916140E-03_JPRB, 0.37889376E-03_JPRB, 0.37857160E-03_JPRB, 0.37817635E-03_JPRB, 0.37777594E-03_JPRB, &
  & 0.37734002E-03_JPRB, 0.37687021E-03_JPRB, 0.37642016E-03_JPRB, 0.37605788E-03_JPRB, 0.37576966E-03_JPRB, 0.37553536E-03_JPRB, &
  & 0.37535215E-03_JPRB, 0.37519700E-03_JPRB, 0.37507403E-03_JPRB, 0.37499335E-03_JPRB, 0.37495404E-03_JPRB, 0.37491497E-03_JPRB, &
  & 0.37486311E-03_JPRB, 0.37480136E-03_JPRB, 0.37473708E-03_JPRB, 0.37467844E-03_JPRB, 0.37464665E-03_JPRB, 0.37462786E-03_JPRB, &
  & 0.37461684E-03_JPRB, 0.37461431E-03_JPRB, 0.37461128E-03_JPRB, 0.37461294E-03_JPRB  /)

RGHG1(:,24, 7) = (/ &
  & 0.37480943E-03_JPRB, 0.37475229E-03_JPRB, 0.37468277E-03_JPRB, 0.37459865E-03_JPRB, 0.37450645E-03_JPRB, 0.37440321E-03_JPRB, &
  & 0.37430282E-03_JPRB, 0.37422160E-03_JPRB, 0.37417630E-03_JPRB, 0.37419267E-03_JPRB, 0.37430213E-03_JPRB, 0.37454885E-03_JPRB, &
  & 0.37492221E-03_JPRB, 0.37534337E-03_JPRB, 0.37568758E-03_JPRB, 0.37592063E-03_JPRB, 0.37607270E-03_JPRB, 0.37616730E-03_JPRB, &
  & 0.37628147E-03_JPRB, 0.37640178E-03_JPRB, 0.37651397E-03_JPRB, 0.37658558E-03_JPRB, 0.37663607E-03_JPRB, 0.37674213E-03_JPRB, &
  & 0.37692392E-03_JPRB, 0.37711295E-03_JPRB, 0.37733579E-03_JPRB, 0.37775577E-03_JPRB, 0.37860291E-03_JPRB, 0.37975299E-03_JPRB, &
  & 0.38059344E-03_JPRB, 0.38082805E-03_JPRB, 0.38063880E-03_JPRB, 0.38042246E-03_JPRB, 0.38029220E-03_JPRB, 0.38016215E-03_JPRB, &
  & 0.38000972E-03_JPRB, 0.37979802E-03_JPRB, 0.37959001E-03_JPRB, 0.37931247E-03_JPRB, 0.37895358E-03_JPRB, 0.37857873E-03_JPRB, &
  & 0.37815290E-03_JPRB, 0.37767371E-03_JPRB, 0.37721227E-03_JPRB, 0.37684792E-03_JPRB, 0.37656540E-03_JPRB, 0.37634172E-03_JPRB, &
  & 0.37616093E-03_JPRB, 0.37598876E-03_JPRB, 0.37583719E-03_JPRB, 0.37572579E-03_JPRB, 0.37565322E-03_JPRB, 0.37558868E-03_JPRB, &
  & 0.37551375E-03_JPRB, 0.37543573E-03_JPRB, 0.37536583E-03_JPRB, 0.37531127E-03_JPRB, 0.37528636E-03_JPRB, 0.37526725E-03_JPRB, &
  & 0.37525541E-03_JPRB, 0.37525331E-03_JPRB, 0.37525752E-03_JPRB, 0.37526792E-03_JPRB  /)

RGHG1(:,25, 7) = (/ &
  & 0.37517782E-03_JPRB, 0.37512530E-03_JPRB, 0.37504458E-03_JPRB, 0.37494371E-03_JPRB, 0.37483073E-03_JPRB, 0.37470246E-03_JPRB, &
  & 0.37458608E-03_JPRB, 0.37449225E-03_JPRB, 0.37445505E-03_JPRB, 0.37449766E-03_JPRB, 0.37463742E-03_JPRB, 0.37491772E-03_JPRB, &
  & 0.37530904E-03_JPRB, 0.37573481E-03_JPRB, 0.37607225E-03_JPRB, 0.37631123E-03_JPRB, 0.37646480E-03_JPRB, 0.37658302E-03_JPRB, &
  & 0.37674282E-03_JPRB, 0.37688956E-03_JPRB, 0.37699309E-03_JPRB, 0.37706028E-03_JPRB, 0.37710851E-03_JPRB, 0.37724392E-03_JPRB, &
  & 0.37745186E-03_JPRB, 0.37766422E-03_JPRB, 0.37790946E-03_JPRB, 0.37833207E-03_JPRB, 0.37920076E-03_JPRB, 0.38037962E-03_JPRB, &
  & 0.38112101E-03_JPRB, 0.38122627E-03_JPRB, 0.38105235E-03_JPRB, 0.38091410E-03_JPRB, 0.38082175E-03_JPRB, 0.38070552E-03_JPRB, &
  & 0.38056438E-03_JPRB, 0.38037658E-03_JPRB, 0.38020083E-03_JPRB, 0.37995773E-03_JPRB, 0.37963618E-03_JPRB, 0.37928777E-03_JPRB, &
  & 0.37888010E-03_JPRB, 0.37839263E-03_JPRB, 0.37791406E-03_JPRB, 0.37754003E-03_JPRB, 0.37726456E-03_JPRB, 0.37704671E-03_JPRB, &
  & 0.37685962E-03_JPRB, 0.37666205E-03_JPRB, 0.37648320E-03_JPRB, 0.37634875E-03_JPRB, 0.37625210E-03_JPRB, 0.37617072E-03_JPRB, &
  & 0.37608196E-03_JPRB, 0.37599632E-03_JPRB, 0.37592839E-03_JPRB, 0.37588089E-03_JPRB, 0.37586115E-03_JPRB, 0.37584383E-03_JPRB, &
  & 0.37582729E-03_JPRB, 0.37581945E-03_JPRB, 0.37582931E-03_JPRB, 0.37584677E-03_JPRB  /)

RGHG1(:,26, 7) = (/ &
  & 0.37543299E-03_JPRB, 0.37537008E-03_JPRB, 0.37527602E-03_JPRB, 0.37516116E-03_JPRB, 0.37504143E-03_JPRB, 0.37490184E-03_JPRB, &
  & 0.37477173E-03_JPRB, 0.37467602E-03_JPRB, 0.37465036E-03_JPRB, 0.37472042E-03_JPRB, 0.37489358E-03_JPRB, 0.37520498E-03_JPRB, &
  & 0.37561359E-03_JPRB, 0.37604739E-03_JPRB, 0.37639328E-03_JPRB, 0.37664354E-03_JPRB, 0.37679813E-03_JPRB, 0.37694787E-03_JPRB, &
  & 0.37714850E-03_JPRB, 0.37732813E-03_JPRB, 0.37743974E-03_JPRB, 0.37751253E-03_JPRB, 0.37758248E-03_JPRB, 0.37776357E-03_JPRB, &
  & 0.37802515E-03_JPRB, 0.37829208E-03_JPRB, 0.37856946E-03_JPRB, 0.37897862E-03_JPRB, 0.37979742E-03_JPRB, 0.38092414E-03_JPRB, &
  & 0.38157768E-03_JPRB, 0.38162187E-03_JPRB, 0.38148209E-03_JPRB, 0.38139557E-03_JPRB, 0.38131736E-03_JPRB, 0.38120327E-03_JPRB, &
  & 0.38106645E-03_JPRB, 0.38089116E-03_JPRB, 0.38071680E-03_JPRB, 0.38048865E-03_JPRB, 0.38019096E-03_JPRB, 0.37985790E-03_JPRB, &
  & 0.37944946E-03_JPRB, 0.37896050E-03_JPRB, 0.37847671E-03_JPRB, 0.37810404E-03_JPRB, 0.37783575E-03_JPRB, 0.37761317E-03_JPRB, &
  & 0.37740695E-03_JPRB, 0.37718370E-03_JPRB, 0.37697590E-03_JPRB, 0.37681775E-03_JPRB, 0.37671207E-03_JPRB, 0.37663229E-03_JPRB, &
  & 0.37655007E-03_JPRB, 0.37647007E-03_JPRB, 0.37640693E-03_JPRB, 0.37636010E-03_JPRB, 0.37633211E-03_JPRB, 0.37630894E-03_JPRB, &
  & 0.37628974E-03_JPRB, 0.37627748E-03_JPRB, 0.37628671E-03_JPRB, 0.37630694E-03_JPRB  /)

RGHG1(:,27, 7) = (/ &
  & 0.37565779E-03_JPRB, 0.37557846E-03_JPRB, 0.37546965E-03_JPRB, 0.37534119E-03_JPRB, 0.37521962E-03_JPRB, 0.37507327E-03_JPRB, &
  & 0.37492964E-03_JPRB, 0.37483595E-03_JPRB, 0.37482363E-03_JPRB, 0.37492283E-03_JPRB, 0.37513207E-03_JPRB, 0.37547507E-03_JPRB, &
  & 0.37590150E-03_JPRB, 0.37634495E-03_JPRB, 0.37670533E-03_JPRB, 0.37696936E-03_JPRB, 0.37712483E-03_JPRB, 0.37731048E-03_JPRB, &
  & 0.37755200E-03_JPRB, 0.37776841E-03_JPRB, 0.37789469E-03_JPRB, 0.37797704E-03_JPRB, 0.37807860E-03_JPRB, 0.37831349E-03_JPRB, &
  & 0.37864134E-03_JPRB, 0.37897691E-03_JPRB, 0.37929151E-03_JPRB, 0.37968066E-03_JPRB, 0.38042081E-03_JPRB, 0.38146300E-03_JPRB, &
  & 0.38202885E-03_JPRB, 0.38203451E-03_JPRB, 0.38193738E-03_JPRB, 0.38189520E-03_JPRB, 0.38182296E-03_JPRB, 0.38170676E-03_JPRB, &
  & 0.38157186E-03_JPRB, 0.38140544E-03_JPRB, 0.38122107E-03_JPRB, 0.38100136E-03_JPRB, 0.38072358E-03_JPRB, 0.38040246E-03_JPRB, &
  & 0.37998621E-03_JPRB, 0.37949822E-03_JPRB, 0.37901338E-03_JPRB, 0.37864624E-03_JPRB, 0.37838550E-03_JPRB, 0.37815405E-03_JPRB, &
  & 0.37792308E-03_JPRB, 0.37767288E-03_JPRB, 0.37743418E-03_JPRB, 0.37725102E-03_JPRB, 0.37714148E-03_JPRB, 0.37707021E-03_JPRB, &
  & 0.37700239E-03_JPRB, 0.37693317E-03_JPRB, 0.37687610E-03_JPRB, 0.37682760E-03_JPRB, 0.37678600E-03_JPRB, 0.37675388E-03_JPRB, &
  & 0.37673266E-03_JPRB, 0.37671628E-03_JPRB, 0.37672252E-03_JPRB, 0.37674407E-03_JPRB  /)

RGHG1(:,28, 7) = (/ &
  & 0.37581000E-03_JPRB, 0.37572224E-03_JPRB, 0.37560448E-03_JPRB, 0.37545596E-03_JPRB, 0.37532689E-03_JPRB, 0.37518916E-03_JPRB, &
  & 0.37504274E-03_JPRB, 0.37495030E-03_JPRB, 0.37495139E-03_JPRB, 0.37507096E-03_JPRB, 0.37530565E-03_JPRB, 0.37566897E-03_JPRB, &
  & 0.37610848E-03_JPRB, 0.37656250E-03_JPRB, 0.37694762E-03_JPRB, 0.37722633E-03_JPRB, 0.37739501E-03_JPRB, 0.37760078E-03_JPRB, &
  & 0.37786977E-03_JPRB, 0.37812658E-03_JPRB, 0.37829384E-03_JPRB, 0.37839492E-03_JPRB, 0.37851214E-03_JPRB, 0.37877405E-03_JPRB, &
  & 0.37917375E-03_JPRB, 0.37958593E-03_JPRB, 0.37994000E-03_JPRB, 0.38031912E-03_JPRB, 0.38097106E-03_JPRB, 0.38189655E-03_JPRB, &
  & 0.38243092E-03_JPRB, 0.38246418E-03_JPRB, 0.38239772E-03_JPRB, 0.38235953E-03_JPRB, 0.38228833E-03_JPRB, 0.38217620E-03_JPRB, &
  & 0.38204953E-03_JPRB, 0.38188761E-03_JPRB, 0.38168057E-03_JPRB, 0.38144108E-03_JPRB, 0.38115827E-03_JPRB, 0.38082167E-03_JPRB, &
  & 0.38038611E-03_JPRB, 0.37990704E-03_JPRB, 0.37944575E-03_JPRB, 0.37909703E-03_JPRB, 0.37884103E-03_JPRB, 0.37860894E-03_JPRB, &
  & 0.37836796E-03_JPRB, 0.37809370E-03_JPRB, 0.37781781E-03_JPRB, 0.37759165E-03_JPRB, 0.37745931E-03_JPRB, 0.37738517E-03_JPRB, &
  & 0.37733132E-03_JPRB, 0.37728852E-03_JPRB, 0.37725054E-03_JPRB, 0.37721807E-03_JPRB, 0.37718213E-03_JPRB, 0.37715140E-03_JPRB, &
  & 0.37713862E-03_JPRB, 0.37712863E-03_JPRB, 0.37711357E-03_JPRB, 0.37709410E-03_JPRB  /)

RGHG1(:,29, 7) = (/ &
  & 0.37596814E-03_JPRB, 0.37587178E-03_JPRB, 0.37574478E-03_JPRB, 0.37557475E-03_JPRB, 0.37543749E-03_JPRB, 0.37530955E-03_JPRB, &
  & 0.37516064E-03_JPRB, 0.37506949E-03_JPRB, 0.37508479E-03_JPRB, 0.37522557E-03_JPRB, 0.37548675E-03_JPRB, 0.37587112E-03_JPRB, &
  & 0.37632428E-03_JPRB, 0.37678955E-03_JPRB, 0.37720133E-03_JPRB, 0.37749562E-03_JPRB, 0.37767884E-03_JPRB, 0.37790525E-03_JPRB, &
  & 0.37820274E-03_JPRB, 0.37850252E-03_JPRB, 0.37871436E-03_JPRB, 0.37883568E-03_JPRB, 0.37896880E-03_JPRB, 0.37925817E-03_JPRB, &
  & 0.37973426E-03_JPRB, 0.38022796E-03_JPRB, 0.38062395E-03_JPRB, 0.38099287E-03_JPRB, 0.38155092E-03_JPRB, 0.38235136E-03_JPRB, &
  & 0.38285481E-03_JPRB, 0.38292020E-03_JPRB, 0.38288570E-03_JPRB, 0.38285000E-03_JPRB, 0.38277968E-03_JPRB, 0.38267213E-03_JPRB, &
  & 0.38255446E-03_JPRB, 0.38239712E-03_JPRB, 0.38216550E-03_JPRB, 0.38190385E-03_JPRB, 0.38161461E-03_JPRB, 0.38126042E-03_JPRB, &
  & 0.38080389E-03_JPRB, 0.38033463E-03_JPRB, 0.37989935E-03_JPRB, 0.37957072E-03_JPRB, 0.37931961E-03_JPRB, 0.37908721E-03_JPRB, &
  & 0.37883627E-03_JPRB, 0.37853663E-03_JPRB, 0.37822107E-03_JPRB, 0.37794856E-03_JPRB, 0.37779124E-03_JPRB, 0.37771357E-03_JPRB, &
  & 0.37767449E-03_JPRB, 0.37766037E-03_JPRB, 0.37764320E-03_JPRB, 0.37762847E-03_JPRB, 0.37759936E-03_JPRB, 0.37757055E-03_JPRB, &
  & 0.37756717E-03_JPRB, 0.37756441E-03_JPRB, 0.37752598E-03_JPRB, 0.37746121E-03_JPRB  /)

RGHG1(:,30, 7) = (/ &
  & 0.37619553E-03_JPRB, 0.37611229E-03_JPRB, 0.37599657E-03_JPRB, 0.37581410E-03_JPRB, 0.37565002E-03_JPRB, 0.37551081E-03_JPRB, &
  & 0.37536662E-03_JPRB, 0.37525861E-03_JPRB, 0.37527548E-03_JPRB, 0.37543123E-03_JPRB, 0.37570676E-03_JPRB, 0.37609834E-03_JPRB, &
  & 0.37655053E-03_JPRB, 0.37701531E-03_JPRB, 0.37745682E-03_JPRB, 0.37779028E-03_JPRB, 0.37802170E-03_JPRB, 0.37827777E-03_JPRB, &
  & 0.37859518E-03_JPRB, 0.37894375E-03_JPRB, 0.37921137E-03_JPRB, 0.37937003E-03_JPRB, 0.37954281E-03_JPRB, 0.37983066E-03_JPRB, &
  & 0.38027937E-03_JPRB, 0.38077617E-03_JPRB, 0.38121002E-03_JPRB, 0.38158648E-03_JPRB, 0.38209386E-03_JPRB, 0.38280106E-03_JPRB, &
  & 0.38328987E-03_JPRB, 0.38339854E-03_JPRB, 0.38338855E-03_JPRB, 0.38335145E-03_JPRB, 0.38328275E-03_JPRB, 0.38319051E-03_JPRB, &
  & 0.38309148E-03_JPRB, 0.38294014E-03_JPRB, 0.38269283E-03_JPRB, 0.38239539E-03_JPRB, 0.38207482E-03_JPRB, 0.38171497E-03_JPRB, &
  & 0.38128912E-03_JPRB, 0.38085196E-03_JPRB, 0.38044811E-03_JPRB, 0.38012922E-03_JPRB, 0.37986952E-03_JPRB, 0.37961792E-03_JPRB, &
  & 0.37936006E-03_JPRB, 0.37903605E-03_JPRB, 0.37867022E-03_JPRB, 0.37834264E-03_JPRB, 0.37813352E-03_JPRB, 0.37801626E-03_JPRB, &
  & 0.37794276E-03_JPRB, 0.37791604E-03_JPRB, 0.37790813E-03_JPRB, 0.37792185E-03_JPRB, 0.37792047E-03_JPRB, 0.37793033E-03_JPRB, &
  & 0.37796725E-03_JPRB, 0.37798664E-03_JPRB, 0.37794085E-03_JPRB, 0.37785178E-03_JPRB  /)

RGHG1(:,31, 7) = (/ &
  & 0.37643519E-03_JPRB, 0.37636579E-03_JPRB, 0.37626198E-03_JPRB, 0.37606641E-03_JPRB, 0.37587406E-03_JPRB, 0.37572294E-03_JPRB, &
  & 0.37558374E-03_JPRB, 0.37545794E-03_JPRB, 0.37547645E-03_JPRB, 0.37564797E-03_JPRB, 0.37593861E-03_JPRB, 0.37633778E-03_JPRB, &
  & 0.37678893E-03_JPRB, 0.37725319E-03_JPRB, 0.37772602E-03_JPRB, 0.37810078E-03_JPRB, 0.37838302E-03_JPRB, 0.37867033E-03_JPRB, &
  & 0.37900873E-03_JPRB, 0.37940872E-03_JPRB, 0.37973511E-03_JPRB, 0.37993313E-03_JPRB, 0.38014773E-03_JPRB, 0.38043394E-03_JPRB, &
  & 0.38085371E-03_JPRB, 0.38135371E-03_JPRB, 0.38182744E-03_JPRB, 0.38221186E-03_JPRB, 0.38266589E-03_JPRB, 0.38327487E-03_JPRB, &
  & 0.38374829E-03_JPRB, 0.38390257E-03_JPRB, 0.38391840E-03_JPRB, 0.38387980E-03_JPRB, 0.38381282E-03_JPRB, 0.38373673E-03_JPRB, &
  & 0.38365734E-03_JPRB, 0.38351232E-03_JPRB, 0.38324849E-03_JPRB, 0.38291333E-03_JPRB, 0.38255972E-03_JPRB, 0.38219392E-03_JPRB, &
  & 0.38180043E-03_JPRB, 0.38139713E-03_JPRB, 0.38102639E-03_JPRB, 0.38071778E-03_JPRB, 0.38044899E-03_JPRB, 0.38017715E-03_JPRB, &
  & 0.37991200E-03_JPRB, 0.37956233E-03_JPRB, 0.37914352E-03_JPRB, 0.37875790E-03_JPRB, 0.37849416E-03_JPRB, 0.37833517E-03_JPRB, &
  & 0.37822536E-03_JPRB, 0.37818532E-03_JPRB, 0.37818715E-03_JPRB, 0.37823086E-03_JPRB, 0.37825872E-03_JPRB, 0.37830936E-03_JPRB, &
  & 0.37838876E-03_JPRB, 0.37843152E-03_JPRB, 0.37837799E-03_JPRB, 0.37826332E-03_JPRB  /)

RGHG1(:,32, 7) = (/ &
  & 0.37702884E-03_JPRB, 0.37697912E-03_JPRB, 0.37685332E-03_JPRB, 0.37661995E-03_JPRB, 0.37636738E-03_JPRB, 0.37616170E-03_JPRB, &
  & 0.37599274E-03_JPRB, 0.37583832E-03_JPRB, 0.37582676E-03_JPRB, 0.37600273E-03_JPRB, 0.37629492E-03_JPRB, 0.37668056E-03_JPRB, &
  & 0.37711523E-03_JPRB, 0.37757842E-03_JPRB, 0.37807317E-03_JPRB, 0.37851533E-03_JPRB, 0.37887028E-03_JPRB, 0.37919970E-03_JPRB, &
  & 0.37958372E-03_JPRB, 0.38003552E-03_JPRB, 0.38043084E-03_JPRB, 0.38070144E-03_JPRB, 0.38095769E-03_JPRB, 0.38124223E-03_JPRB, &
  & 0.38160332E-03_JPRB, 0.38200341E-03_JPRB, 0.38241418E-03_JPRB, 0.38278714E-03_JPRB, 0.38321945E-03_JPRB, 0.38375610E-03_JPRB, &
  & 0.38420085E-03_JPRB, 0.38439822E-03_JPRB, 0.38445297E-03_JPRB, 0.38444026E-03_JPRB, 0.38438479E-03_JPRB, 0.38430713E-03_JPRB, &
  & 0.38422872E-03_JPRB, 0.38409057E-03_JPRB, 0.38383845E-03_JPRB, 0.38351252E-03_JPRB, 0.38318065E-03_JPRB, 0.38287229E-03_JPRB, &
  & 0.38255097E-03_JPRB, 0.38218442E-03_JPRB, 0.38180417E-03_JPRB, 0.38148717E-03_JPRB, 0.38120414E-03_JPRB, 0.38089005E-03_JPRB, &
  & 0.38058456E-03_JPRB, 0.38018898E-03_JPRB, 0.37972507E-03_JPRB, 0.37929846E-03_JPRB, 0.37898830E-03_JPRB, 0.37878114E-03_JPRB, &
  & 0.37862568E-03_JPRB, 0.37852607E-03_JPRB, 0.37845854E-03_JPRB, 0.37847197E-03_JPRB, 0.37851086E-03_JPRB, 0.37858536E-03_JPRB, &
  & 0.37869498E-03_JPRB, 0.37876830E-03_JPRB, 0.37872002E-03_JPRB, 0.37859114E-03_JPRB  /)

RGHG1(:,33, 7) = (/ &
  & 0.37769161E-03_JPRB, 0.37766310E-03_JPRB, 0.37751008E-03_JPRB, 0.37723421E-03_JPRB, 0.37691493E-03_JPRB, 0.37664702E-03_JPRB, &
  & 0.37644264E-03_JPRB, 0.37625707E-03_JPRB, 0.37621016E-03_JPRB, 0.37638928E-03_JPRB, 0.37668133E-03_JPRB, 0.37705016E-03_JPRB, &
  & 0.37746573E-03_JPRB, 0.37792772E-03_JPRB, 0.37844404E-03_JPRB, 0.37895963E-03_JPRB, 0.37939298E-03_JPRB, 0.37976755E-03_JPRB, &
  & 0.38020218E-03_JPRB, 0.38070788E-03_JPRB, 0.38117615E-03_JPRB, 0.38152648E-03_JPRB, 0.38182599E-03_JPRB, 0.38210877E-03_JPRB, &
  & 0.38240504E-03_JPRB, 0.38268796E-03_JPRB, 0.38301997E-03_JPRB, 0.38337851E-03_JPRB, 0.38379234E-03_JPRB, 0.38425717E-03_JPRB, &
  & 0.38467042E-03_JPRB, 0.38491224E-03_JPRB, 0.38500913E-03_JPRB, 0.38502687E-03_JPRB, 0.38498463E-03_JPRB, 0.38490305E-03_JPRB, &
  & 0.38482324E-03_JPRB, 0.38469230E-03_JPRB, 0.38445600E-03_JPRB, 0.38414576E-03_JPRB, 0.38384356E-03_JPRB, 0.38360310E-03_JPRB, &
  & 0.38336193E-03_JPRB, 0.38303395E-03_JPRB, 0.38263830E-03_JPRB, 0.38231017E-03_JPRB, 0.38201168E-03_JPRB, 0.38165083E-03_JPRB, &
  & 0.38129913E-03_JPRB, 0.38085322E-03_JPRB, 0.38034346E-03_JPRB, 0.37987646E-03_JPRB, 0.37951912E-03_JPRB, 0.37926107E-03_JPRB, &
  & 0.37905696E-03_JPRB, 0.37888944E-03_JPRB, 0.37873959E-03_JPRB, 0.37871376E-03_JPRB, 0.37876174E-03_JPRB, 0.37885885E-03_JPRB, &
  & 0.37899830E-03_JPRB, 0.37910431E-03_JPRB, 0.37906317E-03_JPRB, 0.37892098E-03_JPRB  /)

RGHG1(:,34, 7) = (/ &
  & 0.37844001E-03_JPRB, 0.37845135E-03_JPRB, 0.37828020E-03_JPRB, 0.37797758E-03_JPRB, 0.37759934E-03_JPRB, 0.37726945E-03_JPRB, &
  & 0.37701198E-03_JPRB, 0.37679880E-03_JPRB, 0.37671239E-03_JPRB, 0.37687195E-03_JPRB, 0.37715097E-03_JPRB, 0.37748509E-03_JPRB, &
  & 0.37788001E-03_JPRB, 0.37833183E-03_JPRB, 0.37886013E-03_JPRB, 0.37943864E-03_JPRB, 0.37991761E-03_JPRB, 0.38033439E-03_JPRB, &
  & 0.38082069E-03_JPRB, 0.38137472E-03_JPRB, 0.38189399E-03_JPRB, 0.38229143E-03_JPRB, 0.38261264E-03_JPRB, 0.38287642E-03_JPRB, &
  & 0.38311415E-03_JPRB, 0.38331700E-03_JPRB, 0.38355616E-03_JPRB, 0.38384694E-03_JPRB, 0.38419965E-03_JPRB, 0.38460997E-03_JPRB, &
  & 0.38502231E-03_JPRB, 0.38532048E-03_JPRB, 0.38548282E-03_JPRB, 0.38553426E-03_JPRB, 0.38550341E-03_JPRB, 0.38541488E-03_JPRB, &
  & 0.38532247E-03_JPRB, 0.38519827E-03_JPRB, 0.38499780E-03_JPRB, 0.38474558E-03_JPRB, 0.38451889E-03_JPRB, 0.38433707E-03_JPRB, &
  & 0.38414083E-03_JPRB, 0.38383004E-03_JPRB, 0.38343857E-03_JPRB, 0.38309835E-03_JPRB, 0.38277890E-03_JPRB, 0.38238688E-03_JPRB, &
  & 0.38197636E-03_JPRB, 0.38147196E-03_JPRB, 0.38093193E-03_JPRB, 0.38046561E-03_JPRB, 0.38010099E-03_JPRB, 0.37980631E-03_JPRB, &
  & 0.37955537E-03_JPRB, 0.37931201E-03_JPRB, 0.37906678E-03_JPRB, 0.37897143E-03_JPRB, 0.37898397E-03_JPRB, 0.37905767E-03_JPRB, &
  & 0.37919318E-03_JPRB, 0.37932546E-03_JPRB, 0.37929415E-03_JPRB, 0.37915045E-03_JPRB  /)

RGHG1(:,35, 7) = (/ &
  & 0.37925340E-03_JPRB, 0.37931527E-03_JPRB, 0.37913016E-03_JPRB, 0.37880812E-03_JPRB, 0.37837324E-03_JPRB, 0.37797975E-03_JPRB, &
  & 0.37765863E-03_JPRB, 0.37741888E-03_JPRB, 0.37728973E-03_JPRB, 0.37741752E-03_JPRB, 0.37767654E-03_JPRB, 0.37796577E-03_JPRB, &
  & 0.37833867E-03_JPRB, 0.37877542E-03_JPRB, 0.37931112E-03_JPRB, 0.37994895E-03_JPRB, 0.38045799E-03_JPRB, 0.38091666E-03_JPRB, &
  & 0.38145662E-03_JPRB, 0.38205748E-03_JPRB, 0.38261793E-03_JPRB, 0.38304708E-03_JPRB, 0.38337952E-03_JPRB, 0.38361491E-03_JPRB, &
  & 0.38379568E-03_JPRB, 0.38393526E-03_JPRB, 0.38407172E-03_JPRB, 0.38426546E-03_JPRB, 0.38453347E-03_JPRB, 0.38489663E-03_JPRB, &
  & 0.38532371E-03_JPRB, 0.38568593E-03_JPRB, 0.38592751E-03_JPRB, 0.38601526E-03_JPRB, 0.38599520E-03_JPRB, 0.38589797E-03_JPRB, &
  & 0.38578684E-03_JPRB, 0.38566934E-03_JPRB, 0.38551596E-03_JPRB, 0.38534513E-03_JPRB, 0.38521958E-03_JPRB, 0.38509330E-03_JPRB, &
  & 0.38492519E-03_JPRB, 0.38462108E-03_JPRB, 0.38424397E-03_JPRB, 0.38389082E-03_JPRB, 0.38354701E-03_JPRB, 0.38313097E-03_JPRB, &
  & 0.38265347E-03_JPRB, 0.38208477E-03_JPRB, 0.38152161E-03_JPRB, 0.38107705E-03_JPRB, 0.38072542E-03_JPRB, 0.38040041E-03_JPRB, &
  & 0.38010224E-03_JPRB, 0.37977684E-03_JPRB, 0.37942683E-03_JPRB, 0.37924451E-03_JPRB, 0.37919774E-03_JPRB, 0.37922377E-03_JPRB, &
  & 0.37933790E-03_JPRB, 0.37949389E-03_JPRB, 0.37947409E-03_JPRB, 0.37933486E-03_JPRB  /)

RGHG1(:,36, 7) = (/ &
  & 0.38020495E-03_JPRB, 0.38031623E-03_JPRB, 0.38009556E-03_JPRB, 0.37972075E-03_JPRB, 0.37920897E-03_JPRB, 0.37873872E-03_JPRB, &
  & 0.37834041E-03_JPRB, 0.37807154E-03_JPRB, 0.37790779E-03_JPRB, 0.37799262E-03_JPRB, 0.37822311E-03_JPRB, 0.37846388E-03_JPRB, &
  & 0.37881158E-03_JPRB, 0.37922799E-03_JPRB, 0.37977535E-03_JPRB, 0.38045734E-03_JPRB, 0.38099150E-03_JPRB, 0.38149060E-03_JPRB, &
  & 0.38207175E-03_JPRB, 0.38270209E-03_JPRB, 0.38328161E-03_JPRB, 0.38372557E-03_JPRB, 0.38405034E-03_JPRB, 0.38424747E-03_JPRB, &
  & 0.38436616E-03_JPRB, 0.38445004E-03_JPRB, 0.38450979E-03_JPRB, 0.38462363E-03_JPRB, 0.38481858E-03_JPRB, 0.38513012E-03_JPRB, &
  & 0.38556225E-03_JPRB, 0.38598412E-03_JPRB, 0.38629544E-03_JPRB, 0.38641192E-03_JPRB, 0.38640751E-03_JPRB, 0.38631919E-03_JPRB, &
  & 0.38620460E-03_JPRB, 0.38609365E-03_JPRB, 0.38597714E-03_JPRB, 0.38587999E-03_JPRB, 0.38584043E-03_JPRB, 0.38576431E-03_JPRB, &
  & 0.38562589E-03_JPRB, 0.38534478E-03_JPRB, 0.38499412E-03_JPRB, 0.38463764E-03_JPRB, 0.38427482E-03_JPRB, 0.38384450E-03_JPRB, &
  & 0.38331439E-03_JPRB, 0.38269386E-03_JPRB, 0.38211098E-03_JPRB, 0.38168613E-03_JPRB, 0.38134411E-03_JPRB, 0.38099652E-03_JPRB, &
  & 0.38066117E-03_JPRB, 0.38027283E-03_JPRB, 0.37983454E-03_JPRB, 0.37957443E-03_JPRB, 0.37946603E-03_JPRB, 0.37943848E-03_JPRB, &
  & 0.37953381E-03_JPRB, 0.37971578E-03_JPRB, 0.37971421E-03_JPRB, 0.37957912E-03_JPRB  /)

RGHG1(:,37, 7) = (/ &
  & 0.38141407E-03_JPRB, 0.38156906E-03_JPRB, 0.38126559E-03_JPRB, 0.38076479E-03_JPRB, 0.38013446E-03_JPRB, 0.37956203E-03_JPRB, &
  & 0.37906034E-03_JPRB, 0.37875831E-03_JPRB, 0.37858077E-03_JPRB, 0.37859964E-03_JPRB, 0.37878383E-03_JPRB, 0.37897093E-03_JPRB, &
  & 0.37928776E-03_JPRB, 0.37967298E-03_JPRB, 0.38024103E-03_JPRB, 0.38092974E-03_JPRB, 0.38147607E-03_JPRB, 0.38200971E-03_JPRB, &
  & 0.38260094E-03_JPRB, 0.38321910E-03_JPRB, 0.38376582E-03_JPRB, 0.38418495E-03_JPRB, 0.38445917E-03_JPRB, 0.38459778E-03_JPRB, &
  & 0.38464655E-03_JPRB, 0.38469553E-03_JPRB, 0.38474293E-03_JPRB, 0.38482115E-03_JPRB, 0.38497431E-03_JPRB, 0.38522720E-03_JPRB, &
  & 0.38564182E-03_JPRB, 0.38610957E-03_JPRB, 0.38646448E-03_JPRB, 0.38659049E-03_JPRB, 0.38661192E-03_JPRB, 0.38657235E-03_JPRB, &
  & 0.38648949E-03_JPRB, 0.38638435E-03_JPRB, 0.38627900E-03_JPRB, 0.38623324E-03_JPRB, 0.38623961E-03_JPRB, 0.38619821E-03_JPRB, &
  & 0.38609122E-03_JPRB, 0.38586905E-03_JPRB, 0.38557092E-03_JPRB, 0.38523333E-03_JPRB, 0.38486493E-03_JPRB, 0.38444360E-03_JPRB, &
  & 0.38389706E-03_JPRB, 0.38325657E-03_JPRB, 0.38266295E-03_JPRB, 0.38225189E-03_JPRB, 0.38191113E-03_JPRB, 0.38156019E-03_JPRB, &
  & 0.38121296E-03_JPRB, 0.38080939E-03_JPRB, 0.38032613E-03_JPRB, 0.38001415E-03_JPRB, 0.37984260E-03_JPRB, 0.37975132E-03_JPRB, &
  & 0.37983490E-03_JPRB, 0.38004642E-03_JPRB, 0.38007742E-03_JPRB, 0.37994538E-03_JPRB  /)

RGHG1(:,38, 7) = (/ &
  & 0.38275570E-03_JPRB, 0.38295919E-03_JPRB, 0.38256384E-03_JPRB, 0.38192324E-03_JPRB, 0.38116137E-03_JPRB, 0.38047557E-03_JPRB, &
  & 0.37985917E-03_JPRB, 0.37952035E-03_JPRB, 0.37932750E-03_JPRB, 0.37927318E-03_JPRB, 0.37940601E-03_JPRB, 0.37953356E-03_JPRB, &
  & 0.37981612E-03_JPRB, 0.38016675E-03_JPRB, 0.38075775E-03_JPRB, 0.38145391E-03_JPRB, 0.38201375E-03_JPRB, 0.38258571E-03_JPRB, &
  & 0.38318811E-03_JPRB, 0.38379277E-03_JPRB, 0.38430310E-03_JPRB, 0.38469469E-03_JPRB, 0.38491281E-03_JPRB, 0.38498648E-03_JPRB, &
  & 0.38495767E-03_JPRB, 0.38496793E-03_JPRB, 0.38500162E-03_JPRB, 0.38504032E-03_JPRB, 0.38514710E-03_JPRB, 0.38533493E-03_JPRB, &
  & 0.38573011E-03_JPRB, 0.38624876E-03_JPRB, 0.38665204E-03_JPRB, 0.38678863E-03_JPRB, 0.38683875E-03_JPRB, 0.38685327E-03_JPRB, &
  & 0.38680561E-03_JPRB, 0.38670692E-03_JPRB, 0.38661394E-03_JPRB, 0.38662520E-03_JPRB, 0.38668254E-03_JPRB, 0.38667967E-03_JPRB, &
  & 0.38660753E-03_JPRB, 0.38645077E-03_JPRB, 0.38621093E-03_JPRB, 0.38589430E-03_JPRB, 0.38551971E-03_JPRB, 0.38510836E-03_JPRB, &
  & 0.38454359E-03_JPRB, 0.38388094E-03_JPRB, 0.38327541E-03_JPRB, 0.38287965E-03_JPRB, 0.38254029E-03_JPRB, 0.38218563E-03_JPRB, &
  & 0.38182522E-03_JPRB, 0.38140475E-03_JPRB, 0.38087159E-03_JPRB, 0.38050206E-03_JPRB, 0.38026045E-03_JPRB, 0.38009843E-03_JPRB, &
  & 0.38016897E-03_JPRB, 0.38041330E-03_JPRB, 0.38048042E-03_JPRB, 0.38035178E-03_JPRB  /)

RGHG1(:,39, 7) = (/ &
  & 0.38389291E-03_JPRB, 0.38413009E-03_JPRB, 0.38367745E-03_JPRB, 0.38292017E-03_JPRB, 0.38203730E-03_JPRB, 0.38123081E-03_JPRB, &
  & 0.38051099E-03_JPRB, 0.38012679E-03_JPRB, 0.37994423E-03_JPRB, 0.37984602E-03_JPRB, 0.37989504E-03_JPRB, 0.37997429E-03_JPRB, &
  & 0.38022083E-03_JPRB, 0.38055282E-03_JPRB, 0.38114855E-03_JPRB, 0.38182868E-03_JPRB, 0.38241294E-03_JPRB, 0.38300486E-03_JPRB, &
  & 0.38360299E-03_JPRB, 0.38415254E-03_JPRB, 0.38459457E-03_JPRB, 0.38494929E-03_JPRB, 0.38509925E-03_JPRB, 0.38509750E-03_JPRB, &
  & 0.38499995E-03_JPRB, 0.38498565E-03_JPRB, 0.38503366E-03_JPRB, 0.38507144E-03_JPRB, 0.38520045E-03_JPRB, 0.38540922E-03_JPRB, &
  & 0.38580045E-03_JPRB, 0.38630264E-03_JPRB, 0.38669921E-03_JPRB, 0.38683029E-03_JPRB, 0.38688176E-03_JPRB, 0.38691056E-03_JPRB, &
  & 0.38688831E-03_JPRB, 0.38681329E-03_JPRB, 0.38674226E-03_JPRB, 0.38676193E-03_JPRB, 0.38683273E-03_JPRB, 0.38684950E-03_JPRB, &
  & 0.38681049E-03_JPRB, 0.38671437E-03_JPRB, 0.38651760E-03_JPRB, 0.38623890E-03_JPRB, 0.38589480E-03_JPRB, 0.38550205E-03_JPRB, &
  & 0.38495108E-03_JPRB, 0.38430185E-03_JPRB, 0.38371295E-03_JPRB, 0.38333175E-03_JPRB, 0.38300098E-03_JPRB, 0.38263638E-03_JPRB, &
  & 0.38230863E-03_JPRB, 0.38190974E-03_JPRB, 0.38136817E-03_JPRB, 0.38095953E-03_JPRB, 0.38070524E-03_JPRB, 0.38053864E-03_JPRB, &
  & 0.38064333E-03_JPRB, 0.38089425E-03_JPRB, 0.38095048E-03_JPRB, 0.38080034E-03_JPRB  /)

RGHG1(:,40, 7) = (/ &
  & 0.38519407E-03_JPRB, 0.38546837E-03_JPRB, 0.38495417E-03_JPRB, 0.38406372E-03_JPRB, 0.38304058E-03_JPRB, 0.38209126E-03_JPRB, &
  & 0.38125189E-03_JPRB, 0.38081305E-03_JPRB, 0.38064674E-03_JPRB, 0.38050182E-03_JPRB, 0.38044717E-03_JPRB, 0.38047157E-03_JPRB, &
  & 0.38067556E-03_JPRB, 0.38098829E-03_JPRB, 0.38158658E-03_JPRB, 0.38224405E-03_JPRB, 0.38285878E-03_JPRB, 0.38347111E-03_JPRB, &
  & 0.38406169E-03_JPRB, 0.38453976E-03_JPRB, 0.38489643E-03_JPRB, 0.38520635E-03_JPRB, 0.38527434E-03_JPRB, 0.38518235E-03_JPRB, &
  & 0.38500558E-03_JPRB, 0.38496479E-03_JPRB, 0.38503417E-03_JPRB, 0.38507720E-03_JPRB, 0.38524352E-03_JPRB, 0.38549094E-03_JPRB, &
  & 0.38588006E-03_JPRB, 0.38635191E-03_JPRB, 0.38673159E-03_JPRB, 0.38685359E-03_JPRB, 0.38690218E-03_JPRB, 0.38694121E-03_JPRB, &
  & 0.38694718E-03_JPRB, 0.38690275E-03_JPRB, 0.38685905E-03_JPRB, 0.38688063E-03_JPRB, 0.38696110E-03_JPRB, 0.38699784E-03_JPRB, &
  & 0.38699741E-03_JPRB, 0.38697169E-03_JPRB, 0.38682297E-03_JPRB, 0.38659156E-03_JPRB, 0.38628925E-03_JPRB, 0.38591973E-03_JPRB, &
  & 0.38539020E-03_JPRB, 0.38476253E-03_JPRB, 0.38419782E-03_JPRB, 0.38383358E-03_JPRB, 0.38351407E-03_JPRB, 0.38313681E-03_JPRB, &
  & 0.38285487E-03_JPRB, 0.38248759E-03_JPRB, 0.38194295E-03_JPRB, 0.38149144E-03_JPRB, 0.38123164E-03_JPRB, 0.38107048E-03_JPRB, &
  & 0.38122297E-03_JPRB, 0.38147735E-03_JPRB, 0.38151311E-03_JPRB, 0.38133365E-03_JPRB  /)

RGHG1(:,41, 7) = (/ &
  & 0.38678493E-03_JPRB, 0.38710461E-03_JPRB, 0.38651514E-03_JPRB, 0.38546187E-03_JPRB, 0.38426723E-03_JPRB, 0.38314328E-03_JPRB, &
  & 0.38215776E-03_JPRB, 0.38165210E-03_JPRB, 0.38150566E-03_JPRB, 0.38130362E-03_JPRB, 0.38112222E-03_JPRB, 0.38107958E-03_JPRB, &
  & 0.38123154E-03_JPRB, 0.38152071E-03_JPRB, 0.38212213E-03_JPRB, 0.38275191E-03_JPRB, 0.38340388E-03_JPRB, 0.38404117E-03_JPRB, &
  & 0.38462251E-03_JPRB, 0.38501319E-03_JPRB, 0.38526549E-03_JPRB, 0.38552064E-03_JPRB, 0.38548840E-03_JPRB, 0.38528610E-03_JPRB, &
  & 0.38501247E-03_JPRB, 0.38493929E-03_JPRB, 0.38503479E-03_JPRB, 0.38508424E-03_JPRB, 0.38529618E-03_JPRB, 0.38559085E-03_JPRB, &
  & 0.38597739E-03_JPRB, 0.38641216E-03_JPRB, 0.38677118E-03_JPRB, 0.38688207E-03_JPRB, 0.38692713E-03_JPRB, 0.38697869E-03_JPRB, &
  & 0.38701916E-03_JPRB, 0.38701213E-03_JPRB, 0.38700184E-03_JPRB, 0.38702577E-03_JPRB, 0.38711805E-03_JPRB, 0.38717920E-03_JPRB, &
  & 0.38722595E-03_JPRB, 0.38728629E-03_JPRB, 0.38719633E-03_JPRB, 0.38702275E-03_JPRB, 0.38677153E-03_JPRB, 0.38643041E-03_JPRB, &
  & 0.38592708E-03_JPRB, 0.38532579E-03_JPRB, 0.38479065E-03_JPRB, 0.38444714E-03_JPRB, 0.38414141E-03_JPRB, 0.38374864E-03_JPRB, &
  & 0.38352273E-03_JPRB, 0.38319410E-03_JPRB, 0.38264570E-03_JPRB, 0.38214177E-03_JPRB, 0.38187525E-03_JPRB, 0.38172074E-03_JPRB, &
  & 0.38193167E-03_JPRB, 0.38219028E-03_JPRB, 0.38220100E-03_JPRB, 0.38198571E-03_JPRB  /)

RGHG1(:,42, 7) = (/ &
  & 0.38726737E-03_JPRB, 0.38745543E-03_JPRB, 0.38686415E-03_JPRB, 0.38584644E-03_JPRB, 0.38463395E-03_JPRB, 0.38346848E-03_JPRB, &
  & 0.38251237E-03_JPRB, 0.38196072E-03_JPRB, 0.38180297E-03_JPRB, 0.38161720E-03_JPRB, 0.38137138E-03_JPRB, 0.38127932E-03_JPRB, &
  & 0.38139761E-03_JPRB, 0.38168232E-03_JPRB, 0.38221865E-03_JPRB, 0.38282715E-03_JPRB, 0.38347814E-03_JPRB, 0.38410705E-03_JPRB, &
  & 0.38466906E-03_JPRB, 0.38505450E-03_JPRB, 0.38530220E-03_JPRB, 0.38547845E-03_JPRB, 0.38539509E-03_JPRB, 0.38517476E-03_JPRB, &
  & 0.38495415E-03_JPRB, 0.38491841E-03_JPRB, 0.38495761E-03_JPRB, 0.38500826E-03_JPRB, 0.38521747E-03_JPRB, 0.38554848E-03_JPRB, &
  & 0.38596965E-03_JPRB, 0.38640042E-03_JPRB, 0.38672384E-03_JPRB, 0.38683633E-03_JPRB, 0.38690556E-03_JPRB, 0.38696601E-03_JPRB, &
  & 0.38698861E-03_JPRB, 0.38697604E-03_JPRB, 0.38699449E-03_JPRB, 0.38699025E-03_JPRB, 0.38706089E-03_JPRB, 0.38706054E-03_JPRB, &
  & 0.38706179E-03_JPRB, 0.38707994E-03_JPRB, 0.38702099E-03_JPRB, 0.38686632E-03_JPRB, 0.38666427E-03_JPRB, 0.38634394E-03_JPRB, &
  & 0.38587148E-03_JPRB, 0.38529353E-03_JPRB, 0.38478650E-03_JPRB, 0.38449327E-03_JPRB, 0.38424558E-03_JPRB, 0.38389734E-03_JPRB, &
  & 0.38367369E-03_JPRB, 0.38333006E-03_JPRB, 0.38283232E-03_JPRB, 0.38239354E-03_JPRB, 0.38216309E-03_JPRB, 0.38201230E-03_JPRB, &
  & 0.38226470E-03_JPRB, 0.38249408E-03_JPRB, 0.38243497E-03_JPRB, 0.38216307E-03_JPRB  /)

RGHG1(:,43, 7) = (/ &
  & 0.38839185E-03_JPRB, 0.38847935E-03_JPRB, 0.38785403E-03_JPRB, 0.38679874E-03_JPRB, 0.38549618E-03_JPRB, 0.38421773E-03_JPRB, &
  & 0.38322557E-03_JPRB, 0.38260323E-03_JPRB, 0.38244370E-03_JPRB, 0.38224821E-03_JPRB, 0.38188909E-03_JPRB, 0.38172309E-03_JPRB, &
  & 0.38178828E-03_JPRB, 0.38205880E-03_JPRB, 0.38253709E-03_JPRB, 0.38311425E-03_JPRB, 0.38378037E-03_JPRB, 0.38441237E-03_JPRB, &
  & 0.38495276E-03_JPRB, 0.38529583E-03_JPRB, 0.38549445E-03_JPRB, 0.38557516E-03_JPRB, 0.38540204E-03_JPRB, 0.38511780E-03_JPRB, &
  & 0.38490391E-03_JPRB, 0.38488838E-03_JPRB, 0.38488745E-03_JPRB, 0.38494196E-03_JPRB, 0.38516831E-03_JPRB, 0.38555280E-03_JPRB, &
  & 0.38600446E-03_JPRB, 0.38641562E-03_JPRB, 0.38669767E-03_JPRB, 0.38680685E-03_JPRB, 0.38689660E-03_JPRB, 0.38697057E-03_JPRB, &
  & 0.38699170E-03_JPRB, 0.38699017E-03_JPRB, 0.38704921E-03_JPRB, 0.38702027E-03_JPRB, 0.38707625E-03_JPRB, 0.38703028E-03_JPRB, &
  & 0.38701031E-03_JPRB, 0.38702700E-03_JPRB, 0.38702161E-03_JPRB, 0.38690908E-03_JPRB, 0.38677387E-03_JPRB, 0.38648471E-03_JPRB, &
  & 0.38605169E-03_JPRB, 0.38550639E-03_JPRB, 0.38503771E-03_JPRB, 0.38479928E-03_JPRB, 0.38461048E-03_JPRB, 0.38429620E-03_JPRB, &
  & 0.38409871E-03_JPRB, 0.38375801E-03_JPRB, 0.38330488E-03_JPRB, 0.38290299E-03_JPRB, 0.38270256E-03_JPRB, 0.38255802E-03_JPRB, &
  & 0.38287341E-03_JPRB, 0.38307793E-03_JPRB, 0.38294435E-03_JPRB, 0.38260537E-03_JPRB  /)

RGHG1(:,44, 7) = (/ &
  & 0.38862993E-03_JPRB, 0.38858406E-03_JPRB, 0.38789903E-03_JPRB, 0.38688082E-03_JPRB, 0.38559443E-03_JPRB, 0.38435006E-03_JPRB, &
  & 0.38343516E-03_JPRB, 0.38282160E-03_JPRB, 0.38264212E-03_JPRB, 0.38245575E-03_JPRB, 0.38208999E-03_JPRB, 0.38189417E-03_JPRB, &
  & 0.38191965E-03_JPRB, 0.38217512E-03_JPRB, 0.38259170E-03_JPRB, 0.38311823E-03_JPRB, 0.38375946E-03_JPRB, 0.38438354E-03_JPRB, &
  & 0.38491922E-03_JPRB, 0.38529285E-03_JPRB, 0.38549280E-03_JPRB, 0.38550526E-03_JPRB, 0.38528173E-03_JPRB, 0.38497919E-03_JPRB, &
  & 0.38479115E-03_JPRB, 0.38479013E-03_JPRB, 0.38479605E-03_JPRB, 0.38485106E-03_JPRB, 0.38510655E-03_JPRB, 0.38553943E-03_JPRB, &
  & 0.38597839E-03_JPRB, 0.38637292E-03_JPRB, 0.38664586E-03_JPRB, 0.38674762E-03_JPRB, 0.38688357E-03_JPRB, 0.38700324E-03_JPRB, &
  & 0.38704295E-03_JPRB, 0.38703228E-03_JPRB, 0.38707625E-03_JPRB, 0.38701694E-03_JPRB, 0.38703392E-03_JPRB, 0.38696656E-03_JPRB, &
  & 0.38689875E-03_JPRB, 0.38689925E-03_JPRB, 0.38689409E-03_JPRB, 0.38679072E-03_JPRB, 0.38666464E-03_JPRB, 0.38639483E-03_JPRB, &
  & 0.38598303E-03_JPRB, 0.38544754E-03_JPRB, 0.38496729E-03_JPRB, 0.38473926E-03_JPRB, 0.38456567E-03_JPRB, 0.38429768E-03_JPRB, &
  & 0.38410108E-03_JPRB, 0.38377209E-03_JPRB, 0.38336739E-03_JPRB, 0.38301938E-03_JPRB, 0.38282307E-03_JPRB, 0.38265044E-03_JPRB, &
  & 0.38293903E-03_JPRB, 0.38320621E-03_JPRB, 0.38306839E-03_JPRB, 0.38273653E-03_JPRB  /)

RGHG1(:,45, 7) = (/ &
  & 0.38904302E-03_JPRB, 0.38883261E-03_JPRB, 0.38807530E-03_JPRB, 0.38709455E-03_JPRB, 0.38581520E-03_JPRB, 0.38459535E-03_JPRB, &
  & 0.38376386E-03_JPRB, 0.38315135E-03_JPRB, 0.38294895E-03_JPRB, 0.38277174E-03_JPRB, 0.38238411E-03_JPRB, 0.38214499E-03_JPRB, &
  & 0.38211855E-03_JPRB, 0.38235509E-03_JPRB, 0.38269411E-03_JPRB, 0.38315902E-03_JPRB, 0.38377384E-03_JPRB, 0.38438929E-03_JPRB, &
  & 0.38491688E-03_JPRB, 0.38531995E-03_JPRB, 0.38551520E-03_JPRB, 0.38543790E-03_JPRB, 0.38514565E-03_JPRB, 0.38481420E-03_JPRB, &
  & 0.38465643E-03_JPRB, 0.38467449E-03_JPRB, 0.38468313E-03_JPRB, 0.38473920E-03_JPRB, 0.38503003E-03_JPRB, 0.38552474E-03_JPRB, &
  & 0.38595311E-03_JPRB, 0.38632622E-03_JPRB, 0.38658357E-03_JPRB, 0.38667648E-03_JPRB, 0.38686760E-03_JPRB, 0.38704100E-03_JPRB, &
  & 0.38710168E-03_JPRB, 0.38708200E-03_JPRB, 0.38711394E-03_JPRB, 0.38701694E-03_JPRB, 0.38698768E-03_JPRB, 0.38689019E-03_JPRB, &
  & 0.38676524E-03_JPRB, 0.38674712E-03_JPRB, 0.38674900E-03_JPRB, 0.38666138E-03_JPRB, 0.38655414E-03_JPRB, 0.38631029E-03_JPRB, &
  & 0.38592763E-03_JPRB, 0.38540742E-03_JPRB, 0.38491885E-03_JPRB, 0.38470959E-03_JPRB, 0.38456075E-03_JPRB, 0.38434975E-03_JPRB, &
  & 0.38415747E-03_JPRB, 0.38384217E-03_JPRB, 0.38349825E-03_JPRB, 0.38321624E-03_JPRB, 0.38302840E-03_JPRB, 0.38282459E-03_JPRB, &
  & 0.38309062E-03_JPRB, 0.38342600E-03_JPRB, 0.38327395E-03_JPRB, 0.38294171E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART14',0,ZHOOK_HANDLE)



RGHG1(:,46, 7) = (/ &
  & 0.38893539E-03_JPRB, 0.38860427E-03_JPRB, 0.38771214E-03_JPRB, 0.38684865E-03_JPRB, 0.38564893E-03_JPRB, 0.38449651E-03_JPRB, &
  & 0.38376219E-03_JPRB, 0.38318259E-03_JPRB, 0.38296403E-03_JPRB, 0.38281798E-03_JPRB, 0.38247858E-03_JPRB, 0.38222581E-03_JPRB, &
  & 0.38218423E-03_JPRB, 0.38238393E-03_JPRB, 0.38265419E-03_JPRB, 0.38305361E-03_JPRB, 0.38362249E-03_JPRB, 0.38421608E-03_JPRB, &
  & 0.38474204E-03_JPRB, 0.38517620E-03_JPRB, 0.38538557E-03_JPRB, 0.38528789E-03_JPRB, 0.38495933E-03_JPRB, 0.38463371E-03_JPRB, &
  & 0.38451488E-03_JPRB, 0.38454925E-03_JPRB, 0.38457049E-03_JPRB, 0.38464727E-03_JPRB, 0.38495585E-03_JPRB, 0.38545831E-03_JPRB, &
  & 0.38587541E-03_JPRB, 0.38624241E-03_JPRB, 0.38649501E-03_JPRB, 0.38662335E-03_JPRB, 0.38684732E-03_JPRB, 0.38705833E-03_JPRB, &
  & 0.38714493E-03_JPRB, 0.38712140E-03_JPRB, 0.38712037E-03_JPRB, 0.38699706E-03_JPRB, 0.38694028E-03_JPRB, 0.38682355E-03_JPRB, &
  & 0.38665496E-03_JPRB, 0.38661877E-03_JPRB, 0.38660080E-03_JPRB, 0.38651133E-03_JPRB, 0.38639154E-03_JPRB, 0.38614402E-03_JPRB, &
  & 0.38574329E-03_JPRB, 0.38522366E-03_JPRB, 0.38471619E-03_JPRB, 0.38449078E-03_JPRB, 0.38434726E-03_JPRB, 0.38416103E-03_JPRB, &
  & 0.38399528E-03_JPRB, 0.38371921E-03_JPRB, 0.38343150E-03_JPRB, 0.38321125E-03_JPRB, 0.38306364E-03_JPRB, 0.38287777E-03_JPRB, &
  & 0.38310930E-03_JPRB, 0.38343899E-03_JPRB, 0.38330166E-03_JPRB, 0.38307647E-03_JPRB  /)

RGHG1(:,47, 7) = (/ &
  & 0.38870479E-03_JPRB, 0.38824080E-03_JPRB, 0.38717794E-03_JPRB, 0.38646803E-03_JPRB, 0.38537629E-03_JPRB, 0.38431159E-03_JPRB, &
  & 0.38369405E-03_JPRB, 0.38315945E-03_JPRB, 0.38292328E-03_JPRB, 0.38281821E-03_JPRB, 0.38254946E-03_JPRB, 0.38228659E-03_JPRB, &
  & 0.38223461E-03_JPRB, 0.38238750E-03_JPRB, 0.38257884E-03_JPRB, 0.38290064E-03_JPRB, 0.38341170E-03_JPRB, 0.38397698E-03_JPRB, &
  & 0.38450234E-03_JPRB, 0.38497329E-03_JPRB, 0.38520300E-03_JPRB, 0.38509530E-03_JPRB, 0.38473062E-03_JPRB, 0.38441882E-03_JPRB, &
  & 0.38434741E-03_JPRB, 0.38440037E-03_JPRB, 0.38443839E-03_JPRB, 0.38454339E-03_JPRB, 0.38486927E-03_JPRB, 0.38536998E-03_JPRB, &
  & 0.38577373E-03_JPRB, 0.38613663E-03_JPRB, 0.38638581E-03_JPRB, 0.38656462E-03_JPRB, 0.38682266E-03_JPRB, 0.38707457E-03_JPRB, &
  & 0.38719258E-03_JPRB, 0.38716556E-03_JPRB, 0.38712166E-03_JPRB, 0.38696974E-03_JPRB, 0.38688444E-03_JPRB, 0.38674729E-03_JPRB, &
  & 0.38653022E-03_JPRB, 0.38647293E-03_JPRB, 0.38642628E-03_JPRB, 0.38633111E-03_JPRB, 0.38619031E-03_JPRB, 0.38593254E-03_JPRB, &
  & 0.38550116E-03_JPRB, 0.38497925E-03_JPRB, 0.38444750E-03_JPRB, 0.38419614E-03_JPRB, 0.38405497E-03_JPRB, 0.38389136E-03_JPRB, &
  & 0.38376119E-03_JPRB, 0.38353627E-03_JPRB, 0.38331358E-03_JPRB, 0.38316496E-03_JPRB, 0.38307093E-03_JPRB, 0.38291594E-03_JPRB, &
  & 0.38310460E-03_JPRB, 0.38341281E-03_JPRB, 0.38329855E-03_JPRB, 0.38322049E-03_JPRB  /)

RGHG1(:,48, 7) = (/ &
  & 0.38832014E-03_JPRB, 0.38767933E-03_JPRB, 0.38651836E-03_JPRB, 0.38598009E-03_JPRB, 0.38500368E-03_JPRB, 0.38402733E-03_JPRB, &
  & 0.38348511E-03_JPRB, 0.38296884E-03_JPRB, 0.38272102E-03_JPRB, 0.38267145E-03_JPRB, 0.38246304E-03_JPRB, 0.38223313E-03_JPRB, &
  & 0.38219628E-03_JPRB, 0.38232527E-03_JPRB, 0.38245979E-03_JPRB, 0.38272584E-03_JPRB, 0.38316927E-03_JPRB, 0.38369221E-03_JPRB, &
  & 0.38419630E-03_JPRB, 0.38467577E-03_JPRB, 0.38492760E-03_JPRB, 0.38485493E-03_JPRB, 0.38451828E-03_JPRB, 0.38425053E-03_JPRB, &
  & 0.38421790E-03_JPRB, 0.38428196E-03_JPRB, 0.38432525E-03_JPRB, 0.38443966E-03_JPRB, 0.38477876E-03_JPRB, 0.38526595E-03_JPRB, &
  & 0.38567374E-03_JPRB, 0.38602493E-03_JPRB, 0.38630074E-03_JPRB, 0.38652559E-03_JPRB, 0.38679349E-03_JPRB, 0.38706194E-03_JPRB, &
  & 0.38720885E-03_JPRB, 0.38719731E-03_JPRB, 0.38712528E-03_JPRB, 0.38694444E-03_JPRB, 0.38684739E-03_JPRB, 0.38668421E-03_JPRB, &
  & 0.38642820E-03_JPRB, 0.38634732E-03_JPRB, 0.38628125E-03_JPRB, 0.38616573E-03_JPRB, 0.38599777E-03_JPRB, 0.38570172E-03_JPRB, &
  & 0.38521346E-03_JPRB, 0.38467309E-03_JPRB, 0.38413118E-03_JPRB, 0.38384216E-03_JPRB, 0.38367126E-03_JPRB, 0.38352041E-03_JPRB, &
  & 0.38343082E-03_JPRB, 0.38324830E-03_JPRB, 0.38307315E-03_JPRB, 0.38295874E-03_JPRB, 0.38290488E-03_JPRB, 0.38282025E-03_JPRB, &
  & 0.38300227E-03_JPRB, 0.38327123E-03_JPRB, 0.38314264E-03_JPRB, 0.38310830E-03_JPRB  /)

RGHG1(:,49, 7) = (/ &
  & 0.38782414E-03_JPRB, 0.38696753E-03_JPRB, 0.38573094E-03_JPRB, 0.38539095E-03_JPRB, 0.38454561E-03_JPRB, 0.38366738E-03_JPRB, &
  & 0.38318972E-03_JPRB, 0.38268163E-03_JPRB, 0.38242361E-03_JPRB, 0.38244210E-03_JPRB, 0.38229584E-03_JPRB, 0.38212200E-03_JPRB, &
  & 0.38211350E-03_JPRB, 0.38222644E-03_JPRB, 0.38230808E-03_JPRB, 0.38252235E-03_JPRB, 0.38288642E-03_JPRB, 0.38335609E-03_JPRB, &
  & 0.38382724E-03_JPRB, 0.38430329E-03_JPRB, 0.38458043E-03_JPRB, 0.38456702E-03_JPRB, 0.38429056E-03_JPRB, 0.38408535E-03_JPRB, &
  & 0.38409174E-03_JPRB, 0.38416467E-03_JPRB, 0.38420859E-03_JPRB, 0.38432487E-03_JPRB, 0.38467674E-03_JPRB, 0.38514361E-03_JPRB, &
  & 0.38556377E-03_JPRB, 0.38589853E-03_JPRB, 0.38621749E-03_JPRB, 0.38649133E-03_JPRB, 0.38675915E-03_JPRB, 0.38703484E-03_JPRB, &
  & 0.38721258E-03_JPRB, 0.38722683E-03_JPRB, 0.38713034E-03_JPRB, 0.38691734E-03_JPRB, 0.38681492E-03_JPRB, 0.38662035E-03_JPRB, &
  & 0.38632555E-03_JPRB, 0.38621742E-03_JPRB, 0.38613407E-03_JPRB, 0.38598934E-03_JPRB, 0.38578852E-03_JPRB, 0.38543733E-03_JPRB, &
  & 0.38487415E-03_JPRB, 0.38430597E-03_JPRB, 0.38375924E-03_JPRB, 0.38342318E-03_JPRB, 0.38320477E-03_JPRB, 0.38306358E-03_JPRB, &
  & 0.38302118E-03_JPRB, 0.38288165E-03_JPRB, 0.38275121E-03_JPRB, 0.38265767E-03_JPRB, 0.38264220E-03_JPRB, 0.38265344E-03_JPRB, &
  & 0.38284457E-03_JPRB, 0.38306197E-03_JPRB, 0.38290052E-03_JPRB, 0.38286758E-03_JPRB  /)

RGHG1(:,50, 7) = (/ &
  & 0.38728262E-03_JPRB, 0.38631794E-03_JPRB, 0.38503764E-03_JPRB, 0.38481847E-03_JPRB, 0.38411165E-03_JPRB, 0.38333481E-03_JPRB, &
  & 0.38289178E-03_JPRB, 0.38240387E-03_JPRB, 0.38214408E-03_JPRB, 0.38219455E-03_JPRB, 0.38208896E-03_JPRB, 0.38195867E-03_JPRB, &
  & 0.38198226E-03_JPRB, 0.38211375E-03_JPRB, 0.38220892E-03_JPRB, 0.38239283E-03_JPRB, 0.38266824E-03_JPRB, 0.38306745E-03_JPRB, &
  & 0.38347888E-03_JPRB, 0.38393285E-03_JPRB, 0.38423467E-03_JPRB, 0.38428680E-03_JPRB, 0.38408956E-03_JPRB, 0.38396290E-03_JPRB, &
  & 0.38400341E-03_JPRB, 0.38407889E-03_JPRB, 0.38412109E-03_JPRB, 0.38424087E-03_JPRB, 0.38459868E-03_JPRB, 0.38505409E-03_JPRB, &
  & 0.38546783E-03_JPRB, 0.38581038E-03_JPRB, 0.38617386E-03_JPRB, 0.38647141E-03_JPRB, 0.38673127E-03_JPRB, 0.38700300E-03_JPRB, &
  & 0.38720743E-03_JPRB, 0.38724944E-03_JPRB, 0.38712451E-03_JPRB, 0.38690397E-03_JPRB, 0.38679104E-03_JPRB, 0.38655513E-03_JPRB, &
  & 0.38623950E-03_JPRB, 0.38610135E-03_JPRB, 0.38599310E-03_JPRB, 0.38582481E-03_JPRB, 0.38559451E-03_JPRB, 0.38518794E-03_JPRB, &
  & 0.38457798E-03_JPRB, 0.38398882E-03_JPRB, 0.38344096E-03_JPRB, 0.38307884E-03_JPRB, 0.38283189E-03_JPRB, 0.38270185E-03_JPRB, &
  & 0.38265368E-03_JPRB, 0.38250903E-03_JPRB, 0.38239705E-03_JPRB, 0.38233195E-03_JPRB, 0.38233279E-03_JPRB, 0.38240175E-03_JPRB, &
  & 0.38253334E-03_JPRB, 0.38272240E-03_JPRB, 0.38250864E-03_JPRB, 0.38241680E-03_JPRB  /)

RGHG1(:,51, 7) = (/ &
  & 0.38667298E-03_JPRB, 0.38564801E-03_JPRB, 0.38433721E-03_JPRB, 0.38420801E-03_JPRB, 0.38365495E-03_JPRB, 0.38298947E-03_JPRB, &
  & 0.38256816E-03_JPRB, 0.38210841E-03_JPRB, 0.38185113E-03_JPRB, 0.38191722E-03_JPRB, 0.38184434E-03_JPRB, 0.38175456E-03_JPRB, &
  & 0.38181484E-03_JPRB, 0.38198456E-03_JPRB, 0.38212928E-03_JPRB, 0.38229163E-03_JPRB, 0.38246624E-03_JPRB, 0.38278020E-03_JPRB, &
  & 0.38311296E-03_JPRB, 0.38353326E-03_JPRB, 0.38386143E-03_JPRB, 0.38398776E-03_JPRB, 0.38388618E-03_JPRB, 0.38385291E-03_JPRB, &
  & 0.38392775E-03_JPRB, 0.38400266E-03_JPRB, 0.38404177E-03_JPRB, 0.38416619E-03_JPRB, 0.38452685E-03_JPRB, 0.38497453E-03_JPRB, &
  & 0.38537143E-03_JPRB, 0.38573513E-03_JPRB, 0.38614750E-03_JPRB, 0.38645742E-03_JPRB, 0.38670450E-03_JPRB, 0.38696607E-03_JPRB, &
  & 0.38719718E-03_JPRB, 0.38727026E-03_JPRB, 0.38711247E-03_JPRB, 0.38689673E-03_JPRB, 0.38676972E-03_JPRB, 0.38648386E-03_JPRB, &
  & 0.38615514E-03_JPRB, 0.38598306E-03_JPRB, 0.38584391E-03_JPRB, 0.38565308E-03_JPRB, 0.38539268E-03_JPRB, 0.38492607E-03_JPRB, &
  & 0.38428032E-03_JPRB, 0.38367204E-03_JPRB, 0.38312492E-03_JPRB, 0.38274562E-03_JPRB, 0.38247777E-03_JPRB, 0.38236058E-03_JPRB, &
  & 0.38227833E-03_JPRB, 0.38210284E-03_JPRB, 0.38199705E-03_JPRB, 0.38196668E-03_JPRB, 0.38197354E-03_JPRB, 0.38208488E-03_JPRB, &
  & 0.38211601E-03_JPRB, 0.38228660E-03_JPRB, 0.38200606E-03_JPRB, 0.38181878E-03_JPRB  /)

RGHG1(:,52, 7) = (/ &
  & 0.38617662E-03_JPRB, 0.38518776E-03_JPRB, 0.38390458E-03_JPRB, 0.38376672E-03_JPRB, 0.38332439E-03_JPRB, 0.38277728E-03_JPRB, &
  & 0.38237516E-03_JPRB, 0.38194512E-03_JPRB, 0.38170196E-03_JPRB, 0.38176269E-03_JPRB, 0.38169934E-03_JPRB, 0.38161128E-03_JPRB, &
  & 0.38168970E-03_JPRB, 0.38188880E-03_JPRB, 0.38207557E-03_JPRB, 0.38223434E-03_JPRB, 0.38234606E-03_JPRB, 0.38257881E-03_JPRB, &
  & 0.38283686E-03_JPRB, 0.38320584E-03_JPRB, 0.38354142E-03_JPRB, 0.38372574E-03_JPRB, 0.38369917E-03_JPRB, 0.38371096E-03_JPRB, &
  & 0.38381987E-03_JPRB, 0.38391485E-03_JPRB, 0.38398542E-03_JPRB, 0.38411990E-03_JPRB, 0.38448282E-03_JPRB, 0.38492272E-03_JPRB, &
  & 0.38530759E-03_JPRB, 0.38569277E-03_JPRB, 0.38614324E-03_JPRB, 0.38644649E-03_JPRB, 0.38668417E-03_JPRB, 0.38694338E-03_JPRB, &
  & 0.38717749E-03_JPRB, 0.38727407E-03_JPRB, 0.38708870E-03_JPRB, 0.38686449E-03_JPRB, 0.38670102E-03_JPRB, 0.38640800E-03_JPRB, &
  & 0.38608564E-03_JPRB, 0.38587914E-03_JPRB, 0.38569615E-03_JPRB, 0.38548353E-03_JPRB, 0.38519751E-03_JPRB, 0.38468937E-03_JPRB, &
  & 0.38404691E-03_JPRB, 0.38343708E-03_JPRB, 0.38290045E-03_JPRB, 0.38254033E-03_JPRB, 0.38226970E-03_JPRB, 0.38215826E-03_JPRB, &
  & 0.38202633E-03_JPRB, 0.38183324E-03_JPRB, 0.38170751E-03_JPRB, 0.38168610E-03_JPRB, 0.38170209E-03_JPRB, 0.38179136E-03_JPRB, &
  & 0.38174658E-03_JPRB, 0.38188898E-03_JPRB, 0.38161378E-03_JPRB, 0.38137020E-03_JPRB  /)

RGHG1(:,53, 7) = (/ &
  & 0.38567968E-03_JPRB, 0.38476722E-03_JPRB, 0.38353649E-03_JPRB, 0.38335124E-03_JPRB, 0.38301296E-03_JPRB, 0.38259745E-03_JPRB, &
  & 0.38221524E-03_JPRB, 0.38181816E-03_JPRB, 0.38159483E-03_JPRB, 0.38164165E-03_JPRB, 0.38157976E-03_JPRB, 0.38147865E-03_JPRB, &
  & 0.38156969E-03_JPRB, 0.38179738E-03_JPRB, 0.38202707E-03_JPRB, 0.38218884E-03_JPRB, 0.38224665E-03_JPRB, 0.38239253E-03_JPRB, &
  & 0.38257075E-03_JPRB, 0.38287707E-03_JPRB, 0.38321342E-03_JPRB, 0.38345465E-03_JPRB, 0.38350182E-03_JPRB, 0.38354409E-03_JPRB, &
  & 0.38368999E-03_JPRB, 0.38381475E-03_JPRB, 0.38393288E-03_JPRB, 0.38408041E-03_JPRB, 0.38444556E-03_JPRB, 0.38487696E-03_JPRB, &
  & 0.38525059E-03_JPRB, 0.38565929E-03_JPRB, 0.38614711E-03_JPRB, 0.38643576E-03_JPRB, 0.38666452E-03_JPRB, 0.38692415E-03_JPRB, &
  & 0.38715243E-03_JPRB, 0.38727167E-03_JPRB, 0.38705831E-03_JPRB, 0.38681977E-03_JPRB, 0.38660796E-03_JPRB, 0.38632362E-03_JPRB, &
  & 0.38601568E-03_JPRB, 0.38577149E-03_JPRB, 0.38553579E-03_JPRB, 0.38529974E-03_JPRB, 0.38498754E-03_JPRB, 0.38444128E-03_JPRB, &
  & 0.38381745E-03_JPRB, 0.38321269E-03_JPRB, 0.38269126E-03_JPRB, 0.38236599E-03_JPRB, 0.38209930E-03_JPRB, 0.38199138E-03_JPRB, &
  & 0.38179936E-03_JPRB, 0.38159219E-03_JPRB, 0.38143470E-03_JPRB, 0.38141312E-03_JPRB, 0.38144028E-03_JPRB, 0.38148070E-03_JPRB, &
  & 0.38136269E-03_JPRB, 0.38147067E-03_JPRB, 0.38122903E-03_JPRB, 0.38093918E-03_JPRB  /)

RGHG1(:,54, 7) = (/ &
  & 0.38535986E-03_JPRB, 0.38455354E-03_JPRB, 0.38345854E-03_JPRB, 0.38323387E-03_JPRB, 0.38292199E-03_JPRB, 0.38258585E-03_JPRB, &
  & 0.38221730E-03_JPRB, 0.38185481E-03_JPRB, 0.38165629E-03_JPRB, 0.38167342E-03_JPRB, 0.38159205E-03_JPRB, 0.38147846E-03_JPRB, &
  & 0.38155299E-03_JPRB, 0.38177959E-03_JPRB, 0.38200502E-03_JPRB, 0.38215498E-03_JPRB, 0.38219568E-03_JPRB, 0.38228956E-03_JPRB, &
  & 0.38242374E-03_JPRB, 0.38265991E-03_JPRB, 0.38296393E-03_JPRB, 0.38323501E-03_JPRB, 0.38332014E-03_JPRB, 0.38338291E-03_JPRB, &
  & 0.38355560E-03_JPRB, 0.38370440E-03_JPRB, 0.38387498E-03_JPRB, 0.38406100E-03_JPRB, 0.38441978E-03_JPRB, 0.38483786E-03_JPRB, &
  & 0.38519817E-03_JPRB, 0.38561723E-03_JPRB, 0.38610981E-03_JPRB, 0.38639927E-03_JPRB, 0.38663899E-03_JPRB, 0.38692365E-03_JPRB, &
  & 0.38713161E-03_JPRB, 0.38724701E-03_JPRB, 0.38701819E-03_JPRB, 0.38673330E-03_JPRB, 0.38649314E-03_JPRB, 0.38623470E-03_JPRB, &
  & 0.38593969E-03_JPRB, 0.38568268E-03_JPRB, 0.38539802E-03_JPRB, 0.38512869E-03_JPRB, 0.38479004E-03_JPRB, 0.38422879E-03_JPRB, &
  & 0.38363274E-03_JPRB, 0.38305937E-03_JPRB, 0.38256726E-03_JPRB, 0.38226421E-03_JPRB, 0.38200566E-03_JPRB, 0.38190502E-03_JPRB, &
  & 0.38170692E-03_JPRB, 0.38150708E-03_JPRB, 0.38134849E-03_JPRB, 0.38131410E-03_JPRB, 0.38132378E-03_JPRB, 0.38130287E-03_JPRB, &
  & 0.38115923E-03_JPRB, 0.38128274E-03_JPRB, 0.38104613E-03_JPRB, 0.38084361E-03_JPRB  /)

RGHG1(:,55, 7) = (/ &
  & 0.38502887E-03_JPRB, 0.38434406E-03_JPRB, 0.38341036E-03_JPRB, 0.38314306E-03_JPRB, 0.38285022E-03_JPRB, 0.38259514E-03_JPRB, &
  & 0.38224089E-03_JPRB, 0.38191692E-03_JPRB, 0.38174655E-03_JPRB, 0.38172870E-03_JPRB, 0.38162302E-03_JPRB, 0.38149568E-03_JPRB, &
  & 0.38154807E-03_JPRB, 0.38176957E-03_JPRB, 0.38198407E-03_JPRB, 0.38211901E-03_JPRB, 0.38214559E-03_JPRB, 0.38218646E-03_JPRB, &
  & 0.38227656E-03_JPRB, 0.38243403E-03_JPRB, 0.38269788E-03_JPRB, 0.38299847E-03_JPRB, 0.38312095E-03_JPRB, 0.38320513E-03_JPRB, &
  & 0.38340614E-03_JPRB, 0.38358080E-03_JPRB, 0.38381013E-03_JPRB, 0.38404215E-03_JPRB, 0.38439273E-03_JPRB, 0.38479541E-03_JPRB, &
  & 0.38514069E-03_JPRB, 0.38556950E-03_JPRB, 0.38606309E-03_JPRB, 0.38635546E-03_JPRB, 0.38660993E-03_JPRB, 0.38692556E-03_JPRB, &
  & 0.38710912E-03_JPRB, 0.38721677E-03_JPRB, 0.38697247E-03_JPRB, 0.38663201E-03_JPRB, 0.38636307E-03_JPRB, 0.38613560E-03_JPRB, &
  & 0.38585471E-03_JPRB, 0.38558677E-03_JPRB, 0.38524838E-03_JPRB, 0.38494088E-03_JPRB, 0.38457291E-03_JPRB, 0.38399808E-03_JPRB, &
  & 0.38343400E-03_JPRB, 0.38289889E-03_JPRB, 0.38244112E-03_JPRB, 0.38216102E-03_JPRB, 0.38191203E-03_JPRB, 0.38181995E-03_JPRB, &
  & 0.38162221E-03_JPRB, 0.38143330E-03_JPRB, 0.38127754E-03_JPRB, 0.38122730E-03_JPRB, 0.38121384E-03_JPRB, 0.38112335E-03_JPRB, &
  & 0.38095758E-03_JPRB, 0.38110486E-03_JPRB, 0.38087007E-03_JPRB, 0.38078185E-03_JPRB  /)

RGHG1(:,56, 7) = (/ &
  & 0.38482313E-03_JPRB, 0.38428640E-03_JPRB, 0.38350175E-03_JPRB, 0.38325435E-03_JPRB, 0.38296604E-03_JPRB, 0.38273225E-03_JPRB, &
  & 0.38239274E-03_JPRB, 0.38210295E-03_JPRB, 0.38194822E-03_JPRB, 0.38189925E-03_JPRB, 0.38176248E-03_JPRB, 0.38162197E-03_JPRB, &
  & 0.38163989E-03_JPRB, 0.38183938E-03_JPRB, 0.38200652E-03_JPRB, 0.38210551E-03_JPRB, 0.38211538E-03_JPRB, 0.38213467E-03_JPRB, &
  & 0.38221559E-03_JPRB, 0.38231871E-03_JPRB, 0.38252001E-03_JPRB, 0.38281565E-03_JPRB, 0.38296477E-03_JPRB, 0.38307292E-03_JPRB, &
  & 0.38327001E-03_JPRB, 0.38349200E-03_JPRB, 0.38373995E-03_JPRB, 0.38400240E-03_JPRB, 0.38433806E-03_JPRB, 0.38472779E-03_JPRB, &
  & 0.38506143E-03_JPRB, 0.38547657E-03_JPRB, 0.38597150E-03_JPRB, 0.38627789E-03_JPRB, 0.38656057E-03_JPRB, 0.38691871E-03_JPRB, &
  & 0.38709277E-03_JPRB, 0.38715754E-03_JPRB, 0.38692286E-03_JPRB, 0.38652662E-03_JPRB, 0.38626633E-03_JPRB, 0.38603946E-03_JPRB, &
  & 0.38578743E-03_JPRB, 0.38551814E-03_JPRB, 0.38513055E-03_JPRB, 0.38477949E-03_JPRB, 0.38438990E-03_JPRB, 0.38381774E-03_JPRB, &
  & 0.38327805E-03_JPRB, 0.38280215E-03_JPRB, 0.38236216E-03_JPRB, 0.38207550E-03_JPRB, 0.38184837E-03_JPRB, 0.38177253E-03_JPRB, &
  & 0.38160420E-03_JPRB, 0.38146478E-03_JPRB, 0.38134853E-03_JPRB, 0.38130795E-03_JPRB, 0.38125392E-03_JPRB, 0.38115266E-03_JPRB, &
  & 0.38099714E-03_JPRB, 0.38112755E-03_JPRB, 0.38092589E-03_JPRB, 0.38088223E-03_JPRB  /)

RGHG1(:,57, 7) = (/ &
  & 0.38463836E-03_JPRB, 0.38423029E-03_JPRB, 0.38358329E-03_JPRB, 0.38335625E-03_JPRB, 0.38308778E-03_JPRB, 0.38287678E-03_JPRB, &
  & 0.38255737E-03_JPRB, 0.38229938E-03_JPRB, 0.38215742E-03_JPRB, 0.38207928E-03_JPRB, 0.38191333E-03_JPRB, 0.38176071E-03_JPRB, &
  & 0.38174363E-03_JPRB, 0.38191783E-03_JPRB, 0.38203889E-03_JPRB, 0.38210233E-03_JPRB, 0.38208921E-03_JPRB, 0.38208397E-03_JPRB, &
  & 0.38214781E-03_JPRB, 0.38220138E-03_JPRB, 0.38234399E-03_JPRB, 0.38262988E-03_JPRB, 0.38281177E-03_JPRB, 0.38294660E-03_JPRB, &
  & 0.38313618E-03_JPRB, 0.38339449E-03_JPRB, 0.38366840E-03_JPRB, 0.38395650E-03_JPRB, 0.38427851E-03_JPRB, 0.38464993E-03_JPRB, &
  & 0.38497677E-03_JPRB, 0.38537366E-03_JPRB, 0.38586609E-03_JPRB, 0.38619617E-03_JPRB, 0.38651462E-03_JPRB, 0.38690733E-03_JPRB, &
  & 0.38707084E-03_JPRB, 0.38710130E-03_JPRB, 0.38687195E-03_JPRB, 0.38643468E-03_JPRB, 0.38616911E-03_JPRB, 0.38594721E-03_JPRB, &
  & 0.38571625E-03_JPRB, 0.38543514E-03_JPRB, 0.38500713E-03_JPRB, 0.38461301E-03_JPRB, 0.38419697E-03_JPRB, 0.38362961E-03_JPRB, &
  & 0.38311606E-03_JPRB, 0.38269869E-03_JPRB, 0.38227626E-03_JPRB, 0.38198599E-03_JPRB, 0.38178491E-03_JPRB, 0.38173502E-03_JPRB, &
  & 0.38159126E-03_JPRB, 0.38150191E-03_JPRB, 0.38142916E-03_JPRB, 0.38140156E-03_JPRB, 0.38131921E-03_JPRB, 0.38121017E-03_JPRB, &
  & 0.38106918E-03_JPRB, 0.38118423E-03_JPRB, 0.38100383E-03_JPRB, 0.38098688E-03_JPRB  /)

RGHG1(:,58, 7) = (/ &
  & 0.38452737E-03_JPRB, 0.38420977E-03_JPRB, 0.38366781E-03_JPRB, 0.38347197E-03_JPRB, 0.38324491E-03_JPRB, 0.38304620E-03_JPRB, &
  & 0.38275439E-03_JPRB, 0.38252079E-03_JPRB, 0.38238337E-03_JPRB, 0.38228245E-03_JPRB, 0.38209163E-03_JPRB, 0.38192975E-03_JPRB, &
  & 0.38187731E-03_JPRB, 0.38201956E-03_JPRB, 0.38209353E-03_JPRB, 0.38212105E-03_JPRB, 0.38207569E-03_JPRB, 0.38204880E-03_JPRB, &
  & 0.38209014E-03_JPRB, 0.38211081E-03_JPRB, 0.38220180E-03_JPRB, 0.38246415E-03_JPRB, 0.38268452E-03_JPRB, 0.38284894E-03_JPRB, &
  & 0.38301952E-03_JPRB, 0.38329664E-03_JPRB, 0.38359929E-03_JPRB, 0.38389996E-03_JPRB, 0.38421035E-03_JPRB, 0.38455634E-03_JPRB, &
  & 0.38488573E-03_JPRB, 0.38525369E-03_JPRB, 0.38573742E-03_JPRB, 0.38610768E-03_JPRB, 0.38647435E-03_JPRB, 0.38688757E-03_JPRB, &
  & 0.38704238E-03_JPRB, 0.38704921E-03_JPRB, 0.38682222E-03_JPRB, 0.38637209E-03_JPRB, 0.38608516E-03_JPRB, 0.38586950E-03_JPRB, &
  & 0.38564752E-03_JPRB, 0.38533965E-03_JPRB, 0.38489019E-03_JPRB, 0.38445626E-03_JPRB, 0.38400921E-03_JPRB, 0.38345291E-03_JPRB, &
  & 0.38296489E-03_JPRB, 0.38260415E-03_JPRB, 0.38219439E-03_JPRB, 0.38190024E-03_JPRB, 0.38173254E-03_JPRB, 0.38172433E-03_JPRB, &
  & 0.38160043E-03_JPRB, 0.38156535E-03_JPRB, 0.38154620E-03_JPRB, 0.38154091E-03_JPRB, 0.38144996E-03_JPRB, 0.38134980E-03_JPRB, &
  & 0.38123547E-03_JPRB, 0.38133133E-03_JPRB, 0.38115632E-03_JPRB, 0.38112075E-03_JPRB  /)

RGHG1(:,59, 7) = (/ &
  & 0.38443368E-03_JPRB, 0.38414965E-03_JPRB, 0.38372278E-03_JPRB, 0.38354953E-03_JPRB, 0.38338051E-03_JPRB, 0.38320387E-03_JPRB, &
  & 0.38293989E-03_JPRB, 0.38273020E-03_JPRB, 0.38259136E-03_JPRB, 0.38246867E-03_JPRB, 0.38226286E-03_JPRB, 0.38209768E-03_JPRB, &
  & 0.38201689E-03_JPRB, 0.38212206E-03_JPRB, 0.38216058E-03_JPRB, 0.38216284E-03_JPRB, 0.38208510E-03_JPRB, 0.38204325E-03_JPRB, &
  & 0.38204916E-03_JPRB, 0.38204178E-03_JPRB, 0.38210108E-03_JPRB, 0.38232277E-03_JPRB, 0.38256158E-03_JPRB, 0.38274645E-03_JPRB, &
  & 0.38291457E-03_JPRB, 0.38318794E-03_JPRB, 0.38350563E-03_JPRB, 0.38381361E-03_JPRB, 0.38415022E-03_JPRB, 0.38449297E-03_JPRB, &
  & 0.38481101E-03_JPRB, 0.38515603E-03_JPRB, 0.38562016E-03_JPRB, 0.38604031E-03_JPRB, 0.38644741E-03_JPRB, 0.38686315E-03_JPRB, &
  & 0.38700796E-03_JPRB, 0.38699180E-03_JPRB, 0.38674768E-03_JPRB, 0.38631586E-03_JPRB, 0.38601270E-03_JPRB, 0.38581599E-03_JPRB, &
  & 0.38558316E-03_JPRB, 0.38524024E-03_JPRB, 0.38478283E-03_JPRB, 0.38432368E-03_JPRB, 0.38383941E-03_JPRB, 0.38330299E-03_JPRB, &
  & 0.38283972E-03_JPRB, 0.38252507E-03_JPRB, 0.38212801E-03_JPRB, 0.38184622E-03_JPRB, 0.38171395E-03_JPRB, 0.38174697E-03_JPRB, &
  & 0.38164870E-03_JPRB, 0.38165283E-03_JPRB, 0.38168434E-03_JPRB, 0.38170334E-03_JPRB, 0.38163009E-03_JPRB, 0.38154114E-03_JPRB, &
  & 0.38145970E-03_JPRB, 0.38155189E-03_JPRB, 0.38136964E-03_JPRB, 0.38126192E-03_JPRB  /)

RGHG1(:,60, 7) = (/ &
  & 0.38434006E-03_JPRB, 0.38406864E-03_JPRB, 0.38376296E-03_JPRB, 0.38361106E-03_JPRB, 0.38350866E-03_JPRB, 0.38335912E-03_JPRB, &
  & 0.38312174E-03_JPRB, 0.38293778E-03_JPRB, 0.38279584E-03_JPRB, 0.38264984E-03_JPRB, 0.38243245E-03_JPRB, 0.38226634E-03_JPRB, &
  & 0.38216142E-03_JPRB, 0.38222679E-03_JPRB, 0.38223386E-03_JPRB, 0.38221502E-03_JPRB, 0.38210740E-03_JPRB, 0.38205226E-03_JPRB, &
  & 0.38201868E-03_JPRB, 0.38198363E-03_JPRB, 0.38201745E-03_JPRB, 0.38219206E-03_JPRB, 0.38243519E-03_JPRB, 0.38263587E-03_JPRB, &
  & 0.38281405E-03_JPRB, 0.38307442E-03_JPRB, 0.38339387E-03_JPRB, 0.38371234E-03_JPRB, 0.38409002E-03_JPRB, 0.38444129E-03_JPRB, &
  & 0.38474954E-03_JPRB, 0.38507629E-03_JPRB, 0.38551916E-03_JPRB, 0.38598500E-03_JPRB, 0.38642227E-03_JPRB, 0.38683277E-03_JPRB, &
  & 0.38696816E-03_JPRB, 0.38692752E-03_JPRB, 0.38665821E-03_JPRB, 0.38625792E-03_JPRB, 0.38594590E-03_JPRB, 0.38577235E-03_JPRB, &
  & 0.38551800E-03_JPRB, 0.38513882E-03_JPRB, 0.38467788E-03_JPRB, 0.38419935E-03_JPRB, 0.38367737E-03_JPRB, 0.38316619E-03_JPRB, &
  & 0.38272778E-03_JPRB, 0.38245447E-03_JPRB, 0.38207208E-03_JPRB, 0.38181175E-03_JPRB, 0.38171761E-03_JPRB, 0.38179058E-03_JPRB, &
  & 0.38172194E-03_JPRB, 0.38175988E-03_JPRB, 0.38184152E-03_JPRB, 0.38188968E-03_JPRB, 0.38184587E-03_JPRB, 0.38176551E-03_JPRB, &
  & 0.38172155E-03_JPRB, 0.38182036E-03_JPRB, 0.38162569E-03_JPRB, 0.38143300E-03_JPRB  /)

RGHG1(:,61, 7) = (/ &
  & 0.38423981E-03_JPRB, 0.38396562E-03_JPRB, 0.38377372E-03_JPRB, 0.38364560E-03_JPRB, 0.38361312E-03_JPRB, 0.38349443E-03_JPRB, &
  & 0.38327406E-03_JPRB, 0.38311973E-03_JPRB, 0.38297595E-03_JPRB, 0.38280278E-03_JPRB, 0.38257709E-03_JPRB, 0.38241231E-03_JPRB, &
  & 0.38229539E-03_JPRB, 0.38232284E-03_JPRB, 0.38230510E-03_JPRB, 0.38227191E-03_JPRB, 0.38214964E-03_JPRB, 0.38208167E-03_JPRB, &
  & 0.38201479E-03_JPRB, 0.38195196E-03_JPRB, 0.38196445E-03_JPRB, 0.38209509E-03_JPRB, 0.38230952E-03_JPRB, 0.38251614E-03_JPRB, &
  & 0.38273286E-03_JPRB, 0.38297325E-03_JPRB, 0.38325733E-03_JPRB, 0.38360430E-03_JPRB, 0.38402892E-03_JPRB, 0.38440725E-03_JPRB, &
  & 0.38473139E-03_JPRB, 0.38505425E-03_JPRB, 0.38548636E-03_JPRB, 0.38596102E-03_JPRB, 0.38639162E-03_JPRB, 0.38678890E-03_JPRB, &
  & 0.38692029E-03_JPRB, 0.38685228E-03_JPRB, 0.38655366E-03_JPRB, 0.38619427E-03_JPRB, 0.38589834E-03_JPRB, 0.38574528E-03_JPRB, &
  & 0.38545455E-03_JPRB, 0.38505046E-03_JPRB, 0.38458747E-03_JPRB, 0.38409797E-03_JPRB, 0.38355026E-03_JPRB, 0.38307106E-03_JPRB, &
  & 0.38265479E-03_JPRB, 0.38241018E-03_JPRB, 0.38204819E-03_JPRB, 0.38182241E-03_JPRB, 0.38176866E-03_JPRB, 0.38187053E-03_JPRB, &
  & 0.38183582E-03_JPRB, 0.38189919E-03_JPRB, 0.38202449E-03_JPRB, 0.38211448E-03_JPRB, 0.38210993E-03_JPRB, 0.38202311E-03_JPRB, &
  & 0.38202148E-03_JPRB, 0.38214817E-03_JPRB, 0.38193793E-03_JPRB, 0.38168958E-03_JPRB  /)

RGHG1(:,62, 7) = (/ &
  & 0.38415290E-03_JPRB, 0.38387734E-03_JPRB, 0.38376707E-03_JPRB, 0.38367609E-03_JPRB, 0.38370686E-03_JPRB, 0.38361500E-03_JPRB, &
  & 0.38340522E-03_JPRB, 0.38327701E-03_JPRB, 0.38313865E-03_JPRB, 0.38293803E-03_JPRB, 0.38270186E-03_JPRB, 0.38254097E-03_JPRB, &
  & 0.38242047E-03_JPRB, 0.38241399E-03_JPRB, 0.38237426E-03_JPRB, 0.38232868E-03_JPRB, 0.38219940E-03_JPRB, 0.38211795E-03_JPRB, &
  & 0.38203202E-03_JPRB, 0.38194587E-03_JPRB, 0.38192950E-03_JPRB, 0.38202269E-03_JPRB, 0.38220408E-03_JPRB, 0.38240071E-03_JPRB, &
  & 0.38265801E-03_JPRB, 0.38288205E-03_JPRB, 0.38314804E-03_JPRB, 0.38351148E-03_JPRB, 0.38397354E-03_JPRB, 0.38437764E-03_JPRB, &
  & 0.38472512E-03_JPRB, 0.38505413E-03_JPRB, 0.38548302E-03_JPRB, 0.38595713E-03_JPRB, 0.38636720E-03_JPRB, 0.38673915E-03_JPRB, &
  & 0.38686729E-03_JPRB, 0.38676971E-03_JPRB, 0.38645199E-03_JPRB, 0.38613666E-03_JPRB, 0.38587938E-03_JPRB, 0.38572650E-03_JPRB, &
  & 0.38540535E-03_JPRB, 0.38497139E-03_JPRB, 0.38451265E-03_JPRB, 0.38400815E-03_JPRB, 0.38345469E-03_JPRB, 0.38300865E-03_JPRB, &
  & 0.38261367E-03_JPRB, 0.38239143E-03_JPRB, 0.38205887E-03_JPRB, 0.38187530E-03_JPRB, 0.38186019E-03_JPRB, 0.38199185E-03_JPRB, &
  & 0.38198680E-03_JPRB, 0.38207382E-03_JPRB, 0.38223777E-03_JPRB, 0.38237703E-03_JPRB, 0.38241652E-03_JPRB, 0.38234162E-03_JPRB, &
  & 0.38236889E-03_JPRB, 0.38251615E-03_JPRB, 0.38230819E-03_JPRB, 0.38205537E-03_JPRB  /)

RGHG1(:,63, 7) = (/ &
  & 0.38407710E-03_JPRB, 0.38380876E-03_JPRB, 0.38375401E-03_JPRB, 0.38370632E-03_JPRB, 0.38379381E-03_JPRB, 0.38372707E-03_JPRB, &
  & 0.38352379E-03_JPRB, 0.38341780E-03_JPRB, 0.38328766E-03_JPRB, 0.38306119E-03_JPRB, 0.38281776E-03_JPRB, 0.38265987E-03_JPRB, &
  & 0.38253928E-03_JPRB, 0.38250255E-03_JPRB, 0.38244343E-03_JPRB, 0.38238480E-03_JPRB, 0.38225150E-03_JPRB, 0.38215937E-03_JPRB, &
  & 0.38206557E-03_JPRB, 0.38196073E-03_JPRB, 0.38191218E-03_JPRB, 0.38196839E-03_JPRB, 0.38211622E-03_JPRB, 0.38229452E-03_JPRB, &
  & 0.38257969E-03_JPRB, 0.38279528E-03_JPRB, 0.38305929E-03_JPRB, 0.38343370E-03_JPRB, 0.38392092E-03_JPRB, 0.38434252E-03_JPRB, &
  & 0.38472489E-03_JPRB, 0.38507644E-03_JPRB, 0.38550356E-03_JPRB, 0.38595792E-03_JPRB, 0.38634256E-03_JPRB, 0.38668005E-03_JPRB, &
  & 0.38680689E-03_JPRB, 0.38668718E-03_JPRB, 0.38636386E-03_JPRB, 0.38609008E-03_JPRB, 0.38587516E-03_JPRB, 0.38571465E-03_JPRB, &
  & 0.38536786E-03_JPRB, 0.38490262E-03_JPRB, 0.38445023E-03_JPRB, 0.38392980E-03_JPRB, 0.38338104E-03_JPRB, 0.38296886E-03_JPRB, &
  & 0.38259499E-03_JPRB, 0.38239273E-03_JPRB, 0.38209734E-03_JPRB, 0.38196115E-03_JPRB, 0.38198490E-03_JPRB, 0.38214571E-03_JPRB, &
  & 0.38216601E-03_JPRB, 0.38228004E-03_JPRB, 0.38247775E-03_JPRB, 0.38266921E-03_JPRB, 0.38275559E-03_JPRB, 0.38270948E-03_JPRB, &
  & 0.38276131E-03_JPRB, 0.38291851E-03_JPRB, 0.38272819E-03_JPRB, 0.38249950E-03_JPRB  /)

RGHG1(:,64, 7) = (/ &
  & 0.38401824E-03_JPRB, 0.38377686E-03_JPRB, 0.38374336E-03_JPRB, 0.38373889E-03_JPRB, 0.38387140E-03_JPRB, 0.38382865E-03_JPRB, &
  & 0.38362805E-03_JPRB, 0.38353726E-03_JPRB, 0.38341451E-03_JPRB, 0.38316759E-03_JPRB, 0.38292735E-03_JPRB, 0.38276755E-03_JPRB, &
  & 0.38264691E-03_JPRB, 0.38258625E-03_JPRB, 0.38251210E-03_JPRB, 0.38243721E-03_JPRB, 0.38229966E-03_JPRB, 0.38220494E-03_JPRB, &
  & 0.38211680E-03_JPRB, 0.38200098E-03_JPRB, 0.38192098E-03_JPRB, 0.38193616E-03_JPRB, 0.38205483E-03_JPRB, 0.38221111E-03_JPRB, &
  & 0.38248932E-03_JPRB, 0.38271271E-03_JPRB, 0.38299723E-03_JPRB, 0.38338084E-03_JPRB, 0.38387137E-03_JPRB, 0.38429056E-03_JPRB, &
  & 0.38472758E-03_JPRB, 0.38513132E-03_JPRB, 0.38555261E-03_JPRB, 0.38594968E-03_JPRB, 0.38631196E-03_JPRB, 0.38660600E-03_JPRB, &
  & 0.38673570E-03_JPRB, 0.38661554E-03_JPRB, 0.38630999E-03_JPRB, 0.38606659E-03_JPRB, 0.38587847E-03_JPRB, 0.38571201E-03_JPRB, &
  & 0.38534639E-03_JPRB, 0.38485273E-03_JPRB, 0.38440516E-03_JPRB, 0.38387122E-03_JPRB, 0.38333255E-03_JPRB, 0.38295350E-03_JPRB, &
  & 0.38260031E-03_JPRB, 0.38241779E-03_JPRB, 0.38216808E-03_JPRB, 0.38208246E-03_JPRB, 0.38214590E-03_JPRB, 0.38233215E-03_JPRB, &
  & 0.38237045E-03_JPRB, 0.38252064E-03_JPRB, 0.38274374E-03_JPRB, 0.38298503E-03_JPRB, 0.38311867E-03_JPRB, 0.38312334E-03_JPRB, &
  & 0.38320180E-03_JPRB, 0.38334953E-03_JPRB, 0.38319610E-03_JPRB, 0.38300934E-03_JPRB  /)

RGHG1(:,65, 7) = (/ &
  & 0.38398987E-03_JPRB, 0.38379006E-03_JPRB, 0.38375449E-03_JPRB, 0.38378459E-03_JPRB, 0.38394628E-03_JPRB, 0.38392291E-03_JPRB, &
  & 0.38372643E-03_JPRB, 0.38363869E-03_JPRB, 0.38351599E-03_JPRB, 0.38326123E-03_JPRB, 0.38303522E-03_JPRB, 0.38286735E-03_JPRB, &
  & 0.38274221E-03_JPRB, 0.38266291E-03_JPRB, 0.38257843E-03_JPRB, 0.38248663E-03_JPRB, 0.38234979E-03_JPRB, 0.38225760E-03_JPRB, &
  & 0.38218231E-03_JPRB, 0.38206778E-03_JPRB, 0.38196663E-03_JPRB, 0.38194526E-03_JPRB, 0.38202831E-03_JPRB, 0.38216619E-03_JPRB, &
  & 0.38240177E-03_JPRB, 0.38265643E-03_JPRB, 0.38296178E-03_JPRB, 0.38334912E-03_JPRB, 0.38380328E-03_JPRB, 0.38425307E-03_JPRB, &
  & 0.38478252E-03_JPRB, 0.38520806E-03_JPRB, 0.38558649E-03_JPRB, 0.38591137E-03_JPRB, 0.38625242E-03_JPRB, 0.38652664E-03_JPRB, &
  & 0.38665864E-03_JPRB, 0.38655990E-03_JPRB, 0.38629025E-03_JPRB, 0.38606630E-03_JPRB, 0.38588410E-03_JPRB, 0.38570685E-03_JPRB, &
  & 0.38532308E-03_JPRB, 0.38482996E-03_JPRB, 0.38438938E-03_JPRB, 0.38385524E-03_JPRB, 0.38332136E-03_JPRB, 0.38296573E-03_JPRB, &
  & 0.38263182E-03_JPRB, 0.38247403E-03_JPRB, 0.38227907E-03_JPRB, 0.38223813E-03_JPRB, 0.38234287E-03_JPRB, 0.38254135E-03_JPRB, &
  & 0.38259408E-03_JPRB, 0.38278701E-03_JPRB, 0.38303565E-03_JPRB, 0.38331766E-03_JPRB, 0.38349996E-03_JPRB, 0.38355158E-03_JPRB, &
  & 0.38366397E-03_JPRB, 0.38380486E-03_JPRB, 0.38368452E-03_JPRB, 0.38354299E-03_JPRB  /)

RGHG1(:,66, 7) = (/ &
  & 0.38397611E-03_JPRB, 0.38381484E-03_JPRB, 0.38378000E-03_JPRB, 0.38383851E-03_JPRB, 0.38401993E-03_JPRB, 0.38401397E-03_JPRB, &
  & 0.38382149E-03_JPRB, 0.38373341E-03_JPRB, 0.38360669E-03_JPRB, 0.38335258E-03_JPRB, 0.38314012E-03_JPRB, 0.38296446E-03_JPRB, &
  & 0.38283486E-03_JPRB, 0.38273917E-03_JPRB, 0.38264474E-03_JPRB, 0.38253977E-03_JPRB, 0.38240637E-03_JPRB, 0.38231486E-03_JPRB, &
  & 0.38224975E-03_JPRB, 0.38214227E-03_JPRB, 0.38202956E-03_JPRB, 0.38197701E-03_JPRB, 0.38202802E-03_JPRB, 0.38214547E-03_JPRB, &
  & 0.38234559E-03_JPRB, 0.38261938E-03_JPRB, 0.38293980E-03_JPRB, 0.38332746E-03_JPRB, 0.38375987E-03_JPRB, 0.38426786E-03_JPRB, &
  & 0.38485248E-03_JPRB, 0.38527675E-03_JPRB, 0.38559871E-03_JPRB, 0.38586310E-03_JPRB, 0.38618571E-03_JPRB, 0.38645520E-03_JPRB, &
  & 0.38658535E-03_JPRB, 0.38651193E-03_JPRB, 0.38627542E-03_JPRB, 0.38606954E-03_JPRB, 0.38588941E-03_JPRB, 0.38569608E-03_JPRB, &
  & 0.38529881E-03_JPRB, 0.38482129E-03_JPRB, 0.38438819E-03_JPRB, 0.38386344E-03_JPRB, 0.38333768E-03_JPRB, 0.38299709E-03_JPRB, &
  & 0.38268441E-03_JPRB, 0.38255523E-03_JPRB, 0.38241263E-03_JPRB, 0.38241334E-03_JPRB, 0.38255636E-03_JPRB, 0.38276528E-03_JPRB, &
  & 0.38282894E-03_JPRB, 0.38306626E-03_JPRB, 0.38334257E-03_JPRB, 0.38365727E-03_JPRB, 0.38388842E-03_JPRB, 0.38397409E-03_JPRB, &
  & 0.38412392E-03_JPRB, 0.38426695E-03_JPRB, 0.38416742E-03_JPRB, 0.38407592E-03_JPRB  /)

RGHG1(:,67, 7) = (/ &
  & 0.38397393E-03_JPRB, 0.38384516E-03_JPRB, 0.38381643E-03_JPRB, 0.38389702E-03_JPRB, 0.38409116E-03_JPRB, 0.38409978E-03_JPRB, &
  & 0.38391207E-03_JPRB, 0.38382158E-03_JPRB, 0.38368754E-03_JPRB, 0.38344163E-03_JPRB, 0.38324018E-03_JPRB, 0.38305933E-03_JPRB, &
  & 0.38292509E-03_JPRB, 0.38281619E-03_JPRB, 0.38271231E-03_JPRB, 0.38259793E-03_JPRB, 0.38246880E-03_JPRB, 0.38237658E-03_JPRB, &
  & 0.38231749E-03_JPRB, 0.38222036E-03_JPRB, 0.38210403E-03_JPRB, 0.38202645E-03_JPRB, 0.38205197E-03_JPRB, 0.38215014E-03_JPRB, &
  & 0.38232784E-03_JPRB, 0.38260174E-03_JPRB, 0.38292990E-03_JPRB, 0.38332019E-03_JPRB, 0.38374760E-03_JPRB, 0.38432826E-03_JPRB, &
  & 0.38492936E-03_JPRB, 0.38533149E-03_JPRB, 0.38559677E-03_JPRB, 0.38581411E-03_JPRB, 0.38611792E-03_JPRB, 0.38639289E-03_JPRB, &
  & 0.38651907E-03_JPRB, 0.38646836E-03_JPRB, 0.38626151E-03_JPRB, 0.38607380E-03_JPRB, 0.38589304E-03_JPRB, 0.38568236E-03_JPRB, &
  & 0.38527954E-03_JPRB, 0.38482563E-03_JPRB, 0.38439954E-03_JPRB, 0.38389284E-03_JPRB, 0.38337934E-03_JPRB, 0.38304589E-03_JPRB, &
  & 0.38275713E-03_JPRB, 0.38265785E-03_JPRB, 0.38256227E-03_JPRB, 0.38260071E-03_JPRB, 0.38277862E-03_JPRB, 0.38299913E-03_JPRB, &
  & 0.38307076E-03_JPRB, 0.38335110E-03_JPRB, 0.38365448E-03_JPRB, 0.38399450E-03_JPRB, 0.38427060E-03_JPRB, 0.38437800E-03_JPRB, &
  & 0.38456801E-03_JPRB, 0.38471871E-03_JPRB, 0.38462833E-03_JPRB, 0.38458581E-03_JPRB  /)

RGHG1(:,68, 7) = (/ &
  & 0.38397923E-03_JPRB, 0.38387457E-03_JPRB, 0.38385758E-03_JPRB, 0.38395378E-03_JPRB, 0.38415822E-03_JPRB, 0.38417650E-03_JPRB, &
  & 0.38399663E-03_JPRB, 0.38390286E-03_JPRB, 0.38375932E-03_JPRB, 0.38352762E-03_JPRB, 0.38333319E-03_JPRB, 0.38315332E-03_JPRB, &
  & 0.38301293E-03_JPRB, 0.38289620E-03_JPRB, 0.38278431E-03_JPRB, 0.38266320E-03_JPRB, 0.38253546E-03_JPRB, 0.38244358E-03_JPRB, &
  & 0.38238529E-03_JPRB, 0.38229772E-03_JPRB, 0.38218179E-03_JPRB, 0.38208620E-03_JPRB, 0.38209652E-03_JPRB, 0.38218439E-03_JPRB, &
  & 0.38235599E-03_JPRB, 0.38260404E-03_JPRB, 0.38293094E-03_JPRB, 0.38333809E-03_JPRB, 0.38377016E-03_JPRB, 0.38441063E-03_JPRB, &
  & 0.38500349E-03_JPRB, 0.38536677E-03_JPRB, 0.38559907E-03_JPRB, 0.38577998E-03_JPRB, 0.38605714E-03_JPRB, 0.38633832E-03_JPRB, &
  & 0.38646364E-03_JPRB, 0.38642277E-03_JPRB, 0.38624533E-03_JPRB, 0.38607748E-03_JPRB, 0.38589270E-03_JPRB, 0.38567206E-03_JPRB, &
  & 0.38527758E-03_JPRB, 0.38484255E-03_JPRB, 0.38442141E-03_JPRB, 0.38393986E-03_JPRB, 0.38344271E-03_JPRB, 0.38310990E-03_JPRB, &
  & 0.38284888E-03_JPRB, 0.38277561E-03_JPRB, 0.38271854E-03_JPRB, 0.38278905E-03_JPRB, 0.38299919E-03_JPRB, 0.38323673E-03_JPRB, &
  & 0.38331475E-03_JPRB, 0.38363188E-03_JPRB, 0.38395575E-03_JPRB, 0.38431574E-03_JPRB, 0.38462500E-03_JPRB, 0.38474575E-03_JPRB, &
  & 0.38497818E-03_JPRB, 0.38513308E-03_JPRB, 0.38504402E-03_JPRB, 0.38503708E-03_JPRB  /)

RGHG1(:,69, 7) = (/ &
  & 0.38398614E-03_JPRB, 0.38390780E-03_JPRB, 0.38390093E-03_JPRB, 0.38400648E-03_JPRB, 0.38421997E-03_JPRB, 0.38424132E-03_JPRB, &
  & 0.38407399E-03_JPRB, 0.38397919E-03_JPRB, 0.38383223E-03_JPRB, 0.38361198E-03_JPRB, 0.38342038E-03_JPRB, 0.38324363E-03_JPRB, &
  & 0.38309870E-03_JPRB, 0.38298175E-03_JPRB, 0.38286212E-03_JPRB, 0.38273747E-03_JPRB, 0.38260959E-03_JPRB, 0.38251926E-03_JPRB, &
  & 0.38246403E-03_JPRB, 0.38237884E-03_JPRB, 0.38225634E-03_JPRB, 0.38215363E-03_JPRB, 0.38215793E-03_JPRB, 0.38223618E-03_JPRB, &
  & 0.38241153E-03_JPRB, 0.38263207E-03_JPRB, 0.38294507E-03_JPRB, 0.38335945E-03_JPRB, 0.38379754E-03_JPRB, 0.38445667E-03_JPRB, &
  & 0.38502549E-03_JPRB, 0.38536234E-03_JPRB, 0.38559195E-03_JPRB, 0.38574612E-03_JPRB, 0.38600218E-03_JPRB, 0.38629283E-03_JPRB, &
  & 0.38642462E-03_JPRB, 0.38637929E-03_JPRB, 0.38623356E-03_JPRB, 0.38608389E-03_JPRB, 0.38589460E-03_JPRB, 0.38568271E-03_JPRB, &
  & 0.38530307E-03_JPRB, 0.38487341E-03_JPRB, 0.38445853E-03_JPRB, 0.38400983E-03_JPRB, 0.38352257E-03_JPRB, 0.38318259E-03_JPRB, &
  & 0.38293757E-03_JPRB, 0.38288513E-03_JPRB, 0.38285446E-03_JPRB, 0.38294681E-03_JPRB, 0.38319651E-03_JPRB, 0.38346031E-03_JPRB, &
  & 0.38354545E-03_JPRB, 0.38389007E-03_JPRB, 0.38422568E-03_JPRB, 0.38460376E-03_JPRB, 0.38492736E-03_JPRB, 0.38506764E-03_JPRB, &
  & 0.38533390E-03_JPRB, 0.38547403E-03_JPRB, 0.38539269E-03_JPRB, 0.38541817E-03_JPRB  /)

RGHG1(:,70, 7) = (/ &
  & 0.38399785E-03_JPRB, 0.38394857E-03_JPRB, 0.38394853E-03_JPRB, 0.38405960E-03_JPRB, 0.38427373E-03_JPRB, 0.38429654E-03_JPRB, &
  & 0.38414337E-03_JPRB, 0.38405034E-03_JPRB, 0.38390966E-03_JPRB, 0.38369935E-03_JPRB, 0.38350683E-03_JPRB, 0.38332928E-03_JPRB, &
  & 0.38318361E-03_JPRB, 0.38306738E-03_JPRB, 0.38294019E-03_JPRB, 0.38281532E-03_JPRB, 0.38268849E-03_JPRB, 0.38260114E-03_JPRB, &
  & 0.38255335E-03_JPRB, 0.38246875E-03_JPRB, 0.38233661E-03_JPRB, 0.38223090E-03_JPRB, 0.38222598E-03_JPRB, 0.38228867E-03_JPRB, &
  & 0.38245968E-03_JPRB, 0.38265870E-03_JPRB, 0.38295584E-03_JPRB, 0.38336296E-03_JPRB, 0.38380508E-03_JPRB, 0.38445324E-03_JPRB, &
  & 0.38498863E-03_JPRB, 0.38532270E-03_JPRB, 0.38556802E-03_JPRB, 0.38570492E-03_JPRB, 0.38594762E-03_JPRB, 0.38625409E-03_JPRB, &
  & 0.38639600E-03_JPRB, 0.38634007E-03_JPRB, 0.38622280E-03_JPRB, 0.38609114E-03_JPRB, 0.38590333E-03_JPRB, 0.38570201E-03_JPRB, &
  & 0.38534006E-03_JPRB, 0.38491145E-03_JPRB, 0.38450692E-03_JPRB, 0.38409072E-03_JPRB, 0.38360132E-03_JPRB, 0.38325344E-03_JPRB, &
  & 0.38300798E-03_JPRB, 0.38296787E-03_JPRB, 0.38295489E-03_JPRB, 0.38306367E-03_JPRB, 0.38335968E-03_JPRB, 0.38364672E-03_JPRB, &
  & 0.38374884E-03_JPRB, 0.38412121E-03_JPRB, 0.38446715E-03_JPRB, 0.38486470E-03_JPRB, 0.38519726E-03_JPRB, 0.38535930E-03_JPRB, &
  & 0.38564809E-03_JPRB, 0.38577089E-03_JPRB, 0.38569390E-03_JPRB, 0.38572423E-03_JPRB  /)

RGHG1(:,71, 7) = (/ &
  & 0.38401557E-03_JPRB, 0.38399676E-03_JPRB, 0.38399997E-03_JPRB, 0.38411333E-03_JPRB, 0.38431901E-03_JPRB, 0.38434252E-03_JPRB, &
  & 0.38420446E-03_JPRB, 0.38411663E-03_JPRB, 0.38399079E-03_JPRB, 0.38379020E-03_JPRB, 0.38359378E-03_JPRB, 0.38341121E-03_JPRB, &
  & 0.38326929E-03_JPRB, 0.38315150E-03_JPRB, 0.38301660E-03_JPRB, 0.38289578E-03_JPRB, 0.38277292E-03_JPRB, 0.38268939E-03_JPRB, &
  & 0.38265083E-03_JPRB, 0.38256762E-03_JPRB, 0.38242487E-03_JPRB, 0.38231825E-03_JPRB, 0.38229883E-03_JPRB, 0.38233878E-03_JPRB, &
  & 0.38249502E-03_JPRB, 0.38267660E-03_JPRB, 0.38295877E-03_JPRB, 0.38334826E-03_JPRB, 0.38378593E-03_JPRB, 0.38440066E-03_JPRB, &
  & 0.38489921E-03_JPRB, 0.38524324E-03_JPRB, 0.38551950E-03_JPRB, 0.38565323E-03_JPRB, 0.38589240E-03_JPRB, 0.38622150E-03_JPRB, &
  & 0.38637684E-03_JPRB, 0.38630883E-03_JPRB, 0.38621274E-03_JPRB, 0.38609801E-03_JPRB, 0.38591882E-03_JPRB, 0.38572607E-03_JPRB, &
  & 0.38538449E-03_JPRB, 0.38495650E-03_JPRB, 0.38456690E-03_JPRB, 0.38417753E-03_JPRB, 0.38367464E-03_JPRB, 0.38331493E-03_JPRB, &
  & 0.38305392E-03_JPRB, 0.38301680E-03_JPRB, 0.38301439E-03_JPRB, 0.38313361E-03_JPRB, 0.38347868E-03_JPRB, 0.38378544E-03_JPRB, &
  & 0.38391520E-03_JPRB, 0.38431848E-03_JPRB, 0.38467718E-03_JPRB, 0.38509777E-03_JPRB, 0.38543640E-03_JPRB, 0.38562056E-03_JPRB, &
  & 0.38592410E-03_JPRB, 0.38603191E-03_JPRB, 0.38595137E-03_JPRB, 0.38596751E-03_JPRB  /)

RGHG1(:,72, 7) = (/ &
  & 0.38404121E-03_JPRB, 0.38405173E-03_JPRB, 0.38405430E-03_JPRB, 0.38416732E-03_JPRB, 0.38435536E-03_JPRB, 0.38437945E-03_JPRB, &
  & 0.38425684E-03_JPRB, 0.38417886E-03_JPRB, 0.38407376E-03_JPRB, 0.38388487E-03_JPRB, 0.38368292E-03_JPRB, 0.38349170E-03_JPRB, &
  & 0.38335900E-03_JPRB, 0.38323245E-03_JPRB, 0.38308902E-03_JPRB, 0.38297846E-03_JPRB, 0.38286540E-03_JPRB, 0.38278538E-03_JPRB, &
  & 0.38275247E-03_JPRB, 0.38267525E-03_JPRB, 0.38252415E-03_JPRB, 0.38241631E-03_JPRB, 0.38237546E-03_JPRB, 0.38238424E-03_JPRB, &
  & 0.38251421E-03_JPRB, 0.38267706E-03_JPRB, 0.38294845E-03_JPRB, 0.38331871E-03_JPRB, 0.38373131E-03_JPRB, 0.38430104E-03_JPRB, &
  & 0.38476929E-03_JPRB, 0.38511274E-03_JPRB, 0.38543204E-03_JPRB, 0.38558611E-03_JPRB, 0.38583535E-03_JPRB, 0.38619436E-03_JPRB, &
  & 0.38636669E-03_JPRB, 0.38629235E-03_JPRB, 0.38620347E-03_JPRB, 0.38610251E-03_JPRB, 0.38594025E-03_JPRB, 0.38575015E-03_JPRB, &
  & 0.38543226E-03_JPRB, 0.38500997E-03_JPRB, 0.38464042E-03_JPRB, 0.38426349E-03_JPRB, 0.38373807E-03_JPRB, 0.38335469E-03_JPRB, &
  & 0.38306620E-03_JPRB, 0.38302158E-03_JPRB, 0.38302482E-03_JPRB, 0.38314629E-03_JPRB, 0.38353566E-03_JPRB, 0.38386029E-03_JPRB, &
  & 0.38402836E-03_JPRB, 0.38446955E-03_JPRB, 0.38484945E-03_JPRB, 0.38530035E-03_JPRB, 0.38564405E-03_JPRB, 0.38584803E-03_JPRB, &
  & 0.38616574E-03_JPRB, 0.38626699E-03_JPRB, 0.38616807E-03_JPRB, 0.38617229E-03_JPRB  /)

RGHG1(:,73, 7) = (/ &
  & 0.38407513E-03_JPRB, 0.38409947E-03_JPRB, 0.38410312E-03_JPRB, 0.38421541E-03_JPRB, 0.38438241E-03_JPRB, 0.38440494E-03_JPRB, &
  & 0.38430272E-03_JPRB, 0.38423497E-03_JPRB, 0.38414362E-03_JPRB, 0.38397265E-03_JPRB, 0.38376936E-03_JPRB, 0.38357271E-03_JPRB, &
  & 0.38344902E-03_JPRB, 0.38331606E-03_JPRB, 0.38316433E-03_JPRB, 0.38306606E-03_JPRB, 0.38296686E-03_JPRB, 0.38289840E-03_JPRB, &
  & 0.38286967E-03_JPRB, 0.38280628E-03_JPRB, 0.38265667E-03_JPRB, 0.38254896E-03_JPRB, 0.38248548E-03_JPRB, 0.38246440E-03_JPRB, &
  & 0.38255842E-03_JPRB, 0.38269137E-03_JPRB, 0.38293819E-03_JPRB, 0.38327074E-03_JPRB, 0.38363808E-03_JPRB, 0.38414593E-03_JPRB, &
  & 0.38458673E-03_JPRB, 0.38493351E-03_JPRB, 0.38529209E-03_JPRB, 0.38547630E-03_JPRB, 0.38575953E-03_JPRB, 0.38616230E-03_JPRB, &
  & 0.38635666E-03_JPRB, 0.38629273E-03_JPRB, 0.38620253E-03_JPRB, 0.38610323E-03_JPRB, 0.38596914E-03_JPRB, 0.38578710E-03_JPRB, &
  & 0.38548640E-03_JPRB, 0.38506696E-03_JPRB, 0.38471608E-03_JPRB, 0.38433734E-03_JPRB, 0.38378546E-03_JPRB, 0.38335670E-03_JPRB, &
  & 0.38302661E-03_JPRB, 0.38295217E-03_JPRB, 0.38296659E-03_JPRB, 0.38308000E-03_JPRB, 0.38349201E-03_JPRB, 0.38383712E-03_JPRB, &
  & 0.38406843E-03_JPRB, 0.38453727E-03_JPRB, 0.38496022E-03_JPRB, 0.38545053E-03_JPRB, 0.38580194E-03_JPRB, 0.38602650E-03_JPRB, &
  & 0.38637505E-03_JPRB, 0.38647396E-03_JPRB, 0.38635105E-03_JPRB, 0.38635199E-03_JPRB  /)

RGHG1(:,74, 7) = (/ &
  & 0.38411329E-03_JPRB, 0.38414012E-03_JPRB, 0.38414795E-03_JPRB, 0.38425642E-03_JPRB, 0.38440364E-03_JPRB, 0.38442477E-03_JPRB, &
  & 0.38434478E-03_JPRB, 0.38428429E-03_JPRB, 0.38420327E-03_JPRB, 0.38405189E-03_JPRB, 0.38385273E-03_JPRB, 0.38365427E-03_JPRB, &
  & 0.38353726E-03_JPRB, 0.38340378E-03_JPRB, 0.38324783E-03_JPRB, 0.38315780E-03_JPRB, 0.38307328E-03_JPRB, 0.38302059E-03_JPRB, &
  & 0.38299442E-03_JPRB, 0.38294339E-03_JPRB, 0.38280264E-03_JPRB, 0.38270065E-03_JPRB, 0.38262080E-03_JPRB, 0.38258028E-03_JPRB, &
  & 0.38263066E-03_JPRB, 0.38272907E-03_JPRB, 0.38293103E-03_JPRB, 0.38321230E-03_JPRB, 0.38353472E-03_JPRB, 0.38396425E-03_JPRB, &
  & 0.38438252E-03_JPRB, 0.38472974E-03_JPRB, 0.38512192E-03_JPRB, 0.38533344E-03_JPRB, 0.38566214E-03_JPRB, 0.38612103E-03_JPRB, &
  & 0.38634152E-03_JPRB, 0.38630033E-03_JPRB, 0.38620961E-03_JPRB, 0.38610607E-03_JPRB, 0.38600095E-03_JPRB, 0.38583352E-03_JPRB, &
  & 0.38555068E-03_JPRB, 0.38513145E-03_JPRB, 0.38479232E-03_JPRB, 0.38439770E-03_JPRB, 0.38382404E-03_JPRB, 0.38332872E-03_JPRB, &
  & 0.38295397E-03_JPRB, 0.38284343E-03_JPRB, 0.38285881E-03_JPRB, 0.38297012E-03_JPRB, 0.38339551E-03_JPRB, 0.38374981E-03_JPRB, &
  & 0.38404119E-03_JPRB, 0.38453480E-03_JPRB, 0.38502105E-03_JPRB, 0.38555928E-03_JPRB, 0.38591815E-03_JPRB, 0.38617839E-03_JPRB, &
  & 0.38657644E-03_JPRB, 0.38667999E-03_JPRB, 0.38654203E-03_JPRB, 0.38656843E-03_JPRB  /)

RGHG1(:,75, 7) = (/ &
  & 0.38415289E-03_JPRB, 0.38417498E-03_JPRB, 0.38418926E-03_JPRB, 0.38429101E-03_JPRB, 0.38441972E-03_JPRB, 0.38444038E-03_JPRB, &
  & 0.38438257E-03_JPRB, 0.38432599E-03_JPRB, 0.38425355E-03_JPRB, 0.38412144E-03_JPRB, 0.38393177E-03_JPRB, 0.38373518E-03_JPRB, &
  & 0.38362252E-03_JPRB, 0.38349414E-03_JPRB, 0.38334025E-03_JPRB, 0.38325401E-03_JPRB, 0.38318145E-03_JPRB, 0.38314609E-03_JPRB, &
  & 0.38312117E-03_JPRB, 0.38307996E-03_JPRB, 0.38295461E-03_JPRB, 0.38286040E-03_JPRB, 0.38276731E-03_JPRB, 0.38271496E-03_JPRB, &
  & 0.38272315E-03_JPRB, 0.38278649E-03_JPRB, 0.38292761E-03_JPRB, 0.38314869E-03_JPRB, 0.38342870E-03_JPRB, 0.38378220E-03_JPRB, &
  & 0.38418283E-03_JPRB, 0.38452315E-03_JPRB, 0.38493699E-03_JPRB, 0.38517186E-03_JPRB, 0.38555004E-03_JPRB, 0.38607068E-03_JPRB, &
  & 0.38632117E-03_JPRB, 0.38631000E-03_JPRB, 0.38622144E-03_JPRB, 0.38611264E-03_JPRB, 0.38603527E-03_JPRB, 0.38588592E-03_JPRB, &
  & 0.38562445E-03_JPRB, 0.38520573E-03_JPRB, 0.38487002E-03_JPRB, 0.38444908E-03_JPRB, 0.38385648E-03_JPRB, 0.38327799E-03_JPRB, &
  & 0.38285969E-03_JPRB, 0.38271343E-03_JPRB, 0.38271682E-03_JPRB, 0.38283035E-03_JPRB, 0.38325814E-03_JPRB, 0.38360984E-03_JPRB, &
  & 0.38394745E-03_JPRB, 0.38446604E-03_JPRB, 0.38503365E-03_JPRB, 0.38563331E-03_JPRB, 0.38600692E-03_JPRB, 0.38631435E-03_JPRB, &
  & 0.38676995E-03_JPRB, 0.38688283E-03_JPRB, 0.38673855E-03_JPRB, 0.38680817E-03_JPRB  /)

RGHG1(:,76, 7) = (/ &
  & 0.38419024E-03_JPRB, 0.38420604E-03_JPRB, 0.38422764E-03_JPRB, 0.38432034E-03_JPRB, 0.38443113E-03_JPRB, 0.38445312E-03_JPRB, &
  & 0.38441501E-03_JPRB, 0.38435884E-03_JPRB, 0.38429533E-03_JPRB, 0.38417965E-03_JPRB, 0.38400461E-03_JPRB, 0.38381373E-03_JPRB, &
  & 0.38370338E-03_JPRB, 0.38358497E-03_JPRB, 0.38344243E-03_JPRB, 0.38335567E-03_JPRB, 0.38328721E-03_JPRB, 0.38326718E-03_JPRB, &
  & 0.38324272E-03_JPRB, 0.38320842E-03_JPRB, 0.38310428E-03_JPRB, 0.38301370E-03_JPRB, 0.38290447E-03_JPRB, 0.38284232E-03_JPRB, &
  & 0.38282395E-03_JPRB, 0.38285709E-03_JPRB, 0.38292853E-03_JPRB, 0.38308685E-03_JPRB, 0.38332738E-03_JPRB, 0.38363656E-03_JPRB, &
  & 0.38402423E-03_JPRB, 0.38434397E-03_JPRB, 0.38475770E-03_JPRB, 0.38501200E-03_JPRB, 0.38543385E-03_JPRB, 0.38601172E-03_JPRB, &
  & 0.38629599E-03_JPRB, 0.38631501E-03_JPRB, 0.38623308E-03_JPRB, 0.38612475E-03_JPRB, 0.38607227E-03_JPRB, 0.38593957E-03_JPRB, &
  & 0.38570652E-03_JPRB, 0.38529327E-03_JPRB, 0.38495105E-03_JPRB, 0.38449876E-03_JPRB, 0.38388593E-03_JPRB, 0.38321419E-03_JPRB, &
  & 0.38275831E-03_JPRB, 0.38258486E-03_JPRB, 0.38256093E-03_JPRB, 0.38267613E-03_JPRB, 0.38309055E-03_JPRB, 0.38342876E-03_JPRB, &
  & 0.38378585E-03_JPRB, 0.38433349E-03_JPRB, 0.38499792E-03_JPRB, 0.38568097E-03_JPRB, 0.38608928E-03_JPRB, 0.38644800E-03_JPRB, &
  & 0.38695247E-03_JPRB, 0.38707549E-03_JPRB, 0.38693132E-03_JPRB, 0.38704215E-03_JPRB  /)

RGHG1(:,77, 7) = (/ &
  & 0.38422290E-03_JPRB, 0.38423782E-03_JPRB, 0.38426363E-03_JPRB, 0.38434721E-03_JPRB, 0.38443954E-03_JPRB, 0.38446315E-03_JPRB, &
  & 0.38443927E-03_JPRB, 0.38438296E-03_JPRB, 0.38432673E-03_JPRB, 0.38422239E-03_JPRB, 0.38406347E-03_JPRB, 0.38388697E-03_JPRB, &
  & 0.38378068E-03_JPRB, 0.38367038E-03_JPRB, 0.38353992E-03_JPRB, 0.38345529E-03_JPRB, 0.38338587E-03_JPRB, 0.38336060E-03_JPRB, &
  & 0.38333722E-03_JPRB, 0.38330756E-03_JPRB, 0.38321789E-03_JPRB, 0.38313160E-03_JPRB, 0.38300972E-03_JPRB, 0.38293797E-03_JPRB, &
  & 0.38289181E-03_JPRB, 0.38289311E-03_JPRB, 0.38292292E-03_JPRB, 0.38304104E-03_JPRB, 0.38326093E-03_JPRB, 0.38356114E-03_JPRB, &
  & 0.38393483E-03_JPRB, 0.38423752E-03_JPRB, 0.38462580E-03_JPRB, 0.38489159E-03_JPRB, 0.38534417E-03_JPRB, 0.38595559E-03_JPRB, &
  & 0.38627111E-03_JPRB, 0.38631660E-03_JPRB, 0.38623430E-03_JPRB, 0.38612998E-03_JPRB, 0.38609322E-03_JPRB, 0.38597963E-03_JPRB, &
  & 0.38577296E-03_JPRB, 0.38537846E-03_JPRB, 0.38503978E-03_JPRB, 0.38456344E-03_JPRB, 0.38392683E-03_JPRB, 0.38316833E-03_JPRB, &
  & 0.38267872E-03_JPRB, 0.38248416E-03_JPRB, 0.38242638E-03_JPRB, 0.38254981E-03_JPRB, 0.38293920E-03_JPRB, 0.38328757E-03_JPRB, &
  & 0.38363054E-03_JPRB, 0.38415647E-03_JPRB, 0.38491367E-03_JPRB, 0.38571263E-03_JPRB, 0.38616577E-03_JPRB, 0.38657862E-03_JPRB, &
  & 0.38713692E-03_JPRB, 0.38729879E-03_JPRB, 0.38716826E-03_JPRB, 0.38735459E-03_JPRB  /)

RGHG1(:,78, 7) = (/ &
  & 0.38425645E-03_JPRB, 0.38427005E-03_JPRB, 0.38429643E-03_JPRB, 0.38437092E-03_JPRB, 0.38444616E-03_JPRB, 0.38447037E-03_JPRB, &
  & 0.38445746E-03_JPRB, 0.38440294E-03_JPRB, 0.38435073E-03_JPRB, 0.38425996E-03_JPRB, 0.38411715E-03_JPRB, 0.38395553E-03_JPRB, &
  & 0.38384643E-03_JPRB, 0.38374349E-03_JPRB, 0.38362223E-03_JPRB, 0.38353494E-03_JPRB, 0.38346456E-03_JPRB, 0.38343023E-03_JPRB, &
  & 0.38340643E-03_JPRB, 0.38338367E-03_JPRB, 0.38330815E-03_JPRB, 0.38322262E-03_JPRB, 0.38309674E-03_JPRB, 0.38301440E-03_JPRB, &
  & 0.38294280E-03_JPRB, 0.38291524E-03_JPRB, 0.38291542E-03_JPRB, 0.38300601E-03_JPRB, 0.38321658E-03_JPRB, 0.38351678E-03_JPRB, &
  & 0.38388041E-03_JPRB, 0.38416810E-03_JPRB, 0.38453011E-03_JPRB, 0.38479968E-03_JPRB, 0.38527677E-03_JPRB, 0.38591054E-03_JPRB, &
  & 0.38625001E-03_JPRB, 0.38631949E-03_JPRB, 0.38623439E-03_JPRB, 0.38612869E-03_JPRB, 0.38609818E-03_JPRB, 0.38600343E-03_JPRB, &
  & 0.38582831E-03_JPRB, 0.38545170E-03_JPRB, 0.38511873E-03_JPRB, 0.38462627E-03_JPRB, 0.38396933E-03_JPRB, 0.38314460E-03_JPRB, &
  & 0.38261666E-03_JPRB, 0.38240159E-03_JPRB, 0.38231621E-03_JPRB, 0.38245627E-03_JPRB, 0.38282626E-03_JPRB, 0.38318420E-03_JPRB, &
  & 0.38350314E-03_JPRB, 0.38400149E-03_JPRB, 0.38481771E-03_JPRB, 0.38572094E-03_JPRB, 0.38623386E-03_JPRB, 0.38669396E-03_JPRB, &
  & 0.38728906E-03_JPRB, 0.38747580E-03_JPRB, 0.38735597E-03_JPRB, 0.38758344E-03_JPRB  /)

RGHG1(:,79, 7) = (/ &
  & 0.38428973E-03_JPRB, 0.38430088E-03_JPRB, 0.38432487E-03_JPRB, 0.38439050E-03_JPRB, 0.38445081E-03_JPRB, 0.38447450E-03_JPRB, &
  & 0.38446902E-03_JPRB, 0.38441876E-03_JPRB, 0.38436798E-03_JPRB, 0.38429224E-03_JPRB, 0.38416369E-03_JPRB, 0.38401362E-03_JPRB, &
  & 0.38389724E-03_JPRB, 0.38380000E-03_JPRB, 0.38368435E-03_JPRB, 0.38359280E-03_JPRB, 0.38352293E-03_JPRB, 0.38348038E-03_JPRB, &
  & 0.38345668E-03_JPRB, 0.38343978E-03_JPRB, 0.38337652E-03_JPRB, 0.38329075E-03_JPRB, 0.38316739E-03_JPRB, 0.38307346E-03_JPRB, &
  & 0.38298013E-03_JPRB, 0.38292925E-03_JPRB, 0.38290992E-03_JPRB, 0.38298303E-03_JPRB, 0.38319146E-03_JPRB, 0.38349349E-03_JPRB, &
  & 0.38384969E-03_JPRB, 0.38412480E-03_JPRB, 0.38446543E-03_JPRB, 0.38473295E-03_JPRB, 0.38522727E-03_JPRB, 0.38587518E-03_JPRB, &
  & 0.38623370E-03_JPRB, 0.38632479E-03_JPRB, 0.38623571E-03_JPRB, 0.38612461E-03_JPRB, 0.38609610E-03_JPRB, 0.38602001E-03_JPRB, &
  & 0.38587636E-03_JPRB, 0.38551468E-03_JPRB, 0.38518821E-03_JPRB, 0.38468504E-03_JPRB, 0.38401167E-03_JPRB, 0.38314199E-03_JPRB, &
  & 0.38257633E-03_JPRB, 0.38234290E-03_JPRB, 0.38223375E-03_JPRB, 0.38239140E-03_JPRB, 0.38274844E-03_JPRB, 0.38310959E-03_JPRB, &
  & 0.38340311E-03_JPRB, 0.38387602E-03_JPRB, 0.38472040E-03_JPRB, 0.38570877E-03_JPRB, 0.38629309E-03_JPRB, 0.38680187E-03_JPRB, &
  & 0.38742187E-03_JPRB, 0.38763373E-03_JPRB, 0.38752925E-03_JPRB, 0.38776645E-03_JPRB  /)

RGHG1(:,80, 7) = (/ &
  & 0.38432108E-03_JPRB, 0.38432832E-03_JPRB, 0.38434785E-03_JPRB, 0.38440504E-03_JPRB, 0.38445325E-03_JPRB, 0.38447533E-03_JPRB, &
  & 0.38447335E-03_JPRB, 0.38443020E-03_JPRB, 0.38437919E-03_JPRB, 0.38431860E-03_JPRB, 0.38420054E-03_JPRB, 0.38405495E-03_JPRB, &
  & 0.38393019E-03_JPRB, 0.38383598E-03_JPRB, 0.38372182E-03_JPRB, 0.38362849E-03_JPRB, 0.38356194E-03_JPRB, 0.38351612E-03_JPRB, &
  & 0.38349540E-03_JPRB, 0.38347928E-03_JPRB, 0.38342425E-03_JPRB, 0.38334041E-03_JPRB, 0.38322315E-03_JPRB, 0.38311677E-03_JPRB, &
  & 0.38300657E-03_JPRB, 0.38294032E-03_JPRB, 0.38291031E-03_JPRB, 0.38297353E-03_JPRB, 0.38318264E-03_JPRB, 0.38348203E-03_JPRB, &
  & 0.38383148E-03_JPRB, 0.38409701E-03_JPRB, 0.38442589E-03_JPRB, 0.38468781E-03_JPRB, 0.38519067E-03_JPRB, 0.38584724E-03_JPRB, &
  & 0.38622297E-03_JPRB, 0.38633336E-03_JPRB, 0.38624022E-03_JPRB, 0.38612179E-03_JPRB, 0.38609711E-03_JPRB, 0.38603984E-03_JPRB, &
  & 0.38592115E-03_JPRB, 0.38557008E-03_JPRB, 0.38524964E-03_JPRB, 0.38473815E-03_JPRB, 0.38405215E-03_JPRB, 0.38315816E-03_JPRB, &
  & 0.38256199E-03_JPRB, 0.38231449E-03_JPRB, 0.38218164E-03_JPRB, 0.38234935E-03_JPRB, 0.38269969E-03_JPRB, 0.38305290E-03_JPRB, &
  & 0.38332780E-03_JPRB, 0.38378341E-03_JPRB, 0.38463096E-03_JPRB, 0.38568014E-03_JPRB, 0.38634310E-03_JPRB, 0.38691174E-03_JPRB, &
  & 0.38755224E-03_JPRB, 0.38780866E-03_JPRB, 0.38773342E-03_JPRB, 0.38795697E-03_JPRB  /)

RGHG1(:,81, 7) = (/ &
  & 0.38434277E-03_JPRB, 0.38434669E-03_JPRB, 0.38436029E-03_JPRB, 0.38441334E-03_JPRB, 0.38445313E-03_JPRB, 0.38447344E-03_JPRB, &
  & 0.38447086E-03_JPRB, 0.38443589E-03_JPRB, 0.38438405E-03_JPRB, 0.38432974E-03_JPRB, 0.38421951E-03_JPRB, 0.38407783E-03_JPRB, &
  & 0.38394501E-03_JPRB, 0.38385043E-03_JPRB, 0.38373782E-03_JPRB, 0.38364686E-03_JPRB, 0.38358576E-03_JPRB, 0.38354030E-03_JPRB, &
  & 0.38352266E-03_JPRB, 0.38350986E-03_JPRB, 0.38345708E-03_JPRB, 0.38337668E-03_JPRB, 0.38326439E-03_JPRB, 0.38314972E-03_JPRB, &
  & 0.38303122E-03_JPRB, 0.38295727E-03_JPRB, 0.38292572E-03_JPRB, 0.38298053E-03_JPRB, 0.38319059E-03_JPRB, 0.38348795E-03_JPRB, &
  & 0.38383776E-03_JPRB, 0.38408800E-03_JPRB, 0.38440823E-03_JPRB, 0.38466138E-03_JPRB, 0.38516045E-03_JPRB, 0.38582187E-03_JPRB, &
  & 0.38621669E-03_JPRB, 0.38634557E-03_JPRB, 0.38625195E-03_JPRB, 0.38613341E-03_JPRB, 0.38611015E-03_JPRB, 0.38606307E-03_JPRB, &
  & 0.38596654E-03_JPRB, 0.38562246E-03_JPRB, 0.38532206E-03_JPRB, 0.38480618E-03_JPRB, 0.38411651E-03_JPRB, 0.38321434E-03_JPRB, &
  & 0.38258545E-03_JPRB, 0.38231911E-03_JPRB, 0.38217512E-03_JPRB, 0.38234698E-03_JPRB, 0.38267445E-03_JPRB, 0.38302149E-03_JPRB, &
  & 0.38327908E-03_JPRB, 0.38372285E-03_JPRB, 0.38456814E-03_JPRB, 0.38566378E-03_JPRB, 0.38639869E-03_JPRB, 0.38703477E-03_JPRB, &
  & 0.38769150E-03_JPRB, 0.38796392E-03_JPRB, 0.38794037E-03_JPRB, 0.38818726E-03_JPRB  /)

RGHG1(:,82, 7) = (/ &
  & 0.38435812E-03_JPRB, 0.38435956E-03_JPRB, 0.38436841E-03_JPRB, 0.38442003E-03_JPRB, 0.38445203E-03_JPRB, 0.38447025E-03_JPRB, &
  & 0.38446569E-03_JPRB, 0.38443689E-03_JPRB, 0.38438578E-03_JPRB, 0.38433640E-03_JPRB, 0.38423157E-03_JPRB, 0.38408986E-03_JPRB, &
  & 0.38395311E-03_JPRB, 0.38385917E-03_JPRB, 0.38374694E-03_JPRB, 0.38365899E-03_JPRB, 0.38360143E-03_JPRB, 0.38355804E-03_JPRB, &
  & 0.38354665E-03_JPRB, 0.38353665E-03_JPRB, 0.38348701E-03_JPRB, 0.38340888E-03_JPRB, 0.38330236E-03_JPRB, 0.38318279E-03_JPRB, &
  & 0.38305776E-03_JPRB, 0.38298154E-03_JPRB, 0.38295630E-03_JPRB, 0.38301018E-03_JPRB, 0.38321799E-03_JPRB, 0.38351491E-03_JPRB, &
  & 0.38386099E-03_JPRB, 0.38408983E-03_JPRB, 0.38438847E-03_JPRB, 0.38463561E-03_JPRB, 0.38512380E-03_JPRB, 0.38579504E-03_JPRB, &
  & 0.38621167E-03_JPRB, 0.38636096E-03_JPRB, 0.38626769E-03_JPRB, 0.38615156E-03_JPRB, 0.38612996E-03_JPRB, 0.38609040E-03_JPRB, &
  & 0.38601132E-03_JPRB, 0.38568081E-03_JPRB, 0.38540994E-03_JPRB, 0.38488489E-03_JPRB, 0.38420153E-03_JPRB, 0.38329523E-03_JPRB, &
  & 0.38264870E-03_JPRB, 0.38236257E-03_JPRB, 0.38220506E-03_JPRB, 0.38238137E-03_JPRB, 0.38268358E-03_JPRB, 0.38302417E-03_JPRB, &
  & 0.38327217E-03_JPRB, 0.38369656E-03_JPRB, 0.38453022E-03_JPRB, 0.38568493E-03_JPRB, 0.38648421E-03_JPRB, 0.38719359E-03_JPRB, &
  & 0.38785225E-03_JPRB, 0.38815405E-03_JPRB, 0.38819866E-03_JPRB, 0.38846990E-03_JPRB  /)

RGHG1(:,83, 7) = (/ &
  & 0.38437007E-03_JPRB, 0.38436850E-03_JPRB, 0.38437420E-03_JPRB, 0.38442540E-03_JPRB, 0.38445006E-03_JPRB, 0.38446610E-03_JPRB, &
  & 0.38445911E-03_JPRB, 0.38443543E-03_JPRB, 0.38438550E-03_JPRB, 0.38434013E-03_JPRB, 0.38423916E-03_JPRB, 0.38409488E-03_JPRB, &
  & 0.38395680E-03_JPRB, 0.38386368E-03_JPRB, 0.38375116E-03_JPRB, 0.38366666E-03_JPRB, 0.38361128E-03_JPRB, 0.38357070E-03_JPRB, &
  & 0.38356884E-03_JPRB, 0.38356168E-03_JPRB, 0.38351627E-03_JPRB, 0.38343853E-03_JPRB, 0.38333949E-03_JPRB, 0.38321916E-03_JPRB, &
  & 0.38309067E-03_JPRB, 0.38301837E-03_JPRB, 0.38300753E-03_JPRB, 0.38306921E-03_JPRB, 0.38327015E-03_JPRB, 0.38356513E-03_JPRB, &
  & 0.38390603E-03_JPRB, 0.38411139E-03_JPRB, 0.38437348E-03_JPRB, 0.38460950E-03_JPRB, 0.38509198E-03_JPRB, 0.38577518E-03_JPRB, &
  & 0.38621261E-03_JPRB, 0.38637911E-03_JPRB, 0.38628812E-03_JPRB, 0.38617798E-03_JPRB, 0.38615727E-03_JPRB, 0.38612190E-03_JPRB, &
  & 0.38605626E-03_JPRB, 0.38575304E-03_JPRB, 0.38552252E-03_JPRB, 0.38498920E-03_JPRB, 0.38431764E-03_JPRB, 0.38341195E-03_JPRB, &
  & 0.38275236E-03_JPRB, 0.38244972E-03_JPRB, 0.38227900E-03_JPRB, 0.38246361E-03_JPRB, 0.38273799E-03_JPRB, 0.38306905E-03_JPRB, &
  & 0.38331059E-03_JPRB, 0.38370706E-03_JPRB, 0.38452182E-03_JPRB, 0.38573768E-03_JPRB, 0.38659511E-03_JPRB, 0.38737265E-03_JPRB, &
  & 0.38801966E-03_JPRB, 0.38833966E-03_JPRB, 0.38844101E-03_JPRB, 0.38871219E-03_JPRB  /)

RGHG1(:,84, 7) = (/ &
  & 0.38438110E-03_JPRB, 0.38437494E-03_JPRB, 0.38437921E-03_JPRB, 0.38442967E-03_JPRB, 0.38444743E-03_JPRB, 0.38446143E-03_JPRB, &
  & 0.38445241E-03_JPRB, 0.38443345E-03_JPRB, 0.38438427E-03_JPRB, 0.38434231E-03_JPRB, 0.38424439E-03_JPRB, 0.38409628E-03_JPRB, &
  & 0.38395810E-03_JPRB, 0.38386539E-03_JPRB, 0.38375230E-03_JPRB, 0.38367157E-03_JPRB, 0.38361764E-03_JPRB, 0.38357974E-03_JPRB, &
  & 0.38359043E-03_JPRB, 0.38358681E-03_JPRB, 0.38354690E-03_JPRB, 0.38346747E-03_JPRB, 0.38337806E-03_JPRB, 0.38326159E-03_JPRB, &
  & 0.38313374E-03_JPRB, 0.38307157E-03_JPRB, 0.38308253E-03_JPRB, 0.38316093E-03_JPRB, 0.38334935E-03_JPRB, 0.38363934E-03_JPRB, &
  & 0.38397586E-03_JPRB, 0.38415868E-03_JPRB, 0.38436970E-03_JPRB, 0.38458493E-03_JPRB, 0.38507515E-03_JPRB, 0.38576977E-03_JPRB, &
  & 0.38622363E-03_JPRB, 0.38639990E-03_JPRB, 0.38631346E-03_JPRB, 0.38621332E-03_JPRB, 0.38619245E-03_JPRB, 0.38615856E-03_JPRB, &
  & 0.38610334E-03_JPRB, 0.38584538E-03_JPRB, 0.38566605E-03_JPRB, 0.38512925E-03_JPRB, 0.38447309E-03_JPRB, 0.38357208E-03_JPRB, &
  & 0.38289572E-03_JPRB, 0.38258292E-03_JPRB, 0.38240190E-03_JPRB, 0.38260072E-03_JPRB, 0.38284501E-03_JPRB, 0.38316112E-03_JPRB, &
  & 0.38339508E-03_JPRB, 0.38375433E-03_JPRB, 0.38454505E-03_JPRB, 0.38581420E-03_JPRB, 0.38672297E-03_JPRB, 0.38755421E-03_JPRB, &
  & 0.38817880E-03_JPRB, 0.38848999E-03_JPRB, 0.38861713E-03_JPRB, 0.38885210E-03_JPRB  /)

RGHG1(:,85, 7) = (/ &
  & 0.38439400E-03_JPRB, 0.38437972E-03_JPRB, 0.38438363E-03_JPRB, 0.38443242E-03_JPRB, 0.38444492E-03_JPRB, 0.38445724E-03_JPRB, &
  & 0.38444858E-03_JPRB, 0.38443285E-03_JPRB, 0.38438355E-03_JPRB, 0.38434446E-03_JPRB, 0.38424881E-03_JPRB, 0.38409616E-03_JPRB, &
  & 0.38395810E-03_JPRB, 0.38386503E-03_JPRB, 0.38375146E-03_JPRB, 0.38367599E-03_JPRB, 0.38362457E-03_JPRB, 0.38358835E-03_JPRB, &
  & 0.38361385E-03_JPRB, 0.38361883E-03_JPRB, 0.38358788E-03_JPRB, 0.38350726E-03_JPRB, 0.38342920E-03_JPRB, 0.38332479E-03_JPRB, &
  & 0.38320603E-03_JPRB, 0.38315962E-03_JPRB, 0.38319771E-03_JPRB, 0.38330108E-03_JPRB, 0.38346608E-03_JPRB, 0.38375559E-03_JPRB, &
  & 0.38409116E-03_JPRB, 0.38424913E-03_JPRB, 0.38440220E-03_JPRB, 0.38459652E-03_JPRB, 0.38510431E-03_JPRB, 0.38580394E-03_JPRB, &
  & 0.38626162E-03_JPRB, 0.38643168E-03_JPRB, 0.38634728E-03_JPRB, 0.38626088E-03_JPRB, 0.38624455E-03_JPRB, 0.38622284E-03_JPRB, &
  & 0.38617933E-03_JPRB, 0.38598863E-03_JPRB, 0.38587454E-03_JPRB, 0.38533559E-03_JPRB, 0.38472579E-03_JPRB, 0.38382167E-03_JPRB, &
  & 0.38311759E-03_JPRB, 0.38280288E-03_JPRB, 0.38262293E-03_JPRB, 0.38283920E-03_JPRB, 0.38305159E-03_JPRB, 0.38333783E-03_JPRB, &
  & 0.38355160E-03_JPRB, 0.38385171E-03_JPRB, 0.38461232E-03_JPRB, 0.38590225E-03_JPRB, 0.38683373E-03_JPRB, 0.38768731E-03_JPRB, &
  & 0.38829624E-03_JPRB, 0.38859011E-03_JPRB, 0.38871702E-03_JPRB, 0.38895114E-03_JPRB  /)

RGHG1(:,86, 7) = (/ &
  & 0.38440762E-03_JPRB, 0.38438443E-03_JPRB, 0.38438751E-03_JPRB, 0.38443471E-03_JPRB, 0.38444352E-03_JPRB, 0.38445557E-03_JPRB, &
  & 0.38444811E-03_JPRB, 0.38443272E-03_JPRB, 0.38438367E-03_JPRB, 0.38434587E-03_JPRB, 0.38425129E-03_JPRB, 0.38409585E-03_JPRB, &
  & 0.38395819E-03_JPRB, 0.38386458E-03_JPRB, 0.38375034E-03_JPRB, 0.38368071E-03_JPRB, 0.38363191E-03_JPRB, 0.38359643E-03_JPRB, &
  & 0.38363954E-03_JPRB, 0.38365643E-03_JPRB, 0.38364160E-03_JPRB, 0.38356024E-03_JPRB, 0.38349733E-03_JPRB, 0.38341019E-03_JPRB, &
  & 0.38330598E-03_JPRB, 0.38327131E-03_JPRB, 0.38334647E-03_JPRB, 0.38348298E-03_JPRB, 0.38363791E-03_JPRB, 0.38394993E-03_JPRB, &
  & 0.38428043E-03_JPRB, 0.38440594E-03_JPRB, 0.38450611E-03_JPRB, 0.38467707E-03_JPRB, 0.38520018E-03_JPRB, 0.38589849E-03_JPRB, &
  & 0.38633300E-03_JPRB, 0.38648410E-03_JPRB, 0.38640370E-03_JPRB, 0.38632353E-03_JPRB, 0.38632177E-03_JPRB, 0.38631698E-03_JPRB, &
  & 0.38629151E-03_JPRB, 0.38618749E-03_JPRB, 0.38614401E-03_JPRB, 0.38559486E-03_JPRB, 0.38506821E-03_JPRB, 0.38415554E-03_JPRB, &
  & 0.38343800E-03_JPRB, 0.38312988E-03_JPRB, 0.38296859E-03_JPRB, 0.38318780E-03_JPRB, 0.38334878E-03_JPRB, 0.38357854E-03_JPRB, &
  & 0.38376959E-03_JPRB, 0.38399548E-03_JPRB, 0.38470451E-03_JPRB, 0.38599440E-03_JPRB, 0.38691924E-03_JPRB, 0.38778181E-03_JPRB, &
  & 0.38837436E-03_JPRB, 0.38864287E-03_JPRB, 0.38876309E-03_JPRB, 0.38899347E-03_JPRB  /)

RGHG1(:,87, 7) = (/ &
  & 0.38442065E-03_JPRB, 0.38438919E-03_JPRB, 0.38439017E-03_JPRB, 0.38443672E-03_JPRB, 0.38444305E-03_JPRB, 0.38445521E-03_JPRB, &
  & 0.38444916E-03_JPRB, 0.38443284E-03_JPRB, 0.38438422E-03_JPRB, 0.38434709E-03_JPRB, 0.38425275E-03_JPRB, 0.38409536E-03_JPRB, &
  & 0.38395844E-03_JPRB, 0.38386421E-03_JPRB, 0.38374937E-03_JPRB, 0.38368665E-03_JPRB, 0.38363947E-03_JPRB, 0.38360622E-03_JPRB, &
  & 0.38367116E-03_JPRB, 0.38370285E-03_JPRB, 0.38370874E-03_JPRB, 0.38363268E-03_JPRB, 0.38358767E-03_JPRB, 0.38352205E-03_JPRB, &
  & 0.38344781E-03_JPRB, 0.38342493E-03_JPRB, 0.38354015E-03_JPRB, 0.38371469E-03_JPRB, 0.38387828E-03_JPRB, 0.38425406E-03_JPRB, &
  & 0.38456850E-03_JPRB, 0.38466698E-03_JPRB, 0.38471899E-03_JPRB, 0.38484708E-03_JPRB, 0.38537641E-03_JPRB, 0.38605487E-03_JPRB, &
  & 0.38642292E-03_JPRB, 0.38655881E-03_JPRB, 0.38648305E-03_JPRB, 0.38641051E-03_JPRB, 0.38643640E-03_JPRB, 0.38644461E-03_JPRB, &
  & 0.38644710E-03_JPRB, 0.38646333E-03_JPRB, 0.38649022E-03_JPRB, 0.38592023E-03_JPRB, 0.38550235E-03_JPRB, 0.38458105E-03_JPRB, &
  & 0.38388170E-03_JPRB, 0.38358503E-03_JPRB, 0.38348082E-03_JPRB, 0.38368338E-03_JPRB, 0.38377098E-03_JPRB, 0.38390474E-03_JPRB, &
  & 0.38406472E-03_JPRB, 0.38418701E-03_JPRB, 0.38482499E-03_JPRB, 0.38608431E-03_JPRB, 0.38698438E-03_JPRB, 0.38784472E-03_JPRB, &
  & 0.38841522E-03_JPRB, 0.38866775E-03_JPRB, 0.38878479E-03_JPRB, 0.38901209E-03_JPRB  /)

RGHG1(:,88, 7) = (/ &
  & 0.38443253E-03_JPRB, 0.38439413E-03_JPRB, 0.38439158E-03_JPRB, 0.38443823E-03_JPRB, 0.38444321E-03_JPRB, 0.38445539E-03_JPRB, &
  & 0.38445038E-03_JPRB, 0.38443299E-03_JPRB, 0.38438495E-03_JPRB, 0.38434826E-03_JPRB, 0.38425362E-03_JPRB, 0.38409469E-03_JPRB, &
  & 0.38395904E-03_JPRB, 0.38386403E-03_JPRB, 0.38374868E-03_JPRB, 0.38369500E-03_JPRB, 0.38364809E-03_JPRB, 0.38361955E-03_JPRB, &
  & 0.38371350E-03_JPRB, 0.38376317E-03_JPRB, 0.38379704E-03_JPRB, 0.38373457E-03_JPRB, 0.38371166E-03_JPRB, 0.38367942E-03_JPRB, &
  & 0.38365693E-03_JPRB, 0.38365431E-03_JPRB, 0.38380982E-03_JPRB, 0.38403664E-03_JPRB, 0.38424533E-03_JPRB, 0.38472095E-03_JPRB, &
  & 0.38500883E-03_JPRB, 0.38509264E-03_JPRB, 0.38511278E-03_JPRB, 0.38514932E-03_JPRB, 0.38565841E-03_JPRB, 0.38627710E-03_JPRB, &
  & 0.38652837E-03_JPRB, 0.38665586E-03_JPRB, 0.38659032E-03_JPRB, 0.38653745E-03_JPRB, 0.38660229E-03_JPRB, 0.38662182E-03_JPRB, &
  & 0.38667303E-03_JPRB, 0.38684973E-03_JPRB, 0.38694016E-03_JPRB, 0.38635181E-03_JPRB, 0.38607796E-03_JPRB, 0.38515293E-03_JPRB, &
  & 0.38452065E-03_JPRB, 0.38425083E-03_JPRB, 0.38424811E-03_JPRB, 0.38441952E-03_JPRB, 0.38439790E-03_JPRB, 0.38437859E-03_JPRB, &
  & 0.38449702E-03_JPRB, 0.38446311E-03_JPRB, 0.38499597E-03_JPRB, 0.38617483E-03_JPRB, 0.38703251E-03_JPRB, 0.38788029E-03_JPRB, &
  & 0.38842699E-03_JPRB, 0.38867636E-03_JPRB, 0.38879557E-03_JPRB, 0.38902107E-03_JPRB  /)

RGHG1(:,89, 7) = (/ &
  & 0.38444244E-03_JPRB, 0.38439887E-03_JPRB, 0.38439224E-03_JPRB, 0.38443864E-03_JPRB, 0.38444320E-03_JPRB, 0.38445527E-03_JPRB, &
  & 0.38445044E-03_JPRB, 0.38443287E-03_JPRB, 0.38438562E-03_JPRB, 0.38434916E-03_JPRB, 0.38425412E-03_JPRB, 0.38409387E-03_JPRB, &
  & 0.38396021E-03_JPRB, 0.38386412E-03_JPRB, 0.38374821E-03_JPRB, 0.38370666E-03_JPRB, 0.38365974E-03_JPRB, 0.38363662E-03_JPRB, &
  & 0.38377016E-03_JPRB, 0.38384124E-03_JPRB, 0.38391873E-03_JPRB, 0.38387848E-03_JPRB, 0.38388481E-03_JPRB, 0.38391958E-03_JPRB, &
  & 0.38396433E-03_JPRB, 0.38400467E-03_JPRB, 0.38420427E-03_JPRB, 0.38452789E-03_JPRB, 0.38483016E-03_JPRB, 0.38541453E-03_JPRB, &
  & 0.38568087E-03_JPRB, 0.38573957E-03_JPRB, 0.38578092E-03_JPRB, 0.38564800E-03_JPRB, 0.38607465E-03_JPRB, 0.38655478E-03_JPRB, &
  & 0.38665052E-03_JPRB, 0.38676551E-03_JPRB, 0.38673101E-03_JPRB, 0.38671851E-03_JPRB, 0.38682349E-03_JPRB, 0.38686755E-03_JPRB, &
  & 0.38700676E-03_JPRB, 0.38737748E-03_JPRB, 0.38751816E-03_JPRB, 0.38695625E-03_JPRB, 0.38687841E-03_JPRB, 0.38597646E-03_JPRB, &
  & 0.38548939E-03_JPRB, 0.38529223E-03_JPRB, 0.38540177E-03_JPRB, 0.38554338E-03_JPRB, 0.38534826E-03_JPRB, 0.38510867E-03_JPRB, &
  & 0.38517489E-03_JPRB, 0.38489702E-03_JPRB, 0.38524859E-03_JPRB, 0.38626940E-03_JPRB, 0.38706569E-03_JPRB, 0.38789252E-03_JPRB, &
  & 0.38842837E-03_JPRB, 0.38867859E-03_JPRB, 0.38879999E-03_JPRB, 0.38902346E-03_JPRB  /)

RGHG1(:,90, 7) = (/ &
  & 0.38444901E-03_JPRB, 0.38440133E-03_JPRB, 0.38439197E-03_JPRB, 0.38443823E-03_JPRB, 0.38444122E-03_JPRB, 0.38445430E-03_JPRB, &
  & 0.38445003E-03_JPRB, 0.38443288E-03_JPRB, 0.38438633E-03_JPRB, 0.38434985E-03_JPRB, 0.38425439E-03_JPRB, 0.38409287E-03_JPRB, &
  & 0.38396121E-03_JPRB, 0.38386489E-03_JPRB, 0.38374817E-03_JPRB, 0.38372022E-03_JPRB, 0.38367805E-03_JPRB, 0.38365265E-03_JPRB, &
  & 0.38384092E-03_JPRB, 0.38393911E-03_JPRB, 0.38409138E-03_JPRB, 0.38409524E-03_JPRB, 0.38414037E-03_JPRB, 0.38431571E-03_JPRB, &
  & 0.38440334E-03_JPRB, 0.38452288E-03_JPRB, 0.38480999E-03_JPRB, 0.38533697E-03_JPRB, 0.38568125E-03_JPRB, 0.38643531E-03_JPRB, &
  & 0.38672323E-03_JPRB, 0.38658537E-03_JPRB, 0.38678070E-03_JPRB, 0.38645919E-03_JPRB, 0.38668542E-03_JPRB, 0.38688507E-03_JPRB, &
  & 0.38679903E-03_JPRB, 0.38688017E-03_JPRB, 0.38692449E-03_JPRB, 0.38694315E-03_JPRB, 0.38708541E-03_JPRB, 0.38718661E-03_JPRB, &
  & 0.38746943E-03_JPRB, 0.38808700E-03_JPRB, 0.38830477E-03_JPRB, 0.38788624E-03_JPRB, 0.38803129E-03_JPRB, 0.38730053E-03_JPRB, &
  & 0.38714580E-03_JPRB, 0.38710710E-03_JPRB, 0.38720440E-03_JPRB, 0.38729249E-03_JPRB, 0.38680212E-03_JPRB, 0.38629467E-03_JPRB, &
  & 0.38628151E-03_JPRB, 0.38560042E-03_JPRB, 0.38558263E-03_JPRB, 0.38634405E-03_JPRB, 0.38708352E-03_JPRB, 0.38788357E-03_JPRB, &
  & 0.38842442E-03_JPRB, 0.38867872E-03_JPRB, 0.38880177E-03_JPRB, 0.38902482E-03_JPRB  /)

RGHG1(:,91, 7) = (/ &
  & 0.38445064E-03_JPRB, 0.38440193E-03_JPRB, 0.38439197E-03_JPRB, 0.38443808E-03_JPRB, 0.38443885E-03_JPRB, 0.38445356E-03_JPRB, &
  & 0.38445003E-03_JPRB, 0.38443303E-03_JPRB, 0.38438737E-03_JPRB, 0.38435030E-03_JPRB, 0.38425424E-03_JPRB, 0.38409154E-03_JPRB, &
  & 0.38396285E-03_JPRB, 0.38386771E-03_JPRB, 0.38374683E-03_JPRB, 0.38374101E-03_JPRB, 0.38370731E-03_JPRB, 0.38368264E-03_JPRB, &
  & 0.38398629E-03_JPRB, 0.38411299E-03_JPRB, 0.38436592E-03_JPRB, 0.38450580E-03_JPRB, 0.38459251E-03_JPRB, 0.38482814E-03_JPRB, &
  & 0.38501688E-03_JPRB, 0.38539805E-03_JPRB, 0.38596030E-03_JPRB, 0.38654891E-03_JPRB, 0.38693268E-03_JPRB, 0.38793263E-03_JPRB, &
  & 0.38824149E-03_JPRB, 0.38785833E-03_JPRB, 0.38857425E-03_JPRB, 0.38791241E-03_JPRB, 0.38755836E-03_JPRB, 0.38729117E-03_JPRB, &
  & 0.38694662E-03_JPRB, 0.38703104E-03_JPRB, 0.38719236E-03_JPRB, 0.38719558E-03_JPRB, 0.38737421E-03_JPRB, 0.38759406E-03_JPRB, &
  & 0.38807955E-03_JPRB, 0.38898207E-03_JPRB, 0.38943341E-03_JPRB, 0.38937718E-03_JPRB, 0.38965126E-03_JPRB, 0.38983725E-03_JPRB, &
  & 0.39066638E-03_JPRB, 0.39071632E-03_JPRB, 0.39027908E-03_JPRB, 0.39002477E-03_JPRB, 0.38914937E-03_JPRB, 0.38822586E-03_JPRB, &
  & 0.38830491E-03_JPRB, 0.38682008E-03_JPRB, 0.38614124E-03_JPRB, 0.38633856E-03_JPRB, 0.38707194E-03_JPRB, 0.38785818E-03_JPRB, &
  & 0.38841982E-03_JPRB, 0.38867858E-03_JPRB, 0.38880252E-03_JPRB, 0.38902512E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ---GEMS----

RGHG1(:, 1, 8) = (/ &
  & 0.37347008E-03_JPRB, 0.37347035E-03_JPRB, 0.37347246E-03_JPRB, 0.37347452E-03_JPRB, 0.37347701E-03_JPRB, 0.37347969E-03_JPRB, &
  & 0.37348119E-03_JPRB, 0.37348341E-03_JPRB, 0.37348601E-03_JPRB, 0.37348847E-03_JPRB, 0.37348893E-03_JPRB, 0.37348912E-03_JPRB, &
  & 0.37349084E-03_JPRB, 0.37349245E-03_JPRB, 0.37349325E-03_JPRB, 0.37349436E-03_JPRB, 0.37349647E-03_JPRB, 0.37349697E-03_JPRB, &
  & 0.37349210E-03_JPRB, 0.37348644E-03_JPRB, 0.37348379E-03_JPRB, 0.37348215E-03_JPRB, 0.37347897E-03_JPRB, 0.37347226E-03_JPRB, &
  & 0.37346154E-03_JPRB, 0.37344155E-03_JPRB, 0.37341573E-03_JPRB, 0.37338172E-03_JPRB, 0.37333974E-03_JPRB, 0.37329091E-03_JPRB, &
  & 0.37323595E-03_JPRB, 0.37318057E-03_JPRB, 0.37311710E-03_JPRB, 0.37304502E-03_JPRB, 0.37296846E-03_JPRB, 0.37288328E-03_JPRB, &
  & 0.37278511E-03_JPRB, 0.37267894E-03_JPRB, 0.37257120E-03_JPRB, 0.37246454E-03_JPRB, 0.37237238E-03_JPRB, 0.37228923E-03_JPRB, &
  & 0.37219984E-03_JPRB, 0.37210482E-03_JPRB, 0.37201918E-03_JPRB, 0.37194081E-03_JPRB, 0.37185969E-03_JPRB, 0.37177666E-03_JPRB, &
  & 0.37169764E-03_JPRB, 0.37162422E-03_JPRB, 0.37155777E-03_JPRB, 0.37149595E-03_JPRB, 0.37143904E-03_JPRB, 0.37138672E-03_JPRB, &
  & 0.37134099E-03_JPRB, 0.37130249E-03_JPRB, 0.37127281E-03_JPRB, 0.37125217E-03_JPRB, 0.37123834E-03_JPRB, 0.37122938E-03_JPRB, &
  & 0.37122808E-03_JPRB, 0.37123455E-03_JPRB, 0.37124665E-03_JPRB, 0.37125699E-03_JPRB  /)

RGHG1(:, 2, 8) = (/ &
  & 0.37347008E-03_JPRB, 0.37347035E-03_JPRB, 0.37347246E-03_JPRB, 0.37347452E-03_JPRB, 0.37347701E-03_JPRB, 0.37347969E-03_JPRB, &
  & 0.37348119E-03_JPRB, 0.37348341E-03_JPRB, 0.37348601E-03_JPRB, 0.37348847E-03_JPRB, 0.37348893E-03_JPRB, 0.37348912E-03_JPRB, &
  & 0.37349084E-03_JPRB, 0.37349245E-03_JPRB, 0.37349325E-03_JPRB, 0.37349436E-03_JPRB, 0.37349647E-03_JPRB, 0.37349697E-03_JPRB, &
  & 0.37349210E-03_JPRB, 0.37348644E-03_JPRB, 0.37348379E-03_JPRB, 0.37348215E-03_JPRB, 0.37347897E-03_JPRB, 0.37347226E-03_JPRB, &
  & 0.37346154E-03_JPRB, 0.37344155E-03_JPRB, 0.37341573E-03_JPRB, 0.37338172E-03_JPRB, 0.37333974E-03_JPRB, 0.37329091E-03_JPRB, &
  & 0.37323595E-03_JPRB, 0.37318057E-03_JPRB, 0.37311710E-03_JPRB, 0.37304502E-03_JPRB, 0.37296846E-03_JPRB, 0.37288328E-03_JPRB, &
  & 0.37278511E-03_JPRB, 0.37267894E-03_JPRB, 0.37257120E-03_JPRB, 0.37246454E-03_JPRB, 0.37237238E-03_JPRB, 0.37228923E-03_JPRB, &
  & 0.37219984E-03_JPRB, 0.37210482E-03_JPRB, 0.37201918E-03_JPRB, 0.37194081E-03_JPRB, 0.37185969E-03_JPRB, 0.37177666E-03_JPRB, &
  & 0.37169764E-03_JPRB, 0.37162422E-03_JPRB, 0.37155777E-03_JPRB, 0.37149595E-03_JPRB, 0.37143904E-03_JPRB, 0.37138672E-03_JPRB, &
  & 0.37134099E-03_JPRB, 0.37130249E-03_JPRB, 0.37127281E-03_JPRB, 0.37125217E-03_JPRB, 0.37123834E-03_JPRB, 0.37122938E-03_JPRB, &
  & 0.37122808E-03_JPRB, 0.37123455E-03_JPRB, 0.37124665E-03_JPRB, 0.37125699E-03_JPRB  /)

RGHG1(:, 3, 8) = (/ &
  & 0.37347008E-03_JPRB, 0.37347035E-03_JPRB, 0.37347246E-03_JPRB, 0.37347452E-03_JPRB, 0.37347701E-03_JPRB, 0.37347969E-03_JPRB, &
  & 0.37348119E-03_JPRB, 0.37348341E-03_JPRB, 0.37348601E-03_JPRB, 0.37348847E-03_JPRB, 0.37348893E-03_JPRB, 0.37348912E-03_JPRB, &
  & 0.37349084E-03_JPRB, 0.37349245E-03_JPRB, 0.37349325E-03_JPRB, 0.37349436E-03_JPRB, 0.37349647E-03_JPRB, 0.37349697E-03_JPRB, &
  & 0.37349210E-03_JPRB, 0.37348644E-03_JPRB, 0.37348379E-03_JPRB, 0.37348215E-03_JPRB, 0.37347897E-03_JPRB, 0.37347226E-03_JPRB, &
  & 0.37346154E-03_JPRB, 0.37344155E-03_JPRB, 0.37341573E-03_JPRB, 0.37338172E-03_JPRB, 0.37333974E-03_JPRB, 0.37329091E-03_JPRB, &
  & 0.37323595E-03_JPRB, 0.37318057E-03_JPRB, 0.37311710E-03_JPRB, 0.37304502E-03_JPRB, 0.37296846E-03_JPRB, 0.37288328E-03_JPRB, &
  & 0.37278511E-03_JPRB, 0.37267894E-03_JPRB, 0.37257120E-03_JPRB, 0.37246454E-03_JPRB, 0.37237238E-03_JPRB, 0.37228923E-03_JPRB, &
  & 0.37219984E-03_JPRB, 0.37210482E-03_JPRB, 0.37201918E-03_JPRB, 0.37194081E-03_JPRB, 0.37185969E-03_JPRB, 0.37177666E-03_JPRB, &
  & 0.37169764E-03_JPRB, 0.37162422E-03_JPRB, 0.37155777E-03_JPRB, 0.37149595E-03_JPRB, 0.37143904E-03_JPRB, 0.37138672E-03_JPRB, &
  & 0.37134099E-03_JPRB, 0.37130249E-03_JPRB, 0.37127281E-03_JPRB, 0.37125217E-03_JPRB, 0.37123834E-03_JPRB, 0.37122938E-03_JPRB, &
  & 0.37122808E-03_JPRB, 0.37123455E-03_JPRB, 0.37124665E-03_JPRB, 0.37125699E-03_JPRB  /)

RGHG1(:, 4, 8) = (/ &
  & 0.37346997E-03_JPRB, 0.37347025E-03_JPRB, 0.37347235E-03_JPRB, 0.37347444E-03_JPRB, 0.37347694E-03_JPRB, 0.37347963E-03_JPRB, &
  & 0.37348114E-03_JPRB, 0.37348339E-03_JPRB, 0.37348601E-03_JPRB, 0.37348848E-03_JPRB, 0.37348898E-03_JPRB, 0.37348922E-03_JPRB, &
  & 0.37349100E-03_JPRB, 0.37349267E-03_JPRB, 0.37349356E-03_JPRB, 0.37349476E-03_JPRB, 0.37349695E-03_JPRB, 0.37349754E-03_JPRB, &
  & 0.37349281E-03_JPRB, 0.37348726E-03_JPRB, 0.37348470E-03_JPRB, 0.37348310E-03_JPRB, 0.37347996E-03_JPRB, 0.37347331E-03_JPRB, &
  & 0.37346263E-03_JPRB, 0.37344272E-03_JPRB, 0.37341700E-03_JPRB, 0.37338313E-03_JPRB, 0.37334136E-03_JPRB, 0.37329280E-03_JPRB, &
  & 0.37323811E-03_JPRB, 0.37318290E-03_JPRB, 0.37311959E-03_JPRB, 0.37304762E-03_JPRB, 0.37297113E-03_JPRB, 0.37288608E-03_JPRB, &
  & 0.37278810E-03_JPRB, 0.37268204E-03_JPRB, 0.37257421E-03_JPRB, 0.37246733E-03_JPRB, 0.37237493E-03_JPRB, 0.37229157E-03_JPRB, &
  & 0.37220207E-03_JPRB, 0.37210702E-03_JPRB, 0.37202128E-03_JPRB, 0.37194278E-03_JPRB, 0.37186157E-03_JPRB, 0.37177848E-03_JPRB, &
  & 0.37169939E-03_JPRB, 0.37162582E-03_JPRB, 0.37155914E-03_JPRB, 0.37149704E-03_JPRB, 0.37143980E-03_JPRB, 0.37138722E-03_JPRB, &
  & 0.37134128E-03_JPRB, 0.37130260E-03_JPRB, 0.37127277E-03_JPRB, 0.37125199E-03_JPRB, 0.37123805E-03_JPRB, 0.37122902E-03_JPRB, &
  & 0.37122767E-03_JPRB, 0.37123409E-03_JPRB, 0.37124612E-03_JPRB, 0.37125641E-03_JPRB  /)

RGHG1(:, 5, 8) = (/ &
  & 0.37346476E-03_JPRB, 0.37346531E-03_JPRB, 0.37346752E-03_JPRB, 0.37347021E-03_JPRB, 0.37347332E-03_JPRB, 0.37347658E-03_JPRB, &
  & 0.37347909E-03_JPRB, 0.37348227E-03_JPRB, 0.37348600E-03_JPRB, 0.37348926E-03_JPRB, 0.37349152E-03_JPRB, 0.37349401E-03_JPRB, &
  & 0.37349839E-03_JPRB, 0.37350324E-03_JPRB, 0.37350813E-03_JPRB, 0.37351365E-03_JPRB, 0.37351977E-03_JPRB, 0.37352488E-03_JPRB, &
  & 0.37352634E-03_JPRB, 0.37352629E-03_JPRB, 0.37352759E-03_JPRB, 0.37352848E-03_JPRB, 0.37352690E-03_JPRB, 0.37352274E-03_JPRB, &
  & 0.37351460E-03_JPRB, 0.37349825E-03_JPRB, 0.37347717E-03_JPRB, 0.37344989E-03_JPRB, 0.37341792E-03_JPRB, 0.37338253E-03_JPRB, &
  & 0.37334043E-03_JPRB, 0.37329359E-03_JPRB, 0.37323777E-03_JPRB, 0.37317092E-03_JPRB, 0.37309781E-03_JPRB, 0.37301919E-03_JPRB, &
  & 0.37292995E-03_JPRB, 0.37282891E-03_JPRB, 0.37271716E-03_JPRB, 0.37260011E-03_JPRB, 0.37249572E-03_JPRB, 0.37240247E-03_JPRB, &
  & 0.37230798E-03_JPRB, 0.37221141E-03_JPRB, 0.37212117E-03_JPRB, 0.37203600E-03_JPRB, 0.37195047E-03_JPRB, 0.37186505E-03_JPRB, &
  & 0.37178235E-03_JPRB, 0.37170161E-03_JPRB, 0.37162441E-03_JPRB, 0.37154874E-03_JPRB, 0.37147628E-03_JPRB, 0.37141123E-03_JPRB, &
  & 0.37135501E-03_JPRB, 0.37130769E-03_JPRB, 0.37127057E-03_JPRB, 0.37124332E-03_JPRB, 0.37122429E-03_JPRB, 0.37121203E-03_JPRB, &
  & 0.37120835E-03_JPRB, 0.37121228E-03_JPRB, 0.37122104E-03_JPRB, 0.37122866E-03_JPRB  /)

RGHG1(:, 6, 8) = (/ &
  & 0.37345693E-03_JPRB, 0.37345791E-03_JPRB, 0.37346026E-03_JPRB, 0.37346388E-03_JPRB, 0.37346788E-03_JPRB, 0.37347201E-03_JPRB, &
  & 0.37347601E-03_JPRB, 0.37348059E-03_JPRB, 0.37348598E-03_JPRB, 0.37349044E-03_JPRB, 0.37349534E-03_JPRB, 0.37350121E-03_JPRB, &
  & 0.37350949E-03_JPRB, 0.37351910E-03_JPRB, 0.37352999E-03_JPRB, 0.37354199E-03_JPRB, 0.37355400E-03_JPRB, 0.37356589E-03_JPRB, &
  & 0.37357664E-03_JPRB, 0.37358486E-03_JPRB, 0.37359194E-03_JPRB, 0.37359657E-03_JPRB, 0.37359734E-03_JPRB, 0.37359691E-03_JPRB, &
  & 0.37359257E-03_JPRB, 0.37358157E-03_JPRB, 0.37356746E-03_JPRB, 0.37355005E-03_JPRB, 0.37353278E-03_JPRB, 0.37351716E-03_JPRB, &
  & 0.37349396E-03_JPRB, 0.37345965E-03_JPRB, 0.37341508E-03_JPRB, 0.37335591E-03_JPRB, 0.37328787E-03_JPRB, 0.37321891E-03_JPRB, &
  & 0.37314278E-03_JPRB, 0.37304926E-03_JPRB, 0.37293162E-03_JPRB, 0.37279932E-03_JPRB, 0.37267696E-03_JPRB, 0.37256885E-03_JPRB, &
  & 0.37246687E-03_JPRB, 0.37236804E-03_JPRB, 0.37227105E-03_JPRB, 0.37217587E-03_JPRB, 0.37208386E-03_JPRB, 0.37199494E-03_JPRB, &
  & 0.37190683E-03_JPRB, 0.37181532E-03_JPRB, 0.37172232E-03_JPRB, 0.37162631E-03_JPRB, 0.37153101E-03_JPRB, 0.37144724E-03_JPRB, &
  & 0.37137560E-03_JPRB, 0.37131533E-03_JPRB, 0.37126728E-03_JPRB, 0.37123031E-03_JPRB, 0.37120365E-03_JPRB, 0.37118655E-03_JPRB, &
  & 0.37117936E-03_JPRB, 0.37117956E-03_JPRB, 0.37118341E-03_JPRB, 0.37118702E-03_JPRB  /)

RGHG1(:, 7, 8) = (/ &
  & 0.37344558E-03_JPRB, 0.37344745E-03_JPRB, 0.37345088E-03_JPRB, 0.37345583E-03_JPRB, 0.37346106E-03_JPRB, 0.37346658E-03_JPRB, &
  & 0.37347276E-03_JPRB, 0.37347920E-03_JPRB, 0.37348739E-03_JPRB, 0.37349530E-03_JPRB, 0.37350461E-03_JPRB, 0.37351848E-03_JPRB, &
  & 0.37353664E-03_JPRB, 0.37355606E-03_JPRB, 0.37357818E-03_JPRB, 0.37360213E-03_JPRB, 0.37362855E-03_JPRB, 0.37365453E-03_JPRB, &
  & 0.37367774E-03_JPRB, 0.37369712E-03_JPRB, 0.37371225E-03_JPRB, 0.37372180E-03_JPRB, 0.37372724E-03_JPRB, 0.37373054E-03_JPRB, &
  & 0.37373046E-03_JPRB, 0.37372725E-03_JPRB, 0.37372353E-03_JPRB, 0.37372223E-03_JPRB, 0.37372771E-03_JPRB, 0.37373910E-03_JPRB, &
  & 0.37374426E-03_JPRB, 0.37373767E-03_JPRB, 0.37371793E-03_JPRB, 0.37367820E-03_JPRB, 0.37362490E-03_JPRB, 0.37357280E-03_JPRB, &
  & 0.37351404E-03_JPRB, 0.37343140E-03_JPRB, 0.37331525E-03_JPRB, 0.37317327E-03_JPRB, 0.37303276E-03_JPRB, 0.37290490E-03_JPRB, &
  & 0.37278922E-03_JPRB, 0.37268099E-03_JPRB, 0.37256923E-03_JPRB, 0.37245324E-03_JPRB, 0.37233786E-03_JPRB, 0.37222294E-03_JPRB, &
  & 0.37210779E-03_JPRB, 0.37198552E-03_JPRB, 0.37185318E-03_JPRB, 0.37171166E-03_JPRB, 0.37157721E-03_JPRB, 0.37146430E-03_JPRB, &
  & 0.37137355E-03_JPRB, 0.37130131E-03_JPRB, 0.37124770E-03_JPRB, 0.37120841E-03_JPRB, 0.37118072E-03_JPRB, 0.37116269E-03_JPRB, &
  & 0.37115339E-03_JPRB, 0.37114972E-03_JPRB, 0.37114855E-03_JPRB, 0.37114820E-03_JPRB  /)

RGHG1(:, 8, 8) = (/ &
  & 0.37345062E-03_JPRB, 0.37345109E-03_JPRB, 0.37345314E-03_JPRB, 0.37345708E-03_JPRB, 0.37346163E-03_JPRB, 0.37346746E-03_JPRB, &
  & 0.37347513E-03_JPRB, 0.37348297E-03_JPRB, 0.37349356E-03_JPRB, 0.37350680E-03_JPRB, 0.37352423E-03_JPRB, 0.37355088E-03_JPRB, &
  & 0.37358366E-03_JPRB, 0.37361887E-03_JPRB, 0.37365700E-03_JPRB, 0.37370057E-03_JPRB, 0.37374938E-03_JPRB, 0.37379365E-03_JPRB, &
  & 0.37383186E-03_JPRB, 0.37386337E-03_JPRB, 0.37388498E-03_JPRB, 0.37389895E-03_JPRB, 0.37390911E-03_JPRB, 0.37391574E-03_JPRB, &
  & 0.37392044E-03_JPRB, 0.37392645E-03_JPRB, 0.37393764E-03_JPRB, 0.37395681E-03_JPRB, 0.37398877E-03_JPRB, 0.37403812E-03_JPRB, &
  & 0.37408595E-03_JPRB, 0.37412283E-03_JPRB, 0.37413642E-03_JPRB, 0.37412154E-03_JPRB, 0.37408938E-03_JPRB, 0.37405708E-03_JPRB, &
  & 0.37401597E-03_JPRB, 0.37394495E-03_JPRB, 0.37383066E-03_JPRB, 0.37367759E-03_JPRB, 0.37351288E-03_JPRB, 0.37335647E-03_JPRB, &
  & 0.37321713E-03_JPRB, 0.37308570E-03_JPRB, 0.37294584E-03_JPRB, 0.37279667E-03_JPRB, 0.37264475E-03_JPRB, 0.37249110E-03_JPRB, &
  & 0.37233632E-03_JPRB, 0.37217123E-03_JPRB, 0.37198869E-03_JPRB, 0.37179505E-03_JPRB, 0.37161750E-03_JPRB, 0.37147382E-03_JPRB, &
  & 0.37136505E-03_JPRB, 0.37128431E-03_JPRB, 0.37122945E-03_JPRB, 0.37119294E-03_JPRB, 0.37116958E-03_JPRB, 0.37115485E-03_JPRB, &
  & 0.37114548E-03_JPRB, 0.37113822E-03_JPRB, 0.37113084E-03_JPRB, 0.37112424E-03_JPRB  /)

RGHG1(:, 9, 8) = (/ &
  & 0.37347849E-03_JPRB, 0.37347632E-03_JPRB, 0.37347406E-03_JPRB, 0.37347385E-03_JPRB, 0.37347513E-03_JPRB, 0.37347900E-03_JPRB, &
  & 0.37348582E-03_JPRB, 0.37349343E-03_JPRB, 0.37350435E-03_JPRB, 0.37352338E-03_JPRB, 0.37355242E-03_JPRB, 0.37359584E-03_JPRB, &
  & 0.37364622E-03_JPRB, 0.37370094E-03_JPRB, 0.37375874E-03_JPRB, 0.37382666E-03_JPRB, 0.37389952E-03_JPRB, 0.37396173E-03_JPRB, &
  & 0.37401413E-03_JPRB, 0.37405583E-03_JPRB, 0.37408256E-03_JPRB, 0.37410027E-03_JPRB, 0.37411360E-03_JPRB, 0.37412303E-03_JPRB, &
  & 0.37413330E-03_JPRB, 0.37414959E-03_JPRB, 0.37417701E-03_JPRB, 0.37421806E-03_JPRB, 0.37427865E-03_JPRB, 0.37437101E-03_JPRB, &
  & 0.37447401E-03_JPRB, 0.37456757E-03_JPRB, 0.37462092E-03_JPRB, 0.37463291E-03_JPRB, 0.37462296E-03_JPRB, 0.37460440E-03_JPRB, &
  & 0.37456949E-03_JPRB, 0.37450111E-03_JPRB, 0.37438387E-03_JPRB, 0.37421865E-03_JPRB, 0.37402813E-03_JPRB, 0.37383911E-03_JPRB, &
  & 0.37366432E-03_JPRB, 0.37349111E-03_JPRB, 0.37330836E-03_JPRB, 0.37311730E-03_JPRB, 0.37292225E-03_JPRB, 0.37272768E-03_JPRB, &
  & 0.37253240E-03_JPRB, 0.37232537E-03_JPRB, 0.37209677E-03_JPRB, 0.37185866E-03_JPRB, 0.37164558E-03_JPRB, 0.37147649E-03_JPRB, &
  & 0.37135526E-03_JPRB, 0.37127173E-03_JPRB, 0.37122033E-03_JPRB, 0.37119060E-03_JPRB, 0.37117504E-03_JPRB, 0.37116713E-03_JPRB, &
  & 0.37116124E-03_JPRB, 0.37115241E-03_JPRB, 0.37113842E-03_JPRB, 0.37112327E-03_JPRB  /)

RGHG1(:,10, 8) = (/ &
  & 0.37349490E-03_JPRB, 0.37349407E-03_JPRB, 0.37349010E-03_JPRB, 0.37348720E-03_JPRB, 0.37348610E-03_JPRB, 0.37348743E-03_JPRB, &
  & 0.37349167E-03_JPRB, 0.37349753E-03_JPRB, 0.37350659E-03_JPRB, 0.37352935E-03_JPRB, 0.37356932E-03_JPRB, 0.37362900E-03_JPRB, &
  & 0.37369361E-03_JPRB, 0.37376514E-03_JPRB, 0.37384156E-03_JPRB, 0.37392809E-03_JPRB, 0.37401540E-03_JPRB, 0.37408977E-03_JPRB, &
  & 0.37415057E-03_JPRB, 0.37419816E-03_JPRB, 0.37423080E-03_JPRB, 0.37425182E-03_JPRB, 0.37426646E-03_JPRB, 0.37427763E-03_JPRB, &
  & 0.37429269E-03_JPRB, 0.37431676E-03_JPRB, 0.37435467E-03_JPRB, 0.37441155E-03_JPRB, 0.37449479E-03_JPRB, 0.37461422E-03_JPRB, &
  & 0.37476646E-03_JPRB, 0.37491672E-03_JPRB, 0.37501455E-03_JPRB, 0.37505710E-03_JPRB, 0.37506656E-03_JPRB, 0.37505173E-03_JPRB, &
  & 0.37500799E-03_JPRB, 0.37492683E-03_JPRB, 0.37479873E-03_JPRB, 0.37462471E-03_JPRB, 0.37442049E-03_JPRB, 0.37420921E-03_JPRB, &
  & 0.37399538E-03_JPRB, 0.37377121E-03_JPRB, 0.37353908E-03_JPRB, 0.37330735E-03_JPRB, 0.37307676E-03_JPRB, 0.37285562E-03_JPRB, &
  & 0.37263378E-03_JPRB, 0.37239957E-03_JPRB, 0.37214349E-03_JPRB, 0.37188104E-03_JPRB, 0.37165067E-03_JPRB, 0.37146730E-03_JPRB, &
  & 0.37134144E-03_JPRB, 0.37125857E-03_JPRB, 0.37121101E-03_JPRB, 0.37118665E-03_JPRB, 0.37117670E-03_JPRB, 0.37117490E-03_JPRB, &
  & 0.37117506E-03_JPRB, 0.37116849E-03_JPRB, 0.37115176E-03_JPRB, 0.37113212E-03_JPRB  /)

RGHG1(:,11, 8) = (/ &
  & 0.37341964E-03_JPRB, 0.37342500E-03_JPRB, 0.37342861E-03_JPRB, 0.37343285E-03_JPRB, 0.37343783E-03_JPRB, 0.37344256E-03_JPRB, &
  & 0.37344883E-03_JPRB, 0.37345558E-03_JPRB, 0.37346451E-03_JPRB, 0.37348906E-03_JPRB, 0.37353542E-03_JPRB, 0.37360515E-03_JPRB, &
  & 0.37367665E-03_JPRB, 0.37376000E-03_JPRB, 0.37384941E-03_JPRB, 0.37394620E-03_JPRB, 0.37403996E-03_JPRB, 0.37412049E-03_JPRB, &
  & 0.37418530E-03_JPRB, 0.37423460E-03_JPRB, 0.37426900E-03_JPRB, 0.37429093E-03_JPRB, 0.37430534E-03_JPRB, 0.37431529E-03_JPRB, &
  & 0.37432960E-03_JPRB, 0.37435237E-03_JPRB, 0.37438965E-03_JPRB, 0.37444499E-03_JPRB, 0.37452850E-03_JPRB, 0.37464985E-03_JPRB, &
  & 0.37482631E-03_JPRB, 0.37502281E-03_JPRB, 0.37516624E-03_JPRB, 0.37524511E-03_JPRB, 0.37527784E-03_JPRB, 0.37527449E-03_JPRB, &
  & 0.37523350E-03_JPRB, 0.37514534E-03_JPRB, 0.37500855E-03_JPRB, 0.37483412E-03_JPRB, 0.37463588E-03_JPRB, 0.37441986E-03_JPRB, &
  & 0.37417952E-03_JPRB, 0.37391456E-03_JPRB, 0.37363638E-03_JPRB, 0.37336808E-03_JPRB, 0.37311502E-03_JPRB, 0.37287835E-03_JPRB, &
  & 0.37263416E-03_JPRB, 0.37237584E-03_JPRB, 0.37210579E-03_JPRB, 0.37184511E-03_JPRB, 0.37162154E-03_JPRB, 0.37143972E-03_JPRB, &
  & 0.37131622E-03_JPRB, 0.37123392E-03_JPRB, 0.37118548E-03_JPRB, 0.37116076E-03_JPRB, 0.37115305E-03_JPRB, 0.37115696E-03_JPRB, &
  & 0.37116059E-03_JPRB, 0.37115614E-03_JPRB, 0.37114430E-03_JPRB, 0.37112998E-03_JPRB  /)

RGHG1(:,12, 8) = (/ &
  & 0.37318103E-03_JPRB, 0.37319751E-03_JPRB, 0.37321774E-03_JPRB, 0.37324012E-03_JPRB, 0.37326356E-03_JPRB, 0.37328317E-03_JPRB, &
  & 0.37330202E-03_JPRB, 0.37331747E-03_JPRB, 0.37333214E-03_JPRB, 0.37335974E-03_JPRB, 0.37341292E-03_JPRB, 0.37348877E-03_JPRB, &
  & 0.37356992E-03_JPRB, 0.37366701E-03_JPRB, 0.37377177E-03_JPRB, 0.37388136E-03_JPRB, 0.37398426E-03_JPRB, 0.37407060E-03_JPRB, &
  & 0.37413935E-03_JPRB, 0.37418858E-03_JPRB, 0.37422014E-03_JPRB, 0.37424059E-03_JPRB, 0.37425340E-03_JPRB, 0.37426163E-03_JPRB, &
  & 0.37427188E-03_JPRB, 0.37428783E-03_JPRB, 0.37431505E-03_JPRB, 0.37435802E-03_JPRB, 0.37443196E-03_JPRB, 0.37455715E-03_JPRB, &
  & 0.37475021E-03_JPRB, 0.37497866E-03_JPRB, 0.37516145E-03_JPRB, 0.37527347E-03_JPRB, 0.37533316E-03_JPRB, 0.37535334E-03_JPRB, &
  & 0.37533498E-03_JPRB, 0.37526226E-03_JPRB, 0.37513384E-03_JPRB, 0.37497031E-03_JPRB, 0.37478839E-03_JPRB, 0.37457429E-03_JPRB, &
  & 0.37431531E-03_JPRB, 0.37401750E-03_JPRB, 0.37370430E-03_JPRB, 0.37340907E-03_JPRB, 0.37313854E-03_JPRB, 0.37287524E-03_JPRB, &
  & 0.37260198E-03_JPRB, 0.37231910E-03_JPRB, 0.37205085E-03_JPRB, 0.37181407E-03_JPRB, 0.37161576E-03_JPRB, 0.37144764E-03_JPRB, &
  & 0.37132792E-03_JPRB, 0.37124538E-03_JPRB, 0.37119599E-03_JPRB, 0.37116835E-03_JPRB, 0.37116182E-03_JPRB, 0.37117659E-03_JPRB, &
  & 0.37118436E-03_JPRB, 0.37117232E-03_JPRB, 0.37115528E-03_JPRB, 0.37113995E-03_JPRB  /)

RGHG1(:,13, 8) = (/ &
  & 0.37282544E-03_JPRB, 0.37285656E-03_JPRB, 0.37289331E-03_JPRB, 0.37293163E-03_JPRB, 0.37297289E-03_JPRB, 0.37301009E-03_JPRB, &
  & 0.37304571E-03_JPRB, 0.37307596E-03_JPRB, 0.37310143E-03_JPRB, 0.37313803E-03_JPRB, 0.37320682E-03_JPRB, 0.37329713E-03_JPRB, &
  & 0.37340088E-03_JPRB, 0.37352692E-03_JPRB, 0.37366204E-03_JPRB, 0.37380126E-03_JPRB, 0.37393060E-03_JPRB, 0.37403678E-03_JPRB, &
  & 0.37411860E-03_JPRB, 0.37417384E-03_JPRB, 0.37420595E-03_JPRB, 0.37422477E-03_JPRB, 0.37423718E-03_JPRB, 0.37424512E-03_JPRB, &
  & 0.37425515E-03_JPRB, 0.37426823E-03_JPRB, 0.37429237E-03_JPRB, 0.37433821E-03_JPRB, 0.37442265E-03_JPRB, 0.37456517E-03_JPRB, &
  & 0.37477341E-03_JPRB, 0.37501395E-03_JPRB, 0.37521926E-03_JPRB, 0.37535648E-03_JPRB, 0.37544217E-03_JPRB, 0.37548684E-03_JPRB, &
  & 0.37549536E-03_JPRB, 0.37544585E-03_JPRB, 0.37533551E-03_JPRB, 0.37518581E-03_JPRB, 0.37501081E-03_JPRB, 0.37478950E-03_JPRB, &
  & 0.37450714E-03_JPRB, 0.37418735E-03_JPRB, 0.37386237E-03_JPRB, 0.37355392E-03_JPRB, 0.37326467E-03_JPRB, 0.37297191E-03_JPRB, &
  & 0.37267801E-03_JPRB, 0.37238921E-03_JPRB, 0.37214473E-03_JPRB, 0.37194654E-03_JPRB, 0.37178796E-03_JPRB, 0.37164776E-03_JPRB, &
  & 0.37153624E-03_JPRB, 0.37145722E-03_JPRB, 0.37141188E-03_JPRB, 0.37138463E-03_JPRB, 0.37138058E-03_JPRB, 0.37141410E-03_JPRB, &
  & 0.37144095E-03_JPRB, 0.37142058E-03_JPRB, 0.37137190E-03_JPRB, 0.37132953E-03_JPRB  /)

RGHG1(:,14, 8) = (/ &
  & 0.37248847E-03_JPRB, 0.37252002E-03_JPRB, 0.37255765E-03_JPRB, 0.37259744E-03_JPRB, 0.37264169E-03_JPRB, 0.37268759E-03_JPRB, &
  & 0.37273459E-03_JPRB, 0.37277805E-03_JPRB, 0.37281748E-03_JPRB, 0.37287020E-03_JPRB, 0.37296308E-03_JPRB, 0.37308341E-03_JPRB, &
  & 0.37322823E-03_JPRB, 0.37340335E-03_JPRB, 0.37359179E-03_JPRB, 0.37378187E-03_JPRB, 0.37395714E-03_JPRB, 0.37410591E-03_JPRB, &
  & 0.37421883E-03_JPRB, 0.37429282E-03_JPRB, 0.37433492E-03_JPRB, 0.37435812E-03_JPRB, 0.37437260E-03_JPRB, 0.37438679E-03_JPRB, &
  & 0.37441403E-03_JPRB, 0.37444552E-03_JPRB, 0.37449135E-03_JPRB, 0.37457163E-03_JPRB, 0.37469881E-03_JPRB, 0.37486895E-03_JPRB, &
  & 0.37508115E-03_JPRB, 0.37530913E-03_JPRB, 0.37549998E-03_JPRB, 0.37564351E-03_JPRB, 0.37574106E-03_JPRB, 0.37579364E-03_JPRB, &
  & 0.37580234E-03_JPRB, 0.37574479E-03_JPRB, 0.37563164E-03_JPRB, 0.37547930E-03_JPRB, 0.37528660E-03_JPRB, 0.37504008E-03_JPRB, &
  & 0.37473685E-03_JPRB, 0.37441831E-03_JPRB, 0.37409822E-03_JPRB, 0.37378810E-03_JPRB, 0.37349211E-03_JPRB, 0.37319328E-03_JPRB, &
  & 0.37290082E-03_JPRB, 0.37264436E-03_JPRB, 0.37245129E-03_JPRB, 0.37231093E-03_JPRB, 0.37220692E-03_JPRB, 0.37211171E-03_JPRB, &
  & 0.37202692E-03_JPRB, 0.37196533E-03_JPRB, 0.37193039E-03_JPRB, 0.37191196E-03_JPRB, 0.37192225E-03_JPRB, 0.37197330E-03_JPRB, &
  & 0.37202467E-03_JPRB, 0.37201852E-03_JPRB, 0.37194434E-03_JPRB, 0.37187000E-03_JPRB  /)

RGHG1(:,15, 8) = (/ &
  & 0.37228985E-03_JPRB, 0.37230406E-03_JPRB, 0.37232530E-03_JPRB, 0.37234744E-03_JPRB, 0.37237601E-03_JPRB, 0.37241402E-03_JPRB, &
  & 0.37246003E-03_JPRB, 0.37250617E-03_JPRB, 0.37255448E-03_JPRB, 0.37262127E-03_JPRB, 0.37273862E-03_JPRB, 0.37289918E-03_JPRB, &
  & 0.37309997E-03_JPRB, 0.37334476E-03_JPRB, 0.37360498E-03_JPRB, 0.37385123E-03_JPRB, 0.37408165E-03_JPRB, 0.37428837E-03_JPRB, &
  & 0.37444099E-03_JPRB, 0.37454403E-03_JPRB, 0.37460522E-03_JPRB, 0.37463800E-03_JPRB, 0.37466061E-03_JPRB, 0.37469506E-03_JPRB, &
  & 0.37476021E-03_JPRB, 0.37484591E-03_JPRB, 0.37495925E-03_JPRB, 0.37511463E-03_JPRB, 0.37529796E-03_JPRB, 0.37549892E-03_JPRB, &
  & 0.37572374E-03_JPRB, 0.37592108E-03_JPRB, 0.37606208E-03_JPRB, 0.37616880E-03_JPRB, 0.37623845E-03_JPRB, 0.37625229E-03_JPRB, &
  & 0.37619994E-03_JPRB, 0.37607956E-03_JPRB, 0.37591752E-03_JPRB, 0.37572887E-03_JPRB, 0.37549830E-03_JPRB, 0.37521450E-03_JPRB, &
  & 0.37489815E-03_JPRB, 0.37458429E-03_JPRB, 0.37426651E-03_JPRB, 0.37396045E-03_JPRB, 0.37366898E-03_JPRB, 0.37338031E-03_JPRB, &
  & 0.37311400E-03_JPRB, 0.37291235E-03_JPRB, 0.37278260E-03_JPRB, 0.37270697E-03_JPRB, 0.37265831E-03_JPRB, 0.37261977E-03_JPRB, &
  & 0.37258717E-03_JPRB, 0.37256303E-03_JPRB, 0.37255021E-03_JPRB, 0.37255276E-03_JPRB, 0.37257897E-03_JPRB, 0.37262802E-03_JPRB, &
  & 0.37268575E-03_JPRB, 0.37268993E-03_JPRB, 0.37262310E-03_JPRB, 0.37256081E-03_JPRB  /)

RGHG1(:,16, 8) = (/ &
  & 0.37223556E-03_JPRB, 0.37223459E-03_JPRB, 0.37223695E-03_JPRB, 0.37223747E-03_JPRB, 0.37224431E-03_JPRB, 0.37226415E-03_JPRB, &
  & 0.37229483E-03_JPRB, 0.37232943E-03_JPRB, 0.37237305E-03_JPRB, 0.37244333E-03_JPRB, 0.37257656E-03_JPRB, 0.37277262E-03_JPRB, &
  & 0.37303110E-03_JPRB, 0.37335786E-03_JPRB, 0.37368442E-03_JPRB, 0.37398353E-03_JPRB, 0.37426440E-03_JPRB, 0.37451700E-03_JPRB, &
  & 0.37470922E-03_JPRB, 0.37483950E-03_JPRB, 0.37492021E-03_JPRB, 0.37496763E-03_JPRB, 0.37500190E-03_JPRB, 0.37505231E-03_JPRB, &
  & 0.37515875E-03_JPRB, 0.37531618E-03_JPRB, 0.37551482E-03_JPRB, 0.37577924E-03_JPRB, 0.37605665E-03_JPRB, 0.37634380E-03_JPRB, &
  & 0.37661127E-03_JPRB, 0.37677535E-03_JPRB, 0.37684077E-03_JPRB, 0.37685446E-03_JPRB, 0.37682828E-03_JPRB, 0.37674061E-03_JPRB, &
  & 0.37657922E-03_JPRB, 0.37636001E-03_JPRB, 0.37611830E-03_JPRB, 0.37587164E-03_JPRB, 0.37559728E-03_JPRB, 0.37527906E-03_JPRB, &
  & 0.37494594E-03_JPRB, 0.37461639E-03_JPRB, 0.37429114E-03_JPRB, 0.37398164E-03_JPRB, 0.37368249E-03_JPRB, 0.37339860E-03_JPRB, &
  & 0.37316098E-03_JPRB, 0.37300034E-03_JPRB, 0.37291182E-03_JPRB, 0.37287522E-03_JPRB, 0.37286556E-03_JPRB, 0.37287139E-03_JPRB, &
  & 0.37288092E-03_JPRB, 0.37288828E-03_JPRB, 0.37290331E-03_JPRB, 0.37292839E-03_JPRB, 0.37295528E-03_JPRB, 0.37299568E-03_JPRB, &
  & 0.37303849E-03_JPRB, 0.37302892E-03_JPRB, 0.37296843E-03_JPRB, 0.37295573E-03_JPRB  /)

RGHG1(:,17, 8) = (/ &
  & 0.37218472E-03_JPRB, 0.37218581E-03_JPRB, 0.37218685E-03_JPRB, 0.37218576E-03_JPRB, 0.37218475E-03_JPRB, 0.37219437E-03_JPRB, &
  & 0.37221259E-03_JPRB, 0.37223617E-03_JPRB, 0.37227155E-03_JPRB, 0.37234176E-03_JPRB, 0.37248663E-03_JPRB, 0.37270920E-03_JPRB, &
  & 0.37301066E-03_JPRB, 0.37339376E-03_JPRB, 0.37377478E-03_JPRB, 0.37412959E-03_JPRB, 0.37444768E-03_JPRB, 0.37471866E-03_JPRB, &
  & 0.37493152E-03_JPRB, 0.37507481E-03_JPRB, 0.37516691E-03_JPRB, 0.37522384E-03_JPRB, 0.37526689E-03_JPRB, 0.37533092E-03_JPRB, &
  & 0.37546406E-03_JPRB, 0.37565177E-03_JPRB, 0.37587798E-03_JPRB, 0.37621208E-03_JPRB, 0.37661282E-03_JPRB, 0.37703853E-03_JPRB, &
  & 0.37742908E-03_JPRB, 0.37762437E-03_JPRB, 0.37762530E-03_JPRB, 0.37753302E-03_JPRB, 0.37738658E-03_JPRB, 0.37718148E-03_JPRB, &
  & 0.37691193E-03_JPRB, 0.37659699E-03_JPRB, 0.37627400E-03_JPRB, 0.37596276E-03_JPRB, 0.37564672E-03_JPRB, 0.37529235E-03_JPRB, &
  & 0.37492987E-03_JPRB, 0.37457509E-03_JPRB, 0.37423683E-03_JPRB, 0.37390333E-03_JPRB, 0.37356968E-03_JPRB, 0.37327115E-03_JPRB, &
  & 0.37305038E-03_JPRB, 0.37291768E-03_JPRB, 0.37285929E-03_JPRB, 0.37284647E-03_JPRB, 0.37285536E-03_JPRB, 0.37287669E-03_JPRB, &
  & 0.37289831E-03_JPRB, 0.37291297E-03_JPRB, 0.37294227E-03_JPRB, 0.37297515E-03_JPRB, 0.37299698E-03_JPRB, 0.37302493E-03_JPRB, &
  & 0.37305230E-03_JPRB, 0.37303630E-03_JPRB, 0.37297193E-03_JPRB, 0.37295380E-03_JPRB  /)

RGHG1(:,18, 8) = (/ &
  & 0.37210100E-03_JPRB, 0.37211804E-03_JPRB, 0.37213630E-03_JPRB, 0.37215121E-03_JPRB, 0.37215928E-03_JPRB, 0.37216902E-03_JPRB, &
  & 0.37218429E-03_JPRB, 0.37220244E-03_JPRB, 0.37223390E-03_JPRB, 0.37230800E-03_JPRB, 0.37246481E-03_JPRB, 0.37270984E-03_JPRB, &
  & 0.37302801E-03_JPRB, 0.37342996E-03_JPRB, 0.37385447E-03_JPRB, 0.37426013E-03_JPRB, 0.37460855E-03_JPRB, 0.37487833E-03_JPRB, &
  & 0.37508594E-03_JPRB, 0.37522977E-03_JPRB, 0.37532238E-03_JPRB, 0.37538152E-03_JPRB, 0.37543042E-03_JPRB, 0.37549960E-03_JPRB, &
  & 0.37564765E-03_JPRB, 0.37582688E-03_JPRB, 0.37604422E-03_JPRB, 0.37640679E-03_JPRB, 0.37687669E-03_JPRB, 0.37740938E-03_JPRB, &
  & 0.37796461E-03_JPRB, 0.37827289E-03_JPRB, 0.37826369E-03_JPRB, 0.37809868E-03_JPRB, 0.37788308E-03_JPRB, 0.37761201E-03_JPRB, &
  & 0.37727758E-03_JPRB, 0.37689385E-03_JPRB, 0.37649882E-03_JPRB, 0.37612092E-03_JPRB, 0.37576338E-03_JPRB, 0.37537126E-03_JPRB, &
  & 0.37497345E-03_JPRB, 0.37459668E-03_JPRB, 0.37423775E-03_JPRB, 0.37385376E-03_JPRB, 0.37346608E-03_JPRB, 0.37314152E-03_JPRB, &
  & 0.37291773E-03_JPRB, 0.37279762E-03_JPRB, 0.37275820E-03_JPRB, 0.37275301E-03_JPRB, 0.37276142E-03_JPRB, 0.37278308E-03_JPRB, &
  & 0.37280901E-03_JPRB, 0.37282636E-03_JPRB, 0.37285409E-03_JPRB, 0.37288266E-03_JPRB, 0.37289545E-03_JPRB, 0.37291106E-03_JPRB, &
  & 0.37292408E-03_JPRB, 0.37289975E-03_JPRB, 0.37283682E-03_JPRB, 0.37279541E-03_JPRB  /)

RGHG1(:,19, 8) = (/ &
  & 0.37210175E-03_JPRB, 0.37213746E-03_JPRB, 0.37217704E-03_JPRB, 0.37221076E-03_JPRB, 0.37222814E-03_JPRB, 0.37223605E-03_JPRB, &
  & 0.37224278E-03_JPRB, 0.37225156E-03_JPRB, 0.37227808E-03_JPRB, 0.37235273E-03_JPRB, 0.37251864E-03_JPRB, 0.37277975E-03_JPRB, &
  & 0.37310146E-03_JPRB, 0.37350683E-03_JPRB, 0.37396741E-03_JPRB, 0.37440703E-03_JPRB, 0.37476774E-03_JPRB, 0.37502905E-03_JPRB, &
  & 0.37521823E-03_JPRB, 0.37535317E-03_JPRB, 0.37543646E-03_JPRB, 0.37548242E-03_JPRB, 0.37552836E-03_JPRB, 0.37560341E-03_JPRB, &
  & 0.37574540E-03_JPRB, 0.37590817E-03_JPRB, 0.37613415E-03_JPRB, 0.37651096E-03_JPRB, 0.37701408E-03_JPRB, 0.37762821E-03_JPRB, &
  & 0.37834025E-03_JPRB, 0.37878022E-03_JPRB, 0.37879577E-03_JPRB, 0.37860330E-03_JPRB, 0.37837548E-03_JPRB, 0.37810388E-03_JPRB, &
  & 0.37775087E-03_JPRB, 0.37733187E-03_JPRB, 0.37688275E-03_JPRB, 0.37644482E-03_JPRB, 0.37605048E-03_JPRB, 0.37563220E-03_JPRB, &
  & 0.37520440E-03_JPRB, 0.37480528E-03_JPRB, 0.37440193E-03_JPRB, 0.37394712E-03_JPRB, 0.37350075E-03_JPRB, 0.37314306E-03_JPRB, &
  & 0.37290915E-03_JPRB, 0.37279145E-03_JPRB, 0.37275503E-03_JPRB, 0.37274048E-03_JPRB, 0.37273714E-03_JPRB, 0.37275116E-03_JPRB, &
  & 0.37277520E-03_JPRB, 0.37279332E-03_JPRB, 0.37281161E-03_JPRB, 0.37282849E-03_JPRB, 0.37283212E-03_JPRB, 0.37284258E-03_JPRB, &
  & 0.37284834E-03_JPRB, 0.37282509E-03_JPRB, 0.37277795E-03_JPRB, 0.37274379E-03_JPRB  /)

RGHG1(:,20, 8) = (/ &
  & 0.37228206E-03_JPRB, 0.37233058E-03_JPRB, 0.37238137E-03_JPRB, 0.37242535E-03_JPRB, 0.37244625E-03_JPRB, 0.37244468E-03_JPRB, &
  & 0.37243328E-03_JPRB, 0.37242171E-03_JPRB, 0.37243115E-03_JPRB, 0.37249463E-03_JPRB, 0.37265933E-03_JPRB, 0.37292806E-03_JPRB, &
  & 0.37325333E-03_JPRB, 0.37366432E-03_JPRB, 0.37414684E-03_JPRB, 0.37460514E-03_JPRB, 0.37495860E-03_JPRB, 0.37519593E-03_JPRB, &
  & 0.37535863E-03_JPRB, 0.37547398E-03_JPRB, 0.37554163E-03_JPRB, 0.37557021E-03_JPRB, 0.37560997E-03_JPRB, 0.37568639E-03_JPRB, &
  & 0.37581132E-03_JPRB, 0.37596680E-03_JPRB, 0.37620147E-03_JPRB, 0.37658164E-03_JPRB, 0.37711358E-03_JPRB, 0.37782325E-03_JPRB, &
  & 0.37869039E-03_JPRB, 0.37923065E-03_JPRB, 0.37927514E-03_JPRB, 0.37909096E-03_JPRB, 0.37888463E-03_JPRB, 0.37866082E-03_JPRB, &
  & 0.37833227E-03_JPRB, 0.37790627E-03_JPRB, 0.37743765E-03_JPRB, 0.37697002E-03_JPRB, 0.37655041E-03_JPRB, 0.37612030E-03_JPRB, &
  & 0.37567945E-03_JPRB, 0.37525561E-03_JPRB, 0.37478860E-03_JPRB, 0.37426202E-03_JPRB, 0.37377130E-03_JPRB, 0.37338970E-03_JPRB, &
  & 0.37315029E-03_JPRB, 0.37302876E-03_JPRB, 0.37297587E-03_JPRB, 0.37293551E-03_JPRB, 0.37291081E-03_JPRB, 0.37290865E-03_JPRB, &
  & 0.37292084E-03_JPRB, 0.37293392E-03_JPRB, 0.37294090E-03_JPRB, 0.37294327E-03_JPRB, 0.37294138E-03_JPRB, 0.37295031E-03_JPRB, &
  & 0.37295051E-03_JPRB, 0.37293202E-03_JPRB, 0.37290413E-03_JPRB, 0.37288657E-03_JPRB  /)

RGHG1(:,21, 8) = (/ &
  & 0.37267069E-03_JPRB, 0.37272396E-03_JPRB, 0.37277158E-03_JPRB, 0.37281085E-03_JPRB, 0.37282365E-03_JPRB, 0.37280386E-03_JPRB, &
  & 0.37276524E-03_JPRB, 0.37272097E-03_JPRB, 0.37269775E-03_JPRB, 0.37273663E-03_JPRB, 0.37288809E-03_JPRB, 0.37315664E-03_JPRB, &
  & 0.37348958E-03_JPRB, 0.37391247E-03_JPRB, 0.37440219E-03_JPRB, 0.37486413E-03_JPRB, 0.37519921E-03_JPRB, 0.37539950E-03_JPRB, &
  & 0.37552865E-03_JPRB, 0.37561600E-03_JPRB, 0.37566700E-03_JPRB, 0.37568315E-03_JPRB, 0.37571690E-03_JPRB, 0.37578996E-03_JPRB, &
  & 0.37589717E-03_JPRB, 0.37605255E-03_JPRB, 0.37628627E-03_JPRB, 0.37666144E-03_JPRB, 0.37723854E-03_JPRB, 0.37807326E-03_JPRB, &
  & 0.37908035E-03_JPRB, 0.37967115E-03_JPRB, 0.37973438E-03_JPRB, 0.37957899E-03_JPRB, 0.37940843E-03_JPRB, 0.37925357E-03_JPRB, &
  & 0.37898457E-03_JPRB, 0.37857777E-03_JPRB, 0.37812550E-03_JPRB, 0.37766828E-03_JPRB, 0.37724060E-03_JPRB, 0.37681260E-03_JPRB, &
  & 0.37637694E-03_JPRB, 0.37592411E-03_JPRB, 0.37538967E-03_JPRB, 0.37480944E-03_JPRB, 0.37429811E-03_JPRB, 0.37391239E-03_JPRB, &
  & 0.37367644E-03_JPRB, 0.37354532E-03_JPRB, 0.37345846E-03_JPRB, 0.37338055E-03_JPRB, 0.37332751E-03_JPRB, 0.37330173E-03_JPRB, &
  & 0.37329241E-03_JPRB, 0.37329320E-03_JPRB, 0.37328801E-03_JPRB, 0.37327786E-03_JPRB, 0.37327600E-03_JPRB, 0.37328444E-03_JPRB, &
  & 0.37327947E-03_JPRB, 0.37326494E-03_JPRB, 0.37325264E-03_JPRB, 0.37324728E-03_JPRB  /)

RGHG1(:,22, 8) = (/ &
  & 0.37328829E-03_JPRB, 0.37333788E-03_JPRB, 0.37336694E-03_JPRB, 0.37337986E-03_JPRB, 0.37336409E-03_JPRB, 0.37331706E-03_JPRB, &
  & 0.37324320E-03_JPRB, 0.37315390E-03_JPRB, 0.37308188E-03_JPRB, 0.37308306E-03_JPRB, 0.37320951E-03_JPRB, 0.37347105E-03_JPRB, &
  & 0.37381567E-03_JPRB, 0.37425490E-03_JPRB, 0.37473862E-03_JPRB, 0.37518511E-03_JPRB, 0.37550295E-03_JPRB, 0.37566244E-03_JPRB, &
  & 0.37575000E-03_JPRB, 0.37580511E-03_JPRB, 0.37584511E-03_JPRB, 0.37586148E-03_JPRB, 0.37589078E-03_JPRB, 0.37595918E-03_JPRB, &
  & 0.37605760E-03_JPRB, 0.37620965E-03_JPRB, 0.37643214E-03_JPRB, 0.37679741E-03_JPRB, 0.37745356E-03_JPRB, 0.37844560E-03_JPRB, &
  & 0.37954252E-03_JPRB, 0.38012254E-03_JPRB, 0.38018677E-03_JPRB, 0.38006529E-03_JPRB, 0.37992974E-03_JPRB, 0.37983448E-03_JPRB, &
  & 0.37965331E-03_JPRB, 0.37929598E-03_JPRB, 0.37889274E-03_JPRB, 0.37849300E-03_JPRB, 0.37808234E-03_JPRB, 0.37767123E-03_JPRB, &
  & 0.37725715E-03_JPRB, 0.37676862E-03_JPRB, 0.37618426E-03_JPRB, 0.37559113E-03_JPRB, 0.37509104E-03_JPRB, 0.37473089E-03_JPRB, &
  & 0.37450928E-03_JPRB, 0.37436093E-03_JPRB, 0.37422559E-03_JPRB, 0.37410466E-03_JPRB, 0.37401970E-03_JPRB, 0.37396491E-03_JPRB, &
  & 0.37392624E-03_JPRB, 0.37390690E-03_JPRB, 0.37388738E-03_JPRB, 0.37387244E-03_JPRB, 0.37387804E-03_JPRB, 0.37388591E-03_JPRB, &
  & 0.37387839E-03_JPRB, 0.37386452E-03_JPRB, 0.37385956E-03_JPRB, 0.37385709E-03_JPRB  /)

RGHG1(:,23, 8) = (/ &
  & 0.37395474E-03_JPRB, 0.37398986E-03_JPRB, 0.37399471E-03_JPRB, 0.37396965E-03_JPRB, 0.37391784E-03_JPRB, 0.37384024E-03_JPRB, &
  & 0.37373411E-03_JPRB, 0.37360896E-03_JPRB, 0.37349969E-03_JPRB, 0.37347160E-03_JPRB, 0.37357754E-03_JPRB, 0.37383396E-03_JPRB, &
  & 0.37419449E-03_JPRB, 0.37464661E-03_JPRB, 0.37511958E-03_JPRB, 0.37553991E-03_JPRB, 0.37583450E-03_JPRB, 0.37596843E-03_JPRB, &
  & 0.37603186E-03_JPRB, 0.37606803E-03_JPRB, 0.37610122E-03_JPRB, 0.37612053E-03_JPRB, 0.37615367E-03_JPRB, 0.37623383E-03_JPRB, &
  & 0.37632658E-03_JPRB, 0.37646622E-03_JPRB, 0.37668895E-03_JPRB, 0.37709406E-03_JPRB, 0.37786736E-03_JPRB, 0.37897936E-03_JPRB, &
  & 0.38005704E-03_JPRB, 0.38055766E-03_JPRB, 0.38060590E-03_JPRB, 0.38052000E-03_JPRB, 0.38042041E-03_JPRB, 0.38034619E-03_JPRB, &
  & 0.38021506E-03_JPRB, 0.37991964E-03_JPRB, 0.37957879E-03_JPRB, 0.37924911E-03_JPRB, 0.37888636E-03_JPRB, 0.37849997E-03_JPRB, &
  & 0.37809663E-03_JPRB, 0.37758533E-03_JPRB, 0.37699155E-03_JPRB, 0.37641138E-03_JPRB, 0.37594599E-03_JPRB, 0.37562224E-03_JPRB, &
  & 0.37540825E-03_JPRB, 0.37522771E-03_JPRB, 0.37504889E-03_JPRB, 0.37489959E-03_JPRB, 0.37479025E-03_JPRB, 0.37471317E-03_JPRB, &
  & 0.37465236E-03_JPRB, 0.37461316E-03_JPRB, 0.37458627E-03_JPRB, 0.37457230E-03_JPRB, 0.37457882E-03_JPRB, 0.37458195E-03_JPRB, &
  & 0.37456732E-03_JPRB, 0.37455256E-03_JPRB, 0.37455055E-03_JPRB, 0.37454504E-03_JPRB  /)

RGHG1(:,24, 8) = (/ &
  & 0.37460048E-03_JPRB, 0.37461308E-03_JPRB, 0.37459526E-03_JPRB, 0.37453389E-03_JPRB, 0.37444605E-03_JPRB, 0.37433685E-03_JPRB, &
  & 0.37420082E-03_JPRB, 0.37404668E-03_JPRB, 0.37391023E-03_JPRB, 0.37386222E-03_JPRB, 0.37395525E-03_JPRB, 0.37421032E-03_JPRB, &
  & 0.37458843E-03_JPRB, 0.37505283E-03_JPRB, 0.37551751E-03_JPRB, 0.37591473E-03_JPRB, 0.37618547E-03_JPRB, 0.37630098E-03_JPRB, &
  & 0.37634881E-03_JPRB, 0.37637654E-03_JPRB, 0.37640713E-03_JPRB, 0.37642993E-03_JPRB, 0.37647407E-03_JPRB, 0.37657003E-03_JPRB, &
  & 0.37666148E-03_JPRB, 0.37679446E-03_JPRB, 0.37702853E-03_JPRB, 0.37749606E-03_JPRB, 0.37838982E-03_JPRB, 0.37957975E-03_JPRB, &
  & 0.38059022E-03_JPRB, 0.38099253E-03_JPRB, 0.38102724E-03_JPRB, 0.38097741E-03_JPRB, 0.38091165E-03_JPRB, 0.38084530E-03_JPRB, &
  & 0.38073985E-03_JPRB, 0.38050304E-03_JPRB, 0.38022567E-03_JPRB, 0.37995818E-03_JPRB, 0.37964442E-03_JPRB, 0.37928920E-03_JPRB, &
  & 0.37889198E-03_JPRB, 0.37836688E-03_JPRB, 0.37777787E-03_JPRB, 0.37722023E-03_JPRB, 0.37679694E-03_JPRB, 0.37650533E-03_JPRB, &
  & 0.37628598E-03_JPRB, 0.37606729E-03_JPRB, 0.37585061E-03_JPRB, 0.37567943E-03_JPRB, 0.37555266E-03_JPRB, 0.37545780E-03_JPRB, &
  & 0.37538139E-03_JPRB, 0.37532782E-03_JPRB, 0.37529576E-03_JPRB, 0.37528182E-03_JPRB, 0.37528461E-03_JPRB, 0.37527965E-03_JPRB, &
  & 0.37525659E-03_JPRB, 0.37523997E-03_JPRB, 0.37523765E-03_JPRB, 0.37522962E-03_JPRB  /)

RGHG1(:,25, 8) = (/ &
  & 0.37516944E-03_JPRB, 0.37514874E-03_JPRB, 0.37511323E-03_JPRB, 0.37502279E-03_JPRB, 0.37490222E-03_JPRB, 0.37476179E-03_JPRB, &
  & 0.37460073E-03_JPRB, 0.37442900E-03_JPRB, 0.37428182E-03_JPRB, 0.37422949E-03_JPRB, 0.37432261E-03_JPRB, 0.37458267E-03_JPRB, &
  & 0.37497960E-03_JPRB, 0.37545537E-03_JPRB, 0.37591761E-03_JPRB, 0.37630053E-03_JPRB, 0.37654879E-03_JPRB, 0.37665592E-03_JPRB, &
  & 0.37670009E-03_JPRB, 0.37673534E-03_JPRB, 0.37676998E-03_JPRB, 0.37679644E-03_JPRB, 0.37686194E-03_JPRB, 0.37697643E-03_JPRB, &
  & 0.37707372E-03_JPRB, 0.37721253E-03_JPRB, 0.37747454E-03_JPRB, 0.37803050E-03_JPRB, 0.37903659E-03_JPRB, 0.38023489E-03_JPRB, &
  & 0.38112071E-03_JPRB, 0.38141107E-03_JPRB, 0.38144098E-03_JPRB, 0.38142615E-03_JPRB, 0.38138871E-03_JPRB, 0.38131520E-03_JPRB, &
  & 0.38119959E-03_JPRB, 0.38101010E-03_JPRB, 0.38079228E-03_JPRB, 0.38056741E-03_JPRB, 0.38029542E-03_JPRB, 0.37997961E-03_JPRB, &
  & 0.37958248E-03_JPRB, 0.37905720E-03_JPRB, 0.37848879E-03_JPRB, 0.37796380E-03_JPRB, 0.37758858E-03_JPRB, 0.37731766E-03_JPRB, &
  & 0.37707170E-03_JPRB, 0.37680935E-03_JPRB, 0.37656539E-03_JPRB, 0.37638150E-03_JPRB, 0.37624872E-03_JPRB, 0.37614332E-03_JPRB, &
  & 0.37606202E-03_JPRB, 0.37600441E-03_JPRB, 0.37596971E-03_JPRB, 0.37595285E-03_JPRB, 0.37594530E-03_JPRB, 0.37592763E-03_JPRB, &
  & 0.37589517E-03_JPRB, 0.37587545E-03_JPRB, 0.37586805E-03_JPRB, 0.37585982E-03_JPRB  /)

RGHG1(:,26, 8) = (/ &
  & 0.37562356E-03_JPRB, 0.37554611E-03_JPRB, 0.37548187E-03_JPRB, 0.37537403E-03_JPRB, 0.37523744E-03_JPRB, 0.37507929E-03_JPRB, &
  & 0.37489861E-03_JPRB, 0.37471471E-03_JPRB, 0.37456689E-03_JPRB, 0.37452452E-03_JPRB, 0.37463000E-03_JPRB, 0.37490246E-03_JPRB, &
  & 0.37531707E-03_JPRB, 0.37580866E-03_JPRB, 0.37627987E-03_JPRB, 0.37666158E-03_JPRB, 0.37690810E-03_JPRB, 0.37702185E-03_JPRB, &
  & 0.37706939E-03_JPRB, 0.37711250E-03_JPRB, 0.37715527E-03_JPRB, 0.37719155E-03_JPRB, 0.37728941E-03_JPRB, 0.37743138E-03_JPRB, &
  & 0.37757457E-03_JPRB, 0.37776535E-03_JPRB, 0.37807286E-03_JPRB, 0.37867799E-03_JPRB, 0.37969273E-03_JPRB, 0.38082288E-03_JPRB, &
  & 0.38157765E-03_JPRB, 0.38180319E-03_JPRB, 0.38184789E-03_JPRB, 0.38186131E-03_JPRB, 0.38183978E-03_JPRB, 0.38175492E-03_JPRB, &
  & 0.38162586E-03_JPRB, 0.38147237E-03_JPRB, 0.38129462E-03_JPRB, 0.38108673E-03_JPRB, 0.38083956E-03_JPRB, 0.38055304E-03_JPRB, &
  & 0.38015401E-03_JPRB, 0.37963984E-03_JPRB, 0.37909882E-03_JPRB, 0.37861528E-03_JPRB, 0.37827348E-03_JPRB, 0.37799397E-03_JPRB, &
  & 0.37770515E-03_JPRB, 0.37741526E-03_JPRB, 0.37716336E-03_JPRB, 0.37697992E-03_JPRB, 0.37684588E-03_JPRB, 0.37673468E-03_JPRB, &
  & 0.37665378E-03_JPRB, 0.37659566E-03_JPRB, 0.37655661E-03_JPRB, 0.37653118E-03_JPRB, 0.37650759E-03_JPRB, 0.37647935E-03_JPRB, &
  & 0.37643816E-03_JPRB, 0.37641255E-03_JPRB, 0.37639564E-03_JPRB, 0.37637572E-03_JPRB  /)

RGHG1(:,27, 8) = (/ &
  & 0.37605577E-03_JPRB, 0.37591030E-03_JPRB, 0.37581191E-03_JPRB, 0.37569020E-03_JPRB, 0.37554308E-03_JPRB, 0.37537141E-03_JPRB, &
  & 0.37517221E-03_JPRB, 0.37497760E-03_JPRB, 0.37483286E-03_JPRB, 0.37480619E-03_JPRB, 0.37492914E-03_JPRB, 0.37521731E-03_JPRB, &
  & 0.37565001E-03_JPRB, 0.37615977E-03_JPRB, 0.37664458E-03_JPRB, 0.37702989E-03_JPRB, 0.37728229E-03_JPRB, 0.37740850E-03_JPRB, &
  & 0.37746219E-03_JPRB, 0.37751364E-03_JPRB, 0.37756641E-03_JPRB, 0.37761525E-03_JPRB, 0.37775103E-03_JPRB, 0.37792503E-03_JPRB, &
  & 0.37813107E-03_JPRB, 0.37839330E-03_JPRB, 0.37875488E-03_JPRB, 0.37939688E-03_JPRB, 0.38038221E-03_JPRB, 0.38141274E-03_JPRB, &
  & 0.38202812E-03_JPRB, 0.38220336E-03_JPRB, 0.38227080E-03_JPRB, 0.38231125E-03_JPRB, 0.38230174E-03_JPRB, 0.38220346E-03_JPRB, &
  & 0.38205913E-03_JPRB, 0.38193908E-03_JPRB, 0.38179600E-03_JPRB, 0.38159636E-03_JPRB, 0.38136885E-03_JPRB, 0.38110919E-03_JPRB, &
  & 0.38070745E-03_JPRB, 0.38020907E-03_JPRB, 0.37969921E-03_JPRB, 0.37926228E-03_JPRB, 0.37894997E-03_JPRB, 0.37865063E-03_JPRB, &
  & 0.37831098E-03_JPRB, 0.37799827E-03_JPRB, 0.37774523E-03_JPRB, 0.37756715E-03_JPRB, 0.37743354E-03_JPRB, 0.37731804E-03_JPRB, &
  & 0.37723951E-03_JPRB, 0.37718218E-03_JPRB, 0.37713795E-03_JPRB, 0.37710147E-03_JPRB, 0.37705901E-03_JPRB, 0.37702050E-03_JPRB, &
  & 0.37697044E-03_JPRB, 0.37693763E-03_JPRB, 0.37690913E-03_JPRB, 0.37687271E-03_JPRB  /)

RGHG1(:,28, 8) = (/ &
  & 0.37636694E-03_JPRB, 0.37616637E-03_JPRB, 0.37599884E-03_JPRB, 0.37585685E-03_JPRB, 0.37571383E-03_JPRB, 0.37554950E-03_JPRB, &
  & 0.37534258E-03_JPRB, 0.37514566E-03_JPRB, 0.37500504E-03_JPRB, 0.37499771E-03_JPRB, 0.37514246E-03_JPRB, 0.37545287E-03_JPRB, &
  & 0.37590536E-03_JPRB, 0.37644168E-03_JPRB, 0.37694334E-03_JPRB, 0.37734271E-03_JPRB, 0.37761427E-03_JPRB, 0.37775946E-03_JPRB, &
  & 0.37782388E-03_JPRB, 0.37787551E-03_JPRB, 0.37794433E-03_JPRB, 0.37804230E-03_JPRB, 0.37822632E-03_JPRB, 0.37846872E-03_JPRB, &
  & 0.37877473E-03_JPRB, 0.37915060E-03_JPRB, 0.37958042E-03_JPRB, 0.38018419E-03_JPRB, 0.38101843E-03_JPRB, 0.38188033E-03_JPRB, &
  & 0.38239542E-03_JPRB, 0.38256818E-03_JPRB, 0.38266185E-03_JPRB, 0.38271932E-03_JPRB, 0.38271115E-03_JPRB, 0.38261670E-03_JPRB, &
  & 0.38249107E-03_JPRB, 0.38239382E-03_JPRB, 0.38226143E-03_JPRB, 0.38206036E-03_JPRB, 0.38183311E-03_JPRB, 0.38157363E-03_JPRB, &
  & 0.38117936E-03_JPRB, 0.38069194E-03_JPRB, 0.38020282E-03_JPRB, 0.37979977E-03_JPRB, 0.37947696E-03_JPRB, 0.37913395E-03_JPRB, &
  & 0.37878335E-03_JPRB, 0.37848788E-03_JPRB, 0.37825052E-03_JPRB, 0.37808357E-03_JPRB, 0.37794707E-03_JPRB, 0.37782179E-03_JPRB, &
  & 0.37772223E-03_JPRB, 0.37764491E-03_JPRB, 0.37758060E-03_JPRB, 0.37752780E-03_JPRB, 0.37747142E-03_JPRB, 0.37741794E-03_JPRB, &
  & 0.37736040E-03_JPRB, 0.37731937E-03_JPRB, 0.37728022E-03_JPRB, 0.37722604E-03_JPRB  /)

RGHG1(:,29, 8) = (/ &
  & 0.37669141E-03_JPRB, 0.37643301E-03_JPRB, 0.37619071E-03_JPRB, 0.37602696E-03_JPRB, 0.37588892E-03_JPRB, 0.37573325E-03_JPRB, &
  & 0.37551862E-03_JPRB, 0.37531962E-03_JPRB, 0.37518341E-03_JPRB, 0.37519672E-03_JPRB, 0.37536477E-03_JPRB, 0.37569903E-03_JPRB, &
  & 0.37617256E-03_JPRB, 0.37673740E-03_JPRB, 0.37725704E-03_JPRB, 0.37767175E-03_JPRB, 0.37796419E-03_JPRB, 0.37812979E-03_JPRB, &
  & 0.37820576E-03_JPRB, 0.37825724E-03_JPRB, 0.37834333E-03_JPRB, 0.37849495E-03_JPRB, 0.37873053E-03_JPRB, 0.37904698E-03_JPRB, &
  & 0.37946053E-03_JPRB, 0.37995863E-03_JPRB, 0.38046138E-03_JPRB, 0.38102137E-03_JPRB, 0.38169025E-03_JPRB, 0.38237048E-03_JPRB, &
  & 0.38278100E-03_JPRB, 0.38295320E-03_JPRB, 0.38307482E-03_JPRB, 0.38314987E-03_JPRB, 0.38314267E-03_JPRB, 0.38305304E-03_JPRB, &
  & 0.38294869E-03_JPRB, 0.38287514E-03_JPRB, 0.38275302E-03_JPRB, 0.38255003E-03_JPRB, 0.38232222E-03_JPRB, 0.38206178E-03_JPRB, &
  & 0.38167585E-03_JPRB, 0.38119984E-03_JPRB, 0.38073225E-03_JPRB, 0.38036453E-03_JPRB, 0.38002888E-03_JPRB, 0.37963856E-03_JPRB, &
  & 0.37927808E-03_JPRB, 0.37900260E-03_JPRB, 0.37878259E-03_JPRB, 0.37862769E-03_JPRB, 0.37848797E-03_JPRB, 0.37835209E-03_JPRB, &
  & 0.37822925E-03_JPRB, 0.37812984E-03_JPRB, 0.37804360E-03_JPRB, 0.37797330E-03_JPRB, 0.37790238E-03_JPRB, 0.37783284E-03_JPRB, &
  & 0.37776743E-03_JPRB, 0.37771765E-03_JPRB, 0.37766725E-03_JPRB, 0.37759419E-03_JPRB  /)

RGHG1(:,30, 8) = (/ &
  & 0.37721606E-03_JPRB, 0.37687435E-03_JPRB, 0.37655649E-03_JPRB, 0.37630410E-03_JPRB, 0.37611421E-03_JPRB, 0.37595827E-03_JPRB, &
  & 0.37573404E-03_JPRB, 0.37550801E-03_JPRB, 0.37536433E-03_JPRB, 0.37538846E-03_JPRB, 0.37557740E-03_JPRB, 0.37594147E-03_JPRB, &
  & 0.37644175E-03_JPRB, 0.37703124E-03_JPRB, 0.37758865E-03_JPRB, 0.37803384E-03_JPRB, 0.37836151E-03_JPRB, 0.37855535E-03_JPRB, &
  & 0.37866189E-03_JPRB, 0.37874659E-03_JPRB, 0.37887044E-03_JPRB, 0.37908455E-03_JPRB, 0.37939821E-03_JPRB, 0.37978739E-03_JPRB, &
  & 0.38026990E-03_JPRB, 0.38079627E-03_JPRB, 0.38130387E-03_JPRB, 0.38178439E-03_JPRB, 0.38229973E-03_JPRB, 0.38282578E-03_JPRB, &
  & 0.38316114E-03_JPRB, 0.38333891E-03_JPRB, 0.38347622E-03_JPRB, 0.38355079E-03_JPRB, 0.38354550E-03_JPRB, 0.38348255E-03_JPRB, &
  & 0.38341857E-03_JPRB, 0.38336641E-03_JPRB, 0.38325680E-03_JPRB, 0.38306114E-03_JPRB, 0.38283269E-03_JPRB, 0.38255997E-03_JPRB, &
  & 0.38217653E-03_JPRB, 0.38170666E-03_JPRB, 0.38124791E-03_JPRB, 0.38088036E-03_JPRB, 0.38053066E-03_JPRB, 0.38016238E-03_JPRB, &
  & 0.37984599E-03_JPRB, 0.37958083E-03_JPRB, 0.37934813E-03_JPRB, 0.37915486E-03_JPRB, 0.37898403E-03_JPRB, 0.37881590E-03_JPRB, &
  & 0.37864533E-03_JPRB, 0.37849165E-03_JPRB, 0.37835932E-03_JPRB, 0.37826861E-03_JPRB, 0.37818315E-03_JPRB, 0.37809405E-03_JPRB, &
  & 0.37802602E-03_JPRB, 0.37796713E-03_JPRB, 0.37790734E-03_JPRB, 0.37782601E-03_JPRB  /)

RGHG1(:,31, 8) = (/ &
  & 0.37776904E-03_JPRB, 0.37733954E-03_JPRB, 0.37694206E-03_JPRB, 0.37659622E-03_JPRB, 0.37635164E-03_JPRB, 0.37619541E-03_JPRB, &
  & 0.37596105E-03_JPRB, 0.37570653E-03_JPRB, 0.37555496E-03_JPRB, 0.37559047E-03_JPRB, 0.37580144E-03_JPRB, 0.37619690E-03_JPRB, &
  & 0.37672539E-03_JPRB, 0.37734084E-03_JPRB, 0.37793806E-03_JPRB, 0.37841540E-03_JPRB, 0.37878020E-03_JPRB, 0.37900379E-03_JPRB, &
  & 0.37914255E-03_JPRB, 0.37926230E-03_JPRB, 0.37942595E-03_JPRB, 0.37970591E-03_JPRB, 0.38010187E-03_JPRB, 0.38056769E-03_JPRB, &
  & 0.38112282E-03_JPRB, 0.38167887E-03_JPRB, 0.38219154E-03_JPRB, 0.38258827E-03_JPRB, 0.38294186E-03_JPRB, 0.38330548E-03_JPRB, &
  & 0.38356167E-03_JPRB, 0.38374532E-03_JPRB, 0.38389914E-03_JPRB, 0.38397320E-03_JPRB, 0.38396991E-03_JPRB, 0.38393508E-03_JPRB, &
  & 0.38391367E-03_JPRB, 0.38388405E-03_JPRB, 0.38378761E-03_JPRB, 0.38359969E-03_JPRB, 0.38337058E-03_JPRB, 0.38308491E-03_JPRB, &
  & 0.38270406E-03_JPRB, 0.38224068E-03_JPRB, 0.38179122E-03_JPRB, 0.38142383E-03_JPRB, 0.38105931E-03_JPRB, 0.38071432E-03_JPRB, &
  & 0.38044444E-03_JPRB, 0.38019014E-03_JPRB, 0.37994405E-03_JPRB, 0.37971031E-03_JPRB, 0.37950666E-03_JPRB, 0.37930452E-03_JPRB, &
  & 0.37908366E-03_JPRB, 0.37887276E-03_JPRB, 0.37869185E-03_JPRB, 0.37857963E-03_JPRB, 0.37847884E-03_JPRB, 0.37836913E-03_JPRB, &
  & 0.37829835E-03_JPRB, 0.37822986E-03_JPRB, 0.37816017E-03_JPRB, 0.37807014E-03_JPRB  /)

RGHG1(:,32, 8) = (/ &
  & 0.37857708E-03_JPRB, 0.37809071E-03_JPRB, 0.37762734E-03_JPRB, 0.37717058E-03_JPRB, 0.37678152E-03_JPRB, 0.37656542E-03_JPRB, &
  & 0.37632719E-03_JPRB, 0.37603440E-03_JPRB, 0.37584453E-03_JPRB, 0.37587130E-03_JPRB, 0.37610292E-03_JPRB, 0.37652701E-03_JPRB, &
  & 0.37708720E-03_JPRB, 0.37774469E-03_JPRB, 0.37840083E-03_JPRB, 0.37892360E-03_JPRB, 0.37934288E-03_JPRB, 0.37962032E-03_JPRB, &
  & 0.37981961E-03_JPRB, 0.38000673E-03_JPRB, 0.38023667E-03_JPRB, 0.38057609E-03_JPRB, 0.38100428E-03_JPRB, 0.38147452E-03_JPRB, &
  & 0.38198529E-03_JPRB, 0.38245125E-03_JPRB, 0.38288194E-03_JPRB, 0.38318518E-03_JPRB, 0.38342645E-03_JPRB, 0.38368708E-03_JPRB, &
  & 0.38390468E-03_JPRB, 0.38410408E-03_JPRB, 0.38428399E-03_JPRB, 0.38437535E-03_JPRB, 0.38439188E-03_JPRB, 0.38438286E-03_JPRB, &
  & 0.38438749E-03_JPRB, 0.38438589E-03_JPRB, 0.38431917E-03_JPRB, 0.38416044E-03_JPRB, 0.38395263E-03_JPRB, 0.38368548E-03_JPRB, &
  & 0.38333798E-03_JPRB, 0.38291388E-03_JPRB, 0.38249786E-03_JPRB, 0.38216151E-03_JPRB, 0.38183992E-03_JPRB, 0.38152782E-03_JPRB, &
  & 0.38124032E-03_JPRB, 0.38092644E-03_JPRB, 0.38062634E-03_JPRB, 0.38033552E-03_JPRB, 0.38008595E-03_JPRB, 0.37984482E-03_JPRB, &
  & 0.37959018E-03_JPRB, 0.37932335E-03_JPRB, 0.37909201E-03_JPRB, 0.37894789E-03_JPRB, 0.37884024E-03_JPRB, 0.37869992E-03_JPRB, &
  & 0.37860170E-03_JPRB, 0.37847692E-03_JPRB, 0.37836218E-03_JPRB, 0.37821649E-03_JPRB  /)

RGHG1(:,33, 8) = (/ &
  & 0.37944986E-03_JPRB, 0.37890840E-03_JPRB, 0.37837831E-03_JPRB, 0.37780402E-03_JPRB, 0.37725319E-03_JPRB, 0.37696715E-03_JPRB, &
  & 0.37672571E-03_JPRB, 0.37639190E-03_JPRB, 0.37615828E-03_JPRB, 0.37617335E-03_JPRB, 0.37642625E-03_JPRB, 0.37687975E-03_JPRB, &
  & 0.37747332E-03_JPRB, 0.37817660E-03_JPRB, 0.37889643E-03_JPRB, 0.37946813E-03_JPRB, 0.37994629E-03_JPRB, 0.38028282E-03_JPRB, &
  & 0.38054867E-03_JPRB, 0.38081000E-03_JPRB, 0.38111224E-03_JPRB, 0.38151264E-03_JPRB, 0.38196785E-03_JPRB, 0.38243333E-03_JPRB, &
  & 0.38288284E-03_JPRB, 0.38323968E-03_JPRB, 0.38357391E-03_JPRB, 0.38377872E-03_JPRB, 0.38390967E-03_JPRB, 0.38407097E-03_JPRB, &
  & 0.38425370E-03_JPRB, 0.38447074E-03_JPRB, 0.38467900E-03_JPRB, 0.38479067E-03_JPRB, 0.38483008E-03_JPRB, 0.38484760E-03_JPRB, &
  & 0.38487715E-03_JPRB, 0.38490536E-03_JPRB, 0.38487169E-03_JPRB, 0.38474607E-03_JPRB, 0.38456325E-03_JPRB, 0.38431941E-03_JPRB, &
  & 0.38401055E-03_JPRB, 0.38363154E-03_JPRB, 0.38325339E-03_JPRB, 0.38295329E-03_JPRB, 0.38268378E-03_JPRB, 0.38240710E-03_JPRB, &
  & 0.38209301E-03_JPRB, 0.38170807E-03_JPRB, 0.38134658E-03_JPRB, 0.38099430E-03_JPRB, 0.38069531E-03_JPRB, 0.38041302E-03_JPRB, &
  & 0.38012541E-03_JPRB, 0.37980061E-03_JPRB, 0.37951664E-03_JPRB, 0.37933800E-03_JPRB, 0.37922434E-03_JPRB, 0.37905091E-03_JPRB, &
  & 0.37892098E-03_JPRB, 0.37873166E-03_JPRB, 0.37856553E-03_JPRB, 0.37835594E-03_JPRB  /)

RGHG1(:,34, 8) = (/ &
  & 0.38024841E-03_JPRB, 0.37970247E-03_JPRB, 0.37912354E-03_JPRB, 0.37848272E-03_JPRB, 0.37782004E-03_JPRB, 0.37742930E-03_JPRB, &
  & 0.37716065E-03_JPRB, 0.37681774E-03_JPRB, 0.37655109E-03_JPRB, 0.37654841E-03_JPRB, 0.37680966E-03_JPRB, 0.37727910E-03_JPRB, &
  & 0.37791004E-03_JPRB, 0.37866696E-03_JPRB, 0.37944171E-03_JPRB, 0.38006233E-03_JPRB, 0.38058267E-03_JPRB, 0.38097026E-03_JPRB, &
  & 0.38129676E-03_JPRB, 0.38161145E-03_JPRB, 0.38195636E-03_JPRB, 0.38238118E-03_JPRB, 0.38280349E-03_JPRB, 0.38319865E-03_JPRB, &
  & 0.38353973E-03_JPRB, 0.38377223E-03_JPRB, 0.38399343E-03_JPRB, 0.38412708E-03_JPRB, 0.38420166E-03_JPRB, 0.38430836E-03_JPRB, &
  & 0.38447342E-03_JPRB, 0.38471032E-03_JPRB, 0.38495183E-03_JPRB, 0.38510612E-03_JPRB, 0.38518320E-03_JPRB, 0.38521621E-03_JPRB, &
  & 0.38525384E-03_JPRB, 0.38530008E-03_JPRB, 0.38528613E-03_JPRB, 0.38519122E-03_JPRB, 0.38505887E-03_JPRB, 0.38487281E-03_JPRB, &
  & 0.38461391E-03_JPRB, 0.38428395E-03_JPRB, 0.38396220E-03_JPRB, 0.38369411E-03_JPRB, 0.38344877E-03_JPRB, 0.38319016E-03_JPRB, &
  & 0.38285039E-03_JPRB, 0.38241913E-03_JPRB, 0.38200167E-03_JPRB, 0.38160646E-03_JPRB, 0.38127231E-03_JPRB, 0.38095158E-03_JPRB, &
  & 0.38063356E-03_JPRB, 0.38027552E-03_JPRB, 0.37997039E-03_JPRB, 0.37976998E-03_JPRB, 0.37964462E-03_JPRB, 0.37943652E-03_JPRB, &
  & 0.37922220E-03_JPRB, 0.37893549E-03_JPRB, 0.37871715E-03_JPRB, 0.37846326E-03_JPRB  /)

RGHG1(:,35, 8) = (/ &
  & 0.38103133E-03_JPRB, 0.38050677E-03_JPRB, 0.37988678E-03_JPRB, 0.37920374E-03_JPRB, 0.37845168E-03_JPRB, 0.37793544E-03_JPRB, &
  & 0.37762652E-03_JPRB, 0.37729062E-03_JPRB, 0.37699553E-03_JPRB, 0.37697147E-03_JPRB, 0.37723467E-03_JPRB, 0.37771359E-03_JPRB, &
  & 0.37838501E-03_JPRB, 0.37920110E-03_JPRB, 0.38002782E-03_JPRB, 0.38069871E-03_JPRB, 0.38125387E-03_JPRB, 0.38168986E-03_JPRB, &
  & 0.38207566E-03_JPRB, 0.38243452E-03_JPRB, 0.38280807E-03_JPRB, 0.38323926E-03_JPRB, 0.38359701E-03_JPRB, 0.38388622E-03_JPRB, &
  & 0.38409161E-03_JPRB, 0.38418848E-03_JPRB, 0.38428496E-03_JPRB, 0.38435943E-03_JPRB, 0.38440374E-03_JPRB, 0.38447725E-03_JPRB, &
  & 0.38463295E-03_JPRB, 0.38489142E-03_JPRB, 0.38516963E-03_JPRB, 0.38537920E-03_JPRB, 0.38550260E-03_JPRB, 0.38554587E-03_JPRB, &
  & 0.38558318E-03_JPRB, 0.38564189E-03_JPRB, 0.38564138E-03_JPRB, 0.38557680E-03_JPRB, 0.38550941E-03_JPRB, 0.38540045E-03_JPRB, &
  & 0.38519872E-03_JPRB, 0.38492124E-03_JPRB, 0.38466698E-03_JPRB, 0.38442962E-03_JPRB, 0.38419480E-03_JPRB, 0.38394587E-03_JPRB, &
  & 0.38358019E-03_JPRB, 0.38311397E-03_JPRB, 0.38264175E-03_JPRB, 0.38221193E-03_JPRB, 0.38184893E-03_JPRB, 0.38149007E-03_JPRB, &
  & 0.38114211E-03_JPRB, 0.38076256E-03_JPRB, 0.38045185E-03_JPRB, 0.38023559E-03_JPRB, 0.38009529E-03_JPRB, 0.37985075E-03_JPRB, &
  & 0.37952262E-03_JPRB, 0.37911892E-03_JPRB, 0.37884648E-03_JPRB, 0.37855712E-03_JPRB  /)

RGHG1(:,36, 8) = (/ &
  & 0.38191393E-03_JPRB, 0.38140687E-03_JPRB, 0.38073316E-03_JPRB, 0.37997536E-03_JPRB, 0.37911064E-03_JPRB, 0.37847935E-03_JPRB, &
  & 0.37810075E-03_JPRB, 0.37776929E-03_JPRB, 0.37746460E-03_JPRB, 0.37741901E-03_JPRB, 0.37767511E-03_JPRB, 0.37815789E-03_JPRB, &
  & 0.37886478E-03_JPRB, 0.37973592E-03_JPRB, 0.38060891E-03_JPRB, 0.38132736E-03_JPRB, 0.38191178E-03_JPRB, 0.38238627E-03_JPRB, &
  & 0.38281619E-03_JPRB, 0.38320378E-03_JPRB, 0.38358768E-03_JPRB, 0.38399317E-03_JPRB, 0.38426585E-03_JPRB, 0.38443822E-03_JPRB, &
  & 0.38451051E-03_JPRB, 0.38448354E-03_JPRB, 0.38447071E-03_JPRB, 0.38450108E-03_JPRB, 0.38454382E-03_JPRB, 0.38460954E-03_JPRB, &
  & 0.38476618E-03_JPRB, 0.38503647E-03_JPRB, 0.38534149E-03_JPRB, 0.38559313E-03_JPRB, 0.38575604E-03_JPRB, 0.38581023E-03_JPRB, &
  & 0.38584592E-03_JPRB, 0.38590422E-03_JPRB, 0.38590269E-03_JPRB, 0.38586382E-03_JPRB, 0.38585385E-03_JPRB, 0.38581359E-03_JPRB, &
  & 0.38567344E-03_JPRB, 0.38545465E-03_JPRB, 0.38527073E-03_JPRB, 0.38507429E-03_JPRB, 0.38486025E-03_JPRB, 0.38463725E-03_JPRB, &
  & 0.38426619E-03_JPRB, 0.38378321E-03_JPRB, 0.38326786E-03_JPRB, 0.38281422E-03_JPRB, 0.38243198E-03_JPRB, 0.38204478E-03_JPRB, &
  & 0.38167510E-03_JPRB, 0.38127831E-03_JPRB, 0.38095789E-03_JPRB, 0.38072491E-03_JPRB, 0.38057230E-03_JPRB, 0.38029928E-03_JPRB, &
  & 0.37986683E-03_JPRB, 0.37934305E-03_JPRB, 0.37901279E-03_JPRB, 0.37869483E-03_JPRB  /)

RGHG1(:,37, 8) = (/ &
  & 0.38297014E-03_JPRB, 0.38247064E-03_JPRB, 0.38171747E-03_JPRB, 0.38081498E-03_JPRB, 0.37979124E-03_JPRB, 0.37907600E-03_JPRB, &
  & 0.37856463E-03_JPRB, 0.37823144E-03_JPRB, 0.37796099E-03_JPRB, 0.37789483E-03_JPRB, 0.37812353E-03_JPRB, 0.37859701E-03_JPRB, &
  & 0.37932573E-03_JPRB, 0.38023902E-03_JPRB, 0.38114235E-03_JPRB, 0.38189918E-03_JPRB, 0.38249829E-03_JPRB, 0.38298621E-03_JPRB, &
  & 0.38342267E-03_JPRB, 0.38380180E-03_JPRB, 0.38415344E-03_JPRB, 0.38446131E-03_JPRB, 0.38460722E-03_JPRB, 0.38464503E-03_JPRB, &
  & 0.38459848E-03_JPRB, 0.38448240E-03_JPRB, 0.38440241E-03_JPRB, 0.38442594E-03_JPRB, 0.38453303E-03_JPRB, 0.38464972E-03_JPRB, &
  & 0.38483082E-03_JPRB, 0.38508983E-03_JPRB, 0.38539731E-03_JPRB, 0.38565813E-03_JPRB, 0.38584251E-03_JPRB, 0.38590846E-03_JPRB, &
  & 0.38593964E-03_JPRB, 0.38596802E-03_JPRB, 0.38593238E-03_JPRB, 0.38590700E-03_JPRB, 0.38593360E-03_JPRB, 0.38593850E-03_JPRB, &
  & 0.38586622E-03_JPRB, 0.38571670E-03_JPRB, 0.38560527E-03_JPRB, 0.38547060E-03_JPRB, 0.38529955E-03_JPRB, 0.38513813E-03_JPRB, &
  & 0.38480910E-03_JPRB, 0.38435209E-03_JPRB, 0.38382295E-03_JPRB, 0.38337177E-03_JPRB, 0.38299348E-03_JPRB, 0.38260215E-03_JPRB, &
  & 0.38223097E-03_JPRB, 0.38182776E-03_JPRB, 0.38148882E-03_JPRB, 0.38123815E-03_JPRB, 0.38108002E-03_JPRB, 0.38079854E-03_JPRB, &
  & 0.38029000E-03_JPRB, 0.37964653E-03_JPRB, 0.37925355E-03_JPRB, 0.37892449E-03_JPRB  /)

RGHG1(:,38, 8) = (/ &
  & 0.38414211E-03_JPRB, 0.38365098E-03_JPRB, 0.38280966E-03_JPRB, 0.38174662E-03_JPRB, 0.38054642E-03_JPRB, 0.37973803E-03_JPRB, &
  & 0.37907935E-03_JPRB, 0.37874423E-03_JPRB, 0.37851177E-03_JPRB, 0.37842279E-03_JPRB, 0.37862108E-03_JPRB, 0.37908425E-03_JPRB, &
  & 0.37983719E-03_JPRB, 0.38079725E-03_JPRB, 0.38173426E-03_JPRB, 0.38253367E-03_JPRB, 0.38314908E-03_JPRB, 0.38365190E-03_JPRB, &
  & 0.38409561E-03_JPRB, 0.38446536E-03_JPRB, 0.38478120E-03_JPRB, 0.38498075E-03_JPRB, 0.38498601E-03_JPRB, 0.38487452E-03_JPRB, &
  & 0.38469608E-03_JPRB, 0.38448113E-03_JPRB, 0.38432663E-03_JPRB, 0.38434257E-03_JPRB, 0.38452105E-03_JPRB, 0.38469430E-03_JPRB, &
  & 0.38490255E-03_JPRB, 0.38514905E-03_JPRB, 0.38545926E-03_JPRB, 0.38573025E-03_JPRB, 0.38593845E-03_JPRB, 0.38601744E-03_JPRB, &
  & 0.38604364E-03_JPRB, 0.38603881E-03_JPRB, 0.38596531E-03_JPRB, 0.38595490E-03_JPRB, 0.38602209E-03_JPRB, 0.38607709E-03_JPRB, &
  & 0.38608013E-03_JPRB, 0.38600746E-03_JPRB, 0.38597647E-03_JPRB, 0.38591033E-03_JPRB, 0.38578699E-03_JPRB, 0.38569391E-03_JPRB, &
  & 0.38541152E-03_JPRB, 0.38498332E-03_JPRB, 0.38443887E-03_JPRB, 0.38399042E-03_JPRB, 0.38361652E-03_JPRB, 0.38322060E-03_JPRB, &
  & 0.38284775E-03_JPRB, 0.38243743E-03_JPRB, 0.38207793E-03_JPRB, 0.38180763E-03_JPRB, 0.38164338E-03_JPRB, 0.38135252E-03_JPRB, &
  & 0.38075954E-03_JPRB, 0.37998327E-03_JPRB, 0.37952069E-03_JPRB, 0.37917933E-03_JPRB  /)

RGHG1(:,39, 8) = (/ &
  & 0.38515207E-03_JPRB, 0.38468193E-03_JPRB, 0.38373176E-03_JPRB, 0.38248896E-03_JPRB, 0.38116183E-03_JPRB, 0.38027242E-03_JPRB, &
  & 0.37949986E-03_JPRB, 0.37912603E-03_JPRB, 0.37893396E-03_JPRB, 0.37883660E-03_JPRB, 0.37900269E-03_JPRB, 0.37944703E-03_JPRB, &
  & 0.38019441E-03_JPRB, 0.38116475E-03_JPRB, 0.38211367E-03_JPRB, 0.38293289E-03_JPRB, 0.38356379E-03_JPRB, 0.38407763E-03_JPRB, &
  & 0.38450763E-03_JPRB, 0.38483388E-03_JPRB, 0.38507920E-03_JPRB, 0.38516921E-03_JPRB, 0.38505982E-03_JPRB, 0.38483368E-03_JPRB, &
  & 0.38456604E-03_JPRB, 0.38433023E-03_JPRB, 0.38421073E-03_JPRB, 0.38431203E-03_JPRB, 0.38454385E-03_JPRB, 0.38475483E-03_JPRB, &
  & 0.38498718E-03_JPRB, 0.38523583E-03_JPRB, 0.38551173E-03_JPRB, 0.38575870E-03_JPRB, 0.38593603E-03_JPRB, 0.38599019E-03_JPRB, &
  & 0.38599625E-03_JPRB, 0.38595880E-03_JPRB, 0.38584042E-03_JPRB, 0.38580073E-03_JPRB, 0.38587198E-03_JPRB, 0.38596259E-03_JPRB, &
  & 0.38602682E-03_JPRB, 0.38601169E-03_JPRB, 0.38602581E-03_JPRB, 0.38604089E-03_JPRB, 0.38598823E-03_JPRB, 0.38597956E-03_JPRB, &
  & 0.38576800E-03_JPRB, 0.38539243E-03_JPRB, 0.38487315E-03_JPRB, 0.38444503E-03_JPRB, 0.38411800E-03_JPRB, 0.38377736E-03_JPRB, &
  & 0.38342791E-03_JPRB, 0.38303083E-03_JPRB, 0.38265699E-03_JPRB, 0.38235381E-03_JPRB, 0.38218187E-03_JPRB, 0.38191681E-03_JPRB, &
  & 0.38134853E-03_JPRB, 0.38056989E-03_JPRB, 0.38002404E-03_JPRB, 0.37965815E-03_JPRB  /)

RGHG1(:,40, 8) = (/ &
  & 0.38631085E-03_JPRB, 0.38586740E-03_JPRB, 0.38478611E-03_JPRB, 0.38332918E-03_JPRB, 0.38186121E-03_JPRB, 0.38087868E-03_JPRB, &
  & 0.37997795E-03_JPRB, 0.37955267E-03_JPRB, 0.37940840E-03_JPRB, 0.37930355E-03_JPRB, 0.37943157E-03_JPRB, 0.37985242E-03_JPRB, &
  & 0.38058842E-03_JPRB, 0.38156483E-03_JPRB, 0.38252419E-03_JPRB, 0.38336292E-03_JPRB, 0.38401187E-03_JPRB, 0.38453799E-03_JPRB, &
  & 0.38494847E-03_JPRB, 0.38521809E-03_JPRB, 0.38537498E-03_JPRB, 0.38533623E-03_JPRB, 0.38509656E-03_JPRB, 0.38474153E-03_JPRB, &
  & 0.38437617E-03_JPRB, 0.38412865E-03_JPRB, 0.38406816E-03_JPRB, 0.38428484E-03_JPRB, 0.38457629E-03_JPRB, 0.38482849E-03_JPRB, &
  & 0.38508861E-03_JPRB, 0.38534219E-03_JPRB, 0.38557175E-03_JPRB, 0.38578494E-03_JPRB, 0.38591708E-03_JPRB, 0.38593593E-03_JPRB, &
  & 0.38591588E-03_JPRB, 0.38584022E-03_JPRB, 0.38566802E-03_JPRB, 0.38558674E-03_JPRB, 0.38565677E-03_JPRB, 0.38578680E-03_JPRB, &
  & 0.38592052E-03_JPRB, 0.38596977E-03_JPRB, 0.38603106E-03_JPRB, 0.38614354E-03_JPRB, 0.38617759E-03_JPRB, 0.38627059E-03_JPRB, &
  & 0.38614614E-03_JPRB, 0.38583622E-03_JPRB, 0.38535309E-03_JPRB, 0.38495173E-03_JPRB, 0.38468664E-03_JPRB, 0.38442068E-03_JPRB, &
  & 0.38410277E-03_JPRB, 0.38372457E-03_JPRB, 0.38333493E-03_JPRB, 0.38299098E-03_JPRB, 0.38280976E-03_JPRB, 0.38258073E-03_JPRB, &
  & 0.38205929E-03_JPRB, 0.38129921E-03_JPRB, 0.38065341E-03_JPRB, 0.38025674E-03_JPRB  /)

RGHG1(:,41, 8) = (/ &
  & 0.38772763E-03_JPRB, 0.38731680E-03_JPRB, 0.38607520E-03_JPRB, 0.38435647E-03_JPRB, 0.38271630E-03_JPRB, 0.38161993E-03_JPRB, &
  & 0.38056249E-03_JPRB, 0.38007429E-03_JPRB, 0.37998848E-03_JPRB, 0.37987447E-03_JPRB, 0.37995593E-03_JPRB, 0.38034808E-03_JPRB, &
  & 0.38107014E-03_JPRB, 0.38205399E-03_JPRB, 0.38302610E-03_JPRB, 0.38388869E-03_JPRB, 0.38455971E-03_JPRB, 0.38510085E-03_JPRB, &
  & 0.38548747E-03_JPRB, 0.38568785E-03_JPRB, 0.38573660E-03_JPRB, 0.38554044E-03_JPRB, 0.38514147E-03_JPRB, 0.38462886E-03_JPRB, &
  & 0.38414403E-03_JPRB, 0.38388220E-03_JPRB, 0.38389384E-03_JPRB, 0.38425158E-03_JPRB, 0.38461596E-03_JPRB, 0.38491855E-03_JPRB, &
  & 0.38521262E-03_JPRB, 0.38547222E-03_JPRB, 0.38564514E-03_JPRB, 0.38581702E-03_JPRB, 0.38589393E-03_JPRB, 0.38586958E-03_JPRB, &
  & 0.38581761E-03_JPRB, 0.38569524E-03_JPRB, 0.38545724E-03_JPRB, 0.38532510E-03_JPRB, 0.38539365E-03_JPRB, 0.38557187E-03_JPRB, &
  & 0.38579057E-03_JPRB, 0.38591852E-03_JPRB, 0.38603748E-03_JPRB, 0.38626904E-03_JPRB, 0.38640910E-03_JPRB, 0.38662643E-03_JPRB, &
  & 0.38660846E-03_JPRB, 0.38637881E-03_JPRB, 0.38593989E-03_JPRB, 0.38557123E-03_JPRB, 0.38538189E-03_JPRB, 0.38520723E-03_JPRB, &
  & 0.38492790E-03_JPRB, 0.38457278E-03_JPRB, 0.38416381E-03_JPRB, 0.38377002E-03_JPRB, 0.38357746E-03_JPRB, 0.38339247E-03_JPRB, &
  & 0.38292831E-03_JPRB, 0.38219092E-03_JPRB, 0.38142290E-03_JPRB, 0.38098860E-03_JPRB  /)

RGHG1(:,42, 8) = (/ &
  & 0.38801224E-03_JPRB, 0.38749569E-03_JPRB, 0.38612817E-03_JPRB, 0.38445463E-03_JPRB, 0.38286113E-03_JPRB, 0.38176624E-03_JPRB, &
  & 0.38079241E-03_JPRB, 0.38026332E-03_JPRB, 0.38012483E-03_JPRB, 0.38003333E-03_JPRB, 0.38010341E-03_JPRB, 0.38046113E-03_JPRB, &
  & 0.38113063E-03_JPRB, 0.38207739E-03_JPRB, 0.38301439E-03_JPRB, 0.38387902E-03_JPRB, 0.38456044E-03_JPRB, 0.38509873E-03_JPRB, &
  & 0.38548941E-03_JPRB, 0.38565416E-03_JPRB, 0.38563488E-03_JPRB, 0.38538884E-03_JPRB, 0.38496981E-03_JPRB, 0.38447778E-03_JPRB, &
  & 0.38407795E-03_JPRB, 0.38389088E-03_JPRB, 0.38396207E-03_JPRB, 0.38429721E-03_JPRB, 0.38464057E-03_JPRB, 0.38494570E-03_JPRB, &
  & 0.38524432E-03_JPRB, 0.38551911E-03_JPRB, 0.38572093E-03_JPRB, 0.38585544E-03_JPRB, 0.38591838E-03_JPRB, 0.38589545E-03_JPRB, &
  & 0.38588923E-03_JPRB, 0.38578076E-03_JPRB, 0.38550358E-03_JPRB, 0.38528706E-03_JPRB, 0.38528424E-03_JPRB, 0.38542908E-03_JPRB, &
  & 0.38557464E-03_JPRB, 0.38566329E-03_JPRB, 0.38579651E-03_JPRB, 0.38601176E-03_JPRB, 0.38620750E-03_JPRB, 0.38645816E-03_JPRB, &
  & 0.38649513E-03_JPRB, 0.38631223E-03_JPRB, 0.38592598E-03_JPRB, 0.38561473E-03_JPRB, 0.38548534E-03_JPRB, 0.38538801E-03_JPRB, &
  & 0.38516696E-03_JPRB, 0.38485349E-03_JPRB, 0.38446471E-03_JPRB, 0.38409273E-03_JPRB, 0.38393140E-03_JPRB, 0.38379679E-03_JPRB, &
  & 0.38343809E-03_JPRB, 0.38287499E-03_JPRB, 0.38225053E-03_JPRB, 0.38199808E-03_JPRB  /)

RGHG1(:,43, 8) = (/ &
  & 0.38888134E-03_JPRB, 0.38828236E-03_JPRB, 0.38673101E-03_JPRB, 0.38498608E-03_JPRB, 0.38336109E-03_JPRB, 0.38221858E-03_JPRB, &
  & 0.38125362E-03_JPRB, 0.38066017E-03_JPRB, 0.38049876E-03_JPRB, 0.38042385E-03_JPRB, 0.38046352E-03_JPRB, 0.38077748E-03_JPRB, &
  & 0.38139304E-03_JPRB, 0.38230916E-03_JPRB, 0.38321961E-03_JPRB, 0.38409635E-03_JPRB, 0.38479675E-03_JPRB, 0.38533891E-03_JPRB, &
  & 0.38572302E-03_JPRB, 0.38582550E-03_JPRB, 0.38569763E-03_JPRB, 0.38533837E-03_JPRB, 0.38483251E-03_JPRB, 0.38429148E-03_JPRB, &
  & 0.38391781E-03_JPRB, 0.38379279E-03_JPRB, 0.38394933E-03_JPRB, 0.38432453E-03_JPRB, 0.38468008E-03_JPRB, 0.38500922E-03_JPRB, &
  & 0.38532659E-03_JPRB, 0.38561782E-03_JPRB, 0.38582165E-03_JPRB, 0.38590429E-03_JPRB, 0.38593073E-03_JPRB, 0.38589051E-03_JPRB, &
  & 0.38591231E-03_JPRB, 0.38579643E-03_JPRB, 0.38545519E-03_JPRB, 0.38513980E-03_JPRB, 0.38507123E-03_JPRB, 0.38520634E-03_JPRB, &
  & 0.38532173E-03_JPRB, 0.38540837E-03_JPRB, 0.38557940E-03_JPRB, 0.38583101E-03_JPRB, 0.38612314E-03_JPRB, 0.38645770E-03_JPRB, &
  & 0.38659060E-03_JPRB, 0.38648488E-03_JPRB, 0.38616569E-03_JPRB, 0.38592089E-03_JPRB, 0.38587879E-03_JPRB, 0.38589129E-03_JPRB, &
  & 0.38574001E-03_JPRB, 0.38547446E-03_JPRB, 0.38509579E-03_JPRB, 0.38472227E-03_JPRB, 0.38458456E-03_JPRB, 0.38451485E-03_JPRB, &
  & 0.38427701E-03_JPRB, 0.38388270E-03_JPRB, 0.38333666E-03_JPRB, 0.38323393E-03_JPRB  /)

RGHG1(:,44, 8) = (/ &
  & 0.38895210E-03_JPRB, 0.38812938E-03_JPRB, 0.38655043E-03_JPRB, 0.38480411E-03_JPRB, 0.38327536E-03_JPRB, 0.38218095E-03_JPRB, &
  & 0.38131520E-03_JPRB, 0.38075050E-03_JPRB, 0.38054788E-03_JPRB, 0.38049513E-03_JPRB, 0.38053219E-03_JPRB, 0.38081232E-03_JPRB, &
  & 0.38138014E-03_JPRB, 0.38224275E-03_JPRB, 0.38311626E-03_JPRB, 0.38398641E-03_JPRB, 0.38470079E-03_JPRB, 0.38526559E-03_JPRB, &
  & 0.38563886E-03_JPRB, 0.38572312E-03_JPRB, 0.38557100E-03_JPRB, 0.38519671E-03_JPRB, 0.38468679E-03_JPRB, 0.38418311E-03_JPRB, &
  & 0.38382828E-03_JPRB, 0.38373121E-03_JPRB, 0.38390195E-03_JPRB, 0.38426512E-03_JPRB, 0.38464000E-03_JPRB, 0.38497199E-03_JPRB, &
  & 0.38531095E-03_JPRB, 0.38563625E-03_JPRB, 0.38585102E-03_JPRB, 0.38590731E-03_JPRB, 0.38592523E-03_JPRB, 0.38590196E-03_JPRB, &
  & 0.38592470E-03_JPRB, 0.38578685E-03_JPRB, 0.38546687E-03_JPRB, 0.38511419E-03_JPRB, 0.38497626E-03_JPRB, 0.38504803E-03_JPRB, &
  & 0.38511617E-03_JPRB, 0.38517631E-03_JPRB, 0.38533544E-03_JPRB, 0.38557431E-03_JPRB, 0.38586365E-03_JPRB, 0.38620087E-03_JPRB, &
  & 0.38637445E-03_JPRB, 0.38629147E-03_JPRB, 0.38602142E-03_JPRB, 0.38580555E-03_JPRB, 0.38579066E-03_JPRB, 0.38584023E-03_JPRB, &
  & 0.38572934E-03_JPRB, 0.38549890E-03_JPRB, 0.38515109E-03_JPRB, 0.38480858E-03_JPRB, 0.38467815E-03_JPRB, 0.38466181E-03_JPRB, &
  & 0.38449612E-03_JPRB, 0.38420149E-03_JPRB, 0.38383641E-03_JPRB, 0.38387616E-03_JPRB  /)

RGHG1(:,45, 8) = (/ &
  & 0.38914245E-03_JPRB, 0.38805461E-03_JPRB, 0.38642101E-03_JPRB, 0.38466410E-03_JPRB, 0.38324092E-03_JPRB, 0.38219526E-03_JPRB, &
  & 0.38144356E-03_JPRB, 0.38090346E-03_JPRB, 0.38065104E-03_JPRB, 0.38062561E-03_JPRB, 0.38065586E-03_JPRB, 0.38089194E-03_JPRB, &
  & 0.38139861E-03_JPRB, 0.38219644E-03_JPRB, 0.38302453E-03_JPRB, 0.38388870E-03_JPRB, 0.38462140E-03_JPRB, 0.38521246E-03_JPRB, &
  & 0.38557256E-03_JPRB, 0.38562821E-03_JPRB, 0.38543477E-03_JPRB, 0.38502907E-03_JPRB, 0.38450356E-03_JPRB, 0.38403621E-03_JPRB, &
  & 0.38370612E-03_JPRB, 0.38364871E-03_JPRB, 0.38384639E-03_JPRB, 0.38420094E-03_JPRB, 0.38459936E-03_JPRB, 0.38493763E-03_JPRB, &
  & 0.38530353E-03_JPRB, 0.38566970E-03_JPRB, 0.38589719E-03_JPRB, 0.38591692E-03_JPRB, 0.38592054E-03_JPRB, 0.38591437E-03_JPRB, &
  & 0.38594173E-03_JPRB, 0.38577792E-03_JPRB, 0.38547406E-03_JPRB, 0.38506644E-03_JPRB, 0.38484124E-03_JPRB, 0.38483968E-03_JPRB, &
  & 0.38485022E-03_JPRB, 0.38487993E-03_JPRB, 0.38503028E-03_JPRB, 0.38525923E-03_JPRB, 0.38555758E-03_JPRB, 0.38590842E-03_JPRB, &
  & 0.38614043E-03_JPRB, 0.38609310E-03_JPRB, 0.38588746E-03_JPRB, 0.38571291E-03_JPRB, 0.38574003E-03_JPRB, 0.38584568E-03_JPRB, &
  & 0.38578958E-03_JPRB, 0.38560516E-03_JPRB, 0.38529375E-03_JPRB, 0.38498636E-03_JPRB, 0.38486721E-03_JPRB, 0.38491982E-03_JPRB, &
  & 0.38485153E-03_JPRB, 0.38469170E-03_JPRB, 0.38454255E-03_JPRB, 0.38476341E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART16',0,ZHOOK_HANDLE)



RGHG1(:,46, 8) = (/ &
  & 0.38875460E-03_JPRB, 0.38746792E-03_JPRB, 0.38590380E-03_JPRB, 0.38421598E-03_JPRB, 0.38295828E-03_JPRB, 0.38200578E-03_JPRB, &
  & 0.38133949E-03_JPRB, 0.38083457E-03_JPRB, 0.38057908E-03_JPRB, 0.38057145E-03_JPRB, 0.38062214E-03_JPRB, 0.38083185E-03_JPRB, &
  & 0.38128939E-03_JPRB, 0.38202336E-03_JPRB, 0.38281435E-03_JPRB, 0.38364721E-03_JPRB, 0.38435783E-03_JPRB, 0.38495432E-03_JPRB, &
  & 0.38532113E-03_JPRB, 0.38539751E-03_JPRB, 0.38521009E-03_JPRB, 0.38482290E-03_JPRB, 0.38432677E-03_JPRB, 0.38390387E-03_JPRB, &
  & 0.38360805E-03_JPRB, 0.38356559E-03_JPRB, 0.38378847E-03_JPRB, 0.38414297E-03_JPRB, 0.38454377E-03_JPRB, 0.38487136E-03_JPRB, &
  & 0.38526274E-03_JPRB, 0.38564878E-03_JPRB, 0.38588708E-03_JPRB, 0.38590844E-03_JPRB, 0.38591351E-03_JPRB, 0.38592270E-03_JPRB, &
  & 0.38594206E-03_JPRB, 0.38575805E-03_JPRB, 0.38545799E-03_JPRB, 0.38502837E-03_JPRB, 0.38475377E-03_JPRB, 0.38467838E-03_JPRB, &
  & 0.38464252E-03_JPRB, 0.38464753E-03_JPRB, 0.38476196E-03_JPRB, 0.38496550E-03_JPRB, 0.38521501E-03_JPRB, 0.38553430E-03_JPRB, &
  & 0.38577688E-03_JPRB, 0.38573463E-03_JPRB, 0.38555622E-03_JPRB, 0.38539046E-03_JPRB, 0.38540719E-03_JPRB, 0.38550787E-03_JPRB, &
  & 0.38547457E-03_JPRB, 0.38533149E-03_JPRB, 0.38508295E-03_JPRB, 0.38478228E-03_JPRB, 0.38466544E-03_JPRB, 0.38479228E-03_JPRB, &
  & 0.38478383E-03_JPRB, 0.38475489E-03_JPRB, 0.38475196E-03_JPRB, 0.38509573E-03_JPRB  /)

RGHG1(:,47, 8) = (/ &
  & 0.38818368E-03_JPRB, 0.38667694E-03_JPRB, 0.38521920E-03_JPRB, 0.38362844E-03_JPRB, 0.38257691E-03_JPRB, 0.38174263E-03_JPRB, &
  & 0.38117080E-03_JPRB, 0.38070929E-03_JPRB, 0.38045957E-03_JPRB, 0.38047090E-03_JPRB, 0.38055104E-03_JPRB, 0.38073336E-03_JPRB, &
  & 0.38113566E-03_JPRB, 0.38179489E-03_JPRB, 0.38254398E-03_JPRB, 0.38333504E-03_JPRB, 0.38401167E-03_JPRB, 0.38461035E-03_JPRB, &
  & 0.38498900E-03_JPRB, 0.38509961E-03_JPRB, 0.38492872E-03_JPRB, 0.38457325E-03_JPRB, 0.38412060E-03_JPRB, 0.38375150E-03_JPRB, &
  & 0.38349780E-03_JPRB, 0.38346793E-03_JPRB, 0.38372003E-03_JPRB, 0.38407620E-03_JPRB, 0.38447556E-03_JPRB, 0.38478721E-03_JPRB, &
  & 0.38520818E-03_JPRB, 0.38561335E-03_JPRB, 0.38586393E-03_JPRB, 0.38589486E-03_JPRB, 0.38590478E-03_JPRB, 0.38593165E-03_JPRB, &
  & 0.38593910E-03_JPRB, 0.38573256E-03_JPRB, 0.38543446E-03_JPRB, 0.38498565E-03_JPRB, 0.38466067E-03_JPRB, 0.38449855E-03_JPRB, &
  & 0.38441048E-03_JPRB, 0.38438764E-03_JPRB, 0.38445450E-03_JPRB, 0.38462510E-03_JPRB, 0.38480571E-03_JPRB, 0.38507894E-03_JPRB, &
  & 0.38532432E-03_JPRB, 0.38528193E-03_JPRB, 0.38512803E-03_JPRB, 0.38496606E-03_JPRB, 0.38496010E-03_JPRB, 0.38504273E-03_JPRB, &
  & 0.38502976E-03_JPRB, 0.38493426E-03_JPRB, 0.38476478E-03_JPRB, 0.38446631E-03_JPRB, 0.38435038E-03_JPRB, 0.38456540E-03_JPRB, &
  & 0.38461962E-03_JPRB, 0.38474351E-03_JPRB, 0.38489818E-03_JPRB, 0.38537451E-03_JPRB  /)

RGHG1(:,48, 8) = (/ &
  & 0.38741515E-03_JPRB, 0.38586749E-03_JPRB, 0.38452537E-03_JPRB, 0.38311781E-03_JPRB, 0.38221638E-03_JPRB, 0.38148860E-03_JPRB, &
  & 0.38097184E-03_JPRB, 0.38053627E-03_JPRB, 0.38030329E-03_JPRB, 0.38033674E-03_JPRB, 0.38044748E-03_JPRB, 0.38061590E-03_JPRB, &
  & 0.38098173E-03_JPRB, 0.38155983E-03_JPRB, 0.38225979E-03_JPRB, 0.38299131E-03_JPRB, 0.38360619E-03_JPRB, 0.38418368E-03_JPRB, &
  & 0.38457888E-03_JPRB, 0.38472827E-03_JPRB, 0.38460009E-03_JPRB, 0.38429015E-03_JPRB, 0.38389442E-03_JPRB, 0.38358132E-03_JPRB, &
  & 0.38337272E-03_JPRB, 0.38339259E-03_JPRB, 0.38365558E-03_JPRB, 0.38400441E-03_JPRB, 0.38441292E-03_JPRB, 0.38473196E-03_JPRB, &
  & 0.38516229E-03_JPRB, 0.38557631E-03_JPRB, 0.38582305E-03_JPRB, 0.38585860E-03_JPRB, 0.38587582E-03_JPRB, 0.38592060E-03_JPRB, &
  & 0.38593017E-03_JPRB, 0.38570375E-03_JPRB, 0.38539995E-03_JPRB, 0.38494375E-03_JPRB, 0.38458316E-03_JPRB, 0.38435088E-03_JPRB, &
  & 0.38421461E-03_JPRB, 0.38418756E-03_JPRB, 0.38421110E-03_JPRB, 0.38433727E-03_JPRB, 0.38445709E-03_JPRB, 0.38467405E-03_JPRB, &
  & 0.38489043E-03_JPRB, 0.38482251E-03_JPRB, 0.38464543E-03_JPRB, 0.38446597E-03_JPRB, 0.38442121E-03_JPRB, 0.38446068E-03_JPRB, &
  & 0.38443270E-03_JPRB, 0.38435971E-03_JPRB, 0.38423544E-03_JPRB, 0.38393317E-03_JPRB, 0.38379627E-03_JPRB, 0.38405395E-03_JPRB, &
  & 0.38418385E-03_JPRB, 0.38443837E-03_JPRB, 0.38476196E-03_JPRB, 0.38543726E-03_JPRB  /)

RGHG1(:,49, 8) = (/ &
  & 0.38647423E-03_JPRB, 0.38496272E-03_JPRB, 0.38375283E-03_JPRB, 0.38258731E-03_JPRB, 0.38182660E-03_JPRB, 0.38121143E-03_JPRB, &
  & 0.38073774E-03_JPRB, 0.38032296E-03_JPRB, 0.38011350E-03_JPRB, 0.38017289E-03_JPRB, 0.38031805E-03_JPRB, 0.38047720E-03_JPRB, &
  & 0.38081118E-03_JPRB, 0.38129652E-03_JPRB, 0.38193878E-03_JPRB, 0.38259631E-03_JPRB, 0.38313021E-03_JPRB, 0.38367359E-03_JPRB, &
  & 0.38408927E-03_JPRB, 0.38428367E-03_JPRB, 0.38421467E-03_JPRB, 0.38396143E-03_JPRB, 0.38363486E-03_JPRB, 0.38338475E-03_JPRB, &
  & 0.38322748E-03_JPRB, 0.38331931E-03_JPRB, 0.38358604E-03_JPRB, 0.38392264E-03_JPRB, 0.38434611E-03_JPRB, 0.38468391E-03_JPRB, &
  & 0.38511540E-03_JPRB, 0.38553457E-03_JPRB, 0.38576970E-03_JPRB, 0.38580813E-03_JPRB, 0.38583454E-03_JPRB, 0.38589926E-03_JPRB, &
  & 0.38591755E-03_JPRB, 0.38567034E-03_JPRB, 0.38535673E-03_JPRB, 0.38489773E-03_JPRB, 0.38450443E-03_JPRB, 0.38420198E-03_JPRB, &
  & 0.38401416E-03_JPRB, 0.38399317E-03_JPRB, 0.38397069E-03_JPRB, 0.38404242E-03_JPRB, 0.38409862E-03_JPRB, 0.38424860E-03_JPRB, &
  & 0.38441841E-03_JPRB, 0.38431070E-03_JPRB, 0.38408627E-03_JPRB, 0.38387777E-03_JPRB, 0.38378269E-03_JPRB, 0.38376298E-03_JPRB, &
  & 0.38370228E-03_JPRB, 0.38364285E-03_JPRB, 0.38355323E-03_JPRB, 0.38324404E-03_JPRB, 0.38307396E-03_JPRB, 0.38335819E-03_JPRB, &
  & 0.38357781E-03_JPRB, 0.38396690E-03_JPRB, 0.38448269E-03_JPRB, 0.38540852E-03_JPRB  /)

RGHG1(:,50, 8) = (/ &
  & 0.38564104E-03_JPRB, 0.38428286E-03_JPRB, 0.38319224E-03_JPRB, 0.38223338E-03_JPRB, 0.38158196E-03_JPRB, 0.38105180E-03_JPRB, &
  & 0.38063577E-03_JPRB, 0.38024050E-03_JPRB, 0.38002309E-03_JPRB, 0.38009359E-03_JPRB, 0.38024110E-03_JPRB, 0.38039074E-03_JPRB, &
  & 0.38070792E-03_JPRB, 0.38112573E-03_JPRB, 0.38169997E-03_JPRB, 0.38228006E-03_JPRB, 0.38275255E-03_JPRB, 0.38322788E-03_JPRB, &
  & 0.38364216E-03_JPRB, 0.38386040E-03_JPRB, 0.38385403E-03_JPRB, 0.38364438E-03_JPRB, 0.38338689E-03_JPRB, 0.38319485E-03_JPRB, &
  & 0.38308695E-03_JPRB, 0.38323597E-03_JPRB, 0.38353814E-03_JPRB, 0.38387120E-03_JPRB, 0.38430249E-03_JPRB, 0.38466151E-03_JPRB, &
  & 0.38509663E-03_JPRB, 0.38549080E-03_JPRB, 0.38571976E-03_JPRB, 0.38575635E-03_JPRB, 0.38578318E-03_JPRB, 0.38586520E-03_JPRB, &
  & 0.38589945E-03_JPRB, 0.38564109E-03_JPRB, 0.38531040E-03_JPRB, 0.38483758E-03_JPRB, 0.38441698E-03_JPRB, 0.38405377E-03_JPRB, &
  & 0.38382748E-03_JPRB, 0.38381603E-03_JPRB, 0.38376290E-03_JPRB, 0.38379213E-03_JPRB, 0.38380657E-03_JPRB, 0.38391404E-03_JPRB, &
  & 0.38403466E-03_JPRB, 0.38389010E-03_JPRB, 0.38360974E-03_JPRB, 0.38334897E-03_JPRB, 0.38320444E-03_JPRB, 0.38312113E-03_JPRB, &
  & 0.38300510E-03_JPRB, 0.38292925E-03_JPRB, 0.38284327E-03_JPRB, 0.38252335E-03_JPRB, 0.38233260E-03_JPRB, 0.38255325E-03_JPRB, &
  & 0.38279937E-03_JPRB, 0.38321683E-03_JPRB, 0.38392455E-03_JPRB, 0.38507555E-03_JPRB  /)

RGHG1(:,51, 8) = (/ &
  & 0.38479645E-03_JPRB, 0.38366573E-03_JPRB, 0.38269730E-03_JPRB, 0.38194336E-03_JPRB, 0.38139363E-03_JPRB, 0.38094092E-03_JPRB, &
  & 0.38059493E-03_JPRB, 0.38022008E-03_JPRB, 0.37997753E-03_JPRB, 0.38005226E-03_JPRB, 0.38018546E-03_JPRB, 0.38032468E-03_JPRB, &
  & 0.38063162E-03_JPRB, 0.38098963E-03_JPRB, 0.38148488E-03_JPRB, 0.38197939E-03_JPRB, 0.38239574E-03_JPRB, 0.38277964E-03_JPRB, &
  & 0.38318090E-03_JPRB, 0.38341378E-03_JPRB, 0.38347697E-03_JPRB, 0.38330759E-03_JPRB, 0.38312478E-03_JPRB, 0.38299293E-03_JPRB, &
  & 0.38293743E-03_JPRB, 0.38314055E-03_JPRB, 0.38349771E-03_JPRB, 0.38383150E-03_JPRB, 0.38426751E-03_JPRB, 0.38465077E-03_JPRB, &
  & 0.38509110E-03_JPRB, 0.38544240E-03_JPRB, 0.38566753E-03_JPRB, 0.38569965E-03_JPRB, 0.38572233E-03_JPRB, 0.38582168E-03_JPRB, &
  & 0.38587700E-03_JPRB, 0.38561164E-03_JPRB, 0.38525866E-03_JPRB, 0.38476510E-03_JPRB, 0.38431782E-03_JPRB, 0.38389384E-03_JPRB, &
  & 0.38363281E-03_JPRB, 0.38363347E-03_JPRB, 0.38355529E-03_JPRB, 0.38354482E-03_JPRB, 0.38352558E-03_JPRB, 0.38359995E-03_JPRB, &
  & 0.38366598E-03_JPRB, 0.38348310E-03_JPRB, 0.38313775E-03_JPRB, 0.38280823E-03_JPRB, 0.38261065E-03_JPRB, 0.38245625E-03_JPRB, &
  & 0.38226847E-03_JPRB, 0.38215910E-03_JPRB, 0.38206075E-03_JPRB, 0.38172725E-03_JPRB, 0.38152072E-03_JPRB, 0.38162520E-03_JPRB, &
  & 0.38186676E-03_JPRB, 0.38225909E-03_JPRB, 0.38317424E-03_JPRB, 0.38455547E-03_JPRB  /)

RGHG1(:,52, 8) = (/ &
  & 0.38428513E-03_JPRB, 0.38341422E-03_JPRB, 0.38255947E-03_JPRB, 0.38193394E-03_JPRB, 0.38144442E-03_JPRB, 0.38103208E-03_JPRB, &
  & 0.38073712E-03_JPRB, 0.38039433E-03_JPRB, 0.38012600E-03_JPRB, 0.38015937E-03_JPRB, 0.38025545E-03_JPRB, 0.38038258E-03_JPRB, &
  & 0.38066936E-03_JPRB, 0.38098224E-03_JPRB, 0.38139546E-03_JPRB, 0.38182249E-03_JPRB, 0.38218941E-03_JPRB, 0.38252032E-03_JPRB, &
  & 0.38287415E-03_JPRB, 0.38309634E-03_JPRB, 0.38317501E-03_JPRB, 0.38304870E-03_JPRB, 0.38292506E-03_JPRB, 0.38284819E-03_JPRB, &
  & 0.38282541E-03_JPRB, 0.38305401E-03_JPRB, 0.38342675E-03_JPRB, 0.38378549E-03_JPRB, 0.38423030E-03_JPRB, 0.38463964E-03_JPRB, &
  & 0.38506565E-03_JPRB, 0.38539895E-03_JPRB, 0.38561132E-03_JPRB, 0.38564483E-03_JPRB, 0.38566905E-03_JPRB, 0.38577310E-03_JPRB, &
  & 0.38583829E-03_JPRB, 0.38558508E-03_JPRB, 0.38519582E-03_JPRB, 0.38467231E-03_JPRB, 0.38420001E-03_JPRB, 0.38373314E-03_JPRB, &
  & 0.38345378E-03_JPRB, 0.38345901E-03_JPRB, 0.38336421E-03_JPRB, 0.38333021E-03_JPRB, 0.38329006E-03_JPRB, 0.38335083E-03_JPRB, &
  & 0.38337774E-03_JPRB, 0.38315614E-03_JPRB, 0.38277372E-03_JPRB, 0.38240081E-03_JPRB, 0.38216411E-03_JPRB, 0.38196120E-03_JPRB, &
  & 0.38174233E-03_JPRB, 0.38160022E-03_JPRB, 0.38146771E-03_JPRB, 0.38111995E-03_JPRB, 0.38086899E-03_JPRB, 0.38085705E-03_JPRB, &
  & 0.38103253E-03_JPRB, 0.38133896E-03_JPRB, 0.38227775E-03_JPRB, 0.38381216E-03_JPRB  /)

RGHG1(:,53, 8) = (/ &
  & 0.38385652E-03_JPRB, 0.38328099E-03_JPRB, 0.38254677E-03_JPRB, 0.38203163E-03_JPRB, 0.38159172E-03_JPRB, 0.38120909E-03_JPRB, &
  & 0.38096237E-03_JPRB, 0.38065898E-03_JPRB, 0.38036232E-03_JPRB, 0.38033312E-03_JPRB, 0.38038001E-03_JPRB, 0.38049331E-03_JPRB, &
  & 0.38075435E-03_JPRB, 0.38102370E-03_JPRB, 0.38134645E-03_JPRB, 0.38170695E-03_JPRB, 0.38202262E-03_JPRB, 0.38231060E-03_JPRB, &
  & 0.38259954E-03_JPRB, 0.38280036E-03_JPRB, 0.38287508E-03_JPRB, 0.38279676E-03_JPRB, 0.38273157E-03_JPRB, 0.38271256E-03_JPRB, &
  & 0.38271785E-03_JPRB, 0.38296319E-03_JPRB, 0.38333773E-03_JPRB, 0.38373295E-03_JPRB, 0.38418892E-03_JPRB, 0.38462736E-03_JPRB, &
  & 0.38503029E-03_JPRB, 0.38535354E-03_JPRB, 0.38554857E-03_JPRB, 0.38558585E-03_JPRB, 0.38561394E-03_JPRB, 0.38571824E-03_JPRB, &
  & 0.38578987E-03_JPRB, 0.38555727E-03_JPRB, 0.38512311E-03_JPRB, 0.38456347E-03_JPRB, 0.38406455E-03_JPRB, 0.38355785E-03_JPRB, &
  & 0.38326484E-03_JPRB, 0.38327213E-03_JPRB, 0.38316248E-03_JPRB, 0.38310908E-03_JPRB, 0.38305107E-03_JPRB, 0.38310455E-03_JPRB, &
  & 0.38309481E-03_JPRB, 0.38283089E-03_JPRB, 0.38241885E-03_JPRB, 0.38200842E-03_JPRB, 0.38173447E-03_JPRB, 0.38148744E-03_JPRB, &
  & 0.38125037E-03_JPRB, 0.38107289E-03_JPRB, 0.38089480E-03_JPRB, 0.38053124E-03_JPRB, 0.38022088E-03_JPRB, 0.38008206E-03_JPRB, &
  & 0.38016192E-03_JPRB, 0.38035143E-03_JPRB, 0.38124524E-03_JPRB, 0.38291683E-03_JPRB  /)

RGHG1(:,54, 8) = (/ &
  & 0.38380309E-03_JPRB, 0.38341119E-03_JPRB, 0.38281227E-03_JPRB, 0.38235184E-03_JPRB, 0.38193859E-03_JPRB, 0.38155051E-03_JPRB, &
  & 0.38131972E-03_JPRB, 0.38104168E-03_JPRB, 0.38074429E-03_JPRB, 0.38064259E-03_JPRB, 0.38063282E-03_JPRB, 0.38071820E-03_JPRB, &
  & 0.38093659E-03_JPRB, 0.38116325E-03_JPRB, 0.38142378E-03_JPRB, 0.38171659E-03_JPRB, 0.38198206E-03_JPRB, 0.38224248E-03_JPRB, &
  & 0.38246044E-03_JPRB, 0.38265458E-03_JPRB, 0.38270669E-03_JPRB, 0.38263640E-03_JPRB, 0.38260454E-03_JPRB, 0.38261107E-03_JPRB, &
  & 0.38262228E-03_JPRB, 0.38284559E-03_JPRB, 0.38324347E-03_JPRB, 0.38367306E-03_JPRB, 0.38414639E-03_JPRB, 0.38456131E-03_JPRB, &
  & 0.38495341E-03_JPRB, 0.38529463E-03_JPRB, 0.38550296E-03_JPRB, 0.38555270E-03_JPRB, 0.38557972E-03_JPRB, 0.38566950E-03_JPRB, &
  & 0.38574475E-03_JPRB, 0.38553682E-03_JPRB, 0.38504498E-03_JPRB, 0.38446556E-03_JPRB, 0.38394104E-03_JPRB, 0.38342584E-03_JPRB, &
  & 0.38313183E-03_JPRB, 0.38312243E-03_JPRB, 0.38300393E-03_JPRB, 0.38293113E-03_JPRB, 0.38286615E-03_JPRB, 0.38291437E-03_JPRB, &
  & 0.38287024E-03_JPRB, 0.38258000E-03_JPRB, 0.38215776E-03_JPRB, 0.38174798E-03_JPRB, 0.38146405E-03_JPRB, 0.38120396E-03_JPRB, &
  & 0.38096305E-03_JPRB, 0.38077306E-03_JPRB, 0.38059110E-03_JPRB, 0.38023909E-03_JPRB, 0.37989214E-03_JPRB, 0.37970833E-03_JPRB, &
  & 0.37969322E-03_JPRB, 0.37981903E-03_JPRB, 0.38051595E-03_JPRB, 0.38211273E-03_JPRB  /)

RGHG1(:,55, 8) = (/ &
  & 0.38379325E-03_JPRB, 0.38359007E-03_JPRB, 0.38314299E-03_JPRB, 0.38273584E-03_JPRB, 0.38234909E-03_JPRB, 0.38195036E-03_JPRB, &
  & 0.38173295E-03_JPRB, 0.38148114E-03_JPRB, 0.38118658E-03_JPRB, 0.38100327E-03_JPRB, 0.38092974E-03_JPRB, 0.38098233E-03_JPRB, &
  & 0.38115127E-03_JPRB, 0.38133075E-03_JPRB, 0.38152606E-03_JPRB, 0.38174373E-03_JPRB, 0.38195374E-03_JPRB, 0.38218565E-03_JPRB, &
  & 0.38232419E-03_JPRB, 0.38251286E-03_JPRB, 0.38253746E-03_JPRB, 0.38247082E-03_JPRB, 0.38247256E-03_JPRB, 0.38250314E-03_JPRB, &
  & 0.38251800E-03_JPRB, 0.38271179E-03_JPRB, 0.38313836E-03_JPRB, 0.38360576E-03_JPRB, 0.38409912E-03_JPRB, 0.38448107E-03_JPRB, &
  & 0.38486278E-03_JPRB, 0.38522759E-03_JPRB, 0.38545468E-03_JPRB, 0.38551936E-03_JPRB, 0.38554456E-03_JPRB, 0.38561631E-03_JPRB, &
  & 0.38569520E-03_JPRB, 0.38551515E-03_JPRB, 0.38495773E-03_JPRB, 0.38435854E-03_JPRB, 0.38380578E-03_JPRB, 0.38328530E-03_JPRB, &
  & 0.38299184E-03_JPRB, 0.38296149E-03_JPRB, 0.38283397E-03_JPRB, 0.38273968E-03_JPRB, 0.38266842E-03_JPRB, 0.38271108E-03_JPRB, &
  & 0.38262915E-03_JPRB, 0.38231186E-03_JPRB, 0.38188088E-03_JPRB, 0.38147683E-03_JPRB, 0.38118543E-03_JPRB, 0.38091496E-03_JPRB, &
  & 0.38067168E-03_JPRB, 0.38047086E-03_JPRB, 0.38029007E-03_JPRB, 0.37995446E-03_JPRB, 0.37956999E-03_JPRB, 0.37934710E-03_JPRB, &
  & 0.37922689E-03_JPRB, 0.37928912E-03_JPRB, 0.37974796E-03_JPRB, 0.38123398E-03_JPRB  /)

RGHG1(:,56, 8) = (/ &
  & 0.38404991E-03_JPRB, 0.38392945E-03_JPRB, 0.38358893E-03_JPRB, 0.38319575E-03_JPRB, 0.38282417E-03_JPRB, 0.38239739E-03_JPRB, &
  & 0.38216334E-03_JPRB, 0.38192109E-03_JPRB, 0.38164115E-03_JPRB, 0.38141708E-03_JPRB, 0.38129881E-03_JPRB, 0.38130007E-03_JPRB, &
  & 0.38141694E-03_JPRB, 0.38153746E-03_JPRB, 0.38167519E-03_JPRB, 0.38184107E-03_JPRB, 0.38201114E-03_JPRB, 0.38220072E-03_JPRB, &
  & 0.38228830E-03_JPRB, 0.38245783E-03_JPRB, 0.38247740E-03_JPRB, 0.38239795E-03_JPRB, 0.38239317E-03_JPRB, 0.38245497E-03_JPRB, &
  & 0.38247307E-03_JPRB, 0.38263379E-03_JPRB, 0.38303413E-03_JPRB, 0.38349583E-03_JPRB, 0.38400856E-03_JPRB, 0.38436294E-03_JPRB, &
  & 0.38472834E-03_JPRB, 0.38510528E-03_JPRB, 0.38540470E-03_JPRB, 0.38550991E-03_JPRB, 0.38552854E-03_JPRB, 0.38558406E-03_JPRB, &
  & 0.38566901E-03_JPRB, 0.38549607E-03_JPRB, 0.38492069E-03_JPRB, 0.38431502E-03_JPRB, 0.38375285E-03_JPRB, 0.38324636E-03_JPRB, &
  & 0.38293279E-03_JPRB, 0.38287891E-03_JPRB, 0.38272461E-03_JPRB, 0.38261267E-03_JPRB, 0.38253938E-03_JPRB, 0.38256591E-03_JPRB, &
  & 0.38243435E-03_JPRB, 0.38210002E-03_JPRB, 0.38167256E-03_JPRB, 0.38129152E-03_JPRB, 0.38101748E-03_JPRB, 0.38074831E-03_JPRB, &
  & 0.38050261E-03_JPRB, 0.38030897E-03_JPRB, 0.38013941E-03_JPRB, 0.37981109E-03_JPRB, 0.37942449E-03_JPRB, 0.37923916E-03_JPRB, &
  & 0.37911194E-03_JPRB, 0.37913213E-03_JPRB, 0.37948291E-03_JPRB, 0.38077770E-03_JPRB  /)

RGHG1(:,57, 8) = (/ &
  & 0.38432259E-03_JPRB, 0.38426631E-03_JPRB, 0.38402564E-03_JPRB, 0.38364993E-03_JPRB, 0.38329489E-03_JPRB, 0.38284792E-03_JPRB, &
  & 0.38259934E-03_JPRB, 0.38236227E-03_JPRB, 0.38209494E-03_JPRB, 0.38183733E-03_JPRB, 0.38167724E-03_JPRB, 0.38162471E-03_JPRB, &
  & 0.38169239E-03_JPRB, 0.38175811E-03_JPRB, 0.38183510E-03_JPRB, 0.38194527E-03_JPRB, 0.38206973E-03_JPRB, 0.38221498E-03_JPRB, &
  & 0.38225590E-03_JPRB, 0.38239461E-03_JPRB, 0.38241563E-03_JPRB, 0.38232762E-03_JPRB, 0.38231765E-03_JPRB, 0.38240386E-03_JPRB, &
  & 0.38242789E-03_JPRB, 0.38256895E-03_JPRB, 0.38293305E-03_JPRB, 0.38338524E-03_JPRB, 0.38390038E-03_JPRB, 0.38423582E-03_JPRB, &
  & 0.38458613E-03_JPRB, 0.38498135E-03_JPRB, 0.38533191E-03_JPRB, 0.38548424E-03_JPRB, 0.38550442E-03_JPRB, 0.38554815E-03_JPRB, &
  & 0.38563638E-03_JPRB, 0.38546701E-03_JPRB, 0.38488534E-03_JPRB, 0.38427463E-03_JPRB, 0.38370306E-03_JPRB, 0.38321583E-03_JPRB, &
  & 0.38288197E-03_JPRB, 0.38280085E-03_JPRB, 0.38260787E-03_JPRB, 0.38248413E-03_JPRB, 0.38240378E-03_JPRB, 0.38240762E-03_JPRB, &
  & 0.38222711E-03_JPRB, 0.38187509E-03_JPRB, 0.38145131E-03_JPRB, 0.38109611E-03_JPRB, 0.38083939E-03_JPRB, 0.38057616E-03_JPRB, &
  & 0.38033168E-03_JPRB, 0.38014351E-03_JPRB, 0.37997858E-03_JPRB, 0.37965291E-03_JPRB, 0.37927363E-03_JPRB, 0.37912906E-03_JPRB, &
  & 0.37900287E-03_JPRB, 0.37896947E-03_JPRB, 0.37921064E-03_JPRB, 0.38033600E-03_JPRB  /)

RGHG1(:,58, 8) = (/ &
  & 0.38465037E-03_JPRB, 0.38460193E-03_JPRB, 0.38443320E-03_JPRB, 0.38407215E-03_JPRB, 0.38373252E-03_JPRB, 0.38327695E-03_JPRB, &
  & 0.38301296E-03_JPRB, 0.38277012E-03_JPRB, 0.38251318E-03_JPRB, 0.38224461E-03_JPRB, 0.38205455E-03_JPRB, 0.38194492E-03_JPRB, &
  & 0.38197176E-03_JPRB, 0.38199191E-03_JPRB, 0.38200915E-03_JPRB, 0.38206580E-03_JPRB, 0.38214167E-03_JPRB, 0.38224023E-03_JPRB, &
  & 0.38225079E-03_JPRB, 0.38233893E-03_JPRB, 0.38237639E-03_JPRB, 0.38228460E-03_JPRB, 0.38226461E-03_JPRB, 0.38236312E-03_JPRB, &
  & 0.38239707E-03_JPRB, 0.38254200E-03_JPRB, 0.38284560E-03_JPRB, 0.38327443E-03_JPRB, 0.38376302E-03_JPRB, 0.38409666E-03_JPRB, &
  & 0.38443402E-03_JPRB, 0.38485428E-03_JPRB, 0.38522612E-03_JPRB, 0.38543773E-03_JPRB, 0.38547218E-03_JPRB, 0.38551289E-03_JPRB, &
  & 0.38559989E-03_JPRB, 0.38542390E-03_JPRB, 0.38486511E-03_JPRB, 0.38425468E-03_JPRB, 0.38367801E-03_JPRB, 0.38322103E-03_JPRB, &
  & 0.38286429E-03_JPRB, 0.38275140E-03_JPRB, 0.38249943E-03_JPRB, 0.38237541E-03_JPRB, 0.38228087E-03_JPRB, 0.38225078E-03_JPRB, &
  & 0.38202423E-03_JPRB, 0.38165670E-03_JPRB, 0.38123888E-03_JPRB, 0.38091544E-03_JPRB, 0.38067924E-03_JPRB, 0.38043151E-03_JPRB, &
  & 0.38019431E-03_JPRB, 0.38001162E-03_JPRB, 0.37984168E-03_JPRB, 0.37950892E-03_JPRB, 0.37915895E-03_JPRB, 0.37907168E-03_JPRB, &
  & 0.37897839E-03_JPRB, 0.37888022E-03_JPRB, 0.37904236E-03_JPRB, 0.38003366E-03_JPRB  /)

RGHG1(:,59, 8) = (/ &
  & 0.38491406E-03_JPRB, 0.38486976E-03_JPRB, 0.38475544E-03_JPRB, 0.38441291E-03_JPRB, 0.38407833E-03_JPRB, 0.38363099E-03_JPRB, &
  & 0.38335960E-03_JPRB, 0.38310879E-03_JPRB, 0.38286188E-03_JPRB, 0.38259798E-03_JPRB, 0.38238745E-03_JPRB, 0.38223089E-03_JPRB, &
  & 0.38221957E-03_JPRB, 0.38220712E-03_JPRB, 0.38217738E-03_JPRB, 0.38218289E-03_JPRB, 0.38221209E-03_JPRB, 0.38226669E-03_JPRB, &
  & 0.38226331E-03_JPRB, 0.38229564E-03_JPRB, 0.38234324E-03_JPRB, 0.38226156E-03_JPRB, 0.38223545E-03_JPRB, 0.38232043E-03_JPRB, &
  & 0.38237501E-03_JPRB, 0.38251815E-03_JPRB, 0.38279771E-03_JPRB, 0.38319774E-03_JPRB, 0.38362212E-03_JPRB, 0.38394895E-03_JPRB, &
  & 0.38429300E-03_JPRB, 0.38473161E-03_JPRB, 0.38512309E-03_JPRB, 0.38536872E-03_JPRB, 0.38542726E-03_JPRB, 0.38547444E-03_JPRB, &
  & 0.38555286E-03_JPRB, 0.38538190E-03_JPRB, 0.38483726E-03_JPRB, 0.38423468E-03_JPRB, 0.38366473E-03_JPRB, 0.38323540E-03_JPRB, &
  & 0.38287301E-03_JPRB, 0.38271480E-03_JPRB, 0.38240253E-03_JPRB, 0.38228622E-03_JPRB, 0.38216836E-03_JPRB, 0.38209161E-03_JPRB, &
  & 0.38182729E-03_JPRB, 0.38145160E-03_JPRB, 0.38104077E-03_JPRB, 0.38075034E-03_JPRB, 0.38054131E-03_JPRB, 0.38032037E-03_JPRB, &
  & 0.38008909E-03_JPRB, 0.37990564E-03_JPRB, 0.37973290E-03_JPRB, 0.37940836E-03_JPRB, 0.37910813E-03_JPRB, 0.37907370E-03_JPRB, &
  & 0.37904736E-03_JPRB, 0.37890632E-03_JPRB, 0.37902990E-03_JPRB, 0.37989202E-03_JPRB  /)

RGHG1(:,60, 8) = (/ &
  & 0.38515131E-03_JPRB, 0.38511730E-03_JPRB, 0.38504721E-03_JPRB, 0.38472421E-03_JPRB, 0.38439013E-03_JPRB, 0.38395899E-03_JPRB, &
  & 0.38368403E-03_JPRB, 0.38342467E-03_JPRB, 0.38318804E-03_JPRB, 0.38293360E-03_JPRB, 0.38270629E-03_JPRB, 0.38250775E-03_JPRB, &
  & 0.38245910E-03_JPRB, 0.38241862E-03_JPRB, 0.38234823E-03_JPRB, 0.38230177E-03_JPRB, 0.38228482E-03_JPRB, 0.38229668E-03_JPRB, &
  & 0.38228464E-03_JPRB, 0.38226052E-03_JPRB, 0.38230964E-03_JPRB, 0.38224605E-03_JPRB, 0.38221666E-03_JPRB, 0.38227942E-03_JPRB, &
  & 0.38235722E-03_JPRB, 0.38249572E-03_JPRB, 0.38276345E-03_JPRB, 0.38313367E-03_JPRB, 0.38348399E-03_JPRB, 0.38380366E-03_JPRB, &
  & 0.38415675E-03_JPRB, 0.38461349E-03_JPRB, 0.38502273E-03_JPRB, 0.38529140E-03_JPRB, 0.38537849E-03_JPRB, 0.38543495E-03_JPRB, &
  & 0.38549961E-03_JPRB, 0.38533837E-03_JPRB, 0.38480862E-03_JPRB, 0.38421659E-03_JPRB, 0.38365873E-03_JPRB, 0.38325246E-03_JPRB, &
  & 0.38289393E-03_JPRB, 0.38268223E-03_JPRB, 0.38231223E-03_JPRB, 0.38220286E-03_JPRB, 0.38205732E-03_JPRB, 0.38192804E-03_JPRB, &
  & 0.38162739E-03_JPRB, 0.38124754E-03_JPRB, 0.38084611E-03_JPRB, 0.38058955E-03_JPRB, 0.38041273E-03_JPRB, 0.38022435E-03_JPRB, &
  & 0.37999800E-03_JPRB, 0.37981299E-03_JPRB, 0.37964109E-03_JPRB, 0.37933742E-03_JPRB, 0.37909745E-03_JPRB, 0.37910974E-03_JPRB, &
  & 0.37916685E-03_JPRB, 0.37900231E-03_JPRB, 0.37910596E-03_JPRB, 0.37983928E-03_JPRB  /)

RGHG1(:,61, 8) = (/ &
  & 0.38532372E-03_JPRB, 0.38532826E-03_JPRB, 0.38527590E-03_JPRB, 0.38496848E-03_JPRB, 0.38462938E-03_JPRB, 0.38422305E-03_JPRB, &
  & 0.38395055E-03_JPRB, 0.38368442E-03_JPRB, 0.38345794E-03_JPRB, 0.38321118E-03_JPRB, 0.38297281E-03_JPRB, 0.38274639E-03_JPRB, &
  & 0.38266637E-03_JPRB, 0.38260457E-03_JPRB, 0.38250968E-03_JPRB, 0.38241319E-03_JPRB, 0.38235729E-03_JPRB, 0.38233471E-03_JPRB, &
  & 0.38231621E-03_JPRB, 0.38224873E-03_JPRB, 0.38227192E-03_JPRB, 0.38223847E-03_JPRB, 0.38221297E-03_JPRB, 0.38225430E-03_JPRB, &
  & 0.38234861E-03_JPRB, 0.38247880E-03_JPRB, 0.38274018E-03_JPRB, 0.38308816E-03_JPRB, 0.38338384E-03_JPRB, 0.38370249E-03_JPRB, &
  & 0.38404778E-03_JPRB, 0.38452738E-03_JPRB, 0.38494585E-03_JPRB, 0.38522108E-03_JPRB, 0.38533800E-03_JPRB, 0.38540164E-03_JPRB, &
  & 0.38544292E-03_JPRB, 0.38529419E-03_JPRB, 0.38479099E-03_JPRB, 0.38420920E-03_JPRB, 0.38366846E-03_JPRB, 0.38326609E-03_JPRB, &
  & 0.38292775E-03_JPRB, 0.38265507E-03_JPRB, 0.38224878E-03_JPRB, 0.38213193E-03_JPRB, 0.38195697E-03_JPRB, 0.38177572E-03_JPRB, &
  & 0.38144001E-03_JPRB, 0.38106364E-03_JPRB, 0.38067861E-03_JPRB, 0.38045250E-03_JPRB, 0.38031484E-03_JPRB, 0.38016294E-03_JPRB, &
  & 0.37993855E-03_JPRB, 0.37975681E-03_JPRB, 0.37959773E-03_JPRB, 0.37934378E-03_JPRB, 0.37917146E-03_JPRB, 0.37920353E-03_JPRB, &
  & 0.37935485E-03_JPRB, 0.37922198E-03_JPRB, 0.37933363E-03_JPRB, 0.37995419E-03_JPRB  /)

RGHG1(:,62, 8) = (/ &
  & 0.38549056E-03_JPRB, 0.38552758E-03_JPRB, 0.38546742E-03_JPRB, 0.38517167E-03_JPRB, 0.38483907E-03_JPRB, 0.38445766E-03_JPRB, &
  & 0.38419081E-03_JPRB, 0.38392339E-03_JPRB, 0.38370510E-03_JPRB, 0.38345832E-03_JPRB, 0.38321368E-03_JPRB, 0.38296251E-03_JPRB, &
  & 0.38285339E-03_JPRB, 0.38277429E-03_JPRB, 0.38266451E-03_JPRB, 0.38252809E-03_JPRB, 0.38243504E-03_JPRB, 0.38238465E-03_JPRB, &
  & 0.38235555E-03_JPRB, 0.38225819E-03_JPRB, 0.38225379E-03_JPRB, 0.38223011E-03_JPRB, 0.38220962E-03_JPRB, 0.38224979E-03_JPRB, &
  & 0.38234739E-03_JPRB, 0.38248571E-03_JPRB, 0.38273954E-03_JPRB, 0.38307170E-03_JPRB, 0.38333999E-03_JPRB, 0.38364886E-03_JPRB, &
  & 0.38400076E-03_JPRB, 0.38448399E-03_JPRB, 0.38489907E-03_JPRB, 0.38518054E-03_JPRB, 0.38533083E-03_JPRB, 0.38538061E-03_JPRB, &
  & 0.38539179E-03_JPRB, 0.38524891E-03_JPRB, 0.38477272E-03_JPRB, 0.38421236E-03_JPRB, 0.38369802E-03_JPRB, 0.38330163E-03_JPRB, &
  & 0.38297928E-03_JPRB, 0.38265299E-03_JPRB, 0.38221837E-03_JPRB, 0.38206844E-03_JPRB, 0.38187413E-03_JPRB, 0.38164471E-03_JPRB, &
  & 0.38128140E-03_JPRB, 0.38091183E-03_JPRB, 0.38054645E-03_JPRB, 0.38034894E-03_JPRB, 0.38024607E-03_JPRB, 0.38012736E-03_JPRB, &
  & 0.37991491E-03_JPRB, 0.37975235E-03_JPRB, 0.37961468E-03_JPRB, 0.37942637E-03_JPRB, 0.37931347E-03_JPRB, 0.37935207E-03_JPRB, &
  & 0.37958603E-03_JPRB, 0.37951058E-03_JPRB, 0.37962851E-03_JPRB, 0.38016338E-03_JPRB  /)

RGHG1(:,63, 8) = (/ &
  & 0.38565149E-03_JPRB, 0.38571196E-03_JPRB, 0.38562737E-03_JPRB, 0.38534558E-03_JPRB, 0.38502791E-03_JPRB, 0.38467303E-03_JPRB, &
  & 0.38441396E-03_JPRB, 0.38415042E-03_JPRB, 0.38393961E-03_JPRB, 0.38368797E-03_JPRB, 0.38343998E-03_JPRB, 0.38316736E-03_JPRB, &
  & 0.38302878E-03_JPRB, 0.38293300E-03_JPRB, 0.38281284E-03_JPRB, 0.38264687E-03_JPRB, 0.38251947E-03_JPRB, 0.38244583E-03_JPRB, &
  & 0.38240196E-03_JPRB, 0.38228517E-03_JPRB, 0.38225538E-03_JPRB, 0.38222508E-03_JPRB, 0.38221068E-03_JPRB, 0.38226353E-03_JPRB, &
  & 0.38235572E-03_JPRB, 0.38250254E-03_JPRB, 0.38275263E-03_JPRB, 0.38307397E-03_JPRB, 0.38333981E-03_JPRB, 0.38363550E-03_JPRB, &
  & 0.38400337E-03_JPRB, 0.38447931E-03_JPRB, 0.38488123E-03_JPRB, 0.38516672E-03_JPRB, 0.38534158E-03_JPRB, 0.38536461E-03_JPRB, &
  & 0.38534166E-03_JPRB, 0.38519975E-03_JPRB, 0.38475194E-03_JPRB, 0.38422070E-03_JPRB, 0.38373949E-03_JPRB, 0.38335971E-03_JPRB, &
  & 0.38305036E-03_JPRB, 0.38267859E-03_JPRB, 0.38221266E-03_JPRB, 0.38201357E-03_JPRB, 0.38180419E-03_JPRB, 0.38153042E-03_JPRB, &
  & 0.38114785E-03_JPRB, 0.38078694E-03_JPRB, 0.38044461E-03_JPRB, 0.38027252E-03_JPRB, 0.38020198E-03_JPRB, 0.38011204E-03_JPRB, &
  & 0.37992041E-03_JPRB, 0.37978507E-03_JPRB, 0.37967825E-03_JPRB, 0.37956283E-03_JPRB, 0.37950238E-03_JPRB, 0.37954029E-03_JPRB, &
  & 0.37984747E-03_JPRB, 0.37983830E-03_JPRB, 0.37996180E-03_JPRB, 0.38042968E-03_JPRB  /)

RGHG1(:,64, 8) = (/ &
  & 0.38579713E-03_JPRB, 0.38586376E-03_JPRB, 0.38574049E-03_JPRB, 0.38548180E-03_JPRB, 0.38518768E-03_JPRB, 0.38486216E-03_JPRB, &
  & 0.38461263E-03_JPRB, 0.38436007E-03_JPRB, 0.38415666E-03_JPRB, 0.38389628E-03_JPRB, 0.38364739E-03_JPRB, 0.38335919E-03_JPRB, &
  & 0.38318910E-03_JPRB, 0.38307471E-03_JPRB, 0.38294592E-03_JPRB, 0.38276705E-03_JPRB, 0.38261185E-03_JPRB, 0.38252038E-03_JPRB, &
  & 0.38245622E-03_JPRB, 0.38233293E-03_JPRB, 0.38228599E-03_JPRB, 0.38222934E-03_JPRB, 0.38222234E-03_JPRB, 0.38230108E-03_JPRB, &
  & 0.38237994E-03_JPRB, 0.38251903E-03_JPRB, 0.38277617E-03_JPRB, 0.38309303E-03_JPRB, 0.38339071E-03_JPRB, 0.38367430E-03_JPRB, &
  & 0.38406604E-03_JPRB, 0.38452752E-03_JPRB, 0.38490534E-03_JPRB, 0.38518948E-03_JPRB, 0.38536244E-03_JPRB, 0.38534914E-03_JPRB, &
  & 0.38529031E-03_JPRB, 0.38514403E-03_JPRB, 0.38472638E-03_JPRB, 0.38423079E-03_JPRB, 0.38378870E-03_JPRB, 0.38344918E-03_JPRB, &
  & 0.38314925E-03_JPRB, 0.38274641E-03_JPRB, 0.38223485E-03_JPRB, 0.38197467E-03_JPRB, 0.38175116E-03_JPRB, 0.38144040E-03_JPRB, &
  & 0.38105244E-03_JPRB, 0.38070117E-03_JPRB, 0.38038608E-03_JPRB, 0.38023239E-03_JPRB, 0.38019122E-03_JPRB, 0.38012134E-03_JPRB, &
  & 0.37996156E-03_JPRB, 0.37985615E-03_JPRB, 0.37979361E-03_JPRB, 0.37974994E-03_JPRB, 0.37973098E-03_JPRB, 0.37976384E-03_JPRB, &
  & 0.38012977E-03_JPRB, 0.38017990E-03_JPRB, 0.38030879E-03_JPRB, 0.38073115E-03_JPRB  /)

RGHG1(:,65, 8) = (/ &
  & 0.38589890E-03_JPRB, 0.38596569E-03_JPRB, 0.38580940E-03_JPRB, 0.38559150E-03_JPRB, 0.38531631E-03_JPRB, 0.38501788E-03_JPRB, &
  & 0.38478014E-03_JPRB, 0.38454429E-03_JPRB, 0.38435210E-03_JPRB, 0.38408446E-03_JPRB, 0.38383301E-03_JPRB, 0.38353943E-03_JPRB, &
  & 0.38333792E-03_JPRB, 0.38320279E-03_JPRB, 0.38306394E-03_JPRB, 0.38288356E-03_JPRB, 0.38271506E-03_JPRB, 0.38261043E-03_JPRB, &
  & 0.38252895E-03_JPRB, 0.38240453E-03_JPRB, 0.38234594E-03_JPRB, 0.38225941E-03_JPRB, 0.38224984E-03_JPRB, 0.38234519E-03_JPRB, &
  & 0.38242249E-03_JPRB, 0.38254043E-03_JPRB, 0.38279989E-03_JPRB, 0.38313530E-03_JPRB, 0.38346349E-03_JPRB, 0.38375189E-03_JPRB, &
  & 0.38417197E-03_JPRB, 0.38461961E-03_JPRB, 0.38497888E-03_JPRB, 0.38522983E-03_JPRB, 0.38536247E-03_JPRB, 0.38531759E-03_JPRB, &
  & 0.38522292E-03_JPRB, 0.38508330E-03_JPRB, 0.38471315E-03_JPRB, 0.38424889E-03_JPRB, 0.38384456E-03_JPRB, 0.38355811E-03_JPRB, &
  & 0.38326694E-03_JPRB, 0.38284502E-03_JPRB, 0.38228174E-03_JPRB, 0.38196510E-03_JPRB, 0.38172704E-03_JPRB, 0.38138933E-03_JPRB, &
  & 0.38100493E-03_JPRB, 0.38066661E-03_JPRB, 0.38037731E-03_JPRB, 0.38024109E-03_JPRB, 0.38022649E-03_JPRB, 0.38017173E-03_JPRB, &
  & 0.38004225E-03_JPRB, 0.37996492E-03_JPRB, 0.37995357E-03_JPRB, 0.37998117E-03_JPRB, 0.37999231E-03_JPRB, 0.38002604E-03_JPRB, &
  & 0.38041944E-03_JPRB, 0.38052067E-03_JPRB, 0.38066980E-03_JPRB, 0.38106956E-03_JPRB  /)

RGHG1(:,66, 8) = (/ &
  & 0.38596852E-03_JPRB, 0.38603852E-03_JPRB, 0.38585974E-03_JPRB, 0.38568733E-03_JPRB, 0.38542902E-03_JPRB, 0.38515268E-03_JPRB, &
  & 0.38492787E-03_JPRB, 0.38471168E-03_JPRB, 0.38453518E-03_JPRB, 0.38426204E-03_JPRB, 0.38401013E-03_JPRB, 0.38371401E-03_JPRB, &
  & 0.38348537E-03_JPRB, 0.38333154E-03_JPRB, 0.38317923E-03_JPRB, 0.38299939E-03_JPRB, 0.38282645E-03_JPRB, 0.38271314E-03_JPRB, &
  & 0.38261830E-03_JPRB, 0.38249386E-03_JPRB, 0.38242044E-03_JPRB, 0.38231317E-03_JPRB, 0.38228886E-03_JPRB, 0.38238539E-03_JPRB, &
  & 0.38247599E-03_JPRB, 0.38257681E-03_JPRB, 0.38284834E-03_JPRB, 0.38319903E-03_JPRB, 0.38353261E-03_JPRB, 0.38384684E-03_JPRB, &
  & 0.38429911E-03_JPRB, 0.38472706E-03_JPRB, 0.38507035E-03_JPRB, 0.38527591E-03_JPRB, 0.38535582E-03_JPRB, 0.38527911E-03_JPRB, &
  & 0.38515805E-03_JPRB, 0.38502880E-03_JPRB, 0.38469992E-03_JPRB, 0.38427724E-03_JPRB, 0.38391015E-03_JPRB, 0.38367149E-03_JPRB, &
  & 0.38338507E-03_JPRB, 0.38294370E-03_JPRB, 0.38234208E-03_JPRB, 0.38197425E-03_JPRB, 0.38172726E-03_JPRB, 0.38136854E-03_JPRB, &
  & 0.38098527E-03_JPRB, 0.38066575E-03_JPRB, 0.38039627E-03_JPRB, 0.38028389E-03_JPRB, 0.38028810E-03_JPRB, 0.38024948E-03_JPRB, &
  & 0.38014488E-03_JPRB, 0.38009421E-03_JPRB, 0.38012660E-03_JPRB, 0.38022474E-03_JPRB, 0.38026834E-03_JPRB, 0.38031351E-03_JPRB, &
  & 0.38071115E-03_JPRB, 0.38086000E-03_JPRB, 0.38104438E-03_JPRB, 0.38142245E-03_JPRB  /)

RGHG1(:,67, 8) = (/ &
  & 0.38600692E-03_JPRB, 0.38608238E-03_JPRB, 0.38589285E-03_JPRB, 0.38576754E-03_JPRB, 0.38552451E-03_JPRB, 0.38526637E-03_JPRB, &
  & 0.38505539E-03_JPRB, 0.38486115E-03_JPRB, 0.38470329E-03_JPRB, 0.38442691E-03_JPRB, 0.38417761E-03_JPRB, 0.38388145E-03_JPRB, &
  & 0.38363046E-03_JPRB, 0.38346120E-03_JPRB, 0.38329279E-03_JPRB, 0.38311547E-03_JPRB, 0.38294405E-03_JPRB, 0.38282746E-03_JPRB, &
  & 0.38272349E-03_JPRB, 0.38260192E-03_JPRB, 0.38251105E-03_JPRB, 0.38239165E-03_JPRB, 0.38234210E-03_JPRB, 0.38242583E-03_JPRB, &
  & 0.38253881E-03_JPRB, 0.38263452E-03_JPRB, 0.38292651E-03_JPRB, 0.38328138E-03_JPRB, 0.38360142E-03_JPRB, 0.38395556E-03_JPRB, &
  & 0.38444050E-03_JPRB, 0.38484638E-03_JPRB, 0.38517037E-03_JPRB, 0.38532328E-03_JPRB, 0.38534518E-03_JPRB, 0.38523707E-03_JPRB, &
  & 0.38510234E-03_JPRB, 0.38498351E-03_JPRB, 0.38469011E-03_JPRB, 0.38431343E-03_JPRB, 0.38398162E-03_JPRB, 0.38378310E-03_JPRB, &
  & 0.38349721E-03_JPRB, 0.38303520E-03_JPRB, 0.38241244E-03_JPRB, 0.38200298E-03_JPRB, 0.38175169E-03_JPRB, 0.38137677E-03_JPRB, &
  & 0.38099210E-03_JPRB, 0.38069576E-03_JPRB, 0.38044019E-03_JPRB, 0.38035488E-03_JPRB, 0.38036984E-03_JPRB, 0.38034817E-03_JPRB, &
  & 0.38026344E-03_JPRB, 0.38023727E-03_JPRB, 0.38030359E-03_JPRB, 0.38046622E-03_JPRB, 0.38054815E-03_JPRB, 0.38061396E-03_JPRB, &
  & 0.38099808E-03_JPRB, 0.38119083E-03_JPRB, 0.38142136E-03_JPRB, 0.38177300E-03_JPRB  /)

RGHG1(:,68, 8) = (/ &
  & 0.38601602E-03_JPRB, 0.38609562E-03_JPRB, 0.38590793E-03_JPRB, 0.38582775E-03_JPRB, 0.38559910E-03_JPRB, 0.38535881E-03_JPRB, &
  & 0.38516233E-03_JPRB, 0.38499169E-03_JPRB, 0.38485203E-03_JPRB, 0.38457565E-03_JPRB, 0.38433313E-03_JPRB, 0.38404008E-03_JPRB, &
  & 0.38377114E-03_JPRB, 0.38359117E-03_JPRB, 0.38340606E-03_JPRB, 0.38323485E-03_JPRB, 0.38306538E-03_JPRB, 0.38295259E-03_JPRB, &
  & 0.38284379E-03_JPRB, 0.38273270E-03_JPRB, 0.38262456E-03_JPRB, 0.38249733E-03_JPRB, 0.38241635E-03_JPRB, 0.38247821E-03_JPRB, &
  & 0.38260927E-03_JPRB, 0.38272512E-03_JPRB, 0.38303990E-03_JPRB, 0.38337658E-03_JPRB, 0.38368327E-03_JPRB, 0.38407529E-03_JPRB, &
  & 0.38458647E-03_JPRB, 0.38497670E-03_JPRB, 0.38526557E-03_JPRB, 0.38536518E-03_JPRB, 0.38533366E-03_JPRB, 0.38519655E-03_JPRB, &
  & 0.38506539E-03_JPRB, 0.38495059E-03_JPRB, 0.38469334E-03_JPRB, 0.38435176E-03_JPRB, 0.38405058E-03_JPRB, 0.38388394E-03_JPRB, &
  & 0.38359483E-03_JPRB, 0.38311141E-03_JPRB, 0.38248808E-03_JPRB, 0.38205467E-03_JPRB, 0.38180004E-03_JPRB, 0.38141165E-03_JPRB, &
  & 0.38102514E-03_JPRB, 0.38075274E-03_JPRB, 0.38050662E-03_JPRB, 0.38044364E-03_JPRB, 0.38046216E-03_JPRB, 0.38045672E-03_JPRB, &
  & 0.38038916E-03_JPRB, 0.38038405E-03_JPRB, 0.38047316E-03_JPRB, 0.38068380E-03_JPRB, 0.38081511E-03_JPRB, 0.38090671E-03_JPRB, &
  & 0.38127068E-03_JPRB, 0.38150292E-03_JPRB, 0.38178157E-03_JPRB, 0.38209395E-03_JPRB  /)

RGHG1(:,69, 8) = (/ &
  & 0.38600175E-03_JPRB, 0.38608581E-03_JPRB, 0.38591128E-03_JPRB, 0.38586552E-03_JPRB, 0.38564896E-03_JPRB, 0.38543091E-03_JPRB, &
  & 0.38525365E-03_JPRB, 0.38510398E-03_JPRB, 0.38497768E-03_JPRB, 0.38471000E-03_JPRB, 0.38447428E-03_JPRB, 0.38418832E-03_JPRB, &
  & 0.38391022E-03_JPRB, 0.38372038E-03_JPRB, 0.38351932E-03_JPRB, 0.38335798E-03_JPRB, 0.38319120E-03_JPRB, 0.38308420E-03_JPRB, &
  & 0.38298125E-03_JPRB, 0.38288011E-03_JPRB, 0.38276790E-03_JPRB, 0.38262950E-03_JPRB, 0.38252527E-03_JPRB, 0.38255908E-03_JPRB, &
  & 0.38269165E-03_JPRB, 0.38284284E-03_JPRB, 0.38317464E-03_JPRB, 0.38348256E-03_JPRB, 0.38378920E-03_JPRB, 0.38420693E-03_JPRB, &
  & 0.38470915E-03_JPRB, 0.38507828E-03_JPRB, 0.38534095E-03_JPRB, 0.38539639E-03_JPRB, 0.38532603E-03_JPRB, 0.38517080E-03_JPRB, &
  & 0.38505108E-03_JPRB, 0.38493077E-03_JPRB, 0.38470316E-03_JPRB, 0.38438286E-03_JPRB, 0.38410632E-03_JPRB, 0.38395784E-03_JPRB, &
  & 0.38366404E-03_JPRB, 0.38317608E-03_JPRB, 0.38257438E-03_JPRB, 0.38213642E-03_JPRB, 0.38185928E-03_JPRB, 0.38144978E-03_JPRB, &
  & 0.38107514E-03_JPRB, 0.38082061E-03_JPRB, 0.38058330E-03_JPRB, 0.38052505E-03_JPRB, 0.38054536E-03_JPRB, 0.38055552E-03_JPRB, &
  & 0.38050384E-03_JPRB, 0.38051927E-03_JPRB, 0.38062803E-03_JPRB, 0.38086885E-03_JPRB, 0.38105949E-03_JPRB, 0.38117279E-03_JPRB, &
  & 0.38151820E-03_JPRB, 0.38178520E-03_JPRB, 0.38209079E-03_JPRB, 0.38234663E-03_JPRB  /)

RGHG1(:,70, 8) = (/ &
  & 0.38597878E-03_JPRB, 0.38606607E-03_JPRB, 0.38591367E-03_JPRB, 0.38589039E-03_JPRB, 0.38568731E-03_JPRB, 0.38549098E-03_JPRB, &
  & 0.38533678E-03_JPRB, 0.38520493E-03_JPRB, 0.38508773E-03_JPRB, 0.38483625E-03_JPRB, 0.38460679E-03_JPRB, 0.38433067E-03_JPRB, &
  & 0.38404861E-03_JPRB, 0.38384998E-03_JPRB, 0.38363481E-03_JPRB, 0.38348333E-03_JPRB, 0.38331946E-03_JPRB, 0.38321778E-03_JPRB, &
  & 0.38312610E-03_JPRB, 0.38303501E-03_JPRB, 0.38291990E-03_JPRB, 0.38277505E-03_JPRB, 0.38265362E-03_JPRB, 0.38265838E-03_JPRB, &
  & 0.38278408E-03_JPRB, 0.38297016E-03_JPRB, 0.38330347E-03_JPRB, 0.38358420E-03_JPRB, 0.38389337E-03_JPRB, 0.38432276E-03_JPRB, &
  & 0.38479781E-03_JPRB, 0.38514619E-03_JPRB, 0.38538710E-03_JPRB, 0.38541858E-03_JPRB, 0.38532445E-03_JPRB, 0.38515202E-03_JPRB, &
  & 0.38504204E-03_JPRB, 0.38491655E-03_JPRB, 0.38470757E-03_JPRB, 0.38440274E-03_JPRB, 0.38415471E-03_JPRB, 0.38401271E-03_JPRB, &
  & 0.38371487E-03_JPRB, 0.38323593E-03_JPRB, 0.38266205E-03_JPRB, 0.38222498E-03_JPRB, 0.38191556E-03_JPRB, 0.38148422E-03_JPRB, &
  & 0.38112626E-03_JPRB, 0.38088273E-03_JPRB, 0.38065117E-03_JPRB, 0.38058642E-03_JPRB, 0.38061363E-03_JPRB, 0.38063729E-03_JPRB, &
  & 0.38060175E-03_JPRB, 0.38063443E-03_JPRB, 0.38076290E-03_JPRB, 0.38102518E-03_JPRB, 0.38127337E-03_JPRB, 0.38141108E-03_JPRB, &
  & 0.38174292E-03_JPRB, 0.38204021E-03_JPRB, 0.38235506E-03_JPRB, 0.38255476E-03_JPRB  /)

RGHG1(:,71, 8) = (/ &
  & 0.38595247E-03_JPRB, 0.38604096E-03_JPRB, 0.38591722E-03_JPRB, 0.38590414E-03_JPRB, 0.38571740E-03_JPRB, 0.38554179E-03_JPRB, &
  & 0.38541346E-03_JPRB, 0.38529555E-03_JPRB, 0.38518336E-03_JPRB, 0.38495429E-03_JPRB, 0.38473129E-03_JPRB, 0.38446711E-03_JPRB, &
  & 0.38418555E-03_JPRB, 0.38397971E-03_JPRB, 0.38375319E-03_JPRB, 0.38360992E-03_JPRB, 0.38344966E-03_JPRB, 0.38335300E-03_JPRB, &
  & 0.38327481E-03_JPRB, 0.38319549E-03_JPRB, 0.38307555E-03_JPRB, 0.38293035E-03_JPRB, 0.38279751E-03_JPRB, 0.38277646E-03_JPRB, &
  & 0.38289057E-03_JPRB, 0.38310090E-03_JPRB, 0.38342115E-03_JPRB, 0.38367970E-03_JPRB, 0.38398778E-03_JPRB, 0.38441521E-03_JPRB, &
  & 0.38485147E-03_JPRB, 0.38517564E-03_JPRB, 0.38539988E-03_JPRB, 0.38542848E-03_JPRB, 0.38532699E-03_JPRB, 0.38513770E-03_JPRB, &
  & 0.38503422E-03_JPRB, 0.38490696E-03_JPRB, 0.38470713E-03_JPRB, 0.38441394E-03_JPRB, 0.38419569E-03_JPRB, 0.38405015E-03_JPRB, &
  & 0.38374926E-03_JPRB, 0.38328805E-03_JPRB, 0.38274630E-03_JPRB, 0.38231188E-03_JPRB, 0.38196547E-03_JPRB, 0.38151071E-03_JPRB, &
  & 0.38117073E-03_JPRB, 0.38093036E-03_JPRB, 0.38070229E-03_JPRB, 0.38062172E-03_JPRB, 0.38066108E-03_JPRB, 0.38069702E-03_JPRB, &
  & 0.38067614E-03_JPRB, 0.38072288E-03_JPRB, 0.38087345E-03_JPRB, 0.38115597E-03_JPRB, 0.38145795E-03_JPRB, 0.38162175E-03_JPRB, &
  & 0.38194544E-03_JPRB, 0.38226829E-03_JPRB, 0.38257540E-03_JPRB, 0.38271991E-03_JPRB  /)

RGHG1(:,72, 8) = (/ &
  & 0.38592988E-03_JPRB, 0.38601630E-03_JPRB, 0.38592379E-03_JPRB, 0.38590806E-03_JPRB, 0.38574263E-03_JPRB, 0.38558696E-03_JPRB, &
  & 0.38548559E-03_JPRB, 0.38537645E-03_JPRB, 0.38526529E-03_JPRB, 0.38506284E-03_JPRB, 0.38484802E-03_JPRB, 0.38459698E-03_JPRB, &
  & 0.38431980E-03_JPRB, 0.38410935E-03_JPRB, 0.38387580E-03_JPRB, 0.38373668E-03_JPRB, 0.38358183E-03_JPRB, 0.38349071E-03_JPRB, &
  & 0.38342323E-03_JPRB, 0.38336051E-03_JPRB, 0.38323031E-03_JPRB, 0.38309190E-03_JPRB, 0.38295353E-03_JPRB, 0.38291704E-03_JPRB, &
  & 0.38302009E-03_JPRB, 0.38322731E-03_JPRB, 0.38352348E-03_JPRB, 0.38376900E-03_JPRB, 0.38406245E-03_JPRB, 0.38447524E-03_JPRB, &
  & 0.38486991E-03_JPRB, 0.38515755E-03_JPRB, 0.38537245E-03_JPRB, 0.38541915E-03_JPRB, 0.38532952E-03_JPRB, 0.38512468E-03_JPRB, &
  & 0.38502339E-03_JPRB, 0.38490177E-03_JPRB, 0.38470540E-03_JPRB, 0.38442213E-03_JPRB, 0.38422784E-03_JPRB, 0.38407135E-03_JPRB, &
  & 0.38376862E-03_JPRB, 0.38332538E-03_JPRB, 0.38282005E-03_JPRB, 0.38238586E-03_JPRB, 0.38200535E-03_JPRB, 0.38152235E-03_JPRB, &
  & 0.38119689E-03_JPRB, 0.38094983E-03_JPRB, 0.38072499E-03_JPRB, 0.38062137E-03_JPRB, 0.38067709E-03_JPRB, 0.38072617E-03_JPRB, &
  & 0.38071486E-03_JPRB, 0.38077324E-03_JPRB, 0.38095227E-03_JPRB, 0.38126648E-03_JPRB, 0.38161720E-03_JPRB, 0.38180543E-03_JPRB, &
  & 0.38212659E-03_JPRB, 0.38246972E-03_JPRB, 0.38275229E-03_JPRB, 0.38283976E-03_JPRB  /)

RGHG1(:,73, 8) = (/ &
  & 0.38591936E-03_JPRB, 0.38599716E-03_JPRB, 0.38593104E-03_JPRB, 0.38590783E-03_JPRB, 0.38576385E-03_JPRB, 0.38562844E-03_JPRB, &
  & 0.38555120E-03_JPRB, 0.38544658E-03_JPRB, 0.38533572E-03_JPRB, 0.38515758E-03_JPRB, 0.38495549E-03_JPRB, 0.38471894E-03_JPRB, &
  & 0.38444991E-03_JPRB, 0.38424070E-03_JPRB, 0.38400961E-03_JPRB, 0.38386909E-03_JPRB, 0.38372279E-03_JPRB, 0.38363819E-03_JPRB, &
  & 0.38358684E-03_JPRB, 0.38354113E-03_JPRB, 0.38340811E-03_JPRB, 0.38327900E-03_JPRB, 0.38313838E-03_JPRB, 0.38309577E-03_JPRB, &
  & 0.38318020E-03_JPRB, 0.38335531E-03_JPRB, 0.38361410E-03_JPRB, 0.38385305E-03_JPRB, 0.38411007E-03_JPRB, 0.38450012E-03_JPRB, &
  & 0.38486193E-03_JPRB, 0.38509636E-03_JPRB, 0.38530765E-03_JPRB, 0.38537682E-03_JPRB, 0.38531999E-03_JPRB, 0.38510741E-03_JPRB, &
  & 0.38500373E-03_JPRB, 0.38489474E-03_JPRB, 0.38470217E-03_JPRB, 0.38442672E-03_JPRB, 0.38423301E-03_JPRB, 0.38406541E-03_JPRB, &
  & 0.38375985E-03_JPRB, 0.38333609E-03_JPRB, 0.38287455E-03_JPRB, 0.38244273E-03_JPRB, 0.38203069E-03_JPRB, 0.38150753E-03_JPRB, &
  & 0.38118266E-03_JPRB, 0.38092343E-03_JPRB, 0.38068953E-03_JPRB, 0.38056156E-03_JPRB, 0.38062668E-03_JPRB, 0.38068330E-03_JPRB, &
  & 0.38068150E-03_JPRB, 0.38076710E-03_JPRB, 0.38098620E-03_JPRB, 0.38134426E-03_JPRB, 0.38174123E-03_JPRB, 0.38195082E-03_JPRB, &
  & 0.38227424E-03_JPRB, 0.38262825E-03_JPRB, 0.38287758E-03_JPRB, 0.38292885E-03_JPRB  /)

RGHG1(:,74, 8) = (/ &
  & 0.38591752E-03_JPRB, 0.38598318E-03_JPRB, 0.38593792E-03_JPRB, 0.38591004E-03_JPRB, 0.38578532E-03_JPRB, 0.38566754E-03_JPRB, &
  & 0.38560901E-03_JPRB, 0.38550884E-03_JPRB, 0.38540058E-03_JPRB, 0.38524278E-03_JPRB, 0.38505663E-03_JPRB, 0.38483662E-03_JPRB, &
  & 0.38457549E-03_JPRB, 0.38437401E-03_JPRB, 0.38415193E-03_JPRB, 0.38401068E-03_JPRB, 0.38386761E-03_JPRB, 0.38378697E-03_JPRB, &
  & 0.38374767E-03_JPRB, 0.38371933E-03_JPRB, 0.38359691E-03_JPRB, 0.38348683E-03_JPRB, 0.38334682E-03_JPRB, 0.38329805E-03_JPRB, &
  & 0.38336791E-03_JPRB, 0.38349883E-03_JPRB, 0.38370552E-03_JPRB, 0.38391340E-03_JPRB, 0.38413038E-03_JPRB, 0.38449216E-03_JPRB, &
  & 0.38483218E-03_JPRB, 0.38502151E-03_JPRB, 0.38522522E-03_JPRB, 0.38531464E-03_JPRB, 0.38529609E-03_JPRB, 0.38508521E-03_JPRB, &
  & 0.38497492E-03_JPRB, 0.38488101E-03_JPRB, 0.38469254E-03_JPRB, 0.38442203E-03_JPRB, 0.38422025E-03_JPRB, 0.38404041E-03_JPRB, &
  & 0.38373405E-03_JPRB, 0.38333133E-03_JPRB, 0.38291011E-03_JPRB, 0.38248397E-03_JPRB, 0.38203356E-03_JPRB, 0.38147477E-03_JPRB, &
  & 0.38113527E-03_JPRB, 0.38086001E-03_JPRB, 0.38061352E-03_JPRB, 0.38045492E-03_JPRB, 0.38052397E-03_JPRB, 0.38058675E-03_JPRB, &
  & 0.38059793E-03_JPRB, 0.38073060E-03_JPRB, 0.38099565E-03_JPRB, 0.38140522E-03_JPRB, 0.38184136E-03_JPRB, 0.38207252E-03_JPRB, &
  & 0.38240591E-03_JPRB, 0.38276311E-03_JPRB, 0.38298518E-03_JPRB, 0.38301074E-03_JPRB  /)

RGHG1(:,75, 8) = (/ &
  & 0.38592356E-03_JPRB, 0.38597586E-03_JPRB, 0.38594434E-03_JPRB, 0.38591584E-03_JPRB, 0.38580744E-03_JPRB, 0.38570387E-03_JPRB, &
  & 0.38565825E-03_JPRB, 0.38556354E-03_JPRB, 0.38546023E-03_JPRB, 0.38531802E-03_JPRB, 0.38515017E-03_JPRB, 0.38494824E-03_JPRB, &
  & 0.38469564E-03_JPRB, 0.38450445E-03_JPRB, 0.38429695E-03_JPRB, 0.38415781E-03_JPRB, 0.38401406E-03_JPRB, 0.38393207E-03_JPRB, &
  & 0.38390267E-03_JPRB, 0.38388544E-03_JPRB, 0.38378528E-03_JPRB, 0.38370139E-03_JPRB, 0.38356902E-03_JPRB, 0.38350988E-03_JPRB, &
  & 0.38355943E-03_JPRB, 0.38364360E-03_JPRB, 0.38378604E-03_JPRB, 0.38394674E-03_JPRB, 0.38412559E-03_JPRB, 0.38445984E-03_JPRB, &
  & 0.38478626E-03_JPRB, 0.38493967E-03_JPRB, 0.38513300E-03_JPRB, 0.38523918E-03_JPRB, 0.38526186E-03_JPRB, 0.38505986E-03_JPRB, &
  & 0.38493892E-03_JPRB, 0.38486223E-03_JPRB, 0.38467669E-03_JPRB, 0.38440623E-03_JPRB, 0.38419195E-03_JPRB, 0.38400252E-03_JPRB, &
  & 0.38369606E-03_JPRB, 0.38331366E-03_JPRB, 0.38293149E-03_JPRB, 0.38250789E-03_JPRB, 0.38200720E-03_JPRB, 0.38142230E-03_JPRB, &
  & 0.38105701E-03_JPRB, 0.38076409E-03_JPRB, 0.38050145E-03_JPRB, 0.38031288E-03_JPRB, 0.38038317E-03_JPRB, 0.38044511E-03_JPRB, &
  & 0.38047703E-03_JPRB, 0.38067059E-03_JPRB, 0.38098694E-03_JPRB, 0.38145193E-03_JPRB, 0.38192130E-03_JPRB, 0.38217621E-03_JPRB, &
  & 0.38252448E-03_JPRB, 0.38287522E-03_JPRB, 0.38307434E-03_JPRB, 0.38308153E-03_JPRB  /)

RGHG1(:,76, 8) = (/ &
  & 0.38593693E-03_JPRB, 0.38597782E-03_JPRB, 0.38595034E-03_JPRB, 0.38592621E-03_JPRB, 0.38583027E-03_JPRB, 0.38573660E-03_JPRB, &
  & 0.38569779E-03_JPRB, 0.38561068E-03_JPRB, 0.38551441E-03_JPRB, 0.38538199E-03_JPRB, 0.38523373E-03_JPRB, 0.38505059E-03_JPRB, &
  & 0.38480917E-03_JPRB, 0.38462467E-03_JPRB, 0.38443630E-03_JPRB, 0.38430477E-03_JPRB, 0.38415975E-03_JPRB, 0.38406716E-03_JPRB, &
  & 0.38404997E-03_JPRB, 0.38402699E-03_JPRB, 0.38395737E-03_JPRB, 0.38390195E-03_JPRB, 0.38379113E-03_JPRB, 0.38371205E-03_JPRB, &
  & 0.38371815E-03_JPRB, 0.38376543E-03_JPRB, 0.38383526E-03_JPRB, 0.38394996E-03_JPRB, 0.38409862E-03_JPRB, 0.38441558E-03_JPRB, &
  & 0.38473186E-03_JPRB, 0.38485669E-03_JPRB, 0.38503998E-03_JPRB, 0.38515838E-03_JPRB, 0.38522371E-03_JPRB, 0.38503416E-03_JPRB, &
  & 0.38489858E-03_JPRB, 0.38484148E-03_JPRB, 0.38465537E-03_JPRB, 0.38437695E-03_JPRB, 0.38415011E-03_JPRB, 0.38395987E-03_JPRB, &
  & 0.38365157E-03_JPRB, 0.38328519E-03_JPRB, 0.38294590E-03_JPRB, 0.38251123E-03_JPRB, 0.38194127E-03_JPRB, 0.38134542E-03_JPRB, &
  & 0.38094947E-03_JPRB, 0.38064053E-03_JPRB, 0.38035668E-03_JPRB, 0.38015048E-03_JPRB, 0.38022341E-03_JPRB, 0.38026784E-03_JPRB, &
  & 0.38033479E-03_JPRB, 0.38059337E-03_JPRB, 0.38096665E-03_JPRB, 0.38148593E-03_JPRB, 0.38198504E-03_JPRB, 0.38226865E-03_JPRB, &
  & 0.38263202E-03_JPRB, 0.38296305E-03_JPRB, 0.38313877E-03_JPRB, 0.38313156E-03_JPRB  /)

RGHG1(:,77, 8) = (/ &
  & 0.38596136E-03_JPRB, 0.38599123E-03_JPRB, 0.38595498E-03_JPRB, 0.38593917E-03_JPRB, 0.38585197E-03_JPRB, 0.38576282E-03_JPRB, &
  & 0.38572614E-03_JPRB, 0.38564829E-03_JPRB, 0.38555993E-03_JPRB, 0.38543212E-03_JPRB, 0.38530252E-03_JPRB, 0.38513788E-03_JPRB, &
  & 0.38490714E-03_JPRB, 0.38472554E-03_JPRB, 0.38454571E-03_JPRB, 0.38441579E-03_JPRB, 0.38427847E-03_JPRB, 0.38417945E-03_JPRB, &
  & 0.38416057E-03_JPRB, 0.38413351E-03_JPRB, 0.38408057E-03_JPRB, 0.38404206E-03_JPRB, 0.38394556E-03_JPRB, 0.38385412E-03_JPRB, &
  & 0.38382757E-03_JPRB, 0.38384154E-03_JPRB, 0.38386888E-03_JPRB, 0.38394703E-03_JPRB, 0.38407514E-03_JPRB, 0.38437978E-03_JPRB, &
  & 0.38468555E-03_JPRB, 0.38478903E-03_JPRB, 0.38496105E-03_JPRB, 0.38508319E-03_JPRB, 0.38519000E-03_JPRB, 0.38501219E-03_JPRB, &
  & 0.38485810E-03_JPRB, 0.38482376E-03_JPRB, 0.38463385E-03_JPRB, 0.38433340E-03_JPRB, 0.38410268E-03_JPRB, 0.38390697E-03_JPRB, &
  & 0.38360644E-03_JPRB, 0.38326297E-03_JPRB, 0.38294887E-03_JPRB, 0.38248635E-03_JPRB, 0.38184668E-03_JPRB, 0.38122953E-03_JPRB, &
  & 0.38081644E-03_JPRB, 0.38050223E-03_JPRB, 0.38019854E-03_JPRB, 0.37997555E-03_JPRB, 0.38004675E-03_JPRB, 0.38007606E-03_JPRB, &
  & 0.38018177E-03_JPRB, 0.38050140E-03_JPRB, 0.38094464E-03_JPRB, 0.38151188E-03_JPRB, 0.38203804E-03_JPRB, 0.38234178E-03_JPRB, &
  & 0.38272446E-03_JPRB, 0.38303040E-03_JPRB, 0.38319847E-03_JPRB, 0.38320314E-03_JPRB  /)

RGHG1(:,78, 8) = (/ &
  & 0.38598749E-03_JPRB, 0.38600388E-03_JPRB, 0.38595744E-03_JPRB, 0.38594911E-03_JPRB, 0.38587138E-03_JPRB, 0.38578524E-03_JPRB, &
  & 0.38574678E-03_JPRB, 0.38567782E-03_JPRB, 0.38559723E-03_JPRB, 0.38547344E-03_JPRB, 0.38535889E-03_JPRB, 0.38520918E-03_JPRB, &
  & 0.38498622E-03_JPRB, 0.38480589E-03_JPRB, 0.38463250E-03_JPRB, 0.38450424E-03_JPRB, 0.38437552E-03_JPRB, 0.38427455E-03_JPRB, &
  & 0.38424788E-03_JPRB, 0.38421271E-03_JPRB, 0.38416901E-03_JPRB, 0.38413534E-03_JPRB, 0.38404892E-03_JPRB, 0.38395458E-03_JPRB, &
  & 0.38391302E-03_JPRB, 0.38390232E-03_JPRB, 0.38389959E-03_JPRB, 0.38394955E-03_JPRB, 0.38406167E-03_JPRB, 0.38435749E-03_JPRB, &
  & 0.38465181E-03_JPRB, 0.38473309E-03_JPRB, 0.38489187E-03_JPRB, 0.38501839E-03_JPRB, 0.38516001E-03_JPRB, 0.38499422E-03_JPRB, &
  & 0.38482133E-03_JPRB, 0.38480873E-03_JPRB, 0.38461708E-03_JPRB, 0.38429657E-03_JPRB, 0.38405327E-03_JPRB, 0.38385511E-03_JPRB, &
  & 0.38356947E-03_JPRB, 0.38324525E-03_JPRB, 0.38295514E-03_JPRB, 0.38246023E-03_JPRB, 0.38176393E-03_JPRB, 0.38111852E-03_JPRB, &
  & 0.38069588E-03_JPRB, 0.38038086E-03_JPRB, 0.38005680E-03_JPRB, 0.37981900E-03_JPRB, 0.37988087E-03_JPRB, 0.37989727E-03_JPRB, &
  & 0.38004046E-03_JPRB, 0.38040659E-03_JPRB, 0.38091414E-03_JPRB, 0.38152519E-03_JPRB, 0.38207312E-03_JPRB, 0.38239993E-03_JPRB, &
  & 0.38279865E-03_JPRB, 0.38308138E-03_JPRB, 0.38322813E-03_JPRB, 0.38323949E-03_JPRB  /)

RGHG1(:,79, 8) = (/ &
  & 0.38601101E-03_JPRB, 0.38601356E-03_JPRB, 0.38595813E-03_JPRB, 0.38595438E-03_JPRB, 0.38588799E-03_JPRB, 0.38580412E-03_JPRB, &
  & 0.38576129E-03_JPRB, 0.38569958E-03_JPRB, 0.38562797E-03_JPRB, 0.38550834E-03_JPRB, 0.38540352E-03_JPRB, 0.38526394E-03_JPRB, &
  & 0.38504698E-03_JPRB, 0.38486719E-03_JPRB, 0.38469907E-03_JPRB, 0.38457417E-03_JPRB, 0.38445109E-03_JPRB, 0.38434921E-03_JPRB, &
  & 0.38431261E-03_JPRB, 0.38426723E-03_JPRB, 0.38422853E-03_JPRB, 0.38419217E-03_JPRB, 0.38411249E-03_JPRB, 0.38402275E-03_JPRB, &
  & 0.38397789E-03_JPRB, 0.38395147E-03_JPRB, 0.38392881E-03_JPRB, 0.38395831E-03_JPRB, 0.38405649E-03_JPRB, 0.38434694E-03_JPRB, &
  & 0.38463113E-03_JPRB, 0.38468965E-03_JPRB, 0.38483527E-03_JPRB, 0.38496486E-03_JPRB, 0.38513299E-03_JPRB, 0.38497812E-03_JPRB, &
  & 0.38478838E-03_JPRB, 0.38479668E-03_JPRB, 0.38460520E-03_JPRB, 0.38426907E-03_JPRB, 0.38400654E-03_JPRB, 0.38380588E-03_JPRB, &
  & 0.38353872E-03_JPRB, 0.38323076E-03_JPRB, 0.38296416E-03_JPRB, 0.38244181E-03_JPRB, 0.38170275E-03_JPRB, 0.38102528E-03_JPRB, &
  & 0.38059477E-03_JPRB, 0.38028230E-03_JPRB, 0.37993956E-03_JPRB, 0.37968561E-03_JPRB, 0.37973443E-03_JPRB, 0.37974038E-03_JPRB, &
  & 0.37991786E-03_JPRB, 0.38031306E-03_JPRB, 0.38087610E-03_JPRB, 0.38153312E-03_JPRB, 0.38209406E-03_JPRB, 0.38244354E-03_JPRB, &
  & 0.38285670E-03_JPRB, 0.38311844E-03_JPRB, 0.38323834E-03_JPRB, 0.38325325E-03_JPRB  /)

RGHG1(:,80, 8) = (/ &
  & 0.38602777E-03_JPRB, 0.38601866E-03_JPRB, 0.38595761E-03_JPRB, 0.38595367E-03_JPRB, 0.38590140E-03_JPRB, 0.38581970E-03_JPRB, &
  & 0.38577131E-03_JPRB, 0.38571399E-03_JPRB, 0.38565414E-03_JPRB, 0.38553938E-03_JPRB, 0.38543736E-03_JPRB, 0.38530204E-03_JPRB, &
  & 0.38509071E-03_JPRB, 0.38491161E-03_JPRB, 0.38474811E-03_JPRB, 0.38462979E-03_JPRB, 0.38450556E-03_JPRB, 0.38439991E-03_JPRB, &
  & 0.38435522E-03_JPRB, 0.38430013E-03_JPRB, 0.38426546E-03_JPRB, 0.38422408E-03_JPRB, 0.38414864E-03_JPRB, 0.38406860E-03_JPRB, &
  & 0.38402477E-03_JPRB, 0.38399137E-03_JPRB, 0.38395721E-03_JPRB, 0.38397309E-03_JPRB, 0.38405690E-03_JPRB, 0.38434537E-03_JPRB, &
  & 0.38462333E-03_JPRB, 0.38465947E-03_JPRB, 0.38479444E-03_JPRB, 0.38492300E-03_JPRB, 0.38510826E-03_JPRB, 0.38496155E-03_JPRB, &
  & 0.38475909E-03_JPRB, 0.38478792E-03_JPRB, 0.38459789E-03_JPRB, 0.38425222E-03_JPRB, 0.38396749E-03_JPRB, 0.38376026E-03_JPRB, &
  & 0.38351130E-03_JPRB, 0.38321809E-03_JPRB, 0.38297417E-03_JPRB, 0.38243901E-03_JPRB, 0.38167075E-03_JPRB, 0.38096067E-03_JPRB, &
  & 0.38051788E-03_JPRB, 0.38021040E-03_JPRB, 0.37985310E-03_JPRB, 0.37957789E-03_JPRB, 0.37961471E-03_JPRB, 0.37961292E-03_JPRB, &
  & 0.37981981E-03_JPRB, 0.38022442E-03_JPRB, 0.38083204E-03_JPRB, 0.38154416E-03_JPRB, 0.38210585E-03_JPRB, 0.38247310E-03_JPRB, &
  & 0.38290150E-03_JPRB, 0.38314430E-03_JPRB, 0.38324313E-03_JPRB, 0.38326297E-03_JPRB  /)

RGHG1(:,81, 8) = (/ &
  & 0.38603559E-03_JPRB, 0.38601949E-03_JPRB, 0.38595216E-03_JPRB, 0.38594490E-03_JPRB, 0.38590733E-03_JPRB, 0.38582965E-03_JPRB, &
  & 0.38577902E-03_JPRB, 0.38572324E-03_JPRB, 0.38567227E-03_JPRB, 0.38555858E-03_JPRB, 0.38545537E-03_JPRB, 0.38532373E-03_JPRB, &
  & 0.38511773E-03_JPRB, 0.38493840E-03_JPRB, 0.38477821E-03_JPRB, 0.38466404E-03_JPRB, 0.38453815E-03_JPRB, 0.38442717E-03_JPRB, &
  & 0.38437904E-03_JPRB, 0.38431827E-03_JPRB, 0.38428763E-03_JPRB, 0.38424802E-03_JPRB, 0.38417733E-03_JPRB, 0.38410321E-03_JPRB, &
  & 0.38406033E-03_JPRB, 0.38402728E-03_JPRB, 0.38399300E-03_JPRB, 0.38400047E-03_JPRB, 0.38407077E-03_JPRB, 0.38436042E-03_JPRB, &
  & 0.38463411E-03_JPRB, 0.38464631E-03_JPRB, 0.38476860E-03_JPRB, 0.38489468E-03_JPRB, 0.38507732E-03_JPRB, 0.38493797E-03_JPRB, &
  & 0.38472993E-03_JPRB, 0.38478175E-03_JPRB, 0.38459682E-03_JPRB, 0.38424156E-03_JPRB, 0.38393822E-03_JPRB, 0.38372672E-03_JPRB, &
  & 0.38349056E-03_JPRB, 0.38320896E-03_JPRB, 0.38299183E-03_JPRB, 0.38245869E-03_JPRB, 0.38167336E-03_JPRB, 0.38094976E-03_JPRB, &
  & 0.38048422E-03_JPRB, 0.38017721E-03_JPRB, 0.37982229E-03_JPRB, 0.37952622E-03_JPRB, 0.37954644E-03_JPRB, 0.37954074E-03_JPRB, &
  & 0.37976731E-03_JPRB, 0.38017203E-03_JPRB, 0.38080336E-03_JPRB, 0.38156301E-03_JPRB, 0.38212114E-03_JPRB, 0.38249906E-03_JPRB, &
  & 0.38293635E-03_JPRB, 0.38316883E-03_JPRB, 0.38324111E-03_JPRB, 0.38326723E-03_JPRB  /)

RGHG1(:,82, 8) = (/ &
  & 0.38603708E-03_JPRB, 0.38601770E-03_JPRB, 0.38594446E-03_JPRB, 0.38593381E-03_JPRB, 0.38590856E-03_JPRB, 0.38583595E-03_JPRB, &
  & 0.38578634E-03_JPRB, 0.38573283E-03_JPRB, 0.38568735E-03_JPRB, 0.38557349E-03_JPRB, 0.38546764E-03_JPRB, 0.38533825E-03_JPRB, &
  & 0.38513609E-03_JPRB, 0.38495652E-03_JPRB, 0.38479694E-03_JPRB, 0.38468656E-03_JPRB, 0.38455968E-03_JPRB, 0.38444560E-03_JPRB, &
  & 0.38439667E-03_JPRB, 0.38433335E-03_JPRB, 0.38430818E-03_JPRB, 0.38427303E-03_JPRB, 0.38420770E-03_JPRB, 0.38413931E-03_JPRB, &
  & 0.38409770E-03_JPRB, 0.38407032E-03_JPRB, 0.38404400E-03_JPRB, 0.38404613E-03_JPRB, 0.38409639E-03_JPRB, 0.38439130E-03_JPRB, &
  & 0.38466083E-03_JPRB, 0.38464091E-03_JPRB, 0.38474717E-03_JPRB, 0.38486890E-03_JPRB, 0.38504373E-03_JPRB, 0.38489869E-03_JPRB, &
  & 0.38469859E-03_JPRB, 0.38477800E-03_JPRB, 0.38459976E-03_JPRB, 0.38423692E-03_JPRB, 0.38391688E-03_JPRB, 0.38370670E-03_JPRB, &
  & 0.38348408E-03_JPRB, 0.38321304E-03_JPRB, 0.38302473E-03_JPRB, 0.38249841E-03_JPRB, 0.38170861E-03_JPRB, 0.38097600E-03_JPRB, &
  & 0.38048883E-03_JPRB, 0.38018490E-03_JPRB, 0.37984197E-03_JPRB, 0.37952648E-03_JPRB, 0.37952352E-03_JPRB, 0.37951589E-03_JPRB, &
  & 0.37974657E-03_JPRB, 0.38015738E-03_JPRB, 0.38080662E-03_JPRB, 0.38160199E-03_JPRB, 0.38215299E-03_JPRB, 0.38253840E-03_JPRB, &
  & 0.38296501E-03_JPRB, 0.38319558E-03_JPRB, 0.38324605E-03_JPRB, 0.38327245E-03_JPRB  /)

RGHG1(:,83, 8) = (/ &
  & 0.38603308E-03_JPRB, 0.38601415E-03_JPRB, 0.38593622E-03_JPRB, 0.38592170E-03_JPRB, 0.38590666E-03_JPRB, 0.38583908E-03_JPRB, &
  & 0.38579301E-03_JPRB, 0.38574221E-03_JPRB, 0.38570011E-03_JPRB, 0.38558464E-03_JPRB, 0.38547539E-03_JPRB, 0.38534655E-03_JPRB, &
  & 0.38514736E-03_JPRB, 0.38496770E-03_JPRB, 0.38480716E-03_JPRB, 0.38470040E-03_JPRB, 0.38457314E-03_JPRB, 0.38445791E-03_JPRB, &
  & 0.38441150E-03_JPRB, 0.38434846E-03_JPRB, 0.38432972E-03_JPRB, 0.38429851E-03_JPRB, 0.38424146E-03_JPRB, 0.38418048E-03_JPRB, &
  & 0.38414348E-03_JPRB, 0.38412553E-03_JPRB, 0.38411084E-03_JPRB, 0.38411320E-03_JPRB, 0.38413585E-03_JPRB, 0.38443917E-03_JPRB, &
  & 0.38470693E-03_JPRB, 0.38464933E-03_JPRB, 0.38473204E-03_JPRB, 0.38484682E-03_JPRB, 0.38501649E-03_JPRB, 0.38485700E-03_JPRB, &
  & 0.38467150E-03_JPRB, 0.38477920E-03_JPRB, 0.38460895E-03_JPRB, 0.38424145E-03_JPRB, 0.38390587E-03_JPRB, 0.38370101E-03_JPRB, &
  & 0.38349547E-03_JPRB, 0.38324474E-03_JPRB, 0.38308711E-03_JPRB, 0.38257016E-03_JPRB, 0.38178504E-03_JPRB, 0.38104682E-03_JPRB, &
  & 0.38053885E-03_JPRB, 0.38023515E-03_JPRB, 0.37991276E-03_JPRB, 0.37958090E-03_JPRB, 0.37955215E-03_JPRB, 0.37953863E-03_JPRB, &
  & 0.37976142E-03_JPRB, 0.38017856E-03_JPRB, 0.38083813E-03_JPRB, 0.38166173E-03_JPRB, 0.38219902E-03_JPRB, 0.38258685E-03_JPRB, &
  & 0.38299344E-03_JPRB, 0.38322133E-03_JPRB, 0.38325571E-03_JPRB, 0.38327824E-03_JPRB  /)

RGHG1(:,84, 8) = (/ &
  & 0.38602464E-03_JPRB, 0.38600960E-03_JPRB, 0.38592879E-03_JPRB, 0.38590976E-03_JPRB, 0.38590300E-03_JPRB, 0.38583964E-03_JPRB, &
  & 0.38579871E-03_JPRB, 0.38575077E-03_JPRB, 0.38571098E-03_JPRB, 0.38559253E-03_JPRB, 0.38547976E-03_JPRB, 0.38534983E-03_JPRB, &
  & 0.38515321E-03_JPRB, 0.38497360E-03_JPRB, 0.38481158E-03_JPRB, 0.38470845E-03_JPRB, 0.38458132E-03_JPRB, 0.38446648E-03_JPRB, &
  & 0.38442653E-03_JPRB, 0.38436640E-03_JPRB, 0.38435463E-03_JPRB, 0.38432457E-03_JPRB, 0.38428009E-03_JPRB, 0.38422970E-03_JPRB, &
  & 0.38420265E-03_JPRB, 0.38419626E-03_JPRB, 0.38419344E-03_JPRB, 0.38420299E-03_JPRB, 0.38418991E-03_JPRB, 0.38450532E-03_JPRB, &
  & 0.38477490E-03_JPRB, 0.38467661E-03_JPRB, 0.38472624E-03_JPRB, 0.38483127E-03_JPRB, 0.38500421E-03_JPRB, 0.38482494E-03_JPRB, &
  & 0.38465467E-03_JPRB, 0.38478747E-03_JPRB, 0.38462584E-03_JPRB, 0.38425695E-03_JPRB, 0.38390723E-03_JPRB, 0.38371063E-03_JPRB, &
  & 0.38352738E-03_JPRB, 0.38331480E-03_JPRB, 0.38318939E-03_JPRB, 0.38268159E-03_JPRB, 0.38190771E-03_JPRB, 0.38116677E-03_JPRB, &
  & 0.38063864E-03_JPRB, 0.38032869E-03_JPRB, 0.38003288E-03_JPRB, 0.37968923E-03_JPRB, 0.37963530E-03_JPRB, 0.37960769E-03_JPRB, &
  & 0.37981404E-03_JPRB, 0.38023225E-03_JPRB, 0.38089400E-03_JPRB, 0.38174031E-03_JPRB, 0.38225558E-03_JPRB, 0.38263973E-03_JPRB, &
  & 0.38302563E-03_JPRB, 0.38324412E-03_JPRB, 0.38326790E-03_JPRB, 0.38328420E-03_JPRB  /)

RGHG1(:,85, 8) = (/ &
  & 0.38601174E-03_JPRB, 0.38600386E-03_JPRB, 0.38592186E-03_JPRB, 0.38589972E-03_JPRB, 0.38589787E-03_JPRB, 0.38583809E-03_JPRB, &
  & 0.38580181E-03_JPRB, 0.38575662E-03_JPRB, 0.38571767E-03_JPRB, 0.38559624E-03_JPRB, 0.38548072E-03_JPRB, 0.38535042E-03_JPRB, &
  & 0.38515548E-03_JPRB, 0.38497479E-03_JPRB, 0.38481146E-03_JPRB, 0.38471299E-03_JPRB, 0.38458634E-03_JPRB, 0.38447258E-03_JPRB, &
  & 0.38444851E-03_JPRB, 0.38439747E-03_JPRB, 0.38439382E-03_JPRB, 0.38436328E-03_JPRB, 0.38433576E-03_JPRB, 0.38430353E-03_JPRB, &
  & 0.38429310E-03_JPRB, 0.38429770E-03_JPRB, 0.38430921E-03_JPRB, 0.38433238E-03_JPRB, 0.38426709E-03_JPRB, 0.38462037E-03_JPRB, &
  & 0.38489163E-03_JPRB, 0.38474830E-03_JPRB, 0.38475934E-03_JPRB, 0.38485289E-03_JPRB, 0.38504077E-03_JPRB, 0.38483044E-03_JPRB, &
  & 0.38466937E-03_JPRB, 0.38481196E-03_JPRB, 0.38465547E-03_JPRB, 0.38428694E-03_JPRB, 0.38393530E-03_JPRB, 0.38375603E-03_JPRB, &
  & 0.38360062E-03_JPRB, 0.38346092E-03_JPRB, 0.38337243E-03_JPRB, 0.38286069E-03_JPRB, 0.38211404E-03_JPRB, 0.38138004E-03_JPRB, &
  & 0.38083064E-03_JPRB, 0.38051005E-03_JPRB, 0.38023265E-03_JPRB, 0.37988863E-03_JPRB, 0.37980914E-03_JPRB, 0.37975524E-03_JPRB, &
  & 0.37993579E-03_JPRB, 0.38033034E-03_JPRB, 0.38099066E-03_JPRB, 0.38183219E-03_JPRB, 0.38231484E-03_JPRB, 0.38269003E-03_JPRB, &
  & 0.38306015E-03_JPRB, 0.38327148E-03_JPRB, 0.38328032E-03_JPRB, 0.38329006E-03_JPRB  /)

RGHG1(:,86, 8) = (/ &
  & 0.38599840E-03_JPRB, 0.38599819E-03_JPRB, 0.38591536E-03_JPRB, 0.38589132E-03_JPRB, 0.38589261E-03_JPRB, 0.38583634E-03_JPRB, &
  & 0.38580278E-03_JPRB, 0.38576035E-03_JPRB, 0.38572187E-03_JPRB, 0.38559893E-03_JPRB, 0.38548121E-03_JPRB, 0.38535028E-03_JPRB, &
  & 0.38515683E-03_JPRB, 0.38497478E-03_JPRB, 0.38481050E-03_JPRB, 0.38471690E-03_JPRB, 0.38459119E-03_JPRB, 0.38447926E-03_JPRB, &
  & 0.38447893E-03_JPRB, 0.38444262E-03_JPRB, 0.38444975E-03_JPRB, 0.38442154E-03_JPRB, 0.38440631E-03_JPRB, 0.38440065E-03_JPRB, &
  & 0.38440746E-03_JPRB, 0.38441713E-03_JPRB, 0.38444147E-03_JPRB, 0.38449263E-03_JPRB, 0.38438580E-03_JPRB, 0.38481745E-03_JPRB, &
  & 0.38507973E-03_JPRB, 0.38489393E-03_JPRB, 0.38486328E-03_JPRB, 0.38494054E-03_JPRB, 0.38513959E-03_JPRB, 0.38489879E-03_JPRB, &
  & 0.38473546E-03_JPRB, 0.38486491E-03_JPRB, 0.38471152E-03_JPRB, 0.38434307E-03_JPRB, 0.38400943E-03_JPRB, 0.38385393E-03_JPRB, &
  & 0.38372275E-03_JPRB, 0.38368042E-03_JPRB, 0.38364072E-03_JPRB, 0.38311689E-03_JPRB, 0.38240314E-03_JPRB, 0.38167694E-03_JPRB, &
  & 0.38111841E-03_JPRB, 0.38078817E-03_JPRB, 0.38052252E-03_JPRB, 0.38017497E-03_JPRB, 0.38007016E-03_JPRB, 0.37997572E-03_JPRB, &
  & 0.38012510E-03_JPRB, 0.38047053E-03_JPRB, 0.38111080E-03_JPRB, 0.38191668E-03_JPRB, 0.38236645E-03_JPRB, 0.38272207E-03_JPRB, &
  & 0.38307233E-03_JPRB, 0.38328356E-03_JPRB, 0.38328543E-03_JPRB, 0.38329239E-03_JPRB  /)

RGHG1(:,87, 8) = (/ &
  & 0.38598604E-03_JPRB, 0.38599277E-03_JPRB, 0.38590921E-03_JPRB, 0.38588389E-03_JPRB, 0.38588780E-03_JPRB, 0.38583432E-03_JPRB, &
  & 0.38580234E-03_JPRB, 0.38576303E-03_JPRB, 0.38572522E-03_JPRB, 0.38560118E-03_JPRB, 0.38548145E-03_JPRB, 0.38534966E-03_JPRB, &
  & 0.38515768E-03_JPRB, 0.38497410E-03_JPRB, 0.38480910E-03_JPRB, 0.38472168E-03_JPRB, 0.38459707E-03_JPRB, 0.38448802E-03_JPRB, &
  & 0.38451969E-03_JPRB, 0.38450215E-03_JPRB, 0.38452330E-03_JPRB, 0.38450050E-03_JPRB, 0.38449530E-03_JPRB, 0.38451823E-03_JPRB, &
  & 0.38454640E-03_JPRB, 0.38456359E-03_JPRB, 0.38459899E-03_JPRB, 0.38469255E-03_JPRB, 0.38456164E-03_JPRB, 0.38513904E-03_JPRB, &
  & 0.38537387E-03_JPRB, 0.38514432E-03_JPRB, 0.38507281E-03_JPRB, 0.38512454E-03_JPRB, 0.38532792E-03_JPRB, 0.38505160E-03_JPRB, &
  & 0.38484450E-03_JPRB, 0.38495263E-03_JPRB, 0.38480928E-03_JPRB, 0.38444376E-03_JPRB, 0.38416134E-03_JPRB, 0.38402528E-03_JPRB, &
  & 0.38390968E-03_JPRB, 0.38399730E-03_JPRB, 0.38401420E-03_JPRB, 0.38346534E-03_JPRB, 0.38280209E-03_JPRB, 0.38207292E-03_JPRB, &
  & 0.38152647E-03_JPRB, 0.38119138E-03_JPRB, 0.38092403E-03_JPRB, 0.38057632E-03_JPRB, 0.38043351E-03_JPRB, 0.38027777E-03_JPRB, &
  & 0.38039135E-03_JPRB, 0.38066409E-03_JPRB, 0.38125840E-03_JPRB, 0.38200483E-03_JPRB, 0.38240898E-03_JPRB, 0.38273869E-03_JPRB, &
  & 0.38307320E-03_JPRB, 0.38328931E-03_JPRB, 0.38328779E-03_JPRB, 0.38329330E-03_JPRB  /)

RGHG1(:,88, 8) = (/ &
  & 0.38597541E-03_JPRB, 0.38598763E-03_JPRB, 0.38590345E-03_JPRB, 0.38587722E-03_JPRB, 0.38588315E-03_JPRB, 0.38583213E-03_JPRB, &
  & 0.38580121E-03_JPRB, 0.38576507E-03_JPRB, 0.38572821E-03_JPRB, 0.38560313E-03_JPRB, 0.38548151E-03_JPRB, 0.38534873E-03_JPRB, &
  & 0.38515847E-03_JPRB, 0.38497319E-03_JPRB, 0.38480729E-03_JPRB, 0.38472827E-03_JPRB, 0.38460466E-03_JPRB, 0.38450180E-03_JPRB, &
  & 0.38457537E-03_JPRB, 0.38458041E-03_JPRB, 0.38462347E-03_JPRB, 0.38460565E-03_JPRB, 0.38461366E-03_JPRB, 0.38466784E-03_JPRB, &
  & 0.38472141E-03_JPRB, 0.38475285E-03_JPRB, 0.38480556E-03_JPRB, 0.38496216E-03_JPRB, 0.38483412E-03_JPRB, 0.38563078E-03_JPRB, &
  & 0.38582661E-03_JPRB, 0.38554653E-03_JPRB, 0.38545740E-03_JPRB, 0.38546786E-03_JPRB, 0.38563618E-03_JPRB, 0.38530256E-03_JPRB, &
  & 0.38499896E-03_JPRB, 0.38507780E-03_JPRB, 0.38496519E-03_JPRB, 0.38461482E-03_JPRB, 0.38442840E-03_JPRB, 0.38430588E-03_JPRB, &
  & 0.38420748E-03_JPRB, 0.38445905E-03_JPRB, 0.38455313E-03_JPRB, 0.38395789E-03_JPRB, 0.38337669E-03_JPRB, 0.38260897E-03_JPRB, &
  & 0.38211761E-03_JPRB, 0.38178880E-03_JPRB, 0.38151461E-03_JPRB, 0.38114334E-03_JPRB, 0.38094843E-03_JPRB, 0.38069664E-03_JPRB, &
  & 0.38077486E-03_JPRB, 0.38094404E-03_JPRB, 0.38145211E-03_JPRB, 0.38210373E-03_JPRB, 0.38244284E-03_JPRB, 0.38274288E-03_JPRB, &
  & 0.38306900E-03_JPRB, 0.38329205E-03_JPRB, 0.38328914E-03_JPRB, 0.38329366E-03_JPRB  /)

RGHG1(:,89, 8) = (/ &
  & 0.38596753E-03_JPRB, 0.38598311E-03_JPRB, 0.38589862E-03_JPRB, 0.38587183E-03_JPRB, 0.38587811E-03_JPRB, 0.38583023E-03_JPRB, &
  & 0.38580050E-03_JPRB, 0.38576651E-03_JPRB, 0.38573037E-03_JPRB, 0.38560454E-03_JPRB, 0.38548134E-03_JPRB, 0.38534764E-03_JPRB, &
  & 0.38515972E-03_JPRB, 0.38497255E-03_JPRB, 0.38480510E-03_JPRB, 0.38473687E-03_JPRB, 0.38461390E-03_JPRB, 0.38452473E-03_JPRB, &
  & 0.38465263E-03_JPRB, 0.38468380E-03_JPRB, 0.38476711E-03_JPRB, 0.38474393E-03_JPRB, 0.38477533E-03_JPRB, 0.38487136E-03_JPRB, &
  & 0.38494611E-03_JPRB, 0.38499748E-03_JPRB, 0.38509824E-03_JPRB, 0.38535062E-03_JPRB, 0.38525591E-03_JPRB, 0.38632398E-03_JPRB, &
  & 0.38650045E-03_JPRB, 0.38614778E-03_JPRB, 0.38611045E-03_JPRB, 0.38605404E-03_JPRB, 0.38608643E-03_JPRB, 0.38564229E-03_JPRB, &
  & 0.38520075E-03_JPRB, 0.38522722E-03_JPRB, 0.38518958E-03_JPRB, 0.38488258E-03_JPRB, 0.38483933E-03_JPRB, 0.38474330E-03_JPRB, &
  & 0.38467956E-03_JPRB, 0.38511574E-03_JPRB, 0.38533232E-03_JPRB, 0.38466651E-03_JPRB, 0.38422224E-03_JPRB, 0.38334746E-03_JPRB, &
  & 0.38299749E-03_JPRB, 0.38269274E-03_JPRB, 0.38243068E-03_JPRB, 0.38194427E-03_JPRB, 0.38168080E-03_JPRB, 0.38128822E-03_JPRB, &
  & 0.38134822E-03_JPRB, 0.38136497E-03_JPRB, 0.38172362E-03_JPRB, 0.38221543E-03_JPRB, 0.38246971E-03_JPRB, 0.38274000E-03_JPRB, &
  & 0.38306432E-03_JPRB, 0.38329182E-03_JPRB, 0.38328937E-03_JPRB, 0.38329366E-03_JPRB  /)

RGHG1(:,90, 8) = (/ &
  & 0.38596407E-03_JPRB, 0.38598050E-03_JPRB, 0.38589548E-03_JPRB, 0.38586881E-03_JPRB, 0.38587508E-03_JPRB, 0.38582900E-03_JPRB, &
  & 0.38580037E-03_JPRB, 0.38576774E-03_JPRB, 0.38573175E-03_JPRB, 0.38560552E-03_JPRB, 0.38548091E-03_JPRB, 0.38534635E-03_JPRB, &
  & 0.38516143E-03_JPRB, 0.38497214E-03_JPRB, 0.38480337E-03_JPRB, 0.38474758E-03_JPRB, 0.38462502E-03_JPRB, 0.38455826E-03_JPRB, &
  & 0.38477017E-03_JPRB, 0.38483464E-03_JPRB, 0.38499176E-03_JPRB, 0.38494189E-03_JPRB, 0.38499652E-03_JPRB, 0.38516173E-03_JPRB, &
  & 0.38523178E-03_JPRB, 0.38530163E-03_JPRB, 0.38553560E-03_JPRB, 0.38594078E-03_JPRB, 0.38585434E-03_JPRB, 0.38728998E-03_JPRB, &
  & 0.38750201E-03_JPRB, 0.38699782E-03_JPRB, 0.38709924E-03_JPRB, 0.38693361E-03_JPRB, 0.38672556E-03_JPRB, 0.38608518E-03_JPRB, &
  & 0.38545689E-03_JPRB, 0.38537928E-03_JPRB, 0.38549102E-03_JPRB, 0.38525404E-03_JPRB, 0.38538702E-03_JPRB, 0.38541426E-03_JPRB, &
  & 0.38534311E-03_JPRB, 0.38600065E-03_JPRB, 0.38638564E-03_JPRB, 0.38567100E-03_JPRB, 0.38548902E-03_JPRB, 0.38448561E-03_JPRB, &
  & 0.38442553E-03_JPRB, 0.38414540E-03_JPRB, 0.38390439E-03_JPRB, 0.38316315E-03_JPRB, 0.38271924E-03_JPRB, 0.38218443E-03_JPRB, &
  & 0.38227284E-03_JPRB, 0.38203268E-03_JPRB, 0.38213264E-03_JPRB, 0.38235374E-03_JPRB, 0.38249287E-03_JPRB, 0.38273265E-03_JPRB, &
  & 0.38305944E-03_JPRB, 0.38329181E-03_JPRB, 0.38328937E-03_JPRB, 0.38329366E-03_JPRB  /)

RGHG1(:,91, 8) = (/ &
  & 0.38596214E-03_JPRB, 0.38597976E-03_JPRB, 0.38589489E-03_JPRB, 0.38586777E-03_JPRB, 0.38587374E-03_JPRB, 0.38582886E-03_JPRB, &
  & 0.38580067E-03_JPRB, 0.38576819E-03_JPRB, 0.38573264E-03_JPRB, 0.38560656E-03_JPRB, 0.38548017E-03_JPRB, 0.38534412E-03_JPRB, &
  & 0.38516380E-03_JPRB, 0.38497199E-03_JPRB, 0.38480010E-03_JPRB, 0.38477252E-03_JPRB, 0.38465011E-03_JPRB, 0.38461350E-03_JPRB, &
  & 0.38499022E-03_JPRB, 0.38514557E-03_JPRB, 0.38537277E-03_JPRB, 0.38528667E-03_JPRB, 0.38535852E-03_JPRB, 0.38559813E-03_JPRB, &
  & 0.38563551E-03_JPRB, 0.38582548E-03_JPRB, 0.38631129E-03_JPRB, 0.38695612E-03_JPRB, 0.38683478E-03_JPRB, 0.38878597E-03_JPRB, &
  & 0.38895449E-03_JPRB, 0.38838734E-03_JPRB, 0.38885047E-03_JPRB, 0.38860718E-03_JPRB, 0.38774343E-03_JPRB, 0.38679939E-03_JPRB, &
  & 0.38575608E-03_JPRB, 0.38557454E-03_JPRB, 0.38589535E-03_JPRB, 0.38567351E-03_JPRB, 0.38598007E-03_JPRB, 0.38626671E-03_JPRB, &
  & 0.38622734E-03_JPRB, 0.38722223E-03_JPRB, 0.38794933E-03_JPRB, 0.38727984E-03_JPRB, 0.38759038E-03_JPRB, 0.38679173E-03_JPRB, &
  & 0.38705877E-03_JPRB, 0.38673290E-03_JPRB, 0.38634637E-03_JPRB, 0.38522754E-03_JPRB, 0.38436654E-03_JPRB, 0.38374055E-03_JPRB, &
  & 0.38390662E-03_JPRB, 0.38328753E-03_JPRB, 0.38281107E-03_JPRB, 0.38248797E-03_JPRB, 0.38251217E-03_JPRB, 0.38272375E-03_JPRB, &
  & 0.38305543E-03_JPRB, 0.38329151E-03_JPRB, 0.38328952E-03_JPRB, 0.38329381E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ---GEMS----

RGHG1(:, 1, 9) = (/ &
  & 0.37366300E-03_JPRB, 0.37366438E-03_JPRB, 0.37366599E-03_JPRB, 0.37366706E-03_JPRB, 0.37366894E-03_JPRB, 0.37367078E-03_JPRB, &
  & 0.37367147E-03_JPRB, 0.37367239E-03_JPRB, 0.37367277E-03_JPRB, 0.37367361E-03_JPRB, 0.37367487E-03_JPRB, 0.37367675E-03_JPRB, &
  & 0.37367886E-03_JPRB, 0.37368108E-03_JPRB, 0.37368533E-03_JPRB, 0.37369188E-03_JPRB, 0.37369881E-03_JPRB, 0.37370414E-03_JPRB, &
  & 0.37370563E-03_JPRB, 0.37370214E-03_JPRB, 0.37369510E-03_JPRB, 0.37368476E-03_JPRB, 0.37367399E-03_JPRB, 0.37366270E-03_JPRB, &
  & 0.37364818E-03_JPRB, 0.37363504E-03_JPRB, 0.37362451E-03_JPRB, 0.37361003E-03_JPRB, 0.37359084E-03_JPRB, 0.37356637E-03_JPRB, &
  & 0.37353243E-03_JPRB, 0.37348483E-03_JPRB, 0.37342424E-03_JPRB, 0.37335434E-03_JPRB, 0.37326981E-03_JPRB, 0.37317310E-03_JPRB, &
  & 0.37307287E-03_JPRB, 0.37297650E-03_JPRB, 0.37288669E-03_JPRB, 0.37280989E-03_JPRB, 0.37275551E-03_JPRB, 0.37271717E-03_JPRB, &
  & 0.37268461E-03_JPRB, 0.37265129E-03_JPRB, 0.37260927E-03_JPRB, 0.37255477E-03_JPRB, 0.37248687E-03_JPRB, 0.37240517E-03_JPRB, &
  & 0.37231099E-03_JPRB, 0.37221562E-03_JPRB, 0.37211401E-03_JPRB, 0.37198968E-03_JPRB, 0.37183912E-03_JPRB, 0.37170228E-03_JPRB, &
  & 0.37160790E-03_JPRB, 0.37152724E-03_JPRB, 0.37145436E-03_JPRB, 0.37140139E-03_JPRB, 0.37136236E-03_JPRB, 0.37133256E-03_JPRB, &
  & 0.37131153E-03_JPRB, 0.37129437E-03_JPRB, 0.37128396E-03_JPRB, 0.37128005E-03_JPRB  /)

RGHG1(:, 2, 9) = (/ &
  & 0.37366300E-03_JPRB, 0.37366438E-03_JPRB, 0.37366599E-03_JPRB, 0.37366706E-03_JPRB, 0.37366894E-03_JPRB, 0.37367078E-03_JPRB, &
  & 0.37367147E-03_JPRB, 0.37367239E-03_JPRB, 0.37367277E-03_JPRB, 0.37367361E-03_JPRB, 0.37367487E-03_JPRB, 0.37367675E-03_JPRB, &
  & 0.37367886E-03_JPRB, 0.37368108E-03_JPRB, 0.37368533E-03_JPRB, 0.37369188E-03_JPRB, 0.37369881E-03_JPRB, 0.37370414E-03_JPRB, &
  & 0.37370563E-03_JPRB, 0.37370214E-03_JPRB, 0.37369510E-03_JPRB, 0.37368476E-03_JPRB, 0.37367399E-03_JPRB, 0.37366270E-03_JPRB, &
  & 0.37364818E-03_JPRB, 0.37363504E-03_JPRB, 0.37362451E-03_JPRB, 0.37361003E-03_JPRB, 0.37359084E-03_JPRB, 0.37356637E-03_JPRB, &
  & 0.37353243E-03_JPRB, 0.37348483E-03_JPRB, 0.37342424E-03_JPRB, 0.37335434E-03_JPRB, 0.37326981E-03_JPRB, 0.37317310E-03_JPRB, &
  & 0.37307287E-03_JPRB, 0.37297650E-03_JPRB, 0.37288669E-03_JPRB, 0.37280989E-03_JPRB, 0.37275551E-03_JPRB, 0.37271717E-03_JPRB, &
  & 0.37268461E-03_JPRB, 0.37265129E-03_JPRB, 0.37260927E-03_JPRB, 0.37255477E-03_JPRB, 0.37248687E-03_JPRB, 0.37240517E-03_JPRB, &
  & 0.37231099E-03_JPRB, 0.37221562E-03_JPRB, 0.37211401E-03_JPRB, 0.37198968E-03_JPRB, 0.37183912E-03_JPRB, 0.37170228E-03_JPRB, &
  & 0.37160790E-03_JPRB, 0.37152724E-03_JPRB, 0.37145436E-03_JPRB, 0.37140139E-03_JPRB, 0.37136236E-03_JPRB, 0.37133256E-03_JPRB, &
  & 0.37131153E-03_JPRB, 0.37129437E-03_JPRB, 0.37128396E-03_JPRB, 0.37128005E-03_JPRB  /)

RGHG1(:, 3, 9) = (/ &
  & 0.37366300E-03_JPRB, 0.37366438E-03_JPRB, 0.37366599E-03_JPRB, 0.37366706E-03_JPRB, 0.37366894E-03_JPRB, 0.37367078E-03_JPRB, &
  & 0.37367147E-03_JPRB, 0.37367239E-03_JPRB, 0.37367277E-03_JPRB, 0.37367361E-03_JPRB, 0.37367487E-03_JPRB, 0.37367675E-03_JPRB, &
  & 0.37367886E-03_JPRB, 0.37368108E-03_JPRB, 0.37368533E-03_JPRB, 0.37369188E-03_JPRB, 0.37369881E-03_JPRB, 0.37370414E-03_JPRB, &
  & 0.37370563E-03_JPRB, 0.37370214E-03_JPRB, 0.37369510E-03_JPRB, 0.37368476E-03_JPRB, 0.37367399E-03_JPRB, 0.37366270E-03_JPRB, &
  & 0.37364818E-03_JPRB, 0.37363504E-03_JPRB, 0.37362451E-03_JPRB, 0.37361003E-03_JPRB, 0.37359084E-03_JPRB, 0.37356637E-03_JPRB, &
  & 0.37353243E-03_JPRB, 0.37348483E-03_JPRB, 0.37342424E-03_JPRB, 0.37335434E-03_JPRB, 0.37326981E-03_JPRB, 0.37317310E-03_JPRB, &
  & 0.37307287E-03_JPRB, 0.37297650E-03_JPRB, 0.37288669E-03_JPRB, 0.37280989E-03_JPRB, 0.37275551E-03_JPRB, 0.37271717E-03_JPRB, &
  & 0.37268461E-03_JPRB, 0.37265129E-03_JPRB, 0.37260927E-03_JPRB, 0.37255477E-03_JPRB, 0.37248687E-03_JPRB, 0.37240517E-03_JPRB, &
  & 0.37231099E-03_JPRB, 0.37221562E-03_JPRB, 0.37211401E-03_JPRB, 0.37198968E-03_JPRB, 0.37183912E-03_JPRB, 0.37170228E-03_JPRB, &
  & 0.37160790E-03_JPRB, 0.37152724E-03_JPRB, 0.37145436E-03_JPRB, 0.37140139E-03_JPRB, 0.37136236E-03_JPRB, 0.37133256E-03_JPRB, &
  & 0.37131153E-03_JPRB, 0.37129437E-03_JPRB, 0.37128396E-03_JPRB, 0.37128005E-03_JPRB  /)

RGHG1(:, 4, 9) = (/ &
  & 0.37366287E-03_JPRB, 0.37366426E-03_JPRB, 0.37366589E-03_JPRB, 0.37366699E-03_JPRB, 0.37366889E-03_JPRB, 0.37367075E-03_JPRB, &
  & 0.37367145E-03_JPRB, 0.37367238E-03_JPRB, 0.37367278E-03_JPRB, 0.37367363E-03_JPRB, 0.37367490E-03_JPRB, 0.37367679E-03_JPRB, &
  & 0.37367890E-03_JPRB, 0.37368113E-03_JPRB, 0.37368539E-03_JPRB, 0.37369195E-03_JPRB, 0.37369892E-03_JPRB, 0.37370431E-03_JPRB, &
  & 0.37370587E-03_JPRB, 0.37370245E-03_JPRB, 0.37369547E-03_JPRB, 0.37368519E-03_JPRB, 0.37367448E-03_JPRB, 0.37366324E-03_JPRB, &
  & 0.37364881E-03_JPRB, 0.37363575E-03_JPRB, 0.37362528E-03_JPRB, 0.37361088E-03_JPRB, 0.37359178E-03_JPRB, 0.37356739E-03_JPRB, &
  & 0.37353358E-03_JPRB, 0.37348611E-03_JPRB, 0.37342566E-03_JPRB, 0.37335589E-03_JPRB, 0.37327151E-03_JPRB, 0.37317492E-03_JPRB, &
  & 0.37307466E-03_JPRB, 0.37297808E-03_JPRB, 0.37288798E-03_JPRB, 0.37281103E-03_JPRB, 0.37275661E-03_JPRB, 0.37271825E-03_JPRB, &
  & 0.37268566E-03_JPRB, 0.37265230E-03_JPRB, 0.37261031E-03_JPRB, 0.37255592E-03_JPRB, 0.37248817E-03_JPRB, 0.37240666E-03_JPRB, &
  & 0.37231255E-03_JPRB, 0.37221696E-03_JPRB, 0.37211488E-03_JPRB, 0.37199004E-03_JPRB, 0.37183908E-03_JPRB, 0.37170201E-03_JPRB, &
  & 0.37160746E-03_JPRB, 0.37152668E-03_JPRB, 0.37145377E-03_JPRB, 0.37140081E-03_JPRB, 0.37136183E-03_JPRB, 0.37133210E-03_JPRB, &
  & 0.37131110E-03_JPRB, 0.37129397E-03_JPRB, 0.37128356E-03_JPRB, 0.37127965E-03_JPRB  /)

RGHG1(:, 5, 9) = (/ &
  & 0.37365645E-03_JPRB, 0.37365834E-03_JPRB, 0.37366104E-03_JPRB, 0.37366371E-03_JPRB, 0.37366674E-03_JPRB, 0.37366926E-03_JPRB, &
  & 0.37367075E-03_JPRB, 0.37367221E-03_JPRB, 0.37367325E-03_JPRB, 0.37367461E-03_JPRB, 0.37367623E-03_JPRB, 0.37367852E-03_JPRB, &
  & 0.37368096E-03_JPRB, 0.37368363E-03_JPRB, 0.37368801E-03_JPRB, 0.37369532E-03_JPRB, 0.37370409E-03_JPRB, 0.37371234E-03_JPRB, &
  & 0.37371711E-03_JPRB, 0.37371695E-03_JPRB, 0.37371296E-03_JPRB, 0.37370573E-03_JPRB, 0.37369778E-03_JPRB, 0.37368929E-03_JPRB, &
  & 0.37367867E-03_JPRB, 0.37366923E-03_JPRB, 0.37366188E-03_JPRB, 0.37365120E-03_JPRB, 0.37363605E-03_JPRB, 0.37361599E-03_JPRB, &
  & 0.37358779E-03_JPRB, 0.37354685E-03_JPRB, 0.37349311E-03_JPRB, 0.37342957E-03_JPRB, 0.37335239E-03_JPRB, 0.37326138E-03_JPRB, &
  & 0.37315970E-03_JPRB, 0.37305280E-03_JPRB, 0.37294947E-03_JPRB, 0.37286512E-03_JPRB, 0.37280897E-03_JPRB, 0.37276956E-03_JPRB, &
  & 0.37273520E-03_JPRB, 0.37270014E-03_JPRB, 0.37265954E-03_JPRB, 0.37261022E-03_JPRB, 0.37255001E-03_JPRB, 0.37247729E-03_JPRB, &
  & 0.37238683E-03_JPRB, 0.37228039E-03_JPRB, 0.37215646E-03_JPRB, 0.37200707E-03_JPRB, 0.37183703E-03_JPRB, 0.37168957E-03_JPRB, &
  & 0.37158649E-03_JPRB, 0.37150009E-03_JPRB, 0.37142608E-03_JPRB, 0.37137338E-03_JPRB, 0.37133676E-03_JPRB, 0.37131002E-03_JPRB, &
  & 0.37129061E-03_JPRB, 0.37127459E-03_JPRB, 0.37126460E-03_JPRB, 0.37126052E-03_JPRB  /)

RGHG1(:, 6, 9) = (/ &
  & 0.37364682E-03_JPRB, 0.37364947E-03_JPRB, 0.37365376E-03_JPRB, 0.37365878E-03_JPRB, 0.37366351E-03_JPRB, 0.37366704E-03_JPRB, &
  & 0.37366970E-03_JPRB, 0.37367196E-03_JPRB, 0.37367397E-03_JPRB, 0.37367608E-03_JPRB, 0.37367822E-03_JPRB, 0.37368112E-03_JPRB, &
  & 0.37368404E-03_JPRB, 0.37368739E-03_JPRB, 0.37369196E-03_JPRB, 0.37370038E-03_JPRB, 0.37371186E-03_JPRB, 0.37372441E-03_JPRB, &
  & 0.37373397E-03_JPRB, 0.37373870E-03_JPRB, 0.37373920E-03_JPRB, 0.37373654E-03_JPRB, 0.37373272E-03_JPRB, 0.37372837E-03_JPRB, &
  & 0.37372348E-03_JPRB, 0.37371947E-03_JPRB, 0.37371680E-03_JPRB, 0.37371170E-03_JPRB, 0.37370249E-03_JPRB, 0.37368890E-03_JPRB, &
  & 0.37366914E-03_JPRB, 0.37363800E-03_JPRB, 0.37359432E-03_JPRB, 0.37354011E-03_JPRB, 0.37347374E-03_JPRB, 0.37339109E-03_JPRB, &
  & 0.37328730E-03_JPRB, 0.37316492E-03_JPRB, 0.37304172E-03_JPRB, 0.37294628E-03_JPRB, 0.37288752E-03_JPRB, 0.37284654E-03_JPRB, &
  & 0.37280954E-03_JPRB, 0.37277192E-03_JPRB, 0.37273340E-03_JPRB, 0.37269169E-03_JPRB, 0.37264278E-03_JPRB, 0.37258326E-03_JPRB, &
  & 0.37249828E-03_JPRB, 0.37237556E-03_JPRB, 0.37221885E-03_JPRB, 0.37203262E-03_JPRB, 0.37183394E-03_JPRB, 0.37167090E-03_JPRB, &
  & 0.37155503E-03_JPRB, 0.37146019E-03_JPRB, 0.37138452E-03_JPRB, 0.37133222E-03_JPRB, 0.37129915E-03_JPRB, 0.37127690E-03_JPRB, &
  & 0.37125985E-03_JPRB, 0.37124552E-03_JPRB, 0.37123616E-03_JPRB, 0.37123183E-03_JPRB  /)

RGHG1(:, 7, 9) = (/ &
  & 0.37363494E-03_JPRB, 0.37363841E-03_JPRB, 0.37364514E-03_JPRB, 0.37365342E-03_JPRB, 0.37366194E-03_JPRB, 0.37366897E-03_JPRB, &
  & 0.37367529E-03_JPRB, 0.37368068E-03_JPRB, 0.37368494E-03_JPRB, 0.37368878E-03_JPRB, 0.37369359E-03_JPRB, 0.37369878E-03_JPRB, &
  & 0.37370435E-03_JPRB, 0.37371072E-03_JPRB, 0.37371914E-03_JPRB, 0.37373198E-03_JPRB, 0.37374974E-03_JPRB, 0.37377048E-03_JPRB, &
  & 0.37378836E-03_JPRB, 0.37380031E-03_JPRB, 0.37380744E-03_JPRB, 0.37381033E-03_JPRB, 0.37381166E-03_JPRB, 0.37381317E-03_JPRB, &
  & 0.37381576E-03_JPRB, 0.37381906E-03_JPRB, 0.37382559E-03_JPRB, 0.37383331E-03_JPRB, 0.37383927E-03_JPRB, 0.37384047E-03_JPRB, &
  & 0.37383595E-03_JPRB, 0.37382356E-03_JPRB, 0.37379753E-03_JPRB, 0.37375683E-03_JPRB, 0.37370361E-03_JPRB, 0.37363324E-03_JPRB, &
  & 0.37353431E-03_JPRB, 0.37340652E-03_JPRB, 0.37327110E-03_JPRB, 0.37316218E-03_JPRB, 0.37309423E-03_JPRB, 0.37304771E-03_JPRB, &
  & 0.37300822E-03_JPRB, 0.37296673E-03_JPRB, 0.37292482E-03_JPRB, 0.37288844E-03_JPRB, 0.37284955E-03_JPRB, 0.37279606E-03_JPRB, &
  & 0.37270403E-03_JPRB, 0.37255055E-03_JPRB, 0.37233638E-03_JPRB, 0.37207894E-03_JPRB, 0.37183129E-03_JPRB, 0.37164574E-03_JPRB, &
  & 0.37151154E-03_JPRB, 0.37140399E-03_JPRB, 0.37132822E-03_JPRB, 0.37128063E-03_JPRB, 0.37125353E-03_JPRB, 0.37123614E-03_JPRB, &
  & 0.37122317E-03_JPRB, 0.37121271E-03_JPRB, 0.37120584E-03_JPRB, 0.37120243E-03_JPRB  /)

RGHG1(:, 8, 9) = (/ &
  & 0.37363608E-03_JPRB, 0.37364030E-03_JPRB, 0.37364852E-03_JPRB, 0.37365945E-03_JPRB, 0.37367221E-03_JPRB, 0.37368474E-03_JPRB, &
  & 0.37369677E-03_JPRB, 0.37370733E-03_JPRB, 0.37371533E-03_JPRB, 0.37372255E-03_JPRB, 0.37373146E-03_JPRB, 0.37374119E-03_JPRB, &
  & 0.37375295E-03_JPRB, 0.37376737E-03_JPRB, 0.37378501E-03_JPRB, 0.37380740E-03_JPRB, 0.37383603E-03_JPRB, 0.37386819E-03_JPRB, &
  & 0.37389555E-03_JPRB, 0.37391483E-03_JPRB, 0.37392888E-03_JPRB, 0.37393664E-03_JPRB, 0.37394260E-03_JPRB, 0.37395001E-03_JPRB, &
  & 0.37395936E-03_JPRB, 0.37397089E-03_JPRB, 0.37398872E-03_JPRB, 0.37401619E-03_JPRB, 0.37404870E-03_JPRB, 0.37407570E-03_JPRB, &
  & 0.37409545E-03_JPRB, 0.37410876E-03_JPRB, 0.37410898E-03_JPRB, 0.37409205E-03_JPRB, 0.37406090E-03_JPRB, 0.37401205E-03_JPRB, &
  & 0.37393407E-03_JPRB, 0.37382376E-03_JPRB, 0.37369433E-03_JPRB, 0.37357337E-03_JPRB, 0.37348266E-03_JPRB, 0.37341530E-03_JPRB, &
  & 0.37335912E-03_JPRB, 0.37329744E-03_JPRB, 0.37323525E-03_JPRB, 0.37318507E-03_JPRB, 0.37313841E-03_JPRB, 0.37307760E-03_JPRB, &
  & 0.37296736E-03_JPRB, 0.37277837E-03_JPRB, 0.37249868E-03_JPRB, 0.37215956E-03_JPRB, 0.37185640E-03_JPRB, 0.37163766E-03_JPRB, &
  & 0.37147679E-03_JPRB, 0.37135491E-03_JPRB, 0.37127771E-03_JPRB, 0.37123570E-03_JPRB, 0.37121537E-03_JPRB, 0.37120387E-03_JPRB, &
  & 0.37119622E-03_JPRB, 0.37119103E-03_JPRB, 0.37118749E-03_JPRB, 0.37118552E-03_JPRB  /)

RGHG1(:, 9, 9) = (/ &
  & 0.37366721E-03_JPRB, 0.37367067E-03_JPRB, 0.37367710E-03_JPRB, 0.37368766E-03_JPRB, 0.37370234E-03_JPRB, 0.37371962E-03_JPRB, &
  & 0.37373761E-03_JPRB, 0.37375424E-03_JPRB, 0.37376721E-03_JPRB, 0.37377951E-03_JPRB, 0.37379375E-03_JPRB, 0.37381040E-03_JPRB, &
  & 0.37383155E-03_JPRB, 0.37385812E-03_JPRB, 0.37388874E-03_JPRB, 0.37392495E-03_JPRB, 0.37396691E-03_JPRB, 0.37400879E-03_JPRB, &
  & 0.37404258E-03_JPRB, 0.37406777E-03_JPRB, 0.37408848E-03_JPRB, 0.37410069E-03_JPRB, 0.37410991E-03_JPRB, 0.37412251E-03_JPRB, &
  & 0.37413894E-03_JPRB, 0.37416219E-03_JPRB, 0.37419319E-03_JPRB, 0.37424450E-03_JPRB, 0.37431400E-03_JPRB, 0.37437782E-03_JPRB, &
  & 0.37443087E-03_JPRB, 0.37447567E-03_JPRB, 0.37450817E-03_JPRB, 0.37452364E-03_JPRB, 0.37452463E-03_JPRB, 0.37450992E-03_JPRB, &
  & 0.37447217E-03_JPRB, 0.37440550E-03_JPRB, 0.37430531E-03_JPRB, 0.37418159E-03_JPRB, 0.37405570E-03_JPRB, 0.37394267E-03_JPRB, &
  & 0.37384024E-03_JPRB, 0.37373051E-03_JPRB, 0.37362268E-03_JPRB, 0.37352764E-03_JPRB, 0.37344296E-03_JPRB, 0.37335449E-03_JPRB, &
  & 0.37321411E-03_JPRB, 0.37299638E-03_JPRB, 0.37266223E-03_JPRB, 0.37225919E-03_JPRB, 0.37191357E-03_JPRB, 0.37165556E-03_JPRB, &
  & 0.37146275E-03_JPRB, 0.37132567E-03_JPRB, 0.37124382E-03_JPRB, 0.37120530E-03_JPRB, 0.37119178E-03_JPRB, 0.37118826E-03_JPRB, &
  & 0.37118828E-03_JPRB, 0.37118995E-03_JPRB, 0.37119036E-03_JPRB, 0.37119019E-03_JPRB  /)

RGHG1(:,10, 9) = (/ &
  & 0.37371710E-03_JPRB, 0.37371749E-03_JPRB, 0.37371936E-03_JPRB, 0.37372530E-03_JPRB, 0.37373704E-03_JPRB, 0.37375450E-03_JPRB, &
  & 0.37377574E-03_JPRB, 0.37379765E-03_JPRB, 0.37381615E-03_JPRB, 0.37383466E-03_JPRB, 0.37385481E-03_JPRB, 0.37387890E-03_JPRB, &
  & 0.37390943E-03_JPRB, 0.37394568E-03_JPRB, 0.37398613E-03_JPRB, 0.37403274E-03_JPRB, 0.37408216E-03_JPRB, 0.37412460E-03_JPRB, &
  & 0.37415767E-03_JPRB, 0.37418578E-03_JPRB, 0.37421025E-03_JPRB, 0.37422595E-03_JPRB, 0.37423752E-03_JPRB, 0.37425484E-03_JPRB, &
  & 0.37428283E-03_JPRB, 0.37432537E-03_JPRB, 0.37437396E-03_JPRB, 0.37444663E-03_JPRB, 0.37455087E-03_JPRB, 0.37465341E-03_JPRB, &
  & 0.37474449E-03_JPRB, 0.37482720E-03_JPRB, 0.37489211E-03_JPRB, 0.37493811E-03_JPRB, 0.37497290E-03_JPRB, 0.37499678E-03_JPRB, &
  & 0.37500191E-03_JPRB, 0.37498092E-03_JPRB, 0.37491706E-03_JPRB, 0.37480350E-03_JPRB, 0.37464823E-03_JPRB, 0.37447546E-03_JPRB, &
  & 0.37429736E-03_JPRB, 0.37411437E-03_JPRB, 0.37394167E-03_JPRB, 0.37377923E-03_JPRB, 0.37362874E-03_JPRB, 0.37349024E-03_JPRB, &
  & 0.37331309E-03_JPRB, 0.37308437E-03_JPRB, 0.37272755E-03_JPRB, 0.37230817E-03_JPRB, 0.37195317E-03_JPRB, 0.37166682E-03_JPRB, &
  & 0.37144718E-03_JPRB, 0.37129417E-03_JPRB, 0.37120317E-03_JPRB, 0.37116173E-03_JPRB, 0.37115412E-03_JPRB, 0.37116267E-03_JPRB, &
  & 0.37117743E-03_JPRB, 0.37119191E-03_JPRB, 0.37119902E-03_JPRB, 0.37120068E-03_JPRB  /)

RGHG1(:,11, 9) = (/ &
  & 0.37370236E-03_JPRB, 0.37370109E-03_JPRB, 0.37370222E-03_JPRB, 0.37370523E-03_JPRB, 0.37371519E-03_JPRB, 0.37373321E-03_JPRB, &
  & 0.37375758E-03_JPRB, 0.37378619E-03_JPRB, 0.37381434E-03_JPRB, 0.37384136E-03_JPRB, 0.37386910E-03_JPRB, 0.37390175E-03_JPRB, &
  & 0.37394025E-03_JPRB, 0.37398078E-03_JPRB, 0.37402511E-03_JPRB, 0.37407253E-03_JPRB, 0.37411735E-03_JPRB, 0.37415275E-03_JPRB, &
  & 0.37418054E-03_JPRB, 0.37420364E-03_JPRB, 0.37422266E-03_JPRB, 0.37423713E-03_JPRB, 0.37425040E-03_JPRB, 0.37427239E-03_JPRB, &
  & 0.37431621E-03_JPRB, 0.37438375E-03_JPRB, 0.37445536E-03_JPRB, 0.37454003E-03_JPRB, 0.37465608E-03_JPRB, 0.37478431E-03_JPRB, &
  & 0.37491579E-03_JPRB, 0.37504644E-03_JPRB, 0.37514630E-03_JPRB, 0.37521617E-03_JPRB, 0.37527292E-03_JPRB, 0.37531934E-03_JPRB, &
  & 0.37534708E-03_JPRB, 0.37534920E-03_JPRB, 0.37530886E-03_JPRB, 0.37520932E-03_JPRB, 0.37504888E-03_JPRB, 0.37483847E-03_JPRB, &
  & 0.37459075E-03_JPRB, 0.37433062E-03_JPRB, 0.37409179E-03_JPRB, 0.37385687E-03_JPRB, 0.37362215E-03_JPRB, 0.37341310E-03_JPRB, &
  & 0.37319863E-03_JPRB, 0.37297309E-03_JPRB, 0.37262841E-03_JPRB, 0.37223977E-03_JPRB, 0.37190515E-03_JPRB, 0.37161255E-03_JPRB, &
  & 0.37137984E-03_JPRB, 0.37121382E-03_JPRB, 0.37110935E-03_JPRB, 0.37105495E-03_JPRB, 0.37104646E-03_JPRB, 0.37106726E-03_JPRB, &
  & 0.37110437E-03_JPRB, 0.37114360E-03_JPRB, 0.37116634E-03_JPRB, 0.37117285E-03_JPRB  /)

RGHG1(:,12, 9) = (/ &
  & 0.37351265E-03_JPRB, 0.37351716E-03_JPRB, 0.37352917E-03_JPRB, 0.37354528E-03_JPRB, 0.37356982E-03_JPRB, 0.37360137E-03_JPRB, &
  & 0.37363930E-03_JPRB, 0.37368207E-03_JPRB, 0.37372924E-03_JPRB, 0.37377312E-03_JPRB, 0.37381854E-03_JPRB, 0.37386941E-03_JPRB, &
  & 0.37392038E-03_JPRB, 0.37396728E-03_JPRB, 0.37401685E-03_JPRB, 0.37406304E-03_JPRB, 0.37409723E-03_JPRB, 0.37412241E-03_JPRB, &
  & 0.37414118E-03_JPRB, 0.37415297E-03_JPRB, 0.37416235E-03_JPRB, 0.37417529E-03_JPRB, 0.37419345E-03_JPRB, 0.37422799E-03_JPRB, &
  & 0.37429666E-03_JPRB, 0.37440224E-03_JPRB, 0.37450166E-03_JPRB, 0.37458344E-03_JPRB, 0.37468374E-03_JPRB, 0.37481524E-03_JPRB, &
  & 0.37497904E-03_JPRB, 0.37515317E-03_JPRB, 0.37529258E-03_JPRB, 0.37538338E-03_JPRB, 0.37544978E-03_JPRB, 0.37550625E-03_JPRB, &
  & 0.37554410E-03_JPRB, 0.37555718E-03_JPRB, 0.37553146E-03_JPRB, 0.37544890E-03_JPRB, 0.37530158E-03_JPRB, 0.37508550E-03_JPRB, &
  & 0.37480123E-03_JPRB, 0.37447775E-03_JPRB, 0.37417382E-03_JPRB, 0.37385699E-03_JPRB, 0.37352305E-03_JPRB, 0.37323668E-03_JPRB, &
  & 0.37299458E-03_JPRB, 0.37277234E-03_JPRB, 0.37246406E-03_JPRB, 0.37212780E-03_JPRB, 0.37182321E-03_JPRB, 0.37153420E-03_JPRB, &
  & 0.37129830E-03_JPRB, 0.37112222E-03_JPRB, 0.37100430E-03_JPRB, 0.37093088E-03_JPRB, 0.37090747E-03_JPRB, 0.37092591E-03_JPRB, &
  & 0.37097208E-03_JPRB, 0.37103616E-03_JPRB, 0.37108278E-03_JPRB, 0.37110004E-03_JPRB  /)

RGHG1(:,13, 9) = (/ &
  & 0.37319732E-03_JPRB, 0.37321487E-03_JPRB, 0.37324513E-03_JPRB, 0.37328566E-03_JPRB, 0.37333625E-03_JPRB, 0.37339090E-03_JPRB, &
  & 0.37345102E-03_JPRB, 0.37351433E-03_JPRB, 0.37358381E-03_JPRB, 0.37365600E-03_JPRB, 0.37373612E-03_JPRB, 0.37382010E-03_JPRB, &
  & 0.37389856E-03_JPRB, 0.37396922E-03_JPRB, 0.37404168E-03_JPRB, 0.37409320E-03_JPRB, 0.37412322E-03_JPRB, 0.37413995E-03_JPRB, &
  & 0.37414931E-03_JPRB, 0.37415557E-03_JPRB, 0.37416126E-03_JPRB, 0.37417692E-03_JPRB, 0.37421164E-03_JPRB, 0.37427892E-03_JPRB, &
  & 0.37439657E-03_JPRB, 0.37457056E-03_JPRB, 0.37473123E-03_JPRB, 0.37483413E-03_JPRB, 0.37493276E-03_JPRB, 0.37506304E-03_JPRB, &
  & 0.37522756E-03_JPRB, 0.37539940E-03_JPRB, 0.37554434E-03_JPRB, 0.37564075E-03_JPRB, 0.37570860E-03_JPRB, 0.37576915E-03_JPRB, &
  & 0.37581279E-03_JPRB, 0.37583176E-03_JPRB, 0.37581232E-03_JPRB, 0.37573909E-03_JPRB, 0.37559966E-03_JPRB, 0.37539004E-03_JPRB, &
  & 0.37509780E-03_JPRB, 0.37473972E-03_JPRB, 0.37437576E-03_JPRB, 0.37397980E-03_JPRB, 0.37356266E-03_JPRB, 0.37322311E-03_JPRB, &
  & 0.37297013E-03_JPRB, 0.37273924E-03_JPRB, 0.37247240E-03_JPRB, 0.37219049E-03_JPRB, 0.37191519E-03_JPRB, 0.37163253E-03_JPRB, &
  & 0.37139162E-03_JPRB, 0.37120217E-03_JPRB, 0.37106969E-03_JPRB, 0.37097813E-03_JPRB, 0.37093512E-03_JPRB, 0.37093885E-03_JPRB, &
  & 0.37097995E-03_JPRB, 0.37105938E-03_JPRB, 0.37112866E-03_JPRB, 0.37115845E-03_JPRB  /)

RGHG1(:,14, 9) = (/ &
  & 0.37298212E-03_JPRB, 0.37300310E-03_JPRB, 0.37303716E-03_JPRB, 0.37308419E-03_JPRB, 0.37314327E-03_JPRB, 0.37320707E-03_JPRB, &
  & 0.37327709E-03_JPRB, 0.37335355E-03_JPRB, 0.37343933E-03_JPRB, 0.37354029E-03_JPRB, 0.37366394E-03_JPRB, 0.37379687E-03_JPRB, &
  & 0.37392043E-03_JPRB, 0.37404392E-03_JPRB, 0.37416121E-03_JPRB, 0.37423285E-03_JPRB, 0.37427163E-03_JPRB, 0.37428808E-03_JPRB, &
  & 0.37429219E-03_JPRB, 0.37429807E-03_JPRB, 0.37430985E-03_JPRB, 0.37433236E-03_JPRB, 0.37438394E-03_JPRB, 0.37449217E-03_JPRB, &
  & 0.37469008E-03_JPRB, 0.37498531E-03_JPRB, 0.37526666E-03_JPRB, 0.37547315E-03_JPRB, 0.37563097E-03_JPRB, 0.37578828E-03_JPRB, &
  & 0.37593295E-03_JPRB, 0.37604601E-03_JPRB, 0.37613455E-03_JPRB, 0.37619779E-03_JPRB, 0.37624142E-03_JPRB, 0.37627119E-03_JPRB, &
  & 0.37628472E-03_JPRB, 0.37627492E-03_JPRB, 0.37622331E-03_JPRB, 0.37612048E-03_JPRB, 0.37596159E-03_JPRB, 0.37573631E-03_JPRB, &
  & 0.37544005E-03_JPRB, 0.37508067E-03_JPRB, 0.37468470E-03_JPRB, 0.37425156E-03_JPRB, 0.37381754E-03_JPRB, 0.37348321E-03_JPRB, &
  & 0.37322671E-03_JPRB, 0.37300045E-03_JPRB, 0.37276875E-03_JPRB, 0.37253842E-03_JPRB, 0.37231011E-03_JPRB, 0.37205773E-03_JPRB, &
  & 0.37183231E-03_JPRB, 0.37164351E-03_JPRB, 0.37150261E-03_JPRB, 0.37140418E-03_JPRB, 0.37135883E-03_JPRB, 0.37136098E-03_JPRB, &
  & 0.37140185E-03_JPRB, 0.37148906E-03_JPRB, 0.37156811E-03_JPRB, 0.37160277E-03_JPRB  /)

RGHG1(:,15, 9) = (/ &
  & 0.37295575E-03_JPRB, 0.37296993E-03_JPRB, 0.37298742E-03_JPRB, 0.37301504E-03_JPRB, 0.37305689E-03_JPRB, 0.37310578E-03_JPRB, &
  & 0.37316388E-03_JPRB, 0.37323531E-03_JPRB, 0.37332283E-03_JPRB, 0.37344432E-03_JPRB, 0.37360758E-03_JPRB, 0.37379501E-03_JPRB, &
  & 0.37398082E-03_JPRB, 0.37417637E-03_JPRB, 0.37435143E-03_JPRB, 0.37446110E-03_JPRB, 0.37451797E-03_JPRB, 0.37454663E-03_JPRB, &
  & 0.37455495E-03_JPRB, 0.37456004E-03_JPRB, 0.37457894E-03_JPRB, 0.37460236E-03_JPRB, 0.37465885E-03_JPRB, 0.37479034E-03_JPRB, &
  & 0.37506160E-03_JPRB, 0.37548739E-03_JPRB, 0.37591312E-03_JPRB, 0.37625564E-03_JPRB, 0.37652358E-03_JPRB, 0.37676767E-03_JPRB, &
  & 0.37695272E-03_JPRB, 0.37703630E-03_JPRB, 0.37705967E-03_JPRB, 0.37705448E-03_JPRB, 0.37702483E-03_JPRB, 0.37696618E-03_JPRB, &
  & 0.37687988E-03_JPRB, 0.37677284E-03_JPRB, 0.37663542E-03_JPRB, 0.37646446E-03_JPRB, 0.37625668E-03_JPRB, 0.37597645E-03_JPRB, &
  & 0.37565012E-03_JPRB, 0.37529737E-03_JPRB, 0.37490032E-03_JPRB, 0.37447796E-03_JPRB, 0.37408346E-03_JPRB, 0.37380251E-03_JPRB, &
  & 0.37357647E-03_JPRB, 0.37338343E-03_JPRB, 0.37319226E-03_JPRB, 0.37300587E-03_JPRB, 0.37283782E-03_JPRB, 0.37265567E-03_JPRB, &
  & 0.37248993E-03_JPRB, 0.37234564E-03_JPRB, 0.37224042E-03_JPRB, 0.37217030E-03_JPRB, 0.37214703E-03_JPRB, 0.37216664E-03_JPRB, &
  & 0.37220988E-03_JPRB, 0.37229216E-03_JPRB, 0.37237572E-03_JPRB, 0.37241363E-03_JPRB  /)

RGHG1(:,16, 9) = (/ &
  & 0.37298542E-03_JPRB, 0.37298834E-03_JPRB, 0.37298610E-03_JPRB, 0.37298958E-03_JPRB, 0.37300916E-03_JPRB, 0.37304058E-03_JPRB, &
  & 0.37307982E-03_JPRB, 0.37313202E-03_JPRB, 0.37320643E-03_JPRB, 0.37334003E-03_JPRB, 0.37353993E-03_JPRB, 0.37377767E-03_JPRB, &
  & 0.37402985E-03_JPRB, 0.37428783E-03_JPRB, 0.37452234E-03_JPRB, 0.37467722E-03_JPRB, 0.37476079E-03_JPRB, 0.37480629E-03_JPRB, &
  & 0.37482994E-03_JPRB, 0.37483527E-03_JPRB, 0.37484645E-03_JPRB, 0.37486342E-03_JPRB, 0.37491927E-03_JPRB, 0.37505763E-03_JPRB, &
  & 0.37535921E-03_JPRB, 0.37583035E-03_JPRB, 0.37634183E-03_JPRB, 0.37678284E-03_JPRB, 0.37717353E-03_JPRB, 0.37757219E-03_JPRB, &
  & 0.37788760E-03_JPRB, 0.37802153E-03_JPRB, 0.37801883E-03_JPRB, 0.37794426E-03_JPRB, 0.37781727E-03_JPRB, 0.37763069E-03_JPRB, &
  & 0.37739616E-03_JPRB, 0.37715811E-03_JPRB, 0.37692345E-03_JPRB, 0.37668382E-03_JPRB, 0.37641152E-03_JPRB, 0.37605712E-03_JPRB, &
  & 0.37568200E-03_JPRB, 0.37532165E-03_JPRB, 0.37492614E-03_JPRB, 0.37450715E-03_JPRB, 0.37413667E-03_JPRB, 0.37390781E-03_JPRB, &
  & 0.37373191E-03_JPRB, 0.37357279E-03_JPRB, 0.37341991E-03_JPRB, 0.37328078E-03_JPRB, 0.37316188E-03_JPRB, 0.37304983E-03_JPRB, &
  & 0.37296181E-03_JPRB, 0.37289371E-03_JPRB, 0.37285252E-03_JPRB, 0.37283115E-03_JPRB, 0.37284028E-03_JPRB, 0.37288044E-03_JPRB, &
  & 0.37293604E-03_JPRB, 0.37300504E-03_JPRB, 0.37308084E-03_JPRB, 0.37313432E-03_JPRB  /)

RGHG1(:,17, 9) = (/ &
  & 0.37286380E-03_JPRB, 0.37286310E-03_JPRB, 0.37286452E-03_JPRB, 0.37286740E-03_JPRB, 0.37288207E-03_JPRB, 0.37291264E-03_JPRB, &
  & 0.37294925E-03_JPRB, 0.37298997E-03_JPRB, 0.37305283E-03_JPRB, 0.37319354E-03_JPRB, 0.37342858E-03_JPRB, 0.37371601E-03_JPRB, &
  & 0.37402474E-03_JPRB, 0.37432469E-03_JPRB, 0.37460509E-03_JPRB, 0.37479667E-03_JPRB, 0.37490402E-03_JPRB, 0.37496639E-03_JPRB, &
  & 0.37499905E-03_JPRB, 0.37500576E-03_JPRB, 0.37500822E-03_JPRB, 0.37502515E-03_JPRB, 0.37507688E-03_JPRB, 0.37522134E-03_JPRB, &
  & 0.37550909E-03_JPRB, 0.37594550E-03_JPRB, 0.37645255E-03_JPRB, 0.37693831E-03_JPRB, 0.37742463E-03_JPRB, 0.37794907E-03_JPRB, &
  & 0.37841474E-03_JPRB, 0.37867654E-03_JPRB, 0.37871320E-03_JPRB, 0.37860437E-03_JPRB, 0.37840540E-03_JPRB, 0.37812159E-03_JPRB, &
  & 0.37776564E-03_JPRB, 0.37741781E-03_JPRB, 0.37710522E-03_JPRB, 0.37681308E-03_JPRB, 0.37647053E-03_JPRB, 0.37604672E-03_JPRB, &
  & 0.37562483E-03_JPRB, 0.37524850E-03_JPRB, 0.37483220E-03_JPRB, 0.37437117E-03_JPRB, 0.37398732E-03_JPRB, 0.37376877E-03_JPRB, &
  & 0.37363085E-03_JPRB, 0.37349559E-03_JPRB, 0.37337230E-03_JPRB, 0.37326424E-03_JPRB, 0.37317627E-03_JPRB, 0.37310630E-03_JPRB, &
  & 0.37306965E-03_JPRB, 0.37305143E-03_JPRB, 0.37304428E-03_JPRB, 0.37305068E-03_JPRB, 0.37307663E-03_JPRB, 0.37312451E-03_JPRB, &
  & 0.37318619E-03_JPRB, 0.37324018E-03_JPRB, 0.37328264E-03_JPRB, 0.37331916E-03_JPRB  /)

RGHG1(:,18, 9) = (/ &
  & 0.37256254E-03_JPRB, 0.37257805E-03_JPRB, 0.37260275E-03_JPRB, 0.37262753E-03_JPRB, 0.37266123E-03_JPRB, 0.37271204E-03_JPRB, &
  & 0.37276700E-03_JPRB, 0.37281568E-03_JPRB, 0.37288188E-03_JPRB, 0.37302941E-03_JPRB, 0.37329154E-03_JPRB, 0.37362687E-03_JPRB, &
  & 0.37397675E-03_JPRB, 0.37430481E-03_JPRB, 0.37461613E-03_JPRB, 0.37483156E-03_JPRB, 0.37495452E-03_JPRB, 0.37502438E-03_JPRB, &
  & 0.37505809E-03_JPRB, 0.37506558E-03_JPRB, 0.37506624E-03_JPRB, 0.37508552E-03_JPRB, 0.37513430E-03_JPRB, 0.37528276E-03_JPRB, &
  & 0.37554195E-03_JPRB, 0.37591869E-03_JPRB, 0.37637641E-03_JPRB, 0.37686202E-03_JPRB, 0.37739802E-03_JPRB, 0.37800115E-03_JPRB, &
  & 0.37860414E-03_JPRB, 0.37902493E-03_JPRB, 0.37915373E-03_JPRB, 0.37905290E-03_JPRB, 0.37883203E-03_JPRB, 0.37852024E-03_JPRB, &
  & 0.37810925E-03_JPRB, 0.37768460E-03_JPRB, 0.37730681E-03_JPRB, 0.37695750E-03_JPRB, 0.37655666E-03_JPRB, 0.37609290E-03_JPRB, &
  & 0.37564106E-03_JPRB, 0.37524021E-03_JPRB, 0.37477022E-03_JPRB, 0.37422573E-03_JPRB, 0.37378742E-03_JPRB, 0.37353607E-03_JPRB, &
  & 0.37340494E-03_JPRB, 0.37328629E-03_JPRB, 0.37317774E-03_JPRB, 0.37308570E-03_JPRB, 0.37301874E-03_JPRB, 0.37297669E-03_JPRB, &
  & 0.37296482E-03_JPRB, 0.37296640E-03_JPRB, 0.37297357E-03_JPRB, 0.37299121E-03_JPRB, 0.37302280E-03_JPRB, 0.37306961E-03_JPRB, &
  & 0.37312528E-03_JPRB, 0.37316555E-03_JPRB, 0.37317527E-03_JPRB, 0.37318959E-03_JPRB  /)

RGHG1(:,19, 9) = (/ &
  & 0.37233633E-03_JPRB, 0.37235168E-03_JPRB, 0.37238947E-03_JPRB, 0.37243401E-03_JPRB, 0.37248318E-03_JPRB, 0.37255081E-03_JPRB, &
  & 0.37262460E-03_JPRB, 0.37268788E-03_JPRB, 0.37276233E-03_JPRB, 0.37291318E-03_JPRB, 0.37319093E-03_JPRB, 0.37356200E-03_JPRB, &
  & 0.37394443E-03_JPRB, 0.37429405E-03_JPRB, 0.37462442E-03_JPRB, 0.37485098E-03_JPRB, 0.37498346E-03_JPRB, 0.37505475E-03_JPRB, &
  & 0.37508721E-03_JPRB, 0.37509287E-03_JPRB, 0.37509237E-03_JPRB, 0.37511343E-03_JPRB, 0.37516278E-03_JPRB, 0.37531455E-03_JPRB, &
  & 0.37554885E-03_JPRB, 0.37587393E-03_JPRB, 0.37629367E-03_JPRB, 0.37678535E-03_JPRB, 0.37734026E-03_JPRB, 0.37798919E-03_JPRB, &
  & 0.37871185E-03_JPRB, 0.37927851E-03_JPRB, 0.37950610E-03_JPRB, 0.37943593E-03_JPRB, 0.37922741E-03_JPRB, 0.37894530E-03_JPRB, &
  & 0.37854722E-03_JPRB, 0.37808778E-03_JPRB, 0.37765230E-03_JPRB, 0.37723655E-03_JPRB, 0.37679566E-03_JPRB, 0.37632523E-03_JPRB, &
  & 0.37585027E-03_JPRB, 0.37541656E-03_JPRB, 0.37486622E-03_JPRB, 0.37421922E-03_JPRB, 0.37371256E-03_JPRB, 0.37340803E-03_JPRB, &
  & 0.37326526E-03_JPRB, 0.37315003E-03_JPRB, 0.37303784E-03_JPRB, 0.37294326E-03_JPRB, 0.37288246E-03_JPRB, 0.37285476E-03_JPRB, &
  & 0.37284568E-03_JPRB, 0.37285168E-03_JPRB, 0.37286609E-03_JPRB, 0.37288830E-03_JPRB, 0.37292075E-03_JPRB, 0.37295907E-03_JPRB, &
  & 0.37300491E-03_JPRB, 0.37303551E-03_JPRB, 0.37303433E-03_JPRB, 0.37304450E-03_JPRB  /)

RGHG1(:,20, 9) = (/ &
  & 0.37229893E-03_JPRB, 0.37230821E-03_JPRB, 0.37234383E-03_JPRB, 0.37239373E-03_JPRB, 0.37244425E-03_JPRB, 0.37251118E-03_JPRB, &
  & 0.37258675E-03_JPRB, 0.37265462E-03_JPRB, 0.37272975E-03_JPRB, 0.37287681E-03_JPRB, 0.37316015E-03_JPRB, 0.37355781E-03_JPRB, &
  & 0.37397134E-03_JPRB, 0.37434232E-03_JPRB, 0.37468785E-03_JPRB, 0.37492589E-03_JPRB, 0.37506376E-03_JPRB, 0.37513435E-03_JPRB, &
  & 0.37516371E-03_JPRB, 0.37516679E-03_JPRB, 0.37516604E-03_JPRB, 0.37519041E-03_JPRB, 0.37524729E-03_JPRB, 0.37539273E-03_JPRB, &
  & 0.37559744E-03_JPRB, 0.37588558E-03_JPRB, 0.37628517E-03_JPRB, 0.37679992E-03_JPRB, 0.37737877E-03_JPRB, 0.37807790E-03_JPRB, &
  & 0.37890348E-03_JPRB, 0.37957307E-03_JPRB, 0.37987121E-03_JPRB, 0.37984210E-03_JPRB, 0.37966862E-03_JPRB, 0.37943776E-03_JPRB, &
  & 0.37910029E-03_JPRB, 0.37865525E-03_JPRB, 0.37818713E-03_JPRB, 0.37771791E-03_JPRB, 0.37726045E-03_JPRB, 0.37679800E-03_JPRB, &
  & 0.37630583E-03_JPRB, 0.37583811E-03_JPRB, 0.37519620E-03_JPRB, 0.37445221E-03_JPRB, 0.37388078E-03_JPRB, 0.37352457E-03_JPRB, &
  & 0.37336335E-03_JPRB, 0.37323739E-03_JPRB, 0.37310598E-03_JPRB, 0.37299832E-03_JPRB, 0.37292835E-03_JPRB, 0.37290093E-03_JPRB, &
  & 0.37288671E-03_JPRB, 0.37288816E-03_JPRB, 0.37290242E-03_JPRB, 0.37292171E-03_JPRB, 0.37294817E-03_JPRB, 0.37297376E-03_JPRB, &
  & 0.37300640E-03_JPRB, 0.37303184E-03_JPRB, 0.37303448E-03_JPRB, 0.37304179E-03_JPRB  /)

RGHG1(:,21, 9) = (/ &
  & 0.37248375E-03_JPRB, 0.37248839E-03_JPRB, 0.37250914E-03_JPRB, 0.37254738E-03_JPRB, 0.37258402E-03_JPRB, 0.37263086E-03_JPRB, &
  & 0.37268589E-03_JPRB, 0.37273935E-03_JPRB, 0.37280077E-03_JPRB, 0.37293350E-03_JPRB, 0.37321244E-03_JPRB, 0.37362929E-03_JPRB, &
  & 0.37407505E-03_JPRB, 0.37446964E-03_JPRB, 0.37483233E-03_JPRB, 0.37508698E-03_JPRB, 0.37522899E-03_JPRB, 0.37529737E-03_JPRB, &
  & 0.37532236E-03_JPRB, 0.37532506E-03_JPRB, 0.37532824E-03_JPRB, 0.37536028E-03_JPRB, 0.37542811E-03_JPRB, 0.37555836E-03_JPRB, &
  & 0.37573152E-03_JPRB, 0.37599350E-03_JPRB, 0.37638210E-03_JPRB, 0.37692826E-03_JPRB, 0.37755383E-03_JPRB, 0.37832597E-03_JPRB, &
  & 0.37923465E-03_JPRB, 0.37994994E-03_JPRB, 0.38027931E-03_JPRB, 0.38029248E-03_JPRB, 0.38016761E-03_JPRB, 0.37999191E-03_JPRB, &
  & 0.37973610E-03_JPRB, 0.37934844E-03_JPRB, 0.37888390E-03_JPRB, 0.37839128E-03_JPRB, 0.37793956E-03_JPRB, 0.37748903E-03_JPRB, &
  & 0.37698588E-03_JPRB, 0.37648397E-03_JPRB, 0.37576499E-03_JPRB, 0.37495311E-03_JPRB, 0.37433997E-03_JPRB, 0.37394939E-03_JPRB, &
  & 0.37376539E-03_JPRB, 0.37362150E-03_JPRB, 0.37346313E-03_JPRB, 0.37333342E-03_JPRB, 0.37324008E-03_JPRB, 0.37319874E-03_JPRB, &
  & 0.37317655E-03_JPRB, 0.37316775E-03_JPRB, 0.37317357E-03_JPRB, 0.37318219E-03_JPRB, 0.37319376E-03_JPRB, 0.37320370E-03_JPRB, &
  & 0.37322387E-03_JPRB, 0.37324693E-03_JPRB, 0.37325687E-03_JPRB, 0.37325922E-03_JPRB  /)

RGHG1(:,22, 9) = (/ &
  & 0.37292569E-03_JPRB, 0.37292877E-03_JPRB, 0.37292495E-03_JPRB, 0.37293350E-03_JPRB, 0.37294134E-03_JPRB, 0.37294994E-03_JPRB, &
  & 0.37296006E-03_JPRB, 0.37297249E-03_JPRB, 0.37299978E-03_JPRB, 0.37310271E-03_JPRB, 0.37336476E-03_JPRB, 0.37379195E-03_JPRB, &
  & 0.37427094E-03_JPRB, 0.37469189E-03_JPRB, 0.37507848E-03_JPRB, 0.37535459E-03_JPRB, 0.37550294E-03_JPRB, 0.37556631E-03_JPRB, &
  & 0.37558674E-03_JPRB, 0.37559500E-03_JPRB, 0.37561130E-03_JPRB, 0.37565902E-03_JPRB, 0.37573363E-03_JPRB, 0.37584609E-03_JPRB, &
  & 0.37599746E-03_JPRB, 0.37623809E-03_JPRB, 0.37661313E-03_JPRB, 0.37718353E-03_JPRB, 0.37788837E-03_JPRB, 0.37876557E-03_JPRB, &
  & 0.37972751E-03_JPRB, 0.38041444E-03_JPRB, 0.38072992E-03_JPRB, 0.38077710E-03_JPRB, 0.38070649E-03_JPRB, 0.38058282E-03_JPRB, &
  & 0.38040105E-03_JPRB, 0.38010501E-03_JPRB, 0.37969172E-03_JPRB, 0.37922368E-03_JPRB, 0.37879819E-03_JPRB, 0.37835878E-03_JPRB, &
  & 0.37785208E-03_JPRB, 0.37731314E-03_JPRB, 0.37656759E-03_JPRB, 0.37574681E-03_JPRB, 0.37514223E-03_JPRB, 0.37475144E-03_JPRB, &
  & 0.37453797E-03_JPRB, 0.37437952E-03_JPRB, 0.37419646E-03_JPRB, 0.37403173E-03_JPRB, 0.37390070E-03_JPRB, 0.37382946E-03_JPRB, &
  & 0.37379582E-03_JPRB, 0.37377290E-03_JPRB, 0.37376082E-03_JPRB, 0.37375109E-03_JPRB, 0.37373642E-03_JPRB, 0.37372779E-03_JPRB, &
  & 0.37374374E-03_JPRB, 0.37376480E-03_JPRB, 0.37377407E-03_JPRB, 0.37377665E-03_JPRB  /)

RGHG1(:,23, 9) = (/ &
  & 0.37344738E-03_JPRB, 0.37343906E-03_JPRB, 0.37341833E-03_JPRB, 0.37340558E-03_JPRB, 0.37339107E-03_JPRB, 0.37337122E-03_JPRB, &
  & 0.37334373E-03_JPRB, 0.37331351E-03_JPRB, 0.37330290E-03_JPRB, 0.37337073E-03_JPRB, 0.37360867E-03_JPRB, 0.37403278E-03_JPRB, &
  & 0.37453038E-03_JPRB, 0.37497446E-03_JPRB, 0.37537586E-03_JPRB, 0.37565836E-03_JPRB, 0.37580540E-03_JPRB, 0.37586379E-03_JPRB, &
  & 0.37588123E-03_JPRB, 0.37589224E-03_JPRB, 0.37592885E-03_JPRB, 0.37599301E-03_JPRB, 0.37607449E-03_JPRB, 0.37618955E-03_JPRB, &
  & 0.37635040E-03_JPRB, 0.37659340E-03_JPRB, 0.37698699E-03_JPRB, 0.37760213E-03_JPRB, 0.37838241E-03_JPRB, 0.37934750E-03_JPRB, &
  & 0.38029270E-03_JPRB, 0.38089765E-03_JPRB, 0.38116283E-03_JPRB, 0.38122021E-03_JPRB, 0.38118543E-03_JPRB, 0.38110008E-03_JPRB, &
  & 0.38096556E-03_JPRB, 0.38074652E-03_JPRB, 0.38040825E-03_JPRB, 0.37999534E-03_JPRB, 0.37959553E-03_JPRB, 0.37916967E-03_JPRB, &
  & 0.37866637E-03_JPRB, 0.37809771E-03_JPRB, 0.37739064E-03_JPRB, 0.37663811E-03_JPRB, 0.37607482E-03_JPRB, 0.37569267E-03_JPRB, &
  & 0.37544573E-03_JPRB, 0.37526909E-03_JPRB, 0.37507821E-03_JPRB, 0.37489822E-03_JPRB, 0.37474552E-03_JPRB, 0.37464349E-03_JPRB, &
  & 0.37459468E-03_JPRB, 0.37455584E-03_JPRB, 0.37451954E-03_JPRB, 0.37448696E-03_JPRB, 0.37445413E-03_JPRB, 0.37443156E-03_JPRB, &
  & 0.37444721E-03_JPRB, 0.37446221E-03_JPRB, 0.37445866E-03_JPRB, 0.37445693E-03_JPRB  /)

RGHG1(:,24, 9) = (/ &
  & 0.37394886E-03_JPRB, 0.37392621E-03_JPRB, 0.37389728E-03_JPRB, 0.37386835E-03_JPRB, 0.37383682E-03_JPRB, 0.37379708E-03_JPRB, &
  & 0.37374344E-03_JPRB, 0.37367993E-03_JPRB, 0.37363769E-03_JPRB, 0.37367386E-03_JPRB, 0.37388778E-03_JPRB, 0.37430291E-03_JPRB, &
  & 0.37481074E-03_JPRB, 0.37527582E-03_JPRB, 0.37568517E-03_JPRB, 0.37596627E-03_JPRB, 0.37610854E-03_JPRB, 0.37616448E-03_JPRB, &
  & 0.37617811E-03_JPRB, 0.37619091E-03_JPRB, 0.37624704E-03_JPRB, 0.37632727E-03_JPRB, 0.37641981E-03_JPRB, 0.37654938E-03_JPRB, &
  & 0.37673374E-03_JPRB, 0.37700394E-03_JPRB, 0.37744963E-03_JPRB, 0.37811112E-03_JPRB, 0.37894424E-03_JPRB, 0.37996285E-03_JPRB, &
  & 0.38086219E-03_JPRB, 0.38137511E-03_JPRB, 0.38158673E-03_JPRB, 0.38165089E-03_JPRB, 0.38164725E-03_JPRB, 0.38159266E-03_JPRB, &
  & 0.38148744E-03_JPRB, 0.38132769E-03_JPRB, 0.38106396E-03_JPRB, 0.38070832E-03_JPRB, 0.38033168E-03_JPRB, 0.37991665E-03_JPRB, &
  & 0.37941965E-03_JPRB, 0.37883731E-03_JPRB, 0.37818270E-03_JPRB, 0.37752252E-03_JPRB, 0.37700701E-03_JPRB, 0.37662903E-03_JPRB, &
  & 0.37635228E-03_JPRB, 0.37615767E-03_JPRB, 0.37596993E-03_JPRB, 0.37579186E-03_JPRB, 0.37563126E-03_JPRB, 0.37550381E-03_JPRB, &
  & 0.37543262E-03_JPRB, 0.37537545E-03_JPRB, 0.37531580E-03_JPRB, 0.37526100E-03_JPRB, 0.37521599E-03_JPRB, 0.37518533E-03_JPRB, &
  & 0.37519890E-03_JPRB, 0.37520876E-03_JPRB, 0.37519372E-03_JPRB, 0.37518364E-03_JPRB  /)

RGHG1(:,25, 9) = (/ &
  & 0.37437398E-03_JPRB, 0.37433468E-03_JPRB, 0.37431168E-03_JPRB, 0.37427447E-03_JPRB, 0.37423466E-03_JPRB, 0.37418890E-03_JPRB, &
  & 0.37412896E-03_JPRB, 0.37405058E-03_JPRB, 0.37399010E-03_JPRB, 0.37400331E-03_JPRB, 0.37419606E-03_JPRB, 0.37459520E-03_JPRB, &
  & 0.37510124E-03_JPRB, 0.37558335E-03_JPRB, 0.37599016E-03_JPRB, 0.37625950E-03_JPRB, 0.37639283E-03_JPRB, 0.37645094E-03_JPRB, &
  & 0.37645911E-03_JPRB, 0.37647257E-03_JPRB, 0.37654432E-03_JPRB, 0.37663904E-03_JPRB, 0.37674954E-03_JPRB, 0.37690950E-03_JPRB, &
  & 0.37713412E-03_JPRB, 0.37746895E-03_JPRB, 0.37801661E-03_JPRB, 0.37872063E-03_JPRB, 0.37956504E-03_JPRB, 0.38057773E-03_JPRB, &
  & 0.38139739E-03_JPRB, 0.38181669E-03_JPRB, 0.38197959E-03_JPRB, 0.38204948E-03_JPRB, 0.38207143E-03_JPRB, 0.38203594E-03_JPRB, &
  & 0.38193288E-03_JPRB, 0.38180163E-03_JPRB, 0.38160292E-03_JPRB, 0.38129892E-03_JPRB, 0.38094006E-03_JPRB, 0.38053002E-03_JPRB, &
  & 0.38004262E-03_JPRB, 0.37947401E-03_JPRB, 0.37887960E-03_JPRB, 0.37833297E-03_JPRB, 0.37786723E-03_JPRB, 0.37748332E-03_JPRB, &
  & 0.37718550E-03_JPRB, 0.37697489E-03_JPRB, 0.37680578E-03_JPRB, 0.37665556E-03_JPRB, 0.37650823E-03_JPRB, 0.37636619E-03_JPRB, &
  & 0.37626170E-03_JPRB, 0.37618318E-03_JPRB, 0.37610414E-03_JPRB, 0.37603024E-03_JPRB, 0.37598242E-03_JPRB, 0.37595335E-03_JPRB, &
  & 0.37596090E-03_JPRB, 0.37596841E-03_JPRB, 0.37594744E-03_JPRB, 0.37592325E-03_JPRB  /)

RGHG1(:,26, 9) = (/ &
  & 0.37467015E-03_JPRB, 0.37460195E-03_JPRB, 0.37457703E-03_JPRB, 0.37454106E-03_JPRB, 0.37450367E-03_JPRB, 0.37446736E-03_JPRB, &
  & 0.37441836E-03_JPRB, 0.37434867E-03_JPRB, 0.37429313E-03_JPRB, 0.37430659E-03_JPRB, 0.37448947E-03_JPRB, 0.37487500E-03_JPRB, &
  & 0.37537512E-03_JPRB, 0.37586925E-03_JPRB, 0.37627025E-03_JPRB, 0.37652883E-03_JPRB, 0.37666000E-03_JPRB, 0.37672023E-03_JPRB, &
  & 0.37672747E-03_JPRB, 0.37674829E-03_JPRB, 0.37682605E-03_JPRB, 0.37694055E-03_JPRB, 0.37708823E-03_JPRB, 0.37729686E-03_JPRB, &
  & 0.37757658E-03_JPRB, 0.37800240E-03_JPRB, 0.37866656E-03_JPRB, 0.37938071E-03_JPRB, 0.38018240E-03_JPRB, 0.38113138E-03_JPRB, &
  & 0.38185376E-03_JPRB, 0.38219545E-03_JPRB, 0.38232854E-03_JPRB, 0.38241537E-03_JPRB, 0.38246552E-03_JPRB, 0.38243875E-03_JPRB, &
  & 0.38232703E-03_JPRB, 0.38220132E-03_JPRB, 0.38203573E-03_JPRB, 0.38176968E-03_JPRB, 0.38143177E-03_JPRB, 0.38103072E-03_JPRB, &
  & 0.38055426E-03_JPRB, 0.38000220E-03_JPRB, 0.37945752E-03_JPRB, 0.37898604E-03_JPRB, 0.37856382E-03_JPRB, 0.37818573E-03_JPRB, &
  & 0.37788066E-03_JPRB, 0.37767771E-03_JPRB, 0.37753752E-03_JPRB, 0.37740902E-03_JPRB, 0.37727700E-03_JPRB, 0.37713140E-03_JPRB, &
  & 0.37699953E-03_JPRB, 0.37689323E-03_JPRB, 0.37679971E-03_JPRB, 0.37671771E-03_JPRB, 0.37666889E-03_JPRB, 0.37664446E-03_JPRB, &
  & 0.37665378E-03_JPRB, 0.37666123E-03_JPRB, 0.37664317E-03_JPRB, 0.37662496E-03_JPRB  /)

RGHG1(:,27, 9) = (/ &
  & 0.37493199E-03_JPRB, 0.37482902E-03_JPRB, 0.37479919E-03_JPRB, 0.37476805E-03_JPRB, 0.37473716E-03_JPRB, 0.37471647E-03_JPRB, &
  & 0.37468528E-03_JPRB, 0.37463341E-03_JPRB, 0.37459166E-03_JPRB, 0.37461399E-03_JPRB, 0.37479072E-03_JPRB, 0.37516291E-03_JPRB, &
  & 0.37565530E-03_JPRB, 0.37616014E-03_JPRB, 0.37655385E-03_JPRB, 0.37680155E-03_JPRB, 0.37693299E-03_JPRB, 0.37699541E-03_JPRB, &
  & 0.37700335E-03_JPRB, 0.37703435E-03_JPRB, 0.37711483E-03_JPRB, 0.37725198E-03_JPRB, 0.37744565E-03_JPRB, 0.37771195E-03_JPRB, &
  & 0.37805479E-03_JPRB, 0.37858550E-03_JPRB, 0.37937684E-03_JPRB, 0.38008960E-03_JPRB, 0.38082659E-03_JPRB, 0.38168753E-03_JPRB, &
  & 0.38230168E-03_JPRB, 0.38256815E-03_JPRB, 0.38267710E-03_JPRB, 0.38278579E-03_JPRB, 0.38286640E-03_JPRB, 0.38284490E-03_JPRB, &
  & 0.38272009E-03_JPRB, 0.38259166E-03_JPRB, 0.38244890E-03_JPRB, 0.38221743E-03_JPRB, 0.38190261E-03_JPRB, 0.38151243E-03_JPRB, &
  & 0.38104791E-03_JPRB, 0.38051420E-03_JPRB, 0.38001762E-03_JPRB, 0.37961048E-03_JPRB, 0.37923145E-03_JPRB, 0.37886381E-03_JPRB, &
  & 0.37855627E-03_JPRB, 0.37837009E-03_JPRB, 0.37826396E-03_JPRB, 0.37815591E-03_JPRB, 0.37804066E-03_JPRB, 0.37789541E-03_JPRB, &
  & 0.37773712E-03_JPRB, 0.37759940E-03_JPRB, 0.37749253E-03_JPRB, 0.37740614E-03_JPRB, 0.37735697E-03_JPRB, 0.37733851E-03_JPRB, &
  & 0.37735257E-03_JPRB, 0.37736081E-03_JPRB, 0.37734907E-03_JPRB, 0.37734455E-03_JPRB  /)

RGHG1(:,28, 9) = (/ &
  & 0.37503003E-03_JPRB, 0.37490523E-03_JPRB, 0.37485103E-03_JPRB, 0.37482372E-03_JPRB, 0.37481624E-03_JPRB, 0.37481765E-03_JPRB, &
  & 0.37481381E-03_JPRB, 0.37480051E-03_JPRB, 0.37479578E-03_JPRB, 0.37485268E-03_JPRB, 0.37504868E-03_JPRB, 0.37542581E-03_JPRB, &
  & 0.37591586E-03_JPRB, 0.37642389E-03_JPRB, 0.37681440E-03_JPRB, 0.37706116E-03_JPRB, 0.37720251E-03_JPRB, 0.37726203E-03_JPRB, &
  & 0.37727197E-03_JPRB, 0.37731400E-03_JPRB, 0.37741949E-03_JPRB, 0.37759022E-03_JPRB, 0.37784870E-03_JPRB, 0.37819284E-03_JPRB, &
  & 0.37861265E-03_JPRB, 0.37921375E-03_JPRB, 0.38005269E-03_JPRB, 0.38073015E-03_JPRB, 0.38139601E-03_JPRB, 0.38213071E-03_JPRB, &
  & 0.38263321E-03_JPRB, 0.38285557E-03_JPRB, 0.38297035E-03_JPRB, 0.38310567E-03_JPRB, 0.38320750E-03_JPRB, 0.38319604E-03_JPRB, &
  & 0.38307458E-03_JPRB, 0.38294757E-03_JPRB, 0.38280913E-03_JPRB, 0.38259831E-03_JPRB, 0.38230552E-03_JPRB, 0.38192378E-03_JPRB, &
  & 0.38145959E-03_JPRB, 0.38093337E-03_JPRB, 0.38045841E-03_JPRB, 0.38008154E-03_JPRB, 0.37973850E-03_JPRB, 0.37939021E-03_JPRB, &
  & 0.37908957E-03_JPRB, 0.37891627E-03_JPRB, 0.37881410E-03_JPRB, 0.37870905E-03_JPRB, 0.37859503E-03_JPRB, 0.37844456E-03_JPRB, &
  & 0.37827073E-03_JPRB, 0.37811532E-03_JPRB, 0.37800261E-03_JPRB, 0.37791227E-03_JPRB, 0.37786899E-03_JPRB, 0.37785025E-03_JPRB, &
  & 0.37786471E-03_JPRB, 0.37786090E-03_JPRB, 0.37785560E-03_JPRB, 0.37785729E-03_JPRB  /)

RGHG1(:,29, 9) = (/ &
  & 0.37512680E-03_JPRB, 0.37497944E-03_JPRB, 0.37489858E-03_JPRB, 0.37487529E-03_JPRB, 0.37489334E-03_JPRB, 0.37491844E-03_JPRB, &
  & 0.37494400E-03_JPRB, 0.37497246E-03_JPRB, 0.37500797E-03_JPRB, 0.37510261E-03_JPRB, 0.37532014E-03_JPRB, 0.37570329E-03_JPRB, &
  & 0.37619109E-03_JPRB, 0.37670217E-03_JPRB, 0.37708947E-03_JPRB, 0.37733567E-03_JPRB, 0.37748794E-03_JPRB, 0.37754417E-03_JPRB, &
  & 0.37755627E-03_JPRB, 0.37761004E-03_JPRB, 0.37774299E-03_JPRB, 0.37794978E-03_JPRB, 0.37827773E-03_JPRB, 0.37870524E-03_JPRB, &
  & 0.37920721E-03_JPRB, 0.37988139E-03_JPRB, 0.38076732E-03_JPRB, 0.38140590E-03_JPRB, 0.38199611E-03_JPRB, 0.38259540E-03_JPRB, &
  & 0.38297944E-03_JPRB, 0.38315643E-03_JPRB, 0.38327867E-03_JPRB, 0.38344242E-03_JPRB, 0.38356634E-03_JPRB, 0.38356572E-03_JPRB, &
  & 0.38344852E-03_JPRB, 0.38332320E-03_JPRB, 0.38318853E-03_JPRB, 0.38299900E-03_JPRB, 0.38272949E-03_JPRB, 0.38235659E-03_JPRB, &
  & 0.38189223E-03_JPRB, 0.38137348E-03_JPRB, 0.38092029E-03_JPRB, 0.38057402E-03_JPRB, 0.38026881E-03_JPRB, 0.37994140E-03_JPRB, &
  & 0.37964847E-03_JPRB, 0.37948866E-03_JPRB, 0.37938939E-03_JPRB, 0.37928674E-03_JPRB, 0.37917337E-03_JPRB, 0.37901711E-03_JPRB, &
  & 0.37882730E-03_JPRB, 0.37865374E-03_JPRB, 0.37853517E-03_JPRB, 0.37844065E-03_JPRB, 0.37840387E-03_JPRB, 0.37838457E-03_JPRB, &
  & 0.37839928E-03_JPRB, 0.37838213E-03_JPRB, 0.37838365E-03_JPRB, 0.37839162E-03_JPRB  /)

RGHG1(:,30, 9) = (/ &
  & 0.37531816E-03_JPRB, 0.37517551E-03_JPRB, 0.37507585E-03_JPRB, 0.37501983E-03_JPRB, 0.37502386E-03_JPRB, 0.37505195E-03_JPRB, &
  & 0.37507916E-03_JPRB, 0.37512924E-03_JPRB, 0.37520246E-03_JPRB, 0.37533962E-03_JPRB, 0.37559406E-03_JPRB, 0.37600876E-03_JPRB, &
  & 0.37651815E-03_JPRB, 0.37704779E-03_JPRB, 0.37744411E-03_JPRB, 0.37770696E-03_JPRB, 0.37787124E-03_JPRB, 0.37794270E-03_JPRB, &
  & 0.37798451E-03_JPRB, 0.37807744E-03_JPRB, 0.37827632E-03_JPRB, 0.37854988E-03_JPRB, 0.37892213E-03_JPRB, 0.37937998E-03_JPRB, &
  & 0.37988732E-03_JPRB, 0.38053482E-03_JPRB, 0.38133959E-03_JPRB, 0.38193058E-03_JPRB, 0.38243436E-03_JPRB, 0.38291536E-03_JPRB, &
  & 0.38323339E-03_JPRB, 0.38341154E-03_JPRB, 0.38356138E-03_JPRB, 0.38373454E-03_JPRB, 0.38386356E-03_JPRB, 0.38387995E-03_JPRB, &
  & 0.38378871E-03_JPRB, 0.38368914E-03_JPRB, 0.38357367E-03_JPRB, 0.38339552E-03_JPRB, 0.38312970E-03_JPRB, 0.38277092E-03_JPRB, &
  & 0.38232342E-03_JPRB, 0.38183184E-03_JPRB, 0.38141282E-03_JPRB, 0.38109466E-03_JPRB, 0.38079131E-03_JPRB, 0.38045856E-03_JPRB, &
  & 0.38015124E-03_JPRB, 0.37996775E-03_JPRB, 0.37984872E-03_JPRB, 0.37973767E-03_JPRB, 0.37961189E-03_JPRB, 0.37944052E-03_JPRB, &
  & 0.37924287E-03_JPRB, 0.37906435E-03_JPRB, 0.37893618E-03_JPRB, 0.37883622E-03_JPRB, 0.37880023E-03_JPRB, 0.37876879E-03_JPRB, &
  & 0.37876748E-03_JPRB, 0.37874651E-03_JPRB, 0.37875129E-03_JPRB, 0.37876250E-03_JPRB  /)

RGHG1(:,31, 9) = (/ &
  & 0.37551988E-03_JPRB, 0.37538221E-03_JPRB, 0.37526276E-03_JPRB, 0.37517221E-03_JPRB, 0.37516144E-03_JPRB, 0.37519265E-03_JPRB, &
  & 0.37522157E-03_JPRB, 0.37529443E-03_JPRB, 0.37540738E-03_JPRB, 0.37558932E-03_JPRB, 0.37588268E-03_JPRB, 0.37633064E-03_JPRB, &
  & 0.37686280E-03_JPRB, 0.37741200E-03_JPRB, 0.37781785E-03_JPRB, 0.37809826E-03_JPRB, 0.37827519E-03_JPRB, 0.37836272E-03_JPRB, &
  & 0.37843586E-03_JPRB, 0.37857008E-03_JPRB, 0.37883845E-03_JPRB, 0.37918241E-03_JPRB, 0.37960131E-03_JPRB, 0.38009108E-03_JPRB, &
  & 0.38060400E-03_JPRB, 0.38122330E-03_JPRB, 0.38194243E-03_JPRB, 0.38248327E-03_JPRB, 0.38289598E-03_JPRB, 0.38325234E-03_JPRB, &
  & 0.38350088E-03_JPRB, 0.38368029E-03_JPRB, 0.38385923E-03_JPRB, 0.38404228E-03_JPRB, 0.38417666E-03_JPRB, 0.38421098E-03_JPRB, &
  & 0.38414712E-03_JPRB, 0.38407472E-03_JPRB, 0.38397948E-03_JPRB, 0.38381331E-03_JPRB, 0.38355136E-03_JPRB, 0.38320746E-03_JPRB, &
  & 0.38277775E-03_JPRB, 0.38231481E-03_JPRB, 0.38193180E-03_JPRB, 0.38164326E-03_JPRB, 0.38134185E-03_JPRB, 0.38100343E-03_JPRB, &
  & 0.38068094E-03_JPRB, 0.38047244E-03_JPRB, 0.38033258E-03_JPRB, 0.38021268E-03_JPRB, 0.38007380E-03_JPRB, 0.37988651E-03_JPRB, &
  & 0.37968060E-03_JPRB, 0.37949688E-03_JPRB, 0.37935858E-03_JPRB, 0.37925290E-03_JPRB, 0.37921772E-03_JPRB, 0.37917349E-03_JPRB, &
  & 0.37915529E-03_JPRB, 0.37913030E-03_JPRB, 0.37913850E-03_JPRB, 0.37915314E-03_JPRB  /)

RGHG1(:,32, 9) = (/ &
  & 0.37605792E-03_JPRB, 0.37591404E-03_JPRB, 0.37577838E-03_JPRB, 0.37562184E-03_JPRB, 0.37554378E-03_JPRB, 0.37553359E-03_JPRB, &
  & 0.37552832E-03_JPRB, 0.37558363E-03_JPRB, 0.37569913E-03_JPRB, 0.37590748E-03_JPRB, 0.37623947E-03_JPRB, 0.37674083E-03_JPRB, &
  & 0.37733222E-03_JPRB, 0.37793679E-03_JPRB, 0.37838622E-03_JPRB, 0.37869217E-03_JPRB, 0.37889212E-03_JPRB, 0.37902822E-03_JPRB, &
  & 0.37916699E-03_JPRB, 0.37937246E-03_JPRB, 0.37970111E-03_JPRB, 0.38009396E-03_JPRB, 0.38051832E-03_JPRB, 0.38095048E-03_JPRB, &
  & 0.38137118E-03_JPRB, 0.38184097E-03_JPRB, 0.38238128E-03_JPRB, 0.38283110E-03_JPRB, 0.38316729E-03_JPRB, 0.38345289E-03_JPRB, &
  & 0.38368834E-03_JPRB, 0.38389616E-03_JPRB, 0.38411012E-03_JPRB, 0.38430212E-03_JPRB, 0.38443691E-03_JPRB, 0.38448837E-03_JPRB, &
  & 0.38445696E-03_JPRB, 0.38441487E-03_JPRB, 0.38434434E-03_JPRB, 0.38419572E-03_JPRB, 0.38395912E-03_JPRB, 0.38367419E-03_JPRB, &
  & 0.38333527E-03_JPRB, 0.38294349E-03_JPRB, 0.38260250E-03_JPRB, 0.38233958E-03_JPRB, 0.38204252E-03_JPRB, 0.38170366E-03_JPRB, &
  & 0.38135062E-03_JPRB, 0.38110108E-03_JPRB, 0.38093171E-03_JPRB, 0.38079149E-03_JPRB, 0.38064025E-03_JPRB, 0.38044940E-03_JPRB, &
  & 0.38023515E-03_JPRB, 0.38003743E-03_JPRB, 0.37989239E-03_JPRB, 0.37979074E-03_JPRB, 0.37973966E-03_JPRB, 0.37968155E-03_JPRB, &
  & 0.37963022E-03_JPRB, 0.37957831E-03_JPRB, 0.37956545E-03_JPRB, 0.37959376E-03_JPRB  /)

RGHG1(:,33, 9) = (/ &
  & 0.37666063E-03_JPRB, 0.37650884E-03_JPRB, 0.37635680E-03_JPRB, 0.37612760E-03_JPRB, 0.37597282E-03_JPRB, 0.37591384E-03_JPRB, &
  & 0.37586839E-03_JPRB, 0.37590025E-03_JPRB, 0.37601357E-03_JPRB, 0.37624698E-03_JPRB, 0.37661909E-03_JPRB, 0.37717854E-03_JPRB, &
  & 0.37783623E-03_JPRB, 0.37850296E-03_JPRB, 0.37900209E-03_JPRB, 0.37933562E-03_JPRB, 0.37956084E-03_JPRB, 0.37975161E-03_JPRB, &
  & 0.37996304E-03_JPRB, 0.38024642E-03_JPRB, 0.38063654E-03_JPRB, 0.38107740E-03_JPRB, 0.38150212E-03_JPRB, 0.38186280E-03_JPRB, &
  & 0.38217500E-03_JPRB, 0.38247371E-03_JPRB, 0.38281613E-03_JPRB, 0.38316606E-03_JPRB, 0.38342462E-03_JPRB, 0.38364364E-03_JPRB, &
  & 0.38387279E-03_JPRB, 0.38411365E-03_JPRB, 0.38436479E-03_JPRB, 0.38456595E-03_JPRB, 0.38470053E-03_JPRB, 0.38476971E-03_JPRB, &
  & 0.38477266E-03_JPRB, 0.38476250E-03_JPRB, 0.38471821E-03_JPRB, 0.38458857E-03_JPRB, 0.38438109E-03_JPRB, 0.38416315E-03_JPRB, &
  & 0.38392804E-03_JPRB, 0.38361572E-03_JPRB, 0.38331918E-03_JPRB, 0.38308237E-03_JPRB, 0.38279013E-03_JPRB, 0.38245148E-03_JPRB, &
  & 0.38206470E-03_JPRB, 0.38177043E-03_JPRB, 0.38156928E-03_JPRB, 0.38140645E-03_JPRB, 0.38124247E-03_JPRB, 0.38104952E-03_JPRB, &
  & 0.38082659E-03_JPRB, 0.38061319E-03_JPRB, 0.38046157E-03_JPRB, 0.38036538E-03_JPRB, 0.38029561E-03_JPRB, 0.38022294E-03_JPRB, &
  & 0.38013506E-03_JPRB, 0.38005222E-03_JPRB, 0.38001429E-03_JPRB, 0.38005815E-03_JPRB  /)

RGHG1(:,34, 9) = (/ &
  & 0.37734441E-03_JPRB, 0.37720085E-03_JPRB, 0.37705099E-03_JPRB, 0.37676969E-03_JPRB, 0.37654912E-03_JPRB, 0.37641633E-03_JPRB, &
  & 0.37631873E-03_JPRB, 0.37631218E-03_JPRB, 0.37640801E-03_JPRB, 0.37664593E-03_JPRB, 0.37705082E-03_JPRB, 0.37766401E-03_JPRB, &
  & 0.37839316E-03_JPRB, 0.37912213E-03_JPRB, 0.37967587E-03_JPRB, 0.38003502E-03_JPRB, 0.38027102E-03_JPRB, 0.38049891E-03_JPRB, &
  & 0.38076007E-03_JPRB, 0.38108789E-03_JPRB, 0.38149118E-03_JPRB, 0.38192544E-03_JPRB, 0.38230446E-03_JPRB, 0.38257502E-03_JPRB, &
  & 0.38277304E-03_JPRB, 0.38291132E-03_JPRB, 0.38307099E-03_JPRB, 0.38330729E-03_JPRB, 0.38351273E-03_JPRB, 0.38370610E-03_JPRB, &
  & 0.38394254E-03_JPRB, 0.38421312E-03_JPRB, 0.38449172E-03_JPRB, 0.38470310E-03_JPRB, 0.38483959E-03_JPRB, 0.38492558E-03_JPRB, &
  & 0.38495397E-03_JPRB, 0.38495793E-03_JPRB, 0.38491880E-03_JPRB, 0.38480504E-03_JPRB, 0.38464645E-03_JPRB, 0.38449814E-03_JPRB, &
  & 0.38435016E-03_JPRB, 0.38412606E-03_JPRB, 0.38389195E-03_JPRB, 0.38369835E-03_JPRB, 0.38343760E-03_JPRB, 0.38312848E-03_JPRB, &
  & 0.38273548E-03_JPRB, 0.38240423E-03_JPRB, 0.38218159E-03_JPRB, 0.38200562E-03_JPRB, 0.38183863E-03_JPRB, 0.38164043E-03_JPRB, &
  & 0.38141179E-03_JPRB, 0.38118748E-03_JPRB, 0.38103101E-03_JPRB, 0.38092462E-03_JPRB, 0.38083262E-03_JPRB, 0.38074776E-03_JPRB, &
  & 0.38063419E-03_JPRB, 0.38051745E-03_JPRB, 0.38043725E-03_JPRB, 0.38047005E-03_JPRB  /)

RGHG1(:,35, 9) = (/ &
  & 0.37808901E-03_JPRB, 0.37796221E-03_JPRB, 0.37782410E-03_JPRB, 0.37749981E-03_JPRB, 0.37721720E-03_JPRB, 0.37699568E-03_JPRB, &
  & 0.37683832E-03_JPRB, 0.37678461E-03_JPRB, 0.37685459E-03_JPRB, 0.37708660E-03_JPRB, 0.37752143E-03_JPRB, 0.37818762E-03_JPRB, &
  & 0.37899291E-03_JPRB, 0.37978593E-03_JPRB, 0.38039832E-03_JPRB, 0.38078281E-03_JPRB, 0.38102244E-03_JPRB, 0.38127949E-03_JPRB, &
  & 0.38158002E-03_JPRB, 0.38193636E-03_JPRB, 0.38232841E-03_JPRB, 0.38272786E-03_JPRB, 0.38303627E-03_JPRB, 0.38320458E-03_JPRB, &
  & 0.38328230E-03_JPRB, 0.38326112E-03_JPRB, 0.38324065E-03_JPRB, 0.38335308E-03_JPRB, 0.38351650E-03_JPRB, 0.38370448E-03_JPRB, &
  & 0.38395541E-03_JPRB, 0.38425482E-03_JPRB, 0.38455667E-03_JPRB, 0.38477910E-03_JPRB, 0.38491865E-03_JPRB, 0.38502146E-03_JPRB, &
  & 0.38507141E-03_JPRB, 0.38508076E-03_JPRB, 0.38503612E-03_JPRB, 0.38493710E-03_JPRB, 0.38483892E-03_JPRB, 0.38476356E-03_JPRB, &
  & 0.38469657E-03_JPRB, 0.38456771E-03_JPRB, 0.38440699E-03_JPRB, 0.38426659E-03_JPRB, 0.38405190E-03_JPRB, 0.38378819E-03_JPRB, &
  & 0.38340291E-03_JPRB, 0.38303763E-03_JPRB, 0.38279816E-03_JPRB, 0.38261356E-03_JPRB, 0.38244845E-03_JPRB, 0.38224323E-03_JPRB, &
  & 0.38201023E-03_JPRB, 0.38177716E-03_JPRB, 0.38161659E-03_JPRB, 0.38149170E-03_JPRB, 0.38137501E-03_JPRB, 0.38127885E-03_JPRB, &
  & 0.38114443E-03_JPRB, 0.38099131E-03_JPRB, 0.38085882E-03_JPRB, 0.38086661E-03_JPRB  /)

RGHG1(:,36, 9) = (/ &
  & 0.37881251E-03_JPRB, 0.37869476E-03_JPRB, 0.37857217E-03_JPRB, 0.37821039E-03_JPRB, 0.37787639E-03_JPRB, 0.37756995E-03_JPRB, &
  & 0.37735646E-03_JPRB, 0.37726444E-03_JPRB, 0.37731563E-03_JPRB, 0.37754131E-03_JPRB, 0.37800067E-03_JPRB, 0.37871306E-03_JPRB, &
  & 0.37958459E-03_JPRB, 0.38043361E-03_JPRB, 0.38109936E-03_JPRB, 0.38151127E-03_JPRB, 0.38175120E-03_JPRB, 0.38202118E-03_JPRB, &
  & 0.38234317E-03_JPRB, 0.38271005E-03_JPRB, 0.38307397E-03_JPRB, 0.38341762E-03_JPRB, 0.38363478E-03_JPRB, 0.38368467E-03_JPRB, &
  & 0.38363719E-03_JPRB, 0.38348102E-03_JPRB, 0.38332419E-03_JPRB, 0.38334781E-03_JPRB, 0.38348933E-03_JPRB, 0.38368322E-03_JPRB, &
  & 0.38394948E-03_JPRB, 0.38427102E-03_JPRB, 0.38458659E-03_JPRB, 0.38481101E-03_JPRB, 0.38495172E-03_JPRB, 0.38506244E-03_JPRB, &
  & 0.38511402E-03_JPRB, 0.38511149E-03_JPRB, 0.38505567E-03_JPRB, 0.38496875E-03_JPRB, 0.38492132E-03_JPRB, 0.38491268E-03_JPRB, &
  & 0.38492403E-03_JPRB, 0.38489030E-03_JPRB, 0.38481174E-03_JPRB, 0.38473839E-03_JPRB, 0.38458781E-03_JPRB, 0.38438678E-03_JPRB, &
  & 0.38403355E-03_JPRB, 0.38365570E-03_JPRB, 0.38340279E-03_JPRB, 0.38321853E-03_JPRB, 0.38305988E-03_JPRB, 0.38285111E-03_JPRB, &
  & 0.38261651E-03_JPRB, 0.38237740E-03_JPRB, 0.38220745E-03_JPRB, 0.38206182E-03_JPRB, 0.38192047E-03_JPRB, 0.38181882E-03_JPRB, &
  & 0.38167133E-03_JPRB, 0.38148982E-03_JPRB, 0.38129853E-03_JPRB, 0.38127051E-03_JPRB  /)

RGHG1(:,37, 9) = (/ &
  & 0.37944261E-03_JPRB, 0.37931569E-03_JPRB, 0.37921624E-03_JPRB, 0.37883198E-03_JPRB, 0.37847418E-03_JPRB, 0.37809686E-03_JPRB, &
  & 0.37783905E-03_JPRB, 0.37773139E-03_JPRB, 0.37778113E-03_JPRB, 0.37799991E-03_JPRB, 0.37846990E-03_JPRB, 0.37920999E-03_JPRB, &
  & 0.38012097E-03_JPRB, 0.38100405E-03_JPRB, 0.38170770E-03_JPRB, 0.38215013E-03_JPRB, 0.38238269E-03_JPRB, 0.38262754E-03_JPRB, &
  & 0.38292860E-03_JPRB, 0.38326418E-03_JPRB, 0.38356298E-03_JPRB, 0.38380619E-03_JPRB, 0.38389047E-03_JPRB, 0.38379218E-03_JPRB, &
  & 0.38361609E-03_JPRB, 0.38338946E-03_JPRB, 0.38320504E-03_JPRB, 0.38322578E-03_JPRB, 0.38339290E-03_JPRB, 0.38361828E-03_JPRB, &
  & 0.38390085E-03_JPRB, 0.38422772E-03_JPRB, 0.38453430E-03_JPRB, 0.38473983E-03_JPRB, 0.38487730E-03_JPRB, 0.38497501E-03_JPRB, &
  & 0.38498240E-03_JPRB, 0.38492914E-03_JPRB, 0.38484987E-03_JPRB, 0.38476823E-03_JPRB, 0.38474622E-03_JPRB, 0.38478592E-03_JPRB, &
  & 0.38486461E-03_JPRB, 0.38491986E-03_JPRB, 0.38493845E-03_JPRB, 0.38495972E-03_JPRB, 0.38491066E-03_JPRB, 0.38480803E-03_JPRB, &
  & 0.38454061E-03_JPRB, 0.38420017E-03_JPRB, 0.38394241E-03_JPRB, 0.38377907E-03_JPRB, 0.38363697E-03_JPRB, 0.38343283E-03_JPRB, &
  & 0.38320302E-03_JPRB, 0.38296451E-03_JPRB, 0.38277363E-03_JPRB, 0.38260348E-03_JPRB, 0.38243904E-03_JPRB, 0.38234555E-03_JPRB, &
  & 0.38220363E-03_JPRB, 0.38201385E-03_JPRB, 0.38175246E-03_JPRB, 0.38166610E-03_JPRB  /)

RGHG1(:,38, 9) = (/ &
  & 0.38014177E-03_JPRB, 0.38000467E-03_JPRB, 0.37993090E-03_JPRB, 0.37952169E-03_JPRB, 0.37913747E-03_JPRB, 0.37868151E-03_JPRB, &
  & 0.37837453E-03_JPRB, 0.37824950E-03_JPRB, 0.37829765E-03_JPRB, 0.37850878E-03_JPRB, 0.37899054E-03_JPRB, 0.37976137E-03_JPRB, &
  & 0.38071613E-03_JPRB, 0.38163701E-03_JPRB, 0.38238271E-03_JPRB, 0.38285901E-03_JPRB, 0.38308338E-03_JPRB, 0.38330035E-03_JPRB, &
  & 0.38357819E-03_JPRB, 0.38387904E-03_JPRB, 0.38410558E-03_JPRB, 0.38423734E-03_JPRB, 0.38417418E-03_JPRB, 0.38391148E-03_JPRB, &
  & 0.38359267E-03_JPRB, 0.38328786E-03_JPRB, 0.38307283E-03_JPRB, 0.38309038E-03_JPRB, 0.38328591E-03_JPRB, 0.38354622E-03_JPRB, &
  & 0.38384689E-03_JPRB, 0.38417969E-03_JPRB, 0.38447628E-03_JPRB, 0.38466085E-03_JPRB, 0.38479473E-03_JPRB, 0.38487800E-03_JPRB, &
  & 0.38483635E-03_JPRB, 0.38472681E-03_JPRB, 0.38462152E-03_JPRB, 0.38454574E-03_JPRB, 0.38455194E-03_JPRB, 0.38464526E-03_JPRB, &
  & 0.38479867E-03_JPRB, 0.38495266E-03_JPRB, 0.38507904E-03_JPRB, 0.38520530E-03_JPRB, 0.38526889E-03_JPRB, 0.38527544E-03_JPRB, &
  & 0.38510324E-03_JPRB, 0.38480432E-03_JPRB, 0.38454116E-03_JPRB, 0.38440105E-03_JPRB, 0.38427732E-03_JPRB, 0.38407829E-03_JPRB, &
  & 0.38385381E-03_JPRB, 0.38361596E-03_JPRB, 0.38340187E-03_JPRB, 0.38320450E-03_JPRB, 0.38301444E-03_JPRB, 0.38293000E-03_JPRB, &
  & 0.38279427E-03_JPRB, 0.38259531E-03_JPRB, 0.38225614E-03_JPRB, 0.38210503E-03_JPRB  /)

RGHG1(:,39, 9) = (/ &
  & 0.38042252E-03_JPRB, 0.38026929E-03_JPRB, 0.38024231E-03_JPRB, 0.37983550E-03_JPRB, 0.37943809E-03_JPRB, 0.37895284E-03_JPRB, &
  & 0.37862889E-03_JPRB, 0.37854777E-03_JPRB, 0.37863042E-03_JPRB, 0.37885348E-03_JPRB, 0.37934549E-03_JPRB, 0.38012908E-03_JPRB, &
  & 0.38109183E-03_JPRB, 0.38203532E-03_JPRB, 0.38281235E-03_JPRB, 0.38330198E-03_JPRB, 0.38351759E-03_JPRB, 0.38371092E-03_JPRB, &
  & 0.38395907E-03_JPRB, 0.38422901E-03_JPRB, 0.38437081E-03_JPRB, 0.38438212E-03_JPRB, 0.38417970E-03_JPRB, 0.38378902E-03_JPRB, &
  & 0.38338115E-03_JPRB, 0.38306414E-03_JPRB, 0.38294400E-03_JPRB, 0.38305486E-03_JPRB, 0.38333422E-03_JPRB, 0.38366322E-03_JPRB, &
  & 0.38396414E-03_JPRB, 0.38426593E-03_JPRB, 0.38452785E-03_JPRB, 0.38468115E-03_JPRB, 0.38477194E-03_JPRB, 0.38478693E-03_JPRB, &
  & 0.38469803E-03_JPRB, 0.38454604E-03_JPRB, 0.38440484E-03_JPRB, 0.38431005E-03_JPRB, 0.38430750E-03_JPRB, 0.38439868E-03_JPRB, &
  & 0.38456328E-03_JPRB, 0.38476812E-03_JPRB, 0.38497904E-03_JPRB, 0.38519706E-03_JPRB, 0.38536665E-03_JPRB, 0.38547012E-03_JPRB, &
  & 0.38541428E-03_JPRB, 0.38522208E-03_JPRB, 0.38499339E-03_JPRB, 0.38487962E-03_JPRB, 0.38476852E-03_JPRB, 0.38460295E-03_JPRB, &
  & 0.38439467E-03_JPRB, 0.38417121E-03_JPRB, 0.38395853E-03_JPRB, 0.38375181E-03_JPRB, 0.38356795E-03_JPRB, 0.38348944E-03_JPRB, &
  & 0.38337797E-03_JPRB, 0.38319679E-03_JPRB, 0.38280178E-03_JPRB, 0.38261873E-03_JPRB  /)

RGHG1(:,40, 9) = (/ &
  & 0.38068354E-03_JPRB, 0.38051041E-03_JPRB, 0.38054179E-03_JPRB, 0.38014228E-03_JPRB, 0.37973156E-03_JPRB, 0.37922001E-03_JPRB, &
  & 0.37888140E-03_JPRB, 0.37886185E-03_JPRB, 0.37899089E-03_JPRB, 0.37923117E-03_JPRB, 0.37973495E-03_JPRB, 0.38053057E-03_JPRB, &
  & 0.38149684E-03_JPRB, 0.38246439E-03_JPRB, 0.38327642E-03_JPRB, 0.38377834E-03_JPRB, 0.38398359E-03_JPRB, 0.38414984E-03_JPRB, &
  & 0.38436209E-03_JPRB, 0.38459639E-03_JPRB, 0.38463670E-03_JPRB, 0.38450517E-03_JPRB, 0.38414066E-03_JPRB, 0.38360574E-03_JPRB, &
  & 0.38310214E-03_JPRB, 0.38278161E-03_JPRB, 0.38279336E-03_JPRB, 0.38302952E-03_JPRB, 0.38341633E-03_JPRB, 0.38383146E-03_JPRB, &
  & 0.38412975E-03_JPRB, 0.38438912E-03_JPRB, 0.38460631E-03_JPRB, 0.38472120E-03_JPRB, 0.38475499E-03_JPRB, 0.38468102E-03_JPRB, &
  & 0.38453696E-03_JPRB, 0.38433742E-03_JPRB, 0.38415245E-03_JPRB, 0.38403130E-03_JPRB, 0.38401243E-03_JPRB, 0.38409196E-03_JPRB, &
  & 0.38425932E-03_JPRB, 0.38451599E-03_JPRB, 0.38482232E-03_JPRB, 0.38514587E-03_JPRB, 0.38543877E-03_JPRB, 0.38565397E-03_JPRB, &
  & 0.38573814E-03_JPRB, 0.38568187E-03_JPRB, 0.38550015E-03_JPRB, 0.38541780E-03_JPRB, 0.38532058E-03_JPRB, 0.38519891E-03_JPRB, &
  & 0.38501143E-03_JPRB, 0.38480711E-03_JPRB, 0.38460013E-03_JPRB, 0.38438534E-03_JPRB, 0.38421396E-03_JPRB, 0.38414191E-03_JPRB, &
  & 0.38406186E-03_JPRB, 0.38390596E-03_JPRB, 0.38344900E-03_JPRB, 0.38323383E-03_JPRB  /)

RGHG1(:,41, 9) = (/ &
  & 0.38100268E-03_JPRB, 0.38080522E-03_JPRB, 0.38090796E-03_JPRB, 0.38051736E-03_JPRB, 0.38009037E-03_JPRB, 0.37954666E-03_JPRB, &
  & 0.37919014E-03_JPRB, 0.37924585E-03_JPRB, 0.37943162E-03_JPRB, 0.37969294E-03_JPRB, 0.38021112E-03_JPRB, 0.38102145E-03_JPRB, &
  & 0.38199203E-03_JPRB, 0.38298900E-03_JPRB, 0.38384382E-03_JPRB, 0.38436076E-03_JPRB, 0.38455334E-03_JPRB, 0.38468649E-03_JPRB, &
  & 0.38485485E-03_JPRB, 0.38504557E-03_JPRB, 0.38496179E-03_JPRB, 0.38465563E-03_JPRB, 0.38409294E-03_JPRB, 0.38338166E-03_JPRB, &
  & 0.38276101E-03_JPRB, 0.38243618E-03_JPRB, 0.38260918E-03_JPRB, 0.38299854E-03_JPRB, 0.38351671E-03_JPRB, 0.38403715E-03_JPRB, &
  & 0.38433224E-03_JPRB, 0.38453973E-03_JPRB, 0.38470223E-03_JPRB, 0.38477018E-03_JPRB, 0.38473425E-03_JPRB, 0.38455153E-03_JPRB, &
  & 0.38434003E-03_JPRB, 0.38408236E-03_JPRB, 0.38384387E-03_JPRB, 0.38369048E-03_JPRB, 0.38365166E-03_JPRB, 0.38371696E-03_JPRB, &
  & 0.38388768E-03_JPRB, 0.38420772E-03_JPRB, 0.38463071E-03_JPRB, 0.38508328E-03_JPRB, 0.38552695E-03_JPRB, 0.38587876E-03_JPRB, &
  & 0.38613412E-03_JPRB, 0.38624402E-03_JPRB, 0.38611974E-03_JPRB, 0.38607580E-03_JPRB, 0.38599556E-03_JPRB, 0.38592756E-03_JPRB, &
  & 0.38576551E-03_JPRB, 0.38558458E-03_JPRB, 0.38538456E-03_JPRB, 0.38515992E-03_JPRB, 0.38500380E-03_JPRB, 0.38493965E-03_JPRB, &
  & 0.38489801E-03_JPRB, 0.38477302E-03_JPRB, 0.38424032E-03_JPRB, 0.38398587E-03_JPRB  /)

RGHG1(:,42, 9) = (/ &
  & 0.38040763E-03_JPRB, 0.38023957E-03_JPRB, 0.38040704E-03_JPRB, 0.38017634E-03_JPRB, 0.37974874E-03_JPRB, 0.37923144E-03_JPRB, &
  & 0.37891119E-03_JPRB, 0.37905914E-03_JPRB, 0.37931392E-03_JPRB, 0.37962411E-03_JPRB, 0.38017780E-03_JPRB, 0.38099075E-03_JPRB, &
  & 0.38196708E-03_JPRB, 0.38299696E-03_JPRB, 0.38385741E-03_JPRB, 0.38435787E-03_JPRB, 0.38456336E-03_JPRB, 0.38469749E-03_JPRB, &
  & 0.38487664E-03_JPRB, 0.38500696E-03_JPRB, 0.38487687E-03_JPRB, 0.38452819E-03_JPRB, 0.38394144E-03_JPRB, 0.38326907E-03_JPRB, &
  & 0.38277626E-03_JPRB, 0.38261832E-03_JPRB, 0.38285191E-03_JPRB, 0.38327486E-03_JPRB, 0.38377390E-03_JPRB, 0.38426229E-03_JPRB, &
  & 0.38455762E-03_JPRB, 0.38475370E-03_JPRB, 0.38486078E-03_JPRB, 0.38487068E-03_JPRB, 0.38484130E-03_JPRB, 0.38469945E-03_JPRB, &
  & 0.38451602E-03_JPRB, 0.38426808E-03_JPRB, 0.38394266E-03_JPRB, 0.38366304E-03_JPRB, 0.38354210E-03_JPRB, 0.38356969E-03_JPRB, &
  & 0.38370136E-03_JPRB, 0.38398687E-03_JPRB, 0.38437398E-03_JPRB, 0.38482341E-03_JPRB, 0.38530190E-03_JPRB, 0.38572304E-03_JPRB, &
  & 0.38605199E-03_JPRB, 0.38623834E-03_JPRB, 0.38621513E-03_JPRB, 0.38623513E-03_JPRB, 0.38622090E-03_JPRB, 0.38618969E-03_JPRB, &
  & 0.38606514E-03_JPRB, 0.38591361E-03_JPRB, 0.38575599E-03_JPRB, 0.38558336E-03_JPRB, 0.38547494E-03_JPRB, 0.38542932E-03_JPRB, &
  & 0.38545044E-03_JPRB, 0.38538531E-03_JPRB, 0.38489229E-03_JPRB, 0.38469502E-03_JPRB  /)

RGHG1(:,43, 9) = (/ &
  & 0.38000198E-03_JPRB, 0.37985029E-03_JPRB, 0.38010751E-03_JPRB, 0.38002654E-03_JPRB, 0.37959137E-03_JPRB, 0.37908434E-03_JPRB, &
  & 0.37878948E-03_JPRB, 0.37905397E-03_JPRB, 0.37939611E-03_JPRB, 0.37975995E-03_JPRB, 0.38035222E-03_JPRB, 0.38117389E-03_JPRB, &
  & 0.38215732E-03_JPRB, 0.38322988E-03_JPRB, 0.38411387E-03_JPRB, 0.38460577E-03_JPRB, 0.38481759E-03_JPRB, 0.38493836E-03_JPRB, &
  & 0.38510848E-03_JPRB, 0.38516494E-03_JPRB, 0.38493923E-03_JPRB, 0.38447664E-03_JPRB, 0.38378268E-03_JPRB, 0.38306995E-03_JPRB, &
  & 0.38264344E-03_JPRB, 0.38263592E-03_JPRB, 0.38299415E-03_JPRB, 0.38351365E-03_JPRB, 0.38405174E-03_JPRB, 0.38455618E-03_JPRB, &
  & 0.38485035E-03_JPRB, 0.38501371E-03_JPRB, 0.38504670E-03_JPRB, 0.38498343E-03_JPRB, 0.38493006E-03_JPRB, 0.38477871E-03_JPRB, &
  & 0.38459189E-03_JPRB, 0.38432782E-03_JPRB, 0.38390006E-03_JPRB, 0.38349139E-03_JPRB, 0.38328695E-03_JPRB, 0.38327403E-03_JPRB, &
  & 0.38337150E-03_JPRB, 0.38365277E-03_JPRB, 0.38405732E-03_JPRB, 0.38455938E-03_JPRB, 0.38513450E-03_JPRB, 0.38567766E-03_JPRB, &
  & 0.38614738E-03_JPRB, 0.38647497E-03_JPRB, 0.38656868E-03_JPRB, 0.38666355E-03_JPRB, 0.38671685E-03_JPRB, 0.38674228E-03_JPRB, &
  & 0.38666288E-03_JPRB, 0.38654824E-03_JPRB, 0.38643230E-03_JPRB, 0.38630289E-03_JPRB, 0.38624456E-03_JPRB, 0.38621923E-03_JPRB, &
  & 0.38631413E-03_JPRB, 0.38631692E-03_JPRB, 0.38582753E-03_JPRB, 0.38566553E-03_JPRB  /)

RGHG1(:,44, 9) = (/ &
  & 0.37938404E-03_JPRB, 0.37913373E-03_JPRB, 0.37942833E-03_JPRB, 0.37949263E-03_JPRB, 0.37910849E-03_JPRB, 0.37864665E-03_JPRB, &
  & 0.37842211E-03_JPRB, 0.37871409E-03_JPRB, 0.37912107E-03_JPRB, 0.37955799E-03_JPRB, 0.38018607E-03_JPRB, 0.38102466E-03_JPRB, &
  & 0.38201269E-03_JPRB, 0.38309713E-03_JPRB, 0.38398143E-03_JPRB, 0.38447940E-03_JPRB, 0.38471525E-03_JPRB, 0.38484508E-03_JPRB, &
  & 0.38502253E-03_JPRB, 0.38504018E-03_JPRB, 0.38478306E-03_JPRB, 0.38430937E-03_JPRB, 0.38361036E-03_JPRB, 0.38297896E-03_JPRB, &
  & 0.38264202E-03_JPRB, 0.38272678E-03_JPRB, 0.38310768E-03_JPRB, 0.38364485E-03_JPRB, 0.38415301E-03_JPRB, 0.38460195E-03_JPRB, &
  & 0.38488828E-03_JPRB, 0.38505493E-03_JPRB, 0.38507228E-03_JPRB, 0.38498880E-03_JPRB, 0.38497207E-03_JPRB, 0.38485202E-03_JPRB, &
  & 0.38465866E-03_JPRB, 0.38436779E-03_JPRB, 0.38391336E-03_JPRB, 0.38343372E-03_JPRB, 0.38317385E-03_JPRB, 0.38311244E-03_JPRB, &
  & 0.38318326E-03_JPRB, 0.38342817E-03_JPRB, 0.38381749E-03_JPRB, 0.38429862E-03_JPRB, 0.38485617E-03_JPRB, 0.38543034E-03_JPRB, &
  & 0.38595796E-03_JPRB, 0.38634400E-03_JPRB, 0.38649827E-03_JPRB, 0.38664746E-03_JPRB, 0.38675170E-03_JPRB, 0.38680841E-03_JPRB, &
  & 0.38676641E-03_JPRB, 0.38671463E-03_JPRB, 0.38661972E-03_JPRB, 0.38650978E-03_JPRB, 0.38648219E-03_JPRB, 0.38651000E-03_JPRB, &
  & 0.38665103E-03_JPRB, 0.38673230E-03_JPRB, 0.38632302E-03_JPRB, 0.38618157E-03_JPRB  /)

RGHG1(:,45, 9) = (/ &
  & 0.37862931E-03_JPRB, 0.37826881E-03_JPRB, 0.37861730E-03_JPRB, 0.37886588E-03_JPRB, 0.37853889E-03_JPRB, 0.37812981E-03_JPRB, &
  & 0.37798852E-03_JPRB, 0.37832651E-03_JPRB, 0.37881833E-03_JPRB, 0.37934525E-03_JPRB, 0.38001896E-03_JPRB, 0.38087791E-03_JPRB, &
  & 0.38187207E-03_JPRB, 0.38297543E-03_JPRB, 0.38386306E-03_JPRB, 0.38436686E-03_JPRB, 0.38463086E-03_JPRB, 0.38476932E-03_JPRB, &
  & 0.38495396E-03_JPRB, 0.38491810E-03_JPRB, 0.38461315E-03_JPRB, 0.38411244E-03_JPRB, 0.38339413E-03_JPRB, 0.38285022E-03_JPRB, &
  & 0.38262363E-03_JPRB, 0.38283243E-03_JPRB, 0.38325488E-03_JPRB, 0.38382437E-03_JPRB, 0.38430340E-03_JPRB, 0.38469118E-03_JPRB, &
  & 0.38496843E-03_JPRB, 0.38513471E-03_JPRB, 0.38512488E-03_JPRB, 0.38500916E-03_JPRB, 0.38503110E-03_JPRB, 0.38494549E-03_JPRB, &
  & 0.38474426E-03_JPRB, 0.38442085E-03_JPRB, 0.38392312E-03_JPRB, 0.38334638E-03_JPRB, 0.38301287E-03_JPRB, 0.38289114E-03_JPRB, &
  & 0.38292730E-03_JPRB, 0.38313027E-03_JPRB, 0.38350446E-03_JPRB, 0.38396841E-03_JPRB, 0.38451816E-03_JPRB, 0.38514304E-03_JPRB, &
  & 0.38575437E-03_JPRB, 0.38622480E-03_JPRB, 0.38646277E-03_JPRB, 0.38668325E-03_JPRB, 0.38685403E-03_JPRB, 0.38695350E-03_JPRB, &
  & 0.38695979E-03_JPRB, 0.38698422E-03_JPRB, 0.38691852E-03_JPRB, 0.38683621E-03_JPRB, 0.38684995E-03_JPRB, 0.38694079E-03_JPRB, &
  & 0.38714366E-03_JPRB, 0.38732287E-03_JPRB, 0.38700524E-03_JPRB, 0.38689164E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART18',0,ZHOOK_HANDLE)



RGHG1(:,46, 9) = (/ &
  & 0.37794546E-03_JPRB, 0.37759010E-03_JPRB, 0.37788569E-03_JPRB, 0.37815938E-03_JPRB, 0.37793992E-03_JPRB, 0.37762514E-03_JPRB, &
  & 0.37756299E-03_JPRB, 0.37790527E-03_JPRB, 0.37842432E-03_JPRB, 0.37902197E-03_JPRB, 0.37972559E-03_JPRB, 0.38059182E-03_JPRB, &
  & 0.38155754E-03_JPRB, 0.38264201E-03_JPRB, 0.38352620E-03_JPRB, 0.38404665E-03_JPRB, 0.38434226E-03_JPRB, 0.38450165E-03_JPRB, &
  & 0.38469970E-03_JPRB, 0.38466648E-03_JPRB, 0.38438096E-03_JPRB, 0.38391067E-03_JPRB, 0.38324760E-03_JPRB, 0.38277991E-03_JPRB, &
  & 0.38263304E-03_JPRB, 0.38289976E-03_JPRB, 0.38330778E-03_JPRB, 0.38386707E-03_JPRB, 0.38431450E-03_JPRB, 0.38467034E-03_JPRB, &
  & 0.38494211E-03_JPRB, 0.38511955E-03_JPRB, 0.38512388E-03_JPRB, 0.38502743E-03_JPRB, 0.38508428E-03_JPRB, 0.38500690E-03_JPRB, &
  & 0.38479530E-03_JPRB, 0.38443013E-03_JPRB, 0.38388931E-03_JPRB, 0.38326929E-03_JPRB, 0.38289726E-03_JPRB, 0.38272840E-03_JPRB, &
  & 0.38272653E-03_JPRB, 0.38289715E-03_JPRB, 0.38323080E-03_JPRB, 0.38364352E-03_JPRB, 0.38416778E-03_JPRB, 0.38478011E-03_JPRB, &
  & 0.38539801E-03_JPRB, 0.38588710E-03_JPRB, 0.38615424E-03_JPRB, 0.38640539E-03_JPRB, 0.38662055E-03_JPRB, 0.38675708E-03_JPRB, &
  & 0.38680847E-03_JPRB, 0.38690367E-03_JPRB, 0.38688095E-03_JPRB, 0.38681056E-03_JPRB, 0.38684497E-03_JPRB, 0.38700428E-03_JPRB, &
  & 0.38726084E-03_JPRB, 0.38749891E-03_JPRB, 0.38727165E-03_JPRB, 0.38717896E-03_JPRB  /)

RGHG1(:,47, 9) = (/ &
  & 0.37715721E-03_JPRB, 0.37683099E-03_JPRB, 0.37704311E-03_JPRB, 0.37731437E-03_JPRB, 0.37723120E-03_JPRB, 0.37703540E-03_JPRB, &
  & 0.37706529E-03_JPRB, 0.37740423E-03_JPRB, 0.37794369E-03_JPRB, 0.37862048E-03_JPRB, 0.37935606E-03_JPRB, 0.38022820E-03_JPRB, &
  & 0.38115363E-03_JPRB, 0.38220835E-03_JPRB, 0.38308716E-03_JPRB, 0.38362931E-03_JPRB, 0.38396271E-03_JPRB, 0.38414911E-03_JPRB, &
  & 0.38436416E-03_JPRB, 0.38434528E-03_JPRB, 0.38409603E-03_JPRB, 0.38367294E-03_JPRB, 0.38308961E-03_JPRB, 0.38270911E-03_JPRB, &
  & 0.38264966E-03_JPRB, 0.38297109E-03_JPRB, 0.38335095E-03_JPRB, 0.38388975E-03_JPRB, 0.38429963E-03_JPRB, 0.38462382E-03_JPRB, &
  & 0.38488990E-03_JPRB, 0.38508275E-03_JPRB, 0.38511196E-03_JPRB, 0.38504845E-03_JPRB, 0.38514552E-03_JPRB, 0.38507254E-03_JPRB, &
  & 0.38484826E-03_JPRB, 0.38443226E-03_JPRB, 0.38384089E-03_JPRB, 0.38318089E-03_JPRB, 0.38277070E-03_JPRB, 0.38254917E-03_JPRB, &
  & 0.38250200E-03_JPRB, 0.38263658E-03_JPRB, 0.38291756E-03_JPRB, 0.38326336E-03_JPRB, 0.38375416E-03_JPRB, 0.38433909E-03_JPRB, &
  & 0.38494925E-03_JPRB, 0.38544707E-03_JPRB, 0.38573750E-03_JPRB, 0.38601650E-03_JPRB, 0.38627931E-03_JPRB, 0.38645819E-03_JPRB, &
  & 0.38656186E-03_JPRB, 0.38673901E-03_JPRB, 0.38676948E-03_JPRB, 0.38670995E-03_JPRB, 0.38676446E-03_JPRB, 0.38700519E-03_JPRB, &
  & 0.38732314E-03_JPRB, 0.38762244E-03_JPRB, 0.38750096E-03_JPRB, 0.38743141E-03_JPRB  /)

RGHG1(:,48, 9) = (/ &
  & 0.37654200E-03_JPRB, 0.37632606E-03_JPRB, 0.37647829E-03_JPRB, 0.37669919E-03_JPRB, 0.37668151E-03_JPRB, 0.37661507E-03_JPRB, &
  & 0.37672230E-03_JPRB, 0.37705150E-03_JPRB, 0.37757346E-03_JPRB, 0.37826970E-03_JPRB, 0.37899284E-03_JPRB, 0.37985105E-03_JPRB, &
  & 0.38071509E-03_JPRB, 0.38173643E-03_JPRB, 0.38261207E-03_JPRB, 0.38316872E-03_JPRB, 0.38351461E-03_JPRB, 0.38372353E-03_JPRB, &
  & 0.38397603E-03_JPRB, 0.38398984E-03_JPRB, 0.38380261E-03_JPRB, 0.38345816E-03_JPRB, 0.38296945E-03_JPRB, 0.38265550E-03_JPRB, &
  & 0.38265350E-03_JPRB, 0.38298168E-03_JPRB, 0.38335056E-03_JPRB, 0.38385199E-03_JPRB, 0.38421653E-03_JPRB, 0.38454248E-03_JPRB, &
  & 0.38481837E-03_JPRB, 0.38502417E-03_JPRB, 0.38508865E-03_JPRB, 0.38505995E-03_JPRB, 0.38516873E-03_JPRB, 0.38510610E-03_JPRB, &
  & 0.38487166E-03_JPRB, 0.38441493E-03_JPRB, 0.38377296E-03_JPRB, 0.38309913E-03_JPRB, 0.38265648E-03_JPRB, 0.38239799E-03_JPRB, &
  & 0.38231161E-03_JPRB, 0.38242184E-03_JPRB, 0.38263973E-03_JPRB, 0.38292866E-03_JPRB, 0.38338369E-03_JPRB, 0.38391827E-03_JPRB, &
  & 0.38447862E-03_JPRB, 0.38492982E-03_JPRB, 0.38521676E-03_JPRB, 0.38550267E-03_JPRB, 0.38577756E-03_JPRB, 0.38598551E-03_JPRB, &
  & 0.38612164E-03_JPRB, 0.38632364E-03_JPRB, 0.38639832E-03_JPRB, 0.38636916E-03_JPRB, 0.38643610E-03_JPRB, 0.38671040E-03_JPRB, &
  & 0.38708262E-03_JPRB, 0.38742617E-03_JPRB, 0.38743898E-03_JPRB, 0.38737437E-03_JPRB  /)

RGHG1(:,49, 9) = (/ &
  & 0.37593939E-03_JPRB, 0.37588248E-03_JPRB, 0.37597910E-03_JPRB, 0.37612243E-03_JPRB, 0.37614509E-03_JPRB, 0.37622661E-03_JPRB, &
  & 0.37641282E-03_JPRB, 0.37672830E-03_JPRB, 0.37721367E-03_JPRB, 0.37790430E-03_JPRB, 0.37859348E-03_JPRB, 0.37942724E-03_JPRB, &
  & 0.38021372E-03_JPRB, 0.38119643E-03_JPRB, 0.38206958E-03_JPRB, 0.38263899E-03_JPRB, 0.38298723E-03_JPRB, 0.38321904E-03_JPRB, &
  & 0.38352232E-03_JPRB, 0.38358068E-03_JPRB, 0.38347381E-03_JPRB, 0.38323076E-03_JPRB, 0.38285357E-03_JPRB, 0.38260395E-03_JPRB, &
  & 0.38265194E-03_JPRB, 0.38296579E-03_JPRB, 0.38333031E-03_JPRB, 0.38378268E-03_JPRB, 0.38409348E-03_JPRB, 0.38443656E-03_JPRB, &
  & 0.38473037E-03_JPRB, 0.38494941E-03_JPRB, 0.38505766E-03_JPRB, 0.38506836E-03_JPRB, 0.38517714E-03_JPRB, 0.38512869E-03_JPRB, &
  & 0.38488412E-03_JPRB, 0.38438689E-03_JPRB, 0.38368885E-03_JPRB, 0.38301159E-03_JPRB, 0.38253561E-03_JPRB, 0.38224333E-03_JPRB, &
  & 0.38211629E-03_JPRB, 0.38220487E-03_JPRB, 0.38234816E-03_JPRB, 0.38257868E-03_JPRB, 0.38299306E-03_JPRB, 0.38346145E-03_JPRB, &
  & 0.38394750E-03_JPRB, 0.38432191E-03_JPRB, 0.38459281E-03_JPRB, 0.38487685E-03_JPRB, 0.38514893E-03_JPRB, 0.38538305E-03_JPRB, &
  & 0.38554613E-03_JPRB, 0.38574968E-03_JPRB, 0.38586922E-03_JPRB, 0.38588258E-03_JPRB, 0.38595981E-03_JPRB, 0.38624953E-03_JPRB, &
  & 0.38667859E-03_JPRB, 0.38706342E-03_JPRB, 0.38723790E-03_JPRB, 0.38717049E-03_JPRB  /)

RGHG1(:,50, 9) = (/ &
  & 0.37564093E-03_JPRB, 0.37570131E-03_JPRB, 0.37576609E-03_JPRB, 0.37588294E-03_JPRB, 0.37587992E-03_JPRB, 0.37610701E-03_JPRB, &
  & 0.37635873E-03_JPRB, 0.37667752E-03_JPRB, 0.37709980E-03_JPRB, 0.37769678E-03_JPRB, 0.37831281E-03_JPRB, 0.37909798E-03_JPRB, &
  & 0.37981718E-03_JPRB, 0.38075709E-03_JPRB, 0.38161637E-03_JPRB, 0.38219492E-03_JPRB, 0.38255657E-03_JPRB, 0.38280437E-03_JPRB, &
  & 0.38313033E-03_JPRB, 0.38323160E-03_JPRB, 0.38318827E-03_JPRB, 0.38303466E-03_JPRB, 0.38275387E-03_JPRB, 0.38255454E-03_JPRB, &
  & 0.38262000E-03_JPRB, 0.38291904E-03_JPRB, 0.38327474E-03_JPRB, 0.38368829E-03_JPRB, 0.38397909E-03_JPRB, 0.38433861E-03_JPRB, &
  & 0.38466702E-03_JPRB, 0.38488391E-03_JPRB, 0.38501052E-03_JPRB, 0.38505274E-03_JPRB, 0.38516030E-03_JPRB, 0.38512833E-03_JPRB, &
  & 0.38487711E-03_JPRB, 0.38434740E-03_JPRB, 0.38360866E-03_JPRB, 0.38291641E-03_JPRB, 0.38241617E-03_JPRB, 0.38209957E-03_JPRB, &
  & 0.38194152E-03_JPRB, 0.38201938E-03_JPRB, 0.38210688E-03_JPRB, 0.38230696E-03_JPRB, 0.38268406E-03_JPRB, 0.38307957E-03_JPRB, &
  & 0.38347897E-03_JPRB, 0.38377209E-03_JPRB, 0.38401963E-03_JPRB, 0.38426418E-03_JPRB, 0.38450903E-03_JPRB, 0.38472943E-03_JPRB, &
  & 0.38490770E-03_JPRB, 0.38509284E-03_JPRB, 0.38519232E-03_JPRB, 0.38523194E-03_JPRB, 0.38532346E-03_JPRB, 0.38561660E-03_JPRB, &
  & 0.38607266E-03_JPRB, 0.38650328E-03_JPRB, 0.38673387E-03_JPRB, 0.38669439E-03_JPRB  /)

RGHG1(:,51, 9) = (/ &
  & 0.37547798E-03_JPRB, 0.37564331E-03_JPRB, 0.37568612E-03_JPRB, 0.37580118E-03_JPRB, 0.37573568E-03_JPRB, 0.37611897E-03_JPRB, &
  & 0.37643446E-03_JPRB, 0.37676579E-03_JPRB, 0.37710590E-03_JPRB, 0.37755531E-03_JPRB, 0.37807160E-03_JPRB, 0.37879153E-03_JPRB, &
  & 0.37944337E-03_JPRB, 0.38033480E-03_JPRB, 0.38117309E-03_JPRB, 0.38175961E-03_JPRB, 0.38214160E-03_JPRB, 0.38240307E-03_JPRB, &
  & 0.38273879E-03_JPRB, 0.38288562E-03_JPRB, 0.38290216E-03_JPRB, 0.38283901E-03_JPRB, 0.38265454E-03_JPRB, 0.38250224E-03_JPRB, &
  & 0.38256948E-03_JPRB, 0.38285225E-03_JPRB, 0.38319608E-03_JPRB, 0.38357301E-03_JPRB, 0.38385991E-03_JPRB, 0.38423684E-03_JPRB, &
  & 0.38461146E-03_JPRB, 0.38481794E-03_JPRB, 0.38495106E-03_JPRB, 0.38502321E-03_JPRB, 0.38512882E-03_JPRB, 0.38511588E-03_JPRB, &
  & 0.38485929E-03_JPRB, 0.38429867E-03_JPRB, 0.38352397E-03_JPRB, 0.38280943E-03_JPRB, 0.38228771E-03_JPRB, 0.38194980E-03_JPRB, &
  & 0.38176328E-03_JPRB, 0.38183528E-03_JPRB, 0.38187235E-03_JPRB, 0.38205421E-03_JPRB, 0.38239274E-03_JPRB, 0.38270593E-03_JPRB, &
  & 0.38300510E-03_JPRB, 0.38320792E-03_JPRB, 0.38342633E-03_JPRB, 0.38360841E-03_JPRB, 0.38381095E-03_JPRB, 0.38399556E-03_JPRB, &
  & 0.38418408E-03_JPRB, 0.38433879E-03_JPRB, 0.38438247E-03_JPRB, 0.38444194E-03_JPRB, 0.38455103E-03_JPRB, 0.38484157E-03_JPRB, &
  & 0.38531113E-03_JPRB, 0.38579365E-03_JPRB, 0.38602945E-03_JPRB, 0.38603634E-03_JPRB  /)

RGHG1(:,52, 9) = (/ &
  & 0.37572243E-03_JPRB, 0.37592838E-03_JPRB, 0.37596354E-03_JPRB, 0.37608145E-03_JPRB, 0.37594844E-03_JPRB, 0.37643524E-03_JPRB, &
  & 0.37680018E-03_JPRB, 0.37712633E-03_JPRB, 0.37740054E-03_JPRB, 0.37766348E-03_JPRB, 0.37805907E-03_JPRB, 0.37868793E-03_JPRB, &
  & 0.37927757E-03_JPRB, 0.38008982E-03_JPRB, 0.38091151E-03_JPRB, 0.38149411E-03_JPRB, 0.38189376E-03_JPRB, 0.38216911E-03_JPRB, &
  & 0.38249672E-03_JPRB, 0.38265526E-03_JPRB, 0.38270188E-03_JPRB, 0.38269189E-03_JPRB, 0.38255527E-03_JPRB, 0.38242421E-03_JPRB, &
  & 0.38247813E-03_JPRB, 0.38275612E-03_JPRB, 0.38308199E-03_JPRB, 0.38341792E-03_JPRB, 0.38371935E-03_JPRB, 0.38412360E-03_JPRB, &
  & 0.38453661E-03_JPRB, 0.38474596E-03_JPRB, 0.38487722E-03_JPRB, 0.38497985E-03_JPRB, 0.38508553E-03_JPRB, 0.38508130E-03_JPRB, &
  & 0.38481608E-03_JPRB, 0.38422607E-03_JPRB, 0.38343656E-03_JPRB, 0.38269762E-03_JPRB, 0.38217374E-03_JPRB, 0.38180830E-03_JPRB, &
  & 0.38160642E-03_JPRB, 0.38167008E-03_JPRB, 0.38168186E-03_JPRB, 0.38185419E-03_JPRB, 0.38215085E-03_JPRB, 0.38238954E-03_JPRB, &
  & 0.38261164E-03_JPRB, 0.38276433E-03_JPRB, 0.38294537E-03_JPRB, 0.38308003E-03_JPRB, 0.38324701E-03_JPRB, 0.38339757E-03_JPRB, &
  & 0.38358790E-03_JPRB, 0.38372412E-03_JPRB, 0.38369935E-03_JPRB, 0.38376144E-03_JPRB, 0.38385712E-03_JPRB, 0.38413562E-03_JPRB, &
  & 0.38458995E-03_JPRB, 0.38502317E-03_JPRB, 0.38519998E-03_JPRB, 0.38526942E-03_JPRB  /)

RGHG1(:,53, 9) = (/ &
  & 0.37614538E-03_JPRB, 0.37637081E-03_JPRB, 0.37640313E-03_JPRB, 0.37652594E-03_JPRB, 0.37631748E-03_JPRB, 0.37689673E-03_JPRB, &
  & 0.37730999E-03_JPRB, 0.37762369E-03_JPRB, 0.37783241E-03_JPRB, 0.37787731E-03_JPRB, 0.37813341E-03_JPRB, 0.37865317E-03_JPRB, &
  & 0.37917705E-03_JPRB, 0.37989127E-03_JPRB, 0.38069656E-03_JPRB, 0.38127032E-03_JPRB, 0.38168816E-03_JPRB, 0.38197871E-03_JPRB, &
  & 0.38229061E-03_JPRB, 0.38244890E-03_JPRB, 0.38251680E-03_JPRB, 0.38255033E-03_JPRB, 0.38244720E-03_JPRB, 0.38232936E-03_JPRB, &
  & 0.38236293E-03_JPRB, 0.38264015E-03_JPRB, 0.38294413E-03_JPRB, 0.38323370E-03_JPRB, 0.38355805E-03_JPRB, 0.38399586E-03_JPRB, &
  & 0.38444768E-03_JPRB, 0.38466527E-03_JPRB, 0.38479130E-03_JPRB, 0.38492732E-03_JPRB, 0.38503386E-03_JPRB, 0.38503511E-03_JPRB, &
  & 0.38475925E-03_JPRB, 0.38413783E-03_JPRB, 0.38334034E-03_JPRB, 0.38257401E-03_JPRB, 0.38205519E-03_JPRB, 0.38165739E-03_JPRB, &
  & 0.38144384E-03_JPRB, 0.38149745E-03_JPRB, 0.38149138E-03_JPRB, 0.38165667E-03_JPRB, 0.38190646E-03_JPRB, 0.38206703E-03_JPRB, &
  & 0.38221411E-03_JPRB, 0.38232765E-03_JPRB, 0.38246482E-03_JPRB, 0.38255364E-03_JPRB, 0.38268449E-03_JPRB, 0.38279865E-03_JPRB, &
  & 0.38298769E-03_JPRB, 0.38310838E-03_JPRB, 0.38300420E-03_JPRB, 0.38306251E-03_JPRB, 0.38313167E-03_JPRB, 0.38339343E-03_JPRB, &
  & 0.38382012E-03_JPRB, 0.38416071E-03_JPRB, 0.38424859E-03_JPRB, 0.38439237E-03_JPRB  /)

RGHG1(:,54, 9) = (/ &
  & 0.37697533E-03_JPRB, 0.37714558E-03_JPRB, 0.37718128E-03_JPRB, 0.37728101E-03_JPRB, 0.37701302E-03_JPRB, 0.37760649E-03_JPRB, &
  & 0.37804480E-03_JPRB, 0.37831419E-03_JPRB, 0.37848112E-03_JPRB, 0.37835523E-03_JPRB, 0.37846629E-03_JPRB, 0.37885864E-03_JPRB, &
  & 0.37933909E-03_JPRB, 0.37991547E-03_JPRB, 0.38067066E-03_JPRB, 0.38121416E-03_JPRB, 0.38162423E-03_JPRB, 0.38191617E-03_JPRB, &
  & 0.38220244E-03_JPRB, 0.38234578E-03_JPRB, 0.38241404E-03_JPRB, 0.38245027E-03_JPRB, 0.38236017E-03_JPRB, 0.38223103E-03_JPRB, &
  & 0.38223921E-03_JPRB, 0.38250834E-03_JPRB, 0.38277406E-03_JPRB, 0.38305893E-03_JPRB, 0.38340570E-03_JPRB, 0.38386685E-03_JPRB, &
  & 0.38432579E-03_JPRB, 0.38458020E-03_JPRB, 0.38472125E-03_JPRB, 0.38487941E-03_JPRB, 0.38499795E-03_JPRB, 0.38498729E-03_JPRB, &
  & 0.38470163E-03_JPRB, 0.38406246E-03_JPRB, 0.38325486E-03_JPRB, 0.38248306E-03_JPRB, 0.38197463E-03_JPRB, 0.38154326E-03_JPRB, &
  & 0.38132553E-03_JPRB, 0.38135404E-03_JPRB, 0.38133138E-03_JPRB, 0.38149004E-03_JPRB, 0.38169840E-03_JPRB, 0.38181658E-03_JPRB, &
  & 0.38192571E-03_JPRB, 0.38202047E-03_JPRB, 0.38212455E-03_JPRB, 0.38220137E-03_JPRB, 0.38231831E-03_JPRB, 0.38242251E-03_JPRB, &
  & 0.38262119E-03_JPRB, 0.38274897E-03_JPRB, 0.38262005E-03_JPRB, 0.38264541E-03_JPRB, 0.38267757E-03_JPRB, 0.38289206E-03_JPRB, &
  & 0.38325445E-03_JPRB, 0.38351863E-03_JPRB, 0.38357054E-03_JPRB, 0.38365276E-03_JPRB  /)

RGHG1(:,55, 9) = (/ &
  & 0.37794825E-03_JPRB, 0.37804755E-03_JPRB, 0.37808780E-03_JPRB, 0.37815830E-03_JPRB, 0.37782646E-03_JPRB, 0.37842540E-03_JPRB, &
  & 0.37888839E-03_JPRB, 0.37910450E-03_JPRB, 0.37922826E-03_JPRB, 0.37891938E-03_JPRB, 0.37886905E-03_JPRB, 0.37911785E-03_JPRB, &
  & 0.37955313E-03_JPRB, 0.37997157E-03_JPRB, 0.38066683E-03_JPRB, 0.38117399E-03_JPRB, 0.38157204E-03_JPRB, 0.38186370E-03_JPRB, &
  & 0.38212029E-03_JPRB, 0.38224514E-03_JPRB, 0.38231103E-03_JPRB, 0.38234489E-03_JPRB, 0.38226654E-03_JPRB, 0.38212164E-03_JPRB, &
  & 0.38210104E-03_JPRB, 0.38236024E-03_JPRB, 0.38258142E-03_JPRB, 0.38286657E-03_JPRB, 0.38323811E-03_JPRB, 0.38372376E-03_JPRB, &
  & 0.38418644E-03_JPRB, 0.38448538E-03_JPRB, 0.38464574E-03_JPRB, 0.38482695E-03_JPRB, 0.38496024E-03_JPRB, 0.38493410E-03_JPRB, &
  & 0.38463769E-03_JPRB, 0.38398067E-03_JPRB, 0.38316160E-03_JPRB, 0.38238661E-03_JPRB, 0.38189038E-03_JPRB, 0.38142166E-03_JPRB, &
  & 0.38120029E-03_JPRB, 0.38119902E-03_JPRB, 0.38115814E-03_JPRB, 0.38130952E-03_JPRB, 0.38147270E-03_JPRB, 0.38154862E-03_JPRB, &
  & 0.38162059E-03_JPRB, 0.38169722E-03_JPRB, 0.38176605E-03_JPRB, 0.38183404E-03_JPRB, 0.38193850E-03_JPRB, 0.38203515E-03_JPRB, &
  & 0.38224594E-03_JPRB, 0.38238456E-03_JPRB, 0.38223542E-03_JPRB, 0.38222042E-03_JPRB, 0.38221023E-03_JPRB, 0.38236835E-03_JPRB, &
  & 0.38265469E-03_JPRB, 0.38283635E-03_JPRB, 0.38285537E-03_JPRB, 0.38285152E-03_JPRB  /)

RGHG1(:,56, 9) = (/ &
  & 0.37905571E-03_JPRB, 0.37904564E-03_JPRB, 0.37908395E-03_JPRB, 0.37913710E-03_JPRB, 0.37878912E-03_JPRB, 0.37928353E-03_JPRB, &
  & 0.37973498E-03_JPRB, 0.37989707E-03_JPRB, 0.37999112E-03_JPRB, 0.37962584E-03_JPRB, 0.37946051E-03_JPRB, 0.37957380E-03_JPRB, &
  & 0.37993848E-03_JPRB, 0.38023040E-03_JPRB, 0.38081821E-03_JPRB, 0.38125640E-03_JPRB, 0.38161132E-03_JPRB, 0.38186539E-03_JPRB, &
  & 0.38209029E-03_JPRB, 0.38220286E-03_JPRB, 0.38226895E-03_JPRB, 0.38226364E-03_JPRB, 0.38217818E-03_JPRB, 0.38204108E-03_JPRB, &
  & 0.38200744E-03_JPRB, 0.38224805E-03_JPRB, 0.38246089E-03_JPRB, 0.38272422E-03_JPRB, 0.38311357E-03_JPRB, 0.38361639E-03_JPRB, &
  & 0.38404194E-03_JPRB, 0.38435817E-03_JPRB, 0.38457262E-03_JPRB, 0.38476262E-03_JPRB, 0.38494705E-03_JPRB, 0.38490807E-03_JPRB, &
  & 0.38458967E-03_JPRB, 0.38393945E-03_JPRB, 0.38310178E-03_JPRB, 0.38232572E-03_JPRB, 0.38182087E-03_JPRB, 0.38133699E-03_JPRB, &
  & 0.38113493E-03_JPRB, 0.38109090E-03_JPRB, 0.38102945E-03_JPRB, 0.38115519E-03_JPRB, 0.38130778E-03_JPRB, 0.38137274E-03_JPRB, &
  & 0.38143650E-03_JPRB, 0.38150130E-03_JPRB, 0.38155810E-03_JPRB, 0.38163206E-03_JPRB, 0.38174041E-03_JPRB, 0.38184850E-03_JPRB, &
  & 0.38206108E-03_JPRB, 0.38218026E-03_JPRB, 0.38204532E-03_JPRB, 0.38201494E-03_JPRB, 0.38196171E-03_JPRB, 0.38205404E-03_JPRB, &
  & 0.38225274E-03_JPRB, 0.38239462E-03_JPRB, 0.38238956E-03_JPRB, 0.38237817E-03_JPRB  /)

RGHG1(:,57, 9) = (/ &
  & 0.38014599E-03_JPRB, 0.38003710E-03_JPRB, 0.38007529E-03_JPRB, 0.38011716E-03_JPRB, 0.37976476E-03_JPRB, 0.38015170E-03_JPRB, &
  & 0.38058598E-03_JPRB, 0.38069237E-03_JPRB, 0.38075565E-03_JPRB, 0.38034717E-03_JPRB, 0.38007824E-03_JPRB, 0.38006109E-03_JPRB, &
  & 0.38034879E-03_JPRB, 0.38051971E-03_JPRB, 0.38099110E-03_JPRB, 0.38135198E-03_JPRB, 0.38165742E-03_JPRB, 0.38186693E-03_JPRB, &
  & 0.38205413E-03_JPRB, 0.38214933E-03_JPRB, 0.38221167E-03_JPRB, 0.38217410E-03_JPRB, 0.38207804E-03_JPRB, 0.38194801E-03_JPRB, &
  & 0.38190334E-03_JPRB, 0.38212426E-03_JPRB, 0.38234823E-03_JPRB, 0.38260954E-03_JPRB, 0.38301868E-03_JPRB, 0.38352092E-03_JPRB, &
  & 0.38388961E-03_JPRB, 0.38420997E-03_JPRB, 0.38447030E-03_JPRB, 0.38468481E-03_JPRB, 0.38492554E-03_JPRB, 0.38488151E-03_JPRB, &
  & 0.38453740E-03_JPRB, 0.38389025E-03_JPRB, 0.38303241E-03_JPRB, 0.38226458E-03_JPRB, 0.38175201E-03_JPRB, 0.38125325E-03_JPRB, &
  & 0.38106279E-03_JPRB, 0.38098096E-03_JPRB, 0.38089988E-03_JPRB, 0.38100046E-03_JPRB, 0.38114335E-03_JPRB, 0.38119762E-03_JPRB, &
  & 0.38124445E-03_JPRB, 0.38130345E-03_JPRB, 0.38135474E-03_JPRB, 0.38142950E-03_JPRB, 0.38154048E-03_JPRB, 0.38166156E-03_JPRB, &
  & 0.38187102E-03_JPRB, 0.38197179E-03_JPRB, 0.38184945E-03_JPRB, 0.38180345E-03_JPRB, 0.38170875E-03_JPRB, 0.38173826E-03_JPRB, &
  & 0.38186432E-03_JPRB, 0.38195293E-03_JPRB, 0.38192464E-03_JPRB, 0.38191450E-03_JPRB  /)

RGHG1(:,58, 9) = (/ &
  & 0.38114476E-03_JPRB, 0.38095566E-03_JPRB, 0.38099555E-03_JPRB, 0.38103955E-03_JPRB, 0.38071182E-03_JPRB, 0.38097434E-03_JPRB, &
  & 0.38137653E-03_JPRB, 0.38142875E-03_JPRB, 0.38146447E-03_JPRB, 0.38106228E-03_JPRB, 0.38072603E-03_JPRB, 0.38059903E-03_JPRB, &
  & 0.38080037E-03_JPRB, 0.38087523E-03_JPRB, 0.38121549E-03_JPRB, 0.38148510E-03_JPRB, 0.38172847E-03_JPRB, 0.38187822E-03_JPRB, &
  & 0.38202023E-03_JPRB, 0.38209204E-03_JPRB, 0.38214473E-03_JPRB, 0.38208230E-03_JPRB, 0.38196705E-03_JPRB, 0.38184671E-03_JPRB, &
  & 0.38179821E-03_JPRB, 0.38199758E-03_JPRB, 0.38227147E-03_JPRB, 0.38256018E-03_JPRB, 0.38298956E-03_JPRB, 0.38345994E-03_JPRB, &
  & 0.38373532E-03_JPRB, 0.38403214E-03_JPRB, 0.38432736E-03_JPRB, 0.38458828E-03_JPRB, 0.38489628E-03_JPRB, 0.38486128E-03_JPRB, &
  & 0.38448517E-03_JPRB, 0.38383915E-03_JPRB, 0.38295876E-03_JPRB, 0.38221456E-03_JPRB, 0.38169255E-03_JPRB, 0.38118475E-03_JPRB, &
  & 0.38099624E-03_JPRB, 0.38088557E-03_JPRB, 0.38078761E-03_JPRB, 0.38086244E-03_JPRB, 0.38100437E-03_JPRB, 0.38105515E-03_JPRB, &
  & 0.38107706E-03_JPRB, 0.38114212E-03_JPRB, 0.38120371E-03_JPRB, 0.38127327E-03_JPRB, 0.38138761E-03_JPRB, 0.38152679E-03_JPRB, &
  & 0.38172316E-03_JPRB, 0.38180303E-03_JPRB, 0.38169605E-03_JPRB, 0.38163999E-03_JPRB, 0.38150964E-03_JPRB, 0.38148465E-03_JPRB, &
  & 0.38156708E-03_JPRB, 0.38159193E-03_JPRB, 0.38154539E-03_JPRB, 0.38156593E-03_JPRB  /)

RGHG1(:,59, 9) = (/ &
  & 0.38196383E-03_JPRB, 0.38172635E-03_JPRB, 0.38176510E-03_JPRB, 0.38181313E-03_JPRB, 0.38152681E-03_JPRB, 0.38168853E-03_JPRB, &
  & 0.38204942E-03_JPRB, 0.38205460E-03_JPRB, 0.38205377E-03_JPRB, 0.38167409E-03_JPRB, 0.38131428E-03_JPRB, 0.38112091E-03_JPRB, &
  & 0.38124463E-03_JPRB, 0.38124740E-03_JPRB, 0.38145922E-03_JPRB, 0.38164014E-03_JPRB, 0.38181632E-03_JPRB, 0.38190585E-03_JPRB, &
  & 0.38198776E-03_JPRB, 0.38202408E-03_JPRB, 0.38205826E-03_JPRB, 0.38199151E-03_JPRB, 0.38187574E-03_JPRB, 0.38174963E-03_JPRB, &
  & 0.38171673E-03_JPRB, 0.38188780E-03_JPRB, 0.38219158E-03_JPRB, 0.38252654E-03_JPRB, 0.38300134E-03_JPRB, 0.38344655E-03_JPRB, &
  & 0.38364233E-03_JPRB, 0.38388931E-03_JPRB, 0.38418165E-03_JPRB, 0.38450830E-03_JPRB, 0.38486666E-03_JPRB, 0.38482199E-03_JPRB, &
  & 0.38441631E-03_JPRB, 0.38376374E-03_JPRB, 0.38288974E-03_JPRB, 0.38216168E-03_JPRB, 0.38164021E-03_JPRB, 0.38113681E-03_JPRB, &
  & 0.38093888E-03_JPRB, 0.38080860E-03_JPRB, 0.38069604E-03_JPRB, 0.38075554E-03_JPRB, 0.38089428E-03_JPRB, 0.38094078E-03_JPRB, &
  & 0.38093888E-03_JPRB, 0.38101605E-03_JPRB, 0.38109436E-03_JPRB, 0.38115836E-03_JPRB, 0.38127591E-03_JPRB, 0.38143469E-03_JPRB, &
  & 0.38161959E-03_JPRB, 0.38169007E-03_JPRB, 0.38158552E-03_JPRB, 0.38151628E-03_JPRB, 0.38137950E-03_JPRB, 0.38133175E-03_JPRB, &
  & 0.38141135E-03_JPRB, 0.38138285E-03_JPRB, 0.38131481E-03_JPRB, 0.38135975E-03_JPRB  /)

RGHG1(:,60, 9) = (/ &
  & 0.38272507E-03_JPRB, 0.38245346E-03_JPRB, 0.38248716E-03_JPRB, 0.38253582E-03_JPRB, 0.38229715E-03_JPRB, 0.38236978E-03_JPRB, &
  & 0.38268256E-03_JPRB, 0.38264498E-03_JPRB, 0.38260320E-03_JPRB, 0.38225057E-03_JPRB, 0.38188534E-03_JPRB, 0.38164603E-03_JPRB, &
  & 0.38169512E-03_JPRB, 0.38163680E-03_JPRB, 0.38172039E-03_JPRB, 0.38181108E-03_JPRB, 0.38191526E-03_JPRB, 0.38194382E-03_JPRB, &
  & 0.38195747E-03_JPRB, 0.38195280E-03_JPRB, 0.38196520E-03_JPRB, 0.38190136E-03_JPRB, 0.38179181E-03_JPRB, 0.38165888E-03_JPRB, &
  & 0.38164370E-03_JPRB, 0.38179255E-03_JPRB, 0.38211897E-03_JPRB, 0.38249885E-03_JPRB, 0.38303262E-03_JPRB, 0.38346415E-03_JPRB, &
  & 0.38359270E-03_JPRB, 0.38378231E-03_JPRB, 0.38405654E-03_JPRB, 0.38444887E-03_JPRB, 0.38483731E-03_JPRB, 0.38476960E-03_JPRB, &
  & 0.38433775E-03_JPRB, 0.38367885E-03_JPRB, 0.38282527E-03_JPRB, 0.38210923E-03_JPRB, 0.38159420E-03_JPRB, 0.38110173E-03_JPRB, &
  & 0.38088793E-03_JPRB, 0.38073932E-03_JPRB, 0.38061285E-03_JPRB, 0.38066197E-03_JPRB, 0.38079626E-03_JPRB, 0.38083703E-03_JPRB, &
  & 0.38081560E-03_JPRB, 0.38090534E-03_JPRB, 0.38100135E-03_JPRB, 0.38106073E-03_JPRB, 0.38118270E-03_JPRB, 0.38136316E-03_JPRB, &
  & 0.38153745E-03_JPRB, 0.38160439E-03_JPRB, 0.38149769E-03_JPRB, 0.38141250E-03_JPRB, 0.38128435E-03_JPRB, 0.38123279E-03_JPRB, &
  & 0.38132754E-03_JPRB, 0.38125758E-03_JPRB, 0.38116819E-03_JPRB, 0.38123567E-03_JPRB  /)

RGHG1(:,61, 9) = (/ &
  & 0.38335585E-03_JPRB, 0.38307337E-03_JPRB, 0.38309041E-03_JPRB, 0.38312334E-03_JPRB, 0.38292890E-03_JPRB, 0.38294458E-03_JPRB, &
  & 0.38320089E-03_JPRB, 0.38313588E-03_JPRB, 0.38305321E-03_JPRB, 0.38272112E-03_JPRB, 0.38236989E-03_JPRB, 0.38212038E-03_JPRB, &
  & 0.38210786E-03_JPRB, 0.38201285E-03_JPRB, 0.38198629E-03_JPRB, 0.38199164E-03_JPRB, 0.38202228E-03_JPRB, 0.38199717E-03_JPRB, &
  & 0.38193917E-03_JPRB, 0.38189304E-03_JPRB, 0.38188499E-03_JPRB, 0.38182704E-03_JPRB, 0.38172652E-03_JPRB, 0.38160327E-03_JPRB, &
  & 0.38158686E-03_JPRB, 0.38175053E-03_JPRB, 0.38209175E-03_JPRB, 0.38247998E-03_JPRB, 0.38308670E-03_JPRB, 0.38354518E-03_JPRB, &
  & 0.38365042E-03_JPRB, 0.38379446E-03_JPRB, 0.38403922E-03_JPRB, 0.38446199E-03_JPRB, 0.38481419E-03_JPRB, 0.38469631E-03_JPRB, &
  & 0.38425328E-03_JPRB, 0.38359976E-03_JPRB, 0.38278391E-03_JPRB, 0.38207064E-03_JPRB, 0.38157242E-03_JPRB, 0.38109881E-03_JPRB, &
  & 0.38085969E-03_JPRB, 0.38068914E-03_JPRB, 0.38055099E-03_JPRB, 0.38059831E-03_JPRB, 0.38072661E-03_JPRB, 0.38075764E-03_JPRB, &
  & 0.38073596E-03_JPRB, 0.38083041E-03_JPRB, 0.38093713E-03_JPRB, 0.38099692E-03_JPRB, 0.38112771E-03_JPRB, 0.38133303E-03_JPRB, &
  & 0.38149983E-03_JPRB, 0.38157318E-03_JPRB, 0.38146232E-03_JPRB, 0.38135632E-03_JPRB, 0.38125990E-03_JPRB, 0.38124227E-03_JPRB, &
  & 0.38137136E-03_JPRB, 0.38130201E-03_JPRB, 0.38119946E-03_JPRB, 0.38128616E-03_JPRB  /)

RGHG1(:,62, 9) = (/ &
  & 0.38391469E-03_JPRB, 0.38363292E-03_JPRB, 0.38364035E-03_JPRB, 0.38364251E-03_JPRB, 0.38347292E-03_JPRB, 0.38345018E-03_JPRB, &
  & 0.38364813E-03_JPRB, 0.38356299E-03_JPRB, 0.38345507E-03_JPRB, 0.38313258E-03_JPRB, 0.38279977E-03_JPRB, 0.38254908E-03_JPRB, &
  & 0.38247841E-03_JPRB, 0.38235699E-03_JPRB, 0.38224933E-03_JPRB, 0.38217664E-03_JPRB, 0.38214087E-03_JPRB, 0.38206790E-03_JPRB, &
  & 0.38195580E-03_JPRB, 0.38186996E-03_JPRB, 0.38182901E-03_JPRB, 0.38175593E-03_JPRB, 0.38166711E-03_JPRB, 0.38157826E-03_JPRB, &
  & 0.38155939E-03_JPRB, 0.38174999E-03_JPRB, 0.38210328E-03_JPRB, 0.38249661E-03_JPRB, 0.38316082E-03_JPRB, 0.38364242E-03_JPRB, &
  & 0.38375288E-03_JPRB, 0.38388937E-03_JPRB, 0.38413771E-03_JPRB, 0.38454534E-03_JPRB, 0.38481034E-03_JPRB, 0.38462367E-03_JPRB, &
  & 0.38418195E-03_JPRB, 0.38354999E-03_JPRB, 0.38277508E-03_JPRB, 0.38207285E-03_JPRB, 0.38159836E-03_JPRB, 0.38113173E-03_JPRB, &
  & 0.38086360E-03_JPRB, 0.38066627E-03_JPRB, 0.38052187E-03_JPRB, 0.38056617E-03_JPRB, 0.38068179E-03_JPRB, 0.38070224E-03_JPRB, &
  & 0.38069274E-03_JPRB, 0.38079035E-03_JPRB, 0.38089792E-03_JPRB, 0.38096715E-03_JPRB, 0.38111209E-03_JPRB, 0.38134219E-03_JPRB, &
  & 0.38150411E-03_JPRB, 0.38158521E-03_JPRB, 0.38147292E-03_JPRB, 0.38135288E-03_JPRB, 0.38129159E-03_JPRB, 0.38132323E-03_JPRB, &
  & 0.38148875E-03_JPRB, 0.38144709E-03_JPRB, 0.38137340E-03_JPRB, 0.38146411E-03_JPRB  /)

RGHG1(:,63, 9) = (/ &
  & 0.38442065E-03_JPRB, 0.38414885E-03_JPRB, 0.38415380E-03_JPRB, 0.38411764E-03_JPRB, 0.38395631E-03_JPRB, 0.38391025E-03_JPRB, &
  & 0.38404862E-03_JPRB, 0.38394800E-03_JPRB, 0.38382750E-03_JPRB, 0.38351030E-03_JPRB, 0.38319599E-03_JPRB, 0.38294664E-03_JPRB, &
  & 0.38282229E-03_JPRB, 0.38267891E-03_JPRB, 0.38250837E-03_JPRB, 0.38236572E-03_JPRB, 0.38226962E-03_JPRB, 0.38215587E-03_JPRB, &
  & 0.38200270E-03_JPRB, 0.38187708E-03_JPRB, 0.38179635E-03_JPRB, 0.38169006E-03_JPRB, 0.38161229E-03_JPRB, 0.38156874E-03_JPRB, &
  & 0.38155336E-03_JPRB, 0.38176718E-03_JPRB, 0.38214011E-03_JPRB, 0.38254340E-03_JPRB, 0.38325063E-03_JPRB, 0.38375226E-03_JPRB, &
  & 0.38389109E-03_JPRB, 0.38404420E-03_JPRB, 0.38430458E-03_JPRB, 0.38466381E-03_JPRB, 0.38481404E-03_JPRB, 0.38455248E-03_JPRB, &
  & 0.38411910E-03_JPRB, 0.38352419E-03_JPRB, 0.38278913E-03_JPRB, 0.38210823E-03_JPRB, 0.38166413E-03_JPRB, 0.38119633E-03_JPRB, &
  & 0.38089733E-03_JPRB, 0.38067170E-03_JPRB, 0.38052208E-03_JPRB, 0.38056015E-03_JPRB, 0.38065868E-03_JPRB, 0.38066658E-03_JPRB, &
  & 0.38067764E-03_JPRB, 0.38077864E-03_JPRB, 0.38088397E-03_JPRB, 0.38096769E-03_JPRB, 0.38112971E-03_JPRB, 0.38138293E-03_JPRB, &
  & 0.38154165E-03_JPRB, 0.38163267E-03_JPRB, 0.38151545E-03_JPRB, 0.38139086E-03_JPRB, 0.38136849E-03_JPRB, 0.38145433E-03_JPRB, &
  & 0.38165264E-03_JPRB, 0.38165846E-03_JPRB, 0.38164354E-03_JPRB, 0.38173192E-03_JPRB  /)

RGHG1(:,64, 9) = (/ &
  & 0.38484869E-03_JPRB, 0.38459775E-03_JPRB, 0.38461077E-03_JPRB, 0.38453442E-03_JPRB, 0.38435958E-03_JPRB, 0.38430970E-03_JPRB, &
  & 0.38438972E-03_JPRB, 0.38427840E-03_JPRB, 0.38416132E-03_JPRB, 0.38384966E-03_JPRB, 0.38354881E-03_JPRB, 0.38329783E-03_JPRB, &
  & 0.38312948E-03_JPRB, 0.38296552E-03_JPRB, 0.38275019E-03_JPRB, 0.38255300E-03_JPRB, 0.38240679E-03_JPRB, 0.38226551E-03_JPRB, &
  & 0.38208735E-03_JPRB, 0.38192153E-03_JPRB, 0.38179826E-03_JPRB, 0.38163652E-03_JPRB, 0.38156503E-03_JPRB, 0.38156683E-03_JPRB, &
  & 0.38157085E-03_JPRB, 0.38178529E-03_JPRB, 0.38219880E-03_JPRB, 0.38262715E-03_JPRB, 0.38335546E-03_JPRB, 0.38387255E-03_JPRB, &
  & 0.38406705E-03_JPRB, 0.38425738E-03_JPRB, 0.38451647E-03_JPRB, 0.38479307E-03_JPRB, 0.38481667E-03_JPRB, 0.38448701E-03_JPRB, &
  & 0.38406640E-03_JPRB, 0.38352906E-03_JPRB, 0.38282629E-03_JPRB, 0.38218301E-03_JPRB, 0.38177765E-03_JPRB, 0.38130060E-03_JPRB, &
  & 0.38097110E-03_JPRB, 0.38071941E-03_JPRB, 0.38056176E-03_JPRB, 0.38058717E-03_JPRB, 0.38066513E-03_JPRB, 0.38065694E-03_JPRB, &
  & 0.38069586E-03_JPRB, 0.38080230E-03_JPRB, 0.38090791E-03_JPRB, 0.38100878E-03_JPRB, 0.38118907E-03_JPRB, 0.38146045E-03_JPRB, &
  & 0.38161760E-03_JPRB, 0.38172219E-03_JPRB, 0.38158878E-03_JPRB, 0.38147645E-03_JPRB, 0.38149748E-03_JPRB, 0.38163186E-03_JPRB, &
  & 0.38185052E-03_JPRB, 0.38192349E-03_JPRB, 0.38199647E-03_JPRB, 0.38208238E-03_JPRB  /)

RGHG1(:,65, 9) = (/ &
  & 0.38518666E-03_JPRB, 0.38497771E-03_JPRB, 0.38499061E-03_JPRB, 0.38489020E-03_JPRB, 0.38469069E-03_JPRB, 0.38464532E-03_JPRB, &
  & 0.38468594E-03_JPRB, 0.38456561E-03_JPRB, 0.38445870E-03_JPRB, 0.38415791E-03_JPRB, 0.38386185E-03_JPRB, 0.38360183E-03_JPRB, &
  & 0.38339946E-03_JPRB, 0.38322046E-03_JPRB, 0.38297206E-03_JPRB, 0.38273613E-03_JPRB, 0.38255602E-03_JPRB, 0.38239295E-03_JPRB, &
  & 0.38220164E-03_JPRB, 0.38200827E-03_JPRB, 0.38185084E-03_JPRB, 0.38165260E-03_JPRB, 0.38156448E-03_JPRB, 0.38158187E-03_JPRB, &
  & 0.38162046E-03_JPRB, 0.38181908E-03_JPRB, 0.38227057E-03_JPRB, 0.38274446E-03_JPRB, 0.38347590E-03_JPRB, 0.38401193E-03_JPRB, &
  & 0.38427571E-03_JPRB, 0.38447329E-03_JPRB, 0.38469805E-03_JPRB, 0.38489176E-03_JPRB, 0.38480926E-03_JPRB, 0.38443340E-03_JPRB, &
  & 0.38403454E-03_JPRB, 0.38355657E-03_JPRB, 0.38290219E-03_JPRB, 0.38232040E-03_JPRB, 0.38192547E-03_JPRB, 0.38144207E-03_JPRB, &
  & 0.38110038E-03_JPRB, 0.38082205E-03_JPRB, 0.38065069E-03_JPRB, 0.38066021E-03_JPRB, 0.38072067E-03_JPRB, 0.38070196E-03_JPRB, &
  & 0.38076926E-03_JPRB, 0.38088285E-03_JPRB, 0.38099584E-03_JPRB, 0.38110903E-03_JPRB, 0.38130774E-03_JPRB, 0.38158860E-03_JPRB, &
  & 0.38174193E-03_JPRB, 0.38185023E-03_JPRB, 0.38170262E-03_JPRB, 0.38161535E-03_JPRB, 0.38168035E-03_JPRB, 0.38184184E-03_JPRB, &
  & 0.38208111E-03_JPRB, 0.38221700E-03_JPRB, 0.38237088E-03_JPRB, 0.38245973E-03_JPRB  /)

RGHG1(:,66, 9) = (/ &
  & 0.38548489E-03_JPRB, 0.38531963E-03_JPRB, 0.38532644E-03_JPRB, 0.38521512E-03_JPRB, 0.38499304E-03_JPRB, 0.38494752E-03_JPRB, &
  & 0.38496625E-03_JPRB, 0.38483875E-03_JPRB, 0.38474175E-03_JPRB, 0.38445353E-03_JPRB, 0.38415716E-03_JPRB, 0.38389020E-03_JPRB, &
  & 0.38365893E-03_JPRB, 0.38346417E-03_JPRB, 0.38318788E-03_JPRB, 0.38292350E-03_JPRB, 0.38271377E-03_JPRB, 0.38252877E-03_JPRB, &
  & 0.38232902E-03_JPRB, 0.38212284E-03_JPRB, 0.38194129E-03_JPRB, 0.38172118E-03_JPRB, 0.38161397E-03_JPRB, 0.38162184E-03_JPRB, &
  & 0.38169354E-03_JPRB, 0.38189013E-03_JPRB, 0.38235957E-03_JPRB, 0.38287548E-03_JPRB, 0.38359945E-03_JPRB, 0.38415193E-03_JPRB, &
  & 0.38447163E-03_JPRB, 0.38467296E-03_JPRB, 0.38485149E-03_JPRB, 0.38497108E-03_JPRB, 0.38480441E-03_JPRB, 0.38439380E-03_JPRB, &
  & 0.38401699E-03_JPRB, 0.38359050E-03_JPRB, 0.38300453E-03_JPRB, 0.38248257E-03_JPRB, 0.38208315E-03_JPRB, 0.38160494E-03_JPRB, &
  & 0.38126254E-03_JPRB, 0.38095726E-03_JPRB, 0.38077143E-03_JPRB, 0.38076626E-03_JPRB, 0.38080948E-03_JPRB, 0.38079135E-03_JPRB, &
  & 0.38088264E-03_JPRB, 0.38100224E-03_JPRB, 0.38112446E-03_JPRB, 0.38125083E-03_JPRB, 0.38146374E-03_JPRB, 0.38174596E-03_JPRB, &
  & 0.38189519E-03_JPRB, 0.38200180E-03_JPRB, 0.38185064E-03_JPRB, 0.38179227E-03_JPRB, 0.38188767E-03_JPRB, 0.38206536E-03_JPRB, &
  & 0.38232854E-03_JPRB, 0.38252154E-03_JPRB, 0.38273935E-03_JPRB, 0.38283854E-03_JPRB  /)

RGHG1(:,67, 9) = (/ &
  & 0.38574785E-03_JPRB, 0.38562234E-03_JPRB, 0.38561861E-03_JPRB, 0.38550751E-03_JPRB, 0.38526830E-03_JPRB, 0.38521671E-03_JPRB, &
  & 0.38522862E-03_JPRB, 0.38509835E-03_JPRB, 0.38501023E-03_JPRB, 0.38473489E-03_JPRB, 0.38443528E-03_JPRB, 0.38416469E-03_JPRB, &
  & 0.38391104E-03_JPRB, 0.38369859E-03_JPRB, 0.38339903E-03_JPRB, 0.38311325E-03_JPRB, 0.38287764E-03_JPRB, 0.38267066E-03_JPRB, &
  & 0.38246785E-03_JPRB, 0.38226265E-03_JPRB, 0.38206795E-03_JPRB, 0.38183921E-03_JPRB, 0.38171438E-03_JPRB, 0.38169730E-03_JPRB, &
  & 0.38179727E-03_JPRB, 0.38200624E-03_JPRB, 0.38247256E-03_JPRB, 0.38301906E-03_JPRB, 0.38372428E-03_JPRB, 0.38428515E-03_JPRB, &
  & 0.38464321E-03_JPRB, 0.38484509E-03_JPRB, 0.38497608E-03_JPRB, 0.38503475E-03_JPRB, 0.38480616E-03_JPRB, 0.38436981E-03_JPRB, &
  & 0.38401402E-03_JPRB, 0.38363207E-03_JPRB, 0.38312911E-03_JPRB, 0.38265823E-03_JPRB, 0.38224714E-03_JPRB, 0.38178626E-03_JPRB, &
  & 0.38145035E-03_JPRB, 0.38111990E-03_JPRB, 0.38091839E-03_JPRB, 0.38090143E-03_JPRB, 0.38092940E-03_JPRB, 0.38092254E-03_JPRB, &
  & 0.38103187E-03_JPRB, 0.38115498E-03_JPRB, 0.38128737E-03_JPRB, 0.38142798E-03_JPRB, 0.38165019E-03_JPRB, 0.38192717E-03_JPRB, &
  & 0.38207232E-03_JPRB, 0.38217315E-03_JPRB, 0.38202991E-03_JPRB, 0.38200294E-03_JPRB, 0.38211352E-03_JPRB, 0.38229754E-03_JPRB, &
  & 0.38258326E-03_JPRB, 0.38282984E-03_JPRB, 0.38309201E-03_JPRB, 0.38320047E-03_JPRB  /)

RGHG1(:,68, 9) = (/ &
  & 0.38598085E-03_JPRB, 0.38588349E-03_JPRB, 0.38586779E-03_JPRB, 0.38576353E-03_JPRB, 0.38551679E-03_JPRB, 0.38545328E-03_JPRB, &
  & 0.38546755E-03_JPRB, 0.38534407E-03_JPRB, 0.38526378E-03_JPRB, 0.38499944E-03_JPRB, 0.38469781E-03_JPRB, 0.38442739E-03_JPRB, &
  & 0.38416125E-03_JPRB, 0.38392767E-03_JPRB, 0.38360890E-03_JPRB, 0.38330222E-03_JPRB, 0.38304509E-03_JPRB, 0.38281709E-03_JPRB, &
  & 0.38261917E-03_JPRB, 0.38242549E-03_JPRB, 0.38222957E-03_JPRB, 0.38200239E-03_JPRB, 0.38186565E-03_JPRB, 0.38182889E-03_JPRB, &
  & 0.38194889E-03_JPRB, 0.38217943E-03_JPRB, 0.38262371E-03_JPRB, 0.38317799E-03_JPRB, 0.38385056E-03_JPRB, 0.38440124E-03_JPRB, &
  & 0.38477784E-03_JPRB, 0.38497259E-03_JPRB, 0.38507306E-03_JPRB, 0.38509041E-03_JPRB, 0.38482049E-03_JPRB, 0.38436336E-03_JPRB, &
  & 0.38402674E-03_JPRB, 0.38368727E-03_JPRB, 0.38326978E-03_JPRB, 0.38283188E-03_JPRB, 0.38241648E-03_JPRB, 0.38198432E-03_JPRB, &
  & 0.38165377E-03_JPRB, 0.38130398E-03_JPRB, 0.38108353E-03_JPRB, 0.38106006E-03_JPRB, 0.38107889E-03_JPRB, 0.38109154E-03_JPRB, &
  & 0.38121111E-03_JPRB, 0.38133302E-03_JPRB, 0.38147565E-03_JPRB, 0.38163105E-03_JPRB, 0.38185734E-03_JPRB, 0.38212604E-03_JPRB, &
  & 0.38226733E-03_JPRB, 0.38236034E-03_JPRB, 0.38223614E-03_JPRB, 0.38224222E-03_JPRB, 0.38235297E-03_JPRB, 0.38253423E-03_JPRB, &
  & 0.38283070E-03_JPRB, 0.38313352E-03_JPRB, 0.38341843E-03_JPRB, 0.38351635E-03_JPRB  /)

RGHG1(:,69, 9) = (/ &
  & 0.38618908E-03_JPRB, 0.38609739E-03_JPRB, 0.38608056E-03_JPRB, 0.38597970E-03_JPRB, 0.38572987E-03_JPRB, 0.38565801E-03_JPRB, &
  & 0.38568139E-03_JPRB, 0.38557314E-03_JPRB, 0.38550277E-03_JPRB, 0.38524376E-03_JPRB, 0.38495060E-03_JPRB, 0.38467878E-03_JPRB, &
  & 0.38440963E-03_JPRB, 0.38415735E-03_JPRB, 0.38382516E-03_JPRB, 0.38349870E-03_JPRB, 0.38321857E-03_JPRB, 0.38297979E-03_JPRB, &
  & 0.38277843E-03_JPRB, 0.38259861E-03_JPRB, 0.38240862E-03_JPRB, 0.38218843E-03_JPRB, 0.38205744E-03_JPRB, 0.38202195E-03_JPRB, &
  & 0.38214626E-03_JPRB, 0.38239477E-03_JPRB, 0.38281140E-03_JPRB, 0.38335626E-03_JPRB, 0.38397740E-03_JPRB, 0.38451224E-03_JPRB, &
  & 0.38488023E-03_JPRB, 0.38506024E-03_JPRB, 0.38515662E-03_JPRB, 0.38514889E-03_JPRB, 0.38484928E-03_JPRB, 0.38437499E-03_JPRB, &
  & 0.38405004E-03_JPRB, 0.38375047E-03_JPRB, 0.38338523E-03_JPRB, 0.38297643E-03_JPRB, 0.38257437E-03_JPRB, 0.38217496E-03_JPRB, &
  & 0.38184845E-03_JPRB, 0.38149074E-03_JPRB, 0.38125315E-03_JPRB, 0.38123391E-03_JPRB, 0.38124966E-03_JPRB, 0.38128156E-03_JPRB, &
  & 0.38140756E-03_JPRB, 0.38152217E-03_JPRB, 0.38166992E-03_JPRB, 0.38184472E-03_JPRB, 0.38207358E-03_JPRB, 0.38233320E-03_JPRB, &
  & 0.38247430E-03_JPRB, 0.38255770E-03_JPRB, 0.38245701E-03_JPRB, 0.38249224E-03_JPRB, 0.38259222E-03_JPRB, 0.38277616E-03_JPRB, &
  & 0.38306695E-03_JPRB, 0.38341845E-03_JPRB, 0.38371530E-03_JPRB, 0.38378503E-03_JPRB  /)

RGHG1(:,70, 9) = (/ &
  & 0.38637080E-03_JPRB, 0.38627906E-03_JPRB, 0.38626813E-03_JPRB, 0.38616808E-03_JPRB, 0.38591777E-03_JPRB, 0.38584355E-03_JPRB, &
  & 0.38587841E-03_JPRB, 0.38578969E-03_JPRB, 0.38572877E-03_JPRB, 0.38547271E-03_JPRB, 0.38519327E-03_JPRB, 0.38491792E-03_JPRB, &
  & 0.38464954E-03_JPRB, 0.38438587E-03_JPRB, 0.38404715E-03_JPRB, 0.38370099E-03_JPRB, 0.38340090E-03_JPRB, 0.38315445E-03_JPRB, &
  & 0.38294338E-03_JPRB, 0.38277116E-03_JPRB, 0.38259415E-03_JPRB, 0.38238514E-03_JPRB, 0.38227187E-03_JPRB, 0.38224394E-03_JPRB, &
  & 0.38236018E-03_JPRB, 0.38261393E-03_JPRB, 0.38300240E-03_JPRB, 0.38352667E-03_JPRB, 0.38409104E-03_JPRB, 0.38460392E-03_JPRB, &
  & 0.38495800E-03_JPRB, 0.38511819E-03_JPRB, 0.38523036E-03_JPRB, 0.38520789E-03_JPRB, 0.38488728E-03_JPRB, 0.38439819E-03_JPRB, &
  & 0.38407380E-03_JPRB, 0.38380061E-03_JPRB, 0.38347602E-03_JPRB, 0.38310000E-03_JPRB, 0.38271746E-03_JPRB, 0.38234849E-03_JPRB, &
  & 0.38202326E-03_JPRB, 0.38166397E-03_JPRB, 0.38142328E-03_JPRB, 0.38141433E-03_JPRB, 0.38143041E-03_JPRB, 0.38147933E-03_JPRB, &
  & 0.38160723E-03_JPRB, 0.38170930E-03_JPRB, 0.38186005E-03_JPRB, 0.38205792E-03_JPRB, 0.38229041E-03_JPRB, 0.38254173E-03_JPRB, &
  & 0.38268217E-03_JPRB, 0.38275323E-03_JPRB, 0.38267655E-03_JPRB, 0.38272841E-03_JPRB, 0.38281801E-03_JPRB, 0.38301241E-03_JPRB, &
  & 0.38329748E-03_JPRB, 0.38368159E-03_JPRB, 0.38398827E-03_JPRB, 0.38403936E-03_JPRB  /)

RGHG1(:,71, 9) = (/ &
  & 0.38652327E-03_JPRB, 0.38643246E-03_JPRB, 0.38643205E-03_JPRB, 0.38633067E-03_JPRB, 0.38608302E-03_JPRB, 0.38601187E-03_JPRB, &
  & 0.38605930E-03_JPRB, 0.38599352E-03_JPRB, 0.38594062E-03_JPRB, 0.38568675E-03_JPRB, 0.38542340E-03_JPRB, 0.38514254E-03_JPRB, &
  & 0.38487812E-03_JPRB, 0.38461118E-03_JPRB, 0.38427138E-03_JPRB, 0.38390752E-03_JPRB, 0.38359288E-03_JPRB, 0.38333960E-03_JPRB, &
  & 0.38311275E-03_JPRB, 0.38294172E-03_JPRB, 0.38278219E-03_JPRB, 0.38258651E-03_JPRB, 0.38249737E-03_JPRB, 0.38248138E-03_JPRB, &
  & 0.38257956E-03_JPRB, 0.38282901E-03_JPRB, 0.38318704E-03_JPRB, 0.38367839E-03_JPRB, 0.38418754E-03_JPRB, 0.38467599E-03_JPRB, &
  & 0.38501149E-03_JPRB, 0.38514862E-03_JPRB, 0.38529013E-03_JPRB, 0.38526315E-03_JPRB, 0.38493028E-03_JPRB, 0.38442948E-03_JPRB, &
  & 0.38409690E-03_JPRB, 0.38383725E-03_JPRB, 0.38354387E-03_JPRB, 0.38320419E-03_JPRB, 0.38284394E-03_JPRB, 0.38250179E-03_JPRB, &
  & 0.38217788E-03_JPRB, 0.38182136E-03_JPRB, 0.38159481E-03_JPRB, 0.38159981E-03_JPRB, 0.38161716E-03_JPRB, 0.38167830E-03_JPRB, &
  & 0.38180583E-03_JPRB, 0.38189295E-03_JPRB, 0.38204533E-03_JPRB, 0.38226683E-03_JPRB, 0.38250411E-03_JPRB, 0.38274919E-03_JPRB, &
  & 0.38288628E-03_JPRB, 0.38294544E-03_JPRB, 0.38289103E-03_JPRB, 0.38294861E-03_JPRB, 0.38302851E-03_JPRB, 0.38323852E-03_JPRB, &
  & 0.38352375E-03_JPRB, 0.38392555E-03_JPRB, 0.38424228E-03_JPRB, 0.38428471E-03_JPRB  /)

RGHG1(:,72, 9) = (/ &
  & 0.38664138E-03_JPRB, 0.38656198E-03_JPRB, 0.38657304E-03_JPRB, 0.38646878E-03_JPRB, 0.38622845E-03_JPRB, 0.38616432E-03_JPRB, &
  & 0.38622397E-03_JPRB, 0.38618383E-03_JPRB, 0.38613623E-03_JPRB, 0.38588628E-03_JPRB, 0.38563693E-03_JPRB, 0.38534893E-03_JPRB, &
  & 0.38509182E-03_JPRB, 0.38483041E-03_JPRB, 0.38449217E-03_JPRB, 0.38411644E-03_JPRB, 0.38379644E-03_JPRB, 0.38353424E-03_JPRB, &
  & 0.38328531E-03_JPRB, 0.38311042E-03_JPRB, 0.38296807E-03_JPRB, 0.38278436E-03_JPRB, 0.38271631E-03_JPRB, 0.38271623E-03_JPRB, &
  & 0.38278998E-03_JPRB, 0.38303349E-03_JPRB, 0.38335407E-03_JPRB, 0.38379628E-03_JPRB, 0.38426215E-03_JPRB, 0.38473066E-03_JPRB, &
  & 0.38503938E-03_JPRB, 0.38515311E-03_JPRB, 0.38532701E-03_JPRB, 0.38530694E-03_JPRB, 0.38497147E-03_JPRB, 0.38446376E-03_JPRB, &
  & 0.38411943E-03_JPRB, 0.38386381E-03_JPRB, 0.38359175E-03_JPRB, 0.38329027E-03_JPRB, 0.38295105E-03_JPRB, 0.38263091E-03_JPRB, &
  & 0.38231414E-03_JPRB, 0.38196212E-03_JPRB, 0.38177100E-03_JPRB, 0.38179006E-03_JPRB, 0.38180545E-03_JPRB, 0.38186935E-03_JPRB, &
  & 0.38199867E-03_JPRB, 0.38207376E-03_JPRB, 0.38222711E-03_JPRB, 0.38246705E-03_JPRB, 0.38270998E-03_JPRB, 0.38295303E-03_JPRB, &
  & 0.38308063E-03_JPRB, 0.38313472E-03_JPRB, 0.38309724E-03_JPRB, 0.38315442E-03_JPRB, 0.38322337E-03_JPRB, 0.38344876E-03_JPRB, &
  & 0.38374817E-03_JPRB, 0.38415648E-03_JPRB, 0.38448624E-03_JPRB, 0.38452526E-03_JPRB  /)

RGHG1(:,73, 9) = (/ &
  & 0.38673184E-03_JPRB, 0.38667306E-03_JPRB, 0.38668843E-03_JPRB, 0.38658111E-03_JPRB, 0.38635958E-03_JPRB, 0.38630007E-03_JPRB, &
  & 0.38637104E-03_JPRB, 0.38635615E-03_JPRB, 0.38630923E-03_JPRB, 0.38606697E-03_JPRB, 0.38582426E-03_JPRB, 0.38553876E-03_JPRB, &
  & 0.38528692E-03_JPRB, 0.38503231E-03_JPRB, 0.38470579E-03_JPRB, 0.38433278E-03_JPRB, 0.38401284E-03_JPRB, 0.38375353E-03_JPRB, &
  & 0.38348823E-03_JPRB, 0.38330636E-03_JPRB, 0.38317545E-03_JPRB, 0.38299856E-03_JPRB, 0.38293316E-03_JPRB, 0.38295164E-03_JPRB, &
  & 0.38300376E-03_JPRB, 0.38322922E-03_JPRB, 0.38350929E-03_JPRB, 0.38388955E-03_JPRB, 0.38431726E-03_JPRB, 0.38477465E-03_JPRB, &
  & 0.38505529E-03_JPRB, 0.38513255E-03_JPRB, 0.38532506E-03_JPRB, 0.38532526E-03_JPRB, 0.38499628E-03_JPRB, 0.38448915E-03_JPRB, &
  & 0.38413760E-03_JPRB, 0.38388903E-03_JPRB, 0.38361873E-03_JPRB, 0.38334011E-03_JPRB, 0.38303322E-03_JPRB, 0.38274736E-03_JPRB, &
  & 0.38245056E-03_JPRB, 0.38210690E-03_JPRB, 0.38196047E-03_JPRB, 0.38198516E-03_JPRB, 0.38199056E-03_JPRB, 0.38205136E-03_JPRB, &
  & 0.38218948E-03_JPRB, 0.38225486E-03_JPRB, 0.38241027E-03_JPRB, 0.38264908E-03_JPRB, 0.38290870E-03_JPRB, 0.38314657E-03_JPRB, &
  & 0.38326674E-03_JPRB, 0.38333156E-03_JPRB, 0.38329706E-03_JPRB, 0.38335415E-03_JPRB, 0.38340508E-03_JPRB, 0.38364755E-03_JPRB, &
  & 0.38396491E-03_JPRB, 0.38437790E-03_JPRB, 0.38469636E-03_JPRB, 0.38472801E-03_JPRB  /)

RGHG1(:,74, 9) = (/ &
  & 0.38681104E-03_JPRB, 0.38677189E-03_JPRB, 0.38678568E-03_JPRB, 0.38667445E-03_JPRB, 0.38648183E-03_JPRB, 0.38642442E-03_JPRB, &
  & 0.38650481E-03_JPRB, 0.38651206E-03_JPRB, 0.38646616E-03_JPRB, 0.38623443E-03_JPRB, 0.38599684E-03_JPRB, 0.38571704E-03_JPRB, &
  & 0.38547086E-03_JPRB, 0.38522515E-03_JPRB, 0.38491235E-03_JPRB, 0.38455278E-03_JPRB, 0.38424202E-03_JPRB, 0.38398715E-03_JPRB, &
  & 0.38371590E-03_JPRB, 0.38353013E-03_JPRB, 0.38340891E-03_JPRB, 0.38324371E-03_JPRB, 0.38317089E-03_JPRB, 0.38319046E-03_JPRB, &
  & 0.38322562E-03_JPRB, 0.38342093E-03_JPRB, 0.38365872E-03_JPRB, 0.38398045E-03_JPRB, 0.38436244E-03_JPRB, 0.38480157E-03_JPRB, &
  & 0.38505748E-03_JPRB, 0.38509147E-03_JPRB, 0.38529525E-03_JPRB, 0.38531981E-03_JPRB, 0.38500813E-03_JPRB, 0.38450361E-03_JPRB, &
  & 0.38414856E-03_JPRB, 0.38390777E-03_JPRB, 0.38363390E-03_JPRB, 0.38336385E-03_JPRB, 0.38309898E-03_JPRB, 0.38286254E-03_JPRB, &
  & 0.38259328E-03_JPRB, 0.38226551E-03_JPRB, 0.38215658E-03_JPRB, 0.38217788E-03_JPRB, 0.38217235E-03_JPRB, 0.38222883E-03_JPRB, &
  & 0.38237431E-03_JPRB, 0.38244216E-03_JPRB, 0.38259380E-03_JPRB, 0.38282774E-03_JPRB, 0.38311074E-03_JPRB, 0.38334324E-03_JPRB, &
  & 0.38345673E-03_JPRB, 0.38353098E-03_JPRB, 0.38349825E-03_JPRB, 0.38355952E-03_JPRB, 0.38358776E-03_JPRB, 0.38384371E-03_JPRB, &
  & 0.38416862E-03_JPRB, 0.38458526E-03_JPRB, 0.38488769E-03_JPRB, 0.38491070E-03_JPRB  /)

RGHG1(:,75, 9) = (/ &
  & 0.38688300E-03_JPRB, 0.38685972E-03_JPRB, 0.38686690E-03_JPRB, 0.38675065E-03_JPRB, 0.38659470E-03_JPRB, 0.38653851E-03_JPRB, &
  & 0.38662518E-03_JPRB, 0.38665023E-03_JPRB, 0.38660633E-03_JPRB, 0.38638822E-03_JPRB, 0.38615487E-03_JPRB, 0.38588234E-03_JPRB, &
  & 0.38564214E-03_JPRB, 0.38540597E-03_JPRB, 0.38510865E-03_JPRB, 0.38476975E-03_JPRB, 0.38447504E-03_JPRB, 0.38422842E-03_JPRB, &
  & 0.38395583E-03_JPRB, 0.38376692E-03_JPRB, 0.38365403E-03_JPRB, 0.38350388E-03_JPRB, 0.38341700E-03_JPRB, 0.38341818E-03_JPRB, &
  & 0.38343645E-03_JPRB, 0.38359251E-03_JPRB, 0.38379052E-03_JPRB, 0.38406341E-03_JPRB, 0.38439617E-03_JPRB, 0.38481347E-03_JPRB, &
  & 0.38504781E-03_JPRB, 0.38503519E-03_JPRB, 0.38524245E-03_JPRB, 0.38529368E-03_JPRB, 0.38501053E-03_JPRB, 0.38450721E-03_JPRB, &
  & 0.38415237E-03_JPRB, 0.38392442E-03_JPRB, 0.38364303E-03_JPRB, 0.38337279E-03_JPRB, 0.38315574E-03_JPRB, 0.38297626E-03_JPRB, &
  & 0.38273916E-03_JPRB, 0.38243468E-03_JPRB, 0.38234879E-03_JPRB, 0.38235915E-03_JPRB, 0.38234677E-03_JPRB, 0.38239869E-03_JPRB, &
  & 0.38254966E-03_JPRB, 0.38262808E-03_JPRB, 0.38277531E-03_JPRB, 0.38300599E-03_JPRB, 0.38331598E-03_JPRB, 0.38354933E-03_JPRB, &
  & 0.38365658E-03_JPRB, 0.38373454E-03_JPRB, 0.38370359E-03_JPRB, 0.38376262E-03_JPRB, 0.38376853E-03_JPRB, 0.38403491E-03_JPRB, &
  & 0.38435864E-03_JPRB, 0.38477673E-03_JPRB, 0.38506469E-03_JPRB, 0.38508164E-03_JPRB  /)

RGHG1(:,76, 9) = (/ &
  & 0.38695176E-03_JPRB, 0.38693764E-03_JPRB, 0.38693421E-03_JPRB, 0.38681146E-03_JPRB, 0.38669677E-03_JPRB, 0.38664346E-03_JPRB, &
  & 0.38673133E-03_JPRB, 0.38676832E-03_JPRB, 0.38672770E-03_JPRB, 0.38652694E-03_JPRB, 0.38629711E-03_JPRB, 0.38603184E-03_JPRB, &
  & 0.38579751E-03_JPRB, 0.38556907E-03_JPRB, 0.38528990E-03_JPRB, 0.38497416E-03_JPRB, 0.38469848E-03_JPRB, 0.38446915E-03_JPRB, &
  & 0.38419005E-03_JPRB, 0.38399416E-03_JPRB, 0.38388824E-03_JPRB, 0.38375273E-03_JPRB, 0.38364919E-03_JPRB, 0.38361176E-03_JPRB, &
  & 0.38360554E-03_JPRB, 0.38371768E-03_JPRB, 0.38388498E-03_JPRB, 0.38412646E-03_JPRB, 0.38441438E-03_JPRB, 0.38481416E-03_JPRB, &
  & 0.38502919E-03_JPRB, 0.38497099E-03_JPRB, 0.38517208E-03_JPRB, 0.38525092E-03_JPRB, 0.38500834E-03_JPRB, 0.38450012E-03_JPRB, &
  & 0.38414938E-03_JPRB, 0.38394667E-03_JPRB, 0.38365381E-03_JPRB, 0.38338305E-03_JPRB, 0.38321401E-03_JPRB, 0.38308680E-03_JPRB, &
  & 0.38288283E-03_JPRB, 0.38260855E-03_JPRB, 0.38252174E-03_JPRB, 0.38251585E-03_JPRB, 0.38250773E-03_JPRB, 0.38255574E-03_JPRB, &
  & 0.38271079E-03_JPRB, 0.38280022E-03_JPRB, 0.38295160E-03_JPRB, 0.38318683E-03_JPRB, 0.38352334E-03_JPRB, 0.38377362E-03_JPRB, &
  & 0.38387482E-03_JPRB, 0.38394611E-03_JPRB, 0.38391705E-03_JPRB, 0.38394969E-03_JPRB, 0.38394125E-03_JPRB, 0.38421662E-03_JPRB, &
  & 0.38453488E-03_JPRB, 0.38495020E-03_JPRB, 0.38523239E-03_JPRB, 0.38525165E-03_JPRB  /)

RGHG1(:,77, 9) = (/ &
  & 0.38701761E-03_JPRB, 0.38699887E-03_JPRB, 0.38698574E-03_JPRB, 0.38685882E-03_JPRB, 0.38678094E-03_JPRB, 0.38673510E-03_JPRB, &
  & 0.38681683E-03_JPRB, 0.38686164E-03_JPRB, 0.38682702E-03_JPRB, 0.38664480E-03_JPRB, 0.38641498E-03_JPRB, 0.38615602E-03_JPRB, &
  & 0.38591741E-03_JPRB, 0.38569458E-03_JPRB, 0.38542972E-03_JPRB, 0.38514247E-03_JPRB, 0.38489012E-03_JPRB, 0.38467173E-03_JPRB, &
  & 0.38440975E-03_JPRB, 0.38419454E-03_JPRB, 0.38407551E-03_JPRB, 0.38394171E-03_JPRB, 0.38381635E-03_JPRB, 0.38374020E-03_JPRB, &
  & 0.38370808E-03_JPRB, 0.38378510E-03_JPRB, 0.38392396E-03_JPRB, 0.38414811E-03_JPRB, 0.38441079E-03_JPRB, 0.38480588E-03_JPRB, &
  & 0.38500760E-03_JPRB, 0.38492067E-03_JPRB, 0.38510670E-03_JPRB, 0.38520682E-03_JPRB, 0.38500324E-03_JPRB, 0.38448628E-03_JPRB, &
  & 0.38413697E-03_JPRB, 0.38396175E-03_JPRB, 0.38366724E-03_JPRB, 0.38339013E-03_JPRB, 0.38324633E-03_JPRB, 0.38316204E-03_JPRB, &
  & 0.38299119E-03_JPRB, 0.38274882E-03_JPRB, 0.38265325E-03_JPRB, 0.38263304E-03_JPRB, 0.38263097E-03_JPRB, 0.38266723E-03_JPRB, &
  & 0.38283537E-03_JPRB, 0.38293502E-03_JPRB, 0.38310984E-03_JPRB, 0.38335646E-03_JPRB, 0.38371186E-03_JPRB, 0.38398222E-03_JPRB, &
  & 0.38408604E-03_JPRB, 0.38414273E-03_JPRB, 0.38411527E-03_JPRB, 0.38411110E-03_JPRB, 0.38410063E-03_JPRB, 0.38437581E-03_JPRB, &
  & 0.38468524E-03_JPRB, 0.38510314E-03_JPRB, 0.38538303E-03_JPRB, 0.38537131E-03_JPRB  /)

RGHG1(:,78, 9) = (/ &
  & 0.38707144E-03_JPRB, 0.38704475E-03_JPRB, 0.38702567E-03_JPRB, 0.38689863E-03_JPRB, 0.38684994E-03_JPRB, 0.38681368E-03_JPRB, &
  & 0.38688788E-03_JPRB, 0.38693667E-03_JPRB, 0.38690824E-03_JPRB, 0.38674307E-03_JPRB, 0.38651152E-03_JPRB, 0.38625416E-03_JPRB, &
  & 0.38601452E-03_JPRB, 0.38579027E-03_JPRB, 0.38553382E-03_JPRB, 0.38527480E-03_JPRB, 0.38504422E-03_JPRB, 0.38483412E-03_JPRB, &
  & 0.38457784E-03_JPRB, 0.38435127E-03_JPRB, 0.38421578E-03_JPRB, 0.38408208E-03_JPRB, 0.38394541E-03_JPRB, 0.38384679E-03_JPRB, &
  & 0.38379473E-03_JPRB, 0.38383744E-03_JPRB, 0.38394739E-03_JPRB, 0.38415493E-03_JPRB, 0.38439305E-03_JPRB, 0.38478441E-03_JPRB, &
  & 0.38497549E-03_JPRB, 0.38487587E-03_JPRB, 0.38505211E-03_JPRB, 0.38516969E-03_JPRB, 0.38499673E-03_JPRB, 0.38446818E-03_JPRB, &
  & 0.38411871E-03_JPRB, 0.38397029E-03_JPRB, 0.38367905E-03_JPRB, 0.38339155E-03_JPRB, 0.38326337E-03_JPRB, 0.38321354E-03_JPRB, &
  & 0.38307338E-03_JPRB, 0.38285832E-03_JPRB, 0.38275902E-03_JPRB, 0.38272720E-03_JPRB, 0.38272754E-03_JPRB, 0.38275102E-03_JPRB, &
  & 0.38293223E-03_JPRB, 0.38304347E-03_JPRB, 0.38325860E-03_JPRB, 0.38352038E-03_JPRB, 0.38388934E-03_JPRB, 0.38417867E-03_JPRB, &
  & 0.38428120E-03_JPRB, 0.38433160E-03_JPRB, 0.38429086E-03_JPRB, 0.38424741E-03_JPRB, 0.38423835E-03_JPRB, 0.38450663E-03_JPRB, &
  & 0.38481039E-03_JPRB, 0.38522194E-03_JPRB, 0.38549870E-03_JPRB, 0.38545840E-03_JPRB  /)

RGHG1(:,79, 9) = (/ &
  & 0.38711108E-03_JPRB, 0.38707523E-03_JPRB, 0.38705488E-03_JPRB, 0.38693208E-03_JPRB, 0.38690442E-03_JPRB, 0.38687871E-03_JPRB, &
  & 0.38694543E-03_JPRB, 0.38699460E-03_JPRB, 0.38697077E-03_JPRB, 0.38682047E-03_JPRB, 0.38658634E-03_JPRB, 0.38632748E-03_JPRB, &
  & 0.38608718E-03_JPRB, 0.38585888E-03_JPRB, 0.38560630E-03_JPRB, 0.38537092E-03_JPRB, 0.38515777E-03_JPRB, 0.38495425E-03_JPRB, &
  & 0.38469614E-03_JPRB, 0.38446542E-03_JPRB, 0.38431575E-03_JPRB, 0.38418403E-03_JPRB, 0.38404429E-03_JPRB, 0.38393522E-03_JPRB, &
  & 0.38387023E-03_JPRB, 0.38388206E-03_JPRB, 0.38396523E-03_JPRB, 0.38415555E-03_JPRB, 0.38436724E-03_JPRB, 0.38475579E-03_JPRB, &
  & 0.38494299E-03_JPRB, 0.38483788E-03_JPRB, 0.38500766E-03_JPRB, 0.38514069E-03_JPRB, 0.38498753E-03_JPRB, 0.38444662E-03_JPRB, &
  & 0.38409542E-03_JPRB, 0.38397422E-03_JPRB, 0.38369009E-03_JPRB, 0.38339113E-03_JPRB, 0.38327092E-03_JPRB, 0.38324882E-03_JPRB, &
  & 0.38313680E-03_JPRB, 0.38294502E-03_JPRB, 0.38284697E-03_JPRB, 0.38280771E-03_JPRB, 0.38280753E-03_JPRB, 0.38281803E-03_JPRB, &
  & 0.38301127E-03_JPRB, 0.38313776E-03_JPRB, 0.38339883E-03_JPRB, 0.38367956E-03_JPRB, 0.38405843E-03_JPRB, 0.38436389E-03_JPRB, &
  & 0.38446086E-03_JPRB, 0.38450811E-03_JPRB, 0.38444598E-03_JPRB, 0.38436527E-03_JPRB, 0.38435567E-03_JPRB, 0.38460942E-03_JPRB, &
  & 0.38491067E-03_JPRB, 0.38530809E-03_JPRB, 0.38558225E-03_JPRB, 0.38552354E-03_JPRB  /)

RGHG1(:,80, 9) = (/ &
  & 0.38713511E-03_JPRB, 0.38709063E-03_JPRB, 0.38707439E-03_JPRB, 0.38696033E-03_JPRB, 0.38694533E-03_JPRB, 0.38692996E-03_JPRB, &
  & 0.38699046E-03_JPRB, 0.38703676E-03_JPRB, 0.38701408E-03_JPRB, 0.38687592E-03_JPRB, 0.38663935E-03_JPRB, 0.38637804E-03_JPRB, &
  & 0.38613320E-03_JPRB, 0.38590366E-03_JPRB, 0.38565218E-03_JPRB, 0.38543148E-03_JPRB, 0.38522874E-03_JPRB, 0.38503099E-03_JPRB, &
  & 0.38477023E-03_JPRB, 0.38454021E-03_JPRB, 0.38438380E-03_JPRB, 0.38425912E-03_JPRB, 0.38412068E-03_JPRB, 0.38400704E-03_JPRB, &
  & 0.38393672E-03_JPRB, 0.38392444E-03_JPRB, 0.38398599E-03_JPRB, 0.38415784E-03_JPRB, 0.38433964E-03_JPRB, 0.38472689E-03_JPRB, &
  & 0.38492183E-03_JPRB, 0.38480854E-03_JPRB, 0.38497193E-03_JPRB, 0.38512047E-03_JPRB, 0.38497424E-03_JPRB, 0.38442262E-03_JPRB, &
  & 0.38406803E-03_JPRB, 0.38397578E-03_JPRB, 0.38370158E-03_JPRB, 0.38339333E-03_JPRB, 0.38327498E-03_JPRB, 0.38327584E-03_JPRB, &
  & 0.38318951E-03_JPRB, 0.38301804E-03_JPRB, 0.38292517E-03_JPRB, 0.38288403E-03_JPRB, 0.38288166E-03_JPRB, 0.38287937E-03_JPRB, &
  & 0.38308316E-03_JPRB, 0.38323086E-03_JPRB, 0.38353106E-03_JPRB, 0.38383447E-03_JPRB, 0.38422136E-03_JPRB, 0.38453859E-03_JPRB, &
  & 0.38462635E-03_JPRB, 0.38466659E-03_JPRB, 0.38458371E-03_JPRB, 0.38447235E-03_JPRB, 0.38445494E-03_JPRB, 0.38468549E-03_JPRB, &
  & 0.38498719E-03_JPRB, 0.38536520E-03_JPRB, 0.38563892E-03_JPRB, 0.38557778E-03_JPRB  /)

RGHG1(:,81, 9) = (/ &
  & 0.38713765E-03_JPRB, 0.38709092E-03_JPRB, 0.38708073E-03_JPRB, 0.38697953E-03_JPRB, 0.38696986E-03_JPRB, 0.38696463E-03_JPRB, &
  & 0.38702021E-03_JPRB, 0.38706396E-03_JPRB, 0.38704152E-03_JPRB, 0.38691350E-03_JPRB, 0.38667313E-03_JPRB, 0.38640749E-03_JPRB, &
  & 0.38615797E-03_JPRB, 0.38592565E-03_JPRB, 0.38567428E-03_JPRB, 0.38546064E-03_JPRB, 0.38526257E-03_JPRB, 0.38506785E-03_JPRB, &
  & 0.38481420E-03_JPRB, 0.38458975E-03_JPRB, 0.38443245E-03_JPRB, 0.38431198E-03_JPRB, 0.38418131E-03_JPRB, 0.38407075E-03_JPRB, &
  & 0.38399479E-03_JPRB, 0.38397108E-03_JPRB, 0.38402309E-03_JPRB, 0.38418012E-03_JPRB, 0.38433413E-03_JPRB, 0.38473768E-03_JPRB, &
  & 0.38492728E-03_JPRB, 0.38478862E-03_JPRB, 0.38495166E-03_JPRB, 0.38510572E-03_JPRB, 0.38495349E-03_JPRB, 0.38438322E-03_JPRB, &
  & 0.38403538E-03_JPRB, 0.38397702E-03_JPRB, 0.38371255E-03_JPRB, 0.38339866E-03_JPRB, 0.38328031E-03_JPRB, 0.38330500E-03_JPRB, &
  & 0.38323828E-03_JPRB, 0.38308891E-03_JPRB, 0.38300435E-03_JPRB, 0.38296967E-03_JPRB, 0.38296113E-03_JPRB, 0.38296429E-03_JPRB, &
  & 0.38316600E-03_JPRB, 0.38333783E-03_JPRB, 0.38365094E-03_JPRB, 0.38398653E-03_JPRB, 0.38438771E-03_JPRB, 0.38470304E-03_JPRB, &
  & 0.38477420E-03_JPRB, 0.38481237E-03_JPRB, 0.38471006E-03_JPRB, 0.38457138E-03_JPRB, 0.38453708E-03_JPRB, 0.38474375E-03_JPRB, &
  & 0.38502310E-03_JPRB, 0.38537676E-03_JPRB, 0.38566731E-03_JPRB, 0.38563906E-03_JPRB  /)

RGHG1(:,82, 9) = (/ &
  & 0.38712884E-03_JPRB, 0.38708493E-03_JPRB, 0.38708103E-03_JPRB, 0.38698979E-03_JPRB, 0.38698387E-03_JPRB, 0.38699038E-03_JPRB, &
  & 0.38704218E-03_JPRB, 0.38708397E-03_JPRB, 0.38706258E-03_JPRB, 0.38694221E-03_JPRB, 0.38669889E-03_JPRB, 0.38642720E-03_JPRB, &
  & 0.38617193E-03_JPRB, 0.38593761E-03_JPRB, 0.38568673E-03_JPRB, 0.38547944E-03_JPRB, 0.38528595E-03_JPRB, 0.38509488E-03_JPRB, &
  & 0.38484855E-03_JPRB, 0.38463085E-03_JPRB, 0.38447634E-03_JPRB, 0.38435973E-03_JPRB, 0.38423693E-03_JPRB, 0.38412980E-03_JPRB, &
  & 0.38405278E-03_JPRB, 0.38402735E-03_JPRB, 0.38407943E-03_JPRB, 0.38422443E-03_JPRB, 0.38435286E-03_JPRB, 0.38476693E-03_JPRB, &
  & 0.38494736E-03_JPRB, 0.38477182E-03_JPRB, 0.38493545E-03_JPRB, 0.38508897E-03_JPRB, 0.38491819E-03_JPRB, 0.38433295E-03_JPRB, &
  & 0.38399983E-03_JPRB, 0.38397789E-03_JPRB, 0.38372274E-03_JPRB, 0.38341021E-03_JPRB, 0.38329378E-03_JPRB, 0.38333581E-03_JPRB, &
  & 0.38328980E-03_JPRB, 0.38316134E-03_JPRB, 0.38309265E-03_JPRB, 0.38306533E-03_JPRB, 0.38305042E-03_JPRB, 0.38306427E-03_JPRB, &
  & 0.38326355E-03_JPRB, 0.38345211E-03_JPRB, 0.38377435E-03_JPRB, 0.38413506E-03_JPRB, 0.38454977E-03_JPRB, 0.38485550E-03_JPRB, &
  & 0.38490324E-03_JPRB, 0.38494102E-03_JPRB, 0.38482335E-03_JPRB, 0.38466169E-03_JPRB, 0.38460644E-03_JPRB, 0.38479138E-03_JPRB, &
  & 0.38504388E-03_JPRB, 0.38537930E-03_JPRB, 0.38568319E-03_JPRB, 0.38568076E-03_JPRB  /)

RGHG1(:,83, 9) = (/ &
  & 0.38711190E-03_JPRB, 0.38707494E-03_JPRB, 0.38707775E-03_JPRB, 0.38699347E-03_JPRB, 0.38698982E-03_JPRB, 0.38700869E-03_JPRB, &
  & 0.38705875E-03_JPRB, 0.38709907E-03_JPRB, 0.38707852E-03_JPRB, 0.38696375E-03_JPRB, 0.38671761E-03_JPRB, 0.38643858E-03_JPRB, &
  & 0.38617865E-03_JPRB, 0.38594288E-03_JPRB, 0.38569208E-03_JPRB, 0.38549008E-03_JPRB, 0.38530054E-03_JPRB, 0.38511382E-03_JPRB, &
  & 0.38487617E-03_JPRB, 0.38466710E-03_JPRB, 0.38451928E-03_JPRB, 0.38440602E-03_JPRB, 0.38429113E-03_JPRB, 0.38418903E-03_JPRB, &
  & 0.38411517E-03_JPRB, 0.38409323E-03_JPRB, 0.38415464E-03_JPRB, 0.38429216E-03_JPRB, 0.38439260E-03_JPRB, 0.38481427E-03_JPRB, &
  & 0.38498154E-03_JPRB, 0.38476001E-03_JPRB, 0.38492493E-03_JPRB, 0.38507012E-03_JPRB, 0.38487492E-03_JPRB, 0.38427887E-03_JPRB, &
  & 0.38396480E-03_JPRB, 0.38397905E-03_JPRB, 0.38373513E-03_JPRB, 0.38342809E-03_JPRB, 0.38331524E-03_JPRB, 0.38337078E-03_JPRB, &
  & 0.38334570E-03_JPRB, 0.38324258E-03_JPRB, 0.38319824E-03_JPRB, 0.38316885E-03_JPRB, 0.38315277E-03_JPRB, 0.38317832E-03_JPRB, &
  & 0.38337879E-03_JPRB, 0.38357666E-03_JPRB, 0.38390691E-03_JPRB, 0.38428607E-03_JPRB, 0.38470768E-03_JPRB, 0.38500008E-03_JPRB, &
  & 0.38502054E-03_JPRB, 0.38505564E-03_JPRB, 0.38492740E-03_JPRB, 0.38474096E-03_JPRB, 0.38466639E-03_JPRB, 0.38482896E-03_JPRB, &
  & 0.38505709E-03_JPRB, 0.38537548E-03_JPRB, 0.38568802E-03_JPRB, 0.38570871E-03_JPRB  /)

RGHG1(:,84, 9) = (/ &
  & 0.38709026E-03_JPRB, 0.38706314E-03_JPRB, 0.38707301E-03_JPRB, 0.38699298E-03_JPRB, 0.38699026E-03_JPRB, 0.38702106E-03_JPRB, &
  & 0.38707189E-03_JPRB, 0.38711114E-03_JPRB, 0.38709047E-03_JPRB, 0.38697961E-03_JPRB, 0.38673037E-03_JPRB, 0.38644330E-03_JPRB, &
  & 0.38618125E-03_JPRB, 0.38594439E-03_JPRB, 0.38569275E-03_JPRB, 0.38549482E-03_JPRB, 0.38530837E-03_JPRB, 0.38512662E-03_JPRB, &
  & 0.38489994E-03_JPRB, 0.38470189E-03_JPRB, 0.38456436E-03_JPRB, 0.38445394E-03_JPRB, 0.38434682E-03_JPRB, 0.38425226E-03_JPRB, &
  & 0.38418547E-03_JPRB, 0.38416845E-03_JPRB, 0.38424683E-03_JPRB, 0.38438265E-03_JPRB, 0.38445085E-03_JPRB, 0.38488044E-03_JPRB, &
  & 0.38503052E-03_JPRB, 0.38475725E-03_JPRB, 0.38492354E-03_JPRB, 0.38505203E-03_JPRB, 0.38483182E-03_JPRB, 0.38422857E-03_JPRB, &
  & 0.38393418E-03_JPRB, 0.38398156E-03_JPRB, 0.38375250E-03_JPRB, 0.38345271E-03_JPRB, 0.38334503E-03_JPRB, 0.38341298E-03_JPRB, &
  & 0.38340814E-03_JPRB, 0.38333924E-03_JPRB, 0.38332723E-03_JPRB, 0.38327894E-03_JPRB, 0.38327077E-03_JPRB, 0.38330590E-03_JPRB, &
  & 0.38351385E-03_JPRB, 0.38371358E-03_JPRB, 0.38405315E-03_JPRB, 0.38444450E-03_JPRB, 0.38486187E-03_JPRB, 0.38513967E-03_JPRB, &
  & 0.38513199E-03_JPRB, 0.38515922E-03_JPRB, 0.38502497E-03_JPRB, 0.38480789E-03_JPRB, 0.38471902E-03_JPRB, 0.38485731E-03_JPRB, &
  & 0.38506813E-03_JPRB, 0.38536751E-03_JPRB, 0.38568392E-03_JPRB, 0.38572857E-03_JPRB  /)

RGHG1(:,85, 9) = (/ &
  & 0.38706870E-03_JPRB, 0.38705173E-03_JPRB, 0.38706781E-03_JPRB, 0.38699203E-03_JPRB, 0.38698859E-03_JPRB, 0.38702840E-03_JPRB, &
  & 0.38708127E-03_JPRB, 0.38711980E-03_JPRB, 0.38709806E-03_JPRB, 0.38698947E-03_JPRB, 0.38673789E-03_JPRB, 0.38644378E-03_JPRB, &
  & 0.38618054E-03_JPRB, 0.38594337E-03_JPRB, 0.38569036E-03_JPRB, 0.38549649E-03_JPRB, 0.38531380E-03_JPRB, 0.38513761E-03_JPRB, &
  & 0.38492730E-03_JPRB, 0.38474670E-03_JPRB, 0.38462147E-03_JPRB, 0.38451428E-03_JPRB, 0.38441420E-03_JPRB, 0.38433201E-03_JPRB, &
  & 0.38428063E-03_JPRB, 0.38426732E-03_JPRB, 0.38436135E-03_JPRB, 0.38450487E-03_JPRB, 0.38455294E-03_JPRB, 0.38500583E-03_JPRB, &
  & 0.38512933E-03_JPRB, 0.38480684E-03_JPRB, 0.38496900E-03_JPRB, 0.38507359E-03_JPRB, 0.38482417E-03_JPRB, 0.38420790E-03_JPRB, &
  & 0.38392492E-03_JPRB, 0.38399483E-03_JPRB, 0.38378847E-03_JPRB, 0.38349812E-03_JPRB, 0.38340088E-03_JPRB, 0.38348944E-03_JPRB, &
  & 0.38350360E-03_JPRB, 0.38349056E-03_JPRB, 0.38351481E-03_JPRB, 0.38342106E-03_JPRB, 0.38343511E-03_JPRB, 0.38347872E-03_JPRB, &
  & 0.38370173E-03_JPRB, 0.38388915E-03_JPRB, 0.38424652E-03_JPRB, 0.38464038E-03_JPRB, 0.38503284E-03_JPRB, 0.38528329E-03_JPRB, &
  & 0.38525087E-03_JPRB, 0.38526197E-03_JPRB, 0.38511936E-03_JPRB, 0.38486656E-03_JPRB, 0.38475689E-03_JPRB, 0.38487643E-03_JPRB, &
  & 0.38506951E-03_JPRB, 0.38535251E-03_JPRB, 0.38567478E-03_JPRB, 0.38575007E-03_JPRB  /)

RGHG1(:,86, 9) = (/ &
  & 0.38705244E-03_JPRB, 0.38704185E-03_JPRB, 0.38706301E-03_JPRB, 0.38699196E-03_JPRB, 0.38698700E-03_JPRB, 0.38703322E-03_JPRB, &
  & 0.38708812E-03_JPRB, 0.38712664E-03_JPRB, 0.38710363E-03_JPRB, 0.38699601E-03_JPRB, 0.38674233E-03_JPRB, 0.38644267E-03_JPRB, &
  & 0.38617879E-03_JPRB, 0.38594137E-03_JPRB, 0.38568697E-03_JPRB, 0.38549766E-03_JPRB, 0.38531815E-03_JPRB, 0.38514866E-03_JPRB, &
  & 0.38496256E-03_JPRB, 0.38480136E-03_JPRB, 0.38469004E-03_JPRB, 0.38458782E-03_JPRB, 0.38449413E-03_JPRB, 0.38442573E-03_JPRB, &
  & 0.38439124E-03_JPRB, 0.38437534E-03_JPRB, 0.38448585E-03_JPRB, 0.38465249E-03_JPRB, 0.38469594E-03_JPRB, 0.38522161E-03_JPRB, &
  & 0.38531741E-03_JPRB, 0.38493815E-03_JPRB, 0.38510005E-03_JPRB, 0.38516502E-03_JPRB, 0.38488805E-03_JPRB, 0.38424897E-03_JPRB, &
  & 0.38397494E-03_JPRB, 0.38403789E-03_JPRB, 0.38385738E-03_JPRB, 0.38357708E-03_JPRB, 0.38349890E-03_JPRB, 0.38360664E-03_JPRB, &
  & 0.38363269E-03_JPRB, 0.38369593E-03_JPRB, 0.38374901E-03_JPRB, 0.38361209E-03_JPRB, 0.38366652E-03_JPRB, 0.38371969E-03_JPRB, &
  & 0.38394048E-03_JPRB, 0.38412353E-03_JPRB, 0.38449337E-03_JPRB, 0.38487531E-03_JPRB, 0.38522721E-03_JPRB, 0.38543950E-03_JPRB, &
  & 0.38538545E-03_JPRB, 0.38537342E-03_JPRB, 0.38521768E-03_JPRB, 0.38492299E-03_JPRB, 0.38478500E-03_JPRB, 0.38488873E-03_JPRB, &
  & 0.38506710E-03_JPRB, 0.38533744E-03_JPRB, 0.38566615E-03_JPRB, 0.38576972E-03_JPRB  /)

RGHG1(:,87, 9) = (/ &
  & 0.38704280E-03_JPRB, 0.38703539E-03_JPRB, 0.38705984E-03_JPRB, 0.38699233E-03_JPRB, 0.38698585E-03_JPRB, 0.38703705E-03_JPRB, &
  & 0.38709307E-03_JPRB, 0.38713186E-03_JPRB, 0.38710766E-03_JPRB, 0.38700034E-03_JPRB, 0.38674502E-03_JPRB, 0.38644040E-03_JPRB, &
  & 0.38617672E-03_JPRB, 0.38593883E-03_JPRB, 0.38568353E-03_JPRB, 0.38549898E-03_JPRB, 0.38532195E-03_JPRB, 0.38516243E-03_JPRB, &
  & 0.38500792E-03_JPRB, 0.38486616E-03_JPRB, 0.38477107E-03_JPRB, 0.38467393E-03_JPRB, 0.38458244E-03_JPRB, 0.38453076E-03_JPRB, &
  & 0.38451100E-03_JPRB, 0.38448947E-03_JPRB, 0.38463137E-03_JPRB, 0.38483588E-03_JPRB, 0.38488157E-03_JPRB, 0.38554164E-03_JPRB, &
  & 0.38561506E-03_JPRB, 0.38518323E-03_JPRB, 0.38537764E-03_JPRB, 0.38536541E-03_JPRB, 0.38507113E-03_JPRB, 0.38438559E-03_JPRB, &
  & 0.38410185E-03_JPRB, 0.38413631E-03_JPRB, 0.38397892E-03_JPRB, 0.38371869E-03_JPRB, 0.38366827E-03_JPRB, 0.38378279E-03_JPRB, &
  & 0.38381299E-03_JPRB, 0.38397335E-03_JPRB, 0.38405395E-03_JPRB, 0.38387855E-03_JPRB, 0.38399446E-03_JPRB, 0.38405604E-03_JPRB, &
  & 0.38426985E-03_JPRB, 0.38445562E-03_JPRB, 0.38481844E-03_JPRB, 0.38517215E-03_JPRB, 0.38546060E-03_JPRB, 0.38562079E-03_JPRB, &
  & 0.38554418E-03_JPRB, 0.38550211E-03_JPRB, 0.38532732E-03_JPRB, 0.38498005E-03_JPRB, 0.38480532E-03_JPRB, 0.38489607E-03_JPRB, &
  & 0.38506319E-03_JPRB, 0.38532600E-03_JPRB, 0.38566091E-03_JPRB, 0.38578376E-03_JPRB  /)

RGHG1(:,88, 9) = (/ &
  & 0.38703981E-03_JPRB, 0.38703339E-03_JPRB, 0.38705846E-03_JPRB, 0.38699312E-03_JPRB, 0.38698543E-03_JPRB, 0.38704050E-03_JPRB, &
  & 0.38709637E-03_JPRB, 0.38713544E-03_JPRB, 0.38711039E-03_JPRB, 0.38700302E-03_JPRB, 0.38674651E-03_JPRB, 0.38643730E-03_JPRB, &
  & 0.38617489E-03_JPRB, 0.38593601E-03_JPRB, 0.38568045E-03_JPRB, 0.38550101E-03_JPRB, 0.38532560E-03_JPRB, 0.38518220E-03_JPRB, &
  & 0.38506663E-03_JPRB, 0.38494456E-03_JPRB, 0.38487369E-03_JPRB, 0.38477590E-03_JPRB, 0.38468253E-03_JPRB, 0.38465351E-03_JPRB, &
  & 0.38464389E-03_JPRB, 0.38461643E-03_JPRB, 0.38481494E-03_JPRB, 0.38507959E-03_JPRB, 0.38513084E-03_JPRB, 0.38599738E-03_JPRB, &
  & 0.38606627E-03_JPRB, 0.38559021E-03_JPRB, 0.38587734E-03_JPRB, 0.38574969E-03_JPRB, 0.38543694E-03_JPRB, 0.38467457E-03_JPRB, &
  & 0.38432605E-03_JPRB, 0.38431201E-03_JPRB, 0.38418599E-03_JPRB, 0.38396610E-03_JPRB, 0.38395289E-03_JPRB, 0.38405439E-03_JPRB, &
  & 0.38408091E-03_JPRB, 0.38436384E-03_JPRB, 0.38448671E-03_JPRB, 0.38428761E-03_JPRB, 0.38448868E-03_JPRB, 0.38455101E-03_JPRB, &
  & 0.38476703E-03_JPRB, 0.38495667E-03_JPRB, 0.38528846E-03_JPRB, 0.38557623E-03_JPRB, 0.38576861E-03_JPRB, 0.38585160E-03_JPRB, &
  & 0.38574580E-03_JPRB, 0.38566223E-03_JPRB, 0.38545857E-03_JPRB, 0.38503996E-03_JPRB, 0.38481997E-03_JPRB, 0.38489921E-03_JPRB, &
  & 0.38505940E-03_JPRB, 0.38531908E-03_JPRB, 0.38565936E-03_JPRB, 0.38579075E-03_JPRB  /)

RGHG1(:,89, 9) = (/ &
  & 0.38704151E-03_JPRB, 0.38703547E-03_JPRB, 0.38705805E-03_JPRB, 0.38699446E-03_JPRB, 0.38698584E-03_JPRB, 0.38704335E-03_JPRB, &
  & 0.38709812E-03_JPRB, 0.38713721E-03_JPRB, 0.38711195E-03_JPRB, 0.38700439E-03_JPRB, 0.38674687E-03_JPRB, 0.38643396E-03_JPRB, &
  & 0.38617403E-03_JPRB, 0.38593321E-03_JPRB, 0.38567784E-03_JPRB, 0.38550452E-03_JPRB, 0.38532992E-03_JPRB, 0.38521089E-03_JPRB, &
  & 0.38514430E-03_JPRB, 0.38504147E-03_JPRB, 0.38501275E-03_JPRB, 0.38489741E-03_JPRB, 0.38480132E-03_JPRB, 0.38480216E-03_JPRB, &
  & 0.38480055E-03_JPRB, 0.38477248E-03_JPRB, 0.38505708E-03_JPRB, 0.38541302E-03_JPRB, 0.38547732E-03_JPRB, 0.38662102E-03_JPRB, &
  & 0.38672481E-03_JPRB, 0.38620688E-03_JPRB, 0.38667948E-03_JPRB, 0.38642024E-03_JPRB, 0.38605853E-03_JPRB, 0.38519553E-03_JPRB, &
  & 0.38466257E-03_JPRB, 0.38456786E-03_JPRB, 0.38451492E-03_JPRB, 0.38436244E-03_JPRB, 0.38440044E-03_JPRB, 0.38446781E-03_JPRB, &
  & 0.38449412E-03_JPRB, 0.38492653E-03_JPRB, 0.38514090E-03_JPRB, 0.38496268E-03_JPRB, 0.38526442E-03_JPRB, 0.38530216E-03_JPRB, &
  & 0.38554648E-03_JPRB, 0.38573250E-03_JPRB, 0.38601173E-03_JPRB, 0.38614869E-03_JPRB, 0.38619942E-03_JPRB, 0.38616308E-03_JPRB, &
  & 0.38601513E-03_JPRB, 0.38587333E-03_JPRB, 0.38562332E-03_JPRB, 0.38510280E-03_JPRB, 0.38483208E-03_JPRB, 0.38489873E-03_JPRB, &
  & 0.38505725E-03_JPRB, 0.38531510E-03_JPRB, 0.38565909E-03_JPRB, 0.38579190E-03_JPRB  /)

RGHG1(:,90, 9) = (/ &
  & 0.38704439E-03_JPRB, 0.38703719E-03_JPRB, 0.38705845E-03_JPRB, 0.38699533E-03_JPRB, 0.38698587E-03_JPRB, 0.38704562E-03_JPRB, &
  & 0.38709860E-03_JPRB, 0.38713782E-03_JPRB, 0.38711271E-03_JPRB, 0.38700508E-03_JPRB, 0.38674642E-03_JPRB, 0.38643050E-03_JPRB, &
  & 0.38617427E-03_JPRB, 0.38593032E-03_JPRB, 0.38567506E-03_JPRB, 0.38551146E-03_JPRB, 0.38533908E-03_JPRB, 0.38524709E-03_JPRB, &
  & 0.38527282E-03_JPRB, 0.38518045E-03_JPRB, 0.38521194E-03_JPRB, 0.38505871E-03_JPRB, 0.38495439E-03_JPRB, 0.38497893E-03_JPRB, &
  & 0.38501259E-03_JPRB, 0.38500424E-03_JPRB, 0.38540488E-03_JPRB, 0.38586211E-03_JPRB, 0.38597593E-03_JPRB, 0.38749749E-03_JPRB, &
  & 0.38768585E-03_JPRB, 0.38708995E-03_JPRB, 0.38789931E-03_JPRB, 0.38745587E-03_JPRB, 0.38701964E-03_JPRB, 0.38605171E-03_JPRB, &
  & 0.38515574E-03_JPRB, 0.38486551E-03_JPRB, 0.38496852E-03_JPRB, 0.38488996E-03_JPRB, 0.38502759E-03_JPRB, 0.38505859E-03_JPRB, &
  & 0.38515646E-03_JPRB, 0.38577197E-03_JPRB, 0.38618525E-03_JPRB, 0.38613514E-03_JPRB, 0.38652486E-03_JPRB, 0.38648214E-03_JPRB, &
  & 0.38676839E-03_JPRB, 0.38696721E-03_JPRB, 0.38714194E-03_JPRB, 0.38697975E-03_JPRB, 0.38680209E-03_JPRB, 0.38659421E-03_JPRB, &
  & 0.38639463E-03_JPRB, 0.38618450E-03_JPRB, 0.38585295E-03_JPRB, 0.38517550E-03_JPRB, 0.38484482E-03_JPRB, 0.38489720E-03_JPRB, &
  & 0.38505539E-03_JPRB, 0.38531207E-03_JPRB, 0.38565833E-03_JPRB, 0.38579224E-03_JPRB  /)

RGHG1(:,91, 9) = (/ &
  & 0.38704528E-03_JPRB, 0.38703808E-03_JPRB, 0.38705831E-03_JPRB, 0.38699488E-03_JPRB, 0.38698676E-03_JPRB, 0.38704651E-03_JPRB, &
  & 0.38709860E-03_JPRB, 0.38713797E-03_JPRB, 0.38711315E-03_JPRB, 0.38700545E-03_JPRB, 0.38674516E-03_JPRB, 0.38642619E-03_JPRB, &
  & 0.38617984E-03_JPRB, 0.38592675E-03_JPRB, 0.38567090E-03_JPRB, 0.38552475E-03_JPRB, 0.38535408E-03_JPRB, 0.38530077E-03_JPRB, &
  & 0.38550713E-03_JPRB, 0.38550667E-03_JPRB, 0.38558894E-03_JPRB, 0.38536741E-03_JPRB, 0.38519843E-03_JPRB, 0.38525511E-03_JPRB, &
  & 0.38534535E-03_JPRB, 0.38541889E-03_JPRB, 0.38609481E-03_JPRB, 0.38660498E-03_JPRB, 0.38674271E-03_JPRB, 0.38896675E-03_JPRB, &
  & 0.38933107E-03_JPRB, 0.38865989E-03_JPRB, 0.39013676E-03_JPRB, 0.38928602E-03_JPRB, 0.38859232E-03_JPRB, 0.38763879E-03_JPRB, &
  & 0.38592675E-03_JPRB, 0.38528728E-03_JPRB, 0.38555830E-03_JPRB, 0.38555815E-03_JPRB, 0.38581798E-03_JPRB, 0.38582395E-03_JPRB, &
  & 0.38620788E-03_JPRB, 0.38716402E-03_JPRB, 0.38803099E-03_JPRB, 0.38818297E-03_JPRB, 0.38870447E-03_JPRB, 0.38875410E-03_JPRB, &
  & 0.38901378E-03_JPRB, 0.38923072E-03_JPRB, 0.38904871E-03_JPRB, 0.38828040E-03_JPRB, 0.38768736E-03_JPRB, 0.38730159E-03_JPRB, &
  & 0.38706719E-03_JPRB, 0.38668541E-03_JPRB, 0.38619409E-03_JPRB, 0.38526890E-03_JPRB, 0.38486138E-03_JPRB, 0.38489371E-03_JPRB, &
  & 0.38505242E-03_JPRB, 0.38530858E-03_JPRB, 0.38565788E-03_JPRB, 0.38579224E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ---GEMS----

RGHG1(:, 1,10) = (/ &
  & 0.37380016E-03_JPRB, 0.37379939E-03_JPRB, 0.37379905E-03_JPRB, 0.37379882E-03_JPRB, 0.37379839E-03_JPRB, 0.37379820E-03_JPRB, &
  & 0.37379832E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379839E-03_JPRB, &
  & 0.37379847E-03_JPRB, 0.37379878E-03_JPRB, 0.37379889E-03_JPRB, 0.37379897E-03_JPRB, 0.37379920E-03_JPRB, 0.37379966E-03_JPRB, &
  & 0.37380115E-03_JPRB, 0.37380311E-03_JPRB, 0.37380460E-03_JPRB, 0.37380598E-03_JPRB, 0.37380778E-03_JPRB, 0.37381111E-03_JPRB, &
  & 0.37381712E-03_JPRB, 0.37382574E-03_JPRB, 0.37383558E-03_JPRB, 0.37384573E-03_JPRB, 0.37385630E-03_JPRB, 0.37386653E-03_JPRB, &
  & 0.37387358E-03_JPRB, 0.37387549E-03_JPRB, 0.37387113E-03_JPRB, 0.37385853E-03_JPRB, 0.37382846E-03_JPRB, 0.37377913E-03_JPRB, &
  & 0.37372152E-03_JPRB, 0.37366630E-03_JPRB, 0.37361371E-03_JPRB, 0.37356713E-03_JPRB, 0.37352968E-03_JPRB, 0.37349555E-03_JPRB, &
  & 0.37345579E-03_JPRB, 0.37341064E-03_JPRB, 0.37336567E-03_JPRB, 0.37331550E-03_JPRB, 0.37326372E-03_JPRB, 0.37321255E-03_JPRB, &
  & 0.37315659E-03_JPRB, 0.37309136E-03_JPRB, 0.37301901E-03_JPRB, 0.37294038E-03_JPRB, 0.37285631E-03_JPRB, 0.37276378E-03_JPRB, &
  & 0.37266780E-03_JPRB, 0.37257109E-03_JPRB, 0.37248552E-03_JPRB, 0.37239847E-03_JPRB, 0.37231022E-03_JPRB, 0.37223688E-03_JPRB, &
  & 0.37218023E-03_JPRB, 0.37214266E-03_JPRB, 0.37211608E-03_JPRB, 0.37209413E-03_JPRB  /)

RGHG1(:, 2,10) = (/ &
  & 0.37380016E-03_JPRB, 0.37379939E-03_JPRB, 0.37379905E-03_JPRB, 0.37379882E-03_JPRB, 0.37379839E-03_JPRB, 0.37379820E-03_JPRB, &
  & 0.37379832E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379839E-03_JPRB, &
  & 0.37379847E-03_JPRB, 0.37379878E-03_JPRB, 0.37379889E-03_JPRB, 0.37379897E-03_JPRB, 0.37379920E-03_JPRB, 0.37379966E-03_JPRB, &
  & 0.37380115E-03_JPRB, 0.37380311E-03_JPRB, 0.37380460E-03_JPRB, 0.37380598E-03_JPRB, 0.37380778E-03_JPRB, 0.37381111E-03_JPRB, &
  & 0.37381712E-03_JPRB, 0.37382574E-03_JPRB, 0.37383558E-03_JPRB, 0.37384573E-03_JPRB, 0.37385630E-03_JPRB, 0.37386653E-03_JPRB, &
  & 0.37387358E-03_JPRB, 0.37387549E-03_JPRB, 0.37387113E-03_JPRB, 0.37385853E-03_JPRB, 0.37382846E-03_JPRB, 0.37377913E-03_JPRB, &
  & 0.37372152E-03_JPRB, 0.37366630E-03_JPRB, 0.37361371E-03_JPRB, 0.37356713E-03_JPRB, 0.37352968E-03_JPRB, 0.37349555E-03_JPRB, &
  & 0.37345579E-03_JPRB, 0.37341064E-03_JPRB, 0.37336567E-03_JPRB, 0.37331550E-03_JPRB, 0.37326372E-03_JPRB, 0.37321255E-03_JPRB, &
  & 0.37315659E-03_JPRB, 0.37309136E-03_JPRB, 0.37301901E-03_JPRB, 0.37294038E-03_JPRB, 0.37285631E-03_JPRB, 0.37276378E-03_JPRB, &
  & 0.37266780E-03_JPRB, 0.37257109E-03_JPRB, 0.37248552E-03_JPRB, 0.37239847E-03_JPRB, 0.37231022E-03_JPRB, 0.37223688E-03_JPRB, &
  & 0.37218023E-03_JPRB, 0.37214266E-03_JPRB, 0.37211608E-03_JPRB, 0.37209413E-03_JPRB  /)

RGHG1(:, 3,10) = (/ &
  & 0.37380016E-03_JPRB, 0.37379939E-03_JPRB, 0.37379905E-03_JPRB, 0.37379882E-03_JPRB, 0.37379839E-03_JPRB, 0.37379820E-03_JPRB, &
  & 0.37379832E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379843E-03_JPRB, 0.37379839E-03_JPRB, 0.37379839E-03_JPRB, &
  & 0.37379847E-03_JPRB, 0.37379878E-03_JPRB, 0.37379889E-03_JPRB, 0.37379897E-03_JPRB, 0.37379920E-03_JPRB, 0.37379966E-03_JPRB, &
  & 0.37380115E-03_JPRB, 0.37380311E-03_JPRB, 0.37380460E-03_JPRB, 0.37380598E-03_JPRB, 0.37380778E-03_JPRB, 0.37381111E-03_JPRB, &
  & 0.37381712E-03_JPRB, 0.37382574E-03_JPRB, 0.37383558E-03_JPRB, 0.37384573E-03_JPRB, 0.37385630E-03_JPRB, 0.37386653E-03_JPRB, &
  & 0.37387358E-03_JPRB, 0.37387549E-03_JPRB, 0.37387113E-03_JPRB, 0.37385853E-03_JPRB, 0.37382846E-03_JPRB, 0.37377913E-03_JPRB, &
  & 0.37372152E-03_JPRB, 0.37366630E-03_JPRB, 0.37361371E-03_JPRB, 0.37356713E-03_JPRB, 0.37352968E-03_JPRB, 0.37349555E-03_JPRB, &
  & 0.37345579E-03_JPRB, 0.37341064E-03_JPRB, 0.37336567E-03_JPRB, 0.37331550E-03_JPRB, 0.37326372E-03_JPRB, 0.37321255E-03_JPRB, &
  & 0.37315659E-03_JPRB, 0.37309136E-03_JPRB, 0.37301901E-03_JPRB, 0.37294038E-03_JPRB, 0.37285631E-03_JPRB, 0.37276378E-03_JPRB, &
  & 0.37266780E-03_JPRB, 0.37257109E-03_JPRB, 0.37248552E-03_JPRB, 0.37239847E-03_JPRB, 0.37231022E-03_JPRB, 0.37223688E-03_JPRB, &
  & 0.37218023E-03_JPRB, 0.37214266E-03_JPRB, 0.37211608E-03_JPRB, 0.37209413E-03_JPRB  /)

RGHG1(:, 4,10) = (/ &
  & 0.37380013E-03_JPRB, 0.37379937E-03_JPRB, 0.37379904E-03_JPRB, 0.37379881E-03_JPRB, 0.37379839E-03_JPRB, 0.37379821E-03_JPRB, &
  & 0.37379833E-03_JPRB, 0.37379845E-03_JPRB, 0.37379842E-03_JPRB, 0.37379847E-03_JPRB, 0.37379844E-03_JPRB, 0.37379845E-03_JPRB, &
  & 0.37379854E-03_JPRB, 0.37379885E-03_JPRB, 0.37379898E-03_JPRB, 0.37379906E-03_JPRB, 0.37379928E-03_JPRB, 0.37379974E-03_JPRB, &
  & 0.37380122E-03_JPRB, 0.37380317E-03_JPRB, 0.37380466E-03_JPRB, 0.37380604E-03_JPRB, 0.37380785E-03_JPRB, 0.37381120E-03_JPRB, &
  & 0.37381722E-03_JPRB, 0.37382586E-03_JPRB, 0.37383575E-03_JPRB, 0.37384597E-03_JPRB, 0.37385661E-03_JPRB, 0.37386689E-03_JPRB, &
  & 0.37387401E-03_JPRB, 0.37387602E-03_JPRB, 0.37387174E-03_JPRB, 0.37385920E-03_JPRB, 0.37382914E-03_JPRB, 0.37377974E-03_JPRB, &
  & 0.37372200E-03_JPRB, 0.37366662E-03_JPRB, 0.37361391E-03_JPRB, 0.37356724E-03_JPRB, 0.37352970E-03_JPRB, 0.37349552E-03_JPRB, &
  & 0.37345572E-03_JPRB, 0.37341055E-03_JPRB, 0.37336557E-03_JPRB, 0.37331540E-03_JPRB, 0.37326358E-03_JPRB, 0.37321232E-03_JPRB, &
  & 0.37315620E-03_JPRB, 0.37309083E-03_JPRB, 0.37301831E-03_JPRB, 0.37293954E-03_JPRB, 0.37285538E-03_JPRB, 0.37276283E-03_JPRB, &
  & 0.37266689E-03_JPRB, 0.37257025E-03_JPRB, 0.37248472E-03_JPRB, 0.37239771E-03_JPRB, 0.37230955E-03_JPRB, 0.37223629E-03_JPRB, &
  & 0.37217967E-03_JPRB, 0.37214207E-03_JPRB, 0.37211549E-03_JPRB, 0.37209359E-03_JPRB  /)

RGHG1(:, 5,10) = (/ &
  & 0.37379869E-03_JPRB, 0.37379852E-03_JPRB, 0.37379855E-03_JPRB, 0.37379854E-03_JPRB, 0.37379841E-03_JPRB, 0.37379840E-03_JPRB, &
  & 0.37379873E-03_JPRB, 0.37379916E-03_JPRB, 0.37379958E-03_JPRB, 0.37380013E-03_JPRB, 0.37380061E-03_JPRB, 0.37380111E-03_JPRB, &
  & 0.37380178E-03_JPRB, 0.37380252E-03_JPRB, 0.37380300E-03_JPRB, 0.37380321E-03_JPRB, 0.37380335E-03_JPRB, 0.37380356E-03_JPRB, &
  & 0.37380451E-03_JPRB, 0.37380612E-03_JPRB, 0.37380763E-03_JPRB, 0.37380910E-03_JPRB, 0.37381129E-03_JPRB, 0.37381528E-03_JPRB, &
  & 0.37382186E-03_JPRB, 0.37383168E-03_JPRB, 0.37384382E-03_JPRB, 0.37385715E-03_JPRB, 0.37387107E-03_JPRB, 0.37388406E-03_JPRB, &
  & 0.37389461E-03_JPRB, 0.37390105E-03_JPRB, 0.37390106E-03_JPRB, 0.37389109E-03_JPRB, 0.37386132E-03_JPRB, 0.37380896E-03_JPRB, &
  & 0.37374468E-03_JPRB, 0.37368213E-03_JPRB, 0.37362342E-03_JPRB, 0.37357205E-03_JPRB, 0.37353060E-03_JPRB, 0.37349387E-03_JPRB, &
  & 0.37345240E-03_JPRB, 0.37340633E-03_JPRB, 0.37336081E-03_JPRB, 0.37331082E-03_JPRB, 0.37325719E-03_JPRB, 0.37320173E-03_JPRB, &
  & 0.37313779E-03_JPRB, 0.37306538E-03_JPRB, 0.37298491E-03_JPRB, 0.37289937E-03_JPRB, 0.37281087E-03_JPRB, 0.37271763E-03_JPRB, &
  & 0.37262366E-03_JPRB, 0.37253043E-03_JPRB, 0.37244674E-03_JPRB, 0.37236168E-03_JPRB, 0.37227763E-03_JPRB, 0.37220844E-03_JPRB, &
  & 0.37215285E-03_JPRB, 0.37211424E-03_JPRB, 0.37208778E-03_JPRB, 0.37206778E-03_JPRB  /)

RGHG1(:, 6,10) = (/ &
  & 0.37379653E-03_JPRB, 0.37379724E-03_JPRB, 0.37379781E-03_JPRB, 0.37379815E-03_JPRB, 0.37379843E-03_JPRB, 0.37379870E-03_JPRB, &
  & 0.37379934E-03_JPRB, 0.37380023E-03_JPRB, 0.37380132E-03_JPRB, 0.37380263E-03_JPRB, 0.37380386E-03_JPRB, 0.37380509E-03_JPRB, &
  & 0.37380665E-03_JPRB, 0.37380801E-03_JPRB, 0.37380904E-03_JPRB, 0.37380944E-03_JPRB, 0.37380946E-03_JPRB, 0.37380928E-03_JPRB, &
  & 0.37380944E-03_JPRB, 0.37381054E-03_JPRB, 0.37381207E-03_JPRB, 0.37381370E-03_JPRB, 0.37381645E-03_JPRB, 0.37382140E-03_JPRB, &
  & 0.37382883E-03_JPRB, 0.37384041E-03_JPRB, 0.37385592E-03_JPRB, 0.37387394E-03_JPRB, 0.37389276E-03_JPRB, 0.37390982E-03_JPRB, &
  & 0.37392550E-03_JPRB, 0.37393859E-03_JPRB, 0.37394505E-03_JPRB, 0.37393894E-03_JPRB, 0.37390961E-03_JPRB, 0.37385281E-03_JPRB, &
  & 0.37377870E-03_JPRB, 0.37370539E-03_JPRB, 0.37363768E-03_JPRB, 0.37357926E-03_JPRB, 0.37353197E-03_JPRB, 0.37349139E-03_JPRB, &
  & 0.37344741E-03_JPRB, 0.37339999E-03_JPRB, 0.37335365E-03_JPRB, 0.37330394E-03_JPRB, 0.37324761E-03_JPRB, 0.37318583E-03_JPRB, &
  & 0.37311016E-03_JPRB, 0.37302721E-03_JPRB, 0.37293480E-03_JPRB, 0.37283911E-03_JPRB, 0.37274411E-03_JPRB, 0.37264981E-03_JPRB, &
  & 0.37255880E-03_JPRB, 0.37247069E-03_JPRB, 0.37238975E-03_JPRB, 0.37230762E-03_JPRB, 0.37222974E-03_JPRB, 0.37216666E-03_JPRB, &
  & 0.37211262E-03_JPRB, 0.37207247E-03_JPRB, 0.37204621E-03_JPRB, 0.37202906E-03_JPRB  /)

RGHG1(:, 7,10) = (/ &
  & 0.37380069E-03_JPRB, 0.37380177E-03_JPRB, 0.37380290E-03_JPRB, 0.37380443E-03_JPRB, 0.37380619E-03_JPRB, 0.37380795E-03_JPRB, &
  & 0.37381013E-03_JPRB, 0.37381297E-03_JPRB, 0.37381610E-03_JPRB, 0.37381950E-03_JPRB, 0.37382319E-03_JPRB, 0.37382642E-03_JPRB, &
  & 0.37382961E-03_JPRB, 0.37383246E-03_JPRB, 0.37383472E-03_JPRB, 0.37383593E-03_JPRB, 0.37383650E-03_JPRB, 0.37383663E-03_JPRB, &
  & 0.37383693E-03_JPRB, 0.37383766E-03_JPRB, 0.37383948E-03_JPRB, 0.37384141E-03_JPRB, 0.37384391E-03_JPRB, 0.37384838E-03_JPRB, &
  & 0.37385545E-03_JPRB, 0.37386793E-03_JPRB, 0.37388724E-03_JPRB, 0.37391352E-03_JPRB, 0.37394495E-03_JPRB, 0.37397696E-03_JPRB, &
  & 0.37400936E-03_JPRB, 0.37404026E-03_JPRB, 0.37406235E-03_JPRB, 0.37406567E-03_JPRB, 0.37403416E-03_JPRB, 0.37395881E-03_JPRB, &
  & 0.37385722E-03_JPRB, 0.37376135E-03_JPRB, 0.37368302E-03_JPRB, 0.37362174E-03_JPRB, 0.37357233E-03_JPRB, 0.37352985E-03_JPRB, &
  & 0.37348284E-03_JPRB, 0.37343310E-03_JPRB, 0.37338389E-03_JPRB, 0.37333218E-03_JPRB, 0.37326759E-03_JPRB, 0.37319239E-03_JPRB, &
  & 0.37309744E-03_JPRB, 0.37299004E-03_JPRB, 0.37287510E-03_JPRB, 0.37275864E-03_JPRB, 0.37264329E-03_JPRB, 0.37253637E-03_JPRB, &
  & 0.37243792E-03_JPRB, 0.37234802E-03_JPRB, 0.37226503E-03_JPRB, 0.37218223E-03_JPRB, 0.37210824E-03_JPRB, 0.37205104E-03_JPRB, &
  & 0.37200125E-03_JPRB, 0.37196315E-03_JPRB, 0.37193414E-03_JPRB, 0.37191810E-03_JPRB  /)

RGHG1(:, 8,10) = (/ &
  & 0.37382178E-03_JPRB, 0.37382252E-03_JPRB, 0.37382458E-03_JPRB, 0.37382760E-03_JPRB, 0.37383110E-03_JPRB, 0.37383535E-03_JPRB, &
  & 0.37384059E-03_JPRB, 0.37384738E-03_JPRB, 0.37385482E-03_JPRB, 0.37386236E-03_JPRB, 0.37387058E-03_JPRB, 0.37387737E-03_JPRB, &
  & 0.37388283E-03_JPRB, 0.37388751E-03_JPRB, 0.37389121E-03_JPRB, 0.37389462E-03_JPRB, 0.37389769E-03_JPRB, 0.37389988E-03_JPRB, &
  & 0.37390110E-03_JPRB, 0.37390244E-03_JPRB, 0.37390595E-03_JPRB, 0.37390911E-03_JPRB, 0.37391117E-03_JPRB, 0.37391487E-03_JPRB, &
  & 0.37392332E-03_JPRB, 0.37393900E-03_JPRB, 0.37396323E-03_JPRB, 0.37399754E-03_JPRB, 0.37404177E-03_JPRB, 0.37409180E-03_JPRB, &
  & 0.37414585E-03_JPRB, 0.37420028E-03_JPRB, 0.37424681E-03_JPRB, 0.37427124E-03_JPRB, 0.37424976E-03_JPRB, 0.37416387E-03_JPRB, &
  & 0.37403488E-03_JPRB, 0.37391791E-03_JPRB, 0.37383314E-03_JPRB, 0.37377343E-03_JPRB, 0.37372447E-03_JPRB, 0.37368001E-03_JPRB, &
  & 0.37362755E-03_JPRB, 0.37357020E-03_JPRB, 0.37350896E-03_JPRB, 0.37344170E-03_JPRB, 0.37335774E-03_JPRB, 0.37326037E-03_JPRB, &
  & 0.37313853E-03_JPRB, 0.37299485E-03_JPRB, 0.37284315E-03_JPRB, 0.37269510E-03_JPRB, 0.37255328E-03_JPRB, 0.37242371E-03_JPRB, &
  & 0.37230766E-03_JPRB, 0.37220525E-03_JPRB, 0.37211583E-03_JPRB, 0.37203142E-03_JPRB, 0.37196128E-03_JPRB, 0.37190787E-03_JPRB, &
  & 0.37186185E-03_JPRB, 0.37182521E-03_JPRB, 0.37179566E-03_JPRB, 0.37178058E-03_JPRB  /)

RGHG1(:, 9,10) = (/ &
  & 0.37387048E-03_JPRB, 0.37386997E-03_JPRB, 0.37387247E-03_JPRB, 0.37387584E-03_JPRB, 0.37388011E-03_JPRB, 0.37388656E-03_JPRB, &
  & 0.37389584E-03_JPRB, 0.37390746E-03_JPRB, 0.37391964E-03_JPRB, 0.37393227E-03_JPRB, 0.37394568E-03_JPRB, 0.37395720E-03_JPRB, &
  & 0.37396577E-03_JPRB, 0.37397244E-03_JPRB, 0.37397751E-03_JPRB, 0.37398324E-03_JPRB, 0.37398969E-03_JPRB, 0.37399521E-03_JPRB, &
  & 0.37399841E-03_JPRB, 0.37400148E-03_JPRB, 0.37400789E-03_JPRB, 0.37401372E-03_JPRB, 0.37401637E-03_JPRB, 0.37402177E-03_JPRB, &
  & 0.37403919E-03_JPRB, 0.37406903E-03_JPRB, 0.37410628E-03_JPRB, 0.37415065E-03_JPRB, 0.37420506E-03_JPRB, 0.37426893E-03_JPRB, &
  & 0.37433975E-03_JPRB, 0.37441363E-03_JPRB, 0.37448608E-03_JPRB, 0.37454165E-03_JPRB, 0.37455298E-03_JPRB, 0.37449048E-03_JPRB, &
  & 0.37436479E-03_JPRB, 0.37424642E-03_JPRB, 0.37416519E-03_JPRB, 0.37410937E-03_JPRB, 0.37406337E-03_JPRB, 0.37401799E-03_JPRB, &
  & 0.37395257E-03_JPRB, 0.37387286E-03_JPRB, 0.37377906E-03_JPRB, 0.37367080E-03_JPRB, 0.37355064E-03_JPRB, 0.37342256E-03_JPRB, &
  & 0.37326750E-03_JPRB, 0.37308164E-03_JPRB, 0.37288004E-03_JPRB, 0.37268815E-03_JPRB, 0.37251604E-03_JPRB, 0.37235816E-03_JPRB, &
  & 0.37221647E-03_JPRB, 0.37209004E-03_JPRB, 0.37198684E-03_JPRB, 0.37189928E-03_JPRB, 0.37183070E-03_JPRB, 0.37177624E-03_JPRB, &
  & 0.37172804E-03_JPRB, 0.37168699E-03_JPRB, 0.37165542E-03_JPRB, 0.37163800E-03_JPRB  /)

RGHG1(:,10,10) = (/ &
  & 0.37393687E-03_JPRB, 0.37393505E-03_JPRB, 0.37393587E-03_JPRB, 0.37393721E-03_JPRB, 0.37394006E-03_JPRB, 0.37394674E-03_JPRB, &
  & 0.37395867E-03_JPRB, 0.37397231E-03_JPRB, 0.37398498E-03_JPRB, 0.37399971E-03_JPRB, 0.37401629E-03_JPRB, 0.37403230E-03_JPRB, &
  & 0.37404448E-03_JPRB, 0.37405305E-03_JPRB, 0.37405839E-03_JPRB, 0.37406343E-03_JPRB, 0.37407036E-03_JPRB, 0.37407691E-03_JPRB, &
  & 0.37408229E-03_JPRB, 0.37408857E-03_JPRB, 0.37409778E-03_JPRB, 0.37410725E-03_JPRB, 0.37411402E-03_JPRB, 0.37412911E-03_JPRB, &
  & 0.37416961E-03_JPRB, 0.37423465E-03_JPRB, 0.37430428E-03_JPRB, 0.37436826E-03_JPRB, 0.37443289E-03_JPRB, 0.37450275E-03_JPRB, &
  & 0.37457704E-03_JPRB, 0.37465447E-03_JPRB, 0.37473735E-03_JPRB, 0.37481816E-03_JPRB, 0.37487700E-03_JPRB, 0.37487949E-03_JPRB, &
  & 0.37481437E-03_JPRB, 0.37473383E-03_JPRB, 0.37466868E-03_JPRB, 0.37461462E-03_JPRB, 0.37456999E-03_JPRB, 0.37452175E-03_JPRB, &
  & 0.37443138E-03_JPRB, 0.37430432E-03_JPRB, 0.37415199E-03_JPRB, 0.37398154E-03_JPRB, 0.37381136E-03_JPRB, 0.37364610E-03_JPRB, &
  & 0.37345504E-03_JPRB, 0.37323175E-03_JPRB, 0.37298413E-03_JPRB, 0.37274372E-03_JPRB, 0.37253771E-03_JPRB, 0.37235452E-03_JPRB, &
  & 0.37219053E-03_JPRB, 0.37204066E-03_JPRB, 0.37191669E-03_JPRB, 0.37182153E-03_JPRB, 0.37174948E-03_JPRB, 0.37168978E-03_JPRB, &
  & 0.37162889E-03_JPRB, 0.37157231E-03_JPRB, 0.37152819E-03_JPRB, 0.37150098E-03_JPRB  /)

RGHG1(:,11,10) = (/ &
  & 0.37397313E-03_JPRB, 0.37397125E-03_JPRB, 0.37396816E-03_JPRB, 0.37396786E-03_JPRB, 0.37396885E-03_JPRB, 0.37397504E-03_JPRB, &
  & 0.37398780E-03_JPRB, 0.37400035E-03_JPRB, 0.37401027E-03_JPRB, 0.37402524E-03_JPRB, 0.37404638E-03_JPRB, 0.37406711E-03_JPRB, &
  & 0.37408236E-03_JPRB, 0.37409135E-03_JPRB, 0.37409678E-03_JPRB, 0.37410036E-03_JPRB, 0.37410462E-03_JPRB, 0.37410813E-03_JPRB, &
  & 0.37411386E-03_JPRB, 0.37412563E-03_JPRB, 0.37413705E-03_JPRB, 0.37415112E-03_JPRB, 0.37416851E-03_JPRB, 0.37420653E-03_JPRB, &
  & 0.37428823E-03_JPRB, 0.37440734E-03_JPRB, 0.37452296E-03_JPRB, 0.37461100E-03_JPRB, 0.37468275E-03_JPRB, 0.37475309E-03_JPRB, &
  & 0.37482501E-03_JPRB, 0.37489703E-03_JPRB, 0.37497510E-03_JPRB, 0.37506381E-03_JPRB, 0.37515331E-03_JPRB, 0.37521346E-03_JPRB, &
  & 0.37522524E-03_JPRB, 0.37520831E-03_JPRB, 0.37517452E-03_JPRB, 0.37513217E-03_JPRB, 0.37508464E-03_JPRB, 0.37501919E-03_JPRB, &
  & 0.37488995E-03_JPRB, 0.37469679E-03_JPRB, 0.37447217E-03_JPRB, 0.37424695E-03_JPRB, 0.37402618E-03_JPRB, 0.37381836E-03_JPRB, &
  & 0.37359031E-03_JPRB, 0.37333328E-03_JPRB, 0.37306309E-03_JPRB, 0.37279095E-03_JPRB, 0.37255289E-03_JPRB, 0.37234713E-03_JPRB, &
  & 0.37217015E-03_JPRB, 0.37201028E-03_JPRB, 0.37187074E-03_JPRB, 0.37176233E-03_JPRB, 0.37168567E-03_JPRB, 0.37162176E-03_JPRB, &
  & 0.37154478E-03_JPRB, 0.37146432E-03_JPRB, 0.37140018E-03_JPRB, 0.37136024E-03_JPRB  /)

RGHG1(:,12,10) = (/ &
  & 0.37393723E-03_JPRB, 0.37393011E-03_JPRB, 0.37392409E-03_JPRB, 0.37392748E-03_JPRB, 0.37393263E-03_JPRB, 0.37394199E-03_JPRB, &
  & 0.37395992E-03_JPRB, 0.37397824E-03_JPRB, 0.37399331E-03_JPRB, 0.37401926E-03_JPRB, 0.37405488E-03_JPRB, 0.37408448E-03_JPRB, &
  & 0.37410689E-03_JPRB, 0.37412056E-03_JPRB, 0.37413182E-03_JPRB, 0.37414131E-03_JPRB, 0.37414792E-03_JPRB, 0.37415088E-03_JPRB, &
  & 0.37415518E-03_JPRB, 0.37416748E-03_JPRB, 0.37417891E-03_JPRB, 0.37420138E-03_JPRB, 0.37424247E-03_JPRB, 0.37432699E-03_JPRB, &
  & 0.37448281E-03_JPRB, 0.37468321E-03_JPRB, 0.37484577E-03_JPRB, 0.37494189E-03_JPRB, 0.37500213E-03_JPRB, 0.37505208E-03_JPRB, &
  & 0.37510565E-03_JPRB, 0.37516622E-03_JPRB, 0.37523634E-03_JPRB, 0.37532239E-03_JPRB, 0.37541809E-03_JPRB, 0.37550184E-03_JPRB, &
  & 0.37555838E-03_JPRB, 0.37559176E-03_JPRB, 0.37560157E-03_JPRB, 0.37559020E-03_JPRB, 0.37554856E-03_JPRB, 0.37545813E-03_JPRB, &
  & 0.37527233E-03_JPRB, 0.37500058E-03_JPRB, 0.37469936E-03_JPRB, 0.37443014E-03_JPRB, 0.37415604E-03_JPRB, 0.37389881E-03_JPRB, &
  & 0.37363102E-03_JPRB, 0.37334289E-03_JPRB, 0.37306036E-03_JPRB, 0.37277996E-03_JPRB, 0.37252616E-03_JPRB, 0.37230471E-03_JPRB, &
  & 0.37211617E-03_JPRB, 0.37195018E-03_JPRB, 0.37180496E-03_JPRB, 0.37168554E-03_JPRB, 0.37160493E-03_JPRB, 0.37153750E-03_JPRB, &
  & 0.37144671E-03_JPRB, 0.37133884E-03_JPRB, 0.37124893E-03_JPRB, 0.37119692E-03_JPRB  /)

RGHG1(:,13,10) = (/ &
  & 0.37386496E-03_JPRB, 0.37384488E-03_JPRB, 0.37384263E-03_JPRB, 0.37385654E-03_JPRB, 0.37387725E-03_JPRB, 0.37389849E-03_JPRB, &
  & 0.37393101E-03_JPRB, 0.37396842E-03_JPRB, 0.37400476E-03_JPRB, 0.37405624E-03_JPRB, 0.37411761E-03_JPRB, 0.37417063E-03_JPRB, &
  & 0.37421244E-03_JPRB, 0.37424371E-03_JPRB, 0.37427099E-03_JPRB, 0.37429884E-03_JPRB, 0.37431931E-03_JPRB, 0.37432583E-03_JPRB, &
  & 0.37432998E-03_JPRB, 0.37433713E-03_JPRB, 0.37434878E-03_JPRB, 0.37438490E-03_JPRB, 0.37446105E-03_JPRB, 0.37461676E-03_JPRB, &
  & 0.37487843E-03_JPRB, 0.37519783E-03_JPRB, 0.37542539E-03_JPRB, 0.37552740E-03_JPRB, 0.37556913E-03_JPRB, 0.37558606E-03_JPRB, &
  & 0.37560206E-03_JPRB, 0.37562866E-03_JPRB, 0.37567645E-03_JPRB, 0.37574961E-03_JPRB, 0.37583747E-03_JPRB, 0.37592322E-03_JPRB, &
  & 0.37599481E-03_JPRB, 0.37604990E-03_JPRB, 0.37608379E-03_JPRB, 0.37608984E-03_JPRB, 0.37605175E-03_JPRB, 0.37594198E-03_JPRB, &
  & 0.37570713E-03_JPRB, 0.37535063E-03_JPRB, 0.37497876E-03_JPRB, 0.37465107E-03_JPRB, 0.37431814E-03_JPRB, 0.37398879E-03_JPRB, &
  & 0.37366852E-03_JPRB, 0.37335997E-03_JPRB, 0.37306364E-03_JPRB, 0.37278495E-03_JPRB, 0.37253406E-03_JPRB, 0.37231493E-03_JPRB, &
  & 0.37212168E-03_JPRB, 0.37194513E-03_JPRB, 0.37179298E-03_JPRB, 0.37166800E-03_JPRB, 0.37158539E-03_JPRB, 0.37151602E-03_JPRB, &
  & 0.37141870E-03_JPRB, 0.37128715E-03_JPRB, 0.37116978E-03_JPRB, 0.37110588E-03_JPRB  /)

RGHG1(:,14,10) = (/ &
  & 0.37384083E-03_JPRB, 0.37381989E-03_JPRB, 0.37382880E-03_JPRB, 0.37385732E-03_JPRB, 0.37389740E-03_JPRB, 0.37393803E-03_JPRB, &
  & 0.37398956E-03_JPRB, 0.37404925E-03_JPRB, 0.37411220E-03_JPRB, 0.37419399E-03_JPRB, 0.37428603E-03_JPRB, 0.37437576E-03_JPRB, &
  & 0.37444877E-03_JPRB, 0.37450583E-03_JPRB, 0.37455839E-03_JPRB, 0.37460652E-03_JPRB, 0.37464220E-03_JPRB, 0.37465699E-03_JPRB, &
  & 0.37466340E-03_JPRB, 0.37466786E-03_JPRB, 0.37468033E-03_JPRB, 0.37472679E-03_JPRB, 0.37483378E-03_JPRB, 0.37504623E-03_JPRB, &
  & 0.37540401E-03_JPRB, 0.37586095E-03_JPRB, 0.37618365E-03_JPRB, 0.37632713E-03_JPRB, 0.37639172E-03_JPRB, 0.37642235E-03_JPRB, &
  & 0.37643681E-03_JPRB, 0.37643560E-03_JPRB, 0.37644962E-03_JPRB, 0.37649320E-03_JPRB, 0.37655105E-03_JPRB, 0.37660715E-03_JPRB, &
  & 0.37665497E-03_JPRB, 0.37668412E-03_JPRB, 0.37668467E-03_JPRB, 0.37665193E-03_JPRB, 0.37658038E-03_JPRB, 0.37643040E-03_JPRB, &
  & 0.37615794E-03_JPRB, 0.37575740E-03_JPRB, 0.37533100E-03_JPRB, 0.37494107E-03_JPRB, 0.37455981E-03_JPRB, 0.37416243E-03_JPRB, &
  & 0.37378712E-03_JPRB, 0.37347010E-03_JPRB, 0.37317330E-03_JPRB, 0.37290364E-03_JPRB, 0.37266823E-03_JPRB, 0.37246312E-03_JPRB, &
  & 0.37228081E-03_JPRB, 0.37210367E-03_JPRB, 0.37194458E-03_JPRB, 0.37181538E-03_JPRB, 0.37172084E-03_JPRB, 0.37164817E-03_JPRB, &
  & 0.37155336E-03_JPRB, 0.37141965E-03_JPRB, 0.37128576E-03_JPRB, 0.37120917E-03_JPRB  /)

RGHG1(:,15,10) = (/ &
  & 0.37390512E-03_JPRB, 0.37390445E-03_JPRB, 0.37392203E-03_JPRB, 0.37396334E-03_JPRB, 0.37401799E-03_JPRB, 0.37407886E-03_JPRB, &
  & 0.37414093E-03_JPRB, 0.37421497E-03_JPRB, 0.37429587E-03_JPRB, 0.37439827E-03_JPRB, 0.37451652E-03_JPRB, 0.37463521E-03_JPRB, &
  & 0.37473899E-03_JPRB, 0.37482168E-03_JPRB, 0.37489950E-03_JPRB, 0.37496076E-03_JPRB, 0.37501032E-03_JPRB, 0.37503543E-03_JPRB, &
  & 0.37504083E-03_JPRB, 0.37504158E-03_JPRB, 0.37504912E-03_JPRB, 0.37509232E-03_JPRB, 0.37520245E-03_JPRB, 0.37543075E-03_JPRB, &
  & 0.37582836E-03_JPRB, 0.37639458E-03_JPRB, 0.37683815E-03_JPRB, 0.37707565E-03_JPRB, 0.37723558E-03_JPRB, 0.37738266E-03_JPRB, &
  & 0.37749033E-03_JPRB, 0.37750848E-03_JPRB, 0.37750891E-03_JPRB, 0.37751505E-03_JPRB, 0.37750934E-03_JPRB, 0.37747812E-03_JPRB, &
  & 0.37742420E-03_JPRB, 0.37735393E-03_JPRB, 0.37725261E-03_JPRB, 0.37711683E-03_JPRB, 0.37695449E-03_JPRB, 0.37674482E-03_JPRB, &
  & 0.37644694E-03_JPRB, 0.37603366E-03_JPRB, 0.37556880E-03_JPRB, 0.37515729E-03_JPRB, 0.37476459E-03_JPRB, 0.37433927E-03_JPRB, &
  & 0.37394476E-03_JPRB, 0.37364272E-03_JPRB, 0.37338298E-03_JPRB, 0.37314805E-03_JPRB, 0.37294107E-03_JPRB, 0.37276381E-03_JPRB, &
  & 0.37260951E-03_JPRB, 0.37245624E-03_JPRB, 0.37231064E-03_JPRB, 0.37218914E-03_JPRB, 0.37209479E-03_JPRB, 0.37202084E-03_JPRB, &
  & 0.37193777E-03_JPRB, 0.37182260E-03_JPRB, 0.37170185E-03_JPRB, 0.37161506E-03_JPRB  /)

RGHG1(:,16,10) = (/ &
  & 0.37399125E-03_JPRB, 0.37401754E-03_JPRB, 0.37404520E-03_JPRB, 0.37408667E-03_JPRB, 0.37415019E-03_JPRB, 0.37422482E-03_JPRB, &
  & 0.37429397E-03_JPRB, 0.37436808E-03_JPRB, 0.37445487E-03_JPRB, 0.37456469E-03_JPRB, 0.37469062E-03_JPRB, 0.37482294E-03_JPRB, &
  & 0.37494645E-03_JPRB, 0.37504823E-03_JPRB, 0.37514328E-03_JPRB, 0.37521464E-03_JPRB, 0.37527044E-03_JPRB, 0.37530127E-03_JPRB, &
  & 0.37530297E-03_JPRB, 0.37529526E-03_JPRB, 0.37529611E-03_JPRB, 0.37532353E-03_JPRB, 0.37541791E-03_JPRB, 0.37562251E-03_JPRB, &
  & 0.37599643E-03_JPRB, 0.37661105E-03_JPRB, 0.37717429E-03_JPRB, 0.37752312E-03_JPRB, 0.37782511E-03_JPRB, 0.37815368E-03_JPRB, &
  & 0.37843915E-03_JPRB, 0.37856163E-03_JPRB, 0.37858380E-03_JPRB, 0.37853661E-03_JPRB, 0.37843659E-03_JPRB, 0.37828291E-03_JPRB, &
  & 0.37807984E-03_JPRB, 0.37786772E-03_JPRB, 0.37763686E-03_JPRB, 0.37737913E-03_JPRB, 0.37710876E-03_JPRB, 0.37684930E-03_JPRB, &
  & 0.37653216E-03_JPRB, 0.37609724E-03_JPRB, 0.37561117E-03_JPRB, 0.37520377E-03_JPRB, 0.37482161E-03_JPRB, 0.37440683E-03_JPRB, &
  & 0.37402966E-03_JPRB, 0.37376398E-03_JPRB, 0.37356441E-03_JPRB, 0.37339103E-03_JPRB, 0.37323295E-03_JPRB, 0.37310136E-03_JPRB, &
  & 0.37298951E-03_JPRB, 0.37287886E-03_JPRB, 0.37277521E-03_JPRB, 0.37268754E-03_JPRB, 0.37262047E-03_JPRB, 0.37256868E-03_JPRB, &
  & 0.37251260E-03_JPRB, 0.37243216E-03_JPRB, 0.37234589E-03_JPRB, 0.37227483E-03_JPRB  /)

RGHG1(:,17,10) = (/ &
  & 0.37399434E-03_JPRB, 0.37404156E-03_JPRB, 0.37407666E-03_JPRB, 0.37411169E-03_JPRB, 0.37417710E-03_JPRB, 0.37425777E-03_JPRB, &
  & 0.37433852E-03_JPRB, 0.37441279E-03_JPRB, 0.37449996E-03_JPRB, 0.37460973E-03_JPRB, 0.37474137E-03_JPRB, 0.37487453E-03_JPRB, &
  & 0.37500830E-03_JPRB, 0.37512530E-03_JPRB, 0.37523056E-03_JPRB, 0.37530878E-03_JPRB, 0.37536568E-03_JPRB, 0.37539733E-03_JPRB, &
  & 0.37539790E-03_JPRB, 0.37538490E-03_JPRB, 0.37537793E-03_JPRB, 0.37539885E-03_JPRB, 0.37547743E-03_JPRB, 0.37563117E-03_JPRB, &
  & 0.37594542E-03_JPRB, 0.37653609E-03_JPRB, 0.37715230E-03_JPRB, 0.37760032E-03_JPRB, 0.37803817E-03_JPRB, 0.37852086E-03_JPRB, &
  & 0.37896303E-03_JPRB, 0.37925215E-03_JPRB, 0.37935342E-03_JPRB, 0.37927673E-03_JPRB, 0.37907496E-03_JPRB, 0.37880475E-03_JPRB, &
  & 0.37850405E-03_JPRB, 0.37820046E-03_JPRB, 0.37786806E-03_JPRB, 0.37751324E-03_JPRB, 0.37715501E-03_JPRB, 0.37684410E-03_JPRB, &
  & 0.37649700E-03_JPRB, 0.37602142E-03_JPRB, 0.37553431E-03_JPRB, 0.37512444E-03_JPRB, 0.37474274E-03_JPRB, 0.37434445E-03_JPRB, &
  & 0.37398714E-03_JPRB, 0.37375204E-03_JPRB, 0.37360463E-03_JPRB, 0.37348964E-03_JPRB, 0.37339051E-03_JPRB, 0.37330356E-03_JPRB, &
  & 0.37323163E-03_JPRB, 0.37316563E-03_JPRB, 0.37310857E-03_JPRB, 0.37307209E-03_JPRB, 0.37304072E-03_JPRB, 0.37301963E-03_JPRB, &
  & 0.37299779E-03_JPRB, 0.37295341E-03_JPRB, 0.37290726E-03_JPRB, 0.37287584E-03_JPRB  /)

RGHG1(:,18,10) = (/ &
  & 0.37385646E-03_JPRB, 0.37390482E-03_JPRB, 0.37394237E-03_JPRB, 0.37397534E-03_JPRB, 0.37404079E-03_JPRB, 0.37413253E-03_JPRB, &
  & 0.37423425E-03_JPRB, 0.37432454E-03_JPRB, 0.37442197E-03_JPRB, 0.37453835E-03_JPRB, 0.37468265E-03_JPRB, 0.37482306E-03_JPRB, &
  & 0.37496459E-03_JPRB, 0.37509446E-03_JPRB, 0.37520726E-03_JPRB, 0.37529096E-03_JPRB, 0.37534987E-03_JPRB, 0.37538062E-03_JPRB, &
  & 0.37538538E-03_JPRB, 0.37537186E-03_JPRB, 0.37536103E-03_JPRB, 0.37538412E-03_JPRB, 0.37544950E-03_JPRB, 0.37556078E-03_JPRB, &
  & 0.37579810E-03_JPRB, 0.37630280E-03_JPRB, 0.37690204E-03_JPRB, 0.37743366E-03_JPRB, 0.37797359E-03_JPRB, 0.37855349E-03_JPRB, &
  & 0.37914098E-03_JPRB, 0.37960286E-03_JPRB, 0.37980419E-03_JPRB, 0.37973350E-03_JPRB, 0.37948246E-03_JPRB, 0.37914623E-03_JPRB, &
  & 0.37879984E-03_JPRB, 0.37846276E-03_JPRB, 0.37809881E-03_JPRB, 0.37769756E-03_JPRB, 0.37725141E-03_JPRB, 0.37684997E-03_JPRB, &
  & 0.37646175E-03_JPRB, 0.37593264E-03_JPRB, 0.37544108E-03_JPRB, 0.37501529E-03_JPRB, 0.37461119E-03_JPRB, 0.37421191E-03_JPRB, &
  & 0.37385769E-03_JPRB, 0.37363793E-03_JPRB, 0.37352550E-03_JPRB, 0.37344930E-03_JPRB, 0.37339599E-03_JPRB, 0.37334757E-03_JPRB, &
  & 0.37330043E-03_JPRB, 0.37326334E-03_JPRB, 0.37324140E-03_JPRB, 0.37323599E-03_JPRB, 0.37322493E-03_JPRB, 0.37322221E-03_JPRB, &
  & 0.37322515E-03_JPRB, 0.37320704E-03_JPRB, 0.37318173E-03_JPRB, 0.37316675E-03_JPRB  /)

RGHG1(:,19,10) = (/ &
  & 0.37363330E-03_JPRB, 0.37367169E-03_JPRB, 0.37371227E-03_JPRB, 0.37374375E-03_JPRB, 0.37381012E-03_JPRB, 0.37391839E-03_JPRB, &
  & 0.37404706E-03_JPRB, 0.37416638E-03_JPRB, 0.37428453E-03_JPRB, 0.37441945E-03_JPRB, 0.37457546E-03_JPRB, 0.37473362E-03_JPRB, &
  & 0.37488745E-03_JPRB, 0.37502923E-03_JPRB, 0.37515081E-03_JPRB, 0.37524024E-03_JPRB, 0.37530475E-03_JPRB, 0.37533878E-03_JPRB, &
  & 0.37535011E-03_JPRB, 0.37534027E-03_JPRB, 0.37533771E-03_JPRB, 0.37536314E-03_JPRB, 0.37541070E-03_JPRB, 0.37549182E-03_JPRB, &
  & 0.37567355E-03_JPRB, 0.37609847E-03_JPRB, 0.37666059E-03_JPRB, 0.37725290E-03_JPRB, 0.37788262E-03_JPRB, 0.37856009E-03_JPRB, &
  & 0.37928425E-03_JPRB, 0.37987640E-03_JPRB, 0.38014505E-03_JPRB, 0.38009252E-03_JPRB, 0.37984656E-03_JPRB, 0.37950243E-03_JPRB, &
  & 0.37914256E-03_JPRB, 0.37879841E-03_JPRB, 0.37844626E-03_JPRB, 0.37804775E-03_JPRB, 0.37752872E-03_JPRB, 0.37698499E-03_JPRB, &
  & 0.37651636E-03_JPRB, 0.37594573E-03_JPRB, 0.37543087E-03_JPRB, 0.37498556E-03_JPRB, 0.37455035E-03_JPRB, 0.37412694E-03_JPRB, &
  & 0.37377423E-03_JPRB, 0.37355297E-03_JPRB, 0.37345419E-03_JPRB, 0.37339497E-03_JPRB, 0.37336430E-03_JPRB, 0.37334044E-03_JPRB, &
  & 0.37330677E-03_JPRB, 0.37328155E-03_JPRB, 0.37328159E-03_JPRB, 0.37329307E-03_JPRB, 0.37329003E-03_JPRB, 0.37328968E-03_JPRB, &
  & 0.37330463E-03_JPRB, 0.37330015E-03_JPRB, 0.37327749E-03_JPRB, 0.37326206E-03_JPRB  /)

RGHG1(:,20,10) = (/ &
  & 0.37345079E-03_JPRB, 0.37347260E-03_JPRB, 0.37351127E-03_JPRB, 0.37354461E-03_JPRB, 0.37361019E-03_JPRB, 0.37372871E-03_JPRB, &
  & 0.37387660E-03_JPRB, 0.37402520E-03_JPRB, 0.37416630E-03_JPRB, 0.37432187E-03_JPRB, 0.37448784E-03_JPRB, 0.37466921E-03_JPRB, &
  & 0.37484261E-03_JPRB, 0.37499836E-03_JPRB, 0.37512988E-03_JPRB, 0.37523090E-03_JPRB, 0.37530766E-03_JPRB, 0.37535138E-03_JPRB, &
  & 0.37537057E-03_JPRB, 0.37537002E-03_JPRB, 0.37537841E-03_JPRB, 0.37540476E-03_JPRB, 0.37543993E-03_JPRB, 0.37550589E-03_JPRB, &
  & 0.37565451E-03_JPRB, 0.37601613E-03_JPRB, 0.37654816E-03_JPRB, 0.37719618E-03_JPRB, 0.37791547E-03_JPRB, 0.37870325E-03_JPRB, &
  & 0.37954363E-03_JPRB, 0.38020611E-03_JPRB, 0.38051085E-03_JPRB, 0.38049361E-03_JPRB, 0.38029051E-03_JPRB, 0.37997799E-03_JPRB, &
  & 0.37961797E-03_JPRB, 0.37928595E-03_JPRB, 0.37897038E-03_JPRB, 0.37858690E-03_JPRB, 0.37801060E-03_JPRB, 0.37733197E-03_JPRB, &
  & 0.37675592E-03_JPRB, 0.37614851E-03_JPRB, 0.37559257E-03_JPRB, 0.37512134E-03_JPRB, 0.37466288E-03_JPRB, 0.37420670E-03_JPRB, &
  & 0.37385642E-03_JPRB, 0.37363170E-03_JPRB, 0.37353006E-03_JPRB, 0.37347091E-03_JPRB, 0.37344053E-03_JPRB, 0.37342256E-03_JPRB, &
  & 0.37339269E-03_JPRB, 0.37336444E-03_JPRB, 0.37336769E-03_JPRB, 0.37338391E-03_JPRB, 0.37338397E-03_JPRB, 0.37337737E-03_JPRB, &
  & 0.37339195E-03_JPRB, 0.37338876E-03_JPRB, 0.37335738E-03_JPRB, 0.37332958E-03_JPRB  /)

RGHG1(:,21,10) = (/ &
  & 0.37337028E-03_JPRB, 0.37337498E-03_JPRB, 0.37340418E-03_JPRB, 0.37343753E-03_JPRB, 0.37349707E-03_JPRB, 0.37361513E-03_JPRB, &
  & 0.37377111E-03_JPRB, 0.37394216E-03_JPRB, 0.37410399E-03_JPRB, 0.37427788E-03_JPRB, 0.37445534E-03_JPRB, 0.37466200E-03_JPRB, &
  & 0.37486167E-03_JPRB, 0.37503700E-03_JPRB, 0.37518233E-03_JPRB, 0.37530086E-03_JPRB, 0.37539518E-03_JPRB, 0.37545294E-03_JPRB, &
  & 0.37548183E-03_JPRB, 0.37549461E-03_JPRB, 0.37551440E-03_JPRB, 0.37554441E-03_JPRB, 0.37557749E-03_JPRB, 0.37564186E-03_JPRB, &
  & 0.37577307E-03_JPRB, 0.37608906E-03_JPRB, 0.37660405E-03_JPRB, 0.37730488E-03_JPRB, 0.37811775E-03_JPRB, 0.37901932E-03_JPRB, &
  & 0.37994249E-03_JPRB, 0.38061952E-03_JPRB, 0.38093912E-03_JPRB, 0.38097117E-03_JPRB, 0.38083031E-03_JPRB, 0.38057134E-03_JPRB, &
  & 0.38022641E-03_JPRB, 0.37991945E-03_JPRB, 0.37964670E-03_JPRB, 0.37927975E-03_JPRB, 0.37866673E-03_JPRB, 0.37789463E-03_JPRB, &
  & 0.37721589E-03_JPRB, 0.37657546E-03_JPRB, 0.37596709E-03_JPRB, 0.37546263E-03_JPRB, 0.37499530E-03_JPRB, 0.37451314E-03_JPRB, &
  & 0.37416878E-03_JPRB, 0.37394657E-03_JPRB, 0.37382801E-03_JPRB, 0.37375696E-03_JPRB, 0.37371097E-03_JPRB, 0.37367907E-03_JPRB, &
  & 0.37364113E-03_JPRB, 0.37359790E-03_JPRB, 0.37358689E-03_JPRB, 0.37359767E-03_JPRB, 0.37359666E-03_JPRB, 0.37358157E-03_JPRB, &
  & 0.37358645E-03_JPRB, 0.37357585E-03_JPRB, 0.37353203E-03_JPRB, 0.37348670E-03_JPRB  /)

RGHG1(:,22,10) = (/ &
  & 0.37343154E-03_JPRB, 0.37342679E-03_JPRB, 0.37343787E-03_JPRB, 0.37345832E-03_JPRB, 0.37350207E-03_JPRB, 0.37360779E-03_JPRB, &
  & 0.37376210E-03_JPRB, 0.37394383E-03_JPRB, 0.37412145E-03_JPRB, 0.37431034E-03_JPRB, 0.37450593E-03_JPRB, 0.37473793E-03_JPRB, &
  & 0.37496896E-03_JPRB, 0.37517397E-03_JPRB, 0.37534221E-03_JPRB, 0.37548130E-03_JPRB, 0.37559508E-03_JPRB, 0.37566730E-03_JPRB, &
  & 0.37570919E-03_JPRB, 0.37573609E-03_JPRB, 0.37577100E-03_JPRB, 0.37581480E-03_JPRB, 0.37585822E-03_JPRB, 0.37593248E-03_JPRB, &
  & 0.37605647E-03_JPRB, 0.37634966E-03_JPRB, 0.37685976E-03_JPRB, 0.37760017E-03_JPRB, 0.37851110E-03_JPRB, 0.37951128E-03_JPRB, &
  & 0.38046436E-03_JPRB, 0.38110570E-03_JPRB, 0.38142597E-03_JPRB, 0.38151183E-03_JPRB, 0.38143478E-03_JPRB, 0.38123742E-03_JPRB, &
  & 0.38093840E-03_JPRB, 0.38066223E-03_JPRB, 0.38041762E-03_JPRB, 0.38007479E-03_JPRB, 0.37945865E-03_JPRB, 0.37865788E-03_JPRB, &
  & 0.37792466E-03_JPRB, 0.37726155E-03_JPRB, 0.37659714E-03_JPRB, 0.37605299E-03_JPRB, 0.37559467E-03_JPRB, 0.37511006E-03_JPRB, &
  & 0.37477970E-03_JPRB, 0.37456995E-03_JPRB, 0.37441915E-03_JPRB, 0.37432741E-03_JPRB, 0.37425708E-03_JPRB, 0.37418927E-03_JPRB, &
  & 0.37412553E-03_JPRB, 0.37405741E-03_JPRB, 0.37401815E-03_JPRB, 0.37401470E-03_JPRB, 0.37400468E-03_JPRB, 0.37398415E-03_JPRB, &
  & 0.37397336E-03_JPRB, 0.37395108E-03_JPRB, 0.37389914E-03_JPRB, 0.37383947E-03_JPRB  /)

RGHG1(:,23,10) = (/ &
  & 0.37355112E-03_JPRB, 0.37354017E-03_JPRB, 0.37353488E-03_JPRB, 0.37354123E-03_JPRB, 0.37357109E-03_JPRB, 0.37366826E-03_JPRB, &
  & 0.37382813E-03_JPRB, 0.37402051E-03_JPRB, 0.37421177E-03_JPRB, 0.37441500E-03_JPRB, 0.37463058E-03_JPRB, 0.37488861E-03_JPRB, &
  & 0.37514943E-03_JPRB, 0.37539033E-03_JPRB, 0.37558565E-03_JPRB, 0.37573573E-03_JPRB, 0.37585824E-03_JPRB, 0.37593545E-03_JPRB, &
  & 0.37598084E-03_JPRB, 0.37601729E-03_JPRB, 0.37606470E-03_JPRB, 0.37612376E-03_JPRB, 0.37619266E-03_JPRB, 0.37629138E-03_JPRB, &
  & 0.37643534E-03_JPRB, 0.37675179E-03_JPRB, 0.37728982E-03_JPRB, 0.37805362E-03_JPRB, 0.37901044E-03_JPRB, 0.38005118E-03_JPRB, &
  & 0.38098020E-03_JPRB, 0.38156473E-03_JPRB, 0.38186827E-03_JPRB, 0.38198549E-03_JPRB, 0.38194738E-03_JPRB, 0.38180382E-03_JPRB, &
  & 0.38157206E-03_JPRB, 0.38132333E-03_JPRB, 0.38107702E-03_JPRB, 0.38075212E-03_JPRB, 0.38018074E-03_JPRB, 0.37943713E-03_JPRB, &
  & 0.37870397E-03_JPRB, 0.37801761E-03_JPRB, 0.37734627E-03_JPRB, 0.37677890E-03_JPRB, 0.37633335E-03_JPRB, 0.37588048E-03_JPRB, &
  & 0.37556887E-03_JPRB, 0.37536883E-03_JPRB, 0.37520264E-03_JPRB, 0.37508681E-03_JPRB, 0.37498862E-03_JPRB, 0.37489050E-03_JPRB, &
  & 0.37479626E-03_JPRB, 0.37470313E-03_JPRB, 0.37463841E-03_JPRB, 0.37461319E-03_JPRB, 0.37458615E-03_JPRB, 0.37457376E-03_JPRB, &
  & 0.37456146E-03_JPRB, 0.37453142E-03_JPRB, 0.37448157E-03_JPRB, 0.37440985E-03_JPRB  /)

RGHG1(:,24,10) = (/ &
  & 0.37365112E-03_JPRB, 0.37364086E-03_JPRB, 0.37362577E-03_JPRB, 0.37362258E-03_JPRB, 0.37364585E-03_JPRB, 0.37374256E-03_JPRB, &
  & 0.37391420E-03_JPRB, 0.37412142E-03_JPRB, 0.37432773E-03_JPRB, 0.37454667E-03_JPRB, 0.37478299E-03_JPRB, 0.37506665E-03_JPRB, &
  & 0.37535826E-03_JPRB, 0.37563317E-03_JPRB, 0.37585164E-03_JPRB, 0.37600941E-03_JPRB, 0.37613534E-03_JPRB, 0.37621338E-03_JPRB, &
  & 0.37625874E-03_JPRB, 0.37630230E-03_JPRB, 0.37635799E-03_JPRB, 0.37643053E-03_JPRB, 0.37653122E-03_JPRB, 0.37666087E-03_JPRB, &
  & 0.37684282E-03_JPRB, 0.37720678E-03_JPRB, 0.37778247E-03_JPRB, 0.37857092E-03_JPRB, 0.37955001E-03_JPRB, 0.38059562E-03_JPRB, &
  & 0.38147459E-03_JPRB, 0.38199855E-03_JPRB, 0.38228140E-03_JPRB, 0.38241986E-03_JPRB, 0.38241173E-03_JPRB, 0.38231405E-03_JPRB, &
  & 0.38214442E-03_JPRB, 0.38192176E-03_JPRB, 0.38166547E-03_JPRB, 0.38134802E-03_JPRB, 0.38083527E-03_JPRB, 0.38017371E-03_JPRB, &
  & 0.37945618E-03_JPRB, 0.37875457E-03_JPRB, 0.37810199E-03_JPRB, 0.37752896E-03_JPRB, 0.37709486E-03_JPRB, 0.37669169E-03_JPRB, &
  & 0.37640433E-03_JPRB, 0.37620862E-03_JPRB, 0.37603395E-03_JPRB, 0.37589819E-03_JPRB, 0.37577184E-03_JPRB, 0.37565111E-03_JPRB, &
  & 0.37553442E-03_JPRB, 0.37542097E-03_JPRB, 0.37533478E-03_JPRB, 0.37528935E-03_JPRB, 0.37524931E-03_JPRB, 0.37524289E-03_JPRB, &
  & 0.37523458E-03_JPRB, 0.37520577E-03_JPRB, 0.37515864E-03_JPRB, 0.37507766E-03_JPRB  /)

RGHG1(:,25,10) = (/ &
  & 0.37369881E-03_JPRB, 0.37370069E-03_JPRB, 0.37368748E-03_JPRB, 0.37368354E-03_JPRB, 0.37371302E-03_JPRB, 0.37382281E-03_JPRB, &
  & 0.37401505E-03_JPRB, 0.37424381E-03_JPRB, 0.37446752E-03_JPRB, 0.37470406E-03_JPRB, 0.37496108E-03_JPRB, 0.37526835E-03_JPRB, &
  & 0.37559147E-03_JPRB, 0.37589414E-03_JPRB, 0.37612681E-03_JPRB, 0.37628824E-03_JPRB, 0.37641041E-03_JPRB, 0.37648403E-03_JPRB, &
  & 0.37652526E-03_JPRB, 0.37657230E-03_JPRB, 0.37662902E-03_JPRB, 0.37671097E-03_JPRB, 0.37684976E-03_JPRB, 0.37701713E-03_JPRB, &
  & 0.37726117E-03_JPRB, 0.37770312E-03_JPRB, 0.37832462E-03_JPRB, 0.37914252E-03_JPRB, 0.38011277E-03_JPRB, 0.38111284E-03_JPRB, &
  & 0.38191006E-03_JPRB, 0.38237428E-03_JPRB, 0.38263427E-03_JPRB, 0.38278017E-03_JPRB, 0.38279038E-03_JPRB, 0.38272422E-03_JPRB, &
  & 0.38260003E-03_JPRB, 0.38240060E-03_JPRB, 0.38212681E-03_JPRB, 0.38179930E-03_JPRB, 0.38135634E-03_JPRB, 0.38079789E-03_JPRB, &
  & 0.38011066E-03_JPRB, 0.37940876E-03_JPRB, 0.37880858E-03_JPRB, 0.37825757E-03_JPRB, 0.37783118E-03_JPRB, 0.37749960E-03_JPRB, &
  & 0.37724413E-03_JPRB, 0.37704362E-03_JPRB, 0.37686933E-03_JPRB, 0.37672266E-03_JPRB, 0.37656969E-03_JPRB, 0.37643974E-03_JPRB, &
  & 0.37631694E-03_JPRB, 0.37619238E-03_JPRB, 0.37609218E-03_JPRB, 0.37603188E-03_JPRB, 0.37598836E-03_JPRB, 0.37598071E-03_JPRB, &
  & 0.37598275E-03_JPRB, 0.37597022E-03_JPRB, 0.37592450E-03_JPRB, 0.37583910E-03_JPRB  /)

RGHG1(:,26,10) = (/ &
  & 0.37364071E-03_JPRB, 0.37367378E-03_JPRB, 0.37367916E-03_JPRB, 0.37368717E-03_JPRB, 0.37373500E-03_JPRB, 0.37386948E-03_JPRB, &
  & 0.37409370E-03_JPRB, 0.37435524E-03_JPRB, 0.37460496E-03_JPRB, 0.37486233E-03_JPRB, 0.37514262E-03_JPRB, 0.37547206E-03_JPRB, &
  & 0.37582129E-03_JPRB, 0.37613878E-03_JPRB, 0.37637895E-03_JPRB, 0.37653961E-03_JPRB, 0.37665800E-03_JPRB, 0.37672941E-03_JPRB, &
  & 0.37677129E-03_JPRB, 0.37682160E-03_JPRB, 0.37688181E-03_JPRB, 0.37697410E-03_JPRB, 0.37714312E-03_JPRB, 0.37735105E-03_JPRB, &
  & 0.37767487E-03_JPRB, 0.37819109E-03_JPRB, 0.37885254E-03_JPRB, 0.37969376E-03_JPRB, 0.38063616E-03_JPRB, 0.38156129E-03_JPRB, &
  & 0.38226168E-03_JPRB, 0.38266626E-03_JPRB, 0.38291023E-03_JPRB, 0.38306935E-03_JPRB, 0.38309806E-03_JPRB, 0.38303990E-03_JPRB, &
  & 0.38292959E-03_JPRB, 0.38273792E-03_JPRB, 0.38246116E-03_JPRB, 0.38213863E-03_JPRB, 0.38174389E-03_JPRB, 0.38125370E-03_JPRB, &
  & 0.38060496E-03_JPRB, 0.37993887E-03_JPRB, 0.37937658E-03_JPRB, 0.37886201E-03_JPRB, 0.37845796E-03_JPRB, 0.37817791E-03_JPRB, &
  & 0.37796110E-03_JPRB, 0.37777365E-03_JPRB, 0.37760107E-03_JPRB, 0.37744361E-03_JPRB, 0.37728212E-03_JPRB, 0.37715111E-03_JPRB, &
  & 0.37703365E-03_JPRB, 0.37691759E-03_JPRB, 0.37681924E-03_JPRB, 0.37675715E-03_JPRB, 0.37671545E-03_JPRB, 0.37670085E-03_JPRB, &
  & 0.37670511E-03_JPRB, 0.37671598E-03_JPRB, 0.37667801E-03_JPRB, 0.37658996E-03_JPRB  /)

RGHG1(:,27,10) = (/ &
  & 0.37354073E-03_JPRB, 0.37361347E-03_JPRB, 0.37364449E-03_JPRB, 0.37366970E-03_JPRB, 0.37374123E-03_JPRB, 0.37390582E-03_JPRB, &
  & 0.37416769E-03_JPRB, 0.37446768E-03_JPRB, 0.37474777E-03_JPRB, 0.37502814E-03_JPRB, 0.37533371E-03_JPRB, 0.37568580E-03_JPRB, &
  & 0.37606030E-03_JPRB, 0.37638850E-03_JPRB, 0.37663403E-03_JPRB, 0.37679223E-03_JPRB, 0.37690667E-03_JPRB, 0.37697659E-03_JPRB, &
  & 0.37702092E-03_JPRB, 0.37707457E-03_JPRB, 0.37713935E-03_JPRB, 0.37724278E-03_JPRB, 0.37744051E-03_JPRB, 0.37769189E-03_JPRB, &
  & 0.37810568E-03_JPRB, 0.37869818E-03_JPRB, 0.37939921E-03_JPRB, 0.38026255E-03_JPRB, 0.38116879E-03_JPRB, 0.38200465E-03_JPRB, &
  & 0.38259822E-03_JPRB, 0.38294047E-03_JPRB, 0.38317022E-03_JPRB, 0.38334532E-03_JPRB, 0.38339343E-03_JPRB, 0.38333492E-03_JPRB, &
  & 0.38322741E-03_JPRB, 0.38303811E-03_JPRB, 0.38276364E-03_JPRB, 0.38245191E-03_JPRB, 0.38209956E-03_JPRB, 0.38166783E-03_JPRB, &
  & 0.38106236E-03_JPRB, 0.38044709E-03_JPRB, 0.37991904E-03_JPRB, 0.37944792E-03_JPRB, 0.37907266E-03_JPRB, 0.37883904E-03_JPRB, &
  & 0.37866516E-03_JPRB, 0.37849798E-03_JPRB, 0.37832768E-03_JPRB, 0.37815899E-03_JPRB, 0.37799530E-03_JPRB, 0.37786623E-03_JPRB, &
  & 0.37775860E-03_JPRB, 0.37765869E-03_JPRB, 0.37756815E-03_JPRB, 0.37750905E-03_JPRB, 0.37747121E-03_JPRB, 0.37744722E-03_JPRB, &
  & 0.37745077E-03_JPRB, 0.37748877E-03_JPRB, 0.37746124E-03_JPRB, 0.37737109E-03_JPRB  /)

RGHG1(:,28,10) = (/ &
  & 0.37331114E-03_JPRB, 0.37343299E-03_JPRB, 0.37351431E-03_JPRB, 0.37359110E-03_JPRB, 0.37370209E-03_JPRB, 0.37390018E-03_JPRB, &
  & 0.37420453E-03_JPRB, 0.37455701E-03_JPRB, 0.37488038E-03_JPRB, 0.37519107E-03_JPRB, 0.37552275E-03_JPRB, 0.37589743E-03_JPRB, &
  & 0.37628655E-03_JPRB, 0.37661713E-03_JPRB, 0.37686447E-03_JPRB, 0.37702025E-03_JPRB, 0.37713235E-03_JPRB, 0.37720178E-03_JPRB, &
  & 0.37724868E-03_JPRB, 0.37731272E-03_JPRB, 0.37740113E-03_JPRB, 0.37753514E-03_JPRB, 0.37776240E-03_JPRB, 0.37807986E-03_JPRB, &
  & 0.37858719E-03_JPRB, 0.37921363E-03_JPRB, 0.37988462E-03_JPRB, 0.38070813E-03_JPRB, 0.38155352E-03_JPRB, 0.38229303E-03_JPRB, &
  & 0.38279640E-03_JPRB, 0.38309820E-03_JPRB, 0.38333321E-03_JPRB, 0.38353741E-03_JPRB, 0.38360397E-03_JPRB, 0.38353657E-03_JPRB, &
  & 0.38341628E-03_JPRB, 0.38322948E-03_JPRB, 0.38296973E-03_JPRB, 0.38267663E-03_JPRB, 0.38233782E-03_JPRB, 0.38191516E-03_JPRB, &
  & 0.38136710E-03_JPRB, 0.38080210E-03_JPRB, 0.38030292E-03_JPRB, 0.37985564E-03_JPRB, 0.37949346E-03_JPRB, 0.37927237E-03_JPRB, &
  & 0.37913731E-03_JPRB, 0.37899190E-03_JPRB, 0.37883298E-03_JPRB, 0.37866851E-03_JPRB, 0.37851354E-03_JPRB, 0.37839008E-03_JPRB, &
  & 0.37829609E-03_JPRB, 0.37822128E-03_JPRB, 0.37814889E-03_JPRB, 0.37809187E-03_JPRB, 0.37805127E-03_JPRB, 0.37802087E-03_JPRB, &
  & 0.37802869E-03_JPRB, 0.37807249E-03_JPRB, 0.37806408E-03_JPRB, 0.37799387E-03_JPRB  /)

RGHG1(:,29,10) = (/ &
  & 0.37306225E-03_JPRB, 0.37323655E-03_JPRB, 0.37337224E-03_JPRB, 0.37350517E-03_JPRB, 0.37365864E-03_JPRB, 0.37389239E-03_JPRB, &
  & 0.37424196E-03_JPRB, 0.37465065E-03_JPRB, 0.37502044E-03_JPRB, 0.37536359E-03_JPRB, 0.37572297E-03_JPRB, 0.37612159E-03_JPRB, &
  & 0.37652572E-03_JPRB, 0.37685847E-03_JPRB, 0.37710758E-03_JPRB, 0.37726079E-03_JPRB, 0.37737048E-03_JPRB, 0.37743942E-03_JPRB, &
  & 0.37748906E-03_JPRB, 0.37756442E-03_JPRB, 0.37767869E-03_JPRB, 0.37784596E-03_JPRB, 0.37810453E-03_JPRB, 0.37849299E-03_JPRB, &
  & 0.37909958E-03_JPRB, 0.37976016E-03_JPRB, 0.38039629E-03_JPRB, 0.38117491E-03_JPRB, 0.38195477E-03_JPRB, 0.38259188E-03_JPRB, &
  & 0.38300040E-03_JPRB, 0.38326027E-03_JPRB, 0.38350171E-03_JPRB, 0.38373731E-03_JPRB, 0.38382339E-03_JPRB, 0.38374618E-03_JPRB, &
  & 0.38361168E-03_JPRB, 0.38342753E-03_JPRB, 0.38318393E-03_JPRB, 0.38291090E-03_JPRB, 0.38258518E-03_JPRB, 0.38217000E-03_JPRB, &
  & 0.38168337E-03_JPRB, 0.38117162E-03_JPRB, 0.38070280E-03_JPRB, 0.38027994E-03_JPRB, 0.37993093E-03_JPRB, 0.37972164E-03_JPRB, &
  & 0.37962754E-03_JPRB, 0.37950526E-03_JPRB, 0.37935879E-03_JPRB, 0.37919946E-03_JPRB, 0.37905421E-03_JPRB, 0.37893685E-03_JPRB, &
  & 0.37885748E-03_JPRB, 0.37880966E-03_JPRB, 0.37875694E-03_JPRB, 0.37870209E-03_JPRB, 0.37865828E-03_JPRB, 0.37862121E-03_JPRB, &
  & 0.37863376E-03_JPRB, 0.37868279E-03_JPRB, 0.37869502E-03_JPRB, 0.37864690E-03_JPRB  /)

RGHG1(:,30,10) = (/ &
  & 0.37291132E-03_JPRB, 0.37314677E-03_JPRB, 0.37332230E-03_JPRB, 0.37351370E-03_JPRB, 0.37371716E-03_JPRB, 0.37398001E-03_JPRB, &
  & 0.37435699E-03_JPRB, 0.37480370E-03_JPRB, 0.37521600E-03_JPRB, 0.37558669E-03_JPRB, 0.37596741E-03_JPRB, 0.37638989E-03_JPRB, &
  & 0.37681210E-03_JPRB, 0.37715502E-03_JPRB, 0.37740469E-03_JPRB, 0.37757200E-03_JPRB, 0.37769468E-03_JPRB, 0.37776955E-03_JPRB, &
  & 0.37782426E-03_JPRB, 0.37793336E-03_JPRB, 0.37810889E-03_JPRB, 0.37835352E-03_JPRB, 0.37867901E-03_JPRB, 0.37912214E-03_JPRB, &
  & 0.37972953E-03_JPRB, 0.38033045E-03_JPRB, 0.38089359E-03_JPRB, 0.38153614E-03_JPRB, 0.38220475E-03_JPRB, 0.38276557E-03_JPRB, &
  & 0.38312546E-03_JPRB, 0.38337344E-03_JPRB, 0.38362392E-03_JPRB, 0.38386039E-03_JPRB, 0.38394861E-03_JPRB, 0.38387238E-03_JPRB, &
  & 0.38373646E-03_JPRB, 0.38356656E-03_JPRB, 0.38334710E-03_JPRB, 0.38309032E-03_JPRB, 0.38277421E-03_JPRB, 0.38238372E-03_JPRB, &
  & 0.38194908E-03_JPRB, 0.38150765E-03_JPRB, 0.38108090E-03_JPRB, 0.38068530E-03_JPRB, 0.38034688E-03_JPRB, 0.38013507E-03_JPRB, &
  & 0.38003324E-03_JPRB, 0.37991226E-03_JPRB, 0.37976862E-03_JPRB, 0.37961662E-03_JPRB, 0.37946842E-03_JPRB, 0.37935262E-03_JPRB, &
  & 0.37927933E-03_JPRB, 0.37923675E-03_JPRB, 0.37919633E-03_JPRB, 0.37914078E-03_JPRB, 0.37909555E-03_JPRB, 0.37906567E-03_JPRB, &
  & 0.37908642E-03_JPRB, 0.37913657E-03_JPRB, 0.37914332E-03_JPRB, 0.37913007E-03_JPRB  /)

RGHG1(:,31,10) = (/ &
  & 0.37275239E-03_JPRB, 0.37305227E-03_JPRB, 0.37326977E-03_JPRB, 0.37352277E-03_JPRB, 0.37377891E-03_JPRB, 0.37407242E-03_JPRB, &
  & 0.37447828E-03_JPRB, 0.37496501E-03_JPRB, 0.37542211E-03_JPRB, 0.37582181E-03_JPRB, 0.37622501E-03_JPRB, 0.37667263E-03_JPRB, &
  & 0.37711389E-03_JPRB, 0.37746752E-03_JPRB, 0.37771779E-03_JPRB, 0.37789998E-03_JPRB, 0.37803635E-03_JPRB, 0.37811747E-03_JPRB, &
  & 0.37817754E-03_JPRB, 0.37832221E-03_JPRB, 0.37856232E-03_JPRB, 0.37888850E-03_JPRB, 0.37928452E-03_JPRB, 0.37978525E-03_JPRB, &
  & 0.38039338E-03_JPRB, 0.38093135E-03_JPRB, 0.38141756E-03_JPRB, 0.38191665E-03_JPRB, 0.38246800E-03_JPRB, 0.38294846E-03_JPRB, &
  & 0.38325716E-03_JPRB, 0.38349264E-03_JPRB, 0.38375264E-03_JPRB, 0.38399001E-03_JPRB, 0.38408046E-03_JPRB, 0.38400527E-03_JPRB, &
  & 0.38386786E-03_JPRB, 0.38371299E-03_JPRB, 0.38351898E-03_JPRB, 0.38327931E-03_JPRB, 0.38297332E-03_JPRB, 0.38260887E-03_JPRB, &
  & 0.38222899E-03_JPRB, 0.38186168E-03_JPRB, 0.38147927E-03_JPRB, 0.38111239E-03_JPRB, 0.38078514E-03_JPRB, 0.38057064E-03_JPRB, &
  & 0.38046063E-03_JPRB, 0.38034098E-03_JPRB, 0.38020032E-03_JPRB, 0.38005607E-03_JPRB, 0.37990474E-03_JPRB, 0.37979058E-03_JPRB, &
  & 0.37972369E-03_JPRB, 0.37968661E-03_JPRB, 0.37965913E-03_JPRB, 0.37960284E-03_JPRB, 0.37955612E-03_JPRB, 0.37953383E-03_JPRB, &
  & 0.37956321E-03_JPRB, 0.37961456E-03_JPRB, 0.37961551E-03_JPRB, 0.37963901E-03_JPRB  /)

RGHG1(:,32,10) = (/ &
  & 0.37283960E-03_JPRB, 0.37316770E-03_JPRB, 0.37341860E-03_JPRB, 0.37371856E-03_JPRB, 0.37401204E-03_JPRB, 0.37432871E-03_JPRB, &
  & 0.37475801E-03_JPRB, 0.37526738E-03_JPRB, 0.37575448E-03_JPRB, 0.37618280E-03_JPRB, 0.37660525E-03_JPRB, 0.37708058E-03_JPRB, &
  & 0.37755749E-03_JPRB, 0.37793986E-03_JPRB, 0.37820732E-03_JPRB, 0.37841740E-03_JPRB, 0.37857205E-03_JPRB, 0.37868166E-03_JPRB, &
  & 0.37879994E-03_JPRB, 0.37899683E-03_JPRB, 0.37928974E-03_JPRB, 0.37967801E-03_JPRB, 0.38011120E-03_JPRB, 0.38056655E-03_JPRB, &
  & 0.38107079E-03_JPRB, 0.38151254E-03_JPRB, 0.38190278E-03_JPRB, 0.38228739E-03_JPRB, 0.38271039E-03_JPRB, 0.38309162E-03_JPRB, &
  & 0.38336279E-03_JPRB, 0.38359030E-03_JPRB, 0.38384213E-03_JPRB, 0.38405456E-03_JPRB, 0.38413160E-03_JPRB, 0.38406863E-03_JPRB, &
  & 0.38395214E-03_JPRB, 0.38381726E-03_JPRB, 0.38365302E-03_JPRB, 0.38344843E-03_JPRB, 0.38318644E-03_JPRB, 0.38289808E-03_JPRB, &
  & 0.38261111E-03_JPRB, 0.38231441E-03_JPRB, 0.38199993E-03_JPRB, 0.38167600E-03_JPRB, 0.38137814E-03_JPRB, 0.38116107E-03_JPRB, &
  & 0.38101146E-03_JPRB, 0.38087387E-03_JPRB, 0.38072204E-03_JPRB, 0.38056427E-03_JPRB, 0.38040541E-03_JPRB, 0.38028711E-03_JPRB, &
  & 0.38021506E-03_JPRB, 0.38017740E-03_JPRB, 0.38015878E-03_JPRB, 0.38011067E-03_JPRB, 0.38007230E-03_JPRB, 0.38006498E-03_JPRB, &
  & 0.38010179E-03_JPRB, 0.38014943E-03_JPRB, 0.38014446E-03_JPRB, 0.38015731E-03_JPRB  /)

RGHG1(:,33,10) = (/ &
  & 0.37296210E-03_JPRB, 0.37331485E-03_JPRB, 0.37359934E-03_JPRB, 0.37394620E-03_JPRB, 0.37427651E-03_JPRB, 0.37461628E-03_JPRB, &
  & 0.37506923E-03_JPRB, 0.37559989E-03_JPRB, 0.37611625E-03_JPRB, 0.37657424E-03_JPRB, 0.37701630E-03_JPRB, 0.37752075E-03_JPRB, &
  & 0.37803686E-03_JPRB, 0.37845143E-03_JPRB, 0.37873891E-03_JPRB, 0.37897965E-03_JPRB, 0.37915390E-03_JPRB, 0.37929599E-03_JPRB, &
  & 0.37948162E-03_JPRB, 0.37973492E-03_JPRB, 0.38008117E-03_JPRB, 0.38053146E-03_JPRB, 0.38099896E-03_JPRB, 0.38139383E-03_JPRB, &
  & 0.38177654E-03_JPRB, 0.38211399E-03_JPRB, 0.38240203E-03_JPRB, 0.38267142E-03_JPRB, 0.38295959E-03_JPRB, 0.38323526E-03_JPRB, &
  & 0.38346919E-03_JPRB, 0.38368900E-03_JPRB, 0.38393005E-03_JPRB, 0.38411322E-03_JPRB, 0.38417430E-03_JPRB, 0.38412547E-03_JPRB, &
  & 0.38403362E-03_JPRB, 0.38392016E-03_JPRB, 0.38378742E-03_JPRB, 0.38362161E-03_JPRB, 0.38340974E-03_JPRB, 0.38320692E-03_JPRB, &
  & 0.38302146E-03_JPRB, 0.38279770E-03_JPRB, 0.38255686E-03_JPRB, 0.38227941E-03_JPRB, 0.38201445E-03_JPRB, 0.38179472E-03_JPRB, &
  & 0.38159989E-03_JPRB, 0.38144116E-03_JPRB, 0.38127589E-03_JPRB, 0.38110132E-03_JPRB, 0.38093406E-03_JPRB, 0.38081072E-03_JPRB, &
  & 0.38073181E-03_JPRB, 0.38069275E-03_JPRB, 0.38068281E-03_JPRB, 0.38064436E-03_JPRB, 0.38061592E-03_JPRB, 0.38062513E-03_JPRB, &
  & 0.38066950E-03_JPRB, 0.38071266E-03_JPRB, 0.38070153E-03_JPRB, 0.38069716E-03_JPRB  /)

RGHG1(:,34,10) = (/ &
  & 0.37330309E-03_JPRB, 0.37364844E-03_JPRB, 0.37394977E-03_JPRB, 0.37431073E-03_JPRB, 0.37465047E-03_JPRB, 0.37499258E-03_JPRB, &
  & 0.37546058E-03_JPRB, 0.37602053E-03_JPRB, 0.37656892E-03_JPRB, 0.37705222E-03_JPRB, 0.37751189E-03_JPRB, 0.37804955E-03_JPRB, &
  & 0.37860636E-03_JPRB, 0.37905824E-03_JPRB, 0.37937545E-03_JPRB, 0.37963099E-03_JPRB, 0.37980371E-03_JPRB, 0.37997145E-03_JPRB, &
  & 0.38019838E-03_JPRB, 0.38048214E-03_JPRB, 0.38083894E-03_JPRB, 0.38127174E-03_JPRB, 0.38168799E-03_JPRB, 0.38199992E-03_JPRB, &
  & 0.38228094E-03_JPRB, 0.38253836E-03_JPRB, 0.38275659E-03_JPRB, 0.38295530E-03_JPRB, 0.38315922E-03_JPRB, 0.38335752E-03_JPRB, &
  & 0.38354247E-03_JPRB, 0.38372780E-03_JPRB, 0.38393459E-03_JPRB, 0.38408327E-03_JPRB, 0.38412783E-03_JPRB, 0.38408198E-03_JPRB, &
  & 0.38400086E-03_JPRB, 0.38389997E-03_JPRB, 0.38378732E-03_JPRB, 0.38365162E-03_JPRB, 0.38349564E-03_JPRB, 0.38336955E-03_JPRB, &
  & 0.38327305E-03_JPRB, 0.38312188E-03_JPRB, 0.38294841E-03_JPRB, 0.38273250E-03_JPRB, 0.38252022E-03_JPRB, 0.38232637E-03_JPRB, &
  & 0.38212495E-03_JPRB, 0.38196542E-03_JPRB, 0.38179344E-03_JPRB, 0.38161226E-03_JPRB, 0.38144073E-03_JPRB, 0.38131618E-03_JPRB, &
  & 0.38123440E-03_JPRB, 0.38119125E-03_JPRB, 0.38119237E-03_JPRB, 0.38116873E-03_JPRB, 0.38115764E-03_JPRB, 0.38118596E-03_JPRB, &
  & 0.38123524E-03_JPRB, 0.38126764E-03_JPRB, 0.38124287E-03_JPRB, 0.38122265E-03_JPRB  /)

RGHG1(:,35,10) = (/ &
  & 0.37376578E-03_JPRB, 0.37408709E-03_JPRB, 0.37439713E-03_JPRB, 0.37475575E-03_JPRB, 0.37509113E-03_JPRB, 0.37542500E-03_JPRB, &
  & 0.37590404E-03_JPRB, 0.37649822E-03_JPRB, 0.37708097E-03_JPRB, 0.37758805E-03_JPRB, 0.37806480E-03_JPRB, 0.37863871E-03_JPRB, &
  & 0.37923813E-03_JPRB, 0.37973100E-03_JPRB, 0.38008374E-03_JPRB, 0.38034636E-03_JPRB, 0.38050668E-03_JPRB, 0.38069727E-03_JPRB, &
  & 0.38095331E-03_JPRB, 0.38125506E-03_JPRB, 0.38160076E-03_JPRB, 0.38197477E-03_JPRB, 0.38229442E-03_JPRB, 0.38250957E-03_JPRB, &
  & 0.38269621E-03_JPRB, 0.38288380E-03_JPRB, 0.38304688E-03_JPRB, 0.38319577E-03_JPRB, 0.38333902E-03_JPRB, 0.38347223E-03_JPRB, &
  & 0.38360080E-03_JPRB, 0.38373696E-03_JPRB, 0.38389646E-03_JPRB, 0.38400701E-03_JPRB, 0.38403429E-03_JPRB, 0.38398577E-03_JPRB, &
  & 0.38390855E-03_JPRB, 0.38381605E-03_JPRB, 0.38371821E-03_JPRB, 0.38360901E-03_JPRB, 0.38351344E-03_JPRB, 0.38346172E-03_JPRB, &
  & 0.38345025E-03_JPRB, 0.38337352E-03_JPRB, 0.38326612E-03_JPRB, 0.38312121E-03_JPRB, 0.38297323E-03_JPRB, 0.38282062E-03_JPRB, &
  & 0.38263226E-03_JPRB, 0.38248235E-03_JPRB, 0.38230693E-03_JPRB, 0.38212419E-03_JPRB, 0.38195039E-03_JPRB, 0.38182655E-03_JPRB, &
  & 0.38174385E-03_JPRB, 0.38169512E-03_JPRB, 0.38170885E-03_JPRB, 0.38170306E-03_JPRB, 0.38171360E-03_JPRB, 0.38176290E-03_JPRB, &
  & 0.38181589E-03_JPRB, 0.38183400E-03_JPRB, 0.38179137E-03_JPRB, 0.38175555E-03_JPRB  /)

RGHG1(:,36,10) = (/ &
  & 0.37420931E-03_JPRB, 0.37450685E-03_JPRB, 0.37483680E-03_JPRB, 0.37519394E-03_JPRB, 0.37552104E-03_JPRB, 0.37584456E-03_JPRB, &
  & 0.37633513E-03_JPRB, 0.37697419E-03_JPRB, 0.37759899E-03_JPRB, 0.37813658E-03_JPRB, 0.37863590E-03_JPRB, 0.37924552E-03_JPRB, &
  & 0.37988803E-03_JPRB, 0.38042083E-03_JPRB, 0.38080010E-03_JPRB, 0.38106481E-03_JPRB, 0.38120956E-03_JPRB, 0.38140856E-03_JPRB, &
  & 0.38166606E-03_JPRB, 0.38196139E-03_JPRB, 0.38227492E-03_JPRB, 0.38257585E-03_JPRB, 0.38279259E-03_JPRB, 0.38291336E-03_JPRB, &
  & 0.38301250E-03_JPRB, 0.38314222E-03_JPRB, 0.38326846E-03_JPRB, 0.38338291E-03_JPRB, 0.38349460E-03_JPRB, 0.38358869E-03_JPRB, &
  & 0.38367585E-03_JPRB, 0.38376676E-03_JPRB, 0.38387636E-03_JPRB, 0.38394129E-03_JPRB, 0.38393425E-03_JPRB, 0.38386348E-03_JPRB, &
  & 0.38376640E-03_JPRB, 0.38366599E-03_JPRB, 0.38357429E-03_JPRB, 0.38348956E-03_JPRB, 0.38344998E-03_JPRB, 0.38347021E-03_JPRB, &
  & 0.38354178E-03_JPRB, 0.38354079E-03_JPRB, 0.38350162E-03_JPRB, 0.38343219E-03_JPRB, 0.38335430E-03_JPRB, 0.38325367E-03_JPRB, &
  & 0.38309633E-03_JPRB, 0.38296826E-03_JPRB, 0.38280145E-03_JPRB, 0.38262225E-03_JPRB, 0.38245294E-03_JPRB, 0.38233277E-03_JPRB, &
  & 0.38225405E-03_JPRB, 0.38220428E-03_JPRB, 0.38223122E-03_JPRB, 0.38224636E-03_JPRB, 0.38228285E-03_JPRB, 0.38235389E-03_JPRB, &
  & 0.38241245E-03_JPRB, 0.38242018E-03_JPRB, 0.38235590E-03_JPRB, 0.38230997E-03_JPRB  /)

RGHG1(:,37,10) = (/ &
  & 0.37458133E-03_JPRB, 0.37485716E-03_JPRB, 0.37523148E-03_JPRB, 0.37558923E-03_JPRB, 0.37589954E-03_JPRB, 0.37620854E-03_JPRB, &
  & 0.37671105E-03_JPRB, 0.37741661E-03_JPRB, 0.37809843E-03_JPRB, 0.37868010E-03_JPRB, 0.37921318E-03_JPRB, 0.37985506E-03_JPRB, &
  & 0.38053906E-03_JPRB, 0.38110688E-03_JPRB, 0.38149041E-03_JPRB, 0.38174565E-03_JPRB, 0.38186850E-03_JPRB, 0.38204227E-03_JPRB, &
  & 0.38223776E-03_JPRB, 0.38247108E-03_JPRB, 0.38270618E-03_JPRB, 0.38290577E-03_JPRB, 0.38301152E-03_JPRB, 0.38304930E-03_JPRB, &
  & 0.38308218E-03_JPRB, 0.38318503E-03_JPRB, 0.38331871E-03_JPRB, 0.38343616E-03_JPRB, 0.38358496E-03_JPRB, 0.38370190E-03_JPRB, &
  & 0.38378456E-03_JPRB, 0.38384201E-03_JPRB, 0.38389884E-03_JPRB, 0.38390381E-03_JPRB, 0.38382554E-03_JPRB, 0.38368899E-03_JPRB, &
  & 0.38351881E-03_JPRB, 0.38337367E-03_JPRB, 0.38326781E-03_JPRB, 0.38320137E-03_JPRB, 0.38320419E-03_JPRB, 0.38328630E-03_JPRB, &
  & 0.38343121E-03_JPRB, 0.38350421E-03_JPRB, 0.38353400E-03_JPRB, 0.38354564E-03_JPRB, 0.38354672E-03_JPRB, 0.38351943E-03_JPRB, &
  & 0.38343237E-03_JPRB, 0.38335281E-03_JPRB, 0.38322174E-03_JPRB, 0.38305753E-03_JPRB, 0.38290795E-03_JPRB, 0.38279797E-03_JPRB, &
  & 0.38273418E-03_JPRB, 0.38269389E-03_JPRB, 0.38273462E-03_JPRB, 0.38277638E-03_JPRB, 0.38284711E-03_JPRB, 0.38294028E-03_JPRB, &
  & 0.38300838E-03_JPRB, 0.38301532E-03_JPRB, 0.38292209E-03_JPRB, 0.38287921E-03_JPRB  /)

RGHG1(:,38,10) = (/ &
  & 0.37499412E-03_JPRB, 0.37524586E-03_JPRB, 0.37566942E-03_JPRB, 0.37602783E-03_JPRB, 0.37631951E-03_JPRB, 0.37661241E-03_JPRB, &
  & 0.37712816E-03_JPRB, 0.37790751E-03_JPRB, 0.37865261E-03_JPRB, 0.37928318E-03_JPRB, 0.37985372E-03_JPRB, 0.38053140E-03_JPRB, &
  & 0.38126144E-03_JPRB, 0.38186812E-03_JPRB, 0.38225637E-03_JPRB, 0.38250110E-03_JPRB, 0.38259967E-03_JPRB, 0.38274542E-03_JPRB, &
  & 0.38287211E-03_JPRB, 0.38303664E-03_JPRB, 0.38318471E-03_JPRB, 0.38327185E-03_JPRB, 0.38325444E-03_JPRB, 0.38320014E-03_JPRB, &
  & 0.38315949E-03_JPRB, 0.38323254E-03_JPRB, 0.38337447E-03_JPRB, 0.38349525E-03_JPRB, 0.38368523E-03_JPRB, 0.38382752E-03_JPRB, &
  & 0.38390519E-03_JPRB, 0.38392551E-03_JPRB, 0.38392379E-03_JPRB, 0.38386223E-03_JPRB, 0.38370491E-03_JPRB, 0.38349537E-03_JPRB, &
  & 0.38324408E-03_JPRB, 0.38304931E-03_JPRB, 0.38292775E-03_JPRB, 0.38288160E-03_JPRB, 0.38293146E-03_JPRB, 0.38308223E-03_JPRB, &
  & 0.38330852E-03_JPRB, 0.38346362E-03_JPRB, 0.38356993E-03_JPRB, 0.38367153E-03_JPRB, 0.38376024E-03_JPRB, 0.38381432E-03_JPRB, &
  & 0.38380524E-03_JPRB, 0.38377950E-03_JPRB, 0.38368809E-03_JPRB, 0.38354051E-03_JPRB, 0.38341282E-03_JPRB, 0.38331415E-03_JPRB, &
  & 0.38326693E-03_JPRB, 0.38323715E-03_JPRB, 0.38329319E-03_JPRB, 0.38336449E-03_JPRB, 0.38347321E-03_JPRB, 0.38359093E-03_JPRB, &
  & 0.38366961E-03_JPRB, 0.38367569E-03_JPRB, 0.38355032E-03_JPRB, 0.38351084E-03_JPRB  /)

RGHG1(:,39,10) = (/ &
  & 0.37516790E-03_JPRB, 0.37539938E-03_JPRB, 0.37585977E-03_JPRB, 0.37623205E-03_JPRB, 0.37651231E-03_JPRB, 0.37677592E-03_JPRB, &
  & 0.37731707E-03_JPRB, 0.37816038E-03_JPRB, 0.37897955E-03_JPRB, 0.37967004E-03_JPRB, 0.38031149E-03_JPRB, 0.38101930E-03_JPRB, &
  & 0.38177910E-03_JPRB, 0.38239833E-03_JPRB, 0.38279280E-03_JPRB, 0.38301734E-03_JPRB, 0.38308662E-03_JPRB, 0.38317223E-03_JPRB, &
  & 0.38321977E-03_JPRB, 0.38330243E-03_JPRB, 0.38336869E-03_JPRB, 0.38337493E-03_JPRB, 0.38328866E-03_JPRB, 0.38319093E-03_JPRB, &
  & 0.38315038E-03_JPRB, 0.38322663E-03_JPRB, 0.38337938E-03_JPRB, 0.38354167E-03_JPRB, 0.38378106E-03_JPRB, 0.38398029E-03_JPRB, &
  & 0.38410688E-03_JPRB, 0.38414175E-03_JPRB, 0.38411564E-03_JPRB, 0.38398826E-03_JPRB, 0.38376337E-03_JPRB, 0.38349293E-03_JPRB, &
  & 0.38318774E-03_JPRB, 0.38292195E-03_JPRB, 0.38273472E-03_JPRB, 0.38266354E-03_JPRB, 0.38272897E-03_JPRB, 0.38291116E-03_JPRB, &
  & 0.38315343E-03_JPRB, 0.38333284E-03_JPRB, 0.38348053E-03_JPRB, 0.38364735E-03_JPRB, 0.38380732E-03_JPRB, 0.38394573E-03_JPRB, &
  & 0.38402347E-03_JPRB, 0.38405625E-03_JPRB, 0.38402008E-03_JPRB, 0.38391139E-03_JPRB, 0.38380954E-03_JPRB, 0.38374255E-03_JPRB, &
  & 0.38371348E-03_JPRB, 0.38370681E-03_JPRB, 0.38379391E-03_JPRB, 0.38391281E-03_JPRB, 0.38408035E-03_JPRB, 0.38422691E-03_JPRB, &
  & 0.38432086E-03_JPRB, 0.38434382E-03_JPRB, 0.38418418E-03_JPRB, 0.38409424E-03_JPRB  /)

RGHG1(:,40,10) = (/ &
  & 0.37533274E-03_JPRB, 0.37554105E-03_JPRB, 0.37604267E-03_JPRB, 0.37643337E-03_JPRB, 0.37670141E-03_JPRB, 0.37692847E-03_JPRB, &
  & 0.37750143E-03_JPRB, 0.37841821E-03_JPRB, 0.37932607E-03_JPRB, 0.38008868E-03_JPRB, 0.38081883E-03_JPRB, 0.38156106E-03_JPRB, &
  & 0.38235311E-03_JPRB, 0.38298277E-03_JPRB, 0.38338480E-03_JPRB, 0.38358406E-03_JPRB, 0.38361814E-03_JPRB, 0.38362792E-03_JPRB, &
  & 0.38358088E-03_JPRB, 0.38356531E-03_JPRB, 0.38353641E-03_JPRB, 0.38345287E-03_JPRB, 0.38329467E-03_JPRB, 0.38315394E-03_JPRB, &
  & 0.38312555E-03_JPRB, 0.38321095E-03_JPRB, 0.38337682E-03_JPRB, 0.38359408E-03_JPRB, 0.38389279E-03_JPRB, 0.38416401E-03_JPRB, &
  & 0.38435683E-03_JPRB, 0.38441724E-03_JPRB, 0.38436809E-03_JPRB, 0.38416360E-03_JPRB, 0.38386128E-03_JPRB, 0.38352134E-03_JPRB, &
  & 0.38315734E-03_JPRB, 0.38280471E-03_JPRB, 0.38253225E-03_JPRB, 0.38242427E-03_JPRB, 0.38250282E-03_JPRB, 0.38271579E-03_JPRB, &
  & 0.38296612E-03_JPRB, 0.38316461E-03_JPRB, 0.38335510E-03_JPRB, 0.38359443E-03_JPRB, 0.38383535E-03_JPRB, 0.38407320E-03_JPRB, &
  & 0.38425430E-03_JPRB, 0.38435650E-03_JPRB, 0.38438772E-03_JPRB, 0.38432830E-03_JPRB, 0.38425742E-03_JPRB, 0.38423094E-03_JPRB, &
  & 0.38422344E-03_JPRB, 0.38424594E-03_JPRB, 0.38437208E-03_JPRB, 0.38454979E-03_JPRB, 0.38478977E-03_JPRB, 0.38497089E-03_JPRB, &
  & 0.38508352E-03_JPRB, 0.38512921E-03_JPRB, 0.38492899E-03_JPRB, 0.38477103E-03_JPRB  /)

RGHG1(:,41,10) = (/ &
  & 0.37553429E-03_JPRB, 0.37571428E-03_JPRB, 0.37626628E-03_JPRB, 0.37667952E-03_JPRB, 0.37693261E-03_JPRB, 0.37711500E-03_JPRB, &
  & 0.37772684E-03_JPRB, 0.37873344E-03_JPRB, 0.37974974E-03_JPRB, 0.38060053E-03_JPRB, 0.38143912E-03_JPRB, 0.38222344E-03_JPRB, &
  & 0.38305493E-03_JPRB, 0.38369734E-03_JPRB, 0.38410860E-03_JPRB, 0.38427695E-03_JPRB, 0.38426800E-03_JPRB, 0.38418507E-03_JPRB, &
  & 0.38402239E-03_JPRB, 0.38388672E-03_JPRB, 0.38374148E-03_JPRB, 0.38354817E-03_JPRB, 0.38330203E-03_JPRB, 0.38310872E-03_JPRB, &
  & 0.38309520E-03_JPRB, 0.38319178E-03_JPRB, 0.38337369E-03_JPRB, 0.38365816E-03_JPRB, 0.38402940E-03_JPRB, 0.38438864E-03_JPRB, &
  & 0.38466244E-03_JPRB, 0.38475407E-03_JPRB, 0.38467675E-03_JPRB, 0.38437798E-03_JPRB, 0.38398098E-03_JPRB, 0.38355608E-03_JPRB, &
  & 0.38312018E-03_JPRB, 0.38266138E-03_JPRB, 0.38228470E-03_JPRB, 0.38213173E-03_JPRB, 0.38222631E-03_JPRB, 0.38247693E-03_JPRB, &
  & 0.38273711E-03_JPRB, 0.38295891E-03_JPRB, 0.38320175E-03_JPRB, 0.38352973E-03_JPRB, 0.38386962E-03_JPRB, 0.38422906E-03_JPRB, &
  & 0.38453651E-03_JPRB, 0.38472361E-03_JPRB, 0.38483721E-03_JPRB, 0.38483804E-03_JPRB, 0.38480503E-03_JPRB, 0.38482807E-03_JPRB, &
  & 0.38484693E-03_JPRB, 0.38490512E-03_JPRB, 0.38507898E-03_JPRB, 0.38532859E-03_JPRB, 0.38565714E-03_JPRB, 0.38588052E-03_JPRB, &
  & 0.38601599E-03_JPRB, 0.38608945E-03_JPRB, 0.38583963E-03_JPRB, 0.38559850E-03_JPRB  /)

RGHG1(:,42,10) = (/ &
  & 0.37504864E-03_JPRB, 0.37518801E-03_JPRB, 0.37579103E-03_JPRB, 0.37623104E-03_JPRB, 0.37657441E-03_JPRB, 0.37685382E-03_JPRB, &
  & 0.37744615E-03_JPRB, 0.37844508E-03_JPRB, 0.37953664E-03_JPRB, 0.38047206E-03_JPRB, 0.38140637E-03_JPRB, 0.38223632E-03_JPRB, &
  & 0.38306867E-03_JPRB, 0.38374060E-03_JPRB, 0.38416341E-03_JPRB, 0.38433161E-03_JPRB, 0.38427968E-03_JPRB, 0.38413709E-03_JPRB, &
  & 0.38396650E-03_JPRB, 0.38381098E-03_JPRB, 0.38363076E-03_JPRB, 0.38344826E-03_JPRB, 0.38322768E-03_JPRB, 0.38309857E-03_JPRB, &
  & 0.38312693E-03_JPRB, 0.38325597E-03_JPRB, 0.38347701E-03_JPRB, 0.38377310E-03_JPRB, 0.38414737E-03_JPRB, 0.38452990E-03_JPRB, &
  & 0.38481171E-03_JPRB, 0.38489200E-03_JPRB, 0.38476689E-03_JPRB, 0.38449160E-03_JPRB, 0.38415734E-03_JPRB, 0.38378230E-03_JPRB, &
  & 0.38336490E-03_JPRB, 0.38289729E-03_JPRB, 0.38246096E-03_JPRB, 0.38220097E-03_JPRB, 0.38220746E-03_JPRB, 0.38238010E-03_JPRB, &
  & 0.38257964E-03_JPRB, 0.38275171E-03_JPRB, 0.38297427E-03_JPRB, 0.38331509E-03_JPRB, 0.38367329E-03_JPRB, 0.38406084E-03_JPRB, &
  & 0.38441733E-03_JPRB, 0.38469890E-03_JPRB, 0.38489666E-03_JPRB, 0.38496653E-03_JPRB, 0.38499467E-03_JPRB, 0.38509401E-03_JPRB, &
  & 0.38516270E-03_JPRB, 0.38525718E-03_JPRB, 0.38545050E-03_JPRB, 0.38575588E-03_JPRB, 0.38614824E-03_JPRB, 0.38640820E-03_JPRB, &
  & 0.38655422E-03_JPRB, 0.38668462E-03_JPRB, 0.38650065E-03_JPRB, 0.38621583E-03_JPRB  /)

RGHG1(:,43,10) = (/ &
  & 0.37469223E-03_JPRB, 0.37478237E-03_JPRB, 0.37545361E-03_JPRB, 0.37592773E-03_JPRB, 0.37634704E-03_JPRB, 0.37669576E-03_JPRB, &
  & 0.37728701E-03_JPRB, 0.37831759E-03_JPRB, 0.37952444E-03_JPRB, 0.38057501E-03_JPRB, 0.38164330E-03_JPRB, 0.38253299E-03_JPRB, &
  & 0.38338309E-03_JPRB, 0.38408743E-03_JPRB, 0.38452475E-03_JPRB, 0.38467953E-03_JPRB, 0.38456986E-03_JPRB, 0.38433297E-03_JPRB, &
  & 0.38410542E-03_JPRB, 0.38388013E-03_JPRB, 0.38361795E-03_JPRB, 0.38339809E-03_JPRB, 0.38316300E-03_JPRB, 0.38306986E-03_JPRB, &
  & 0.38314283E-03_JPRB, 0.38330629E-03_JPRB, 0.38356993E-03_JPRB, 0.38390554E-03_JPRB, 0.38431376E-03_JPRB, 0.38475542E-03_JPRB, &
  & 0.38507937E-03_JPRB, 0.38516274E-03_JPRB, 0.38498191E-03_JPRB, 0.38468748E-03_JPRB, 0.38436973E-03_JPRB, 0.38400365E-03_JPRB, &
  & 0.38357220E-03_JPRB, 0.38305087E-03_JPRB, 0.38251529E-03_JPRB, 0.38213830E-03_JPRB, 0.38207132E-03_JPRB, 0.38218901E-03_JPRB, &
  & 0.38233746E-03_JPRB, 0.38247418E-03_JPRB, 0.38270075E-03_JPRB, 0.38309143E-03_JPRB, 0.38350890E-03_JPRB, 0.38397440E-03_JPRB, &
  & 0.38442999E-03_JPRB, 0.38483427E-03_JPRB, 0.38514424E-03_JPRB, 0.38530302E-03_JPRB, 0.38540325E-03_JPRB, 0.38559350E-03_JPRB, &
  & 0.38571900E-03_JPRB, 0.38586195E-03_JPRB, 0.38609355E-03_JPRB, 0.38648073E-03_JPRB, 0.38696941E-03_JPRB, 0.38728093E-03_JPRB, &
  & 0.38744640E-03_JPRB, 0.38764070E-03_JPRB, 0.38749547E-03_JPRB, 0.38713502E-03_JPRB  /)

RGHG1(:,44,10) = (/ &
  & 0.37384059E-03_JPRB, 0.37393260E-03_JPRB, 0.37461502E-03_JPRB, 0.37520861E-03_JPRB, 0.37576988E-03_JPRB, 0.37621702E-03_JPRB, &
  & 0.37683032E-03_JPRB, 0.37784157E-03_JPRB, 0.37912298E-03_JPRB, 0.38027380E-03_JPRB, 0.38138998E-03_JPRB, 0.38233978E-03_JPRB, &
  & 0.38323511E-03_JPRB, 0.38396219E-03_JPRB, 0.38441784E-03_JPRB, 0.38457464E-03_JPRB, 0.38445888E-03_JPRB, 0.38421038E-03_JPRB, &
  & 0.38398211E-03_JPRB, 0.38374488E-03_JPRB, 0.38349711E-03_JPRB, 0.38330826E-03_JPRB, 0.38311467E-03_JPRB, 0.38307351E-03_JPRB, &
  & 0.38319897E-03_JPRB, 0.38337616E-03_JPRB, 0.38364478E-03_JPRB, 0.38398784E-03_JPRB, 0.38441570E-03_JPRB, 0.38483151E-03_JPRB, &
  & 0.38510997E-03_JPRB, 0.38514806E-03_JPRB, 0.38498804E-03_JPRB, 0.38473375E-03_JPRB, 0.38442640E-03_JPRB, 0.38409231E-03_JPRB, &
  & 0.38368343E-03_JPRB, 0.38316686E-03_JPRB, 0.38262275E-03_JPRB, 0.38216247E-03_JPRB, 0.38202014E-03_JPRB, 0.38207519E-03_JPRB, &
  & 0.38215751E-03_JPRB, 0.38225334E-03_JPRB, 0.38244516E-03_JPRB, 0.38282327E-03_JPRB, 0.38322804E-03_JPRB, 0.38371348E-03_JPRB, &
  & 0.38420780E-03_JPRB, 0.38468928E-03_JPRB, 0.38505195E-03_JPRB, 0.38528942E-03_JPRB, 0.38544919E-03_JPRB, 0.38568839E-03_JPRB, &
  & 0.38587553E-03_JPRB, 0.38606469E-03_JPRB, 0.38632515E-03_JPRB, 0.38675897E-03_JPRB, 0.38730225E-03_JPRB, 0.38764301E-03_JPRB, &
  & 0.38782760E-03_JPRB, 0.38803981E-03_JPRB, 0.38792352E-03_JPRB, 0.38757199E-03_JPRB  /)

RGHG1(:,45,10) = (/ &
  & 0.37282604E-03_JPRB, 0.37291396E-03_JPRB, 0.37361773E-03_JPRB, 0.37435164E-03_JPRB, 0.37508411E-03_JPRB, 0.37565203E-03_JPRB, &
  & 0.37629031E-03_JPRB, 0.37728354E-03_JPRB, 0.37866441E-03_JPRB, 0.37994389E-03_JPRB, 0.38113151E-03_JPRB, 0.38215731E-03_JPRB, &
  & 0.38310637E-03_JPRB, 0.38386342E-03_JPRB, 0.38434178E-03_JPRB, 0.38449918E-03_JPRB, 0.38436920E-03_JPRB, 0.38409556E-03_JPRB, &
  & 0.38385927E-03_JPRB, 0.38359964E-03_JPRB, 0.38335792E-03_JPRB, 0.38319965E-03_JPRB, 0.38305147E-03_JPRB, 0.38307404E-03_JPRB, &
  & 0.38326490E-03_JPRB, 0.38346207E-03_JPRB, 0.38374173E-03_JPRB, 0.38409826E-03_JPRB, 0.38455276E-03_JPRB, 0.38494663E-03_JPRB, &
  & 0.38517861E-03_JPRB, 0.38516554E-03_JPRB, 0.38502217E-03_JPRB, 0.38481118E-03_JPRB, 0.38451776E-03_JPRB, 0.38422120E-03_JPRB, &
  & 0.38383623E-03_JPRB, 0.38331830E-03_JPRB, 0.38275194E-03_JPRB, 0.38218207E-03_JPRB, 0.38194468E-03_JPRB, 0.38192147E-03_JPRB, &
  & 0.38192205E-03_JPRB, 0.38196687E-03_JPRB, 0.38211964E-03_JPRB, 0.38248972E-03_JPRB, 0.38288753E-03_JPRB, 0.38340552E-03_JPRB, &
  & 0.38395645E-03_JPRB, 0.38454132E-03_JPRB, 0.38497816E-03_JPRB, 0.38531644E-03_JPRB, 0.38555310E-03_JPRB, 0.38585951E-03_JPRB, &
  & 0.38612400E-03_JPRB, 0.38637190E-03_JPRB, 0.38667005E-03_JPRB, 0.38716729E-03_JPRB, 0.38778489E-03_JPRB, 0.38816546E-03_JPRB, &
  & 0.38837427E-03_JPRB, 0.38861493E-03_JPRB, 0.38853649E-03_JPRB, 0.38818557E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART20',0,ZHOOK_HANDLE)



RGHG1(:,46,10) = (/ &
  & 0.37184652E-03_JPRB, 0.37199549E-03_JPRB, 0.37275605E-03_JPRB, 0.37359206E-03_JPRB, 0.37432950E-03_JPRB, 0.37500485E-03_JPRB, &
  & 0.37569549E-03_JPRB, 0.37662677E-03_JPRB, 0.37804192E-03_JPRB, 0.37941506E-03_JPRB, 0.38063763E-03_JPRB, 0.38171173E-03_JPRB, &
  & 0.38270531E-03_JPRB, 0.38348683E-03_JPRB, 0.38399027E-03_JPRB, 0.38418797E-03_JPRB, 0.38409435E-03_JPRB, 0.38384026E-03_JPRB, &
  & 0.38362467E-03_JPRB, 0.38338464E-03_JPRB, 0.38318391E-03_JPRB, 0.38307583E-03_JPRB, 0.38299702E-03_JPRB, 0.38309229E-03_JPRB, &
  & 0.38332759E-03_JPRB, 0.38353485E-03_JPRB, 0.38378598E-03_JPRB, 0.38414082E-03_JPRB, 0.38459843E-03_JPRB, 0.38495629E-03_JPRB, &
  & 0.38515520E-03_JPRB, 0.38514263E-03_JPRB, 0.38503438E-03_JPRB, 0.38485312E-03_JPRB, 0.38457742E-03_JPRB, 0.38430213E-03_JPRB, &
  & 0.38392585E-03_JPRB, 0.38341059E-03_JPRB, 0.38281447E-03_JPRB, 0.38220487E-03_JPRB, 0.38190556E-03_JPRB, 0.38180819E-03_JPRB, &
  & 0.38175145E-03_JPRB, 0.38173669E-03_JPRB, 0.38185791E-03_JPRB, 0.38219468E-03_JPRB, 0.38256286E-03_JPRB, 0.38307542E-03_JPRB, &
  & 0.38364345E-03_JPRB, 0.38426681E-03_JPRB, 0.38473723E-03_JPRB, 0.38513627E-03_JPRB, 0.38543663E-03_JPRB, 0.38577085E-03_JPRB, &
  & 0.38608892E-03_JPRB, 0.38637941E-03_JPRB, 0.38669753E-03_JPRB, 0.38723870E-03_JPRB, 0.38788857E-03_JPRB, 0.38830014E-03_JPRB, &
  & 0.38853888E-03_JPRB, 0.38876149E-03_JPRB, 0.38865443E-03_JPRB, 0.38830084E-03_JPRB  /)

RGHG1(:,47,10) = (/ &
  & 0.37070414E-03_JPRB, 0.37093779E-03_JPRB, 0.37177211E-03_JPRB, 0.37272027E-03_JPRB, 0.37343024E-03_JPRB, 0.37422898E-03_JPRB, &
  & 0.37498654E-03_JPRB, 0.37583633E-03_JPRB, 0.37727864E-03_JPRB, 0.37875467E-03_JPRB, 0.38001093E-03_JPRB, 0.38113618E-03_JPRB, &
  & 0.38218014E-03_JPRB, 0.38298928E-03_JPRB, 0.38352261E-03_JPRB, 0.38377556E-03_JPRB, 0.38373476E-03_JPRB, 0.38351253E-03_JPRB, &
  & 0.38332699E-03_JPRB, 0.38311837E-03_JPRB, 0.38297273E-03_JPRB, 0.38292748E-03_JPRB, 0.38293487E-03_JPRB, 0.38311726E-03_JPRB, &
  & 0.38340051E-03_JPRB, 0.38361764E-03_JPRB, 0.38382733E-03_JPRB, 0.38417717E-03_JPRB, 0.38463372E-03_JPRB, 0.38494650E-03_JPRB, &
  & 0.38510930E-03_JPRB, 0.38510765E-03_JPRB, 0.38504432E-03_JPRB, 0.38489524E-03_JPRB, 0.38464108E-03_JPRB, 0.38438750E-03_JPRB, &
  & 0.38401835E-03_JPRB, 0.38350704E-03_JPRB, 0.38287449E-03_JPRB, 0.38223227E-03_JPRB, 0.38186694E-03_JPRB, 0.38168337E-03_JPRB, &
  & 0.38156425E-03_JPRB, 0.38147786E-03_JPRB, 0.38156357E-03_JPRB, 0.38185617E-03_JPRB, 0.38218505E-03_JPRB, 0.38268365E-03_JPRB, &
  & 0.38326382E-03_JPRB, 0.38391935E-03_JPRB, 0.38442103E-03_JPRB, 0.38488336E-03_JPRB, 0.38525581E-03_JPRB, 0.38561476E-03_JPRB, &
  & 0.38599096E-03_JPRB, 0.38632819E-03_JPRB, 0.38666619E-03_JPRB, 0.38725502E-03_JPRB, 0.38793433E-03_JPRB, 0.38838050E-03_JPRB, &
  & 0.38865551E-03_JPRB, 0.38884762E-03_JPRB, 0.38869366E-03_JPRB, 0.38833627E-03_JPRB  /)

RGHG1(:,48,10) = (/ &
  & 0.36985598E-03_JPRB, 0.37023991E-03_JPRB, 0.37123949E-03_JPRB, 0.37216216E-03_JPRB, 0.37277489E-03_JPRB, 0.37362709E-03_JPRB, &
  & 0.37442038E-03_JPRB, 0.37522053E-03_JPRB, 0.37660892E-03_JPRB, 0.37811191E-03_JPRB, 0.37937169E-03_JPRB, 0.38050275E-03_JPRB, &
  & 0.38158282E-03_JPRB, 0.38242573E-03_JPRB, 0.38299049E-03_JPRB, 0.38331755E-03_JPRB, 0.38334217E-03_JPRB, 0.38316143E-03_JPRB, &
  & 0.38302113E-03_JPRB, 0.38286284E-03_JPRB, 0.38278787E-03_JPRB, 0.38280448E-03_JPRB, 0.38288552E-03_JPRB, 0.38312358E-03_JPRB, &
  & 0.38342139E-03_JPRB, 0.38363620E-03_JPRB, 0.38382695E-03_JPRB, 0.38414472E-03_JPRB, 0.38458830E-03_JPRB, 0.38488966E-03_JPRB, &
  & 0.38505012E-03_JPRB, 0.38506940E-03_JPRB, 0.38502912E-03_JPRB, 0.38490555E-03_JPRB, 0.38467372E-03_JPRB, 0.38444570E-03_JPRB, &
  & 0.38407563E-03_JPRB, 0.38354333E-03_JPRB, 0.38288892E-03_JPRB, 0.38223401E-03_JPRB, 0.38183601E-03_JPRB, 0.38159344E-03_JPRB, &
  & 0.38142596E-03_JPRB, 0.38128033E-03_JPRB, 0.38134783E-03_JPRB, 0.38161651E-03_JPRB, 0.38192517E-03_JPRB, 0.38238929E-03_JPRB, &
  & 0.38293231E-03_JPRB, 0.38356291E-03_JPRB, 0.38406631E-03_JPRB, 0.38453250E-03_JPRB, 0.38492483E-03_JPRB, 0.38527523E-03_JPRB, &
  & 0.38567453E-03_JPRB, 0.38604281E-03_JPRB, 0.38639129E-03_JPRB, 0.38700396E-03_JPRB, 0.38768655E-03_JPRB, 0.38816622E-03_JPRB, &
  & 0.38845927E-03_JPRB, 0.38862056E-03_JPRB, 0.38842275E-03_JPRB, 0.38803912E-03_JPRB  /)

RGHG1(:,49,10) = (/ &
  & 0.36905049E-03_JPRB, 0.36963068E-03_JPRB, 0.37085485E-03_JPRB, 0.37168672E-03_JPRB, 0.37216005E-03_JPRB, 0.37303966E-03_JPRB, &
  & 0.37385834E-03_JPRB, 0.37461799E-03_JPRB, 0.37590981E-03_JPRB, 0.37740813E-03_JPRB, 0.37865810E-03_JPRB, 0.37977499E-03_JPRB, &
  & 0.38088854E-03_JPRB, 0.38177164E-03_JPRB, 0.38237191E-03_JPRB, 0.38278962E-03_JPRB, 0.38289243E-03_JPRB, 0.38276200E-03_JPRB, &
  & 0.38267870E-03_JPRB, 0.38258474E-03_JPRB, 0.38259513E-03_JPRB, 0.38267980E-03_JPRB, 0.38283669E-03_JPRB, 0.38312210E-03_JPRB, &
  & 0.38342084E-03_JPRB, 0.38362756E-03_JPRB, 0.38380756E-03_JPRB, 0.38407752E-03_JPRB, 0.38450131E-03_JPRB, 0.38480532E-03_JPRB, &
  & 0.38497855E-03_JPRB, 0.38502555E-03_JPRB, 0.38500085E-03_JPRB, 0.38490251E-03_JPRB, 0.38469576E-03_JPRB, 0.38449780E-03_JPRB, &
  & 0.38412306E-03_JPRB, 0.38355618E-03_JPRB, 0.38288417E-03_JPRB, 0.38222427E-03_JPRB, 0.38180525E-03_JPRB, 0.38150972E-03_JPRB, &
  & 0.38129505E-03_JPRB, 0.38108945E-03_JPRB, 0.38114465E-03_JPRB, 0.38139604E-03_JPRB, 0.38169099E-03_JPRB, 0.38210761E-03_JPRB, &
  & 0.38258708E-03_JPRB, 0.38316410E-03_JPRB, 0.38365598E-03_JPRB, 0.38409943E-03_JPRB, 0.38449004E-03_JPRB, 0.38481583E-03_JPRB, &
  & 0.38522479E-03_JPRB, 0.38562033E-03_JPRB, 0.38597612E-03_JPRB, 0.38660437E-03_JPRB, 0.38727871E-03_JPRB, 0.38779498E-03_JPRB, &
  & 0.38809971E-03_JPRB, 0.38822674E-03_JPRB, 0.38798173E-03_JPRB, 0.38755885E-03_JPRB  /)

RGHG1(:,50,10) = (/ &
  & 0.36872860E-03_JPRB, 0.36946226E-03_JPRB, 0.37087224E-03_JPRB, 0.37159181E-03_JPRB, 0.37196641E-03_JPRB, 0.37279799E-03_JPRB, &
  & 0.37360564E-03_JPRB, 0.37434172E-03_JPRB, 0.37552038E-03_JPRB, 0.37692738E-03_JPRB, 0.37810652E-03_JPRB, 0.37916897E-03_JPRB, &
  & 0.38027991E-03_JPRB, 0.38119214E-03_JPRB, 0.38184239E-03_JPRB, 0.38233044E-03_JPRB, 0.38249729E-03_JPRB, 0.38243281E-03_JPRB, &
  & 0.38239984E-03_JPRB, 0.38236417E-03_JPRB, 0.38244124E-03_JPRB, 0.38257996E-03_JPRB, 0.38277998E-03_JPRB, 0.38309291E-03_JPRB, &
  & 0.38339106E-03_JPRB, 0.38358297E-03_JPRB, 0.38376088E-03_JPRB, 0.38400143E-03_JPRB, 0.38439233E-03_JPRB, 0.38469042E-03_JPRB, &
  & 0.38489709E-03_JPRB, 0.38496652E-03_JPRB, 0.38495825E-03_JPRB, 0.38487859E-03_JPRB, 0.38469654E-03_JPRB, 0.38452197E-03_JPRB, &
  & 0.38413700E-03_JPRB, 0.38353108E-03_JPRB, 0.38284218E-03_JPRB, 0.38219178E-03_JPRB, 0.38176122E-03_JPRB, 0.38142956E-03_JPRB, &
  & 0.38118669E-03_JPRB, 0.38096826E-03_JPRB, 0.38102682E-03_JPRB, 0.38127651E-03_JPRB, 0.38157002E-03_JPRB, 0.38193426E-03_JPRB, &
  & 0.38233545E-03_JPRB, 0.38284160E-03_JPRB, 0.38329771E-03_JPRB, 0.38368382E-03_JPRB, 0.38403662E-03_JPRB, 0.38431610E-03_JPRB, &
  & 0.38468853E-03_JPRB, 0.38507234E-03_JPRB, 0.38542870E-03_JPRB, 0.38604190E-03_JPRB, 0.38668813E-03_JPRB, 0.38721060E-03_JPRB, &
  & 0.38754456E-03_JPRB, 0.38763113E-03_JPRB, 0.38731369E-03_JPRB, 0.38693518E-03_JPRB  /)

RGHG1(:,51,10) = (/ &
  & 0.36863464E-03_JPRB, 0.36951180E-03_JPRB, 0.37110239E-03_JPRB, 0.37168919E-03_JPRB, 0.37197837E-03_JPRB, 0.37271835E-03_JPRB, &
  & 0.37349493E-03_JPRB, 0.37421441E-03_JPRB, 0.37526192E-03_JPRB, 0.37652461E-03_JPRB, 0.37759507E-03_JPRB, 0.37857746E-03_JPRB, &
  & 0.37966660E-03_JPRB, 0.38060454E-03_JPRB, 0.38131646E-03_JPRB, 0.38186991E-03_JPRB, 0.38209859E-03_JPRB, 0.38211367E-03_JPRB, &
  & 0.38213162E-03_JPRB, 0.38215583E-03_JPRB, 0.38229521E-03_JPRB, 0.38248502E-03_JPRB, 0.38271449E-03_JPRB, 0.38304679E-03_JPRB, &
  & 0.38334346E-03_JPRB, 0.38351586E-03_JPRB, 0.38369604E-03_JPRB, 0.38391447E-03_JPRB, 0.38426290E-03_JPRB, 0.38455009E-03_JPRB, &
  & 0.38480378E-03_JPRB, 0.38489469E-03_JPRB, 0.38490464E-03_JPRB, 0.38484174E-03_JPRB, 0.38468621E-03_JPRB, 0.38453344E-03_JPRB, &
  & 0.38413448E-03_JPRB, 0.38348398E-03_JPRB, 0.38277718E-03_JPRB, 0.38214468E-03_JPRB, 0.38170664E-03_JPRB, 0.38134471E-03_JPRB, &
  & 0.38108134E-03_JPRB, 0.38087382E-03_JPRB, 0.38094425E-03_JPRB, 0.38120028E-03_JPRB, 0.38149867E-03_JPRB, 0.38180369E-03_JPRB, &
  & 0.38211246E-03_JPRB, 0.38253287E-03_JPRB, 0.38293757E-03_JPRB, 0.38324347E-03_JPRB, 0.38353639E-03_JPRB, 0.38375437E-03_JPRB, &
  & 0.38406302E-03_JPRB, 0.38441364E-03_JPRB, 0.38476707E-03_JPRB, 0.38534789E-03_JPRB, 0.38595329E-03_JPRB, 0.38646648E-03_JPRB, &
  & 0.38684128E-03_JPRB, 0.38688083E-03_JPRB, 0.38647179E-03_JPRB, 0.38618520E-03_JPRB  /)

RGHG1(:,52,10) = (/ &
  & 0.36905001E-03_JPRB, 0.37003546E-03_JPRB, 0.37172340E-03_JPRB, 0.37220448E-03_JPRB, 0.37243618E-03_JPRB, 0.37305579E-03_JPRB, &
  & 0.37378651E-03_JPRB, 0.37446729E-03_JPRB, 0.37539413E-03_JPRB, 0.37648796E-03_JPRB, 0.37740924E-03_JPRB, 0.37825296E-03_JPRB, &
  & 0.37925066E-03_JPRB, 0.38018366E-03_JPRB, 0.38093649E-03_JPRB, 0.38153277E-03_JPRB, 0.38181055E-03_JPRB, 0.38189941E-03_JPRB, &
  & 0.38196421E-03_JPRB, 0.38201651E-03_JPRB, 0.38219302E-03_JPRB, 0.38240548E-03_JPRB, 0.38265429E-03_JPRB, 0.38299106E-03_JPRB, &
  & 0.38328794E-03_JPRB, 0.38345360E-03_JPRB, 0.38363054E-03_JPRB, 0.38382606E-03_JPRB, 0.38413568E-03_JPRB, 0.38440197E-03_JPRB, &
  & 0.38467107E-03_JPRB, 0.38478309E-03_JPRB, 0.38483030E-03_JPRB, 0.38478983E-03_JPRB, 0.38464950E-03_JPRB, 0.38450207E-03_JPRB, &
  & 0.38407522E-03_JPRB, 0.38339211E-03_JPRB, 0.38267703E-03_JPRB, 0.38206516E-03_JPRB, 0.38162307E-03_JPRB, 0.38125802E-03_JPRB, &
  & 0.38100654E-03_JPRB, 0.38083343E-03_JPRB, 0.38091233E-03_JPRB, 0.38116990E-03_JPRB, 0.38146688E-03_JPRB, 0.38174083E-03_JPRB, &
  & 0.38198517E-03_JPRB, 0.38236548E-03_JPRB, 0.38271866E-03_JPRB, 0.38296390E-03_JPRB, 0.38319320E-03_JPRB, 0.38335923E-03_JPRB, &
  & 0.38360010E-03_JPRB, 0.38388589E-03_JPRB, 0.38420094E-03_JPRB, 0.38470946E-03_JPRB, 0.38525678E-03_JPRB, 0.38571420E-03_JPRB, &
  & 0.38607939E-03_JPRB, 0.38606786E-03_JPRB, 0.38564575E-03_JPRB, 0.38539434E-03_JPRB  /)

RGHG1(:,53,10) = (/ &
  & 0.36969829E-03_JPRB, 0.37078812E-03_JPRB, 0.37255006E-03_JPRB, 0.37292641E-03_JPRB, 0.37310626E-03_JPRB, 0.37358372E-03_JPRB, &
  & 0.37425881E-03_JPRB, 0.37488895E-03_JPRB, 0.37568840E-03_JPRB, 0.37658891E-03_JPRB, 0.37733215E-03_JPRB, 0.37800230E-03_JPRB, &
  & 0.37887364E-03_JPRB, 0.37978947E-03_JPRB, 0.38057887E-03_JPRB, 0.38121309E-03_JPRB, 0.38153946E-03_JPRB, 0.38170643E-03_JPRB, &
  & 0.38182068E-03_JPRB, 0.38189135E-03_JPRB, 0.38209859E-03_JPRB, 0.38232479E-03_JPRB, 0.38259077E-03_JPRB, 0.38292668E-03_JPRB, &
  & 0.38322441E-03_JPRB, 0.38338768E-03_JPRB, 0.38355894E-03_JPRB, 0.38372923E-03_JPRB, 0.38399799E-03_JPRB, 0.38423767E-03_JPRB, &
  & 0.38451141E-03_JPRB, 0.38464625E-03_JPRB, 0.38474136E-03_JPRB, 0.38472751E-03_JPRB, 0.38459936E-03_JPRB, 0.38445142E-03_JPRB, &
  & 0.38398887E-03_JPRB, 0.38327485E-03_JPRB, 0.38255445E-03_JPRB, 0.38196610E-03_JPRB, 0.38152092E-03_JPRB, 0.38116290E-03_JPRB, &
  & 0.38093684E-03_JPRB, 0.38081025E-03_JPRB, 0.38089705E-03_JPRB, 0.38115445E-03_JPRB, 0.38144748E-03_JPRB, 0.38169842E-03_JPRB, &
  & 0.38188336E-03_JPRB, 0.38223758E-03_JPRB, 0.38253462E-03_JPRB, 0.38272131E-03_JPRB, 0.38287987E-03_JPRB, 0.38299303E-03_JPRB, &
  & 0.38315852E-03_JPRB, 0.38336157E-03_JPRB, 0.38362116E-03_JPRB, 0.38403560E-03_JPRB, 0.38451304E-03_JPRB, 0.38489183E-03_JPRB, &
  & 0.38522715E-03_JPRB, 0.38515845E-03_JPRB, 0.38475230E-03_JPRB, 0.38451738E-03_JPRB  /)

RGHG1(:,54,10) = (/ &
  & 0.37077227E-03_JPRB, 0.37189788E-03_JPRB, 0.37365533E-03_JPRB, 0.37397382E-03_JPRB, 0.37408805E-03_JPRB, 0.37446560E-03_JPRB, &
  & 0.37507423E-03_JPRB, 0.37565651E-03_JPRB, 0.37633323E-03_JPRB, 0.37705345E-03_JPRB, 0.37762390E-03_JPRB, 0.37810585E-03_JPRB, &
  & 0.37880210E-03_JPRB, 0.37963511E-03_JPRB, 0.38041238E-03_JPRB, 0.38105297E-03_JPRB, 0.38141096E-03_JPRB, 0.38161444E-03_JPRB, &
  & 0.38176378E-03_JPRB, 0.38183551E-03_JPRB, 0.38203999E-03_JPRB, 0.38226103E-03_JPRB, 0.38252104E-03_JPRB, 0.38283643E-03_JPRB, &
  & 0.38312029E-03_JPRB, 0.38330696E-03_JPRB, 0.38348351E-03_JPRB, 0.38360775E-03_JPRB, 0.38384190E-03_JPRB, 0.38408169E-03_JPRB, &
  & 0.38433138E-03_JPRB, 0.38448908E-03_JPRB, 0.38462264E-03_JPRB, 0.38465615E-03_JPRB, 0.38452283E-03_JPRB, 0.38435528E-03_JPRB, &
  & 0.38386762E-03_JPRB, 0.38314166E-03_JPRB, 0.38242495E-03_JPRB, 0.38185071E-03_JPRB, 0.38141652E-03_JPRB, 0.38107924E-03_JPRB, &
  & 0.38088453E-03_JPRB, 0.38080199E-03_JPRB, 0.38088403E-03_JPRB, 0.38113215E-03_JPRB, 0.38142492E-03_JPRB, 0.38167606E-03_JPRB, &
  & 0.38185161E-03_JPRB, 0.38222099E-03_JPRB, 0.38249429E-03_JPRB, 0.38266256E-03_JPRB, 0.38279759E-03_JPRB, 0.38287222E-03_JPRB, &
  & 0.38299076E-03_JPRB, 0.38314019E-03_JPRB, 0.38334803E-03_JPRB, 0.38369663E-03_JPRB, 0.38411550E-03_JPRB, 0.38444362E-03_JPRB, &
  & 0.38477032E-03_JPRB, 0.38469953E-03_JPRB, 0.38428449E-03_JPRB, 0.38398899E-03_JPRB  /)

RGHG1(:,55,10) = (/ &
  & 0.37201798E-03_JPRB, 0.37317419E-03_JPRB, 0.37491634E-03_JPRB, 0.37517690E-03_JPRB, 0.37521663E-03_JPRB, 0.37548907E-03_JPRB, &
  & 0.37602265E-03_JPRB, 0.37655229E-03_JPRB, 0.37709366E-03_JPRB, 0.37761587E-03_JPRB, 0.37799560E-03_JPRB, 0.37826715E-03_JPRB, &
  & 0.37876302E-03_JPRB, 0.37949567E-03_JPRB, 0.38025308E-03_JPRB, 0.38089658E-03_JPRB, 0.38128736E-03_JPRB, 0.38152582E-03_JPRB, &
  & 0.38171214E-03_JPRB, 0.38178278E-03_JPRB, 0.38197978E-03_JPRB, 0.38219263E-03_JPRB, 0.38244298E-03_JPRB, 0.38273305E-03_JPRB, &
  & 0.38299961E-03_JPRB, 0.38321561E-03_JPRB, 0.38339944E-03_JPRB, 0.38346995E-03_JPRB, 0.38366657E-03_JPRB, 0.38391001E-03_JPRB, &
  & 0.38412927E-03_JPRB, 0.38431229E-03_JPRB, 0.38448720E-03_JPRB, 0.38457590E-03_JPRB, 0.38443457E-03_JPRB, 0.38424280E-03_JPRB, &
  & 0.38372872E-03_JPRB, 0.38299201E-03_JPRB, 0.38228058E-03_JPRB, 0.38172074E-03_JPRB, 0.38130057E-03_JPRB, 0.38098807E-03_JPRB, &
  & 0.38082888E-03_JPRB, 0.38079479E-03_JPRB, 0.38086992E-03_JPRB, 0.38110656E-03_JPRB, 0.38139951E-03_JPRB, 0.38165393E-03_JPRB, &
  & 0.38182565E-03_JPRB, 0.38221725E-03_JPRB, 0.38246851E-03_JPRB, 0.38262166E-03_JPRB, 0.38273684E-03_JPRB, 0.38277066E-03_JPRB, &
  & 0.38284093E-03_JPRB, 0.38293480E-03_JPRB, 0.38308581E-03_JPRB, 0.38336519E-03_JPRB, 0.38372067E-03_JPRB, 0.38399632E-03_JPRB, &
  & 0.38431628E-03_JPRB, 0.38425041E-03_JPRB, 0.38382225E-03_JPRB, 0.38344952E-03_JPRB  /)

RGHG1(:,56,10) = (/ &
  & 0.37342655E-03_JPRB, 0.37453751E-03_JPRB, 0.37618667E-03_JPRB, 0.37639030E-03_JPRB, 0.37639751E-03_JPRB, 0.37662280E-03_JPRB, &
  & 0.37710779E-03_JPRB, 0.37757166E-03_JPRB, 0.37800839E-03_JPRB, 0.37837408E-03_JPRB, 0.37862088E-03_JPRB, 0.37873882E-03_JPRB, &
  & 0.37905688E-03_JPRB, 0.37963929E-03_JPRB, 0.38031147E-03_JPRB, 0.38089238E-03_JPRB, 0.38125768E-03_JPRB, 0.38148438E-03_JPRB, &
  & 0.38167833E-03_JPRB, 0.38175630E-03_JPRB, 0.38194607E-03_JPRB, 0.38213700E-03_JPRB, 0.38236950E-03_JPRB, 0.38263473E-03_JPRB, &
  & 0.38287194E-03_JPRB, 0.38310509E-03_JPRB, 0.38330571E-03_JPRB, 0.38338039E-03_JPRB, 0.38354028E-03_JPRB, 0.38379473E-03_JPRB, &
  & 0.38400107E-03_JPRB, 0.38419902E-03_JPRB, 0.38435632E-03_JPRB, 0.38446477E-03_JPRB, 0.38434699E-03_JPRB, 0.38412441E-03_JPRB, &
  & 0.38360099E-03_JPRB, 0.38287029E-03_JPRB, 0.38217357E-03_JPRB, 0.38160765E-03_JPRB, 0.38120848E-03_JPRB, 0.38093936E-03_JPRB, &
  & 0.38078352E-03_JPRB, 0.38076127E-03_JPRB, 0.38083551E-03_JPRB, 0.38106211E-03_JPRB, 0.38136806E-03_JPRB, 0.38164697E-03_JPRB, &
  & 0.38183608E-03_JPRB, 0.38225272E-03_JPRB, 0.38251801E-03_JPRB, 0.38269464E-03_JPRB, 0.38282260E-03_JPRB, 0.38284888E-03_JPRB, &
  & 0.38291098E-03_JPRB, 0.38299603E-03_JPRB, 0.38313197E-03_JPRB, 0.38339043E-03_JPRB, 0.38372135E-03_JPRB, 0.38400744E-03_JPRB, &
  & 0.38433544E-03_JPRB, 0.38428917E-03_JPRB, 0.38383757E-03_JPRB, 0.38347604E-03_JPRB  /)

RGHG1(:,57,10) = (/ &
  & 0.37484238E-03_JPRB, 0.37589794E-03_JPRB, 0.37744329E-03_JPRB, 0.37759928E-03_JPRB, 0.37758605E-03_JPRB, 0.37776529E-03_JPRB, &
  & 0.37820063E-03_JPRB, 0.37859491E-03_JPRB, 0.37893207E-03_JPRB, 0.37915367E-03_JPRB, 0.37927288E-03_JPRB, 0.37924720E-03_JPRB, &
  & 0.37939476E-03_JPRB, 0.37982345E-03_JPRB, 0.38039775E-03_JPRB, 0.38090381E-03_JPRB, 0.38123000E-03_JPRB, 0.38143875E-03_JPRB, &
  & 0.38163508E-03_JPRB, 0.38172231E-03_JPRB, 0.38190346E-03_JPRB, 0.38207491E-03_JPRB, 0.38229024E-03_JPRB, 0.38253054E-03_JPRB, &
  & 0.38273867E-03_JPRB, 0.38298688E-03_JPRB, 0.38320954E-03_JPRB, 0.38329803E-03_JPRB, 0.38342030E-03_JPRB, 0.38367846E-03_JPRB, &
  & 0.38388600E-03_JPRB, 0.38409092E-03_JPRB, 0.38422848E-03_JPRB, 0.38435444E-03_JPRB, 0.38425730E-03_JPRB, 0.38400908E-03_JPRB, &
  & 0.38347479E-03_JPRB, 0.38275069E-03_JPRB, 0.38206419E-03_JPRB, 0.38148805E-03_JPRB, 0.38111184E-03_JPRB, 0.38088839E-03_JPRB, &
  & 0.38074105E-03_JPRB, 0.38072526E-03_JPRB, 0.38079784E-03_JPRB, 0.38101870E-03_JPRB, 0.38133698E-03_JPRB, 0.38163854E-03_JPRB, &
  & 0.38184896E-03_JPRB, 0.38228907E-03_JPRB, 0.38256817E-03_JPRB, 0.38277306E-03_JPRB, 0.38291334E-03_JPRB, 0.38294767E-03_JPRB, &
  & 0.38300725E-03_JPRB, 0.38307421E-03_JPRB, 0.38320301E-03_JPRB, 0.38343920E-03_JPRB, 0.38374381E-03_JPRB, 0.38403932E-03_JPRB, &
  & 0.38435000E-03_JPRB, 0.38430976E-03_JPRB, 0.38383028E-03_JPRB, 0.38346935E-03_JPRB  /)

RGHG1(:,58,10) = (/ &
  & 0.37618712E-03_JPRB, 0.37716034E-03_JPRB, 0.37857740E-03_JPRB, 0.37870550E-03_JPRB, 0.37870173E-03_JPRB, 0.37885137E-03_JPRB, &
  & 0.37924416E-03_JPRB, 0.37956556E-03_JPRB, 0.37982547E-03_JPRB, 0.37994337E-03_JPRB, 0.37996510E-03_JPRB, 0.37983486E-03_JPRB, &
  & 0.37984222E-03_JPRB, 0.38011436E-03_JPRB, 0.38056499E-03_JPRB, 0.38096923E-03_JPRB, 0.38122556E-03_JPRB, 0.38139857E-03_JPRB, &
  & 0.38158270E-03_JPRB, 0.38168326E-03_JPRB, 0.38185421E-03_JPRB, 0.38200929E-03_JPRB, 0.38220846E-03_JPRB, 0.38242579E-03_JPRB, &
  & 0.38260537E-03_JPRB, 0.38286161E-03_JPRB, 0.38311519E-03_JPRB, 0.38324348E-03_JPRB, 0.38332982E-03_JPRB, 0.38358042E-03_JPRB, &
  & 0.38381623E-03_JPRB, 0.38401216E-03_JPRB, 0.38411692E-03_JPRB, 0.38424856E-03_JPRB, 0.38417136E-03_JPRB, 0.38390707E-03_JPRB, &
  & 0.38336343E-03_JPRB, 0.38264953E-03_JPRB, 0.38196662E-03_JPRB, 0.38137025E-03_JPRB, 0.38101976E-03_JPRB, 0.38084566E-03_JPRB, &
  & 0.38070881E-03_JPRB, 0.38068300E-03_JPRB, 0.38075387E-03_JPRB, 0.38097701E-03_JPRB, 0.38130786E-03_JPRB, 0.38163117E-03_JPRB, &
  & 0.38187175E-03_JPRB, 0.38233133E-03_JPRB, 0.38262953E-03_JPRB, 0.38287573E-03_JPRB, 0.38303265E-03_JPRB, 0.38310697E-03_JPRB, &
  & 0.38318130E-03_JPRB, 0.38322472E-03_JPRB, 0.38336817E-03_JPRB, 0.38359065E-03_JPRB, 0.38387541E-03_JPRB, 0.38418964E-03_JPRB, &
  & 0.38444436E-03_JPRB, 0.38438946E-03_JPRB, 0.38387490E-03_JPRB, 0.38351321E-03_JPRB  /)

RGHG1(:,59,10) = (/ &
  & 0.37732605E-03_JPRB, 0.37822051E-03_JPRB, 0.37949912E-03_JPRB, 0.37962098E-03_JPRB, 0.37963677E-03_JPRB, 0.37978901E-03_JPRB, &
  & 0.38013744E-03_JPRB, 0.38039054E-03_JPRB, 0.38058958E-03_JPRB, 0.38064024E-03_JPRB, 0.38059865E-03_JPRB, 0.38040251E-03_JPRB, &
  & 0.38031438E-03_JPRB, 0.38045597E-03_JPRB, 0.38078577E-03_JPRB, 0.38107560E-03_JPRB, 0.38124601E-03_JPRB, 0.38136916E-03_JPRB, &
  & 0.38152177E-03_JPRB, 0.38163738E-03_JPRB, 0.38179137E-03_JPRB, 0.38193121E-03_JPRB, 0.38211194E-03_JPRB, 0.38230466E-03_JPRB, &
  & 0.38248137E-03_JPRB, 0.38274825E-03_JPRB, 0.38304078E-03_JPRB, 0.38320397E-03_JPRB, 0.38327307E-03_JPRB, 0.38349068E-03_JPRB, &
  & 0.38373276E-03_JPRB, 0.38390241E-03_JPRB, 0.38399506E-03_JPRB, 0.38414954E-03_JPRB, 0.38408941E-03_JPRB, 0.38382468E-03_JPRB, &
  & 0.38326040E-03_JPRB, 0.38254636E-03_JPRB, 0.38185975E-03_JPRB, 0.38125645E-03_JPRB, 0.38093613E-03_JPRB, 0.38080140E-03_JPRB, &
  & 0.38068840E-03_JPRB, 0.38065008E-03_JPRB, 0.38072466E-03_JPRB, 0.38095472E-03_JPRB, 0.38129053E-03_JPRB, 0.38162524E-03_JPRB, &
  & 0.38190555E-03_JPRB, 0.38238355E-03_JPRB, 0.38271284E-03_JPRB, 0.38299937E-03_JPRB, 0.38316677E-03_JPRB, 0.38328609E-03_JPRB, &
  & 0.38338043E-03_JPRB, 0.38340411E-03_JPRB, 0.38358097E-03_JPRB, 0.38378604E-03_JPRB, 0.38405318E-03_JPRB, 0.38436215E-03_JPRB, &
  & 0.38454863E-03_JPRB, 0.38448373E-03_JPRB, 0.38395703E-03_JPRB, 0.38358724E-03_JPRB  /)

RGHG1(:,60,10) = (/ &
  & 0.37839296E-03_JPRB, 0.37921263E-03_JPRB, 0.38034854E-03_JPRB, 0.38047200E-03_JPRB, 0.38050848E-03_JPRB, 0.38067790E-03_JPRB, &
  & 0.38097990E-03_JPRB, 0.38116921E-03_JPRB, 0.38131036E-03_JPRB, 0.38130618E-03_JPRB, 0.38121473E-03_JPRB, 0.38096926E-03_JPRB, &
  & 0.38080301E-03_JPRB, 0.38082718E-03_JPRB, 0.38103535E-03_JPRB, 0.38120485E-03_JPRB, 0.38128140E-03_JPRB, 0.38134582E-03_JPRB, &
  & 0.38145526E-03_JPRB, 0.38158750E-03_JPRB, 0.38172469E-03_JPRB, 0.38184889E-03_JPRB, 0.38200829E-03_JPRB, 0.38217899E-03_JPRB, &
  & 0.38236238E-03_JPRB, 0.38264146E-03_JPRB, 0.38297477E-03_JPRB, 0.38316794E-03_JPRB, 0.38323355E-03_JPRB, 0.38340798E-03_JPRB, &
  & 0.38364116E-03_JPRB, 0.38377665E-03_JPRB, 0.38386885E-03_JPRB, 0.38405186E-03_JPRB, 0.38401011E-03_JPRB, 0.38374882E-03_JPRB, &
  & 0.38315681E-03_JPRB, 0.38243714E-03_JPRB, 0.38174236E-03_JPRB, 0.38114175E-03_JPRB, 0.38085428E-03_JPRB, 0.38075315E-03_JPRB, &
  & 0.38067026E-03_JPRB, 0.38062405E-03_JPRB, 0.38070718E-03_JPRB, 0.38094546E-03_JPRB, 0.38128159E-03_JPRB, 0.38162400E-03_JPRB, &
  & 0.38195002E-03_JPRB, 0.38244490E-03_JPRB, 0.38281185E-03_JPRB, 0.38313928E-03_JPRB, 0.38331488E-03_JPRB, 0.38347891E-03_JPRB, &
  & 0.38359620E-03_JPRB, 0.38360616E-03_JPRB, 0.38382497E-03_JPRB, 0.38401336E-03_JPRB, 0.38426702E-03_JPRB, 0.38455420E-03_JPRB, &
  & 0.38467459E-03_JPRB, 0.38460407E-03_JPRB, 0.38407942E-03_JPRB, 0.38369853E-03_JPRB  /)

RGHG1(:,61,10) = (/ &
  & 0.37925545E-03_JPRB, 0.38002397E-03_JPRB, 0.38103564E-03_JPRB, 0.38116505E-03_JPRB, 0.38121065E-03_JPRB, 0.38141318E-03_JPRB, &
  & 0.38167008E-03_JPRB, 0.38181838E-03_JPRB, 0.38190244E-03_JPRB, 0.38185654E-03_JPRB, 0.38173495E-03_JPRB, 0.38146662E-03_JPRB, &
  & 0.38124891E-03_JPRB, 0.38119518E-03_JPRB, 0.38129449E-03_JPRB, 0.38135481E-03_JPRB, 0.38134054E-03_JPRB, 0.38133742E-03_JPRB, &
  & 0.38138751E-03_JPRB, 0.38153799E-03_JPRB, 0.38167026E-03_JPRB, 0.38177837E-03_JPRB, 0.38191091E-03_JPRB, 0.38207577E-03_JPRB, &
  & 0.38227125E-03_JPRB, 0.38256366E-03_JPRB, 0.38292833E-03_JPRB, 0.38313278E-03_JPRB, 0.38322802E-03_JPRB, 0.38335683E-03_JPRB, &
  & 0.38354849E-03_JPRB, 0.38364503E-03_JPRB, 0.38375825E-03_JPRB, 0.38396657E-03_JPRB, 0.38394932E-03_JPRB, 0.38368691E-03_JPRB, &
  & 0.38305697E-03_JPRB, 0.38232336E-03_JPRB, 0.38161269E-03_JPRB, 0.38103668E-03_JPRB, 0.38078211E-03_JPRB, 0.38069831E-03_JPRB, &
  & 0.38064935E-03_JPRB, 0.38061852E-03_JPRB, 0.38072174E-03_JPRB, 0.38096627E-03_JPRB, 0.38129338E-03_JPRB, 0.38164029E-03_JPRB, &
  & 0.38201696E-03_JPRB, 0.38252106E-03_JPRB, 0.38293117E-03_JPRB, 0.38329653E-03_JPRB, 0.38347756E-03_JPRB, 0.38367152E-03_JPRB, &
  & 0.38381341E-03_JPRB, 0.38383167E-03_JPRB, 0.38409671E-03_JPRB, 0.38427886E-03_JPRB, 0.38453528E-03_JPRB, 0.38476700E-03_JPRB, &
  & 0.38485634E-03_JPRB, 0.38479309E-03_JPRB, 0.38429899E-03_JPRB, 0.38390590E-03_JPRB  /)

RGHG1(:,62,10) = (/ &
  & 0.38000081E-03_JPRB, 0.38072767E-03_JPRB, 0.38163549E-03_JPRB, 0.38177426E-03_JPRB, 0.38181835E-03_JPRB, 0.38204636E-03_JPRB, &
  & 0.38225997E-03_JPRB, 0.38238805E-03_JPRB, 0.38241843E-03_JPRB, 0.38233016E-03_JPRB, 0.38218647E-03_JPRB, 0.38190506E-03_JPRB, &
  & 0.38164882E-03_JPRB, 0.38152972E-03_JPRB, 0.38154162E-03_JPRB, 0.38151287E-03_JPRB, 0.38142347E-03_JPRB, 0.38135022E-03_JPRB, &
  & 0.38133876E-03_JPRB, 0.38150125E-03_JPRB, 0.38163739E-03_JPRB, 0.38172703E-03_JPRB, 0.38183391E-03_JPRB, 0.38199949E-03_JPRB, &
  & 0.38220700E-03_JPRB, 0.38250967E-03_JPRB, 0.38289343E-03_JPRB, 0.38312443E-03_JPRB, 0.38323911E-03_JPRB, 0.38332556E-03_JPRB, &
  & 0.38347704E-03_JPRB, 0.38357766E-03_JPRB, 0.38369697E-03_JPRB, 0.38391746E-03_JPRB, 0.38391247E-03_JPRB, 0.38363102E-03_JPRB, &
  & 0.38297424E-03_JPRB, 0.38223016E-03_JPRB, 0.38150920E-03_JPRB, 0.38095808E-03_JPRB, 0.38072343E-03_JPRB, 0.38065766E-03_JPRB, &
  & 0.38064291E-03_JPRB, 0.38064081E-03_JPRB, 0.38076594E-03_JPRB, 0.38101403E-03_JPRB, 0.38133172E-03_JPRB, 0.38169312E-03_JPRB, &
  & 0.38210876E-03_JPRB, 0.38261654E-03_JPRB, 0.38307034E-03_JPRB, 0.38347135E-03_JPRB, 0.38366098E-03_JPRB, 0.38387505E-03_JPRB, &
  & 0.38404442E-03_JPRB, 0.38408931E-03_JPRB, 0.38438646E-03_JPRB, 0.38458010E-03_JPRB, 0.38483368E-03_JPRB, 0.38501718E-03_JPRB, &
  & 0.38511312E-03_JPRB, 0.38505659E-03_JPRB, 0.38459109E-03_JPRB, 0.38417160E-03_JPRB  /)

RGHG1(:,63,10) = (/ &
  & 0.38067401E-03_JPRB, 0.38136528E-03_JPRB, 0.38218032E-03_JPRB, 0.38232898E-03_JPRB, 0.38236580E-03_JPRB, 0.38261153E-03_JPRB, &
  & 0.38278504E-03_JPRB, 0.38290274E-03_JPRB, 0.38288487E-03_JPRB, 0.38275463E-03_JPRB, 0.38259180E-03_JPRB, 0.38230481E-03_JPRB, &
  & 0.38201937E-03_JPRB, 0.38184364E-03_JPRB, 0.38178109E-03_JPRB, 0.38167732E-03_JPRB, 0.38152414E-03_JPRB, 0.38138420E-03_JPRB, &
  & 0.38131679E-03_JPRB, 0.38147777E-03_JPRB, 0.38161822E-03_JPRB, 0.38168849E-03_JPRB, 0.38177024E-03_JPRB, 0.38193957E-03_JPRB, &
  & 0.38216188E-03_JPRB, 0.38247325E-03_JPRB, 0.38287032E-03_JPRB, 0.38312935E-03_JPRB, 0.38325711E-03_JPRB, 0.38331382E-03_JPRB, &
  & 0.38344163E-03_JPRB, 0.38355829E-03_JPRB, 0.38367439E-03_JPRB, 0.38389531E-03_JPRB, 0.38388945E-03_JPRB, 0.38357727E-03_JPRB, &
  & 0.38290677E-03_JPRB, 0.38215445E-03_JPRB, 0.38143840E-03_JPRB, 0.38091220E-03_JPRB, 0.38068833E-03_JPRB, 0.38063984E-03_JPRB, &
  & 0.38065778E-03_JPRB, 0.38068838E-03_JPRB, 0.38083231E-03_JPRB, 0.38108433E-03_JPRB, 0.38139570E-03_JPRB, 0.38177878E-03_JPRB, &
  & 0.38222229E-03_JPRB, 0.38273144E-03_JPRB, 0.38322713E-03_JPRB, 0.38366134E-03_JPRB, 0.38386746E-03_JPRB, 0.38409440E-03_JPRB, &
  & 0.38429206E-03_JPRB, 0.38438009E-03_JPRB, 0.38469516E-03_JPRB, 0.38490723E-03_JPRB, 0.38515311E-03_JPRB, 0.38530671E-03_JPRB, &
  & 0.38542585E-03_JPRB, 0.38536134E-03_JPRB, 0.38494316E-03_JPRB, 0.38449642E-03_JPRB  /)

RGHG1(:,64,10) = (/ &
  & 0.38126103E-03_JPRB, 0.38192354E-03_JPRB, 0.38265607E-03_JPRB, 0.38281207E-03_JPRB, 0.38283846E-03_JPRB, 0.38308975E-03_JPRB, &
  & 0.38323074E-03_JPRB, 0.38334172E-03_JPRB, 0.38328752E-03_JPRB, 0.38311860E-03_JPRB, 0.38293654E-03_JPRB, 0.38265286E-03_JPRB, &
  & 0.38234938E-03_JPRB, 0.38212813E-03_JPRB, 0.38200430E-03_JPRB, 0.38184296E-03_JPRB, 0.38164068E-03_JPRB, 0.38144788E-03_JPRB, &
  & 0.38134291E-03_JPRB, 0.38147519E-03_JPRB, 0.38161183E-03_JPRB, 0.38166365E-03_JPRB, 0.38172142E-03_JPRB, 0.38189512E-03_JPRB, &
  & 0.38213862E-03_JPRB, 0.38245761E-03_JPRB, 0.38286566E-03_JPRB, 0.38313966E-03_JPRB, 0.38327455E-03_JPRB, 0.38333081E-03_JPRB, &
  & 0.38347565E-03_JPRB, 0.38359338E-03_JPRB, 0.38369855E-03_JPRB, 0.38390411E-03_JPRB, 0.38387723E-03_JPRB, 0.38352474E-03_JPRB, &
  & 0.38286243E-03_JPRB, 0.38210423E-03_JPRB, 0.38142501E-03_JPRB, 0.38092252E-03_JPRB, 0.38069954E-03_JPRB, 0.38066506E-03_JPRB, &
  & 0.38071030E-03_JPRB, 0.38076854E-03_JPRB, 0.38092094E-03_JPRB, 0.38118035E-03_JPRB, 0.38149380E-03_JPRB, 0.38190541E-03_JPRB, &
  & 0.38236002E-03_JPRB, 0.38287040E-03_JPRB, 0.38340130E-03_JPRB, 0.38386364E-03_JPRB, 0.38410200E-03_JPRB, 0.38433331E-03_JPRB, &
  & 0.38455726E-03_JPRB, 0.38470908E-03_JPRB, 0.38502052E-03_JPRB, 0.38524934E-03_JPRB, 0.38548143E-03_JPRB, 0.38564462E-03_JPRB, &
  & 0.38578870E-03_JPRB, 0.38568053E-03_JPRB, 0.38535647E-03_JPRB, 0.38489593E-03_JPRB  /)

RGHG1(:,65,10) = (/ &
  & 0.38179169E-03_JPRB, 0.38242090E-03_JPRB, 0.38307477E-03_JPRB, 0.38321871E-03_JPRB, 0.38323209E-03_JPRB, 0.38348067E-03_JPRB, &
  & 0.38360508E-03_JPRB, 0.38369488E-03_JPRB, 0.38362202E-03_JPRB, 0.38342905E-03_JPRB, 0.38322705E-03_JPRB, 0.38295301E-03_JPRB, &
  & 0.38263875E-03_JPRB, 0.38239418E-03_JPRB, 0.38221388E-03_JPRB, 0.38200982E-03_JPRB, 0.38177465E-03_JPRB, 0.38155368E-03_JPRB, &
  & 0.38143122E-03_JPRB, 0.38150984E-03_JPRB, 0.38162313E-03_JPRB, 0.38166248E-03_JPRB, 0.38171140E-03_JPRB, 0.38189243E-03_JPRB, &
  & 0.38215811E-03_JPRB, 0.38247488E-03_JPRB, 0.38288649E-03_JPRB, 0.38315559E-03_JPRB, 0.38329738E-03_JPRB, 0.38340370E-03_JPRB, &
  & 0.38355131E-03_JPRB, 0.38363636E-03_JPRB, 0.38376031E-03_JPRB, 0.38394026E-03_JPRB, 0.38387097E-03_JPRB, 0.38348408E-03_JPRB, &
  & 0.38284608E-03_JPRB, 0.38211059E-03_JPRB, 0.38148669E-03_JPRB, 0.38102442E-03_JPRB, 0.38079431E-03_JPRB, 0.38075538E-03_JPRB, &
  & 0.38081702E-03_JPRB, 0.38089053E-03_JPRB, 0.38104619E-03_JPRB, 0.38131222E-03_JPRB, 0.38164075E-03_JPRB, 0.38207855E-03_JPRB, &
  & 0.38253715E-03_JPRB, 0.38304241E-03_JPRB, 0.38359625E-03_JPRB, 0.38408810E-03_JPRB, 0.38436974E-03_JPRB, 0.38461234E-03_JPRB, &
  & 0.38486304E-03_JPRB, 0.38508655E-03_JPRB, 0.38537579E-03_JPRB, 0.38560277E-03_JPRB, 0.38583432E-03_JPRB, 0.38602402E-03_JPRB, &
  & 0.38618578E-03_JPRB, 0.38604722E-03_JPRB, 0.38582421E-03_JPRB, 0.38536136E-03_JPRB  /)

RGHG1(:,66,10) = (/ &
  & 0.38231542E-03_JPRB, 0.38289069E-03_JPRB, 0.38346370E-03_JPRB, 0.38358918E-03_JPRB, 0.38358580E-03_JPRB, 0.38382522E-03_JPRB, &
  & 0.38394146E-03_JPRB, 0.38400548E-03_JPRB, 0.38392572E-03_JPRB, 0.38372039E-03_JPRB, 0.38349698E-03_JPRB, 0.38323273E-03_JPRB, &
  & 0.38290947E-03_JPRB, 0.38265200E-03_JPRB, 0.38242361E-03_JPRB, 0.38218183E-03_JPRB, 0.38192153E-03_JPRB, 0.38167869E-03_JPRB, &
  & 0.38154229E-03_JPRB, 0.38157264E-03_JPRB, 0.38165403E-03_JPRB, 0.38168471E-03_JPRB, 0.38173378E-03_JPRB, 0.38191605E-03_JPRB, &
  & 0.38219806E-03_JPRB, 0.38251488E-03_JPRB, 0.38291501E-03_JPRB, 0.38317654E-03_JPRB, 0.38333552E-03_JPRB, 0.38349171E-03_JPRB, &
  & 0.38363356E-03_JPRB, 0.38370077E-03_JPRB, 0.38383693E-03_JPRB, 0.38398258E-03_JPRB, 0.38386591E-03_JPRB, 0.38344912E-03_JPRB, &
  & 0.38284220E-03_JPRB, 0.38215199E-03_JPRB, 0.38159585E-03_JPRB, 0.38118227E-03_JPRB, 0.38093682E-03_JPRB, 0.38088952E-03_JPRB, &
  & 0.38095482E-03_JPRB, 0.38104159E-03_JPRB, 0.38120399E-03_JPRB, 0.38147043E-03_JPRB, 0.38182336E-03_JPRB, 0.38228127E-03_JPRB, &
  & 0.38274410E-03_JPRB, 0.38324586E-03_JPRB, 0.38381720E-03_JPRB, 0.38433724E-03_JPRB, 0.38466144E-03_JPRB, 0.38492455E-03_JPRB, &
  & 0.38520320E-03_JPRB, 0.38548749E-03_JPRB, 0.38574833E-03_JPRB, 0.38596543E-03_JPRB, 0.38621215E-03_JPRB, 0.38641931E-03_JPRB, &
  & 0.38659554E-03_JPRB, 0.38647082E-03_JPRB, 0.38631191E-03_JPRB, 0.38588331E-03_JPRB  /)

RGHG1(:,67,10) = (/ &
  & 0.38282931E-03_JPRB, 0.38332743E-03_JPRB, 0.38381702E-03_JPRB, 0.38392444E-03_JPRB, 0.38389925E-03_JPRB, 0.38412231E-03_JPRB, &
  & 0.38423858E-03_JPRB, 0.38427615E-03_JPRB, 0.38420051E-03_JPRB, 0.38399321E-03_JPRB, 0.38374859E-03_JPRB, 0.38349179E-03_JPRB, &
  & 0.38316160E-03_JPRB, 0.38289918E-03_JPRB, 0.38263271E-03_JPRB, 0.38235722E-03_JPRB, 0.38207759E-03_JPRB, 0.38181692E-03_JPRB, &
  & 0.38166821E-03_JPRB, 0.38165960E-03_JPRB, 0.38170544E-03_JPRB, 0.38173127E-03_JPRB, 0.38178872E-03_JPRB, 0.38196605E-03_JPRB, &
  & 0.38225618E-03_JPRB, 0.38257659E-03_JPRB, 0.38295198E-03_JPRB, 0.38320729E-03_JPRB, 0.38338736E-03_JPRB, 0.38358082E-03_JPRB, &
  & 0.38371782E-03_JPRB, 0.38378101E-03_JPRB, 0.38391914E-03_JPRB, 0.38402677E-03_JPRB, 0.38386034E-03_JPRB, 0.38342100E-03_JPRB, &
  & 0.38285199E-03_JPRB, 0.38222606E-03_JPRB, 0.38174626E-03_JPRB, 0.38138337E-03_JPRB, 0.38112081E-03_JPRB, 0.38106332E-03_JPRB, &
  & 0.38112124E-03_JPRB, 0.38122128E-03_JPRB, 0.38139478E-03_JPRB, 0.38165648E-03_JPRB, 0.38203784E-03_JPRB, 0.38250961E-03_JPRB, &
  & 0.38297961E-03_JPRB, 0.38348264E-03_JPRB, 0.38406707E-03_JPRB, 0.38461120E-03_JPRB, 0.38497521E-03_JPRB, 0.38526570E-03_JPRB, &
  & 0.38557096E-03_JPRB, 0.38590110E-03_JPRB, 0.38612950E-03_JPRB, 0.38633510E-03_JPRB, 0.38660892E-03_JPRB, 0.38682430E-03_JPRB, &
  & 0.38700898E-03_JPRB, 0.38694117E-03_JPRB, 0.38680178E-03_JPRB, 0.38645035E-03_JPRB  /)

RGHG1(:,68,10) = (/ &
  & 0.38332490E-03_JPRB, 0.38372033E-03_JPRB, 0.38412336E-03_JPRB, 0.38422513E-03_JPRB, 0.38417047E-03_JPRB, 0.38436809E-03_JPRB, &
  & 0.38449323E-03_JPRB, 0.38450996E-03_JPRB, 0.38444848E-03_JPRB, 0.38424682E-03_JPRB, 0.38398458E-03_JPRB, 0.38372894E-03_JPRB, &
  & 0.38339541E-03_JPRB, 0.38313241E-03_JPRB, 0.38283970E-03_JPRB, 0.38253358E-03_JPRB, 0.38223726E-03_JPRB, 0.38196105E-03_JPRB, &
  & 0.38180048E-03_JPRB, 0.38176378E-03_JPRB, 0.38177866E-03_JPRB, 0.38180356E-03_JPRB, 0.38187690E-03_JPRB, 0.38204502E-03_JPRB, &
  & 0.38233181E-03_JPRB, 0.38265947E-03_JPRB, 0.38300263E-03_JPRB, 0.38325829E-03_JPRB, 0.38344745E-03_JPRB, 0.38364966E-03_JPRB, &
  & 0.38380209E-03_JPRB, 0.38386240E-03_JPRB, 0.38399201E-03_JPRB, 0.38406821E-03_JPRB, 0.38385136E-03_JPRB, 0.38340270E-03_JPRB, &
  & 0.38288066E-03_JPRB, 0.38233116E-03_JPRB, 0.38192964E-03_JPRB, 0.38160762E-03_JPRB, 0.38134012E-03_JPRB, 0.38127226E-03_JPRB, &
  & 0.38131625E-03_JPRB, 0.38143218E-03_JPRB, 0.38162122E-03_JPRB, 0.38187670E-03_JPRB, 0.38227982E-03_JPRB, 0.38276011E-03_JPRB, &
  & 0.38324462E-03_JPRB, 0.38375869E-03_JPRB, 0.38435314E-03_JPRB, 0.38491235E-03_JPRB, 0.38531193E-03_JPRB, 0.38563109E-03_JPRB, &
  & 0.38595638E-03_JPRB, 0.38631381E-03_JPRB, 0.38650778E-03_JPRB, 0.38671211E-03_JPRB, 0.38701598E-03_JPRB, 0.38723574E-03_JPRB, &
  & 0.38741628E-03_JPRB, 0.38743825E-03_JPRB, 0.38726847E-03_JPRB, 0.38704483E-03_JPRB  /)

RGHG1(:,69,10) = (/ &
  & 0.38376120E-03_JPRB, 0.38406025E-03_JPRB, 0.38438447E-03_JPRB, 0.38448071E-03_JPRB, 0.38440508E-03_JPRB, 0.38456489E-03_JPRB, &
  & 0.38470790E-03_JPRB, 0.38471375E-03_JPRB, 0.38467513E-03_JPRB, 0.38447513E-03_JPRB, 0.38420607E-03_JPRB, 0.38394833E-03_JPRB, &
  & 0.38361670E-03_JPRB, 0.38335659E-03_JPRB, 0.38304664E-03_JPRB, 0.38271484E-03_JPRB, 0.38240130E-03_JPRB, 0.38210745E-03_JPRB, &
  & 0.38193828E-03_JPRB, 0.38188146E-03_JPRB, 0.38187795E-03_JPRB, 0.38190654E-03_JPRB, 0.38198633E-03_JPRB, 0.38215416E-03_JPRB, &
  & 0.38244148E-03_JPRB, 0.38277221E-03_JPRB, 0.38308848E-03_JPRB, 0.38333296E-03_JPRB, 0.38352136E-03_JPRB, 0.38371209E-03_JPRB, &
  & 0.38387733E-03_JPRB, 0.38391245E-03_JPRB, 0.38403396E-03_JPRB, 0.38409246E-03_JPRB, 0.38384081E-03_JPRB, 0.38340032E-03_JPRB, &
  & 0.38293404E-03_JPRB, 0.38245500E-03_JPRB, 0.38211509E-03_JPRB, 0.38183508E-03_JPRB, 0.38157499E-03_JPRB, 0.38150117E-03_JPRB, &
  & 0.38154287E-03_JPRB, 0.38167101E-03_JPRB, 0.38187653E-03_JPRB, 0.38213617E-03_JPRB, 0.38255078E-03_JPRB, 0.38304378E-03_JPRB, &
  & 0.38354771E-03_JPRB, 0.38408027E-03_JPRB, 0.38468180E-03_JPRB, 0.38524499E-03_JPRB, 0.38567343E-03_JPRB, 0.38602805E-03_JPRB, &
  & 0.38636530E-03_JPRB, 0.38671973E-03_JPRB, 0.38688055E-03_JPRB, 0.38710383E-03_JPRB, 0.38743177E-03_JPRB, 0.38764741E-03_JPRB, &
  & 0.38780809E-03_JPRB, 0.38789459E-03_JPRB, 0.38769474E-03_JPRB, 0.38760210E-03_JPRB  /)

RGHG1(:,70,10) = (/ &
  & 0.38413987E-03_JPRB, 0.38436344E-03_JPRB, 0.38462058E-03_JPRB, 0.38470794E-03_JPRB, 0.38461982E-03_JPRB, 0.38473625E-03_JPRB, &
  & 0.38489853E-03_JPRB, 0.38490316E-03_JPRB, 0.38488776E-03_JPRB, 0.38468775E-03_JPRB, 0.38441889E-03_JPRB, 0.38416120E-03_JPRB, &
  & 0.38383520E-03_JPRB, 0.38357872E-03_JPRB, 0.38325882E-03_JPRB, 0.38290437E-03_JPRB, 0.38257373E-03_JPRB, 0.38226034E-03_JPRB, &
  & 0.38208099E-03_JPRB, 0.38200706E-03_JPRB, 0.38199621E-03_JPRB, 0.38202788E-03_JPRB, 0.38210645E-03_JPRB, 0.38227625E-03_JPRB, &
  & 0.38256678E-03_JPRB, 0.38289607E-03_JPRB, 0.38318432E-03_JPRB, 0.38341286E-03_JPRB, 0.38359571E-03_JPRB, 0.38376901E-03_JPRB, &
  & 0.38393578E-03_JPRB, 0.38394512E-03_JPRB, 0.38405688E-03_JPRB, 0.38410396E-03_JPRB, 0.38382968E-03_JPRB, 0.38340774E-03_JPRB, &
  & 0.38299841E-03_JPRB, 0.38258234E-03_JPRB, 0.38229282E-03_JPRB, 0.38205355E-03_JPRB, 0.38180866E-03_JPRB, 0.38173406E-03_JPRB, &
  & 0.38178430E-03_JPRB, 0.38192519E-03_JPRB, 0.38214638E-03_JPRB, 0.38241791E-03_JPRB, 0.38284414E-03_JPRB, 0.38335377E-03_JPRB, &
  & 0.38387665E-03_JPRB, 0.38443041E-03_JPRB, 0.38503660E-03_JPRB, 0.38560207E-03_JPRB, 0.38605341E-03_JPRB, 0.38644432E-03_JPRB, &
  & 0.38678339E-03_JPRB, 0.38712272E-03_JPRB, 0.38725024E-03_JPRB, 0.38750542E-03_JPRB, 0.38784979E-03_JPRB, 0.38804883E-03_JPRB, &
  & 0.38818124E-03_JPRB, 0.38830394E-03_JPRB, 0.38810356E-03_JPRB, 0.38812565E-03_JPRB  /)

RGHG1(:,71,10) = (/ &
  & 0.38446396E-03_JPRB, 0.38462960E-03_JPRB, 0.38483306E-03_JPRB, 0.38490915E-03_JPRB, 0.38481585E-03_JPRB, 0.38488732E-03_JPRB, &
  & 0.38506671E-03_JPRB, 0.38507980E-03_JPRB, 0.38508561E-03_JPRB, 0.38488549E-03_JPRB, 0.38462139E-03_JPRB, 0.38436679E-03_JPRB, &
  & 0.38405122E-03_JPRB, 0.38379877E-03_JPRB, 0.38347653E-03_JPRB, 0.38310448E-03_JPRB, 0.38275677E-03_JPRB, 0.38242274E-03_JPRB, &
  & 0.38223073E-03_JPRB, 0.38213970E-03_JPRB, 0.38212916E-03_JPRB, 0.38216253E-03_JPRB, 0.38223653E-03_JPRB, 0.38240846E-03_JPRB, &
  & 0.38269968E-03_JPRB, 0.38302264E-03_JPRB, 0.38328291E-03_JPRB, 0.38349282E-03_JPRB, 0.38366421E-03_JPRB, 0.38381764E-03_JPRB, &
  & 0.38397766E-03_JPRB, 0.38396018E-03_JPRB, 0.38405989E-03_JPRB, 0.38410069E-03_JPRB, 0.38381673E-03_JPRB, 0.38342190E-03_JPRB, &
  & 0.38306730E-03_JPRB, 0.38270530E-03_JPRB, 0.38245629E-03_JPRB, 0.38225570E-03_JPRB, 0.38203460E-03_JPRB, 0.38196436E-03_JPRB, &
  & 0.38203446E-03_JPRB, 0.38218960E-03_JPRB, 0.38242607E-03_JPRB, 0.38271795E-03_JPRB, 0.38315788E-03_JPRB, 0.38368709E-03_JPRB, &
  & 0.38422894E-03_JPRB, 0.38480577E-03_JPRB, 0.38541371E-03_JPRB, 0.38598158E-03_JPRB, 0.38644995E-03_JPRB, 0.38687375E-03_JPRB, &
  & 0.38720505E-03_JPRB, 0.38751954E-03_JPRB, 0.38761550E-03_JPRB, 0.38791027E-03_JPRB, 0.38826408E-03_JPRB, 0.38843656E-03_JPRB, &
  & 0.38853941E-03_JPRB, 0.38867576E-03_JPRB, 0.38850289E-03_JPRB, 0.38862269E-03_JPRB  /)

RGHG1(:,72,10) = (/ &
  & 0.38473891E-03_JPRB, 0.38485477E-03_JPRB, 0.38502055E-03_JPRB, 0.38508546E-03_JPRB, 0.38499216E-03_JPRB, 0.38502318E-03_JPRB, &
  & 0.38521225E-03_JPRB, 0.38524390E-03_JPRB, 0.38526607E-03_JPRB, 0.38506826E-03_JPRB, 0.38480968E-03_JPRB, 0.38456188E-03_JPRB, &
  & 0.38426406E-03_JPRB, 0.38401599E-03_JPRB, 0.38370020E-03_JPRB, 0.38331997E-03_JPRB, 0.38295486E-03_JPRB, 0.38260055E-03_JPRB, &
  & 0.38239252E-03_JPRB, 0.38227948E-03_JPRB, 0.38227090E-03_JPRB, 0.38230415E-03_JPRB, 0.38237815E-03_JPRB, 0.38254962E-03_JPRB, &
  & 0.38282920E-03_JPRB, 0.38314007E-03_JPRB, 0.38337591E-03_JPRB, 0.38356703E-03_JPRB, 0.38371756E-03_JPRB, 0.38385244E-03_JPRB, &
  & 0.38400486E-03_JPRB, 0.38395384E-03_JPRB, 0.38403822E-03_JPRB, 0.38407741E-03_JPRB, 0.38379921E-03_JPRB, 0.38343838E-03_JPRB, &
  & 0.38313149E-03_JPRB, 0.38281212E-03_JPRB, 0.38259515E-03_JPRB, 0.38243028E-03_JPRB, 0.38224432E-03_JPRB, 0.38218353E-03_JPRB, &
  & 0.38228625E-03_JPRB, 0.38245822E-03_JPRB, 0.38271082E-03_JPRB, 0.38303380E-03_JPRB, 0.38349114E-03_JPRB, 0.38404120E-03_JPRB, &
  & 0.38460426E-03_JPRB, 0.38520552E-03_JPRB, 0.38581116E-03_JPRB, 0.38638306E-03_JPRB, 0.38686249E-03_JPRB, 0.38730899E-03_JPRB, &
  & 0.38762416E-03_JPRB, 0.38790442E-03_JPRB, 0.38797446E-03_JPRB, 0.38830817E-03_JPRB, 0.38866590E-03_JPRB, 0.38880727E-03_JPRB, &
  & 0.38889145E-03_JPRB, 0.38903022E-03_JPRB, 0.38890460E-03_JPRB, 0.38910771E-03_JPRB  /)

RGHG1(:,73,10) = (/ &
  & 0.38496230E-03_JPRB, 0.38503622E-03_JPRB, 0.38517576E-03_JPRB, 0.38523199E-03_JPRB, 0.38514296E-03_JPRB, 0.38514571E-03_JPRB, &
  & 0.38533125E-03_JPRB, 0.38538820E-03_JPRB, 0.38541944E-03_JPRB, 0.38522887E-03_JPRB, 0.38497650E-03_JPRB, 0.38474014E-03_JPRB, &
  & 0.38445952E-03_JPRB, 0.38422313E-03_JPRB, 0.38392185E-03_JPRB, 0.38355350E-03_JPRB, 0.38318426E-03_JPRB, 0.38281543E-03_JPRB, &
  & 0.38259428E-03_JPRB, 0.38245173E-03_JPRB, 0.38244116E-03_JPRB, 0.38246970E-03_JPRB, 0.38253707E-03_JPRB, 0.38270615E-03_JPRB, &
  & 0.38297477E-03_JPRB, 0.38326513E-03_JPRB, 0.38346634E-03_JPRB, 0.38363654E-03_JPRB, 0.38376460E-03_JPRB, 0.38387344E-03_JPRB, &
  & 0.38401349E-03_JPRB, 0.38391057E-03_JPRB, 0.38398488E-03_JPRB, 0.38403593E-03_JPRB, 0.38377464E-03_JPRB, 0.38344640E-03_JPRB, &
  & 0.38318877E-03_JPRB, 0.38290865E-03_JPRB, 0.38271321E-03_JPRB, 0.38258994E-03_JPRB, 0.38246297E-03_JPRB, 0.38243232E-03_JPRB, &
  & 0.38256966E-03_JPRB, 0.38276496E-03_JPRB, 0.38302791E-03_JPRB, 0.38338305E-03_JPRB, 0.38386195E-03_JPRB, 0.38442914E-03_JPRB, &
  & 0.38501919E-03_JPRB, 0.38563005E-03_JPRB, 0.38623070E-03_JPRB, 0.38680376E-03_JPRB, 0.38728330E-03_JPRB, 0.38773553E-03_JPRB, &
  & 0.38802634E-03_JPRB, 0.38827015E-03_JPRB, 0.38832427E-03_JPRB, 0.38868988E-03_JPRB, 0.38903337E-03_JPRB, 0.38914858E-03_JPRB, &
  & 0.38922875E-03_JPRB, 0.38935583E-03_JPRB, 0.38928511E-03_JPRB, 0.38953255E-03_JPRB  /)

RGHG1(:,74,10) = (/ &
  & 0.38515349E-03_JPRB, 0.38519250E-03_JPRB, 0.38530957E-03_JPRB, 0.38535602E-03_JPRB, 0.38527483E-03_JPRB, 0.38525906E-03_JPRB, &
  & 0.38543329E-03_JPRB, 0.38551342E-03_JPRB, 0.38555082E-03_JPRB, 0.38537284E-03_JPRB, 0.38512832E-03_JPRB, 0.38490572E-03_JPRB, &
  & 0.38464420E-03_JPRB, 0.38442287E-03_JPRB, 0.38413913E-03_JPRB, 0.38378983E-03_JPRB, 0.38343149E-03_JPRB, 0.38306117E-03_JPRB, &
  & 0.38282432E-03_JPRB, 0.38265470E-03_JPRB, 0.38263841E-03_JPRB, 0.38266791E-03_JPRB, 0.38273707E-03_JPRB, 0.38290632E-03_JPRB, &
  & 0.38314610E-03_JPRB, 0.38340127E-03_JPRB, 0.38355973E-03_JPRB, 0.38370231E-03_JPRB, 0.38380165E-03_JPRB, 0.38388517E-03_JPRB, &
  & 0.38400804E-03_JPRB, 0.38383988E-03_JPRB, 0.38392016E-03_JPRB, 0.38399274E-03_JPRB, 0.38374714E-03_JPRB, 0.38344709E-03_JPRB, &
  & 0.38324604E-03_JPRB, 0.38300554E-03_JPRB, 0.38282619E-03_JPRB, 0.38275611E-03_JPRB, 0.38270537E-03_JPRB, 0.38272495E-03_JPRB, &
  & 0.38290420E-03_JPRB, 0.38311906E-03_JPRB, 0.38338357E-03_JPRB, 0.38376854E-03_JPRB, 0.38427386E-03_JPRB, 0.38485430E-03_JPRB, &
  & 0.38546450E-03_JPRB, 0.38607451E-03_JPRB, 0.38667182E-03_JPRB, 0.38724519E-03_JPRB, 0.38771167E-03_JPRB, 0.38815747E-03_JPRB, &
  & 0.38841888E-03_JPRB, 0.38863171E-03_JPRB, 0.38867488E-03_JPRB, 0.38906474E-03_JPRB, 0.38938343E-03_JPRB, 0.38947028E-03_JPRB, &
  & 0.38954683E-03_JPRB, 0.38966739E-03_JPRB, 0.38967526E-03_JPRB, 0.38991472E-03_JPRB  /)

RGHG1(:,75,10) = (/ &
  & 0.38531500E-03_JPRB, 0.38532710E-03_JPRB, 0.38542437E-03_JPRB, 0.38545994E-03_JPRB, 0.38538962E-03_JPRB, 0.38536289E-03_JPRB, &
  & 0.38551978E-03_JPRB, 0.38561876E-03_JPRB, 0.38566088E-03_JPRB, 0.38549965E-03_JPRB, 0.38526342E-03_JPRB, 0.38505670E-03_JPRB, &
  & 0.38481567E-03_JPRB, 0.38461146E-03_JPRB, 0.38434663E-03_JPRB, 0.38402131E-03_JPRB, 0.38368458E-03_JPRB, 0.38333013E-03_JPRB, &
  & 0.38307974E-03_JPRB, 0.38288740E-03_JPRB, 0.38285954E-03_JPRB, 0.38289853E-03_JPRB, 0.38297601E-03_JPRB, 0.38313729E-03_JPRB, &
  & 0.38332728E-03_JPRB, 0.38353538E-03_JPRB, 0.38365239E-03_JPRB, 0.38376528E-03_JPRB, 0.38383260E-03_JPRB, 0.38389175E-03_JPRB, &
  & 0.38399307E-03_JPRB, 0.38375049E-03_JPRB, 0.38384509E-03_JPRB, 0.38394826E-03_JPRB, 0.38371990E-03_JPRB, 0.38343934E-03_JPRB, &
  & 0.38330051E-03_JPRB, 0.38310046E-03_JPRB, 0.38293052E-03_JPRB, 0.38291684E-03_JPRB, 0.38295743E-03_JPRB, 0.38304987E-03_JPRB, &
  & 0.38327680E-03_JPRB, 0.38351023E-03_JPRB, 0.38377579E-03_JPRB, 0.38418461E-03_JPRB, 0.38471806E-03_JPRB, 0.38530984E-03_JPRB, &
  & 0.38593791E-03_JPRB, 0.38653812E-03_JPRB, 0.38713175E-03_JPRB, 0.38770239E-03_JPRB, 0.38814387E-03_JPRB, 0.38857190E-03_JPRB, &
  & 0.38879939E-03_JPRB, 0.38898454E-03_JPRB, 0.38902601E-03_JPRB, 0.38942684E-03_JPRB, 0.38971669E-03_JPRB, 0.38977427E-03_JPRB, &
  & 0.38984573E-03_JPRB, 0.38996752E-03_JPRB, 0.39005737E-03_JPRB, 0.39025891E-03_JPRB  /)

RGHG1(:,76,10) = (/ &
  & 0.38544779E-03_JPRB, 0.38544271E-03_JPRB, 0.38552223E-03_JPRB, 0.38554627E-03_JPRB, 0.38548920E-03_JPRB, 0.38545614E-03_JPRB, &
  & 0.38559147E-03_JPRB, 0.38570267E-03_JPRB, 0.38574975E-03_JPRB, 0.38560765E-03_JPRB, 0.38537811E-03_JPRB, 0.38518949E-03_JPRB, &
  & 0.38496931E-03_JPRB, 0.38478286E-03_JPRB, 0.38453646E-03_JPRB, 0.38423858E-03_JPRB, 0.38392732E-03_JPRB, 0.38361241E-03_JPRB, &
  & 0.38335901E-03_JPRB, 0.38314985E-03_JPRB, 0.38310101E-03_JPRB, 0.38316133E-03_JPRB, 0.38324860E-03_JPRB, 0.38337600E-03_JPRB, &
  & 0.38349245E-03_JPRB, 0.38364649E-03_JPRB, 0.38373791E-03_JPRB, 0.38382695E-03_JPRB, 0.38386407E-03_JPRB, 0.38389889E-03_JPRB, &
  & 0.38397498E-03_JPRB, 0.38365413E-03_JPRB, 0.38375783E-03_JPRB, 0.38390054E-03_JPRB, 0.38369730E-03_JPRB, 0.38342101E-03_JPRB, &
  & 0.38334685E-03_JPRB, 0.38318840E-03_JPRB, 0.38301835E-03_JPRB, 0.38305043E-03_JPRB, 0.38319556E-03_JPRB, 0.38338839E-03_JPRB, &
  & 0.38366581E-03_JPRB, 0.38392287E-03_JPRB, 0.38420249E-03_JPRB, 0.38462376E-03_JPRB, 0.38518211E-03_JPRB, 0.38578645E-03_JPRB, &
  & 0.38643918E-03_JPRB, 0.38702210E-03_JPRB, 0.38760790E-03_JPRB, 0.38816897E-03_JPRB, 0.38857541E-03_JPRB, 0.38897463E-03_JPRB, &
  & 0.38916385E-03_JPRB, 0.38931995E-03_JPRB, 0.38937675E-03_JPRB, 0.38976617E-03_JPRB, 0.39003216E-03_JPRB, 0.39006254E-03_JPRB, &
  & 0.39012651E-03_JPRB, 0.39025878E-03_JPRB, 0.39039981E-03_JPRB, 0.39057012E-03_JPRB  /)

RGHG1(:,77,10) = (/ &
  & 0.38554975E-03_JPRB, 0.38553369E-03_JPRB, 0.38560363E-03_JPRB, 0.38561798E-03_JPRB, 0.38557180E-03_JPRB, 0.38553552E-03_JPRB, &
  & 0.38564678E-03_JPRB, 0.38576239E-03_JPRB, 0.38581383E-03_JPRB, 0.38569080E-03_JPRB, 0.38546627E-03_JPRB, 0.38529001E-03_JPRB, &
  & 0.38509156E-03_JPRB, 0.38491745E-03_JPRB, 0.38469308E-03_JPRB, 0.38442391E-03_JPRB, 0.38414680E-03_JPRB, 0.38385348E-03_JPRB, &
  & 0.38360347E-03_JPRB, 0.38340053E-03_JPRB, 0.38331244E-03_JPRB, 0.38336013E-03_JPRB, 0.38343228E-03_JPRB, 0.38352453E-03_JPRB, &
  & 0.38359855E-03_JPRB, 0.38371207E-03_JPRB, 0.38378618E-03_JPRB, 0.38386410E-03_JPRB, 0.38388944E-03_JPRB, 0.38391202E-03_JPRB, &
  & 0.38396705E-03_JPRB, 0.38359975E-03_JPRB, 0.38368153E-03_JPRB, 0.38386578E-03_JPRB, 0.38368182E-03_JPRB, 0.38339632E-03_JPRB, &
  & 0.38337688E-03_JPRB, 0.38325509E-03_JPRB, 0.38308315E-03_JPRB, 0.38314845E-03_JPRB, 0.38337355E-03_JPRB, 0.38365669E-03_JPRB, &
  & 0.38397976E-03_JPRB, 0.38427398E-03_JPRB, 0.38457951E-03_JPRB, 0.38503957E-03_JPRB, 0.38563259E-03_JPRB, 0.38627240E-03_JPRB, &
  & 0.38695492E-03_JPRB, 0.38750844E-03_JPRB, 0.38808962E-03_JPRB, 0.38864331E-03_JPRB, 0.38900168E-03_JPRB, 0.38936514E-03_JPRB, &
  & 0.38951033E-03_JPRB, 0.38964052E-03_JPRB, 0.38971420E-03_JPRB, 0.39008207E-03_JPRB, 0.39032153E-03_JPRB, 0.39033529E-03_JPRB, &
  & 0.39039887E-03_JPRB, 0.39055265E-03_JPRB, 0.39073771E-03_JPRB, 0.39090883E-03_JPRB  /)

RGHG1(:,78,10) = (/ &
  & 0.38563109E-03_JPRB, 0.38560442E-03_JPRB, 0.38567188E-03_JPRB, 0.38568068E-03_JPRB, 0.38564099E-03_JPRB, 0.38560302E-03_JPRB, &
  & 0.38569170E-03_JPRB, 0.38580704E-03_JPRB, 0.38586235E-03_JPRB, 0.38575832E-03_JPRB, 0.38553943E-03_JPRB, 0.38536968E-03_JPRB, &
  & 0.38518437E-03_JPRB, 0.38501841E-03_JPRB, 0.38481255E-03_JPRB, 0.38456456E-03_JPRB, 0.38430532E-03_JPRB, 0.38402991E-03_JPRB, &
  & 0.38378023E-03_JPRB, 0.38358303E-03_JPRB, 0.38347052E-03_JPRB, 0.38349855E-03_JPRB, 0.38355976E-03_JPRB, 0.38362769E-03_JPRB, &
  & 0.38367362E-03_JPRB, 0.38375648E-03_JPRB, 0.38381278E-03_JPRB, 0.38388010E-03_JPRB, 0.38390162E-03_JPRB, 0.38392364E-03_JPRB, &
  & 0.38396304E-03_JPRB, 0.38356547E-03_JPRB, 0.38362824E-03_JPRB, 0.38384574E-03_JPRB, 0.38366968E-03_JPRB, 0.38337019E-03_JPRB, &
  & 0.38339692E-03_JPRB, 0.38330537E-03_JPRB, 0.38313784E-03_JPRB, 0.38322819E-03_JPRB, 0.38350705E-03_JPRB, 0.38386348E-03_JPRB, &
  & 0.38423430E-03_JPRB, 0.38457616E-03_JPRB, 0.38490481E-03_JPRB, 0.38541061E-03_JPRB, 0.38605505E-03_JPRB, 0.38674052E-03_JPRB, &
  & 0.38744037E-03_JPRB, 0.38798636E-03_JPRB, 0.38856206E-03_JPRB, 0.38909717E-03_JPRB, 0.38942267E-03_JPRB, 0.38974417E-03_JPRB, &
  & 0.38984311E-03_JPRB, 0.38994773E-03_JPRB, 0.39002955E-03_JPRB, 0.39036493E-03_JPRB, 0.39058114E-03_JPRB, 0.39056625E-03_JPRB, &
  & 0.39063562E-03_JPRB, 0.39079888E-03_JPRB, 0.39099483E-03_JPRB, 0.39117059E-03_JPRB  /)

RGHG1(:,79,10) = (/ &
  & 0.38569399E-03_JPRB, 0.38565674E-03_JPRB, 0.38572817E-03_JPRB, 0.38573383E-03_JPRB, 0.38569787E-03_JPRB, 0.38565934E-03_JPRB, &
  & 0.38572801E-03_JPRB, 0.38583913E-03_JPRB, 0.38589700E-03_JPRB, 0.38580991E-03_JPRB, 0.38559778E-03_JPRB, 0.38542930E-03_JPRB, &
  & 0.38525029E-03_JPRB, 0.38508906E-03_JPRB, 0.38489586E-03_JPRB, 0.38466046E-03_JPRB, 0.38440938E-03_JPRB, 0.38414762E-03_JPRB, &
  & 0.38389772E-03_JPRB, 0.38370583E-03_JPRB, 0.38358085E-03_JPRB, 0.38359131E-03_JPRB, 0.38364723E-03_JPRB, 0.38370044E-03_JPRB, &
  & 0.38372886E-03_JPRB, 0.38378834E-03_JPRB, 0.38382683E-03_JPRB, 0.38388215E-03_JPRB, 0.38390146E-03_JPRB, 0.38393194E-03_JPRB, &
  & 0.38396199E-03_JPRB, 0.38354417E-03_JPRB, 0.38359543E-03_JPRB, 0.38383775E-03_JPRB, 0.38365862E-03_JPRB, 0.38334194E-03_JPRB, &
  & 0.38340891E-03_JPRB, 0.38334451E-03_JPRB, 0.38318497E-03_JPRB, 0.38329593E-03_JPRB, 0.38360568E-03_JPRB, 0.38401795E-03_JPRB, &
  & 0.38443559E-03_JPRB, 0.38482892E-03_JPRB, 0.38518155E-03_JPRB, 0.38573338E-03_JPRB, 0.38644318E-03_JPRB, 0.38717934E-03_JPRB, &
  & 0.38788773E-03_JPRB, 0.38843967E-03_JPRB, 0.38901289E-03_JPRB, 0.38952466E-03_JPRB, 0.38982921E-03_JPRB, 0.39010724E-03_JPRB, &
  & 0.39016232E-03_JPRB, 0.39024528E-03_JPRB, 0.39032399E-03_JPRB, 0.39062096E-03_JPRB, 0.39081304E-03_JPRB, 0.39076258E-03_JPRB, &
  & 0.39083804E-03_JPRB, 0.39100137E-03_JPRB, 0.39118652E-03_JPRB, 0.39136457E-03_JPRB  /)

RGHG1(:,80,10) = (/ &
  & 0.38574083E-03_JPRB, 0.38569290E-03_JPRB, 0.38577395E-03_JPRB, 0.38577676E-03_JPRB, 0.38574378E-03_JPRB, 0.38570544E-03_JPRB, &
  & 0.38575750E-03_JPRB, 0.38586119E-03_JPRB, 0.38591942E-03_JPRB, 0.38584498E-03_JPRB, 0.38564114E-03_JPRB, 0.38546945E-03_JPRB, &
  & 0.38529268E-03_JPRB, 0.38513369E-03_JPRB, 0.38494524E-03_JPRB, 0.38471337E-03_JPRB, 0.38446999E-03_JPRB, 0.38421607E-03_JPRB, &
  & 0.38396891E-03_JPRB, 0.38378345E-03_JPRB, 0.38365226E-03_JPRB, 0.38365570E-03_JPRB, 0.38371157E-03_JPRB, 0.38375726E-03_JPRB, &
  & 0.38377543E-03_JPRB, 0.38381587E-03_JPRB, 0.38383770E-03_JPRB, 0.38387828E-03_JPRB, 0.38389060E-03_JPRB, 0.38393531E-03_JPRB, &
  & 0.38396299E-03_JPRB, 0.38352906E-03_JPRB, 0.38357894E-03_JPRB, 0.38383843E-03_JPRB, 0.38364644E-03_JPRB, 0.38331067E-03_JPRB, &
  & 0.38341484E-03_JPRB, 0.38337828E-03_JPRB, 0.38322669E-03_JPRB, 0.38335785E-03_JPRB, 0.38367997E-03_JPRB, 0.38413097E-03_JPRB, &
  & 0.38459065E-03_JPRB, 0.38503181E-03_JPRB, 0.38541431E-03_JPRB, 0.38600621E-03_JPRB, 0.38679136E-03_JPRB, 0.38757795E-03_JPRB, &
  & 0.38829133E-03_JPRB, 0.38885064E-03_JPRB, 0.38942908E-03_JPRB, 0.38992098E-03_JPRB, 0.39021095E-03_JPRB, 0.39044934E-03_JPRB, &
  & 0.39046755E-03_JPRB, 0.39053684E-03_JPRB, 0.39059943E-03_JPRB, 0.39085834E-03_JPRB, 0.39102034E-03_JPRB, 0.39093495E-03_JPRB, &
  & 0.39101011E-03_JPRB, 0.39116868E-03_JPRB, 0.39133641E-03_JPRB, 0.39150938E-03_JPRB  /)

RGHG1(:,81,10) = (/ &
  & 0.38576051E-03_JPRB, 0.38571103E-03_JPRB, 0.38580453E-03_JPRB, 0.38580283E-03_JPRB, 0.38577329E-03_JPRB, 0.38573803E-03_JPRB, &
  & 0.38577990E-03_JPRB, 0.38587351E-03_JPRB, 0.38593009E-03_JPRB, 0.38586703E-03_JPRB, 0.38566971E-03_JPRB, 0.38549410E-03_JPRB, &
  & 0.38531508E-03_JPRB, 0.38515348E-03_JPRB, 0.38496551E-03_JPRB, 0.38474016E-03_JPRB, 0.38450460E-03_JPRB, 0.38425625E-03_JPRB, &
  & 0.38401264E-03_JPRB, 0.38383418E-03_JPRB, 0.38370655E-03_JPRB, 0.38370477E-03_JPRB, 0.38376478E-03_JPRB, 0.38380739E-03_JPRB, &
  & 0.38381763E-03_JPRB, 0.38384609E-03_JPRB, 0.38386129E-03_JPRB, 0.38389061E-03_JPRB, 0.38388527E-03_JPRB, 0.38394503E-03_JPRB, &
  & 0.38397685E-03_JPRB, 0.38350927E-03_JPRB, 0.38357763E-03_JPRB, 0.38383962E-03_JPRB, 0.38362510E-03_JPRB, 0.38327215E-03_JPRB, &
  & 0.38341484E-03_JPRB, 0.38341194E-03_JPRB, 0.38326604E-03_JPRB, 0.38340893E-03_JPRB, 0.38373639E-03_JPRB, 0.38421489E-03_JPRB, &
  & 0.38470645E-03_JPRB, 0.38519158E-03_JPRB, 0.38560288E-03_JPRB, 0.38622619E-03_JPRB, 0.38707653E-03_JPRB, 0.38792226E-03_JPRB, &
  & 0.38865532E-03_JPRB, 0.38922980E-03_JPRB, 0.38980041E-03_JPRB, 0.39028201E-03_JPRB, 0.39053760E-03_JPRB, 0.39073724E-03_JPRB, &
  & 0.39075758E-03_JPRB, 0.39082284E-03_JPRB, 0.39085331E-03_JPRB, 0.39104893E-03_JPRB, 0.39118023E-03_JPRB, 0.39106177E-03_JPRB, &
  & 0.39114179E-03_JPRB, 0.39130024E-03_JPRB, 0.39145742E-03_JPRB, 0.39161700E-03_JPRB  /)

RGHG1(:,82,10) = (/ &
  & 0.38576764E-03_JPRB, 0.38572170E-03_JPRB, 0.38582348E-03_JPRB, 0.38581845E-03_JPRB, 0.38579273E-03_JPRB, 0.38576160E-03_JPRB, &
  & 0.38579742E-03_JPRB, 0.38588176E-03_JPRB, 0.38593824E-03_JPRB, 0.38588379E-03_JPRB, 0.38569237E-03_JPRB, 0.38550994E-03_JPRB, &
  & 0.38532852E-03_JPRB, 0.38516376E-03_JPRB, 0.38497675E-03_JPRB, 0.38475795E-03_JPRB, 0.38452894E-03_JPRB, 0.38428670E-03_JPRB, &
  & 0.38404875E-03_JPRB, 0.38387813E-03_JPRB, 0.38375706E-03_JPRB, 0.38375401E-03_JPRB, 0.38381399E-03_JPRB, 0.38385868E-03_JPRB, &
  & 0.38386461E-03_JPRB, 0.38388478E-03_JPRB, 0.38389714E-03_JPRB, 0.38391788E-03_JPRB, 0.38389712E-03_JPRB, 0.38396113E-03_JPRB, &
  & 0.38399708E-03_JPRB, 0.38348152E-03_JPRB, 0.38358189E-03_JPRB, 0.38383802E-03_JPRB, 0.38359508E-03_JPRB, 0.38323518E-03_JPRB, &
  & 0.38341215E-03_JPRB, 0.38344367E-03_JPRB, 0.38330196E-03_JPRB, 0.38345683E-03_JPRB, 0.38378411E-03_JPRB, 0.38428642E-03_JPRB, &
  & 0.38480510E-03_JPRB, 0.38532803E-03_JPRB, 0.38576371E-03_JPRB, 0.38641464E-03_JPRB, 0.38731880E-03_JPRB, 0.38821750E-03_JPRB, &
  & 0.38896946E-03_JPRB, 0.38955754E-03_JPRB, 0.39012879E-03_JPRB, 0.39058822E-03_JPRB, 0.39080370E-03_JPRB, 0.39097569E-03_JPRB, &
  & 0.39101382E-03_JPRB, 0.39107884E-03_JPRB, 0.39108164E-03_JPRB, 0.39120457E-03_JPRB, 0.39130406E-03_JPRB, 0.39116018E-03_JPRB, &
  & 0.39124299E-03_JPRB, 0.39138776E-03_JPRB, 0.39154328E-03_JPRB, 0.39167943E-03_JPRB  /)

RGHG1(:,83,10) = (/ &
  & 0.38576666E-03_JPRB, 0.38572761E-03_JPRB, 0.38583296E-03_JPRB, 0.38582595E-03_JPRB, 0.38580452E-03_JPRB, 0.38577816E-03_JPRB, &
  & 0.38581141E-03_JPRB, 0.38588791E-03_JPRB, 0.38594479E-03_JPRB, 0.38589593E-03_JPRB, 0.38570809E-03_JPRB, 0.38551869E-03_JPRB, &
  & 0.38533468E-03_JPRB, 0.38516739E-03_JPRB, 0.38498109E-03_JPRB, 0.38476830E-03_JPRB, 0.38454456E-03_JPRB, 0.38430944E-03_JPRB, &
  & 0.38408011E-03_JPRB, 0.38391975E-03_JPRB, 0.38380831E-03_JPRB, 0.38380564E-03_JPRB, 0.38386555E-03_JPRB, 0.38391384E-03_JPRB, &
  & 0.38391890E-03_JPRB, 0.38393277E-03_JPRB, 0.38394591E-03_JPRB, 0.38395930E-03_JPRB, 0.38392371E-03_JPRB, 0.38398550E-03_JPRB, &
  & 0.38402119E-03_JPRB, 0.38344077E-03_JPRB, 0.38358814E-03_JPRB, 0.38382952E-03_JPRB, 0.38355838E-03_JPRB, 0.38320140E-03_JPRB, &
  & 0.38340676E-03_JPRB, 0.38347181E-03_JPRB, 0.38333595E-03_JPRB, 0.38349991E-03_JPRB, 0.38382462E-03_JPRB, 0.38434697E-03_JPRB, &
  & 0.38489052E-03_JPRB, 0.38544385E-03_JPRB, 0.38590595E-03_JPRB, 0.38657639E-03_JPRB, 0.38752416E-03_JPRB, 0.38846516E-03_JPRB, &
  & 0.38923551E-03_JPRB, 0.38984061E-03_JPRB, 0.39041288E-03_JPRB, 0.39084378E-03_JPRB, 0.39101769E-03_JPRB, 0.39117032E-03_JPRB, &
  & 0.39123719E-03_JPRB, 0.39130637E-03_JPRB, 0.39128508E-03_JPRB, 0.39133304E-03_JPRB, 0.39139549E-03_JPRB, 0.39123480E-03_JPRB, &
  & 0.39131622E-03_JPRB, 0.39144643E-03_JPRB, 0.39161000E-03_JPRB, 0.39173078E-03_JPRB  /)

RGHG1(:,84,10) = (/ &
  & 0.38576148E-03_JPRB, 0.38573109E-03_JPRB, 0.38583539E-03_JPRB, 0.38582771E-03_JPRB, 0.38581097E-03_JPRB, 0.38578970E-03_JPRB, &
  & 0.38582303E-03_JPRB, 0.38589359E-03_JPRB, 0.38595043E-03_JPRB, 0.38590424E-03_JPRB, 0.38571668E-03_JPRB, 0.38552214E-03_JPRB, &
  & 0.38533546E-03_JPRB, 0.38516697E-03_JPRB, 0.38498060E-03_JPRB, 0.38477274E-03_JPRB, 0.38455314E-03_JPRB, 0.38432638E-03_JPRB, &
  & 0.38410925E-03_JPRB, 0.38396244E-03_JPRB, 0.38386355E-03_JPRB, 0.38386117E-03_JPRB, 0.38392401E-03_JPRB, 0.38397489E-03_JPRB, &
  & 0.38398196E-03_JPRB, 0.38399016E-03_JPRB, 0.38400745E-03_JPRB, 0.38401452E-03_JPRB, 0.38396449E-03_JPRB, 0.38402192E-03_JPRB, &
  & 0.38404954E-03_JPRB, 0.38338734E-03_JPRB, 0.38359539E-03_JPRB, 0.38381422E-03_JPRB, 0.38351898E-03_JPRB, 0.38317296E-03_JPRB, &
  & 0.38339974E-03_JPRB, 0.38349570E-03_JPRB, 0.38336970E-03_JPRB, 0.38353802E-03_JPRB, 0.38386051E-03_JPRB, 0.38439956E-03_JPRB, &
  & 0.38496739E-03_JPRB, 0.38554365E-03_JPRB, 0.38603819E-03_JPRB, 0.38671718E-03_JPRB, 0.38769961E-03_JPRB, 0.38866978E-03_JPRB, &
  & 0.38945701E-03_JPRB, 0.39008505E-03_JPRB, 0.39065319E-03_JPRB, 0.39105435E-03_JPRB, 0.39118893E-03_JPRB, 0.39132794E-03_JPRB, &
  & 0.39142989E-03_JPRB, 0.39150738E-03_JPRB, 0.39146472E-03_JPRB, 0.39144104E-03_JPRB, 0.39145887E-03_JPRB, 0.39128938E-03_JPRB, &
  & 0.39136397E-03_JPRB, 0.39148765E-03_JPRB, 0.39166875E-03_JPRB, 0.39179508E-03_JPRB  /)

RGHG1(:,85,10) = (/ &
  & 0.38575431E-03_JPRB, 0.38573324E-03_JPRB, 0.38583456E-03_JPRB, 0.38582652E-03_JPRB, 0.38581420E-03_JPRB, 0.38579842E-03_JPRB, &
  & 0.38583318E-03_JPRB, 0.38590004E-03_JPRB, 0.38595437E-03_JPRB, 0.38590950E-03_JPRB, 0.38572122E-03_JPRB, 0.38552202E-03_JPRB, &
  & 0.38533402E-03_JPRB, 0.38516350E-03_JPRB, 0.38497594E-03_JPRB, 0.38477118E-03_JPRB, 0.38455577E-03_JPRB, 0.38433893E-03_JPRB, &
  & 0.38414163E-03_JPRB, 0.38401202E-03_JPRB, 0.38392986E-03_JPRB, 0.38392868E-03_JPRB, 0.38399713E-03_JPRB, 0.38405339E-03_JPRB, &
  & 0.38406345E-03_JPRB, 0.38406532E-03_JPRB, 0.38409240E-03_JPRB, 0.38410760E-03_JPRB, 0.38405613E-03_JPRB, 0.38411821E-03_JPRB, &
  & 0.38412099E-03_JPRB, 0.38336034E-03_JPRB, 0.38362992E-03_JPRB, 0.38382928E-03_JPRB, 0.38350285E-03_JPRB, 0.38316317E-03_JPRB, &
  & 0.38340345E-03_JPRB, 0.38352330E-03_JPRB, 0.38341414E-03_JPRB, 0.38358677E-03_JPRB, 0.38391176E-03_JPRB, 0.38447030E-03_JPRB, &
  & 0.38505950E-03_JPRB, 0.38566002E-03_JPRB, 0.38618802E-03_JPRB, 0.38686175E-03_JPRB, 0.38787142E-03_JPRB, 0.38886357E-03_JPRB, &
  & 0.38964961E-03_JPRB, 0.39029652E-03_JPRB, 0.39086073E-03_JPRB, 0.39123739E-03_JPRB, 0.39133720E-03_JPRB, 0.39146689E-03_JPRB, &
  & 0.39160863E-03_JPRB, 0.39169316E-03_JPRB, 0.39162888E-03_JPRB, 0.39153196E-03_JPRB, 0.39149699E-03_JPRB, 0.39131375E-03_JPRB, &
  & 0.39137520E-03_JPRB, 0.39149446E-03_JPRB, 0.39170161E-03_JPRB, 0.39185757E-03_JPRB  /)

RGHG1(:,86,10) = (/ &
  & 0.38574748E-03_JPRB, 0.38573503E-03_JPRB, 0.38583409E-03_JPRB, 0.38582513E-03_JPRB, 0.38581613E-03_JPRB, 0.38580457E-03_JPRB, &
  & 0.38583956E-03_JPRB, 0.38590521E-03_JPRB, 0.38595749E-03_JPRB, 0.38591300E-03_JPRB, 0.38572372E-03_JPRB, 0.38552106E-03_JPRB, &
  & 0.38533249E-03_JPRB, 0.38515955E-03_JPRB, 0.38497042E-03_JPRB, 0.38476813E-03_JPRB, 0.38455757E-03_JPRB, 0.38435144E-03_JPRB, &
  & 0.38418090E-03_JPRB, 0.38406625E-03_JPRB, 0.38399931E-03_JPRB, 0.38400138E-03_JPRB, 0.38407595E-03_JPRB, 0.38413312E-03_JPRB, &
  & 0.38415105E-03_JPRB, 0.38415188E-03_JPRB, 0.38420405E-03_JPRB, 0.38423985E-03_JPRB, 0.38420545E-03_JPRB, 0.38429980E-03_JPRB, &
  & 0.38428694E-03_JPRB, 0.38342108E-03_JPRB, 0.38374437E-03_JPRB, 0.38390780E-03_JPRB, 0.38355741E-03_JPRB, 0.38320194E-03_JPRB, &
  & 0.38344616E-03_JPRB, 0.38357712E-03_JPRB, 0.38348275E-03_JPRB, 0.38365315E-03_JPRB, 0.38399778E-03_JPRB, 0.38457766E-03_JPRB, &
  & 0.38517864E-03_JPRB, 0.38580634E-03_JPRB, 0.38637320E-03_JPRB, 0.38703304E-03_JPRB, 0.38806429E-03_JPRB, 0.38906928E-03_JPRB, &
  & 0.38984702E-03_JPRB, 0.39049794E-03_JPRB, 0.39105977E-03_JPRB, 0.39140892E-03_JPRB, 0.39147350E-03_JPRB, 0.39159832E-03_JPRB, &
  & 0.39176752E-03_JPRB, 0.39186250E-03_JPRB, 0.39178817E-03_JPRB, 0.39161727E-03_JPRB, 0.39152707E-03_JPRB, 0.39132740E-03_JPRB, &
  & 0.39137826E-03_JPRB, 0.39148793E-03_JPRB, 0.39172472E-03_JPRB, 0.39189728E-03_JPRB  /)

RGHG1(:,87,10) = (/ &
  & 0.38574283E-03_JPRB, 0.38573760E-03_JPRB, 0.38583435E-03_JPRB, 0.38582398E-03_JPRB, 0.38581740E-03_JPRB, 0.38580856E-03_JPRB, &
  & 0.38584324E-03_JPRB, 0.38590878E-03_JPRB, 0.38595980E-03_JPRB, 0.38591543E-03_JPRB, 0.38572499E-03_JPRB, 0.38551971E-03_JPRB, &
  & 0.38533121E-03_JPRB, 0.38515565E-03_JPRB, 0.38496500E-03_JPRB, 0.38476546E-03_JPRB, 0.38455891E-03_JPRB, 0.38436543E-03_JPRB, &
  & 0.38422678E-03_JPRB, 0.38412440E-03_JPRB, 0.38407421E-03_JPRB, 0.38407514E-03_JPRB, 0.38415605E-03_JPRB, 0.38421491E-03_JPRB, &
  & 0.38424440E-03_JPRB, 0.38425257E-03_JPRB, 0.38434570E-03_JPRB, 0.38441143E-03_JPRB, 0.38442568E-03_JPRB, 0.38458821E-03_JPRB, &
  & 0.38455795E-03_JPRB, 0.38358959E-03_JPRB, 0.38398344E-03_JPRB, 0.38409468E-03_JPRB, 0.38372198E-03_JPRB, 0.38333136E-03_JPRB, &
  & 0.38355614E-03_JPRB, 0.38368078E-03_JPRB, 0.38360746E-03_JPRB, 0.38376973E-03_JPRB, 0.38414907E-03_JPRB, 0.38474094E-03_JPRB, &
  & 0.38534347E-03_JPRB, 0.38601391E-03_JPRB, 0.38662230E-03_JPRB, 0.38725274E-03_JPRB, 0.38830386E-03_JPRB, 0.38931704E-03_JPRB, &
  & 0.39007514E-03_JPRB, 0.39072115E-03_JPRB, 0.39127219E-03_JPRB, 0.39158259E-03_JPRB, 0.39161095E-03_JPRB, 0.39173029E-03_JPRB, &
  & 0.39191953E-03_JPRB, 0.39202405E-03_JPRB, 0.39194694E-03_JPRB, 0.39170259E-03_JPRB, 0.39155157E-03_JPRB, 0.39133378E-03_JPRB, &
  & 0.39137694E-03_JPRB, 0.39147346E-03_JPRB, 0.39174284E-03_JPRB, 0.39192085E-03_JPRB  /)

RGHG1(:,88,10) = (/ &
  & 0.38574114E-03_JPRB, 0.38574107E-03_JPRB, 0.38583524E-03_JPRB, 0.38582360E-03_JPRB, 0.38581854E-03_JPRB, 0.38581091E-03_JPRB, &
  & 0.38584483E-03_JPRB, 0.38591081E-03_JPRB, 0.38596129E-03_JPRB, 0.38591705E-03_JPRB, 0.38572544E-03_JPRB, 0.38551814E-03_JPRB, &
  & 0.38533038E-03_JPRB, 0.38515245E-03_JPRB, 0.38496002E-03_JPRB, 0.38476450E-03_JPRB, 0.38456053E-03_JPRB, 0.38438309E-03_JPRB, &
  & 0.38428637E-03_JPRB, 0.38418999E-03_JPRB, 0.38415993E-03_JPRB, 0.38415405E-03_JPRB, 0.38424252E-03_JPRB, 0.38430551E-03_JPRB, &
  & 0.38435126E-03_JPRB, 0.38437939E-03_JPRB, 0.38452884E-03_JPRB, 0.38463816E-03_JPRB, 0.38474304E-03_JPRB, 0.38501450E-03_JPRB, &
  & 0.38498306E-03_JPRB, 0.38391989E-03_JPRB, 0.38444935E-03_JPRB, 0.38446154E-03_JPRB, 0.38407225E-03_JPRB, 0.38363013E-03_JPRB, &
  & 0.38376907E-03_JPRB, 0.38385950E-03_JPRB, 0.38385031E-03_JPRB, 0.38400742E-03_JPRB, 0.38445618E-03_JPRB, 0.38502655E-03_JPRB, &
  & 0.38559313E-03_JPRB, 0.38633926E-03_JPRB, 0.38699758E-03_JPRB, 0.38757027E-03_JPRB, 0.38864515E-03_JPRB, 0.38965492E-03_JPRB, &
  & 0.39038455E-03_JPRB, 0.39101244E-03_JPRB, 0.39152575E-03_JPRB, 0.39177369E-03_JPRB, 0.39176296E-03_JPRB, 0.39187234E-03_JPRB, &
  & 0.39207677E-03_JPRB, 0.39218435E-03_JPRB, 0.39211096E-03_JPRB, 0.39179301E-03_JPRB, 0.39157170E-03_JPRB, 0.39133516E-03_JPRB, &
  & 0.39137356E-03_JPRB, 0.39145581E-03_JPRB, 0.39175612E-03_JPRB, 0.39193247E-03_JPRB  /)

RGHG1(:,89,10) = (/ &
  & 0.38574210E-03_JPRB, 0.38574417E-03_JPRB, 0.38583626E-03_JPRB, 0.38582467E-03_JPRB, 0.38582002E-03_JPRB, 0.38581255E-03_JPRB, &
  & 0.38584494E-03_JPRB, 0.38591179E-03_JPRB, 0.38596202E-03_JPRB, 0.38591792E-03_JPRB, 0.38572537E-03_JPRB, 0.38551638E-03_JPRB, &
  & 0.38533017E-03_JPRB, 0.38515081E-03_JPRB, 0.38495563E-03_JPRB, 0.38476615E-03_JPRB, 0.38456310E-03_JPRB, 0.38440583E-03_JPRB, &
  & 0.38436936E-03_JPRB, 0.38426975E-03_JPRB, 0.38426279E-03_JPRB, 0.38424973E-03_JPRB, 0.38434954E-03_JPRB, 0.38441687E-03_JPRB, &
  & 0.38448675E-03_JPRB, 0.38455280E-03_JPRB, 0.38476965E-03_JPRB, 0.38495064E-03_JPRB, 0.38518865E-03_JPRB, 0.38561447E-03_JPRB, &
  & 0.38563641E-03_JPRB, 0.38448873E-03_JPRB, 0.38528744E-03_JPRB, 0.38510953E-03_JPRB, 0.38473580E-03_JPRB, 0.38423077E-03_JPRB, &
  & 0.38412879E-03_JPRB, 0.38412981E-03_JPRB, 0.38429849E-03_JPRB, 0.38450543E-03_JPRB, 0.38507414E-03_JPRB, 0.38557769E-03_JPRB, &
  & 0.38600118E-03_JPRB, 0.38688019E-03_JPRB, 0.38761953E-03_JPRB, 0.38807712E-03_JPRB, 0.38917640E-03_JPRB, 0.39015827E-03_JPRB, &
  & 0.39085383E-03_JPRB, 0.39143227E-03_JPRB, 0.39185240E-03_JPRB, 0.39199754E-03_JPRB, 0.39193896E-03_JPRB, 0.39203138E-03_JPRB, &
  & 0.39224881E-03_JPRB, 0.39234511E-03_JPRB, 0.39228151E-03_JPRB, 0.39188932E-03_JPRB, 0.39158776E-03_JPRB, 0.39133422E-03_JPRB, &
  & 0.39137023E-03_JPRB, 0.39144185E-03_JPRB, 0.39176127E-03_JPRB, 0.39193667E-03_JPRB  /)

RGHG1(:,90,10) = (/ &
  & 0.38574421E-03_JPRB, 0.38574572E-03_JPRB, 0.38583797E-03_JPRB, 0.38582682E-03_JPRB, 0.38582173E-03_JPRB, 0.38581452E-03_JPRB, &
  & 0.38584494E-03_JPRB, 0.38591220E-03_JPRB, 0.38596230E-03_JPRB, 0.38591833E-03_JPRB, 0.38572479E-03_JPRB, 0.38551438E-03_JPRB, &
  & 0.38533127E-03_JPRB, 0.38514975E-03_JPRB, 0.38495203E-03_JPRB, 0.38476903E-03_JPRB, 0.38456308E-03_JPRB, 0.38442863E-03_JPRB, &
  & 0.38446585E-03_JPRB, 0.38438263E-03_JPRB, 0.38439781E-03_JPRB, 0.38438699E-03_JPRB, 0.38450792E-03_JPRB, 0.38457294E-03_JPRB, &
  & 0.38468316E-03_JPRB, 0.38481284E-03_JPRB, 0.38512246E-03_JPRB, 0.38543928E-03_JPRB, 0.38584303E-03_JPRB, 0.38653502E-03_JPRB, &
  & 0.38660868E-03_JPRB, 0.38535960E-03_JPRB, 0.38655918E-03_JPRB, 0.38617427E-03_JPRB, 0.38593014E-03_JPRB, 0.38533970E-03_JPRB, &
  & 0.38471599E-03_JPRB, 0.38448206E-03_JPRB, 0.38497202E-03_JPRB, 0.38549698E-03_JPRB, 0.38610428E-03_JPRB, 0.38664805E-03_JPRB, &
  & 0.38674436E-03_JPRB, 0.38784312E-03_JPRB, 0.38875748E-03_JPRB, 0.38896776E-03_JPRB, 0.39002672E-03_JPRB, 0.39098506E-03_JPRB, &
  & 0.39158940E-03_JPRB, 0.39204588E-03_JPRB, 0.39230386E-03_JPRB, 0.39229172E-03_JPRB, 0.39214642E-03_JPRB, 0.39221882E-03_JPRB, &
  & 0.39245865E-03_JPRB, 0.39252850E-03_JPRB, 0.39246864E-03_JPRB, 0.39199047E-03_JPRB, 0.39160289E-03_JPRB, 0.39133326E-03_JPRB, &
  & 0.39136689E-03_JPRB, 0.39143167E-03_JPRB, 0.39176334E-03_JPRB, 0.39193859E-03_JPRB  /)

RGHG1(:,91,10) = (/ &
  & 0.38574659E-03_JPRB, 0.38574735E-03_JPRB, 0.38584050E-03_JPRB, 0.38583023E-03_JPRB, 0.38582395E-03_JPRB, 0.38581675E-03_JPRB, &
  & 0.38584494E-03_JPRB, 0.38591235E-03_JPRB, 0.38596245E-03_JPRB, 0.38591833E-03_JPRB, 0.38572361E-03_JPRB, 0.38551127E-03_JPRB, &
  & 0.38533171E-03_JPRB, 0.38514634E-03_JPRB, 0.38494580E-03_JPRB, 0.38477007E-03_JPRB, 0.38456264E-03_JPRB, 0.38444942E-03_JPRB, &
  & 0.38458745E-03_JPRB, 0.38461427E-03_JPRB, 0.38462499E-03_JPRB, 0.38462101E-03_JPRB, 0.38482048E-03_JPRB, 0.38483472E-03_JPRB, &
  & 0.38500478E-03_JPRB, 0.38528606E-03_JPRB, 0.38582702E-03_JPRB, 0.38633687E-03_JPRB, 0.38707991E-03_JPRB, 0.38811341E-03_JPRB, &
  & 0.38822479E-03_JPRB, 0.38684505E-03_JPRB, 0.38882090E-03_JPRB, 0.38795669E-03_JPRB, 0.38808124E-03_JPRB, 0.38764538E-03_JPRB, &
  & 0.38583468E-03_JPRB, 0.38495958E-03_JPRB, 0.38580710E-03_JPRB, 0.38701464E-03_JPRB, 0.38773776E-03_JPRB, 0.38797492E-03_JPRB, &
  & 0.38830568E-03_JPRB, 0.38978500E-03_JPRB, 0.39071540E-03_JPRB, 0.39071617E-03_JPRB, 0.39166005E-03_JPRB, 0.39255751E-03_JPRB, &
  & 0.39299659E-03_JPRB, 0.39312804E-03_JPRB, 0.39301421E-03_JPRB, 0.39274534E-03_JPRB, 0.39244384E-03_JPRB, 0.39248030E-03_JPRB, &
  & 0.39277537E-03_JPRB, 0.39278241E-03_JPRB, 0.39269493E-03_JPRB, 0.39210510E-03_JPRB, 0.39162160E-03_JPRB, 0.39133296E-03_JPRB, &
  & 0.39136437E-03_JPRB, 0.39142351E-03_JPRB, 0.39176423E-03_JPRB, 0.39193919E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ---GEMS----

RGHG1(:, 1,11) = (/ &
  & 0.37392450E-03_JPRB, 0.37392381E-03_JPRB, 0.37392276E-03_JPRB, 0.37392109E-03_JPRB, 0.37391898E-03_JPRB, 0.37391637E-03_JPRB, &
  & 0.37391246E-03_JPRB, 0.37390710E-03_JPRB, 0.37390098E-03_JPRB, 0.37389523E-03_JPRB, 0.37389086E-03_JPRB, 0.37388747E-03_JPRB, &
  & 0.37388485E-03_JPRB, 0.37388305E-03_JPRB, 0.37388150E-03_JPRB, 0.37387998E-03_JPRB, 0.37387903E-03_JPRB, 0.37387883E-03_JPRB, &
  & 0.37387933E-03_JPRB, 0.37388010E-03_JPRB, 0.37388083E-03_JPRB, 0.37388160E-03_JPRB, 0.37388279E-03_JPRB, 0.37388475E-03_JPRB, &
  & 0.37388778E-03_JPRB, 0.37389206E-03_JPRB, 0.37389794E-03_JPRB, 0.37390559E-03_JPRB, 0.37391513E-03_JPRB, 0.37392740E-03_JPRB, &
  & 0.37394352E-03_JPRB, 0.37396246E-03_JPRB, 0.37398289E-03_JPRB, 0.37400177E-03_JPRB, 0.37401572E-03_JPRB, 0.37402476E-03_JPRB, &
  & 0.37403086E-03_JPRB, 0.37403521E-03_JPRB, 0.37403825E-03_JPRB, 0.37404009E-03_JPRB, 0.37403844E-03_JPRB, 0.37403281E-03_JPRB, &
  & 0.37402436E-03_JPRB, 0.37401339E-03_JPRB, 0.37400121E-03_JPRB, 0.37398419E-03_JPRB, 0.37395541E-03_JPRB, 0.37391332E-03_JPRB, &
  & 0.37386315E-03_JPRB, 0.37382001E-03_JPRB, 0.37377880E-03_JPRB, 0.37374074E-03_JPRB, 0.37370344E-03_JPRB, 0.37366825E-03_JPRB, &
  & 0.37363373E-03_JPRB, 0.37360269E-03_JPRB, 0.37357194E-03_JPRB, 0.37354237E-03_JPRB, 0.37351479E-03_JPRB, 0.37348957E-03_JPRB, &
  & 0.37347335E-03_JPRB, 0.37345946E-03_JPRB, 0.37343983E-03_JPRB, 0.37343146E-03_JPRB  /)

RGHG1(:, 2,11) = (/ &
  & 0.37392450E-03_JPRB, 0.37392381E-03_JPRB, 0.37392276E-03_JPRB, 0.37392109E-03_JPRB, 0.37391898E-03_JPRB, 0.37391637E-03_JPRB, &
  & 0.37391246E-03_JPRB, 0.37390710E-03_JPRB, 0.37390098E-03_JPRB, 0.37389523E-03_JPRB, 0.37389086E-03_JPRB, 0.37388747E-03_JPRB, &
  & 0.37388485E-03_JPRB, 0.37388305E-03_JPRB, 0.37388150E-03_JPRB, 0.37387998E-03_JPRB, 0.37387903E-03_JPRB, 0.37387883E-03_JPRB, &
  & 0.37387933E-03_JPRB, 0.37388010E-03_JPRB, 0.37388083E-03_JPRB, 0.37388160E-03_JPRB, 0.37388279E-03_JPRB, 0.37388475E-03_JPRB, &
  & 0.37388778E-03_JPRB, 0.37389206E-03_JPRB, 0.37389794E-03_JPRB, 0.37390559E-03_JPRB, 0.37391513E-03_JPRB, 0.37392740E-03_JPRB, &
  & 0.37394352E-03_JPRB, 0.37396246E-03_JPRB, 0.37398289E-03_JPRB, 0.37400177E-03_JPRB, 0.37401572E-03_JPRB, 0.37402476E-03_JPRB, &
  & 0.37403086E-03_JPRB, 0.37403521E-03_JPRB, 0.37403825E-03_JPRB, 0.37404009E-03_JPRB, 0.37403844E-03_JPRB, 0.37403281E-03_JPRB, &
  & 0.37402436E-03_JPRB, 0.37401339E-03_JPRB, 0.37400121E-03_JPRB, 0.37398419E-03_JPRB, 0.37395541E-03_JPRB, 0.37391332E-03_JPRB, &
  & 0.37386315E-03_JPRB, 0.37382001E-03_JPRB, 0.37377880E-03_JPRB, 0.37374074E-03_JPRB, 0.37370344E-03_JPRB, 0.37366825E-03_JPRB, &
  & 0.37363373E-03_JPRB, 0.37360269E-03_JPRB, 0.37357194E-03_JPRB, 0.37354237E-03_JPRB, 0.37351479E-03_JPRB, 0.37348957E-03_JPRB, &
  & 0.37347335E-03_JPRB, 0.37345946E-03_JPRB, 0.37343983E-03_JPRB, 0.37343146E-03_JPRB  /)

RGHG1(:, 3,11) = (/ &
  & 0.37392450E-03_JPRB, 0.37392381E-03_JPRB, 0.37392276E-03_JPRB, 0.37392109E-03_JPRB, 0.37391898E-03_JPRB, 0.37391637E-03_JPRB, &
  & 0.37391246E-03_JPRB, 0.37390710E-03_JPRB, 0.37390098E-03_JPRB, 0.37389523E-03_JPRB, 0.37389086E-03_JPRB, 0.37388747E-03_JPRB, &
  & 0.37388485E-03_JPRB, 0.37388305E-03_JPRB, 0.37388150E-03_JPRB, 0.37387998E-03_JPRB, 0.37387903E-03_JPRB, 0.37387883E-03_JPRB, &
  & 0.37387933E-03_JPRB, 0.37388010E-03_JPRB, 0.37388083E-03_JPRB, 0.37388160E-03_JPRB, 0.37388279E-03_JPRB, 0.37388475E-03_JPRB, &
  & 0.37388778E-03_JPRB, 0.37389206E-03_JPRB, 0.37389794E-03_JPRB, 0.37390559E-03_JPRB, 0.37391513E-03_JPRB, 0.37392740E-03_JPRB, &
  & 0.37394352E-03_JPRB, 0.37396246E-03_JPRB, 0.37398289E-03_JPRB, 0.37400177E-03_JPRB, 0.37401572E-03_JPRB, 0.37402476E-03_JPRB, &
  & 0.37403086E-03_JPRB, 0.37403521E-03_JPRB, 0.37403825E-03_JPRB, 0.37404009E-03_JPRB, 0.37403844E-03_JPRB, 0.37403281E-03_JPRB, &
  & 0.37402436E-03_JPRB, 0.37401339E-03_JPRB, 0.37400121E-03_JPRB, 0.37398419E-03_JPRB, 0.37395541E-03_JPRB, 0.37391332E-03_JPRB, &
  & 0.37386315E-03_JPRB, 0.37382001E-03_JPRB, 0.37377880E-03_JPRB, 0.37374074E-03_JPRB, 0.37370344E-03_JPRB, 0.37366825E-03_JPRB, &
  & 0.37363373E-03_JPRB, 0.37360269E-03_JPRB, 0.37357194E-03_JPRB, 0.37354237E-03_JPRB, 0.37351479E-03_JPRB, 0.37348957E-03_JPRB, &
  & 0.37347335E-03_JPRB, 0.37345946E-03_JPRB, 0.37343983E-03_JPRB, 0.37343146E-03_JPRB  /)

RGHG1(:, 4,11) = (/ &
  & 0.37392453E-03_JPRB, 0.37392384E-03_JPRB, 0.37392278E-03_JPRB, 0.37392112E-03_JPRB, 0.37391901E-03_JPRB, 0.37391639E-03_JPRB, &
  & 0.37391247E-03_JPRB, 0.37390710E-03_JPRB, 0.37390098E-03_JPRB, 0.37389523E-03_JPRB, 0.37389087E-03_JPRB, 0.37388749E-03_JPRB, &
  & 0.37388487E-03_JPRB, 0.37388307E-03_JPRB, 0.37388152E-03_JPRB, 0.37388000E-03_JPRB, 0.37387905E-03_JPRB, 0.37387885E-03_JPRB, &
  & 0.37387936E-03_JPRB, 0.37388013E-03_JPRB, 0.37388087E-03_JPRB, 0.37388165E-03_JPRB, 0.37388286E-03_JPRB, 0.37388484E-03_JPRB, &
  & 0.37388790E-03_JPRB, 0.37389224E-03_JPRB, 0.37389820E-03_JPRB, 0.37390594E-03_JPRB, 0.37391558E-03_JPRB, 0.37392793E-03_JPRB, &
  & 0.37394412E-03_JPRB, 0.37396313E-03_JPRB, 0.37398359E-03_JPRB, 0.37400244E-03_JPRB, 0.37401629E-03_JPRB, 0.37402524E-03_JPRB, &
  & 0.37403127E-03_JPRB, 0.37403554E-03_JPRB, 0.37403851E-03_JPRB, 0.37404026E-03_JPRB, 0.37403851E-03_JPRB, 0.37403277E-03_JPRB, &
  & 0.37402423E-03_JPRB, 0.37401321E-03_JPRB, 0.37400095E-03_JPRB, 0.37398385E-03_JPRB, 0.37395500E-03_JPRB, 0.37391286E-03_JPRB, &
  & 0.37386266E-03_JPRB, 0.37381949E-03_JPRB, 0.37377828E-03_JPRB, 0.37374022E-03_JPRB, 0.37370295E-03_JPRB, 0.37366780E-03_JPRB, &
  & 0.37363330E-03_JPRB, 0.37360225E-03_JPRB, 0.37357148E-03_JPRB, 0.37354189E-03_JPRB, 0.37351427E-03_JPRB, 0.37348899E-03_JPRB, &
  & 0.37347265E-03_JPRB, 0.37345874E-03_JPRB, 0.37343921E-03_JPRB, 0.37343079E-03_JPRB  /)

RGHG1(:, 5,11) = (/ &
  & 0.37392578E-03_JPRB, 0.37392510E-03_JPRB, 0.37392411E-03_JPRB, 0.37392252E-03_JPRB, 0.37392025E-03_JPRB, 0.37391727E-03_JPRB, &
  & 0.37391283E-03_JPRB, 0.37390708E-03_JPRB, 0.37390086E-03_JPRB, 0.37389538E-03_JPRB, 0.37389126E-03_JPRB, 0.37388813E-03_JPRB, &
  & 0.37388571E-03_JPRB, 0.37388395E-03_JPRB, 0.37388239E-03_JPRB, 0.37388097E-03_JPRB, 0.37388025E-03_JPRB, 0.37388017E-03_JPRB, &
  & 0.37388073E-03_JPRB, 0.37388172E-03_JPRB, 0.37388276E-03_JPRB, 0.37388401E-03_JPRB, 0.37388597E-03_JPRB, 0.37388902E-03_JPRB, &
  & 0.37389376E-03_JPRB, 0.37390087E-03_JPRB, 0.37391069E-03_JPRB, 0.37392277E-03_JPRB, 0.37393665E-03_JPRB, 0.37395310E-03_JPRB, &
  & 0.37397294E-03_JPRB, 0.37399483E-03_JPRB, 0.37401679E-03_JPRB, 0.37403404E-03_JPRB, 0.37404348E-03_JPRB, 0.37404808E-03_JPRB, &
  & 0.37405055E-03_JPRB, 0.37405120E-03_JPRB, 0.37405053E-03_JPRB, 0.37404831E-03_JPRB, 0.37404181E-03_JPRB, 0.37403080E-03_JPRB, &
  & 0.37401812E-03_JPRB, 0.37400432E-03_JPRB, 0.37398875E-03_JPRB, 0.37396759E-03_JPRB, 0.37393566E-03_JPRB, 0.37389057E-03_JPRB, &
  & 0.37383934E-03_JPRB, 0.37379479E-03_JPRB, 0.37375340E-03_JPRB, 0.37371556E-03_JPRB, 0.37367979E-03_JPRB, 0.37364627E-03_JPRB, &
  & 0.37361288E-03_JPRB, 0.37358143E-03_JPRB, 0.37354967E-03_JPRB, 0.37351896E-03_JPRB, 0.37348948E-03_JPRB, 0.37346165E-03_JPRB, &
  & 0.37343972E-03_JPRB, 0.37342463E-03_JPRB, 0.37340967E-03_JPRB, 0.37339885E-03_JPRB  /)

RGHG1(:, 6,11) = (/ &
  & 0.37392765E-03_JPRB, 0.37392700E-03_JPRB, 0.37392611E-03_JPRB, 0.37392462E-03_JPRB, 0.37392210E-03_JPRB, 0.37391860E-03_JPRB, &
  & 0.37391337E-03_JPRB, 0.37390704E-03_JPRB, 0.37390068E-03_JPRB, 0.37389561E-03_JPRB, 0.37389184E-03_JPRB, 0.37388908E-03_JPRB, &
  & 0.37388697E-03_JPRB, 0.37388528E-03_JPRB, 0.37388369E-03_JPRB, 0.37388243E-03_JPRB, 0.37388205E-03_JPRB, 0.37388216E-03_JPRB, &
  & 0.37388278E-03_JPRB, 0.37388409E-03_JPRB, 0.37388559E-03_JPRB, 0.37388756E-03_JPRB, 0.37389063E-03_JPRB, 0.37389528E-03_JPRB, &
  & 0.37390256E-03_JPRB, 0.37391383E-03_JPRB, 0.37392942E-03_JPRB, 0.37394802E-03_JPRB, 0.37396828E-03_JPRB, 0.37399086E-03_JPRB, &
  & 0.37401619E-03_JPRB, 0.37404239E-03_JPRB, 0.37406661E-03_JPRB, 0.37408146E-03_JPRB, 0.37408428E-03_JPRB, 0.37408234E-03_JPRB, &
  & 0.37407947E-03_JPRB, 0.37407471E-03_JPRB, 0.37406857E-03_JPRB, 0.37406038E-03_JPRB, 0.37404675E-03_JPRB, 0.37402784E-03_JPRB, &
  & 0.37400896E-03_JPRB, 0.37399097E-03_JPRB, 0.37397046E-03_JPRB, 0.37394319E-03_JPRB, 0.37390665E-03_JPRB, 0.37385712E-03_JPRB, &
  & 0.37380434E-03_JPRB, 0.37375774E-03_JPRB, 0.37371607E-03_JPRB, 0.37367855E-03_JPRB, 0.37364505E-03_JPRB, 0.37361398E-03_JPRB, &
  & 0.37358224E-03_JPRB, 0.37355019E-03_JPRB, 0.37351695E-03_JPRB, 0.37348456E-03_JPRB, 0.37345230E-03_JPRB, 0.37342062E-03_JPRB, &
  & 0.37339030E-03_JPRB, 0.37337344E-03_JPRB, 0.37336534E-03_JPRB, 0.37335092E-03_JPRB  /)

RGHG1(:, 7,11) = (/ &
  & 0.37394102E-03_JPRB, 0.37394122E-03_JPRB, 0.37394092E-03_JPRB, 0.37393959E-03_JPRB, 0.37393696E-03_JPRB, 0.37393271E-03_JPRB, &
  & 0.37392658E-03_JPRB, 0.37391990E-03_JPRB, 0.37391430E-03_JPRB, 0.37391023E-03_JPRB, 0.37390699E-03_JPRB, 0.37390428E-03_JPRB, &
  & 0.37390207E-03_JPRB, 0.37390001E-03_JPRB, 0.37389810E-03_JPRB, 0.37389666E-03_JPRB, 0.37389602E-03_JPRB, 0.37389649E-03_JPRB, &
  & 0.37389803E-03_JPRB, 0.37390097E-03_JPRB, 0.37390473E-03_JPRB, 0.37390942E-03_JPRB, 0.37391535E-03_JPRB, 0.37392390E-03_JPRB, &
  & 0.37393685E-03_JPRB, 0.37395696E-03_JPRB, 0.37398433E-03_JPRB, 0.37401401E-03_JPRB, 0.37404399E-03_JPRB, 0.37407515E-03_JPRB, &
  & 0.37410757E-03_JPRB, 0.37413931E-03_JPRB, 0.37416414E-03_JPRB, 0.37417290E-03_JPRB, 0.37416418E-03_JPRB, 0.37414801E-03_JPRB, &
  & 0.37412987E-03_JPRB, 0.37410926E-03_JPRB, 0.37408806E-03_JPRB, 0.37406563E-03_JPRB, 0.37404002E-03_JPRB, 0.37401374E-03_JPRB, &
  & 0.37399034E-03_JPRB, 0.37396675E-03_JPRB, 0.37393805E-03_JPRB, 0.37390060E-03_JPRB, 0.37385553E-03_JPRB, 0.37380002E-03_JPRB, &
  & 0.37374385E-03_JPRB, 0.37369415E-03_JPRB, 0.37365121E-03_JPRB, 0.37361556E-03_JPRB, 0.37358247E-03_JPRB, 0.37355052E-03_JPRB, &
  & 0.37351774E-03_JPRB, 0.37348172E-03_JPRB, 0.37344452E-03_JPRB, 0.37340762E-03_JPRB, 0.37336868E-03_JPRB, 0.37332818E-03_JPRB, &
  & 0.37329264E-03_JPRB, 0.37326825E-03_JPRB, 0.37325336E-03_JPRB, 0.37324132E-03_JPRB  /)

RGHG1(:, 8,11) = (/ &
  & 0.37397201E-03_JPRB, 0.37397241E-03_JPRB, 0.37397241E-03_JPRB, 0.37397187E-03_JPRB, 0.37396979E-03_JPRB, 0.37396530E-03_JPRB, &
  & 0.37395874E-03_JPRB, 0.37395220E-03_JPRB, 0.37394764E-03_JPRB, 0.37394465E-03_JPRB, 0.37394213E-03_JPRB, 0.37393946E-03_JPRB, &
  & 0.37393672E-03_JPRB, 0.37393412E-03_JPRB, 0.37393151E-03_JPRB, 0.37392953E-03_JPRB, 0.37392863E-03_JPRB, 0.37393014E-03_JPRB, &
  & 0.37393442E-03_JPRB, 0.37394181E-03_JPRB, 0.37395122E-03_JPRB, 0.37396200E-03_JPRB, 0.37397399E-03_JPRB, 0.37399002E-03_JPRB, &
  & 0.37401271E-03_JPRB, 0.37404613E-03_JPRB, 0.37409002E-03_JPRB, 0.37413259E-03_JPRB, 0.37417040E-03_JPRB, 0.37420805E-03_JPRB, &
  & 0.37424596E-03_JPRB, 0.37428381E-03_JPRB, 0.37431092E-03_JPRB, 0.37431472E-03_JPRB, 0.37429263E-03_JPRB, 0.37425265E-03_JPRB, &
  & 0.37420459E-03_JPRB, 0.37415889E-03_JPRB, 0.37411861E-03_JPRB, 0.37408089E-03_JPRB, 0.37404591E-03_JPRB, 0.37401570E-03_JPRB, &
  & 0.37399050E-03_JPRB, 0.37396356E-03_JPRB, 0.37392692E-03_JPRB, 0.37387751E-03_JPRB, 0.37382238E-03_JPRB, 0.37375707E-03_JPRB, &
  & 0.37368930E-03_JPRB, 0.37362835E-03_JPRB, 0.37357824E-03_JPRB, 0.37353848E-03_JPRB, 0.37349957E-03_JPRB, 0.37346170E-03_JPRB, &
  & 0.37342370E-03_JPRB, 0.37338266E-03_JPRB, 0.37333799E-03_JPRB, 0.37329155E-03_JPRB, 0.37324328E-03_JPRB, 0.37319164E-03_JPRB, &
  & 0.37314728E-03_JPRB, 0.37311161E-03_JPRB, 0.37308357E-03_JPRB, 0.37307166E-03_JPRB  /)

RGHG1(:, 9,11) = (/ &
  & 0.37401744E-03_JPRB, 0.37401760E-03_JPRB, 0.37401692E-03_JPRB, 0.37401579E-03_JPRB, 0.37401328E-03_JPRB, 0.37400873E-03_JPRB, &
  & 0.37400252E-03_JPRB, 0.37399673E-03_JPRB, 0.37399313E-03_JPRB, 0.37399065E-03_JPRB, 0.37398872E-03_JPRB, 0.37398628E-03_JPRB, &
  & 0.37398294E-03_JPRB, 0.37398023E-03_JPRB, 0.37397702E-03_JPRB, 0.37397460E-03_JPRB, 0.37397478E-03_JPRB, 0.37397977E-03_JPRB, &
  & 0.37399081E-03_JPRB, 0.37400803E-03_JPRB, 0.37403007E-03_JPRB, 0.37405407E-03_JPRB, 0.37407826E-03_JPRB, 0.37410809E-03_JPRB, &
  & 0.37414876E-03_JPRB, 0.37420431E-03_JPRB, 0.37426984E-03_JPRB, 0.37432487E-03_JPRB, 0.37436481E-03_JPRB, 0.37440101E-03_JPRB, &
  & 0.37443636E-03_JPRB, 0.37447429E-03_JPRB, 0.37450431E-03_JPRB, 0.37451033E-03_JPRB, 0.37447977E-03_JPRB, 0.37441102E-03_JPRB, &
  & 0.37432581E-03_JPRB, 0.37425216E-03_JPRB, 0.37419701E-03_JPRB, 0.37415218E-03_JPRB, 0.37411829E-03_JPRB, 0.37409380E-03_JPRB, &
  & 0.37407320E-03_JPRB, 0.37404651E-03_JPRB, 0.37400133E-03_JPRB, 0.37393610E-03_JPRB, 0.37386467E-03_JPRB, 0.37377939E-03_JPRB, &
  & 0.37368444E-03_JPRB, 0.37359595E-03_JPRB, 0.37352397E-03_JPRB, 0.37346627E-03_JPRB, 0.37341010E-03_JPRB, 0.37335811E-03_JPRB, &
  & 0.37330855E-03_JPRB, 0.37325785E-03_JPRB, 0.37319940E-03_JPRB, 0.37313774E-03_JPRB, 0.37307656E-03_JPRB, 0.37301059E-03_JPRB, &
  & 0.37294890E-03_JPRB, 0.37289629E-03_JPRB, 0.37285109E-03_JPRB, 0.37283221E-03_JPRB  /)

RGHG1(:,10,11) = (/ &
  & 0.37405385E-03_JPRB, 0.37405306E-03_JPRB, 0.37404898E-03_JPRB, 0.37404293E-03_JPRB, 0.37403662E-03_JPRB, 0.37403039E-03_JPRB, &
  & 0.37402424E-03_JPRB, 0.37401927E-03_JPRB, 0.37401658E-03_JPRB, 0.37401366E-03_JPRB, 0.37401131E-03_JPRB, 0.37400919E-03_JPRB, &
  & 0.37400615E-03_JPRB, 0.37400457E-03_JPRB, 0.37400279E-03_JPRB, 0.37400230E-03_JPRB, 0.37400682E-03_JPRB, 0.37401958E-03_JPRB, &
  & 0.37404343E-03_JPRB, 0.37407794E-03_JPRB, 0.37412274E-03_JPRB, 0.37417163E-03_JPRB, 0.37422035E-03_JPRB, 0.37427781E-03_JPRB, &
  & 0.37435274E-03_JPRB, 0.37444553E-03_JPRB, 0.37453694E-03_JPRB, 0.37460142E-03_JPRB, 0.37463746E-03_JPRB, 0.37466060E-03_JPRB, &
  & 0.37468003E-03_JPRB, 0.37470227E-03_JPRB, 0.37472725E-03_JPRB, 0.37473979E-03_JPRB, 0.37471207E-03_JPRB, 0.37463065E-03_JPRB, &
  & 0.37452890E-03_JPRB, 0.37444382E-03_JPRB, 0.37439123E-03_JPRB, 0.37435965E-03_JPRB, 0.37434560E-03_JPRB, 0.37434193E-03_JPRB, &
  & 0.37433388E-03_JPRB, 0.37430669E-03_JPRB, 0.37424594E-03_JPRB, 0.37415315E-03_JPRB, 0.37404663E-03_JPRB, 0.37392132E-03_JPRB, &
  & 0.37377547E-03_JPRB, 0.37363598E-03_JPRB, 0.37351741E-03_JPRB, 0.37342072E-03_JPRB, 0.37333115E-03_JPRB, 0.37325150E-03_JPRB, &
  & 0.37318218E-03_JPRB, 0.37311034E-03_JPRB, 0.37302930E-03_JPRB, 0.37294787E-03_JPRB, 0.37286712E-03_JPRB, 0.37278314E-03_JPRB, &
  & 0.37269734E-03_JPRB, 0.37261947E-03_JPRB, 0.37255326E-03_JPRB, 0.37251870E-03_JPRB  /)

RGHG1(:,11,11) = (/ &
  & 0.37405634E-03_JPRB, 0.37405066E-03_JPRB, 0.37403939E-03_JPRB, 0.37402753E-03_JPRB, 0.37401789E-03_JPRB, 0.37401004E-03_JPRB, &
  & 0.37400408E-03_JPRB, 0.37400142E-03_JPRB, 0.37400159E-03_JPRB, 0.37399867E-03_JPRB, 0.37399603E-03_JPRB, 0.37399656E-03_JPRB, &
  & 0.37399769E-03_JPRB, 0.37399861E-03_JPRB, 0.37400120E-03_JPRB, 0.37400655E-03_JPRB, 0.37401653E-03_JPRB, 0.37403667E-03_JPRB, &
  & 0.37407525E-03_JPRB, 0.37413137E-03_JPRB, 0.37420618E-03_JPRB, 0.37429409E-03_JPRB, 0.37439408E-03_JPRB, 0.37451025E-03_JPRB, &
  & 0.37464136E-03_JPRB, 0.37478125E-03_JPRB, 0.37489635E-03_JPRB, 0.37496296E-03_JPRB, 0.37498688E-03_JPRB, 0.37498569E-03_JPRB, &
  & 0.37497818E-03_JPRB, 0.37497137E-03_JPRB, 0.37497510E-03_JPRB, 0.37498032E-03_JPRB, 0.37495985E-03_JPRB, 0.37489844E-03_JPRB, &
  & 0.37482179E-03_JPRB, 0.37476142E-03_JPRB, 0.37473568E-03_JPRB, 0.37474139E-03_JPRB, 0.37476295E-03_JPRB, 0.37478655E-03_JPRB, &
  & 0.37479120E-03_JPRB, 0.37475753E-03_JPRB, 0.37467181E-03_JPRB, 0.37453820E-03_JPRB, 0.37437070E-03_JPRB, 0.37417853E-03_JPRB, &
  & 0.37395404E-03_JPRB, 0.37374020E-03_JPRB, 0.37354805E-03_JPRB, 0.37338883E-03_JPRB, 0.37324699E-03_JPRB, 0.37312243E-03_JPRB, &
  & 0.37301821E-03_JPRB, 0.37291422E-03_JPRB, 0.37280393E-03_JPRB, 0.37269672E-03_JPRB, 0.37258879E-03_JPRB, 0.37248450E-03_JPRB, &
  & 0.37238008E-03_JPRB, 0.37227282E-03_JPRB, 0.37218232E-03_JPRB, 0.37212942E-03_JPRB  /)

RGHG1(:,12,11) = (/ &
  & 0.37403342E-03_JPRB, 0.37402286E-03_JPRB, 0.37400931E-03_JPRB, 0.37399915E-03_JPRB, 0.37399443E-03_JPRB, 0.37399253E-03_JPRB, &
  & 0.37399404E-03_JPRB, 0.37400155E-03_JPRB, 0.37401225E-03_JPRB, 0.37401649E-03_JPRB, 0.37402083E-03_JPRB, 0.37403528E-03_JPRB, &
  & 0.37405275E-03_JPRB, 0.37406263E-03_JPRB, 0.37406974E-03_JPRB, 0.37407579E-03_JPRB, 0.37408380E-03_JPRB, 0.37410170E-03_JPRB, &
  & 0.37414544E-03_JPRB, 0.37421923E-03_JPRB, 0.37432277E-03_JPRB, 0.37446077E-03_JPRB, 0.37464763E-03_JPRB, 0.37486289E-03_JPRB, &
  & 0.37507167E-03_JPRB, 0.37525484E-03_JPRB, 0.37538917E-03_JPRB, 0.37545104E-03_JPRB, 0.37544889E-03_JPRB, 0.37540682E-03_JPRB, &
  & 0.37535674E-03_JPRB, 0.37531368E-03_JPRB, 0.37528617E-03_JPRB, 0.37527324E-03_JPRB, 0.37526011E-03_JPRB, 0.37523846E-03_JPRB, &
  & 0.37522131E-03_JPRB, 0.37521845E-03_JPRB, 0.37523493E-03_JPRB, 0.37528002E-03_JPRB, 0.37532880E-03_JPRB, 0.37536324E-03_JPRB, &
  & 0.37536925E-03_JPRB, 0.37532434E-03_JPRB, 0.37521277E-03_JPRB, 0.37503581E-03_JPRB, 0.37478874E-03_JPRB, 0.37450542E-03_JPRB, &
  & 0.37418319E-03_JPRB, 0.37387725E-03_JPRB, 0.37358997E-03_JPRB, 0.37335039E-03_JPRB, 0.37314467E-03_JPRB, 0.37296199E-03_JPRB, &
  & 0.37279910E-03_JPRB, 0.37265212E-03_JPRB, 0.37251280E-03_JPRB, 0.37237392E-03_JPRB, 0.37223568E-03_JPRB, 0.37210688E-03_JPRB, &
  & 0.37198811E-03_JPRB, 0.37186464E-03_JPRB, 0.37176469E-03_JPRB, 0.37170589E-03_JPRB  /)

RGHG1(:,13,11) = (/ &
  & 0.37406995E-03_JPRB, 0.37406584E-03_JPRB, 0.37406572E-03_JPRB, 0.37407487E-03_JPRB, 0.37408447E-03_JPRB, 0.37409461E-03_JPRB, &
  & 0.37411126E-03_JPRB, 0.37413804E-03_JPRB, 0.37417230E-03_JPRB, 0.37419948E-03_JPRB, 0.37422357E-03_JPRB, 0.37426505E-03_JPRB, &
  & 0.37430950E-03_JPRB, 0.37434030E-03_JPRB, 0.37435429E-03_JPRB, 0.37435464E-03_JPRB, 0.37435408E-03_JPRB, 0.37436092E-03_JPRB, &
  & 0.37439421E-03_JPRB, 0.37447000E-03_JPRB, 0.37458999E-03_JPRB, 0.37476132E-03_JPRB, 0.37502370E-03_JPRB, 0.37534102E-03_JPRB, &
  & 0.37564980E-03_JPRB, 0.37588994E-03_JPRB, 0.37605361E-03_JPRB, 0.37612454E-03_JPRB, 0.37610021E-03_JPRB, 0.37601657E-03_JPRB, &
  & 0.37591778E-03_JPRB, 0.37583422E-03_JPRB, 0.37578046E-03_JPRB, 0.37575578E-03_JPRB, 0.37576150E-03_JPRB, 0.37579875E-03_JPRB, &
  & 0.37586129E-03_JPRB, 0.37591780E-03_JPRB, 0.37595449E-03_JPRB, 0.37599130E-03_JPRB, 0.37602678E-03_JPRB, 0.37604160E-03_JPRB, &
  & 0.37602243E-03_JPRB, 0.37595340E-03_JPRB, 0.37581395E-03_JPRB, 0.37559412E-03_JPRB, 0.37526631E-03_JPRB, 0.37488067E-03_JPRB, &
  & 0.37446055E-03_JPRB, 0.37406365E-03_JPRB, 0.37368665E-03_JPRB, 0.37336754E-03_JPRB, 0.37309957E-03_JPRB, 0.37284510E-03_JPRB, &
  & 0.37261330E-03_JPRB, 0.37241739E-03_JPRB, 0.37225236E-03_JPRB, 0.37208587E-03_JPRB, 0.37192382E-03_JPRB, 0.37178156E-03_JPRB, &
  & 0.37165636E-03_JPRB, 0.37154427E-03_JPRB, 0.37145695E-03_JPRB, 0.37140757E-03_JPRB  /)

RGHG1(:,14,11) = (/ &
  & 0.37424643E-03_JPRB, 0.37425786E-03_JPRB, 0.37428223E-03_JPRB, 0.37431711E-03_JPRB, 0.37434136E-03_JPRB, 0.37436028E-03_JPRB, &
  & 0.37439182E-03_JPRB, 0.37444371E-03_JPRB, 0.37450753E-03_JPRB, 0.37456435E-03_JPRB, 0.37461452E-03_JPRB, 0.37467661E-03_JPRB, &
  & 0.37474294E-03_JPRB, 0.37479600E-03_JPRB, 0.37482586E-03_JPRB, 0.37482850E-03_JPRB, 0.37482552E-03_JPRB, 0.37481911E-03_JPRB, &
  & 0.37482957E-03_JPRB, 0.37487994E-03_JPRB, 0.37498410E-03_JPRB, 0.37514503E-03_JPRB, 0.37541458E-03_JPRB, 0.37579041E-03_JPRB, &
  & 0.37619971E-03_JPRB, 0.37653210E-03_JPRB, 0.37676127E-03_JPRB, 0.37687383E-03_JPRB, 0.37686832E-03_JPRB, 0.37679257E-03_JPRB, &
  & 0.37669086E-03_JPRB, 0.37660152E-03_JPRB, 0.37654679E-03_JPRB, 0.37653702E-03_JPRB, 0.37657988E-03_JPRB, 0.37667821E-03_JPRB, &
  & 0.37680266E-03_JPRB, 0.37688083E-03_JPRB, 0.37687507E-03_JPRB, 0.37681821E-03_JPRB, 0.37676962E-03_JPRB, 0.37672534E-03_JPRB, &
  & 0.37665714E-03_JPRB, 0.37654012E-03_JPRB, 0.37636572E-03_JPRB, 0.37610329E-03_JPRB, 0.37571067E-03_JPRB, 0.37523734E-03_JPRB, &
  & 0.37475049E-03_JPRB, 0.37430057E-03_JPRB, 0.37387274E-03_JPRB, 0.37349592E-03_JPRB, 0.37316454E-03_JPRB, 0.37285033E-03_JPRB, &
  & 0.37256414E-03_JPRB, 0.37233007E-03_JPRB, 0.37214218E-03_JPRB, 0.37195968E-03_JPRB, 0.37179100E-03_JPRB, 0.37165644E-03_JPRB, &
  & 0.37154240E-03_JPRB, 0.37145013E-03_JPRB, 0.37138651E-03_JPRB, 0.37135102E-03_JPRB  /)

RGHG1(:,15,11) = (/ &
  & 0.37453153E-03_JPRB, 0.37454351E-03_JPRB, 0.37458485E-03_JPRB, 0.37463007E-03_JPRB, 0.37467479E-03_JPRB, 0.37471225E-03_JPRB, &
  & 0.37475822E-03_JPRB, 0.37482645E-03_JPRB, 0.37490250E-03_JPRB, 0.37497001E-03_JPRB, 0.37503724E-03_JPRB, 0.37510330E-03_JPRB, &
  & 0.37516922E-03_JPRB, 0.37523029E-03_JPRB, 0.37526993E-03_JPRB, 0.37527754E-03_JPRB, 0.37526974E-03_JPRB, 0.37525570E-03_JPRB, &
  & 0.37524400E-03_JPRB, 0.37525990E-03_JPRB, 0.37531425E-03_JPRB, 0.37543025E-03_JPRB, 0.37566864E-03_JPRB, 0.37607456E-03_JPRB, &
  & 0.37654962E-03_JPRB, 0.37698655E-03_JPRB, 0.37731089E-03_JPRB, 0.37749771E-03_JPRB, 0.37756754E-03_JPRB, 0.37757478E-03_JPRB, &
  & 0.37755615E-03_JPRB, 0.37753460E-03_JPRB, 0.37751222E-03_JPRB, 0.37753182E-03_JPRB, 0.37760302E-03_JPRB, 0.37771008E-03_JPRB, &
  & 0.37781483E-03_JPRB, 0.37784361E-03_JPRB, 0.37774299E-03_JPRB, 0.37753205E-03_JPRB, 0.37735398E-03_JPRB, 0.37723085E-03_JPRB, &
  & 0.37711107E-03_JPRB, 0.37694780E-03_JPRB, 0.37672979E-03_JPRB, 0.37642275E-03_JPRB, 0.37598677E-03_JPRB, 0.37546989E-03_JPRB, &
  & 0.37497030E-03_JPRB, 0.37451761E-03_JPRB, 0.37408524E-03_JPRB, 0.37369508E-03_JPRB, 0.37331768E-03_JPRB, 0.37296937E-03_JPRB, &
  & 0.37265706E-03_JPRB, 0.37240610E-03_JPRB, 0.37221169E-03_JPRB, 0.37202596E-03_JPRB, 0.37187055E-03_JPRB, 0.37176278E-03_JPRB, &
  & 0.37167558E-03_JPRB, 0.37160438E-03_JPRB, 0.37155993E-03_JPRB, 0.37153515E-03_JPRB  /)

RGHG1(:,16,11) = (/ &
  & 0.37478770E-03_JPRB, 0.37480707E-03_JPRB, 0.37485671E-03_JPRB, 0.37490254E-03_JPRB, 0.37497107E-03_JPRB, 0.37503282E-03_JPRB, &
  & 0.37507862E-03_JPRB, 0.37514032E-03_JPRB, 0.37520767E-03_JPRB, 0.37526207E-03_JPRB, 0.37531723E-03_JPRB, 0.37537118E-03_JPRB, &
  & 0.37542395E-03_JPRB, 0.37546825E-03_JPRB, 0.37549956E-03_JPRB, 0.37550332E-03_JPRB, 0.37549293E-03_JPRB, 0.37547134E-03_JPRB, &
  & 0.37544236E-03_JPRB, 0.37544168E-03_JPRB, 0.37545413E-03_JPRB, 0.37552146E-03_JPRB, 0.37572455E-03_JPRB, 0.37614735E-03_JPRB, &
  & 0.37667817E-03_JPRB, 0.37719430E-03_JPRB, 0.37759131E-03_JPRB, 0.37785915E-03_JPRB, 0.37804696E-03_JPRB, 0.37820946E-03_JPRB, &
  & 0.37836408E-03_JPRB, 0.37848008E-03_JPRB, 0.37851875E-03_JPRB, 0.37854777E-03_JPRB, 0.37857270E-03_JPRB, 0.37858939E-03_JPRB, &
  & 0.37859394E-03_JPRB, 0.37852395E-03_JPRB, 0.37832319E-03_JPRB, 0.37796859E-03_JPRB, 0.37766402E-03_JPRB, 0.37747185E-03_JPRB, &
  & 0.37731548E-03_JPRB, 0.37712410E-03_JPRB, 0.37687492E-03_JPRB, 0.37652970E-03_JPRB, 0.37606790E-03_JPRB, 0.37554268E-03_JPRB, &
  & 0.37506218E-03_JPRB, 0.37462807E-03_JPRB, 0.37423483E-03_JPRB, 0.37387354E-03_JPRB, 0.37349934E-03_JPRB, 0.37314734E-03_JPRB, &
  & 0.37284195E-03_JPRB, 0.37259988E-03_JPRB, 0.37242175E-03_JPRB, 0.37226599E-03_JPRB, 0.37214662E-03_JPRB, 0.37207361E-03_JPRB, &
  & 0.37201761E-03_JPRB, 0.37198043E-03_JPRB, 0.37195962E-03_JPRB, 0.37193827E-03_JPRB  /)

RGHG1(:,17,11) = (/ &
  & 0.37498969E-03_JPRB, 0.37502107E-03_JPRB, 0.37506378E-03_JPRB, 0.37510298E-03_JPRB, 0.37517171E-03_JPRB, 0.37523827E-03_JPRB, &
  & 0.37527233E-03_JPRB, 0.37531296E-03_JPRB, 0.37535736E-03_JPRB, 0.37539597E-03_JPRB, 0.37543399E-03_JPRB, 0.37546798E-03_JPRB, &
  & 0.37550439E-03_JPRB, 0.37552503E-03_JPRB, 0.37553976E-03_JPRB, 0.37553693E-03_JPRB, 0.37552218E-03_JPRB, 0.37549606E-03_JPRB, &
  & 0.37545899E-03_JPRB, 0.37544705E-03_JPRB, 0.37545017E-03_JPRB, 0.37548261E-03_JPRB, 0.37564391E-03_JPRB, 0.37606056E-03_JPRB, &
  & 0.37662266E-03_JPRB, 0.37717969E-03_JPRB, 0.37763082E-03_JPRB, 0.37796961E-03_JPRB, 0.37826897E-03_JPRB, 0.37859342E-03_JPRB, &
  & 0.37895539E-03_JPRB, 0.37925574E-03_JPRB, 0.37940803E-03_JPRB, 0.37942910E-03_JPRB, 0.37933807E-03_JPRB, 0.37919682E-03_JPRB, &
  & 0.37906940E-03_JPRB, 0.37889544E-03_JPRB, 0.37859770E-03_JPRB, 0.37814587E-03_JPRB, 0.37773876E-03_JPRB, 0.37749182E-03_JPRB, &
  & 0.37731418E-03_JPRB, 0.37711920E-03_JPRB, 0.37687047E-03_JPRB, 0.37649974E-03_JPRB, 0.37601484E-03_JPRB, 0.37549756E-03_JPRB, &
  & 0.37503403E-03_JPRB, 0.37462390E-03_JPRB, 0.37426771E-03_JPRB, 0.37394840E-03_JPRB, 0.37361370E-03_JPRB, 0.37329735E-03_JPRB, &
  & 0.37303051E-03_JPRB, 0.37282359E-03_JPRB, 0.37267645E-03_JPRB, 0.37257164E-03_JPRB, 0.37250239E-03_JPRB, 0.37246348E-03_JPRB, &
  & 0.37243575E-03_JPRB, 0.37242433E-03_JPRB, 0.37242099E-03_JPRB, 0.37240671E-03_JPRB  /)

RGHG1(:,18,11) = (/ &
  & 0.37516793E-03_JPRB, 0.37517855E-03_JPRB, 0.37519111E-03_JPRB, 0.37520996E-03_JPRB, 0.37525827E-03_JPRB, 0.37531448E-03_JPRB, &
  & 0.37534350E-03_JPRB, 0.37536249E-03_JPRB, 0.37538512E-03_JPRB, 0.37540682E-03_JPRB, 0.37543408E-03_JPRB, 0.37545976E-03_JPRB, &
  & 0.37548107E-03_JPRB, 0.37548675E-03_JPRB, 0.37548583E-03_JPRB, 0.37547726E-03_JPRB, 0.37546027E-03_JPRB, 0.37543302E-03_JPRB, &
  & 0.37539920E-03_JPRB, 0.37538014E-03_JPRB, 0.37538542E-03_JPRB, 0.37540824E-03_JPRB, 0.37553795E-03_JPRB, 0.37591397E-03_JPRB, &
  & 0.37646627E-03_JPRB, 0.37701637E-03_JPRB, 0.37749705E-03_JPRB, 0.37792497E-03_JPRB, 0.37832848E-03_JPRB, 0.37877393E-03_JPRB, &
  & 0.37929750E-03_JPRB, 0.37977748E-03_JPRB, 0.38004999E-03_JPRB, 0.38007742E-03_JPRB, 0.37990118E-03_JPRB, 0.37962687E-03_JPRB, &
  & 0.37936871E-03_JPRB, 0.37910123E-03_JPRB, 0.37871815E-03_JPRB, 0.37819967E-03_JPRB, 0.37771462E-03_JPRB, 0.37740126E-03_JPRB, &
  & 0.37720427E-03_JPRB, 0.37701744E-03_JPRB, 0.37678210E-03_JPRB, 0.37638800E-03_JPRB, 0.37588255E-03_JPRB, 0.37539338E-03_JPRB, &
  & 0.37493098E-03_JPRB, 0.37454301E-03_JPRB, 0.37421456E-03_JPRB, 0.37392905E-03_JPRB, 0.37364130E-03_JPRB, 0.37338151E-03_JPRB, &
  & 0.37317605E-03_JPRB, 0.37302155E-03_JPRB, 0.37291282E-03_JPRB, 0.37284958E-03_JPRB, 0.37282114E-03_JPRB, 0.37280799E-03_JPRB, &
  & 0.37280121E-03_JPRB, 0.37280188E-03_JPRB, 0.37280376E-03_JPRB, 0.37280093E-03_JPRB  /)

RGHG1(:,19,11) = (/ &
  & 0.37528350E-03_JPRB, 0.37525449E-03_JPRB, 0.37523037E-03_JPRB, 0.37522992E-03_JPRB, 0.37525510E-03_JPRB, 0.37529726E-03_JPRB, &
  & 0.37532711E-03_JPRB, 0.37533730E-03_JPRB, 0.37535175E-03_JPRB, 0.37536701E-03_JPRB, 0.37539422E-03_JPRB, 0.37542095E-03_JPRB, &
  & 0.37543886E-03_JPRB, 0.37544278E-03_JPRB, 0.37543612E-03_JPRB, 0.37542760E-03_JPRB, 0.37541118E-03_JPRB, 0.37538682E-03_JPRB, &
  & 0.37536079E-03_JPRB, 0.37534336E-03_JPRB, 0.37535207E-03_JPRB, 0.37537815E-03_JPRB, 0.37549151E-03_JPRB, 0.37582691E-03_JPRB, &
  & 0.37632984E-03_JPRB, 0.37682898E-03_JPRB, 0.37733243E-03_JPRB, 0.37786896E-03_JPRB, 0.37839815E-03_JPRB, 0.37895645E-03_JPRB, &
  & 0.37960153E-03_JPRB, 0.38020233E-03_JPRB, 0.38053345E-03_JPRB, 0.38055412E-03_JPRB, 0.38034118E-03_JPRB, 0.38001149E-03_JPRB, &
  & 0.37967500E-03_JPRB, 0.37934632E-03_JPRB, 0.37888613E-03_JPRB, 0.37829428E-03_JPRB, 0.37772039E-03_JPRB, 0.37733105E-03_JPRB, &
  & 0.37709389E-03_JPRB, 0.37690962E-03_JPRB, 0.37668650E-03_JPRB, 0.37627917E-03_JPRB, 0.37575990E-03_JPRB, 0.37530326E-03_JPRB, &
  & 0.37485083E-03_JPRB, 0.37447612E-03_JPRB, 0.37417682E-03_JPRB, 0.37392071E-03_JPRB, 0.37367053E-03_JPRB, 0.37346271E-03_JPRB, &
  & 0.37331788E-03_JPRB, 0.37321903E-03_JPRB, 0.37314704E-03_JPRB, 0.37310893E-03_JPRB, 0.37309713E-03_JPRB, 0.37309678E-03_JPRB, &
  & 0.37310260E-03_JPRB, 0.37310811E-03_JPRB, 0.37311249E-03_JPRB, 0.37311609E-03_JPRB  /)

RGHG1(:,20,11) = (/ &
  & 0.37535454E-03_JPRB, 0.37529769E-03_JPRB, 0.37524572E-03_JPRB, 0.37522720E-03_JPRB, 0.37523062E-03_JPRB, 0.37525997E-03_JPRB, &
  & 0.37528902E-03_JPRB, 0.37530158E-03_JPRB, 0.37531873E-03_JPRB, 0.37533815E-03_JPRB, 0.37537319E-03_JPRB, 0.37540682E-03_JPRB, &
  & 0.37543129E-03_JPRB, 0.37544369E-03_JPRB, 0.37544469E-03_JPRB, 0.37544381E-03_JPRB, 0.37543599E-03_JPRB, 0.37542071E-03_JPRB, &
  & 0.37540589E-03_JPRB, 0.37539929E-03_JPRB, 0.37541497E-03_JPRB, 0.37544895E-03_JPRB, 0.37555669E-03_JPRB, 0.37585473E-03_JPRB, &
  & 0.37629674E-03_JPRB, 0.37674531E-03_JPRB, 0.37726467E-03_JPRB, 0.37790455E-03_JPRB, 0.37857376E-03_JPRB, 0.37924126E-03_JPRB, &
  & 0.37996570E-03_JPRB, 0.38061917E-03_JPRB, 0.38097662E-03_JPRB, 0.38100903E-03_JPRB, 0.38080208E-03_JPRB, 0.38046984E-03_JPRB, &
  & 0.38010464E-03_JPRB, 0.37974160E-03_JPRB, 0.37921999E-03_JPRB, 0.37854114E-03_JPRB, 0.37786827E-03_JPRB, 0.37738982E-03_JPRB, &
  & 0.37709437E-03_JPRB, 0.37689281E-03_JPRB, 0.37666599E-03_JPRB, 0.37625888E-03_JPRB, 0.37574515E-03_JPRB, 0.37531977E-03_JPRB, &
  & 0.37489045E-03_JPRB, 0.37452210E-03_JPRB, 0.37425092E-03_JPRB, 0.37402447E-03_JPRB, 0.37380072E-03_JPRB, 0.37362905E-03_JPRB, &
  & 0.37353059E-03_JPRB, 0.37347805E-03_JPRB, 0.37343899E-03_JPRB, 0.37341010E-03_JPRB, 0.37339761E-03_JPRB, 0.37339829E-03_JPRB, &
  & 0.37340805E-03_JPRB, 0.37341566E-03_JPRB, 0.37342044E-03_JPRB, 0.37342637E-03_JPRB  /)

RGHG1(:,21,11) = (/ &
  & 0.37541394E-03_JPRB, 0.37534786E-03_JPRB, 0.37527718E-03_JPRB, 0.37523673E-03_JPRB, 0.37521771E-03_JPRB, 0.37523489E-03_JPRB, &
  & 0.37526157E-03_JPRB, 0.37528486E-03_JPRB, 0.37531254E-03_JPRB, 0.37534445E-03_JPRB, 0.37539127E-03_JPRB, 0.37543674E-03_JPRB, &
  & 0.37547591E-03_JPRB, 0.37550533E-03_JPRB, 0.37552602E-03_JPRB, 0.37554111E-03_JPRB, 0.37555063E-03_JPRB, 0.37555154E-03_JPRB, &
  & 0.37555183E-03_JPRB, 0.37556153E-03_JPRB, 0.37558934E-03_JPRB, 0.37563573E-03_JPRB, 0.37574661E-03_JPRB, 0.37601256E-03_JPRB, &
  & 0.37639608E-03_JPRB, 0.37680925E-03_JPRB, 0.37733850E-03_JPRB, 0.37806109E-03_JPRB, 0.37885795E-03_JPRB, 0.37962441E-03_JPRB, &
  & 0.38039596E-03_JPRB, 0.38105463E-03_JPRB, 0.38142935E-03_JPRB, 0.38150089E-03_JPRB, 0.38133316E-03_JPRB, 0.38102770E-03_JPRB, &
  & 0.38066778E-03_JPRB, 0.38029100E-03_JPRB, 0.37972490E-03_JPRB, 0.37896190E-03_JPRB, 0.37819718E-03_JPRB, 0.37762126E-03_JPRB, &
  & 0.37726493E-03_JPRB, 0.37703079E-03_JPRB, 0.37678361E-03_JPRB, 0.37638304E-03_JPRB, 0.37589119E-03_JPRB, 0.37549792E-03_JPRB, &
  & 0.37510036E-03_JPRB, 0.37473589E-03_JPRB, 0.37448244E-03_JPRB, 0.37428154E-03_JPRB, 0.37407723E-03_JPRB, 0.37392648E-03_JPRB, &
  & 0.37385659E-03_JPRB, 0.37383557E-03_JPRB, 0.37382274E-03_JPRB, 0.37379258E-03_JPRB, 0.37376896E-03_JPRB, 0.37376228E-03_JPRB, &
  & 0.37376960E-03_JPRB, 0.37377883E-03_JPRB, 0.37378255E-03_JPRB, 0.37378730E-03_JPRB  /)

RGHG1(:,22,11) = (/ &
  & 0.37549688E-03_JPRB, 0.37543580E-03_JPRB, 0.37534933E-03_JPRB, 0.37527598E-03_JPRB, 0.37522972E-03_JPRB, 0.37523256E-03_JPRB, &
  & 0.37525990E-03_JPRB, 0.37530109E-03_JPRB, 0.37534589E-03_JPRB, 0.37539704E-03_JPRB, 0.37545575E-03_JPRB, 0.37551901E-03_JPRB, &
  & 0.37558109E-03_JPRB, 0.37563652E-03_JPRB, 0.37568667E-03_JPRB, 0.37572744E-03_JPRB, 0.37576187E-03_JPRB, 0.37578702E-03_JPRB, &
  & 0.37580743E-03_JPRB, 0.37583347E-03_JPRB, 0.37587952E-03_JPRB, 0.37594714E-03_JPRB, 0.37607114E-03_JPRB, 0.37631630E-03_JPRB, &
  & 0.37664979E-03_JPRB, 0.37704095E-03_JPRB, 0.37757632E-03_JPRB, 0.37834771E-03_JPRB, 0.37921984E-03_JPRB, 0.38006190E-03_JPRB, &
  & 0.38086180E-03_JPRB, 0.38150624E-03_JPRB, 0.38189997E-03_JPRB, 0.38203210E-03_JPRB, 0.38193030E-03_JPRB, 0.38166709E-03_JPRB, &
  & 0.38133241E-03_JPRB, 0.38096119E-03_JPRB, 0.38036729E-03_JPRB, 0.37955270E-03_JPRB, 0.37872995E-03_JPRB, 0.37805919E-03_JPRB, &
  & 0.37766140E-03_JPRB, 0.37739301E-03_JPRB, 0.37711381E-03_JPRB, 0.37671401E-03_JPRB, 0.37624963E-03_JPRB, 0.37589450E-03_JPRB, &
  & 0.37553040E-03_JPRB, 0.37517226E-03_JPRB, 0.37491170E-03_JPRB, 0.37472159E-03_JPRB, 0.37453484E-03_JPRB, 0.37439332E-03_JPRB, &
  & 0.37433199E-03_JPRB, 0.37432298E-03_JPRB, 0.37432416E-03_JPRB, 0.37428889E-03_JPRB, 0.37424780E-03_JPRB, 0.37422868E-03_JPRB, &
  & 0.37423011E-03_JPRB, 0.37424178E-03_JPRB, 0.37424450E-03_JPRB, 0.37424346E-03_JPRB  /)

RGHG1(:,23,11) = (/ &
  & 0.37544900E-03_JPRB, 0.37539627E-03_JPRB, 0.37530935E-03_JPRB, 0.37521681E-03_JPRB, 0.37516164E-03_JPRB, 0.37517224E-03_JPRB, &
  & 0.37522894E-03_JPRB, 0.37530301E-03_JPRB, 0.37537804E-03_JPRB, 0.37545532E-03_JPRB, 0.37553616E-03_JPRB, 0.37562220E-03_JPRB, &
  & 0.37570790E-03_JPRB, 0.37578918E-03_JPRB, 0.37586715E-03_JPRB, 0.37593035E-03_JPRB, 0.37598394E-03_JPRB, 0.37602651E-03_JPRB, &
  & 0.37606077E-03_JPRB, 0.37609758E-03_JPRB, 0.37615347E-03_JPRB, 0.37623684E-03_JPRB, 0.37639221E-03_JPRB, 0.37666634E-03_JPRB, &
  & 0.37698729E-03_JPRB, 0.37737402E-03_JPRB, 0.37792441E-03_JPRB, 0.37867768E-03_JPRB, 0.37953344E-03_JPRB, 0.38041259E-03_JPRB, &
  & 0.38123779E-03_JPRB, 0.38188655E-03_JPRB, 0.38230064E-03_JPRB, 0.38247745E-03_JPRB, 0.38242809E-03_JPRB, 0.38219485E-03_JPRB, &
  & 0.38187955E-03_JPRB, 0.38151541E-03_JPRB, 0.38093828E-03_JPRB, 0.38015927E-03_JPRB, 0.37932848E-03_JPRB, 0.37862881E-03_JPRB, &
  & 0.37823643E-03_JPRB, 0.37794801E-03_JPRB, 0.37762602E-03_JPRB, 0.37721587E-03_JPRB, 0.37678881E-03_JPRB, 0.37645796E-03_JPRB, &
  & 0.37612796E-03_JPRB, 0.37578372E-03_JPRB, 0.37551157E-03_JPRB, 0.37530816E-03_JPRB, 0.37512986E-03_JPRB, 0.37498689E-03_JPRB, &
  & 0.37492096E-03_JPRB, 0.37490764E-03_JPRB, 0.37490067E-03_JPRB, 0.37486438E-03_JPRB, 0.37480912E-03_JPRB, 0.37476834E-03_JPRB, &
  & 0.37476247E-03_JPRB, 0.37478044E-03_JPRB, 0.37478446E-03_JPRB, 0.37477941E-03_JPRB  /)

RGHG1(:,24,11) = (/ &
  & 0.37530081E-03_JPRB, 0.37526102E-03_JPRB, 0.37518583E-03_JPRB, 0.37508952E-03_JPRB, 0.37504294E-03_JPRB, 0.37507555E-03_JPRB, &
  & 0.37517056E-03_JPRB, 0.37528613E-03_JPRB, 0.37539817E-03_JPRB, 0.37550739E-03_JPRB, 0.37561794E-03_JPRB, 0.37572986E-03_JPRB, &
  & 0.37584057E-03_JPRB, 0.37594597E-03_JPRB, 0.37604680E-03_JPRB, 0.37612777E-03_JPRB, 0.37619635E-03_JPRB, 0.37625218E-03_JPRB, &
  & 0.37629810E-03_JPRB, 0.37634573E-03_JPRB, 0.37640856E-03_JPRB, 0.37650429E-03_JPRB, 0.37670128E-03_JPRB, 0.37702446E-03_JPRB, &
  & 0.37735858E-03_JPRB, 0.37776410E-03_JPRB, 0.37832573E-03_JPRB, 0.37904671E-03_JPRB, 0.37986316E-03_JPRB, 0.38075880E-03_JPRB, &
  & 0.38159864E-03_JPRB, 0.38224022E-03_JPRB, 0.38265820E-03_JPRB, 0.38286659E-03_JPRB, 0.38285703E-03_JPRB, 0.38264621E-03_JPRB, &
  & 0.38234619E-03_JPRB, 0.38199268E-03_JPRB, 0.38145434E-03_JPRB, 0.38073831E-03_JPRB, 0.37993754E-03_JPRB, 0.37923392E-03_JPRB, &
  & 0.37884154E-03_JPRB, 0.37854136E-03_JPRB, 0.37818416E-03_JPRB, 0.37777335E-03_JPRB, 0.37738952E-03_JPRB, 0.37708235E-03_JPRB, &
  & 0.37678347E-03_JPRB, 0.37645802E-03_JPRB, 0.37617672E-03_JPRB, 0.37595590E-03_JPRB, 0.37577987E-03_JPRB, 0.37563641E-03_JPRB, &
  & 0.37556422E-03_JPRB, 0.37554227E-03_JPRB, 0.37552286E-03_JPRB, 0.37548790E-03_JPRB, 0.37542299E-03_JPRB, 0.37535920E-03_JPRB, &
  & 0.37534499E-03_JPRB, 0.37536739E-03_JPRB, 0.37537241E-03_JPRB, 0.37536798E-03_JPRB  /)

RGHG1(:,25,11) = (/ &
  & 0.37501096E-03_JPRB, 0.37499093E-03_JPRB, 0.37494510E-03_JPRB, 0.37486938E-03_JPRB, 0.37485790E-03_JPRB, 0.37493181E-03_JPRB, &
  & 0.37507281E-03_JPRB, 0.37523994E-03_JPRB, 0.37539638E-03_JPRB, 0.37554483E-03_JPRB, 0.37569489E-03_JPRB, 0.37583588E-03_JPRB, &
  & 0.37597274E-03_JPRB, 0.37609818E-03_JPRB, 0.37621247E-03_JPRB, 0.37630285E-03_JPRB, 0.37637960E-03_JPRB, 0.37644230E-03_JPRB, &
  & 0.37649688E-03_JPRB, 0.37655618E-03_JPRB, 0.37662239E-03_JPRB, 0.37672518E-03_JPRB, 0.37697598E-03_JPRB, 0.37737037E-03_JPRB, &
  & 0.37775416E-03_JPRB, 0.37821481E-03_JPRB, 0.37877851E-03_JPRB, 0.37945857E-03_JPRB, 0.38021744E-03_JPRB, 0.38110105E-03_JPRB, &
  & 0.38193665E-03_JPRB, 0.38254681E-03_JPRB, 0.38293902E-03_JPRB, 0.38315794E-03_JPRB, 0.38316701E-03_JPRB, 0.38296700E-03_JPRB, &
  & 0.38267564E-03_JPRB, 0.38233822E-03_JPRB, 0.38186592E-03_JPRB, 0.38123897E-03_JPRB, 0.38052306E-03_JPRB, 0.37984502E-03_JPRB, &
  & 0.37943251E-03_JPRB, 0.37913262E-03_JPRB, 0.37875764E-03_JPRB, 0.37836583E-03_JPRB, 0.37803158E-03_JPRB, 0.37774906E-03_JPRB, &
  & 0.37747445E-03_JPRB, 0.37717392E-03_JPRB, 0.37688924E-03_JPRB, 0.37664989E-03_JPRB, 0.37646718E-03_JPRB, 0.37632729E-03_JPRB, &
  & 0.37624918E-03_JPRB, 0.37621500E-03_JPRB, 0.37618110E-03_JPRB, 0.37615066E-03_JPRB, 0.37608377E-03_JPRB, 0.37599768E-03_JPRB, &
  & 0.37597397E-03_JPRB, 0.37599647E-03_JPRB, 0.37600140E-03_JPRB, 0.37600533E-03_JPRB  /)

RGHG1(:,26,11) = (/ &
  & 0.37462762E-03_JPRB, 0.37462485E-03_JPRB, 0.37461508E-03_JPRB, 0.37458796E-03_JPRB, 0.37462892E-03_JPRB, 0.37475300E-03_JPRB, &
  & 0.37494267E-03_JPRB, 0.37516488E-03_JPRB, 0.37537230E-03_JPRB, 0.37556963E-03_JPRB, 0.37576356E-03_JPRB, 0.37593907E-03_JPRB, &
  & 0.37610118E-03_JPRB, 0.37624022E-03_JPRB, 0.37636349E-03_JPRB, 0.37645832E-03_JPRB, 0.37653653E-03_JPRB, 0.37660332E-03_JPRB, &
  & 0.37666648E-03_JPRB, 0.37673603E-03_JPRB, 0.37681050E-03_JPRB, 0.37692828E-03_JPRB, 0.37724814E-03_JPRB, 0.37771484E-03_JPRB, &
  & 0.37817312E-03_JPRB, 0.37868086E-03_JPRB, 0.37923662E-03_JPRB, 0.37988507E-03_JPRB, 0.38059218E-03_JPRB, 0.38144524E-03_JPRB, &
  & 0.38224100E-03_JPRB, 0.38278765E-03_JPRB, 0.38313878E-03_JPRB, 0.38335402E-03_JPRB, 0.38336963E-03_JPRB, 0.38317004E-03_JPRB, &
  & 0.38289111E-03_JPRB, 0.38256955E-03_JPRB, 0.38214453E-03_JPRB, 0.38160345E-03_JPRB, 0.38098114E-03_JPRB, 0.38035115E-03_JPRB, &
  & 0.37991068E-03_JPRB, 0.37959933E-03_JPRB, 0.37924244E-03_JPRB, 0.37890097E-03_JPRB, 0.37860840E-03_JPRB, 0.37835687E-03_JPRB, &
  & 0.37811167E-03_JPRB, 0.37784005E-03_JPRB, 0.37756495E-03_JPRB, 0.37731932E-03_JPRB, 0.37712892E-03_JPRB, 0.37698990E-03_JPRB, &
  & 0.37690701E-03_JPRB, 0.37687006E-03_JPRB, 0.37683362E-03_JPRB, 0.37680634E-03_JPRB, 0.37674593E-03_JPRB, 0.37666343E-03_JPRB, &
  & 0.37663395E-03_JPRB, 0.37665052E-03_JPRB, 0.37665449E-03_JPRB, 0.37665225E-03_JPRB  /)

RGHG1(:,27,11) = (/ &
  & 0.37419216E-03_JPRB, 0.37420650E-03_JPRB, 0.37423694E-03_JPRB, 0.37427100E-03_JPRB, 0.37437323E-03_JPRB, 0.37455304E-03_JPRB, &
  & 0.37479459E-03_JPRB, 0.37507570E-03_JPRB, 0.37533886E-03_JPRB, 0.37559087E-03_JPRB, 0.37583229E-03_JPRB, 0.37604589E-03_JPRB, &
  & 0.37623407E-03_JPRB, 0.37638497E-03_JPRB, 0.37651596E-03_JPRB, 0.37661359E-03_JPRB, 0.37669084E-03_JPRB, 0.37676088E-03_JPRB, &
  & 0.37683300E-03_JPRB, 0.37691272E-03_JPRB, 0.37699764E-03_JPRB, 0.37713403E-03_JPRB, 0.37753175E-03_JPRB, 0.37807446E-03_JPRB, &
  & 0.37861981E-03_JPRB, 0.37917381E-03_JPRB, 0.37971754E-03_JPRB, 0.38033642E-03_JPRB, 0.38099156E-03_JPRB, 0.38180583E-03_JPRB, &
  & 0.38254673E-03_JPRB, 0.38301508E-03_JPRB, 0.38331758E-03_JPRB, 0.38352369E-03_JPRB, 0.38354167E-03_JPRB, 0.38333866E-03_JPRB, &
  & 0.38307413E-03_JPRB, 0.38276906E-03_JPRB, 0.38238653E-03_JPRB, 0.38193401E-03_JPRB, 0.38141283E-03_JPRB, 0.38084138E-03_JPRB, &
  & 0.38036878E-03_JPRB, 0.38004111E-03_JPRB, 0.37971644E-03_JPRB, 0.37943922E-03_JPRB, 0.37918729E-03_JPRB, 0.37897052E-03_JPRB, &
  & 0.37875797E-03_JPRB, 0.37851803E-03_JPRB, 0.37825777E-03_JPRB, 0.37801012E-03_JPRB, 0.37781129E-03_JPRB, 0.37767219E-03_JPRB, &
  & 0.37758473E-03_JPRB, 0.37754840E-03_JPRB, 0.37751371E-03_JPRB, 0.37748924E-03_JPRB, 0.37743875E-03_JPRB, 0.37736959E-03_JPRB, &
  & 0.37733546E-03_JPRB, 0.37734360E-03_JPRB, 0.37734626E-03_JPRB, 0.37733217E-03_JPRB  /)

RGHG1(:,28,11) = (/ &
  & 0.37371185E-03_JPRB, 0.37375556E-03_JPRB, 0.37381605E-03_JPRB, 0.37391353E-03_JPRB, 0.37409091E-03_JPRB, 0.37433889E-03_JPRB, &
  & 0.37464001E-03_JPRB, 0.37497702E-03_JPRB, 0.37530164E-03_JPRB, 0.37561195E-03_JPRB, 0.37589980E-03_JPRB, 0.37615422E-03_JPRB, &
  & 0.37636345E-03_JPRB, 0.37652195E-03_JPRB, 0.37666045E-03_JPRB, 0.37676256E-03_JPRB, 0.37683599E-03_JPRB, 0.37690528E-03_JPRB, &
  & 0.37697884E-03_JPRB, 0.37706894E-03_JPRB, 0.37717882E-03_JPRB, 0.37737469E-03_JPRB, 0.37785645E-03_JPRB, 0.37845662E-03_JPRB, &
  & 0.37903641E-03_JPRB, 0.37958874E-03_JPRB, 0.38013199E-03_JPRB, 0.38071970E-03_JPRB, 0.38133137E-03_JPRB, 0.38209584E-03_JPRB, &
  & 0.38275361E-03_JPRB, 0.38314119E-03_JPRB, 0.38339924E-03_JPRB, 0.38359211E-03_JPRB, 0.38361805E-03_JPRB, 0.38342131E-03_JPRB, &
  & 0.38314751E-03_JPRB, 0.38284302E-03_JPRB, 0.38249784E-03_JPRB, 0.38210000E-03_JPRB, 0.38164919E-03_JPRB, 0.38114158E-03_JPRB, &
  & 0.38067464E-03_JPRB, 0.38032907E-03_JPRB, 0.38003253E-03_JPRB, 0.37979519E-03_JPRB, 0.37958622E-03_JPRB, 0.37939150E-03_JPRB, &
  & 0.37920069E-03_JPRB, 0.37899055E-03_JPRB, 0.37876065E-03_JPRB, 0.37853295E-03_JPRB, 0.37835592E-03_JPRB, 0.37822599E-03_JPRB, &
  & 0.37814039E-03_JPRB, 0.37809862E-03_JPRB, 0.37806604E-03_JPRB, 0.37804394E-03_JPRB, 0.37800818E-03_JPRB, 0.37796897E-03_JPRB, &
  & 0.37795387E-03_JPRB, 0.37795652E-03_JPRB, 0.37795643E-03_JPRB, 0.37794646E-03_JPRB  /)

RGHG1(:,29,11) = (/ &
  & 0.37320098E-03_JPRB, 0.37327633E-03_JPRB, 0.37336822E-03_JPRB, 0.37353301E-03_JPRB, 0.37379062E-03_JPRB, 0.37411136E-03_JPRB, &
  & 0.37447593E-03_JPRB, 0.37487206E-03_JPRB, 0.37526205E-03_JPRB, 0.37563428E-03_JPRB, 0.37597128E-03_JPRB, 0.37626907E-03_JPRB, &
  & 0.37650038E-03_JPRB, 0.37666675E-03_JPRB, 0.37681321E-03_JPRB, 0.37692014E-03_JPRB, 0.37698939E-03_JPRB, 0.37705772E-03_JPRB, &
  & 0.37713248E-03_JPRB, 0.37723358E-03_JPRB, 0.37737052E-03_JPRB, 0.37763121E-03_JPRB, 0.37820227E-03_JPRB, 0.37886252E-03_JPRB, &
  & 0.37947653E-03_JPRB, 0.38002500E-03_JPRB, 0.38056825E-03_JPRB, 0.38112288E-03_JPRB, 0.38168885E-03_JPRB, 0.38240006E-03_JPRB, &
  & 0.38296852E-03_JPRB, 0.38327041E-03_JPRB, 0.38348156E-03_JPRB, 0.38366021E-03_JPRB, 0.38369483E-03_JPRB, 0.38350516E-03_JPRB, &
  & 0.38322052E-03_JPRB, 0.38291595E-03_JPRB, 0.38261012E-03_JPRB, 0.38226874E-03_JPRB, 0.38189118E-03_JPRB, 0.38145143E-03_JPRB, &
  & 0.38099212E-03_JPRB, 0.38062751E-03_JPRB, 0.38036061E-03_JPRB, 0.38016447E-03_JPRB, 0.38000112E-03_JPRB, 0.37982920E-03_JPRB, &
  & 0.37966097E-03_JPRB, 0.37948230E-03_JPRB, 0.37928525E-03_JPRB, 0.37907964E-03_JPRB, 0.37892703E-03_JPRB, 0.37880721E-03_JPRB, &
  & 0.37872387E-03_JPRB, 0.37867607E-03_JPRB, 0.37864574E-03_JPRB, 0.37862613E-03_JPRB, 0.37860619E-03_JPRB, 0.37859942E-03_JPRB, &
  & 0.37860553E-03_JPRB, 0.37860247E-03_JPRB, 0.37859941E-03_JPRB, 0.37859451E-03_JPRB  /)

RGHG1(:,30,11) = (/ &
  & 0.37280422E-03_JPRB, 0.37288171E-03_JPRB, 0.37303572E-03_JPRB, 0.37326350E-03_JPRB, 0.37359217E-03_JPRB, 0.37397464E-03_JPRB, &
  & 0.37439895E-03_JPRB, 0.37484367E-03_JPRB, 0.37527761E-03_JPRB, 0.37569942E-03_JPRB, 0.37608698E-03_JPRB, 0.37643095E-03_JPRB, &
  & 0.37668726E-03_JPRB, 0.37686591E-03_JPRB, 0.37702564E-03_JPRB, 0.37714923E-03_JPRB, 0.37722722E-03_JPRB, 0.37729908E-03_JPRB, &
  & 0.37738315E-03_JPRB, 0.37752773E-03_JPRB, 0.37772593E-03_JPRB, 0.37805569E-03_JPRB, 0.37865208E-03_JPRB, 0.37930434E-03_JPRB, &
  & 0.37989693E-03_JPRB, 0.38043171E-03_JPRB, 0.38096297E-03_JPRB, 0.38149513E-03_JPRB, 0.38203312E-03_JPRB, 0.38263986E-03_JPRB, &
  & 0.38310284E-03_JPRB, 0.38333480E-03_JPRB, 0.38350612E-03_JPRB, 0.38365653E-03_JPRB, 0.38368834E-03_JPRB, 0.38352153E-03_JPRB, &
  & 0.38323490E-03_JPRB, 0.38292737E-03_JPRB, 0.38264910E-03_JPRB, 0.38235447E-03_JPRB, 0.38202891E-03_JPRB, 0.38165158E-03_JPRB, &
  & 0.38124647E-03_JPRB, 0.38091134E-03_JPRB, 0.38064474E-03_JPRB, 0.38044003E-03_JPRB, 0.38027898E-03_JPRB, 0.38011160E-03_JPRB, &
  & 0.37995834E-03_JPRB, 0.37980158E-03_JPRB, 0.37962361E-03_JPRB, 0.37944877E-03_JPRB, 0.37931749E-03_JPRB, 0.37921434E-03_JPRB, &
  & 0.37914242E-03_JPRB, 0.37910704E-03_JPRB, 0.37908532E-03_JPRB, 0.37907375E-03_JPRB, 0.37906314E-03_JPRB, 0.37909041E-03_JPRB, &
  & 0.37911319E-03_JPRB, 0.37910716E-03_JPRB, 0.37910777E-03_JPRB, 0.37909877E-03_JPRB  /)

RGHG1(:,31,11) = (/ &
  & 0.37238628E-03_JPRB, 0.37246601E-03_JPRB, 0.37268549E-03_JPRB, 0.37297964E-03_JPRB, 0.37338316E-03_JPRB, 0.37383066E-03_JPRB, &
  & 0.37431792E-03_JPRB, 0.37481383E-03_JPRB, 0.37529405E-03_JPRB, 0.37576809E-03_JPRB, 0.37620893E-03_JPRB, 0.37660156E-03_JPRB, &
  & 0.37688421E-03_JPRB, 0.37707581E-03_JPRB, 0.37724953E-03_JPRB, 0.37739067E-03_JPRB, 0.37747790E-03_JPRB, 0.37755347E-03_JPRB, &
  & 0.37764737E-03_JPRB, 0.37783778E-03_JPRB, 0.37810057E-03_JPRB, 0.37850309E-03_JPRB, 0.37912612E-03_JPRB, 0.37976990E-03_JPRB, &
  & 0.38033987E-03_JPRB, 0.38086021E-03_JPRB, 0.38137883E-03_JPRB, 0.38188732E-03_JPRB, 0.38239585E-03_JPRB, 0.38289247E-03_JPRB, &
  & 0.38324429E-03_JPRB, 0.38340258E-03_JPRB, 0.38353194E-03_JPRB, 0.38365259E-03_JPRB, 0.38368142E-03_JPRB, 0.38353872E-03_JPRB, &
  & 0.38325001E-03_JPRB, 0.38293935E-03_JPRB, 0.38269010E-03_JPRB, 0.38244472E-03_JPRB, 0.38217392E-03_JPRB, 0.38186238E-03_JPRB, &
  & 0.38151440E-03_JPRB, 0.38121037E-03_JPRB, 0.38094408E-03_JPRB, 0.38073029E-03_JPRB, 0.38057162E-03_JPRB, 0.38040900E-03_JPRB, &
  & 0.38027152E-03_JPRB, 0.38013782E-03_JPRB, 0.37997994E-03_JPRB, 0.37983754E-03_JPRB, 0.37972873E-03_JPRB, 0.37964314E-03_JPRB, &
  & 0.37958328E-03_JPRB, 0.37956099E-03_JPRB, 0.37954834E-03_JPRB, 0.37954526E-03_JPRB, 0.37954448E-03_JPRB, 0.37960761E-03_JPRB, &
  & 0.37964795E-03_JPRB, 0.37963879E-03_JPRB, 0.37964327E-03_JPRB, 0.37962996E-03_JPRB  /)

RGHG1(:,32,11) = (/ &
  & 0.37229464E-03_JPRB, 0.37233269E-03_JPRB, 0.37257320E-03_JPRB, 0.37294742E-03_JPRB, 0.37340954E-03_JPRB, 0.37390054E-03_JPRB, &
  & 0.37439980E-03_JPRB, 0.37493146E-03_JPRB, 0.37545837E-03_JPRB, 0.37598300E-03_JPRB, 0.37648341E-03_JPRB, 0.37693509E-03_JPRB, &
  & 0.37726642E-03_JPRB, 0.37749444E-03_JPRB, 0.37769438E-03_JPRB, 0.37787029E-03_JPRB, 0.37799124E-03_JPRB, 0.37809622E-03_JPRB, &
  & 0.37821876E-03_JPRB, 0.37843461E-03_JPRB, 0.37872456E-03_JPRB, 0.37913083E-03_JPRB, 0.37969739E-03_JPRB, 0.38028237E-03_JPRB, &
  & 0.38081018E-03_JPRB, 0.38131048E-03_JPRB, 0.38181356E-03_JPRB, 0.38229547E-03_JPRB, 0.38275282E-03_JPRB, 0.38313962E-03_JPRB, &
  & 0.38337525E-03_JPRB, 0.38345795E-03_JPRB, 0.38353139E-03_JPRB, 0.38361280E-03_JPRB, 0.38362608E-03_JPRB, 0.38349480E-03_JPRB, &
  & 0.38323222E-03_JPRB, 0.38296027E-03_JPRB, 0.38275148E-03_JPRB, 0.38254942E-03_JPRB, 0.38233212E-03_JPRB, 0.38208644E-03_JPRB, &
  & 0.38181284E-03_JPRB, 0.38156197E-03_JPRB, 0.38131331E-03_JPRB, 0.38109541E-03_JPRB, 0.38092418E-03_JPRB, 0.38076161E-03_JPRB, &
  & 0.38062479E-03_JPRB, 0.38048694E-03_JPRB, 0.38033297E-03_JPRB, 0.38020459E-03_JPRB, 0.38010797E-03_JPRB, 0.38003414E-03_JPRB, &
  & 0.37998640E-03_JPRB, 0.37998030E-03_JPRB, 0.37999405E-03_JPRB, 0.38002281E-03_JPRB, 0.38005307E-03_JPRB, 0.38012808E-03_JPRB, &
  & 0.38017994E-03_JPRB, 0.38017823E-03_JPRB, 0.38018829E-03_JPRB, 0.38017378E-03_JPRB  /)

RGHG1(:,33,11) = (/ &
  & 0.37224165E-03_JPRB, 0.37223069E-03_JPRB, 0.37248731E-03_JPRB, 0.37294651E-03_JPRB, 0.37346743E-03_JPRB, 0.37400085E-03_JPRB, &
  & 0.37450600E-03_JPRB, 0.37507279E-03_JPRB, 0.37564828E-03_JPRB, 0.37622528E-03_JPRB, 0.37678840E-03_JPRB, 0.37730281E-03_JPRB, &
  & 0.37768762E-03_JPRB, 0.37795652E-03_JPRB, 0.37818530E-03_JPRB, 0.37839957E-03_JPRB, 0.37855874E-03_JPRB, 0.37869760E-03_JPRB, &
  & 0.37885234E-03_JPRB, 0.37909199E-03_JPRB, 0.37940532E-03_JPRB, 0.37980655E-03_JPRB, 0.38030368E-03_JPRB, 0.38082103E-03_JPRB, &
  & 0.38130250E-03_JPRB, 0.38178124E-03_JPRB, 0.38226780E-03_JPRB, 0.38272171E-03_JPRB, 0.38312306E-03_JPRB, 0.38339575E-03_JPRB, &
  & 0.38351001E-03_JPRB, 0.38351388E-03_JPRB, 0.38352740E-03_JPRB, 0.38356681E-03_JPRB, 0.38356231E-03_JPRB, 0.38344125E-03_JPRB, &
  & 0.38320947E-03_JPRB, 0.38298316E-03_JPRB, 0.38281791E-03_JPRB, 0.38266009E-03_JPRB, 0.38249823E-03_JPRB, 0.38232101E-03_JPRB, &
  & 0.38212693E-03_JPRB, 0.38193416E-03_JPRB, 0.38170609E-03_JPRB, 0.38148454E-03_JPRB, 0.38129833E-03_JPRB, 0.38113521E-03_JPRB, &
  & 0.38099713E-03_JPRB, 0.38085144E-03_JPRB, 0.38069942E-03_JPRB, 0.38058322E-03_JPRB, 0.38049795E-03_JPRB, 0.38043560E-03_JPRB, &
  & 0.38040046E-03_JPRB, 0.38041158E-03_JPRB, 0.38045501E-03_JPRB, 0.38051989E-03_JPRB, 0.38058515E-03_JPRB, 0.38066940E-03_JPRB, &
  & 0.38073246E-03_JPRB, 0.38073985E-03_JPRB, 0.38075592E-03_JPRB, 0.38074058E-03_JPRB  /)

RGHG1(:,34,11) = (/ &
  & 0.37235162E-03_JPRB, 0.37235731E-03_JPRB, 0.37258717E-03_JPRB, 0.37308461E-03_JPRB, 0.37365849E-03_JPRB, 0.37424101E-03_JPRB, &
  & 0.37474811E-03_JPRB, 0.37532315E-03_JPRB, 0.37595401E-03_JPRB, 0.37659404E-03_JPRB, 0.37721514E-03_JPRB, 0.37779097E-03_JPRB, &
  & 0.37823278E-03_JPRB, 0.37855263E-03_JPRB, 0.37882135E-03_JPRB, 0.37907023E-03_JPRB, 0.37925595E-03_JPRB, 0.37940777E-03_JPRB, &
  & 0.37956118E-03_JPRB, 0.37977630E-03_JPRB, 0.38006227E-03_JPRB, 0.38040947E-03_JPRB, 0.38081647E-03_JPRB, 0.38127035E-03_JPRB, &
  & 0.38169990E-03_JPRB, 0.38214499E-03_JPRB, 0.38261626E-03_JPRB, 0.38306018E-03_JPRB, 0.38341372E-03_JPRB, 0.38359558E-03_JPRB, &
  & 0.38361328E-03_JPRB, 0.38354169E-03_JPRB, 0.38349825E-03_JPRB, 0.38349915E-03_JPRB, 0.38347331E-03_JPRB, 0.38334756E-03_JPRB, &
  & 0.38313454E-03_JPRB, 0.38294476E-03_JPRB, 0.38280918E-03_JPRB, 0.38267612E-03_JPRB, 0.38255236E-03_JPRB, 0.38243190E-03_JPRB, &
  & 0.38231664E-03_JPRB, 0.38219303E-03_JPRB, 0.38201505E-03_JPRB, 0.38181766E-03_JPRB, 0.38165057E-03_JPRB, 0.38149914E-03_JPRB, &
  & 0.38136056E-03_JPRB, 0.38121100E-03_JPRB, 0.38106241E-03_JPRB, 0.38094951E-03_JPRB, 0.38087121E-03_JPRB, 0.38081454E-03_JPRB, &
  & 0.38079624E-03_JPRB, 0.38083062E-03_JPRB, 0.38090670E-03_JPRB, 0.38100274E-03_JPRB, 0.38110131E-03_JPRB, 0.38120043E-03_JPRB, &
  & 0.38129159E-03_JPRB, 0.38131347E-03_JPRB, 0.38132329E-03_JPRB, 0.38130412E-03_JPRB  /)

RGHG1(:,35,11) = (/ &
  & 0.37254831E-03_JPRB, 0.37260480E-03_JPRB, 0.37278516E-03_JPRB, 0.37329793E-03_JPRB, 0.37392325E-03_JPRB, 0.37455969E-03_JPRB, &
  & 0.37506679E-03_JPRB, 0.37563650E-03_JPRB, 0.37632778E-03_JPRB, 0.37703809E-03_JPRB, 0.37771634E-03_JPRB, 0.37835467E-03_JPRB, &
  & 0.37885689E-03_JPRB, 0.37923429E-03_JPRB, 0.37954978E-03_JPRB, 0.37983231E-03_JPRB, 0.38003933E-03_JPRB, 0.38019375E-03_JPRB, &
  & 0.38032858E-03_JPRB, 0.38049369E-03_JPRB, 0.38072548E-03_JPRB, 0.38099201E-03_JPRB, 0.38129572E-03_JPRB, 0.38168647E-03_JPRB, &
  & 0.38205976E-03_JPRB, 0.38246405E-03_JPRB, 0.38292026E-03_JPRB, 0.38336314E-03_JPRB, 0.38367173E-03_JPRB, 0.38377213E-03_JPRB, &
  & 0.38370331E-03_JPRB, 0.38355585E-03_JPRB, 0.38345538E-03_JPRB, 0.38341848E-03_JPRB, 0.38336886E-03_JPRB, 0.38323064E-03_JPRB, &
  & 0.38303074E-03_JPRB, 0.38287382E-03_JPRB, 0.38276163E-03_JPRB, 0.38264403E-03_JPRB, 0.38255054E-03_JPRB, 0.38248243E-03_JPRB, &
  & 0.38244785E-03_JPRB, 0.38240102E-03_JPRB, 0.38228968E-03_JPRB, 0.38213140E-03_JPRB, 0.38200147E-03_JPRB, 0.38186836E-03_JPRB, &
  & 0.38172965E-03_JPRB, 0.38157813E-03_JPRB, 0.38143384E-03_JPRB, 0.38131977E-03_JPRB, 0.38124640E-03_JPRB, 0.38119259E-03_JPRB, &
  & 0.38119378E-03_JPRB, 0.38125518E-03_JPRB, 0.38136633E-03_JPRB, 0.38149186E-03_JPRB, 0.38162382E-03_JPRB, 0.38174114E-03_JPRB, &
  & 0.38186984E-03_JPRB, 0.38190939E-03_JPRB, 0.38190647E-03_JPRB, 0.38188185E-03_JPRB  /)

RGHG1(:,36,11) = (/ &
  & 0.37278435E-03_JPRB, 0.37287845E-03_JPRB, 0.37300430E-03_JPRB, 0.37350831E-03_JPRB, 0.37417891E-03_JPRB, 0.37487637E-03_JPRB, &
  & 0.37540307E-03_JPRB, 0.37597839E-03_JPRB, 0.37672590E-03_JPRB, 0.37751060E-03_JPRB, 0.37824862E-03_JPRB, 0.37894677E-03_JPRB, &
  & 0.37951120E-03_JPRB, 0.37993980E-03_JPRB, 0.38029737E-03_JPRB, 0.38060136E-03_JPRB, 0.38080895E-03_JPRB, 0.38094554E-03_JPRB, &
  & 0.38104175E-03_JPRB, 0.38114734E-03_JPRB, 0.38131852E-03_JPRB, 0.38150400E-03_JPRB, 0.38171055E-03_JPRB, 0.38203992E-03_JPRB, &
  & 0.38236174E-03_JPRB, 0.38272473E-03_JPRB, 0.38317106E-03_JPRB, 0.38361795E-03_JPRB, 0.38389289E-03_JPRB, 0.38393764E-03_JPRB, &
  & 0.38380181E-03_JPRB, 0.38360113E-03_JPRB, 0.38345970E-03_JPRB, 0.38338877E-03_JPRB, 0.38330795E-03_JPRB, 0.38313990E-03_JPRB, &
  & 0.38293227E-03_JPRB, 0.38278116E-03_JPRB, 0.38267613E-03_JPRB, 0.38256783E-03_JPRB, 0.38250036E-03_JPRB, 0.38247943E-03_JPRB, &
  & 0.38252141E-03_JPRB, 0.38255387E-03_JPRB, 0.38251548E-03_JPRB, 0.38240641E-03_JPRB, 0.38231829E-03_JPRB, 0.38220850E-03_JPRB, &
  & 0.38208113E-03_JPRB, 0.38193789E-03_JPRB, 0.38180414E-03_JPRB, 0.38169098E-03_JPRB, 0.38162264E-03_JPRB, 0.38157412E-03_JPRB, &
  & 0.38160109E-03_JPRB, 0.38170232E-03_JPRB, 0.38185329E-03_JPRB, 0.38200739E-03_JPRB, 0.38217077E-03_JPRB, 0.38232349E-03_JPRB, &
  & 0.38248971E-03_JPRB, 0.38254618E-03_JPRB, 0.38252581E-03_JPRB, 0.38248796E-03_JPRB  /)

RGHG1(:,37,11) = (/ &
  & 0.37309593E-03_JPRB, 0.37319506E-03_JPRB, 0.37325831E-03_JPRB, 0.37369888E-03_JPRB, 0.37439778E-03_JPRB, 0.37516876E-03_JPRB, &
  & 0.37575878E-03_JPRB, 0.37636444E-03_JPRB, 0.37715513E-03_JPRB, 0.37801898E-03_JPRB, 0.37881900E-03_JPRB, 0.37956716E-03_JPRB, &
  & 0.38019408E-03_JPRB, 0.38065614E-03_JPRB, 0.38104236E-03_JPRB, 0.38133856E-03_JPRB, 0.38149914E-03_JPRB, 0.38157217E-03_JPRB, &
  & 0.38158623E-03_JPRB, 0.38161423E-03_JPRB, 0.38171381E-03_JPRB, 0.38182241E-03_JPRB, 0.38195184E-03_JPRB, 0.38222773E-03_JPRB, &
  & 0.38251226E-03_JPRB, 0.38283530E-03_JPRB, 0.38328427E-03_JPRB, 0.38374652E-03_JPRB, 0.38401582E-03_JPRB, 0.38406752E-03_JPRB, &
  & 0.38391358E-03_JPRB, 0.38371494E-03_JPRB, 0.38357195E-03_JPRB, 0.38347775E-03_JPRB, 0.38335064E-03_JPRB, 0.38311483E-03_JPRB, &
  & 0.38285216E-03_JPRB, 0.38264444E-03_JPRB, 0.38250895E-03_JPRB, 0.38239525E-03_JPRB, 0.38234241E-03_JPRB, 0.38235387E-03_JPRB, &
  & 0.38245821E-03_JPRB, 0.38257078E-03_JPRB, 0.38261526E-03_JPRB, 0.38257551E-03_JPRB, 0.38253728E-03_JPRB, 0.38246083E-03_JPRB, &
  & 0.38237040E-03_JPRB, 0.38225834E-03_JPRB, 0.38214881E-03_JPRB, 0.38204129E-03_JPRB, 0.38197787E-03_JPRB, 0.38193991E-03_JPRB, &
  & 0.38200549E-03_JPRB, 0.38217340E-03_JPRB, 0.38237258E-03_JPRB, 0.38255139E-03_JPRB, 0.38273971E-03_JPRB, 0.38296511E-03_JPRB, &
  & 0.38316647E-03_JPRB, 0.38323709E-03_JPRB, 0.38318949E-03_JPRB, 0.38312142E-03_JPRB  /)

RGHG1(:,38,11) = (/ &
  & 0.37344165E-03_JPRB, 0.37354637E-03_JPRB, 0.37354016E-03_JPRB, 0.37391033E-03_JPRB, 0.37464063E-03_JPRB, 0.37549318E-03_JPRB, &
  & 0.37615347E-03_JPRB, 0.37679280E-03_JPRB, 0.37763139E-03_JPRB, 0.37858307E-03_JPRB, 0.37945189E-03_JPRB, 0.38025554E-03_JPRB, &
  & 0.38095179E-03_JPRB, 0.38145098E-03_JPRB, 0.38186900E-03_JPRB, 0.38215655E-03_JPRB, 0.38226497E-03_JPRB, 0.38226747E-03_JPRB, &
  & 0.38219038E-03_JPRB, 0.38213227E-03_JPRB, 0.38215241E-03_JPRB, 0.38217572E-03_JPRB, 0.38221958E-03_JPRB, 0.38243612E-03_JPRB, &
  & 0.38267926E-03_JPRB, 0.38295800E-03_JPRB, 0.38340989E-03_JPRB, 0.38388917E-03_JPRB, 0.38415222E-03_JPRB, 0.38421163E-03_JPRB, &
  & 0.38403760E-03_JPRB, 0.38384123E-03_JPRB, 0.38369651E-03_JPRB, 0.38357649E-03_JPRB, 0.38339802E-03_JPRB, 0.38308702E-03_JPRB, &
  & 0.38276327E-03_JPRB, 0.38249274E-03_JPRB, 0.38232345E-03_JPRB, 0.38220376E-03_JPRB, 0.38216715E-03_JPRB, 0.38221454E-03_JPRB, &
  & 0.38238808E-03_JPRB, 0.38258954E-03_JPRB, 0.38272598E-03_JPRB, 0.38276314E-03_JPRB, 0.38278027E-03_JPRB, 0.38274081E-03_JPRB, &
  & 0.38269137E-03_JPRB, 0.38261391E-03_JPRB, 0.38253126E-03_JPRB, 0.38242999E-03_JPRB, 0.38237203E-03_JPRB, 0.38234578E-03_JPRB, &
  & 0.38245421E-03_JPRB, 0.38269610E-03_JPRB, 0.38294878E-03_JPRB, 0.38315500E-03_JPRB, 0.38337100E-03_JPRB, 0.38367704E-03_JPRB, &
  & 0.38391739E-03_JPRB, 0.38400372E-03_JPRB, 0.38392591E-03_JPRB, 0.38382430E-03_JPRB  /)

RGHG1(:,39,11) = (/ &
  & 0.37371212E-03_JPRB, 0.37379437E-03_JPRB, 0.37368347E-03_JPRB, 0.37396673E-03_JPRB, 0.37469380E-03_JPRB, 0.37559337E-03_JPRB, &
  & 0.37636236E-03_JPRB, 0.37708038E-03_JPRB, 0.37797096E-03_JPRB, 0.37898564E-03_JPRB, 0.37992901E-03_JPRB, 0.38078291E-03_JPRB, &
  & 0.38153492E-03_JPRB, 0.38205234E-03_JPRB, 0.38244765E-03_JPRB, 0.38268360E-03_JPRB, 0.38273108E-03_JPRB, 0.38266915E-03_JPRB, &
  & 0.38251831E-03_JPRB, 0.38238239E-03_JPRB, 0.38234361E-03_JPRB, 0.38230767E-03_JPRB, 0.38230211E-03_JPRB, 0.38248286E-03_JPRB, &
  & 0.38274362E-03_JPRB, 0.38306030E-03_JPRB, 0.38351092E-03_JPRB, 0.38398712E-03_JPRB, 0.38424318E-03_JPRB, 0.38431684E-03_JPRB, &
  & 0.38421932E-03_JPRB, 0.38409213E-03_JPRB, 0.38399879E-03_JPRB, 0.38387648E-03_JPRB, 0.38367851E-03_JPRB, 0.38330893E-03_JPRB, &
  & 0.38290908E-03_JPRB, 0.38252998E-03_JPRB, 0.38227577E-03_JPRB, 0.38210271E-03_JPRB, 0.38203536E-03_JPRB, 0.38207747E-03_JPRB, &
  & 0.38227527E-03_JPRB, 0.38252187E-03_JPRB, 0.38272297E-03_JPRB, 0.38282400E-03_JPRB, 0.38287901E-03_JPRB, 0.38287116E-03_JPRB, &
  & 0.38287249E-03_JPRB, 0.38285573E-03_JPRB, 0.38281159E-03_JPRB, 0.38274478E-03_JPRB, 0.38270394E-03_JPRB, 0.38273043E-03_JPRB, &
  & 0.38289167E-03_JPRB, 0.38318875E-03_JPRB, 0.38348606E-03_JPRB, 0.38373316E-03_JPRB, 0.38398021E-03_JPRB, 0.38434895E-03_JPRB, &
  & 0.38459847E-03_JPRB, 0.38465638E-03_JPRB, 0.38456636E-03_JPRB, 0.38446725E-03_JPRB  /)

RGHG1(:,40,11) = (/ &
  & 0.37401724E-03_JPRB, 0.37406851E-03_JPRB, 0.37382899E-03_JPRB, 0.37400756E-03_JPRB, 0.37472515E-03_JPRB, 0.37567425E-03_JPRB, &
  & 0.37657712E-03_JPRB, 0.37739484E-03_JPRB, 0.37834711E-03_JPRB, 0.37943167E-03_JPRB, 0.38046348E-03_JPRB, 0.38137548E-03_JPRB, &
  & 0.38219072E-03_JPRB, 0.38272644E-03_JPRB, 0.38308617E-03_JPRB, 0.38325455E-03_JPRB, 0.38322907E-03_JPRB, 0.38309253E-03_JPRB, &
  & 0.38285799E-03_JPRB, 0.38263209E-03_JPRB, 0.38252753E-03_JPRB, 0.38242631E-03_JPRB, 0.38236866E-03_JPRB, 0.38251128E-03_JPRB, &
  & 0.38280237E-03_JPRB, 0.38317702E-03_JPRB, 0.38362547E-03_JPRB, 0.38409475E-03_JPRB, 0.38434249E-03_JPRB, 0.38443395E-03_JPRB, &
  & 0.38444201E-03_JPRB, 0.38440698E-03_JPRB, 0.38438262E-03_JPRB, 0.38426146E-03_JPRB, 0.38404582E-03_JPRB, 0.38361020E-03_JPRB, &
  & 0.38311859E-03_JPRB, 0.38260459E-03_JPRB, 0.38224237E-03_JPRB, 0.38199892E-03_JPRB, 0.38188779E-03_JPRB, 0.38191698E-03_JPRB, &
  & 0.38213589E-03_JPRB, 0.38242832E-03_JPRB, 0.38270083E-03_JPRB, 0.38287468E-03_JPRB, 0.38297128E-03_JPRB, 0.38299966E-03_JPRB, &
  & 0.38306216E-03_JPRB, 0.38312091E-03_JPRB, 0.38312387E-03_JPRB, 0.38310211E-03_JPRB, 0.38308329E-03_JPRB, 0.38317838E-03_JPRB, &
  & 0.38340323E-03_JPRB, 0.38376200E-03_JPRB, 0.38411025E-03_JPRB, 0.38440752E-03_JPRB, 0.38469155E-03_JPRB, 0.38513094E-03_JPRB, &
  & 0.38538635E-03_JPRB, 0.38540368E-03_JPRB, 0.38530227E-03_JPRB, 0.38521200E-03_JPRB  /)

RGHG1(:,41,11) = (/ &
  & 0.37439029E-03_JPRB, 0.37440369E-03_JPRB, 0.37400690E-03_JPRB, 0.37405748E-03_JPRB, 0.37476349E-03_JPRB, 0.37577315E-03_JPRB, &
  & 0.37683970E-03_JPRB, 0.37777931E-03_JPRB, 0.37880701E-03_JPRB, 0.37997700E-03_JPRB, 0.38111694E-03_JPRB, 0.38209999E-03_JPRB, &
  & 0.38299253E-03_JPRB, 0.38355062E-03_JPRB, 0.38386685E-03_JPRB, 0.38395261E-03_JPRB, 0.38383794E-03_JPRB, 0.38361017E-03_JPRB, &
  & 0.38327329E-03_JPRB, 0.38293738E-03_JPRB, 0.38275239E-03_JPRB, 0.38257137E-03_JPRB, 0.38245003E-03_JPRB, 0.38254602E-03_JPRB, &
  & 0.38287419E-03_JPRB, 0.38331973E-03_JPRB, 0.38376552E-03_JPRB, 0.38422635E-03_JPRB, 0.38446392E-03_JPRB, 0.38457713E-03_JPRB, &
  & 0.38471429E-03_JPRB, 0.38479192E-03_JPRB, 0.38485190E-03_JPRB, 0.38473215E-03_JPRB, 0.38449492E-03_JPRB, 0.38397856E-03_JPRB, &
  & 0.38337475E-03_JPRB, 0.38269582E-03_JPRB, 0.38220153E-03_JPRB, 0.38187201E-03_JPRB, 0.38170737E-03_JPRB, 0.38172075E-03_JPRB, &
  & 0.38196549E-03_JPRB, 0.38231393E-03_JPRB, 0.38267375E-03_JPRB, 0.38293665E-03_JPRB, 0.38308411E-03_JPRB, 0.38315677E-03_JPRB, &
  & 0.38329406E-03_JPRB, 0.38344514E-03_JPRB, 0.38350569E-03_JPRB, 0.38353901E-03_JPRB, 0.38354710E-03_JPRB, 0.38372606E-03_JPRB, &
  & 0.38402868E-03_JPRB, 0.38446287E-03_JPRB, 0.38487340E-03_JPRB, 0.38523202E-03_JPRB, 0.38556127E-03_JPRB, 0.38608704E-03_JPRB, &
  & 0.38634965E-03_JPRB, 0.38631738E-03_JPRB, 0.38620204E-03_JPRB, 0.38612256E-03_JPRB  /)

RGHG1(:,42,11) = (/ &
  & 0.37395870E-03_JPRB, 0.37382332E-03_JPRB, 0.37356479E-03_JPRB, 0.37358926E-03_JPRB, 0.37428737E-03_JPRB, 0.37528996E-03_JPRB, &
  & 0.37644074E-03_JPRB, 0.37752369E-03_JPRB, 0.37865794E-03_JPRB, 0.37988612E-03_JPRB, 0.38109892E-03_JPRB, 0.38212511E-03_JPRB, &
  & 0.38304143E-03_JPRB, 0.38358627E-03_JPRB, 0.38386617E-03_JPRB, 0.38393031E-03_JPRB, 0.38380914E-03_JPRB, 0.38357244E-03_JPRB, &
  & 0.38322577E-03_JPRB, 0.38289115E-03_JPRB, 0.38269536E-03_JPRB, 0.38253927E-03_JPRB, 0.38246792E-03_JPRB, 0.38259536E-03_JPRB, &
  & 0.38299437E-03_JPRB, 0.38346400E-03_JPRB, 0.38392103E-03_JPRB, 0.38436436E-03_JPRB, 0.38459353E-03_JPRB, 0.38470697E-03_JPRB, &
  & 0.38487073E-03_JPRB, 0.38497222E-03_JPRB, 0.38497806E-03_JPRB, 0.38485054E-03_JPRB, 0.38464498E-03_JPRB, 0.38421151E-03_JPRB, &
  & 0.38361999E-03_JPRB, 0.38298229E-03_JPRB, 0.38244469E-03_JPRB, 0.38201398E-03_JPRB, 0.38178591E-03_JPRB, 0.38174009E-03_JPRB, &
  & 0.38189213E-03_JPRB, 0.38218658E-03_JPRB, 0.38252876E-03_JPRB, 0.38278842E-03_JPRB, 0.38294709E-03_JPRB, 0.38306959E-03_JPRB, &
  & 0.38322897E-03_JPRB, 0.38342754E-03_JPRB, 0.38354316E-03_JPRB, 0.38365354E-03_JPRB, 0.38372913E-03_JPRB, 0.38399408E-03_JPRB, &
  & 0.38429438E-03_JPRB, 0.38472516E-03_JPRB, 0.38514676E-03_JPRB, 0.38550927E-03_JPRB, 0.38582989E-03_JPRB, 0.38631121E-03_JPRB, &
  & 0.38656299E-03_JPRB, 0.38653143E-03_JPRB, 0.38641149E-03_JPRB, 0.38642014E-03_JPRB  /)

RGHG1(:,43,11) = (/ &
  & 0.37372540E-03_JPRB, 0.37343797E-03_JPRB, 0.37323794E-03_JPRB, 0.37318354E-03_JPRB, 0.37386945E-03_JPRB, 0.37489165E-03_JPRB, &
  & 0.37618968E-03_JPRB, 0.37745585E-03_JPRB, 0.37871976E-03_JPRB, 0.38003777E-03_JPRB, 0.38136356E-03_JPRB, 0.38245967E-03_JPRB, &
  & 0.38343095E-03_JPRB, 0.38397332E-03_JPRB, 0.38420135E-03_JPRB, 0.38421023E-03_JPRB, 0.38404476E-03_JPRB, 0.38376067E-03_JPRB, &
  & 0.38336107E-03_JPRB, 0.38298029E-03_JPRB, 0.38274004E-03_JPRB, 0.38257238E-03_JPRB, 0.38251925E-03_JPRB, 0.38265533E-03_JPRB, &
  & 0.38313491E-03_JPRB, 0.38365703E-03_JPRB, 0.38412316E-03_JPRB, 0.38454689E-03_JPRB, 0.38476402E-03_JPRB, 0.38488703E-03_JPRB, &
  & 0.38513059E-03_JPRB, 0.38530231E-03_JPRB, 0.38529503E-03_JPRB, 0.38516103E-03_JPRB, 0.38497507E-03_JPRB, 0.38458251E-03_JPRB, &
  & 0.38395394E-03_JPRB, 0.38328289E-03_JPRB, 0.38264898E-03_JPRB, 0.38208892E-03_JPRB, 0.38177997E-03_JPRB, 0.38167333E-03_JPRB, &
  & 0.38175189E-03_JPRB, 0.38202119E-03_JPRB, 0.38238482E-03_JPRB, 0.38267983E-03_JPRB, 0.38287061E-03_JPRB, 0.38305763E-03_JPRB, &
  & 0.38326934E-03_JPRB, 0.38355094E-03_JPRB, 0.38374158E-03_JPRB, 0.38394597E-03_JPRB, 0.38409472E-03_JPRB, 0.38447420E-03_JPRB, &
  & 0.38480584E-03_JPRB, 0.38526594E-03_JPRB, 0.38572443E-03_JPRB, 0.38611689E-03_JPRB, 0.38644909E-03_JPRB, 0.38692701E-03_JPRB, &
  & 0.38717200E-03_JPRB, 0.38711976E-03_JPRB, 0.38698963E-03_JPRB, 0.38708333E-03_JPRB  /)

RGHG1(:,44,11) = (/ &
  & 0.37271164E-03_JPRB, 0.37243165E-03_JPRB, 0.37232113E-03_JPRB, 0.37241402E-03_JPRB, 0.37311858E-03_JPRB, 0.37416625E-03_JPRB, &
  & 0.37552733E-03_JPRB, 0.37693126E-03_JPRB, 0.37832066E-03_JPRB, 0.37971606E-03_JPRB, 0.38109486E-03_JPRB, 0.38228507E-03_JPRB, &
  & 0.38329345E-03_JPRB, 0.38383224E-03_JPRB, 0.38404715E-03_JPRB, 0.38406695E-03_JPRB, 0.38391158E-03_JPRB, 0.38362836E-03_JPRB, &
  & 0.38325777E-03_JPRB, 0.38290365E-03_JPRB, 0.38268230E-03_JPRB, 0.38256897E-03_JPRB, 0.38258123E-03_JPRB, 0.38279746E-03_JPRB, &
  & 0.38330786E-03_JPRB, 0.38381963E-03_JPRB, 0.38425191E-03_JPRB, 0.38463912E-03_JPRB, 0.38486743E-03_JPRB, 0.38502036E-03_JPRB, &
  & 0.38525254E-03_JPRB, 0.38538296E-03_JPRB, 0.38535307E-03_JPRB, 0.38521380E-03_JPRB, 0.38502593E-03_JPRB, 0.38468335E-03_JPRB, &
  & 0.38410663E-03_JPRB, 0.38348129E-03_JPRB, 0.38286844E-03_JPRB, 0.38225212E-03_JPRB, 0.38188341E-03_JPRB, 0.38169204E-03_JPRB, &
  & 0.38168223E-03_JPRB, 0.38187587E-03_JPRB, 0.38218420E-03_JPRB, 0.38245653E-03_JPRB, 0.38264029E-03_JPRB, 0.38287028E-03_JPRB, &
  & 0.38310769E-03_JPRB, 0.38343008E-03_JPRB, 0.38367794E-03_JPRB, 0.38394170E-03_JPRB, 0.38416053E-03_JPRB, 0.38454923E-03_JPRB, &
  & 0.38487779E-03_JPRB, 0.38535153E-03_JPRB, 0.38581776E-03_JPRB, 0.38619466E-03_JPRB, 0.38650803E-03_JPRB, 0.38696918E-03_JPRB, &
  & 0.38723446E-03_JPRB, 0.38721097E-03_JPRB, 0.38701762E-03_JPRB, 0.38707024E-03_JPRB  /)

RGHG1(:,45,11) = (/ &
  & 0.37152809E-03_JPRB, 0.37123735E-03_JPRB, 0.37123612E-03_JPRB, 0.37148674E-03_JPRB, 0.37221097E-03_JPRB, 0.37329013E-03_JPRB, &
  & 0.37474157E-03_JPRB, 0.37632548E-03_JPRB, 0.37787412E-03_JPRB, 0.37936897E-03_JPRB, 0.38082240E-03_JPRB, 0.38212855E-03_JPRB, &
  & 0.38318613E-03_JPRB, 0.38372053E-03_JPRB, 0.38391394E-03_JPRB, 0.38393919E-03_JPRB, 0.38378973E-03_JPRB, 0.38350151E-03_JPRB, &
  & 0.38315726E-03_JPRB, 0.38282767E-03_JPRB, 0.38262220E-03_JPRB, 0.38256927E-03_JPRB, 0.38265828E-03_JPRB, 0.38296684E-03_JPRB, &
  & 0.38352250E-03_JPRB, 0.38402912E-03_JPRB, 0.38442402E-03_JPRB, 0.38476718E-03_JPRB, 0.38500669E-03_JPRB, 0.38519488E-03_JPRB, &
  & 0.38542419E-03_JPRB, 0.38551646E-03_JPRB, 0.38545918E-03_JPRB, 0.38531310E-03_JPRB, 0.38512553E-03_JPRB, 0.38484501E-03_JPRB, &
  & 0.38432263E-03_JPRB, 0.38374513E-03_JPRB, 0.38314408E-03_JPRB, 0.38244739E-03_JPRB, 0.38200042E-03_JPRB, 0.38170491E-03_JPRB, &
  & 0.38158520E-03_JPRB, 0.38168953E-03_JPRB, 0.38193762E-03_JPRB, 0.38218861E-03_JPRB, 0.38236843E-03_JPRB, 0.38265549E-03_JPRB, &
  & 0.38292878E-03_JPRB, 0.38330808E-03_JPRB, 0.38363057E-03_JPRB, 0.38397380E-03_JPRB, 0.38428162E-03_JPRB, 0.38469530E-03_JPRB, &
  & 0.38502432E-03_JPRB, 0.38551728E-03_JPRB, 0.38599698E-03_JPRB, 0.38635996E-03_JPRB, 0.38665334E-03_JPRB, 0.38709496E-03_JPRB, &
  & 0.38738250E-03_JPRB, 0.38738913E-03_JPRB, 0.38712252E-03_JPRB, 0.38713911E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART22',0,ZHOOK_HANDLE)



RGHG1(:,46,11) = (/ &
  & 0.37039621E-03_JPRB, 0.37010887E-03_JPRB, 0.37026366E-03_JPRB, 0.37063693E-03_JPRB, 0.37141142E-03_JPRB, 0.37250434E-03_JPRB, &
  & 0.37398564E-03_JPRB, 0.37562132E-03_JPRB, 0.37725018E-03_JPRB, 0.37877809E-03_JPRB, 0.38027820E-03_JPRB, 0.38166025E-03_JPRB, &
  & 0.38275903E-03_JPRB, 0.38331223E-03_JPRB, 0.38352725E-03_JPRB, 0.38358500E-03_JPRB, 0.38348755E-03_JPRB, 0.38326069E-03_JPRB, &
  & 0.38300114E-03_JPRB, 0.38273125E-03_JPRB, 0.38258124E-03_JPRB, 0.38259964E-03_JPRB, 0.38276181E-03_JPRB, 0.38314394E-03_JPRB, &
  & 0.38371459E-03_JPRB, 0.38419086E-03_JPRB, 0.38454086E-03_JPRB, 0.38486412E-03_JPRB, 0.38509156E-03_JPRB, 0.38529717E-03_JPRB, &
  & 0.38550650E-03_JPRB, 0.38556151E-03_JPRB, 0.38548874E-03_JPRB, 0.38535503E-03_JPRB, 0.38516972E-03_JPRB, 0.38491371E-03_JPRB, &
  & 0.38441461E-03_JPRB, 0.38388684E-03_JPRB, 0.38331347E-03_JPRB, 0.38260992E-03_JPRB, 0.38213707E-03_JPRB, 0.38176440E-03_JPRB, &
  & 0.38155951E-03_JPRB, 0.38156641E-03_JPRB, 0.38172153E-03_JPRB, 0.38192224E-03_JPRB, 0.38208525E-03_JPRB, 0.38239830E-03_JPRB, &
  & 0.38269262E-03_JPRB, 0.38310265E-03_JPRB, 0.38345900E-03_JPRB, 0.38384375E-03_JPRB, 0.38419726E-03_JPRB, 0.38457735E-03_JPRB, &
  & 0.38490500E-03_JPRB, 0.38539270E-03_JPRB, 0.38586608E-03_JPRB, 0.38621819E-03_JPRB, 0.38649894E-03_JPRB, 0.38696124E-03_JPRB, &
  & 0.38729135E-03_JPRB, 0.38729917E-03_JPRB, 0.38701238E-03_JPRB, 0.38699985E-03_JPRB  /)

RGHG1(:,47,11) = (/ &
  & 0.36907840E-03_JPRB, 0.36879789E-03_JPRB, 0.36914511E-03_JPRB, 0.36965526E-03_JPRB, 0.37049486E-03_JPRB, 0.37160038E-03_JPRB, &
  & 0.37310459E-03_JPRB, 0.37477533E-03_JPRB, 0.37648250E-03_JPRB, 0.37803590E-03_JPRB, 0.37958518E-03_JPRB, 0.38104827E-03_JPRB, &
  & 0.38219379E-03_JPRB, 0.38277371E-03_JPRB, 0.38302272E-03_JPRB, 0.38312403E-03_JPRB, 0.38309684E-03_JPRB, 0.38295527E-03_JPRB, &
  & 0.38280681E-03_JPRB, 0.38261401E-03_JPRB, 0.38253700E-03_JPRB, 0.38264130E-03_JPRB, 0.38288861E-03_JPRB, 0.38335330E-03_JPRB, &
  & 0.38393548E-03_JPRB, 0.38437107E-03_JPRB, 0.38466690E-03_JPRB, 0.38497164E-03_JPRB, 0.38518027E-03_JPRB, 0.38540272E-03_JPRB, &
  & 0.38558519E-03_JPRB, 0.38559664E-03_JPRB, 0.38550809E-03_JPRB, 0.38539274E-03_JPRB, 0.38521047E-03_JPRB, 0.38497570E-03_JPRB, &
  & 0.38449770E-03_JPRB, 0.38402866E-03_JPRB, 0.38349095E-03_JPRB, 0.38279408E-03_JPRB, 0.38230135E-03_JPRB, 0.38184354E-03_JPRB, &
  & 0.38154365E-03_JPRB, 0.38143461E-03_JPRB, 0.38147409E-03_JPRB, 0.38161000E-03_JPRB, 0.38175070E-03_JPRB, 0.38208803E-03_JPRB, &
  & 0.38240405E-03_JPRB, 0.38284488E-03_JPRB, 0.38323280E-03_JPRB, 0.38365868E-03_JPRB, 0.38405711E-03_JPRB, 0.38438606E-03_JPRB, &
  & 0.38471173E-03_JPRB, 0.38518835E-03_JPRB, 0.38565035E-03_JPRB, 0.38599032E-03_JPRB, 0.38625771E-03_JPRB, 0.38675234E-03_JPRB, &
  & 0.38713647E-03_JPRB, 0.38713990E-03_JPRB, 0.38684005E-03_JPRB, 0.38679475E-03_JPRB  /)

RGHG1(:,48,11) = (/ &
  & 0.36840358E-03_JPRB, 0.36802155E-03_JPRB, 0.36851632E-03_JPRB, 0.36908546E-03_JPRB, 0.36996235E-03_JPRB, 0.37100822E-03_JPRB, &
  & 0.37246975E-03_JPRB, 0.37408448E-03_JPRB, 0.37578303E-03_JPRB, 0.37732900E-03_JPRB, 0.37885559E-03_JPRB, 0.38033270E-03_JPRB, &
  & 0.38151516E-03_JPRB, 0.38213525E-03_JPRB, 0.38245569E-03_JPRB, 0.38263329E-03_JPRB, 0.38269425E-03_JPRB, 0.38265628E-03_JPRB, &
  & 0.38261873E-03_JPRB, 0.38251278E-03_JPRB, 0.38250488E-03_JPRB, 0.38267626E-03_JPRB, 0.38298953E-03_JPRB, 0.38350178E-03_JPRB, &
  & 0.38408203E-03_JPRB, 0.38448435E-03_JPRB, 0.38475314E-03_JPRB, 0.38504422E-03_JPRB, 0.38522543E-03_JPRB, 0.38541180E-03_JPRB, &
  & 0.38558197E-03_JPRB, 0.38557795E-03_JPRB, 0.38549178E-03_JPRB, 0.38540083E-03_JPRB, 0.38522332E-03_JPRB, 0.38497859E-03_JPRB, &
  & 0.38451670E-03_JPRB, 0.38407961E-03_JPRB, 0.38356634E-03_JPRB, 0.38290402E-03_JPRB, 0.38241338E-03_JPRB, 0.38192391E-03_JPRB, &
  & 0.38155907E-03_JPRB, 0.38135257E-03_JPRB, 0.38129996E-03_JPRB, 0.38138690E-03_JPRB, 0.38151602E-03_JPRB, 0.38184576E-03_JPRB, &
  & 0.38215693E-03_JPRB, 0.38259217E-03_JPRB, 0.38297332E-03_JPRB, 0.38340499E-03_JPRB, 0.38381091E-03_JPRB, 0.38412398E-03_JPRB, &
  & 0.38441607E-03_JPRB, 0.38484579E-03_JPRB, 0.38529461E-03_JPRB, 0.38559335E-03_JPRB, 0.38584340E-03_JPRB, 0.38635481E-03_JPRB, &
  & 0.38677770E-03_JPRB, 0.38674465E-03_JPRB, 0.38654391E-03_JPRB, 0.38650033E-03_JPRB  /)

RGHG1(:,49,11) = (/ &
  & 0.36794862E-03_JPRB, 0.36740492E-03_JPRB, 0.36804267E-03_JPRB, 0.36864171E-03_JPRB, 0.36954727E-03_JPRB, 0.37049423E-03_JPRB, &
  & 0.37187866E-03_JPRB, 0.37338997E-03_JPRB, 0.37503946E-03_JPRB, 0.37656222E-03_JPRB, 0.37803103E-03_JPRB, 0.37949318E-03_JPRB, &
  & 0.38071209E-03_JPRB, 0.38138280E-03_JPRB, 0.38179934E-03_JPRB, 0.38207631E-03_JPRB, 0.38224303E-03_JPRB, 0.38232811E-03_JPRB, &
  & 0.38241329E-03_JPRB, 0.38240796E-03_JPRB, 0.38247482E-03_JPRB, 0.38271193E-03_JPRB, 0.38308952E-03_JPRB, 0.38363853E-03_JPRB, &
  & 0.38421053E-03_JPRB, 0.38457936E-03_JPRB, 0.38483055E-03_JPRB, 0.38510870E-03_JPRB, 0.38525565E-03_JPRB, 0.38537800E-03_JPRB, &
  & 0.38554116E-03_JPRB, 0.38553278E-03_JPRB, 0.38545751E-03_JPRB, 0.38539631E-03_JPRB, 0.38522488E-03_JPRB, 0.38495492E-03_JPRB, &
  & 0.38450860E-03_JPRB, 0.38409472E-03_JPRB, 0.38360341E-03_JPRB, 0.38299203E-03_JPRB, 0.38251369E-03_JPRB, 0.38201347E-03_JPRB, &
  & 0.38159038E-03_JPRB, 0.38128435E-03_JPRB, 0.38114047E-03_JPRB, 0.38118037E-03_JPRB, 0.38130154E-03_JPRB, 0.38160839E-03_JPRB, &
  & 0.38190211E-03_JPRB, 0.38231462E-03_JPRB, 0.38267084E-03_JPRB, 0.38309286E-03_JPRB, 0.38349005E-03_JPRB, 0.38380156E-03_JPRB, &
  & 0.38404210E-03_JPRB, 0.38440360E-03_JPRB, 0.38483700E-03_JPRB, 0.38507687E-03_JPRB, 0.38530589E-03_JPRB, 0.38582883E-03_JPRB, &
  & 0.38628770E-03_JPRB, 0.38619966E-03_JPRB, 0.38615966E-03_JPRB, 0.38613368E-03_JPRB  /)

RGHG1(:,50,11) = (/ &
  & 0.36810826E-03_JPRB, 0.36745784E-03_JPRB, 0.36813860E-03_JPRB, 0.36868457E-03_JPRB, 0.36954858E-03_JPRB, 0.37038717E-03_JPRB, &
  & 0.37171734E-03_JPRB, 0.37307669E-03_JPRB, 0.37457196E-03_JPRB, 0.37601911E-03_JPRB, 0.37736627E-03_JPRB, 0.37876553E-03_JPRB, &
  & 0.37999697E-03_JPRB, 0.38073637E-03_JPRB, 0.38125053E-03_JPRB, 0.38163511E-03_JPRB, 0.38189726E-03_JPRB, 0.38206813E-03_JPRB, &
  & 0.38224012E-03_JPRB, 0.38231578E-03_JPRB, 0.38243452E-03_JPRB, 0.38272633E-03_JPRB, 0.38313387E-03_JPRB, 0.38367566E-03_JPRB, &
  & 0.38423535E-03_JPRB, 0.38460132E-03_JPRB, 0.38485455E-03_JPRB, 0.38512271E-03_JPRB, 0.38523202E-03_JPRB, 0.38529680E-03_JPRB, &
  & 0.38545189E-03_JPRB, 0.38545535E-03_JPRB, 0.38540723E-03_JPRB, 0.38536011E-03_JPRB, 0.38518895E-03_JPRB, 0.38488259E-03_JPRB, &
  & 0.38446303E-03_JPRB, 0.38406595E-03_JPRB, 0.38358142E-03_JPRB, 0.38301919E-03_JPRB, 0.38254781E-03_JPRB, 0.38206584E-03_JPRB, &
  & 0.38160993E-03_JPRB, 0.38123896E-03_JPRB, 0.38104306E-03_JPRB, 0.38105512E-03_JPRB, 0.38117906E-03_JPRB, 0.38145018E-03_JPRB, &
  & 0.38172069E-03_JPRB, 0.38210926E-03_JPRB, 0.38243830E-03_JPRB, 0.38281383E-03_JPRB, 0.38317082E-03_JPRB, 0.38346431E-03_JPRB, &
  & 0.38365964E-03_JPRB, 0.38394073E-03_JPRB, 0.38433780E-03_JPRB, 0.38451793E-03_JPRB, 0.38470525E-03_JPRB, 0.38520341E-03_JPRB, &
  & 0.38568265E-03_JPRB, 0.38555902E-03_JPRB, 0.38562422E-03_JPRB, 0.38562010E-03_JPRB  /)

RGHG1(:,51,11) = (/ &
  & 0.36860402E-03_JPRB, 0.36786704E-03_JPRB, 0.36854178E-03_JPRB, 0.36898671E-03_JPRB, 0.36976888E-03_JPRB, 0.37048528E-03_JPRB, &
  & 0.37176875E-03_JPRB, 0.37293823E-03_JPRB, 0.37421141E-03_JPRB, 0.37554922E-03_JPRB, 0.37673124E-03_JPRB, 0.37803727E-03_JPRB, &
  & 0.37926969E-03_JPRB, 0.38009288E-03_JPRB, 0.38071345E-03_JPRB, 0.38121876E-03_JPRB, 0.38157869E-03_JPRB, 0.38182278E-03_JPRB, &
  & 0.38206977E-03_JPRB, 0.38222271E-03_JPRB, 0.38238554E-03_JPRB, 0.38273072E-03_JPRB, 0.38315258E-03_JPRB, 0.38366346E-03_JPRB, &
  & 0.38420769E-03_JPRB, 0.38458668E-03_JPRB, 0.38485243E-03_JPRB, 0.38511132E-03_JPRB, 0.38517817E-03_JPRB, 0.38518405E-03_JPRB, &
  & 0.38532986E-03_JPRB, 0.38535463E-03_JPRB, 0.38534443E-03_JPRB, 0.38530430E-03_JPRB, 0.38513038E-03_JPRB, 0.38477879E-03_JPRB, &
  & 0.38439404E-03_JPRB, 0.38401177E-03_JPRB, 0.38352659E-03_JPRB, 0.38301658E-03_JPRB, 0.38254992E-03_JPRB, 0.38210294E-03_JPRB, &
  & 0.38162490E-03_JPRB, 0.38120186E-03_JPRB, 0.38097033E-03_JPRB, 0.38096238E-03_JPRB, 0.38109495E-03_JPRB, 0.38132067E-03_JPRB, &
  & 0.38156303E-03_JPRB, 0.38192508E-03_JPRB, 0.38222353E-03_JPRB, 0.38252943E-03_JPRB, 0.38282638E-03_JPRB, 0.38309172E-03_JPRB, &
  & 0.38324150E-03_JPRB, 0.38342919E-03_JPRB, 0.38377599E-03_JPRB, 0.38389103E-03_JPRB, 0.38402239E-03_JPRB, 0.38447467E-03_JPRB, &
  & 0.38496774E-03_JPRB, 0.38481580E-03_JPRB, 0.38496561E-03_JPRB, 0.38498735E-03_JPRB  /)

RGHG1(:,52,11) = (/ &
  & 0.36952079E-03_JPRB, 0.36882004E-03_JPRB, 0.36941784E-03_JPRB, 0.36977185E-03_JPRB, 0.37041860E-03_JPRB, 0.37101504E-03_JPRB, &
  & 0.37221945E-03_JPRB, 0.37325093E-03_JPRB, 0.37429558E-03_JPRB, 0.37544211E-03_JPRB, 0.37645042E-03_JPRB, 0.37761224E-03_JPRB, &
  & 0.37880798E-03_JPRB, 0.37969440E-03_JPRB, 0.38037921E-03_JPRB, 0.38095611E-03_JPRB, 0.38136918E-03_JPRB, 0.38166069E-03_JPRB, &
  & 0.38193716E-03_JPRB, 0.38213498E-03_JPRB, 0.38232098E-03_JPRB, 0.38269045E-03_JPRB, 0.38310778E-03_JPRB, 0.38355979E-03_JPRB, &
  & 0.38408845E-03_JPRB, 0.38447970E-03_JPRB, 0.38478938E-03_JPRB, 0.38505248E-03_JPRB, 0.38508623E-03_JPRB, 0.38507394E-03_JPRB, &
  & 0.38521489E-03_JPRB, 0.38525780E-03_JPRB, 0.38525901E-03_JPRB, 0.38520137E-03_JPRB, 0.38502020E-03_JPRB, 0.38464527E-03_JPRB, &
  & 0.38428033E-03_JPRB, 0.38389994E-03_JPRB, 0.38342706E-03_JPRB, 0.38295934E-03_JPRB, 0.38249240E-03_JPRB, 0.38207260E-03_JPRB, &
  & 0.38160428E-03_JPRB, 0.38116451E-03_JPRB, 0.38093672E-03_JPRB, 0.38093520E-03_JPRB, 0.38108213E-03_JPRB, 0.38128016E-03_JPRB, &
  & 0.38151459E-03_JPRB, 0.38184874E-03_JPRB, 0.38210881E-03_JPRB, 0.38235610E-03_JPRB, 0.38259125E-03_JPRB, 0.38280684E-03_JPRB, &
  & 0.38294239E-03_JPRB, 0.38309254E-03_JPRB, 0.38337449E-03_JPRB, 0.38347929E-03_JPRB, 0.38356400E-03_JPRB, 0.38394547E-03_JPRB, &
  & 0.38443901E-03_JPRB, 0.38433000E-03_JPRB, 0.38438878E-03_JPRB, 0.38438535E-03_JPRB  /)

RGHG1(:,53,11) = (/ &
  & 0.37068112E-03_JPRB, 0.37006707E-03_JPRB, 0.37055379E-03_JPRB, 0.37081269E-03_JPRB, 0.37129136E-03_JPRB, 0.37175800E-03_JPRB, &
  & 0.37286386E-03_JPRB, 0.37376504E-03_JPRB, 0.37455835E-03_JPRB, 0.37546503E-03_JPRB, 0.37628088E-03_JPRB, 0.37726604E-03_JPRB, &
  & 0.37840735E-03_JPRB, 0.37935472E-03_JPRB, 0.38009327E-03_JPRB, 0.38072923E-03_JPRB, 0.38118299E-03_JPRB, 0.38151622E-03_JPRB, &
  & 0.38180729E-03_JPRB, 0.38204150E-03_JPRB, 0.38224466E-03_JPRB, 0.38262942E-03_JPRB, 0.38303455E-03_JPRB, 0.38341172E-03_JPRB, &
  & 0.38392338E-03_JPRB, 0.38432767E-03_JPRB, 0.38469727E-03_JPRB, 0.38497016E-03_JPRB, 0.38497146E-03_JPRB, 0.38495504E-03_JPRB, &
  & 0.38509239E-03_JPRB, 0.38515385E-03_JPRB, 0.38515729E-03_JPRB, 0.38507115E-03_JPRB, 0.38488036E-03_JPRB, 0.38448843E-03_JPRB, &
  & 0.38413929E-03_JPRB, 0.38375598E-03_JPRB, 0.38330147E-03_JPRB, 0.38287599E-03_JPRB, 0.38240681E-03_JPRB, 0.38201363E-03_JPRB, &
  & 0.38156814E-03_JPRB, 0.38112374E-03_JPRB, 0.38091518E-03_JPRB, 0.38093082E-03_JPRB, 0.38109561E-03_JPRB, 0.38127029E-03_JPRB, &
  & 0.38150386E-03_JPRB, 0.38180711E-03_JPRB, 0.38202237E-03_JPRB, 0.38221008E-03_JPRB, 0.38237724E-03_JPRB, 0.38253034E-03_JPRB, &
  & 0.38266246E-03_JPRB, 0.38279321E-03_JPRB, 0.38299893E-03_JPRB, 0.38311369E-03_JPRB, 0.38315118E-03_JPRB, 0.38344595E-03_JPRB, &
  & 0.38393486E-03_JPRB, 0.38390002E-03_JPRB, 0.38379209E-03_JPRB, 0.38374162E-03_JPRB  /)

RGHG1(:,54,11) = (/ &
  & 0.37200112E-03_JPRB, 0.37147639E-03_JPRB, 0.37188400E-03_JPRB, 0.37208885E-03_JPRB, 0.37248368E-03_JPRB, 0.37281896E-03_JPRB, &
  & 0.37375253E-03_JPRB, 0.37460548E-03_JPRB, 0.37521351E-03_JPRB, 0.37589350E-03_JPRB, 0.37654327E-03_JPRB, 0.37734357E-03_JPRB, &
  & 0.37835314E-03_JPRB, 0.37927699E-03_JPRB, 0.38000567E-03_JPRB, 0.38063173E-03_JPRB, 0.38107452E-03_JPRB, 0.38143040E-03_JPRB, &
  & 0.38171890E-03_JPRB, 0.38196521E-03_JPRB, 0.38217725E-03_JPRB, 0.38253173E-03_JPRB, 0.38290485E-03_JPRB, 0.38323189E-03_JPRB, &
  & 0.38372528E-03_JPRB, 0.38414551E-03_JPRB, 0.38456439E-03_JPRB, 0.38485978E-03_JPRB, 0.38488468E-03_JPRB, 0.38487165E-03_JPRB, &
  & 0.38498965E-03_JPRB, 0.38504367E-03_JPRB, 0.38503677E-03_JPRB, 0.38491115E-03_JPRB, 0.38470023E-03_JPRB, 0.38431723E-03_JPRB, &
  & 0.38395698E-03_JPRB, 0.38358350E-03_JPRB, 0.38315872E-03_JPRB, 0.38277491E-03_JPRB, 0.38232108E-03_JPRB, 0.38193483E-03_JPRB, &
  & 0.38152073E-03_JPRB, 0.38109949E-03_JPRB, 0.38093736E-03_JPRB, 0.38097658E-03_JPRB, 0.38116811E-03_JPRB, 0.38135662E-03_JPRB, &
  & 0.38159834E-03_JPRB, 0.38188067E-03_JPRB, 0.38207779E-03_JPRB, 0.38226051E-03_JPRB, 0.38242089E-03_JPRB, 0.38257838E-03_JPRB, &
  & 0.38273233E-03_JPRB, 0.38290012E-03_JPRB, 0.38307511E-03_JPRB, 0.38315668E-03_JPRB, 0.38319240E-03_JPRB, 0.38341035E-03_JPRB, &
  & 0.38387598E-03_JPRB, 0.38392795E-03_JPRB, 0.38364078E-03_JPRB, 0.38358077E-03_JPRB  /)

RGHG1(:,55,11) = (/ &
  & 0.37348437E-03_JPRB, 0.37305891E-03_JPRB, 0.37338309E-03_JPRB, 0.37353348E-03_JPRB, 0.37384652E-03_JPRB, 0.37403607E-03_JPRB, &
  & 0.37476908E-03_JPRB, 0.37557940E-03_JPRB, 0.37599088E-03_JPRB, 0.37642150E-03_JPRB, 0.37689074E-03_JPRB, 0.37748520E-03_JPRB, &
  & 0.37833866E-03_JPRB, 0.37922535E-03_JPRB, 0.37993472E-03_JPRB, 0.38054074E-03_JPRB, 0.38096458E-03_JPRB, 0.38134306E-03_JPRB, &
  & 0.38162646E-03_JPRB, 0.38188297E-03_JPRB, 0.38210375E-03_JPRB, 0.38241870E-03_JPRB, 0.38275375E-03_JPRB, 0.38302850E-03_JPRB, &
  & 0.38350150E-03_JPRB, 0.38393976E-03_JPRB, 0.38441183E-03_JPRB, 0.38473382E-03_JPRB, 0.38479223E-03_JPRB, 0.38478394E-03_JPRB, &
  & 0.38487844E-03_JPRB, 0.38492080E-03_JPRB, 0.38490078E-03_JPRB, 0.38472999E-03_JPRB, 0.38449539E-03_JPRB, 0.38412569E-03_JPRB, &
  & 0.38374959E-03_JPRB, 0.38338868E-03_JPRB, 0.38299833E-03_JPRB, 0.38266060E-03_JPRB, 0.38222608E-03_JPRB, 0.38184494E-03_JPRB, &
  & 0.38146672E-03_JPRB, 0.38107481E-03_JPRB, 0.38096769E-03_JPRB, 0.38103387E-03_JPRB, 0.38125618E-03_JPRB, 0.38146492E-03_JPRB, &
  & 0.38171683E-03_JPRB, 0.38197731E-03_JPRB, 0.38215785E-03_JPRB, 0.38234221E-03_JPRB, 0.38250314E-03_JPRB, 0.38267429E-03_JPRB, &
  & 0.38285574E-03_JPRB, 0.38307198E-03_JPRB, 0.38321893E-03_JPRB, 0.38325806E-03_JPRB, 0.38329778E-03_JPRB, 0.38343194E-03_JPRB, &
  & 0.38386933E-03_JPRB, 0.38401912E-03_JPRB, 0.38353176E-03_JPRB, 0.38346610E-03_JPRB  /)

RGHG1(:,56,11) = (/ &
  & 0.37473775E-03_JPRB, 0.37438342E-03_JPRB, 0.37468875E-03_JPRB, 0.37483923E-03_JPRB, 0.37512855E-03_JPRB, 0.37526774E-03_JPRB, &
  & 0.37581168E-03_JPRB, 0.37655859E-03_JPRB, 0.37691740E-03_JPRB, 0.37721949E-03_JPRB, 0.37754763E-03_JPRB, 0.37798529E-03_JPRB, &
  & 0.37863781E-03_JPRB, 0.37940196E-03_JPRB, 0.38002914E-03_JPRB, 0.38055395E-03_JPRB, 0.38091764E-03_JPRB, 0.38127627E-03_JPRB, &
  & 0.38155486E-03_JPRB, 0.38180952E-03_JPRB, 0.38201462E-03_JPRB, 0.38228658E-03_JPRB, 0.38260100E-03_JPRB, 0.38287275E-03_JPRB, &
  & 0.38331086E-03_JPRB, 0.38377400E-03_JPRB, 0.38425713E-03_JPRB, 0.38459348E-03_JPRB, 0.38472288E-03_JPRB, 0.38474326E-03_JPRB, &
  & 0.38479014E-03_JPRB, 0.38480741E-03_JPRB, 0.38476335E-03_JPRB, 0.38456913E-03_JPRB, 0.38430773E-03_JPRB, 0.38396846E-03_JPRB, &
  & 0.38357285E-03_JPRB, 0.38323332E-03_JPRB, 0.38286628E-03_JPRB, 0.38256014E-03_JPRB, 0.38215072E-03_JPRB, 0.38179296E-03_JPRB, &
  & 0.38142027E-03_JPRB, 0.38107196E-03_JPRB, 0.38101564E-03_JPRB, 0.38111374E-03_JPRB, 0.38136342E-03_JPRB, 0.38161631E-03_JPRB, &
  & 0.38188474E-03_JPRB, 0.38215621E-03_JPRB, 0.38237480E-03_JPRB, 0.38260844E-03_JPRB, 0.38283251E-03_JPRB, 0.38307069E-03_JPRB, &
  & 0.38323704E-03_JPRB, 0.38350305E-03_JPRB, 0.38367547E-03_JPRB, 0.38372077E-03_JPRB, 0.38376777E-03_JPRB, 0.38387739E-03_JPRB, &
  & 0.38431714E-03_JPRB, 0.38449594E-03_JPRB, 0.38400616E-03_JPRB, 0.38395472E-03_JPRB  /)

RGHG1(:,57,11) = (/ &
  & 0.37597285E-03_JPRB, 0.37568643E-03_JPRB, 0.37597813E-03_JPRB, 0.37612660E-03_JPRB, 0.37638410E-03_JPRB, 0.37647677E-03_JPRB, &
  & 0.37685604E-03_JPRB, 0.37753652E-03_JPRB, 0.37784331E-03_JPRB, 0.37803176E-03_JPRB, 0.37823258E-03_JPRB, 0.37851886E-03_JPRB, &
  & 0.37897140E-03_JPRB, 0.37959500E-03_JPRB, 0.38013432E-03_JPRB, 0.38057549E-03_JPRB, 0.38087434E-03_JPRB, 0.38120658E-03_JPRB, &
  & 0.38147700E-03_JPRB, 0.38172846E-03_JPRB, 0.38191578E-03_JPRB, 0.38214956E-03_JPRB, 0.38244372E-03_JPRB, 0.38271140E-03_JPRB, &
  & 0.38312190E-03_JPRB, 0.38361309E-03_JPRB, 0.38410097E-03_JPRB, 0.38444367E-03_JPRB, 0.38464047E-03_JPRB, 0.38469227E-03_JPRB, &
  & 0.38470768E-03_JPRB, 0.38470467E-03_JPRB, 0.38463584E-03_JPRB, 0.38440926E-03_JPRB, 0.38412403E-03_JPRB, 0.38380544E-03_JPRB, &
  & 0.38339666E-03_JPRB, 0.38307389E-03_JPRB, 0.38273743E-03_JPRB, 0.38245970E-03_JPRB, 0.38207232E-03_JPRB, 0.38173389E-03_JPRB, &
  & 0.38136835E-03_JPRB, 0.38106575E-03_JPRB, 0.38105991E-03_JPRB, 0.38119406E-03_JPRB, 0.38147573E-03_JPRB, 0.38177542E-03_JPRB, &
  & 0.38206794E-03_JPRB, 0.38236061E-03_JPRB, 0.38261583E-03_JPRB, 0.38290304E-03_JPRB, 0.38318997E-03_JPRB, 0.38347806E-03_JPRB, &
  & 0.38364157E-03_JPRB, 0.38394772E-03_JPRB, 0.38413869E-03_JPRB, 0.38419740E-03_JPRB, 0.38425613E-03_JPRB, 0.38435451E-03_JPRB, &
  & 0.38478638E-03_JPRB, 0.38497746E-03_JPRB, 0.38449364E-03_JPRB, 0.38445566E-03_JPRB  /)

RGHG1(:,58,11) = (/ &
  & 0.37703464E-03_JPRB, 0.37679992E-03_JPRB, 0.37710004E-03_JPRB, 0.37725333E-03_JPRB, 0.37747878E-03_JPRB, 0.37755302E-03_JPRB, &
  & 0.37782423E-03_JPRB, 0.37843465E-03_JPRB, 0.37872169E-03_JPRB, 0.37885341E-03_JPRB, 0.37896782E-03_JPRB, 0.37913328E-03_JPRB, &
  & 0.37939513E-03_JPRB, 0.37984308E-03_JPRB, 0.38028020E-03_JPRB, 0.38062890E-03_JPRB, 0.38085250E-03_JPRB, 0.38114144E-03_JPRB, &
  & 0.38139872E-03_JPRB, 0.38164271E-03_JPRB, 0.38180555E-03_JPRB, 0.38201172E-03_JPRB, 0.38229113E-03_JPRB, 0.38256250E-03_JPRB, &
  & 0.38295721E-03_JPRB, 0.38348083E-03_JPRB, 0.38395453E-03_JPRB, 0.38428721E-03_JPRB, 0.38454697E-03_JPRB, 0.38463677E-03_JPRB, &
  & 0.38464604E-03_JPRB, 0.38462999E-03_JPRB, 0.38453506E-03_JPRB, 0.38426773E-03_JPRB, 0.38396501E-03_JPRB, 0.38365219E-03_JPRB, &
  & 0.38324133E-03_JPRB, 0.38292783E-03_JPRB, 0.38262965E-03_JPRB, 0.38236998E-03_JPRB, 0.38199877E-03_JPRB, 0.38167471E-03_JPRB, &
  & 0.38131276E-03_JPRB, 0.38105847E-03_JPRB, 0.38109772E-03_JPRB, 0.38127291E-03_JPRB, 0.38159117E-03_JPRB, 0.38194285E-03_JPRB, &
  & 0.38227148E-03_JPRB, 0.38260708E-03_JPRB, 0.38290380E-03_JPRB, 0.38325643E-03_JPRB, 0.38361247E-03_JPRB, 0.38392750E-03_JPRB, &
  & 0.38410113E-03_JPRB, 0.38442817E-03_JPRB, 0.38463456E-03_JPRB, 0.38472692E-03_JPRB, 0.38480456E-03_JPRB, 0.38492620E-03_JPRB, &
  & 0.38533925E-03_JPRB, 0.38550046E-03_JPRB, 0.38507336E-03_JPRB, 0.38505023E-03_JPRB  /)

RGHG1(:,59,11) = (/ &
  & 0.37791727E-03_JPRB, 0.37773005E-03_JPRB, 0.37804728E-03_JPRB, 0.37816979E-03_JPRB, 0.37835351E-03_JPRB, 0.37843695E-03_JPRB, &
  & 0.37863535E-03_JPRB, 0.37918197E-03_JPRB, 0.37946102E-03_JPRB, 0.37956102E-03_JPRB, 0.37962925E-03_JPRB, 0.37969876E-03_JPRB, &
  & 0.37981522E-03_JPRB, 0.38008816E-03_JPRB, 0.38042377E-03_JPRB, 0.38069536E-03_JPRB, 0.38085429E-03_JPRB, 0.38108189E-03_JPRB, &
  & 0.38132629E-03_JPRB, 0.38155867E-03_JPRB, 0.38169956E-03_JPRB, 0.38188384E-03_JPRB, 0.38214193E-03_JPRB, 0.38242393E-03_JPRB, &
  & 0.38281109E-03_JPRB, 0.38332772E-03_JPRB, 0.38380069E-03_JPRB, 0.38414692E-03_JPRB, 0.38444561E-03_JPRB, 0.38456182E-03_JPRB, &
  & 0.38456949E-03_JPRB, 0.38454755E-03_JPRB, 0.38443073E-03_JPRB, 0.38415601E-03_JPRB, 0.38385113E-03_JPRB, 0.38351530E-03_JPRB, &
  & 0.38310601E-03_JPRB, 0.38281422E-03_JPRB, 0.38253379E-03_JPRB, 0.38228618E-03_JPRB, 0.38191520E-03_JPRB, 0.38159815E-03_JPRB, &
  & 0.38125107E-03_JPRB, 0.38104024E-03_JPRB, 0.38112900E-03_JPRB, 0.38135083E-03_JPRB, 0.38170000E-03_JPRB, 0.38209755E-03_JPRB, &
  & 0.38248296E-03_JPRB, 0.38287299E-03_JPRB, 0.38320575E-03_JPRB, 0.38361470E-03_JPRB, 0.38402897E-03_JPRB, 0.38433975E-03_JPRB, &
  & 0.38454021E-03_JPRB, 0.38486288E-03_JPRB, 0.38507593E-03_JPRB, 0.38522259E-03_JPRB, 0.38531087E-03_JPRB, 0.38547039E-03_JPRB, &
  & 0.38586805E-03_JPRB, 0.38599949E-03_JPRB, 0.38563487E-03_JPRB, 0.38565614E-03_JPRB  /)

RGHG1(:,60,11) = (/ &
  & 0.37874509E-03_JPRB, 0.37860356E-03_JPRB, 0.37893878E-03_JPRB, 0.37901701E-03_JPRB, 0.37915271E-03_JPRB, 0.37925881E-03_JPRB, &
  & 0.37939636E-03_JPRB, 0.37988062E-03_JPRB, 0.38015512E-03_JPRB, 0.38022975E-03_JPRB, 0.38026759E-03_JPRB, 0.38024989E-03_JPRB, &
  & 0.38023850E-03_JPRB, 0.38033778E-03_JPRB, 0.38056822E-03_JPRB, 0.38076722E-03_JPRB, 0.38086695E-03_JPRB, 0.38102437E-03_JPRB, &
  & 0.38125437E-03_JPRB, 0.38147237E-03_JPRB, 0.38159447E-03_JPRB, 0.38175840E-03_JPRB, 0.38199151E-03_JPRB, 0.38228604E-03_JPRB, &
  & 0.38267002E-03_JPRB, 0.38316692E-03_JPRB, 0.38364410E-03_JPRB, 0.38401558E-03_JPRB, 0.38434305E-03_JPRB, 0.38447716E-03_JPRB, &
  & 0.38447788E-03_JPRB, 0.38445010E-03_JPRB, 0.38431622E-03_JPRB, 0.38405809E-03_JPRB, 0.38375963E-03_JPRB, 0.38338977E-03_JPRB, &
  & 0.38297859E-03_JPRB, 0.38270822E-03_JPRB, 0.38244239E-03_JPRB, 0.38220247E-03_JPRB, 0.38182681E-03_JPRB, 0.38151373E-03_JPRB, &
  & 0.38118772E-03_JPRB, 0.38101953E-03_JPRB, 0.38116313E-03_JPRB, 0.38143453E-03_JPRB, 0.38181288E-03_JPRB, 0.38225583E-03_JPRB, &
  & 0.38270841E-03_JPRB, 0.38315601E-03_JPRB, 0.38352603E-03_JPRB, 0.38398774E-03_JPRB, 0.38445386E-03_JPRB, 0.38474982E-03_JPRB, &
  & 0.38498011E-03_JPRB, 0.38528915E-03_JPRB, 0.38550934E-03_JPRB, 0.38572047E-03_JPRB, 0.38581625E-03_JPRB, 0.38601411E-03_JPRB, &
  & 0.38640031E-03_JPRB, 0.38650382E-03_JPRB, 0.38620581E-03_JPRB, 0.38628092E-03_JPRB  /)

RGHG1(:,61,11) = (/ &
  & 0.37944337E-03_JPRB, 0.37933823E-03_JPRB, 0.37968103E-03_JPRB, 0.37971221E-03_JPRB, 0.37979409E-03_JPRB, 0.37993915E-03_JPRB, &
  & 0.38002975E-03_JPRB, 0.38045957E-03_JPRB, 0.38072936E-03_JPRB, 0.38077693E-03_JPRB, 0.38080267E-03_JPRB, 0.38071588E-03_JPRB, &
  & 0.38061142E-03_JPRB, 0.38056954E-03_JPRB, 0.38069594E-03_JPRB, 0.38083303E-03_JPRB, 0.38089196E-03_JPRB, 0.38097732E-03_JPRB, &
  & 0.38118867E-03_JPRB, 0.38138852E-03_JPRB, 0.38150458E-03_JPRB, 0.38165035E-03_JPRB, 0.38185600E-03_JPRB, 0.38215996E-03_JPRB, &
  & 0.38254876E-03_JPRB, 0.38302711E-03_JPRB, 0.38351084E-03_JPRB, 0.38392138E-03_JPRB, 0.38426207E-03_JPRB, 0.38439116E-03_JPRB, &
  & 0.38435846E-03_JPRB, 0.38431684E-03_JPRB, 0.38418307E-03_JPRB, 0.38399443E-03_JPRB, 0.38371698E-03_JPRB, 0.38331002E-03_JPRB, &
  & 0.38287854E-03_JPRB, 0.38260910E-03_JPRB, 0.38236879E-03_JPRB, 0.38212508E-03_JPRB, 0.38174563E-03_JPRB, 0.38143285E-03_JPRB, &
  & 0.38113554E-03_JPRB, 0.38100600E-03_JPRB, 0.38121172E-03_JPRB, 0.38152955E-03_JPRB, 0.38193250E-03_JPRB, 0.38241943E-03_JPRB, &
  & 0.38294458E-03_JPRB, 0.38343873E-03_JPRB, 0.38385189E-03_JPRB, 0.38435491E-03_JPRB, 0.38485241E-03_JPRB, 0.38513238E-03_JPRB, &
  & 0.38537866E-03_JPRB, 0.38567048E-03_JPRB, 0.38590973E-03_JPRB, 0.38619036E-03_JPRB, 0.38629003E-03_JPRB, 0.38650337E-03_JPRB, &
  & 0.38689172E-03_JPRB, 0.38697915E-03_JPRB, 0.38674664E-03_JPRB, 0.38686797E-03_JPRB  /)

RGHG1(:,62,11) = (/ &
  & 0.38007217E-03_JPRB, 0.37999395E-03_JPRB, 0.38032804E-03_JPRB, 0.38033647E-03_JPRB, 0.38036525E-03_JPRB, 0.38054686E-03_JPRB, &
  & 0.38060176E-03_JPRB, 0.38098536E-03_JPRB, 0.38124922E-03_JPRB, 0.38125961E-03_JPRB, 0.38127082E-03_JPRB, 0.38113155E-03_JPRB, &
  & 0.38095321E-03_JPRB, 0.38079383E-03_JPRB, 0.38082417E-03_JPRB, 0.38089738E-03_JPRB, 0.38092392E-03_JPRB, 0.38094850E-03_JPRB, &
  & 0.38112784E-03_JPRB, 0.38131490E-03_JPRB, 0.38143184E-03_JPRB, 0.38157127E-03_JPRB, 0.38174682E-03_JPRB, 0.38204746E-03_JPRB, &
  & 0.38245140E-03_JPRB, 0.38292198E-03_JPRB, 0.38340938E-03_JPRB, 0.38386545E-03_JPRB, 0.38422442E-03_JPRB, 0.38435136E-03_JPRB, &
  & 0.38428752E-03_JPRB, 0.38422456E-03_JPRB, 0.38409507E-03_JPRB, 0.38395804E-03_JPRB, 0.38370812E-03_JPRB, 0.38327576E-03_JPRB, &
  & 0.38280855E-03_JPRB, 0.38252518E-03_JPRB, 0.38231978E-03_JPRB, 0.38206441E-03_JPRB, 0.38169069E-03_JPRB, 0.38137815E-03_JPRB, &
  & 0.38110394E-03_JPRB, 0.38102095E-03_JPRB, 0.38128507E-03_JPRB, 0.38164620E-03_JPRB, 0.38207294E-03_JPRB, 0.38260509E-03_JPRB, &
  & 0.38320051E-03_JPRB, 0.38372917E-03_JPRB, 0.38419347E-03_JPRB, 0.38472257E-03_JPRB, 0.38523870E-03_JPRB, 0.38550922E-03_JPRB, &
  & 0.38576252E-03_JPRB, 0.38604818E-03_JPRB, 0.38631364E-03_JPRB, 0.38664693E-03_JPRB, 0.38676375E-03_JPRB, 0.38698699E-03_JPRB, &
  & 0.38735670E-03_JPRB, 0.38743973E-03_JPRB, 0.38723907E-03_JPRB, 0.38737814E-03_JPRB  /)

RGHG1(:,63,11) = (/ &
  & 0.38065438E-03_JPRB, 0.38060114E-03_JPRB, 0.38091428E-03_JPRB, 0.38091855E-03_JPRB, 0.38089758E-03_JPRB, 0.38111009E-03_JPRB, &
  & 0.38113971E-03_JPRB, 0.38148251E-03_JPRB, 0.38174020E-03_JPRB, 0.38170714E-03_JPRB, 0.38169941E-03_JPRB, 0.38151630E-03_JPRB, &
  & 0.38127828E-03_JPRB, 0.38101710E-03_JPRB, 0.38095594E-03_JPRB, 0.38096491E-03_JPRB, 0.38096187E-03_JPRB, 0.38093513E-03_JPRB, &
  & 0.38107231E-03_JPRB, 0.38125178E-03_JPRB, 0.38137373E-03_JPRB, 0.38151321E-03_JPRB, 0.38166340E-03_JPRB, 0.38195107E-03_JPRB, &
  & 0.38236933E-03_JPRB, 0.38283564E-03_JPRB, 0.38332800E-03_JPRB, 0.38382649E-03_JPRB, 0.38419843E-03_JPRB, 0.38432311E-03_JPRB, &
  & 0.38424464E-03_JPRB, 0.38416016E-03_JPRB, 0.38403857E-03_JPRB, 0.38393945E-03_JPRB, 0.38371672E-03_JPRB, 0.38327377E-03_JPRB, &
  & 0.38276175E-03_JPRB, 0.38245591E-03_JPRB, 0.38228642E-03_JPRB, 0.38202093E-03_JPRB, 0.38165991E-03_JPRB, 0.38135016E-03_JPRB, &
  & 0.38109854E-03_JPRB, 0.38106654E-03_JPRB, 0.38138129E-03_JPRB, 0.38178075E-03_JPRB, 0.38223140E-03_JPRB, 0.38281189E-03_JPRB, &
  & 0.38347562E-03_JPRB, 0.38403048E-03_JPRB, 0.38455101E-03_JPRB, 0.38509757E-03_JPRB, 0.38562261E-03_JPRB, 0.38588879E-03_JPRB, &
  & 0.38614282E-03_JPRB, 0.38643138E-03_JPRB, 0.38672680E-03_JPRB, 0.38710002E-03_JPRB, 0.38724335E-03_JPRB, 0.38747426E-03_JPRB, &
  & 0.38781088E-03_JPRB, 0.38789108E-03_JPRB, 0.38770178E-03_JPRB, 0.38784034E-03_JPRB  /)

RGHG1(:,64,11) = (/ &
  & 0.38116886E-03_JPRB, 0.38114443E-03_JPRB, 0.38142372E-03_JPRB, 0.38144536E-03_JPRB, 0.38138426E-03_JPRB, 0.38161482E-03_JPRB, &
  & 0.38163457E-03_JPRB, 0.38194329E-03_JPRB, 0.38219572E-03_JPRB, 0.38211568E-03_JPRB, 0.38208127E-03_JPRB, 0.38186049E-03_JPRB, &
  & 0.38158088E-03_JPRB, 0.38123673E-03_JPRB, 0.38109081E-03_JPRB, 0.38103924E-03_JPRB, 0.38100616E-03_JPRB, 0.38094208E-03_JPRB, &
  & 0.38102713E-03_JPRB, 0.38120682E-03_JPRB, 0.38133674E-03_JPRB, 0.38148014E-03_JPRB, 0.38162047E-03_JPRB, 0.38188470E-03_JPRB, &
  & 0.38230409E-03_JPRB, 0.38276389E-03_JPRB, 0.38326723E-03_JPRB, 0.38379207E-03_JPRB, 0.38415807E-03_JPRB, 0.38427737E-03_JPRB, &
  & 0.38422368E-03_JPRB, 0.38412574E-03_JPRB, 0.38401648E-03_JPRB, 0.38393799E-03_JPRB, 0.38373387E-03_JPRB, 0.38330561E-03_JPRB, &
  & 0.38274382E-03_JPRB, 0.38241028E-03_JPRB, 0.38226815E-03_JPRB, 0.38200478E-03_JPRB, 0.38166361E-03_JPRB, 0.38136294E-03_JPRB, &
  & 0.38113755E-03_JPRB, 0.38115746E-03_JPRB, 0.38150529E-03_JPRB, 0.38193243E-03_JPRB, 0.38240719E-03_JPRB, 0.38304060E-03_JPRB, &
  & 0.38376744E-03_JPRB, 0.38433913E-03_JPRB, 0.38491818E-03_JPRB, 0.38547561E-03_JPRB, 0.38599808E-03_JPRB, 0.38626604E-03_JPRB, &
  & 0.38651437E-03_JPRB, 0.38681694E-03_JPRB, 0.38714318E-03_JPRB, 0.38754029E-03_JPRB, 0.38771882E-03_JPRB, 0.38795724E-03_JPRB, &
  & 0.38824745E-03_JPRB, 0.38831677E-03_JPRB, 0.38812186E-03_JPRB, 0.38824372E-03_JPRB  /)

RGHG1(:,65,11) = (/ &
  & 0.38161308E-03_JPRB, 0.38162947E-03_JPRB, 0.38186212E-03_JPRB, 0.38190827E-03_JPRB, 0.38182759E-03_JPRB, 0.38205265E-03_JPRB, &
  & 0.38207780E-03_JPRB, 0.38236460E-03_JPRB, 0.38261422E-03_JPRB, 0.38249227E-03_JPRB, 0.38242712E-03_JPRB, 0.38217266E-03_JPRB, &
  & 0.38185927E-03_JPRB, 0.38146283E-03_JPRB, 0.38123996E-03_JPRB, 0.38113406E-03_JPRB, 0.38106925E-03_JPRB, 0.38097413E-03_JPRB, &
  & 0.38100707E-03_JPRB, 0.38118771E-03_JPRB, 0.38133201E-03_JPRB, 0.38147248E-03_JPRB, 0.38161852E-03_JPRB, 0.38185320E-03_JPRB, &
  & 0.38224867E-03_JPRB, 0.38269785E-03_JPRB, 0.38320767E-03_JPRB, 0.38373683E-03_JPRB, 0.38408380E-03_JPRB, 0.38422199E-03_JPRB, &
  & 0.38419807E-03_JPRB, 0.38409910E-03_JPRB, 0.38400550E-03_JPRB, 0.38393537E-03_JPRB, 0.38375272E-03_JPRB, 0.38334677E-03_JPRB, &
  & 0.38275277E-03_JPRB, 0.38239686E-03_JPRB, 0.38226278E-03_JPRB, 0.38200688E-03_JPRB, 0.38169530E-03_JPRB, 0.38142862E-03_JPRB, &
  & 0.38123185E-03_JPRB, 0.38130866E-03_JPRB, 0.38166289E-03_JPRB, 0.38210709E-03_JPRB, 0.38261302E-03_JPRB, 0.38330288E-03_JPRB, &
  & 0.38406515E-03_JPRB, 0.38465785E-03_JPRB, 0.38528189E-03_JPRB, 0.38585675E-03_JPRB, 0.38636858E-03_JPRB, 0.38664274E-03_JPRB, &
  & 0.38688989E-03_JPRB, 0.38720689E-03_JPRB, 0.38756817E-03_JPRB, 0.38797702E-03_JPRB, 0.38819312E-03_JPRB, 0.38842502E-03_JPRB, &
  & 0.38868901E-03_JPRB, 0.38873965E-03_JPRB, 0.38854609E-03_JPRB, 0.38866552E-03_JPRB  /)

RGHG1(:,66,11) = (/ &
  & 0.38203005E-03_JPRB, 0.38208253E-03_JPRB, 0.38226952E-03_JPRB, 0.38233637E-03_JPRB, 0.38224515E-03_JPRB, 0.38245502E-03_JPRB, &
  & 0.38249220E-03_JPRB, 0.38276509E-03_JPRB, 0.38300865E-03_JPRB, 0.38285405E-03_JPRB, 0.38275811E-03_JPRB, 0.38247740E-03_JPRB, &
  & 0.38213031E-03_JPRB, 0.38169679E-03_JPRB, 0.38140453E-03_JPRB, 0.38124468E-03_JPRB, 0.38114709E-03_JPRB, 0.38102615E-03_JPRB, &
  & 0.38101205E-03_JPRB, 0.38118374E-03_JPRB, 0.38133718E-03_JPRB, 0.38147430E-03_JPRB, 0.38163020E-03_JPRB, 0.38183828E-03_JPRB, &
  & 0.38220318E-03_JPRB, 0.38264703E-03_JPRB, 0.38315358E-03_JPRB, 0.38366836E-03_JPRB, 0.38401360E-03_JPRB, 0.38417187E-03_JPRB, &
  & 0.38417625E-03_JPRB, 0.38408615E-03_JPRB, 0.38400542E-03_JPRB, 0.38394228E-03_JPRB, 0.38377197E-03_JPRB, 0.38338633E-03_JPRB, &
  & 0.38278515E-03_JPRB, 0.38241779E-03_JPRB, 0.38227630E-03_JPRB, 0.38201968E-03_JPRB, 0.38174498E-03_JPRB, 0.38152477E-03_JPRB, &
  & 0.38136354E-03_JPRB, 0.38149595E-03_JPRB, 0.38185028E-03_JPRB, 0.38231014E-03_JPRB, 0.38285064E-03_JPRB, 0.38359027E-03_JPRB, &
  & 0.38437119E-03_JPRB, 0.38499206E-03_JPRB, 0.38564984E-03_JPRB, 0.38624752E-03_JPRB, 0.38674730E-03_JPRB, 0.38703034E-03_JPRB, &
  & 0.38727610E-03_JPRB, 0.38760856E-03_JPRB, 0.38799788E-03_JPRB, 0.38841368E-03_JPRB, 0.38866508E-03_JPRB, 0.38888932E-03_JPRB, &
  & 0.38914456E-03_JPRB, 0.38918829E-03_JPRB, 0.38899859E-03_JPRB, 0.38911017E-03_JPRB  /)

RGHG1(:,67,11) = (/ &
  & 0.38242160E-03_JPRB, 0.38250041E-03_JPRB, 0.38264547E-03_JPRB, 0.38272469E-03_JPRB, 0.38263051E-03_JPRB, 0.38282122E-03_JPRB, &
  & 0.38287407E-03_JPRB, 0.38314030E-03_JPRB, 0.38337311E-03_JPRB, 0.38319759E-03_JPRB, 0.38307225E-03_JPRB, 0.38277433E-03_JPRB, &
  & 0.38239583E-03_JPRB, 0.38193639E-03_JPRB, 0.38158401E-03_JPRB, 0.38136988E-03_JPRB, 0.38123971E-03_JPRB, 0.38110020E-03_JPRB, &
  & 0.38104545E-03_JPRB, 0.38119444E-03_JPRB, 0.38134889E-03_JPRB, 0.38148153E-03_JPRB, 0.38164811E-03_JPRB, 0.38184039E-03_JPRB, &
  & 0.38217233E-03_JPRB, 0.38261531E-03_JPRB, 0.38310824E-03_JPRB, 0.38359650E-03_JPRB, 0.38395296E-03_JPRB, 0.38413103E-03_JPRB, &
  & 0.38416391E-03_JPRB, 0.38409079E-03_JPRB, 0.38401913E-03_JPRB, 0.38395762E-03_JPRB, 0.38378983E-03_JPRB, 0.38342614E-03_JPRB, &
  & 0.38284117E-03_JPRB, 0.38247246E-03_JPRB, 0.38231182E-03_JPRB, 0.38205252E-03_JPRB, 0.38181716E-03_JPRB, 0.38164845E-03_JPRB, &
  & 0.38152988E-03_JPRB, 0.38171491E-03_JPRB, 0.38206636E-03_JPRB, 0.38254506E-03_JPRB, 0.38312104E-03_JPRB, 0.38390155E-03_JPRB, &
  & 0.38468680E-03_JPRB, 0.38534135E-03_JPRB, 0.38602240E-03_JPRB, 0.38664666E-03_JPRB, 0.38713513E-03_JPRB, 0.38742713E-03_JPRB, &
  & 0.38766933E-03_JPRB, 0.38801728E-03_JPRB, 0.38842582E-03_JPRB, 0.38884598E-03_JPRB, 0.38912766E-03_JPRB, 0.38934779E-03_JPRB, &
  & 0.38960892E-03_JPRB, 0.38966152E-03_JPRB, 0.38948100E-03_JPRB, 0.38957008E-03_JPRB  /)

RGHG1(:,68,11) = (/ &
  & 0.38278998E-03_JPRB, 0.38287858E-03_JPRB, 0.38298795E-03_JPRB, 0.38306406E-03_JPRB, 0.38297322E-03_JPRB, 0.38315046E-03_JPRB, &
  & 0.38321793E-03_JPRB, 0.38348335E-03_JPRB, 0.38369878E-03_JPRB, 0.38351773E-03_JPRB, 0.38336626E-03_JPRB, 0.38306224E-03_JPRB, &
  & 0.38266048E-03_JPRB, 0.38217952E-03_JPRB, 0.38177879E-03_JPRB, 0.38150894E-03_JPRB, 0.38134850E-03_JPRB, 0.38120162E-03_JPRB, &
  & 0.38111360E-03_JPRB, 0.38122034E-03_JPRB, 0.38136409E-03_JPRB, 0.38148832E-03_JPRB, 0.38166147E-03_JPRB, 0.38186330E-03_JPRB, &
  & 0.38216520E-03_JPRB, 0.38260783E-03_JPRB, 0.38307693E-03_JPRB, 0.38354044E-03_JPRB, 0.38390495E-03_JPRB, 0.38410421E-03_JPRB, &
  & 0.38417117E-03_JPRB, 0.38411945E-03_JPRB, 0.38405240E-03_JPRB, 0.38397662E-03_JPRB, 0.38380295E-03_JPRB, 0.38347299E-03_JPRB, &
  & 0.38292152E-03_JPRB, 0.38255811E-03_JPRB, 0.38237421E-03_JPRB, 0.38212665E-03_JPRB, 0.38192353E-03_JPRB, 0.38179787E-03_JPRB, &
  & 0.38172892E-03_JPRB, 0.38196207E-03_JPRB, 0.38231099E-03_JPRB, 0.38281997E-03_JPRB, 0.38342806E-03_JPRB, 0.38423885E-03_JPRB, &
  & 0.38501812E-03_JPRB, 0.38570789E-03_JPRB, 0.38640379E-03_JPRB, 0.38705522E-03_JPRB, 0.38753632E-03_JPRB, 0.38783212E-03_JPRB, &
  & 0.38806533E-03_JPRB, 0.38842676E-03_JPRB, 0.38884462E-03_JPRB, 0.38927019E-03_JPRB, 0.38957260E-03_JPRB, 0.38979964E-03_JPRB, &
  & 0.39007504E-03_JPRB, 0.39015641E-03_JPRB, 0.38999731E-03_JPRB, 0.39003332E-03_JPRB  /)

RGHG1(:,69,11) = (/ &
  & 0.38314028E-03_JPRB, 0.38321330E-03_JPRB, 0.38329359E-03_JPRB, 0.38335255E-03_JPRB, 0.38327134E-03_JPRB, 0.38343961E-03_JPRB, &
  & 0.38351951E-03_JPRB, 0.38378328E-03_JPRB, 0.38398730E-03_JPRB, 0.38380943E-03_JPRB, 0.38363790E-03_JPRB, 0.38333250E-03_JPRB, &
  & 0.38292269E-03_JPRB, 0.38242942E-03_JPRB, 0.38199365E-03_JPRB, 0.38167208E-03_JPRB, 0.38148429E-03_JPRB, 0.38132796E-03_JPRB, &
  & 0.38120982E-03_JPRB, 0.38126227E-03_JPRB, 0.38138630E-03_JPRB, 0.38149658E-03_JPRB, 0.38166235E-03_JPRB, 0.38189500E-03_JPRB, &
  & 0.38219599E-03_JPRB, 0.38262822E-03_JPRB, 0.38308355E-03_JPRB, 0.38350566E-03_JPRB, 0.38386953E-03_JPRB, 0.38410170E-03_JPRB, &
  & 0.38418711E-03_JPRB, 0.38414895E-03_JPRB, 0.38407215E-03_JPRB, 0.38398251E-03_JPRB, 0.38381188E-03_JPRB, 0.38352361E-03_JPRB, &
  & 0.38303089E-03_JPRB, 0.38268492E-03_JPRB, 0.38247945E-03_JPRB, 0.38225715E-03_JPRB, 0.38207043E-03_JPRB, 0.38198174E-03_JPRB, &
  & 0.38196386E-03_JPRB, 0.38223800E-03_JPRB, 0.38259811E-03_JPRB, 0.38314019E-03_JPRB, 0.38377924E-03_JPRB, 0.38460008E-03_JPRB, &
  & 0.38538782E-03_JPRB, 0.38609595E-03_JPRB, 0.38680208E-03_JPRB, 0.38747722E-03_JPRB, 0.38794802E-03_JPRB, 0.38824385E-03_JPRB, &
  & 0.38846944E-03_JPRB, 0.38884664E-03_JPRB, 0.38925968E-03_JPRB, 0.38969884E-03_JPRB, 0.39000991E-03_JPRB, 0.39025161E-03_JPRB, &
  & 0.39054128E-03_JPRB, 0.39066547E-03_JPRB, 0.39055899E-03_JPRB, 0.39051450E-03_JPRB  /)

RGHG1(:,70,11) = (/ &
  & 0.38346895E-03_JPRB, 0.38351570E-03_JPRB, 0.38357533E-03_JPRB, 0.38361473E-03_JPRB, 0.38354398E-03_JPRB, 0.38370218E-03_JPRB, &
  & 0.38379343E-03_JPRB, 0.38405614E-03_JPRB, 0.38425334E-03_JPRB, 0.38408090E-03_JPRB, 0.38389083E-03_JPRB, 0.38358651E-03_JPRB, &
  & 0.38317748E-03_JPRB, 0.38267908E-03_JPRB, 0.38221916E-03_JPRB, 0.38185725E-03_JPRB, 0.38164029E-03_JPRB, 0.38146698E-03_JPRB, &
  & 0.38131897E-03_JPRB, 0.38131463E-03_JPRB, 0.38141226E-03_JPRB, 0.38151042E-03_JPRB, 0.38166716E-03_JPRB, 0.38193139E-03_JPRB, &
  & 0.38224524E-03_JPRB, 0.38266598E-03_JPRB, 0.38310249E-03_JPRB, 0.38347725E-03_JPRB, 0.38383695E-03_JPRB, 0.38410546E-03_JPRB, &
  & 0.38420308E-03_JPRB, 0.38416320E-03_JPRB, 0.38407274E-03_JPRB, 0.38398137E-03_JPRB, 0.38382209E-03_JPRB, 0.38357905E-03_JPRB, &
  & 0.38316133E-03_JPRB, 0.38283772E-03_JPRB, 0.38261695E-03_JPRB, 0.38241480E-03_JPRB, 0.38224129E-03_JPRB, 0.38218925E-03_JPRB, &
  & 0.38222637E-03_JPRB, 0.38253913E-03_JPRB, 0.38292118E-03_JPRB, 0.38348801E-03_JPRB, 0.38416064E-03_JPRB, 0.38498340E-03_JPRB, &
  & 0.38578367E-03_JPRB, 0.38649922E-03_JPRB, 0.38721294E-03_JPRB, 0.38791163E-03_JPRB, 0.38837008E-03_JPRB, 0.38866683E-03_JPRB, &
  & 0.38888433E-03_JPRB, 0.38928257E-03_JPRB, 0.38967782E-03_JPRB, 0.39013734E-03_JPRB, 0.39045363E-03_JPRB, 0.39071132E-03_JPRB, &
  & 0.39101008E-03_JPRB, 0.39118083E-03_JPRB, 0.39114114E-03_JPRB, 0.39102838E-03_JPRB  /)

RGHG1(:,71,11) = (/ &
  & 0.38377119E-03_JPRB, 0.38378597E-03_JPRB, 0.38383305E-03_JPRB, 0.38385429E-03_JPRB, 0.38379357E-03_JPRB, 0.38393922E-03_JPRB, &
  & 0.38404163E-03_JPRB, 0.38430421E-03_JPRB, 0.38449620E-03_JPRB, 0.38433057E-03_JPRB, 0.38412364E-03_JPRB, 0.38382151E-03_JPRB, &
  & 0.38342077E-03_JPRB, 0.38292588E-03_JPRB, 0.38245171E-03_JPRB, 0.38206274E-03_JPRB, 0.38181504E-03_JPRB, 0.38161741E-03_JPRB, &
  & 0.38143823E-03_JPRB, 0.38137803E-03_JPRB, 0.38144385E-03_JPRB, 0.38153302E-03_JPRB, 0.38168291E-03_JPRB, 0.38197019E-03_JPRB, &
  & 0.38230248E-03_JPRB, 0.38271413E-03_JPRB, 0.38312476E-03_JPRB, 0.38345206E-03_JPRB, 0.38380509E-03_JPRB, 0.38410989E-03_JPRB, &
  & 0.38421482E-03_JPRB, 0.38415750E-03_JPRB, 0.38405581E-03_JPRB, 0.38397540E-03_JPRB, 0.38383856E-03_JPRB, 0.38364555E-03_JPRB, &
  & 0.38330853E-03_JPRB, 0.38300371E-03_JPRB, 0.38277645E-03_JPRB, 0.38259063E-03_JPRB, 0.38243108E-03_JPRB, 0.38241765E-03_JPRB, &
  & 0.38251180E-03_JPRB, 0.38286349E-03_JPRB, 0.38327329E-03_JPRB, 0.38385904E-03_JPRB, 0.38456829E-03_JPRB, 0.38538857E-03_JPRB, &
  & 0.38620073E-03_JPRB, 0.38691808E-03_JPRB, 0.38763617E-03_JPRB, 0.38835528E-03_JPRB, 0.38880117E-03_JPRB, 0.38910203E-03_JPRB, &
  & 0.38931244E-03_JPRB, 0.38973345E-03_JPRB, 0.39009993E-03_JPRB, 0.39058680E-03_JPRB, 0.39090624E-03_JPRB, 0.39117775E-03_JPRB, &
  & 0.39148349E-03_JPRB, 0.39169931E-03_JPRB, 0.39173116E-03_JPRB, 0.39156988E-03_JPRB  /)

RGHG1(:,72,11) = (/ &
  & 0.38403888E-03_JPRB, 0.38402232E-03_JPRB, 0.38406409E-03_JPRB, 0.38407358E-03_JPRB, 0.38402116E-03_JPRB, 0.38415022E-03_JPRB, &
  & 0.38426507E-03_JPRB, 0.38452880E-03_JPRB, 0.38471181E-03_JPRB, 0.38455401E-03_JPRB, 0.38433325E-03_JPRB, 0.38403227E-03_JPRB, &
  & 0.38364628E-03_JPRB, 0.38316707E-03_JPRB, 0.38268736E-03_JPRB, 0.38228687E-03_JPRB, 0.38200829E-03_JPRB, 0.38178024E-03_JPRB, &
  & 0.38156603E-03_JPRB, 0.38145535E-03_JPRB, 0.38148568E-03_JPRB, 0.38157001E-03_JPRB, 0.38172014E-03_JPRB, 0.38200810E-03_JPRB, &
  & 0.38235191E-03_JPRB, 0.38276172E-03_JPRB, 0.38313847E-03_JPRB, 0.38342705E-03_JPRB, 0.38377179E-03_JPRB, 0.38410793E-03_JPRB, &
  & 0.38421586E-03_JPRB, 0.38412558E-03_JPRB, 0.38402528E-03_JPRB, 0.38396745E-03_JPRB, 0.38387001E-03_JPRB, 0.38373555E-03_JPRB, &
  & 0.38346674E-03_JPRB, 0.38316216E-03_JPRB, 0.38294135E-03_JPRB, 0.38277443E-03_JPRB, 0.38263470E-03_JPRB, 0.38266529E-03_JPRB, &
  & 0.38281452E-03_JPRB, 0.38320977E-03_JPRB, 0.38364446E-03_JPRB, 0.38425049E-03_JPRB, 0.38499962E-03_JPRB, 0.38581759E-03_JPRB, &
  & 0.38663413E-03_JPRB, 0.38735654E-03_JPRB, 0.38807418E-03_JPRB, 0.38880411E-03_JPRB, 0.38924056E-03_JPRB, 0.38955225E-03_JPRB, &
  & 0.38975990E-03_JPRB, 0.39019796E-03_JPRB, 0.39052803E-03_JPRB, 0.39105016E-03_JPRB, 0.39137144E-03_JPRB, 0.39164917E-03_JPRB, &
  & 0.39196690E-03_JPRB, 0.39221844E-03_JPRB, 0.39231229E-03_JPRB, 0.39212865E-03_JPRB  /)

RGHG1(:,73,11) = (/ &
  & 0.38425539E-03_JPRB, 0.38421650E-03_JPRB, 0.38425787E-03_JPRB, 0.38426431E-03_JPRB, 0.38421894E-03_JPRB, 0.38433281E-03_JPRB, &
  & 0.38446254E-03_JPRB, 0.38472293E-03_JPRB, 0.38488856E-03_JPRB, 0.38473757E-03_JPRB, 0.38451231E-03_JPRB, 0.38421078E-03_JPRB, &
  & 0.38384647E-03_JPRB, 0.38339885E-03_JPRB, 0.38292898E-03_JPRB, 0.38253037E-03_JPRB, 0.38222780E-03_JPRB, 0.38197043E-03_JPRB, &
  & 0.38172248E-03_JPRB, 0.38157366E-03_JPRB, 0.38156765E-03_JPRB, 0.38164497E-03_JPRB, 0.38179468E-03_JPRB, 0.38206538E-03_JPRB, &
  & 0.38240367E-03_JPRB, 0.38279494E-03_JPRB, 0.38313055E-03_JPRB, 0.38339815E-03_JPRB, 0.38373433E-03_JPRB, 0.38407954E-03_JPRB, &
  & 0.38418749E-03_JPRB, 0.38406064E-03_JPRB, 0.38397884E-03_JPRB, 0.38396341E-03_JPRB, 0.38392123E-03_JPRB, 0.38384800E-03_JPRB, &
  & 0.38363155E-03_JPRB, 0.38332634E-03_JPRB, 0.38312529E-03_JPRB, 0.38299491E-03_JPRB, 0.38291041E-03_JPRB, 0.38298763E-03_JPRB, &
  & 0.38317258E-03_JPRB, 0.38362084E-03_JPRB, 0.38406645E-03_JPRB, 0.38470015E-03_JPRB, 0.38547483E-03_JPRB, 0.38628365E-03_JPRB, &
  & 0.38709838E-03_JPRB, 0.38781392E-03_JPRB, 0.38853772E-03_JPRB, 0.38926957E-03_JPRB, 0.38969565E-03_JPRB, 0.39001824E-03_JPRB, &
  & 0.39023124E-03_JPRB, 0.39066506E-03_JPRB, 0.39096642E-03_JPRB, 0.39151781E-03_JPRB, 0.39183517E-03_JPRB, 0.39210611E-03_JPRB, &
  & 0.39244402E-03_JPRB, 0.39272294E-03_JPRB, 0.39285112E-03_JPRB, 0.39266724E-03_JPRB  /)

RGHG1(:,74,11) = (/ &
  & 0.38443202E-03_JPRB, 0.38437813E-03_JPRB, 0.38442339E-03_JPRB, 0.38443197E-03_JPRB, 0.38439230E-03_JPRB, 0.38449487E-03_JPRB, &
  & 0.38464243E-03_JPRB, 0.38489258E-03_JPRB, 0.38503582E-03_JPRB, 0.38489183E-03_JPRB, 0.38466760E-03_JPRB, 0.38436927E-03_JPRB, &
  & 0.38403012E-03_JPRB, 0.38361860E-03_JPRB, 0.38316876E-03_JPRB, 0.38277748E-03_JPRB, 0.38245762E-03_JPRB, 0.38218067E-03_JPRB, &
  & 0.38190246E-03_JPRB, 0.38172409E-03_JPRB, 0.38169132E-03_JPRB, 0.38177496E-03_JPRB, 0.38191224E-03_JPRB, 0.38214454E-03_JPRB, &
  & 0.38245974E-03_JPRB, 0.38281647E-03_JPRB, 0.38311094E-03_JPRB, 0.38336159E-03_JPRB, 0.38368739E-03_JPRB, 0.38402878E-03_JPRB, &
  & 0.38413789E-03_JPRB, 0.38398144E-03_JPRB, 0.38392875E-03_JPRB, 0.38395928E-03_JPRB, 0.38397071E-03_JPRB, 0.38395692E-03_JPRB, &
  & 0.38379436E-03_JPRB, 0.38349598E-03_JPRB, 0.38332106E-03_JPRB, 0.38325080E-03_JPRB, 0.38323962E-03_JPRB, 0.38337074E-03_JPRB, &
  & 0.38360116E-03_JPRB, 0.38408048E-03_JPRB, 0.38454153E-03_JPRB, 0.38518971E-03_JPRB, 0.38597912E-03_JPRB, 0.38677583E-03_JPRB, &
  & 0.38758297E-03_JPRB, 0.38829035E-03_JPRB, 0.38901920E-03_JPRB, 0.38974205E-03_JPRB, 0.39015965E-03_JPRB, 0.39049173E-03_JPRB, &
  & 0.39071089E-03_JPRB, 0.39112854E-03_JPRB, 0.39141439E-03_JPRB, 0.39198741E-03_JPRB, 0.39229689E-03_JPRB, 0.39254910E-03_JPRB, &
  & 0.39290313E-03_JPRB, 0.39320548E-03_JPRB, 0.39334546E-03_JPRB, 0.39316111E-03_JPRB  /)

RGHG1(:,75,11) = (/ &
  & 0.38457049E-03_JPRB, 0.38451030E-03_JPRB, 0.38456331E-03_JPRB, 0.38457735E-03_JPRB, 0.38454222E-03_JPRB, 0.38463652E-03_JPRB, &
  & 0.38480353E-03_JPRB, 0.38503644E-03_JPRB, 0.38515430E-03_JPRB, 0.38501729E-03_JPRB, 0.38479798E-03_JPRB, 0.38450721E-03_JPRB, &
  & 0.38419555E-03_JPRB, 0.38382285E-03_JPRB, 0.38340144E-03_JPRB, 0.38302102E-03_JPRB, 0.38269323E-03_JPRB, 0.38240604E-03_JPRB, &
  & 0.38210237E-03_JPRB, 0.38190378E-03_JPRB, 0.38185138E-03_JPRB, 0.38195097E-03_JPRB, 0.38206658E-03_JPRB, 0.38224319E-03_JPRB, &
  & 0.38251897E-03_JPRB, 0.38282653E-03_JPRB, 0.38308244E-03_JPRB, 0.38332167E-03_JPRB, 0.38363393E-03_JPRB, 0.38396290E-03_JPRB, &
  & 0.38407345E-03_JPRB, 0.38389444E-03_JPRB, 0.38387796E-03_JPRB, 0.38395442E-03_JPRB, 0.38401226E-03_JPRB, 0.38405264E-03_JPRB, &
  & 0.38394308E-03_JPRB, 0.38366509E-03_JPRB, 0.38351803E-03_JPRB, 0.38352381E-03_JPRB, 0.38360570E-03_JPRB, 0.38379584E-03_JPRB, &
  & 0.38407656E-03_JPRB, 0.38457182E-03_JPRB, 0.38505294E-03_JPRB, 0.38570267E-03_JPRB, 0.38649855E-03_JPRB, 0.38728757E-03_JPRB, &
  & 0.38808629E-03_JPRB, 0.38878503E-03_JPRB, 0.38951475E-03_JPRB, 0.39021774E-03_JPRB, 0.39063003E-03_JPRB, 0.39096753E-03_JPRB, &
  & 0.39119249E-03_JPRB, 0.39158553E-03_JPRB, 0.39186760E-03_JPRB, 0.39245252E-03_JPRB, 0.39274965E-03_JPRB, 0.39297745E-03_JPRB, &
  & 0.39333728E-03_JPRB, 0.39365872E-03_JPRB, 0.39379235E-03_JPRB, 0.39360482E-03_JPRB  /)

RGHG1(:,76,11) = (/ &
  & 0.38467134E-03_JPRB, 0.38461623E-03_JPRB, 0.38468030E-03_JPRB, 0.38470080E-03_JPRB, 0.38466935E-03_JPRB, 0.38475673E-03_JPRB, &
  & 0.38494265E-03_JPRB, 0.38515135E-03_JPRB, 0.38524340E-03_JPRB, 0.38511284E-03_JPRB, 0.38490045E-03_JPRB, 0.38462190E-03_JPRB, &
  & 0.38433882E-03_JPRB, 0.38400669E-03_JPRB, 0.38362032E-03_JPRB, 0.38325259E-03_JPRB, 0.38293056E-03_JPRB, 0.38264083E-03_JPRB, &
  & 0.38231826E-03_JPRB, 0.38211068E-03_JPRB, 0.38204052E-03_JPRB, 0.38215786E-03_JPRB, 0.38224834E-03_JPRB, 0.38235787E-03_JPRB, &
  & 0.38257948E-03_JPRB, 0.38282480E-03_JPRB, 0.38304775E-03_JPRB, 0.38328559E-03_JPRB, 0.38357918E-03_JPRB, 0.38389224E-03_JPRB, &
  & 0.38400256E-03_JPRB, 0.38380673E-03_JPRB, 0.38382920E-03_JPRB, 0.38394831E-03_JPRB, 0.38403912E-03_JPRB, 0.38412352E-03_JPRB, &
  & 0.38405984E-03_JPRB, 0.38382473E-03_JPRB, 0.38370095E-03_JPRB, 0.38378626E-03_JPRB, 0.38398687E-03_JPRB, 0.38423741E-03_JPRB, &
  & 0.38456146E-03_JPRB, 0.38507264E-03_JPRB, 0.38557611E-03_JPRB, 0.38621755E-03_JPRB, 0.38701504E-03_JPRB, 0.38781189E-03_JPRB, &
  & 0.38860923E-03_JPRB, 0.38929852E-03_JPRB, 0.39002109E-03_JPRB, 0.39069342E-03_JPRB, 0.39110525E-03_JPRB, 0.39143999E-03_JPRB, &
  & 0.39166955E-03_JPRB, 0.39203355E-03_JPRB, 0.39232069E-03_JPRB, 0.39290446E-03_JPRB, 0.39318361E-03_JPRB, 0.39339090E-03_JPRB, &
  & 0.39373781E-03_JPRB, 0.39407262E-03_JPRB, 0.39418758E-03_JPRB, 0.39399337E-03_JPRB  /)

RGHG1(:,77,11) = (/ &
  & 0.38474037E-03_JPRB, 0.38469706E-03_JPRB, 0.38477346E-03_JPRB, 0.38480028E-03_JPRB, 0.38477191E-03_JPRB, 0.38485272E-03_JPRB, &
  & 0.38504806E-03_JPRB, 0.38523221E-03_JPRB, 0.38530273E-03_JPRB, 0.38517916E-03_JPRB, 0.38497444E-03_JPRB, 0.38471006E-03_JPRB, &
  & 0.38445087E-03_JPRB, 0.38416056E-03_JPRB, 0.38380862E-03_JPRB, 0.38345929E-03_JPRB, 0.38315087E-03_JPRB, 0.38286300E-03_JPRB, &
  & 0.38253456E-03_JPRB, 0.38231809E-03_JPRB, 0.38223525E-03_JPRB, 0.38232292E-03_JPRB, 0.38238259E-03_JPRB, 0.38244182E-03_JPRB, &
  & 0.38260759E-03_JPRB, 0.38280530E-03_JPRB, 0.38300701E-03_JPRB, 0.38324412E-03_JPRB, 0.38352543E-03_JPRB, 0.38383255E-03_JPRB, &
  & 0.38394885E-03_JPRB, 0.38374127E-03_JPRB, 0.38379261E-03_JPRB, 0.38394699E-03_JPRB, 0.38405726E-03_JPRB, 0.38417014E-03_JPRB, &
  & 0.38413325E-03_JPRB, 0.38394052E-03_JPRB, 0.38384235E-03_JPRB, 0.38400367E-03_JPRB, 0.38433112E-03_JPRB, 0.38460988E-03_JPRB, &
  & 0.38497878E-03_JPRB, 0.38551008E-03_JPRB, 0.38604821E-03_JPRB, 0.38669963E-03_JPRB, 0.38750785E-03_JPRB, 0.38832263E-03_JPRB, &
  & 0.38913187E-03_JPRB, 0.38982422E-03_JPRB, 0.39053422E-03_JPRB, 0.39118521E-03_JPRB, 0.39159081E-03_JPRB, 0.39192052E-03_JPRB, &
  & 0.39214389E-03_JPRB, 0.39246468E-03_JPRB, 0.39276540E-03_JPRB, 0.39334555E-03_JPRB, 0.39358407E-03_JPRB, 0.39376146E-03_JPRB, &
  & 0.39407621E-03_JPRB, 0.39442502E-03_JPRB, 0.39454743E-03_JPRB, 0.39436107E-03_JPRB  /)

RGHG1(:,78,11) = (/ &
  & 0.38479411E-03_JPRB, 0.38476143E-03_JPRB, 0.38484989E-03_JPRB, 0.38488360E-03_JPRB, 0.38485901E-03_JPRB, 0.38493121E-03_JPRB, &
  & 0.38513006E-03_JPRB, 0.38529537E-03_JPRB, 0.38534809E-03_JPRB, 0.38522899E-03_JPRB, 0.38503256E-03_JPRB, 0.38478092E-03_JPRB, &
  & 0.38453725E-03_JPRB, 0.38428126E-03_JPRB, 0.38396492E-03_JPRB, 0.38363617E-03_JPRB, 0.38333847E-03_JPRB, 0.38304840E-03_JPRB, &
  & 0.38271186E-03_JPRB, 0.38249320E-03_JPRB, 0.38238880E-03_JPRB, 0.38244341E-03_JPRB, 0.38248203E-03_JPRB, 0.38251047E-03_JPRB, &
  & 0.38262380E-03_JPRB, 0.38278038E-03_JPRB, 0.38295845E-03_JPRB, 0.38319382E-03_JPRB, 0.38347526E-03_JPRB, 0.38378401E-03_JPRB, &
  & 0.38390912E-03_JPRB, 0.38369576E-03_JPRB, 0.38376700E-03_JPRB, 0.38394884E-03_JPRB, 0.38407331E-03_JPRB, 0.38420701E-03_JPRB, &
  & 0.38418523E-03_JPRB, 0.38402356E-03_JPRB, 0.38395296E-03_JPRB, 0.38419189E-03_JPRB, 0.38462166E-03_JPRB, 0.38492632E-03_JPRB, &
  & 0.38535795E-03_JPRB, 0.38593105E-03_JPRB, 0.38647751E-03_JPRB, 0.38713410E-03_JPRB, 0.38797058E-03_JPRB, 0.38881863E-03_JPRB, &
  & 0.38964283E-03_JPRB, 0.39033802E-03_JPRB, 0.39103535E-03_JPRB, 0.39166054E-03_JPRB, 0.39206792E-03_JPRB, 0.39238553E-03_JPRB, &
  & 0.39260289E-03_JPRB, 0.39287406E-03_JPRB, 0.39317822E-03_JPRB, 0.39374855E-03_JPRB, 0.39394757E-03_JPRB, 0.39410178E-03_JPRB, &
  & 0.39438610E-03_JPRB, 0.39473391E-03_JPRB, 0.39487408E-03_JPRB, 0.39469382E-03_JPRB  /)

RGHG1(:,79,11) = (/ &
  & 0.38483595E-03_JPRB, 0.38481124E-03_JPRB, 0.38491034E-03_JPRB, 0.38495146E-03_JPRB, 0.38493178E-03_JPRB, 0.38499439E-03_JPRB, &
  & 0.38519171E-03_JPRB, 0.38534378E-03_JPRB, 0.38538383E-03_JPRB, 0.38526745E-03_JPRB, 0.38507776E-03_JPRB, 0.38483424E-03_JPRB, &
  & 0.38459770E-03_JPRB, 0.38436600E-03_JPRB, 0.38408140E-03_JPRB, 0.38377177E-03_JPRB, 0.38348340E-03_JPRB, 0.38319120E-03_JPRB, &
  & 0.38284677E-03_JPRB, 0.38263336E-03_JPRB, 0.38250629E-03_JPRB, 0.38253128E-03_JPRB, 0.38255777E-03_JPRB, 0.38256738E-03_JPRB, &
  & 0.38263445E-03_JPRB, 0.38275915E-03_JPRB, 0.38291528E-03_JPRB, 0.38314678E-03_JPRB, 0.38343311E-03_JPRB, 0.38374734E-03_JPRB, &
  & 0.38388110E-03_JPRB, 0.38366527E-03_JPRB, 0.38375069E-03_JPRB, 0.38395283E-03_JPRB, 0.38408638E-03_JPRB, 0.38423783E-03_JPRB, &
  & 0.38422397E-03_JPRB, 0.38408355E-03_JPRB, 0.38403904E-03_JPRB, 0.38435050E-03_JPRB, 0.38485470E-03_JPRB, 0.38519225E-03_JPRB, &
  & 0.38569142E-03_JPRB, 0.38631958E-03_JPRB, 0.38686485E-03_JPRB, 0.38752529E-03_JPRB, 0.38840385E-03_JPRB, 0.38929185E-03_JPRB, &
  & 0.39013487E-03_JPRB, 0.39083201E-03_JPRB, 0.39151726E-03_JPRB, 0.39212110E-03_JPRB, 0.39253793E-03_JPRB, 0.39283977E-03_JPRB, &
  & 0.39304535E-03_JPRB, 0.39326617E-03_JPRB, 0.39355913E-03_JPRB, 0.39411219E-03_JPRB, 0.39427555E-03_JPRB, 0.39441096E-03_JPRB, &
  & 0.39467008E-03_JPRB, 0.39500550E-03_JPRB, 0.39516233E-03_JPRB, 0.39499129E-03_JPRB  /)

RGHG1(:,80,11) = (/ &
  & 0.38486894E-03_JPRB, 0.38484837E-03_JPRB, 0.38495560E-03_JPRB, 0.38500453E-03_JPRB, 0.38499125E-03_JPRB, 0.38504463E-03_JPRB, &
  & 0.38523626E-03_JPRB, 0.38537999E-03_JPRB, 0.38541402E-03_JPRB, 0.38529976E-03_JPRB, 0.38511285E-03_JPRB, 0.38486959E-03_JPRB, &
  & 0.38463221E-03_JPRB, 0.38441278E-03_JPRB, 0.38415032E-03_JPRB, 0.38385455E-03_JPRB, 0.38357651E-03_JPRB, 0.38328754E-03_JPRB, &
  & 0.38293914E-03_JPRB, 0.38273853E-03_JPRB, 0.38259724E-03_JPRB, 0.38260074E-03_JPRB, 0.38262203E-03_JPRB, 0.38261566E-03_JPRB, &
  & 0.38264542E-03_JPRB, 0.38275097E-03_JPRB, 0.38289229E-03_JPRB, 0.38311663E-03_JPRB, 0.38340345E-03_JPRB, 0.38372307E-03_JPRB, &
  & 0.38386218E-03_JPRB, 0.38364405E-03_JPRB, 0.38374166E-03_JPRB, 0.38395794E-03_JPRB, 0.38409520E-03_JPRB, 0.38426586E-03_JPRB, &
  & 0.38425748E-03_JPRB, 0.38413117E-03_JPRB, 0.38410735E-03_JPRB, 0.38447862E-03_JPRB, 0.38502829E-03_JPRB, 0.38541419E-03_JPRB, &
  & 0.38596980E-03_JPRB, 0.38665535E-03_JPRB, 0.38721124E-03_JPRB, 0.38787945E-03_JPRB, 0.38880860E-03_JPRB, 0.38973285E-03_JPRB, &
  & 0.39060009E-03_JPRB, 0.39129840E-03_JPRB, 0.39197242E-03_JPRB, 0.39257007E-03_JPRB, 0.39300278E-03_JPRB, 0.39328935E-03_JPRB, &
  & 0.39347050E-03_JPRB, 0.39364619E-03_JPRB, 0.39390988E-03_JPRB, 0.39443736E-03_JPRB, 0.39457043E-03_JPRB, 0.39468777E-03_JPRB, &
  & 0.39492928E-03_JPRB, 0.39524636E-03_JPRB, 0.39540712E-03_JPRB, 0.39525444E-03_JPRB  /)

RGHG1(:,81,11) = (/ &
  & 0.38489039E-03_JPRB, 0.38487267E-03_JPRB, 0.38498108E-03_JPRB, 0.38503807E-03_JPRB, 0.38503309E-03_JPRB, 0.38508078E-03_JPRB, &
  & 0.38526245E-03_JPRB, 0.38540381E-03_JPRB, 0.38543642E-03_JPRB, 0.38532002E-03_JPRB, 0.38513312E-03_JPRB, 0.38488725E-03_JPRB, &
  & 0.38464347E-03_JPRB, 0.38442759E-03_JPRB, 0.38417936E-03_JPRB, 0.38389094E-03_JPRB, 0.38362380E-03_JPRB, 0.38333721E-03_JPRB, &
  & 0.38299046E-03_JPRB, 0.38280811E-03_JPRB, 0.38267013E-03_JPRB, 0.38266296E-03_JPRB, 0.38267216E-03_JPRB, 0.38266058E-03_JPRB, &
  & 0.38266165E-03_JPRB, 0.38275488E-03_JPRB, 0.38289075E-03_JPRB, 0.38311059E-03_JPRB, 0.38339551E-03_JPRB, 0.38371181E-03_JPRB, &
  & 0.38385068E-03_JPRB, 0.38362971E-03_JPRB, 0.38373846E-03_JPRB, 0.38395877E-03_JPRB, 0.38409650E-03_JPRB, 0.38429347E-03_JPRB, &
  & 0.38429340E-03_JPRB, 0.38417348E-03_JPRB, 0.38416839E-03_JPRB, 0.38457284E-03_JPRB, 0.38514954E-03_JPRB, 0.38557502E-03_JPRB, &
  & 0.38617330E-03_JPRB, 0.38689916E-03_JPRB, 0.38750008E-03_JPRB, 0.38819887E-03_JPRB, 0.38919321E-03_JPRB, 0.39015705E-03_JPRB, &
  & 0.39104041E-03_JPRB, 0.39173777E-03_JPRB, 0.39241818E-03_JPRB, 0.39302769E-03_JPRB, 0.39345495E-03_JPRB, 0.39373441E-03_JPRB, &
  & 0.39386008E-03_JPRB, 0.39400022E-03_JPRB, 0.39422361E-03_JPRB, 0.39471222E-03_JPRB, 0.39481257E-03_JPRB, 0.39490597E-03_JPRB, &
  & 0.39514179E-03_JPRB, 0.39543777E-03_JPRB, 0.39558124E-03_JPRB, 0.39548734E-03_JPRB  /)

RGHG1(:,82,11) = (/ &
  & 0.38490142E-03_JPRB, 0.38489077E-03_JPRB, 0.38499742E-03_JPRB, 0.38506029E-03_JPRB, 0.38506307E-03_JPRB, 0.38510886E-03_JPRB, &
  & 0.38528178E-03_JPRB, 0.38542112E-03_JPRB, 0.38545410E-03_JPRB, 0.38533542E-03_JPRB, 0.38514721E-03_JPRB, 0.38489745E-03_JPRB, &
  & 0.38464796E-03_JPRB, 0.38443317E-03_JPRB, 0.38419515E-03_JPRB, 0.38391436E-03_JPRB, 0.38365658E-03_JPRB, 0.38337300E-03_JPRB, &
  & 0.38303231E-03_JPRB, 0.38286809E-03_JPRB, 0.38273586E-03_JPRB, 0.38272251E-03_JPRB, 0.38272116E-03_JPRB, 0.38270766E-03_JPRB, &
  & 0.38268808E-03_JPRB, 0.38277330E-03_JPRB, 0.38290555E-03_JPRB, 0.38311911E-03_JPRB, 0.38339268E-03_JPRB, 0.38370846E-03_JPRB, &
  & 0.38384416E-03_JPRB, 0.38361644E-03_JPRB, 0.38373512E-03_JPRB, 0.38395763E-03_JPRB, 0.38409535E-03_JPRB, 0.38431846E-03_JPRB, &
  & 0.38433071E-03_JPRB, 0.38421307E-03_JPRB, 0.38422201E-03_JPRB, 0.38465014E-03_JPRB, 0.38524682E-03_JPRB, 0.38570331E-03_JPRB, &
  & 0.38633125E-03_JPRB, 0.38709567E-03_JPRB, 0.38773890E-03_JPRB, 0.38847853E-03_JPRB, 0.38953715E-03_JPRB, 0.39054800E-03_JPRB, &
  & 0.39144051E-03_JPRB, 0.39213187E-03_JPRB, 0.39282452E-03_JPRB, 0.39344417E-03_JPRB, 0.39386471E-03_JPRB, 0.39413841E-03_JPRB, &
  & 0.39422775E-03_JPRB, 0.39432455E-03_JPRB, 0.39450725E-03_JPRB, 0.39495037E-03_JPRB, 0.39501234E-03_JPRB, 0.39507297E-03_JPRB, &
  & 0.39529955E-03_JPRB, 0.39558061E-03_JPRB, 0.39571716E-03_JPRB, 0.39570111E-03_JPRB  /)

RGHG1(:,83,11) = (/ &
  & 0.38490381E-03_JPRB, 0.38490385E-03_JPRB, 0.38500719E-03_JPRB, 0.38507425E-03_JPRB, 0.38508341E-03_JPRB, 0.38513024E-03_JPRB, &
  & 0.38529553E-03_JPRB, 0.38543335E-03_JPRB, 0.38546760E-03_JPRB, 0.38534713E-03_JPRB, 0.38515659E-03_JPRB, 0.38490185E-03_JPRB, &
  & 0.38464699E-03_JPRB, 0.38443247E-03_JPRB, 0.38420150E-03_JPRB, 0.38392769E-03_JPRB, 0.38367766E-03_JPRB, 0.38339897E-03_JPRB, &
  & 0.38307048E-03_JPRB, 0.38292433E-03_JPRB, 0.38279797E-03_JPRB, 0.38278095E-03_JPRB, 0.38277306E-03_JPRB, 0.38276017E-03_JPRB, &
  & 0.38272607E-03_JPRB, 0.38280649E-03_JPRB, 0.38293720E-03_JPRB, 0.38314204E-03_JPRB, 0.38339784E-03_JPRB, 0.38371405E-03_JPRB, &
  & 0.38384233E-03_JPRB, 0.38360530E-03_JPRB, 0.38372563E-03_JPRB, 0.38395135E-03_JPRB, 0.38409299E-03_JPRB, 0.38434149E-03_JPRB, &
  & 0.38436866E-03_JPRB, 0.38424904E-03_JPRB, 0.38426718E-03_JPRB, 0.38471234E-03_JPRB, 0.38532512E-03_JPRB, 0.38580363E-03_JPRB, &
  & 0.38645377E-03_JPRB, 0.38725181E-03_JPRB, 0.38793293E-03_JPRB, 0.38871582E-03_JPRB, 0.38983707E-03_JPRB, 0.39089636E-03_JPRB, &
  & 0.39180626E-03_JPRB, 0.39248600E-03_JPRB, 0.39319509E-03_JPRB, 0.39381539E-03_JPRB, 0.39422570E-03_JPRB, 0.39449888E-03_JPRB, &
  & 0.39456450E-03_JPRB, 0.39462016E-03_JPRB, 0.39476303E-03_JPRB, 0.39515759E-03_JPRB, 0.39517412E-03_JPRB, 0.39519587E-03_JPRB, &
  & 0.39541161E-03_JPRB, 0.39567519E-03_JPRB, 0.39581005E-03_JPRB, 0.39587175E-03_JPRB  /)

RGHG1(:,84,11) = (/ &
  & 0.38489968E-03_JPRB, 0.38491300E-03_JPRB, 0.38501281E-03_JPRB, 0.38508270E-03_JPRB, 0.38509640E-03_JPRB, 0.38514619E-03_JPRB, &
  & 0.38530489E-03_JPRB, 0.38544191E-03_JPRB, 0.38547752E-03_JPRB, 0.38535612E-03_JPRB, 0.38516260E-03_JPRB, 0.38490216E-03_JPRB, &
  & 0.38464210E-03_JPRB, 0.38442815E-03_JPRB, 0.38420184E-03_JPRB, 0.38393379E-03_JPRB, 0.38368990E-03_JPRB, 0.38341870E-03_JPRB, &
  & 0.38310943E-03_JPRB, 0.38298113E-03_JPRB, 0.38285963E-03_JPRB, 0.38283982E-03_JPRB, 0.38283100E-03_JPRB, 0.38281983E-03_JPRB, &
  & 0.38277576E-03_JPRB, 0.38285398E-03_JPRB, 0.38298544E-03_JPRB, 0.38318003E-03_JPRB, 0.38341502E-03_JPRB, 0.38373076E-03_JPRB, &
  & 0.38384717E-03_JPRB, 0.38359896E-03_JPRB, 0.38370857E-03_JPRB, 0.38394025E-03_JPRB, 0.38409232E-03_JPRB, 0.38436405E-03_JPRB, &
  & 0.38440679E-03_JPRB, 0.38428176E-03_JPRB, 0.38430454E-03_JPRB, 0.38476236E-03_JPRB, 0.38538993E-03_JPRB, 0.38588213E-03_JPRB, &
  & 0.38655103E-03_JPRB, 0.38737585E-03_JPRB, 0.38808907E-03_JPRB, 0.38891032E-03_JPRB, 0.39009271E-03_JPRB, 0.39119651E-03_JPRB, &
  & 0.39214112E-03_JPRB, 0.39280350E-03_JPRB, 0.39353164E-03_JPRB, 0.39413988E-03_JPRB, 0.39453352E-03_JPRB, 0.39481453E-03_JPRB, &
  & 0.39486452E-03_JPRB, 0.39488837E-03_JPRB, 0.39499381E-03_JPRB, 0.39533925E-03_JPRB, 0.39530259E-03_JPRB, 0.39528231E-03_JPRB, &
  & 0.39548702E-03_JPRB, 0.39572524E-03_JPRB, 0.39585891E-03_JPRB, 0.39598258E-03_JPRB  /)

RGHG1(:,85,11) = (/ &
  & 0.38489191E-03_JPRB, 0.38491790E-03_JPRB, 0.38501652E-03_JPRB, 0.38508688E-03_JPRB, 0.38510416E-03_JPRB, 0.38515659E-03_JPRB, &
  & 0.38530979E-03_JPRB, 0.38544776E-03_JPRB, 0.38548457E-03_JPRB, 0.38536197E-03_JPRB, 0.38516559E-03_JPRB, 0.38490013E-03_JPRB, &
  & 0.38463625E-03_JPRB, 0.38442086E-03_JPRB, 0.38419671E-03_JPRB, 0.38393463E-03_JPRB, 0.38369599E-03_JPRB, 0.38343459E-03_JPRB, &
  & 0.38315423E-03_JPRB, 0.38304266E-03_JPRB, 0.38293382E-03_JPRB, 0.38291067E-03_JPRB, 0.38290806E-03_JPRB, 0.38288948E-03_JPRB, &
  & 0.38284111E-03_JPRB, 0.38292603E-03_JPRB, 0.38306274E-03_JPRB, 0.38326282E-03_JPRB, 0.38348204E-03_JPRB, 0.38378990E-03_JPRB, &
  & 0.38389580E-03_JPRB, 0.38362655E-03_JPRB, 0.38371944E-03_JPRB, 0.38395685E-03_JPRB, 0.38412088E-03_JPRB, 0.38440192E-03_JPRB, &
  & 0.38445231E-03_JPRB, 0.38432705E-03_JPRB, 0.38435149E-03_JPRB, 0.38481529E-03_JPRB, 0.38545910E-03_JPRB, 0.38596349E-03_JPRB, &
  & 0.38664290E-03_JPRB, 0.38749306E-03_JPRB, 0.38823041E-03_JPRB, 0.38906839E-03_JPRB, 0.39032724E-03_JPRB, 0.39146402E-03_JPRB, &
  & 0.39244400E-03_JPRB, 0.39307962E-03_JPRB, 0.39383021E-03_JPRB, 0.39443893E-03_JPRB, 0.39478478E-03_JPRB, 0.39509207E-03_JPRB, &
  & 0.39514804E-03_JPRB, 0.39514537E-03_JPRB, 0.39522070E-03_JPRB, 0.39550664E-03_JPRB, 0.39539997E-03_JPRB, 0.39533762E-03_JPRB, &
  & 0.39552752E-03_JPRB, 0.39574257E-03_JPRB, 0.39586715E-03_JPRB, 0.39601974E-03_JPRB  /)

RGHG1(:,86,11) = (/ &
  & 0.38488467E-03_JPRB, 0.38492170E-03_JPRB, 0.38501987E-03_JPRB, 0.38508922E-03_JPRB, 0.38510935E-03_JPRB, 0.38516442E-03_JPRB, &
  & 0.38531265E-03_JPRB, 0.38545234E-03_JPRB, 0.38548960E-03_JPRB, 0.38536598E-03_JPRB, 0.38516747E-03_JPRB, 0.38489716E-03_JPRB, &
  & 0.38463055E-03_JPRB, 0.38441335E-03_JPRB, 0.38419098E-03_JPRB, 0.38393360E-03_JPRB, 0.38369912E-03_JPRB, 0.38345038E-03_JPRB, &
  & 0.38320469E-03_JPRB, 0.38311048E-03_JPRB, 0.38301157E-03_JPRB, 0.38298431E-03_JPRB, 0.38298589E-03_JPRB, 0.38296585E-03_JPRB, &
  & 0.38292063E-03_JPRB, 0.38301788E-03_JPRB, 0.38318101E-03_JPRB, 0.38339428E-03_JPRB, 0.38360625E-03_JPRB, 0.38393479E-03_JPRB, &
  & 0.38402377E-03_JPRB, 0.38373750E-03_JPRB, 0.38382293E-03_JPRB, 0.38405002E-03_JPRB, 0.38421259E-03_JPRB, 0.38447047E-03_JPRB, &
  & 0.38451620E-03_JPRB, 0.38438939E-03_JPRB, 0.38442000E-03_JPRB, 0.38488176E-03_JPRB, 0.38554808E-03_JPRB, 0.38607014E-03_JPRB, &
  & 0.38675002E-03_JPRB, 0.38762264E-03_JPRB, 0.38837864E-03_JPRB, 0.38922239E-03_JPRB, 0.39054314E-03_JPRB, 0.39170670E-03_JPRB, &
  & 0.39270521E-03_JPRB, 0.39332665E-03_JPRB, 0.39409814E-03_JPRB, 0.39470229E-03_JPRB, 0.39499767E-03_JPRB, 0.39533493E-03_JPRB, &
  & 0.39541579E-03_JPRB, 0.39540385E-03_JPRB, 0.39544331E-03_JPRB, 0.39566048E-03_JPRB, 0.39547502E-03_JPRB, 0.39537677E-03_JPRB, &
  & 0.39555252E-03_JPRB, 0.39574726E-03_JPRB, 0.39586889E-03_JPRB, 0.39603988E-03_JPRB  /)

RGHG1(:,87,11) = (/ &
  & 0.38487940E-03_JPRB, 0.38492542E-03_JPRB, 0.38502272E-03_JPRB, 0.38509061E-03_JPRB, 0.38511355E-03_JPRB, 0.38517043E-03_JPRB, &
  & 0.38531429E-03_JPRB, 0.38545542E-03_JPRB, 0.38549293E-03_JPRB, 0.38536846E-03_JPRB, 0.38516862E-03_JPRB, 0.38489405E-03_JPRB, &
  & 0.38462576E-03_JPRB, 0.38440585E-03_JPRB, 0.38418494E-03_JPRB, 0.38393145E-03_JPRB, 0.38370175E-03_JPRB, 0.38346666E-03_JPRB, &
  & 0.38325818E-03_JPRB, 0.38317618E-03_JPRB, 0.38308878E-03_JPRB, 0.38305899E-03_JPRB, 0.38306622E-03_JPRB, 0.38304830E-03_JPRB, &
  & 0.38301019E-03_JPRB, 0.38313267E-03_JPRB, 0.38334242E-03_JPRB, 0.38357753E-03_JPRB, 0.38379184E-03_JPRB, 0.38416932E-03_JPRB, &
  & 0.38425285E-03_JPRB, 0.38396031E-03_JPRB, 0.38405655E-03_JPRB, 0.38426416E-03_JPRB, 0.38442959E-03_JPRB, 0.38459415E-03_JPRB, &
  & 0.38460917E-03_JPRB, 0.38448838E-03_JPRB, 0.38454286E-03_JPRB, 0.38498790E-03_JPRB, 0.38569268E-03_JPRB, 0.38622292E-03_JPRB, &
  & 0.38688717E-03_JPRB, 0.38778311E-03_JPRB, 0.38856091E-03_JPRB, 0.38939639E-03_JPRB, 0.39076908E-03_JPRB, 0.39194282E-03_JPRB, &
  & 0.39293905E-03_JPRB, 0.39355585E-03_JPRB, 0.39434496E-03_JPRB, 0.39493604E-03_JPRB, 0.39518420E-03_JPRB, 0.39555181E-03_JPRB, &
  & 0.39567274E-03_JPRB, 0.39567371E-03_JPRB, 0.39567201E-03_JPRB, 0.39580266E-03_JPRB, 0.39552891E-03_JPRB, 0.39540063E-03_JPRB, &
  & 0.39556709E-03_JPRB, 0.39574544E-03_JPRB, 0.39586896E-03_JPRB, 0.39605170E-03_JPRB  /)

RGHG1(:,88,11) = (/ &
  & 0.38487667E-03_JPRB, 0.38492910E-03_JPRB, 0.38502480E-03_JPRB, 0.38509160E-03_JPRB, 0.38511709E-03_JPRB, 0.38517484E-03_JPRB, &
  & 0.38531505E-03_JPRB, 0.38545706E-03_JPRB, 0.38549475E-03_JPRB, 0.38536974E-03_JPRB, 0.38516913E-03_JPRB, 0.38489102E-03_JPRB, &
  & 0.38462192E-03_JPRB, 0.38439837E-03_JPRB, 0.38417874E-03_JPRB, 0.38392875E-03_JPRB, 0.38370515E-03_JPRB, 0.38348437E-03_JPRB, &
  & 0.38331655E-03_JPRB, 0.38323773E-03_JPRB, 0.38316669E-03_JPRB, 0.38313820E-03_JPRB, 0.38315578E-03_JPRB, 0.38314326E-03_JPRB, &
  & 0.38311472E-03_JPRB, 0.38327910E-03_JPRB, 0.38355953E-03_JPRB, 0.38383760E-03_JPRB, 0.38406838E-03_JPRB, 0.38453410E-03_JPRB, &
  & 0.38464026E-03_JPRB, 0.38435267E-03_JPRB, 0.38451534E-03_JPRB, 0.38466654E-03_JPRB, 0.38484791E-03_JPRB, 0.38481641E-03_JPRB, &
  & 0.38475404E-03_JPRB, 0.38465218E-03_JPRB, 0.38478579E-03_JPRB, 0.38519947E-03_JPRB, 0.38595539E-03_JPRB, 0.38648437E-03_JPRB, &
  & 0.38708168E-03_JPRB, 0.38801358E-03_JPRB, 0.38882607E-03_JPRB, 0.38963114E-03_JPRB, 0.39104446E-03_JPRB, 0.39220816E-03_JPRB, &
  & 0.39317066E-03_JPRB, 0.39378205E-03_JPRB, 0.39458494E-03_JPRB, 0.39514937E-03_JPRB, 0.39535407E-03_JPRB, 0.39574571E-03_JPRB, &
  & 0.39592219E-03_JPRB, 0.39596260E-03_JPRB, 0.39591680E-03_JPRB, 0.39593417E-03_JPRB, 0.39556434E-03_JPRB, 0.39541137E-03_JPRB, &
  & 0.39557335E-03_JPRB, 0.39574084E-03_JPRB, 0.39586940E-03_JPRB, 0.39606005E-03_JPRB  /)

RGHG1(:,89,11) = (/ &
  & 0.38487609E-03_JPRB, 0.38493165E-03_JPRB, 0.38502572E-03_JPRB, 0.38509248E-03_JPRB, 0.38511917E-03_JPRB, 0.38517746E-03_JPRB, &
  & 0.38531513E-03_JPRB, 0.38545768E-03_JPRB, 0.38549537E-03_JPRB, 0.38537029E-03_JPRB, 0.38516894E-03_JPRB, 0.38488793E-03_JPRB, &
  & 0.38461853E-03_JPRB, 0.38439092E-03_JPRB, 0.38417274E-03_JPRB, 0.38392630E-03_JPRB, 0.38370976E-03_JPRB, 0.38350215E-03_JPRB, &
  & 0.38338266E-03_JPRB, 0.38329946E-03_JPRB, 0.38325083E-03_JPRB, 0.38322962E-03_JPRB, 0.38326485E-03_JPRB, 0.38326157E-03_JPRB, &
  & 0.38324480E-03_JPRB, 0.38346928E-03_JPRB, 0.38385498E-03_JPRB, 0.38422385E-03_JPRB, 0.38450394E-03_JPRB, 0.38510699E-03_JPRB, &
  & 0.38527887E-03_JPRB, 0.38500252E-03_JPRB, 0.38533730E-03_JPRB, 0.38532547E-03_JPRB, 0.38555624E-03_JPRB, 0.38522030E-03_JPRB, &
  & 0.38499252E-03_JPRB, 0.38492286E-03_JPRB, 0.38526947E-03_JPRB, 0.38567484E-03_JPRB, 0.38646125E-03_JPRB, 0.38699423E-03_JPRB, &
  & 0.38738912E-03_JPRB, 0.38838727E-03_JPRB, 0.38926542E-03_JPRB, 0.38999777E-03_JPRB, 0.39143181E-03_JPRB, 0.39256173E-03_JPRB, &
  & 0.39344065E-03_JPRB, 0.39402060E-03_JPRB, 0.39483442E-03_JPRB, 0.39535017E-03_JPRB, 0.39551251E-03_JPRB, 0.39591076E-03_JPRB, &
  & 0.39615594E-03_JPRB, 0.39626284E-03_JPRB, 0.39617834E-03_JPRB, 0.39605143E-03_JPRB, 0.39558783E-03_JPRB, 0.39541421E-03_JPRB, &
  & 0.39557275E-03_JPRB, 0.39573674E-03_JPRB, 0.39587018E-03_JPRB, 0.39606713E-03_JPRB  /)

RGHG1(:,90,11) = (/ &
  & 0.38487608E-03_JPRB, 0.38493247E-03_JPRB, 0.38502654E-03_JPRB, 0.38509303E-03_JPRB, 0.38512000E-03_JPRB, 0.38517883E-03_JPRB, &
  & 0.38531486E-03_JPRB, 0.38545796E-03_JPRB, 0.38549565E-03_JPRB, 0.38537000E-03_JPRB, 0.38516837E-03_JPRB, 0.38488452E-03_JPRB, &
  & 0.38461456E-03_JPRB, 0.38438243E-03_JPRB, 0.38416648E-03_JPRB, 0.38392430E-03_JPRB, 0.38371577E-03_JPRB, 0.38350945E-03_JPRB, &
  & 0.38345844E-03_JPRB, 0.38339122E-03_JPRB, 0.38336435E-03_JPRB, 0.38335435E-03_JPRB, 0.38341241E-03_JPRB, 0.38341966E-03_JPRB, &
  & 0.38342190E-03_JPRB, 0.38374719E-03_JPRB, 0.38431756E-03_JPRB, 0.38486083E-03_JPRB, 0.38530998E-03_JPRB, 0.38606100E-03_JPRB, &
  & 0.38632724E-03_JPRB, 0.38607279E-03_JPRB, 0.38659573E-03_JPRB, 0.38624566E-03_JPRB, 0.38667314E-03_JPRB, 0.38600420E-03_JPRB, &
  & 0.38542009E-03_JPRB, 0.38537985E-03_JPRB, 0.38618648E-03_JPRB, 0.38680162E-03_JPRB, 0.38750573E-03_JPRB, 0.38804223E-03_JPRB, &
  & 0.38798291E-03_JPRB, 0.38906135E-03_JPRB, 0.39007584E-03_JPRB, 0.39064024E-03_JPRB, 0.39207074E-03_JPRB, 0.39309452E-03_JPRB, &
  & 0.39381808E-03_JPRB, 0.39430327E-03_JPRB, 0.39513028E-03_JPRB, 0.39555696E-03_JPRB, 0.39567362E-03_JPRB, 0.39606930E-03_JPRB, &
  & 0.39638354E-03_JPRB, 0.39658111E-03_JPRB, 0.39647057E-03_JPRB, 0.39616671E-03_JPRB, 0.39561144E-03_JPRB, 0.39541360E-03_JPRB, &
  & 0.39557080E-03_JPRB, 0.39573284E-03_JPRB, 0.39586990E-03_JPRB, 0.39606881E-03_JPRB  /)

RGHG1(:,91,11) = (/ &
  & 0.38487594E-03_JPRB, 0.38493262E-03_JPRB, 0.38502669E-03_JPRB, 0.38509318E-03_JPRB, 0.38512045E-03_JPRB, 0.38517928E-03_JPRB, &
  & 0.38531471E-03_JPRB, 0.38545810E-03_JPRB, 0.38549610E-03_JPRB, 0.38536955E-03_JPRB, 0.38516733E-03_JPRB, 0.38487992E-03_JPRB, &
  & 0.38460936E-03_JPRB, 0.38437159E-03_JPRB, 0.38415772E-03_JPRB, 0.38392118E-03_JPRB, 0.38371711E-03_JPRB, 0.38351672E-03_JPRB, &
  & 0.38358658E-03_JPRB, 0.38361201E-03_JPRB, 0.38356881E-03_JPRB, 0.38355288E-03_JPRB, 0.38365399E-03_JPRB, 0.38366778E-03_JPRB, &
  & 0.38372109E-03_JPRB, 0.38423585E-03_JPRB, 0.38506162E-03_JPRB, 0.38605866E-03_JPRB, 0.38715283E-03_JPRB, 0.38810698E-03_JPRB, &
  & 0.38841093E-03_JPRB, 0.38808461E-03_JPRB, 0.38891344E-03_JPRB, 0.38782539E-03_JPRB, 0.38848569E-03_JPRB, 0.38738110E-03_JPRB, &
  & 0.38630194E-03_JPRB, 0.38608470E-03_JPRB, 0.38764921E-03_JPRB, 0.38907062E-03_JPRB, 0.38947538E-03_JPRB, 0.38971254E-03_JPRB, &
  & 0.38945455E-03_JPRB, 0.39045251E-03_JPRB, 0.39146640E-03_JPRB, 0.39185738E-03_JPRB, 0.39323620E-03_JPRB, 0.39395380E-03_JPRB, &
  & 0.39442137E-03_JPRB, 0.39472809E-03_JPRB, 0.39551708E-03_JPRB, 0.39583329E-03_JPRB, 0.39587986E-03_JPRB, 0.39628891E-03_JPRB, &
  & 0.39665691E-03_JPRB, 0.39692961E-03_JPRB, 0.39681164E-03_JPRB, 0.39629841E-03_JPRB, 0.39564485E-03_JPRB, 0.39541137E-03_JPRB, &
  & 0.39556917E-03_JPRB, 0.39572972E-03_JPRB, 0.39586975E-03_JPRB, 0.39607045E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ---GEMS----

RGHG1(:, 1,12) = (/ &
  & 0.37409261E-03_JPRB, 0.37409137E-03_JPRB, 0.37408825E-03_JPRB, 0.37408253E-03_JPRB, 0.37407350E-03_JPRB, 0.37406012E-03_JPRB, &
  & 0.37404337E-03_JPRB, 0.37402502E-03_JPRB, 0.37400708E-03_JPRB, 0.37399075E-03_JPRB, 0.37397610E-03_JPRB, 0.37396309E-03_JPRB, &
  & 0.37395192E-03_JPRB, 0.37394291E-03_JPRB, 0.37393560E-03_JPRB, 0.37392938E-03_JPRB, 0.37392383E-03_JPRB, 0.37391908E-03_JPRB, &
  & 0.37391530E-03_JPRB, 0.37391308E-03_JPRB, 0.37391321E-03_JPRB, 0.37391678E-03_JPRB, 0.37392436E-03_JPRB, 0.37393610E-03_JPRB, &
  & 0.37395138E-03_JPRB, 0.37396896E-03_JPRB, 0.37398781E-03_JPRB, 0.37400642E-03_JPRB, 0.37402312E-03_JPRB, 0.37403723E-03_JPRB, &
  & 0.37404962E-03_JPRB, 0.37406113E-03_JPRB, 0.37407075E-03_JPRB, 0.37408140E-03_JPRB, 0.37409502E-03_JPRB, 0.37410531E-03_JPRB, &
  & 0.37411144E-03_JPRB, 0.37411670E-03_JPRB, 0.37411899E-03_JPRB, 0.37411808E-03_JPRB, 0.37411674E-03_JPRB, 0.37411490E-03_JPRB, &
  & 0.37411327E-03_JPRB, 0.37411101E-03_JPRB, 0.37410804E-03_JPRB, 0.37410535E-03_JPRB, 0.37410115E-03_JPRB, 0.37409645E-03_JPRB, &
  & 0.37409134E-03_JPRB, 0.37408607E-03_JPRB, 0.37408075E-03_JPRB, 0.37407631E-03_JPRB, 0.37407067E-03_JPRB, 0.37406523E-03_JPRB, &
  & 0.37406113E-03_JPRB, 0.37405572E-03_JPRB, 0.37404949E-03_JPRB, 0.37404345E-03_JPRB, 0.37403863E-03_JPRB, 0.37403499E-03_JPRB, &
  & 0.37403082E-03_JPRB, 0.37402598E-03_JPRB, 0.37402230E-03_JPRB, 0.37402163E-03_JPRB  /)

RGHG1(:, 2,12) = (/ &
  & 0.37409261E-03_JPRB, 0.37409137E-03_JPRB, 0.37408825E-03_JPRB, 0.37408253E-03_JPRB, 0.37407350E-03_JPRB, 0.37406012E-03_JPRB, &
  & 0.37404337E-03_JPRB, 0.37402502E-03_JPRB, 0.37400708E-03_JPRB, 0.37399075E-03_JPRB, 0.37397610E-03_JPRB, 0.37396309E-03_JPRB, &
  & 0.37395192E-03_JPRB, 0.37394291E-03_JPRB, 0.37393560E-03_JPRB, 0.37392938E-03_JPRB, 0.37392383E-03_JPRB, 0.37391908E-03_JPRB, &
  & 0.37391530E-03_JPRB, 0.37391308E-03_JPRB, 0.37391321E-03_JPRB, 0.37391678E-03_JPRB, 0.37392436E-03_JPRB, 0.37393610E-03_JPRB, &
  & 0.37395138E-03_JPRB, 0.37396896E-03_JPRB, 0.37398781E-03_JPRB, 0.37400642E-03_JPRB, 0.37402312E-03_JPRB, 0.37403723E-03_JPRB, &
  & 0.37404962E-03_JPRB, 0.37406113E-03_JPRB, 0.37407075E-03_JPRB, 0.37408140E-03_JPRB, 0.37409502E-03_JPRB, 0.37410531E-03_JPRB, &
  & 0.37411144E-03_JPRB, 0.37411670E-03_JPRB, 0.37411899E-03_JPRB, 0.37411808E-03_JPRB, 0.37411674E-03_JPRB, 0.37411490E-03_JPRB, &
  & 0.37411327E-03_JPRB, 0.37411101E-03_JPRB, 0.37410804E-03_JPRB, 0.37410535E-03_JPRB, 0.37410115E-03_JPRB, 0.37409645E-03_JPRB, &
  & 0.37409134E-03_JPRB, 0.37408607E-03_JPRB, 0.37408075E-03_JPRB, 0.37407631E-03_JPRB, 0.37407067E-03_JPRB, 0.37406523E-03_JPRB, &
  & 0.37406113E-03_JPRB, 0.37405572E-03_JPRB, 0.37404949E-03_JPRB, 0.37404345E-03_JPRB, 0.37403863E-03_JPRB, 0.37403499E-03_JPRB, &
  & 0.37403082E-03_JPRB, 0.37402598E-03_JPRB, 0.37402230E-03_JPRB, 0.37402163E-03_JPRB  /)

RGHG1(:, 3,12) = (/ &
  & 0.37409261E-03_JPRB, 0.37409137E-03_JPRB, 0.37408825E-03_JPRB, 0.37408253E-03_JPRB, 0.37407350E-03_JPRB, 0.37406012E-03_JPRB, &
  & 0.37404337E-03_JPRB, 0.37402502E-03_JPRB, 0.37400708E-03_JPRB, 0.37399075E-03_JPRB, 0.37397610E-03_JPRB, 0.37396309E-03_JPRB, &
  & 0.37395192E-03_JPRB, 0.37394291E-03_JPRB, 0.37393560E-03_JPRB, 0.37392938E-03_JPRB, 0.37392383E-03_JPRB, 0.37391908E-03_JPRB, &
  & 0.37391530E-03_JPRB, 0.37391308E-03_JPRB, 0.37391321E-03_JPRB, 0.37391678E-03_JPRB, 0.37392436E-03_JPRB, 0.37393610E-03_JPRB, &
  & 0.37395138E-03_JPRB, 0.37396896E-03_JPRB, 0.37398781E-03_JPRB, 0.37400642E-03_JPRB, 0.37402312E-03_JPRB, 0.37403723E-03_JPRB, &
  & 0.37404962E-03_JPRB, 0.37406113E-03_JPRB, 0.37407075E-03_JPRB, 0.37408140E-03_JPRB, 0.37409502E-03_JPRB, 0.37410531E-03_JPRB, &
  & 0.37411144E-03_JPRB, 0.37411670E-03_JPRB, 0.37411899E-03_JPRB, 0.37411808E-03_JPRB, 0.37411674E-03_JPRB, 0.37411490E-03_JPRB, &
  & 0.37411327E-03_JPRB, 0.37411101E-03_JPRB, 0.37410804E-03_JPRB, 0.37410535E-03_JPRB, 0.37410115E-03_JPRB, 0.37409645E-03_JPRB, &
  & 0.37409134E-03_JPRB, 0.37408607E-03_JPRB, 0.37408075E-03_JPRB, 0.37407631E-03_JPRB, 0.37407067E-03_JPRB, 0.37406523E-03_JPRB, &
  & 0.37406113E-03_JPRB, 0.37405572E-03_JPRB, 0.37404949E-03_JPRB, 0.37404345E-03_JPRB, 0.37403863E-03_JPRB, 0.37403499E-03_JPRB, &
  & 0.37403082E-03_JPRB, 0.37402598E-03_JPRB, 0.37402230E-03_JPRB, 0.37402163E-03_JPRB  /)

RGHG1(:, 4,12) = (/ &
  & 0.37409273E-03_JPRB, 0.37409147E-03_JPRB, 0.37408833E-03_JPRB, 0.37408257E-03_JPRB, 0.37407347E-03_JPRB, 0.37406003E-03_JPRB, &
  & 0.37404322E-03_JPRB, 0.37402483E-03_JPRB, 0.37400687E-03_JPRB, 0.37399055E-03_JPRB, 0.37397589E-03_JPRB, 0.37396288E-03_JPRB, &
  & 0.37395172E-03_JPRB, 0.37394273E-03_JPRB, 0.37393543E-03_JPRB, 0.37392923E-03_JPRB, 0.37392370E-03_JPRB, 0.37391897E-03_JPRB, &
  & 0.37391522E-03_JPRB, 0.37391306E-03_JPRB, 0.37391327E-03_JPRB, 0.37391694E-03_JPRB, 0.37392464E-03_JPRB, 0.37393651E-03_JPRB, &
  & 0.37395189E-03_JPRB, 0.37396955E-03_JPRB, 0.37398845E-03_JPRB, 0.37400712E-03_JPRB, 0.37402383E-03_JPRB, 0.37403795E-03_JPRB, &
  & 0.37405034E-03_JPRB, 0.37406184E-03_JPRB, 0.37407145E-03_JPRB, 0.37408207E-03_JPRB, 0.37409561E-03_JPRB, 0.37410583E-03_JPRB, &
  & 0.37411192E-03_JPRB, 0.37411712E-03_JPRB, 0.37411936E-03_JPRB, 0.37411841E-03_JPRB, 0.37411702E-03_JPRB, 0.37411514E-03_JPRB, &
  & 0.37411348E-03_JPRB, 0.37411119E-03_JPRB, 0.37410819E-03_JPRB, 0.37410547E-03_JPRB, 0.37410124E-03_JPRB, 0.37409651E-03_JPRB, &
  & 0.37409138E-03_JPRB, 0.37408608E-03_JPRB, 0.37408075E-03_JPRB, 0.37407629E-03_JPRB, 0.37407065E-03_JPRB, 0.37406520E-03_JPRB, &
  & 0.37406108E-03_JPRB, 0.37405566E-03_JPRB, 0.37404943E-03_JPRB, 0.37404338E-03_JPRB, 0.37403855E-03_JPRB, 0.37403489E-03_JPRB, &
  & 0.37403070E-03_JPRB, 0.37402585E-03_JPRB, 0.37402215E-03_JPRB, 0.37402147E-03_JPRB  /)

RGHG1(:, 5,12) = (/ &
  & 0.37409827E-03_JPRB, 0.37409640E-03_JPRB, 0.37409202E-03_JPRB, 0.37408417E-03_JPRB, 0.37407227E-03_JPRB, 0.37405576E-03_JPRB, &
  & 0.37403613E-03_JPRB, 0.37401593E-03_JPRB, 0.37399729E-03_JPRB, 0.37398074E-03_JPRB, 0.37396579E-03_JPRB, 0.37395283E-03_JPRB, &
  & 0.37394225E-03_JPRB, 0.37393406E-03_JPRB, 0.37392756E-03_JPRB, 0.37392208E-03_JPRB, 0.37391732E-03_JPRB, 0.37391367E-03_JPRB, &
  & 0.37391159E-03_JPRB, 0.37391204E-03_JPRB, 0.37391599E-03_JPRB, 0.37392465E-03_JPRB, 0.37393807E-03_JPRB, 0.37395578E-03_JPRB, &
  & 0.37397625E-03_JPRB, 0.37399757E-03_JPRB, 0.37401916E-03_JPRB, 0.37403994E-03_JPRB, 0.37405780E-03_JPRB, 0.37407215E-03_JPRB, &
  & 0.37408464E-03_JPRB, 0.37409590E-03_JPRB, 0.37410492E-03_JPRB, 0.37411404E-03_JPRB, 0.37412385E-03_JPRB, 0.37413060E-03_JPRB, &
  & 0.37413453E-03_JPRB, 0.37413710E-03_JPRB, 0.37413694E-03_JPRB, 0.37413393E-03_JPRB, 0.37413031E-03_JPRB, 0.37412652E-03_JPRB, &
  & 0.37412336E-03_JPRB, 0.37411973E-03_JPRB, 0.37411541E-03_JPRB, 0.37411095E-03_JPRB, 0.37410535E-03_JPRB, 0.37409931E-03_JPRB, &
  & 0.37409306E-03_JPRB, 0.37408677E-03_JPRB, 0.37408062E-03_JPRB, 0.37407534E-03_JPRB, 0.37406939E-03_JPRB, 0.37406352E-03_JPRB, &
  & 0.37405845E-03_JPRB, 0.37405273E-03_JPRB, 0.37404643E-03_JPRB, 0.37404014E-03_JPRB, 0.37403491E-03_JPRB, 0.37403036E-03_JPRB, &
  & 0.37402520E-03_JPRB, 0.37401951E-03_JPRB, 0.37401501E-03_JPRB, 0.37401400E-03_JPRB  /)

RGHG1(:, 6,12) = (/ &
  & 0.37410657E-03_JPRB, 0.37410380E-03_JPRB, 0.37409755E-03_JPRB, 0.37408658E-03_JPRB, 0.37407045E-03_JPRB, 0.37404935E-03_JPRB, &
  & 0.37402551E-03_JPRB, 0.37400258E-03_JPRB, 0.37398292E-03_JPRB, 0.37396602E-03_JPRB, 0.37395064E-03_JPRB, 0.37393775E-03_JPRB, &
  & 0.37392804E-03_JPRB, 0.37392106E-03_JPRB, 0.37391575E-03_JPRB, 0.37391134E-03_JPRB, 0.37390776E-03_JPRB, 0.37390572E-03_JPRB, &
  & 0.37390614E-03_JPRB, 0.37391050E-03_JPRB, 0.37392007E-03_JPRB, 0.37393622E-03_JPRB, 0.37395822E-03_JPRB, 0.37398469E-03_JPRB, &
  & 0.37401279E-03_JPRB, 0.37403962E-03_JPRB, 0.37406524E-03_JPRB, 0.37408919E-03_JPRB, 0.37410876E-03_JPRB, 0.37412348E-03_JPRB, &
  & 0.37413609E-03_JPRB, 0.37414700E-03_JPRB, 0.37415513E-03_JPRB, 0.37416201E-03_JPRB, 0.37416620E-03_JPRB, 0.37416776E-03_JPRB, &
  & 0.37416846E-03_JPRB, 0.37416708E-03_JPRB, 0.37416331E-03_JPRB, 0.37415721E-03_JPRB, 0.37415026E-03_JPRB, 0.37414359E-03_JPRB, &
  & 0.37413819E-03_JPRB, 0.37413253E-03_JPRB, 0.37412626E-03_JPRB, 0.37411918E-03_JPRB, 0.37411152E-03_JPRB, 0.37410350E-03_JPRB, &
  & 0.37409558E-03_JPRB, 0.37408781E-03_JPRB, 0.37408044E-03_JPRB, 0.37407391E-03_JPRB, 0.37406751E-03_JPRB, 0.37406100E-03_JPRB, &
  & 0.37405452E-03_JPRB, 0.37404832E-03_JPRB, 0.37404193E-03_JPRB, 0.37403528E-03_JPRB, 0.37402946E-03_JPRB, 0.37402355E-03_JPRB, &
  & 0.37401696E-03_JPRB, 0.37400999E-03_JPRB, 0.37400430E-03_JPRB, 0.37400278E-03_JPRB  /)

RGHG1(:, 7,12) = (/ &
  & 0.37412167E-03_JPRB, 0.37411836E-03_JPRB, 0.37410977E-03_JPRB, 0.37409458E-03_JPRB, 0.37407288E-03_JPRB, 0.37404595E-03_JPRB, &
  & 0.37401788E-03_JPRB, 0.37399305E-03_JPRB, 0.37397177E-03_JPRB, 0.37395265E-03_JPRB, 0.37393576E-03_JPRB, 0.37392317E-03_JPRB, &
  & 0.37391531E-03_JPRB, 0.37391064E-03_JPRB, 0.37390704E-03_JPRB, 0.37390407E-03_JPRB, 0.37390258E-03_JPRB, 0.37390395E-03_JPRB, &
  & 0.37390993E-03_JPRB, 0.37392372E-03_JPRB, 0.37394794E-03_JPRB, 0.37398341E-03_JPRB, 0.37402627E-03_JPRB, 0.37407177E-03_JPRB, &
  & 0.37411579E-03_JPRB, 0.37415568E-03_JPRB, 0.37419217E-03_JPRB, 0.37422431E-03_JPRB, 0.37424838E-03_JPRB, 0.37426485E-03_JPRB, &
  & 0.37427620E-03_JPRB, 0.37428178E-03_JPRB, 0.37428072E-03_JPRB, 0.37427508E-03_JPRB, 0.37426445E-03_JPRB, 0.37425185E-03_JPRB, &
  & 0.37424115E-03_JPRB, 0.37422874E-03_JPRB, 0.37421319E-03_JPRB, 0.37419784E-03_JPRB, 0.37418458E-03_JPRB, 0.37417271E-03_JPRB, &
  & 0.37416284E-03_JPRB, 0.37415312E-03_JPRB, 0.37414218E-03_JPRB, 0.37413080E-03_JPRB, 0.37411973E-03_JPRB, 0.37410875E-03_JPRB, &
  & 0.37409767E-03_JPRB, 0.37408714E-03_JPRB, 0.37407734E-03_JPRB, 0.37406860E-03_JPRB, 0.37406076E-03_JPRB, 0.37405302E-03_JPRB, &
  & 0.37404499E-03_JPRB, 0.37403781E-03_JPRB, 0.37403042E-03_JPRB, 0.37402313E-03_JPRB, 0.37401662E-03_JPRB, 0.37400880E-03_JPRB, &
  & 0.37400028E-03_JPRB, 0.37399062E-03_JPRB, 0.37398251E-03_JPRB, 0.37398063E-03_JPRB  /)

RGHG1(:, 8,12) = (/ &
  & 0.37414083E-03_JPRB, 0.37413741E-03_JPRB, 0.37412655E-03_JPRB, 0.37410799E-03_JPRB, 0.37408214E-03_JPRB, 0.37405083E-03_JPRB, &
  & 0.37401903E-03_JPRB, 0.37399108E-03_JPRB, 0.37396627E-03_JPRB, 0.37394381E-03_JPRB, 0.37392554E-03_JPRB, 0.37391422E-03_JPRB, &
  & 0.37390917E-03_JPRB, 0.37390735E-03_JPRB, 0.37390589E-03_JPRB, 0.37390554E-03_JPRB, 0.37390815E-03_JPRB, 0.37391524E-03_JPRB, &
  & 0.37392912E-03_JPRB, 0.37395505E-03_JPRB, 0.37399803E-03_JPRB, 0.37405962E-03_JPRB, 0.37413309E-03_JPRB, 0.37420933E-03_JPRB, &
  & 0.37428149E-03_JPRB, 0.37434631E-03_JPRB, 0.37440446E-03_JPRB, 0.37445471E-03_JPRB, 0.37449206E-03_JPRB, 0.37451429E-03_JPRB, &
  & 0.37452341E-03_JPRB, 0.37451830E-03_JPRB, 0.37449785E-03_JPRB, 0.37446862E-03_JPRB, 0.37443503E-03_JPRB, 0.37439949E-03_JPRB, &
  & 0.37436572E-03_JPRB, 0.37432930E-03_JPRB, 0.37429218E-03_JPRB, 0.37425984E-03_JPRB, 0.37423452E-03_JPRB, 0.37421482E-03_JPRB, &
  & 0.37419946E-03_JPRB, 0.37418416E-03_JPRB, 0.37416816E-03_JPRB, 0.37415225E-03_JPRB, 0.37413663E-03_JPRB, 0.37412188E-03_JPRB, &
  & 0.37410688E-03_JPRB, 0.37409180E-03_JPRB, 0.37407687E-03_JPRB, 0.37406370E-03_JPRB, 0.37405292E-03_JPRB, 0.37404345E-03_JPRB, &
  & 0.37403344E-03_JPRB, 0.37402435E-03_JPRB, 0.37401494E-03_JPRB, 0.37400586E-03_JPRB, 0.37399734E-03_JPRB, 0.37398740E-03_JPRB, &
  & 0.37397588E-03_JPRB, 0.37396100E-03_JPRB, 0.37394819E-03_JPRB, 0.37394374E-03_JPRB  /)

RGHG1(:, 9,12) = (/ &
  & 0.37413990E-03_JPRB, 0.37413923E-03_JPRB, 0.37412907E-03_JPRB, 0.37410953E-03_JPRB, 0.37408392E-03_JPRB, 0.37405297E-03_JPRB, &
  & 0.37402008E-03_JPRB, 0.37398922E-03_JPRB, 0.37396090E-03_JPRB, 0.37393680E-03_JPRB, 0.37391984E-03_JPRB, 0.37391250E-03_JPRB, &
  & 0.37391209E-03_JPRB, 0.37391433E-03_JPRB, 0.37391698E-03_JPRB, 0.37392246E-03_JPRB, 0.37393273E-03_JPRB, 0.37394861E-03_JPRB, &
  & 0.37397250E-03_JPRB, 0.37401137E-03_JPRB, 0.37407471E-03_JPRB, 0.37416878E-03_JPRB, 0.37428392E-03_JPRB, 0.37440451E-03_JPRB, &
  & 0.37451801E-03_JPRB, 0.37461958E-03_JPRB, 0.37471025E-03_JPRB, 0.37478725E-03_JPRB, 0.37484226E-03_JPRB, 0.37487031E-03_JPRB, &
  & 0.37487472E-03_JPRB, 0.37485417E-03_JPRB, 0.37480656E-03_JPRB, 0.37474181E-03_JPRB, 0.37466947E-03_JPRB, 0.37459941E-03_JPRB, &
  & 0.37453049E-03_JPRB, 0.37445873E-03_JPRB, 0.37439424E-03_JPRB, 0.37434280E-03_JPRB, 0.37430476E-03_JPRB, 0.37427732E-03_JPRB, &
  & 0.37425594E-03_JPRB, 0.37423470E-03_JPRB, 0.37421482E-03_JPRB, 0.37419509E-03_JPRB, 0.37417416E-03_JPRB, 0.37415277E-03_JPRB, &
  & 0.37413079E-03_JPRB, 0.37410858E-03_JPRB, 0.37408547E-03_JPRB, 0.37406408E-03_JPRB, 0.37404763E-03_JPRB, 0.37403454E-03_JPRB, &
  & 0.37402151E-03_JPRB, 0.37400882E-03_JPRB, 0.37399593E-03_JPRB, 0.37398340E-03_JPRB, 0.37397050E-03_JPRB, 0.37395624E-03_JPRB, &
  & 0.37393871E-03_JPRB, 0.37391469E-03_JPRB, 0.37389409E-03_JPRB, 0.37388407E-03_JPRB  /)

RGHG1(:,10,12) = (/ &
  & 0.37406681E-03_JPRB, 0.37407483E-03_JPRB, 0.37407351E-03_JPRB, 0.37406063E-03_JPRB, 0.37404392E-03_JPRB, 0.37401916E-03_JPRB, &
  & 0.37398898E-03_JPRB, 0.37395987E-03_JPRB, 0.37393414E-03_JPRB, 0.37391541E-03_JPRB, 0.37390624E-03_JPRB, 0.37390858E-03_JPRB, &
  & 0.37391780E-03_JPRB, 0.37392841E-03_JPRB, 0.37394040E-03_JPRB, 0.37395737E-03_JPRB, 0.37397957E-03_JPRB, 0.37400684E-03_JPRB, &
  & 0.37404178E-03_JPRB, 0.37409255E-03_JPRB, 0.37417670E-03_JPRB, 0.37431194E-03_JPRB, 0.37448196E-03_JPRB, 0.37465791E-03_JPRB, &
  & 0.37481845E-03_JPRB, 0.37495838E-03_JPRB, 0.37508176E-03_JPRB, 0.37517889E-03_JPRB, 0.37523905E-03_JPRB, 0.37526090E-03_JPRB, &
  & 0.37525384E-03_JPRB, 0.37521557E-03_JPRB, 0.37514285E-03_JPRB, 0.37504010E-03_JPRB, 0.37491364E-03_JPRB, 0.37479586E-03_JPRB, &
  & 0.37468720E-03_JPRB, 0.37458526E-03_JPRB, 0.37450293E-03_JPRB, 0.37444237E-03_JPRB, 0.37439992E-03_JPRB, 0.37436780E-03_JPRB, &
  & 0.37434108E-03_JPRB, 0.37431751E-03_JPRB, 0.37429696E-03_JPRB, 0.37427472E-03_JPRB, 0.37424821E-03_JPRB, 0.37421468E-03_JPRB, &
  & 0.37417825E-03_JPRB, 0.37414325E-03_JPRB, 0.37410782E-03_JPRB, 0.37407318E-03_JPRB, 0.37404688E-03_JPRB, 0.37402485E-03_JPRB, &
  & 0.37400507E-03_JPRB, 0.37398608E-03_JPRB, 0.37396810E-03_JPRB, 0.37395006E-03_JPRB, 0.37392883E-03_JPRB, 0.37390360E-03_JPRB, &
  & 0.37387285E-03_JPRB, 0.37383406E-03_JPRB, 0.37380192E-03_JPRB, 0.37378535E-03_JPRB  /)

RGHG1(:,11,12) = (/ &
  & 0.37393681E-03_JPRB, 0.37395027E-03_JPRB, 0.37396476E-03_JPRB, 0.37397437E-03_JPRB, 0.37397684E-03_JPRB, 0.37396030E-03_JPRB, &
  & 0.37393237E-03_JPRB, 0.37390690E-03_JPRB, 0.37388802E-03_JPRB, 0.37387962E-03_JPRB, 0.37388274E-03_JPRB, 0.37390189E-03_JPRB, &
  & 0.37393163E-03_JPRB, 0.37396147E-03_JPRB, 0.37399058E-03_JPRB, 0.37402313E-03_JPRB, 0.37405865E-03_JPRB, 0.37409760E-03_JPRB, &
  & 0.37414298E-03_JPRB, 0.37420329E-03_JPRB, 0.37430684E-03_JPRB, 0.37448950E-03_JPRB, 0.37472218E-03_JPRB, 0.37495402E-03_JPRB, &
  & 0.37515698E-03_JPRB, 0.37533195E-03_JPRB, 0.37547836E-03_JPRB, 0.37557522E-03_JPRB, 0.37561939E-03_JPRB, 0.37561785E-03_JPRB, &
  & 0.37559142E-03_JPRB, 0.37553722E-03_JPRB, 0.37544940E-03_JPRB, 0.37532027E-03_JPRB, 0.37514144E-03_JPRB, 0.37496492E-03_JPRB, &
  & 0.37482245E-03_JPRB, 0.37471220E-03_JPRB, 0.37463358E-03_JPRB, 0.37457735E-03_JPRB, 0.37453748E-03_JPRB, 0.37450601E-03_JPRB, &
  & 0.37448392E-03_JPRB, 0.37446843E-03_JPRB, 0.37445192E-03_JPRB, 0.37442592E-03_JPRB, 0.37438706E-03_JPRB, 0.37433006E-03_JPRB, &
  & 0.37426306E-03_JPRB, 0.37419801E-03_JPRB, 0.37413903E-03_JPRB, 0.37408696E-03_JPRB, 0.37404470E-03_JPRB, 0.37400613E-03_JPRB, &
  & 0.37397122E-03_JPRB, 0.37393938E-03_JPRB, 0.37391173E-03_JPRB, 0.37388205E-03_JPRB, 0.37384482E-03_JPRB, 0.37379873E-03_JPRB, &
  & 0.37374340E-03_JPRB, 0.37368119E-03_JPRB, 0.37363326E-03_JPRB, 0.37360903E-03_JPRB  /)

RGHG1(:,12,12) = (/ &
  & 0.37396301E-03_JPRB, 0.37396804E-03_JPRB, 0.37398542E-03_JPRB, 0.37400998E-03_JPRB, 0.37401893E-03_JPRB, 0.37400182E-03_JPRB, &
  & 0.37396940E-03_JPRB, 0.37393691E-03_JPRB, 0.37391362E-03_JPRB, 0.37390802E-03_JPRB, 0.37392091E-03_JPRB, 0.37396165E-03_JPRB, &
  & 0.37402299E-03_JPRB, 0.37408646E-03_JPRB, 0.37413984E-03_JPRB, 0.37418678E-03_JPRB, 0.37423267E-03_JPRB, 0.37428193E-03_JPRB, &
  & 0.37433790E-03_JPRB, 0.37440642E-03_JPRB, 0.37451971E-03_JPRB, 0.37472862E-03_JPRB, 0.37500397E-03_JPRB, 0.37527581E-03_JPRB, &
  & 0.37551491E-03_JPRB, 0.37573562E-03_JPRB, 0.37591177E-03_JPRB, 0.37600236E-03_JPRB, 0.37601586E-03_JPRB, 0.37598349E-03_JPRB, &
  & 0.37593970E-03_JPRB, 0.37587772E-03_JPRB, 0.37578427E-03_JPRB, 0.37563471E-03_JPRB, 0.37541916E-03_JPRB, 0.37520963E-03_JPRB, &
  & 0.37505750E-03_JPRB, 0.37495430E-03_JPRB, 0.37488614E-03_JPRB, 0.37483733E-03_JPRB, 0.37481046E-03_JPRB, 0.37479461E-03_JPRB, &
  & 0.37478852E-03_JPRB, 0.37478453E-03_JPRB, 0.37476657E-03_JPRB, 0.37472863E-03_JPRB, 0.37466040E-03_JPRB, 0.37455775E-03_JPRB, &
  & 0.37443159E-03_JPRB, 0.37430336E-03_JPRB, 0.37419581E-03_JPRB, 0.37411546E-03_JPRB, 0.37404809E-03_JPRB, 0.37398534E-03_JPRB, &
  & 0.37392470E-03_JPRB, 0.37386412E-03_JPRB, 0.37381160E-03_JPRB, 0.37375580E-03_JPRB, 0.37368761E-03_JPRB, 0.37360675E-03_JPRB, &
  & 0.37351397E-03_JPRB, 0.37342050E-03_JPRB, 0.37335277E-03_JPRB, 0.37332065E-03_JPRB  /)

RGHG1(:,13,12) = (/ &
  & 0.37441379E-03_JPRB, 0.37441169E-03_JPRB, 0.37440559E-03_JPRB, 0.37439713E-03_JPRB, 0.37436581E-03_JPRB, 0.37432375E-03_JPRB, &
  & 0.37427616E-03_JPRB, 0.37422356E-03_JPRB, 0.37417845E-03_JPRB, 0.37415982E-03_JPRB, 0.37417529E-03_JPRB, 0.37423283E-03_JPRB, &
  & 0.37431968E-03_JPRB, 0.37441321E-03_JPRB, 0.37448855E-03_JPRB, 0.37454409E-03_JPRB, 0.37459378E-03_JPRB, 0.37464882E-03_JPRB, &
  & 0.37471577E-03_JPRB, 0.37479574E-03_JPRB, 0.37490745E-03_JPRB, 0.37509306E-03_JPRB, 0.37535908E-03_JPRB, 0.37564152E-03_JPRB, &
  & 0.37590263E-03_JPRB, 0.37617182E-03_JPRB, 0.37640308E-03_JPRB, 0.37652022E-03_JPRB, 0.37653087E-03_JPRB, 0.37648495E-03_JPRB, &
  & 0.37642341E-03_JPRB, 0.37634518E-03_JPRB, 0.37623892E-03_JPRB, 0.37608370E-03_JPRB, 0.37589179E-03_JPRB, 0.37572380E-03_JPRB, &
  & 0.37559619E-03_JPRB, 0.37549222E-03_JPRB, 0.37542025E-03_JPRB, 0.37537475E-03_JPRB, 0.37535901E-03_JPRB, 0.37534862E-03_JPRB, &
  & 0.37534344E-03_JPRB, 0.37533300E-03_JPRB, 0.37529650E-03_JPRB, 0.37522819E-03_JPRB, 0.37510999E-03_JPRB, 0.37494331E-03_JPRB, &
  & 0.37474407E-03_JPRB, 0.37453766E-03_JPRB, 0.37434838E-03_JPRB, 0.37421305E-03_JPRB, 0.37411011E-03_JPRB, 0.37401210E-03_JPRB, &
  & 0.37391171E-03_JPRB, 0.37380413E-03_JPRB, 0.37370489E-03_JPRB, 0.37360670E-03_JPRB, 0.37349056E-03_JPRB, 0.37335779E-03_JPRB, &
  & 0.37321896E-03_JPRB, 0.37309533E-03_JPRB, 0.37301146E-03_JPRB, 0.37298148E-03_JPRB  /)

RGHG1(:,14,12) = (/ &
  & 0.37517833E-03_JPRB, 0.37516922E-03_JPRB, 0.37513783E-03_JPRB, 0.37507355E-03_JPRB, 0.37499314E-03_JPRB, 0.37492384E-03_JPRB, &
  & 0.37485374E-03_JPRB, 0.37477413E-03_JPRB, 0.37470313E-03_JPRB, 0.37466378E-03_JPRB, 0.37466887E-03_JPRB, 0.37472396E-03_JPRB, &
  & 0.37481025E-03_JPRB, 0.37490781E-03_JPRB, 0.37498841E-03_JPRB, 0.37504371E-03_JPRB, 0.37508716E-03_JPRB, 0.37513548E-03_JPRB, &
  & 0.37520069E-03_JPRB, 0.37528550E-03_JPRB, 0.37538619E-03_JPRB, 0.37551959E-03_JPRB, 0.37573107E-03_JPRB, 0.37599500E-03_JPRB, &
  & 0.37625868E-03_JPRB, 0.37655248E-03_JPRB, 0.37684760E-03_JPRB, 0.37704032E-03_JPRB, 0.37711230E-03_JPRB, 0.37710974E-03_JPRB, &
  & 0.37705830E-03_JPRB, 0.37697043E-03_JPRB, 0.37686128E-03_JPRB, 0.37673691E-03_JPRB, 0.37661943E-03_JPRB, 0.37652695E-03_JPRB, &
  & 0.37642962E-03_JPRB, 0.37632074E-03_JPRB, 0.37624744E-03_JPRB, 0.37619810E-03_JPRB, 0.37615985E-03_JPRB, 0.37612444E-03_JPRB, &
  & 0.37610372E-03_JPRB, 0.37606295E-03_JPRB, 0.37599147E-03_JPRB, 0.37587668E-03_JPRB, 0.37569137E-03_JPRB, 0.37544172E-03_JPRB, &
  & 0.37516936E-03_JPRB, 0.37490023E-03_JPRB, 0.37462958E-03_JPRB, 0.37442435E-03_JPRB, 0.37427608E-03_JPRB, 0.37413128E-03_JPRB, &
  & 0.37397554E-03_JPRB, 0.37380234E-03_JPRB, 0.37364185E-03_JPRB, 0.37349157E-03_JPRB, 0.37332498E-03_JPRB, 0.37313604E-03_JPRB, &
  & 0.37295660E-03_JPRB, 0.37281153E-03_JPRB, 0.37272082E-03_JPRB, 0.37269661E-03_JPRB  /)

RGHG1(:,15,12) = (/ &
  & 0.37586682E-03_JPRB, 0.37584118E-03_JPRB, 0.37578637E-03_JPRB, 0.37569329E-03_JPRB, 0.37560189E-03_JPRB, 0.37552345E-03_JPRB, &
  & 0.37543528E-03_JPRB, 0.37534023E-03_JPRB, 0.37525669E-03_JPRB, 0.37519910E-03_JPRB, 0.37518255E-03_JPRB, 0.37521336E-03_JPRB, &
  & 0.37527284E-03_JPRB, 0.37534998E-03_JPRB, 0.37541603E-03_JPRB, 0.37545459E-03_JPRB, 0.37548229E-03_JPRB, 0.37551499E-03_JPRB, &
  & 0.37556409E-03_JPRB, 0.37563189E-03_JPRB, 0.37570742E-03_JPRB, 0.37579841E-03_JPRB, 0.37596451E-03_JPRB, 0.37621328E-03_JPRB, &
  & 0.37648817E-03_JPRB, 0.37681166E-03_JPRB, 0.37716508E-03_JPRB, 0.37742317E-03_JPRB, 0.37756687E-03_JPRB, 0.37764552E-03_JPRB, &
  & 0.37766714E-03_JPRB, 0.37764088E-03_JPRB, 0.37759510E-03_JPRB, 0.37754974E-03_JPRB, 0.37753296E-03_JPRB, 0.37751916E-03_JPRB, &
  & 0.37745001E-03_JPRB, 0.37732798E-03_JPRB, 0.37719969E-03_JPRB, 0.37708642E-03_JPRB, 0.37698931E-03_JPRB, 0.37691265E-03_JPRB, &
  & 0.37686592E-03_JPRB, 0.37679331E-03_JPRB, 0.37668443E-03_JPRB, 0.37652711E-03_JPRB, 0.37628258E-03_JPRB, 0.37596152E-03_JPRB, &
  & 0.37562150E-03_JPRB, 0.37529778E-03_JPRB, 0.37498068E-03_JPRB, 0.37472312E-03_JPRB, 0.37452537E-03_JPRB, 0.37432512E-03_JPRB, &
  & 0.37410768E-03_JPRB, 0.37386438E-03_JPRB, 0.37364195E-03_JPRB, 0.37344492E-03_JPRB, 0.37323934E-03_JPRB, 0.37300665E-03_JPRB, &
  & 0.37279008E-03_JPRB, 0.37263714E-03_JPRB, 0.37254485E-03_JPRB, 0.37251954E-03_JPRB  /)

RGHG1(:,16,12) = (/ &
  & 0.37626302E-03_JPRB, 0.37621703E-03_JPRB, 0.37614259E-03_JPRB, 0.37604826E-03_JPRB, 0.37595059E-03_JPRB, 0.37586311E-03_JPRB, &
  & 0.37576812E-03_JPRB, 0.37566768E-03_JPRB, 0.37558044E-03_JPRB, 0.37551706E-03_JPRB, 0.37547993E-03_JPRB, 0.37547605E-03_JPRB, &
  & 0.37550164E-03_JPRB, 0.37554603E-03_JPRB, 0.37558788E-03_JPRB, 0.37561422E-03_JPRB, 0.37563688E-03_JPRB, 0.37566234E-03_JPRB, &
  & 0.37569407E-03_JPRB, 0.37573280E-03_JPRB, 0.37577857E-03_JPRB, 0.37585054E-03_JPRB, 0.37600375E-03_JPRB, 0.37625848E-03_JPRB, &
  & 0.37658517E-03_JPRB, 0.37697633E-03_JPRB, 0.37738353E-03_JPRB, 0.37767537E-03_JPRB, 0.37788082E-03_JPRB, 0.37804266E-03_JPRB, &
  & 0.37817673E-03_JPRB, 0.37826672E-03_JPRB, 0.37833992E-03_JPRB, 0.37841719E-03_JPRB, 0.37848037E-03_JPRB, 0.37849973E-03_JPRB, &
  & 0.37841205E-03_JPRB, 0.37823135E-03_JPRB, 0.37800625E-03_JPRB, 0.37776756E-03_JPRB, 0.37758161E-03_JPRB, 0.37746808E-03_JPRB, &
  & 0.37738247E-03_JPRB, 0.37729258E-03_JPRB, 0.37717462E-03_JPRB, 0.37699950E-03_JPRB, 0.37673664E-03_JPRB, 0.37638754E-03_JPRB, &
  & 0.37600062E-03_JPRB, 0.37563962E-03_JPRB, 0.37529277E-03_JPRB, 0.37500924E-03_JPRB, 0.37477448E-03_JPRB, 0.37452484E-03_JPRB, &
  & 0.37425560E-03_JPRB, 0.37396603E-03_JPRB, 0.37370103E-03_JPRB, 0.37347452E-03_JPRB, 0.37324697E-03_JPRB, 0.37299366E-03_JPRB, &
  & 0.37276322E-03_JPRB, 0.37261210E-03_JPRB, 0.37252886E-03_JPRB, 0.37250468E-03_JPRB  /)

RGHG1(:,17,12) = (/ &
  & 0.37638219E-03_JPRB, 0.37632269E-03_JPRB, 0.37624603E-03_JPRB, 0.37616057E-03_JPRB, 0.37606075E-03_JPRB, 0.37596455E-03_JPRB, &
  & 0.37586762E-03_JPRB, 0.37575860E-03_JPRB, 0.37566532E-03_JPRB, 0.37559957E-03_JPRB, 0.37555731E-03_JPRB, 0.37553696E-03_JPRB, &
  & 0.37554267E-03_JPRB, 0.37556494E-03_JPRB, 0.37558861E-03_JPRB, 0.37561121E-03_JPRB, 0.37563573E-03_JPRB, 0.37565572E-03_JPRB, &
  & 0.37566921E-03_JPRB, 0.37568288E-03_JPRB, 0.37570980E-03_JPRB, 0.37577719E-03_JPRB, 0.37592478E-03_JPRB, 0.37620024E-03_JPRB, &
  & 0.37660261E-03_JPRB, 0.37708337E-03_JPRB, 0.37753852E-03_JPRB, 0.37786409E-03_JPRB, 0.37812752E-03_JPRB, 0.37837958E-03_JPRB, &
  & 0.37862201E-03_JPRB, 0.37883978E-03_JPRB, 0.37906202E-03_JPRB, 0.37926564E-03_JPRB, 0.37935970E-03_JPRB, 0.37931932E-03_JPRB, &
  & 0.37910574E-03_JPRB, 0.37880349E-03_JPRB, 0.37847937E-03_JPRB, 0.37814913E-03_JPRB, 0.37786551E-03_JPRB, 0.37772159E-03_JPRB, &
  & 0.37761468E-03_JPRB, 0.37751422E-03_JPRB, 0.37740779E-03_JPRB, 0.37724035E-03_JPRB, 0.37699282E-03_JPRB, 0.37664102E-03_JPRB, &
  & 0.37623677E-03_JPRB, 0.37585539E-03_JPRB, 0.37549156E-03_JPRB, 0.37520143E-03_JPRB, 0.37494656E-03_JPRB, 0.37467105E-03_JPRB, &
  & 0.37437092E-03_JPRB, 0.37406033E-03_JPRB, 0.37378736E-03_JPRB, 0.37355782E-03_JPRB, 0.37332485E-03_JPRB, 0.37307156E-03_JPRB, &
  & 0.37285841E-03_JPRB, 0.37272112E-03_JPRB, 0.37265109E-03_JPRB, 0.37263216E-03_JPRB  /)

RGHG1(:,18,12) = (/ &
  & 0.37629103E-03_JPRB, 0.37623826E-03_JPRB, 0.37617809E-03_JPRB, 0.37610588E-03_JPRB, 0.37601789E-03_JPRB, 0.37593182E-03_JPRB, &
  & 0.37584102E-03_JPRB, 0.37573635E-03_JPRB, 0.37564467E-03_JPRB, 0.37558043E-03_JPRB, 0.37554127E-03_JPRB, 0.37551834E-03_JPRB, &
  & 0.37551491E-03_JPRB, 0.37552414E-03_JPRB, 0.37553329E-03_JPRB, 0.37555229E-03_JPRB, 0.37557508E-03_JPRB, 0.37559426E-03_JPRB, &
  & 0.37560342E-03_JPRB, 0.37559895E-03_JPRB, 0.37561288E-03_JPRB, 0.37568532E-03_JPRB, 0.37584274E-03_JPRB, 0.37614828E-03_JPRB, &
  & 0.37661779E-03_JPRB, 0.37716934E-03_JPRB, 0.37767093E-03_JPRB, 0.37804564E-03_JPRB, 0.37839427E-03_JPRB, 0.37872377E-03_JPRB, &
  & 0.37904289E-03_JPRB, 0.37939222E-03_JPRB, 0.37977348E-03_JPRB, 0.38005567E-03_JPRB, 0.38010024E-03_JPRB, 0.37992727E-03_JPRB, &
  & 0.37955411E-03_JPRB, 0.37911634E-03_JPRB, 0.37871997E-03_JPRB, 0.37833484E-03_JPRB, 0.37796523E-03_JPRB, 0.37776385E-03_JPRB, &
  & 0.37762427E-03_JPRB, 0.37754247E-03_JPRB, 0.37744890E-03_JPRB, 0.37729640E-03_JPRB, 0.37707272E-03_JPRB, 0.37673847E-03_JPRB, &
  & 0.37634653E-03_JPRB, 0.37596121E-03_JPRB, 0.37559834E-03_JPRB, 0.37530220E-03_JPRB, 0.37503578E-03_JPRB, 0.37475320E-03_JPRB, &
  & 0.37444845E-03_JPRB, 0.37413772E-03_JPRB, 0.37388128E-03_JPRB, 0.37366703E-03_JPRB, 0.37343844E-03_JPRB, 0.37319871E-03_JPRB, &
  & 0.37301634E-03_JPRB, 0.37289368E-03_JPRB, 0.37284253E-03_JPRB, 0.37283122E-03_JPRB  /)

RGHG1(:,19,12) = (/ &
  & 0.37613050E-03_JPRB, 0.37609722E-03_JPRB, 0.37605487E-03_JPRB, 0.37599153E-03_JPRB, 0.37592189E-03_JPRB, 0.37585393E-03_JPRB, &
  & 0.37577937E-03_JPRB, 0.37569635E-03_JPRB, 0.37561740E-03_JPRB, 0.37556037E-03_JPRB, 0.37552672E-03_JPRB, 0.37550885E-03_JPRB, &
  & 0.37550607E-03_JPRB, 0.37551101E-03_JPRB, 0.37551429E-03_JPRB, 0.37552921E-03_JPRB, 0.37554979E-03_JPRB, 0.37557143E-03_JPRB, &
  & 0.37558738E-03_JPRB, 0.37558343E-03_JPRB, 0.37559392E-03_JPRB, 0.37567624E-03_JPRB, 0.37585128E-03_JPRB, 0.37618018E-03_JPRB, &
  & 0.37668521E-03_JPRB, 0.37727024E-03_JPRB, 0.37782512E-03_JPRB, 0.37828767E-03_JPRB, 0.37872482E-03_JPRB, 0.37911438E-03_JPRB, &
  & 0.37949065E-03_JPRB, 0.37993282E-03_JPRB, 0.38041505E-03_JPRB, 0.38072315E-03_JPRB, 0.38070115E-03_JPRB, 0.38041172E-03_JPRB, &
  & 0.37992919E-03_JPRB, 0.37940888E-03_JPRB, 0.37892924E-03_JPRB, 0.37845276E-03_JPRB, 0.37799135E-03_JPRB, 0.37770794E-03_JPRB, &
  & 0.37752890E-03_JPRB, 0.37745888E-03_JPRB, 0.37737959E-03_JPRB, 0.37724409E-03_JPRB, 0.37704519E-03_JPRB, 0.37675155E-03_JPRB, &
  & 0.37639273E-03_JPRB, 0.37602457E-03_JPRB, 0.37568063E-03_JPRB, 0.37537808E-03_JPRB, 0.37510580E-03_JPRB, 0.37482379E-03_JPRB, &
  & 0.37452728E-03_JPRB, 0.37423308E-03_JPRB, 0.37400085E-03_JPRB, 0.37380387E-03_JPRB, 0.37358595E-03_JPRB, 0.37336734E-03_JPRB, &
  & 0.37321299E-03_JPRB, 0.37310610E-03_JPRB, 0.37307380E-03_JPRB, 0.37307603E-03_JPRB  /)

RGHG1(:,20,12) = (/ &
  & 0.37600935E-03_JPRB, 0.37599198E-03_JPRB, 0.37596123E-03_JPRB, 0.37591024E-03_JPRB, 0.37586190E-03_JPRB, 0.37581583E-03_JPRB, &
  & 0.37576209E-03_JPRB, 0.37570244E-03_JPRB, 0.37564164E-03_JPRB, 0.37559711E-03_JPRB, 0.37557151E-03_JPRB, 0.37555974E-03_JPRB, &
  & 0.37555897E-03_JPRB, 0.37556461E-03_JPRB, 0.37557056E-03_JPRB, 0.37558488E-03_JPRB, 0.37560436E-03_JPRB, 0.37562880E-03_JPRB, &
  & 0.37565805E-03_JPRB, 0.37567289E-03_JPRB, 0.37569542E-03_JPRB, 0.37579932E-03_JPRB, 0.37599732E-03_JPRB, 0.37633350E-03_JPRB, &
  & 0.37682942E-03_JPRB, 0.37741337E-03_JPRB, 0.37801107E-03_JPRB, 0.37857437E-03_JPRB, 0.37909697E-03_JPRB, 0.37954877E-03_JPRB, &
  & 0.37998587E-03_JPRB, 0.38048961E-03_JPRB, 0.38100879E-03_JPRB, 0.38129895E-03_JPRB, 0.38121144E-03_JPRB, 0.38086214E-03_JPRB, &
  & 0.38036604E-03_JPRB, 0.37982055E-03_JPRB, 0.37922746E-03_JPRB, 0.37860643E-03_JPRB, 0.37802783E-03_JPRB, 0.37764217E-03_JPRB, &
  & 0.37743684E-03_JPRB, 0.37736196E-03_JPRB, 0.37729227E-03_JPRB, 0.37717085E-03_JPRB, 0.37699727E-03_JPRB, 0.37675497E-03_JPRB, &
  & 0.37644051E-03_JPRB, 0.37610962E-03_JPRB, 0.37578895E-03_JPRB, 0.37548536E-03_JPRB, 0.37520878E-03_JPRB, 0.37493211E-03_JPRB, &
  & 0.37464939E-03_JPRB, 0.37438099E-03_JPRB, 0.37417336E-03_JPRB, 0.37399107E-03_JPRB, 0.37378636E-03_JPRB, 0.37359010E-03_JPRB, &
  & 0.37346225E-03_JPRB, 0.37337767E-03_JPRB, 0.37336532E-03_JPRB, 0.37338241E-03_JPRB  /)

RGHG1(:,21,12) = (/ &
  & 0.37595704E-03_JPRB, 0.37594909E-03_JPRB, 0.37592792E-03_JPRB, 0.37589527E-03_JPRB, 0.37586931E-03_JPRB, 0.37584606E-03_JPRB, &
  & 0.37581422E-03_JPRB, 0.37577410E-03_JPRB, 0.37573212E-03_JPRB, 0.37570218E-03_JPRB, 0.37568628E-03_JPRB, 0.37567929E-03_JPRB, &
  & 0.37567982E-03_JPRB, 0.37568933E-03_JPRB, 0.37570339E-03_JPRB, 0.37572072E-03_JPRB, 0.37574029E-03_JPRB, 0.37576619E-03_JPRB, &
  & 0.37580761E-03_JPRB, 0.37585156E-03_JPRB, 0.37590363E-03_JPRB, 0.37604651E-03_JPRB, 0.37627242E-03_JPRB, 0.37660596E-03_JPRB, &
  & 0.37706482E-03_JPRB, 0.37762449E-03_JPRB, 0.37824197E-03_JPRB, 0.37888572E-03_JPRB, 0.37948124E-03_JPRB, 0.38000140E-03_JPRB, &
  & 0.38050771E-03_JPRB, 0.38105213E-03_JPRB, 0.38156352E-03_JPRB, 0.38181428E-03_JPRB, 0.38168182E-03_JPRB, 0.38132426E-03_JPRB, &
  & 0.38087207E-03_JPRB, 0.38033188E-03_JPRB, 0.37962404E-03_JPRB, 0.37883510E-03_JPRB, 0.37812185E-03_JPRB, 0.37763684E-03_JPRB, &
  & 0.37741953E-03_JPRB, 0.37732321E-03_JPRB, 0.37725162E-03_JPRB, 0.37714104E-03_JPRB, 0.37699445E-03_JPRB, 0.37680232E-03_JPRB, &
  & 0.37653546E-03_JPRB, 0.37624952E-03_JPRB, 0.37595338E-03_JPRB, 0.37565431E-03_JPRB, 0.37537309E-03_JPRB, 0.37510400E-03_JPRB, &
  & 0.37483838E-03_JPRB, 0.37459816E-03_JPRB, 0.37441276E-03_JPRB, 0.37424478E-03_JPRB, 0.37405632E-03_JPRB, 0.37388442E-03_JPRB, &
  & 0.37378274E-03_JPRB, 0.37372902E-03_JPRB, 0.37373899E-03_JPRB, 0.37376731E-03_JPRB  /)

RGHG1(:,22,12) = (/ &
  & 0.37597471E-03_JPRB, 0.37597377E-03_JPRB, 0.37596984E-03_JPRB, 0.37596020E-03_JPRB, 0.37595592E-03_JPRB, 0.37595301E-03_JPRB, &
  & 0.37594208E-03_JPRB, 0.37591819E-03_JPRB, 0.37589177E-03_JPRB, 0.37587373E-03_JPRB, 0.37586717E-03_JPRB, 0.37586329E-03_JPRB, &
  & 0.37586637E-03_JPRB, 0.37588290E-03_JPRB, 0.37590663E-03_JPRB, 0.37592862E-03_JPRB, 0.37594919E-03_JPRB, 0.37597398E-03_JPRB, &
  & 0.37601618E-03_JPRB, 0.37608892E-03_JPRB, 0.37619003E-03_JPRB, 0.37639561E-03_JPRB, 0.37665476E-03_JPRB, 0.37698897E-03_JPRB, &
  & 0.37741326E-03_JPRB, 0.37793780E-03_JPRB, 0.37853993E-03_JPRB, 0.37920447E-03_JPRB, 0.37984335E-03_JPRB, 0.38043122E-03_JPRB, &
  & 0.38100901E-03_JPRB, 0.38157745E-03_JPRB, 0.38205882E-03_JPRB, 0.38227711E-03_JPRB, 0.38215066E-03_JPRB, 0.38181801E-03_JPRB, &
  & 0.38138972E-03_JPRB, 0.38084898E-03_JPRB, 0.38008266E-03_JPRB, 0.37915419E-03_JPRB, 0.37831241E-03_JPRB, 0.37776858E-03_JPRB, &
  & 0.37754528E-03_JPRB, 0.37741160E-03_JPRB, 0.37731788E-03_JPRB, 0.37721664E-03_JPRB, 0.37710018E-03_JPRB, 0.37694496E-03_JPRB, &
  & 0.37672091E-03_JPRB, 0.37646876E-03_JPRB, 0.37620209E-03_JPRB, 0.37591047E-03_JPRB, 0.37562369E-03_JPRB, 0.37536127E-03_JPRB, &
  & 0.37511600E-03_JPRB, 0.37489946E-03_JPRB, 0.37473184E-03_JPRB, 0.37458265E-03_JPRB, 0.37441665E-03_JPRB, 0.37427588E-03_JPRB, &
  & 0.37419922E-03_JPRB, 0.37418552E-03_JPRB, 0.37422095E-03_JPRB, 0.37425149E-03_JPRB  /)

RGHG1(:,23,12) = (/ &
  & 0.37604763E-03_JPRB, 0.37605411E-03_JPRB, 0.37605902E-03_JPRB, 0.37606453E-03_JPRB, 0.37607207E-03_JPRB, 0.37607818E-03_JPRB, &
  & 0.37607773E-03_JPRB, 0.37606779E-03_JPRB, 0.37605312E-03_JPRB, 0.37604181E-03_JPRB, 0.37604152E-03_JPRB, 0.37604701E-03_JPRB, &
  & 0.37605542E-03_JPRB, 0.37607212E-03_JPRB, 0.37609552E-03_JPRB, 0.37611636E-03_JPRB, 0.37613174E-03_JPRB, 0.37614889E-03_JPRB, &
  & 0.37618065E-03_JPRB, 0.37625884E-03_JPRB, 0.37640014E-03_JPRB, 0.37666895E-03_JPRB, 0.37697995E-03_JPRB, 0.37735643E-03_JPRB, &
  & 0.37779963E-03_JPRB, 0.37830686E-03_JPRB, 0.37887277E-03_JPRB, 0.37950437E-03_JPRB, 0.38012805E-03_JPRB, 0.38071506E-03_JPRB, &
  & 0.38132417E-03_JPRB, 0.38191760E-03_JPRB, 0.38239497E-03_JPRB, 0.38262234E-03_JPRB, 0.38252575E-03_JPRB, 0.38219962E-03_JPRB, &
  & 0.38175023E-03_JPRB, 0.38120960E-03_JPRB, 0.38044510E-03_JPRB, 0.37950427E-03_JPRB, 0.37863750E-03_JPRB, 0.37809960E-03_JPRB, &
  & 0.37784413E-03_JPRB, 0.37767335E-03_JPRB, 0.37755211E-03_JPRB, 0.37743750E-03_JPRB, 0.37733089E-03_JPRB, 0.37719151E-03_JPRB, &
  & 0.37698810E-03_JPRB, 0.37675524E-03_JPRB, 0.37651055E-03_JPRB, 0.37623701E-03_JPRB, 0.37595677E-03_JPRB, 0.37570058E-03_JPRB, &
  & 0.37547441E-03_JPRB, 0.37527982E-03_JPRB, 0.37512420E-03_JPRB, 0.37499906E-03_JPRB, 0.37486946E-03_JPRB, 0.37476058E-03_JPRB, &
  & 0.37471150E-03_JPRB, 0.37472858E-03_JPRB, 0.37478633E-03_JPRB, 0.37482579E-03_JPRB  /)

RGHG1(:,24,12) = (/ &
  & 0.37614459E-03_JPRB, 0.37615038E-03_JPRB, 0.37616075E-03_JPRB, 0.37617618E-03_JPRB, 0.37619224E-03_JPRB, 0.37620427E-03_JPRB, &
  & 0.37621130E-03_JPRB, 0.37621244E-03_JPRB, 0.37620815E-03_JPRB, 0.37620318E-03_JPRB, 0.37620781E-03_JPRB, 0.37621895E-03_JPRB, &
  & 0.37622970E-03_JPRB, 0.37624439E-03_JPRB, 0.37626496E-03_JPRB, 0.37628306E-03_JPRB, 0.37629424E-03_JPRB, 0.37630595E-03_JPRB, &
  & 0.37633221E-03_JPRB, 0.37641324E-03_JPRB, 0.37658106E-03_JPRB, 0.37690524E-03_JPRB, 0.37727873E-03_JPRB, 0.37771393E-03_JPRB, &
  & 0.37820058E-03_JPRB, 0.37870473E-03_JPRB, 0.37924041E-03_JPRB, 0.37981837E-03_JPRB, 0.38039537E-03_JPRB, 0.38095391E-03_JPRB, &
  & 0.38158104E-03_JPRB, 0.38219365E-03_JPRB, 0.38266705E-03_JPRB, 0.38290344E-03_JPRB, 0.38283477E-03_JPRB, 0.38251457E-03_JPRB, &
  & 0.38205197E-03_JPRB, 0.38151134E-03_JPRB, 0.38077203E-03_JPRB, 0.37986978E-03_JPRB, 0.37902639E-03_JPRB, 0.37851066E-03_JPRB, &
  & 0.37822437E-03_JPRB, 0.37801842E-03_JPRB, 0.37786833E-03_JPRB, 0.37773396E-03_JPRB, 0.37762669E-03_JPRB, 0.37749593E-03_JPRB, &
  & 0.37730674E-03_JPRB, 0.37708480E-03_JPRB, 0.37685611E-03_JPRB, 0.37660059E-03_JPRB, 0.37633308E-03_JPRB, 0.37608753E-03_JPRB, &
  & 0.37588139E-03_JPRB, 0.37570699E-03_JPRB, 0.37556507E-03_JPRB, 0.37546727E-03_JPRB, 0.37537818E-03_JPRB, 0.37530430E-03_JPRB, &
  & 0.37528543E-03_JPRB, 0.37532995E-03_JPRB, 0.37540930E-03_JPRB, 0.37546090E-03_JPRB  /)

RGHG1(:,25,12) = (/ &
  & 0.37626736E-03_JPRB, 0.37625800E-03_JPRB, 0.37626950E-03_JPRB, 0.37628691E-03_JPRB, 0.37630748E-03_JPRB, 0.37632224E-03_JPRB, &
  & 0.37633341E-03_JPRB, 0.37634057E-03_JPRB, 0.37634466E-03_JPRB, 0.37634618E-03_JPRB, 0.37635381E-03_JPRB, 0.37636232E-03_JPRB, &
  & 0.37636940E-03_JPRB, 0.37637986E-03_JPRB, 0.37639554E-03_JPRB, 0.37640949E-03_JPRB, 0.37641983E-03_JPRB, 0.37643173E-03_JPRB, &
  & 0.37646401E-03_JPRB, 0.37654833E-03_JPRB, 0.37671925E-03_JPRB, 0.37708228E-03_JPRB, 0.37753009E-03_JPRB, 0.37804122E-03_JPRB, &
  & 0.37860078E-03_JPRB, 0.37912317E-03_JPRB, 0.37964531E-03_JPRB, 0.38014744E-03_JPRB, 0.38063723E-03_JPRB, 0.38113509E-03_JPRB, &
  & 0.38176496E-03_JPRB, 0.38238538E-03_JPRB, 0.38284918E-03_JPRB, 0.38308472E-03_JPRB, 0.38303393E-03_JPRB, 0.38272248E-03_JPRB, &
  & 0.38227136E-03_JPRB, 0.38173034E-03_JPRB, 0.38104296E-03_JPRB, 0.38023921E-03_JPRB, 0.37948058E-03_JPRB, 0.37900022E-03_JPRB, &
  & 0.37869277E-03_JPRB, 0.37845662E-03_JPRB, 0.37827784E-03_JPRB, 0.37811834E-03_JPRB, 0.37799641E-03_JPRB, 0.37786583E-03_JPRB, &
  & 0.37768379E-03_JPRB, 0.37746072E-03_JPRB, 0.37723843E-03_JPRB, 0.37699758E-03_JPRB, 0.37675049E-03_JPRB, 0.37652300E-03_JPRB, &
  & 0.37633793E-03_JPRB, 0.37618009E-03_JPRB, 0.37605557E-03_JPRB, 0.37598854E-03_JPRB, 0.37594225E-03_JPRB, 0.37590713E-03_JPRB, &
  & 0.37592118E-03_JPRB, 0.37598809E-03_JPRB, 0.37608748E-03_JPRB, 0.37615489E-03_JPRB  /)

RGHG1(:,26,12) = (/ &
  & 0.37637623E-03_JPRB, 0.37634679E-03_JPRB, 0.37634811E-03_JPRB, 0.37636151E-03_JPRB, 0.37638029E-03_JPRB, 0.37639415E-03_JPRB, &
  & 0.37641075E-03_JPRB, 0.37642506E-03_JPRB, 0.37643425E-03_JPRB, 0.37643933E-03_JPRB, 0.37644651E-03_JPRB, 0.37645389E-03_JPRB, &
  & 0.37646163E-03_JPRB, 0.37646974E-03_JPRB, 0.37648538E-03_JPRB, 0.37650420E-03_JPRB, 0.37653371E-03_JPRB, 0.37656741E-03_JPRB, &
  & 0.37662457E-03_JPRB, 0.37671868E-03_JPRB, 0.37688645E-03_JPRB, 0.37727378E-03_JPRB, 0.37778871E-03_JPRB, 0.37836464E-03_JPRB, &
  & 0.37898314E-03_JPRB, 0.37954600E-03_JPRB, 0.38005158E-03_JPRB, 0.38047753E-03_JPRB, 0.38087892E-03_JPRB, 0.38133127E-03_JPRB, &
  & 0.38195094E-03_JPRB, 0.38254694E-03_JPRB, 0.38297043E-03_JPRB, 0.38318307E-03_JPRB, 0.38314303E-03_JPRB, 0.38285636E-03_JPRB, &
  & 0.38241593E-03_JPRB, 0.38186812E-03_JPRB, 0.38123760E-03_JPRB, 0.38055706E-03_JPRB, 0.37989567E-03_JPRB, 0.37945153E-03_JPRB, &
  & 0.37914064E-03_JPRB, 0.37890335E-03_JPRB, 0.37871432E-03_JPRB, 0.37853499E-03_JPRB, 0.37839229E-03_JPRB, 0.37825098E-03_JPRB, &
  & 0.37807298E-03_JPRB, 0.37785129E-03_JPRB, 0.37762869E-03_JPRB, 0.37739838E-03_JPRB, 0.37716747E-03_JPRB, 0.37696579E-03_JPRB, &
  & 0.37680520E-03_JPRB, 0.37666439E-03_JPRB, 0.37656762E-03_JPRB, 0.37652915E-03_JPRB, 0.37651867E-03_JPRB, 0.37651873E-03_JPRB, &
  & 0.37656570E-03_JPRB, 0.37665645E-03_JPRB, 0.37676604E-03_JPRB, 0.37684341E-03_JPRB  /)

RGHG1(:,27,12) = (/ &
  & 0.37648490E-03_JPRB, 0.37643263E-03_JPRB, 0.37641912E-03_JPRB, 0.37642611E-03_JPRB, 0.37644068E-03_JPRB, 0.37645226E-03_JPRB, &
  & 0.37647500E-03_JPRB, 0.37649721E-03_JPRB, 0.37651053E-03_JPRB, 0.37651824E-03_JPRB, 0.37652367E-03_JPRB, 0.37653043E-03_JPRB, &
  & 0.37654046E-03_JPRB, 0.37654681E-03_JPRB, 0.37656420E-03_JPRB, 0.37659145E-03_JPRB, 0.37664843E-03_JPRB, 0.37671294E-03_JPRB, &
  & 0.37680311E-03_JPRB, 0.37690985E-03_JPRB, 0.37707201E-03_JPRB, 0.37747935E-03_JPRB, 0.37806178E-03_JPRB, 0.37870135E-03_JPRB, &
  & 0.37937629E-03_JPRB, 0.37998971E-03_JPRB, 0.38047686E-03_JPRB, 0.38082301E-03_JPRB, 0.38113154E-03_JPRB, 0.38154193E-03_JPRB, &
  & 0.38214616E-03_JPRB, 0.38270468E-03_JPRB, 0.38307462E-03_JPRB, 0.38325513E-03_JPRB, 0.38322369E-03_JPRB, 0.38296889E-03_JPRB, &
  & 0.38253934E-03_JPRB, 0.38198206E-03_JPRB, 0.38141280E-03_JPRB, 0.38087025E-03_JPRB, 0.38031515E-03_JPRB, 0.37990919E-03_JPRB, &
  & 0.37960129E-03_JPRB, 0.37937356E-03_JPRB, 0.37918068E-03_JPRB, 0.37898256E-03_JPRB, 0.37881590E-03_JPRB, 0.37865932E-03_JPRB, &
  & 0.37848439E-03_JPRB, 0.37826506E-03_JPRB, 0.37803966E-03_JPRB, 0.37781883E-03_JPRB, 0.37760328E-03_JPRB, 0.37743144E-03_JPRB, &
  & 0.37729771E-03_JPRB, 0.37717490E-03_JPRB, 0.37711095E-03_JPRB, 0.37710154E-03_JPRB, 0.37712591E-03_JPRB, 0.37716143E-03_JPRB, &
  & 0.37724281E-03_JPRB, 0.37735901E-03_JPRB, 0.37747563E-03_JPRB, 0.37756125E-03_JPRB  /)

RGHG1(:,28,12) = (/ &
  & 0.37650009E-03_JPRB, 0.37643382E-03_JPRB, 0.37640261E-03_JPRB, 0.37639559E-03_JPRB, 0.37640395E-03_JPRB, 0.37641136E-03_JPRB, &
  & 0.37643165E-03_JPRB, 0.37644871E-03_JPRB, 0.37646678E-03_JPRB, 0.37648318E-03_JPRB, 0.37649998E-03_JPRB, 0.37652434E-03_JPRB, &
  & 0.37655746E-03_JPRB, 0.37658908E-03_JPRB, 0.37664310E-03_JPRB, 0.37671910E-03_JPRB, 0.37682202E-03_JPRB, 0.37692561E-03_JPRB, &
  & 0.37703025E-03_JPRB, 0.37713932E-03_JPRB, 0.37731603E-03_JPRB, 0.37773327E-03_JPRB, 0.37834762E-03_JPRB, 0.37902770E-03_JPRB, &
  & 0.37973071E-03_JPRB, 0.38036374E-03_JPRB, 0.38082606E-03_JPRB, 0.38113027E-03_JPRB, 0.38140259E-03_JPRB, 0.38179255E-03_JPRB, &
  & 0.38234658E-03_JPRB, 0.38281719E-03_JPRB, 0.38311170E-03_JPRB, 0.38325010E-03_JPRB, 0.38320946E-03_JPRB, 0.38296348E-03_JPRB, &
  & 0.38252133E-03_JPRB, 0.38198734E-03_JPRB, 0.38149141E-03_JPRB, 0.38102062E-03_JPRB, 0.38054507E-03_JPRB, 0.38016967E-03_JPRB, &
  & 0.37987215E-03_JPRB, 0.37966737E-03_JPRB, 0.37950317E-03_JPRB, 0.37931873E-03_JPRB, 0.37914348E-03_JPRB, 0.37897064E-03_JPRB, &
  & 0.37880181E-03_JPRB, 0.37859641E-03_JPRB, 0.37837876E-03_JPRB, 0.37817345E-03_JPRB, 0.37798363E-03_JPRB, 0.37783721E-03_JPRB, &
  & 0.37772776E-03_JPRB, 0.37763362E-03_JPRB, 0.37759827E-03_JPRB, 0.37760718E-03_JPRB, 0.37765498E-03_JPRB, 0.37771207E-03_JPRB, &
  & 0.37781643E-03_JPRB, 0.37794623E-03_JPRB, 0.37806094E-03_JPRB, 0.37813734E-03_JPRB  /)

RGHG1(:,29,12) = (/ &
  & 0.37651214E-03_JPRB, 0.37643141E-03_JPRB, 0.37638133E-03_JPRB, 0.37635913E-03_JPRB, 0.37636082E-03_JPRB, 0.37636374E-03_JPRB, &
  & 0.37638105E-03_JPRB, 0.37639209E-03_JPRB, 0.37641522E-03_JPRB, 0.37644110E-03_JPRB, 0.37647050E-03_JPRB, 0.37651430E-03_JPRB, &
  & 0.37657280E-03_JPRB, 0.37663237E-03_JPRB, 0.37672671E-03_JPRB, 0.37685612E-03_JPRB, 0.37700851E-03_JPRB, 0.37715386E-03_JPRB, &
  & 0.37727304E-03_JPRB, 0.37738411E-03_JPRB, 0.37757713E-03_JPRB, 0.37800440E-03_JPRB, 0.37865104E-03_JPRB, 0.37937305E-03_JPRB, &
  & 0.38010456E-03_JPRB, 0.38075704E-03_JPRB, 0.38119277E-03_JPRB, 0.38145417E-03_JPRB, 0.38169059E-03_JPRB, 0.38205983E-03_JPRB, &
  & 0.38255917E-03_JPRB, 0.38293445E-03_JPRB, 0.38314808E-03_JPRB, 0.38324142E-03_JPRB, 0.38319026E-03_JPRB, 0.38295264E-03_JPRB, &
  & 0.38249611E-03_JPRB, 0.38198822E-03_JPRB, 0.38157052E-03_JPRB, 0.38117289E-03_JPRB, 0.38078047E-03_JPRB, 0.38043711E-03_JPRB, &
  & 0.38015092E-03_JPRB, 0.37997104E-03_JPRB, 0.37983864E-03_JPRB, 0.37967010E-03_JPRB, 0.37948642E-03_JPRB, 0.37929631E-03_JPRB, &
  & 0.37913406E-03_JPRB, 0.37894393E-03_JPRB, 0.37873495E-03_JPRB, 0.37854634E-03_JPRB, 0.37838423E-03_JPRB, 0.37826455E-03_JPRB, &
  & 0.37818073E-03_JPRB, 0.37811743E-03_JPRB, 0.37811219E-03_JPRB, 0.37814006E-03_JPRB, 0.37821219E-03_JPRB, 0.37829153E-03_JPRB, &
  & 0.37841974E-03_JPRB, 0.37856343E-03_JPRB, 0.37867573E-03_JPRB, 0.37874162E-03_JPRB  /)

RGHG1(:,30,12) = (/ &
  & 0.37636208E-03_JPRB, 0.37629955E-03_JPRB, 0.37624105E-03_JPRB, 0.37620854E-03_JPRB, 0.37620027E-03_JPRB, 0.37620163E-03_JPRB, &
  & 0.37621302E-03_JPRB, 0.37622511E-03_JPRB, 0.37626771E-03_JPRB, 0.37632832E-03_JPRB, 0.37640253E-03_JPRB, 0.37650131E-03_JPRB, &
  & 0.37663257E-03_JPRB, 0.37677775E-03_JPRB, 0.37696194E-03_JPRB, 0.37715426E-03_JPRB, 0.37734197E-03_JPRB, 0.37750959E-03_JPRB, &
  & 0.37764465E-03_JPRB, 0.37777760E-03_JPRB, 0.37800189E-03_JPRB, 0.37842790E-03_JPRB, 0.37903823E-03_JPRB, 0.37973763E-03_JPRB, &
  & 0.38044024E-03_JPRB, 0.38106232E-03_JPRB, 0.38149973E-03_JPRB, 0.38177591E-03_JPRB, 0.38201702E-03_JPRB, 0.38234723E-03_JPRB, &
  & 0.38273532E-03_JPRB, 0.38300038E-03_JPRB, 0.38313648E-03_JPRB, 0.38317503E-03_JPRB, 0.38309973E-03_JPRB, 0.38286232E-03_JPRB, &
  & 0.38244134E-03_JPRB, 0.38200445E-03_JPRB, 0.38164756E-03_JPRB, 0.38128641E-03_JPRB, 0.38093180E-03_JPRB, 0.38062552E-03_JPRB, &
  & 0.38036452E-03_JPRB, 0.38018212E-03_JPRB, 0.38004538E-03_JPRB, 0.37989647E-03_JPRB, 0.37972372E-03_JPRB, 0.37954446E-03_JPRB, &
  & 0.37939202E-03_JPRB, 0.37921023E-03_JPRB, 0.37901586E-03_JPRB, 0.37884413E-03_JPRB, 0.37871422E-03_JPRB, 0.37861982E-03_JPRB, &
  & 0.37855345E-03_JPRB, 0.37851409E-03_JPRB, 0.37852984E-03_JPRB, 0.37858263E-03_JPRB, 0.37867503E-03_JPRB, 0.37877507E-03_JPRB, &
  & 0.37891451E-03_JPRB, 0.37905074E-03_JPRB, 0.37915690E-03_JPRB, 0.37922906E-03_JPRB  /)

RGHG1(:,31,12) = (/ &
  & 0.37620382E-03_JPRB, 0.37616048E-03_JPRB, 0.37609313E-03_JPRB, 0.37604975E-03_JPRB, 0.37603100E-03_JPRB, 0.37603072E-03_JPRB, &
  & 0.37603586E-03_JPRB, 0.37604906E-03_JPRB, 0.37611220E-03_JPRB, 0.37620942E-03_JPRB, 0.37633088E-03_JPRB, 0.37648762E-03_JPRB, &
  & 0.37669560E-03_JPRB, 0.37693103E-03_JPRB, 0.37720994E-03_JPRB, 0.37746855E-03_JPRB, 0.37769347E-03_JPRB, 0.37788452E-03_JPRB, &
  & 0.37803633E-03_JPRB, 0.37819234E-03_JPRB, 0.37844959E-03_JPRB, 0.37887426E-03_JPRB, 0.37944627E-03_JPRB, 0.38012179E-03_JPRB, &
  & 0.38079390E-03_JPRB, 0.38138391E-03_JPRB, 0.38182309E-03_JPRB, 0.38211490E-03_JPRB, 0.38236100E-03_JPRB, 0.38265006E-03_JPRB, &
  & 0.38292089E-03_JPRB, 0.38306980E-03_JPRB, 0.38312420E-03_JPRB, 0.38310501E-03_JPRB, 0.38300426E-03_JPRB, 0.38276708E-03_JPRB, &
  & 0.38238360E-03_JPRB, 0.38202156E-03_JPRB, 0.38172874E-03_JPRB, 0.38140598E-03_JPRB, 0.38109118E-03_JPRB, 0.38082396E-03_JPRB, &
  & 0.38058953E-03_JPRB, 0.38040445E-03_JPRB, 0.38026309E-03_JPRB, 0.38013487E-03_JPRB, 0.37997365E-03_JPRB, 0.37980585E-03_JPRB, &
  & 0.37966376E-03_JPRB, 0.37949074E-03_JPRB, 0.37931178E-03_JPRB, 0.37915783E-03_JPRB, 0.37906184E-03_JPRB, 0.37899409E-03_JPRB, &
  & 0.37894609E-03_JPRB, 0.37893196E-03_JPRB, 0.37896980E-03_JPRB, 0.37904886E-03_JPRB, 0.37916262E-03_JPRB, 0.37928445E-03_JPRB, &
  & 0.37943573E-03_JPRB, 0.37956407E-03_JPRB, 0.37966375E-03_JPRB, 0.37974253E-03_JPRB  /)

RGHG1(:,32,12) = (/ &
  & 0.37607368E-03_JPRB, 0.37602870E-03_JPRB, 0.37594779E-03_JPRB, 0.37589842E-03_JPRB, 0.37587191E-03_JPRB, 0.37588038E-03_JPRB, &
  & 0.37591585E-03_JPRB, 0.37596451E-03_JPRB, 0.37607132E-03_JPRB, 0.37622847E-03_JPRB, 0.37641991E-03_JPRB, 0.37667058E-03_JPRB, &
  & 0.37699122E-03_JPRB, 0.37734536E-03_JPRB, 0.37768447E-03_JPRB, 0.37798768E-03_JPRB, 0.37824984E-03_JPRB, 0.37848608E-03_JPRB, &
  & 0.37866939E-03_JPRB, 0.37883927E-03_JPRB, 0.37909736E-03_JPRB, 0.37948409E-03_JPRB, 0.37998670E-03_JPRB, 0.38056990E-03_JPRB, &
  & 0.38115926E-03_JPRB, 0.38169733E-03_JPRB, 0.38214127E-03_JPRB, 0.38247218E-03_JPRB, 0.38274171E-03_JPRB, 0.38298039E-03_JPRB, &
  & 0.38314443E-03_JPRB, 0.38318327E-03_JPRB, 0.38315500E-03_JPRB, 0.38307485E-03_JPRB, 0.38293134E-03_JPRB, 0.38269849E-03_JPRB, &
  & 0.38239577E-03_JPRB, 0.38211330E-03_JPRB, 0.38187148E-03_JPRB, 0.38160329E-03_JPRB, 0.38134141E-03_JPRB, 0.38110637E-03_JPRB, &
  & 0.38088680E-03_JPRB, 0.38069813E-03_JPRB, 0.38054363E-03_JPRB, 0.38041158E-03_JPRB, 0.38025931E-03_JPRB, 0.38010631E-03_JPRB, &
  & 0.37996788E-03_JPRB, 0.37980320E-03_JPRB, 0.37963541E-03_JPRB, 0.37949020E-03_JPRB, 0.37940690E-03_JPRB, 0.37935455E-03_JPRB, &
  & 0.37932147E-03_JPRB, 0.37932630E-03_JPRB, 0.37939049E-03_JPRB, 0.37951049E-03_JPRB, 0.37966627E-03_JPRB, 0.37982639E-03_JPRB, &
  & 0.38000905E-03_JPRB, 0.38012693E-03_JPRB, 0.38021165E-03_JPRB, 0.38032254E-03_JPRB  /)

RGHG1(:,33,12) = (/ &
  & 0.37594208E-03_JPRB, 0.37589268E-03_JPRB, 0.37579708E-03_JPRB, 0.37574210E-03_JPRB, 0.37570790E-03_JPRB, 0.37572679E-03_JPRB, &
  & 0.37579852E-03_JPRB, 0.37588849E-03_JPRB, 0.37604367E-03_JPRB, 0.37626613E-03_JPRB, 0.37653325E-03_JPRB, 0.37688619E-03_JPRB, &
  & 0.37732855E-03_JPRB, 0.37780974E-03_JPRB, 0.37820696E-03_JPRB, 0.37855371E-03_JPRB, 0.37885459E-03_JPRB, 0.37914059E-03_JPRB, &
  & 0.37935855E-03_JPRB, 0.37954167E-03_JPRB, 0.37979646E-03_JPRB, 0.38013902E-03_JPRB, 0.38056547E-03_JPRB, 0.38104388E-03_JPRB, &
  & 0.38154049E-03_JPRB, 0.38202199E-03_JPRB, 0.38247125E-03_JPRB, 0.38284584E-03_JPRB, 0.38314212E-03_JPRB, 0.38332725E-03_JPRB, &
  & 0.38338167E-03_JPRB, 0.38330689E-03_JPRB, 0.38319259E-03_JPRB, 0.38304867E-03_JPRB, 0.38285847E-03_JPRB, 0.38263066E-03_JPRB, &
  & 0.38241747E-03_JPRB, 0.38221830E-03_JPRB, 0.38202779E-03_JPRB, 0.38181840E-03_JPRB, 0.38161323E-03_JPRB, 0.38141073E-03_JPRB, &
  & 0.38120509E-03_JPRB, 0.38101257E-03_JPRB, 0.38084330E-03_JPRB, 0.38070412E-03_JPRB, 0.38056080E-03_JPRB, 0.38042363E-03_JPRB, &
  & 0.38028814E-03_JPRB, 0.38013207E-03_JPRB, 0.37997534E-03_JPRB, 0.37983804E-03_JPRB, 0.37976516E-03_JPRB, 0.37972738E-03_JPRB, &
  & 0.37970934E-03_JPRB, 0.37973308E-03_JPRB, 0.37982520E-03_JPRB, 0.37998965E-03_JPRB, 0.38019177E-03_JPRB, 0.38039382E-03_JPRB, &
  & 0.38061162E-03_JPRB, 0.38071830E-03_JPRB, 0.38078636E-03_JPRB, 0.38093393E-03_JPRB  /)

RGHG1(:,34,12) = (/ &
  & 0.37582240E-03_JPRB, 0.37578254E-03_JPRB, 0.37570834E-03_JPRB, 0.37569145E-03_JPRB, 0.37567319E-03_JPRB, 0.37569998E-03_JPRB, &
  & 0.37580582E-03_JPRB, 0.37595839E-03_JPRB, 0.37617607E-03_JPRB, 0.37647380E-03_JPRB, 0.37682924E-03_JPRB, 0.37729074E-03_JPRB, &
  & 0.37783884E-03_JPRB, 0.37839866E-03_JPRB, 0.37882799E-03_JPRB, 0.37919645E-03_JPRB, 0.37951370E-03_JPRB, 0.37980186E-03_JPRB, &
  & 0.38000557E-03_JPRB, 0.38016414E-03_JPRB, 0.38038813E-03_JPRB, 0.38068167E-03_JPRB, 0.38104748E-03_JPRB, 0.38145383E-03_JPRB, &
  & 0.38189635E-03_JPRB, 0.38234747E-03_JPRB, 0.38279403E-03_JPRB, 0.38318047E-03_JPRB, 0.38347705E-03_JPRB, 0.38363642E-03_JPRB, &
  & 0.38361646E-03_JPRB, 0.38347490E-03_JPRB, 0.38331620E-03_JPRB, 0.38312256E-03_JPRB, 0.38287774E-03_JPRB, 0.38263299E-03_JPRB, &
  & 0.38246048E-03_JPRB, 0.38231568E-03_JPRB, 0.38216219E-03_JPRB, 0.38198914E-03_JPRB, 0.38182131E-03_JPRB, 0.38164845E-03_JPRB, &
  & 0.38147501E-03_JPRB, 0.38130662E-03_JPRB, 0.38113930E-03_JPRB, 0.38100343E-03_JPRB, 0.38087009E-03_JPRB, 0.38074286E-03_JPRB, &
  & 0.38061299E-03_JPRB, 0.38046210E-03_JPRB, 0.38031887E-03_JPRB, 0.38019129E-03_JPRB, 0.38012703E-03_JPRB, 0.38010045E-03_JPRB, &
  & 0.38009801E-03_JPRB, 0.38014431E-03_JPRB, 0.38025875E-03_JPRB, 0.38046480E-03_JPRB, 0.38071724E-03_JPRB, 0.38097149E-03_JPRB, &
  & 0.38124127E-03_JPRB, 0.38136694E-03_JPRB, 0.38140184E-03_JPRB, 0.38154280E-03_JPRB  /)

RGHG1(:,35,12) = (/ &
  & 0.37570548E-03_JPRB, 0.37568257E-03_JPRB, 0.37564890E-03_JPRB, 0.37569360E-03_JPRB, 0.37570385E-03_JPRB, 0.37573746E-03_JPRB, &
  & 0.37587728E-03_JPRB, 0.37610513E-03_JPRB, 0.37639432E-03_JPRB, 0.37677455E-03_JPRB, 0.37722730E-03_JPRB, 0.37780364E-03_JPRB, &
  & 0.37845223E-03_JPRB, 0.37906804E-03_JPRB, 0.37951705E-03_JPRB, 0.37989662E-03_JPRB, 0.38021926E-03_JPRB, 0.38048521E-03_JPRB, &
  & 0.38064916E-03_JPRB, 0.38076310E-03_JPRB, 0.38094130E-03_JPRB, 0.38118197E-03_JPRB, 0.38149341E-03_JPRB, 0.38184247E-03_JPRB, &
  & 0.38224919E-03_JPRB, 0.38268252E-03_JPRB, 0.38312219E-03_JPRB, 0.38350447E-03_JPRB, 0.38378780E-03_JPRB, 0.38393497E-03_JPRB, &
  & 0.38385661E-03_JPRB, 0.38367042E-03_JPRB, 0.38348743E-03_JPRB, 0.38324988E-03_JPRB, 0.38294484E-03_JPRB, 0.38267137E-03_JPRB, &
  & 0.38251562E-03_JPRB, 0.38241188E-03_JPRB, 0.38228911E-03_JPRB, 0.38214192E-03_JPRB, 0.38200254E-03_JPRB, 0.38185865E-03_JPRB, &
  & 0.38172769E-03_JPRB, 0.38159847E-03_JPRB, 0.38144174E-03_JPRB, 0.38131464E-03_JPRB, 0.38119208E-03_JPRB, 0.38107207E-03_JPRB, &
  & 0.38094933E-03_JPRB, 0.38080202E-03_JPRB, 0.38067393E-03_JPRB, 0.38055726E-03_JPRB, 0.38050092E-03_JPRB, 0.38048416E-03_JPRB, &
  & 0.38049802E-03_JPRB, 0.38056938E-03_JPRB, 0.38070390E-03_JPRB, 0.38095126E-03_JPRB, 0.38125749E-03_JPRB, 0.38157065E-03_JPRB, &
  & 0.38190254E-03_JPRB, 0.38206322E-03_JPRB, 0.38205557E-03_JPRB, 0.38216749E-03_JPRB  /)

RGHG1(:,36,12) = (/ &
  & 0.37567288E-03_JPRB, 0.37567139E-03_JPRB, 0.37569019E-03_JPRB, 0.37580356E-03_JPRB, 0.37583158E-03_JPRB, 0.37587294E-03_JPRB, &
  & 0.37605148E-03_JPRB, 0.37635602E-03_JPRB, 0.37671368E-03_JPRB, 0.37716511E-03_JPRB, 0.37771092E-03_JPRB, 0.37838767E-03_JPRB, &
  & 0.37911234E-03_JPRB, 0.37976604E-03_JPRB, 0.38022545E-03_JPRB, 0.38059694E-03_JPRB, 0.38089761E-03_JPRB, 0.38111367E-03_JPRB, &
  & 0.38122771E-03_JPRB, 0.38128912E-03_JPRB, 0.38141499E-03_JPRB, 0.38160241E-03_JPRB, 0.38186422E-03_JPRB, 0.38217275E-03_JPRB, &
  & 0.38256797E-03_JPRB, 0.38300643E-03_JPRB, 0.38344770E-03_JPRB, 0.38380769E-03_JPRB, 0.38407003E-03_JPRB, 0.38420218E-03_JPRB, &
  & 0.38407938E-03_JPRB, 0.38387057E-03_JPRB, 0.38368271E-03_JPRB, 0.38341138E-03_JPRB, 0.38306072E-03_JPRB, 0.38276140E-03_JPRB, &
  & 0.38260401E-03_JPRB, 0.38251988E-03_JPRB, 0.38241216E-03_JPRB, 0.38227743E-03_JPRB, 0.38215672E-03_JPRB, 0.38203909E-03_JPRB, &
  & 0.38194630E-03_JPRB, 0.38185401E-03_JPRB, 0.38171684E-03_JPRB, 0.38160352E-03_JPRB, 0.38149520E-03_JPRB, 0.38138324E-03_JPRB, &
  & 0.38127081E-03_JPRB, 0.38113420E-03_JPRB, 0.38102360E-03_JPRB, 0.38091980E-03_JPRB, 0.38087282E-03_JPRB, 0.38087545E-03_JPRB, &
  & 0.38091154E-03_JPRB, 0.38100804E-03_JPRB, 0.38116119E-03_JPRB, 0.38144506E-03_JPRB, 0.38180214E-03_JPRB, 0.38217600E-03_JPRB, &
  & 0.38257691E-03_JPRB, 0.38278343E-03_JPRB, 0.38274316E-03_JPRB, 0.38275256E-03_JPRB  /)

RGHG1(:,37,12) = (/ &
  & 0.37583562E-03_JPRB, 0.37586448E-03_JPRB, 0.37595985E-03_JPRB, 0.37615387E-03_JPRB, 0.37617391E-03_JPRB, 0.37622469E-03_JPRB, &
  & 0.37645042E-03_JPRB, 0.37683009E-03_JPRB, 0.37724497E-03_JPRB, 0.37773729E-03_JPRB, 0.37836063E-03_JPRB, 0.37909843E-03_JPRB, &
  & 0.37983851E-03_JPRB, 0.38048621E-03_JPRB, 0.38093411E-03_JPRB, 0.38125403E-03_JPRB, 0.38147135E-03_JPRB, 0.38157720E-03_JPRB, &
  & 0.38162114E-03_JPRB, 0.38161514E-03_JPRB, 0.38167697E-03_JPRB, 0.38181361E-03_JPRB, 0.38203974E-03_JPRB, 0.38234869E-03_JPRB, &
  & 0.38278882E-03_JPRB, 0.38328467E-03_JPRB, 0.38374686E-03_JPRB, 0.38404437E-03_JPRB, 0.38426929E-03_JPRB, 0.38438093E-03_JPRB, &
  & 0.38424848E-03_JPRB, 0.38406887E-03_JPRB, 0.38392101E-03_JPRB, 0.38364122E-03_JPRB, 0.38328120E-03_JPRB, 0.38296420E-03_JPRB, &
  & 0.38276309E-03_JPRB, 0.38264820E-03_JPRB, 0.38251866E-03_JPRB, 0.38236492E-03_JPRB, 0.38223929E-03_JPRB, 0.38214007E-03_JPRB, &
  & 0.38207318E-03_JPRB, 0.38201040E-03_JPRB, 0.38191214E-03_JPRB, 0.38182323E-03_JPRB, 0.38173620E-03_JPRB, 0.38163371E-03_JPRB, &
  & 0.38153819E-03_JPRB, 0.38142797E-03_JPRB, 0.38133920E-03_JPRB, 0.38125194E-03_JPRB, 0.38121702E-03_JPRB, 0.38125982E-03_JPRB, &
  & 0.38133033E-03_JPRB, 0.38145051E-03_JPRB, 0.38161788E-03_JPRB, 0.38192496E-03_JPRB, 0.38232299E-03_JPRB, 0.38275790E-03_JPRB, &
  & 0.38323940E-03_JPRB, 0.38351374E-03_JPRB, 0.38346561E-03_JPRB, 0.38321038E-03_JPRB  /)

RGHG1(:,38,12) = (/ &
  & 0.37601620E-03_JPRB, 0.37607872E-03_JPRB, 0.37625906E-03_JPRB, 0.37654257E-03_JPRB, 0.37655377E-03_JPRB, 0.37661499E-03_JPRB, &
  & 0.37689308E-03_JPRB, 0.37735613E-03_JPRB, 0.37783447E-03_JPRB, 0.37837218E-03_JPRB, 0.37908155E-03_JPRB, 0.37988708E-03_JPRB, &
  & 0.38064425E-03_JPRB, 0.38128530E-03_JPRB, 0.38172043E-03_JPRB, 0.38198312E-03_JPRB, 0.38210796E-03_JPRB, 0.38209152E-03_JPRB, &
  & 0.38205768E-03_JPRB, 0.38197690E-03_JPRB, 0.38196767E-03_JPRB, 0.38204795E-03_JPRB, 0.38223449E-03_JPRB, 0.38254390E-03_JPRB, &
  & 0.38303387E-03_JPRB, 0.38359339E-03_JPRB, 0.38407881E-03_JPRB, 0.38430698E-03_JPRB, 0.38449039E-03_JPRB, 0.38457927E-03_JPRB, &
  & 0.38443611E-03_JPRB, 0.38428891E-03_JPRB, 0.38418543E-03_JPRB, 0.38389626E-03_JPRB, 0.38352586E-03_JPRB, 0.38318922E-03_JPRB, &
  & 0.38293961E-03_JPRB, 0.38279059E-03_JPRB, 0.38263682E-03_JPRB, 0.38246200E-03_JPRB, 0.38233091E-03_JPRB, 0.38225211E-03_JPRB, &
  & 0.38221397E-03_JPRB, 0.38218392E-03_JPRB, 0.38212885E-03_JPRB, 0.38206701E-03_JPRB, 0.38200361E-03_JPRB, 0.38191163E-03_JPRB, &
  & 0.38183487E-03_JPRB, 0.38175393E-03_JPRB, 0.38168938E-03_JPRB, 0.38162049E-03_JPRB, 0.38159893E-03_JPRB, 0.38168632E-03_JPRB, &
  & 0.38179502E-03_JPRB, 0.38194148E-03_JPRB, 0.38212462E-03_JPRB, 0.38245744E-03_JPRB, 0.38290092E-03_JPRB, 0.38340356E-03_JPRB, &
  & 0.38397448E-03_JPRB, 0.38432408E-03_JPRB, 0.38426723E-03_JPRB, 0.38371838E-03_JPRB  /)

RGHG1(:,39,12) = (/ &
  & 0.37643947E-03_JPRB, 0.37651377E-03_JPRB, 0.37672691E-03_JPRB, 0.37707410E-03_JPRB, 0.37704291E-03_JPRB, 0.37714059E-03_JPRB, &
  & 0.37747098E-03_JPRB, 0.37796944E-03_JPRB, 0.37846183E-03_JPRB, 0.37902394E-03_JPRB, 0.37976039E-03_JPRB, 0.38054784E-03_JPRB, &
  & 0.38126179E-03_JPRB, 0.38185445E-03_JPRB, 0.38226342E-03_JPRB, 0.38245925E-03_JPRB, 0.38248299E-03_JPRB, 0.38236075E-03_JPRB, &
  & 0.38223212E-03_JPRB, 0.38209443E-03_JPRB, 0.38202903E-03_JPRB, 0.38208236E-03_JPRB, 0.38228129E-03_JPRB, 0.38261215E-03_JPRB, &
  & 0.38315555E-03_JPRB, 0.38376148E-03_JPRB, 0.38423978E-03_JPRB, 0.38443396E-03_JPRB, 0.38459061E-03_JPRB, 0.38467470E-03_JPRB, &
  & 0.38458422E-03_JPRB, 0.38449644E-03_JPRB, 0.38443136E-03_JPRB, 0.38419584E-03_JPRB, 0.38386413E-03_JPRB, 0.38352332E-03_JPRB, &
  & 0.38321509E-03_JPRB, 0.38300666E-03_JPRB, 0.38280619E-03_JPRB, 0.38259447E-03_JPRB, 0.38241323E-03_JPRB, 0.38232627E-03_JPRB, &
  & 0.38228140E-03_JPRB, 0.38225019E-03_JPRB, 0.38221901E-03_JPRB, 0.38218212E-03_JPRB, 0.38214367E-03_JPRB, 0.38208068E-03_JPRB, &
  & 0.38204001E-03_JPRB, 0.38199313E-03_JPRB, 0.38196016E-03_JPRB, 0.38191955E-03_JPRB, 0.38192686E-03_JPRB, 0.38204885E-03_JPRB, &
  & 0.38219232E-03_JPRB, 0.38235248E-03_JPRB, 0.38255487E-03_JPRB, 0.38289477E-03_JPRB, 0.38334409E-03_JPRB, 0.38391068E-03_JPRB, &
  & 0.38455375E-03_JPRB, 0.38495237E-03_JPRB, 0.38487043E-03_JPRB, 0.38410826E-03_JPRB  /)

RGHG1(:,40,12) = (/ &
  & 0.37697592E-03_JPRB, 0.37706046E-03_JPRB, 0.37730354E-03_JPRB, 0.37772126E-03_JPRB, 0.37763484E-03_JPRB, 0.37777956E-03_JPRB, &
  & 0.37817132E-03_JPRB, 0.37870351E-03_JPRB, 0.37920427E-03_JPRB, 0.37979159E-03_JPRB, 0.38055019E-03_JPRB, 0.38130238E-03_JPRB, &
  & 0.38195573E-03_JPRB, 0.38248478E-03_JPRB, 0.38286086E-03_JPRB, 0.38297663E-03_JPRB, 0.38288032E-03_JPRB, 0.38263663E-03_JPRB, &
  & 0.38239395E-03_JPRB, 0.38219240E-03_JPRB, 0.38206352E-03_JPRB, 0.38209004E-03_JPRB, 0.38231200E-03_JPRB, 0.38267147E-03_JPRB, &
  & 0.38327816E-03_JPRB, 0.38393573E-03_JPRB, 0.38440072E-03_JPRB, 0.38456080E-03_JPRB, 0.38468846E-03_JPRB, 0.38476986E-03_JPRB, &
  & 0.38475156E-03_JPRB, 0.38473794E-03_JPRB, 0.38471696E-03_JPRB, 0.38455471E-03_JPRB, 0.38427643E-03_JPRB, 0.38393326E-03_JPRB, &
  & 0.38355457E-03_JPRB, 0.38327229E-03_JPRB, 0.38301334E-03_JPRB, 0.38275573E-03_JPRB, 0.38250833E-03_JPRB, 0.38240709E-03_JPRB, &
  & 0.38234853E-03_JPRB, 0.38231040E-03_JPRB, 0.38230412E-03_JPRB, 0.38229616E-03_JPRB, 0.38228720E-03_JPRB, 0.38226127E-03_JPRB, &
  & 0.38226578E-03_JPRB, 0.38225966E-03_JPRB, 0.38226496E-03_JPRB, 0.38225916E-03_JPRB, 0.38230288E-03_JPRB, 0.38246384E-03_JPRB, &
  & 0.38264756E-03_JPRB, 0.38282174E-03_JPRB, 0.38304730E-03_JPRB, 0.38339244E-03_JPRB, 0.38384215E-03_JPRB, 0.38448316E-03_JPRB, &
  & 0.38520808E-03_JPRB, 0.38565994E-03_JPRB, 0.38554588E-03_JPRB, 0.38454648E-03_JPRB  /)

RGHG1(:,41,12) = (/ &
  & 0.37763181E-03_JPRB, 0.37772887E-03_JPRB, 0.37800857E-03_JPRB, 0.37851250E-03_JPRB, 0.37835857E-03_JPRB, 0.37856079E-03_JPRB, &
  & 0.37902758E-03_JPRB, 0.37960100E-03_JPRB, 0.38011201E-03_JPRB, 0.38073016E-03_JPRB, 0.38151583E-03_JPRB, 0.38222491E-03_JPRB, &
  & 0.38280416E-03_JPRB, 0.38325545E-03_JPRB, 0.38359131E-03_JPRB, 0.38360920E-03_JPRB, 0.38336612E-03_JPRB, 0.38297392E-03_JPRB, &
  & 0.38259182E-03_JPRB, 0.38231219E-03_JPRB, 0.38210569E-03_JPRB, 0.38209943E-03_JPRB, 0.38234956E-03_JPRB, 0.38274400E-03_JPRB, &
  & 0.38342807E-03_JPRB, 0.38414878E-03_JPRB, 0.38459750E-03_JPRB, 0.38471587E-03_JPRB, 0.38480809E-03_JPRB, 0.38488620E-03_JPRB, &
  & 0.38495615E-03_JPRB, 0.38503322E-03_JPRB, 0.38506615E-03_JPRB, 0.38499348E-03_JPRB, 0.38478053E-03_JPRB, 0.38443446E-03_JPRB, &
  & 0.38396963E-03_JPRB, 0.38359707E-03_JPRB, 0.38326660E-03_JPRB, 0.38295290E-03_JPRB, 0.38262459E-03_JPRB, 0.38250591E-03_JPRB, &
  & 0.38243060E-03_JPRB, 0.38238403E-03_JPRB, 0.38240818E-03_JPRB, 0.38243558E-03_JPRB, 0.38246270E-03_JPRB, 0.38248206E-03_JPRB, &
  & 0.38254181E-03_JPRB, 0.38258553E-03_JPRB, 0.38263761E-03_JPRB, 0.38267438E-03_JPRB, 0.38276262E-03_JPRB, 0.38297123E-03_JPRB, &
  & 0.38320416E-03_JPRB, 0.38339547E-03_JPRB, 0.38364935E-03_JPRB, 0.38400091E-03_JPRB, 0.38445109E-03_JPRB, 0.38518310E-03_JPRB, &
  & 0.38600808E-03_JPRB, 0.38652504E-03_JPRB, 0.38637170E-03_JPRB, 0.38508227E-03_JPRB  /)

RGHG1(:,42,12) = (/ &
  & 0.37796056E-03_JPRB, 0.37800307E-03_JPRB, 0.37821230E-03_JPRB, 0.37866738E-03_JPRB, 0.37862336E-03_JPRB, 0.37883746E-03_JPRB, &
  & 0.37930923E-03_JPRB, 0.37985881E-03_JPRB, 0.38037675E-03_JPRB, 0.38100921E-03_JPRB, 0.38172798E-03_JPRB, 0.38236509E-03_JPRB, &
  & 0.38289452E-03_JPRB, 0.38328655E-03_JPRB, 0.38355221E-03_JPRB, 0.38351762E-03_JPRB, 0.38324384E-03_JPRB, 0.38284112E-03_JPRB, &
  & 0.38245083E-03_JPRB, 0.38218204E-03_JPRB, 0.38201399E-03_JPRB, 0.38205051E-03_JPRB, 0.38232229E-03_JPRB, 0.38275802E-03_JPRB, &
  & 0.38346017E-03_JPRB, 0.38420449E-03_JPRB, 0.38472685E-03_JPRB, 0.38488274E-03_JPRB, 0.38495318E-03_JPRB, 0.38498065E-03_JPRB, &
  & 0.38503792E-03_JPRB, 0.38513103E-03_JPRB, 0.38517559E-03_JPRB, 0.38515128E-03_JPRB, 0.38497656E-03_JPRB, 0.38467068E-03_JPRB, &
  & 0.38422726E-03_JPRB, 0.38378924E-03_JPRB, 0.38341560E-03_JPRB, 0.38305061E-03_JPRB, 0.38270715E-03_JPRB, 0.38252462E-03_JPRB, &
  & 0.38239817E-03_JPRB, 0.38232259E-03_JPRB, 0.38235405E-03_JPRB, 0.38239226E-03_JPRB, 0.38242936E-03_JPRB, 0.38249022E-03_JPRB, &
  & 0.38261553E-03_JPRB, 0.38269793E-03_JPRB, 0.38279892E-03_JPRB, 0.38288871E-03_JPRB, 0.38300333E-03_JPRB, 0.38322272E-03_JPRB, &
  & 0.38347153E-03_JPRB, 0.38366965E-03_JPRB, 0.38388218E-03_JPRB, 0.38418123E-03_JPRB, 0.38459321E-03_JPRB, 0.38529568E-03_JPRB, &
  & 0.38613523E-03_JPRB, 0.38662294E-03_JPRB, 0.38641723E-03_JPRB, 0.38544480E-03_JPRB  /)

RGHG1(:,43,12) = (/ &
  & 0.37854263E-03_JPRB, 0.37854077E-03_JPRB, 0.37870146E-03_JPRB, 0.37914905E-03_JPRB, 0.37917626E-03_JPRB, 0.37942594E-03_JPRB, &
  & 0.37993452E-03_JPRB, 0.38048009E-03_JPRB, 0.38100876E-03_JPRB, 0.38166754E-03_JPRB, 0.38233692E-03_JPRB, 0.38288983E-03_JPRB, &
  & 0.38334192E-03_JPRB, 0.38364643E-03_JPRB, 0.38383075E-03_JPRB, 0.38370617E-03_JPRB, 0.38334124E-03_JPRB, 0.38286505E-03_JPRB, &
  & 0.38240730E-03_JPRB, 0.38211481E-03_JPRB, 0.38194847E-03_JPRB, 0.38200991E-03_JPRB, 0.38231357E-03_JPRB, 0.38280201E-03_JPRB, &
  & 0.38355394E-03_JPRB, 0.38434696E-03_JPRB, 0.38492952E-03_JPRB, 0.38510169E-03_JPRB, 0.38513702E-03_JPRB, 0.38511687E-03_JPRB, &
  & 0.38520054E-03_JPRB, 0.38534728E-03_JPRB, 0.38542564E-03_JPRB, 0.38548399E-03_JPRB, 0.38537225E-03_JPRB, 0.38510179E-03_JPRB, &
  & 0.38464086E-03_JPRB, 0.38410428E-03_JPRB, 0.38366048E-03_JPRB, 0.38322456E-03_JPRB, 0.38283249E-03_JPRB, 0.38258420E-03_JPRB, &
  & 0.38240388E-03_JPRB, 0.38229820E-03_JPRB, 0.38234942E-03_JPRB, 0.38241272E-03_JPRB, 0.38247443E-03_JPRB, 0.38259263E-03_JPRB, &
  & 0.38280153E-03_JPRB, 0.38294065E-03_JPRB, 0.38310640E-03_JPRB, 0.38326287E-03_JPRB, 0.38342071E-03_JPRB, 0.38367043E-03_JPRB, &
  & 0.38395490E-03_JPRB, 0.38416660E-03_JPRB, 0.38435358E-03_JPRB, 0.38460748E-03_JPRB, 0.38498481E-03_JPRB, 0.38569947E-03_JPRB, &
  & 0.38659537E-03_JPRB, 0.38708438E-03_JPRB, 0.38681401E-03_JPRB, 0.38600603E-03_JPRB  /)

RGHG1(:,44,12) = (/ &
  & 0.37851880E-03_JPRB, 0.37844514E-03_JPRB, 0.37852558E-03_JPRB, 0.37893246E-03_JPRB, 0.37900581E-03_JPRB, 0.37923998E-03_JPRB, &
  & 0.37978762E-03_JPRB, 0.38037047E-03_JPRB, 0.38094355E-03_JPRB, 0.38163139E-03_JPRB, 0.38227932E-03_JPRB, 0.38280534E-03_JPRB, &
  & 0.38320373E-03_JPRB, 0.38346503E-03_JPRB, 0.38360724E-03_JPRB, 0.38346486E-03_JPRB, 0.38310758E-03_JPRB, 0.38266541E-03_JPRB, &
  & 0.38226062E-03_JPRB, 0.38202534E-03_JPRB, 0.38190754E-03_JPRB, 0.38201827E-03_JPRB, 0.38235756E-03_JPRB, 0.38288867E-03_JPRB, &
  & 0.38365954E-03_JPRB, 0.38446039E-03_JPRB, 0.38506719E-03_JPRB, 0.38527232E-03_JPRB, 0.38529027E-03_JPRB, 0.38522269E-03_JPRB, &
  & 0.38526014E-03_JPRB, 0.38542254E-03_JPRB, 0.38551763E-03_JPRB, 0.38559812E-03_JPRB, 0.38551356E-03_JPRB, 0.38526331E-03_JPRB, &
  & 0.38483902E-03_JPRB, 0.38427156E-03_JPRB, 0.38377498E-03_JPRB, 0.38329667E-03_JPRB, 0.38289483E-03_JPRB, 0.38260631E-03_JPRB, &
  & 0.38238244E-03_JPRB, 0.38224333E-03_JPRB, 0.38226071E-03_JPRB, 0.38232887E-03_JPRB, 0.38240787E-03_JPRB, 0.38255747E-03_JPRB, &
  & 0.38282377E-03_JPRB, 0.38302082E-03_JPRB, 0.38322240E-03_JPRB, 0.38341295E-03_JPRB, 0.38360781E-03_JPRB, 0.38387178E-03_JPRB, &
  & 0.38413501E-03_JPRB, 0.38430731E-03_JPRB, 0.38445498E-03_JPRB, 0.38468457E-03_JPRB, 0.38501109E-03_JPRB, 0.38565287E-03_JPRB, &
  & 0.38646407E-03_JPRB, 0.38691418E-03_JPRB, 0.38672377E-03_JPRB, 0.38616474E-03_JPRB  /)

RGHG1(:,45,12) = (/ &
  & 0.37856519E-03_JPRB, 0.37840420E-03_JPRB, 0.37838716E-03_JPRB, 0.37874673E-03_JPRB, 0.37888161E-03_JPRB, 0.37910261E-03_JPRB, &
  & 0.37969937E-03_JPRB, 0.38032415E-03_JPRB, 0.38094915E-03_JPRB, 0.38167339E-03_JPRB, 0.38229067E-03_JPRB, 0.38277544E-03_JPRB, &
  & 0.38310291E-03_JPRB, 0.38330397E-03_JPRB, 0.38338798E-03_JPRB, 0.38321396E-03_JPRB, 0.38285389E-03_JPRB, 0.38244116E-03_JPRB, &
  & 0.38208813E-03_JPRB, 0.38191499E-03_JPRB, 0.38185267E-03_JPRB, 0.38202266E-03_JPRB, 0.38240652E-03_JPRB, 0.38299289E-03_JPRB, &
  & 0.38379161E-03_JPRB, 0.38460752E-03_JPRB, 0.38524951E-03_JPRB, 0.38549423E-03_JPRB, 0.38548795E-03_JPRB, 0.38536036E-03_JPRB, &
  & 0.38534854E-03_JPRB, 0.38553554E-03_JPRB, 0.38565394E-03_JPRB, 0.38577008E-03_JPRB, 0.38572442E-03_JPRB, 0.38550164E-03_JPRB, &
  & 0.38511685E-03_JPRB, 0.38450179E-03_JPRB, 0.38393627E-03_JPRB, 0.38340074E-03_JPRB, 0.38298164E-03_JPRB, 0.38263901E-03_JPRB, &
  & 0.38235875E-03_JPRB, 0.38217779E-03_JPRB, 0.38215914E-03_JPRB, 0.38223601E-03_JPRB, 0.38233778E-03_JPRB, 0.38253037E-03_JPRB, &
  & 0.38287259E-03_JPRB, 0.38314275E-03_JPRB, 0.38339329E-03_JPRB, 0.38363107E-03_JPRB, 0.38387354E-03_JPRB, 0.38415757E-03_JPRB, &
  & 0.38440112E-03_JPRB, 0.38453028E-03_JPRB, 0.38462996E-03_JPRB, 0.38482618E-03_JPRB, 0.38509049E-03_JPRB, 0.38565083E-03_JPRB, &
  & 0.38637272E-03_JPRB, 0.38677870E-03_JPRB, 0.38667117E-03_JPRB, 0.38641632E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART24',0,ZHOOK_HANDLE)



RGHG1(:,46,12) = (/ &
  & 0.37828274E-03_JPRB, 0.37802162E-03_JPRB, 0.37782284E-03_JPRB, 0.37814828E-03_JPRB, 0.37831285E-03_JPRB, 0.37850299E-03_JPRB, &
  & 0.37912000E-03_JPRB, 0.37983441E-03_JPRB, 0.38051840E-03_JPRB, 0.38126872E-03_JPRB, 0.38186690E-03_JPRB, 0.38235482E-03_JPRB, &
  & 0.38267344E-03_JPRB, 0.38288576E-03_JPRB, 0.38297256E-03_JPRB, 0.38283403E-03_JPRB, 0.38253298E-03_JPRB, 0.38221993E-03_JPRB, &
  & 0.38195737E-03_JPRB, 0.38185146E-03_JPRB, 0.38183180E-03_JPRB, 0.38205567E-03_JPRB, 0.38248083E-03_JPRB, 0.38309150E-03_JPRB, &
  & 0.38390555E-03_JPRB, 0.38472536E-03_JPRB, 0.38537746E-03_JPRB, 0.38564148E-03_JPRB, 0.38562792E-03_JPRB, 0.38547765E-03_JPRB, &
  & 0.38541059E-03_JPRB, 0.38558306E-03_JPRB, 0.38570762E-03_JPRB, 0.38583840E-03_JPRB, 0.38582830E-03_JPRB, 0.38561499E-03_JPRB, &
  & 0.38525569E-03_JPRB, 0.38463302E-03_JPRB, 0.38403452E-03_JPRB, 0.38346773E-03_JPRB, 0.38303114E-03_JPRB, 0.38266200E-03_JPRB, &
  & 0.38236479E-03_JPRB, 0.38212719E-03_JPRB, 0.38205496E-03_JPRB, 0.38212122E-03_JPRB, 0.38222957E-03_JPRB, 0.38243567E-03_JPRB, &
  & 0.38282386E-03_JPRB, 0.38314727E-03_JPRB, 0.38343462E-03_JPRB, 0.38369099E-03_JPRB, 0.38394394E-03_JPRB, 0.38424083E-03_JPRB, &
  & 0.38446273E-03_JPRB, 0.38451843E-03_JPRB, 0.38457665E-03_JPRB, 0.38471862E-03_JPRB, 0.38490796E-03_JPRB, 0.38539942E-03_JPRB, &
  & 0.38597252E-03_JPRB, 0.38640748E-03_JPRB, 0.38637478E-03_JPRB, 0.38624012E-03_JPRB  /)

RGHG1(:,47,12) = (/ &
  & 0.37788543E-03_JPRB, 0.37750427E-03_JPRB, 0.37707534E-03_JPRB, 0.37736337E-03_JPRB, 0.37755640E-03_JPRB, 0.37770677E-03_JPRB, &
  & 0.37834177E-03_JPRB, 0.37917091E-03_JPRB, 0.37992555E-03_JPRB, 0.38070440E-03_JPRB, 0.38128246E-03_JPRB, 0.38178299E-03_JPRB, &
  & 0.38210366E-03_JPRB, 0.38234352E-03_JPRB, 0.38244580E-03_JPRB, 0.38236236E-03_JPRB, 0.38214295E-03_JPRB, 0.38196095E-03_JPRB, &
  & 0.38181229E-03_JPRB, 0.38178627E-03_JPRB, 0.38181412E-03_JPRB, 0.38210014E-03_JPRB, 0.38257310E-03_JPRB, 0.38320608E-03_JPRB, &
  & 0.38403561E-03_JPRB, 0.38485777E-03_JPRB, 0.38551670E-03_JPRB, 0.38579931E-03_JPRB, 0.38578059E-03_JPRB, 0.38561120E-03_JPRB, &
  & 0.38547813E-03_JPRB, 0.38562571E-03_JPRB, 0.38575406E-03_JPRB, 0.38589782E-03_JPRB, 0.38592876E-03_JPRB, 0.38572297E-03_JPRB, &
  & 0.38539076E-03_JPRB, 0.38476718E-03_JPRB, 0.38413719E-03_JPRB, 0.38353890E-03_JPRB, 0.38308176E-03_JPRB, 0.38268704E-03_JPRB, &
  & 0.38237785E-03_JPRB, 0.38207081E-03_JPRB, 0.38193219E-03_JPRB, 0.38198213E-03_JPRB, 0.38209496E-03_JPRB, 0.38231100E-03_JPRB, &
  & 0.38274715E-03_JPRB, 0.38312906E-03_JPRB, 0.38345715E-03_JPRB, 0.38372962E-03_JPRB, 0.38398742E-03_JPRB, 0.38429797E-03_JPRB, &
  & 0.38449407E-03_JPRB, 0.38445750E-03_JPRB, 0.38446837E-03_JPRB, 0.38454250E-03_JPRB, 0.38464132E-03_JPRB, 0.38505447E-03_JPRB, &
  & 0.38544105E-03_JPRB, 0.38592465E-03_JPRB, 0.38597815E-03_JPRB, 0.38594768E-03_JPRB  /)

RGHG1(:,48,12) = (/ &
  & 0.37760546E-03_JPRB, 0.37689332E-03_JPRB, 0.37622814E-03_JPRB, 0.37647572E-03_JPRB, 0.37664063E-03_JPRB, 0.37682441E-03_JPRB, &
  & 0.37746479E-03_JPRB, 0.37836970E-03_JPRB, 0.37916883E-03_JPRB, 0.37996227E-03_JPRB, 0.38053632E-03_JPRB, 0.38107636E-03_JPRB, &
  & 0.38145312E-03_JPRB, 0.38176152E-03_JPRB, 0.38192001E-03_JPRB, 0.38193287E-03_JPRB, 0.38183519E-03_JPRB, 0.38177784E-03_JPRB, &
  & 0.38173003E-03_JPRB, 0.38175279E-03_JPRB, 0.38180793E-03_JPRB, 0.38213113E-03_JPRB, 0.38263516E-03_JPRB, 0.38327203E-03_JPRB, &
  & 0.38408572E-03_JPRB, 0.38490942E-03_JPRB, 0.38558550E-03_JPRB, 0.38588957E-03_JPRB, 0.38587423E-03_JPRB, 0.38569299E-03_JPRB, &
  & 0.38552535E-03_JPRB, 0.38563488E-03_JPRB, 0.38576658E-03_JPRB, 0.38592134E-03_JPRB, 0.38598288E-03_JPRB, 0.38578990E-03_JPRB, &
  & 0.38545744E-03_JPRB, 0.38483829E-03_JPRB, 0.38420012E-03_JPRB, 0.38361386E-03_JPRB, 0.38314480E-03_JPRB, 0.38274369E-03_JPRB, &
  & 0.38241729E-03_JPRB, 0.38204219E-03_JPRB, 0.38185786E-03_JPRB, 0.38187629E-03_JPRB, 0.38197591E-03_JPRB, 0.38219459E-03_JPRB, &
  & 0.38263224E-03_JPRB, 0.38303706E-03_JPRB, 0.38338933E-03_JPRB, 0.38365525E-03_JPRB, 0.38389413E-03_JPRB, 0.38419116E-03_JPRB, &
  & 0.38434350E-03_JPRB, 0.38424508E-03_JPRB, 0.38416594E-03_JPRB, 0.38414659E-03_JPRB, 0.38420245E-03_JPRB, 0.38454625E-03_JPRB, &
  & 0.38483881E-03_JPRB, 0.38532345E-03_JPRB, 0.38543320E-03_JPRB, 0.38544836E-03_JPRB  /)

RGHG1(:,49,12) = (/ &
  & 0.37734878E-03_JPRB, 0.37617420E-03_JPRB, 0.37524463E-03_JPRB, 0.37544603E-03_JPRB, 0.37555409E-03_JPRB, 0.37580811E-03_JPRB, &
  & 0.37644872E-03_JPRB, 0.37741983E-03_JPRB, 0.37825634E-03_JPRB, 0.37905959E-03_JPRB, 0.37963653E-03_JPRB, 0.38023256E-03_JPRB, &
  & 0.38069599E-03_JPRB, 0.38109894E-03_JPRB, 0.38133818E-03_JPRB, 0.38147643E-03_JPRB, 0.38153178E-03_JPRB, 0.38160954E-03_JPRB, &
  & 0.38166749E-03_JPRB, 0.38173013E-03_JPRB, 0.38180629E-03_JPRB, 0.38215932E-03_JPRB, 0.38269014E-03_JPRB, 0.38332296E-03_JPRB, &
  & 0.38410488E-03_JPRB, 0.38492991E-03_JPRB, 0.38562965E-03_JPRB, 0.38595880E-03_JPRB, 0.38595110E-03_JPRB, 0.38576005E-03_JPRB, &
  & 0.38556842E-03_JPRB, 0.38562982E-03_JPRB, 0.38576502E-03_JPRB, 0.38593107E-03_JPRB, 0.38602174E-03_JPRB, 0.38584534E-03_JPRB, &
  & 0.38550019E-03_JPRB, 0.38488836E-03_JPRB, 0.38425175E-03_JPRB, 0.38369859E-03_JPRB, 0.38322026E-03_JPRB, 0.38282079E-03_JPRB, &
  & 0.38247297E-03_JPRB, 0.38202311E-03_JPRB, 0.38179759E-03_JPRB, 0.38177419E-03_JPRB, 0.38185115E-03_JPRB, 0.38206944E-03_JPRB, &
  & 0.38248762E-03_JPRB, 0.38290163E-03_JPRB, 0.38327314E-03_JPRB, 0.38352154E-03_JPRB, 0.38372864E-03_JPRB, 0.38399833E-03_JPRB, &
  & 0.38409406E-03_JPRB, 0.38394097E-03_JPRB, 0.38374275E-03_JPRB, 0.38360822E-03_JPRB, 0.38363815E-03_JPRB, 0.38390921E-03_JPRB, &
  & 0.38413970E-03_JPRB, 0.38460386E-03_JPRB, 0.38476229E-03_JPRB, 0.38480135E-03_JPRB  /)

RGHG1(:,50,12) = (/ &
  & 0.37705139E-03_JPRB, 0.37546502E-03_JPRB, 0.37440353E-03_JPRB, 0.37451724E-03_JPRB, 0.37458870E-03_JPRB, 0.37492440E-03_JPRB, &
  & 0.37565397E-03_JPRB, 0.37664844E-03_JPRB, 0.37747218E-03_JPRB, 0.37827631E-03_JPRB, 0.37885692E-03_JPRB, 0.37949171E-03_JPRB, &
  & 0.38003401E-03_JPRB, 0.38051313E-03_JPRB, 0.38084792E-03_JPRB, 0.38111786E-03_JPRB, 0.38131123E-03_JPRB, 0.38148896E-03_JPRB, &
  & 0.38161895E-03_JPRB, 0.38170900E-03_JPRB, 0.38180965E-03_JPRB, 0.38215563E-03_JPRB, 0.38268246E-03_JPRB, 0.38329898E-03_JPRB, &
  & 0.38406291E-03_JPRB, 0.38488341E-03_JPRB, 0.38560851E-03_JPRB, 0.38596854E-03_JPRB, 0.38597426E-03_JPRB, 0.38578162E-03_JPRB, &
  & 0.38557830E-03_JPRB, 0.38561343E-03_JPRB, 0.38574928E-03_JPRB, 0.38592925E-03_JPRB, 0.38603460E-03_JPRB, 0.38587922E-03_JPRB, &
  & 0.38552172E-03_JPRB, 0.38491106E-03_JPRB, 0.38427618E-03_JPRB, 0.38375622E-03_JPRB, 0.38327212E-03_JPRB, 0.38286559E-03_JPRB, &
  & 0.38249063E-03_JPRB, 0.38199900E-03_JPRB, 0.38175778E-03_JPRB, 0.38170906E-03_JPRB, 0.38175645E-03_JPRB, 0.38195841E-03_JPRB, &
  & 0.38234147E-03_JPRB, 0.38273875E-03_JPRB, 0.38309377E-03_JPRB, 0.38331347E-03_JPRB, 0.38349024E-03_JPRB, 0.38371637E-03_JPRB, &
  & 0.38376139E-03_JPRB, 0.38358900E-03_JPRB, 0.38330325E-03_JPRB, 0.38307568E-03_JPRB, 0.38308093E-03_JPRB, 0.38327222E-03_JPRB, &
  & 0.38345822E-03_JPRB, 0.38382732E-03_JPRB, 0.38398253E-03_JPRB, 0.38404409E-03_JPRB  /)

RGHG1(:,51,12) = (/ &
  & 0.37670834E-03_JPRB, 0.37470317E-03_JPRB, 0.37356862E-03_JPRB, 0.37356568E-03_JPRB, 0.37360817E-03_JPRB, 0.37403824E-03_JPRB, &
  & 0.37491066E-03_JPRB, 0.37590790E-03_JPRB, 0.37669145E-03_JPRB, 0.37749184E-03_JPRB, 0.37807685E-03_JPRB, 0.37874450E-03_JPRB, &
  & 0.37936798E-03_JPRB, 0.37991983E-03_JPRB, 0.38036575E-03_JPRB, 0.38078148E-03_JPRB, 0.38111623E-03_JPRB, 0.38138361E-03_JPRB, &
  & 0.38157380E-03_JPRB, 0.38168696E-03_JPRB, 0.38181592E-03_JPRB, 0.38213489E-03_JPRB, 0.38264121E-03_JPRB, 0.38323365E-03_JPRB, &
  & 0.38398539E-03_JPRB, 0.38479791E-03_JPRB, 0.38555132E-03_JPRB, 0.38594779E-03_JPRB, 0.38597109E-03_JPRB, 0.38578105E-03_JPRB, &
  & 0.38557155E-03_JPRB, 0.38558976E-03_JPRB, 0.38572479E-03_JPRB, 0.38592119E-03_JPRB, 0.38603485E-03_JPRB, 0.38590452E-03_JPRB, &
  & 0.38553384E-03_JPRB, 0.38492123E-03_JPRB, 0.38428830E-03_JPRB, 0.38380429E-03_JPRB, 0.38331581E-03_JPRB, 0.38289707E-03_JPRB, &
  & 0.38248973E-03_JPRB, 0.38197029E-03_JPRB, 0.38172548E-03_JPRB, 0.38165806E-03_JPRB, 0.38166981E-03_JPRB, 0.38184574E-03_JPRB, &
  & 0.38218259E-03_JPRB, 0.38254814E-03_JPRB, 0.38286656E-03_JPRB, 0.38304932E-03_JPRB, 0.38319404E-03_JPRB, 0.38336452E-03_JPRB, &
  & 0.38335781E-03_JPRB, 0.38318314E-03_JPRB, 0.38281929E-03_JPRB, 0.38250273E-03_JPRB, 0.38248195E-03_JPRB, 0.38258326E-03_JPRB, &
  & 0.38273038E-03_JPRB, 0.38295743E-03_JPRB, 0.38308189E-03_JPRB, 0.38316704E-03_JPRB  /)

RGHG1(:,52,12) = (/ &
  & 0.37575710E-03_JPRB, 0.37405372E-03_JPRB, 0.37305749E-03_JPRB, 0.37298227E-03_JPRB, 0.37307615E-03_JPRB, 0.37361869E-03_JPRB, &
  & 0.37466483E-03_JPRB, 0.37565161E-03_JPRB, 0.37637166E-03_JPRB, 0.37709372E-03_JPRB, 0.37764609E-03_JPRB, 0.37829786E-03_JPRB, &
  & 0.37893356E-03_JPRB, 0.37952036E-03_JPRB, 0.38004340E-03_JPRB, 0.38055171E-03_JPRB, 0.38096648E-03_JPRB, 0.38128790E-03_JPRB, &
  & 0.38151279E-03_JPRB, 0.38164293E-03_JPRB, 0.38179676E-03_JPRB, 0.38207012E-03_JPRB, 0.38253509E-03_JPRB, 0.38310796E-03_JPRB, &
  & 0.38386129E-03_JPRB, 0.38467639E-03_JPRB, 0.38546317E-03_JPRB, 0.38588267E-03_JPRB, 0.38592535E-03_JPRB, 0.38574205E-03_JPRB, &
  & 0.38554014E-03_JPRB, 0.38555673E-03_JPRB, 0.38569900E-03_JPRB, 0.38589876E-03_JPRB, 0.38600561E-03_JPRB, 0.38588893E-03_JPRB, &
  & 0.38548592E-03_JPRB, 0.38486558E-03_JPRB, 0.38424038E-03_JPRB, 0.38378195E-03_JPRB, 0.38328987E-03_JPRB, 0.38286259E-03_JPRB, &
  & 0.38244168E-03_JPRB, 0.38191776E-03_JPRB, 0.38168857E-03_JPRB, 0.38161649E-03_JPRB, 0.38161277E-03_JPRB, 0.38177305E-03_JPRB, &
  & 0.38207559E-03_JPRB, 0.38241154E-03_JPRB, 0.38269080E-03_JPRB, 0.38285810E-03_JPRB, 0.38299864E-03_JPRB, 0.38312268E-03_JPRB, &
  & 0.38308090E-03_JPRB, 0.38289982E-03_JPRB, 0.38255508E-03_JPRB, 0.38221819E-03_JPRB, 0.38217570E-03_JPRB, 0.38218176E-03_JPRB, &
  & 0.38225978E-03_JPRB, 0.38234257E-03_JPRB, 0.38235066E-03_JPRB, 0.38238139E-03_JPRB  /)

RGHG1(:,53,12) = (/ &
  & 0.37448724E-03_JPRB, 0.37338973E-03_JPRB, 0.37262545E-03_JPRB, 0.37248859E-03_JPRB, 0.37266934E-03_JPRB, 0.37334134E-03_JPRB, &
  & 0.37458852E-03_JPRB, 0.37555881E-03_JPRB, 0.37620075E-03_JPRB, 0.37680881E-03_JPRB, 0.37731139E-03_JPRB, 0.37792711E-03_JPRB, &
  & 0.37854959E-03_JPRB, 0.37915991E-03_JPRB, 0.37975385E-03_JPRB, 0.38034251E-03_JPRB, 0.38082081E-03_JPRB, 0.38118738E-03_JPRB, &
  & 0.38144025E-03_JPRB, 0.38158653E-03_JPRB, 0.38176611E-03_JPRB, 0.38198264E-03_JPRB, 0.38239457E-03_JPRB, 0.38294787E-03_JPRB, &
  & 0.38370823E-03_JPRB, 0.38453020E-03_JPRB, 0.38535527E-03_JPRB, 0.38579469E-03_JPRB, 0.38585917E-03_JPRB, 0.38568479E-03_JPRB, &
  & 0.38549645E-03_JPRB, 0.38551715E-03_JPRB, 0.38567041E-03_JPRB, 0.38586880E-03_JPRB, 0.38596243E-03_JPRB, 0.38585623E-03_JPRB, &
  & 0.38541064E-03_JPRB, 0.38477965E-03_JPRB, 0.38416510E-03_JPRB, 0.38373054E-03_JPRB, 0.38323485E-03_JPRB, 0.38279967E-03_JPRB, &
  & 0.38237120E-03_JPRB, 0.38185141E-03_JPRB, 0.38164659E-03_JPRB, 0.38157486E-03_JPRB, 0.38156203E-03_JPRB, 0.38170927E-03_JPRB, &
  & 0.38197901E-03_JPRB, 0.38228355E-03_JPRB, 0.38251920E-03_JPRB, 0.38267791E-03_JPRB, 0.38282464E-03_JPRB, 0.38290164E-03_JPRB, &
  & 0.38282810E-03_JPRB, 0.38263843E-03_JPRB, 0.38235189E-03_JPRB, 0.38201929E-03_JPRB, 0.38195483E-03_JPRB, 0.38185513E-03_JPRB, &
  & 0.38184628E-03_JPRB, 0.38177112E-03_JPRB, 0.38161954E-03_JPRB, 0.38156100E-03_JPRB  /)

RGHG1(:,54,12) = (/ &
  & 0.37356886E-03_JPRB, 0.37304836E-03_JPRB, 0.37263942E-03_JPRB, 0.37263507E-03_JPRB, 0.37287501E-03_JPRB, 0.37368936E-03_JPRB, &
  & 0.37501594E-03_JPRB, 0.37597684E-03_JPRB, 0.37655434E-03_JPRB, 0.37702947E-03_JPRB, 0.37740918E-03_JPRB, 0.37793376E-03_JPRB, &
  & 0.37848076E-03_JPRB, 0.37904683E-03_JPRB, 0.37963419E-03_JPRB, 0.38022300E-03_JPRB, 0.38071362E-03_JPRB, 0.38108748E-03_JPRB, &
  & 0.38135274E-03_JPRB, 0.38149456E-03_JPRB, 0.38168804E-03_JPRB, 0.38187958E-03_JPRB, 0.38224222E-03_JPRB, 0.38276684E-03_JPRB, &
  & 0.38352854E-03_JPRB, 0.38438225E-03_JPRB, 0.38521550E-03_JPRB, 0.38569304E-03_JPRB, 0.38580261E-03_JPRB, 0.38563153E-03_JPRB, &
  & 0.38546168E-03_JPRB, 0.38547444E-03_JPRB, 0.38563254E-03_JPRB, 0.38581829E-03_JPRB, 0.38589509E-03_JPRB, 0.38576500E-03_JPRB, &
  & 0.38527903E-03_JPRB, 0.38462487E-03_JPRB, 0.38405187E-03_JPRB, 0.38363174E-03_JPRB, 0.38314508E-03_JPRB, 0.38272082E-03_JPRB, &
  & 0.38230375E-03_JPRB, 0.38180188E-03_JPRB, 0.38161979E-03_JPRB, 0.38156676E-03_JPRB, 0.38157634E-03_JPRB, 0.38174483E-03_JPRB, &
  & 0.38201418E-03_JPRB, 0.38231538E-03_JPRB, 0.38254068E-03_JPRB, 0.38271626E-03_JPRB, 0.38288922E-03_JPRB, 0.38298533E-03_JPRB, &
  & 0.38290695E-03_JPRB, 0.38276428E-03_JPRB, 0.38258020E-03_JPRB, 0.38228054E-03_JPRB, 0.38217700E-03_JPRB, 0.38202845E-03_JPRB, &
  & 0.38193600E-03_JPRB, 0.38179189E-03_JPRB, 0.38150343E-03_JPRB, 0.38129577E-03_JPRB  /)

RGHG1(:,55,12) = (/ &
  & 0.37259776E-03_JPRB, 0.37271263E-03_JPRB, 0.37271355E-03_JPRB, 0.37288153E-03_JPRB, 0.37318341E-03_JPRB, 0.37415715E-03_JPRB, &
  & 0.37555568E-03_JPRB, 0.37650711E-03_JPRB, 0.37701503E-03_JPRB, 0.37734042E-03_JPRB, 0.37757440E-03_JPRB, 0.37799078E-03_JPRB, &
  & 0.37844597E-03_JPRB, 0.37895411E-03_JPRB, 0.37952399E-03_JPRB, 0.38010241E-03_JPRB, 0.38059995E-03_JPRB, 0.38097691E-03_JPRB, &
  & 0.38125383E-03_JPRB, 0.38138800E-03_JPRB, 0.38159532E-03_JPRB, 0.38176336E-03_JPRB, 0.38207190E-03_JPRB, 0.38256355E-03_JPRB, &
  & 0.38332597E-03_JPRB, 0.38421812E-03_JPRB, 0.38505647E-03_JPRB, 0.38557864E-03_JPRB, 0.38574122E-03_JPRB, 0.38557306E-03_JPRB, &
  & 0.38542433E-03_JPRB, 0.38542671E-03_JPRB, 0.38558937E-03_JPRB, 0.38575964E-03_JPRB, 0.38581731E-03_JPRB, 0.38565625E-03_JPRB, &
  & 0.38512583E-03_JPRB, 0.38444435E-03_JPRB, 0.38392144E-03_JPRB, 0.38351607E-03_JPRB, 0.38304106E-03_JPRB, 0.38263138E-03_JPRB, &
  & 0.38222943E-03_JPRB, 0.38174924E-03_JPRB, 0.38159211E-03_JPRB, 0.38156221E-03_JPRB, 0.38160075E-03_JPRB, 0.38179729E-03_JPRB, &
  & 0.38207047E-03_JPRB, 0.38237167E-03_JPRB, 0.38258986E-03_JPRB, 0.38278748E-03_JPRB, 0.38299214E-03_JPRB, 0.38311812E-03_JPRB, &
  & 0.38303792E-03_JPRB, 0.38295464E-03_JPRB, 0.38288987E-03_JPRB, 0.38263047E-03_JPRB, 0.38248139E-03_JPRB, 0.38228621E-03_JPRB, &
  & 0.38210158E-03_JPRB, 0.38189281E-03_JPRB, 0.38145570E-03_JPRB, 0.38107499E-03_JPRB  /)

RGHG1(:,56,12) = (/ &
  & 0.37271609E-03_JPRB, 0.37300191E-03_JPRB, 0.37332348E-03_JPRB, 0.37371127E-03_JPRB, 0.37406240E-03_JPRB, 0.37501994E-03_JPRB, &
  & 0.37634181E-03_JPRB, 0.37723200E-03_JPRB, 0.37768967E-03_JPRB, 0.37790017E-03_JPRB, 0.37804694E-03_JPRB, 0.37832864E-03_JPRB, &
  & 0.37867239E-03_JPRB, 0.37907400E-03_JPRB, 0.37955369E-03_JPRB, 0.38005640E-03_JPRB, 0.38052041E-03_JPRB, 0.38087579E-03_JPRB, &
  & 0.38115222E-03_JPRB, 0.38126459E-03_JPRB, 0.38146144E-03_JPRB, 0.38162211E-03_JPRB, 0.38191173E-03_JPRB, 0.38238474E-03_JPRB, &
  & 0.38310390E-03_JPRB, 0.38405017E-03_JPRB, 0.38487797E-03_JPRB, 0.38542490E-03_JPRB, 0.38562404E-03_JPRB, 0.38550335E-03_JPRB, &
  & 0.38539244E-03_JPRB, 0.38538658E-03_JPRB, 0.38552787E-03_JPRB, 0.38566914E-03_JPRB, 0.38570489E-03_JPRB, 0.38550220E-03_JPRB, &
  & 0.38489332E-03_JPRB, 0.38424169E-03_JPRB, 0.38379226E-03_JPRB, 0.38338077E-03_JPRB, 0.38293018E-03_JPRB, 0.38256146E-03_JPRB, &
  & 0.38218037E-03_JPRB, 0.38174278E-03_JPRB, 0.38161054E-03_JPRB, 0.38162053E-03_JPRB, 0.38171905E-03_JPRB, 0.38196654E-03_JPRB, &
  & 0.38227541E-03_JPRB, 0.38262192E-03_JPRB, 0.38285714E-03_JPRB, 0.38308721E-03_JPRB, 0.38333166E-03_JPRB, 0.38352004E-03_JPRB, &
  & 0.38349374E-03_JPRB, 0.38349813E-03_JPRB, 0.38351356E-03_JPRB, 0.38325205E-03_JPRB, 0.38307501E-03_JPRB, 0.38293291E-03_JPRB, &
  & 0.38272770E-03_JPRB, 0.38255696E-03_JPRB, 0.38211546E-03_JPRB, 0.38165776E-03_JPRB  /)

RGHG1(:,57,12) = (/ &
  & 0.37294314E-03_JPRB, 0.37341115E-03_JPRB, 0.37402967E-03_JPRB, 0.37457305E-03_JPRB, 0.37496879E-03_JPRB, 0.37589678E-03_JPRB, &
  & 0.37712518E-03_JPRB, 0.37794682E-03_JPRB, 0.37835290E-03_JPRB, 0.37845728E-03_JPRB, 0.37852700E-03_JPRB, 0.37868506E-03_JPRB, &
  & 0.37891638E-03_JPRB, 0.37920830E-03_JPRB, 0.37958886E-03_JPRB, 0.38000976E-03_JPRB, 0.38043743E-03_JPRB, 0.38076980E-03_JPRB, &
  & 0.38104382E-03_JPRB, 0.38113809E-03_JPRB, 0.38132157E-03_JPRB, 0.38147587E-03_JPRB, 0.38173984E-03_JPRB, 0.38219164E-03_JPRB, &
  & 0.38287211E-03_JPRB, 0.38385302E-03_JPRB, 0.38469047E-03_JPRB, 0.38525944E-03_JPRB, 0.38548755E-03_JPRB, 0.38541622E-03_JPRB, &
  & 0.38535142E-03_JPRB, 0.38533871E-03_JPRB, 0.38545873E-03_JPRB, 0.38556975E-03_JPRB, 0.38557563E-03_JPRB, 0.38532580E-03_JPRB, &
  & 0.38464819E-03_JPRB, 0.38403143E-03_JPRB, 0.38363927E-03_JPRB, 0.38322706E-03_JPRB, 0.38280244E-03_JPRB, 0.38247415E-03_JPRB, &
  & 0.38211942E-03_JPRB, 0.38173293E-03_JPRB, 0.38163289E-03_JPRB, 0.38169346E-03_JPRB, 0.38185802E-03_JPRB, 0.38216171E-03_JPRB, &
  & 0.38251155E-03_JPRB, 0.38290603E-03_JPRB, 0.38316040E-03_JPRB, 0.38342016E-03_JPRB, 0.38370828E-03_JPRB, 0.38395972E-03_JPRB, &
  & 0.38399062E-03_JPRB, 0.38406926E-03_JPRB, 0.38414965E-03_JPRB, 0.38388561E-03_JPRB, 0.38368768E-03_JPRB, 0.38359946E-03_JPRB, &
  & 0.38337614E-03_JPRB, 0.38322372E-03_JPRB, 0.38276503E-03_JPRB, 0.38224949E-03_JPRB  /)

RGHG1(:,58,12) = (/ &
  & 0.37353978E-03_JPRB, 0.37410725E-03_JPRB, 0.37494208E-03_JPRB, 0.37552895E-03_JPRB, 0.37595551E-03_JPRB, 0.37680087E-03_JPRB, &
  & 0.37788709E-03_JPRB, 0.37862364E-03_JPRB, 0.37898358E-03_JPRB, 0.37901176E-03_JPRB, 0.37903874E-03_JPRB, 0.37909678E-03_JPRB, &
  & 0.37921939E-03_JPRB, 0.37939596E-03_JPRB, 0.37965664E-03_JPRB, 0.37997979E-03_JPRB, 0.38036170E-03_JPRB, 0.38066590E-03_JPRB, &
  & 0.38093217E-03_JPRB, 0.38101340E-03_JPRB, 0.38117513E-03_JPRB, 0.38132829E-03_JPRB, 0.38156390E-03_JPRB, 0.38199452E-03_JPRB, &
  & 0.38263887E-03_JPRB, 0.38362168E-03_JPRB, 0.38449922E-03_JPRB, 0.38508009E-03_JPRB, 0.38531899E-03_JPRB, 0.38530457E-03_JPRB, &
  & 0.38529933E-03_JPRB, 0.38528302E-03_JPRB, 0.38537885E-03_JPRB, 0.38545734E-03_JPRB, 0.38542181E-03_JPRB, 0.38511733E-03_JPRB, &
  & 0.38438659E-03_JPRB, 0.38382108E-03_JPRB, 0.38345861E-03_JPRB, 0.38305093E-03_JPRB, 0.38265524E-03_JPRB, 0.38236817E-03_JPRB, &
  & 0.38204804E-03_JPRB, 0.38172678E-03_JPRB, 0.38166872E-03_JPRB, 0.38179699E-03_JPRB, 0.38203831E-03_JPRB, 0.38240685E-03_JPRB, &
  & 0.38280926E-03_JPRB, 0.38326084E-03_JPRB, 0.38354093E-03_JPRB, 0.38382526E-03_JPRB, 0.38416160E-03_JPRB, 0.38447827E-03_JPRB, &
  & 0.38457782E-03_JPRB, 0.38470731E-03_JPRB, 0.38481436E-03_JPRB, 0.38453936E-03_JPRB, 0.38433746E-03_JPRB, 0.38431881E-03_JPRB, &
  & 0.38409645E-03_JPRB, 0.38394686E-03_JPRB, 0.38347777E-03_JPRB, 0.38295939E-03_JPRB  /)

RGHG1(:,59,12) = (/ &
  & 0.37437214E-03_JPRB, 0.37497787E-03_JPRB, 0.37591742E-03_JPRB, 0.37644137E-03_JPRB, 0.37685190E-03_JPRB, 0.37759958E-03_JPRB, &
  & 0.37853994E-03_JPRB, 0.37918777E-03_JPRB, 0.37950286E-03_JPRB, 0.37948523E-03_JPRB, 0.37948183E-03_JPRB, 0.37947828E-03_JPRB, &
  & 0.37951375E-03_JPRB, 0.37958459E-03_JPRB, 0.37972981E-03_JPRB, 0.37995757E-03_JPRB, 0.38028401E-03_JPRB, 0.38056846E-03_JPRB, &
  & 0.38081748E-03_JPRB, 0.38089224E-03_JPRB, 0.38103149E-03_JPRB, 0.38119378E-03_JPRB, 0.38140476E-03_JPRB, 0.38179850E-03_JPRB, &
  & 0.38242167E-03_JPRB, 0.38336031E-03_JPRB, 0.38431120E-03_JPRB, 0.38489108E-03_JPRB, 0.38514236E-03_JPRB, 0.38519061E-03_JPRB, &
  & 0.38524118E-03_JPRB, 0.38522990E-03_JPRB, 0.38530545E-03_JPRB, 0.38534937E-03_JPRB, 0.38525397E-03_JPRB, 0.38487871E-03_JPRB, &
  & 0.38414608E-03_JPRB, 0.38362588E-03_JPRB, 0.38328851E-03_JPRB, 0.38289747E-03_JPRB, 0.38253256E-03_JPRB, 0.38227831E-03_JPRB, &
  & 0.38198870E-03_JPRB, 0.38173531E-03_JPRB, 0.38172771E-03_JPRB, 0.38193162E-03_JPRB, 0.38224897E-03_JPRB, 0.38268574E-03_JPRB, &
  & 0.38314743E-03_JPRB, 0.38363985E-03_JPRB, 0.38395568E-03_JPRB, 0.38425554E-03_JPRB, 0.38463134E-03_JPRB, 0.38499034E-03_JPRB, &
  & 0.38514653E-03_JPRB, 0.38529264E-03_JPRB, 0.38540924E-03_JPRB, 0.38514161E-03_JPRB, 0.38494758E-03_JPRB, 0.38497934E-03_JPRB, &
  & 0.38478816E-03_JPRB, 0.38463632E-03_JPRB, 0.38415199E-03_JPRB, 0.38367976E-03_JPRB  /)

RGHG1(:,60,12) = (/ &
  & 0.37534121E-03_JPRB, 0.37594953E-03_JPRB, 0.37693595E-03_JPRB, 0.37735469E-03_JPRB, 0.37772128E-03_JPRB, 0.37836745E-03_JPRB, &
  & 0.37916068E-03_JPRB, 0.37971333E-03_JPRB, 0.37998443E-03_JPRB, 0.37993444E-03_JPRB, 0.37990398E-03_JPRB, 0.37985221E-03_JPRB, &
  & 0.37980810E-03_JPRB, 0.37977805E-03_JPRB, 0.37980907E-03_JPRB, 0.37994102E-03_JPRB, 0.38020543E-03_JPRB, 0.38047179E-03_JPRB, &
  & 0.38069805E-03_JPRB, 0.38076918E-03_JPRB, 0.38088766E-03_JPRB, 0.38106052E-03_JPRB, 0.38125125E-03_JPRB, 0.38160368E-03_JPRB, &
  & 0.38220981E-03_JPRB, 0.38308923E-03_JPRB, 0.38411582E-03_JPRB, 0.38468997E-03_JPRB, 0.38496358E-03_JPRB, 0.38507833E-03_JPRB, &
  & 0.38518054E-03_JPRB, 0.38517426E-03_JPRB, 0.38523212E-03_JPRB, 0.38523996E-03_JPRB, 0.38507952E-03_JPRB, 0.38463370E-03_JPRB, &
  & 0.38391837E-03_JPRB, 0.38343579E-03_JPRB, 0.38312235E-03_JPRB, 0.38275491E-03_JPRB, 0.38241923E-03_JPRB, 0.38219335E-03_JPRB, &
  & 0.38193549E-03_JPRB, 0.38175328E-03_JPRB, 0.38180220E-03_JPRB, 0.38208748E-03_JPRB, 0.38248366E-03_JPRB, 0.38298882E-03_JPRB, &
  & 0.38351508E-03_JPRB, 0.38404146E-03_JPRB, 0.38439507E-03_JPRB, 0.38470736E-03_JPRB, 0.38512037E-03_JPRB, 0.38550908E-03_JPRB, &
  & 0.38571666E-03_JPRB, 0.38586649E-03_JPRB, 0.38598712E-03_JPRB, 0.38573740E-03_JPRB, 0.38555913E-03_JPRB, 0.38563404E-03_JPRB, &
  & 0.38549245E-03_JPRB, 0.38534282E-03_JPRB, 0.38483880E-03_JPRB, 0.38443249E-03_JPRB  /)

RGHG1(:,61,12) = (/ &
  & 0.37641374E-03_JPRB, 0.37695614E-03_JPRB, 0.37788721E-03_JPRB, 0.37818007E-03_JPRB, 0.37845523E-03_JPRB, 0.37901970E-03_JPRB, &
  & 0.37968890E-03_JPRB, 0.38013986E-03_JPRB, 0.38037590E-03_JPRB, 0.38031515E-03_JPRB, 0.38025988E-03_JPRB, 0.38017347E-03_JPRB, &
  & 0.38006601E-03_JPRB, 0.37995887E-03_JPRB, 0.37989364E-03_JPRB, 0.37994051E-03_JPRB, 0.38013839E-03_JPRB, 0.38038558E-03_JPRB, &
  & 0.38058232E-03_JPRB, 0.38065365E-03_JPRB, 0.38076260E-03_JPRB, 0.38093721E-03_JPRB, 0.38112415E-03_JPRB, 0.38144367E-03_JPRB, &
  & 0.38203350E-03_JPRB, 0.38286023E-03_JPRB, 0.38391767E-03_JPRB, 0.38448404E-03_JPRB, 0.38481495E-03_JPRB, 0.38499387E-03_JPRB, &
  & 0.38512713E-03_JPRB, 0.38511409E-03_JPRB, 0.38516262E-03_JPRB, 0.38513663E-03_JPRB, 0.38492391E-03_JPRB, 0.38444037E-03_JPRB, &
  & 0.38375282E-03_JPRB, 0.38327783E-03_JPRB, 0.38298561E-03_JPRB, 0.38265107E-03_JPRB, 0.38233118E-03_JPRB, 0.38212159E-03_JPRB, &
  & 0.38190064E-03_JPRB, 0.38178833E-03_JPRB, 0.38189866E-03_JPRB, 0.38226553E-03_JPRB, 0.38274024E-03_JPRB, 0.38329921E-03_JPRB, &
  & 0.38389272E-03_JPRB, 0.38444011E-03_JPRB, 0.38482099E-03_JPRB, 0.38514260E-03_JPRB, 0.38558872E-03_JPRB, 0.38597990E-03_JPRB, &
  & 0.38622437E-03_JPRB, 0.38636815E-03_JPRB, 0.38649135E-03_JPRB, 0.38627638E-03_JPRB, 0.38612855E-03_JPRB, 0.38623443E-03_JPRB, &
  & 0.38617114E-03_JPRB, 0.38604816E-03_JPRB, 0.38551555E-03_JPRB, 0.38518315E-03_JPRB  /)

RGHG1(:,62,12) = (/ &
  & 0.37750036E-03_JPRB, 0.37795616E-03_JPRB, 0.37878427E-03_JPRB, 0.37895748E-03_JPRB, 0.37910824E-03_JPRB, 0.37961057E-03_JPRB, &
  & 0.38017113E-03_JPRB, 0.38052482E-03_JPRB, 0.38072492E-03_JPRB, 0.38066134E-03_JPRB, 0.38058396E-03_JPRB, 0.38046869E-03_JPRB, &
  & 0.38030459E-03_JPRB, 0.38013749E-03_JPRB, 0.37999320E-03_JPRB, 0.37996191E-03_JPRB, 0.38009312E-03_JPRB, 0.38031711E-03_JPRB, &
  & 0.38048544E-03_JPRB, 0.38055364E-03_JPRB, 0.38066414E-03_JPRB, 0.38082316E-03_JPRB, 0.38101476E-03_JPRB, 0.38131005E-03_JPRB, &
  & 0.38188359E-03_JPRB, 0.38267264E-03_JPRB, 0.38371913E-03_JPRB, 0.38430105E-03_JPRB, 0.38469041E-03_JPRB, 0.38491771E-03_JPRB, &
  & 0.38506186E-03_JPRB, 0.38505633E-03_JPRB, 0.38509250E-03_JPRB, 0.38505627E-03_JPRB, 0.38481464E-03_JPRB, 0.38432542E-03_JPRB, &
  & 0.38364308E-03_JPRB, 0.38316764E-03_JPRB, 0.38288905E-03_JPRB, 0.38256874E-03_JPRB, 0.38226589E-03_JPRB, 0.38207745E-03_JPRB, &
  & 0.38189184E-03_JPRB, 0.38184371E-03_JPRB, 0.38200760E-03_JPRB, 0.38245594E-03_JPRB, 0.38300735E-03_JPRB, 0.38361965E-03_JPRB, &
  & 0.38426380E-03_JPRB, 0.38481573E-03_JPRB, 0.38521761E-03_JPRB, 0.38556289E-03_JPRB, 0.38602595E-03_JPRB, 0.38641731E-03_JPRB, &
  & 0.38668787E-03_JPRB, 0.38682587E-03_JPRB, 0.38694602E-03_JPRB, 0.38677700E-03_JPRB, 0.38666795E-03_JPRB, 0.38681336E-03_JPRB, &
  & 0.38683172E-03_JPRB, 0.38674717E-03_JPRB, 0.38619931E-03_JPRB, 0.38592496E-03_JPRB  /)

RGHG1(:,63,12) = (/ &
  & 0.37857643E-03_JPRB, 0.37893811E-03_JPRB, 0.37964754E-03_JPRB, 0.37970417E-03_JPRB, 0.37971436E-03_JPRB, 0.38016255E-03_JPRB, &
  & 0.38062300E-03_JPRB, 0.38088751E-03_JPRB, 0.38105253E-03_JPRB, 0.38098780E-03_JPRB, 0.38089004E-03_JPRB, 0.38074993E-03_JPRB, &
  & 0.38053674E-03_JPRB, 0.38031950E-03_JPRB, 0.38010412E-03_JPRB, 0.37999975E-03_JPRB, 0.38006639E-03_JPRB, 0.38026235E-03_JPRB, &
  & 0.38040439E-03_JPRB, 0.38046912E-03_JPRB, 0.38058370E-03_JPRB, 0.38072143E-03_JPRB, 0.38091605E-03_JPRB, 0.38119816E-03_JPRB, &
  & 0.38175301E-03_JPRB, 0.38251056E-03_JPRB, 0.38352713E-03_JPRB, 0.38413411E-03_JPRB, 0.38457235E-03_JPRB, 0.38484631E-03_JPRB, &
  & 0.38499443E-03_JPRB, 0.38500285E-03_JPRB, 0.38502738E-03_JPRB, 0.38499755E-03_JPRB, 0.38474376E-03_JPRB, 0.38424846E-03_JPRB, &
  & 0.38357026E-03_JPRB, 0.38309806E-03_JPRB, 0.38282422E-03_JPRB, 0.38250407E-03_JPRB, 0.38222384E-03_JPRB, 0.38205574E-03_JPRB, &
  & 0.38190613E-03_JPRB, 0.38191780E-03_JPRB, 0.38213060E-03_JPRB, 0.38265900E-03_JPRB, 0.38328441E-03_JPRB, 0.38394698E-03_JPRB, &
  & 0.38462831E-03_JPRB, 0.38517614E-03_JPRB, 0.38559847E-03_JPRB, 0.38597554E-03_JPRB, 0.38644534E-03_JPRB, 0.38683639E-03_JPRB, &
  & 0.38712776E-03_JPRB, 0.38726020E-03_JPRB, 0.38737223E-03_JPRB, 0.38725744E-03_JPRB, 0.38719540E-03_JPRB, 0.38738144E-03_JPRB, &
  & 0.38748005E-03_JPRB, 0.38744788E-03_JPRB, 0.38690590E-03_JPRB, 0.38668494E-03_JPRB  /)

RGHG1(:,64,12) = (/ &
  & 0.37956941E-03_JPRB, 0.37984320E-03_JPRB, 0.38044825E-03_JPRB, 0.38039411E-03_JPRB, 0.38026281E-03_JPRB, 0.38065887E-03_JPRB, &
  & 0.38102863E-03_JPRB, 0.38122306E-03_JPRB, 0.38135748E-03_JPRB, 0.38128770E-03_JPRB, 0.38117189E-03_JPRB, 0.38101194E-03_JPRB, &
  & 0.38076355E-03_JPRB, 0.38050505E-03_JPRB, 0.38022364E-03_JPRB, 0.38005457E-03_JPRB, 0.38006459E-03_JPRB, 0.38022569E-03_JPRB, &
  & 0.38034665E-03_JPRB, 0.38041060E-03_JPRB, 0.38052405E-03_JPRB, 0.38064485E-03_JPRB, 0.38082961E-03_JPRB, 0.38111778E-03_JPRB, &
  & 0.38164863E-03_JPRB, 0.38237591E-03_JPRB, 0.38335941E-03_JPRB, 0.38399016E-03_JPRB, 0.38445037E-03_JPRB, 0.38478106E-03_JPRB, &
  & 0.38493646E-03_JPRB, 0.38495969E-03_JPRB, 0.38497794E-03_JPRB, 0.38497154E-03_JPRB, 0.38472381E-03_JPRB, 0.38418881E-03_JPRB, &
  & 0.38353506E-03_JPRB, 0.38308337E-03_JPRB, 0.38279977E-03_JPRB, 0.38246394E-03_JPRB, 0.38221801E-03_JPRB, 0.38206247E-03_JPRB, &
  & 0.38195063E-03_JPRB, 0.38201477E-03_JPRB, 0.38227096E-03_JPRB, 0.38287291E-03_JPRB, 0.38356458E-03_JPRB, 0.38426829E-03_JPRB, &
  & 0.38496879E-03_JPRB, 0.38550811E-03_JPRB, 0.38595510E-03_JPRB, 0.38636827E-03_JPRB, 0.38683572E-03_JPRB, 0.38722755E-03_JPRB, &
  & 0.38753686E-03_JPRB, 0.38766426E-03_JPRB, 0.38776160E-03_JPRB, 0.38770802E-03_JPRB, 0.38770316E-03_JPRB, 0.38792216E-03_JPRB, &
  & 0.38809095E-03_JPRB, 0.38813176E-03_JPRB, 0.38763441E-03_JPRB, 0.38746940E-03_JPRB  /)

RGHG1(:,65,12) = (/ &
  & 0.38037639E-03_JPRB, 0.38058656E-03_JPRB, 0.38114018E-03_JPRB, 0.38099926E-03_JPRB, 0.38076923E-03_JPRB, 0.38109522E-03_JPRB, &
  & 0.38138298E-03_JPRB, 0.38154354E-03_JPRB, 0.38166026E-03_JPRB, 0.38157309E-03_JPRB, 0.38143304E-03_JPRB, 0.38126248E-03_JPRB, &
  & 0.38099636E-03_JPRB, 0.38070234E-03_JPRB, 0.38036211E-03_JPRB, 0.38013632E-03_JPRB, 0.38008866E-03_JPRB, 0.38021181E-03_JPRB, &
  & 0.38031811E-03_JPRB, 0.38038815E-03_JPRB, 0.38049161E-03_JPRB, 0.38060516E-03_JPRB, 0.38077287E-03_JPRB, 0.38107424E-03_JPRB, &
  & 0.38159146E-03_JPRB, 0.38229074E-03_JPRB, 0.38321378E-03_JPRB, 0.38385231E-03_JPRB, 0.38433717E-03_JPRB, 0.38472241E-03_JPRB, &
  & 0.38490446E-03_JPRB, 0.38493018E-03_JPRB, 0.38495056E-03_JPRB, 0.38496328E-03_JPRB, 0.38473406E-03_JPRB, 0.38416085E-03_JPRB, &
  & 0.38353725E-03_JPRB, 0.38309977E-03_JPRB, 0.38280990E-03_JPRB, 0.38246690E-03_JPRB, 0.38224626E-03_JPRB, 0.38210243E-03_JPRB, &
  & 0.38203419E-03_JPRB, 0.38214234E-03_JPRB, 0.38244600E-03_JPRB, 0.38310713E-03_JPRB, 0.38384668E-03_JPRB, 0.38457589E-03_JPRB, &
  & 0.38528276E-03_JPRB, 0.38582132E-03_JPRB, 0.38630735E-03_JPRB, 0.38675147E-03_JPRB, 0.38722218E-03_JPRB, 0.38760771E-03_JPRB, &
  & 0.38792529E-03_JPRB, 0.38805699E-03_JPRB, 0.38814329E-03_JPRB, 0.38815567E-03_JPRB, 0.38820707E-03_JPRB, 0.38844759E-03_JPRB, &
  & 0.38868064E-03_JPRB, 0.38882399E-03_JPRB, 0.38839111E-03_JPRB, 0.38827903E-03_JPRB  /)

RGHG1(:,66,12) = (/ &
  & 0.38106583E-03_JPRB, 0.38123701E-03_JPRB, 0.38174421E-03_JPRB, 0.38154022E-03_JPRB, 0.38124913E-03_JPRB, 0.38150128E-03_JPRB, &
  & 0.38171565E-03_JPRB, 0.38186011E-03_JPRB, 0.38196512E-03_JPRB, 0.38185414E-03_JPRB, 0.38169162E-03_JPRB, 0.38151281E-03_JPRB, &
  & 0.38123780E-03_JPRB, 0.38091050E-03_JPRB, 0.38051954E-03_JPRB, 0.38024243E-03_JPRB, 0.38013615E-03_JPRB, 0.38021997E-03_JPRB, &
  & 0.38031129E-03_JPRB, 0.38038060E-03_JPRB, 0.38047600E-03_JPRB, 0.38058551E-03_JPRB, 0.38075232E-03_JPRB, 0.38105057E-03_JPRB, &
  & 0.38157075E-03_JPRB, 0.38223270E-03_JPRB, 0.38308781E-03_JPRB, 0.38373602E-03_JPRB, 0.38424090E-03_JPRB, 0.38468192E-03_JPRB, &
  & 0.38488584E-03_JPRB, 0.38491140E-03_JPRB, 0.38493728E-03_JPRB, 0.38496548E-03_JPRB, 0.38475438E-03_JPRB, 0.38417101E-03_JPRB, &
  & 0.38356959E-03_JPRB, 0.38313855E-03_JPRB, 0.38283491E-03_JPRB, 0.38248854E-03_JPRB, 0.38228717E-03_JPRB, 0.38215626E-03_JPRB, &
  & 0.38213712E-03_JPRB, 0.38229435E-03_JPRB, 0.38265161E-03_JPRB, 0.38336337E-03_JPRB, 0.38413873E-03_JPRB, 0.38488858E-03_JPRB, &
  & 0.38559828E-03_JPRB, 0.38614573E-03_JPRB, 0.38667624E-03_JPRB, 0.38714459E-03_JPRB, 0.38761783E-03_JPRB, 0.38799545E-03_JPRB, &
  & 0.38831133E-03_JPRB, 0.38845068E-03_JPRB, 0.38853746E-03_JPRB, 0.38862000E-03_JPRB, 0.38872066E-03_JPRB, 0.38898106E-03_JPRB, &
  & 0.38926992E-03_JPRB, 0.38950606E-03_JPRB, 0.38915494E-03_JPRB, 0.38906654E-03_JPRB  /)

RGHG1(:,67,12) = (/ &
  & 0.38163673E-03_JPRB, 0.38179163E-03_JPRB, 0.38224779E-03_JPRB, 0.38200700E-03_JPRB, 0.38169211E-03_JPRB, 0.38187428E-03_JPRB, &
  & 0.38202684E-03_JPRB, 0.38216894E-03_JPRB, 0.38226463E-03_JPRB, 0.38212724E-03_JPRB, 0.38194682E-03_JPRB, 0.38176111E-03_JPRB, &
  & 0.38148363E-03_JPRB, 0.38112791E-03_JPRB, 0.38069721E-03_JPRB, 0.38037435E-03_JPRB, 0.38021185E-03_JPRB, 0.38025330E-03_JPRB, &
  & 0.38032679E-03_JPRB, 0.38038404E-03_JPRB, 0.38047742E-03_JPRB, 0.38058505E-03_JPRB, 0.38076846E-03_JPRB, 0.38105059E-03_JPRB, &
  & 0.38158247E-03_JPRB, 0.38219801E-03_JPRB, 0.38298795E-03_JPRB, 0.38364748E-03_JPRB, 0.38416497E-03_JPRB, 0.38465940E-03_JPRB, &
  & 0.38487904E-03_JPRB, 0.38490777E-03_JPRB, 0.38494122E-03_JPRB, 0.38497893E-03_JPRB, 0.38478352E-03_JPRB, 0.38421524E-03_JPRB, &
  & 0.38362755E-03_JPRB, 0.38319623E-03_JPRB, 0.38287359E-03_JPRB, 0.38252715E-03_JPRB, 0.38233925E-03_JPRB, 0.38222339E-03_JPRB, &
  & 0.38226027E-03_JPRB, 0.38247600E-03_JPRB, 0.38288913E-03_JPRB, 0.38364080E-03_JPRB, 0.38444281E-03_JPRB, 0.38520997E-03_JPRB, &
  & 0.38592018E-03_JPRB, 0.38648538E-03_JPRB, 0.38706169E-03_JPRB, 0.38755115E-03_JPRB, 0.38802237E-03_JPRB, 0.38839026E-03_JPRB, &
  & 0.38869467E-03_JPRB, 0.38884425E-03_JPRB, 0.38894427E-03_JPRB, 0.38909646E-03_JPRB, 0.38923525E-03_JPRB, 0.38951394E-03_JPRB, &
  & 0.38984888E-03_JPRB, 0.39015622E-03_JPRB, 0.38989579E-03_JPRB, 0.38980248E-03_JPRB  /)

RGHG1(:,68,12) = (/ &
  & 0.38208766E-03_JPRB, 0.38224325E-03_JPRB, 0.38263171E-03_JPRB, 0.38238413E-03_JPRB, 0.38208040E-03_JPRB, 0.38220928E-03_JPRB, &
  & 0.38231659E-03_JPRB, 0.38246410E-03_JPRB, 0.38254621E-03_JPRB, 0.38238672E-03_JPRB, 0.38219697E-03_JPRB, 0.38200482E-03_JPRB, &
  & 0.38172723E-03_JPRB, 0.38135378E-03_JPRB, 0.38089936E-03_JPRB, 0.38053621E-03_JPRB, 0.38032628E-03_JPRB, 0.38031788E-03_JPRB, &
  & 0.38036639E-03_JPRB, 0.38039360E-03_JPRB, 0.38049745E-03_JPRB, 0.38060416E-03_JPRB, 0.38081946E-03_JPRB, 0.38108478E-03_JPRB, &
  & 0.38161839E-03_JPRB, 0.38218109E-03_JPRB, 0.38292601E-03_JPRB, 0.38359441E-03_JPRB, 0.38411305E-03_JPRB, 0.38465088E-03_JPRB, &
  & 0.38488238E-03_JPRB, 0.38492861E-03_JPRB, 0.38496988E-03_JPRB, 0.38500645E-03_JPRB, 0.38482278E-03_JPRB, 0.38428224E-03_JPRB, &
  & 0.38370215E-03_JPRB, 0.38326680E-03_JPRB, 0.38292700E-03_JPRB, 0.38258356E-03_JPRB, 0.38240360E-03_JPRB, 0.38230662E-03_JPRB, &
  & 0.38241004E-03_JPRB, 0.38270083E-03_JPRB, 0.38316392E-03_JPRB, 0.38394000E-03_JPRB, 0.38476549E-03_JPRB, 0.38554819E-03_JPRB, &
  & 0.38625759E-03_JPRB, 0.38684708E-03_JPRB, 0.38746392E-03_JPRB, 0.38797997E-03_JPRB, 0.38843772E-03_JPRB, 0.38879249E-03_JPRB, &
  & 0.38907652E-03_JPRB, 0.38923842E-03_JPRB, 0.38936503E-03_JPRB, 0.38957720E-03_JPRB, 0.38973625E-03_JPRB, 0.39003025E-03_JPRB, &
  & 0.39040030E-03_JPRB, 0.39074137E-03_JPRB, 0.39056359E-03_JPRB, 0.39044485E-03_JPRB  /)

RGHG1(:,69,12) = (/ &
  & 0.38243162E-03_JPRB, 0.38259901E-03_JPRB, 0.38290953E-03_JPRB, 0.38268062E-03_JPRB, 0.38239927E-03_JPRB, 0.38250932E-03_JPRB, &
  & 0.38259498E-03_JPRB, 0.38274423E-03_JPRB, 0.38280186E-03_JPRB, 0.38262928E-03_JPRB, 0.38243534E-03_JPRB, 0.38223884E-03_JPRB, &
  & 0.38196082E-03_JPRB, 0.38158347E-03_JPRB, 0.38112798E-03_JPRB, 0.38072685E-03_JPRB, 0.38047516E-03_JPRB, 0.38041870E-03_JPRB, &
  & 0.38043396E-03_JPRB, 0.38042578E-03_JPRB, 0.38053372E-03_JPRB, 0.38064349E-03_JPRB, 0.38088679E-03_JPRB, 0.38115606E-03_JPRB, &
  & 0.38165796E-03_JPRB, 0.38218387E-03_JPRB, 0.38289709E-03_JPRB, 0.38355434E-03_JPRB, 0.38408607E-03_JPRB, 0.38464917E-03_JPRB, &
  & 0.38489640E-03_JPRB, 0.38495950E-03_JPRB, 0.38500609E-03_JPRB, 0.38503647E-03_JPRB, 0.38486056E-03_JPRB, 0.38435520E-03_JPRB, &
  & 0.38379402E-03_JPRB, 0.38335056E-03_JPRB, 0.38299770E-03_JPRB, 0.38267296E-03_JPRB, 0.38250357E-03_JPRB, 0.38243803E-03_JPRB, &
  & 0.38261594E-03_JPRB, 0.38298994E-03_JPRB, 0.38348706E-03_JPRB, 0.38427518E-03_JPRB, 0.38511305E-03_JPRB, 0.38590971E-03_JPRB, &
  & 0.38661904E-03_JPRB, 0.38722810E-03_JPRB, 0.38787456E-03_JPRB, 0.38842317E-03_JPRB, 0.38886253E-03_JPRB, 0.38919873E-03_JPRB, &
  & 0.38944782E-03_JPRB, 0.38963073E-03_JPRB, 0.38979221E-03_JPRB, 0.39004370E-03_JPRB, 0.39021358E-03_JPRB, 0.39050204E-03_JPRB, &
  & 0.39089389E-03_JPRB, 0.39124930E-03_JPRB, 0.39113447E-03_JPRB, 0.39098787E-03_JPRB  /)

RGHG1(:,70,12) = (/ &
  & 0.38273107E-03_JPRB, 0.38290844E-03_JPRB, 0.38314238E-03_JPRB, 0.38294018E-03_JPRB, 0.38267994E-03_JPRB, 0.38278658E-03_JPRB, &
  & 0.38286370E-03_JPRB, 0.38300952E-03_JPRB, 0.38304275E-03_JPRB, 0.38286196E-03_JPRB, 0.38266353E-03_JPRB, 0.38246435E-03_JPRB, &
  & 0.38218814E-03_JPRB, 0.38181375E-03_JPRB, 0.38136703E-03_JPRB, 0.38093329E-03_JPRB, 0.38063884E-03_JPRB, 0.38054190E-03_JPRB, &
  & 0.38052048E-03_JPRB, 0.38048167E-03_JPRB, 0.38057701E-03_JPRB, 0.38069051E-03_JPRB, 0.38094825E-03_JPRB, 0.38123194E-03_JPRB, &
  & 0.38169571E-03_JPRB, 0.38218324E-03_JPRB, 0.38286803E-03_JPRB, 0.38350263E-03_JPRB, 0.38406285E-03_JPRB, 0.38464894E-03_JPRB, &
  & 0.38491084E-03_JPRB, 0.38498408E-03_JPRB, 0.38503615E-03_JPRB, 0.38506466E-03_JPRB, 0.38489867E-03_JPRB, 0.38443826E-03_JPRB, &
  & 0.38390638E-03_JPRB, 0.38345064E-03_JPRB, 0.38309432E-03_JPRB, 0.38279444E-03_JPRB, 0.38264243E-03_JPRB, 0.38261407E-03_JPRB, &
  & 0.38287636E-03_JPRB, 0.38332118E-03_JPRB, 0.38384172E-03_JPRB, 0.38464429E-03_JPRB, 0.38548222E-03_JPRB, 0.38628845E-03_JPRB, &
  & 0.38699684E-03_JPRB, 0.38761701E-03_JPRB, 0.38828458E-03_JPRB, 0.38886252E-03_JPRB, 0.38928645E-03_JPRB, 0.38960150E-03_JPRB, &
  & 0.38981468E-03_JPRB, 0.39001884E-03_JPRB, 0.39021499E-03_JPRB, 0.39049502E-03_JPRB, 0.39067549E-03_JPRB, 0.39095045E-03_JPRB, &
  & 0.39135132E-03_JPRB, 0.39172239E-03_JPRB, 0.39165504E-03_JPRB, 0.39148298E-03_JPRB  /)

RGHG1(:,71,12) = (/ &
  & 0.38300087E-03_JPRB, 0.38317998E-03_JPRB, 0.38334233E-03_JPRB, 0.38316976E-03_JPRB, 0.38292866E-03_JPRB, 0.38304078E-03_JPRB, &
  & 0.38311883E-03_JPRB, 0.38325802E-03_JPRB, 0.38326854E-03_JPRB, 0.38308326E-03_JPRB, 0.38288086E-03_JPRB, 0.38268012E-03_JPRB, &
  & 0.38240859E-03_JPRB, 0.38204204E-03_JPRB, 0.38161084E-03_JPRB, 0.38115146E-03_JPRB, 0.38081378E-03_JPRB, 0.38068300E-03_JPRB, &
  & 0.38062114E-03_JPRB, 0.38055918E-03_JPRB, 0.38062862E-03_JPRB, 0.38074395E-03_JPRB, 0.38100218E-03_JPRB, 0.38130227E-03_JPRB, &
  & 0.38173137E-03_JPRB, 0.38217709E-03_JPRB, 0.38283391E-03_JPRB, 0.38343933E-03_JPRB, 0.38403534E-03_JPRB, 0.38464386E-03_JPRB, &
  & 0.38491832E-03_JPRB, 0.38499792E-03_JPRB, 0.38505778E-03_JPRB, 0.38509255E-03_JPRB, 0.38494221E-03_JPRB, 0.38453375E-03_JPRB, &
  & 0.38403698E-03_JPRB, 0.38356538E-03_JPRB, 0.38321838E-03_JPRB, 0.38294687E-03_JPRB, 0.38281829E-03_JPRB, 0.38283539E-03_JPRB, &
  & 0.38318803E-03_JPRB, 0.38368666E-03_JPRB, 0.38422468E-03_JPRB, 0.38504466E-03_JPRB, 0.38587382E-03_JPRB, 0.38668169E-03_JPRB, &
  & 0.38738922E-03_JPRB, 0.38801157E-03_JPRB, 0.38869278E-03_JPRB, 0.38929238E-03_JPRB, 0.38970530E-03_JPRB, 0.38999583E-03_JPRB, &
  & 0.39017808E-03_JPRB, 0.39040120E-03_JPRB, 0.39062801E-03_JPRB, 0.39092855E-03_JPRB, 0.39112519E-03_JPRB, 0.39138634E-03_JPRB, &
  & 0.39178361E-03_JPRB, 0.39217134E-03_JPRB, 0.39213676E-03_JPRB, 0.39194292E-03_JPRB  /)

RGHG1(:,72,12) = (/ &
  & 0.38325692E-03_JPRB, 0.38341966E-03_JPRB, 0.38351979E-03_JPRB, 0.38337372E-03_JPRB, 0.38315106E-03_JPRB, 0.38326918E-03_JPRB, &
  & 0.38335299E-03_JPRB, 0.38348642E-03_JPRB, 0.38347666E-03_JPRB, 0.38328930E-03_JPRB, 0.38308620E-03_JPRB, 0.38288408E-03_JPRB, &
  & 0.38262085E-03_JPRB, 0.38226490E-03_JPRB, 0.38185284E-03_JPRB, 0.38137732E-03_JPRB, 0.38099815E-03_JPRB, 0.38083718E-03_JPRB, &
  & 0.38072923E-03_JPRB, 0.38065482E-03_JPRB, 0.38069338E-03_JPRB, 0.38080433E-03_JPRB, 0.38105011E-03_JPRB, 0.38135436E-03_JPRB, &
  & 0.38176571E-03_JPRB, 0.38216603E-03_JPRB, 0.38279196E-03_JPRB, 0.38336927E-03_JPRB, 0.38399224E-03_JPRB, 0.38462265E-03_JPRB, &
  & 0.38490657E-03_JPRB, 0.38499561E-03_JPRB, 0.38506930E-03_JPRB, 0.38512412E-03_JPRB, 0.38500098E-03_JPRB, 0.38464599E-03_JPRB, &
  & 0.38418172E-03_JPRB, 0.38369167E-03_JPRB, 0.38337211E-03_JPRB, 0.38312963E-03_JPRB, 0.38302824E-03_JPRB, 0.38310596E-03_JPRB, &
  & 0.38354734E-03_JPRB, 0.38407799E-03_JPRB, 0.38463537E-03_JPRB, 0.38547380E-03_JPRB, 0.38629213E-03_JPRB, 0.38708731E-03_JPRB, &
  & 0.38779623E-03_JPRB, 0.38841143E-03_JPRB, 0.38910025E-03_JPRB, 0.38970699E-03_JPRB, 0.39011461E-03_JPRB, 0.39037495E-03_JPRB, &
  & 0.39053992E-03_JPRB, 0.39077663E-03_JPRB, 0.39102442E-03_JPRB, 0.39134063E-03_JPRB, 0.39156862E-03_JPRB, 0.39182769E-03_JPRB, &
  & 0.39220860E-03_JPRB, 0.39260900E-03_JPRB, 0.39259286E-03_JPRB, 0.39238243E-03_JPRB  /)

RGHG1(:,73,12) = (/ &
  & 0.38349895E-03_JPRB, 0.38363240E-03_JPRB, 0.38367935E-03_JPRB, 0.38355438E-03_JPRB, 0.38334813E-03_JPRB, 0.38346713E-03_JPRB, &
  & 0.38355396E-03_JPRB, 0.38368459E-03_JPRB, 0.38365742E-03_JPRB, 0.38346541E-03_JPRB, 0.38326825E-03_JPRB, 0.38306795E-03_JPRB, &
  & 0.38281648E-03_JPRB, 0.38247291E-03_JPRB, 0.38208115E-03_JPRB, 0.38160909E-03_JPRB, 0.38120317E-03_JPRB, 0.38100734E-03_JPRB, &
  & 0.38084811E-03_JPRB, 0.38076503E-03_JPRB, 0.38078386E-03_JPRB, 0.38087993E-03_JPRB, 0.38110571E-03_JPRB, 0.38140086E-03_JPRB, &
  & 0.38178880E-03_JPRB, 0.38215608E-03_JPRB, 0.38274389E-03_JPRB, 0.38330404E-03_JPRB, 0.38393552E-03_JPRB, 0.38457812E-03_JPRB, &
  & 0.38487924E-03_JPRB, 0.38497971E-03_JPRB, 0.38507522E-03_JPRB, 0.38515877E-03_JPRB, 0.38508929E-03_JPRB, 0.38479749E-03_JPRB, &
  & 0.38436269E-03_JPRB, 0.38387614E-03_JPRB, 0.38360362E-03_JPRB, 0.38339078E-03_JPRB, 0.38331803E-03_JPRB, 0.38346227E-03_JPRB, &
  & 0.38397707E-03_JPRB, 0.38453053E-03_JPRB, 0.38510974E-03_JPRB, 0.38595366E-03_JPRB, 0.38675360E-03_JPRB, 0.38752107E-03_JPRB, &
  & 0.38822303E-03_JPRB, 0.38882891E-03_JPRB, 0.38950848E-03_JPRB, 0.39011321E-03_JPRB, 0.39051187E-03_JPRB, 0.39074333E-03_JPRB, &
  & 0.39090246E-03_JPRB, 0.39114665E-03_JPRB, 0.39140398E-03_JPRB, 0.39173147E-03_JPRB, 0.39199247E-03_JPRB, 0.39225459E-03_JPRB, &
  & 0.39262033E-03_JPRB, 0.39301744E-03_JPRB, 0.39302690E-03_JPRB, 0.39282245E-03_JPRB  /)

RGHG1(:,74,12) = (/ &
  & 0.38372924E-03_JPRB, 0.38382580E-03_JPRB, 0.38382972E-03_JPRB, 0.38371896E-03_JPRB, 0.38352670E-03_JPRB, 0.38364116E-03_JPRB, &
  & 0.38373091E-03_JPRB, 0.38386038E-03_JPRB, 0.38381844E-03_JPRB, 0.38362045E-03_JPRB, 0.38343186E-03_JPRB, 0.38323531E-03_JPRB, &
  & 0.38299729E-03_JPRB, 0.38266901E-03_JPRB, 0.38229722E-03_JPRB, 0.38184320E-03_JPRB, 0.38142599E-03_JPRB, 0.38119801E-03_JPRB, &
  & 0.38098823E-03_JPRB, 0.38090210E-03_JPRB, 0.38090954E-03_JPRB, 0.38098707E-03_JPRB, 0.38118708E-03_JPRB, 0.38146063E-03_JPRB, &
  & 0.38181357E-03_JPRB, 0.38214359E-03_JPRB, 0.38269215E-03_JPRB, 0.38324360E-03_JPRB, 0.38385768E-03_JPRB, 0.38449479E-03_JPRB, &
  & 0.38481890E-03_JPRB, 0.38494835E-03_JPRB, 0.38507413E-03_JPRB, 0.38518779E-03_JPRB, 0.38518068E-03_JPRB, 0.38495241E-03_JPRB, &
  & 0.38456100E-03_JPRB, 0.38410969E-03_JPRB, 0.38388068E-03_JPRB, 0.38371391E-03_JPRB, 0.38368687E-03_JPRB, 0.38389820E-03_JPRB, &
  & 0.38447321E-03_JPRB, 0.38503310E-03_JPRB, 0.38563028E-03_JPRB, 0.38645049E-03_JPRB, 0.38723339E-03_JPRB, 0.38797802E-03_JPRB, &
  & 0.38866607E-03_JPRB, 0.38925396E-03_JPRB, 0.38991536E-03_JPRB, 0.39051620E-03_JPRB, 0.39090517E-03_JPRB, 0.39111654E-03_JPRB, &
  & 0.39126426E-03_JPRB, 0.39151289E-03_JPRB, 0.39177726E-03_JPRB, 0.39211467E-03_JPRB, 0.39240727E-03_JPRB, 0.39267718E-03_JPRB, &
  & 0.39301074E-03_JPRB, 0.39340057E-03_JPRB, 0.39345027E-03_JPRB, 0.39325884E-03_JPRB  /)

RGHG1(:,75,12) = (/ &
  & 0.38394564E-03_JPRB, 0.38399917E-03_JPRB, 0.38397075E-03_JPRB, 0.38386457E-03_JPRB, 0.38368619E-03_JPRB, 0.38379190E-03_JPRB, &
  & 0.38388414E-03_JPRB, 0.38401312E-03_JPRB, 0.38395813E-03_JPRB, 0.38375606E-03_JPRB, 0.38357741E-03_JPRB, 0.38338610E-03_JPRB, &
  & 0.38316150E-03_JPRB, 0.38285256E-03_JPRB, 0.38250060E-03_JPRB, 0.38207774E-03_JPRB, 0.38166449E-03_JPRB, 0.38141343E-03_JPRB, &
  & 0.38115748E-03_JPRB, 0.38107328E-03_JPRB, 0.38107566E-03_JPRB, 0.38113324E-03_JPRB, 0.38130242E-03_JPRB, 0.38154111E-03_JPRB, &
  & 0.38184162E-03_JPRB, 0.38212363E-03_JPRB, 0.38263767E-03_JPRB, 0.38318114E-03_JPRB, 0.38376159E-03_JPRB, 0.38437498E-03_JPRB, &
  & 0.38472473E-03_JPRB, 0.38490202E-03_JPRB, 0.38506614E-03_JPRB, 0.38520916E-03_JPRB, 0.38526457E-03_JPRB, 0.38509497E-03_JPRB, &
  & 0.38475522E-03_JPRB, 0.38436159E-03_JPRB, 0.38417593E-03_JPRB, 0.38407327E-03_JPRB, 0.38411787E-03_JPRB, 0.38439806E-03_JPRB, &
  & 0.38501406E-03_JPRB, 0.38557124E-03_JPRB, 0.38617881E-03_JPRB, 0.38695202E-03_JPRB, 0.38772221E-03_JPRB, 0.38845195E-03_JPRB, &
  & 0.38912319E-03_JPRB, 0.38968394E-03_JPRB, 0.39032013E-03_JPRB, 0.39091520E-03_JPRB, 0.39129334E-03_JPRB, 0.39149421E-03_JPRB, &
  & 0.39162584E-03_JPRB, 0.39187571E-03_JPRB, 0.39214194E-03_JPRB, 0.39248770E-03_JPRB, 0.39280269E-03_JPRB, 0.39308591E-03_JPRB, &
  & 0.39337871E-03_JPRB, 0.39375896E-03_JPRB, 0.39385874E-03_JPRB, 0.39367804E-03_JPRB  /)

RGHG1(:,76,12) = (/ &
  & 0.38414470E-03_JPRB, 0.38415027E-03_JPRB, 0.38410111E-03_JPRB, 0.38398548E-03_JPRB, 0.38382462E-03_JPRB, 0.38391926E-03_JPRB, &
  & 0.38401265E-03_JPRB, 0.38414049E-03_JPRB, 0.38407282E-03_JPRB, 0.38387351E-03_JPRB, 0.38370478E-03_JPRB, 0.38351969E-03_JPRB, &
  & 0.38330616E-03_JPRB, 0.38302234E-03_JPRB, 0.38269066E-03_JPRB, 0.38231092E-03_JPRB, 0.38191680E-03_JPRB, 0.38166090E-03_JPRB, &
  & 0.38136807E-03_JPRB, 0.38128963E-03_JPRB, 0.38129062E-03_JPRB, 0.38132930E-03_JPRB, 0.38146321E-03_JPRB, 0.38165211E-03_JPRB, &
  & 0.38187378E-03_JPRB, 0.38208871E-03_JPRB, 0.38258131E-03_JPRB, 0.38310565E-03_JPRB, 0.38365221E-03_JPRB, 0.38422341E-03_JPRB, &
  & 0.38459690E-03_JPRB, 0.38484127E-03_JPRB, 0.38505151E-03_JPRB, 0.38522080E-03_JPRB, 0.38532808E-03_JPRB, 0.38520551E-03_JPRB, &
  & 0.38491463E-03_JPRB, 0.38458554E-03_JPRB, 0.38445198E-03_JPRB, 0.38443231E-03_JPRB, 0.38458710E-03_JPRB, 0.38494083E-03_JPRB, &
  & 0.38556836E-03_JPRB, 0.38612599E-03_JPRB, 0.38673126E-03_JPRB, 0.38744522E-03_JPRB, 0.38821057E-03_JPRB, 0.38893547E-03_JPRB, &
  & 0.38959311E-03_JPRB, 0.39011744E-03_JPRB, 0.39072297E-03_JPRB, 0.39130928E-03_JPRB, 0.39167428E-03_JPRB, 0.39187469E-03_JPRB, &
  & 0.39198926E-03_JPRB, 0.39223637E-03_JPRB, 0.39249361E-03_JPRB, 0.39284535E-03_JPRB, 0.39316150E-03_JPRB, 0.39346501E-03_JPRB, &
  & 0.39372415E-03_JPRB, 0.39409333E-03_JPRB, 0.39424475E-03_JPRB, 0.39405990E-03_JPRB  /)

RGHG1(:,77,12) = (/ &
  & 0.38429970E-03_JPRB, 0.38426728E-03_JPRB, 0.38420617E-03_JPRB, 0.38407030E-03_JPRB, 0.38392965E-03_JPRB, 0.38401618E-03_JPRB, &
  & 0.38411007E-03_JPRB, 0.38422942E-03_JPRB, 0.38415799E-03_JPRB, 0.38395949E-03_JPRB, 0.38379925E-03_JPRB, 0.38361782E-03_JPRB, &
  & 0.38341773E-03_JPRB, 0.38316316E-03_JPRB, 0.38286227E-03_JPRB, 0.38252314E-03_JPRB, 0.38215552E-03_JPRB, 0.38190003E-03_JPRB, &
  & 0.38160416E-03_JPRB, 0.38151073E-03_JPRB, 0.38149125E-03_JPRB, 0.38150055E-03_JPRB, 0.38159735E-03_JPRB, 0.38175460E-03_JPRB, &
  & 0.38191671E-03_JPRB, 0.38205539E-03_JPRB, 0.38250718E-03_JPRB, 0.38302652E-03_JPRB, 0.38355025E-03_JPRB, 0.38409640E-03_JPRB, &
  & 0.38447934E-03_JPRB, 0.38477800E-03_JPRB, 0.38503322E-03_JPRB, 0.38522828E-03_JPRB, 0.38536910E-03_JPRB, 0.38527649E-03_JPRB, &
  & 0.38501411E-03_JPRB, 0.38475071E-03_JPRB, 0.38468196E-03_JPRB, 0.38475534E-03_JPRB, 0.38501613E-03_JPRB, 0.38542448E-03_JPRB, &
  & 0.38605816E-03_JPRB, 0.38662646E-03_JPRB, 0.38723205E-03_JPRB, 0.38790632E-03_JPRB, 0.38868317E-03_JPRB, 0.38940738E-03_JPRB, &
  & 0.39007229E-03_JPRB, 0.39055790E-03_JPRB, 0.39112701E-03_JPRB, 0.39169246E-03_JPRB, 0.39204679E-03_JPRB, 0.39224829E-03_JPRB, &
  & 0.39234489E-03_JPRB, 0.39258809E-03_JPRB, 0.39283377E-03_JPRB, 0.39318982E-03_JPRB, 0.39348031E-03_JPRB, 0.39377933E-03_JPRB, &
  & 0.39402873E-03_JPRB, 0.39439844E-03_JPRB, 0.39458915E-03_JPRB, 0.39440386E-03_JPRB  /)

RGHG1(:,78,12) = (/ &
  & 0.38439877E-03_JPRB, 0.38434642E-03_JPRB, 0.38428368E-03_JPRB, 0.38413197E-03_JPRB, 0.38401041E-03_JPRB, 0.38409243E-03_JPRB, &
  & 0.38418531E-03_JPRB, 0.38429713E-03_JPRB, 0.38422941E-03_JPRB, 0.38403161E-03_JPRB, 0.38387695E-03_JPRB, 0.38369649E-03_JPRB, &
  & 0.38350799E-03_JPRB, 0.38328176E-03_JPRB, 0.38300957E-03_JPRB, 0.38270157E-03_JPRB, 0.38235794E-03_JPRB, 0.38209914E-03_JPRB, &
  & 0.38178860E-03_JPRB, 0.38169170E-03_JPRB, 0.38164884E-03_JPRB, 0.38163676E-03_JPRB, 0.38170081E-03_JPRB, 0.38183271E-03_JPRB, &
  & 0.38194797E-03_JPRB, 0.38202994E-03_JPRB, 0.38244830E-03_JPRB, 0.38296761E-03_JPRB, 0.38347423E-03_JPRB, 0.38400068E-03_JPRB, &
  & 0.38438349E-03_JPRB, 0.38472217E-03_JPRB, 0.38501473E-03_JPRB, 0.38523855E-03_JPRB, 0.38540643E-03_JPRB, 0.38532981E-03_JPRB, &
  & 0.38509173E-03_JPRB, 0.38488880E-03_JPRB, 0.38489112E-03_JPRB, 0.38506116E-03_JPRB, 0.38540550E-03_JPRB, 0.38584734E-03_JPRB, &
  & 0.38649204E-03_JPRB, 0.38709083E-03_JPRB, 0.38769823E-03_JPRB, 0.38834072E-03_JPRB, 0.38913586E-03_JPRB, 0.38986657E-03_JPRB, &
  & 0.39055339E-03_JPRB, 0.39101159E-03_JPRB, 0.39155093E-03_JPRB, 0.39208661E-03_JPRB, 0.39242630E-03_JPRB, 0.39261931E-03_JPRB, &
  & 0.39269395E-03_JPRB, 0.39292487E-03_JPRB, 0.39316112E-03_JPRB, 0.39351869E-03_JPRB, 0.39378392E-03_JPRB, 0.39407177E-03_JPRB, &
  & 0.39431664E-03_JPRB, 0.39469078E-03_JPRB, 0.39490630E-03_JPRB, 0.39471706E-03_JPRB  /)

RGHG1(:,79,12) = (/ &
  & 0.38444104E-03_JPRB, 0.38438730E-03_JPRB, 0.38433574E-03_JPRB, 0.38417608E-03_JPRB, 0.38407032E-03_JPRB, 0.38414875E-03_JPRB, &
  & 0.38424162E-03_JPRB, 0.38434761E-03_JPRB, 0.38428725E-03_JPRB, 0.38409125E-03_JPRB, 0.38393824E-03_JPRB, 0.38375716E-03_JPRB, &
  & 0.38357681E-03_JPRB, 0.38337410E-03_JPRB, 0.38312550E-03_JPRB, 0.38284057E-03_JPRB, 0.38251469E-03_JPRB, 0.38224811E-03_JPRB, &
  & 0.38191812E-03_JPRB, 0.38182929E-03_JPRB, 0.38176748E-03_JPRB, 0.38174109E-03_JPRB, 0.38177928E-03_JPRB, 0.38189018E-03_JPRB, &
  & 0.38197050E-03_JPRB, 0.38201428E-03_JPRB, 0.38240804E-03_JPRB, 0.38292915E-03_JPRB, 0.38342237E-03_JPRB, 0.38393232E-03_JPRB, &
  & 0.38431165E-03_JPRB, 0.38467569E-03_JPRB, 0.38499726E-03_JPRB, 0.38525131E-03_JPRB, 0.38544218E-03_JPRB, 0.38537421E-03_JPRB, &
  & 0.38515863E-03_JPRB, 0.38501008E-03_JPRB, 0.38507424E-03_JPRB, 0.38533290E-03_JPRB, 0.38574536E-03_JPRB, 0.38621271E-03_JPRB, &
  & 0.38687332E-03_JPRB, 0.38751708E-03_JPRB, 0.38812178E-03_JPRB, 0.38874346E-03_JPRB, 0.38956172E-03_JPRB, 0.39030353E-03_JPRB, &
  & 0.39101477E-03_JPRB, 0.39146593E-03_JPRB, 0.39198189E-03_JPRB, 0.39248563E-03_JPRB, 0.39280713E-03_JPRB, 0.39298091E-03_JPRB, &
  & 0.39303344E-03_JPRB, 0.39324565E-03_JPRB, 0.39347416E-03_JPRB, 0.39383358E-03_JPRB, 0.39407477E-03_JPRB, 0.39434832E-03_JPRB, &
  & 0.39459575E-03_JPRB, 0.39497512E-03_JPRB, 0.39520328E-03_JPRB, 0.39500905E-03_JPRB  /)

RGHG1(:,80,12) = (/ &
  & 0.38442772E-03_JPRB, 0.38439062E-03_JPRB, 0.38436556E-03_JPRB, 0.38420858E-03_JPRB, 0.38411317E-03_JPRB, 0.38418582E-03_JPRB, &
  & 0.38428256E-03_JPRB, 0.38438463E-03_JPRB, 0.38433096E-03_JPRB, 0.38413905E-03_JPRB, 0.38398285E-03_JPRB, 0.38380093E-03_JPRB, &
  & 0.38362389E-03_JPRB, 0.38343596E-03_JPRB, 0.38320323E-03_JPRB, 0.38293557E-03_JPRB, 0.38261774E-03_JPRB, 0.38233872E-03_JPRB, &
  & 0.38199547E-03_JPRB, 0.38192374E-03_JPRB, 0.38185448E-03_JPRB, 0.38181841E-03_JPRB, 0.38183993E-03_JPRB, 0.38193262E-03_JPRB, &
  & 0.38198923E-03_JPRB, 0.38200989E-03_JPRB, 0.38238752E-03_JPRB, 0.38290928E-03_JPRB, 0.38339078E-03_JPRB, 0.38388585E-03_JPRB, &
  & 0.38426514E-03_JPRB, 0.38463979E-03_JPRB, 0.38498188E-03_JPRB, 0.38526573E-03_JPRB, 0.38547745E-03_JPRB, 0.38541813E-03_JPRB, &
  & 0.38522489E-03_JPRB, 0.38512433E-03_JPRB, 0.38522436E-03_JPRB, 0.38555110E-03_JPRB, 0.38602578E-03_JPRB, 0.38652572E-03_JPRB, &
  & 0.38720621E-03_JPRB, 0.38790237E-03_JPRB, 0.38849290E-03_JPRB, 0.38910855E-03_JPRB, 0.38995293E-03_JPRB, 0.39070722E-03_JPRB, &
  & 0.39143212E-03_JPRB, 0.39190527E-03_JPRB, 0.39240304E-03_JPRB, 0.39288059E-03_JPRB, 0.39318159E-03_JPRB, 0.39332489E-03_JPRB, &
  & 0.39335962E-03_JPRB, 0.39354949E-03_JPRB, 0.39377120E-03_JPRB, 0.39413638E-03_JPRB, 0.39435385E-03_JPRB, 0.39461293E-03_JPRB, &
  & 0.39487322E-03_JPRB, 0.39525567E-03_JPRB, 0.39548723E-03_JPRB, 0.39528982E-03_JPRB  /)

RGHG1(:,81,12) = (/ &
  & 0.38438493E-03_JPRB, 0.38437510E-03_JPRB, 0.38437065E-03_JPRB, 0.38422197E-03_JPRB, 0.38413605E-03_JPRB, 0.38420609E-03_JPRB, &
  & 0.38430970E-03_JPRB, 0.38440893E-03_JPRB, 0.38435929E-03_JPRB, 0.38417544E-03_JPRB, 0.38401425E-03_JPRB, 0.38382476E-03_JPRB, &
  & 0.38364250E-03_JPRB, 0.38346311E-03_JPRB, 0.38324436E-03_JPRB, 0.38299092E-03_JPRB, 0.38268044E-03_JPRB, 0.38239194E-03_JPRB, &
  & 0.38202925E-03_JPRB, 0.38198549E-03_JPRB, 0.38191718E-03_JPRB, 0.38187424E-03_JPRB, 0.38189006E-03_JPRB, 0.38196995E-03_JPRB, &
  & 0.38200689E-03_JPRB, 0.38201712E-03_JPRB, 0.38238290E-03_JPRB, 0.38290892E-03_JPRB, 0.38337904E-03_JPRB, 0.38385539E-03_JPRB, &
  & 0.38423753E-03_JPRB, 0.38461952E-03_JPRB, 0.38497489E-03_JPRB, 0.38527438E-03_JPRB, 0.38551171E-03_JPRB, 0.38546779E-03_JPRB, &
  & 0.38529209E-03_JPRB, 0.38522140E-03_JPRB, 0.38533541E-03_JPRB, 0.38570317E-03_JPRB, 0.38622384E-03_JPRB, 0.38675862E-03_JPRB, &
  & 0.38746802E-03_JPRB, 0.38821373E-03_JPRB, 0.38882298E-03_JPRB, 0.38945689E-03_JPRB, 0.39033233E-03_JPRB, 0.39109372E-03_JPRB, &
  & 0.39182313E-03_JPRB, 0.39234203E-03_JPRB, 0.39282581E-03_JPRB, 0.39323865E-03_JPRB, 0.39350504E-03_JPRB, 0.39363057E-03_JPRB, &
  & 0.39365652E-03_JPRB, 0.39382980E-03_JPRB, 0.39403657E-03_JPRB, 0.39440579E-03_JPRB, 0.39460500E-03_JPRB, 0.39485009E-03_JPRB, &
  & 0.39512295E-03_JPRB, 0.39550089E-03_JPRB, 0.39573933E-03_JPRB, 0.39557439E-03_JPRB  /)

RGHG1(:,82,12) = (/ &
  & 0.38436087E-03_JPRB, 0.38436637E-03_JPRB, 0.38437343E-03_JPRB, 0.38422793E-03_JPRB, 0.38414783E-03_JPRB, 0.38421904E-03_JPRB, &
  & 0.38432949E-03_JPRB, 0.38442621E-03_JPRB, 0.38438106E-03_JPRB, 0.38420408E-03_JPRB, 0.38403517E-03_JPRB, 0.38383879E-03_JPRB, &
  & 0.38365184E-03_JPRB, 0.38347521E-03_JPRB, 0.38326644E-03_JPRB, 0.38302436E-03_JPRB, 0.38272216E-03_JPRB, 0.38243142E-03_JPRB, &
  & 0.38205383E-03_JPRB, 0.38203738E-03_JPRB, 0.38197556E-03_JPRB, 0.38192856E-03_JPRB, 0.38194380E-03_JPRB, 0.38200982E-03_JPRB, &
  & 0.38202869E-03_JPRB, 0.38203214E-03_JPRB, 0.38238566E-03_JPRB, 0.38291608E-03_JPRB, 0.38336902E-03_JPRB, 0.38383018E-03_JPRB, &
  & 0.38421727E-03_JPRB, 0.38460885E-03_JPRB, 0.38497349E-03_JPRB, 0.38528314E-03_JPRB, 0.38554460E-03_JPRB, 0.38551845E-03_JPRB, &
  & 0.38535592E-03_JPRB, 0.38529875E-03_JPRB, 0.38542159E-03_JPRB, 0.38581703E-03_JPRB, 0.38637277E-03_JPRB, 0.38693238E-03_JPRB, &
  & 0.38766693E-03_JPRB, 0.38845484E-03_JPRB, 0.38910801E-03_JPRB, 0.38977590E-03_JPRB, 0.39068840E-03_JPRB, 0.39144690E-03_JPRB, &
  & 0.39218110E-03_JPRB, 0.39273533E-03_JPRB, 0.39322008E-03_JPRB, 0.39355522E-03_JPRB, 0.39377694E-03_JPRB, 0.39388872E-03_JPRB, &
  & 0.39392654E-03_JPRB, 0.39408806E-03_JPRB, 0.39427086E-03_JPRB, 0.39463281E-03_JPRB, 0.39481780E-03_JPRB, 0.39504867E-03_JPRB, &
  & 0.39533287E-03_JPRB, 0.39570503E-03_JPRB, 0.39595993E-03_JPRB, 0.39584278E-03_JPRB  /)

RGHG1(:,83,12) = (/ &
  & 0.38435063E-03_JPRB, 0.38436272E-03_JPRB, 0.38437582E-03_JPRB, 0.38422853E-03_JPRB, 0.38415237E-03_JPRB, 0.38422683E-03_JPRB, &
  & 0.38434360E-03_JPRB, 0.38443835E-03_JPRB, 0.38439715E-03_JPRB, 0.38422521E-03_JPRB, 0.38404806E-03_JPRB, 0.38384432E-03_JPRB, &
  & 0.38365303E-03_JPRB, 0.38347663E-03_JPRB, 0.38327450E-03_JPRB, 0.38304164E-03_JPRB, 0.38274763E-03_JPRB, 0.38245928E-03_JPRB, &
  & 0.38207563E-03_JPRB, 0.38208522E-03_JPRB, 0.38203608E-03_JPRB, 0.38198781E-03_JPRB, 0.38200360E-03_JPRB, 0.38205556E-03_JPRB, &
  & 0.38205822E-03_JPRB, 0.38205572E-03_JPRB, 0.38239767E-03_JPRB, 0.38292828E-03_JPRB, 0.38336025E-03_JPRB, 0.38380841E-03_JPRB, &
  & 0.38420523E-03_JPRB, 0.38460379E-03_JPRB, 0.38497907E-03_JPRB, 0.38529534E-03_JPRB, 0.38557509E-03_JPRB, 0.38556807E-03_JPRB, &
  & 0.38541431E-03_JPRB, 0.38536109E-03_JPRB, 0.38548894E-03_JPRB, 0.38590058E-03_JPRB, 0.38648220E-03_JPRB, 0.38706005E-03_JPRB, &
  & 0.38781270E-03_JPRB, 0.38863830E-03_JPRB, 0.38933916E-03_JPRB, 0.39005239E-03_JPRB, 0.39101730E-03_JPRB, 0.39177480E-03_JPRB, &
  & 0.39250929E-03_JPRB, 0.39308689E-03_JPRB, 0.39357269E-03_JPRB, 0.39382627E-03_JPRB, 0.39399609E-03_JPRB, 0.39410800E-03_JPRB, &
  & 0.39417041E-03_JPRB, 0.39432570E-03_JPRB, 0.39447789E-03_JPRB, 0.39481612E-03_JPRB, 0.39498819E-03_JPRB, 0.39520436E-03_JPRB, &
  & 0.39550111E-03_JPRB, 0.39586615E-03_JPRB, 0.39614758E-03_JPRB, 0.39608660E-03_JPRB  /)

RGHG1(:,84,12) = (/ &
  & 0.38434917E-03_JPRB, 0.38436231E-03_JPRB, 0.38437902E-03_JPRB, 0.38422590E-03_JPRB, 0.38415296E-03_JPRB, 0.38423144E-03_JPRB, &
  & 0.38435353E-03_JPRB, 0.38444701E-03_JPRB, 0.38440849E-03_JPRB, 0.38423945E-03_JPRB, 0.38405514E-03_JPRB, 0.38384296E-03_JPRB, &
  & 0.38364759E-03_JPRB, 0.38347142E-03_JPRB, 0.38327334E-03_JPRB, 0.38304808E-03_JPRB, 0.38276132E-03_JPRB, 0.38247815E-03_JPRB, &
  & 0.38209948E-03_JPRB, 0.38213419E-03_JPRB, 0.38210355E-03_JPRB, 0.38205625E-03_JPRB, 0.38207043E-03_JPRB, 0.38210915E-03_JPRB, &
  & 0.38209842E-03_JPRB, 0.38208853E-03_JPRB, 0.38242087E-03_JPRB, 0.38294556E-03_JPRB, 0.38335499E-03_JPRB, 0.38379152E-03_JPRB, &
  & 0.38420355E-03_JPRB, 0.38460354E-03_JPRB, 0.38499414E-03_JPRB, 0.38531475E-03_JPRB, 0.38560355E-03_JPRB, 0.38561590E-03_JPRB, &
  & 0.38546613E-03_JPRB, 0.38541339E-03_JPRB, 0.38554378E-03_JPRB, 0.38596228E-03_JPRB, 0.38656216E-03_JPRB, 0.38715446E-03_JPRB, &
  & 0.38791661E-03_JPRB, 0.38877730E-03_JPRB, 0.38951388E-03_JPRB, 0.39027813E-03_JPRB, 0.39131554E-03_JPRB, 0.39208308E-03_JPRB, &
  & 0.39281057E-03_JPRB, 0.39339891E-03_JPRB, 0.39387587E-03_JPRB, 0.39405133E-03_JPRB, 0.39416544E-03_JPRB, 0.39429633E-03_JPRB, &
  & 0.39438884E-03_JPRB, 0.39454353E-03_JPRB, 0.39466062E-03_JPRB, 0.39495607E-03_JPRB, 0.39511471E-03_JPRB, 0.39531575E-03_JPRB, &
  & 0.39562756E-03_JPRB, 0.39598400E-03_JPRB, 0.39630108E-03_JPRB, 0.39629801E-03_JPRB  /)

RGHG1(:,85,12) = (/ &
  & 0.38434834E-03_JPRB, 0.38436075E-03_JPRB, 0.38438034E-03_JPRB, 0.38422339E-03_JPRB, 0.38415021E-03_JPRB, 0.38423442E-03_JPRB, &
  & 0.38435891E-03_JPRB, 0.38445287E-03_JPRB, 0.38441578E-03_JPRB, 0.38424842E-03_JPRB, 0.38405622E-03_JPRB, 0.38383639E-03_JPRB, &
  & 0.38363791E-03_JPRB, 0.38346198E-03_JPRB, 0.38326653E-03_JPRB, 0.38304557E-03_JPRB, 0.38276455E-03_JPRB, 0.38249596E-03_JPRB, &
  & 0.38212827E-03_JPRB, 0.38220026E-03_JPRB, 0.38219017E-03_JPRB, 0.38214096E-03_JPRB, 0.38214629E-03_JPRB, 0.38217665E-03_JPRB, &
  & 0.38216593E-03_JPRB, 0.38214433E-03_JPRB, 0.38247475E-03_JPRB, 0.38300160E-03_JPRB, 0.38339167E-03_JPRB, 0.38382151E-03_JPRB, &
  & 0.38424238E-03_JPRB, 0.38464452E-03_JPRB, 0.38504946E-03_JPRB, 0.38536672E-03_JPRB, 0.38564812E-03_JPRB, 0.38567743E-03_JPRB, &
  & 0.38551834E-03_JPRB, 0.38547014E-03_JPRB, 0.38560340E-03_JPRB, 0.38602094E-03_JPRB, 0.38663014E-03_JPRB, 0.38723295E-03_JPRB, &
  & 0.38800227E-03_JPRB, 0.38889379E-03_JPRB, 0.38966071E-03_JPRB, 0.39046225E-03_JPRB, 0.39158544E-03_JPRB, 0.39238381E-03_JPRB, &
  & 0.39310246E-03_JPRB, 0.39368625E-03_JPRB, 0.39415629E-03_JPRB, 0.39425289E-03_JPRB, 0.39431276E-03_JPRB, 0.39446516E-03_JPRB, &
  & 0.39458801E-03_JPRB, 0.39474700E-03_JPRB, 0.39481869E-03_JPRB, 0.39504866E-03_JPRB, 0.39519584E-03_JPRB, 0.39538206E-03_JPRB, &
  & 0.39570749E-03_JPRB, 0.39605008E-03_JPRB, 0.39640730E-03_JPRB, 0.39645536E-03_JPRB  /)

RGHG1(:,86,12) = (/ &
  & 0.38434740E-03_JPRB, 0.38435966E-03_JPRB, 0.38437988E-03_JPRB, 0.38422171E-03_JPRB, 0.38414792E-03_JPRB, 0.38423677E-03_JPRB, &
  & 0.38436197E-03_JPRB, 0.38445641E-03_JPRB, 0.38442002E-03_JPRB, 0.38425247E-03_JPRB, 0.38405533E-03_JPRB, 0.38382875E-03_JPRB, &
  & 0.38362679E-03_JPRB, 0.38345128E-03_JPRB, 0.38325753E-03_JPRB, 0.38304034E-03_JPRB, 0.38276414E-03_JPRB, 0.38251132E-03_JPRB, &
  & 0.38216292E-03_JPRB, 0.38226956E-03_JPRB, 0.38227695E-03_JPRB, 0.38222207E-03_JPRB, 0.38222133E-03_JPRB, 0.38225132E-03_JPRB, &
  & 0.38224770E-03_JPRB, 0.38222967E-03_JPRB, 0.38256546E-03_JPRB, 0.38310606E-03_JPRB, 0.38348958E-03_JPRB, 0.38393084E-03_JPRB, &
  & 0.38436340E-03_JPRB, 0.38476508E-03_JPRB, 0.38518406E-03_JPRB, 0.38549160E-03_JPRB, 0.38572965E-03_JPRB, 0.38575900E-03_JPRB, &
  & 0.38557988E-03_JPRB, 0.38553962E-03_JPRB, 0.38568062E-03_JPRB, 0.38609084E-03_JPRB, 0.38670941E-03_JPRB, 0.38732391E-03_JPRB, &
  & 0.38809295E-03_JPRB, 0.38900592E-03_JPRB, 0.38980895E-03_JPRB, 0.39062831E-03_JPRB, 0.39182912E-03_JPRB, 0.39266876E-03_JPRB, &
  & 0.39339236E-03_JPRB, 0.39395177E-03_JPRB, 0.39442625E-03_JPRB, 0.39445163E-03_JPRB, 0.39444913E-03_JPRB, 0.39462726E-03_JPRB, &
  & 0.39477220E-03_JPRB, 0.39494000E-03_JPRB, 0.39495690E-03_JPRB, 0.39510872E-03_JPRB, 0.39524643E-03_JPRB, 0.39542206E-03_JPRB, &
  & 0.39575707E-03_JPRB, 0.39608086E-03_JPRB, 0.39647581E-03_JPRB, 0.39657695E-03_JPRB  /)

RGHG1(:,87,12) = (/ &
  & 0.38434680E-03_JPRB, 0.38435881E-03_JPRB, 0.38437853E-03_JPRB, 0.38422062E-03_JPRB, 0.38414635E-03_JPRB, 0.38423847E-03_JPRB, &
  & 0.38436354E-03_JPRB, 0.38445859E-03_JPRB, 0.38442219E-03_JPRB, 0.38425366E-03_JPRB, 0.38405300E-03_JPRB, 0.38382058E-03_JPRB, &
  & 0.38361582E-03_JPRB, 0.38344006E-03_JPRB, 0.38324765E-03_JPRB, 0.38303411E-03_JPRB, 0.38276181E-03_JPRB, 0.38252334E-03_JPRB, &
  & 0.38219141E-03_JPRB, 0.38233481E-03_JPRB, 0.38235940E-03_JPRB, 0.38230143E-03_JPRB, 0.38230005E-03_JPRB, 0.38233399E-03_JPRB, &
  & 0.38234549E-03_JPRB, 0.38234434E-03_JPRB, 0.38270675E-03_JPRB, 0.38325807E-03_JPRB, 0.38365261E-03_JPRB, 0.38414057E-03_JPRB, &
  & 0.38458345E-03_JPRB, 0.38499164E-03_JPRB, 0.38543958E-03_JPRB, 0.38571910E-03_JPRB, 0.38588869E-03_JPRB, 0.38586460E-03_JPRB, &
  & 0.38565746E-03_JPRB, 0.38562609E-03_JPRB, 0.38580015E-03_JPRB, 0.38619612E-03_JPRB, 0.38682420E-03_JPRB, 0.38744865E-03_JPRB, &
  & 0.38820555E-03_JPRB, 0.38913405E-03_JPRB, 0.38998409E-03_JPRB, 0.39080021E-03_JPRB, 0.39206790E-03_JPRB, 0.39295105E-03_JPRB, &
  & 0.39368741E-03_JPRB, 0.39420525E-03_JPRB, 0.39468517E-03_JPRB, 0.39465848E-03_JPRB, 0.39458352E-03_JPRB, 0.39479058E-03_JPRB, &
  & 0.39495665E-03_JPRB, 0.39513257E-03_JPRB, 0.39508656E-03_JPRB, 0.39514986E-03_JPRB, 0.39527629E-03_JPRB, 0.39544465E-03_JPRB, &
  & 0.39578696E-03_JPRB, 0.39609125E-03_JPRB, 0.39651779E-03_JPRB, 0.39665590E-03_JPRB  /)

RGHG1(:,88,12) = (/ &
  & 0.38434662E-03_JPRB, 0.38435812E-03_JPRB, 0.38437704E-03_JPRB, 0.38422000E-03_JPRB, 0.38414555E-03_JPRB, 0.38423953E-03_JPRB, &
  & 0.38436409E-03_JPRB, 0.38445983E-03_JPRB, 0.38442277E-03_JPRB, 0.38425311E-03_JPRB, 0.38404953E-03_JPRB, 0.38381226E-03_JPRB, &
  & 0.38360598E-03_JPRB, 0.38342860E-03_JPRB, 0.38323740E-03_JPRB, 0.38302755E-03_JPRB, 0.38275856E-03_JPRB, 0.38253158E-03_JPRB, &
  & 0.38220838E-03_JPRB, 0.38239229E-03_JPRB, 0.38243866E-03_JPRB, 0.38238466E-03_JPRB, 0.38239318E-03_JPRB, 0.38243310E-03_JPRB, &
  & 0.38246617E-03_JPRB, 0.38250476E-03_JPRB, 0.38292764E-03_JPRB, 0.38348547E-03_JPRB, 0.38391879E-03_JPRB, 0.38450012E-03_JPRB, &
  & 0.38495232E-03_JPRB, 0.38538058E-03_JPRB, 0.38588050E-03_JPRB, 0.38608722E-03_JPRB, 0.38616715E-03_JPRB, 0.38601088E-03_JPRB, &
  & 0.38576144E-03_JPRB, 0.38574074E-03_JPRB, 0.38601568E-03_JPRB, 0.38638598E-03_JPRB, 0.38702697E-03_JPRB, 0.38764540E-03_JPRB, &
  & 0.38836731E-03_JPRB, 0.38931028E-03_JPRB, 0.39022964E-03_JPRB, 0.39101490E-03_JPRB, 0.39232894E-03_JPRB, 0.39324952E-03_JPRB, &
  & 0.39399902E-03_JPRB, 0.39445263E-03_JPRB, 0.39493866E-03_JPRB, 0.39487235E-03_JPRB, 0.39472432E-03_JPRB, 0.39495677E-03_JPRB, &
  & 0.39515109E-03_JPRB, 0.39533303E-03_JPRB, 0.39521483E-03_JPRB, 0.39517939E-03_JPRB, 0.39529082E-03_JPRB, 0.39545492E-03_JPRB, &
  & 0.39580346E-03_JPRB, 0.39609018E-03_JPRB, 0.39654263E-03_JPRB, 0.39669384E-03_JPRB  /)

RGHG1(:,89,12) = (/ &
  & 0.38434664E-03_JPRB, 0.38435756E-03_JPRB, 0.38437625E-03_JPRB, 0.38421972E-03_JPRB, 0.38414529E-03_JPRB, 0.38424001E-03_JPRB, &
  & 0.38436407E-03_JPRB, 0.38446035E-03_JPRB, 0.38442222E-03_JPRB, 0.38425172E-03_JPRB, 0.38404557E-03_JPRB, 0.38380462E-03_JPRB, &
  & 0.38359807E-03_JPRB, 0.38341745E-03_JPRB, 0.38322731E-03_JPRB, 0.38302091E-03_JPRB, 0.38275543E-03_JPRB, 0.38253613E-03_JPRB, &
  & 0.38221191E-03_JPRB, 0.38244193E-03_JPRB, 0.38252147E-03_JPRB, 0.38248097E-03_JPRB, 0.38251721E-03_JPRB, 0.38256191E-03_JPRB, &
  & 0.38262021E-03_JPRB, 0.38274460E-03_JPRB, 0.38327988E-03_JPRB, 0.38385126E-03_JPRB, 0.38436839E-03_JPRB, 0.38509078E-03_JPRB, &
  & 0.38555120E-03_JPRB, 0.38600859E-03_JPRB, 0.38656840E-03_JPRB, 0.38662024E-03_JPRB, 0.38661042E-03_JPRB, 0.38623291E-03_JPRB, &
  & 0.38590157E-03_JPRB, 0.38589732E-03_JPRB, 0.38641966E-03_JPRB, 0.38676575E-03_JPRB, 0.38742384E-03_JPRB, 0.38798969E-03_JPRB, &
  & 0.38862676E-03_JPRB, 0.38959219E-03_JPRB, 0.39062064E-03_JPRB, 0.39133305E-03_JPRB, 0.39265389E-03_JPRB, 0.39358571E-03_JPRB, &
  & 0.39433233E-03_JPRB, 0.39468977E-03_JPRB, 0.39518736E-03_JPRB, 0.39506764E-03_JPRB, 0.39487279E-03_JPRB, 0.39511394E-03_JPRB, &
  & 0.39535182E-03_JPRB, 0.39554002E-03_JPRB, 0.39533974E-03_JPRB, 0.39520052E-03_JPRB, 0.39529487E-03_JPRB, 0.39545757E-03_JPRB, &
  & 0.39581178E-03_JPRB, 0.39608548E-03_JPRB, 0.39656061E-03_JPRB, 0.39670488E-03_JPRB  /)

RGHG1(:,90,12) = (/ &
  & 0.38434676E-03_JPRB, 0.38435688E-03_JPRB, 0.38437556E-03_JPRB, 0.38421928E-03_JPRB, 0.38414513E-03_JPRB, 0.38424014E-03_JPRB, &
  & 0.38436392E-03_JPRB, 0.38446076E-03_JPRB, 0.38442148E-03_JPRB, 0.38424986E-03_JPRB, 0.38404177E-03_JPRB, 0.38379743E-03_JPRB, &
  & 0.38359062E-03_JPRB, 0.38340633E-03_JPRB, 0.38321726E-03_JPRB, 0.38301432E-03_JPRB, 0.38275267E-03_JPRB, 0.38253915E-03_JPRB, &
  & 0.38219653E-03_JPRB, 0.38251092E-03_JPRB, 0.38263654E-03_JPRB, 0.38261337E-03_JPRB, 0.38269520E-03_JPRB, 0.38273615E-03_JPRB, &
  & 0.38284347E-03_JPRB, 0.38313577E-03_JPRB, 0.38389337E-03_JPRB, 0.38449665E-03_JPRB, 0.38516932E-03_JPRB, 0.38608977E-03_JPRB, &
  & 0.38652015E-03_JPRB, 0.38695977E-03_JPRB, 0.38749499E-03_JPRB, 0.38731653E-03_JPRB, 0.38731798E-03_JPRB, 0.38661988E-03_JPRB, &
  & 0.38608264E-03_JPRB, 0.38610633E-03_JPRB, 0.38711632E-03_JPRB, 0.38758167E-03_JPRB, 0.38822228E-03_JPRB, 0.38866099E-03_JPRB, &
  & 0.38910418E-03_JPRB, 0.39011586E-03_JPRB, 0.39130630E-03_JPRB, 0.39186725E-03_JPRB, 0.39315777E-03_JPRB, 0.39402505E-03_JPRB, &
  & 0.39471930E-03_JPRB, 0.39494233E-03_JPRB, 0.39543736E-03_JPRB, 0.39523295E-03_JPRB, 0.39502096E-03_JPRB, 0.39526462E-03_JPRB, &
  & 0.39555577E-03_JPRB, 0.39575581E-03_JPRB, 0.39545535E-03_JPRB, 0.39521105E-03_JPRB, 0.39529549E-03_JPRB, 0.39545817E-03_JPRB, &
  & 0.39581495E-03_JPRB, 0.39607952E-03_JPRB, 0.39656842E-03_JPRB, 0.39670750E-03_JPRB  /)

RGHG1(:,91,12) = (/ &
  & 0.38434647E-03_JPRB, 0.38435658E-03_JPRB, 0.38437496E-03_JPRB, 0.38421839E-03_JPRB, 0.38414424E-03_JPRB, 0.38423984E-03_JPRB, &
  & 0.38436363E-03_JPRB, 0.38446076E-03_JPRB, 0.38441970E-03_JPRB, 0.38424719E-03_JPRB, 0.38403761E-03_JPRB, 0.38378912E-03_JPRB, &
  & 0.38358260E-03_JPRB, 0.38339385E-03_JPRB, 0.38320450E-03_JPRB, 0.38300778E-03_JPRB, 0.38274703E-03_JPRB, 0.38254450E-03_JPRB, &
  & 0.38216149E-03_JPRB, 0.38266921E-03_JPRB, 0.38284294E-03_JPRB, 0.38285244E-03_JPRB, 0.38299246E-03_JPRB, 0.38300135E-03_JPRB, &
  & 0.38319775E-03_JPRB, 0.38388502E-03_JPRB, 0.38501443E-03_JPRB, 0.38580955E-03_JPRB, 0.38680414E-03_JPRB, 0.38818756E-03_JPRB, &
  & 0.38822862E-03_JPRB, 0.38850193E-03_JPRB, 0.38893856E-03_JPRB, 0.38827366E-03_JPRB, 0.38848477E-03_JPRB, 0.38726252E-03_JPRB, &
  & 0.38629735E-03_JPRB, 0.38636261E-03_JPRB, 0.38798258E-03_JPRB, 0.38922689E-03_JPRB, 0.38963318E-03_JPRB, 0.38978056E-03_JPRB, &
  & 0.39020861E-03_JPRB, 0.39133373E-03_JPRB, 0.39261297E-03_JPRB, 0.39292060E-03_JPRB, 0.39410333E-03_JPRB, 0.39481143E-03_JPRB, &
  & 0.39531087E-03_JPRB, 0.39525296E-03_JPRB, 0.39574412E-03_JPRB, 0.39541321E-03_JPRB, 0.39518340E-03_JPRB, 0.39542914E-03_JPRB, &
  & 0.39578978E-03_JPRB, 0.39596933E-03_JPRB, 0.39557621E-03_JPRB, 0.39521312E-03_JPRB, 0.39529371E-03_JPRB, 0.39545580E-03_JPRB, &
  & 0.39581644E-03_JPRB, 0.39607566E-03_JPRB, 0.39657050E-03_JPRB, 0.39670869E-03_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GCO2CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24




END SUBROUTINE SU_GCO2CLIM
