!option! -Nv -NO                                            :
#ifdef RS6K                                                 
@PROCESS NOOPTIMIZE                                         
#endif                                                      
!pgi$r opt=0                                                
SUBROUTINE SU_GOZOCLIM
                                                            
                                                            
!**   OZONE FROM GEMS and Cariolle above level 4 (level 4 ia average)                       
                                                            
!     PURPOSE.                                              
!     --------                                              
                                                            
!**   INTERFACE.                                            
!     ----------                                            
!        CALL *SU_GOZOCLIM* FROM *SU_GHGCLIM*                
                                                            
!        EXPLICIT ARGUMENTS :                               
!        --------------------                               
!     ==== INPUTS ===                                       
!     ==== OUTPUTS ===                                      
                                                            
!        IMPLICIT ARGUMENTS :   NONE                        
!        --------------------                               
                                                            
!     METHOD.                                               
!     -------                                               
                                                            
!     EXTERNALS.                                            
!     ----------                                            
                                                            
!          NONE                                             
                                                            
!     REFERENCE.                                            
!     ----------                                            
                                                            
!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION A
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F
                                                            
!     AUTHOR.                                               
!     -------                                               
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423               
                                                            
!     MODIFICATIONS.                                        
!     --------------                                        
!        Same history as suecaesu                           
!        M.Hamrud      01-Oct-2003 CY28 Cleaning            
!     R. Elkhatib 12-10-2005 Split for faster and more robus
                                                            
!-----------------------------------------------------------
                                                            
USE PARKIND1  ,ONLY : JPRB                        
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK                      
USE YOMCLIM   ,ONLY : RGHG7
                                                            
IMPLICIT NONE                                               
                                                            
!     ------------------------------------------------------
                                                            
!*       0.1   ARGUMENTS.                                   
!              ----------                                   
! REAL(KIND=JPRB),INTENT(OUT) :: PCLOZO(64,91,12)             
                                                            
!     ------------------------------------------------------
                                                            
!*       0.2   LOCAL ARRAYS.                                
!              -------------                                
                                                            
! REAL(KIND=JPRB),SAVE :: ZGHG9(64,91,12)                     
                                                            
LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.                        
                                                            
REAL(KIND=JPRB) :: ZHOOK_HANDLE                             
!     ------------------------------------------------------
                                                            
IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM',0,ZHOOK_HANDLE)        
                                                            
IF(LLFIRSTCALL) THEN                                        

  ALLOCATE(RGHG7(64,91,12))
                                                            
  CALL PART1                                                
  CALL PART2                                                
  CALL PART3                                                
  CALL PART4                                                
  CALL PART5                                                
  CALL PART6                                                
  CALL PART7                                                
  CALL PART8                                                
  CALL PART9                                                
  CALL PART10                                               
  CALL PART11                                               
  CALL PART12                                               
  CALL PART13                                               
  CALL PART14                                               
  CALL PART15                                               
  CALL PART16                                               
  CALL PART17                                               
  CALL PART18                                               
  CALL PART19                                               
  CALL PART20                                               
  CALL PART21                                               
  CALL PART22                                               
  CALL PART23                                               
  CALL PART24                                               
                                                            
ENDIF                                                       
                                                            
! PCLOZO(:,:,:)=ZGHG9(:,:,:)                                  
                                                            
!     ------------------------------------------------------
                                                            
LLFIRSTCALL = .FALSE.                                       
                                                            
IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM',1,ZHOOK_HANDLE)        
                                                            
!-----------------------------------------------------------
                                                            
CONTAINS                                                    
                                                            


SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ---GEMS----

RGHG7(:, 1, 1) = (/ &
  & 0.10244170E-06_JPRB, 0.87350955E-07_JPRB, 0.81038387E-07_JPRB, 0.74772849E-07_JPRB, 0.72049509E-07_JPRB, 0.69850522E-07_JPRB, &
  & 0.69082780E-07_JPRB, 0.68604685E-07_JPRB, 0.68582679E-07_JPRB, 0.68581038E-07_JPRB, 0.68945525E-07_JPRB, 0.69309124E-07_JPRB, &
  & 0.69722937E-07_JPRB, 0.70244738E-07_JPRB, 0.70545475E-07_JPRB, 0.70831106E-07_JPRB, 0.71162489E-07_JPRB, 0.71156606E-07_JPRB, &
  & 0.71030890E-07_JPRB, 0.70994048E-07_JPRB, 0.70629753E-07_JPRB, 0.70102381E-07_JPRB, 0.69524539E-07_JPRB, 0.68914574E-07_JPRB, &
  & 0.68273792E-07_JPRB, 0.67699482E-07_JPRB, 0.67135929E-07_JPRB, 0.66637568E-07_JPRB, 0.66264498E-07_JPRB, 0.66054348E-07_JPRB, &
  & 0.66057247E-07_JPRB, 0.66312261E-07_JPRB, 0.66834765E-07_JPRB, 0.67621471E-07_JPRB, 0.68457524E-07_JPRB, 0.69258469E-07_JPRB, &
  & 0.69895734E-07_JPRB, 0.70259205E-07_JPRB, 0.70301937E-07_JPRB, 0.70070286E-07_JPRB, 0.69767907E-07_JPRB, 0.69302395E-07_JPRB, &
  & 0.68806230E-07_JPRB, 0.68347141E-07_JPRB, 0.67961992E-07_JPRB, 0.67655748E-07_JPRB, 0.67421269E-07_JPRB, 0.67145521E-07_JPRB, &
  & 0.66836833E-07_JPRB, 0.66542469E-07_JPRB, 0.66337385E-07_JPRB, 0.66214518E-07_JPRB, 0.66234023E-07_JPRB, 0.66431127E-07_JPRB, &
  & 0.66817741E-07_JPRB, 0.67452810E-07_JPRB, 0.68440023E-07_JPRB, 0.75295830E-07_JPRB, 0.60362431E-05_JPRB, 0.60492280E-05_JPRB, &
  & 0.60431471E-05_JPRB, 0.60501566E-05_JPRB, 0.60950856E-05_JPRB, 0.61820888E-05_JPRB  /)

RGHG7(:, 2, 1) = (/ &
  & 0.29225527E-06_JPRB, 0.34611080E-06_JPRB, 0.33856784E-06_JPRB, 0.30258332E-06_JPRB, 0.26971924E-06_JPRB, 0.24052997E-06_JPRB, &
  & 0.22007153E-06_JPRB, 0.20748635E-06_JPRB, 0.19999524E-06_JPRB, 0.19278458E-06_JPRB, 0.19400827E-06_JPRB, 0.19481713E-06_JPRB, &
  & 0.19527734E-06_JPRB, 0.19766783E-06_JPRB, 0.19469812E-06_JPRB, 0.19420320E-06_JPRB, 0.19742761E-06_JPRB, 0.19571661E-06_JPRB, &
  & 0.19588933E-06_JPRB, 0.20098571E-06_JPRB, 0.20192954E-06_JPRB, 0.20230210E-06_JPRB, 0.20305818E-06_JPRB, 0.20424599E-06_JPRB, &
  & 0.20571450E-06_JPRB, 0.21030324E-06_JPRB, 0.21153618E-06_JPRB, 0.21123915E-06_JPRB, 0.21086223E-06_JPRB, 0.21050010E-06_JPRB, &
  & 0.21041544E-06_JPRB, 0.21094731E-06_JPRB, 0.21287508E-06_JPRB, 0.22110316E-06_JPRB, 0.22459746E-06_JPRB, 0.22583932E-06_JPRB, &
  & 0.22593383E-06_JPRB, 0.22493960E-06_JPRB, 0.22344258E-06_JPRB, 0.22200044E-06_JPRB, 0.22659682E-06_JPRB, 0.22722230E-06_JPRB, &
  & 0.22708950E-06_JPRB, 0.22835329E-06_JPRB, 0.23119350E-06_JPRB, 0.23519273E-06_JPRB, 0.24187966E-06_JPRB, 0.24568408E-06_JPRB, &
  & 0.24739757E-06_JPRB, 0.24707848E-06_JPRB, 0.24689894E-06_JPRB, 0.24354529E-06_JPRB, 0.23936340E-06_JPRB, 0.23637912E-06_JPRB, &
  & 0.23415542E-06_JPRB, 0.23626841E-06_JPRB, 0.24217846E-06_JPRB, 0.33588390E-06_JPRB, 0.77322493E-05_JPRB, 0.77550358E-05_JPRB, &
  & 0.78218300E-05_JPRB, 0.78287903E-05_JPRB, 0.78194107E-05_JPRB, 0.78002004E-05_JPRB  /)

RGHG7(:, 3, 1) = (/ &
  & 0.45009986E-06_JPRB, 0.54151985E-06_JPRB, 0.54272789E-06_JPRB, 0.52133953E-06_JPRB, 0.49654494E-06_JPRB, 0.47288449E-06_JPRB, &
  & 0.45947874E-06_JPRB, 0.44774305E-06_JPRB, 0.42706642E-06_JPRB, 0.40995698E-06_JPRB, 0.40599559E-06_JPRB, 0.39949595E-06_JPRB, &
  & 0.39712813E-06_JPRB, 0.39425117E-06_JPRB, 0.38779518E-06_JPRB, 0.38872494E-06_JPRB, 0.39399845E-06_JPRB, 0.38794764E-06_JPRB, &
  & 0.39494330E-06_JPRB, 0.40270075E-06_JPRB, 0.39971158E-06_JPRB, 0.39984775E-06_JPRB, 0.39969672E-06_JPRB, 0.40167592E-06_JPRB, &
  & 0.40620372E-06_JPRB, 0.41395637E-06_JPRB, 0.41204174E-06_JPRB, 0.41026561E-06_JPRB, 0.40866885E-06_JPRB, 0.40805398E-06_JPRB, &
  & 0.40843102E-06_JPRB, 0.41032564E-06_JPRB, 0.41638469E-06_JPRB, 0.42851798E-06_JPRB, 0.43007927E-06_JPRB, 0.42967196E-06_JPRB, &
  & 0.42739234E-06_JPRB, 0.42422448E-06_JPRB, 0.42100115E-06_JPRB, 0.41966362E-06_JPRB, 0.42747502E-06_JPRB, 0.42699290E-06_JPRB, &
  & 0.42739052E-06_JPRB, 0.42919368E-06_JPRB, 0.43225717E-06_JPRB, 0.43789902E-06_JPRB, 0.44965611E-06_JPRB, 0.45812496E-06_JPRB, &
  & 0.46811908E-06_JPRB, 0.48130266E-06_JPRB, 0.49552659E-06_JPRB, 0.50029399E-06_JPRB, 0.50032361E-06_JPRB, 0.50390605E-06_JPRB, &
  & 0.51735691E-06_JPRB, 0.55333021E-06_JPRB, 0.61758743E-06_JPRB, 0.13454649E-05_JPRB, 0.71261934E-05_JPRB, 0.70673391E-05_JPRB, &
  & 0.68782592E-05_JPRB, 0.67261394E-05_JPRB, 0.64878564E-05_JPRB, 0.60649236E-05_JPRB  /)

RGHG7(:, 4, 1) = (/ &
  & 0.38212871E-06_JPRB, 0.41106356E-06_JPRB, 0.40871089E-06_JPRB, 0.42095902E-06_JPRB, 0.46723196E-06_JPRB, 0.54374805E-06_JPRB, &
  & 0.62758586E-06_JPRB, 0.67384179E-06_JPRB, 0.68477499E-06_JPRB, 0.70534516E-06_JPRB, 0.72776308E-06_JPRB, 0.73804685E-06_JPRB, &
  & 0.74742593E-06_JPRB, 0.75086960E-06_JPRB, 0.75582528E-06_JPRB, 0.76868361E-06_JPRB, 0.78296187E-06_JPRB, 0.78873035E-06_JPRB, &
  & 0.80383003E-06_JPRB, 0.81343258E-06_JPRB, 0.81256313E-06_JPRB, 0.80828275E-06_JPRB, 0.80095992E-06_JPRB, 0.79230216E-06_JPRB, &
  & 0.78258482E-06_JPRB, 0.76641573E-06_JPRB, 0.73515703E-06_JPRB, 0.70758056E-06_JPRB, 0.67435086E-06_JPRB, 0.64067958E-06_JPRB, &
  & 0.60746738E-06_JPRB, 0.57937735E-06_JPRB, 0.56923122E-06_JPRB, 0.58361359E-06_JPRB, 0.61602482E-06_JPRB, 0.66569265E-06_JPRB, &
  & 0.72865131E-06_JPRB, 0.79305320E-06_JPRB, 0.86814083E-06_JPRB, 0.95812468E-06_JPRB, 0.10561969E-05_JPRB, 0.11438769E-05_JPRB, &
  & 0.12145998E-05_JPRB, 0.12936181E-05_JPRB, 0.13844620E-05_JPRB, 0.14791053E-05_JPRB, 0.15872563E-05_JPRB, 0.16719537E-05_JPRB, &
  & 0.17655976E-05_JPRB, 0.18791775E-05_JPRB, 0.19899512E-05_JPRB, 0.20473221E-05_JPRB, 0.20660723E-05_JPRB, 0.20621916E-05_JPRB, &
  & 0.20390389E-05_JPRB, 0.20338214E-05_JPRB, 0.20758932E-05_JPRB, 0.27082663E-05_JPRB, 0.37141463E-05_JPRB, 0.37072955E-05_JPRB, &
  & 0.36695077E-05_JPRB, 0.36205001E-05_JPRB, 0.35612810E-05_JPRB, 0.34341151E-05_JPRB  /)

RGHG7(:, 5, 1) = (/ &
  & 0.21214653E-06_JPRB, 0.22284375E-06_JPRB, 0.22393488E-06_JPRB, 0.27016949E-06_JPRB, 0.38301796E-06_JPRB, 0.55333318E-06_JPRB, &
  & 0.72192489E-06_JPRB, 0.80307305E-06_JPRB, 0.81903871E-06_JPRB, 0.84245867E-06_JPRB, 0.86922690E-06_JPRB, 0.88269516E-06_JPRB, &
  & 0.88760370E-06_JPRB, 0.89173117E-06_JPRB, 0.90001083E-06_JPRB, 0.91598148E-06_JPRB, 0.93357711E-06_JPRB, 0.94456442E-06_JPRB, &
  & 0.95194627E-06_JPRB, 0.95481396E-06_JPRB, 0.95428446E-06_JPRB, 0.94209014E-06_JPRB, 0.92318266E-06_JPRB, 0.89933876E-06_JPRB, &
  & 0.86369859E-06_JPRB, 0.81926630E-06_JPRB, 0.76588378E-06_JPRB, 0.71094298E-06_JPRB, 0.64969476E-06_JPRB, 0.58587670E-06_JPRB, &
  & 0.52143508E-06_JPRB, 0.46520648E-06_JPRB, 0.43574668E-06_JPRB, 0.45115166E-06_JPRB, 0.52461966E-06_JPRB, 0.63685897E-06_JPRB, &
  & 0.78127711E-06_JPRB, 0.93169015E-06_JPRB, 0.11054804E-05_JPRB, 0.12978913E-05_JPRB, 0.14863133E-05_JPRB, 0.16706377E-05_JPRB, &
  & 0.18222079E-05_JPRB, 0.19819144E-05_JPRB, 0.21575021E-05_JPRB, 0.23413288E-05_JPRB, 0.25427208E-05_JPRB, 0.27117813E-05_JPRB, &
  & 0.29109860E-05_JPRB, 0.31560049E-05_JPRB, 0.33720134E-05_JPRB, 0.34908336E-05_JPRB, 0.35149452E-05_JPRB, 0.34673281E-05_JPRB, &
  & 0.33645565E-05_JPRB, 0.32402435E-05_JPRB, 0.31325895E-05_JPRB, 0.30659754E-05_JPRB, 0.30385831E-05_JPRB, 0.29998116E-05_JPRB, &
  & 0.29878878E-05_JPRB, 0.29874475E-05_JPRB, 0.29935253E-05_JPRB, 0.29979927E-05_JPRB  /)

RGHG7(:, 6, 1) = (/ &
  & 0.39351372E-06_JPRB, 0.39334664E-06_JPRB, 0.37561653E-06_JPRB, 0.40850030E-06_JPRB, 0.51124958E-06_JPRB, 0.68026414E-06_JPRB, &
  & 0.85887855E-06_JPRB, 0.94821318E-06_JPRB, 0.96085069E-06_JPRB, 0.97095807E-06_JPRB, 0.98758884E-06_JPRB, 0.99570146E-06_JPRB, &
  & 0.99601946E-06_JPRB, 0.99861675E-06_JPRB, 0.10083883E-05_JPRB, 0.10282227E-05_JPRB, 0.10473485E-05_JPRB, 0.10553902E-05_JPRB, &
  & 0.10576077E-05_JPRB, 0.10553493E-05_JPRB, 0.10477809E-05_JPRB, 0.10285478E-05_JPRB, 0.10044377E-05_JPRB, 0.97409051E-06_JPRB, &
  & 0.93206184E-06_JPRB, 0.88330679E-06_JPRB, 0.82579278E-06_JPRB, 0.76771510E-06_JPRB, 0.70627561E-06_JPRB, 0.64505886E-06_JPRB, &
  & 0.58199441E-06_JPRB, 0.52576580E-06_JPRB, 0.49232753E-06_JPRB, 0.50275941E-06_JPRB, 0.57733680E-06_JPRB, 0.69787735E-06_JPRB, &
  & 0.85579934E-06_JPRB, 0.10247276E-05_JPRB, 0.12202847E-05_JPRB, 0.14246693E-05_JPRB, 0.16142772E-05_JPRB, 0.18004378E-05_JPRB, &
  & 0.19568280E-05_JPRB, 0.21069326E-05_JPRB, 0.22625897E-05_JPRB, 0.24335629E-05_JPRB, 0.26183524E-05_JPRB, 0.27855001E-05_JPRB, &
  & 0.29943450E-05_JPRB, 0.32401673E-05_JPRB, 0.34100408E-05_JPRB, 0.34978748E-05_JPRB, 0.34956290E-05_JPRB, 0.34201243E-05_JPRB, &
  & 0.33082864E-05_JPRB, 0.31690159E-05_JPRB, 0.30527164E-05_JPRB, 0.29996827E-05_JPRB, 0.29708367E-05_JPRB, 0.29501213E-05_JPRB, &
  & 0.29248849E-05_JPRB, 0.28917753E-05_JPRB, 0.28703481E-05_JPRB, 0.28608525E-05_JPRB  /)

RGHG7(:, 7, 1) = (/ &
  & 0.73058607E-06_JPRB, 0.71120664E-06_JPRB, 0.69244304E-06_JPRB, 0.71954534E-06_JPRB, 0.80891118E-06_JPRB, 0.95835762E-06_JPRB, &
  & 0.11132012E-05_JPRB, 0.11841284E-05_JPRB, 0.11944490E-05_JPRB, 0.12075534E-05_JPRB, 0.12224925E-05_JPRB, 0.12282117E-05_JPRB, &
  & 0.12291719E-05_JPRB, 0.12339037E-05_JPRB, 0.12492170E-05_JPRB, 0.12769456E-05_JPRB, 0.13019242E-05_JPRB, 0.13120692E-05_JPRB, &
  & 0.13165477E-05_JPRB, 0.13160320E-05_JPRB, 0.13064804E-05_JPRB, 0.12821213E-05_JPRB, 0.12519738E-05_JPRB, 0.12144835E-05_JPRB, &
  & 0.11690384E-05_JPRB, 0.11152467E-05_JPRB, 0.10519383E-05_JPRB, 0.99000021E-06_JPRB, 0.92264064E-06_JPRB, 0.86005613E-06_JPRB, &
  & 0.79837031E-06_JPRB, 0.74711741E-06_JPRB, 0.71419202E-06_JPRB, 0.72211155E-06_JPRB, 0.79545350E-06_JPRB, 0.92352939E-06_JPRB, &
  & 0.10980794E-05_JPRB, 0.12837967E-05_JPRB, 0.14821249E-05_JPRB, 0.16760288E-05_JPRB, 0.18506637E-05_JPRB, 0.20172321E-05_JPRB, &
  & 0.21604870E-05_JPRB, 0.22981533E-05_JPRB, 0.24364665E-05_JPRB, 0.25970604E-05_JPRB, 0.27672156E-05_JPRB, 0.29268836E-05_JPRB, &
  & 0.31407524E-05_JPRB, 0.33614637E-05_JPRB, 0.35025463E-05_JPRB, 0.35658426E-05_JPRB, 0.35359347E-05_JPRB, 0.34614395E-05_JPRB, &
  & 0.33454468E-05_JPRB, 0.32095016E-05_JPRB, 0.31053449E-05_JPRB, 0.30450321E-05_JPRB, 0.30136179E-05_JPRB, 0.29905513E-05_JPRB, &
  & 0.29571821E-05_JPRB, 0.29177526E-05_JPRB, 0.28889230E-05_JPRB, 0.28655697E-05_JPRB  /)

RGHG7(:, 8, 1) = (/ &
  & 0.11767316E-05_JPRB, 0.11548745E-05_JPRB, 0.11497524E-05_JPRB, 0.11774199E-05_JPRB, 0.12519028E-05_JPRB, 0.13701548E-05_JPRB, &
  & 0.14810488E-05_JPRB, 0.15206190E-05_JPRB, 0.15306278E-05_JPRB, 0.15558739E-05_JPRB, 0.15769287E-05_JPRB, 0.15889348E-05_JPRB, &
  & 0.15988522E-05_JPRB, 0.16119714E-05_JPRB, 0.16347405E-05_JPRB, 0.16689850E-05_JPRB, 0.17006564E-05_JPRB, 0.17194513E-05_JPRB, &
  & 0.17342560E-05_JPRB, 0.17457714E-05_JPRB, 0.17499666E-05_JPRB, 0.17394870E-05_JPRB, 0.17220697E-05_JPRB, 0.16958761E-05_JPRB, &
  & 0.16673622E-05_JPRB, 0.16297273E-05_JPRB, 0.15825773E-05_JPRB, 0.15366100E-05_JPRB, 0.14844849E-05_JPRB, 0.14399711E-05_JPRB, &
  & 0.13958084E-05_JPRB, 0.13599099E-05_JPRB, 0.13346435E-05_JPRB, 0.13326865E-05_JPRB, 0.13795405E-05_JPRB, 0.14714429E-05_JPRB, &
  & 0.16138147E-05_JPRB, 0.17641105E-05_JPRB, 0.19137117E-05_JPRB, 0.20564255E-05_JPRB, 0.21836674E-05_JPRB, 0.23062595E-05_JPRB, &
  & 0.24201964E-05_JPRB, 0.25457755E-05_JPRB, 0.26755418E-05_JPRB, 0.28296379E-05_JPRB, 0.29875347E-05_JPRB, 0.31409864E-05_JPRB, &
  & 0.33477860E-05_JPRB, 0.35330030E-05_JPRB, 0.36452417E-05_JPRB, 0.36796953E-05_JPRB, 0.36372475E-05_JPRB, 0.35590718E-05_JPRB, &
  & 0.34423539E-05_JPRB, 0.33211627E-05_JPRB, 0.32345465E-05_JPRB, 0.31632522E-05_JPRB, 0.31168885E-05_JPRB, 0.30874274E-05_JPRB, &
  & 0.30527668E-05_JPRB, 0.30273483E-05_JPRB, 0.30203577E-05_JPRB, 0.30108206E-05_JPRB  /)

RGHG7(:, 9, 1) = (/ &
  & 0.16838721E-05_JPRB, 0.16862334E-05_JPRB, 0.17076010E-05_JPRB, 0.17452157E-05_JPRB, 0.18090404E-05_JPRB, 0.18890827E-05_JPRB, &
  & 0.19469355E-05_JPRB, 0.19571177E-05_JPRB, 0.19760857E-05_JPRB, 0.20225613E-05_JPRB, 0.20603497E-05_JPRB, 0.20910849E-05_JPRB, &
  & 0.21206150E-05_JPRB, 0.21524846E-05_JPRB, 0.21881609E-05_JPRB, 0.22293635E-05_JPRB, 0.22693602E-05_JPRB, 0.23031846E-05_JPRB, &
  & 0.23372660E-05_JPRB, 0.23719353E-05_JPRB, 0.24080708E-05_JPRB, 0.24355922E-05_JPRB, 0.24598552E-05_JPRB, 0.24769198E-05_JPRB, &
  & 0.24964569E-05_JPRB, 0.25080520E-05_JPRB, 0.25153131E-05_JPRB, 0.25274248E-05_JPRB, 0.25348405E-05_JPRB, 0.25477520E-05_JPRB, &
  & 0.25542937E-05_JPRB, 0.25556975E-05_JPRB, 0.25474403E-05_JPRB, 0.25289414E-05_JPRB, 0.25225455E-05_JPRB, 0.25252443E-05_JPRB, &
  & 0.25615747E-05_JPRB, 0.25963231E-05_JPRB, 0.26294928E-05_JPRB, 0.26707952E-05_JPRB, 0.27110653E-05_JPRB, 0.27651232E-05_JPRB, &
  & 0.28315664E-05_JPRB, 0.29353618E-05_JPRB, 0.30560932E-05_JPRB, 0.32020801E-05_JPRB, 0.33500517E-05_JPRB, 0.34970152E-05_JPRB, &
  & 0.36739012E-05_JPRB, 0.38111036E-05_JPRB, 0.38835344E-05_JPRB, 0.38896355E-05_JPRB, 0.38422142E-05_JPRB, 0.37535331E-05_JPRB, &
  & 0.36419403E-05_JPRB, 0.35318753E-05_JPRB, 0.34532283E-05_JPRB, 0.33681399E-05_JPRB, 0.33024552E-05_JPRB, 0.32717732E-05_JPRB, &
  & 0.32443402E-05_JPRB, 0.32395370E-05_JPRB, 0.32636850E-05_JPRB, 0.32810932E-05_JPRB  /)

RGHG7(:,10, 1) = (/ &
  & 0.22045183E-05_JPRB, 0.22340711E-05_JPRB, 0.22771354E-05_JPRB, 0.23269236E-05_JPRB, 0.23872916E-05_JPRB, 0.24333580E-05_JPRB, &
  & 0.24558424E-05_JPRB, 0.24640027E-05_JPRB, 0.25094920E-05_JPRB, 0.25857919E-05_JPRB, 0.26503920E-05_JPRB, 0.27080224E-05_JPRB, &
  & 0.27638273E-05_JPRB, 0.28233240E-05_JPRB, 0.28814898E-05_JPRB, 0.29378728E-05_JPRB, 0.29925897E-05_JPRB, 0.30462271E-05_JPRB, &
  & 0.31054641E-05_JPRB, 0.31667998E-05_JPRB, 0.32381740E-05_JPRB, 0.33102319E-05_JPRB, 0.33919535E-05_JPRB, 0.34737875E-05_JPRB, &
  & 0.35577699E-05_JPRB, 0.36369911E-05_JPRB, 0.37215150E-05_JPRB, 0.38179381E-05_JPRB, 0.39065987E-05_JPRB, 0.39917601E-05_JPRB, &
  & 0.40607086E-05_JPRB, 0.41047599E-05_JPRB, 0.41087867E-05_JPRB, 0.40740283E-05_JPRB, 0.40179514E-05_JPRB, 0.39368836E-05_JPRB, &
  & 0.38521162E-05_JPRB, 0.37481169E-05_JPRB, 0.36542025E-05_JPRB, 0.35884200E-05_JPRB, 0.35412913E-05_JPRB, 0.35372257E-05_JPRB, &
  & 0.35611190E-05_JPRB, 0.36403533E-05_JPRB, 0.37505881E-05_JPRB, 0.38878372E-05_JPRB, 0.40261401E-05_JPRB, 0.41527099E-05_JPRB, &
  & 0.42636180E-05_JPRB, 0.43205741E-05_JPRB, 0.43195218E-05_JPRB, 0.42806663E-05_JPRB, 0.41958801E-05_JPRB, 0.40859510E-05_JPRB, &
  & 0.39679632E-05_JPRB, 0.38462781E-05_JPRB, 0.37555768E-05_JPRB, 0.36656217E-05_JPRB, 0.36029414E-05_JPRB, 0.35800993E-05_JPRB, &
  & 0.35626717E-05_JPRB, 0.35580462E-05_JPRB, 0.35808536E-05_JPRB, 0.36007011E-05_JPRB  /)

RGHG7(:,11, 1) = (/ &
  & 0.28233238E-05_JPRB, 0.28520426E-05_JPRB, 0.28911175E-05_JPRB, 0.29333352E-05_JPRB, 0.29835413E-05_JPRB, 0.30063994E-05_JPRB, &
  & 0.30231708E-05_JPRB, 0.30569837E-05_JPRB, 0.31374233E-05_JPRB, 0.32501993E-05_JPRB, 0.33472573E-05_JPRB, 0.34338541E-05_JPRB, &
  & 0.35194866E-05_JPRB, 0.36077417E-05_JPRB, 0.36929739E-05_JPRB, 0.37738621E-05_JPRB, 0.38538708E-05_JPRB, 0.39355991E-05_JPRB, &
  & 0.40249603E-05_JPRB, 0.41126105E-05_JPRB, 0.42122301E-05_JPRB, 0.43182507E-05_JPRB, 0.44445736E-05_JPRB, 0.45777616E-05_JPRB, &
  & 0.47121286E-05_JPRB, 0.48483021E-05_JPRB, 0.49851780E-05_JPRB, 0.51222645E-05_JPRB, 0.52393936E-05_JPRB, 0.53377999E-05_JPRB, &
  & 0.54126887E-05_JPRB, 0.54545366E-05_JPRB, 0.54528259E-05_JPRB, 0.54145461E-05_JPRB, 0.53475735E-05_JPRB, 0.52524856E-05_JPRB, &
  & 0.51310025E-05_JPRB, 0.49717296E-05_JPRB, 0.48223052E-05_JPRB, 0.47076969E-05_JPRB, 0.46265414E-05_JPRB, 0.46068620E-05_JPRB, &
  & 0.46215193E-05_JPRB, 0.47021513E-05_JPRB, 0.48083018E-05_JPRB, 0.49269456E-05_JPRB, 0.50227093E-05_JPRB, 0.50768401E-05_JPRB, &
  & 0.50754699E-05_JPRB, 0.50150758E-05_JPRB, 0.49117391E-05_JPRB, 0.47872620E-05_JPRB, 0.46352408E-05_JPRB, 0.44797782E-05_JPRB, &
  & 0.43310633E-05_JPRB, 0.41997505E-05_JPRB, 0.40999261E-05_JPRB, 0.40339344E-05_JPRB, 0.39954752E-05_JPRB, 0.39861934E-05_JPRB, &
  & 0.39837916E-05_JPRB, 0.39710760E-05_JPRB, 0.39838821E-05_JPRB, 0.40022849E-05_JPRB  /)

RGHG7(:,12, 1) = (/ &
  & 0.37031939E-05_JPRB, 0.37121428E-05_JPRB, 0.37268691E-05_JPRB, 0.37447582E-05_JPRB, 0.37726118E-05_JPRB, 0.37780929E-05_JPRB, &
  & 0.37941805E-05_JPRB, 0.38492248E-05_JPRB, 0.39552027E-05_JPRB, 0.41007186E-05_JPRB, 0.42296102E-05_JPRB, 0.43430417E-05_JPRB, &
  & 0.44597159E-05_JPRB, 0.45753784E-05_JPRB, 0.46891727E-05_JPRB, 0.48003942E-05_JPRB, 0.49141341E-05_JPRB, 0.50265633E-05_JPRB, &
  & 0.51477695E-05_JPRB, 0.52656926E-05_JPRB, 0.53953543E-05_JPRB, 0.55290258E-05_JPRB, 0.56781588E-05_JPRB, 0.58389802E-05_JPRB, &
  & 0.60056188E-05_JPRB, 0.61754928E-05_JPRB, 0.63256150E-05_JPRB, 0.64553647E-05_JPRB, 0.65521145E-05_JPRB, 0.66161696E-05_JPRB, &
  & 0.66523452E-05_JPRB, 0.66617401E-05_JPRB, 0.66479497E-05_JPRB, 0.66211375E-05_JPRB, 0.65815048E-05_JPRB, 0.65238453E-05_JPRB, &
  & 0.64416574E-05_JPRB, 0.63185271E-05_JPRB, 0.61837519E-05_JPRB, 0.60686626E-05_JPRB, 0.59781964E-05_JPRB, 0.59321928E-05_JPRB, &
  & 0.59064083E-05_JPRB, 0.59325718E-05_JPRB, 0.59619272E-05_JPRB, 0.59773907E-05_JPRB, 0.59444535E-05_JPRB, 0.58577239E-05_JPRB, &
  & 0.57328073E-05_JPRB, 0.55722356E-05_JPRB, 0.53982605E-05_JPRB, 0.52183812E-05_JPRB, 0.50226538E-05_JPRB, 0.48402228E-05_JPRB, &
  & 0.46875876E-05_JPRB, 0.45665280E-05_JPRB, 0.44779219E-05_JPRB, 0.44312458E-05_JPRB, 0.44163005E-05_JPRB, 0.44353508E-05_JPRB, &
  & 0.44670195E-05_JPRB, 0.44744322E-05_JPRB, 0.44919715E-05_JPRB, 0.45127481E-05_JPRB  /)

RGHG7(:,13, 1) = (/ &
  & 0.47536242E-05_JPRB, 0.47371677E-05_JPRB, 0.47195618E-05_JPRB, 0.47090835E-05_JPRB, 0.47116799E-05_JPRB, 0.47119879E-05_JPRB, &
  & 0.47349317E-05_JPRB, 0.48077266E-05_JPRB, 0.49427904E-05_JPRB, 0.51192661E-05_JPRB, 0.52803051E-05_JPRB, 0.54123391E-05_JPRB, &
  & 0.55514636E-05_JPRB, 0.56895176E-05_JPRB, 0.58301932E-05_JPRB, 0.59699821E-05_JPRB, 0.61118337E-05_JPRB, 0.62483510E-05_JPRB, &
  & 0.63939729E-05_JPRB, 0.65391872E-05_JPRB, 0.66968234E-05_JPRB, 0.68521158E-05_JPRB, 0.70140508E-05_JPRB, 0.71876234E-05_JPRB, &
  & 0.73641808E-05_JPRB, 0.75318512E-05_JPRB, 0.76698769E-05_JPRB, 0.77800073E-05_JPRB, 0.78479257E-05_JPRB, 0.78761896E-05_JPRB, &
  & 0.78732222E-05_JPRB, 0.78398374E-05_JPRB, 0.77802428E-05_JPRB, 0.77157700E-05_JPRB, 0.76663783E-05_JPRB, 0.76260265E-05_JPRB, &
  & 0.75865010E-05_JPRB, 0.75290109E-05_JPRB, 0.74587375E-05_JPRB, 0.73840717E-05_JPRB, 0.73006766E-05_JPRB, 0.72170062E-05_JPRB, &
  & 0.71016325E-05_JPRB, 0.70029572E-05_JPRB, 0.69047154E-05_JPRB, 0.67736085E-05_JPRB, 0.65914933E-05_JPRB, 0.63787210E-05_JPRB, &
  & 0.61729877E-05_JPRB, 0.59577427E-05_JPRB, 0.57555445E-05_JPRB, 0.55620594E-05_JPRB, 0.53540485E-05_JPRB, 0.51666546E-05_JPRB, &
  & 0.50324821E-05_JPRB, 0.49274224E-05_JPRB, 0.48579529E-05_JPRB, 0.48283959E-05_JPRB, 0.48377764E-05_JPRB, 0.48896967E-05_JPRB, &
  & 0.49503691E-05_JPRB, 0.49958034E-05_JPRB, 0.50316396E-05_JPRB, 0.50516804E-05_JPRB  /)

RGHG7(:,14, 1) = (/ &
  & 0.55704793E-05_JPRB, 0.55442736E-05_JPRB, 0.55023899E-05_JPRB, 0.54732666E-05_JPRB, 0.54652287E-05_JPRB, 0.54834084E-05_JPRB, &
  & 0.55376374E-05_JPRB, 0.56401867E-05_JPRB, 0.58176666E-05_JPRB, 0.60360300E-05_JPRB, 0.62445217E-05_JPRB, 0.64028598E-05_JPRB, &
  & 0.65686096E-05_JPRB, 0.67293524E-05_JPRB, 0.68920526E-05_JPRB, 0.70503884E-05_JPRB, 0.72109987E-05_JPRB, 0.73664581E-05_JPRB, &
  & 0.75316590E-05_JPRB, 0.76999385E-05_JPRB, 0.78810408E-05_JPRB, 0.80557187E-05_JPRB, 0.82290706E-05_JPRB, 0.84033274E-05_JPRB, &
  & 0.85678247E-05_JPRB, 0.87082434E-05_JPRB, 0.88298524E-05_JPRB, 0.89307770E-05_JPRB, 0.89876416E-05_JPRB, 0.90045329E-05_JPRB, &
  & 0.89886176E-05_JPRB, 0.89230415E-05_JPRB, 0.87945452E-05_JPRB, 0.86497746E-05_JPRB, 0.85290314E-05_JPRB, 0.84374501E-05_JPRB, &
  & 0.83688204E-05_JPRB, 0.83137973E-05_JPRB, 0.82701038E-05_JPRB, 0.82272991E-05_JPRB, 0.81590557E-05_JPRB, 0.80535781E-05_JPRB, &
  & 0.78801625E-05_JPRB, 0.76790835E-05_JPRB, 0.74725397E-05_JPRB, 0.72310961E-05_JPRB, 0.69439529E-05_JPRB, 0.66693119E-05_JPRB, &
  & 0.64224246E-05_JPRB, 0.61855558E-05_JPRB, 0.59829347E-05_JPRB, 0.57965749E-05_JPRB, 0.56052591E-05_JPRB, 0.54353466E-05_JPRB, &
  & 0.53268377E-05_JPRB, 0.52488464E-05_JPRB, 0.51975964E-05_JPRB, 0.51890884E-05_JPRB, 0.52207625E-05_JPRB, 0.52929190E-05_JPRB, &
  & 0.53722427E-05_JPRB, 0.54374260E-05_JPRB, 0.55016920E-05_JPRB, 0.55263358E-05_JPRB  /)

RGHG7(:,15, 1) = (/ &
  & 0.57994775E-05_JPRB, 0.57877874E-05_JPRB, 0.57536901E-05_JPRB, 0.57338718E-05_JPRB, 0.57492666E-05_JPRB, 0.58130594E-05_JPRB, &
  & 0.59112024E-05_JPRB, 0.60487150E-05_JPRB, 0.62732390E-05_JPRB, 0.65516316E-05_JPRB, 0.68254158E-05_JPRB, 0.70300107E-05_JPRB, &
  & 0.72381582E-05_JPRB, 0.74276550E-05_JPRB, 0.76156413E-05_JPRB, 0.77974530E-05_JPRB, 0.79863032E-05_JPRB, 0.81687094E-05_JPRB, &
  & 0.83599207E-05_JPRB, 0.85536047E-05_JPRB, 0.87583470E-05_JPRB, 0.89512793E-05_JPRB, 0.91341019E-05_JPRB, 0.93018243E-05_JPRB, &
  & 0.94441147E-05_JPRB, 0.95502420E-05_JPRB, 0.96456560E-05_JPRB, 0.97272753E-05_JPRB, 0.97707584E-05_JPRB, 0.97876279E-05_JPRB, &
  & 0.97732608E-05_JPRB, 0.96826999E-05_JPRB, 0.94966593E-05_JPRB, 0.92812969E-05_JPRB, 0.90938918E-05_JPRB, 0.89487087E-05_JPRB, &
  & 0.88211443E-05_JPRB, 0.87226484E-05_JPRB, 0.86550964E-05_JPRB, 0.85961873E-05_JPRB, 0.85184741E-05_JPRB, 0.83923598E-05_JPRB, &
  & 0.81978090E-05_JPRB, 0.79433675E-05_JPRB, 0.76647735E-05_JPRB, 0.73522228E-05_JPRB, 0.70205951E-05_JPRB, 0.67324716E-05_JPRB, &
  & 0.64830658E-05_JPRB, 0.62535664E-05_JPRB, 0.60666508E-05_JPRB, 0.58980155E-05_JPRB, 0.57419758E-05_JPRB, 0.56001959E-05_JPRB, &
  & 0.55162115E-05_JPRB, 0.54669380E-05_JPRB, 0.54378272E-05_JPRB, 0.54464016E-05_JPRB, 0.54951932E-05_JPRB, 0.55720052E-05_JPRB, &
  & 0.56670789E-05_JPRB, 0.57428825E-05_JPRB, 0.58311205E-05_JPRB, 0.58764610E-05_JPRB  /)

RGHG7(:,16, 1) = (/ &
  & 0.55768690E-05_JPRB, 0.55918304E-05_JPRB, 0.55863163E-05_JPRB, 0.55958261E-05_JPRB, 0.56511816E-05_JPRB, 0.57628750E-05_JPRB, &
  & 0.59028647E-05_JPRB, 0.60824190E-05_JPRB, 0.63446238E-05_JPRB, 0.66652422E-05_JPRB, 0.69819318E-05_JPRB, 0.72303344E-05_JPRB, &
  & 0.74766840E-05_JPRB, 0.77020084E-05_JPRB, 0.79285867E-05_JPRB, 0.81510573E-05_JPRB, 0.83865882E-05_JPRB, 0.86142659E-05_JPRB, &
  & 0.88458631E-05_JPRB, 0.90736777E-05_JPRB, 0.93032839E-05_JPRB, 0.95123829E-05_JPRB, 0.97042942E-05_JPRB, 0.98680298E-05_JPRB, &
  & 0.99912074E-05_JPRB, 0.10063879E-04_JPRB, 0.10119829E-04_JPRB, 0.10163416E-04_JPRB, 0.10180591E-04_JPRB, 0.10184428E-04_JPRB, &
  & 0.10154945E-04_JPRB, 0.10044214E-04_JPRB, 0.98390858E-05_JPRB, 0.95927204E-05_JPRB, 0.93715156E-05_JPRB, 0.91947880E-05_JPRB, &
  & 0.90294185E-05_JPRB, 0.88894936E-05_JPRB, 0.87794501E-05_JPRB, 0.86683799E-05_JPRB, 0.85426437E-05_JPRB, 0.83792737E-05_JPRB, &
  & 0.81582630E-05_JPRB, 0.78641295E-05_JPRB, 0.75342433E-05_JPRB, 0.71837446E-05_JPRB, 0.68607774E-05_JPRB, 0.65927767E-05_JPRB, &
  & 0.63694658E-05_JPRB, 0.61724750E-05_JPRB, 0.60178820E-05_JPRB, 0.58804476E-05_JPRB, 0.57571574E-05_JPRB, 0.56556028E-05_JPRB, &
  & 0.55945357E-05_JPRB, 0.55655911E-05_JPRB, 0.55596704E-05_JPRB, 0.55860220E-05_JPRB, 0.56449174E-05_JPRB, 0.57274077E-05_JPRB, &
  & 0.58229256E-05_JPRB, 0.59138571E-05_JPRB, 0.60102827E-05_JPRB, 0.60612635E-05_JPRB  /)

RGHG7(:,17, 1) = (/ &
  & 0.51872869E-05_JPRB, 0.52060670E-05_JPRB, 0.52222831E-05_JPRB, 0.52605898E-05_JPRB, 0.53446957E-05_JPRB, 0.54999110E-05_JPRB, &
  & 0.56856292E-05_JPRB, 0.59180249E-05_JPRB, 0.62278945E-05_JPRB, 0.65858712E-05_JPRB, 0.69243328E-05_JPRB, 0.71995530E-05_JPRB, &
  & 0.74686955E-05_JPRB, 0.77203066E-05_JPRB, 0.79754202E-05_JPRB, 0.82310453E-05_JPRB, 0.85030470E-05_JPRB, 0.87718775E-05_JPRB, &
  & 0.90368287E-05_JPRB, 0.92865145E-05_JPRB, 0.95287006E-05_JPRB, 0.97498983E-05_JPRB, 0.99555659E-05_JPRB, 0.10124910E-04_JPRB, &
  & 0.10241796E-04_JPRB, 0.10294584E-04_JPRB, 0.10314077E-04_JPRB, 0.10323489E-04_JPRB, 0.10315707E-04_JPRB, 0.10298949E-04_JPRB, &
  & 0.10254069E-04_JPRB, 0.10134011E-04_JPRB, 0.99162506E-05_JPRB, 0.96586353E-05_JPRB, 0.94215862E-05_JPRB, 0.92287322E-05_JPRB, &
  & 0.90518121E-05_JPRB, 0.88911747E-05_JPRB, 0.87368095E-05_JPRB, 0.85571445E-05_JPRB, 0.83571932E-05_JPRB, 0.81355074E-05_JPRB, &
  & 0.78724618E-05_JPRB, 0.75490138E-05_JPRB, 0.72107116E-05_JPRB, 0.68695778E-05_JPRB, 0.65918205E-05_JPRB, 0.63594823E-05_JPRB, &
  & 0.61739868E-05_JPRB, 0.60129790E-05_JPRB, 0.58928254E-05_JPRB, 0.57877493E-05_JPRB, 0.56905166E-05_JPRB, 0.56263417E-05_JPRB, &
  & 0.55920507E-05_JPRB, 0.55802734E-05_JPRB, 0.55963716E-05_JPRB, 0.56348607E-05_JPRB, 0.57050781E-05_JPRB, 0.57930963E-05_JPRB, &
  & 0.58917047E-05_JPRB, 0.59954548E-05_JPRB, 0.60867538E-05_JPRB, 0.61012871E-05_JPRB  /)

RGHG7(:,18, 1) = (/ &
  & 0.47556517E-05_JPRB, 0.47788942E-05_JPRB, 0.48178830E-05_JPRB, 0.48887355E-05_JPRB, 0.49997202E-05_JPRB, 0.51830055E-05_JPRB, &
  & 0.53994491E-05_JPRB, 0.56639651E-05_JPRB, 0.60139110E-05_JPRB, 0.64072520E-05_JPRB, 0.67644682E-05_JPRB, 0.70580115E-05_JPRB, &
  & 0.73430304E-05_JPRB, 0.76152496E-05_JPRB, 0.78884116E-05_JPRB, 0.81666083E-05_JPRB, 0.84600455E-05_JPRB, 0.87505330E-05_JPRB, &
  & 0.90309081E-05_JPRB, 0.92818977E-05_JPRB, 0.95220499E-05_JPRB, 0.97470141E-05_JPRB, 0.99631708E-05_JPRB, 0.10145075E-04_JPRB, &
  & 0.10267832E-04_JPRB, 0.10317937E-04_JPRB, 0.10322439E-04_JPRB, 0.10307261E-04_JPRB, 0.10271991E-04_JPRB, 0.10234946E-04_JPRB, &
  & 0.10176505E-04_JPRB, 0.10042765E-04_JPRB, 0.98128837E-05_JPRB, 0.95394422E-05_JPRB, 0.92982730E-05_JPRB, 0.91188754E-05_JPRB, &
  & 0.89525113E-05_JPRB, 0.87818667E-05_JPRB, 0.85880726E-05_JPRB, 0.83475003E-05_JPRB, 0.80677713E-05_JPRB, 0.77812931E-05_JPRB, &
  & 0.74903783E-05_JPRB, 0.71884791E-05_JPRB, 0.68935293E-05_JPRB, 0.65901866E-05_JPRB, 0.63479603E-05_JPRB, 0.61460395E-05_JPRB, &
  & 0.59881504E-05_JPRB, 0.58570405E-05_JPRB, 0.57591840E-05_JPRB, 0.56706950E-05_JPRB, 0.55922376E-05_JPRB, 0.55445861E-05_JPRB, &
  & 0.55368890E-05_JPRB, 0.55364985E-05_JPRB, 0.55649329E-05_JPRB, 0.56177260E-05_JPRB, 0.56927644E-05_JPRB, 0.57826697E-05_JPRB, &
  & 0.58883532E-05_JPRB, 0.60014112E-05_JPRB, 0.60852984E-05_JPRB, 0.60821762E-05_JPRB  /)

RGHG7(:,19, 1) = (/ &
  & 0.43431953E-05_JPRB, 0.43829090E-05_JPRB, 0.44481132E-05_JPRB, 0.45470725E-05_JPRB, 0.46805757E-05_JPRB, 0.48752586E-05_JPRB, &
  & 0.51020911E-05_JPRB, 0.53771194E-05_JPRB, 0.57408905E-05_JPRB, 0.61500959E-05_JPRB, 0.65215980E-05_JPRB, 0.68295545E-05_JPRB, &
  & 0.71272092E-05_JPRB, 0.74157117E-05_JPRB, 0.76973748E-05_JPRB, 0.79824804E-05_JPRB, 0.82753277E-05_JPRB, 0.85613506E-05_JPRB, &
  & 0.88266185E-05_JPRB, 0.90521132E-05_JPRB, 0.92648440E-05_JPRB, 0.94748415E-05_JPRB, 0.96891076E-05_JPRB, 0.98796691E-05_JPRB, &
  & 0.10013440E-04_JPRB, 0.10078718E-04_JPRB, 0.10091073E-04_JPRB, 0.10068809E-04_JPRB, 0.10024527E-04_JPRB, 0.99842222E-05_JPRB, &
  & 0.99194222E-05_JPRB, 0.97749452E-05_JPRB, 0.95386658E-05_JPRB, 0.92589041E-05_JPRB, 0.90374125E-05_JPRB, 0.88939502E-05_JPRB, &
  & 0.87440077E-05_JPRB, 0.85652687E-05_JPRB, 0.83389245E-05_JPRB, 0.80555527E-05_JPRB, 0.77252795E-05_JPRB, 0.74085952E-05_JPRB, &
  & 0.71300729E-05_JPRB, 0.68777065E-05_JPRB, 0.66411230E-05_JPRB, 0.63838030E-05_JPRB, 0.61658250E-05_JPRB, 0.59846597E-05_JPRB, &
  & 0.58380246E-05_JPRB, 0.57236210E-05_JPRB, 0.56410680E-05_JPRB, 0.55591847E-05_JPRB, 0.54854062E-05_JPRB, 0.54397260E-05_JPRB, &
  & 0.54405277E-05_JPRB, 0.54492184E-05_JPRB, 0.54794115E-05_JPRB, 0.55396009E-05_JPRB, 0.56164692E-05_JPRB, 0.57110762E-05_JPRB, &
  & 0.58162013E-05_JPRB, 0.59258693E-05_JPRB, 0.60072616E-05_JPRB, 0.60290826E-05_JPRB  /)

RGHG7(:,20, 1) = (/ &
  & 0.39945122E-05_JPRB, 0.40482844E-05_JPRB, 0.41347397E-05_JPRB, 0.42561890E-05_JPRB, 0.44017385E-05_JPRB, 0.45972702E-05_JPRB, &
  & 0.48227651E-05_JPRB, 0.50905074E-05_JPRB, 0.54357985E-05_JPRB, 0.58283077E-05_JPRB, 0.61952233E-05_JPRB, 0.65095627E-05_JPRB, &
  & 0.68175057E-05_JPRB, 0.71173490E-05_JPRB, 0.73980661E-05_JPRB, 0.76710818E-05_JPRB, 0.79376561E-05_JPRB, 0.81894989E-05_JPRB, &
  & 0.84086541E-05_JPRB, 0.85871561E-05_JPRB, 0.87553196E-05_JPRB, 0.89290395E-05_JPRB, 0.91197440E-05_JPRB, 0.93056537E-05_JPRB, &
  & 0.94489780E-05_JPRB, 0.95378919E-05_JPRB, 0.95814373E-05_JPRB, 0.95840249E-05_JPRB, 0.95615632E-05_JPRB, 0.95412241E-05_JPRB, &
  & 0.94857116E-05_JPRB, 0.93435950E-05_JPRB, 0.91074110E-05_JPRB, 0.88351416E-05_JPRB, 0.86407445E-05_JPRB, 0.85204967E-05_JPRB, &
  & 0.83731888E-05_JPRB, 0.81842201E-05_JPRB, 0.79378327E-05_JPRB, 0.76443426E-05_JPRB, 0.73237321E-05_JPRB, 0.70298238E-05_JPRB, &
  & 0.67941076E-05_JPRB, 0.65992996E-05_JPRB, 0.64183280E-05_JPRB, 0.62086309E-05_JPRB, 0.60245300E-05_JPRB, 0.58641139E-05_JPRB, &
  & 0.57232196E-05_JPRB, 0.56182222E-05_JPRB, 0.55453168E-05_JPRB, 0.54642584E-05_JPRB, 0.53881985E-05_JPRB, 0.53378124E-05_JPRB, &
  & 0.53325111E-05_JPRB, 0.53407416E-05_JPRB, 0.53645281E-05_JPRB, 0.54172179E-05_JPRB, 0.54940754E-05_JPRB, 0.55895804E-05_JPRB, &
  & 0.56890727E-05_JPRB, 0.57863415E-05_JPRB, 0.58606449E-05_JPRB, 0.59185368E-05_JPRB  /)

RGHG7(:,21, 1) = (/ &
  & 0.37046142E-05_JPRB, 0.37625160E-05_JPRB, 0.38625098E-05_JPRB, 0.40002282E-05_JPRB, 0.41470754E-05_JPRB, 0.43387242E-05_JPRB, &
  & 0.45573867E-05_JPRB, 0.48064287E-05_JPRB, 0.51112724E-05_JPRB, 0.54589225E-05_JPRB, 0.57975436E-05_JPRB, 0.61032726E-05_JPRB, &
  & 0.64120360E-05_JPRB, 0.67134832E-05_JPRB, 0.69835502E-05_JPRB, 0.72295307E-05_JPRB, 0.74523654E-05_JPRB, 0.76480332E-05_JPRB, &
  & 0.78023502E-05_JPRB, 0.79228205E-05_JPRB, 0.80377680E-05_JPRB, 0.81594678E-05_JPRB, 0.83053666E-05_JPRB, 0.84710309E-05_JPRB, &
  & 0.86178998E-05_JPRB, 0.87283770E-05_JPRB, 0.88141420E-05_JPRB, 0.88661237E-05_JPRB, 0.88920818E-05_JPRB, 0.89139825E-05_JPRB, &
  & 0.88910626E-05_JPRB, 0.87728058E-05_JPRB, 0.85470146E-05_JPRB, 0.82891185E-05_JPRB, 0.81087224E-05_JPRB, 0.79794284E-05_JPRB, &
  & 0.78135216E-05_JPRB, 0.76125292E-05_JPRB, 0.73649824E-05_JPRB, 0.70993327E-05_JPRB, 0.68467113E-05_JPRB, 0.66226498E-05_JPRB, &
  & 0.64501599E-05_JPRB, 0.63176862E-05_JPRB, 0.61910120E-05_JPRB, 0.60337986E-05_JPRB, 0.58966009E-05_JPRB, 0.57637614E-05_JPRB, &
  & 0.56318283E-05_JPRB, 0.55331223E-05_JPRB, 0.54645191E-05_JPRB, 0.53821240E-05_JPRB, 0.53037168E-05_JPRB, 0.52476057E-05_JPRB, &
  & 0.52293710E-05_JPRB, 0.52283833E-05_JPRB, 0.52401932E-05_JPRB, 0.52740251E-05_JPRB, 0.53448076E-05_JPRB, 0.54333865E-05_JPRB, &
  & 0.55217493E-05_JPRB, 0.56019567E-05_JPRB, 0.56646941E-05_JPRB, 0.57451082E-05_JPRB  /)

RGHG7(:,22, 1) = (/ &
  & 0.34542571E-05_JPRB, 0.35029334E-05_JPRB, 0.36086044E-05_JPRB, 0.37541290E-05_JPRB, 0.38931700E-05_JPRB, 0.40810678E-05_JPRB, &
  & 0.42909104E-05_JPRB, 0.45166352E-05_JPRB, 0.47757571E-05_JPRB, 0.50610594E-05_JPRB, 0.53459498E-05_JPRB, 0.56177168E-05_JPRB, &
  & 0.59044811E-05_JPRB, 0.61889980E-05_JPRB, 0.64370659E-05_JPRB, 0.66476652E-05_JPRB, 0.68226491E-05_JPRB, 0.69523194E-05_JPRB, &
  & 0.70406389E-05_JPRB, 0.71044385E-05_JPRB, 0.71645401E-05_JPRB, 0.72268319E-05_JPRB, 0.73102814E-05_JPRB, 0.74395508E-05_JPRB, &
  & 0.75792218E-05_JPRB, 0.76975052E-05_JPRB, 0.78169279E-05_JPRB, 0.79247693E-05_JPRB, 0.80159138E-05_JPRB, 0.81008721E-05_JPRB, &
  & 0.81442539E-05_JPRB, 0.80820595E-05_JPRB, 0.78845530E-05_JPRB, 0.76360851E-05_JPRB, 0.74328788E-05_JPRB, 0.72480293E-05_JPRB, &
  & 0.70386310E-05_JPRB, 0.68261829E-05_JPRB, 0.66060083E-05_JPRB, 0.64111209E-05_JPRB, 0.62720436E-05_JPRB, 0.61528077E-05_JPRB, &
  & 0.60583795E-05_JPRB, 0.59978847E-05_JPRB, 0.59334570E-05_JPRB, 0.58413287E-05_JPRB, 0.57572535E-05_JPRB, 0.56639517E-05_JPRB, &
  & 0.55512805E-05_JPRB, 0.54575421E-05_JPRB, 0.53873168E-05_JPRB, 0.53050231E-05_JPRB, 0.52301641E-05_JPRB, 0.51721269E-05_JPRB, &
  & 0.51420308E-05_JPRB, 0.51283709E-05_JPRB, 0.51246698E-05_JPRB, 0.51370094E-05_JPRB, 0.51876175E-05_JPRB, 0.52588607E-05_JPRB, &
  & 0.53264408E-05_JPRB, 0.53882987E-05_JPRB, 0.54416079E-05_JPRB, 0.55107689E-05_JPRB  /)

RGHG7(:,23, 1) = (/ &
  & 0.32273019E-05_JPRB, 0.32870761E-05_JPRB, 0.33887495E-05_JPRB, 0.35264437E-05_JPRB, 0.36636377E-05_JPRB, 0.38454275E-05_JPRB, &
  & 0.40369380E-05_JPRB, 0.42342300E-05_JPRB, 0.44457019E-05_JPRB, 0.46711992E-05_JPRB, 0.48976987E-05_JPRB, 0.51196728E-05_JPRB, &
  & 0.53556125E-05_JPRB, 0.55958435E-05_JPRB, 0.58022400E-05_JPRB, 0.59669993E-05_JPRB, 0.60930047E-05_JPRB, 0.61721765E-05_JPRB, &
  & 0.62153201E-05_JPRB, 0.62386234E-05_JPRB, 0.62555311E-05_JPRB, 0.62729458E-05_JPRB, 0.63119417E-05_JPRB, 0.64020713E-05_JPRB, &
  & 0.65216977E-05_JPRB, 0.66342073E-05_JPRB, 0.67528245E-05_JPRB, 0.68818774E-05_JPRB, 0.70079049E-05_JPRB, 0.71473046E-05_JPRB, &
  & 0.72524287E-05_JPRB, 0.72514684E-05_JPRB, 0.71088412E-05_JPRB, 0.68855481E-05_JPRB, 0.66465467E-05_JPRB, 0.63908429E-05_JPRB, &
  & 0.61357797E-05_JPRB, 0.59226057E-05_JPRB, 0.57528125E-05_JPRB, 0.56326295E-05_JPRB, 0.55935595E-05_JPRB, 0.55856470E-05_JPRB, &
  & 0.55876323E-05_JPRB, 0.56096805E-05_JPRB, 0.56140383E-05_JPRB, 0.55854104E-05_JPRB, 0.55504236E-05_JPRB, 0.54993978E-05_JPRB, &
  & 0.54188156E-05_JPRB, 0.53398706E-05_JPRB, 0.52757529E-05_JPRB, 0.52008495E-05_JPRB, 0.51306241E-05_JPRB, 0.50744666E-05_JPRB, &
  & 0.50389619E-05_JPRB, 0.50179471E-05_JPRB, 0.50048376E-05_JPRB, 0.50072159E-05_JPRB, 0.50361969E-05_JPRB, 0.50813745E-05_JPRB, &
  & 0.51260089E-05_JPRB, 0.51678967E-05_JPRB, 0.52155472E-05_JPRB, 0.52779567E-05_JPRB  /)

RGHG7(:,24, 1) = (/ &
  & 0.30198807E-05_JPRB, 0.30943780E-05_JPRB, 0.31853653E-05_JPRB, 0.33093993E-05_JPRB, 0.34443982E-05_JPRB, 0.36131692E-05_JPRB, &
  & 0.37812087E-05_JPRB, 0.39453608E-05_JPRB, 0.41101868E-05_JPRB, 0.42813987E-05_JPRB, 0.44539848E-05_JPRB, 0.46250356E-05_JPRB, &
  & 0.48030249E-05_JPRB, 0.49867735E-05_JPRB, 0.51427323E-05_JPRB, 0.52567960E-05_JPRB, 0.53334392E-05_JPRB, 0.53685639E-05_JPRB, &
  & 0.53756160E-05_JPRB, 0.53655481E-05_JPRB, 0.53468879E-05_JPRB, 0.53299861E-05_JPRB, 0.53363826E-05_JPRB, 0.53903857E-05_JPRB, &
  & 0.54857275E-05_JPRB, 0.55850601E-05_JPRB, 0.56867528E-05_JPRB, 0.58100498E-05_JPRB, 0.59433778E-05_JPRB, 0.61079731E-05_JPRB, &
  & 0.62545390E-05_JPRB, 0.63061416E-05_JPRB, 0.62218629E-05_JPRB, 0.60334817E-05_JPRB, 0.57730994E-05_JPRB, 0.54695903E-05_JPRB, &
  & 0.51955364E-05_JPRB, 0.50017686E-05_JPRB, 0.48866808E-05_JPRB, 0.48379125E-05_JPRB, 0.48881744E-05_JPRB, 0.49849698E-05_JPRB, &
  & 0.50850841E-05_JPRB, 0.51864357E-05_JPRB, 0.52568147E-05_JPRB, 0.52883499E-05_JPRB, 0.52987060E-05_JPRB, 0.52885574E-05_JPRB, &
  & 0.52416573E-05_JPRB, 0.51827300E-05_JPRB, 0.51312325E-05_JPRB, 0.50668052E-05_JPRB, 0.50014418E-05_JPRB, 0.49470949E-05_JPRB, &
  & 0.49091979E-05_JPRB, 0.48848571E-05_JPRB, 0.48656500E-05_JPRB, 0.48617911E-05_JPRB, 0.48733274E-05_JPRB, 0.48942182E-05_JPRB, &
  & 0.49186289E-05_JPRB, 0.49436711E-05_JPRB, 0.49882307E-05_JPRB, 0.50469235E-05_JPRB  /)

RGHG7(:,25, 1) = (/ &
  & 0.28511438E-05_JPRB, 0.29415537E-05_JPRB, 0.30126610E-05_JPRB, 0.31168363E-05_JPRB, 0.32477820E-05_JPRB, 0.33924053E-05_JPRB, &
  & 0.35310644E-05_JPRB, 0.36563785E-05_JPRB, 0.37788709E-05_JPRB, 0.39074490E-05_JPRB, 0.40375300E-05_JPRB, 0.41615077E-05_JPRB, &
  & 0.42780125E-05_JPRB, 0.43923633E-05_JPRB, 0.44890464E-05_JPRB, 0.45484453E-05_JPRB, 0.45775222E-05_JPRB, 0.45785270E-05_JPRB, &
  & 0.45625251E-05_JPRB, 0.45295748E-05_JPRB, 0.44878391E-05_JPRB, 0.44536092E-05_JPRB, 0.44458302E-05_JPRB, 0.44712892E-05_JPRB, &
  & 0.45388161E-05_JPRB, 0.46155022E-05_JPRB, 0.46802227E-05_JPRB, 0.47580336E-05_JPRB, 0.48562766E-05_JPRB, 0.49950514E-05_JPRB, &
  & 0.51462496E-05_JPRB, 0.52315218E-05_JPRB, 0.52031302E-05_JPRB, 0.50618007E-05_JPRB, 0.48094605E-05_JPRB, 0.45045788E-05_JPRB, &
  & 0.42601413E-05_JPRB, 0.41181646E-05_JPRB, 0.40578059E-05_JPRB, 0.40705221E-05_JPRB, 0.41902248E-05_JPRB, 0.43738320E-05_JPRB, &
  & 0.45665697E-05_JPRB, 0.47355393E-05_JPRB, 0.48625989E-05_JPRB, 0.49460325E-05_JPRB, 0.49939612E-05_JPRB, 0.50197554E-05_JPRB, &
  & 0.50049594E-05_JPRB, 0.49721957E-05_JPRB, 0.49425512E-05_JPRB, 0.48919563E-05_JPRB, 0.48313967E-05_JPRB, 0.47778005E-05_JPRB, &
  & 0.47415118E-05_JPRB, 0.47199376E-05_JPRB, 0.46994008E-05_JPRB, 0.46935903E-05_JPRB, 0.46962053E-05_JPRB, 0.46990175E-05_JPRB, &
  & 0.47094242E-05_JPRB, 0.47242797E-05_JPRB, 0.47695900E-05_JPRB, 0.48290977E-05_JPRB  /)

RGHG7(:,26, 1) = (/ &
  & 0.27754345E-05_JPRB, 0.28588491E-05_JPRB, 0.29027967E-05_JPRB, 0.29854692E-05_JPRB, 0.30981739E-05_JPRB, 0.32122032E-05_JPRB, &
  & 0.33153804E-05_JPRB, 0.34066361E-05_JPRB, 0.34971360E-05_JPRB, 0.35961718E-05_JPRB, 0.36945403E-05_JPRB, 0.37795485E-05_JPRB, &
  & 0.38477305E-05_JPRB, 0.39044671E-05_JPRB, 0.39461578E-05_JPRB, 0.39580726E-05_JPRB, 0.39472882E-05_JPRB, 0.39219120E-05_JPRB, &
  & 0.38864246E-05_JPRB, 0.38391764E-05_JPRB, 0.37866383E-05_JPRB, 0.37432098E-05_JPRB, 0.37227058E-05_JPRB, 0.37249815E-05_JPRB, &
  & 0.37610108E-05_JPRB, 0.38062950E-05_JPRB, 0.38279797E-05_JPRB, 0.38485311E-05_JPRB, 0.38790701E-05_JPRB, 0.39451491E-05_JPRB, &
  & 0.40387163E-05_JPRB, 0.41042644E-05_JPRB, 0.41037986E-05_JPRB, 0.40188246E-05_JPRB, 0.38405162E-05_JPRB, 0.36152121E-05_JPRB, &
  & 0.34528421E-05_JPRB, 0.33836636E-05_JPRB, 0.33782231E-05_JPRB, 0.34418053E-05_JPRB, 0.36078167E-05_JPRB, 0.38438062E-05_JPRB, &
  & 0.40875514E-05_JPRB, 0.42942005E-05_JPRB, 0.44566274E-05_JPRB, 0.45746140E-05_JPRB, 0.46517490E-05_JPRB, 0.47035959E-05_JPRB, &
  & 0.47198804E-05_JPRB, 0.47127991E-05_JPRB, 0.47029474E-05_JPRB, 0.46718256E-05_JPRB, 0.46213396E-05_JPRB, 0.45720935E-05_JPRB, &
  & 0.45400829E-05_JPRB, 0.45235420E-05_JPRB, 0.45053273E-05_JPRB, 0.44987658E-05_JPRB, 0.44958946E-05_JPRB, 0.44890855E-05_JPRB, &
  & 0.44926188E-05_JPRB, 0.45079298E-05_JPRB, 0.45474462E-05_JPRB, 0.46063903E-05_JPRB  /)

RGHG7(:,27, 1) = (/ &
  & 0.27307725E-05_JPRB, 0.27983794E-05_JPRB, 0.28112317E-05_JPRB, 0.28708127E-05_JPRB, 0.29591855E-05_JPRB, 0.30388379E-05_JPRB, &
  & 0.31026557E-05_JPRB, 0.31600748E-05_JPRB, 0.32209601E-05_JPRB, 0.32939631E-05_JPRB, 0.33631772E-05_JPRB, 0.34104469E-05_JPRB, &
  & 0.34329864E-05_JPRB, 0.34338555E-05_JPRB, 0.34196388E-05_JPRB, 0.33845704E-05_JPRB, 0.33349669E-05_JPRB, 0.32848786E-05_JPRB, &
  & 0.32303418E-05_JPRB, 0.31713278E-05_JPRB, 0.31120464E-05_JPRB, 0.30620146E-05_JPRB, 0.30287443E-05_JPRB, 0.30087691E-05_JPRB, &
  & 0.30105015E-05_JPRB, 0.30197080E-05_JPRB, 0.29941494E-05_JPRB, 0.29504692E-05_JPRB, 0.28981274E-05_JPRB, 0.28708204E-05_JPRB, &
  & 0.28810467E-05_JPRB, 0.29061748E-05_JPRB, 0.29245384E-05_JPRB, 0.29019350E-05_JPRB, 0.28254967E-05_JPRB, 0.27134084E-05_JPRB, &
  & 0.26562902E-05_JPRB, 0.26710130E-05_JPRB, 0.27230608E-05_JPRB, 0.28358871E-05_JPRB, 0.30417382E-05_JPRB, 0.33197283E-05_JPRB, &
  & 0.36013722E-05_JPRB, 0.38363152E-05_JPRB, 0.40278164E-05_JPRB, 0.41754977E-05_JPRB, 0.42800661E-05_JPRB, 0.43554846E-05_JPRB, &
  & 0.44038849E-05_JPRB, 0.44234768E-05_JPRB, 0.44335548E-05_JPRB, 0.44248841E-05_JPRB, 0.43868842E-05_JPRB, 0.43435211E-05_JPRB, &
  & 0.43169732E-05_JPRB, 0.43065353E-05_JPRB, 0.42921024E-05_JPRB, 0.42852007E-05_JPRB, 0.42778674E-05_JPRB, 0.42641348E-05_JPRB, &
  & 0.42631259E-05_JPRB, 0.42828591E-05_JPRB, 0.43138913E-05_JPRB, 0.43717348E-05_JPRB  /)

RGHG7(:,28, 1) = (/ &
  & 0.27264568E-05_JPRB, 0.27390285E-05_JPRB, 0.27372293E-05_JPRB, 0.27906571E-05_JPRB, 0.28604611E-05_JPRB, 0.29094139E-05_JPRB, &
  & 0.29423196E-05_JPRB, 0.29756006E-05_JPRB, 0.30215108E-05_JPRB, 0.30772061E-05_JPRB, 0.31225160E-05_JPRB, 0.31406969E-05_JPRB, &
  & 0.31324923E-05_JPRB, 0.31031449E-05_JPRB, 0.30583117E-05_JPRB, 0.29976755E-05_JPRB, 0.29264603E-05_JPRB, 0.28558462E-05_JPRB, &
  & 0.27850398E-05_JPRB, 0.27162840E-05_JPRB, 0.26492511E-05_JPRB, 0.25896971E-05_JPRB, 0.25409687E-05_JPRB, 0.24960326E-05_JPRB, &
  & 0.24639977E-05_JPRB, 0.24385699E-05_JPRB, 0.23841133E-05_JPRB, 0.23058873E-05_JPRB, 0.22127057E-05_JPRB, 0.21320116E-05_JPRB, &
  & 0.20842989E-05_JPRB, 0.20734103E-05_JPRB, 0.20898084E-05_JPRB, 0.21055287E-05_JPRB, 0.21008217E-05_JPRB, 0.20876362E-05_JPRB, &
  & 0.21147158E-05_JPRB, 0.21854242E-05_JPRB, 0.22820445E-05_JPRB, 0.24284457E-05_JPRB, 0.26472336E-05_JPRB, 0.29153381E-05_JPRB, &
  & 0.31863707E-05_JPRB, 0.34270241E-05_JPRB, 0.36311220E-05_JPRB, 0.37885361E-05_JPRB, 0.39091725E-05_JPRB, 0.40055700E-05_JPRB, &
  & 0.40771112E-05_JPRB, 0.41205761E-05_JPRB, 0.41478547E-05_JPRB, 0.41554544E-05_JPRB, 0.41371014E-05_JPRB, 0.41112830E-05_JPRB, &
  & 0.40978644E-05_JPRB, 0.40990538E-05_JPRB, 0.40919905E-05_JPRB, 0.40835814E-05_JPRB, 0.40775168E-05_JPRB, 0.40678778E-05_JPRB, &
  & 0.40667567E-05_JPRB, 0.40802231E-05_JPRB, 0.40956667E-05_JPRB, 0.41414322E-05_JPRB  /)

RGHG7(:,29, 1) = (/ &
  & 0.27236333E-05_JPRB, 0.26761899E-05_JPRB, 0.26595791E-05_JPRB, 0.27072215E-05_JPRB, 0.27576002E-05_JPRB, 0.27741836E-05_JPRB, &
  & 0.27747017E-05_JPRB, 0.27828269E-05_JPRB, 0.28135044E-05_JPRB, 0.28512391E-05_JPRB, 0.28714482E-05_JPRB, 0.28591821E-05_JPRB, &
  & 0.28190476E-05_JPRB, 0.27587955E-05_JPRB, 0.26826183E-05_JPRB, 0.25958193E-05_JPRB, 0.25024508E-05_JPRB, 0.24102693E-05_JPRB, &
  & 0.23223446E-05_JPRB, 0.22433544E-05_JPRB, 0.21680644E-05_JPRB, 0.20982942E-05_JPRB, 0.20330699E-05_JPRB, 0.19615683E-05_JPRB, &
  & 0.18937769E-05_JPRB, 0.18317139E-05_JPRB, 0.17474328E-05_JPRB, 0.16338898E-05_JPRB, 0.14992579E-05_JPRB, 0.13637299E-05_JPRB, &
  & 0.12557275E-05_JPRB, 0.12068672E-05_JPRB, 0.12202810E-05_JPRB, 0.12755659E-05_JPRB, 0.13455574E-05_JPRB, 0.14365470E-05_JPRB, &
  & 0.15519282E-05_JPRB, 0.16807477E-05_JPRB, 0.18240362E-05_JPRB, 0.20053333E-05_JPRB, 0.22366626E-05_JPRB, 0.24920427E-05_JPRB, &
  & 0.27497284E-05_JPRB, 0.29954533E-05_JPRB, 0.32121840E-05_JPRB, 0.33790452E-05_JPRB, 0.35162141E-05_JPRB, 0.36347283E-05_JPRB, &
  & 0.37304000E-05_JPRB, 0.37990391E-05_JPRB, 0.38444247E-05_JPRB, 0.38689964E-05_JPRB, 0.38717713E-05_JPRB, 0.38650486E-05_JPRB, &
  & 0.38658740E-05_JPRB, 0.38796230E-05_JPRB, 0.38805238E-05_JPRB, 0.38704670E-05_JPRB, 0.38659953E-05_JPRB, 0.38611713E-05_JPRB, &
  & 0.38601235E-05_JPRB, 0.38664862E-05_JPRB, 0.38651044E-05_JPRB, 0.38975962E-05_JPRB  /)

RGHG7(:,30, 1) = (/ &
  & 0.25952185E-05_JPRB, 0.25494259E-05_JPRB, 0.25338955E-05_JPRB, 0.25783803E-05_JPRB, 0.26199599E-05_JPRB, 0.26243870E-05_JPRB, &
  & 0.26148719E-05_JPRB, 0.26107508E-05_JPRB, 0.26295127E-05_JPRB, 0.26494106E-05_JPRB, 0.26511651E-05_JPRB, 0.26220160E-05_JPRB, &
  & 0.25657690E-05_JPRB, 0.24902740E-05_JPRB, 0.24015233E-05_JPRB, 0.23033778E-05_JPRB, 0.21985057E-05_JPRB, 0.20935343E-05_JPRB, &
  & 0.19923091E-05_JPRB, 0.19022119E-05_JPRB, 0.18168461E-05_JPRB, 0.17370949E-05_JPRB, 0.16602433E-05_JPRB, 0.15760117E-05_JPRB, &
  & 0.14948708E-05_JPRB, 0.14201331E-05_JPRB, 0.13347315E-05_JPRB, 0.12322222E-05_JPRB, 0.11132185E-05_JPRB, 0.99160180E-06_JPRB, &
  & 0.89477150E-06_JPRB, 0.85034832E-06_JPRB, 0.86112165E-06_JPRB, 0.91515552E-06_JPRB, 0.99171206E-06_JPRB, 0.10914806E-05_JPRB, &
  & 0.12112839E-05_JPRB, 0.13464283E-05_JPRB, 0.14947770E-05_JPRB, 0.16674525E-05_JPRB, 0.18704214E-05_JPRB, 0.20975471E-05_JPRB, &
  & 0.23450238E-05_JPRB, 0.25884050E-05_JPRB, 0.28053401E-05_JPRB, 0.29858166E-05_JPRB, 0.31404995E-05_JPRB, 0.32769507E-05_JPRB, &
  & 0.33907544E-05_JPRB, 0.34765613E-05_JPRB, 0.35356344E-05_JPRB, 0.35762085E-05_JPRB, 0.35979812E-05_JPRB, 0.36148865E-05_JPRB, &
  & 0.36342209E-05_JPRB, 0.36617810E-05_JPRB, 0.36717280E-05_JPRB, 0.36684892E-05_JPRB, 0.36718355E-05_JPRB, 0.36783067E-05_JPRB, &
  & 0.36894825E-05_JPRB, 0.36924291E-05_JPRB, 0.36739512E-05_JPRB, 0.36837531E-05_JPRB  /)

RGHG7(:,31, 1) = (/ &
  & 0.24597946E-05_JPRB, 0.24157999E-05_JPRB, 0.24014229E-05_JPRB, 0.24425832E-05_JPRB, 0.24749016E-05_JPRB, 0.24665395E-05_JPRB, &
  & 0.24464741E-05_JPRB, 0.24294620E-05_JPRB, 0.24356721E-05_JPRB, 0.24367762E-05_JPRB, 0.24190924E-05_JPRB, 0.23721672E-05_JPRB, &
  & 0.22989583E-05_JPRB, 0.22074174E-05_JPRB, 0.21054364E-05_JPRB, 0.19953498E-05_JPRB, 0.18783669E-05_JPRB, 0.17599278E-05_JPRB, &
  & 0.16446920E-05_JPRB, 0.15428911E-05_JPRB, 0.14469072E-05_JPRB, 0.13566396E-05_JPRB, 0.12675416E-05_JPRB, 0.11699100E-05_JPRB, &
  & 0.10747247E-05_JPRB, 0.98665498E-06_JPRB, 0.90009990E-06_JPRB, 0.80926045E-06_JPRB, 0.70677757E-06_JPRB, 0.59988381E-06_JPRB, &
  & 0.51489290E-06_JPRB, 0.47518513E-06_JPRB, 0.48317670E-06_JPRB, 0.53585362E-06_JPRB, 0.61926277E-06_JPRB, 0.72819072E-06_JPRB, &
  & 0.85257374E-06_JPRB, 0.99433327E-06_JPRB, 0.11479740E-05_JPRB, 0.13115240E-05_JPRB, 0.14845722E-05_JPRB, 0.16819129E-05_JPRB, &
  & 0.19186357E-05_JPRB, 0.21595405E-05_JPRB, 0.23766791E-05_JPRB, 0.25715054E-05_JPRB, 0.27446428E-05_JPRB, 0.28999896E-05_JPRB, &
  & 0.30328923E-05_JPRB, 0.31367806E-05_JPRB, 0.32102713E-05_JPRB, 0.32677055E-05_JPRB, 0.33094932E-05_JPRB, 0.33512985E-05_JPRB, &
  & 0.33901391E-05_JPRB, 0.34322525E-05_JPRB, 0.34517321E-05_JPRB, 0.34556852E-05_JPRB, 0.34672750E-05_JPRB, 0.34856533E-05_JPRB, &
  & 0.35097202E-05_JPRB, 0.35090708E-05_JPRB, 0.34725795E-05_JPRB, 0.34584651E-05_JPRB  /)

RGHG7(:,32, 1) = (/ &
  & 0.23074112E-05_JPRB, 0.22752763E-05_JPRB, 0.22633755E-05_JPRB, 0.22982962E-05_JPRB, 0.23196758E-05_JPRB, 0.23048723E-05_JPRB, &
  & 0.22808254E-05_JPRB, 0.22569782E-05_JPRB, 0.22494819E-05_JPRB, 0.22354507E-05_JPRB, 0.22048269E-05_JPRB, 0.21478492E-05_JPRB, &
  & 0.20676547E-05_JPRB, 0.19692842E-05_JPRB, 0.18598298E-05_JPRB, 0.17421668E-05_JPRB, 0.16179437E-05_JPRB, 0.14930699E-05_JPRB, &
  & 0.13746435E-05_JPRB, 0.12681053E-05_JPRB, 0.11676681E-05_JPRB, 0.10763447E-05_JPRB, 0.98913969E-06_JPRB, 0.89870765E-06_JPRB, &
  & 0.81152433E-06_JPRB, 0.73205434E-06_JPRB, 0.65837012E-06_JPRB, 0.58695600E-06_JPRB, 0.51112634E-06_JPRB, 0.43669440E-06_JPRB, &
  & 0.37884849E-06_JPRB, 0.35154209E-06_JPRB, 0.35949859E-06_JPRB, 0.40077426E-06_JPRB, 0.46588152E-06_JPRB, 0.55067343E-06_JPRB, &
  & 0.64757303E-06_JPRB, 0.75846996E-06_JPRB, 0.87503917E-06_JPRB, 0.10028697E-05_JPRB, 0.11467971E-05_JPRB, 0.13230880E-05_JPRB, &
  & 0.15491436E-05_JPRB, 0.17844217E-05_JPRB, 0.20074267E-05_JPRB, 0.22155305E-05_JPRB, 0.24010074E-05_JPRB, 0.25683604E-05_JPRB, &
  & 0.27158313E-05_JPRB, 0.28354860E-05_JPRB, 0.29180836E-05_JPRB, 0.29841306E-05_JPRB, 0.30393865E-05_JPRB, 0.30973313E-05_JPRB, &
  & 0.31534068E-05_JPRB, 0.32029217E-05_JPRB, 0.32327694E-05_JPRB, 0.32504086E-05_JPRB, 0.32723329E-05_JPRB, 0.32990758E-05_JPRB, &
  & 0.33308516E-05_JPRB, 0.33345282E-05_JPRB, 0.32992363E-05_JPRB, 0.32734608E-05_JPRB  /)

RGHG7(:,33, 1) = (/ &
  & 0.21468514E-05_JPRB, 0.21283444E-05_JPRB, 0.21191884E-05_JPRB, 0.21472472E-05_JPRB, 0.21570415E-05_JPRB, 0.21363655E-05_JPRB, &
  & 0.21090314E-05_JPRB, 0.20788649E-05_JPRB, 0.20569747E-05_JPRB, 0.20276880E-05_JPRB, 0.19844575E-05_JPRB, 0.19180329E-05_JPRB, &
  & 0.18318703E-05_JPRB, 0.17275954E-05_JPRB, 0.16111196E-05_JPRB, 0.14861479E-05_JPRB, 0.13550311E-05_JPRB, 0.12243806E-05_JPRB, &
  & 0.11040393E-05_JPRB, 0.99347974E-06_JPRB, 0.88921269E-06_JPRB, 0.79801699E-06_JPRB, 0.71460988E-06_JPRB, 0.63432694E-06_JPRB, &
  & 0.55831403E-06_JPRB, 0.49062083E-06_JPRB, 0.43212836E-06_JPRB, 0.38190609E-06_JPRB, 0.33508756E-06_JPRB, 0.29668815E-06_JPRB, &
  & 0.26903424E-06_JPRB, 0.25561107E-06_JPRB, 0.26388671E-06_JPRB, 0.29201323E-06_JPRB, 0.33484351E-06_JPRB, 0.39024130E-06_JPRB, &
  & 0.45442758E-06_JPRB, 0.52839835E-06_JPRB, 0.60095617E-06_JPRB, 0.68822219E-06_JPRB, 0.80198953E-06_JPRB, 0.95753532E-06_JPRB, &
  & 0.11725163E-05_JPRB, 0.14015389E-05_JPRB, 0.16313739E-05_JPRB, 0.18531375E-05_JPRB, 0.20506465E-05_JPRB, 0.22295848E-05_JPRB, &
  & 0.23916092E-05_JPRB, 0.25273492E-05_JPRB, 0.26187235E-05_JPRB, 0.26926537E-05_JPRB, 0.27610588E-05_JPRB, 0.28346421E-05_JPRB, &
  & 0.29083349E-05_JPRB, 0.29646159E-05_JPRB, 0.30053468E-05_JPRB, 0.30380500E-05_JPRB, 0.30709851E-05_JPRB, 0.31059623E-05_JPRB, &
  & 0.31450786E-05_JPRB, 0.31542766E-05_JPRB, 0.31227188E-05_JPRB, 0.30864112E-05_JPRB  /)

RGHG7(:,34, 1) = (/ &
  & 0.19847976E-05_JPRB, 0.19707509E-05_JPRB, 0.19631621E-05_JPRB, 0.19826146E-05_JPRB, 0.19839018E-05_JPRB, 0.19595989E-05_JPRB, &
  & 0.19289606E-05_JPRB, 0.18952491E-05_JPRB, 0.18651080E-05_JPRB, 0.18284172E-05_JPRB, 0.17786838E-05_JPRB, 0.17086720E-05_JPRB, &
  & 0.16211949E-05_JPRB, 0.15146660E-05_JPRB, 0.13953145E-05_JPRB, 0.12676598E-05_JPRB, 0.11344207E-05_JPRB, 0.10044410E-05_JPRB, &
  & 0.88893849E-06_JPRB, 0.78272774E-06_JPRB, 0.68450655E-06_JPRB, 0.60115468E-06_JPRB, 0.52731294E-06_JPRB, 0.46007416E-06_JPRB, &
  & 0.39902106E-06_JPRB, 0.34620134E-06_JPRB, 0.30206681E-06_JPRB, 0.26652839E-06_JPRB, 0.23657428E-06_JPRB, 0.21555150E-06_JPRB, &
  & 0.20146587E-06_JPRB, 0.19468245E-06_JPRB, 0.20196909E-06_JPRB, 0.22079876E-06_JPRB, 0.24752709E-06_JPRB, 0.28174407E-06_JPRB, &
  & 0.32258763E-06_JPRB, 0.37064098E-06_JPRB, 0.41790081E-06_JPRB, 0.48057445E-06_JPRB, 0.57158013E-06_JPRB, 0.70502009E-06_JPRB, &
  & 0.89548476E-06_JPRB, 0.11068221E-05_JPRB, 0.13308030E-05_JPRB, 0.15557694E-05_JPRB, 0.17605124E-05_JPRB, 0.19475928E-05_JPRB, &
  & 0.21170181E-05_JPRB, 0.22599965E-05_JPRB, 0.23598653E-05_JPRB, 0.24384953E-05_JPRB, 0.25135071E-05_JPRB, 0.25909711E-05_JPRB, &
  & 0.26724125E-05_JPRB, 0.27355001E-05_JPRB, 0.27855227E-05_JPRB, 0.28279298E-05_JPRB, 0.28655492E-05_JPRB, 0.29048049E-05_JPRB, &
  & 0.29476526E-05_JPRB, 0.29581892E-05_JPRB, 0.29297001E-05_JPRB, 0.28951318E-05_JPRB  /)

RGHG7(:,35, 1) = (/ &
  & 0.18174187E-05_JPRB, 0.18032536E-05_JPRB, 0.17966716E-05_JPRB, 0.18063806E-05_JPRB, 0.18005008E-05_JPRB, 0.17736214E-05_JPRB, &
  & 0.17395772E-05_JPRB, 0.17036446E-05_JPRB, 0.16681727E-05_JPRB, 0.16278984E-05_JPRB, 0.15746111E-05_JPRB, 0.15039182E-05_JPRB, &
  & 0.14174776E-05_JPRB, 0.13105045E-05_JPRB, 0.11903237E-05_JPRB, 0.10622840E-05_JPRB, 0.92931151E-06_JPRB, 0.80332989E-06_JPRB, &
  & 0.69626783E-06_JPRB, 0.59882330E-06_JPRB, 0.51188566E-06_JPRB, 0.44055772E-06_JPRB, 0.37950993E-06_JPRB, 0.32716781E-06_JPRB, &
  & 0.28343985E-06_JPRB, 0.24750103E-06_JPRB, 0.21770045E-06_JPRB, 0.19391944E-06_JPRB, 0.17507117E-06_JPRB, 0.16234077E-06_JPRB, &
  & 0.15367479E-06_JPRB, 0.15000102E-06_JPRB, 0.15559957E-06_JPRB, 0.16684764E-06_JPRB, 0.18018971E-06_JPRB, 0.19684463E-06_JPRB, &
  & 0.21849727E-06_JPRB, 0.24555315E-06_JPRB, 0.27640593E-06_JPRB, 0.32199136E-06_JPRB, 0.39339150E-06_JPRB, 0.50340551E-06_JPRB, &
  & 0.66176685E-06_JPRB, 0.84905636E-06_JPRB, 0.10605099E-05_JPRB, 0.12834031E-05_JPRB, 0.14931216E-05_JPRB, 0.16868062E-05_JPRB, &
  & 0.18601704E-05_JPRB, 0.20060512E-05_JPRB, 0.21145085E-05_JPRB, 0.21963369E-05_JPRB, 0.22747841E-05_JPRB, 0.23502047E-05_JPRB, &
  & 0.24345484E-05_JPRB, 0.25046549E-05_JPRB, 0.25634142E-05_JPRB, 0.26130474E-05_JPRB, 0.26522364E-05_JPRB, 0.26938614E-05_JPRB, &
  & 0.27386934E-05_JPRB, 0.27484599E-05_JPRB, 0.27227843E-05_JPRB, 0.26963010E-05_JPRB  /)

RGHG7(:,36, 1) = (/ &
  & 0.16506955E-05_JPRB, 0.16349991E-05_JPRB, 0.16275788E-05_JPRB, 0.16286717E-05_JPRB, 0.16169268E-05_JPRB, 0.15883246E-05_JPRB, &
  & 0.15520960E-05_JPRB, 0.15150609E-05_JPRB, 0.14761484E-05_JPRB, 0.14340291E-05_JPRB, 0.13794763E-05_JPRB, 0.13099502E-05_JPRB, &
  & 0.12257559E-05_JPRB, 0.11200162E-05_JPRB, 0.10008761E-05_JPRB, 0.87466189E-06_JPRB, 0.74487443E-06_JPRB, 0.62542857E-06_JPRB, &
  & 0.52788157E-06_JPRB, 0.44036948E-06_JPRB, 0.36575172E-06_JPRB, 0.30688407E-06_JPRB, 0.25834373E-06_JPRB, 0.21942589E-06_JPRB, &
  & 0.19021949E-06_JPRB, 0.16797071E-06_JPRB, 0.14982832E-06_JPRB, 0.13538604E-06_JPRB, 0.12494018E-06_JPRB, 0.11825999E-06_JPRB, &
  & 0.11345732E-06_JPRB, 0.11192701E-06_JPRB, 0.11583243E-06_JPRB, 0.12118353E-06_JPRB, 0.12479674E-06_JPRB, 0.12881843E-06_JPRB, &
  & 0.13638140E-06_JPRB, 0.14776504E-06_JPRB, 0.16571683E-06_JPRB, 0.19683039E-06_JPRB, 0.25012292E-06_JPRB, 0.33757460E-06_JPRB, &
  & 0.46557339E-06_JPRB, 0.62808620E-06_JPRB, 0.82335811E-06_JPRB, 0.10395669E-05_JPRB, 0.12501000E-05_JPRB, 0.14471218E-05_JPRB, &
  & 0.16221263E-05_JPRB, 0.17688356E-05_JPRB, 0.18836083E-05_JPRB, 0.19673555E-05_JPRB, 0.20470561E-05_JPRB, 0.21189191E-05_JPRB, &
  & 0.22034227E-05_JPRB, 0.22775204E-05_JPRB, 0.23436099E-05_JPRB, 0.23980713E-05_JPRB, 0.24375280E-05_JPRB, 0.24800517E-05_JPRB, &
  & 0.25249716E-05_JPRB, 0.25333074E-05_JPRB, 0.25082871E-05_JPRB, 0.24875800E-05_JPRB  /)

RGHG7(:,37, 1) = (/ &
  & 0.14958482E-05_JPRB, 0.14754768E-05_JPRB, 0.14630397E-05_JPRB, 0.14586375E-05_JPRB, 0.14443773E-05_JPRB, 0.14161168E-05_JPRB, &
  & 0.13806401E-05_JPRB, 0.13451360E-05_JPRB, 0.13073308E-05_JPRB, 0.12674669E-05_JPRB, 0.12169740E-05_JPRB, 0.11527791E-05_JPRB, &
  & 0.10734649E-05_JPRB, 0.97272832E-06_JPRB, 0.85885100E-06_JPRB, 0.73941698E-06_JPRB, 0.61930766E-06_JPRB, 0.51180911E-06_JPRB, &
  & 0.42564896E-06_JPRB, 0.35012519E-06_JPRB, 0.28943685E-06_JPRB, 0.24325466E-06_JPRB, 0.20578677E-06_JPRB, 0.17608231E-06_JPRB, &
  & 0.15406616E-06_JPRB, 0.13733994E-06_JPRB, 0.12399561E-06_JPRB, 0.11276570E-06_JPRB, 0.10400122E-06_JPRB, 0.97854142E-07_JPRB, &
  & 0.93106152E-07_JPRB, 0.91370802E-07_JPRB, 0.93676869E-07_JPRB, 0.97360265E-07_JPRB, 0.10023531E-06_JPRB, 0.10371022E-06_JPRB, &
  & 0.10975585E-06_JPRB, 0.11865160E-06_JPRB, 0.13254350E-06_JPRB, 0.15608404E-06_JPRB, 0.19582992E-06_JPRB, 0.26410301E-06_JPRB, &
  & 0.36761939E-06_JPRB, 0.50522603E-06_JPRB, 0.67694506E-06_JPRB, 0.87631283E-06_JPRB, 0.10780699E-05_JPRB, 0.12707312E-05_JPRB, &
  & 0.14420038E-05_JPRB, 0.15847352E-05_JPRB, 0.17002187E-05_JPRB, 0.17828314E-05_JPRB, 0.18587044E-05_JPRB, 0.19237600E-05_JPRB, &
  & 0.20021258E-05_JPRB, 0.20730248E-05_JPRB, 0.21427642E-05_JPRB, 0.21962550E-05_JPRB, 0.22329777E-05_JPRB, 0.22729725E-05_JPRB, &
  & 0.23136276E-05_JPRB, 0.23191063E-05_JPRB, 0.22897528E-05_JPRB, 0.22691687E-05_JPRB  /)

RGHG7(:,38, 1) = (/ &
  & 0.13240314E-05_JPRB, 0.12984727E-05_JPRB, 0.12804691E-05_JPRB, 0.12699693E-05_JPRB, 0.12529184E-05_JPRB, 0.12250371E-05_JPRB, &
  & 0.11903946E-05_JPRB, 0.11565893E-05_JPRB, 0.11200126E-05_JPRB, 0.10826514E-05_JPRB, 0.10366633E-05_JPRB, 0.97838386E-06_JPRB, &
  & 0.90448448E-06_JPRB, 0.80929931E-06_JPRB, 0.70126156E-06_JPRB, 0.58935075E-06_JPRB, 0.47998018E-06_JPRB, 0.38573823E-06_JPRB, &
  & 0.31221280E-06_JPRB, 0.24999114E-06_JPRB, 0.20475871E-06_JPRB, 0.17265219E-06_JPRB, 0.14747016E-06_JPRB, 0.12798875E-06_JPRB, &
  & 0.11395084E-06_JPRB, 0.10335238E-06_JPRB, 0.95331926E-07_JPRB, 0.87666436E-07_JPRB, 0.80767582E-07_JPRB, 0.75212046E-07_JPRB, &
  & 0.70524727E-07_JPRB, 0.68561861E-07_JPRB, 0.69093304E-07_JPRB, 0.70926236E-07_JPRB, 0.72982223E-07_JPRB, 0.75850420E-07_JPRB, &
  & 0.80212435E-07_JPRB, 0.86347662E-07_JPRB, 0.95734740E-07_JPRB, 0.11087236E-06_JPRB, 0.13558701E-06_JPRB, 0.18257977E-06_JPRB, &
  & 0.25893073E-06_JPRB, 0.36890176E-06_JPRB, 0.51448679E-06_JPRB, 0.69516790E-06_JPRB, 0.88718729E-06_JPRB, 0.10750100E-05_JPRB, &
  & 0.12421419E-05_JPRB, 0.13804595E-05_JPRB, 0.14967317E-05_JPRB, 0.15780855E-05_JPRB, 0.16497115E-05_JPRB, 0.17072135E-05_JPRB, &
  & 0.17787691E-05_JPRB, 0.18461189E-05_JPRB, 0.19199080E-05_JPRB, 0.19723219E-05_JPRB, 0.20060111E-05_JPRB, 0.20431999E-05_JPRB, &
  & 0.20791225E-05_JPRB, 0.20814312E-05_JPRB, 0.20472695E-05_JPRB, 0.20268219E-05_JPRB  /)

RGHG7(:,39, 1) = (/ &
  & 0.11951933E-05_JPRB, 0.11664689E-05_JPRB, 0.11450023E-05_JPRB, 0.11329274E-05_JPRB, 0.11155023E-05_JPRB, 0.10896965E-05_JPRB, &
  & 0.10585708E-05_JPRB, 0.10272316E-05_JPRB, 0.99382713E-06_JPRB, 0.96005588E-06_JPRB, 0.91847003E-06_JPRB, 0.86593265E-06_JPRB, &
  & 0.79842325E-06_JPRB, 0.71091026E-06_JPRB, 0.61062359E-06_JPRB, 0.50753168E-06_JPRB, 0.40905350E-06_JPRB, 0.32591381E-06_JPRB, &
  & 0.26244360E-06_JPRB, 0.20998790E-06_JPRB, 0.17342126E-06_JPRB, 0.14755339E-06_JPRB, 0.12718008E-06_JPRB, 0.11151317E-06_JPRB, &
  & 0.10024052E-06_JPRB, 0.91537284E-07_JPRB, 0.84680939E-07_JPRB, 0.77680647E-07_JPRB, 0.71173691E-07_JPRB, 0.65745076E-07_JPRB, &
  & 0.61490650E-07_JPRB, 0.59739956E-07_JPRB, 0.60021549E-07_JPRB, 0.61617171E-07_JPRB, 0.63878414E-07_JPRB, 0.66825115E-07_JPRB, &
  & 0.70806590E-07_JPRB, 0.76178604E-07_JPRB, 0.84065402E-07_JPRB, 0.96483970E-07_JPRB, 0.11616310E-06_JPRB, 0.15394112E-06_JPRB, &
  & 0.21651717E-06_JPRB, 0.31061569E-06_JPRB, 0.43955189E-06_JPRB, 0.60398260E-06_JPRB, 0.78242834E-06_JPRB, 0.95825870E-06_JPRB, &
  & 0.11165273E-05_JPRB, 0.12477373E-05_JPRB, 0.13587604E-05_JPRB, 0.14363709E-05_JPRB, 0.15046300E-05_JPRB, 0.15542913E-05_JPRB, &
  & 0.16174315E-05_JPRB, 0.16818596E-05_JPRB, 0.17538205E-05_JPRB, 0.18015534E-05_JPRB, 0.18319041E-05_JPRB, 0.18647021E-05_JPRB, &
  & 0.18930419E-05_JPRB, 0.18910572E-05_JPRB, 0.18570818E-05_JPRB, 0.18355491E-05_JPRB  /)

RGHG7(:,40, 1) = (/ &
  & 0.10510223E-05_JPRB, 0.10189135E-05_JPRB, 0.99372694E-06_JPRB, 0.98054341E-06_JPRB, 0.96307447E-06_JPRB, 0.93998210E-06_JPRB, &
  & 0.91342238E-06_JPRB, 0.88510290E-06_JPRB, 0.85573934E-06_JPRB, 0.82635909E-06_JPRB, 0.78992280E-06_JPRB, 0.74409590E-06_JPRB, &
  & 0.68424520E-06_JPRB, 0.60608312E-06_JPRB, 0.51520570E-06_JPRB, 0.42267551E-06_JPRB, 0.33700559E-06_JPRB, 0.26654287E-06_JPRB, &
  & 0.21445131E-06_JPRB, 0.17287825E-06_JPRB, 0.14537076E-06_JPRB, 0.12554232E-06_JPRB, 0.10958918E-06_JPRB, 0.97350444E-07_JPRB, &
  & 0.88470232E-07_JPRB, 0.81298730E-07_JPRB, 0.75128022E-07_JPRB, 0.68434077E-07_JPRB, 0.62145941E-07_JPRB, 0.56790267E-07_JPRB, &
  & 0.53104772E-07_JPRB, 0.51675015E-07_JPRB, 0.51912844E-07_JPRB, 0.53493878E-07_JPRB, 0.56163585E-07_JPRB, 0.59314517E-07_JPRB, &
  & 0.63062585E-07_JPRB, 0.67865666E-07_JPRB, 0.74483309E-07_JPRB, 0.84640737E-07_JPRB, 0.10004559E-06_JPRB, 0.12898328E-06_JPRB, &
  & 0.17758402E-06_JPRB, 0.25497928E-06_JPRB, 0.36592847E-06_JPRB, 0.51168654E-06_JPRB, 0.67357491E-06_JPRB, 0.83416081E-06_JPRB, &
  & 0.98125499E-06_JPRB, 0.11036830E-05_JPRB, 0.12075580E-05_JPRB, 0.12803691E-05_JPRB, 0.13448207E-05_JPRB, 0.13852331E-05_JPRB, &
  & 0.14382347E-05_JPRB, 0.14993368E-05_JPRB, 0.15681905E-05_JPRB, 0.16098401E-05_JPRB, 0.16362229E-05_JPRB, 0.16636088E-05_JPRB, &
  & 0.16825831E-05_JPRB, 0.16753758E-05_JPRB, 0.16424362E-05_JPRB, 0.16194301E-05_JPRB  /)

RGHG7(:,41, 1) = (/ &
  & 0.87475241E-06_JPRB, 0.83850561E-06_JPRB, 0.80877093E-06_JPRB, 0.79423187E-06_JPRB, 0.77670942E-06_JPRB, 0.75693453E-06_JPRB, &
  & 0.73595746E-06_JPRB, 0.71133002E-06_JPRB, 0.68690702E-06_JPRB, 0.66289538E-06_JPRB, 0.63275518E-06_JPRB, 0.59513282E-06_JPRB, &
  & 0.54464598E-06_JPRB, 0.47791675E-06_JPRB, 0.39854352E-06_JPRB, 0.31892654E-06_JPRB, 0.24891658E-06_JPRB, 0.19395330E-06_JPRB, &
  & 0.15577377E-06_JPRB, 0.12750633E-06_JPRB, 0.11107496E-06_JPRB, 0.98630596E-07_JPRB, 0.88081746E-07_JPRB, 0.80034460E-07_JPRB, &
  & 0.74079342E-07_JPRB, 0.68780615E-07_JPRB, 0.63448196E-07_JPRB, 0.57128806E-07_JPRB, 0.51108209E-07_JPRB, 0.45841715E-07_JPRB, &
  & 0.42851822E-07_JPRB, 0.41814455E-07_JPRB, 0.41998776E-07_JPRB, 0.43561975E-07_JPRB, 0.46731088E-07_JPRB, 0.50131724E-07_JPRB, &
  & 0.53594416E-07_JPRB, 0.57701896E-07_JPRB, 0.62767811E-07_JPRB, 0.70160668E-07_JPRB, 0.80339586E-07_JPRB, 0.98468695E-07_JPRB, &
  & 0.12998261E-06_JPRB, 0.18695571E-06_JPRB, 0.27591318E-06_JPRB, 0.39884125E-06_JPRB, 0.54048581E-06_JPRB, 0.68243315E-06_JPRB, &
  & 0.81586501E-06_JPRB, 0.92755583E-06_JPRB, 0.10226912E-05_JPRB, 0.10896342E-05_JPRB, 0.11494307E-05_JPRB, 0.11785351E-05_JPRB, &
  & 0.12191407E-05_JPRB, 0.12761762E-05_JPRB, 0.13412308E-05_JPRB, 0.13754429E-05_JPRB, 0.13969743E-05_JPRB, 0.14177430E-05_JPRB, &
  & 0.14252667E-05_JPRB, 0.14116741E-05_JPRB, 0.13800008E-05_JPRB, 0.13551933E-05_JPRB  /)

RGHG7(:,42, 1) = (/ &
  & 0.80969988E-06_JPRB, 0.77936660E-06_JPRB, 0.75231609E-06_JPRB, 0.74074936E-06_JPRB, 0.72620245E-06_JPRB, 0.70825735E-06_JPRB, &
  & 0.68921842E-06_JPRB, 0.66713120E-06_JPRB, 0.64441876E-06_JPRB, 0.62291860E-06_JPRB, 0.59657845E-06_JPRB, 0.56339905E-06_JPRB, &
  & 0.51760885E-06_JPRB, 0.45641344E-06_JPRB, 0.38425659E-06_JPRB, 0.31116278E-06_JPRB, 0.24625568E-06_JPRB, 0.19474509E-06_JPRB, &
  & 0.15802846E-06_JPRB, 0.13058421E-06_JPRB, 0.11301898E-06_JPRB, 0.99571244E-07_JPRB, 0.88229282E-07_JPRB, 0.79546099E-07_JPRB, &
  & 0.72800068E-07_JPRB, 0.67225832E-07_JPRB, 0.61546406E-07_JPRB, 0.55590357E-07_JPRB, 0.50205311E-07_JPRB, 0.45716304E-07_JPRB, &
  & 0.43198716E-07_JPRB, 0.42304168E-07_JPRB, 0.42523357E-07_JPRB, 0.43825000E-07_JPRB, 0.46565836E-07_JPRB, 0.49906597E-07_JPRB, &
  & 0.53590605E-07_JPRB, 0.57968179E-07_JPRB, 0.63302868E-07_JPRB, 0.70504652E-07_JPRB, 0.81392594E-07_JPRB, 0.10089581E-06_JPRB, &
  & 0.13388020E-06_JPRB, 0.18966359E-06_JPRB, 0.27508602E-06_JPRB, 0.39136474E-06_JPRB, 0.52275921E-06_JPRB, 0.65275480E-06_JPRB, &
  & 0.77447277E-06_JPRB, 0.87557746E-06_JPRB, 0.95866428E-06_JPRB, 0.10183658E-05_JPRB, 0.10707444E-05_JPRB, 0.10973222E-05_JPRB, &
  & 0.11346895E-05_JPRB, 0.11904605E-05_JPRB, 0.12489374E-05_JPRB, 0.12741508E-05_JPRB, 0.12902080E-05_JPRB, 0.13061999E-05_JPRB, &
  & 0.13110424E-05_JPRB, 0.12989948E-05_JPRB, 0.12729914E-05_JPRB, 0.12526873E-05_JPRB  /)

RGHG7(:,43, 1) = (/ &
  & 0.67452393E-06_JPRB, 0.64780617E-06_JPRB, 0.62124829E-06_JPRB, 0.61181040E-06_JPRB, 0.59995533E-06_JPRB, 0.58510672E-06_JPRB, &
  & 0.57023751E-06_JPRB, 0.55205610E-06_JPRB, 0.53302955E-06_JPRB, 0.51613015E-06_JPRB, 0.49596541E-06_JPRB, 0.47036890E-06_JPRB, &
  & 0.43289174E-06_JPRB, 0.38166318E-06_JPRB, 0.32103903E-06_JPRB, 0.25945152E-06_JPRB, 0.20593637E-06_JPRB, 0.16424309E-06_JPRB, &
  & 0.13484544E-06_JPRB, 0.11387570E-06_JPRB, 0.10004034E-06_JPRB, 0.88853394E-07_JPRB, 0.79112462E-07_JPRB, 0.71652043E-07_JPRB, &
  & 0.65442621E-07_JPRB, 0.60422588E-07_JPRB, 0.54787146E-07_JPRB, 0.49323723E-07_JPRB, 0.44633629E-07_JPRB, 0.40892356E-07_JPRB, &
  & 0.39104908E-07_JPRB, 0.38509453E-07_JPRB, 0.38737439E-07_JPRB, 0.39792770E-07_JPRB, 0.42357668E-07_JPRB, 0.45751211E-07_JPRB, &
  & 0.49514390E-07_JPRB, 0.53839184E-07_JPRB, 0.58751623E-07_JPRB, 0.64589892E-07_JPRB, 0.73876804E-07_JPRB, 0.89984431E-07_JPRB, &
  & 0.11696056E-06_JPRB, 0.16287386E-06_JPRB, 0.23561121E-06_JPRB, 0.33600278E-06_JPRB, 0.44933729E-06_JPRB, 0.56041081E-06_JPRB, &
  & 0.66556427E-06_JPRB, 0.75239164E-06_JPRB, 0.82072612E-06_JPRB, 0.87129653E-06_JPRB, 0.91490459E-06_JPRB, 0.93431293E-06_JPRB, &
  & 0.96339365E-06_JPRB, 0.10162617E-05_JPRB, 0.10671028E-05_JPRB, 0.10809068E-05_JPRB, 0.10898824E-05_JPRB, 0.10986698E-05_JPRB, &
  & 0.10961405E-05_JPRB, 0.10827557E-05_JPRB, 0.10624703E-05_JPRB, 0.10455002E-05_JPRB  /)

RGHG7(:,44, 1) = (/ &
  & 0.61256215E-06_JPRB, 0.58889106E-06_JPRB, 0.56558997E-06_JPRB, 0.55764357E-06_JPRB, 0.54750548E-06_JPRB, 0.53385913E-06_JPRB, &
  & 0.52036861E-06_JPRB, 0.50411047E-06_JPRB, 0.48683457E-06_JPRB, 0.47250878E-06_JPRB, 0.45572803E-06_JPRB, 0.43334417E-06_JPRB, &
  & 0.40011257E-06_JPRB, 0.35350680E-06_JPRB, 0.29812735E-06_JPRB, 0.24160561E-06_JPRB, 0.19210046E-06_JPRB, 0.15361439E-06_JPRB, &
  & 0.12672364E-06_JPRB, 0.10780133E-06_JPRB, 0.94779678E-07_JPRB, 0.83917777E-07_JPRB, 0.74635718E-07_JPRB, 0.67585213E-07_JPRB, &
  & 0.61558734E-07_JPRB, 0.56954600E-07_JPRB, 0.51731051E-07_JPRB, 0.46629738E-07_JPRB, 0.42544524E-07_JPRB, 0.39387118E-07_JPRB, &
  & 0.37799027E-07_JPRB, 0.37390137E-07_JPRB, 0.37632303E-07_JPRB, 0.38586144E-07_JPRB, 0.40867457E-07_JPRB, 0.43898991E-07_JPRB, &
  & 0.47509409E-07_JPRB, 0.51756704E-07_JPRB, 0.56715997E-07_JPRB, 0.62523701E-07_JPRB, 0.71291118E-07_JPRB, 0.86252410E-07_JPRB, &
  & 0.11165223E-06_JPRB, 0.15443996E-06_JPRB, 0.22112842E-06_JPRB, 0.31277260E-06_JPRB, 0.41461520E-06_JPRB, 0.51439856E-06_JPRB, &
  & 0.60696970E-06_JPRB, 0.68336309E-06_JPRB, 0.74069492E-06_JPRB, 0.78309437E-06_JPRB, 0.81915829E-06_JPRB, 0.83686910E-06_JPRB, &
  & 0.86486882E-06_JPRB, 0.91314105E-06_JPRB, 0.95534218E-06_JPRB, 0.96422116E-06_JPRB, 0.96989820E-06_JPRB, 0.97577951E-06_JPRB, &
  & 0.97207527E-06_JPRB, 0.95821748E-06_JPRB, 0.93841914E-06_JPRB, 0.92323872E-06_JPRB  /)

RGHG7(:,45, 1) = (/ &
  & 0.52494741E-06_JPRB, 0.50520144E-06_JPRB, 0.48567021E-06_JPRB, 0.47969069E-06_JPRB, 0.47184728E-06_JPRB, 0.45996077E-06_JPRB, &
  & 0.44856653E-06_JPRB, 0.43499128E-06_JPRB, 0.42017398E-06_JPRB, 0.40935924E-06_JPRB, 0.39721100E-06_JPRB, 0.37944241E-06_JPRB, &
  & 0.35209419E-06_JPRB, 0.31201017E-06_JPRB, 0.26405828E-06_JPRB, 0.21475705E-06_JPRB, 0.17125605E-06_JPRB, 0.13766129E-06_JPRB, &
  & 0.11454902E-06_JPRB, 0.98775436E-07_JPRB, 0.87151306E-07_JPRB, 0.76945032E-07_JPRB, 0.68387612E-07_JPRB, 0.61958226E-07_JPRB, &
  & 0.56207800E-07_JPRB, 0.52147146E-07_JPRB, 0.47398063E-07_JPRB, 0.42771216E-07_JPRB, 0.39462401E-07_JPRB, 0.37064141E-07_JPRB, &
  & 0.35795236E-07_JPRB, 0.35636520E-07_JPRB, 0.35895938E-07_JPRB, 0.36703127E-07_JPRB, 0.38639373E-07_JPRB, 0.41265454E-07_JPRB, &
  & 0.44711965E-07_JPRB, 0.48864367E-07_JPRB, 0.53823660E-07_JPRB, 0.59424324E-07_JPRB, 0.67398089E-07_JPRB, 0.80625423E-07_JPRB, &
  & 0.10347175E-06_JPRB, 0.14145443E-06_JPRB, 0.19965427E-06_JPRB, 0.27933327E-06_JPRB, 0.36581179E-06_JPRB, 0.45035185E-06_JPRB, &
  & 0.52650646E-06_JPRB, 0.58921797E-06_JPRB, 0.63216053E-06_JPRB, 0.66410448E-06_JPRB, 0.69047203E-06_JPRB, 0.70534468E-06_JPRB, &
  & 0.73106695E-06_JPRB, 0.77374049E-06_JPRB, 0.80514104E-06_JPRB, 0.80697204E-06_JPRB, 0.80799932E-06_JPRB, 0.80966219E-06_JPRB, &
  & 0.80368913E-06_JPRB, 0.78912395E-06_JPRB, 0.77060237E-06_JPRB, 0.75788054E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART2',0,ZHOOK_HANDLE)



RGHG7(:,46, 1) = (/ &
  & 0.47367883E-06_JPRB, 0.45606662E-06_JPRB, 0.43995604E-06_JPRB, 0.43437037E-06_JPRB, 0.42795392E-06_JPRB, 0.41699455E-06_JPRB, &
  & 0.40614524E-06_JPRB, 0.39364746E-06_JPRB, 0.38067451E-06_JPRB, 0.37184816E-06_JPRB, 0.36177627E-06_JPRB, 0.34634596E-06_JPRB, &
  & 0.32218515E-06_JPRB, 0.28551699E-06_JPRB, 0.24141525E-06_JPRB, 0.19635581E-06_JPRB, 0.15676498E-06_JPRB, 0.12648684E-06_JPRB, &
  & 0.10589618E-06_JPRB, 0.91947962E-07_JPRB, 0.81342942E-07_JPRB, 0.71931121E-07_JPRB, 0.63976747E-07_JPRB, 0.57965321E-07_JPRB, &
  & 0.52708457E-07_JPRB, 0.49054442E-07_JPRB, 0.44849889E-07_JPRB, 0.40591286E-07_JPRB, 0.37675854E-07_JPRB, 0.35693646E-07_JPRB, &
  & 0.34660163E-07_JPRB, 0.34569407E-07_JPRB, 0.34809306E-07_JPRB, 0.35582517E-07_JPRB, 0.37361415E-07_JPRB, 0.39767826E-07_JPRB, &
  & 0.42916564E-07_JPRB, 0.46815883E-07_JPRB, 0.51592593E-07_JPRB, 0.57081220E-07_JPRB, 0.64507982E-07_JPRB, 0.76569559E-07_JPRB, &
  & 0.97400298E-07_JPRB, 0.13190580E-06_JPRB, 0.18408920E-06_JPRB, 0.25432666E-06_JPRB, 0.32852276E-06_JPRB, 0.40040767E-06_JPRB, &
  & 0.46429010E-06_JPRB, 0.51634959E-06_JPRB, 0.54966397E-06_JPRB, 0.57417770E-06_JPRB, 0.59439049E-06_JPRB, 0.60723436E-06_JPRB, &
  & 0.63153850E-06_JPRB, 0.66811963E-06_JPRB, 0.69210261E-06_JPRB, 0.69108320E-06_JPRB, 0.69070212E-06_JPRB, 0.69057566E-06_JPRB, &
  & 0.68289611E-06_JPRB, 0.66592976E-06_JPRB, 0.64994588E-06_JPRB, 0.63961616E-06_JPRB  /)

RGHG7(:,47, 1) = (/ &
  & 0.42079992E-06_JPRB, 0.40533266E-06_JPRB, 0.39316603E-06_JPRB, 0.38772738E-06_JPRB, 0.38281154E-06_JPRB, 0.37277329E-06_JPRB, &
  & 0.36225263E-06_JPRB, 0.35069760E-06_JPRB, 0.33976582E-06_JPRB, 0.33296765E-06_JPRB, 0.32482017E-06_JPRB, 0.31167751E-06_JPRB, &
  & 0.29071683E-06_JPRB, 0.25743476E-06_JPRB, 0.21713425E-06_JPRB, 0.17645553E-06_JPRB, 0.14103352E-06_JPRB, 0.11433174E-06_JPRB, &
  & 0.96448215E-07_JPRB, 0.84376830E-07_JPRB, 0.74891856E-07_JPRB, 0.66440073E-07_JPRB, 0.59168970E-07_JPRB, 0.53607292E-07_JPRB, &
  & 0.48973156E-07_JPRB, 0.45768889E-07_JPRB, 0.42217335E-07_JPRB, 0.38369560E-07_JPRB, 0.35839009E-07_JPRB, 0.34276277E-07_JPRB, &
  & 0.33502264E-07_JPRB, 0.33454753E-07_JPRB, 0.33664380E-07_JPRB, 0.34420293E-07_JPRB, 0.36052158E-07_JPRB, 0.38238020E-07_JPRB, &
  & 0.41010526E-07_JPRB, 0.44581183E-07_JPRB, 0.49107073E-07_JPRB, 0.54483262E-07_JPRB, 0.61317568E-07_JPRB, 0.72125041E-07_JPRB, &
  & 0.90698391E-07_JPRB, 0.12138968E-06_JPRB, 0.16700849E-06_JPRB, 0.22667255E-06_JPRB, 0.28707351E-06_JPRB, 0.34462702E-06_JPRB, &
  & 0.39493917E-06_JPRB, 0.43510629E-06_JPRB, 0.45807647E-06_JPRB, 0.47447744E-06_JPRB, 0.48817753E-06_JPRB, 0.49880294E-06_JPRB, &
  & 0.52161512E-06_JPRB, 0.55094839E-06_JPRB, 0.56690510E-06_JPRB, 0.56338180E-06_JPRB, 0.56199744E-06_JPRB, 0.56025794E-06_JPRB, &
  & 0.55068858E-06_JPRB, 0.53056535E-06_JPRB, 0.51781187E-06_JPRB, 0.51027578E-06_JPRB  /)

RGHG7(:,48, 1) = (/ &
  & 0.38222655E-06_JPRB, 0.36834397E-06_JPRB, 0.35758098E-06_JPRB, 0.35272498E-06_JPRB, 0.34864653E-06_JPRB, 0.33869169E-06_JPRB, &
  & 0.32788879E-06_JPRB, 0.31658258E-06_JPRB, 0.30683021E-06_JPRB, 0.30101163E-06_JPRB, 0.29375670E-06_JPRB, 0.28206125E-06_JPRB, &
  & 0.26305203E-06_JPRB, 0.23231541E-06_JPRB, 0.19511589E-06_JPRB, 0.15841717E-06_JPRB, 0.12688222E-06_JPRB, 0.10359673E-06_JPRB, &
  & 0.88095133E-07_JPRB, 0.77811680E-07_JPRB, 0.69556249E-07_JPRB, 0.62142530E-07_JPRB, 0.55453880E-07_JPRB, 0.50335652E-07_JPRB, &
  & 0.46260664E-07_JPRB, 0.43354938E-07_JPRB, 0.40249166E-07_JPRB, 0.36756796E-07_JPRB, 0.34432031E-07_JPRB, 0.33065267E-07_JPRB, &
  & 0.32523048E-07_JPRB, 0.32513696E-07_JPRB, 0.32720195E-07_JPRB, 0.33465391E-07_JPRB, 0.35048777E-07_JPRB, 0.37147716E-07_JPRB, &
  & 0.39654443E-07_JPRB, 0.42890768E-07_JPRB, 0.47136237E-07_JPRB, 0.52155788E-07_JPRB, 0.58294849E-07_JPRB, 0.67992873E-07_JPRB, &
  & 0.84471476E-07_JPRB, 0.11191308E-06_JPRB, 0.15169449E-06_JPRB, 0.20152721E-06_JPRB, 0.24999701E-06_JPRB, 0.29575027E-06_JPRB, &
  & 0.33533608E-06_JPRB, 0.36645008E-06_JPRB, 0.38278963E-06_JPRB, 0.39394820E-06_JPRB, 0.40312448E-06_JPRB, 0.41235975E-06_JPRB, &
  & 0.43244473E-06_JPRB, 0.45515641E-06_JPRB, 0.46611751E-06_JPRB, 0.46166087E-06_JPRB, 0.46027714E-06_JPRB, 0.45775846E-06_JPRB, &
  & 0.44705658E-06_JPRB, 0.42788979E-06_JPRB, 0.41671301E-06_JPRB, 0.41110098E-06_JPRB  /)

RGHG7(:,49, 1) = (/ &
  & 0.34601439E-06_JPRB, 0.33363195E-06_JPRB, 0.32326841E-06_JPRB, 0.31925569E-06_JPRB, 0.31580304E-06_JPRB, 0.30555970E-06_JPRB, &
  & 0.29416652E-06_JPRB, 0.28282036E-06_JPRB, 0.27398228E-06_JPRB, 0.26877174E-06_JPRB, 0.26203609E-06_JPRB, 0.25156118E-06_JPRB, &
  & 0.23414531E-06_JPRB, 0.20584531E-06_JPRB, 0.17176148E-06_JPRB, 0.13928802E-06_JPRB, 0.11192951E-06_JPRB, 0.92354436E-07_JPRB, &
  & 0.79342720E-07_JPRB, 0.70998803E-07_JPRB, 0.64154751E-07_JPRB, 0.57926058E-07_JPRB, 0.51836577E-07_JPRB, 0.47206562E-07_JPRB, &
  & 0.43721867E-07_JPRB, 0.41078001E-07_JPRB, 0.38371676E-07_JPRB, 0.35247685E-07_JPRB, 0.33069384E-07_JPRB, 0.31818015E-07_JPRB, &
  & 0.31519903E-07_JPRB, 0.31550495E-07_JPRB, 0.31765871E-07_JPRB, 0.32502190E-07_JPRB, 0.34076700E-07_JPRB, 0.36140132E-07_JPRB, &
  & 0.38402753E-07_JPRB, 0.41266261E-07_JPRB, 0.45187734E-07_JPRB, 0.49701319E-07_JPRB, 0.55023734E-07_JPRB, 0.63558924E-07_JPRB, &
  & 0.77791748E-07_JPRB, 0.10189132E-06_JPRB, 0.13553900E-06_JPRB, 0.17482188E-06_JPRB, 0.21092659E-06_JPRB, 0.24476301E-06_JPRB, &
  & 0.27376349E-06_JPRB, 0.29614292E-06_JPRB, 0.30682807E-06_JPRB, 0.31348621E-06_JPRB, 0.31855706E-06_JPRB, 0.32662950E-06_JPRB, &
  & 0.34313277E-06_JPRB, 0.35879644E-06_JPRB, 0.36560329E-06_JPRB, 0.36082709E-06_JPRB, 0.35990051E-06_JPRB, 0.35689805E-06_JPRB, &
  & 0.34528632E-06_JPRB, 0.32904881E-06_JPRB, 0.31886620E-06_JPRB, 0.31498956E-06_JPRB  /)

RGHG7(:,50, 1) = (/ &
  & 0.31429078E-06_JPRB, 0.30245808E-06_JPRB, 0.29224825E-06_JPRB, 0.28886467E-06_JPRB, 0.28534987E-06_JPRB, 0.27424058E-06_JPRB, &
  & 0.26165630E-06_JPRB, 0.25002449E-06_JPRB, 0.24135562E-06_JPRB, 0.23658624E-06_JPRB, 0.23040117E-06_JPRB, 0.22132491E-06_JPRB, &
  & 0.20570077E-06_JPRB, 0.18033219E-06_JPRB, 0.14994128E-06_JPRB, 0.12200964E-06_JPRB, 0.98887107E-07_JPRB, 0.82631199E-07_JPRB, &
  & 0.71969790E-07_JPRB, 0.65346206E-07_JPRB, 0.59784381E-07_JPRB, 0.54593701E-07_JPRB, 0.49037664E-07_JPRB, 0.44919227E-07_JPRB, &
  & 0.41900171E-07_JPRB, 0.39432806E-07_JPRB, 0.36939326E-07_JPRB, 0.34065614E-07_JPRB, 0.32004442E-07_JPRB, 0.30774947E-07_JPRB, &
  & 0.30594167E-07_JPRB, 0.30698398E-07_JPRB, 0.30968598E-07_JPRB, 0.31726533E-07_JPRB, 0.33282275E-07_JPRB, 0.35354287E-07_JPRB, &
  & 0.37477942E-07_JPRB, 0.40020491E-07_JPRB, 0.43561974E-07_JPRB, 0.47550964E-07_JPRB, 0.52075548E-07_JPRB, 0.59470370E-07_JPRB, &
  & 0.71898571E-07_JPRB, 0.93015790E-07_JPRB, 0.12075039E-06_JPRB, 0.15078515E-06_JPRB, 0.17719948E-06_JPRB, 0.20178204E-06_JPRB, &
  & 0.22298234E-06_JPRB, 0.23905386E-06_JPRB, 0.24601629E-06_JPRB, 0.24971562E-06_JPRB, 0.25272846E-06_JPRB, 0.25950621E-06_JPRB, &
  & 0.27255213E-06_JPRB, 0.28277099E-06_JPRB, 0.28689091E-06_JPRB, 0.28284815E-06_JPRB, 0.28246625E-06_JPRB, 0.27945124E-06_JPRB, &
  & 0.26926113E-06_JPRB, 0.25605991E-06_JPRB, 0.24710242E-06_JPRB, 0.24323948E-06_JPRB  /)

RGHG7(:,51, 1) = (/ &
  & 0.28233664E-06_JPRB, 0.27059900E-06_JPRB, 0.26042625E-06_JPRB, 0.25761062E-06_JPRB, 0.25366696E-06_JPRB, 0.24131746E-06_JPRB, &
  & 0.22712903E-06_JPRB, 0.21505909E-06_JPRB, 0.20618159E-06_JPRB, 0.20180166E-06_JPRB, 0.19622858E-06_JPRB, 0.18875879E-06_JPRB, &
  & 0.17517693E-06_JPRB, 0.15323919E-06_JPRB, 0.12714611E-06_JPRB, 0.10429352E-06_JPRB, 0.85784077E-07_JPRB, 0.72912650E-07_JPRB, &
  & 0.64720058E-07_JPRB, 0.59842032E-07_JPRB, 0.55599228E-07_JPRB, 0.51454029E-07_JPRB, 0.46440436E-07_JPRB, 0.42887625E-07_JPRB, &
  & 0.40306696E-07_JPRB, 0.37985375E-07_JPRB, 0.35624028E-07_JPRB, 0.32958949E-07_JPRB, 0.31009047E-07_JPRB, 0.29754053E-07_JPRB, &
  & 0.29633545E-07_JPRB, 0.29835137E-07_JPRB, 0.30188790E-07_JPRB, 0.30986134E-07_JPRB, 0.32516376E-07_JPRB, 0.34620842E-07_JPRB, &
  & 0.36649453E-07_JPRB, 0.38872099E-07_JPRB, 0.41973136E-07_JPRB, 0.45384909E-07_JPRB, 0.49056418E-07_JPRB, 0.55229582E-07_JPRB, &
  & 0.65937724E-07_JPRB, 0.84018182E-07_JPRB, 0.10547295E-06_JPRB, 0.12618879E-06_JPRB, 0.14352761E-06_JPRB, 0.15950061E-06_JPRB, &
  & 0.17372794E-06_JPRB, 0.18425216E-06_JPRB, 0.18820333E-06_JPRB, 0.18951266E-06_JPRB, 0.19137570E-06_JPRB, 0.19668375E-06_JPRB, &
  & 0.20605542E-06_JPRB, 0.21122769E-06_JPRB, 0.21321260E-06_JPRB, 0.21051668E-06_JPRB, 0.21076996E-06_JPRB, 0.20798908E-06_JPRB, &
  & 0.20056219E-06_JPRB, 0.19070141E-06_JPRB, 0.18319043E-06_JPRB, 0.17843733E-06_JPRB  /)

RGHG7(:,52, 1) = (/ &
  & 0.25180792E-06_JPRB, 0.23987100E-06_JPRB, 0.22926809E-06_JPRB, 0.22654263E-06_JPRB, 0.22220484E-06_JPRB, 0.20881951E-06_JPRB, &
  & 0.19317325E-06_JPRB, 0.18046940E-06_JPRB, 0.17168682E-06_JPRB, 0.16817374E-06_JPRB, 0.16374304E-06_JPRB, 0.15819146E-06_JPRB, &
  & 0.14748311E-06_JPRB, 0.12962293E-06_JPRB, 0.10828354E-06_JPRB, 0.90123020E-07_JPRB, 0.75480243E-07_JPRB, 0.65338101E-07_JPRB, &
  & 0.59078048E-07_JPRB, 0.55542068E-07_JPRB, 0.52320818E-07_JPRB, 0.49061029E-07_JPRB, 0.44635541E-07_JPRB, 0.41477707E-07_JPRB, &
  & 0.39226935E-07_JPRB, 0.37015112E-07_JPRB, 0.34721457E-07_JPRB, 0.32175576E-07_JPRB, 0.30284600E-07_JPRB, 0.29001371E-07_JPRB, &
  & 0.28875020E-07_JPRB, 0.29161784E-07_JPRB, 0.29598637E-07_JPRB, 0.30432825E-07_JPRB, 0.31941472E-07_JPRB, 0.34037812E-07_JPRB, &
  & 0.36031652E-07_JPRB, 0.38033018E-07_JPRB, 0.40790015E-07_JPRB, 0.43719134E-07_JPRB, 0.46806096E-07_JPRB, 0.52076073E-07_JPRB, &
  & 0.61408991E-07_JPRB, 0.76628524E-07_JPRB, 0.92815487E-07_JPRB, 0.10680288E-06_JPRB, 0.11803451E-06_JPRB, 0.12840869E-06_JPRB, &
  & 0.13799727E-06_JPRB, 0.14476448E-06_JPRB, 0.14665312E-06_JPRB, 0.14640569E-06_JPRB, 0.14775279E-06_JPRB, 0.15192525E-06_JPRB, &
  & 0.15860154E-06_JPRB, 0.16101395E-06_JPRB, 0.16219418E-06_JPRB, 0.16055031E-06_JPRB, 0.16131465E-06_JPRB, 0.15929867E-06_JPRB, &
  & 0.15396416E-06_JPRB, 0.14621533E-06_JPRB, 0.13994011E-06_JPRB, 0.13552395E-06_JPRB  /)

RGHG7(:,53, 1) = (/ &
  & 0.21911101E-06_JPRB, 0.20684387E-06_JPRB, 0.19559274E-06_JPRB, 0.19278167E-06_JPRB, 0.18802804E-06_JPRB, 0.17359333E-06_JPRB, &
  & 0.15641580E-06_JPRB, 0.14294632E-06_JPRB, 0.13438389E-06_JPRB, 0.13199847E-06_JPRB, 0.12901587E-06_JPRB, 0.12567312E-06_JPRB, &
  & 0.11841379E-06_JPRB, 0.10524280E-06_JPRB, 0.89255498E-07_JPRB, 0.76055686E-07_JPRB, 0.65336468E-07_JPRB, 0.57914400E-07_JPRB, &
  & 0.53552528E-07_JPRB, 0.51322770E-07_JPRB, 0.49099534E-07_JPRB, 0.46742359E-07_JPRB, 0.42974874E-07_JPRB, 0.40181510E-07_JPRB, &
  & 0.38248732E-07_JPRB, 0.36142092E-07_JPRB, 0.33897359E-07_JPRB, 0.31446877E-07_JPRB, 0.29599931E-07_JPRB, 0.28284903E-07_JPRB, &
  & 0.28126752E-07_JPRB, 0.28501575E-07_JPRB, 0.29028934E-07_JPRB, 0.29902261E-07_JPRB, 0.31388893E-07_JPRB, 0.33460772E-07_JPRB, &
  & 0.35439935E-07_JPRB, 0.37238274E-07_JPRB, 0.39657708E-07_JPRB, 0.42097605E-07_JPRB, 0.44651315E-07_JPRB, 0.49060262E-07_JPRB, &
  & 0.57028250E-07_JPRB, 0.69199930E-07_JPRB, 0.80039699E-07_JPRB, 0.87696565E-07_JPRB, 0.93419554E-07_JPRB, 0.98855037E-07_JPRB, &
  & 0.10429012E-06_JPRB, 0.10765480E-06_JPRB, 0.10766237E-06_JPRB, 0.10604023E-06_JPRB, 0.10706934E-06_JPRB, 0.11013372E-06_JPRB, &
  & 0.11425137E-06_JPRB, 0.11453811E-06_JPRB, 0.11535387E-06_JPRB, 0.11474226E-06_JPRB, 0.11601539E-06_JPRB, 0.11503656E-06_JPRB, &
  & 0.11172254E-06_JPRB, 0.10580095E-06_JPRB, 0.10079037E-06_JPRB, 0.97213222E-07_JPRB  /)

RGHG7(:,54, 1) = (/ &
  & 0.18874838E-06_JPRB, 0.17616451E-06_JPRB, 0.16463411E-06_JPRB, 0.16162442E-06_JPRB, 0.15712612E-06_JPRB, 0.14307950E-06_JPRB, &
  & 0.12619808E-06_JPRB, 0.11303581E-06_JPRB, 0.10540774E-06_JPRB, 0.10417132E-06_JPRB, 0.10239688E-06_JPRB, 0.10085717E-06_JPRB, &
  & 0.96509464E-07_JPRB, 0.87371265E-07_JPRB, 0.75848374E-07_JPRB, 0.66356250E-07_JPRB, 0.58411599E-07_JPRB, 0.52960965E-07_JPRB, &
  & 0.49856066E-07_JPRB, 0.48427780E-07_JPRB, 0.46801574E-07_JPRB, 0.45138109E-07_JPRB, 0.42019523E-07_JPRB, 0.39418771E-07_JPRB, &
  & 0.37657965E-07_JPRB, 0.35629505E-07_JPRB, 0.33397295E-07_JPRB, 0.31019766E-07_JPRB, 0.29067546E-07_JPRB, 0.27761708E-07_JPRB, &
  & 0.27566674E-07_JPRB, 0.28062886E-07_JPRB, 0.28707704E-07_JPRB, 0.29573667E-07_JPRB, 0.31096705E-07_JPRB, 0.33148187E-07_JPRB, &
  & 0.35145687E-07_JPRB, 0.36909911E-07_JPRB, 0.39038018E-07_JPRB, 0.41094052E-07_JPRB, 0.43446659E-07_JPRB, 0.47225994E-07_JPRB, &
  & 0.54105653E-07_JPRB, 0.63611424E-07_JPRB, 0.71048031E-07_JPRB, 0.75399453E-07_JPRB, 0.78334602E-07_JPRB, 0.81364206E-07_JPRB, &
  & 0.84622305E-07_JPRB, 0.86259334E-07_JPRB, 0.85310183E-07_JPRB, 0.83304430E-07_JPRB, 0.83953186E-07_JPRB, 0.86166967E-07_JPRB, &
  & 0.89050739E-07_JPRB, 0.88789345E-07_JPRB, 0.89382125E-07_JPRB, 0.89341862E-07_JPRB, 0.90600935E-07_JPRB, 0.90222236E-07_JPRB, &
  & 0.87858800E-07_JPRB, 0.82969906E-07_JPRB, 0.79242246E-07_JPRB, 0.76947864E-07_JPRB  /)

RGHG7(:,55, 1) = (/ &
  & 0.15542106E-06_JPRB, 0.14248811E-06_JPRB, 0.13069687E-06_JPRB, 0.12745230E-06_JPRB, 0.12332515E-06_JPRB, 0.10989753E-06_JPRB, &
  & 0.93584489E-07_JPRB, 0.80903668E-07_JPRB, 0.74404586E-07_JPRB, 0.74443797E-07_JPRB, 0.73976125E-07_JPRB, 0.74380356E-07_JPRB, &
  & 0.73187338E-07_JPRB, 0.68430142E-07_JPRB, 0.61735957E-07_JPRB, 0.56186216E-07_JPRB, 0.51163964E-07_JPRB, 0.47798719E-07_JPRB, &
  & 0.46001891E-07_JPRB, 0.45395043E-07_JPRB, 0.44377454E-07_JPRB, 0.43454971E-07_JPRB, 0.41054007E-07_JPRB, 0.38644016E-07_JPRB, &
  & 0.37054505E-07_JPRB, 0.35109097E-07_JPRB, 0.32885971E-07_JPRB, 0.30586303E-07_JPRB, 0.28497826E-07_JPRB, 0.27207560E-07_JPRB, &
  & 0.26971000E-07_JPRB, 0.27606065E-07_JPRB, 0.28384545E-07_JPRB, 0.29236233E-07_JPRB, 0.30807286E-07_JPRB, 0.32836707E-07_JPRB, &
  & 0.34858864E-07_JPRB, 0.36607515E-07_JPRB, 0.38418986E-07_JPRB, 0.40063652E-07_JPRB, 0.42237177E-07_JPRB, 0.45349500E-07_JPRB, &
  & 0.51059939E-07_JPRB, 0.57662777E-07_JPRB, 0.61585238E-07_JPRB, 0.62672969E-07_JPRB, 0.62877778E-07_JPRB, 0.63575432E-07_JPRB, &
  & 0.64681960E-07_JPRB, 0.64625503E-07_JPRB, 0.62738122E-07_JPRB, 0.60437794E-07_JPRB, 0.60657014E-07_JPRB, 0.61962412E-07_JPRB, &
  & 0.63653606E-07_JPRB, 0.62992524E-07_JPRB, 0.63356910E-07_JPRB, 0.63888929E-07_JPRB, 0.65063651E-07_JPRB, 0.65292271E-07_JPRB, &
  & 0.63841112E-07_JPRB, 0.59991668E-07_JPRB, 0.57687574E-07_JPRB, 0.56872559E-07_JPRB  /)

RGHG7(:,56, 1) = (/ &
  & 0.12850490E-06_JPRB, 0.11661438E-06_JPRB, 0.10613300E-06_JPRB, 0.10307291E-06_JPRB, 0.99574090E-07_JPRB, 0.88456148E-07_JPRB, &
  & 0.74405081E-07_JPRB, 0.63796210E-07_JPRB, 0.58713308E-07_JPRB, 0.59126616E-07_JPRB, 0.59133053E-07_JPRB, 0.60099470E-07_JPRB, &
  & 0.60206871E-07_JPRB, 0.57717735E-07_JPRB, 0.53616688E-07_JPRB, 0.50352366E-07_JPRB, 0.47141637E-07_JPRB, 0.44965107E-07_JPRB, &
  & 0.43904058E-07_JPRB, 0.43626882E-07_JPRB, 0.42991858E-07_JPRB, 0.42399395E-07_JPRB, 0.40577960E-07_JPRB, 0.38266063E-07_JPRB, &
  & 0.36693956E-07_JPRB, 0.34872558E-07_JPRB, 0.32664922E-07_JPRB, 0.30351376E-07_JPRB, 0.28127522E-07_JPRB, 0.26853322E-07_JPRB, &
  & 0.26591469E-07_JPRB, 0.27362972E-07_JPRB, 0.28228666E-07_JPRB, 0.29220671E-07_JPRB, 0.30878548E-07_JPRB, 0.32901026E-07_JPRB, &
  & 0.34986601E-07_JPRB, 0.36733041E-07_JPRB, 0.38222467E-07_JPRB, 0.39677441E-07_JPRB, 0.41682147E-07_JPRB, 0.44477380E-07_JPRB, &
  & 0.49222745E-07_JPRB, 0.53993620E-07_JPRB, 0.56483217E-07_JPRB, 0.56500254E-07_JPRB, 0.56117764E-07_JPRB, 0.56249033E-07_JPRB, &
  & 0.56633661E-07_JPRB, 0.56192937E-07_JPRB, 0.54385292E-07_JPRB, 0.52402968E-07_JPRB, 0.52336405E-07_JPRB, 0.53112413E-07_JPRB, &
  & 0.54342947E-07_JPRB, 0.53756703E-07_JPRB, 0.54008299E-07_JPRB, 0.54434233E-07_JPRB, 0.55368738E-07_JPRB, 0.55675307E-07_JPRB, &
  & 0.54571571E-07_JPRB, 0.51635521E-07_JPRB, 0.50065254E-07_JPRB, 0.49633533E-07_JPRB  /)

RGHG7(:,57, 1) = (/ &
  & 0.10191320E-06_JPRB, 0.91373218E-07_JPRB, 0.82408085E-07_JPRB, 0.79540844E-07_JPRB, 0.76664805E-07_JPRB, 0.67811325E-07_JPRB, &
  & 0.56066429E-07_JPRB, 0.47494738E-07_JPRB, 0.43710922E-07_JPRB, 0.44497595E-07_JPRB, 0.44933591E-07_JPRB, 0.46398946E-07_JPRB, &
  & 0.47662597E-07_JPRB, 0.47281045E-07_JPRB, 0.45642680E-07_JPRB, 0.44551160E-07_JPRB, 0.43105183E-07_JPRB, 0.42125003E-07_JPRB, &
  & 0.41792943E-07_JPRB, 0.41855449E-07_JPRB, 0.41599526E-07_JPRB, 0.41329543E-07_JPRB, 0.40093105E-07_JPRB, 0.37905343E-07_JPRB, &
  & 0.36350658E-07_JPRB, 0.34635786E-07_JPRB, 0.32453210E-07_JPRB, 0.30094930E-07_JPRB, 0.27767868E-07_JPRB, 0.26503775E-07_JPRB, &
  & 0.26244775E-07_JPRB, 0.27120801E-07_JPRB, 0.28078060E-07_JPRB, 0.29232686E-07_JPRB, 0.30969294E-07_JPRB, 0.33020528E-07_JPRB, &
  & 0.35168649E-07_JPRB, 0.36852539E-07_JPRB, 0.38051216E-07_JPRB, 0.39352720E-07_JPRB, 0.41148236E-07_JPRB, 0.43606122E-07_JPRB, &
  & 0.47343772E-07_JPRB, 0.50404334E-07_JPRB, 0.51466755E-07_JPRB, 0.50452200E-07_JPRB, 0.49480694E-07_JPRB, 0.49017401E-07_JPRB, &
  & 0.48707676E-07_JPRB, 0.47879648E-07_JPRB, 0.46151164E-07_JPRB, 0.44472206E-07_JPRB, 0.44177998E-07_JPRB, 0.44486144E-07_JPRB, &
  & 0.45252205E-07_JPRB, 0.44714654E-07_JPRB, 0.44849540E-07_JPRB, 0.45204934E-07_JPRB, 0.45894410E-07_JPRB, 0.46264967E-07_JPRB, &
  & 0.45507331E-07_JPRB, 0.43447749E-07_JPRB, 0.42544712E-07_JPRB, 0.42427804E-07_JPRB  /)

RGHG7(:,58, 1) = (/ &
  & 0.79210517E-07_JPRB, 0.70693711E-07_JPRB, 0.63765895E-07_JPRB, 0.61168725E-07_JPRB, 0.58904218E-07_JPRB, 0.52373617E-07_JPRB, &
  & 0.43141524E-07_JPRB, 0.36682581E-07_JPRB, 0.33949415E-07_JPRB, 0.34909176E-07_JPRB, 0.35508831E-07_JPRB, 0.37067128E-07_JPRB, &
  & 0.38802898E-07_JPRB, 0.39692227E-07_JPRB, 0.39679002E-07_JPRB, 0.40084658E-07_JPRB, 0.39974217E-07_JPRB, 0.39938949E-07_JPRB, &
  & 0.40158480E-07_JPRB, 0.40458055E-07_JPRB, 0.40502510E-07_JPRB, 0.40439290E-07_JPRB, 0.39724135E-07_JPRB, 0.37677134E-07_JPRB, &
  & 0.36109653E-07_JPRB, 0.34470885E-07_JPRB, 0.32328719E-07_JPRB, 0.29859987E-07_JPRB, 0.27492514E-07_JPRB, 0.26227748E-07_JPRB, &
  & 0.26021954E-07_JPRB, 0.26939737E-07_JPRB, 0.27979835E-07_JPRB, 0.29350653E-07_JPRB, 0.31153263E-07_JPRB, 0.33294071E-07_JPRB, &
  & 0.35505501E-07_JPRB, 0.37032467E-07_JPRB, 0.38015626E-07_JPRB, 0.39278741E-07_JPRB, 0.40815636E-07_JPRB, 0.42994696E-07_JPRB, &
  & 0.45771944E-07_JPRB, 0.47666015E-07_JPRB, 0.47815853E-07_JPRB, 0.46329853E-07_JPRB, 0.45215566E-07_JPRB, 0.44488937E-07_JPRB, &
  & 0.43855262E-07_JPRB, 0.42911393E-07_JPRB, 0.41445572E-07_JPRB, 0.40135687E-07_JPRB, 0.39757293E-07_JPRB, 0.39810185E-07_JPRB, &
  & 0.40279910E-07_JPRB, 0.39831933E-07_JPRB, 0.39874550E-07_JPRB, 0.40097939E-07_JPRB, 0.40524753E-07_JPRB, 0.40831328E-07_JPRB, &
  & 0.40283822E-07_JPRB, 0.38944205E-07_JPRB, 0.38412936E-07_JPRB, 0.38264374E-07_JPRB  /)

RGHG7(:,59, 1) = (/ &
  & 0.62368532E-07_JPRB, 0.55828028E-07_JPRB, 0.50772954E-07_JPRB, 0.48436925E-07_JPRB, 0.46568645E-07_JPRB, 0.41759712E-07_JPRB, &
  & 0.34613498E-07_JPRB, 0.29767840E-07_JPRB, 0.27732914E-07_JPRB, 0.28725096E-07_JPRB, 0.29434662E-07_JPRB, 0.30909133E-07_JPRB, &
  & 0.32736473E-07_JPRB, 0.34306737E-07_JPRB, 0.35308878E-07_JPRB, 0.36707397E-07_JPRB, 0.37519859E-07_JPRB, 0.38183635E-07_JPRB, &
  & 0.38785440E-07_JPRB, 0.39295983E-07_JPRB, 0.39600925E-07_JPRB, 0.39677966E-07_JPRB, 0.39385211E-07_JPRB, 0.37523987E-07_JPRB, &
  & 0.35966018E-07_JPRB, 0.34325432E-07_JPRB, 0.32221080E-07_JPRB, 0.29652439E-07_JPRB, 0.27264405E-07_JPRB, 0.25976999E-07_JPRB, &
  & 0.25853878E-07_JPRB, 0.26834888E-07_JPRB, 0.27986122E-07_JPRB, 0.29448202E-07_JPRB, 0.31394027E-07_JPRB, 0.33680766E-07_JPRB, &
  & 0.35862249E-07_JPRB, 0.37175817E-07_JPRB, 0.38115971E-07_JPRB, 0.39357958E-07_JPRB, 0.40626754E-07_JPRB, 0.42486395E-07_JPRB, &
  & 0.44569552E-07_JPRB, 0.45669424E-07_JPRB, 0.45249696E-07_JPRB, 0.43657124E-07_JPRB, 0.42499045E-07_JPRB, 0.41628672E-07_JPRB, &
  & 0.40865633E-07_JPRB, 0.39899259E-07_JPRB, 0.38673741E-07_JPRB, 0.37641941E-07_JPRB, 0.37264233E-07_JPRB, 0.37205097E-07_JPRB, &
  & 0.37502078E-07_JPRB, 0.37120827E-07_JPRB, 0.37121435E-07_JPRB, 0.37248955E-07_JPRB, 0.37472324E-07_JPRB, 0.37675634E-07_JPRB, &
  & 0.37295066E-07_JPRB, 0.36366672E-07_JPRB, 0.36006691E-07_JPRB, 0.35807491E-07_JPRB  /)

RGHG7(:,60, 1) = (/ &
  & 0.47973414E-07_JPRB, 0.43363608E-07_JPRB, 0.40052923E-07_JPRB, 0.37983500E-07_JPRB, 0.36432449E-07_JPRB, 0.33073405E-07_JPRB, &
  & 0.27800165E-07_JPRB, 0.24337600E-07_JPRB, 0.22866982E-07_JPRB, 0.23827550E-07_JPRB, 0.24621930E-07_JPRB, 0.25947171E-07_JPRB, &
  & 0.27720469E-07_JPRB, 0.29735472E-07_JPRB, 0.31494207E-07_JPRB, 0.33678970E-07_JPRB, 0.35266027E-07_JPRB, 0.36525220E-07_JPRB, &
  & 0.37448763E-07_JPRB, 0.38173853E-07_JPRB, 0.38725681E-07_JPRB, 0.38923433E-07_JPRB, 0.39001205E-07_JPRB, 0.37368643E-07_JPRB, &
  & 0.35833066E-07_JPRB, 0.34168502E-07_JPRB, 0.32103302E-07_JPRB, 0.29441595E-07_JPRB, 0.27031838E-07_JPRB, 0.25705235E-07_JPRB, &
  & 0.25670237E-07_JPRB, 0.26723843E-07_JPRB, 0.27978137E-07_JPRB, 0.29523585E-07_JPRB, 0.31655132E-07_JPRB, 0.34082371E-07_JPRB, &
  & 0.36191017E-07_JPRB, 0.37319566E-07_JPRB, 0.38278982E-07_JPRB, 0.39481805E-07_JPRB, 0.40482147E-07_JPRB, 0.42018802E-07_JPRB, &
  & 0.43512588E-07_JPRB, 0.43949804E-07_JPRB, 0.43110347E-07_JPRB, 0.41546508E-07_JPRB, 0.40375699E-07_JPRB, 0.39409498E-07_JPRB, &
  & 0.38579385E-07_JPRB, 0.37625157E-07_JPRB, 0.36624148E-07_JPRB, 0.35830429E-07_JPRB, 0.35479627E-07_JPRB, 0.35356110E-07_JPRB, &
  & 0.35530679E-07_JPRB, 0.35201786E-07_JPRB, 0.35178280E-07_JPRB, 0.35224981E-07_JPRB, 0.35273487E-07_JPRB, 0.35372763E-07_JPRB, &
  & 0.35135271E-07_JPRB, 0.34491255E-07_JPRB, 0.34228276E-07_JPRB, 0.33979795E-07_JPRB  /)

RGHG7(:,61, 1) = (/ &
  & 0.38448180E-07_JPRB, 0.35331721E-07_JPRB, 0.33169343E-07_JPRB, 0.31357330E-07_JPRB, 0.30023161E-07_JPRB, 0.27533836E-07_JPRB, &
  & 0.23504566E-07_JPRB, 0.20896385E-07_JPRB, 0.19799651E-07_JPRB, 0.20650682E-07_JPRB, 0.21481939E-07_JPRB, 0.22639225E-07_JPRB, &
  & 0.24255521E-07_JPRB, 0.26427891E-07_JPRB, 0.28538603E-07_JPRB, 0.31179403E-07_JPRB, 0.33334589E-07_JPRB, 0.34982271E-07_JPRB, &
  & 0.36143508E-07_JPRB, 0.37096434E-07_JPRB, 0.37850539E-07_JPRB, 0.38154176E-07_JPRB, 0.38456498E-07_JPRB, 0.37133924E-07_JPRB, &
  & 0.35641431E-07_JPRB, 0.33965183E-07_JPRB, 0.31941608E-07_JPRB, 0.29216369E-07_JPRB, 0.26758416E-07_JPRB, 0.25359154E-07_JPRB, &
  & 0.25382940E-07_JPRB, 0.26508475E-07_JPRB, 0.27780296E-07_JPRB, 0.29522179E-07_JPRB, 0.31885212E-07_JPRB, 0.34336550E-07_JPRB, &
  & 0.36327262E-07_JPRB, 0.37488306E-07_JPRB, 0.38499204E-07_JPRB, 0.39573505E-07_JPRB, 0.40359156E-07_JPRB, 0.41661767E-07_JPRB, &
  & 0.42750634E-07_JPRB, 0.42696397E-07_JPRB, 0.41681316E-07_JPRB, 0.40231030E-07_JPRB, 0.39050727E-07_JPRB, 0.38048015E-07_JPRB, &
  & 0.37168976E-07_JPRB, 0.36247973E-07_JPRB, 0.35399219E-07_JPRB, 0.34757391E-07_JPRB, 0.34428496E-07_JPRB, 0.34263721E-07_JPRB, &
  & 0.34384252E-07_JPRB, 0.34069598E-07_JPRB, 0.34035139E-07_JPRB, 0.34029628E-07_JPRB, 0.33972979E-07_JPRB, 0.34031726E-07_JPRB, &
  & 0.33871640E-07_JPRB, 0.33340081E-07_JPRB, 0.33109598E-07_JPRB, 0.32849434E-07_JPRB  /)

RGHG7(:,62, 1) = (/ &
  & 0.31626689E-07_JPRB, 0.29529797E-07_JPRB, 0.28157171E-07_JPRB, 0.26564828E-07_JPRB, 0.25411480E-07_JPRB, 0.23498768E-07_JPRB, &
  & 0.20313633E-07_JPRB, 0.18272727E-07_JPRB, 0.17427464E-07_JPRB, 0.18154383E-07_JPRB, 0.18973147E-07_JPRB, 0.20000638E-07_JPRB, &
  & 0.21454925E-07_JPRB, 0.23677778E-07_JPRB, 0.25960050E-07_JPRB, 0.28857895E-07_JPRB, 0.31462017E-07_JPRB, 0.33381105E-07_JPRB, &
  & 0.34757883E-07_JPRB, 0.35908070E-07_JPRB, 0.36824953E-07_JPRB, 0.37243798E-07_JPRB, 0.37671875E-07_JPRB, 0.36719991E-07_JPRB, &
  & 0.35285201E-07_JPRB, 0.33644740E-07_JPRB, 0.31624922E-07_JPRB, 0.28878725E-07_JPRB, 0.26367796E-07_JPRB, 0.24847606E-07_JPRB, &
  & 0.24905292E-07_JPRB, 0.26112348E-07_JPRB, 0.27463341E-07_JPRB, 0.29374948E-07_JPRB, 0.31954686E-07_JPRB, 0.34376560E-07_JPRB, &
  & 0.36335587E-07_JPRB, 0.37667475E-07_JPRB, 0.38651218E-07_JPRB, 0.39567219E-07_JPRB, 0.40232153E-07_JPRB, 0.41377590E-07_JPRB, &
  & 0.42096196E-07_JPRB, 0.41662953E-07_JPRB, 0.40576389E-07_JPRB, 0.39215437E-07_JPRB, 0.38032907E-07_JPRB, 0.36999005E-07_JPRB, &
  & 0.36085967E-07_JPRB, 0.35201954E-07_JPRB, 0.34452467E-07_JPRB, 0.33901421E-07_JPRB, 0.33582157E-07_JPRB, 0.33381295E-07_JPRB, &
  & 0.33461472E-07_JPRB, 0.33153943E-07_JPRB, 0.33100883E-07_JPRB, 0.33049333E-07_JPRB, 0.32926612E-07_JPRB, 0.32974083E-07_JPRB, &
  & 0.32850352E-07_JPRB, 0.32375912E-07_JPRB, 0.32174096E-07_JPRB, 0.31947285E-07_JPRB  /)

RGHG7(:,63, 1) = (/ &
  & 0.26514367E-07_JPRB, 0.25110802E-07_JPRB, 0.24299863E-07_JPRB, 0.22885853E-07_JPRB, 0.21884225E-07_JPRB, 0.20373938E-07_JPRB, &
  & 0.17794828E-07_JPRB, 0.16142833E-07_JPRB, 0.15455311E-07_JPRB, 0.16052234E-07_JPRB, 0.16821523E-07_JPRB, 0.17741457E-07_JPRB, &
  & 0.19045402E-07_JPRB, 0.21246914E-07_JPRB, 0.23602998E-07_JPRB, 0.26625746E-07_JPRB, 0.29572266E-07_JPRB, 0.31692479E-07_JPRB, &
  & 0.33280239E-07_JPRB, 0.34589856E-07_JPRB, 0.35657829E-07_JPRB, 0.36205854E-07_JPRB, 0.36705407E-07_JPRB, 0.36130710E-07_JPRB, &
  & 0.34807836E-07_JPRB, 0.33229629E-07_JPRB, 0.31177795E-07_JPRB, 0.28431087E-07_JPRB, 0.25885241E-07_JPRB, 0.24225726E-07_JPRB, &
  & 0.24306385E-07_JPRB, 0.25597221E-07_JPRB, 0.27041599E-07_JPRB, 0.29091712E-07_JPRB, 0.31891708E-07_JPRB, 0.34287506E-07_JPRB, &
  & 0.36262934E-07_JPRB, 0.37819491E-07_JPRB, 0.38722684E-07_JPRB, 0.39493376E-07_JPRB, 0.40115638E-07_JPRB, 0.41114724E-07_JPRB, &
  & 0.41477960E-07_JPRB, 0.40742000E-07_JPRB, 0.39655368E-07_JPRB, 0.38362339E-07_JPRB, 0.37187414E-07_JPRB, 0.36128534E-07_JPRB, &
  & 0.35189610E-07_JPRB, 0.34340929E-07_JPRB, 0.33654982E-07_JPRB, 0.33157318E-07_JPRB, 0.32834998E-07_JPRB, 0.32602686E-07_JPRB, &
  & 0.32649706E-07_JPRB, 0.32345091E-07_JPRB, 0.32268700E-07_JPRB, 0.32177080E-07_JPRB, 0.32010880E-07_JPRB, 0.32056241E-07_JPRB, &
  & 0.31942508E-07_JPRB, 0.31500834E-07_JPRB, 0.31325280E-07_JPRB, 0.31155469E-07_JPRB  /)

RGHG7(:,64, 1) = (/ &
  & 0.23089043E-07_JPRB, 0.22024514E-07_JPRB, 0.21552612E-07_JPRB, 0.20245625E-07_JPRB, 0.19354213E-07_JPRB, 0.18097106E-07_JPRB, &
  & 0.15916933E-07_JPRB, 0.14488567E-07_JPRB, 0.13844572E-07_JPRB, 0.14316903E-07_JPRB, 0.14997140E-07_JPRB, 0.15830018E-07_JPRB, &
  & 0.17023746E-07_JPRB, 0.19135407E-07_JPRB, 0.21503871E-07_JPRB, 0.24521428E-07_JPRB, 0.27653639E-07_JPRB, 0.29912022E-07_JPRB, &
  & 0.31713827E-07_JPRB, 0.33113694E-07_JPRB, 0.34338207E-07_JPRB, 0.35035584E-07_JPRB, 0.35569879E-07_JPRB, 0.35311457E-07_JPRB, &
  & 0.34216205E-07_JPRB, 0.32715069E-07_JPRB, 0.30582171E-07_JPRB, 0.27842251E-07_JPRB, 0.25312778E-07_JPRB, 0.23523080E-07_JPRB, &
  & 0.23624105E-07_JPRB, 0.24991214E-07_JPRB, 0.26497489E-07_JPRB, 0.28630265E-07_JPRB, 0.31665869E-07_JPRB, 0.34100004E-07_JPRB, &
  & 0.36122553E-07_JPRB, 0.37887165E-07_JPRB, 0.38660574E-07_JPRB, 0.39354592E-07_JPRB, 0.40033960E-07_JPRB, 0.40840565E-07_JPRB, &
  & 0.40863966E-07_JPRB, 0.39911965E-07_JPRB, 0.38896415E-07_JPRB, 0.37640124E-07_JPRB, 0.36489560E-07_JPRB, 0.35416703E-07_JPRB, &
  & 0.34457812E-07_JPRB, 0.33635088E-07_JPRB, 0.32975497E-07_JPRB, 0.32498598E-07_JPRB, 0.32154315E-07_JPRB, 0.31898043E-07_JPRB, &
  & 0.31917108E-07_JPRB, 0.31612095E-07_JPRB, 0.31509347E-07_JPRB, 0.31387777E-07_JPRB, 0.31196020E-07_JPRB, 0.31232196E-07_JPRB, &
  & 0.31104486E-07_JPRB, 0.30690367E-07_JPRB, 0.30537973E-07_JPRB, 0.30435650E-07_JPRB  /)

RGHG7(:,65, 1) = (/ &
  & 0.20907442E-07_JPRB, 0.19935140E-07_JPRB, 0.19664738E-07_JPRB, 0.18405749E-07_JPRB, 0.17550315E-07_JPRB, 0.16437559E-07_JPRB, &
  & 0.14533367E-07_JPRB, 0.13231097E-07_JPRB, 0.12533210E-07_JPRB, 0.12876281E-07_JPRB, 0.13441884E-07_JPRB, 0.14207485E-07_JPRB, &
  & 0.15328810E-07_JPRB, 0.17281918E-07_JPRB, 0.19604502E-07_JPRB, 0.22519448E-07_JPRB, 0.25692697E-07_JPRB, 0.28061686E-07_JPRB, &
  & 0.30001487E-07_JPRB, 0.31435798E-07_JPRB, 0.32839230E-07_JPRB, 0.33752142E-07_JPRB, 0.34344488E-07_JPRB, 0.34237498E-07_JPRB, &
  & 0.33516187E-07_JPRB, 0.32207932E-07_JPRB, 0.30036464E-07_JPRB, 0.27250234E-07_JPRB, 0.24680021E-07_JPRB, 0.22827906E-07_JPRB, &
  & 0.22954656E-07_JPRB, 0.24322798E-07_JPRB, 0.25754293E-07_JPRB, 0.27972964E-07_JPRB, 0.31192081E-07_JPRB, 0.33838046E-07_JPRB, &
  & 0.35932236E-07_JPRB, 0.37808366E-07_JPRB, 0.38568451E-07_JPRB, 0.39240592E-07_JPRB, 0.39918032E-07_JPRB, 0.40480140E-07_JPRB, &
  & 0.40183042E-07_JPRB, 0.39165369E-07_JPRB, 0.38242257E-07_JPRB, 0.37009977E-07_JPRB, 0.35871320E-07_JPRB, 0.34799247E-07_JPRB, &
  & 0.33836963E-07_JPRB, 0.33029987E-07_JPRB, 0.32366103E-07_JPRB, 0.31894147E-07_JPRB, 0.31503945E-07_JPRB, 0.31227618E-07_JPRB, &
  & 0.31233013E-07_JPRB, 0.30923508E-07_JPRB, 0.30796434E-07_JPRB, 0.30659923E-07_JPRB, 0.30443157E-07_JPRB, 0.30441831E-07_JPRB, &
  & 0.30299666E-07_JPRB, 0.29933010E-07_JPRB, 0.29786858E-07_JPRB, 0.29709051E-07_JPRB  /)

RGHG7(:,66, 1) = (/ &
  & 0.19209563E-07_JPRB, 0.18265895E-07_JPRB, 0.18133591E-07_JPRB, 0.16913827E-07_JPRB, 0.16070803E-07_JPRB, 0.15046488E-07_JPRB, &
  & 0.13368368E-07_JPRB, 0.12144949E-07_JPRB, 0.11361961E-07_JPRB, 0.11564235E-07_JPRB, 0.12016856E-07_JPRB, 0.12723653E-07_JPRB, &
  & 0.13773602E-07_JPRB, 0.15557836E-07_JPRB, 0.17782630E-07_JPRB, 0.20541311E-07_JPRB, 0.23707655E-07_JPRB, 0.26161152E-07_JPRB, &
  & 0.28165584E-07_JPRB, 0.29623075E-07_JPRB, 0.31192447E-07_JPRB, 0.32327335E-07_JPRB, 0.33029435E-07_JPRB, 0.33076087E-07_JPRB, &
  & 0.32696334E-07_JPRB, 0.31698519E-07_JPRB, 0.29591054E-07_JPRB, 0.26694390E-07_JPRB, 0.24060493E-07_JPRB, 0.22200466E-07_JPRB, &
  & 0.22317454E-07_JPRB, 0.23610045E-07_JPRB, 0.24979246E-07_JPRB, 0.27239372E-07_JPRB, 0.30594932E-07_JPRB, 0.33544980E-07_JPRB, &
  & 0.35723699E-07_JPRB, 0.37667966E-07_JPRB, 0.38476593E-07_JPRB, 0.39128139E-07_JPRB, 0.39739635E-07_JPRB, 0.40045984E-07_JPRB, &
  & 0.39480643E-07_JPRB, 0.38467863E-07_JPRB, 0.37610291E-07_JPRB, 0.36393081E-07_JPRB, 0.35261230E-07_JPRB, 0.34205950E-07_JPRB, &
  & 0.33249585E-07_JPRB, 0.32451857E-07_JPRB, 0.31774948E-07_JPRB, 0.31290976E-07_JPRB, 0.30851500E-07_JPRB, 0.30566881E-07_JPRB, &
  & 0.30559856E-07_JPRB, 0.30245922E-07_JPRB, 0.30095996E-07_JPRB, 0.29945374E-07_JPRB, 0.29702833E-07_JPRB, 0.29653138E-07_JPRB, &
  & 0.29502601E-07_JPRB, 0.29189487E-07_JPRB, 0.29041911E-07_JPRB, 0.28971046E-07_JPRB  /)

RGHG7(:,67, 1) = (/ &
  & 0.17887209E-07_JPRB, 0.16946951E-07_JPRB, 0.16902357E-07_JPRB, 0.15720095E-07_JPRB, 0.14876052E-07_JPRB, 0.13893691E-07_JPRB, &
  & 0.12397077E-07_JPRB, 0.11210040E-07_JPRB, 0.10323669E-07_JPRB, 0.10385279E-07_JPRB, 0.10730788E-07_JPRB, 0.11380670E-07_JPRB, &
  & 0.12357875E-07_JPRB, 0.13971639E-07_JPRB, 0.16053073E-07_JPRB, 0.18614014E-07_JPRB, 0.21723748E-07_JPRB, 0.24230866E-07_JPRB, &
  & 0.26228968E-07_JPRB, 0.27716876E-07_JPRB, 0.29421866E-07_JPRB, 0.30755939E-07_JPRB, 0.31619012E-07_JPRB, 0.31834215E-07_JPRB, &
  & 0.31736414E-07_JPRB, 0.31131698E-07_JPRB, 0.29198355E-07_JPRB, 0.26166721E-07_JPRB, 0.23470298E-07_JPRB, 0.21627546E-07_JPRB, &
  & 0.21710166E-07_JPRB, 0.22897629E-07_JPRB, 0.24223409E-07_JPRB, 0.26477277E-07_JPRB, 0.29908579E-07_JPRB, 0.33202513E-07_JPRB, &
  & 0.35510854E-07_JPRB, 0.37470456E-07_JPRB, 0.38366815E-07_JPRB, 0.38992708E-07_JPRB, 0.39487372E-07_JPRB, 0.39545095E-07_JPRB, &
  & 0.38785160E-07_JPRB, 0.37818156E-07_JPRB, 0.36994893E-07_JPRB, 0.35781670E-07_JPRB, 0.34658655E-07_JPRB, 0.33633260E-07_JPRB, &
  & 0.32687513E-07_JPRB, 0.31891744E-07_JPRB, 0.31196790E-07_JPRB, 0.30686641E-07_JPRB, 0.30202433E-07_JPRB, 0.29920300E-07_JPRB, &
  & 0.29900567E-07_JPRB, 0.29584902E-07_JPRB, 0.29411938E-07_JPRB, 0.29246853E-07_JPRB, 0.28974485E-07_JPRB, 0.28873663E-07_JPRB, &
  & 0.28723585E-07_JPRB, 0.28462266E-07_JPRB, 0.28305369E-07_JPRB, 0.28224581E-07_JPRB  /)

RGHG7(:,68, 1) = (/ &
  & 0.16816387E-07_JPRB, 0.15903192E-07_JPRB, 0.15913544E-07_JPRB, 0.14773107E-07_JPRB, 0.13927424E-07_JPRB, 0.12953674E-07_JPRB, &
  & 0.11596065E-07_JPRB, 0.10406158E-07_JPRB, 0.94127649E-08_JPRB, 0.93587427E-08_JPRB, 0.96050199E-08_JPRB, 0.10186834E-07_JPRB, &
  & 0.11091051E-07_JPRB, 0.12537926E-07_JPRB, 0.14443450E-07_JPRB, 0.16782556E-07_JPRB, 0.19764766E-07_JPRB, 0.22286235E-07_JPRB, &
  & 0.24215449E-07_JPRB, 0.25772656E-07_JPRB, 0.27555555E-07_JPRB, 0.29017972E-07_JPRB, 0.30086068E-07_JPRB, 0.30480871E-07_JPRB, &
  & 0.30588504E-07_JPRB, 0.30383993E-07_JPRB, 0.28736042E-07_JPRB, 0.25633060E-07_JPRB, 0.22920235E-07_JPRB, 0.21057390E-07_JPRB, &
  & 0.21113768E-07_JPRB, 0.22269657E-07_JPRB, 0.23553613E-07_JPRB, 0.25758275E-07_JPRB, 0.29178095E-07_JPRB, 0.32759883E-07_JPRB, &
  & 0.35315071E-07_JPRB, 0.37209066E-07_JPRB, 0.38192765E-07_JPRB, 0.38784624E-07_JPRB, 0.39142332E-07_JPRB, 0.38986831E-07_JPRB, &
  & 0.38139557E-07_JPRB, 0.37208636E-07_JPRB, 0.36390704E-07_JPRB, 0.35165590E-07_JPRB, 0.34067587E-07_JPRB, 0.33078277E-07_JPRB, &
  & 0.32139090E-07_JPRB, 0.31335941E-07_JPRB, 0.30621715E-07_JPRB, 0.30077942E-07_JPRB, 0.29565850E-07_JPRB, 0.29292738E-07_JPRB, &
  & 0.29259064E-07_JPRB, 0.28949139E-07_JPRB, 0.28749113E-07_JPRB, 0.28569265E-07_JPRB, 0.28255893E-07_JPRB, 0.28114887E-07_JPRB, &
  & 0.27978340E-07_JPRB, 0.27753515E-07_JPRB, 0.27577346E-07_JPRB, 0.27467034E-07_JPRB  /)

RGHG7(:,69, 1) = (/ &
  & 0.15914732E-07_JPRB, 0.15068901E-07_JPRB, 0.15128591E-07_JPRB, 0.14037808E-07_JPRB, 0.13169586E-07_JPRB, 0.12189891E-07_JPRB, &
  & 0.10928717E-07_JPRB, 0.97187731E-08_JPRB, 0.86411427E-08_JPRB, 0.85110676E-08_JPRB, 0.86730597E-08_JPRB, 0.91730107E-08_JPRB, &
  & 0.99915640E-08_JPRB, 0.11259265E-07_JPRB, 0.12983687E-07_JPRB, 0.15106596E-07_JPRB, 0.17842255E-07_JPRB, 0.20341127E-07_JPRB, &
  & 0.22205197E-07_JPRB, 0.23876846E-07_JPRB, 0.25673823E-07_JPRB, 0.27108564E-07_JPRB, 0.28311857E-07_JPRB, 0.28861224E-07_JPRB, &
  & 0.29170147E-07_JPRB, 0.29236641E-07_JPRB, 0.27901647E-07_JPRB, 0.24902360E-07_JPRB, 0.22160447E-07_JPRB, 0.20383502E-07_JPRB, &
  & 0.20467009E-07_JPRB, 0.21518183E-07_JPRB, 0.22729346E-07_JPRB, 0.24958706E-07_JPRB, 0.28415562E-07_JPRB, 0.32131765E-07_JPRB, &
  & 0.34922560E-07_JPRB, 0.36800968E-07_JPRB, 0.37858555E-07_JPRB, 0.38415267E-07_JPRB, 0.38651720E-07_JPRB, 0.38391261E-07_JPRB, &
  & 0.37549589E-07_JPRB, 0.36624144E-07_JPRB, 0.35806317E-07_JPRB, 0.34548414E-07_JPRB, 0.33489975E-07_JPRB, 0.32528905E-07_JPRB, &
  & 0.31585081E-07_JPRB, 0.30775672E-07_JPRB, 0.30038819E-07_JPRB, 0.29473370E-07_JPRB, 0.28943477E-07_JPRB, 0.28681997E-07_JPRB, &
  & 0.28635877E-07_JPRB, 0.28339902E-07_JPRB, 0.28100502E-07_JPRB, 0.27889474E-07_JPRB, 0.27545181E-07_JPRB, 0.27381538E-07_JPRB, &
  & 0.27279793E-07_JPRB, 0.27067197E-07_JPRB, 0.26857951E-07_JPRB, 0.26689386E-07_JPRB  /)

RGHG7(:,70, 1) = (/ &
  & 0.15110812E-07_JPRB, 0.14353614E-07_JPRB, 0.14452895E-07_JPRB, 0.13413592E-07_JPRB, 0.12519054E-07_JPRB, 0.11518144E-07_JPRB, &
  & 0.10329144E-07_JPRB, 0.91007639E-08_JPRB, 0.79469331E-08_JPRB, 0.77657670E-08_JPRB, 0.78619367E-08_JPRB, 0.82725405E-08_JPRB, &
  & 0.89968580E-08_JPRB, 0.10091438E-07_JPRB, 0.11628399E-07_JPRB, 0.13540953E-07_JPRB, 0.15992319E-07_JPRB, 0.18427489E-07_JPRB, &
  & 0.20262874E-07_JPRB, 0.22034350E-07_JPRB, 0.23813635E-07_JPRB, 0.25155203E-07_JPRB, 0.26382702E-07_JPRB, 0.27085900E-07_JPRB, &
  & 0.27528435E-07_JPRB, 0.27812502E-07_JPRB, 0.26766412E-07_JPRB, 0.23991725E-07_JPRB, 0.21235379E-07_JPRB, 0.19654813E-07_JPRB, &
  & 0.19752900E-07_JPRB, 0.20636408E-07_JPRB, 0.21757993E-07_JPRB, 0.24077536E-07_JPRB, 0.27628717E-07_JPRB, 0.31339595E-07_JPRB, &
  & 0.34307695E-07_JPRB, 0.36233804E-07_JPRB, 0.37351709E-07_JPRB, 0.37947678E-07_JPRB, 0.38091345E-07_JPRB, 0.37765477E-07_JPRB, &
  & 0.36970286E-07_JPRB, 0.36050879E-07_JPRB, 0.35232165E-07_JPRB, 0.33943396E-07_JPRB, 0.32921508E-07_JPRB, 0.31988199E-07_JPRB, &
  & 0.31023374E-07_JPRB, 0.30212092E-07_JPRB, 0.29458907E-07_JPRB, 0.28870536E-07_JPRB, 0.28326184E-07_JPRB, 0.28075902E-07_JPRB, &
  & 0.28025798E-07_JPRB, 0.27738416E-07_JPRB, 0.27454296E-07_JPRB, 0.27190866E-07_JPRB, 0.26842559E-07_JPRB, 0.26666783E-07_JPRB, &
  & 0.26599626E-07_JPRB, 0.26391408E-07_JPRB, 0.26148371E-07_JPRB, 0.25919074E-07_JPRB  /)

RGHG7(:,71, 1) = (/ &
  & 0.14395210E-07_JPRB, 0.13748982E-07_JPRB, 0.13870582E-07_JPRB, 0.12878898E-07_JPRB, 0.11959423E-07_JPRB, 0.10926572E-07_JPRB, &
  & 0.97869132E-08_JPRB, 0.85453040E-08_JPRB, 0.73218634E-08_JPRB, 0.71064079E-08_JPRB, 0.71579637E-08_JPRB, 0.74791509E-08_JPRB, &
  & 0.81041671E-08_JPRB, 0.90367366E-08_JPRB, 0.10381559E-07_JPRB, 0.12086359E-07_JPRB, 0.14246774E-07_JPRB, 0.16576592E-07_JPRB, &
  & 0.18421296E-07_JPRB, 0.20254850E-07_JPRB, 0.21986411E-07_JPRB, 0.23194661E-07_JPRB, 0.24345493E-07_JPRB, 0.25178950E-07_JPRB, &
  & 0.25680057E-07_JPRB, 0.26108950E-07_JPRB, 0.25366430E-07_JPRB, 0.22896978E-07_JPRB, 0.20176205E-07_JPRB, 0.18859111E-07_JPRB, &
  & 0.18941994E-07_JPRB, 0.19639670E-07_JPRB, 0.20700402E-07_JPRB, 0.23146630E-07_JPRB, 0.26817467E-07_JPRB, 0.30397910E-07_JPRB, &
  & 0.33472726E-07_JPRB, 0.35501401E-07_JPRB, 0.36686775E-07_JPRB, 0.37384463E-07_JPRB, 0.37470000E-07_JPRB, 0.37108968E-07_JPRB, &
  & 0.36387537E-07_JPRB, 0.35484405E-07_JPRB, 0.34666526E-07_JPRB, 0.33351995E-07_JPRB, 0.32358521E-07_JPRB, 0.31449837E-07_JPRB, &
  & 0.30452042E-07_JPRB, 0.29644266E-07_JPRB, 0.28880923E-07_JPRB, 0.28268424E-07_JPRB, 0.27717436E-07_JPRB, 0.27473079E-07_JPRB, &
  & 0.27425132E-07_JPRB, 0.27140204E-07_JPRB, 0.26809160E-07_JPRB, 0.26479393E-07_JPRB, 0.26155278E-07_JPRB, 0.25975612E-07_JPRB, &
  & 0.25931807E-07_JPRB, 0.25722243E-07_JPRB, 0.25447794E-07_JPRB, 0.25158942E-07_JPRB  /)

RGHG7(:,72, 1) = (/ &
  & 0.13764248E-07_JPRB, 0.13258396E-07_JPRB, 0.13370966E-07_JPRB, 0.12413350E-07_JPRB, 0.11476636E-07_JPRB, 0.10409717E-07_JPRB, &
  & 0.92950958E-08_JPRB, 0.80485611E-08_JPRB, 0.67623206E-08_JPRB, 0.65169018E-08_JPRB, 0.65499869E-08_JPRB, 0.67944187E-08_JPRB, &
  & 0.73205147E-08_JPRB, 0.81077824E-08_JPRB, 0.92584586E-08_JPRB, 0.10751052E-07_JPRB, 0.12655753E-07_JPRB, 0.14836985E-07_JPRB, &
  & 0.16726019E-07_JPRB, 0.18550953E-07_JPRB, 0.20200423E-07_JPRB, 0.21263781E-07_JPRB, 0.22262744E-07_JPRB, 0.23153255E-07_JPRB, &
  & 0.23635480E-07_JPRB, 0.24081613E-07_JPRB, 0.23745035E-07_JPRB, 0.21597791E-07_JPRB, 0.19026836E-07_JPRB, 0.17957657E-07_JPRB, &
  & 0.17975278E-07_JPRB, 0.18552690E-07_JPRB, 0.19667192E-07_JPRB, 0.22223422E-07_JPRB, 0.25976351E-07_JPRB, 0.29323243E-07_JPRB, &
  & 0.32418993E-07_JPRB, 0.34587633E-07_JPRB, 0.35888347E-07_JPRB, 0.36712865E-07_JPRB, 0.36784858E-07_JPRB, 0.36416027E-07_JPRB, &
  & 0.35781202E-07_JPRB, 0.34917064E-07_JPRB, 0.34106162E-07_JPRB, 0.32772340E-07_JPRB, 0.31792822E-07_JPRB, 0.30898914E-07_JPRB, &
  & 0.29865409E-07_JPRB, 0.29067895E-07_JPRB, 0.28298395E-07_JPRB, 0.27663320E-07_JPRB, 0.27123825E-07_JPRB, 0.26871259E-07_JPRB, &
  & 0.26825775E-07_JPRB, 0.26538384E-07_JPRB, 0.26162600E-07_JPRB, 0.25767160E-07_JPRB, 0.25495174E-07_JPRB, 0.25317149E-07_JPRB, &
  & 0.25268419E-07_JPRB, 0.25052287E-07_JPRB, 0.24751980E-07_JPRB, 0.24406074E-07_JPRB  /)

RGHG7(:,73, 1) = (/ &
  & 0.13211363E-07_JPRB, 0.12871847E-07_JPRB, 0.12934190E-07_JPRB, 0.11991411E-07_JPRB, 0.11047644E-07_JPRB, 0.99681734E-08_JPRB, &
  & 0.88676882E-08_JPRB, 0.75925801E-08_JPRB, 0.62690800E-08_JPRB, 0.59908571E-08_JPRB, 0.60164122E-08_JPRB, 0.62190718E-08_JPRB, &
  & 0.66571019E-08_JPRB, 0.73187957E-08_JPRB, 0.83012462E-08_JPRB, 0.95910683E-08_JPRB, 0.11261426E-07_JPRB, 0.13287877E-07_JPRB, &
  & 0.15191402E-07_JPRB, 0.16949380E-07_JPRB, 0.18501805E-07_JPRB, 0.19385907E-07_JPRB, 0.20202404E-07_JPRB, 0.21022298E-07_JPRB, &
  & 0.21406675E-07_JPRB, 0.21795479E-07_JPRB, 0.21916344E-07_JPRB, 0.20159848E-07_JPRB, 0.17818437E-07_JPRB, 0.16941090E-07_JPRB, &
  & 0.16978784E-07_JPRB, 0.17565521E-07_JPRB, 0.18783629E-07_JPRB, 0.21417739E-07_JPRB, 0.25177044E-07_JPRB, 0.28296269E-07_JPRB, &
  & 0.31254595E-07_JPRB, 0.33541538E-07_JPRB, 0.34954449E-07_JPRB, 0.35901964E-07_JPRB, 0.35996905E-07_JPRB, 0.35675850E-07_JPRB, &
  & 0.35129277E-07_JPRB, 0.34346264E-07_JPRB, 0.33547714E-07_JPRB, 0.32192965E-07_JPRB, 0.31217959E-07_JPRB, 0.30325580E-07_JPRB, &
  & 0.29266825E-07_JPRB, 0.28481156E-07_JPRB, 0.27709272E-07_JPRB, 0.27061777E-07_JPRB, 0.26518984E-07_JPRB, 0.26257400E-07_JPRB, &
  & 0.26198392E-07_JPRB, 0.25912715E-07_JPRB, 0.25502217E-07_JPRB, 0.25062437E-07_JPRB, 0.24836024E-07_JPRB, 0.24678318E-07_JPRB, &
  & 0.24599110E-07_JPRB, 0.24348182E-07_JPRB, 0.24030628E-07_JPRB, 0.23645242E-07_JPRB  /)

RGHG7(:,74, 1) = (/ &
  & 0.12721127E-07_JPRB, 0.12536566E-07_JPRB, 0.12523212E-07_JPRB, 0.11593141E-07_JPRB, 0.10648142E-07_JPRB, 0.95790113E-08_JPRB, &
  & 0.84880113E-08_JPRB, 0.71677475E-08_JPRB, 0.58282616E-08_JPRB, 0.55187660E-08_JPRB, 0.55312753E-08_JPRB, 0.57023386E-08_JPRB, &
  & 0.60736350E-08_JPRB, 0.66291477E-08_JPRB, 0.74752292E-08_JPRB, 0.85756842E-08_JPRB, 0.10022673E-07_JPRB, 0.11882338E-07_JPRB, &
  & 0.13764368E-07_JPRB, 0.15435682E-07_JPRB, 0.16906516E-07_JPRB, 0.17645841E-07_JPRB, 0.18288648E-07_JPRB, 0.18949186E-07_JPRB, &
  & 0.19288661E-07_JPRB, 0.19661266E-07_JPRB, 0.20042899E-07_JPRB, 0.18710751E-07_JPRB, 0.16660369E-07_JPRB, 0.15937459E-07_JPRB, &
  & 0.16029401E-07_JPRB, 0.16654201E-07_JPRB, 0.17992638E-07_JPRB, 0.20714977E-07_JPRB, 0.24497581E-07_JPRB, 0.27398056E-07_JPRB, &
  & 0.30167862E-07_JPRB, 0.32487878E-07_JPRB, 0.33990296E-07_JPRB, 0.34997892E-07_JPRB, 0.35155509E-07_JPRB, 0.34907922E-07_JPRB, &
  & 0.34455098E-07_JPRB, 0.33770299E-07_JPRB, 0.32996684E-07_JPRB, 0.31629320E-07_JPRB, 0.30643652E-07_JPRB, 0.29746728E-07_JPRB, &
  & 0.28672057E-07_JPRB, 0.27887695E-07_JPRB, 0.27124655E-07_JPRB, 0.26460402E-07_JPRB, 0.25905635E-07_JPRB, 0.25632495E-07_JPRB, &
  & 0.25554172E-07_JPRB, 0.25267584E-07_JPRB, 0.24824988E-07_JPRB, 0.24355599E-07_JPRB, 0.24173911E-07_JPRB, 0.24035098E-07_JPRB, &
  & 0.23940397E-07_JPRB, 0.23639695E-07_JPRB, 0.23309354E-07_JPRB, 0.22917984E-07_JPRB  /)

RGHG7(:,75, 1) = (/ &
  & 0.12287929E-07_JPRB, 0.12232216E-07_JPRB, 0.12126699E-07_JPRB, 0.11213519E-07_JPRB, 0.10277965E-07_JPRB, 0.92393641E-08_JPRB, &
  & 0.81561552E-08_JPRB, 0.67812760E-08_JPRB, 0.54444083E-08_JPRB, 0.51073738E-08_JPRB, 0.51004408E-08_JPRB, 0.52486211E-08_JPRB, &
  & 0.55694486E-08_JPRB, 0.60385708E-08_JPRB, 0.67777459E-08_JPRB, 0.77068737E-08_JPRB, 0.89471194E-08_JPRB, 0.10619537E-07_JPRB, &
  & 0.12431579E-07_JPRB, 0.14001830E-07_JPRB, 0.15399343E-07_JPRB, 0.16041881E-07_JPRB, 0.16539540E-07_JPRB, 0.17016670E-07_JPRB, &
  & 0.17370572E-07_JPRB, 0.17744309E-07_JPRB, 0.18216155E-07_JPRB, 0.17304587E-07_JPRB, 0.15582753E-07_JPRB, 0.14984843E-07_JPRB, &
  & 0.15143114E-07_JPRB, 0.15801339E-07_JPRB, 0.17269186E-07_JPRB, 0.20099933E-07_JPRB, 0.23936902E-07_JPRB, 0.26638841E-07_JPRB, &
  & 0.29182080E-07_JPRB, 0.31471237E-07_JPRB, 0.33034724E-07_JPRB, 0.34046858E-07_JPRB, 0.34282777E-07_JPRB, 0.34121972E-07_JPRB, &
  & 0.33772740E-07_JPRB, 0.33195498E-07_JPRB, 0.32463441E-07_JPRB, 0.31095105E-07_JPRB, 0.30076203E-07_JPRB, 0.29169870E-07_JPRB, &
  & 0.28085935E-07_JPRB, 0.27299335E-07_JPRB, 0.26545410E-07_JPRB, 0.25857698E-07_JPRB, 0.25282081E-07_JPRB, 0.24991454E-07_JPRB, &
  & 0.24893298E-07_JPRB, 0.24601783E-07_JPRB, 0.24131621E-07_JPRB, 0.23645110E-07_JPRB, 0.23500476E-07_JPRB, 0.23380353E-07_JPRB, &
  & 0.23290970E-07_JPRB, 0.22938271E-07_JPRB, 0.22594120E-07_JPRB, 0.22232636E-07_JPRB  /)

RGHG7(:,76, 1) = (/ &
  & 0.11905274E-07_JPRB, 0.11934135E-07_JPRB, 0.11731317E-07_JPRB, 0.10846875E-07_JPRB, 0.99400601E-08_JPRB, 0.89482623E-08_JPRB, &
  & 0.78749066E-08_JPRB, 0.64458343E-08_JPRB, 0.51270310E-08_JPRB, 0.47690583E-08_JPRB, 0.47370814E-08_JPRB, 0.48725346E-08_JPRB, &
  & 0.51498434E-08_JPRB, 0.55532770E-08_JPRB, 0.62107519E-08_JPRB, 0.69933120E-08_JPRB, 0.80537351E-08_JPRB, 0.95048645E-08_JPRB, &
  & 0.11178139E-07_JPRB, 0.12635077E-07_JPRB, 0.13951711E-07_JPRB, 0.14557710E-07_JPRB, 0.14964637E-07_JPRB, 0.15330095E-07_JPRB, &
  & 0.15750097E-07_JPRB, 0.16088115E-07_JPRB, 0.16553393E-07_JPRB, 0.16005576E-07_JPRB, 0.14616290E-07_JPRB, 0.14123482E-07_JPRB, &
  & 0.14333073E-07_JPRB, 0.14981855E-07_JPRB, 0.16581489E-07_JPRB, 0.19551003E-07_JPRB, 0.23483221E-07_JPRB, 0.26024222E-07_JPRB, &
  & 0.28306350E-07_JPRB, 0.30542134E-07_JPRB, 0.32131487E-07_JPRB, 0.33111597E-07_JPRB, 0.33403351E-07_JPRB, 0.33327942E-07_JPRB, &
  & 0.33099002E-07_JPRB, 0.32630557E-07_JPRB, 0.31962546E-07_JPRB, 0.30608990E-07_JPRB, 0.29522758E-07_JPRB, 0.28602876E-07_JPRB, &
  & 0.27512372E-07_JPRB, 0.26732752E-07_JPRB, 0.25969794E-07_JPRB, 0.25250059E-07_JPRB, 0.24643240E-07_JPRB, 0.24323874E-07_JPRB, &
  & 0.24212170E-07_JPRB, 0.23910391E-07_JPRB, 0.23421344E-07_JPRB, 0.22927853E-07_JPRB, 0.22800873E-07_JPRB, 0.22704152E-07_JPRB, &
  & 0.22644739E-07_JPRB, 0.22255911E-07_JPRB, 0.21888769E-07_JPRB, 0.21595437E-07_JPRB  /)

RGHG7(:,77, 1) = (/ &
  & 0.11536067E-07_JPRB, 0.11584361E-07_JPRB, 0.11316422E-07_JPRB, 0.10477322E-07_JPRB, 0.96186117E-08_JPRB, 0.86845529E-08_JPRB, &
  & 0.76318541E-08_JPRB, 0.61734856E-08_JPRB, 0.48836674E-08_JPRB, 0.45052475E-08_JPRB, 0.44368116E-08_JPRB, 0.45609358E-08_JPRB, &
  & 0.48185903E-08_JPRB, 0.51625066E-08_JPRB, 0.57513328E-08_JPRB, 0.64259112E-08_JPRB, 0.73418588E-08_JPRB, 0.85693320E-08_JPRB, &
  & 0.10035907E-07_JPRB, 0.11395687E-07_JPRB, 0.12721910E-07_JPRB, 0.13369439E-07_JPRB, 0.13713563E-07_JPRB, 0.13997746E-07_JPRB, &
  & 0.14394352E-07_JPRB, 0.14726947E-07_JPRB, 0.15132642E-07_JPRB, 0.14820281E-07_JPRB, 0.13782111E-07_JPRB, 0.13399459E-07_JPRB, &
  & 0.13603837E-07_JPRB, 0.14272661E-07_JPRB, 0.15941591E-07_JPRB, 0.19054221E-07_JPRB, 0.23141101E-07_JPRB, 0.25566655E-07_JPRB, &
  & 0.27639234E-07_JPRB, 0.29822465E-07_JPRB, 0.31375258E-07_JPRB, 0.32368305E-07_JPRB, 0.32701289E-07_JPRB, 0.32664707E-07_JPRB, &
  & 0.32507620E-07_JPRB, 0.32123065E-07_JPRB, 0.31524753E-07_JPRB, 0.30172366E-07_JPRB, 0.29004019E-07_JPRB, 0.28056968E-07_JPRB, &
  & 0.26952693E-07_JPRB, 0.26183706E-07_JPRB, 0.25402899E-07_JPRB, 0.24629358E-07_JPRB, 0.23970355E-07_JPRB, 0.23600515E-07_JPRB, &
  & 0.23487311E-07_JPRB, 0.23176307E-07_JPRB, 0.22674818E-07_JPRB, 0.22196365E-07_JPRB, 0.22037135E-07_JPRB, 0.22005616E-07_JPRB, &
  & 0.21959620E-07_JPRB, 0.21561792E-07_JPRB, 0.21181599E-07_JPRB, 0.20976743E-07_JPRB  /)

RGHG7(:,78, 1) = (/ &
  & 0.11140398E-07_JPRB, 0.11176177E-07_JPRB, 0.10858086E-07_JPRB, 0.10106055E-07_JPRB, 0.93140538E-08_JPRB, 0.84378570E-08_JPRB, &
  & 0.74081838E-08_JPRB, 0.59405068E-08_JPRB, 0.46722345E-08_JPRB, 0.42726772E-08_JPRB, 0.41731067E-08_JPRB, 0.42870784E-08_JPRB, &
  & 0.45359836E-08_JPRB, 0.48275536E-08_JPRB, 0.53481753E-08_JPRB, 0.59360694E-08_JPRB, 0.67213924E-08_JPRB, 0.77719180E-08_JPRB, &
  & 0.90809130E-08_JPRB, 0.10388149E-07_JPRB, 0.11719914E-07_JPRB, 0.12389315E-07_JPRB, 0.12721324E-07_JPRB, 0.12935461E-07_JPRB, &
  & 0.13281887E-07_JPRB, 0.13636130E-07_JPRB, 0.13980340E-07_JPRB, 0.13769639E-07_JPRB, 0.13019637E-07_JPRB, 0.12782177E-07_JPRB, &
  & 0.12970583E-07_JPRB, 0.13683737E-07_JPRB, 0.15373315E-07_JPRB, 0.18626920E-07_JPRB, 0.22882526E-07_JPRB, 0.25233376E-07_JPRB, &
  & 0.27115886E-07_JPRB, 0.29234640E-07_JPRB, 0.30736205E-07_JPRB, 0.31701249E-07_JPRB, 0.32102006E-07_JPRB, 0.32095728E-07_JPRB, &
  & 0.32012323E-07_JPRB, 0.31674807E-07_JPRB, 0.31136464E-07_JPRB, 0.29755934E-07_JPRB, 0.28498883E-07_JPRB, 0.27509208E-07_JPRB, &
  & 0.26380768E-07_JPRB, 0.25629715E-07_JPRB, 0.24834078E-07_JPRB, 0.24015779E-07_JPRB, 0.23290147E-07_JPRB, 0.22848463E-07_JPRB, &
  & 0.22732050E-07_JPRB, 0.22420373E-07_JPRB, 0.21899704E-07_JPRB, 0.21437443E-07_JPRB, 0.21272952E-07_JPRB, 0.21273791E-07_JPRB, &
  & 0.21247390E-07_JPRB, 0.20875670E-07_JPRB, 0.20469800E-07_JPRB, 0.20356325E-07_JPRB  /)

RGHG7(:,79, 1) = (/ &
  & 0.10695725E-07_JPRB, 0.10708672E-07_JPRB, 0.10368982E-07_JPRB, 0.97375917E-08_JPRB, 0.90233012E-08_JPRB, 0.82037135E-08_JPRB, &
  & 0.72045741E-08_JPRB, 0.57427442E-08_JPRB, 0.44881110E-08_JPRB, 0.40669489E-08_JPRB, 0.39456361E-08_JPRB, 0.40505051E-08_JPRB, &
  & 0.42925519E-08_JPRB, 0.45410741E-08_JPRB, 0.49986950E-08_JPRB, 0.55158921E-08_JPRB, 0.61907798E-08_JPRB, 0.71122098E-08_JPRB, &
  & 0.83037615E-08_JPRB, 0.96000515E-08_JPRB, 0.10930913E-07_JPRB, 0.11606598E-07_JPRB, 0.11955089E-07_JPRB, 0.12117315E-07_JPRB, &
  & 0.12412051E-07_JPRB, 0.12790107E-07_JPRB, 0.13085990E-07_JPRB, 0.12894752E-07_JPRB, 0.12365142E-07_JPRB, 0.12279262E-07_JPRB, &
  & 0.12452042E-07_JPRB, 0.13207040E-07_JPRB, 0.14885607E-07_JPRB, 0.18273239E-07_JPRB, 0.22693758E-07_JPRB, 0.24996096E-07_JPRB, &
  & 0.26698827E-07_JPRB, 0.28762881E-07_JPRB, 0.30203360E-07_JPRB, 0.31111748E-07_JPRB, 0.31585631E-07_JPRB, 0.31622916E-07_JPRB, &
  & 0.31605485E-07_JPRB, 0.31291782E-07_JPRB, 0.30787127E-07_JPRB, 0.29356619E-07_JPRB, 0.28004209E-07_JPRB, 0.26947941E-07_JPRB, &
  & 0.25792798E-07_JPRB, 0.25062709E-07_JPRB, 0.24253217E-07_JPRB, 0.23398209E-07_JPRB, 0.22600372E-07_JPRB, 0.22076740E-07_JPRB, &
  & 0.21947620E-07_JPRB, 0.21647183E-07_JPRB, 0.21096543E-07_JPRB, 0.20644988E-07_JPRB, 0.20495746E-07_JPRB, 0.20511211E-07_JPRB, &
  & 0.20510718E-07_JPRB, 0.20187169E-07_JPRB, 0.19763537E-07_JPRB, 0.19745308E-07_JPRB  /)

RGHG7(:,80, 1) = (/ &
  & 0.10181169E-07_JPRB, 0.10183464E-07_JPRB, 0.98664658E-08_JPRB, 0.93776868E-08_JPRB, 0.87433332E-08_JPRB, 0.79782518E-08_JPRB, &
  & 0.70232271E-08_JPRB, 0.55765601E-08_JPRB, 0.43283528E-08_JPRB, 0.38855525E-08_JPRB, 0.37551666E-08_JPRB, 0.38519485E-08_JPRB, &
  & 0.40796823E-08_JPRB, 0.42964105E-08_JPRB, 0.47023471E-08_JPRB, 0.51593499E-08_JPRB, 0.57518130E-08_JPRB, 0.65889722E-08_JPRB, &
  & 0.76844040E-08_JPRB, 0.90055360E-08_JPRB, 0.10332818E-07_JPRB, 0.11010533E-07_JPRB, 0.11377241E-07_JPRB, 0.11514415E-07_JPRB, &
  & 0.11780434E-07_JPRB, 0.12156725E-07_JPRB, 0.12431082E-07_JPRB, 0.12237151E-07_JPRB, 0.11861454E-07_JPRB, 0.11898793E-07_JPRB, &
  & 0.12065934E-07_JPRB, 0.12830531E-07_JPRB, 0.14485242E-07_JPRB, 0.17994906E-07_JPRB, 0.22559804E-07_JPRB, 0.24823247E-07_JPRB, &
  & 0.26348528E-07_JPRB, 0.28393411E-07_JPRB, 0.29764767E-07_JPRB, 0.30607659E-07_JPRB, 0.31133131E-07_JPRB, 0.31249039E-07_JPRB, &
  & 0.31275988E-07_JPRB, 0.30979664E-07_JPRB, 0.30465612E-07_JPRB, 0.28973568E-07_JPRB, 0.27518835E-07_JPRB, 0.26363073E-07_JPRB, &
  & 0.25188055E-07_JPRB, 0.24477501E-07_JPRB, 0.23652035E-07_JPRB, 0.22764543E-07_JPRB, 0.21899122E-07_JPRB, 0.21296575E-07_JPRB, &
  & 0.21138015E-07_JPRB, 0.20863403E-07_JPRB, 0.20268425E-07_JPRB, 0.19816664E-07_JPRB, 0.19690180E-07_JPRB, 0.19724748E-07_JPRB, &
  & 0.19754625E-07_JPRB, 0.19486055E-07_JPRB, 0.19076468E-07_JPRB, 0.19159155E-07_JPRB  /)

RGHG7(:,81, 1) = (/ &
  & 0.96728739E-08_JPRB, 0.96658809E-08_JPRB, 0.93898336E-08_JPRB, 0.90230627E-08_JPRB, 0.84549904E-08_JPRB, 0.77363480E-08_JPRB, &
  & 0.68311398E-08_JPRB, 0.54317562E-08_JPRB, 0.42000137E-08_JPRB, 0.37318830E-08_JPRB, 0.35985419E-08_JPRB, 0.36792812E-08_JPRB, &
  & 0.38922389E-08_JPRB, 0.41017902E-08_JPRB, 0.44676202E-08_JPRB, 0.49035144E-08_JPRB, 0.54643144E-08_JPRB, 0.62512351E-08_JPRB, &
  & 0.72833408E-08_JPRB, 0.86044729E-08_JPRB, 0.99195122E-08_JPRB, 0.10600604E-07_JPRB, 0.10967313E-07_JPRB, 0.11087599E-07_JPRB, &
  & 0.11331665E-07_JPRB, 0.11682626E-07_JPRB, 0.11922365E-07_JPRB, 0.11745743E-07_JPRB, 0.11481921E-07_JPRB, 0.11635780E-07_JPRB, &
  & 0.11789834E-07_JPRB, 0.12548099E-07_JPRB, 0.14189722E-07_JPRB, 0.17811262E-07_JPRB, 0.22454685E-07_JPRB, 0.24681821E-07_JPRB, &
  & 0.26021345E-07_JPRB, 0.28007968E-07_JPRB, 0.29377636E-07_JPRB, 0.30192664E-07_JPRB, 0.30766263E-07_JPRB, 0.30954363E-07_JPRB, &
  & 0.31009176E-07_JPRB, 0.30713696E-07_JPRB, 0.30154894E-07_JPRB, 0.28581370E-07_JPRB, 0.27028271E-07_JPRB, 0.25780053E-07_JPRB, &
  & 0.24570839E-07_JPRB, 0.23819756E-07_JPRB, 0.22979936E-07_JPRB, 0.22108065E-07_JPRB, 0.21147655E-07_JPRB, 0.20462784E-07_JPRB, &
  & 0.20239210E-07_JPRB, 0.20020324E-07_JPRB, 0.19394105E-07_JPRB, 0.18890839E-07_JPRB, 0.18799818E-07_JPRB, 0.18863938E-07_JPRB, &
  & 0.18950386E-07_JPRB, 0.18688993E-07_JPRB, 0.18350753E-07_JPRB, 0.18545317E-07_JPRB  /)

RGHG7(:,82, 1) = (/ &
  & 0.92252379E-08_JPRB, 0.91799302E-08_JPRB, 0.89393367E-08_JPRB, 0.86763431E-08_JPRB, 0.81578406E-08_JPRB, 0.74838864E-08_JPRB, &
  & 0.66182872E-08_JPRB, 0.52853729E-08_JPRB, 0.40691174E-08_JPRB, 0.35953058E-08_JPRB, 0.34628096E-08_JPRB, 0.35363345E-08_JPRB, &
  & 0.37346106E-08_JPRB, 0.39428479E-08_JPRB, 0.42845342E-08_JPRB, 0.47107981E-08_JPRB, 0.52578799E-08_JPRB, 0.60102983E-08_JPRB, &
  & 0.69914077E-08_JPRB, 0.82939246E-08_JPRB, 0.95976717E-08_JPRB, 0.10271649E-07_JPRB, 0.10639811E-07_JPRB, 0.10758734E-07_JPRB, &
  & 0.10973716E-07_JPRB, 0.11288455E-07_JPRB, 0.11501069E-07_JPRB, 0.11349498E-07_JPRB, 0.11177351E-07_JPRB, 0.11402774E-07_JPRB, &
  & 0.11533644E-07_JPRB, 0.12299578E-07_JPRB, 0.13958738E-07_JPRB, 0.17684168E-07_JPRB, 0.22364602E-07_JPRB, 0.24543156E-07_JPRB, &
  & 0.25719052E-07_JPRB, 0.27599795E-07_JPRB, 0.28992799E-07_JPRB, 0.29848495E-07_JPRB, 0.30452753E-07_JPRB, 0.30706476E-07_JPRB, &
  & 0.30758142E-07_JPRB, 0.30460303E-07_JPRB, 0.29856454E-07_JPRB, 0.28198190E-07_JPRB, 0.26550552E-07_JPRB, 0.25252062E-07_JPRB, &
  & 0.23991418E-07_JPRB, 0.23153818E-07_JPRB, 0.22299736E-07_JPRB, 0.21449203E-07_JPRB, 0.20399937E-07_JPRB, 0.19601272E-07_JPRB, &
  & 0.19320952E-07_JPRB, 0.19144931E-07_JPRB, 0.18514139E-07_JPRB, 0.17970749E-07_JPRB, 0.17905947E-07_JPRB, 0.17977907E-07_JPRB, &
  & 0.18138307E-07_JPRB, 0.17887245E-07_JPRB, 0.17617570E-07_JPRB, 0.17883156E-07_JPRB  /)

RGHG7(:,83, 1) = (/ &
  & 0.88107027E-08_JPRB, 0.87227039E-08_JPRB, 0.85085264E-08_JPRB, 0.83404664E-08_JPRB, 0.78622038E-08_JPRB, 0.72216136E-08_JPRB, &
  & 0.63862827E-08_JPRB, 0.51355602E-08_JPRB, 0.39341183E-08_JPRB, 0.34683745E-08_JPRB, 0.33428857E-08_JPRB, 0.34203338E-08_JPRB, &
  & 0.36074347E-08_JPRB, 0.38180479E-08_JPRB, 0.41463856E-08_JPRB, 0.45672683E-08_JPRB, 0.51088488E-08_JPRB, 0.58384863E-08_JPRB, &
  & 0.67850513E-08_JPRB, 0.80569183E-08_JPRB, 0.93522672E-08_JPRB, 0.10022492E-07_JPRB, 0.10396280E-07_JPRB, 0.10528345E-07_JPRB, &
  & 0.10722899E-07_JPRB, 0.11006218E-07_JPRB, 0.11211074E-07_JPRB, 0.11093268E-07_JPRB, 0.10986240E-07_JPRB, 0.11226667E-07_JPRB, &
  & 0.11309620E-07_JPRB, 0.12089119E-07_JPRB, 0.13799363E-07_JPRB, 0.17611573E-07_JPRB, 0.22286395E-07_JPRB, 0.24403877E-07_JPRB, &
  & 0.25453768E-07_JPRB, 0.27224104E-07_JPRB, 0.28624953E-07_JPRB, 0.29560936E-07_JPRB, 0.30195001E-07_JPRB, 0.30492266E-07_JPRB, &
  & 0.30518916E-07_JPRB, 0.30204442E-07_JPRB, 0.29560825E-07_JPRB, 0.27829924E-07_JPRB, 0.26095582E-07_JPRB, 0.24770795E-07_JPRB, &
  & 0.23454562E-07_JPRB, 0.22512825E-07_JPRB, 0.21617208E-07_JPRB, 0.20779589E-07_JPRB, 0.19649307E-07_JPRB, 0.18746815E-07_JPRB, &
  & 0.18424141E-07_JPRB, 0.18263066E-07_JPRB, 0.17633705E-07_JPRB, 0.17063592E-07_JPRB, 0.17015358E-07_JPRB, 0.17097255E-07_JPRB, &
  & 0.17345214E-07_JPRB, 0.17089525E-07_JPRB, 0.16856850E-07_JPRB, 0.17185092E-07_JPRB  /)

RGHG7(:,84, 1) = (/ &
  & 0.84096982E-08_JPRB, 0.82937054E-08_JPRB, 0.80942209E-08_JPRB, 0.80184918E-08_JPRB, 0.75787301E-08_JPRB, 0.69531191E-08_JPRB, &
  & 0.61402869E-08_JPRB, 0.49816918E-08_JPRB, 0.37955148E-08_JPRB, 0.33458116E-08_JPRB, 0.32350252E-08_JPRB, 0.33279735E-08_JPRB, &
  & 0.35101736E-08_JPRB, 0.37248867E-08_JPRB, 0.40463276E-08_JPRB, 0.44604978E-08_JPRB, 0.49966245E-08_JPRB, 0.57112449E-08_JPRB, &
  & 0.66404377E-08_JPRB, 0.78757900E-08_JPRB, 0.91661968E-08_JPRB, 0.98445489E-08_JPRB, 0.10229228E-07_JPRB, 0.10385819E-07_JPRB, &
  & 0.10578730E-07_JPRB, 0.10846896E-07_JPRB, 0.11068208E-07_JPRB, 0.10990391E-07_JPRB, 0.10919020E-07_JPRB, 0.11118768E-07_JPRB, &
  & 0.11124474E-07_JPRB, 0.11913178E-07_JPRB, 0.13702268E-07_JPRB, 0.17575217E-07_JPRB, 0.22209249E-07_JPRB, 0.24260653E-07_JPRB, &
  & 0.25232257E-07_JPRB, 0.26921592E-07_JPRB, 0.28286715E-07_JPRB, 0.29314229E-07_JPRB, 0.29988549E-07_JPRB, 0.30297285E-07_JPRB, &
  & 0.30286825E-07_JPRB, 0.29936192E-07_JPRB, 0.29263068E-07_JPRB, 0.27480919E-07_JPRB, 0.25672679E-07_JPRB, 0.24328737E-07_JPRB, &
  & 0.22963451E-07_JPRB, 0.21924374E-07_JPRB, 0.20943797E-07_JPRB, 0.20101214E-07_JPRB, 0.18903829E-07_JPRB, 0.17933393E-07_JPRB, &
  & 0.17581359E-07_JPRB, 0.17399435E-07_JPRB, 0.16762720E-07_JPRB, 0.16176128E-07_JPRB, 0.16138556E-07_JPRB, 0.16253316E-07_JPRB, &
  & 0.16596199E-07_JPRB, 0.16306844E-07_JPRB, 0.16059622E-07_JPRB, 0.16466494E-07_JPRB  /)

RGHG7(:,85, 1) = (/ &
  & 0.80102178E-08_JPRB, 0.78891181E-08_JPRB, 0.76845268E-08_JPRB, 0.76930608E-08_JPRB, 0.73184116E-08_JPRB, 0.66796079E-08_JPRB, &
  & 0.58893309E-08_JPRB, 0.48115944E-08_JPRB, 0.36556331E-08_JPRB, 0.32233783E-08_JPRB, 0.31398285E-08_JPRB, 0.32540554E-08_JPRB, &
  & 0.34443413E-08_JPRB, 0.36633101E-08_JPRB, 0.39851766E-08_JPRB, 0.43899843E-08_JPRB, 0.49120671E-08_JPRB, 0.56134948E-08_JPRB, &
  & 0.65222601E-08_JPRB, 0.77193110E-08_JPRB, 0.89978018E-08_JPRB, 0.96770050E-08_JPRB, 0.10070195E-07_JPRB, 0.10244661E-07_JPRB, &
  & 0.10442253E-07_JPRB, 0.10714249E-07_JPRB, 0.10940668E-07_JPRB, 0.10875618E-07_JPRB, 0.10815312E-07_JPRB, 0.10997186E-07_JPRB, &
  & 0.10952249E-07_JPRB, 0.11689033E-07_JPRB, 0.13510466E-07_JPRB, 0.17376607E-07_JPRB, 0.22010213E-07_JPRB, 0.24082044E-07_JPRB, &
  & 0.25030668E-07_JPRB, 0.26690213E-07_JPRB, 0.27978732E-07_JPRB, 0.29051357E-07_JPRB, 0.29768660E-07_JPRB, 0.30056968E-07_JPRB, &
  & 0.30017569E-07_JPRB, 0.29634593E-07_JPRB, 0.28956788E-07_JPRB, 0.27121442E-07_JPRB, 0.25280008E-07_JPRB, 0.23892232E-07_JPRB, &
  & 0.22491198E-07_JPRB, 0.21387009E-07_JPRB, 0.20297485E-07_JPRB, 0.19436177E-07_JPRB, 0.18254964E-07_JPRB, 0.17190051E-07_JPRB, &
  & 0.16745668E-07_JPRB, 0.16523740E-07_JPRB, 0.15879790E-07_JPRB, 0.15229788E-07_JPRB, 0.15248392E-07_JPRB, 0.15475503E-07_JPRB, &
  & 0.15894563E-07_JPRB, 0.15511581E-07_JPRB, 0.15181799E-07_JPRB, 0.15694638E-07_JPRB  /)

RGHG7(:,86, 1) = (/ &
  & 0.76119601E-08_JPRB, 0.75033779E-08_JPRB, 0.72869935E-08_JPRB, 0.73678948E-08_JPRB, 0.70780024E-08_JPRB, 0.64312676E-08_JPRB, &
  & 0.56633269E-08_JPRB, 0.46458773E-08_JPRB, 0.35246136E-08_JPRB, 0.31049001E-08_JPRB, 0.30583821E-08_JPRB, 0.31926630E-08_JPRB, &
  & 0.33900766E-08_JPRB, 0.36126566E-08_JPRB, 0.39422773E-08_JPRB, 0.43383411E-08_JPRB, 0.48409808E-08_JPRB, 0.55324793E-08_JPRB, &
  & 0.64197149E-08_JPRB, 0.75845981E-08_JPRB, 0.88467834E-08_JPRB, 0.95198486E-08_JPRB, 0.99136010E-08_JPRB, 0.10103700E-07_JPRB, &
  & 0.10306330E-07_JPRB, 0.10591167E-07_JPRB, 0.10819721E-07_JPRB, 0.10765504E-07_JPRB, 0.10708993E-07_JPRB, 0.10875234E-07_JPRB, &
  & 0.10801377E-07_JPRB, 0.11486646E-07_JPRB, 0.13316275E-07_JPRB, 0.17137274E-07_JPRB, 0.21736152E-07_JPRB, 0.23857153E-07_JPRB, &
  & 0.24802328E-07_JPRB, 0.26424939E-07_JPRB, 0.27657116E-07_JPRB, 0.28737447E-07_JPRB, 0.29469977E-07_JPRB, 0.29720104E-07_JPRB, &
  & 0.29669603E-07_JPRB, 0.29270106E-07_JPRB, 0.28603580E-07_JPRB, 0.26743742E-07_JPRB, 0.24870277E-07_JPRB, 0.23445107E-07_JPRB, &
  & 0.22035119E-07_JPRB, 0.20890798E-07_JPRB, 0.19708761E-07_JPRB, 0.18825969E-07_JPRB, 0.17732942E-07_JPRB, 0.16498145E-07_JPRB, &
  & 0.15934304E-07_JPRB, 0.15663179E-07_JPRB, 0.15025612E-07_JPRB, 0.14283239E-07_JPRB, 0.14384944E-07_JPRB, 0.14775593E-07_JPRB, &
  & 0.15204278E-07_JPRB, 0.14785476E-07_JPRB, 0.14345408E-07_JPRB, 0.14940773E-07_JPRB  /)

RGHG7(:,87, 1) = (/ &
  & 0.72207869E-08_JPRB, 0.71246939E-08_JPRB, 0.68981779E-08_JPRB, 0.70259589E-08_JPRB, 0.68470183E-08_JPRB, 0.61986455E-08_JPRB, &
  & 0.54557334E-08_JPRB, 0.44856933E-08_JPRB, 0.33900551E-08_JPRB, 0.29951622E-08_JPRB, 0.29886010E-08_JPRB, 0.31419779E-08_JPRB, &
  & 0.33452334E-08_JPRB, 0.35699583E-08_JPRB, 0.39073530E-08_JPRB, 0.42969460E-08_JPRB, 0.47807386E-08_JPRB, 0.54584580E-08_JPRB, &
  & 0.63266429E-08_JPRB, 0.74602394E-08_JPRB, 0.87026183E-08_JPRB, 0.93676514E-08_JPRB, 0.97581140E-08_JPRB, 0.99629735E-08_JPRB, &
  & 0.10168377E-07_JPRB, 0.10463975E-07_JPRB, 0.10688511E-07_JPRB, 0.10650929E-07_JPRB, 0.10591720E-07_JPRB, 0.10738322E-07_JPRB, &
  & 0.10646098E-07_JPRB, 0.11286555E-07_JPRB, 0.13098639E-07_JPRB, 0.16867165E-07_JPRB, 0.21404012E-07_JPRB, 0.23561938E-07_JPRB, &
  & 0.24512389E-07_JPRB, 0.26087708E-07_JPRB, 0.27255986E-07_JPRB, 0.28306668E-07_JPRB, 0.29018200E-07_JPRB, 0.29224674E-07_JPRB, &
  & 0.29176295E-07_JPRB, 0.28793016E-07_JPRB, 0.28151655E-07_JPRB, 0.26295931E-07_JPRB, 0.24404289E-07_JPRB, 0.22971223E-07_JPRB, &
  & 0.21576118E-07_JPRB, 0.20418969E-07_JPRB, 0.19166060E-07_JPRB, 0.18269326E-07_JPRB, 0.17271784E-07_JPRB, 0.15806218E-07_JPRB, &
  & 0.15126883E-07_JPRB, 0.14759955E-07_JPRB, 0.14180488E-07_JPRB, 0.13369066E-07_JPRB, 0.13578610E-07_JPRB, 0.14117601E-07_JPRB, &
  & 0.14534290E-07_JPRB, 0.14128535E-07_JPRB, 0.13605377E-07_JPRB, 0.14266102E-07_JPRB  /)

RGHG7(:,88, 1) = (/ &
  & 0.68343789E-08_JPRB, 0.67563716E-08_JPRB, 0.65011497E-08_JPRB, 0.66561750E-08_JPRB, 0.66116409E-08_JPRB, 0.59694666E-08_JPRB, &
  & 0.52621628E-08_JPRB, 0.43348986E-08_JPRB, 0.32478474E-08_JPRB, 0.28980413E-08_JPRB, 0.29307874E-08_JPRB, 0.31015704E-08_JPRB, &
  & 0.33086515E-08_JPRB, 0.35332382E-08_JPRB, 0.38754995E-08_JPRB, 0.42600185E-08_JPRB, 0.47274388E-08_JPRB, 0.53846076E-08_JPRB, &
  & 0.62377924E-08_JPRB, 0.73355545E-08_JPRB, 0.85555771E-08_JPRB, 0.92075726E-08_JPRB, 0.95964370E-08_JPRB, 0.98113321E-08_JPRB, &
  & 0.10018108E-07_JPRB, 0.10313655E-07_JPRB, 0.10530733E-07_JPRB, 0.10516679E-07_JPRB, 0.10450453E-07_JPRB, 0.10567576E-07_JPRB, &
  & 0.10463150E-07_JPRB, 0.11065858E-07_JPRB, 0.12827662E-07_JPRB, 0.16542802E-07_JPRB, 0.21002862E-07_JPRB, 0.23159603E-07_JPRB, &
  & 0.24128788E-07_JPRB, 0.25629614E-07_JPRB, 0.26699926E-07_JPRB, 0.27664392E-07_JPRB, 0.28311664E-07_JPRB, 0.28473032E-07_JPRB, &
  & 0.28432104E-07_JPRB, 0.28114370E-07_JPRB, 0.27498148E-07_JPRB, 0.25691163E-07_JPRB, 0.23814170E-07_JPRB, 0.22433748E-07_JPRB, &
  & 0.21070099E-07_JPRB, 0.19944469E-07_JPRB, 0.18642411E-07_JPRB, 0.17741596E-07_JPRB, 0.16827433E-07_JPRB, 0.15077389E-07_JPRB, &
  & 0.14263031E-07_JPRB, 0.13741977E-07_JPRB, 0.13274789E-07_JPRB, 0.12484641E-07_JPRB, 0.12820849E-07_JPRB, 0.13472073E-07_JPRB, &
  & 0.13876237E-07_JPRB, 0.13527896E-07_JPRB, 0.12983516E-07_JPRB, 0.13707665E-07_JPRB  /)

RGHG7(:,89, 1) = (/ &
  & 0.64677765E-08_JPRB, 0.64370121E-08_JPRB, 0.60863709E-08_JPRB, 0.62738258E-08_JPRB, 0.63637530E-08_JPRB, 0.57387892E-08_JPRB, &
  & 0.50870838E-08_JPRB, 0.42066338E-08_JPRB, 0.31105028E-08_JPRB, 0.28222434E-08_JPRB, 0.28886919E-08_JPRB, 0.30727395E-08_JPRB, &
  & 0.32806500E-08_JPRB, 0.35020051E-08_JPRB, 0.38468355E-08_JPRB, 0.42238763E-08_JPRB, 0.46767071E-08_JPRB, 0.53091103E-08_JPRB, &
  & 0.61502176E-08_JPRB, 0.72031578E-08_JPRB, 0.83990444E-08_JPRB, 0.90237722E-08_JPRB, 0.94194143E-08_JPRB, 0.96303155E-08_JPRB, &
  & 0.98383643E-08_JPRB, 0.10118841E-07_JPRB, 0.10336014E-07_JPRB, 0.10345586E-07_JPRB, 0.10273678E-07_JPRB, 0.10348010E-07_JPRB, &
  & 0.10237655E-07_JPRB, 0.10807117E-07_JPRB, 0.12484387E-07_JPRB, 0.16134216E-07_JPRB, 0.20523787E-07_JPRB, 0.22620222E-07_JPRB, &
  & 0.23646934E-07_JPRB, 0.25020125E-07_JPRB, 0.25931317E-07_JPRB, 0.26711442E-07_JPRB, 0.27230981E-07_JPRB, 0.27343576E-07_JPRB, &
  & 0.27300666E-07_JPRB, 0.27100607E-07_JPRB, 0.26503422E-07_JPRB, 0.24814683E-07_JPRB, 0.23014411E-07_JPRB, 0.21785040E-07_JPRB, &
  & 0.20463548E-07_JPRB, 0.19439605E-07_JPRB, 0.18108910E-07_JPRB, 0.17219290E-07_JPRB, 0.16379634E-07_JPRB, 0.14339575E-07_JPRB, &
  & 0.13287136E-07_JPRB, 0.12564866E-07_JPRB, 0.12231523E-07_JPRB, 0.11637643E-07_JPRB, 0.12117032E-07_JPRB, 0.12854373E-07_JPRB, &
  & 0.13245049E-07_JPRB, 0.12975573E-07_JPRB, 0.12504499E-07_JPRB, 0.13312554E-07_JPRB  /)

RGHG7(:,90, 1) = (/ &
  & 0.61575228E-08_JPRB, 0.61843371E-08_JPRB, 0.56739144E-08_JPRB, 0.58953480E-08_JPRB, 0.61015391E-08_JPRB, 0.55179069E-08_JPRB, &
  & 0.49267677E-08_JPRB, 0.40931878E-08_JPRB, 0.29940535E-08_JPRB, 0.27707308E-08_JPRB, 0.28578831E-08_JPRB, 0.30518071E-08_JPRB, &
  & 0.32597344E-08_JPRB, 0.34751502E-08_JPRB, 0.38238337E-08_JPRB, 0.41873430E-08_JPRB, 0.46262257E-08_JPRB, 0.52359026E-08_JPRB, &
  & 0.60565378E-08_JPRB, 0.70586204E-08_JPRB, 0.82167979E-08_JPRB, 0.88056711E-08_JPRB, 0.92055157E-08_JPRB, 0.94003454E-08_JPRB, &
  & 0.95903638E-08_JPRB, 0.98675115E-08_JPRB, 0.10103212E-07_JPRB, 0.10133058E-07_JPRB, 0.10062605E-07_JPRB, 0.10089485E-07_JPRB, &
  & 0.99781968E-08_JPRB, 0.10524591E-07_JPRB, 0.12126588E-07_JPRB, 0.15694192E-07_JPRB, 0.19986691E-07_JPRB, 0.21940013E-07_JPRB, &
  & 0.23111746E-07_JPRB, 0.24317121E-07_JPRB, 0.24999086E-07_JPRB, 0.25439200E-07_JPRB, 0.25647646E-07_JPRB, 0.25689368E-07_JPRB, &
  & 0.25621114E-07_JPRB, 0.25529091E-07_JPRB, 0.25094322E-07_JPRB, 0.23561339E-07_JPRB, 0.21915438E-07_JPRB, 0.20919585E-07_JPRB, &
  & 0.19718319E-07_JPRB, 0.18847462E-07_JPRB, 0.17528248E-07_JPRB, 0.16725992E-07_JPRB, 0.15903526E-07_JPRB, 0.13732511E-07_JPRB, &
  & 0.12252459E-07_JPRB, 0.11225910E-07_JPRB, 0.11076742E-07_JPRB, 0.10815852E-07_JPRB, 0.11559611E-07_JPRB, 0.12356798E-07_JPRB, &
  & 0.12682685E-07_JPRB, 0.12428517E-07_JPRB, 0.12186767E-07_JPRB, 0.13086153E-07_JPRB  /)

RGHG7(:,91, 1) = (/ &
  & 0.59523226E-08_JPRB, 0.59643279E-08_JPRB, 0.53274997E-08_JPRB, 0.54764750E-08_JPRB, 0.57487777E-08_JPRB, 0.52936665E-08_JPRB, &
  & 0.47665234E-08_JPRB, 0.39921795E-08_JPRB, 0.28898719E-08_JPRB, 0.27310741E-08_JPRB, 0.28303910E-08_JPRB, 0.30306617E-08_JPRB, &
  & 0.32391179E-08_JPRB, 0.34503026E-08_JPRB, 0.37984572E-08_JPRB, 0.41471574E-08_JPRB, 0.45733467E-08_JPRB, 0.51528767E-08_JPRB, &
  & 0.59534140E-08_JPRB, 0.68925583E-08_JPRB, 0.80057798E-08_JPRB, 0.85623906E-08_JPRB, 0.89574751E-08_JPRB, 0.91184557E-08_JPRB, &
  & 0.92434203E-08_JPRB, 0.95528304E-08_JPRB, 0.98387755E-08_JPRB, 0.98977108E-08_JPRB, 0.98425954E-08_JPRB, 0.98224046E-08_JPRB, &
  & 0.97121739E-08_JPRB, 0.10263328E-07_JPRB, 0.11825658E-07_JPRB, 0.15302292E-07_JPRB, 0.19493244E-07_JPRB, 0.21266213E-07_JPRB, &
  & 0.22647918E-07_JPRB, 0.23748042E-07_JPRB, 0.24218979E-07_JPRB, 0.24204245E-07_JPRB, 0.24000154E-07_JPRB, 0.23912297E-07_JPRB, &
  & 0.23533583E-07_JPRB, 0.23705478E-07_JPRB, 0.23601796E-07_JPRB, 0.21961977E-07_JPRB, 0.20485321E-07_JPRB, 0.19576736E-07_JPRB, &
  & 0.18627223E-07_JPRB, 0.18067884E-07_JPRB, 0.16912098E-07_JPRB, 0.16210332E-07_JPRB, 0.15350314E-07_JPRB, 0.13275029E-07_JPRB, &
  & 0.11293058E-07_JPRB, 0.98857054E-08_JPRB, 0.97476441E-08_JPRB, 0.99490063E-08_JPRB, 0.11035489E-07_JPRB, 0.11813107E-07_JPRB, &
  & 0.11987730E-07_JPRB, 0.11789096E-07_JPRB, 0.11959353E-07_JPRB, 0.12947065E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ---GEMS----

RGHG7(:, 1, 2) = (/ &
  & 0.82067928E-07_JPRB, 0.72492426E-07_JPRB, 0.69881800E-07_JPRB, 0.69057322E-07_JPRB, 0.69081104E-07_JPRB, 0.68799039E-07_JPRB, &
  & 0.68737997E-07_JPRB, 0.68663098E-07_JPRB, 0.68745621E-07_JPRB, 0.68859570E-07_JPRB, 0.69143681E-07_JPRB, 0.69368220E-07_JPRB, &
  & 0.69803527E-07_JPRB, 0.69969687E-07_JPRB, 0.70205154E-07_JPRB, 0.70305546E-07_JPRB, 0.70471231E-07_JPRB, 0.70464473E-07_JPRB, &
  & 0.70536892E-07_JPRB, 0.70560674E-07_JPRB, 0.70287527E-07_JPRB, 0.69973701E-07_JPRB, 0.69467909E-07_JPRB, 0.68916933E-07_JPRB, &
  & 0.68334636E-07_JPRB, 0.67752985E-07_JPRB, 0.67240109E-07_JPRB, 0.66843505E-07_JPRB, 0.66599824E-07_JPRB, 0.66540132E-07_JPRB, &
  & 0.66679199E-07_JPRB, 0.67012287E-07_JPRB, 0.67526315E-07_JPRB, 0.68160467E-07_JPRB, 0.68740150E-07_JPRB, 0.69286088E-07_JPRB, &
  & 0.69699517E-07_JPRB, 0.69953771E-07_JPRB, 0.70040841E-07_JPRB, 0.69986882E-07_JPRB, 0.69827706E-07_JPRB, 0.69601548E-07_JPRB, &
  & 0.69320826E-07_JPRB, 0.69002830E-07_JPRB, 0.68653833E-07_JPRB, 0.68357664E-07_JPRB, 0.68115817E-07_JPRB, 0.67963278E-07_JPRB, &
  & 0.67830143E-07_JPRB, 0.67779347E-07_JPRB, 0.67826946E-07_JPRB, 0.68001476E-07_JPRB, 0.68326308E-07_JPRB, 0.68839412E-07_JPRB, &
  & 0.69586861E-07_JPRB, 0.70552318E-07_JPRB, 0.71707788E-07_JPRB, 0.72776984E-07_JPRB, 0.73578889E-07_JPRB, 0.74598709E-07_JPRB, &
  & 0.14227939E-06_JPRB, 0.64376050E-05_JPRB, 0.66556468E-05_JPRB, 0.71551576E-05_JPRB  /)

RGHG7(:, 2, 2) = (/ &
  & 0.19003399E-06_JPRB, 0.18295269E-06_JPRB, 0.17830968E-06_JPRB, 0.18002467E-06_JPRB, 0.18227288E-06_JPRB, 0.18196414E-06_JPRB, &
  & 0.18042431E-06_JPRB, 0.17850448E-06_JPRB, 0.18020444E-06_JPRB, 0.18044925E-06_JPRB, 0.18329973E-06_JPRB, 0.18783489E-06_JPRB, &
  & 0.19178314E-06_JPRB, 0.19127482E-06_JPRB, 0.19159901E-06_JPRB, 0.18959939E-06_JPRB, 0.19004719E-06_JPRB, 0.19037442E-06_JPRB, &
  & 0.19464620E-06_JPRB, 0.20068194E-06_JPRB, 0.20108698E-06_JPRB, 0.20315223E-06_JPRB, 0.20431726E-06_JPRB, 0.20515996E-06_JPRB, &
  & 0.20566897E-06_JPRB, 0.20573157E-06_JPRB, 0.20548862E-06_JPRB, 0.20523188E-06_JPRB, 0.20518439E-06_JPRB, 0.20545770E-06_JPRB, &
  & 0.20618958E-06_JPRB, 0.20792729E-06_JPRB, 0.21321961E-06_JPRB, 0.22165385E-06_JPRB, 0.22328700E-06_JPRB, 0.22495939E-06_JPRB, &
  & 0.22555632E-06_JPRB, 0.22561996E-06_JPRB, 0.22500157E-06_JPRB, 0.22414842E-06_JPRB, 0.22384354E-06_JPRB, 0.22457790E-06_JPRB, &
  & 0.22654957E-06_JPRB, 0.22997658E-06_JPRB, 0.23509077E-06_JPRB, 0.24227654E-06_JPRB, 0.25168333E-06_JPRB, 0.26441668E-06_JPRB, &
  & 0.27301760E-06_JPRB, 0.28033242E-06_JPRB, 0.28835177E-06_JPRB, 0.30005597E-06_JPRB, 0.31939362E-06_JPRB, 0.35094112E-06_JPRB, &
  & 0.39943413E-06_JPRB, 0.46624439E-06_JPRB, 0.54876301E-06_JPRB, 0.62554494E-06_JPRB, 0.67918734E-06_JPRB, 0.73911906E-06_JPRB, &
  & 0.34298632E-05_JPRB, 0.23479452E-04_JPRB, 0.23262621E-04_JPRB, 0.22969967E-04_JPRB  /)

RGHG7(:, 3, 2) = (/ &
  & 0.31718378E-06_JPRB, 0.31896718E-06_JPRB, 0.32188640E-06_JPRB, 0.34727304E-06_JPRB, 0.36959938E-06_JPRB, 0.38205619E-06_JPRB, &
  & 0.38681375E-06_JPRB, 0.37989437E-06_JPRB, 0.37296132E-06_JPRB, 0.36820157E-06_JPRB, 0.36930160E-06_JPRB, 0.37869341E-06_JPRB, &
  & 0.38019485E-06_JPRB, 0.37847391E-06_JPRB, 0.37751624E-06_JPRB, 0.37617122E-06_JPRB, 0.37594327E-06_JPRB, 0.37921276E-06_JPRB, &
  & 0.39082022E-06_JPRB, 0.39770188E-06_JPRB, 0.39982916E-06_JPRB, 0.40170943E-06_JPRB, 0.40154546E-06_JPRB, 0.40342337E-06_JPRB, &
  & 0.40253383E-06_JPRB, 0.40209397E-06_JPRB, 0.40138332E-06_JPRB, 0.40059336E-06_JPRB, 0.40099621E-06_JPRB, 0.40180078E-06_JPRB, &
  & 0.40394039E-06_JPRB, 0.40811810E-06_JPRB, 0.41858505E-06_JPRB, 0.43038818E-06_JPRB, 0.43099274E-06_JPRB, 0.43394107E-06_JPRB, &
  & 0.43423384E-06_JPRB, 0.43484002E-06_JPRB, 0.43426934E-06_JPRB, 0.43369275E-06_JPRB, 0.43464263E-06_JPRB, 0.43742460E-06_JPRB, &
  & 0.44202673E-06_JPRB, 0.44880730E-06_JPRB, 0.45810492E-06_JPRB, 0.47080442E-06_JPRB, 0.48725940E-06_JPRB, 0.50969771E-06_JPRB, &
  & 0.53055254E-06_JPRB, 0.55805788E-06_JPRB, 0.59096288E-06_JPRB, 0.63021798E-06_JPRB, 0.68146579E-06_JPRB, 0.75827580E-06_JPRB, &
  & 0.87609783E-06_JPRB, 0.10440981E-05_JPRB, 0.12640860E-05_JPRB, 0.14770195E-05_JPRB, 0.15812116E-05_JPRB, 0.18299160E-05_JPRB, &
  & 0.72887287E-05_JPRB, 0.15831884E-04_JPRB, 0.15469610E-04_JPRB, 0.14691203E-04_JPRB  /)

RGHG7(:, 4, 2) = (/ &
  & 0.59367637E-06_JPRB, 0.60602321E-06_JPRB, 0.64937622E-06_JPRB, 0.71962975E-06_JPRB, 0.79533329E-06_JPRB, 0.84491033E-06_JPRB, &
  & 0.86678900E-06_JPRB, 0.88079950E-06_JPRB, 0.90708039E-06_JPRB, 0.93518070E-06_JPRB, 0.96159479E-06_JPRB, 0.98627568E-06_JPRB, &
  & 0.99587234E-06_JPRB, 0.99777898E-06_JPRB, 0.99303033E-06_JPRB, 0.98489151E-06_JPRB, 0.97645534E-06_JPRB, 0.97316874E-06_JPRB, &
  & 0.98004212E-06_JPRB, 0.97884981E-06_JPRB, 0.97349530E-06_JPRB, 0.96797508E-06_JPRB, 0.96331574E-06_JPRB, 0.96021033E-06_JPRB, &
  & 0.95815936E-06_JPRB, 0.95247279E-06_JPRB, 0.94843859E-06_JPRB, 0.95122689E-06_JPRB, 0.95144464E-06_JPRB, 0.95580941E-06_JPRB, &
  & 0.95380286E-06_JPRB, 0.95043139E-06_JPRB, 0.95353995E-06_JPRB, 0.95588341E-06_JPRB, 0.95742936E-06_JPRB, 0.96973571E-06_JPRB, &
  & 0.98984772E-06_JPRB, 0.10019063E-05_JPRB, 0.99915519E-06_JPRB, 0.10005511E-05_JPRB, 0.10250678E-05_JPRB, 0.10560733E-05_JPRB, &
  & 0.10905526E-05_JPRB, 0.11383132E-05_JPRB, 0.11789747E-05_JPRB, 0.12230745E-05_JPRB, 0.12546993E-05_JPRB, 0.12784082E-05_JPRB, &
  & 0.12987396E-05_JPRB, 0.13207804E-05_JPRB, 0.13497944E-05_JPRB, 0.13893526E-05_JPRB, 0.14794084E-05_JPRB, 0.16555235E-05_JPRB, &
  & 0.19041638E-05_JPRB, 0.21995128E-05_JPRB, 0.25102396E-05_JPRB, 0.27763351E-05_JPRB, 0.29709872E-05_JPRB, 0.33343438E-05_JPRB, &
  & 0.47889400E-05_JPRB, 0.57148741E-05_JPRB, 0.56632857E-05_JPRB, 0.56083474E-05_JPRB  /)

RGHG7(:, 5, 2) = (/ &
  & 0.72844612E-06_JPRB, 0.80192101E-06_JPRB, 0.89362754E-06_JPRB, 0.10040561E-05_JPRB, 0.11177250E-05_JPRB, 0.11926764E-05_JPRB, &
  & 0.12200166E-05_JPRB, 0.12408335E-05_JPRB, 0.12768998E-05_JPRB, 0.13163482E-05_JPRB, 0.13497927E-05_JPRB, 0.13715915E-05_JPRB, &
  & 0.13780201E-05_JPRB, 0.13759392E-05_JPRB, 0.13638997E-05_JPRB, 0.13466062E-05_JPRB, 0.13289006E-05_JPRB, 0.13150246E-05_JPRB, &
  & 0.13030023E-05_JPRB, 0.12912288E-05_JPRB, 0.12774857E-05_JPRB, 0.12634047E-05_JPRB, 0.12491034E-05_JPRB, 0.12371174E-05_JPRB, &
  & 0.12277164E-05_JPRB, 0.12145671E-05_JPRB, 0.12056671E-05_JPRB, 0.12051122E-05_JPRB, 0.12015341E-05_JPRB, 0.12042697E-05_JPRB, &
  & 0.11992425E-05_JPRB, 0.11904414E-05_JPRB, 0.11865247E-05_JPRB, 0.11851181E-05_JPRB, 0.11951274E-05_JPRB, 0.12194464E-05_JPRB, &
  & 0.12616290E-05_JPRB, 0.12931855E-05_JPRB, 0.13073195E-05_JPRB, 0.13285801E-05_JPRB, 0.13812420E-05_JPRB, 0.14425379E-05_JPRB, &
  & 0.15097888E-05_JPRB, 0.15934404E-05_JPRB, 0.16656950E-05_JPRB, 0.17403741E-05_JPRB, 0.17898972E-05_JPRB, 0.18219168E-05_JPRB, &
  & 0.18625257E-05_JPRB, 0.19185485E-05_JPRB, 0.20097098E-05_JPRB, 0.21437932E-05_JPRB, 0.23859970E-05_JPRB, 0.27677870E-05_JPRB, &
  & 0.32454667E-05_JPRB, 0.37430348E-05_JPRB, 0.41712690E-05_JPRB, 0.44781207E-05_JPRB, 0.46578294E-05_JPRB, 0.47433386E-05_JPRB, &
  & 0.48143133E-05_JPRB, 0.48580569E-05_JPRB, 0.48802576E-05_JPRB, 0.49029631E-05_JPRB  /)

RGHG7(:, 6, 2) = (/ &
  & 0.82682068E-06_JPRB, 0.91024175E-06_JPRB, 0.98018144E-06_JPRB, 0.10766471E-05_JPRB, 0.11760853E-05_JPRB, 0.12481676E-05_JPRB, &
  & 0.12810930E-05_JPRB, 0.13077628E-05_JPRB, 0.13422225E-05_JPRB, 0.13730253E-05_JPRB, 0.13991632E-05_JPRB, 0.14174808E-05_JPRB, &
  & 0.14232974E-05_JPRB, 0.14240090E-05_JPRB, 0.14180902E-05_JPRB, 0.14105899E-05_JPRB, 0.14030983E-05_JPRB, 0.13960316E-05_JPRB, &
  & 0.13881025E-05_JPRB, 0.13793512E-05_JPRB, 0.13677885E-05_JPRB, 0.13531337E-05_JPRB, 0.13345480E-05_JPRB, 0.13158291E-05_JPRB, &
  & 0.12974383E-05_JPRB, 0.12801575E-05_JPRB, 0.12656723E-05_JPRB, 0.12557833E-05_JPRB, 0.12455107E-05_JPRB, 0.12412840E-05_JPRB, &
  & 0.12379017E-05_JPRB, 0.12333086E-05_JPRB, 0.12348241E-05_JPRB, 0.12420247E-05_JPRB, 0.12575045E-05_JPRB, 0.12832771E-05_JPRB, &
  & 0.13227818E-05_JPRB, 0.13622188E-05_JPRB, 0.13977371E-05_JPRB, 0.14378190E-05_JPRB, 0.14894480E-05_JPRB, 0.15457708E-05_JPRB, &
  & 0.16079720E-05_JPRB, 0.16731084E-05_JPRB, 0.17338103E-05_JPRB, 0.17976250E-05_JPRB, 0.18429402E-05_JPRB, 0.18743859E-05_JPRB, &
  & 0.19211921E-05_JPRB, 0.19847127E-05_JPRB, 0.20886128E-05_JPRB, 0.22627869E-05_JPRB, 0.25738107E-05_JPRB, 0.30115288E-05_JPRB, &
  & 0.35294141E-05_JPRB, 0.40423222E-05_JPRB, 0.44480628E-05_JPRB, 0.47203324E-05_JPRB, 0.48444955E-05_JPRB, 0.48910233E-05_JPRB, &
  & 0.49349138E-05_JPRB, 0.49575409E-05_JPRB, 0.49740799E-05_JPRB, 0.49936102E-05_JPRB  /)

RGHG7(:, 7, 2) = (/ &
  & 0.10456469E-05_JPRB, 0.11051114E-05_JPRB, 0.11649911E-05_JPRB, 0.12437581E-05_JPRB, 0.13237566E-05_JPRB, 0.13856887E-05_JPRB, &
  & 0.14238341E-05_JPRB, 0.14604768E-05_JPRB, 0.14963615E-05_JPRB, 0.15243801E-05_JPRB, 0.15474482E-05_JPRB, 0.15670056E-05_JPRB, &
  & 0.15777090E-05_JPRB, 0.15858100E-05_JPRB, 0.15897720E-05_JPRB, 0.15959162E-05_JPRB, 0.16030468E-05_JPRB, 0.16073141E-05_JPRB, &
  & 0.16070070E-05_JPRB, 0.16024922E-05_JPRB, 0.15922067E-05_JPRB, 0.15740641E-05_JPRB, 0.15480031E-05_JPRB, 0.15183979E-05_JPRB, &
  & 0.14898401E-05_JPRB, 0.14636659E-05_JPRB, 0.14400761E-05_JPRB, 0.14228508E-05_JPRB, 0.14068476E-05_JPRB, 0.14000813E-05_JPRB, &
  & 0.13956723E-05_JPRB, 0.13942661E-05_JPRB, 0.13950871E-05_JPRB, 0.14042808E-05_JPRB, 0.14273209E-05_JPRB, 0.14650894E-05_JPRB, &
  & 0.15126287E-05_JPRB, 0.15595835E-05_JPRB, 0.16113913E-05_JPRB, 0.16639421E-05_JPRB, 0.17147662E-05_JPRB, 0.17638629E-05_JPRB, &
  & 0.18095301E-05_JPRB, 0.18612383E-05_JPRB, 0.19098293E-05_JPRB, 0.19618516E-05_JPRB, 0.19937667E-05_JPRB, 0.20217682E-05_JPRB, &
  & 0.20717448E-05_JPRB, 0.21480526E-05_JPRB, 0.22899000E-05_JPRB, 0.25152064E-05_JPRB, 0.28886528E-05_JPRB, 0.33807219E-05_JPRB, &
  & 0.39342181E-05_JPRB, 0.44386625E-05_JPRB, 0.48069584E-05_JPRB, 0.50292891E-05_JPRB, 0.50992005E-05_JPRB, 0.51202031E-05_JPRB, &
  & 0.51501181E-05_JPRB, 0.51743024E-05_JPRB, 0.51932047E-05_JPRB, 0.52150232E-05_JPRB  /)

RGHG7(:, 8, 2) = (/ &
  & 0.14235213E-05_JPRB, 0.14540435E-05_JPRB, 0.14999398E-05_JPRB, 0.15498026E-05_JPRB, 0.15972564E-05_JPRB, 0.16382964E-05_JPRB, &
  & 0.16822117E-05_JPRB, 0.17288423E-05_JPRB, 0.17664167E-05_JPRB, 0.17963892E-05_JPRB, 0.18223849E-05_JPRB, 0.18474073E-05_JPRB, &
  & 0.18670606E-05_JPRB, 0.18881562E-05_JPRB, 0.19067915E-05_JPRB, 0.19286329E-05_JPRB, 0.19521057E-05_JPRB, 0.19708174E-05_JPRB, &
  & 0.19826478E-05_JPRB, 0.19873850E-05_JPRB, 0.19845537E-05_JPRB, 0.19706456E-05_JPRB, 0.19443513E-05_JPRB, 0.19105648E-05_JPRB, &
  & 0.18776975E-05_JPRB, 0.18450935E-05_JPRB, 0.18144429E-05_JPRB, 0.17907254E-05_JPRB, 0.17701624E-05_JPRB, 0.17622266E-05_JPRB, &
  & 0.17560166E-05_JPRB, 0.17543580E-05_JPRB, 0.17523952E-05_JPRB, 0.17590057E-05_JPRB, 0.17824475E-05_JPRB, 0.18225583E-05_JPRB, &
  & 0.18717790E-05_JPRB, 0.19215182E-05_JPRB, 0.19787469E-05_JPRB, 0.20341436E-05_JPRB, 0.20827134E-05_JPRB, 0.21245300E-05_JPRB, &
  & 0.21554747E-05_JPRB, 0.21937331E-05_JPRB, 0.22251772E-05_JPRB, 0.22608462E-05_JPRB, 0.22778907E-05_JPRB, 0.23021709E-05_JPRB, &
  & 0.23603878E-05_JPRB, 0.24664333E-05_JPRB, 0.26546218E-05_JPRB, 0.29336595E-05_JPRB, 0.33591138E-05_JPRB, 0.38856515E-05_JPRB, &
  & 0.44339870E-05_JPRB, 0.48965189E-05_JPRB, 0.52100987E-05_JPRB, 0.53748011E-05_JPRB, 0.54163590E-05_JPRB, 0.54391949E-05_JPRB, &
  & 0.54749774E-05_JPRB, 0.55100788E-05_JPRB, 0.55449017E-05_JPRB, 0.55831676E-05_JPRB  /)

RGHG7(:, 9, 2) = (/ &
  & 0.19957674E-05_JPRB, 0.20099703E-05_JPRB, 0.20326843E-05_JPRB, 0.20396938E-05_JPRB, 0.20443716E-05_JPRB, 0.20597970E-05_JPRB, &
  & 0.21040963E-05_JPRB, 0.21573397E-05_JPRB, 0.21983315E-05_JPRB, 0.22348940E-05_JPRB, 0.22704001E-05_JPRB, 0.23065902E-05_JPRB, &
  & 0.23393383E-05_JPRB, 0.23777836E-05_JPRB, 0.24136866E-05_JPRB, 0.24513065E-05_JPRB, 0.24900668E-05_JPRB, 0.25260446E-05_JPRB, &
  & 0.25566764E-05_JPRB, 0.25791164E-05_JPRB, 0.25933430E-05_JPRB, 0.25959923E-05_JPRB, 0.25860454E-05_JPRB, 0.25669743E-05_JPRB, &
  & 0.25427285E-05_JPRB, 0.25108617E-05_JPRB, 0.24795512E-05_JPRB, 0.24528653E-05_JPRB, 0.24287197E-05_JPRB, 0.24173980E-05_JPRB, &
  & 0.24075766E-05_JPRB, 0.24028262E-05_JPRB, 0.23998022E-05_JPRB, 0.24007670E-05_JPRB, 0.24158787E-05_JPRB, 0.24437573E-05_JPRB, &
  & 0.24817617E-05_JPRB, 0.25222353E-05_JPRB, 0.25701782E-05_JPRB, 0.26192104E-05_JPRB, 0.26622137E-05_JPRB, 0.26977109E-05_JPRB, &
  & 0.27211115E-05_JPRB, 0.27464751E-05_JPRB, 0.27574361E-05_JPRB, 0.27739562E-05_JPRB, 0.27805771E-05_JPRB, 0.28054395E-05_JPRB, &
  & 0.28847530E-05_JPRB, 0.30378614E-05_JPRB, 0.32798036E-05_JPRB, 0.36124821E-05_JPRB, 0.40597397E-05_JPRB, 0.45625799E-05_JPRB, &
  & 0.50294686E-05_JPRB, 0.53983280E-05_JPRB, 0.56240210E-05_JPRB, 0.57263295E-05_JPRB, 0.57580595E-05_JPRB, 0.57895167E-05_JPRB, &
  & 0.58344627E-05_JPRB, 0.58798495E-05_JPRB, 0.59315009E-05_JPRB, 0.59847509E-05_JPRB  /)

RGHG7(:,10, 2) = (/ &
  & 0.27416080E-05_JPRB, 0.27409493E-05_JPRB, 0.27305810E-05_JPRB, 0.26896787E-05_JPRB, 0.26608825E-05_JPRB, 0.26654677E-05_JPRB, &
  & 0.27060801E-05_JPRB, 0.27660253E-05_JPRB, 0.28165047E-05_JPRB, 0.28622024E-05_JPRB, 0.29089810E-05_JPRB, 0.29599305E-05_JPRB, &
  & 0.30077706E-05_JPRB, 0.30623218E-05_JPRB, 0.31135602E-05_JPRB, 0.31667219E-05_JPRB, 0.32178130E-05_JPRB, 0.32716969E-05_JPRB, &
  & 0.33256926E-05_JPRB, 0.33709533E-05_JPRB, 0.34081340E-05_JPRB, 0.34350145E-05_JPRB, 0.34549475E-05_JPRB, 0.34657770E-05_JPRB, &
  & 0.34585416E-05_JPRB, 0.34339610E-05_JPRB, 0.34087974E-05_JPRB, 0.33831172E-05_JPRB, 0.33551032E-05_JPRB, 0.33353719E-05_JPRB, &
  & 0.33214021E-05_JPRB, 0.33149242E-05_JPRB, 0.33161535E-05_JPRB, 0.33165821E-05_JPRB, 0.33255054E-05_JPRB, 0.33407038E-05_JPRB, &
  & 0.33642073E-05_JPRB, 0.33872081E-05_JPRB, 0.34192724E-05_JPRB, 0.34597898E-05_JPRB, 0.34963901E-05_JPRB, 0.35297862E-05_JPRB, &
  & 0.35525739E-05_JPRB, 0.35726813E-05_JPRB, 0.35752952E-05_JPRB, 0.35858889E-05_JPRB, 0.36056233E-05_JPRB, 0.36617309E-05_JPRB, &
  & 0.37951189E-05_JPRB, 0.40134577E-05_JPRB, 0.43217395E-05_JPRB, 0.46912922E-05_JPRB, 0.50934440E-05_JPRB, 0.54696945E-05_JPRB, &
  & 0.57582656E-05_JPRB, 0.59539129E-05_JPRB, 0.60319400E-05_JPRB, 0.60413954E-05_JPRB, 0.60206503E-05_JPRB, 0.60107367E-05_JPRB, &
  & 0.60269495E-05_JPRB, 0.60582369E-05_JPRB, 0.60943008E-05_JPRB, 0.61321928E-05_JPRB  /)

RGHG7(:,11, 2) = (/ &
  & 0.35864897E-05_JPRB, 0.35523248E-05_JPRB, 0.35164845E-05_JPRB, 0.34530312E-05_JPRB, 0.34219756E-05_JPRB, 0.34422038E-05_JPRB, &
  & 0.34946149E-05_JPRB, 0.35663122E-05_JPRB, 0.36294508E-05_JPRB, 0.36839545E-05_JPRB, 0.37397662E-05_JPRB, 0.38024709E-05_JPRB, &
  & 0.38652045E-05_JPRB, 0.39328302E-05_JPRB, 0.39960074E-05_JPRB, 0.40647805E-05_JPRB, 0.41271943E-05_JPRB, 0.41932872E-05_JPRB, &
  & 0.42630791E-05_JPRB, 0.43235455E-05_JPRB, 0.43812679E-05_JPRB, 0.44307244E-05_JPRB, 0.44712289E-05_JPRB, 0.44988452E-05_JPRB, &
  & 0.45041536E-05_JPRB, 0.44916390E-05_JPRB, 0.44751629E-05_JPRB, 0.44517031E-05_JPRB, 0.44253279E-05_JPRB, 0.44035730E-05_JPRB, &
  & 0.43960429E-05_JPRB, 0.43935175E-05_JPRB, 0.43980516E-05_JPRB, 0.44046667E-05_JPRB, 0.44149494E-05_JPRB, 0.44260356E-05_JPRB, &
  & 0.44406327E-05_JPRB, 0.44499965E-05_JPRB, 0.44653077E-05_JPRB, 0.44900365E-05_JPRB, 0.45164950E-05_JPRB, 0.45451994E-05_JPRB, &
  & 0.45681940E-05_JPRB, 0.45962950E-05_JPRB, 0.46208885E-05_JPRB, 0.46693159E-05_JPRB, 0.47630518E-05_JPRB, 0.49174536E-05_JPRB, &
  & 0.51493738E-05_JPRB, 0.54440458E-05_JPRB, 0.57701108E-05_JPRB, 0.60697845E-05_JPRB, 0.62981636E-05_JPRB, 0.64382563E-05_JPRB, &
  & 0.64805985E-05_JPRB, 0.64551653E-05_JPRB, 0.63712617E-05_JPRB, 0.62607361E-05_JPRB, 0.61513558E-05_JPRB, 0.60745426E-05_JPRB, &
  & 0.60391176E-05_JPRB, 0.60319188E-05_JPRB, 0.60325011E-05_JPRB, 0.60458229E-05_JPRB  /)

RGHG7(:,12, 2) = (/ &
  & 0.43890284E-05_JPRB, 0.43540988E-05_JPRB, 0.43252997E-05_JPRB, 0.42899544E-05_JPRB, 0.42961888E-05_JPRB, 0.43676072E-05_JPRB, &
  & 0.44511816E-05_JPRB, 0.45373040E-05_JPRB, 0.46174012E-05_JPRB, 0.46829344E-05_JPRB, 0.47522752E-05_JPRB, 0.48245225E-05_JPRB, &
  & 0.49052049E-05_JPRB, 0.49878033E-05_JPRB, 0.50588614E-05_JPRB, 0.51389778E-05_JPRB, 0.52153000E-05_JPRB, 0.52857159E-05_JPRB, &
  & 0.53573675E-05_JPRB, 0.54235484E-05_JPRB, 0.54941574E-05_JPRB, 0.55546407E-05_JPRB, 0.55994400E-05_JPRB, 0.56364472E-05_JPRB, &
  & 0.56612577E-05_JPRB, 0.56744427E-05_JPRB, 0.56767456E-05_JPRB, 0.56724722E-05_JPRB, 0.56665587E-05_JPRB, 0.56617133E-05_JPRB, &
  & 0.56662910E-05_JPRB, 0.56653617E-05_JPRB, 0.56635325E-05_JPRB, 0.56678058E-05_JPRB, 0.56760584E-05_JPRB, 0.56805612E-05_JPRB, &
  & 0.56800096E-05_JPRB, 0.56645372E-05_JPRB, 0.56460726E-05_JPRB, 0.56303689E-05_JPRB, 0.56108542E-05_JPRB, 0.55963345E-05_JPRB, &
  & 0.55942085E-05_JPRB, 0.56217539E-05_JPRB, 0.56853536E-05_JPRB, 0.58163299E-05_JPRB, 0.60274397E-05_JPRB, 0.62915814E-05_JPRB, &
  & 0.65824553E-05_JPRB, 0.68505431E-05_JPRB, 0.70345918E-05_JPRB, 0.71132931E-05_JPRB, 0.70895710E-05_JPRB, 0.69963688E-05_JPRB, &
  & 0.68580772E-05_JPRB, 0.67173882E-05_JPRB, 0.65692930E-05_JPRB, 0.64180731E-05_JPRB, 0.62829282E-05_JPRB, 0.61871961E-05_JPRB, &
  & 0.61324538E-05_JPRB, 0.61126001E-05_JPRB, 0.61087056E-05_JPRB, 0.61153889E-05_JPRB  /)

RGHG7(:,13, 2) = (/ &
  & 0.49234445E-05_JPRB, 0.48955035E-05_JPRB, 0.48782167E-05_JPRB, 0.48962494E-05_JPRB, 0.49670358E-05_JPRB, 0.51267325E-05_JPRB, &
  & 0.52867072E-05_JPRB, 0.54299105E-05_JPRB, 0.55719094E-05_JPRB, 0.56786407E-05_JPRB, 0.57885308E-05_JPRB, 0.58840869E-05_JPRB, &
  & 0.59892749E-05_JPRB, 0.60926496E-05_JPRB, 0.61780971E-05_JPRB, 0.62666576E-05_JPRB, 0.63530997E-05_JPRB, 0.64249275E-05_JPRB, &
  & 0.64971061E-05_JPRB, 0.65644864E-05_JPRB, 0.66329126E-05_JPRB, 0.66910042E-05_JPRB, 0.67422496E-05_JPRB, 0.68009366E-05_JPRB, &
  & 0.68599703E-05_JPRB, 0.69213752E-05_JPRB, 0.69772053E-05_JPRB, 0.70322359E-05_JPRB, 0.70779948E-05_JPRB, 0.71077503E-05_JPRB, &
  & 0.71183177E-05_JPRB, 0.70980250E-05_JPRB, 0.70641012E-05_JPRB, 0.70319175E-05_JPRB, 0.70041029E-05_JPRB, 0.69747875E-05_JPRB, &
  & 0.69354266E-05_JPRB, 0.68721642E-05_JPRB, 0.67909104E-05_JPRB, 0.67005843E-05_JPRB, 0.66020745E-05_JPRB, 0.65205015E-05_JPRB, &
  & 0.64735402E-05_JPRB, 0.64876593E-05_JPRB, 0.65858938E-05_JPRB, 0.67897710E-05_JPRB, 0.70661465E-05_JPRB, 0.73315061E-05_JPRB, &
  & 0.75270090E-05_JPRB, 0.76181913E-05_JPRB, 0.75889926E-05_JPRB, 0.74672695E-05_JPRB, 0.72934892E-05_JPRB, 0.70973313E-05_JPRB, &
  & 0.69096420E-05_JPRB, 0.67560682E-05_JPRB, 0.66121210E-05_JPRB, 0.64796065E-05_JPRB, 0.63642378E-05_JPRB, 0.62792217E-05_JPRB, &
  & 0.62340111E-05_JPRB, 0.62306348E-05_JPRB, 0.62507138E-05_JPRB, 0.62756765E-05_JPRB  /)

RGHG7(:,14, 2) = (/ &
  & 0.50314536E-05_JPRB, 0.50018284E-05_JPRB, 0.50013127E-05_JPRB, 0.50758134E-05_JPRB, 0.52147090E-05_JPRB, 0.54500524E-05_JPRB, &
  & 0.57082334E-05_JPRB, 0.59488897E-05_JPRB, 0.61907365E-05_JPRB, 0.63744542E-05_JPRB, 0.65532846E-05_JPRB, 0.66957579E-05_JPRB, &
  & 0.68399276E-05_JPRB, 0.69747976E-05_JPRB, 0.70877189E-05_JPRB, 0.71910491E-05_JPRB, 0.72913796E-05_JPRB, 0.73807838E-05_JPRB, &
  & 0.74698838E-05_JPRB, 0.75453328E-05_JPRB, 0.76169674E-05_JPRB, 0.76851121E-05_JPRB, 0.77615978E-05_JPRB, 0.78558612E-05_JPRB, &
  & 0.79611587E-05_JPRB, 0.80864012E-05_JPRB, 0.82206969E-05_JPRB, 0.83649959E-05_JPRB, 0.84852319E-05_JPRB, 0.85641868E-05_JPRB, &
  & 0.85895682E-05_JPRB, 0.85435374E-05_JPRB, 0.84437134E-05_JPRB, 0.83259588E-05_JPRB, 0.82082184E-05_JPRB, 0.80968774E-05_JPRB, &
  & 0.79739639E-05_JPRB, 0.78330785E-05_JPRB, 0.76811593E-05_JPRB, 0.75253689E-05_JPRB, 0.73757360E-05_JPRB, 0.72558970E-05_JPRB, &
  & 0.71873414E-05_JPRB, 0.71963893E-05_JPRB, 0.72982888E-05_JPRB, 0.74930900E-05_JPRB, 0.77020043E-05_JPRB, 0.78144092E-05_JPRB, &
  & 0.78023203E-05_JPRB, 0.77032753E-05_JPRB, 0.75246866E-05_JPRB, 0.73177224E-05_JPRB, 0.71024994E-05_JPRB, 0.68975863E-05_JPRB, &
  & 0.67286669E-05_JPRB, 0.65948300E-05_JPRB, 0.64699178E-05_JPRB, 0.63600556E-05_JPRB, 0.62708988E-05_JPRB, 0.61906482E-05_JPRB, &
  & 0.61520741E-05_JPRB, 0.61663699E-05_JPRB, 0.62116528E-05_JPRB, 0.62697586E-05_JPRB  /)

RGHG7(:,15, 2) = (/ &
  & 0.47830636E-05_JPRB, 0.47838114E-05_JPRB, 0.48213195E-05_JPRB, 0.49588541E-05_JPRB, 0.51620032E-05_JPRB, 0.54417245E-05_JPRB, &
  & 0.57583815E-05_JPRB, 0.60657459E-05_JPRB, 0.63733937E-05_JPRB, 0.66319066E-05_JPRB, 0.68705914E-05_JPRB, 0.70692665E-05_JPRB, &
  & 0.72642300E-05_JPRB, 0.74437113E-05_JPRB, 0.75994399E-05_JPRB, 0.77384451E-05_JPRB, 0.78783360E-05_JPRB, 0.80119362E-05_JPRB, &
  & 0.81405156E-05_JPRB, 0.82505952E-05_JPRB, 0.83603032E-05_JPRB, 0.84686741E-05_JPRB, 0.85848564E-05_JPRB, 0.87175872E-05_JPRB, &
  & 0.88625596E-05_JPRB, 0.90318355E-05_JPRB, 0.92175714E-05_JPRB, 0.94128869E-05_JPRB, 0.95669966E-05_JPRB, 0.96594247E-05_JPRB, &
  & 0.96757146E-05_JPRB, 0.95819407E-05_JPRB, 0.94031562E-05_JPRB, 0.92114309E-05_JPRB, 0.90320817E-05_JPRB, 0.88613139E-05_JPRB, &
  & 0.86783165E-05_JPRB, 0.84868089E-05_JPRB, 0.82986970E-05_JPRB, 0.81278623E-05_JPRB, 0.79929278E-05_JPRB, 0.78885913E-05_JPRB, &
  & 0.78199912E-05_JPRB, 0.78072725E-05_JPRB, 0.78473471E-05_JPRB, 0.79215325E-05_JPRB, 0.79351899E-05_JPRB, 0.78343107E-05_JPRB, &
  & 0.76356239E-05_JPRB, 0.74011587E-05_JPRB, 0.71558680E-05_JPRB, 0.69261091E-05_JPRB, 0.67137350E-05_JPRB, 0.65273001E-05_JPRB, &
  & 0.63905770E-05_JPRB, 0.62823569E-05_JPRB, 0.61808863E-05_JPRB, 0.60958800E-05_JPRB, 0.60267200E-05_JPRB, 0.59591928E-05_JPRB, &
  & 0.59317432E-05_JPRB, 0.59492893E-05_JPRB, 0.59955177E-05_JPRB, 0.60575919E-05_JPRB  /)

RGHG7(:,16, 2) = (/ &
  & 0.44068441E-05_JPRB, 0.44518355E-05_JPRB, 0.45356527E-05_JPRB, 0.47125133E-05_JPRB, 0.49551487E-05_JPRB, 0.52534977E-05_JPRB, &
  & 0.55935613E-05_JPRB, 0.59397248E-05_JPRB, 0.62779540E-05_JPRB, 0.65803482E-05_JPRB, 0.68561025E-05_JPRB, 0.70913904E-05_JPRB, &
  & 0.73206932E-05_JPRB, 0.75376472E-05_JPRB, 0.77410936E-05_JPRB, 0.79288835E-05_JPRB, 0.81238375E-05_JPRB, 0.83215107E-05_JPRB, &
  & 0.85174407E-05_JPRB, 0.86927173E-05_JPRB, 0.88680054E-05_JPRB, 0.90353719E-05_JPRB, 0.91948917E-05_JPRB, 0.93556220E-05_JPRB, &
  & 0.95131271E-05_JPRB, 0.96797004E-05_JPRB, 0.98496040E-05_JPRB, 0.10009120E-04_JPRB, 0.10114330E-04_JPRB, 0.10155454E-04_JPRB, &
  & 0.10121550E-04_JPRB, 0.99801886E-05_JPRB, 0.97672330E-05_JPRB, 0.95606130E-05_JPRB, 0.93727162E-05_JPRB, 0.91918147E-05_JPRB, &
  & 0.90132297E-05_JPRB, 0.88406858E-05_JPRB, 0.86770043E-05_JPRB, 0.85419912E-05_JPRB, 0.84477713E-05_JPRB, 0.83649102E-05_JPRB, &
  & 0.82699408E-05_JPRB, 0.81715159E-05_JPRB, 0.80821642E-05_JPRB, 0.79707128E-05_JPRB, 0.77761992E-05_JPRB, 0.75003028E-05_JPRB, &
  & 0.71929651E-05_JPRB, 0.69122151E-05_JPRB, 0.66627265E-05_JPRB, 0.64338210E-05_JPRB, 0.62501279E-05_JPRB, 0.61025189E-05_JPRB, &
  & 0.60020551E-05_JPRB, 0.59236242E-05_JPRB, 0.58600894E-05_JPRB, 0.58088213E-05_JPRB, 0.57579024E-05_JPRB, 0.57155459E-05_JPRB, &
  & 0.57087742E-05_JPRB, 0.57280422E-05_JPRB, 0.57624572E-05_JPRB, 0.57899857E-05_JPRB  /)

RGHG7(:,17, 2) = (/ &
  & 0.40731941E-05_JPRB, 0.41390099E-05_JPRB, 0.42675141E-05_JPRB, 0.44663497E-05_JPRB, 0.47119395E-05_JPRB, 0.50061865E-05_JPRB, &
  & 0.53384284E-05_JPRB, 0.56920806E-05_JPRB, 0.60438289E-05_JPRB, 0.63582123E-05_JPRB, 0.66567975E-05_JPRB, 0.69242078E-05_JPRB, &
  & 0.71876828E-05_JPRB, 0.74387752E-05_JPRB, 0.76787692E-05_JPRB, 0.79054681E-05_JPRB, 0.81440278E-05_JPRB, 0.83952946E-05_JPRB, &
  & 0.86489732E-05_JPRB, 0.88771679E-05_JPRB, 0.91088029E-05_JPRB, 0.93268788E-05_JPRB, 0.95173052E-05_JPRB, 0.96873196E-05_JPRB, &
  & 0.98347859E-05_JPRB, 0.99728578E-05_JPRB, 0.10092876E-04_JPRB, 0.10191771E-04_JPRB, 0.10245420E-04_JPRB, 0.10234579E-04_JPRB, &
  & 0.10167060E-04_JPRB, 0.10023511E-04_JPRB, 0.98197848E-05_JPRB, 0.96191070E-05_JPRB, 0.94282303E-05_JPRB, 0.92518163E-05_JPRB, &
  & 0.90934094E-05_JPRB, 0.89547988E-05_JPRB, 0.88298314E-05_JPRB, 0.87231598E-05_JPRB, 0.86253527E-05_JPRB, 0.85105235E-05_JPRB, &
  & 0.83460706E-05_JPRB, 0.81291113E-05_JPRB, 0.78875156E-05_JPRB, 0.76086882E-05_JPRB, 0.72951196E-05_JPRB, 0.69651029E-05_JPRB, &
  & 0.66695677E-05_JPRB, 0.64218391E-05_JPRB, 0.62076162E-05_JPRB, 0.60125944E-05_JPRB, 0.58650700E-05_JPRB, 0.57675722E-05_JPRB, &
  & 0.57130647E-05_JPRB, 0.56680302E-05_JPRB, 0.56436793E-05_JPRB, 0.56195308E-05_JPRB, 0.55931758E-05_JPRB, 0.55712492E-05_JPRB, &
  & 0.55737147E-05_JPRB, 0.55798636E-05_JPRB, 0.55827815E-05_JPRB, 0.55740558E-05_JPRB  /)

RGHG7(:,18, 2) = (/ &
  & 0.38174048E-05_JPRB, 0.38777434E-05_JPRB, 0.40252373E-05_JPRB, 0.42321228E-05_JPRB, 0.44704224E-05_JPRB, 0.47453225E-05_JPRB, &
  & 0.50520038E-05_JPRB, 0.53848436E-05_JPRB, 0.57341150E-05_JPRB, 0.60542636E-05_JPRB, 0.63644065E-05_JPRB, 0.66608664E-05_JPRB, &
  & 0.69585905E-05_JPRB, 0.72401820E-05_JPRB, 0.75066334E-05_JPRB, 0.77649893E-05_JPRB, 0.80419804E-05_JPRB, 0.83228222E-05_JPRB, &
  & 0.86019189E-05_JPRB, 0.88563065E-05_JPRB, 0.91181964E-05_JPRB, 0.93622463E-05_JPRB, 0.95675255E-05_JPRB, 0.97403661E-05_JPRB, &
  & 0.98816721E-05_JPRB, 0.10008088E-04_JPRB, 0.10105311E-04_JPRB, 0.10170062E-04_JPRB, 0.10186597E-04_JPRB, 0.10141528E-04_JPRB, &
  & 0.10050961E-04_JPRB, 0.99129619E-05_JPRB, 0.97339945E-05_JPRB, 0.95517439E-05_JPRB, 0.93698543E-05_JPRB, 0.92076060E-05_JPRB, &
  & 0.90610910E-05_JPRB, 0.89322813E-05_JPRB, 0.88170679E-05_JPRB, 0.86983800E-05_JPRB, 0.85456443E-05_JPRB, 0.83422022E-05_JPRB, &
  & 0.80697591E-05_JPRB, 0.77363886E-05_JPRB, 0.73989398E-05_JPRB, 0.70776339E-05_JPRB, 0.67736525E-05_JPRB, 0.64929364E-05_JPRB, &
  & 0.62567089E-05_JPRB, 0.60640737E-05_JPRB, 0.58990597E-05_JPRB, 0.57525005E-05_JPRB, 0.56477808E-05_JPRB, 0.55907544E-05_JPRB, &
  & 0.55630306E-05_JPRB, 0.55444356E-05_JPRB, 0.55422092E-05_JPRB, 0.55347776E-05_JPRB, 0.55223597E-05_JPRB, 0.55081644E-05_JPRB, &
  & 0.55114392E-05_JPRB, 0.54986870E-05_JPRB, 0.54738183E-05_JPRB, 0.54445521E-05_JPRB  /)

RGHG7(:,19, 2) = (/ &
  & 0.36086916E-05_JPRB, 0.36783214E-05_JPRB, 0.38316212E-05_JPRB, 0.40330722E-05_JPRB, 0.42465334E-05_JPRB, 0.44825650E-05_JPRB, &
  & 0.47480736E-05_JPRB, 0.50487443E-05_JPRB, 0.53788146E-05_JPRB, 0.56980797E-05_JPRB, 0.60170058E-05_JPRB, 0.63307771E-05_JPRB, &
  & 0.66504305E-05_JPRB, 0.69538605E-05_JPRB, 0.72437375E-05_JPRB, 0.75274323E-05_JPRB, 0.78246314E-05_JPRB, 0.81066696E-05_JPRB, &
  & 0.83702806E-05_JPRB, 0.86105438E-05_JPRB, 0.88657841E-05_JPRB, 0.91146399E-05_JPRB, 0.93290021E-05_JPRB, 0.95029784E-05_JPRB, &
  & 0.96455733E-05_JPRB, 0.97807571E-05_JPRB, 0.98810539E-05_JPRB, 0.99344919E-05_JPRB, 0.99388255E-05_JPRB, 0.98956503E-05_JPRB, &
  & 0.98044756E-05_JPRB, 0.96844781E-05_JPRB, 0.95411402E-05_JPRB, 0.93786060E-05_JPRB, 0.92138543E-05_JPRB, 0.90720113E-05_JPRB, &
  & 0.89367584E-05_JPRB, 0.88052186E-05_JPRB, 0.86653678E-05_JPRB, 0.84855894E-05_JPRB, 0.82432063E-05_JPRB, 0.79469998E-05_JPRB, &
  & 0.75938174E-05_JPRB, 0.72102589E-05_JPRB, 0.68804932E-05_JPRB, 0.65956991E-05_JPRB, 0.63553866E-05_JPRB, 0.61442388E-05_JPRB, &
  & 0.59643776E-05_JPRB, 0.58159051E-05_JPRB, 0.56996103E-05_JPRB, 0.56029245E-05_JPRB, 0.55332991E-05_JPRB, 0.55018184E-05_JPRB, &
  & 0.54903195E-05_JPRB, 0.54893668E-05_JPRB, 0.54982149E-05_JPRB, 0.55001659E-05_JPRB, 0.54924636E-05_JPRB, 0.54791404E-05_JPRB, &
  & 0.54778172E-05_JPRB, 0.54583832E-05_JPRB, 0.54245432E-05_JPRB, 0.53964066E-05_JPRB  /)

RGHG7(:,20, 2) = (/ &
  & 0.34436667E-05_JPRB, 0.35384832E-05_JPRB, 0.37000682E-05_JPRB, 0.38818564E-05_JPRB, 0.40535484E-05_JPRB, 0.42406514E-05_JPRB, &
  & 0.44552055E-05_JPRB, 0.47185974E-05_JPRB, 0.50171670E-05_JPRB, 0.53184054E-05_JPRB, 0.56296282E-05_JPRB, 0.59419830E-05_JPRB, &
  & 0.62615065E-05_JPRB, 0.65751988E-05_JPRB, 0.68826083E-05_JPRB, 0.71819495E-05_JPRB, 0.74756604E-05_JPRB, 0.77389729E-05_JPRB, &
  & 0.79639180E-05_JPRB, 0.81593704E-05_JPRB, 0.83739795E-05_JPRB, 0.86011273E-05_JPRB, 0.88113833E-05_JPRB, 0.89774585E-05_JPRB, &
  & 0.91187720E-05_JPRB, 0.92668712E-05_JPRB, 0.93881430E-05_JPRB, 0.94591999E-05_JPRB, 0.94806486E-05_JPRB, 0.94603617E-05_JPRB, &
  & 0.93925945E-05_JPRB, 0.92948849E-05_JPRB, 0.91796049E-05_JPRB, 0.90394992E-05_JPRB, 0.88963642E-05_JPRB, 0.87715676E-05_JPRB, &
  & 0.86387126E-05_JPRB, 0.84910397E-05_JPRB, 0.83100960E-05_JPRB, 0.80686764E-05_JPRB, 0.77701157E-05_JPRB, 0.74378183E-05_JPRB, &
  & 0.70716869E-05_JPRB, 0.67121032E-05_JPRB, 0.64420131E-05_JPRB, 0.62134477E-05_JPRB, 0.60378486E-05_JPRB, 0.58882623E-05_JPRB, &
  & 0.57514949E-05_JPRB, 0.56357093E-05_JPRB, 0.55571348E-05_JPRB, 0.55016331E-05_JPRB, 0.54593811E-05_JPRB, 0.54439918E-05_JPRB, &
  & 0.54479034E-05_JPRB, 0.54645969E-05_JPRB, 0.54800250E-05_JPRB, 0.54845007E-05_JPRB, 0.54808884E-05_JPRB, 0.54691610E-05_JPRB, &
  & 0.54615406E-05_JPRB, 0.54400532E-05_JPRB, 0.54044923E-05_JPRB, 0.53892237E-05_JPRB  /)

RGHG7(:,21, 2) = (/ &
  & 0.33366727E-05_JPRB, 0.34582937E-05_JPRB, 0.36255775E-05_JPRB, 0.37740284E-05_JPRB, 0.38932796E-05_JPRB, 0.40288618E-05_JPRB, &
  & 0.41924194E-05_JPRB, 0.44171440E-05_JPRB, 0.46769581E-05_JPRB, 0.49434706E-05_JPRB, 0.52262463E-05_JPRB, 0.55151791E-05_JPRB, &
  & 0.58127655E-05_JPRB, 0.61213067E-05_JPRB, 0.64345485E-05_JPRB, 0.67381259E-05_JPRB, 0.70115552E-05_JPRB, 0.72447052E-05_JPRB, &
  & 0.74227358E-05_JPRB, 0.75591968E-05_JPRB, 0.77120952E-05_JPRB, 0.78919648E-05_JPRB, 0.80754104E-05_JPRB, 0.82199524E-05_JPRB, &
  & 0.83504754E-05_JPRB, 0.85005944E-05_JPRB, 0.86445437E-05_JPRB, 0.87519142E-05_JPRB, 0.88117536E-05_JPRB, 0.88271854E-05_JPRB, &
  & 0.88025057E-05_JPRB, 0.87335857E-05_JPRB, 0.86360269E-05_JPRB, 0.85121924E-05_JPRB, 0.83792277E-05_JPRB, 0.82547229E-05_JPRB, &
  & 0.81092478E-05_JPRB, 0.79372874E-05_JPRB, 0.77239759E-05_JPRB, 0.74583293E-05_JPRB, 0.71659419E-05_JPRB, 0.68678714E-05_JPRB, &
  & 0.65588839E-05_JPRB, 0.62776008E-05_JPRB, 0.60843436E-05_JPRB, 0.59131212E-05_JPRB, 0.57905353E-05_JPRB, 0.56926821E-05_JPRB, &
  & 0.55888207E-05_JPRB, 0.54966677E-05_JPRB, 0.54421456E-05_JPRB, 0.54166193E-05_JPRB, 0.53975582E-05_JPRB, 0.53951081E-05_JPRB, &
  & 0.54152995E-05_JPRB, 0.54500351E-05_JPRB, 0.54704702E-05_JPRB, 0.54740651E-05_JPRB, 0.54754309E-05_JPRB, 0.54682873E-05_JPRB, &
  & 0.54570915E-05_JPRB, 0.54360692E-05_JPRB, 0.53988165E-05_JPRB, 0.53960060E-05_JPRB  /)

RGHG7(:,22, 2) = (/ &
  & 0.33201935E-05_JPRB, 0.34500262E-05_JPRB, 0.36028128E-05_JPRB, 0.37042240E-05_JPRB, 0.37685280E-05_JPRB, 0.38559552E-05_JPRB, &
  & 0.39814958E-05_JPRB, 0.41702310E-05_JPRB, 0.43888853E-05_JPRB, 0.46094733E-05_JPRB, 0.48433844E-05_JPRB, 0.50824389E-05_JPRB, &
  & 0.53390683E-05_JPRB, 0.56200345E-05_JPRB, 0.59186777E-05_JPRB, 0.62128270E-05_JPRB, 0.64606074E-05_JPRB, 0.66589845E-05_JPRB, &
  & 0.67935236E-05_JPRB, 0.68751387E-05_JPRB, 0.69614313E-05_JPRB, 0.70710455E-05_JPRB, 0.71924473E-05_JPRB, 0.72978572E-05_JPRB, &
  & 0.74022245E-05_JPRB, 0.75279112E-05_JPRB, 0.76741921E-05_JPRB, 0.78171466E-05_JPRB, 0.79240257E-05_JPRB, 0.79876124E-05_JPRB, &
  & 0.80210227E-05_JPRB, 0.79977231E-05_JPRB, 0.79131408E-05_JPRB, 0.77817029E-05_JPRB, 0.76214674E-05_JPRB, 0.74620883E-05_JPRB, &
  & 0.72832596E-05_JPRB, 0.70886917E-05_JPRB, 0.68827808E-05_JPRB, 0.66657961E-05_JPRB, 0.64550185E-05_JPRB, 0.62587323E-05_JPRB, &
  & 0.60698786E-05_JPRB, 0.58962596E-05_JPRB, 0.57791378E-05_JPRB, 0.56686413E-05_JPRB, 0.55910675E-05_JPRB, 0.55403554E-05_JPRB, &
  & 0.54646773E-05_JPRB, 0.53869201E-05_JPRB, 0.53417248E-05_JPRB, 0.53342439E-05_JPRB, 0.53375875E-05_JPRB, 0.53506483E-05_JPRB, &
  & 0.53853369E-05_JPRB, 0.54330490E-05_JPRB, 0.54578434E-05_JPRB, 0.54623507E-05_JPRB, 0.54667578E-05_JPRB, 0.54669135E-05_JPRB, &
  & 0.54603812E-05_JPRB, 0.54459485E-05_JPRB, 0.54041337E-05_JPRB, 0.54002081E-05_JPRB  /)

RGHG7(:,23, 2) = (/ &
  & 0.33439006E-05_JPRB, 0.34505052E-05_JPRB, 0.35728687E-05_JPRB, 0.36262395E-05_JPRB, 0.36449591E-05_JPRB, 0.36994622E-05_JPRB, &
  & 0.38047931E-05_JPRB, 0.39681438E-05_JPRB, 0.41511136E-05_JPRB, 0.43332222E-05_JPRB, 0.45217100E-05_JPRB, 0.47096624E-05_JPRB, &
  & 0.49092592E-05_JPRB, 0.51380067E-05_JPRB, 0.53863364E-05_JPRB, 0.56418028E-05_JPRB, 0.58584684E-05_JPRB, 0.60245820E-05_JPRB, &
  & 0.61288997E-05_JPRB, 0.61763934E-05_JPRB, 0.62161916E-05_JPRB, 0.62631746E-05_JPRB, 0.63161363E-05_JPRB, 0.63748804E-05_JPRB, &
  & 0.64411403E-05_JPRB, 0.65268170E-05_JPRB, 0.66417479E-05_JPRB, 0.67783478E-05_JPRB, 0.69031062E-05_JPRB, 0.70055847E-05_JPRB, &
  & 0.70827157E-05_JPRB, 0.71016111E-05_JPRB, 0.70374824E-05_JPRB, 0.68936962E-05_JPRB, 0.66941390E-05_JPRB, 0.64878479E-05_JPRB, &
  & 0.62788106E-05_JPRB, 0.60853655E-05_JPRB, 0.59260139E-05_JPRB, 0.57959213E-05_JPRB, 0.56922796E-05_JPRB, 0.56119741E-05_JPRB, &
  & 0.55426198E-05_JPRB, 0.54738699E-05_JPRB, 0.54382271E-05_JPRB, 0.53950141E-05_JPRB, 0.53644862E-05_JPRB, 0.53540840E-05_JPRB, &
  & 0.53150884E-05_JPRB, 0.52577430E-05_JPRB, 0.52123483E-05_JPRB, 0.52024243E-05_JPRB, 0.52257109E-05_JPRB, 0.52625349E-05_JPRB, &
  & 0.53101065E-05_JPRB, 0.53650061E-05_JPRB, 0.53970253E-05_JPRB, 0.54136917E-05_JPRB, 0.54166673E-05_JPRB, 0.54267177E-05_JPRB, &
  & 0.54370009E-05_JPRB, 0.54299234E-05_JPRB, 0.53932399E-05_JPRB, 0.53866886E-05_JPRB  /)

RGHG7(:,24, 2) = (/ &
  & 0.33437098E-05_JPRB, 0.34207680E-05_JPRB, 0.35023486E-05_JPRB, 0.35114917E-05_JPRB, 0.34976593E-05_JPRB, 0.35291074E-05_JPRB, &
  & 0.36193934E-05_JPRB, 0.37598261E-05_JPRB, 0.39098756E-05_JPRB, 0.40556016E-05_JPRB, 0.42031396E-05_JPRB, 0.43455170E-05_JPRB, &
  & 0.44888056E-05_JPRB, 0.46582395E-05_JPRB, 0.48451346E-05_JPRB, 0.50466118E-05_JPRB, 0.52251100E-05_JPRB, 0.53596524E-05_JPRB, &
  & 0.54390884E-05_JPRB, 0.54600879E-05_JPRB, 0.54617232E-05_JPRB, 0.54566527E-05_JPRB, 0.54520007E-05_JPRB, 0.54681611E-05_JPRB, &
  & 0.54976082E-05_JPRB, 0.55412168E-05_JPRB, 0.56120081E-05_JPRB, 0.57191483E-05_JPRB, 0.58362967E-05_JPRB, 0.59568179E-05_JPRB, &
  & 0.60637207E-05_JPRB, 0.61174272E-05_JPRB, 0.60772644E-05_JPRB, 0.59326051E-05_JPRB, 0.57066841E-05_JPRB, 0.54653233E-05_JPRB, &
  & 0.52426812E-05_JPRB, 0.50692801E-05_JPRB, 0.49682324E-05_JPRB, 0.49267355E-05_JPRB, 0.49304880E-05_JPRB, 0.49599990E-05_JPRB, &
  & 0.49935493E-05_JPRB, 0.50200248E-05_JPRB, 0.50597007E-05_JPRB, 0.50796863E-05_JPRB, 0.50953025E-05_JPRB, 0.51224444E-05_JPRB, &
  & 0.51222362E-05_JPRB, 0.50907539E-05_JPRB, 0.50478571E-05_JPRB, 0.50337512E-05_JPRB, 0.50686373E-05_JPRB, 0.51255231E-05_JPRB, &
  & 0.51866727E-05_JPRB, 0.52490525E-05_JPRB, 0.52913663E-05_JPRB, 0.53213283E-05_JPRB, 0.53253248E-05_JPRB, 0.53437725E-05_JPRB, &
  & 0.53721189E-05_JPRB, 0.53715274E-05_JPRB, 0.53456704E-05_JPRB, 0.53439891E-05_JPRB  /)

RGHG7(:,25, 2) = (/ &
  & 0.32921442E-05_JPRB, 0.33368625E-05_JPRB, 0.33647219E-05_JPRB, 0.33386084E-05_JPRB, 0.33146752E-05_JPRB, 0.33381669E-05_JPRB, &
  & 0.34192313E-05_JPRB, 0.35397626E-05_JPRB, 0.36620400E-05_JPRB, 0.37750615E-05_JPRB, 0.38906456E-05_JPRB, 0.39995679E-05_JPRB, &
  & 0.40939820E-05_JPRB, 0.41997440E-05_JPRB, 0.43162975E-05_JPRB, 0.44456747E-05_JPRB, 0.45764565E-05_JPRB, 0.46815112E-05_JPRB, &
  & 0.47436620E-05_JPRB, 0.47482128E-05_JPRB, 0.47236415E-05_JPRB, 0.46858879E-05_JPRB, 0.46468373E-05_JPRB, 0.46312582E-05_JPRB, &
  & 0.46305314E-05_JPRB, 0.46338223E-05_JPRB, 0.46473753E-05_JPRB, 0.46948753E-05_JPRB, 0.47661517E-05_JPRB, 0.48690446E-05_JPRB, &
  & 0.49828957E-05_JPRB, 0.50575331E-05_JPRB, 0.50447992E-05_JPRB, 0.49207062E-05_JPRB, 0.46952785E-05_JPRB, 0.44441171E-05_JPRB, &
  & 0.42371945E-05_JPRB, 0.41111239E-05_JPRB, 0.40777584E-05_JPRB, 0.41152885E-05_JPRB, 0.42163182E-05_JPRB, 0.43365869E-05_JPRB, &
  & 0.44391491E-05_JPRB, 0.45401051E-05_JPRB, 0.46395928E-05_JPRB, 0.47112193E-05_JPRB, 0.47688474E-05_JPRB, 0.48284794E-05_JPRB, &
  & 0.48671306E-05_JPRB, 0.48686530E-05_JPRB, 0.48350636E-05_JPRB, 0.48184915E-05_JPRB, 0.48502250E-05_JPRB, 0.49178551E-05_JPRB, &
  & 0.49935662E-05_JPRB, 0.50649103E-05_JPRB, 0.51218500E-05_JPRB, 0.51639931E-05_JPRB, 0.51743160E-05_JPRB, 0.51975461E-05_JPRB, &
  & 0.52426201E-05_JPRB, 0.52465107E-05_JPRB, 0.52389039E-05_JPRB, 0.52554943E-05_JPRB  /)

RGHG7(:,26, 2) = (/ &
  & 0.32225099E-05_JPRB, 0.32343341E-05_JPRB, 0.32187287E-05_JPRB, 0.31760384E-05_JPRB, 0.31521168E-05_JPRB, 0.31699088E-05_JPRB, &
  & 0.32360980E-05_JPRB, 0.33313995E-05_JPRB, 0.34283221E-05_JPRB, 0.35176786E-05_JPRB, 0.36108397E-05_JPRB, 0.36931737E-05_JPRB, &
  & 0.37545045E-05_JPRB, 0.38147334E-05_JPRB, 0.38753754E-05_JPRB, 0.39405821E-05_JPRB, 0.40131954E-05_JPRB, 0.40746731E-05_JPRB, &
  & 0.41117140E-05_JPRB, 0.41021111E-05_JPRB, 0.40594895E-05_JPRB, 0.40044624E-05_JPRB, 0.39503170E-05_JPRB, 0.39193221E-05_JPRB, &
  & 0.39004670E-05_JPRB, 0.38761217E-05_JPRB, 0.38476203E-05_JPRB, 0.38369808E-05_JPRB, 0.38492718E-05_JPRB, 0.38997118E-05_JPRB, &
  & 0.39748625E-05_JPRB, 0.40332222E-05_JPRB, 0.40327695E-05_JPRB, 0.39413139E-05_JPRB, 0.37632881E-05_JPRB, 0.35644346E-05_JPRB, &
  & 0.34179139E-05_JPRB, 0.33656917E-05_JPRB, 0.33977703E-05_JPRB, 0.34937683E-05_JPRB, 0.36467554E-05_JPRB, 0.38045170E-05_JPRB, &
  & 0.39347678E-05_JPRB, 0.40732361E-05_JPRB, 0.42034431E-05_JPRB, 0.43105585E-05_JPRB, 0.44039944E-05_JPRB, 0.44946525E-05_JPRB, &
  & 0.45653616E-05_JPRB, 0.45967874E-05_JPRB, 0.45842838E-05_JPRB, 0.45742714E-05_JPRB, 0.46009977E-05_JPRB, 0.46637125E-05_JPRB, &
  & 0.47416959E-05_JPRB, 0.48177744E-05_JPRB, 0.48820329E-05_JPRB, 0.49257403E-05_JPRB, 0.49453486E-05_JPRB, 0.49782652E-05_JPRB, &
  & 0.50342457E-05_JPRB, 0.50398042E-05_JPRB, 0.50469074E-05_JPRB, 0.50827343E-05_JPRB  /)

RGHG7(:,27, 2) = (/ &
  & 0.31430061E-05_JPRB, 0.31202333E-05_JPRB, 0.30629874E-05_JPRB, 0.30098919E-05_JPRB, 0.29897322E-05_JPRB, 0.30024017E-05_JPRB, &
  & 0.30509422E-05_JPRB, 0.31178897E-05_JPRB, 0.31891998E-05_JPRB, 0.32571658E-05_JPRB, 0.33304170E-05_JPRB, 0.33874986E-05_JPRB, &
  & 0.34200953E-05_JPRB, 0.34394440E-05_JPRB, 0.34469799E-05_JPRB, 0.34480350E-05_JPRB, 0.34559565E-05_JPRB, 0.34666492E-05_JPRB, &
  & 0.34745358E-05_JPRB, 0.34509861E-05_JPRB, 0.33925166E-05_JPRB, 0.33251435E-05_JPRB, 0.32623738E-05_JPRB, 0.32213140E-05_JPRB, &
  & 0.31879717E-05_JPRB, 0.31394345E-05_JPRB, 0.30725943E-05_JPRB, 0.30017251E-05_JPRB, 0.29474834E-05_JPRB, 0.29301700E-05_JPRB, &
  & 0.29479325E-05_JPRB, 0.29754771E-05_JPRB, 0.29822479E-05_JPRB, 0.29293913E-05_JPRB, 0.28183184E-05_JPRB, 0.26971831E-05_JPRB, &
  & 0.26303817E-05_JPRB, 0.26652023E-05_JPRB, 0.27648742E-05_JPRB, 0.29143785E-05_JPRB, 0.31048841E-05_JPRB, 0.32820952E-05_JPRB, &
  & 0.34259728E-05_JPRB, 0.35899536E-05_JPRB, 0.37414911E-05_JPRB, 0.38797218E-05_JPRB, 0.40082950E-05_JPRB, 0.41308488E-05_JPRB, &
  & 0.42325531E-05_JPRB, 0.42940938E-05_JPRB, 0.43080032E-05_JPRB, 0.43081958E-05_JPRB, 0.43289992E-05_JPRB, 0.43807686E-05_JPRB, &
  & 0.44565709E-05_JPRB, 0.45360311E-05_JPRB, 0.46052320E-05_JPRB, 0.46466383E-05_JPRB, 0.46770519E-05_JPRB, 0.47219144E-05_JPRB, &
  & 0.47871394E-05_JPRB, 0.47933983E-05_JPRB, 0.48145684E-05_JPRB, 0.48708654E-05_JPRB  /)

RGHG7(:,28, 2) = (/ &
  & 0.30661128E-05_JPRB, 0.30269240E-05_JPRB, 0.29525703E-05_JPRB, 0.28986674E-05_JPRB, 0.28732275E-05_JPRB, 0.28762504E-05_JPRB, &
  & 0.29042771E-05_JPRB, 0.29502734E-05_JPRB, 0.30027319E-05_JPRB, 0.30531910E-05_JPRB, 0.31061549E-05_JPRB, 0.31422578E-05_JPRB, &
  & 0.31555814E-05_JPRB, 0.31498180E-05_JPRB, 0.31297692E-05_JPRB, 0.30987549E-05_JPRB, 0.30649249E-05_JPRB, 0.30295158E-05_JPRB, &
  & 0.29944417E-05_JPRB, 0.29423235E-05_JPRB, 0.28704494E-05_JPRB, 0.27933449E-05_JPRB, 0.27233141E-05_JPRB, 0.26753681E-05_JPRB, &
  & 0.26356630E-05_JPRB, 0.25847639E-05_JPRB, 0.25116856E-05_JPRB, 0.24268455E-05_JPRB, 0.23485083E-05_JPRB, 0.22946349E-05_JPRB, &
  & 0.22641604E-05_JPRB, 0.22530779E-05_JPRB, 0.22507704E-05_JPRB, 0.22277503E-05_JPRB, 0.21834671E-05_JPRB, 0.21459784E-05_JPRB, &
  & 0.21566276E-05_JPRB, 0.22453828E-05_JPRB, 0.23795832E-05_JPRB, 0.25396733E-05_JPRB, 0.27092609E-05_JPRB, 0.28755505E-05_JPRB, &
  & 0.30169592E-05_JPRB, 0.31791210E-05_JPRB, 0.33381535E-05_JPRB, 0.35013615E-05_JPRB, 0.36623739E-05_JPRB, 0.38120605E-05_JPRB, &
  & 0.39350191E-05_JPRB, 0.40189580E-05_JPRB, 0.40539250E-05_JPRB, 0.40677154E-05_JPRB, 0.40916225E-05_JPRB, 0.41363550E-05_JPRB, &
  & 0.42041369E-05_JPRB, 0.42786008E-05_JPRB, 0.43430990E-05_JPRB, 0.43825059E-05_JPRB, 0.44129625E-05_JPRB, 0.44692836E-05_JPRB, &
  & 0.45403831E-05_JPRB, 0.45445448E-05_JPRB, 0.45653715E-05_JPRB, 0.46238178E-05_JPRB  /)

RGHG7(:,29, 2) = (/ &
  & 0.29847512E-05_JPRB, 0.29289567E-05_JPRB, 0.28375394E-05_JPRB, 0.27831971E-05_JPRB, 0.27517704E-05_JPRB, 0.27443758E-05_JPRB, &
  & 0.27505422E-05_JPRB, 0.27746598E-05_JPRB, 0.28074368E-05_JPRB, 0.28395141E-05_JPRB, 0.28709657E-05_JPRB, 0.28850252E-05_JPRB, &
  & 0.28783377E-05_JPRB, 0.28466495E-05_JPRB, 0.27984789E-05_JPRB, 0.27348756E-05_JPRB, 0.26578010E-05_JPRB, 0.25737464E-05_JPRB, &
  & 0.24925533E-05_JPRB, 0.24095304E-05_JPRB, 0.23235587E-05_JPRB, 0.22362564E-05_JPRB, 0.21585910E-05_JPRB, 0.21034864E-05_JPRB, &
  & 0.20573917E-05_JPRB, 0.20049363E-05_JPRB, 0.19266401E-05_JPRB, 0.18290024E-05_JPRB, 0.17269741E-05_JPRB, 0.16357148E-05_JPRB, &
  & 0.15545259E-05_JPRB, 0.15021761E-05_JPRB, 0.14895427E-05_JPRB, 0.14977568E-05_JPRB, 0.15242358E-05_JPRB, 0.15756346E-05_JPRB, &
  & 0.16682507E-05_JPRB, 0.18127186E-05_JPRB, 0.19820712E-05_JPRB, 0.21515169E-05_JPRB, 0.22964064E-05_JPRB, 0.24498068E-05_JPRB, &
  & 0.25879017E-05_JPRB, 0.27469511E-05_JPRB, 0.29133253E-05_JPRB, 0.31027327E-05_JPRB, 0.32980002E-05_JPRB, 0.34762297E-05_JPRB, &
  & 0.36212866E-05_JPRB, 0.37286237E-05_JPRB, 0.37856706E-05_JPRB, 0.38140163E-05_JPRB, 0.38416034E-05_JPRB, 0.38790492E-05_JPRB, &
  & 0.39380796E-05_JPRB, 0.40068862E-05_JPRB, 0.40659834E-05_JPRB, 0.41032848E-05_JPRB, 0.41333203E-05_JPRB, 0.42017616E-05_JPRB, &
  & 0.42789395E-05_JPRB, 0.42807577E-05_JPRB, 0.43005958E-05_JPRB, 0.43605251E-05_JPRB  /)

RGHG7(:,30, 2) = (/ &
  & 0.28389237E-05_JPRB, 0.27804765E-05_JPRB, 0.26940942E-05_JPRB, 0.26426787E-05_JPRB, 0.26188703E-05_JPRB, 0.26092467E-05_JPRB, &
  & 0.26069013E-05_JPRB, 0.26186791E-05_JPRB, 0.26364484E-05_JPRB, 0.26514927E-05_JPRB, 0.26616622E-05_JPRB, 0.26549861E-05_JPRB, &
  & 0.26282725E-05_JPRB, 0.25786116E-05_JPRB, 0.25123376E-05_JPRB, 0.24293081E-05_JPRB, 0.23306425E-05_JPRB, 0.22232549E-05_JPRB, &
  & 0.21187955E-05_JPRB, 0.20148039E-05_JPRB, 0.19162099E-05_JPRB, 0.18230761E-05_JPRB, 0.17379732E-05_JPRB, 0.16747238E-05_JPRB, &
  & 0.16256318E-05_JPRB, 0.15775820E-05_JPRB, 0.15165549E-05_JPRB, 0.14402648E-05_JPRB, 0.13574512E-05_JPRB, 0.12766448E-05_JPRB, &
  & 0.11993025E-05_JPRB, 0.11465296E-05_JPRB, 0.11328253E-05_JPRB, 0.11499779E-05_JPRB, 0.11926686E-05_JPRB, 0.12605528E-05_JPRB, &
  & 0.13585825E-05_JPRB, 0.14948334E-05_JPRB, 0.16413789E-05_JPRB, 0.17758994E-05_JPRB, 0.18986355E-05_JPRB, 0.20433713E-05_JPRB, &
  & 0.21878966E-05_JPRB, 0.23537627E-05_JPRB, 0.25352943E-05_JPRB, 0.27452481E-05_JPRB, 0.29654118E-05_JPRB, 0.31667309E-05_JPRB, &
  & 0.33326200E-05_JPRB, 0.34563513E-05_JPRB, 0.35245159E-05_JPRB, 0.35643584E-05_JPRB, 0.36015668E-05_JPRB, 0.36415472E-05_JPRB, &
  & 0.36968062E-05_JPRB, 0.37531589E-05_JPRB, 0.38043382E-05_JPRB, 0.38420880E-05_JPRB, 0.38808405E-05_JPRB, 0.39544716E-05_JPRB, &
  & 0.40277628E-05_JPRB, 0.40345969E-05_JPRB, 0.40449126E-05_JPRB, 0.40874085E-05_JPRB  /)

RGHG7(:,31, 2) = (/ &
  & 0.26852109E-05_JPRB, 0.26239820E-05_JPRB, 0.25429257E-05_JPRB, 0.24945973E-05_JPRB, 0.24788287E-05_JPRB, 0.24668644E-05_JPRB, &
  & 0.24555631E-05_JPRB, 0.24543482E-05_JPRB, 0.24563090E-05_JPRB, 0.24534076E-05_JPRB, 0.24411535E-05_JPRB, 0.24126305E-05_JPRB, &
  & 0.23648163E-05_JPRB, 0.22962260E-05_JPRB, 0.22108868E-05_JPRB, 0.21074013E-05_JPRB, 0.19860067E-05_JPRB, 0.18540583E-05_JPRB, &
  & 0.17251060E-05_JPRB, 0.15990300E-05_JPRB, 0.14871379E-05_JPRB, 0.13878639E-05_JPRB, 0.12949245E-05_JPRB, 0.12230925E-05_JPRB, &
  & 0.11708455E-05_JPRB, 0.11274433E-05_JPRB, 0.10846333E-05_JPRB, 0.10308686E-05_JPRB, 0.96834137E-06_JPRB, 0.89859417E-06_JPRB, &
  & 0.82535658E-06_JPRB, 0.77217659E-06_JPRB, 0.75735288E-06_JPRB, 0.78390232E-06_JPRB, 0.84362274E-06_JPRB, 0.92880806E-06_JPRB, &
  & 0.10324691E-05_JPRB, 0.11600016E-05_JPRB, 0.12824613E-05_JPRB, 0.13801405E-05_JPRB, 0.14795370E-05_JPRB, 0.16151474E-05_JPRB, &
  & 0.17664574E-05_JPRB, 0.19395154E-05_JPRB, 0.21370251E-05_JPRB, 0.23686222E-05_JPRB, 0.26150090E-05_JPRB, 0.28406514E-05_JPRB, &
  & 0.30284892E-05_JPRB, 0.31694877E-05_JPRB, 0.32493560E-05_JPRB, 0.33013093E-05_JPRB, 0.33486609E-05_JPRB, 0.33913213E-05_JPRB, &
  & 0.34426112E-05_JPRB, 0.34858354E-05_JPRB, 0.35286694E-05_JPRB, 0.35668942E-05_JPRB, 0.36148400E-05_JPRB, 0.36939329E-05_JPRB, &
  & 0.37631192E-05_JPRB, 0.37752455E-05_JPRB, 0.37755197E-05_JPRB, 0.37996290E-05_JPRB  /)

RGHG7(:,32, 2) = (/ &
  & 0.25183506E-05_JPRB, 0.24640774E-05_JPRB, 0.23946436E-05_JPRB, 0.23505349E-05_JPRB, 0.23338274E-05_JPRB, 0.23181357E-05_JPRB, &
  & 0.23015822E-05_JPRB, 0.22904897E-05_JPRB, 0.22799126E-05_JPRB, 0.22631441E-05_JPRB, 0.22350796E-05_JPRB, 0.21903459E-05_JPRB, &
  & 0.21270316E-05_JPRB, 0.20452572E-05_JPRB, 0.19470193E-05_JPRB, 0.18312456E-05_JPRB, 0.17003968E-05_JPRB, 0.15624779E-05_JPRB, &
  & 0.14293376E-05_JPRB, 0.13030543E-05_JPRB, 0.11910545E-05_JPRB, 0.10953330E-05_JPRB, 0.10077791E-05_JPRB, 0.93963860E-06_JPRB, &
  & 0.88922680E-06_JPRB, 0.84781403E-06_JPRB, 0.81253833E-06_JPRB, 0.77372149E-06_JPRB, 0.73105534E-06_JPRB, 0.68290509E-06_JPRB, &
  & 0.63065788E-06_JPRB, 0.59245223E-06_JPRB, 0.58332112E-06_JPRB, 0.60637841E-06_JPRB, 0.65392175E-06_JPRB, 0.71901341E-06_JPRB, &
  & 0.79380555E-06_JPRB, 0.88309679E-06_JPRB, 0.97025503E-06_JPRB, 0.10488881E-05_JPRB, 0.11418760E-05_JPRB, 0.12700034E-05_JPRB, &
  & 0.14199351E-05_JPRB, 0.15938170E-05_JPRB, 0.17990772E-05_JPRB, 0.20440772E-05_JPRB, 0.23057941E-05_JPRB, 0.25466656E-05_JPRB, &
  & 0.27493326E-05_JPRB, 0.29040685E-05_JPRB, 0.29942722E-05_JPRB, 0.30583811E-05_JPRB, 0.31114988E-05_JPRB, 0.31566407E-05_JPRB, &
  & 0.32033128E-05_JPRB, 0.32423518E-05_JPRB, 0.32825136E-05_JPRB, 0.33224022E-05_JPRB, 0.33759542E-05_JPRB, 0.34577003E-05_JPRB, &
  & 0.35314565E-05_JPRB, 0.35532627E-05_JPRB, 0.35547457E-05_JPRB, 0.35589039E-05_JPRB  /)

RGHG7(:,33, 2) = (/ &
  & 0.23432392E-05_JPRB, 0.22974556E-05_JPRB, 0.22409156E-05_JPRB, 0.22013389E-05_JPRB, 0.21824931E-05_JPRB, 0.21627481E-05_JPRB, &
  & 0.21412157E-05_JPRB, 0.21202614E-05_JPRB, 0.20970777E-05_JPRB, 0.20664260E-05_JPRB, 0.20227868E-05_JPRB, 0.19619357E-05_JPRB, &
  & 0.18832383E-05_JPRB, 0.17885061E-05_JPRB, 0.16776617E-05_JPRB, 0.15501750E-05_JPRB, 0.14112197E-05_JPRB, 0.12695029E-05_JPRB, &
  & 0.11346391E-05_JPRB, 0.10109729E-05_JPRB, 0.90056880E-06_JPRB, 0.80979424E-06_JPRB, 0.72954895E-06_JPRB, 0.66683409E-06_JPRB, &
  & 0.61897552E-06_JPRB, 0.57928618E-06_JPRB, 0.55045740E-06_JPRB, 0.52619401E-06_JPRB, 0.50411331E-06_JPRB, 0.47977197E-06_JPRB, &
  & 0.45152518E-06_JPRB, 0.43087302E-06_JPRB, 0.42853989E-06_JPRB, 0.44629923E-06_JPRB, 0.47740612E-06_JPRB, 0.51677392E-06_JPRB, &
  & 0.55709740E-06_JPRB, 0.60282407E-06_JPRB, 0.65184336E-06_JPRB, 0.71298680E-06_JPRB, 0.80150650E-06_JPRB, 0.92206993E-06_JPRB, &
  & 0.10695122E-05_JPRB, 0.12434261E-05_JPRB, 0.14556758E-05_JPRB, 0.17135376E-05_JPRB, 0.19897761E-05_JPRB, 0.22452967E-05_JPRB, &
  & 0.24624534E-05_JPRB, 0.26310086E-05_JPRB, 0.27317764E-05_JPRB, 0.28085238E-05_JPRB, 0.28670672E-05_JPRB, 0.29147623E-05_JPRB, &
  & 0.29565513E-05_JPRB, 0.29923988E-05_JPRB, 0.30305180E-05_JPRB, 0.30722895E-05_JPRB, 0.31312034E-05_JPRB, 0.32153431E-05_JPRB, &
  & 0.32949718E-05_JPRB, 0.33274058E-05_JPRB, 0.33316016E-05_JPRB, 0.33148233E-05_JPRB  /)

RGHG7(:,34, 2) = (/ &
  & 0.21529566E-05_JPRB, 0.21166285E-05_JPRB, 0.20678016E-05_JPRB, 0.20305024E-05_JPRB, 0.20092921E-05_JPRB, 0.19856997E-05_JPRB, &
  & 0.19598581E-05_JPRB, 0.19328150E-05_JPRB, 0.19025326E-05_JPRB, 0.18645110E-05_JPRB, 0.18133614E-05_JPRB, 0.17458378E-05_JPRB, &
  & 0.16603662E-05_JPRB, 0.15589566E-05_JPRB, 0.14416860E-05_JPRB, 0.13104150E-05_JPRB, 0.11719505E-05_JPRB, 0.10349836E-05_JPRB, &
  & 0.90752022E-06_JPRB, 0.79464031E-06_JPRB, 0.69498995E-06_JPRB, 0.61454760E-06_JPRB, 0.54561296E-06_JPRB, 0.49187169E-06_JPRB, &
  & 0.44991674E-06_JPRB, 0.41483636E-06_JPRB, 0.39003705E-06_JPRB, 0.37254048E-06_JPRB, 0.35996503E-06_JPRB, 0.34798916E-06_JPRB, &
  & 0.33361271E-06_JPRB, 0.32299356E-06_JPRB, 0.32305822E-06_JPRB, 0.33430756E-06_JPRB, 0.35239069E-06_JPRB, 0.37470112E-06_JPRB, &
  & 0.39674670E-06_JPRB, 0.42235848E-06_JPRB, 0.45468333E-06_JPRB, 0.50460445E-06_JPRB, 0.58350857E-06_JPRB, 0.69040897E-06_JPRB, &
  & 0.82389853E-06_JPRB, 0.98627476E-06_JPRB, 0.11918973E-05_JPRB, 0.14452024E-05_JPRB, 0.17200883E-05_JPRB, 0.19780458E-05_JPRB, &
  & 0.22001610E-05_JPRB, 0.23794083E-05_JPRB, 0.24924937E-05_JPRB, 0.25796938E-05_JPRB, 0.26422725E-05_JPRB, 0.26909137E-05_JPRB, &
  & 0.27287136E-05_JPRB, 0.27634216E-05_JPRB, 0.28003228E-05_JPRB, 0.28425291E-05_JPRB, 0.29053993E-05_JPRB, 0.29947746E-05_JPRB, &
  & 0.30825457E-05_JPRB, 0.31295283E-05_JPRB, 0.31364527E-05_JPRB, 0.31164702E-05_JPRB  /)

RGHG7(:,35, 2) = (/ &
  & 0.19495362E-05_JPRB, 0.19234255E-05_JPRB, 0.18798702E-05_JPRB, 0.18437556E-05_JPRB, 0.18199984E-05_JPRB, 0.17925559E-05_JPRB, &
  & 0.17626274E-05_JPRB, 0.17312604E-05_JPRB, 0.16965061E-05_JPRB, 0.16542495E-05_JPRB, 0.15995164E-05_JPRB, 0.15299788E-05_JPRB, &
  & 0.14419604E-05_JPRB, 0.13369080E-05_JPRB, 0.12162020E-05_JPRB, 0.10851087E-05_JPRB, 0.95156042E-06_JPRB, 0.82386312E-06_JPRB, &
  & 0.70869027E-06_JPRB, 0.61109203E-06_JPRB, 0.52719717E-06_JPRB, 0.46014107E-06_JPRB, 0.40488885E-06_JPRB, 0.36219420E-06_JPRB, &
  & 0.32802817E-06_JPRB, 0.29916706E-06_JPRB, 0.27727008E-06_JPRB, 0.26273507E-06_JPRB, 0.25424658E-06_JPRB, 0.24911191E-06_JPRB, &
  & 0.24379784E-06_JPRB, 0.23963490E-06_JPRB, 0.23990687E-06_JPRB, 0.24384115E-06_JPRB, 0.25028534E-06_JPRB, 0.25950567E-06_JPRB, &
  & 0.27106732E-06_JPRB, 0.28803135E-06_JPRB, 0.31419615E-06_JPRB, 0.35579528E-06_JPRB, 0.42217200E-06_JPRB, 0.51189533E-06_JPRB, &
  & 0.62515743E-06_JPRB, 0.76973468E-06_JPRB, 0.96155630E-06_JPRB, 0.12012382E-05_JPRB, 0.14665879E-05_JPRB, 0.17207842E-05_JPRB, &
  & 0.19431068E-05_JPRB, 0.21317422E-05_JPRB, 0.22583916E-05_JPRB, 0.23552167E-05_JPRB, 0.24212308E-05_JPRB, 0.24700202E-05_JPRB, &
  & 0.25041773E-05_JPRB, 0.25387668E-05_JPRB, 0.25748388E-05_JPRB, 0.26167489E-05_JPRB, 0.26829657E-05_JPRB, 0.27791822E-05_JPRB, &
  & 0.28764896E-05_JPRB, 0.29404419E-05_JPRB, 0.29501798E-05_JPRB, 0.29360019E-05_JPRB  /)

RGHG7(:,36, 2) = (/ &
  & 0.17443464E-05_JPRB, 0.17274590E-05_JPRB, 0.16887282E-05_JPRB, 0.16544445E-05_JPRB, 0.16290828E-05_JPRB, 0.15987218E-05_JPRB, &
  & 0.15658503E-05_JPRB, 0.15314654E-05_JPRB, 0.14941467E-05_JPRB, 0.14496037E-05_JPRB, 0.13935122E-05_JPRB, 0.13241618E-05_JPRB, &
  & 0.12361891E-05_JPRB, 0.11302864E-05_JPRB, 0.10093087E-05_JPRB, 0.88097346E-06_JPRB, 0.75483256E-06_JPRB, 0.63857174E-06_JPRB, &
  & 0.53688616E-06_JPRB, 0.45431412E-06_JPRB, 0.38563789E-06_JPRB, 0.33128958E-06_JPRB, 0.28839678E-06_JPRB, 0.25557312E-06_JPRB, &
  & 0.22845827E-06_JPRB, 0.20520431E-06_JPRB, 0.18636576E-06_JPRB, 0.17449115E-06_JPRB, 0.16891168E-06_JPRB, 0.16823453E-06_JPRB, &
  & 0.16886973E-06_JPRB, 0.16909418E-06_JPRB, 0.16941172E-06_JPRB, 0.16841679E-06_JPRB, 0.16712540E-06_JPRB, 0.16762257E-06_JPRB, &
  & 0.17212450E-06_JPRB, 0.18283264E-06_JPRB, 0.20370314E-06_JPRB, 0.23755964E-06_JPRB, 0.29185502E-06_JPRB, 0.36557088E-06_JPRB, &
  & 0.46022052E-06_JPRB, 0.58706254E-06_JPRB, 0.76290319E-06_JPRB, 0.98531693E-06_JPRB, 0.12361213E-05_JPRB, 0.14824013E-05_JPRB, &
  & 0.17010965E-05_JPRB, 0.18947785E-05_JPRB, 0.20326029E-05_JPRB, 0.21367923E-05_JPRB, 0.22058031E-05_JPRB, 0.22548075E-05_JPRB, &
  & 0.22867602E-05_JPRB, 0.23209695E-05_JPRB, 0.23561398E-05_JPRB, 0.23975351E-05_JPRB, 0.24657885E-05_JPRB, 0.25666994E-05_JPRB, &
  & 0.26728058E-05_JPRB, 0.27512475E-05_JPRB, 0.27656734E-05_JPRB, 0.27572231E-05_JPRB  /)

RGHG7(:,37, 2) = (/ &
  & 0.15478657E-05_JPRB, 0.15373484E-05_JPRB, 0.15021170E-05_JPRB, 0.14710320E-05_JPRB, 0.14463265E-05_JPRB, 0.14153640E-05_JPRB, &
  & 0.13823559E-05_JPRB, 0.13481350E-05_JPRB, 0.13127847E-05_JPRB, 0.12705656E-05_JPRB, 0.12183016E-05_JPRB, 0.11541730E-05_JPRB, &
  & 0.10721876E-05_JPRB, 0.97188948E-06_JPRB, 0.85791072E-06_JPRB, 0.73807798E-06_JPRB, 0.62459521E-06_JPRB, 0.52402720E-06_JPRB, &
  & 0.43773369E-06_JPRB, 0.36866730E-06_JPRB, 0.31303196E-06_JPRB, 0.26904527E-06_JPRB, 0.23470970E-06_JPRB, 0.20844749E-06_JPRB, &
  & 0.18625373E-06_JPRB, 0.16685463E-06_JPRB, 0.15124212E-06_JPRB, 0.14117191E-06_JPRB, 0.13561978E-06_JPRB, 0.13365767E-06_JPRB, &
  & 0.13273453E-06_JPRB, 0.13233018E-06_JPRB, 0.13231965E-06_JPRB, 0.13217223E-06_JPRB, 0.13257589E-06_JPRB, 0.13490479E-06_JPRB, &
  & 0.14063699E-06_JPRB, 0.15096239E-06_JPRB, 0.16885289E-06_JPRB, 0.19677674E-06_JPRB, 0.24076518E-06_JPRB, 0.30215098E-06_JPRB, &
  & 0.38304891E-06_JPRB, 0.49340528E-06_JPRB, 0.64926085E-06_JPRB, 0.84712383E-06_JPRB, 0.10728033E-05_JPRB, 0.13021328E-05_JPRB, &
  & 0.15086347E-05_JPRB, 0.16970949E-05_JPRB, 0.18399224E-05_JPRB, 0.19458342E-05_JPRB, 0.20166494E-05_JPRB, 0.20660092E-05_JPRB, &
  & 0.20991922E-05_JPRB, 0.21324446E-05_JPRB, 0.21666033E-05_JPRB, 0.22070144E-05_JPRB, 0.22741742E-05_JPRB, 0.23745657E-05_JPRB, &
  & 0.24872336E-05_JPRB, 0.25735764E-05_JPRB, 0.25966961E-05_JPRB, 0.25934403E-05_JPRB  /)

RGHG7(:,38, 2) = (/ &
  & 0.13298530E-05_JPRB, 0.13264038E-05_JPRB, 0.12950554E-05_JPRB, 0.12675197E-05_JPRB, 0.12435422E-05_JPRB, 0.12119123E-05_JPRB, &
  & 0.11787525E-05_JPRB, 0.11447136E-05_JPRB, 0.11115474E-05_JPRB, 0.10719069E-05_JPRB, 0.10238898E-05_JPRB, 0.96555533E-06_JPRB, &
  & 0.89021342E-06_JPRB, 0.79613404E-06_JPRB, 0.68992117E-06_JPRB, 0.57952276E-06_JPRB, 0.48008532E-06_JPRB, 0.39692986E-06_JPRB, &
  & 0.32771522E-06_JPRB, 0.27363455E-06_JPRB, 0.23246923E-06_JPRB, 0.19997969E-06_JPRB, 0.17513912E-06_JPRB, 0.15615742E-06_JPRB, &
  & 0.13942404E-06_JPRB, 0.12430224E-06_JPRB, 0.11226932E-06_JPRB, 0.10420125E-06_JPRB, 0.98679455E-07_JPRB, 0.95291586E-07_JPRB, &
  & 0.92639323E-07_JPRB, 0.91537250E-07_JPRB, 0.91162693E-07_JPRB, 0.91955677E-07_JPRB, 0.94240136E-07_JPRB, 0.98601514E-07_JPRB, &
  & 0.10569881E-06_JPRB, 0.11559951E-06_JPRB, 0.13018345E-06_JPRB, 0.15152450E-06_JPRB, 0.18407647E-06_JPRB, 0.23178097E-06_JPRB, &
  & 0.29742016E-06_JPRB, 0.38948424E-06_JPRB, 0.52316458E-06_JPRB, 0.69378631E-06_JPRB, 0.89158747E-06_JPRB, 0.11021090E-05_JPRB, &
  & 0.12950813E-05_JPRB, 0.14777474E-05_JPRB, 0.16261263E-05_JPRB, 0.17339492E-05_JPRB, 0.18067665E-05_JPRB, 0.18565207E-05_JPRB, &
  & 0.18910688E-05_JPRB, 0.19232595E-05_JPRB, 0.19562958E-05_JPRB, 0.19956148E-05_JPRB, 0.20615612E-05_JPRB, 0.21613763E-05_JPRB, &
  & 0.22813247E-05_JPRB, 0.23764344E-05_JPRB, 0.24092009E-05_JPRB, 0.24117088E-05_JPRB  /)

RGHG7(:,39, 2) = (/ &
  & 0.11784483E-05_JPRB, 0.11764966E-05_JPRB, 0.11487543E-05_JPRB, 0.11237583E-05_JPRB, 0.11007645E-05_JPRB, 0.10704385E-05_JPRB, &
  & 0.10390492E-05_JPRB, 0.10070291E-05_JPRB, 0.97634477E-06_JPRB, 0.93960522E-06_JPRB, 0.89635155E-06_JPRB, 0.84367887E-06_JPRB, &
  & 0.77584820E-06_JPRB, 0.69098452E-06_JPRB, 0.59532213E-06_JPRB, 0.49691110E-06_JPRB, 0.40971973E-06_JPRB, 0.33812045E-06_JPRB, &
  & 0.27949386E-06_JPRB, 0.23426146E-06_JPRB, 0.20015761E-06_JPRB, 0.17311122E-06_JPRB, 0.15215972E-06_JPRB, 0.13563974E-06_JPRB, &
  & 0.12098175E-06_JPRB, 0.10776877E-06_JPRB, 0.97450213E-07_JPRB, 0.90041664E-07_JPRB, 0.84534487E-07_JPRB, 0.80841264E-07_JPRB, &
  & 0.78119270E-07_JPRB, 0.77019110E-07_JPRB, 0.76676381E-07_JPRB, 0.77486235E-07_JPRB, 0.79880802E-07_JPRB, 0.84458120E-07_JPRB, &
  & 0.91700618E-07_JPRB, 0.10142935E-06_JPRB, 0.11472507E-06_JPRB, 0.13334066E-06_JPRB, 0.16113328E-06_JPRB, 0.20248374E-06_JPRB, &
  & 0.26096496E-06_JPRB, 0.34247800E-06_JPRB, 0.46225211E-06_JPRB, 0.61548952E-06_JPRB, 0.79503203E-06_JPRB, 0.98898288E-06_JPRB, &
  & 0.11689540E-05_JPRB, 0.13381689E-05_JPRB, 0.14792522E-05_JPRB, 0.15830324E-05_JPRB, 0.16540437E-05_JPRB, 0.17031916E-05_JPRB, &
  & 0.17385612E-05_JPRB, 0.17721057E-05_JPRB, 0.18046119E-05_JPRB, 0.18420409E-05_JPRB, 0.19043478E-05_JPRB, 0.19961940E-05_JPRB, &
  & 0.21110220E-05_JPRB, 0.22084371E-05_JPRB, 0.22514059E-05_JPRB, 0.22559608E-05_JPRB  /)

RGHG7(:,40, 2) = (/ &
  & 0.10116593E-05_JPRB, 0.10105538E-05_JPRB, 0.98699822E-06_JPRB, 0.96481774E-06_JPRB, 0.94302011E-06_JPRB, 0.91454675E-06_JPRB, &
  & 0.88554997E-06_JPRB, 0.85619945E-06_JPRB, 0.82847647E-06_JPRB, 0.79519428E-06_JPRB, 0.75761534E-06_JPRB, 0.71156561E-06_JPRB, &
  & 0.65269198E-06_JPRB, 0.57913400E-06_JPRB, 0.49630904E-06_JPRB, 0.41238390E-06_JPRB, 0.33926994E-06_JPRB, 0.28027470E-06_JPRB, &
  & 0.23301216E-06_JPRB, 0.19715984E-06_JPRB, 0.17013117E-06_JPRB, 0.14848235E-06_JPRB, 0.13117784E-06_JPRB, 0.11675854E-06_JPRB, &
  & 0.10398240E-06_JPRB, 0.92622096E-07_JPRB, 0.84010335E-07_JPRB, 0.77156129E-07_JPRB, 0.71663540E-07_JPRB, 0.67795261E-07_JPRB, &
  & 0.65262912E-07_JPRB, 0.64279455E-07_JPRB, 0.64038842E-07_JPRB, 0.64717404E-07_JPRB, 0.66951503E-07_JPRB, 0.71485058E-07_JPRB, &
  & 0.78698379E-07_JPRB, 0.88266643E-07_JPRB, 0.10038073E-06_JPRB, 0.11642884E-06_JPRB, 0.13972836E-06_JPRB, 0.17482056E-06_JPRB, &
  & 0.22622660E-06_JPRB, 0.29662358E-06_JPRB, 0.40143041E-06_JPRB, 0.53587848E-06_JPRB, 0.69556672E-06_JPRB, 0.87043647E-06_JPRB, &
  & 0.10352360E-05_JPRB, 0.11874121E-05_JPRB, 0.13178317E-05_JPRB, 0.14158933E-05_JPRB, 0.14841621E-05_JPRB, 0.15324347E-05_JPRB, &
  & 0.15686796E-05_JPRB, 0.16042080E-05_JPRB, 0.16361891E-05_JPRB, 0.16712694E-05_JPRB, 0.17289082E-05_JPRB, 0.18101926E-05_JPRB, &
  & 0.19169826E-05_JPRB, 0.20160462E-05_JPRB, 0.20710793E-05_JPRB, 0.20774286E-05_JPRB  /)

RGHG7(:,41, 2) = (/ &
  & 0.80773571E-06_JPRB, 0.80766463E-06_JPRB, 0.78922798E-06_JPRB, 0.77048984E-06_JPRB, 0.75015476E-06_JPRB, 0.72394657E-06_JPRB, &
  & 0.69787488E-06_JPRB, 0.67178834E-06_JPRB, 0.64768605E-06_JPRB, 0.61863098E-06_JPRB, 0.58799023E-06_JPRB, 0.55003802E-06_JPRB, &
  & 0.50211565E-06_JPRB, 0.44238052E-06_JPRB, 0.37525120E-06_JPRB, 0.30903715E-06_JPRB, 0.25313488E-06_JPRB, 0.20954989E-06_JPRB, &
  & 0.17618155E-06_JPRB, 0.15179774E-06_JPRB, 0.13341951E-06_JPRB, 0.11836998E-06_JPRB, 0.10552446E-06_JPRB, 0.93673532E-07_JPRB, &
  & 0.83198229E-07_JPRB, 0.74103092E-07_JPRB, 0.67578136E-07_JPRB, 0.61401696E-07_JPRB, 0.55926943E-07_JPRB, 0.51844633E-07_JPRB, &
  & 0.49544150E-07_JPRB, 0.48703381E-07_JPRB, 0.48587620E-07_JPRB, 0.49105659E-07_JPRB, 0.51143562E-07_JPRB, 0.55623609E-07_JPRB, &
  & 0.62801259E-07_JPRB, 0.72173327E-07_JPRB, 0.82842707E-07_JPRB, 0.95751688E-07_JPRB, 0.11355773E-06_JPRB, 0.14099832E-06_JPRB, &
  & 0.18375392E-06_JPRB, 0.24055992E-06_JPRB, 0.32706707E-06_JPRB, 0.43854244E-06_JPRB, 0.57395596E-06_JPRB, 0.72549629E-06_JPRB, &
  & 0.87174648E-06_JPRB, 0.10030902E-05_JPRB, 0.11204716E-05_JPRB, 0.12115417E-05_JPRB, 0.12764572E-05_JPRB, 0.13236597E-05_JPRB, &
  & 0.13609748E-05_JPRB, 0.13989289E-05_JPRB, 0.14302678E-05_JPRB, 0.14624766E-05_JPRB, 0.15144078E-05_JPRB, 0.15827791E-05_JPRB, &
  & 0.16797415E-05_JPRB, 0.17808205E-05_JPRB, 0.18506039E-05_JPRB, 0.18591470E-05_JPRB  /)

RGHG7(:,42, 2) = (/ &
  & 0.76532441E-06_JPRB, 0.75778514E-06_JPRB, 0.73913342E-06_JPRB, 0.72110564E-06_JPRB, 0.70195149E-06_JPRB, 0.67855129E-06_JPRB, &
  & 0.65399302E-06_JPRB, 0.62873948E-06_JPRB, 0.60483923E-06_JPRB, 0.57982688E-06_JPRB, 0.55351264E-06_JPRB, 0.52016954E-06_JPRB, &
  & 0.47738133E-06_JPRB, 0.42389478E-06_JPRB, 0.36359662E-06_JPRB, 0.30345637E-06_JPRB, 0.25153009E-06_JPRB, 0.20989720E-06_JPRB, &
  & 0.17690102E-06_JPRB, 0.15187326E-06_JPRB, 0.13292627E-06_JPRB, 0.11731085E-06_JPRB, 0.10392506E-06_JPRB, 0.91923828E-07_JPRB, &
  & 0.81694320E-07_JPRB, 0.72803947E-07_JPRB, 0.66124332E-07_JPRB, 0.60052586E-07_JPRB, 0.55147917E-07_JPRB, 0.51822138E-07_JPRB, &
  & 0.50145099E-07_JPRB, 0.49545589E-07_JPRB, 0.49467382E-07_JPRB, 0.50080383E-07_JPRB, 0.52114368E-07_JPRB, 0.56253262E-07_JPRB, &
  & 0.62676405E-07_JPRB, 0.71099683E-07_JPRB, 0.81582438E-07_JPRB, 0.94775820E-07_JPRB, 0.11291566E-06_JPRB, 0.13975991E-06_JPRB, &
  & 0.18136808E-06_JPRB, 0.23808319E-06_JPRB, 0.32241926E-06_JPRB, 0.43369526E-06_JPRB, 0.56717072E-06_JPRB, 0.71112088E-06_JPRB, &
  & 0.84671744E-06_JPRB, 0.96389448E-06_JPRB, 0.10665006E-05_JPRB, 0.11476001E-05_JPRB, 0.12072125E-05_JPRB, 0.12506965E-05_JPRB, &
  & 0.12849809E-05_JPRB, 0.13190339E-05_JPRB, 0.13513120E-05_JPRB, 0.13805358E-05_JPRB, 0.14228745E-05_JPRB, 0.14823508E-05_JPRB, &
  & 0.15691756E-05_JPRB, 0.16649465E-05_JPRB, 0.17352769E-05_JPRB, 0.17421494E-05_JPRB  /)

RGHG7(:,43, 2) = (/ &
  & 0.63891087E-06_JPRB, 0.62500266E-06_JPRB, 0.60835664E-06_JPRB, 0.59245769E-06_JPRB, 0.57501014E-06_JPRB, 0.55514627E-06_JPRB, &
  & 0.53322707E-06_JPRB, 0.51013756E-06_JPRB, 0.48797909E-06_JPRB, 0.46847358E-06_JPRB, 0.44909127E-06_JPRB, 0.42343663E-06_JPRB, &
  & 0.39004347E-06_JPRB, 0.34820398E-06_JPRB, 0.30089000E-06_JPRB, 0.25390986E-06_JPRB, 0.21301486E-06_JPRB, 0.17979177E-06_JPRB, &
  & 0.15311174E-06_JPRB, 0.13242964E-06_JPRB, 0.11668471E-06_JPRB, 0.10339166E-06_JPRB, 0.91430961E-07_JPRB, 0.80397388E-07_JPRB, &
  & 0.71381848E-07_JPRB, 0.63652661E-07_JPRB, 0.57729577E-07_JPRB, 0.52044893E-07_JPRB, 0.47668036E-07_JPRB, 0.44940444E-07_JPRB, &
  & 0.43931967E-07_JPRB, 0.43613957E-07_JPRB, 0.43623718E-07_JPRB, 0.44254313E-07_JPRB, 0.46200330E-07_JPRB, 0.50004943E-07_JPRB, &
  & 0.55724336E-07_JPRB, 0.63197553E-07_JPRB, 0.72888589E-07_JPRB, 0.84991159E-07_JPRB, 0.10107253E-06_JPRB, 0.12408135E-06_JPRB, &
  & 0.16092161E-06_JPRB, 0.21170764E-06_JPRB, 0.28619121E-06_JPRB, 0.38740360E-06_JPRB, 0.50866900E-06_JPRB, 0.63565880E-06_JPRB, &
  & 0.75355606E-06_JPRB, 0.84884650E-06_JPRB, 0.93236342E-06_JPRB, 0.10013584E-05_JPRB, 0.10546898E-05_JPRB, 0.10943208E-05_JPRB, &
  & 0.11263005E-05_JPRB, 0.11578376E-05_JPRB, 0.11906962E-05_JPRB, 0.12159615E-05_JPRB, 0.12470930E-05_JPRB, 0.12928989E-05_JPRB, &
  & 0.13662469E-05_JPRB, 0.14580416E-05_JPRB, 0.15352160E-05_JPRB, 0.15415079E-05_JPRB  /)

RGHG7(:,44, 2) = (/ &
  & 0.58392470E-06_JPRB, 0.57084445E-06_JPRB, 0.55502159E-06_JPRB, 0.54097787E-06_JPRB, 0.52562942E-06_JPRB, 0.50831330E-06_JPRB, &
  & 0.48775319E-06_JPRB, 0.46593910E-06_JPRB, 0.44546663E-06_JPRB, 0.42895705E-06_JPRB, 0.41254894E-06_JPRB, 0.39058779E-06_JPRB, &
  & 0.36124435E-06_JPRB, 0.32376544E-06_JPRB, 0.28108801E-06_JPRB, 0.23807323E-06_JPRB, 0.19984910E-06_JPRB, 0.16899672E-06_JPRB, &
  & 0.14425288E-06_JPRB, 0.12496784E-06_JPRB, 0.10983755E-06_JPRB, 0.97029419E-07_JPRB, 0.85653198E-07_JPRB, 0.75285177E-07_JPRB, &
  & 0.66877547E-07_JPRB, 0.59792438E-07_JPRB, 0.54270380E-07_JPRB, 0.48921631E-07_JPRB, 0.44925714E-07_JPRB, 0.42662185E-07_JPRB, &
  & 0.41943252E-07_JPRB, 0.41760715E-07_JPRB, 0.41881959E-07_JPRB, 0.42449980E-07_JPRB, 0.44208737E-07_JPRB, 0.47762490E-07_JPRB, &
  & 0.53044690E-07_JPRB, 0.59986801E-07_JPRB, 0.69023073E-07_JPRB, 0.80504068E-07_JPRB, 0.95828754E-07_JPRB, 0.11762638E-06_JPRB, &
  & 0.15258599E-06_JPRB, 0.20166568E-06_JPRB, 0.27319601E-06_JPRB, 0.37056927E-06_JPRB, 0.48558152E-06_JPRB, 0.60273816E-06_JPRB, &
  & 0.71121768E-06_JPRB, 0.79496342E-06_JPRB, 0.86745880E-06_JPRB, 0.92880979E-06_JPRB, 0.97560901E-06_JPRB, 0.10122273E-05_JPRB, &
  & 0.10405980E-05_JPRB, 0.10666250E-05_JPRB, 0.10968579E-05_JPRB, 0.11181977E-05_JPRB, 0.11457988E-05_JPRB, 0.11878476E-05_JPRB, &
  & 0.12530976E-05_JPRB, 0.13356946E-05_JPRB, 0.14102001E-05_JPRB, 0.14181174E-05_JPRB  /)

RGHG7(:,45, 2) = (/ &
  & 0.50535808E-06_JPRB, 0.49241585E-06_JPRB, 0.47778347E-06_JPRB, 0.46612071E-06_JPRB, 0.45337750E-06_JPRB, 0.43940853E-06_JPRB, &
  & 0.42072903E-06_JPRB, 0.40064027E-06_JPRB, 0.38230721E-06_JPRB, 0.36990392E-06_JPRB, 0.35775738E-06_JPRB, 0.34097222E-06_JPRB, &
  & 0.31742590E-06_JPRB, 0.28638247E-06_JPRB, 0.25062363E-06_JPRB, 0.21378553E-06_JPRB, 0.17999551E-06_JPRB, 0.15290435E-06_JPRB, &
  & 0.13116258E-06_JPRB, 0.11401696E-06_JPRB, 0.99990876E-07_JPRB, 0.88028159E-07_JPRB, 0.77497351E-07_JPRB, 0.68009248E-07_JPRB, &
  & 0.60447031E-07_JPRB, 0.54241841E-07_JPRB, 0.49271889E-07_JPRB, 0.44354473E-07_JPRB, 0.40858902E-07_JPRB, 0.39199239E-07_JPRB, &
  & 0.38894386E-07_JPRB, 0.38901636E-07_JPRB, 0.39160905E-07_JPRB, 0.39659913E-07_JPRB, 0.41194377E-07_JPRB, 0.44420318E-07_JPRB, &
  & 0.49115904E-07_JPRB, 0.55333376E-07_JPRB, 0.63524236E-07_JPRB, 0.74159818E-07_JPRB, 0.88363039E-07_JPRB, 0.10829730E-06_JPRB, &
  & 0.14051364E-06_JPRB, 0.18690181E-06_JPRB, 0.25382551E-06_JPRB, 0.34555693E-06_JPRB, 0.45190802E-06_JPRB, 0.55572785E-06_JPRB, &
  & 0.65125012E-06_JPRB, 0.71908831E-06_JPRB, 0.77662507E-06_JPRB, 0.82774484E-06_JPRB, 0.86631423E-06_JPRB, 0.89901597E-06_JPRB, &
  & 0.92298715E-06_JPRB, 0.94242333E-06_JPRB, 0.96974045E-06_JPRB, 0.98611125E-06_JPRB, 0.10082776E-05_JPRB, 0.10443222E-05_JPRB, &
  & 0.10986509E-05_JPRB, 0.11702748E-05_JPRB, 0.12426063E-05_JPRB, 0.12523007E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART4',0,ZHOOK_HANDLE)



RGHG7(:,46, 2) = (/ &
  & 0.45921583E-06_JPRB, 0.44837769E-06_JPRB, 0.43588324E-06_JPRB, 0.42549317E-06_JPRB, 0.41476681E-06_JPRB, 0.40240659E-06_JPRB, &
  & 0.38507164E-06_JPRB, 0.36649365E-06_JPRB, 0.35021653E-06_JPRB, 0.33977824E-06_JPRB, 0.32938639E-06_JPRB, 0.31461519E-06_JPRB, &
  & 0.29348189E-06_JPRB, 0.26483754E-06_JPRB, 0.23123972E-06_JPRB, 0.19640410E-06_JPRB, 0.16489131E-06_JPRB, 0.14029406E-06_JPRB, &
  & 0.12067736E-06_JPRB, 0.10536732E-06_JPRB, 0.92333323E-07_JPRB, 0.81324948E-07_JPRB, 0.71735890E-07_JPRB, 0.63068651E-07_JPRB, &
  & 0.56196346E-07_JPRB, 0.50616845E-07_JPRB, 0.46098862E-07_JPRB, 0.41678762E-07_JPRB, 0.38495397E-07_JPRB, 0.37106373E-07_JPRB, &
  & 0.36975227E-07_JPRB, 0.37054223E-07_JPRB, 0.37383988E-07_JPRB, 0.37866636E-07_JPRB, 0.39318026E-07_JPRB, 0.42345062E-07_JPRB, &
  & 0.46690680E-07_JPRB, 0.52349177E-07_JPRB, 0.59780869E-07_JPRB, 0.69682467E-07_JPRB, 0.83004419E-07_JPRB, 0.10170369E-06_JPRB, &
  & 0.13165640E-06_JPRB, 0.17557444E-06_JPRB, 0.23880435E-06_JPRB, 0.32440560E-06_JPRB, 0.42166786E-06_JPRB, 0.51613889E-06_JPRB, &
  & 0.60219143E-06_JPRB, 0.66069630E-06_JPRB, 0.70888701E-06_JPRB, 0.75209930E-06_JPRB, 0.78478444E-06_JPRB, 0.81337676E-06_JPRB, &
  & 0.83408728E-06_JPRB, 0.84996217E-06_JPRB, 0.87485200E-06_JPRB, 0.88997566E-06_JPRB, 0.91095916E-06_JPRB, 0.94382392E-06_JPRB, &
  & 0.99032079E-06_JPRB, 0.10512281E-05_JPRB, 0.11180485E-05_JPRB, 0.11291164E-05_JPRB  /)

RGHG7(:,47, 2) = (/ &
  & 0.41156669E-06_JPRB, 0.40359136E-06_JPRB, 0.39379539E-06_JPRB, 0.38467673E-06_JPRB, 0.37619911E-06_JPRB, 0.36537841E-06_JPRB, &
  & 0.34951379E-06_JPRB, 0.33266560E-06_JPRB, 0.31878426E-06_JPRB, 0.31022279E-06_JPRB, 0.30138777E-06_JPRB, 0.28834636E-06_JPRB, &
  & 0.26936666E-06_JPRB, 0.24272889E-06_JPRB, 0.21071383E-06_JPRB, 0.17739179E-06_JPRB, 0.14811908E-06_JPRB, 0.12619437E-06_JPRB, &
  & 0.10889561E-06_JPRB, 0.95678629E-07_JPRB, 0.83786295E-07_JPRB, 0.73919588E-07_JPRB, 0.65454900E-07_JPRB, 0.57739051E-07_JPRB, &
  & 0.51645156E-07_JPRB, 0.46748926E-07_JPRB, 0.42741233E-07_JPRB, 0.38917915E-07_JPRB, 0.36063212E-07_JPRB, 0.34925008E-07_JPRB, &
  & 0.34949545E-07_JPRB, 0.35089084E-07_JPRB, 0.35488040E-07_JPRB, 0.35962040E-07_JPRB, 0.37344238E-07_JPRB, 0.40163698E-07_JPRB, &
  & 0.44146057E-07_JPRB, 0.49181826E-07_JPRB, 0.55739970E-07_JPRB, 0.64802615E-07_JPRB, 0.77138581E-07_JPRB, 0.94514554E-07_JPRB, &
  & 0.12190716E-06_JPRB, 0.16297103E-06_JPRB, 0.22204942E-06_JPRB, 0.30035957E-06_JPRB, 0.38687113E-06_JPRB, 0.47117093E-06_JPRB, &
  & 0.54681008E-06_JPRB, 0.59567996E-06_JPRB, 0.63402811E-06_JPRB, 0.66842708E-06_JPRB, 0.69467736E-06_JPRB, 0.71840894E-06_JPRB, &
  & 0.73552148E-06_JPRB, 0.74782433E-06_JPRB, 0.76996378E-06_JPRB, 0.78436957E-06_JPRB, 0.80481684E-06_JPRB, 0.83451606E-06_JPRB, &
  & 0.87244177E-06_JPRB, 0.92082532E-06_JPRB, 0.98051027E-06_JPRB, 0.99310903E-06_JPRB  /)

RGHG7(:,48, 2) = (/ &
  & 0.37851632E-06_JPRB, 0.37169815E-06_JPRB, 0.36352296E-06_JPRB, 0.35560402E-06_JPRB, 0.34827530E-06_JPRB, 0.33761288E-06_JPRB, &
  & 0.32227281E-06_JPRB, 0.30675777E-06_JPRB, 0.29444887E-06_JPRB, 0.28673485E-06_JPRB, 0.27865981E-06_JPRB, 0.26641738E-06_JPRB, &
  & 0.24804746E-06_JPRB, 0.22218124E-06_JPRB, 0.19072347E-06_JPRB, 0.15864322E-06_JPRB, 0.13180118E-06_JPRB, 0.11260350E-06_JPRB, &
  & 0.97746701E-07_JPRB, 0.86701656E-07_JPRB, 0.76352024E-07_JPRB, 0.67760932E-07_JPRB, 0.60492950E-07_JPRB, 0.53684788E-07_JPRB, &
  & 0.48181146E-07_JPRB, 0.43824748E-07_JPRB, 0.40238349E-07_JPRB, 0.36867179E-07_JPRB, 0.34289982E-07_JPRB, 0.33253195E-07_JPRB, &
  & 0.33294631E-07_JPRB, 0.33485887E-07_JPRB, 0.33910665E-07_JPRB, 0.34393513E-07_JPRB, 0.35789668E-07_JPRB, 0.38525981E-07_JPRB, &
  & 0.42198035E-07_JPRB, 0.46745689E-07_JPRB, 0.52555187E-07_JPRB, 0.60725823E-07_JPRB, 0.72007648E-07_JPRB, 0.88009680E-07_JPRB, &
  & 0.11282733E-06_JPRB, 0.15034415E-06_JPRB, 0.20374194E-06_JPRB, 0.27302550E-06_JPRB, 0.34878751E-06_JPRB, 0.42404644E-06_JPRB, &
  & 0.49065946E-06_JPRB, 0.53290625E-06_JPRB, 0.56375257E-06_JPRB, 0.59113113E-06_JPRB, 0.61234893E-06_JPRB, 0.63221083E-06_JPRB, &
  & 0.64762833E-06_JPRB, 0.65870966E-06_JPRB, 0.67851995E-06_JPRB, 0.69343282E-06_JPRB, 0.71379788E-06_JPRB, 0.74130852E-06_JPRB, &
  & 0.77350040E-06_JPRB, 0.81288005E-06_JPRB, 0.86341892E-06_JPRB, 0.87819079E-06_JPRB  /)

RGHG7(:,49, 2) = (/ &
  & 0.34855365E-06_JPRB, 0.34224145E-06_JPRB, 0.33537112E-06_JPRB, 0.32874816E-06_JPRB, 0.32219170E-06_JPRB, 0.31107658E-06_JPRB, &
  & 0.29588741E-06_JPRB, 0.28166835E-06_JPRB, 0.27072644E-06_JPRB, 0.26348289E-06_JPRB, 0.25588719E-06_JPRB, 0.24410634E-06_JPRB, &
  & 0.22570979E-06_JPRB, 0.20013649E-06_JPRB, 0.16882962E-06_JPRB, 0.13800097E-06_JPRB, 0.11393732E-06_JPRB, 0.97784301E-07_JPRB, &
  & 0.85688125E-07_JPRB, 0.77084145E-07_JPRB, 0.68625227E-07_JPRB, 0.61507651E-07_JPRB, 0.55597787E-07_JPRB, 0.49774927E-07_JPRB, &
  & 0.44839388E-07_JPRB, 0.41015586E-07_JPRB, 0.37855262E-07_JPRB, 0.34919046E-07_JPRB, 0.32625900E-07_JPRB, 0.31633496E-07_JPRB, &
  & 0.31630549E-07_JPRB, 0.31875065E-07_JPRB, 0.32308719E-07_JPRB, 0.32809320E-07_JPRB, 0.34258735E-07_JPRB, 0.36959541E-07_JPRB, &
  & 0.40312038E-07_JPRB, 0.44380356E-07_JPRB, 0.49417590E-07_JPRB, 0.56576294E-07_JPRB, 0.66659779E-07_JPRB, 0.81117283E-07_JPRB, &
  & 0.10307667E-06_JPRB, 0.13635047E-06_JPRB, 0.18276239E-06_JPRB, 0.24126088E-06_JPRB, 0.30511938E-06_JPRB, 0.37088035E-06_JPRB, &
  & 0.42812856E-06_JPRB, 0.46441028E-06_JPRB, 0.48801330E-06_JPRB, 0.50843261E-06_JPRB, 0.52471502E-06_JPRB, 0.54074224E-06_JPRB, &
  & 0.55514780E-06_JPRB, 0.56594508E-06_JPRB, 0.58336757E-06_JPRB, 0.59939888E-06_JPRB, 0.61987935E-06_JPRB, 0.64541050E-06_JPRB, &
  & 0.67254272E-06_JPRB, 0.70355174E-06_JPRB, 0.74304813E-06_JPRB, 0.76051849E-06_JPRB  /)

RGHG7(:,50, 2) = (/ &
  & 0.32172297E-06_JPRB, 0.31487530E-06_JPRB, 0.30814326E-06_JPRB, 0.30228740E-06_JPRB, 0.29566333E-06_JPRB, 0.28360402E-06_JPRB, &
  & 0.26765078E-06_JPRB, 0.25388729E-06_JPRB, 0.24362609E-06_JPRB, 0.23749118E-06_JPRB, 0.23079933E-06_JPRB, 0.21974922E-06_JPRB, &
  & 0.20191221E-06_JPRB, 0.17710681E-06_JPRB, 0.14733482E-06_JPRB, 0.11922311E-06_JPRB, 0.98444948E-07_JPRB, 0.85130880E-07_JPRB, &
  & 0.75414420E-07_JPRB, 0.68929883E-07_JPRB, 0.62407536E-07_JPRB, 0.56599719E-07_JPRB, 0.51800343E-07_JPRB, 0.46781434E-07_JPRB, &
  & 0.42288411E-07_JPRB, 0.38846476E-07_JPRB, 0.36033183E-07_JPRB, 0.33397864E-07_JPRB, 0.31321649E-07_JPRB, 0.30343760E-07_JPRB, &
  & 0.30280145E-07_JPRB, 0.30475736E-07_JPRB, 0.30932485E-07_JPRB, 0.31571580E-07_JPRB, 0.33070142E-07_JPRB, 0.35750683E-07_JPRB, &
  & 0.38802523E-07_JPRB, 0.42382358E-07_JPRB, 0.46766080E-07_JPRB, 0.53042896E-07_JPRB, 0.61877770E-07_JPRB, 0.74682108E-07_JPRB, &
  & 0.93952928E-07_JPRB, 0.12273246E-06_JPRB, 0.16143968E-06_JPRB, 0.20950257E-06_JPRB, 0.26264622E-06_JPRB, 0.31877040E-06_JPRB, &
  & 0.36721283E-06_JPRB, 0.39843131E-06_JPRB, 0.41629347E-06_JPRB, 0.43111095E-06_JPRB, 0.44356397E-06_JPRB, 0.45677366E-06_JPRB, &
  & 0.47053386E-06_JPRB, 0.48140267E-06_JPRB, 0.49630199E-06_JPRB, 0.51166066E-06_JPRB, 0.53264904E-06_JPRB, 0.55647420E-06_JPRB, &
  & 0.58070269E-06_JPRB, 0.60603483E-06_JPRB, 0.63626043E-06_JPRB, 0.65296048E-06_JPRB  /)

RGHG7(:,51, 2) = (/ &
  & 0.29434815E-06_JPRB, 0.28637387E-06_JPRB, 0.27917820E-06_JPRB, 0.27387406E-06_JPRB, 0.26673536E-06_JPRB, 0.25339644E-06_JPRB, &
  & 0.23613576E-06_JPRB, 0.22242327E-06_JPRB, 0.21253762E-06_JPRB, 0.20793731E-06_JPRB, 0.20244625E-06_JPRB, 0.19232804E-06_JPRB, &
  & 0.17540438E-06_JPRB, 0.15167923E-06_JPRB, 0.12429492E-06_JPRB, 0.99892233E-07_JPRB, 0.82934360E-07_JPRB, 0.72582873E-07_JPRB, &
  & 0.65240186E-07_JPRB, 0.60879063E-07_JPRB, 0.56475495E-07_JPRB, 0.51998289E-07_JPRB, 0.48269894E-07_JPRB, 0.44025242E-07_JPRB, &
  & 0.39944848E-07_JPRB, 0.36836725E-07_JPRB, 0.34357244E-07_JPRB, 0.31976920E-07_JPRB, 0.30100065E-07_JPRB, 0.29122176E-07_JPRB, &
  & 0.28984381E-07_JPRB, 0.29073337E-07_JPRB, 0.29562540E-07_JPRB, 0.30414903E-07_JPRB, 0.31964465E-07_JPRB, 0.34631097E-07_JPRB, &
  & 0.37367670E-07_JPRB, 0.40414334E-07_JPRB, 0.44153613E-07_JPRB, 0.49544900E-07_JPRB, 0.57002800E-07_JPRB, 0.67961900E-07_JPRB, &
  & 0.84413864E-07_JPRB, 0.10820013E-06_JPRB, 0.13819578E-06_JPRB, 0.17515479E-06_JPRB, 0.21733364E-06_JPRB, 0.26296129E-06_JPRB, &
  & 0.30217290E-06_JPRB, 0.32838884E-06_JPRB, 0.34083119E-06_JPRB, 0.35030304E-06_JPRB, 0.35919540E-06_JPRB, 0.36989223E-06_JPRB, &
  & 0.38314708E-06_JPRB, 0.39428015E-06_JPRB, 0.40637916E-06_JPRB, 0.42006878E-06_JPRB, 0.44181287E-06_JPRB, 0.46393651E-06_JPRB, &
  & 0.48615750E-06_JPRB, 0.50676527E-06_JPRB, 0.52789450E-06_JPRB, 0.54193796E-06_JPRB  /)

RGHG7(:,52, 2) = (/ &
  & 0.26439858E-06_JPRB, 0.25534675E-06_JPRB, 0.24716030E-06_JPRB, 0.24182093E-06_JPRB, 0.23418604E-06_JPRB, 0.21994871E-06_JPRB, &
  & 0.20164959E-06_JPRB, 0.18781431E-06_JPRB, 0.17873378E-06_JPRB, 0.17614413E-06_JPRB, 0.17267618E-06_JPRB, 0.16458390E-06_JPRB, &
  & 0.14982739E-06_JPRB, 0.12865490E-06_JPRB, 0.10492477E-06_JPRB, 0.84730341E-07_JPRB, 0.71232981E-07_JPRB, 0.63231745E-07_JPRB, &
  & 0.57660680E-07_JPRB, 0.54677172E-07_JPRB, 0.51918901E-07_JPRB, 0.48572505E-07_JPRB, 0.45551936E-07_JPRB, 0.41984124E-07_JPRB, &
  & 0.38316859E-07_JPRB, 0.35448585E-07_JPRB, 0.33228872E-07_JPRB, 0.30944995E-07_JPRB, 0.29130143E-07_JPRB, 0.28162214E-07_JPRB, &
  & 0.28011692E-07_JPRB, 0.28023015E-07_JPRB, 0.28490814E-07_JPRB, 0.29478525E-07_JPRB, 0.31170867E-07_JPRB, 0.33820589E-07_JPRB, &
  & 0.36205967E-07_JPRB, 0.38798073E-07_JPRB, 0.42060385E-07_JPRB, 0.46785620E-07_JPRB, 0.53163680E-07_JPRB, 0.62502419E-07_JPRB, &
  & 0.76452433E-07_JPRB, 0.95867784E-07_JPRB, 0.11894167E-06_JPRB, 0.14720577E-06_JPRB, 0.18028119E-06_JPRB, 0.21623384E-06_JPRB, &
  & 0.24696732E-06_JPRB, 0.26832858E-06_JPRB, 0.27699575E-06_JPRB, 0.28278150E-06_JPRB, 0.28904465E-06_JPRB, 0.29711027E-06_JPRB, &
  & 0.30927713E-06_JPRB, 0.31904179E-06_JPRB, 0.32892918E-06_JPRB, 0.34076557E-06_JPRB, 0.36179737E-06_JPRB, 0.38251743E-06_JPRB, &
  & 0.40237193E-06_JPRB, 0.41808810E-06_JPRB, 0.43323082E-06_JPRB, 0.44358974E-06_JPRB  /)

RGHG7(:,53, 2) = (/ &
  & 0.23079340E-06_JPRB, 0.22058700E-06_JPRB, 0.21111879E-06_JPRB, 0.20551524E-06_JPRB, 0.19734710E-06_JPRB, 0.18227810E-06_JPRB, &
  & 0.16295161E-06_JPRB, 0.14891575E-06_JPRB, 0.14087726E-06_JPRB, 0.14066033E-06_JPRB, 0.13971187E-06_JPRB, 0.13424672E-06_JPRB, &
  & 0.12233259E-06_JPRB, 0.10450637E-06_JPRB, 0.85242837E-07_JPRB, 0.69823218E-07_JPRB, 0.59955885E-07_JPRB, 0.54278453E-07_JPRB, &
  & 0.50404987E-07_JPRB, 0.48634750E-07_JPRB, 0.47486019E-07_JPRB, 0.45294187E-07_JPRB, 0.42904714E-07_JPRB, 0.40036489E-07_JPRB, &
  & 0.36819309E-07_JPRB, 0.34176077E-07_JPRB, 0.32210759E-07_JPRB, 0.29970912E-07_JPRB, 0.28170737E-07_JPRB, 0.27217484E-07_JPRB, &
  & 0.27076747E-07_JPRB, 0.27014687E-07_JPRB, 0.27438455E-07_JPRB, 0.28543580E-07_JPRB, 0.30426719E-07_JPRB, 0.33056872E-07_JPRB, &
  & 0.35045980E-07_JPRB, 0.37173325E-07_JPRB, 0.39980661E-07_JPRB, 0.44065015E-07_JPRB, 0.49381464E-07_JPRB, 0.57042171E-07_JPRB, &
  & 0.68389525E-07_JPRB, 0.83284466E-07_JPRB, 0.99509246E-07_JPRB, 0.11923153E-06_JPRB, 0.14310958E-06_JPRB, 0.16884239E-06_JPRB, &
  & 0.19063288E-06_JPRB, 0.20676436E-06_JPRB, 0.21195316E-06_JPRB, 0.21436329E-06_JPRB, 0.21812162E-06_JPRB, 0.22327638E-06_JPRB, &
  & 0.23403427E-06_JPRB, 0.24168060E-06_JPRB, 0.24938606E-06_JPRB, 0.25913348E-06_JPRB, 0.27882480E-06_JPRB, 0.29813102E-06_JPRB, &
  & 0.31527033E-06_JPRB, 0.32559527E-06_JPRB, 0.33541527E-06_JPRB, 0.34136630E-06_JPRB  /)

RGHG7(:,54, 2) = (/ &
  & 0.19601525E-06_JPRB, 0.18551247E-06_JPRB, 0.17537627E-06_JPRB, 0.16995411E-06_JPRB, 0.16234926E-06_JPRB, 0.14765690E-06_JPRB, &
  & 0.12898366E-06_JPRB, 0.11602180E-06_JPRB, 0.10930019E-06_JPRB, 0.11038642E-06_JPRB, 0.11129491E-06_JPRB, 0.10847718E-06_JPRB, &
  & 0.10010453E-06_JPRB, 0.86248148E-07_JPRB, 0.71272312E-07_JPRB, 0.59660019E-07_JPRB, 0.52414630E-07_JPRB, 0.48366049E-07_JPRB, &
  & 0.45742925E-07_JPRB, 0.44685760E-07_JPRB, 0.44415722E-07_JPRB, 0.43048007E-07_JPRB, 0.41050127E-07_JPRB, 0.38729456E-07_JPRB, &
  & 0.35947482E-07_JPRB, 0.33487298E-07_JPRB, 0.31586679E-07_JPRB, 0.29359882E-07_JPRB, 0.27492156E-07_JPRB, 0.26502764E-07_JPRB, &
  & 0.26363066E-07_JPRB, 0.26351855E-07_JPRB, 0.26787704E-07_JPRB, 0.27991155E-07_JPRB, 0.30007634E-07_JPRB, 0.32600108E-07_JPRB, &
  & 0.34268621E-07_JPRB, 0.36078573E-07_JPRB, 0.38533953E-07_JPRB, 0.42206827E-07_JPRB, 0.46725779E-07_JPRB, 0.53213613E-07_JPRB, &
  & 0.62582100E-07_JPRB, 0.74251689E-07_JPRB, 0.86436404E-07_JPRB, 0.10070964E-06_JPRB, 0.11802403E-06_JPRB, 0.13643126E-06_JPRB, &
  & 0.15177515E-06_JPRB, 0.16344997E-06_JPRB, 0.16629470E-06_JPRB, 0.16705019E-06_JPRB, 0.16920862E-06_JPRB, 0.17268269E-06_JPRB, &
  & 0.18162822E-06_JPRB, 0.18725913E-06_JPRB, 0.19283352E-06_JPRB, 0.20080947E-06_JPRB, 0.21791245E-06_JPRB, 0.23484033E-06_JPRB, &
  & 0.24856686E-06_JPRB, 0.25487244E-06_JPRB, 0.26136726E-06_JPRB, 0.26513734E-06_JPRB  /)

RGHG7(:,55, 2) = (/ &
  & 0.15733525E-06_JPRB, 0.14661707E-06_JPRB, 0.13582164E-06_JPRB, 0.13065901E-06_JPRB, 0.12382239E-06_JPRB, 0.10970621E-06_JPRB, &
  & 0.91977691E-07_JPRB, 0.80373208E-07_JPRB, 0.75146542E-07_JPRB, 0.77535652E-07_JPRB, 0.80414039E-07_JPRB, 0.80531688E-07_JPRB, &
  & 0.76174091E-07_JPRB, 0.66797333E-07_JPRB, 0.56547685E-07_JPRB, 0.49025712E-07_JPRB, 0.44552190E-07_JPRB, 0.42216560E-07_JPRB, &
  & 0.40919676E-07_JPRB, 0.40586622E-07_JPRB, 0.41193823E-07_JPRB, 0.40695560E-07_JPRB, 0.39099965E-07_JPRB, 0.37365849E-07_JPRB, &
  & 0.35064021E-07_JPRB, 0.32801086E-07_JPRB, 0.30947184E-07_JPRB, 0.28730768E-07_JPRB, 0.26777394E-07_JPRB, 0.25741286E-07_JPRB, &
  & 0.25601588E-07_JPRB, 0.25663048E-07_JPRB, 0.26119660E-07_JPRB, 0.27429521E-07_JPRB, 0.29586151E-07_JPRB, 0.32134503E-07_JPRB, &
  & 0.33457831E-07_JPRB, 0.34935574E-07_JPRB, 0.37014623E-07_JPRB, 0.40261856E-07_JPRB, 0.43932117E-07_JPRB, 0.49187146E-07_JPRB, &
  & 0.56445588E-07_JPRB, 0.64712633E-07_JPRB, 0.72791456E-07_JPRB, 0.81435312E-07_JPRB, 0.91825229E-07_JPRB, 0.10249822E-06_JPRB, &
  & 0.11102924E-06_JPRB, 0.11786886E-06_JPRB, 0.11826615E-06_JPRB, 0.11741510E-06_JPRB, 0.11792027E-06_JPRB, 0.11969436E-06_JPRB, &
  & 0.12657916E-06_JPRB, 0.12999102E-06_JPRB, 0.13321140E-06_JPRB, 0.13926677E-06_JPRB, 0.15333835E-06_JPRB, 0.16750474E-06_JPRB, &
  & 0.17735896E-06_JPRB, 0.17939255E-06_JPRB, 0.18246666E-06_JPRB, 0.18411371E-06_JPRB  /)

RGHG7(:,56, 2) = (/ &
  & 0.12643641E-06_JPRB, 0.11627848E-06_JPRB, 0.10664455E-06_JPRB, 0.10243311E-06_JPRB, 0.97172702E-07_JPRB, 0.85418650E-07_JPRB, &
  & 0.70628270E-07_JPRB, 0.61075036E-07_JPRB, 0.56962571E-07_JPRB, 0.59273520E-07_JPRB, 0.62032029E-07_JPRB, 0.63088194E-07_JPRB, &
  & 0.61260463E-07_JPRB, 0.55138293E-07_JPRB, 0.48127687E-07_JPRB, 0.43011199E-07_JPRB, 0.40099236E-07_JPRB, 0.38741144E-07_JPRB, &
  & 0.38215176E-07_JPRB, 0.38330617E-07_JPRB, 0.39275762E-07_JPRB, 0.39248025E-07_JPRB, 0.38028892E-07_JPRB, 0.36631609E-07_JPRB, &
  & 0.34690980E-07_JPRB, 0.32537798E-07_JPRB, 0.30635118E-07_JPRB, 0.28350909E-07_JPRB, 0.26300170E-07_JPRB, 0.25240802E-07_JPRB, &
  & 0.25063699E-07_JPRB, 0.25312806E-07_JPRB, 0.25913674E-07_JPRB, 0.27445759E-07_JPRB, 0.29629222E-07_JPRB, 0.31749468E-07_JPRB, &
  & 0.32964889E-07_JPRB, 0.34222278E-07_JPRB, 0.36060159E-07_JPRB, 0.39036361E-07_JPRB, 0.42300002E-07_JPRB, 0.46786304E-07_JPRB, &
  & 0.52850797E-07_JPRB, 0.59371808E-07_JPRB, 0.65304766E-07_JPRB, 0.71366788E-07_JPRB, 0.78412536E-07_JPRB, 0.85352040E-07_JPRB, &
  & 0.90788173E-07_JPRB, 0.94842904E-07_JPRB, 0.94425010E-07_JPRB, 0.93386641E-07_JPRB, 0.93470664E-07_JPRB, 0.94599467E-07_JPRB, &
  & 0.99832530E-07_JPRB, 0.10212639E-06_JPRB, 0.10413618E-06_JPRB, 0.10851955E-06_JPRB, 0.11948267E-06_JPRB, 0.13059280E-06_JPRB, &
  & 0.13723297E-06_JPRB, 0.13715391E-06_JPRB, 0.13821410E-06_JPRB, 0.13966629E-06_JPRB  /)

RGHG7(:,57, 2) = (/ &
  & 0.96486255E-07_JPRB, 0.87038106E-07_JPRB, 0.78709570E-07_JPRB, 0.75352967E-07_JPRB, 0.71562910E-07_JPRB, 0.62209645E-07_JPRB, &
  & 0.50340758E-07_JPRB, 0.42808870E-07_JPRB, 0.39780578E-07_JPRB, 0.41981645E-07_JPRB, 0.44643350E-07_JPRB, 0.46487619E-07_JPRB, &
  & 0.46853916E-07_JPRB, 0.43739077E-07_JPRB, 0.39789756E-07_JPRB, 0.37011531E-07_JPRB, 0.35646362E-07_JPRB, 0.35240769E-07_JPRB, &
  & 0.35458091E-07_JPRB, 0.36027802E-07_JPRB, 0.37327338E-07_JPRB, 0.37741883E-07_JPRB, 0.36943926E-07_JPRB, 0.35879503E-07_JPRB, &
  & 0.34295929E-07_JPRB, 0.32263731E-07_JPRB, 0.30330392E-07_JPRB, 0.27958851E-07_JPRB, 0.25810799E-07_JPRB, 0.24726681E-07_JPRB, &
  & 0.24571423E-07_JPRB, 0.25024131E-07_JPRB, 0.25788789E-07_JPRB, 0.27526923E-07_JPRB, 0.29679103E-07_JPRB, 0.31401811E-07_JPRB, &
  & 0.32477901E-07_JPRB, 0.33570374E-07_JPRB, 0.35177068E-07_JPRB, 0.37825442E-07_JPRB, 0.40682755E-07_JPRB, 0.44415926E-07_JPRB, &
  & 0.49348994E-07_JPRB, 0.54069973E-07_JPRB, 0.57914716E-07_JPRB, 0.61476445E-07_JPRB, 0.65370214E-07_JPRB, 0.68784565E-07_JPRB, &
  & 0.71285552E-07_JPRB, 0.72767273E-07_JPRB, 0.71668626E-07_JPRB, 0.70419368E-07_JPRB, 0.70080447E-07_JPRB, 0.70562276E-07_JPRB, &
  & 0.74230966E-07_JPRB, 0.75418700E-07_JPRB, 0.76349735E-07_JPRB, 0.79203542E-07_JPRB, 0.87193645E-07_JPRB, 0.95352831E-07_JPRB, &
  & 0.99088546E-07_JPRB, 0.97146349E-07_JPRB, 0.96583044E-07_JPRB, 0.97495254E-07_JPRB  /)

RGHG7(:,58, 2) = (/ &
  & 0.72006452E-07_JPRB, 0.63608952E-07_JPRB, 0.57065173E-07_JPRB, 0.54461536E-07_JPRB, 0.51996241E-07_JPRB, 0.45250742E-07_JPRB, &
  & 0.36413921E-07_JPRB, 0.30820347E-07_JPRB, 0.28666923E-07_JPRB, 0.30454465E-07_JPRB, 0.32674359E-07_JPRB, 0.34614937E-07_JPRB, &
  & 0.36153113E-07_JPRB, 0.35156409E-07_JPRB, 0.33443087E-07_JPRB, 0.32385637E-07_JPRB, 0.32190999E-07_JPRB, 0.32481125E-07_JPRB, &
  & 0.33231180E-07_JPRB, 0.34176701E-07_JPRB, 0.35728796E-07_JPRB, 0.36427555E-07_JPRB, 0.36087574E-07_JPRB, 0.35275711E-07_JPRB, &
  & 0.33991168E-07_JPRB, 0.32072791E-07_JPRB, 0.30123961E-07_JPRB, 0.27624456E-07_JPRB, 0.25384810E-07_JPRB, 0.24279813E-07_JPRB, &
  & 0.24237702E-07_JPRB, 0.24926132E-07_JPRB, 0.25897553E-07_JPRB, 0.27819551E-07_JPRB, 0.29823562E-07_JPRB, 0.31160359E-07_JPRB, &
  & 0.32099729E-07_JPRB, 0.33155160E-07_JPRB, 0.34591460E-07_JPRB, 0.36871434E-07_JPRB, 0.39438471E-07_JPRB, 0.42592438E-07_JPRB, &
  & 0.46762438E-07_JPRB, 0.50047529E-07_JPRB, 0.52436853E-07_JPRB, 0.54408465E-07_JPRB, 0.56399615E-07_JPRB, 0.57674277E-07_JPRB, &
  & 0.58443040E-07_JPRB, 0.58300968E-07_JPRB, 0.57109379E-07_JPRB, 0.55892449E-07_JPRB, 0.55392563E-07_JPRB, 0.55474337E-07_JPRB, &
  & 0.57928719E-07_JPRB, 0.58325771E-07_JPRB, 0.58701848E-07_JPRB, 0.60436309E-07_JPRB, 0.65906874E-07_JPRB, 0.71475131E-07_JPRB, &
  & 0.73186325E-07_JPRB, 0.70357138E-07_JPRB, 0.69224057E-07_JPRB, 0.69418323E-07_JPRB  /)

RGHG7(:,59, 2) = (/ &
  & 0.54567732E-07_JPRB, 0.47423949E-07_JPRB, 0.42394238E-07_JPRB, 0.40335907E-07_JPRB, 0.38752009E-07_JPRB, 0.33951272E-07_JPRB, &
  & 0.27511940E-07_JPRB, 0.23348604E-07_JPRB, 0.21770440E-07_JPRB, 0.23153295E-07_JPRB, 0.24959963E-07_JPRB, 0.26784315E-07_JPRB, &
  & 0.28765599E-07_JPRB, 0.29039716E-07_JPRB, 0.28723972E-07_JPRB, 0.28828996E-07_JPRB, 0.29487807E-07_JPRB, 0.30282739E-07_JPRB, &
  & 0.31349428E-07_JPRB, 0.32598941E-07_JPRB, 0.34333526E-07_JPRB, 0.35222804E-07_JPRB, 0.35286027E-07_JPRB, 0.34682532E-07_JPRB, &
  & 0.33672011E-07_JPRB, 0.31848590E-07_JPRB, 0.29893995E-07_JPRB, 0.27278405E-07_JPRB, 0.24961359E-07_JPRB, 0.23839388E-07_JPRB, &
  & 0.24020681E-07_JPRB, 0.24943287E-07_JPRB, 0.26083984E-07_JPRB, 0.27993906E-07_JPRB, 0.29924093E-07_JPRB, 0.31073178E-07_JPRB, &
  & 0.31909025E-07_JPRB, 0.32982596E-07_JPRB, 0.34278110E-07_JPRB, 0.36214809E-07_JPRB, 0.38479056E-07_JPRB, 0.41312949E-07_JPRB, &
  & 0.44868590E-07_JPRB, 0.47089875E-07_JPRB, 0.48581716E-07_JPRB, 0.49635665E-07_JPRB, 0.50465919E-07_JPRB, 0.50550652E-07_JPRB, &
  & 0.50346879E-07_JPRB, 0.49472595E-07_JPRB, 0.48384699E-07_JPRB, 0.47269017E-07_JPRB, 0.46680771E-07_JPRB, 0.46552658E-07_JPRB, &
  & 0.48164120E-07_JPRB, 0.48071489E-07_JPRB, 0.48216106E-07_JPRB, 0.49263221E-07_JPRB, 0.52905881E-07_JPRB, 0.56619632E-07_JPRB, &
  & 0.57338640E-07_JPRB, 0.54496466E-07_JPRB, 0.53383539E-07_JPRB, 0.53259074E-07_JPRB  /)

RGHG7(:,60, 2) = (/ &
  & 0.40076683E-07_JPRB, 0.34272009E-07_JPRB, 0.30611862E-07_JPRB, 0.29024060E-07_JPRB, 0.28117261E-07_JPRB, 0.24941201E-07_JPRB, &
  & 0.20591382E-07_JPRB, 0.17624666E-07_JPRB, 0.16486896E-07_JPRB, 0.17484395E-07_JPRB, 0.18891416E-07_JPRB, 0.20516426E-07_JPRB, &
  & 0.22658266E-07_JPRB, 0.23856624E-07_JPRB, 0.24590743E-07_JPRB, 0.25627852E-07_JPRB, 0.27023538E-07_JPRB, 0.28257717E-07_JPRB, &
  & 0.29547455E-07_JPRB, 0.31062451E-07_JPRB, 0.32943340E-07_JPRB, 0.34001130E-07_JPRB, 0.34442634E-07_JPRB, 0.34043083E-07_JPRB, &
  & 0.33296369E-07_JPRB, 0.31578287E-07_JPRB, 0.29605040E-07_JPRB, 0.26888568E-07_JPRB, 0.24486362E-07_JPRB, 0.23353018E-07_JPRB, &
  & 0.23787157E-07_JPRB, 0.24950119E-07_JPRB, 0.26228929E-07_JPRB, 0.28066883E-07_JPRB, 0.29989825E-07_JPRB, 0.31033399E-07_JPRB, &
  & 0.31793104E-07_JPRB, 0.32910556E-07_JPRB, 0.34087712E-07_JPRB, 0.35697025E-07_JPRB, 0.37662880E-07_JPRB, 0.40264627E-07_JPRB, &
  & 0.43237744E-07_JPRB, 0.44547656E-07_JPRB, 0.45363189E-07_JPRB, 0.45743767E-07_JPRB, 0.45700851E-07_JPRB, 0.44969993E-07_JPRB, &
  & 0.44110358E-07_JPRB, 0.42858307E-07_JPRB, 0.41927167E-07_JPRB, 0.40929640E-07_JPRB, 0.40284808E-07_JPRB, 0.40025306E-07_JPRB, &
  & 0.40944574E-07_JPRB, 0.40507141E-07_JPRB, 0.40537895E-07_JPRB, 0.41061237E-07_JPRB, 0.43192524E-07_JPRB, 0.45367264E-07_JPRB, &
  & 0.45489170E-07_JPRB, 0.42992292E-07_JPRB, 0.42102336E-07_JPRB, 0.41814316E-07_JPRB  /)

RGHG7(:,61, 2) = (/ &
  & 0.31018154E-07_JPRB, 0.26428239E-07_JPRB, 0.23670672E-07_JPRB, 0.22435943E-07_JPRB, 0.21825623E-07_JPRB, 0.19547031E-07_JPRB, &
  & 0.16498139E-07_JPRB, 0.14226250E-07_JPRB, 0.13287471E-07_JPRB, 0.14029385E-07_JPRB, 0.15120211E-07_JPRB, 0.16508257E-07_JPRB, &
  & 0.18555895E-07_JPRB, 0.20189844E-07_JPRB, 0.21449008E-07_JPRB, 0.23035989E-07_JPRB, 0.24976436E-07_JPRB, 0.26553829E-07_JPRB, &
  & 0.27922798E-07_JPRB, 0.29594432E-07_JPRB, 0.31539217E-07_JPRB, 0.32767519E-07_JPRB, 0.33494182E-07_JPRB, 0.33303847E-07_JPRB, &
  & 0.32768537E-07_JPRB, 0.31205267E-07_JPRB, 0.29151328E-07_JPRB, 0.26397248E-07_JPRB, 0.23873823E-07_JPRB, 0.22748876E-07_JPRB, &
  & 0.23375434E-07_JPRB, 0.24767327E-07_JPRB, 0.26082284E-07_JPRB, 0.27864010E-07_JPRB, 0.29958559E-07_JPRB, 0.30997752E-07_JPRB, &
  & 0.31763298E-07_JPRB, 0.32952679E-07_JPRB, 0.34084560E-07_JPRB, 0.35452162E-07_JPRB, 0.37201501E-07_JPRB, 0.39638578E-07_JPRB, &
  & 0.42064012E-07_JPRB, 0.42759426E-07_JPRB, 0.43202534E-07_JPRB, 0.43162128E-07_JPRB, 0.42620090E-07_JPRB, 0.41528127E-07_JPRB, &
  & 0.40447229E-07_JPRB, 0.39194083E-07_JPRB, 0.38361525E-07_JPRB, 0.37444690E-07_JPRB, 0.36790000E-07_JPRB, 0.36499462E-07_JPRB, &
  & 0.36982045E-07_JPRB, 0.36465015E-07_JPRB, 0.36469846E-07_JPRB, 0.36673342E-07_JPRB, 0.37951340E-07_JPRB, 0.39188448E-07_JPRB, &
  & 0.39112458E-07_JPRB, 0.37259289E-07_JPRB, 0.36635872E-07_JPRB, 0.36337628E-07_JPRB  /)

RGHG7(:,62, 2) = (/ &
  & 0.24766536E-07_JPRB, 0.21187664E-07_JPRB, 0.19097381E-07_JPRB, 0.18144543E-07_JPRB, 0.17636081E-07_JPRB, 0.15867320E-07_JPRB, &
  & 0.13615383E-07_JPRB, 0.11760448E-07_JPRB, 0.10914562E-07_JPRB, 0.11460314E-07_JPRB, 0.12280542E-07_JPRB, 0.13460558E-07_JPRB, &
  & 0.15369635E-07_JPRB, 0.17203039E-07_JPRB, 0.18752884E-07_JPRB, 0.20700497E-07_JPRB, 0.23032250E-07_JPRB, 0.24898661E-07_JPRB, &
  & 0.26338576E-07_JPRB, 0.28075346E-07_JPRB, 0.30037682E-07_JPRB, 0.31465179E-07_JPRB, 0.32410143E-07_JPRB, 0.32399474E-07_JPRB, &
  & 0.32010413E-07_JPRB, 0.30598241E-07_JPRB, 0.28538343E-07_JPRB, 0.25726535E-07_JPRB, 0.23083970E-07_JPRB, 0.21964986E-07_JPRB, &
  & 0.22683602E-07_JPRB, 0.24248207E-07_JPRB, 0.25659660E-07_JPRB, 0.27516350E-07_JPRB, 0.29779059E-07_JPRB, 0.30975099E-07_JPRB, &
  & 0.31799653E-07_JPRB, 0.32963787E-07_JPRB, 0.34161123E-07_JPRB, 0.35387155E-07_JPRB, 0.36999026E-07_JPRB, 0.39191580E-07_JPRB, &
  & 0.41074570E-07_JPRB, 0.41363207E-07_JPRB, 0.41533378E-07_JPRB, 0.41179654E-07_JPRB, 0.40289351E-07_JPRB, 0.39006678E-07_JPRB, &
  & 0.37829906E-07_JPRB, 0.36628067E-07_JPRB, 0.35868585E-07_JPRB, 0.34997714E-07_JPRB, 0.34343122E-07_JPRB, 0.34044886E-07_JPRB, &
  & 0.34237685E-07_JPRB, 0.33724475E-07_JPRB, 0.33709043E-07_JPRB, 0.33706289E-07_JPRB, 0.34450578E-07_JPRB, 0.35081270E-07_JPRB, &
  & 0.34898110E-07_JPRB, 0.33611602E-07_JPRB, 0.33188891E-07_JPRB, 0.32929563E-07_JPRB  /)

RGHG7(:,63, 2) = (/ &
  & 0.20252255E-07_JPRB, 0.17538752E-07_JPRB, 0.15972028E-07_JPRB, 0.15246495E-07_JPRB, 0.14728170E-07_JPRB, 0.13242064E-07_JPRB, &
  & 0.11465811E-07_JPRB, 0.98554047E-08_JPRB, 0.90302409E-08_JPRB, 0.94095031E-08_JPRB, 0.99962701E-08_JPRB, 0.10988816E-07_JPRB, &
  & 0.12727917E-07_JPRB, 0.14612343E-07_JPRB, 0.16310578E-07_JPRB, 0.18496610E-07_JPRB, 0.21095623E-07_JPRB, 0.23208549E-07_JPRB, &
  & 0.24730171E-07_JPRB, 0.26482143E-07_JPRB, 0.28439908E-07_JPRB, 0.30075562E-07_JPRB, 0.31181356E-07_JPRB, 0.31337040E-07_JPRB, &
  & 0.31071188E-07_JPRB, 0.29796465E-07_JPRB, 0.27777599E-07_JPRB, 0.24923005E-07_JPRB, 0.22188821E-07_JPRB, 0.21033168E-07_JPRB, &
  & 0.21764009E-07_JPRB, 0.23395628E-07_JPRB, 0.24951675E-07_JPRB, 0.27041163E-07_JPRB, 0.29505874E-07_JPRB, 0.30965609E-07_JPRB, &
  & 0.31863004E-07_JPRB, 0.32931701E-07_JPRB, 0.34259719E-07_JPRB, 0.35385333E-07_JPRB, 0.36911986E-07_JPRB, 0.38793411E-07_JPRB, &
  & 0.40163958E-07_JPRB, 0.40191912E-07_JPRB, 0.40152194E-07_JPRB, 0.39555161E-07_JPRB, 0.38409850E-07_JPRB, 0.37031246E-07_JPRB, &
  & 0.35810846E-07_JPRB, 0.34675371E-07_JPRB, 0.33974586E-07_JPRB, 0.33130390E-07_JPRB, 0.32488080E-07_JPRB, 0.32189602E-07_JPRB, &
  & 0.32183462E-07_JPRB, 0.31716066E-07_JPRB, 0.31683526E-07_JPRB, 0.31552355E-07_JPRB, 0.31947621E-07_JPRB, 0.32181195E-07_JPRB, &
  & 0.31939888E-07_JPRB, 0.31120679E-07_JPRB, 0.30858549E-07_JPRB, 0.30651392E-07_JPRB  /)

RGHG7(:,64, 2) = (/ &
  & 0.17365820E-07_JPRB, 0.15329592E-07_JPRB, 0.14149027E-07_JPRB, 0.13578835E-07_JPRB, 0.12972257E-07_JPRB, 0.11589180E-07_JPRB, &
  & 0.99862393E-08_JPRB, 0.84660829E-08_JPRB, 0.75898040E-08_JPRB, 0.78221103E-08_JPRB, 0.82303738E-08_JPRB, 0.90643827E-08_JPRB, &
  & 0.10607410E-07_JPRB, 0.12413166E-07_JPRB, 0.14139754E-07_JPRB, 0.16444390E-07_JPRB, 0.19148428E-07_JPRB, 0.21447844E-07_JPRB, &
  & 0.23083277E-07_JPRB, 0.24819276E-07_JPRB, 0.26765061E-07_JPRB, 0.28593594E-07_JPRB, 0.29779256E-07_JPRB, 0.30091879E-07_JPRB, &
  & 0.29953814E-07_JPRB, 0.28780922E-07_JPRB, 0.26841923E-07_JPRB, 0.24004101E-07_JPRB, 0.21248353E-07_JPRB, 0.19953731E-07_JPRB, &
  & 0.20600312E-07_JPRB, 0.22090566E-07_JPRB, 0.23843486E-07_JPRB, 0.26415373E-07_JPRB, 0.29162016E-07_JPRB, 0.30975962E-07_JPRB, &
  & 0.31923274E-07_JPRB, 0.32825048E-07_JPRB, 0.34327577E-07_JPRB, 0.35356551E-07_JPRB, 0.36850459E-07_JPRB, 0.38348920E-07_JPRB, &
  & 0.39296569E-07_JPRB, 0.39225088E-07_JPRB, 0.39038814E-07_JPRB, 0.38272063E-07_JPRB, 0.36959430E-07_JPRB, 0.35550076E-07_JPRB, &
  & 0.34289344E-07_JPRB, 0.33201390E-07_JPRB, 0.32547327E-07_JPRB, 0.31716309E-07_JPRB, 0.31105946E-07_JPRB, 0.30801878E-07_JPRB, &
  & 0.30680329E-07_JPRB, 0.30276028E-07_JPRB, 0.30229112E-07_JPRB, 0.30052017E-07_JPRB, 0.30244421E-07_JPRB, 0.30278327E-07_JPRB, &
  & 0.30010264E-07_JPRB, 0.29471389E-07_JPRB, 0.29331057E-07_JPRB, 0.29156645E-07_JPRB  /)

RGHG7(:,65, 2) = (/ &
  & 0.15686424E-07_JPRB, 0.14108515E-07_JPRB, 0.13168754E-07_JPRB, 0.12680010E-07_JPRB, 0.11982647E-07_JPRB, 0.10622730E-07_JPRB, &
  & 0.90137878E-08_JPRB, 0.74790131E-08_JPRB, 0.65129463E-08_JPRB, 0.66057244E-08_JPRB, 0.68742642E-08_JPRB, 0.75630227E-08_JPRB, &
  & 0.88850639E-08_JPRB, 0.10555428E-07_JPRB, 0.12216922E-07_JPRB, 0.14496854E-07_JPRB, 0.17169569E-07_JPRB, 0.19587022E-07_JPRB, &
  & 0.21366869E-07_JPRB, 0.23126542E-07_JPRB, 0.25073635E-07_JPRB, 0.26969778E-07_JPRB, 0.28209898E-07_JPRB, 0.28693294E-07_JPRB, &
  & 0.28718187E-07_JPRB, 0.27673920E-07_JPRB, 0.25824318E-07_JPRB, 0.23075873E-07_JPRB, 0.20353777E-07_JPRB, 0.18941055E-07_JPRB, &
  & 0.19445494E-07_JPRB, 0.20783641E-07_JPRB, 0.22539061E-07_JPRB, 0.25535327E-07_JPRB, 0.28706175E-07_JPRB, 0.30900079E-07_JPRB, &
  & 0.32114749E-07_JPRB, 0.32846469E-07_JPRB, 0.34264292E-07_JPRB, 0.35294757E-07_JPRB, 0.36665722E-07_JPRB, 0.37792422E-07_JPRB, &
  & 0.38454814E-07_JPRB, 0.38364538E-07_JPRB, 0.38084855E-07_JPRB, 0.37190948E-07_JPRB, 0.35812301E-07_JPRB, 0.34412848E-07_JPRB, &
  & 0.33094749E-07_JPRB, 0.32042786E-07_JPRB, 0.31379678E-07_JPRB, 0.30585726E-07_JPRB, 0.30024280E-07_JPRB, 0.29708259E-07_JPRB, &
  & 0.29529891E-07_JPRB, 0.29189538E-07_JPRB, 0.29122561E-07_JPRB, 0.28948997E-07_JPRB, 0.29052954E-07_JPRB, 0.29009437E-07_JPRB, &
  & 0.28734114E-07_JPRB, 0.28296332E-07_JPRB, 0.28220745E-07_JPRB, 0.28138797E-07_JPRB  /)

RGHG7(:,66, 2) = (/ &
  & 0.14495451E-07_JPRB, 0.13250341E-07_JPRB, 0.12488096E-07_JPRB, 0.12044303E-07_JPRB, 0.11271085E-07_JPRB, 0.99250928E-08_JPRB, &
  & 0.82544183E-08_JPRB, 0.66622525E-08_JPRB, 0.56075188E-08_JPRB, 0.55629916E-08_JPRB, 0.57020604E-08_JPRB, 0.62512514E-08_JPRB, &
  & 0.73511487E-08_JPRB, 0.88567583E-08_JPRB, 0.10407378E-07_JPRB, 0.12583903E-07_JPRB, 0.15164884E-07_JPRB, 0.17638615E-07_JPRB, &
  & 0.19578682E-07_JPRB, 0.21385136E-07_JPRB, 0.23327655E-07_JPRB, 0.25257405E-07_JPRB, 0.26596948E-07_JPRB, 0.27242222E-07_JPRB, &
  & 0.27409289E-07_JPRB, 0.26582672E-07_JPRB, 0.24854704E-07_JPRB, 0.22195737E-07_JPRB, 0.19512650E-07_JPRB, 0.18025520E-07_JPRB, &
  & 0.18404393E-07_JPRB, 0.19605934E-07_JPRB, 0.21376511E-07_JPRB, 0.24604446E-07_JPRB, 0.28112674E-07_JPRB, 0.30630943E-07_JPRB, &
  & 0.32183237E-07_JPRB, 0.32948822E-07_JPRB, 0.34152819E-07_JPRB, 0.35217432E-07_JPRB, 0.36377946E-07_JPRB, 0.37137856E-07_JPRB, &
  & 0.37597154E-07_JPRB, 0.37517813E-07_JPRB, 0.37168530E-07_JPRB, 0.36176010E-07_JPRB, 0.34772477E-07_JPRB, 0.33395158E-07_JPRB, &
  & 0.32026364E-07_JPRB, 0.31007336E-07_JPRB, 0.30310916E-07_JPRB, 0.29565219E-07_JPRB, 0.29049643E-07_JPRB, 0.28714646E-07_JPRB, &
  & 0.28517342E-07_JPRB, 0.28232756E-07_JPRB, 0.28162992E-07_JPRB, 0.27992734E-07_JPRB, 0.28056730E-07_JPRB, 0.27960737E-07_JPRB, &
  & 0.27694217E-07_JPRB, 0.27307256E-07_JPRB, 0.27271412E-07_JPRB, 0.27298543E-07_JPRB  /)

RGHG7(:,67, 2) = (/ &
  & 0.13699382E-07_JPRB, 0.12665461E-07_JPRB, 0.12030243E-07_JPRB, 0.11600095E-07_JPRB, 0.10771551E-07_JPRB, 0.94345941E-08_JPRB, &
  & 0.76727603E-08_JPRB, 0.59953155E-08_JPRB, 0.48582933E-08_JPRB, 0.46832695E-08_JPRB, 0.47064138E-08_JPRB, 0.51224385E-08_JPRB, &
  & 0.60106384E-08_JPRB, 0.73279726E-08_JPRB, 0.87289774E-08_JPRB, 0.10728470E-07_JPRB, 0.13166947E-07_JPRB, 0.15635930E-07_JPRB, &
  & 0.17733638E-07_JPRB, 0.19594339E-07_JPRB, 0.21527501E-07_JPRB, 0.23484614E-07_JPRB, 0.24969555E-07_JPRB, 0.25766746E-07_JPRB, &
  & 0.26051418E-07_JPRB, 0.25509942E-07_JPRB, 0.23948311E-07_JPRB, 0.21389020E-07_JPRB, 0.18731392E-07_JPRB, 0.17204954E-07_JPRB, &
  & 0.17485052E-07_JPRB, 0.18584016E-07_JPRB, 0.20380754E-07_JPRB, 0.23666279E-07_JPRB, 0.27378386E-07_JPRB, 0.30149740E-07_JPRB, &
  & 0.32038715E-07_JPRB, 0.33048946E-07_JPRB, 0.34000691E-07_JPRB, 0.35081451E-07_JPRB, 0.35969235E-07_JPRB, 0.36399977E-07_JPRB, &
  & 0.36732948E-07_JPRB, 0.36673325E-07_JPRB, 0.36283792E-07_JPRB, 0.35223233E-07_JPRB, 0.33823161E-07_JPRB, 0.32473286E-07_JPRB, &
  & 0.31067187E-07_JPRB, 0.30078856E-07_JPRB, 0.29333824E-07_JPRB, 0.28643124E-07_JPRB, 0.28166163E-07_JPRB, 0.27808548E-07_JPRB, &
  & 0.27624124E-07_JPRB, 0.27387405E-07_JPRB, 0.27335727E-07_JPRB, 0.27160032E-07_JPRB, 0.27218711E-07_JPRB, 0.27086916E-07_JPRB, &
  & 0.26834658E-07_JPRB, 0.26474072E-07_JPRB, 0.26461949E-07_JPRB, 0.26604880E-07_JPRB  /)

RGHG7(:,68, 2) = (/ &
  & 0.13204418E-07_JPRB, 0.12259477E-07_JPRB, 0.11716929E-07_JPRB, 0.11274889E-07_JPRB, 0.10418463E-07_JPRB, 0.90815057E-08_JPRB, &
  & 0.72323320E-08_JPRB, 0.54622167E-08_JPRB, 0.42513862E-08_JPRB, 0.39615494E-08_JPRB, 0.38928433E-08_JPRB, 0.41829837E-08_JPRB, &
  & 0.48870728E-08_JPRB, 0.59985636E-08_JPRB, 0.72170978E-08_JPRB, 0.89656420E-08_JPRB, 0.11217548E-07_JPRB, 0.13624204E-07_JPRB, &
  & 0.15842055E-07_JPRB, 0.17733920E-07_JPRB, 0.19659291E-07_JPRB, 0.21680782E-07_JPRB, 0.23344912E-07_JPRB, 0.24288900E-07_JPRB, &
  & 0.24672394E-07_JPRB, 0.24424511E-07_JPRB, 0.23096607E-07_JPRB, 0.20684522E-07_JPRB, 0.18008442E-07_JPRB, 0.16452071E-07_JPRB, &
  & 0.16664921E-07_JPRB, 0.17727391E-07_JPRB, 0.19516338E-07_JPRB, 0.22762908E-07_JPRB, 0.26498798E-07_JPRB, 0.29441141E-07_JPRB, &
  & 0.31544161E-07_JPRB, 0.32975919E-07_JPRB, 0.33807931E-07_JPRB, 0.34790280E-07_JPRB, 0.35397182E-07_JPRB, 0.35602398E-07_JPRB, &
  & 0.35879193E-07_JPRB, 0.35812189E-07_JPRB, 0.35427577E-07_JPRB, 0.34334214E-07_JPRB, 0.32948494E-07_JPRB, 0.31621992E-07_JPRB, &
  & 0.30200721E-07_JPRB, 0.29241503E-07_JPRB, 0.28446035E-07_JPRB, 0.27810281E-07_JPRB, 0.27360383E-07_JPRB, 0.26983907E-07_JPRB, &
  & 0.26833516E-07_JPRB, 0.26640262E-07_JPRB, 0.26629999E-07_JPRB, 0.26431751E-07_JPRB, 0.26500681E-07_JPRB, 0.26349614E-07_JPRB, &
  & 0.26094485E-07_JPRB, 0.25768344E-07_JPRB, 0.25778363E-07_JPRB, 0.26032006E-07_JPRB  /)

RGHG7(:,69, 2) = (/ &
  & 0.12902594E-07_JPRB, 0.11948466E-07_JPRB, 0.11517231E-07_JPRB, 0.11040911E-07_JPRB, 0.10164443E-07_JPRB, 0.87927787E-08_JPRB, &
  & 0.69036773E-08_JPRB, 0.50584489E-08_JPRB, 0.37887515E-08_JPRB, 0.34139787E-08_JPRB, 0.32765773E-08_JPRB, 0.34688465E-08_JPRB, &
  & 0.40105041E-08_JPRB, 0.49296246E-08_JPRB, 0.59403442E-08_JPRB, 0.74126087E-08_JPRB, 0.94283425E-08_JPRB, 0.11712598E-07_JPRB, &
  & 0.13959883E-07_JPRB, 0.15818343E-07_JPRB, 0.17771752E-07_JPRB, 0.19822154E-07_JPRB, 0.21668801E-07_JPRB, 0.22749108E-07_JPRB, &
  & 0.23181396E-07_JPRB, 0.23168461E-07_JPRB, 0.22070508E-07_JPRB, 0.19951523E-07_JPRB, 0.17222661E-07_JPRB, 0.15646065E-07_JPRB, &
  & 0.15842061E-07_JPRB, 0.16893048E-07_JPRB, 0.18704062E-07_JPRB, 0.21877350E-07_JPRB, 0.25554915E-07_JPRB, 0.28533118E-07_JPRB, &
  & 0.30824765E-07_JPRB, 0.32578704E-07_JPRB, 0.33515295E-07_JPRB, 0.34317521E-07_JPRB, 0.34693228E-07_JPRB, 0.34820001E-07_JPRB, &
  & 0.35072351E-07_JPRB, 0.34976322E-07_JPRB, 0.34598496E-07_JPRB, 0.33502191E-07_JPRB, 0.32131193E-07_JPRB, 0.30825447E-07_JPRB, &
  & 0.29407667E-07_JPRB, 0.28479050E-07_JPRB, 0.27641738E-07_JPRB, 0.27052338E-07_JPRB, 0.26623526E-07_JPRB, 0.26236402E-07_JPRB, &
  & 0.26140192E-07_JPRB, 0.25982184E-07_JPRB, 0.26013328E-07_JPRB, 0.25790666E-07_JPRB, 0.25872457E-07_JPRB, 0.25728992E-07_JPRB, &
  & 0.25444123E-07_JPRB, 0.25181155E-07_JPRB, 0.25192788E-07_JPRB, 0.25528013E-07_JPRB  /)

RGHG7(:,70, 2) = (/ &
  & 0.12681134E-07_JPRB, 0.11685233E-07_JPRB, 0.11380244E-07_JPRB, 0.10866887E-07_JPRB, 0.99556237E-08_JPRB, 0.85355092E-08_JPRB, &
  & 0.66456320E-08_JPRB, 0.47342595E-08_JPRB, 0.34208725E-08_JPRB, 0.29751416E-08_JPRB, 0.27812007E-08_JPRB, 0.28943707E-08_JPRB, &
  & 0.32947115E-08_JPRB, 0.40355106E-08_JPRB, 0.48466955E-08_JPRB, 0.60670272E-08_JPRB, 0.78300180E-08_JPRB, 0.99163542E-08_JPRB, &
  & 0.12125799E-07_JPRB, 0.13932020E-07_JPRB, 0.15903954E-07_JPRB, 0.17936695E-07_JPRB, 0.19900309E-07_JPRB, 0.21084722E-07_JPRB, &
  & 0.21567160E-07_JPRB, 0.21696165E-07_JPRB, 0.20886873E-07_JPRB, 0.19082889E-07_JPRB, 0.16311570E-07_JPRB, 0.14763086E-07_JPRB, &
  & 0.14996495E-07_JPRB, 0.16045356E-07_JPRB, 0.17867368E-07_JPRB, 0.20983141E-07_JPRB, 0.24579861E-07_JPRB, 0.27538003E-07_JPRB, &
  & 0.29988030E-07_JPRB, 0.32018292E-07_JPRB, 0.33088490E-07_JPRB, 0.33721703E-07_JPRB, 0.33972405E-07_JPRB, 0.34074651E-07_JPRB, &
  & 0.34291581E-07_JPRB, 0.34165047E-07_JPRB, 0.33791106E-07_JPRB, 0.32700520E-07_JPRB, 0.31347170E-07_JPRB, 0.30059342E-07_JPRB, &
  & 0.28654766E-07_JPRB, 0.27743614E-07_JPRB, 0.26890244E-07_JPRB, 0.26330714E-07_JPRB, 0.25918391E-07_JPRB, 0.25533084E-07_JPRB, &
  & 0.25495296E-07_JPRB, 0.25372271E-07_JPRB, 0.25432752E-07_JPRB, 0.25199978E-07_JPRB, 0.25292532E-07_JPRB, 0.25166962E-07_JPRB, &
  & 0.24847019E-07_JPRB, 0.24651857E-07_JPRB, 0.24650925E-07_JPRB, 0.25038096E-07_JPRB  /)

RGHG7(:,71, 2) = (/ &
  & 0.12517179E-07_JPRB, 0.11466154E-07_JPRB, 0.11296199E-07_JPRB, 0.10745669E-07_JPRB, 0.97789955E-08_JPRB, 0.83105622E-08_JPRB, &
  & 0.64476073E-08_JPRB, 0.44782323E-08_JPRB, 0.31336433E-08_JPRB, 0.26321972E-08_JPRB, 0.23945459E-08_JPRB, 0.24438648E-08_JPRB, &
  & 0.27276180E-08_JPRB, 0.33060014E-08_JPRB, 0.39377597E-08_JPRB, 0.49429605E-08_JPRB, 0.64482171E-08_JPRB, 0.82667112E-08_JPRB, &
  & 0.10366290E-07_JPRB, 0.12116269E-07_JPRB, 0.14079152E-07_JPRB, 0.16057741E-07_JPRB, 0.18042303E-07_JPRB, 0.19294404E-07_JPRB, &
  & 0.19819381E-07_JPRB, 0.20020020E-07_JPRB, 0.19534982E-07_JPRB, 0.18041888E-07_JPRB, 0.15266644E-07_JPRB, 0.13805712E-07_JPRB, &
  & 0.14118232E-07_JPRB, 0.15167487E-07_JPRB, 0.17000554E-07_JPRB, 0.20081984E-07_JPRB, 0.23586171E-07_JPRB, 0.26492862E-07_JPRB, &
  & 0.29055996E-07_JPRB, 0.31307477E-07_JPRB, 0.32500081E-07_JPRB, 0.33024120E-07_JPRB, 0.33255827E-07_JPRB, 0.33372516E-07_JPRB, &
  & 0.33534860E-07_JPRB, 0.33385988E-07_JPRB, 0.33012243E-07_JPRB, 0.31935650E-07_JPRB, 0.30598502E-07_JPRB, 0.29326901E-07_JPRB, &
  & 0.27938842E-07_JPRB, 0.27032084E-07_JPRB, 0.26186970E-07_JPRB, 0.25643443E-07_JPRB, 0.25241058E-07_JPRB, 0.24869741E-07_JPRB, &
  & 0.24886757E-07_JPRB, 0.24798024E-07_JPRB, 0.24878837E-07_JPRB, 0.24652364E-07_JPRB, 0.24750027E-07_JPRB, 0.24644873E-07_JPRB, &
  & 0.24296644E-07_JPRB, 0.24163772E-07_JPRB, 0.24136313E-07_JPRB, 0.24553763E-07_JPRB  /)

RGHG7(:,72, 2) = (/ &
  & 0.12391034E-07_JPRB, 0.11294448E-07_JPRB, 0.11257893E-07_JPRB, 0.10670832E-07_JPRB, 0.96208353E-08_JPRB, 0.81265433E-08_JPRB, &
  & 0.62984772E-08_JPRB, 0.42794369E-08_JPRB, 0.29110414E-08_JPRB, 0.23751169E-08_JPRB, 0.21103754E-08_JPRB, 0.21063349E-08_JPRB, &
  & 0.23055339E-08_JPRB, 0.27406678E-08_JPRB, 0.32287661E-08_JPRB, 0.40693736E-08_JPRB, 0.53263037E-08_JPRB, 0.68184843E-08_JPRB, &
  & 0.87198124E-08_JPRB, 0.10428335E-07_JPRB, 0.12328419E-07_JPRB, 0.14237229E-07_JPRB, 0.16099885E-07_JPRB, 0.17379077E-07_JPRB, &
  & 0.17910622E-07_JPRB, 0.18162568E-07_JPRB, 0.17981268E-07_JPRB, 0.16771800E-07_JPRB, 0.14077416E-07_JPRB, 0.12778614E-07_JPRB, &
  & 0.13188002E-07_JPRB, 0.14230279E-07_JPRB, 0.16104802E-07_JPRB, 0.19179254E-07_JPRB, 0.22586984E-07_JPRB, 0.25440726E-07_JPRB, &
  & 0.28042854E-07_JPRB, 0.30430606E-07_JPRB, 0.31697914E-07_JPRB, 0.32248632E-07_JPRB, 0.32557505E-07_JPRB, 0.32719344E-07_JPRB, &
  & 0.32800418E-07_JPRB, 0.32651956E-07_JPRB, 0.32274107E-07_JPRB, 0.31223783E-07_JPRB, 0.29892382E-07_JPRB, 0.28637609E-07_JPRB, &
  & 0.27258991E-07_JPRB, 0.26346487E-07_JPRB, 0.25528052E-07_JPRB, 0.24993145E-07_JPRB, 0.24589939E-07_JPRB, 0.24243659E-07_JPRB, &
  & 0.24300079E-07_JPRB, 0.24242541E-07_JPRB, 0.24343056E-07_JPRB, 0.24140390E-07_JPRB, 0.24231486E-07_JPRB, 0.24137825E-07_JPRB, &
  & 0.23787133E-07_JPRB, 0.23696537E-07_JPRB, 0.23627212E-07_JPRB, 0.24068468E-07_JPRB  /)

RGHG7(:,73, 2) = (/ &
  & 0.12260650E-07_JPRB, 0.11189477E-07_JPRB, 0.11260809E-07_JPRB, 0.10627101E-07_JPRB, 0.94498682E-08_JPRB, 0.79790916E-08_JPRB, &
  & 0.61792597E-08_JPRB, 0.41197897E-08_JPRB, 0.27339257E-08_JPRB, 0.21880847E-08_JPRB, 0.19067626E-08_JPRB, 0.18738150E-08_JPRB, &
  & 0.20115882E-08_JPRB, 0.23296886E-08_JPRB, 0.27224362E-08_JPRB, 0.34294950E-08_JPRB, 0.44690378E-08_JPRB, 0.56703440E-08_JPRB, &
  & 0.73033169E-08_JPRB, 0.89297615E-08_JPRB, 0.10738870E-07_JPRB, 0.12549308E-07_JPRB, 0.14249349E-07_JPRB, 0.15479216E-07_JPRB, &
  & 0.15993366E-07_JPRB, 0.16210059E-07_JPRB, 0.16245498E-07_JPRB, 0.15282445E-07_JPRB, 0.12868631E-07_JPRB, 0.11827760E-07_JPRB, &
  & 0.12254577E-07_JPRB, 0.13327170E-07_JPRB, 0.15240723E-07_JPRB, 0.18325681E-07_JPRB, 0.21655060E-07_JPRB, 0.24379735E-07_JPRB, &
  & 0.26890795E-07_JPRB, 0.29327229E-07_JPRB, 0.30717674E-07_JPRB, 0.31462086E-07_JPRB, 0.31840192E-07_JPRB, 0.32085539E-07_JPRB, &
  & 0.32104299E-07_JPRB, 0.31950536E-07_JPRB, 0.31607797E-07_JPRB, 0.30549990E-07_JPRB, 0.29217892E-07_JPRB, 0.27997189E-07_JPRB, &
  & 0.26613971E-07_JPRB, 0.25706735E-07_JPRB, 0.24909801E-07_JPRB, 0.24372135E-07_JPRB, 0.23946008E-07_JPRB, 0.23623769E-07_JPRB, &
  & 0.23712202E-07_JPRB, 0.23696706E-07_JPRB, 0.23820847E-07_JPRB, 0.23627650E-07_JPRB, 0.23698426E-07_JPRB, 0.23616324E-07_JPRB, &
  & 0.23303156E-07_JPRB, 0.23220035E-07_JPRB, 0.23068980E-07_JPRB, 0.23525419E-07_JPRB  /)

RGHG7(:,74, 2) = (/ &
  & 0.12112944E-07_JPRB, 0.11132120E-07_JPRB, 0.11284290E-07_JPRB, 0.10580826E-07_JPRB, 0.92715613E-08_JPRB, 0.78447872E-08_JPRB, &
  & 0.60609501E-08_JPRB, 0.39849214E-08_JPRB, 0.25878417E-08_JPRB, 0.20363921E-08_JPRB, 0.17498013E-08_JPRB, 0.16979662E-08_JPRB, &
  & 0.17926840E-08_JPRB, 0.20134326E-08_JPRB, 0.23261498E-08_JPRB, 0.29185261E-08_JPRB, 0.37752443E-08_JPRB, 0.47444904E-08_JPRB, &
  & 0.61206012E-08_JPRB, 0.76214854E-08_JPRB, 0.93356124E-08_JPRB, 0.11047607E-07_JPRB, 0.12569144E-07_JPRB, 0.13715798E-07_JPRB, &
  & 0.14190479E-07_JPRB, 0.14366906E-07_JPRB, 0.14507927E-07_JPRB, 0.13747493E-07_JPRB, 0.11739062E-07_JPRB, 0.10947297E-07_JPRB, &
  & 0.11384346E-07_JPRB, 0.12503496E-07_JPRB, 0.14453602E-07_JPRB, 0.17551517E-07_JPRB, 0.20835631E-07_JPRB, 0.23433153E-07_JPRB, &
  & 0.25776620E-07_JPRB, 0.28204246E-07_JPRB, 0.29728711E-07_JPRB, 0.30702967E-07_JPRB, 0.31129239E-07_JPRB, 0.31453796E-07_JPRB, &
  & 0.31431981E-07_JPRB, 0.31294253E-07_JPRB, 0.31002030E-07_JPRB, 0.29905900E-07_JPRB, 0.28573308E-07_JPRB, 0.27398498E-07_JPRB, &
  & 0.25999342E-07_JPRB, 0.25093833E-07_JPRB, 0.24311002E-07_JPRB, 0.23761195E-07_JPRB, 0.23308329E-07_JPRB, 0.23005311E-07_JPRB, &
  & 0.23122128E-07_JPRB, 0.23156235E-07_JPRB, 0.23296127E-07_JPRB, 0.23102506E-07_JPRB, 0.23137947E-07_JPRB, 0.23062937E-07_JPRB, &
  & 0.22809948E-07_JPRB, 0.22709307E-07_JPRB, 0.22454668E-07_JPRB, 0.22886882E-07_JPRB  /)

RGHG7(:,75, 2) = (/ &
  & 0.11954382E-07_JPRB, 0.11112997E-07_JPRB, 0.11318336E-07_JPRB, 0.10522332E-07_JPRB, 0.90907942E-08_JPRB, 0.77188628E-08_JPRB, &
  & 0.59437103E-08_JPRB, 0.38722436E-08_JPRB, 0.24771904E-08_JPRB, 0.19145791E-08_JPRB, 0.16340669E-08_JPRB, 0.15691071E-08_JPRB, &
  & 0.16349106E-08_JPRB, 0.17792740E-08_JPRB, 0.20227502E-08_JPRB, 0.25164302E-08_JPRB, 0.32279809E-08_JPRB, 0.40148640E-08_JPRB, &
  & 0.51657968E-08_JPRB, 0.65255224E-08_JPRB, 0.81417248E-08_JPRB, 0.97499706E-08_JPRB, 0.11091010E-07_JPRB, 0.12118137E-07_JPRB, &
  & 0.12562992E-07_JPRB, 0.12707557E-07_JPRB, 0.12863266E-07_JPRB, 0.12265172E-07_JPRB, 0.10714772E-07_JPRB, 0.10142142E-07_JPRB, &
  & 0.10589749E-07_JPRB, 0.11756197E-07_JPRB, 0.13743894E-07_JPRB, 0.16866072E-07_JPRB, 0.20157049E-07_JPRB, 0.22652275E-07_JPRB, &
  & 0.24782100E-07_JPRB, 0.27155933E-07_JPRB, 0.28785815E-07_JPRB, 0.29971127E-07_JPRB, 0.30453447E-07_JPRB, 0.30829114E-07_JPRB, &
  & 0.30791506E-07_JPRB, 0.30692412E-07_JPRB, 0.30457144E-07_JPRB, 0.29302636E-07_JPRB, 0.27962543E-07_JPRB, 0.26837904E-07_JPRB, &
  & 0.25417139E-07_JPRB, 0.24504371E-07_JPRB, 0.23722594E-07_JPRB, 0.23156230E-07_JPRB, 0.22679360E-07_JPRB, 0.22388640E-07_JPRB, &
  & 0.22531224E-07_JPRB, 0.22620941E-07_JPRB, 0.22766120E-07_JPRB, 0.22557121E-07_JPRB, 0.22546643E-07_JPRB, 0.22478589E-07_JPRB, &
  & 0.22294685E-07_JPRB, 0.22149785E-07_JPRB, 0.21780652E-07_JPRB, 0.22149209E-07_JPRB  /)

RGHG7(:,76, 2) = (/ &
  & 0.11796412E-07_JPRB, 0.11120890E-07_JPRB, 0.11350452E-07_JPRB, 0.10440725E-07_JPRB, 0.89139385E-08_JPRB, 0.75970214E-08_JPRB, &
  & 0.58317221E-08_JPRB, 0.37799620E-08_JPRB, 0.24115948E-08_JPRB, 0.18194237E-08_JPRB, 0.15565653E-08_JPRB, 0.14796994E-08_JPRB, &
  & 0.15249752E-08_JPRB, 0.16171982E-08_JPRB, 0.17999125E-08_JPRB, 0.22081973E-08_JPRB, 0.28171096E-08_JPRB, 0.34541405E-08_JPRB, &
  & 0.44318196E-08_JPRB, 0.56786430E-08_JPRB, 0.71917964E-08_JPRB, 0.86781077E-08_JPRB, 0.98545149E-08_JPRB, 0.10714547E-07_JPRB, &
  & 0.11189372E-07_JPRB, 0.11319978E-07_JPRB, 0.11432989E-07_JPRB, 0.10962989E-07_JPRB, 0.98223213E-08_JPRB, 0.94204813E-08_JPRB, &
  & 0.98804048E-08_JPRB, 0.11073539E-07_JPRB, 0.13105576E-07_JPRB, 0.16279894E-07_JPRB, 0.19659141E-07_JPRB, 0.22102226E-07_JPRB, &
  & 0.24011173E-07_JPRB, 0.26300432E-07_JPRB, 0.27949610E-07_JPRB, 0.29259320E-07_JPRB, 0.29853721E-07_JPRB, 0.30220356E-07_JPRB, &
  & 0.30196706E-07_JPRB, 0.30157553E-07_JPRB, 0.29975247E-07_JPRB, 0.28758335E-07_JPRB, 0.27391145E-07_JPRB, 0.26310025E-07_JPRB, &
  & 0.24870374E-07_JPRB, 0.23934616E-07_JPRB, 0.23131900E-07_JPRB, 0.22551988E-07_JPRB, 0.22061570E-07_JPRB, 0.21773313E-07_JPRB, &
  & 0.21940120E-07_JPRB, 0.22089778E-07_JPRB, 0.22227156E-07_JPRB, 0.21978744E-07_JPRB, 0.21918588E-07_JPRB, 0.21864904E-07_JPRB, &
  & 0.21740119E-07_JPRB, 0.21519267E-07_JPRB, 0.21038874E-07_JPRB, 0.21307667E-07_JPRB  /)

RGHG7(:,77, 2) = (/ &
  & 0.11691861E-07_JPRB, 0.11145867E-07_JPRB, 0.11339573E-07_JPRB, 0.10331481E-07_JPRB, 0.87610077E-08_JPRB, 0.74876470E-08_JPRB, &
  & 0.57512981E-08_JPRB, 0.37159714E-08_JPRB, 0.23975767E-08_JPRB, 0.17477791E-08_JPRB, 0.14984822E-08_JPRB, 0.14154643E-08_JPRB, &
  & 0.14561114E-08_JPRB, 0.15163812E-08_JPRB, 0.16422056E-08_JPRB, 0.19701955E-08_JPRB, 0.25133126E-08_JPRB, 0.30496935E-08_JPRB, &
  & 0.39112806E-08_JPRB, 0.50965107E-08_JPRB, 0.65466119E-08_JPRB, 0.79052996E-08_JPRB, 0.89376313E-08_JPRB, 0.96029084E-08_JPRB, &
  & 0.10041389E-07_JPRB, 0.10217866E-07_JPRB, 0.10300603E-07_JPRB, 0.99226100E-08_JPRB, 0.90284934E-08_JPRB, 0.88314748E-08_JPRB, &
  & 0.92948074E-08_JPRB, 0.10507109E-07_JPRB, 0.12572666E-07_JPRB, 0.15833833E-07_JPRB, 0.19367771E-07_JPRB, 0.21832217E-07_JPRB, &
  & 0.23558997E-07_JPRB, 0.25727722E-07_JPRB, 0.27337627E-07_JPRB, 0.28706373E-07_JPRB, 0.29420773E-07_JPRB, 0.29811026E-07_JPRB, &
  & 0.29753353E-07_JPRB, 0.29762753E-07_JPRB, 0.29569792E-07_JPRB, 0.28293929E-07_JPRB, 0.26845941E-07_JPRB, 0.25802247E-07_JPRB, &
  & 0.24371086E-07_JPRB, 0.23386338E-07_JPRB, 0.22561596E-07_JPRB, 0.21954514E-07_JPRB, 0.21451144E-07_JPRB, 0.21173284E-07_JPRB, &
  & 0.21342544E-07_JPRB, 0.21532067E-07_JPRB, 0.21647711E-07_JPRB, 0.21354189E-07_JPRB, 0.21241278E-07_JPRB, 0.21191110E-07_JPRB, &
  & 0.21105753E-07_JPRB, 0.20781405E-07_JPRB, 0.20202381E-07_JPRB, 0.20387758E-07_JPRB  /)

RGHG7(:,78, 2) = (/ &
  & 0.11622831E-07_JPRB, 0.11177971E-07_JPRB, 0.11274478E-07_JPRB, 0.10207044E-07_JPRB, 0.86247033E-08_JPRB, 0.73853813E-08_JPRB, &
  & 0.56995505E-08_JPRB, 0.36875554E-08_JPRB, 0.24091234E-08_JPRB, 0.16985181E-08_JPRB, 0.14543103E-08_JPRB, 0.13694460E-08_JPRB, &
  & 0.14082074E-08_JPRB, 0.14422483E-08_JPRB, 0.15155733E-08_JPRB, 0.17860581E-08_JPRB, 0.22722617E-08_JPRB, 0.27322267E-08_JPRB, &
  & 0.35169940E-08_JPRB, 0.46629850E-08_JPRB, 0.60601368E-08_JPRB, 0.73101352E-08_JPRB, 0.82468592E-08_JPRB, 0.87697303E-08_JPRB, &
  & 0.91585693E-08_JPRB, 0.93628852E-08_JPRB, 0.94182589E-08_JPRB, 0.90913420E-08_JPRB, 0.84061191E-08_JPRB, 0.83822462E-08_JPRB, &
  & 0.88297115E-08_JPRB, 0.10040601E-07_JPRB, 0.12130761E-07_JPRB, 0.15488031E-07_JPRB, 0.19176303E-07_JPRB, 0.21666340E-07_JPRB, &
  & 0.23236499E-07_JPRB, 0.25302196E-07_JPRB, 0.26864199E-07_JPRB, 0.28280497E-07_JPRB, 0.29083421E-07_JPRB, 0.29510899E-07_JPRB, &
  & 0.29439958E-07_JPRB, 0.29460087E-07_JPRB, 0.29220221E-07_JPRB, 0.27894543E-07_JPRB, 0.26350939E-07_JPRB, 0.25302418E-07_JPRB, &
  & 0.23882808E-07_JPRB, 0.22850996E-07_JPRB, 0.22005042E-07_JPRB, 0.21371993E-07_JPRB, 0.20851258E-07_JPRB, 0.20575202E-07_JPRB, &
  & 0.20736982E-07_JPRB, 0.20953747E-07_JPRB, 0.21032693E-07_JPRB, 0.20697882E-07_JPRB, 0.20533300E-07_JPRB, 0.20469115E-07_JPRB, &
  & 0.20410321E-07_JPRB, 0.19971562E-07_JPRB, 0.19296555E-07_JPRB, 0.19447848E-07_JPRB  /)

RGHG7(:,79, 2) = (/ &
  & 0.11571357E-07_JPRB, 0.11199750E-07_JPRB, 0.11156323E-07_JPRB, 0.10067769E-07_JPRB, 0.85019516E-08_JPRB, 0.72879807E-08_JPRB, &
  & 0.56721229E-08_JPRB, 0.36969936E-08_JPRB, 0.24408185E-08_JPRB, 0.16723712E-08_JPRB, 0.14231782E-08_JPRB, 0.13371469E-08_JPRB, &
  & 0.13769256E-08_JPRB, 0.13890087E-08_JPRB, 0.14155275E-08_JPRB, 0.16462860E-08_JPRB, 0.20874011E-08_JPRB, 0.24956046E-08_JPRB, &
  & 0.32302682E-08_JPRB, 0.43443608E-08_JPRB, 0.56953049E-08_JPRB, 0.68594351E-08_JPRB, 0.77399868E-08_JPRB, 0.81747995E-08_JPRB, &
  & 0.85167485E-08_JPRB, 0.87305681E-08_JPRB, 0.87637446E-08_JPRB, 0.84713953E-08_JPRB, 0.79562031E-08_JPRB, 0.80692238E-08_JPRB, &
  & 0.84805176E-08_JPRB, 0.96663615E-08_JPRB, 0.11776474E-07_JPRB, 0.15235914E-07_JPRB, 0.19054012E-07_JPRB, 0.21551088E-07_JPRB, &
  & 0.22994562E-07_JPRB, 0.24966874E-07_JPRB, 0.26509026E-07_JPRB, 0.27960897E-07_JPRB, 0.28821118E-07_JPRB, 0.29293685E-07_JPRB, &
  & 0.29228143E-07_JPRB, 0.29227810E-07_JPRB, 0.28916511E-07_JPRB, 0.27540310E-07_JPRB, 0.25906427E-07_JPRB, 0.24821908E-07_JPRB, &
  & 0.23404153E-07_JPRB, 0.22323775E-07_JPRB, 0.21458359E-07_JPRB, 0.20806854E-07_JPRB, 0.20263664E-07_JPRB, 0.19977985E-07_JPRB, &
  & 0.20120398E-07_JPRB, 0.20351886E-07_JPRB, 0.20386233E-07_JPRB, 0.20002862E-07_JPRB, 0.19791438E-07_JPRB, 0.19710957E-07_JPRB, &
  & 0.19648548E-07_JPRB, 0.19090843E-07_JPRB, 0.18324433E-07_JPRB, 0.18477809E-07_JPRB  /)

RGHG7(:,80, 2) = (/ &
  & 0.11519049E-07_JPRB, 0.11193773E-07_JPRB, 0.10989685E-07_JPRB, 0.99144746E-08_JPRB, 0.83897890E-08_JPRB, 0.71935910E-08_JPRB, &
  & 0.56637497E-08_JPRB, 0.37453460E-08_JPRB, 0.24876930E-08_JPRB, 0.16696214E-08_JPRB, 0.14041369E-08_JPRB, 0.13136327E-08_JPRB, &
  & 0.13584002E-08_JPRB, 0.13520301E-08_JPRB, 0.13386372E-08_JPRB, 0.15402692E-08_JPRB, 0.19530452E-08_JPRB, 0.23356500E-08_JPRB, &
  & 0.30333663E-08_JPRB, 0.41076389E-08_JPRB, 0.54171374E-08_JPRB, 0.65206120E-08_JPRB, 0.73715672E-08_JPRB, 0.77684671E-08_JPRB, &
  & 0.80808909E-08_JPRB, 0.82910096E-08_JPRB, 0.83103178E-08_JPRB, 0.80644538E-08_JPRB, 0.76714059E-08_JPRB, 0.78848819E-08_JPRB, &
  & 0.82396197E-08_JPRB, 0.93747499E-08_JPRB, 0.11504804E-07_JPRB, 0.15070399E-07_JPRB, 0.18971862E-07_JPRB, 0.21437446E-07_JPRB, &
  & 0.22789472E-07_JPRB, 0.24665484E-07_JPRB, 0.26252613E-07_JPRB, 0.27724072E-07_JPRB, 0.28613971E-07_JPRB, 0.29134240E-07_JPRB, &
  & 0.29085500E-07_JPRB, 0.29043495E-07_JPRB, 0.28648180E-07_JPRB, 0.27209365E-07_JPRB, 0.25510585E-07_JPRB, 0.24374652E-07_JPRB, &
  & 0.22936383E-07_JPRB, 0.21800481E-07_JPRB, 0.20918492E-07_JPRB, 0.20262080E-07_JPRB, 0.19691183E-07_JPRB, 0.19382914E-07_JPRB, &
  & 0.19491431E-07_JPRB, 0.19725259E-07_JPRB, 0.19715196E-07_JPRB, 0.19263567E-07_JPRB, 0.19013744E-07_JPRB, 0.18932349E-07_JPRB, &
  & 0.18817287E-07_JPRB, 0.18142620E-07_JPRB, 0.17292448E-07_JPRB, 0.17466648E-07_JPRB  /)

RGHG7(:,81, 2) = (/ &
  & 0.11385995E-07_JPRB, 0.11064097E-07_JPRB, 0.10724069E-07_JPRB, 0.97096515E-08_JPRB, 0.82761554E-08_JPRB, 0.70824904E-08_JPRB, &
  & 0.56641029E-08_JPRB, 0.38140913E-08_JPRB, 0.25416623E-08_JPRB, 0.16843285E-08_JPRB, 0.13964688E-08_JPRB, 0.12992099E-08_JPRB, &
  & 0.13422887E-08_JPRB, 0.13211425E-08_JPRB, 0.12870631E-08_JPRB, 0.14663199E-08_JPRB, 0.18600981E-08_JPRB, 0.22367925E-08_JPRB, &
  & 0.29083340E-08_JPRB, 0.39543210E-08_JPRB, 0.52330008E-08_JPRB, 0.62849702E-08_JPRB, 0.71181942E-08_JPRB, 0.75003180E-08_JPRB, &
  & 0.77891000E-08_JPRB, 0.79971079E-08_JPRB, 0.79991070E-08_JPRB, 0.77781512E-08_JPRB, 0.74876915E-08_JPRB, 0.77826470E-08_JPRB, &
  & 0.80892570E-08_JPRB, 0.91724598E-08_JPRB, 0.11331222E-07_JPRB, 0.14986318E-07_JPRB, 0.18910155E-07_JPRB, 0.21274840E-07_JPRB, &
  & 0.22553830E-07_JPRB, 0.24347097E-07_JPRB, 0.26049900E-07_JPRB, 0.27545001E-07_JPRB, 0.28445877E-07_JPRB, 0.28993165E-07_JPRB, &
  & 0.28958779E-07_JPRB, 0.28870335E-07_JPRB, 0.28403673E-07_JPRB, 0.26904065E-07_JPRB, 0.25162223E-07_JPRB, 0.23963808E-07_JPRB, &
  & 0.22509919E-07_JPRB, 0.21309002E-07_JPRB, 0.20393661E-07_JPRB, 0.19732183E-07_JPRB, 0.19124135E-07_JPRB, 0.18766472E-07_JPRB, &
  & 0.18836149E-07_JPRB, 0.19047602E-07_JPRB, 0.19012209E-07_JPRB, 0.18452925E-07_JPRB, 0.18194237E-07_JPRB, 0.18120018E-07_JPRB, &
  & 0.17907856E-07_JPRB, 0.17112870E-07_JPRB, 0.16170242E-07_JPRB, 0.16334309E-07_JPRB  /)

RGHG7(:,82, 2) = (/ &
  & 0.11162111E-07_JPRB, 0.10826407E-07_JPRB, 0.10375449E-07_JPRB, 0.94554672E-08_JPRB, 0.81396284E-08_JPRB, 0.69601147E-08_JPRB, &
  & 0.56571231E-08_JPRB, 0.38820476E-08_JPRB, 0.25885378E-08_JPRB, 0.16919018E-08_JPRB, 0.13870453E-08_JPRB, 0.12842382E-08_JPRB, &
  & 0.13238939E-08_JPRB, 0.12944649E-08_JPRB, 0.12468118E-08_JPRB, 0.14113988E-08_JPRB, 0.17903725E-08_JPRB, 0.21597399E-08_JPRB, &
  & 0.28148722E-08_JPRB, 0.38397349E-08_JPRB, 0.50898289E-08_JPRB, 0.61060377E-08_JPRB, 0.69146629E-08_JPRB, 0.72940303E-08_JPRB, &
  & 0.75537953E-08_JPRB, 0.77541794E-08_JPRB, 0.77357804E-08_JPRB, 0.75352108E-08_JPRB, 0.73347589E-08_JPRB, 0.77013660E-08_JPRB, &
  & 0.79648094E-08_JPRB, 0.90135772E-08_JPRB, 0.11201445E-07_JPRB, 0.14930927E-07_JPRB, 0.18844712E-07_JPRB, 0.21097216E-07_JPRB, &
  & 0.22298110E-07_JPRB, 0.24044644E-07_JPRB, 0.25854241E-07_JPRB, 0.27380686E-07_JPRB, 0.28291886E-07_JPRB, 0.28857585E-07_JPRB, &
  & 0.28813902E-07_JPRB, 0.28695604E-07_JPRB, 0.28167939E-07_JPRB, 0.26624215E-07_JPRB, 0.24841331E-07_JPRB, 0.23588396E-07_JPRB, &
  & 0.22102407E-07_JPRB, 0.20869758E-07_JPRB, 0.19928841E-07_JPRB, 0.19253603E-07_JPRB, 0.18592062E-07_JPRB, 0.18158270E-07_JPRB, &
  & 0.18186446E-07_JPRB, 0.18356179E-07_JPRB, 0.18318014E-07_JPRB, 0.17653217E-07_JPRB, 0.17362451E-07_JPRB, 0.17286056E-07_JPRB, &
  & 0.17009409E-07_JPRB, 0.16108542E-07_JPRB, 0.15057179E-07_JPRB, 0.15185001E-07_JPRB  /)

RGHG7(:,83, 2) = (/ &
  & 0.10862805E-07_JPRB, 0.10496219E-07_JPRB, 0.99501960E-08_JPRB, 0.91478041E-08_JPRB, 0.79653322E-08_JPRB, 0.68228382E-08_JPRB, &
  & 0.56332551E-08_JPRB, 0.39389327E-08_JPRB, 0.26244522E-08_JPRB, 0.16938716E-08_JPRB, 0.13775178E-08_JPRB, 0.12702025E-08_JPRB, &
  & 0.13055374E-08_JPRB, 0.12723122E-08_JPRB, 0.12186105E-08_JPRB, 0.13721275E-08_JPRB, 0.17377230E-08_JPRB, 0.21009595E-08_JPRB, &
  & 0.27469292E-08_JPRB, 0.37576113E-08_JPRB, 0.49846022E-08_JPRB, 0.59787158E-08_JPRB, 0.67598874E-08_JPRB, 0.71514183E-08_JPRB, &
  & 0.73904593E-08_JPRB, 0.75873055E-08_JPRB, 0.75614557E-08_JPRB, 0.73827334E-08_JPRB, 0.72555106E-08_JPRB, 0.76600847E-08_JPRB, &
  & 0.78805077E-08_JPRB, 0.88954031E-08_JPRB, 0.11113356E-07_JPRB, 0.14890566E-07_JPRB, 0.18772812E-07_JPRB, 0.20922704E-07_JPRB, &
  & 0.22039544E-07_JPRB, 0.23751912E-07_JPRB, 0.25643050E-07_JPRB, 0.27214816E-07_JPRB, 0.28142928E-07_JPRB, 0.28721575E-07_JPRB, &
  & 0.28668170E-07_JPRB, 0.28514681E-07_JPRB, 0.27942140E-07_JPRB, 0.26359555E-07_JPRB, 0.24543345E-07_JPRB, 0.23244657E-07_JPRB, &
  & 0.21719246E-07_JPRB, 0.20480499E-07_JPRB, 0.19518019E-07_JPRB, 0.18817576E-07_JPRB, 0.18102327E-07_JPRB, 0.17576187E-07_JPRB, &
  & 0.17548078E-07_JPRB, 0.17669345E-07_JPRB, 0.17629228E-07_JPRB, 0.16876392E-07_JPRB, 0.16529434E-07_JPRB, 0.16438260E-07_JPRB, &
  & 0.16126844E-07_JPRB, 0.15138578E-07_JPRB, 0.13966353E-07_JPRB, 0.14034510E-07_JPRB  /)

RGHG7(:,84, 2) = (/ &
  & 0.10505600E-07_JPRB, 0.10093302E-07_JPRB, 0.94610728E-08_JPRB, 0.87889787E-08_JPRB, 0.77444516E-08_JPRB, 0.66675213E-08_JPRB, &
  & 0.55850986E-08_JPRB, 0.39764834E-08_JPRB, 0.26461626E-08_JPRB, 0.16917134E-08_JPRB, 0.13689523E-08_JPRB, 0.12580995E-08_JPRB, &
  & 0.12892043E-08_JPRB, 0.12548254E-08_JPRB, 0.12019436E-08_JPRB, 0.13451822E-08_JPRB, 0.16966854E-08_JPRB, 0.20564386E-08_JPRB, &
  & 0.26976696E-08_JPRB, 0.36996942E-08_JPRB, 0.49114327E-08_JPRB, 0.58935580E-08_JPRB, 0.66477719E-08_JPRB, 0.70658029E-08_JPRB, &
  & 0.73008966E-08_JPRB, 0.75044297E-08_JPRB, 0.74927549E-08_JPRB, 0.73402531E-08_JPRB, 0.72660910E-08_JPRB, 0.76626718E-08_JPRB, &
  & 0.78385487E-08_JPRB, 0.88078143E-08_JPRB, 0.11055146E-07_JPRB, 0.14847994E-07_JPRB, 0.18688872E-07_JPRB, 0.20764030E-07_JPRB, &
  & 0.21794009E-07_JPRB, 0.23464810E-07_JPRB, 0.25397129E-07_JPRB, 0.27032147E-07_JPRB, 0.27988085E-07_JPRB, 0.28578583E-07_JPRB, &
  & 0.28531604E-07_JPRB, 0.28322849E-07_JPRB, 0.27725362E-07_JPRB, 0.26100373E-07_JPRB, 0.24262376E-07_JPRB, 0.22927269E-07_JPRB, &
  & 0.21364482E-07_JPRB, 0.20138152E-07_JPRB, 0.19156850E-07_JPRB, 0.18418212E-07_JPRB, 0.17662103E-07_JPRB, 0.17036774E-07_JPRB, &
  & 0.16929349E-07_JPRB, 0.17004421E-07_JPRB, 0.16945416E-07_JPRB, 0.16134307E-07_JPRB, 0.15712327E-07_JPRB, 0.15594036E-07_JPRB, &
  & 0.15270790E-07_JPRB, 0.14214390E-07_JPRB, 0.12912798E-07_JPRB, 0.12901760E-07_JPRB  /)

RGHG7(:,85, 2) = (/ &
  & 0.10066226E-07_JPRB, 0.96032849E-08_JPRB, 0.88927504E-08_JPRB, 0.83610950E-08_JPRB, 0.74433881E-08_JPRB, 0.64532744E-08_JPRB, &
  & 0.54844794E-08_JPRB, 0.39780014E-08_JPRB, 0.26400202E-08_JPRB, 0.16851455E-08_JPRB, 0.13581287E-08_JPRB, 0.12459992E-08_JPRB, &
  & 0.12771039E-08_JPRB, 0.12427250E-08_JPRB, 0.11906944E-08_JPRB, 0.13292518E-08_JPRB, 0.16637321E-08_JPRB, 0.20166761E-08_JPRB, &
  & 0.26493957E-08_JPRB, 0.36352486E-08_JPRB, 0.48427313E-08_JPRB, 0.58044293E-08_JPRB, 0.65322577E-08_JPRB, 0.69690139E-08_JPRB, &
  & 0.72024052E-08_JPRB, 0.74148753E-08_JPRB, 0.74087330E-08_JPRB, 0.72702750E-08_JPRB, 0.72152636E-08_JPRB, 0.76003541E-08_JPRB, &
  & 0.77515478E-08_JPRB, 0.86586799E-08_JPRB, 0.10908565E-07_JPRB, 0.14705668E-07_JPRB, 0.18523566E-07_JPRB, 0.20596596E-07_JPRB, &
  & 0.21575932E-07_JPRB, 0.23162470E-07_JPRB, 0.25030953E-07_JPRB, 0.26759172E-07_JPRB, 0.27749580E-07_JPRB, 0.28377529E-07_JPRB, &
  & 0.28347999E-07_JPRB, 0.28070301E-07_JPRB, 0.27473665E-07_JPRB, 0.25795480E-07_JPRB, 0.23946843E-07_JPRB, 0.22587905E-07_JPRB, &
  & 0.21017457E-07_JPRB, 0.19825173E-07_JPRB, 0.18850680E-07_JPRB, 0.18052036E-07_JPRB, 0.17281458E-07_JPRB, 0.16547183E-07_JPRB, &
  & 0.16322300E-07_JPRB, 0.16338642E-07_JPRB, 0.16214525E-07_JPRB, 0.15400011E-07_JPRB, 0.14938879E-07_JPRB, 0.14804416E-07_JPRB, &
  & 0.14450529E-07_JPRB, 0.13322207E-07_JPRB, 0.11863580E-07_JPRB, 0.11749979E-07_JPRB  /)

RGHG7(:,86, 2) = (/ &
  & 0.95131410E-08_JPRB, 0.90519182E-08_JPRB, 0.82829970E-08_JPRB, 0.78658483E-08_JPRB, 0.71089050E-08_JPRB, 0.62173693E-08_JPRB, &
  & 0.53451260E-08_JPRB, 0.39499600E-08_JPRB, 0.26235951E-08_JPRB, 0.16742870E-08_JPRB, 0.13463232E-08_JPRB, 0.12362408E-08_JPRB, &
  & 0.12666794E-08_JPRB, 0.12323005E-08_JPRB, 0.11834565E-08_JPRB, 0.13173089E-08_JPRB, 0.16360124E-08_JPRB, 0.19791157E-08_JPRB, &
  & 0.26049459E-08_JPRB, 0.35665529E-08_JPRB, 0.47684263E-08_JPRB, 0.57072624E-08_JPRB, 0.64185626E-08_JPRB, 0.68594857E-08_JPRB, &
  & 0.70951624E-08_JPRB, 0.73129515E-08_JPRB, 0.73183639E-08_JPRB, 0.71963519E-08_JPRB, 0.71492653E-08_JPRB, 0.75214752E-08_JPRB, &
  & 0.76528563E-08_JPRB, 0.85151911E-08_JPRB, 0.10752657E-07_JPRB, 0.14526063E-07_JPRB, 0.18310874E-07_JPRB, 0.20393421E-07_JPRB, &
  & 0.21367481E-07_JPRB, 0.22839358E-07_JPRB, 0.24609049E-07_JPRB, 0.26391309E-07_JPRB, 0.27399712E-07_JPRB, 0.28091276E-07_JPRB, &
  & 0.28079283E-07_JPRB, 0.27736290E-07_JPRB, 0.27155496E-07_JPRB, 0.25434834E-07_JPRB, 0.23568845E-07_JPRB, 0.22217258E-07_JPRB, &
  & 0.20669082E-07_JPRB, 0.19537325E-07_JPRB, 0.18557021E-07_JPRB, 0.17728040E-07_JPRB, 0.16952910E-07_JPRB, 0.16110803E-07_JPRB, &
  & 0.15758544E-07_JPRB, 0.15673900E-07_JPRB, 0.15475683E-07_JPRB, 0.14715360E-07_JPRB, 0.14234525E-07_JPRB, 0.14094466E-07_JPRB, &
  & 0.13671818E-07_JPRB, 0.12467881E-07_JPRB, 0.10839435E-07_JPRB, 0.10552819E-07_JPRB  /)

RGHG7(:,87, 2) = (/ &
  & 0.88256624E-08_JPRB, 0.84281680E-08_JPRB, 0.76337529E-08_JPRB, 0.73127899E-08_JPRB, 0.67518029E-08_JPRB, 0.59634355E-08_JPRB, &
  & 0.51783911E-08_JPRB, 0.39007742E-08_JPRB, 0.25999900E-08_JPRB, 0.16613929E-08_JPRB, 0.13349813E-08_JPRB, 0.12283832E-08_JPRB, &
  & 0.12579531E-08_JPRB, 0.12233524E-08_JPRB, 0.11768660E-08_JPRB, 0.13061616E-08_JPRB, 0.16096697E-08_JPRB, 0.19412475E-08_JPRB, &
  & 0.25590094E-08_JPRB, 0.34872525E-08_JPRB, 0.46812703E-08_JPRB, 0.55988746E-08_JPRB, 0.62962736E-08_JPRB, 0.67320968E-08_JPRB, &
  & 0.69730227E-08_JPRB, 0.71960428E-08_JPRB, 0.72175828E-08_JPRB, 0.71144994E-08_JPRB, 0.70662045E-08_JPRB, 0.74185172E-08_JPRB, &
  & 0.75376490E-08_JPRB, 0.83582531E-08_JPRB, 0.10576781E-07_JPRB, 0.14314937E-07_JPRB, 0.18053278E-07_JPRB, 0.20138658E-07_JPRB, &
  & 0.21115438E-07_JPRB, 0.22478613E-07_JPRB, 0.24129980E-07_JPRB, 0.25904018E-07_JPRB, 0.26908370E-07_JPRB, 0.27657190E-07_JPRB, &
  & 0.27663007E-07_JPRB, 0.27275475E-07_JPRB, 0.26701793E-07_JPRB, 0.24968218E-07_JPRB, 0.23099310E-07_JPRB, 0.21784409E-07_JPRB, &
  & 0.20284807E-07_JPRB, 0.19239416E-07_JPRB, 0.18250442E-07_JPRB, 0.17409506E-07_JPRB, 0.16651929E-07_JPRB, 0.15695241E-07_JPRB, &
  & 0.15227330E-07_JPRB, 0.14986093E-07_JPRB, 0.14708564E-07_JPRB, 0.14061384E-07_JPRB, 0.13592600E-07_JPRB, 0.13456586E-07_JPRB, &
  & 0.12952695E-07_JPRB, 0.11660133E-07_JPRB, 0.98570806E-08_JPRB, 0.93523706E-08_JPRB  /)

RGHG7(:,88, 2) = (/ &
  & 0.79806930E-08_JPRB, 0.77232809E-08_JPRB, 0.69293136E-08_JPRB, 0.66865288E-08_JPRB, 0.63656056E-08_JPRB, 0.56855938E-08_JPRB, &
  & 0.49897554E-08_JPRB, 0.38367354E-08_JPRB, 0.25703299E-08_JPRB, 0.16478646E-08_JPRB, 0.13247689E-08_JPRB, 0.12221347E-08_JPRB, &
  & 0.12509256E-08_JPRB, 0.12156080E-08_JPRB, 0.11695074E-08_JPRB, 0.12932049E-08_JPRB, 0.15828159E-08_JPRB, 0.19006058E-08_JPRB, &
  & 0.25077029E-08_JPRB, 0.33936252E-08_JPRB, 0.45709511E-08_JPRB, 0.54688600E-08_JPRB, 0.61519615E-08_JPRB, 0.65761408E-08_JPRB, &
  & 0.68286703E-08_JPRB, 0.70558328E-08_JPRB, 0.70957579E-08_JPRB, 0.70135348E-08_JPRB, 0.69545534E-08_JPRB, 0.72738020E-08_JPRB, &
  & 0.73957357E-08_JPRB, 0.81690688E-08_JPRB, 0.10354359E-07_JPRB, 0.14054572E-07_JPRB, 0.17735399E-07_JPRB, 0.19801183E-07_JPRB, &
  & 0.20776212E-07_JPRB, 0.22037041E-07_JPRB, 0.23543623E-07_JPRB, 0.25232776E-07_JPRB, 0.26202318E-07_JPRB, 0.26976528E-07_JPRB, &
  & 0.26993662E-07_JPRB, 0.26601421E-07_JPRB, 0.26013046E-07_JPRB, 0.24311464E-07_JPRB, 0.22465640E-07_JPRB, 0.21226595E-07_JPRB, &
  & 0.19815157E-07_JPRB, 0.18893976E-07_JPRB, 0.17892881E-07_JPRB, 0.17060414E-07_JPRB, 0.16354359E-07_JPRB, 0.15269213E-07_JPRB, &
  & 0.14693379E-07_JPRB, 0.14229132E-07_JPRB, 0.13869596E-07_JPRB, 0.13398424E-07_JPRB, 0.12989078E-07_JPRB, 0.12852454E-07_JPRB, &
  & 0.12282024E-07_JPRB, 0.10888739E-07_JPRB, 0.89266836E-08_JPRB, 0.82180524E-08_JPRB  /)

RGHG7(:,89, 2) = (/ &
  & 0.70426456E-08_JPRB, 0.69982711E-08_JPRB, 0.61927326E-08_JPRB, 0.59950571E-08_JPRB, 0.59540850E-08_JPRB, 0.53880107E-08_JPRB, &
  & 0.47959908E-08_JPRB, 0.37694723E-08_JPRB, 0.25370122E-08_JPRB, 0.16357663E-08_JPRB, 0.13164836E-08_JPRB, 0.12172906E-08_JPRB, &
  & 0.12455430E-08_JPRB, 0.12088574E-08_JPRB, 0.11616177E-08_JPRB, 0.12766120E-08_JPRB, 0.15561090E-08_JPRB, 0.18573599E-08_JPRB, &
  & 0.24505969E-08_JPRB, 0.32896240E-08_JPRB, 0.44301736E-08_JPRB, 0.53048187E-08_JPRB, 0.59717010E-08_JPRB, 0.63815575E-08_JPRB, &
  & 0.66519897E-08_JPRB, 0.68793332E-08_JPRB, 0.69393666E-08_JPRB, 0.68775765E-08_JPRB, 0.67992583E-08_JPRB, 0.70683802E-08_JPRB, &
  & 0.72201646E-08_JPRB, 0.79409970E-08_JPRB, 0.10059960E-07_JPRB, 0.13724245E-07_JPRB, 0.17347010E-07_JPRB, 0.19351940E-07_JPRB, &
  & 0.20330829E-07_JPRB, 0.21469876E-07_JPRB, 0.22783596E-07_JPRB, 0.24302368E-07_JPRB, 0.25187163E-07_JPRB, 0.25928515E-07_JPRB, &
  & 0.25934349E-07_JPRB, 0.25598039E-07_JPRB, 0.24964348E-07_JPRB, 0.23356802E-07_JPRB, 0.21572852E-07_JPRB, 0.20468324E-07_JPRB, &
  & 0.19216315E-07_JPRB, 0.18465752E-07_JPRB, 0.17440044E-07_JPRB, 0.16653137E-07_JPRB, 0.16039537E-07_JPRB, 0.14825428E-07_JPRB, &
  & 0.14120806E-07_JPRB, 0.13385049E-07_JPRB, 0.12944348E-07_JPRB, 0.12685735E-07_JPRB, 0.12410399E-07_JPRB, 0.12243580E-07_JPRB, &
  & 0.11630600E-07_JPRB, 0.10157387E-07_JPRB, 0.81196018E-08_JPRB, 0.73447734E-08_JPRB  /)

RGHG7(:,90, 2) = (/ &
  & 0.62560719E-08_JPRB, 0.64243301E-08_JPRB, 0.55371917E-08_JPRB, 0.53074323E-08_JPRB, 0.55447731E-08_JPRB, 0.50919401E-08_JPRB, &
  & 0.46166424E-08_JPRB, 0.37035765E-08_JPRB, 0.25038668E-08_JPRB, 0.16264455E-08_JPRB, 0.13111336E-08_JPRB, 0.12129417E-08_JPRB, &
  & 0.12401930E-08_JPRB, 0.12024895E-08_JPRB, 0.11527471E-08_JPRB, 0.12577809E-08_JPRB, 0.15293699E-08_JPRB, 0.18175394E-08_JPRB, &
  & 0.23890848E-08_JPRB, 0.31773718E-08_JPRB, 0.42649439E-08_JPRB, 0.50982549E-08_JPRB, 0.57349903E-08_JPRB, 0.61364383E-08_JPRB, &
  & 0.63860889E-08_JPRB, 0.66246761E-08_JPRB, 0.67336827E-08_JPRB, 0.66940582E-08_JPRB, 0.66005928E-08_JPRB, 0.68147324E-08_JPRB, &
  & 0.70194703E-08_JPRB, 0.77049655E-08_JPRB, 0.97427736E-08_JPRB, 0.13356880E-07_JPRB, 0.16911882E-07_JPRB, 0.18793627E-07_JPRB, &
  & 0.19808196E-07_JPRB, 0.20810144E-07_JPRB, 0.21868523E-07_JPRB, 0.23078618E-07_JPRB, 0.23767826E-07_JPRB, 0.24407517E-07_JPRB, &
  & 0.24368895E-07_JPRB, 0.24137585E-07_JPRB, 0.23413415E-07_JPRB, 0.21988936E-07_JPRB, 0.20362452E-07_JPRB, 0.19473425E-07_JPRB, &
  & 0.18497936E-07_JPRB, 0.17911693E-07_JPRB, 0.16849809E-07_JPRB, 0.16173174E-07_JPRB, 0.15676013E-07_JPRB, 0.14419751E-07_JPRB, &
  & 0.13527229E-07_JPRB, 0.12544882E-07_JPRB, 0.12011999E-07_JPRB, 0.11883846E-07_JPRB, 0.11884803E-07_JPRB, 0.11686923E-07_JPRB, &
  & 0.10870729E-07_JPRB, 0.94285965E-08_JPRB, 0.75610998E-08_JPRB, 0.69011117E-08_JPRB  /)

RGHG7(:,91, 2) = (/ &
  & 0.56263402E-08_JPRB, 0.60923653E-08_JPRB, 0.50730036E-08_JPRB, 0.46708250E-08_JPRB, 0.50959228E-08_JPRB, 0.47663219E-08_JPRB, &
  & 0.44629145E-08_JPRB, 0.36492805E-08_JPRB, 0.24754866E-08_JPRB, 0.16171054E-08_JPRB, 0.13049669E-08_JPRB, 0.12078328E-08_JPRB, &
  & 0.12340263E-08_JPRB, 0.11947361E-08_JPRB, 0.11423492E-08_JPRB, 0.12383918E-08_JPRB, 0.15046919E-08_JPRB, 0.17769946E-08_JPRB, &
  & 0.23205087E-08_JPRB, 0.30495597E-08_JPRB, 0.40683757E-08_JPRB, 0.48339883E-08_JPRB, 0.54506258E-08_JPRB, 0.58462560E-08_JPRB, &
  & 0.60356128E-08_JPRB, 0.62779022E-08_JPRB, 0.64514338E-08_JPRB, 0.64699875E-08_JPRB, 0.63717620E-08_JPRB, 0.65758527E-08_JPRB, &
  & 0.68181421E-08_JPRB, 0.74724326E-08_JPRB, 0.94986049E-08_JPRB, 0.13025444E-07_JPRB, 0.16487890E-07_JPRB, 0.18237940E-07_JPRB, &
  & 0.19324968E-07_JPRB, 0.20259747E-07_JPRB, 0.21137773E-07_JPRB, 0.21996154E-07_JPRB, 0.22375959E-07_JPRB, 0.22693555E-07_JPRB, &
  & 0.22504198E-07_JPRB, 0.22532574E-07_JPRB, 0.21944859E-07_JPRB, 0.20496579E-07_JPRB, 0.19015012E-07_JPRB, 0.18346534E-07_JPRB, &
  & 0.17669869E-07_JPRB, 0.17215850E-07_JPRB, 0.16172477E-07_JPRB, 0.15616958E-07_JPRB, 0.15221873E-07_JPRB, 0.13963497E-07_JPRB, &
  & 0.12820807E-07_JPRB, 0.11492036E-07_JPRB, 0.11087674E-07_JPRB, 0.11030922E-07_JPRB, 0.11353974E-07_JPRB, 0.11076760E-07_JPRB, &
  & 0.99395280E-08_JPRB, 0.82271313E-08_JPRB, 0.71974014E-08_JPRB, 0.66500674E-08_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ---GEMS----

RGHG7(:, 1, 3) = (/ &
  & 0.58291503E-05_JPRB, 0.66943961E-07_JPRB, 0.66229489E-07_JPRB, 0.66365025E-07_JPRB, 0.66659162E-07_JPRB, 0.67017332E-07_JPRB, &
  & 0.67224306E-07_JPRB, 0.67384839E-07_JPRB, 0.67550090E-07_JPRB, 0.67819848E-07_JPRB, 0.68067258E-07_JPRB, 0.68401079E-07_JPRB, &
  & 0.68688124E-07_JPRB, 0.69008777E-07_JPRB, 0.69259627E-07_JPRB, 0.69566624E-07_JPRB, 0.69739222E-07_JPRB, 0.69939809E-07_JPRB, &
  & 0.70071131E-07_JPRB, 0.70158094E-07_JPRB, 0.70124827E-07_JPRB, 0.69971371E-07_JPRB, 0.69706452E-07_JPRB, 0.69311426E-07_JPRB, &
  & 0.68851314E-07_JPRB, 0.68330884E-07_JPRB, 0.67863361E-07_JPRB, 0.67473792E-07_JPRB, 0.67219879E-07_JPRB, 0.67116240E-07_JPRB, &
  & 0.67192936E-07_JPRB, 0.67477757E-07_JPRB, 0.67815584E-07_JPRB, 0.68202013E-07_JPRB, 0.68738252E-07_JPRB, 0.69136753E-07_JPRB, &
  & 0.69537279E-07_JPRB, 0.69819656E-07_JPRB, 0.70004923E-07_JPRB, 0.70169918E-07_JPRB, 0.70190779E-07_JPRB, 0.70224274E-07_JPRB, &
  & 0.70106616E-07_JPRB, 0.69957380E-07_JPRB, 0.69683416E-07_JPRB, 0.69348715E-07_JPRB, 0.68986296E-07_JPRB, 0.68620778E-07_JPRB, &
  & 0.68325349E-07_JPRB, 0.68188072E-07_JPRB, 0.68235728E-07_JPRB, 0.68451676E-07_JPRB, 0.68819276E-07_JPRB, 0.69373790E-07_JPRB, &
  & 0.70256590E-07_JPRB, 0.71754165E-07_JPRB, 0.74068240E-07_JPRB, 0.76311736E-07_JPRB, 0.77670137E-07_JPRB, 0.78828990E-07_JPRB, &
  & 0.79533713E-07_JPRB, 0.79939895E-07_JPRB, 0.80265593E-07_JPRB, 0.84088072E-07_JPRB  /)

RGHG7(:, 2, 3) = (/ &
  & 0.59981389E-05_JPRB, 0.16366452E-06_JPRB, 0.15126028E-06_JPRB, 0.14674077E-06_JPRB, 0.14499328E-06_JPRB, 0.14814604E-06_JPRB, &
  & 0.15077491E-06_JPRB, 0.15529160E-06_JPRB, 0.16125978E-06_JPRB, 0.16734491E-06_JPRB, 0.17292442E-06_JPRB, 0.17775683E-06_JPRB, &
  & 0.18195983E-06_JPRB, 0.18537118E-06_JPRB, 0.18815966E-06_JPRB, 0.19038416E-06_JPRB, 0.19237993E-06_JPRB, 0.19408051E-06_JPRB, &
  & 0.19600296E-06_JPRB, 0.19799833E-06_JPRB, 0.20046215E-06_JPRB, 0.20349390E-06_JPRB, 0.20640898E-06_JPRB, 0.20893060E-06_JPRB, &
  & 0.21091631E-06_JPRB, 0.21249291E-06_JPRB, 0.21348033E-06_JPRB, 0.21421999E-06_JPRB, 0.21532209E-06_JPRB, 0.21609507E-06_JPRB, &
  & 0.21652447E-06_JPRB, 0.21904887E-06_JPRB, 0.21595530E-06_JPRB, 0.20981582E-06_JPRB, 0.20886421E-06_JPRB, 0.20868947E-06_JPRB, &
  & 0.20913699E-06_JPRB, 0.20955601E-06_JPRB, 0.21010945E-06_JPRB, 0.21166380E-06_JPRB, 0.21374737E-06_JPRB, 0.21697635E-06_JPRB, &
  & 0.22083164E-06_JPRB, 0.22578784E-06_JPRB, 0.23166155E-06_JPRB, 0.23873315E-06_JPRB, 0.24689768E-06_JPRB, 0.25652292E-06_JPRB, &
  & 0.26769993E-06_JPRB, 0.28010655E-06_JPRB, 0.29431021E-06_JPRB, 0.31240819E-06_JPRB, 0.33941720E-06_JPRB, 0.38494233E-06_JPRB, &
  & 0.46650871E-06_JPRB, 0.61125951E-06_JPRB, 0.83626855E-06_JPRB, 0.10641116E-05_JPRB, 0.12201290E-05_JPRB, 0.13588150E-05_JPRB, &
  & 0.14544154E-05_JPRB, 0.15355781E-05_JPRB, 0.16047114E-05_JPRB, 0.19897936E-05_JPRB  /)

RGHG7(:, 3, 3) = (/ &
  & 0.36137737E-05_JPRB, 0.18696790E-06_JPRB, 0.19526183E-06_JPRB, 0.22421250E-06_JPRB, 0.25472619E-06_JPRB, 0.28084841E-06_JPRB, &
  & 0.29121915E-06_JPRB, 0.29484812E-06_JPRB, 0.30245752E-06_JPRB, 0.31404082E-06_JPRB, 0.32596498E-06_JPRB, 0.33622885E-06_JPRB, &
  & 0.34575814E-06_JPRB, 0.35374106E-06_JPRB, 0.36075434E-06_JPRB, 0.36644576E-06_JPRB, 0.37183455E-06_JPRB, 0.37660811E-06_JPRB, &
  & 0.38175017E-06_JPRB, 0.38711130E-06_JPRB, 0.39271430E-06_JPRB, 0.39746658E-06_JPRB, 0.40217992E-06_JPRB, 0.40662954E-06_JPRB, &
  & 0.41063183E-06_JPRB, 0.41350168E-06_JPRB, 0.41516407E-06_JPRB, 0.41531678E-06_JPRB, 0.41657285E-06_JPRB, 0.41675293E-06_JPRB, &
  & 0.41749402E-06_JPRB, 0.41944375E-06_JPRB, 0.41479527E-06_JPRB, 0.40367513E-06_JPRB, 0.40323852E-06_JPRB, 0.40662289E-06_JPRB, &
  & 0.40924877E-06_JPRB, 0.41282226E-06_JPRB, 0.41550135E-06_JPRB, 0.41926199E-06_JPRB, 0.42365281E-06_JPRB, 0.43021106E-06_JPRB, &
  & 0.43809416E-06_JPRB, 0.44820419E-06_JPRB, 0.46004268E-06_JPRB, 0.47424911E-06_JPRB, 0.48985191E-06_JPRB, 0.50669996E-06_JPRB, &
  & 0.52535785E-06_JPRB, 0.54844571E-06_JPRB, 0.57880311E-06_JPRB, 0.61738484E-06_JPRB, 0.66674397E-06_JPRB, 0.73626910E-06_JPRB, &
  & 0.85000914E-06_JPRB, 0.10546839E-05_JPRB, 0.14021662E-05_JPRB, 0.17509357E-05_JPRB, 0.19062884E-05_JPRB, 0.20541399E-05_JPRB, &
  & 0.21267115E-05_JPRB, 0.22139584E-05_JPRB, 0.23455812E-05_JPRB, 0.39072024E-05_JPRB  /)

RGHG7(:, 4, 3) = (/ &
  & 0.26229621E-05_JPRB, 0.16309370E-05_JPRB, 0.15628792E-05_JPRB, 0.15003748E-05_JPRB, 0.14362825E-05_JPRB, 0.13753393E-05_JPRB, &
  & 0.13352157E-05_JPRB, 0.13053449E-05_JPRB, 0.12730775E-05_JPRB, 0.12460105E-05_JPRB, 0.12161513E-05_JPRB, 0.11791880E-05_JPRB, &
  & 0.11370668E-05_JPRB, 0.10985210E-05_JPRB, 0.10648124E-05_JPRB, 0.10445457E-05_JPRB, 0.10249853E-05_JPRB, 0.10015979E-05_JPRB, &
  & 0.98445173E-06_JPRB, 0.97640065E-06_JPRB, 0.96826537E-06_JPRB, 0.95801857E-06_JPRB, 0.95135855E-06_JPRB, 0.95257098E-06_JPRB, &
  & 0.95946599E-06_JPRB, 0.96687239E-06_JPRB, 0.98530078E-06_JPRB, 0.10109948E-05_JPRB, 0.10360816E-05_JPRB, 0.10638221E-05_JPRB, &
  & 0.10868621E-05_JPRB, 0.11111585E-05_JPRB, 0.11252746E-05_JPRB, 0.11166249E-05_JPRB, 0.11091312E-05_JPRB, 0.10997373E-05_JPRB, &
  & 0.10894819E-05_JPRB, 0.10730127E-05_JPRB, 0.10518099E-05_JPRB, 0.10346212E-05_JPRB, 0.10310371E-05_JPRB, 0.10384120E-05_JPRB, &
  & 0.10539166E-05_JPRB, 0.10789397E-05_JPRB, 0.11076738E-05_JPRB, 0.11462336E-05_JPRB, 0.11791571E-05_JPRB, 0.12123806E-05_JPRB, &
  & 0.12482387E-05_JPRB, 0.12810407E-05_JPRB, 0.13137183E-05_JPRB, 0.13339093E-05_JPRB, 0.13524237E-05_JPRB, 0.13698505E-05_JPRB, &
  & 0.14174933E-05_JPRB, 0.14880356E-05_JPRB, 0.16060587E-05_JPRB, 0.17517393E-05_JPRB, 0.18771285E-05_JPRB, 0.20186377E-05_JPRB, &
  & 0.21332315E-05_JPRB, 0.22869272E-05_JPRB, 0.23837055E-05_JPRB, 0.28831119E-05_JPRB  /)

RGHG7(:, 5, 3) = (/ &
  & 0.28536385E-05_JPRB, 0.27779301E-05_JPRB, 0.26789831E-05_JPRB, 0.25783154E-05_JPRB, 0.24789782E-05_JPRB, 0.23561534E-05_JPRB, &
  & 0.22568647E-05_JPRB, 0.21804298E-05_JPRB, 0.20996479E-05_JPRB, 0.20244749E-05_JPRB, 0.19422748E-05_JPRB, 0.18484400E-05_JPRB, &
  & 0.17455044E-05_JPRB, 0.16526398E-05_JPRB, 0.15680248E-05_JPRB, 0.15078628E-05_JPRB, 0.14513729E-05_JPRB, 0.13927029E-05_JPRB, &
  & 0.13440933E-05_JPRB, 0.13141426E-05_JPRB, 0.12868610E-05_JPRB, 0.12571291E-05_JPRB, 0.12339032E-05_JPRB, 0.12247010E-05_JPRB, &
  & 0.12266514E-05_JPRB, 0.12362468E-05_JPRB, 0.12643780E-05_JPRB, 0.13073427E-05_JPRB, 0.13539550E-05_JPRB, 0.14060364E-05_JPRB, &
  & 0.14523480E-05_JPRB, 0.14942376E-05_JPRB, 0.15259651E-05_JPRB, 0.15300834E-05_JPRB, 0.15173260E-05_JPRB, 0.14954791E-05_JPRB, &
  & 0.14699143E-05_JPRB, 0.14312433E-05_JPRB, 0.13911647E-05_JPRB, 0.13616707E-05_JPRB, 0.13586087E-05_JPRB, 0.13737478E-05_JPRB, &
  & 0.14029736E-05_JPRB, 0.14462541E-05_JPRB, 0.14952266E-05_JPRB, 0.15596045E-05_JPRB, 0.16126347E-05_JPRB, 0.16653080E-05_JPRB, &
  & 0.17220758E-05_JPRB, 0.17771246E-05_JPRB, 0.18402931E-05_JPRB, 0.18915481E-05_JPRB, 0.19464429E-05_JPRB, 0.20034744E-05_JPRB, &
  & 0.21076339E-05_JPRB, 0.22203739E-05_JPRB, 0.23655789E-05_JPRB, 0.25404924E-05_JPRB, 0.27106531E-05_JPRB, 0.28459556E-05_JPRB, &
  & 0.29992119E-05_JPRB, 0.31420264E-05_JPRB, 0.32097986E-05_JPRB, 0.32478888E-05_JPRB  /)

RGHG7(:, 6, 3) = (/ &
  & 0.28159757E-05_JPRB, 0.27834375E-05_JPRB, 0.27036752E-05_JPRB, 0.26097594E-05_JPRB, 0.25236966E-05_JPRB, 0.24080637E-05_JPRB, &
  & 0.23062119E-05_JPRB, 0.22251290E-05_JPRB, 0.21467572E-05_JPRB, 0.20710486E-05_JPRB, 0.19890206E-05_JPRB, 0.18975576E-05_JPRB, &
  & 0.17997864E-05_JPRB, 0.17132339E-05_JPRB, 0.16321191E-05_JPRB, 0.15698722E-05_JPRB, 0.15142813E-05_JPRB, 0.14621338E-05_JPRB, &
  & 0.14153794E-05_JPRB, 0.13861173E-05_JPRB, 0.13611884E-05_JPRB, 0.13351863E-05_JPRB, 0.13132420E-05_JPRB, 0.12997552E-05_JPRB, &
  & 0.12935383E-05_JPRB, 0.13010680E-05_JPRB, 0.13219882E-05_JPRB, 0.13579331E-05_JPRB, 0.14032448E-05_JPRB, 0.14552880E-05_JPRB, &
  & 0.15043730E-05_JPRB, 0.15395107E-05_JPRB, 0.15632047E-05_JPRB, 0.15669595E-05_JPRB, 0.15555220E-05_JPRB, 0.15361616E-05_JPRB, &
  & 0.15063888E-05_JPRB, 0.14658051E-05_JPRB, 0.14315986E-05_JPRB, 0.14136766E-05_JPRB, 0.14204842E-05_JPRB, 0.14431403E-05_JPRB, &
  & 0.14769758E-05_JPRB, 0.15202180E-05_JPRB, 0.15672014E-05_JPRB, 0.16255924E-05_JPRB, 0.16729992E-05_JPRB, 0.17197813E-05_JPRB, &
  & 0.17707726E-05_JPRB, 0.18239852E-05_JPRB, 0.18853940E-05_JPRB, 0.19369359E-05_JPRB, 0.19902814E-05_JPRB, 0.20505454E-05_JPRB, &
  & 0.21544180E-05_JPRB, 0.22757844E-05_JPRB, 0.24478632E-05_JPRB, 0.26494784E-05_JPRB, 0.28407938E-05_JPRB, 0.30169522E-05_JPRB, &
  & 0.31758129E-05_JPRB, 0.33041671E-05_JPRB, 0.33717097E-05_JPRB, 0.34159399E-05_JPRB  /)

RGHG7(:, 7, 3) = (/ &
  & 0.28437607E-05_JPRB, 0.28319880E-05_JPRB, 0.27756372E-05_JPRB, 0.26973026E-05_JPRB, 0.26243646E-05_JPRB, 0.25164331E-05_JPRB, &
  & 0.24162820E-05_JPRB, 0.23327777E-05_JPRB, 0.22533812E-05_JPRB, 0.21783805E-05_JPRB, 0.21021389E-05_JPRB, 0.20218449E-05_JPRB, &
  & 0.19364562E-05_JPRB, 0.18629548E-05_JPRB, 0.17936970E-05_JPRB, 0.17405310E-05_JPRB, 0.16920105E-05_JPRB, 0.16507843E-05_JPRB, &
  & 0.16123306E-05_JPRB, 0.15863111E-05_JPRB, 0.15639938E-05_JPRB, 0.15385556E-05_JPRB, 0.15150081E-05_JPRB, 0.14958574E-05_JPRB, &
  & 0.14821465E-05_JPRB, 0.14812794E-05_JPRB, 0.14908728E-05_JPRB, 0.15193813E-05_JPRB, 0.15621033E-05_JPRB, 0.16156904E-05_JPRB, &
  & 0.16623197E-05_JPRB, 0.16908020E-05_JPRB, 0.17060830E-05_JPRB, 0.17098287E-05_JPRB, 0.16982556E-05_JPRB, 0.16769215E-05_JPRB, &
  & 0.16439401E-05_JPRB, 0.16034712E-05_JPRB, 0.15770798E-05_JPRB, 0.15734537E-05_JPRB, 0.15942661E-05_JPRB, 0.16260676E-05_JPRB, &
  & 0.16643922E-05_JPRB, 0.17092220E-05_JPRB, 0.17536902E-05_JPRB, 0.18029836E-05_JPRB, 0.18386614E-05_JPRB, 0.18736101E-05_JPRB, &
  & 0.19133522E-05_JPRB, 0.19579177E-05_JPRB, 0.20136804E-05_JPRB, 0.20640855E-05_JPRB, 0.21218106E-05_JPRB, 0.21897679E-05_JPRB, &
  & 0.23060817E-05_JPRB, 0.24528821E-05_JPRB, 0.26631515E-05_JPRB, 0.28960797E-05_JPRB, 0.31170289E-05_JPRB, 0.33185266E-05_JPRB, &
  & 0.34781146E-05_JPRB, 0.35924733E-05_JPRB, 0.36590878E-05_JPRB, 0.37055416E-05_JPRB  /)

RGHG7(:, 8, 3) = (/ &
  & 0.29181388E-05_JPRB, 0.29314079E-05_JPRB, 0.29066356E-05_JPRB, 0.28569575E-05_JPRB, 0.28038492E-05_JPRB, 0.27112240E-05_JPRB, &
  & 0.26176493E-05_JPRB, 0.25337436E-05_JPRB, 0.24550046E-05_JPRB, 0.23881735E-05_JPRB, 0.23270323E-05_JPRB, 0.22690586E-05_JPRB, &
  & 0.22070427E-05_JPRB, 0.21563478E-05_JPRB, 0.21082733E-05_JPRB, 0.20746068E-05_JPRB, 0.20418627E-05_JPRB, 0.20180761E-05_JPRB, &
  & 0.19946183E-05_JPRB, 0.19770319E-05_JPRB, 0.19607149E-05_JPRB, 0.19384289E-05_JPRB, 0.19145012E-05_JPRB, 0.18907939E-05_JPRB, &
  & 0.18695108E-05_JPRB, 0.18569370E-05_JPRB, 0.18518571E-05_JPRB, 0.18646513E-05_JPRB, 0.18916562E-05_JPRB, 0.19327335E-05_JPRB, &
  & 0.19676455E-05_JPRB, 0.19872475E-05_JPRB, 0.19933204E-05_JPRB, 0.19953255E-05_JPRB, 0.19865057E-05_JPRB, 0.19701112E-05_JPRB, &
  & 0.19473544E-05_JPRB, 0.19227381E-05_JPRB, 0.19195502E-05_JPRB, 0.19387192E-05_JPRB, 0.19762746E-05_JPRB, 0.20170908E-05_JPRB, &
  & 0.20555627E-05_JPRB, 0.20961590E-05_JPRB, 0.21262926E-05_JPRB, 0.21568283E-05_JPRB, 0.21700862E-05_JPRB, 0.21774490E-05_JPRB, &
  & 0.21927851E-05_JPRB, 0.22188167E-05_JPRB, 0.22629512E-05_JPRB, 0.23119233E-05_JPRB, 0.23792273E-05_JPRB, 0.24666806E-05_JPRB, &
  & 0.26078088E-05_JPRB, 0.27934973E-05_JPRB, 0.30447139E-05_JPRB, 0.33059256E-05_JPRB, 0.35510219E-05_JPRB, 0.37672428E-05_JPRB, &
  & 0.39198533E-05_JPRB, 0.40070223E-05_JPRB, 0.40565363E-05_JPRB, 0.40886457E-05_JPRB  /)

RGHG7(:, 9, 3) = (/ &
  & 0.30999064E-05_JPRB, 0.31377352E-05_JPRB, 0.31516407E-05_JPRB, 0.31480840E-05_JPRB, 0.31336703E-05_JPRB, 0.30708295E-05_JPRB, &
  & 0.29947331E-05_JPRB, 0.29189201E-05_JPRB, 0.28487966E-05_JPRB, 0.28018997E-05_JPRB, 0.27665025E-05_JPRB, 0.27406475E-05_JPRB, &
  & 0.27114145E-05_JPRB, 0.26911241E-05_JPRB, 0.26682067E-05_JPRB, 0.26588825E-05_JPRB, 0.26467831E-05_JPRB, 0.26428818E-05_JPRB, &
  & 0.26357135E-05_JPRB, 0.26294694E-05_JPRB, 0.26229600E-05_JPRB, 0.26099246E-05_JPRB, 0.25919509E-05_JPRB, 0.25700336E-05_JPRB, &
  & 0.25449369E-05_JPRB, 0.25184483E-05_JPRB, 0.24949565E-05_JPRB, 0.24785581E-05_JPRB, 0.24690357E-05_JPRB, 0.24725687E-05_JPRB, &
  & 0.24784779E-05_JPRB, 0.24829031E-05_JPRB, 0.24808943E-05_JPRB, 0.24816885E-05_JPRB, 0.24854108E-05_JPRB, 0.24927937E-05_JPRB, &
  & 0.25055452E-05_JPRB, 0.25238043E-05_JPRB, 0.25632739E-05_JPRB, 0.26149824E-05_JPRB, 0.26704544E-05_JPRB, 0.27201695E-05_JPRB, &
  & 0.27521751E-05_JPRB, 0.27767781E-05_JPRB, 0.27775771E-05_JPRB, 0.27736680E-05_JPRB, 0.27485023E-05_JPRB, 0.27109779E-05_JPRB, &
  & 0.26883447E-05_JPRB, 0.26863852E-05_JPRB, 0.27184766E-05_JPRB, 0.27731685E-05_JPRB, 0.28670206E-05_JPRB, 0.29938153E-05_JPRB, &
  & 0.31732105E-05_JPRB, 0.34001097E-05_JPRB, 0.36774372E-05_JPRB, 0.39454702E-05_JPRB, 0.41863133E-05_JPRB, 0.43845981E-05_JPRB, &
  & 0.45040772E-05_JPRB, 0.45481644E-05_JPRB, 0.45587782E-05_JPRB, 0.45590496E-05_JPRB  /)

RGHG7(:,10, 3) = (/ &
  & 0.34524773E-05_JPRB, 0.35051056E-05_JPRB, 0.35759004E-05_JPRB, 0.36543974E-05_JPRB, 0.37267119E-05_JPRB, 0.37354767E-05_JPRB, &
  & 0.37117024E-05_JPRB, 0.36683837E-05_JPRB, 0.36164702E-05_JPRB, 0.35864009E-05_JPRB, 0.35689691E-05_JPRB, 0.35636199E-05_JPRB, &
  & 0.35559426E-05_JPRB, 0.35560094E-05_JPRB, 0.35453451E-05_JPRB, 0.35465309E-05_JPRB, 0.35400720E-05_JPRB, 0.35424252E-05_JPRB, &
  & 0.35387982E-05_JPRB, 0.35344430E-05_JPRB, 0.35332608E-05_JPRB, 0.35296922E-05_JPRB, 0.35220650E-05_JPRB, 0.35065934E-05_JPRB, &
  & 0.34794743E-05_JPRB, 0.34355060E-05_JPRB, 0.33881584E-05_JPRB, 0.33326922E-05_JPRB, 0.32753937E-05_JPRB, 0.32272800E-05_JPRB, &
  & 0.31926041E-05_JPRB, 0.31750563E-05_JPRB, 0.31707335E-05_JPRB, 0.31794538E-05_JPRB, 0.32089721E-05_JPRB, 0.32589505E-05_JPRB, &
  & 0.33243500E-05_JPRB, 0.34000766E-05_JPRB, 0.34865097E-05_JPRB, 0.35727939E-05_JPRB, 0.36463157E-05_JPRB, 0.37046496E-05_JPRB, &
  & 0.37310829E-05_JPRB, 0.37380216E-05_JPRB, 0.37122883E-05_JPRB, 0.36713530E-05_JPRB, 0.36086940E-05_JPRB, 0.35351012E-05_JPRB, &
  & 0.34893072E-05_JPRB, 0.34758383E-05_JPRB, 0.35243168E-05_JPRB, 0.36167241E-05_JPRB, 0.37705399E-05_JPRB, 0.39578816E-05_JPRB, &
  & 0.41791756E-05_JPRB, 0.44202315E-05_JPRB, 0.46741928E-05_JPRB, 0.48912555E-05_JPRB, 0.50557348E-05_JPRB, 0.51592084E-05_JPRB, &
  & 0.51879042E-05_JPRB, 0.51662160E-05_JPRB, 0.51277243E-05_JPRB, 0.50945392E-05_JPRB  /)

RGHG7(:,11, 3) = (/ &
  & 0.38610524E-05_JPRB, 0.39292559E-05_JPRB, 0.40715280E-05_JPRB, 0.42613431E-05_JPRB, 0.44596538E-05_JPRB, 0.46023549E-05_JPRB, &
  & 0.46972609E-05_JPRB, 0.47442405E-05_JPRB, 0.47460082E-05_JPRB, 0.47313910E-05_JPRB, 0.47141217E-05_JPRB, 0.47049701E-05_JPRB, &
  & 0.46974315E-05_JPRB, 0.47024174E-05_JPRB, 0.46945050E-05_JPRB, 0.46890549E-05_JPRB, 0.46642432E-05_JPRB, 0.46500987E-05_JPRB, &
  & 0.46352597E-05_JPRB, 0.46179996E-05_JPRB, 0.46073216E-05_JPRB, 0.45995822E-05_JPRB, 0.45892446E-05_JPRB, 0.45689573E-05_JPRB, &
  & 0.45292368E-05_JPRB, 0.44635037E-05_JPRB, 0.43892263E-05_JPRB, 0.42996919E-05_JPRB, 0.42088830E-05_JPRB, 0.41291644E-05_JPRB, &
  & 0.40719112E-05_JPRB, 0.40401012E-05_JPRB, 0.40416773E-05_JPRB, 0.40695997E-05_JPRB, 0.41259374E-05_JPRB, 0.42080637E-05_JPRB, &
  & 0.43066727E-05_JPRB, 0.44124204E-05_JPRB, 0.45231079E-05_JPRB, 0.46282236E-05_JPRB, 0.47136895E-05_JPRB, 0.47772571E-05_JPRB, &
  & 0.48103847E-05_JPRB, 0.48241455E-05_JPRB, 0.48051808E-05_JPRB, 0.47685125E-05_JPRB, 0.47216854E-05_JPRB, 0.46752363E-05_JPRB, &
  & 0.46787125E-05_JPRB, 0.47245449E-05_JPRB, 0.48461812E-05_JPRB, 0.50137832E-05_JPRB, 0.52214603E-05_JPRB, 0.54361500E-05_JPRB, &
  & 0.56430130E-05_JPRB, 0.58238205E-05_JPRB, 0.59684204E-05_JPRB, 0.60495500E-05_JPRB, 0.60554186E-05_JPRB, 0.60039684E-05_JPRB, &
  & 0.59125541E-05_JPRB, 0.58103016E-05_JPRB, 0.57344047E-05_JPRB, 0.56863062E-05_JPRB  /)

RGHG7(:,12, 3) = (/ &
  & 0.41721844E-05_JPRB, 0.42481838E-05_JPRB, 0.44151611E-05_JPRB, 0.46571116E-05_JPRB, 0.49267632E-05_JPRB, 0.51761103E-05_JPRB, &
  & 0.53970108E-05_JPRB, 0.55805573E-05_JPRB, 0.57137188E-05_JPRB, 0.57859635E-05_JPRB, 0.58171716E-05_JPRB, 0.58335722E-05_JPRB, &
  & 0.58500634E-05_JPRB, 0.58791619E-05_JPRB, 0.58954342E-05_JPRB, 0.58995654E-05_JPRB, 0.58783050E-05_JPRB, 0.58596640E-05_JPRB, &
  & 0.58420773E-05_JPRB, 0.58193680E-05_JPRB, 0.57996866E-05_JPRB, 0.57835837E-05_JPRB, 0.57594907E-05_JPRB, 0.57262554E-05_JPRB, &
  & 0.56735538E-05_JPRB, 0.55953568E-05_JPRB, 0.55067603E-05_JPRB, 0.54058816E-05_JPRB, 0.53116957E-05_JPRB, 0.52354106E-05_JPRB, &
  & 0.51845908E-05_JPRB, 0.51581826E-05_JPRB, 0.51669552E-05_JPRB, 0.52083036E-05_JPRB, 0.52760753E-05_JPRB, 0.53557929E-05_JPRB, &
  & 0.54413973E-05_JPRB, 0.55259645E-05_JPRB, 0.56165543E-05_JPRB, 0.57038369E-05_JPRB, 0.57770289E-05_JPRB, 0.58372139E-05_JPRB, &
  & 0.58767486E-05_JPRB, 0.59104026E-05_JPRB, 0.59340175E-05_JPRB, 0.59614716E-05_JPRB, 0.60067146E-05_JPRB, 0.60784481E-05_JPRB, &
  & 0.62046494E-05_JPRB, 0.63527434E-05_JPRB, 0.65308344E-05_JPRB, 0.67105487E-05_JPRB, 0.68636014E-05_JPRB, 0.69788824E-05_JPRB, &
  & 0.70486731E-05_JPRB, 0.70769490E-05_JPRB, 0.70536657E-05_JPRB, 0.69704482E-05_JPRB, 0.68384324E-05_JPRB, 0.66887657E-05_JPRB, &
  & 0.65389409E-05_JPRB, 0.64006447E-05_JPRB, 0.63075466E-05_JPRB, 0.62642780E-05_JPRB  /)

RGHG7(:,13, 3) = (/ &
  & 0.43815683E-05_JPRB, 0.44642301E-05_JPRB, 0.46295772E-05_JPRB, 0.48695087E-05_JPRB, 0.51420854E-05_JPRB, 0.54187738E-05_JPRB, &
  & 0.56943624E-05_JPRB, 0.59643384E-05_JPRB, 0.62191910E-05_JPRB, 0.64217162E-05_JPRB, 0.65688026E-05_JPRB, 0.66651832E-05_JPRB, &
  & 0.67388333E-05_JPRB, 0.68091314E-05_JPRB, 0.68673927E-05_JPRB, 0.69129559E-05_JPRB, 0.69454136E-05_JPRB, 0.69683601E-05_JPRB, &
  & 0.69783270E-05_JPRB, 0.69753301E-05_JPRB, 0.69659979E-05_JPRB, 0.69496989E-05_JPRB, 0.69210352E-05_JPRB, 0.68867851E-05_JPRB, &
  & 0.68438527E-05_JPRB, 0.67904366E-05_JPRB, 0.67337806E-05_JPRB, 0.66764308E-05_JPRB, 0.66297978E-05_JPRB, 0.65963189E-05_JPRB, &
  & 0.65767494E-05_JPRB, 0.65655426E-05_JPRB, 0.65639725E-05_JPRB, 0.65794818E-05_JPRB, 0.66099085E-05_JPRB, 0.66347512E-05_JPRB, &
  & 0.66527127E-05_JPRB, 0.66615323E-05_JPRB, 0.66758699E-05_JPRB, 0.66947123E-05_JPRB, 0.67123748E-05_JPRB, 0.67370928E-05_JPRB, &
  & 0.67653597E-05_JPRB, 0.68136715E-05_JPRB, 0.68934024E-05_JPRB, 0.70170912E-05_JPRB, 0.71954102E-05_JPRB, 0.74073477E-05_JPRB, &
  & 0.76186400E-05_JPRB, 0.77789568E-05_JPRB, 0.78880847E-05_JPRB, 0.79556856E-05_JPRB, 0.79630522E-05_JPRB, 0.79184567E-05_JPRB, &
  & 0.78255373E-05_JPRB, 0.77008768E-05_JPRB, 0.75391939E-05_JPRB, 0.73437976E-05_JPRB, 0.71386932E-05_JPRB, 0.69513085E-05_JPRB, &
  & 0.67884229E-05_JPRB, 0.66471966E-05_JPRB, 0.65490471E-05_JPRB, 0.64965742E-05_JPRB  /)

RGHG7(:,14, 3) = (/ &
  & 0.44807892E-05_JPRB, 0.45616337E-05_JPRB, 0.47119308E-05_JPRB, 0.49177451E-05_JPRB, 0.51656886E-05_JPRB, 0.54344162E-05_JPRB, &
  & 0.57143821E-05_JPRB, 0.60046984E-05_JPRB, 0.63140331E-05_JPRB, 0.66178563E-05_JPRB, 0.68882490E-05_JPRB, 0.70977106E-05_JPRB, &
  & 0.72548124E-05_JPRB, 0.73769254E-05_JPRB, 0.74826793E-05_JPRB, 0.75844684E-05_JPRB, 0.76862585E-05_JPRB, 0.77778559E-05_JPRB, &
  & 0.78424284E-05_JPRB, 0.78826707E-05_JPRB, 0.79030362E-05_JPRB, 0.79065724E-05_JPRB, 0.79004372E-05_JPRB, 0.78971825E-05_JPRB, &
  & 0.79009662E-05_JPRB, 0.79198772E-05_JPRB, 0.79514392E-05_JPRB, 0.79918089E-05_JPRB, 0.80326977E-05_JPRB, 0.80654060E-05_JPRB, &
  & 0.80834501E-05_JPRB, 0.80805169E-05_JPRB, 0.80440747E-05_JPRB, 0.79846855E-05_JPRB, 0.79209225E-05_JPRB, 0.78472005E-05_JPRB, &
  & 0.77680091E-05_JPRB, 0.76747689E-05_JPRB, 0.75810106E-05_JPRB, 0.74996812E-05_JPRB, 0.74365735E-05_JPRB, 0.74034036E-05_JPRB, &
  & 0.74024887E-05_JPRB, 0.74544418E-05_JPRB, 0.75743246E-05_JPRB, 0.77656000E-05_JPRB, 0.80185813E-05_JPRB, 0.82522435E-05_JPRB, &
  & 0.84114315E-05_JPRB, 0.84720389E-05_JPRB, 0.84561840E-05_JPRB, 0.83889877E-05_JPRB, 0.82652675E-05_JPRB, 0.80977902E-05_JPRB, &
  & 0.78975472E-05_JPRB, 0.76749699E-05_JPRB, 0.74355952E-05_JPRB, 0.71918658E-05_JPRB, 0.69591121E-05_JPRB, 0.67628888E-05_JPRB, &
  & 0.66129037E-05_JPRB, 0.64901433E-05_JPRB, 0.64062798E-05_JPRB, 0.63498004E-05_JPRB  /)

RGHG7(:,15, 3) = (/ &
  & 0.45045904E-05_JPRB, 0.45513243E-05_JPRB, 0.46527252E-05_JPRB, 0.48072513E-05_JPRB, 0.50204774E-05_JPRB, 0.52761344E-05_JPRB, &
  & 0.55481836E-05_JPRB, 0.58269508E-05_JPRB, 0.61392289E-05_JPRB, 0.64802190E-05_JPRB, 0.68276722E-05_JPRB, 0.71485039E-05_JPRB, &
  & 0.74104110E-05_JPRB, 0.75944294E-05_JPRB, 0.77505688E-05_JPRB, 0.79039861E-05_JPRB, 0.80653138E-05_JPRB, 0.82217198E-05_JPRB, &
  & 0.83494157E-05_JPRB, 0.84448777E-05_JPRB, 0.85127677E-05_JPRB, 0.85640972E-05_JPRB, 0.86046462E-05_JPRB, 0.86546384E-05_JPRB, &
  & 0.87281667E-05_JPRB, 0.88312224E-05_JPRB, 0.89523070E-05_JPRB, 0.90714728E-05_JPRB, 0.91631720E-05_JPRB, 0.92269328E-05_JPRB, &
  & 0.92641874E-05_JPRB, 0.92559297E-05_JPRB, 0.91798886E-05_JPRB, 0.90589216E-05_JPRB, 0.89266114E-05_JPRB, 0.87863541E-05_JPRB, &
  & 0.86348138E-05_JPRB, 0.84688526E-05_JPRB, 0.82968688E-05_JPRB, 0.81409421E-05_JPRB, 0.80178835E-05_JPRB, 0.79383223E-05_JPRB, &
  & 0.79058346E-05_JPRB, 0.79450589E-05_JPRB, 0.80629092E-05_JPRB, 0.82463986E-05_JPRB, 0.84509258E-05_JPRB, 0.85725484E-05_JPRB, &
  & 0.85940761E-05_JPRB, 0.85233898E-05_JPRB, 0.83916062E-05_JPRB, 0.82145517E-05_JPRB, 0.79974425E-05_JPRB, 0.77541445E-05_JPRB, &
  & 0.74996810E-05_JPRB, 0.72362799E-05_JPRB, 0.69763418E-05_JPRB, 0.67389254E-05_JPRB, 0.65222835E-05_JPRB, 0.63382078E-05_JPRB, &
  & 0.62056848E-05_JPRB, 0.61014566E-05_JPRB, 0.60275876E-05_JPRB, 0.59851540E-05_JPRB  /)

RGHG7(:,16, 3) = (/ &
  & 0.44451992E-05_JPRB, 0.44588320E-05_JPRB, 0.44851803E-05_JPRB, 0.45714295E-05_JPRB, 0.47368791E-05_JPRB, 0.49733162E-05_JPRB, &
  & 0.52390882E-05_JPRB, 0.55062535E-05_JPRB, 0.58005026E-05_JPRB, 0.61319856E-05_JPRB, 0.64924354E-05_JPRB, 0.68788606E-05_JPRB, &
  & 0.72536119E-05_JPRB, 0.75227329E-05_JPRB, 0.77297204E-05_JPRB, 0.79291721E-05_JPRB, 0.81348500E-05_JPRB, 0.83405547E-05_JPRB, &
  & 0.85301807E-05_JPRB, 0.86879913E-05_JPRB, 0.88261694E-05_JPRB, 0.89538980E-05_JPRB, 0.90570058E-05_JPRB, 0.91604318E-05_JPRB, &
  & 0.92864519E-05_JPRB, 0.94337220E-05_JPRB, 0.95819911E-05_JPRB, 0.97107481E-05_JPRB, 0.97953148E-05_JPRB, 0.98380674E-05_JPRB, &
  & 0.98589614E-05_JPRB, 0.98380905E-05_JPRB, 0.97379109E-05_JPRB, 0.95935071E-05_JPRB, 0.94545419E-05_JPRB, 0.93089184E-05_JPRB, &
  & 0.91433236E-05_JPRB, 0.89687225E-05_JPRB, 0.87893497E-05_JPRB, 0.86224770E-05_JPRB, 0.84853448E-05_JPRB, 0.83875334E-05_JPRB, &
  & 0.83356227E-05_JPRB, 0.83352668E-05_JPRB, 0.83928456E-05_JPRB, 0.84866306E-05_JPRB, 0.85332874E-05_JPRB, 0.84754146E-05_JPRB, &
  & 0.83364748E-05_JPRB, 0.81496756E-05_JPRB, 0.79268524E-05_JPRB, 0.76806231E-05_JPRB, 0.74168895E-05_JPRB, 0.71485963E-05_JPRB, &
  & 0.68816266E-05_JPRB, 0.66225037E-05_JPRB, 0.63851167E-05_JPRB, 0.61776287E-05_JPRB, 0.60030719E-05_JPRB, 0.58534343E-05_JPRB, &
  & 0.57347235E-05_JPRB, 0.56456530E-05_JPRB, 0.55878416E-05_JPRB, 0.55510341E-05_JPRB  /)

RGHG7(:,17, 3) = (/ &
  & 0.43308183E-05_JPRB, 0.43304282E-05_JPRB, 0.43157746E-05_JPRB, 0.43550987E-05_JPRB, 0.44572473E-05_JPRB, 0.46485868E-05_JPRB, &
  & 0.48960590E-05_JPRB, 0.51566724E-05_JPRB, 0.54409859E-05_JPRB, 0.57512231E-05_JPRB, 0.60828395E-05_JPRB, 0.64641828E-05_JPRB, &
  & 0.68827213E-05_JPRB, 0.72372915E-05_JPRB, 0.75073499E-05_JPRB, 0.77505246E-05_JPRB, 0.79944233E-05_JPRB, 0.82308778E-05_JPRB, &
  & 0.84764658E-05_JPRB, 0.86957481E-05_JPRB, 0.89023143E-05_JPRB, 0.91026478E-05_JPRB, 0.92679224E-05_JPRB, 0.94121201E-05_JPRB, &
  & 0.95545884E-05_JPRB, 0.96947231E-05_JPRB, 0.98182040E-05_JPRB, 0.99137269E-05_JPRB, 0.99742912E-05_JPRB, 0.99963912E-05_JPRB, &
  & 0.99993288E-05_JPRB, 0.99729731E-05_JPRB, 0.98698875E-05_JPRB, 0.97130908E-05_JPRB, 0.95754424E-05_JPRB, 0.94478146E-05_JPRB, &
  & 0.93008630E-05_JPRB, 0.91469870E-05_JPRB, 0.89980842E-05_JPRB, 0.88615809E-05_JPRB, 0.87449539E-05_JPRB, 0.86473821E-05_JPRB, &
  & 0.85672332E-05_JPRB, 0.84907266E-05_JPRB, 0.84481237E-05_JPRB, 0.83993806E-05_JPRB, 0.82609727E-05_JPRB, 0.80518121E-05_JPRB, &
  & 0.78089018E-05_JPRB, 0.75571253E-05_JPRB, 0.72999062E-05_JPRB, 0.70450089E-05_JPRB, 0.67941235E-05_JPRB, 0.65530989E-05_JPRB, &
  & 0.63157839E-05_JPRB, 0.60913749E-05_JPRB, 0.58935959E-05_JPRB, 0.57204799E-05_JPRB, 0.55820477E-05_JPRB, 0.54680459E-05_JPRB, &
  & 0.53686035E-05_JPRB, 0.52952310E-05_JPRB, 0.52525535E-05_JPRB, 0.52234640E-05_JPRB  /)

RGHG7(:,18, 3) = (/ &
  & 0.42207393E-05_JPRB, 0.42020270E-05_JPRB, 0.41859820E-05_JPRB, 0.42097478E-05_JPRB, 0.42665523E-05_JPRB, 0.43950254E-05_JPRB, &
  & 0.46015382E-05_JPRB, 0.48440767E-05_JPRB, 0.51236546E-05_JPRB, 0.54292811E-05_JPRB, 0.57371795E-05_JPRB, 0.60844078E-05_JPRB, &
  & 0.64848442E-05_JPRB, 0.68761607E-05_JPRB, 0.71993468E-05_JPRB, 0.74761913E-05_JPRB, 0.77446575E-05_JPRB, 0.80001411E-05_JPRB, &
  & 0.82746950E-05_JPRB, 0.85495806E-05_JPRB, 0.88215141E-05_JPRB, 0.90785800E-05_JPRB, 0.92875731E-05_JPRB, 0.94574445E-05_JPRB, &
  & 0.96010692E-05_JPRB, 0.97258623E-05_JPRB, 0.98290758E-05_JPRB, 0.98990194E-05_JPRB, 0.99430521E-05_JPRB, 0.99571694E-05_JPRB, &
  & 0.99493809E-05_JPRB, 0.99141496E-05_JPRB, 0.98083011E-05_JPRB, 0.96507845E-05_JPRB, 0.95208291E-05_JPRB, 0.94147008E-05_JPRB, &
  & 0.92826877E-05_JPRB, 0.91452747E-05_JPRB, 0.90157804E-05_JPRB, 0.88930611E-05_JPRB, 0.87778233E-05_JPRB, 0.86613033E-05_JPRB, &
  & 0.85259091E-05_JPRB, 0.83625083E-05_JPRB, 0.82160534E-05_JPRB, 0.80300398E-05_JPRB, 0.77839117E-05_JPRB, 0.75107993E-05_JPRB, &
  & 0.72380213E-05_JPRB, 0.69826273E-05_JPRB, 0.67471319E-05_JPRB, 0.65271259E-05_JPRB, 0.63160017E-05_JPRB, 0.61156019E-05_JPRB, &
  & 0.59218339E-05_JPRB, 0.57385391E-05_JPRB, 0.55713562E-05_JPRB, 0.54243622E-05_JPRB, 0.53104122E-05_JPRB, 0.52199301E-05_JPRB, &
  & 0.51425649E-05_JPRB, 0.50836920E-05_JPRB, 0.50482317E-05_JPRB, 0.50264632E-05_JPRB  /)

RGHG7(:,19, 3) = (/ &
  & 0.41057884E-05_JPRB, 0.40879894E-05_JPRB, 0.40899132E-05_JPRB, 0.41185449E-05_JPRB, 0.41547528E-05_JPRB, 0.42314776E-05_JPRB, &
  & 0.43835241E-05_JPRB, 0.45934096E-05_JPRB, 0.48457971E-05_JPRB, 0.51331021E-05_JPRB, 0.54289539E-05_JPRB, 0.57439409E-05_JPRB, &
  & 0.61065723E-05_JPRB, 0.64829388E-05_JPRB, 0.68323480E-05_JPRB, 0.71351638E-05_JPRB, 0.74209418E-05_JPRB, 0.76838341E-05_JPRB, &
  & 0.79511934E-05_JPRB, 0.82427239E-05_JPRB, 0.85493634E-05_JPRB, 0.88371449E-05_JPRB, 0.90743898E-05_JPRB, 0.92708927E-05_JPRB, &
  & 0.94272741E-05_JPRB, 0.95466301E-05_JPRB, 0.96452047E-05_JPRB, 0.97095356E-05_JPRB, 0.97483729E-05_JPRB, 0.97684481E-05_JPRB, &
  & 0.97654908E-05_JPRB, 0.97304418E-05_JPRB, 0.96281266E-05_JPRB, 0.94867033E-05_JPRB, 0.93815609E-05_JPRB, 0.92907834E-05_JPRB, &
  & 0.91633950E-05_JPRB, 0.90299305E-05_JPRB, 0.88942051E-05_JPRB, 0.87497778E-05_JPRB, 0.85972935E-05_JPRB, 0.84323290E-05_JPRB, &
  & 0.82281187E-05_JPRB, 0.79947238E-05_JPRB, 0.77714421E-05_JPRB, 0.75168889E-05_JPRB, 0.72468519E-05_JPRB, 0.69793836E-05_JPRB, &
  & 0.67311493E-05_JPRB, 0.65102227E-05_JPRB, 0.63150184E-05_JPRB, 0.61375911E-05_JPRB, 0.59673952E-05_JPRB, 0.58023551E-05_JPRB, &
  & 0.56437595E-05_JPRB, 0.54977691E-05_JPRB, 0.53570066E-05_JPRB, 0.52271825E-05_JPRB, 0.51332231E-05_JPRB, 0.50614941E-05_JPRB, &
  & 0.50037343E-05_JPRB, 0.49532990E-05_JPRB, 0.49170841E-05_JPRB, 0.48954497E-05_JPRB  /)

RGHG7(:,20, 3) = (/ &
  & 0.39759282E-05_JPRB, 0.39795630E-05_JPRB, 0.40068259E-05_JPRB, 0.40509003E-05_JPRB, 0.40908901E-05_JPRB, 0.41407976E-05_JPRB, &
  & 0.42466790E-05_JPRB, 0.44121621E-05_JPRB, 0.46182956E-05_JPRB, 0.48642639E-05_JPRB, 0.51328561E-05_JPRB, 0.54163789E-05_JPRB, &
  & 0.57340629E-05_JPRB, 0.60654131E-05_JPRB, 0.64046395E-05_JPRB, 0.67243298E-05_JPRB, 0.70261793E-05_JPRB, 0.72875766E-05_JPRB, &
  & 0.75302606E-05_JPRB, 0.78028077E-05_JPRB, 0.81055719E-05_JPRB, 0.83879844E-05_JPRB, 0.86279988E-05_JPRB, 0.88422222E-05_JPRB, &
  & 0.90171940E-05_JPRB, 0.91446999E-05_JPRB, 0.92560567E-05_JPRB, 0.93347547E-05_JPRB, 0.93813184E-05_JPRB, 0.94140547E-05_JPRB, &
  & 0.94265158E-05_JPRB, 0.94030411E-05_JPRB, 0.93143011E-05_JPRB, 0.91970590E-05_JPRB, 0.91163827E-05_JPRB, 0.90290280E-05_JPRB, &
  & 0.89004775E-05_JPRB, 0.87652215E-05_JPRB, 0.86118462E-05_JPRB, 0.84333378E-05_JPRB, 0.82318872E-05_JPRB, 0.80129825E-05_JPRB, &
  & 0.77582889E-05_JPRB, 0.74917714E-05_JPRB, 0.72411903E-05_JPRB, 0.69829556E-05_JPRB, 0.67383780E-05_JPRB, 0.65114763E-05_JPRB, &
  & 0.63094671E-05_JPRB, 0.61321367E-05_JPRB, 0.59760287E-05_JPRB, 0.58334570E-05_JPRB, 0.56996080E-05_JPRB, 0.55655138E-05_JPRB, &
  & 0.54359187E-05_JPRB, 0.53213075E-05_JPRB, 0.52083852E-05_JPRB, 0.50960569E-05_JPRB, 0.50152220E-05_JPRB, 0.49592526E-05_JPRB, &
  & 0.49168987E-05_JPRB, 0.48724350E-05_JPRB, 0.48305732E-05_JPRB, 0.48050868E-05_JPRB  /)

RGHG7(:,21, 3) = (/ &
  & 0.38391915E-05_JPRB, 0.38705609E-05_JPRB, 0.39217892E-05_JPRB, 0.39854122E-05_JPRB, 0.40473126E-05_JPRB, 0.40967801E-05_JPRB, &
  & 0.41741091E-05_JPRB, 0.42913315E-05_JPRB, 0.44428249E-05_JPRB, 0.46348534E-05_JPRB, 0.48549611E-05_JPRB, 0.51006051E-05_JPRB, &
  & 0.53694638E-05_JPRB, 0.56433984E-05_JPRB, 0.59403393E-05_JPRB, 0.62559181E-05_JPRB, 0.65639748E-05_JPRB, 0.68179481E-05_JPRB, &
  & 0.70328052E-05_JPRB, 0.72654010E-05_JPRB, 0.75338293E-05_JPRB, 0.77765714E-05_JPRB, 0.79896175E-05_JPRB, 0.82011350E-05_JPRB, &
  & 0.83864420E-05_JPRB, 0.85280369E-05_JPRB, 0.86615359E-05_JPRB, 0.87663457E-05_JPRB, 0.88325303E-05_JPRB, 0.88840569E-05_JPRB, &
  & 0.89192926E-05_JPRB, 0.89171347E-05_JPRB, 0.88493137E-05_JPRB, 0.87488452E-05_JPRB, 0.86741060E-05_JPRB, 0.85766712E-05_JPRB, &
  & 0.84439125E-05_JPRB, 0.83048518E-05_JPRB, 0.81369890E-05_JPRB, 0.79355051E-05_JPRB, 0.77039575E-05_JPRB, 0.74549257E-05_JPRB, &
  & 0.71890804E-05_JPRB, 0.69336260E-05_JPRB, 0.67045238E-05_JPRB, 0.64855567E-05_JPRB, 0.62895407E-05_JPRB, 0.61151090E-05_JPRB, &
  & 0.59618115E-05_JPRB, 0.58235895E-05_JPRB, 0.57001559E-05_JPRB, 0.55841979E-05_JPRB, 0.54817274E-05_JPRB, 0.53768105E-05_JPRB, &
  & 0.52735122E-05_JPRB, 0.51871027E-05_JPRB, 0.51036642E-05_JPRB, 0.50138833E-05_JPRB, 0.49426147E-05_JPRB, 0.48978128E-05_JPRB, &
  & 0.48643732E-05_JPRB, 0.48251436E-05_JPRB, 0.47762153E-05_JPRB, 0.47457488E-05_JPRB  /)

RGHG7(:,22, 3) = (/ &
  & 0.37150762E-05_JPRB, 0.37593715E-05_JPRB, 0.38241338E-05_JPRB, 0.39064104E-05_JPRB, 0.40010054E-05_JPRB, 0.40763245E-05_JPRB, &
  & 0.41476216E-05_JPRB, 0.42238362E-05_JPRB, 0.43244882E-05_JPRB, 0.44689194E-05_JPRB, 0.46251078E-05_JPRB, 0.48177815E-05_JPRB, &
  & 0.50353425E-05_JPRB, 0.52534175E-05_JPRB, 0.54838032E-05_JPRB, 0.57530520E-05_JPRB, 0.60385519E-05_JPRB, 0.62814749E-05_JPRB, &
  & 0.64758028E-05_JPRB, 0.66636399E-05_JPRB, 0.68791485E-05_JPRB, 0.70521928E-05_JPRB, 0.72047157E-05_JPRB, 0.73794328E-05_JPRB, &
  & 0.75486713E-05_JPRB, 0.76974133E-05_JPRB, 0.78496674E-05_JPRB, 0.79809371E-05_JPRB, 0.80775353E-05_JPRB, 0.81584617E-05_JPRB, &
  & 0.82233000E-05_JPRB, 0.82503898E-05_JPRB, 0.82054804E-05_JPRB, 0.80938603E-05_JPRB, 0.79864771E-05_JPRB, 0.78640525E-05_JPRB, &
  & 0.77248055E-05_JPRB, 0.75807773E-05_JPRB, 0.74157531E-05_JPRB, 0.72262319E-05_JPRB, 0.70175959E-05_JPRB, 0.67977104E-05_JPRB, &
  & 0.65808311E-05_JPRB, 0.63882315E-05_JPRB, 0.62228458E-05_JPRB, 0.60641990E-05_JPRB, 0.59218124E-05_JPRB, 0.57954849E-05_JPRB, &
  & 0.56809647E-05_JPRB, 0.55704191E-05_JPRB, 0.54724823E-05_JPRB, 0.53791318E-05_JPRB, 0.53027156E-05_JPRB, 0.52267423E-05_JPRB, &
  & 0.51484845E-05_JPRB, 0.50912721E-05_JPRB, 0.50361182E-05_JPRB, 0.49759906E-05_JPRB, 0.49177999E-05_JPRB, 0.48757859E-05_JPRB, &
  & 0.48405722E-05_JPRB, 0.48056512E-05_JPRB, 0.47518567E-05_JPRB, 0.47171323E-05_JPRB  /)

RGHG7(:,23, 3) = (/ &
  & 0.36013638E-05_JPRB, 0.36315103E-05_JPRB, 0.36904989E-05_JPRB, 0.37779009E-05_JPRB, 0.38885980E-05_JPRB, 0.39904580E-05_JPRB, &
  & 0.40749464E-05_JPRB, 0.41365016E-05_JPRB, 0.42101767E-05_JPRB, 0.43171096E-05_JPRB, 0.44261788E-05_JPRB, 0.45673214E-05_JPRB, &
  & 0.47323705E-05_JPRB, 0.48939923E-05_JPRB, 0.50697846E-05_JPRB, 0.52673230E-05_JPRB, 0.54841131E-05_JPRB, 0.56822431E-05_JPRB, &
  & 0.58530490E-05_JPRB, 0.60141913E-05_JPRB, 0.61786181E-05_JPRB, 0.62874005E-05_JPRB, 0.63773804E-05_JPRB, 0.64940412E-05_JPRB, &
  & 0.66157845E-05_JPRB, 0.67423478E-05_JPRB, 0.68849001E-05_JPRB, 0.70241502E-05_JPRB, 0.71451016E-05_JPRB, 0.72525251E-05_JPRB, &
  & 0.73466252E-05_JPRB, 0.74039449E-05_JPRB, 0.73654066E-05_JPRB, 0.72227724E-05_JPRB, 0.70628415E-05_JPRB, 0.69110698E-05_JPRB, &
  & 0.67576646E-05_JPRB, 0.66097703E-05_JPRB, 0.64683723E-05_JPRB, 0.63345127E-05_JPRB, 0.62031749E-05_JPRB, 0.60707657E-05_JPRB, &
  & 0.59520225E-05_JPRB, 0.58455751E-05_JPRB, 0.57514389E-05_JPRB, 0.56521671E-05_JPRB, 0.55596116E-05_JPRB, 0.54758798E-05_JPRB, &
  & 0.53947194E-05_JPRB, 0.53149525E-05_JPRB, 0.52450892E-05_JPRB, 0.51785997E-05_JPRB, 0.51271343E-05_JPRB, 0.50801066E-05_JPRB, &
  & 0.50342258E-05_JPRB, 0.50033666E-05_JPRB, 0.49719632E-05_JPRB, 0.49355386E-05_JPRB, 0.48952323E-05_JPRB, 0.48540161E-05_JPRB, &
  & 0.48076752E-05_JPRB, 0.47692477E-05_JPRB, 0.47128082E-05_JPRB, 0.46716769E-05_JPRB  /)

RGHG7(:,24, 3) = (/ &
  & 0.34810352E-05_JPRB, 0.34932744E-05_JPRB, 0.35383934E-05_JPRB, 0.36184151E-05_JPRB, 0.37330001E-05_JPRB, 0.38530909E-05_JPRB, &
  & 0.39497184E-05_JPRB, 0.40039135E-05_JPRB, 0.40613203E-05_JPRB, 0.41394038E-05_JPRB, 0.42106611E-05_JPRB, 0.43009949E-05_JPRB, &
  & 0.44134587E-05_JPRB, 0.45196550E-05_JPRB, 0.46455532E-05_JPRB, 0.47758258E-05_JPRB, 0.49193575E-05_JPRB, 0.50593153E-05_JPRB, &
  & 0.51987665E-05_JPRB, 0.53325391E-05_JPRB, 0.54466706E-05_JPRB, 0.55003427E-05_JPRB, 0.55344716E-05_JPRB, 0.55929373E-05_JPRB, &
  & 0.56641921E-05_JPRB, 0.57562692E-05_JPRB, 0.58740950E-05_JPRB, 0.60068375E-05_JPRB, 0.61394091E-05_JPRB, 0.62646992E-05_JPRB, &
  & 0.63797748E-05_JPRB, 0.64591149E-05_JPRB, 0.64248700E-05_JPRB, 0.62603585E-05_JPRB, 0.60603548E-05_JPRB, 0.58807708E-05_JPRB, &
  & 0.57155671E-05_JPRB, 0.55741229E-05_JPRB, 0.54680921E-05_JPRB, 0.54001077E-05_JPRB, 0.53581187E-05_JPRB, 0.53256855E-05_JPRB, &
  & 0.53048788E-05_JPRB, 0.52854325E-05_JPRB, 0.52618159E-05_JPRB, 0.52195996E-05_JPRB, 0.51730226E-05_JPRB, 0.51292710E-05_JPRB, &
  & 0.50807597E-05_JPRB, 0.50328798E-05_JPRB, 0.49925284E-05_JPRB, 0.49557741E-05_JPRB, 0.49307801E-05_JPRB, 0.49124075E-05_JPRB, &
  & 0.48984724E-05_JPRB, 0.48926581E-05_JPRB, 0.48822354E-05_JPRB, 0.48657473E-05_JPRB, 0.48412648E-05_JPRB, 0.48025422E-05_JPRB, &
  & 0.47472086E-05_JPRB, 0.47007223E-05_JPRB, 0.46403173E-05_JPRB, 0.45917233E-05_JPRB  /)

RGHG7(:,25, 3) = (/ &
  & 0.33520594E-05_JPRB, 0.33466274E-05_JPRB, 0.33684994E-05_JPRB, 0.34223576E-05_JPRB, 0.35227456E-05_JPRB, 0.36453669E-05_JPRB, &
  & 0.37473988E-05_JPRB, 0.38015724E-05_JPRB, 0.38570490E-05_JPRB, 0.39206353E-05_JPRB, 0.39684956E-05_JPRB, 0.40112630E-05_JPRB, &
  & 0.40736514E-05_JPRB, 0.41288715E-05_JPRB, 0.42127579E-05_JPRB, 0.42923759E-05_JPRB, 0.43682683E-05_JPRB, 0.44365549E-05_JPRB, &
  & 0.45328577E-05_JPRB, 0.46352339E-05_JPRB, 0.47023138E-05_JPRB, 0.47183488E-05_JPRB, 0.47114524E-05_JPRB, 0.47188776E-05_JPRB, &
  & 0.47436812E-05_JPRB, 0.47876130E-05_JPRB, 0.48616040E-05_JPRB, 0.49666174E-05_JPRB, 0.50890881E-05_JPRB, 0.52168016E-05_JPRB, &
  & 0.53373029E-05_JPRB, 0.54229051E-05_JPRB, 0.53927992E-05_JPRB, 0.52280518E-05_JPRB, 0.50163603E-05_JPRB, 0.48139153E-05_JPRB, &
  & 0.46433502E-05_JPRB, 0.45260966E-05_JPRB, 0.44699697E-05_JPRB, 0.44731632E-05_JPRB, 0.45256205E-05_JPRB, 0.45976916E-05_JPRB, &
  & 0.46590001E-05_JPRB, 0.47189024E-05_JPRB, 0.47596441E-05_JPRB, 0.47680179E-05_JPRB, 0.47593782E-05_JPRB, 0.47504112E-05_JPRB, &
  & 0.47330390E-05_JPRB, 0.47168771E-05_JPRB, 0.47066782E-05_JPRB, 0.47024568E-05_JPRB, 0.47056852E-05_JPRB, 0.47141625E-05_JPRB, &
  & 0.47283211E-05_JPRB, 0.47447459E-05_JPRB, 0.47504717E-05_JPRB, 0.47476873E-05_JPRB, 0.47335845E-05_JPRB, 0.47006951E-05_JPRB, &
  & 0.46426593E-05_JPRB, 0.45821691E-05_JPRB, 0.45151374E-05_JPRB, 0.44580295E-05_JPRB  /)

RGHG7(:,26, 3) = (/ &
  & 0.32098127E-05_JPRB, 0.32033853E-05_JPRB, 0.32103412E-05_JPRB, 0.32428542E-05_JPRB, 0.33214980E-05_JPRB, 0.34244514E-05_JPRB, &
  & 0.35113682E-05_JPRB, 0.35602241E-05_JPRB, 0.36119600E-05_JPRB, 0.36676820E-05_JPRB, 0.36958115E-05_JPRB, 0.37083388E-05_JPRB, &
  & 0.37350406E-05_JPRB, 0.37531234E-05_JPRB, 0.37987862E-05_JPRB, 0.38440779E-05_JPRB, 0.38754894E-05_JPRB, 0.38958662E-05_JPRB, &
  & 0.39428821E-05_JPRB, 0.40014783E-05_JPRB, 0.40274469E-05_JPRB, 0.40161238E-05_JPRB, 0.39872833E-05_JPRB, 0.39649716E-05_JPRB, &
  & 0.39564362E-05_JPRB, 0.39634915E-05_JPRB, 0.39959136E-05_JPRB, 0.40570757E-05_JPRB, 0.41463993E-05_JPRB, 0.42523683E-05_JPRB, &
  & 0.43592012E-05_JPRB, 0.44332189E-05_JPRB, 0.44079546E-05_JPRB, 0.42690988E-05_JPRB, 0.40781958E-05_JPRB, 0.38964962E-05_JPRB, &
  & 0.37573895E-05_JPRB, 0.36905488E-05_JPRB, 0.36937705E-05_JPRB, 0.37533770E-05_JPRB, 0.38704158E-05_JPRB, 0.40033722E-05_JPRB, &
  & 0.41087128E-05_JPRB, 0.42093799E-05_JPRB, 0.42901690E-05_JPRB, 0.43327959E-05_JPRB, 0.43576114E-05_JPRB, 0.43795367E-05_JPRB, &
  & 0.43888244E-05_JPRB, 0.43963096E-05_JPRB, 0.44084152E-05_JPRB, 0.44295517E-05_JPRB, 0.44543110E-05_JPRB, 0.44816428E-05_JPRB, &
  & 0.45136112E-05_JPRB, 0.45429363E-05_JPRB, 0.45610700E-05_JPRB, 0.45678212E-05_JPRB, 0.45618045E-05_JPRB, 0.45348502E-05_JPRB, &
  & 0.44817724E-05_JPRB, 0.44143523E-05_JPRB, 0.43445262E-05_JPRB, 0.42851187E-05_JPRB  /)

RGHG7(:,27, 3) = (/ &
  & 0.30561699E-05_JPRB, 0.30548851E-05_JPRB, 0.30493347E-05_JPRB, 0.30613177E-05_JPRB, 0.31144289E-05_JPRB, 0.31885882E-05_JPRB, &
  & 0.32520934E-05_JPRB, 0.32934256E-05_JPRB, 0.33405793E-05_JPRB, 0.33905385E-05_JPRB, 0.33993985E-05_JPRB, 0.33867333E-05_JPRB, &
  & 0.33814595E-05_JPRB, 0.33658457E-05_JPRB, 0.33729494E-05_JPRB, 0.33884065E-05_JPRB, 0.33818994E-05_JPRB, 0.33609958E-05_JPRB, &
  & 0.33542052E-05_JPRB, 0.33624367E-05_JPRB, 0.33476252E-05_JPRB, 0.33115099E-05_JPRB, 0.32668016E-05_JPRB, 0.32212985E-05_JPRB, &
  & 0.31827684E-05_JPRB, 0.31554467E-05_JPRB, 0.31452478E-05_JPRB, 0.31545844E-05_JPRB, 0.32007068E-05_JPRB, 0.32749801E-05_JPRB, &
  & 0.33604426E-05_JPRB, 0.34157311E-05_JPRB, 0.33957894E-05_JPRB, 0.32936917E-05_JPRB, 0.31365653E-05_JPRB, 0.29927243E-05_JPRB, &
  & 0.29001605E-05_JPRB, 0.28957505E-05_JPRB, 0.29645245E-05_JPRB, 0.30776373E-05_JPRB, 0.32511239E-05_JPRB, 0.34315637E-05_JPRB, &
  & 0.35688200E-05_JPRB, 0.36978010E-05_JPRB, 0.38114463E-05_JPRB, 0.38838278E-05_JPRB, 0.39419597E-05_JPRB, 0.39947402E-05_JPRB, &
  & 0.40302408E-05_JPRB, 0.40594566E-05_JPRB, 0.40919723E-05_JPRB, 0.41369605E-05_JPRB, 0.41817497E-05_JPRB, 0.42258297E-05_JPRB, &
  & 0.42726054E-05_JPRB, 0.43119555E-05_JPRB, 0.43416749E-05_JPRB, 0.43568502E-05_JPRB, 0.43584373E-05_JPRB, 0.43377260E-05_JPRB, &
  & 0.42926722E-05_JPRB, 0.42206298E-05_JPRB, 0.41493029E-05_JPRB, 0.40897954E-05_JPRB  /)

RGHG7(:,28, 3) = (/ &
  & 0.29521040E-05_JPRB, 0.29518015E-05_JPRB, 0.29427384E-05_JPRB, 0.29515737E-05_JPRB, 0.29895715E-05_JPRB, 0.30320721E-05_JPRB, &
  & 0.30664375E-05_JPRB, 0.30884175E-05_JPRB, 0.31152557E-05_JPRB, 0.31431432E-05_JPRB, 0.31415515E-05_JPRB, 0.31167410E-05_JPRB, &
  & 0.30932453E-05_JPRB, 0.30633425E-05_JPRB, 0.30429520E-05_JPRB, 0.30258793E-05_JPRB, 0.29961693E-05_JPRB, 0.29551011E-05_JPRB, &
  & 0.29171459E-05_JPRB, 0.28875255E-05_JPRB, 0.28430575E-05_JPRB, 0.27864298E-05_JPRB, 0.27288305E-05_JPRB, 0.26729041E-05_JPRB, &
  & 0.26191017E-05_JPRB, 0.25778461E-05_JPRB, 0.25484425E-05_JPRB, 0.25277381E-05_JPRB, 0.25354603E-05_JPRB, 0.25659593E-05_JPRB, &
  & 0.26059285E-05_JPRB, 0.26319459E-05_JPRB, 0.26198494E-05_JPRB, 0.25607789E-05_JPRB, 0.24683743E-05_JPRB, 0.23988942E-05_JPRB, &
  & 0.23768329E-05_JPRB, 0.24295066E-05_JPRB, 0.25436847E-05_JPRB, 0.26883653E-05_JPRB, 0.28703125E-05_JPRB, 0.30404015E-05_JPRB, &
  & 0.31788461E-05_JPRB, 0.33108658E-05_JPRB, 0.34263670E-05_JPRB, 0.35157709E-05_JPRB, 0.35976885E-05_JPRB, 0.36699084E-05_JPRB, &
  & 0.37226408E-05_JPRB, 0.37685967E-05_JPRB, 0.38193610E-05_JPRB, 0.38741677E-05_JPRB, 0.39252056E-05_JPRB, 0.39745753E-05_JPRB, &
  & 0.40296685E-05_JPRB, 0.40795219E-05_JPRB, 0.41178638E-05_JPRB, 0.41420187E-05_JPRB, 0.41544122E-05_JPRB, 0.41431924E-05_JPRB, &
  & 0.41059903E-05_JPRB, 0.40382149E-05_JPRB, 0.39717923E-05_JPRB, 0.39163975E-05_JPRB  /)

RGHG7(:,29, 3) = (/ &
  & 0.28439871E-05_JPRB, 0.28445452E-05_JPRB, 0.28321499E-05_JPRB, 0.28384038E-05_JPRB, 0.28608394E-05_JPRB, 0.28696707E-05_JPRB, &
  & 0.28729118E-05_JPRB, 0.28738736E-05_JPRB, 0.28785037E-05_JPRB, 0.28822972E-05_JPRB, 0.28700134E-05_JPRB, 0.28328996E-05_JPRB, &
  & 0.27906926E-05_JPRB, 0.27464910E-05_JPRB, 0.26974477E-05_JPRB, 0.26457904E-05_JPRB, 0.25921329E-05_JPRB, 0.25306141E-05_JPRB, &
  & 0.24606192E-05_JPRB, 0.23914342E-05_JPRB, 0.23160250E-05_JPRB, 0.22378482E-05_JPRB, 0.21667190E-05_JPRB, 0.21003018E-05_JPRB, &
  & 0.20309556E-05_JPRB, 0.19758221E-05_JPRB, 0.19270848E-05_JPRB, 0.18754940E-05_JPRB, 0.18427363E-05_JPRB, 0.18263290E-05_JPRB, &
  & 0.18170485E-05_JPRB, 0.18115936E-05_JPRB, 0.18079190E-05_JPRB, 0.17947111E-05_JPRB, 0.17722266E-05_JPRB, 0.17831206E-05_JPRB, &
  & 0.18368013E-05_JPRB, 0.19497282E-05_JPRB, 0.21111420E-05_JPRB, 0.22883202E-05_JPRB, 0.24771513E-05_JPRB, 0.26337653E-05_JPRB, &
  & 0.27721367E-05_JPRB, 0.29062801E-05_JPRB, 0.30224039E-05_JPRB, 0.31292923E-05_JPRB, 0.32359996E-05_JPRB, 0.33283221E-05_JPRB, &
  & 0.33989236E-05_JPRB, 0.34624007E-05_JPRB, 0.35324072E-05_JPRB, 0.35970089E-05_JPRB, 0.36540703E-05_JPRB, 0.37085480E-05_JPRB, &
  & 0.37721730E-05_JPRB, 0.38331762E-05_JPRB, 0.38805258E-05_JPRB, 0.39142195E-05_JPRB, 0.39382023E-05_JPRB, 0.39371803E-05_JPRB, &
  & 0.39082901E-05_JPRB, 0.38454214E-05_JPRB, 0.37844731E-05_JPRB, 0.37336188E-05_JPRB  /)

RGHG7(:,30, 3) = (/ &
  & 0.27051358E-05_JPRB, 0.27022527E-05_JPRB, 0.26948886E-05_JPRB, 0.26972318E-05_JPRB, 0.27103570E-05_JPRB, 0.27117917E-05_JPRB, &
  & 0.27030707E-05_JPRB, 0.26873992E-05_JPRB, 0.26725802E-05_JPRB, 0.26566013E-05_JPRB, 0.26295109E-05_JPRB, 0.25820120E-05_JPRB, &
  & 0.25274520E-05_JPRB, 0.24713677E-05_JPRB, 0.24112170E-05_JPRB, 0.23449247E-05_JPRB, 0.22747276E-05_JPRB, 0.21973320E-05_JPRB, &
  & 0.21114658E-05_JPRB, 0.20246497E-05_JPRB, 0.19336436E-05_JPRB, 0.18438511E-05_JPRB, 0.17606951E-05_JPRB, 0.16858407E-05_JPRB, &
  & 0.16154511E-05_JPRB, 0.15639240E-05_JPRB, 0.15195762E-05_JPRB, 0.14687618E-05_JPRB, 0.14257223E-05_JPRB, 0.13915969E-05_JPRB, &
  & 0.13607360E-05_JPRB, 0.13397964E-05_JPRB, 0.13346336E-05_JPRB, 0.13427135E-05_JPRB, 0.13594074E-05_JPRB, 0.14070445E-05_JPRB, &
  & 0.14931699E-05_JPRB, 0.16199668E-05_JPRB, 0.17832728E-05_JPRB, 0.19474847E-05_JPRB, 0.21070658E-05_JPRB, 0.22519909E-05_JPRB, &
  & 0.23927426E-05_JPRB, 0.25343347E-05_JPRB, 0.26617336E-05_JPRB, 0.27885011E-05_JPRB, 0.29124724E-05_JPRB, 0.30157821E-05_JPRB, &
  & 0.30950526E-05_JPRB, 0.31705440E-05_JPRB, 0.32542550E-05_JPRB, 0.33251060E-05_JPRB, 0.33827518E-05_JPRB, 0.34399362E-05_JPRB, &
  & 0.35086191E-05_JPRB, 0.35777225E-05_JPRB, 0.36336046E-05_JPRB, 0.36754934E-05_JPRB, 0.37092494E-05_JPRB, 0.37244971E-05_JPRB, &
  & 0.37071143E-05_JPRB, 0.36520345E-05_JPRB, 0.35979588E-05_JPRB, 0.35558260E-05_JPRB  /)

RGHG7(:,31, 3) = (/ &
  & 0.25588053E-05_JPRB, 0.25522924E-05_JPRB, 0.25502374E-05_JPRB, 0.25484588E-05_JPRB, 0.25517801E-05_JPRB, 0.25454462E-05_JPRB, &
  & 0.25241395E-05_JPRB, 0.24909464E-05_JPRB, 0.24556374E-05_JPRB, 0.24188294E-05_JPRB, 0.23761340E-05_JPRB, 0.23176948E-05_JPRB, &
  & 0.22501250E-05_JPRB, 0.21815228E-05_JPRB, 0.21096854E-05_JPRB, 0.20279916E-05_JPRB, 0.19403747E-05_JPRB, 0.18462547E-05_JPRB, &
  & 0.17436810E-05_JPRB, 0.16383086E-05_JPRB, 0.15308834E-05_JPRB, 0.14288614E-05_JPRB, 0.13330349E-05_JPRB, 0.12492925E-05_JPRB, &
  & 0.11778173E-05_JPRB, 0.11301066E-05_JPRB, 0.10904064E-05_JPRB, 0.10404401E-05_JPRB, 0.98659589E-06_JPRB, 0.93382934E-06_JPRB, &
  & 0.88025648E-06_JPRB, 0.84301654E-06_JPRB, 0.83627623E-06_JPRB, 0.86676282E-06_JPRB, 0.92470801E-06_JPRB, 0.10110182E-05_JPRB, &
  & 0.11312878E-05_JPRB, 0.12726550E-05_JPRB, 0.14379117E-05_JPRB, 0.15884183E-05_JPRB, 0.17171457E-05_JPRB, 0.18497566E-05_JPRB, &
  & 0.19930186E-05_JPRB, 0.21424640E-05_JPRB, 0.22817533E-05_JPRB, 0.24294687E-05_JPRB, 0.25716231E-05_JPRB, 0.26865008E-05_JPRB, &
  & 0.27748969E-05_JPRB, 0.28630418E-05_JPRB, 0.29611873E-05_JPRB, 0.30386195E-05_JPRB, 0.30968759E-05_JPRB, 0.31569100E-05_JPRB, &
  & 0.32309189E-05_JPRB, 0.33085541E-05_JPRB, 0.33734260E-05_JPRB, 0.34239484E-05_JPRB, 0.34680002E-05_JPRB, 0.35003965E-05_JPRB, &
  & 0.34951414E-05_JPRB, 0.34482712E-05_JPRB, 0.34014382E-05_JPRB, 0.33684987E-05_JPRB  /)

RGHG7(:,32, 3) = (/ &
  & 0.24145427E-05_JPRB, 0.24119150E-05_JPRB, 0.24086185E-05_JPRB, 0.24017137E-05_JPRB, 0.23975861E-05_JPRB, 0.23879066E-05_JPRB, &
  & 0.23614917E-05_JPRB, 0.23190663E-05_JPRB, 0.22697450E-05_JPRB, 0.22173577E-05_JPRB, 0.21602627E-05_JPRB, 0.20906986E-05_JPRB, &
  & 0.20127033E-05_JPRB, 0.19335662E-05_JPRB, 0.18522963E-05_JPRB, 0.17639809E-05_JPRB, 0.16685630E-05_JPRB, 0.15655447E-05_JPRB, &
  & 0.14572151E-05_JPRB, 0.13499782E-05_JPRB, 0.12443933E-05_JPRB, 0.11434469E-05_JPRB, 0.10490023E-05_JPRB, 0.96820756E-06_JPRB, &
  & 0.90324799E-06_JPRB, 0.85833589E-06_JPRB, 0.82308285E-06_JPRB, 0.78222218E-06_JPRB, 0.73692999E-06_JPRB, 0.69111003E-06_JPRB, &
  & 0.64515242E-06_JPRB, 0.61443568E-06_JPRB, 0.61137104E-06_JPRB, 0.64245561E-06_JPRB, 0.69836209E-06_JPRB, 0.77505669E-06_JPRB, &
  & 0.87581509E-06_JPRB, 0.98924907E-06_JPRB, 0.11189483E-05_JPRB, 0.12445882E-05_JPRB, 0.13598756E-05_JPRB, 0.14908492E-05_JPRB, &
  & 0.16377755E-05_JPRB, 0.17985499E-05_JPRB, 0.19578351E-05_JPRB, 0.21240648E-05_JPRB, 0.22769448E-05_JPRB, 0.24014603E-05_JPRB, &
  & 0.24957554E-05_JPRB, 0.25894529E-05_JPRB, 0.26878868E-05_JPRB, 0.27695435E-05_JPRB, 0.28351042E-05_JPRB, 0.29014890E-05_JPRB, &
  & 0.29784910E-05_JPRB, 0.30604029E-05_JPRB, 0.31328247E-05_JPRB, 0.31926598E-05_JPRB, 0.32455804E-05_JPRB, 0.32904719E-05_JPRB, &
  & 0.32983574E-05_JPRB, 0.32626645E-05_JPRB, 0.32233516E-05_JPRB, 0.31992406E-05_JPRB  /)

RGHG7(:,33, 3) = (/ &
  & 0.22648859E-05_JPRB, 0.22672689E-05_JPRB, 0.22618341E-05_JPRB, 0.22494717E-05_JPRB, 0.22379078E-05_JPRB, 0.22253240E-05_JPRB, &
  & 0.21945686E-05_JPRB, 0.21436218E-05_JPRB, 0.20805768E-05_JPRB, 0.20126786E-05_JPRB, 0.19407748E-05_JPRB, 0.18596255E-05_JPRB, &
  & 0.17711300E-05_JPRB, 0.16813012E-05_JPRB, 0.15905205E-05_JPRB, 0.14964603E-05_JPRB, 0.13941806E-05_JPRB, 0.12829281E-05_JPRB, &
  & 0.11700346E-05_JPRB, 0.10630211E-05_JPRB, 0.96171294E-06_JPRB, 0.86360703E-06_JPRB, 0.77241774E-06_JPRB, 0.69621885E-06_JPRB, &
  & 0.63901473E-06_JPRB, 0.59687927E-06_JPRB, 0.56622206E-06_JPRB, 0.53589349E-06_JPRB, 0.50199511E-06_JPRB, 0.46670724E-06_JPRB, &
  & 0.43259026E-06_JPRB, 0.41160772E-06_JPRB, 0.41304317E-06_JPRB, 0.44192556E-06_JPRB, 0.49010851E-06_JPRB, 0.55055816E-06_JPRB, &
  & 0.62409268E-06_JPRB, 0.70299416E-06_JPRB, 0.79088413E-06_JPRB, 0.88923637E-06_JPRB, 0.99281081E-06_JPRB, 0.11234652E-05_JPRB, &
  & 0.12743490E-05_JPRB, 0.14473471E-05_JPRB, 0.16284624E-05_JPRB, 0.18136180E-05_JPRB, 0.19766790E-05_JPRB, 0.21109606E-05_JPRB, &
  & 0.22109686E-05_JPRB, 0.23095173E-05_JPRB, 0.24064192E-05_JPRB, 0.24921610E-05_JPRB, 0.25661793E-05_JPRB, 0.26396174E-05_JPRB, &
  & 0.27194281E-05_JPRB, 0.28052337E-05_JPRB, 0.28853151E-05_JPRB, 0.29549163E-05_JPRB, 0.30168690E-05_JPRB, 0.30741437E-05_JPRB, &
  & 0.30958167E-05_JPRB, 0.30721240E-05_JPRB, 0.30406623E-05_JPRB, 0.30256792E-05_JPRB  /)

RGHG7(:,34, 3) = (/ &
  & 0.21005998E-05_JPRB, 0.21077063E-05_JPRB, 0.21008486E-05_JPRB, 0.20878029E-05_JPRB, 0.20739938E-05_JPRB, 0.20591940E-05_JPRB, &
  & 0.20242842E-05_JPRB, 0.19672722E-05_JPRB, 0.18960650E-05_JPRB, 0.18195632E-05_JPRB, 0.17388092E-05_JPRB, 0.16514969E-05_JPRB, &
  & 0.15585448E-05_JPRB, 0.14631965E-05_JPRB, 0.13663863E-05_JPRB, 0.12692798E-05_JPRB, 0.11659261E-05_JPRB, 0.10556599E-05_JPRB, &
  & 0.94649266E-06_JPRB, 0.84543336E-06_JPRB, 0.75133275E-06_JPRB, 0.66247343E-06_JPRB, 0.58088025E-06_JPRB, 0.51499275E-06_JPRB, &
  & 0.46684616E-06_JPRB, 0.43030440E-06_JPRB, 0.40425170E-06_JPRB, 0.38158007E-06_JPRB, 0.35785447E-06_JPRB, 0.33356697E-06_JPRB, &
  & 0.31113580E-06_JPRB, 0.29835159E-06_JPRB, 0.30191935E-06_JPRB, 0.32420798E-06_JPRB, 0.35873240E-06_JPRB, 0.40043830E-06_JPRB, &
  & 0.45005585E-06_JPRB, 0.50385605E-06_JPRB, 0.56547105E-06_JPRB, 0.64353593E-06_JPRB, 0.73408357E-06_JPRB, 0.85421714E-06_JPRB, &
  & 0.99955876E-06_JPRB, 0.11722070E-05_JPRB, 0.13600138E-05_JPRB, 0.15516818E-05_JPRB, 0.17224174E-05_JPRB, 0.18655229E-05_JPRB, &
  & 0.19692583E-05_JPRB, 0.20686150E-05_JPRB, 0.21616250E-05_JPRB, 0.22467286E-05_JPRB, 0.23284818E-05_JPRB, 0.24098598E-05_JPRB, &
  & 0.24915085E-05_JPRB, 0.25790909E-05_JPRB, 0.26613189E-05_JPRB, 0.27373806E-05_JPRB, 0.28081625E-05_JPRB, 0.28731532E-05_JPRB, &
  & 0.29016838E-05_JPRB, 0.28905947E-05_JPRB, 0.28676652E-05_JPRB, 0.28523776E-05_JPRB  /)

RGHG7(:,35, 3) = (/ &
  & 0.19241855E-05_JPRB, 0.19360009E-05_JPRB, 0.19280474E-05_JPRB, 0.19167490E-05_JPRB, 0.19032953E-05_JPRB, 0.18865706E-05_JPRB, &
  & 0.18474850E-05_JPRB, 0.17854975E-05_JPRB, 0.17087522E-05_JPRB, 0.16269492E-05_JPRB, 0.15401536E-05_JPRB, 0.14492875E-05_JPRB, &
  & 0.13548545E-05_JPRB, 0.12564854E-05_JPRB, 0.11552625E-05_JPRB, 0.10564087E-05_JPRB, 0.95492077E-06_JPRB, 0.85040004E-06_JPRB, &
  & 0.74931784E-06_JPRB, 0.65732091E-06_JPRB, 0.57213460E-06_JPRB, 0.49606923E-06_JPRB, 0.42759577E-06_JPRB, 0.37524261E-06_JPRB, &
  & 0.33707648E-06_JPRB, 0.30773131E-06_JPRB, 0.28641711E-06_JPRB, 0.27014245E-06_JPRB, 0.25624924E-06_JPRB, 0.24351183E-06_JPRB, &
  & 0.23301574E-06_JPRB, 0.22787237E-06_JPRB, 0.23241745E-06_JPRB, 0.24567331E-06_JPRB, 0.26310952E-06_JPRB, 0.28426219E-06_JPRB, &
  & 0.31098687E-06_JPRB, 0.34381921E-06_JPRB, 0.38639137E-06_JPRB, 0.44719034E-06_JPRB, 0.52367056E-06_JPRB, 0.62775247E-06_JPRB, &
  & 0.76252131E-06_JPRB, 0.92835796E-06_JPRB, 0.11152763E-05_JPRB, 0.13072701E-05_JPRB, 0.14846100E-05_JPRB, 0.16363040E-05_JPRB, &
  & 0.17428528E-05_JPRB, 0.18409657E-05_JPRB, 0.19287634E-05_JPRB, 0.20107869E-05_JPRB, 0.21001217E-05_JPRB, 0.21901178E-05_JPRB, &
  & 0.22731585E-05_JPRB, 0.23614813E-05_JPRB, 0.24430874E-05_JPRB, 0.25240949E-05_JPRB, 0.26038503E-05_JPRB, 0.26743791E-05_JPRB, &
  & 0.27064044E-05_JPRB, 0.27085831E-05_JPRB, 0.26947752E-05_JPRB, 0.26743345E-05_JPRB  /)

RGHG7(:,36, 3) = (/ &
  & 0.17458447E-05_JPRB, 0.17592290E-05_JPRB, 0.17520339E-05_JPRB, 0.17429911E-05_JPRB, 0.17300097E-05_JPRB, 0.17114829E-05_JPRB, &
  & 0.16691925E-05_JPRB, 0.16040717E-05_JPRB, 0.15246145E-05_JPRB, 0.14398956E-05_JPRB, 0.13497135E-05_JPRB, 0.12574761E-05_JPRB, &
  & 0.11636129E-05_JPRB, 0.10646232E-05_JPRB, 0.96193144E-06_JPRB, 0.86350473E-06_JPRB, 0.76582906E-06_JPRB, 0.66910958E-06_JPRB, &
  & 0.57777260E-06_JPRB, 0.49574481E-06_JPRB, 0.41996978E-06_JPRB, 0.35598026E-06_JPRB, 0.29997041E-06_JPRB, 0.25960077E-06_JPRB, &
  & 0.23027815E-06_JPRB, 0.20764843E-06_JPRB, 0.19104701E-06_JPRB, 0.18020941E-06_JPRB, 0.17377672E-06_JPRB, 0.16940578E-06_JPRB, &
  & 0.16744363E-06_JPRB, 0.16771879E-06_JPRB, 0.17253011E-06_JPRB, 0.17875331E-06_JPRB, 0.18376565E-06_JPRB, 0.19001411E-06_JPRB, &
  & 0.19990332E-06_JPRB, 0.21673324E-06_JPRB, 0.24403869E-06_JPRB, 0.28957533E-06_JPRB, 0.35220000E-06_JPRB, 0.44003643E-06_JPRB, &
  & 0.56202930E-06_JPRB, 0.71785665E-06_JPRB, 0.89988764E-06_JPRB, 0.10892183E-05_JPRB, 0.12684864E-05_JPRB, 0.14253152E-05_JPRB, &
  & 0.15340344E-05_JPRB, 0.16301727E-05_JPRB, 0.17132302E-05_JPRB, 0.17919931E-05_JPRB, 0.18855450E-05_JPRB, 0.19822922E-05_JPRB, &
  & 0.20661303E-05_JPRB, 0.21530786E-05_JPRB, 0.22320176E-05_JPRB, 0.23159301E-05_JPRB, 0.24031754E-05_JPRB, 0.24781128E-05_JPRB, &
  & 0.25130584E-05_JPRB, 0.25259694E-05_JPRB, 0.25214745E-05_JPRB, 0.24963229E-05_JPRB  /)

RGHG7(:,37, 3) = (/ &
  & 0.15741824E-05_JPRB, 0.15818391E-05_JPRB, 0.15796061E-05_JPRB, 0.15738441E-05_JPRB, 0.15615734E-05_JPRB, 0.15416387E-05_JPRB, &
  & 0.14985691E-05_JPRB, 0.14347332E-05_JPRB, 0.13592129E-05_JPRB, 0.12772279E-05_JPRB, 0.11899575E-05_JPRB, 0.11014382E-05_JPRB, &
  & 0.10128105E-05_JPRB, 0.91874192E-06_JPRB, 0.82142236E-06_JPRB, 0.72838151E-06_JPRB, 0.63874362E-06_JPRB, 0.55405347E-06_JPRB, &
  & 0.47566168E-06_JPRB, 0.40506176E-06_JPRB, 0.33925193E-06_JPRB, 0.28494055E-06_JPRB, 0.23911462E-06_JPRB, 0.20642734E-06_JPRB, &
  & 0.18279132E-06_JPRB, 0.16535607E-06_JPRB, 0.15311529E-06_JPRB, 0.14517566E-06_JPRB, 0.14030132E-06_JPRB, 0.13647717E-06_JPRB, &
  & 0.13472006E-06_JPRB, 0.13498155E-06_JPRB, 0.13841223E-06_JPRB, 0.14262599E-06_JPRB, 0.14668145E-06_JPRB, 0.15190469E-06_JPRB, &
  & 0.15989381E-06_JPRB, 0.17310125E-06_JPRB, 0.19474745E-06_JPRB, 0.23056495E-06_JPRB, 0.28068185E-06_JPRB, 0.35283915E-06_JPRB, &
  & 0.45779958E-06_JPRB, 0.59690890E-06_JPRB, 0.76518818E-06_JPRB, 0.94516879E-06_JPRB, 0.11155243E-05_JPRB, 0.12692500E-05_JPRB, &
  & 0.13785296E-05_JPRB, 0.14711412E-05_JPRB, 0.15508360E-05_JPRB, 0.16261267E-05_JPRB, 0.17159194E-05_JPRB, 0.18147171E-05_JPRB, &
  & 0.18979401E-05_JPRB, 0.19787507E-05_JPRB, 0.20504995E-05_JPRB, 0.21324571E-05_JPRB, 0.22233250E-05_JPRB, 0.22998071E-05_JPRB, &
  & 0.23361743E-05_JPRB, 0.23533365E-05_JPRB, 0.23580140E-05_JPRB, 0.23294586E-05_JPRB  /)

RGHG7(:,38, 3) = (/ &
  & 0.13837079E-05_JPRB, 0.13850093E-05_JPRB, 0.13882821E-05_JPRB, 0.13861604E-05_JPRB, 0.13746784E-05_JPRB, 0.13531814E-05_JPRB, &
  & 0.13092473E-05_JPRB, 0.12468372E-05_JPRB, 0.11756852E-05_JPRB, 0.10967337E-05_JPRB, 0.10126940E-05_JPRB, 0.92830039E-06_JPRB, &
  & 0.84548191E-06_JPRB, 0.75687371E-06_JPRB, 0.66551507E-06_JPRB, 0.57845030E-06_JPRB, 0.49773104E-06_JPRB, 0.42638850E-06_JPRB, &
  & 0.36236055E-06_JPRB, 0.30444085E-06_JPRB, 0.24968831E-06_JPRB, 0.20611568E-06_JPRB, 0.17158971E-06_JPRB, 0.14742670E-06_JPRB, &
  & 0.13010046E-06_JPRB, 0.11842895E-06_JPRB, 0.11102668E-06_JPRB, 0.10630261E-06_JPRB, 0.10315739E-06_JPRB, 0.99939945E-07_JPRB, &
  & 0.98410352E-07_JPRB, 0.98656680E-07_JPRB, 0.10055541E-06_JPRB, 0.10253951E-06_JPRB, 0.10553323E-06_JPRB, 0.10961889E-06_JPRB, &
  & 0.11549970E-06_JPRB, 0.12468770E-06_JPRB, 0.14005445E-06_JPRB, 0.16508769E-06_JPRB, 0.20132611E-06_JPRB, 0.25608602E-06_JPRB, &
  & 0.34214745E-06_JPRB, 0.46270664E-06_JPRB, 0.61572717E-06_JPRB, 0.78533306E-06_JPRB, 0.94579916E-06_JPRB, 0.10960819E-05_JPRB, &
  & 0.12059833E-05_JPRB, 0.12946817E-05_JPRB, 0.13706451E-05_JPRB, 0.14420833E-05_JPRB, 0.15277049E-05_JPRB, 0.16287777E-05_JPRB, &
  & 0.17113182E-05_JPRB, 0.17853184E-05_JPRB, 0.18490890E-05_JPRB, 0.19288777E-05_JPRB, 0.20237650E-05_JPRB, 0.21019610E-05_JPRB, &
  & 0.21399056E-05_JPRB, 0.21617850E-05_JPRB, 0.21766401E-05_JPRB, 0.21443079E-05_JPRB  /)

RGHG7(:,39, 3) = (/ &
  & 0.12440962E-05_JPRB, 0.12380962E-05_JPRB, 0.12414536E-05_JPRB, 0.12399299E-05_JPRB, 0.12279990E-05_JPRB, 0.12070200E-05_JPRB, &
  & 0.11663511E-05_JPRB, 0.11093629E-05_JPRB, 0.10451602E-05_JPRB, 0.97238366E-06_JPRB, 0.89464128E-06_JPRB, 0.81597803E-06_JPRB, &
  & 0.73963051E-06_JPRB, 0.65823606E-06_JPRB, 0.57510154E-06_JPRB, 0.49671004E-06_JPRB, 0.42489314E-06_JPRB, 0.36338758E-06_JPRB, &
  & 0.30867729E-06_JPRB, 0.25932378E-06_JPRB, 0.21254613E-06_JPRB, 0.17544755E-06_JPRB, 0.14594787E-06_JPRB, 0.12528242E-06_JPRB, &
  & 0.11081188E-06_JPRB, 0.10135106E-06_JPRB, 0.95206241E-07_JPRB, 0.91115600E-07_JPRB, 0.87996473E-07_JPRB, 0.84755073E-07_JPRB, &
  & 0.83078764E-07_JPRB, 0.83301417E-07_JPRB, 0.85023632E-07_JPRB, 0.87073131E-07_JPRB, 0.90144228E-07_JPRB, 0.94308898E-07_JPRB, &
  & 0.99931758E-07_JPRB, 0.10847525E-06_JPRB, 0.12211370E-06_JPRB, 0.14315468E-06_JPRB, 0.17376769E-06_JPRB, 0.22006065E-06_JPRB, &
  & 0.29464587E-06_JPRB, 0.40381516E-06_JPRB, 0.54628487E-06_JPRB, 0.70672297E-06_JPRB, 0.85793885E-06_JPRB, 0.99905090E-06_JPRB, &
  & 0.11063338E-05_JPRB, 0.11902986E-05_JPRB, 0.12614200E-05_JPRB, 0.13282739E-05_JPRB, 0.14090541E-05_JPRB, 0.15066742E-05_JPRB, &
  & 0.15839056E-05_JPRB, 0.16498396E-05_JPRB, 0.17062193E-05_JPRB, 0.17800369E-05_JPRB, 0.18730814E-05_JPRB, 0.19501998E-05_JPRB, &
  & 0.19869956E-05_JPRB, 0.20088848E-05_JPRB, 0.20290216E-05_JPRB, 0.19991293E-05_JPRB  /)

RGHG7(:,40, 3) = (/ &
  & 0.10885715E-05_JPRB, 0.10738479E-05_JPRB, 0.10764175E-05_JPRB, 0.10750981E-05_JPRB, 0.10624378E-05_JPRB, 0.10424070E-05_JPRB, &
  & 0.10062458E-05_JPRB, 0.95627443E-06_JPRB, 0.90064941E-06_JPRB, 0.83563373E-06_JPRB, 0.76578345E-06_JPRB, 0.69410786E-06_JPRB, &
  & 0.62546280E-06_JPRB, 0.55282115E-06_JPRB, 0.47970859E-06_JPRB, 0.41193715E-06_JPRB, 0.35056526E-06_JPRB, 0.30002987E-06_JPRB, &
  & 0.25542907E-06_JPRB, 0.21545565E-06_JPRB, 0.17753291E-06_JPRB, 0.14733445E-06_JPRB, 0.12270717E-06_JPRB, 0.10532402E-06_JPRB, &
  & 0.93639776E-07_JPRB, 0.86192105E-07_JPRB, 0.80937155E-07_JPRB, 0.77167449E-07_JPRB, 0.73800326E-07_JPRB, 0.70427635E-07_JPRB, &
  & 0.68517917E-07_JPRB, 0.68711394E-07_JPRB, 0.70448197E-07_JPRB, 0.72949924E-07_JPRB, 0.76298194E-07_JPRB, 0.80754623E-07_JPRB, &
  & 0.86377483E-07_JPRB, 0.94716743E-07_JPRB, 0.10707145E-06_JPRB, 0.12453837E-06_JPRB, 0.14989970E-06_JPRB, 0.18771703E-06_JPRB, &
  & 0.25004833E-06_JPRB, 0.34702205E-06_JPRB, 0.47787972E-06_JPRB, 0.62775610E-06_JPRB, 0.76822063E-06_JPRB, 0.89763310E-06_JPRB, &
  & 0.10013128E-05_JPRB, 0.10795883E-05_JPRB, 0.11448453E-05_JPRB, 0.12061995E-05_JPRB, 0.12811883E-05_JPRB, 0.13738193E-05_JPRB, &
  & 0.14440630E-05_JPRB, 0.15003252E-05_JPRB, 0.15481271E-05_JPRB, 0.16143152E-05_JPRB, 0.17042378E-05_JPRB, 0.17796349E-05_JPRB, &
  & 0.18146363E-05_JPRB, 0.18357670E-05_JPRB, 0.18613013E-05_JPRB, 0.18352894E-05_JPRB  /)

RGHG7(:,41, 3) = (/ &
  & 0.89842006E-06_JPRB, 0.87303054E-06_JPRB, 0.87463702E-06_JPRB, 0.87356731E-06_JPRB, 0.86001522E-06_JPRB, 0.84114371E-06_JPRB, &
  & 0.81049382E-06_JPRB, 0.76910157E-06_JPRB, 0.72396408E-06_JPRB, 0.66843712E-06_JPRB, 0.60823609E-06_JPRB, 0.54510392E-06_JPRB, &
  & 0.48587623E-06_JPRB, 0.42393615E-06_JPRB, 0.36307688E-06_JPRB, 0.30829001E-06_JPRB, 0.25968866E-06_JPRB, 0.22256590E-06_JPRB, &
  & 0.19032540E-06_JPRB, 0.16182049E-06_JPRB, 0.13472417E-06_JPRB, 0.11296212E-06_JPRB, 0.94292036E-07_JPRB, 0.80921973E-07_JPRB, &
  & 0.72644398E-07_JPRB, 0.67658086E-07_JPRB, 0.63491129E-07_JPRB, 0.60113814E-07_JPRB, 0.56443479E-07_JPRB, 0.52910265E-07_JPRB, &
  & 0.50715172E-07_JPRB, 0.50872978E-07_JPRB, 0.52627616E-07_JPRB, 0.55682258E-07_JPRB, 0.59369410E-07_JPRB, 0.64182558E-07_JPRB, &
  & 0.69805418E-07_JPRB, 0.77894975E-07_JPRB, 0.88680116E-07_JPRB, 0.10177723E-06_JPRB, 0.12071762E-06_JPRB, 0.14817227E-06_JPRB, &
  & 0.19552138E-06_JPRB, 0.27758425E-06_JPRB, 0.39424451E-06_JPRB, 0.53120767E-06_JPRB, 0.65852710E-06_JPRB, 0.77363515E-06_JPRB, &
  & 0.87290935E-06_JPRB, 0.94422885E-06_JPRB, 0.10023158E-05_JPRB, 0.10569459E-05_JPRB, 0.11248537E-05_JPRB, 0.12113849E-05_JPRB, &
  & 0.12730852E-05_JPRB, 0.13175221E-05_JPRB, 0.13548365E-05_JPRB, 0.14116964E-05_JPRB, 0.14978022E-05_JPRB, 0.15710945E-05_JPRB, &
  & 0.16039022E-05_JPRB, 0.16241054E-05_JPRB, 0.16562390E-05_JPRB, 0.16349715E-05_JPRB  /)

RGHG7(:,42, 3) = (/ &
  & 0.83171796E-06_JPRB, 0.80913936E-06_JPRB, 0.80736258E-06_JPRB, 0.80376475E-06_JPRB, 0.79099948E-06_JPRB, 0.77501380E-06_JPRB, &
  & 0.74728055E-06_JPRB, 0.71160090E-06_JPRB, 0.67175836E-06_JPRB, 0.62361701E-06_JPRB, 0.57053308E-06_JPRB, 0.51341958E-06_JPRB, &
  & 0.45879582E-06_JPRB, 0.40295607E-06_JPRB, 0.34833332E-06_JPRB, 0.29845475E-06_JPRB, 0.25445767E-06_JPRB, 0.21932249E-06_JPRB, &
  & 0.18879438E-06_JPRB, 0.16099534E-06_JPRB, 0.13475334E-06_JPRB, 0.11250415E-06_JPRB, 0.93416629E-07_JPRB, 0.80121456E-07_JPRB, &
  & 0.71664745E-07_JPRB, 0.66038660E-07_JPRB, 0.61628727E-07_JPRB, 0.57950720E-07_JPRB, 0.54828280E-07_JPRB, 0.52180636E-07_JPRB, &
  & 0.50794993E-07_JPRB, 0.51335995E-07_JPRB, 0.53294339E-07_JPRB, 0.56049741E-07_JPRB, 0.59557842E-07_JPRB, 0.64144964E-07_JPRB, &
  & 0.69979939E-07_JPRB, 0.77589443E-07_JPRB, 0.88266104E-07_JPRB, 0.10188073E-06_JPRB, 0.12126437E-06_JPRB, 0.14920800E-06_JPRB, &
  & 0.19592656E-06_JPRB, 0.27504984E-06_JPRB, 0.39107594E-06_JPRB, 0.52313572E-06_JPRB, 0.64845714E-06_JPRB, 0.76045540E-06_JPRB, &
  & 0.85249284E-06_JPRB, 0.92113330E-06_JPRB, 0.97295904E-06_JPRB, 0.10229496E-05_JPRB, 0.10859426E-05_JPRB, 0.11609258E-05_JPRB, &
  & 0.12129050E-05_JPRB, 0.12507687E-05_JPRB, 0.12863170E-05_JPRB, 0.13382224E-05_JPRB, 0.14111832E-05_JPRB, 0.14741101E-05_JPRB, &
  & 0.14995831E-05_JPRB, 0.15188159E-05_JPRB, 0.15450615E-05_JPRB, 0.15333971E-05_JPRB  /)

RGHG7(:,43, 3) = (/ &
  & 0.68906582E-06_JPRB, 0.66446394E-06_JPRB, 0.65918600E-06_JPRB, 0.65338896E-06_JPRB, 0.64095797E-06_JPRB, 0.62810397E-06_JPRB, &
  & 0.60540253E-06_JPRB, 0.57862531E-06_JPRB, 0.54812504E-06_JPRB, 0.51080384E-06_JPRB, 0.46836412E-06_JPRB, 0.42041696E-06_JPRB, &
  & 0.37404466E-06_JPRB, 0.32837409E-06_JPRB, 0.28471223E-06_JPRB, 0.24489729E-06_JPRB, 0.21059436E-06_JPRB, 0.18304208E-06_JPRB, &
  & 0.15939311E-06_JPRB, 0.13717129E-06_JPRB, 0.11636575E-06_JPRB, 0.97301032E-07_JPRB, 0.80395133E-07_JPRB, 0.68894522E-07_JPRB, &
  & 0.61739747E-07_JPRB, 0.56588693E-07_JPRB, 0.52425072E-07_JPRB, 0.48641502E-07_JPRB, 0.45888532E-07_JPRB, 0.43979824E-07_JPRB, &
  & 0.43209962E-07_JPRB, 0.44085245E-07_JPRB, 0.46237120E-07_JPRB, 0.48957334E-07_JPRB, 0.52447842E-07_JPRB, 0.56982183E-07_JPRB, &
  & 0.63010689E-07_JPRB, 0.70074787E-07_JPRB, 0.79977323E-07_JPRB, 0.92184451E-07_JPRB, 0.10921053E-06_JPRB, 0.13314278E-06_JPRB, &
  & 0.17284145E-06_JPRB, 0.24286877E-06_JPRB, 0.35220925E-06_JPRB, 0.47424060E-06_JPRB, 0.59208468E-06_JPRB, 0.69509253E-06_JPRB, &
  & 0.77863220E-06_JPRB, 0.84183620E-06_JPRB, 0.88486507E-06_JPRB, 0.92773016E-06_JPRB, 0.98319305E-06_JPRB, 0.10450161E-05_JPRB, &
  & 0.10844510E-05_JPRB, 0.11112307E-05_JPRB, 0.11406563E-05_JPRB, 0.11840288E-05_JPRB, 0.12433544E-05_JPRB, 0.12959186E-05_JPRB, &
  & 0.13137560E-05_JPRB, 0.13317044E-05_JPRB, 0.13554165E-05_JPRB, 0.13545546E-05_JPRB  /)

RGHG7(:,44, 3) = (/ &
  & 0.62101627E-06_JPRB, 0.60105670E-06_JPRB, 0.59661434E-06_JPRB, 0.59006107E-06_JPRB, 0.57942679E-06_JPRB, 0.56637685E-06_JPRB, &
  & 0.54539795E-06_JPRB, 0.52240685E-06_JPRB, 0.49664415E-06_JPRB, 0.46520746E-06_JPRB, 0.42817924E-06_JPRB, 0.38546656E-06_JPRB, &
  & 0.34380131E-06_JPRB, 0.30251891E-06_JPRB, 0.26313464E-06_JPRB, 0.22744678E-06_JPRB, 0.19637987E-06_JPRB, 0.17137341E-06_JPRB, &
  & 0.14962846E-06_JPRB, 0.12889438E-06_JPRB, 0.10885716E-06_JPRB, 0.90416608E-07_JPRB, 0.74632617E-07_JPRB, 0.64092264E-07_JPRB, &
  & 0.57482594E-07_JPRB, 0.52741069E-07_JPRB, 0.48883536E-07_JPRB, 0.45407210E-07_JPRB, 0.42802684E-07_JPRB, 0.41198445E-07_JPRB, &
  & 0.40746718E-07_JPRB, 0.41728884E-07_JPRB, 0.43882018E-07_JPRB, 0.46537937E-07_JPRB, 0.50015242E-07_JPRB, 0.54365997E-07_JPRB, &
  & 0.60107808E-07_JPRB, 0.66921740E-07_JPRB, 0.76250915E-07_JPRB, 0.88015585E-07_JPRB, 0.10412872E-06_JPRB, 0.12621004E-06_JPRB, &
  & 0.16342924E-06_JPRB, 0.22894173E-06_JPRB, 0.33384849E-06_JPRB, 0.45068798E-06_JPRB, 0.56377699E-06_JPRB, 0.66407695E-06_JPRB, &
  & 0.74096670E-06_JPRB, 0.80037887E-06_JPRB, 0.84104968E-06_JPRB, 0.88052253E-06_JPRB, 0.93111498E-06_JPRB, 0.98447156E-06_JPRB, &
  & 0.10157657E-05_JPRB, 0.10376600E-05_JPRB, 0.10624379E-05_JPRB, 0.10999221E-05_JPRB, 0.11480529E-05_JPRB, 0.11906808E-05_JPRB, &
  & 0.12054478E-05_JPRB, 0.12181282E-05_JPRB, 0.12352030E-05_JPRB, 0.12348929E-05_JPRB  /)

RGHG7(:,45, 3) = (/ &
  & 0.52552663E-06_JPRB, 0.51059640E-06_JPRB, 0.50666302E-06_JPRB, 0.49897103E-06_JPRB, 0.49042440E-06_JPRB, 0.47754699E-06_JPRB, &
  & 0.45916472E-06_JPRB, 0.44160841E-06_JPRB, 0.42241922E-06_JPRB, 0.39904846E-06_JPRB, 0.36952543E-06_JPRB, 0.33392974E-06_JPRB, &
  & 0.29866547E-06_JPRB, 0.26366328E-06_JPRB, 0.23053333E-06_JPRB, 0.20081512E-06_JPRB, 0.17465678E-06_JPRB, 0.15350643E-06_JPRB, &
  & 0.13479807E-06_JPRB, 0.11646220E-06_JPRB, 0.97986410E-07_JPRB, 0.80658696E-07_JPRB, 0.66427503E-07_JPRB, 0.57207029E-07_JPRB, &
  & 0.51382385E-07_JPRB, 0.47167086E-07_JPRB, 0.43689126E-07_JPRB, 0.40549239E-07_JPRB, 0.38160380E-07_JPRB, 0.36996100E-07_JPRB, &
  & 0.36984332E-07_JPRB, 0.38130405E-07_JPRB, 0.40309419E-07_JPRB, 0.42887698E-07_JPRB, 0.46347749E-07_JPRB, 0.50482838E-07_JPRB, &
  & 0.55922717E-07_JPRB, 0.62382956E-07_JPRB, 0.70961612E-07_JPRB, 0.82044775E-07_JPRB, 0.96820775E-07_JPRB, 0.11628822E-06_JPRB, &
  & 0.14979796E-06_JPRB, 0.20902161E-06_JPRB, 0.30803637E-06_JPRB, 0.41769848E-06_JPRB, 0.52442965E-06_JPRB, 0.62051117E-06_JPRB, &
  & 0.68875700E-06_JPRB, 0.74316572E-06_JPRB, 0.78004079E-06_JPRB, 0.81475173E-06_JPRB, 0.85884830E-06_JPRB, 0.90090396E-06_JPRB, &
  & 0.92134574E-06_JPRB, 0.93627835E-06_JPRB, 0.95499169E-06_JPRB, 0.98469467E-06_JPRB, 0.10183586E-05_JPRB, 0.10483657E-05_JPRB, &
  & 0.10586727E-05_JPRB, 0.10651937E-05_JPRB, 0.10743923E-05_JPRB, 0.10760750E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART6',0,ZHOOK_HANDLE)



RGHG7(:,46, 3) = (/ &
  & 0.47099985E-06_JPRB, 0.46019022E-06_JPRB, 0.45726285E-06_JPRB, 0.44998404E-06_JPRB, 0.44210700E-06_JPRB, 0.42977101E-06_JPRB, &
  & 0.41262993E-06_JPRB, 0.39744640E-06_JPRB, 0.38162081E-06_JPRB, 0.36193831E-06_JPRB, 0.33614768E-06_JPRB, 0.30455518E-06_JPRB, &
  & 0.27250972E-06_JPRB, 0.24020507E-06_JPRB, 0.20997035E-06_JPRB, 0.18301771E-06_JPRB, 0.15935689E-06_JPRB, 0.14051911E-06_JPRB, &
  & 0.12393456E-06_JPRB, 0.10742794E-06_JPRB, 0.90338285E-07_JPRB, 0.74010205E-07_JPRB, 0.61056863E-07_JPRB, 0.52878806E-07_JPRB, &
  & 0.47640830E-07_JPRB, 0.43905205E-07_JPRB, 0.40803687E-07_JPRB, 0.37933218E-07_JPRB, 0.35645063E-07_JPRB, 0.34582714E-07_JPRB, &
  & 0.34729540E-07_JPRB, 0.35930994E-07_JPRB, 0.38038230E-07_JPRB, 0.40510749E-07_JPRB, 0.43810885E-07_JPRB, 0.47769719E-07_JPRB, &
  & 0.52888548E-07_JPRB, 0.58913160E-07_JPRB, 0.66872404E-07_JPRB, 0.77346219E-07_JPRB, 0.91039511E-07_JPRB, 0.10887921E-06_JPRB, &
  & 0.13948076E-06_JPRB, 0.19400351E-06_JPRB, 0.28640461E-06_JPRB, 0.38876194E-06_JPRB, 0.48847784E-06_JPRB, 0.57834085E-06_JPRB, &
  & 0.64083722E-06_JPRB, 0.69079543E-06_JPRB, 0.72629224E-06_JPRB, 0.75859001E-06_JPRB, 0.79852842E-06_JPRB, 0.83366648E-06_JPRB, &
  & 0.84939668E-06_JPRB, 0.86104130E-06_JPRB, 0.87669191E-06_JPRB, 0.90065161E-06_JPRB, 0.92572117E-06_JPRB, 0.94844187E-06_JPRB, &
  & 0.95789075E-06_JPRB, 0.95984308E-06_JPRB, 0.96429822E-06_JPRB, 0.96431972E-06_JPRB  /)

RGHG7(:,47, 3) = (/ &
  & 0.41522251E-06_JPRB, 0.40906604E-06_JPRB, 0.40741872E-06_JPRB, 0.40093562E-06_JPRB, 0.39356022E-06_JPRB, 0.38193346E-06_JPRB, &
  & 0.36597728E-06_JPRB, 0.35296465E-06_JPRB, 0.34044298E-06_JPRB, 0.32421143E-06_JPRB, 0.30204473E-06_JPRB, 0.27452591E-06_JPRB, &
  & 0.24562004E-06_JPRB, 0.21576305E-06_JPRB, 0.18825276E-06_JPRB, 0.16390347E-06_JPRB, 0.14269032E-06_JPRB, 0.12625696E-06_JPRB, &
  & 0.11198169E-06_JPRB, 0.97507587E-07_JPRB, 0.82009353E-07_JPRB, 0.66831589E-07_JPRB, 0.55322630E-07_JPRB, 0.48312188E-07_JPRB, &
  & 0.43722886E-07_JPRB, 0.40540797E-07_JPRB, 0.37880379E-07_JPRB, 0.35312624E-07_JPRB, 0.33119608E-07_JPRB, 0.32109153E-07_JPRB, &
  & 0.32385714E-07_JPRB, 0.33630413E-07_JPRB, 0.35633861E-07_JPRB, 0.37976645E-07_JPRB, 0.41060557E-07_JPRB, 0.44820463E-07_JPRB, &
  & 0.49558736E-07_JPRB, 0.55055759E-07_JPRB, 0.62314434E-07_JPRB, 0.72087680E-07_JPRB, 0.84561464E-07_JPRB, 0.10068866E-06_JPRB, &
  & 0.12803818E-06_JPRB, 0.17736289E-06_JPRB, 0.26185880E-06_JPRB, 0.35561904E-06_JPRB, 0.44697135E-06_JPRB, 0.52913675E-06_JPRB, &
  & 0.58546638E-06_JPRB, 0.63031303E-06_JPRB, 0.66467683E-06_JPRB, 0.69461342E-06_JPRB, 0.73014084E-06_JPRB, 0.75803969E-06_JPRB, &
  & 0.76947134E-06_JPRB, 0.77799367E-06_JPRB, 0.79065173E-06_JPRB, 0.80828036E-06_JPRB, 0.82444145E-06_JPRB, 0.83968076E-06_JPRB, &
  & 0.84884423E-06_JPRB, 0.84575419E-06_JPRB, 0.84527076E-06_JPRB, 0.84261107E-06_JPRB  /)

RGHG7(:,48, 3) = (/ &
  & 0.37681470E-06_JPRB, 0.37325708E-06_JPRB, 0.37104469E-06_JPRB, 0.36529894E-06_JPRB, 0.35880262E-06_JPRB, 0.34805283E-06_JPRB, &
  & 0.33298707E-06_JPRB, 0.32078815E-06_JPRB, 0.30968840E-06_JPRB, 0.29520002E-06_JPRB, 0.27520191E-06_JPRB, 0.24998825E-06_JPRB, &
  & 0.22285995E-06_JPRB, 0.19450526E-06_JPRB, 0.16878241E-06_JPRB, 0.14647513E-06_JPRB, 0.12728709E-06_JPRB, 0.11268441E-06_JPRB, &
  & 0.10060992E-06_JPRB, 0.88443561E-07_JPRB, 0.74823508E-07_JPRB, 0.61173915E-07_JPRB, 0.51011631E-07_JPRB, 0.44966127E-07_JPRB, &
  & 0.40957732E-07_JPRB, 0.38203840E-07_JPRB, 0.35836604E-07_JPRB, 0.33516073E-07_JPRB, 0.31413257E-07_JPRB, 0.30366762E-07_JPRB, &
  & 0.30669718E-07_JPRB, 0.31949734E-07_JPRB, 0.33843417E-07_JPRB, 0.36046152E-07_JPRB, 0.38942111E-07_JPRB, 0.42507734E-07_JPRB, &
  & 0.46828379E-07_JPRB, 0.51802469E-07_JPRB, 0.58442402E-07_JPRB, 0.67517349E-07_JPRB, 0.78823562E-07_JPRB, 0.93446487E-07_JPRB, &
  & 0.11803671E-06_JPRB, 0.16222294E-06_JPRB, 0.23764423E-06_JPRB, 0.32145222E-06_JPRB, 0.40318735E-06_JPRB, 0.47541795E-06_JPRB, &
  & 0.52543498E-06_JPRB, 0.56596390E-06_JPRB, 0.59849201E-06_JPRB, 0.62718446E-06_JPRB, 0.65995622E-06_JPRB, 0.68399208E-06_JPRB, &
  & 0.69392825E-06_JPRB, 0.70092240E-06_JPRB, 0.71233440E-06_JPRB, 0.72640415E-06_JPRB, 0.73920519E-06_JPRB, 0.75255113E-06_JPRB, &
  & 0.76108030E-06_JPRB, 0.75573275E-06_JPRB, 0.74962377E-06_JPRB, 0.74383675E-06_JPRB  /)

RGHG7(:,49, 3) = (/ &
  & 0.34217892E-06_JPRB, 0.34056527E-06_JPRB, 0.33688824E-06_JPRB, 0.33193251E-06_JPRB, 0.32658126E-06_JPRB, 0.31687891E-06_JPRB, &
  & 0.30266531E-06_JPRB, 0.29075044E-06_JPRB, 0.28036969E-06_JPRB, 0.26703527E-06_JPRB, 0.24877697E-06_JPRB, 0.22531200E-06_JPRB, &
  & 0.19953294E-06_JPRB, 0.17241211E-06_JPRB, 0.14824266E-06_JPRB, 0.12794149E-06_JPRB, 0.11080394E-06_JPRB, 0.97967706E-07_JPRB, &
  & 0.88281018E-07_JPRB, 0.78795390E-07_JPRB, 0.67385609E-07_JPRB, 0.55600101E-07_JPRB, 0.46884702E-07_JPRB, 0.41815624E-07_JPRB, &
  & 0.38419714E-07_JPRB, 0.36083022E-07_JPRB, 0.33973207E-07_JPRB, 0.31901220E-07_JPRB, 0.29896047E-07_JPRB, 0.28769663E-07_JPRB, &
  & 0.29054866E-07_JPRB, 0.30370388E-07_JPRB, 0.32139798E-07_JPRB, 0.34182755E-07_JPRB, 0.36883429E-07_JPRB, 0.40236014E-07_JPRB, &
  & 0.44077322E-07_JPRB, 0.48474433E-07_JPRB, 0.54466375E-07_JPRB, 0.62769059E-07_JPRB, 0.72805919E-07_JPRB, 0.85857686E-07_JPRB, &
  & 0.10761627E-06_JPRB, 0.14613924E-06_JPRB, 0.21097963E-06_JPRB, 0.28315040E-06_JPRB, 0.35366551E-06_JPRB, 0.41387720E-06_JPRB, &
  & 0.45683734E-06_JPRB, 0.49294571E-06_JPRB, 0.52312153E-06_JPRB, 0.55094407E-06_JPRB, 0.58141679E-06_JPRB, 0.60270979E-06_JPRB, &
  & 0.61226426E-06_JPRB, 0.61829086E-06_JPRB, 0.62911700E-06_JPRB, 0.64050602E-06_JPRB, 0.65210873E-06_JPRB, 0.66589849E-06_JPRB, &
  & 0.67356664E-06_JPRB, 0.66698524E-06_JPRB, 0.65433420E-06_JPRB, 0.64488115E-06_JPRB  /)

RGHG7(:,50, 3) = (/ &
  & 0.31272865E-06_JPRB, 0.31072964E-06_JPRB, 0.30509385E-06_JPRB, 0.30032150E-06_JPRB, 0.29572261E-06_JPRB, 0.28669454E-06_JPRB, &
  & 0.27335672E-06_JPRB, 0.26144532E-06_JPRB, 0.25150741E-06_JPRB, 0.23962631E-06_JPRB, 0.22333023E-06_JPRB, 0.20148423E-06_JPRB, &
  & 0.17694257E-06_JPRB, 0.15141367E-06_JPRB, 0.12928105E-06_JPRB, 0.11115034E-06_JPRB, 0.96079496E-07_JPRB, 0.84948809E-07_JPRB, &
  & 0.77384338E-07_JPRB, 0.70275374E-07_JPRB, 0.61102820E-07_JPRB, 0.51126908E-07_JPRB, 0.43718329E-07_JPRB, 0.39415684E-07_JPRB, &
  & 0.36499882E-07_JPRB, 0.34501549E-07_JPRB, 0.32597072E-07_JPRB, 0.30681367E-07_JPRB, 0.28768702E-07_JPRB, 0.27607537E-07_JPRB, &
  & 0.27840782E-07_JPRB, 0.29118880E-07_JPRB, 0.30827455E-07_JPRB, 0.32734507E-07_JPRB, 0.35284778E-07_JPRB, 0.38460963E-07_JPRB, &
  & 0.41923400E-07_JPRB, 0.45857785E-07_JPRB, 0.51303202E-07_JPRB, 0.58764880E-07_JPRB, 0.67780857E-07_JPRB, 0.79346705E-07_JPRB, &
  & 0.98578320E-07_JPRB, 0.13137524E-06_JPRB, 0.18558430E-06_JPRB, 0.24584659E-06_JPRB, 0.30515502E-06_JPRB, 0.35388434E-06_JPRB, &
  & 0.38960405E-06_JPRB, 0.42073606E-06_JPRB, 0.44779457E-06_JPRB, 0.47434899E-06_JPRB, 0.50329678E-06_JPRB, 0.52281296E-06_JPRB, &
  & 0.53235222E-06_JPRB, 0.53786047E-06_JPRB, 0.54917576E-06_JPRB, 0.55948038E-06_JPRB, 0.57100847E-06_JPRB, 0.58740388E-06_JPRB, &
  & 0.59378373E-06_JPRB, 0.58212878E-06_JPRB, 0.56535655E-06_JPRB, 0.55675544E-06_JPRB  /)

RGHG7(:,51, 3) = (/ &
  & 0.28359982E-06_JPRB, 0.27995957E-06_JPRB, 0.27194537E-06_JPRB, 0.26705247E-06_JPRB, 0.26306094E-06_JPRB, 0.25456604E-06_JPRB, &
  & 0.24218793E-06_JPRB, 0.23013281E-06_JPRB, 0.22052871E-06_JPRB, 0.21037694E-06_JPRB, 0.19632018E-06_JPRB, 0.17615715E-06_JPRB, &
  & 0.15289510E-06_JPRB, 0.12927635E-06_JPRB, 0.10960095E-06_JPRB, 0.93904284E-07_JPRB, 0.81077401E-07_JPRB, 0.71759499E-07_JPRB, &
  & 0.66350896E-07_JPRB, 0.61652796E-07_JPRB, 0.54914287E-07_JPRB, 0.46867067E-07_JPRB, 0.40798372E-07_JPRB, 0.37214350E-07_JPRB, &
  & 0.34748266E-07_JPRB, 0.33074472E-07_JPRB, 0.31364719E-07_JPRB, 0.29569557E-07_JPRB, 0.27754254E-07_JPRB, 0.26579180E-07_JPRB, &
  & 0.26738244E-07_JPRB, 0.27937525E-07_JPRB, 0.29613648E-07_JPRB, 0.31386247E-07_JPRB, 0.33797430E-07_JPRB, 0.36802073E-07_JPRB, &
  & 0.39907516E-07_JPRB, 0.43401455E-07_JPRB, 0.48309064E-07_JPRB, 0.54824941E-07_JPRB, 0.62867301E-07_JPRB, 0.72870723E-07_JPRB, &
  & 0.89529204E-07_JPRB, 0.11609960E-06_JPRB, 0.15878289E-06_JPRB, 0.20602187E-06_JPRB, 0.25321571E-06_JPRB, 0.28980726E-06_JPRB, &
  & 0.31759893E-06_JPRB, 0.34305614E-06_JPRB, 0.36634073E-06_JPRB, 0.39131418E-06_JPRB, 0.41901944E-06_JPRB, 0.43712156E-06_JPRB, &
  & 0.44683699E-06_JPRB, 0.45202071E-06_JPRB, 0.46443016E-06_JPRB, 0.47440096E-06_JPRB, 0.48643905E-06_JPRB, 0.50678920E-06_JPRB, &
  & 0.51155100E-06_JPRB, 0.49238991E-06_JPRB, 0.47243255E-06_JPRB, 0.46712784E-06_JPRB  /)

RGHG7(:,52, 3) = (/ &
  & 0.25404674E-06_JPRB, 0.24711981E-06_JPRB, 0.23744565E-06_JPRB, 0.23256776E-06_JPRB, 0.22930908E-06_JPRB, 0.22115587E-06_JPRB, &
  & 0.20900839E-06_JPRB, 0.19700869E-06_JPRB, 0.18801293E-06_JPRB, 0.18052019E-06_JPRB, 0.16930207E-06_JPRB, 0.15159011E-06_JPRB, &
  & 0.13056095E-06_JPRB, 0.10991069E-06_JPRB, 0.93137468E-07_JPRB, 0.79885446E-07_JPRB, 0.69294241E-07_JPRB, 0.61674538E-07_JPRB, &
  & 0.57804728E-07_JPRB, 0.54798301E-07_JPRB, 0.49993212E-07_JPRB, 0.43548304E-07_JPRB, 0.38543126E-07_JPRB, 0.35571624E-07_JPRB, &
  & 0.33505115E-07_JPRB, 0.32048832E-07_JPRB, 0.30466266E-07_JPRB, 0.28702574E-07_JPRB, 0.26969122E-07_JPRB, 0.25833572E-07_JPRB, &
  & 0.25936755E-07_JPRB, 0.27035788E-07_JPRB, 0.28710077E-07_JPRB, 0.30447576E-07_JPRB, 0.32785932E-07_JPRB, 0.35652842E-07_JPRB, &
  & 0.38449311E-07_JPRB, 0.41622447E-07_JPRB, 0.46047731E-07_JPRB, 0.51712519E-07_JPRB, 0.58976200E-07_JPRB, 0.67725222E-07_JPRB, &
  & 0.81750042E-07_JPRB, 0.10298356E-06_JPRB, 0.13624434E-06_JPRB, 0.17326488E-06_JPRB, 0.21001939E-06_JPRB, 0.23732743E-06_JPRB, &
  & 0.25870729E-06_JPRB, 0.27874924E-06_JPRB, 0.29808746E-06_JPRB, 0.31980988E-06_JPRB, 0.34514586E-06_JPRB, 0.36125884E-06_JPRB, &
  & 0.37034637E-06_JPRB, 0.37546860E-06_JPRB, 0.38685907E-06_JPRB, 0.39596593E-06_JPRB, 0.40935547E-06_JPRB, 0.43098703E-06_JPRB, &
  & 0.43376617E-06_JPRB, 0.41111184E-06_JPRB, 0.39033293E-06_JPRB, 0.38893290E-06_JPRB  /)

RGHG7(:,53, 3) = (/ &
  & 0.22170070E-06_JPRB, 0.21056156E-06_JPRB, 0.19935614E-06_JPRB, 0.19454674E-06_JPRB, 0.19213442E-06_JPRB, 0.18427963E-06_JPRB, &
  & 0.17210279E-06_JPRB, 0.16024008E-06_JPRB, 0.15201239E-06_JPRB, 0.14777298E-06_JPRB, 0.13987668E-06_JPRB, 0.12512941E-06_JPRB, &
  & 0.10689860E-06_JPRB, 0.89888146E-07_JPRB, 0.76446524E-07_JPRB, 0.65860761E-07_JPRB, 0.57700989E-07_JPRB, 0.51886515E-07_JPRB, &
  & 0.49455017E-07_JPRB, 0.48014100E-07_JPRB, 0.45121868E-07_JPRB, 0.40296285E-07_JPRB, 0.36342934E-07_JPRB, 0.33997636E-07_JPRB, &
  & 0.32346966E-07_JPRB, 0.31086372E-07_JPRB, 0.29616326E-07_JPRB, 0.27852634E-07_JPRB, 0.26202350E-07_JPRB, 0.25130400E-07_JPRB, &
  & 0.25179767E-07_JPRB, 0.26161388E-07_JPRB, 0.27845461E-07_JPRB, 0.29582960E-07_JPRB, 0.31867502E-07_JPRB, 0.34597429E-07_JPRB, &
  & 0.37075904E-07_JPRB, 0.39945723E-07_JPRB, 0.43867108E-07_JPRB, 0.48641513E-07_JPRB, 0.55132222E-07_JPRB, 0.62633728E-07_JPRB, &
  & 0.73767247E-07_JPRB, 0.89531270E-07_JPRB, 0.11334028E-06_JPRB, 0.14031220E-06_JPRB, 0.16634296E-06_JPRB, 0.18463954E-06_JPRB, &
  & 0.19962037E-06_JPRB, 0.21386504E-06_JPRB, 0.22883941E-06_JPRB, 0.24637898E-06_JPRB, 0.26870136E-06_JPRB, 0.28242693E-06_JPRB, &
  & 0.29052134E-06_JPRB, 0.29567782E-06_JPRB, 0.30514564E-06_JPRB, 0.31310773E-06_JPRB, 0.32829271E-06_JPRB, 0.35029118E-06_JPRB, &
  & 0.35077098E-06_JPRB, 0.32585645E-06_JPRB, 0.30509222E-06_JPRB, 0.30817835E-06_JPRB  /)

RGHG7(:,54, 3) = (/ &
  & 0.18889532E-06_JPRB, 0.17525674E-06_JPRB, 0.16380920E-06_JPRB, 0.16028874E-06_JPRB, 0.15860709E-06_JPRB, 0.15130335E-06_JPRB, &
  & 0.13902496E-06_JPRB, 0.12747208E-06_JPRB, 0.12029974E-06_JPRB, 0.11870930E-06_JPRB, 0.11385667E-06_JPRB, 0.10241046E-06_JPRB, &
  & 0.87938444E-07_JPRB, 0.74730028E-07_JPRB, 0.64377103E-07_JPRB, 0.56130882E-07_JPRB, 0.49898295E-07_JPRB, 0.45531974E-07_JPRB, &
  & 0.43965183E-07_JPRB, 0.43381532E-07_JPRB, 0.41670345E-07_JPRB, 0.37979989E-07_JPRB, 0.34762364E-07_JPRB, 0.32894004E-07_JPRB, &
  & 0.31616267E-07_JPRB, 0.30464401E-07_JPRB, 0.29018865E-07_JPRB, 0.27259361E-07_JPRB, 0.25584397E-07_JPRB, 0.24609249E-07_JPRB, &
  & 0.24654999E-07_JPRB, 0.25605308E-07_JPRB, 0.27263195E-07_JPRB, 0.29073992E-07_JPRB, 0.31430309E-07_JPRB, 0.34061927E-07_JPRB, &
  & 0.36272095E-07_JPRB, 0.38833280E-07_JPRB, 0.42343065E-07_JPRB, 0.46719298E-07_JPRB, 0.52411734E-07_JPRB, 0.58798629E-07_JPRB, &
  & 0.67610603E-07_JPRB, 0.79659006E-07_JPRB, 0.97708767E-07_JPRB, 0.11808322E-06_JPRB, 0.13667628E-06_JPRB, 0.14961636E-06_JPRB, &
  & 0.16055883E-06_JPRB, 0.17073267E-06_JPRB, 0.18199359E-06_JPRB, 0.19527140E-06_JPRB, 0.21405297E-06_JPRB, 0.22516493E-06_JPRB, &
  & 0.23170472E-06_JPRB, 0.23596012E-06_JPRB, 0.24329299E-06_JPRB, 0.24870635E-06_JPRB, 0.26418662E-06_JPRB, 0.28443766E-06_JPRB, &
  & 0.28342105E-06_JPRB, 0.25910220E-06_JPRB, 0.24122119E-06_JPRB, 0.24692590E-06_JPRB  /)

RGHG7(:,55, 3) = (/ &
  & 0.15249456E-06_JPRB, 0.13631250E-06_JPRB, 0.12476634E-06_JPRB, 0.12283425E-06_JPRB, 0.12194678E-06_JPRB, 0.11528670E-06_JPRB, &
  & 0.10288633E-06_JPRB, 0.91699399E-07_JPRB, 0.85733907E-07_JPRB, 0.86998389E-07_JPRB, 0.85480828E-07_JPRB, 0.77735626E-07_JPRB, &
  & 0.67553776E-07_JPRB, 0.58578426E-07_JPRB, 0.51615068E-07_JPRB, 0.45917512E-07_JPRB, 0.41753443E-07_JPRB, 0.38944351E-07_JPRB, &
  & 0.38259989E-07_JPRB, 0.38532813E-07_JPRB, 0.38033669E-07_JPRB, 0.35537188E-07_JPRB, 0.33092987E-07_JPRB, 0.31733321E-07_JPRB, &
  & 0.30863059E-07_JPRB, 0.29820199E-07_JPRB, 0.28390235E-07_JPRB, 0.26635922E-07_JPRB, 0.24919432E-07_JPRB, 0.24055885E-07_JPRB, &
  & 0.24104231E-07_JPRB, 0.25031182E-07_JPRB, 0.26655329E-07_JPRB, 0.28556964E-07_JPRB, 0.31009310E-07_JPRB, 0.33537113E-07_JPRB, &
  & 0.35456598E-07_JPRB, 0.37675192E-07_JPRB, 0.40741168E-07_JPRB, 0.44741070E-07_JPRB, 0.49545886E-07_JPRB, 0.54715548E-07_JPRB, &
  & 0.61030765E-07_JPRB, 0.69193883E-07_JPRB, 0.81349534E-07_JPRB, 0.94869587E-07_JPRB, 0.10565574E-06_JPRB, 0.11314292E-06_JPRB, &
  & 0.11992241E-06_JPRB, 0.12581387E-06_JPRB, 0.13304676E-06_JPRB, 0.14159319E-06_JPRB, 0.15638306E-06_JPRB, 0.16457003E-06_JPRB, &
  & 0.16931382E-06_JPRB, 0.17244801E-06_JPRB, 0.17738794E-06_JPRB, 0.17979325E-06_JPRB, 0.19540329E-06_JPRB, 0.21344047E-06_JPRB, &
  & 0.21087182E-06_JPRB, 0.18758853E-06_JPRB, 0.17327877E-06_JPRB, 0.18163855E-06_JPRB  /)

RGHG7(:,56, 3) = (/ &
  & 0.12317747E-06_JPRB, 0.10776459E-06_JPRB, 0.97793425E-07_JPRB, 0.97070543E-07_JPRB, 0.96615899E-07_JPRB, 0.91130582E-07_JPRB, &
  & 0.79907758E-07_JPRB, 0.70131140E-07_JPRB, 0.65337983E-07_JPRB, 0.67271184E-07_JPRB, 0.67271188E-07_JPRB, 0.62046573E-07_JPRB, &
  & 0.54978108E-07_JPRB, 0.48882221E-07_JPRB, 0.44216503E-07_JPRB, 0.40255220E-07_JPRB, 0.37255651E-07_JPRB, 0.35392281E-07_JPRB, &
  & 0.35114483E-07_JPRB, 0.35743083E-07_JPRB, 0.35740958E-07_JPRB, 0.33982046E-07_JPRB, 0.31998194E-07_JPRB, 0.30958759E-07_JPRB, &
  & 0.30346557E-07_JPRB, 0.29435550E-07_JPRB, 0.28027192E-07_JPRB, 0.26269460E-07_JPRB, 0.24458410E-07_JPRB, 0.23670977E-07_JPRB, &
  & 0.23720384E-07_JPRB, 0.24702895E-07_JPRB, 0.26404678E-07_JPRB, 0.28419653E-07_JPRB, 0.30930663E-07_JPRB, 0.33368911E-07_JPRB, &
  & 0.35150134E-07_JPRB, 0.37116421E-07_JPRB, 0.39885928E-07_JPRB, 0.43737481E-07_JPRB, 0.47611332E-07_JPRB, 0.51910577E-07_JPRB, &
  & 0.56963758E-07_JPRB, 0.63276255E-07_JPRB, 0.72667009E-07_JPRB, 0.82357582E-07_JPRB, 0.89695007E-07_JPRB, 0.94849853E-07_JPRB, &
  & 0.99393626E-07_JPRB, 0.10343279E-06_JPRB, 0.10863062E-06_JPRB, 0.11464241E-06_JPRB, 0.12615972E-06_JPRB, 0.13178047E-06_JPRB, &
  & 0.13499464E-06_JPRB, 0.13668121E-06_JPRB, 0.14030319E-06_JPRB, 0.14155047E-06_JPRB, 0.15485986E-06_JPRB, 0.16943992E-06_JPRB, &
  & 0.16677966E-06_JPRB, 0.14653954E-06_JPRB, 0.13547171E-06_JPRB, 0.14340857E-06_JPRB  /)

RGHG7(:,57, 3) = (/ &
  & 0.94471010E-07_JPRB, 0.80312891E-07_JPRB, 0.71994355E-07_JPRB, 0.72199399E-07_JPRB, 0.72126101E-07_JPRB, 0.67883504E-07_JPRB, &
  & 0.58069172E-07_JPRB, 0.49815366E-07_JPRB, 0.46185237E-07_JPRB, 0.48658193E-07_JPRB, 0.49931748E-07_JPRB, 0.47037200E-07_JPRB, &
  & 0.42823854E-07_JPRB, 0.39419288E-07_JPRB, 0.36905554E-07_JPRB, 0.34602960E-07_JPRB, 0.32773488E-07_JPRB, 0.31831306E-07_JPRB, &
  & 0.31966618E-07_JPRB, 0.32931529E-07_JPRB, 0.33421627E-07_JPRB, 0.32403633E-07_JPRB, 0.30897842E-07_JPRB, 0.30156236E-07_JPRB, &
  & 0.29800866E-07_JPRB, 0.29038911E-07_JPRB, 0.27631201E-07_JPRB, 0.25869550E-07_JPRB, 0.23993855E-07_JPRB, 0.23245088E-07_JPRB, &
  & 0.23319820E-07_JPRB, 0.24347350E-07_JPRB, 0.26151038E-07_JPRB, 0.28276252E-07_JPRB, 0.30852200E-07_JPRB, 0.33202264E-07_JPRB, &
  & 0.34845573E-07_JPRB, 0.36569715E-07_JPRB, 0.39055861E-07_JPRB, 0.42670530E-07_JPRB, 0.45658124E-07_JPRB, 0.49148372E-07_JPRB, &
  & 0.52993849E-07_JPRB, 0.57463832E-07_JPRB, 0.64057426E-07_JPRB, 0.70054221E-07_JPRB, 0.74141624E-07_JPRB, 0.77020120E-07_JPRB, &
  & 0.79520807E-07_JPRB, 0.81744235E-07_JPRB, 0.85031923E-07_JPRB, 0.88689603E-07_JPRB, 0.96971540E-07_JPRB, 0.10026204E-06_JPRB, &
  & 0.10202567E-06_JPRB, 0.10252006E-06_JPRB, 0.10492252E-06_JPRB, 0.10518171E-06_JPRB, 0.11618701E-06_JPRB, 0.12742491E-06_JPRB, &
  & 0.12475659E-06_JPRB, 0.10780883E-06_JPRB, 0.99754509E-07_JPRB, 0.10684920E-06_JPRB  /)

RGHG7(:,58, 3) = (/ &
  & 0.70433111E-07_JPRB, 0.58869961E-07_JPRB, 0.52516005E-07_JPRB, 0.53028162E-07_JPRB, 0.53150851E-07_JPRB, 0.50265343E-07_JPRB, &
  & 0.42379895E-07_JPRB, 0.35912194E-07_JPRB, 0.33329347E-07_JPRB, 0.35670972E-07_JPRB, 0.37362766E-07_JPRB, 0.36067765E-07_JPRB, &
  & 0.33823039E-07_JPRB, 0.32321766E-07_JPRB, 0.31336188E-07_JPRB, 0.30275516E-07_JPRB, 0.29361995E-07_JPRB, 0.29110816E-07_JPRB, &
  & 0.29547854E-07_JPRB, 0.30695282E-07_JPRB, 0.31495860E-07_JPRB, 0.31079295E-07_JPRB, 0.29984335E-07_JPRB, 0.29443430E-07_JPRB, &
  & 0.29294149E-07_JPRB, 0.28702588E-07_JPRB, 0.27261203E-07_JPRB, 0.25493491E-07_JPRB, 0.23598938E-07_JPRB, 0.22815823E-07_JPRB, &
  & 0.22954537E-07_JPRB, 0.24020456E-07_JPRB, 0.25979721E-07_JPRB, 0.28205286E-07_JPRB, 0.30844542E-07_JPRB, 0.33118500E-07_JPRB, &
  & 0.34664153E-07_JPRB, 0.36199717E-07_JPRB, 0.38475059E-07_JPRB, 0.41765105E-07_JPRB, 0.44005122E-07_JPRB, 0.46920206E-07_JPRB, &
  & 0.49978369E-07_JPRB, 0.53149184E-07_JPRB, 0.57702766E-07_JPRB, 0.61099204E-07_JPRB, 0.63350664E-07_JPRB, 0.64815498E-07_JPRB, &
  & 0.66124102E-07_JPRB, 0.67195182E-07_JPRB, 0.69310993E-07_JPRB, 0.71520662E-07_JPRB, 0.77025112E-07_JPRB, 0.78638614E-07_JPRB, &
  & 0.79251921E-07_JPRB, 0.79020278E-07_JPRB, 0.80669105E-07_JPRB, 0.80653506E-07_JPRB, 0.89078659E-07_JPRB, 0.97204344E-07_JPRB, &
  & 0.94943483E-07_JPRB, 0.81820495E-07_JPRB, 0.76089725E-07_JPRB, 0.81124878E-07_JPRB  /)

RGHG7(:,59, 3) = (/ &
  & 0.52907732E-07_JPRB, 0.44151023E-07_JPRB, 0.39431937E-07_JPRB, 0.39855379E-07_JPRB, 0.40042320E-07_JPRB, 0.38150959E-07_JPRB, &
  & 0.32043530E-07_JPRB, 0.27094660E-07_JPRB, 0.25208733E-07_JPRB, 0.27243697E-07_JPRB, 0.28970369E-07_JPRB, 0.28642841E-07_JPRB, &
  & 0.27597929E-07_JPRB, 0.27257972E-07_JPRB, 0.27215619E-07_JPRB, 0.27018791E-07_JPRB, 0.26781501E-07_JPRB, 0.27019372E-07_JPRB, &
  & 0.27641932E-07_JPRB, 0.28840485E-07_JPRB, 0.29889830E-07_JPRB, 0.29931662E-07_JPRB, 0.29224806E-07_JPRB, 0.28758681E-07_JPRB, &
  & 0.28730942E-07_JPRB, 0.28278598E-07_JPRB, 0.26857981E-07_JPRB, 0.25106607E-07_JPRB, 0.23239473E-07_JPRB, 0.22391750E-07_JPRB, &
  & 0.22561321E-07_JPRB, 0.23673985E-07_JPRB, 0.25711446E-07_JPRB, 0.28052821E-07_JPRB, 0.30761985E-07_JPRB, 0.33072790E-07_JPRB, &
  & 0.34621424E-07_JPRB, 0.36041689E-07_JPRB, 0.38123271E-07_JPRB, 0.40961485E-07_JPRB, 0.42739293E-07_JPRB, 0.45261808E-07_JPRB, &
  & 0.47713978E-07_JPRB, 0.50018875E-07_JPRB, 0.53120454E-07_JPRB, 0.55003629E-07_JPRB, 0.56237308E-07_JPRB, 0.56975845E-07_JPRB, &
  & 0.57574626E-07_JPRB, 0.57983471E-07_JPRB, 0.59297008E-07_JPRB, 0.60660879E-07_JPRB, 0.64278607E-07_JPRB, 0.64942864E-07_JPRB, &
  & 0.64900688E-07_JPRB, 0.64392835E-07_JPRB, 0.65556581E-07_JPRB, 0.65513459E-07_JPRB, 0.71841991E-07_JPRB, 0.77786180E-07_JPRB, &
  & 0.75999932E-07_JPRB, 0.66139183E-07_JPRB, 0.61984119E-07_JPRB, 0.65228044E-07_JPRB  /)

RGHG7(:,60, 3) = (/ &
  & 0.38144441E-07_JPRB, 0.32200233E-07_JPRB, 0.28954688E-07_JPRB, 0.29140183E-07_JPRB, 0.29332969E-07_JPRB, 0.28249297E-07_JPRB, &
  & 0.23826691E-07_JPRB, 0.20253256E-07_JPRB, 0.18914022E-07_JPRB, 0.20581307E-07_JPRB, 0.22203805E-07_JPRB, 0.22578639E-07_JPRB, &
  & 0.22435089E-07_JPRB, 0.22954728E-07_JPRB, 0.23623377E-07_JPRB, 0.24142680E-07_JPRB, 0.24480797E-07_JPRB, 0.25120651E-07_JPRB, &
  & 0.25882134E-07_JPRB, 0.27081360E-07_JPRB, 0.28355718E-07_JPRB, 0.28804713E-07_JPRB, 0.28481285E-07_JPRB, 0.28049618E-07_JPRB, &
  & 0.28092910E-07_JPRB, 0.27771003E-07_JPRB, 0.26406708E-07_JPRB, 0.24684448E-07_JPRB, 0.22872897E-07_JPRB, 0.21944794E-07_JPRB, &
  & 0.22116601E-07_JPRB, 0.23284729E-07_JPRB, 0.25363847E-07_JPRB, 0.27829603E-07_JPRB, 0.30611067E-07_JPRB, 0.33034042E-07_JPRB, &
  & 0.34615701E-07_JPRB, 0.35926747E-07_JPRB, 0.37856857E-07_JPRB, 0.40204834E-07_JPRB, 0.41636594E-07_JPRB, 0.43812171E-07_JPRB, &
  & 0.45713472E-07_JPRB, 0.47318897E-07_JPRB, 0.49213446E-07_JPRB, 0.50022625E-07_JPRB, 0.50570275E-07_JPRB, 0.50853713E-07_JPRB, &
  & 0.50910586E-07_JPRB, 0.50855341E-07_JPRB, 0.51517803E-07_JPRB, 0.52259814E-07_JPRB, 0.54362873E-07_JPRB, 0.54380873E-07_JPRB, &
  & 0.53899070E-07_JPRB, 0.53289331E-07_JPRB, 0.54080456E-07_JPRB, 0.54084943E-07_JPRB, 0.58553671E-07_JPRB, 0.62691868E-07_JPRB, &
  & 0.61403270E-07_JPRB, 0.54522444E-07_JPRB, 0.51670798E-07_JPRB, 0.53366026E-07_JPRB  /)

RGHG7(:,61, 3) = (/ &
  & 0.28770487E-07_JPRB, 0.24942523E-07_JPRB, 0.22693029E-07_JPRB, 0.22571822E-07_JPRB, 0.22698156E-07_JPRB, 0.21991290E-07_JPRB, &
  & 0.18793301E-07_JPRB, 0.16127558E-07_JPRB, 0.15078231E-07_JPRB, 0.16410334E-07_JPRB, 0.17864145E-07_JPRB, 0.18547872E-07_JPRB, &
  & 0.18917683E-07_JPRB, 0.19868166E-07_JPRB, 0.20927494E-07_JPRB, 0.21924376E-07_JPRB, 0.22637838E-07_JPRB, 0.23515751E-07_JPRB, &
  & 0.24350989E-07_JPRB, 0.25511512E-07_JPRB, 0.26956017E-07_JPRB, 0.27719016E-07_JPRB, 0.27727118E-07_JPRB, 0.27319549E-07_JPRB, &
  & 0.27323408E-07_JPRB, 0.27114689E-07_JPRB, 0.25873804E-07_JPRB, 0.24199741E-07_JPRB, 0.22491154E-07_JPRB, 0.21469580E-07_JPRB, &
  & 0.21568362E-07_JPRB, 0.22808054E-07_JPRB, 0.24871107E-07_JPRB, 0.27456622E-07_JPRB, 0.30300157E-07_JPRB, 0.32981639E-07_JPRB, &
  & 0.34585935E-07_JPRB, 0.35737058E-07_JPRB, 0.37691266E-07_JPRB, 0.39632498E-07_JPRB, 0.40886078E-07_JPRB, 0.42725014E-07_JPRB, &
  & 0.44158959E-07_JPRB, 0.45307252E-07_JPRB, 0.46443078E-07_JPRB, 0.46765186E-07_JPRB, 0.47053599E-07_JPRB, 0.47190259E-07_JPRB, &
  & 0.46865944E-07_JPRB, 0.46608423E-07_JPRB, 0.46872902E-07_JPRB, 0.47243220E-07_JPRB, 0.48464145E-07_JPRB, 0.48253579E-07_JPRB, &
  & 0.47656397E-07_JPRB, 0.47102157E-07_JPRB, 0.47699038E-07_JPRB, 0.47736386E-07_JPRB, 0.50998022E-07_JPRB, 0.53972942E-07_JPRB, &
  & 0.53110806E-07_JPRB, 0.48291456E-07_JPRB, 0.46370869E-07_JPRB, 0.47416911E-07_JPRB  /)

RGHG7(:,62, 3) = (/ &
  & 0.22385120E-07_JPRB, 0.20052441E-07_JPRB, 0.18433696E-07_JPRB, 0.18053580E-07_JPRB, 0.18053768E-07_JPRB, 0.17527594E-07_JPRB, &
  & 0.15169450E-07_JPRB, 0.13119232E-07_JPRB, 0.12231475E-07_JPRB, 0.13291499E-07_JPRB, 0.14583678E-07_JPRB, 0.15411806E-07_JPRB, &
  & 0.16121330E-07_JPRB, 0.17315024E-07_JPRB, 0.18642072E-07_JPRB, 0.19971747E-07_JPRB, 0.20935754E-07_JPRB, 0.21965525E-07_JPRB, &
  & 0.22877140E-07_JPRB, 0.23984211E-07_JPRB, 0.25547525E-07_JPRB, 0.26574267E-07_JPRB, 0.26864736E-07_JPRB, 0.26490414E-07_JPRB, &
  & 0.26406550E-07_JPRB, 0.26314898E-07_JPRB, 0.25226498E-07_JPRB, 0.23647038E-07_JPRB, 0.22014425E-07_JPRB, 0.20881533E-07_JPRB, &
  & 0.20947129E-07_JPRB, 0.22293373E-07_JPRB, 0.24270382E-07_JPRB, 0.26862436E-07_JPRB, 0.29840299E-07_JPRB, 0.32791234E-07_JPRB, &
  & 0.34416998E-07_JPRB, 0.35543112E-07_JPRB, 0.37571651E-07_JPRB, 0.39121547E-07_JPRB, 0.40247488E-07_JPRB, 0.41760939E-07_JPRB, &
  & 0.42816418E-07_JPRB, 0.43606796E-07_JPRB, 0.44265681E-07_JPRB, 0.44344129E-07_JPRB, 0.44475320E-07_JPRB, 0.44465115E-07_JPRB, &
  & 0.43903689E-07_JPRB, 0.43545559E-07_JPRB, 0.43532350E-07_JPRB, 0.43673191E-07_JPRB, 0.44276042E-07_JPRB, 0.43969095E-07_JPRB, &
  & 0.43338540E-07_JPRB, 0.42874004E-07_JPRB, 0.43356670E-07_JPRB, 0.43421710E-07_JPRB, 0.45861586E-07_JPRB, 0.47984545E-07_JPRB, &
  & 0.47460029E-07_JPRB, 0.44160538E-07_JPRB, 0.43004738E-07_JPRB, 0.43755525E-07_JPRB  /)

RGHG7(:,63, 3) = (/ &
  & 0.17870937E-07_JPRB, 0.16609401E-07_JPRB, 0.15392781E-07_JPRB, 0.14802402E-07_JPRB, 0.14639450E-07_JPRB, 0.14181267E-07_JPRB, &
  & 0.12401494E-07_JPRB, 0.10775592E-07_JPRB, 0.99651668E-08_JPRB, 0.10798405E-07_JPRB, 0.11931491E-07_JPRB, 0.12812777E-07_JPRB, &
  & 0.13741812E-07_JPRB, 0.15068605E-07_JPRB, 0.16581037E-07_JPRB, 0.18144444E-07_JPRB, 0.19290607E-07_JPRB, 0.20429240E-07_JPRB, &
  & 0.21422552E-07_JPRB, 0.22470353E-07_JPRB, 0.24109952E-07_JPRB, 0.25365209E-07_JPRB, 0.25886975E-07_JPRB, 0.25546306E-07_JPRB, &
  & 0.25364771E-07_JPRB, 0.25385716E-07_JPRB, 0.24480202E-07_JPRB, 0.23033583E-07_JPRB, 0.21443393E-07_JPRB, 0.20171997E-07_JPRB, &
  & 0.20232993E-07_JPRB, 0.21698691E-07_JPRB, 0.23582164E-07_JPRB, 0.26142527E-07_JPRB, 0.29312021E-07_JPRB, 0.32456759E-07_JPRB, &
  & 0.34150525E-07_JPRB, 0.35339844E-07_JPRB, 0.37396709E-07_JPRB, 0.38617724E-07_JPRB, 0.39637755E-07_JPRB, 0.40835515E-07_JPRB, &
  & 0.41580511E-07_JPRB, 0.42083858E-07_JPRB, 0.42457235E-07_JPRB, 0.42425078E-07_JPRB, 0.42438402E-07_JPRB, 0.42285737E-07_JPRB, &
  & 0.41582676E-07_JPRB, 0.41175079E-07_JPRB, 0.40959825E-07_JPRB, 0.40946986E-07_JPRB, 0.41105501E-07_JPRB, 0.40759123E-07_JPRB, &
  & 0.40140293E-07_JPRB, 0.39788023E-07_JPRB, 0.40189823E-07_JPRB, 0.40297140E-07_JPRB, 0.42161802E-07_JPRB, 0.43641817E-07_JPRB, &
  & 0.43391145E-07_JPRB, 0.41285530E-07_JPRB, 0.40773663E-07_JPRB, 0.41377517E-07_JPRB  /)

RGHG7(:,64, 3) = (/ &
  & 0.15131793E-07_JPRB, 0.14479246E-07_JPRB, 0.13453908E-07_JPRB, 0.12733745E-07_JPRB, 0.12383104E-07_JPRB, 0.11910545E-07_JPRB, &
  & 0.10429476E-07_JPRB, 0.90343904E-08_JPRB, 0.82199721E-08_JPRB, 0.88834919E-08_JPRB, 0.98628334E-08_JPRB, 0.10736532E-07_JPRB, &
  & 0.11755018E-07_JPRB, 0.13127735E-07_JPRB, 0.14739203E-07_JPRB, 0.16428800E-07_JPRB, 0.17707543E-07_JPRB, 0.18932033E-07_JPRB, &
  & 0.20014397E-07_JPRB, 0.21005892E-07_JPRB, 0.22665458E-07_JPRB, 0.24104010E-07_JPRB, 0.24771135E-07_JPRB, 0.24454425E-07_JPRB, &
  & 0.24203805E-07_JPRB, 0.24317796E-07_JPRB, 0.23633914E-07_JPRB, 0.22362604E-07_JPRB, 0.20757239E-07_JPRB, 0.19303346E-07_JPRB, &
  & 0.19390299E-07_JPRB, 0.20967012E-07_JPRB, 0.22813747E-07_JPRB, 0.25364525E-07_JPRB, 0.28786799E-07_JPRB, 0.31917961E-07_JPRB, &
  & 0.33794223E-07_JPRB, 0.35125706E-07_JPRB, 0.37043602E-07_JPRB, 0.38088509E-07_JPRB, 0.39009105E-07_JPRB, 0.39916547E-07_JPRB, &
  & 0.40441509E-07_JPRB, 0.40743990E-07_JPRB, 0.41031110E-07_JPRB, 0.40974593E-07_JPRB, 0.40868117E-07_JPRB, 0.40589661E-07_JPRB, &
  & 0.39840676E-07_JPRB, 0.39408720E-07_JPRB, 0.39064480E-07_JPRB, 0.38947014E-07_JPRB, 0.38840769E-07_JPRB, 0.38462844E-07_JPRB, &
  & 0.37883548E-07_JPRB, 0.37660264E-07_JPRB, 0.37985391E-07_JPRB, 0.38174971E-07_JPRB, 0.39706187E-07_JPRB, 0.40770093E-07_JPRB, &
  & 0.40714697E-07_JPRB, 0.39499203E-07_JPRB, 0.39475326E-07_JPRB, 0.39944604E-07_JPRB  /)

RGHG7(:,65, 3) = (/ &
  & 0.13684338E-07_JPRB, 0.13220967E-07_JPRB, 0.12265717E-07_JPRB, 0.11515132E-07_JPRB, 0.11006593E-07_JPRB, 0.10447814E-07_JPRB, &
  & 0.90659058E-08_JPRB, 0.77536108E-08_JPRB, 0.68983724E-08_JPRB, 0.74150387E-08_JPRB, 0.82506133E-08_JPRB, 0.90821003E-08_JPRB, &
  & 0.10103376E-07_JPRB, 0.11447659E-07_JPRB, 0.13073804E-07_JPRB, 0.14793174E-07_JPRB, 0.16174658E-07_JPRB, 0.17516511E-07_JPRB, &
  & 0.18682287E-07_JPRB, 0.19671311E-07_JPRB, 0.21239121E-07_JPRB, 0.22762757E-07_JPRB, 0.23530632E-07_JPRB, 0.23248473E-07_JPRB, &
  & 0.23030081E-07_JPRB, 0.23189508E-07_JPRB, 0.22786187E-07_JPRB, 0.21662903E-07_JPRB, 0.20005080E-07_JPRB, 0.18390714E-07_JPRB, &
  & 0.18452530E-07_JPRB, 0.20108399E-07_JPRB, 0.22017724E-07_JPRB, 0.24701198E-07_JPRB, 0.28309420E-07_JPRB, 0.31352936E-07_JPRB, &
  & 0.33326857E-07_JPRB, 0.34829837E-07_JPRB, 0.36456801E-07_JPRB, 0.37454717E-07_JPRB, 0.38307085E-07_JPRB, 0.38983693E-07_JPRB, &
  & 0.39402534E-07_JPRB, 0.39654261E-07_JPRB, 0.39947015E-07_JPRB, 0.39853687E-07_JPRB, 0.39623151E-07_JPRB, 0.39249537E-07_JPRB, &
  & 0.38508543E-07_JPRB, 0.38073227E-07_JPRB, 0.37652911E-07_JPRB, 0.37448605E-07_JPRB, 0.37180022E-07_JPRB, 0.36784433E-07_JPRB, &
  & 0.36273964E-07_JPRB, 0.36164666E-07_JPRB, 0.36428891E-07_JPRB, 0.36766034E-07_JPRB, 0.38130002E-07_JPRB, 0.39002836E-07_JPRB, &
  & 0.39074330E-07_JPRB, 0.38477731E-07_JPRB, 0.38783141E-07_JPRB, 0.39115701E-07_JPRB  /)

RGHG7(:,66, 3) = (/ &
  & 0.12745906E-07_JPRB, 0.12300950E-07_JPRB, 0.11371394E-07_JPRB, 0.10628799E-07_JPRB, 0.99985325E-08_JPRB, 0.93282536E-08_JPRB, &
  & 0.79738243E-08_JPRB, 0.66819140E-08_JPRB, 0.57892099E-08_JPRB, 0.61643216E-08_JPRB, 0.68552312E-08_JPRB, 0.76285936E-08_JPRB, &
  & 0.86140037E-08_JPRB, 0.98997696E-08_JPRB, 0.11483796E-07_JPRB, 0.13185636E-07_JPRB, 0.14637846E-07_JPRB, 0.16082834E-07_JPRB, &
  & 0.17341591E-07_JPRB, 0.18373163E-07_JPRB, 0.19821899E-07_JPRB, 0.21381113E-07_JPRB, 0.22213874E-07_JPRB, 0.22017507E-07_JPRB, &
  & 0.21916672E-07_JPRB, 0.22104326E-07_JPRB, 0.21926472E-07_JPRB, 0.20942984E-07_JPRB, 0.19232112E-07_JPRB, 0.17543798E-07_JPRB, &
  & 0.17666901E-07_JPRB, 0.19386506E-07_JPRB, 0.21356196E-07_JPRB, 0.24114552E-07_JPRB, 0.27820637E-07_JPRB, 0.30816114E-07_JPRB, &
  & 0.32824975E-07_JPRB, 0.34404535E-07_JPRB, 0.35784386E-07_JPRB, 0.36751889E-07_JPRB, 0.37559501E-07_JPRB, 0.38078778E-07_JPRB, &
  & 0.38455386E-07_JPRB, 0.38716103E-07_JPRB, 0.39005234E-07_JPRB, 0.38837480E-07_JPRB, 0.38490420E-07_JPRB, 0.38046811E-07_JPRB, &
  & 0.37328304E-07_JPRB, 0.36891824E-07_JPRB, 0.36419928E-07_JPRB, 0.36123002E-07_JPRB, 0.35746266E-07_JPRB, 0.35341200E-07_JPRB, &
  & 0.34911172E-07_JPRB, 0.34914522E-07_JPRB, 0.35152055E-07_JPRB, 0.35664204E-07_JPRB, 0.36925110E-07_JPRB, 0.37694430E-07_JPRB, &
  & 0.37896977E-07_JPRB, 0.37766492E-07_JPRB, 0.38323473E-07_JPRB, 0.38523345E-07_JPRB  /)

RGHG7(:,67, 3) = (/ &
  & 0.12192414E-07_JPRB, 0.11645607E-07_JPRB, 0.10717025E-07_JPRB, 0.10007783E-07_JPRB, 0.92914781E-08_JPRB, 0.85017394E-08_JPRB, &
  & 0.71247383E-08_JPRB, 0.58044021E-08_JPRB, 0.48813508E-08_JPRB, 0.51236862E-08_JPRB, 0.56691073E-08_JPRB, 0.63734641E-08_JPRB, &
  & 0.72883871E-08_JPRB, 0.84910901E-08_JPRB, 0.99809585E-08_JPRB, 0.11621164E-07_JPRB, 0.13106364E-07_JPRB, 0.14621955E-07_JPRB, &
  & 0.15981251E-07_JPRB, 0.17094481E-07_JPRB, 0.18421837E-07_JPRB, 0.19975367E-07_JPRB, 0.20859226E-07_JPRB, 0.20787089E-07_JPRB, &
  & 0.20854387E-07_JPRB, 0.21072064E-07_JPRB, 0.21041515E-07_JPRB, 0.20191757E-07_JPRB, 0.18429398E-07_JPRB, 0.16765460E-07_JPRB, &
  & 0.17017270E-07_JPRB, 0.18806263E-07_JPRB, 0.20842611E-07_JPRB, 0.23576248E-07_JPRB, 0.27278360E-07_JPRB, 0.30250420E-07_JPRB, &
  & 0.32259606E-07_JPRB, 0.33821260E-07_JPRB, 0.35050158E-07_JPRB, 0.35999714E-07_JPRB, 0.36769500E-07_JPRB, 0.37208540E-07_JPRB, &
  & 0.37606872E-07_JPRB, 0.37919445E-07_JPRB, 0.38186621E-07_JPRB, 0.37905908E-07_JPRB, 0.37453699E-07_JPRB, 0.36963291E-07_JPRB, &
  & 0.36271878E-07_JPRB, 0.35834774E-07_JPRB, 0.35326860E-07_JPRB, 0.34937296E-07_JPRB, 0.34499567E-07_JPRB, 0.34092572E-07_JPRB, &
  & 0.33752718E-07_JPRB, 0.33862577E-07_JPRB, 0.34120123E-07_JPRB, 0.34821933E-07_JPRB, 0.36032443E-07_JPRB, 0.36766789E-07_JPRB, &
  & 0.37101505E-07_JPRB, 0.37295758E-07_JPRB, 0.38032308E-07_JPRB, 0.38119818E-07_JPRB  /)

RGHG7(:,68, 3) = (/ &
  & 0.11879885E-07_JPRB, 0.11176850E-07_JPRB, 0.10253599E-07_JPRB, 0.95857715E-08_JPRB, 0.88137004E-08_JPRB, 0.79239103E-08_JPRB, &
  & 0.64985238E-08_JPRB, 0.51158605E-08_JPRB, 0.41690265E-08_JPRB, 0.42961389E-08_JPRB, 0.46955834E-08_JPRB, 0.53269519E-08_JPRB, &
  & 0.61369031E-08_JPRB, 0.72354543E-08_JPRB, 0.85854969E-08_JPRB, 0.10118680E-07_JPRB, 0.11589529E-07_JPRB, 0.13114960E-07_JPRB, &
  & 0.14575948E-07_JPRB, 0.15797841E-07_JPRB, 0.17037857E-07_JPRB, 0.18554893E-07_JPRB, 0.19524041E-07_JPRB, 0.19578199E-07_JPRB, &
  & 0.19791063E-07_JPRB, 0.20076398E-07_JPRB, 0.20093414E-07_JPRB, 0.19374460E-07_JPRB, 0.17558796E-07_JPRB, 0.16025663E-07_JPRB, &
  & 0.16402946E-07_JPRB, 0.18310443E-07_JPRB, 0.20459144E-07_JPRB, 0.23021792E-07_JPRB, 0.26597609E-07_JPRB, 0.29513903E-07_JPRB, &
  & 0.31547692E-07_JPRB, 0.33027336E-07_JPRB, 0.34269766E-07_JPRB, 0.35226293E-07_JPRB, 0.35929651E-07_JPRB, 0.36365411E-07_JPRB, &
  & 0.36856413E-07_JPRB, 0.37243205E-07_JPRB, 0.37471016E-07_JPRB, 0.37042277E-07_JPRB, 0.36500268E-07_JPRB, 0.35981156E-07_JPRB, &
  & 0.35307785E-07_JPRB, 0.34870682E-07_JPRB, 0.34327093E-07_JPRB, 0.33860850E-07_JPRB, 0.33400158E-07_JPRB, 0.32998084E-07_JPRB, &
  & 0.32758282E-07_JPRB, 0.32957121E-07_JPRB, 0.33302827E-07_JPRB, 0.34190388E-07_JPRB, 0.35394747E-07_JPRB, 0.36144265E-07_JPRB, &
  & 0.36592973E-07_JPRB, 0.36984049E-07_JPRB, 0.37830901E-07_JPRB, 0.37858135E-07_JPRB  /)

RGHG7(:,69, 3) = (/ &
  & 0.11651560E-07_JPRB, 0.10835990E-07_JPRB, 0.99430721E-08_JPRB, 0.93140397E-08_JPRB, 0.85003940E-08_JPRB, 0.75408000E-08_JPRB, &
  & 0.60554678E-08_JPRB, 0.46082497E-08_JPRB, 0.36439818E-08_JPRB, 0.36693274E-08_JPRB, 0.39429750E-08_JPRB, 0.44883067E-08_JPRB, &
  & 0.51873341E-08_JPRB, 0.61548825E-08_JPRB, 0.73427331E-08_JPRB, 0.87271158E-08_JPRB, 0.10126889E-07_JPRB, 0.11601702E-07_JPRB, &
  & 0.13128535E-07_JPRB, 0.14445636E-07_JPRB, 0.15652815E-07_JPRB, 0.17096043E-07_JPRB, 0.18170992E-07_JPRB, 0.18339478E-07_JPRB, &
  & 0.18628094E-07_JPRB, 0.18927333E-07_JPRB, 0.18990414E-07_JPRB, 0.18349620E-07_JPRB, 0.16604934E-07_JPRB, 0.15204448E-07_JPRB, &
  & 0.15620227E-07_JPRB, 0.17603661E-07_JPRB, 0.19854991E-07_JPRB, 0.22297808E-07_JPRB, 0.25658907E-07_JPRB, 0.28503397E-07_JPRB, &
  & 0.30605075E-07_JPRB, 0.32091547E-07_JPRB, 0.33424011E-07_JPRB, 0.34409526E-07_JPRB, 0.35080803E-07_JPRB, 0.35586804E-07_JPRB, &
  & 0.36189865E-07_JPRB, 0.36631455E-07_JPRB, 0.36821402E-07_JPRB, 0.36252501E-07_JPRB, 0.35630411E-07_JPRB, 0.35084467E-07_JPRB, &
  & 0.34409355E-07_JPRB, 0.33971506E-07_JPRB, 0.33387771E-07_JPRB, 0.32874346E-07_JPRB, 0.32421299E-07_JPRB, 0.32041311E-07_JPRB, &
  & 0.31897063E-07_JPRB, 0.32172551E-07_JPRB, 0.32664246E-07_JPRB, 0.33702444E-07_JPRB, 0.34934987E-07_JPRB, 0.35749310E-07_JPRB, &
  & 0.36273550E-07_JPRB, 0.36769605E-07_JPRB, 0.37622244E-07_JPRB, 0.37703784E-07_JPRB  /)

RGHG7(:,70, 3) = (/ &
  & 0.11446032E-07_JPRB, 0.10563000E-07_JPRB, 0.97172425E-08_JPRB, 0.91222967E-08_JPRB, 0.82672023E-08_JPRB, 0.72482751E-08_JPRB, &
  & 0.57034034E-08_JPRB, 0.42129652E-08_JPRB, 0.32289954E-08_JPRB, 0.31587020E-08_JPRB, 0.33261632E-08_JPRB, 0.37804227E-08_JPRB, &
  & 0.43708135E-08_JPRB, 0.51944367E-08_JPRB, 0.62161315E-08_JPRB, 0.74334694E-08_JPRB, 0.87349795E-08_JPRB, 0.10133325E-07_JPRB, &
  & 0.11680898E-07_JPRB, 0.13064904E-07_JPRB, 0.14273870E-07_JPRB, 0.15618490E-07_JPRB, 0.16746669E-07_JPRB, 0.17002798E-07_JPRB, &
  & 0.17319202E-07_JPRB, 0.17617774E-07_JPRB, 0.17721621E-07_JPRB, 0.17193026E-07_JPRB, 0.15580104E-07_JPRB, 0.14305087E-07_JPRB, &
  & 0.14738463E-07_JPRB, 0.16722298E-07_JPRB, 0.19029752E-07_JPRB, 0.21395437E-07_JPRB, 0.24596756E-07_JPRB, 0.27400837E-07_JPRB, &
  & 0.29588635E-07_JPRB, 0.31107158E-07_JPRB, 0.32533816E-07_JPRB, 0.33559368E-07_JPRB, 0.34281716E-07_JPRB, 0.34869406E-07_JPRB, &
  & 0.35582616E-07_JPRB, 0.36059088E-07_JPRB, 0.36195277E-07_JPRB, 0.35496954E-07_JPRB, 0.34806782E-07_JPRB, 0.34227226E-07_JPRB, &
  & 0.33543652E-07_JPRB, 0.33098547E-07_JPRB, 0.32492016E-07_JPRB, 0.31948285E-07_JPRB, 0.31513305E-07_JPRB, 0.31169296E-07_JPRB, &
  & 0.31111772E-07_JPRB, 0.31472376E-07_JPRB, 0.32122973E-07_JPRB, 0.33286245E-07_JPRB, 0.34569959E-07_JPRB, 0.35476991E-07_JPRB, &
  & 0.36066448E-07_JPRB, 0.36602391E-07_JPRB, 0.37409287E-07_JPRB, 0.37592534E-07_JPRB  /)

RGHG7(:,71, 3) = (/ &
  & 0.11257332E-07_JPRB, 0.10352943E-07_JPRB, 0.95620059E-08_JPRB, 0.89954901E-08_JPRB, 0.80985005E-08_JPRB, 0.70243163E-08_JPRB, &
  & 0.54256639E-08_JPRB, 0.39179368E-08_JPRB, 0.29131268E-08_JPRB, 0.27524760E-08_JPRB, 0.28321718E-08_JPRB, 0.31911235E-08_JPRB, &
  & 0.36753333E-08_JPRB, 0.43522398E-08_JPRB, 0.52091310E-08_JPRB, 0.62522205E-08_JPRB, 0.74363317E-08_JPRB, 0.87410050E-08_JPRB, &
  & 0.10261353E-07_JPRB, 0.11674819E-07_JPRB, 0.12904927E-07_JPRB, 0.14139590E-07_JPRB, 0.15263134E-07_JPRB, 0.15566049E-07_JPRB, &
  & 0.15870064E-07_JPRB, 0.16179020E-07_JPRB, 0.16314357E-07_JPRB, 0.15922006E-07_JPRB, 0.14487740E-07_JPRB, 0.13360262E-07_JPRB, &
  & 0.13796270E-07_JPRB, 0.15716150E-07_JPRB, 0.18032343E-07_JPRB, 0.20342021E-07_JPRB, 0.23446299E-07_JPRB, 0.26249764E-07_JPRB, &
  & 0.28517039E-07_JPRB, 0.30080755E-07_JPRB, 0.31605214E-07_JPRB, 0.32700851E-07_JPRB, 0.33546521E-07_JPRB, 0.34213558E-07_JPRB, &
  & 0.35031186E-07_JPRB, 0.35522400E-07_JPRB, 0.35594208E-07_JPRB, 0.34773061E-07_JPRB, 0.34020954E-07_JPRB, 0.33410745E-07_JPRB, &
  & 0.32716705E-07_JPRB, 0.32255244E-07_JPRB, 0.31645366E-07_JPRB, 0.31086882E-07_JPRB, 0.30669631E-07_JPRB, 0.30376493E-07_JPRB, &
  & 0.30399996E-07_JPRB, 0.30855609E-07_JPRB, 0.31662762E-07_JPRB, 0.32931062E-07_JPRB, 0.34286185E-07_JPRB, 0.35307958E-07_JPRB, &
  & 0.35957384E-07_JPRB, 0.36473901E-07_JPRB, 0.37200463E-07_JPRB, 0.37493164E-07_JPRB  /)

RGHG7(:,72, 3) = (/ &
  & 0.11086598E-07_JPRB, 0.10209710E-07_JPRB, 0.94655645E-08_JPRB, 0.89203925E-08_JPRB, 0.79827676E-08_JPRB, 0.68490672E-08_JPRB, &
  & 0.52101900E-08_JPRB, 0.37155974E-08_JPRB, 0.26927273E-08_JPRB, 0.24467015E-08_JPRB, 0.24549778E-08_JPRB, 0.27137779E-08_JPRB, &
  & 0.30925002E-08_JPRB, 0.36360082E-08_JPRB, 0.43352839E-08_JPRB, 0.52125487E-08_JPRB, 0.62685973E-08_JPRB, 0.74710667E-08_JPRB, &
  & 0.89113753E-08_JPRB, 0.10301445E-07_JPRB, 0.11547151E-07_JPRB, 0.12683304E-07_JPRB, 0.13748153E-07_JPRB, 0.14031776E-07_JPRB, &
  & 0.14292693E-07_JPRB, 0.14664860E-07_JPRB, 0.14815384E-07_JPRB, 0.14546581E-07_JPRB, 0.13326162E-07_JPRB, 0.12428130E-07_JPRB, &
  & 0.12848951E-07_JPRB, 0.14667448E-07_JPRB, 0.16949984E-07_JPRB, 0.19184958E-07_JPRB, 0.22240803E-07_JPRB, 0.25090649E-07_JPRB, &
  & 0.27387888E-07_JPRB, 0.29000448E-07_JPRB, 0.30641066E-07_JPRB, 0.31877079E-07_JPRB, 0.32888985E-07_JPRB, 0.33619642E-07_JPRB, &
  & 0.34533318E-07_JPRB, 0.35018375E-07_JPRB, 0.35028615E-07_JPRB, 0.34082278E-07_JPRB, 0.33262445E-07_JPRB, 0.32645259E-07_JPRB, &
  & 0.31945062E-07_JPRB, 0.31454048E-07_JPRB, 0.30860178E-07_JPRB, 0.30302925E-07_JPRB, 0.29886495E-07_JPRB, 0.29662314E-07_JPRB, &
  & 0.29768319E-07_JPRB, 0.30327777E-07_JPRB, 0.31269560E-07_JPRB, 0.32631444E-07_JPRB, 0.34076047E-07_JPRB, 0.35228756E-07_JPRB, &
  & 0.35936877E-07_JPRB, 0.36378691E-07_JPRB, 0.37010848E-07_JPRB, 0.37358550E-07_JPRB  /)

RGHG7(:,73, 3) = (/ &
  & 0.10942955E-07_JPRB, 0.10152014E-07_JPRB, 0.94328368E-08_JPRB, 0.88729416E-08_JPRB, 0.79001599E-08_JPRB, 0.67077404E-08_JPRB, &
  & 0.50527861E-08_JPRB, 0.35874046E-08_JPRB, 0.25509410E-08_JPRB, 0.22384732E-08_JPRB, 0.21924392E-08_JPRB, 0.23520301E-08_JPRB, &
  & 0.26231285E-08_JPRB, 0.30587494E-08_JPRB, 0.36234945E-08_JPRB, 0.43655912E-08_JPRB, 0.52981669E-08_JPRB, 0.63875532E-08_JPRB, &
  & 0.77130718E-08_JPRB, 0.90232284E-08_JPRB, 0.10252241E-07_JPRB, 0.11313693E-07_JPRB, 0.12340077E-07_JPRB, 0.12588678E-07_JPRB, &
  & 0.12757484E-07_JPRB, 0.13137608E-07_JPRB, 0.13389504E-07_JPRB, 0.13157727E-07_JPRB, 0.12169160E-07_JPRB, 0.11592955E-07_JPRB, &
  & 0.11985167E-07_JPRB, 0.13739788E-07_JPRB, 0.15893232E-07_JPRB, 0.18062974E-07_JPRB, 0.21100199E-07_JPRB, 0.23926219E-07_JPRB, &
  & 0.26136642E-07_JPRB, 0.27750329E-07_JPRB, 0.29639592E-07_JPRB, 0.31062893E-07_JPRB, 0.32269428E-07_JPRB, 0.33088457E-07_JPRB, &
  & 0.34067879E-07_JPRB, 0.34554363E-07_JPRB, 0.34543058E-07_JPRB, 0.33456329E-07_JPRB, 0.32542091E-07_JPRB, 0.31939601E-07_JPRB, &
  & 0.31241974E-07_JPRB, 0.30715520E-07_JPRB, 0.30134703E-07_JPRB, 0.29584785E-07_JPRB, 0.29171847E-07_JPRB, 0.29021214E-07_JPRB, &
  & 0.29210962E-07_JPRB, 0.29880202E-07_JPRB, 0.30908634E-07_JPRB, 0.32382551E-07_JPRB, 0.33896581E-07_JPRB, 0.35188225E-07_JPRB, &
  & 0.35917286E-07_JPRB, 0.36299202E-07_JPRB, 0.36856595E-07_JPRB, 0.37163998E-07_JPRB  /)

RGHG7(:,74, 3) = (/ &
  & 0.10824600E-07_JPRB, 0.10137566E-07_JPRB, 0.94350502E-08_JPRB, 0.88351062E-08_JPRB, 0.78298970E-08_JPRB, 0.65850852E-08_JPRB, &
  & 0.49312219E-08_JPRB, 0.34919112E-08_JPRB, 0.24514152E-08_JPRB, 0.20895367E-08_JPRB, 0.19971346E-08_JPRB, 0.20681123E-08_JPRB, &
  & 0.22394543E-08_JPRB, 0.25791168E-08_JPRB, 0.30357084E-08_JPRB, 0.36609765E-08_JPRB, 0.44740683E-08_JPRB, 0.54364415E-08_JPRB, &
  & 0.66431307E-08_JPRB, 0.78577993E-08_JPRB, 0.90441210E-08_JPRB, 0.10073605E-07_JPRB, 0.11066986E-07_JPRB, 0.11305303E-07_JPRB, &
  & 0.11421101E-07_JPRB, 0.11759912E-07_JPRB, 0.12082894E-07_JPRB, 0.11886277E-07_JPRB, 0.11114964E-07_JPRB, 0.10816209E-07_JPRB, &
  & 0.11198047E-07_JPRB, 0.12883837E-07_JPRB, 0.14901290E-07_JPRB, 0.17048308E-07_JPRB, 0.20073159E-07_JPRB, 0.22848652E-07_JPRB, &
  & 0.24912708E-07_JPRB, 0.26561677E-07_JPRB, 0.28673533E-07_JPRB, 0.30291088E-07_JPRB, 0.31700876E-07_JPRB, 0.32605554E-07_JPRB, &
  & 0.33641908E-07_JPRB, 0.34140864E-07_JPRB, 0.34127764E-07_JPRB, 0.32900010E-07_JPRB, 0.31881045E-07_JPRB, 0.31284896E-07_JPRB, &
  & 0.30586604E-07_JPRB, 0.30013845E-07_JPRB, 0.29450528E-07_JPRB, 0.28910927E-07_JPRB, 0.28513352E-07_JPRB, 0.28430873E-07_JPRB, &
  & 0.28683806E-07_JPRB, 0.29456517E-07_JPRB, 0.30553093E-07_JPRB, 0.32144192E-07_JPRB, 0.33707299E-07_JPRB, 0.35105187E-07_JPRB, &
  & 0.35830179E-07_JPRB, 0.36191676E-07_JPRB, 0.36699586E-07_JPRB, 0.36923023E-07_JPRB  /)

RGHG7(:,75, 3) = (/ &
  & 0.10732702E-07_JPRB, 0.10151642E-07_JPRB, 0.94615845E-08_JPRB, 0.88064568E-08_JPRB, 0.77707263E-08_JPRB, 0.64790196E-08_JPRB, &
  & 0.48436544E-08_JPRB, 0.34262509E-08_JPRB, 0.23882670E-08_JPRB, 0.19884330E-08_JPRB, 0.18570133E-08_JPRB, 0.18528793E-08_JPRB, &
  & 0.19386266E-08_JPRB, 0.21929722E-08_JPRB, 0.25620053E-08_JPRB, 0.30865627E-08_JPRB, 0.37874494E-08_JPRB, 0.46183045E-08_JPRB, &
  & 0.57047504E-08_JPRB, 0.68215025E-08_JPRB, 0.79503715E-08_JPRB, 0.89768498E-08_JPRB, 0.99472809E-08_JPRB, 0.10205096E-07_JPRB, &
  & 0.10312300E-07_JPRB, 0.10576697E-07_JPRB, 0.10912238E-07_JPRB, 0.10765894E-07_JPRB, 0.10181761E-07_JPRB, 0.10083097E-07_JPRB, &
  & 0.10467631E-07_JPRB, 0.12081512E-07_JPRB, 0.13981497E-07_JPRB, 0.16142317E-07_JPRB, 0.19163430E-07_JPRB, 0.21887005E-07_JPRB, &
  & 0.23800246E-07_JPRB, 0.25515047E-07_JPRB, 0.27783960E-07_JPRB, 0.29577270E-07_JPRB, 0.31176424E-07_JPRB, 0.32170449E-07_JPRB, &
  & 0.33269817E-07_JPRB, 0.33798229E-07_JPRB, 0.33778837E-07_JPRB, 0.32411786E-07_JPRB, 0.31284997E-07_JPRB, 0.30684459E-07_JPRB, &
  & 0.29974578E-07_JPRB, 0.29354192E-07_JPRB, 0.28803266E-07_JPRB, 0.28282759E-07_JPRB, 0.27906523E-07_JPRB, 0.27879145E-07_JPRB, &
  & 0.28180093E-07_JPRB, 0.29038152E-07_JPRB, 0.30194638E-07_JPRB, 0.31882453E-07_JPRB, 0.33483093E-07_JPRB, 0.34949469E-07_JPRB, &
  & 0.35657194E-07_JPRB, 0.36032380E-07_JPRB, 0.36514617E-07_JPRB, 0.36631791E-07_JPRB  /)

RGHG7(:,76, 3) = (/ &
  & 0.10669755E-07_JPRB, 0.10177785E-07_JPRB, 0.95004548E-08_JPRB, 0.87890812E-08_JPRB, 0.77237909E-08_JPRB, 0.63885655E-08_JPRB, &
  & 0.47909712E-08_JPRB, 0.33924532E-08_JPRB, 0.23581643E-08_JPRB, 0.19234332E-08_JPRB, 0.17608114E-08_JPRB, 0.16983788E-08_JPRB, &
  & 0.17213113E-08_JPRB, 0.19009362E-08_JPRB, 0.21936063E-08_JPRB, 0.26319474E-08_JPRB, 0.32330695E-08_JPRB, 0.39428112E-08_JPRB, &
  & 0.49069121E-08_JPRB, 0.59378585E-08_JPRB, 0.70108921E-08_JPRB, 0.80394232E-08_JPRB, 0.90065699E-08_JPRB, 0.93165254E-08_JPRB, &
  & 0.94561635E-08_JPRB, 0.96368068E-08_JPRB, 0.98972163E-08_JPRB, 0.98313412E-08_JPRB, 0.93843332E-08_JPRB, 0.93747594E-08_JPRB, &
  & 0.97625779E-08_JPRB, 0.11310359E-07_JPRB, 0.13138908E-07_JPRB, 0.15336678E-07_JPRB, 0.18370108E-07_JPRB, 0.21073976E-07_JPRB, &
  & 0.22910444E-07_JPRB, 0.24704892E-07_JPRB, 0.27024714E-07_JPRB, 0.28940779E-07_JPRB, 0.30682806E-07_JPRB, 0.31784396E-07_JPRB, &
  & 0.32973675E-07_JPRB, 0.33557923E-07_JPRB, 0.33492138E-07_JPRB, 0.31988783E-07_JPRB, 0.30759767E-07_JPRB, 0.30144449E-07_JPRB, &
  & 0.29401313E-07_JPRB, 0.28747671E-07_JPRB, 0.28187713E-07_JPRB, 0.27704978E-07_JPRB, 0.27345574E-07_JPRB, 0.27349398E-07_JPRB, &
  & 0.27694686E-07_JPRB, 0.28602833E-07_JPRB, 0.29822955E-07_JPRB, 0.31548130E-07_JPRB, 0.33188594E-07_JPRB, 0.34682888E-07_JPRB, &
  & 0.35376653E-07_JPRB, 0.35788379E-07_JPRB, 0.36266100E-07_JPRB, 0.36280224E-07_JPRB  /)

RGHG7(:,77, 3) = (/ &
  & 0.10639296E-07_JPRB, 0.10193061E-07_JPRB, 0.95258751E-08_JPRB, 0.87791740E-08_JPRB, 0.76925904E-08_JPRB, 0.63199391E-08_JPRB, &
  & 0.47685532E-08_JPRB, 0.33994582E-08_JPRB, 0.23685221E-08_JPRB, 0.18912873E-08_JPRB, 0.17029420E-08_JPRB, 0.15987557E-08_JPRB, &
  & 0.15765387E-08_JPRB, 0.17017026E-08_JPRB, 0.19362714E-08_JPRB, 0.22962493E-08_JPRB, 0.27946036E-08_JPRB, 0.34036196E-08_JPRB, &
  & 0.42732491E-08_JPRB, 0.52503392E-08_JPRB, 0.63220304E-08_JPRB, 0.73510639E-08_JPRB, 0.83192234E-08_JPRB, 0.86666612E-08_JPRB, &
  & 0.87886453E-08_JPRB, 0.89459490E-08_JPRB, 0.91653035E-08_JPRB, 0.91111433E-08_JPRB, 0.87226520E-08_JPRB, 0.87019437E-08_JPRB, &
  & 0.90867747E-08_JPRB, 0.10597923E-07_JPRB, 0.12410096E-07_JPRB, 0.14638629E-07_JPRB, 0.17730363E-07_JPRB, 0.20445047E-07_JPRB, &
  & 0.22278682E-07_JPRB, 0.24172871E-07_JPRB, 0.26497331E-07_JPRB, 0.28495647E-07_JPRB, 0.30342697E-07_JPRB, 0.31499677E-07_JPRB, &
  & 0.32767908E-07_JPRB, 0.33381143E-07_JPRB, 0.33212619E-07_JPRB, 0.31608533E-07_JPRB, 0.30276620E-07_JPRB, 0.29633279E-07_JPRB, &
  & 0.28858783E-07_JPRB, 0.28197082E-07_JPRB, 0.27607032E-07_JPRB, 0.27171295E-07_JPRB, 0.26821460E-07_JPRB, 0.26806776E-07_JPRB, &
  & 0.27230606E-07_JPRB, 0.28130316E-07_JPRB, 0.29394840E-07_JPRB, 0.31092746E-07_JPRB, 0.32782290E-07_JPRB, 0.34190766E-07_JPRB, &
  & 0.34982138E-07_JPRB, 0.35433689E-07_JPRB, 0.35879975E-07_JPRB, 0.35832626E-07_JPRB  /)

RGHG7(:,78, 3) = (/ &
  & 0.10620644E-07_JPRB, 0.10187445E-07_JPRB, 0.95312810E-08_JPRB, 0.87616400E-08_JPRB, 0.76749215E-08_JPRB, 0.62743086E-08_JPRB, &
  & 0.47643999E-08_JPRB, 0.34331310E-08_JPRB, 0.24097471E-08_JPRB, 0.18799644E-08_JPRB, 0.16625908E-08_JPRB, 0.15190381E-08_JPRB, &
  & 0.14599504E-08_JPRB, 0.15438689E-08_JPRB, 0.17376864E-08_JPRB, 0.20327160E-08_JPRB, 0.24459703E-08_JPRB, 0.29858998E-08_JPRB, &
  & 0.38007540E-08_JPRB, 0.47560891E-08_JPRB, 0.58275901E-08_JPRB, 0.68393228E-08_JPRB, 0.77925985E-08_JPRB, 0.81556839E-08_JPRB, &
  & 0.82618188E-08_JPRB, 0.84375340E-08_JPRB, 0.86186540E-08_JPRB, 0.85625990E-08_JPRB, 0.82227938E-08_JPRB, 0.81905019E-08_JPRB, &
  & 0.85249452E-08_JPRB, 0.99721317E-08_JPRB, 0.11781331E-07_JPRB, 0.14061062E-07_JPRB, 0.17191466E-07_JPRB, 0.19952187E-07_JPRB, &
  & 0.21793149E-07_JPRB, 0.23778030E-07_JPRB, 0.26085793E-07_JPRB, 0.28133681E-07_JPRB, 0.30079053E-07_JPRB, 0.31320341E-07_JPRB, &
  & 0.32602902E-07_JPRB, 0.33205728E-07_JPRB, 0.32908214E-07_JPRB, 0.31226352E-07_JPRB, 0.29818065E-07_JPRB, 0.29136292E-07_JPRB, &
  & 0.28325898E-07_JPRB, 0.27669453E-07_JPRB, 0.27045091E-07_JPRB, 0.26652190E-07_JPRB, 0.26319686E-07_JPRB, 0.26291231E-07_JPRB, &
  & 0.26767957E-07_JPRB, 0.27626691E-07_JPRB, 0.28901608E-07_JPRB, 0.30539440E-07_JPRB, 0.32279713E-07_JPRB, 0.33592466E-07_JPRB, &
  & 0.34493037E-07_JPRB, 0.34985768E-07_JPRB, 0.35374928E-07_JPRB, 0.35300881E-07_JPRB  /)

RGHG7(:,79, 3) = (/ &
  & 0.10607827E-07_JPRB, 0.10161414E-07_JPRB, 0.95112828E-08_JPRB, 0.87315756E-08_JPRB, 0.76666893E-08_JPRB, 0.62520543E-08_JPRB, &
  & 0.47763361E-08_JPRB, 0.34886357E-08_JPRB, 0.24741091E-08_JPRB, 0.18855928E-08_JPRB, 0.16344835E-08_JPRB, 0.14556870E-08_JPRB, &
  & 0.13681900E-08_JPRB, 0.14211258E-08_JPRB, 0.15852712E-08_JPRB, 0.18339615E-08_JPRB, 0.21816896E-08_JPRB, 0.26788226E-08_JPRB, &
  & 0.34701212E-08_JPRB, 0.44210455E-08_JPRB, 0.54807746E-08_JPRB, 0.64677547E-08_JPRB, 0.74002396E-08_JPRB, 0.77665148E-08_JPRB, &
  & 0.78656238E-08_JPRB, 0.80713880E-08_JPRB, 0.82158518E-08_JPRB, 0.81606586E-08_JPRB, 0.78702271E-08_JPRB, 0.78371632E-08_JPRB, &
  & 0.80929558E-08_JPRB, 0.94458117E-08_JPRB, 0.11256848E-07_JPRB, 0.13613566E-07_JPRB, 0.16765773E-07_JPRB, 0.19565125E-07_JPRB, &
  & 0.21419061E-07_JPRB, 0.23487937E-07_JPRB, 0.25761731E-07_JPRB, 0.27841039E-07_JPRB, 0.29875876E-07_JPRB, 0.31205599E-07_JPRB, &
  & 0.32463510E-07_JPRB, 0.33032432E-07_JPRB, 0.32594332E-07_JPRB, 0.30847339E-07_JPRB, 0.29386231E-07_JPRB, 0.28658974E-07_JPRB, &
  & 0.27811361E-07_JPRB, 0.27154647E-07_JPRB, 0.26500020E-07_JPRB, 0.26143488E-07_JPRB, 0.25834187E-07_JPRB, 0.25798078E-07_JPRB, &
  & 0.26296037E-07_JPRB, 0.27090658E-07_JPRB, 0.28335459E-07_JPRB, 0.29890840E-07_JPRB, 0.31674418E-07_JPRB, 0.32889849E-07_JPRB, &
  & 0.33891794E-07_JPRB, 0.34417148E-07_JPRB, 0.34729506E-07_JPRB, 0.34667740E-07_JPRB  /)

RGHG7(:,80, 3) = (/ &
  & 0.10596206E-07_JPRB, 0.10117369E-07_JPRB, 0.94616400E-08_JPRB, 0.86851448E-08_JPRB, 0.76633261E-08_JPRB, 0.62528380E-08_JPRB, &
  & 0.48021670E-08_JPRB, 0.35607584E-08_JPRB, 0.25528767E-08_JPRB, 0.19042155E-08_JPRB, 0.16137054E-08_JPRB, 0.14066258E-08_JPRB, &
  & 0.12997965E-08_JPRB, 0.13289782E-08_JPRB, 0.14673247E-08_JPRB, 0.16934520E-08_JPRB, 0.19953598E-08_JPRB, 0.24685961E-08_JPRB, &
  & 0.32566180E-08_JPRB, 0.42033765E-08_JPRB, 0.52291229E-08_JPRB, 0.61969082E-08_JPRB, 0.71156470E-08_JPRB, 0.74839720E-08_JPRB, &
  & 0.75891540E-08_JPRB, 0.78038063E-08_JPRB, 0.79137715E-08_JPRB, 0.78770621E-08_JPRB, 0.76436379E-08_JPRB, 0.76264157E-08_JPRB, &
  & 0.78003845E-08_JPRB, 0.90295977E-08_JPRB, 0.10840042E-07_JPRB, 0.13302942E-07_JPRB, 0.16467724E-07_JPRB, 0.19250791E-07_JPRB, &
  & 0.21123754E-07_JPRB, 0.23274561E-07_JPRB, 0.25499714E-07_JPRB, 0.27607971E-07_JPRB, 0.29719171E-07_JPRB, 0.31108164E-07_JPRB, &
  & 0.32335813E-07_JPRB, 0.32866251E-07_JPRB, 0.32290575E-07_JPRB, 0.30480094E-07_JPRB, 0.28984339E-07_JPRB, 0.28208759E-07_JPRB, &
  & 0.27326836E-07_JPRB, 0.26644046E-07_JPRB, 0.25971085E-07_JPRB, 0.25643096E-07_JPRB, 0.25360042E-07_JPRB, 0.25320338E-07_JPRB, &
  & 0.25806038E-07_JPRB, 0.26523434E-07_JPRB, 0.27692259E-07_JPRB, 0.29153684E-07_JPRB, 0.30964290E-07_JPRB, 0.32083314E-07_JPRB, &
  & 0.33165011E-07_JPRB, 0.33703314E-07_JPRB, 0.33926563E-07_JPRB, 0.33920144E-07_JPRB  /)

RGHG7(:,81, 3) = (/ &
  & 0.10515138E-07_JPRB, 0.10012660E-07_JPRB, 0.93404663E-08_JPRB, 0.86066106E-08_JPRB, 0.76527618E-08_JPRB, 0.62760477E-08_JPRB, &
  & 0.48426858E-08_JPRB, 0.36422280E-08_JPRB, 0.26326576E-08_JPRB, 0.19244700E-08_JPRB, 0.16052521E-08_JPRB, 0.13745307E-08_JPRB, &
  & 0.12571471E-08_JPRB, 0.12647979E-08_JPRB, 0.13795027E-08_JPRB, 0.15883209E-08_JPRB, 0.18788300E-08_JPRB, 0.23423563E-08_JPRB, &
  & 0.31274230E-08_JPRB, 0.40762924E-08_JPRB, 0.50703757E-08_JPRB, 0.60162080E-08_JPRB, 0.69075055E-08_JPRB, 0.72775192E-08_JPRB, &
  & 0.73940999E-08_JPRB, 0.75927097E-08_JPRB, 0.76794553E-08_JPRB, 0.76549890E-08_JPRB, 0.75009333E-08_JPRB, 0.75090416E-08_JPRB, &
  & 0.76015309E-08_JPRB, 0.87150686E-08_JPRB, 0.10540289E-07_JPRB, 0.13124775E-07_JPRB, 0.16311088E-07_JPRB, 0.19002544E-07_JPRB, &
  & 0.20774184E-07_JPRB, 0.22997605E-07_JPRB, 0.25239223E-07_JPRB, 0.27418828E-07_JPRB, 0.29583644E-07_JPRB, 0.31001767E-07_JPRB, &
  & 0.32198175E-07_JPRB, 0.32726924E-07_JPRB, 0.32057947E-07_JPRB, 0.30190474E-07_JPRB, 0.28649545E-07_JPRB, 0.27795441E-07_JPRB, &
  & 0.26874678E-07_JPRB, 0.26156848E-07_JPRB, 0.25493597E-07_JPRB, 0.25167718E-07_JPRB, 0.24871155E-07_JPRB, 0.24820475E-07_JPRB, &
  & 0.25258469E-07_JPRB, 0.25856390E-07_JPRB, 0.26939514E-07_JPRB, 0.28261199E-07_JPRB, 0.30027899E-07_JPRB, 0.31073042E-07_JPRB, &
  & 0.32099013E-07_JPRB, 0.32662224E-07_JPRB, 0.32790062E-07_JPRB, 0.32863433E-07_JPRB  /)

RGHG7(:,82, 3) = (/ &
  & 0.10378062E-07_JPRB, 0.98648907E-08_JPRB, 0.91760465E-08_JPRB, 0.84976468E-08_JPRB, 0.76197689E-08_JPRB, 0.62929012E-08_JPRB, &
  & 0.48869180E-08_JPRB, 0.37172603E-08_JPRB, 0.26987405E-08_JPRB, 0.19407140E-08_JPRB, 0.15964620E-08_JPRB, 0.13506849E-08_JPRB, &
  & 0.12257229E-08_JPRB, 0.12151799E-08_JPRB, 0.13093025E-08_JPRB, 0.15041216E-08_JPRB, 0.17940667E-08_JPRB, 0.22491085E-08_JPRB, &
  & 0.30326931E-08_JPRB, 0.39865686E-08_JPRB, 0.49497728E-08_JPRB, 0.58778643E-08_JPRB, 0.67421866E-08_JPRB, 0.71217315E-08_JPRB, &
  & 0.72342224E-08_JPRB, 0.74131108E-08_JPRB, 0.74811481E-08_JPRB, 0.74828080E-08_JPRB, 0.74026695E-08_JPRB, 0.74350738E-08_JPRB, &
  & 0.74460222E-08_JPRB, 0.84565484E-08_JPRB, 0.10306921E-07_JPRB, 0.13000292E-07_JPRB, 0.16209743E-07_JPRB, 0.18791266E-07_JPRB, &
  & 0.20411622E-07_JPRB, 0.22633896E-07_JPRB, 0.24949464E-07_JPRB, 0.27239518E-07_JPRB, 0.29447137E-07_JPRB, 0.30893912E-07_JPRB, &
  & 0.32067714E-07_JPRB, 0.32580242E-07_JPRB, 0.31849974E-07_JPRB, 0.29940996E-07_JPRB, 0.28356347E-07_JPRB, 0.27434110E-07_JPRB, &
  & 0.26460211E-07_JPRB, 0.25720653E-07_JPRB, 0.25089156E-07_JPRB, 0.24753449E-07_JPRB, 0.24411177E-07_JPRB, 0.24324286E-07_JPRB, &
  & 0.24676194E-07_JPRB, 0.25152203E-07_JPRB, 0.26156863E-07_JPRB, 0.27306834E-07_JPRB, 0.28939450E-07_JPRB, 0.29900423E-07_JPRB, &
  & 0.30792781E-07_JPRB, 0.31438041E-07_JPRB, 0.31460897E-07_JPRB, 0.31633910E-07_JPRB  /)

RGHG7(:,83, 3) = (/ &
  & 0.10197397E-07_JPRB, 0.96800400E-08_JPRB, 0.89656951E-08_JPRB, 0.83552770E-08_JPRB, 0.75619107E-08_JPRB, 0.62948367E-08_JPRB, &
  & 0.49273954E-08_JPRB, 0.37812042E-08_JPRB, 0.27483656E-08_JPRB, 0.19516054E-08_JPRB, 0.15877653E-08_JPRB, 0.13333352E-08_JPRB, &
  & 0.12040674E-08_JPRB, 0.11793027E-08_JPRB, 0.12560634E-08_JPRB, 0.14390480E-08_JPRB, 0.17325083E-08_JPRB, 0.21807747E-08_JPRB, &
  & 0.29614327E-08_JPRB, 0.39213865E-08_JPRB, 0.48613150E-08_JPRB, 0.57773058E-08_JPRB, 0.66224184E-08_JPRB, 0.70137302E-08_JPRB, &
  & 0.71200788E-08_JPRB, 0.72853261E-08_JPRB, 0.73497763E-08_JPRB, 0.73866880E-08_JPRB, 0.73723621E-08_JPRB, 0.74307322E-08_JPRB, &
  & 0.73608898E-08_JPRB, 0.82614449E-08_JPRB, 0.10144090E-07_JPRB, 0.12931503E-07_JPRB, 0.16145168E-07_JPRB, 0.18627597E-07_JPRB, &
  & 0.20106680E-07_JPRB, 0.22270541E-07_JPRB, 0.24636515E-07_JPRB, 0.27052793E-07_JPRB, 0.29302293E-07_JPRB, 0.30780899E-07_JPRB, &
  & 0.31933566E-07_JPRB, 0.32405746E-07_JPRB, 0.31639431E-07_JPRB, 0.29707851E-07_JPRB, 0.28089864E-07_JPRB, 0.27111329E-07_JPRB, &
  & 0.26082876E-07_JPRB, 0.25331539E-07_JPRB, 0.24739933E-07_JPRB, 0.24395536E-07_JPRB, 0.23989752E-07_JPRB, 0.23834749E-07_JPRB, &
  & 0.24078852E-07_JPRB, 0.24436435E-07_JPRB, 0.25360581E-07_JPRB, 0.26295572E-07_JPRB, 0.27772481E-07_JPRB, 0.28581141E-07_JPRB, &
  & 0.29254008E-07_JPRB, 0.29983357E-07_JPRB, 0.29953881E-07_JPRB, 0.30260570E-07_JPRB  /)

RGHG7(:,84, 3) = (/ &
  & 0.99842741E-08_JPRB, 0.94645810E-08_JPRB, 0.87103207E-08_JPRB, 0.81787704E-08_JPRB, 0.74770897E-08_JPRB, 0.62748897E-08_JPRB, &
  & 0.49575594E-08_JPRB, 0.38303042E-08_JPRB, 0.27801410E-08_JPRB, 0.19563403E-08_JPRB, 0.15794281E-08_JPRB, 0.13206661E-08_JPRB, &
  & 0.11903208E-08_JPRB, 0.11557386E-08_JPRB, 0.12184038E-08_JPRB, 0.13906524E-08_JPRB, 0.16862675E-08_JPRB, 0.21297665E-08_JPRB, &
  & 0.29039187E-08_JPRB, 0.38686463E-08_JPRB, 0.47969392E-08_JPRB, 0.57063734E-08_JPRB, 0.65434451E-08_JPRB, 0.69441392E-08_JPRB, &
  & 0.70522770E-08_JPRB, 0.72161641E-08_JPRB, 0.72967883E-08_JPRB, 0.73721217E-08_JPRB, 0.74125187E-08_JPRB, 0.74984220E-08_JPRB, &
  & 0.73522478E-08_JPRB, 0.81260994E-08_JPRB, 0.10041570E-07_JPRB, 0.12907272E-07_JPRB, 0.16095180E-07_JPRB, 0.18511676E-07_JPRB, &
  & 0.19904140E-07_JPRB, 0.21973353E-07_JPRB, 0.24310526E-07_JPRB, 0.26843754E-07_JPRB, 0.29141347E-07_JPRB, 0.30657005E-07_JPRB, &
  & 0.31785809E-07_JPRB, 0.32188892E-07_JPRB, 0.31405424E-07_JPRB, 0.29470612E-07_JPRB, 0.27835018E-07_JPRB, 0.26813192E-07_JPRB, &
  & 0.25739423E-07_JPRB, 0.24983977E-07_JPRB, 0.24429807E-07_JPRB, 0.24086995E-07_JPRB, 0.23614571E-07_JPRB, 0.23358894E-07_JPRB, &
  & 0.23486903E-07_JPRB, 0.23731499E-07_JPRB, 0.24561930E-07_JPRB, 0.25240475E-07_JPRB, 0.26591355E-07_JPRB, 0.27154445E-07_JPRB, &
  & 0.27526473E-07_JPRB, 0.28281012E-07_JPRB, 0.28290666E-07_JPRB, 0.28768230E-07_JPRB  /)

RGHG7(:,85, 3) = (/ &
  & 0.97009843E-08_JPRB, 0.91872492E-08_JPRB, 0.83763879E-08_JPRB, 0.79354843E-08_JPRB, 0.73265782E-08_JPRB, 0.62060880E-08_JPRB, &
  & 0.49615305E-08_JPRB, 0.38551282E-08_JPRB, 0.27917723E-08_JPRB, 0.19530766E-08_JPRB, 0.15697809E-08_JPRB, 0.13093166E-08_JPRB, &
  & 0.11802480E-08_JPRB, 0.11422612E-08_JPRB, 0.11942871E-08_JPRB, 0.13541941E-08_JPRB, 0.16472558E-08_JPRB, 0.20882014E-08_JPRB, &
  & 0.28500120E-08_JPRB, 0.38045259E-08_JPRB, 0.47247330E-08_JPRB, 0.56209744E-08_JPRB, 0.64393210E-08_JPRB, 0.68425684E-08_JPRB, &
  & 0.69613456E-08_JPRB, 0.71282116E-08_JPRB, 0.72156450E-08_JPRB, 0.73097036E-08_JPRB, 0.73777628E-08_JPRB, 0.74674961E-08_JPRB, &
  & 0.72859995E-08_JPRB, 0.79602673E-08_JPRB, 0.98587148E-08_JPRB, 0.12792508E-07_JPRB, 0.15961266E-07_JPRB, 0.18362016E-07_JPRB, &
  & 0.19733627E-07_JPRB, 0.21737727E-07_JPRB, 0.23991914E-07_JPRB, 0.26545144E-07_JPRB, 0.28901040E-07_JPRB, 0.30457553E-07_JPRB, &
  & 0.31573164E-07_JPRB, 0.31881770E-07_JPRB, 0.31100856E-07_JPRB, 0.29169873E-07_JPRB, 0.27522789E-07_JPRB, 0.26477982E-07_JPRB, &
  & 0.25379530E-07_JPRB, 0.24638979E-07_JPRB, 0.24125664E-07_JPRB, 0.23790087E-07_JPRB, 0.23283617E-07_JPRB, 0.22913461E-07_JPRB, &
  & 0.22900606E-07_JPRB, 0.22991997E-07_JPRB, 0.23637729E-07_JPRB, 0.24091998E-07_JPRB, 0.25328825E-07_JPRB, 0.25708068E-07_JPRB, &
  & 0.25730702E-07_JPRB, 0.26153720E-07_JPRB, 0.26251893E-07_JPRB, 0.26886067E-07_JPRB  /)

RGHG7(:,86, 3) = (/ &
  & 0.93092652E-08_JPRB, 0.88314901E-08_JPRB, 0.79607445E-08_JPRB, 0.76129439E-08_JPRB, 0.71049409E-08_JPRB, 0.60852225E-08_JPRB, &
  & 0.49231302E-08_JPRB, 0.38536713E-08_JPRB, 0.27887117E-08_JPRB, 0.19460355E-08_JPRB, 0.15613192E-08_JPRB, 0.12994770E-08_JPRB, &
  & 0.11713586E-08_JPRB, 0.11309491E-08_JPRB, 0.11779433E-08_JPRB, 0.13281105E-08_JPRB, 0.16159417E-08_JPRB, 0.20539880E-08_JPRB, &
  & 0.28027286E-08_JPRB, 0.37416487E-08_JPRB, 0.46460696E-08_JPRB, 0.55217252E-08_JPRB, 0.63199199E-08_JPRB, 0.67263997E-08_JPRB, &
  & 0.68548709E-08_JPRB, 0.70330565E-08_JPRB, 0.71289986E-08_JPRB, 0.72392127E-08_JPRB, 0.73220861E-08_JPRB, 0.74036802E-08_JPRB, &
  & 0.72013355E-08_JPRB, 0.78121486E-08_JPRB, 0.96678446E-08_JPRB, 0.12650425E-07_JPRB, 0.15792276E-07_JPRB, 0.18170540E-07_JPRB, &
  & 0.19532182E-07_JPRB, 0.21484162E-07_JPRB, 0.23646950E-07_JPRB, 0.26181986E-07_JPRB, 0.28537202E-07_JPRB, 0.30128782E-07_JPRB, &
  & 0.31251781E-07_JPRB, 0.31464101E-07_JPRB, 0.30701404E-07_JPRB, 0.28781265E-07_JPRB, 0.27115305E-07_JPRB, 0.26067383E-07_JPRB, &
  & 0.24972763E-07_JPRB, 0.24276488E-07_JPRB, 0.23792578E-07_JPRB, 0.23482922E-07_JPRB, 0.22959218E-07_JPRB, 0.22473339E-07_JPRB, &
  & 0.22350545E-07_JPRB, 0.22223016E-07_JPRB, 0.22670129E-07_JPRB, 0.22949608E-07_JPRB, 0.24068142E-07_JPRB, 0.24432116E-07_JPRB, &
  & 0.24211490E-07_JPRB, 0.23902019E-07_JPRB, 0.23959613E-07_JPRB, 0.24609322E-07_JPRB  /)

RGHG7(:,87, 3) = (/ &
  & 0.87666326E-08_JPRB, 0.83655228E-08_JPRB, 0.74441776E-08_JPRB, 0.71846393E-08_JPRB, 0.68072725E-08_JPRB, 0.58999447E-08_JPRB, &
  & 0.48362740E-08_JPRB, 0.38315701E-08_JPRB, 0.27758873E-08_JPRB, 0.19374421E-08_JPRB, 0.15536128E-08_JPRB, 0.12915761E-08_JPRB, &
  & 0.11634395E-08_JPRB, 0.11210796E-08_JPRB, 0.11652638E-08_JPRB, 0.13080823E-08_JPRB, 0.15904969E-08_JPRB, 0.20219545E-08_JPRB, &
  & 0.27543458E-08_JPRB, 0.36705678E-08_JPRB, 0.45560782E-08_JPRB, 0.54069361E-08_JPRB, 0.61856094E-08_JPRB, 0.65946776E-08_JPRB, &
  & 0.67331493E-08_JPRB, 0.69250144E-08_JPRB, 0.70320747E-08_JPRB, 0.71597016E-08_JPRB, 0.72469958E-08_JPRB, 0.73068826E-08_JPRB, &
  & 0.70918089E-08_JPRB, 0.76600635E-08_JPRB, 0.94638246E-08_JPRB, 0.12473429E-07_JPRB, 0.15583744E-07_JPRB, 0.17936581E-07_JPRB, &
  & 0.19283291E-07_JPRB, 0.21165116E-07_JPRB, 0.23230551E-07_JPRB, 0.25713652E-07_JPRB, 0.28018240E-07_JPRB, 0.29623082E-07_JPRB, &
  & 0.30765979E-07_JPRB, 0.30895421E-07_JPRB, 0.30160849E-07_JPRB, 0.28250859E-07_JPRB, 0.26560509E-07_JPRB, 0.25524728E-07_JPRB, &
  & 0.24476197E-07_JPRB, 0.23869498E-07_JPRB, 0.23406322E-07_JPRB, 0.23138578E-07_JPRB, 0.22622897E-07_JPRB, 0.22013528E-07_JPRB, &
  & 0.21831451E-07_JPRB, 0.21455063E-07_JPRB, 0.21682730E-07_JPRB, 0.21844538E-07_JPRB, 0.22907062E-07_JPRB, 0.23369233E-07_JPRB, &
  & 0.23002550E-07_JPRB, 0.21792128E-07_JPRB, 0.21604569E-07_JPRB, 0.22104023E-07_JPRB  /)

RGHG7(:,88, 3) = (/ &
  & 0.80111710E-08_JPRB, 0.77433446E-08_JPRB, 0.68051664E-08_JPRB, 0.66082361E-08_JPRB, 0.64202210E-08_JPRB, 0.56397391E-08_JPRB, &
  & 0.46958966E-08_JPRB, 0.37903824E-08_JPRB, 0.27559197E-08_JPRB, 0.19283395E-08_JPRB, 0.15464611E-08_JPRB, 0.12853344E-08_JPRB, &
  & 0.11564189E-08_JPRB, 0.11121080E-08_JPRB, 0.11541483E-08_JPRB, 0.12917071E-08_JPRB, 0.15687238E-08_JPRB, 0.19891926E-08_JPRB, &
  & 0.26989441E-08_JPRB, 0.35819853E-08_JPRB, 0.44441388E-08_JPRB, 0.52665875E-08_JPRB, 0.60283788E-08_JPRB, 0.64388739E-08_JPRB, &
  & 0.65886583E-08_JPRB, 0.67944969E-08_JPRB, 0.69159929E-08_JPRB, 0.70608876E-08_JPRB, 0.71421072E-08_JPRB, 0.71634700E-08_JPRB, &
  & 0.69471581E-08_JPRB, 0.74757786E-08_JPRB, 0.92221971E-08_JPRB, 0.12239246E-07_JPRB, 0.15313085E-07_JPRB, 0.17638886E-07_JPRB, &
  & 0.18955253E-07_JPRB, 0.20735498E-07_JPRB, 0.22681935E-07_JPRB, 0.25052504E-07_JPRB, 0.27273459E-07_JPRB, 0.28840948E-07_JPRB, &
  & 0.29999483E-07_JPRB, 0.30077277E-07_JPRB, 0.29369815E-07_JPRB, 0.27478697E-07_JPRB, 0.25777502E-07_JPRB, 0.24763622E-07_JPRB, &
  & 0.23816704E-07_JPRB, 0.23364632E-07_JPRB, 0.22919215E-07_JPRB, 0.22712297E-07_JPRB, 0.22242507E-07_JPRB, 0.21497351E-07_JPRB, &
  & 0.21303695E-07_JPRB, 0.20657032E-07_JPRB, 0.20639909E-07_JPRB, 0.20752347E-07_JPRB, 0.21871747E-07_JPRB, 0.22489492E-07_JPRB, &
  & 0.22038036E-07_JPRB, 0.19944576E-07_JPRB, 0.19301657E-07_JPRB, 0.19465307E-07_JPRB  /)

RGHG7(:,89, 3) = (/ &
  & 0.70216687E-08_JPRB, 0.69693507E-08_JPRB, 0.60683840E-08_JPRB, 0.58792606E-08_JPRB, 0.59499161E-08_JPRB, 0.53175690E-08_JPRB, &
  & 0.45145070E-08_JPRB, 0.37335640E-08_JPRB, 0.27325031E-08_JPRB, 0.19195744E-08_JPRB, 0.15401411E-08_JPRB, 0.12800295E-08_JPRB, &
  & 0.11506374E-08_JPRB, 0.11039434E-08_JPRB, 0.11441391E-08_JPRB, 0.12780708E-08_JPRB, 0.15482289E-08_JPRB, 0.19553951E-08_JPRB, &
  & 0.26338372E-08_JPRB, 0.34709174E-08_JPRB, 0.42994023E-08_JPRB, 0.50899600E-08_JPRB, 0.58389064E-08_JPRB, 0.62487010E-08_JPRB, &
  & 0.64116021E-08_JPRB, 0.66309341E-08_JPRB, 0.67705179E-08_JPRB, 0.69257555E-08_JPRB, 0.69903361E-08_JPRB, 0.69574017E-08_JPRB, &
  & 0.67626329E-08_JPRB, 0.72344680E-08_JPRB, 0.89155698E-08_JPRB, 0.11927014E-07_JPRB, 0.14958539E-07_JPRB, 0.17252791E-07_JPRB, &
  & 0.18518642E-07_JPRB, 0.20177647E-07_JPRB, 0.21953953E-07_JPRB, 0.24095745E-07_JPRB, 0.26212645E-07_JPRB, 0.27654435E-07_JPRB, &
  & 0.28783349E-07_JPRB, 0.28864974E-07_JPRB, 0.28175303E-07_JPRB, 0.26339988E-07_JPRB, 0.24689819E-07_JPRB, 0.23701767E-07_JPRB, &
  & 0.22920351E-07_JPRB, 0.22696015E-07_JPRB, 0.22277670E-07_JPRB, 0.22158345E-07_JPRB, 0.21787068E-07_JPRB, 0.20898653E-07_JPRB, &
  & 0.20703449E-07_JPRB, 0.19775532E-07_JPRB, 0.19495327E-07_JPRB, 0.19642515E-07_JPRB, 0.20973562E-07_JPRB, 0.21687871E-07_JPRB, &
  & 0.21121518E-07_JPRB, 0.18425033E-07_JPRB, 0.17286930E-07_JPRB, 0.16993015E-07_JPRB  /)

RGHG7(:,90, 3) = (/ &
  & 0.59295426E-08_JPRB, 0.62457440E-08_JPRB, 0.53085006E-08_JPRB, 0.51373021E-08_JPRB, 0.54153227E-08_JPRB, 0.49687575E-08_JPRB, &
  & 0.43328304E-08_JPRB, 0.36695929E-08_JPRB, 0.27095697E-08_JPRB, 0.19111568E-08_JPRB, 0.15346932E-08_JPRB, 0.12760665E-08_JPRB, &
  & 0.11461907E-08_JPRB, 0.10970276E-08_JPRB, 0.11357216E-08_JPRB, 0.12671673E-08_JPRB, 0.15286985E-08_JPRB, 0.19189638E-08_JPRB, &
  & 0.25588973E-08_JPRB, 0.33426003E-08_JPRB, 0.41227938E-08_JPRB, 0.48764755E-08_JPRB, 0.56064083E-08_JPRB, 0.60067225E-08_JPRB, &
  & 0.61850229E-08_JPRB, 0.64129650E-08_JPRB, 0.65777071E-08_JPRB, 0.67395526E-08_JPRB, 0.67842325E-08_JPRB, 0.67022852E-08_JPRB, &
  & 0.65469048E-08_JPRB, 0.69699455E-08_JPRB, 0.85803968E-08_JPRB, 0.11562570E-07_JPRB, 0.14546489E-07_JPRB, 0.16779991E-07_JPRB, &
  & 0.17984133E-07_JPRB, 0.19539956E-07_JPRB, 0.21090856E-07_JPRB, 0.22862902E-07_JPRB, 0.24707321E-07_JPRB, 0.25962426E-07_JPRB, &
  & 0.26937338E-07_JPRB, 0.27075565E-07_JPRB, 0.26464284E-07_JPRB, 0.24741180E-07_JPRB, 0.23263248E-07_JPRB, 0.22327033E-07_JPRB, &
  & 0.21782735E-07_JPRB, 0.21812250E-07_JPRB, 0.21452212E-07_JPRB, 0.21468837E-07_JPRB, 0.21249302E-07_JPRB, 0.20216354E-07_JPRB, &
  & 0.19956720E-07_JPRB, 0.18774302E-07_JPRB, 0.18189493E-07_JPRB, 0.18464478E-07_JPRB, 0.20185607E-07_JPRB, 0.20760004E-07_JPRB, &
  & 0.19919780E-07_JPRB, 0.16970999E-07_JPRB, 0.15803537E-07_JPRB, 0.15249743E-07_JPRB  /)

RGHG7(:,91, 3) = (/ &
  & 0.52474108E-08_JPRB, 0.58804192E-08_JPRB, 0.47453698E-08_JPRB, 0.45445533E-08_JPRB, 0.48479608E-08_JPRB, 0.47219048E-08_JPRB, &
  & 0.42002186E-08_JPRB, 0.36332396E-08_JPRB, 0.26859099E-08_JPRB, 0.19028349E-08_JPRB, 0.15284869E-08_JPRB, 0.12709180E-08_JPRB, &
  & 0.11410421E-08_JPRB, 0.10902923E-08_JPRB, 0.11273997E-08_JPRB, 0.12567298E-08_JPRB, 0.15055676E-08_JPRB, 0.18815527E-08_JPRB, &
  & 0.24818192E-08_JPRB, 0.31994106E-08_JPRB, 0.39060880E-08_JPRB, 0.46105826E-08_JPRB, 0.53510932E-08_JPRB, 0.57270784E-08_JPRB, &
  & 0.59180723E-08_JPRB, 0.61581789E-08_JPRB, 0.63382588E-08_JPRB, 0.65101533E-08_JPRB, 0.65527177E-08_JPRB, 0.64506724E-08_JPRB, &
  & 0.63169767E-08_JPRB, 0.67267950E-08_JPRB, 0.83060417E-08_JPRB, 0.11234797E-07_JPRB, 0.14151546E-07_JPRB, 0.16315234E-07_JPRB, &
  & 0.17495576E-07_JPRB, 0.19001154E-07_JPRB, 0.20415600E-07_JPRB, 0.21832229E-07_JPRB, 0.23246130E-07_JPRB, 0.24243664E-07_JPRB, &
  & 0.24695501E-07_JPRB, 0.25062209E-07_JPRB, 0.24482133E-07_JPRB, 0.22971644E-07_JPRB, 0.21814221E-07_JPRB, 0.20849975E-07_JPRB, &
  & 0.20521465E-07_JPRB, 0.20775760E-07_JPRB, 0.20591315E-07_JPRB, 0.20684629E-07_JPRB, 0.20597317E-07_JPRB, 0.19445897E-07_JPRB, &
  & 0.18863638E-07_JPRB, 0.17238008E-07_JPRB, 0.16383992E-07_JPRB, 0.16829281E-07_JPRB, 0.19271820E-07_JPRB, 0.19736208E-07_JPRB, &
  & 0.18436904E-07_JPRB, 0.14703246E-07_JPRB, 0.14971729E-07_JPRB, 0.14231764E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ---GEMS----

RGHG7(:, 1, 4) = (/ &
  & 0.59702215E-05_JPRB, 0.59483759E-05_JPRB, 0.59300851E-05_JPRB, 0.59114982E-05_JPRB, 0.58737091E-05_JPRB, 0.66917409E-07_JPRB, &
  & 0.65816742E-07_JPRB, 0.65589710E-07_JPRB, 0.65634701E-07_JPRB, 0.65847580E-07_JPRB, 0.66161192E-07_JPRB, 0.66510069E-07_JPRB, &
  & 0.66948736E-07_JPRB, 0.67411904E-07_JPRB, 0.67852753E-07_JPRB, 0.68201352E-07_JPRB, 0.68550584E-07_JPRB, 0.68862192E-07_JPRB, &
  & 0.69130756E-07_JPRB, 0.69346910E-07_JPRB, 0.69542224E-07_JPRB, 0.69608525E-07_JPRB, 0.69638119E-07_JPRB, 0.69557537E-07_JPRB, &
  & 0.69324045E-07_JPRB, 0.68920642E-07_JPRB, 0.68440301E-07_JPRB, 0.67991671E-07_JPRB, 0.67648131E-07_JPRB, 0.67430939E-07_JPRB, &
  & 0.67356602E-07_JPRB, 0.67355209E-07_JPRB, 0.67616391E-07_JPRB, 0.68042866E-07_JPRB, 0.68586765E-07_JPRB, 0.69139304E-07_JPRB, &
  & 0.69687218E-07_JPRB, 0.70121352E-07_JPRB, 0.70487104E-07_JPRB, 0.70705944E-07_JPRB, 0.70807040E-07_JPRB, 0.70786051E-07_JPRB, &
  & 0.70629966E-07_JPRB, 0.70454909E-07_JPRB, 0.70258025E-07_JPRB, 0.70097549E-07_JPRB, 0.69747550E-07_JPRB, 0.69538466E-07_JPRB, &
  & 0.69256373E-07_JPRB, 0.68990531E-07_JPRB, 0.68810508E-07_JPRB, 0.68807473E-07_JPRB, 0.68909699E-07_JPRB, 0.69059993E-07_JPRB, &
  & 0.69440475E-07_JPRB, 0.70274311E-07_JPRB, 0.72364706E-07_JPRB, 0.74118660E-07_JPRB, 0.74963346E-07_JPRB, 0.75638617E-07_JPRB, &
  & 0.76963751E-07_JPRB, 0.79699483E-07_JPRB, 0.84497692E-07_JPRB, 0.92524623E-07_JPRB  /)

RGHG7(:, 2, 4) = (/ &
  & 0.61264091E-05_JPRB, 0.62005356E-05_JPRB, 0.61010333E-05_JPRB, 0.59417976E-05_JPRB, 0.52072810E-05_JPRB, 0.15123790E-06_JPRB, &
  & 0.14738200E-06_JPRB, 0.15045774E-06_JPRB, 0.15404859E-06_JPRB, 0.16042370E-06_JPRB, 0.16796463E-06_JPRB, 0.17096993E-06_JPRB, &
  & 0.17612759E-06_JPRB, 0.18196046E-06_JPRB, 0.18691067E-06_JPRB, 0.18642082E-06_JPRB, 0.18908324E-06_JPRB, 0.19312633E-06_JPRB, &
  & 0.19711013E-06_JPRB, 0.20054604E-06_JPRB, 0.20362057E-06_JPRB, 0.20242811E-06_JPRB, 0.20306412E-06_JPRB, 0.20563027E-06_JPRB, &
  & 0.20981497E-06_JPRB, 0.21414307E-06_JPRB, 0.21723797E-06_JPRB, 0.21875761E-06_JPRB, 0.21904614E-06_JPRB, 0.21824711E-06_JPRB, &
  & 0.21751204E-06_JPRB, 0.20962493E-06_JPRB, 0.20562426E-06_JPRB, 0.20493080E-06_JPRB, 0.20548077E-06_JPRB, 0.20645240E-06_JPRB, &
  & 0.20800506E-06_JPRB, 0.20967916E-06_JPRB, 0.21198983E-06_JPRB, 0.21457882E-06_JPRB, 0.21691289E-06_JPRB, 0.21853026E-06_JPRB, &
  & 0.21815268E-06_JPRB, 0.22137037E-06_JPRB, 0.22607198E-06_JPRB, 0.23396379E-06_JPRB, 0.24121991E-06_JPRB, 0.25078134E-06_JPRB, &
  & 0.25990107E-06_JPRB, 0.26626262E-06_JPRB, 0.27562541E-06_JPRB, 0.29364605E-06_JPRB, 0.31524095E-06_JPRB, 0.33981664E-06_JPRB, &
  & 0.38809313E-06_JPRB, 0.48764542E-06_JPRB, 0.69689190E-06_JPRB, 0.89062257E-06_JPRB, 0.10071971E-05_JPRB, 0.11137674E-05_JPRB, &
  & 0.12525092E-05_JPRB, 0.14632006E-05_JPRB, 0.17566417E-05_JPRB, 0.21766068E-05_JPRB  /)

RGHG7(:, 3, 4) = (/ &
  & 0.57752522E-05_JPRB, 0.50023336E-05_JPRB, 0.41032927E-05_JPRB, 0.31900877E-05_JPRB, 0.22070478E-05_JPRB, 0.17837307E-06_JPRB, &
  & 0.18748544E-06_JPRB, 0.20831938E-06_JPRB, 0.23096182E-06_JPRB, 0.25618053E-06_JPRB, 0.28204863E-06_JPRB, 0.29678120E-06_JPRB, &
  & 0.31180008E-06_JPRB, 0.32645644E-06_JPRB, 0.34175795E-06_JPRB, 0.34593390E-06_JPRB, 0.35148872E-06_JPRB, 0.35909875E-06_JPRB, &
  & 0.36757288E-06_JPRB, 0.37351876E-06_JPRB, 0.38018945E-06_JPRB, 0.37899619E-06_JPRB, 0.38137296E-06_JPRB, 0.38714271E-06_JPRB, &
  & 0.39337263E-06_JPRB, 0.39831909E-06_JPRB, 0.40238569E-06_JPRB, 0.40444115E-06_JPRB, 0.40737899E-06_JPRB, 0.40690369E-06_JPRB, &
  & 0.41091420E-06_JPRB, 0.40205049E-06_JPRB, 0.39663195E-06_JPRB, 0.39734084E-06_JPRB, 0.40096430E-06_JPRB, 0.40467853E-06_JPRB, &
  & 0.40908543E-06_JPRB, 0.41313871E-06_JPRB, 0.41835941E-06_JPRB, 0.42348518E-06_JPRB, 0.42861291E-06_JPRB, 0.43169095E-06_JPRB, &
  & 0.42965013E-06_JPRB, 0.43653503E-06_JPRB, 0.44722731E-06_JPRB, 0.46222681E-06_JPRB, 0.47893730E-06_JPRB, 0.49693853E-06_JPRB, &
  & 0.51362616E-06_JPRB, 0.52684459E-06_JPRB, 0.54628674E-06_JPRB, 0.57611339E-06_JPRB, 0.61155941E-06_JPRB, 0.64430907E-06_JPRB, &
  & 0.70395856E-06_JPRB, 0.83145744E-06_JPRB, 0.11161645E-05_JPRB, 0.13762310E-05_JPRB, 0.14460247E-05_JPRB, 0.15409397E-05_JPRB, &
  & 0.16474675E-05_JPRB, 0.18997418E-05_JPRB, 0.22361505E-05_JPRB, 0.28795930E-05_JPRB  /)

RGHG7(:, 4, 4) = (/ &
  & 0.39239595E-05_JPRB, 0.31932729E-05_JPRB, 0.28670647E-05_JPRB, 0.26875866E-05_JPRB, 0.25768991E-05_JPRB, 0.17492168E-05_JPRB, &
  & 0.17372777E-05_JPRB, 0.17026857E-05_JPRB, 0.16327149E-05_JPRB, 0.15339728E-05_JPRB, 0.14360934E-05_JPRB, 0.13366598E-05_JPRB, &
  & 0.12620463E-05_JPRB, 0.12139737E-05_JPRB, 0.11845514E-05_JPRB, 0.11682929E-05_JPRB, 0.11569411E-05_JPRB, 0.11586143E-05_JPRB, &
  & 0.11611733E-05_JPRB, 0.11616415E-05_JPRB, 0.11619171E-05_JPRB, 0.11549311E-05_JPRB, 0.11565310E-05_JPRB, 0.11663848E-05_JPRB, &
  & 0.11799936E-05_JPRB, 0.11857720E-05_JPRB, 0.11917300E-05_JPRB, 0.11960946E-05_JPRB, 0.11992895E-05_JPRB, 0.11927824E-05_JPRB, &
  & 0.11752249E-05_JPRB, 0.11330306E-05_JPRB, 0.10846253E-05_JPRB, 0.10470715E-05_JPRB, 0.10218495E-05_JPRB, 0.99669082E-06_JPRB, &
  & 0.97703391E-06_JPRB, 0.95123313E-06_JPRB, 0.93313613E-06_JPRB, 0.91879173E-06_JPRB, 0.90795050E-06_JPRB, 0.89695963E-06_JPRB, &
  & 0.88826658E-06_JPRB, 0.90332336E-06_JPRB, 0.93469546E-06_JPRB, 0.98398258E-06_JPRB, 0.10481520E-05_JPRB, 0.11111375E-05_JPRB, &
  & 0.11534721E-05_JPRB, 0.11715239E-05_JPRB, 0.11849982E-05_JPRB, 0.11926322E-05_JPRB, 0.12043732E-05_JPRB, 0.12090191E-05_JPRB, &
  & 0.12227091E-05_JPRB, 0.12421239E-05_JPRB, 0.13027494E-05_JPRB, 0.13475492E-05_JPRB, 0.13833748E-05_JPRB, 0.14750604E-05_JPRB, &
  & 0.15630958E-05_JPRB, 0.17181411E-05_JPRB, 0.18227861E-05_JPRB, 0.19413018E-05_JPRB  /)

RGHG7(:, 5, 4) = (/ &
  & 0.31261460E-05_JPRB, 0.31035083E-05_JPRB, 0.30822871E-05_JPRB, 0.30515182E-05_JPRB, 0.30559091E-05_JPRB, 0.30924227E-05_JPRB, &
  & 0.30962289E-05_JPRB, 0.30395948E-05_JPRB, 0.29140982E-05_JPRB, 0.27139205E-05_JPRB, 0.24860566E-05_JPRB, 0.22623964E-05_JPRB, &
  & 0.20825748E-05_JPRB, 0.19531371E-05_JPRB, 0.18608274E-05_JPRB, 0.18105415E-05_JPRB, 0.17746689E-05_JPRB, 0.17575609E-05_JPRB, &
  & 0.17399731E-05_JPRB, 0.17203598E-05_JPRB, 0.16969705E-05_JPRB, 0.16787100E-05_JPRB, 0.16742543E-05_JPRB, 0.16803522E-05_JPRB, &
  & 0.16917850E-05_JPRB, 0.16936474E-05_JPRB, 0.16956709E-05_JPRB, 0.16999107E-05_JPRB, 0.16998986E-05_JPRB, 0.16918915E-05_JPRB, &
  & 0.16558339E-05_JPRB, 0.15915137E-05_JPRB, 0.15050708E-05_JPRB, 0.14290999E-05_JPRB, 0.13701707E-05_JPRB, 0.13118123E-05_JPRB, &
  & 0.12601300E-05_JPRB, 0.12041735E-05_JPRB, 0.11629297E-05_JPRB, 0.11290414E-05_JPRB, 0.11032144E-05_JPRB, 0.10837051E-05_JPRB, &
  & 0.10778689E-05_JPRB, 0.11000379E-05_JPRB, 0.11502925E-05_JPRB, 0.12358057E-05_JPRB, 0.13449864E-05_JPRB, 0.14510811E-05_JPRB, &
  & 0.15262262E-05_JPRB, 0.15637832E-05_JPRB, 0.15849824E-05_JPRB, 0.15940726E-05_JPRB, 0.16124636E-05_JPRB, 0.16299650E-05_JPRB, &
  & 0.16612455E-05_JPRB, 0.16890324E-05_JPRB, 0.17244530E-05_JPRB, 0.17410958E-05_JPRB, 0.17658478E-05_JPRB, 0.18173041E-05_JPRB, &
  & 0.18843184E-05_JPRB, 0.19334584E-05_JPRB, 0.19802141E-05_JPRB, 0.20074864E-05_JPRB  /)

RGHG7(:, 6, 4) = (/ &
  & 0.31973640E-05_JPRB, 0.31909845E-05_JPRB, 0.31519749E-05_JPRB, 0.31244385E-05_JPRB, 0.31311247E-05_JPRB, 0.31707943E-05_JPRB, &
  & 0.31747535E-05_JPRB, 0.31242975E-05_JPRB, 0.30112528E-05_JPRB, 0.28149388E-05_JPRB, 0.25803804E-05_JPRB, 0.23490692E-05_JPRB, &
  & 0.21575036E-05_JPRB, 0.20161495E-05_JPRB, 0.19153664E-05_JPRB, 0.18564158E-05_JPRB, 0.18175594E-05_JPRB, 0.18013312E-05_JPRB, &
  & 0.17855606E-05_JPRB, 0.17656604E-05_JPRB, 0.17419268E-05_JPRB, 0.17224421E-05_JPRB, 0.17144670E-05_JPRB, 0.17155153E-05_JPRB, &
  & 0.17208082E-05_JPRB, 0.17220204E-05_JPRB, 0.17235273E-05_JPRB, 0.17286088E-05_JPRB, 0.17336080E-05_JPRB, 0.17351837E-05_JPRB, &
  & 0.17175265E-05_JPRB, 0.16705165E-05_JPRB, 0.15914567E-05_JPRB, 0.15168056E-05_JPRB, 0.14585267E-05_JPRB, 0.13979114E-05_JPRB, &
  & 0.13395154E-05_JPRB, 0.12863706E-05_JPRB, 0.12477473E-05_JPRB, 0.12145093E-05_JPRB, 0.11908627E-05_JPRB, 0.11754276E-05_JPRB, &
  & 0.11684055E-05_JPRB, 0.11841477E-05_JPRB, 0.12306533E-05_JPRB, 0.13160900E-05_JPRB, 0.14153246E-05_JPRB, 0.15124295E-05_JPRB, &
  & 0.15843229E-05_JPRB, 0.16197950E-05_JPRB, 0.16409942E-05_JPRB, 0.16508687E-05_JPRB, 0.16674426E-05_JPRB, 0.16807934E-05_JPRB, &
  & 0.17086691E-05_JPRB, 0.17343330E-05_JPRB, 0.17680703E-05_JPRB, 0.17875631E-05_JPRB, 0.18146104E-05_JPRB, 0.18620309E-05_JPRB, &
  & 0.19294468E-05_JPRB, 0.19909048E-05_JPRB, 0.20501697E-05_JPRB, 0.20741521E-05_JPRB  /)

RGHG7(:, 7, 4) = (/ &
  & 0.33241681E-05_JPRB, 0.33130592E-05_JPRB, 0.32747375E-05_JPRB, 0.32556146E-05_JPRB, 0.32737206E-05_JPRB, 0.33185628E-05_JPRB, &
  & 0.33322992E-05_JPRB, 0.32911650E-05_JPRB, 0.31941808E-05_JPRB, 0.30145994E-05_JPRB, 0.27865097E-05_JPRB, 0.25507693E-05_JPRB, &
  & 0.23477853E-05_JPRB, 0.21928273E-05_JPRB, 0.20812103E-05_JPRB, 0.20086047E-05_JPRB, 0.19599305E-05_JPRB, 0.19388328E-05_JPRB, &
  & 0.19194635E-05_JPRB, 0.18972083E-05_JPRB, 0.18738611E-05_JPRB, 0.18507942E-05_JPRB, 0.18377246E-05_JPRB, 0.18348091E-05_JPRB, &
  & 0.18370709E-05_JPRB, 0.18363117E-05_JPRB, 0.18372635E-05_JPRB, 0.18447805E-05_JPRB, 0.18525377E-05_JPRB, 0.18595218E-05_JPRB, &
  & 0.18538358E-05_JPRB, 0.18266041E-05_JPRB, 0.17669708E-05_JPRB, 0.17087917E-05_JPRB, 0.16527897E-05_JPRB, 0.15916935E-05_JPRB, &
  & 0.15321035E-05_JPRB, 0.14799565E-05_JPRB, 0.14440492E-05_JPRB, 0.14197878E-05_JPRB, 0.14056021E-05_JPRB, 0.13982009E-05_JPRB, &
  & 0.13976407E-05_JPRB, 0.14129289E-05_JPRB, 0.14524518E-05_JPRB, 0.15234958E-05_JPRB, 0.16015565E-05_JPRB, 0.16804852E-05_JPRB, &
  & 0.17405361E-05_JPRB, 0.17712532E-05_JPRB, 0.17903138E-05_JPRB, 0.17984909E-05_JPRB, 0.18077300E-05_JPRB, 0.18152617E-05_JPRB, &
  & 0.18376014E-05_JPRB, 0.18600760E-05_JPRB, 0.18905570E-05_JPRB, 0.19085654E-05_JPRB, 0.19360336E-05_JPRB, 0.19817327E-05_JPRB, &
  & 0.20466537E-05_JPRB, 0.21159690E-05_JPRB, 0.21837301E-05_JPRB, 0.22094385E-05_JPRB  /)

RGHG7(:, 8, 4) = (/ &
  & 0.34708457E-05_JPRB, 0.34663633E-05_JPRB, 0.34397555E-05_JPRB, 0.34388099E-05_JPRB, 0.34838734E-05_JPRB, 0.35492919E-05_JPRB, &
  & 0.35862524E-05_JPRB, 0.35645144E-05_JPRB, 0.34881213E-05_JPRB, 0.33372723E-05_JPRB, 0.31389998E-05_JPRB, 0.29201661E-05_JPRB, &
  & 0.27194443E-05_JPRB, 0.25588578E-05_JPRB, 0.24330841E-05_JPRB, 0.23428624E-05_JPRB, 0.22756983E-05_JPRB, 0.22421671E-05_JPRB, &
  & 0.22128756E-05_JPRB, 0.21853669E-05_JPRB, 0.21619820E-05_JPRB, 0.21365873E-05_JPRB, 0.21180532E-05_JPRB, 0.21062736E-05_JPRB, &
  & 0.21002949E-05_JPRB, 0.20949386E-05_JPRB, 0.20945610E-05_JPRB, 0.21009744E-05_JPRB, 0.21066847E-05_JPRB, 0.21138867E-05_JPRB, &
  & 0.21157380E-05_JPRB, 0.21089967E-05_JPRB, 0.20771974E-05_JPRB, 0.20433834E-05_JPRB, 0.20002700E-05_JPRB, 0.19504083E-05_JPRB, &
  & 0.19043323E-05_JPRB, 0.18644174E-05_JPRB, 0.18409856E-05_JPRB, 0.18308587E-05_JPRB, 0.18277309E-05_JPRB, 0.18304761E-05_JPRB, &
  & 0.18383945E-05_JPRB, 0.18549016E-05_JPRB, 0.18794385E-05_JPRB, 0.19236291E-05_JPRB, 0.19683927E-05_JPRB, 0.20111029E-05_JPRB, &
  & 0.20434425E-05_JPRB, 0.20568323E-05_JPRB, 0.20651599E-05_JPRB, 0.20654508E-05_JPRB, 0.20652709E-05_JPRB, 0.20669424E-05_JPRB, &
  & 0.20837949E-05_JPRB, 0.21029153E-05_JPRB, 0.21282126E-05_JPRB, 0.21398598E-05_JPRB, 0.21631370E-05_JPRB, 0.22019870E-05_JPRB, &
  & 0.22590653E-05_JPRB, 0.23249400E-05_JPRB, 0.23927979E-05_JPRB, 0.24202082E-05_JPRB  /)

RGHG7(:, 9, 4) = (/ &
  & 0.35718333E-05_JPRB, 0.35986630E-05_JPRB, 0.36136755E-05_JPRB, 0.36547416E-05_JPRB, 0.37603453E-05_JPRB, 0.38819395E-05_JPRB, &
  & 0.39717892E-05_JPRB, 0.39977868E-05_JPRB, 0.39655888E-05_JPRB, 0.38725298E-05_JPRB, 0.37425158E-05_JPRB, 0.35784918E-05_JPRB, &
  & 0.34072828E-05_JPRB, 0.32538037E-05_JPRB, 0.31113677E-05_JPRB, 0.29974731E-05_JPRB, 0.28979411E-05_JPRB, 0.28369926E-05_JPRB, &
  & 0.27862915E-05_JPRB, 0.27456602E-05_JPRB, 0.27172543E-05_JPRB, 0.26895334E-05_JPRB, 0.26666328E-05_JPRB, 0.26433921E-05_JPRB, &
  & 0.26244499E-05_JPRB, 0.26081535E-05_JPRB, 0.25989773E-05_JPRB, 0.25927352E-05_JPRB, 0.25860001E-05_JPRB, 0.25833211E-05_JPRB, &
  & 0.25809588E-05_JPRB, 0.25845682E-05_JPRB, 0.25802884E-05_JPRB, 0.25750927E-05_JPRB, 0.25617107E-05_JPRB, 0.25429778E-05_JPRB, &
  & 0.25302399E-05_JPRB, 0.25191076E-05_JPRB, 0.25191781E-05_JPRB, 0.25275115E-05_JPRB, 0.25368104E-05_JPRB, 0.25486457E-05_JPRB, &
  & 0.25595355E-05_JPRB, 0.25710386E-05_JPRB, 0.25719148E-05_JPRB, 0.25812778E-05_JPRB, 0.25819368E-05_JPRB, 0.25732715E-05_JPRB, &
  & 0.25631676E-05_JPRB, 0.25435588E-05_JPRB, 0.25301421E-05_JPRB, 0.25166513E-05_JPRB, 0.25104553E-05_JPRB, 0.25099244E-05_JPRB, &
  & 0.25252788E-05_JPRB, 0.25422879E-05_JPRB, 0.25630454E-05_JPRB, 0.25658045E-05_JPRB, 0.25792985E-05_JPRB, 0.26057512E-05_JPRB, &
  & 0.26507143E-05_JPRB, 0.27034092E-05_JPRB, 0.27633375E-05_JPRB, 0.27904753E-05_JPRB  /)

RGHG7(:,10, 4) = (/ &
  & 0.34737254E-05_JPRB, 0.35569472E-05_JPRB, 0.36718570E-05_JPRB, 0.38034719E-05_JPRB, 0.40171165E-05_JPRB, 0.42565008E-05_JPRB, &
  & 0.44697739E-05_JPRB, 0.46202462E-05_JPRB, 0.47141623E-05_JPRB, 0.47481749E-05_JPRB, 0.47364430E-05_JPRB, 0.46662913E-05_JPRB, &
  & 0.45519617E-05_JPRB, 0.44133736E-05_JPRB, 0.42538649E-05_JPRB, 0.41035699E-05_JPRB, 0.39521626E-05_JPRB, 0.38383602E-05_JPRB, &
  & 0.37447556E-05_JPRB, 0.36708612E-05_JPRB, 0.36196311E-05_JPRB, 0.35797371E-05_JPRB, 0.35509759E-05_JPRB, 0.35213040E-05_JPRB, &
  & 0.34906799E-05_JPRB, 0.34530460E-05_JPRB, 0.34179549E-05_JPRB, 0.33803563E-05_JPRB, 0.33441850E-05_JPRB, 0.33151879E-05_JPRB, &
  & 0.32912226E-05_JPRB, 0.32830420E-05_JPRB, 0.32906503E-05_JPRB, 0.33096018E-05_JPRB, 0.33332125E-05_JPRB, 0.33570129E-05_JPRB, &
  & 0.33839621E-05_JPRB, 0.34066638E-05_JPRB, 0.34316128E-05_JPRB, 0.34595836E-05_JPRB, 0.34835549E-05_JPRB, 0.35009615E-05_JPRB, &
  & 0.35056453E-05_JPRB, 0.35024779E-05_JPRB, 0.34791608E-05_JPRB, 0.34602872E-05_JPRB, 0.34225596E-05_JPRB, 0.33751502E-05_JPRB, &
  & 0.33341175E-05_JPRB, 0.32894449E-05_JPRB, 0.32622270E-05_JPRB, 0.32444522E-05_JPRB, 0.32448420E-05_JPRB, 0.32519048E-05_JPRB, &
  & 0.32776138E-05_JPRB, 0.33012125E-05_JPRB, 0.33257744E-05_JPRB, 0.33241376E-05_JPRB, 0.33260530E-05_JPRB, 0.33362285E-05_JPRB, &
  & 0.33648416E-05_JPRB, 0.34040648E-05_JPRB, 0.34570834E-05_JPRB, 0.34838154E-05_JPRB  /)

RGHG7(:,11, 4) = (/ &
  & 0.32046267E-05_JPRB, 0.33431506E-05_JPRB, 0.35737300E-05_JPRB, 0.38236535E-05_JPRB, 0.41471157E-05_JPRB, 0.45267745E-05_JPRB, &
  & 0.49164290E-05_JPRB, 0.52635221E-05_JPRB, 0.55663266E-05_JPRB, 0.57913735E-05_JPRB, 0.59337723E-05_JPRB, 0.59827748E-05_JPRB, &
  & 0.59517818E-05_JPRB, 0.58563512E-05_JPRB, 0.57113137E-05_JPRB, 0.55438070E-05_JPRB, 0.53542744E-05_JPRB, 0.51831840E-05_JPRB, &
  & 0.50310059E-05_JPRB, 0.49020648E-05_JPRB, 0.48052311E-05_JPRB, 0.47389817E-05_JPRB, 0.46974334E-05_JPRB, 0.46609827E-05_JPRB, &
  & 0.46150643E-05_JPRB, 0.45490109E-05_JPRB, 0.44773734E-05_JPRB, 0.43971065E-05_JPRB, 0.43174548E-05_JPRB, 0.42477829E-05_JPRB, &
  & 0.41967580E-05_JPRB, 0.41683356E-05_JPRB, 0.41744094E-05_JPRB, 0.42060476E-05_JPRB, 0.42565392E-05_JPRB, 0.43156975E-05_JPRB, &
  & 0.43714190E-05_JPRB, 0.44174115E-05_JPRB, 0.44603001E-05_JPRB, 0.45013869E-05_JPRB, 0.45350649E-05_JPRB, 0.45549435E-05_JPRB, &
  & 0.45549223E-05_JPRB, 0.45436526E-05_JPRB, 0.45096467E-05_JPRB, 0.44818531E-05_JPRB, 0.44390062E-05_JPRB, 0.43961918E-05_JPRB, &
  & 0.43722087E-05_JPRB, 0.43558676E-05_JPRB, 0.43630378E-05_JPRB, 0.43759356E-05_JPRB, 0.43999907E-05_JPRB, 0.44218011E-05_JPRB, &
  & 0.44588575E-05_JPRB, 0.44888657E-05_JPRB, 0.45123920E-05_JPRB, 0.45008062E-05_JPRB, 0.44812459E-05_JPRB, 0.44572541E-05_JPRB, &
  & 0.44485782E-05_JPRB, 0.44589719E-05_JPRB, 0.44915718E-05_JPRB, 0.45103201E-05_JPRB  /)

RGHG7(:,12, 4) = (/ &
  & 0.31680496E-05_JPRB, 0.33102163E-05_JPRB, 0.35729803E-05_JPRB, 0.38686027E-05_JPRB, 0.42339654E-05_JPRB, 0.46816202E-05_JPRB, &
  & 0.51719155E-05_JPRB, 0.56535572E-05_JPRB, 0.60998274E-05_JPRB, 0.64662079E-05_JPRB, 0.67361321E-05_JPRB, 0.68983434E-05_JPRB, &
  & 0.69726760E-05_JPRB, 0.69742668E-05_JPRB, 0.69179701E-05_JPRB, 0.68198022E-05_JPRB, 0.66800428E-05_JPRB, 0.65227755E-05_JPRB, &
  & 0.63617243E-05_JPRB, 0.62101224E-05_JPRB, 0.60881814E-05_JPRB, 0.60048975E-05_JPRB, 0.59509188E-05_JPRB, 0.59037412E-05_JPRB, &
  & 0.58398480E-05_JPRB, 0.57508733E-05_JPRB, 0.56492205E-05_JPRB, 0.55328118E-05_JPRB, 0.54168421E-05_JPRB, 0.53174219E-05_JPRB, &
  & 0.52508023E-05_JPRB, 0.52177533E-05_JPRB, 0.52278647E-05_JPRB, 0.52700608E-05_JPRB, 0.53417868E-05_JPRB, 0.54290570E-05_JPRB, &
  & 0.55058222E-05_JPRB, 0.55663750E-05_JPRB, 0.56160357E-05_JPRB, 0.56559423E-05_JPRB, 0.56825641E-05_JPRB, 0.56943478E-05_JPRB, &
  & 0.56892673E-05_JPRB, 0.56792465E-05_JPRB, 0.56586571E-05_JPRB, 0.56503523E-05_JPRB, 0.56456381E-05_JPRB, 0.56568780E-05_JPRB, &
  & 0.57037319E-05_JPRB, 0.57728669E-05_JPRB, 0.58536709E-05_JPRB, 0.59098096E-05_JPRB, 0.59426641E-05_JPRB, 0.59456756E-05_JPRB, &
  & 0.59380724E-05_JPRB, 0.59183793E-05_JPRB, 0.58942647E-05_JPRB, 0.58434423E-05_JPRB, 0.57770355E-05_JPRB, 0.56990319E-05_JPRB, &
  & 0.56372128E-05_JPRB, 0.56000262E-05_JPRB, 0.55868158E-05_JPRB, 0.55859685E-05_JPRB  /)

RGHG7(:,13, 4) = (/ &
  & 0.32518764E-05_JPRB, 0.33966459E-05_JPRB, 0.36266267E-05_JPRB, 0.38931329E-05_JPRB, 0.42505449E-05_JPRB, 0.47198691E-05_JPRB, &
  & 0.52390641E-05_JPRB, 0.57690304E-05_JPRB, 0.62625839E-05_JPRB, 0.66831096E-05_JPRB, 0.70180606E-05_JPRB, 0.72482850E-05_JPRB, &
  & 0.73992580E-05_JPRB, 0.74915097E-05_JPRB, 0.75383029E-05_JPRB, 0.75510787E-05_JPRB, 0.75243657E-05_JPRB, 0.74641764E-05_JPRB, &
  & 0.73845231E-05_JPRB, 0.72920611E-05_JPRB, 0.72060642E-05_JPRB, 0.71349656E-05_JPRB, 0.70789467E-05_JPRB, 0.70308849E-05_JPRB, &
  & 0.69689176E-05_JPRB, 0.68889168E-05_JPRB, 0.67887181E-05_JPRB, 0.66728318E-05_JPRB, 0.65606633E-05_JPRB, 0.64680625E-05_JPRB, &
  & 0.64078658E-05_JPRB, 0.63830112E-05_JPRB, 0.63985620E-05_JPRB, 0.64447308E-05_JPRB, 0.65183388E-05_JPRB, 0.66053134E-05_JPRB, &
  & 0.66805121E-05_JPRB, 0.67342513E-05_JPRB, 0.67678779E-05_JPRB, 0.67858980E-05_JPRB, 0.67870062E-05_JPRB, 0.67771424E-05_JPRB, &
  & 0.67631338E-05_JPRB, 0.67589658E-05_JPRB, 0.67654141E-05_JPRB, 0.67998483E-05_JPRB, 0.68587930E-05_JPRB, 0.69490889E-05_JPRB, &
  & 0.70813057E-05_JPRB, 0.72278267E-05_JPRB, 0.73354769E-05_JPRB, 0.73674374E-05_JPRB, 0.73374108E-05_JPRB, 0.72574561E-05_JPRB, &
  & 0.71531369E-05_JPRB, 0.70507570E-05_JPRB, 0.69615336E-05_JPRB, 0.68657849E-05_JPRB, 0.67613425E-05_JPRB, 0.66506638E-05_JPRB, &
  & 0.65563625E-05_JPRB, 0.64824612E-05_JPRB, 0.64369330E-05_JPRB, 0.64189526E-05_JPRB  /)

RGHG7(:,14, 4) = (/ &
  & 0.32294306E-05_JPRB, 0.33751334E-05_JPRB, 0.35684140E-05_JPRB, 0.38053630E-05_JPRB, 0.41383603E-05_JPRB, 0.45867233E-05_JPRB, &
  & 0.50904607E-05_JPRB, 0.56143390E-05_JPRB, 0.61115637E-05_JPRB, 0.65559168E-05_JPRB, 0.69288025E-05_JPRB, 0.72101114E-05_JPRB, &
  & 0.74183337E-05_JPRB, 0.75737344E-05_JPRB, 0.76953595E-05_JPRB, 0.78020110E-05_JPRB, 0.78822371E-05_JPRB, 0.79323066E-05_JPRB, &
  & 0.79636540E-05_JPRB, 0.79748415E-05_JPRB, 0.79638252E-05_JPRB, 0.79305670E-05_JPRB, 0.78906673E-05_JPRB, 0.78604129E-05_JPRB, &
  & 0.78322724E-05_JPRB, 0.78064497E-05_JPRB, 0.77654529E-05_JPRB, 0.77162817E-05_JPRB, 0.76720442E-05_JPRB, 0.76331922E-05_JPRB, &
  & 0.76079854E-05_JPRB, 0.75973667E-05_JPRB, 0.76012295E-05_JPRB, 0.76215505E-05_JPRB, 0.76607801E-05_JPRB, 0.77069616E-05_JPRB, &
  & 0.77420479E-05_JPRB, 0.77541282E-05_JPRB, 0.77433492E-05_JPRB, 0.77200234E-05_JPRB, 0.76883237E-05_JPRB, 0.76519437E-05_JPRB, &
  & 0.76269367E-05_JPRB, 0.76285290E-05_JPRB, 0.76551282E-05_JPRB, 0.77230575E-05_JPRB, 0.78262013E-05_JPRB, 0.79603615E-05_JPRB, &
  & 0.81147733E-05_JPRB, 0.82376084E-05_JPRB, 0.82600856E-05_JPRB, 0.81899948E-05_JPRB, 0.80575692E-05_JPRB, 0.78904396E-05_JPRB, &
  & 0.77187723E-05_JPRB, 0.75751178E-05_JPRB, 0.74558768E-05_JPRB, 0.73396329E-05_JPRB, 0.72277562E-05_JPRB, 0.71212324E-05_JPRB, &
  & 0.70178651E-05_JPRB, 0.69255391E-05_JPRB, 0.68640933E-05_JPRB, 0.68320572E-05_JPRB  /)

RGHG7(:,15, 4) = (/ &
  & 0.31501623E-05_JPRB, 0.32662461E-05_JPRB, 0.34301661E-05_JPRB, 0.36542271E-05_JPRB, 0.39435138E-05_JPRB, 0.43246481E-05_JPRB, &
  & 0.47706975E-05_JPRB, 0.52420042E-05_JPRB, 0.57145221E-05_JPRB, 0.61718779E-05_JPRB, 0.65885711E-05_JPRB, 0.69326238E-05_JPRB, &
  & 0.72041890E-05_JPRB, 0.74192685E-05_JPRB, 0.76084195E-05_JPRB, 0.77913275E-05_JPRB, 0.79470065E-05_JPRB, 0.80756239E-05_JPRB, &
  & 0.81989795E-05_JPRB, 0.83118370E-05_JPRB, 0.83869209E-05_JPRB, 0.84096557E-05_JPRB, 0.84092616E-05_JPRB, 0.84196681E-05_JPRB, &
  & 0.84522572E-05_JPRB, 0.85010626E-05_JPRB, 0.85443911E-05_JPRB, 0.85928157E-05_JPRB, 0.86427891E-05_JPRB, 0.86812167E-05_JPRB, &
  & 0.87020166E-05_JPRB, 0.86985397E-05_JPRB, 0.86741066E-05_JPRB, 0.86488085E-05_JPRB, 0.86390849E-05_JPRB, 0.86315010E-05_JPRB, &
  & 0.86080558E-05_JPRB, 0.85610654E-05_JPRB, 0.84990987E-05_JPRB, 0.84283986E-05_JPRB, 0.83529128E-05_JPRB, 0.82896632E-05_JPRB, &
  & 0.82535300E-05_JPRB, 0.82509879E-05_JPRB, 0.82798776E-05_JPRB, 0.83476198E-05_JPRB, 0.84487462E-05_JPRB, 0.85639315E-05_JPRB, &
  & 0.86577661E-05_JPRB, 0.86616708E-05_JPRB, 0.85467966E-05_JPRB, 0.83717016E-05_JPRB, 0.81608019E-05_JPRB, 0.79509374E-05_JPRB, &
  & 0.77628041E-05_JPRB, 0.76130835E-05_JPRB, 0.74880935E-05_JPRB, 0.73712217E-05_JPRB, 0.72602053E-05_JPRB, 0.71666464E-05_JPRB, &
  & 0.70690047E-05_JPRB, 0.69773823E-05_JPRB, 0.69032871E-05_JPRB, 0.68642518E-05_JPRB  /)

RGHG7(:,16, 4) = (/ &
  & 0.30812957E-05_JPRB, 0.31670960E-05_JPRB, 0.33020125E-05_JPRB, 0.34928034E-05_JPRB, 0.37319780E-05_JPRB, 0.40411731E-05_JPRB, &
  & 0.43986199E-05_JPRB, 0.47860005E-05_JPRB, 0.51978442E-05_JPRB, 0.56369824E-05_JPRB, 0.60817772E-05_JPRB, 0.64824249E-05_JPRB, &
  & 0.68169771E-05_JPRB, 0.70894059E-05_JPRB, 0.73396367E-05_JPRB, 0.75859457E-05_JPRB, 0.78002369E-05_JPRB, 0.79962927E-05_JPRB, &
  & 0.82002505E-05_JPRB, 0.84010117E-05_JPRB, 0.85561213E-05_JPRB, 0.86498868E-05_JPRB, 0.87131587E-05_JPRB, 0.87801501E-05_JPRB, &
  & 0.88765754E-05_JPRB, 0.89911038E-05_JPRB, 0.91051348E-05_JPRB, 0.92221431E-05_JPRB, 0.93306572E-05_JPRB, 0.94115462E-05_JPRB, &
  & 0.94476315E-05_JPRB, 0.94408531E-05_JPRB, 0.93899962E-05_JPRB, 0.93244382E-05_JPRB, 0.92771946E-05_JPRB, 0.92430335E-05_JPRB, &
  & 0.91902093E-05_JPRB, 0.91094186E-05_JPRB, 0.90170932E-05_JPRB, 0.89125411E-05_JPRB, 0.88014566E-05_JPRB, 0.87069281E-05_JPRB, &
  & 0.86479699E-05_JPRB, 0.86193816E-05_JPRB, 0.86208618E-05_JPRB, 0.86556211E-05_JPRB, 0.87133530E-05_JPRB, 0.87578518E-05_JPRB, &
  & 0.87327929E-05_JPRB, 0.85843239E-05_JPRB, 0.83634237E-05_JPRB, 0.81193129E-05_JPRB, 0.78721172E-05_JPRB, 0.76555823E-05_JPRB, &
  & 0.74773356E-05_JPRB, 0.73348724E-05_JPRB, 0.72082814E-05_JPRB, 0.70907361E-05_JPRB, 0.69781495E-05_JPRB, 0.68991489E-05_JPRB, &
  & 0.68151537E-05_JPRB, 0.67296978E-05_JPRB, 0.66468275E-05_JPRB, 0.65965160E-05_JPRB  /)

RGHG7(:,17, 4) = (/ &
  & 0.30683851E-05_JPRB, 0.31410960E-05_JPRB, 0.32541346E-05_JPRB, 0.34084874E-05_JPRB, 0.36077239E-05_JPRB, 0.38559834E-05_JPRB, &
  & 0.41364043E-05_JPRB, 0.44391538E-05_JPRB, 0.47679208E-05_JPRB, 0.51539598E-05_JPRB, 0.55818112E-05_JPRB, 0.60084376E-05_JPRB, &
  & 0.63857632E-05_JPRB, 0.66920265E-05_JPRB, 0.69738998E-05_JPRB, 0.72492983E-05_JPRB, 0.74946212E-05_JPRB, 0.77346452E-05_JPRB, &
  & 0.80102711E-05_JPRB, 0.82965120E-05_JPRB, 0.85263150E-05_JPRB, 0.86985319E-05_JPRB, 0.88326096E-05_JPRB, 0.89558773E-05_JPRB, &
  & 0.90914710E-05_JPRB, 0.92416625E-05_JPRB, 0.93917143E-05_JPRB, 0.95304140E-05_JPRB, 0.96469762E-05_JPRB, 0.97288463E-05_JPRB, &
  & 0.97667264E-05_JPRB, 0.97661135E-05_JPRB, 0.97121849E-05_JPRB, 0.96239181E-05_JPRB, 0.95480881E-05_JPRB, 0.94922650E-05_JPRB, &
  & 0.94253229E-05_JPRB, 0.93386225E-05_JPRB, 0.92471183E-05_JPRB, 0.91396010E-05_JPRB, 0.90144435E-05_JPRB, 0.88915519E-05_JPRB, &
  & 0.87957504E-05_JPRB, 0.87280182E-05_JPRB, 0.86864956E-05_JPRB, 0.86699389E-05_JPRB, 0.86589909E-05_JPRB, 0.86016979E-05_JPRB, &
  & 0.84361533E-05_JPRB, 0.81667329E-05_JPRB, 0.79021202E-05_JPRB, 0.76467383E-05_JPRB, 0.74119468E-05_JPRB, 0.72141787E-05_JPRB, &
  & 0.70563137E-05_JPRB, 0.69276662E-05_JPRB, 0.68098058E-05_JPRB, 0.66919341E-05_JPRB, 0.65725629E-05_JPRB, 0.64980682E-05_JPRB, &
  & 0.64175614E-05_JPRB, 0.63295532E-05_JPRB, 0.62465050E-05_JPRB, 0.61997817E-05_JPRB  /)

RGHG7(:,18, 4) = (/ &
  & 0.30657763E-05_JPRB, 0.31344111E-05_JPRB, 0.32368298E-05_JPRB, 0.33739648E-05_JPRB, 0.35530521E-05_JPRB, 0.37668767E-05_JPRB, &
  & 0.40072856E-05_JPRB, 0.42518457E-05_JPRB, 0.45123793E-05_JPRB, 0.48358888E-05_JPRB, 0.52271825E-05_JPRB, 0.56467447E-05_JPRB, &
  & 0.60356586E-05_JPRB, 0.63555038E-05_JPRB, 0.66468142E-05_JPRB, 0.69176783E-05_JPRB, 0.71597659E-05_JPRB, 0.74051851E-05_JPRB, &
  & 0.77278336E-05_JPRB, 0.80829360E-05_JPRB, 0.83759598E-05_JPRB, 0.86185151E-05_JPRB, 0.88167321E-05_JPRB, 0.89883091E-05_JPRB, &
  & 0.91465196E-05_JPRB, 0.93076325E-05_JPRB, 0.94622947E-05_JPRB, 0.96005302E-05_JPRB, 0.97120482E-05_JPRB, 0.97910207E-05_JPRB, &
  & 0.98366352E-05_JPRB, 0.98481219E-05_JPRB, 0.98016752E-05_JPRB, 0.97022445E-05_JPRB, 0.96079891E-05_JPRB, 0.95317197E-05_JPRB, &
  & 0.94478946E-05_JPRB, 0.93620285E-05_JPRB, 0.92787794E-05_JPRB, 0.91778489E-05_JPRB, 0.90399352E-05_JPRB, 0.88884822E-05_JPRB, &
  & 0.87504693E-05_JPRB, 0.86345984E-05_JPRB, 0.85532454E-05_JPRB, 0.84828326E-05_JPRB, 0.83908555E-05_JPRB, 0.82295926E-05_JPRB, &
  & 0.79642359E-05_JPRB, 0.76572088E-05_JPRB, 0.73996995E-05_JPRB, 0.71708035E-05_JPRB, 0.69703821E-05_JPRB, 0.67939385E-05_JPRB, &
  & 0.66473294E-05_JPRB, 0.65264677E-05_JPRB, 0.64200475E-05_JPRB, 0.63039918E-05_JPRB, 0.61766390E-05_JPRB, 0.60932413E-05_JPRB, &
  & 0.60035881E-05_JPRB, 0.59095010E-05_JPRB, 0.58286963E-05_JPRB, 0.57883627E-05_JPRB  /)

RGHG7(:,19, 4) = (/ &
  & 0.30304331E-05_JPRB, 0.31019905E-05_JPRB, 0.32008457E-05_JPRB, 0.33308206E-05_JPRB, 0.35069791E-05_JPRB, 0.37088121E-05_JPRB, &
  & 0.39324587E-05_JPRB, 0.41469448E-05_JPRB, 0.43683687E-05_JPRB, 0.46434976E-05_JPRB, 0.49964527E-05_JPRB, 0.53823783E-05_JPRB, &
  & 0.57527885E-05_JPRB, 0.60759627E-05_JPRB, 0.63623675E-05_JPRB, 0.66095472E-05_JPRB, 0.68213367E-05_JPRB, 0.70523054E-05_JPRB, &
  & 0.73882081E-05_JPRB, 0.77744617E-05_JPRB, 0.81018809E-05_JPRB, 0.83826916E-05_JPRB, 0.86250963E-05_JPRB, 0.88376922E-05_JPRB, &
  & 0.90214131E-05_JPRB, 0.91914201E-05_JPRB, 0.93491720E-05_JPRB, 0.94882055E-05_JPRB, 0.95964906E-05_JPRB, 0.96768154E-05_JPRB, &
  & 0.97352352E-05_JPRB, 0.97652572E-05_JPRB, 0.97306561E-05_JPRB, 0.96382376E-05_JPRB, 0.95435887E-05_JPRB, 0.94546946E-05_JPRB, &
  & 0.93512784E-05_JPRB, 0.92609850E-05_JPRB, 0.91754236E-05_JPRB, 0.90654728E-05_JPRB, 0.89046618E-05_JPRB, 0.87164436E-05_JPRB, &
  & 0.85379694E-05_JPRB, 0.83877950E-05_JPRB, 0.82694065E-05_JPRB, 0.81379561E-05_JPRB, 0.79667011E-05_JPRB, 0.77237260E-05_JPRB, &
  & 0.74302239E-05_JPRB, 0.71457034E-05_JPRB, 0.69143609E-05_JPRB, 0.67137190E-05_JPRB, 0.65433216E-05_JPRB, 0.63913832E-05_JPRB, &
  & 0.62560254E-05_JPRB, 0.61392180E-05_JPRB, 0.60391038E-05_JPRB, 0.59259286E-05_JPRB, 0.57973530E-05_JPRB, 0.56997835E-05_JPRB, &
  & 0.55897338E-05_JPRB, 0.54820017E-05_JPRB, 0.53978019E-05_JPRB, 0.53612864E-05_JPRB  /)

RGHG7(:,20, 4) = (/ &
  & 0.29758621E-05_JPRB, 0.30483737E-05_JPRB, 0.31411478E-05_JPRB, 0.32677822E-05_JPRB, 0.34463266E-05_JPRB, 0.36444063E-05_JPRB, &
  & 0.38608541E-05_JPRB, 0.40668002E-05_JPRB, 0.42723308E-05_JPRB, 0.45134438E-05_JPRB, 0.48287359E-05_JPRB, 0.51715161E-05_JPRB, &
  & 0.55077529E-05_JPRB, 0.58172561E-05_JPRB, 0.60855094E-05_JPRB, 0.63052694E-05_JPRB, 0.64778212E-05_JPRB, 0.66885413E-05_JPRB, &
  & 0.70100306E-05_JPRB, 0.73882040E-05_JPRB, 0.77247924E-05_JPRB, 0.80050932E-05_JPRB, 0.82586448E-05_JPRB, 0.84944593E-05_JPRB, &
  & 0.86975348E-05_JPRB, 0.88795312E-05_JPRB, 0.90472756E-05_JPRB, 0.91911794E-05_JPRB, 0.92979324E-05_JPRB, 0.93762446E-05_JPRB, &
  & 0.94436225E-05_JPRB, 0.94941203E-05_JPRB, 0.94769420E-05_JPRB, 0.94042276E-05_JPRB, 0.93212855E-05_JPRB, 0.92312179E-05_JPRB, &
  & 0.91174908E-05_JPRB, 0.90191368E-05_JPRB, 0.89214489E-05_JPRB, 0.87941143E-05_JPRB, 0.86127028E-05_JPRB, 0.83977250E-05_JPRB, &
  & 0.81975615E-05_JPRB, 0.80272142E-05_JPRB, 0.78704555E-05_JPRB, 0.76783584E-05_JPRB, 0.74440842E-05_JPRB, 0.71658753E-05_JPRB, &
  & 0.68948947E-05_JPRB, 0.66558681E-05_JPRB, 0.64615954E-05_JPRB, 0.62889859E-05_JPRB, 0.61422503E-05_JPRB, 0.60131555E-05_JPRB, &
  & 0.58923759E-05_JPRB, 0.57815058E-05_JPRB, 0.56828427E-05_JPRB, 0.55676934E-05_JPRB, 0.54383408E-05_JPRB, 0.53249832E-05_JPRB, &
  & 0.51903049E-05_JPRB, 0.50649828E-05_JPRB, 0.49718860E-05_JPRB, 0.49327560E-05_JPRB  /)

RGHG7(:,21, 4) = (/ &
  & 0.29240445E-05_JPRB, 0.29914822E-05_JPRB, 0.30732706E-05_JPRB, 0.31976550E-05_JPRB, 0.33767249E-05_JPRB, 0.35712361E-05_JPRB, &
  & 0.37829415E-05_JPRB, 0.39920501E-05_JPRB, 0.41942900E-05_JPRB, 0.44113914E-05_JPRB, 0.46899703E-05_JPRB, 0.49889702E-05_JPRB, &
  & 0.52818084E-05_JPRB, 0.55594690E-05_JPRB, 0.57990017E-05_JPRB, 0.59902587E-05_JPRB, 0.61249284E-05_JPRB, 0.63116673E-05_JPRB, &
  & 0.66000110E-05_JPRB, 0.69372461E-05_JPRB, 0.72591661E-05_JPRB, 0.75074023E-05_JPRB, 0.77382725E-05_JPRB, 0.79715396E-05_JPRB, &
  & 0.81774355E-05_JPRB, 0.83687294E-05_JPRB, 0.85507983E-05_JPRB, 0.87026055E-05_JPRB, 0.88095511E-05_JPRB, 0.88839896E-05_JPRB, &
  & 0.89572377E-05_JPRB, 0.90282490E-05_JPRB, 0.90306667E-05_JPRB, 0.89781471E-05_JPRB, 0.89071256E-05_JPRB, 0.88216033E-05_JPRB, &
  & 0.87062445E-05_JPRB, 0.85990558E-05_JPRB, 0.84877257E-05_JPRB, 0.83488587E-05_JPRB, 0.81649095E-05_JPRB, 0.79483906E-05_JPRB, &
  & 0.77527232E-05_JPRB, 0.75771868E-05_JPRB, 0.73869555E-05_JPRB, 0.71481257E-05_JPRB, 0.68808561E-05_JPRB, 0.66153033E-05_JPRB, &
  & 0.63945522E-05_JPRB, 0.62056530E-05_JPRB, 0.60540410E-05_JPRB, 0.59097364E-05_JPRB, 0.57835423E-05_JPRB, 0.56743956E-05_JPRB, &
  & 0.55697340E-05_JPRB, 0.54682151E-05_JPRB, 0.53692609E-05_JPRB, 0.52464997E-05_JPRB, 0.51144942E-05_JPRB, 0.49854187E-05_JPRB, &
  & 0.48310294E-05_JPRB, 0.46930413E-05_JPRB, 0.45929228E-05_JPRB, 0.45458894E-05_JPRB  /)

RGHG7(:,22, 4) = (/ &
  & 0.28994479E-05_JPRB, 0.29541118E-05_JPRB, 0.30214031E-05_JPRB, 0.31433545E-05_JPRB, 0.33165443E-05_JPRB, 0.35033508E-05_JPRB, &
  & 0.37089735E-05_JPRB, 0.39227455E-05_JPRB, 0.41237688E-05_JPRB, 0.43235345E-05_JPRB, 0.45674418E-05_JPRB, 0.48265999E-05_JPRB, &
  & 0.50674309E-05_JPRB, 0.52964297E-05_JPRB, 0.54999730E-05_JPRB, 0.56575722E-05_JPRB, 0.57622337E-05_JPRB, 0.59172411E-05_JPRB, &
  & 0.61613837E-05_JPRB, 0.64301882E-05_JPRB, 0.67086167E-05_JPRB, 0.69031222E-05_JPRB, 0.70790452E-05_JPRB, 0.72742952E-05_JPRB, &
  & 0.74548465E-05_JPRB, 0.76415783E-05_JPRB, 0.78359140E-05_JPRB, 0.79975549E-05_JPRB, 0.81079475E-05_JPRB, 0.81844135E-05_JPRB, &
  & 0.82667857E-05_JPRB, 0.83579714E-05_JPRB, 0.83752917E-05_JPRB, 0.83275369E-05_JPRB, 0.82536768E-05_JPRB, 0.81680531E-05_JPRB, &
  & 0.80522888E-05_JPRB, 0.79381050E-05_JPRB, 0.78231252E-05_JPRB, 0.76958155E-05_JPRB, 0.75467405E-05_JPRB, 0.73697593E-05_JPRB, &
  & 0.72100814E-05_JPRB, 0.70500559E-05_JPRB, 0.68452261E-05_JPRB, 0.65929129E-05_JPRB, 0.63418638E-05_JPRB, 0.61321708E-05_JPRB, &
  & 0.59713345E-05_JPRB, 0.58286639E-05_JPRB, 0.57190227E-05_JPRB, 0.56015836E-05_JPRB, 0.54962734E-05_JPRB, 0.54048680E-05_JPRB, &
  & 0.53137911E-05_JPRB, 0.52245391E-05_JPRB, 0.51275111E-05_JPRB, 0.49932941E-05_JPRB, 0.48576389E-05_JPRB, 0.47143705E-05_JPRB, &
  & 0.45567370E-05_JPRB, 0.44236151E-05_JPRB, 0.43299848E-05_JPRB, 0.42731177E-05_JPRB  /)

RGHG7(:,23, 4) = (/ &
  & 0.28753461E-05_JPRB, 0.29202648E-05_JPRB, 0.29825763E-05_JPRB, 0.31081245E-05_JPRB, 0.32759746E-05_JPRB, 0.34522358E-05_JPRB, &
  & 0.36437460E-05_JPRB, 0.38486482E-05_JPRB, 0.40380023E-05_JPRB, 0.42190815E-05_JPRB, 0.44234384E-05_JPRB, 0.46327056E-05_JPRB, &
  & 0.48182430E-05_JPRB, 0.49952285E-05_JPRB, 0.51478229E-05_JPRB, 0.52648971E-05_JPRB, 0.53521866E-05_JPRB, 0.54674505E-05_JPRB, &
  & 0.56493967E-05_JPRB, 0.58504530E-05_JPRB, 0.60559990E-05_JPRB, 0.61935653E-05_JPRB, 0.63127346E-05_JPRB, 0.64481784E-05_JPRB, &
  & 0.65827299E-05_JPRB, 0.67420931E-05_JPRB, 0.69272058E-05_JPRB, 0.70963657E-05_JPRB, 0.72220255E-05_JPRB, 0.73162198E-05_JPRB, &
  & 0.74171599E-05_JPRB, 0.75224326E-05_JPRB, 0.75388913E-05_JPRB, 0.74669959E-05_JPRB, 0.73636630E-05_JPRB, 0.72519797E-05_JPRB, &
  & 0.71277827E-05_JPRB, 0.70088190E-05_JPRB, 0.69020571E-05_JPRB, 0.68091135E-05_JPRB, 0.67214665E-05_JPRB, 0.66272047E-05_JPRB, &
  & 0.65337981E-05_JPRB, 0.64140277E-05_JPRB, 0.62404162E-05_JPRB, 0.60366242E-05_JPRB, 0.58453052E-05_JPRB, 0.56973476E-05_JPRB, &
  & 0.55843891E-05_JPRB, 0.54853127E-05_JPRB, 0.54050362E-05_JPRB, 0.53180827E-05_JPRB, 0.52439555E-05_JPRB, 0.51753952E-05_JPRB, &
  & 0.51012920E-05_JPRB, 0.50238652E-05_JPRB, 0.49360864E-05_JPRB, 0.48167079E-05_JPRB, 0.46906416E-05_JPRB, 0.45575889E-05_JPRB, &
  & 0.44224527E-05_JPRB, 0.43179433E-05_JPRB, 0.42473825E-05_JPRB, 0.42055366E-05_JPRB  /)

RGHG7(:,24, 4) = (/ &
  & 0.28345794E-05_JPRB, 0.28723302E-05_JPRB, 0.29370198E-05_JPRB, 0.30680294E-05_JPRB, 0.32336341E-05_JPRB, 0.33983261E-05_JPRB, &
  & 0.35726111E-05_JPRB, 0.37602524E-05_JPRB, 0.39296009E-05_JPRB, 0.40858274E-05_JPRB, 0.42451132E-05_JPRB, 0.44005123E-05_JPRB, &
  & 0.45319030E-05_JPRB, 0.46561597E-05_JPRB, 0.47563888E-05_JPRB, 0.48327697E-05_JPRB, 0.48995108E-05_JPRB, 0.49736138E-05_JPRB, &
  & 0.50913261E-05_JPRB, 0.52286140E-05_JPRB, 0.53581573E-05_JPRB, 0.54382803E-05_JPRB, 0.54999908E-05_JPRB, 0.55733688E-05_JPRB, &
  & 0.56587099E-05_JPRB, 0.57809805E-05_JPRB, 0.59434636E-05_JPRB, 0.61128040E-05_JPRB, 0.62540936E-05_JPRB, 0.63721287E-05_JPRB, &
  & 0.64932900E-05_JPRB, 0.66060815E-05_JPRB, 0.66169365E-05_JPRB, 0.65169355E-05_JPRB, 0.63763211E-05_JPRB, 0.62338138E-05_JPRB, &
  & 0.60995272E-05_JPRB, 0.59823905E-05_JPRB, 0.58955373E-05_JPRB, 0.58484647E-05_JPRB, 0.58286873E-05_JPRB, 0.58208517E-05_JPRB, &
  & 0.57998389E-05_JPRB, 0.57311367E-05_JPRB, 0.56068034E-05_JPRB, 0.54658904E-05_JPRB, 0.53393387E-05_JPRB, 0.52481658E-05_JPRB, &
  & 0.51787101E-05_JPRB, 0.51212704E-05_JPRB, 0.50710360E-05_JPRB, 0.50157355E-05_JPRB, 0.49729911E-05_JPRB, 0.49291336E-05_JPRB, &
  & 0.48743296E-05_JPRB, 0.48126350E-05_JPRB, 0.47365665E-05_JPRB, 0.46402922E-05_JPRB, 0.45333926E-05_JPRB, 0.44189635E-05_JPRB, &
  & 0.43153387E-05_JPRB, 0.42455362E-05_JPRB, 0.42022492E-05_JPRB, 0.41787259E-05_JPRB  /)

RGHG7(:,25, 4) = (/ &
  & 0.27660081E-05_JPRB, 0.28007995E-05_JPRB, 0.28786567E-05_JPRB, 0.30168291E-05_JPRB, 0.31856506E-05_JPRB, 0.33381186E-05_JPRB, &
  & 0.34922448E-05_JPRB, 0.36515779E-05_JPRB, 0.37894014E-05_JPRB, 0.39112720E-05_JPRB, 0.40188311E-05_JPRB, 0.41179999E-05_JPRB, &
  & 0.42004517E-05_JPRB, 0.42738395E-05_JPRB, 0.43249154E-05_JPRB, 0.43636807E-05_JPRB, 0.44023281E-05_JPRB, 0.44364137E-05_JPRB, &
  & 0.44932205E-05_JPRB, 0.45765084E-05_JPRB, 0.46345521E-05_JPRB, 0.46596457E-05_JPRB, 0.46656406E-05_JPRB, 0.46806438E-05_JPRB, &
  & 0.47179467E-05_JPRB, 0.47926939E-05_JPRB, 0.49146448E-05_JPRB, 0.50716754E-05_JPRB, 0.52258753E-05_JPRB, 0.53739771E-05_JPRB, &
  & 0.55152544E-05_JPRB, 0.56249577E-05_JPRB, 0.56256046E-05_JPRB, 0.54982391E-05_JPRB, 0.53141759E-05_JPRB, 0.51396289E-05_JPRB, &
  & 0.49945766E-05_JPRB, 0.48903930E-05_JPRB, 0.48405978E-05_JPRB, 0.48525864E-05_JPRB, 0.49030647E-05_JPRB, 0.49746206E-05_JPRB, &
  & 0.50267802E-05_JPRB, 0.50204418E-05_JPRB, 0.49648629E-05_JPRB, 0.48954925E-05_JPRB, 0.48299320E-05_JPRB, 0.47828941E-05_JPRB, &
  & 0.47499388E-05_JPRB, 0.47293855E-05_JPRB, 0.47118771E-05_JPRB, 0.46880587E-05_JPRB, 0.46733222E-05_JPRB, 0.46551995E-05_JPRB, &
  & 0.46221841E-05_JPRB, 0.45825356E-05_JPRB, 0.45203638E-05_JPRB, 0.44548854E-05_JPRB, 0.43802829E-05_JPRB, 0.42930467E-05_JPRB, &
  & 0.42296968E-05_JPRB, 0.41984963E-05_JPRB, 0.41849758E-05_JPRB, 0.41792095E-05_JPRB  /)

RGHG7(:,26, 4) = (/ &
  & 0.26705960E-05_JPRB, 0.27084978E-05_JPRB, 0.27954112E-05_JPRB, 0.29345122E-05_JPRB, 0.31002483E-05_JPRB, 0.32368148E-05_JPRB, &
  & 0.33710550E-05_JPRB, 0.34981256E-05_JPRB, 0.36003862E-05_JPRB, 0.36863343E-05_JPRB, 0.37506116E-05_JPRB, 0.38066758E-05_JPRB, &
  & 0.38512663E-05_JPRB, 0.38846909E-05_JPRB, 0.39019605E-05_JPRB, 0.39106608E-05_JPRB, 0.39197862E-05_JPRB, 0.39248449E-05_JPRB, &
  & 0.39407847E-05_JPRB, 0.39799979E-05_JPRB, 0.39871108E-05_JPRB, 0.39680581E-05_JPRB, 0.39299247E-05_JPRB, 0.38993404E-05_JPRB, &
  & 0.38976333E-05_JPRB, 0.39304393E-05_JPRB, 0.40102308E-05_JPRB, 0.41354857E-05_JPRB, 0.42829498E-05_JPRB, 0.44443058E-05_JPRB, &
  & 0.45936468E-05_JPRB, 0.46910979E-05_JPRB, 0.46819800E-05_JPRB, 0.45511379E-05_JPRB, 0.43620999E-05_JPRB, 0.41856496E-05_JPRB, &
  & 0.40544077E-05_JPRB, 0.39829171E-05_JPRB, 0.39816619E-05_JPRB, 0.40466652E-05_JPRB, 0.41461239E-05_JPRB, 0.42609141E-05_JPRB, &
  & 0.43586498E-05_JPRB, 0.44057528E-05_JPRB, 0.44026325E-05_JPRB, 0.43830595E-05_JPRB, 0.43627401E-05_JPRB, 0.43507235E-05_JPRB, &
  & 0.43491662E-05_JPRB, 0.43577948E-05_JPRB, 0.43644657E-05_JPRB, 0.43644585E-05_JPRB, 0.43699393E-05_JPRB, 0.43717778E-05_JPRB, &
  & 0.43597252E-05_JPRB, 0.43408242E-05_JPRB, 0.42995834E-05_JPRB, 0.42578495E-05_JPRB, 0.42099277E-05_JPRB, 0.41479794E-05_JPRB, &
  & 0.41127347E-05_JPRB, 0.41072518E-05_JPRB, 0.41085741E-05_JPRB, 0.41085303E-05_JPRB  /)

RGHG7(:,27, 4) = (/ &
  & 0.25608883E-05_JPRB, 0.26042928E-05_JPRB, 0.26991501E-05_JPRB, 0.28369104E-05_JPRB, 0.29970838E-05_JPRB, 0.31156615E-05_JPRB, &
  & 0.32292114E-05_JPRB, 0.33210847E-05_JPRB, 0.33846663E-05_JPRB, 0.34324756E-05_JPRB, 0.34546322E-05_JPRB, 0.34704966E-05_JPRB, &
  & 0.34796097E-05_JPRB, 0.34752957E-05_JPRB, 0.34629108E-05_JPRB, 0.34429769E-05_JPRB, 0.34207068E-05_JPRB, 0.33994927E-05_JPRB, &
  & 0.33801351E-05_JPRB, 0.33769474E-05_JPRB, 0.33384379E-05_JPRB, 0.32772644E-05_JPRB, 0.31972904E-05_JPRB, 0.31237851E-05_JPRB, &
  & 0.30846395E-05_JPRB, 0.30756649E-05_JPRB, 0.31107744E-05_JPRB, 0.31955895E-05_JPRB, 0.33287265E-05_JPRB, 0.34977063E-05_JPRB, &
  & 0.36510092E-05_JPRB, 0.37322524E-05_JPRB, 0.37130895E-05_JPRB, 0.35874700E-05_JPRB, 0.34074964E-05_JPRB, 0.32402307E-05_JPRB, &
  & 0.31325403E-05_JPRB, 0.31025501E-05_JPRB, 0.31563020E-05_JPRB, 0.32744915E-05_JPRB, 0.34172715E-05_JPRB, 0.35638574E-05_JPRB, &
  & 0.36990114E-05_JPRB, 0.37986803E-05_JPRB, 0.38443640E-05_JPRB, 0.38687928E-05_JPRB, 0.38899337E-05_JPRB, 0.39111535E-05_JPRB, &
  & 0.39405313E-05_JPRB, 0.39768136E-05_JPRB, 0.40055953E-05_JPRB, 0.40276390E-05_JPRB, 0.40513688E-05_JPRB, 0.40719366E-05_JPRB, &
  & 0.40814945E-05_JPRB, 0.40838039E-05_JPRB, 0.40670552E-05_JPRB, 0.40475323E-05_JPRB, 0.40254231E-05_JPRB, 0.39892075E-05_JPRB, &
  & 0.39788350E-05_JPRB, 0.39954631E-05_JPRB, 0.40067703E-05_JPRB, 0.40082472E-05_JPRB  /)

RGHG7(:,28, 4) = (/ &
  & 0.25470652E-05_JPRB, 0.25916820E-05_JPRB, 0.26723434E-05_JPRB, 0.27868448E-05_JPRB, 0.29177002E-05_JPRB, 0.30073513E-05_JPRB, &
  & 0.30893620E-05_JPRB, 0.31465195E-05_JPRB, 0.31792821E-05_JPRB, 0.31974557E-05_JPRB, 0.31947667E-05_JPRB, 0.31870231E-05_JPRB, &
  & 0.31730291E-05_JPRB, 0.31464488E-05_JPRB, 0.31169126E-05_JPRB, 0.30809632E-05_JPRB, 0.30404276E-05_JPRB, 0.30013154E-05_JPRB, &
  & 0.29635390E-05_JPRB, 0.29323076E-05_JPRB, 0.28739608E-05_JPRB, 0.27900332E-05_JPRB, 0.26906528E-05_JPRB, 0.25934490E-05_JPRB, &
  & 0.25264714E-05_JPRB, 0.24946234E-05_JPRB, 0.24988274E-05_JPRB, 0.25436411E-05_JPRB, 0.26393802E-05_JPRB, 0.27747466E-05_JPRB, &
  & 0.29011478E-05_JPRB, 0.29667975E-05_JPRB, 0.29528670E-05_JPRB, 0.28625943E-05_JPRB, 0.27320291E-05_JPRB, 0.26162348E-05_JPRB, &
  & 0.25612446E-05_JPRB, 0.25817553E-05_JPRB, 0.26749192E-05_JPRB, 0.28156337E-05_JPRB, 0.29661092E-05_JPRB, 0.31102101E-05_JPRB, &
  & 0.32505867E-05_JPRB, 0.33613688E-05_JPRB, 0.34255541E-05_JPRB, 0.34743878E-05_JPRB, 0.35211285E-05_JPRB, 0.35661143E-05_JPRB, &
  & 0.36166610E-05_JPRB, 0.36716260E-05_JPRB, 0.37164158E-05_JPRB, 0.37508133E-05_JPRB, 0.37826142E-05_JPRB, 0.38098941E-05_JPRB, &
  & 0.38341623E-05_JPRB, 0.38545858E-05_JPRB, 0.38600475E-05_JPRB, 0.38579974E-05_JPRB, 0.38545152E-05_JPRB, 0.38361266E-05_JPRB, &
  & 0.38403436E-05_JPRB, 0.38615592E-05_JPRB, 0.38687936E-05_JPRB, 0.38644042E-05_JPRB  /)

RGHG7(:,29, 4) = (/ &
  & 0.25365759E-05_JPRB, 0.25822912E-05_JPRB, 0.26469510E-05_JPRB, 0.27358572E-05_JPRB, 0.28346179E-05_JPRB, 0.28931446E-05_JPRB, &
  & 0.29412663E-05_JPRB, 0.29616605E-05_JPRB, 0.29621086E-05_JPRB, 0.29492494E-05_JPRB, 0.29209835E-05_JPRB, 0.28889446E-05_JPRB, &
  & 0.28510031E-05_JPRB, 0.28015007E-05_JPRB, 0.27543334E-05_JPRB, 0.27019613E-05_JPRB, 0.26426413E-05_JPRB, 0.25849277E-05_JPRB, &
  & 0.25283668E-05_JPRB, 0.24680432E-05_JPRB, 0.23897951E-05_JPRB, 0.22825976E-05_JPRB, 0.21636271E-05_JPRB, 0.20421463E-05_JPRB, &
  & 0.19460949E-05_JPRB, 0.18908303E-05_JPRB, 0.18628847E-05_JPRB, 0.18653326E-05_JPRB, 0.19204453E-05_JPRB, 0.20184075E-05_JPRB, &
  & 0.21149660E-05_JPRB, 0.21641197E-05_JPRB, 0.21563958E-05_JPRB, 0.21048820E-05_JPRB, 0.20284183E-05_JPRB, 0.19689958E-05_JPRB, &
  & 0.19711097E-05_JPRB, 0.20455204E-05_JPRB, 0.21797685E-05_JPRB, 0.23430207E-05_JPRB, 0.25001056E-05_JPRB, 0.26400871E-05_JPRB, &
  & 0.27846013E-05_JPRB, 0.29053616E-05_JPRB, 0.29878371E-05_JPRB, 0.30616801E-05_JPRB, 0.31348582E-05_JPRB, 0.32046153E-05_JPRB, &
  & 0.32771688E-05_JPRB, 0.33515407E-05_JPRB, 0.34130279E-05_JPRB, 0.34600948E-05_JPRB, 0.35000064E-05_JPRB, 0.35338773E-05_JPRB, &
  & 0.35734331E-05_JPRB, 0.36129156E-05_JPRB, 0.36418121E-05_JPRB, 0.36580705E-05_JPRB, 0.36740136E-05_JPRB, 0.36741715E-05_JPRB, &
  & 0.36934014E-05_JPRB, 0.37187181E-05_JPRB, 0.37210275E-05_JPRB, 0.37101020E-05_JPRB  /)

RGHG7(:,30, 4) = (/ &
  & 0.24789909E-05_JPRB, 0.25188045E-05_JPRB, 0.25674467E-05_JPRB, 0.26312232E-05_JPRB, 0.26995087E-05_JPRB, 0.27337693E-05_JPRB, &
  & 0.27554993E-05_JPRB, 0.27539383E-05_JPRB, 0.27366010E-05_JPRB, 0.27099302E-05_JPRB, 0.26707365E-05_JPRB, 0.26270312E-05_JPRB, &
  & 0.25770858E-05_JPRB, 0.25177195E-05_JPRB, 0.24597764E-05_JPRB, 0.23961309E-05_JPRB, 0.23266131E-05_JPRB, 0.22561927E-05_JPRB, &
  & 0.21853326E-05_JPRB, 0.21115369E-05_JPRB, 0.20234116E-05_JPRB, 0.19169651E-05_JPRB, 0.17982826E-05_JPRB, 0.16735793E-05_JPRB, &
  & 0.15727570E-05_JPRB, 0.15116652E-05_JPRB, 0.14742173E-05_JPRB, 0.14565707E-05_JPRB, 0.14743810E-05_JPRB, 0.15256026E-05_JPRB, &
  & 0.15824075E-05_JPRB, 0.16104607E-05_JPRB, 0.16063612E-05_JPRB, 0.15862133E-05_JPRB, 0.15638716E-05_JPRB, 0.15642989E-05_JPRB, &
  & 0.16112733E-05_JPRB, 0.17078958E-05_JPRB, 0.18441914E-05_JPRB, 0.19940340E-05_JPRB, 0.21321140E-05_JPRB, 0.22617017E-05_JPRB, &
  & 0.23975988E-05_JPRB, 0.25193653E-05_JPRB, 0.26175548E-05_JPRB, 0.27103187E-05_JPRB, 0.28020812E-05_JPRB, 0.28882015E-05_JPRB, &
  & 0.29714222E-05_JPRB, 0.30533066E-05_JPRB, 0.31256653E-05_JPRB, 0.31842917E-05_JPRB, 0.32307244E-05_JPRB, 0.32663383E-05_JPRB, &
  & 0.33115854E-05_JPRB, 0.33625850E-05_JPRB, 0.34091946E-05_JPRB, 0.34385294E-05_JPRB, 0.34663758E-05_JPRB, 0.34787257E-05_JPRB, &
  & 0.35104662E-05_JPRB, 0.35326180E-05_JPRB, 0.35253694E-05_JPRB, 0.35085031E-05_JPRB  /)

RGHG7(:,31, 4) = (/ &
  & 0.24182716E-05_JPRB, 0.24518602E-05_JPRB, 0.24836253E-05_JPRB, 0.25209243E-05_JPRB, 0.25571009E-05_JPRB, 0.25658000E-05_JPRB, &
  & 0.25597295E-05_JPRB, 0.25350495E-05_JPRB, 0.24989863E-05_JPRB, 0.24577791E-05_JPRB, 0.24070853E-05_JPRB, 0.23510995E-05_JPRB, &
  & 0.22885175E-05_JPRB, 0.22187706E-05_JPRB, 0.21494800E-05_JPRB, 0.20739612E-05_JPRB, 0.19937065E-05_JPRB, 0.19099032E-05_JPRB, &
  & 0.18239809E-05_JPRB, 0.17360051E-05_JPRB, 0.16374821E-05_JPRB, 0.15318498E-05_JPRB, 0.14134896E-05_JPRB, 0.12854108E-05_JPRB, &
  & 0.11795848E-05_JPRB, 0.11123697E-05_JPRB, 0.10649313E-05_JPRB, 0.10261333E-05_JPRB, 0.10046428E-05_JPRB, 0.10066071E-05_JPRB, &
  & 0.10215162E-05_JPRB, 0.10273324E-05_JPRB, 0.10270493E-05_JPRB, 0.10399432E-05_JPRB, 0.10746273E-05_JPRB, 0.11381189E-05_JPRB, &
  & 0.12323491E-05_JPRB, 0.13523451E-05_JPRB, 0.14907609E-05_JPRB, 0.16264403E-05_JPRB, 0.17444713E-05_JPRB, 0.18631017E-05_JPRB, &
  & 0.19899073E-05_JPRB, 0.21127254E-05_JPRB, 0.22274697E-05_JPRB, 0.23401638E-05_JPRB, 0.24515003E-05_JPRB, 0.25548539E-05_JPRB, &
  & 0.26493034E-05_JPRB, 0.27390920E-05_JPRB, 0.28229000E-05_JPRB, 0.28937050E-05_JPRB, 0.29470073E-05_JPRB, 0.29844531E-05_JPRB, &
  & 0.30356877E-05_JPRB, 0.30988150E-05_JPRB, 0.31640827E-05_JPRB, 0.32071905E-05_JPRB, 0.32475717E-05_JPRB, 0.32727618E-05_JPRB, &
  & 0.33176817E-05_JPRB, 0.33364920E-05_JPRB, 0.33191680E-05_JPRB, 0.32960428E-05_JPRB  /)

RGHG7(:,32, 4) = (/ &
  & 0.23628627E-05_JPRB, 0.23823261E-05_JPRB, 0.23975298E-05_JPRB, 0.24099399E-05_JPRB, 0.24194023E-05_JPRB, 0.24049797E-05_JPRB, &
  & 0.23767957E-05_JPRB, 0.23357367E-05_JPRB, 0.22868123E-05_JPRB, 0.22359116E-05_JPRB, 0.21778541E-05_JPRB, 0.21155105E-05_JPRB, &
  & 0.20454936E-05_JPRB, 0.19693262E-05_JPRB, 0.18918969E-05_JPRB, 0.18090004E-05_JPRB, 0.17246342E-05_JPRB, 0.16351976E-05_JPRB, &
  & 0.15419539E-05_JPRB, 0.14477375E-05_JPRB, 0.13446765E-05_JPRB, 0.12439679E-05_JPRB, 0.11405263E-05_JPRB, 0.10277484E-05_JPRB, &
  & 0.92986092E-06_JPRB, 0.86234982E-06_JPRB, 0.81443271E-06_JPRB, 0.77367385E-06_JPRB, 0.74236803E-06_JPRB, 0.72759735E-06_JPRB, &
  & 0.72584963E-06_JPRB, 0.72434156E-06_JPRB, 0.72819515E-06_JPRB, 0.75266875E-06_JPRB, 0.80268189E-06_JPRB, 0.87812979E-06_JPRB, &
  & 0.97429077E-06_JPRB, 0.10816382E-05_JPRB, 0.11951108E-05_JPRB, 0.13056271E-05_JPRB, 0.14097219E-05_JPRB, 0.15227418E-05_JPRB, &
  & 0.16460552E-05_JPRB, 0.17733318E-05_JPRB, 0.19006421E-05_JPRB, 0.20266311E-05_JPRB, 0.21507862E-05_JPRB, 0.22642687E-05_JPRB, &
  & 0.23634302E-05_JPRB, 0.24569072E-05_JPRB, 0.25491109E-05_JPRB, 0.26304134E-05_JPRB, 0.26920683E-05_JPRB, 0.27357248E-05_JPRB, &
  & 0.27907085E-05_JPRB, 0.28609140E-05_JPRB, 0.29374515E-05_JPRB, 0.29902775E-05_JPRB, 0.30415778E-05_JPRB, 0.30737885E-05_JPRB, &
  & 0.31254389E-05_JPRB, 0.31413121E-05_JPRB, 0.31236912E-05_JPRB, 0.31099766E-05_JPRB  /)

RGHG7(:,33, 4) = (/ &
  & 0.23059666E-05_JPRB, 0.23097276E-05_JPRB, 0.23077608E-05_JPRB, 0.22945109E-05_JPRB, 0.22769090E-05_JPRB, 0.22387732E-05_JPRB, &
  & 0.21883442E-05_JPRB, 0.21311359E-05_JPRB, 0.20696050E-05_JPRB, 0.20092573E-05_JPRB, 0.19440826E-05_JPRB, 0.18758986E-05_JPRB, &
  & 0.17988283E-05_JPRB, 0.17165012E-05_JPRB, 0.16310292E-05_JPRB, 0.15410475E-05_JPRB, 0.14532664E-05_JPRB, 0.13589786E-05_JPRB, &
  & 0.12591284E-05_JPRB, 0.11594545E-05_JPRB, 0.10524360E-05_JPRB, 0.95737643E-06_JPRB, 0.87132870E-06_JPRB, 0.77687032E-06_JPRB, &
  & 0.68890850E-06_JPRB, 0.62184421E-06_JPRB, 0.57466116E-06_JPRB, 0.53434911E-06_JPRB, 0.49666021E-06_JPRB, 0.46870845E-06_JPRB, &
  & 0.45291794E-06_JPRB, 0.44572892E-06_JPRB, 0.45392301E-06_JPRB, 0.48765209E-06_JPRB, 0.54819732E-06_JPRB, 0.62945383E-06_JPRB, &
  & 0.72175304E-06_JPRB, 0.81129167E-06_JPRB, 0.89533826E-06_JPRB, 0.97827962E-06_JPRB, 0.10686827E-05_JPRB, 0.11765642E-05_JPRB, &
  & 0.12969733E-05_JPRB, 0.14293244E-05_JPRB, 0.15691775E-05_JPRB, 0.17081242E-05_JPRB, 0.18447263E-05_JPRB, 0.19678153E-05_JPRB, &
  & 0.20710301E-05_JPRB, 0.21677944E-05_JPRB, 0.22683280E-05_JPRB, 0.23603221E-05_JPRB, 0.24308495E-05_JPRB, 0.24815274E-05_JPRB, &
  & 0.25401176E-05_JPRB, 0.26170254E-05_JPRB, 0.27043183E-05_JPRB, 0.27667190E-05_JPRB, 0.28291578E-05_JPRB, 0.28679112E-05_JPRB, &
  & 0.29257212E-05_JPRB, 0.29385944E-05_JPRB, 0.29219309E-05_JPRB, 0.29200250E-05_JPRB  /)

RGHG7(:,34, 4) = (/ &
  & 0.22156096E-05_JPRB, 0.22086665E-05_JPRB, 0.21948534E-05_JPRB, 0.21626651E-05_JPRB, 0.21266756E-05_JPRB, 0.20722096E-05_JPRB, &
  & 0.20074954E-05_JPRB, 0.19405295E-05_JPRB, 0.18728991E-05_JPRB, 0.18069083E-05_JPRB, 0.17375963E-05_JPRB, 0.16665454E-05_JPRB, &
  & 0.15863006E-05_JPRB, 0.15003279E-05_JPRB, 0.14112175E-05_JPRB, 0.13183773E-05_JPRB, 0.12284600E-05_JPRB, 0.11348437E-05_JPRB, &
  & 0.10369060E-05_JPRB, 0.93843193E-06_JPRB, 0.83543762E-06_JPRB, 0.74623631E-06_JPRB, 0.67020691E-06_JPRB, 0.59183952E-06_JPRB, &
  & 0.51815410E-06_JPRB, 0.45896304E-06_JPRB, 0.41723166E-06_JPRB, 0.38229488E-06_JPRB, 0.34916768E-06_JPRB, 0.32188107E-06_JPRB, &
  & 0.30433595E-06_JPRB, 0.29706177E-06_JPRB, 0.30625901E-06_JPRB, 0.33830420E-06_JPRB, 0.39176840E-06_JPRB, 0.45960595E-06_JPRB, &
  & 0.53372939E-06_JPRB, 0.60212053E-06_JPRB, 0.66562900E-06_JPRB, 0.73191508E-06_JPRB, 0.81278304E-06_JPRB, 0.91403476E-06_JPRB, &
  & 0.10317283E-05_JPRB, 0.11649619E-05_JPRB, 0.13074345E-05_JPRB, 0.14500035E-05_JPRB, 0.15906151E-05_JPRB, 0.17154229E-05_JPRB, &
  & 0.18208710E-05_JPRB, 0.19206897E-05_JPRB, 0.20249766E-05_JPRB, 0.21224134E-05_JPRB, 0.22007369E-05_JPRB, 0.22578069E-05_JPRB, &
  & 0.23200189E-05_JPRB, 0.24003686E-05_JPRB, 0.24923760E-05_JPRB, 0.25614808E-05_JPRB, 0.26327008E-05_JPRB, 0.26704811E-05_JPRB, &
  & 0.27280361E-05_JPRB, 0.27415629E-05_JPRB, 0.27311173E-05_JPRB, 0.27435382E-05_JPRB  /)

RGHG7(:,35, 4) = (/ &
  & 0.21055408E-05_JPRB, 0.20901572E-05_JPRB, 0.20668968E-05_JPRB, 0.20186864E-05_JPRB, 0.19682445E-05_JPRB, 0.19007772E-05_JPRB, &
  & 0.18254607E-05_JPRB, 0.17517424E-05_JPRB, 0.16811801E-05_JPRB, 0.16113391E-05_JPRB, 0.15393025E-05_JPRB, 0.14668301E-05_JPRB, &
  & 0.13853118E-05_JPRB, 0.12968810E-05_JPRB, 0.12062898E-05_JPRB, 0.11126796E-05_JPRB, 0.10212224E-05_JPRB, 0.93113028E-06_JPRB, &
  & 0.83953037E-06_JPRB, 0.74570591E-06_JPRB, 0.65094474E-06_JPRB, 0.56787387E-06_JPRB, 0.49835990E-06_JPRB, 0.43539263E-06_JPRB, &
  & 0.37861773E-06_JPRB, 0.33133214E-06_JPRB, 0.29762660E-06_JPRB, 0.27074526E-06_JPRB, 0.24792430E-06_JPRB, 0.22842660E-06_JPRB, &
  & 0.21538305E-06_JPRB, 0.21089274E-06_JPRB, 0.21940882E-06_JPRB, 0.24410933E-06_JPRB, 0.28125533E-06_JPRB, 0.32543000E-06_JPRB, &
  & 0.37352132E-06_JPRB, 0.41845689E-06_JPRB, 0.46541023E-06_JPRB, 0.52017584E-06_JPRB, 0.59337335E-06_JPRB, 0.68704347E-06_JPRB, &
  & 0.80204200E-06_JPRB, 0.93403172E-06_JPRB, 0.10741055E-05_JPRB, 0.12156083E-05_JPRB, 0.13560126E-05_JPRB, 0.14785400E-05_JPRB, &
  & 0.15853504E-05_JPRB, 0.16881899E-05_JPRB, 0.17939872E-05_JPRB, 0.18943263E-05_JPRB, 0.19801130E-05_JPRB, 0.20434318E-05_JPRB, &
  & 0.21093754E-05_JPRB, 0.21915909E-05_JPRB, 0.22853457E-05_JPRB, 0.23598701E-05_JPRB, 0.24389086E-05_JPRB, 0.24718320E-05_JPRB, &
  & 0.25258331E-05_JPRB, 0.25419069E-05_JPRB, 0.25405532E-05_JPRB, 0.25689962E-05_JPRB  /)

RGHG7(:,36, 4) = (/ &
  & 0.19755857E-05_JPRB, 0.19546096E-05_JPRB, 0.19249997E-05_JPRB, 0.18648767E-05_JPRB, 0.18033823E-05_JPRB, 0.17263197E-05_JPRB, &
  & 0.16440371E-05_JPRB, 0.15666522E-05_JPRB, 0.14955789E-05_JPRB, 0.14246770E-05_JPRB, 0.13514303E-05_JPRB, 0.12783340E-05_JPRB, &
  & 0.11970883E-05_JPRB, 0.11081824E-05_JPRB, 0.10179493E-05_JPRB, 0.92565441E-06_JPRB, 0.83454291E-06_JPRB, 0.74873769E-06_JPRB, &
  & 0.66419576E-06_JPRB, 0.57674322E-06_JPRB, 0.49168849E-06_JPRB, 0.41605316E-06_JPRB, 0.35371058E-06_JPRB, 0.30391982E-06_JPRB, &
  & 0.26161341E-06_JPRB, 0.22526535E-06_JPRB, 0.19927421E-06_JPRB, 0.17981094E-06_JPRB, 0.16557808E-06_JPRB, 0.15279304E-06_JPRB, &
  & 0.14393023E-06_JPRB, 0.14179649E-06_JPRB, 0.14919866E-06_JPRB, 0.16675282E-06_JPRB, 0.18993533E-06_JPRB, 0.21512857E-06_JPRB, &
  & 0.24264160E-06_JPRB, 0.26931412E-06_JPRB, 0.30271129E-06_JPRB, 0.34712152E-06_JPRB, 0.41180322E-06_JPRB, 0.49679631E-06_JPRB, &
  & 0.60645893E-06_JPRB, 0.73470119E-06_JPRB, 0.87047012E-06_JPRB, 0.10079073E-05_JPRB, 0.11451940E-05_JPRB, 0.12644696E-05_JPRB, &
  & 0.13704020E-05_JPRB, 0.14746025E-05_JPRB, 0.15800162E-05_JPRB, 0.16816915E-05_JPRB, 0.17726522E-05_JPRB, 0.18407148E-05_JPRB, &
  & 0.19104111E-05_JPRB, 0.19940015E-05_JPRB, 0.20886833E-05_JPRB, 0.21671091E-05_JPRB, 0.22493480E-05_JPRB, 0.22770387E-05_JPRB, &
  & 0.23261776E-05_JPRB, 0.23465132E-05_JPRB, 0.23537491E-05_JPRB, 0.23929961E-05_JPRB  /)

RGHG7(:,37, 4) = (/ &
  & 0.18081221E-05_JPRB, 0.17884310E-05_JPRB, 0.17599693E-05_JPRB, 0.16980966E-05_JPRB, 0.16340323E-05_JPRB, 0.15557805E-05_JPRB, &
  & 0.14753023E-05_JPRB, 0.14015535E-05_JPRB, 0.13355516E-05_JPRB, 0.12700493E-05_JPRB, 0.11991400E-05_JPRB, 0.11272877E-05_JPRB, &
  & 0.10498422E-05_JPRB, 0.96503718E-06_JPRB, 0.87935611E-06_JPRB, 0.79307589E-06_JPRB, 0.70661209E-06_JPRB, 0.62657547E-06_JPRB, &
  & 0.55030370E-06_JPRB, 0.47277536E-06_JPRB, 0.40020106E-06_JPRB, 0.33453093E-06_JPRB, 0.28041751E-06_JPRB, 0.23788535E-06_JPRB, &
  & 0.20354838E-06_JPRB, 0.17523808E-06_JPRB, 0.15576739E-06_JPRB, 0.14179934E-06_JPRB, 0.13168105E-06_JPRB, 0.12272353E-06_JPRB, &
  & 0.11704576E-06_JPRB, 0.11614229E-06_JPRB, 0.12150768E-06_JPRB, 0.13281479E-06_JPRB, 0.14830126E-06_JPRB, 0.16642726E-06_JPRB, &
  & 0.18714646E-06_JPRB, 0.20859716E-06_JPRB, 0.23615737E-06_JPRB, 0.27352771E-06_JPRB, 0.32828521E-06_JPRB, 0.40262962E-06_JPRB, &
  & 0.50123346E-06_JPRB, 0.62022134E-06_JPRB, 0.74758340E-06_JPRB, 0.87433086E-06_JPRB, 0.10020215E-05_JPRB, 0.11160206E-05_JPRB, &
  & 0.12159930E-05_JPRB, 0.13176646E-05_JPRB, 0.14183759E-05_JPRB, 0.15177137E-05_JPRB, 0.16082780E-05_JPRB, 0.16773385E-05_JPRB, &
  & 0.17506026E-05_JPRB, 0.18343570E-05_JPRB, 0.19280272E-05_JPRB, 0.20066308E-05_JPRB, 0.20812830E-05_JPRB, 0.21032051E-05_JPRB, &
  & 0.21447846E-05_JPRB, 0.21730487E-05_JPRB, 0.21871877E-05_JPRB, 0.22246030E-05_JPRB  /)

RGHG7(:,38, 4) = (/ &
  & 0.16223064E-05_JPRB, 0.16040410E-05_JPRB, 0.15768535E-05_JPRB, 0.15130393E-05_JPRB, 0.14461234E-05_JPRB, 0.13665520E-05_JPRB, &
  & 0.12880760E-05_JPRB, 0.12183618E-05_JPRB, 0.11579872E-05_JPRB, 0.10984761E-05_JPRB, 0.10301605E-05_JPRB, 0.95968844E-06_JPRB, &
  & 0.88645954E-06_JPRB, 0.80620488E-06_JPRB, 0.72557467E-06_JPRB, 0.64596825E-06_JPRB, 0.56466148E-06_JPRB, 0.49102564E-06_JPRB, &
  & 0.42393036E-06_JPRB, 0.35741379E-06_JPRB, 0.29868763E-06_JPRB, 0.24407479E-06_JPRB, 0.19909234E-06_JPRB, 0.16461425E-06_JPRB, &
  & 0.13912006E-06_JPRB, 0.11972840E-06_JPRB, 0.10749271E-06_JPRB, 0.99622088E-07_JPRB, 0.94069293E-07_JPRB, 0.89358735E-07_JPRB, &
  & 0.87215042E-07_JPRB, 0.87676668E-07_JPRB, 0.90782066E-07_JPRB, 0.95157523E-07_JPRB, 0.10210456E-06_JPRB, 0.11238885E-06_JPRB, &
  & 0.12556968E-06_JPRB, 0.14122630E-06_JPRB, 0.16230989E-06_JPRB, 0.19186885E-06_JPRB, 0.23561457E-06_JPRB, 0.29814332E-06_JPRB, &
  & 0.38447646E-06_JPRB, 0.49319578E-06_JPRB, 0.61122969E-06_JPRB, 0.72611597E-06_JPRB, 0.84315882E-06_JPRB, 0.95130320E-06_JPRB, &
  & 0.10446625E-05_JPRB, 0.11435281E-05_JPRB, 0.12390217E-05_JPRB, 0.13357658E-05_JPRB, 0.14258902E-05_JPRB, 0.14960579E-05_JPRB, &
  & 0.15732808E-05_JPRB, 0.16572173E-05_JPRB, 0.17497651E-05_JPRB, 0.18285658E-05_JPRB, 0.18947999E-05_JPRB, 0.19103212E-05_JPRB, &
  & 0.19435130E-05_JPRB, 0.19805743E-05_JPRB, 0.20023731E-05_JPRB, 0.20377559E-05_JPRB  /)

RGHG7(:,39, 4) = (/ &
  & 0.14542569E-05_JPRB, 0.14382824E-05_JPRB, 0.14161710E-05_JPRB, 0.13576940E-05_JPRB, 0.12952403E-05_JPRB, 0.12214531E-05_JPRB, &
  & 0.11491895E-05_JPRB, 0.10861328E-05_JPRB, 0.10329160E-05_JPRB, 0.98012720E-06_JPRB, 0.91735465E-06_JPRB, 0.85091339E-06_JPRB, &
  & 0.78205142E-06_JPRB, 0.70739367E-06_JPRB, 0.63352345E-06_JPRB, 0.56113743E-06_JPRB, 0.48783641E-06_JPRB, 0.42186759E-06_JPRB, &
  & 0.36218979E-06_JPRB, 0.30404620E-06_JPRB, 0.25329819E-06_JPRB, 0.20595112E-06_JPRB, 0.16724601E-06_JPRB, 0.13794256E-06_JPRB, &
  & 0.11677038E-06_JPRB, 0.10086998E-06_JPRB, 0.90839530E-07_JPRB, 0.84336752E-07_JPRB, 0.79920737E-07_JPRB, 0.76547996E-07_JPRB, &
  & 0.75207613E-07_JPRB, 0.75836256E-07_JPRB, 0.78250588E-07_JPRB, 0.81287046E-07_JPRB, 0.86414730E-07_JPRB, 0.94615921E-07_JPRB, &
  & 0.10515076E-06_JPRB, 0.11812387E-06_JPRB, 0.13689864E-06_JPRB, 0.16351636E-06_JPRB, 0.20240197E-06_JPRB, 0.25839037E-06_JPRB, &
  & 0.33679653E-06_JPRB, 0.43716835E-06_JPRB, 0.54752620E-06_JPRB, 0.65347739E-06_JPRB, 0.76147178E-06_JPRB, 0.86377239E-06_JPRB, &
  & 0.95099875E-06_JPRB, 0.10428226E-05_JPRB, 0.11335977E-05_JPRB, 0.12241552E-05_JPRB, 0.13083455E-05_JPRB, 0.13772632E-05_JPRB, &
  & 0.14551232E-05_JPRB, 0.15378710E-05_JPRB, 0.16286778E-05_JPRB, 0.17040988E-05_JPRB, 0.17618955E-05_JPRB, 0.17771683E-05_JPRB, &
  & 0.18061592E-05_JPRB, 0.18395948E-05_JPRB, 0.18581960E-05_JPRB, 0.18856826E-05_JPRB  /)

RGHG7(:,40, 4) = (/ &
  & 0.12599434E-05_JPRB, 0.12467989E-05_JPRB, 0.12312667E-05_JPRB, 0.11802442E-05_JPRB, 0.11242238E-05_JPRB, 0.10583871E-05_JPRB, &
  & 0.99410308E-06_JPRB, 0.93928860E-06_JPRB, 0.89472247E-06_JPRB, 0.84994249E-06_JPRB, 0.79415759E-06_JPRB, 0.73288049E-06_JPRB, &
  & 0.66916808E-06_JPRB, 0.60124999E-06_JPRB, 0.53559282E-06_JPRB, 0.47176994E-06_JPRB, 0.40833042E-06_JPRB, 0.35156662E-06_JPRB, &
  & 0.30030610E-06_JPRB, 0.25155718E-06_JPRB, 0.20921186E-06_JPRB, 0.16977148E-06_JPRB, 0.13796650E-06_JPRB, 0.11426484E-06_JPRB, &
  & 0.97425296E-07_JPRB, 0.84734253E-07_JPRB, 0.76468954E-07_JPRB, 0.70797692E-07_JPRB, 0.67154841E-07_JPRB, 0.64876200E-07_JPRB, &
  & 0.64031809E-07_JPRB, 0.64660452E-07_JPRB, 0.66520440E-07_JPRB, 0.68900438E-07_JPRB, 0.72992374E-07_JPRB, 0.79691001E-07_JPRB, &
  & 0.87920933E-07_JPRB, 0.98253617E-07_JPRB, 0.11500066E-06_JPRB, 0.13896336E-06_JPRB, 0.17315164E-06_JPRB, 0.22232743E-06_JPRB, &
  & 0.29214127E-06_JPRB, 0.38303089E-06_JPRB, 0.48465053E-06_JPRB, 0.58059435E-06_JPRB, 0.67823126E-06_JPRB, 0.77367550E-06_JPRB, &
  & 0.85378292E-06_JPRB, 0.93664976E-06_JPRB, 0.10219689E-05_JPRB, 0.11046781E-05_JPRB, 0.11810055E-05_JPRB, 0.12480705E-05_JPRB, &
  & 0.13261347E-05_JPRB, 0.14072632E-05_JPRB, 0.14959256E-05_JPRB, 0.15667952E-05_JPRB, 0.16146866E-05_JPRB, 0.16306742E-05_JPRB, &
  & 0.16554200E-05_JPRB, 0.16825682E-05_JPRB, 0.16956406E-05_JPRB, 0.17129010E-05_JPRB  /)

RGHG7(:,41, 4) = (/ &
  & 0.10223669E-05_JPRB, 0.10126826E-05_JPRB, 0.10051944E-05_JPRB, 0.96328605E-06_JPRB, 0.91513132E-06_JPRB, 0.85901518E-06_JPRB, &
  & 0.80448746E-06_JPRB, 0.75975029E-06_JPRB, 0.72576087E-06_JPRB, 0.69077283E-06_JPRB, 0.64353134E-06_JPRB, 0.58856816E-06_JPRB, &
  & 0.53115185E-06_JPRB, 0.47147396E-06_JPRB, 0.41585842E-06_JPRB, 0.36250525E-06_JPRB, 0.31112282E-06_JPRB, 0.26561350E-06_JPRB, &
  & 0.22464432E-06_JPRB, 0.18738175E-06_JPRB, 0.15530993E-06_JPRB, 0.12553664E-06_JPRB, 0.10216805E-06_JPRB, 0.85315395E-07_JPRB, &
  & 0.73773128E-07_JPRB, 0.65005992E-07_JPRB, 0.58898842E-07_JPRB, 0.54244230E-07_JPRB, 0.51546684E-07_JPRB, 0.50605739E-07_JPRB, &
  & 0.50367770E-07_JPRB, 0.50996413E-07_JPRB, 0.52178635E-07_JPRB, 0.53756015E-07_JPRB, 0.56581599E-07_JPRB, 0.61443124E-07_JPRB, &
  & 0.66854977E-07_JPRB, 0.73959355E-07_JPRB, 0.88227200E-07_JPRB, 0.10894376E-06_JPRB, 0.13738886E-06_JPRB, 0.17823527E-06_JPRB, &
  & 0.23754374E-06_JPRB, 0.31684000E-06_JPRB, 0.40777591E-06_JPRB, 0.49148427E-06_JPRB, 0.57645766E-06_JPRB, 0.66351901E-06_JPRB, &
  & 0.73492248E-06_JPRB, 0.80683805E-06_JPRB, 0.88548656E-06_JPRB, 0.95859999E-06_JPRB, 0.10253138E-05_JPRB, 0.10901137E-05_JPRB, &
  & 0.11684276E-05_JPRB, 0.12475763E-05_JPRB, 0.13336168E-05_JPRB, 0.13989216E-05_JPRB, 0.14347024E-05_JPRB, 0.14515639E-05_JPRB, &
  & 0.14711194E-05_JPRB, 0.14905804E-05_JPRB, 0.14968929E-05_JPRB, 0.15016504E-05_JPRB  /)

RGHG7(:,42, 4) = (/ &
  & 0.93144069E-06_JPRB, 0.92384676E-06_JPRB, 0.91524647E-06_JPRB, 0.88005188E-06_JPRB, 0.84000939E-06_JPRB, 0.79348353E-06_JPRB, &
  & 0.74579106E-06_JPRB, 0.70681220E-06_JPRB, 0.67599310E-06_JPRB, 0.64506601E-06_JPRB, 0.60355395E-06_JPRB, 0.55396363E-06_JPRB, &
  & 0.50117654E-06_JPRB, 0.44563555E-06_JPRB, 0.39407894E-06_JPRB, 0.34516137E-06_JPRB, 0.29945233E-06_JPRB, 0.25850999E-06_JPRB, &
  & 0.22113492E-06_JPRB, 0.18676808E-06_JPRB, 0.15571484E-06_JPRB, 0.12622402E-06_JPRB, 0.10286967E-06_JPRB, 0.86143284E-07_JPRB, &
  & 0.74340436E-07_JPRB, 0.65053893E-07_JPRB, 0.58700599E-07_JPRB, 0.54106610E-07_JPRB, 0.51387625E-07_JPRB, 0.50452360E-07_JPRB, &
  & 0.50391286E-07_JPRB, 0.51019929E-07_JPRB, 0.52155307E-07_JPRB, 0.54091802E-07_JPRB, 0.57475846E-07_JPRB, 0.62894950E-07_JPRB, &
  & 0.69134037E-07_JPRB, 0.77027655E-07_JPRB, 0.90053939E-07_JPRB, 0.10950486E-06_JPRB, 0.13776513E-06_JPRB, 0.17812264E-06_JPRB, &
  & 0.23638685E-06_JPRB, 0.31488184E-06_JPRB, 0.40624597E-06_JPRB, 0.49084417E-06_JPRB, 0.57496160E-06_JPRB, 0.65571649E-06_JPRB, &
  & 0.72127339E-06_JPRB, 0.79006024E-06_JPRB, 0.86298342E-06_JPRB, 0.93122992E-06_JPRB, 0.99449290E-06_JPRB, 0.10576996E-05_JPRB, &
  & 0.11299566E-05_JPRB, 0.12033089E-05_JPRB, 0.12805004E-05_JPRB, 0.13378423E-05_JPRB, 0.13702311E-05_JPRB, 0.13901130E-05_JPRB, &
  & 0.14066584E-05_JPRB, 0.14114824E-05_JPRB, 0.14068667E-05_JPRB, 0.14023815E-05_JPRB  /)

RGHG7(:,43, 4) = (/ &
  & 0.74628678E-06_JPRB, 0.74208844E-06_JPRB, 0.73593368E-06_JPRB, 0.71078511E-06_JPRB, 0.68152759E-06_JPRB, 0.64793312E-06_JPRB, &
  & 0.61067374E-06_JPRB, 0.58128347E-06_JPRB, 0.55790652E-06_JPRB, 0.53489661E-06_JPRB, 0.50228698E-06_JPRB, 0.46031474E-06_JPRB, &
  & 0.41445959E-06_JPRB, 0.36623759E-06_JPRB, 0.32270373E-06_JPRB, 0.28233672E-06_JPRB, 0.24699039E-06_JPRB, 0.21505604E-06_JPRB, &
  & 0.18538702E-06_JPRB, 0.15860308E-06_JPRB, 0.13289835E-06_JPRB, 0.10782355E-06_JPRB, 0.88111099E-07_JPRB, 0.74446026E-07_JPRB, &
  & 0.64684052E-07_JPRB, 0.56611476E-07_JPRB, 0.50961932E-07_JPRB, 0.46860568E-07_JPRB, 0.44528645E-07_JPRB, 0.44173973E-07_JPRB, &
  & 0.44535149E-07_JPRB, 0.45163791E-07_JPRB, 0.45964889E-07_JPRB, 0.47883790E-07_JPRB, 0.51232647E-07_JPRB, 0.56370251E-07_JPRB, &
  & 0.62151901E-07_JPRB, 0.69376956E-07_JPRB, 0.80204023E-07_JPRB, 0.97103850E-07_JPRB, 0.12272506E-06_JPRB, 0.15905360E-06_JPRB, &
  & 0.21184616E-06_JPRB, 0.28462319E-06_JPRB, 0.37178242E-06_JPRB, 0.45192940E-06_JPRB, 0.52981865E-06_JPRB, 0.60121367E-06_JPRB, &
  & 0.65769220E-06_JPRB, 0.71891374E-06_JPRB, 0.78374380E-06_JPRB, 0.84342216E-06_JPRB, 0.89940133E-06_JPRB, 0.96018012E-06_JPRB, &
  & 0.10270182E-05_JPRB, 0.10942303E-05_JPRB, 0.11622203E-05_JPRB, 0.12099032E-05_JPRB, 0.12339878E-05_JPRB, 0.12570014E-05_JPRB, &
  & 0.12685677E-05_JPRB, 0.12567305E-05_JPRB, 0.12392361E-05_JPRB, 0.12209398E-05_JPRB  /)

RGHG7(:,44, 4) = (/ &
  & 0.66549150E-06_JPRB, 0.65943115E-06_JPRB, 0.65514951E-06_JPRB, 0.63522117E-06_JPRB, 0.61140499E-06_JPRB, 0.58282424E-06_JPRB, &
  & 0.55124985E-06_JPRB, 0.52561501E-06_JPRB, 0.50517081E-06_JPRB, 0.48613969E-06_JPRB, 0.45743742E-06_JPRB, 0.41980301E-06_JPRB, &
  & 0.37855126E-06_JPRB, 0.33533680E-06_JPRB, 0.29598977E-06_JPRB, 0.25985712E-06_JPRB, 0.22790754E-06_JPRB, 0.19898224E-06_JPRB, &
  & 0.17217122E-06_JPRB, 0.14761483E-06_JPRB, 0.12341563E-06_JPRB, 0.10011656E-06_JPRB, 0.81992926E-07_JPRB, 0.69632523E-07_JPRB, &
  & 0.60674656E-07_JPRB, 0.53187257E-07_JPRB, 0.47861241E-07_JPRB, 0.44197764E-07_JPRB, 0.42095689E-07_JPRB, 0.41820570E-07_JPRB, &
  & 0.42271290E-07_JPRB, 0.43104531E-07_JPRB, 0.43935143E-07_JPRB, 0.45598354E-07_JPRB, 0.48989004E-07_JPRB, 0.54135112E-07_JPRB, &
  & 0.59596212E-07_JPRB, 0.66622656E-07_JPRB, 0.76701075E-07_JPRB, 0.92565457E-07_JPRB, 0.11680484E-06_JPRB, 0.15127682E-06_JPRB, &
  & 0.20127414E-06_JPRB, 0.27145754E-06_JPRB, 0.35543091E-06_JPRB, 0.43304830E-06_JPRB, 0.50776402E-06_JPRB, 0.57577984E-06_JPRB, &
  & 0.62951476E-06_JPRB, 0.68761264E-06_JPRB, 0.74863498E-06_JPRB, 0.80560405E-06_JPRB, 0.85951192E-06_JPRB, 0.91702891E-06_JPRB, &
  & 0.97901236E-06_JPRB, 0.10391083E-05_JPRB, 0.10980789E-05_JPRB, 0.11375964E-05_JPRB, 0.11582831E-05_JPRB, 0.11787744E-05_JPRB, &
  & 0.11844749E-05_JPRB, 0.11694928E-05_JPRB, 0.11509723E-05_JPRB, 0.11327839E-05_JPRB  /)

RGHG7(:,45, 4) = (/ &
  & 0.55012284E-06_JPRB, 0.54237167E-06_JPRB, 0.54053137E-06_JPRB, 0.52781492E-06_JPRB, 0.51155569E-06_JPRB, 0.49031623E-06_JPRB, &
  & 0.46653170E-06_JPRB, 0.44638343E-06_JPRB, 0.43021804E-06_JPRB, 0.41671661E-06_JPRB, 0.39358716E-06_JPRB, 0.36185339E-06_JPRB, &
  & 0.32671794E-06_JPRB, 0.29012875E-06_JPRB, 0.25656158E-06_JPRB, 0.22632957E-06_JPRB, 0.19955598E-06_JPRB, 0.17519419E-06_JPRB, &
  & 0.15261022E-06_JPRB, 0.13154763E-06_JPRB, 0.10973802E-06_JPRB, 0.89018314E-07_JPRB, 0.73163492E-07_JPRB, 0.62675074E-07_JPRB, &
  & 0.54890431E-07_JPRB, 0.48222565E-07_JPRB, 0.43353762E-07_JPRB, 0.40251018E-07_JPRB, 0.38459502E-07_JPRB, 0.38348290E-07_JPRB, &
  & 0.38954290E-07_JPRB, 0.40020450E-07_JPRB, 0.40842436E-07_JPRB, 0.42212341E-07_JPRB, 0.45646124E-07_JPRB, 0.50766351E-07_JPRB, &
  & 0.55804746E-07_JPRB, 0.62520630E-07_JPRB, 0.71468956E-07_JPRB, 0.85832300E-07_JPRB, 0.10816519E-06_JPRB, 0.14001467E-06_JPRB, &
  & 0.18613862E-06_JPRB, 0.25264707E-06_JPRB, 0.33246238E-06_JPRB, 0.40663774E-06_JPRB, 0.47695386E-06_JPRB, 0.53994034E-06_JPRB, &
  & 0.58940507E-06_JPRB, 0.64299120E-06_JPRB, 0.69865639E-06_JPRB, 0.75145878E-06_JPRB, 0.80208852E-06_JPRB, 0.85558549E-06_JPRB, &
  & 0.91135775E-06_JPRB, 0.96257688E-06_JPRB, 0.10101171E-05_JPRB, 0.10391187E-05_JPRB, 0.10548883E-05_JPRB, 0.10729037E-05_JPRB, &
  & 0.10712974E-05_JPRB, 0.10506303E-05_JPRB, 0.10293148E-05_JPRB, 0.10095046E-05_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART8',0,ZHOOK_HANDLE)



RGHG7(:,46, 4) = (/ &
  & 0.48363110E-06_JPRB, 0.47630703E-06_JPRB, 0.47591193E-06_JPRB, 0.46699844E-06_JPRB, 0.45395660E-06_JPRB, 0.43599123E-06_JPRB, &
  & 0.41560916E-06_JPRB, 0.39825045E-06_JPRB, 0.38384227E-06_JPRB, 0.37251970E-06_JPRB, 0.35244423E-06_JPRB, 0.32446072E-06_JPRB, &
  & 0.29316995E-06_JPRB, 0.26103481E-06_JPRB, 0.23132622E-06_JPRB, 0.20434709E-06_JPRB, 0.18018556E-06_JPRB, 0.15822690E-06_JPRB, &
  & 0.13829921E-06_JPRB, 0.11943970E-06_JPRB, 0.99684730E-07_JPRB, 0.81072535E-07_JPRB, 0.67084760E-07_JPRB, 0.58021472E-07_JPRB, &
  & 0.51213790E-07_JPRB, 0.45244654E-07_JPRB, 0.40788798E-07_JPRB, 0.38038546E-07_JPRB, 0.36418235E-07_JPRB, 0.36374995E-07_JPRB, &
  & 0.37035117E-07_JPRB, 0.38191906E-07_JPRB, 0.39069297E-07_JPRB, 0.40283105E-07_JPRB, 0.43647626E-07_JPRB, 0.48550018E-07_JPRB, &
  & 0.53287528E-07_JPRB, 0.59706288E-07_JPRB, 0.67910598E-07_JPRB, 0.81217701E-07_JPRB, 0.10192525E-06_JPRB, 0.13098097E-06_JPRB, &
  & 0.17339844E-06_JPRB, 0.23482533E-06_JPRB, 0.30840575E-06_JPRB, 0.37711799E-06_JPRB, 0.44254281E-06_JPRB, 0.50273713E-06_JPRB, &
  & 0.55099996E-06_JPRB, 0.60323563E-06_JPRB, 0.65534942E-06_JPRB, 0.70661873E-06_JPRB, 0.75538535E-06_JPRB, 0.80581552E-06_JPRB, &
  & 0.85595381E-06_JPRB, 0.90227095E-06_JPRB, 0.94346653E-06_JPRB, 0.96675422E-06_JPRB, 0.97818656E-06_JPRB, 0.99055235E-06_JPRB, &
  & 0.98588481E-06_JPRB, 0.96489239E-06_JPRB, 0.94260896E-06_JPRB, 0.92220966E-06_JPRB  /)

RGHG7(:,47, 4) = (/ &
  & 0.41539913E-06_JPRB, 0.40900051E-06_JPRB, 0.41010169E-06_JPRB, 0.40496781E-06_JPRB, 0.39483203E-06_JPRB, 0.37989380E-06_JPRB, &
  & 0.36262538E-06_JPRB, 0.34799975E-06_JPRB, 0.33514840E-06_JPRB, 0.32571130E-06_JPRB, 0.30871488E-06_JPRB, 0.28470126E-06_JPRB, &
  & 0.25746687E-06_JPRB, 0.23012327E-06_JPRB, 0.20455755E-06_JPRB, 0.18086504E-06_JPRB, 0.15925497E-06_JPRB, 0.13968343E-06_JPRB, &
  & 0.12255802E-06_JPRB, 0.10602508E-06_JPRB, 0.88613994E-07_JPRB, 0.72380274E-07_JPRB, 0.60502854E-07_JPRB, 0.53022333E-07_JPRB, &
  & 0.47321722E-07_JPRB, 0.42148294E-07_JPRB, 0.38168134E-07_JPRB, 0.35789788E-07_JPRB, 0.34342457E-07_JPRB, 0.34359760E-07_JPRB, &
  & 0.35063128E-07_JPRB, 0.36297757E-07_JPRB, 0.37252989E-07_JPRB, 0.38311115E-07_JPRB, 0.41571849E-07_JPRB, 0.46180175E-07_JPRB, &
  & 0.50589022E-07_JPRB, 0.56661823E-07_JPRB, 0.64070425E-07_JPRB, 0.76227211E-07_JPRB, 0.95083878E-07_JPRB, 0.12082703E-06_JPRB, &
  & 0.15892864E-06_JPRB, 0.21411097E-06_JPRB, 0.27995918E-06_JPRB, 0.34185601E-06_JPRB, 0.40144275E-06_JPRB, 0.45880885E-06_JPRB, &
  & 0.50627597E-06_JPRB, 0.55756025E-06_JPRB, 0.60586849E-06_JPRB, 0.65586639E-06_JPRB, 0.70273023E-06_JPRB, 0.74975269E-06_JPRB, &
  & 0.79339559E-06_JPRB, 0.83475685E-06_JPRB, 0.86952622E-06_JPRB, 0.88707098E-06_JPRB, 0.89353014E-06_JPRB, 0.89863078E-06_JPRB, &
  & 0.89122150E-06_JPRB, 0.87092101E-06_JPRB, 0.84786781E-06_JPRB, 0.82698417E-06_JPRB  /)

RGHG7(:,48, 4) = (/ &
  & 0.36820656E-06_JPRB, 0.36365708E-06_JPRB, 0.36423907E-06_JPRB, 0.36093835E-06_JPRB, 0.35204619E-06_JPRB, 0.33874484E-06_JPRB, &
  & 0.32297934E-06_JPRB, 0.30951858E-06_JPRB, 0.29705783E-06_JPRB, 0.28836273E-06_JPRB, 0.27343313E-06_JPRB, 0.25224000E-06_JPRB, &
  & 0.22790242E-06_JPRB, 0.20389123E-06_JPRB, 0.18125886E-06_JPRB, 0.15989815E-06_JPRB, 0.14024680E-06_JPRB, 0.12296688E-06_JPRB, &
  & 0.10840736E-06_JPRB, 0.94301857E-07_JPRB, 0.79618737E-07_JPRB, 0.65742315E-07_JPRB, 0.55644080E-07_JPRB, 0.49255013E-07_JPRB, &
  & 0.44490353E-07_JPRB, 0.40025867E-07_JPRB, 0.36496709E-07_JPRB, 0.34391407E-07_JPRB, 0.33096712E-07_JPRB, 0.33097540E-07_JPRB, &
  & 0.33790764E-07_JPRB, 0.35048049E-07_JPRB, 0.36014573E-07_JPRB, 0.37027386E-07_JPRB, 0.40189719E-07_JPRB, 0.44485148E-07_JPRB, &
  & 0.48639221E-07_JPRB, 0.54338559E-07_JPRB, 0.61004123E-07_JPRB, 0.72024842E-07_JPRB, 0.88865298E-07_JPRB, 0.11153603E-06_JPRB, &
  & 0.14513099E-06_JPRB, 0.19330749E-06_JPRB, 0.25052354E-06_JPRB, 0.30460627E-06_JPRB, 0.35788514E-06_JPRB, 0.41116053E-06_JPRB, &
  & 0.45612866E-06_JPRB, 0.50412990E-06_JPRB, 0.54941543E-06_JPRB, 0.59765671E-06_JPRB, 0.64289270E-06_JPRB, 0.68786066E-06_JPRB, &
  & 0.72851627E-06_JPRB, 0.76693485E-06_JPRB, 0.79824268E-06_JPRB, 0.81263841E-06_JPRB, 0.81566116E-06_JPRB, 0.81567517E-06_JPRB, &
  & 0.80495615E-06_JPRB, 0.78319202E-06_JPRB, 0.75820997E-06_JPRB, 0.73886744E-06_JPRB  /)

RGHG7(:,49, 4) = (/ &
  & 0.32551103E-06_JPRB, 0.32342924E-06_JPRB, 0.32251996E-06_JPRB, 0.32036432E-06_JPRB, 0.31209352E-06_JPRB, 0.29997276E-06_JPRB, &
  & 0.28513931E-06_JPRB, 0.27225552E-06_JPRB, 0.25969713E-06_JPRB, 0.25130384E-06_JPRB, 0.23820281E-06_JPRB, 0.21961052E-06_JPRB, &
  & 0.19795367E-06_JPRB, 0.17696941E-06_JPRB, 0.15703552E-06_JPRB, 0.13782295E-06_JPRB, 0.12007119E-06_JPRB, 0.10528559E-06_JPRB, &
  & 0.93460063E-07_JPRB, 0.82088550E-07_JPRB, 0.70601005E-07_JPRB, 0.59325425E-07_JPRB, 0.51046892E-07_JPRB, 0.45643127E-07_JPRB, &
  & 0.41837140E-07_JPRB, 0.38118288E-07_JPRB, 0.35077342E-07_JPRB, 0.33229462E-07_JPRB, 0.32094545E-07_JPRB, 0.32042114E-07_JPRB, &
  & 0.32699831E-07_JPRB, 0.33957117E-07_JPRB, 0.34905887E-07_JPRB, 0.35918700E-07_JPRB, 0.38974514E-07_JPRB, 0.42914879E-07_JPRB, &
  & 0.46820407E-07_JPRB, 0.52093668E-07_JPRB, 0.57960339E-07_JPRB, 0.67729458E-07_JPRB, 0.82262000E-07_JPRB, 0.10163951E-06_JPRB, &
  & 0.13015706E-06_JPRB, 0.17022923E-06_JPRB, 0.21747687E-06_JPRB, 0.26245220E-06_JPRB, 0.30853216E-06_JPRB, 0.35670350E-06_JPRB, &
  & 0.39812987E-06_JPRB, 0.44143539E-06_JPRB, 0.48372951E-06_JPRB, 0.52980491E-06_JPRB, 0.57336322E-06_JPRB, 0.61667126E-06_JPRB, &
  & 0.65561368E-06_JPRB, 0.69168884E-06_JPRB, 0.72051122E-06_JPRB, 0.73259904E-06_JPRB, 0.73251497E-06_JPRB, 0.72788653E-06_JPRB, &
  & 0.71324405E-06_JPRB, 0.68887908E-06_JPRB, 0.66123406E-06_JPRB, 0.64451899E-06_JPRB  /)

RGHG7(:,50, 4) = (/ &
  & 0.28950669E-06_JPRB, 0.28841655E-06_JPRB, 0.28701091E-06_JPRB, 0.28557879E-06_JPRB, 0.27769870E-06_JPRB, 0.26579096E-06_JPRB, &
  & 0.25139213E-06_JPRB, 0.23863358E-06_JPRB, 0.22614711E-06_JPRB, 0.21850730E-06_JPRB, 0.20712926E-06_JPRB, 0.19072598E-06_JPRB, &
  & 0.17153810E-06_JPRB, 0.15312448E-06_JPRB, 0.13556441E-06_JPRB, 0.11858028E-06_JPRB, 0.10298722E-06_JPRB, 0.90609631E-07_JPRB, &
  & 0.81183951E-07_JPRB, 0.72244020E-07_JPRB, 0.63500547E-07_JPRB, 0.54411087E-07_JPRB, 0.47610338E-07_JPRB, 0.42947065E-07_JPRB, &
  & 0.39841131E-07_JPRB, 0.36741121E-07_JPRB, 0.34107910E-07_JPRB, 0.32462483E-07_JPRB, 0.31477894E-07_JPRB, 0.31350354E-07_JPRB, &
  & 0.31976268E-07_JPRB, 0.33207593E-07_JPRB, 0.34139019E-07_JPRB, 0.35218176E-07_JPRB, 0.38227616E-07_JPRB, 0.41910518E-07_JPRB, &
  & 0.45659764E-07_JPRB, 0.50456191E-07_JPRB, 0.55597181E-07_JPRB, 0.64186807E-07_JPRB, 0.76626144E-07_JPRB, 0.93155538E-07_JPRB, &
  & 0.11718573E-06_JPRB, 0.15007297E-06_JPRB, 0.18832319E-06_JPRB, 0.22531826E-06_JPRB, 0.26392384E-06_JPRB, 0.30483286E-06_JPRB, &
  & 0.34081452E-06_JPRB, 0.37802392E-06_JPRB, 0.41604848E-06_JPRB, 0.45824256E-06_JPRB, 0.49926766E-06_JPRB, 0.53977713E-06_JPRB, &
  & 0.57801216E-06_JPRB, 0.61219019E-06_JPRB, 0.63906610E-06_JPRB, 0.64987415E-06_JPRB, 0.64798367E-06_JPRB, 0.64054468E-06_JPRB, &
  & 0.62171146E-06_JPRB, 0.59339505E-06_JPRB, 0.56353493E-06_JPRB, 0.54765608E-06_JPRB  /)

RGHG7(:,51, 4) = (/ &
  & 0.25408018E-06_JPRB, 0.25328677E-06_JPRB, 0.25186722E-06_JPRB, 0.25099608E-06_JPRB, 0.24341735E-06_JPRB, 0.23123144E-06_JPRB, &
  & 0.21704124E-06_JPRB, 0.20418069E-06_JPRB, 0.19186112E-06_JPRB, 0.18527375E-06_JPRB, 0.17570386E-06_JPRB, 0.16145181E-06_JPRB, &
  & 0.14482315E-06_JPRB, 0.12895022E-06_JPRB, 0.11378710E-06_JPRB, 0.99255563E-07_JPRB, 0.86133632E-07_JPRB, 0.76315272E-07_JPRB, &
  & 0.69309728E-07_JPRB, 0.62840933E-07_JPRB, 0.56828227E-07_JPRB, 0.49885363E-07_JPRB, 0.44503314E-07_JPRB, 0.40512301E-07_JPRB, &
  & 0.38027628E-07_JPRB, 0.35530334E-07_JPRB, 0.33295843E-07_JPRB, 0.31840503E-07_JPRB, 0.31013548E-07_JPRB, 0.30793283E-07_JPRB, &
  & 0.31386742E-07_JPRB, 0.32576340E-07_JPRB, 0.33489221E-07_JPRB, 0.34675013E-07_JPRB, 0.37665908E-07_JPRB, 0.41121632E-07_JPRB, &
  & 0.44750335E-07_JPRB, 0.49004318E-07_JPRB, 0.53398867E-07_JPRB, 0.60750607E-07_JPRB, 0.71038712E-07_JPRB, 0.84721433E-07_JPRB, &
  & 0.10420807E-06_JPRB, 0.12980708E-06_JPRB, 0.15883575E-06_JPRB, 0.18779152E-06_JPRB, 0.21816771E-06_JPRB, 0.25008699E-06_JPRB, &
  & 0.27917915E-06_JPRB, 0.30905859E-06_JPRB, 0.34179316E-06_JPRB, 0.37888734E-06_JPRB, 0.41672267E-06_JPRB, 0.45360658E-06_JPRB, &
  & 0.49160515E-06_JPRB, 0.52396577E-06_JPRB, 0.54901962E-06_JPRB, 0.55898387E-06_JPRB, 0.55582305E-06_JPRB, 0.54630700E-06_JPRB, &
  & 0.52280042E-06_JPRB, 0.48950001E-06_JPRB, 0.45747938E-06_JPRB, 0.44156345E-06_JPRB  /)

RGHG7(:,52, 4) = (/ &
  & 0.22021408E-06_JPRB, 0.21926907E-06_JPRB, 0.21831397E-06_JPRB, 0.21848559E-06_JPRB, 0.21181544E-06_JPRB, 0.19932453E-06_JPRB, &
  & 0.18504938E-06_JPRB, 0.17230162E-06_JPRB, 0.16082898E-06_JPRB, 0.15603344E-06_JPRB, 0.14854230E-06_JPRB, 0.13657476E-06_JPRB, &
  & 0.12257281E-06_JPRB, 0.10919891E-06_JPRB, 0.96503957E-07_JPRB, 0.84425229E-07_JPRB, 0.73757626E-07_JPRB, 0.65822374E-07_JPRB, &
  & 0.60527522E-07_JPRB, 0.55859085E-07_JPRB, 0.51827384E-07_JPRB, 0.46520481E-07_JPRB, 0.42255723E-07_JPRB, 0.38858487E-07_JPRB, &
  & 0.36771696E-07_JPRB, 0.34690681E-07_JPRB, 0.32759460E-07_JPRB, 0.31396900E-07_JPRB, 0.30680809E-07_JPRB, 0.30393182E-07_JPRB, &
  & 0.30968210E-07_JPRB, 0.32136956E-07_JPRB, 0.33074872E-07_JPRB, 0.34384772E-07_JPRB, 0.37417300E-07_JPRB, 0.40783841E-07_JPRB, &
  & 0.44274845E-07_JPRB, 0.48015416E-07_JPRB, 0.51836658E-07_JPRB, 0.58327450E-07_JPRB, 0.67068014E-07_JPRB, 0.78361030E-07_JPRB, &
  & 0.94281329E-07_JPRB, 0.11449867E-06_JPRB, 0.13706665E-06_JPRB, 0.15982722E-06_JPRB, 0.18270042E-06_JPRB, 0.20683192E-06_JPRB, &
  & 0.22944146E-06_JPRB, 0.25268347E-06_JPRB, 0.27982439E-06_JPRB, 0.31043840E-06_JPRB, 0.34313210E-06_JPRB, 0.37446515E-06_JPRB, &
  & 0.40855452E-06_JPRB, 0.43815344E-06_JPRB, 0.46133073E-06_JPRB, 0.46926216E-06_JPRB, 0.46527839E-06_JPRB, 0.45463585E-06_JPRB, &
  & 0.42973661E-06_JPRB, 0.39474335E-06_JPRB, 0.36305833E-06_JPRB, 0.34744808E-06_JPRB  /)

RGHG7(:,53, 4) = (/ &
  & 0.18393478E-06_JPRB, 0.18265220E-06_JPRB, 0.18238690E-06_JPRB, 0.18387942E-06_JPRB, 0.17843233E-06_JPRB, 0.16559896E-06_JPRB, &
  & 0.15111833E-06_JPRB, 0.13857606E-06_JPRB, 0.12828733E-06_JPRB, 0.12572754E-06_JPRB, 0.12060423E-06_JPRB, 0.11117574E-06_JPRB, &
  & 0.10006021E-06_JPRB, 0.89391709E-07_JPRB, 0.79411934E-07_JPRB, 0.70004356E-07_JPRB, 0.62003013E-07_JPRB, 0.55858314E-07_JPRB, &
  & 0.52153433E-07_JPRB, 0.49187487E-07_JPRB, 0.47024614E-07_JPRB, 0.43302790E-07_JPRB, 0.40138781E-07_JPRB, 0.37357965E-07_JPRB, &
  & 0.35618522E-07_JPRB, 0.33919100E-07_JPRB, 0.32281411E-07_JPRB, 0.30982451E-07_JPRB, 0.30369096E-07_JPRB, 0.30017870E-07_JPRB, &
  & 0.30578221E-07_JPRB, 0.31732291E-07_JPRB, 0.32714237E-07_JPRB, 0.34166011E-07_JPRB, 0.37267031E-07_JPRB, 0.40589541E-07_JPRB, &
  & 0.43923995E-07_JPRB, 0.47116637E-07_JPRB, 0.50380166E-07_JPRB, 0.56078418E-07_JPRB, 0.63365993E-07_JPRB, 0.72232469E-07_JPRB, &
  & 0.84645046E-07_JPRB, 0.99735345E-07_JPRB, 0.11632993E-06_JPRB, 0.13305349E-06_JPRB, 0.14803555E-06_JPRB, 0.16414870E-06_JPRB, &
  & 0.17985532E-06_JPRB, 0.19613570E-06_JPRB, 0.21706839E-06_JPRB, 0.24009457E-06_JPRB, 0.26643817E-06_JPRB, 0.29098572E-06_JPRB, &
  & 0.31940500E-06_JPRB, 0.34563318E-06_JPRB, 0.36674596E-06_JPRB, 0.37200624E-06_JPRB, 0.36729842E-06_JPRB, 0.35579485E-06_JPRB, &
  & 0.33064122E-06_JPRB, 0.29507067E-06_JPRB, 0.26471144E-06_JPRB, 0.24956595E-06_JPRB  /)

RGHG7(:,54, 4) = (/ &
  & 0.15278075E-06_JPRB, 0.15158800E-06_JPRB, 0.15197811E-06_JPRB, 0.15410298E-06_JPRB, 0.14995638E-06_JPRB, 0.13789923E-06_JPRB, &
  & 0.12365019E-06_JPRB, 0.11216428E-06_JPRB, 0.10327032E-06_JPRB, 0.10245150E-06_JPRB, 0.99317728E-07_JPRB, 0.92460314E-07_JPRB, &
  & 0.83887791E-07_JPRB, 0.75464561E-07_JPRB, 0.67754129E-07_JPRB, 0.60355725E-07_JPRB, 0.54421675E-07_JPRB, 0.49633518E-07_JPRB, &
  & 0.46937190E-07_JPRB, 0.44866087E-07_JPRB, 0.43770684E-07_JPRB, 0.41117626E-07_JPRB, 0.38692442E-07_JPRB, 0.36444068E-07_JPRB, &
  & 0.34888091E-07_JPRB, 0.33444878E-07_JPRB, 0.32001697E-07_JPRB, 0.30717864E-07_JPRB, 0.30107037E-07_JPRB, 0.29742777E-07_JPRB, &
  & 0.30282723E-07_JPRB, 0.31412198E-07_JPRB, 0.32493058E-07_JPRB, 0.34108582E-07_JPRB, 0.37323677E-07_JPRB, 0.40704341E-07_JPRB, &
  & 0.43881864E-07_JPRB, 0.46683364E-07_JPRB, 0.49617540E-07_JPRB, 0.54812822E-07_JPRB, 0.60953505E-07_JPRB, 0.68236770E-07_JPRB, &
  & 0.78406875E-07_JPRB, 0.90383347E-07_JPRB, 0.10321511E-06_JPRB, 0.11552826E-06_JPRB, 0.12566227E-06_JPRB, 0.13697251E-06_JPRB, &
  & 0.14830874E-06_JPRB, 0.16033816E-06_JPRB, 0.17631662E-06_JPRB, 0.19319501E-06_JPRB, 0.21286671E-06_JPRB, 0.23091393E-06_JPRB, &
  & 0.25249685E-06_JPRB, 0.27359658E-06_JPRB, 0.29114573E-06_JPRB, 0.29425025E-06_JPRB, 0.28844150E-06_JPRB, 0.27867898E-06_JPRB, &
  & 0.25661457E-06_JPRB, 0.22557749E-06_JPRB, 0.20022598E-06_JPRB, 0.18748374E-06_JPRB  /)

RGHG7(:,55, 4) = (/ &
  & 0.11894390E-06_JPRB, 0.11790687E-06_JPRB, 0.11901850E-06_JPRB, 0.12175328E-06_JPRB, 0.11905751E-06_JPRB, 0.10800736E-06_JPRB, &
  & 0.94072366E-07_JPRB, 0.83868566E-07_JPRB, 0.76547414E-07_JPRB, 0.77592070E-07_JPRB, 0.76612468E-07_JPRB, 0.72607377E-07_JPRB, &
  & 0.66806720E-07_JPRB, 0.60810172E-07_JPRB, 0.55554970E-07_JPRB, 0.50295160E-07_JPRB, 0.46572374E-07_JPRB, 0.43229845E-07_JPRB, &
  & 0.41574264E-07_JPRB, 0.40388185E-07_JPRB, 0.40369866E-07_JPRB, 0.38832822E-07_JPRB, 0.37178466E-07_JPRB, 0.35508862E-07_JPRB, &
  & 0.34134561E-07_JPRB, 0.32958673E-07_JPRB, 0.31717931E-07_JPRB, 0.30444479E-07_JPRB, 0.29823271E-07_JPRB, 0.29451225E-07_JPRB, &
  & 0.29967813E-07_JPRB, 0.31068739E-07_JPRB, 0.32266391E-07_JPRB, 0.34066187E-07_JPRB, 0.37413646E-07_JPRB, 0.40872171E-07_JPRB, &
  & 0.43875804E-07_JPRB, 0.46264638E-07_JPRB, 0.48864010E-07_JPRB, 0.53540216E-07_JPRB, 0.58450689E-07_JPRB, 0.64091077E-07_JPRB, &
  & 0.71943508E-07_JPRB, 0.80735448E-07_JPRB, 0.89689707E-07_JPRB, 0.97331181E-07_JPRB, 0.10249503E-06_JPRB, 0.10890778E-06_JPRB, &
  & 0.11573585E-06_JPRB, 0.12341281E-06_JPRB, 0.13406814E-06_JPRB, 0.14432572E-06_JPRB, 0.15656424E-06_JPRB, 0.16744822E-06_JPRB, &
  & 0.18130468E-06_JPRB, 0.19649214E-06_JPRB, 0.20989647E-06_JPRB, 0.21068071E-06_JPRB, 0.20360282E-06_JPRB, 0.19611126E-06_JPRB, &
  & 0.17790877E-06_JPRB, 0.15256596E-06_JPRB, 0.13324612E-06_JPRB, 0.12342108E-06_JPRB  /)

RGHG7(:,56, 4) = (/ &
  & 0.95894357E-07_JPRB, 0.95771616E-07_JPRB, 0.96905374E-07_JPRB, 0.99386684E-07_JPRB, 0.97831398E-07_JPRB, 0.88574241E-07_JPRB, &
  & 0.76248607E-07_JPRB, 0.67775740E-07_JPRB, 0.62068877E-07_JPRB, 0.63411464E-07_JPRB, 0.63391718E-07_JPRB, 0.61108539E-07_JPRB, &
  & 0.57188073E-07_JPRB, 0.52837741E-07_JPRB, 0.49011846E-07_JPRB, 0.45013074E-07_JPRB, 0.42380166E-07_JPRB, 0.39991751E-07_JPRB, &
  & 0.38890596E-07_JPRB, 0.38081665E-07_JPRB, 0.38392963E-07_JPRB, 0.37506234E-07_JPRB, 0.36273760E-07_JPRB, 0.35005687E-07_JPRB, &
  & 0.33787414E-07_JPRB, 0.32694519E-07_JPRB, 0.31562882E-07_JPRB, 0.30311685E-07_JPRB, 0.29582330E-07_JPRB, 0.29259744E-07_JPRB, &
  & 0.29750155E-07_JPRB, 0.30779836E-07_JPRB, 0.32141617E-07_JPRB, 0.34112356E-07_JPRB, 0.37689882E-07_JPRB, 0.41278607E-07_JPRB, &
  & 0.44065670E-07_JPRB, 0.46198477E-07_JPRB, 0.48705271E-07_JPRB, 0.52918465E-07_JPRB, 0.56969839E-07_JPRB, 0.61883000E-07_JPRB, &
  & 0.68539698E-07_JPRB, 0.75627652E-07_JPRB, 0.82541911E-07_JPRB, 0.87760437E-07_JPRB, 0.91307477E-07_JPRB, 0.95692589E-07_JPRB, &
  & 0.10052892E-06_JPRB, 0.10633185E-06_JPRB, 0.11399861E-06_JPRB, 0.12076050E-06_JPRB, 0.12866550E-06_JPRB, 0.13595528E-06_JPRB, &
  & 0.14488034E-06_JPRB, 0.15538091E-06_JPRB, 0.16468258E-06_JPRB, 0.16466485E-06_JPRB, 0.15920280E-06_JPRB, 0.15376896E-06_JPRB, &
  & 0.14005357E-06_JPRB, 0.12135050E-06_JPRB, 0.10753384E-06_JPRB, 0.10024137E-06_JPRB  /)

RGHG7(:,57, 4) = (/ &
  & 0.73559376E-07_JPRB, 0.74226353E-07_JPRB, 0.75389074E-07_JPRB, 0.77594037E-07_JPRB, 0.77048651E-07_JPRB, 0.69631254E-07_JPRB, &
  & 0.59044099E-07_JPRB, 0.52297190E-07_JPRB, 0.48131389E-07_JPRB, 0.49737309E-07_JPRB, 0.50563533E-07_JPRB, 0.49868173E-07_JPRB, &
  & 0.47739100E-07_JPRB, 0.44976008E-07_JPRB, 0.42544065E-07_JPRB, 0.39812915E-07_JPRB, 0.38261642E-07_JPRB, 0.36762824E-07_JPRB, &
  & 0.36209222E-07_JPRB, 0.35792782E-07_JPRB, 0.36405817E-07_JPRB, 0.36160036E-07_JPRB, 0.35353346E-07_JPRB, 0.34485539E-07_JPRB, &
  & 0.33462049E-07_JPRB, 0.32449048E-07_JPRB, 0.31404573E-07_JPRB, 0.30161769E-07_JPRB, 0.29316231E-07_JPRB, 0.29028267E-07_JPRB, &
  & 0.29503998E-07_JPRB, 0.30478225E-07_JPRB, 0.32007421E-07_JPRB, 0.34165191E-07_JPRB, 0.38016594E-07_JPRB, 0.41694638E-07_JPRB, &
  & 0.44258307E-07_JPRB, 0.46143084E-07_JPRB, 0.48562199E-07_JPRB, 0.52264506E-07_JPRB, 0.55496198E-07_JPRB, 0.59680338E-07_JPRB, &
  & 0.65132862E-07_JPRB, 0.70532948E-07_JPRB, 0.75407683E-07_JPRB, 0.78344551E-07_JPRB, 0.80265254E-07_JPRB, 0.82638377E-07_JPRB, &
  & 0.85551377E-07_JPRB, 0.89430927E-07_JPRB, 0.94255666E-07_JPRB, 0.97691492E-07_JPRB, 0.10172538E-06_JPRB, 0.10566724E-06_JPRB, &
  & 0.11017368E-06_JPRB, 0.11641342E-06_JPRB, 0.12201309E-06_JPRB, 0.12135975E-06_JPRB, 0.11737510E-06_JPRB, 0.11380142E-06_JPRB, &
  & 0.10417564E-06_JPRB, 0.91484214E-07_JPRB, 0.82598427E-07_JPRB, 0.77649314E-07_JPRB  /)

RGHG7(:,58, 4) = (/ &
  & 0.56250267E-07_JPRB, 0.57575247E-07_JPRB, 0.58645025E-07_JPRB, 0.60395380E-07_JPRB, 0.60499916E-07_JPRB, 0.55000628E-07_JPRB, &
  & 0.46473015E-07_JPRB, 0.41388961E-07_JPRB, 0.38524349E-07_JPRB, 0.40020490E-07_JPRB, 0.41208379E-07_JPRB, 0.41534709E-07_JPRB, &
  & 0.40735785E-07_JPRB, 0.39186329E-07_JPRB, 0.37784156E-07_JPRB, 0.36065267E-07_JPRB, 0.35284470E-07_JPRB, 0.34402572E-07_JPRB, &
  & 0.34249698E-07_JPRB, 0.34124881E-07_JPRB, 0.34828164E-07_JPRB, 0.35068645E-07_JPRB, 0.34594662E-07_JPRB, 0.34059560E-07_JPRB, &
  & 0.33275833E-07_JPRB, 0.32296507E-07_JPRB, 0.31277625E-07_JPRB, 0.30021351E-07_JPRB, 0.29037073E-07_JPRB, 0.28766620E-07_JPRB, &
  & 0.29247739E-07_JPRB, 0.30189638E-07_JPRB, 0.31887208E-07_JPRB, 0.34241638E-07_JPRB, 0.38437195E-07_JPRB, 0.42138138E-07_JPRB, &
  & 0.44476861E-07_JPRB, 0.46176427E-07_JPRB, 0.48568602E-07_JPRB, 0.51730767E-07_JPRB, 0.54344867E-07_JPRB, 0.58027254E-07_JPRB, &
  & 0.62568541E-07_JPRB, 0.66721318E-07_JPRB, 0.70065877E-07_JPRB, 0.71564836E-07_JPRB, 0.72602589E-07_JPRB, 0.73690013E-07_JPRB, &
  & 0.75421706E-07_JPRB, 0.77913860E-07_JPRB, 0.80810388E-07_JPRB, 0.82060054E-07_JPRB, 0.83896332E-07_JPRB, 0.85844651E-07_JPRB, &
  & 0.87678000E-07_JPRB, 0.90948979E-07_JPRB, 0.93829080E-07_JPRB, 0.93156888E-07_JPRB, 0.90837787E-07_JPRB, 0.88600992E-07_JPRB, &
  & 0.82181716E-07_JPRB, 0.74134695E-07_JPRB, 0.68717398E-07_JPRB, 0.65531491E-07_JPRB  /)

RGHG7(:,59, 4) = (/ &
  & 0.44321972E-07_JPRB, 0.45735029E-07_JPRB, 0.46672456E-07_JPRB, 0.48069809E-07_JPRB, 0.48472240E-07_JPRB, 0.44528838E-07_JPRB, &
  & 0.37866691E-07_JPRB, 0.34056847E-07_JPRB, 0.32119277E-07_JPRB, 0.33466003E-07_JPRB, 0.34766322E-07_JPRB, 0.35667440E-07_JPRB, &
  & 0.35684796E-07_JPRB, 0.35016525E-07_JPRB, 0.34343193E-07_JPRB, 0.33386110E-07_JPRB, 0.33128893E-07_JPRB, 0.32673515E-07_JPRB, &
  & 0.32792901E-07_JPRB, 0.32890943E-07_JPRB, 0.33604127E-07_JPRB, 0.34153881E-07_JPRB, 0.33982032E-07_JPRB, 0.33660190E-07_JPRB, &
  & 0.33087025E-07_JPRB, 0.32166397E-07_JPRB, 0.31174495E-07_JPRB, 0.29863792E-07_JPRB, 0.28776558E-07_JPRB, 0.28372238E-07_JPRB, &
  & 0.28808105E-07_JPRB, 0.29814485E-07_JPRB, 0.31680593E-07_JPRB, 0.34233271E-07_JPRB, 0.38800598E-07_JPRB, 0.42570752E-07_JPRB, &
  & 0.44811170E-07_JPRB, 0.46469428E-07_JPRB, 0.48627273E-07_JPRB, 0.51227945E-07_JPRB, 0.53516789E-07_JPRB, 0.56753961E-07_JPRB, &
  & 0.60600268E-07_JPRB, 0.63821527E-07_JPRB, 0.66147099E-07_JPRB, 0.66878462E-07_JPRB, 0.67356030E-07_JPRB, 0.67670652E-07_JPRB, &
  & 0.68648547E-07_JPRB, 0.70207331E-07_JPRB, 0.71835209E-07_JPRB, 0.71869548E-07_JPRB, 0.72593912E-07_JPRB, 0.73472960E-07_JPRB, &
  & 0.73891859E-07_JPRB, 0.75491112E-07_JPRB, 0.76868892E-07_JPRB, 0.76332339E-07_JPRB, 0.75161568E-07_JPRB, 0.73689848E-07_JPRB, &
  & 0.69418486E-07_JPRB, 0.64348145E-07_JPRB, 0.60958435E-07_JPRB, 0.58841025E-07_JPRB  /)

RGHG7(:,60, 4) = (/ &
  & 0.34546354E-07_JPRB, 0.35816277E-07_JPRB, 0.36590303E-07_JPRB, 0.37685119E-07_JPRB, 0.38253398E-07_JPRB, 0.35696279E-07_JPRB, &
  & 0.30802892E-07_JPRB, 0.28106802E-07_JPRB, 0.26943702E-07_JPRB, 0.28138010E-07_JPRB, 0.29452950E-07_JPRB, 0.30744447E-07_JPRB, &
  & 0.31372026E-07_JPRB, 0.31455823E-07_JPRB, 0.31385018E-07_JPRB, 0.31099735E-07_JPRB, 0.31265116E-07_JPRB, 0.31173790E-07_JPRB, &
  & 0.31508309E-07_JPRB, 0.31799011E-07_JPRB, 0.32496573E-07_JPRB, 0.33279507E-07_JPRB, 0.33406770E-07_JPRB, 0.33252399E-07_JPRB, &
  & 0.32875895E-07_JPRB, 0.32027465E-07_JPRB, 0.31059197E-07_JPRB, 0.29677061E-07_JPRB, 0.28500592E-07_JPRB, 0.27890583E-07_JPRB, &
  & 0.28246202E-07_JPRB, 0.29349426E-07_JPRB, 0.31384161E-07_JPRB, 0.34143825E-07_JPRB, 0.39094604E-07_JPRB, 0.42988819E-07_JPRB, &
  & 0.45215168E-07_JPRB, 0.46881605E-07_JPRB, 0.48698760E-07_JPRB, 0.50734693E-07_JPRB, 0.52801361E-07_JPRB, 0.55603843E-07_JPRB, &
  & 0.58821122E-07_JPRB, 0.61226915E-07_JPRB, 0.62748640E-07_JPRB, 0.62964896E-07_JPRB, 0.63009508E-07_JPRB, 0.62764402E-07_JPRB, &
  & 0.63155860E-07_JPRB, 0.63963234E-07_JPRB, 0.64588601E-07_JPRB, 0.63812686E-07_JPRB, 0.63841924E-07_JPRB, 0.63992171E-07_JPRB, &
  & 0.63514881E-07_JPRB, 0.63954509E-07_JPRB, 0.64327023E-07_JPRB, 0.63976646E-07_JPRB, 0.63720372E-07_JPRB, 0.62803818E-07_JPRB, &
  & 0.60242927E-07_JPRB, 0.57456387E-07_JPRB, 0.55554105E-07_JPRB, 0.54225839E-07_JPRB  /)

RGHG7(:,61, 4) = (/ &
  & 0.28304922E-07_JPRB, 0.29233822E-07_JPRB, 0.29793887E-07_JPRB, 0.30711984E-07_JPRB, 0.31326999E-07_JPRB, 0.29700209E-07_JPRB, &
  & 0.26142437E-07_JPRB, 0.24218944E-07_JPRB, 0.23557520E-07_JPRB, 0.24662008E-07_JPRB, 0.25906115E-07_JPRB, 0.27339278E-07_JPRB, &
  & 0.28289625E-07_JPRB, 0.28899197E-07_JPRB, 0.29200086E-07_JPRB, 0.29428893E-07_JPRB, 0.29849859E-07_JPRB, 0.30050631E-07_JPRB, &
  & 0.30495417E-07_JPRB, 0.30911720E-07_JPRB, 0.31593947E-07_JPRB, 0.32486418E-07_JPRB, 0.32891173E-07_JPRB, 0.32841957E-07_JPRB, &
  & 0.32610772E-07_JPRB, 0.31846319E-07_JPRB, 0.30882432E-07_JPRB, 0.29422891E-07_JPRB, 0.28182161E-07_JPRB, 0.27298310E-07_JPRB, &
  & 0.27507881E-07_JPRB, 0.28701655E-07_JPRB, 0.30878058E-07_JPRB, 0.33845110E-07_JPRB, 0.39130340E-07_JPRB, 0.43294014E-07_JPRB, &
  & 0.45691971E-07_JPRB, 0.47384697E-07_JPRB, 0.48744720E-07_JPRB, 0.50320600E-07_JPRB, 0.52250712E-07_JPRB, 0.54659593E-07_JPRB, &
  & 0.57343795E-07_JPRB, 0.59138375E-07_JPRB, 0.60215381E-07_JPRB, 0.60179704E-07_JPRB, 0.59970922E-07_JPRB, 0.59475342E-07_JPRB, &
  & 0.59515554E-07_JPRB, 0.59859223E-07_JPRB, 0.59893093E-07_JPRB, 0.58859403E-07_JPRB, 0.58629405E-07_JPRB, 0.58385321E-07_JPRB, &
  & 0.57675083E-07_JPRB, 0.57586745E-07_JPRB, 0.57600710E-07_JPRB, 0.57416828E-07_JPRB, 0.57629370E-07_JPRB, 0.57047268E-07_JPRB, &
  & 0.55478777E-07_JPRB, 0.53895677E-07_JPRB, 0.52864574E-07_JPRB, 0.51939403E-07_JPRB  /)

RGHG7(:,62, 4) = (/ &
  & 0.23748756E-07_JPRB, 0.24376572E-07_JPRB, 0.24742342E-07_JPRB, 0.25515925E-07_JPRB, 0.26155921E-07_JPRB, 0.25165854E-07_JPRB, &
  & 0.22639228E-07_JPRB, 0.21269703E-07_JPRB, 0.20956748E-07_JPRB, 0.22012340E-07_JPRB, 0.23184436E-07_JPRB, 0.24650259E-07_JPRB, &
  & 0.25793652E-07_JPRB, 0.26781425E-07_JPRB, 0.27361527E-07_JPRB, 0.27960264E-07_JPRB, 0.28578472E-07_JPRB, 0.29046599E-07_JPRB, &
  & 0.29578679E-07_JPRB, 0.30091073E-07_JPRB, 0.30740717E-07_JPRB, 0.31707294E-07_JPRB, 0.32323249E-07_JPRB, 0.32374432E-07_JPRB, &
  & 0.32261845E-07_JPRB, 0.31595942E-07_JPRB, 0.30591707E-07_JPRB, 0.29049048E-07_JPRB, 0.27730654E-07_JPRB, 0.26589637E-07_JPRB, &
  & 0.26657691E-07_JPRB, 0.27892465E-07_JPRB, 0.30165318E-07_JPRB, 0.33271772E-07_JPRB, 0.38779403E-07_JPRB, 0.43326007E-07_JPRB, &
  & 0.45926993E-07_JPRB, 0.47594948E-07_JPRB, 0.48697878E-07_JPRB, 0.49989323E-07_JPRB, 0.51723924E-07_JPRB, 0.53759087E-07_JPRB, &
  & 0.55941323E-07_JPRB, 0.57267917E-07_JPRB, 0.58051986E-07_JPRB, 0.57832565E-07_JPRB, 0.57481238E-07_JPRB, 0.56876402E-07_JPRB, &
  & 0.56640120E-07_JPRB, 0.56676666E-07_JPRB, 0.56341822E-07_JPRB, 0.55240534E-07_JPRB, 0.54840880E-07_JPRB, 0.54298008E-07_JPRB, &
  & 0.53577148E-07_JPRB, 0.53222414E-07_JPRB, 0.53092905E-07_JPRB, 0.53065692E-07_JPRB, 0.53563062E-07_JPRB, 0.53278504E-07_JPRB, &
  & 0.52330777E-07_JPRB, 0.51467282E-07_JPRB, 0.51125391E-07_JPRB, 0.50424257E-07_JPRB  /)

RGHG7(:,63, 4) = (/ &
  & 0.20234750E-07_JPRB, 0.20603686E-07_JPRB, 0.20799902E-07_JPRB, 0.21445208E-07_JPRB, 0.22093763E-07_JPRB, 0.21550980E-07_JPRB, &
  & 0.19856490E-07_JPRB, 0.18901652E-07_JPRB, 0.18828698E-07_JPRB, 0.19852366E-07_JPRB, 0.20956638E-07_JPRB, 0.22391443E-07_JPRB, &
  & 0.23648354E-07_JPRB, 0.24907588E-07_JPRB, 0.25705922E-07_JPRB, 0.26586198E-07_JPRB, 0.27366447E-07_JPRB, 0.28078020E-07_JPRB, &
  & 0.28694964E-07_JPRB, 0.29295241E-07_JPRB, 0.29909998E-07_JPRB, 0.30919537E-07_JPRB, 0.31692290E-07_JPRB, 0.31852692E-07_JPRB, &
  & 0.31832109E-07_JPRB, 0.31285383E-07_JPRB, 0.30197794E-07_JPRB, 0.28564300E-07_JPRB, 0.27163895E-07_JPRB, 0.25786471E-07_JPRB, &
  & 0.25679941E-07_JPRB, 0.26929355E-07_JPRB, 0.29283140E-07_JPRB, 0.32476486E-07_JPRB, 0.38168255E-07_JPRB, 0.43133673E-07_JPRB, &
  & 0.45935409E-07_JPRB, 0.47571473E-07_JPRB, 0.48578109E-07_JPRB, 0.49659762E-07_JPRB, 0.51159170E-07_JPRB, 0.52832194E-07_JPRB, &
  & 0.54534148E-07_JPRB, 0.55506299E-07_JPRB, 0.56088406E-07_JPRB, 0.55719843E-07_JPRB, 0.55306199E-07_JPRB, 0.54674174E-07_JPRB, &
  & 0.54216818E-07_JPRB, 0.54042589E-07_JPRB, 0.53461081E-07_JPRB, 0.52395262E-07_JPRB, 0.51882883E-07_JPRB, 0.51104397E-07_JPRB, &
  & 0.50475692E-07_JPRB, 0.50020041E-07_JPRB, 0.49869148E-07_JPRB, 0.50013392E-07_JPRB, 0.50690131E-07_JPRB, 0.50680150E-07_JPRB, &
  & 0.50124650E-07_JPRB, 0.49702259E-07_JPRB, 0.49890732E-07_JPRB, 0.49364723E-07_JPRB  /)

RGHG7(:,64, 4) = (/ &
  & 0.17727379E-07_JPRB, 0.17911821E-07_JPRB, 0.17986639E-07_JPRB, 0.18516138E-07_JPRB, 0.19154310E-07_JPRB, 0.18870297E-07_JPRB, &
  & 0.17791584E-07_JPRB, 0.17112288E-07_JPRB, 0.17156739E-07_JPRB, 0.18150058E-07_JPRB, 0.19200819E-07_JPRB, 0.20558951E-07_JPRB, &
  & 0.21859789E-07_JPRB, 0.23265180E-07_JPRB, 0.24216061E-07_JPRB, 0.25294408E-07_JPRB, 0.26202445E-07_JPRB, 0.27113686E-07_JPRB, &
  & 0.27829665E-07_JPRB, 0.28524185E-07_JPRB, 0.29117379E-07_JPRB, 0.30126918E-07_JPRB, 0.30982733E-07_JPRB, 0.31274916E-07_JPRB, &
  & 0.31303851E-07_JPRB, 0.30908074E-07_JPRB, 0.29679120E-07_JPRB, 0.27944993E-07_JPRB, 0.26468714E-07_JPRB, 0.24898810E-07_JPRB, &
  & 0.24537503E-07_JPRB, 0.25786119E-07_JPRB, 0.28225361E-07_JPRB, 0.31441070E-07_JPRB, 0.37329312E-07_JPRB, 0.42670108E-07_JPRB, &
  & 0.45626785E-07_JPRB, 0.47266843E-07_JPRB, 0.48376508E-07_JPRB, 0.49262486E-07_JPRB, 0.50497533E-07_JPRB, 0.51831121E-07_JPRB, &
  & 0.53093804E-07_JPRB, 0.53861495E-07_JPRB, 0.54320606E-07_JPRB, 0.53825055E-07_JPRB, 0.53437766E-07_JPRB, 0.52839286E-07_JPRB, &
  & 0.52230981E-07_JPRB, 0.51933756E-07_JPRB, 0.51190916E-07_JPRB, 0.50220938E-07_JPRB, 0.49650256E-07_JPRB, 0.48704847E-07_JPRB, &
  & 0.48192749E-07_JPRB, 0.47784219E-07_JPRB, 0.47696421E-07_JPRB, 0.48052313E-07_JPRB, 0.48827290E-07_JPRB, 0.49061702E-07_JPRB, &
  & 0.48694690E-07_JPRB, 0.48498323E-07_JPRB, 0.48987097E-07_JPRB, 0.48691106E-07_JPRB  /)

RGHG7(:,65, 4) = (/ &
  & 0.16022996E-07_JPRB, 0.16095874E-07_JPRB, 0.16110809E-07_JPRB, 0.16531794E-07_JPRB, 0.17122337E-07_JPRB, 0.16974927E-07_JPRB, &
  & 0.16294424E-07_JPRB, 0.15779782E-07_JPRB, 0.15852587E-07_JPRB, 0.16800458E-07_JPRB, 0.17805477E-07_JPRB, 0.19073714E-07_JPRB, &
  & 0.20368266E-07_JPRB, 0.21813886E-07_JPRB, 0.22876848E-07_JPRB, 0.24055911E-07_JPRB, 0.25057772E-07_JPRB, 0.26087692E-07_JPRB, &
  & 0.26927250E-07_JPRB, 0.27728626E-07_JPRB, 0.28356586E-07_JPRB, 0.29296993E-07_JPRB, 0.30229069E-07_JPRB, 0.30632482E-07_JPRB, &
  & 0.30721719E-07_JPRB, 0.30422291E-07_JPRB, 0.29062787E-07_JPRB, 0.27254021E-07_JPRB, 0.25723590E-07_JPRB, 0.24106179E-07_JPRB, &
  & 0.23462134E-07_JPRB, 0.24611822E-07_JPRB, 0.27109670E-07_JPRB, 0.30362780E-07_JPRB, 0.36368711E-07_JPRB, 0.41939075E-07_JPRB, &
  & 0.45069717E-07_JPRB, 0.46875851E-07_JPRB, 0.48113118E-07_JPRB, 0.48723132E-07_JPRB, 0.49628617E-07_JPRB, 0.50651401E-07_JPRB, &
  & 0.51665480E-07_JPRB, 0.52305203E-07_JPRB, 0.52717689E-07_JPRB, 0.52161826E-07_JPRB, 0.51850899E-07_JPRB, 0.51266892E-07_JPRB, &
  & 0.50599406E-07_JPRB, 0.50258530E-07_JPRB, 0.49396242E-07_JPRB, 0.48512428E-07_JPRB, 0.47900096E-07_JPRB, 0.46886844E-07_JPRB, &
  & 0.46455074E-07_JPRB, 0.46160184E-07_JPRB, 0.46219219E-07_JPRB, 0.46803241E-07_JPRB, 0.47689840E-07_JPRB, 0.48063468E-07_JPRB, &
  & 0.47808327E-07_JPRB, 0.47741586E-07_JPRB, 0.48287644E-07_JPRB, 0.48284380E-07_JPRB  /)

RGHG7(:,66, 4) = (/ &
  & 0.14659668E-07_JPRB, 0.14656514E-07_JPRB, 0.14638885E-07_JPRB, 0.14955164E-07_JPRB, 0.15492873E-07_JPRB, 0.15435226E-07_JPRB, &
  & 0.15025769E-07_JPRB, 0.14629810E-07_JPRB, 0.14705577E-07_JPRB, 0.15596734E-07_JPRB, 0.16564936E-07_JPRB, 0.17735776E-07_JPRB, &
  & 0.19008945E-07_JPRB, 0.20435826E-07_JPRB, 0.21582300E-07_JPRB, 0.22819182E-07_JPRB, 0.23901114E-07_JPRB, 0.25004699E-07_JPRB, &
  & 0.25956151E-07_JPRB, 0.26861764E-07_JPRB, 0.27560164E-07_JPRB, 0.28423715E-07_JPRB, 0.29418010E-07_JPRB, 0.29919800E-07_JPRB, &
  & 0.30109478E-07_JPRB, 0.29834741E-07_JPRB, 0.28357857E-07_JPRB, 0.26580987E-07_JPRB, 0.25045729E-07_JPRB, 0.23440165E-07_JPRB, &
  & 0.22561929E-07_JPRB, 0.23610069E-07_JPRB, 0.26140709E-07_JPRB, 0.29431598E-07_JPRB, 0.35395178E-07_JPRB, 0.41026730E-07_JPRB, &
  & 0.44383100E-07_JPRB, 0.46430281E-07_JPRB, 0.47706255E-07_JPRB, 0.48041912E-07_JPRB, 0.48630280E-07_JPRB, 0.49343218E-07_JPRB, &
  & 0.50256246E-07_JPRB, 0.50812040E-07_JPRB, 0.51178558E-07_JPRB, 0.50624316E-07_JPRB, 0.50387062E-07_JPRB, 0.49803472E-07_JPRB, &
  & 0.49110902E-07_JPRB, 0.48754016E-07_JPRB, 0.47799933E-07_JPRB, 0.46987665E-07_JPRB, 0.46348097E-07_JPRB, 0.45308153E-07_JPRB, &
  & 0.44933209E-07_JPRB, 0.44756327E-07_JPRB, 0.45017643E-07_JPRB, 0.45846496E-07_JPRB, 0.46858621E-07_JPRB, 0.47332182E-07_JPRB, &
  & 0.47169464E-07_JPRB, 0.47185247E-07_JPRB, 0.47759490E-07_JPRB, 0.47997392E-07_JPRB  /)

RGHG7(:,67, 4) = (/ &
  & 0.13585587E-07_JPRB, 0.13535999E-07_JPRB, 0.13504949E-07_JPRB, 0.13724782E-07_JPRB, 0.14209897E-07_JPRB, 0.14208771E-07_JPRB, &
  & 0.13954333E-07_JPRB, 0.13638385E-07_JPRB, 0.13703381E-07_JPRB, 0.14528831E-07_JPRB, 0.15462212E-07_JPRB, 0.16533541E-07_JPRB, &
  & 0.17768260E-07_JPRB, 0.19131482E-07_JPRB, 0.20329722E-07_JPRB, 0.21587711E-07_JPRB, 0.22739277E-07_JPRB, 0.23876113E-07_JPRB, &
  & 0.24920125E-07_JPRB, 0.25923144E-07_JPRB, 0.26723327E-07_JPRB, 0.27515720E-07_JPRB, 0.28540668E-07_JPRB, 0.29129063E-07_JPRB, &
  & 0.29440724E-07_JPRB, 0.29130821E-07_JPRB, 0.27586153E-07_JPRB, 0.25931469E-07_JPRB, 0.24434523E-07_JPRB, 0.22880722E-07_JPRB, &
  & 0.21847000E-07_JPRB, 0.22808069E-07_JPRB, 0.25337565E-07_JPRB, 0.28646704E-07_JPRB, 0.34415077E-07_JPRB, 0.39936072E-07_JPRB, &
  & 0.43549083E-07_JPRB, 0.45867119E-07_JPRB, 0.47081378E-07_JPRB, 0.47174878E-07_JPRB, 0.47497955E-07_JPRB, 0.47952848E-07_JPRB, &
  & 0.48896597E-07_JPRB, 0.49415291E-07_JPRB, 0.49726991E-07_JPRB, 0.49220734E-07_JPRB, 0.49038163E-07_JPRB, 0.48444555E-07_JPRB, &
  & 0.47750520E-07_JPRB, 0.47389284E-07_JPRB, 0.46376185E-07_JPRB, 0.45620508E-07_JPRB, 0.44971513E-07_JPRB, 0.43942485E-07_JPRB, &
  & 0.43599388E-07_JPRB, 0.43542033E-07_JPRB, 0.44050987E-07_JPRB, 0.45139772E-07_JPRB, 0.46296504E-07_JPRB, 0.46848183E-07_JPRB, &
  & 0.46752323E-07_JPRB, 0.46817971E-07_JPRB, 0.47412667E-07_JPRB, 0.47820678E-07_JPRB  /)

RGHG7(:,68, 4) = (/ &
  & 0.12748889E-07_JPRB, 0.12674698E-07_JPRB, 0.12637088E-07_JPRB, 0.12777372E-07_JPRB, 0.13214921E-07_JPRB, 0.13254390E-07_JPRB, &
  & 0.13053668E-07_JPRB, 0.12785285E-07_JPRB, 0.12839210E-07_JPRB, 0.13593722E-07_JPRB, 0.14478307E-07_JPRB, 0.15457376E-07_JPRB, &
  & 0.16625667E-07_JPRB, 0.17903189E-07_JPRB, 0.19114551E-07_JPRB, 0.20361879E-07_JPRB, 0.21577412E-07_JPRB, 0.22712608E-07_JPRB, &
  & 0.23822638E-07_JPRB, 0.24911766E-07_JPRB, 0.25839474E-07_JPRB, 0.26582251E-07_JPRB, 0.27571525E-07_JPRB, 0.28237419E-07_JPRB, &
  & 0.28646671E-07_JPRB, 0.28273620E-07_JPRB, 0.26786359E-07_JPRB, 0.25289543E-07_JPRB, 0.23853284E-07_JPRB, 0.22364270E-07_JPRB, &
  & 0.21298155E-07_JPRB, 0.22203047E-07_JPRB, 0.24681287E-07_JPRB, 0.27949832E-07_JPRB, 0.33407389E-07_JPRB, 0.38650784E-07_JPRB, &
  & 0.42501211E-07_JPRB, 0.45040672E-07_JPRB, 0.46094603E-07_JPRB, 0.46023674E-07_JPRB, 0.46197494E-07_JPRB, 0.46556437E-07_JPRB, &
  & 0.47630171E-07_JPRB, 0.48168137E-07_JPRB, 0.48410129E-07_JPRB, 0.47963328E-07_JPRB, 0.47793059E-07_JPRB, 0.47186329E-07_JPRB, &
  & 0.46501725E-07_JPRB, 0.46122447E-07_JPRB, 0.45094587E-07_JPRB, 0.44382374E-07_JPRB, 0.43748551E-07_JPRB, 0.42769959E-07_JPRB, &
  & 0.42429732E-07_JPRB, 0.42501132E-07_JPRB, 0.43287688E-07_JPRB, 0.44650793E-07_JPRB, 0.45983435E-07_JPRB, 0.46618764E-07_JPRB, &
  & 0.46541766E-07_JPRB, 0.46648829E-07_JPRB, 0.47261156E-07_JPRB, 0.47754457E-07_JPRB  /)

RGHG7(:,69, 4) = (/ &
  & 0.12093474E-07_JPRB, 0.12004388E-07_JPRB, 0.11954993E-07_JPRB, 0.12048584E-07_JPRB, 0.12437084E-07_JPRB, 0.12511169E-07_JPRB, &
  & 0.12305188E-07_JPRB, 0.12052266E-07_JPRB, 0.12108558E-07_JPRB, 0.12786174E-07_JPRB, 0.13595848E-07_JPRB, 0.14476702E-07_JPRB, &
  & 0.15583057E-07_JPRB, 0.16764446E-07_JPRB, 0.17965042E-07_JPRB, 0.19172601E-07_JPRB, 0.20426712E-07_JPRB, 0.21540862E-07_JPRB, &
  & 0.22691519E-07_JPRB, 0.23832407E-07_JPRB, 0.24874181E-07_JPRB, 0.25615868E-07_JPRB, 0.26521704E-07_JPRB, 0.27212089E-07_JPRB, &
  & 0.27622629E-07_JPRB, 0.27204356E-07_JPRB, 0.25840920E-07_JPRB, 0.24528067E-07_JPRB, 0.23116656E-07_JPRB, 0.21674504E-07_JPRB, &
  & 0.20587197E-07_JPRB, 0.21422488E-07_JPRB, 0.23822612E-07_JPRB, 0.27063258E-07_JPRB, 0.32226478E-07_JPRB, 0.37148285E-07_JPRB, &
  & 0.41098002E-07_JPRB, 0.43704344E-07_JPRB, 0.44562149E-07_JPRB, 0.44623141E-07_JPRB, 0.44817910E-07_JPRB, 0.45332455E-07_JPRB, &
  & 0.46524207E-07_JPRB, 0.47094130E-07_JPRB, 0.47261203E-07_JPRB, 0.46813390E-07_JPRB, 0.46633028E-07_JPRB, 0.46005715E-07_JPRB, &
  & 0.45352186E-07_JPRB, 0.44902621E-07_JPRB, 0.43896575E-07_JPRB, 0.43256929E-07_JPRB, 0.42643500E-07_JPRB, 0.41753400E-07_JPRB, &
  & 0.41433211E-07_JPRB, 0.41655733E-07_JPRB, 0.42713868E-07_JPRB, 0.44354230E-07_JPRB, 0.45888873E-07_JPRB, 0.46634706E-07_JPRB, &
  & 0.46533276E-07_JPRB, 0.46669057E-07_JPRB, 0.47336333E-07_JPRB, 0.47861914E-07_JPRB  /)

RGHG7(:,70, 4) = (/ &
  & 0.11524982E-07_JPRB, 0.11425265E-07_JPRB, 0.11359734E-07_JPRB, 0.11425985E-07_JPRB, 0.11766143E-07_JPRB, 0.11871703E-07_JPRB, &
  & 0.11641524E-07_JPRB, 0.11390918E-07_JPRB, 0.11445902E-07_JPRB, 0.12051360E-07_JPRB, 0.12774579E-07_JPRB, 0.13556671E-07_JPRB, &
  & 0.14597118E-07_JPRB, 0.15697592E-07_JPRB, 0.16872175E-07_JPRB, 0.18032247E-07_JPRB, 0.19287717E-07_JPRB, 0.20369808E-07_JPRB, &
  & 0.21541750E-07_JPRB, 0.22703469E-07_JPRB, 0.23827471E-07_JPRB, 0.24599781E-07_JPRB, 0.25424685E-07_JPRB, 0.26084098E-07_JPRB, &
  & 0.26453061E-07_JPRB, 0.26013644E-07_JPRB, 0.24779886E-07_JPRB, 0.23667047E-07_JPRB, 0.22203604E-07_JPRB, 0.20779951E-07_JPRB, &
  & 0.19662745E-07_JPRB, 0.20446271E-07_JPRB, 0.22781435E-07_JPRB, 0.26008963E-07_JPRB, 0.30910811E-07_JPRB, 0.35599688E-07_JPRB, &
  & 0.39525886E-07_JPRB, 0.42091053E-07_JPRB, 0.42881055E-07_JPRB, 0.43190940E-07_JPRB, 0.43497847E-07_JPRB, 0.44256047E-07_JPRB, &
  & 0.45520314E-07_JPRB, 0.46122796E-07_JPRB, 0.46230011E-07_JPRB, 0.45745428E-07_JPRB, 0.45532250E-07_JPRB, 0.44870709E-07_JPRB, &
  & 0.44254504E-07_JPRB, 0.43724589E-07_JPRB, 0.42752113E-07_JPRB, 0.42182810E-07_JPRB, 0.41587709E-07_JPRB, 0.40790752E-07_JPRB, &
  & 0.40544043E-07_JPRB, 0.40933068E-07_JPRB, 0.42254394E-07_JPRB, 0.44165949E-07_JPRB, 0.45886274E-07_JPRB, 0.46746914E-07_JPRB, &
  & 0.46650090E-07_JPRB, 0.46784560E-07_JPRB, 0.47544655E-07_JPRB, 0.48092582E-07_JPRB  /)

RGHG7(:,71, 4) = (/ &
  & 0.11032157E-07_JPRB, 0.10920917E-07_JPRB, 0.10834010E-07_JPRB, 0.10887753E-07_JPRB, 0.11183363E-07_JPRB, 0.11316844E-07_JPRB, &
  & 0.11052156E-07_JPRB, 0.10794141E-07_JPRB, 0.10837581E-07_JPRB, 0.11378986E-07_JPRB, 0.12009373E-07_JPRB, 0.12698670E-07_JPRB, &
  & 0.13668455E-07_JPRB, 0.14701367E-07_JPRB, 0.15835457E-07_JPRB, 0.16941700E-07_JPRB, 0.18164870E-07_JPRB, 0.19205456E-07_JPRB, &
  & 0.20380233E-07_JPRB, 0.21534299E-07_JPRB, 0.22707729E-07_JPRB, 0.23519817E-07_JPRB, 0.24276583E-07_JPRB, 0.24841757E-07_JPRB, &
  & 0.25131356E-07_JPRB, 0.24682875E-07_JPRB, 0.23589673E-07_JPRB, 0.22677021E-07_JPRB, 0.21118759E-07_JPRB, 0.19697384E-07_JPRB, &
  & 0.18563881E-07_JPRB, 0.19312097E-07_JPRB, 0.21601510E-07_JPRB, 0.24820377E-07_JPRB, 0.29487910E-07_JPRB, 0.34027164E-07_JPRB, &
  & 0.37832067E-07_JPRB, 0.40271222E-07_JPRB, 0.41132152E-07_JPRB, 0.41756077E-07_JPRB, 0.42255392E-07_JPRB, 0.43301323E-07_JPRB, &
  & 0.44595716E-07_JPRB, 0.45239539E-07_JPRB, 0.45304899E-07_JPRB, 0.44760541E-07_JPRB, 0.44487518E-07_JPRB, 0.43784709E-07_JPRB, &
  & 0.43201732E-07_JPRB, 0.42599803E-07_JPRB, 0.41660973E-07_JPRB, 0.41144777E-07_JPRB, 0.40568794E-07_JPRB, 0.39879548E-07_JPRB, &
  & 0.39754907E-07_JPRB, 0.40317464E-07_JPRB, 0.41888487E-07_JPRB, 0.44058568E-07_JPRB, 0.45924960E-07_JPRB, 0.46897922E-07_JPRB, &
  & 0.46855069E-07_JPRB, 0.46965085E-07_JPRB, 0.47831909E-07_JPRB, 0.48384261E-07_JPRB  /)

RGHG7(:,72, 4) = (/ &
  & 0.10613147E-07_JPRB, 0.10480564E-07_JPRB, 0.10364925E-07_JPRB, 0.10415384E-07_JPRB, 0.10675695E-07_JPRB, 0.10832162E-07_JPRB, &
  & 0.10530533E-07_JPRB, 0.10257741E-07_JPRB, 0.10269986E-07_JPRB, 0.10759674E-07_JPRB, 0.11297297E-07_JPRB, 0.11911070E-07_JPRB, &
  & 0.12805331E-07_JPRB, 0.13775033E-07_JPRB, 0.14853300E-07_JPRB, 0.15897154E-07_JPRB, 0.17062860E-07_JPRB, 0.18053370E-07_JPRB, &
  & 0.19212550E-07_JPRB, 0.20333779E-07_JPRB, 0.21525270E-07_JPRB, 0.22346388E-07_JPRB, 0.23057182E-07_JPRB, 0.23448323E-07_JPRB, &
  & 0.23618068E-07_JPRB, 0.23148244E-07_JPRB, 0.22229896E-07_JPRB, 0.21489636E-07_JPRB, 0.19867342E-07_JPRB, 0.18457460E-07_JPRB, &
  & 0.17369108E-07_JPRB, 0.18089413E-07_JPRB, 0.20355840E-07_JPRB, 0.23550080E-07_JPRB, 0.27995145E-07_JPRB, 0.32430964E-07_JPRB, &
  & 0.36059370E-07_JPRB, 0.38320387E-07_JPRB, 0.39379978E-07_JPRB, 0.40323239E-07_JPRB, 0.41093456E-07_JPRB, 0.42422601E-07_JPRB, &
  & 0.43716994E-07_JPRB, 0.44429775E-07_JPRB, 0.44472970E-07_JPRB, 0.43864580E-07_JPRB, 0.43495510E-07_JPRB, 0.42758223E-07_JPRB, &
  & 0.42187559E-07_JPRB, 0.41548689E-07_JPRB, 0.40626278E-07_JPRB, 0.40123216E-07_JPRB, 0.39574324E-07_JPRB, 0.39034484E-07_JPRB, &
  & 0.39064996E-07_JPRB, 0.39794199E-07_JPRB, 0.41592614E-07_JPRB, 0.43998299E-07_JPRB, 0.45934468E-07_JPRB, 0.47009223E-07_JPRB, &
  & 0.47095254E-07_JPRB, 0.47174075E-07_JPRB, 0.48115602E-07_JPRB, 0.48629371E-07_JPRB  /)

RGHG7(:,73, 4) = (/ &
  & 0.10267238E-07_JPRB, 0.10100997E-07_JPRB, 0.99534114E-08_JPRB, 0.99967583E-08_JPRB, 0.10226898E-07_JPRB, 0.10400389E-07_JPRB, &
  & 0.10073032E-07_JPRB, 0.97731876E-08_JPRB, 0.97304381E-08_JPRB, 0.10184870E-07_JPRB, 0.10661191E-07_JPRB, 0.11211192E-07_JPRB, &
  & 0.12018824E-07_JPRB, 0.12912758E-07_JPRB, 0.13924212E-07_JPRB, 0.14890075E-07_JPRB, 0.15973603E-07_JPRB, 0.16922127E-07_JPRB, &
  & 0.18032095E-07_JPRB, 0.19119535E-07_JPRB, 0.20304810E-07_JPRB, 0.21068724E-07_JPRB, 0.21707374E-07_JPRB, 0.21943281E-07_JPRB, &
  & 0.21953619E-07_JPRB, 0.21476041E-07_JPRB, 0.20658896E-07_JPRB, 0.20076029E-07_JPRB, 0.18505143E-07_JPRB, 0.17138059E-07_JPRB, &
  & 0.16165215E-07_JPRB, 0.16900876E-07_JPRB, 0.19122851E-07_JPRB, 0.22242034E-07_JPRB, 0.26541816E-07_JPRB, 0.30773027E-07_JPRB, &
  & 0.34272674E-07_JPRB, 0.36308803E-07_JPRB, 0.37518685E-07_JPRB, 0.38767135E-07_JPRB, 0.39942400E-07_JPRB, 0.41540405E-07_JPRB, &
  & 0.42886608E-07_JPRB, 0.43663413E-07_JPRB, 0.43727743E-07_JPRB, 0.43061046E-07_JPRB, 0.42581657E-07_JPRB, 0.41838644E-07_JPRB, &
  & 0.41195031E-07_JPRB, 0.40534244E-07_JPRB, 0.39643584E-07_JPRB, 0.39116400E-07_JPRB, 0.38599326E-07_JPRB, 0.38250903E-07_JPRB, &
  & 0.38459565E-07_JPRB, 0.39282475E-07_JPRB, 0.41278366E-07_JPRB, 0.43876830E-07_JPRB, 0.45809276E-07_JPRB, 0.46987178E-07_JPRB, &
  & 0.47189889E-07_JPRB, 0.47278477E-07_JPRB, 0.48127520E-07_JPRB, 0.48532386E-07_JPRB  /)

RGHG7(:,74, 4) = (/ &
  & 0.99570930E-08_JPRB, 0.97522274E-08_JPRB, 0.95774168E-08_JPRB, 0.96093713E-08_JPRB, 0.98122829E-08_JPRB, 0.99948414E-08_JPRB, &
  & 0.96546265E-08_JPRB, 0.93272207E-08_JPRB, 0.92260457E-08_JPRB, 0.96565588E-08_JPRB, 0.10087180E-07_JPRB, 0.10584876E-07_JPRB, &
  & 0.11307020E-07_JPRB, 0.12110827E-07_JPRB, 0.13050650E-07_JPRB, 0.13936799E-07_JPRB, 0.14924755E-07_JPRB, 0.15809217E-07_JPRB, &
  & 0.16841916E-07_JPRB, 0.17902463E-07_JPRB, 0.19049247E-07_JPRB, 0.19761848E-07_JPRB, 0.20362914E-07_JPRB, 0.20498376E-07_JPRB, &
  & 0.20362509E-07_JPRB, 0.19872877E-07_JPRB, 0.19131792E-07_JPRB, 0.18642427E-07_JPRB, 0.17183168E-07_JPRB, 0.15882785E-07_JPRB, &
  & 0.15057022E-07_JPRB, 0.15804722E-07_JPRB, 0.17953222E-07_JPRB, 0.20991699E-07_JPRB, 0.25195481E-07_JPRB, 0.29183553E-07_JPRB, &
  & 0.32558595E-07_JPRB, 0.34406299E-07_JPRB, 0.35676977E-07_JPRB, 0.37257850E-07_JPRB, 0.38849013E-07_JPRB, 0.40663818E-07_JPRB, &
  & 0.42102817E-07_JPRB, 0.42935726E-07_JPRB, 0.43045632E-07_JPRB, 0.42315222E-07_JPRB, 0.41750705E-07_JPRB, 0.40982084E-07_JPRB, &
  & 0.40212326E-07_JPRB, 0.39524960E-07_JPRB, 0.38682676E-07_JPRB, 0.38145610E-07_JPRB, 0.37656257E-07_JPRB, 0.37483247E-07_JPRB, &
  & 0.37853460E-07_JPRB, 0.38742029E-07_JPRB, 0.40897966E-07_JPRB, 0.43621452E-07_JPRB, 0.45546474E-07_JPRB, 0.46781424E-07_JPRB, &
  & 0.47062483E-07_JPRB, 0.47197487E-07_JPRB, 0.47847877E-07_JPRB, 0.48074590E-07_JPRB  /)

RGHG7(:,75, 4) = (/ &
  & 0.96723384E-08_JPRB, 0.94290509E-08_JPRB, 0.92331013E-08_JPRB, 0.92487917E-08_JPRB, 0.94275544E-08_JPRB, 0.96103635E-08_JPRB, &
  & 0.92693023E-08_JPRB, 0.89174655E-08_JPRB, 0.87597627E-08_JPRB, 0.91702652E-08_JPRB, 0.95745354E-08_JPRB, 0.10031740E-07_JPRB, &
  & 0.10673576E-07_JPRB, 0.11382715E-07_JPRB, 0.12245968E-07_JPRB, 0.13038648E-07_JPRB, 0.13924639E-07_JPRB, 0.14734640E-07_JPRB, &
  & 0.15668063E-07_JPRB, 0.16694114E-07_JPRB, 0.17773827E-07_JPRB, 0.18459176E-07_JPRB, 0.19058895E-07_JPRB, 0.19146616E-07_JPRB, &
  & 0.18905329E-07_JPRB, 0.18398696E-07_JPRB, 0.17708479E-07_JPRB, 0.17256642E-07_JPRB, 0.15957460E-07_JPRB, 0.14734548E-07_JPRB, &
  & 0.14063468E-07_JPRB, 0.14804482E-07_JPRB, 0.16862084E-07_JPRB, 0.19820221E-07_JPRB, 0.23963337E-07_JPRB, 0.27720016E-07_JPRB, &
  & 0.30970332E-07_JPRB, 0.32696281E-07_JPRB, 0.33977894E-07_JPRB, 0.35858216E-07_JPRB, 0.37801884E-07_JPRB, 0.39797575E-07_JPRB, &
  & 0.41347075E-07_JPRB, 0.42239647E-07_JPRB, 0.42419947E-07_JPRB, 0.41623870E-07_JPRB, 0.40990958E-07_JPRB, 0.40164281E-07_JPRB, &
  & 0.39243836E-07_JPRB, 0.38538522E-07_JPRB, 0.37751487E-07_JPRB, 0.37219023E-07_JPRB, 0.36744358E-07_JPRB, 0.36709156E-07_JPRB, &
  & 0.37214918E-07_JPRB, 0.38155650E-07_JPRB, 0.40429791E-07_JPRB, 0.43216937E-07_JPRB, 0.45146882E-07_JPRB, 0.46380435E-07_JPRB, &
  & 0.46712488E-07_JPRB, 0.46926939E-07_JPRB, 0.47330816E-07_JPRB, 0.47283916E-07_JPRB  /)

RGHG7(:,76, 4) = (/ &
  & 0.94017803E-08_JPRB, 0.91272906E-08_JPRB, 0.89173822E-08_JPRB, 0.89109027E-08_JPRB, 0.90691377E-08_JPRB, 0.92420936E-08_JPRB, &
  & 0.89108856E-08_JPRB, 0.85418056E-08_JPRB, 0.83348364E-08_JPRB, 0.87182422E-08_JPRB, 0.91241547E-08_JPRB, 0.95534421E-08_JPRB, &
  & 0.10124662E-07_JPRB, 0.10750049E-07_JPRB, 0.11530370E-07_JPRB, 0.12194136E-07_JPRB, 0.12980773E-07_JPRB, 0.13728370E-07_JPRB, &
  & 0.14548479E-07_JPRB, 0.15508021E-07_JPRB, 0.16498234E-07_JPRB, 0.17199183E-07_JPRB, 0.17828462E-07_JPRB, 0.17913719E-07_JPRB, &
  & 0.17644515E-07_JPRB, 0.17117355E-07_JPRB, 0.16445202E-07_JPRB, 0.15993365E-07_JPRB, 0.14893712E-07_JPRB, 0.13739773E-07_JPRB, &
  & 0.13199249E-07_JPRB, 0.13896744E-07_JPRB, 0.15864846E-07_JPRB, 0.18745799E-07_JPRB, 0.22846217E-07_JPRB, 0.26453454E-07_JPRB, &
  & 0.29578141E-07_JPRB, 0.31286026E-07_JPRB, 0.32596377E-07_JPRB, 0.34641742E-07_JPRB, 0.36774264E-07_JPRB, 0.38945673E-07_JPRB, &
  & 0.40588779E-07_JPRB, 0.41563461E-07_JPRB, 0.41843115E-07_JPRB, 0.40986277E-07_JPRB, 0.40282750E-07_JPRB, 0.39351791E-07_JPRB, &
  & 0.38295864E-07_JPRB, 0.37605330E-07_JPRB, 0.36865099E-07_JPRB, 0.36344951E-07_JPRB, 0.35858791E-07_JPRB, 0.35897487E-07_JPRB, &
  & 0.36503425E-07_JPRB, 0.37499171E-07_JPRB, 0.39843107E-07_JPRB, 0.42645032E-07_JPRB, 0.44607822E-07_JPRB, 0.45767475E-07_JPRB, &
  & 0.46143868E-07_JPRB, 0.46466705E-07_JPRB, 0.46657915E-07_JPRB, 0.46197177E-07_JPRB  /)

RGHG7(:,77, 4) = (/ &
  & 0.91401025E-08_JPRB, 0.88442336E-08_JPRB, 0.86264860E-08_JPRB, 0.85959406E-08_JPRB, 0.87380941E-08_JPRB, 0.88892083E-08_JPRB, &
  & 0.85877405E-08_JPRB, 0.82035407E-08_JPRB, 0.79592397E-08_JPRB, 0.83191116E-08_JPRB, 0.87211608E-08_JPRB, 0.91173931E-08_JPRB, &
  & 0.96138312E-08_JPRB, 0.10168487E-07_JPRB, 0.10852845E-07_JPRB, 0.11432458E-07_JPRB, 0.12157027E-07_JPRB, 0.12829481E-07_JPRB, &
  & 0.13577313E-07_JPRB, 0.14454389E-07_JPRB, 0.15391736E-07_JPRB, 0.16121147E-07_JPRB, 0.16763031E-07_JPRB, 0.16950050E-07_JPRB, &
  & 0.16730725E-07_JPRB, 0.16194592E-07_JPRB, 0.15510747E-07_JPRB, 0.14974396E-07_JPRB, 0.13984707E-07_JPRB, 0.12974971E-07_JPRB, &
  & 0.12511576E-07_JPRB, 0.13105693E-07_JPRB, 0.14990915E-07_JPRB, 0.17811750E-07_JPRB, 0.21868071E-07_JPRB, 0.25458009E-07_JPRB, &
  & 0.28460802E-07_JPRB, 0.30227771E-07_JPRB, 0.31654944E-07_JPRB, 0.33765816E-07_JPRB, 0.35895585E-07_JPRB, 0.38130689E-07_JPRB, &
  & 0.39890852E-07_JPRB, 0.40980412E-07_JPRB, 0.41330823E-07_JPRB, 0.40426573E-07_JPRB, 0.39617459E-07_JPRB, 0.38585471E-07_JPRB, &
  & 0.37444259E-07_JPRB, 0.36748179E-07_JPRB, 0.36013556E-07_JPRB, 0.35494843E-07_JPRB, 0.35040465E-07_JPRB, 0.35069602E-07_JPRB, &
  & 0.35706848E-07_JPRB, 0.36670719E-07_JPRB, 0.39071227E-07_JPRB, 0.41916578E-07_JPRB, 0.43861341E-07_JPRB, 0.44908127E-07_JPRB, &
  & 0.45338181E-07_JPRB, 0.45778059E-07_JPRB, 0.45855459E-07_JPRB, 0.45042115E-07_JPRB  /)

RGHG7(:,78, 4) = (/ &
  & 0.88910657E-08_JPRB, 0.85749662E-08_JPRB, 0.83502740E-08_JPRB, 0.82998783E-08_JPRB, 0.84326007E-08_JPRB, 0.85554775E-08_JPRB, &
  & 0.82947815E-08_JPRB, 0.78982791E-08_JPRB, 0.76364795E-08_JPRB, 0.79667549E-08_JPRB, 0.83498449E-08_JPRB, 0.87181504E-08_JPRB, &
  & 0.91536043E-08_JPRB, 0.96469694E-08_JPRB, 0.10255100E-07_JPRB, 0.10780836E-07_JPRB, 0.11445617E-07_JPRB, 0.12069477E-07_JPRB, &
  & 0.12766067E-07_JPRB, 0.13601354E-07_JPRB, 0.14520836E-07_JPRB, 0.15281426E-07_JPRB, 0.15930704E-07_JPRB, 0.16183593E-07_JPRB, &
  & 0.16006608E-07_JPRB, 0.15479094E-07_JPRB, 0.14798357E-07_JPRB, 0.14190607E-07_JPRB, 0.13260594E-07_JPRB, 0.12394964E-07_JPRB, &
  & 0.11956820E-07_JPRB, 0.12426139E-07_JPRB, 0.14217519E-07_JPRB, 0.17019060E-07_JPRB, 0.21036130E-07_JPRB, 0.24635671E-07_JPRB, &
  & 0.27502422E-07_JPRB, 0.29365816E-07_JPRB, 0.30918455E-07_JPRB, 0.33039404E-07_JPRB, 0.35159059E-07_JPRB, 0.37440882E-07_JPRB, &
  & 0.39282999E-07_JPRB, 0.40468715E-07_JPRB, 0.40877471E-07_JPRB, 0.39933066E-07_JPRB, 0.39014189E-07_JPRB, 0.37889658E-07_JPRB, &
  & 0.36688449E-07_JPRB, 0.35971448E-07_JPRB, 0.35217407E-07_JPRB, 0.34684717E-07_JPRB, 0.34255394E-07_JPRB, 0.34240271E-07_JPRB, &
  & 0.34865256E-07_JPRB, 0.35770381E-07_JPRB, 0.38178929E-07_JPRB, 0.41115128E-07_JPRB, 0.42957691E-07_JPRB, 0.43918442E-07_JPRB, &
  & 0.44404586E-07_JPRB, 0.44922414E-07_JPRB, 0.44983353E-07_JPRB, 0.43961693E-07_JPRB  /)

RGHG7(:,79, 4) = (/ &
  & 0.86530528E-08_JPRB, 0.83197654E-08_JPRB, 0.80876761E-08_JPRB, 0.80233600E-08_JPRB, 0.81516178E-08_JPRB, 0.82439010E-08_JPRB, &
  & 0.80291913E-08_JPRB, 0.76266923E-08_JPRB, 0.73640788E-08_JPRB, 0.76610554E-08_JPRB, 0.80158378E-08_JPRB, 0.83617367E-08_JPRB, &
  & 0.87522336E-08_JPRB, 0.91933884E-08_JPRB, 0.97392061E-08_JPRB, 0.10234061E-07_JPRB, 0.10848595E-07_JPRB, 0.11456536E-07_JPRB, &
  & 0.12135040E-07_JPRB, 0.12957425E-07_JPRB, 0.13871676E-07_JPRB, 0.14647886E-07_JPRB, 0.15296853E-07_JPRB, 0.15583962E-07_JPRB, &
  & 0.15436433E-07_JPRB, 0.14929195E-07_JPRB, 0.14259530E-07_JPRB, 0.13602514E-07_JPRB, 0.12715579E-07_JPRB, 0.11976429E-07_JPRB, &
  & 0.11523695E-07_JPRB, 0.11865768E-07_JPRB, 0.13560902E-07_JPRB, 0.16376279E-07_JPRB, 0.20367544E-07_JPRB, 0.23964822E-07_JPRB, &
  & 0.26680496E-07_JPRB, 0.28642361E-07_JPRB, 0.30325610E-07_JPRB, 0.32422333E-07_JPRB, 0.34548212E-07_JPRB, 0.36869978E-07_JPRB, &
  & 0.38763730E-07_JPRB, 0.40022100E-07_JPRB, 0.40466297E-07_JPRB, 0.39483183E-07_JPRB, 0.38471017E-07_JPRB, 0.37267369E-07_JPRB, &
  & 0.36020928E-07_JPRB, 0.35267121E-07_JPRB, 0.34475867E-07_JPRB, 0.33911134E-07_JPRB, 0.33495313E-07_JPRB, 0.33406172E-07_JPRB, &
  & 0.33983303E-07_JPRB, 0.34822405E-07_JPRB, 0.37135066E-07_JPRB, 0.40179552E-07_JPRB, 0.41869278E-07_JPRB, 0.42801207E-07_JPRB, &
  & 0.43358030E-07_JPRB, 0.43917236E-07_JPRB, 0.44033174E-07_JPRB, 0.42870336E-07_JPRB  /)

RGHG7(:,80, 4) = (/ &
  & 0.84244818E-08_JPRB, 0.80794486E-08_JPRB, 0.78384696E-08_JPRB, 0.77675442E-08_JPRB, 0.78940797E-08_JPRB, 0.79576504E-08_JPRB, &
  & 0.77881178E-08_JPRB, 0.73893822E-08_JPRB, 0.71380816E-08_JPRB, 0.74014079E-08_JPRB, 0.77258574E-08_JPRB, 0.80544178E-08_JPRB, &
  & 0.84169337E-08_JPRB, 0.88143079E-08_JPRB, 0.93025276E-08_JPRB, 0.97816392E-08_JPRB, 0.10365820E-07_JPRB, 0.10994310E-07_JPRB, &
  & 0.11702502E-07_JPRB, 0.12522991E-07_JPRB, 0.13419417E-07_JPRB, 0.14176008E-07_JPRB, 0.14813774E-07_JPRB, 0.15118298E-07_JPRB, &
  & 0.14987275E-07_JPRB, 0.14504802E-07_JPRB, 0.13843454E-07_JPRB, 0.13162276E-07_JPRB, 0.12337556E-07_JPRB, 0.11692620E-07_JPRB, &
  & 0.11199539E-07_JPRB, 0.11430923E-07_JPRB, 0.13038524E-07_JPRB, 0.15889588E-07_JPRB, 0.19877499E-07_JPRB, 0.23424598E-07_JPRB, &
  & 0.25975488E-07_JPRB, 0.28001629E-07_JPRB, 0.29821917E-07_JPRB, 0.31880685E-07_JPRB, 0.34043022E-07_JPRB, 0.36402979E-07_JPRB, &
  & 0.38328172E-07_JPRB, 0.39634010E-07_JPRB, 0.40078400E-07_JPRB, 0.39051969E-07_JPRB, 0.37984162E-07_JPRB, 0.36719787E-07_JPRB, &
  & 0.35432126E-07_JPRB, 0.34625121E-07_JPRB, 0.33786593E-07_JPRB, 0.33168553E-07_JPRB, 0.32753654E-07_JPRB, 0.32564407E-07_JPRB, &
  & 0.33066731E-07_JPRB, 0.33851717E-07_JPRB, 0.35908344E-07_JPRB, 0.39044835E-07_JPRB, 0.40573725E-07_JPRB, 0.41561837E-07_JPRB, &
  & 0.42217155E-07_JPRB, 0.42786507E-07_JPRB, 0.42997847E-07_JPRB, 0.41665617E-07_JPRB  /)

RGHG7(:,81, 4) = (/ &
  & 0.81821162E-08_JPRB, 0.78497483E-08_JPRB, 0.75906158E-08_JPRB, 0.75184239E-08_JPRB, 0.76504477E-08_JPRB, 0.76916432E-08_JPRB, &
  & 0.75525070E-08_JPRB, 0.71850123E-08_JPRB, 0.69569312E-08_JPRB, 0.71953493E-08_JPRB, 0.74944684E-08_JPRB, 0.78188071E-08_JPRB, &
  & 0.81669690E-08_JPRB, 0.85554776E-08_JPRB, 0.90133008E-08_JPRB, 0.94932568E-08_JPRB, 0.10053796E-07_JPRB, 0.10694951E-07_JPRB, &
  & 0.11413275E-07_JPRB, 0.12253606E-07_JPRB, 0.13117525E-07_JPRB, 0.13853007E-07_JPRB, 0.14458266E-07_JPRB, 0.14760679E-07_JPRB, &
  & 0.14634300E-07_JPRB, 0.14158160E-07_JPRB, 0.13493856E-07_JPRB, 0.12824922E-07_JPRB, 0.12059728E-07_JPRB, 0.11498805E-07_JPRB, &
  & 0.10986726E-07_JPRB, 0.11126921E-07_JPRB, 0.12645865E-07_JPRB, 0.15558988E-07_JPRB, 0.19550277E-07_JPRB, 0.23001121E-07_JPRB, &
  & 0.25345989E-07_JPRB, 0.27329491E-07_JPRB, 0.29253212E-07_JPRB, 0.31369395E-07_JPRB, 0.33598436E-07_JPRB, 0.36018763E-07_JPRB, &
  & 0.37946067E-07_JPRB, 0.39298344E-07_JPRB, 0.39726692E-07_JPRB, 0.38652977E-07_JPRB, 0.37529865E-07_JPRB, 0.36219895E-07_JPRB, &
  & 0.34917036E-07_JPRB, 0.34058104E-07_JPRB, 0.33157094E-07_JPRB, 0.32564807E-07_JPRB, 0.32073494E-07_JPRB, 0.31739442E-07_JPRB, &
  & 0.32127780E-07_JPRB, 0.32799622E-07_JPRB, 0.34457718E-07_JPRB, 0.37518218E-07_JPRB, 0.38788315E-07_JPRB, 0.39924188E-07_JPRB, &
  & 0.40720512E-07_JPRB, 0.41409762E-07_JPRB, 0.41743954E-07_JPRB, 0.40381750E-07_JPRB  /)

RGHG7(:,82, 4) = (/ &
  & 0.79372388E-08_JPRB, 0.76354886E-08_JPRB, 0.73458115E-08_JPRB, 0.72761425E-08_JPRB, 0.74150737E-08_JPRB, 0.74352004E-08_JPRB, &
  & 0.73233580E-08_JPRB, 0.69909767E-08_JPRB, 0.67912024E-08_JPRB, 0.70278494E-08_JPRB, 0.73084896E-08_JPRB, 0.76309604E-08_JPRB, &
  & 0.79674779E-08_JPRB, 0.83433962E-08_JPRB, 0.87846875E-08_JPRB, 0.92660642E-08_JPRB, 0.98185282E-08_JPRB, 0.10462088E-07_JPRB, &
  & 0.11188153E-07_JPRB, 0.12048490E-07_JPRB, 0.12887962E-07_JPRB, 0.13598398E-07_JPRB, 0.14167867E-07_JPRB, 0.14461202E-07_JPRB, &
  & 0.14334783E-07_JPRB, 0.13855628E-07_JPRB, 0.13198568E-07_JPRB, 0.12542380E-07_JPRB, 0.11840986E-07_JPRB, 0.11356849E-07_JPRB, &
  & 0.10840437E-07_JPRB, 0.10914748E-07_JPRB, 0.12367708E-07_JPRB, 0.15346565E-07_JPRB, 0.19315033E-07_JPRB, 0.22636496E-07_JPRB, &
  & 0.24752227E-07_JPRB, 0.26646242E-07_JPRB, 0.28618343E-07_JPRB, 0.30859346E-07_JPRB, 0.33202075E-07_JPRB, 0.35702457E-07_JPRB, &
  & 0.37625750E-07_JPRB, 0.38990721E-07_JPRB, 0.39398766E-07_JPRB, 0.38298721E-07_JPRB, 0.37110768E-07_JPRB, 0.35748223E-07_JPRB, &
  & 0.34439570E-07_JPRB, 0.33529333E-07_JPRB, 0.32591254E-07_JPRB, 0.32003323E-07_JPRB, 0.31448301E-07_JPRB, 0.30974148E-07_JPRB, &
  & 0.31248064E-07_JPRB, 0.31721392E-07_JPRB, 0.33005897E-07_JPRB, 0.35614224E-07_JPRB, 0.36828459E-07_JPRB, 0.38105913E-07_JPRB, &
  & 0.39119712E-07_JPRB, 0.39873702E-07_JPRB, 0.40419839E-07_JPRB, 0.39090677E-07_JPRB  /)

RGHG7(:,83, 4) = (/ &
  & 0.76870218E-08_JPRB, 0.74348193E-08_JPRB, 0.71030853E-08_JPRB, 0.70424097E-08_JPRB, 0.71873782E-08_JPRB, 0.71834166E-08_JPRB, &
  & 0.70962361E-08_JPRB, 0.68069048E-08_JPRB, 0.66465191E-08_JPRB, 0.68935801E-08_JPRB, 0.71617300E-08_JPRB, 0.74786961E-08_JPRB, &
  & 0.78073925E-08_JPRB, 0.81717462E-08_JPRB, 0.86037662E-08_JPRB, 0.90909961E-08_JPRB, 0.96409232E-08_JPRB, 0.10283047E-07_JPRB, &
  & 0.11016090E-07_JPRB, 0.11890754E-07_JPRB, 0.12715712E-07_JPRB, 0.13411611E-07_JPRB, 0.13949537E-07_JPRB, 0.14234354E-07_JPRB, &
  & 0.14106017E-07_JPRB, 0.13621240E-07_JPRB, 0.12985011E-07_JPRB, 0.12351064E-07_JPRB, 0.11720455E-07_JPRB, 0.11304855E-07_JPRB, &
  & 0.10800030E-07_JPRB, 0.10813726E-07_JPRB, 0.12227059E-07_JPRB, 0.15277721E-07_JPRB, 0.19190972E-07_JPRB, 0.22354197E-07_JPRB, &
  & 0.24258099E-07_JPRB, 0.26037398E-07_JPRB, 0.27989638E-07_JPRB, 0.30354000E-07_JPRB, 0.32842499E-07_JPRB, 0.35434933E-07_JPRB, &
  & 0.37336585E-07_JPRB, 0.38686425E-07_JPRB, 0.39065012E-07_JPRB, 0.37949201E-07_JPRB, 0.36699865E-07_JPRB, 0.35291665E-07_JPRB, &
  & 0.33980703E-07_JPRB, 0.33026002E-07_JPRB, 0.32061812E-07_JPRB, 0.31459060E-07_JPRB, 0.30860559E-07_JPRB, 0.30262835E-07_JPRB, &
  & 0.30458225E-07_JPRB, 0.30689537E-07_JPRB, 0.31639182E-07_JPRB, 0.33514404E-07_JPRB, 0.34800009E-07_JPRB, 0.36149178E-07_JPRB, &
  & 0.37380330E-07_JPRB, 0.38105867E-07_JPRB, 0.38786536E-07_JPRB, 0.37584235E-07_JPRB  /)

RGHG7(:,84, 4) = (/ &
  & 0.74296462E-08_JPRB, 0.72443200E-08_JPRB, 0.68620234E-08_JPRB, 0.68184340E-08_JPRB, 0.69666856E-08_JPRB, 0.69333063E-08_JPRB, &
  & 0.68696923E-08_JPRB, 0.66333993E-08_JPRB, 0.65255466E-08_JPRB, 0.67864424E-08_JPRB, 0.70470058E-08_JPRB, 0.73517707E-08_JPRB, &
  & 0.76763958E-08_JPRB, 0.80336239E-08_JPRB, 0.84587471E-08_JPRB, 0.89578191E-08_JPRB, 0.95031346E-08_JPRB, 0.10144722E-07_JPRB, &
  & 0.10885119E-07_JPRB, 0.11764350E-07_JPRB, 0.12584569E-07_JPRB, 0.13284826E-07_JPRB, 0.13800278E-07_JPRB, 0.14081641E-07_JPRB, &
  & 0.13951816E-07_JPRB, 0.13464446E-07_JPRB, 0.12861948E-07_JPRB, 0.12263600E-07_JPRB, 0.11708096E-07_JPRB, 0.11350019E-07_JPRB, &
  & 0.10869704E-07_JPRB, 0.10815815E-07_JPRB, 0.12214090E-07_JPRB, 0.15340798E-07_JPRB, 0.19169186E-07_JPRB, 0.22159318E-07_JPRB, &
  & 0.23903743E-07_JPRB, 0.25567277E-07_JPRB, 0.27429157E-07_JPRB, 0.29860256E-07_JPRB, 0.32506386E-07_JPRB, 0.35193696E-07_JPRB, &
  & 0.37051092E-07_JPRB, 0.38364452E-07_JPRB, 0.38701280E-07_JPRB, 0.37573288E-07_JPRB, 0.36275185E-07_JPRB, 0.34835758E-07_JPRB, &
  & 0.33523754E-07_JPRB, 0.32535837E-07_JPRB, 0.31547060E-07_JPRB, 0.30915218E-07_JPRB, 0.30295760E-07_JPRB, 0.29601554E-07_JPRB, &
  & 0.29777499E-07_JPRB, 0.29763648E-07_JPRB, 0.30430700E-07_JPRB, 0.31424047E-07_JPRB, 0.32805301E-07_JPRB, 0.34107204E-07_JPRB, &
  & 0.35485878E-07_JPRB, 0.36063583E-07_JPRB, 0.36668275E-07_JPRB, 0.35726963E-07_JPRB  /)

RGHG7(:,85, 4) = (/ &
  & 0.71310063E-08_JPRB, 0.70222830E-08_JPRB, 0.65982804E-08_JPRB, 0.65832043E-08_JPRB, 0.67284769E-08_JPRB, 0.66661587E-08_JPRB, &
  & 0.66429740E-08_JPRB, 0.64705167E-08_JPRB, 0.64116048E-08_JPRB, 0.66916513E-08_JPRB, 0.69475334E-08_JPRB, 0.72476170E-08_JPRB, &
  & 0.75620284E-08_JPRB, 0.79158519E-08_JPRB, 0.83414007E-08_JPRB, 0.88455796E-08_JPRB, 0.93845115E-08_JPRB, 0.10023545E-07_JPRB, &
  & 0.10771177E-07_JPRB, 0.11643173E-07_JPRB, 0.12454881E-07_JPRB, 0.13157265E-07_JPRB, 0.13650589E-07_JPRB, 0.13919184E-07_JPRB, &
  & 0.13790210E-07_JPRB, 0.13310926E-07_JPRB, 0.12725876E-07_JPRB, 0.12150509E-07_JPRB, 0.11622667E-07_JPRB, 0.11281188E-07_JPRB, &
  & 0.10799170E-07_JPRB, 0.10701873E-07_JPRB, 0.12066954E-07_JPRB, 0.15237070E-07_JPRB, 0.19016092E-07_JPRB, 0.21928344E-07_JPRB, &
  & 0.23642553E-07_JPRB, 0.25273744E-07_JPRB, 0.27007101E-07_JPRB, 0.29383727E-07_JPRB, 0.32112844E-07_JPRB, 0.34869097E-07_JPRB, &
  & 0.36687340E-07_JPRB, 0.37943673E-07_JPRB, 0.38218793E-07_JPRB, 0.37099312E-07_JPRB, 0.35757375E-07_JPRB, 0.34265178E-07_JPRB, &
  & 0.32987219E-07_JPRB, 0.31977599E-07_JPRB, 0.30989247E-07_JPRB, 0.30340382E-07_JPRB, 0.29691985E-07_JPRB, 0.28959903E-07_JPRB, &
  & 0.29157978E-07_JPRB, 0.28967089E-07_JPRB, 0.29454976E-07_JPRB, 0.29958065E-07_JPRB, 0.30893319E-07_JPRB, 0.31919026E-07_JPRB, &
  & 0.33192158E-07_JPRB, 0.33419618E-07_JPRB, 0.33486388E-07_JPRB, 0.33321744E-07_JPRB  /)

RGHG7(:,86, 4) = (/ &
  & 0.67872326E-08_JPRB, 0.67428445E-08_JPRB, 0.62925771E-08_JPRB, 0.63141509E-08_JPRB, 0.64694173E-08_JPRB, 0.64053218E-08_JPRB, &
  & 0.64097828E-08_JPRB, 0.63084774E-08_JPRB, 0.63080781E-08_JPRB, 0.66143656E-08_JPRB, 0.68722032E-08_JPRB, 0.71649177E-08_JPRB, &
  & 0.74717279E-08_JPRB, 0.78174673E-08_JPRB, 0.82431108E-08_JPRB, 0.87464280E-08_JPRB, 0.92836064E-08_JPRB, 0.99187414E-08_JPRB, &
  & 0.10666984E-07_JPRB, 0.11520054E-07_JPRB, 0.12317213E-07_JPRB, 0.13006083E-07_JPRB, 0.13476832E-07_JPRB, 0.13729599E-07_JPRB, &
  & 0.13614135E-07_JPRB, 0.13155965E-07_JPRB, 0.12590450E-07_JPRB, 0.12037181E-07_JPRB, 0.11523487E-07_JPRB, 0.11185035E-07_JPRB, &
  & 0.10698310E-07_JPRB, 0.10573370E-07_JPRB, 0.11916744E-07_JPRB, 0.15094854E-07_JPRB, 0.18818932E-07_JPRB, 0.21678887E-07_JPRB, &
  & 0.23373717E-07_JPRB, 0.24981060E-07_JPRB, 0.26627205E-07_JPRB, 0.28903459E-07_JPRB, 0.31627065E-07_JPRB, 0.34404987E-07_JPRB, &
  & 0.36221844E-07_JPRB, 0.37408207E-07_JPRB, 0.37583344E-07_JPRB, 0.36479410E-07_JPRB, 0.35100079E-07_JPRB, 0.33542189E-07_JPRB, &
  & 0.32333415E-07_JPRB, 0.31310639E-07_JPRB, 0.30343696E-07_JPRB, 0.29706028E-07_JPRB, 0.29031544E-07_JPRB, 0.28305353E-07_JPRB, &
  & 0.28562302E-07_JPRB, 0.28242768E-07_JPRB, 0.28658815E-07_JPRB, 0.28893624E-07_JPRB, 0.29558459E-07_JPRB, 0.30351532E-07_JPRB, &
  & 0.31297462E-07_JPRB, 0.31265487E-07_JPRB, 0.30988764E-07_JPRB, 0.31331303E-07_JPRB  /)

RGHG7(:,87, 4) = (/ &
  & 0.63895956E-08_JPRB, 0.63811727E-08_JPRB, 0.59216110E-08_JPRB, 0.59811641E-08_JPRB, 0.61804877E-08_JPRB, 0.61304564E-08_JPRB, &
  & 0.61543664E-08_JPRB, 0.61455277E-08_JPRB, 0.62198882E-08_JPRB, 0.65546251E-08_JPRB, 0.68143768E-08_JPRB, 0.71001678E-08_JPRB, &
  & 0.74026883E-08_JPRB, 0.77366533E-08_JPRB, 0.81611882E-08_JPRB, 0.86590163E-08_JPRB, 0.91977559E-08_JPRB, 0.98261077E-08_JPRB, &
  & 0.10568391E-07_JPRB, 0.11386897E-07_JPRB, 0.12160675E-07_JPRB, 0.12817331E-07_JPRB, 0.13264612E-07_JPRB, 0.13508641E-07_JPRB, &
  & 0.13406784E-07_JPRB, 0.12982015E-07_JPRB, 0.12441573E-07_JPRB, 0.11915116E-07_JPRB, 0.11410739E-07_JPRB, 0.11060109E-07_JPRB, &
  & 0.10567959E-07_JPRB, 0.10419561E-07_JPRB, 0.11746694E-07_JPRB, 0.14914871E-07_JPRB, 0.18579168E-07_JPRB, 0.21392844E-07_JPRB, &
  & 0.23050102E-07_JPRB, 0.24621755E-07_JPRB, 0.26193883E-07_JPRB, 0.28350361E-07_JPRB, 0.31017411E-07_JPRB, 0.33756579E-07_JPRB, &
  & 0.35588315E-07_JPRB, 0.36693307E-07_JPRB, 0.36756375E-07_JPRB, 0.35630783E-07_JPRB, 0.34228699E-07_JPRB, 0.32588461E-07_JPRB, &
  & 0.31513936E-07_JPRB, 0.30494934E-07_JPRB, 0.29559340E-07_JPRB, 0.28962065E-07_JPRB, 0.28292550E-07_JPRB, 0.27590360E-07_JPRB, &
  & 0.27958483E-07_JPRB, 0.27528070E-07_JPRB, 0.27954744E-07_JPRB, 0.28080576E-07_JPRB, 0.28573788E-07_JPRB, 0.29238255E-07_JPRB, &
  & 0.29839223E-07_JPRB, 0.29490225E-07_JPRB, 0.28936212E-07_JPRB, 0.29571436E-07_JPRB  /)

RGHG7(:,88, 4) = (/ &
  & 0.59054663E-08_JPRB, 0.59184377E-08_JPRB, 0.54686121E-08_JPRB, 0.55530195E-08_JPRB, 0.58404418E-08_JPRB, 0.58139460E-08_JPRB, &
  & 0.58697035E-08_JPRB, 0.59877683E-08_JPRB, 0.61465746E-08_JPRB, 0.65102304E-08_JPRB, 0.67703752E-08_JPRB, 0.70507756E-08_JPRB, &
  & 0.73505590E-08_JPRB, 0.76714057E-08_JPRB, 0.80922243E-08_JPRB, 0.85806216E-08_JPRB, 0.91228700E-08_JPRB, 0.97400949E-08_JPRB, &
  & 0.10466741E-07_JPRB, 0.11238067E-07_JPRB, 0.11969838E-07_JPRB, 0.12574790E-07_JPRB, 0.12997047E-07_JPRB, 0.13237676E-07_JPRB, &
  & 0.13148381E-07_JPRB, 0.12769324E-07_JPRB, 0.12262705E-07_JPRB, 0.11771233E-07_JPRB, 0.11271833E-07_JPRB, 0.10886738E-07_JPRB, &
  & 0.10393451E-07_JPRB, 0.10224022E-07_JPRB, 0.11530044E-07_JPRB, 0.14674781E-07_JPRB, 0.18277290E-07_JPRB, 0.21038290E-07_JPRB, &
  & 0.22625733E-07_JPRB, 0.24130642E-07_JPRB, 0.25617085E-07_JPRB, 0.27642520E-07_JPRB, 0.30211317E-07_JPRB, 0.32827033E-07_JPRB, &
  & 0.34667644E-07_JPRB, 0.35667627E-07_JPRB, 0.35623983E-07_JPRB, 0.34432128E-07_JPRB, 0.33031372E-07_JPRB, 0.31270320E-07_JPRB, &
  & 0.30422106E-07_JPRB, 0.29443901E-07_JPRB, 0.28548506E-07_JPRB, 0.28029279E-07_JPRB, 0.27423223E-07_JPRB, 0.26752042E-07_JPRB, &
  & 0.27284403E-07_JPRB, 0.26732685E-07_JPRB, 0.27250309E-07_JPRB, 0.27369382E-07_JPRB, 0.27783877E-07_JPRB, 0.28410201E-07_JPRB, &
  & 0.28696608E-07_JPRB, 0.28026393E-07_JPRB, 0.27317987E-07_JPRB, 0.28157308E-07_JPRB  /)

RGHG7(:,89, 4) = (/ &
  & 0.53189106E-08_JPRB, 0.53967866E-08_JPRB, 0.49495333E-08_JPRB, 0.50227593E-08_JPRB, 0.54287714E-08_JPRB, 0.54346663E-08_JPRB, &
  & 0.55776067E-08_JPRB, 0.58574814E-08_JPRB, 0.60857372E-08_JPRB, 0.64768134E-08_JPRB, 0.67382022E-08_JPRB, 0.70144988E-08_JPRB, &
  & 0.73092251E-08_JPRB, 0.76204344E-08_JPRB, 0.80333793E-08_JPRB, 0.85097370E-08_JPRB, 0.90554457E-08_JPRB, 0.96558268E-08_JPRB, &
  & 0.10350406E-07_JPRB, 0.11077873E-07_JPRB, 0.11732202E-07_JPRB, 0.12271818E-07_JPRB, 0.12667799E-07_JPRB, 0.12899163E-07_JPRB, &
  & 0.12827340E-07_JPRB, 0.12503920E-07_JPRB, 0.12040383E-07_JPRB, 0.11591083E-07_JPRB, 0.11087145E-07_JPRB, 0.10636410E-07_JPRB, &
  & 0.10156973E-07_JPRB, 0.99765954E-08_JPRB, 0.11241056E-07_JPRB, 0.14350080E-07_JPRB, 0.17893683E-07_JPRB, 0.20591330E-07_JPRB, &
  & 0.22076336E-07_JPRB, 0.23461771E-07_JPRB, 0.24826565E-07_JPRB, 0.26708446E-07_JPRB, 0.29128675E-07_JPRB, 0.31512724E-07_JPRB, &
  & 0.33310532E-07_JPRB, 0.34171159E-07_JPRB, 0.34037552E-07_JPRB, 0.32770747E-07_JPRB, 0.31411961E-07_JPRB, 0.29482892E-07_JPRB, &
  & 0.28943937E-07_JPRB, 0.28068241E-07_JPRB, 0.27247659E-07_JPRB, 0.26859755E-07_JPRB, 0.26402719E-07_JPRB, 0.25759369E-07_JPRB, &
  & 0.26468788E-07_JPRB, 0.25759193E-07_JPRB, 0.26445285E-07_JPRB, 0.26576427E-07_JPRB, 0.27055983E-07_JPRB, 0.27624524E-07_JPRB, &
  & 0.27593475E-07_JPRB, 0.26819928E-07_JPRB, 0.26340866E-07_JPRB, 0.27462072E-07_JPRB  /)

RGHG7(:,90, 4) = (/ &
  & 0.47302179E-08_JPRB, 0.49969061E-08_JPRB, 0.43781896E-08_JPRB, 0.44141236E-08_JPRB, 0.49144692E-08_JPRB, 0.50037712E-08_JPRB, &
  & 0.53166517E-08_JPRB, 0.57540439E-08_JPRB, 0.60395698E-08_JPRB, 0.64507316E-08_JPRB, 0.67121036E-08_JPRB, 0.69854641E-08_JPRB, &
  & 0.72761693E-08_JPRB, 0.75800048E-08_JPRB, 0.79831067E-08_JPRB, 0.84458320E-08_JPRB, 0.89957264E-08_JPRB, 0.95708484E-08_JPRB, &
  & 0.10206844E-07_JPRB, 0.10907929E-07_JPRB, 0.11439477E-07_JPRB, 0.11901914E-07_JPRB, 0.12270166E-07_JPRB, 0.12497546E-07_JPRB, &
  & 0.12435428E-07_JPRB, 0.12179683E-07_JPRB, 0.11762243E-07_JPRB, 0.11356666E-07_JPRB, 0.10846675E-07_JPRB, 0.10309187E-07_JPRB, &
  & 0.98710438E-08_JPRB, 0.96923657E-08_JPRB, 0.10897457E-07_JPRB, 0.13985185E-07_JPRB, 0.17448520E-07_JPRB, 0.20086148E-07_JPRB, &
  & 0.21428895E-07_JPRB, 0.22621180E-07_JPRB, 0.23826578E-07_JPRB, 0.25528836E-07_JPRB, 0.27718651E-07_JPRB, 0.29794150E-07_JPRB, &
  & 0.31393544E-07_JPRB, 0.32142718E-07_JPRB, 0.31877519E-07_JPRB, 0.30567050E-07_JPRB, 0.29330367E-07_JPRB, 0.27345231E-07_JPRB, &
  & 0.27057928E-07_JPRB, 0.26308817E-07_JPRB, 0.25729866E-07_JPRB, 0.25558900E-07_JPRB, 0.25334782E-07_JPRB, 0.24676435E-07_JPRB, &
  & 0.25471198E-07_JPRB, 0.24572496E-07_JPRB, 0.25446828E-07_JPRB, 0.25580780E-07_JPRB, 0.26274696E-07_JPRB, 0.26637156E-07_JPRB, &
  & 0.26437346E-07_JPRB, 0.25514667E-07_JPRB, 0.25844940E-07_JPRB, 0.26976670E-07_JPRB  /)

RGHG7(:,91, 4) = (/ &
  & 0.44101322E-08_JPRB, 0.47577411E-08_JPRB, 0.39190050E-08_JPRB, 0.36947236E-08_JPRB, 0.42104071E-08_JPRB, 0.46715210E-08_JPRB, &
  & 0.51108069E-08_JPRB, 0.56947025E-08_JPRB, 0.60013842E-08_JPRB, 0.64204793E-08_JPRB, 0.66813224E-08_JPRB, 0.69536252E-08_JPRB, &
  & 0.72395703E-08_JPRB, 0.75397036E-08_JPRB, 0.79375166E-08_JPRB, 0.83822595E-08_JPRB, 0.89268649E-08_JPRB, 0.94834757E-08_JPRB, &
  & 0.10041724E-07_JPRB, 0.10704200E-07_JPRB, 0.11116746E-07_JPRB, 0.11449076E-07_JPRB, 0.11797230E-07_JPRB, 0.12036246E-07_JPRB, &
  & 0.11959848E-07_JPRB, 0.11778677E-07_JPRB, 0.11396143E-07_JPRB, 0.11072545E-07_JPRB, 0.10569958E-07_JPRB, 0.99816969E-08_JPRB, &
  & 0.95795184E-08_JPRB, 0.93934357E-08_JPRB, 0.10587420E-07_JPRB, 0.13629135E-07_JPRB, 0.17017366E-07_JPRB, 0.19577776E-07_JPRB, &
  & 0.20827967E-07_JPRB, 0.21863700E-07_JPRB, 0.22878696E-07_JPRB, 0.24347712E-07_JPRB, 0.26243463E-07_JPRB, 0.28153947E-07_JPRB, &
  & 0.29339747E-07_JPRB, 0.30052427E-07_JPRB, 0.29512733E-07_JPRB, 0.28228708E-07_JPRB, 0.27348499E-07_JPRB, 0.25349611E-07_JPRB, &
  & 0.25156980E-07_JPRB, 0.24600915E-07_JPRB, 0.24349349E-07_JPRB, 0.24413741E-07_JPRB, 0.24349349E-07_JPRB, 0.23614841E-07_JPRB, &
  & 0.24141984E-07_JPRB, 0.22970373E-07_JPRB, 0.23831483E-07_JPRB, 0.24145258E-07_JPRB, 0.25176080E-07_JPRB, 0.25507864E-07_JPRB, &
  & 0.24944704E-07_JPRB, 0.23423847E-07_JPRB, 0.25475667E-07_JPRB, 0.26451373E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ---GEMS----

RGHG7(:, 1, 5) = (/ &
  & 0.59920089E-05_JPRB, 0.59911886E-05_JPRB, 0.59801350E-05_JPRB, 0.59583977E-05_JPRB, 0.59294211E-05_JPRB, 0.58961859E-05_JPRB, &
  & 0.58495680E-05_JPRB, 0.58114051E-05_JPRB, 0.65498966E-07_JPRB, 0.64308509E-07_JPRB, 0.63991195E-07_JPRB, 0.63986761E-07_JPRB, &
  & 0.64211569E-07_JPRB, 0.64672001E-07_JPRB, 0.65272459E-07_JPRB, 0.65923437E-07_JPRB, 0.66636616E-07_JPRB, 0.67310005E-07_JPRB, &
  & 0.67893552E-07_JPRB, 0.68359896E-07_JPRB, 0.68764159E-07_JPRB, 0.69087719E-07_JPRB, 0.69320159E-07_JPRB, 0.69444589E-07_JPRB, &
  & 0.69445782E-07_JPRB, 0.69271039E-07_JPRB, 0.69096970E-07_JPRB, 0.68867884E-07_JPRB, 0.68601395E-07_JPRB, 0.68322763E-07_JPRB, &
  & 0.68095133E-07_JPRB, 0.67985724E-07_JPRB, 0.68105336E-07_JPRB, 0.68388950E-07_JPRB, 0.68803395E-07_JPRB, 0.69306452E-07_JPRB, &
  & 0.69781997E-07_JPRB, 0.70245363E-07_JPRB, 0.70431774E-07_JPRB, 0.70576348E-07_JPRB, 0.70802109E-07_JPRB, 0.70731915E-07_JPRB, &
  & 0.70850348E-07_JPRB, 0.70620935E-07_JPRB, 0.70498167E-07_JPRB, 0.70317235E-07_JPRB, 0.70147763E-07_JPRB, 0.69977439E-07_JPRB, &
  & 0.69702693E-07_JPRB, 0.69546985E-07_JPRB, 0.69421993E-07_JPRB, 0.69280631E-07_JPRB, 0.69251364E-07_JPRB, 0.69163754E-07_JPRB, &
  & 0.69069706E-07_JPRB, 0.69025432E-07_JPRB, 0.69536419E-07_JPRB, 0.70121935E-07_JPRB, 0.71068449E-07_JPRB, 0.72718215E-07_JPRB, &
  & 0.74885889E-07_JPRB, 0.78134015E-07_JPRB, 0.81889795E-07_JPRB, 0.86810708E-07_JPRB  /)

RGHG7(:, 2, 5) = (/ &
  & 0.60625366E-05_JPRB, 0.61151272E-05_JPRB, 0.61733072E-05_JPRB, 0.62531744E-05_JPRB, 0.62821691E-05_JPRB, 0.62524896E-05_JPRB, &
  & 0.58063792E-05_JPRB, 0.55130286E-05_JPRB, 0.17152132E-06_JPRB, 0.17144002E-06_JPRB, 0.17826900E-06_JPRB, 0.18242103E-06_JPRB, &
  & 0.18491421E-06_JPRB, 0.19008057E-06_JPRB, 0.19398566E-06_JPRB, 0.19443574E-06_JPRB, 0.19780200E-06_JPRB, 0.20095653E-06_JPRB, &
  & 0.20269135E-06_JPRB, 0.20150827E-06_JPRB, 0.20400783E-06_JPRB, 0.20758871E-06_JPRB, 0.21186744E-06_JPRB, 0.21649429E-06_JPRB, &
  & 0.21921127E-06_JPRB, 0.21599104E-06_JPRB, 0.21714743E-06_JPRB, 0.21778904E-06_JPRB, 0.21750412E-06_JPRB, 0.21621560E-06_JPRB, &
  & 0.21237315E-06_JPRB, 0.20346555E-06_JPRB, 0.20087047E-06_JPRB, 0.20010164E-06_JPRB, 0.20073742E-06_JPRB, 0.20266009E-06_JPRB, &
  & 0.20517913E-06_JPRB, 0.20868190E-06_JPRB, 0.20721357E-06_JPRB, 0.20811714E-06_JPRB, 0.21163430E-06_JPRB, 0.21453971E-06_JPRB, &
  & 0.21913517E-06_JPRB, 0.22075177E-06_JPRB, 0.22300426E-06_JPRB, 0.22777603E-06_JPRB, 0.23430420E-06_JPRB, 0.24176910E-06_JPRB, &
  & 0.24460093E-06_JPRB, 0.25422182E-06_JPRB, 0.26503213E-06_JPRB, 0.27042674E-06_JPRB, 0.28217454E-06_JPRB, 0.28813969E-06_JPRB, &
  & 0.29525938E-06_JPRB, 0.31621303E-06_JPRB, 0.37850486E-06_JPRB, 0.45700216E-06_JPRB, 0.53799135E-06_JPRB, 0.64927008E-06_JPRB, &
  & 0.75322140E-06_JPRB, 0.89350118E-06_JPRB, 0.10164993E-05_JPRB, 0.11134151E-05_JPRB  /)

RGHG7(:, 3, 5) = (/ &
  & 0.59638969E-05_JPRB, 0.56955150E-05_JPRB, 0.53877125E-05_JPRB, 0.49962437E-05_JPRB, 0.44002390E-05_JPRB, 0.35839287E-05_JPRB, &
  & 0.25731715E-05_JPRB, 0.21717315E-05_JPRB, 0.20171792E-06_JPRB, 0.21448847E-06_JPRB, 0.24104236E-06_JPRB, 0.26678524E-06_JPRB, &
  & 0.28891952E-06_JPRB, 0.31171379E-06_JPRB, 0.33009542E-06_JPRB, 0.33769388E-06_JPRB, 0.34809992E-06_JPRB, 0.35907502E-06_JPRB, &
  & 0.36807316E-06_JPRB, 0.36945843E-06_JPRB, 0.37542716E-06_JPRB, 0.38338106E-06_JPRB, 0.39205247E-06_JPRB, 0.40060243E-06_JPRB, &
  & 0.40726346E-06_JPRB, 0.40274790E-06_JPRB, 0.40277260E-06_JPRB, 0.40409674E-06_JPRB, 0.40546644E-06_JPRB, 0.40563853E-06_JPRB, &
  & 0.40570632E-06_JPRB, 0.39609571E-06_JPRB, 0.39199637E-06_JPRB, 0.39310154E-06_JPRB, 0.39597708E-06_JPRB, 0.40127867E-06_JPRB, &
  & 0.40483511E-06_JPRB, 0.41161721E-06_JPRB, 0.40893764E-06_JPRB, 0.40853263E-06_JPRB, 0.41427830E-06_JPRB, 0.42024445E-06_JPRB, &
  & 0.42953391E-06_JPRB, 0.43238018E-06_JPRB, 0.43498989E-06_JPRB, 0.44371754E-06_JPRB, 0.45660485E-06_JPRB, 0.46947281E-06_JPRB, &
  & 0.47645733E-06_JPRB, 0.49326161E-06_JPRB, 0.51185344E-06_JPRB, 0.52133487E-06_JPRB, 0.54033035E-06_JPRB, 0.55052749E-06_JPRB, &
  & 0.56918907E-06_JPRB, 0.62112645E-06_JPRB, 0.75313005E-06_JPRB, 0.89619834E-06_JPRB, 0.10023879E-05_JPRB, 0.11661197E-05_JPRB, &
  & 0.13207604E-05_JPRB, 0.15655625E-05_JPRB, 0.18630290E-05_JPRB, 0.24500278E-05_JPRB  /)

RGHG7(:, 4, 5) = (/ &
  & 0.44902773E-05_JPRB, 0.40994853E-05_JPRB, 0.38017562E-05_JPRB, 0.35117072E-05_JPRB, 0.31986157E-05_JPRB, 0.29304785E-05_JPRB, &
  & 0.26729460E-05_JPRB, 0.26186616E-05_JPRB, 0.19399723E-05_JPRB, 0.19420376E-05_JPRB, 0.19085201E-05_JPRB, 0.17979665E-05_JPRB, &
  & 0.16226781E-05_JPRB, 0.14708530E-05_JPRB, 0.13606097E-05_JPRB, 0.12936337E-05_JPRB, 0.12509238E-05_JPRB, 0.12254836E-05_JPRB, &
  & 0.12020482E-05_JPRB, 0.11819025E-05_JPRB, 0.11700820E-05_JPRB, 0.11588429E-05_JPRB, 0.11442371E-05_JPRB, 0.11244355E-05_JPRB, &
  & 0.11044689E-05_JPRB, 0.10501134E-05_JPRB, 0.98287450E-06_JPRB, 0.91510304E-06_JPRB, 0.85198152E-06_JPRB, 0.80574490E-06_JPRB, &
  & 0.78319820E-06_JPRB, 0.76506903E-06_JPRB, 0.75274603E-06_JPRB, 0.76206155E-06_JPRB, 0.78639586E-06_JPRB, 0.81626165E-06_JPRB, &
  & 0.83600119E-06_JPRB, 0.85264093E-06_JPRB, 0.86247426E-06_JPRB, 0.87466595E-06_JPRB, 0.89679815E-06_JPRB, 0.91943321E-06_JPRB, &
  & 0.94628094E-06_JPRB, 0.96598079E-06_JPRB, 0.98258511E-06_JPRB, 0.10037090E-05_JPRB, 0.10228634E-05_JPRB, 0.10350015E-05_JPRB, &
  & 0.10367064E-05_JPRB, 0.10435257E-05_JPRB, 0.10462234E-05_JPRB, 0.10369202E-05_JPRB, 0.10324214E-05_JPRB, 0.10189595E-05_JPRB, &
  & 0.99842628E-06_JPRB, 0.98365348E-06_JPRB, 0.98627333E-06_JPRB, 0.99211221E-06_JPRB, 0.96738128E-06_JPRB, 0.95772938E-06_JPRB, &
  & 0.94941181E-06_JPRB, 0.99045984E-06_JPRB, 0.99154100E-06_JPRB, 0.97999620E-06_JPRB  /)

RGHG7(:, 5, 5) = (/ &
  & 0.34772029E-05_JPRB, 0.34587396E-05_JPRB, 0.34248970E-05_JPRB, 0.33984483E-05_JPRB, 0.33577108E-05_JPRB, 0.33179950E-05_JPRB, &
  & 0.33332291E-05_JPRB, 0.33942348E-05_JPRB, 0.34713560E-05_JPRB, 0.34985648E-05_JPRB, 0.34365608E-05_JPRB, 0.32268936E-05_JPRB, &
  & 0.28797512E-05_JPRB, 0.25313362E-05_JPRB, 0.22589418E-05_JPRB, 0.20965241E-05_JPRB, 0.19879055E-05_JPRB, 0.19153614E-05_JPRB, &
  & 0.18500377E-05_JPRB, 0.18054325E-05_JPRB, 0.17705847E-05_JPRB, 0.17342694E-05_JPRB, 0.16927388E-05_JPRB, 0.16441745E-05_JPRB, &
  & 0.15927774E-05_JPRB, 0.15006340E-05_JPRB, 0.13833994E-05_JPRB, 0.12507106E-05_JPRB, 0.11103398E-05_JPRB, 0.99866072E-06_JPRB, &
  & 0.92789298E-06_JPRB, 0.89062600E-06_JPRB, 0.87054749E-06_JPRB, 0.88102487E-06_JPRB, 0.91760562E-06_JPRB, 0.96263303E-06_JPRB, &
  & 0.99485322E-06_JPRB, 0.10169205E-05_JPRB, 0.10409518E-05_JPRB, 0.10681707E-05_JPRB, 0.11027392E-05_JPRB, 0.11396043E-05_JPRB, &
  & 0.11776608E-05_JPRB, 0.12158118E-05_JPRB, 0.12497910E-05_JPRB, 0.12825078E-05_JPRB, 0.13060006E-05_JPRB, 0.13196810E-05_JPRB, &
  & 0.13252620E-05_JPRB, 0.13283005E-05_JPRB, 0.13271035E-05_JPRB, 0.13188891E-05_JPRB, 0.13062165E-05_JPRB, 0.12854147E-05_JPRB, &
  & 0.12562704E-05_JPRB, 0.12184242E-05_JPRB, 0.11843829E-05_JPRB, 0.11240584E-05_JPRB, 0.10178600E-05_JPRB, 0.89746457E-06_JPRB, &
  & 0.79319622E-06_JPRB, 0.71590816E-06_JPRB, 0.66864950E-06_JPRB, 0.64338564E-06_JPRB  /)

RGHG7(:, 6, 5) = (/ &
  & 0.35133882E-05_JPRB, 0.35172655E-05_JPRB, 0.34877839E-05_JPRB, 0.34597285E-05_JPRB, 0.34310795E-05_JPRB, 0.34118298E-05_JPRB, &
  & 0.34232768E-05_JPRB, 0.34798067E-05_JPRB, 0.35550917E-05_JPRB, 0.35837924E-05_JPRB, 0.35353687E-05_JPRB, 0.33460529E-05_JPRB, &
  & 0.30074413E-05_JPRB, 0.26229906E-05_JPRB, 0.23233207E-05_JPRB, 0.21506125E-05_JPRB, 0.20406550E-05_JPRB, 0.19694880E-05_JPRB, &
  & 0.19097877E-05_JPRB, 0.18730248E-05_JPRB, 0.18428058E-05_JPRB, 0.18133763E-05_JPRB, 0.17835899E-05_JPRB, 0.17480320E-05_JPRB, &
  & 0.17042476E-05_JPRB, 0.16339476E-05_JPRB, 0.15464368E-05_JPRB, 0.14267162E-05_JPRB, 0.12779677E-05_JPRB, 0.11450573E-05_JPRB, &
  & 0.10495389E-05_JPRB, 0.10023640E-05_JPRB, 0.98572839E-06_JPRB, 0.99620577E-06_JPRB, 0.10250591E-05_JPRB, 0.10635832E-05_JPRB, &
  & 0.10931639E-05_JPRB, 0.11164553E-05_JPRB, 0.11418255E-05_JPRB, 0.11680881E-05_JPRB, 0.11980277E-05_JPRB, 0.12301493E-05_JPRB, &
  & 0.12625441E-05_JPRB, 0.12953778E-05_JPRB, 0.13236570E-05_JPRB, 0.13518980E-05_JPRB, 0.13718332E-05_JPRB, 0.13795458E-05_JPRB, &
  & 0.13804980E-05_JPRB, 0.13814325E-05_JPRB, 0.13846347E-05_JPRB, 0.13865196E-05_JPRB, 0.13789348E-05_JPRB, 0.13612317E-05_JPRB, &
  & 0.13383228E-05_JPRB, 0.12996733E-05_JPRB, 0.12652877E-05_JPRB, 0.12198825E-05_JPRB, 0.11391999E-05_JPRB, 0.10359807E-05_JPRB, &
  & 0.93194192E-06_JPRB, 0.84834186E-06_JPRB, 0.79825236E-06_JPRB, 0.77620188E-06_JPRB  /)

RGHG7(:, 7, 5) = (/ &
  & 0.35948713E-05_JPRB, 0.36277474E-05_JPRB, 0.36112516E-05_JPRB, 0.36039567E-05_JPRB, 0.35912935E-05_JPRB, 0.35805181E-05_JPRB, &
  & 0.35973942E-05_JPRB, 0.36524006E-05_JPRB, 0.37330490E-05_JPRB, 0.37752352E-05_JPRB, 0.37453275E-05_JPRB, 0.35840229E-05_JPRB, &
  & 0.32749343E-05_JPRB, 0.28749450E-05_JPRB, 0.25372226E-05_JPRB, 0.23322479E-05_JPRB, 0.22054228E-05_JPRB, 0.21283018E-05_JPRB, &
  & 0.20697245E-05_JPRB, 0.20320500E-05_JPRB, 0.20036386E-05_JPRB, 0.19768686E-05_JPRB, 0.19555107E-05_JPRB, 0.19328424E-05_JPRB, &
  & 0.19060955E-05_JPRB, 0.18600953E-05_JPRB, 0.17997757E-05_JPRB, 0.17064695E-05_JPRB, 0.15759259E-05_JPRB, 0.14508848E-05_JPRB, &
  & 0.13498047E-05_JPRB, 0.12956902E-05_JPRB, 0.12791622E-05_JPRB, 0.12876319E-05_JPRB, 0.13048432E-05_JPRB, 0.13322088E-05_JPRB, &
  & 0.13532875E-05_JPRB, 0.13690314E-05_JPRB, 0.13917155E-05_JPRB, 0.14132562E-05_JPRB, 0.14351468E-05_JPRB, 0.14592900E-05_JPRB, &
  & 0.14842712E-05_JPRB, 0.15083883E-05_JPRB, 0.15269351E-05_JPRB, 0.15444432E-05_JPRB, 0.15537789E-05_JPRB, 0.15526805E-05_JPRB, &
  & 0.15468057E-05_JPRB, 0.15427642E-05_JPRB, 0.15437689E-05_JPRB, 0.15460741E-05_JPRB, 0.15390543E-05_JPRB, 0.15199248E-05_JPRB, &
  & 0.14981405E-05_JPRB, 0.14595488E-05_JPRB, 0.14274264E-05_JPRB, 0.13964981E-05_JPRB, 0.13495531E-05_JPRB, 0.12784229E-05_JPRB, &
  & 0.11918760E-05_JPRB, 0.11158259E-05_JPRB, 0.10668089E-05_JPRB, 0.10402062E-05_JPRB  /)

RGHG7(:, 8, 5) = (/ &
  & 0.37324552E-05_JPRB, 0.37819581E-05_JPRB, 0.37970444E-05_JPRB, 0.38197681E-05_JPRB, 0.38264684E-05_JPRB, 0.38280807E-05_JPRB, &
  & 0.38517645E-05_JPRB, 0.39141026E-05_JPRB, 0.40101199E-05_JPRB, 0.40750682E-05_JPRB, 0.40721595E-05_JPRB, 0.39505352E-05_JPRB, &
  & 0.36965057E-05_JPRB, 0.33135213E-05_JPRB, 0.29480152E-05_JPRB, 0.26985396E-05_JPRB, 0.25340994E-05_JPRB, 0.24329662E-05_JPRB, &
  & 0.23578512E-05_JPRB, 0.23061993E-05_JPRB, 0.22719070E-05_JPRB, 0.22433247E-05_JPRB, 0.22263492E-05_JPRB, 0.22155841E-05_JPRB, &
  & 0.22055945E-05_JPRB, 0.21815519E-05_JPRB, 0.21536711E-05_JPRB, 0.21051572E-05_JPRB, 0.20328720E-05_JPRB, 0.19583873E-05_JPRB, &
  & 0.18868570E-05_JPRB, 0.18447739E-05_JPRB, 0.18276000E-05_JPRB, 0.18273871E-05_JPRB, 0.18282194E-05_JPRB, 0.18355719E-05_JPRB, &
  & 0.18385578E-05_JPRB, 0.18382115E-05_JPRB, 0.18478401E-05_JPRB, 0.18561236E-05_JPRB, 0.18635533E-05_JPRB, 0.18730040E-05_JPRB, &
  & 0.18851948E-05_JPRB, 0.18968766E-05_JPRB, 0.19019069E-05_JPRB, 0.19044337E-05_JPRB, 0.18974947E-05_JPRB, 0.18823834E-05_JPRB, &
  & 0.18648637E-05_JPRB, 0.18503520E-05_JPRB, 0.18413876E-05_JPRB, 0.18342302E-05_JPRB, 0.18210797E-05_JPRB, 0.17981102E-05_JPRB, &
  & 0.17751319E-05_JPRB, 0.17374022E-05_JPRB, 0.17104860E-05_JPRB, 0.16941085E-05_JPRB, 0.16803030E-05_JPRB, 0.16430914E-05_JPRB, &
  & 0.15813805E-05_JPRB, 0.15210773E-05_JPRB, 0.14774312E-05_JPRB, 0.14492349E-05_JPRB  /)

RGHG7(:, 9, 5) = (/ &
  & 0.39231214E-05_JPRB, 0.39692455E-05_JPRB, 0.40219994E-05_JPRB, 0.40678336E-05_JPRB, 0.41002665E-05_JPRB, 0.41253031E-05_JPRB, &
  & 0.41653378E-05_JPRB, 0.42515753E-05_JPRB, 0.43881207E-05_JPRB, 0.45037201E-05_JPRB, 0.45563908E-05_JPRB, 0.45122853E-05_JPRB, &
  & 0.43568359E-05_JPRB, 0.40486745E-05_JPRB, 0.36912202E-05_JPRB, 0.33947746E-05_JPRB, 0.31658248E-05_JPRB, 0.30078176E-05_JPRB, &
  & 0.28846878E-05_JPRB, 0.27960313E-05_JPRB, 0.27400157E-05_JPRB, 0.27010074E-05_JPRB, 0.26794300E-05_JPRB, 0.26674763E-05_JPRB, &
  & 0.26629123E-05_JPRB, 0.26530075E-05_JPRB, 0.26600810E-05_JPRB, 0.26668218E-05_JPRB, 0.26747322E-05_JPRB, 0.26804196E-05_JPRB, &
  & 0.26722685E-05_JPRB, 0.26655346E-05_JPRB, 0.26537441E-05_JPRB, 0.26408951E-05_JPRB, 0.26248146E-05_JPRB, 0.26103677E-05_JPRB, &
  & 0.25931662E-05_JPRB, 0.25721521E-05_JPRB, 0.25592720E-05_JPRB, 0.25470019E-05_JPRB, 0.25358912E-05_JPRB, 0.25259520E-05_JPRB, &
  & 0.25203258E-05_JPRB, 0.25145475E-05_JPRB, 0.25010000E-05_JPRB, 0.24843329E-05_JPRB, 0.24548878E-05_JPRB, 0.24193918E-05_JPRB, &
  & 0.23831839E-05_JPRB, 0.23501520E-05_JPRB, 0.23235804E-05_JPRB, 0.22991360E-05_JPRB, 0.22760198E-05_JPRB, 0.22499332E-05_JPRB, &
  & 0.22268861E-05_JPRB, 0.21911357E-05_JPRB, 0.21706460E-05_JPRB, 0.21670770E-05_JPRB, 0.21796947E-05_JPRB, 0.21705740E-05_JPRB, &
  & 0.21339632E-05_JPRB, 0.20930674E-05_JPRB, 0.20597063E-05_JPRB, 0.20394935E-05_JPRB  /)

RGHG7(:,10, 5) = (/ &
  & 0.40438467E-05_JPRB, 0.40934140E-05_JPRB, 0.41638801E-05_JPRB, 0.42210016E-05_JPRB, 0.42869797E-05_JPRB, 0.43533043E-05_JPRB, &
  & 0.44385838E-05_JPRB, 0.45799263E-05_JPRB, 0.48018983E-05_JPRB, 0.50265383E-05_JPRB, 0.52009154E-05_JPRB, 0.53199422E-05_JPRB, &
  & 0.53426030E-05_JPRB, 0.51931263E-05_JPRB, 0.49135696E-05_JPRB, 0.45938987E-05_JPRB, 0.42861395E-05_JPRB, 0.40361388E-05_JPRB, &
  & 0.38354988E-05_JPRB, 0.36892848E-05_JPRB, 0.35940964E-05_JPRB, 0.35274851E-05_JPRB, 0.34819016E-05_JPRB, 0.34427093E-05_JPRB, &
  & 0.34244452E-05_JPRB, 0.34098232E-05_JPRB, 0.34283153E-05_JPRB, 0.34590535E-05_JPRB, 0.35008597E-05_JPRB, 0.35499835E-05_JPRB, &
  & 0.35887629E-05_JPRB, 0.36118225E-05_JPRB, 0.36107417E-05_JPRB, 0.35911652E-05_JPRB, 0.35677121E-05_JPRB, 0.35491437E-05_JPRB, &
  & 0.35276671E-05_JPRB, 0.34964496E-05_JPRB, 0.34671422E-05_JPRB, 0.34389723E-05_JPRB, 0.34132395E-05_JPRB, 0.33873970E-05_JPRB, &
  & 0.33653445E-05_JPRB, 0.33397339E-05_JPRB, 0.33029080E-05_JPRB, 0.32630842E-05_JPRB, 0.32064803E-05_JPRB, 0.31474462E-05_JPRB, &
  & 0.30892609E-05_JPRB, 0.30350583E-05_JPRB, 0.29932803E-05_JPRB, 0.29566057E-05_JPRB, 0.29302408E-05_JPRB, 0.29061934E-05_JPRB, &
  & 0.28873997E-05_JPRB, 0.28526472E-05_JPRB, 0.28334273E-05_JPRB, 0.28343564E-05_JPRB, 0.28677428E-05_JPRB, 0.28869395E-05_JPRB, &
  & 0.28791888E-05_JPRB, 0.28598554E-05_JPRB, 0.28422588E-05_JPRB, 0.28388489E-05_JPRB  /)

RGHG7(:,11, 5) = (/ &
  & 0.40799196E-05_JPRB, 0.41522181E-05_JPRB, 0.42245839E-05_JPRB, 0.43016007E-05_JPRB, 0.43923744E-05_JPRB, 0.45050379E-05_JPRB, &
  & 0.46428498E-05_JPRB, 0.48556696E-05_JPRB, 0.51645001E-05_JPRB, 0.55066866E-05_JPRB, 0.58337772E-05_JPRB, 0.61551262E-05_JPRB, &
  & 0.64088565E-05_JPRB, 0.64845131E-05_JPRB, 0.63800874E-05_JPRB, 0.61298445E-05_JPRB, 0.58111123E-05_JPRB, 0.55069593E-05_JPRB, &
  & 0.52542170E-05_JPRB, 0.50653060E-05_JPRB, 0.49330091E-05_JPRB, 0.48287367E-05_JPRB, 0.47475210E-05_JPRB, 0.46747658E-05_JPRB, &
  & 0.46261213E-05_JPRB, 0.45706135E-05_JPRB, 0.45423336E-05_JPRB, 0.45255632E-05_JPRB, 0.45230928E-05_JPRB, 0.45410660E-05_JPRB, &
  & 0.45669212E-05_JPRB, 0.45823692E-05_JPRB, 0.45814848E-05_JPRB, 0.45634049E-05_JPRB, 0.45458902E-05_JPRB, 0.45441342E-05_JPRB, &
  & 0.45378667E-05_JPRB, 0.45189087E-05_JPRB, 0.44920625E-05_JPRB, 0.44602143E-05_JPRB, 0.44258657E-05_JPRB, 0.43876003E-05_JPRB, &
  & 0.43509483E-05_JPRB, 0.43083504E-05_JPRB, 0.42500112E-05_JPRB, 0.41889170E-05_JPRB, 0.41100470E-05_JPRB, 0.40381115E-05_JPRB, &
  & 0.39721272E-05_JPRB, 0.39117961E-05_JPRB, 0.38725068E-05_JPRB, 0.38413707E-05_JPRB, 0.38236231E-05_JPRB, 0.38050111E-05_JPRB, &
  & 0.37887183E-05_JPRB, 0.37475254E-05_JPRB, 0.37176369E-05_JPRB, 0.37060891E-05_JPRB, 0.37526193E-05_JPRB, 0.38057457E-05_JPRB, &
  & 0.38410353E-05_JPRB, 0.38555143E-05_JPRB, 0.38692154E-05_JPRB, 0.38883557E-05_JPRB  /)

RGHG7(:,12, 5) = (/ &
  & 0.43521774E-05_JPRB, 0.43962588E-05_JPRB, 0.44565656E-05_JPRB, 0.45348975E-05_JPRB, 0.46315109E-05_JPRB, 0.47550348E-05_JPRB, &
  & 0.49123322E-05_JPRB, 0.51432485E-05_JPRB, 0.54578334E-05_JPRB, 0.58264544E-05_JPRB, 0.62215181E-05_JPRB, 0.66411832E-05_JPRB, &
  & 0.70262735E-05_JPRB, 0.72721609E-05_JPRB, 0.73693210E-05_JPRB, 0.73046218E-05_JPRB, 0.71272103E-05_JPRB, 0.69077653E-05_JPRB, &
  & 0.66978460E-05_JPRB, 0.65237441E-05_JPRB, 0.63993812E-05_JPRB, 0.63069746E-05_JPRB, 0.62318641E-05_JPRB, 0.61527621E-05_JPRB, &
  & 0.60678814E-05_JPRB, 0.59587722E-05_JPRB, 0.58576157E-05_JPRB, 0.57598386E-05_JPRB, 0.56777835E-05_JPRB, 0.56258691E-05_JPRB, &
  & 0.56064548E-05_JPRB, 0.56015747E-05_JPRB, 0.56039868E-05_JPRB, 0.56005245E-05_JPRB, 0.56046891E-05_JPRB, 0.56318737E-05_JPRB, &
  & 0.56564360E-05_JPRB, 0.56666554E-05_JPRB, 0.56555319E-05_JPRB, 0.56284457E-05_JPRB, 0.55884285E-05_JPRB, 0.55342846E-05_JPRB, &
  & 0.54756151E-05_JPRB, 0.54147598E-05_JPRB, 0.53444639E-05_JPRB, 0.52799863E-05_JPRB, 0.52052798E-05_JPRB, 0.51529459E-05_JPRB, &
  & 0.51142340E-05_JPRB, 0.50767081E-05_JPRB, 0.50625640E-05_JPRB, 0.50536493E-05_JPRB, 0.50475121E-05_JPRB, 0.50248182E-05_JPRB, &
  & 0.49927918E-05_JPRB, 0.49212519E-05_JPRB, 0.48535824E-05_JPRB, 0.48074518E-05_JPRB, 0.48324874E-05_JPRB, 0.48832562E-05_JPRB, &
  & 0.49331555E-05_JPRB, 0.49726019E-05_JPRB, 0.50234743E-05_JPRB, 0.50682304E-05_JPRB  /)

RGHG7(:,13, 5) = (/ &
  & 0.45435456E-05_JPRB, 0.45641655E-05_JPRB, 0.46063681E-05_JPRB, 0.46696510E-05_JPRB, 0.47627484E-05_JPRB, 0.48819011E-05_JPRB, &
  & 0.50498131E-05_JPRB, 0.52778737E-05_JPRB, 0.55663772E-05_JPRB, 0.59244225E-05_JPRB, 0.63184257E-05_JPRB, 0.67511783E-05_JPRB, &
  & 0.71628011E-05_JPRB, 0.74691618E-05_JPRB, 0.76727940E-05_JPRB, 0.77542824E-05_JPRB, 0.77426174E-05_JPRB, 0.76706842E-05_JPRB, &
  & 0.75763718E-05_JPRB, 0.74909696E-05_JPRB, 0.74359367E-05_JPRB, 0.74071965E-05_JPRB, 0.73765912E-05_JPRB, 0.73227784E-05_JPRB, &
  & 0.72401675E-05_JPRB, 0.71242841E-05_JPRB, 0.69933055E-05_JPRB, 0.68542653E-05_JPRB, 0.67278662E-05_JPRB, 0.66288607E-05_JPRB, &
  & 0.65746556E-05_JPRB, 0.65615967E-05_JPRB, 0.65781201E-05_JPRB, 0.66051343E-05_JPRB, 0.66496523E-05_JPRB, 0.67211480E-05_JPRB, &
  & 0.67898739E-05_JPRB, 0.68377860E-05_JPRB, 0.68518607E-05_JPRB, 0.68350844E-05_JPRB, 0.67890179E-05_JPRB, 0.67220038E-05_JPRB, &
  & 0.66475129E-05_JPRB, 0.65764576E-05_JPRB, 0.65134669E-05_JPRB, 0.64729697E-05_JPRB, 0.64347834E-05_JPRB, 0.64288021E-05_JPRB, &
  & 0.64399824E-05_JPRB, 0.64366747E-05_JPRB, 0.64473777E-05_JPRB, 0.64450839E-05_JPRB, 0.64207225E-05_JPRB, 0.63603142E-05_JPRB, &
  & 0.62732429E-05_JPRB, 0.61317246E-05_JPRB, 0.59873565E-05_JPRB, 0.58731222E-05_JPRB, 0.58248808E-05_JPRB, 0.58138907E-05_JPRB, &
  & 0.58199115E-05_JPRB, 0.58394552E-05_JPRB, 0.58872770E-05_JPRB, 0.59314555E-05_JPRB  /)

RGHG7(:,14, 5) = (/ &
  & 0.43763554E-05_JPRB, 0.44107227E-05_JPRB, 0.44417213E-05_JPRB, 0.44944144E-05_JPRB, 0.45800282E-05_JPRB, 0.47023681E-05_JPRB, &
  & 0.48726348E-05_JPRB, 0.51059976E-05_JPRB, 0.53905862E-05_JPRB, 0.57482892E-05_JPRB, 0.61338229E-05_JPRB, 0.65528172E-05_JPRB, &
  & 0.69541979E-05_JPRB, 0.72767802E-05_JPRB, 0.75245218E-05_JPRB, 0.76804446E-05_JPRB, 0.77723640E-05_JPRB, 0.78143639E-05_JPRB, &
  & 0.78345970E-05_JPRB, 0.78530143E-05_JPRB, 0.78748137E-05_JPRB, 0.79025040E-05_JPRB, 0.79151129E-05_JPRB, 0.79056008E-05_JPRB, &
  & 0.78751473E-05_JPRB, 0.78173658E-05_JPRB, 0.77371489E-05_JPRB, 0.76404401E-05_JPRB, 0.75451508E-05_JPRB, 0.74612067E-05_JPRB, &
  & 0.74119684E-05_JPRB, 0.74080383E-05_JPRB, 0.74421223E-05_JPRB, 0.74932556E-05_JPRB, 0.75686860E-05_JPRB, 0.76799136E-05_JPRB, &
  & 0.77862535E-05_JPRB, 0.78574244E-05_JPRB, 0.78869026E-05_JPRB, 0.78741931E-05_JPRB, 0.78262323E-05_JPRB, 0.77625542E-05_JPRB, &
  & 0.76974228E-05_JPRB, 0.76434071E-05_JPRB, 0.76064251E-05_JPRB, 0.75979594E-05_JPRB, 0.76050840E-05_JPRB, 0.76407409E-05_JPRB, &
  & 0.76667326E-05_JPRB, 0.76563565E-05_JPRB, 0.76425797E-05_JPRB, 0.75942022E-05_JPRB, 0.75056031E-05_JPRB, 0.73739600E-05_JPRB, &
  & 0.72094040E-05_JPRB, 0.69936868E-05_JPRB, 0.67731835E-05_JPRB, 0.65876876E-05_JPRB, 0.64526990E-05_JPRB, 0.63602499E-05_JPRB, &
  & 0.62977376E-05_JPRB, 0.62654702E-05_JPRB, 0.62698819E-05_JPRB, 0.62902311E-05_JPRB  /)

RGHG7(:,15, 5) = (/ &
  & 0.40350358E-05_JPRB, 0.40634512E-05_JPRB, 0.40884975E-05_JPRB, 0.41322038E-05_JPRB, 0.42104953E-05_JPRB, 0.43266651E-05_JPRB, &
  & 0.44847009E-05_JPRB, 0.47063794E-05_JPRB, 0.49946368E-05_JPRB, 0.53435683E-05_JPRB, 0.57243225E-05_JPRB, 0.61241207E-05_JPRB, &
  & 0.65109186E-05_JPRB, 0.68493348E-05_JPRB, 0.71273806E-05_JPRB, 0.73396904E-05_JPRB, 0.75095784E-05_JPRB, 0.76486475E-05_JPRB, &
  & 0.77733511E-05_JPRB, 0.78879212E-05_JPRB, 0.79798140E-05_JPRB, 0.80531007E-05_JPRB, 0.81016734E-05_JPRB, 0.81369942E-05_JPRB, &
  & 0.81654288E-05_JPRB, 0.81855120E-05_JPRB, 0.82005247E-05_JPRB, 0.82090624E-05_JPRB, 0.82064610E-05_JPRB, 0.81938427E-05_JPRB, &
  & 0.81931404E-05_JPRB, 0.82157376E-05_JPRB, 0.82552640E-05_JPRB, 0.83045820E-05_JPRB, 0.83726281E-05_JPRB, 0.84744417E-05_JPRB, &
  & 0.85670953E-05_JPRB, 0.86208609E-05_JPRB, 0.86386676E-05_JPRB, 0.86223911E-05_JPRB, 0.85809081E-05_JPRB, 0.85286561E-05_JPRB, &
  & 0.84839671E-05_JPRB, 0.84559578E-05_JPRB, 0.84374008E-05_JPRB, 0.84445206E-05_JPRB, 0.84716650E-05_JPRB, 0.85014139E-05_JPRB, &
  & 0.84781403E-05_JPRB, 0.84065596E-05_JPRB, 0.83128999E-05_JPRB, 0.81783567E-05_JPRB, 0.80126877E-05_JPRB, 0.78118539E-05_JPRB, &
  & 0.75859456E-05_JPRB, 0.73347339E-05_JPRB, 0.70771480E-05_JPRB, 0.68548061E-05_JPRB, 0.66626085E-05_JPRB, 0.65040672E-05_JPRB, &
  & 0.63816075E-05_JPRB, 0.62995001E-05_JPRB, 0.62600442E-05_JPRB, 0.62470546E-05_JPRB  /)

RGHG7(:,16, 5) = (/ &
  & 0.36829566E-05_JPRB, 0.36994325E-05_JPRB, 0.37243923E-05_JPRB, 0.37643206E-05_JPRB, 0.38354453E-05_JPRB, 0.39364709E-05_JPRB, &
  & 0.40775541E-05_JPRB, 0.42832254E-05_JPRB, 0.45578730E-05_JPRB, 0.48795662E-05_JPRB, 0.52365005E-05_JPRB, 0.56146136E-05_JPRB, &
  & 0.59841383E-05_JPRB, 0.63181523E-05_JPRB, 0.66067868E-05_JPRB, 0.68563829E-05_JPRB, 0.70870201E-05_JPRB, 0.73108060E-05_JPRB, &
  & 0.75402648E-05_JPRB, 0.77597128E-05_JPRB, 0.79396383E-05_JPRB, 0.80675716E-05_JPRB, 0.81576255E-05_JPRB, 0.82324382E-05_JPRB, &
  & 0.83065445E-05_JPRB, 0.83906521E-05_JPRB, 0.84917020E-05_JPRB, 0.86089971E-05_JPRB, 0.87182163E-05_JPRB, 0.88077089E-05_JPRB, &
  & 0.88906697E-05_JPRB, 0.89532838E-05_JPRB, 0.89813073E-05_JPRB, 0.89905778E-05_JPRB, 0.90000438E-05_JPRB, 0.90414766E-05_JPRB, &
  & 0.90785246E-05_JPRB, 0.90903096E-05_JPRB, 0.90892018E-05_JPRB, 0.90732069E-05_JPRB, 0.90346052E-05_JPRB, 0.89791298E-05_JPRB, &
  & 0.89292283E-05_JPRB, 0.88935621E-05_JPRB, 0.88639709E-05_JPRB, 0.88559486E-05_JPRB, 0.88513938E-05_JPRB, 0.88153941E-05_JPRB, &
  & 0.87125998E-05_JPRB, 0.85694630E-05_JPRB, 0.84006320E-05_JPRB, 0.82037903E-05_JPRB, 0.79957873E-05_JPRB, 0.77656166E-05_JPRB, &
  & 0.75179538E-05_JPRB, 0.72667901E-05_JPRB, 0.70114955E-05_JPRB, 0.67766668E-05_JPRB, 0.65586279E-05_JPRB, 0.63619775E-05_JPRB, &
  & 0.61932134E-05_JPRB, 0.60631086E-05_JPRB, 0.59872038E-05_JPRB, 0.59576357E-05_JPRB  /)

RGHG7(:,17, 5) = (/ &
  & 0.34142151E-05_JPRB, 0.34174354E-05_JPRB, 0.34433014E-05_JPRB, 0.34913304E-05_JPRB, 0.35617553E-05_JPRB, 0.36553568E-05_JPRB, &
  & 0.37898949E-05_JPRB, 0.39872705E-05_JPRB, 0.42385450E-05_JPRB, 0.45303742E-05_JPRB, 0.48579326E-05_JPRB, 0.52110590E-05_JPRB, &
  & 0.55544688E-05_JPRB, 0.58628649E-05_JPRB, 0.61368224E-05_JPRB, 0.63875373E-05_JPRB, 0.66376726E-05_JPRB, 0.69073682E-05_JPRB, &
  & 0.72161664E-05_JPRB, 0.75327383E-05_JPRB, 0.78054466E-05_JPRB, 0.79850600E-05_JPRB, 0.81115683E-05_JPRB, 0.82181470E-05_JPRB, &
  & 0.83319410E-05_JPRB, 0.84664049E-05_JPRB, 0.86267145E-05_JPRB, 0.88189455E-05_JPRB, 0.90157794E-05_JPRB, 0.92003262E-05_JPRB, &
  & 0.93603237E-05_JPRB, 0.94471481E-05_JPRB, 0.94542061E-05_JPRB, 0.94096828E-05_JPRB, 0.93481590E-05_JPRB, 0.93257354E-05_JPRB, &
  & 0.93180753E-05_JPRB, 0.93021135E-05_JPRB, 0.92848386E-05_JPRB, 0.92626470E-05_JPRB, 0.92120665E-05_JPRB, 0.91339490E-05_JPRB, &
  & 0.90580684E-05_JPRB, 0.89935776E-05_JPRB, 0.89371656E-05_JPRB, 0.88985476E-05_JPRB, 0.88438246E-05_JPRB, 0.87263713E-05_JPRB, &
  & 0.85527302E-05_JPRB, 0.83479092E-05_JPRB, 0.81281787E-05_JPRB, 0.79166421E-05_JPRB, 0.77074007E-05_JPRB, 0.74752220E-05_JPRB, &
  & 0.72379346E-05_JPRB, 0.70000597E-05_JPRB, 0.67646622E-05_JPRB, 0.65361171E-05_JPRB, 0.63132831E-05_JPRB, 0.60983131E-05_JPRB, &
  & 0.59072501E-05_JPRB, 0.57468638E-05_JPRB, 0.56588592E-05_JPRB, 0.56264055E-05_JPRB  /)

RGHG7(:,18, 5) = (/ &
  & 0.32524980E-05_JPRB, 0.32542523E-05_JPRB, 0.32827388E-05_JPRB, 0.33411613E-05_JPRB, 0.34153776E-05_JPRB, 0.35117280E-05_JPRB, &
  & 0.36483881E-05_JPRB, 0.38415398E-05_JPRB, 0.40789030E-05_JPRB, 0.43477020E-05_JPRB, 0.46570514E-05_JPRB, 0.49904570E-05_JPRB, &
  & 0.53172083E-05_JPRB, 0.56009522E-05_JPRB, 0.58510436E-05_JPRB, 0.60806316E-05_JPRB, 0.63129841E-05_JPRB, 0.65813041E-05_JPRB, &
  & 0.69217957E-05_JPRB, 0.72966408E-05_JPRB, 0.76336211E-05_JPRB, 0.78501657E-05_JPRB, 0.79977417E-05_JPRB, 0.81388183E-05_JPRB, &
  & 0.82945567E-05_JPRB, 0.84691812E-05_JPRB, 0.86622495E-05_JPRB, 0.88876016E-05_JPRB, 0.91309913E-05_JPRB, 0.93732156E-05_JPRB, &
  & 0.95536902E-05_JPRB, 0.96230295E-05_JPRB, 0.96011373E-05_JPRB, 0.95278578E-05_JPRB, 0.94417505E-05_JPRB, 0.93968248E-05_JPRB, &
  & 0.93730299E-05_JPRB, 0.93473318E-05_JPRB, 0.93201105E-05_JPRB, 0.92850913E-05_JPRB, 0.92156524E-05_JPRB, 0.91127260E-05_JPRB, &
  & 0.90110716E-05_JPRB, 0.89130544E-05_JPRB, 0.88197196E-05_JPRB, 0.87320649E-05_JPRB, 0.86079858E-05_JPRB, 0.84197732E-05_JPRB, &
  & 0.82050110E-05_JPRB, 0.79760997E-05_JPRB, 0.77534716E-05_JPRB, 0.75620065E-05_JPRB, 0.73698830E-05_JPRB, 0.71533727E-05_JPRB, &
  & 0.69372870E-05_JPRB, 0.67100102E-05_JPRB, 0.64915266E-05_JPRB, 0.62714657E-05_JPRB, 0.60359323E-05_JPRB, 0.58025198E-05_JPRB, &
  & 0.55905092E-05_JPRB, 0.54081147E-05_JPRB, 0.53251583E-05_JPRB, 0.52893134E-05_JPRB  /)

RGHG7(:,19, 5) = (/ &
  & 0.31722542E-05_JPRB, 0.31801768E-05_JPRB, 0.32143463E-05_JPRB, 0.32799308E-05_JPRB, 0.33588050E-05_JPRB, 0.34595770E-05_JPRB, &
  & 0.36017510E-05_JPRB, 0.37938888E-05_JPRB, 0.40230160E-05_JPRB, 0.42764024E-05_JPRB, 0.45722218E-05_JPRB, 0.48964830E-05_JPRB, &
  & 0.52118761E-05_JPRB, 0.54812218E-05_JPRB, 0.57108283E-05_JPRB, 0.59155550E-05_JPRB, 0.61129738E-05_JPRB, 0.63498925E-05_JPRB, &
  & 0.66774318E-05_JPRB, 0.70530738E-05_JPRB, 0.74092487E-05_JPRB, 0.76538963E-05_JPRB, 0.78285003E-05_JPRB, 0.80010258E-05_JPRB, &
  & 0.81962296E-05_JPRB, 0.84025627E-05_JPRB, 0.86158013E-05_JPRB, 0.88535632E-05_JPRB, 0.91111287E-05_JPRB, 0.93606872E-05_JPRB, &
  & 0.95372720E-05_JPRB, 0.95949026E-05_JPRB, 0.95565805E-05_JPRB, 0.94682812E-05_JPRB, 0.93878761E-05_JPRB, 0.93466061E-05_JPRB, &
  & 0.93136774E-05_JPRB, 0.92762118E-05_JPRB, 0.92340861E-05_JPRB, 0.91803153E-05_JPRB, 0.90848844E-05_JPRB, 0.89553665E-05_JPRB, &
  & 0.88260938E-05_JPRB, 0.86930364E-05_JPRB, 0.85616046E-05_JPRB, 0.84136173E-05_JPRB, 0.82163755E-05_JPRB, 0.79861563E-05_JPRB, &
  & 0.77566366E-05_JPRB, 0.75263759E-05_JPRB, 0.73216858E-05_JPRB, 0.71481702E-05_JPRB, 0.69671157E-05_JPRB, 0.67684881E-05_JPRB, &
  & 0.65809059E-05_JPRB, 0.63728807E-05_JPRB, 0.61692611E-05_JPRB, 0.59570020E-05_JPRB, 0.57110863E-05_JPRB, 0.54639676E-05_JPRB, &
  & 0.52251018E-05_JPRB, 0.50332995E-05_JPRB, 0.49642607E-05_JPRB, 0.49420886E-05_JPRB  /)

RGHG7(:,20, 5) = (/ &
  & 0.31260196E-05_JPRB, 0.31411241E-05_JPRB, 0.31825668E-05_JPRB, 0.32540320E-05_JPRB, 0.33385666E-05_JPRB, 0.34454296E-05_JPRB, &
  & 0.35936487E-05_JPRB, 0.37883513E-05_JPRB, 0.40115875E-05_JPRB, 0.42538777E-05_JPRB, 0.45386182E-05_JPRB, 0.48553856E-05_JPRB, &
  & 0.51580057E-05_JPRB, 0.54161286E-05_JPRB, 0.56295175E-05_JPRB, 0.58082269E-05_JPRB, 0.59686862E-05_JPRB, 0.61681241E-05_JPRB, &
  & 0.64566995E-05_JPRB, 0.67884210E-05_JPRB, 0.71274176E-05_JPRB, 0.73894746E-05_JPRB, 0.75907142E-05_JPRB, 0.77853195E-05_JPRB, &
  & 0.80063873E-05_JPRB, 0.82315252E-05_JPRB, 0.84533014E-05_JPRB, 0.86925768E-05_JPRB, 0.89316764E-05_JPRB, 0.91459412E-05_JPRB, &
  & 0.93041122E-05_JPRB, 0.93625179E-05_JPRB, 0.93287262E-05_JPRB, 0.92480364E-05_JPRB, 0.91869225E-05_JPRB, 0.91562699E-05_JPRB, &
  & 0.91187172E-05_JPRB, 0.90645043E-05_JPRB, 0.90053731E-05_JPRB, 0.89327921E-05_JPRB, 0.88156239E-05_JPRB, 0.86687739E-05_JPRB, &
  & 0.85166477E-05_JPRB, 0.83580125E-05_JPRB, 0.81929557E-05_JPRB, 0.79875864E-05_JPRB, 0.77336472E-05_JPRB, 0.74865730E-05_JPRB, &
  & 0.72528630E-05_JPRB, 0.70298304E-05_JPRB, 0.68414377E-05_JPRB, 0.66769604E-05_JPRB, 0.64989099E-05_JPRB, 0.63188900E-05_JPRB, &
  & 0.61598574E-05_JPRB, 0.59872452E-05_JPRB, 0.58033958E-05_JPRB, 0.56058488E-05_JPRB, 0.53728607E-05_JPRB, 0.51218921E-05_JPRB, &
  & 0.48595466E-05_JPRB, 0.46658210E-05_JPRB, 0.46035985E-05_JPRB, 0.45960764E-05_JPRB  /)

RGHG7(:,21, 5) = (/ &
  & 0.30854939E-05_JPRB, 0.31068375E-05_JPRB, 0.31554275E-05_JPRB, 0.32331615E-05_JPRB, 0.33252264E-05_JPRB, 0.34403146E-05_JPRB, &
  & 0.35956628E-05_JPRB, 0.37951592E-05_JPRB, 0.40122312E-05_JPRB, 0.42444757E-05_JPRB, 0.45170209E-05_JPRB, 0.48201087E-05_JPRB, &
  & 0.51031319E-05_JPRB, 0.53466180E-05_JPRB, 0.55440636E-05_JPRB, 0.56950241E-05_JPRB, 0.58214784E-05_JPRB, 0.59879638E-05_JPRB, &
  & 0.62275632E-05_JPRB, 0.64911495E-05_JPRB, 0.67842277E-05_JPRB, 0.70453773E-05_JPRB, 0.72622455E-05_JPRB, 0.74647715E-05_JPRB, &
  & 0.76898321E-05_JPRB, 0.79171844E-05_JPRB, 0.81343005E-05_JPRB, 0.83626696E-05_JPRB, 0.85620471E-05_JPRB, 0.87209433E-05_JPRB, &
  & 0.88552357E-05_JPRB, 0.89237741E-05_JPRB, 0.89124165E-05_JPRB, 0.88579295E-05_JPRB, 0.88194381E-05_JPRB, 0.87973987E-05_JPRB, &
  & 0.87558188E-05_JPRB, 0.86828370E-05_JPRB, 0.86081806E-05_JPRB, 0.85228735E-05_JPRB, 0.83975747E-05_JPRB, 0.82511695E-05_JPRB, &
  & 0.80927502E-05_JPRB, 0.79272262E-05_JPRB, 0.77401648E-05_JPRB, 0.74918832E-05_JPRB, 0.72085993E-05_JPRB, 0.69631547E-05_JPRB, &
  & 0.67317380E-05_JPRB, 0.65187502E-05_JPRB, 0.63434351E-05_JPRB, 0.61831656E-05_JPRB, 0.60063319E-05_JPRB, 0.58498173E-05_JPRB, &
  & 0.57147665E-05_JPRB, 0.55843954E-05_JPRB, 0.54273377E-05_JPRB, 0.52535586E-05_JPRB, 0.50567191E-05_JPRB, 0.48192950E-05_JPRB, &
  & 0.45501756E-05_JPRB, 0.43634123E-05_JPRB, 0.43002521E-05_JPRB, 0.43001332E-05_JPRB  /)

RGHG7(:,22, 5) = (/ &
  & 0.30342177E-05_JPRB, 0.30612385E-05_JPRB, 0.31149987E-05_JPRB, 0.32003362E-05_JPRB, 0.33029444E-05_JPRB, 0.34284747E-05_JPRB, &
  & 0.35943663E-05_JPRB, 0.37986274E-05_JPRB, 0.40066768E-05_JPRB, 0.42270599E-05_JPRB, 0.44811542E-05_JPRB, 0.47571739E-05_JPRB, &
  & 0.50080601E-05_JPRB, 0.52278236E-05_JPRB, 0.54038782E-05_JPRB, 0.55246279E-05_JPRB, 0.56211755E-05_JPRB, 0.57638369E-05_JPRB, &
  & 0.59582213E-05_JPRB, 0.61506398E-05_JPRB, 0.63710295E-05_JPRB, 0.65997379E-05_JPRB, 0.68083943E-05_JPRB, 0.69981466E-05_JPRB, &
  & 0.71953281E-05_JPRB, 0.74029116E-05_JPRB, 0.75985354E-05_JPRB, 0.77951729E-05_JPRB, 0.79509576E-05_JPRB, 0.80632196E-05_JPRB, &
  & 0.81797707E-05_JPRB, 0.82644283E-05_JPRB, 0.82871340E-05_JPRB, 0.82657978E-05_JPRB, 0.82454532E-05_JPRB, 0.82256442E-05_JPRB, &
  & 0.81737236E-05_JPRB, 0.80847239E-05_JPRB, 0.79993214E-05_JPRB, 0.79147239E-05_JPRB, 0.78047333E-05_JPRB, 0.76857004E-05_JPRB, &
  & 0.75546533E-05_JPRB, 0.74118382E-05_JPRB, 0.72252837E-05_JPRB, 0.69615926E-05_JPRB, 0.66868245E-05_JPRB, 0.64571949E-05_JPRB, &
  & 0.62386533E-05_JPRB, 0.60369186E-05_JPRB, 0.58800544E-05_JPRB, 0.57259690E-05_JPRB, 0.55576510E-05_JPRB, 0.54362135E-05_JPRB, &
  & 0.53165723E-05_JPRB, 0.52166148E-05_JPRB, 0.50931134E-05_JPRB, 0.49514714E-05_JPRB, 0.48041048E-05_JPRB, 0.46095639E-05_JPRB, &
  & 0.43681209E-05_JPRB, 0.42045732E-05_JPRB, 0.41402979E-05_JPRB, 0.41381514E-05_JPRB  /)

RGHG7(:,23, 5) = (/ &
  & 0.29740787E-05_JPRB, 0.30014164E-05_JPRB, 0.30590252E-05_JPRB, 0.31504207E-05_JPRB, 0.32633295E-05_JPRB, 0.33989471E-05_JPRB, &
  & 0.35732844E-05_JPRB, 0.37749371E-05_JPRB, 0.39690267E-05_JPRB, 0.41670255E-05_JPRB, 0.43872674E-05_JPRB, 0.46169318E-05_JPRB, &
  & 0.48233514E-05_JPRB, 0.50049187E-05_JPRB, 0.51438060E-05_JPRB, 0.52342979E-05_JPRB, 0.53074365E-05_JPRB, 0.54218499E-05_JPRB, &
  & 0.55681173E-05_JPRB, 0.56990114E-05_JPRB, 0.58416975E-05_JPRB, 0.60103003E-05_JPRB, 0.61775482E-05_JPRB, 0.63287247E-05_JPRB, &
  & 0.64830483E-05_JPRB, 0.66500584E-05_JPRB, 0.68133420E-05_JPRB, 0.69810021E-05_JPRB, 0.71158281E-05_JPRB, 0.72190064E-05_JPRB, &
  & 0.73393655E-05_JPRB, 0.74379759E-05_JPRB, 0.74816556E-05_JPRB, 0.74745374E-05_JPRB, 0.74479305E-05_JPRB, 0.74088567E-05_JPRB, &
  & 0.73324650E-05_JPRB, 0.72260966E-05_JPRB, 0.71406933E-05_JPRB, 0.70751676E-05_JPRB, 0.70064576E-05_JPRB, 0.69376044E-05_JPRB, &
  & 0.68594388E-05_JPRB, 0.67622459E-05_JPRB, 0.66049822E-05_JPRB, 0.63732245E-05_JPRB, 0.61416734E-05_JPRB, 0.59426962E-05_JPRB, &
  & 0.57564112E-05_JPRB, 0.55866293E-05_JPRB, 0.54618030E-05_JPRB, 0.53329301E-05_JPRB, 0.51971842E-05_JPRB, 0.51092541E-05_JPRB, &
  & 0.50108244E-05_JPRB, 0.49242524E-05_JPRB, 0.48227969E-05_JPRB, 0.47144118E-05_JPRB, 0.46024565E-05_JPRB, 0.44623023E-05_JPRB, &
  & 0.42801459E-05_JPRB, 0.41543341E-05_JPRB, 0.41123120E-05_JPRB, 0.41145339E-05_JPRB  /)

RGHG7(:,24, 5) = (/ &
  & 0.29096611E-05_JPRB, 0.29376906E-05_JPRB, 0.29987135E-05_JPRB, 0.30956481E-05_JPRB, 0.32177466E-05_JPRB, 0.33605032E-05_JPRB, &
  & 0.35376229E-05_JPRB, 0.37298158E-05_JPRB, 0.39049897E-05_JPRB, 0.40738440E-05_JPRB, 0.42523842E-05_JPRB, 0.44293227E-05_JPRB, &
  & 0.45861388E-05_JPRB, 0.47229596E-05_JPRB, 0.48211846E-05_JPRB, 0.48805137E-05_JPRB, 0.49287221E-05_JPRB, 0.50090324E-05_JPRB, &
  & 0.51047624E-05_JPRB, 0.51783230E-05_JPRB, 0.52494525E-05_JPRB, 0.53514568E-05_JPRB, 0.54639246E-05_JPRB, 0.55665468E-05_JPRB, &
  & 0.56725654E-05_JPRB, 0.57925576E-05_JPRB, 0.59211761E-05_JPRB, 0.60642729E-05_JPRB, 0.61891875E-05_JPRB, 0.62987151E-05_JPRB, &
  & 0.64280448E-05_JPRB, 0.65384526E-05_JPRB, 0.65968833E-05_JPRB, 0.65932582E-05_JPRB, 0.65474192E-05_JPRB, 0.64808262E-05_JPRB, &
  & 0.63779463E-05_JPRB, 0.62587334E-05_JPRB, 0.61820176E-05_JPRB, 0.61452158E-05_JPRB, 0.61246454E-05_JPRB, 0.61113566E-05_JPRB, &
  & 0.60895225E-05_JPRB, 0.60420943E-05_JPRB, 0.59252542E-05_JPRB, 0.57405181E-05_JPRB, 0.55613028E-05_JPRB, 0.54028136E-05_JPRB, &
  & 0.52589529E-05_JPRB, 0.51278892E-05_JPRB, 0.50355241E-05_JPRB, 0.49375958E-05_JPRB, 0.48407752E-05_JPRB, 0.47828877E-05_JPRB, &
  & 0.47090377E-05_JPRB, 0.46354370E-05_JPRB, 0.45540735E-05_JPRB, 0.44769225E-05_JPRB, 0.43963961E-05_JPRB, 0.43032419E-05_JPRB, &
  & 0.41813744E-05_JPRB, 0.40946817E-05_JPRB, 0.40750399E-05_JPRB, 0.40839466E-05_JPRB  /)

RGHG7(:,25, 5) = (/ &
  & 0.28425552E-05_JPRB, 0.28731153E-05_JPRB, 0.29369261E-05_JPRB, 0.30385788E-05_JPRB, 0.31675398E-05_JPRB, 0.33119691E-05_JPRB, &
  & 0.34821834E-05_JPRB, 0.36548608E-05_JPRB, 0.38043000E-05_JPRB, 0.39357103E-05_JPRB, 0.40639821E-05_JPRB, 0.41836180E-05_JPRB, &
  & 0.42867343E-05_JPRB, 0.43724717E-05_JPRB, 0.44292210E-05_JPRB, 0.44571966E-05_JPRB, 0.44774400E-05_JPRB, 0.45158027E-05_JPRB, &
  & 0.45596344E-05_JPRB, 0.45836986E-05_JPRB, 0.45985120E-05_JPRB, 0.46316331E-05_JPRB, 0.46755608E-05_JPRB, 0.47199367E-05_JPRB, &
  & 0.47735424E-05_JPRB, 0.48418936E-05_JPRB, 0.49357273E-05_JPRB, 0.50625684E-05_JPRB, 0.51925012E-05_JPRB, 0.53269915E-05_JPRB, &
  & 0.54691886E-05_JPRB, 0.55875313E-05_JPRB, 0.56519667E-05_JPRB, 0.56369325E-05_JPRB, 0.55552365E-05_JPRB, 0.54525721E-05_JPRB, &
  & 0.53240003E-05_JPRB, 0.52008415E-05_JPRB, 0.51453996E-05_JPRB, 0.51490014E-05_JPRB, 0.51807153E-05_JPRB, 0.52249007E-05_JPRB, &
  & 0.52572381E-05_JPRB, 0.52595208E-05_JPRB, 0.51945361E-05_JPRB, 0.50707912E-05_JPRB, 0.49499079E-05_JPRB, 0.48441748E-05_JPRB, &
  & 0.47544857E-05_JPRB, 0.46677286E-05_JPRB, 0.46040577E-05_JPRB, 0.45415575E-05_JPRB, 0.44877567E-05_JPRB, 0.44527731E-05_JPRB, &
  & 0.44070597E-05_JPRB, 0.43489428E-05_JPRB, 0.42858938E-05_JPRB, 0.42347349E-05_JPRB, 0.41803292E-05_JPRB, 0.41163838E-05_JPRB, &
  & 0.40467578E-05_JPRB, 0.39966084E-05_JPRB, 0.39933081E-05_JPRB, 0.40112649E-05_JPRB  /)

RGHG7(:,26, 5) = (/ &
  & 0.27677353E-05_JPRB, 0.27999044E-05_JPRB, 0.28662818E-05_JPRB, 0.29702151E-05_JPRB, 0.31009304E-05_JPRB, 0.32410082E-05_JPRB, &
  & 0.33941421E-05_JPRB, 0.35399954E-05_JPRB, 0.36574786E-05_JPRB, 0.37486117E-05_JPRB, 0.38282615E-05_JPRB, 0.38978296E-05_JPRB, &
  & 0.39564836E-05_JPRB, 0.40008312E-05_JPRB, 0.40224924E-05_JPRB, 0.40235682E-05_JPRB, 0.40170076E-05_JPRB, 0.40212749E-05_JPRB, &
  & 0.40266258E-05_JPRB, 0.40195772E-05_JPRB, 0.39982570E-05_JPRB, 0.39807650E-05_JPRB, 0.39645623E-05_JPRB, 0.39509236E-05_JPRB, &
  & 0.39520822E-05_JPRB, 0.39741083E-05_JPRB, 0.40356088E-05_JPRB, 0.41427238E-05_JPRB, 0.42754256E-05_JPRB, 0.44310738E-05_JPRB, &
  & 0.45841415E-05_JPRB, 0.46976953E-05_JPRB, 0.47537566E-05_JPRB, 0.47304657E-05_JPRB, 0.46342255E-05_JPRB, 0.45136972E-05_JPRB, &
  & 0.43823976E-05_JPRB, 0.42805423E-05_JPRB, 0.42592371E-05_JPRB, 0.43009098E-05_JPRB, 0.43717142E-05_JPRB, 0.44523645E-05_JPRB, &
  & 0.45189884E-05_JPRB, 0.45552374E-05_JPRB, 0.45357439E-05_JPRB, 0.44682176E-05_JPRB, 0.44019101E-05_JPRB, 0.43470749E-05_JPRB, &
  & 0.43034692E-05_JPRB, 0.42550137E-05_JPRB, 0.42153848E-05_JPRB, 0.41840160E-05_JPRB, 0.41608616E-05_JPRB, 0.41460164E-05_JPRB, &
  & 0.41208367E-05_JPRB, 0.40794181E-05_JPRB, 0.40350800E-05_JPRB, 0.40048115E-05_JPRB, 0.39712593E-05_JPRB, 0.39310670E-05_JPRB, &
  & 0.38938941E-05_JPRB, 0.38671007E-05_JPRB, 0.38626817E-05_JPRB, 0.38779217E-05_JPRB  /)

RGHG7(:,27, 5) = (/ &
  & 0.26866491E-05_JPRB, 0.27201590E-05_JPRB, 0.27891376E-05_JPRB, 0.28945516E-05_JPRB, 0.30252069E-05_JPRB, 0.31585014E-05_JPRB, &
  & 0.32900046E-05_JPRB, 0.34051028E-05_JPRB, 0.34868684E-05_JPRB, 0.35348402E-05_JPRB, 0.35642654E-05_JPRB, 0.35841690E-05_JPRB, &
  & 0.35997618E-05_JPRB, 0.36044299E-05_JPRB, 0.35917742E-05_JPRB, 0.35663770E-05_JPRB, 0.35322228E-05_JPRB, 0.35037540E-05_JPRB, &
  & 0.34738476E-05_JPRB, 0.34410863E-05_JPRB, 0.33894712E-05_JPRB, 0.33258365E-05_JPRB, 0.32498844E-05_JPRB, 0.31756758E-05_JPRB, &
  & 0.31219875E-05_JPRB, 0.30975508E-05_JPRB, 0.31261550E-05_JPRB, 0.32113593E-05_JPRB, 0.33461221E-05_JPRB, 0.35224804E-05_JPRB, &
  & 0.36861734E-05_JPRB, 0.37900024E-05_JPRB, 0.38319767E-05_JPRB, 0.38012222E-05_JPRB, 0.36976785E-05_JPRB, 0.35652243E-05_JPRB, &
  & 0.34395874E-05_JPRB, 0.33693677E-05_JPRB, 0.33885224E-05_JPRB, 0.34691343E-05_JPRB, 0.35759163E-05_JPRB, 0.36869016E-05_JPRB, &
  & 0.37819995E-05_JPRB, 0.38479231E-05_JPRB, 0.38736318E-05_JPRB, 0.38631136E-05_JPRB, 0.38524735E-05_JPRB, 0.38501641E-05_JPRB, &
  & 0.38517407E-05_JPRB, 0.38411037E-05_JPRB, 0.38248864E-05_JPRB, 0.38244728E-05_JPRB, 0.38287719E-05_JPRB, 0.38339566E-05_JPRB, &
  & 0.38274260E-05_JPRB, 0.38039162E-05_JPRB, 0.37792879E-05_JPRB, 0.37689692E-05_JPRB, 0.37552668E-05_JPRB, 0.37378857E-05_JPRB, &
  & 0.37273058E-05_JPRB, 0.37200421E-05_JPRB, 0.37079793E-05_JPRB, 0.37160157E-05_JPRB  /)

RGHG7(:,28, 5) = (/ &
  & 0.26954784E-05_JPRB, 0.27240444E-05_JPRB, 0.27835804E-05_JPRB, 0.28725195E-05_JPRB, 0.29808956E-05_JPRB, 0.30870486E-05_JPRB, &
  & 0.31833900E-05_JPRB, 0.32608263E-05_JPRB, 0.33046353E-05_JPRB, 0.33156859E-05_JPRB, 0.33096883E-05_JPRB, 0.32983744E-05_JPRB, &
  & 0.32873416E-05_JPRB, 0.32701983E-05_JPRB, 0.32398595E-05_JPRB, 0.32012042E-05_JPRB, 0.31528516E-05_JPRB, 0.31053010E-05_JPRB, &
  & 0.30593677E-05_JPRB, 0.30118510E-05_JPRB, 0.29483383E-05_JPRB, 0.28677507E-05_JPRB, 0.27670900E-05_JPRB, 0.26603056E-05_JPRB, &
  & 0.25673775E-05_JPRB, 0.25071845E-05_JPRB, 0.25024250E-05_JPRB, 0.25567557E-05_JPRB, 0.26697544E-05_JPRB, 0.28302774E-05_JPRB, &
  & 0.29838141E-05_JPRB, 0.30830113E-05_JPRB, 0.31223569E-05_JPRB, 0.30997581E-05_JPRB, 0.30120124E-05_JPRB, 0.29006357E-05_JPRB, &
  & 0.28138489E-05_JPRB, 0.27919827E-05_JPRB, 0.28483010E-05_JPRB, 0.29515418E-05_JPRB, 0.30651995E-05_JPRB, 0.31743063E-05_JPRB, &
  & 0.32708058E-05_JPRB, 0.33478724E-05_JPRB, 0.33976680E-05_JPRB, 0.34224242E-05_JPRB, 0.34475203E-05_JPRB, 0.34743333E-05_JPRB, &
  & 0.35023698E-05_JPRB, 0.35192810E-05_JPRB, 0.35282693E-05_JPRB, 0.35454067E-05_JPRB, 0.35637826E-05_JPRB, 0.35796647E-05_JPRB, &
  & 0.35850056E-05_JPRB, 0.35775711E-05_JPRB, 0.35714958E-05_JPRB, 0.35752744E-05_JPRB, 0.35740882E-05_JPRB, 0.35714147E-05_JPRB, &
  & 0.35715247E-05_JPRB, 0.35741088E-05_JPRB, 0.35673561E-05_JPRB, 0.35709097E-05_JPRB  /)

RGHG7(:,29, 5) = (/ &
  & 0.27087322E-05_JPRB, 0.27317874E-05_JPRB, 0.27807961E-05_JPRB, 0.28514999E-05_JPRB, 0.29353062E-05_JPRB, 0.30118177E-05_JPRB, &
  & 0.30703156E-05_JPRB, 0.31075464E-05_JPRB, 0.31110403E-05_JPRB, 0.30832403E-05_JPRB, 0.30403512E-05_JPRB, 0.29967595E-05_JPRB, &
  & 0.29582275E-05_JPRB, 0.29187478E-05_JPRB, 0.28703935E-05_JPRB, 0.28182632E-05_JPRB, 0.27554469E-05_JPRB, 0.26882696E-05_JPRB, &
  & 0.26261882E-05_JPRB, 0.25635122E-05_JPRB, 0.24881905E-05_JPRB, 0.23909056E-05_JPRB, 0.22655834E-05_JPRB, 0.21254959E-05_JPRB, &
  & 0.19916667E-05_JPRB, 0.18940512E-05_JPRB, 0.18539198E-05_JPRB, 0.18751488E-05_JPRB, 0.19640536E-05_JPRB, 0.21062133E-05_JPRB, &
  & 0.22480875E-05_JPRB, 0.23425977E-05_JPRB, 0.23796547E-05_JPRB, 0.23663750E-05_JPRB, 0.22963701E-05_JPRB, 0.22087578E-05_JPRB, &
  & 0.21645748E-05_JPRB, 0.21946679E-05_JPRB, 0.22902213E-05_JPRB, 0.24167321E-05_JPRB, 0.25364133E-05_JPRB, 0.26421331E-05_JPRB, &
  & 0.27389438E-05_JPRB, 0.28270137E-05_JPRB, 0.29014159E-05_JPRB, 0.29626059E-05_JPRB, 0.30247035E-05_JPRB, 0.30813592E-05_JPRB, &
  & 0.31366204E-05_JPRB, 0.31822759E-05_JPRB, 0.32180495E-05_JPRB, 0.32532023E-05_JPRB, 0.32859138E-05_JPRB, 0.33127260E-05_JPRB, &
  & 0.33303519E-05_JPRB, 0.33398710E-05_JPRB, 0.33534041E-05_JPRB, 0.33718660E-05_JPRB, 0.33836239E-05_JPRB, 0.33961831E-05_JPRB, &
  & 0.34069303E-05_JPRB, 0.34195291E-05_JPRB, 0.34189647E-05_JPRB, 0.34178862E-05_JPRB  /)

RGHG7(:,30, 5) = (/ &
  & 0.26382334E-05_JPRB, 0.26584368E-05_JPRB, 0.26991851E-05_JPRB, 0.27551559E-05_JPRB, 0.28193662E-05_JPRB, 0.28724654E-05_JPRB, &
  & 0.29063051E-05_JPRB, 0.29165436E-05_JPRB, 0.28943637E-05_JPRB, 0.28444781E-05_JPRB, 0.27823519E-05_JPRB, 0.27211677E-05_JPRB, &
  & 0.26666881E-05_JPRB, 0.26173613E-05_JPRB, 0.25630719E-05_JPRB, 0.25050268E-05_JPRB, 0.24375975E-05_JPRB, 0.23601090E-05_JPRB, &
  & 0.22875587E-05_JPRB, 0.22120504E-05_JPRB, 0.21261832E-05_JPRB, 0.20252966E-05_JPRB, 0.19036354E-05_JPRB, 0.17690507E-05_JPRB, &
  & 0.16355386E-05_JPRB, 0.15290112E-05_JPRB, 0.14717349E-05_JPRB, 0.14668786E-05_JPRB, 0.15182063E-05_JPRB, 0.16203815E-05_JPRB, &
  & 0.17328121E-05_JPRB, 0.18109288E-05_JPRB, 0.18434965E-05_JPRB, 0.18407439E-05_JPRB, 0.18051258E-05_JPRB, 0.17627139E-05_JPRB, &
  & 0.17619790E-05_JPRB, 0.18206031E-05_JPRB, 0.19242818E-05_JPRB, 0.20452809E-05_JPRB, 0.21497845E-05_JPRB, 0.22461727E-05_JPRB, &
  & 0.23379656E-05_JPRB, 0.24284097E-05_JPRB, 0.25146395E-05_JPRB, 0.25945354E-05_JPRB, 0.26765939E-05_JPRB, 0.27506308E-05_JPRB, &
  & 0.28202792E-05_JPRB, 0.28825107E-05_JPRB, 0.29357431E-05_JPRB, 0.29836826E-05_JPRB, 0.30265396E-05_JPRB, 0.30635909E-05_JPRB, &
  & 0.30902669E-05_JPRB, 0.31113655E-05_JPRB, 0.31364964E-05_JPRB, 0.31609225E-05_JPRB, 0.31770186E-05_JPRB, 0.31938375E-05_JPRB, &
  & 0.32097411E-05_JPRB, 0.32243754E-05_JPRB, 0.32289956E-05_JPRB, 0.32284437E-05_JPRB  /)

RGHG7(:,31, 5) = (/ &
  & 0.25638725E-05_JPRB, 0.25810737E-05_JPRB, 0.26131205E-05_JPRB, 0.26535712E-05_JPRB, 0.26971389E-05_JPRB, 0.27255755E-05_JPRB, &
  & 0.27334466E-05_JPRB, 0.27152569E-05_JPRB, 0.26660398E-05_JPRB, 0.25928995E-05_JPRB, 0.25105208E-05_JPRB, 0.24308142E-05_JPRB, &
  & 0.23595424E-05_JPRB, 0.22998518E-05_JPRB, 0.22393205E-05_JPRB, 0.21750503E-05_JPRB, 0.21027700E-05_JPRB, 0.20144259E-05_JPRB, &
  & 0.19308503E-05_JPRB, 0.18418234E-05_JPRB, 0.17448462E-05_JPRB, 0.16401771E-05_JPRB, 0.15224001E-05_JPRB, 0.13936503E-05_JPRB, &
  & 0.12605113E-05_JPRB, 0.11446210E-05_JPRB, 0.10692973E-05_JPRB, 0.10369627E-05_JPRB, 0.10486845E-05_JPRB, 0.11087094E-05_JPRB, &
  & 0.11900997E-05_JPRB, 0.12509323E-05_JPRB, 0.12787676E-05_JPRB, 0.12871080E-05_JPRB, 0.12877375E-05_JPRB, 0.12929715E-05_JPRB, &
  & 0.13380168E-05_JPRB, 0.14266804E-05_JPRB, 0.15388909E-05_JPRB, 0.16540551E-05_JPRB, 0.17425466E-05_JPRB, 0.18290970E-05_JPRB, &
  & 0.19155978E-05_JPRB, 0.20085353E-05_JPRB, 0.21072150E-05_JPRB, 0.22068038E-05_JPRB, 0.23098780E-05_JPRB, 0.24022168E-05_JPRB, &
  & 0.24870121E-05_JPRB, 0.25666974E-05_JPRB, 0.26383165E-05_JPRB, 0.26997237E-05_JPRB, 0.27532667E-05_JPRB, 0.28011058E-05_JPRB, &
  & 0.28373143E-05_JPRB, 0.28706085E-05_JPRB, 0.29079520E-05_JPRB, 0.29386540E-05_JPRB, 0.29593128E-05_JPRB, 0.29806097E-05_JPRB, &
  & 0.30019411E-05_JPRB, 0.30187126E-05_JPRB, 0.30287945E-05_JPRB, 0.30288023E-05_JPRB  /)

RGHG7(:,32, 5) = (/ &
  & 0.24761028E-05_JPRB, 0.24859941E-05_JPRB, 0.25067136E-05_JPRB, 0.25314496E-05_JPRB, 0.25558678E-05_JPRB, 0.25648461E-05_JPRB, &
  & 0.25545614E-05_JPRB, 0.25166329E-05_JPRB, 0.24502750E-05_JPRB, 0.23626385E-05_JPRB, 0.22694688E-05_JPRB, 0.21811018E-05_JPRB, &
  & 0.21015932E-05_JPRB, 0.20362487E-05_JPRB, 0.19735513E-05_JPRB, 0.19073217E-05_JPRB, 0.18327835E-05_JPRB, 0.17411205E-05_JPRB, &
  & 0.16521045E-05_JPRB, 0.15575110E-05_JPRB, 0.14543603E-05_JPRB, 0.13481252E-05_JPRB, 0.12374008E-05_JPRB, 0.11219546E-05_JPRB, &
  & 0.10084369E-05_JPRB, 0.90781222E-06_JPRB, 0.83294689E-06_JPRB, 0.78923931E-06_JPRB, 0.77897343E-06_JPRB, 0.80718471E-06_JPRB, &
  & 0.85842913E-06_JPRB, 0.90235480E-06_JPRB, 0.92914698E-06_JPRB, 0.95075918E-06_JPRB, 0.97471095E-06_JPRB, 0.10060047E-05_JPRB, &
  & 0.10657885E-05_JPRB, 0.11507344E-05_JPRB, 0.12457166E-05_JPRB, 0.13413509E-05_JPRB, 0.14179100E-05_JPRB, 0.14976358E-05_JPRB, &
  & 0.15845061E-05_JPRB, 0.16828265E-05_JPRB, 0.17892209E-05_JPRB, 0.18960296E-05_JPRB, 0.20084229E-05_JPRB, 0.21128794E-05_JPRB, &
  & 0.22079548E-05_JPRB, 0.22944481E-05_JPRB, 0.23748628E-05_JPRB, 0.24485214E-05_JPRB, 0.25098977E-05_JPRB, 0.25663733E-05_JPRB, &
  & 0.26100279E-05_JPRB, 0.26511725E-05_JPRB, 0.26940607E-05_JPRB, 0.27270145E-05_JPRB, 0.27495169E-05_JPRB, 0.27718150E-05_JPRB, &
  & 0.27969427E-05_JPRB, 0.28130362E-05_JPRB, 0.28247881E-05_JPRB, 0.28319171E-05_JPRB  /)

RGHG7(:,33, 5) = (/ &
  & 0.23831523E-05_JPRB, 0.23848892E-05_JPRB, 0.23934968E-05_JPRB, 0.24018761E-05_JPRB, 0.24065865E-05_JPRB, 0.23960166E-05_JPRB, &
  & 0.23678753E-05_JPRB, 0.23105581E-05_JPRB, 0.22276680E-05_JPRB, 0.21261005E-05_JPRB, 0.20229412E-05_JPRB, 0.19268506E-05_JPRB, &
  & 0.18398898E-05_JPRB, 0.17692793E-05_JPRB, 0.17048584E-05_JPRB, 0.16371448E-05_JPRB, 0.15605959E-05_JPRB, 0.14664594E-05_JPRB, &
  & 0.13725125E-05_JPRB, 0.12731636E-05_JPRB, 0.11642362E-05_JPRB, 0.10566607E-05_JPRB, 0.95367574E-06_JPRB, 0.85302240E-06_JPRB, &
  & 0.76238801E-06_JPRB, 0.68081688E-06_JPRB, 0.60882394E-06_JPRB, 0.55538215E-06_JPRB, 0.52454677E-06_JPRB, 0.52103410E-06_JPRB, &
  & 0.54106523E-06_JPRB, 0.56746932E-06_JPRB, 0.59365511E-06_JPRB, 0.62934201E-06_JPRB, 0.67585800E-06_JPRB, 0.73143938E-06_JPRB, &
  & 0.80252130E-06_JPRB, 0.87923303E-06_JPRB, 0.95297549E-06_JPRB, 0.10265402E-05_JPRB, 0.10912268E-05_JPRB, 0.11642504E-05_JPRB, &
  & 0.12522377E-05_JPRB, 0.13565263E-05_JPRB, 0.14703251E-05_JPRB, 0.15830221E-05_JPRB, 0.17035858E-05_JPRB, 0.18198351E-05_JPRB, &
  & 0.19249638E-05_JPRB, 0.20171540E-05_JPRB, 0.21054678E-05_JPRB, 0.21917010E-05_JPRB, 0.22608488E-05_JPRB, 0.23260213E-05_JPRB, &
  & 0.23771442E-05_JPRB, 0.24258846E-05_JPRB, 0.24736718E-05_JPRB, 0.25084448E-05_JPRB, 0.25325111E-05_JPRB, 0.25553996E-05_JPRB, &
  & 0.25842614E-05_JPRB, 0.25992857E-05_JPRB, 0.26122824E-05_JPRB, 0.26276615E-05_JPRB  /)

RGHG7(:,34, 5) = (/ &
  & 0.22599675E-05_JPRB, 0.22564820E-05_JPRB, 0.22585208E-05_JPRB, 0.22561222E-05_JPRB, 0.22484587E-05_JPRB, 0.22269995E-05_JPRB, &
  & 0.21872831E-05_JPRB, 0.21183899E-05_JPRB, 0.20263161E-05_JPRB, 0.19162386E-05_JPRB, 0.18085141E-05_JPRB, 0.17092372E-05_JPRB, &
  & 0.16199298E-05_JPRB, 0.15462210E-05_JPRB, 0.14810438E-05_JPRB, 0.14137872E-05_JPRB, 0.13383463E-05_JPRB, 0.12461149E-05_JPRB, &
  & 0.11534757E-05_JPRB, 0.10557141E-05_JPRB, 0.94781299E-06_JPRB, 0.84253896E-06_JPRB, 0.74497458E-06_JPRB, 0.65458805E-06_JPRB, &
  & 0.57858578E-06_JPRB, 0.51248536E-06_JPRB, 0.45167115E-06_JPRB, 0.40241516E-06_JPRB, 0.36839199E-06_JPRB, 0.35297232E-06_JPRB, &
  & 0.35742344E-06_JPRB, 0.37303654E-06_JPRB, 0.39591720E-06_JPRB, 0.43240859E-06_JPRB, 0.48201748E-06_JPRB, 0.53938247E-06_JPRB, &
  & 0.60409954E-06_JPRB, 0.66742468E-06_JPRB, 0.72518955E-06_JPRB, 0.78548834E-06_JPRB, 0.84661612E-06_JPRB, 0.91826335E-06_JPRB, &
  & 0.10052775E-05_JPRB, 0.11091224E-05_JPRB, 0.12215530E-05_JPRB, 0.13326652E-05_JPRB, 0.14539315E-05_JPRB, 0.15753272E-05_JPRB, &
  & 0.16864354E-05_JPRB, 0.17818097E-05_JPRB, 0.18723691E-05_JPRB, 0.19639994E-05_JPRB, 0.20365031E-05_JPRB, 0.21037257E-05_JPRB, &
  & 0.21578153E-05_JPRB, 0.22103817E-05_JPRB, 0.22608856E-05_JPRB, 0.22971097E-05_JPRB, 0.23233491E-05_JPRB, 0.23467994E-05_JPRB, &
  & 0.23783455E-05_JPRB, 0.23934174E-05_JPRB, 0.24067708E-05_JPRB, 0.24263762E-05_JPRB  /)

RGHG7(:,35, 5) = (/ &
  & 0.21178031E-05_JPRB, 0.21104528E-05_JPRB, 0.21085823E-05_JPRB, 0.20979654E-05_JPRB, 0.20813431E-05_JPRB, 0.20531316E-05_JPRB, &
  & 0.20047378E-05_JPRB, 0.19279521E-05_JPRB, 0.18302069E-05_JPRB, 0.17141618E-05_JPRB, 0.16045271E-05_JPRB, 0.15043025E-05_JPRB, &
  & 0.14152025E-05_JPRB, 0.13394206E-05_JPRB, 0.12739620E-05_JPRB, 0.12081714E-05_JPRB, 0.11354699E-05_JPRB, 0.10474439E-05_JPRB, &
  & 0.95935078E-06_JPRB, 0.86647576E-06_JPRB, 0.76312060E-06_JPRB, 0.66208160E-06_JPRB, 0.56890033E-06_JPRB, 0.48674694E-06_JPRB, &
  & 0.42155437E-06_JPRB, 0.36952137E-06_JPRB, 0.32446267E-06_JPRB, 0.28665311E-06_JPRB, 0.25827172E-06_JPRB, 0.24077896E-06_JPRB, &
  & 0.23723386E-06_JPRB, 0.24520613E-06_JPRB, 0.26330387E-06_JPRB, 0.29381290E-06_JPRB, 0.33661020E-06_JPRB, 0.38426127E-06_JPRB, &
  & 0.43337091E-06_JPRB, 0.48028900E-06_JPRB, 0.52432703E-06_JPRB, 0.57550421E-06_JPRB, 0.63723912E-06_JPRB, 0.71020424E-06_JPRB, &
  & 0.79514533E-06_JPRB, 0.89524379E-06_JPRB, 0.10017661E-05_JPRB, 0.11074142E-05_JPRB, 0.12255709E-05_JPRB, 0.13488471E-05_JPRB, &
  & 0.14640128E-05_JPRB, 0.15613713E-05_JPRB, 0.16513383E-05_JPRB, 0.17448344E-05_JPRB, 0.18185228E-05_JPRB, 0.18844423E-05_JPRB, &
  & 0.19392723E-05_JPRB, 0.19938377E-05_JPRB, 0.20460149E-05_JPRB, 0.20835421E-05_JPRB, 0.21123284E-05_JPRB, 0.21363414E-05_JPRB, &
  & 0.21701087E-05_JPRB, 0.21858025E-05_JPRB, 0.21990670E-05_JPRB, 0.22209529E-05_JPRB  /)

RGHG7(:,36, 5) = (/ &
  & 0.19578558E-05_JPRB, 0.19487316E-05_JPRB, 0.19449541E-05_JPRB, 0.19296174E-05_JPRB, 0.19080503E-05_JPRB, 0.18763118E-05_JPRB, &
  & 0.18225762E-05_JPRB, 0.17417886E-05_JPRB, 0.16409323E-05_JPRB, 0.15217141E-05_JPRB, 0.14119254E-05_JPRB, 0.13120946E-05_JPRB, &
  & 0.12245676E-05_JPRB, 0.11480972E-05_JPRB, 0.10830822E-05_JPRB, 0.10196437E-05_JPRB, 0.95046058E-06_JPRB, 0.86813153E-06_JPRB, &
  & 0.78574015E-06_JPRB, 0.69867316E-06_JPRB, 0.60130746E-06_JPRB, 0.50571565E-06_JPRB, 0.41837862E-06_JPRB, 0.34484420E-06_JPRB, &
  & 0.28969722E-06_JPRB, 0.25003030E-06_JPRB, 0.21871769E-06_JPRB, 0.19166796E-06_JPRB, 0.16960096E-06_JPRB, 0.15238448E-06_JPRB, &
  & 0.14389219E-06_JPRB, 0.14605663E-06_JPRB, 0.15919849E-06_JPRB, 0.18297793E-06_JPRB, 0.21775470E-06_JPRB, 0.25541430E-06_JPRB, &
  & 0.29102257E-06_JPRB, 0.32489581E-06_JPRB, 0.35823546E-06_JPRB, 0.40156373E-06_JPRB, 0.46140646E-06_JPRB, 0.53277651E-06_JPRB, &
  & 0.61412212E-06_JPRB, 0.70913714E-06_JPRB, 0.80821647E-06_JPRB, 0.90765946E-06_JPRB, 0.10208037E-05_JPRB, 0.11435232E-05_JPRB, &
  & 0.12605062E-05_JPRB, 0.13586552E-05_JPRB, 0.14468097E-05_JPRB, 0.15391166E-05_JPRB, 0.16123508E-05_JPRB, 0.16755683E-05_JPRB, &
  & 0.17295020E-05_JPRB, 0.17851180E-05_JPRB, 0.18396507E-05_JPRB, 0.18784793E-05_JPRB, 0.19087770E-05_JPRB, 0.19333543E-05_JPRB, &
  & 0.19688969E-05_JPRB, 0.19854975E-05_JPRB, 0.19981489E-05_JPRB, 0.20212851E-05_JPRB  /)

RGHG7(:,37, 5) = (/ &
  & 0.17670882E-05_JPRB, 0.17610943E-05_JPRB, 0.17601191E-05_JPRB, 0.17483776E-05_JPRB, 0.17313762E-05_JPRB, 0.17037249E-05_JPRB, &
  & 0.16526276E-05_JPRB, 0.15770071E-05_JPRB, 0.14791034E-05_JPRB, 0.13633163E-05_JPRB, 0.12574099E-05_JPRB, 0.11610238E-05_JPRB, &
  & 0.10781035E-05_JPRB, 0.10041620E-05_JPRB, 0.94122473E-06_JPRB, 0.88202387E-06_JPRB, 0.81792586E-06_JPRB, 0.74435908E-06_JPRB, &
  & 0.66996446E-06_JPRB, 0.59045682E-06_JPRB, 0.50201743E-06_JPRB, 0.41431303E-06_JPRB, 0.33580662E-06_JPRB, 0.27123951E-06_JPRB, &
  & 0.22376123E-06_JPRB, 0.19179034E-06_JPRB, 0.16876156E-06_JPRB, 0.15022806E-06_JPRB, 0.13562470E-06_JPRB, 0.12405381E-06_JPRB, &
  & 0.11791271E-06_JPRB, 0.11883320E-06_JPRB, 0.12693094E-06_JPRB, 0.14268628E-06_JPRB, 0.16716977E-06_JPRB, 0.19482315E-06_JPRB, &
  & 0.22259870E-06_JPRB, 0.25194727E-06_JPRB, 0.28219757E-06_JPRB, 0.32108319E-06_JPRB, 0.37342126E-06_JPRB, 0.43661683E-06_JPRB, &
  & 0.51110026E-06_JPRB, 0.59828254E-06_JPRB, 0.68686355E-06_JPRB, 0.77878821E-06_JPRB, 0.88286943E-06_JPRB, 0.99947859E-06_JPRB, &
  & 0.11130306E-05_JPRB, 0.12091838E-05_JPRB, 0.12928410E-05_JPRB, 0.13770280E-05_JPRB, 0.14460793E-05_JPRB, 0.15035555E-05_JPRB, &
  & 0.15528962E-05_JPRB, 0.16073230E-05_JPRB, 0.16656285E-05_JPRB, 0.17056736E-05_JPRB, 0.17350145E-05_JPRB, 0.17601249E-05_JPRB, &
  & 0.17963100E-05_JPRB, 0.18144143E-05_JPRB, 0.18252886E-05_JPRB, 0.18472355E-05_JPRB  /)

RGHG7(:,38, 5) = (/ &
  & 0.15554146E-05_JPRB, 0.15528942E-05_JPRB, 0.15550283E-05_JPRB, 0.15472759E-05_JPRB, 0.15353405E-05_JPRB, 0.15122244E-05_JPRB, &
  & 0.14640544E-05_JPRB, 0.13941674E-05_JPRB, 0.12995399E-05_JPRB, 0.11875599E-05_JPRB, 0.10859611E-05_JPRB, 0.99339729E-06_JPRB, &
  & 0.91558854E-06_JPRB, 0.84445307E-06_JPRB, 0.78382129E-06_JPRB, 0.72932244E-06_JPRB, 0.67086682E-06_JPRB, 0.60702256E-06_JPRB, &
  & 0.54150107E-06_JPRB, 0.47038118E-06_JPRB, 0.39184632E-06_JPRB, 0.31289370E-06_JPRB, 0.24418565E-06_JPRB, 0.18956857E-06_JPRB, &
  & 0.15059939E-06_JPRB, 0.12716794E-06_JPRB, 0.11333081E-06_JPRB, 0.10424680E-06_JPRB, 0.97925029E-07_JPRB, 0.92618411E-07_JPRB, &
  & 0.89086161E-07_JPRB, 0.88626390E-07_JPRB, 0.91127237E-07_JPRB, 0.97979115E-07_JPRB, 0.11104130E-06_JPRB, 0.12759190E-06_JPRB, &
  & 0.14667633E-06_JPRB, 0.17100439E-06_JPRB, 0.19782678E-06_JPRB, 0.23178288E-06_JPRB, 0.27579387E-06_JPRB, 0.32991914E-06_JPRB, &
  & 0.39678836E-06_JPRB, 0.47527953E-06_JPRB, 0.55221172E-06_JPRB, 0.63579413E-06_JPRB, 0.72981914E-06_JPRB, 0.83964832E-06_JPRB, &
  & 0.94939318E-06_JPRB, 0.10433319E-05_JPRB, 0.11219989E-05_JPRB, 0.11971763E-05_JPRB, 0.12615863E-05_JPRB, 0.13126921E-05_JPRB, &
  & 0.13569364E-05_JPRB, 0.14100436E-05_JPRB, 0.14725353E-05_JPRB, 0.15139305E-05_JPRB, 0.15422096E-05_JPRB, 0.15679116E-05_JPRB, &
  & 0.16048095E-05_JPRB, 0.16245822E-05_JPRB, 0.16334848E-05_JPRB, 0.16541120E-05_JPRB  /)

RGHG7(:,39, 5) = (/ &
  & 0.13766797E-05_JPRB, 0.13743878E-05_JPRB, 0.13789097E-05_JPRB, 0.13788893E-05_JPRB, 0.13752213E-05_JPRB, 0.13583875E-05_JPRB, &
  & 0.13181032E-05_JPRB, 0.12576343E-05_JPRB, 0.11714044E-05_JPRB, 0.10677231E-05_JPRB, 0.97283702E-06_JPRB, 0.88581377E-06_JPRB, &
  & 0.81326693E-06_JPRB, 0.74672947E-06_JPRB, 0.69017626E-06_JPRB, 0.63987463E-06_JPRB, 0.58680043E-06_JPRB, 0.53032046E-06_JPRB, &
  & 0.47214662E-06_JPRB, 0.40845682E-06_JPRB, 0.33812674E-06_JPRB, 0.26668148E-06_JPRB, 0.20536882E-06_JPRB, 0.15843843E-06_JPRB, &
  & 0.12634689E-06_JPRB, 0.10765853E-06_JPRB, 0.97215152E-07_JPRB, 0.90749138E-07_JPRB, 0.86204263E-07_JPRB, 0.82133173E-07_JPRB, &
  & 0.79181938E-07_JPRB, 0.78498747E-07_JPRB, 0.79780262E-07_JPRB, 0.83840941E-07_JPRB, 0.92680202E-07_JPRB, 0.10505776E-06_JPRB, &
  & 0.12055876E-06_JPRB, 0.14189429E-06_JPRB, 0.16670450E-06_JPRB, 0.19766832E-06_JPRB, 0.23714765E-06_JPRB, 0.28548302E-06_JPRB, &
  & 0.34695868E-06_JPRB, 0.41721899E-06_JPRB, 0.48824217E-06_JPRB, 0.56623285E-06_JPRB, 0.65403096E-06_JPRB, 0.75644131E-06_JPRB, &
  & 0.85906559E-06_JPRB, 0.94949324E-06_JPRB, 0.10237969E-05_JPRB, 0.10905844E-05_JPRB, 0.11481100E-05_JPRB, 0.11956108E-05_JPRB, &
  & 0.12356205E-05_JPRB, 0.12857298E-05_JPRB, 0.13469010E-05_JPRB, 0.13870866E-05_JPRB, 0.14140140E-05_JPRB, 0.14408138E-05_JPRB, &
  & 0.14775263E-05_JPRB, 0.14964449E-05_JPRB, 0.15033716E-05_JPRB, 0.15195063E-05_JPRB  /)

RGHG7(:,40, 5) = (/ &
  & 0.11723080E-05_JPRB, 0.11697536E-05_JPRB, 0.11769597E-05_JPRB, 0.11866257E-05_JPRB, 0.11931839E-05_JPRB, 0.11840088E-05_JPRB, &
  & 0.11537903E-05_JPRB, 0.11049771E-05_JPRB, 0.10294402E-05_JPRB, 0.93623317E-06_JPRB, 0.84961845E-06_JPRB, 0.76937862E-06_JPRB, &
  & 0.70303169E-06_JPRB, 0.64218354E-06_JPRB, 0.59070696E-06_JPRB, 0.54524855E-06_JPRB, 0.49844718E-06_JPRB, 0.45022402E-06_JPRB, &
  & 0.40042370E-06_JPRB, 0.34529705E-06_JPRB, 0.28431787E-06_JPRB, 0.22147953E-06_JPRB, 0.16845286E-06_JPRB, 0.13017315E-06_JPRB, &
  & 0.10588619E-06_JPRB, 0.92143170E-07_JPRB, 0.84734092E-07_JPRB, 0.80222871E-07_JPRB, 0.76699155E-07_JPRB, 0.73255349E-07_JPRB, &
  & 0.70654226E-07_JPRB, 0.69898096E-07_JPRB, 0.70464798E-07_JPRB, 0.72249750E-07_JPRB, 0.77310718E-07_JPRB, 0.85924568E-07_JPRB, &
  & 0.98055742E-07_JPRB, 0.11621109E-06_JPRB, 0.13889146E-06_JPRB, 0.16666050E-06_JPRB, 0.20144249E-06_JPRB, 0.24351961E-06_JPRB, &
  & 0.29902878E-06_JPRB, 0.35970477E-06_JPRB, 0.42473229E-06_JPRB, 0.49661059E-06_JPRB, 0.57772740E-06_JPRB, 0.67132659E-06_JPRB, &
  & 0.76505220E-06_JPRB, 0.85114722E-06_JPRB, 0.92043256E-06_JPRB, 0.97747532E-06_JPRB, 0.10265544E-05_JPRB, 0.10702769E-05_JPRB, &
  & 0.11054581E-05_JPRB, 0.11517744E-05_JPRB, 0.12104948E-05_JPRB, 0.12488424E-05_JPRB, 0.12741359E-05_JPRB, 0.13023071E-05_JPRB, &
  & 0.13386548E-05_JPRB, 0.13561584E-05_JPRB, 0.13607656E-05_JPRB, 0.13711089E-05_JPRB  /)

RGHG7(:,41, 5) = (/ &
  & 0.92243414E-06_JPRB, 0.91955866E-06_JPRB, 0.93004659E-06_JPRB, 0.95155566E-06_JPRB, 0.97061682E-06_JPRB, 0.97080558E-06_JPRB, &
  & 0.95289387E-06_JPRB, 0.91833165E-06_JPRB, 0.85586848E-06_JPRB, 0.77546764E-06_JPRB, 0.69896590E-06_JPRB, 0.62701978E-06_JPRB, &
  & 0.56825313E-06_JPRB, 0.51436100E-06_JPRB, 0.46909133E-06_JPRB, 0.42955445E-06_JPRB, 0.39042253E-06_JPRB, 0.35229452E-06_JPRB, &
  & 0.31273203E-06_JPRB, 0.26807508E-06_JPRB, 0.21852874E-06_JPRB, 0.16621361E-06_JPRB, 0.12331775E-06_JPRB, 0.95614757E-07_JPRB, &
  & 0.80870026E-07_JPRB, 0.73173390E-07_JPRB, 0.69474188E-07_JPRB, 0.67352983E-07_JPRB, 0.65077784E-07_JPRB, 0.62400924E-07_JPRB, &
  & 0.60227863E-07_JPRB, 0.59382553E-07_JPRB, 0.59075294E-07_JPRB, 0.58077839E-07_JPRB, 0.58519298E-07_JPRB, 0.62531474E-07_JPRB, &
  & 0.70542546E-07_JPRB, 0.84809661E-07_JPRB, 0.10488598E-06_JPRB, 0.12874895E-06_JPRB, 0.15778777E-06_JPRB, 0.19221327E-06_JPRB, &
  & 0.24042754E-06_JPRB, 0.28938531E-06_JPRB, 0.34708225E-06_JPRB, 0.41148730E-06_JPRB, 0.48443525E-06_JPRB, 0.56726153E-06_JPRB, &
  & 0.65010721E-06_JPRB, 0.73090495E-06_JPRB, 0.79405473E-06_JPRB, 0.83918307E-06_JPRB, 0.87793519E-06_JPRB, 0.91703818E-06_JPRB, &
  & 0.94631563E-06_JPRB, 0.98799463E-06_JPRB, 0.10437186E-05_JPRB, 0.10798189E-05_JPRB, 0.11031147E-05_JPRB, 0.11329624E-05_JPRB, &
  & 0.11688642E-05_JPRB, 0.11846378E-05_JPRB, 0.11864091E-05_JPRB, 0.11896715E-05_JPRB  /)

RGHG7(:,42, 5) = (/ &
  & 0.84435240E-06_JPRB, 0.84088589E-06_JPRB, 0.84730050E-06_JPRB, 0.86801797E-06_JPRB, 0.88677664E-06_JPRB, 0.88867315E-06_JPRB, &
  & 0.87492871E-06_JPRB, 0.84829336E-06_JPRB, 0.79732985E-06_JPRB, 0.72739781E-06_JPRB, 0.65878763E-06_JPRB, 0.59289113E-06_JPRB, &
  & 0.53791687E-06_JPRB, 0.48916238E-06_JPRB, 0.44680921E-06_JPRB, 0.41004378E-06_JPRB, 0.37442118E-06_JPRB, 0.33909275E-06_JPRB, &
  & 0.30253252E-06_JPRB, 0.26091316E-06_JPRB, 0.21437456E-06_JPRB, 0.16584311E-06_JPRB, 0.12592284E-06_JPRB, 0.99567919E-07_JPRB, &
  & 0.84219653E-07_JPRB, 0.75677867E-07_JPRB, 0.71020237E-07_JPRB, 0.67830099E-07_JPRB, 0.64705960E-07_JPRB, 0.61397557E-07_JPRB, &
  & 0.59003401E-07_JPRB, 0.58180852E-07_JPRB, 0.58025304E-07_JPRB, 0.57741849E-07_JPRB, 0.59358472E-07_JPRB, 0.64450631E-07_JPRB, &
  & 0.72697586E-07_JPRB, 0.85702887E-07_JPRB, 0.10356486E-06_JPRB, 0.12714822E-06_JPRB, 0.15594436E-06_JPRB, 0.19075697E-06_JPRB, &
  & 0.23808139E-06_JPRB, 0.28844682E-06_JPRB, 0.34421981E-06_JPRB, 0.40845544E-06_JPRB, 0.48303707E-06_JPRB, 0.56446316E-06_JPRB, &
  & 0.64435860E-06_JPRB, 0.71908242E-06_JPRB, 0.78051618E-06_JPRB, 0.82540919E-06_JPRB, 0.86222308E-06_JPRB, 0.89826859E-06_JPRB, &
  & 0.92613530E-06_JPRB, 0.96587401E-06_JPRB, 0.10153649E-05_JPRB, 0.10451585E-05_JPRB, 0.10671594E-05_JPRB, 0.10941244E-05_JPRB, &
  & 0.11275464E-05_JPRB, 0.11401440E-05_JPRB, 0.11426545E-05_JPRB, 0.11480308E-05_JPRB  /)

RGHG7(:,43, 5) = (/ &
  & 0.66562794E-06_JPRB, 0.66148407E-06_JPRB, 0.66559390E-06_JPRB, 0.69068341E-06_JPRB, 0.71454427E-06_JPRB, 0.72202679E-06_JPRB, &
  & 0.71737831E-06_JPRB, 0.70410540E-06_JPRB, 0.66925776E-06_JPRB, 0.61438595E-06_JPRB, 0.55732606E-06_JPRB, 0.50051672E-06_JPRB, &
  & 0.45226327E-06_JPRB, 0.41118845E-06_JPRB, 0.37416619E-06_JPRB, 0.34247654E-06_JPRB, 0.31335483E-06_JPRB, 0.28492314E-06_JPRB, &
  & 0.25550598E-06_JPRB, 0.22116162E-06_JPRB, 0.18228510E-06_JPRB, 0.14173240E-06_JPRB, 0.10888482E-06_JPRB, 0.88309439E-07_JPRB, &
  & 0.76515108E-07_JPRB, 0.69803071E-07_JPRB, 0.65866785E-07_JPRB, 0.62729427E-07_JPRB, 0.59367773E-07_JPRB, 0.55813057E-07_JPRB, &
  & 0.53401308E-07_JPRB, 0.52561165E-07_JPRB, 0.52168102E-07_JPRB, 0.51339241E-07_JPRB, 0.52040990E-07_JPRB, 0.56139102E-07_JPRB, &
  & 0.62829012E-07_JPRB, 0.73010518E-07_JPRB, 0.87732006E-07_JPRB, 0.10938006E-06_JPRB, 0.13548436E-06_JPRB, 0.16735881E-06_JPRB, &
  & 0.21073344E-06_JPRB, 0.25734261E-06_JPRB, 0.30820694E-06_JPRB, 0.36907337E-06_JPRB, 0.44163172E-06_JPRB, 0.51714632E-06_JPRB, &
  & 0.58966998E-06_JPRB, 0.65657339E-06_JPRB, 0.71380224E-06_JPRB, 0.75335556E-06_JPRB, 0.78395886E-06_JPRB, 0.81522767E-06_JPRB, &
  & 0.83926773E-06_JPRB, 0.87524139E-06_JPRB, 0.91775636E-06_JPRB, 0.94082918E-06_JPRB, 0.96078913E-06_JPRB, 0.98584526E-06_JPRB, &
  & 0.10168130E-05_JPRB, 0.10257687E-05_JPRB, 0.10277338E-05_JPRB, 0.10319928E-05_JPRB  /)

RGHG7(:,44, 5) = (/ &
  & 0.59651126E-06_JPRB, 0.59391262E-06_JPRB, 0.59557295E-06_JPRB, 0.61607780E-06_JPRB, 0.63631111E-06_JPRB, 0.64251454E-06_JPRB, &
  & 0.63957715E-06_JPRB, 0.63108826E-06_JPRB, 0.60419728E-06_JPRB, 0.55855109E-06_JPRB, 0.50938615E-06_JPRB, 0.45830505E-06_JPRB, &
  & 0.41443594E-06_JPRB, 0.37674490E-06_JPRB, 0.34273052E-06_JPRB, 0.31433470E-06_JPRB, 0.28855328E-06_JPRB, 0.26298603E-06_JPRB, &
  & 0.23629231E-06_JPRB, 0.20589950E-06_JPRB, 0.17074212E-06_JPRB, 0.13371431E-06_JPRB, 0.10340853E-06_JPRB, 0.84260549E-07_JPRB, &
  & 0.73299452E-07_JPRB, 0.67142151E-07_JPRB, 0.63262221E-07_JPRB, 0.59944720E-07_JPRB, 0.56503333E-07_JPRB, 0.53066881E-07_JPRB, &
  & 0.50914726E-07_JPRB, 0.50068958E-07_JPRB, 0.49550696E-07_JPRB, 0.48653534E-07_JPRB, 0.49464377E-07_JPRB, 0.53475771E-07_JPRB, &
  & 0.60012613E-07_JPRB, 0.69363222E-07_JPRB, 0.82803980E-07_JPRB, 0.10228738E-06_JPRB, 0.12630340E-06_JPRB, 0.15660188E-06_JPRB, &
  & 0.19736855E-06_JPRB, 0.24125735E-06_JPRB, 0.28954435E-06_JPRB, 0.34881443E-06_JPRB, 0.42106685E-06_JPRB, 0.49666907E-06_JPRB, &
  & 0.56800264E-06_JPRB, 0.63223503E-06_JPRB, 0.68700548E-06_JPRB, 0.72670422E-06_JPRB, 0.75683727E-06_JPRB, 0.78566566E-06_JPRB, &
  & 0.80850113E-06_JPRB, 0.84210397E-06_JPRB, 0.88038415E-06_JPRB, 0.90029263E-06_JPRB, 0.91832698E-06_JPRB, 0.94079118E-06_JPRB, &
  & 0.96726486E-06_JPRB, 0.97401792E-06_JPRB, 0.97797586E-06_JPRB, 0.98716316E-06_JPRB  /)

RGHG7(:,45, 5) = (/ &
  & 0.49525002E-06_JPRB, 0.49432495E-06_JPRB, 0.49290557E-06_JPRB, 0.50874339E-06_JPRB, 0.52549154E-06_JPRB, 0.53094444E-06_JPRB, &
  & 0.53110402E-06_JPRB, 0.52974938E-06_JPRB, 0.51395228E-06_JPRB, 0.48071123E-06_JPRB, 0.44199316E-06_JPRB, 0.39858117E-06_JPRB, &
  & 0.36055231E-06_JPRB, 0.32768356E-06_JPRB, 0.29776684E-06_JPRB, 0.27376199E-06_JPRB, 0.25260446E-06_JPRB, 0.23116939E-06_JPRB, &
  & 0.20847843E-06_JPRB, 0.18350316E-06_JPRB, 0.15354766E-06_JPRB, 0.12154056E-06_JPRB, 0.95021885E-07_JPRB, 0.78228982E-07_JPRB, &
  & 0.68665403E-07_JPRB, 0.63370769E-07_JPRB, 0.59646118E-07_JPRB, 0.56130204E-07_JPRB, 0.52568044E-07_JPRB, 0.49235112E-07_JPRB, &
  & 0.47376263E-07_JPRB, 0.46521868E-07_JPRB, 0.45831073E-07_JPRB, 0.44787258E-07_JPRB, 0.45606728E-07_JPRB, 0.49393828E-07_JPRB, &
  & 0.55559725E-07_JPRB, 0.63607708E-07_JPRB, 0.75193735E-07_JPRB, 0.91968365E-07_JPRB, 0.11326699E-06_JPRB, 0.14140017E-06_JPRB, &
  & 0.17869893E-06_JPRB, 0.21901630E-06_JPRB, 0.26374911E-06_JPRB, 0.32077626E-06_JPRB, 0.39242481E-06_JPRB, 0.46738004E-06_JPRB, &
  & 0.53642754E-06_JPRB, 0.59663128E-06_JPRB, 0.64807184E-06_JPRB, 0.68726160E-06_JPRB, 0.71607478E-06_JPRB, 0.74152152E-06_JPRB, &
  & 0.76250226E-06_JPRB, 0.79293049E-06_JPRB, 0.82550844E-06_JPRB, 0.84096557E-06_JPRB, 0.85654995E-06_JPRB, 0.87582229E-06_JPRB, &
  & 0.89686980E-06_JPRB, 0.90065529E-06_JPRB, 0.90681303E-06_JPRB, 0.92146963E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART10',0,ZHOOK_HANDLE)



RGHG7(:,46, 5) = (/ &
  & 0.43864451E-06_JPRB, 0.43843567E-06_JPRB, 0.43648536E-06_JPRB, 0.44751250E-06_JPRB, 0.46046596E-06_JPRB, 0.46405915E-06_JPRB, &
  & 0.46385186E-06_JPRB, 0.46377678E-06_JPRB, 0.45318608E-06_JPRB, 0.42755250E-06_JPRB, 0.39543863E-06_JPRB, 0.35741988E-06_JPRB, &
  & 0.32278621E-06_JPRB, 0.29240240E-06_JPRB, 0.26517345E-06_JPRB, 0.24404396E-06_JPRB, 0.22564464E-06_JPRB, 0.20748789E-06_JPRB, &
  & 0.18806898E-06_JPRB, 0.16705685E-06_JPRB, 0.14119044E-06_JPRB, 0.11287455E-06_JPRB, 0.88960589E-07_JPRB, 0.73486974E-07_JPRB, &
  & 0.64863806E-07_JPRB, 0.60198641E-07_JPRB, 0.56735879E-07_JPRB, 0.53442870E-07_JPRB, 0.50039385E-07_JPRB, 0.46929314E-07_JPRB, &
  & 0.45283225E-07_JPRB, 0.44396093E-07_JPRB, 0.43610883E-07_JPRB, 0.42564571E-07_JPRB, 0.43460850E-07_JPRB, 0.47208948E-07_JPRB, &
  & 0.53119283E-07_JPRB, 0.60517714E-07_JPRB, 0.71033700E-07_JPRB, 0.85744912E-07_JPRB, 0.10461999E-06_JPRB, 0.13025904E-06_JPRB, &
  & 0.16355786E-06_JPRB, 0.19972168E-06_JPRB, 0.24067493E-06_JPRB, 0.29345264E-06_JPRB, 0.36213590E-06_JPRB, 0.43541020E-06_JPRB, &
  & 0.50377807E-06_JPRB, 0.56332510E-06_JPRB, 0.61336088E-06_JPRB, 0.65338934E-06_JPRB, 0.68294185E-06_JPRB, 0.70777585E-06_JPRB, &
  & 0.72873798E-06_JPRB, 0.75728670E-06_JPRB, 0.78628183E-06_JPRB, 0.80161872E-06_JPRB, 0.81624773E-06_JPRB, 0.83419208E-06_JPRB, &
  & 0.85231402E-06_JPRB, 0.85538347E-06_JPRB, 0.86196901E-06_JPRB, 0.87744833E-06_JPRB  /)

RGHG7(:,47, 5) = (/ &
  & 0.38116769E-06_JPRB, 0.38160753E-06_JPRB, 0.37954478E-06_JPRB, 0.38489818E-06_JPRB, 0.39333686E-06_JPRB, 0.39452563E-06_JPRB, &
  & 0.39319397E-06_JPRB, 0.39344755E-06_JPRB, 0.38778678E-06_JPRB, 0.37011893E-06_JPRB, 0.34498480E-06_JPRB, 0.31283872E-06_JPRB, &
  & 0.28169924E-06_JPRB, 0.25376310E-06_JPRB, 0.22940562E-06_JPRB, 0.21134652E-06_JPRB, 0.19581002E-06_JPRB, 0.18132909E-06_JPRB, &
  & 0.16560331E-06_JPRB, 0.14895027E-06_JPRB, 0.12765918E-06_JPRB, 0.10340832E-06_JPRB, 0.82313935E-07_JPRB, 0.68180914E-07_JPRB, &
  & 0.60569680E-07_JPRB, 0.56596434E-07_JPRB, 0.53462334E-07_JPRB, 0.50515285E-07_JPRB, 0.47353972E-07_JPRB, 0.44529318E-07_JPRB, &
  & 0.43116752E-07_JPRB, 0.42186375E-07_JPRB, 0.41306027E-07_JPRB, 0.40285661E-07_JPRB, 0.41285728E-07_JPRB, 0.45025178E-07_JPRB, &
  & 0.50658744E-07_JPRB, 0.57425799E-07_JPRB, 0.66843361E-07_JPRB, 0.79262590E-07_JPRB, 0.95352692E-07_JPRB, 0.11799919E-06_JPRB, &
  & 0.14649781E-06_JPRB, 0.17767116E-06_JPRB, 0.21414422E-06_JPRB, 0.26153361E-06_JPRB, 0.32626428E-06_JPRB, 0.39735903E-06_JPRB, &
  & 0.46525121E-06_JPRB, 0.52470310E-06_JPRB, 0.57347613E-06_JPRB, 0.61475869E-06_JPRB, 0.64559125E-06_JPRB, 0.67026092E-06_JPRB, &
  & 0.69156901E-06_JPRB, 0.71817170E-06_JPRB, 0.74338722E-06_JPRB, 0.75945063E-06_JPRB, 0.77325798E-06_JPRB, 0.79001742E-06_JPRB, &
  & 0.80520736E-06_JPRB, 0.80788760E-06_JPRB, 0.81462017E-06_JPRB, 0.83013409E-06_JPRB  /)

RGHG7(:,48, 5) = (/ &
  & 0.33895857E-06_JPRB, 0.33841658E-06_JPRB, 0.33617335E-06_JPRB, 0.33833535E-06_JPRB, 0.34417001E-06_JPRB, 0.34382360E-06_JPRB, &
  & 0.34109634E-06_JPRB, 0.34025790E-06_JPRB, 0.33612295E-06_JPRB, 0.32325692E-06_JPRB, 0.30253534E-06_JPRB, 0.27467280E-06_JPRB, &
  & 0.24617558E-06_JPRB, 0.22020204E-06_JPRB, 0.19787937E-06_JPRB, 0.18190161E-06_JPRB, 0.16888611E-06_JPRB, 0.15760607E-06_JPRB, &
  & 0.14530782E-06_JPRB, 0.13225912E-06_JPRB, 0.11513536E-06_JPRB, 0.94874909E-07_JPRB, 0.76550337E-07_JPRB, 0.63807658E-07_JPRB, &
  & 0.57042174E-07_JPRB, 0.53571499E-07_JPRB, 0.50845606E-07_JPRB, 0.48323164E-07_JPRB, 0.45476692E-07_JPRB, 0.42911274E-07_JPRB, &
  & 0.41629187E-07_JPRB, 0.40691905E-07_JPRB, 0.39789548E-07_JPRB, 0.38805148E-07_JPRB, 0.39926347E-07_JPRB, 0.43646231E-07_JPRB, &
  & 0.49074223E-07_JPRB, 0.55384741E-07_JPRB, 0.63954110E-07_JPRB, 0.74626529E-07_JPRB, 0.88604709E-07_JPRB, 0.10846513E-06_JPRB, &
  & 0.13246956E-06_JPRB, 0.15916153E-06_JPRB, 0.19068801E-06_JPRB, 0.23192316E-06_JPRB, 0.29006507E-06_JPRB, 0.35530876E-06_JPRB, &
  & 0.42001088E-06_JPRB, 0.47825877E-06_JPRB, 0.52548795E-06_JPRB, 0.56644225E-06_JPRB, 0.59788036E-06_JPRB, 0.62239992E-06_JPRB, &
  & 0.64531460E-06_JPRB, 0.67144181E-06_JPRB, 0.69530721E-06_JPRB, 0.71245152E-06_JPRB, 0.72767339E-06_JPRB, 0.74404249E-06_JPRB, &
  & 0.75808922E-06_JPRB, 0.76086644E-06_JPRB, 0.76853399E-06_JPRB, 0.78212018E-06_JPRB  /)

RGHG7(:,49, 5) = (/ &
  & 0.29915761E-06_JPRB, 0.29678704E-06_JPRB, 0.29431303E-06_JPRB, 0.29406947E-06_JPRB, 0.29788914E-06_JPRB, 0.29623787E-06_JPRB, &
  & 0.29184181E-06_JPRB, 0.28914817E-06_JPRB, 0.28515524E-06_JPRB, 0.27616828E-06_JPRB, 0.25916599E-06_JPRB, 0.23532455E-06_JPRB, &
  & 0.20936604E-06_JPRB, 0.18534535E-06_JPRB, 0.16489564E-06_JPRB, 0.15077309E-06_JPRB, 0.14039394E-06_JPRB, 0.13244262E-06_JPRB, &
  & 0.12381929E-06_JPRB, 0.11441886E-06_JPRB, 0.10172453E-06_JPRB, 0.85849110E-07_JPRB, 0.70569210E-07_JPRB, 0.59388813E-07_JPRB, &
  & 0.53484359E-07_JPRB, 0.50484143E-07_JPRB, 0.48246463E-07_JPRB, 0.46229987E-07_JPRB, 0.43765208E-07_JPRB, 0.41474965E-07_JPRB, &
  & 0.40290520E-07_JPRB, 0.39362115E-07_JPRB, 0.38468635E-07_JPRB, 0.37528618E-07_JPRB, 0.38791842E-07_JPRB, 0.42485096E-07_JPRB, &
  & 0.47717803E-07_JPRB, 0.53602245E-07_JPRB, 0.61346090E-07_JPRB, 0.70331956E-07_JPRB, 0.82277395E-07_JPRB, 0.99146408E-07_JPRB, &
  & 0.11831309E-06_JPRB, 0.14027384E-06_JPRB, 0.16611041E-06_JPRB, 0.20018216E-06_JPRB, 0.24982917E-06_JPRB, 0.30692413E-06_JPRB, &
  & 0.36685953E-06_JPRB, 0.42326996E-06_JPRB, 0.46866168E-06_JPRB, 0.50853304E-06_JPRB, 0.54033509E-06_JPRB, 0.56469487E-06_JPRB, &
  & 0.58996185E-06_JPRB, 0.61623109E-06_JPRB, 0.63970592E-06_JPRB, 0.65820835E-06_JPRB, 0.67601330E-06_JPRB, 0.69231139E-06_JPRB, &
  & 0.70590541E-06_JPRB, 0.70901106E-06_JPRB, 0.71807224E-06_JPRB, 0.72863151E-06_JPRB  /)

RGHG7(:,50, 5) = (/ &
  & 0.26405426E-06_JPRB, 0.25993187E-06_JPRB, 0.25678527E-06_JPRB, 0.25573481E-06_JPRB, 0.25863011E-06_JPRB, 0.25628095E-06_JPRB, &
  & 0.25108240E-06_JPRB, 0.24688205E-06_JPRB, 0.24237309E-06_JPRB, 0.23547973E-06_JPRB, 0.22099761E-06_JPRB, 0.20047887E-06_JPRB, &
  & 0.17741017E-06_JPRB, 0.15558291E-06_JPRB, 0.13722549E-06_JPRB, 0.12494425E-06_JPRB, 0.11670514E-06_JPRB, 0.11128760E-06_JPRB, &
  & 0.10569491E-06_JPRB, 0.99010653E-07_JPRB, 0.89818710E-07_JPRB, 0.77869613E-07_JPRB, 0.65492120E-07_JPRB, 0.55861082E-07_JPRB, &
  & 0.50642054E-07_JPRB, 0.48063960E-07_JPRB, 0.46245553E-07_JPRB, 0.44665694E-07_JPRB, 0.42568046E-07_JPRB, 0.40497599E-07_JPRB, &
  & 0.39379702E-07_JPRB, 0.38483045E-07_JPRB, 0.37635736E-07_JPRB, 0.36756386E-07_JPRB, 0.38109326E-07_JPRB, 0.41796756E-07_JPRB, &
  & 0.46881945E-07_JPRB, 0.52436664E-07_JPRB, 0.59417275E-07_JPRB, 0.67257354E-07_JPRB, 0.77626491E-07_JPRB, 0.91948005E-07_JPRB, &
  & 0.10741530E-06_JPRB, 0.12547785E-06_JPRB, 0.14630080E-06_JPRB, 0.17434050E-06_JPRB, 0.21513163E-06_JPRB, 0.26252339E-06_JPRB, &
  & 0.31528947E-06_JPRB, 0.36691354E-06_JPRB, 0.40773235E-06_JPRB, 0.44413714E-06_JPRB, 0.47420636E-06_JPRB, 0.49760525E-06_JPRB, &
  & 0.52282811E-06_JPRB, 0.54834766E-06_JPRB, 0.57230051E-06_JPRB, 0.59144902E-06_JPRB, 0.61191600E-06_JPRB, 0.62911102E-06_JPRB, &
  & 0.64267238E-06_JPRB, 0.64580179E-06_JPRB, 0.65547162E-06_JPRB, 0.66588035E-06_JPRB  /)

RGHG7(:,51, 5) = (/ &
  & 0.22855437E-06_JPRB, 0.22257746E-06_JPRB, 0.21847116E-06_JPRB, 0.21738824E-06_JPRB, 0.21985700E-06_JPRB, 0.21707203E-06_JPRB, &
  & 0.21146085E-06_JPRB, 0.20581399E-06_JPRB, 0.20040095E-06_JPRB, 0.19483356E-06_JPRB, 0.18244705E-06_JPRB, 0.16515515E-06_JPRB, &
  & 0.14539675E-06_JPRB, 0.12606844E-06_JPRB, 0.11008944E-06_JPRB, 0.99792522E-07_JPRB, 0.93607282E-07_JPRB, 0.90512517E-07_JPRB, &
  & 0.87859224E-07_JPRB, 0.83622924E-07_JPRB, 0.77732009E-07_JPRB, 0.69788656E-07_JPRB, 0.60475741E-07_JPRB, 0.52513763E-07_JPRB, &
  & 0.47943814E-07_JPRB, 0.45796893E-07_JPRB, 0.44395751E-07_JPRB, 0.43251702E-07_JPRB, 0.41543501E-07_JPRB, 0.39681687E-07_JPRB, &
  & 0.38619425E-07_JPRB, 0.37769131E-07_JPRB, 0.36991366E-07_JPRB, 0.36186197E-07_JPRB, 0.37608681E-07_JPRB, 0.41300747E-07_JPRB, &
  & 0.46251484E-07_JPRB, 0.51500208E-07_JPRB, 0.57688016E-07_JPRB, 0.64573023E-07_JPRB, 0.73477096E-07_JPRB, 0.85276476E-07_JPRB, &
  & 0.97340747E-07_JPRB, 0.11162473E-06_JPRB, 0.12738023E-06_JPRB, 0.14949013E-06_JPRB, 0.18051263E-06_JPRB, 0.21659187E-06_JPRB, &
  & 0.26034039E-06_JPRB, 0.30523722E-06_JPRB, 0.33967188E-06_JPRB, 0.37107413E-06_JPRB, 0.39816686E-06_JPRB, 0.42010533E-06_JPRB, &
  & 0.44402075E-06_JPRB, 0.46826070E-06_JPRB, 0.49318716E-06_JPRB, 0.51266021E-06_JPRB, 0.53604804E-06_JPRB, 0.55472204E-06_JPRB, &
  & 0.56846884E-06_JPRB, 0.57146380E-06_JPRB, 0.58137936E-06_JPRB, 0.59313725E-06_JPRB  /)

RGHG7(:,52, 5) = (/ &
  & 0.19643932E-06_JPRB, 0.18945708E-06_JPRB, 0.18467865E-06_JPRB, 0.18391258E-06_JPRB, 0.18627663E-06_JPRB, 0.18340444E-06_JPRB, &
  & 0.17785152E-06_JPRB, 0.17170752E-06_JPRB, 0.16604187E-06_JPRB, 0.16155429E-06_JPRB, 0.15132156E-06_JPRB, 0.13703981E-06_JPRB, &
  & 0.12054903E-06_JPRB, 0.10408399E-06_JPRB, 0.90611457E-07_JPRB, 0.82060841E-07_JPRB, 0.77334650E-07_JPRB, 0.75513523E-07_JPRB, &
  & 0.74630130E-07_JPRB, 0.72068628E-07_JPRB, 0.68244519E-07_JPRB, 0.63162761E-07_JPRB, 0.56309716E-07_JPRB, 0.49792640E-07_JPRB, &
  & 0.45873490E-07_JPRB, 0.44078147E-07_JPRB, 0.43028271E-07_JPRB, 0.42217093E-07_JPRB, 0.40849576E-07_JPRB, 0.39135179E-07_JPRB, &
  & 0.38094080E-07_JPRB, 0.37309004E-07_JPRB, 0.36609148E-07_JPRB, 0.35853221E-07_JPRB, 0.37287222E-07_JPRB, 0.41086727E-07_JPRB, &
  & 0.45989085E-07_JPRB, 0.50962066E-07_JPRB, 0.56478152E-07_JPRB, 0.62652394E-07_JPRB, 0.70430394E-07_JPRB, 0.80243480E-07_JPRB, &
  & 0.89908910E-07_JPRB, 0.10128769E-06_JPRB, 0.11351271E-06_JPRB, 0.13114332E-06_JPRB, 0.15458300E-06_JPRB, 0.18161410E-06_JPRB, &
  & 0.21726216E-06_JPRB, 0.25460334E-06_JPRB, 0.28192048E-06_JPRB, 0.30644969E-06_JPRB, 0.32929302E-06_JPRB, 0.34808496E-06_JPRB, &
  & 0.36776843E-06_JPRB, 0.38849741E-06_JPRB, 0.41191199E-06_JPRB, 0.43012862E-06_JPRB, 0.45369141E-06_JPRB, 0.47380383E-06_JPRB, &
  & 0.48682557E-06_JPRB, 0.48911818E-06_JPRB, 0.49751109E-06_JPRB, 0.50970087E-06_JPRB  /)

RGHG7(:,53, 5) = (/ &
  & 0.16276880E-06_JPRB, 0.15501849E-06_JPRB, 0.14961874E-06_JPRB, 0.14933211E-06_JPRB, 0.15170594E-06_JPRB, 0.14887289E-06_JPRB, &
  & 0.14356458E-06_JPRB, 0.13724446E-06_JPRB, 0.13155435E-06_JPRB, 0.12814795E-06_JPRB, 0.12028305E-06_JPRB, 0.10919592E-06_JPRB, &
  & 0.96247106E-07_JPRB, 0.83040284E-07_JPRB, 0.72346535E-07_JPRB, 0.65606039E-07_JPRB, 0.62239886E-07_JPRB, 0.61402094E-07_JPRB, &
  & 0.61996151E-07_JPRB, 0.60961021E-07_JPRB, 0.58912788E-07_JPRB, 0.56507074E-07_JPRB, 0.52100139E-07_JPRB, 0.47070297E-07_JPRB, &
  & 0.43860519E-07_JPRB, 0.42417415E-07_JPRB, 0.41724672E-07_JPRB, 0.41236380E-07_JPRB, 0.40221103E-07_JPRB, 0.38643687E-07_JPRB, &
  & 0.37612373E-07_JPRB, 0.36905573E-07_JPRB, 0.36293776E-07_JPRB, 0.35581880E-07_JPRB, 0.37006096E-07_JPRB, 0.40962152E-07_JPRB, &
  & 0.45844942E-07_JPRB, 0.50529282E-07_JPRB, 0.55360457E-07_JPRB, 0.60854681E-07_JPRB, 0.67536823E-07_JPRB, 0.75393022E-07_JPRB, &
  & 0.82832492E-07_JPRB, 0.91383571E-07_JPRB, 0.10035527E-06_JPRB, 0.11366604E-06_JPRB, 0.12968912E-06_JPRB, 0.14773811E-06_JPRB, &
  & 0.17491774E-06_JPRB, 0.20371221E-06_JPRB, 0.22299632E-06_JPRB, 0.23932129E-06_JPRB, 0.25704735E-06_JPRB, 0.27176407E-06_JPRB, &
  & 0.28571386E-06_JPRB, 0.30176099E-06_JPRB, 0.32257291E-06_JPRB, 0.33881309E-06_JPRB, 0.36150995E-06_JPRB, 0.38317321E-06_JPRB, &
  & 0.39505506E-06_JPRB, 0.39636433E-06_JPRB, 0.40241876E-06_JPRB, 0.41472595E-06_JPRB  /)

RGHG7(:,54, 5) = (/ &
  & 0.13571731E-06_JPRB, 0.12824567E-06_JPRB, 0.12299359E-06_JPRB, 0.12287722E-06_JPRB, 0.12519764E-06_JPRB, 0.12260540E-06_JPRB, &
  & 0.11788221E-06_JPRB, 0.11221564E-06_JPRB, 0.10713026E-06_JPRB, 0.10477893E-06_JPRB, 0.99031328E-07_JPRB, 0.90668613E-07_JPRB, &
  & 0.80537633E-07_JPRB, 0.70189729E-07_JPRB, 0.61805581E-07_JPRB, 0.56402764E-07_JPRB, 0.53800863E-07_JPRB, 0.53262210E-07_JPRB, &
  & 0.54090575E-07_JPRB, 0.54042588E-07_JPRB, 0.52811123E-07_JPRB, 0.51755418E-07_JPRB, 0.48889792E-07_JPRB, 0.44956026E-07_JPRB, &
  & 0.42288557E-07_JPRB, 0.41163470E-07_JPRB, 0.40778789E-07_JPRB, 0.40492308E-07_JPRB, 0.39740596E-07_JPRB, 0.38234265E-07_JPRB, &
  & 0.37254251E-07_JPRB, 0.36649999E-07_JPRB, 0.36114566E-07_JPRB, 0.35426191E-07_JPRB, 0.36893347E-07_JPRB, 0.41002145E-07_JPRB, &
  & 0.45834690E-07_JPRB, 0.50320854E-07_JPRB, 0.54670955E-07_JPRB, 0.59605043E-07_JPRB, 0.65486053E-07_JPRB, 0.72148157E-07_JPRB, &
  & 0.78075968E-07_JPRB, 0.85066176E-07_JPRB, 0.92157480E-07_JPRB, 0.10247571E-06_JPRB, 0.11398802E-06_JPRB, 0.12693075E-06_JPRB, &
  & 0.14794452E-06_JPRB, 0.17008104E-06_JPRB, 0.18353032E-06_JPRB, 0.19402950E-06_JPRB, 0.20698206E-06_JPRB, 0.21764738E-06_JPRB, &
  & 0.22687760E-06_JPRB, 0.23841732E-06_JPRB, 0.25544305E-06_JPRB, 0.26818550E-06_JPRB, 0.28732449E-06_JPRB, 0.30701834E-06_JPRB, &
  & 0.31687764E-06_JPRB, 0.31701657E-06_JPRB, 0.32102803E-06_JPRB, 0.33022099E-06_JPRB  /)

RGHG7(:,55, 5) = (/ &
  & 0.10662156E-06_JPRB, 0.99596332E-07_JPRB, 0.94608973E-07_JPRB, 0.94640540E-07_JPRB, 0.96893483E-07_JPRB, 0.94594517E-07_JPRB, &
  & 0.90564298E-07_JPRB, 0.85730849E-07_JPRB, 0.81398128E-07_JPRB, 0.80212120E-07_JPRB, 0.76777003E-07_JPRB, 0.71370428E-07_JPRB, &
  & 0.64265661E-07_JPRB, 0.57032214E-07_JPRB, 0.51144823E-07_JPRB, 0.47161679E-07_JPRB, 0.45328010E-07_JPRB, 0.45030728E-07_JPRB, &
  & 0.45955122E-07_JPRB, 0.46929715E-07_JPRB, 0.46476864E-07_JPRB, 0.46742208E-07_JPRB, 0.45464955E-07_JPRB, 0.42693920E-07_JPRB, &
  & 0.40605221E-07_JPRB, 0.39827914E-07_JPRB, 0.39778038E-07_JPRB, 0.39699187E-07_JPRB, 0.39227777E-07_JPRB, 0.37791521E-07_JPRB, &
  & 0.36873796E-07_JPRB, 0.36386336E-07_JPRB, 0.35933955E-07_JPRB, 0.35268938E-07_JPRB, 0.36790597E-07_JPRB, 0.41068095E-07_JPRB, &
  & 0.45840947E-07_JPRB, 0.50119480E-07_JPRB, 0.53963482E-07_JPRB, 0.58292846E-07_JPRB, 0.63325167E-07_JPRB, 0.68764846E-07_JPRB, &
  & 0.73112070E-07_JPRB, 0.78539859E-07_JPRB, 0.83728749E-07_JPRB, 0.90906569E-07_JPRB, 0.97804293E-07_JPRB, 0.10560038E-06_JPRB, &
  & 0.12008676E-06_JPRB, 0.13509638E-06_JPRB, 0.14237124E-06_JPRB, 0.14672975E-06_JPRB, 0.15443964E-06_JPRB, 0.16062015E-06_JPRB, &
  & 0.16475563E-06_JPRB, 0.17132520E-06_JPRB, 0.18400107E-06_JPRB, 0.19266877E-06_JPRB, 0.20751241E-06_JPRB, 0.22456157E-06_JPRB, &
  & 0.23206426E-06_JPRB, 0.23088214E-06_JPRB, 0.23266936E-06_JPRB, 0.23798742E-06_JPRB  /)

RGHG7(:,56, 5) = (/ &
  & 0.88300379E-07_JPRB, 0.82352636E-07_JPRB, 0.77986112E-07_JPRB, 0.78097569E-07_JPRB, 0.80227328E-07_JPRB, 0.78202064E-07_JPRB, &
  & 0.74977495E-07_JPRB, 0.70950207E-07_JPRB, 0.67633182E-07_JPRB, 0.67083021E-07_JPRB, 0.64763935E-07_JPRB, 0.61143889E-07_JPRB, &
  & 0.55978990E-07_JPRB, 0.50663310E-07_JPRB, 0.46262383E-07_JPRB, 0.43258760E-07_JPRB, 0.41880547E-07_JPRB, 0.41665342E-07_JPRB, &
  & 0.42325613E-07_JPRB, 0.43372026E-07_JPRB, 0.43229257E-07_JPRB, 0.43810383E-07_JPRB, 0.43263005E-07_JPRB, 0.41099048E-07_JPRB, &
  & 0.39467294E-07_JPRB, 0.38972124E-07_JPRB, 0.38989890E-07_JPRB, 0.39090148E-07_JPRB, 0.38759682E-07_JPRB, 0.37493387E-07_JPRB, &
  & 0.36599748E-07_JPRB, 0.36132341E-07_JPRB, 0.35777648E-07_JPRB, 0.35169285E-07_JPRB, 0.36786655E-07_JPRB, 0.41212104E-07_JPRB, &
  & 0.45942536E-07_JPRB, 0.50090447E-07_JPRB, 0.53651298E-07_JPRB, 0.57493710E-07_JPRB, 0.62039060E-07_JPRB, 0.66794608E-07_JPRB, &
  & 0.70359726E-07_JPRB, 0.75219257E-07_JPRB, 0.79565090E-07_JPRB, 0.85070820E-07_JPRB, 0.90045507E-07_JPRB, 0.95800733E-07_JPRB, &
  & 0.10678531E-06_JPRB, 0.11791219E-06_JPRB, 0.12238235E-06_JPRB, 0.12451240E-06_JPRB, 0.12980551E-06_JPRB, 0.13377941E-06_JPRB, &
  & 0.13608367E-06_JPRB, 0.14066653E-06_JPRB, 0.15041934E-06_JPRB, 0.15627232E-06_JPRB, 0.16712629E-06_JPRB, 0.17986332E-06_JPRB, &
  & 0.18489646E-06_JPRB, 0.18298157E-06_JPRB, 0.18331618E-06_JPRB, 0.18660361E-06_JPRB  /)

RGHG7(:,57, 5) = (/ &
  & 0.70449468E-07_JPRB, 0.65577968E-07_JPRB, 0.61871837E-07_JPRB, 0.62069603E-07_JPRB, 0.64043568E-07_JPRB, 0.62318794E-07_JPRB, &
  & 0.59863892E-07_JPRB, 0.56624643E-07_JPRB, 0.54256960E-07_JPRB, 0.54329020E-07_JPRB, 0.53046251E-07_JPRB, 0.51090954E-07_JPRB, &
  & 0.47786862E-07_JPRB, 0.44311667E-07_JPRB, 0.41341866E-07_JPRB, 0.39295592E-07_JPRB, 0.38385796E-07_JPRB, 0.38274686E-07_JPRB, &
  & 0.38767620E-07_JPRB, 0.39902786E-07_JPRB, 0.40037322E-07_JPRB, 0.40905743E-07_JPRB, 0.41085770E-07_JPRB, 0.39511538E-07_JPRB, &
  & 0.38279932E-07_JPRB, 0.38055295E-07_JPRB, 0.38173753E-07_JPRB, 0.38418367E-07_JPRB, 0.38225062E-07_JPRB, 0.37158714E-07_JPRB, &
  & 0.36313624E-07_JPRB, 0.35844982E-07_JPRB, 0.35551456E-07_JPRB, 0.35015078E-07_JPRB, 0.36775885E-07_JPRB, 0.41369364E-07_JPRB, &
  & 0.46044494E-07_JPRB, 0.50055823E-07_JPRB, 0.53320237E-07_JPRB, 0.56699470E-07_JPRB, 0.60778298E-07_JPRB, 0.64831705E-07_JPRB, &
  & 0.67635526E-07_JPRB, 0.71890173E-07_JPRB, 0.75363310E-07_JPRB, 0.79278868E-07_JPRB, 0.82403693E-07_JPRB, 0.86142326E-07_JPRB, &
  & 0.93762719E-07_JPRB, 0.10106167E-06_JPRB, 0.10296322E-06_JPRB, 0.10309038E-06_JPRB, 0.10614955E-06_JPRB, 0.10813595E-06_JPRB, &
  & 0.10867169E-06_JPRB, 0.11139387E-06_JPRB, 0.11835525E-06_JPRB, 0.12169800E-06_JPRB, 0.12895274E-06_JPRB, 0.13780745E-06_JPRB, &
  & 0.14063600E-06_JPRB, 0.13808819E-06_JPRB, 0.13740021E-06_JPRB, 0.13895552E-06_JPRB  /)

RGHG7(:,58, 5) = (/ &
  & 0.56848725E-07_JPRB, 0.53083100E-07_JPRB, 0.50117812E-07_JPRB, 0.50393030E-07_JPRB, 0.52158212E-07_JPRB, 0.50751327E-07_JPRB, &
  & 0.48964530E-07_JPRB, 0.46414265E-07_JPRB, 0.44856795E-07_JPRB, 0.45378748E-07_JPRB, 0.44690000E-07_JPRB, 0.43840579E-07_JPRB, &
  & 0.41910413E-07_JPRB, 0.39772775E-07_JPRB, 0.37836113E-07_JPRB, 0.36550214E-07_JPRB, 0.36034412E-07_JPRB, 0.36026346E-07_JPRB, &
  & 0.36461360E-07_JPRB, 0.37528503E-07_JPRB, 0.37774839E-07_JPRB, 0.38670873E-07_JPRB, 0.39354672E-07_JPRB, 0.38189251E-07_JPRB, &
  & 0.37206838E-07_JPRB, 0.37199065E-07_JPRB, 0.37415854E-07_JPRB, 0.37729164E-07_JPRB, 0.37629474E-07_JPRB, 0.36816360E-07_JPRB, &
  & 0.36050069E-07_JPRB, 0.35526200E-07_JPRB, 0.35229980E-07_JPRB, 0.34791932E-07_JPRB, 0.36772972E-07_JPRB, 0.41550987E-07_JPRB, &
  & 0.46156748E-07_JPRB, 0.50046848E-07_JPRB, 0.53058029E-07_JPRB, 0.56073575E-07_JPRB, 0.59825759E-07_JPRB, 0.63304003E-07_JPRB, &
  & 0.65592601E-07_JPRB, 0.69415539E-07_JPRB, 0.72234714E-07_JPRB, 0.75101643E-07_JPRB, 0.77153593E-07_JPRB, 0.79661080E-07_JPRB, &
  & 0.84987555E-07_JPRB, 0.89467266E-07_JPRB, 0.90037317E-07_JPRB, 0.89437102E-07_JPRB, 0.91280622E-07_JPRB, 0.92236574E-07_JPRB, &
  & 0.91863768E-07_JPRB, 0.93647102E-07_JPRB, 0.98531430E-07_JPRB, 0.10031639E-06_JPRB, 0.10497818E-06_JPRB, 0.11067623E-06_JPRB, &
  & 0.11190388E-06_JPRB, 0.10905300E-06_JPRB, 0.10829565E-06_JPRB, 0.10910810E-06_JPRB  /)

RGHG7(:,59, 5) = (/ &
  & 0.47307047E-07_JPRB, 0.44383983E-07_JPRB, 0.42069607E-07_JPRB, 0.42385672E-07_JPRB, 0.43958618E-07_JPRB, 0.42862379E-07_JPRB, &
  & 0.41557633E-07_JPRB, 0.39583768E-07_JPRB, 0.38572894E-07_JPRB, 0.39380858E-07_JPRB, 0.39062488E-07_JPRB, 0.38873170E-07_JPRB, &
  & 0.37802079E-07_JPRB, 0.36590175E-07_JPRB, 0.35378969E-07_JPRB, 0.34614776E-07_JPRB, 0.34376956E-07_JPRB, 0.34459723E-07_JPRB, &
  & 0.34888843E-07_JPRB, 0.35884961E-07_JPRB, 0.36228910E-07_JPRB, 0.37030592E-07_JPRB, 0.37977628E-07_JPRB, 0.37187807E-07_JPRB, &
  & 0.36293242E-07_JPRB, 0.36405385E-07_JPRB, 0.36699340E-07_JPRB, 0.37004369E-07_JPRB, 0.37019416E-07_JPRB, 0.36391304E-07_JPRB, &
  & 0.35726302E-07_JPRB, 0.35106210E-07_JPRB, 0.34777983E-07_JPRB, 0.34440628E-07_JPRB, 0.36697131E-07_JPRB, 0.41697183E-07_JPRB, &
  & 0.46197618E-07_JPRB, 0.49990482E-07_JPRB, 0.52757061E-07_JPRB, 0.55570823E-07_JPRB, 0.59124255E-07_JPRB, 0.62116349E-07_JPRB, &
  & 0.64101876E-07_JPRB, 0.67560514E-07_JPRB, 0.69864918E-07_JPRB, 0.72071727E-07_JPRB, 0.73514270E-07_JPRB, 0.75246731E-07_JPRB, &
  & 0.79004528E-07_JPRB, 0.81698448E-07_JPRB, 0.81656314E-07_JPRB, 0.80869492E-07_JPRB, 0.81981915E-07_JPRB, 0.82380869E-07_JPRB, &
  & 0.81714710E-07_JPRB, 0.82994659E-07_JPRB, 0.86443293E-07_JPRB, 0.87497575E-07_JPRB, 0.90667725E-07_JPRB, 0.94370314E-07_JPRB, &
  & 0.94736827E-07_JPRB, 0.92050381E-07_JPRB, 0.91428195E-07_JPRB, 0.91928027E-07_JPRB  /)

RGHG7(:,60, 5) = (/ &
  & 0.39375148E-07_JPRB, 0.37187121E-07_JPRB, 0.35476154E-07_JPRB, 0.35811333E-07_JPRB, 0.37200151E-07_JPRB, 0.36427513E-07_JPRB, &
  & 0.35523489E-07_JPRB, 0.34076626E-07_JPRB, 0.33499872E-07_JPRB, 0.34523465E-07_JPRB, 0.34496060E-07_JPRB, 0.34787166E-07_JPRB, &
  & 0.34372074E-07_JPRB, 0.33922206E-07_JPRB, 0.33318168E-07_JPRB, 0.32979514E-07_JPRB, 0.32974569E-07_JPRB, 0.33142294E-07_JPRB, &
  & 0.33583796E-07_JPRB, 0.34505242E-07_JPRB, 0.34947419E-07_JPRB, 0.35616982E-07_JPRB, 0.36710747E-07_JPRB, 0.36301947E-07_JPRB, &
  & 0.35447251E-07_JPRB, 0.35615056E-07_JPRB, 0.35969651E-07_JPRB, 0.36240990E-07_JPRB, 0.36343635E-07_JPRB, 0.35870833E-07_JPRB, &
  & 0.35318346E-07_JPRB, 0.34606514E-07_JPRB, 0.34220309E-07_JPRB, 0.33973034E-07_JPRB, 0.36523460E-07_JPRB, 0.41775652E-07_JPRB, &
  & 0.46199879E-07_JPRB, 0.49896173E-07_JPRB, 0.52419798E-07_JPRB, 0.55103603E-07_JPRB, 0.58486882E-07_JPRB, 0.61020329E-07_JPRB, &
  & 0.62797562E-07_JPRB, 0.65895152E-07_JPRB, 0.67751450E-07_JPRB, 0.69457270E-07_JPRB, 0.70450154E-07_JPRB, 0.71594392E-07_JPRB, &
  & 0.74055145E-07_JPRB, 0.75387990E-07_JPRB, 0.75004789E-07_JPRB, 0.74221142E-07_JPRB, 0.74784232E-07_JPRB, 0.74808633E-07_JPRB, &
  & 0.74085323E-07_JPRB, 0.75016510E-07_JPRB, 0.77297561E-07_JPRB, 0.77941456E-07_JPRB, 0.80066478E-07_JPRB, 0.82258237E-07_JPRB, &
  & 0.82064467E-07_JPRB, 0.79724844E-07_JPRB, 0.79292005E-07_JPRB, 0.79608603E-07_JPRB  /)

RGHG7(:,61, 5) = (/ &
  & 0.34141277E-07_JPRB, 0.32465151E-07_JPRB, 0.31180645E-07_JPRB, 0.31489536E-07_JPRB, 0.32735957E-07_JPRB, 0.32297039E-07_JPRB, &
  & 0.31633266E-07_JPRB, 0.30569780E-07_JPRB, 0.30232546E-07_JPRB, 0.31357643E-07_JPRB, 0.31533975E-07_JPRB, 0.32060220E-07_JPRB, &
  & 0.32019742E-07_JPRB, 0.32063518E-07_JPRB, 0.31876449E-07_JPRB, 0.31805064E-07_JPRB, 0.31958582E-07_JPRB, 0.32189107E-07_JPRB, &
  & 0.32649596E-07_JPRB, 0.33497288E-07_JPRB, 0.34042428E-07_JPRB, 0.34601725E-07_JPRB, 0.35648024E-07_JPRB, 0.35623332E-07_JPRB, &
  & 0.34810990E-07_JPRB, 0.34886054E-07_JPRB, 0.35250873E-07_JPRB, 0.35487890E-07_JPRB, 0.35526274E-07_JPRB, 0.35149133E-07_JPRB, &
  & 0.34708373E-07_JPRB, 0.33989970E-07_JPRB, 0.33486195E-07_JPRB, 0.33268130E-07_JPRB, 0.36070490E-07_JPRB, 0.41609667E-07_JPRB, &
  & 0.46134668E-07_JPRB, 0.49722156E-07_JPRB, 0.52037662E-07_JPRB, 0.54700289E-07_JPRB, 0.57895166E-07_JPRB, 0.60043044E-07_JPRB, &
  & 0.61763319E-07_JPRB, 0.64485563E-07_JPRB, 0.66061448E-07_JPRB, 0.67503651E-07_JPRB, 0.68183261E-07_JPRB, 0.69017875E-07_JPRB, &
  & 0.70578969E-07_JPRB, 0.71192525E-07_JPRB, 0.70717314E-07_JPRB, 0.70024947E-07_JPRB, 0.70254316E-07_JPRB, 0.70108570E-07_JPRB, &
  & 0.69521085E-07_JPRB, 0.70238311E-07_JPRB, 0.71820519E-07_JPRB, 0.72378246E-07_JPRB, 0.74051978E-07_JPRB, 0.75481363E-07_JPRB, &
  & 0.75107223E-07_JPRB, 0.73210127E-07_JPRB, 0.72897779E-07_JPRB, 0.73042770E-07_JPRB  /)

RGHG7(:,62, 5) = (/ &
  & 0.30247997E-07_JPRB, 0.28978462E-07_JPRB, 0.28001573E-07_JPRB, 0.28257928E-07_JPRB, 0.29363898E-07_JPRB, 0.29226637E-07_JPRB, &
  & 0.28747526E-07_JPRB, 0.27950442E-07_JPRB, 0.27758734E-07_JPRB, 0.28916131E-07_JPRB, 0.29271345E-07_JPRB, 0.29941297E-07_JPRB, &
  & 0.30177100E-07_JPRB, 0.30544839E-07_JPRB, 0.30690729E-07_JPRB, 0.30812425E-07_JPRB, 0.31113241E-07_JPRB, 0.31376135E-07_JPRB, &
  & 0.31860540E-07_JPRB, 0.32622935E-07_JPRB, 0.33261349E-07_JPRB, 0.33760922E-07_JPRB, 0.34694451E-07_JPRB, 0.34951510E-07_JPRB, &
  & 0.34279640E-07_JPRB, 0.34199540E-07_JPRB, 0.34505171E-07_JPRB, 0.34694339E-07_JPRB, 0.34588565E-07_JPRB, 0.34260943E-07_JPRB, &
  & 0.33813839E-07_JPRB, 0.33111359E-07_JPRB, 0.32447342E-07_JPRB, 0.32233470E-07_JPRB, 0.35305529E-07_JPRB, 0.41174362E-07_JPRB, &
  & 0.45990397E-07_JPRB, 0.49471555E-07_JPRB, 0.51593387E-07_JPRB, 0.54214160E-07_JPRB, 0.57107587E-07_JPRB, 0.59006265E-07_JPRB, &
  & 0.60750475E-07_JPRB, 0.63101622E-07_JPRB, 0.64542221E-07_JPRB, 0.65751862E-07_JPRB, 0.66201731E-07_JPRB, 0.66824426E-07_JPRB, &
  & 0.67689085E-07_JPRB, 0.67850172E-07_JPRB, 0.67387595E-07_JPRB, 0.66700761E-07_JPRB, 0.66723619E-07_JPRB, 0.66508798E-07_JPRB, &
  & 0.66052279E-07_JPRB, 0.66620079E-07_JPRB, 0.67756322E-07_JPRB, 0.68307843E-07_JPRB, 0.69734294E-07_JPRB, 0.70746760E-07_JPRB, &
  & 0.70300023E-07_JPRB, 0.68793615E-07_JPRB, 0.68559108E-07_JPRB, 0.68549183E-07_JPRB  /)

RGHG7(:,63, 5) = (/ &
  & 0.27190356E-07_JPRB, 0.26260258E-07_JPRB, 0.25515889E-07_JPRB, 0.25703859E-07_JPRB, 0.26665083E-07_JPRB, 0.26792695E-07_JPRB, &
  & 0.26461580E-07_JPRB, 0.25859264E-07_JPRB, 0.25754846E-07_JPRB, 0.26908521E-07_JPRB, 0.27423395E-07_JPRB, 0.28186331E-07_JPRB, &
  & 0.28640443E-07_JPRB, 0.29225831E-07_JPRB, 0.29640515E-07_JPRB, 0.29913302E-07_JPRB, 0.30351121E-07_JPRB, 0.30632730E-07_JPRB, &
  & 0.31148353E-07_JPRB, 0.31818227E-07_JPRB, 0.32529875E-07_JPRB, 0.33010147E-07_JPRB, 0.33814660E-07_JPRB, 0.34263405E-07_JPRB, &
  & 0.33794937E-07_JPRB, 0.33554459E-07_JPRB, 0.33733600E-07_JPRB, 0.33829160E-07_JPRB, 0.33560905E-07_JPRB, 0.33260173E-07_JPRB, &
  & 0.32705405E-07_JPRB, 0.31988024E-07_JPRB, 0.31170459E-07_JPRB, 0.30954262E-07_JPRB, 0.34291490E-07_JPRB, 0.40506467E-07_JPRB, &
  & 0.45680455E-07_JPRB, 0.49097401E-07_JPRB, 0.51050659E-07_JPRB, 0.53593212E-07_JPRB, 0.56110105E-07_JPRB, 0.57839130E-07_JPRB, &
  & 0.59675538E-07_JPRB, 0.61697877E-07_JPRB, 0.63074926E-07_JPRB, 0.64056082E-07_JPRB, 0.64349448E-07_JPRB, 0.64827860E-07_JPRB, &
  & 0.65118844E-07_JPRB, 0.64997927E-07_JPRB, 0.64598689E-07_JPRB, 0.63871407E-07_JPRB, 0.63760566E-07_JPRB, 0.63545347E-07_JPRB, &
  & 0.63200187E-07_JPRB, 0.63666586E-07_JPRB, 0.64533866E-07_JPRB, 0.65114149E-07_JPRB, 0.66408157E-07_JPRB, 0.67206608E-07_JPRB, &
  & 0.66745968E-07_JPRB, 0.65590342E-07_JPRB, 0.65421554E-07_JPRB, 0.65318191E-07_JPRB  /)

RGHG7(:,64, 5) = (/ &
  & 0.24960293E-07_JPRB, 0.24296952E-07_JPRB, 0.23710720E-07_JPRB, 0.23820420E-07_JPRB, 0.24629897E-07_JPRB, 0.24953184E-07_JPRB, &
  & 0.24729889E-07_JPRB, 0.24256160E-07_JPRB, 0.24186883E-07_JPRB, 0.25318195E-07_JPRB, 0.25964052E-07_JPRB, 0.26783694E-07_JPRB, &
  & 0.27403929E-07_JPRB, 0.28107521E-07_JPRB, 0.28706699E-07_JPRB, 0.29096092E-07_JPRB, 0.29651316E-07_JPRB, 0.29948100E-07_JPRB, &
  & 0.30506851E-07_JPRB, 0.31081684E-07_JPRB, 0.31823681E-07_JPRB, 0.32334302E-07_JPRB, 0.33041377E-07_JPRB, 0.33554815E-07_JPRB, &
  & 0.33337929E-07_JPRB, 0.32994422E-07_JPRB, 0.32955526E-07_JPRB, 0.32861001E-07_JPRB, 0.32472945E-07_JPRB, 0.32188985E-07_JPRB, &
  & 0.31399407E-07_JPRB, 0.30567816E-07_JPRB, 0.29663195E-07_JPRB, 0.29454186E-07_JPRB, 0.33016641E-07_JPRB, 0.39561469E-07_JPRB, &
  & 0.45050934E-07_JPRB, 0.48508611E-07_JPRB, 0.50347660E-07_JPRB, 0.52745653E-07_JPRB, 0.54829665E-07_JPRB, 0.56454063E-07_JPRB, &
  & 0.58466180E-07_JPRB, 0.60273676E-07_JPRB, 0.61619576E-07_JPRB, 0.62359533E-07_JPRB, 0.62599388E-07_JPRB, 0.63007516E-07_JPRB, &
  & 0.62844854E-07_JPRB, 0.62604136E-07_JPRB, 0.62284765E-07_JPRB, 0.61491992E-07_JPRB, 0.61303680E-07_JPRB, 0.61155549E-07_JPRB, &
  & 0.60873484E-07_JPRB, 0.61295957E-07_JPRB, 0.62086564E-07_JPRB, 0.62699592E-07_JPRB, 0.63943284E-07_JPRB, 0.64687425E-07_JPRB, &
  & 0.64249148E-07_JPRB, 0.63384240E-07_JPRB, 0.63292124E-07_JPRB, 0.63235084E-07_JPRB  /)

RGHG7(:,65, 5) = (/ &
  & 0.23406534E-07_JPRB, 0.22920552E-07_JPRB, 0.22430478E-07_JPRB, 0.22503683E-07_JPRB, 0.23155050E-07_JPRB, 0.23575152E-07_JPRB, &
  & 0.23411439E-07_JPRB, 0.23030109E-07_JPRB, 0.22959074E-07_JPRB, 0.24073056E-07_JPRB, 0.24809266E-07_JPRB, 0.25654082E-07_JPRB, &
  & 0.26399338E-07_JPRB, 0.27157363E-07_JPRB, 0.27856955E-07_JPRB, 0.28337827E-07_JPRB, 0.28952625E-07_JPRB, 0.29282540E-07_JPRB, &
  & 0.29880289E-07_JPRB, 0.30401726E-07_JPRB, 0.31122269E-07_JPRB, 0.31670905E-07_JPRB, 0.32317710E-07_JPRB, 0.32832405E-07_JPRB, &
  & 0.32765694E-07_JPRB, 0.32496778E-07_JPRB, 0.32209932E-07_JPRB, 0.31906777E-07_JPRB, 0.31467882E-07_JPRB, 0.31114592E-07_JPRB, &
  & 0.30074290E-07_JPRB, 0.29042874E-07_JPRB, 0.28086958E-07_JPRB, 0.28045758E-07_JPRB, 0.31742979E-07_JPRB, 0.38442513E-07_JPRB, &
  & 0.43992659E-07_JPRB, 0.47501786E-07_JPRB, 0.49340974E-07_JPRB, 0.51483287E-07_JPRB, 0.53257487E-07_JPRB, 0.54884248E-07_JPRB, &
  & 0.57062263E-07_JPRB, 0.58755860E-07_JPRB, 0.60087472E-07_JPRB, 0.60657982E-07_JPRB, 0.60913050E-07_JPRB, 0.61251846E-07_JPRB, &
  & 0.60791899E-07_JPRB, 0.60522642E-07_JPRB, 0.60311252E-07_JPRB, 0.59488913E-07_JPRB, 0.59262680E-07_JPRB, 0.59176203E-07_JPRB, &
  & 0.58989678E-07_JPRB, 0.59374579E-07_JPRB, 0.60213556E-07_JPRB, 0.60891544E-07_JPRB, 0.62176712E-07_JPRB, 0.62956075E-07_JPRB, &
  & 0.62587906E-07_JPRB, 0.61964641E-07_JPRB, 0.61983978E-07_JPRB, 0.62146816E-07_JPRB  /)

RGHG7(:,66, 5) = (/ &
  & 0.22131190E-07_JPRB, 0.21779054E-07_JPRB, 0.21362494E-07_JPRB, 0.21430327E-07_JPRB, 0.21934925E-07_JPRB, 0.22394247E-07_JPRB, &
  & 0.22275154E-07_JPRB, 0.21957276E-07_JPRB, 0.21866826E-07_JPRB, 0.22955235E-07_JPRB, 0.23767902E-07_JPRB, 0.24627615E-07_JPRB, &
  & 0.25483961E-07_JPRB, 0.26276796E-07_JPRB, 0.27051884E-07_JPRB, 0.27599485E-07_JPRB, 0.28236077E-07_JPRB, 0.28597816E-07_JPRB, &
  & 0.29216485E-07_JPRB, 0.29715875E-07_JPRB, 0.30397183E-07_JPRB, 0.30980789E-07_JPRB, 0.31602415E-07_JPRB, 0.32103194E-07_JPRB, &
  & 0.32101484E-07_JPRB, 0.31958771E-07_JPRB, 0.31475179E-07_JPRB, 0.31031078E-07_JPRB, 0.30514623E-07_JPRB, 0.30084250E-07_JPRB, &
  & 0.28864300E-07_JPRB, 0.27652589E-07_JPRB, 0.26718407E-07_JPRB, 0.26869310E-07_JPRB, 0.30589209E-07_JPRB, 0.37257515E-07_JPRB, &
  & 0.42717475E-07_JPRB, 0.46273576E-07_JPRB, 0.48088842E-07_JPRB, 0.50026738E-07_JPRB, 0.51584834E-07_JPRB, 0.53193521E-07_JPRB, &
  & 0.55535606E-07_JPRB, 0.57164879E-07_JPRB, 0.58490454E-07_JPRB, 0.58958936E-07_JPRB, 0.59256302E-07_JPRB, 0.59527703E-07_JPRB, &
  & 0.58852644E-07_JPRB, 0.58555139E-07_JPRB, 0.58458864E-07_JPRB, 0.57656416E-07_JPRB, 0.57416622E-07_JPRB, 0.57358937E-07_JPRB, &
  & 0.57303381E-07_JPRB, 0.57691941E-07_JPRB, 0.58602686E-07_JPRB, 0.59377812E-07_JPRB, 0.60752582E-07_JPRB, 0.61615952E-07_JPRB, &
  & 0.61369716E-07_JPRB, 0.60956361E-07_JPRB, 0.61092554E-07_JPRB, 0.61492946E-07_JPRB  /)

RGHG7(:,67, 5) = (/ &
  & 0.21091068E-07_JPRB, 0.20834538E-07_JPRB, 0.20474934E-07_JPRB, 0.20560143E-07_JPRB, 0.20937745E-07_JPRB, 0.21386843E-07_JPRB, &
  & 0.21305449E-07_JPRB, 0.21018420E-07_JPRB, 0.20893248E-07_JPRB, 0.21945491E-07_JPRB, 0.22818774E-07_JPRB, 0.23692460E-07_JPRB, &
  & 0.24638558E-07_JPRB, 0.25462713E-07_JPRB, 0.26287499E-07_JPRB, 0.26875650E-07_JPRB, 0.27506784E-07_JPRB, 0.27893525E-07_JPRB, &
  & 0.28510287E-07_JPRB, 0.29010439E-07_JPRB, 0.29642298E-07_JPRB, 0.30258905E-07_JPRB, 0.30887819E-07_JPRB, 0.31373188E-07_JPRB, &
  & 0.31372112E-07_JPRB, 0.31356597E-07_JPRB, 0.30754844E-07_JPRB, 0.30201950E-07_JPRB, 0.29587072E-07_JPRB, 0.29109993E-07_JPRB, &
  & 0.27795955E-07_JPRB, 0.26457826E-07_JPRB, 0.25583707E-07_JPRB, 0.25904415E-07_JPRB, 0.29537418E-07_JPRB, 0.35980567E-07_JPRB, &
  & 0.41232578E-07_JPRB, 0.44836703E-07_JPRB, 0.46628427E-07_JPRB, 0.48449655E-07_JPRB, 0.49878634E-07_JPRB, 0.51445913E-07_JPRB, &
  & 0.53915524E-07_JPRB, 0.55532529E-07_JPRB, 0.56868556E-07_JPRB, 0.57289358E-07_JPRB, 0.57638083E-07_JPRB, 0.57853506E-07_JPRB, &
  & 0.57033746E-07_JPRB, 0.56701597E-07_JPRB, 0.56717395E-07_JPRB, 0.55989125E-07_JPRB, 0.55756541E-07_JPRB, 0.55693863E-07_JPRB, &
  & 0.55800963E-07_JPRB, 0.56251684E-07_JPRB, 0.57239541E-07_JPRB, 0.58146544E-07_JPRB, 0.59648871E-07_JPRB, 0.60637048E-07_JPRB, &
  & 0.60573135E-07_JPRB, 0.60337669E-07_JPRB, 0.60580199E-07_JPRB, 0.61196519E-07_JPRB  /)

RGHG7(:,68, 5) = (/ &
  & 0.20243755E-07_JPRB, 0.20050372E-07_JPRB, 0.19738334E-07_JPRB, 0.19846505E-07_JPRB, 0.20128976E-07_JPRB, 0.20530509E-07_JPRB, &
  & 0.20491760E-07_JPRB, 0.20195710E-07_JPRB, 0.20022152E-07_JPRB, 0.21025190E-07_JPRB, 0.21935377E-07_JPRB, 0.22838586E-07_JPRB, &
  & 0.23833890E-07_JPRB, 0.24712991E-07_JPRB, 0.25550079E-07_JPRB, 0.26151351E-07_JPRB, 0.26770183E-07_JPRB, 0.27167586E-07_JPRB, &
  & 0.27753185E-07_JPRB, 0.28259077E-07_JPRB, 0.28840910E-07_JPRB, 0.29493602E-07_JPRB, 0.30155319E-07_JPRB, 0.30643969E-07_JPRB, &
  & 0.30624850E-07_JPRB, 0.30653621E-07_JPRB, 0.30050227E-07_JPRB, 0.29322653E-07_JPRB, 0.28620025E-07_JPRB, 0.28192152E-07_JPRB, &
  & 0.26878114E-07_JPRB, 0.25517023E-07_JPRB, 0.24656845E-07_JPRB, 0.25053821E-07_JPRB, 0.28504764E-07_JPRB, 0.34520645E-07_JPRB, &
  & 0.39502025E-07_JPRB, 0.43170938E-07_JPRB, 0.45020067E-07_JPRB, 0.46853597E-07_JPRB, 0.48225170E-07_JPRB, 0.49747344E-07_JPRB, &
  & 0.52234177E-07_JPRB, 0.53903668E-07_JPRB, 0.55285619E-07_JPRB, 0.55681819E-07_JPRB, 0.56060068E-07_JPRB, 0.56250067E-07_JPRB, &
  & 0.55339277E-07_JPRB, 0.54969404E-07_JPRB, 0.55077872E-07_JPRB, 0.54484098E-07_JPRB, 0.54273656E-07_JPRB, 0.54177355E-07_JPRB, &
  & 0.54470615E-07_JPRB, 0.55070593E-07_JPRB, 0.56122417E-07_JPRB, 0.57201640E-07_JPRB, 0.58855684E-07_JPRB, 0.59999679E-07_JPRB, &
  & 0.60195735E-07_JPRB, 0.60106246E-07_JPRB, 0.60417664E-07_JPRB, 0.61177500E-07_JPRB  /)

RGHG7(:,69, 5) = (/ &
  & 0.19547061E-07_JPRB, 0.19397407E-07_JPRB, 0.19117251E-07_JPRB, 0.19239424E-07_JPRB, 0.19458131E-07_JPRB, 0.19806136E-07_JPRB, &
  & 0.19785393E-07_JPRB, 0.19469127E-07_JPRB, 0.19253910E-07_JPRB, 0.20180882E-07_JPRB, 0.21078704E-07_JPRB, 0.22017402E-07_JPRB, &
  & 0.23055931E-07_JPRB, 0.23989222E-07_JPRB, 0.24828905E-07_JPRB, 0.25417920E-07_JPRB, 0.26034902E-07_JPRB, 0.26426543E-07_JPRB, &
  & 0.26962324E-07_JPRB, 0.27444100E-07_JPRB, 0.27987113E-07_JPRB, 0.28681107E-07_JPRB, 0.29353230E-07_JPRB, 0.29918306E-07_JPRB, &
  & 0.29881149E-07_JPRB, 0.29831787E-07_JPRB, 0.29240189E-07_JPRB, 0.28324533E-07_JPRB, 0.27596868E-07_JPRB, 0.27225655E-07_JPRB, &
  & 0.25912363E-07_JPRB, 0.24540256E-07_JPRB, 0.23596986E-07_JPRB, 0.24047825E-07_JPRB, 0.27270465E-07_JPRB, 0.32750182E-07_JPRB, &
  & 0.37519946E-07_JPRB, 0.41190191E-07_JPRB, 0.43419159E-07_JPRB, 0.45404564E-07_JPRB, 0.46762778E-07_JPRB, 0.48213731E-07_JPRB, &
  & 0.50622991E-07_JPRB, 0.52374068E-07_JPRB, 0.53813878E-07_JPRB, 0.54169059E-07_JPRB, 0.54519353E-07_JPRB, 0.54722747E-07_JPRB, &
  & 0.53791105E-07_JPRB, 0.53418595E-07_JPRB, 0.53540598E-07_JPRB, 0.53110404E-07_JPRB, 0.52910158E-07_JPRB, 0.52817559E-07_JPRB, &
  & 0.53314114E-07_JPRB, 0.54054364E-07_JPRB, 0.55208210E-07_JPRB, 0.56508883E-07_JPRB, 0.58342979E-07_JPRB, 0.59658437E-07_JPRB, &
  & 0.60168155E-07_JPRB, 0.60191028E-07_JPRB, 0.60547436E-07_JPRB, 0.61408964E-07_JPRB  /)

RGHG7(:,70, 5) = (/ &
  & 0.18941502E-07_JPRB, 0.18820405E-07_JPRB, 0.18556349E-07_JPRB, 0.18684995E-07_JPRB, 0.18853867E-07_JPRB, 0.19150507E-07_JPRB, &
  & 0.19113443E-07_JPRB, 0.18786302E-07_JPRB, 0.18537631E-07_JPRB, 0.19369051E-07_JPRB, 0.20239135E-07_JPRB, 0.21196826E-07_JPRB, &
  & 0.22280460E-07_JPRB, 0.23261779E-07_JPRB, 0.24105012E-07_JPRB, 0.24684957E-07_JPRB, 0.25293016E-07_JPRB, 0.25669161E-07_JPRB, &
  & 0.26153183E-07_JPRB, 0.26589260E-07_JPRB, 0.27109254E-07_JPRB, 0.27824179E-07_JPRB, 0.28508807E-07_JPRB, 0.29135285E-07_JPRB, &
  & 0.29119609E-07_JPRB, 0.28934599E-07_JPRB, 0.28338036E-07_JPRB, 0.27281206E-07_JPRB, 0.26518442E-07_JPRB, 0.26140401E-07_JPRB, &
  & 0.24832220E-07_JPRB, 0.23424519E-07_JPRB, 0.22437499E-07_JPRB, 0.22930088E-07_JPRB, 0.25932744E-07_JPRB, 0.30874478E-07_JPRB, &
  & 0.35493787E-07_JPRB, 0.39118116E-07_JPRB, 0.41770954E-07_JPRB, 0.43958060E-07_JPRB, 0.45376341E-07_JPRB, 0.46795291E-07_JPRB, &
  & 0.49117464E-07_JPRB, 0.50974132E-07_JPRB, 0.52434970E-07_JPRB, 0.52733131E-07_JPRB, 0.53029248E-07_JPRB, 0.53236074E-07_JPRB, &
  & 0.52346702E-07_JPRB, 0.51974536E-07_JPRB, 0.52064165E-07_JPRB, 0.51794078E-07_JPRB, 0.51598581E-07_JPRB, 0.51542447E-07_JPRB, &
  & 0.52225333E-07_JPRB, 0.53101439E-07_JPRB, 0.54376995E-07_JPRB, 0.55935877E-07_JPRB, 0.57967005E-07_JPRB, 0.59465348E-07_JPRB, &
  & 0.60261775E-07_JPRB, 0.60364847E-07_JPRB, 0.60736335E-07_JPRB, 0.61735187E-07_JPRB  /)

RGHG7(:,71, 5) = (/ &
  & 0.18420569E-07_JPRB, 0.18309478E-07_JPRB, 0.18045799E-07_JPRB, 0.18173608E-07_JPRB, 0.18304509E-07_JPRB, 0.18549791E-07_JPRB, &
  & 0.18470399E-07_JPRB, 0.18142866E-07_JPRB, 0.17870397E-07_JPRB, 0.18587582E-07_JPRB, 0.19417793E-07_JPRB, 0.20381436E-07_JPRB, &
  & 0.21505076E-07_JPRB, 0.22522494E-07_JPRB, 0.23369829E-07_JPRB, 0.23945879E-07_JPRB, 0.24539150E-07_JPRB, 0.24891455E-07_JPRB, &
  & 0.25323101E-07_JPRB, 0.25703955E-07_JPRB, 0.26212867E-07_JPRB, 0.26925067E-07_JPRB, 0.27620963E-07_JPRB, 0.28280016E-07_JPRB, &
  & 0.28294816E-07_JPRB, 0.27945320E-07_JPRB, 0.27331923E-07_JPRB, 0.26193095E-07_JPRB, 0.25376682E-07_JPRB, 0.24934907E-07_JPRB, &
  & 0.23632254E-07_JPRB, 0.22161650E-07_JPRB, 0.21185845E-07_JPRB, 0.21724722E-07_JPRB, 0.24538358E-07_JPRB, 0.28991761E-07_JPRB, &
  & 0.33490857E-07_JPRB, 0.37029476E-07_JPRB, 0.40069788E-07_JPRB, 0.42487351E-07_JPRB, 0.44043623E-07_JPRB, 0.45479534E-07_JPRB, &
  & 0.47732402E-07_JPRB, 0.49709008E-07_JPRB, 0.51167615E-07_JPRB, 0.51392209E-07_JPRB, 0.51608775E-07_JPRB, 0.51805102E-07_JPRB, &
  & 0.51005938E-07_JPRB, 0.50623437E-07_JPRB, 0.50654955E-07_JPRB, 0.50506650E-07_JPRB, 0.50333880E-07_JPRB, 0.50333806E-07_JPRB, &
  & 0.51177430E-07_JPRB, 0.52185383E-07_JPRB, 0.53586791E-07_JPRB, 0.55427463E-07_JPRB, 0.57667063E-07_JPRB, 0.59353731E-07_JPRB, &
  & 0.60390929E-07_JPRB, 0.60543848E-07_JPRB, 0.60912268E-07_JPRB, 0.62082236E-07_JPRB  /)

RGHG7(:,72, 5) = (/ &
  & 0.17984338E-07_JPRB, 0.17856829E-07_JPRB, 0.17577553E-07_JPRB, 0.17697152E-07_JPRB, 0.17801784E-07_JPRB, 0.17989602E-07_JPRB, &
  & 0.17859314E-07_JPRB, 0.17539989E-07_JPRB, 0.17256028E-07_JPRB, 0.17839404E-07_JPRB, 0.18616255E-07_JPRB, 0.19584003E-07_JPRB, &
  & 0.20727344E-07_JPRB, 0.21758719E-07_JPRB, 0.22607696E-07_JPRB, 0.23182924E-07_JPRB, 0.23761419E-07_JPRB, 0.24082529E-07_JPRB, &
  & 0.24459994E-07_JPRB, 0.24797340E-07_JPRB, 0.25298864E-07_JPRB, 0.25983153E-07_JPRB, 0.26677407E-07_JPRB, 0.27331535E-07_JPRB, &
  & 0.27318423E-07_JPRB, 0.26816237E-07_JPRB, 0.26189706E-07_JPRB, 0.25040206E-07_JPRB, 0.24149911E-07_JPRB, 0.23613730E-07_JPRB, &
  & 0.22308615E-07_JPRB, 0.20749352E-07_JPRB, 0.19842504E-07_JPRB, 0.20462651E-07_JPRB, 0.23150688E-07_JPRB, 0.27242068E-07_JPRB, &
  & 0.31590936E-07_JPRB, 0.35013806E-07_JPRB, 0.38308601E-07_JPRB, 0.40965051E-07_JPRB, 0.42742148E-07_JPRB, 0.44250300E-07_JPRB, &
  & 0.46486750E-07_JPRB, 0.48580747E-07_JPRB, 0.50050025E-07_JPRB, 0.50182677E-07_JPRB, 0.50288420E-07_JPRB, 0.50462582E-07_JPRB, &
  & 0.49775062E-07_JPRB, 0.49351516E-07_JPRB, 0.49330495E-07_JPRB, 0.49204354E-07_JPRB, 0.49116959E-07_JPRB, 0.49168603E-07_JPRB, &
  & 0.50137827E-07_JPRB, 0.51273842E-07_JPRB, 0.52779507E-07_JPRB, 0.54904215E-07_JPRB, 0.57356432E-07_JPRB, 0.59226985E-07_JPRB, &
  & 0.60439037E-07_JPRB, 0.60614121E-07_JPRB, 0.60985004E-07_JPRB, 0.62341319E-07_JPRB  /)

RGHG7(:,73, 5) = (/ &
  & 0.17623492E-07_JPRB, 0.17456612E-07_JPRB, 0.17141837E-07_JPRB, 0.17245561E-07_JPRB, 0.17334438E-07_JPRB, 0.17457601E-07_JPRB, &
  & 0.17287549E-07_JPRB, 0.16966576E-07_JPRB, 0.16668008E-07_JPRB, 0.17144989E-07_JPRB, 0.17868171E-07_JPRB, 0.18814142E-07_JPRB, &
  & 0.19923204E-07_JPRB, 0.20950329E-07_JPRB, 0.21791814E-07_JPRB, 0.22354026E-07_JPRB, 0.22909278E-07_JPRB, 0.23190631E-07_JPRB, &
  & 0.23542554E-07_JPRB, 0.23846044E-07_JPRB, 0.24343946E-07_JPRB, 0.25011591E-07_JPRB, 0.25636383E-07_JPRB, 0.26152983E-07_JPRB, &
  & 0.26004369E-07_JPRB, 0.25462132E-07_JPRB, 0.24888676E-07_JPRB, 0.23793967E-07_JPRB, 0.22875075E-07_JPRB, 0.22259941E-07_JPRB, &
  & 0.20985873E-07_JPRB, 0.19396104E-07_JPRB, 0.18457279E-07_JPRB, 0.19197264E-07_JPRB, 0.21895354E-07_JPRB, 0.25796325E-07_JPRB, &
  & 0.29896568E-07_JPRB, 0.33184732E-07_JPRB, 0.36618153E-07_JPRB, 0.39440970E-07_JPRB, 0.41427224E-07_JPRB, 0.43114703E-07_JPRB, &
  & 0.45386449E-07_JPRB, 0.47618328E-07_JPRB, 0.49077007E-07_JPRB, 0.49123278E-07_JPRB, 0.49125173E-07_JPRB, 0.49270946E-07_JPRB, &
  & 0.48640862E-07_JPRB, 0.48143269E-07_JPRB, 0.48073976E-07_JPRB, 0.47923652E-07_JPRB, 0.47936604E-07_JPRB, 0.48040266E-07_JPRB, &
  & 0.49090866E-07_JPRB, 0.50293973E-07_JPRB, 0.51846593E-07_JPRB, 0.54257749E-07_JPRB, 0.56884959E-07_JPRB, 0.58878750E-07_JPRB, &
  & 0.60185148E-07_JPRB, 0.60404621E-07_JPRB, 0.60835886E-07_JPRB, 0.62326297E-07_JPRB  /)

RGHG7(:,74, 5) = (/ &
  & 0.17298703E-07_JPRB, 0.17078666E-07_JPRB, 0.16725271E-07_JPRB, 0.16805551E-07_JPRB, 0.16886514E-07_JPRB, 0.16946469E-07_JPRB, &
  & 0.16739617E-07_JPRB, 0.16416169E-07_JPRB, 0.16109687E-07_JPRB, 0.16511444E-07_JPRB, 0.17176032E-07_JPRB, 0.18068825E-07_JPRB, &
  & 0.19130180E-07_JPRB, 0.20123769E-07_JPRB, 0.20947088E-07_JPRB, 0.21493289E-07_JPRB, 0.22010234E-07_JPRB, 0.22249666E-07_JPRB, &
  & 0.22586415E-07_JPRB, 0.22866811E-07_JPRB, 0.23373805E-07_JPRB, 0.24030233E-07_JPRB, 0.24560104E-07_JPRB, 0.24900409E-07_JPRB, &
  & 0.24596480E-07_JPRB, 0.24042548E-07_JPRB, 0.23533630E-07_JPRB, 0.22517997E-07_JPRB, 0.21637801E-07_JPRB, 0.20952039E-07_JPRB, &
  & 0.19738076E-07_JPRB, 0.18189151E-07_JPRB, 0.17182628E-07_JPRB, 0.18021277E-07_JPRB, 0.20774530E-07_JPRB, 0.24578553E-07_JPRB, &
  & 0.28446451E-07_JPRB, 0.31565741E-07_JPRB, 0.35060971E-07_JPRB, 0.38009672E-07_JPRB, 0.40154302E-07_JPRB, 0.42042815E-07_JPRB, &
  & 0.44376477E-07_JPRB, 0.46757232E-07_JPRB, 0.48190645E-07_JPRB, 0.48174890E-07_JPRB, 0.48089003E-07_JPRB, 0.48179126E-07_JPRB, &
  & 0.47586982E-07_JPRB, 0.47013142E-07_JPRB, 0.46894996E-07_JPRB, 0.46703727E-07_JPRB, 0.46796863E-07_JPRB, 0.46926734E-07_JPRB, &
  & 0.48020698E-07_JPRB, 0.49206381E-07_JPRB, 0.50831820E-07_JPRB, 0.53479747E-07_JPRB, 0.56285537E-07_JPRB, 0.58317025E-07_JPRB, &
  & 0.59644964E-07_JPRB, 0.59879417E-07_JPRB, 0.60334233E-07_JPRB, 0.61805981E-07_JPRB  /)

RGHG7(:,75, 5) = (/ &
  & 0.16998247E-07_JPRB, 0.16716399E-07_JPRB, 0.16328956E-07_JPRB, 0.16378299E-07_JPRB, 0.16455288E-07_JPRB, 0.16455110E-07_JPRB, &
  & 0.16215142E-07_JPRB, 0.15888997E-07_JPRB, 0.15581042E-07_JPRB, 0.15939338E-07_JPRB, 0.16547430E-07_JPRB, 0.17364162E-07_JPRB, &
  & 0.18367931E-07_JPRB, 0.19301261E-07_JPRB, 0.20083750E-07_JPRB, 0.20612668E-07_JPRB, 0.21084381E-07_JPRB, 0.21285335E-07_JPRB, &
  & 0.21609481E-07_JPRB, 0.21880464E-07_JPRB, 0.22393148E-07_JPRB, 0.23028389E-07_JPRB, 0.23471815E-07_JPRB, 0.23640398E-07_JPRB, &
  & 0.23205254E-07_JPRB, 0.22640325E-07_JPRB, 0.22173119E-07_JPRB, 0.21235427E-07_JPRB, 0.20429519E-07_JPRB, 0.19703832E-07_JPRB, &
  & 0.18576096E-07_JPRB, 0.17129442E-07_JPRB, 0.16052557E-07_JPRB, 0.16954184E-07_JPRB, 0.19773433E-07_JPRB, 0.23569840E-07_JPRB, &
  & 0.27234388E-07_JPRB, 0.30157429E-07_JPRB, 0.33660395E-07_JPRB, 0.36679236E-07_JPRB, 0.38958509E-07_JPRB, 0.41031967E-07_JPRB, &
  & 0.43456034E-07_JPRB, 0.45998331E-07_JPRB, 0.47388226E-07_JPRB, 0.47337295E-07_JPRB, 0.47182911E-07_JPRB, 0.47186831E-07_JPRB, &
  & 0.46614032E-07_JPRB, 0.45979706E-07_JPRB, 0.45802633E-07_JPRB, 0.45570623E-07_JPRB, 0.45700274E-07_JPRB, 0.45814422E-07_JPRB, &
  & 0.46903274E-07_JPRB, 0.48026503E-07_JPRB, 0.49746305E-07_JPRB, 0.52579553E-07_JPRB, 0.55556228E-07_JPRB, 0.57575488E-07_JPRB, &
  & 0.58888480E-07_JPRB, 0.59120810E-07_JPRB, 0.59533776E-07_JPRB, 0.60880931E-07_JPRB  /)

RGHG7(:,76, 5) = (/ &
  & 0.16709004E-07_JPRB, 0.16363110E-07_JPRB, 0.15955960E-07_JPRB, 0.15966711E-07_JPRB, 0.16037952E-07_JPRB, 0.15981939E-07_JPRB, &
  & 0.15714874E-07_JPRB, 0.15385445E-07_JPRB, 0.15080774E-07_JPRB, 0.15428396E-07_JPRB, 0.15993790E-07_JPRB, 0.16725127E-07_JPRB, &
  & 0.17660744E-07_JPRB, 0.18511963E-07_JPRB, 0.19211521E-07_JPRB, 0.19723196E-07_JPRB, 0.20156316E-07_JPRB, 0.20330174E-07_JPRB, &
  & 0.20634613E-07_JPRB, 0.20914628E-07_JPRB, 0.21402679E-07_JPRB, 0.21982906E-07_JPRB, 0.22395951E-07_JPRB, 0.22452042E-07_JPRB, &
  & 0.21966811E-07_JPRB, 0.21360005E-07_JPRB, 0.20864881E-07_JPRB, 0.19969887E-07_JPRB, 0.19221457E-07_JPRB, 0.18523687E-07_JPRB, &
  & 0.17505158E-07_JPRB, 0.16206304E-07_JPRB, 0.15099038E-07_JPRB, 0.16012982E-07_JPRB, 0.18868359E-07_JPRB, 0.22753445E-07_JPRB, &
  & 0.26247204E-07_JPRB, 0.28958399E-07_JPRB, 0.32444121E-07_JPRB, 0.35447362E-07_JPRB, 0.37885930E-07_JPRB, 0.40080911E-07_JPRB, &
  & 0.42631428E-07_JPRB, 0.45352727E-07_JPRB, 0.46673649E-07_JPRB, 0.46616149E-07_JPRB, 0.46416605E-07_JPRB, 0.46300643E-07_JPRB, &
  & 0.45724559E-07_JPRB, 0.45069705E-07_JPRB, 0.44808880E-07_JPRB, 0.44558805E-07_JPRB, 0.44648222E-07_JPRB, 0.44681901E-07_JPRB, &
  & 0.45698496E-07_JPRB, 0.46779027E-07_JPRB, 0.48596541E-07_JPRB, 0.51567735E-07_JPRB, 0.54683998E-07_JPRB, 0.56699974E-07_JPRB, &
  & 0.58017072E-07_JPRB, 0.58256792E-07_JPRB, 0.58529349E-07_JPRB, 0.59731988E-07_JPRB  /)

RGHG7(:,77, 5) = (/ &
  & 0.16419606E-07_JPRB, 0.16024548E-07_JPRB, 0.15611628E-07_JPRB, 0.15583236E-07_JPRB, 0.15639170E-07_JPRB, 0.15534423E-07_JPRB, &
  & 0.15240665E-07_JPRB, 0.14901586E-07_JPRB, 0.14586029E-07_JPRB, 0.14944150E-07_JPRB, 0.15483614E-07_JPRB, 0.16128337E-07_JPRB, &
  & 0.16952178E-07_JPRB, 0.17725643E-07_JPRB, 0.18370311E-07_JPRB, 0.18838431E-07_JPRB, 0.19233198E-07_JPRB, 0.19438812E-07_JPRB, &
  & 0.19786451E-07_JPRB, 0.20109591E-07_JPRB, 0.20567918E-07_JPRB, 0.21061541E-07_JPRB, 0.21509330E-07_JPRB, 0.21541367E-07_JPRB, &
  & 0.21105645E-07_JPRB, 0.20422401E-07_JPRB, 0.19804970E-07_JPRB, 0.18859289E-07_JPRB, 0.18104389E-07_JPRB, 0.17533667E-07_JPRB, &
  & 0.16602208E-07_JPRB, 0.15430357E-07_JPRB, 0.14383109E-07_JPRB, 0.15260574E-07_JPRB, 0.18107575E-07_JPRB, 0.22120519E-07_JPRB, &
  & 0.25478173E-07_JPRB, 0.28065332E-07_JPRB, 0.31499601E-07_JPRB, 0.34396185E-07_JPRB, 0.36919705E-07_JPRB, 0.39177916E-07_JPRB, &
  & 0.41829044E-07_JPRB, 0.44734268E-07_JPRB, 0.46055529E-07_JPRB, 0.46022961E-07_JPRB, 0.45810785E-07_JPRB, 0.45571651E-07_JPRB, &
  & 0.44990656E-07_JPRB, 0.44288127E-07_JPRB, 0.43944723E-07_JPRB, 0.43662898E-07_JPRB, 0.43707558E-07_JPRB, 0.43606700E-07_JPRB, &
  & 0.44515253E-07_JPRB, 0.45460855E-07_JPRB, 0.47333243E-07_JPRB, 0.50359837E-07_JPRB, 0.53560021E-07_JPRB, 0.55433652E-07_JPRB, &
  & 0.56743066E-07_JPRB, 0.56770702E-07_JPRB, 0.56892158E-07_JPRB, 0.57896090E-07_JPRB  /)

RGHG7(:,78, 5) = (/ &
  & 0.16133256E-07_JPRB, 0.15708017E-07_JPRB, 0.15285355E-07_JPRB, 0.15216877E-07_JPRB, 0.15262322E-07_JPRB, 0.15114702E-07_JPRB, &
  & 0.14789083E-07_JPRB, 0.14448501E-07_JPRB, 0.14113386E-07_JPRB, 0.14481018E-07_JPRB, 0.14996099E-07_JPRB, 0.15569799E-07_JPRB, &
  & 0.16277234E-07_JPRB, 0.16973474E-07_JPRB, 0.17586151E-07_JPRB, 0.18018421E-07_JPRB, 0.18418884E-07_JPRB, 0.18696392E-07_JPRB, &
  & 0.19079956E-07_JPRB, 0.19441590E-07_JPRB, 0.19876370E-07_JPRB, 0.20313703E-07_JPRB, 0.20772189E-07_JPRB, 0.20795176E-07_JPRB, &
  & 0.20412672E-07_JPRB, 0.19677286E-07_JPRB, 0.18936508E-07_JPRB, 0.17948414E-07_JPRB, 0.17203116E-07_JPRB, 0.16744328E-07_JPRB, &
  & 0.15861379E-07_JPRB, 0.14768906E-07_JPRB, 0.13802822E-07_JPRB, 0.14666115E-07_JPRB, 0.17495974E-07_JPRB, 0.21611486E-07_JPRB, &
  & 0.24855545E-07_JPRB, 0.27400642E-07_JPRB, 0.30749508E-07_JPRB, 0.33514726E-07_JPRB, 0.36090236E-07_JPRB, 0.38390782E-07_JPRB, &
  & 0.41095773E-07_JPRB, 0.44142204E-07_JPRB, 0.45487184E-07_JPRB, 0.45487005E-07_JPRB, 0.45291005E-07_JPRB, 0.44944840E-07_JPRB, &
  & 0.44355689E-07_JPRB, 0.43585130E-07_JPRB, 0.43160048E-07_JPRB, 0.42833146E-07_JPRB, 0.42822918E-07_JPRB, 0.42603557E-07_JPRB, &
  & 0.43378174E-07_JPRB, 0.44137206E-07_JPRB, 0.46077244E-07_JPRB, 0.49045551E-07_JPRB, 0.52265995E-07_JPRB, 0.53950495E-07_JPRB, &
  & 0.55314537E-07_JPRB, 0.55039477E-07_JPRB, 0.54924133E-07_JPRB, 0.55640384E-07_JPRB  /)

RGHG7(:,79, 5) = (/ &
  & 0.15850169E-07_JPRB, 0.15410375E-07_JPRB, 0.14971375E-07_JPRB, 0.14865589E-07_JPRB, 0.14904918E-07_JPRB, 0.14715022E-07_JPRB, &
  & 0.14358139E-07_JPRB, 0.14018227E-07_JPRB, 0.13668905E-07_JPRB, 0.14048482E-07_JPRB, 0.14544879E-07_JPRB, 0.15055058E-07_JPRB, &
  & 0.15662333E-07_JPRB, 0.16278869E-07_JPRB, 0.16857768E-07_JPRB, 0.17270803E-07_JPRB, 0.17710778E-07_JPRB, 0.18084472E-07_JPRB, &
  & 0.18506194E-07_JPRB, 0.18903042E-07_JPRB, 0.19323267E-07_JPRB, 0.19727612E-07_JPRB, 0.20171137E-07_JPRB, 0.20187924E-07_JPRB, &
  & 0.19842704E-07_JPRB, 0.19079632E-07_JPRB, 0.18248295E-07_JPRB, 0.17236310E-07_JPRB, 0.16507183E-07_JPRB, 0.16141743E-07_JPRB, &
  & 0.15273936E-07_JPRB, 0.14221417E-07_JPRB, 0.13343511E-07_JPRB, 0.14215756E-07_JPRB, 0.17038399E-07_JPRB, 0.21232992E-07_JPRB, &
  & 0.24359141E-07_JPRB, 0.26909049E-07_JPRB, 0.30127294E-07_JPRB, 0.32767575E-07_JPRB, 0.35348315E-07_JPRB, 0.37716620E-07_JPRB, &
  & 0.40472075E-07_JPRB, 0.43593613E-07_JPRB, 0.44958797E-07_JPRB, 0.44994131E-07_JPRB, 0.44825828E-07_JPRB, 0.44391425E-07_JPRB, &
  & 0.43789994E-07_JPRB, 0.42937553E-07_JPRB, 0.42428900E-07_JPRB, 0.42057341E-07_JPRB, 0.41972603E-07_JPRB, 0.41656410E-07_JPRB, &
  & 0.42284019E-07_JPRB, 0.42856341E-07_JPRB, 0.44820485E-07_JPRB, 0.47634280E-07_JPRB, 0.50781698E-07_JPRB, 0.52302733E-07_JPRB, &
  & 0.53722300E-07_JPRB, 0.53140956E-07_JPRB, 0.52755990E-07_JPRB, 0.53009745E-07_JPRB  /)

RGHG7(:,80, 5) = (/ &
  & 0.15571628E-07_JPRB, 0.15128329E-07_JPRB, 0.14664680E-07_JPRB, 0.14528368E-07_JPRB, 0.14564343E-07_JPRB, 0.14327071E-07_JPRB, &
  & 0.13946246E-07_JPRB, 0.13601376E-07_JPRB, 0.13258444E-07_JPRB, 0.13657405E-07_JPRB, 0.14145942E-07_JPRB, 0.14589394E-07_JPRB, &
  & 0.15133784E-07_JPRB, 0.15664711E-07_JPRB, 0.16180358E-07_JPRB, 0.16597985E-07_JPRB, 0.17096100E-07_JPRB, 0.17573621E-07_JPRB, &
  & 0.18051204E-07_JPRB, 0.18484253E-07_JPRB, 0.18901165E-07_JPRB, 0.19283356E-07_JPRB, 0.19690864E-07_JPRB, 0.19695260E-07_JPRB, &
  & 0.19356040E-07_JPRB, 0.18585262E-07_JPRB, 0.17727813E-07_JPRB, 0.16715234E-07_JPRB, 0.15992905E-07_JPRB, 0.15706155E-07_JPRB, &
  & 0.14827685E-07_JPRB, 0.13787577E-07_JPRB, 0.12992942E-07_JPRB, 0.13892649E-07_JPRB, 0.16735955E-07_JPRB, 0.20993360E-07_JPRB, &
  & 0.23968088E-07_JPRB, 0.26531402E-07_JPRB, 0.29561028E-07_JPRB, 0.32113725E-07_JPRB, 0.34635303E-07_JPRB, 0.37146092E-07_JPRB, &
  & 0.39998895E-07_JPRB, 0.43107347E-07_JPRB, 0.44461929E-07_JPRB, 0.44532890E-07_JPRB, 0.44384349E-07_JPRB, 0.43882316E-07_JPRB, &
  & 0.43263944E-07_JPRB, 0.42323345E-07_JPRB, 0.41725689E-07_JPRB, 0.41325443E-07_JPRB, 0.41136742E-07_JPRB, 0.40747816E-07_JPRB, &
  & 0.41229709E-07_JPRB, 0.41670997E-07_JPRB, 0.43549824E-07_JPRB, 0.46135090E-07_JPRB, 0.49086977E-07_JPRB, 0.50545894E-07_JPRB, &
  & 0.51947763E-07_JPRB, 0.51148887E-07_JPRB, 0.50528399E-07_JPRB, 0.50044801E-07_JPRB  /)

RGHG7(:,81, 5) = (/ &
  & 0.15237768E-07_JPRB, 0.14810512E-07_JPRB, 0.14330820E-07_JPRB, 0.14185220E-07_JPRB, 0.14224573E-07_JPRB, 0.13933263E-07_JPRB, &
  & 0.13546527E-07_JPRB, 0.13200813E-07_JPRB, 0.12877301E-07_JPRB, 0.13316790E-07_JPRB, 0.13839101E-07_JPRB, 0.14253846E-07_JPRB, &
  & 0.14725622E-07_JPRB, 0.15214331E-07_JPRB, 0.15687761E-07_JPRB, 0.16136629E-07_JPRB, 0.16688782E-07_JPRB, 0.17208520E-07_JPRB, &
  & 0.17723254E-07_JPRB, 0.18175723E-07_JPRB, 0.18592635E-07_JPRB, 0.18957940E-07_JPRB, 0.19330829E-07_JPRB, 0.19332692E-07_JPRB, &
  & 0.18976585E-07_JPRB, 0.18226916E-07_JPRB, 0.17337382E-07_JPRB, 0.16305383E-07_JPRB, 0.15568700E-07_JPRB, 0.15348653E-07_JPRB, &
  & 0.14461740E-07_JPRB, 0.13422476E-07_JPRB, 0.12726629E-07_JPRB, 0.13683752E-07_JPRB, 0.16598828E-07_JPRB, 0.20866365E-07_JPRB, &
  & 0.23694177E-07_JPRB, 0.26107197E-07_JPRB, 0.29053232E-07_JPRB, 0.31521495E-07_JPRB, 0.34005077E-07_JPRB, 0.36648428E-07_JPRB, &
  & 0.39600020E-07_JPRB, 0.42694963E-07_JPRB, 0.44036036E-07_JPRB, 0.44105308E-07_JPRB, 0.43966054E-07_JPRB, 0.43372832E-07_JPRB, &
  & 0.42717309E-07_JPRB, 0.41671166E-07_JPRB, 0.41038047E-07_JPRB, 0.40613315E-07_JPRB, 0.40324981E-07_JPRB, 0.39787450E-07_JPRB, &
  & 0.40130026E-07_JPRB, 0.40450573E-07_JPRB, 0.42194304E-07_JPRB, 0.44709489E-07_JPRB, 0.47327015E-07_JPRB, 0.48718384E-07_JPRB, &
  & 0.50077191E-07_JPRB, 0.48914402E-07_JPRB, 0.47979816E-07_JPRB, 0.47595852E-07_JPRB  /)

RGHG7(:,82, 5) = (/ &
  & 0.14882770E-07_JPRB, 0.14476689E-07_JPRB, 0.13986875E-07_JPRB, 0.13835827E-07_JPRB, 0.13890461E-07_JPRB, 0.13546912E-07_JPRB, &
  & 0.13147905E-07_JPRB, 0.12810368E-07_JPRB, 0.12528258E-07_JPRB, 0.13036231E-07_JPRB, 0.13582211E-07_JPRB, 0.13978611E-07_JPRB, &
  & 0.14416921E-07_JPRB, 0.14881425E-07_JPRB, 0.15330650E-07_JPRB, 0.15808232E-07_JPRB, 0.16383829E-07_JPRB, 0.16919629E-07_JPRB, &
  & 0.17462550E-07_JPRB, 0.17935188E-07_JPRB, 0.18353264E-07_JPRB, 0.18702080E-07_JPRB, 0.19046389E-07_JPRB, 0.19049808E-07_JPRB, &
  & 0.18683903E-07_JPRB, 0.17944154E-07_JPRB, 0.17011978E-07_JPRB, 0.15953411E-07_JPRB, 0.15212355E-07_JPRB, 0.15053060E-07_JPRB, &
  & 0.14152230E-07_JPRB, 0.13107406E-07_JPRB, 0.12498083E-07_JPRB, 0.13551231E-07_JPRB, 0.16535872E-07_JPRB, 0.20774210E-07_JPRB, &
  & 0.23423177E-07_JPRB, 0.25676974E-07_JPRB, 0.28501559E-07_JPRB, 0.30972311E-07_JPRB, 0.33489693E-07_JPRB, 0.36259525E-07_JPRB, &
  & 0.39244993E-07_JPRB, 0.42336693E-07_JPRB, 0.43659980E-07_JPRB, 0.43720303E-07_JPRB, 0.43578352E-07_JPRB, 0.42887542E-07_JPRB, &
  & 0.42129952E-07_JPRB, 0.40997845E-07_JPRB, 0.40328036E-07_JPRB, 0.39880720E-07_JPRB, 0.39506769E-07_JPRB, 0.38847468E-07_JPRB, &
  & 0.39108044E-07_JPRB, 0.39257138E-07_JPRB, 0.40867509E-07_JPRB, 0.43265940E-07_JPRB, 0.45576255E-07_JPRB, 0.47013652E-07_JPRB, &
  & 0.48414895E-07_JPRB, 0.47086557E-07_JPRB, 0.45763093E-07_JPRB, 0.45255615E-07_JPRB  /)

RGHG7(:,83, 5) = (/ &
  & 0.14504706E-07_JPRB, 0.14127719E-07_JPRB, 0.13627839E-07_JPRB, 0.13477077E-07_JPRB, 0.13548870E-07_JPRB, 0.13156252E-07_JPRB, &
  & 0.12745493E-07_JPRB, 0.12442738E-07_JPRB, 0.12214437E-07_JPRB, 0.12813326E-07_JPRB, 0.13381985E-07_JPRB, 0.13766753E-07_JPRB, &
  & 0.14188680E-07_JPRB, 0.14632449E-07_JPRB, 0.15070446E-07_JPRB, 0.15566137E-07_JPRB, 0.16147688E-07_JPRB, 0.16692736E-07_JPRB, &
  & 0.17258012E-07_JPRB, 0.17751837E-07_JPRB, 0.18170771E-07_JPRB, 0.18511260E-07_JPRB, 0.18835903E-07_JPRB, 0.18838137E-07_JPRB, &
  & 0.18469766E-07_JPRB, 0.17725824E-07_JPRB, 0.16756957E-07_JPRB, 0.15679652E-07_JPRB, 0.14962765E-07_JPRB, 0.14866445E-07_JPRB, &
  & 0.13947621E-07_JPRB, 0.12884810E-07_JPRB, 0.12352478E-07_JPRB, 0.13535499E-07_JPRB, 0.16568056E-07_JPRB, 0.20733152E-07_JPRB, &
  & 0.23198899E-07_JPRB, 0.25306905E-07_JPRB, 0.27981654E-07_JPRB, 0.30477609E-07_JPRB, 0.33071965E-07_JPRB, 0.35940915E-07_JPRB, &
  & 0.38922284E-07_JPRB, 0.41976238E-07_JPRB, 0.43293832E-07_JPRB, 0.43336613E-07_JPRB, 0.43184665E-07_JPRB, 0.42399019E-07_JPRB, &
  & 0.41508586E-07_JPRB, 0.40299687E-07_JPRB, 0.39583995E-07_JPRB, 0.39110376E-07_JPRB, 0.38644985E-07_JPRB, 0.37903516E-07_JPRB, &
  & 0.38156021E-07_JPRB, 0.38132342E-07_JPRB, 0.39641467E-07_JPRB, 0.41870914E-07_JPRB, 0.43924456E-07_JPRB, 0.45437613E-07_JPRB, &
  & 0.46900742E-07_JPRB, 0.45602159E-07_JPRB, 0.44083856E-07_JPRB, 0.43413373E-07_JPRB  /)

RGHG7(:,84, 5) = (/ &
  & 0.14101801E-07_JPRB, 0.13764898E-07_JPRB, 0.13248689E-07_JPRB, 0.13106266E-07_JPRB, 0.13190788E-07_JPRB, 0.12754266E-07_JPRB, &
  & 0.12339820E-07_JPRB, 0.12107501E-07_JPRB, 0.11937669E-07_JPRB, 0.12643280E-07_JPRB, 0.13239386E-07_JPRB, 0.13616336E-07_JPRB, &
  & 0.14022117E-07_JPRB, 0.14438392E-07_JPRB, 0.14872804E-07_JPRB, 0.15371190E-07_JPRB, 0.15952408E-07_JPRB, 0.16513626E-07_JPRB, &
  & 0.17097485E-07_JPRB, 0.17612153E-07_JPRB, 0.18030982E-07_JPRB, 0.18375495E-07_JPRB, 0.18689611E-07_JPRB, 0.18683010E-07_JPRB, &
  & 0.18317900E-07_JPRB, 0.17555737E-07_JPRB, 0.16567645E-07_JPRB, 0.15489768E-07_JPRB, 0.14833134E-07_JPRB, 0.14804279E-07_JPRB, &
  & 0.13865056E-07_JPRB, 0.12770056E-07_JPRB, 0.12305570E-07_JPRB, 0.13637825E-07_JPRB, 0.16684742E-07_JPRB, 0.20737637E-07_JPRB, &
  & 0.23042107E-07_JPRB, 0.25039002E-07_JPRB, 0.27551101E-07_JPRB, 0.30041473E-07_JPRB, 0.32729672E-07_JPRB, 0.35654238E-07_JPRB, &
  & 0.38614536E-07_JPRB, 0.41567655E-07_JPRB, 0.42899687E-07_JPRB, 0.42917656E-07_JPRB, 0.42753172E-07_JPRB, 0.41883440E-07_JPRB, &
  & 0.40860122E-07_JPRB, 0.39578124E-07_JPRB, 0.38804613E-07_JPRB, 0.38293971E-07_JPRB, 0.37718680E-07_JPRB, 0.36940782E-07_JPRB, &
  & 0.37263249E-07_JPRB, 0.37101241E-07_JPRB, 0.38565390E-07_JPRB, 0.40586364E-07_JPRB, 0.42447238E-07_JPRB, 0.43993361E-07_JPRB, &
  & 0.45485761E-07_JPRB, 0.44385430E-07_JPRB, 0.43029804E-07_JPRB, 0.42308547E-07_JPRB  /)

RGHG7(:,85, 5) = (/ &
  & 0.13595936E-07_JPRB, 0.13337764E-07_JPRB, 0.12767082E-07_JPRB, 0.12661258E-07_JPRB, 0.12772165E-07_JPRB, 0.12308832E-07_JPRB, &
  & 0.11935666E-07_JPRB, 0.11788036E-07_JPRB, 0.11689275E-07_JPRB, 0.12514046E-07_JPRB, 0.13131856E-07_JPRB, 0.13506678E-07_JPRB, &
  & 0.13899692E-07_JPRB, 0.14287028E-07_JPRB, 0.14712929E-07_JPRB, 0.15204931E-07_JPRB, 0.15787000E-07_JPRB, 0.16361411E-07_JPRB, &
  & 0.16953781E-07_JPRB, 0.17469726E-07_JPRB, 0.17893237E-07_JPRB, 0.18240728E-07_JPRB, 0.18533140E-07_JPRB, 0.18507389E-07_JPRB, &
  & 0.18132490E-07_JPRB, 0.17355007E-07_JPRB, 0.16360531E-07_JPRB, 0.15298826E-07_JPRB, 0.14685175E-07_JPRB, 0.14684833E-07_JPRB, &
  & 0.13726034E-07_JPRB, 0.12607202E-07_JPRB, 0.12177613E-07_JPRB, 0.13568171E-07_JPRB, 0.16610832E-07_JPRB, 0.20581592E-07_JPRB, &
  & 0.22812864E-07_JPRB, 0.24803800E-07_JPRB, 0.27219720E-07_JPRB, 0.29597315E-07_JPRB, 0.32369353E-07_JPRB, 0.35278598E-07_JPRB, &
  & 0.38182295E-07_JPRB, 0.40986038E-07_JPRB, 0.42308708E-07_JPRB, 0.42316889E-07_JPRB, 0.42148575E-07_JPRB, 0.41216709E-07_JPRB, &
  & 0.40099765E-07_JPRB, 0.38778614E-07_JPRB, 0.37964249E-07_JPRB, 0.37355299E-07_JPRB, 0.36659146E-07_JPRB, 0.35876567E-07_JPRB, &
  & 0.36307981E-07_JPRB, 0.36019152E-07_JPRB, 0.37547988E-07_JPRB, 0.39491082E-07_JPRB, 0.41197474E-07_JPRB, 0.42600179E-07_JPRB, &
  & 0.44054704E-07_JPRB, 0.43170137E-07_JPRB, 0.42059215E-07_JPRB, 0.41614580E-07_JPRB  /)

RGHG7(:,86, 5) = (/ &
  & 0.12968969E-07_JPRB, 0.12812904E-07_JPRB, 0.12164495E-07_JPRB, 0.12124761E-07_JPRB, 0.12302483E-07_JPRB, 0.11857161E-07_JPRB, &
  & 0.11557788E-07_JPRB, 0.11472629E-07_JPRB, 0.11467610E-07_JPRB, 0.12413808E-07_JPRB, 0.13044108E-07_JPRB, 0.13420454E-07_JPRB, &
  & 0.13802302E-07_JPRB, 0.14166547E-07_JPRB, 0.14578565E-07_JPRB, 0.15058822E-07_JPRB, 0.15640415E-07_JPRB, 0.16226421E-07_JPRB, &
  & 0.16822350E-07_JPRB, 0.17329920E-07_JPRB, 0.17736489E-07_JPRB, 0.18068326E-07_JPRB, 0.18337592E-07_JPRB, 0.18278273E-07_JPRB, &
  & 0.17900197E-07_JPRB, 0.17128296E-07_JPRB, 0.16139726E-07_JPRB, 0.15112258E-07_JPRB, 0.14530817E-07_JPRB, 0.14548142E-07_JPRB, &
  & 0.13583988E-07_JPRB, 0.12454192E-07_JPRB, 0.12053348E-07_JPRB, 0.13466538E-07_JPRB, 0.16485607E-07_JPRB, 0.20370486E-07_JPRB, &
  & 0.22533185E-07_JPRB, 0.24540446E-07_JPRB, 0.26868359E-07_JPRB, 0.29150258E-07_JPRB, 0.31902654E-07_JPRB, 0.34767195E-07_JPRB, &
  & 0.37585698E-07_JPRB, 0.40216998E-07_JPRB, 0.41515272E-07_JPRB, 0.41499962E-07_JPRB, 0.41338455E-07_JPRB, 0.40277204E-07_JPRB, &
  & 0.39157742E-07_JPRB, 0.37847194E-07_JPRB, 0.37030065E-07_JPRB, 0.36259704E-07_JPRB, 0.35456397E-07_JPRB, 0.34678771E-07_JPRB, &
  & 0.35266970E-07_JPRB, 0.34871660E-07_JPRB, 0.36516796E-07_JPRB, 0.38406594E-07_JPRB, 0.40131559E-07_JPRB, 0.41387790E-07_JPRB, &
  & 0.42673371E-07_JPRB, 0.41906752E-07_JPRB, 0.41024453E-07_JPRB, 0.40980389E-07_JPRB  /)

RGHG7(:,87, 5) = (/ &
  & 0.12228222E-07_JPRB, 0.12162763E-07_JPRB, 0.11434540E-07_JPRB, 0.11460858E-07_JPRB, 0.11739808E-07_JPRB, 0.11369224E-07_JPRB, &
  & 0.11170091E-07_JPRB, 0.11155810E-07_JPRB, 0.11272843E-07_JPRB, 0.12335753E-07_JPRB, 0.12974270E-07_JPRB, 0.13350340E-07_JPRB, &
  & 0.13720219E-07_JPRB, 0.14068730E-07_JPRB, 0.14466440E-07_JPRB, 0.14930348E-07_JPRB, 0.15506637E-07_JPRB, 0.16104825E-07_JPRB, &
  & 0.16695608E-07_JPRB, 0.17175698E-07_JPRB, 0.17540626E-07_JPRB, 0.17841198E-07_JPRB, 0.18089011E-07_JPRB, 0.17997229E-07_JPRB, &
  & 0.17617628E-07_JPRB, 0.16872535E-07_JPRB, 0.15896404E-07_JPRB, 0.14924867E-07_JPRB, 0.14360548E-07_JPRB, 0.14381113E-07_JPRB, &
  & 0.13424747E-07_JPRB, 0.12294439E-07_JPRB, 0.11911208E-07_JPRB, 0.13334778E-07_JPRB, 0.16305459E-07_JPRB, 0.20104148E-07_JPRB, &
  & 0.22202858E-07_JPRB, 0.24214738E-07_JPRB, 0.26434039E-07_JPRB, 0.28636260E-07_JPRB, 0.31297456E-07_JPRB, 0.34079969E-07_JPRB, &
  & 0.36809536E-07_JPRB, 0.39205814E-07_JPRB, 0.40465004E-07_JPRB, 0.40387300E-07_JPRB, 0.40227581E-07_JPRB, 0.38975233E-07_JPRB, &
  & 0.37966363E-07_JPRB, 0.36706067E-07_JPRB, 0.35925795E-07_JPRB, 0.34984059E-07_JPRB, 0.34085594E-07_JPRB, 0.33272548E-07_JPRB, &
  & 0.34103490E-07_JPRB, 0.33571059E-07_JPRB, 0.35428063E-07_JPRB, 0.37241231E-07_JPRB, 0.39146136E-07_JPRB, 0.40305703E-07_JPRB, &
  & 0.41400079E-07_JPRB, 0.40679896E-07_JPRB, 0.40082668E-07_JPRB, 0.40457775E-07_JPRB  /)

RGHG7(:,88, 5) = (/ &
  & 0.11385553E-07_JPRB, 0.11393071E-07_JPRB, 0.10566212E-07_JPRB, 0.10630908E-07_JPRB, 0.11021592E-07_JPRB, 0.10806749E-07_JPRB, &
  & 0.10748820E-07_JPRB, 0.10844163E-07_JPRB, 0.11103494E-07_JPRB, 0.12274833E-07_JPRB, 0.12919782E-07_JPRB, 0.13292536E-07_JPRB, &
  & 0.13650206E-07_JPRB, 0.13988777E-07_JPRB, 0.14371265E-07_JPRB, 0.14815547E-07_JPRB, 0.15379337E-07_JPRB, 0.15988291E-07_JPRB, &
  & 0.16562273E-07_JPRB, 0.16989982E-07_JPRB, 0.17282812E-07_JPRB, 0.17531575E-07_JPRB, 0.17760155E-07_JPRB, 0.17642391E-07_JPRB, &
  & 0.17262411E-07_JPRB, 0.16565783E-07_JPRB, 0.15614355E-07_JPRB, 0.14723331E-07_JPRB, 0.14162508E-07_JPRB, 0.14156802E-07_JPRB, &
  & 0.13223621E-07_JPRB, 0.12098373E-07_JPRB, 0.11725751E-07_JPRB, 0.13152856E-07_JPRB, 0.16046587E-07_JPRB, 0.19761071E-07_JPRB, &
  & 0.21805116E-07_JPRB, 0.23772294E-07_JPRB, 0.25855354E-07_JPRB, 0.27978081E-07_JPRB, 0.30502064E-07_JPRB, 0.33129365E-07_JPRB, &
  & 0.35772099E-07_JPRB, 0.37848626E-07_JPRB, 0.39011654E-07_JPRB, 0.38832019E-07_JPRB, 0.38660820E-07_JPRB, 0.37161496E-07_JPRB, &
  & 0.36421716E-07_JPRB, 0.35221403E-07_JPRB, 0.34529958E-07_JPRB, 0.33452833E-07_JPRB, 0.32491796E-07_JPRB, 0.31600839E-07_JPRB, &
  & 0.32722905E-07_JPRB, 0.31993977E-07_JPRB, 0.34197253E-07_JPRB, 0.35915252E-07_JPRB, 0.38168209E-07_JPRB, 0.39277975E-07_JPRB, &
  & 0.40172538E-07_JPRB, 0.39487310E-07_JPRB, 0.39335624E-07_JPRB, 0.40063827E-07_JPRB  /)

RGHG7(:,89, 5) = (/ &
  & 0.10533272E-07_JPRB, 0.10618250E-07_JPRB, 0.96204746E-08_JPRB, 0.96415249E-08_JPRB, 0.10110738E-07_JPRB, 0.10146414E-07_JPRB, &
  & 0.10303412E-07_JPRB, 0.10574672E-07_JPRB, 0.10962812E-07_JPRB, 0.12226774E-07_JPRB, 0.12877071E-07_JPRB, 0.13246260E-07_JPRB, &
  & 0.13594874E-07_JPRB, 0.13924575E-07_JPRB, 0.14286735E-07_JPRB, 0.14712095E-07_JPRB, 0.15255290E-07_JPRB, 0.15865517E-07_JPRB, &
  & 0.16410201E-07_JPRB, 0.16764404E-07_JPRB, 0.16949971E-07_JPRB, 0.17121230E-07_JPRB, 0.17327484E-07_JPRB, 0.17187839E-07_JPRB, &
  & 0.16813426E-07_JPRB, 0.16183434E-07_JPRB, 0.15283162E-07_JPRB, 0.14493302E-07_JPRB, 0.13932536E-07_JPRB, 0.13845104E-07_JPRB, &
  & 0.12952908E-07_JPRB, 0.11833779E-07_JPRB, 0.11475566E-07_JPRB, 0.12892643E-07_JPRB, 0.15684839E-07_JPRB, 0.19330182E-07_JPRB, &
  & 0.21335153E-07_JPRB, 0.23158593E-07_JPRB, 0.25101696E-07_JPRB, 0.27111344E-07_JPRB, 0.29486945E-07_JPRB, 0.31853669E-07_JPRB, &
  & 0.34376502E-07_JPRB, 0.36068405E-07_JPRB, 0.36994101E-07_JPRB, 0.36698289E-07_JPRB, 0.36502324E-07_JPRB, 0.34755184E-07_JPRB, &
  & 0.34471216E-07_JPRB, 0.33282071E-07_JPRB, 0.32756184E-07_JPRB, 0.31646136E-07_JPRB, 0.30703643E-07_JPRB, 0.29715614E-07_JPRB, &
  & 0.31039229E-07_JPRB, 0.30044764E-07_JPRB, 0.32748342E-07_JPRB, 0.34432221E-07_JPRB, 0.37193259E-07_JPRB, 0.38233463E-07_JPRB, &
  & 0.38858863E-07_JPRB, 0.38264349E-07_JPRB, 0.38864629E-07_JPRB, 0.39791181E-07_JPRB  /)

RGHG7(:,90, 5) = (/ &
  & 0.98100246E-08_JPRB, 0.10013289E-07_JPRB, 0.87413225E-08_JPRB, 0.85086102E-08_JPRB, 0.90840973E-08_JPRB, 0.93833573E-08_JPRB, &
  & 0.98662209E-08_JPRB, 0.10362088E-07_JPRB, 0.10850706E-07_JPRB, 0.12185407E-07_JPRB, 0.12838622E-07_JPRB, 0.13205826E-07_JPRB, &
  & 0.13544930E-07_JPRB, 0.13866790E-07_JPRB, 0.14205424E-07_JPRB, 0.14615032E-07_JPRB, 0.15129346E-07_JPRB, 0.15723056E-07_JPRB, &
  & 0.16227454E-07_JPRB, 0.16507059E-07_JPRB, 0.16543382E-07_JPRB, 0.16632889E-07_JPRB, 0.16786893E-07_JPRB, 0.16619605E-07_JPRB, &
  & 0.16267372E-07_JPRB, 0.15723272E-07_JPRB, 0.14894562E-07_JPRB, 0.14223779E-07_JPRB, 0.13674818E-07_JPRB, 0.13450575E-07_JPRB, &
  & 0.12610530E-07_JPRB, 0.11527659E-07_JPRB, 0.11171848E-07_JPRB, 0.12574422E-07_JPRB, 0.15248016E-07_JPRB, 0.18880980E-07_JPRB, &
  & 0.20825725E-07_JPRB, 0.22381365E-07_JPRB, 0.24209833E-07_JPRB, 0.26047249E-07_JPRB, 0.28239031E-07_JPRB, 0.30390390E-07_JPRB, &
  & 0.32572184E-07_JPRB, 0.33881172E-07_JPRB, 0.34417773E-07_JPRB, 0.33961226E-07_JPRB, 0.33751021E-07_JPRB, 0.31942721E-07_JPRB, &
  & 0.32148338E-07_JPRB, 0.30938029E-07_JPRB, 0.30699470E-07_JPRB, 0.29719920E-07_JPRB, 0.28882779E-07_JPRB, 0.27629343E-07_JPRB, &
  & 0.29032332E-07_JPRB, 0.27665035E-07_JPRB, 0.31027879E-07_JPRB, 0.32877007E-07_JPRB, 0.36302808E-07_JPRB, 0.37176095E-07_JPRB, &
  & 0.37427202E-07_JPRB, 0.36742151E-07_JPRB, 0.38510140E-07_JPRB, 0.39582573E-07_JPRB  /)

RGHG7(:,91, 5) = (/ &
  & 0.95391219E-08_JPRB, 0.96133366E-08_JPRB, 0.80853855E-08_JPRB, 0.74327321E-08_JPRB, 0.81557804E-08_JPRB, 0.87882430E-08_JPRB, &
  & 0.95091085E-08_JPRB, 0.10222880E-07_JPRB, 0.10752752E-07_JPRB, 0.12136639E-07_JPRB, 0.12790384E-07_JPRB, 0.13156001E-07_JPRB, &
  & 0.13485056E-07_JPRB, 0.13803743E-07_JPRB, 0.14117518E-07_JPRB, 0.14503326E-07_JPRB, 0.14991725E-07_JPRB, 0.15567981E-07_JPRB, &
  & 0.15991987E-07_JPRB, 0.16192258E-07_JPRB, 0.16083664E-07_JPRB, 0.16036188E-07_JPRB, 0.16159516E-07_JPRB, 0.15913952E-07_JPRB, &
  & 0.15605088E-07_JPRB, 0.15145611E-07_JPRB, 0.14392004E-07_JPRB, 0.13906334E-07_JPRB, 0.13409204E-07_JPRB, 0.13065961E-07_JPRB, &
  & 0.12253418E-07_JPRB, 0.11215503E-07_JPRB, 0.10859163E-07_JPRB, 0.12231590E-07_JPRB, 0.14826379E-07_JPRB, 0.18450351E-07_JPRB, &
  & 0.20357016E-07_JPRB, 0.21599022E-07_JPRB, 0.23336521E-07_JPRB, 0.25021087E-07_JPRB, 0.27015063E-07_JPRB, 0.28950104E-07_JPRB, &
  & 0.30705611E-07_JPRB, 0.31838478E-07_JPRB, 0.31882679E-07_JPRB, 0.31071774E-07_JPRB, 0.31098513E-07_JPRB, 0.29466333E-07_JPRB, &
  & 0.29977651E-07_JPRB, 0.28923365E-07_JPRB, 0.28836599E-07_JPRB, 0.28234150E-07_JPRB, 0.27378497E-07_JPRB, 0.25627902E-07_JPRB, &
  & 0.26773320E-07_JPRB, 0.25120950E-07_JPRB, 0.28801129E-07_JPRB, 0.31192373E-07_JPRB, 0.35336940E-07_JPRB, 0.36026701E-07_JPRB, &
  & 0.36022881E-07_JPRB, 0.35365862E-07_JPRB, 0.38076338E-07_JPRB, 0.39324893E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ---GEMS----

RGHG7(:, 1, 6) = (/ &
  & 0.59862564E-05_JPRB, 0.59765221E-05_JPRB, 0.59679173E-05_JPRB, 0.59542326E-05_JPRB, 0.59348768E-05_JPRB, 0.59092185E-05_JPRB, &
  & 0.58776936E-05_JPRB, 0.58331170E-05_JPRB, 0.66071934E-07_JPRB, 0.63972976E-07_JPRB, 0.63390999E-07_JPRB, 0.63269148E-07_JPRB, &
  & 0.63462231E-07_JPRB, 0.63851580E-07_JPRB, 0.64459257E-07_JPRB, 0.65170831E-07_JPRB, 0.65882453E-07_JPRB, 0.66582416E-07_JPRB, &
  & 0.67213200E-07_JPRB, 0.67762898E-07_JPRB, 0.68195668E-07_JPRB, 0.68600400E-07_JPRB, 0.68945269E-07_JPRB, 0.69229131E-07_JPRB, &
  & 0.69419990E-07_JPRB, 0.69468783E-07_JPRB, 0.69501183E-07_JPRB, 0.69412138E-07_JPRB, 0.69185930E-07_JPRB, 0.68879466E-07_JPRB, &
  & 0.68689481E-07_JPRB, 0.68494970E-07_JPRB, 0.68535748E-07_JPRB, 0.68719856E-07_JPRB, 0.69014447E-07_JPRB, 0.69371396E-07_JPRB, &
  & 0.69739500E-07_JPRB, 0.69900778E-07_JPRB, 0.70181834E-07_JPRB, 0.70432137E-07_JPRB, 0.70541226E-07_JPRB, 0.70677096E-07_JPRB, &
  & 0.70627642E-07_JPRB, 0.70633348E-07_JPRB, 0.70611136E-07_JPRB, 0.70540551E-07_JPRB, 0.70544445E-07_JPRB, 0.70157583E-07_JPRB, &
  & 0.70284024E-07_JPRB, 0.69830463E-07_JPRB, 0.69980125E-07_JPRB, 0.69435465E-07_JPRB, 0.69651648E-07_JPRB, 0.68630847E-07_JPRB, &
  & 0.68914524E-07_JPRB, 0.67843729E-07_JPRB, 0.68446852E-07_JPRB, 0.68388573E-07_JPRB, 0.70059706E-07_JPRB, 0.70978466E-07_JPRB, &
  & 0.72757935E-07_JPRB, 0.75899059E-07_JPRB, 0.79206558E-07_JPRB, 0.83183672E-07_JPRB  /)

RGHG7(:, 2, 6) = (/ &
  & 0.61713486E-05_JPRB, 0.63617267E-05_JPRB, 0.64679220E-05_JPRB, 0.65452664E-05_JPRB, 0.66086236E-05_JPRB, 0.66297748E-05_JPRB, &
  & 0.65665567E-05_JPRB, 0.60986858E-05_JPRB, 0.19150463E-06_JPRB, 0.18453750E-06_JPRB, 0.18820151E-06_JPRB, 0.19346871E-06_JPRB, &
  & 0.20019529E-06_JPRB, 0.20282660E-06_JPRB, 0.20673647E-06_JPRB, 0.20953748E-06_JPRB, 0.21030473E-06_JPRB, 0.21270496E-06_JPRB, &
  & 0.21324431E-06_JPRB, 0.21400125E-06_JPRB, 0.21350796E-06_JPRB, 0.21690448E-06_JPRB, 0.21981491E-06_JPRB, 0.22238243E-06_JPRB, &
  & 0.22399293E-06_JPRB, 0.22079939E-06_JPRB, 0.22184255E-06_JPRB, 0.22294446E-06_JPRB, 0.22124685E-06_JPRB, 0.21693917E-06_JPRB, &
  & 0.21191217E-06_JPRB, 0.20315720E-06_JPRB, 0.20039566E-06_JPRB, 0.19940539E-06_JPRB, 0.19994408E-06_JPRB, 0.20176256E-06_JPRB, &
  & 0.20405672E-06_JPRB, 0.20273845E-06_JPRB, 0.20591675E-06_JPRB, 0.21084242E-06_JPRB, 0.21499092E-06_JPRB, 0.21949484E-06_JPRB, &
  & 0.22009358E-06_JPRB, 0.22215407E-06_JPRB, 0.22501919E-06_JPRB, 0.23069994E-06_JPRB, 0.23383156E-06_JPRB, 0.23518518E-06_JPRB, &
  & 0.24305228E-06_JPRB, 0.24500815E-06_JPRB, 0.24427410E-06_JPRB, 0.24327539E-06_JPRB, 0.23411869E-06_JPRB, 0.22193196E-06_JPRB, &
  & 0.21248255E-06_JPRB, 0.21263281E-06_JPRB, 0.24058320E-06_JPRB, 0.27537629E-06_JPRB, 0.31463603E-06_JPRB, 0.36499242E-06_JPRB, &
  & 0.42147875E-06_JPRB, 0.48473055E-06_JPRB, 0.53689257E-06_JPRB, 0.58730012E-06_JPRB  /)

RGHG7(:, 3, 6) = (/ &
  & 0.62708605E-05_JPRB, 0.62155405E-05_JPRB, 0.60441848E-05_JPRB, 0.58222586E-05_JPRB, 0.54956090E-05_JPRB, 0.49263454E-05_JPRB, &
  & 0.41224639E-05_JPRB, 0.32488215E-05_JPRB, 0.28430350E-06_JPRB, 0.26689665E-06_JPRB, 0.28288471E-06_JPRB, 0.30347871E-06_JPRB, &
  & 0.32858497E-06_JPRB, 0.34478452E-06_JPRB, 0.35959187E-06_JPRB, 0.36988033E-06_JPRB, 0.37222435E-06_JPRB, 0.37956696E-06_JPRB, &
  & 0.38768795E-06_JPRB, 0.39452027E-06_JPRB, 0.39434016E-06_JPRB, 0.40029070E-06_JPRB, 0.40759653E-06_JPRB, 0.41498370E-06_JPRB, &
  & 0.41950426E-06_JPRB, 0.41422467E-06_JPRB, 0.41473936E-06_JPRB, 0.41552198E-06_JPRB, 0.41524831E-06_JPRB, 0.41336162E-06_JPRB, &
  & 0.40952136E-06_JPRB, 0.39705895E-06_JPRB, 0.39221680E-06_JPRB, 0.39143521E-06_JPRB, 0.39334955E-06_JPRB, 0.39627520E-06_JPRB, &
  & 0.40145486E-06_JPRB, 0.39912797E-06_JPRB, 0.40086243E-06_JPRB, 0.40786455E-06_JPRB, 0.41338112E-06_JPRB, 0.42139621E-06_JPRB, &
  & 0.42158504E-06_JPRB, 0.42420092E-06_JPRB, 0.42989197E-06_JPRB, 0.44017153E-06_JPRB, 0.44667837E-06_JPRB, 0.44943101E-06_JPRB, &
  & 0.46272316E-06_JPRB, 0.47060107E-06_JPRB, 0.47547468E-06_JPRB, 0.48331282E-06_JPRB, 0.48471566E-06_JPRB, 0.48382600E-06_JPRB, &
  & 0.48635025E-06_JPRB, 0.50430225E-06_JPRB, 0.58426463E-06_JPRB, 0.66868358E-06_JPRB, 0.74595084E-06_JPRB, 0.83773239E-06_JPRB, &
  & 0.93560988E-06_JPRB, 0.10819532E-05_JPRB, 0.12582202E-05_JPRB, 0.15655738E-05_JPRB  /)

RGHG7(:, 4, 6) = (/ &
  & 0.46986924E-05_JPRB, 0.44394020E-05_JPRB, 0.42300078E-05_JPRB, 0.40072315E-05_JPRB, 0.37667820E-05_JPRB, 0.34730502E-05_JPRB, &
  & 0.31877572E-05_JPRB, 0.28530242E-05_JPRB, 0.19222226E-05_JPRB, 0.19142431E-05_JPRB, 0.19277753E-05_JPRB, 0.18663700E-05_JPRB, &
  & 0.17391664E-05_JPRB, 0.15790541E-05_JPRB, 0.14460836E-05_JPRB, 0.13508693E-05_JPRB, 0.12874625E-05_JPRB, 0.12442015E-05_JPRB, &
  & 0.11939296E-05_JPRB, 0.11431011E-05_JPRB, 0.10983949E-05_JPRB, 0.10519453E-05_JPRB, 0.10134482E-05_JPRB, 0.95946791E-06_JPRB, &
  & 0.89420488E-06_JPRB, 0.81252543E-06_JPRB, 0.74826032E-06_JPRB, 0.69679682E-06_JPRB, 0.65201892E-06_JPRB, 0.63220016E-06_JPRB, &
  & 0.63860957E-06_JPRB, 0.65767884E-06_JPRB, 0.68891474E-06_JPRB, 0.73339712E-06_JPRB, 0.78080346E-06_JPRB, 0.82333139E-06_JPRB, &
  & 0.85781332E-06_JPRB, 0.87628435E-06_JPRB, 0.89208892E-06_JPRB, 0.90699231E-06_JPRB, 0.91584096E-06_JPRB, 0.92423039E-06_JPRB, &
  & 0.92272221E-06_JPRB, 0.92215702E-06_JPRB, 0.92389467E-06_JPRB, 0.92812770E-06_JPRB, 0.92618143E-06_JPRB, 0.91906185E-06_JPRB, &
  & 0.91471031E-06_JPRB, 0.89976252E-06_JPRB, 0.87560444E-06_JPRB, 0.84888656E-06_JPRB, 0.81691379E-06_JPRB, 0.78719805E-06_JPRB, &
  & 0.77123588E-06_JPRB, 0.77773884E-06_JPRB, 0.74143683E-06_JPRB, 0.63776314E-06_JPRB, 0.56453406E-06_JPRB, 0.55341379E-06_JPRB, &
  & 0.56730478E-06_JPRB, 0.58402210E-06_JPRB, 0.57713253E-06_JPRB, 0.55260490E-06_JPRB  /)

RGHG7(:, 5, 6) = (/ &
  & 0.33700423E-05_JPRB, 0.33452196E-05_JPRB, 0.33408407E-05_JPRB, 0.33280689E-05_JPRB, 0.33256985E-05_JPRB, 0.33292087E-05_JPRB, &
  & 0.33138049E-05_JPRB, 0.32891348E-05_JPRB, 0.33190469E-05_JPRB, 0.34091110E-05_JPRB, 0.34559917E-05_JPRB, 0.33379066E-05_JPRB, &
  & 0.30629301E-05_JPRB, 0.27206660E-05_JPRB, 0.24183829E-05_JPRB, 0.21945442E-05_JPRB, 0.20521895E-05_JPRB, 0.19496013E-05_JPRB, &
  & 0.18450615E-05_JPRB, 0.17419346E-05_JPRB, 0.16577134E-05_JPRB, 0.15689786E-05_JPRB, 0.14882410E-05_JPRB, 0.13779260E-05_JPRB, &
  & 0.12463522E-05_JPRB, 0.10830384E-05_JPRB, 0.93384908E-06_JPRB, 0.80295268E-06_JPRB, 0.67912512E-06_JPRB, 0.60138161E-06_JPRB, &
  & 0.58277292E-06_JPRB, 0.61945342E-06_JPRB, 0.68653208E-06_JPRB, 0.77535479E-06_JPRB, 0.86781409E-06_JPRB, 0.95301350E-06_JPRB, &
  & 0.10180906E-05_JPRB, 0.10647333E-05_JPRB, 0.11009551E-05_JPRB, 0.11255820E-05_JPRB, 0.11412491E-05_JPRB, 0.11498176E-05_JPRB, &
  & 0.11532770E-05_JPRB, 0.11541514E-05_JPRB, 0.11523430E-05_JPRB, 0.11496386E-05_JPRB, 0.11442869E-05_JPRB, 0.11366784E-05_JPRB, &
  & 0.11227834E-05_JPRB, 0.10974154E-05_JPRB, 0.10600618E-05_JPRB, 0.10130570E-05_JPRB, 0.96005981E-06_JPRB, 0.90556541E-06_JPRB, &
  & 0.87181759E-06_JPRB, 0.88852806E-06_JPRB, 0.79569375E-06_JPRB, 0.53161733E-06_JPRB, 0.30201950E-06_JPRB, 0.18667594E-06_JPRB, &
  & 0.13198166E-06_JPRB, 0.97648358E-07_JPRB, 0.74854742E-07_JPRB, 0.89585749E-07_JPRB  /)

RGHG7(:, 6, 6) = (/ &
  & 0.34162951E-05_JPRB, 0.34040582E-05_JPRB, 0.33986847E-05_JPRB, 0.34022476E-05_JPRB, 0.33967020E-05_JPRB, 0.34043437E-05_JPRB, &
  & 0.34062309E-05_JPRB, 0.33784622E-05_JPRB, 0.34001878E-05_JPRB, 0.34938862E-05_JPRB, 0.35567955E-05_JPRB, 0.34378305E-05_JPRB, &
  & 0.31475905E-05_JPRB, 0.27955715E-05_JPRB, 0.24832657E-05_JPRB, 0.22611102E-05_JPRB, 0.21255266E-05_JPRB, 0.20306658E-05_JPRB, &
  & 0.19517183E-05_JPRB, 0.18766702E-05_JPRB, 0.18114615E-05_JPRB, 0.17479364E-05_JPRB, 0.16841456E-05_JPRB, 0.15919633E-05_JPRB, &
  & 0.14781778E-05_JPRB, 0.13121862E-05_JPRB, 0.11378636E-05_JPRB, 0.97525424E-06_JPRB, 0.81213925E-06_JPRB, 0.68646279E-06_JPRB, &
  & 0.63281293E-06_JPRB, 0.65667816E-06_JPRB, 0.72861515E-06_JPRB, 0.82355859E-06_JPRB, 0.92317149E-06_JPRB, 0.10165574E-05_JPRB, &
  & 0.10890942E-05_JPRB, 0.11439233E-05_JPRB, 0.11852330E-05_JPRB, 0.12149477E-05_JPRB, 0.12360852E-05_JPRB, 0.12501624E-05_JPRB, &
  & 0.12573707E-05_JPRB, 0.12600431E-05_JPRB, 0.12563984E-05_JPRB, 0.12510544E-05_JPRB, 0.12434840E-05_JPRB, 0.12346514E-05_JPRB, &
  & 0.12237403E-05_JPRB, 0.12056406E-05_JPRB, 0.11791896E-05_JPRB, 0.11438906E-05_JPRB, 0.10969759E-05_JPRB, 0.10390768E-05_JPRB, &
  & 0.99320234E-06_JPRB, 0.10101423E-05_JPRB, 0.94152316E-06_JPRB, 0.68651307E-06_JPRB, 0.43258534E-06_JPRB, 0.28908643E-06_JPRB, &
  & 0.21817223E-06_JPRB, 0.17393100E-06_JPRB, 0.14402203E-06_JPRB, 0.17516424E-06_JPRB  /)

RGHG7(:, 7, 6) = (/ &
  & 0.35847671E-05_JPRB, 0.35828706E-05_JPRB, 0.35650442E-05_JPRB, 0.35683626E-05_JPRB, 0.35627920E-05_JPRB, 0.35709033E-05_JPRB, &
  & 0.35742563E-05_JPRB, 0.35496162E-05_JPRB, 0.35789685E-05_JPRB, 0.36845868E-05_JPRB, 0.37633564E-05_JPRB, 0.36681818E-05_JPRB, &
  & 0.33872895E-05_JPRB, 0.30266073E-05_JPRB, 0.26991833E-05_JPRB, 0.24669718E-05_JPRB, 0.23295354E-05_JPRB, 0.22388531E-05_JPRB, &
  & 0.21742316E-05_JPRB, 0.21180173E-05_JPRB, 0.20732490E-05_JPRB, 0.20291010E-05_JPRB, 0.19798635E-05_JPRB, 0.19055931E-05_JPRB, &
  & 0.18159982E-05_JPRB, 0.16727501E-05_JPRB, 0.15142407E-05_JPRB, 0.13575405E-05_JPRB, 0.11867073E-05_JPRB, 0.10277448E-05_JPRB, &
  & 0.91762965E-06_JPRB, 0.90510774E-06_JPRB, 0.96090334E-06_JPRB, 0.10514552E-05_JPRB, 0.11518897E-05_JPRB, 0.12487351E-05_JPRB, &
  & 0.13274192E-05_JPRB, 0.13848785E-05_JPRB, 0.14287173E-05_JPRB, 0.14600444E-05_JPRB, 0.14831555E-05_JPRB, 0.15000848E-05_JPRB, &
  & 0.15103696E-05_JPRB, 0.15136088E-05_JPRB, 0.15072094E-05_JPRB, 0.14968552E-05_JPRB, 0.14837683E-05_JPRB, 0.14686036E-05_JPRB, &
  & 0.14515792E-05_JPRB, 0.14305205E-05_JPRB, 0.14055233E-05_JPRB, 0.13754176E-05_JPRB, 0.13370251E-05_JPRB, 0.12870113E-05_JPRB, &
  & 0.12302520E-05_JPRB, 0.12260131E-05_JPRB, 0.11891094E-05_JPRB, 0.99355425E-06_JPRB, 0.76363107E-06_JPRB, 0.61708724E-06_JPRB, &
  & 0.54495024E-06_JPRB, 0.50712524E-06_JPRB, 0.47565829E-06_JPRB, 0.50543230E-06_JPRB  /)

RGHG7(:, 8, 6) = (/ &
  & 0.38450042E-05_JPRB, 0.38414026E-05_JPRB, 0.38089623E-05_JPRB, 0.38100775E-05_JPRB, 0.38094383E-05_JPRB, 0.38216354E-05_JPRB, &
  & 0.38199427E-05_JPRB, 0.37981453E-05_JPRB, 0.38449054E-05_JPRB, 0.39701400E-05_JPRB, 0.40727439E-05_JPRB, 0.40206382E-05_JPRB, &
  & 0.37738535E-05_JPRB, 0.34149737E-05_JPRB, 0.30739534E-05_JPRB, 0.28182376E-05_JPRB, 0.26625031E-05_JPRB, 0.25610037E-05_JPRB, &
  & 0.24911709E-05_JPRB, 0.24376611E-05_JPRB, 0.24019273E-05_JPRB, 0.23680641E-05_JPRB, 0.23302808E-05_JPRB, 0.22770123E-05_JPRB, &
  & 0.22192226E-05_JPRB, 0.21249131E-05_JPRB, 0.20273699E-05_JPRB, 0.19250340E-05_JPRB, 0.18067868E-05_JPRB, 0.16874876E-05_JPRB, &
  & 0.15897859E-05_JPRB, 0.15696937E-05_JPRB, 0.15999160E-05_JPRB, 0.16580827E-05_JPRB, 0.17215052E-05_JPRB, 0.17854823E-05_JPRB, &
  & 0.18400420E-05_JPRB, 0.18754613E-05_JPRB, 0.19020443E-05_JPRB, 0.19176477E-05_JPRB, 0.19281209E-05_JPRB, 0.19341037E-05_JPRB, &
  & 0.19366012E-05_JPRB, 0.19312216E-05_JPRB, 0.19161039E-05_JPRB, 0.18964731E-05_JPRB, 0.18745892E-05_JPRB, 0.18492939E-05_JPRB, &
  & 0.18218400E-05_JPRB, 0.17922502E-05_JPRB, 0.17615901E-05_JPRB, 0.17295423E-05_JPRB, 0.16947572E-05_JPRB, 0.16528662E-05_JPRB, &
  & 0.15919240E-05_JPRB, 0.15684831E-05_JPRB, 0.15615045E-05_JPRB, 0.14442000E-05_JPRB, 0.12723610E-05_JPRB, 0.11476470E-05_JPRB, &
  & 0.10817755E-05_JPRB, 0.10516011E-05_JPRB, 0.10211132E-05_JPRB, 0.10389482E-05_JPRB  /)

RGHG7(:, 9, 6) = (/ &
  & 0.41106757E-05_JPRB, 0.40962015E-05_JPRB, 0.40604427E-05_JPRB, 0.40653608E-05_JPRB, 0.40792246E-05_JPRB, 0.40991025E-05_JPRB, &
  & 0.40945972E-05_JPRB, 0.40800034E-05_JPRB, 0.41513404E-05_JPRB, 0.43166975E-05_JPRB, 0.44807813E-05_JPRB, 0.45231755E-05_JPRB, &
  & 0.43723712E-05_JPRB, 0.40584948E-05_JPRB, 0.37166299E-05_JPRB, 0.34233538E-05_JPRB, 0.32183695E-05_JPRB, 0.30727359E-05_JPRB, &
  & 0.29639584E-05_JPRB, 0.28880872E-05_JPRB, 0.28420077E-05_JPRB, 0.28083708E-05_JPRB, 0.27822696E-05_JPRB, 0.27553788E-05_JPRB, &
  & 0.27406730E-05_JPRB, 0.27164033E-05_JPRB, 0.27131149E-05_JPRB, 0.27088913E-05_JPRB, 0.26985794E-05_JPRB, 0.26942938E-05_JPRB, &
  & 0.26936535E-05_JPRB, 0.27124269E-05_JPRB, 0.27220900E-05_JPRB, 0.27218712E-05_JPRB, 0.27108616E-05_JPRB, 0.27048102E-05_JPRB, &
  & 0.26997380E-05_JPRB, 0.26806960E-05_JPRB, 0.26621574E-05_JPRB, 0.26399377E-05_JPRB, 0.26183834E-05_JPRB, 0.25962041E-05_JPRB, &
  & 0.25760442E-05_JPRB, 0.25494782E-05_JPRB, 0.25158968E-05_JPRB, 0.24795920E-05_JPRB, 0.24431153E-05_JPRB, 0.24019799E-05_JPRB, &
  & 0.23594927E-05_JPRB, 0.23162126E-05_JPRB, 0.22724124E-05_JPRB, 0.22297827E-05_JPRB, 0.21896960E-05_JPRB, 0.21496904E-05_JPRB, &
  & 0.20895866E-05_JPRB, 0.20561485E-05_JPRB, 0.20709824E-05_JPRB, 0.20279092E-05_JPRB, 0.19335203E-05_JPRB, 0.18499668E-05_JPRB, &
  & 0.17925909E-05_JPRB, 0.17620406E-05_JPRB, 0.17311289E-05_JPRB, 0.17322836E-05_JPRB  /)

RGHG7(:,10, 6) = (/ &
  & 0.41513602E-05_JPRB, 0.41415830E-05_JPRB, 0.41264537E-05_JPRB, 0.41440915E-05_JPRB, 0.41866053E-05_JPRB, 0.42241112E-05_JPRB, &
  & 0.42386081E-05_JPRB, 0.42582169E-05_JPRB, 0.43678892E-05_JPRB, 0.46097212E-05_JPRB, 0.49158541E-05_JPRB, 0.51722601E-05_JPRB, &
  & 0.52530758E-05_JPRB, 0.51016087E-05_JPRB, 0.48162102E-05_JPRB, 0.44872464E-05_JPRB, 0.41942229E-05_JPRB, 0.39566788E-05_JPRB, &
  & 0.37702060E-05_JPRB, 0.36479010E-05_JPRB, 0.35733257E-05_JPRB, 0.35287995E-05_JPRB, 0.35111786E-05_JPRB, 0.35035993E-05_JPRB, &
  & 0.35263752E-05_JPRB, 0.35513881E-05_JPRB, 0.36080925E-05_JPRB, 0.36745590E-05_JPRB, 0.37408048E-05_JPRB, 0.38266685E-05_JPRB, &
  & 0.39160460E-05_JPRB, 0.39795591E-05_JPRB, 0.39878307E-05_JPRB, 0.39478627E-05_JPRB, 0.38832478E-05_JPRB, 0.38242282E-05_JPRB, &
  & 0.37654348E-05_JPRB, 0.36942769E-05_JPRB, 0.36293649E-05_JPRB, 0.35669649E-05_JPRB, 0.35074448E-05_JPRB, 0.34512132E-05_JPRB, &
  & 0.34024911E-05_JPRB, 0.33502903E-05_JPRB, 0.32926232E-05_JPRB, 0.32327683E-05_JPRB, 0.31737110E-05_JPRB, 0.31107042E-05_JPRB, &
  & 0.30476393E-05_JPRB, 0.29866320E-05_JPRB, 0.29263126E-05_JPRB, 0.28699248E-05_JPRB, 0.28197211E-05_JPRB, 0.27730580E-05_JPRB, &
  & 0.27064553E-05_JPRB, 0.26629501E-05_JPRB, 0.26839452E-05_JPRB, 0.26858664E-05_JPRB, 0.26522933E-05_JPRB, 0.26030973E-05_JPRB, &
  & 0.25487060E-05_JPRB, 0.25094700E-05_JPRB, 0.24757641E-05_JPRB, 0.24669555E-05_JPRB  /)

RGHG7(:,11, 6) = (/ &
  & 0.40899565E-05_JPRB, 0.41029365E-05_JPRB, 0.41149657E-05_JPRB, 0.41372599E-05_JPRB, 0.41881608E-05_JPRB, 0.42415040E-05_JPRB, &
  & 0.42798013E-05_JPRB, 0.43391664E-05_JPRB, 0.44897810E-05_JPRB, 0.48008586E-05_JPRB, 0.52637218E-05_JPRB, 0.57971737E-05_JPRB, &
  & 0.62184067E-05_JPRB, 0.63773110E-05_JPRB, 0.62813981E-05_JPRB, 0.59874361E-05_JPRB, 0.56309524E-05_JPRB, 0.53067039E-05_JPRB, &
  & 0.50470777E-05_JPRB, 0.48771810E-05_JPRB, 0.47671020E-05_JPRB, 0.46954610E-05_JPRB, 0.46666401E-05_JPRB, 0.46502390E-05_JPRB, &
  & 0.46647126E-05_JPRB, 0.46753136E-05_JPRB, 0.47106818E-05_JPRB, 0.47558461E-05_JPRB, 0.48012360E-05_JPRB, 0.48720755E-05_JPRB, &
  & 0.49641051E-05_JPRB, 0.50255192E-05_JPRB, 0.50372272E-05_JPRB, 0.50037544E-05_JPRB, 0.49436591E-05_JPRB, 0.48876422E-05_JPRB, &
  & 0.48250239E-05_JPRB, 0.47537802E-05_JPRB, 0.46814991E-05_JPRB, 0.46026837E-05_JPRB, 0.45217129E-05_JPRB, 0.44391895E-05_JPRB, &
  & 0.43641850E-05_JPRB, 0.42896981E-05_JPRB, 0.42111588E-05_JPRB, 0.41287110E-05_JPRB, 0.40426868E-05_JPRB, 0.39593061E-05_JPRB, &
  & 0.38765528E-05_JPRB, 0.37983546E-05_JPRB, 0.37251905E-05_JPRB, 0.36606511E-05_JPRB, 0.36056858E-05_JPRB, 0.35504241E-05_JPRB, &
  & 0.34670743E-05_JPRB, 0.34055534E-05_JPRB, 0.34082124E-05_JPRB, 0.34193220E-05_JPRB, 0.34190256E-05_JPRB, 0.33923872E-05_JPRB, &
  & 0.33493438E-05_JPRB, 0.33172412E-05_JPRB, 0.32982606E-05_JPRB, 0.32898527E-05_JPRB  /)

RGHG7(:,12, 6) = (/ &
  & 0.45060356E-05_JPRB, 0.45098960E-05_JPRB, 0.45189405E-05_JPRB, 0.45259828E-05_JPRB, 0.45360538E-05_JPRB, 0.45538929E-05_JPRB, &
  & 0.45732374E-05_JPRB, 0.46153963E-05_JPRB, 0.47457286E-05_JPRB, 0.50334289E-05_JPRB, 0.55095641E-05_JPRB, 0.61484553E-05_JPRB, &
  & 0.67908442E-05_JPRB, 0.72378718E-05_JPRB, 0.74125797E-05_JPRB, 0.72995719E-05_JPRB, 0.70424105E-05_JPRB, 0.67640898E-05_JPRB, &
  & 0.65247789E-05_JPRB, 0.63554301E-05_JPRB, 0.62444395E-05_JPRB, 0.61752503E-05_JPRB, 0.61466588E-05_JPRB, 0.61236024E-05_JPRB, &
  & 0.61065076E-05_JPRB, 0.60732826E-05_JPRB, 0.60523801E-05_JPRB, 0.60329112E-05_JPRB, 0.60066938E-05_JPRB, 0.59897163E-05_JPRB, &
  & 0.60015951E-05_JPRB, 0.60175854E-05_JPRB, 0.60211989E-05_JPRB, 0.60017159E-05_JPRB, 0.59655718E-05_JPRB, 0.59411852E-05_JPRB, &
  & 0.59157762E-05_JPRB, 0.58814586E-05_JPRB, 0.58305201E-05_JPRB, 0.57587437E-05_JPRB, 0.56750302E-05_JPRB, 0.55780622E-05_JPRB, &
  & 0.54799892E-05_JPRB, 0.53831737E-05_JPRB, 0.52839813E-05_JPRB, 0.51853550E-05_JPRB, 0.50810487E-05_JPRB, 0.49896020E-05_JPRB, &
  & 0.49024338E-05_JPRB, 0.48186166E-05_JPRB, 0.47430594E-05_JPRB, 0.46789275E-05_JPRB, 0.46250817E-05_JPRB, 0.45596560E-05_JPRB, &
  & 0.44498257E-05_JPRB, 0.43666413E-05_JPRB, 0.43399712E-05_JPRB, 0.43345607E-05_JPRB, 0.43437554E-05_JPRB, 0.43369052E-05_JPRB, &
  & 0.43245756E-05_JPRB, 0.43277476E-05_JPRB, 0.43485235E-05_JPRB, 0.43579131E-05_JPRB  /)

RGHG7(:,13, 6) = (/ &
  & 0.49567079E-05_JPRB, 0.49476776E-05_JPRB, 0.49363958E-05_JPRB, 0.49295860E-05_JPRB, 0.49198568E-05_JPRB, 0.49102886E-05_JPRB, &
  & 0.49105720E-05_JPRB, 0.49351172E-05_JPRB, 0.50252118E-05_JPRB, 0.52353001E-05_JPRB, 0.56138736E-05_JPRB, 0.61893124E-05_JPRB, &
  & 0.68618523E-05_JPRB, 0.74324849E-05_JPRB, 0.78020513E-05_JPRB, 0.79041494E-05_JPRB, 0.78401687E-05_JPRB, 0.77039429E-05_JPRB, &
  & 0.75643748E-05_JPRB, 0.74622509E-05_JPRB, 0.74074101E-05_JPRB, 0.73892084E-05_JPRB, 0.73887119E-05_JPRB, 0.73759001E-05_JPRB, &
  & 0.73431806E-05_JPRB, 0.72883461E-05_JPRB, 0.72327699E-05_JPRB, 0.71695314E-05_JPRB, 0.70916601E-05_JPRB, 0.70066084E-05_JPRB, &
  & 0.69411454E-05_JPRB, 0.69115969E-05_JPRB, 0.69059918E-05_JPRB, 0.69068379E-05_JPRB, 0.69114807E-05_JPRB, 0.69479527E-05_JPRB, &
  & 0.69940514E-05_JPRB, 0.70187300E-05_JPRB, 0.70101500E-05_JPRB, 0.69673648E-05_JPRB, 0.68926736E-05_JPRB, 0.67939954E-05_JPRB, &
  & 0.66888667E-05_JPRB, 0.65846289E-05_JPRB, 0.64748900E-05_JPRB, 0.63721519E-05_JPRB, 0.62701980E-05_JPRB, 0.61866259E-05_JPRB, &
  & 0.61094957E-05_JPRB, 0.60319976E-05_JPRB, 0.59609981E-05_JPRB, 0.58926069E-05_JPRB, 0.58214696E-05_JPRB, 0.57227043E-05_JPRB, &
  & 0.55591026E-05_JPRB, 0.54315606E-05_JPRB, 0.53602772E-05_JPRB, 0.53254172E-05_JPRB, 0.53168022E-05_JPRB, 0.53114663E-05_JPRB, &
  & 0.53074448E-05_JPRB, 0.53297452E-05_JPRB, 0.53836310E-05_JPRB, 0.54281076E-05_JPRB  /)

RGHG7(:,14, 6) = (/ &
  & 0.49845000E-05_JPRB, 0.49830614E-05_JPRB, 0.49727451E-05_JPRB, 0.49644027E-05_JPRB, 0.49534689E-05_JPRB, 0.49432102E-05_JPRB, &
  & 0.49402509E-05_JPRB, 0.49601519E-05_JPRB, 0.50275154E-05_JPRB, 0.51753144E-05_JPRB, 0.54527904E-05_JPRB, 0.59094211E-05_JPRB, &
  & 0.64951913E-05_JPRB, 0.70783774E-05_JPRB, 0.75436042E-05_JPRB, 0.77945611E-05_JPRB, 0.78896270E-05_JPRB, 0.78851596E-05_JPRB, &
  & 0.78463475E-05_JPRB, 0.78221170E-05_JPRB, 0.78277589E-05_JPRB, 0.78627842E-05_JPRB, 0.79005210E-05_JPRB, 0.79206736E-05_JPRB, &
  & 0.79156431E-05_JPRB, 0.78930841E-05_JPRB, 0.78593473E-05_JPRB, 0.78123162E-05_JPRB, 0.77483233E-05_JPRB, 0.76780485E-05_JPRB, &
  & 0.76199456E-05_JPRB, 0.75946972E-05_JPRB, 0.76059727E-05_JPRB, 0.76440531E-05_JPRB, 0.77124250E-05_JPRB, 0.78277698E-05_JPRB, &
  & 0.79533369E-05_JPRB, 0.80352138E-05_JPRB, 0.80620483E-05_JPRB, 0.80447728E-05_JPRB, 0.79881652E-05_JPRB, 0.79076558E-05_JPRB, &
  & 0.78158412E-05_JPRB, 0.77249129E-05_JPRB, 0.76256478E-05_JPRB, 0.75372992E-05_JPRB, 0.74432120E-05_JPRB, 0.73670257E-05_JPRB, &
  & 0.72986321E-05_JPRB, 0.72184790E-05_JPRB, 0.71312774E-05_JPRB, 0.70243339E-05_JPRB, 0.68997331E-05_JPRB, 0.67391517E-05_JPRB, &
  & 0.64995590E-05_JPRB, 0.63030086E-05_JPRB, 0.61678120E-05_JPRB, 0.60928295E-05_JPRB, 0.60484393E-05_JPRB, 0.60253979E-05_JPRB, &
  & 0.60077020E-05_JPRB, 0.60201507E-05_JPRB, 0.60870580E-05_JPRB, 0.61493476E-05_JPRB  /)

RGHG7(:,15, 6) = (/ &
  & 0.47537837E-05_JPRB, 0.47530574E-05_JPRB, 0.47449289E-05_JPRB, 0.47361539E-05_JPRB, 0.47240361E-05_JPRB, 0.47132216E-05_JPRB, &
  & 0.47060115E-05_JPRB, 0.47159109E-05_JPRB, 0.47574292E-05_JPRB, 0.48559897E-05_JPRB, 0.50517485E-05_JPRB, 0.53872983E-05_JPRB, &
  & 0.58563159E-05_JPRB, 0.64014141E-05_JPRB, 0.68973440E-05_JPRB, 0.72495670E-05_JPRB, 0.74836183E-05_JPRB, 0.76139355E-05_JPRB, &
  & 0.76865986E-05_JPRB, 0.77443062E-05_JPRB, 0.78089545E-05_JPRB, 0.78891723E-05_JPRB, 0.79723315E-05_JPRB, 0.80405727E-05_JPRB, &
  & 0.80844884E-05_JPRB, 0.81150986E-05_JPRB, 0.81374183E-05_JPRB, 0.81477856E-05_JPRB, 0.81462282E-05_JPRB, 0.81370733E-05_JPRB, &
  & 0.81343151E-05_JPRB, 0.81568228E-05_JPRB, 0.82164923E-05_JPRB, 0.82992684E-05_JPRB, 0.84125172E-05_JPRB, 0.85601930E-05_JPRB, &
  & 0.87061094E-05_JPRB, 0.87919686E-05_JPRB, 0.88155943E-05_JPRB, 0.88012553E-05_JPRB, 0.87610610E-05_JPRB, 0.87031905E-05_JPRB, &
  & 0.86338306E-05_JPRB, 0.85560218E-05_JPRB, 0.84714693E-05_JPRB, 0.83946765E-05_JPRB, 0.82980813E-05_JPRB, 0.82096773E-05_JPRB, &
  & 0.81198492E-05_JPRB, 0.80107371E-05_JPRB, 0.78795955E-05_JPRB, 0.77076754E-05_JPRB, 0.75166365E-05_JPRB, 0.72927382E-05_JPRB, &
  & 0.69896546E-05_JPRB, 0.67306459E-05_JPRB, 0.65452175E-05_JPRB, 0.64265347E-05_JPRB, 0.63333135E-05_JPRB, 0.62833772E-05_JPRB, &
  & 0.62502059E-05_JPRB, 0.62388282E-05_JPRB, 0.62940960E-05_JPRB, 0.63458832E-05_JPRB  /)

RGHG7(:,16, 6) = (/ &
  & 0.44482306E-05_JPRB, 0.44448293E-05_JPRB, 0.44364762E-05_JPRB, 0.44279258E-05_JPRB, 0.44156323E-05_JPRB, 0.44011416E-05_JPRB, &
  & 0.43867882E-05_JPRB, 0.43827619E-05_JPRB, 0.44021007E-05_JPRB, 0.44686515E-05_JPRB, 0.46098616E-05_JPRB, 0.48536368E-05_JPRB, &
  & 0.52237984E-05_JPRB, 0.56885385E-05_JPRB, 0.61536324E-05_JPRB, 0.65494420E-05_JPRB, 0.68765206E-05_JPRB, 0.71267222E-05_JPRB, &
  & 0.73175059E-05_JPRB, 0.74725653E-05_JPRB, 0.76127375E-05_JPRB, 0.77566211E-05_JPRB, 0.79047430E-05_JPRB, 0.80194912E-05_JPRB, &
  & 0.81110912E-05_JPRB, 0.81972663E-05_JPRB, 0.82819095E-05_JPRB, 0.83727660E-05_JPRB, 0.84756375E-05_JPRB, 0.85834959E-05_JPRB, &
  & 0.86950372E-05_JPRB, 0.87951529E-05_JPRB, 0.88766739E-05_JPRB, 0.89342701E-05_JPRB, 0.89986874E-05_JPRB, 0.90969361E-05_JPRB, &
  & 0.91992767E-05_JPRB, 0.92428298E-05_JPRB, 0.92431499E-05_JPRB, 0.92202967E-05_JPRB, 0.91818681E-05_JPRB, 0.91240953E-05_JPRB, &
  & 0.90548729E-05_JPRB, 0.89679374E-05_JPRB, 0.88689310E-05_JPRB, 0.87747539E-05_JPRB, 0.86610030E-05_JPRB, 0.85427027E-05_JPRB, &
  & 0.84089324E-05_JPRB, 0.82600610E-05_JPRB, 0.80838697E-05_JPRB, 0.78641503E-05_JPRB, 0.76296611E-05_JPRB, 0.73759679E-05_JPRB, &
  & 0.70521880E-05_JPRB, 0.67703684E-05_JPRB, 0.65643357E-05_JPRB, 0.64177912E-05_JPRB, 0.62812351E-05_JPRB, 0.61959993E-05_JPRB, &
  & 0.61463481E-05_JPRB, 0.61244209E-05_JPRB, 0.61570414E-05_JPRB, 0.61850275E-05_JPRB  /)

RGHG7(:,17, 6) = (/ &
  & 0.41446320E-05_JPRB, 0.41471430E-05_JPRB, 0.41467471E-05_JPRB, 0.41451058E-05_JPRB, 0.41399384E-05_JPRB, 0.41286934E-05_JPRB, &
  & 0.41174316E-05_JPRB, 0.41139828E-05_JPRB, 0.41325677E-05_JPRB, 0.41942320E-05_JPRB, 0.43180070E-05_JPRB, 0.45203773E-05_JPRB, &
  & 0.48224293E-05_JPRB, 0.52036943E-05_JPRB, 0.56057366E-05_JPRB, 0.59707883E-05_JPRB, 0.62997866E-05_JPRB, 0.65990477E-05_JPRB, &
  & 0.68660897E-05_JPRB, 0.71019754E-05_JPRB, 0.73176739E-05_JPRB, 0.75302690E-05_JPRB, 0.77254480E-05_JPRB, 0.78718021E-05_JPRB, &
  & 0.80021091E-05_JPRB, 0.81358982E-05_JPRB, 0.82764498E-05_JPRB, 0.84459568E-05_JPRB, 0.86643436E-05_JPRB, 0.89320020E-05_JPRB, &
  & 0.91999583E-05_JPRB, 0.93668738E-05_JPRB, 0.94131187E-05_JPRB, 0.93845963E-05_JPRB, 0.93555406E-05_JPRB, 0.93814411E-05_JPRB, &
  & 0.94340839E-05_JPRB, 0.94412164E-05_JPRB, 0.94186533E-05_JPRB, 0.93798093E-05_JPRB, 0.93304575E-05_JPRB, 0.92594592E-05_JPRB, &
  & 0.91675452E-05_JPRB, 0.90553481E-05_JPRB, 0.89297181E-05_JPRB, 0.88100496E-05_JPRB, 0.86755090E-05_JPRB, 0.85323088E-05_JPRB, &
  & 0.83740818E-05_JPRB, 0.82059781E-05_JPRB, 0.80059139E-05_JPRB, 0.77674241E-05_JPRB, 0.75084021E-05_JPRB, 0.72378708E-05_JPRB, &
  & 0.69121784E-05_JPRB, 0.66191639E-05_JPRB, 0.63997941E-05_JPRB, 0.62302683E-05_JPRB, 0.60557661E-05_JPRB, 0.59264574E-05_JPRB, &
  & 0.58518778E-05_JPRB, 0.58167146E-05_JPRB, 0.58271759E-05_JPRB, 0.58369419E-05_JPRB  /)

RGHG7(:,18, 6) = (/ &
  & 0.38813545E-05_JPRB, 0.38905829E-05_JPRB, 0.39019446E-05_JPRB, 0.39128886E-05_JPRB, 0.39221899E-05_JPRB, 0.39256870E-05_JPRB, &
  & 0.39311427E-05_JPRB, 0.39477327E-05_JPRB, 0.39875611E-05_JPRB, 0.40682566E-05_JPRB, 0.42045760E-05_JPRB, 0.44080161E-05_JPRB, &
  & 0.46873303E-05_JPRB, 0.50194629E-05_JPRB, 0.53668115E-05_JPRB, 0.56689120E-05_JPRB, 0.59389908E-05_JPRB, 0.62123362E-05_JPRB, &
  & 0.64816650E-05_JPRB, 0.67459228E-05_JPRB, 0.70160544E-05_JPRB, 0.72753108E-05_JPRB, 0.74900157E-05_JPRB, 0.76560775E-05_JPRB, &
  & 0.78152125E-05_JPRB, 0.79829834E-05_JPRB, 0.81601008E-05_JPRB, 0.83897430E-05_JPRB, 0.86945734E-05_JPRB, 0.90656831E-05_JPRB, &
  & 0.94160884E-05_JPRB, 0.96111821E-05_JPRB, 0.96284553E-05_JPRB, 0.95450870E-05_JPRB, 0.94669900E-05_JPRB, 0.94546711E-05_JPRB, &
  & 0.94816831E-05_JPRB, 0.94762855E-05_JPRB, 0.94444407E-05_JPRB, 0.93925195E-05_JPRB, 0.93263273E-05_JPRB, 0.92405962E-05_JPRB, &
  & 0.91193785E-05_JPRB, 0.89696821E-05_JPRB, 0.88167718E-05_JPRB, 0.86744693E-05_JPRB, 0.85274927E-05_JPRB, 0.83707829E-05_JPRB, &
  & 0.82014412E-05_JPRB, 0.80223354E-05_JPRB, 0.78207991E-05_JPRB, 0.75915545E-05_JPRB, 0.73286407E-05_JPRB, 0.70551099E-05_JPRB, &
  & 0.67250897E-05_JPRB, 0.64073514E-05_JPRB, 0.61577320E-05_JPRB, 0.59638001E-05_JPRB, 0.57677018E-05_JPRB, 0.55993490E-05_JPRB, &
  & 0.54746406E-05_JPRB, 0.54039208E-05_JPRB, 0.53953918E-05_JPRB, 0.54016298E-05_JPRB  /)

RGHG7(:,19, 6) = (/ &
  & 0.36622291E-05_JPRB, 0.36772257E-05_JPRB, 0.36964127E-05_JPRB, 0.37207814E-05_JPRB, 0.37459517E-05_JPRB, 0.37696343E-05_JPRB, &
  & 0.37981868E-05_JPRB, 0.38442146E-05_JPRB, 0.39183004E-05_JPRB, 0.40331953E-05_JPRB, 0.41979313E-05_JPRB, 0.44190602E-05_JPRB, &
  & 0.46991513E-05_JPRB, 0.50108091E-05_JPRB, 0.53237690E-05_JPRB, 0.55730219E-05_JPRB, 0.57784197E-05_JPRB, 0.59920968E-05_JPRB, &
  & 0.62227527E-05_JPRB, 0.64705089E-05_JPRB, 0.67513917E-05_JPRB, 0.70313737E-05_JPRB, 0.72579403E-05_JPRB, 0.74374102E-05_JPRB, &
  & 0.76139276E-05_JPRB, 0.78030154E-05_JPRB, 0.80085994E-05_JPRB, 0.82628940E-05_JPRB, 0.85937822E-05_JPRB, 0.89991603E-05_JPRB, &
  & 0.93705806E-05_JPRB, 0.95611205E-05_JPRB, 0.95661019E-05_JPRB, 0.94783471E-05_JPRB, 0.94005957E-05_JPRB, 0.93755237E-05_JPRB, &
  & 0.93888370E-05_JPRB, 0.93809791E-05_JPRB, 0.93459160E-05_JPRB, 0.92818894E-05_JPRB, 0.91954646E-05_JPRB, 0.90942806E-05_JPRB, &
  & 0.89454667E-05_JPRB, 0.87563230E-05_JPRB, 0.85764960E-05_JPRB, 0.84131669E-05_JPRB, 0.82594845E-05_JPRB, 0.80950985E-05_JPRB, &
  & 0.79151216E-05_JPRB, 0.77218240E-05_JPRB, 0.75158602E-05_JPRB, 0.72982902E-05_JPRB, 0.70430370E-05_JPRB, 0.67683558E-05_JPRB, &
  & 0.64417545E-05_JPRB, 0.61104831E-05_JPRB, 0.58437542E-05_JPRB, 0.56319291E-05_JPRB, 0.54260703E-05_JPRB, 0.52399467E-05_JPRB, &
  & 0.50728748E-05_JPRB, 0.49593109E-05_JPRB, 0.49241955E-05_JPRB, 0.49270095E-05_JPRB  /)

RGHG7(:,20, 6) = (/ &
  & 0.34827674E-05_JPRB, 0.35002297E-05_JPRB, 0.35243840E-05_JPRB, 0.35597160E-05_JPRB, 0.35996211E-05_JPRB, 0.36421102E-05_JPRB, &
  & 0.36943357E-05_JPRB, 0.37721144E-05_JPRB, 0.38833035E-05_JPRB, 0.40352666E-05_JPRB, 0.42302243E-05_JPRB, 0.44743900E-05_JPRB, &
  & 0.47638433E-05_JPRB, 0.50686526E-05_JPRB, 0.53534579E-05_JPRB, 0.55613760E-05_JPRB, 0.57190774E-05_JPRB, 0.58757514E-05_JPRB, &
  & 0.60596945E-05_JPRB, 0.62749363E-05_JPRB, 0.65318894E-05_JPRB, 0.68004230E-05_JPRB, 0.70286704E-05_JPRB, 0.72178932E-05_JPRB, &
  & 0.74023645E-05_JPRB, 0.75991220E-05_JPRB, 0.78133220E-05_JPRB, 0.80544081E-05_JPRB, 0.83668160E-05_JPRB, 0.87559833E-05_JPRB, &
  & 0.90977513E-05_JPRB, 0.92657949E-05_JPRB, 0.92735982E-05_JPRB, 0.92095929E-05_JPRB, 0.91554188E-05_JPRB, 0.91333293E-05_JPRB, &
  & 0.91385586E-05_JPRB, 0.91298225E-05_JPRB, 0.90938605E-05_JPRB, 0.90206234E-05_JPRB, 0.89179883E-05_JPRB, 0.88068073E-05_JPRB, &
  & 0.86406401E-05_JPRB, 0.84286104E-05_JPRB, 0.82286939E-05_JPRB, 0.80528145E-05_JPRB, 0.78940946E-05_JPRB, 0.77201539E-05_JPRB, &
  & 0.75268654E-05_JPRB, 0.73182695E-05_JPRB, 0.70979399E-05_JPRB, 0.68827818E-05_JPRB, 0.66400951E-05_JPRB, 0.63679825E-05_JPRB, &
  & 0.60551662E-05_JPRB, 0.57411648E-05_JPRB, 0.54884838E-05_JPRB, 0.52821277E-05_JPRB, 0.50803572E-05_JPRB, 0.48940086E-05_JPRB, &
  & 0.47073256E-05_JPRB, 0.45553337E-05_JPRB, 0.44855241E-05_JPRB, 0.44775199E-05_JPRB  /)

RGHG7(:,21, 6) = (/ &
  & 0.33395315E-05_JPRB, 0.33565634E-05_JPRB, 0.33848433E-05_JPRB, 0.34282323E-05_JPRB, 0.34801273E-05_JPRB, 0.35383323E-05_JPRB, &
  & 0.36119753E-05_JPRB, 0.37189864E-05_JPRB, 0.38628023E-05_JPRB, 0.40451081E-05_JPRB, 0.42640946E-05_JPRB, 0.45277073E-05_JPRB, &
  & 0.48241558E-05_JPRB, 0.51210388E-05_JPRB, 0.53763263E-05_JPRB, 0.55519085E-05_JPRB, 0.56818678E-05_JPRB, 0.57970631E-05_JPRB, &
  & 0.59394855E-05_JPRB, 0.61195935E-05_JPRB, 0.63318900E-05_JPRB, 0.65630405E-05_JPRB, 0.67778362E-05_JPRB, 0.69702242E-05_JPRB, &
  & 0.71557583E-05_JPRB, 0.73455516E-05_JPRB, 0.75442854E-05_JPRB, 0.77485967E-05_JPRB, 0.80161798E-05_JPRB, 0.83498761E-05_JPRB, &
  & 0.86229311E-05_JPRB, 0.87621102E-05_JPRB, 0.87859227E-05_JPRB, 0.87577815E-05_JPRB, 0.87334613E-05_JPRB, 0.87212782E-05_JPRB, &
  & 0.87200234E-05_JPRB, 0.87058329E-05_JPRB, 0.86671545E-05_JPRB, 0.85893217E-05_JPRB, 0.84803927E-05_JPRB, 0.83700425E-05_JPRB, &
  & 0.82037568E-05_JPRB, 0.79944579E-05_JPRB, 0.77914862E-05_JPRB, 0.76160365E-05_JPRB, 0.74542450E-05_JPRB, 0.72693840E-05_JPRB, &
  & 0.70643276E-05_JPRB, 0.68463305E-05_JPRB, 0.66112459E-05_JPRB, 0.63903262E-05_JPRB, 0.61594925E-05_JPRB, 0.58983567E-05_JPRB, &
  & 0.56107366E-05_JPRB, 0.53408376E-05_JPRB, 0.51265991E-05_JPRB, 0.49468253E-05_JPRB, 0.47654679E-05_JPRB, 0.45927456E-05_JPRB, &
  & 0.44098730E-05_JPRB, 0.42357048E-05_JPRB, 0.41334411E-05_JPRB, 0.41036674E-05_JPRB  /)

RGHG7(:,22, 6) = (/ &
  & 0.32373730E-05_JPRB, 0.32527829E-05_JPRB, 0.32860303E-05_JPRB, 0.33349952E-05_JPRB, 0.33939867E-05_JPRB, 0.34651682E-05_JPRB, &
  & 0.35557414E-05_JPRB, 0.36843461E-05_JPRB, 0.38489447E-05_JPRB, 0.40449366E-05_JPRB, 0.42752775E-05_JPRB, 0.45441619E-05_JPRB, &
  & 0.48343250E-05_JPRB, 0.51070798E-05_JPRB, 0.53294192E-05_JPRB, 0.54822927E-05_JPRB, 0.56029251E-05_JPRB, 0.56963239E-05_JPRB, &
  & 0.58074204E-05_JPRB, 0.59539720E-05_JPRB, 0.61134501E-05_JPRB, 0.62922893E-05_JPRB, 0.64721093E-05_JPRB, 0.66540552E-05_JPRB, &
  & 0.68354329E-05_JPRB, 0.70007939E-05_JPRB, 0.71587734E-05_JPRB, 0.73233443E-05_JPRB, 0.75332429E-05_JPRB, 0.77730625E-05_JPRB, &
  & 0.79479828E-05_JPRB, 0.80615131E-05_JPRB, 0.81145227E-05_JPRB, 0.81251082E-05_JPRB, 0.81265383E-05_JPRB, 0.81226682E-05_JPRB, &
  & 0.81129989E-05_JPRB, 0.80821823E-05_JPRB, 0.80335688E-05_JPRB, 0.79577636E-05_JPRB, 0.78589725E-05_JPRB, 0.77665663E-05_JPRB, &
  & 0.76264363E-05_JPRB, 0.74528227E-05_JPRB, 0.72788453E-05_JPRB, 0.71213397E-05_JPRB, 0.69615757E-05_JPRB, 0.67697196E-05_JPRB, &
  & 0.65626356E-05_JPRB, 0.63512281E-05_JPRB, 0.61188808E-05_JPRB, 0.58898508E-05_JPRB, 0.56640860E-05_JPRB, 0.54285990E-05_JPRB, &
  & 0.51800097E-05_JPRB, 0.49674911E-05_JPRB, 0.47992786E-05_JPRB, 0.46558996E-05_JPRB, 0.45154993E-05_JPRB, 0.43699465E-05_JPRB, &
  & 0.42123172E-05_JPRB, 0.40482869E-05_JPRB, 0.39328439E-05_JPRB, 0.38666752E-05_JPRB  /)

RGHG7(:,23, 6) = (/ &
  & 0.31640820E-05_JPRB, 0.31807204E-05_JPRB, 0.32180354E-05_JPRB, 0.32729106E-05_JPRB, 0.33401612E-05_JPRB, 0.34213527E-05_JPRB, &
  & 0.35233894E-05_JPRB, 0.36616442E-05_JPRB, 0.38269305E-05_JPRB, 0.40139803E-05_JPRB, 0.42298745E-05_JPRB, 0.44741915E-05_JPRB, &
  & 0.47276790E-05_JPRB, 0.49549743E-05_JPRB, 0.51367074E-05_JPRB, 0.52656117E-05_JPRB, 0.53715645E-05_JPRB, 0.54482744E-05_JPRB, &
  & 0.55308423E-05_JPRB, 0.56362352E-05_JPRB, 0.57485543E-05_JPRB, 0.58747673E-05_JPRB, 0.60119381E-05_JPRB, 0.61597241E-05_JPRB, &
  & 0.63109966E-05_JPRB, 0.64439686E-05_JPRB, 0.65688899E-05_JPRB, 0.67014441E-05_JPRB, 0.68611355E-05_JPRB, 0.70137277E-05_JPRB, &
  & 0.71261023E-05_JPRB, 0.72301709E-05_JPRB, 0.73082031E-05_JPRB, 0.73421830E-05_JPRB, 0.73502233E-05_JPRB, 0.73347494E-05_JPRB, &
  & 0.73028421E-05_JPRB, 0.72449109E-05_JPRB, 0.71796944E-05_JPRB, 0.71136740E-05_JPRB, 0.70458231E-05_JPRB, 0.69878171E-05_JPRB, &
  & 0.68926491E-05_JPRB, 0.67742647E-05_JPRB, 0.66477465E-05_JPRB, 0.65216169E-05_JPRB, 0.63756297E-05_JPRB, 0.61991145E-05_JPRB, &
  & 0.60229713E-05_JPRB, 0.58469833E-05_JPRB, 0.56471619E-05_JPRB, 0.54309682E-05_JPRB, 0.52210566E-05_JPRB, 0.50268860E-05_JPRB, &
  & 0.48287010E-05_JPRB, 0.46625247E-05_JPRB, 0.45303433E-05_JPRB, 0.44138864E-05_JPRB, 0.43061236E-05_JPRB, 0.41954456E-05_JPRB, &
  & 0.40645306E-05_JPRB, 0.39347066E-05_JPRB, 0.38621740E-05_JPRB, 0.37973492E-05_JPRB  /)

RGHG7(:,24, 6) = (/ &
  & 0.30952843E-05_JPRB, 0.31126573E-05_JPRB, 0.31531860E-05_JPRB, 0.32132976E-05_JPRB, 0.32887947E-05_JPRB, 0.33789828E-05_JPRB, &
  & 0.34886308E-05_JPRB, 0.36295756E-05_JPRB, 0.37866519E-05_JPRB, 0.39554232E-05_JPRB, 0.41453941E-05_JPRB, 0.43519238E-05_JPRB, &
  & 0.45556528E-05_JPRB, 0.47293143E-05_JPRB, 0.48649665E-05_JPRB, 0.49666155E-05_JPRB, 0.50518138E-05_JPRB, 0.51099373E-05_JPRB, &
  & 0.51622287E-05_JPRB, 0.52225078E-05_JPRB, 0.52863103E-05_JPRB, 0.53585145E-05_JPRB, 0.54473478E-05_JPRB, 0.55499353E-05_JPRB, &
  & 0.56592465E-05_JPRB, 0.57576498E-05_JPRB, 0.58539235E-05_JPRB, 0.59594058E-05_JPRB, 0.60806412E-05_JPRB, 0.61725572E-05_JPRB, &
  & 0.62463923E-05_JPRB, 0.63462143E-05_JPRB, 0.64400671E-05_JPRB, 0.64844918E-05_JPRB, 0.64893501E-05_JPRB, 0.64570175E-05_JPRB, &
  & 0.63996107E-05_JPRB, 0.63152368E-05_JPRB, 0.62382888E-05_JPRB, 0.61868949E-05_JPRB, 0.61556811E-05_JPRB, 0.61379951E-05_JPRB, &
  & 0.60921388E-05_JPRB, 0.60303014E-05_JPRB, 0.59539028E-05_JPRB, 0.58612386E-05_JPRB, 0.57368276E-05_JPRB, 0.55884500E-05_JPRB, &
  & 0.54518668E-05_JPRB, 0.53186212E-05_JPRB, 0.51588443E-05_JPRB, 0.49682125E-05_JPRB, 0.47854409E-05_JPRB, 0.46340532E-05_JPRB, &
  & 0.44854919E-05_JPRB, 0.43606133E-05_JPRB, 0.42600170E-05_JPRB, 0.41680268E-05_JPRB, 0.40883508E-05_JPRB, 0.40116496E-05_JPRB, &
  & 0.39044589E-05_JPRB, 0.38060666E-05_JPRB, 0.37798532E-05_JPRB, 0.37343347E-05_JPRB  /)

RGHG7(:,25, 6) = (/ &
  & 0.30310517E-05_JPRB, 0.30476098E-05_JPRB, 0.30898971E-05_JPRB, 0.31537402E-05_JPRB, 0.32368290E-05_JPRB, 0.33344802E-05_JPRB, &
  & 0.34458010E-05_JPRB, 0.35796687E-05_JPRB, 0.37176584E-05_JPRB, 0.38575211E-05_JPRB, 0.40082037E-05_JPRB, 0.41619344E-05_JPRB, &
  & 0.43017984E-05_JPRB, 0.44145544E-05_JPRB, 0.44982226E-05_JPRB, 0.45683036E-05_JPRB, 0.46241215E-05_JPRB, 0.46599845E-05_JPRB, &
  & 0.46796357E-05_JPRB, 0.46915335E-05_JPRB, 0.47053249E-05_JPRB, 0.47235720E-05_JPRB, 0.47578907E-05_JPRB, 0.48030898E-05_JPRB, &
  & 0.48571571E-05_JPRB, 0.49204755E-05_JPRB, 0.49954751E-05_JPRB, 0.50821282E-05_JPRB, 0.51857782E-05_JPRB, 0.52652987E-05_JPRB, &
  & 0.53368606E-05_JPRB, 0.54382266E-05_JPRB, 0.55318221E-05_JPRB, 0.55667249E-05_JPRB, 0.55554991E-05_JPRB, 0.55022356E-05_JPRB, &
  & 0.54178074E-05_JPRB, 0.53117305E-05_JPRB, 0.52337103E-05_JPRB, 0.52031186E-05_JPRB, 0.52123082E-05_JPRB, 0.52399153E-05_JPRB, &
  & 0.52446277E-05_JPRB, 0.52347315E-05_JPRB, 0.52067571E-05_JPRB, 0.51467330E-05_JPRB, 0.50541044E-05_JPRB, 0.49502479E-05_JPRB, &
  & 0.48593009E-05_JPRB, 0.47733642E-05_JPRB, 0.46584515E-05_JPRB, 0.45100675E-05_JPRB, 0.43707875E-05_JPRB, 0.42593314E-05_JPRB, &
  & 0.41542189E-05_JPRB, 0.40623237E-05_JPRB, 0.39862611E-05_JPRB, 0.39154162E-05_JPRB, 0.38563709E-05_JPRB, 0.38087928E-05_JPRB, &
  & 0.37186299E-05_JPRB, 0.36399247E-05_JPRB, 0.36513697E-05_JPRB, 0.36476272E-05_JPRB  /)

RGHG7(:,26, 6) = (/ &
  & 0.29688349E-05_JPRB, 0.29820290E-05_JPRB, 0.30213083E-05_JPRB, 0.30840939E-05_JPRB, 0.31685415E-05_JPRB, 0.32656811E-05_JPRB, &
  & 0.33710327E-05_JPRB, 0.34890326E-05_JPRB, 0.36026981E-05_JPRB, 0.37121191E-05_JPRB, 0.38232707E-05_JPRB, 0.39248067E-05_JPRB, &
  & 0.40073960E-05_JPRB, 0.40666403E-05_JPRB, 0.41065637E-05_JPRB, 0.41464887E-05_JPRB, 0.41721652E-05_JPRB, 0.41827600E-05_JPRB, &
  & 0.41723630E-05_JPRB, 0.41415512E-05_JPRB, 0.41065903E-05_JPRB, 0.40805478E-05_JPRB, 0.40684460E-05_JPRB, 0.40627283E-05_JPRB, &
  & 0.40659670E-05_JPRB, 0.40921194E-05_JPRB, 0.41442284E-05_JPRB, 0.42173620E-05_JPRB, 0.43196718E-05_JPRB, 0.44167861E-05_JPRB, &
  & 0.44995004E-05_JPRB, 0.45962764E-05_JPRB, 0.46813841E-05_JPRB, 0.47059601E-05_JPRB, 0.46839468E-05_JPRB, 0.46231197E-05_JPRB, &
  & 0.45278804E-05_JPRB, 0.44244078E-05_JPRB, 0.43604610E-05_JPRB, 0.43519230E-05_JPRB, 0.43926352E-05_JPRB, 0.44532004E-05_JPRB, &
  & 0.44930714E-05_JPRB, 0.45199083E-05_JPRB, 0.45285938E-05_JPRB, 0.45013376E-05_JPRB, 0.44464232E-05_JPRB, 0.43852830E-05_JPRB, &
  & 0.43317424E-05_JPRB, 0.42811636E-05_JPRB, 0.42065917E-05_JPRB, 0.41029496E-05_JPRB, 0.40050568E-05_JPRB, 0.39262572E-05_JPRB, &
  & 0.38532950E-05_JPRB, 0.37866495E-05_JPRB, 0.37324024E-05_JPRB, 0.36837011E-05_JPRB, 0.36411404E-05_JPRB, 0.36083214E-05_JPRB, &
  & 0.35352116E-05_JPRB, 0.34742557E-05_JPRB, 0.34984771E-05_JPRB, 0.35217777E-05_JPRB  /)

RGHG7(:,27, 6) = (/ &
  & 0.29045332E-05_JPRB, 0.29132652E-05_JPRB, 0.29476320E-05_JPRB, 0.30075362E-05_JPRB, 0.30910934E-05_JPRB, 0.31847413E-05_JPRB, &
  & 0.32810184E-05_JPRB, 0.33791685E-05_JPRB, 0.34654606E-05_JPRB, 0.35424856E-05_JPRB, 0.36122169E-05_JPRB, 0.36594061E-05_JPRB, &
  & 0.36845571E-05_JPRB, 0.36905952E-05_JPRB, 0.36878377E-05_JPRB, 0.36967574E-05_JPRB, 0.36906383E-05_JPRB, 0.36736996E-05_JPRB, &
  & 0.36328476E-05_JPRB, 0.35594848E-05_JPRB, 0.34740190E-05_JPRB, 0.34052556E-05_JPRB, 0.33476213E-05_JPRB, 0.32910686E-05_JPRB, &
  & 0.32428020E-05_JPRB, 0.32293248E-05_JPRB, 0.32569018E-05_JPRB, 0.33178694E-05_JPRB, 0.34248015E-05_JPRB, 0.35514303E-05_JPRB, &
  & 0.36507828E-05_JPRB, 0.37404853E-05_JPRB, 0.38136672E-05_JPRB, 0.38271477E-05_JPRB, 0.37958198E-05_JPRB, 0.37320413E-05_JPRB, &
  & 0.36315093E-05_JPRB, 0.35397725E-05_JPRB, 0.34961558E-05_JPRB, 0.35111392E-05_JPRB, 0.35815161E-05_JPRB, 0.36719660E-05_JPRB, &
  & 0.37428823E-05_JPRB, 0.38024853E-05_JPRB, 0.38451375E-05_JPRB, 0.38521882E-05_JPRB, 0.38389043E-05_JPRB, 0.38217557E-05_JPRB, &
  & 0.38042729E-05_JPRB, 0.37862300E-05_JPRB, 0.37521581E-05_JPRB, 0.36962195E-05_JPRB, 0.36408176E-05_JPRB, 0.35934635E-05_JPRB, &
  & 0.35499258E-05_JPRB, 0.35068118E-05_JPRB, 0.34743655E-05_JPRB, 0.34491857E-05_JPRB, 0.34223227E-05_JPRB, 0.33996087E-05_JPRB, &
  & 0.33443377E-05_JPRB, 0.33012205E-05_JPRB, 0.33295740E-05_JPRB, 0.33756858E-05_JPRB  /)

RGHG7(:,28, 6) = (/ &
  & 0.29108411E-05_JPRB, 0.29105832E-05_JPRB, 0.29316847E-05_JPRB, 0.29755898E-05_JPRB, 0.30386362E-05_JPRB, 0.31092642E-05_JPRB, &
  & 0.31831320E-05_JPRB, 0.32524483E-05_JPRB, 0.33065234E-05_JPRB, 0.33516319E-05_JPRB, 0.33870833E-05_JPRB, 0.33968949E-05_JPRB, &
  & 0.33879084E-05_JPRB, 0.33659096E-05_JPRB, 0.33424841E-05_JPRB, 0.33315187E-05_JPRB, 0.33066701E-05_JPRB, 0.32702898E-05_JPRB, &
  & 0.32114915E-05_JPRB, 0.31134074E-05_JPRB, 0.30018369E-05_JPRB, 0.29110594E-05_JPRB, 0.28344795E-05_JPRB, 0.27555523E-05_JPRB, &
  & 0.26760787E-05_JPRB, 0.26279190E-05_JPRB, 0.26248845E-05_JPRB, 0.26621012E-05_JPRB, 0.27546404E-05_JPRB, 0.28905136E-05_JPRB, &
  & 0.30019656E-05_JPRB, 0.30879954E-05_JPRB, 0.31507985E-05_JPRB, 0.31653617E-05_JPRB, 0.31375104E-05_JPRB, 0.30811770E-05_JPRB, &
  & 0.30003151E-05_JPRB, 0.29402553E-05_JPRB, 0.29254082E-05_JPRB, 0.29605969E-05_JPRB, 0.30427388E-05_JPRB, 0.31395011E-05_JPRB, &
  & 0.32218715E-05_JPRB, 0.32944404E-05_JPRB, 0.33524298E-05_JPRB, 0.33823672E-05_JPRB, 0.33969058E-05_JPRB, 0.34076560E-05_JPRB, &
  & 0.34153282E-05_JPRB, 0.34190649E-05_JPRB, 0.34106546E-05_JPRB, 0.33876493E-05_JPRB, 0.33606515E-05_JPRB, 0.33341461E-05_JPRB, &
  & 0.33097840E-05_JPRB, 0.32868009E-05_JPRB, 0.32723840E-05_JPRB, 0.32642388E-05_JPRB, 0.32532398E-05_JPRB, 0.32345583E-05_JPRB, &
  & 0.31879813E-05_JPRB, 0.31612438E-05_JPRB, 0.32028154E-05_JPRB, 0.32520814E-05_JPRB  /)

RGHG7(:,29, 6) = (/ &
  & 0.29205864E-05_JPRB, 0.29106067E-05_JPRB, 0.29172903E-05_JPRB, 0.29436741E-05_JPRB, 0.29841371E-05_JPRB, 0.30295269E-05_JPRB, &
  & 0.30790719E-05_JPRB, 0.31174469E-05_JPRB, 0.31371753E-05_JPRB, 0.31484864E-05_JPRB, 0.31479251E-05_JPRB, 0.31188679E-05_JPRB, &
  & 0.30747199E-05_JPRB, 0.30241050E-05_JPRB, 0.29797347E-05_JPRB, 0.29481814E-05_JPRB, 0.29040541E-05_JPRB, 0.28474246E-05_JPRB, &
  & 0.27701531E-05_JPRB, 0.26466477E-05_JPRB, 0.25084750E-05_JPRB, 0.23952697E-05_JPRB, 0.22997679E-05_JPRB, 0.21983671E-05_JPRB, &
  & 0.20867072E-05_JPRB, 0.20020130E-05_JPRB, 0.19662797E-05_JPRB, 0.19778279E-05_JPRB, 0.20542923E-05_JPRB, 0.21990817E-05_JPRB, &
  & 0.23231574E-05_JPRB, 0.24054431E-05_JPRB, 0.24573160E-05_JPRB, 0.24735544E-05_JPRB, 0.24499416E-05_JPRB, 0.24019477E-05_JPRB, &
  & 0.23430102E-05_JPRB, 0.23173794E-05_JPRB, 0.23333821E-05_JPRB, 0.23898360E-05_JPRB, 0.24836679E-05_JPRB, 0.25860966E-05_JPRB, &
  & 0.26797542E-05_JPRB, 0.27652031E-05_JPRB, 0.28386356E-05_JPRB, 0.28923283E-05_JPRB, 0.29357485E-05_JPRB, 0.29753619E-05_JPRB, &
  & 0.30092152E-05_JPRB, 0.30355629E-05_JPRB, 0.30536998E-05_JPRB, 0.30649496E-05_JPRB, 0.30674376E-05_JPRB, 0.30625637E-05_JPRB, &
  & 0.30580754E-05_JPRB, 0.30562752E-05_JPRB, 0.30607983E-05_JPRB, 0.30704215E-05_JPRB, 0.30762388E-05_JPRB, 0.30615669E-05_JPRB, &
  & 0.30238054E-05_JPRB, 0.30143602E-05_JPRB, 0.30703314E-05_JPRB, 0.31220874E-05_JPRB  /)

RGHG7(:,30, 6) = (/ &
  & 0.28208515E-05_JPRB, 0.28110400E-05_JPRB, 0.28123548E-05_JPRB, 0.28291209E-05_JPRB, 0.28556512E-05_JPRB, 0.28872345E-05_JPRB, &
  & 0.29202879E-05_JPRB, 0.29375495E-05_JPRB, 0.29359200E-05_JPRB, 0.29244101E-05_JPRB, 0.29002377E-05_JPRB, 0.28507032E-05_JPRB, &
  & 0.27901504E-05_JPRB, 0.27275595E-05_JPRB, 0.26720244E-05_JPRB, 0.26306415E-05_JPRB, 0.25794361E-05_JPRB, 0.25139424E-05_JPRB, &
  & 0.24284194E-05_JPRB, 0.22954339E-05_JPRB, 0.21520905E-05_JPRB, 0.20327853E-05_JPRB, 0.19299002E-05_JPRB, 0.18251660E-05_JPRB, &
  & 0.17127694E-05_JPRB, 0.16200166E-05_JPRB, 0.15675429E-05_JPRB, 0.15590438E-05_JPRB, 0.16148102E-05_JPRB, 0.17335038E-05_JPRB, &
  & 0.18457050E-05_JPRB, 0.19216022E-05_JPRB, 0.19650856E-05_JPRB, 0.19790417E-05_JPRB, 0.19619948E-05_JPRB, 0.19284033E-05_JPRB, &
  & 0.18978088E-05_JPRB, 0.19015135E-05_JPRB, 0.19371821E-05_JPRB, 0.20023725E-05_JPRB, 0.20939632E-05_JPRB, 0.21897384E-05_JPRB, &
  & 0.22841621E-05_JPRB, 0.23733540E-05_JPRB, 0.24526066E-05_JPRB, 0.25202813E-05_JPRB, 0.25792321E-05_JPRB, 0.26350839E-05_JPRB, &
  & 0.26856878E-05_JPRB, 0.27271584E-05_JPRB, 0.27612259E-05_JPRB, 0.27887028E-05_JPRB, 0.28061752E-05_JPRB, 0.28168253E-05_JPRB, &
  & 0.28252541E-05_JPRB, 0.28339273E-05_JPRB, 0.28477156E-05_JPRB, 0.28675036E-05_JPRB, 0.28832436E-05_JPRB, 0.28789010E-05_JPRB, &
  & 0.28535962E-05_JPRB, 0.28517098E-05_JPRB, 0.29058443E-05_JPRB, 0.29512656E-05_JPRB  /)

RGHG7(:,31, 6) = (/ &
  & 0.27156616E-05_JPRB, 0.27060367E-05_JPRB, 0.27017031E-05_JPRB, 0.27083430E-05_JPRB, 0.27202013E-05_JPRB, 0.27372483E-05_JPRB, &
  & 0.27529327E-05_JPRB, 0.27479572E-05_JPRB, 0.27238363E-05_JPRB, 0.26882914E-05_JPRB, 0.26392529E-05_JPRB, 0.25681598E-05_JPRB, &
  & 0.24903398E-05_JPRB, 0.24151463E-05_JPRB, 0.23478566E-05_JPRB, 0.22961270E-05_JPRB, 0.22374753E-05_JPRB, 0.21626525E-05_JPRB, &
  & 0.20684451E-05_JPRB, 0.19254860E-05_JPRB, 0.17767148E-05_JPRB, 0.16509980E-05_JPRB, 0.15403444E-05_JPRB, 0.14321160E-05_JPRB, &
  & 0.13189731E-05_JPRB, 0.12177563E-05_JPRB, 0.11476592E-05_JPRB, 0.11180426E-05_JPRB, 0.11519959E-05_JPRB, 0.12431604E-05_JPRB, &
  & 0.13428268E-05_JPRB, 0.14119901E-05_JPRB, 0.14466364E-05_JPRB, 0.14581839E-05_JPRB, 0.14480574E-05_JPRB, 0.14296468E-05_JPRB, &
  & 0.14289222E-05_JPRB, 0.14635315E-05_JPRB, 0.15199105E-05_JPRB, 0.15942942E-05_JPRB, 0.16835103E-05_JPRB, 0.17722633E-05_JPRB, &
  & 0.18674842E-05_JPRB, 0.19606112E-05_JPRB, 0.20459871E-05_JPRB, 0.21283847E-05_JPRB, 0.22036868E-05_JPRB, 0.22766361E-05_JPRB, &
  & 0.23448803E-05_JPRB, 0.24022782E-05_JPRB, 0.24531210E-05_JPRB, 0.24976785E-05_JPRB, 0.25309255E-05_JPRB, 0.25579269E-05_JPRB, &
  & 0.25799590E-05_JPRB, 0.25996575E-05_JPRB, 0.26231989E-05_JPRB, 0.26536898E-05_JPRB, 0.26798783E-05_JPRB, 0.26864252E-05_JPRB, &
  & 0.26742490E-05_JPRB, 0.26803177E-05_JPRB, 0.27325016E-05_JPRB, 0.27712399E-05_JPRB  /)

RGHG7(:,32, 6) = (/ &
  & 0.25629739E-05_JPRB, 0.25580393E-05_JPRB, 0.25548551E-05_JPRB, 0.25565910E-05_JPRB, 0.25586178E-05_JPRB, 0.25652613E-05_JPRB, &
  & 0.25670880E-05_JPRB, 0.25483435E-05_JPRB, 0.25120093E-05_JPRB, 0.24614585E-05_JPRB, 0.23988240E-05_JPRB, 0.23171093E-05_JPRB, &
  & 0.22309591E-05_JPRB, 0.21488668E-05_JPRB, 0.20782814E-05_JPRB, 0.20223881E-05_JPRB, 0.19619557E-05_JPRB, 0.18851846E-05_JPRB, &
  & 0.17898922E-05_JPRB, 0.16485727E-05_JPRB, 0.15023953E-05_JPRB, 0.13774975E-05_JPRB, 0.12645222E-05_JPRB, 0.11572312E-05_JPRB, &
  & 0.10529217E-05_JPRB, 0.96276916E-06_JPRB, 0.89611306E-06_JPRB, 0.85974680E-06_JPRB, 0.87365636E-06_JPRB, 0.93685252E-06_JPRB, &
  & 0.10123008E-05_JPRB, 0.10668046E-05_JPRB, 0.10949284E-05_JPRB, 0.11079841E-05_JPRB, 0.11093427E-05_JPRB, 0.11075377E-05_JPRB, &
  & 0.11245817E-05_JPRB, 0.11702472E-05_JPRB, 0.12294803E-05_JPRB, 0.12997213E-05_JPRB, 0.13795261E-05_JPRB, 0.14597320E-05_JPRB, &
  & 0.15531570E-05_JPRB, 0.16481946E-05_JPRB, 0.17368021E-05_JPRB, 0.18249815E-05_JPRB, 0.19095501E-05_JPRB, 0.19929410E-05_JPRB, &
  & 0.20706082E-05_JPRB, 0.21364882E-05_JPRB, 0.21956614E-05_JPRB, 0.22481599E-05_JPRB, 0.22890392E-05_JPRB, 0.23244469E-05_JPRB, &
  & 0.23554139E-05_JPRB, 0.23825873E-05_JPRB, 0.24107865E-05_JPRB, 0.24473512E-05_JPRB, 0.24800905E-05_JPRB, 0.24973743E-05_JPRB, &
  & 0.24991049E-05_JPRB, 0.25106973E-05_JPRB, 0.25547048E-05_JPRB, 0.25854388E-05_JPRB  /)

RGHG7(:,33, 6) = (/ &
  & 0.23981440E-05_JPRB, 0.23986670E-05_JPRB, 0.23975572E-05_JPRB, 0.23948729E-05_JPRB, 0.23873091E-05_JPRB, 0.23836758E-05_JPRB, &
  & 0.23715554E-05_JPRB, 0.23395980E-05_JPRB, 0.22919019E-05_JPRB, 0.22269253E-05_JPRB, 0.21516204E-05_JPRB, 0.20602832E-05_JPRB, &
  & 0.19666328E-05_JPRB, 0.18781096E-05_JPRB, 0.18051944E-05_JPRB, 0.17457744E-05_JPRB, 0.16842249E-05_JPRB, 0.16063847E-05_JPRB, &
  & 0.15109487E-05_JPRB, 0.13728367E-05_JPRB, 0.12303933E-05_JPRB, 0.11072828E-05_JPRB, 0.99260011E-06_JPRB, 0.88685695E-06_JPRB, &
  & 0.79296788E-06_JPRB, 0.71684215E-06_JPRB, 0.65648935E-06_JPRB, 0.61496875E-06_JPRB, 0.60827689E-06_JPRB, 0.64235021E-06_JPRB, &
  & 0.69111719E-06_JPRB, 0.72936010E-06_JPRB, 0.75100504E-06_JPRB, 0.76613522E-06_JPRB, 0.78002065E-06_JPRB, 0.79565741E-06_JPRB, &
  & 0.82960067E-06_JPRB, 0.88418652E-06_JPRB, 0.94407393E-06_JPRB, 0.10082829E-05_JPRB, 0.10773960E-05_JPRB, 0.11485220E-05_JPRB, &
  & 0.12397448E-05_JPRB, 0.13365058E-05_JPRB, 0.14280974E-05_JPRB, 0.15211280E-05_JPRB, 0.16144095E-05_JPRB, 0.17077899E-05_JPRB, &
  & 0.17941859E-05_JPRB, 0.18679172E-05_JPRB, 0.19346544E-05_JPRB, 0.19942221E-05_JPRB, 0.20419792E-05_JPRB, 0.20850945E-05_JPRB, &
  & 0.21247425E-05_JPRB, 0.21592245E-05_JPRB, 0.21916046E-05_JPRB, 0.22338822E-05_JPRB, 0.22729248E-05_JPRB, 0.23013471E-05_JPRB, &
  & 0.23176311E-05_JPRB, 0.23346491E-05_JPRB, 0.23693533E-05_JPRB, 0.23915978E-05_JPRB  /)

RGHG7(:,34, 6) = (/ &
  & 0.22230602E-05_JPRB, 0.22276964E-05_JPRB, 0.22284782E-05_JPRB, 0.22224199E-05_JPRB, 0.22091171E-05_JPRB, 0.21989303E-05_JPRB, &
  & 0.21793323E-05_JPRB, 0.21416307E-05_JPRB, 0.20884417E-05_JPRB, 0.20168946E-05_JPRB, 0.19354402E-05_JPRB, 0.18409857E-05_JPRB, &
  & 0.17436854E-05_JPRB, 0.16518202E-05_JPRB, 0.15793303E-05_JPRB, 0.15196680E-05_JPRB, 0.14576891E-05_JPRB, 0.13799156E-05_JPRB, &
  & 0.12857864E-05_JPRB, 0.11558519E-05_JPRB, 0.10191288E-05_JPRB, 0.89914014E-06_JPRB, 0.78860627E-06_JPRB, 0.69013255E-06_JPRB, &
  & 0.60761978E-06_JPRB, 0.54325441E-06_JPRB, 0.49188879E-06_JPRB, 0.45287946E-06_JPRB, 0.43740721E-06_JPRB, 0.45247487E-06_JPRB, &
  & 0.48166557E-06_JPRB, 0.50752922E-06_JPRB, 0.52486506E-06_JPRB, 0.54136804E-06_JPRB, 0.56197966E-06_JPRB, 0.58788126E-06_JPRB, &
  & 0.62828669E-06_JPRB, 0.68138452E-06_JPRB, 0.73566759E-06_JPRB, 0.79157536E-06_JPRB, 0.84970220E-06_JPRB, 0.91252102E-06_JPRB, &
  & 0.99764004E-06_JPRB, 0.10914009E-05_JPRB, 0.11840725E-05_JPRB, 0.12781321E-05_JPRB, 0.13732384E-05_JPRB, 0.14688877E-05_JPRB, &
  & 0.15586511E-05_JPRB, 0.16364950E-05_JPRB, 0.17047033E-05_JPRB, 0.17668840E-05_JPRB, 0.18194289E-05_JPRB, 0.18666187E-05_JPRB, &
  & 0.19120103E-05_JPRB, 0.19520192E-05_JPRB, 0.19872901E-05_JPRB, 0.20334296E-05_JPRB, 0.20771552E-05_JPRB, 0.21126965E-05_JPRB, &
  & 0.21384856E-05_JPRB, 0.21602979E-05_JPRB, 0.21904059E-05_JPRB, 0.22057407E-05_JPRB  /)

RGHG7(:,35, 6) = (/ &
  & 0.20377896E-05_JPRB, 0.20459648E-05_JPRB, 0.20485977E-05_JPRB, 0.20396074E-05_JPRB, 0.20223805E-05_JPRB, 0.20073664E-05_JPRB, &
  & 0.19834000E-05_JPRB, 0.19436254E-05_JPRB, 0.18878006E-05_JPRB, 0.18135288E-05_JPRB, 0.17290980E-05_JPRB, 0.16347769E-05_JPRB, &
  & 0.15356996E-05_JPRB, 0.14419834E-05_JPRB, 0.13713445E-05_JPRB, 0.13131186E-05_JPRB, 0.12510508E-05_JPRB, 0.11739289E-05_JPRB, &
  & 0.10818876E-05_JPRB, 0.96291081E-06_JPRB, 0.83308822E-06_JPRB, 0.71699396E-06_JPRB, 0.61373073E-06_JPRB, 0.52566690E-06_JPRB, &
  & 0.45534095E-06_JPRB, 0.40190375E-06_JPRB, 0.36115533E-06_JPRB, 0.32866143E-06_JPRB, 0.31022761E-06_JPRB, 0.31094651E-06_JPRB, &
  & 0.32365612E-06_JPRB, 0.33878411E-06_JPRB, 0.35280300E-06_JPRB, 0.37035733E-06_JPRB, 0.39490783E-06_JPRB, 0.42768026E-06_JPRB, &
  & 0.46937396E-06_JPRB, 0.51560098E-06_JPRB, 0.56091051E-06_JPRB, 0.60711917E-06_JPRB, 0.65379957E-06_JPRB, 0.70847410E-06_JPRB, &
  & 0.78531555E-06_JPRB, 0.87356789E-06_JPRB, 0.96637274E-06_JPRB, 0.10595291E-05_JPRB, 0.11529769E-05_JPRB, 0.12469974E-05_JPRB, &
  & 0.13374715E-05_JPRB, 0.14176255E-05_JPRB, 0.14842197E-05_JPRB, 0.15468002E-05_JPRB, 0.16031952E-05_JPRB, 0.16527098E-05_JPRB, &
  & 0.17024993E-05_JPRB, 0.17472763E-05_JPRB, 0.17848572E-05_JPRB, 0.18340176E-05_JPRB, 0.18817265E-05_JPRB, 0.19225245E-05_JPRB, &
  & 0.19554954E-05_JPRB, 0.19819129E-05_JPRB, 0.20097109E-05_JPRB, 0.20187524E-05_JPRB  /)

RGHG7(:,36, 6) = (/ &
  & 0.18506595E-05_JPRB, 0.18612618E-05_JPRB, 0.18647301E-05_JPRB, 0.18531301E-05_JPRB, 0.18335203E-05_JPRB, 0.18155455E-05_JPRB, &
  & 0.17898965E-05_JPRB, 0.17507113E-05_JPRB, 0.16945772E-05_JPRB, 0.16202251E-05_JPRB, 0.15352941E-05_JPRB, 0.14423328E-05_JPRB, &
  & 0.13427095E-05_JPRB, 0.12482890E-05_JPRB, 0.11793149E-05_JPRB, 0.11227558E-05_JPRB, 0.10608577E-05_JPRB, 0.98556494E-06_JPRB, &
  & 0.89669380E-06_JPRB, 0.78863783E-06_JPRB, 0.66723733E-06_JPRB, 0.55653473E-06_JPRB, 0.46116081E-06_JPRB, 0.38367549E-06_JPRB, &
  & 0.32554036E-06_JPRB, 0.28272790E-06_JPRB, 0.25189267E-06_JPRB, 0.22611740E-06_JPRB, 0.20701619E-06_JPRB, 0.19790707E-06_JPRB, &
  & 0.19840364E-06_JPRB, 0.20498575E-06_JPRB, 0.21558424E-06_JPRB, 0.23261953E-06_JPRB, 0.25825600E-06_JPRB, 0.29389901E-06_JPRB, &
  & 0.33459441E-06_JPRB, 0.37423141E-06_JPRB, 0.41161517E-06_JPRB, 0.44950158E-06_JPRB, 0.48638692E-06_JPRB, 0.53311486E-06_JPRB, &
  & 0.60096307E-06_JPRB, 0.68228473E-06_JPRB, 0.77304306E-06_JPRB, 0.86426350E-06_JPRB, 0.95523101E-06_JPRB, 0.10461237E-05_JPRB, &
  & 0.11346480E-05_JPRB, 0.12147827E-05_JPRB, 0.12793174E-05_JPRB, 0.13412550E-05_JPRB, 0.14004035E-05_JPRB, 0.14511872E-05_JPRB, &
  & 0.15038822E-05_JPRB, 0.15523098E-05_JPRB, 0.15926980E-05_JPRB, 0.16443365E-05_JPRB, 0.16946735E-05_JPRB, 0.17389823E-05_JPRB, &
  & 0.17772871E-05_JPRB, 0.18072100E-05_JPRB, 0.18321837E-05_JPRB, 0.18348250E-05_JPRB  /)

RGHG7(:,37, 6) = (/ &
  & 0.16709083E-05_JPRB, 0.16812372E-05_JPRB, 0.16831608E-05_JPRB, 0.16698521E-05_JPRB, 0.16515409E-05_JPRB, 0.16350699E-05_JPRB, &
  & 0.16140002E-05_JPRB, 0.15814721E-05_JPRB, 0.15303821E-05_JPRB, 0.14620174E-05_JPRB, 0.13822945E-05_JPRB, 0.12934204E-05_JPRB, &
  & 0.11961073E-05_JPRB, 0.11036553E-05_JPRB, 0.10358157E-05_JPRB, 0.98134811E-06_JPRB, 0.92020181E-06_JPRB, 0.84932438E-06_JPRB, &
  & 0.76590744E-06_JPRB, 0.66800806E-06_JPRB, 0.55799441E-06_JPRB, 0.45578069E-06_JPRB, 0.36922372E-06_JPRB, 0.30204534E-06_JPRB, &
  & 0.25535174E-06_JPRB, 0.22180733E-06_JPRB, 0.19865447E-06_JPRB, 0.17964570E-06_JPRB, 0.16517852E-06_JPRB, 0.15721764E-06_JPRB, &
  & 0.15604652E-06_JPRB, 0.15963496E-06_JPRB, 0.16678870E-06_JPRB, 0.17973675E-06_JPRB, 0.19985065E-06_JPRB, 0.22901424E-06_JPRB, &
  & 0.26353094E-06_JPRB, 0.29763171E-06_JPRB, 0.32998502E-06_JPRB, 0.36322374E-06_JPRB, 0.39470955E-06_JPRB, 0.43443861E-06_JPRB, &
  & 0.49221226E-06_JPRB, 0.56377377E-06_JPRB, 0.64761523E-06_JPRB, 0.73465274E-06_JPRB, 0.82140999E-06_JPRB, 0.90593257E-06_JPRB, &
  & 0.98652849E-06_JPRB, 0.10613047E-05_JPRB, 0.11228867E-05_JPRB, 0.11818306E-05_JPRB, 0.12410475E-05_JPRB, 0.12906009E-05_JPRB, &
  & 0.13425987E-05_JPRB, 0.13918875E-05_JPRB, 0.14360486E-05_JPRB, 0.14887670E-05_JPRB, 0.15384615E-05_JPRB, 0.15820595E-05_JPRB, &
  & 0.16211298E-05_JPRB, 0.16518182E-05_JPRB, 0.16729644E-05_JPRB, 0.16693587E-05_JPRB  /)

RGHG7(:,38, 6) = (/ &
  & 0.14714584E-05_JPRB, 0.14814839E-05_JPRB, 0.14816936E-05_JPRB, 0.14664889E-05_JPRB, 0.14496187E-05_JPRB, 0.14348161E-05_JPRB, &
  & 0.14188276E-05_JPRB, 0.13936862E-05_JPRB, 0.13481931E-05_JPRB, 0.12864718E-05_JPRB, 0.12125279E-05_JPRB, 0.11281889E-05_JPRB, &
  & 0.10334392E-05_JPRB, 0.94317128E-06_JPRB, 0.87659067E-06_JPRB, 0.82444371E-06_JPRB, 0.76413164E-06_JPRB, 0.69815339E-06_JPRB, &
  & 0.62078838E-06_JPRB, 0.53415862E-06_JPRB, 0.43677969E-06_JPRB, 0.34398514E-06_JPRB, 0.26721135E-06_JPRB, 0.21146945E-06_JPRB, &
  & 0.17747125E-06_JPRB, 0.15421056E-06_JPRB, 0.13958197E-06_JPRB, 0.12808122E-06_JPRB, 0.11875590E-06_JPRB, 0.11206912E-06_JPRB, &
  & 0.10904753E-06_JPRB, 0.10931424E-06_JPRB, 0.11264570E-06_JPRB, 0.12105860E-06_JPRB, 0.13504474E-06_JPRB, 0.15701882E-06_JPRB, &
  & 0.18467971E-06_JPRB, 0.21263754E-06_JPRB, 0.23940913E-06_JPRB, 0.26749082E-06_JPRB, 0.29298537E-06_JPRB, 0.32494855E-06_JPRB, &
  & 0.37154359E-06_JPRB, 0.43227533E-06_JPRB, 0.50844191E-06_JPRB, 0.59083810E-06_JPRB, 0.67292368E-06_JPRB, 0.75037810E-06_JPRB, &
  & 0.82217674E-06_JPRB, 0.89100716E-06_JPRB, 0.94931298E-06_JPRB, 0.10049352E-05_JPRB, 0.10642279E-05_JPRB, 0.11124162E-05_JPRB, &
  & 0.11636405E-05_JPRB, 0.12138848E-05_JPRB, 0.12622321E-05_JPRB, 0.13161488E-05_JPRB, 0.13651305E-05_JPRB, 0.14079398E-05_JPRB, &
  & 0.14478594E-05_JPRB, 0.14793972E-05_JPRB, 0.14962964E-05_JPRB, 0.14857591E-05_JPRB  /)

RGHG7(:,39, 6) = (/ &
  & 0.13145011E-05_JPRB, 0.13225476E-05_JPRB, 0.13219530E-05_JPRB, 0.13068655E-05_JPRB, 0.12946280E-05_JPRB, 0.12841206E-05_JPRB, &
  & 0.12742194E-05_JPRB, 0.12571493E-05_JPRB, 0.12196995E-05_JPRB, 0.11676058E-05_JPRB, 0.11015256E-05_JPRB, 0.10217562E-05_JPRB, &
  & 0.93286207E-06_JPRB, 0.84648333E-06_JPRB, 0.78120769E-06_JPRB, 0.72937194E-06_JPRB, 0.67193294E-06_JPRB, 0.61119607E-06_JPRB, &
  & 0.54060445E-06_JPRB, 0.46117371E-06_JPRB, 0.37330454E-06_JPRB, 0.29014997E-06_JPRB, 0.22268979E-06_JPRB, 0.17584739E-06_JPRB, &
  & 0.14863899E-06_JPRB, 0.13030208E-06_JPRB, 0.11902376E-06_JPRB, 0.11031259E-06_JPRB, 0.10297459E-06_JPRB, 0.97354634E-07_JPRB, &
  & 0.94406657E-07_JPRB, 0.94070588E-07_JPRB, 0.96138013E-07_JPRB, 0.10186870E-06_JPRB, 0.11193046E-06_JPRB, 0.12878113E-06_JPRB, &
  & 0.15122307E-06_JPRB, 0.17608379E-06_JPRB, 0.20097242E-06_JPRB, 0.22660127E-06_JPRB, 0.25035914E-06_JPRB, 0.27881391E-06_JPRB, &
  & 0.31917018E-06_JPRB, 0.37264762E-06_JPRB, 0.44215318E-06_JPRB, 0.51844495E-06_JPRB, 0.59578608E-06_JPRB, 0.66989382E-06_JPRB, &
  & 0.73705419E-06_JPRB, 0.80053699E-06_JPRB, 0.85514185E-06_JPRB, 0.90651750E-06_JPRB, 0.96123749E-06_JPRB, 0.10071042E-05_JPRB, &
  & 0.10529209E-05_JPRB, 0.10988965E-05_JPRB, 0.11466651E-05_JPRB, 0.11988465E-05_JPRB, 0.12464045E-05_JPRB, 0.12866081E-05_JPRB, &
  & 0.13233752E-05_JPRB, 0.13516786E-05_JPRB, 0.13645781E-05_JPRB, 0.13549710E-05_JPRB  /)

RGHG7(:,40, 6) = (/ &
  & 0.11372503E-05_JPRB, 0.11427002E-05_JPRB, 0.11413106E-05_JPRB, 0.11266899E-05_JPRB, 0.11204116E-05_JPRB, 0.11153747E-05_JPRB, &
  & 0.11127821E-05_JPRB, 0.11052963E-05_JPRB, 0.10776861E-05_JPRB, 0.10373795E-05_JPRB, 0.98086901E-06_JPRB, 0.90646797E-06_JPRB, &
  & 0.82498458E-06_JPRB, 0.74344905E-06_JPRB, 0.67971245E-06_JPRB, 0.62791317E-06_JPRB, 0.57417952E-06_JPRB, 0.51964985E-06_JPRB, &
  & 0.45712539E-06_JPRB, 0.38547735E-06_JPRB, 0.30825742E-06_JPRB, 0.23645231E-06_JPRB, 0.17984561E-06_JPRB, 0.14303245E-06_JPRB, &
  & 0.12282629E-06_JPRB, 0.10939095E-06_JPRB, 0.10119800E-06_JPRB, 0.94988662E-07_JPRB, 0.89466873E-07_JPRB, 0.85065013E-07_JPRB, &
  & 0.82518206E-07_JPRB, 0.81919553E-07_JPRB, 0.82922054E-07_JPRB, 0.85808080E-07_JPRB, 0.91624735E-07_JPRB, 0.10280067E-06_JPRB, &
  & 0.11938553E-06_JPRB, 0.14110983E-06_JPRB, 0.16439378E-06_JPRB, 0.18758643E-06_JPRB, 0.21000221E-06_JPRB, 0.23503609E-06_JPRB, &
  & 0.26887882E-06_JPRB, 0.31442768E-06_JPRB, 0.37628183E-06_JPRB, 0.44517020E-06_JPRB, 0.51693142E-06_JPRB, 0.58772039E-06_JPRB, &
  & 0.65011777E-06_JPRB, 0.70742255E-06_JPRB, 0.75761455E-06_JPRB, 0.80385522E-06_JPRB, 0.85244825E-06_JPRB, 0.89543382E-06_JPRB, &
  & 0.93414616E-06_JPRB, 0.97425744E-06_JPRB, 0.10205672E-05_JPRB, 0.10702322E-05_JPRB, 0.11160032E-05_JPRB, 0.11528515E-05_JPRB, &
  & 0.11852641E-05_JPRB, 0.12091036E-05_JPRB, 0.12173495E-05_JPRB, 0.12101202E-05_JPRB  /)

RGHG7(:,41, 6) = (/ &
  & 0.92053565E-06_JPRB, 0.92281074E-06_JPRB, 0.92044906E-06_JPRB, 0.90639906E-06_JPRB, 0.90740681E-06_JPRB, 0.90905836E-06_JPRB, &
  & 0.91540158E-06_JPRB, 0.91963397E-06_JPRB, 0.90405411E-06_JPRB, 0.87815902E-06_JPRB, 0.83334886E-06_JPRB, 0.76551145E-06_JPRB, &
  & 0.69308872E-06_JPRB, 0.61747472E-06_JPRB, 0.55561982E-06_JPRB, 0.50386512E-06_JPRB, 0.45466180E-06_JPRB, 0.40772133E-06_JPRB, &
  & 0.35506014E-06_JPRB, 0.29292758E-06_JPRB, 0.22872789E-06_JPRB, 0.17079915E-06_JPRB, 0.12746238E-06_JPRB, 0.10291144E-06_JPRB, &
  & 0.91266530E-07_JPRB, 0.83824064E-07_JPRB, 0.79403415E-07_JPRB, 0.76252944E-07_JPRB, 0.72951730E-07_JPRB, 0.70039171E-07_JPRB, &
  & 0.67982853E-07_JPRB, 0.67063153E-07_JPRB, 0.66763630E-07_JPRB, 0.66171647E-07_JPRB, 0.66798043E-07_JPRB, 0.71035798E-07_JPRB, &
  & 0.80459519E-07_JPRB, 0.98349095E-07_JPRB, 0.11967109E-06_JPRB, 0.13988514E-06_JPRB, 0.16066001E-06_JPRB, 0.18151136E-06_JPRB, &
  & 0.20739035E-06_JPRB, 0.24324537E-06_JPRB, 0.29574457E-06_JPRB, 0.35558119E-06_JPRB, 0.42052017E-06_JPRB, 0.48725146E-06_JPRB, &
  & 0.54382541E-06_JPRB, 0.59357667E-06_JPRB, 0.63837329E-06_JPRB, 0.67833571E-06_JPRB, 0.71943764E-06_JPRB, 0.75890061E-06_JPRB, &
  & 0.78892685E-06_JPRB, 0.82186808E-06_JPRB, 0.86639425E-06_JPRB, 0.91298251E-06_JPRB, 0.95656861E-06_JPRB, 0.98931470E-06_JPRB, &
  & 0.10164033E-05_JPRB, 0.10347849E-05_JPRB, 0.10373412E-05_JPRB, 0.10330191E-05_JPRB  /)

RGHG7(:,42, 6) = (/ &
  & 0.84121238E-06_JPRB, 0.84334517E-06_JPRB, 0.84265661E-06_JPRB, 0.82981269E-06_JPRB, 0.83227369E-06_JPRB, 0.83644117E-06_JPRB, &
  & 0.84536887E-06_JPRB, 0.85108607E-06_JPRB, 0.84241667E-06_JPRB, 0.82221306E-06_JPRB, 0.78441109E-06_JPRB, 0.72793192E-06_JPRB, &
  & 0.66317375E-06_JPRB, 0.59213418E-06_JPRB, 0.53405865E-06_JPRB, 0.48538751E-06_JPRB, 0.43858952E-06_JPRB, 0.39422240E-06_JPRB, &
  & 0.34490399E-06_JPRB, 0.28592143E-06_JPRB, 0.22537910E-06_JPRB, 0.17063662E-06_JPRB, 0.13095521E-06_JPRB, 0.10752655E-06_JPRB, &
  & 0.94824645E-07_JPRB, 0.86244086E-07_JPRB, 0.81086257E-07_JPRB, 0.76657579E-07_JPRB, 0.72068428E-07_JPRB, 0.68511581E-07_JPRB, &
  & 0.66378285E-07_JPRB, 0.65706359E-07_JPRB, 0.65586811E-07_JPRB, 0.65487204E-07_JPRB, 0.67027561E-07_JPRB, 0.72714096E-07_JPRB, &
  & 0.82987874E-07_JPRB, 0.99175822E-07_JPRB, 0.11829893E-06_JPRB, 0.13730439E-06_JPRB, 0.15694384E-06_JPRB, 0.17796410E-06_JPRB, &
  & 0.20458945E-06_JPRB, 0.24090737E-06_JPRB, 0.29130896E-06_JPRB, 0.35090081E-06_JPRB, 0.41694466E-06_JPRB, 0.48316893E-06_JPRB, &
  & 0.54324040E-06_JPRB, 0.59456664E-06_JPRB, 0.63659444E-06_JPRB, 0.67349080E-06_JPRB, 0.70984234E-06_JPRB, 0.74430374E-06_JPRB, &
  & 0.76991158E-06_JPRB, 0.79852956E-06_JPRB, 0.83530599E-06_JPRB, 0.87682708E-06_JPRB, 0.91588972E-06_JPRB, 0.94417750E-06_JPRB, &
  & 0.96643887E-06_JPRB, 0.98244751E-06_JPRB, 0.98308718E-06_JPRB, 0.98279374E-06_JPRB  /)

RGHG7(:,43, 6) = (/ &
  & 0.67561860E-06_JPRB, 0.67625592E-06_JPRB, 0.67667577E-06_JPRB, 0.66517777E-06_JPRB, 0.67209879E-06_JPRB, 0.68143882E-06_JPRB, &
  & 0.69656831E-06_JPRB, 0.70868083E-06_JPRB, 0.71149135E-06_JPRB, 0.70267969E-06_JPRB, 0.67630485E-06_JPRB, 0.63301219E-06_JPRB, &
  & 0.57914454E-06_JPRB, 0.51482577E-06_JPRB, 0.46100792E-06_JPRB, 0.41516938E-06_JPRB, 0.37251472E-06_JPRB, 0.33376000E-06_JPRB, &
  & 0.29173418E-06_JPRB, 0.23971874E-06_JPRB, 0.18811404E-06_JPRB, 0.14224760E-06_JPRB, 0.11160937E-06_JPRB, 0.94479265E-07_JPRB, &
  & 0.84495593E-07_JPRB, 0.77454485E-07_JPRB, 0.73246718E-07_JPRB, 0.68967587E-07_JPRB, 0.64158514E-07_JPRB, 0.60654449E-07_JPRB, &
  & 0.58661902E-07_JPRB, 0.58077945E-07_JPRB, 0.57562538E-07_JPRB, 0.56416103E-07_JPRB, 0.56557759E-07_JPRB, 0.60581686E-07_JPRB, &
  & 0.68550684E-07_JPRB, 0.81536572E-07_JPRB, 0.97809492E-07_JPRB, 0.11443101E-06_JPRB, 0.13232868E-06_JPRB, 0.15170392E-06_JPRB, &
  & 0.17558465E-06_JPRB, 0.20815510E-06_JPRB, 0.25261880E-06_JPRB, 0.30809372E-06_JPRB, 0.37221106E-06_JPRB, 0.43622731E-06_JPRB, &
  & 0.49698494E-06_JPRB, 0.54649902E-06_JPRB, 0.58367974E-06_JPRB, 0.61507806E-06_JPRB, 0.64387309E-06_JPRB, 0.67225586E-06_JPRB, &
  & 0.69009606E-06_JPRB, 0.71168535E-06_JPRB, 0.74062377E-06_JPRB, 0.77619818E-06_JPRB, 0.81019382E-06_JPRB, 0.83264927E-06_JPRB, &
  & 0.84821623E-06_JPRB, 0.85971208E-06_JPRB, 0.85615564E-06_JPRB, 0.86078845E-06_JPRB  /)

RGHG7(:,44, 6) = (/ &
  & 0.59970857E-06_JPRB, 0.60193645E-06_JPRB, 0.60164982E-06_JPRB, 0.59220000E-06_JPRB, 0.59777743E-06_JPRB, 0.60586908E-06_JPRB, &
  & 0.62124246E-06_JPRB, 0.63366833E-06_JPRB, 0.63894082E-06_JPRB, 0.63507879E-06_JPRB, 0.61665046E-06_JPRB, 0.58231392E-06_JPRB, &
  & 0.53696760E-06_JPRB, 0.47995817E-06_JPRB, 0.43009326E-06_JPRB, 0.38738826E-06_JPRB, 0.34892655E-06_JPRB, 0.31345916E-06_JPRB, &
  & 0.27480703E-06_JPRB, 0.22648177E-06_JPRB, 0.17753777E-06_JPRB, 0.13496025E-06_JPRB, 0.10647846E-06_JPRB, 0.90339284E-07_JPRB, &
  & 0.80713250E-07_JPRB, 0.74395489E-07_JPRB, 0.70256589E-07_JPRB, 0.65627444E-07_JPRB, 0.60933707E-07_JPRB, 0.57393474E-07_JPRB, &
  & 0.55392887E-07_JPRB, 0.54655193E-07_JPRB, 0.53933647E-07_JPRB, 0.52554797E-07_JPRB, 0.52715257E-07_JPRB, 0.56810006E-07_JPRB, &
  & 0.64534620E-07_JPRB, 0.76678540E-07_JPRB, 0.91577897E-07_JPRB, 0.10639523E-06_JPRB, 0.12236441E-06_JPRB, 0.14074007E-06_JPRB, &
  & 0.16348559E-06_JPRB, 0.19307706E-06_JPRB, 0.23301649E-06_JPRB, 0.28555343E-06_JPRB, 0.34994516E-06_JPRB, 0.41429735E-06_JPRB, &
  & 0.47642618E-06_JPRB, 0.52722496E-06_JPRB, 0.56463284E-06_JPRB, 0.59402692E-06_JPRB, 0.62040961E-06_JPRB, 0.64601145E-06_JPRB, &
  & 0.66244026E-06_JPRB, 0.68343032E-06_JPRB, 0.70985123E-06_JPRB, 0.74078869E-06_JPRB, 0.76920864E-06_JPRB, 0.78796166E-06_JPRB, &
  & 0.79963390E-06_JPRB, 0.80995582E-06_JPRB, 0.80743333E-06_JPRB, 0.80670766E-06_JPRB  /)

RGHG7(:,45, 6) = (/ &
  & 0.49237231E-06_JPRB, 0.49622200E-06_JPRB, 0.49527112E-06_JPRB, 0.48832303E-06_JPRB, 0.49293427E-06_JPRB, 0.50025815E-06_JPRB, &
  & 0.51669261E-06_JPRB, 0.53028308E-06_JPRB, 0.53980851E-06_JPRB, 0.54302034E-06_JPRB, 0.53508202E-06_JPRB, 0.51260714E-06_JPRB, &
  & 0.47833745E-06_JPRB, 0.43049815E-06_JPRB, 0.38567121E-06_JPRB, 0.34689134E-06_JPRB, 0.31372640E-06_JPRB, 0.28271036E-06_JPRB, &
  & 0.24882015E-06_JPRB, 0.20557599E-06_JPRB, 0.16079004E-06_JPRB, 0.12307795E-06_JPRB, 0.98193486E-07_JPRB, 0.83978051E-07_JPRB, &
  & 0.75102536E-07_JPRB, 0.69802721E-07_JPRB, 0.65862233E-07_JPRB, 0.60853516E-07_JPRB, 0.56263298E-07_JPRB, 0.52688559E-07_JPRB, &
  & 0.50696599E-07_JPRB, 0.49794998E-07_JPRB, 0.48788772E-07_JPRB, 0.47013096E-07_JPRB, 0.47018277E-07_JPRB, 0.50983625E-07_JPRB, &
  & 0.58138880E-07_JPRB, 0.68919788E-07_JPRB, 0.81895400E-07_JPRB, 0.94357653E-07_JPRB, 0.10791137E-06_JPRB, 0.12494127E-06_JPRB, &
  & 0.14604773E-06_JPRB, 0.17177446E-06_JPRB, 0.20581325E-06_JPRB, 0.25448545E-06_JPRB, 0.31894619E-06_JPRB, 0.38340190E-06_JPRB, &
  & 0.44717842E-06_JPRB, 0.49921081E-06_JPRB, 0.53626500E-06_JPRB, 0.56268289E-06_JPRB, 0.58536474E-06_JPRB, 0.60703282E-06_JPRB, &
  & 0.62087363E-06_JPRB, 0.64029365E-06_JPRB, 0.66285844E-06_JPRB, 0.68776587E-06_JPRB, 0.70919822E-06_JPRB, 0.72299954E-06_JPRB, &
  & 0.72939226E-06_JPRB, 0.73780770E-06_JPRB, 0.73593220E-06_JPRB, 0.72972861E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART12',0,ZHOOK_HANDLE)



RGHG7(:,46, 6) = (/ &
  & 0.42636845E-06_JPRB, 0.43004539E-06_JPRB, 0.42844361E-06_JPRB, 0.42301248E-06_JPRB, 0.42710507E-06_JPRB, 0.43283746E-06_JPRB, &
  & 0.44683901E-06_JPRB, 0.45975565E-06_JPRB, 0.46969348E-06_JPRB, 0.47587596E-06_JPRB, 0.47333301E-06_JPRB, 0.45846191E-06_JPRB, &
  & 0.43172559E-06_JPRB, 0.39145646E-06_JPRB, 0.35147541E-06_JPRB, 0.31703916E-06_JPRB, 0.28819751E-06_JPRB, 0.26087781E-06_JPRB, &
  & 0.23103141E-06_JPRB, 0.19211057E-06_JPRB, 0.15077672E-06_JPRB, 0.11595250E-06_JPRB, 0.92870667E-07_JPRB, 0.79565346E-07_JPRB, &
  & 0.71302947E-07_JPRB, 0.66541917E-07_JPRB, 0.62756281E-07_JPRB, 0.57811837E-07_JPRB, 0.53457072E-07_JPRB, 0.49858413E-07_JPRB, &
  & 0.47817344E-07_JPRB, 0.46847770E-07_JPRB, 0.45724481E-07_JPRB, 0.43859460E-07_JPRB, 0.44011988E-07_JPRB, 0.48021427E-07_JPRB, &
  & 0.54942555E-07_JPRB, 0.64920299E-07_JPRB, 0.76589152E-07_JPRB, 0.87316585E-07_JPRB, 0.99202232E-07_JPRB, 0.11475152E-06_JPRB, &
  & 0.13361686E-06_JPRB, 0.15585242E-06_JPRB, 0.18517767E-06_JPRB, 0.22949615E-06_JPRB, 0.29044753E-06_JPRB, 0.35300437E-06_JPRB, &
  & 0.41462870E-06_JPRB, 0.46553772E-06_JPRB, 0.50149520E-06_JPRB, 0.52669211E-06_JPRB, 0.54852581E-06_JPRB, 0.56897178E-06_JPRB, &
  & 0.58529357E-06_JPRB, 0.60717300E-06_JPRB, 0.63051653E-06_JPRB, 0.65436837E-06_JPRB, 0.67423405E-06_JPRB, 0.68636892E-06_JPRB, &
  & 0.69249546E-06_JPRB, 0.70099176E-06_JPRB, 0.70115605E-06_JPRB, 0.69482104E-06_JPRB  /)

RGHG7(:,47, 6) = (/ &
  & 0.35719766E-06_JPRB, 0.36031242E-06_JPRB, 0.35794953E-06_JPRB, 0.35410116E-06_JPRB, 0.35767482E-06_JPRB, 0.36137469E-06_JPRB, &
  & 0.37182150E-06_JPRB, 0.38357917E-06_JPRB, 0.39323158E-06_JPRB, 0.40207796E-06_JPRB, 0.40484549E-06_JPRB, 0.39804390E-06_JPRB, &
  & 0.37943765E-06_JPRB, 0.34773103E-06_JPRB, 0.31339777E-06_JPRB, 0.28414228E-06_JPRB, 0.26017866E-06_JPRB, 0.23704507E-06_JPRB, &
  & 0.21179994E-06_JPRB, 0.17780038E-06_JPRB, 0.14037587E-06_JPRB, 0.10854421E-06_JPRB, 0.87218124E-07_JPRB, 0.74777703E-07_JPRB, &
  & 0.67207224E-07_JPRB, 0.62982432E-07_JPRB, 0.59369775E-07_JPRB, 0.54589663E-07_JPRB, 0.50537613E-07_JPRB, 0.46913007E-07_JPRB, &
  & 0.44802745E-07_JPRB, 0.43772629E-07_JPRB, 0.42545552E-07_JPRB, 0.40637286E-07_JPRB, 0.41023337E-07_JPRB, 0.45119266E-07_JPRB, &
  & 0.51832818E-07_JPRB, 0.60980257E-07_JPRB, 0.71239324E-07_JPRB, 0.80055329E-07_JPRB, 0.90133335E-07_JPRB, 0.10391822E-06_JPRB, &
  & 0.12003318E-06_JPRB, 0.13824696E-06_JPRB, 0.16227903E-06_JPRB, 0.20139081E-06_JPRB, 0.25750740E-06_JPRB, 0.31743494E-06_JPRB, &
  & 0.37577265E-06_JPRB, 0.42489133E-06_JPRB, 0.45941308E-06_JPRB, 0.48352886E-06_JPRB, 0.50493876E-06_JPRB, 0.52449388E-06_JPRB, &
  & 0.54474232E-06_JPRB, 0.57031487E-06_JPRB, 0.59550064E-06_JPRB, 0.61911031E-06_JPRB, 0.63822352E-06_JPRB, 0.64906105E-06_JPRB, &
  & 0.65587950E-06_JPRB, 0.66486879E-06_JPRB, 0.66770562E-06_JPRB, 0.66228741E-06_JPRB  /)

RGHG7(:,48, 6) = (/ &
  & 0.30483968E-06_JPRB, 0.30696114E-06_JPRB, 0.30415509E-06_JPRB, 0.30086401E-06_JPRB, 0.30367289E-06_JPRB, 0.30614472E-06_JPRB, &
  & 0.31348272E-06_JPRB, 0.32385746E-06_JPRB, 0.33235845E-06_JPRB, 0.34184380E-06_JPRB, 0.34657750E-06_JPRB, 0.34398853E-06_JPRB, &
  & 0.33087975E-06_JPRB, 0.30606939E-06_JPRB, 0.27644293E-06_JPRB, 0.25157077E-06_JPRB, 0.23164666E-06_JPRB, 0.21287967E-06_JPRB, &
  & 0.19236066E-06_JPRB, 0.16342470E-06_JPRB, 0.13047377E-06_JPRB, 0.10171799E-06_JPRB, 0.82187219E-07_JPRB, 0.70731599E-07_JPRB, &
  & 0.63828488E-07_JPRB, 0.60060954E-07_JPRB, 0.56663443E-07_JPRB, 0.52238024E-07_JPRB, 0.48433197E-07_JPRB, 0.44886279E-07_JPRB, &
  & 0.42789974E-07_JPRB, 0.41702458E-07_JPRB, 0.40405394E-07_JPRB, 0.38603877E-07_JPRB, 0.39199963E-07_JPRB, 0.43298335E-07_JPRB, &
  & 0.49786674E-07_JPRB, 0.58249198E-07_JPRB, 0.67404648E-07_JPRB, 0.74885789E-07_JPRB, 0.83670505E-07_JPRB, 0.95856462E-07_JPRB, &
  & 0.10968204E-06_JPRB, 0.12471357E-06_JPRB, 0.14467623E-06_JPRB, 0.17847085E-06_JPRB, 0.22815675E-06_JPRB, 0.28186933E-06_JPRB, &
  & 0.33351663E-06_JPRB, 0.37751124E-06_JPRB, 0.40905790E-06_JPRB, 0.43087576E-06_JPRB, 0.45112238E-06_JPRB, 0.47114560E-06_JPRB, &
  & 0.49468497E-06_JPRB, 0.52380440E-06_JPRB, 0.55314623E-06_JPRB, 0.57978247E-06_JPRB, 0.60200104E-06_JPRB, 0.61500111E-06_JPRB, &
  & 0.62489070E-06_JPRB, 0.63531345E-06_JPRB, 0.64132056E-06_JPRB, 0.64043118E-06_JPRB  /)

RGHG7(:,49, 6) = (/ &
  & 0.25450236E-06_JPRB, 0.25532783E-06_JPRB, 0.25217560E-06_JPRB, 0.24903542E-06_JPRB, 0.25088563E-06_JPRB, 0.25236329E-06_JPRB, &
  & 0.25646133E-06_JPRB, 0.26520277E-06_JPRB, 0.27203497E-06_JPRB, 0.28130727E-06_JPRB, 0.28669784E-06_JPRB, 0.28702040E-06_JPRB, &
  & 0.27880262E-06_JPRB, 0.26087163E-06_JPRB, 0.23602965E-06_JPRB, 0.21564905E-06_JPRB, 0.19981704E-06_JPRB, 0.18596769E-06_JPRB, &
  & 0.17073913E-06_JPRB, 0.14747531E-06_JPRB, 0.11973495E-06_JPRB, 0.94423288E-07_JPRB, 0.76898623E-07_JPRB, 0.66588084E-07_JPRB, &
  & 0.60412854E-07_JPRB, 0.57115779E-07_JPRB, 0.53975689E-07_JPRB, 0.50029607E-07_JPRB, 0.46473324E-07_JPRB, 0.43059555E-07_JPRB, &
  & 0.41016510E-07_JPRB, 0.39866858E-07_JPRB, 0.38507657E-07_JPRB, 0.36892549E-07_JPRB, 0.37710550E-07_JPRB, 0.41773416E-07_JPRB, &
  & 0.48004333E-07_JPRB, 0.55774482E-07_JPRB, 0.63846988E-07_JPRB, 0.70112036E-07_JPRB, 0.77698412E-07_JPRB, 0.88188939E-07_JPRB, &
  & 0.99688846E-07_JPRB, 0.11157807E-06_JPRB, 0.12759063E-06_JPRB, 0.15544681E-06_JPRB, 0.19728580E-06_JPRB, 0.24248573E-06_JPRB, &
  & 0.28517654E-06_JPRB, 0.32198111E-06_JPRB, 0.34953331E-06_JPRB, 0.36825324E-06_JPRB, 0.38687544E-06_JPRB, 0.40803486E-06_JPRB, &
  & 0.43492958E-06_JPRB, 0.46791033E-06_JPRB, 0.50290655E-06_JPRB, 0.53438053E-06_JPRB, 0.56179191E-06_JPRB, 0.57875983E-06_JPRB, &
  & 0.59313210E-06_JPRB, 0.60556984E-06_JPRB, 0.61531399E-06_JPRB, 0.62108206E-06_JPRB  /)

RGHG7(:,50, 6) = (/ &
  & 0.21292690E-06_JPRB, 0.21341218E-06_JPRB, 0.20975155E-06_JPRB, 0.20657996E-06_JPRB, 0.20762050E-06_JPRB, 0.20818457E-06_JPRB, &
  & 0.21034035E-06_JPRB, 0.21737363E-06_JPRB, 0.22268798E-06_JPRB, 0.23101372E-06_JPRB, 0.23609413E-06_JPRB, 0.23741215E-06_JPRB, &
  & 0.23245542E-06_JPRB, 0.21941938E-06_JPRB, 0.19901800E-06_JPRB, 0.18215722E-06_JPRB, 0.16980094E-06_JPRB, 0.15992229E-06_JPRB, &
  & 0.14924211E-06_JPRB, 0.13147360E-06_JPRB, 0.10913526E-06_JPRB, 0.87586428E-07_JPRB, 0.72263949E-07_JPRB, 0.63054800E-07_JPRB, &
  & 0.57596448E-07_JPRB, 0.54675342E-07_JPRB, 0.51804049E-07_JPRB, 0.48329143E-07_JPRB, 0.45018563E-07_JPRB, 0.41792565E-07_JPRB, &
  & 0.39798668E-07_JPRB, 0.38588311E-07_JPRB, 0.37174175E-07_JPRB, 0.35718104E-07_JPRB, 0.36758677E-07_JPRB, 0.40792623E-07_JPRB, &
  & 0.46812433E-07_JPRB, 0.54001350E-07_JPRB, 0.61180282E-07_JPRB, 0.66632243E-07_JPRB, 0.73382494E-07_JPRB, 0.82453187E-07_JPRB, &
  & 0.92125229E-07_JPRB, 0.10178970E-06_JPRB, 0.11486336E-06_JPRB, 0.13797078E-06_JPRB, 0.17264845E-06_JPRB, 0.20885400E-06_JPRB, &
  & 0.24230721E-06_JPRB, 0.27174703E-06_JPRB, 0.29434107E-06_JPRB, 0.30965369E-06_JPRB, 0.32594757E-06_JPRB, 0.34686996E-06_JPRB, &
  & 0.37373417E-06_JPRB, 0.40613165E-06_JPRB, 0.44323382E-06_JPRB, 0.47845911E-06_JPRB, 0.51102154E-06_JPRB, 0.53264180E-06_JPRB, &
  & 0.55086271E-06_JPRB, 0.56593533E-06_JPRB, 0.57879679E-06_JPRB, 0.58765941E-06_JPRB  /)

RGHG7(:,51, 6) = (/ &
  & 0.17256289E-06_JPRB, 0.17318263E-06_JPRB, 0.16888683E-06_JPRB, 0.16558542E-06_JPRB, 0.16582852E-06_JPRB, 0.16544679E-06_JPRB, &
  & 0.16618387E-06_JPRB, 0.17133019E-06_JPRB, 0.17508211E-06_JPRB, 0.18199842E-06_JPRB, 0.18623503E-06_JPRB, 0.18762259E-06_JPRB, &
  & 0.18533636E-06_JPRB, 0.17655178E-06_JPRB, 0.16077277E-06_JPRB, 0.14720839E-06_JPRB, 0.13828759E-06_JPRB, 0.13220605E-06_JPRB, &
  & 0.12605551E-06_JPRB, 0.11413797E-06_JPRB, 0.97743345E-07_JPRB, 0.80432068E-07_JPRB, 0.67594633E-07_JPRB, 0.59553826E-07_JPRB, &
  & 0.54865096E-07_JPRB, 0.52300984E-07_JPRB, 0.49726412E-07_JPRB, 0.46756860E-07_JPRB, 0.43710548E-07_JPRB, 0.40716364E-07_JPRB, &
  & 0.38773466E-07_JPRB, 0.37498201E-07_JPRB, 0.36028430E-07_JPRB, 0.34729992E-07_JPRB, 0.36011651E-07_JPRB, 0.40017779E-07_JPRB, &
  & 0.45833594E-07_JPRB, 0.52452249E-07_JPRB, 0.58764196E-07_JPRB, 0.63548534E-07_JPRB, 0.69584799E-07_JPRB, 0.77264608E-07_JPRB, &
  & 0.85221228E-07_JPRB, 0.92961648E-07_JPRB, 0.10338799E-06_JPRB, 0.12198431E-06_JPRB, 0.14927639E-06_JPRB, 0.17550004E-06_JPRB, &
  & 0.19881372E-06_JPRB, 0.22019569E-06_JPRB, 0.23692020E-06_JPRB, 0.24838471E-06_JPRB, 0.26179020E-06_JPRB, 0.28173432E-06_JPRB, &
  & 0.30678576E-06_JPRB, 0.33621602E-06_JPRB, 0.37373082E-06_JPRB, 0.41244259E-06_JPRB, 0.45055463E-06_JPRB, 0.47756688E-06_JPRB, &
  & 0.49961736E-06_JPRB, 0.51786583E-06_JPRB, 0.53377332E-06_JPRB, 0.54411028E-06_JPRB  /)

RGHG7(:,52, 6) = (/ &
  & 0.14092688E-06_JPRB, 0.14152196E-06_JPRB, 0.13714665E-06_JPRB, 0.13375824E-06_JPRB, 0.13378321E-06_JPRB, 0.13297862E-06_JPRB, &
  & 0.13289718E-06_JPRB, 0.13645539E-06_JPRB, 0.13909566E-06_JPRB, 0.14460165E-06_JPRB, 0.14822958E-06_JPRB, 0.14952907E-06_JPRB, &
  & 0.14872675E-06_JPRB, 0.14262559E-06_JPRB, 0.13055632E-06_JPRB, 0.11989076E-06_JPRB, 0.11343371E-06_JPRB, 0.10974766E-06_JPRB, &
  & 0.10661873E-06_JPRB, 0.99173191E-07_JPRB, 0.87802593E-07_JPRB, 0.74349571E-07_JPRB, 0.63724443E-07_JPRB, 0.56775402E-07_JPRB, &
  & 0.52742383E-07_JPRB, 0.50473967E-07_JPRB, 0.48166078E-07_JPRB, 0.45597347E-07_JPRB, 0.42792646E-07_JPRB, 0.40097995E-07_JPRB, &
  & 0.38145174E-07_JPRB, 0.36779931E-07_JPRB, 0.35292316E-07_JPRB, 0.34038350E-07_JPRB, 0.35495815E-07_JPRB, 0.39517919E-07_JPRB, &
  & 0.45227364E-07_JPRB, 0.51424934E-07_JPRB, 0.57022556E-07_JPRB, 0.61343793E-07_JPRB, 0.66904854E-07_JPRB, 0.73557627E-07_JPRB, &
  & 0.80246461E-07_JPRB, 0.86634753E-07_JPRB, 0.95208106E-07_JPRB, 0.11036607E-06_JPRB, 0.13188922E-06_JPRB, 0.15060717E-06_JPRB, &
  & 0.16691842E-06_JPRB, 0.18215678E-06_JPRB, 0.19403597E-06_JPRB, 0.20322778E-06_JPRB, 0.21429906E-06_JPRB, 0.23132876E-06_JPRB, &
  & 0.25240471E-06_JPRB, 0.27634976E-06_JPRB, 0.30971649E-06_JPRB, 0.34622461E-06_JPRB, 0.38413890E-06_JPRB, 0.41244592E-06_JPRB, &
  & 0.43499157E-06_JPRB, 0.45391975E-06_JPRB, 0.47206981E-06_JPRB, 0.48180904E-06_JPRB  /)

RGHG7(:,53, 6) = (/ &
  & 0.10983369E-06_JPRB, 0.11034071E-06_JPRB, 0.10609260E-06_JPRB, 0.10262591E-06_JPRB, 0.10263620E-06_JPRB, 0.10157233E-06_JPRB, &
  & 0.10083044E-06_JPRB, 0.10277422E-06_JPRB, 0.10437734E-06_JPRB, 0.10834717E-06_JPRB, 0.11140271E-06_JPRB, 0.11254565E-06_JPRB, &
  & 0.11290279E-06_JPRB, 0.10912054E-06_JPRB, 0.10074000E-06_JPRB, 0.93078265E-07_JPRB, 0.88930342E-07_JPRB, 0.87313703E-07_JPRB, &
  & 0.86895055E-07_JPRB, 0.83788917E-07_JPRB, 0.77535580E-07_JPRB, 0.68138208E-07_JPRB, 0.59817314E-07_JPRB, 0.54027729E-07_JPRB, &
  & 0.50664945E-07_JPRB, 0.48694954E-07_JPRB, 0.46665922E-07_JPRB, 0.44493460E-07_JPRB, 0.41943155E-07_JPRB, 0.39600743E-07_JPRB, &
  & 0.37613676E-07_JPRB, 0.36140805E-07_JPRB, 0.34648298E-07_JPRB, 0.33399224E-07_JPRB, 0.35023025E-07_JPRB, 0.39079374E-07_JPRB, &
  & 0.44710543E-07_JPRB, 0.50506951E-07_JPRB, 0.55385417E-07_JPRB, 0.59281032E-07_JPRB, 0.64416469E-07_JPRB, 0.70090798E-07_JPRB, &
  & 0.75571254E-07_JPRB, 0.80707138E-07_JPRB, 0.87568215E-07_JPRB, 0.99394574E-07_JPRB, 0.11525743E-06_JPRB, 0.12675447E-06_JPRB, &
  & 0.13664712E-06_JPRB, 0.14593165E-06_JPRB, 0.15292841E-06_JPRB, 0.16025139E-06_JPRB, 0.16899397E-06_JPRB, 0.18210501E-06_JPRB, &
  & 0.19801967E-06_JPRB, 0.21502266E-06_JPRB, 0.24211756E-06_JPRB, 0.27403678E-06_JPRB, 0.30952453E-06_JPRB, 0.33766522E-06_JPRB, &
  & 0.35946725E-06_JPRB, 0.37817528E-06_JPRB, 0.39845834E-06_JPRB, 0.40674948E-06_JPRB  /)

RGHG7(:,54, 6) = (/ &
  & 0.89063410E-07_JPRB, 0.89223914E-07_JPRB, 0.85378833E-07_JPRB, 0.82238913E-07_JPRB, 0.82429842E-07_JPRB, 0.81491328E-07_JPRB, &
  & 0.80432211E-07_JPRB, 0.81607779E-07_JPRB, 0.82681959E-07_JPRB, 0.85841622E-07_JPRB, 0.88373581E-07_JPRB, 0.89403565E-07_JPRB, &
  & 0.90170688E-07_JPRB, 0.87662840E-07_JPRB, 0.81650794E-07_JPRB, 0.76173858E-07_JPRB, 0.73510820E-07_JPRB, 0.72878230E-07_JPRB, &
  & 0.73564014E-07_JPRB, 0.72711138E-07_JPRB, 0.69589438E-07_JPRB, 0.63173322E-07_JPRB, 0.56839410E-07_JPRB, 0.52088074E-07_JPRB, &
  & 0.49236219E-07_JPRB, 0.47467537E-07_JPRB, 0.45685904E-07_JPRB, 0.43792152E-07_JPRB, 0.41480367E-07_JPRB, 0.39324034E-07_JPRB, &
  & 0.37352180E-07_JPRB, 0.35769455E-07_JPRB, 0.34215696E-07_JPRB, 0.32918974E-07_JPRB, 0.34606504E-07_JPRB, 0.38695807E-07_JPRB, &
  & 0.44308197E-07_JPRB, 0.49888203E-07_JPRB, 0.54273583E-07_JPRB, 0.57887371E-07_JPRB, 0.62841506E-07_JPRB, 0.67882139E-07_JPRB, &
  & 0.72564179E-07_JPRB, 0.76899068E-07_JPRB, 0.82648558E-07_JPRB, 0.92401924E-07_JPRB, 0.10466084E-06_JPRB, 0.11234013E-06_JPRB, &
  & 0.11890229E-06_JPRB, 0.12506272E-06_JPRB, 0.12952030E-06_JPRB, 0.13538419E-06_JPRB, 0.14213929E-06_JPRB, 0.15182288E-06_JPRB, &
  & 0.16343474E-06_JPRB, 0.17501189E-06_JPRB, 0.19561073E-06_JPRB, 0.22020311E-06_JPRB, 0.24866264E-06_JPRB, 0.27233543E-06_JPRB, &
  & 0.28928578E-06_JPRB, 0.30286679E-06_JPRB, 0.32255114E-06_JPRB, 0.32728544E-06_JPRB  /)

RGHG7(:,55, 6) = (/ &
  & 0.67412933E-07_JPRB, 0.67155581E-07_JPRB, 0.63793241E-07_JPRB, 0.61068582E-07_JPRB, 0.61485310E-07_JPRB, 0.60736258E-07_JPRB, &
  & 0.59370886E-07_JPRB, 0.59806770E-07_JPRB, 0.60361874E-07_JPRB, 0.62719565E-07_JPRB, 0.64677944E-07_JPRB, 0.65588541E-07_JPRB, &
  & 0.66711231E-07_JPRB, 0.65477715E-07_JPRB, 0.61915708E-07_JPRB, 0.58751257E-07_JPRB, 0.57624684E-07_JPRB, 0.57939409E-07_JPRB, &
  & 0.59637391E-07_JPRB, 0.61006161E-07_JPRB, 0.61092351E-07_JPRB, 0.57837409E-07_JPRB, 0.53662854E-07_JPRB, 0.50045699E-07_JPRB, &
  & 0.47738875E-07_JPRB, 0.46180418E-07_JPRB, 0.44668705E-07_JPRB, 0.43068230E-07_JPRB, 0.41018579E-07_JPRB, 0.39046518E-07_JPRB, &
  & 0.37098023E-07_JPRB, 0.35393315E-07_JPRB, 0.33764290E-07_JPRB, 0.32407875E-07_JPRB, 0.34152502E-07_JPRB, 0.38278141E-07_JPRB, &
  & 0.43877553E-07_JPRB, 0.49242143E-07_JPRB, 0.53111042E-07_JPRB, 0.56431553E-07_JPRB, 0.61216988E-07_JPRB, 0.65600989E-07_JPRB, &
  & 0.69452508E-07_JPRB, 0.72959470E-07_JPRB, 0.77556611E-07_JPRB, 0.85179169E-07_JPRB, 0.93716313E-07_JPRB, 0.97614130E-07_JPRB, &
  & 0.10089313E-06_JPRB, 0.10396506E-06_JPRB, 0.10591810E-06_JPRB, 0.11021957E-06_JPRB, 0.11481791E-06_JPRB, 0.12076934E-06_JPRB, &
  & 0.12772768E-06_JPRB, 0.13349377E-06_JPRB, 0.14686708E-06_JPRB, 0.16298294E-06_JPRB, 0.18305161E-06_JPRB, 0.20120921E-06_JPRB, &
  & 0.21224468E-06_JPRB, 0.21950076E-06_JPRB, 0.23816252E-06_JPRB, 0.23867933E-06_JPRB  /)

RGHG7(:,56, 6) = (/ &
  & 0.56097346E-07_JPRB, 0.55757784E-07_JPRB, 0.52983519E-07_JPRB, 0.50722365E-07_JPRB, 0.51250822E-07_JPRB, 0.50756571E-07_JPRB, &
  & 0.49454373E-07_JPRB, 0.49820521E-07_JPRB, 0.50239557E-07_JPRB, 0.52316403E-07_JPRB, 0.53857365E-07_JPRB, 0.54612469E-07_JPRB, &
  & 0.55766960E-07_JPRB, 0.55223563E-07_JPRB, 0.52742403E-07_JPRB, 0.50666275E-07_JPRB, 0.50269131E-07_JPRB, 0.50895042E-07_JPRB, &
  & 0.52660598E-07_JPRB, 0.54362933E-07_JPRB, 0.55712421E-07_JPRB, 0.54132518E-07_JPRB, 0.51510103E-07_JPRB, 0.48676759E-07_JPRB, &
  & 0.46807540E-07_JPRB, 0.45361372E-07_JPRB, 0.44014064E-07_JPRB, 0.42710844E-07_JPRB, 0.40818258E-07_JPRB, 0.38956184E-07_JPRB, &
  & 0.37007543E-07_JPRB, 0.35269578E-07_JPRB, 0.33572370E-07_JPRB, 0.32141672E-07_JPRB, 0.33782196E-07_JPRB, 0.37989190E-07_JPRB, &
  & 0.43533423E-07_JPRB, 0.48772519E-07_JPRB, 0.52388656E-07_JPRB, 0.55630799E-07_JPRB, 0.60150528E-07_JPRB, 0.64254934E-07_JPRB, &
  & 0.67687867E-07_JPRB, 0.70753753E-07_JPRB, 0.74727281E-07_JPRB, 0.81420315E-07_JPRB, 0.88133526E-07_JPRB, 0.91021138E-07_JPRB, &
  & 0.93150141E-07_JPRB, 0.95220937E-07_JPRB, 0.96411636E-07_JPRB, 0.99308095E-07_JPRB, 0.10244679E-06_JPRB, 0.10652571E-06_JPRB, &
  & 0.11125002E-06_JPRB, 0.11464121E-06_JPRB, 0.12397508E-06_JPRB, 0.13453003E-06_JPRB, 0.14864474E-06_JPRB, 0.16154638E-06_JPRB, &
  & 0.16828873E-06_JPRB, 0.17112971E-06_JPRB, 0.18648901E-06_JPRB, 0.18553609E-06_JPRB  /)

RGHG7(:,57, 6) = (/ &
  & 0.45004528E-07_JPRB, 0.44616533E-07_JPRB, 0.42398262E-07_JPRB, 0.40597185E-07_JPRB, 0.41218576E-07_JPRB, 0.40958967E-07_JPRB, &
  & 0.39769749E-07_JPRB, 0.40014455E-07_JPRB, 0.40280942E-07_JPRB, 0.42038835E-07_JPRB, 0.43234531E-07_JPRB, 0.43859277E-07_JPRB, &
  & 0.45040329E-07_JPRB, 0.45181980E-07_JPRB, 0.43775826E-07_JPRB, 0.42748726E-07_JPRB, 0.43011485E-07_JPRB, 0.43957409E-07_JPRB, &
  & 0.45822729E-07_JPRB, 0.47912620E-07_JPRB, 0.50381193E-07_JPRB, 0.50430798E-07_JPRB, 0.49286888E-07_JPRB, 0.47289857E-07_JPRB, &
  & 0.45862998E-07_JPRB, 0.44550792E-07_JPRB, 0.43334300E-07_JPRB, 0.42260440E-07_JPRB, 0.40545522E-07_JPRB, 0.38814737E-07_JPRB, &
  & 0.36875436E-07_JPRB, 0.35123761E-07_JPRB, 0.33351431E-07_JPRB, 0.31861549E-07_JPRB, 0.33406492E-07_JPRB, 0.37680484E-07_JPRB, &
  & 0.43189182E-07_JPRB, 0.48297702E-07_JPRB, 0.51668745E-07_JPRB, 0.54822497E-07_JPRB, 0.59026635E-07_JPRB, 0.62827124E-07_JPRB, &
  & 0.65861571E-07_JPRB, 0.68483940E-07_JPRB, 0.71895634E-07_JPRB, 0.77585495E-07_JPRB, 0.82537008E-07_JPRB, 0.84366624E-07_JPRB, &
  & 0.85356570E-07_JPRB, 0.86410968E-07_JPRB, 0.86790510E-07_JPRB, 0.88380978E-07_JPRB, 0.90153978E-07_JPRB, 0.92453075E-07_JPRB, &
  & 0.95037271E-07_JPRB, 0.96138274E-07_JPRB, 0.10172663E-06_JPRB, 0.10734421E-06_JPRB, 0.11606908E-06_JPRB, 0.12414955E-06_JPRB, &
  & 0.12725670E-06_JPRB, 0.12673200E-06_JPRB, 0.13892196E-06_JPRB, 0.13655143E-06_JPRB  /)

RGHG7(:,58, 6) = (/ &
  & 0.37117782E-07_JPRB, 0.36805218E-07_JPRB, 0.35063781E-07_JPRB, 0.33689025E-07_JPRB, 0.34342743E-07_JPRB, 0.34277100E-07_JPRB, &
  & 0.33345157E-07_JPRB, 0.33516453E-07_JPRB, 0.33686630E-07_JPRB, 0.35184554E-07_JPRB, 0.36213897E-07_JPRB, 0.36754457E-07_JPRB, &
  & 0.37890384E-07_JPRB, 0.38543891E-07_JPRB, 0.37859722E-07_JPRB, 0.37501400E-07_JPRB, 0.38102253E-07_JPRB, 0.39238102E-07_JPRB, &
  & 0.41072442E-07_JPRB, 0.43255948E-07_JPRB, 0.46145454E-07_JPRB, 0.47337977E-07_JPRB, 0.47315434E-07_JPRB, 0.46110430E-07_JPRB, &
  & 0.45078239E-07_JPRB, 0.43907467E-07_JPRB, 0.42734751E-07_JPRB, 0.41757874E-07_JPRB, 0.40221432E-07_JPRB, 0.38633428E-07_JPRB, &
  & 0.36714332E-07_JPRB, 0.34999699E-07_JPRB, 0.33147897E-07_JPRB, 0.31626361E-07_JPRB, 0.33067586E-07_JPRB, 0.37387375E-07_JPRB, &
  & 0.42888665E-07_JPRB, 0.47885384E-07_JPRB, 0.51093443E-07_JPRB, 0.54189274E-07_JPRB, 0.58000766E-07_JPRB, 0.61551388E-07_JPRB, &
  & 0.64330582E-07_JPRB, 0.66613510E-07_JPRB, 0.69712029E-07_JPRB, 0.74580229E-07_JPRB, 0.78372659E-07_JPRB, 0.79668195E-07_JPRB, &
  & 0.80029099E-07_JPRB, 0.80514395E-07_JPRB, 0.80392184E-07_JPRB, 0.80978473E-07_JPRB, 0.81785011E-07_JPRB, 0.82952639E-07_JPRB, &
  & 0.84181093E-07_JPRB, 0.83963396E-07_JPRB, 0.87201263E-07_JPRB, 0.89878364E-07_JPRB, 0.95056619E-07_JPRB, 0.99486763E-07_JPRB, &
  & 0.10066637E-06_JPRB, 0.99177226E-07_JPRB, 0.10825027E-06_JPRB, 0.10517930E-06_JPRB  /)

RGHG7(:,59, 6) = (/ &
  & 0.31698008E-07_JPRB, 0.31455089E-07_JPRB, 0.30033236E-07_JPRB, 0.29015229E-07_JPRB, 0.29703277E-07_JPRB, 0.29794988E-07_JPRB, &
  & 0.29103377E-07_JPRB, 0.29210211E-07_JPRB, 0.29313111E-07_JPRB, 0.30607706E-07_JPRB, 0.31562050E-07_JPRB, 0.32109830E-07_JPRB, &
  & 0.33175981E-07_JPRB, 0.34140124E-07_JPRB, 0.33987379E-07_JPRB, 0.34032848E-07_JPRB, 0.34808505E-07_JPRB, 0.36046378E-07_JPRB, &
  & 0.37837821E-07_JPRB, 0.40003794E-07_JPRB, 0.42938750E-07_JPRB, 0.44803821E-07_JPRB, 0.45507790E-07_JPRB, 0.45019686E-07_JPRB, &
  & 0.44350330E-07_JPRB, 0.43363664E-07_JPRB, 0.42222242E-07_JPRB, 0.41225494E-07_JPRB, 0.39806137E-07_JPRB, 0.38303227E-07_JPRB, &
  & 0.36433360E-07_JPRB, 0.34764108E-07_JPRB, 0.32820790E-07_JPRB, 0.31333572E-07_JPRB, 0.32682759E-07_JPRB, 0.37018115E-07_JPRB, &
  & 0.42560517E-07_JPRB, 0.47518699E-07_JPRB, 0.50629553E-07_JPRB, 0.53709558E-07_JPRB, 0.57132553E-07_JPRB, 0.60369840E-07_JPRB, &
  & 0.62993352E-07_JPRB, 0.65079722E-07_JPRB, 0.67998891E-07_JPRB, 0.72117547E-07_JPRB, 0.75218436E-07_JPRB, 0.76113371E-07_JPRB, &
  & 0.76108138E-07_JPRB, 0.76218510E-07_JPRB, 0.75743097E-07_JPRB, 0.75773911E-07_JPRB, 0.75993140E-07_JPRB, 0.76473684E-07_JPRB, &
  & 0.76862013E-07_JPRB, 0.76009550E-07_JPRB, 0.77839938E-07_JPRB, 0.78874502E-07_JPRB, 0.81940247E-07_JPRB, 0.84192508E-07_JPRB, &
  & 0.84554800E-07_JPRB, 0.82997447E-07_JPRB, 0.89691301E-07_JPRB, 0.86499188E-07_JPRB  /)

RGHG7(:,60, 6) = (/ &
  & 0.27222356E-07_JPRB, 0.27036468E-07_JPRB, 0.25875523E-07_JPRB, 0.25189360E-07_JPRB, 0.25911890E-07_JPRB, 0.26145610E-07_JPRB, &
  & 0.25681930E-07_JPRB, 0.25731811E-07_JPRB, 0.25778970E-07_JPRB, 0.26893983E-07_JPRB, 0.27805660E-07_JPRB, 0.28398718E-07_JPRB, &
  & 0.29396912E-07_JPRB, 0.30575187E-07_JPRB, 0.30882085E-07_JPRB, 0.31237651E-07_JPRB, 0.32122744E-07_JPRB, 0.33422891E-07_JPRB, &
  & 0.35162626E-07_JPRB, 0.37261968E-07_JPRB, 0.40111260E-07_JPRB, 0.42445321E-07_JPRB, 0.43724476E-07_JPRB, 0.43919985E-07_JPRB, &
  & 0.43607187E-07_JPRB, 0.42827704E-07_JPRB, 0.41731999E-07_JPRB, 0.40680771E-07_JPRB, 0.39363917E-07_JPRB, 0.37897313E-07_JPRB, &
  & 0.36069552E-07_JPRB, 0.34397118E-07_JPRB, 0.32387216E-07_JPRB, 0.30962678E-07_JPRB, 0.32232292E-07_JPRB, 0.36565947E-07_JPRB, &
  & 0.42152454E-07_JPRB, 0.47111195E-07_JPRB, 0.50161479E-07_JPRB, 0.53231354E-07_JPRB, 0.56269361E-07_JPRB, 0.59158131E-07_JPRB, &
  & 0.61666746E-07_JPRB, 0.63630298E-07_JPRB, 0.66423767E-07_JPRB, 0.69793598E-07_JPRB, 0.72393000E-07_JPRB, 0.72908474E-07_JPRB, &
  & 0.72642820E-07_JPRB, 0.72434403E-07_JPRB, 0.71680102E-07_JPRB, 0.71344141E-07_JPRB, 0.71127195E-07_JPRB, 0.71093307E-07_JPRB, &
  & 0.70862456E-07_JPRB, 0.69637656E-07_JPRB, 0.70420048E-07_JPRB, 0.70338852E-07_JPRB, 0.71842588E-07_JPRB, 0.72518427E-07_JPRB, &
  & 0.72451757E-07_JPRB, 0.71131064E-07_JPRB, 0.75786016E-07_JPRB, 0.72710240E-07_JPRB  /)

RGHG7(:,61, 6) = (/ &
  & 0.24190976E-07_JPRB, 0.24008740E-07_JPRB, 0.23026704E-07_JPRB, 0.22605620E-07_JPRB, 0.23355168E-07_JPRB, 0.23691853E-07_JPRB, &
  & 0.23390287E-07_JPRB, 0.23411688E-07_JPRB, 0.23422335E-07_JPRB, 0.24411746E-07_JPRB, 0.25303707E-07_JPRB, 0.25974171E-07_JPRB, &
  & 0.26954109E-07_JPRB, 0.28173277E-07_JPRB, 0.28814626E-07_JPRB, 0.29384153E-07_JPRB, 0.30301377E-07_JPRB, 0.31602984E-07_JPRB, &
  & 0.33278458E-07_JPRB, 0.35262422E-07_JPRB, 0.37981000E-07_JPRB, 0.40474254E-07_JPRB, 0.42119261E-07_JPRB, 0.42847847E-07_JPRB, &
  & 0.42849054E-07_JPRB, 0.42283532E-07_JPRB, 0.41301015E-07_JPRB, 0.40211084E-07_JPRB, 0.38998655E-07_JPRB, 0.37436389E-07_JPRB, &
  & 0.35577957E-07_JPRB, 0.33693753E-07_JPRB, 0.31745191E-07_JPRB, 0.30405362E-07_JPRB, 0.31644306E-07_JPRB, 0.35944369E-07_JPRB, &
  & 0.41518462E-07_JPRB, 0.46544385E-07_JPRB, 0.49610004E-07_JPRB, 0.52641176E-07_JPRB, 0.55365179E-07_JPRB, 0.57898321E-07_JPRB, &
  & 0.60350707E-07_JPRB, 0.62331055E-07_JPRB, 0.65068295E-07_JPRB, 0.67721027E-07_JPRB, 0.70082371E-07_JPRB, 0.70196210E-07_JPRB, &
  & 0.69810067E-07_JPRB, 0.69316855E-07_JPRB, 0.68443524E-07_JPRB, 0.68000947E-07_JPRB, 0.67553975E-07_JPRB, 0.67229451E-07_JPRB, &
  & 0.66726949E-07_JPRB, 0.65393343E-07_JPRB, 0.65567443E-07_JPRB, 0.65053943E-07_JPRB, 0.65674815E-07_JPRB, 0.65615300E-07_JPRB, &
  & 0.65365339E-07_JPRB, 0.64350618E-07_JPRB, 0.67748091E-07_JPRB, 0.65004576E-07_JPRB  /)

RGHG7(:,62, 6) = (/ &
  & 0.21821866E-07_JPRB, 0.21603393E-07_JPRB, 0.20787592E-07_JPRB, 0.20589224E-07_JPRB, 0.21330974E-07_JPRB, 0.21745255E-07_JPRB, &
  & 0.21562859E-07_JPRB, 0.21572713E-07_JPRB, 0.21562982E-07_JPRB, 0.22451978E-07_JPRB, 0.23334405E-07_JPRB, 0.24066904E-07_JPRB, &
  & 0.25028544E-07_JPRB, 0.26238553E-07_JPRB, 0.27124469E-07_JPRB, 0.27865587E-07_JPRB, 0.28831644E-07_JPRB, 0.30086104E-07_JPRB, &
  & 0.31701754E-07_JPRB, 0.33567201E-07_JPRB, 0.36181711E-07_JPRB, 0.38703003E-07_JPRB, 0.40563350E-07_JPRB, 0.41767954E-07_JPRB, &
  & 0.42061825E-07_JPRB, 0.41607346E-07_JPRB, 0.40782712E-07_JPRB, 0.39781506E-07_JPRB, 0.38549792E-07_JPRB, 0.36770963E-07_JPRB, &
  & 0.34797631E-07_JPRB, 0.32783560E-07_JPRB, 0.30849101E-07_JPRB, 0.29494508E-07_JPRB, 0.30774784E-07_JPRB, 0.35150467E-07_JPRB, &
  & 0.40629039E-07_JPRB, 0.45695635E-07_JPRB, 0.48828435E-07_JPRB, 0.51727768E-07_JPRB, 0.54155323E-07_JPRB, 0.56396637E-07_JPRB, &
  & 0.58819654E-07_JPRB, 0.60980052E-07_JPRB, 0.63675489E-07_JPRB, 0.65709887E-07_JPRB, 0.67852608E-07_JPRB, 0.67646069E-07_JPRB, &
  & 0.67168029E-07_JPRB, 0.66440946E-07_JPRB, 0.65529663E-07_JPRB, 0.65026265E-07_JPRB, 0.64465187E-07_JPRB, 0.63933198E-07_JPRB, &
  & 0.63284451E-07_JPRB, 0.61949391E-07_JPRB, 0.61710416E-07_JPRB, 0.61027612E-07_JPRB, 0.61036954E-07_JPRB, 0.60581374E-07_JPRB, &
  & 0.60176874E-07_JPRB, 0.59338409E-07_JPRB, 0.61869156E-07_JPRB, 0.59502556E-07_JPRB  /)

RGHG7(:,63, 6) = (/ &
  & 0.19858833E-07_JPRB, 0.19576217E-07_JPRB, 0.18915263E-07_JPRB, 0.18911322E-07_JPRB, 0.19626689E-07_JPRB, 0.20098924E-07_JPRB, &
  & 0.20010140E-07_JPRB, 0.20003966E-07_JPRB, 0.19984321E-07_JPRB, 0.20796064E-07_JPRB, 0.21679725E-07_JPRB, 0.22460296E-07_JPRB, &
  & 0.23397383E-07_JPRB, 0.24575964E-07_JPRB, 0.25646394E-07_JPRB, 0.26527918E-07_JPRB, 0.27550143E-07_JPRB, 0.28736703E-07_JPRB, &
  & 0.30295457E-07_JPRB, 0.32050835E-07_JPRB, 0.34574323E-07_JPRB, 0.37056996E-07_JPRB, 0.39049796E-07_JPRB, 0.40648565E-07_JPRB, &
  & 0.41223896E-07_JPRB, 0.40833793E-07_JPRB, 0.40150734E-07_JPRB, 0.39274325E-07_JPRB, 0.37935729E-07_JPRB, 0.35916327E-07_JPRB, &
  & 0.33796179E-07_JPRB, 0.31705075E-07_JPRB, 0.29711014E-07_JPRB, 0.28316213E-07_JPRB, 0.29644243E-07_JPRB, 0.34189762E-07_JPRB, &
  & 0.39515945E-07_JPRB, 0.44572333E-07_JPRB, 0.47784754E-07_JPRB, 0.50493022E-07_JPRB, 0.52632948E-07_JPRB, 0.54646732E-07_JPRB, &
  & 0.57090301E-07_JPRB, 0.59539956E-07_JPRB, 0.62177815E-07_JPRB, 0.63681686E-07_JPRB, 0.65583796E-07_JPRB, 0.65147258E-07_JPRB, &
  & 0.64587327E-07_JPRB, 0.63681591E-07_JPRB, 0.62773711E-07_JPRB, 0.62228916E-07_JPRB, 0.61625007E-07_JPRB, 0.60930747E-07_JPRB, &
  & 0.60214627E-07_JPRB, 0.58940713E-07_JPRB, 0.58418799E-07_JPRB, 0.57703727E-07_JPRB, 0.57301410E-07_JPRB, 0.56642025E-07_JPRB, &
  & 0.56108620E-07_JPRB, 0.55370861E-07_JPRB, 0.57251253E-07_JPRB, 0.55298575E-07_JPRB  /)

RGHG7(:,64, 6) = (/ &
  & 0.18305638E-07_JPRB, 0.17932772E-07_JPRB, 0.17405197E-07_JPRB, 0.17560990E-07_JPRB, 0.18240417E-07_JPRB, 0.18745397E-07_JPRB, &
  & 0.18726897E-07_JPRB, 0.18676796E-07_JPRB, 0.18657151E-07_JPRB, 0.19426564E-07_JPRB, 0.20327795E-07_JPRB, 0.21135522E-07_JPRB, &
  & 0.22033474E-07_JPRB, 0.23177712E-07_JPRB, 0.24367942E-07_JPRB, 0.25350099E-07_JPRB, 0.26427433E-07_JPRB, 0.27546904E-07_JPRB, &
  & 0.29053745E-07_JPRB, 0.30727658E-07_JPRB, 0.33168882E-07_JPRB, 0.35582869E-07_JPRB, 0.37650745E-07_JPRB, 0.39482726E-07_JPRB, &
  & 0.40322418E-07_JPRB, 0.39983430E-07_JPRB, 0.39349889E-07_JPRB, 0.38552549E-07_JPRB, 0.37019875E-07_JPRB, 0.34833551E-07_JPRB, &
  & 0.32579226E-07_JPRB, 0.30461766E-07_JPRB, 0.28275224E-07_JPRB, 0.26880423E-07_JPRB, 0.28196473E-07_JPRB, 0.33027917E-07_JPRB, &
  & 0.38151237E-07_JPRB, 0.43098206E-07_JPRB, 0.46364937E-07_JPRB, 0.48837597E-07_JPRB, 0.50705175E-07_JPRB, 0.52595165E-07_JPRB, &
  & 0.55155340E-07_JPRB, 0.57987560E-07_JPRB, 0.60516001E-07_JPRB, 0.61627723E-07_JPRB, 0.63223941E-07_JPRB, 0.62708334E-07_JPRB, &
  & 0.62065341E-07_JPRB, 0.61073348E-07_JPRB, 0.60188630E-07_JPRB, 0.59605499E-07_JPRB, 0.59019161E-07_JPRB, 0.58196314E-07_JPRB, &
  & 0.57483389E-07_JPRB, 0.56314101E-07_JPRB, 0.55644432E-07_JPRB, 0.54970093E-07_JPRB, 0.54392068E-07_JPRB, 0.53667991E-07_JPRB, &
  & 0.53045134E-07_JPRB, 0.52348906E-07_JPRB, 0.53742906E-07_JPRB, 0.52234290E-07_JPRB  /)

RGHG7(:,65, 6) = (/ &
  & 0.17103407E-07_JPRB, 0.16639602E-07_JPRB, 0.16205538E-07_JPRB, 0.16471736E-07_JPRB, 0.17131302E-07_JPRB, 0.17632110E-07_JPRB, &
  & 0.17649491E-07_JPRB, 0.17536544E-07_JPRB, 0.17509466E-07_JPRB, 0.18267447E-07_JPRB, 0.19181923E-07_JPRB, 0.20024445E-07_JPRB, &
  & 0.20867353E-07_JPRB, 0.22001517E-07_JPRB, 0.23243330E-07_JPRB, 0.24287489E-07_JPRB, 0.25389131E-07_JPRB, 0.26487834E-07_JPRB, &
  & 0.27944595E-07_JPRB, 0.29547572E-07_JPRB, 0.31877658E-07_JPRB, 0.34233586E-07_JPRB, 0.36386773E-07_JPRB, 0.38241889E-07_JPRB, &
  & 0.39347215E-07_JPRB, 0.39192049E-07_JPRB, 0.38538528E-07_JPRB, 0.37685569E-07_JPRB, 0.36010858E-07_JPRB, 0.33699453E-07_JPRB, &
  & 0.31316617E-07_JPRB, 0.29189697E-07_JPRB, 0.26867189E-07_JPRB, 0.25453804E-07_JPRB, 0.26819482E-07_JPRB, 0.31710821E-07_JPRB, &
  & 0.36722650E-07_JPRB, 0.41387651E-07_JPRB, 0.44473462E-07_JPRB, 0.46777848E-07_JPRB, 0.48421550E-07_JPRB, 0.50377843E-07_JPRB, &
  & 0.53196009E-07_JPRB, 0.56345322E-07_JPRB, 0.58695122E-07_JPRB, 0.59551455E-07_JPRB, 0.60802280E-07_JPRB, 0.60293231E-07_JPRB, &
  & 0.59593303E-07_JPRB, 0.58614005E-07_JPRB, 0.57750395E-07_JPRB, 0.57144246E-07_JPRB, 0.56588993E-07_JPRB, 0.55704225E-07_JPRB, &
  & 0.55017562E-07_JPRB, 0.53978974E-07_JPRB, 0.53246652E-07_JPRB, 0.52677285E-07_JPRB, 0.52111767E-07_JPRB, 0.51483069E-07_JPRB, &
  & 0.50806504E-07_JPRB, 0.50184088E-07_JPRB, 0.51171985E-07_JPRB, 0.50026819E-07_JPRB  /)

RGHG7(:,66, 6) = (/ &
  & 0.16059970E-07_JPRB, 0.15517032E-07_JPRB, 0.15146299E-07_JPRB, 0.15497307E-07_JPRB, 0.16143717E-07_JPRB, 0.16620788E-07_JPRB, &
  & 0.16647287E-07_JPRB, 0.16470907E-07_JPRB, 0.16429108E-07_JPRB, 0.17184666E-07_JPRB, 0.18102370E-07_JPRB, 0.18991581E-07_JPRB, &
  & 0.19785775E-07_JPRB, 0.20901473E-07_JPRB, 0.22172022E-07_JPRB, 0.23248612E-07_JPRB, 0.24361992E-07_JPRB, 0.25456196E-07_JPRB, &
  & 0.26853447E-07_JPRB, 0.28385871E-07_JPRB, 0.30593362E-07_JPRB, 0.32886178E-07_JPRB, 0.35122498E-07_JPRB, 0.36975367E-07_JPRB, &
  & 0.38358513E-07_JPRB, 0.38438364E-07_JPRB, 0.37761061E-07_JPRB, 0.36778531E-07_JPRB, 0.35078024E-07_JPRB, 0.32677070E-07_JPRB, &
  & 0.30200496E-07_JPRB, 0.27991890E-07_JPRB, 0.25564417E-07_JPRB, 0.24210702E-07_JPRB, 0.25599110E-07_JPRB, 0.30374734E-07_JPRB, &
  & 0.35334174E-07_JPRB, 0.39603232E-07_JPRB, 0.42454400E-07_JPRB, 0.44675839E-07_JPRB, 0.46170204E-07_JPRB, 0.48224281E-07_JPRB, &
  & 0.51279391E-07_JPRB, 0.54641600E-07_JPRB, 0.56808673E-07_JPRB, 0.57443415E-07_JPRB, 0.58367460E-07_JPRB, 0.57872757E-07_JPRB, &
  & 0.57123406E-07_JPRB, 0.56217314E-07_JPRB, 0.55343552E-07_JPRB, 0.54726602E-07_JPRB, 0.54218051E-07_JPRB, 0.53313135E-07_JPRB, &
  & 0.52664878E-07_JPRB, 0.51760984E-07_JPRB, 0.51028063E-07_JPRB, 0.50588797E-07_JPRB, 0.50113666E-07_JPRB, 0.49682745E-07_JPRB, &
  & 0.49004390E-07_JPRB, 0.48467487E-07_JPRB, 0.49139927E-07_JPRB, 0.48285684E-07_JPRB  /)

RGHG7(:,67, 6) = (/ &
  & 0.15159437E-07_JPRB, 0.14553055E-07_JPRB, 0.14217096E-07_JPRB, 0.14627731E-07_JPRB, 0.15266496E-07_JPRB, 0.15703099E-07_JPRB, &
  & 0.15712263E-07_JPRB, 0.15479035E-07_JPRB, 0.15414965E-07_JPRB, 0.16169624E-07_JPRB, 0.17081246E-07_JPRB, 0.18020115E-07_JPRB, &
  & 0.18776173E-07_JPRB, 0.19867977E-07_JPRB, 0.21146409E-07_JPRB, 0.22229973E-07_JPRB, 0.23345678E-07_JPRB, 0.24440456E-07_JPRB, &
  & 0.25770228E-07_JPRB, 0.27232653E-07_JPRB, 0.29313445E-07_JPRB, 0.31536974E-07_JPRB, 0.33842861E-07_JPRB, 0.35702551E-07_JPRB, &
  & 0.37345052E-07_JPRB, 0.37676956E-07_JPRB, 0.36972349E-07_JPRB, 0.35861983E-07_JPRB, 0.34236793E-07_JPRB, 0.31766048E-07_JPRB, &
  & 0.29199423E-07_JPRB, 0.26852548E-07_JPRB, 0.24379881E-07_JPRB, 0.23145812E-07_JPRB, 0.24496587E-07_JPRB, 0.28997135E-07_JPRB, &
  & 0.33978049E-07_JPRB, 0.37812978E-07_JPRB, 0.40416622E-07_JPRB, 0.42618468E-07_JPRB, 0.44073184E-07_JPRB, 0.46227140E-07_JPRB, &
  & 0.49449900E-07_JPRB, 0.52906872E-07_JPRB, 0.54911947E-07_JPRB, 0.55345886E-07_JPRB, 0.55970585E-07_JPRB, 0.55474442E-07_JPRB, &
  & 0.54688843E-07_JPRB, 0.53895010E-07_JPRB, 0.52990362E-07_JPRB, 0.52374508E-07_JPRB, 0.51916100E-07_JPRB, 0.51038150E-07_JPRB, &
  & 0.50440804E-07_JPRB, 0.49673142E-07_JPRB, 0.48993722E-07_JPRB, 0.48698926E-07_JPRB, 0.48383026E-07_JPRB, 0.48215628E-07_JPRB, &
  & 0.47602233E-07_JPRB, 0.47164977E-07_JPRB, 0.47620874E-07_JPRB, 0.46990499E-07_JPRB  /)

RGHG7(:,68, 6) = (/ &
  & 0.14385071E-07_JPRB, 0.13735224E-07_JPRB, 0.13409106E-07_JPRB, 0.13852544E-07_JPRB, 0.14488030E-07_JPRB, 0.14870506E-07_JPRB, &
  & 0.14836205E-07_JPRB, 0.14563613E-07_JPRB, 0.14469200E-07_JPRB, 0.15212377E-07_JPRB, 0.16111697E-07_JPRB, 0.17083370E-07_JPRB, &
  & 0.17815645E-07_JPRB, 0.18891047E-07_JPRB, 0.20153078E-07_JPRB, 0.21226801E-07_JPRB, 0.22339225E-07_JPRB, 0.23420882E-07_JPRB, &
  & 0.24680126E-07_JPRB, 0.26074484E-07_JPRB, 0.28035542E-07_JPRB, 0.30183622E-07_JPRB, 0.32524774E-07_JPRB, 0.34438590E-07_JPRB, &
  & 0.36257410E-07_JPRB, 0.36802539E-07_JPRB, 0.36054466E-07_JPRB, 0.34969524E-07_JPRB, 0.33470628E-07_JPRB, 0.30914593E-07_JPRB, &
  & 0.28186409E-07_JPRB, 0.25697659E-07_JPRB, 0.23303720E-07_JPRB, 0.22188566E-07_JPRB, 0.23388443E-07_JPRB, 0.27484686E-07_JPRB, &
  & 0.32595994E-07_JPRB, 0.36108626E-07_JPRB, 0.38502326E-07_JPRB, 0.40692692E-07_JPRB, 0.42282723E-07_JPRB, 0.44507206E-07_JPRB, &
  & 0.47761130E-07_JPRB, 0.51179558E-07_JPRB, 0.53081301E-07_JPRB, 0.53323338E-07_JPRB, 0.53678227E-07_JPRB, 0.53129598E-07_JPRB, &
  & 0.52335798E-07_JPRB, 0.51653498E-07_JPRB, 0.50726707E-07_JPRB, 0.50123155E-07_JPRB, 0.49691810E-07_JPRB, 0.48902429E-07_JPRB, &
  & 0.48371512E-07_JPRB, 0.47742445E-07_JPRB, 0.47155696E-07_JPRB, 0.47005236E-07_JPRB, 0.46918141E-07_JPRB, 0.47011533E-07_JPRB, &
  & 0.46556416E-07_JPRB, 0.46242994E-07_JPRB, 0.46588998E-07_JPRB, 0.46132484E-07_JPRB  /)

RGHG7(:,69, 6) = (/ &
  & 0.13722147E-07_JPRB, 0.13048996E-07_JPRB, 0.12717790E-07_JPRB, 0.13156706E-07_JPRB, 0.13790404E-07_JPRB, 0.14113540E-07_JPRB, &
  & 0.14022347E-07_JPRB, 0.13723832E-07_JPRB, 0.13606545E-07_JPRB, 0.14324808E-07_JPRB, 0.15180481E-07_JPRB, 0.16162559E-07_JPRB, &
  & 0.16892702E-07_JPRB, 0.17936031E-07_JPRB, 0.19177184E-07_JPRB, 0.20226886E-07_JPRB, 0.21347227E-07_JPRB, 0.22399343E-07_JPRB, &
  & 0.23579116E-07_JPRB, 0.24894969E-07_JPRB, 0.26760947E-07_JPRB, 0.28820157E-07_JPRB, 0.31130137E-07_JPRB, 0.33099562E-07_JPRB, &
  & 0.34911056E-07_JPRB, 0.35662652E-07_JPRB, 0.34950987E-07_JPRB, 0.33935501E-07_JPRB, 0.32412850E-07_JPRB, 0.29744671E-07_JPRB, &
  & 0.26873619E-07_JPRB, 0.24350499E-07_JPRB, 0.22153952E-07_JPRB, 0.21164406E-07_JPRB, 0.22142507E-07_JPRB, 0.25757639E-07_JPRB, &
  & 0.30931396E-07_JPRB, 0.34440502E-07_JPRB, 0.36704162E-07_JPRB, 0.38945746E-07_JPRB, 0.40766605E-07_JPRB, 0.42969051E-07_JPRB, &
  & 0.46205617E-07_JPRB, 0.49487730E-07_JPRB, 0.51407076E-07_JPRB, 0.51494567E-07_JPRB, 0.51546107E-07_JPRB, 0.50952465E-07_JPRB, &
  & 0.50172112E-07_JPRB, 0.49521459E-07_JPRB, 0.48622539E-07_JPRB, 0.48011879E-07_JPRB, 0.47607592E-07_JPRB, 0.46950056E-07_JPRB, &
  & 0.46475104E-07_JPRB, 0.45957738E-07_JPRB, 0.45521114E-07_JPRB, 0.45541088E-07_JPRB, 0.45731273E-07_JPRB, 0.45961505E-07_JPRB, &
  & 0.45728826E-07_JPRB, 0.45641472E-07_JPRB, 0.45992549E-07_JPRB, 0.45647165E-07_JPRB  /)

RGHG7(:,70, 6) = (/ &
  & 0.13133257E-07_JPRB, 0.12441128E-07_JPRB, 0.12095724E-07_JPRB, 0.12505455E-07_JPRB, 0.13135604E-07_JPRB, 0.13400194E-07_JPRB, &
  & 0.13252575E-07_JPRB, 0.12934179E-07_JPRB, 0.12796616E-07_JPRB, 0.13486682E-07_JPRB, 0.14287423E-07_JPRB, 0.15255318E-07_JPRB, &
  & 0.15992609E-07_JPRB, 0.17001301E-07_JPRB, 0.18202506E-07_JPRB, 0.19234841E-07_JPRB, 0.20357547E-07_JPRB, 0.21367959E-07_JPRB, &
  & 0.22485804E-07_JPRB, 0.23713862E-07_JPRB, 0.25490814E-07_JPRB, 0.27448690E-07_JPRB, 0.29681798E-07_JPRB, 0.31657526E-07_JPRB, &
  & 0.33422582E-07_JPRB, 0.34342267E-07_JPRB, 0.33705468E-07_JPRB, 0.32700062E-07_JPRB, 0.31100671E-07_JPRB, 0.28350355E-07_JPRB, &
  & 0.25470957E-07_JPRB, 0.22942598E-07_JPRB, 0.20951264E-07_JPRB, 0.20090148E-07_JPRB, 0.20903843E-07_JPRB, 0.24025503E-07_JPRB, &
  & 0.29133123E-07_JPRB, 0.32757377E-07_JPRB, 0.34956764E-07_JPRB, 0.37281117E-07_JPRB, 0.39300760E-07_JPRB, 0.41482947E-07_JPRB, &
  & 0.44658251E-07_JPRB, 0.47838921E-07_JPRB, 0.49841221E-07_JPRB, 0.49782784E-07_JPRB, 0.49565181E-07_JPRB, 0.48930986E-07_JPRB, &
  & 0.48157665E-07_JPRB, 0.47517493E-07_JPRB, 0.46655725E-07_JPRB, 0.46015059E-07_JPRB, 0.45635978E-07_JPRB, 0.45101956E-07_JPRB, &
  & 0.44695870E-07_JPRB, 0.44278718E-07_JPRB, 0.44013445E-07_JPRB, 0.44239179E-07_JPRB, 0.44705791E-07_JPRB, 0.45002283E-07_JPRB, &
  & 0.44978331E-07_JPRB, 0.45166194E-07_JPRB, 0.45619487E-07_JPRB, 0.45297769E-07_JPRB  /)

RGHG7(:,71, 6) = (/ &
  & 0.12617309E-07_JPRB, 0.11902553E-07_JPRB, 0.11534745E-07_JPRB, 0.11896599E-07_JPRB, 0.12520992E-07_JPRB, 0.12728902E-07_JPRB, &
  & 0.12525621E-07_JPRB, 0.12194102E-07_JPRB, 0.12036403E-07_JPRB, 0.12695448E-07_JPRB, 0.13438703E-07_JPRB, 0.14369380E-07_JPRB, &
  & 0.15118581E-07_JPRB, 0.16090086E-07_JPRB, 0.17235205E-07_JPRB, 0.18251904E-07_JPRB, 0.19369045E-07_JPRB, 0.20332439E-07_JPRB, &
  & 0.21405535E-07_JPRB, 0.22544486E-07_JPRB, 0.24230010E-07_JPRB, 0.26076970E-07_JPRB, 0.28185491E-07_JPRB, 0.30115934E-07_JPRB, &
  & 0.31793743E-07_JPRB, 0.32832205E-07_JPRB, 0.32314878E-07_JPRB, 0.31283246E-07_JPRB, 0.29582416E-07_JPRB, 0.26824002E-07_JPRB, &
  & 0.24062481E-07_JPRB, 0.21554120E-07_JPRB, 0.19728500E-07_JPRB, 0.18993464E-07_JPRB, 0.19713039E-07_JPRB, 0.22379013E-07_JPRB, &
  & 0.27283195E-07_JPRB, 0.31056574E-07_JPRB, 0.33255071E-07_JPRB, 0.35675304E-07_JPRB, 0.37846409E-07_JPRB, 0.40021441E-07_JPRB, &
  & 0.43103685E-07_JPRB, 0.46259996E-07_JPRB, 0.48373340E-07_JPRB, 0.48197998E-07_JPRB, 0.47758710E-07_JPRB, 0.47084658E-07_JPRB, &
  & 0.46301409E-07_JPRB, 0.45667227E-07_JPRB, 0.44822355E-07_JPRB, 0.44135058E-07_JPRB, 0.43771533E-07_JPRB, 0.43337646E-07_JPRB, &
  & 0.43012495E-07_JPRB, 0.42694991E-07_JPRB, 0.42618712E-07_JPRB, 0.43083574E-07_JPRB, 0.43811776E-07_JPRB, 0.44126924E-07_JPRB, &
  & 0.44285277E-07_JPRB, 0.44756852E-07_JPRB, 0.45382306E-07_JPRB, 0.45018441E-07_JPRB  /)

RGHG7(:,72, 6) = (/ &
  & 0.12179951E-07_JPRB, 0.11426612E-07_JPRB, 0.11028430E-07_JPRB, 0.11331999E-07_JPRB, 0.11948183E-07_JPRB, 0.12101913E-07_JPRB, &
  & 0.11841168E-07_JPRB, 0.11506365E-07_JPRB, 0.11324860E-07_JPRB, 0.11948605E-07_JPRB, 0.12644247E-07_JPRB, 0.13517460E-07_JPRB, &
  & 0.14277333E-07_JPRB, 0.15206150E-07_JPRB, 0.16287238E-07_JPRB, 0.17276026E-07_JPRB, 0.18378390E-07_JPRB, 0.19301560E-07_JPRB, &
  & 0.20340998E-07_JPRB, 0.21404426E-07_JPRB, 0.22983231E-07_JPRB, 0.24714441E-07_JPRB, 0.26640719E-07_JPRB, 0.28479220E-07_JPRB, &
  & 0.29993667E-07_JPRB, 0.31086309E-07_JPRB, 0.30755330E-07_JPRB, 0.29726982E-07_JPRB, 0.27933388E-07_JPRB, 0.25316172E-07_JPRB, &
  & 0.22761521E-07_JPRB, 0.20308161E-07_JPRB, 0.18540005E-07_JPRB, 0.17919897E-07_JPRB, 0.18614845E-07_JPRB, 0.20945886E-07_JPRB, &
  & 0.25501179E-07_JPRB, 0.29336947E-07_JPRB, 0.31597834E-07_JPRB, 0.34098517E-07_JPRB, 0.36370595E-07_JPRB, 0.38553836E-07_JPRB, &
  & 0.41532644E-07_JPRB, 0.44797316E-07_JPRB, 0.46990289E-07_JPRB, 0.46773080E-07_JPRB, 0.46171251E-07_JPRB, 0.45451228E-07_JPRB, &
  & 0.44626112E-07_JPRB, 0.44013274E-07_JPRB, 0.43115864E-07_JPRB, 0.42377670E-07_JPRB, 0.42005115E-07_JPRB, 0.41629513E-07_JPRB, &
  & 0.41391378E-07_JPRB, 0.41191266E-07_JPRB, 0.41323498E-07_JPRB, 0.42056799E-07_JPRB, 0.43015678E-07_JPRB, 0.43334110E-07_JPRB, &
  & 0.43640227E-07_JPRB, 0.44337554E-07_JPRB, 0.45158385E-07_JPRB, 0.44732131E-07_JPRB  /)

RGHG7(:,73, 6) = (/ &
  & 0.11820838E-07_JPRB, 0.11002787E-07_JPRB, 0.10572912E-07_JPRB, 0.10819763E-07_JPRB, 0.11418928E-07_JPRB, 0.11526544E-07_JPRB, &
  & 0.11212192E-07_JPRB, 0.10871038E-07_JPRB, 0.10666732E-07_JPRB, 0.11253448E-07_JPRB, 0.11908439E-07_JPRB, 0.12718140E-07_JPRB, &
  & 0.13465889E-07_JPRB, 0.14332724E-07_JPRB, 0.15353980E-07_JPRB, 0.16315457E-07_JPRB, 0.17377815E-07_JPRB, 0.18267384E-07_JPRB, &
  & 0.19296208E-07_JPRB, 0.20297387E-07_JPRB, 0.21774949E-07_JPRB, 0.23364976E-07_JPRB, 0.25059571E-07_JPRB, 0.26748452E-07_JPRB, &
  & 0.28047541E-07_JPRB, 0.29046485E-07_JPRB, 0.28885031E-07_JPRB, 0.28005511E-07_JPRB, 0.26352904E-07_JPRB, 0.24002658E-07_JPRB, &
  & 0.21716651E-07_JPRB, 0.19338041E-07_JPRB, 0.17493967E-07_JPRB, 0.16928882E-07_JPRB, 0.17650489E-07_JPRB, 0.19808082E-07_JPRB, &
  & 0.23927508E-07_JPRB, 0.27649644E-07_JPRB, 0.30014045E-07_JPRB, 0.32541167E-07_JPRB, 0.34850803E-07_JPRB, 0.37057921E-07_JPRB, &
  & 0.40027551E-07_JPRB, 0.43464072E-07_JPRB, 0.45694468E-07_JPRB, 0.45522388E-07_JPRB, 0.44826790E-07_JPRB, 0.44057481E-07_JPRB, &
  & 0.43179208E-07_JPRB, 0.42506693E-07_JPRB, 0.41509201E-07_JPRB, 0.40701529E-07_JPRB, 0.40266557E-07_JPRB, 0.39846340E-07_JPRB, &
  & 0.39757061E-07_JPRB, 0.39664735E-07_JPRB, 0.40048596E-07_JPRB, 0.41041990E-07_JPRB, 0.42188694E-07_JPRB, 0.42510048E-07_JPRB, &
  & 0.42939645E-07_JPRB, 0.43727270E-07_JPRB, 0.44575468E-07_JPRB, 0.44104367E-07_JPRB  /)

RGHG7(:,74, 6) = (/ &
  & 0.11496051E-07_JPRB, 0.10607442E-07_JPRB, 0.10153976E-07_JPRB, 0.10347771E-07_JPRB, 0.10919528E-07_JPRB, 0.10986963E-07_JPRB, &
  & 0.10627565E-07_JPRB, 0.10276340E-07_JPRB, 0.10054546E-07_JPRB, 0.10606607E-07_JPRB, 0.11223807E-07_JPRB, 0.11974761E-07_JPRB, &
  & 0.12706498E-07_JPRB, 0.13494178E-07_JPRB, 0.14446850E-07_JPRB, 0.15372172E-07_JPRB, 0.16394677E-07_JPRB, 0.17273049E-07_JPRB, &
  & 0.18286268E-07_JPRB, 0.19227870E-07_JPRB, 0.20594348E-07_JPRB, 0.22052853E-07_JPRB, 0.23533172E-07_JPRB, 0.25030067E-07_JPRB, &
  & 0.26085612E-07_JPRB, 0.26958195E-07_JPRB, 0.26982017E-07_JPRB, 0.26310008E-07_JPRB, 0.24901924E-07_JPRB, 0.22905284E-07_JPRB, &
  & 0.20869034E-07_JPRB, 0.18596001E-07_JPRB, 0.16636117E-07_JPRB, 0.16056018E-07_JPRB, 0.16809066E-07_JPRB, 0.18893238E-07_JPRB, &
  & 0.22561272E-07_JPRB, 0.26042317E-07_JPRB, 0.28491025E-07_JPRB, 0.31063066E-07_JPRB, 0.33380594E-07_JPRB, 0.35597017E-07_JPRB, &
  & 0.38612255E-07_JPRB, 0.42235693E-07_JPRB, 0.44479351E-07_JPRB, 0.44374047E-07_JPRB, 0.43642119E-07_JPRB, 0.42842632E-07_JPRB, &
  & 0.41891223E-07_JPRB, 0.41110889E-07_JPRB, 0.40016114E-07_JPRB, 0.39127561E-07_JPRB, 0.38608151E-07_JPRB, 0.38083650E-07_JPRB, &
  & 0.38084323E-07_JPRB, 0.38119184E-07_JPRB, 0.38741671E-07_JPRB, 0.39955758E-07_JPRB, 0.41246575E-07_JPRB, 0.41578500E-07_JPRB, &
  & 0.42117751E-07_JPRB, 0.42872400E-07_JPRB, 0.43578395E-07_JPRB, 0.43043151E-07_JPRB  /)

RGHG7(:,75, 6) = (/ &
  & 0.11192121E-07_JPRB, 0.10238519E-07_JPRB, 0.97702431E-08_JPRB, 0.99150152E-08_JPRB, 0.10448824E-07_JPRB, 0.10481795E-07_JPRB, &
  & 0.10088577E-07_JPRB, 0.97247797E-08_JPRB, 0.94910400E-08_JPRB, 0.10009841E-07_JPRB, 0.10593216E-07_JPRB, 0.11296303E-07_JPRB, &
  & 0.12011326E-07_JPRB, 0.12711188E-07_JPRB, 0.13585742E-07_JPRB, 0.14463068E-07_JPRB, 0.15450372E-07_JPRB, 0.16326808E-07_JPRB, &
  & 0.17324296E-07_JPRB, 0.18217581E-07_JPRB, 0.19463303E-07_JPRB, 0.20794040E-07_JPRB, 0.22081602E-07_JPRB, 0.23362959E-07_JPRB, &
  & 0.24186496E-07_JPRB, 0.24923787E-07_JPRB, 0.25136391E-07_JPRB, 0.24666084E-07_JPRB, 0.23563934E-07_JPRB, 0.21976244E-07_JPRB, &
  & 0.20161265E-07_JPRB, 0.18019394E-07_JPRB, 0.15952797E-07_JPRB, 0.15308654E-07_JPRB, 0.16084748E-07_JPRB, 0.18177877E-07_JPRB, &
  & 0.21421001E-07_JPRB, 0.24542626E-07_JPRB, 0.27028756E-07_JPRB, 0.29661329E-07_JPRB, 0.31986085E-07_JPRB, 0.34194909E-07_JPRB, &
  & 0.37288504E-07_JPRB, 0.41099933E-07_JPRB, 0.43351931E-07_JPRB, 0.43329459E-07_JPRB, 0.42611613E-07_JPRB, 0.41803026E-07_JPRB, &
  & 0.40752842E-07_JPRB, 0.39845834E-07_JPRB, 0.38664042E-07_JPRB, 0.37691433E-07_JPRB, 0.37071826E-07_JPRB, 0.36418452E-07_JPRB, &
  & 0.36400754E-07_JPRB, 0.36568434E-07_JPRB, 0.37410225E-07_JPRB, 0.38784966E-07_JPRB, 0.40184195E-07_JPRB, 0.40539713E-07_JPRB, &
  & 0.41176740E-07_JPRB, 0.41824399E-07_JPRB, 0.42266459E-07_JPRB, 0.41624687E-07_JPRB  /)

RGHG7(:,76, 6) = (/ &
  & 0.10893741E-07_JPRB, 0.98957994E-08_JPRB, 0.94213654E-08_JPRB, 0.95213872E-08_JPRB, 0.10006340E-07_JPRB, 0.10010573E-07_JPRB, &
  & 0.95984684E-08_JPRB, 0.92215338E-08_JPRB, 0.89812252E-08_JPRB, 0.94659503E-08_JPRB, 0.10021818E-07_JPRB, 0.10696166E-07_JPRB, &
  & 0.11395999E-07_JPRB, 0.12012108E-07_JPRB, 0.12799214E-07_JPRB, 0.13612904E-07_JPRB, 0.14573112E-07_JPRB, 0.15433946E-07_JPRB, &
  & 0.16427329E-07_JPRB, 0.17298855E-07_JPRB, 0.18416073E-07_JPRB, 0.19608043E-07_JPRB, 0.20721120E-07_JPRB, 0.21789810E-07_JPRB, &
  & 0.22451999E-07_JPRB, 0.23065303E-07_JPRB, 0.23446645E-07_JPRB, 0.23083081E-07_JPRB, 0.22302806E-07_JPRB, 0.21137986E-07_JPRB, &
  & 0.19512273E-07_JPRB, 0.17518201E-07_JPRB, 0.15417939E-07_JPRB, 0.14694148E-07_JPRB, 0.15470653E-07_JPRB, 0.17638091E-07_JPRB, &
  & 0.20538403E-07_JPRB, 0.23185839E-07_JPRB, 0.25626397E-07_JPRB, 0.28320554E-07_JPRB, 0.30692934E-07_JPRB, 0.32877535E-07_JPRB, &
  & 0.36054062E-07_JPRB, 0.40039976E-07_JPRB, 0.42323176E-07_JPRB, 0.42400879E-07_JPRB, 0.41739280E-07_JPRB, 0.40943009E-07_JPRB, &
  & 0.39759806E-07_JPRB, 0.38748106E-07_JPRB, 0.37494056E-07_JPRB, 0.36445906E-07_JPRB, 0.35715038E-07_JPRB, 0.34956563E-07_JPRB, &
  & 0.34748778E-07_JPRB, 0.35029360E-07_JPRB, 0.36069449E-07_JPRB, 0.37515627E-07_JPRB, 0.38999840E-07_JPRB, 0.39399698E-07_JPRB, &
  & 0.40124173E-07_JPRB, 0.40665088E-07_JPRB, 0.40793895E-07_JPRB, 0.39970659E-07_JPRB  /)

RGHG7(:,77, 6) = (/ &
  & 0.10584921E-07_JPRB, 0.95858434E-08_JPRB, 0.91063481E-08_JPRB, 0.91724337E-08_JPRB, 0.95924315E-08_JPRB, 0.95651456E-08_JPRB, &
  & 0.91603466E-08_JPRB, 0.87740360E-08_JPRB, 0.85270649E-08_JPRB, 0.89645901E-08_JPRB, 0.95040109E-08_JPRB, 0.10160663E-07_JPRB, &
  & 0.10829686E-07_JPRB, 0.11399945E-07_JPRB, 0.12111388E-07_JPRB, 0.12875147E-07_JPRB, 0.13813400E-07_JPRB, 0.14692769E-07_JPRB, &
  & 0.15685938E-07_JPRB, 0.16579230E-07_JPRB, 0.17624955E-07_JPRB, 0.18673809E-07_JPRB, 0.19657301E-07_JPRB, 0.20607837E-07_JPRB, &
  & 0.21188915E-07_JPRB, 0.21698183E-07_JPRB, 0.22061502E-07_JPRB, 0.21773426E-07_JPRB, 0.21233524E-07_JPRB, 0.20336874E-07_JPRB, &
  & 0.18831250E-07_JPRB, 0.16977213E-07_JPRB, 0.14988928E-07_JPRB, 0.14219896E-07_JPRB, 0.14998397E-07_JPRB, 0.17242786E-07_JPRB, &
  & 0.20029190E-07_JPRB, 0.22262412E-07_JPRB, 0.24594351E-07_JPRB, 0.27146398E-07_JPRB, 0.29506263E-07_JPRB, 0.31699864E-07_JPRB, &
  & 0.35009477E-07_JPRB, 0.39097726E-07_JPRB, 0.41391642E-07_JPRB, 0.41559497E-07_JPRB, 0.41007076E-07_JPRB, 0.40185385E-07_JPRB, &
  & 0.38875162E-07_JPRB, 0.37826389E-07_JPRB, 0.36569743E-07_JPRB, 0.35418513E-07_JPRB, 0.34569269E-07_JPRB, 0.33698268E-07_JPRB, &
  & 0.33380224E-07_JPRB, 0.33600367E-07_JPRB, 0.34698225E-07_JPRB, 0.36113388E-07_JPRB, 0.37574009E-07_JPRB, 0.37944989E-07_JPRB, &
  & 0.38724195E-07_JPRB, 0.39207394E-07_JPRB, 0.39112076E-07_JPRB, 0.38273419E-07_JPRB  /)

RGHG7(:,78, 6) = (/ &
  & 0.10275133E-07_JPRB, 0.93042712E-08_JPRB, 0.88203224E-08_JPRB, 0.88632409E-08_JPRB, 0.92041536E-08_JPRB, 0.91461066E-08_JPRB, &
  & 0.87688002E-08_JPRB, 0.83672738E-08_JPRB, 0.81065204E-08_JPRB, 0.84944481E-08_JPRB, 0.90194138E-08_JPRB, 0.96569280E-08_JPRB, &
  & 0.10307089E-07_JPRB, 0.10860724E-07_JPRB, 0.11526254E-07_JPRB, 0.12263760E-07_JPRB, 0.13180688E-07_JPRB, 0.14062421E-07_JPRB, &
  & 0.15067488E-07_JPRB, 0.15975607E-07_JPRB, 0.16976510E-07_JPRB, 0.17906865E-07_JPRB, 0.18802859E-07_JPRB, 0.19668642E-07_JPRB, &
  & 0.20176234E-07_JPRB, 0.20600931E-07_JPRB, 0.20909046E-07_JPRB, 0.20696310E-07_JPRB, 0.20325036E-07_JPRB, 0.19623588E-07_JPRB, &
  & 0.18185678E-07_JPRB, 0.16459624E-07_JPRB, 0.14640094E-07_JPRB, 0.13846656E-07_JPRB, 0.14636753E-07_JPRB, 0.16961389E-07_JPRB, &
  & 0.19683920E-07_JPRB, 0.21625697E-07_JPRB, 0.23846743E-07_JPRB, 0.26238597E-07_JPRB, 0.28536941E-07_JPRB, 0.30787610E-07_JPRB, &
  & 0.34191589E-07_JPRB, 0.38323617E-07_JPRB, 0.40586362E-07_JPRB, 0.40818628E-07_JPRB, 0.40349071E-07_JPRB, 0.39491516E-07_JPRB, &
  & 0.38114570E-07_JPRB, 0.37032053E-07_JPRB, 0.35785378E-07_JPRB, 0.34532051E-07_JPRB, 0.33573733E-07_JPRB, 0.32613485E-07_JPRB, &
  & 0.32220655E-07_JPRB, 0.32280616E-07_JPRB, 0.33384667E-07_JPRB, 0.34722838E-07_JPRB, 0.36036844E-07_JPRB, 0.36378197E-07_JPRB, &
  & 0.37131600E-07_JPRB, 0.37534081E-07_JPRB, 0.37449360E-07_JPRB, 0.36641229E-07_JPRB  /)

RGHG7(:,79, 6) = (/ &
  & 0.99687096E-08_JPRB, 0.90492387E-08_JPRB, 0.85640571E-08_JPRB, 0.85930552E-08_JPRB, 0.88450295E-08_JPRB, 0.87531511E-08_JPRB, &
  & 0.84209452E-08_JPRB, 0.80007048E-08_JPRB, 0.77185083E-08_JPRB, 0.80627717E-08_JPRB, 0.85759536E-08_JPRB, 0.91879670E-08_JPRB, &
  & 0.98290672E-08_JPRB, 0.10391865E-07_JPRB, 0.11032816E-07_JPRB, 0.11761716E-07_JPRB, 0.12657320E-07_JPRB, 0.13545164E-07_JPRB, &
  & 0.14566049E-07_JPRB, 0.15480505E-07_JPRB, 0.16440808E-07_JPRB, 0.17292249E-07_JPRB, 0.18138552E-07_JPRB, 0.18939342E-07_JPRB, &
  & 0.19375626E-07_JPRB, 0.19733122E-07_JPRB, 0.19991576E-07_JPRB, 0.19848765E-07_JPRB, 0.19581498E-07_JPRB, 0.19006871E-07_JPRB, &
  & 0.17616916E-07_JPRB, 0.15992632E-07_JPRB, 0.14353433E-07_JPRB, 0.13561509E-07_JPRB, 0.14379464E-07_JPRB, 0.16780728E-07_JPRB, &
  & 0.19452827E-07_JPRB, 0.21209401E-07_JPRB, 0.23331928E-07_JPRB, 0.25538926E-07_JPRB, 0.27749086E-07_JPRB, 0.30110011E-07_JPRB, &
  & 0.33568014E-07_JPRB, 0.37702969E-07_JPRB, 0.39923863E-07_JPRB, 0.40205173E-07_JPRB, 0.39763373E-07_JPRB, 0.38863111E-07_JPRB, &
  & 0.37463023E-07_JPRB, 0.36342958E-07_JPRB, 0.35089819E-07_JPRB, 0.33745364E-07_JPRB, 0.32694210E-07_JPRB, 0.31660896E-07_JPRB, &
  & 0.31224905E-07_JPRB, 0.31092434E-07_JPRB, 0.32146304E-07_JPRB, 0.33340979E-07_JPRB, 0.34428776E-07_JPRB, 0.34760499E-07_JPRB, &
  & 0.35409865E-07_JPRB, 0.35772141E-07_JPRB, 0.35839802E-07_JPRB, 0.35026129E-07_JPRB  /)

RGHG7(:,80, 6) = (/ &
  & 0.96706616E-08_JPRB, 0.88187845E-08_JPRB, 0.83383676E-08_JPRB, 0.83607055E-08_JPRB, 0.85189764E-08_JPRB, 0.83858460E-08_JPRB, &
  & 0.81135440E-08_JPRB, 0.76743243E-08_JPRB, 0.73631286E-08_JPRB, 0.76781433E-08_JPRB, 0.81834841E-08_JPRB, 0.87587810E-08_JPRB, &
  & 0.93959766E-08_JPRB, 0.99898891E-08_JPRB, 0.10616257E-07_JPRB, 0.11346446E-07_JPRB, 0.12219979E-07_JPRB, 0.13143910E-07_JPRB, &
  & 0.14174645E-07_JPRB, 0.15088651E-07_JPRB, 0.15989066E-07_JPRB, 0.16815266E-07_JPRB, 0.17644485E-07_JPRB, 0.18388411E-07_JPRB, &
  & 0.18754017E-07_JPRB, 0.19059041E-07_JPRB, 0.19311882E-07_JPRB, 0.19225861E-07_JPRB, 0.19006894E-07_JPRB, 0.18491365E-07_JPRB, &
  & 0.17165715E-07_JPRB, 0.15602014E-07_JPRB, 0.14109371E-07_JPRB, 0.13350456E-07_JPRB, 0.14218789E-07_JPRB, 0.16685233E-07_JPRB, &
  & 0.19291127E-07_JPRB, 0.20943736E-07_JPRB, 0.22992291E-07_JPRB, 0.24970362E-07_JPRB, 0.27091209E-07_JPRB, 0.29620183E-07_JPRB, &
  & 0.33096217E-07_JPRB, 0.37213575E-07_JPRB, 0.39418201E-07_JPRB, 0.39745504E-07_JPRB, 0.39250576E-07_JPRB, 0.38303826E-07_JPRB, &
  & 0.36901129E-07_JPRB, 0.35736753E-07_JPRB, 0.34431956E-07_JPRB, 0.33016494E-07_JPRB, 0.31895239E-07_JPRB, 0.30794598E-07_JPRB, &
  & 0.30344878E-07_JPRB, 0.30059665E-07_JPRB, 0.30997806E-07_JPRB, 0.31957010E-07_JPRB, 0.32791635E-07_JPRB, 0.33151873E-07_JPRB, &
  & 0.33626890E-07_JPRB, 0.34066849E-07_JPRB, 0.34313712E-07_JPRB, 0.33374071E-07_JPRB  /)

RGHG7(:,81, 6) = (/ &
  & 0.93644984E-08_JPRB, 0.86067660E-08_JPRB, 0.81432361E-08_JPRB, 0.81685292E-08_JPRB, 0.82347662E-08_JPRB, 0.80547745E-08_JPRB, &
  & 0.78276452E-08_JPRB, 0.73829371E-08_JPRB, 0.70388119E-08_JPRB, 0.73415837E-08_JPRB, 0.78448135E-08_JPRB, 0.84091339E-08_JPRB, &
  & 0.90611056E-08_JPRB, 0.96841481E-08_JPRB, 0.10318116E-07_JPRB, 0.11044504E-07_JPRB, 0.11928592E-07_JPRB, 0.12847035E-07_JPRB, &
  & 0.13884946E-07_JPRB, 0.14801908E-07_JPRB, 0.15655883E-07_JPRB, 0.16480817E-07_JPRB, 0.17284706E-07_JPRB, 0.17971639E-07_JPRB, &
  & 0.18292916E-07_JPRB, 0.18554456E-07_JPRB, 0.18792099E-07_JPRB, 0.18734786E-07_JPRB, 0.18527640E-07_JPRB, 0.18089790E-07_JPRB, &
  & 0.16821979E-07_JPRB, 0.15281497E-07_JPRB, 0.13892709E-07_JPRB, 0.13211896E-07_JPRB, 0.14160019E-07_JPRB, 0.16680501E-07_JPRB, &
  & 0.19180008E-07_JPRB, 0.20767602E-07_JPRB, 0.22770140E-07_JPRB, 0.24573854E-07_JPRB, 0.26581980E-07_JPRB, 0.29183568E-07_JPRB, &
  & 0.32709419E-07_JPRB, 0.36775272E-07_JPRB, 0.39024226E-07_JPRB, 0.39451584E-07_JPRB, 0.38864622E-07_JPRB, 0.37824571E-07_JPRB, &
  & 0.36397811E-07_JPRB, 0.35131269E-07_JPRB, 0.33784254E-07_JPRB, 0.32317287E-07_JPRB, 0.31138194E-07_JPRB, 0.29989848E-07_JPRB, &
  & 0.29545616E-07_JPRB, 0.29154438E-07_JPRB, 0.29904290E-07_JPRB, 0.30648185E-07_JPRB, 0.31190244E-07_JPRB, 0.31589321E-07_JPRB, &
  & 0.31861696E-07_JPRB, 0.32245927E-07_JPRB, 0.32430308E-07_JPRB, 0.31396101E-07_JPRB  /)

RGHG7(:,82, 6) = (/ &
  & 0.90617457E-08_JPRB, 0.84161720E-08_JPRB, 0.79691303E-08_JPRB, 0.79964872E-08_JPRB, 0.79826217E-08_JPRB, 0.77525776E-08_JPRB, &
  & 0.75520081E-08_JPRB, 0.71117362E-08_JPRB, 0.67508891E-08_JPRB, 0.70505127E-08_JPRB, 0.75644431E-08_JPRB, 0.81443255E-08_JPRB, &
  & 0.88150510E-08_JPRB, 0.94586024E-08_JPRB, 0.10095176E-07_JPRB, 0.10824479E-07_JPRB, 0.11708292E-07_JPRB, 0.12613137E-07_JPRB, &
  & 0.13650327E-07_JPRB, 0.14572261E-07_JPRB, 0.15401035E-07_JPRB, 0.16222384E-07_JPRB, 0.16995868E-07_JPRB, 0.17646823E-07_JPRB, &
  & 0.17930746E-07_JPRB, 0.18165076E-07_JPRB, 0.18378019E-07_JPRB, 0.18333815E-07_JPRB, 0.18146850E-07_JPRB, 0.17765242E-07_JPRB, &
  & 0.16531339E-07_JPRB, 0.14981352E-07_JPRB, 0.13680049E-07_JPRB, 0.13114942E-07_JPRB, 0.14144092E-07_JPRB, 0.16692380E-07_JPRB, &
  & 0.19083561E-07_JPRB, 0.20589394E-07_JPRB, 0.22545628E-07_JPRB, 0.24236597E-07_JPRB, 0.26187404E-07_JPRB, 0.28818095E-07_JPRB, &
  & 0.32384136E-07_JPRB, 0.36387179E-07_JPRB, 0.38675815E-07_JPRB, 0.39200844E-07_JPRB, 0.38518073E-07_JPRB, 0.37372811E-07_JPRB, &
  & 0.35905561E-07_JPRB, 0.34541578E-07_JPRB, 0.33150870E-07_JPRB, 0.31615566E-07_JPRB, 0.30397911E-07_JPRB, 0.29200418E-07_JPRB, &
  & 0.28814867E-07_JPRB, 0.28307638E-07_JPRB, 0.28858768E-07_JPRB, 0.29403855E-07_JPRB, 0.29657543E-07_JPRB, 0.30046056E-07_JPRB, &
  & 0.30251169E-07_JPRB, 0.30629476E-07_JPRB, 0.30779115E-07_JPRB, 0.29757982E-07_JPRB  /)

RGHG7(:,83, 6) = (/ &
  & 0.87643384E-08_JPRB, 0.82387910E-08_JPRB, 0.78081330E-08_JPRB, 0.78344145E-08_JPRB, 0.77547924E-08_JPRB, 0.74734236E-08_JPRB, &
  & 0.72781051E-08_JPRB, 0.68504355E-08_JPRB, 0.64914614E-08_JPRB, 0.68012624E-08_JPRB, 0.73444669E-08_JPRB, 0.79542873E-08_JPRB, &
  & 0.86455562E-08_JPRB, 0.92983342E-08_JPRB, 0.99327455E-08_JPRB, 0.10664327E-07_JPRB, 0.11543148E-07_JPRB, 0.12433356E-07_JPRB, &
  & 0.13467031E-07_JPRB, 0.14395916E-07_JPRB, 0.15214685E-07_JPRB, 0.16027430E-07_JPRB, 0.16770725E-07_JPRB, 0.17399408E-07_JPRB, &
  & 0.17655667E-07_JPRB, 0.17872126E-07_JPRB, 0.18061362E-07_JPRB, 0.18024365E-07_JPRB, 0.17873354E-07_JPRB, 0.17547197E-07_JPRB, &
  & 0.16325470E-07_JPRB, 0.14739849E-07_JPRB, 0.13521473E-07_JPRB, 0.13093612E-07_JPRB, 0.14183250E-07_JPRB, 0.16723270E-07_JPRB, &
  & 0.19012812E-07_JPRB, 0.20434073E-07_JPRB, 0.22346713E-07_JPRB, 0.23967233E-07_JPRB, 0.25892430E-07_JPRB, 0.28523436E-07_JPRB, &
  & 0.32100275E-07_JPRB, 0.36032225E-07_JPRB, 0.38339286E-07_JPRB, 0.38948962E-07_JPRB, 0.38188768E-07_JPRB, 0.36937881E-07_JPRB, &
  & 0.35396786E-07_JPRB, 0.33950531E-07_JPRB, 0.32509124E-07_JPRB, 0.30889991E-07_JPRB, 0.29634330E-07_JPRB, 0.28418596E-07_JPRB, &
  & 0.28122792E-07_JPRB, 0.27508494E-07_JPRB, 0.27861011E-07_JPRB, 0.28188194E-07_JPRB, 0.28168870E-07_JPRB, 0.28514075E-07_JPRB, &
  & 0.28771385E-07_JPRB, 0.29205298E-07_JPRB, 0.29380492E-07_JPRB, 0.28424736E-07_JPRB  /)

RGHG7(:,84, 6) = (/ &
  & 0.84732433E-08_JPRB, 0.80665459E-08_JPRB, 0.76516520E-08_JPRB, 0.76735443E-08_JPRB, 0.75441733E-08_JPRB, 0.72129062E-08_JPRB, &
  & 0.70017060E-08_JPRB, 0.65932742E-08_JPRB, 0.62546154E-08_JPRB, 0.65900583E-08_JPRB, 0.71831990E-08_JPRB, 0.78267436E-08_JPRB, &
  & 0.85371646E-08_JPRB, 0.91873302E-08_JPRB, 0.98158204E-08_JPRB, 0.10544173E-07_JPRB, 0.11418125E-07_JPRB, 0.12297877E-07_JPRB, &
  & 0.13328964E-07_JPRB, 0.14265366E-07_JPRB, 0.15083086E-07_JPRB, 0.15880817E-07_JPRB, 0.16597949E-07_JPRB, 0.17210878E-07_JPRB, &
  & 0.17450501E-07_JPRB, 0.17652967E-07_JPRB, 0.17826191E-07_JPRB, 0.17798947E-07_JPRB, 0.17700890E-07_JPRB, 0.17440481E-07_JPRB, &
  & 0.16212636E-07_JPRB, 0.14574984E-07_JPRB, 0.13441184E-07_JPRB, 0.13151665E-07_JPRB, 0.14267680E-07_JPRB, 0.16762311E-07_JPRB, &
  & 0.18964026E-07_JPRB, 0.20313090E-07_JPRB, 0.22186348E-07_JPRB, 0.23761302E-07_JPRB, 0.25673551E-07_JPRB, 0.28288247E-07_JPRB, &
  & 0.31834864E-07_JPRB, 0.35691830E-07_JPRB, 0.37983749E-07_JPRB, 0.38655719E-07_JPRB, 0.37852148E-07_JPRB, 0.36508259E-07_JPRB, &
  & 0.34853874E-07_JPRB, 0.33346628E-07_JPRB, 0.31843758E-07_JPRB, 0.30128864E-07_JPRB, 0.28819243E-07_JPRB, 0.27635861E-07_JPRB, &
  & 0.27442621E-07_JPRB, 0.26747542E-07_JPRB, 0.26912975E-07_JPRB, 0.26975565E-07_JPRB, 0.26716846E-07_JPRB, 0.27003283E-07_JPRB, &
  & 0.27405425E-07_JPRB, 0.27957329E-07_JPRB, 0.28229739E-07_JPRB, 0.27339207E-07_JPRB  /)

RGHG7(:,85, 6) = (/ &
  & 0.81500001E-08_JPRB, 0.78594837E-08_JPRB, 0.74509733E-08_JPRB, 0.74830794E-08_JPRB, 0.73256206E-08_JPRB, 0.69573288E-08_JPRB, &
  & 0.67184665E-08_JPRB, 0.63423782E-08_JPRB, 0.60347860E-08_JPRB, 0.64132116E-08_JPRB, 0.70697626E-08_JPRB, 0.77435228E-08_JPRB, &
  & 0.84526671E-08_JPRB, 0.90977258E-08_JPRB, 0.97236625E-08_JPRB, 0.10449462E-07_JPRB, 0.11319158E-07_JPRB, 0.12191249E-07_JPRB, &
  & 0.13217655E-07_JPRB, 0.14144695E-07_JPRB, 0.14957734E-07_JPRB, 0.15735888E-07_JPRB, 0.16427060E-07_JPRB, 0.17014455E-07_JPRB, &
  & 0.17245993E-07_JPRB, 0.17439521E-07_JPRB, 0.17589339E-07_JPRB, 0.17590183E-07_JPRB, 0.17522341E-07_JPRB, 0.17287466E-07_JPRB, &
  & 0.16040896E-07_JPRB, 0.14375582E-07_JPRB, 0.13299234E-07_JPRB, 0.13059507E-07_JPRB, 0.14185736E-07_JPRB, 0.16648023E-07_JPRB, &
  & 0.18782923E-07_JPRB, 0.20133690E-07_JPRB, 0.21959284E-07_JPRB, 0.23498915E-07_JPRB, 0.25413292E-07_JPRB, 0.27986708E-07_JPRB, &
  & 0.31471617E-07_JPRB, 0.35264322E-07_JPRB, 0.37483043E-07_JPRB, 0.38167780E-07_JPRB, 0.37359102E-07_JPRB, 0.35990530E-07_JPRB, &
  & 0.34229326E-07_JPRB, 0.32666756E-07_JPRB, 0.31081325E-07_JPRB, 0.29269826E-07_JPRB, 0.27842322E-07_JPRB, 0.26717669E-07_JPRB, &
  & 0.26651249E-07_JPRB, 0.25949361E-07_JPRB, 0.25970100E-07_JPRB, 0.25646270E-07_JPRB, 0.25313502E-07_JPRB, 0.25562488E-07_JPRB, &
  & 0.26110176E-07_JPRB, 0.26802519E-07_JPRB, 0.27131530E-07_JPRB, 0.26186950E-07_JPRB  /)

RGHG7(:,86, 6) = (/ &
  & 0.77782179E-08_JPRB, 0.75958112E-08_JPRB, 0.71737354E-08_JPRB, 0.72454127E-08_JPRB, 0.70866989E-08_JPRB, 0.67048398E-08_JPRB, &
  & 0.64475001E-08_JPRB, 0.61052507E-08_JPRB, 0.58398720E-08_JPRB, 0.62698232E-08_JPRB, 0.69877736E-08_JPRB, 0.76762501E-08_JPRB, &
  & 0.83844442E-08_JPRB, 0.90227052E-08_JPRB, 0.96500719E-08_JPRB, 0.10372306E-07_JPRB, 0.11239390E-07_JPRB, 0.12106446E-07_JPRB, &
  & 0.13123152E-07_JPRB, 0.14020801E-07_JPRB, 0.14820809E-07_JPRB, 0.15567632E-07_JPRB, 0.16224387E-07_JPRB, 0.16782456E-07_JPRB, &
  & 0.17005201E-07_JPRB, 0.17199404E-07_JPRB, 0.17348010E-07_JPRB, 0.17384743E-07_JPRB, 0.17328954E-07_JPRB, 0.17114414E-07_JPRB, &
  & 0.15860680E-07_JPRB, 0.14187878E-07_JPRB, 0.13159948E-07_JPRB, 0.12945954E-07_JPRB, 0.14064798E-07_JPRB, 0.16472932E-07_JPRB, &
  & 0.18556665E-07_JPRB, 0.19921797E-07_JPRB, 0.21672511E-07_JPRB, 0.23173645E-07_JPRB, 0.25047200E-07_JPRB, 0.27553151E-07_JPRB, &
  & 0.30954727E-07_JPRB, 0.34677184E-07_JPRB, 0.36793031E-07_JPRB, 0.37426993E-07_JPRB, 0.36651480E-07_JPRB, 0.35280413E-07_JPRB, &
  & 0.33439158E-07_JPRB, 0.31837635E-07_JPRB, 0.30194202E-07_JPRB, 0.28287609E-07_JPRB, 0.26708656E-07_JPRB, 0.25621383E-07_JPRB, &
  & 0.25754357E-07_JPRB, 0.25076929E-07_JPRB, 0.25009855E-07_JPRB, 0.24260022E-07_JPRB, 0.23987704E-07_JPRB, 0.24268319E-07_JPRB, &
  & 0.24988263E-07_JPRB, 0.25733837E-07_JPRB, 0.26173018E-07_JPRB, 0.25240722E-07_JPRB  /)

RGHG7(:,87, 6) = (/ &
  & 0.73404700E-08_JPRB, 0.72427458E-08_JPRB, 0.68084388E-08_JPRB, 0.69325397E-08_JPRB, 0.68060635E-08_JPRB, 0.64434186E-08_JPRB, &
  & 0.61877446E-08_JPRB, 0.58744830E-08_JPRB, 0.56702300E-08_JPRB, 0.61646734E-08_JPRB, 0.69254627E-08_JPRB, 0.76217042E-08_JPRB, &
  & 0.83276992E-08_JPRB, 0.89599055E-08_JPRB, 0.95878830E-08_JPRB, 0.10305320E-07_JPRB, 0.11171785E-07_JPRB, 0.12034497E-07_JPRB, &
  & 0.13033921E-07_JPRB, 0.13880870E-07_JPRB, 0.14648165E-07_JPRB, 0.15351154E-07_JPRB, 0.15971880E-07_JPRB, 0.16502653E-07_JPRB, &
  & 0.16719823E-07_JPRB, 0.16927924E-07_JPRB, 0.17086399E-07_JPRB, 0.17174434E-07_JPRB, 0.17113177E-07_JPRB, 0.16905334E-07_JPRB, &
  & 0.15658777E-07_JPRB, 0.13990668E-07_JPRB, 0.12996138E-07_JPRB, 0.12805471E-07_JPRB, 0.13895530E-07_JPRB, 0.16241525E-07_JPRB, &
  & 0.18285446E-07_JPRB, 0.19651085E-07_JPRB, 0.21319067E-07_JPRB, 0.22771586E-07_JPRB, 0.24564001E-07_JPRB, 0.26943596E-07_JPRB, &
  & 0.30263249E-07_JPRB, 0.33826248E-07_JPRB, 0.35817175E-07_JPRB, 0.36373435E-07_JPRB, 0.35667723E-07_JPRB, 0.34253779E-07_JPRB, &
  & 0.32405407E-07_JPRB, 0.30767136E-07_JPRB, 0.29125669E-07_JPRB, 0.27140366E-07_JPRB, 0.25413596E-07_JPRB, 0.24352491E-07_JPRB, &
  & 0.24730704E-07_JPRB, 0.24096252E-07_JPRB, 0.23989891E-07_JPRB, 0.22871693E-07_JPRB, 0.22748284E-07_JPRB, 0.23142671E-07_JPRB, &
  & 0.24015134E-07_JPRB, 0.24776074E-07_JPRB, 0.25403516E-07_JPRB, 0.24447054E-07_JPRB  /)

RGHG7(:,88, 6) = (/ &
  & 0.67950511E-08_JPRB, 0.67804640E-08_JPRB, 0.63577303E-08_JPRB, 0.65092095E-08_JPRB, 0.64529494E-08_JPRB, 0.61534841E-08_JPRB, &
  & 0.59351938E-08_JPRB, 0.56551491E-08_JPRB, 0.55307186E-08_JPRB, 0.60941239E-08_JPRB, 0.68763926E-08_JPRB, 0.75777008E-08_JPRB, &
  & 0.82778285E-08_JPRB, 0.89056851E-08_JPRB, 0.95325597E-08_JPRB, 0.10244606E-07_JPRB, 0.11110539E-07_JPRB, 0.11967653E-07_JPRB, &
  & 0.12936936E-07_JPRB, 0.13710003E-07_JPRB, 0.14415796E-07_JPRB, 0.15058815E-07_JPRB, 0.15646287E-07_JPRB, 0.16146401E-07_JPRB, &
  & 0.16371910E-07_JPRB, 0.16610537E-07_JPRB, 0.16785993E-07_JPRB, 0.16941896E-07_JPRB, 0.16861523E-07_JPRB, 0.16630139E-07_JPRB, &
  & 0.15408526E-07_JPRB, 0.13752709E-07_JPRB, 0.12779494E-07_JPRB, 0.12617884E-07_JPRB, 0.13657734E-07_JPRB, 0.15941949E-07_JPRB, &
  & 0.17957774E-07_JPRB, 0.19287255E-07_JPRB, 0.20866424E-07_JPRB, 0.22261306E-07_JPRB, 0.23935182E-07_JPRB, 0.26095578E-07_JPRB, &
  & 0.29344498E-07_JPRB, 0.32609722E-07_JPRB, 0.34432364E-07_JPRB, 0.34866560E-07_JPRB, 0.34251263E-07_JPRB, 0.32703746E-07_JPRB, &
  & 0.30996806E-07_JPRB, 0.29323151E-07_JPRB, 0.27774596E-07_JPRB, 0.25729733E-07_JPRB, 0.23895970E-07_JPRB, 0.22858014E-07_JPRB, &
  & 0.23514741E-07_JPRB, 0.22930370E-07_JPRB, 0.22847983E-07_JPRB, 0.21417387E-07_JPRB, 0.21585984E-07_JPRB, 0.22155166E-07_JPRB, &
  & 0.23149046E-07_JPRB, 0.23894372E-07_JPRB, 0.24834228E-07_JPRB, 0.23809295E-07_JPRB  /)

RGHG7(:,89, 6) = (/ &
  & 0.61334919E-08_JPRB, 0.62520643E-08_JPRB, 0.58698363E-08_JPRB, 0.59631869E-08_JPRB, 0.60061748E-08_JPRB, 0.58219093E-08_JPRB, &
  & 0.56943869E-08_JPRB, 0.54777326E-08_JPRB, 0.54357063E-08_JPRB, 0.60451114E-08_JPRB, 0.68380326E-08_JPRB, 0.75431969E-08_JPRB, &
  & 0.82315947E-08_JPRB, 0.88569633E-08_JPRB, 0.94826798E-08_JPRB, 0.10190499E-07_JPRB, 0.11051708E-07_JPRB, 0.11900119E-07_JPRB, &
  & 0.12819738E-07_JPRB, 0.13502241E-07_JPRB, 0.14108368E-07_JPRB, 0.14674650E-07_JPRB, 0.15233386E-07_JPRB, 0.15687102E-07_JPRB, &
  & 0.15950878E-07_JPRB, 0.16239270E-07_JPRB, 0.16440701E-07_JPRB, 0.16670753E-07_JPRB, 0.16571262E-07_JPRB, 0.16265658E-07_JPRB, &
  & 0.15080579E-07_JPRB, 0.13445280E-07_JPRB, 0.12490248E-07_JPRB, 0.12360406E-07_JPRB, 0.13338562E-07_JPRB, 0.15573007E-07_JPRB, &
  & 0.17575876E-07_JPRB, 0.18802752E-07_JPRB, 0.20278293E-07_JPRB, 0.21619002E-07_JPRB, 0.23154298E-07_JPRB, 0.24995279E-07_JPRB, &
  & 0.28176695E-07_JPRB, 0.31003468E-07_JPRB, 0.32551211E-07_JPRB, 0.32775515E-07_JPRB, 0.32228190E-07_JPRB, 0.30441006E-07_JPRB, &
  & 0.29108916E-07_JPRB, 0.27418740E-07_JPRB, 0.26069847E-07_JPRB, 0.23995741E-07_JPRB, 0.22161011E-07_JPRB, 0.21147726E-07_JPRB, &
  & 0.22077848E-07_JPRB, 0.21522038E-07_JPRB, 0.21556246E-07_JPRB, 0.19830015E-07_JPRB, 0.20539447E-07_JPRB, 0.21258535E-07_JPRB, &
  & 0.22355747E-07_JPRB, 0.23010194E-07_JPRB, 0.24449668E-07_JPRB, 0.23390447E-07_JPRB  /)

RGHG7(:,90, 6) = (/ &
  & 0.55464804E-08_JPRB, 0.58132606E-08_JPRB, 0.53572282E-08_JPRB, 0.53462755E-08_JPRB, 0.54814013E-08_JPRB, 0.54586047E-08_JPRB, &
  & 0.54642243E-08_JPRB, 0.53586650E-08_JPRB, 0.53815011E-08_JPRB, 0.60071049E-08_JPRB, 0.68088512E-08_JPRB, 0.75149493E-08_JPRB, &
  & 0.81924359E-08_JPRB, 0.88177541E-08_JPRB, 0.94374472E-08_JPRB, 0.10141195E-07_JPRB, 0.10994177E-07_JPRB, 0.11832728E-07_JPRB, &
  & 0.12682469E-07_JPRB, 0.13280164E-07_JPRB, 0.13715994E-07_JPRB, 0.14201788E-07_JPRB, 0.14716295E-07_JPRB, 0.15124619E-07_JPRB, &
  & 0.15441728E-07_JPRB, 0.15804583E-07_JPRB, 0.16055168E-07_JPRB, 0.16362350E-07_JPRB, 0.16267291E-07_JPRB, 0.15864715E-07_JPRB, &
  & 0.14675792E-07_JPRB, 0.13098284E-07_JPRB, 0.12143408E-07_JPRB, 0.12048314E-07_JPRB, 0.12968804E-07_JPRB, 0.15179522E-07_JPRB, &
  & 0.17175051E-07_JPRB, 0.18179881E-07_JPRB, 0.19529351E-07_JPRB, 0.20822887E-07_JPRB, 0.22224377E-07_JPRB, 0.23765673E-07_JPRB, &
  & 0.26804222E-07_JPRB, 0.29088476E-07_JPRB, 0.30113606E-07_JPRB, 0.30136148E-07_JPRB, 0.29620847E-07_JPRB, 0.27639635E-07_JPRB, &
  & 0.26801688E-07_JPRB, 0.25149448E-07_JPRB, 0.24056869E-07_JPRB, 0.22084505E-07_JPRB, 0.20444885E-07_JPRB, 0.19437143E-07_JPRB, &
  & 0.20521203E-07_JPRB, 0.19899274E-07_JPRB, 0.20120209E-07_JPRB, 0.18354610E-07_JPRB, 0.19686246E-07_JPRB, 0.20442162E-07_JPRB, &
  & 0.21630373E-07_JPRB, 0.22003457E-07_JPRB, 0.24190642E-07_JPRB, 0.23122814E-07_JPRB  /)

RGHG7(:,91, 6) = (/ &
  & 0.52696772E-08_JPRB, 0.56030979E-08_JPRB, 0.48947834E-08_JPRB, 0.46765047E-08_JPRB, 0.49253425E-08_JPRB, 0.51125165E-08_JPRB, &
  & 0.52434837E-08_JPRB, 0.52849567E-08_JPRB, 0.53395264E-08_JPRB, 0.59725347E-08_JPRB, 0.67779832E-08_JPRB, 0.74830236E-08_JPRB, &
  & 0.81520479E-08_JPRB, 0.87757794E-08_JPRB, 0.93885969E-08_JPRB, 0.10085998E-07_JPRB, 0.10923642E-07_JPRB, 0.11756376E-07_JPRB, &
  & 0.12523080E-07_JPRB, 0.13039855E-07_JPRB, 0.13246674E-07_JPRB, 0.13650489E-07_JPRB, 0.14127974E-07_JPRB, 0.14523604E-07_JPRB, &
  & 0.14859753E-07_JPRB, 0.15221550E-07_JPRB, 0.15527141E-07_JPRB, 0.16039004E-07_JPRB, 0.15992074E-07_JPRB, 0.15491125E-07_JPRB, &
  & 0.14272584E-07_JPRB, 0.12732627E-07_JPRB, 0.11797849E-07_JPRB, 0.11715448E-07_JPRB, 0.12632765E-07_JPRB, 0.14812278E-07_JPRB, &
  & 0.16805163E-07_JPRB, 0.17490012E-07_JPRB, 0.18632156E-07_JPRB, 0.19933097E-07_JPRB, 0.21218759E-07_JPRB, 0.22630477E-07_JPRB, &
  & 0.25328947E-07_JPRB, 0.27285816E-07_JPRB, 0.27650887E-07_JPRB, 0.27352391E-07_JPRB, 0.27038070E-07_JPRB, 0.24857465E-07_JPRB, &
  & 0.24697030E-07_JPRB, 0.23203458E-07_JPRB, 0.22382730E-07_JPRB, 0.20506624E-07_JPRB, 0.19130923E-07_JPRB, 0.18145394E-07_JPRB, &
  & 0.19050160E-07_JPRB, 0.18296007E-07_JPRB, 0.18669263E-07_JPRB, 0.17187151E-07_JPRB, 0.18918101E-07_JPRB, 0.19660794E-07_JPRB, &
  & 0.20942090E-07_JPRB, 0.21137996E-07_JPRB, 0.23944515E-07_JPRB, 0.22879860E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ---GEMS----

RGHG7(:, 1, 7) = (/ &
  & 0.59957442E-05_JPRB, 0.59850381E-05_JPRB, 0.59779254E-05_JPRB, 0.59683130E-05_JPRB, 0.59596960E-05_JPRB, 0.59522563E-05_JPRB, &
  & 0.15696436E-06_JPRB, 0.65332387E-07_JPRB, 0.64335815E-07_JPRB, 0.63945464E-07_JPRB, 0.63894696E-07_JPRB, 0.64021691E-07_JPRB, &
  & 0.64368642E-07_JPRB, 0.64824128E-07_JPRB, 0.65442855E-07_JPRB, 0.66115341E-07_JPRB, 0.66771783E-07_JPRB, 0.67306431E-07_JPRB, &
  & 0.67799689E-07_JPRB, 0.68208081E-07_JPRB, 0.68526695E-07_JPRB, 0.68762560E-07_JPRB, 0.68925431E-07_JPRB, 0.68972469E-07_JPRB, &
  & 0.69080755E-07_JPRB, 0.69157174E-07_JPRB, 0.69194790E-07_JPRB, 0.69176970E-07_JPRB, 0.69059851E-07_JPRB, 0.68849587E-07_JPRB, &
  & 0.68590822E-07_JPRB, 0.68444074E-07_JPRB, 0.68490230E-07_JPRB, 0.68666225E-07_JPRB, 0.68946370E-07_JPRB, 0.69295830E-07_JPRB, &
  & 0.69661851E-07_JPRB, 0.70048934E-07_JPRB, 0.70348030E-07_JPRB, 0.70461773E-07_JPRB, 0.70543706E-07_JPRB, 0.70692202E-07_JPRB, &
  & 0.70670652E-07_JPRB, 0.70786534E-07_JPRB, 0.70676045E-07_JPRB, 0.70648120E-07_JPRB, 0.70444010E-07_JPRB, 0.70361885E-07_JPRB, &
  & 0.70228140E-07_JPRB, 0.69924830E-07_JPRB, 0.69914968E-07_JPRB, 0.69411591E-07_JPRB, 0.69469067E-07_JPRB, 0.68925836E-07_JPRB, &
  & 0.68941830E-07_JPRB, 0.68548339E-07_JPRB, 0.68627031E-07_JPRB, 0.68525168E-07_JPRB, 0.68790420E-07_JPRB, 0.69625528E-07_JPRB, &
  & 0.71002425E-07_JPRB, 0.73555761E-07_JPRB, 0.77142793E-07_JPRB, 0.81997648E-07_JPRB  /)

RGHG7(:, 2, 7) = (/ &
  & 0.64040678E-05_JPRB, 0.68253339E-05_JPRB, 0.71436807E-05_JPRB, 0.74664636E-05_JPRB, 0.79051624E-05_JPRB, 0.84502735E-05_JPRB, &
  & 0.14373812E-05_JPRB, 0.26034104E-06_JPRB, 0.24150239E-06_JPRB, 0.23815907E-06_JPRB, 0.24349441E-06_JPRB, 0.24572827E-06_JPRB, &
  & 0.24890485E-06_JPRB, 0.24686796E-06_JPRB, 0.24676018E-06_JPRB, 0.24502904E-06_JPRB, 0.24176981E-06_JPRB, 0.23604400E-06_JPRB, &
  & 0.23430759E-06_JPRB, 0.23452245E-06_JPRB, 0.23468445E-06_JPRB, 0.23446471E-06_JPRB, 0.23428682E-06_JPRB, 0.22945609E-06_JPRB, &
  & 0.23066590E-06_JPRB, 0.23246460E-06_JPRB, 0.23325926E-06_JPRB, 0.23294105E-06_JPRB, 0.22958470E-06_JPRB, 0.22370850E-06_JPRB, &
  & 0.21731877E-06_JPRB, 0.20653032E-06_JPRB, 0.20208691E-06_JPRB, 0.19960552E-06_JPRB, 0.19890886E-06_JPRB, 0.19992672E-06_JPRB, &
  & 0.20249077E-06_JPRB, 0.20672873E-06_JPRB, 0.21012447E-06_JPRB, 0.21083446E-06_JPRB, 0.21248376E-06_JPRB, 0.21617180E-06_JPRB, &
  & 0.21892765E-06_JPRB, 0.22445195E-06_JPRB, 0.22539936E-06_JPRB, 0.22798575E-06_JPRB, 0.22451891E-06_JPRB, 0.22857699E-06_JPRB, &
  & 0.22702847E-06_JPRB, 0.22719637E-06_JPRB, 0.22127433E-06_JPRB, 0.21609274E-06_JPRB, 0.20842327E-06_JPRB, 0.20095523E-06_JPRB, &
  & 0.19067424E-06_JPRB, 0.18347589E-06_JPRB, 0.18454828E-06_JPRB, 0.18576198E-06_JPRB, 0.18921894E-06_JPRB, 0.20400448E-06_JPRB, &
  & 0.22331790E-06_JPRB, 0.25038457E-06_JPRB, 0.27699292E-06_JPRB, 0.31938845E-06_JPRB  /)

RGHG7(:, 3, 7) = (/ &
  & 0.71273366E-05_JPRB, 0.76496681E-05_JPRB, 0.79419387E-05_JPRB, 0.81961716E-05_JPRB, 0.86201835E-05_JPRB, 0.87679527E-05_JPRB, &
  & 0.39827041E-05_JPRB, 0.63404258E-06_JPRB, 0.49247109E-06_JPRB, 0.45035051E-06_JPRB, 0.44926591E-06_JPRB, 0.45076501E-06_JPRB, &
  & 0.45436599E-06_JPRB, 0.44899787E-06_JPRB, 0.44773091E-06_JPRB, 0.44716455E-06_JPRB, 0.44695193E-06_JPRB, 0.43717043E-06_JPRB, &
  & 0.43666850E-06_JPRB, 0.43925655E-06_JPRB, 0.44341539E-06_JPRB, 0.44609422E-06_JPRB, 0.44743786E-06_JPRB, 0.43663363E-06_JPRB, &
  & 0.43818241E-06_JPRB, 0.44114935E-06_JPRB, 0.44165313E-06_JPRB, 0.43993478E-06_JPRB, 0.43628822E-06_JPRB, 0.43092138E-06_JPRB, &
  & 0.42313928E-06_JPRB, 0.40667553E-06_JPRB, 0.39843178E-06_JPRB, 0.39444615E-06_JPRB, 0.39305246E-06_JPRB, 0.39430040E-06_JPRB, &
  & 0.39685301E-06_JPRB, 0.40440369E-06_JPRB, 0.40755842E-06_JPRB, 0.40824750E-06_JPRB, 0.40685984E-06_JPRB, 0.41101876E-06_JPRB, &
  & 0.41481667E-06_JPRB, 0.42488523E-06_JPRB, 0.42610469E-06_JPRB, 0.43086567E-06_JPRB, 0.42436139E-06_JPRB, 0.43227143E-06_JPRB, &
  & 0.43376659E-06_JPRB, 0.43900346E-06_JPRB, 0.43305758E-06_JPRB, 0.43191625E-06_JPRB, 0.42688470E-06_JPRB, 0.42884810E-06_JPRB, &
  & 0.42741434E-06_JPRB, 0.43686489E-06_JPRB, 0.47727673E-06_JPRB, 0.49935613E-06_JPRB, 0.51032822E-06_JPRB, 0.54287790E-06_JPRB, &
  & 0.58363787E-06_JPRB, 0.63435880E-06_JPRB, 0.71612737E-06_JPRB, 0.80597175E-06_JPRB  /)

RGHG7(:, 4, 7) = (/ &
  & 0.52450817E-05_JPRB, 0.53042200E-05_JPRB, 0.52903499E-05_JPRB, 0.52160979E-05_JPRB, 0.51313807E-05_JPRB, 0.48403269E-05_JPRB, &
  & 0.39140297E-05_JPRB, 0.20196679E-05_JPRB, 0.17891024E-05_JPRB, 0.17560240E-05_JPRB, 0.17594251E-05_JPRB, 0.17418127E-05_JPRB, &
  & 0.16935701E-05_JPRB, 0.16104011E-05_JPRB, 0.15055664E-05_JPRB, 0.14062571E-05_JPRB, 0.13182456E-05_JPRB, 0.12430077E-05_JPRB, &
  & 0.11853917E-05_JPRB, 0.11493582E-05_JPRB, 0.11096317E-05_JPRB, 0.10520249E-05_JPRB, 0.98819152E-06_JPRB, 0.91419394E-06_JPRB, &
  & 0.86370376E-06_JPRB, 0.82370750E-06_JPRB, 0.79486200E-06_JPRB, 0.77845005E-06_JPRB, 0.77256380E-06_JPRB, 0.77724059E-06_JPRB, &
  & 0.78447112E-06_JPRB, 0.78504499E-06_JPRB, 0.78921528E-06_JPRB, 0.79853731E-06_JPRB, 0.81004442E-06_JPRB, 0.82509390E-06_JPRB, &
  & 0.83676119E-06_JPRB, 0.85016190E-06_JPRB, 0.85787295E-06_JPRB, 0.86029052E-06_JPRB, 0.85855526E-06_JPRB, 0.86318526E-06_JPRB, &
  & 0.87286114E-06_JPRB, 0.89026155E-06_JPRB, 0.89605639E-06_JPRB, 0.89796406E-06_JPRB, 0.88563112E-06_JPRB, 0.88169023E-06_JPRB, &
  & 0.86789515E-06_JPRB, 0.85444101E-06_JPRB, 0.83079971E-06_JPRB, 0.81042112E-06_JPRB, 0.78722885E-06_JPRB, 0.77150185E-06_JPRB, &
  & 0.75767484E-06_JPRB, 0.76032666E-06_JPRB, 0.75961045E-06_JPRB, 0.67865601E-06_JPRB, 0.55575100E-06_JPRB, 0.47952123E-06_JPRB, &
  & 0.44705747E-06_JPRB, 0.43843622E-06_JPRB, 0.41174079E-06_JPRB, 0.39235753E-06_JPRB  /)

RGHG7(:, 5, 7) = (/ &
  & 0.30098783E-05_JPRB, 0.29846431E-05_JPRB, 0.29521251E-05_JPRB, 0.29283415E-05_JPRB, 0.28957662E-05_JPRB, 0.28651468E-05_JPRB, &
  & 0.28438263E-05_JPRB, 0.28420636E-05_JPRB, 0.28850640E-05_JPRB, 0.29556117E-05_JPRB, 0.29894630E-05_JPRB, 0.29527039E-05_JPRB, &
  & 0.28398707E-05_JPRB, 0.26479708E-05_JPRB, 0.24101878E-05_JPRB, 0.21824820E-05_JPRB, 0.19963858E-05_JPRB, 0.18550934E-05_JPRB, &
  & 0.17413762E-05_JPRB, 0.16615594E-05_JPRB, 0.15773166E-05_JPRB, 0.14691656E-05_JPRB, 0.13503068E-05_JPRB, 0.12279822E-05_JPRB, &
  & 0.11297062E-05_JPRB, 0.10367707E-05_JPRB, 0.95870615E-06_JPRB, 0.89987507E-06_JPRB, 0.86344780E-06_JPRB, 0.85548844E-06_JPRB, &
  & 0.86057867E-06_JPRB, 0.87390147E-06_JPRB, 0.89429800E-06_JPRB, 0.91904612E-06_JPRB, 0.94421782E-06_JPRB, 0.97135802E-06_JPRB, &
  & 0.99481778E-06_JPRB, 0.10133392E-05_JPRB, 0.10287415E-05_JPRB, 0.10391382E-05_JPRB, 0.10472089E-05_JPRB, 0.10569090E-05_JPRB, &
  & 0.10743383E-05_JPRB, 0.10947940E-05_JPRB, 0.11080152E-05_JPRB, 0.11106200E-05_JPRB, 0.11052187E-05_JPRB, 0.10939082E-05_JPRB, &
  & 0.10737369E-05_JPRB, 0.10484654E-05_JPRB, 0.10188182E-05_JPRB, 0.98254610E-06_JPRB, 0.94286161E-06_JPRB, 0.90281463E-06_JPRB, &
  & 0.87527326E-06_JPRB, 0.88392579E-06_JPRB, 0.88692279E-06_JPRB, 0.75812308E-06_JPRB, 0.53295450E-06_JPRB, 0.35493942E-06_JPRB, &
  & 0.25447105E-06_JPRB, 0.19097190E-06_JPRB, 0.14587800E-06_JPRB, 0.12621416E-06_JPRB  /)

RGHG7(:, 6, 7) = (/ &
  & 0.30363126E-05_JPRB, 0.30095089E-05_JPRB, 0.29777560E-05_JPRB, 0.29518684E-05_JPRB, 0.29296219E-05_JPRB, 0.29051232E-05_JPRB, &
  & 0.28793652E-05_JPRB, 0.28773729E-05_JPRB, 0.29225921E-05_JPRB, 0.29931398E-05_JPRB, 0.30373198E-05_JPRB, 0.30071022E-05_JPRB, &
  & 0.29006958E-05_JPRB, 0.27061946E-05_JPRB, 0.24597660E-05_JPRB, 0.22272402E-05_JPRB, 0.20538445E-05_JPRB, 0.19305317E-05_JPRB, &
  & 0.18300506E-05_JPRB, 0.17599122E-05_JPRB, 0.16914686E-05_JPRB, 0.16101723E-05_JPRB, 0.15126977E-05_JPRB, 0.14137467E-05_JPRB, &
  & 0.13213236E-05_JPRB, 0.12223821E-05_JPRB, 0.11252668E-05_JPRB, 0.10351053E-05_JPRB, 0.96742404E-06_JPRB, 0.93555559E-06_JPRB, &
  & 0.93016406E-06_JPRB, 0.94161239E-06_JPRB, 0.96816790E-06_JPRB, 0.10003374E-05_JPRB, 0.10297554E-05_JPRB, 0.10580815E-05_JPRB, &
  & 0.10859405E-05_JPRB, 0.11101236E-05_JPRB, 0.11295809E-05_JPRB, 0.11446829E-05_JPRB, 0.11561965E-05_JPRB, 0.11680389E-05_JPRB, &
  & 0.11850091E-05_JPRB, 0.12037051E-05_JPRB, 0.12142867E-05_JPRB, 0.12162029E-05_JPRB, 0.12121023E-05_JPRB, 0.12037756E-05_JPRB, &
  & 0.11883479E-05_JPRB, 0.11681260E-05_JPRB, 0.11438727E-05_JPRB, 0.11124972E-05_JPRB, 0.10710530E-05_JPRB, 0.10219397E-05_JPRB, &
  & 0.98051189E-06_JPRB, 0.97868268E-06_JPRB, 0.99583386E-06_JPRB, 0.89587808E-06_JPRB, 0.68562878E-06_JPRB, 0.50447682E-06_JPRB, &
  & 0.38908917E-06_JPRB, 0.31449621E-06_JPRB, 0.26041249E-06_JPRB, 0.24315868E-06_JPRB  /)

RGHG7(:, 7, 7) = (/ &
  & 0.31258267E-05_JPRB, 0.30903713E-05_JPRB, 0.30575511E-05_JPRB, 0.30328417E-05_JPRB, 0.30147589E-05_JPRB, 0.29930703E-05_JPRB, &
  & 0.29650524E-05_JPRB, 0.29622411E-05_JPRB, 0.30188690E-05_JPRB, 0.31018560E-05_JPRB, 0.31673529E-05_JPRB, 0.31593419E-05_JPRB, &
  & 0.30742089E-05_JPRB, 0.28878407E-05_JPRB, 0.26519400E-05_JPRB, 0.24296688E-05_JPRB, 0.22664121E-05_JPRB, 0.21572790E-05_JPRB, &
  & 0.20714666E-05_JPRB, 0.20155234E-05_JPRB, 0.19646961E-05_JPRB, 0.19078171E-05_JPRB, 0.18402061E-05_JPRB, 0.17660829E-05_JPRB, &
  & 0.16963775E-05_JPRB, 0.16157238E-05_JPRB, 0.15320323E-05_JPRB, 0.14264052E-05_JPRB, 0.13118876E-05_JPRB, 0.12326792E-05_JPRB, &
  & 0.11918071E-05_JPRB, 0.11853061E-05_JPRB, 0.12079121E-05_JPRB, 0.12429935E-05_JPRB, 0.12791391E-05_JPRB, 0.13144465E-05_JPRB, &
  & 0.13496229E-05_JPRB, 0.13791681E-05_JPRB, 0.14034922E-05_JPRB, 0.14225516E-05_JPRB, 0.14379265E-05_JPRB, 0.14510404E-05_JPRB, &
  & 0.14653688E-05_JPRB, 0.14780913E-05_JPRB, 0.14831826E-05_JPRB, 0.14819871E-05_JPRB, 0.14734927E-05_JPRB, 0.14613660E-05_JPRB, &
  & 0.14420886E-05_JPRB, 0.14193708E-05_JPRB, 0.13953777E-05_JPRB, 0.13668526E-05_JPRB, 0.13272913E-05_JPRB, 0.12754198E-05_JPRB, &
  & 0.12180941E-05_JPRB, 0.11880733E-05_JPRB, 0.12009967E-05_JPRB, 0.11439916E-05_JPRB, 0.98584243E-06_JPRB, 0.83277935E-06_JPRB, &
  & 0.72421434E-06_JPRB, 0.65394479E-06_JPRB, 0.59973284E-06_JPRB, 0.58859067E-06_JPRB  /)

RGHG7(:, 8, 7) = (/ &
  & 0.32768339E-05_JPRB, 0.32432307E-05_JPRB, 0.32038665E-05_JPRB, 0.31720502E-05_JPRB, 0.31531207E-05_JPRB, 0.31410402E-05_JPRB, &
  & 0.31144979E-05_JPRB, 0.31166730E-05_JPRB, 0.31913771E-05_JPRB, 0.32991524E-05_JPRB, 0.33982669E-05_JPRB, 0.34227507E-05_JPRB, &
  & 0.33631892E-05_JPRB, 0.31960015E-05_JPRB, 0.29852690E-05_JPRB, 0.27871160E-05_JPRB, 0.26394225E-05_JPRB, 0.25419813E-05_JPRB, &
  & 0.24627789E-05_JPRB, 0.24094494E-05_JPRB, 0.23633078E-05_JPRB, 0.23180341E-05_JPRB, 0.22741203E-05_JPRB, 0.22258609E-05_JPRB, &
  & 0.21856255E-05_JPRB, 0.21338742E-05_JPRB, 0.20803162E-05_JPRB, 0.19933778E-05_JPRB, 0.18852399E-05_JPRB, 0.18021608E-05_JPRB, &
  & 0.17490112E-05_JPRB, 0.17321032E-05_JPRB, 0.17447494E-05_JPRB, 0.17701572E-05_JPRB, 0.17995127E-05_JPRB, 0.18310361E-05_JPRB, &
  & 0.18623342E-05_JPRB, 0.18854080E-05_JPRB, 0.19045230E-05_JPRB, 0.19190327E-05_JPRB, 0.19316928E-05_JPRB, 0.19390419E-05_JPRB, &
  & 0.19437161E-05_JPRB, 0.19421216E-05_JPRB, 0.19346351E-05_JPRB, 0.19223562E-05_JPRB, 0.19025764E-05_JPRB, 0.18799576E-05_JPRB, &
  & 0.18504938E-05_JPRB, 0.18182179E-05_JPRB, 0.17858653E-05_JPRB, 0.17525351E-05_JPRB, 0.17102037E-05_JPRB, 0.16562056E-05_JPRB, &
  & 0.15904211E-05_JPRB, 0.15382384E-05_JPRB, 0.15410315E-05_JPRB, 0.15221382E-05_JPRB, 0.14288268E-05_JPRB, 0.13197329E-05_JPRB, &
  & 0.12312202E-05_JPRB, 0.11746415E-05_JPRB, 0.11251754E-05_JPRB, 0.11197162E-05_JPRB  /)

RGHG7(:, 9, 7) = (/ &
  & 0.34657323E-05_JPRB, 0.34494903E-05_JPRB, 0.34125947E-05_JPRB, 0.33734168E-05_JPRB, 0.33456251E-05_JPRB, 0.33431780E-05_JPRB, &
  & 0.33292968E-05_JPRB, 0.33513751E-05_JPRB, 0.34568182E-05_JPRB, 0.36109000E-05_JPRB, 0.37686686E-05_JPRB, 0.38565244E-05_JPRB, &
  & 0.38502509E-05_JPRB, 0.37387274E-05_JPRB, 0.35834814E-05_JPRB, 0.34209228E-05_JPRB, 0.32839712E-05_JPRB, 0.31777547E-05_JPRB, &
  & 0.30785210E-05_JPRB, 0.30014255E-05_JPRB, 0.29364918E-05_JPRB, 0.28831372E-05_JPRB, 0.28472930E-05_JPRB, 0.28173373E-05_JPRB, &
  & 0.28036431E-05_JPRB, 0.27820130E-05_JPRB, 0.27710181E-05_JPRB, 0.27440635E-05_JPRB, 0.27098073E-05_JPRB, 0.26897405E-05_JPRB, &
  & 0.26762196E-05_JPRB, 0.26756271E-05_JPRB, 0.26785017E-05_JPRB, 0.26767955E-05_JPRB, 0.26735259E-05_JPRB, 0.26770668E-05_JPRB, &
  & 0.26829380E-05_JPRB, 0.26817719E-05_JPRB, 0.26814628E-05_JPRB, 0.26783075E-05_JPRB, 0.26757947E-05_JPRB, 0.26674942E-05_JPRB, &
  & 0.26555226E-05_JPRB, 0.26324857E-05_JPRB, 0.26032161E-05_JPRB, 0.25676870E-05_JPRB, 0.25268066E-05_JPRB, 0.24849191E-05_JPRB, &
  & 0.24373353E-05_JPRB, 0.23867860E-05_JPRB, 0.23341410E-05_JPRB, 0.22826027E-05_JPRB, 0.22275247E-05_JPRB, 0.21687257E-05_JPRB, &
  & 0.21047696E-05_JPRB, 0.20461785E-05_JPRB, 0.20397397E-05_JPRB, 0.20425393E-05_JPRB, 0.20057985E-05_JPRB, 0.19431618E-05_JPRB, &
  & 0.18816907E-05_JPRB, 0.18431362E-05_JPRB, 0.18024092E-05_JPRB, 0.18001929E-05_JPRB  /)

RGHG7(:,10, 7) = (/ &
  & 0.35924649E-05_JPRB, 0.35781798E-05_JPRB, 0.35638233E-05_JPRB, 0.35414543E-05_JPRB, 0.35182059E-05_JPRB, 0.35292621E-05_JPRB, &
  & 0.35438571E-05_JPRB, 0.36106576E-05_JPRB, 0.37695510E-05_JPRB, 0.40090369E-05_JPRB, 0.42870631E-05_JPRB, 0.45361273E-05_JPRB, &
  & 0.46912919E-05_JPRB, 0.47351386E-05_JPRB, 0.46927280E-05_JPRB, 0.45557921E-05_JPRB, 0.43828627E-05_JPRB, 0.42078875E-05_JPRB, &
  & 0.40381637E-05_JPRB, 0.39019236E-05_JPRB, 0.37949128E-05_JPRB, 0.37145348E-05_JPRB, 0.36655653E-05_JPRB, 0.36301463E-05_JPRB, &
  & 0.36231022E-05_JPRB, 0.36125098E-05_JPRB, 0.36335853E-05_JPRB, 0.36652363E-05_JPRB, 0.36995394E-05_JPRB, 0.37500551E-05_JPRB, &
  & 0.38009676E-05_JPRB, 0.38387160E-05_JPRB, 0.38435236E-05_JPRB, 0.38132821E-05_JPRB, 0.37671576E-05_JPRB, 0.37325773E-05_JPRB, &
  & 0.37053515E-05_JPRB, 0.36776128E-05_JPRB, 0.36551860E-05_JPRB, 0.36309469E-05_JPRB, 0.36076747E-05_JPRB, 0.35798258E-05_JPRB, &
  & 0.35502747E-05_JPRB, 0.35067365E-05_JPRB, 0.34529087E-05_JPRB, 0.33871184E-05_JPRB, 0.33175768E-05_JPRB, 0.32492807E-05_JPRB, &
  & 0.31753090E-05_JPRB, 0.30990831E-05_JPRB, 0.30194209E-05_JPRB, 0.29415321E-05_JPRB, 0.28676517E-05_JPRB, 0.27999019E-05_JPRB, &
  & 0.27347651E-05_JPRB, 0.26727450E-05_JPRB, 0.26586555E-05_JPRB, 0.26681887E-05_JPRB, 0.26666135E-05_JPRB, 0.26388118E-05_JPRB, &
  & 0.26002810E-05_JPRB, 0.25753550E-05_JPRB, 0.25454217E-05_JPRB, 0.25452589E-05_JPRB  /)

RGHG7(:,11, 7) = (/ &
  & 0.36441344E-05_JPRB, 0.36106666E-05_JPRB, 0.36209039E-05_JPRB, 0.36425388E-05_JPRB, 0.36637267E-05_JPRB, 0.37141476E-05_JPRB, &
  & 0.37664750E-05_JPRB, 0.38792786E-05_JPRB, 0.40822024E-05_JPRB, 0.44155170E-05_JPRB, 0.48540102E-05_JPRB, 0.53588832E-05_JPRB, &
  & 0.58194575E-05_JPRB, 0.61531383E-05_JPRB, 0.62899581E-05_JPRB, 0.61680022E-05_JPRB, 0.59106982E-05_JPRB, 0.56249832E-05_JPRB, &
  & 0.53653470E-05_JPRB, 0.51621667E-05_JPRB, 0.50113480E-05_JPRB, 0.48969256E-05_JPRB, 0.48186001E-05_JPRB, 0.47552577E-05_JPRB, &
  & 0.47295687E-05_JPRB, 0.47007483E-05_JPRB, 0.47102920E-05_JPRB, 0.47407931E-05_JPRB, 0.47731416E-05_JPRB, 0.48220929E-05_JPRB, &
  & 0.48841547E-05_JPRB, 0.49339703E-05_JPRB, 0.49429859E-05_JPRB, 0.49036662E-05_JPRB, 0.48418909E-05_JPRB, 0.47984615E-05_JPRB, &
  & 0.47642911E-05_JPRB, 0.47332001E-05_JPRB, 0.47041760E-05_JPRB, 0.46732240E-05_JPRB, 0.46390892E-05_JPRB, 0.45935233E-05_JPRB, &
  & 0.45443901E-05_JPRB, 0.44816485E-05_JPRB, 0.44091582E-05_JPRB, 0.43204273E-05_JPRB, 0.42251406E-05_JPRB, 0.41322215E-05_JPRB, &
  & 0.40314896E-05_JPRB, 0.39310939E-05_JPRB, 0.38313867E-05_JPRB, 0.37375816E-05_JPRB, 0.36539958E-05_JPRB, 0.35786950E-05_JPRB, &
  & 0.34984395E-05_JPRB, 0.34156208E-05_JPRB, 0.33795961E-05_JPRB, 0.33817043E-05_JPRB, 0.34020937E-05_JPRB, 0.34013393E-05_JPRB, &
  & 0.33847490E-05_JPRB, 0.33745695E-05_JPRB, 0.33597456E-05_JPRB, 0.33664896E-05_JPRB  /)

RGHG7(:,12, 7) = (/ &
  & 0.38921918E-05_JPRB, 0.38820456E-05_JPRB, 0.39143916E-05_JPRB, 0.39748476E-05_JPRB, 0.40312042E-05_JPRB, 0.40981578E-05_JPRB, &
  & 0.41777994E-05_JPRB, 0.42969187E-05_JPRB, 0.44809822E-05_JPRB, 0.48077120E-05_JPRB, 0.53015329E-05_JPRB, 0.59650330E-05_JPRB, &
  & 0.66987071E-05_JPRB, 0.73260117E-05_JPRB, 0.76582718E-05_JPRB, 0.76120748E-05_JPRB, 0.73603877E-05_JPRB, 0.70612047E-05_JPRB, &
  & 0.68004751E-05_JPRB, 0.66018418E-05_JPRB, 0.64598229E-05_JPRB, 0.63521466E-05_JPRB, 0.62729557E-05_JPRB, 0.62035642E-05_JPRB, &
  & 0.61612801E-05_JPRB, 0.61140648E-05_JPRB, 0.60885744E-05_JPRB, 0.60727328E-05_JPRB, 0.60568975E-05_JPRB, 0.60506581E-05_JPRB, &
  & 0.60577210E-05_JPRB, 0.60590224E-05_JPRB, 0.60350965E-05_JPRB, 0.59854787E-05_JPRB, 0.59275609E-05_JPRB, 0.58978053E-05_JPRB, &
  & 0.58807460E-05_JPRB, 0.58658024E-05_JPRB, 0.58448229E-05_JPRB, 0.58133570E-05_JPRB, 0.57678763E-05_JPRB, 0.57008446E-05_JPRB, &
  & 0.56255113E-05_JPRB, 0.55410712E-05_JPRB, 0.54516733E-05_JPRB, 0.53515419E-05_JPRB, 0.52428310E-05_JPRB, 0.51411383E-05_JPRB, &
  & 0.50337555E-05_JPRB, 0.49294299E-05_JPRB, 0.48280680E-05_JPRB, 0.47338929E-05_JPRB, 0.46505148E-05_JPRB, 0.45666648E-05_JPRB, &
  & 0.44646929E-05_JPRB, 0.43487599E-05_JPRB, 0.42737012E-05_JPRB, 0.42481469E-05_JPRB, 0.42603606E-05_JPRB, 0.42686052E-05_JPRB, &
  & 0.42752833E-05_JPRB, 0.42881239E-05_JPRB, 0.42912441E-05_JPRB, 0.43129739E-05_JPRB  /)

RGHG7(:,13, 7) = (/ &
  & 0.43240981E-05_JPRB, 0.43359160E-05_JPRB, 0.43639052E-05_JPRB, 0.44227862E-05_JPRB, 0.44844285E-05_JPRB, 0.45362003E-05_JPRB, &
  & 0.45997151E-05_JPRB, 0.46997768E-05_JPRB, 0.48426670E-05_JPRB, 0.50930242E-05_JPRB, 0.55357717E-05_JPRB, 0.62127691E-05_JPRB, &
  & 0.70406195E-05_JPRB, 0.77942123E-05_JPRB, 0.82362826E-05_JPRB, 0.83155866E-05_JPRB, 0.81914806E-05_JPRB, 0.79995205E-05_JPRB, &
  & 0.78311274E-05_JPRB, 0.77131037E-05_JPRB, 0.76409121E-05_JPRB, 0.75907482E-05_JPRB, 0.75569558E-05_JPRB, 0.75216833E-05_JPRB, &
  & 0.74891428E-05_JPRB, 0.74490144E-05_JPRB, 0.74126232E-05_JPRB, 0.73659764E-05_JPRB, 0.73087706E-05_JPRB, 0.72508146E-05_JPRB, &
  & 0.71895610E-05_JPRB, 0.71198882E-05_JPRB, 0.70501634E-05_JPRB, 0.70051754E-05_JPRB, 0.69804788E-05_JPRB, 0.69936406E-05_JPRB, &
  & 0.70188220E-05_JPRB, 0.70335198E-05_JPRB, 0.70237313E-05_JPRB, 0.69834022E-05_JPRB, 0.69212887E-05_JPRB, 0.68361492E-05_JPRB, &
  & 0.67406721E-05_JPRB, 0.66400005E-05_JPRB, 0.65395514E-05_JPRB, 0.64387677E-05_JPRB, 0.63358332E-05_JPRB, 0.62497868E-05_JPRB, &
  & 0.61638575E-05_JPRB, 0.60780264E-05_JPRB, 0.59873710E-05_JPRB, 0.58939583E-05_JPRB, 0.58009258E-05_JPRB, 0.56892971E-05_JPRB, &
  & 0.55392948E-05_JPRB, 0.53674765E-05_JPRB, 0.52370263E-05_JPRB, 0.51716704E-05_JPRB, 0.51389836E-05_JPRB, 0.51274034E-05_JPRB, &
  & 0.51410125E-05_JPRB, 0.51692660E-05_JPRB, 0.51864294E-05_JPRB, 0.52315685E-05_JPRB  /)

RGHG7(:,14, 7) = (/ &
  & 0.46176883E-05_JPRB, 0.46252653E-05_JPRB, 0.46330655E-05_JPRB, 0.46637737E-05_JPRB, 0.46983725E-05_JPRB, 0.47174215E-05_JPRB, &
  & 0.47488164E-05_JPRB, 0.48126846E-05_JPRB, 0.49168511E-05_JPRB, 0.51001408E-05_JPRB, 0.54556367E-05_JPRB, 0.60679131E-05_JPRB, &
  & 0.68478306E-05_JPRB, 0.75763155E-05_JPRB, 0.80590106E-05_JPRB, 0.82574386E-05_JPRB, 0.82717240E-05_JPRB, 0.81966849E-05_JPRB, &
  & 0.81248848E-05_JPRB, 0.80890646E-05_JPRB, 0.80819449E-05_JPRB, 0.80898818E-05_JPRB, 0.81104762E-05_JPRB, 0.81260375E-05_JPRB, &
  & 0.81338481E-05_JPRB, 0.81382101E-05_JPRB, 0.81412202E-05_JPRB, 0.81288007E-05_JPRB, 0.80918864E-05_JPRB, 0.80382186E-05_JPRB, &
  & 0.79691232E-05_JPRB, 0.78945869E-05_JPRB, 0.78456157E-05_JPRB, 0.78480892E-05_JPRB, 0.78815190E-05_JPRB, 0.79552921E-05_JPRB, &
  & 0.80362809E-05_JPRB, 0.80784042E-05_JPRB, 0.80728301E-05_JPRB, 0.80190943E-05_JPRB, 0.79445377E-05_JPRB, 0.78585322E-05_JPRB, &
  & 0.77613624E-05_JPRB, 0.76567873E-05_JPRB, 0.75567538E-05_JPRB, 0.74647634E-05_JPRB, 0.73788898E-05_JPRB, 0.73153663E-05_JPRB, &
  & 0.72510840E-05_JPRB, 0.71751779E-05_JPRB, 0.70780588E-05_JPRB, 0.69586883E-05_JPRB, 0.68242614E-05_JPRB, 0.66571186E-05_JPRB, &
  & 0.64297846E-05_JPRB, 0.61806048E-05_JPRB, 0.59869635E-05_JPRB, 0.58788795E-05_JPRB, 0.57910143E-05_JPRB, 0.57409267E-05_JPRB, &
  & 0.57341342E-05_JPRB, 0.57616612E-05_JPRB, 0.57940805E-05_JPRB, 0.58605077E-05_JPRB  /)

RGHG7(:,15, 7) = (/ &
  & 0.46434877E-05_JPRB, 0.46328121E-05_JPRB, 0.46271171E-05_JPRB, 0.46297433E-05_JPRB, 0.46288716E-05_JPRB, 0.46205653E-05_JPRB, &
  & 0.46225530E-05_JPRB, 0.46439857E-05_JPRB, 0.46975957E-05_JPRB, 0.48175850E-05_JPRB, 0.50793663E-05_JPRB, 0.55690482E-05_JPRB, &
  & 0.62062873E-05_JPRB, 0.68318705E-05_JPRB, 0.73375393E-05_JPRB, 0.76670346E-05_JPRB, 0.78452281E-05_JPRB, 0.79092319E-05_JPRB, &
  & 0.79452264E-05_JPRB, 0.79872742E-05_JPRB, 0.80313317E-05_JPRB, 0.80865533E-05_JPRB, 0.81539846E-05_JPRB, 0.82141058E-05_JPRB, &
  & 0.82661924E-05_JPRB, 0.83242793E-05_JPRB, 0.83856387E-05_JPRB, 0.84457437E-05_JPRB, 0.84827761E-05_JPRB, 0.84926398E-05_JPRB, &
  & 0.84828461E-05_JPRB, 0.84713898E-05_JPRB, 0.84955681E-05_JPRB, 0.85550199E-05_JPRB, 0.86236417E-05_JPRB, 0.87211302E-05_JPRB, &
  & 0.88216884E-05_JPRB, 0.88587132E-05_JPRB, 0.88365166E-05_JPRB, 0.87688437E-05_JPRB, 0.86921193E-05_JPRB, 0.86161366E-05_JPRB, &
  & 0.85266033E-05_JPRB, 0.84269181E-05_JPRB, 0.83315517E-05_JPRB, 0.82430786E-05_JPRB, 0.81595430E-05_JPRB, 0.80873500E-05_JPRB, &
  & 0.80001425E-05_JPRB, 0.78892210E-05_JPRB, 0.77469777E-05_JPRB, 0.75715426E-05_JPRB, 0.73738181E-05_JPRB, 0.71474249E-05_JPRB, &
  & 0.68624317E-05_JPRB, 0.65587248E-05_JPRB, 0.63140783E-05_JPRB, 0.61634783E-05_JPRB, 0.60308376E-05_JPRB, 0.59457137E-05_JPRB, &
  & 0.59096975E-05_JPRB, 0.59175661E-05_JPRB, 0.59491443E-05_JPRB, 0.60050128E-05_JPRB  /)

RGHG7(:,16, 7) = (/ &
  & 0.44921265E-05_JPRB, 0.44756974E-05_JPRB, 0.44629569E-05_JPRB, 0.44473043E-05_JPRB, 0.44235987E-05_JPRB, 0.43942417E-05_JPRB, &
  & 0.43677545E-05_JPRB, 0.43545409E-05_JPRB, 0.43636313E-05_JPRB, 0.44279703E-05_JPRB, 0.45924427E-05_JPRB, 0.49166386E-05_JPRB, &
  & 0.53660993E-05_JPRB, 0.58673939E-05_JPRB, 0.63631565E-05_JPRB, 0.67928086E-05_JPRB, 0.71173654E-05_JPRB, 0.73356374E-05_JPRB, &
  & 0.75172113E-05_JPRB, 0.76723361E-05_JPRB, 0.77932900E-05_JPRB, 0.79164141E-05_JPRB, 0.80359285E-05_JPRB, 0.81475089E-05_JPRB, &
  & 0.82467692E-05_JPRB, 0.83540454E-05_JPRB, 0.84756140E-05_JPRB, 0.86127359E-05_JPRB, 0.87585030E-05_JPRB, 0.89005407E-05_JPRB, &
  & 0.90296503E-05_JPRB, 0.91195620E-05_JPRB, 0.91882523E-05_JPRB, 0.92305627E-05_JPRB, 0.92473763E-05_JPRB, 0.92877260E-05_JPRB, &
  & 0.93363690E-05_JPRB, 0.93339407E-05_JPRB, 0.92873279E-05_JPRB, 0.92108722E-05_JPRB, 0.91375041E-05_JPRB, 0.90659636E-05_JPRB, &
  & 0.89698278E-05_JPRB, 0.88595037E-05_JPRB, 0.87485006E-05_JPRB, 0.86356048E-05_JPRB, 0.85174510E-05_JPRB, 0.83992136E-05_JPRB, &
  & 0.82538316E-05_JPRB, 0.80910107E-05_JPRB, 0.79043836E-05_JPRB, 0.76841828E-05_JPRB, 0.74483823E-05_JPRB, 0.71902868E-05_JPRB, &
  & 0.68772980E-05_JPRB, 0.65548458E-05_JPRB, 0.62913580E-05_JPRB, 0.61123272E-05_JPRB, 0.59461854E-05_JPRB, 0.58331327E-05_JPRB, &
  & 0.57822266E-05_JPRB, 0.57751153E-05_JPRB, 0.57921649E-05_JPRB, 0.58084215E-05_JPRB  /)

RGHG7(:,17, 7) = (/ &
  & 0.43172132E-05_JPRB, 0.43049954E-05_JPRB, 0.42871781E-05_JPRB, 0.42653432E-05_JPRB, 0.42370923E-05_JPRB, 0.41947759E-05_JPRB, &
  & 0.41517459E-05_JPRB, 0.41224282E-05_JPRB, 0.41079895E-05_JPRB, 0.41311842E-05_JPRB, 0.42164028E-05_JPRB, 0.44017552E-05_JPRB, &
  & 0.46941373E-05_JPRB, 0.50794091E-05_JPRB, 0.55186700E-05_JPRB, 0.59602430E-05_JPRB, 0.63515227E-05_JPRB, 0.66807175E-05_JPRB, &
  & 0.69877419E-05_JPRB, 0.72515797E-05_JPRB, 0.74501222E-05_JPRB, 0.76338438E-05_JPRB, 0.77973012E-05_JPRB, 0.79554988E-05_JPRB, &
  & 0.81056527E-05_JPRB, 0.82558001E-05_JPRB, 0.84257206E-05_JPRB, 0.86253223E-05_JPRB, 0.88804870E-05_JPRB, 0.91881747E-05_JPRB, &
  & 0.94879919E-05_JPRB, 0.96842612E-05_JPRB, 0.97462540E-05_JPRB, 0.97112951E-05_JPRB, 0.96428172E-05_JPRB, 0.96074812E-05_JPRB, &
  & 0.95940924E-05_JPRB, 0.95529634E-05_JPRB, 0.94873933E-05_JPRB, 0.94057339E-05_JPRB, 0.93299687E-05_JPRB, 0.92438561E-05_JPRB, &
  & 0.91219811E-05_JPRB, 0.89842260E-05_JPRB, 0.88431417E-05_JPRB, 0.86987889E-05_JPRB, 0.85479208E-05_JPRB, 0.83974263E-05_JPRB, &
  & 0.82188523E-05_JPRB, 0.80264633E-05_JPRB, 0.78132356E-05_JPRB, 0.75723777E-05_JPRB, 0.73180464E-05_JPRB, 0.70419222E-05_JPRB, &
  & 0.67114216E-05_JPRB, 0.63677138E-05_JPRB, 0.60967193E-05_JPRB, 0.59041043E-05_JPRB, 0.57176564E-05_JPRB, 0.55758668E-05_JPRB, &
  & 0.55039953E-05_JPRB, 0.54710576E-05_JPRB, 0.54655883E-05_JPRB, 0.54709459E-05_JPRB  /)

RGHG7(:,18, 7) = (/ &
  & 0.41818985E-05_JPRB, 0.41784642E-05_JPRB, 0.41649204E-05_JPRB, 0.41426466E-05_JPRB, 0.41174903E-05_JPRB, 0.40796094E-05_JPRB, &
  & 0.40344089E-05_JPRB, 0.40018417E-05_JPRB, 0.39827002E-05_JPRB, 0.39916123E-05_JPRB, 0.40436556E-05_JPRB, 0.41661530E-05_JPRB, &
  & 0.43818905E-05_JPRB, 0.46946552E-05_JPRB, 0.50612558E-05_JPRB, 0.54439919E-05_JPRB, 0.58164992E-05_JPRB, 0.61761534E-05_JPRB, &
  & 0.65286393E-05_JPRB, 0.68408990E-05_JPRB, 0.70830287E-05_JPRB, 0.72902706E-05_JPRB, 0.74779898E-05_JPRB, 0.76636486E-05_JPRB, &
  & 0.78489759E-05_JPRB, 0.80281804E-05_JPRB, 0.82281073E-05_JPRB, 0.84719793E-05_JPRB, 0.87925827E-05_JPRB, 0.91998835E-05_JPRB, &
  & 0.96071014E-05_JPRB, 0.98617265E-05_JPRB, 0.99134333E-05_JPRB, 0.98442332E-05_JPRB, 0.97473355E-05_JPRB, 0.96902749E-05_JPRB, &
  & 0.96572894E-05_JPRB, 0.96021887E-05_JPRB, 0.95288549E-05_JPRB, 0.94458109E-05_JPRB, 0.93635820E-05_JPRB, 0.92617225E-05_JPRB, &
  & 0.91176980E-05_JPRB, 0.89539087E-05_JPRB, 0.87823525E-05_JPRB, 0.86047234E-05_JPRB, 0.84255336E-05_JPRB, 0.82523431E-05_JPRB, &
  & 0.80598866E-05_JPRB, 0.78522781E-05_JPRB, 0.76328387E-05_JPRB, 0.73974580E-05_JPRB, 0.71468474E-05_JPRB, 0.68660656E-05_JPRB, &
  & 0.65372520E-05_JPRB, 0.61760021E-05_JPRB, 0.58753148E-05_JPRB, 0.56610045E-05_JPRB, 0.54531996E-05_JPRB, 0.52727373E-05_JPRB, &
  & 0.51539622E-05_JPRB, 0.50770551E-05_JPRB, 0.50496317E-05_JPRB, 0.50498277E-05_JPRB  /)

RGHG7(:,19, 7) = (/ &
  & 0.40552402E-05_JPRB, 0.40567398E-05_JPRB, 0.40479010E-05_JPRB, 0.40293529E-05_JPRB, 0.40112917E-05_JPRB, 0.39848803E-05_JPRB, &
  & 0.39488652E-05_JPRB, 0.39253180E-05_JPRB, 0.39176592E-05_JPRB, 0.39392121E-05_JPRB, 0.39993571E-05_JPRB, 0.41193491E-05_JPRB, &
  & 0.43190129E-05_JPRB, 0.46016170E-05_JPRB, 0.49186018E-05_JPRB, 0.52386724E-05_JPRB, 0.55565091E-05_JPRB, 0.58812021E-05_JPRB, &
  & 0.62031006E-05_JPRB, 0.64953228E-05_JPRB, 0.67373760E-05_JPRB, 0.69420925E-05_JPRB, 0.71253852E-05_JPRB, 0.73168421E-05_JPRB, &
  & 0.75118074E-05_JPRB, 0.77170253E-05_JPRB, 0.79510841E-05_JPRB, 0.82220847E-05_JPRB, 0.85596290E-05_JPRB, 0.89916442E-05_JPRB, &
  & 0.94400093E-05_JPRB, 0.96966619E-05_JPRB, 0.97406887E-05_JPRB, 0.96817040E-05_JPRB, 0.96049009E-05_JPRB, 0.95650867E-05_JPRB, &
  & 0.95491785E-05_JPRB, 0.95083199E-05_JPRB, 0.94407694E-05_JPRB, 0.93593412E-05_JPRB, 0.92674439E-05_JPRB, 0.91475598E-05_JPRB, &
  & 0.89845260E-05_JPRB, 0.88002410E-05_JPRB, 0.86038747E-05_JPRB, 0.83983078E-05_JPRB, 0.81964396E-05_JPRB, 0.80049940E-05_JPRB, &
  & 0.78046359E-05_JPRB, 0.75877592E-05_JPRB, 0.73679783E-05_JPRB, 0.71377877E-05_JPRB, 0.68886707E-05_JPRB, 0.66120637E-05_JPRB, &
  & 0.62913975E-05_JPRB, 0.59277785E-05_JPRB, 0.56065177E-05_JPRB, 0.53638111E-05_JPRB, 0.51344053E-05_JPRB, 0.49265490E-05_JPRB, &
  & 0.47566737E-05_JPRB, 0.46307327E-05_JPRB, 0.45822882E-05_JPRB, 0.45712780E-05_JPRB  /)

RGHG7(:,20, 7) = (/ &
  & 0.39018413E-05_JPRB, 0.39039629E-05_JPRB, 0.38983074E-05_JPRB, 0.38860076E-05_JPRB, 0.38757231E-05_JPRB, 0.38618497E-05_JPRB, &
  & 0.38442441E-05_JPRB, 0.38389734E-05_JPRB, 0.38564592E-05_JPRB, 0.39116410E-05_JPRB, 0.40075985E-05_JPRB, 0.41586314E-05_JPRB, &
  & 0.43737471E-05_JPRB, 0.46488881E-05_JPRB, 0.49335816E-05_JPRB, 0.52026732E-05_JPRB, 0.54619101E-05_JPRB, 0.57247296E-05_JPRB, &
  & 0.59833302E-05_JPRB, 0.62219269E-05_JPRB, 0.64368019E-05_JPRB, 0.66184125E-05_JPRB, 0.67782220E-05_JPRB, 0.69534678E-05_JPRB, &
  & 0.71417109E-05_JPRB, 0.73623298E-05_JPRB, 0.76107866E-05_JPRB, 0.78789516E-05_JPRB, 0.81948989E-05_JPRB, 0.86039348E-05_JPRB, &
  & 0.90312550E-05_JPRB, 0.92563524E-05_JPRB, 0.93057308E-05_JPRB, 0.92836846E-05_JPRB, 0.92421627E-05_JPRB, 0.92316159E-05_JPRB, &
  & 0.92436282E-05_JPRB, 0.92279442E-05_JPRB, 0.91725930E-05_JPRB, 0.90915526E-05_JPRB, 0.89890518E-05_JPRB, 0.88595983E-05_JPRB, &
  & 0.86930273E-05_JPRB, 0.85085714E-05_JPRB, 0.83077662E-05_JPRB, 0.80892058E-05_JPRB, 0.78732023E-05_JPRB, 0.76692932E-05_JPRB, &
  & 0.74662492E-05_JPRB, 0.72477087E-05_JPRB, 0.70274097E-05_JPRB, 0.67926380E-05_JPRB, 0.65339580E-05_JPRB, 0.62592776E-05_JPRB, &
  & 0.59459540E-05_JPRB, 0.55990216E-05_JPRB, 0.52828030E-05_JPRB, 0.50276462E-05_JPRB, 0.47899101E-05_JPRB, 0.45729892E-05_JPRB, &
  & 0.43702300E-05_JPRB, 0.42058483E-05_JPRB, 0.41224943E-05_JPRB, 0.40859401E-05_JPRB  /)

RGHG7(:,21, 7) = (/ &
  & 0.37203233E-05_JPRB, 0.37208924E-05_JPRB, 0.37179172E-05_JPRB, 0.37119597E-05_JPRB, 0.37080976E-05_JPRB, 0.37053602E-05_JPRB, &
  & 0.37096269E-05_JPRB, 0.37273603E-05_JPRB, 0.37784593E-05_JPRB, 0.38797093E-05_JPRB, 0.40265028E-05_JPRB, 0.42223641E-05_JPRB, &
  & 0.44638509E-05_JPRB, 0.47385820E-05_JPRB, 0.49992302E-05_JPRB, 0.52276253E-05_JPRB, 0.54354073E-05_JPRB, 0.56337080E-05_JPRB, &
  & 0.58255990E-05_JPRB, 0.60046881E-05_JPRB, 0.61811900E-05_JPRB, 0.63288454E-05_JPRB, 0.64555235E-05_JPRB, 0.66003416E-05_JPRB, &
  & 0.67713772E-05_JPRB, 0.69867732E-05_JPRB, 0.72161206E-05_JPRB, 0.74504970E-05_JPRB, 0.77202563E-05_JPRB, 0.80780592E-05_JPRB, &
  & 0.84328965E-05_JPRB, 0.86105052E-05_JPRB, 0.86783219E-05_JPRB, 0.87036704E-05_JPRB, 0.86955006E-05_JPRB, 0.87115011E-05_JPRB, &
  & 0.87441523E-05_JPRB, 0.87478478E-05_JPRB, 0.87029508E-05_JPRB, 0.86203291E-05_JPRB, 0.85107744E-05_JPRB, 0.83866558E-05_JPRB, &
  & 0.82373701E-05_JPRB, 0.80768678E-05_JPRB, 0.78958663E-05_JPRB, 0.76844172E-05_JPRB, 0.74674833E-05_JPRB, 0.72616488E-05_JPRB, &
  & 0.70652194E-05_JPRB, 0.68554865E-05_JPRB, 0.66371312E-05_JPRB, 0.63935883E-05_JPRB, 0.61200023E-05_JPRB, 0.58422098E-05_JPRB, &
  & 0.55346712E-05_JPRB, 0.52173898E-05_JPRB, 0.49274581E-05_JPRB, 0.46806843E-05_JPRB, 0.44528090E-05_JPRB, 0.42441346E-05_JPRB, &
  & 0.40337613E-05_JPRB, 0.38515402E-05_JPRB, 0.37329406E-05_JPRB, 0.36641583E-05_JPRB  /)

RGHG7(:,22, 7) = (/ &
  & 0.35269295E-05_JPRB, 0.35264849E-05_JPRB, 0.35275648E-05_JPRB, 0.35249528E-05_JPRB, 0.35244362E-05_JPRB, 0.35298091E-05_JPRB, &
  & 0.35512088E-05_JPRB, 0.35915497E-05_JPRB, 0.36783339E-05_JPRB, 0.38289554E-05_JPRB, 0.40303920E-05_JPRB, 0.42694407E-05_JPRB, &
  & 0.45323184E-05_JPRB, 0.48015750E-05_JPRB, 0.50405282E-05_JPRB, 0.52346572E-05_JPRB, 0.54020906E-05_JPRB, 0.55501073E-05_JPRB, &
  & 0.56928297E-05_JPRB, 0.58287315E-05_JPRB, 0.59691425E-05_JPRB, 0.60846609E-05_JPRB, 0.61759579E-05_JPRB, 0.62874224E-05_JPRB, &
  & 0.64323022E-05_JPRB, 0.66086675E-05_JPRB, 0.67762751E-05_JPRB, 0.69489120E-05_JPRB, 0.71612909E-05_JPRB, 0.74502577E-05_JPRB, &
  & 0.76903342E-05_JPRB, 0.78165440E-05_JPRB, 0.79109218E-05_JPRB, 0.79791536E-05_JPRB, 0.79938954E-05_JPRB, 0.80243930E-05_JPRB, &
  & 0.80553208E-05_JPRB, 0.80555693E-05_JPRB, 0.80104696E-05_JPRB, 0.79255162E-05_JPRB, 0.78190029E-05_JPRB, 0.77204317E-05_JPRB, &
  & 0.76124071E-05_JPRB, 0.74998570E-05_JPRB, 0.73632593E-05_JPRB, 0.71846570E-05_JPRB, 0.69877961E-05_JPRB, 0.67985877E-05_JPRB, &
  & 0.66252726E-05_JPRB, 0.64390596E-05_JPRB, 0.62322614E-05_JPRB, 0.59880089E-05_JPRB, 0.57063126E-05_JPRB, 0.54219304E-05_JPRB, &
  & 0.51204746E-05_JPRB, 0.48357358E-05_JPRB, 0.45813880E-05_JPRB, 0.43601616E-05_JPRB, 0.41621930E-05_JPRB, 0.39773427E-05_JPRB, &
  & 0.37875493E-05_JPRB, 0.36188115E-05_JPRB, 0.34970691E-05_JPRB, 0.34059835E-05_JPRB  /)

RGHG7(:,23, 7) = (/ &
  & 0.33682708E-05_JPRB, 0.33689217E-05_JPRB, 0.33685632E-05_JPRB, 0.33680216E-05_JPRB, 0.33713093E-05_JPRB, 0.33812247E-05_JPRB, &
  & 0.34090705E-05_JPRB, 0.34632481E-05_JPRB, 0.35721568E-05_JPRB, 0.37541056E-05_JPRB, 0.39874634E-05_JPRB, 0.42454493E-05_JPRB, &
  & 0.45043656E-05_JPRB, 0.47444977E-05_JPRB, 0.49500395E-05_JPRB, 0.51122444E-05_JPRB, 0.52467054E-05_JPRB, 0.53614776E-05_JPRB, &
  & 0.54742261E-05_JPRB, 0.55830859E-05_JPRB, 0.56946333E-05_JPRB, 0.57821770E-05_JPRB, 0.58481579E-05_JPRB, 0.59276801E-05_JPRB, &
  & 0.60339687E-05_JPRB, 0.61578328E-05_JPRB, 0.62662685E-05_JPRB, 0.63828382E-05_JPRB, 0.65315765E-05_JPRB, 0.67308140E-05_JPRB, &
  & 0.68804237E-05_JPRB, 0.69833035E-05_JPRB, 0.70997861E-05_JPRB, 0.71799047E-05_JPRB, 0.71949693E-05_JPRB, 0.72172613E-05_JPRB, &
  & 0.72259386E-05_JPRB, 0.71959603E-05_JPRB, 0.71366443E-05_JPRB, 0.70552589E-05_JPRB, 0.69688057E-05_JPRB, 0.69046848E-05_JPRB, &
  & 0.68429206E-05_JPRB, 0.67818604E-05_JPRB, 0.66936514E-05_JPRB, 0.65556843E-05_JPRB, 0.63959633E-05_JPRB, 0.62459259E-05_JPRB, &
  & 0.61128352E-05_JPRB, 0.59674165E-05_JPRB, 0.57927264E-05_JPRB, 0.55774260E-05_JPRB, 0.53209048E-05_JPRB, 0.50523528E-05_JPRB, &
  & 0.47637999E-05_JPRB, 0.44955895E-05_JPRB, 0.42675886E-05_JPRB, 0.40747641E-05_JPRB, 0.39107689E-05_JPRB, 0.37611020E-05_JPRB, &
  & 0.36073766E-05_JPRB, 0.34793106E-05_JPRB, 0.34069317E-05_JPRB, 0.33397046E-05_JPRB  /)

RGHG7(:,24, 7) = (/ &
  & 0.32285077E-05_JPRB, 0.32314049E-05_JPRB, 0.32293520E-05_JPRB, 0.32304516E-05_JPRB, 0.32378692E-05_JPRB, 0.32523767E-05_JPRB, &
  & 0.32832620E-05_JPRB, 0.33455421E-05_JPRB, 0.34660646E-05_JPRB, 0.36632870E-05_JPRB, 0.39111082E-05_JPRB, 0.41714637E-05_JPRB, &
  & 0.44100092E-05_JPRB, 0.46085899E-05_JPRB, 0.47733509E-05_JPRB, 0.49008489E-05_JPRB, 0.50032629E-05_JPRB, 0.50889911E-05_JPRB, &
  & 0.51726629E-05_JPRB, 0.52531558E-05_JPRB, 0.53331194E-05_JPRB, 0.53928094E-05_JPRB, 0.54354320E-05_JPRB, 0.54835718E-05_JPRB, &
  & 0.55477858E-05_JPRB, 0.56172664E-05_JPRB, 0.56736311E-05_JPRB, 0.57412369E-05_JPRB, 0.58306390E-05_JPRB, 0.59504230E-05_JPRB, &
  & 0.60350498E-05_JPRB, 0.61282234E-05_JPRB, 0.62541009E-05_JPRB, 0.63315458E-05_JPRB, 0.63434076E-05_JPRB, 0.63518023E-05_JPRB, &
  & 0.63329798E-05_JPRB, 0.62714154E-05_JPRB, 0.61996375E-05_JPRB, 0.61264995E-05_JPRB, 0.60647875E-05_JPRB, 0.60344897E-05_JPRB, &
  & 0.60169681E-05_JPRB, 0.60039076E-05_JPRB, 0.59612482E-05_JPRB, 0.58636502E-05_JPRB, 0.57443811E-05_JPRB, 0.56378492E-05_JPRB, &
  & 0.55470610E-05_JPRB, 0.54456813E-05_JPRB, 0.53084531E-05_JPRB, 0.51304006E-05_JPRB, 0.49133996E-05_JPRB, 0.46737426E-05_JPRB, &
  & 0.44061454E-05_JPRB, 0.41547233E-05_JPRB, 0.39494190E-05_JPRB, 0.37818047E-05_JPRB, 0.36490208E-05_JPRB, 0.35367583E-05_JPRB, &
  & 0.34239557E-05_JPRB, 0.33404545E-05_JPRB, 0.33216584E-05_JPRB, 0.32885036E-05_JPRB  /)

RGHG7(:,25, 7) = (/ &
  & 0.31207031E-05_JPRB, 0.31273104E-05_JPRB, 0.31244211E-05_JPRB, 0.31266144E-05_JPRB, 0.31384498E-05_JPRB, 0.31582329E-05_JPRB, &
  & 0.31883891E-05_JPRB, 0.32502188E-05_JPRB, 0.33662592E-05_JPRB, 0.35536809E-05_JPRB, 0.37894927E-05_JPRB, 0.40282095E-05_JPRB, &
  & 0.42239282E-05_JPRB, 0.43661285E-05_JPRB, 0.44815217E-05_JPRB, 0.45704176E-05_JPRB, 0.46422074E-05_JPRB, 0.47038093E-05_JPRB, &
  & 0.47569855E-05_JPRB, 0.48044093E-05_JPRB, 0.48477652E-05_JPRB, 0.48801336E-05_JPRB, 0.49016537E-05_JPRB, 0.49204989E-05_JPRB, &
  & 0.49411569E-05_JPRB, 0.49583960E-05_JPRB, 0.49770379E-05_JPRB, 0.50091942E-05_JPRB, 0.50509656E-05_JPRB, 0.51177790E-05_JPRB, &
  & 0.51800381E-05_JPRB, 0.52817685E-05_JPRB, 0.53951004E-05_JPRB, 0.54511640E-05_JPRB, 0.54588010E-05_JPRB, 0.54489455E-05_JPRB, &
  & 0.53991771E-05_JPRB, 0.53110630E-05_JPRB, 0.52336449E-05_JPRB, 0.51753472E-05_JPRB, 0.51417290E-05_JPRB, 0.51406186E-05_JPRB, &
  & 0.51606482E-05_JPRB, 0.51864472E-05_JPRB, 0.51813604E-05_JPRB, 0.51200913E-05_JPRB, 0.50414830E-05_JPRB, 0.49791075E-05_JPRB, &
  & 0.49285512E-05_JPRB, 0.48710921E-05_JPRB, 0.47745032E-05_JPRB, 0.46400497E-05_JPRB, 0.44787214E-05_JPRB, 0.42847649E-05_JPRB, &
  & 0.40499152E-05_JPRB, 0.38185875E-05_JPRB, 0.36305684E-05_JPRB, 0.34807325E-05_JPRB, 0.33719462E-05_JPRB, 0.32967845E-05_JPRB, &
  & 0.32281813E-05_JPRB, 0.31880216E-05_JPRB, 0.32160627E-05_JPRB, 0.32231613E-05_JPRB  /)

RGHG7(:,26, 7) = (/ &
  & 0.30222167E-05_JPRB, 0.30317944E-05_JPRB, 0.30345493E-05_JPRB, 0.30413027E-05_JPRB, 0.30561101E-05_JPRB, 0.30794219E-05_JPRB, &
  & 0.31090623E-05_JPRB, 0.31634274E-05_JPRB, 0.32633680E-05_JPRB, 0.34220092E-05_JPRB, 0.36248100E-05_JPRB, 0.38223013E-05_JPRB, &
  & 0.39676518E-05_JPRB, 0.40566491E-05_JPRB, 0.41238046E-05_JPRB, 0.41752071E-05_JPRB, 0.42185572E-05_JPRB, 0.42507928E-05_JPRB, &
  & 0.42678278E-05_JPRB, 0.42769745E-05_JPRB, 0.42854502E-05_JPRB, 0.42899963E-05_JPRB, 0.42880137E-05_JPRB, 0.42790499E-05_JPRB, &
  & 0.42613484E-05_JPRB, 0.42395154E-05_JPRB, 0.42320059E-05_JPRB, 0.42477185E-05_JPRB, 0.42759889E-05_JPRB, 0.43276984E-05_JPRB, &
  & 0.43911233E-05_JPRB, 0.44900642E-05_JPRB, 0.45866687E-05_JPRB, 0.46330093E-05_JPRB, 0.46420833E-05_JPRB, 0.46244406E-05_JPRB, &
  & 0.45611171E-05_JPRB, 0.44659817E-05_JPRB, 0.43931762E-05_JPRB, 0.43516839E-05_JPRB, 0.43416468E-05_JPRB, 0.43660003E-05_JPRB, &
  & 0.44123625E-05_JPRB, 0.44610219E-05_JPRB, 0.44805355E-05_JPRB, 0.44514388E-05_JPRB, 0.44070836E-05_JPRB, 0.43784283E-05_JPRB, &
  & 0.43586857E-05_JPRB, 0.43326314E-05_JPRB, 0.42699581E-05_JPRB, 0.41740448E-05_JPRB, 0.40610155E-05_JPRB, 0.39163358E-05_JPRB, &
  & 0.37266724E-05_JPRB, 0.35317368E-05_JPRB, 0.33710811E-05_JPRB, 0.32442802E-05_JPRB, 0.31583276E-05_JPRB, 0.31099245E-05_JPRB, &
  & 0.30691612E-05_JPRB, 0.30552395E-05_JPRB, 0.31011584E-05_JPRB, 0.31235282E-05_JPRB  /)

RGHG7(:,27, 7) = (/ &
  & 0.29227021E-05_JPRB, 0.29351112E-05_JPRB, 0.29461702E-05_JPRB, 0.29589766E-05_JPRB, 0.29763553E-05_JPRB, 0.30027085E-05_JPRB, &
  & 0.30318887E-05_JPRB, 0.30758487E-05_JPRB, 0.31546489E-05_JPRB, 0.32761618E-05_JPRB, 0.34366618E-05_JPRB, 0.35837883E-05_JPRB, &
  & 0.36736816E-05_JPRB, 0.37082320E-05_JPRB, 0.37253729E-05_JPRB, 0.37379863E-05_JPRB, 0.37524122E-05_JPRB, 0.37520017E-05_JPRB, &
  & 0.37291571E-05_JPRB, 0.36963532E-05_JPRB, 0.36690012E-05_JPRB, 0.36442729E-05_JPRB, 0.36168278E-05_JPRB, 0.35793400E-05_JPRB, &
  & 0.35234597E-05_JPRB, 0.34656590E-05_JPRB, 0.34350981E-05_JPRB, 0.34406658E-05_JPRB, 0.34674755E-05_JPRB, 0.35174341E-05_JPRB, &
  & 0.35908039E-05_JPRB, 0.36826213E-05_JPRB, 0.37601864E-05_JPRB, 0.38006842E-05_JPRB, 0.38133599E-05_JPRB, 0.37914551E-05_JPRB, &
  & 0.37204078E-05_JPRB, 0.36251723E-05_JPRB, 0.35609911E-05_JPRB, 0.35377978E-05_JPRB, 0.35507420E-05_JPRB, 0.36003379E-05_JPRB, &
  & 0.36700716E-05_JPRB, 0.37366999E-05_JPRB, 0.37771238E-05_JPRB, 0.37801229E-05_JPRB, 0.37692042E-05_JPRB, 0.37719343E-05_JPRB, &
  & 0.37809158E-05_JPRB, 0.37830554E-05_JPRB, 0.37533483E-05_JPRB, 0.36958538E-05_JPRB, 0.36305880E-05_JPRB, 0.35387544E-05_JPRB, &
  & 0.34009465E-05_JPRB, 0.32501026E-05_JPRB, 0.31217928E-05_JPRB, 0.30210247E-05_JPRB, 0.29585137E-05_JPRB, 0.29342525E-05_JPRB, &
  & 0.29165305E-05_JPRB, 0.29236991E-05_JPRB, 0.29775719E-05_JPRB, 0.30066451E-05_JPRB  /)

RGHG7(:,28, 7) = (/ &
  & 0.29115442E-05_JPRB, 0.29197156E-05_JPRB, 0.29297813E-05_JPRB, 0.29413234E-05_JPRB, 0.29509847E-05_JPRB, 0.29649663E-05_JPRB, &
  & 0.29788816E-05_JPRB, 0.29979978E-05_JPRB, 0.30421701E-05_JPRB, 0.31191888E-05_JPRB, 0.32294552E-05_JPRB, 0.33282307E-05_JPRB, &
  & 0.33800305E-05_JPRB, 0.33819967E-05_JPRB, 0.33680639E-05_JPRB, 0.33550913E-05_JPRB, 0.33452734E-05_JPRB, 0.33189456E-05_JPRB, &
  & 0.32684719E-05_JPRB, 0.32065297E-05_JPRB, 0.31524299E-05_JPRB, 0.31023070E-05_JPRB, 0.30567383E-05_JPRB, 0.30023263E-05_JPRB, &
  & 0.29249509E-05_JPRB, 0.28479829E-05_JPRB, 0.28054688E-05_JPRB, 0.28088199E-05_JPRB, 0.28401205E-05_JPRB, 0.28925251E-05_JPRB, &
  & 0.29730087E-05_JPRB, 0.30631932E-05_JPRB, 0.31349470E-05_JPRB, 0.31786097E-05_JPRB, 0.31917673E-05_JPRB, 0.31718280E-05_JPRB, &
  & 0.31065193E-05_JPRB, 0.30279377E-05_JPRB, 0.29809691E-05_JPRB, 0.29762153E-05_JPRB, 0.30074427E-05_JPRB, 0.30736264E-05_JPRB, &
  & 0.31518898E-05_JPRB, 0.32208678E-05_JPRB, 0.32669608E-05_JPRB, 0.32877715E-05_JPRB, 0.33005187E-05_JPRB, 0.33232818E-05_JPRB, &
  & 0.33506229E-05_JPRB, 0.33717736E-05_JPRB, 0.33672328E-05_JPRB, 0.33383061E-05_JPRB, 0.33005644E-05_JPRB, 0.32464809E-05_JPRB, &
  & 0.31556136E-05_JPRB, 0.30530153E-05_JPRB, 0.29624299E-05_JPRB, 0.28920916E-05_JPRB, 0.28495086E-05_JPRB, 0.28301389E-05_JPRB, &
  & 0.28151653E-05_JPRB, 0.28244993E-05_JPRB, 0.28724433E-05_JPRB, 0.28935714E-05_JPRB  /)

RGHG7(:,29, 7) = (/ &
  & 0.29035526E-05_JPRB, 0.29069271E-05_JPRB, 0.29155374E-05_JPRB, 0.29254225E-05_JPRB, 0.29264605E-05_JPRB, 0.29266650E-05_JPRB, &
  & 0.29237640E-05_JPRB, 0.29159302E-05_JPRB, 0.29228264E-05_JPRB, 0.29523805E-05_JPRB, 0.30090764E-05_JPRB, 0.30567072E-05_JPRB, &
  & 0.30688966E-05_JPRB, 0.30372851E-05_JPRB, 0.29912485E-05_JPRB, 0.29517377E-05_JPRB, 0.29164345E-05_JPRB, 0.28629370E-05_JPRB, &
  & 0.27837189E-05_JPRB, 0.26914580E-05_JPRB, 0.26094103E-05_JPRB, 0.25325479E-05_JPRB, 0.24680941E-05_JPRB, 0.23962524E-05_JPRB, &
  & 0.22968245E-05_JPRB, 0.22002756E-05_JPRB, 0.21455772E-05_JPRB, 0.21469236E-05_JPRB, 0.21832407E-05_JPRB, 0.22384190E-05_JPRB, &
  & 0.23263176E-05_JPRB, 0.24150099E-05_JPRB, 0.24811796E-05_JPRB, 0.25285864E-05_JPRB, 0.25421193E-05_JPRB, 0.25245327E-05_JPRB, &
  & 0.24658883E-05_JPRB, 0.24056792E-05_JPRB, 0.23773211E-05_JPRB, 0.23921115E-05_JPRB, 0.24425079E-05_JPRB, 0.25258924E-05_JPRB, &
  & 0.26125502E-05_JPRB, 0.26833408E-05_JPRB, 0.27347799E-05_JPRB, 0.27738441E-05_JPRB, 0.28112436E-05_JPRB, 0.28547410E-05_JPRB, &
  & 0.29010863E-05_JPRB, 0.29419827E-05_JPRB, 0.29637694E-05_JPRB, 0.29646855E-05_JPRB, 0.29552304E-05_JPRB, 0.29404917E-05_JPRB, &
  & 0.28991488E-05_JPRB, 0.28478507E-05_JPRB, 0.27974707E-05_JPRB, 0.27595658E-05_JPRB, 0.27379461E-05_JPRB, 0.27229246E-05_JPRB, &
  & 0.27099832E-05_JPRB, 0.27207910E-05_JPRB, 0.27618511E-05_JPRB, 0.27739257E-05_JPRB  /)

RGHG7(:,30, 7) = (/ &
  & 0.28021517E-05_JPRB, 0.28021202E-05_JPRB, 0.28068449E-05_JPRB, 0.28169377E-05_JPRB, 0.28172361E-05_JPRB, 0.28132063E-05_JPRB, &
  & 0.28035430E-05_JPRB, 0.27809523E-05_JPRB, 0.27630059E-05_JPRB, 0.27589506E-05_JPRB, 0.27785576E-05_JPRB, 0.27958970E-05_JPRB, &
  & 0.27889273E-05_JPRB, 0.27480536E-05_JPRB, 0.26892980E-05_JPRB, 0.26328916E-05_JPRB, 0.25770024E-05_JPRB, 0.25112167E-05_JPRB, &
  & 0.24212450E-05_JPRB, 0.23151167E-05_JPRB, 0.22142743E-05_JPRB, 0.21225827E-05_JPRB, 0.20447786E-05_JPRB, 0.19660294E-05_JPRB, &
  & 0.18705301E-05_JPRB, 0.17755076E-05_JPRB, 0.17195035E-05_JPRB, 0.17158863E-05_JPRB, 0.17443108E-05_JPRB, 0.17958246E-05_JPRB, &
  & 0.18803844E-05_JPRB, 0.19632129E-05_JPRB, 0.20215529E-05_JPRB, 0.20605432E-05_JPRB, 0.20698867E-05_JPRB, 0.20544332E-05_JPRB, &
  & 0.20131170E-05_JPRB, 0.19771062E-05_JPRB, 0.19691831E-05_JPRB, 0.19976301E-05_JPRB, 0.20564796E-05_JPRB, 0.21382390E-05_JPRB, &
  & 0.22191545E-05_JPRB, 0.22849447E-05_JPRB, 0.23383990E-05_JPRB, 0.23880627E-05_JPRB, 0.24407076E-05_JPRB, 0.24995032E-05_JPRB, &
  & 0.25592552E-05_JPRB, 0.26130444E-05_JPRB, 0.26517346E-05_JPRB, 0.26737954E-05_JPRB, 0.26830550E-05_JPRB, 0.26872500E-05_JPRB, &
  & 0.26723852E-05_JPRB, 0.26501724E-05_JPRB, 0.26251202E-05_JPRB, 0.26070032E-05_JPRB, 0.25967494E-05_JPRB, 0.25864283E-05_JPRB, &
  & 0.25756037E-05_JPRB, 0.25830916E-05_JPRB, 0.26131844E-05_JPRB, 0.26246638E-05_JPRB  /)

RGHG7(:,31, 7) = (/ &
  & 0.26952216E-05_JPRB, 0.26916027E-05_JPRB, 0.26922311E-05_JPRB, 0.27025444E-05_JPRB, 0.27020711E-05_JPRB, 0.26935887E-05_JPRB, &
  & 0.26768099E-05_JPRB, 0.26386821E-05_JPRB, 0.25945720E-05_JPRB, 0.25551173E-05_JPRB, 0.25356611E-05_JPRB, 0.25211037E-05_JPRB, &
  & 0.24939663E-05_JPRB, 0.24433564E-05_JPRB, 0.23712180E-05_JPRB, 0.22970185E-05_JPRB, 0.22194436E-05_JPRB, 0.21407244E-05_JPRB, &
  & 0.20394391E-05_JPRB, 0.19187151E-05_JPRB, 0.17980782E-05_JPRB, 0.16907732E-05_JPRB, 0.15989077E-05_JPRB, 0.15128903E-05_JPRB, &
  & 0.14215552E-05_JPRB, 0.13281610E-05_JPRB, 0.12707915E-05_JPRB, 0.12619415E-05_JPRB, 0.12820378E-05_JPRB, 0.13296842E-05_JPRB, &
  & 0.14107160E-05_JPRB, 0.14873619E-05_JPRB, 0.15374499E-05_JPRB, 0.15675607E-05_JPRB, 0.15724856E-05_JPRB, 0.15592796E-05_JPRB, &
  & 0.15362313E-05_JPRB, 0.15257227E-05_JPRB, 0.15393327E-05_JPRB, 0.15821634E-05_JPRB, 0.16499094E-05_JPRB, 0.17299387E-05_JPRB, &
  & 0.18047903E-05_JPRB, 0.18653053E-05_JPRB, 0.19208799E-05_JPRB, 0.19817045E-05_JPRB, 0.20504038E-05_JPRB, 0.21253132E-05_JPRB, &
  & 0.21991860E-05_JPRB, 0.22665531E-05_JPRB, 0.23230448E-05_JPRB, 0.23673766E-05_JPRB, 0.23963459E-05_JPRB, 0.24204712E-05_JPRB, &
  & 0.24334832E-05_JPRB, 0.24418951E-05_JPRB, 0.24435154E-05_JPRB, 0.24462361E-05_JPRB, 0.24479489E-05_JPRB, 0.24425806E-05_JPRB, &
  & 0.24339866E-05_JPRB, 0.24379718E-05_JPRB, 0.24565051E-05_JPRB, 0.24673654E-05_JPRB  /)

RGHG7(:,32, 7) = (/ &
  & 0.25542204E-05_JPRB, 0.25456846E-05_JPRB, 0.25402474E-05_JPRB, 0.25429252E-05_JPRB, 0.25403320E-05_JPRB, 0.25310696E-05_JPRB, &
  & 0.25134752E-05_JPRB, 0.24665944E-05_JPRB, 0.24084989E-05_JPRB, 0.23492838E-05_JPRB, 0.23076134E-05_JPRB, 0.22764692E-05_JPRB, &
  & 0.22424962E-05_JPRB, 0.21936478E-05_JPRB, 0.21214195E-05_JPRB, 0.20390227E-05_JPRB, 0.19512899E-05_JPRB, 0.18669189E-05_JPRB, &
  & 0.17634654E-05_JPRB, 0.16380934E-05_JPRB, 0.15098565E-05_JPRB, 0.13965346E-05_JPRB, 0.13002303E-05_JPRB, 0.12142270E-05_JPRB, &
  & 0.11315319E-05_JPRB, 0.10517128E-05_JPRB, 0.99787856E-06_JPRB, 0.98175845E-06_JPRB, 0.99125134E-06_JPRB, 0.10304681E-05_JPRB, &
  & 0.10987521E-05_JPRB, 0.11636124E-05_JPRB, 0.12046758E-05_JPRB, 0.12292561E-05_JPRB, 0.12366544E-05_JPRB, 0.12320673E-05_JPRB, &
  & 0.12238912E-05_JPRB, 0.12287694E-05_JPRB, 0.12526160E-05_JPRB, 0.12979685E-05_JPRB, 0.13596683E-05_JPRB, 0.14274631E-05_JPRB, &
  & 0.14925630E-05_JPRB, 0.15503773E-05_JPRB, 0.16087264E-05_JPRB, 0.16747061E-05_JPRB, 0.17501813E-05_JPRB, 0.18351774E-05_JPRB, &
  & 0.19192575E-05_JPRB, 0.19956932E-05_JPRB, 0.20634827E-05_JPRB, 0.21201262E-05_JPRB, 0.21621202E-05_JPRB, 0.21958265E-05_JPRB, &
  & 0.22211296E-05_JPRB, 0.22426012E-05_JPRB, 0.22563791E-05_JPRB, 0.22686995E-05_JPRB, 0.22797119E-05_JPRB, 0.22834943E-05_JPRB, &
  & 0.22834763E-05_JPRB, 0.22893128E-05_JPRB, 0.23036163E-05_JPRB, 0.23154320E-05_JPRB  /)

RGHG7(:,33, 7) = (/ &
  & 0.24032741E-05_JPRB, 0.23894563E-05_JPRB, 0.23774605E-05_JPRB, 0.23711860E-05_JPRB, 0.23662150E-05_JPRB, 0.23566176E-05_JPRB, &
  & 0.23389913E-05_JPRB, 0.22838923E-05_JPRB, 0.22128390E-05_JPRB, 0.21351130E-05_JPRB, 0.20725380E-05_JPRB, 0.20261382E-05_JPRB, &
  & 0.19867875E-05_JPRB, 0.19412583E-05_JPRB, 0.18706577E-05_JPRB, 0.17809842E-05_JPRB, 0.16841874E-05_JPRB, 0.15948854E-05_JPRB, &
  & 0.14903628E-05_JPRB, 0.13614481E-05_JPRB, 0.12268920E-05_JPRB, 0.11085593E-05_JPRB, 0.10088880E-05_JPRB, 0.92384212E-06_JPRB, &
  & 0.85070575E-06_JPRB, 0.78654113E-06_JPRB, 0.73701549E-06_JPRB, 0.71307609E-06_JPRB, 0.71125496E-06_JPRB, 0.74112053E-06_JPRB, &
  & 0.79496280E-06_JPRB, 0.84684945E-06_JPRB, 0.87843390E-06_JPRB, 0.89770031E-06_JPRB, 0.90856148E-06_JPRB, 0.91375645E-06_JPRB, &
  & 0.92059650E-06_JPRB, 0.94015590E-06_JPRB, 0.97317812E-06_JPRB, 0.10196158E-05_JPRB, 0.10730974E-05_JPRB, 0.11268174E-05_JPRB, &
  & 0.11813055E-05_JPRB, 0.12366463E-05_JPRB, 0.12979635E-05_JPRB, 0.13685231E-05_JPRB, 0.14498389E-05_JPRB, 0.15445372E-05_JPRB, &
  & 0.16387186E-05_JPRB, 0.17239948E-05_JPRB, 0.18026834E-05_JPRB, 0.18708324E-05_JPRB, 0.19254969E-05_JPRB, 0.19678204E-05_JPRB, &
  & 0.20038790E-05_JPRB, 0.20366486E-05_JPRB, 0.20611820E-05_JPRB, 0.20820239E-05_JPRB, 0.21023556E-05_JPRB, 0.21161914E-05_JPRB, &
  & 0.21259076E-05_JPRB, 0.21343611E-05_JPRB, 0.21452177E-05_JPRB, 0.21582303E-05_JPRB  /)

RGHG7(:,34, 7) = (/ &
  & 0.22362030E-05_JPRB, 0.22175234E-05_JPRB, 0.22010286E-05_JPRB, 0.21877096E-05_JPRB, 0.21815243E-05_JPRB, 0.21742075E-05_JPRB, &
  & 0.21592223E-05_JPRB, 0.21027803E-05_JPRB, 0.20254050E-05_JPRB, 0.19396234E-05_JPRB, 0.18654577E-05_JPRB, 0.18110197E-05_JPRB, &
  & 0.17693694E-05_JPRB, 0.17280101E-05_JPRB, 0.16626398E-05_JPRB, 0.15719560E-05_JPRB, 0.14742743E-05_JPRB, 0.13831097E-05_JPRB, &
  & 0.12775394E-05_JPRB, 0.11488864E-05_JPRB, 0.10144458E-05_JPRB, 0.89638559E-06_JPRB, 0.79691904E-06_JPRB, 0.71461307E-06_JPRB, &
  & 0.64916503E-06_JPRB, 0.59665897E-06_JPRB, 0.55413057E-06_JPRB, 0.52885607E-06_JPRB, 0.52203837E-06_JPRB, 0.54303569E-06_JPRB, &
  & 0.58312521E-06_JPRB, 0.62229552E-06_JPRB, 0.64671780E-06_JPRB, 0.66409012E-06_JPRB, 0.67892880E-06_JPRB, 0.69247255E-06_JPRB, &
  & 0.70937516E-06_JPRB, 0.73477353E-06_JPRB, 0.76793955E-06_JPRB, 0.80897399E-06_JPRB, 0.85313826E-06_JPRB, 0.89660003E-06_JPRB, &
  & 0.94372161E-06_JPRB, 0.99682659E-06_JPRB, 0.10579600E-05_JPRB, 0.11290355E-05_JPRB, 0.12114215E-05_JPRB, 0.13085719E-05_JPRB, &
  & 0.14069713E-05_JPRB, 0.14967281E-05_JPRB, 0.15805441E-05_JPRB, 0.16532251E-05_JPRB, 0.17132608E-05_JPRB, 0.17603748E-05_JPRB, &
  & 0.18018300E-05_JPRB, 0.18403787E-05_JPRB, 0.18709718E-05_JPRB, 0.18970429E-05_JPRB, 0.19230810E-05_JPRB, 0.19438571E-05_JPRB, &
  & 0.19608205E-05_JPRB, 0.19739019E-05_JPRB, 0.19852923E-05_JPRB, 0.19978290E-05_JPRB  /)

RGHG7(:,35, 7) = (/ &
  & 0.20561579E-05_JPRB, 0.20326953E-05_JPRB, 0.20126319E-05_JPRB, 0.19930491E-05_JPRB, 0.19862123E-05_JPRB, 0.19825827E-05_JPRB, &
  & 0.19716844E-05_JPRB, 0.19173895E-05_JPRB, 0.18369194E-05_JPRB, 0.17482207E-05_JPRB, 0.16669176E-05_JPRB, 0.16079188E-05_JPRB, &
  & 0.15654837E-05_JPRB, 0.15288481E-05_JPRB, 0.14707040E-05_JPRB, 0.13821969E-05_JPRB, 0.12878026E-05_JPRB, 0.11962974E-05_JPRB, &
  & 0.10896609E-05_JPRB, 0.96322911E-06_JPRB, 0.83220910E-06_JPRB, 0.71714008E-06_JPRB, 0.61971701E-06_JPRB, 0.54114261E-06_JPRB, &
  & 0.48263943E-06_JPRB, 0.44006941E-06_JPRB, 0.40611473E-06_JPRB, 0.38279486E-06_JPRB, 0.37408176E-06_JPRB, 0.38620921E-06_JPRB, &
  & 0.41251265E-06_JPRB, 0.43874094E-06_JPRB, 0.45698836E-06_JPRB, 0.47416819E-06_JPRB, 0.49336036E-06_JPRB, 0.51475225E-06_JPRB, &
  & 0.53945858E-06_JPRB, 0.56632291E-06_JPRB, 0.59500217E-06_JPRB, 0.62715192E-06_JPRB, 0.66117285E-06_JPRB, 0.69604609E-06_JPRB, &
  & 0.73725935E-06_JPRB, 0.78818759E-06_JPRB, 0.84751440E-06_JPRB, 0.91703516E-06_JPRB, 0.99807360E-06_JPRB, 0.10940245E-05_JPRB, &
  & 0.11937419E-05_JPRB, 0.12858679E-05_JPRB, 0.13719940E-05_JPRB, 0.14457559E-05_JPRB, 0.15075686E-05_JPRB, 0.15576441E-05_JPRB, &
  & 0.16018980E-05_JPRB, 0.16435564E-05_JPRB, 0.16779698E-05_JPRB, 0.17077281E-05_JPRB, 0.17377791E-05_JPRB, 0.17640933E-05_JPRB, &
  & 0.17872316E-05_JPRB, 0.18061028E-05_JPRB, 0.18200846E-05_JPRB, 0.18312738E-05_JPRB  /)

RGHG7(:,36, 7) = (/ &
  & 0.18695789E-05_JPRB, 0.18435513E-05_JPRB, 0.18216278E-05_JPRB, 0.17985391E-05_JPRB, 0.17916418E-05_JPRB, 0.17915388E-05_JPRB, &
  & 0.17852294E-05_JPRB, 0.17353611E-05_JPRB, 0.16547130E-05_JPRB, 0.15656746E-05_JPRB, 0.14804528E-05_JPRB, 0.14183060E-05_JPRB, &
  & 0.13754281E-05_JPRB, 0.13428050E-05_JPRB, 0.12912832E-05_JPRB, 0.12067540E-05_JPRB, 0.11165461E-05_JPRB, 0.10257090E-05_JPRB, &
  & 0.91972914E-06_JPRB, 0.79657897E-06_JPRB, 0.67045353E-06_JPRB, 0.55963156E-06_JPRB, 0.46590142E-06_JPRB, 0.39248882E-06_JPRB, &
  & 0.34123754E-06_JPRB, 0.30719600E-06_JPRB, 0.28090872E-06_JPRB, 0.26046131E-06_JPRB, 0.25094042E-06_JPRB, 0.25568111E-06_JPRB, &
  & 0.27019475E-06_JPRB, 0.28560885E-06_JPRB, 0.29872495E-06_JPRB, 0.31536194E-06_JPRB, 0.33706413E-06_JPRB, 0.36316693E-06_JPRB, &
  & 0.39238763E-06_JPRB, 0.41964497E-06_JPRB, 0.44427672E-06_JPRB, 0.46905883E-06_JPRB, 0.49492039E-06_JPRB, 0.52286466E-06_JPRB, &
  & 0.55902999E-06_JPRB, 0.60689851E-06_JPRB, 0.66308560E-06_JPRB, 0.72938294E-06_JPRB, 0.80731970E-06_JPRB, 0.89991437E-06_JPRB, &
  & 0.99863753E-06_JPRB, 0.10916410E-05_JPRB, 0.11782937E-05_JPRB, 0.12515703E-05_JPRB, 0.13133535E-05_JPRB, 0.13649977E-05_JPRB, &
  & 0.14111702E-05_JPRB, 0.14545361E-05_JPRB, 0.14917498E-05_JPRB, 0.15239768E-05_JPRB, 0.15566516E-05_JPRB, 0.15873321E-05_JPRB, &
  & 0.16149288E-05_JPRB, 0.16387090E-05_JPRB, 0.16543563E-05_JPRB, 0.16647077E-05_JPRB  /)

RGHG7(:,37, 7) = (/ &
  & 0.16796277E-05_JPRB, 0.16562793E-05_JPRB, 0.16365294E-05_JPRB, 0.16164753E-05_JPRB, 0.16108767E-05_JPRB, 0.16137126E-05_JPRB, &
  & 0.16128574E-05_JPRB, 0.15723665E-05_JPRB, 0.14982388E-05_JPRB, 0.14147913E-05_JPRB, 0.13332740E-05_JPRB, 0.12714143E-05_JPRB, &
  & 0.12289055E-05_JPRB, 0.11984149E-05_JPRB, 0.11517185E-05_JPRB, 0.10750493E-05_JPRB, 0.99082880E-06_JPRB, 0.90293062E-06_JPRB, &
  & 0.80151646E-06_JPRB, 0.68387518E-06_JPRB, 0.56571916E-06_JPRB, 0.46175938E-06_JPRB, 0.37527418E-06_JPRB, 0.30998137E-06_JPRB, &
  & 0.26623475E-06_JPRB, 0.23696393E-06_JPRB, 0.21578912E-06_JPRB, 0.20013977E-06_JPRB, 0.19235493E-06_JPRB, 0.19356884E-06_JPRB, &
  & 0.20160305E-06_JPRB, 0.21175432E-06_JPRB, 0.22245088E-06_JPRB, 0.23777558E-06_JPRB, 0.25760502E-06_JPRB, 0.28093288E-06_JPRB, &
  & 0.30684551E-06_JPRB, 0.33201139E-06_JPRB, 0.35385452E-06_JPRB, 0.37520554E-06_JPRB, 0.39796408E-06_JPRB, 0.42321542E-06_JPRB, &
  & 0.45661947E-06_JPRB, 0.49959425E-06_JPRB, 0.54978034E-06_JPRB, 0.60922916E-06_JPRB, 0.68023539E-06_JPRB, 0.76473761E-06_JPRB, &
  & 0.85722739E-06_JPRB, 0.94763364E-06_JPRB, 0.10306912E-05_JPRB, 0.10999215E-05_JPRB, 0.11575355E-05_JPRB, 0.12074573E-05_JPRB, &
  & 0.12534111E-05_JPRB, 0.12951640E-05_JPRB, 0.13326648E-05_JPRB, 0.13644134E-05_JPRB, 0.13963636E-05_JPRB, 0.14284521E-05_JPRB, &
  & 0.14562949E-05_JPRB, 0.14826586E-05_JPRB, 0.14977455E-05_JPRB, 0.15084796E-05_JPRB  /)

RGHG7(:,38, 7) = (/ &
  & 0.14688600E-05_JPRB, 0.14484844E-05_JPRB, 0.14311462E-05_JPRB, 0.14144593E-05_JPRB, 0.14103016E-05_JPRB, 0.14163986E-05_JPRB, &
  & 0.14215954E-05_JPRB, 0.13915095E-05_JPRB, 0.13246169E-05_JPRB, 0.12473730E-05_JPRB, 0.11699661E-05_JPRB, 0.11084249E-05_JPRB, &
  & 0.10663256E-05_JPRB, 0.10382012E-05_JPRB, 0.99685899E-06_JPRB, 0.92891133E-06_JPRB, 0.85133426E-06_JPRB, 0.76669714E-06_JPRB, &
  & 0.67034900E-06_JPRB, 0.55882031E-06_JPRB, 0.44950709E-06_JPRB, 0.35316151E-06_JPRB, 0.27471521E-06_JPRB, 0.21843203E-06_JPRB, &
  & 0.18301250E-06_JPRB, 0.15903522E-06_JPRB, 0.14353314E-06_JPRB, 0.13320766E-06_JPRB, 0.12734913E-06_JPRB, 0.12464977E-06_JPRB, &
  & 0.12549446E-06_JPRB, 0.12980616E-06_JPRB, 0.13781803E-06_JPRB, 0.15168663E-06_JPRB, 0.16943809E-06_JPRB, 0.18968690E-06_JPRB, &
  & 0.21192894E-06_JPRB, 0.23477415E-06_JPRB, 0.25352306E-06_JPRB, 0.27106698E-06_JPRB, 0.29038244E-06_JPRB, 0.31264575E-06_JPRB, &
  & 0.34298591E-06_JPRB, 0.38053064E-06_JPRB, 0.42405809E-06_JPRB, 0.47590788E-06_JPRB, 0.53922407E-06_JPRB, 0.61474699E-06_JPRB, &
  & 0.70032028E-06_JPRB, 0.78784467E-06_JPRB, 0.86691307E-06_JPRB, 0.93165378E-06_JPRB, 0.98464160E-06_JPRB, 0.10326523E-05_JPRB, &
  & 0.10783633E-05_JPRB, 0.11183265E-05_JPRB, 0.11561458E-05_JPRB, 0.11873635E-05_JPRB, 0.12185098E-05_JPRB, 0.12521606E-05_JPRB, &
  & 0.12802764E-05_JPRB, 0.13095068E-05_JPRB, 0.13239719E-05_JPRB, 0.13351307E-05_JPRB  /)

RGHG7(:,39, 7) = (/ &
  & 0.13097198E-05_JPRB, 0.12937936E-05_JPRB, 0.12799033E-05_JPRB, 0.12670594E-05_JPRB, 0.12645017E-05_JPRB, 0.12719523E-05_JPRB, &
  & 0.12795750E-05_JPRB, 0.12578424E-05_JPRB, 0.12014953E-05_JPRB, 0.11334434E-05_JPRB, 0.10637506E-05_JPRB, 0.10062140E-05_JPRB, &
  & 0.96510303E-06_JPRB, 0.93712084E-06_JPRB, 0.89863195E-06_JPRB, 0.83808975E-06_JPRB, 0.76578201E-06_JPRB, 0.68561311E-06_JPRB, &
  & 0.59456496E-06_JPRB, 0.49030255E-06_JPRB, 0.38890055E-06_JPRB, 0.30019043E-06_JPRB, 0.23020612E-06_JPRB, 0.18182186E-06_JPRB, &
  & 0.15171401E-06_JPRB, 0.13171723E-06_JPRB, 0.11910746E-06_JPRB, 0.11095522E-06_JPRB, 0.10570874E-06_JPRB, 0.10220331E-06_JPRB, &
  & 0.10136654E-06_JPRB, 0.10400920E-06_JPRB, 0.11050347E-06_JPRB, 0.12151018E-06_JPRB, 0.13481817E-06_JPRB, 0.14969372E-06_JPRB, &
  & 0.16783199E-06_JPRB, 0.18882232E-06_JPRB, 0.20803269E-06_JPRB, 0.22584720E-06_JPRB, 0.24361774E-06_JPRB, 0.26361721E-06_JPRB, &
  & 0.29104060E-06_JPRB, 0.32434267E-06_JPRB, 0.36287712E-06_JPRB, 0.40932975E-06_JPRB, 0.46696492E-06_JPRB, 0.53692726E-06_JPRB, &
  & 0.61721963E-06_JPRB, 0.69970035E-06_JPRB, 0.77381871E-06_JPRB, 0.83365724E-06_JPRB, 0.88179164E-06_JPRB, 0.92633383E-06_JPRB, &
  & 0.96820779E-06_JPRB, 0.10037409E-05_JPRB, 0.10386427E-05_JPRB, 0.10681209E-05_JPRB, 0.10969324E-05_JPRB, 0.11274797E-05_JPRB, &
  & 0.11521815E-05_JPRB, 0.11805898E-05_JPRB, 0.11942260E-05_JPRB, 0.12038168E-05_JPRB  /)

RGHG7(:,40, 7) = (/ &
  & 0.11314019E-05_JPRB, 0.11209389E-05_JPRB, 0.11112645E-05_JPRB, 0.11030086E-05_JPRB, 0.11023546E-05_JPRB, 0.11110816E-05_JPRB, &
  & 0.11209581E-05_JPRB, 0.11086932E-05_JPRB, 0.10652637E-05_JPRB, 0.10084884E-05_JPRB, 0.94843829E-06_JPRB, 0.89620441E-06_JPRB, &
  & 0.85634798E-06_JPRB, 0.82816886E-06_JPRB, 0.79261944E-06_JPRB, 0.74055287E-06_JPRB, 0.67420433E-06_JPRB, 0.59947676E-06_JPRB, &
  & 0.51468685E-06_JPRB, 0.41914077E-06_JPRB, 0.32687087E-06_JPRB, 0.24712507E-06_JPRB, 0.18714083E-06_JPRB, 0.14784490E-06_JPRB, &
  & 0.12347743E-06_JPRB, 0.10793728E-06_JPRB, 0.98266992E-07_JPRB, 0.92149777E-07_JPRB, 0.87406580E-07_JPRB, 0.83463517E-07_JPRB, &
  & 0.81554527E-07_JPRB, 0.82920731E-07_JPRB, 0.87824917E-07_JPRB, 0.95242979E-07_JPRB, 0.10294917E-06_JPRB, 0.11114342E-06_JPRB, &
  & 0.12439471E-06_JPRB, 0.14328437E-06_JPRB, 0.16361801E-06_JPRB, 0.18241722E-06_JPRB, 0.19868519E-06_JPRB, 0.21614635E-06_JPRB, &
  & 0.24017074E-06_JPRB, 0.26868794E-06_JPRB, 0.30163519E-06_JPRB, 0.34211403E-06_JPRB, 0.39341071E-06_JPRB, 0.45740656E-06_JPRB, &
  & 0.53176891E-06_JPRB, 0.60797679E-06_JPRB, 0.67612866E-06_JPRB, 0.73014658E-06_JPRB, 0.77254789E-06_JPRB, 0.81276474E-06_JPRB, &
  & 0.84954749E-06_JPRB, 0.87944966E-06_JPRB, 0.91039810E-06_JPRB, 0.93763698E-06_JPRB, 0.96345796E-06_JPRB, 0.98959966E-06_JPRB, &
  & 0.10096917E-05_JPRB, 0.10365318E-05_JPRB, 0.10491614E-05_JPRB, 0.10565859E-05_JPRB  /)

RGHG7(:,41, 7) = (/ &
  & 0.91338240E-06_JPRB, 0.90959897E-06_JPRB, 0.90507913E-06_JPRB, 0.90243262E-06_JPRB, 0.90410623E-06_JPRB, 0.91439388E-06_JPRB, &
  & 0.92702608E-06_JPRB, 0.92633668E-06_JPRB, 0.89870093E-06_JPRB, 0.85571280E-06_JPRB, 0.80745223E-06_JPRB, 0.76170171E-06_JPRB, &
  & 0.72337917E-06_JPRB, 0.69495927E-06_JPRB, 0.66300379E-06_JPRB, 0.62129991E-06_JPRB, 0.56223735E-06_JPRB, 0.49416258E-06_JPRB, &
  & 0.41702430E-06_JPRB, 0.33213520E-06_JPRB, 0.25103059E-06_JPRB, 0.18224498E-06_JPRB, 0.13448728E-06_JPRB, 0.10630314E-06_JPRB, &
  & 0.88954115E-07_JPRB, 0.78862845E-07_JPRB, 0.72786500E-07_JPRB, 0.69157399E-07_JPRB, 0.65029542E-07_JPRB, 0.60551401E-07_JPRB, &
  & 0.57331470E-07_JPRB, 0.57137029E-07_JPRB, 0.60097097E-07_JPRB, 0.63127517E-07_JPRB, 0.63984706E-07_JPRB, 0.64010094E-07_JPRB, &
  & 0.71286346E-07_JPRB, 0.87607623E-07_JPRB, 0.10931463E-06_JPRB, 0.12931777E-06_JPRB, 0.14374863E-06_JPRB, 0.15810634E-06_JPRB, &
  & 0.17797496E-06_JPRB, 0.20064197E-06_JPRB, 0.22675805E-06_JPRB, 0.25993308E-06_JPRB, 0.30348004E-06_JPRB, 0.36018099E-06_JPRB, &
  & 0.42729302E-06_JPRB, 0.49583145E-06_JPRB, 0.55668842E-06_JPRB, 0.60358980E-06_JPRB, 0.63898158E-06_JPRB, 0.67391007E-06_JPRB, &
  & 0.70446808E-06_JPRB, 0.72748557E-06_JPRB, 0.75360048E-06_JPRB, 0.77810154E-06_JPRB, 0.80026615E-06_JPRB, 0.82102140E-06_JPRB, &
  & 0.83547726E-06_JPRB, 0.86040005E-06_JPRB, 0.87179898E-06_JPRB, 0.87657476E-06_JPRB  /)

RGHG7(:,42, 7) = (/ &
  & 0.84814268E-06_JPRB, 0.84472932E-06_JPRB, 0.83829997E-06_JPRB, 0.83471544E-06_JPRB, 0.83839628E-06_JPRB, 0.84862307E-06_JPRB, &
  & 0.85849058E-06_JPRB, 0.85872656E-06_JPRB, 0.83922555E-06_JPRB, 0.80498069E-06_JPRB, 0.76471791E-06_JPRB, 0.72610191E-06_JPRB, &
  & 0.69197340E-06_JPRB, 0.66509396E-06_JPRB, 0.63466439E-06_JPRB, 0.59504582E-06_JPRB, 0.53996261E-06_JPRB, 0.47570291E-06_JPRB, &
  & 0.40200522E-06_JPRB, 0.32126096E-06_JPRB, 0.24437007E-06_JPRB, 0.17993345E-06_JPRB, 0.13629410E-06_JPRB, 0.10987103E-06_JPRB, &
  & 0.93214370E-07_JPRB, 0.82742836E-07_JPRB, 0.76225515E-07_JPRB, 0.71789762E-07_JPRB, 0.67304309E-07_JPRB, 0.62856677E-07_JPRB, &
  & 0.59878774E-07_JPRB, 0.59880178E-07_JPRB, 0.62619106E-07_JPRB, 0.65703012E-07_JPRB, 0.67272745E-07_JPRB, 0.69664576E-07_JPRB, &
  & 0.77588435E-07_JPRB, 0.91630341E-07_JPRB, 0.11001916E-06_JPRB, 0.12847126E-06_JPRB, 0.14313189E-06_JPRB, 0.15719798E-06_JPRB, &
  & 0.17500532E-06_JPRB, 0.19509865E-06_JPRB, 0.22027980E-06_JPRB, 0.25450714E-06_JPRB, 0.29843925E-06_JPRB, 0.35435640E-06_JPRB, &
  & 0.42078897E-06_JPRB, 0.48912513E-06_JPRB, 0.54827273E-06_JPRB, 0.59294676E-06_JPRB, 0.62528944E-06_JPRB, 0.65624166E-06_JPRB, &
  & 0.68429651E-06_JPRB, 0.70510269E-06_JPRB, 0.72643877E-06_JPRB, 0.74629139E-06_JPRB, 0.76464556E-06_JPRB, 0.77987029E-06_JPRB, &
  & 0.79119841E-06_JPRB, 0.81056531E-06_JPRB, 0.82086682E-06_JPRB, 0.82517511E-06_JPRB  /)

RGHG7(:,43, 7) = (/ &
  & 0.69483736E-06_JPRB, 0.69463485E-06_JPRB, 0.68868053E-06_JPRB, 0.68665305E-06_JPRB, 0.69316648E-06_JPRB, 0.70400905E-06_JPRB, &
  & 0.71253944E-06_JPRB, 0.71859894E-06_JPRB, 0.71331367E-06_JPRB, 0.69297666E-06_JPRB, 0.66508228E-06_JPRB, 0.63576457E-06_JPRB, &
  & 0.60612246E-06_JPRB, 0.58054496E-06_JPRB, 0.55305354E-06_JPRB, 0.51979511E-06_JPRB, 0.47147669E-06_JPRB, 0.41355953E-06_JPRB, &
  & 0.34629235E-06_JPRB, 0.27391391E-06_JPRB, 0.20567035E-06_JPRB, 0.14991623E-06_JPRB, 0.11529367E-06_JPRB, 0.95257125E-07_JPRB, &
  & 0.82251170E-07_JPRB, 0.73776525E-07_JPRB, 0.68402797E-07_JPRB, 0.64301325E-07_JPRB, 0.59754294E-07_JPRB, 0.55104334E-07_JPRB, &
  & 0.51783353E-07_JPRB, 0.51292133E-07_JPRB, 0.52993029E-07_JPRB, 0.54238390E-07_JPRB, 0.53512140E-07_JPRB, 0.54549254E-07_JPRB, &
  & 0.60493818E-07_JPRB, 0.71351257E-07_JPRB, 0.87303347E-07_JPRB, 0.10485817E-06_JPRB, 0.11893820E-06_JPRB, 0.13140325E-06_JPRB, &
  & 0.14554231E-06_JPRB, 0.16077097E-06_JPRB, 0.18216067E-06_JPRB, 0.21420638E-06_JPRB, 0.25515635E-06_JPRB, 0.30722048E-06_JPRB, &
  & 0.36991438E-06_JPRB, 0.43476698E-06_JPRB, 0.48921705E-06_JPRB, 0.52879770E-06_JPRB, 0.55534323E-06_JPRB, 0.58039276E-06_JPRB, &
  & 0.60348618E-06_JPRB, 0.61931333E-06_JPRB, 0.63421010E-06_JPRB, 0.64864385E-06_JPRB, 0.66194862E-06_JPRB, 0.66981037E-06_JPRB, &
  & 0.67586037E-06_JPRB, 0.68933337E-06_JPRB, 0.69810422E-06_JPRB, 0.70084667E-06_JPRB  /)

RGHG7(:,44, 7) = (/ &
  & 0.62212416E-06_JPRB, 0.61973914E-06_JPRB, 0.61392534E-06_JPRB, 0.61270640E-06_JPRB, 0.61983379E-06_JPRB, 0.63012305E-06_JPRB, &
  & 0.63889654E-06_JPRB, 0.64471904E-06_JPRB, 0.64371013E-06_JPRB, 0.63097237E-06_JPRB, 0.61076091E-06_JPRB, 0.58755342E-06_JPRB, &
  & 0.56294521E-06_JPRB, 0.54057638E-06_JPRB, 0.51569908E-06_JPRB, 0.48530022E-06_JPRB, 0.44164543E-06_JPRB, 0.38795378E-06_JPRB, &
  & 0.32512589E-06_JPRB, 0.25733951E-06_JPRB, 0.19324758E-06_JPRB, 0.14120548E-06_JPRB, 0.10934093E-06_JPRB, 0.90846293E-07_JPRB, &
  & 0.78761345E-07_JPRB, 0.70656181E-07_JPRB, 0.65500342E-07_JPRB, 0.61380721E-07_JPRB, 0.56836735E-07_JPRB, 0.52330469E-07_JPRB, &
  & 0.49248366E-07_JPRB, 0.48883796E-07_JPRB, 0.50283102E-07_JPRB, 0.50834515E-07_JPRB, 0.49965204E-07_JPRB, 0.51254939E-07_JPRB, &
  & 0.56847014E-07_JPRB, 0.66841589E-07_JPRB, 0.81423493E-07_JPRB, 0.97353950E-07_JPRB, 0.11033902E-06_JPRB, 0.12170489E-06_JPRB, &
  & 0.13449295E-06_JPRB, 0.14812071E-06_JPRB, 0.16683942E-06_JPRB, 0.19562252E-06_JPRB, 0.23410723E-06_JPRB, 0.28400732E-06_JPRB, &
  & 0.34529742E-06_JPRB, 0.41080558E-06_JPRB, 0.46551168E-06_JPRB, 0.50517632E-06_JPRB, 0.53079275E-06_JPRB, 0.55293194E-06_JPRB, &
  & 0.57429122E-06_JPRB, 0.58852258E-06_JPRB, 0.60210684E-06_JPRB, 0.61362203E-06_JPRB, 0.62480459E-06_JPRB, 0.63127446E-06_JPRB, &
  & 0.63477296E-06_JPRB, 0.64358041E-06_JPRB, 0.65043724E-06_JPRB, 0.65419457E-06_JPRB  /)

RGHG7(:,45, 7) = (/ &
  & 0.51997956E-06_JPRB, 0.51551552E-06_JPRB, 0.50992170E-06_JPRB, 0.50981991E-06_JPRB, 0.51800406E-06_JPRB, 0.52774122E-06_JPRB, &
  & 0.53662254E-06_JPRB, 0.54291089E-06_JPRB, 0.54856607E-06_JPRB, 0.54623637E-06_JPRB, 0.53633376E-06_JPRB, 0.52125690E-06_JPRB, &
  & 0.50294615E-06_JPRB, 0.48439461E-06_JPRB, 0.46286446E-06_JPRB, 0.43652444E-06_JPRB, 0.39903339E-06_JPRB, 0.35095339E-06_JPRB, &
  & 0.29399163E-06_JPRB, 0.23248977E-06_JPRB, 0.17421652E-06_JPRB, 0.12749706E-06_JPRB, 0.99911333E-07_JPRB, 0.83978816E-07_JPRB, &
  & 0.73403534E-07_JPRB, 0.65971249E-07_JPRB, 0.61207923E-07_JPRB, 0.57109869E-07_JPRB, 0.52561569E-07_JPRB, 0.48193329E-07_JPRB, &
  & 0.45339833E-07_JPRB, 0.45057217E-07_JPRB, 0.45982056E-07_JPRB, 0.45511210E-07_JPRB, 0.44188999E-07_JPRB, 0.45595195E-07_JPRB, &
  & 0.50535957E-07_JPRB, 0.59145953E-07_JPRB, 0.71860186E-07_JPRB, 0.85828078E-07_JPRB, 0.97493274E-07_JPRB, 0.10740554E-06_JPRB, &
  & 0.11819223E-06_JPRB, 0.12938295E-06_JPRB, 0.14458199E-06_JPRB, 0.16937526E-06_JPRB, 0.20467673E-06_JPRB, 0.25162651E-06_JPRB, &
  & 0.31084621E-06_JPRB, 0.37666061E-06_JPRB, 0.43106478E-06_JPRB, 0.47018163E-06_JPRB, 0.49400802E-06_JPRB, 0.51208837E-06_JPRB, &
  & 0.53084671E-06_JPRB, 0.54263241E-06_JPRB, 0.55390904E-06_JPRB, 0.56141716E-06_JPRB, 0.56954588E-06_JPRB, 0.57350107E-06_JPRB, &
  & 0.57342814E-06_JPRB, 0.57617968E-06_JPRB, 0.58066418E-06_JPRB, 0.58537907E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART14',0,ZHOOK_HANDLE)



RGHG7(:,46, 7) = (/ &
  & 0.45294992E-06_JPRB, 0.44618690E-06_JPRB, 0.43970909E-06_JPRB, 0.44070201E-06_JPRB, 0.44860269E-06_JPRB, 0.45714181E-06_JPRB, &
  & 0.46626866E-06_JPRB, 0.47257142E-06_JPRB, 0.47995072E-06_JPRB, 0.48285333E-06_JPRB, 0.47883279E-06_JPRB, 0.46872224E-06_JPRB, &
  & 0.45493422E-06_JPRB, 0.43955528E-06_JPRB, 0.42111343E-06_JPRB, 0.39811030E-06_JPRB, 0.36600391E-06_JPRB, 0.32383561E-06_JPRB, &
  & 0.27275341E-06_JPRB, 0.21652790E-06_JPRB, 0.16244942E-06_JPRB, 0.11927947E-06_JPRB, 0.93948328E-07_JPRB, 0.79176412E-07_JPRB, &
  & 0.69438270E-07_JPRB, 0.62645555E-07_JPRB, 0.58213339E-07_JPRB, 0.54212869E-07_JPRB, 0.49937814E-07_JPRB, 0.45989493E-07_JPRB, &
  & 0.43443205E-07_JPRB, 0.43141060E-07_JPRB, 0.43628400E-07_JPRB, 0.42709432E-07_JPRB, 0.41330623E-07_JPRB, 0.42936382E-07_JPRB, &
  & 0.47621624E-07_JPRB, 0.55459938E-07_JPRB, 0.66944844E-07_JPRB, 0.79745124E-07_JPRB, 0.90238836E-07_JPRB, 0.98868833E-07_JPRB, &
  & 0.10845391E-06_JPRB, 0.11804267E-06_JPRB, 0.13097505E-06_JPRB, 0.15212040E-06_JPRB, 0.18268590E-06_JPRB, 0.22539327E-06_JPRB, &
  & 0.28149049E-06_JPRB, 0.34529707E-06_JPRB, 0.39863726E-06_JPRB, 0.43701316E-06_JPRB, 0.46092481E-06_JPRB, 0.47865884E-06_JPRB, &
  & 0.49666960E-06_JPRB, 0.50923509E-06_JPRB, 0.52133053E-06_JPRB, 0.52831729E-06_JPRB, 0.53612347E-06_JPRB, 0.54149687E-06_JPRB, &
  & 0.54218438E-06_JPRB, 0.54354917E-06_JPRB, 0.54685352E-06_JPRB, 0.55216450E-06_JPRB  /)

RGHG7(:,47, 7) = (/ &
  & 0.38132997E-06_JPRB, 0.37182522E-06_JPRB, 0.36408899E-06_JPRB, 0.36636196E-06_JPRB, 0.37366154E-06_JPRB, 0.38066546E-06_JPRB, &
  & 0.39010799E-06_JPRB, 0.39633724E-06_JPRB, 0.40475010E-06_JPRB, 0.41275561E-06_JPRB, 0.41475045E-06_JPRB, 0.40983363E-06_JPRB, &
  & 0.40099715E-06_JPRB, 0.38921188E-06_JPRB, 0.37434207E-06_JPRB, 0.35510990E-06_JPRB, 0.32916592E-06_JPRB, 0.29399466E-06_JPRB, &
  & 0.24981435E-06_JPRB, 0.19957827E-06_JPRB, 0.15009674E-06_JPRB, 0.11073667E-06_JPRB, 0.87645624E-07_JPRB, 0.73954832E-07_JPRB, &
  & 0.65064293E-07_JPRB, 0.59015392E-07_JPRB, 0.54959407E-07_JPRB, 0.51088672E-07_JPRB, 0.47189848E-07_JPRB, 0.43790739E-07_JPRB, &
  & 0.41620682E-07_JPRB, 0.41275292E-07_JPRB, 0.41256666E-07_JPRB, 0.39926870E-07_JPRB, 0.38561034E-07_JPRB, 0.40417615E-07_JPRB, &
  & 0.44882307E-07_JPRB, 0.51937887E-07_JPRB, 0.62108145E-07_JPRB, 0.73697565E-07_JPRB, 0.82846358E-07_JPRB, 0.90006025E-07_JPRB, &
  & 0.98341324E-07_JPRB, 0.10621758E-06_JPRB, 0.11674121E-06_JPRB, 0.13367450E-06_JPRB, 0.15837165E-06_JPRB, 0.19584206E-06_JPRB, &
  & 0.24806452E-06_JPRB, 0.30905153E-06_JPRB, 0.36099059E-06_JPRB, 0.39845834E-06_JPRB, 0.42284569E-06_JPRB, 0.44091703E-06_JPRB, &
  & 0.45842182E-06_JPRB, 0.47254846E-06_JPRB, 0.48623098E-06_JPRB, 0.49330423E-06_JPRB, 0.50127907E-06_JPRB, 0.50910446E-06_JPRB, &
  & 0.51155204E-06_JPRB, 0.51222491E-06_JPRB, 0.51438327E-06_JPRB, 0.52032130E-06_JPRB  /)

RGHG7(:,48, 7) = (/ &
  & 0.32533595E-06_JPRB, 0.31408134E-06_JPRB, 0.30483946E-06_JPRB, 0.30750205E-06_JPRB, 0.31407829E-06_JPRB, 0.31974604E-06_JPRB, &
  & 0.32901337E-06_JPRB, 0.33513314E-06_JPRB, 0.34307114E-06_JPRB, 0.35283467E-06_JPRB, 0.35796690E-06_JPRB, 0.35605914E-06_JPRB, &
  & 0.35020102E-06_JPRB, 0.34046186E-06_JPRB, 0.32834220E-06_JPRB, 0.31302053E-06_JPRB, 0.29272018E-06_JPRB, 0.26432482E-06_JPRB, &
  & 0.22738711E-06_JPRB, 0.18353421E-06_JPRB, 0.13895084E-06_JPRB, 0.10304946E-06_JPRB, 0.81860597E-07_JPRB, 0.69228906E-07_JPRB, &
  & 0.61295403E-07_JPRB, 0.55988642E-07_JPRB, 0.52411536E-07_JPRB, 0.48859854E-07_JPRB, 0.45329097E-07_JPRB, 0.42328513E-07_JPRB, &
  & 0.40361726E-07_JPRB, 0.39921350E-07_JPRB, 0.39567930E-07_JPRB, 0.38061732E-07_JPRB, 0.36813326E-07_JPRB, 0.38836674E-07_JPRB, &
  & 0.43205919E-07_JPRB, 0.49792164E-07_JPRB, 0.59020039E-07_JPRB, 0.69708651E-07_JPRB, 0.77877837E-07_JPRB, 0.83970252E-07_JPRB, &
  & 0.91472971E-07_JPRB, 0.98117728E-07_JPRB, 0.10689750E-06_JPRB, 0.12063011E-06_JPRB, 0.14055342E-06_JPRB, 0.17259557E-06_JPRB, &
  & 0.21926061E-06_JPRB, 0.27428698E-06_JPRB, 0.32087430E-06_JPRB, 0.35452890E-06_JPRB, 0.37819377E-06_JPRB, 0.39636898E-06_JPRB, &
  & 0.41438569E-06_JPRB, 0.43013450E-06_JPRB, 0.44581897E-06_JPRB, 0.45560530E-06_JPRB, 0.46643362E-06_JPRB, 0.47733668E-06_JPRB, &
  & 0.48359817E-06_JPRB, 0.48737981E-06_JPRB, 0.49034116E-06_JPRB, 0.49678845E-06_JPRB  /)

RGHG7(:,49, 7) = (/ &
  & 0.27043246E-06_JPRB, 0.25769103E-06_JPRB, 0.24666939E-06_JPRB, 0.24935861E-06_JPRB, 0.25507826E-06_JPRB, 0.25935682E-06_JPRB, &
  & 0.26820695E-06_JPRB, 0.27418913E-06_JPRB, 0.28091548E-06_JPRB, 0.29110508E-06_JPRB, 0.29840321E-06_JPRB, 0.29883443E-06_JPRB, &
  & 0.29537743E-06_JPRB, 0.28720054E-06_JPRB, 0.27775274E-06_JPRB, 0.26682498E-06_JPRB, 0.25253853E-06_JPRB, 0.23154625E-06_JPRB, &
  & 0.20278388E-06_JPRB, 0.16617872E-06_JPRB, 0.12715655E-06_JPRB, 0.94925638E-07_JPRB, 0.75689623E-07_JPRB, 0.64220766E-07_JPRB, &
  & 0.57396837E-07_JPRB, 0.52911162E-07_JPRB, 0.49911035E-07_JPRB, 0.46798744E-07_JPRB, 0.43671872E-07_JPRB, 0.41044104E-07_JPRB, &
  & 0.39223781E-07_JPRB, 0.38654695E-07_JPRB, 0.38008347E-07_JPRB, 0.36413383E-07_JPRB, 0.35342509E-07_JPRB, 0.37512321E-07_JPRB, &
  & 0.41832745E-07_JPRB, 0.48041735E-07_JPRB, 0.56395265E-07_JPRB, 0.66227285E-07_JPRB, 0.73477744E-07_JPRB, 0.78571542E-07_JPRB, &
  & 0.85341942E-07_JPRB, 0.90841617E-07_JPRB, 0.97992535E-07_JPRB, 0.10864053E-06_JPRB, 0.12377492E-06_JPRB, 0.14971884E-06_JPRB, &
  & 0.18946458E-06_JPRB, 0.23646207E-06_JPRB, 0.27532675E-06_JPRB, 0.30343791E-06_JPRB, 0.32575798E-06_JPRB, 0.34394206E-06_JPRB, &
  & 0.36298846E-06_JPRB, 0.38056141E-06_JPRB, 0.39865144E-06_JPRB, 0.41263640E-06_JPRB, 0.42784532E-06_JPRB, 0.44244104E-06_JPRB, &
  & 0.45385984E-06_JPRB, 0.46281210E-06_JPRB, 0.46754876E-06_JPRB, 0.47450645E-06_JPRB  /)

RGHG7(:,50, 7) = (/ &
  & 0.22521418E-06_JPRB, 0.21149324E-06_JPRB, 0.19995588E-06_JPRB, 0.20237978E-06_JPRB, 0.20759429E-06_JPRB, 0.21065702E-06_JPRB, &
  & 0.21820825E-06_JPRB, 0.22379352E-06_JPRB, 0.22913998E-06_JPRB, 0.23869588E-06_JPRB, 0.24637351E-06_JPRB, 0.24851291E-06_JPRB, &
  & 0.24621040E-06_JPRB, 0.23932039E-06_JPRB, 0.23193771E-06_JPRB, 0.22456130E-06_JPRB, 0.21477425E-06_JPRB, 0.19993278E-06_JPRB, &
  & 0.17845068E-06_JPRB, 0.14924933E-06_JPRB, 0.11626307E-06_JPRB, 0.87736330E-07_JPRB, 0.70312981E-07_JPRB, 0.60009010E-07_JPRB, &
  & 0.54133517E-07_JPRB, 0.50375010E-07_JPRB, 0.47918376E-07_JPRB, 0.45197854E-07_JPRB, 0.42373256E-07_JPRB, 0.39974143E-07_JPRB, &
  & 0.38244988E-07_JPRB, 0.37613616E-07_JPRB, 0.36796471E-07_JPRB, 0.35207091E-07_JPRB, 0.34309658E-07_JPRB, 0.36579292E-07_JPRB, &
  & 0.40866441E-07_JPRB, 0.46874171E-07_JPRB, 0.54569650E-07_JPRB, 0.63700387E-07_JPRB, 0.70301356E-07_JPRB, 0.74797418E-07_JPRB, &
  & 0.80858142E-07_JPRB, 0.85492958E-07_JPRB, 0.91459268E-07_JPRB, 0.99863883E-07_JPRB, 0.11156869E-06_JPRB, 0.13252987E-06_JPRB, &
  & 0.16556477E-06_JPRB, 0.20387033E-06_JPRB, 0.23425861E-06_JPRB, 0.25637716E-06_JPRB, 0.27530079E-06_JPRB, 0.29189263E-06_JPRB, &
  & 0.31040755E-06_JPRB, 0.32820208E-06_JPRB, 0.34767881E-06_JPRB, 0.36491760E-06_JPRB, 0.38343411E-06_JPRB, 0.40054706E-06_JPRB, &
  & 0.41454384E-06_JPRB, 0.42773125E-06_JPRB, 0.43445905E-06_JPRB, 0.44201346E-06_JPRB  /)

RGHG7(:,51, 7) = (/ &
  & 0.18139531E-06_JPRB, 0.16688156E-06_JPRB, 0.15545084E-06_JPRB, 0.15743429E-06_JPRB, 0.16228717E-06_JPRB, 0.16412593E-06_JPRB, &
  & 0.16980873E-06_JPRB, 0.17482838E-06_JPRB, 0.17859387E-06_JPRB, 0.18690725E-06_JPRB, 0.19405634E-06_JPRB, 0.19771181E-06_JPRB, &
  & 0.19600274E-06_JPRB, 0.19035988E-06_JPRB, 0.18489198E-06_JPRB, 0.18091397E-06_JPRB, 0.17519757E-06_JPRB, 0.16635081E-06_JPRB, &
  & 0.15227284E-06_JPRB, 0.13116179E-06_JPRB, 0.10495377E-06_JPRB, 0.80451313E-07_JPRB, 0.64914929E-07_JPRB, 0.55872025E-07_JPRB, &
  & 0.50937696E-07_JPRB, 0.47916358E-07_JPRB, 0.46029985E-07_JPRB, 0.43708183E-07_JPRB, 0.41157126E-07_JPRB, 0.38929555E-07_JPRB, &
  & 0.37269944E-07_JPRB, 0.36606118E-07_JPRB, 0.35668429E-07_JPRB, 0.34134685E-07_JPRB, 0.33422703E-07_JPRB, 0.35775790E-07_JPRB, &
  & 0.40035122E-07_JPRB, 0.45917671E-07_JPRB, 0.53015071E-07_JPRB, 0.61468912E-07_JPRB, 0.67508891E-07_JPRB, 0.71569144E-07_JPRB, &
  & 0.76874154E-07_JPRB, 0.80720803E-07_JPRB, 0.85639315E-07_JPRB, 0.92059603E-07_JPRB, 0.10076938E-06_JPRB, 0.11692737E-06_JPRB, &
  & 0.14281313E-06_JPRB, 0.17136860E-06_JPRB, 0.19219224E-06_JPRB, 0.20759283E-06_JPRB, 0.22176428E-06_JPRB, 0.23579226E-06_JPRB, &
  & 0.25291166E-06_JPRB, 0.27010347E-06_JPRB, 0.29054454E-06_JPRB, 0.31080620E-06_JPRB, 0.33233628E-06_JPRB, 0.35155410E-06_JPRB, &
  & 0.36698349E-06_JPRB, 0.38426010E-06_JPRB, 0.39325504E-06_JPRB, 0.40150025E-06_JPRB  /)

RGHG7(:,52, 7) = (/ &
  & 0.14702137E-06_JPRB, 0.13294965E-06_JPRB, 0.12242149E-06_JPRB, 0.12425510E-06_JPRB, 0.12869323E-06_JPRB, 0.12955848E-06_JPRB, &
  & 0.13360658E-06_JPRB, 0.13766856E-06_JPRB, 0.14017315E-06_JPRB, 0.14724759E-06_JPRB, 0.15365453E-06_JPRB, 0.15801119E-06_JPRB, &
  & 0.15681557E-06_JPRB, 0.15236804E-06_JPRB, 0.14869634E-06_JPRB, 0.14670432E-06_JPRB, 0.14346645E-06_JPRB, 0.13836402E-06_JPRB, &
  & 0.12946562E-06_JPRB, 0.11492825E-06_JPRB, 0.95045982E-07_JPRB, 0.74502130E-07_JPRB, 0.60739745E-07_JPRB, 0.52748083E-07_JPRB, &
  & 0.48477731E-07_JPRB, 0.45980804E-07_JPRB, 0.44475681E-07_JPRB, 0.42460468E-07_JPRB, 0.40101989E-07_JPRB, 0.38002193E-07_JPRB, &
  & 0.36458666E-07_JPRB, 0.35786368E-07_JPRB, 0.34757457E-07_JPRB, 0.33293011E-07_JPRB, 0.32689197E-07_JPRB, 0.35171959E-07_JPRB, &
  & 0.39422368E-07_JPRB, 0.45260620E-07_JPRB, 0.52024282E-07_JPRB, 0.59851599E-07_JPRB, 0.65512749E-07_JPRB, 0.69268349E-07_JPRB, &
  & 0.73922939E-07_JPRB, 0.77190367E-07_JPRB, 0.81413743E-07_JPRB, 0.86572398E-07_JPRB, 0.93454591E-07_JPRB, 0.10615275E-06_JPRB, &
  & 0.12635289E-06_JPRB, 0.14702830E-06_JPRB, 0.16097802E-06_JPRB, 0.17184128E-06_JPRB, 0.18190891E-06_JPRB, 0.19299693E-06_JPRB, &
  & 0.20747140E-06_JPRB, 0.22228669E-06_JPRB, 0.24132135E-06_JPRB, 0.26094138E-06_JPRB, 0.28208138E-06_JPRB, 0.29985525E-06_JPRB, &
  & 0.31388594E-06_JPRB, 0.33037274E-06_JPRB, 0.33972550E-06_JPRB, 0.34816268E-06_JPRB  /)

RGHG7(:,53, 7) = (/ &
  & 0.11322246E-06_JPRB, 0.10010717E-06_JPRB, 0.90868113E-07_JPRB, 0.92650355E-07_JPRB, 0.96616385E-07_JPRB, 0.96517867E-07_JPRB, &
  & 0.98875699E-07_JPRB, 0.10174398E-06_JPRB, 0.10299861E-06_JPRB, 0.10872524E-06_JPRB, 0.11424180E-06_JPRB, 0.11904854E-06_JPRB, &
  & 0.11838128E-06_JPRB, 0.11521552E-06_JPRB, 0.11345423E-06_JPRB, 0.11308153E-06_JPRB, 0.11193019E-06_JPRB, 0.11003951E-06_JPRB, &
  & 0.10592569E-06_JPRB, 0.97963463E-07_JPRB, 0.84795769E-07_JPRB, 0.68537500E-07_JPRB, 0.56663512E-07_JPRB, 0.49735907E-07_JPRB, &
  & 0.46081975E-07_JPRB, 0.44074270E-07_JPRB, 0.42911602E-07_JPRB, 0.41194814E-07_JPRB, 0.39014901E-07_JPRB, 0.37037410E-07_JPRB, &
  & 0.35638204E-07_JPRB, 0.34965906E-07_JPRB, 0.33848935E-07_JPRB, 0.32465211E-07_JPRB, 0.31949457E-07_JPRB, 0.34591215E-07_JPRB, &
  & 0.38839179E-07_JPRB, 0.44660308E-07_JPRB, 0.51162237E-07_JPRB, 0.58326658E-07_JPRB, 0.63645353E-07_JPRB, 0.67119650E-07_JPRB, &
  & 0.71106452E-07_JPRB, 0.73823506E-07_JPRB, 0.77425569E-07_JPRB, 0.81488367E-07_JPRB, 0.86829512E-07_JPRB, 0.96276796E-07_JPRB, &
  & 0.11084843E-06_JPRB, 0.12366205E-06_JPRB, 0.13116138E-06_JPRB, 0.13792251E-06_JPRB, 0.14377060E-06_JPRB, 0.15151234E-06_JPRB, &
  & 0.16262586E-06_JPRB, 0.17417070E-06_JPRB, 0.19076170E-06_JPRB, 0.20827318E-06_JPRB, 0.22767889E-06_JPRB, 0.24251498E-06_JPRB, &
  & 0.25393323E-06_JPRB, 0.26768283E-06_JPRB, 0.27669069E-06_JPRB, 0.28514499E-06_JPRB  /)

RGHG7(:,54, 7) = (/ &
  & 0.90294062E-07_JPRB, 0.78953575E-07_JPRB, 0.71305796E-07_JPRB, 0.73128658E-07_JPRB, 0.76450864E-07_JPRB, 0.75965232E-07_JPRB, &
  & 0.77415908E-07_JPRB, 0.79396235E-07_JPRB, 0.79993583E-07_JPRB, 0.84674539E-07_JPRB, 0.89314387E-07_JPRB, 0.94062100E-07_JPRB, &
  & 0.93987043E-07_JPRB, 0.91663091E-07_JPRB, 0.90924472E-07_JPRB, 0.91288052E-07_JPRB, 0.91164464E-07_JPRB, 0.90739287E-07_JPRB, &
  & 0.89047451E-07_JPRB, 0.84782075E-07_JPRB, 0.76522885E-07_JPRB, 0.63856664E-07_JPRB, 0.53805100E-07_JPRB, 0.47658498E-07_JPRB, &
  & 0.44428110E-07_JPRB, 0.42734111E-07_JPRB, 0.41789991E-07_JPRB, 0.40308020E-07_JPRB, 0.38268526E-07_JPRB, 0.36433859E-07_JPRB, &
  & 0.35140024E-07_JPRB, 0.34408040E-07_JPRB, 0.33297429E-07_JPRB, 0.31869917E-07_JPRB, 0.31350945E-07_JPRB, 0.34117433E-07_JPRB, &
  & 0.38489744E-07_JPRB, 0.44354081E-07_JPRB, 0.50724564E-07_JPRB, 0.57255274E-07_JPRB, 0.62363798E-07_JPRB, 0.65640698E-07_JPRB, &
  & 0.69124160E-07_JPRB, 0.71556618E-07_JPRB, 0.74803729E-07_JPRB, 0.78359634E-07_JPRB, 0.82904748E-07_JPRB, 0.90359858E-07_JPRB, &
  & 0.10111104E-06_JPRB, 0.10942736E-06_JPRB, 0.11388811E-06_JPRB, 0.11838033E-06_JPRB, 0.12191249E-06_JPRB, 0.12734198E-06_JPRB, &
  & 0.13574065E-06_JPRB, 0.14429752E-06_JPRB, 0.15720611E-06_JPRB, 0.17067915E-06_JPRB, 0.18615419E-06_JPRB, 0.19739470E-06_JPRB, &
  & 0.20504770E-06_JPRB, 0.21506385E-06_JPRB, 0.22164978E-06_JPRB, 0.22702109E-06_JPRB  /)

RGHG7(:,55, 7) = (/ &
  & 0.66324947E-07_JPRB, 0.57058170E-07_JPRB, 0.51212883E-07_JPRB, 0.53092843E-07_JPRB, 0.55679258E-07_JPRB, 0.54840655E-07_JPRB, &
  & 0.55389436E-07_JPRB, 0.56426342E-07_JPRB, 0.56373547E-07_JPRB, 0.59935894E-07_JPRB, 0.63606367E-07_JPRB, 0.68221716E-07_JPRB, &
  & 0.68811076E-07_JPRB, 0.67361767E-07_JPRB, 0.67639241E-07_JPRB, 0.68702275E-07_JPRB, 0.69577908E-07_JPRB, 0.70546452E-07_JPRB, &
  & 0.71226793E-07_JPRB, 0.70678003E-07_JPRB, 0.67618658E-07_JPRB, 0.58840318E-07_JPRB, 0.50798876E-07_JPRB, 0.45480201E-07_JPRB, &
  & 0.42693622E-07_JPRB, 0.41324046E-07_JPRB, 0.40605724E-07_JPRB, 0.39375505E-07_JPRB, 0.37486543E-07_JPRB, 0.35812790E-07_JPRB, &
  & 0.34630557E-07_JPRB, 0.33824604E-07_JPRB, 0.32733458E-07_JPRB, 0.31241062E-07_JPRB, 0.30706517E-07_JPRB, 0.33606667E-07_JPRB, &
  & 0.38133404E-07_JPRB, 0.44053541E-07_JPRB, 0.50295553E-07_JPRB, 0.56128106E-07_JPRB, 0.61021213E-07_JPRB, 0.64090483E-07_JPRB, &
  & 0.67037998E-07_JPRB, 0.69190155E-07_JPRB, 0.72079104E-07_JPRB, 0.75150971E-07_JPRB, 0.78912279E-07_JPRB, 0.84326122E-07_JPRB, &
  & 0.91083012E-07_JPRB, 0.94860016E-07_JPRB, 0.96403553E-07_JPRB, 0.98623514E-07_JPRB, 0.99840595E-07_JPRB, 0.10284470E-06_JPRB, &
  & 0.10832098E-06_JPRB, 0.11360507E-06_JPRB, 0.12227152E-06_JPRB, 0.13101706E-06_JPRB, 0.14184897E-06_JPRB, 0.14901992E-06_JPRB, &
  & 0.15235032E-06_JPRB, 0.15809966E-06_JPRB, 0.16172945E-06_JPRB, 0.16327777E-06_JPRB  /)

RGHG7(:,56, 7) = (/ &
  & 0.53747279E-07_JPRB, 0.46481106E-07_JPRB, 0.41976224E-07_JPRB, 0.43573370E-07_JPRB, 0.45664260E-07_JPRB, 0.44954232E-07_JPRB, &
  & 0.45218020E-07_JPRB, 0.45936329E-07_JPRB, 0.45909291E-07_JPRB, 0.48850739E-07_JPRB, 0.51885838E-07_JPRB, 0.55887377E-07_JPRB, &
  & 0.56957622E-07_JPRB, 0.56084862E-07_JPRB, 0.56572115E-07_JPRB, 0.57682201E-07_JPRB, 0.59009386E-07_JPRB, 0.60313731E-07_JPRB, &
  & 0.61495865E-07_JPRB, 0.62091447E-07_JPRB, 0.61329538E-07_JPRB, 0.55318598E-07_JPRB, 0.48771735E-07_JPRB, 0.44171205E-07_JPRB, &
  & 0.41654774E-07_JPRB, 0.40573022E-07_JPRB, 0.40088341E-07_JPRB, 0.39034493E-07_JPRB, 0.37237565E-07_JPRB, 0.35633770E-07_JPRB, &
  & 0.34506870E-07_JPRB, 0.33617334E-07_JPRB, 0.32534840E-07_JPRB, 0.31047774E-07_JPRB, 0.30368327E-07_JPRB, 0.33262872E-07_JPRB, &
  & 0.37971204E-07_JPRB, 0.44003515E-07_JPRB, 0.49954018E-07_JPRB, 0.55383322E-07_JPRB, 0.60119073E-07_JPRB, 0.63064647E-07_JPRB, &
  & 0.65581735E-07_JPRB, 0.67630352E-07_JPRB, 0.70397776E-07_JPRB, 0.73307034E-07_JPRB, 0.76799084E-07_JPRB, 0.81130916E-07_JPRB, &
  & 0.85847149E-07_JPRB, 0.88162738E-07_JPRB, 0.88956670E-07_JPRB, 0.90450405E-07_JPRB, 0.90979854E-07_JPRB, 0.92940213E-07_JPRB, &
  & 0.96671459E-07_JPRB, 0.10015453E-06_JPRB, 0.10615460E-06_JPRB, 0.11211151E-06_JPRB, 0.11933104E-06_JPRB, 0.12387226E-06_JPRB, &
  & 0.12541495E-06_JPRB, 0.12959681E-06_JPRB, 0.13165619E-06_JPRB, 0.13136827E-06_JPRB  /)

RGHG7(:,57, 7) = (/ &
  & 0.41455412E-07_JPRB, 0.36078518E-07_JPRB, 0.32852462E-07_JPRB, 0.34180157E-07_JPRB, 0.35765115E-07_JPRB, 0.35188415E-07_JPRB, &
  & 0.35190034E-07_JPRB, 0.35621004E-07_JPRB, 0.35646754E-07_JPRB, 0.37994725E-07_JPRB, 0.40418342E-07_JPRB, 0.43829586E-07_JPRB, &
  & 0.45297712E-07_JPRB, 0.44998605E-07_JPRB, 0.45740308E-07_JPRB, 0.46948141E-07_JPRB, 0.48674704E-07_JPRB, 0.50303745E-07_JPRB, &
  & 0.52072229E-07_JPRB, 0.53705942E-07_JPRB, 0.54974268E-07_JPRB, 0.51699077E-07_JPRB, 0.46688068E-07_JPRB, 0.42866367E-07_JPRB, &
  & 0.40623826E-07_JPRB, 0.39812394E-07_JPRB, 0.39561047E-07_JPRB, 0.38689037E-07_JPRB, 0.37001861E-07_JPRB, 0.35484754E-07_JPRB, &
  & 0.34393853E-07_JPRB, 0.33426620E-07_JPRB, 0.32345600E-07_JPRB, 0.30842222E-07_JPRB, 0.30012409E-07_JPRB, 0.32906105E-07_JPRB, &
  & 0.37800808E-07_JPRB, 0.43918739E-07_JPRB, 0.49549434E-07_JPRB, 0.54601951E-07_JPRB, 0.59121139E-07_JPRB, 0.61915270E-07_JPRB, &
  & 0.64047968E-07_JPRB, 0.66000318E-07_JPRB, 0.68644166E-07_JPRB, 0.71396120E-07_JPRB, 0.74567637E-07_JPRB, 0.77829418E-07_JPRB, &
  & 0.80604244E-07_JPRB, 0.81438694E-07_JPRB, 0.81465237E-07_JPRB, 0.82227119E-07_JPRB, 0.82064768E-07_JPRB, 0.82985381E-07_JPRB, &
  & 0.85076128E-07_JPRB, 0.86915762E-07_JPRB, 0.90388864E-07_JPRB, 0.93701143E-07_JPRB, 0.97772586E-07_JPRB, 0.99998992E-07_JPRB, &
  & 0.10006102E-06_JPRB, 0.10270634E-06_JPRB, 0.10338776E-06_JPRB, 0.10158121E-06_JPRB  /)

RGHG7(:,58, 7) = (/ &
  & 0.32770604E-07_JPRB, 0.28929275E-07_JPRB, 0.26688539E-07_JPRB, 0.27727306E-07_JPRB, 0.28874493E-07_JPRB, 0.28518699E-07_JPRB, &
  & 0.28433437E-07_JPRB, 0.28770118E-07_JPRB, 0.29016774E-07_JPRB, 0.30958628E-07_JPRB, 0.32922923E-07_JPRB, 0.35740820E-07_JPRB, &
  & 0.37400218E-07_JPRB, 0.37567841E-07_JPRB, 0.38467816E-07_JPRB, 0.39728855E-07_JPRB, 0.41631873E-07_JPRB, 0.43342407E-07_JPRB, &
  & 0.45442249E-07_JPRB, 0.47368932E-07_JPRB, 0.49508758E-07_JPRB, 0.48485728E-07_JPRB, 0.44860095E-07_JPRB, 0.41836484E-07_JPRB, &
  & 0.39819563E-07_JPRB, 0.39220282E-07_JPRB, 0.39184453E-07_JPRB, 0.38474754E-07_JPRB, 0.36907460E-07_JPRB, 0.35481275E-07_JPRB, &
  & 0.34380272E-07_JPRB, 0.33349730E-07_JPRB, 0.32255914E-07_JPRB, 0.30714147E-07_JPRB, 0.29712593E-07_JPRB, 0.32587430E-07_JPRB, &
  & 0.37666671E-07_JPRB, 0.43829052E-07_JPRB, 0.49087306E-07_JPRB, 0.53893324E-07_JPRB, 0.58124258E-07_JPRB, 0.60747994E-07_JPRB, &
  & 0.62624765E-07_JPRB, 0.64534011E-07_JPRB, 0.67105122E-07_JPRB, 0.69781645E-07_JPRB, 0.72668274E-07_JPRB, 0.75146108E-07_JPRB, &
  & 0.76669584E-07_JPRB, 0.76685740E-07_JPRB, 0.76382944E-07_JPRB, 0.76752180E-07_JPRB, 0.76251736E-07_JPRB, 0.76482018E-07_JPRB, &
  & 0.77461501E-07_JPRB, 0.78331978E-07_JPRB, 0.80012241E-07_JPRB, 0.81499353E-07_JPRB, 0.83653360E-07_JPRB, 0.84552985E-07_JPRB, &
  & 0.84247287E-07_JPRB, 0.86037943E-07_JPRB, 0.86037116E-07_JPRB, 0.83742952E-07_JPRB  /)

RGHG7(:,59, 7) = (/ &
  & 0.26859563E-07_JPRB, 0.24076663E-07_JPRB, 0.22466919E-07_JPRB, 0.23291829E-07_JPRB, 0.24126603E-07_JPRB, 0.23957556E-07_JPRB, &
  & 0.23879399E-07_JPRB, 0.24226134E-07_JPRB, 0.24642806E-07_JPRB, 0.26368109E-07_JPRB, 0.28045726E-07_JPRB, 0.30423349E-07_JPRB, &
  & 0.32154246E-07_JPRB, 0.32673563E-07_JPRB, 0.33686876E-07_JPRB, 0.35021178E-07_JPRB, 0.36981725E-07_JPRB, 0.38680216E-07_JPRB, &
  & 0.40900462E-07_JPRB, 0.42910737E-07_JPRB, 0.45269780E-07_JPRB, 0.45703058E-07_JPRB, 0.43306221E-07_JPRB, 0.40922527E-07_JPRB, &
  & 0.39175026E-07_JPRB, 0.38664220E-07_JPRB, 0.38787719E-07_JPRB, 0.38317268E-07_JPRB, 0.36906489E-07_JPRB, 0.35495069E-07_JPRB, &
  & 0.34383305E-07_JPRB, 0.33291743E-07_JPRB, 0.32173981E-07_JPRB, 0.30510708E-07_JPRB, 0.29359162E-07_JPRB, 0.32231618E-07_JPRB, &
  & 0.37448202E-07_JPRB, 0.43513427E-07_JPRB, 0.48529655E-07_JPRB, 0.53122992E-07_JPRB, 0.57073310E-07_JPRB, 0.59422424E-07_JPRB, &
  & 0.61289214E-07_JPRB, 0.63183011E-07_JPRB, 0.65715438E-07_JPRB, 0.68356298E-07_JPRB, 0.70902988E-07_JPRB, 0.72809610E-07_JPRB, &
  & 0.73575226E-07_JPRB, 0.73133837E-07_JPRB, 0.72666678E-07_JPRB, 0.72772368E-07_JPRB, 0.72068365E-07_JPRB, 0.71902816E-07_JPRB, &
  & 0.72166547E-07_JPRB, 0.72447508E-07_JPRB, 0.73046495E-07_JPRB, 0.73428982E-07_JPRB, 0.74580386E-07_JPRB, 0.74825029E-07_JPRB, &
  & 0.74482316E-07_JPRB, 0.75616503E-07_JPRB, 0.75254698E-07_JPRB, 0.72864767E-07_JPRB  /)

RGHG7(:,60, 7) = (/ &
  & 0.22011419E-07_JPRB, 0.20091808E-07_JPRB, 0.18964291E-07_JPRB, 0.19608308E-07_JPRB, 0.20189980E-07_JPRB, 0.20190923E-07_JPRB, &
  & 0.20154611E-07_JPRB, 0.20540897E-07_JPRB, 0.21103881E-07_JPRB, 0.22686402E-07_JPRB, 0.24157061E-07_JPRB, 0.26163083E-07_JPRB, &
  & 0.27916925E-07_JPRB, 0.28743717E-07_JPRB, 0.29856818E-07_JPRB, 0.31273973E-07_JPRB, 0.33238387E-07_JPRB, 0.34903207E-07_JPRB, &
  & 0.37147745E-07_JPRB, 0.39178115E-07_JPRB, 0.41512417E-07_JPRB, 0.43037472E-07_JPRB, 0.41832591E-07_JPRB, 0.40032251E-07_JPRB, &
  & 0.38564044E-07_JPRB, 0.38102749E-07_JPRB, 0.38358175E-07_JPRB, 0.38112733E-07_JPRB, 0.36860380E-07_JPRB, 0.35430452E-07_JPRB, &
  & 0.34292249E-07_JPRB, 0.33155987E-07_JPRB, 0.32023188E-07_JPRB, 0.30193351E-07_JPRB, 0.28905331E-07_JPRB, 0.31809112E-07_JPRB, &
  & 0.37127029E-07_JPRB, 0.43013615E-07_JPRB, 0.47851413E-07_JPRB, 0.52249001E-07_JPRB, 0.55929045E-07_JPRB, 0.57966218E-07_JPRB, &
  & 0.59929959E-07_JPRB, 0.61821776E-07_JPRB, 0.64327481E-07_JPRB, 0.66928999E-07_JPRB, 0.69108457E-07_JPRB, 0.70521326E-07_JPRB, &
  & 0.70715781E-07_JPRB, 0.69957437E-07_JPRB, 0.69388754E-07_JPRB, 0.69265062E-07_JPRB, 0.68410271E-07_JPRB, 0.67953583E-07_JPRB, &
  & 0.67668270E-07_JPRB, 0.67504830E-07_JPRB, 0.67308862E-07_JPRB, 0.66874298E-07_JPRB, 0.67369493E-07_JPRB, 0.67235682E-07_JPRB, &
  & 0.66945776E-07_JPRB, 0.67502682E-07_JPRB, 0.66893414E-07_JPRB, 0.64572815E-07_JPRB  /)

RGHG7(:,61, 7) = (/ &
  & 0.18763125E-07_JPRB, 0.17376591E-07_JPRB, 0.16495896E-07_JPRB, 0.17027455E-07_JPRB, 0.17479874E-07_JPRB, 0.17598387E-07_JPRB, &
  & 0.17619764E-07_JPRB, 0.18027227E-07_JPRB, 0.18680761E-07_JPRB, 0.20204132E-07_JPRB, 0.21607609E-07_JPRB, 0.23387986E-07_JPRB, &
  & 0.25114809E-07_JPRB, 0.26165056E-07_JPRB, 0.27363595E-07_JPRB, 0.28863997E-07_JPRB, 0.30763420E-07_JPRB, 0.32430430E-07_JPRB, &
  & 0.34570544E-07_JPRB, 0.36624281E-07_JPRB, 0.38769450E-07_JPRB, 0.40731922E-07_JPRB, 0.40575669E-07_JPRB, 0.39234652E-07_JPRB, &
  & 0.37985518E-07_JPRB, 0.37563655E-07_JPRB, 0.37889186E-07_JPRB, 0.37676604E-07_JPRB, 0.36518452E-07_JPRB, 0.35033756E-07_JPRB, &
  & 0.33810115E-07_JPRB, 0.32700141E-07_JPRB, 0.31605315E-07_JPRB, 0.29557135E-07_JPRB, 0.28182216E-07_JPRB, 0.31229125E-07_JPRB, &
  & 0.36544852E-07_JPRB, 0.42128386E-07_JPRB, 0.46910686E-07_JPRB, 0.51170258E-07_JPRB, 0.54656058E-07_JPRB, 0.56411357E-07_JPRB, &
  & 0.58581027E-07_JPRB, 0.60491099E-07_JPRB, 0.62980009E-07_JPRB, 0.65482944E-07_JPRB, 0.67312616E-07_JPRB, 0.68357442E-07_JPRB, &
  & 0.68208684E-07_JPRB, 0.67300640E-07_JPRB, 0.66693984E-07_JPRB, 0.66353409E-07_JPRB, 0.65416832E-07_JPRB, 0.64769550E-07_JPRB, &
  & 0.64202363E-07_JPRB, 0.63776766E-07_JPRB, 0.63179895E-07_JPRB, 0.62319599E-07_JPRB, 0.62517585E-07_JPRB, 0.62342881E-07_JPRB, &
  & 0.62044212E-07_JPRB, 0.62188530E-07_JPRB, 0.61427372E-07_JPRB, 0.59341912E-07_JPRB  /)

RGHG7(:,62, 7) = (/ &
  & 0.16224868E-07_JPRB, 0.15215961E-07_JPRB, 0.14479138E-07_JPRB, 0.14941685E-07_JPRB, 0.15341819E-07_JPRB, 0.15530834E-07_JPRB, &
  & 0.15602550E-07_JPRB, 0.16000510E-07_JPRB, 0.16701532E-07_JPRB, 0.18198465E-07_JPRB, 0.19583974E-07_JPRB, 0.21200705E-07_JPRB, &
  & 0.22885052E-07_JPRB, 0.24118307E-07_JPRB, 0.25383926E-07_JPRB, 0.26956716E-07_JPRB, 0.28784749E-07_JPRB, 0.30474023E-07_JPRB, &
  & 0.32500975E-07_JPRB, 0.34548552E-07_JPRB, 0.36551535E-07_JPRB, 0.38666421E-07_JPRB, 0.39353297E-07_JPRB, 0.38502469E-07_JPRB, &
  & 0.37456149E-07_JPRB, 0.37050651E-07_JPRB, 0.37371755E-07_JPRB, 0.37094153E-07_JPRB, 0.36039153E-07_JPRB, 0.34533621E-07_JPRB, &
  & 0.33215330E-07_JPRB, 0.32031933E-07_JPRB, 0.30800595E-07_JPRB, 0.28517920E-07_JPRB, 0.27159288E-07_JPRB, 0.30409030E-07_JPRB, &
  & 0.35638162E-07_JPRB, 0.40865733E-07_JPRB, 0.45656177E-07_JPRB, 0.49723596E-07_JPRB, 0.53027337E-07_JPRB, 0.54798832E-07_JPRB, &
  & 0.57144778E-07_JPRB, 0.59097475E-07_JPRB, 0.61553376E-07_JPRB, 0.63881063E-07_JPRB, 0.65454669E-07_JPRB, 0.66166747E-07_JPRB, &
  & 0.65735728E-07_JPRB, 0.64744028E-07_JPRB, 0.64111163E-07_JPRB, 0.63552736E-07_JPRB, 0.62557171E-07_JPRB, 0.61762412E-07_JPRB, &
  & 0.61037349E-07_JPRB, 0.60439081E-07_JPRB, 0.59605297E-07_JPRB, 0.58484629E-07_JPRB, 0.58489454E-07_JPRB, 0.58360129E-07_JPRB, &
  & 0.57977274E-07_JPRB, 0.57825590E-07_JPRB, 0.56982840E-07_JPRB, 0.55132989E-07_JPRB  /)

RGHG7(:,63, 7) = (/ &
  & 0.14110660E-07_JPRB, 0.13379251E-07_JPRB, 0.12729794E-07_JPRB, 0.13148267E-07_JPRB, 0.13544400E-07_JPRB, 0.13774945E-07_JPRB, &
  & 0.13887981E-07_JPRB, 0.14258634E-07_JPRB, 0.14976742E-07_JPRB, 0.16464774E-07_JPRB, 0.17854711E-07_JPRB, 0.19346304E-07_JPRB, &
  & 0.20975045E-07_JPRB, 0.22360525E-07_JPRB, 0.23689693E-07_JPRB, 0.25318675E-07_JPRB, 0.27077783E-07_JPRB, 0.28793252E-07_JPRB, &
  & 0.30703549E-07_JPRB, 0.32720327E-07_JPRB, 0.34627924E-07_JPRB, 0.36760051E-07_JPRB, 0.38109148E-07_JPRB, 0.37779975E-07_JPRB, &
  & 0.36957326E-07_JPRB, 0.36574827E-07_JPRB, 0.36821325E-07_JPRB, 0.36467019E-07_JPRB, 0.35463917E-07_JPRB, 0.33946952E-07_JPRB, &
  & 0.32539334E-07_JPRB, 0.31168995E-07_JPRB, 0.29646653E-07_JPRB, 0.27149446E-07_JPRB, 0.25924131E-07_JPRB, 0.29376640E-07_JPRB, &
  & 0.34478641E-07_JPRB, 0.39343819E-07_JPRB, 0.44153034E-07_JPRB, 0.47963672E-07_JPRB, 0.51095447E-07_JPRB, 0.53068964E-07_JPRB, &
  & 0.55589077E-07_JPRB, 0.57599441E-07_JPRB, 0.60013978E-07_JPRB, 0.62122081E-07_JPRB, 0.63501238E-07_JPRB, 0.63902674E-07_JPRB, &
  & 0.63226590E-07_JPRB, 0.62183953E-07_JPRB, 0.61515773E-07_JPRB, 0.60748467E-07_JPRB, 0.59703453E-07_JPRB, 0.58811357E-07_JPRB, &
  & 0.58005251E-07_JPRB, 0.57289974E-07_JPRB, 0.56311938E-07_JPRB, 0.55037666E-07_JPRB, 0.54924962E-07_JPRB, 0.54867207E-07_JPRB, &
  & 0.54381751E-07_JPRB, 0.54011273E-07_JPRB, 0.53155269E-07_JPRB, 0.51546858E-07_JPRB  /)

RGHG7(:,64, 7) = (/ &
  & 0.12408025E-07_JPRB, 0.11853122E-07_JPRB, 0.11252384E-07_JPRB, 0.11646098E-07_JPRB, 0.12079769E-07_JPRB, 0.12326287E-07_JPRB, &
  & 0.12464082E-07_JPRB, 0.12795601E-07_JPRB, 0.13498534E-07_JPRB, 0.14988163E-07_JPRB, 0.16387684E-07_JPRB, 0.17791423E-07_JPRB, &
  & 0.19349880E-07_JPRB, 0.20846376E-07_JPRB, 0.22246626E-07_JPRB, 0.23900367E-07_JPRB, 0.25605964E-07_JPRB, 0.27335809E-07_JPRB, &
  & 0.29134292E-07_JPRB, 0.31090371E-07_JPRB, 0.32974805E-07_JPRB, 0.35078979E-07_JPRB, 0.36824218E-07_JPRB, 0.37042935E-07_JPRB, &
  & 0.36503815E-07_JPRB, 0.36183612E-07_JPRB, 0.36259993E-07_JPRB, 0.35903292E-07_JPRB, 0.34813134E-07_JPRB, 0.33273806E-07_JPRB, &
  & 0.31803093E-07_JPRB, 0.30072553E-07_JPRB, 0.28064617E-07_JPRB, 0.25427642E-07_JPRB, 0.24516206E-07_JPRB, 0.28102093E-07_JPRB, &
  & 0.33067521E-07_JPRB, 0.37622814E-07_JPRB, 0.42411263E-07_JPRB, 0.45869686E-07_JPRB, 0.48848914E-07_JPRB, 0.51173848E-07_JPRB, &
  & 0.53886442E-07_JPRB, 0.55964692E-07_JPRB, 0.58335303E-07_JPRB, 0.60200609E-07_JPRB, 0.61450380E-07_JPRB, 0.61572281E-07_JPRB, &
  & 0.60690938E-07_JPRB, 0.59613160E-07_JPRB, 0.58876293E-07_JPRB, 0.57931682E-07_JPRB, 0.56839546E-07_JPRB, 0.55934672E-07_JPRB, &
  & 0.55114988E-07_JPRB, 0.54334220E-07_JPRB, 0.53280310E-07_JPRB, 0.51954923E-07_JPRB, 0.51811071E-07_JPRB, 0.51798839E-07_JPRB, &
  & 0.51246295E-07_JPRB, 0.50738446E-07_JPRB, 0.49967899E-07_JPRB, 0.48605480E-07_JPRB  /)

RGHG7(:,65, 7) = (/ &
  & 0.11047372E-07_JPRB, 0.10564766E-07_JPRB, 0.99863578E-08_JPRB, 0.10367761E-07_JPRB, 0.10856354E-07_JPRB, 0.11118967E-07_JPRB, &
  & 0.11259409E-07_JPRB, 0.11555211E-07_JPRB, 0.12222782E-07_JPRB, 0.13705845E-07_JPRB, 0.15114280E-07_JPRB, 0.16457742E-07_JPRB, &
  & 0.17942406E-07_JPRB, 0.19503190E-07_JPRB, 0.20947559E-07_JPRB, 0.22585363E-07_JPRB, 0.24243731E-07_JPRB, 0.25971708E-07_JPRB, &
  & 0.27702869E-07_JPRB, 0.29568794E-07_JPRB, 0.31501997E-07_JPRB, 0.33597331E-07_JPRB, 0.35506833E-07_JPRB, 0.36227070E-07_JPRB, &
  & 0.36016013E-07_JPRB, 0.35712494E-07_JPRB, 0.35737140E-07_JPRB, 0.35308892E-07_JPRB, 0.34087901E-07_JPRB, 0.32556517E-07_JPRB, &
  & 0.30840848E-07_JPRB, 0.28554086E-07_JPRB, 0.26192144E-07_JPRB, 0.23666333E-07_JPRB, 0.23060763E-07_JPRB, 0.26679949E-07_JPRB, &
  & 0.31559797E-07_JPRB, 0.35941849E-07_JPRB, 0.40487111E-07_JPRB, 0.43627056E-07_JPRB, 0.46521707E-07_JPRB, 0.49078083E-07_JPRB, &
  & 0.52048554E-07_JPRB, 0.54184059E-07_JPRB, 0.56509664E-07_JPRB, 0.58171207E-07_JPRB, 0.59296553E-07_JPRB, 0.59242343E-07_JPRB, &
  & 0.58150457E-07_JPRB, 0.57069234E-07_JPRB, 0.56199229E-07_JPRB, 0.55113871E-07_JPRB, 0.54031493E-07_JPRB, 0.53171724E-07_JPRB, &
  & 0.52381474E-07_JPRB, 0.51597157E-07_JPRB, 0.50561201E-07_JPRB, 0.49244521E-07_JPRB, 0.49127265E-07_JPRB, 0.49128197E-07_JPRB, &
  & 0.48595026E-07_JPRB, 0.48011942E-07_JPRB, 0.47388461E-07_JPRB, 0.46238971E-07_JPRB  /)

RGHG7(:,66, 7) = (/ &
  & 0.98314841E-08_JPRB, 0.93749681E-08_JPRB, 0.88029191E-08_JPRB, 0.91785133E-08_JPRB, 0.97195662E-08_JPRB, 0.10001784E-07_JPRB, &
  & 0.10132740E-07_JPRB, 0.10396369E-07_JPRB, 0.11021707E-07_JPRB, 0.12485246E-07_JPRB, 0.13900788E-07_JPRB, 0.15195308E-07_JPRB, &
  & 0.16610489E-07_JPRB, 0.18208147E-07_JPRB, 0.19689814E-07_JPRB, 0.21284143E-07_JPRB, 0.22902656E-07_JPRB, 0.24608168E-07_JPRB, &
  & 0.26296848E-07_JPRB, 0.28083413E-07_JPRB, 0.30055735E-07_JPRB, 0.32136698E-07_JPRB, 0.34144437E-07_JPRB, 0.35271763E-07_JPRB, &
  & 0.35393289E-07_JPRB, 0.35173075E-07_JPRB, 0.35121087E-07_JPRB, 0.34585904E-07_JPRB, 0.33334889E-07_JPRB, 0.31789297E-07_JPRB, &
  & 0.29695220E-07_JPRB, 0.26909060E-07_JPRB, 0.24328610E-07_JPRB, 0.22059372E-07_JPRB, 0.21720577E-07_JPRB, 0.25293420E-07_JPRB, &
  & 0.29995286E-07_JPRB, 0.34200611E-07_JPRB, 0.38433734E-07_JPRB, 0.41358107E-07_JPRB, 0.44243470E-07_JPRB, 0.46964865E-07_JPRB, &
  & 0.50137651E-07_JPRB, 0.52267548E-07_JPRB, 0.54563361E-07_JPRB, 0.56057226E-07_JPRB, 0.57051706E-07_JPRB, 0.56914802E-07_JPRB, &
  & 0.55600608E-07_JPRB, 0.54502646E-07_JPRB, 0.53486144E-07_JPRB, 0.52268686E-07_JPRB, 0.51251109E-07_JPRB, 0.50448509E-07_JPRB, &
  & 0.49716080E-07_JPRB, 0.48978352E-07_JPRB, 0.48000363E-07_JPRB, 0.46741580E-07_JPRB, 0.46659908E-07_JPRB, 0.46678946E-07_JPRB, &
  & 0.46214392E-07_JPRB, 0.45571057E-07_JPRB, 0.45077980E-07_JPRB, 0.44154666E-07_JPRB  /)

RGHG7(:,67, 7) = (/ &
  & 0.87449091E-08_JPRB, 0.82825686E-08_JPRB, 0.77054266E-08_JPRB, 0.80787859E-08_JPRB, 0.86635527E-08_JPRB, 0.89669452E-08_JPRB, &
  & 0.90790808E-08_JPRB, 0.93135551E-08_JPRB, 0.98947046E-08_JPRB, 0.11323582E-07_JPRB, 0.12739134E-07_JPRB, 0.13996142E-07_JPRB, &
  & 0.15347039E-07_JPRB, 0.16957841E-07_JPRB, 0.18468418E-07_JPRB, 0.20002962E-07_JPRB, 0.21584033E-07_JPRB, 0.23250431E-07_JPRB, &
  & 0.24917392E-07_JPRB, 0.26639356E-07_JPRB, 0.28618398E-07_JPRB, 0.30681045E-07_JPRB, 0.32721505E-07_JPRB, 0.34158881E-07_JPRB, &
  & 0.34615590E-07_JPRB, 0.34537176E-07_JPRB, 0.34368144E-07_JPRB, 0.33694201E-07_JPRB, 0.32522891E-07_JPRB, 0.30936752E-07_JPRB, &
  & 0.28369115E-07_JPRB, 0.25237050E-07_JPRB, 0.22590228E-07_JPRB, 0.20655446E-07_JPRB, 0.20540795E-07_JPRB, 0.23970977E-07_JPRB, &
  & 0.28392226E-07_JPRB, 0.32390028E-07_JPRB, 0.36310479E-07_JPRB, 0.39134295E-07_JPRB, 0.42067118E-07_JPRB, 0.44889828E-07_JPRB, &
  & 0.48178995E-07_JPRB, 0.50263873E-07_JPRB, 0.52526992E-07_JPRB, 0.53876675E-07_JPRB, 0.54750348E-07_JPRB, 0.54612195E-07_JPRB, &
  & 0.53084971E-07_JPRB, 0.51946415E-07_JPRB, 0.50774100E-07_JPRB, 0.49445032E-07_JPRB, 0.48537181E-07_JPRB, 0.47798152E-07_JPRB, &
  & 0.47143051E-07_JPRB, 0.46498423E-07_JPRB, 0.45613989E-07_JPRB, 0.44463328E-07_JPRB, 0.44419642E-07_JPRB, 0.44477316E-07_JPRB, &
  & 0.44108555E-07_JPRB, 0.43409325E-07_JPRB, 0.43027745E-07_JPRB, 0.42326232E-07_JPRB  /)

RGHG7(:,68, 7) = (/ &
  & 0.77709992E-08_JPRB, 0.72922569E-08_JPRB, 0.67069139E-08_JPRB, 0.70761727E-08_JPRB, 0.76871825E-08_JPRB, 0.80086170E-08_JPRB, &
  & 0.80969700E-08_JPRB, 0.83035612E-08_JPRB, 0.88461663E-08_JPRB, 0.10221737E-07_JPRB, 0.11619248E-07_JPRB, 0.12852473E-07_JPRB, &
  & 0.14143503E-07_JPRB, 0.15749385E-07_JPRB, 0.17273903E-07_JPRB, 0.18754321E-07_JPRB, 0.20288647E-07_JPRB, 0.21909120E-07_JPRB, &
  & 0.23568700E-07_JPRB, 0.25239818E-07_JPRB, 0.27161454E-07_JPRB, 0.29210159E-07_JPRB, 0.31189932E-07_JPRB, 0.32853654E-07_JPRB, &
  & 0.33656442E-07_JPRB, 0.33737126E-07_JPRB, 0.33405716E-07_JPRB, 0.32562013E-07_JPRB, 0.31566203E-07_JPRB, 0.29915277E-07_JPRB, &
  & 0.26851483E-07_JPRB, 0.23675134E-07_JPRB, 0.21140664E-07_JPRB, 0.19492094E-07_JPRB, 0.19562784E-07_JPRB, 0.22716595E-07_JPRB, &
  & 0.26762242E-07_JPRB, 0.30488593E-07_JPRB, 0.34210582E-07_JPRB, 0.37054080E-07_JPRB, 0.40046770E-07_JPRB, 0.42907203E-07_JPRB, &
  & 0.46190630E-07_JPRB, 0.48254185E-07_JPRB, 0.50438576E-07_JPRB, 0.51637362E-07_JPRB, 0.52436407E-07_JPRB, 0.52349919E-07_JPRB, &
  & 0.50662777E-07_JPRB, 0.49446312E-07_JPRB, 0.48105878E-07_JPRB, 0.46714484E-07_JPRB, 0.45938667E-07_JPRB, 0.45266886E-07_JPRB, &
  & 0.44692154E-07_JPRB, 0.44180381E-07_JPRB, 0.43425522E-07_JPRB, 0.42436419E-07_JPRB, 0.42428817E-07_JPRB, 0.42571781E-07_JPRB, &
  & 0.42285029E-07_JPRB, 0.41519371E-07_JPRB, 0.41243584E-07_JPRB, 0.40715110E-07_JPRB  /)

RGHG7(:,69, 7) = (/ &
  & 0.68976178E-08_JPRB, 0.64121799E-08_JPRB, 0.58343118E-08_JPRB, 0.61920069E-08_JPRB, 0.68091022E-08_JPRB, 0.71329011E-08_JPRB, &
  & 0.71989685E-08_JPRB, 0.73761889E-08_JPRB, 0.78869743E-08_JPRB, 0.91965603E-08_JPRB, 0.10561104E-07_JPRB, 0.11772790E-07_JPRB, &
  & 0.12997247E-07_JPRB, 0.14579549E-07_JPRB, 0.16087404E-07_JPRB, 0.17540576E-07_JPRB, 0.19016970E-07_JPRB, 0.20575851E-07_JPRB, &
  & 0.22201182E-07_JPRB, 0.23857291E-07_JPRB, 0.25705109E-07_JPRB, 0.27746593E-07_JPRB, 0.29600754E-07_JPRB, 0.31320602E-07_JPRB, &
  & 0.32385809E-07_JPRB, 0.32669599E-07_JPRB, 0.32125086E-07_JPRB, 0.31261680E-07_JPRB, 0.30436859E-07_JPRB, 0.28673389E-07_JPRB, &
  & 0.25506134E-07_JPRB, 0.22384032E-07_JPRB, 0.20012650E-07_JPRB, 0.18490511E-07_JPRB, 0.18624099E-07_JPRB, 0.21391122E-07_JPRB, &
  & 0.25124680E-07_JPRB, 0.28676662E-07_JPRB, 0.32187535E-07_JPRB, 0.35054444E-07_JPRB, 0.38189839E-07_JPRB, 0.40984988E-07_JPRB, &
  & 0.44163405E-07_JPRB, 0.46243707E-07_JPRB, 0.48379240E-07_JPRB, 0.49403272E-07_JPRB, 0.50153079E-07_JPRB, 0.50072717E-07_JPRB, &
  & 0.48381684E-07_JPRB, 0.47070903E-07_JPRB, 0.45569099E-07_JPRB, 0.44178086E-07_JPRB, 0.43505917E-07_JPRB, 0.42917792E-07_JPRB, &
  & 0.42401022E-07_JPRB, 0.42028051E-07_JPRB, 0.41433345E-07_JPRB, 0.40659511E-07_JPRB, 0.40714111E-07_JPRB, 0.40962501E-07_JPRB, &
  & 0.40729381E-07_JPRB, 0.39921938E-07_JPRB, 0.39728039E-07_JPRB, 0.39428553E-07_JPRB  /)

RGHG7(:,70, 7) = (/ &
  & 0.60763387E-08_JPRB, 0.55946812E-08_JPRB, 0.50463434E-08_JPRB, 0.53898086E-08_JPRB, 0.59981440E-08_JPRB, 0.63151393E-08_JPRB, &
  & 0.63585475E-08_JPRB, 0.65066677E-08_JPRB, 0.69828972E-08_JPRB, 0.82246374E-08_JPRB, 0.95503858E-08_JPRB, 0.10735945E-07_JPRB, &
  & 0.11906854E-07_JPRB, 0.13444147E-07_JPRB, 0.14924659E-07_JPRB, 0.16352707E-07_JPRB, 0.17759939E-07_JPRB, 0.19239832E-07_JPRB, &
  & 0.20806269E-07_JPRB, 0.22447540E-07_JPRB, 0.24243602E-07_JPRB, 0.26267075E-07_JPRB, 0.28007549E-07_JPRB, 0.29695822E-07_JPRB, &
  & 0.30914207E-07_JPRB, 0.31305774E-07_JPRB, 0.30705235E-07_JPRB, 0.29857393E-07_JPRB, 0.29130067E-07_JPRB, 0.27375881E-07_JPRB, &
  & 0.24388207E-07_JPRB, 0.21309218E-07_JPRB, 0.18983778E-07_JPRB, 0.17513456E-07_JPRB, 0.17640792E-07_JPRB, 0.20061299E-07_JPRB, &
  & 0.23463626E-07_JPRB, 0.26944833E-07_JPRB, 0.30193831E-07_JPRB, 0.33146998E-07_JPRB, 0.36389718E-07_JPRB, 0.39088788E-07_JPRB, &
  & 0.42087370E-07_JPRB, 0.44228244E-07_JPRB, 0.46319675E-07_JPRB, 0.47177684E-07_JPRB, 0.47926413E-07_JPRB, 0.47827678E-07_JPRB, &
  & 0.46202477E-07_JPRB, 0.44800338E-07_JPRB, 0.43182302E-07_JPRB, 0.41805964E-07_JPRB, 0.41234849E-07_JPRB, 0.40719300E-07_JPRB, &
  & 0.40265547E-07_JPRB, 0.40007938E-07_JPRB, 0.39590070E-07_JPRB, 0.39038193E-07_JPRB, 0.39173424E-07_JPRB, 0.39521816E-07_JPRB, &
  & 0.39350118E-07_JPRB, 0.38526116E-07_JPRB, 0.38371876E-07_JPRB, 0.38311174E-07_JPRB  /)

RGHG7(:,71, 7) = (/ &
  & 0.53010603E-08_JPRB, 0.48352505E-08_JPRB, 0.43411973E-08_JPRB, 0.46665729E-08_JPRB, 0.52537341E-08_JPRB, 0.55575796E-08_JPRB, &
  & 0.55777784E-08_JPRB, 0.56979720E-08_JPRB, 0.61339254E-08_JPRB, 0.73101660E-08_JPRB, 0.85917428E-08_JPRB, 0.97440060E-08_JPRB, &
  & 0.10871787E-07_JPRB, 0.12348277E-07_JPRB, 0.13795101E-07_JPRB, 0.15189207E-07_JPRB, 0.16523344E-07_JPRB, 0.17912249E-07_JPRB, &
  & 0.19394211E-07_JPRB, 0.21006861E-07_JPRB, 0.22769246E-07_JPRB, 0.24756715E-07_JPRB, 0.26398823E-07_JPRB, 0.28014251E-07_JPRB, &
  & 0.29275942E-07_JPRB, 0.29690639E-07_JPRB, 0.29173212E-07_JPRB, 0.28386980E-07_JPRB, 0.27681898E-07_JPRB, 0.26065348E-07_JPRB, &
  & 0.23423468E-07_JPRB, 0.20411686E-07_JPRB, 0.18035259E-07_JPRB, 0.16550822E-07_JPRB, 0.16623275E-07_JPRB, 0.18752664E-07_JPRB, &
  & 0.21805635E-07_JPRB, 0.25248617E-07_JPRB, 0.28261409E-07_JPRB, 0.31336097E-07_JPRB, 0.34627112E-07_JPRB, 0.37194812E-07_JPRB, &
  & 0.39978228E-07_JPRB, 0.42214023E-07_JPRB, 0.44269349E-07_JPRB, 0.44983062E-07_JPRB, 0.45778713E-07_JPRB, 0.45644637E-07_JPRB, &
  & 0.44116323E-07_JPRB, 0.42636616E-07_JPRB, 0.40963518E-07_JPRB, 0.39599862E-07_JPRB, 0.39122147E-07_JPRB, 0.38662828E-07_JPRB, &
  & 0.38277881E-07_JPRB, 0.38110179E-07_JPRB, 0.37886239E-07_JPRB, 0.37559063E-07_JPRB, 0.37787545E-07_JPRB, 0.38226898E-07_JPRB, &
  & 0.38129997E-07_JPRB, 0.37316330E-07_JPRB, 0.37160575E-07_JPRB, 0.37317629E-07_JPRB  /)

RGHG7(:,72, 7) = (/ &
  & 0.45684088E-08_JPRB, 0.41337937E-08_JPRB, 0.37234738E-08_JPRB, 0.40234011E-08_JPRB, 0.45801884E-08_JPRB, 0.48684366E-08_JPRB, &
  & 0.48648288E-08_JPRB, 0.49595741E-08_JPRB, 0.53454517E-08_JPRB, 0.64642284E-08_JPRB, 0.76949085E-08_JPRB, 0.88028423E-08_JPRB, &
  & 0.98887570E-08_JPRB, 0.11299573E-07_JPRB, 0.12710277E-07_JPRB, 0.14045277E-07_JPRB, 0.15316204E-07_JPRB, 0.16612346E-07_JPRB, &
  & 0.17981022E-07_JPRB, 0.19531282E-07_JPRB, 0.21262473E-07_JPRB, 0.23185089E-07_JPRB, 0.24734434E-07_JPRB, 0.26307174E-07_JPRB, &
  & 0.27504014E-07_JPRB, 0.27905575E-07_JPRB, 0.27535092E-07_JPRB, 0.26903192E-07_JPRB, 0.26154602E-07_JPRB, 0.24784326E-07_JPRB, &
  & 0.22456035E-07_JPRB, 0.19628138E-07_JPRB, 0.17176186E-07_JPRB, 0.15608837E-07_JPRB, 0.15604945E-07_JPRB, 0.17496269E-07_JPRB, &
  & 0.20199531E-07_JPRB, 0.23498032E-07_JPRB, 0.26456643E-07_JPRB, 0.29623274E-07_JPRB, 0.32881452E-07_JPRB, 0.35257059E-07_JPRB, &
  & 0.37859873E-07_JPRB, 0.40206492E-07_JPRB, 0.42245400E-07_JPRB, 0.42854856E-07_JPRB, 0.43741629E-07_JPRB, 0.43564865E-07_JPRB, &
  & 0.42108791E-07_JPRB, 0.40582292E-07_JPRB, 0.38939568E-07_JPRB, 0.37565241E-07_JPRB, 0.37158124E-07_JPRB, 0.36734104E-07_JPRB, &
  & 0.36419756E-07_JPRB, 0.36318548E-07_JPRB, 0.36310508E-07_JPRB, 0.36214009E-07_JPRB, 0.36539360E-07_JPRB, 0.37059162E-07_JPRB, &
  & 0.37054203E-07_JPRB, 0.36281582E-07_JPRB, 0.36088065E-07_JPRB, 0.36392063E-07_JPRB  /)

RGHG7(:,73, 7) = (/ &
  & 0.38865497E-08_JPRB, 0.35092156E-08_JPRB, 0.31968295E-08_JPRB, 0.34688749E-08_JPRB, 0.39852073E-08_JPRB, 0.42577674E-08_JPRB, &
  & 0.42264054E-08_JPRB, 0.43016498E-08_JPRB, 0.46485896E-08_JPRB, 0.56996637E-08_JPRB, 0.68700086E-08_JPRB, 0.79173555E-08_JPRB, &
  & 0.89497317E-08_JPRB, 0.10280017E-07_JPRB, 0.11653629E-07_JPRB, 0.12920799E-07_JPRB, 0.14114434E-07_JPRB, 0.15327940E-07_JPRB, &
  & 0.16597911E-07_JPRB, 0.18046562E-07_JPRB, 0.19729614E-07_JPRB, 0.21543573E-07_JPRB, 0.23023997E-07_JPRB, 0.24466944E-07_JPRB, &
  & 0.25651888E-07_JPRB, 0.26172050E-07_JPRB, 0.25975269E-07_JPRB, 0.25378215E-07_JPRB, 0.24638435E-07_JPRB, 0.23433577E-07_JPRB, &
  & 0.21307171E-07_JPRB, 0.18748799E-07_JPRB, 0.16323743E-07_JPRB, 0.14755287E-07_JPRB, 0.14698226E-07_JPRB, 0.16391246E-07_JPRB, &
  & 0.18789244E-07_JPRB, 0.21825091E-07_JPRB, 0.24815303E-07_JPRB, 0.28023362E-07_JPRB, 0.31026034E-07_JPRB, 0.33257193E-07_JPRB, &
  & 0.35768264E-07_JPRB, 0.38267493E-07_JPRB, 0.40399603E-07_JPRB, 0.40972008E-07_JPRB, 0.41885669E-07_JPRB, 0.41714732E-07_JPRB, &
  & 0.40221603E-07_JPRB, 0.38654135E-07_JPRB, 0.37077771E-07_JPRB, 0.35664519E-07_JPRB, 0.35281934E-07_JPRB, 0.34844656E-07_JPRB, &
  & 0.34580745E-07_JPRB, 0.34584513E-07_JPRB, 0.34816485E-07_JPRB, 0.34978669E-07_JPRB, 0.35381640E-07_JPRB, 0.35998360E-07_JPRB, &
  & 0.36054638E-07_JPRB, 0.35338540E-07_JPRB, 0.35108565E-07_JPRB, 0.35488740E-07_JPRB  /)

RGHG7(:,74, 7) = (/ &
  & 0.32559557E-08_JPRB, 0.29479498E-08_JPRB, 0.27296299E-08_JPRB, 0.29785759E-08_JPRB, 0.34511699E-08_JPRB, 0.37075557E-08_JPRB, &
  & 0.36466499E-08_JPRB, 0.37118378E-08_JPRB, 0.40277586E-08_JPRB, 0.50068717E-08_JPRB, 0.61102037E-08_JPRB, 0.70981396E-08_JPRB, &
  & 0.80839845E-08_JPRB, 0.93226616E-08_JPRB, 0.10644764E-07_JPRB, 0.11848896E-07_JPRB, 0.12957197E-07_JPRB, 0.14058771E-07_JPRB, &
  & 0.15258633E-07_JPRB, 0.16599014E-07_JPRB, 0.18201821E-07_JPRB, 0.19873810E-07_JPRB, 0.21279462E-07_JPRB, 0.22544778E-07_JPRB, &
  & 0.23722296E-07_JPRB, 0.24365073E-07_JPRB, 0.24343563E-07_JPRB, 0.23798529E-07_JPRB, 0.23193402E-07_JPRB, 0.22159374E-07_JPRB, &
  & 0.20250024E-07_JPRB, 0.17965118E-07_JPRB, 0.15535392E-07_JPRB, 0.14018318E-07_JPRB, 0.13920009E-07_JPRB, 0.15438607E-07_JPRB, &
  & 0.17597870E-07_JPRB, 0.20345044E-07_JPRB, 0.23381477E-07_JPRB, 0.26575611E-07_JPRB, 0.29296883E-07_JPRB, 0.31347111E-07_JPRB, &
  & 0.33821104E-07_JPRB, 0.36469851E-07_JPRB, 0.38719155E-07_JPRB, 0.39319193E-07_JPRB, 0.40207712E-07_JPRB, 0.40060558E-07_JPRB, &
  & 0.38526175E-07_JPRB, 0.36919760E-07_JPRB, 0.35360662E-07_JPRB, 0.33873433E-07_JPRB, 0.33499085E-07_JPRB, 0.32979540E-07_JPRB, &
  & 0.32751426E-07_JPRB, 0.32864782E-07_JPRB, 0.33346962E-07_JPRB, 0.33775856E-07_JPRB, 0.34257720E-07_JPRB, 0.34997423E-07_JPRB, &
  & 0.35068172E-07_JPRB, 0.34369188E-07_JPRB, 0.34140083E-07_JPRB, 0.34572059E-07_JPRB  /)

RGHG7(:,75, 7) = (/ &
  & 0.26816447E-08_JPRB, 0.24504907E-08_JPRB, 0.23170173E-08_JPRB, 0.25506440E-08_JPRB, 0.29791100E-08_JPRB, 0.32180130E-08_JPRB, &
  & 0.31292706E-08_JPRB, 0.31910254E-08_JPRB, 0.34829972E-08_JPRB, 0.43886091E-08_JPRB, 0.54157082E-08_JPRB, 0.63442160E-08_JPRB, &
  & 0.72876610E-08_JPRB, 0.84301068E-08_JPRB, 0.96826697E-08_JPRB, 0.10827660E-07_JPRB, 0.11857848E-07_JPRB, 0.12828084E-07_JPRB, &
  & 0.13976324E-07_JPRB, 0.15218472E-07_JPRB, 0.16729739E-07_JPRB, 0.18259970E-07_JPRB, 0.19590566E-07_JPRB, 0.20686444E-07_JPRB, &
  & 0.21816207E-07_JPRB, 0.22519958E-07_JPRB, 0.22678037E-07_JPRB, 0.22256830E-07_JPRB, 0.21875029E-07_JPRB, 0.21027433E-07_JPRB, &
  & 0.19320530E-07_JPRB, 0.17290818E-07_JPRB, 0.14857778E-07_JPRB, 0.13412519E-07_JPRB, 0.13265210E-07_JPRB, 0.14640487E-07_JPRB, &
  & 0.16631923E-07_JPRB, 0.19102741E-07_JPRB, 0.22149282E-07_JPRB, 0.25261927E-07_JPRB, 0.27740923E-07_JPRB, 0.29615012E-07_JPRB, &
  & 0.32074948E-07_JPRB, 0.34850129E-07_JPRB, 0.37201511E-07_JPRB, 0.37893784E-07_JPRB, 0.38726908E-07_JPRB, 0.38615515E-07_JPRB, &
  & 0.37059186E-07_JPRB, 0.35414799E-07_JPRB, 0.33810800E-07_JPRB, 0.32231628E-07_JPRB, 0.31828979E-07_JPRB, 0.31185589E-07_JPRB, &
  & 0.30964630E-07_JPRB, 0.31181448E-07_JPRB, 0.31897048E-07_JPRB, 0.32596339E-07_JPRB, 0.33157605E-07_JPRB, 0.34026392E-07_JPRB, &
  & 0.34069143E-07_JPRB, 0.33353919E-07_JPRB, 0.33135665E-07_JPRB, 0.33598847E-07_JPRB  /)

RGHG7(:,76, 7) = (/ &
  & 0.21712354E-08_JPRB, 0.20197289E-08_JPRB, 0.19560496E-08_JPRB, 0.21859813E-08_JPRB, 0.25733919E-08_JPRB, 0.27921778E-08_JPRB, &
  & 0.26824971E-08_JPRB, 0.27426097E-08_JPRB, 0.30169278E-08_JPRB, 0.38506928E-08_JPRB, 0.47874700E-08_JPRB, 0.56519314E-08_JPRB, &
  & 0.65498049E-08_JPRB, 0.76006972E-08_JPRB, 0.87612961E-08_JPRB, 0.98475768E-08_JPRB, 0.10830141E-07_JPRB, 0.11670231E-07_JPRB, &
  & 0.12767563E-07_JPRB, 0.13943201E-07_JPRB, 0.15386316E-07_JPRB, 0.16826225E-07_JPRB, 0.18094417E-07_JPRB, 0.19111880E-07_JPRB, &
  & 0.20088506E-07_JPRB, 0.20704809E-07_JPRB, 0.21055437E-07_JPRB, 0.20898627E-07_JPRB, 0.20761927E-07_JPRB, 0.20120839E-07_JPRB, &
  & 0.18536281E-07_JPRB, 0.16720467E-07_JPRB, 0.14357222E-07_JPRB, 0.12958355E-07_JPRB, 0.12724420E-07_JPRB, 0.14001574E-07_JPRB, &
  & 0.15901046E-07_JPRB, 0.18154681E-07_JPRB, 0.21104332E-07_JPRB, 0.24047418E-07_JPRB, 0.26397911E-07_JPRB, 0.28177983E-07_JPRB, &
  & 0.30602201E-07_JPRB, 0.33455387E-07_JPRB, 0.35844130E-07_JPRB, 0.36695287E-07_JPRB, 0.37474628E-07_JPRB, 0.37406343E-07_JPRB, &
  & 0.35869721E-07_JPRB, 0.34187153E-07_JPRB, 0.32466146E-07_JPRB, 0.30804452E-07_JPRB, 0.30299576E-07_JPRB, 0.29535893E-07_JPRB, &
  & 0.29269773E-07_JPRB, 0.29571986E-07_JPRB, 0.30463714E-07_JPRB, 0.31433970E-07_JPRB, 0.32071189E-07_JPRB, 0.33042615E-07_JPRB, &
  & 0.33022961E-07_JPRB, 0.32274893E-07_JPRB, 0.32029132E-07_JPRB, 0.32501756E-07_JPRB  /)

RGHG7(:,77, 7) = (/ &
  & 0.17563943E-08_JPRB, 0.16777732E-08_JPRB, 0.16631630E-08_JPRB, 0.18917166E-08_JPRB, 0.22473591E-08_JPRB, 0.24390271E-08_JPRB, &
  & 0.23191673E-08_JPRB, 0.23712955E-08_JPRB, 0.26186245E-08_JPRB, 0.33771478E-08_JPRB, 0.42191550E-08_JPRB, 0.50336634E-08_JPRB, &
  & 0.58663587E-08_JPRB, 0.68445323E-08_JPRB, 0.79173839E-08_JPRB, 0.89223968E-08_JPRB, 0.99131313E-08_JPRB, 0.10776425E-07_JPRB, &
  & 0.11808694E-07_JPRB, 0.13008101E-07_JPRB, 0.14413686E-07_JPRB, 0.15760800E-07_JPRB, 0.17050606E-07_JPRB, 0.18003146E-07_JPRB, &
  & 0.18839853E-07_JPRB, 0.19466981E-07_JPRB, 0.19872708E-07_JPRB, 0.19848608E-07_JPRB, 0.19859010E-07_JPRB, 0.19329436E-07_JPRB, &
  & 0.17739433E-07_JPRB, 0.16085280E-07_JPRB, 0.14015957E-07_JPRB, 0.12647954E-07_JPRB, 0.12307199E-07_JPRB, 0.13562236E-07_JPRB, &
  & 0.15424117E-07_JPRB, 0.17560150E-07_JPRB, 0.20326619E-07_JPRB, 0.23052705E-07_JPRB, 0.25340788E-07_JPRB, 0.27166491E-07_JPRB, &
  & 0.29508274E-07_JPRB, 0.32369887E-07_JPRB, 0.34816664E-07_JPRB, 0.35767759E-07_JPRB, 0.36531648E-07_JPRB, 0.36519724E-07_JPRB, &
  & 0.35030734E-07_JPRB, 0.33257310E-07_JPRB, 0.31393140E-07_JPRB, 0.29659595E-07_JPRB, 0.29044319E-07_JPRB, 0.28212732E-07_JPRB, &
  & 0.27841568E-07_JPRB, 0.28086247E-07_JPRB, 0.29114753E-07_JPRB, 0.30277302E-07_JPRB, 0.30997481E-07_JPRB, 0.32019694E-07_JPRB, &
  & 0.31953333E-07_JPRB, 0.31148651E-07_JPRB, 0.30784158E-07_JPRB, 0.31219759E-07_JPRB  /)

RGHG7(:,78, 7) = (/ &
  & 0.14147053E-08_JPRB, 0.14027743E-08_JPRB, 0.14234831E-08_JPRB, 0.16441807E-08_JPRB, 0.19731792E-08_JPRB, 0.21385024E-08_JPRB, &
  & 0.20157037E-08_JPRB, 0.20576772E-08_JPRB, 0.22672915E-08_JPRB, 0.29427332E-08_JPRB, 0.37011829E-08_JPRB, 0.44680211E-08_JPRB, &
  & 0.52500377E-08_JPRB, 0.61753081E-08_JPRB, 0.71778927E-08_JPRB, 0.81268757E-08_JPRB, 0.91269694E-08_JPRB, 0.10052490E-07_JPRB, &
  & 0.11087643E-07_JPRB, 0.12300626E-07_JPRB, 0.13659399E-07_JPRB, 0.14950416E-07_JPRB, 0.16220106E-07_JPRB, 0.17115053E-07_JPRB, &
  & 0.17851163E-07_JPRB, 0.18472272E-07_JPRB, 0.18918192E-07_JPRB, 0.18951902E-07_JPRB, 0.19019383E-07_JPRB, 0.18588543E-07_JPRB, &
  & 0.17027597E-07_JPRB, 0.15524492E-07_JPRB, 0.13727281E-07_JPRB, 0.12400012E-07_JPRB, 0.11979751E-07_JPRB, 0.13249988E-07_JPRB, &
  & 0.15077936E-07_JPRB, 0.17156490E-07_JPRB, 0.19783303E-07_JPRB, 0.22355103E-07_JPRB, 0.24576448E-07_JPRB, 0.26437314E-07_JPRB, &
  & 0.28703389E-07_JPRB, 0.31547094E-07_JPRB, 0.34049390E-07_JPRB, 0.35066401E-07_JPRB, 0.35817004E-07_JPRB, 0.35841600E-07_JPRB, &
  & 0.34393142E-07_JPRB, 0.32495892E-07_JPRB, 0.30505368E-07_JPRB, 0.28716426E-07_JPRB, 0.27985156E-07_JPRB, 0.27087478E-07_JPRB, &
  & 0.26650408E-07_JPRB, 0.26793148E-07_JPRB, 0.27891507E-07_JPRB, 0.29179432E-07_JPRB, 0.29973923E-07_JPRB, 0.31034893E-07_JPRB, &
  & 0.30955649E-07_JPRB, 0.30154071E-07_JPRB, 0.29737660E-07_JPRB, 0.30165284E-07_JPRB  /)

RGHG7(:,79, 7) = (/ &
  & 0.11401710E-08_JPRB, 0.11869437E-08_JPRB, 0.12319145E-08_JPRB, 0.14396014E-08_JPRB, 0.17453075E-08_JPRB, 0.18866081E-08_JPRB, &
  & 0.17679270E-08_JPRB, 0.18003309E-08_JPRB, 0.19709311E-08_JPRB, 0.25597684E-08_JPRB, 0.32526021E-08_JPRB, 0.39763327E-08_JPRB, &
  & 0.47284917E-08_JPRB, 0.56211217E-08_JPRB, 0.65838245E-08_JPRB, 0.75011425E-08_JPRB, 0.85043602E-08_JPRB, 0.94949458E-08_JPRB, &
  & 0.10561932E-07_JPRB, 0.11776316E-07_JPRB, 0.13086445E-07_JPRB, 0.14339333E-07_JPRB, 0.15567381E-07_JPRB, 0.16408646E-07_JPRB, &
  & 0.17077488E-07_JPRB, 0.17674354E-07_JPRB, 0.18141980E-07_JPRB, 0.18185750E-07_JPRB, 0.18266923E-07_JPRB, 0.17929181E-07_JPRB, &
  & 0.16457677E-07_JPRB, 0.15069550E-07_JPRB, 0.13481838E-07_JPRB, 0.12207420E-07_JPRB, 0.11740042E-07_JPRB, 0.13045851E-07_JPRB, &
  & 0.14847856E-07_JPRB, 0.16891555E-07_JPRB, 0.19431214E-07_JPRB, 0.21905900E-07_JPRB, 0.24057535E-07_JPRB, 0.25929880E-07_JPRB, &
  & 0.28123780E-07_JPRB, 0.30953384E-07_JPRB, 0.33516324E-07_JPRB, 0.34566113E-07_JPRB, 0.35298630E-07_JPRB, 0.35332862E-07_JPRB, &
  & 0.33906881E-07_JPRB, 0.31880290E-07_JPRB, 0.29776775E-07_JPRB, 0.27948036E-07_JPRB, 0.27101412E-07_JPRB, 0.26140409E-07_JPRB, &
  & 0.25675852E-07_JPRB, 0.25699652E-07_JPRB, 0.26781804E-07_JPRB, 0.28129582E-07_JPRB, 0.28969729E-07_JPRB, 0.30035314E-07_JPRB, &
  & 0.29977256E-07_JPRB, 0.29194955E-07_JPRB, 0.28765023E-07_JPRB, 0.29218884E-07_JPRB  /)

RGHG7(:,80, 7) = (/ &
  & 0.92598002E-09_JPRB, 0.10215898E-08_JPRB, 0.10826518E-08_JPRB, 0.12743798E-08_JPRB, 0.15584070E-08_JPRB, 0.16792250E-08_JPRB, &
  & 0.15715292E-08_JPRB, 0.15976972E-08_JPRB, 0.17386907E-08_JPRB, 0.22423528E-08_JPRB, 0.28936187E-08_JPRB, 0.35819206E-08_JPRB, &
  & 0.43294387E-08_JPRB, 0.52099227E-08_JPRB, 0.61764282E-08_JPRB, 0.70818208E-08_JPRB, 0.80772635E-08_JPRB, 0.91026380E-08_JPRB, &
  & 0.10180277E-07_JPRB, 0.11388552E-07_JPRB, 0.12659174E-07_JPRB, 0.13867810E-07_JPRB, 0.15064278E-07_JPRB, 0.15852268E-07_JPRB, &
  & 0.16478105E-07_JPRB, 0.17038689E-07_JPRB, 0.17497676E-07_JPRB, 0.17531463E-07_JPRB, 0.17636186E-07_JPRB, 0.17388762E-07_JPRB, &
  & 0.16084493E-07_JPRB, 0.14744761E-07_JPRB, 0.13275461E-07_JPRB, 0.12066173E-07_JPRB, 0.11585619E-07_JPRB, 0.12930354E-07_JPRB, &
  & 0.14722596E-07_JPRB, 0.16714041E-07_JPRB, 0.19219783E-07_JPRB, 0.21640152E-07_JPRB, 0.23725437E-07_JPRB, 0.25580694E-07_JPRB, &
  & 0.27698716E-07_JPRB, 0.30549039E-07_JPRB, 0.33187790E-07_JPRB, 0.34236941E-07_JPRB, 0.34941282E-07_JPRB, 0.34953440E-07_JPRB, &
  & 0.33522739E-07_JPRB, 0.31391200E-07_JPRB, 0.29180790E-07_JPRB, 0.27326231E-07_JPRB, 0.26371597E-07_JPRB, 0.25354840E-07_JPRB, &
  & 0.24892849E-07_JPRB, 0.24806478E-07_JPRB, 0.25768901E-07_JPRB, 0.27115275E-07_JPRB, 0.27952591E-07_JPRB, 0.28962617E-07_JPRB, &
  & 0.28959185E-07_JPRB, 0.28157163E-07_JPRB, 0.27709833E-07_JPRB, 0.28225062E-07_JPRB  /)

RGHG7(:,81, 7) = (/ &
  & 0.77793668E-09_JPRB, 0.90943120E-09_JPRB, 0.97513714E-09_JPRB, 0.11512447E-08_JPRB, 0.14133189E-08_JPRB, 0.15159834E-08_JPRB, &
  & 0.14243302E-08_JPRB, 0.14526091E-08_JPRB, 0.15767156E-08_JPRB, 0.20364717E-08_JPRB, 0.26670510E-08_JPRB, 0.33405769E-08_JPRB, &
  & 0.40952720E-08_JPRB, 0.49529586E-08_JPRB, 0.59131315E-08_JPRB, 0.68117693E-08_JPRB, 0.77996129E-08_JPRB, 0.88241431E-08_JPRB, &
  & 0.99110701E-08_JPRB, 0.11110901E-07_JPRB, 0.12361681E-07_JPRB, 0.13531899E-07_JPRB, 0.14703459E-07_JPRB, 0.15445855E-07_JPRB, &
  & 0.16032852E-07_JPRB, 0.16580770E-07_JPRB, 0.17035113E-07_JPRB, 0.17072700E-07_JPRB, 0.17181645E-07_JPRB, 0.16997969E-07_JPRB, &
  & 0.15833862E-07_JPRB, 0.14497929E-07_JPRB, 0.13097443E-07_JPRB, 0.11980611E-07_JPRB, 0.11528343E-07_JPRB, 0.12906852E-07_JPRB, &
  & 0.14684739E-07_JPRB, 0.16614548E-07_JPRB, 0.19083139E-07_JPRB, 0.21441448E-07_JPRB, 0.23466784E-07_JPRB, 0.25331329E-07_JPRB, &
  & 0.27389825E-07_JPRB, 0.30273077E-07_JPRB, 0.32976843E-07_JPRB, 0.34044570E-07_JPRB, 0.34716404E-07_JPRB, 0.34670723E-07_JPRB, &
  & 0.33185140E-07_JPRB, 0.30967055E-07_JPRB, 0.28694163E-07_JPRB, 0.26817652E-07_JPRB, 0.25789981E-07_JPRB, 0.24693011E-07_JPRB, &
  & 0.24258462E-07_JPRB, 0.24003644E-07_JPRB, 0.24800575E-07_JPRB, 0.25954437E-07_JPRB, 0.26683255E-07_JPRB, 0.27562407E-07_JPRB, &
  & 0.27526889E-07_JPRB, 0.26712203E-07_JPRB, 0.26162706E-07_JPRB, 0.26670337E-07_JPRB  /)

RGHG7(:,82, 7) = (/ &
  & 0.66970716E-09_JPRB, 0.82376851E-09_JPRB, 0.89234353E-09_JPRB, 0.10564208E-08_JPRB, 0.12946461E-08_JPRB, 0.13786913E-08_JPRB, &
  & 0.13035600E-08_JPRB, 0.13339362E-08_JPRB, 0.14485352E-08_JPRB, 0.18800813E-08_JPRB, 0.24991230E-08_JPRB, 0.31696016E-08_JPRB, &
  & 0.39325912E-08_JPRB, 0.47760611E-08_JPRB, 0.57267423E-08_JPRB, 0.66160507E-08_JPRB, 0.76012883E-08_JPRB, 0.86217801E-08_JPRB, &
  & 0.97057195E-08_JPRB, 0.10895998E-07_JPRB, 0.12133461E-07_JPRB, 0.13275105E-07_JPRB, 0.14421625E-07_JPRB, 0.15134133E-07_JPRB, &
  & 0.15694463E-07_JPRB, 0.16234742E-07_JPRB, 0.16674872E-07_JPRB, 0.16716816E-07_JPRB, 0.16842462E-07_JPRB, 0.16699441E-07_JPRB, &
  & 0.15611192E-07_JPRB, 0.14267401E-07_JPRB, 0.12916965E-07_JPRB, 0.11910032E-07_JPRB, 0.11516409E-07_JPRB, 0.12914515E-07_JPRB, &
  & 0.14661561E-07_JPRB, 0.16536234E-07_JPRB, 0.18971401E-07_JPRB, 0.21258449E-07_JPRB, 0.23226837E-07_JPRB, 0.25110500E-07_JPRB, &
  & 0.27122065E-07_JPRB, 0.30026984E-07_JPRB, 0.32761901E-07_JPRB, 0.33862046E-07_JPRB, 0.34520776E-07_JPRB, 0.34406284E-07_JPRB, &
  & 0.32828938E-07_JPRB, 0.30524860E-07_JPRB, 0.28225080E-07_JPRB, 0.26340426E-07_JPRB, 0.25227389E-07_JPRB, 0.24067297E-07_JPRB, &
  & 0.23694917E-07_JPRB, 0.23292215E-07_JPRB, 0.23873228E-07_JPRB, 0.24748841E-07_JPRB, 0.25352692E-07_JPRB, 0.26006113E-07_JPRB, &
  & 0.25880252E-07_JPRB, 0.24952342E-07_JPRB, 0.24335945E-07_JPRB, 0.24981456E-07_JPRB  /)

RGHG7(:,83, 7) = (/ &
  & 0.59613678E-09_JPRB, 0.75878024E-09_JPRB, 0.83072411E-09_JPRB, 0.98359662E-09_JPRB, 0.11979245E-08_JPRB, 0.12630903E-08_JPRB, &
  & 0.12057254E-08_JPRB, 0.12407595E-08_JPRB, 0.13508915E-08_JPRB, 0.17655739E-08_JPRB, 0.23772893E-08_JPRB, 0.30512979E-08_JPRB, &
  & 0.38220560E-08_JPRB, 0.46560935E-08_JPRB, 0.55946707E-08_JPRB, 0.64753524E-08_JPRB, 0.74635577E-08_JPRB, 0.84788031E-08_JPRB, &
  & 0.95521674E-08_JPRB, 0.10733429E-07_JPRB, 0.11960010E-07_JPRB, 0.13083329E-07_JPRB, 0.14208435E-07_JPRB, 0.14908861E-07_JPRB, &
  & 0.15455228E-07_JPRB, 0.15985749E-07_JPRB, 0.16406771E-07_JPRB, 0.16455869E-07_JPRB, 0.16606623E-07_JPRB, 0.16482848E-07_JPRB, &
  & 0.15425262E-07_JPRB, 0.14063098E-07_JPRB, 0.12767149E-07_JPRB, 0.11874363E-07_JPRB, 0.11555024E-07_JPRB, 0.12952584E-07_JPRB, &
  & 0.14652754E-07_JPRB, 0.16482360E-07_JPRB, 0.18892682E-07_JPRB, 0.21106950E-07_JPRB, 0.23023882E-07_JPRB, 0.24926327E-07_JPRB, &
  & 0.26897357E-07_JPRB, 0.29777988E-07_JPRB, 0.32523326E-07_JPRB, 0.33658034E-07_JPRB, 0.34314123E-07_JPRB, 0.34129643E-07_JPRB, &
  & 0.32444173E-07_JPRB, 0.30062073E-07_JPRB, 0.27752190E-07_JPRB, 0.25861428E-07_JPRB, 0.24658609E-07_JPRB, 0.23454312E-07_JPRB, &
  & 0.23171937E-07_JPRB, 0.22645798E-07_JPRB, 0.23000278E-07_JPRB, 0.23474023E-07_JPRB, 0.23924032E-07_JPRB, 0.24330504E-07_JPRB, &
  & 0.24110368E-07_JPRB, 0.23050386E-07_JPRB, 0.22375735E-07_JPRB, 0.23206917E-07_JPRB  /)

RGHG7(:,84, 7) = (/ &
  & 0.55146696E-09_JPRB, 0.70912066E-09_JPRB, 0.78621646E-09_JPRB, 0.92689091E-09_JPRB, 0.11189489E-08_JPRB, 0.11653313E-08_JPRB, &
  & 0.11272361E-08_JPRB, 0.11709563E-08_JPRB, 0.12797788E-08_JPRB, 0.16850282E-08_JPRB, 0.22900280E-08_JPRB, 0.29697511E-08_JPRB, &
  & 0.37459472E-08_JPRB, 0.45721440E-08_JPRB, 0.54970102E-08_JPRB, 0.63719266E-08_JPRB, 0.73680013E-08_JPRB, 0.83785047E-08_JPRB, &
  & 0.94379039E-08_JPRB, 0.10611328E-07_JPRB, 0.11826276E-07_JPRB, 0.12940728E-07_JPRB, 0.14049823E-07_JPRB, 0.14755575E-07_JPRB, &
  & 0.15299254E-07_JPRB, 0.15812993E-07_JPRB, 0.16213443E-07_JPRB, 0.16274627E-07_JPRB, 0.16453706E-07_JPRB, 0.16330631E-07_JPRB, &
  & 0.15276331E-07_JPRB, 0.13888381E-07_JPRB, 0.12665748E-07_JPRB, 0.11876979E-07_JPRB, 0.11631443E-07_JPRB, 0.13007499E-07_JPRB, &
  & 0.14648697E-07_JPRB, 0.16446920E-07_JPRB, 0.18843175E-07_JPRB, 0.20990882E-07_JPRB, 0.22864981E-07_JPRB, 0.24776872E-07_JPRB, &
  & 0.26707833E-07_JPRB, 0.29500395E-07_JPRB, 0.32241828E-07_JPRB, 0.33401647E-07_JPRB, 0.34059926E-07_JPRB, 0.33813267E-07_JPRB, &
  & 0.32023986E-07_JPRB, 0.29577152E-07_JPRB, 0.27260569E-07_JPRB, 0.25356490E-07_JPRB, 0.24065933E-07_JPRB, 0.22834202E-07_JPRB, &
  & 0.22662131E-07_JPRB, 0.22042217E-07_JPRB, 0.22190361E-07_JPRB, 0.22124912E-07_JPRB, 0.22385248E-07_JPRB, 0.22577374E-07_JPRB, &
  & 0.22299842E-07_JPRB, 0.21156663E-07_JPRB, 0.20408103E-07_JPRB, 0.21402181E-07_JPRB  /)

RGHG7(:,85, 7) = (/ &
  & 0.53331076E-09_JPRB, 0.67181374E-09_JPRB, 0.75146297E-09_JPRB, 0.88107256E-09_JPRB, 0.10544054E-08_JPRB, 0.10824882E-08_JPRB, &
  & 0.10643949E-08_JPRB, 0.11183288E-08_JPRB, 0.12309814E-08_JPRB, 0.16328262E-08_JPRB, 0.22348471E-08_JPRB, 0.29201026E-08_JPRB, &
  & 0.36907662E-08_JPRB, 0.45080261E-08_JPRB, 0.54222530E-08_JPRB, 0.62907858E-08_JPRB, 0.72898395E-08_JPRB, 0.82982151E-08_JPRB, &
  & 0.93427192E-08_JPRB, 0.10500823E-07_JPRB, 0.11701302E-07_JPRB, 0.12808944E-07_JPRB, 0.13894633E-07_JPRB, 0.14612301E-07_JPRB, &
  & 0.15149596E-07_JPRB, 0.15639929E-07_JPRB, 0.16011440E-07_JPRB, 0.16101137E-07_JPRB, 0.16290855E-07_JPRB, 0.16153736E-07_JPRB, &
  & 0.15090074E-07_JPRB, 0.13688931E-07_JPRB, 0.12534815E-07_JPRB, 0.11787752E-07_JPRB, 0.11560941E-07_JPRB, 0.12924655E-07_JPRB, &
  & 0.14524999E-07_JPRB, 0.16325776E-07_JPRB, 0.18705433E-07_JPRB, 0.20813987E-07_JPRB, 0.22672766E-07_JPRB, 0.24562527E-07_JPRB, &
  & 0.26434334E-07_JPRB, 0.29130291E-07_JPRB, 0.31787035E-07_JPRB, 0.32923023E-07_JPRB, 0.33611517E-07_JPRB, 0.33328259E-07_JPRB, &
  & 0.31494293E-07_JPRB, 0.28993837E-07_JPRB, 0.26693851E-07_JPRB, 0.24759982E-07_JPRB, 0.23378353E-07_JPRB, 0.22099383E-07_JPRB, &
  & 0.22061367E-07_JPRB, 0.21423154E-07_JPRB, 0.21374683E-07_JPRB, 0.20652152E-07_JPRB, 0.20666508E-07_JPRB, 0.20630953E-07_JPRB, &
  & 0.20338951E-07_JPRB, 0.19251522E-07_JPRB, 0.18340820E-07_JPRB, 0.19551088E-07_JPRB  /)

RGHG7(:,86, 7) = (/ &
  & 0.52698490E-09_JPRB, 0.63791483E-09_JPRB, 0.71380299E-09_JPRB, 0.83695410E-09_JPRB, 0.99746157E-09_JPRB, 0.10104825E-08_JPRB, &
  & 0.10121591E-08_JPRB, 0.10736942E-08_JPRB, 0.11948586E-08_JPRB, 0.15946137E-08_JPRB, 0.21956386E-08_JPRB, 0.28857885E-08_JPRB, &
  & 0.36518908E-08_JPRB, 0.44598354E-08_JPRB, 0.53650344E-08_JPRB, 0.62254863E-08_JPRB, 0.72248699E-08_JPRB, 0.82317729E-08_JPRB, &
  & 0.92623058E-08_JPRB, 0.10394022E-07_JPRB, 0.11566637E-07_JPRB, 0.12662774E-07_JPRB, 0.13720608E-07_JPRB, 0.14438597E-07_JPRB, &
  & 0.14970475E-07_JPRB, 0.15440281E-07_JPRB, 0.15786703E-07_JPRB, 0.15914382E-07_JPRB, 0.16093480E-07_JPRB, 0.15948573E-07_JPRB, &
  & 0.14899811E-07_JPRB, 0.13506390E-07_JPRB, 0.12394496E-07_JPRB, 0.11683355E-07_JPRB, 0.11458713E-07_JPRB, 0.12806360E-07_JPRB, &
  & 0.14362978E-07_JPRB, 0.16161992E-07_JPRB, 0.18504321E-07_JPRB, 0.20563533E-07_JPRB, 0.22360957E-07_JPRB, 0.24206164E-07_JPRB, &
  & 0.26034503E-07_JPRB, 0.28648353E-07_JPRB, 0.31140388E-07_JPRB, 0.32184154E-07_JPRB, 0.32908677E-07_JPRB, 0.32609616E-07_JPRB, &
  & 0.30773699E-07_JPRB, 0.28241329E-07_JPRB, 0.26020633E-07_JPRB, 0.24057156E-07_JPRB, 0.22575003E-07_JPRB, 0.21267871E-07_JPRB, &
  & 0.21344273E-07_JPRB, 0.20718972E-07_JPRB, 0.20538499E-07_JPRB, 0.19248144E-07_JPRB, 0.19051909E-07_JPRB, 0.18858456E-07_JPRB, &
  & 0.18466325E-07_JPRB, 0.17489210E-07_JPRB, 0.16735911E-07_JPRB, 0.17932346E-07_JPRB  /)

RGHG7(:,87, 7) = (/ &
  & 0.51822723E-09_JPRB, 0.59830488E-09_JPRB, 0.66588485E-09_JPRB, 0.78980990E-09_JPRB, 0.94257044E-09_JPRB, 0.94413838E-09_JPRB, &
  & 0.96712829E-09_JPRB, 0.10356140E-08_JPRB, 0.11678786E-08_JPRB, 0.15670047E-08_JPRB, 0.21671517E-08_JPRB, 0.28598627E-08_JPRB, &
  & 0.36231731E-08_JPRB, 0.44226694E-08_JPRB, 0.53194019E-08_JPRB, 0.61709437E-08_JPRB, 0.71690060E-08_JPRB, 0.81739406E-08_JPRB, &
  & 0.91890201E-08_JPRB, 0.10277679E-07_JPRB, 0.11408614E-07_JPRB, 0.12479523E-07_JPRB, 0.13507152E-07_JPRB, 0.14213452E-07_JPRB, &
  & 0.14738786E-07_JPRB, 0.15199252E-07_JPRB, 0.15531325E-07_JPRB, 0.15706483E-07_JPRB, 0.15863095E-07_JPRB, 0.15709446E-07_JPRB, &
  & 0.14690378E-07_JPRB, 0.13303097E-07_JPRB, 0.12222399E-07_JPRB, 0.11556433E-07_JPRB, 0.11325193E-07_JPRB, 0.12651250E-07_JPRB, &
  & 0.14168898E-07_JPRB, 0.15948906E-07_JPRB, 0.18228290E-07_JPRB, 0.20227409E-07_JPRB, 0.21925963E-07_JPRB, 0.23682889E-07_JPRB, &
  & 0.25498082E-07_JPRB, 0.28002935E-07_JPRB, 0.30273212E-07_JPRB, 0.31154592E-07_JPRB, 0.31933531E-07_JPRB, 0.31565718E-07_JPRB, &
  & 0.29816504E-07_JPRB, 0.27270265E-07_JPRB, 0.25147958E-07_JPRB, 0.23163155E-07_JPRB, 0.21585621E-07_JPRB, 0.20294269E-07_JPRB, &
  & 0.20495425E-07_JPRB, 0.19903144E-07_JPRB, 0.19631721E-07_JPRB, 0.17863687E-07_JPRB, 0.17566367E-07_JPRB, 0.17258755E-07_JPRB, &
  & 0.16778349E-07_JPRB, 0.15946247E-07_JPRB, 0.15545122E-07_JPRB, 0.16538802E-07_JPRB  /)

RGHG7(:,88, 7) = (/ &
  & 0.49429022E-09_JPRB, 0.54632581E-09_JPRB, 0.60502062E-09_JPRB, 0.73341200E-09_JPRB, 0.88332601E-09_JPRB, 0.87946294E-09_JPRB, &
  & 0.92611208E-09_JPRB, 0.10039739E-08_JPRB, 0.11481920E-08_JPRB, 0.15475110E-08_JPRB, 0.21464241E-08_JPRB, 0.28390660E-08_JPRB, &
  & 0.36000943E-08_JPRB, 0.43931660E-08_JPRB, 0.52817779E-08_JPRB, 0.61233720E-08_JPRB, 0.71191593E-08_JPRB, 0.81199227E-08_JPRB, &
  & 0.91155545E-08_JPRB, 0.10141652E-07_JPRB, 0.11210312E-07_JPRB, 0.12232720E-07_JPRB, 0.13224115E-07_JPRB, 0.13900052E-07_JPRB, &
  & 0.14420341E-07_JPRB, 0.14887613E-07_JPRB, 0.15224377E-07_JPRB, 0.15459822E-07_JPRB, 0.15585611E-07_JPRB, 0.15415547E-07_JPRB, &
  & 0.14435022E-07_JPRB, 0.13041135E-07_JPRB, 0.11989625E-07_JPRB, 0.11385635E-07_JPRB, 0.11149895E-07_JPRB, 0.12446881E-07_JPRB, &
  & 0.13939384E-07_JPRB, 0.15663401E-07_JPRB, 0.17850628E-07_JPRB, 0.19782169E-07_JPRB, 0.21341858E-07_JPRB, 0.22962231E-07_JPRB, &
  & 0.24785578E-07_JPRB, 0.27122879E-07_JPRB, 0.29113541E-07_JPRB, 0.29757012E-07_JPRB, 0.30580771E-07_JPRB, 0.30049559E-07_JPRB, &
  & 0.28511411E-07_JPRB, 0.25973510E-07_JPRB, 0.23956389E-07_JPRB, 0.21971694E-07_JPRB, 0.20324189E-07_JPRB, 0.19106034E-07_JPRB, &
  & 0.19436606E-07_JPRB, 0.18889038E-07_JPRB, 0.18574676E-07_JPRB, 0.16435297E-07_JPRB, 0.16197684E-07_JPRB, 0.15827529E-07_JPRB, &
  & 0.15301889E-07_JPRB, 0.14640875E-07_JPRB, 0.14768850E-07_JPRB, 0.15443121E-07_JPRB  /)

RGHG7(:,89, 7) = (/ &
  & 0.44476489E-09_JPRB, 0.48379283E-09_JPRB, 0.53876054E-09_JPRB, 0.66361563E-09_JPRB, 0.81241942E-09_JPRB, 0.81410405E-09_JPRB, &
  & 0.88727243E-09_JPRB, 0.98069608E-09_JPRB, 0.11348423E-08_JPRB, 0.15338086E-08_JPRB, 0.21317685E-08_JPRB, 0.28229805E-08_JPRB, &
  & 0.35793044E-08_JPRB, 0.43689159E-08_JPRB, 0.52501925E-08_JPRB, 0.60813389E-08_JPRB, 0.70739996E-08_JPRB, 0.80664745E-08_JPRB, &
  & 0.90358969E-08_JPRB, 0.99865584E-08_JPRB, 0.10961176E-07_JPRB, 0.11902678E-07_JPRB, 0.12842402E-07_JPRB, 0.13455158E-07_JPRB, &
  & 0.13981467E-07_JPRB, 0.14476840E-07_JPRB, 0.14848650E-07_JPRB, 0.15160245E-07_JPRB, 0.15255034E-07_JPRB, 0.15056639E-07_JPRB, &
  & 0.14110017E-07_JPRB, 0.12696688E-07_JPRB, 0.11674696E-07_JPRB, 0.11145932E-07_JPRB, 0.10923966E-07_JPRB, 0.12187764E-07_JPRB, &
  & 0.13680901E-07_JPRB, 0.15283375E-07_JPRB, 0.17347929E-07_JPRB, 0.19211594E-07_JPRB, 0.20601871E-07_JPRB, 0.22064279E-07_JPRB, &
  & 0.23875679E-07_JPRB, 0.25961437E-07_JPRB, 0.27615488E-07_JPRB, 0.27958014E-07_JPRB, 0.28751984E-07_JPRB, 0.27957475E-07_JPRB, &
  & 0.26750096E-07_JPRB, 0.24251703E-07_JPRB, 0.22372747E-07_JPRB, 0.20431667E-07_JPRB, 0.18793696E-07_JPRB, 0.17684527E-07_JPRB, &
  & 0.18100718E-07_JPRB, 0.17592128E-07_JPRB, 0.17314394E-07_JPRB, 0.14970904E-07_JPRB, 0.14965736E-07_JPRB, 0.14614860E-07_JPRB, &
  & 0.14080400E-07_JPRB, 0.13592213E-07_JPRB, 0.14409501E-07_JPRB, 0.14811149E-07_JPRB  /)

RGHG7(:,90, 7) = (/ &
  & 0.38545689E-09_JPRB, 0.43983376E-09_JPRB, 0.48477372E-09_JPRB, 0.59057084E-09_JPRB, 0.72000097E-09_JPRB, 0.73960447E-09_JPRB, &
  & 0.85296785E-09_JPRB, 0.96482773E-09_JPRB, 0.11252458E-08_JPRB, 0.15247127E-08_JPRB, 0.21216210E-08_JPRB, 0.28113314E-08_JPRB, &
  & 0.35631840E-08_JPRB, 0.43482065E-08_JPRB, 0.52205573E-08_JPRB, 0.60476825E-08_JPRB, 0.70317331E-08_JPRB, 0.80141299E-08_JPRB, &
  & 0.89456751E-08_JPRB, 0.98260920E-08_JPRB, 0.10663405E-07_JPRB, 0.11485380E-07_JPRB, 0.12346924E-07_JPRB, 0.12846235E-07_JPRB, &
  & 0.13399126E-07_JPRB, 0.13962378E-07_JPRB, 0.14406300E-07_JPRB, 0.14814949E-07_JPRB, 0.14919431E-07_JPRB, 0.14696828E-07_JPRB, &
  & 0.13741656E-07_JPRB, 0.12315330E-07_JPRB, 0.11306748E-07_JPRB, 0.10852394E-07_JPRB, 0.10658228E-07_JPRB, 0.11908746E-07_JPRB, &
  & 0.13420587E-07_JPRB, 0.14818540E-07_JPRB, 0.16696385E-07_JPRB, 0.18463306E-07_JPRB, 0.19725685E-07_JPRB, 0.21056238E-07_JPRB, &
  & 0.22791180E-07_JPRB, 0.24506575E-07_JPRB, 0.25784771E-07_JPRB, 0.25784256E-07_JPRB, 0.26531772E-07_JPRB, 0.25404213E-07_JPRB, &
  & 0.24516487E-07_JPRB, 0.22087083E-07_JPRB, 0.20509626E-07_JPRB, 0.18670329E-07_JPRB, 0.17251389E-07_JPRB, 0.16159726E-07_JPRB, &
  & 0.16591197E-07_JPRB, 0.16082709E-07_JPRB, 0.15908333E-07_JPRB, 0.13636591E-07_JPRB, 0.13916762E-07_JPRB, 0.13614388E-07_JPRB, &
  & 0.13186024E-07_JPRB, 0.12801453E-07_JPRB, 0.14186336E-07_JPRB, 0.14460478E-07_JPRB  /)

RGHG7(:,91, 7) = (/ &
  & 0.36533364E-09_JPRB, 0.43081727E-09_JPRB, 0.46465047E-09_JPRB, 0.53395397E-09_JPRB, 0.63217940E-09_JPRB, 0.66764970E-09_JPRB, &
  & 0.82808457E-09_JPRB, 0.95686902E-09_JPRB, 0.11167582E-08_JPRB, 0.15167540E-08_JPRB, 0.21110178E-08_JPRB, 0.27991416E-08_JPRB, &
  & 0.35472919E-08_JPRB, 0.43249099E-08_JPRB, 0.51903851E-08_JPRB, 0.60127503E-08_JPRB, 0.69846363E-08_JPRB, 0.79543396E-08_JPRB, &
  & 0.88356400E-08_JPRB, 0.96367230E-08_JPRB, 0.10309022E-07_JPRB, 0.10946941E-07_JPRB, 0.11753481E-07_JPRB, 0.12184036E-07_JPRB, &
  & 0.12705722E-07_JPRB, 0.13289072E-07_JPRB, 0.13810212E-07_JPRB, 0.14456863E-07_JPRB, 0.14638035E-07_JPRB, 0.14399565E-07_JPRB, &
  & 0.13403668E-07_JPRB, 0.11964120E-07_JPRB, 0.10951307E-07_JPRB, 0.10555131E-07_JPRB, 0.10398516E-07_JPRB, 0.11642159E-07_JPRB, &
  & 0.13179387E-07_JPRB, 0.14367369E-07_JPRB, 0.15956438E-07_JPRB, 0.17601714E-07_JPRB, 0.18766777E-07_JPRB, 0.20119014E-07_JPRB, &
  & 0.21670430E-07_JPRB, 0.23102338E-07_JPRB, 0.23939437E-07_JPRB, 0.23510520E-07_JPRB, 0.24409828E-07_JPRB, 0.22985559E-07_JPRB, &
  & 0.22307804E-07_JPRB, 0.20085726E-07_JPRB, 0.18908112E-07_JPRB, 0.17196807E-07_JPRB, 0.16048661E-07_JPRB, 0.14914157E-07_JPRB, &
  & 0.15065315E-07_JPRB, 0.14560000E-07_JPRB, 0.14547995E-07_JPRB, 0.12722639E-07_JPRB, 0.13061516E-07_JPRB, 0.12808859E-07_JPRB, &
  & 0.12689897E-07_JPRB, 0.12430145E-07_JPRB, 0.14018123E-07_JPRB, 0.14298611E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ---GEMS----

RGHG7(:, 1, 8) = (/ &
  & 0.61769283E-05_JPRB, 0.61951250E-05_JPRB, 0.62518789E-05_JPRB, 0.72681068E-07_JPRB, 0.70093286E-07_JPRB, 0.69847950E-07_JPRB, &
  & 0.69369889E-07_JPRB, 0.67652770E-07_JPRB, 0.66686290E-07_JPRB, 0.66245491E-07_JPRB, 0.66224437E-07_JPRB, 0.66454199E-07_JPRB, &
  & 0.66826068E-07_JPRB, 0.67284496E-07_JPRB, 0.67767672E-07_JPRB, 0.68232154E-07_JPRB, 0.68608728E-07_JPRB, 0.68961647E-07_JPRB, &
  & 0.69198677E-07_JPRB, 0.69338910E-07_JPRB, 0.69393856E-07_JPRB, 0.69377073E-07_JPRB, 0.69304747E-07_JPRB, 0.69189113E-07_JPRB, &
  & 0.69038222E-07_JPRB, 0.68875870E-07_JPRB, 0.68725321E-07_JPRB, 0.68608280E-07_JPRB, 0.68518773E-07_JPRB, 0.68412518E-07_JPRB, &
  & 0.68247822E-07_JPRB, 0.67989852E-07_JPRB, 0.67948605E-07_JPRB, 0.68047129E-07_JPRB, 0.68254508E-07_JPRB, 0.68551273E-07_JPRB, &
  & 0.68937595E-07_JPRB, 0.69319853E-07_JPRB, 0.69731350E-07_JPRB, 0.70059585E-07_JPRB, 0.70299009E-07_JPRB, 0.70549049E-07_JPRB, &
  & 0.70559587E-07_JPRB, 0.70705610E-07_JPRB, 0.70588932E-07_JPRB, 0.70556624E-07_JPRB, 0.70349863E-07_JPRB, 0.70133026E-07_JPRB, &
  & 0.69946722E-07_JPRB, 0.69809410E-07_JPRB, 0.69622168E-07_JPRB, 0.69558851E-07_JPRB, 0.69335201E-07_JPRB, 0.69322788E-07_JPRB, &
  & 0.68995035E-07_JPRB, 0.69060192E-07_JPRB, 0.68787799E-07_JPRB, 0.69020018E-07_JPRB, 0.68866747E-07_JPRB, 0.69198748E-07_JPRB, &
  & 0.68935286E-07_JPRB, 0.69320684E-07_JPRB, 0.70870435E-07_JPRB, 0.79714638E-07_JPRB  /)

RGHG7(:, 2, 8) = (/ &
  & 0.10017921E-04_JPRB, 0.13465768E-04_JPRB, 0.16251744E-04_JPRB, 0.76732476E-06_JPRB, 0.65361377E-06_JPRB, 0.67516623E-06_JPRB, &
  & 0.65994294E-06_JPRB, 0.51801987E-06_JPRB, 0.42105833E-06_JPRB, 0.36186384E-06_JPRB, 0.33177221E-06_JPRB, 0.31564417E-06_JPRB, &
  & 0.30466325E-06_JPRB, 0.29525168E-06_JPRB, 0.28547737E-06_JPRB, 0.27518087E-06_JPRB, 0.26222929E-06_JPRB, 0.25318232E-06_JPRB, &
  & 0.24662796E-06_JPRB, 0.24246910E-06_JPRB, 0.24010336E-06_JPRB, 0.23888015E-06_JPRB, 0.23845507E-06_JPRB, 0.23864550E-06_JPRB, &
  & 0.23901524E-06_JPRB, 0.23896479E-06_JPRB, 0.23800646E-06_JPRB, 0.23606462E-06_JPRB, 0.23300947E-06_JPRB, 0.22872071E-06_JPRB, &
  & 0.22257751E-06_JPRB, 0.21090520E-06_JPRB, 0.20487801E-06_JPRB, 0.20133341E-06_JPRB, 0.19949074E-06_JPRB, 0.19909716E-06_JPRB, &
  & 0.19998366E-06_JPRB, 0.20186775E-06_JPRB, 0.20441574E-06_JPRB, 0.20715513E-06_JPRB, 0.20911314E-06_JPRB, 0.21200057E-06_JPRB, &
  & 0.21230406E-06_JPRB, 0.21553343E-06_JPRB, 0.21544965E-06_JPRB, 0.21733355E-06_JPRB, 0.21591136E-06_JPRB, 0.21077044E-06_JPRB, &
  & 0.20874857E-06_JPRB, 0.20800492E-06_JPRB, 0.20672782E-06_JPRB, 0.20488797E-06_JPRB, 0.20169482E-06_JPRB, 0.19577102E-06_JPRB, &
  & 0.18460882E-06_JPRB, 0.17814672E-06_JPRB, 0.17138380E-06_JPRB, 0.16371423E-06_JPRB, 0.15683551E-06_JPRB, 0.15035094E-06_JPRB, &
  & 0.14037113E-06_JPRB, 0.12890429E-06_JPRB, 0.13119785E-06_JPRB, 0.17234149E-06_JPRB  /)

RGHG7(:, 3, 8) = (/ &
  & 0.17779594E-04_JPRB, 0.21196855E-04_JPRB, 0.23542110E-04_JPRB, 0.57246757E-05_JPRB, 0.26424032E-05_JPRB, 0.21772807E-05_JPRB, &
  & 0.17752974E-05_JPRB, 0.12243802E-05_JPRB, 0.88032334E-06_JPRB, 0.70261285E-06_JPRB, 0.61903262E-06_JPRB, 0.57796046E-06_JPRB, &
  & 0.55355491E-06_JPRB, 0.53704349E-06_JPRB, 0.52308667E-06_JPRB, 0.51176772E-06_JPRB, 0.49366514E-06_JPRB, 0.47967103E-06_JPRB, &
  & 0.47082972E-06_JPRB, 0.46454568E-06_JPRB, 0.46082050E-06_JPRB, 0.45886728E-06_JPRB, 0.45848043E-06_JPRB, 0.45948420E-06_JPRB, &
  & 0.46088053E-06_JPRB, 0.46141068E-06_JPRB, 0.45900848E-06_JPRB, 0.45361267E-06_JPRB, 0.44671361E-06_JPRB, 0.43889193E-06_JPRB, &
  & 0.43166838E-06_JPRB, 0.41427560E-06_JPRB, 0.40253767E-06_JPRB, 0.39650953E-06_JPRB, 0.39315699E-06_JPRB, 0.39151513E-06_JPRB, &
  & 0.39154878E-06_JPRB, 0.39278424E-06_JPRB, 0.39555863E-06_JPRB, 0.39780244E-06_JPRB, 0.40008911E-06_JPRB, 0.40372350E-06_JPRB, &
  & 0.40313290E-06_JPRB, 0.40853251E-06_JPRB, 0.40769092E-06_JPRB, 0.41061463E-06_JPRB, 0.40775740E-06_JPRB, 0.39805951E-06_JPRB, &
  & 0.39596705E-06_JPRB, 0.39711719E-06_JPRB, 0.39845975E-06_JPRB, 0.39812110E-06_JPRB, 0.39789867E-06_JPRB, 0.39400098E-06_JPRB, &
  & 0.38335415E-06_JPRB, 0.38512405E-06_JPRB, 0.39582972E-06_JPRB, 0.40186913E-06_JPRB, 0.39645823E-06_JPRB, 0.38801170E-06_JPRB, &
  & 0.36193535E-06_JPRB, 0.32966341E-06_JPRB, 0.33354661E-06_JPRB, 0.35424026E-06_JPRB  /)

RGHG7(:, 4, 8) = (/ &
  & 0.10678234E-04_JPRB, 0.10273501E-04_JPRB, 0.88194106E-05_JPRB, 0.48525229E-05_JPRB, 0.29317571E-05_JPRB, 0.24114620E-05_JPRB, &
  & 0.22379995E-05_JPRB, 0.19486367E-05_JPRB, 0.17694558E-05_JPRB, 0.16878331E-05_JPRB, 0.16431595E-05_JPRB, 0.16208982E-05_JPRB, &
  & 0.16002474E-05_JPRB, 0.15668577E-05_JPRB, 0.15125369E-05_JPRB, 0.14415251E-05_JPRB, 0.13665065E-05_JPRB, 0.13020676E-05_JPRB, &
  & 0.12380732E-05_JPRB, 0.11943261E-05_JPRB, 0.11578343E-05_JPRB, 0.11236026E-05_JPRB, 0.11034414E-05_JPRB, 0.10866034E-05_JPRB, &
  & 0.10756603E-05_JPRB, 0.10595351E-05_JPRB, 0.10407517E-05_JPRB, 0.10163349E-05_JPRB, 0.98775344E-06_JPRB, 0.95571318E-06_JPRB, &
  & 0.91986723E-06_JPRB, 0.87483137E-06_JPRB, 0.83090094E-06_JPRB, 0.79410670E-06_JPRB, 0.76443223E-06_JPRB, 0.74311911E-06_JPRB, &
  & 0.72972937E-06_JPRB, 0.72078058E-06_JPRB, 0.72491533E-06_JPRB, 0.73425401E-06_JPRB, 0.74914658E-06_JPRB, 0.77226847E-06_JPRB, &
  & 0.79542145E-06_JPRB, 0.82311611E-06_JPRB, 0.84594183E-06_JPRB, 0.87003694E-06_JPRB, 0.88860319E-06_JPRB, 0.89487612E-06_JPRB, &
  & 0.90218107E-06_JPRB, 0.90537992E-06_JPRB, 0.90607299E-06_JPRB, 0.90209838E-06_JPRB, 0.89704277E-06_JPRB, 0.88627096E-06_JPRB, &
  & 0.87558764E-06_JPRB, 0.86794134E-06_JPRB, 0.86823150E-06_JPRB, 0.87141335E-06_JPRB, 0.86624197E-06_JPRB, 0.83987600E-06_JPRB, &
  & 0.78003606E-06_JPRB, 0.71513578E-06_JPRB, 0.67700138E-06_JPRB, 0.69630934E-06_JPRB  /)

RGHG7(:, 5, 8) = (/ &
  & 0.27730705E-05_JPRB, 0.27607117E-05_JPRB, 0.27499113E-05_JPRB, 0.27190900E-05_JPRB, 0.26962929E-05_JPRB, 0.26987775E-05_JPRB, &
  & 0.27153337E-05_JPRB, 0.27334065E-05_JPRB, 0.27252406E-05_JPRB, 0.26650269E-05_JPRB, 0.25849206E-05_JPRB, 0.25242638E-05_JPRB, &
  & 0.24580077E-05_JPRB, 0.23762094E-05_JPRB, 0.22706122E-05_JPRB, 0.21435118E-05_JPRB, 0.20169544E-05_JPRB, 0.19026378E-05_JPRB, &
  & 0.17859228E-05_JPRB, 0.16968787E-05_JPRB, 0.16222823E-05_JPRB, 0.15560064E-05_JPRB, 0.15139860E-05_JPRB, 0.14789096E-05_JPRB, &
  & 0.14553822E-05_JPRB, 0.14187301E-05_JPRB, 0.13781430E-05_JPRB, 0.13279135E-05_JPRB, 0.12658901E-05_JPRB, 0.12016168E-05_JPRB, &
  & 0.11317879E-05_JPRB, 0.10634556E-05_JPRB, 0.99470840E-06_JPRB, 0.93082617E-06_JPRB, 0.87697336E-06_JPRB, 0.84061171E-06_JPRB, &
  & 0.81809228E-06_JPRB, 0.80407603E-06_JPRB, 0.81007513E-06_JPRB, 0.82824166E-06_JPRB, 0.85807997E-06_JPRB, 0.89912373E-06_JPRB, &
  & 0.94682161E-06_JPRB, 0.99440262E-06_JPRB, 0.10434587E-05_JPRB, 0.10902698E-05_JPRB, 0.11336405E-05_JPRB, 0.11684321E-05_JPRB, &
  & 0.11902873E-05_JPRB, 0.12030336E-05_JPRB, 0.12096216E-05_JPRB, 0.12102423E-05_JPRB, 0.12035644E-05_JPRB, 0.11936380E-05_JPRB, &
  & 0.11896979E-05_JPRB, 0.11872863E-05_JPRB, 0.11914507E-05_JPRB, 0.12023121E-05_JPRB, 0.12065777E-05_JPRB, 0.11775045E-05_JPRB, &
  & 0.11138977E-05_JPRB, 0.10460431E-05_JPRB, 0.97607459E-06_JPRB, 0.93119537E-06_JPRB  /)

RGHG7(:, 6, 8) = (/ &
  & 0.28009476E-05_JPRB, 0.27875177E-05_JPRB, 0.27840431E-05_JPRB, 0.27596102E-05_JPRB, 0.27294874E-05_JPRB, 0.27171483E-05_JPRB, &
  & 0.27248295E-05_JPRB, 0.27441074E-05_JPRB, 0.27280993E-05_JPRB, 0.26603876E-05_JPRB, 0.25839921E-05_JPRB, 0.25331475E-05_JPRB, &
  & 0.24689380E-05_JPRB, 0.23935474E-05_JPRB, 0.23022383E-05_JPRB, 0.21963691E-05_JPRB, 0.20843485E-05_JPRB, 0.19825411E-05_JPRB, &
  & 0.18839970E-05_JPRB, 0.17969230E-05_JPRB, 0.17259225E-05_JPRB, 0.16685408E-05_JPRB, 0.16290261E-05_JPRB, 0.15968571E-05_JPRB, &
  & 0.15757588E-05_JPRB, 0.15377487E-05_JPRB, 0.14951532E-05_JPRB, 0.14415764E-05_JPRB, 0.13705249E-05_JPRB, 0.12986390E-05_JPRB, &
  & 0.12302255E-05_JPRB, 0.11687408E-05_JPRB, 0.11068985E-05_JPRB, 0.10484484E-05_JPRB, 0.99752211E-06_JPRB, 0.96659260E-06_JPRB, &
  & 0.94870197E-06_JPRB, 0.93954405E-06_JPRB, 0.94429988E-06_JPRB, 0.96108924E-06_JPRB, 0.98997119E-06_JPRB, 0.10260992E-05_JPRB, &
  & 0.10665479E-05_JPRB, 0.11097870E-05_JPRB, 0.11546160E-05_JPRB, 0.11964157E-05_JPRB, 0.12327476E-05_JPRB, 0.12627765E-05_JPRB, &
  & 0.12822599E-05_JPRB, 0.12932082E-05_JPRB, 0.12986486E-05_JPRB, 0.13001300E-05_JPRB, 0.12920559E-05_JPRB, 0.12787821E-05_JPRB, &
  & 0.12691039E-05_JPRB, 0.12587353E-05_JPRB, 0.12503905E-05_JPRB, 0.12497564E-05_JPRB, 0.12497184E-05_JPRB, 0.12244706E-05_JPRB, &
  & 0.11756301E-05_JPRB, 0.11288729E-05_JPRB, 0.10561118E-05_JPRB, 0.10251381E-05_JPRB  /)

RGHG7(:, 7, 8) = (/ &
  & 0.28508220E-05_JPRB, 0.28427795E-05_JPRB, 0.28424865E-05_JPRB, 0.28284099E-05_JPRB, 0.28058643E-05_JPRB, 0.27910650E-05_JPRB, &
  & 0.27877449E-05_JPRB, 0.28033570E-05_JPRB, 0.27956367E-05_JPRB, 0.27405402E-05_JPRB, 0.26748973E-05_JPRB, 0.26284906E-05_JPRB, &
  & 0.25790474E-05_JPRB, 0.25212393E-05_JPRB, 0.24524553E-05_JPRB, 0.23709063E-05_JPRB, 0.22773878E-05_JPRB, 0.21940280E-05_JPRB, &
  & 0.21172641E-05_JPRB, 0.20392494E-05_JPRB, 0.19713467E-05_JPRB, 0.19153233E-05_JPRB, 0.18728120E-05_JPRB, 0.18337330E-05_JPRB, &
  & 0.18131842E-05_JPRB, 0.17766789E-05_JPRB, 0.17363448E-05_JPRB, 0.16823688E-05_JPRB, 0.16085865E-05_JPRB, 0.15369253E-05_JPRB, &
  & 0.14714673E-05_JPRB, 0.14185288E-05_JPRB, 0.13701948E-05_JPRB, 0.13248863E-05_JPRB, 0.12857553E-05_JPRB, 0.12638427E-05_JPRB, &
  & 0.12573401E-05_JPRB, 0.12567229E-05_JPRB, 0.12662955E-05_JPRB, 0.12836704E-05_JPRB, 0.13094890E-05_JPRB, 0.13383992E-05_JPRB, &
  & 0.13693267E-05_JPRB, 0.14025289E-05_JPRB, 0.14367702E-05_JPRB, 0.14684139E-05_JPRB, 0.14930729E-05_JPRB, 0.15113015E-05_JPRB, &
  & 0.15209907E-05_JPRB, 0.15251089E-05_JPRB, 0.15227662E-05_JPRB, 0.15190696E-05_JPRB, 0.15079555E-05_JPRB, 0.14884775E-05_JPRB, &
  & 0.14682757E-05_JPRB, 0.14448132E-05_JPRB, 0.14195703E-05_JPRB, 0.13974279E-05_JPRB, 0.13877513E-05_JPRB, 0.13700431E-05_JPRB, &
  & 0.13365520E-05_JPRB, 0.13014597E-05_JPRB, 0.12320899E-05_JPRB, 0.12152057E-05_JPRB  /)

RGHG7(:, 8, 8) = (/ &
  & 0.29373550E-05_JPRB, 0.29384137E-05_JPRB, 0.29392654E-05_JPRB, 0.29365274E-05_JPRB, 0.29293445E-05_JPRB, 0.29217128E-05_JPRB, &
  & 0.29189671E-05_JPRB, 0.29312480E-05_JPRB, 0.29343615E-05_JPRB, 0.29009011E-05_JPRB, 0.28562966E-05_JPRB, 0.28234500E-05_JPRB, &
  & 0.28000293E-05_JPRB, 0.27721566E-05_JPRB, 0.27319595E-05_JPRB, 0.26824031E-05_JPRB, 0.26169118E-05_JPRB, 0.25584580E-05_JPRB, &
  & 0.25016549E-05_JPRB, 0.24358951E-05_JPRB, 0.23705164E-05_JPRB, 0.23130652E-05_JPRB, 0.22663279E-05_JPRB, 0.22202125E-05_JPRB, &
  & 0.21965162E-05_JPRB, 0.21610959E-05_JPRB, 0.21275319E-05_JPRB, 0.20823001E-05_JPRB, 0.20217214E-05_JPRB, 0.19656875E-05_JPRB, &
  & 0.19159197E-05_JPRB, 0.18797710E-05_JPRB, 0.18489453E-05_JPRB, 0.18214318E-05_JPRB, 0.17982442E-05_JPRB, 0.17897892E-05_JPRB, &
  & 0.17994365E-05_JPRB, 0.18087756E-05_JPRB, 0.18243614E-05_JPRB, 0.18442901E-05_JPRB, 0.18662867E-05_JPRB, 0.18855192E-05_JPRB, &
  & 0.19048643E-05_JPRB, 0.19228446E-05_JPRB, 0.19397409E-05_JPRB, 0.19517327E-05_JPRB, 0.19564163E-05_JPRB, 0.19543314E-05_JPRB, &
  & 0.19455229E-05_JPRB, 0.19345134E-05_JPRB, 0.19160671E-05_JPRB, 0.18971825E-05_JPRB, 0.18741747E-05_JPRB, 0.18429983E-05_JPRB, &
  & 0.18102595E-05_JPRB, 0.17719957E-05_JPRB, 0.17307274E-05_JPRB, 0.16913441E-05_JPRB, 0.16756415E-05_JPRB, 0.16684197E-05_JPRB, &
  & 0.16535185E-05_JPRB, 0.16345673E-05_JPRB, 0.15765633E-05_JPRB, 0.15666244E-05_JPRB  /)

RGHG7(:, 9, 8) = (/ &
  & 0.30522493E-05_JPRB, 0.30624309E-05_JPRB, 0.30682535E-05_JPRB, 0.30801021E-05_JPRB, 0.31048587E-05_JPRB, 0.31294051E-05_JPRB, &
  & 0.31542493E-05_JPRB, 0.31796040E-05_JPRB, 0.32031658E-05_JPRB, 0.32051921E-05_JPRB, 0.31991429E-05_JPRB, 0.32032683E-05_JPRB, &
  & 0.32226457E-05_JPRB, 0.32386926E-05_JPRB, 0.32359913E-05_JPRB, 0.32237315E-05_JPRB, 0.31915592E-05_JPRB, 0.31540926E-05_JPRB, &
  & 0.31057682E-05_JPRB, 0.30475831E-05_JPRB, 0.29828238E-05_JPRB, 0.29207204E-05_JPRB, 0.28677619E-05_JPRB, 0.28145358E-05_JPRB, &
  & 0.27839349E-05_JPRB, 0.27464961E-05_JPRB, 0.27235999E-05_JPRB, 0.26985244E-05_JPRB, 0.26687526E-05_JPRB, 0.26466159E-05_JPRB, &
  & 0.26285066E-05_JPRB, 0.26159839E-05_JPRB, 0.26020132E-05_JPRB, 0.25889683E-05_JPRB, 0.25792412E-05_JPRB, 0.25841372E-05_JPRB, &
  & 0.26094682E-05_JPRB, 0.26292545E-05_JPRB, 0.26520382E-05_JPRB, 0.26781232E-05_JPRB, 0.26984189E-05_JPRB, 0.27089765E-05_JPRB, &
  & 0.27153582E-05_JPRB, 0.27129113E-05_JPRB, 0.27055883E-05_JPRB, 0.26885158E-05_JPRB, 0.26648917E-05_JPRB, 0.26345297E-05_JPRB, &
  & 0.25979225E-05_JPRB, 0.25603675E-05_JPRB, 0.25150302E-05_JPRB, 0.24682068E-05_JPRB, 0.24214062E-05_JPRB, 0.23720357E-05_JPRB, &
  & 0.23270119E-05_JPRB, 0.22779208E-05_JPRB, 0.22291221E-05_JPRB, 0.21858345E-05_JPRB, 0.21717515E-05_JPRB, 0.21765185E-05_JPRB, &
  & 0.21855241E-05_JPRB, 0.21957153E-05_JPRB, 0.21665689E-05_JPRB, 0.21616364E-05_JPRB  /)

RGHG7(:,10, 8) = (/ &
  & 0.31350924E-05_JPRB, 0.31477998E-05_JPRB, 0.31726868E-05_JPRB, 0.32181295E-05_JPRB, 0.33074438E-05_JPRB, 0.34061708E-05_JPRB, &
  & 0.35038913E-05_JPRB, 0.35948963E-05_JPRB, 0.36832448E-05_JPRB, 0.37588891E-05_JPRB, 0.38284835E-05_JPRB, 0.39088901E-05_JPRB, &
  & 0.39957928E-05_JPRB, 0.40680949E-05_JPRB, 0.41136411E-05_JPRB, 0.41341529E-05_JPRB, 0.41210210E-05_JPRB, 0.40821888E-05_JPRB, &
  & 0.40236333E-05_JPRB, 0.39572750E-05_JPRB, 0.38849446E-05_JPRB, 0.38092478E-05_JPRB, 0.37415259E-05_JPRB, 0.36699658E-05_JPRB, &
  & 0.36225414E-05_JPRB, 0.35717437E-05_JPRB, 0.35503894E-05_JPRB, 0.35408761E-05_JPRB, 0.35347605E-05_JPRB, 0.35428739E-05_JPRB, &
  & 0.35559556E-05_JPRB, 0.35633526E-05_JPRB, 0.35614521E-05_JPRB, 0.35510757E-05_JPRB, 0.35423461E-05_JPRB, 0.35522636E-05_JPRB, &
  & 0.35864951E-05_JPRB, 0.36192573E-05_JPRB, 0.36537152E-05_JPRB, 0.36910104E-05_JPRB, 0.37170023E-05_JPRB, 0.37273279E-05_JPRB, &
  & 0.37241840E-05_JPRB, 0.37014312E-05_JPRB, 0.36681401E-05_JPRB, 0.36217084E-05_JPRB, 0.35678263E-05_JPRB, 0.35076330E-05_JPRB, &
  & 0.34392707E-05_JPRB, 0.33686011E-05_JPRB, 0.32913775E-05_JPRB, 0.32128470E-05_JPRB, 0.31401942E-05_JPRB, 0.30734674E-05_JPRB, &
  & 0.30218314E-05_JPRB, 0.29720594E-05_JPRB, 0.29273314E-05_JPRB, 0.28887954E-05_JPRB, 0.28768328E-05_JPRB, 0.28909679E-05_JPRB, &
  & 0.29307458E-05_JPRB, 0.29851438E-05_JPRB, 0.30088635E-05_JPRB, 0.30289092E-05_JPRB  /)

RGHG7(:,11, 8) = (/ &
  & 0.32559690E-05_JPRB, 0.32684875E-05_JPRB, 0.33101171E-05_JPRB, 0.33894767E-05_JPRB, 0.35370359E-05_JPRB, 0.37173754E-05_JPRB, &
  & 0.39133676E-05_JPRB, 0.41260959E-05_JPRB, 0.43403340E-05_JPRB, 0.45455047E-05_JPRB, 0.47437898E-05_JPRB, 0.49389253E-05_JPRB, &
  & 0.51207534E-05_JPRB, 0.52648310E-05_JPRB, 0.53630831E-05_JPRB, 0.54053704E-05_JPRB, 0.53918883E-05_JPRB, 0.53416951E-05_JPRB, &
  & 0.52707791E-05_JPRB, 0.51926373E-05_JPRB, 0.51089047E-05_JPRB, 0.50163305E-05_JPRB, 0.49261757E-05_JPRB, 0.48250929E-05_JPRB, &
  & 0.47430702E-05_JPRB, 0.46605004E-05_JPRB, 0.46131878E-05_JPRB, 0.45891149E-05_JPRB, 0.45721984E-05_JPRB, 0.45759071E-05_JPRB, &
  & 0.45943951E-05_JPRB, 0.46063755E-05_JPRB, 0.46074356E-05_JPRB, 0.45928675E-05_JPRB, 0.45742955E-05_JPRB, 0.45839095E-05_JPRB, &
  & 0.46230580E-05_JPRB, 0.46728295E-05_JPRB, 0.47245034E-05_JPRB, 0.47745774E-05_JPRB, 0.48120754E-05_JPRB, 0.48268699E-05_JPRB, &
  & 0.48183011E-05_JPRB, 0.47829311E-05_JPRB, 0.47291411E-05_JPRB, 0.46610854E-05_JPRB, 0.45821093E-05_JPRB, 0.44987627E-05_JPRB, &
  & 0.44064311E-05_JPRB, 0.43132574E-05_JPRB, 0.42175695E-05_JPRB, 0.41241560E-05_JPRB, 0.40428446E-05_JPRB, 0.39719762E-05_JPRB, &
  & 0.39218974E-05_JPRB, 0.38749050E-05_JPRB, 0.38292415E-05_JPRB, 0.37821221E-05_JPRB, 0.37496512E-05_JPRB, 0.37501758E-05_JPRB, &
  & 0.38023122E-05_JPRB, 0.38848138E-05_JPRB, 0.39530354E-05_JPRB, 0.40043856E-05_JPRB  /)

RGHG7(:,12, 8) = (/ &
  & 0.36585278E-05_JPRB, 0.36719492E-05_JPRB, 0.36901731E-05_JPRB, 0.37382415E-05_JPRB, 0.38600252E-05_JPRB, 0.40570797E-05_JPRB, &
  & 0.43030391E-05_JPRB, 0.46160143E-05_JPRB, 0.49584287E-05_JPRB, 0.53150217E-05_JPRB, 0.56629595E-05_JPRB, 0.59862402E-05_JPRB, &
  & 0.62838468E-05_JPRB, 0.65137542E-05_JPRB, 0.66647088E-05_JPRB, 0.67244725E-05_JPRB, 0.67212501E-05_JPRB, 0.66841084E-05_JPRB, &
  & 0.66313875E-05_JPRB, 0.65729946E-05_JPRB, 0.65102190E-05_JPRB, 0.64357028E-05_JPRB, 0.63531623E-05_JPRB, 0.62551255E-05_JPRB, &
  & 0.61624902E-05_JPRB, 0.60622203E-05_JPRB, 0.59838291E-05_JPRB, 0.59249589E-05_JPRB, 0.58747683E-05_JPRB, 0.58400334E-05_JPRB, &
  & 0.58223183E-05_JPRB, 0.57995441E-05_JPRB, 0.57720272E-05_JPRB, 0.57428637E-05_JPRB, 0.57169719E-05_JPRB, 0.57301928E-05_JPRB, &
  & 0.57745046E-05_JPRB, 0.58367637E-05_JPRB, 0.59005836E-05_JPRB, 0.59542062E-05_JPRB, 0.59921430E-05_JPRB, 0.60004400E-05_JPRB, &
  & 0.59784905E-05_JPRB, 0.59334264E-05_JPRB, 0.58673037E-05_JPRB, 0.57875162E-05_JPRB, 0.56931367E-05_JPRB, 0.56002912E-05_JPRB, &
  & 0.55034898E-05_JPRB, 0.54090890E-05_JPRB, 0.53135269E-05_JPRB, 0.52224273E-05_JPRB, 0.51467522E-05_JPRB, 0.50758337E-05_JPRB, &
  & 0.50161501E-05_JPRB, 0.49510852E-05_JPRB, 0.48677758E-05_JPRB, 0.47747059E-05_JPRB, 0.46715560E-05_JPRB, 0.45984695E-05_JPRB, &
  & 0.46005250E-05_JPRB, 0.46512559E-05_JPRB, 0.47070984E-05_JPRB, 0.47506541E-05_JPRB  /)

RGHG7(:,13, 8) = (/ &
  & 0.41208515E-05_JPRB, 0.41282682E-05_JPRB, 0.41239573E-05_JPRB, 0.41312536E-05_JPRB, 0.41979296E-05_JPRB, 0.43487095E-05_JPRB, &
  & 0.45916857E-05_JPRB, 0.49396261E-05_JPRB, 0.53603564E-05_JPRB, 0.58425698E-05_JPRB, 0.63277803E-05_JPRB, 0.67714201E-05_JPRB, &
  & 0.71772610E-05_JPRB, 0.74757682E-05_JPRB, 0.76591115E-05_JPRB, 0.77336966E-05_JPRB, 0.77465450E-05_JPRB, 0.77344105E-05_JPRB, &
  & 0.77157588E-05_JPRB, 0.76949319E-05_JPRB, 0.76761723E-05_JPRB, 0.76543640E-05_JPRB, 0.76304564E-05_JPRB, 0.75944908E-05_JPRB, &
  & 0.75548559E-05_JPRB, 0.74977555E-05_JPRB, 0.74393631E-05_JPRB, 0.73698164E-05_JPRB, 0.72866566E-05_JPRB, 0.71946008E-05_JPRB, &
  & 0.71092131E-05_JPRB, 0.70221292E-05_JPRB, 0.69560824E-05_JPRB, 0.69195057E-05_JPRB, 0.69017474E-05_JPRB, 0.69305217E-05_JPRB, &
  & 0.69872824E-05_JPRB, 0.70487624E-05_JPRB, 0.71002975E-05_JPRB, 0.71326438E-05_JPRB, 0.71440680E-05_JPRB, 0.71310596E-05_JPRB, &
  & 0.70932094E-05_JPRB, 0.70407083E-05_JPRB, 0.69756233E-05_JPRB, 0.69053285E-05_JPRB, 0.68174031E-05_JPRB, 0.67303557E-05_JPRB, &
  & 0.66436589E-05_JPRB, 0.65567782E-05_JPRB, 0.64603091E-05_JPRB, 0.63605953E-05_JPRB, 0.62672786E-05_JPRB, 0.61650934E-05_JPRB, &
  & 0.60567111E-05_JPRB, 0.59315818E-05_JPRB, 0.57666651E-05_JPRB, 0.55892639E-05_JPRB, 0.53791471E-05_JPRB, 0.51998112E-05_JPRB, &
  & 0.51105766E-05_JPRB, 0.50847655E-05_JPRB, 0.50892769E-05_JPRB, 0.51057319E-05_JPRB  /)

RGHG7(:,14, 8) = (/ &
  & 0.43828779E-05_JPRB, 0.43802521E-05_JPRB, 0.43769450E-05_JPRB, 0.43720511E-05_JPRB, 0.44070483E-05_JPRB, 0.45048653E-05_JPRB, &
  & 0.47079993E-05_JPRB, 0.50363783E-05_JPRB, 0.54748712E-05_JPRB, 0.60153499E-05_JPRB, 0.65881284E-05_JPRB, 0.71191817E-05_JPRB, &
  & 0.75915893E-05_JPRB, 0.79252918E-05_JPRB, 0.81168460E-05_JPRB, 0.81957973E-05_JPRB, 0.82186958E-05_JPRB, 0.82199224E-05_JPRB, &
  & 0.82167927E-05_JPRB, 0.82166887E-05_JPRB, 0.82307348E-05_JPRB, 0.82597361E-05_JPRB, 0.83008207E-05_JPRB, 0.83492848E-05_JPRB, &
  & 0.83935865E-05_JPRB, 0.84204903E-05_JPRB, 0.84419440E-05_JPRB, 0.84287138E-05_JPRB, 0.83693126E-05_JPRB, 0.82737439E-05_JPRB, &
  & 0.81684213E-05_JPRB, 0.80658537E-05_JPRB, 0.80081073E-05_JPRB, 0.79919785E-05_JPRB, 0.79973680E-05_JPRB, 0.80445728E-05_JPRB, &
  & 0.81067308E-05_JPRB, 0.81502340E-05_JPRB, 0.81591703E-05_JPRB, 0.81410753E-05_JPRB, 0.81097750E-05_JPRB, 0.80686461E-05_JPRB, &
  & 0.80177289E-05_JPRB, 0.79611272E-05_JPRB, 0.79025715E-05_JPRB, 0.78516994E-05_JPRB, 0.77828465E-05_JPRB, 0.77035751E-05_JPRB, &
  & 0.76168366E-05_JPRB, 0.75172180E-05_JPRB, 0.73980467E-05_JPRB, 0.72620386E-05_JPRB, 0.71146553E-05_JPRB, 0.69493389E-05_JPRB, &
  & 0.67652390E-05_JPRB, 0.65591570E-05_JPRB, 0.63057415E-05_JPRB, 0.60453073E-05_JPRB, 0.57485281E-05_JPRB, 0.54842435E-05_JPRB, &
  & 0.53059997E-05_JPRB, 0.52028958E-05_JPRB, 0.51518412E-05_JPRB, 0.51385317E-05_JPRB  /)

RGHG7(:,15, 8) = (/ &
  & 0.44377260E-05_JPRB, 0.44308730E-05_JPRB, 0.44203085E-05_JPRB, 0.44051620E-05_JPRB, 0.44160681E-05_JPRB, 0.44761807E-05_JPRB, &
  & 0.46285433E-05_JPRB, 0.49053216E-05_JPRB, 0.53118626E-05_JPRB, 0.58415406E-05_JPRB, 0.64236082E-05_JPRB, 0.69914923E-05_JPRB, &
  & 0.75015846E-05_JPRB, 0.78648343E-05_JPRB, 0.80746119E-05_JPRB, 0.81754563E-05_JPRB, 0.82227922E-05_JPRB, 0.82443999E-05_JPRB, &
  & 0.82579574E-05_JPRB, 0.82765719E-05_JPRB, 0.83139057E-05_JPRB, 0.83752553E-05_JPRB, 0.84575910E-05_JPRB, 0.85607011E-05_JPRB, &
  & 0.86696737E-05_JPRB, 0.87732650E-05_JPRB, 0.88785241E-05_JPRB, 0.89678478E-05_JPRB, 0.90152251E-05_JPRB, 0.90209286E-05_JPRB, &
  & 0.90031077E-05_JPRB, 0.89804898E-05_JPRB, 0.89796153E-05_JPRB, 0.89890013E-05_JPRB, 0.89927657E-05_JPRB, 0.90106499E-05_JPRB, &
  & 0.90256934E-05_JPRB, 0.90091498E-05_JPRB, 0.89525528E-05_JPRB, 0.88730407E-05_JPRB, 0.87992270E-05_JPRB, 0.87318143E-05_JPRB, &
  & 0.86680888E-05_JPRB, 0.86043869E-05_JPRB, 0.85442569E-05_JPRB, 0.84936904E-05_JPRB, 0.84185534E-05_JPRB, 0.83204190E-05_JPRB, &
  & 0.81982856E-05_JPRB, 0.80526955E-05_JPRB, 0.78830256E-05_JPRB, 0.76922055E-05_JPRB, 0.74833686E-05_JPRB, 0.72597313E-05_JPRB, &
  & 0.70202358E-05_JPRB, 0.67652851E-05_JPRB, 0.64595562E-05_JPRB, 0.61494766E-05_JPRB, 0.58130212E-05_JPRB, 0.54962404E-05_JPRB, &
  & 0.52523392E-05_JPRB, 0.50826061E-05_JPRB, 0.49833117E-05_JPRB, 0.49460098E-05_JPRB  /)

RGHG7(:,16, 8) = (/ &
  & 0.43378377E-05_JPRB, 0.43254586E-05_JPRB, 0.43024576E-05_JPRB, 0.42761165E-05_JPRB, 0.42650184E-05_JPRB, 0.42903142E-05_JPRB, &
  & 0.43916526E-05_JPRB, 0.45993458E-05_JPRB, 0.49286271E-05_JPRB, 0.53917813E-05_JPRB, 0.59273369E-05_JPRB, 0.64812277E-05_JPRB, &
  & 0.69991279E-05_JPRB, 0.73977245E-05_JPRB, 0.76488748E-05_JPRB, 0.78077672E-05_JPRB, 0.79154734E-05_JPRB, 0.79887143E-05_JPRB, &
  & 0.80454877E-05_JPRB, 0.81019192E-05_JPRB, 0.81692757E-05_JPRB, 0.82562324E-05_JPRB, 0.83658793E-05_JPRB, 0.85015598E-05_JPRB, &
  & 0.86584624E-05_JPRB, 0.88246537E-05_JPRB, 0.90016898E-05_JPRB, 0.92003251E-05_JPRB, 0.93949615E-05_JPRB, 0.95828151E-05_JPRB, &
  & 0.97538764E-05_JPRB, 0.98737024E-05_JPRB, 0.99167356E-05_JPRB, 0.98913275E-05_JPRB, 0.98169818E-05_JPRB, 0.97409616E-05_JPRB, &
  & 0.96668558E-05_JPRB, 0.95721075E-05_JPRB, 0.94571303E-05_JPRB, 0.93308344E-05_JPRB, 0.92201793E-05_JPRB, 0.91265978E-05_JPRB, &
  & 0.90403523E-05_JPRB, 0.89468479E-05_JPRB, 0.88458605E-05_JPRB, 0.87470676E-05_JPRB, 0.86319489E-05_JPRB, 0.84925226E-05_JPRB, &
  & 0.83303279E-05_JPRB, 0.81472744E-05_JPRB, 0.79324687E-05_JPRB, 0.76946231E-05_JPRB, 0.74451296E-05_JPRB, 0.71845909E-05_JPRB, &
  & 0.69165145E-05_JPRB, 0.66381388E-05_JPRB, 0.63072237E-05_JPRB, 0.59646844E-05_JPRB, 0.56085337E-05_JPRB, 0.52674564E-05_JPRB, &
  & 0.49889221E-05_JPRB, 0.47767154E-05_JPRB, 0.46454590E-05_JPRB, 0.45934815E-05_JPRB  /)

RGHG7(:,17, 8) = (/ &
  & 0.42146278E-05_JPRB, 0.41988269E-05_JPRB, 0.41686556E-05_JPRB, 0.41345341E-05_JPRB, 0.41066926E-05_JPRB, 0.40969940E-05_JPRB, &
  & 0.41394273E-05_JPRB, 0.42661162E-05_JPRB, 0.44944609E-05_JPRB, 0.48453114E-05_JPRB, 0.52908430E-05_JPRB, 0.57895194E-05_JPRB, &
  & 0.62807706E-05_JPRB, 0.67021676E-05_JPRB, 0.70124946E-05_JPRB, 0.72457783E-05_JPRB, 0.74291778E-05_JPRB, 0.75668072E-05_JPRB, &
  & 0.76741073E-05_JPRB, 0.77696344E-05_JPRB, 0.78676192E-05_JPRB, 0.79763880E-05_JPRB, 0.81041189E-05_JPRB, 0.82571470E-05_JPRB, &
  & 0.84431099E-05_JPRB, 0.86496249E-05_JPRB, 0.88720350E-05_JPRB, 0.91457102E-05_JPRB, 0.94635318E-05_JPRB, 0.98083140E-05_JPRB, &
  & 0.10152757E-04_JPRB, 0.10372094E-04_JPRB, 0.10426583E-04_JPRB, 0.10357629E-04_JPRB, 0.10220545E-04_JPRB, 0.10091356E-04_JPRB, &
  & 0.99737731E-05_JPRB, 0.98389670E-05_JPRB, 0.96941983E-05_JPRB, 0.95451122E-05_JPRB, 0.94099136E-05_JPRB, 0.92887876E-05_JPRB, &
  & 0.91664820E-05_JPRB, 0.90308077E-05_JPRB, 0.88789943E-05_JPRB, 0.87277347E-05_JPRB, 0.85693232E-05_JPRB, 0.83883243E-05_JPRB, &
  & 0.81897485E-05_JPRB, 0.79753057E-05_JPRB, 0.77246442E-05_JPRB, 0.74525129E-05_JPRB, 0.71838432E-05_JPRB, 0.69079797E-05_JPRB, &
  & 0.66249024E-05_JPRB, 0.63339952E-05_JPRB, 0.59958277E-05_JPRB, 0.56442609E-05_JPRB, 0.52908104E-05_JPRB, 0.49532736E-05_JPRB, &
  & 0.46637229E-05_JPRB, 0.44358989E-05_JPRB, 0.42927471E-05_JPRB, 0.42340100E-05_JPRB  /)

RGHG7(:,18, 8) = (/ &
  & 0.41373347E-05_JPRB, 0.41231971E-05_JPRB, 0.40931633E-05_JPRB, 0.40564669E-05_JPRB, 0.40176492E-05_JPRB, 0.39821044E-05_JPRB, &
  & 0.39764435E-05_JPRB, 0.40285065E-05_JPRB, 0.41575276E-05_JPRB, 0.43873671E-05_JPRB, 0.47228767E-05_JPRB, 0.51441233E-05_JPRB, &
  & 0.55862977E-05_JPRB, 0.60072665E-05_JPRB, 0.63696139E-05_JPRB, 0.66731247E-05_JPRB, 0.69220066E-05_JPRB, 0.71038673E-05_JPRB, &
  & 0.72435869E-05_JPRB, 0.73653565E-05_JPRB, 0.74821034E-05_JPRB, 0.76029402E-05_JPRB, 0.77357976E-05_JPRB, 0.78929301E-05_JPRB, &
  & 0.80903042E-05_JPRB, 0.83052585E-05_JPRB, 0.85396351E-05_JPRB, 0.88528509E-05_JPRB, 0.92424722E-05_JPRB, 0.96664017E-05_JPRB, &
  & 0.10105640E-04_JPRB, 0.10387358E-04_JPRB, 0.10453948E-04_JPRB, 0.10381556E-04_JPRB, 0.10249668E-04_JPRB, 0.10130621E-04_JPRB, &
  & 0.10021489E-04_JPRB, 0.98901222E-05_JPRB, 0.97447312E-05_JPRB, 0.95904073E-05_JPRB, 0.94469140E-05_JPRB, 0.93085932E-05_JPRB, &
  & 0.91567991E-05_JPRB, 0.89853462E-05_JPRB, 0.87874616E-05_JPRB, 0.85822708E-05_JPRB, 0.83741196E-05_JPRB, 0.81513421E-05_JPRB, &
  & 0.79276558E-05_JPRB, 0.76960326E-05_JPRB, 0.74320211E-05_JPRB, 0.71580914E-05_JPRB, 0.68948329E-05_JPRB, 0.66221485E-05_JPRB, &
  & 0.63324071E-05_JPRB, 0.60270702E-05_JPRB, 0.56823951E-05_JPRB, 0.53373350E-05_JPRB, 0.49956641E-05_JPRB, 0.46622243E-05_JPRB, &
  & 0.43619369E-05_JPRB, 0.41187025E-05_JPRB, 0.39673995E-05_JPRB, 0.39049501E-05_JPRB  /)

RGHG7(:,19, 8) = (/ &
  & 0.40775583E-05_JPRB, 0.40621756E-05_JPRB, 0.40305879E-05_JPRB, 0.39899386E-05_JPRB, 0.39446622E-05_JPRB, 0.38993682E-05_JPRB, &
  & 0.38683146E-05_JPRB, 0.38735079E-05_JPRB, 0.39342093E-05_JPRB, 0.40728596E-05_JPRB, 0.43158328E-05_JPRB, 0.46624015E-05_JPRB, &
  & 0.50517401E-05_JPRB, 0.54555871E-05_JPRB, 0.58468509E-05_JPRB, 0.61923737E-05_JPRB, 0.64788241E-05_JPRB, 0.66793714E-05_JPRB, &
  & 0.68315336E-05_JPRB, 0.69669472E-05_JPRB, 0.70845238E-05_JPRB, 0.71970253E-05_JPRB, 0.73185907E-05_JPRB, 0.74712505E-05_JPRB, &
  & 0.76661687E-05_JPRB, 0.78701909E-05_JPRB, 0.81104338E-05_JPRB, 0.84282860E-05_JPRB, 0.88303934E-05_JPRB, 0.92670941E-05_JPRB, &
  & 0.97374149E-05_JPRB, 0.10043991E-04_JPRB, 0.10122948E-04_JPRB, 0.10074610E-04_JPRB, 0.99864958E-05_JPRB, 0.99099437E-05_JPRB, &
  & 0.98437805E-05_JPRB, 0.97490706E-05_JPRB, 0.96268154E-05_JPRB, 0.94839634E-05_JPRB, 0.93441034E-05_JPRB, 0.91977903E-05_JPRB, &
  & 0.90294444E-05_JPRB, 0.88418708E-05_JPRB, 0.86187844E-05_JPRB, 0.83766024E-05_JPRB, 0.81269163E-05_JPRB, 0.78677630E-05_JPRB, &
  & 0.76203550E-05_JPRB, 0.73760650E-05_JPRB, 0.71117886E-05_JPRB, 0.68447324E-05_JPRB, 0.65861660E-05_JPRB, 0.63158313E-05_JPRB, &
  & 0.60192039E-05_JPRB, 0.57040845E-05_JPRB, 0.53573360E-05_JPRB, 0.50218788E-05_JPRB, 0.46947305E-05_JPRB, 0.43691400E-05_JPRB, &
  & 0.40663959E-05_JPRB, 0.38087138E-05_JPRB, 0.36520624E-05_JPRB, 0.35908727E-05_JPRB  /)

RGHG7(:,20, 8) = (/ &
  & 0.39790189E-05_JPRB, 0.39612258E-05_JPRB, 0.39254432E-05_JPRB, 0.38778178E-05_JPRB, 0.38278012E-05_JPRB, 0.37831590E-05_JPRB, &
  & 0.37464409E-05_JPRB, 0.37367467E-05_JPRB, 0.37700418E-05_JPRB, 0.38660732E-05_JPRB, 0.40557178E-05_JPRB, 0.43500082E-05_JPRB, &
  & 0.46965819E-05_JPRB, 0.50738964E-05_JPRB, 0.54656314E-05_JPRB, 0.58258153E-05_JPRB, 0.61190233E-05_JPRB, 0.63178781E-05_JPRB, &
  & 0.64680268E-05_JPRB, 0.65989035E-05_JPRB, 0.67036079E-05_JPRB, 0.67933194E-05_JPRB, 0.68921862E-05_JPRB, 0.70280028E-05_JPRB, &
  & 0.72033134E-05_JPRB, 0.73918801E-05_JPRB, 0.76238290E-05_JPRB, 0.79107154E-05_JPRB, 0.82786097E-05_JPRB, 0.86970289E-05_JPRB, &
  & 0.91513524E-05_JPRB, 0.94376872E-05_JPRB, 0.95290455E-05_JPRB, 0.95219443E-05_JPRB, 0.94849089E-05_JPRB, 0.94518257E-05_JPRB, &
  & 0.94324166E-05_JPRB, 0.93828246E-05_JPRB, 0.92933916E-05_JPRB, 0.91711492E-05_JPRB, 0.90417010E-05_JPRB, 0.89016665E-05_JPRB, &
  & 0.87410458E-05_JPRB, 0.85632368E-05_JPRB, 0.83406792E-05_JPRB, 0.80855819E-05_JPRB, 0.78170509E-05_JPRB, 0.75395279E-05_JPRB, &
  & 0.72795807E-05_JPRB, 0.70332708E-05_JPRB, 0.67765449E-05_JPRB, 0.65113694E-05_JPRB, 0.62470077E-05_JPRB, 0.59695766E-05_JPRB, &
  & 0.56644095E-05_JPRB, 0.53459747E-05_JPRB, 0.50039606E-05_JPRB, 0.46843172E-05_JPRB, 0.43797522E-05_JPRB, 0.40754972E-05_JPRB, &
  & 0.37893877E-05_JPRB, 0.35264880E-05_JPRB, 0.33604145E-05_JPRB, 0.32891818E-05_JPRB  /)

RGHG7(:,21, 8) = (/ &
  & 0.38225671E-05_JPRB, 0.38022830E-05_JPRB, 0.37603656E-05_JPRB, 0.37039568E-05_JPRB, 0.36489563E-05_JPRB, 0.36075187E-05_JPRB, &
  & 0.35766967E-05_JPRB, 0.35767483E-05_JPRB, 0.36196824E-05_JPRB, 0.37209810E-05_JPRB, 0.39008446E-05_JPRB, 0.41721321E-05_JPRB, &
  & 0.44898338E-05_JPRB, 0.48363235E-05_JPRB, 0.52039517E-05_JPRB, 0.55557447E-05_JPRB, 0.58341823E-05_JPRB, 0.60167373E-05_JPRB, &
  & 0.61531008E-05_JPRB, 0.62640651E-05_JPRB, 0.63479297E-05_JPRB, 0.64103355E-05_JPRB, 0.64817019E-05_JPRB, 0.65908657E-05_JPRB, &
  & 0.67332802E-05_JPRB, 0.69022775E-05_JPRB, 0.71056384E-05_JPRB, 0.73362950E-05_JPRB, 0.76420702E-05_JPRB, 0.80194343E-05_JPRB, &
  & 0.84155391E-05_JPRB, 0.86493134E-05_JPRB, 0.87521827E-05_JPRB, 0.87895139E-05_JPRB, 0.87957287E-05_JPRB, 0.87950522E-05_JPRB, &
  & 0.88099394E-05_JPRB, 0.87957632E-05_JPRB, 0.87366762E-05_JPRB, 0.86380781E-05_JPRB, 0.85243067E-05_JPRB, 0.84059090E-05_JPRB, &
  & 0.82773509E-05_JPRB, 0.81320281E-05_JPRB, 0.79335269E-05_JPRB, 0.76905513E-05_JPRB, 0.74300213E-05_JPRB, 0.71590305E-05_JPRB, &
  & 0.69076791E-05_JPRB, 0.66762715E-05_JPRB, 0.64331870E-05_JPRB, 0.61661705E-05_JPRB, 0.58903824E-05_JPRB, 0.56012587E-05_JPRB, &
  & 0.52853475E-05_JPRB, 0.49656185E-05_JPRB, 0.46345388E-05_JPRB, 0.43371300E-05_JPRB, 0.40652542E-05_JPRB, 0.37971738E-05_JPRB, &
  & 0.35445816E-05_JPRB, 0.32890163E-05_JPRB, 0.31140992E-05_JPRB, 0.30229453E-05_JPRB  /)

RGHG7(:,22, 8) = (/ &
  & 0.36045474E-05_JPRB, 0.35815261E-05_JPRB, 0.35322080E-05_JPRB, 0.34674862E-05_JPRB, 0.34057947E-05_JPRB, 0.33619241E-05_JPRB, &
  & 0.33397192E-05_JPRB, 0.33647100E-05_JPRB, 0.34494121E-05_JPRB, 0.36007918E-05_JPRB, 0.38172531E-05_JPRB, 0.41000978E-05_JPRB, &
  & 0.44042147E-05_JPRB, 0.47197839E-05_JPRB, 0.50440220E-05_JPRB, 0.53654014E-05_JPRB, 0.56202178E-05_JPRB, 0.57758061E-05_JPRB, &
  & 0.58859124E-05_JPRB, 0.59680852E-05_JPRB, 0.60284299E-05_JPRB, 0.60701545E-05_JPRB, 0.61161762E-05_JPRB, 0.61950278E-05_JPRB, &
  & 0.62987156E-05_JPRB, 0.64359813E-05_JPRB, 0.65860171E-05_JPRB, 0.67498651E-05_JPRB, 0.69844724E-05_JPRB, 0.72872217E-05_JPRB, &
  & 0.75766762E-05_JPRB, 0.77474942E-05_JPRB, 0.78589808E-05_JPRB, 0.79259146E-05_JPRB, 0.79581837E-05_JPRB, 0.79744374E-05_JPRB, &
  & 0.80006790E-05_JPRB, 0.79957283E-05_JPRB, 0.79524564E-05_JPRB, 0.78755534E-05_JPRB, 0.77836798E-05_JPRB, 0.77023867E-05_JPRB, &
  & 0.76263427E-05_JPRB, 0.75308982E-05_JPRB, 0.73777134E-05_JPRB, 0.71740727E-05_JPRB, 0.69509515E-05_JPRB, 0.67184845E-05_JPRB, &
  & 0.65085970E-05_JPRB, 0.63164230E-05_JPRB, 0.60933102E-05_JPRB, 0.58287267E-05_JPRB, 0.55470586E-05_JPRB, 0.52528660E-05_JPRB, &
  & 0.49230659E-05_JPRB, 0.45966459E-05_JPRB, 0.42813813E-05_JPRB, 0.40103310E-05_JPRB, 0.37815411E-05_JPRB, 0.35624266E-05_JPRB, &
  & 0.33524135E-05_JPRB, 0.31187460E-05_JPRB, 0.29479855E-05_JPRB, 0.28391916E-05_JPRB  /)

RGHG7(:,23, 8) = (/ &
  & 0.33684658E-05_JPRB, 0.33411443E-05_JPRB, 0.32922425E-05_JPRB, 0.32237214E-05_JPRB, 0.31515182E-05_JPRB, 0.30954381E-05_JPRB, &
  & 0.30711394E-05_JPRB, 0.31147458E-05_JPRB, 0.32437493E-05_JPRB, 0.34587135E-05_JPRB, 0.37351438E-05_JPRB, 0.40477982E-05_JPRB, &
  & 0.43506268E-05_JPRB, 0.46362616E-05_JPRB, 0.49109349E-05_JPRB, 0.51782436E-05_JPRB, 0.53985042E-05_JPRB, 0.55314582E-05_JPRB, &
  & 0.56198166E-05_JPRB, 0.56789480E-05_JPRB, 0.57194257E-05_JPRB, 0.57458369E-05_JPRB, 0.57726328E-05_JPRB, 0.58241588E-05_JPRB, &
  & 0.58898152E-05_JPRB, 0.59785471E-05_JPRB, 0.60704393E-05_JPRB, 0.61746654E-05_JPRB, 0.63344017E-05_JPRB, 0.65356822E-05_JPRB, &
  & 0.67213092E-05_JPRB, 0.68546326E-05_JPRB, 0.69641463E-05_JPRB, 0.70334066E-05_JPRB, 0.70653041E-05_JPRB, 0.70859649E-05_JPRB, &
  & 0.71013484E-05_JPRB, 0.70782434E-05_JPRB, 0.70291724E-05_JPRB, 0.69668905E-05_JPRB, 0.69022818E-05_JPRB, 0.68576278E-05_JPRB, &
  & 0.68247571E-05_JPRB, 0.67721082E-05_JPRB, 0.66710438E-05_JPRB, 0.65214707E-05_JPRB, 0.63528453E-05_JPRB, 0.61844352E-05_JPRB, &
  & 0.60367583E-05_JPRB, 0.58913421E-05_JPRB, 0.56976159E-05_JPRB, 0.54553226E-05_JPRB, 0.51934356E-05_JPRB, 0.49176235E-05_JPRB, &
  & 0.45955733E-05_JPRB, 0.42740448E-05_JPRB, 0.39869325E-05_JPRB, 0.37487301E-05_JPRB, 0.35591079E-05_JPRB, 0.33807508E-05_JPRB, &
  & 0.32098079E-05_JPRB, 0.30216310E-05_JPRB, 0.28881127E-05_JPRB, 0.27822108E-05_JPRB  /)

RGHG7(:,24, 8) = (/ &
  & 0.31400983E-05_JPRB, 0.31123073E-05_JPRB, 0.30671050E-05_JPRB, 0.29993187E-05_JPRB, 0.29187746E-05_JPRB, 0.28481348E-05_JPRB, &
  & 0.28150330E-05_JPRB, 0.28687354E-05_JPRB, 0.30323810E-05_JPRB, 0.33019496E-05_JPRB, 0.36338082E-05_JPRB, 0.39749825E-05_JPRB, &
  & 0.42741818E-05_JPRB, 0.45243246E-05_JPRB, 0.47444660E-05_JPRB, 0.49511739E-05_JPRB, 0.51291881E-05_JPRB, 0.52380085E-05_JPRB, &
  & 0.53066933E-05_JPRB, 0.53461992E-05_JPRB, 0.53680291E-05_JPRB, 0.53785151E-05_JPRB, 0.53863394E-05_JPRB, 0.54089681E-05_JPRB, &
  & 0.54354044E-05_JPRB, 0.54737231E-05_JPRB, 0.55086723E-05_JPRB, 0.55562837E-05_JPRB, 0.56427001E-05_JPRB, 0.57491561E-05_JPRB, &
  & 0.58521989E-05_JPRB, 0.59601133E-05_JPRB, 0.60627842E-05_JPRB, 0.61258325E-05_JPRB, 0.61519114E-05_JPRB, 0.61735063E-05_JPRB, &
  & 0.61744184E-05_JPRB, 0.61290323E-05_JPRB, 0.60700376E-05_JPRB, 0.60194411E-05_JPRB, 0.59808559E-05_JPRB, 0.59671121E-05_JPRB, &
  & 0.59700650E-05_JPRB, 0.59556818E-05_JPRB, 0.59049320E-05_JPRB, 0.58105657E-05_JPRB, 0.56982801E-05_JPRB, 0.55951954E-05_JPRB, &
  & 0.55070968E-05_JPRB, 0.54029392E-05_JPRB, 0.52400635E-05_JPRB, 0.50288187E-05_JPRB, 0.47975208E-05_JPRB, 0.45507020E-05_JPRB, &
  & 0.42549295E-05_JPRB, 0.39551357E-05_JPRB, 0.37024495E-05_JPRB, 0.34992132E-05_JPRB, 0.33488588E-05_JPRB, 0.32081207E-05_JPRB, &
  & 0.30708323E-05_JPRB, 0.29283954E-05_JPRB, 0.28382267E-05_JPRB, 0.27425668E-05_JPRB  /)

RGHG7(:,25, 8) = (/ &
  & 0.29397406E-05_JPRB, 0.29186406E-05_JPRB, 0.28810300E-05_JPRB, 0.28209641E-05_JPRB, 0.27371603E-05_JPRB, 0.26506507E-05_JPRB, &
  & 0.25996634E-05_JPRB, 0.26493339E-05_JPRB, 0.28283775E-05_JPRB, 0.31311439E-05_JPRB, 0.35026339E-05_JPRB, 0.38646533E-05_JPRB, &
  & 0.41534730E-05_JPRB, 0.43596524E-05_JPRB, 0.45203036E-05_JPRB, 0.46628893E-05_JPRB, 0.47893912E-05_JPRB, 0.48715333E-05_JPRB, &
  & 0.49240910E-05_JPRB, 0.49496144E-05_JPRB, 0.49549741E-05_JPRB, 0.49479605E-05_JPRB, 0.49367411E-05_JPRB, 0.49283166E-05_JPRB, &
  & 0.49150357E-05_JPRB, 0.49056594E-05_JPRB, 0.48894394E-05_JPRB, 0.48866966E-05_JPRB, 0.49066746E-05_JPRB, 0.49403871E-05_JPRB, &
  & 0.50015681E-05_JPRB, 0.51009043E-05_JPRB, 0.51907937E-05_JPRB, 0.52389159E-05_JPRB, 0.52557302E-05_JPRB, 0.52748803E-05_JPRB, &
  & 0.52605661E-05_JPRB, 0.51927479E-05_JPRB, 0.51218294E-05_JPRB, 0.50787818E-05_JPRB, 0.50616422E-05_JPRB, 0.50673709E-05_JPRB, &
  & 0.50936138E-05_JPRB, 0.51093401E-05_JPRB, 0.51019105E-05_JPRB, 0.50589707E-05_JPRB, 0.49999130E-05_JPRB, 0.49557178E-05_JPRB, &
  & 0.49151856E-05_JPRB, 0.48389931E-05_JPRB, 0.47060554E-05_JPRB, 0.45355143E-05_JPRB, 0.43468074E-05_JPRB, 0.41412070E-05_JPRB, &
  & 0.38984908E-05_JPRB, 0.36466922E-05_JPRB, 0.34352245E-05_JPRB, 0.32676736E-05_JPRB, 0.31558784E-05_JPRB, 0.30473516E-05_JPRB, &
  & 0.29333959E-05_JPRB, 0.28297755E-05_JPRB, 0.27843852E-05_JPRB, 0.27069111E-05_JPRB  /)

RGHG7(:,26, 8) = (/ &
  & 0.27805760E-05_JPRB, 0.27687722E-05_JPRB, 0.27390264E-05_JPRB, 0.26912670E-05_JPRB, 0.26138858E-05_JPRB, 0.25231085E-05_JPRB, &
  & 0.24609680E-05_JPRB, 0.24961613E-05_JPRB, 0.26687530E-05_JPRB, 0.29692613E-05_JPRB, 0.33395983E-05_JPRB, 0.36945008E-05_JPRB, &
  & 0.39585491E-05_JPRB, 0.41160053E-05_JPRB, 0.42179348E-05_JPRB, 0.43031572E-05_JPRB, 0.43804431E-05_JPRB, 0.44326144E-05_JPRB, &
  & 0.44670480E-05_JPRB, 0.44759129E-05_JPRB, 0.44653756E-05_JPRB, 0.44416304E-05_JPRB, 0.44092628E-05_JPRB, 0.43717848E-05_JPRB, &
  & 0.43252466E-05_JPRB, 0.42765686E-05_JPRB, 0.42243899E-05_JPRB, 0.41893913E-05_JPRB, 0.41741601E-05_JPRB, 0.41834033E-05_JPRB, &
  & 0.42374960E-05_JPRB, 0.43295567E-05_JPRB, 0.44064786E-05_JPRB, 0.44484892E-05_JPRB, 0.44669188E-05_JPRB, 0.44855842E-05_JPRB, &
  & 0.44652493E-05_JPRB, 0.43897358E-05_JPRB, 0.43158511E-05_JPRB, 0.42781281E-05_JPRB, 0.42726075E-05_JPRB, 0.42903286E-05_JPRB, &
  & 0.43303828E-05_JPRB, 0.43679363E-05_JPRB, 0.43889287E-05_JPRB, 0.43824247E-05_JPRB, 0.43628882E-05_JPRB, 0.43563197E-05_JPRB, &
  & 0.43404894E-05_JPRB, 0.42839379E-05_JPRB, 0.41826862E-05_JPRB, 0.40539822E-05_JPRB, 0.39123252E-05_JPRB, 0.37570321E-05_JPRB, &
  & 0.35763548E-05_JPRB, 0.33839985E-05_JPRB, 0.32164381E-05_JPRB, 0.30835049E-05_JPRB, 0.30012165E-05_JPRB, 0.29172428E-05_JPRB, &
  & 0.28203450E-05_JPRB, 0.27419191E-05_JPRB, 0.27144116E-05_JPRB, 0.26442841E-05_JPRB  /)

RGHG7(:,27, 8) = (/ &
  & 0.26294401E-05_JPRB, 0.26283215E-05_JPRB, 0.26068998E-05_JPRB, 0.25737076E-05_JPRB, 0.25066314E-05_JPRB, 0.24156941E-05_JPRB, &
  & 0.23443891E-05_JPRB, 0.23605730E-05_JPRB, 0.25183174E-05_JPRB, 0.28033180E-05_JPRB, 0.31573270E-05_JPRB, 0.34944208E-05_JPRB, &
  & 0.37272337E-05_JPRB, 0.38319840E-05_JPRB, 0.38728034E-05_JPRB, 0.39005575E-05_JPRB, 0.39272386E-05_JPRB, 0.39468538E-05_JPRB, &
  & 0.39615977E-05_JPRB, 0.39520536E-05_JPRB, 0.39251082E-05_JPRB, 0.38841545E-05_JPRB, 0.38288957E-05_JPRB, 0.37617831E-05_JPRB, &
  & 0.36828689E-05_JPRB, 0.35962123E-05_JPRB, 0.35120778E-05_JPRB, 0.34500660E-05_JPRB, 0.34096024E-05_JPRB, 0.34111617E-05_JPRB, &
  & 0.34707371E-05_JPRB, 0.35556744E-05_JPRB, 0.36189696E-05_JPRB, 0.36578586E-05_JPRB, 0.36820110E-05_JPRB, 0.37008965E-05_JPRB, &
  & 0.36776802E-05_JPRB, 0.35995855E-05_JPRB, 0.35259208E-05_JPRB, 0.34929402E-05_JPRB, 0.34959237E-05_JPRB, 0.35234097E-05_JPRB, &
  & 0.35743892E-05_JPRB, 0.36316924E-05_JPRB, 0.36768768E-05_JPRB, 0.37029088E-05_JPRB, 0.37196101E-05_JPRB, 0.37444971E-05_JPRB, &
  & 0.37460154E-05_JPRB, 0.37069124E-05_JPRB, 0.36394374E-05_JPRB, 0.35548951E-05_JPRB, 0.34640830E-05_JPRB, 0.33647576E-05_JPRB, &
  & 0.32522738E-05_JPRB, 0.31263101E-05_JPRB, 0.30056528E-05_JPRB, 0.29085172E-05_JPRB, 0.28537224E-05_JPRB, 0.27925799E-05_JPRB, &
  & 0.27111897E-05_JPRB, 0.26540543E-05_JPRB, 0.26352711E-05_JPRB, 0.25688054E-05_JPRB  /)

RGHG7(:,28, 8) = (/ &
  & 0.25767655E-05_JPRB, 0.25736351E-05_JPRB, 0.25523332E-05_JPRB, 0.25243781E-05_JPRB, 0.24645461E-05_JPRB, 0.23778022E-05_JPRB, &
  & 0.23026426E-05_JPRB, 0.22946821E-05_JPRB, 0.24179297E-05_JPRB, 0.26604480E-05_JPRB, 0.29629122E-05_JPRB, 0.32553335E-05_JPRB, &
  & 0.34489716E-05_JPRB, 0.35123171E-05_JPRB, 0.35111937E-05_JPRB, 0.34983684E-05_JPRB, 0.34915705E-05_JPRB, 0.34866581E-05_JPRB, &
  & 0.34819865E-05_JPRB, 0.34575010E-05_JPRB, 0.34140579E-05_JPRB, 0.33547990E-05_JPRB, 0.32819825E-05_JPRB, 0.31980597E-05_JPRB, &
  & 0.31019869E-05_JPRB, 0.29924403E-05_JPRB, 0.28944588E-05_JPRB, 0.28339745E-05_JPRB, 0.28023460E-05_JPRB, 0.28162025E-05_JPRB, &
  & 0.28852643E-05_JPRB, 0.29697555E-05_JPRB, 0.30317597E-05_JPRB, 0.30731654E-05_JPRB, 0.30999082E-05_JPRB, 0.31178147E-05_JPRB, &
  & 0.30953317E-05_JPRB, 0.30290209E-05_JPRB, 0.29664120E-05_JPRB, 0.29414445E-05_JPRB, 0.29526057E-05_JPRB, 0.29887753E-05_JPRB, &
  & 0.30490818E-05_JPRB, 0.31158430E-05_JPRB, 0.31697636E-05_JPRB, 0.32074495E-05_JPRB, 0.32428805E-05_JPRB, 0.32795283E-05_JPRB, &
  & 0.32925017E-05_JPRB, 0.32779383E-05_JPRB, 0.32448992E-05_JPRB, 0.32005046E-05_JPRB, 0.31516384E-05_JPRB, 0.30940286E-05_JPRB, &
  & 0.30239487E-05_JPRB, 0.29427332E-05_JPRB, 0.28659750E-05_JPRB, 0.28003502E-05_JPRB, 0.27598329E-05_JPRB, 0.27150339E-05_JPRB, &
  & 0.26506787E-05_JPRB, 0.26051700E-05_JPRB, 0.25872112E-05_JPRB, 0.25312974E-05_JPRB  /)

RGHG7(:,29, 8) = (/ &
  & 0.25252214E-05_JPRB, 0.25194089E-05_JPRB, 0.24978781E-05_JPRB, 0.24750677E-05_JPRB, 0.24227788E-05_JPRB, 0.23406669E-05_JPRB, &
  & 0.22616535E-05_JPRB, 0.22278871E-05_JPRB, 0.23137305E-05_JPRB, 0.25100658E-05_JPRB, 0.27563872E-05_JPRB, 0.30003093E-05_JPRB, &
  & 0.31520944E-05_JPRB, 0.31720579E-05_JPRB, 0.31273238E-05_JPRB, 0.30722334E-05_JPRB, 0.30307044E-05_JPRB, 0.30001510E-05_JPRB, &
  & 0.29749190E-05_JPRB, 0.29347524E-05_JPRB, 0.28738247E-05_JPRB, 0.27951221E-05_JPRB, 0.27039331E-05_JPRB, 0.26027546E-05_JPRB, &
  & 0.24891607E-05_JPRB, 0.23560144E-05_JPRB, 0.22441460E-05_JPRB, 0.21865178E-05_JPRB, 0.21657279E-05_JPRB, 0.21934805E-05_JPRB, &
  & 0.22727676E-05_JPRB, 0.23570757E-05_JPRB, 0.24182469E-05_JPRB, 0.24625636E-05_JPRB, 0.24919154E-05_JPRB, 0.25087325E-05_JPRB, &
  & 0.24871832E-05_JPRB, 0.24339812E-05_JPRB, 0.23835566E-05_JPRB, 0.23672216E-05_JPRB, 0.23870335E-05_JPRB, 0.24323574E-05_JPRB, &
  & 0.25024772E-05_JPRB, 0.25788137E-05_JPRB, 0.26413210E-05_JPRB, 0.26904496E-05_JPRB, 0.27449672E-05_JPRB, 0.27932226E-05_JPRB, &
  & 0.28180782E-05_JPRB, 0.28298241E-05_JPRB, 0.28333011E-05_JPRB, 0.28312723E-05_JPRB, 0.28264654E-05_JPRB, 0.28124389E-05_JPRB, &
  & 0.27861711E-05_JPRB, 0.27514316E-05_JPRB, 0.27210579E-05_JPRB, 0.26886354E-05_JPRB, 0.26626733E-05_JPRB, 0.26349104E-05_JPRB, &
  & 0.25886714E-05_JPRB, 0.25550632E-05_JPRB, 0.25376354E-05_JPRB, 0.24932009E-05_JPRB  /)

RGHG7(:,30, 8) = (/ &
  & 0.23537246E-05_JPRB, 0.23570693E-05_JPRB, 0.23446819E-05_JPRB, 0.23337941E-05_JPRB, 0.23005872E-05_JPRB, 0.22361233E-05_JPRB, &
  & 0.21704639E-05_JPRB, 0.21348006E-05_JPRB, 0.21940401E-05_JPRB, 0.23509208E-05_JPRB, 0.25485948E-05_JPRB, 0.27446726E-05_JPRB, &
  & 0.28643170E-05_JPRB, 0.28629869E-05_JPRB, 0.27959537E-05_JPRB, 0.27187665E-05_JPRB, 0.26559919E-05_JPRB, 0.26080048E-05_JPRB, &
  & 0.25685203E-05_JPRB, 0.25157862E-05_JPRB, 0.24410752E-05_JPRB, 0.23488127E-05_JPRB, 0.22427217E-05_JPRB, 0.21338960E-05_JPRB, &
  & 0.20155576E-05_JPRB, 0.18896761E-05_JPRB, 0.17907022E-05_JPRB, 0.17462974E-05_JPRB, 0.17392367E-05_JPRB, 0.17726149E-05_JPRB, &
  & 0.18475767E-05_JPRB, 0.19266896E-05_JPRB, 0.19825766E-05_JPRB, 0.20221190E-05_JPRB, 0.20458519E-05_JPRB, 0.20574168E-05_JPRB, &
  & 0.20413046E-05_JPRB, 0.20043107E-05_JPRB, 0.19713880E-05_JPRB, 0.19647512E-05_JPRB, 0.19918809E-05_JPRB, 0.20430836E-05_JPRB, &
  & 0.21159464E-05_JPRB, 0.21911979E-05_JPRB, 0.22519116E-05_JPRB, 0.23050553E-05_JPRB, 0.23679134E-05_JPRB, 0.24253629E-05_JPRB, &
  & 0.24681625E-05_JPRB, 0.25042345E-05_JPRB, 0.25342101E-05_JPRB, 0.25571009E-05_JPRB, 0.25727358E-05_JPRB, 0.25794562E-05_JPRB, &
  & 0.25734611E-05_JPRB, 0.25611439E-05_JPRB, 0.25509406E-05_JPRB, 0.25369076E-05_JPRB, 0.25243885E-05_JPRB, 0.25093872E-05_JPRB, &
  & 0.24796100E-05_JPRB, 0.24559844E-05_JPRB, 0.24454730E-05_JPRB, 0.24174221E-05_JPRB  /)

RGHG7(:,31, 8) = (/ &
  & 0.21729126E-05_JPRB, 0.21859171E-05_JPRB, 0.21831724E-05_JPRB, 0.21848534E-05_JPRB, 0.21717633E-05_JPRB, 0.21259066E-05_JPRB, &
  & 0.20743340E-05_JPRB, 0.20366946E-05_JPRB, 0.20679131E-05_JPRB, 0.21832287E-05_JPRB, 0.23296524E-05_JPRB, 0.24753195E-05_JPRB, &
  & 0.25611079E-05_JPRB, 0.25373627E-05_JPRB, 0.24468543E-05_JPRB, 0.23464039E-05_JPRB, 0.22612565E-05_JPRB, 0.21949083E-05_JPRB, &
  & 0.21404125E-05_JPRB, 0.20744397E-05_JPRB, 0.19852092E-05_JPRB, 0.18786648E-05_JPRB, 0.17568756E-05_JPRB, 0.16400015E-05_JPRB, &
  & 0.15166764E-05_JPRB, 0.13984785E-05_JPRB, 0.13131166E-05_JPRB, 0.12826545E-05_JPRB, 0.12900622E-05_JPRB, 0.13293601E-05_JPRB, &
  & 0.13997506E-05_JPRB, 0.14733849E-05_JPRB, 0.15236999E-05_JPRB, 0.15582047E-05_JPRB, 0.15760094E-05_JPRB, 0.15820362E-05_JPRB, &
  & 0.15716571E-05_JPRB, 0.15517438E-05_JPRB, 0.15372672E-05_JPRB, 0.15408499E-05_JPRB, 0.15756888E-05_JPRB, 0.16330826E-05_JPRB, &
  & 0.17088289E-05_JPRB, 0.17829270E-05_JPRB, 0.18417409E-05_JPRB, 0.18991082E-05_JPRB, 0.19707440E-05_JPRB, 0.20378788E-05_JPRB, &
  & 0.20995909E-05_JPRB, 0.21612923E-05_JPRB, 0.22191787E-05_JPRB, 0.22683094E-05_JPRB, 0.23054605E-05_JPRB, 0.23340194E-05_JPRB, &
  & 0.23493623E-05_JPRB, 0.23606476E-05_JPRB, 0.23716721E-05_JPRB, 0.23770010E-05_JPRB, 0.23786451E-05_JPRB, 0.23770861E-05_JPRB, &
  & 0.23646524E-05_JPRB, 0.23515432E-05_JPRB, 0.23483254E-05_JPRB, 0.23375417E-05_JPRB  /)

RGHG7(:,32, 8) = (/ &
  & 0.19800020E-05_JPRB, 0.19955376E-05_JPRB, 0.19974522E-05_JPRB, 0.20044580E-05_JPRB, 0.20029358E-05_JPRB, 0.19751292E-05_JPRB, &
  & 0.19366275E-05_JPRB, 0.19070026E-05_JPRB, 0.19251768E-05_JPRB, 0.20138229E-05_JPRB, 0.21273838E-05_JPRB, 0.22381239E-05_JPRB, &
  & 0.23028758E-05_JPRB, 0.22732885E-05_JPRB, 0.21775306E-05_JPRB, 0.20706253E-05_JPRB, 0.19737421E-05_JPRB, 0.18973585E-05_JPRB, &
  & 0.18326523E-05_JPRB, 0.17572253E-05_JPRB, 0.16611432E-05_JPRB, 0.15500674E-05_JPRB, 0.14272218E-05_JPRB, 0.13125419E-05_JPRB, &
  & 0.11974029E-05_JPRB, 0.10944613E-05_JPRB, 0.10228004E-05_JPRB, 0.99863439E-06_JPRB, 0.10084778E-05_JPRB, 0.10441442E-05_JPRB, &
  & 0.11032553E-05_JPRB, 0.11647996E-05_JPRB, 0.12079570E-05_JPRB, 0.12366060E-05_JPRB, 0.12514601E-05_JPRB, 0.12568597E-05_JPRB, &
  & 0.12527412E-05_JPRB, 0.12455751E-05_JPRB, 0.12426315E-05_JPRB, 0.12524392E-05_JPRB, 0.12886374E-05_JPRB, 0.13441091E-05_JPRB, &
  & 0.14137028E-05_JPRB, 0.14810646E-05_JPRB, 0.15394632E-05_JPRB, 0.16011079E-05_JPRB, 0.16754911E-05_JPRB, 0.17504440E-05_JPRB, &
  & 0.18253383E-05_JPRB, 0.19010343E-05_JPRB, 0.19721985E-05_JPRB, 0.20341217E-05_JPRB, 0.20821901E-05_JPRB, 0.21202274E-05_JPRB, &
  & 0.21458808E-05_JPRB, 0.21669491E-05_JPRB, 0.21853636E-05_JPRB, 0.21986131E-05_JPRB, 0.22101005E-05_JPRB, 0.22197660E-05_JPRB, &
  & 0.22236041E-05_JPRB, 0.22261741E-05_JPRB, 0.22356843E-05_JPRB, 0.22368082E-05_JPRB  /)

RGHG7(:,33, 8) = (/ &
  & 0.17779539E-05_JPRB, 0.17951969E-05_JPRB, 0.18013084E-05_JPRB, 0.18129100E-05_JPRB, 0.18223029E-05_JPRB, 0.18131828E-05_JPRB, &
  & 0.17881335E-05_JPRB, 0.17681311E-05_JPRB, 0.17746880E-05_JPRB, 0.18375464E-05_JPRB, 0.19193356E-05_JPRB, 0.19957825E-05_JPRB, &
  & 0.20403319E-05_JPRB, 0.20068190E-05_JPRB, 0.19079654E-05_JPRB, 0.17965281E-05_JPRB, 0.16888255E-05_JPRB, 0.16030906E-05_JPRB, &
  & 0.15283949E-05_JPRB, 0.14436327E-05_JPRB, 0.13414229E-05_JPRB, 0.12269002E-05_JPRB, 0.11048525E-05_JPRB, 0.99377897E-06_JPRB, &
  & 0.88885294E-06_JPRB, 0.80274668E-06_JPRB, 0.74533602E-06_JPRB, 0.72672334E-06_JPRB, 0.73754020E-06_JPRB, 0.76819585E-06_JPRB, &
  & 0.81471630E-06_JPRB, 0.86284016E-06_JPRB, 0.89835383E-06_JPRB, 0.92081118E-06_JPRB, 0.93298438E-06_JPRB, 0.93836809E-06_JPRB, &
  & 0.94082416E-06_JPRB, 0.94634441E-06_JPRB, 0.95449142E-06_JPRB, 0.97025142E-06_JPRB, 0.10070400E-05_JPRB, 0.10594638E-05_JPRB, &
  & 0.11214936E-05_JPRB, 0.11811318E-05_JPRB, 0.12392911E-05_JPRB, 0.13053879E-05_JPRB, 0.13818457E-05_JPRB, 0.14646816E-05_JPRB, &
  & 0.15525336E-05_JPRB, 0.16412670E-05_JPRB, 0.17243357E-05_JPRB, 0.17978123E-05_JPRB, 0.18558543E-05_JPRB, 0.19021417E-05_JPRB, &
  & 0.19370825E-05_JPRB, 0.19665286E-05_JPRB, 0.19908315E-05_JPRB, 0.20108311E-05_JPRB, 0.20319889E-05_JPRB, 0.20530322E-05_JPRB, &
  & 0.20736419E-05_JPRB, 0.20931750E-05_JPRB, 0.21166162E-05_JPRB, 0.21294212E-05_JPRB  /)

RGHG7(:,34, 8) = (/ &
  & 0.15938780E-05_JPRB, 0.16095566E-05_JPRB, 0.16140486E-05_JPRB, 0.16235679E-05_JPRB, 0.16376035E-05_JPRB, 0.16447639E-05_JPRB, &
  & 0.16346463E-05_JPRB, 0.16244768E-05_JPRB, 0.16276944E-05_JPRB, 0.16742427E-05_JPRB, 0.17363076E-05_JPRB, 0.17911820E-05_JPRB, &
  & 0.18208582E-05_JPRB, 0.17863938E-05_JPRB, 0.16912460E-05_JPRB, 0.15807018E-05_JPRB, 0.14711264E-05_JPRB, 0.13803663E-05_JPRB, &
  & 0.12984537E-05_JPRB, 0.12066155E-05_JPRB, 0.11008860E-05_JPRB, 0.98698356E-06_JPRB, 0.87101405E-06_JPRB, 0.76824124E-06_JPRB, &
  & 0.67781214E-06_JPRB, 0.60720671E-06_JPRB, 0.55989182E-06_JPRB, 0.54350270E-06_JPRB, 0.55285665E-06_JPRB, 0.57850064E-06_JPRB, &
  & 0.61470925E-06_JPRB, 0.65160129E-06_JPRB, 0.67941086E-06_JPRB, 0.69687653E-06_JPRB, 0.70720602E-06_JPRB, 0.71361242E-06_JPRB, &
  & 0.72056320E-06_JPRB, 0.73287238E-06_JPRB, 0.74701762E-06_JPRB, 0.76538381E-06_JPRB, 0.79905436E-06_JPRB, 0.84482374E-06_JPRB, &
  & 0.89905111E-06_JPRB, 0.95264958E-06_JPRB, 0.10080583E-05_JPRB, 0.10742155E-05_JPRB, 0.11510276E-05_JPRB, 0.12358348E-05_JPRB, &
  & 0.13286253E-05_JPRB, 0.14236017E-05_JPRB, 0.15127282E-05_JPRB, 0.15925108E-05_JPRB, 0.16554490E-05_JPRB, 0.17053670E-05_JPRB, &
  & 0.17442069E-05_JPRB, 0.17769035E-05_JPRB, 0.18033205E-05_JPRB, 0.18260671E-05_JPRB, 0.18519816E-05_JPRB, 0.18808482E-05_JPRB, &
  & 0.19140744E-05_JPRB, 0.19491700E-05_JPRB, 0.19859153E-05_JPRB, 0.20081048E-05_JPRB  /)

RGHG7(:,35, 8) = (/ &
  & 0.14138462E-05_JPRB, 0.14262376E-05_JPRB, 0.14260800E-05_JPRB, 0.14300314E-05_JPRB, 0.14456219E-05_JPRB, 0.14682860E-05_JPRB, &
  & 0.14742794E-05_JPRB, 0.14743272E-05_JPRB, 0.14783593E-05_JPRB, 0.15130021E-05_JPRB, 0.15609700E-05_JPRB, 0.16001926E-05_JPRB, &
  & 0.16173117E-05_JPRB, 0.15833952E-05_JPRB, 0.14955476E-05_JPRB, 0.13887053E-05_JPRB, 0.12817954E-05_JPRB, 0.11880886E-05_JPRB, &
  & 0.11001788E-05_JPRB, 0.10022250E-05_JPRB, 0.89421509E-06_JPRB, 0.78303724E-06_JPRB, 0.67602646E-06_JPRB, 0.58419662E-06_JPRB, &
  & 0.51087054E-06_JPRB, 0.45551715E-06_JPRB, 0.41645020E-06_JPRB, 0.40063859E-06_JPRB, 0.40723829E-06_JPRB, 0.42772916E-06_JPRB, &
  & 0.45450520E-06_JPRB, 0.48097254E-06_JPRB, 0.50083032E-06_JPRB, 0.51377960E-06_JPRB, 0.52264313E-06_JPRB, 0.53063396E-06_JPRB, &
  & 0.54113861E-06_JPRB, 0.55740147E-06_JPRB, 0.57510060E-06_JPRB, 0.59442929E-06_JPRB, 0.62299114E-06_JPRB, 0.66006834E-06_JPRB, &
  & 0.70615141E-06_JPRB, 0.75440427E-06_JPRB, 0.80569641E-06_JPRB, 0.86966203E-06_JPRB, 0.94595593E-06_JPRB, 0.10297562E-05_JPRB, &
  & 0.11235092E-05_JPRB, 0.12214175E-05_JPRB, 0.13137721E-05_JPRB, 0.13973455E-05_JPRB, 0.14627122E-05_JPRB, 0.15139925E-05_JPRB, &
  & 0.15540763E-05_JPRB, 0.15874836E-05_JPRB, 0.16141376E-05_JPRB, 0.16376541E-05_JPRB, 0.16659380E-05_JPRB, 0.17010238E-05_JPRB, &
  & 0.17450893E-05_JPRB, 0.17954665E-05_JPRB, 0.18455686E-05_JPRB, 0.18762281E-05_JPRB  /)

RGHG7(:,36, 8) = (/ &
  & 0.12467168E-05_JPRB, 0.12552095E-05_JPRB, 0.12488280E-05_JPRB, 0.12481087E-05_JPRB, 0.12647941E-05_JPRB, 0.12984530E-05_JPRB, &
  & 0.13184996E-05_JPRB, 0.13286085E-05_JPRB, 0.13345388E-05_JPRB, 0.13594163E-05_JPRB, 0.13957121E-05_JPRB, 0.14222142E-05_JPRB, &
  & 0.14283524E-05_JPRB, 0.13945539E-05_JPRB, 0.13140454E-05_JPRB, 0.12114553E-05_JPRB, 0.11084512E-05_JPRB, 0.10137913E-05_JPRB, &
  & 0.92160412E-06_JPRB, 0.81953000E-06_JPRB, 0.71121343E-06_JPRB, 0.60399192E-06_JPRB, 0.50614467E-06_JPRB, 0.42540284E-06_JPRB, &
  & 0.36734197E-06_JPRB, 0.32557623E-06_JPRB, 0.29469869E-06_JPRB, 0.28004168E-06_JPRB, 0.28381920E-06_JPRB, 0.29898991E-06_JPRB, &
  & 0.31720126E-06_JPRB, 0.33464099E-06_JPRB, 0.34784398E-06_JPRB, 0.35713095E-06_JPRB, 0.36495829E-06_JPRB, 0.37409477E-06_JPRB, &
  & 0.38660118E-06_JPRB, 0.40450637E-06_JPRB, 0.42396605E-06_JPRB, 0.44400323E-06_JPRB, 0.46879976E-06_JPRB, 0.49908178E-06_JPRB, &
  & 0.53807725E-06_JPRB, 0.58079714E-06_JPRB, 0.62727203E-06_JPRB, 0.68775275E-06_JPRB, 0.76180007E-06_JPRB, 0.84310426E-06_JPRB, &
  & 0.93599166E-06_JPRB, 0.10346013E-05_JPRB, 0.11284092E-05_JPRB, 0.12138097E-05_JPRB, 0.12801636E-05_JPRB, 0.13317338E-05_JPRB, &
  & 0.13722222E-05_JPRB, 0.14057954E-05_JPRB, 0.14321944E-05_JPRB, 0.14554662E-05_JPRB, 0.14847587E-05_JPRB, 0.15248169E-05_JPRB, &
  & 0.15776627E-05_JPRB, 0.16404892E-05_JPRB, 0.17012004E-05_JPRB, 0.17391279E-05_JPRB  /)

RGHG7(:,37, 8) = (/ &
  & 0.11195667E-05_JPRB, 0.11230015E-05_JPRB, 0.11071743E-05_JPRB, 0.11041311E-05_JPRB, 0.11207893E-05_JPRB, 0.11544208E-05_JPRB, &
  & 0.11829290E-05_JPRB, 0.12021146E-05_JPRB, 0.12123098E-05_JPRB, 0.12329359E-05_JPRB, 0.12638459E-05_JPRB, 0.12851399E-05_JPRB, &
  & 0.12845935E-05_JPRB, 0.12499203E-05_JPRB, 0.11763833E-05_JPRB, 0.10790423E-05_JPRB, 0.98254501E-06_JPRB, 0.89156224E-06_JPRB, &
  & 0.79930672E-06_JPRB, 0.69794343E-06_JPRB, 0.59386447E-06_JPRB, 0.49317707E-06_JPRB, 0.40439282E-06_JPRB, 0.33438169E-06_JPRB, &
  & 0.28642273E-06_JPRB, 0.25358330E-06_JPRB, 0.23025143E-06_JPRB, 0.21800028E-06_JPRB, 0.21897552E-06_JPRB, 0.22877403E-06_JPRB, &
  & 0.24094338E-06_JPRB, 0.25312028E-06_JPRB, 0.26305622E-06_JPRB, 0.27086686E-06_JPRB, 0.27870787E-06_JPRB, 0.28791270E-06_JPRB, &
  & 0.29873774E-06_JPRB, 0.31288376E-06_JPRB, 0.32988290E-06_JPRB, 0.35000210E-06_JPRB, 0.37434753E-06_JPRB, 0.40260643E-06_JPRB, &
  & 0.43737797E-06_JPRB, 0.47447962E-06_JPRB, 0.51483048E-06_JPRB, 0.56907783E-06_JPRB, 0.63705580E-06_JPRB, 0.71260505E-06_JPRB, &
  & 0.80048935E-06_JPRB, 0.89464271E-06_JPRB, 0.98574395E-06_JPRB, 0.10683559E-05_JPRB, 0.11323312E-05_JPRB, 0.11817142E-05_JPRB, &
  & 0.12206580E-05_JPRB, 0.12531377E-05_JPRB, 0.12781696E-05_JPRB, 0.12988852E-05_JPRB, 0.13260042E-05_JPRB, 0.13678669E-05_JPRB, &
  & 0.14242257E-05_JPRB, 0.14922331E-05_JPRB, 0.15565940E-05_JPRB, 0.15985815E-05_JPRB  /)

RGHG7(:,38, 8) = (/ &
  & 0.97848230E-06_JPRB, 0.97630511E-06_JPRB, 0.94999699E-06_JPRB, 0.94437529E-06_JPRB, 0.96100311E-06_JPRB, 0.99460428E-06_JPRB, &
  & 0.10325013E-05_JPRB, 0.10617582E-05_JPRB, 0.10766858E-05_JPRB, 0.10925948E-05_JPRB, 0.11175287E-05_JPRB, 0.11330438E-05_JPRB, &
  & 0.11250804E-05_JPRB, 0.10894364E-05_JPRB, 0.10236350E-05_JPRB, 0.93211841E-06_JPRB, 0.84284092E-06_JPRB, 0.75593827E-06_JPRB, &
  & 0.66360691E-06_JPRB, 0.56303234E-06_JPRB, 0.46365538E-06_JPRB, 0.37021815E-06_JPRB, 0.29149011E-06_JPRB, 0.23338566E-06_JPRB, &
  & 0.19663565E-06_JPRB, 0.17370075E-06_JPRB, 0.15874147E-06_JPRB, 0.14915984E-06_JPRB, 0.14702570E-06_JPRB, 0.15086329E-06_JPRB, &
  & 0.15632850E-06_JPRB, 0.16266582E-06_JPRB, 0.16897667E-06_JPRB, 0.17514920E-06_JPRB, 0.18300538E-06_JPRB, 0.19228604E-06_JPRB, &
  & 0.20124545E-06_JPRB, 0.21122034E-06_JPRB, 0.22548929E-06_JPRB, 0.24569950E-06_JPRB, 0.26954439E-06_JPRB, 0.29555847E-06_JPRB, &
  & 0.32564317E-06_JPRB, 0.35651089E-06_JPRB, 0.39006661E-06_JPRB, 0.43739746E-06_JPRB, 0.49864097E-06_JPRB, 0.56780459E-06_JPRB, &
  & 0.65013750E-06_JPRB, 0.73934618E-06_JPRB, 0.82744421E-06_JPRB, 0.90696192E-06_JPRB, 0.96829809E-06_JPRB, 0.10152543E-05_JPRB, &
  & 0.10524840E-05_JPRB, 0.10837503E-05_JPRB, 0.11072655E-05_JPRB, 0.11251447E-05_JPRB, 0.11498520E-05_JPRB, 0.11937169E-05_JPRB, &
  & 0.12539738E-05_JPRB, 0.13277297E-05_JPRB, 0.13961405E-05_JPRB, 0.14426328E-05_JPRB  /)

RGHG7(:,39, 8) = (/ &
  & 0.88433848E-06_JPRB, 0.88056918E-06_JPRB, 0.85579339E-06_JPRB, 0.85079443E-06_JPRB, 0.86660033E-06_JPRB, 0.89492305E-06_JPRB, &
  & 0.93144321E-06_JPRB, 0.96419610E-06_JPRB, 0.98321548E-06_JPRB, 0.99884739E-06_JPRB, 0.10206173E-05_JPRB, 0.10343562E-05_JPRB, &
  & 0.10246835E-05_JPRB, 0.98910620E-06_JPRB, 0.92767679E-06_JPRB, 0.84260032E-06_JPRB, 0.75872814E-06_JPRB, 0.67608846E-06_JPRB, &
  & 0.58701521E-06_JPRB, 0.49059547E-06_JPRB, 0.39710124E-06_JPRB, 0.31184950E-06_JPRB, 0.24247938E-06_JPRB, 0.19286284E-06_JPRB, &
  & 0.16227349E-06_JPRB, 0.14373050E-06_JPRB, 0.13182475E-06_JPRB, 0.12372614E-06_JPRB, 0.12079155E-06_JPRB, 0.12243797E-06_JPRB, &
  & 0.12546288E-06_JPRB, 0.12966751E-06_JPRB, 0.13440026E-06_JPRB, 0.13877958E-06_JPRB, 0.14434662E-06_JPRB, 0.15125830E-06_JPRB, &
  & 0.15836394E-06_JPRB, 0.16718484E-06_JPRB, 0.18089066E-06_JPRB, 0.20063744E-06_JPRB, 0.22304650E-06_JPRB, 0.24680585E-06_JPRB, &
  & 0.27332794E-06_JPRB, 0.29973463E-06_JPRB, 0.32911522E-06_JPRB, 0.37034695E-06_JPRB, 0.42575905E-06_JPRB, 0.48985944E-06_JPRB, &
  & 0.56740028E-06_JPRB, 0.65110017E-06_JPRB, 0.73413423E-06_JPRB, 0.80894230E-06_JPRB, 0.86548814E-06_JPRB, 0.90748906E-06_JPRB, &
  & 0.94155266E-06_JPRB, 0.97046676E-06_JPRB, 0.99239998E-06_JPRB, 0.10087539E-05_JPRB, 0.10313334E-05_JPRB, 0.10727213E-05_JPRB, &
  & 0.11304987E-05_JPRB, 0.12021269E-05_JPRB, 0.12685294E-05_JPRB, 0.13150874E-05_JPRB  /)

RGHG7(:,40, 8) = (/ &
  & 0.78153238E-06_JPRB, 0.77655227E-06_JPRB, 0.75554019E-06_JPRB, 0.75179579E-06_JPRB, 0.76650759E-06_JPRB, 0.78777702E-06_JPRB, &
  & 0.82092005E-06_JPRB, 0.85669995E-06_JPRB, 0.88041666E-06_JPRB, 0.89644974E-06_JPRB, 0.91496655E-06_JPRB, 0.92727583E-06_JPRB, &
  & 0.91653091E-06_JPRB, 0.88120158E-06_JPRB, 0.82435281E-06_JPRB, 0.74693504E-06_JPRB, 0.66910958E-06_JPRB, 0.59150276E-06_JPRB, &
  & 0.50679862E-06_JPRB, 0.41580561E-06_JPRB, 0.32940845E-06_JPRB, 0.25391608E-06_JPRB, 0.19541402E-06_JPRB, 0.15519945E-06_JPRB, &
  & 0.13101423E-06_JPRB, 0.11672364E-06_JPRB, 0.10753126E-06_JPRB, 0.10097897E-06_JPRB, 0.97482749E-07_JPRB, 0.97174376E-07_JPRB, &
  & 0.98032971E-07_JPRB, 0.10034116E-06_JPRB, 0.10355675E-06_JPRB, 0.10580623E-06_JPRB, 0.10830979E-06_JPRB, 0.11204128E-06_JPRB, &
  & 0.11697331E-06_JPRB, 0.12493352E-06_JPRB, 0.13833299E-06_JPRB, 0.15744519E-06_JPRB, 0.17801616E-06_JPRB, 0.19912780E-06_JPRB, &
  & 0.22165277E-06_JPRB, 0.24311413E-06_JPRB, 0.26802350E-06_JPRB, 0.30223110E-06_JPRB, 0.35094731E-06_JPRB, 0.40932191E-06_JPRB, &
  & 0.48136307E-06_JPRB, 0.55850566E-06_JPRB, 0.63525959E-06_JPRB, 0.70427622E-06_JPRB, 0.75484828E-06_JPRB, 0.79062012E-06_JPRB, &
  & 0.82073037E-06_JPRB, 0.84669770E-06_JPRB, 0.86676365E-06_JPRB, 0.88154207E-06_JPRB, 0.90167079E-06_JPRB, 0.93941894E-06_JPRB, &
  & 0.99324299E-06_JPRB, 0.10610856E-05_JPRB, 0.11241402E-05_JPRB, 0.11700490E-05_JPRB  /)

RGHG7(:,41, 8) = (/ &
  & 0.65583701E-06_JPRB, 0.64937652E-06_JPRB, 0.63296611E-06_JPRB, 0.63075561E-06_JPRB, 0.64412971E-06_JPRB, 0.65677546E-06_JPRB, &
  & 0.68578947E-06_JPRB, 0.72527033E-06_JPRB, 0.75473022E-06_JPRB, 0.77125379E-06_JPRB, 0.78579318E-06_JPRB, 0.79635453E-06_JPRB, &
  & 0.78429868E-06_JPRB, 0.74927256E-06_JPRB, 0.69802427E-06_JPRB, 0.62997037E-06_JPRB, 0.55953791E-06_JPRB, 0.48808449E-06_JPRB, &
  & 0.40872221E-06_JPRB, 0.32436418E-06_JPRB, 0.24664420E-06_JPRB, 0.18308408E-06_JPRB, 0.13786980E-06_JPRB, 0.10915049E-06_JPRB, &
  & 0.92795248E-07_JPRB, 0.83703841E-07_JPRB, 0.77828943E-07_JPRB, 0.73167268E-07_JPRB, 0.68984360E-07_JPRB, 0.66285970E-07_JPRB, &
  & 0.64495928E-07_JPRB, 0.64485444E-07_JPRB, 0.65846100E-07_JPRB, 0.65491526E-07_JPRB, 0.64249542E-07_JPRB, 0.64092798E-07_JPRB, &
  & 0.66367267E-07_JPRB, 0.73275161E-07_JPRB, 0.86300074E-07_JPRB, 0.10463641E-06_JPRB, 0.12296005E-06_JPRB, 0.14083446E-06_JPRB, &
  & 0.15847239E-06_JPRB, 0.17388736E-06_JPRB, 0.19333002E-06_JPRB, 0.21894961E-06_JPRB, 0.25947913E-06_JPRB, 0.31085312E-06_JPRB, &
  & 0.37617013E-06_JPRB, 0.44529546E-06_JPRB, 0.51437101E-06_JPRB, 0.57630678E-06_JPRB, 0.61957501E-06_JPRB, 0.64773091E-06_JPRB, &
  & 0.67300762E-06_JPRB, 0.69537209E-06_JPRB, 0.71315504E-06_JPRB, 0.72600718E-06_JPRB, 0.74313946E-06_JPRB, 0.77643753E-06_JPRB, &
  & 0.82542805E-06_JPRB, 0.88864227E-06_JPRB, 0.94760348E-06_JPRB, 0.99271858E-06_JPRB  /)

RGHG7(:,42, 8) = (/ &
  & 0.62020838E-06_JPRB, 0.61472543E-06_JPRB, 0.60256681E-06_JPRB, 0.60186999E-06_JPRB, 0.61293408E-06_JPRB, 0.62628060E-06_JPRB, &
  & 0.65023184E-06_JPRB, 0.68216366E-06_JPRB, 0.71122987E-06_JPRB, 0.73054964E-06_JPRB, 0.74592292E-06_JPRB, 0.75665271E-06_JPRB, &
  & 0.74881120E-06_JPRB, 0.71802904E-06_JPRB, 0.67085091E-06_JPRB, 0.60863134E-06_JPRB, 0.54245559E-06_JPRB, 0.47383785E-06_JPRB, &
  & 0.39770349E-06_JPRB, 0.31721714E-06_JPRB, 0.24358231E-06_JPRB, 0.18390325E-06_JPRB, 0.14157423E-06_JPRB, 0.11369280E-06_JPRB, &
  & 0.97174893E-07_JPRB, 0.87406360E-07_JPRB, 0.80738745E-07_JPRB, 0.75870284E-07_JPRB, 0.72387136E-07_JPRB, 0.70449150E-07_JPRB, &
  & 0.69435383E-07_JPRB, 0.69611740E-07_JPRB, 0.70265699E-07_JPRB, 0.69827563E-07_JPRB, 0.69213728E-07_JPRB, 0.69762047E-07_JPRB, &
  & 0.72788071E-07_JPRB, 0.79546102E-07_JPRB, 0.91860577E-07_JPRB, 0.10790163E-06_JPRB, 0.12448873E-06_JPRB, 0.14032197E-06_JPRB, &
  & 0.15632052E-06_JPRB, 0.17138509E-06_JPRB, 0.19037760E-06_JPRB, 0.21591946E-06_JPRB, 0.25292320E-06_JPRB, 0.30014473E-06_JPRB, &
  & 0.36352185E-06_JPRB, 0.43153868E-06_JPRB, 0.49774546E-06_JPRB, 0.55585586E-06_JPRB, 0.59622337E-06_JPRB, 0.62183780E-06_JPRB, &
  & 0.64324200E-06_JPRB, 0.66173223E-06_JPRB, 0.67658062E-06_JPRB, 0.68795945E-06_JPRB, 0.70237783E-06_JPRB, 0.73057167E-06_JPRB, &
  & 0.77275864E-06_JPRB, 0.82734676E-06_JPRB, 0.88082345E-06_JPRB, 0.92051816E-06_JPRB  /)

RGHG7(:,43, 8) = (/ &
  & 0.53363321E-06_JPRB, 0.52840536E-06_JPRB, 0.52210547E-06_JPRB, 0.52344951E-06_JPRB, 0.53183056E-06_JPRB, 0.54210697E-06_JPRB, &
  & 0.55966289E-06_JPRB, 0.58629899E-06_JPRB, 0.61747646E-06_JPRB, 0.63955845E-06_JPRB, 0.65398166E-06_JPRB, 0.66411326E-06_JPRB, &
  & 0.65955299E-06_JPRB, 0.63277340E-06_JPRB, 0.59171789E-06_JPRB, 0.53884939E-06_JPRB, 0.47973753E-06_JPRB, 0.41635392E-06_JPRB, &
  & 0.34546250E-06_JPRB, 0.27136268E-06_JPRB, 0.20518759E-06_JPRB, 0.15418224E-06_JPRB, 0.12020145E-06_JPRB, 0.98029190E-07_JPRB, &
  & 0.84730933E-07_JPRB, 0.76581023E-07_JPRB, 0.70617157E-07_JPRB, 0.66373274E-07_JPRB, 0.63233204E-07_JPRB, 0.60960938E-07_JPRB, &
  & 0.59516124E-07_JPRB, 0.58865575E-07_JPRB, 0.58076848E-07_JPRB, 0.56442337E-07_JPRB, 0.54790472E-07_JPRB, 0.54309558E-07_JPRB, &
  & 0.56878144E-07_JPRB, 0.63046785E-07_JPRB, 0.74551948E-07_JPRB, 0.88165066E-07_JPRB, 0.10220108E-06_JPRB, 0.11477947E-06_JPRB, &
  & 0.12718010E-06_JPRB, 0.13932411E-06_JPRB, 0.15555441E-06_JPRB, 0.17733121E-06_JPRB, 0.20759654E-06_JPRB, 0.24801810E-06_JPRB, &
  & 0.30673287E-06_JPRB, 0.37028969E-06_JPRB, 0.43057618E-06_JPRB, 0.48215051E-06_JPRB, 0.51672968E-06_JPRB, 0.53674930E-06_JPRB, &
  & 0.55254110E-06_JPRB, 0.56594674E-06_JPRB, 0.57713564E-06_JPRB, 0.58634164E-06_JPRB, 0.59699495E-06_JPRB, 0.61861753E-06_JPRB, &
  & 0.65251785E-06_JPRB, 0.69724469E-06_JPRB, 0.74395658E-06_JPRB, 0.77836438E-06_JPRB  /)

RGHG7(:,44, 8) = (/ &
  & 0.49227663E-06_JPRB, 0.48351200E-06_JPRB, 0.47789568E-06_JPRB, 0.48137373E-06_JPRB, 0.48839676E-06_JPRB, 0.49714972E-06_JPRB, &
  & 0.51272899E-06_JPRB, 0.53621691E-06_JPRB, 0.56498531E-06_JPRB, 0.58815509E-06_JPRB, 0.60377112E-06_JPRB, 0.61421917E-06_JPRB, &
  & 0.61226526E-06_JPRB, 0.59067556E-06_JPRB, 0.55574544E-06_JPRB, 0.50912149E-06_JPRB, 0.45463249E-06_JPRB, 0.39458955E-06_JPRB, &
  & 0.32642782E-06_JPRB, 0.25598030E-06_JPRB, 0.19367563E-06_JPRB, 0.14612942E-06_JPRB, 0.11431398E-06_JPRB, 0.93648922E-07_JPRB, &
  & 0.80951983E-07_JPRB, 0.73115017E-07_JPRB, 0.67436791E-07_JPRB, 0.63252424E-07_JPRB, 0.60021242E-07_JPRB, 0.57729235E-07_JPRB, &
  & 0.56294363E-07_JPRB, 0.55557493E-07_JPRB, 0.54671208E-07_JPRB, 0.53006530E-07_JPRB, 0.51280405E-07_JPRB, 0.50970530E-07_JPRB, &
  & 0.53714907E-07_JPRB, 0.59717828E-07_JPRB, 0.70536080E-07_JPRB, 0.83043255E-07_JPRB, 0.95687668E-07_JPRB, 0.10701697E-06_JPRB, &
  & 0.11803229E-06_JPRB, 0.12924247E-06_JPRB, 0.14440770E-06_JPRB, 0.16497308E-06_JPRB, 0.19188280E-06_JPRB, 0.22856532E-06_JPRB, &
  & 0.28273932E-06_JPRB, 0.34432450E-06_JPRB, 0.40277485E-06_JPRB, 0.45171752E-06_JPRB, 0.48480206E-06_JPRB, 0.50344578E-06_JPRB, &
  & 0.51716268E-06_JPRB, 0.52870765E-06_JPRB, 0.53848397E-06_JPRB, 0.54577143E-06_JPRB, 0.55373188E-06_JPRB, 0.57123011E-06_JPRB, &
  & 0.60057883E-06_JPRB, 0.63857971E-06_JPRB, 0.68051052E-06_JPRB, 0.71039381E-06_JPRB  /)

RGHG7(:,45, 8) = (/ &
  & 0.43425879E-06_JPRB, 0.42150002E-06_JPRB, 0.41740199E-06_JPRB, 0.42356723E-06_JPRB, 0.42870534E-06_JPRB, 0.43533615E-06_JPRB, &
  & 0.44785727E-06_JPRB, 0.46709225E-06_JPRB, 0.49338479E-06_JPRB, 0.51814188E-06_JPRB, 0.53499584E-06_JPRB, 0.54572856E-06_JPRB, &
  & 0.54715630E-06_JPRB, 0.53198052E-06_JPRB, 0.50479714E-06_JPRB, 0.46646341E-06_JPRB, 0.41812953E-06_JPRB, 0.36255089E-06_JPRB, &
  & 0.29815900E-06_JPRB, 0.23267612E-06_JPRB, 0.17571998E-06_JPRB, 0.13320743E-06_JPRB, 0.10491167E-06_JPRB, 0.86683637E-07_JPRB, &
  & 0.75077971E-07_JPRB, 0.67801737E-07_JPRB, 0.62537591E-07_JPRB, 0.58499877E-07_JPRB, 0.55208308E-07_JPRB, 0.52851601E-07_JPRB, &
  & 0.51373596E-07_JPRB, 0.50434000E-07_JPRB, 0.49254409E-07_JPRB, 0.47404257E-07_JPRB, 0.45462466E-07_JPRB, 0.45217291E-07_JPRB, &
  & 0.48104007E-07_JPRB, 0.53843815E-07_JPRB, 0.63777835E-07_JPRB, 0.74719271E-07_JPRB, 0.85457193E-07_JPRB, 0.94953331E-07_JPRB, &
  & 0.10393707E-06_JPRB, 0.11371523E-06_JPRB, 0.12731904E-06_JPRB, 0.14602968E-06_JPRB, 0.16826806E-06_JPRB, 0.19983498E-06_JPRB, &
  & 0.24825069E-06_JPRB, 0.30702788E-06_JPRB, 0.36264007E-06_JPRB, 0.40776113E-06_JPRB, 0.43841295E-06_JPRB, 0.45478354E-06_JPRB, &
  & 0.46542935E-06_JPRB, 0.47421380E-06_JPRB, 0.48191972E-06_JPRB, 0.48674858E-06_JPRB, 0.49116779E-06_JPRB, 0.50314064E-06_JPRB, &
  & 0.52626092E-06_JPRB, 0.55535909E-06_JPRB, 0.59099244E-06_JPRB, 0.61505704E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART16',0,ZHOOK_HANDLE)



RGHG7(:,46, 8) = (/ &
  & 0.38809021E-06_JPRB, 0.37510474E-06_JPRB, 0.37062999E-06_JPRB, 0.37664878E-06_JPRB, 0.38138612E-06_JPRB, 0.38691103E-06_JPRB, &
  & 0.39767666E-06_JPRB, 0.41490321E-06_JPRB, 0.43880114E-06_JPRB, 0.46356618E-06_JPRB, 0.48100674E-06_JPRB, 0.49222799E-06_JPRB, &
  & 0.49597467E-06_JPRB, 0.48562505E-06_JPRB, 0.46470249E-06_JPRB, 0.43298271E-06_JPRB, 0.39043202E-06_JPRB, 0.33918434E-06_JPRB, &
  & 0.27906307E-06_JPRB, 0.21805022E-06_JPRB, 0.16496216E-06_JPRB, 0.12535571E-06_JPRB, 0.98961445E-07_JPRB, 0.81995397E-07_JPRB, &
  & 0.71128087E-07_JPRB, 0.64242120E-07_JPRB, 0.59318525E-07_JPRB, 0.55481630E-07_JPRB, 0.52335506E-07_JPRB, 0.50019732E-07_JPRB, &
  & 0.48658207E-07_JPRB, 0.47663866E-07_JPRB, 0.46485577E-07_JPRB, 0.44624119E-07_JPRB, 0.42723283E-07_JPRB, 0.42641792E-07_JPRB, &
  & 0.45524081E-07_JPRB, 0.51036644E-07_JPRB, 0.60215279E-07_JPRB, 0.70138259E-07_JPRB, 0.79707301E-07_JPRB, 0.88133394E-07_JPRB, &
  & 0.96200738E-07_JPRB, 0.10482883E-06_JPRB, 0.11703076E-06_JPRB, 0.13370179E-06_JPRB, 0.15282562E-06_JPRB, 0.18033806E-06_JPRB, &
  & 0.22326455E-06_JPRB, 0.27743604E-06_JPRB, 0.33004359E-06_JPRB, 0.37303968E-06_JPRB, 0.40313530E-06_JPRB, 0.41962458E-06_JPRB, &
  & 0.42950147E-06_JPRB, 0.43741433E-06_JPRB, 0.44493167E-06_JPRB, 0.45009142E-06_JPRB, 0.45452626E-06_JPRB, 0.46445624E-06_JPRB, &
  & 0.48462526E-06_JPRB, 0.51008000E-06_JPRB, 0.54208150E-06_JPRB, 0.56388734E-06_JPRB  /)

RGHG7(:,47, 8) = (/ &
  & 0.33628858E-06_JPRB, 0.32379177E-06_JPRB, 0.31849537E-06_JPRB, 0.32377467E-06_JPRB, 0.32833902E-06_JPRB, 0.33276984E-06_JPRB, &
  & 0.34173647E-06_JPRB, 0.35705592E-06_JPRB, 0.37816022E-06_JPRB, 0.40261823E-06_JPRB, 0.42061665E-06_JPRB, 0.43245198E-06_JPRB, &
  & 0.43870686E-06_JPRB, 0.43370233E-06_JPRB, 0.41982870E-06_JPRB, 0.39553408E-06_JPRB, 0.35969502E-06_JPRB, 0.31350267E-06_JPRB, &
  & 0.25849296E-06_JPRB, 0.20262627E-06_JPRB, 0.15378054E-06_JPRB, 0.11715800E-06_JPRB, 0.92670836E-07_JPRB, 0.76950244E-07_JPRB, &
  & 0.66878641E-07_JPRB, 0.60416476E-07_JPRB, 0.55877760E-07_JPRB, 0.52287362E-07_JPRB, 0.49353139E-07_JPRB, 0.47106557E-07_JPRB, &
  & 0.45913688E-07_JPRB, 0.44884750E-07_JPRB, 0.43767004E-07_JPRB, 0.41927169E-07_JPRB, 0.40125796E-07_JPRB, 0.40256206E-07_JPRB, &
  & 0.43103899E-07_JPRB, 0.48356992E-07_JPRB, 0.56675051E-07_JPRB, 0.65512582E-07_JPRB, 0.73857791E-07_JPRB, 0.81181136E-07_JPRB, &
  & 0.88396554E-07_JPRB, 0.95731625E-07_JPRB, 0.10632052E-06_JPRB, 0.12056118E-06_JPRB, 0.13634217E-06_JPRB, 0.15930956E-06_JPRB, &
  & 0.19584876E-06_JPRB, 0.24425569E-06_JPRB, 0.29330418E-06_JPRB, 0.33414667E-06_JPRB, 0.36396553E-06_JPRB, 0.38107321E-06_JPRB, &
  & 0.39050900E-06_JPRB, 0.39777751E-06_JPRB, 0.40545053E-06_JPRB, 0.41155735E-06_JPRB, 0.41672302E-06_JPRB, 0.42495348E-06_JPRB, &
  & 0.44231589E-06_JPRB, 0.46454888E-06_JPRB, 0.49282267E-06_JPRB, 0.51269113E-06_JPRB  /)

RGHG7(:,48, 8) = (/ &
  & 0.29083878E-06_JPRB, 0.27893881E-06_JPRB, 0.27291740E-06_JPRB, 0.27712338E-06_JPRB, 0.28159192E-06_JPRB, 0.28508772E-06_JPRB, &
  & 0.29230897E-06_JPRB, 0.30581179E-06_JPRB, 0.32501191E-06_JPRB, 0.34824401E-06_JPRB, 0.36568026E-06_JPRB, 0.37747838E-06_JPRB, &
  & 0.38514806E-06_JPRB, 0.38362284E-06_JPRB, 0.37511671E-06_JPRB, 0.35665425E-06_JPRB, 0.32717842E-06_JPRB, 0.28692405E-06_JPRB, &
  & 0.23826931E-06_JPRB, 0.18836987E-06_JPRB, 0.14419125E-06_JPRB, 0.11040624E-06_JPRB, 0.87346445E-07_JPRB, 0.72641861E-07_JPRB, &
  & 0.63361599E-07_JPRB, 0.57394999E-07_JPRB, 0.53263806E-07_JPRB, 0.49978142E-07_JPRB, 0.47236295E-07_JPRB, 0.45140554E-07_JPRB, &
  & 0.44028028E-07_JPRB, 0.43011752E-07_JPRB, 0.41994026E-07_JPRB, 0.40211628E-07_JPRB, 0.38584113E-07_JPRB, 0.38884169E-07_JPRB, &
  & 0.41716110E-07_JPRB, 0.46737408E-07_JPRB, 0.54319122E-07_JPRB, 0.62394634E-07_JPRB, 0.69906291E-07_JPRB, 0.76459742E-07_JPRB, &
  & 0.82910076E-07_JPRB, 0.89272121E-07_JPRB, 0.98456723E-07_JPRB, 0.11048694E-06_JPRB, 0.12351345E-06_JPRB, 0.14249279E-06_JPRB, &
  & 0.17342520E-06_JPRB, 0.21497171E-06_JPRB, 0.25825347E-06_JPRB, 0.29533515E-06_JPRB, 0.32439437E-06_JPRB, 0.34150020E-06_JPRB, &
  & 0.35036436E-06_JPRB, 0.35728336E-06_JPRB, 0.36541369E-06_JPRB, 0.37281620E-06_JPRB, 0.38020626E-06_JPRB, 0.38968664E-06_JPRB, &
  & 0.40777785E-06_JPRB, 0.43153372E-06_JPRB, 0.46047563E-06_JPRB, 0.48087127E-06_JPRB  /)

RGHG7(:,49, 8) = (/ &
  & 0.24339554E-06_JPRB, 0.23220571E-06_JPRB, 0.22542534E-06_JPRB, 0.22829096E-06_JPRB, 0.23268849E-06_JPRB, 0.23522118E-06_JPRB, &
  & 0.24053396E-06_JPRB, 0.25206617E-06_JPRB, 0.26956198E-06_JPRB, 0.29101877E-06_JPRB, 0.30732325E-06_JPRB, 0.31878406E-06_JPRB, &
  & 0.32752337E-06_JPRB, 0.32900288E-06_JPRB, 0.32567624E-06_JPRB, 0.31294806E-06_JPRB, 0.29036046E-06_JPRB, 0.25708310E-06_JPRB, &
  & 0.21603117E-06_JPRB, 0.17311317E-06_JPRB, 0.13429601E-06_JPRB, 0.10358674E-06_JPRB, 0.81889506E-07_JPRB, 0.68205730E-07_JPRB, &
  & 0.59799813E-07_JPRB, 0.54414630E-07_JPRB, 0.50745020E-07_JPRB, 0.47823296E-07_JPRB, 0.45285611E-07_JPRB, 0.43394032E-07_JPRB, &
  & 0.42330327E-07_JPRB, 0.41349557E-07_JPRB, 0.40460542E-07_JPRB, 0.38758034E-07_JPRB, 0.37356872E-07_JPRB, 0.37825583E-07_JPRB, &
  & 0.40648648E-07_JPRB, 0.45425839E-07_JPRB, 0.52248604E-07_JPRB, 0.59627303E-07_JPRB, 0.66393326E-07_JPRB, 0.72245526E-07_JPRB, &
  & 0.77888090E-07_JPRB, 0.83318092E-07_JPRB, 0.91042495E-07_JPRB, 0.10072485E-06_JPRB, 0.11096855E-06_JPRB, 0.12578477E-06_JPRB, &
  & 0.15086306E-06_JPRB, 0.18431412E-06_JPRB, 0.22020612E-06_JPRB, 0.25239235E-06_JPRB, 0.28039082E-06_JPRB, 0.29721259E-06_JPRB, &
  & 0.30538438E-06_JPRB, 0.31205040E-06_JPRB, 0.32082428E-06_JPRB, 0.32982014E-06_JPRB, 0.34035251E-06_JPRB, 0.35255801E-06_JPRB, &
  & 0.37306366E-06_JPRB, 0.40066309E-06_JPRB, 0.43234343E-06_JPRB, 0.45444338E-06_JPRB  /)

RGHG7(:,50, 8) = (/ &
  & 0.20256451E-06_JPRB, 0.19182037E-06_JPRB, 0.18494756E-06_JPRB, 0.18719598E-06_JPRB, 0.19142029E-06_JPRB, 0.19311302E-06_JPRB, &
  & 0.19675456E-06_JPRB, 0.20600102E-06_JPRB, 0.22157795E-06_JPRB, 0.24113302E-06_JPRB, 0.25574049E-06_JPRB, 0.26616794E-06_JPRB, &
  & 0.27470901E-06_JPRB, 0.27805674E-06_JPRB, 0.27818069E-06_JPRB, 0.26962394E-06_JPRB, 0.25256591E-06_JPRB, 0.22617402E-06_JPRB, &
  & 0.19282375E-06_JPRB, 0.15707247E-06_JPRB, 0.12426052E-06_JPRB, 0.97213790E-07_JPRB, 0.77190978E-07_JPRB, 0.64507374E-07_JPRB, &
  & 0.56837390E-07_JPRB, 0.52017343E-07_JPRB, 0.48792911E-07_JPRB, 0.46183475E-07_JPRB, 0.43801980E-07_JPRB, 0.42055052E-07_JPRB, &
  & 0.40987122E-07_JPRB, 0.40084308E-07_JPRB, 0.39243156E-07_JPRB, 0.37690809E-07_JPRB, 0.36493478E-07_JPRB, 0.37089460E-07_JPRB, &
  & 0.39961543E-07_JPRB, 0.44575250E-07_JPRB, 0.50872892E-07_JPRB, 0.57729482E-07_JPRB, 0.63994929E-07_JPRB, 0.69268762E-07_JPRB, &
  & 0.74301008E-07_JPRB, 0.79028129E-07_JPRB, 0.85591352E-07_JPRB, 0.93424161E-07_JPRB, 0.10142511E-06_JPRB, 0.11295872E-06_JPRB, &
  & 0.13315141E-06_JPRB, 0.15942621E-06_JPRB, 0.18772949E-06_JPRB, 0.21393601E-06_JPRB, 0.23875785E-06_JPRB, 0.25355699E-06_JPRB, &
  & 0.25999950E-06_JPRB, 0.26500784E-06_JPRB, 0.27368355E-06_JPRB, 0.28287166E-06_JPRB, 0.29543552E-06_JPRB, 0.31011873E-06_JPRB, &
  & 0.33357162E-06_JPRB, 0.36596449E-06_JPRB, 0.40315276E-06_JPRB, 0.42977342E-06_JPRB  /)

RGHG7(:,51, 8) = (/ &
  & 0.16187573E-06_JPRB, 0.15147467E-06_JPRB, 0.14485222E-06_JPRB, 0.14681319E-06_JPRB, 0.15079641E-06_JPRB, 0.15164534E-06_JPRB, &
  & 0.15360392E-06_JPRB, 0.16021233E-06_JPRB, 0.17360094E-06_JPRB, 0.19103260E-06_JPRB, 0.20350738E-06_JPRB, 0.21245122E-06_JPRB, &
  & 0.22011140E-06_JPRB, 0.22488246E-06_JPRB, 0.22782990E-06_JPRB, 0.22296364E-06_JPRB, 0.21117241E-06_JPRB, 0.19218002E-06_JPRB, &
  & 0.16721214E-06_JPRB, 0.13931007E-06_JPRB, 0.11333200E-06_JPRB, 0.90555278E-07_JPRB, 0.72507519E-07_JPRB, 0.60894895E-07_JPRB, &
  & 0.53948170E-07_JPRB, 0.49730840E-07_JPRB, 0.46979308E-07_JPRB, 0.44680502E-07_JPRB, 0.42442731E-07_JPRB, 0.40820983E-07_JPRB, &
  & 0.39720599E-07_JPRB, 0.38924420E-07_JPRB, 0.38092540E-07_JPRB, 0.36739553E-07_JPRB, 0.35750854E-07_JPRB, 0.36462743E-07_JPRB, &
  & 0.39418279E-07_JPRB, 0.43897534E-07_JPRB, 0.49750093E-07_JPRB, 0.56133784E-07_JPRB, 0.61986602E-07_JPRB, 0.66699446E-07_JPRB, &
  & 0.71175338E-07_JPRB, 0.75262653E-07_JPRB, 0.80727079E-07_JPRB, 0.86821284E-07_JPRB, 0.92680275E-07_JPRB, 0.10112613E-06_JPRB, &
  & 0.11654345E-06_JPRB, 0.13553929E-06_JPRB, 0.15552973E-06_JPRB, 0.17469838E-06_JPRB, 0.19497203E-06_JPRB, 0.20666950E-06_JPRB, &
  & 0.21069651E-06_JPRB, 0.21317345E-06_JPRB, 0.22135307E-06_JPRB, 0.23001266E-06_JPRB, 0.24418994E-06_JPRB, 0.26142310E-06_JPRB, &
  & 0.28834393E-06_JPRB, 0.32642087E-06_JPRB, 0.37102254E-06_JPRB, 0.40401345E-06_JPRB  /)

RGHG7(:,52, 8) = (/ &
  & 0.13018423E-06_JPRB, 0.12068605E-06_JPRB, 0.11483937E-06_JPRB, 0.11671534E-06_JPRB, 0.12042648E-06_JPRB, 0.12086591E-06_JPRB, &
  & 0.12178759E-06_JPRB, 0.12620019E-06_JPRB, 0.13705892E-06_JPRB, 0.15212038E-06_JPRB, 0.16271386E-06_JPRB, 0.17016494E-06_JPRB, &
  & 0.17678847E-06_JPRB, 0.18166887E-06_JPRB, 0.18575841E-06_JPRB, 0.18359840E-06_JPRB, 0.17535652E-06_JPRB, 0.16191095E-06_JPRB, &
  & 0.14386189E-06_JPRB, 0.12247720E-06_JPRB, 0.10256222E-06_JPRB, 0.84176735E-07_JPRB, 0.68463757E-07_JPRB, 0.57927441E-07_JPRB, &
  & 0.51624324E-07_JPRB, 0.47869747E-07_JPRB, 0.45557038E-07_JPRB, 0.43584981E-07_JPRB, 0.41514197E-07_JPRB, 0.39911850E-07_JPRB, &
  & 0.38793035E-07_JPRB, 0.38018054E-07_JPRB, 0.37165357E-07_JPRB, 0.35970645E-07_JPRB, 0.35099485E-07_JPRB, 0.35961141E-07_JPRB, &
  & 0.39054650E-07_JPRB, 0.43472248E-07_JPRB, 0.49009434E-07_JPRB, 0.55040612E-07_JPRB, 0.60613087E-07_JPRB, 0.64900627E-07_JPRB, &
  & 0.68992262E-07_JPRB, 0.72593862E-07_JPRB, 0.77260207E-07_JPRB, 0.82120411E-07_JPRB, 0.86440922E-07_JPRB, 0.92859046E-07_JPRB, &
  & 0.10453332E-06_JPRB, 0.11806693E-06_JPRB, 0.13173764E-06_JPRB, 0.14528125E-06_JPRB, 0.16081551E-06_JPRB, 0.16885831E-06_JPRB, &
  & 0.17084720E-06_JPRB, 0.17162422E-06_JPRB, 0.17851911E-06_JPRB, 0.18585891E-06_JPRB, 0.19901003E-06_JPRB, 0.21537520E-06_JPRB, &
  & 0.24229511E-06_JPRB, 0.28134140E-06_JPRB, 0.33017895E-06_JPRB, 0.36906876E-06_JPRB  /)

RGHG7(:,53, 8) = (/ &
  & 0.99134218E-07_JPRB, 0.90834638E-07_JPRB, 0.86034886E-07_JPRB, 0.87896178E-07_JPRB, 0.91299117E-07_JPRB, 0.91459683E-07_JPRB, &
  & 0.91500766E-07_JPRB, 0.93692296E-07_JPRB, 0.10166462E-06_JPRB, 0.11405004E-06_JPRB, 0.12269152E-06_JPRB, 0.12851349E-06_JPRB, &
  & 0.13394822E-06_JPRB, 0.13844213E-06_JPRB, 0.14312852E-06_JPRB, 0.14353693E-06_JPRB, 0.13849944E-06_JPRB, 0.13038150E-06_JPRB, &
  & 0.11930385E-06_JPRB, 0.10450410E-06_JPRB, 0.90895183E-07_JPRB, 0.77338318E-07_JPRB, 0.64306275E-07_JPRB, 0.54944092E-07_JPRB, &
  & 0.49311208E-07_JPRB, 0.46006716E-07_JPRB, 0.44158768E-07_JPRB, 0.42548734E-07_JPRB, 0.40668748E-07_JPRB, 0.39046831E-07_JPRB, &
  & 0.37913339E-07_JPRB, 0.37128574E-07_JPRB, 0.36241632E-07_JPRB, 0.35203471E-07_JPRB, 0.34425263E-07_JPRB, 0.35463038E-07_JPRB, &
  & 0.38727776E-07_JPRB, 0.43106236E-07_JPRB, 0.48349889E-07_JPRB, 0.54043504E-07_JPRB, 0.59361583E-07_JPRB, 0.63238177E-07_JPRB, &
  & 0.66977572E-07_JPRB, 0.70109519E-07_JPRB, 0.74022462E-07_JPRB, 0.77732995E-07_JPRB, 0.80610301E-07_JPRB, 0.85228088E-07_JPRB, &
  & 0.93223417E-07_JPRB, 0.10150767E-06_JPRB, 0.10906311E-06_JPRB, 0.11702469E-06_JPRB, 0.12732428E-06_JPRB, 0.13117445E-06_JPRB, &
  & 0.13108904E-06_JPRB, 0.13033480E-06_JPRB, 0.13552719E-06_JPRB, 0.14112537E-06_JPRB, 0.15214347E-06_JPRB, 0.16624844E-06_JPRB, &
  & 0.19183278E-06_JPRB, 0.23012078E-06_JPRB, 0.28234863E-06_JPRB, 0.32748091E-06_JPRB  /)

RGHG7(:,54, 8) = (/ &
  & 0.79521687E-07_JPRB, 0.72631002E-07_JPRB, 0.68788444E-07_JPRB, 0.70497394E-07_JPRB, 0.73392227E-07_JPRB, 0.73447802E-07_JPRB, &
  & 0.73194369E-07_JPRB, 0.74281040E-07_JPRB, 0.80076840E-07_JPRB, 0.90052567E-07_JPRB, 0.97272203E-07_JPRB, 0.10192650E-06_JPRB, &
  & 0.10625284E-06_JPRB, 0.11000625E-06_JPRB, 0.11443977E-06_JPRB, 0.11604436E-06_JPRB, 0.11304961E-06_JPRB, 0.10794742E-06_JPRB, &
  & 0.10118459E-06_JPRB, 0.90606281E-07_JPRB, 0.81086599E-07_JPRB, 0.71340677E-07_JPRB, 0.60991095E-07_JPRB, 0.52685472E-07_JPRB, &
  & 0.47668230E-07_JPRB, 0.44719364E-07_JPRB, 0.43232788E-07_JPRB, 0.41881075E-07_JPRB, 0.40195162E-07_JPRB, 0.38636089E-07_JPRB, &
  & 0.37446590E-07_JPRB, 0.36543509E-07_JPRB, 0.35604764E-07_JPRB, 0.34599974E-07_JPRB, 0.33850481E-07_JPRB, 0.35040981E-07_JPRB, &
  & 0.38460018E-07_JPRB, 0.42769403E-07_JPRB, 0.47854151E-07_JPRB, 0.53292041E-07_JPRB, 0.58371600E-07_JPRB, 0.62057979E-07_JPRB, &
  & 0.65558940E-07_JPRB, 0.68454649E-07_JPRB, 0.71841552E-07_JPRB, 0.74797596E-07_JPRB, 0.76868315E-07_JPRB, 0.80551555E-07_JPRB, &
  & 0.86112415E-07_JPRB, 0.91359912E-07_JPRB, 0.95830659E-07_JPRB, 0.10087515E-06_JPRB, 0.10772698E-06_JPRB, 0.10940857E-06_JPRB, &
  & 0.10861922E-06_JPRB, 0.10761239E-06_JPRB, 0.11136125E-06_JPRB, 0.11564368E-06_JPRB, 0.12373382E-06_JPRB, 0.13425440E-06_JPRB, &
  & 0.15527814E-06_JPRB, 0.18734117E-06_JPRB, 0.23478545E-06_JPRB, 0.27932588E-06_JPRB  /)

RGHG7(:,55, 8) = (/ &
  & 0.59300329E-07_JPRB, 0.53998016E-07_JPRB, 0.51203993E-07_JPRB, 0.52726076E-07_JPRB, 0.55031757E-07_JPRB, 0.54993898E-07_JPRB, &
  & 0.54491308E-07_JPRB, 0.54500897E-07_JPRB, 0.57979021E-07_JPRB, 0.65320437E-07_JPRB, 0.71034752E-07_JPRB, 0.74456239E-07_JPRB, &
  & 0.77565350E-07_JPRB, 0.80451905E-07_JPRB, 0.84493519E-07_JPRB, 0.87242668E-07_JPRB, 0.86357965E-07_JPRB, 0.84292368E-07_JPRB, &
  & 0.81959857E-07_JPRB, 0.75746979E-07_JPRB, 0.70465554E-07_JPRB, 0.64807357E-07_JPRB, 0.57429486E-07_JPRB, 0.50278808E-07_JPRB, &
  & 0.45936365E-07_JPRB, 0.43369019E-07_JPRB, 0.42269155E-07_JPRB, 0.41189957E-07_JPRB, 0.39719461E-07_JPRB, 0.38240845E-07_JPRB, &
  & 0.36983865E-07_JPRB, 0.35935444E-07_JPRB, 0.34937005E-07_JPRB, 0.33952978E-07_JPRB, 0.33226843E-07_JPRB, 0.34583447E-07_JPRB, &
  & 0.38171184E-07_JPRB, 0.42400112E-07_JPRB, 0.47326542E-07_JPRB, 0.52491918E-07_JPRB, 0.57309343E-07_JPRB, 0.60814045E-07_JPRB, &
  & 0.64065849E-07_JPRB, 0.66730570E-07_JPRB, 0.69564657E-07_JPRB, 0.71736896E-07_JPRB, 0.72997855E-07_JPRB, 0.75759735E-07_JPRB, &
  & 0.78787504E-07_JPRB, 0.80962070E-07_JPRB, 0.82414389E-07_JPRB, 0.84578009E-07_JPRB, 0.87845616E-07_JPRB, 0.87391212E-07_JPRB, &
  & 0.86002322E-07_JPRB, 0.84883897E-07_JPRB, 0.87067741E-07_JPRB, 0.89948662E-07_JPRB, 0.94690762E-07_JPRB, 0.10106652E-06_JPRB, &
  & 0.11661400E-06_JPRB, 0.14106219E-06_JPRB, 0.18213221E-06_JPRB, 0.22511801E-06_JPRB  /)

RGHG7(:,56, 8) = (/ &
  & 0.50128979E-07_JPRB, 0.45922275E-07_JPRB, 0.43806386E-07_JPRB, 0.44991608E-07_JPRB, 0.46734969E-07_JPRB, 0.46663059E-07_JPRB, &
  & 0.46208201E-07_JPRB, 0.46065497E-07_JPRB, 0.48551536E-07_JPRB, 0.54110572E-07_JPRB, 0.58800645E-07_JPRB, 0.61758183E-07_JPRB, &
  & 0.64222689E-07_JPRB, 0.66509558E-07_JPRB, 0.69892186E-07_JPRB, 0.72649437E-07_JPRB, 0.72613730E-07_JPRB, 0.71622244E-07_JPRB, &
  & 0.70810473E-07_JPRB, 0.66711056E-07_JPRB, 0.63291596E-07_JPRB, 0.59899288E-07_JPRB, 0.54698057E-07_JPRB, 0.48730351E-07_JPRB, &
  & 0.45072529E-07_JPRB, 0.42749859E-07_JPRB, 0.41662669E-07_JPRB, 0.40877776E-07_JPRB, 0.39546626E-07_JPRB, 0.38107838E-07_JPRB, &
  & 0.36848201E-07_JPRB, 0.35750043E-07_JPRB, 0.34653770E-07_JPRB, 0.33538313E-07_JPRB, 0.32788481E-07_JPRB, 0.34128503E-07_JPRB, &
  & 0.37842025E-07_JPRB, 0.41990950E-07_JPRB, 0.46856796E-07_JPRB, 0.51880256E-07_JPRB, 0.56425631E-07_JPRB, 0.59860197E-07_JPRB, &
  & 0.63021198E-07_JPRB, 0.65633022E-07_JPRB, 0.68033246E-07_JPRB, 0.69839251E-07_JPRB, 0.70857743E-07_JPRB, 0.73096009E-07_JPRB, &
  & 0.75024208E-07_JPRB, 0.76227559E-07_JPRB, 0.76872258E-07_JPRB, 0.78101640E-07_JPRB, 0.80022711E-07_JPRB, 0.79248987E-07_JPRB, &
  & 0.77854599E-07_JPRB, 0.76849854E-07_JPRB, 0.78393724E-07_JPRB, 0.80539449E-07_JPRB, 0.83638152E-07_JPRB, 0.87932472E-07_JPRB, &
  & 0.99054495E-07_JPRB, 0.11639758E-06_JPRB, 0.14718338E-06_JPRB, 0.18103847E-06_JPRB  /)

RGHG7(:,57, 8) = (/ &
  & 0.41147769E-07_JPRB, 0.37990270E-07_JPRB, 0.36494994E-07_JPRB, 0.37369866E-07_JPRB, 0.38589712E-07_JPRB, 0.38484257E-07_JPRB, &
  & 0.38072791E-07_JPRB, 0.37782316E-07_JPRB, 0.39306882E-07_JPRB, 0.43184861E-07_JPRB, 0.46852382E-07_JPRB, 0.49301160E-07_JPRB, &
  & 0.51191474E-07_JPRB, 0.52952347E-07_JPRB, 0.55698733E-07_JPRB, 0.58449958E-07_JPRB, 0.59221378E-07_JPRB, 0.59287924E-07_JPRB, &
  & 0.59892468E-07_JPRB, 0.57873263E-07_JPRB, 0.56231137E-07_JPRB, 0.54975978E-07_JPRB, 0.51875075E-07_JPRB, 0.47163671E-07_JPRB, &
  & 0.44154457E-07_JPRB, 0.42131979E-07_JPRB, 0.41092269E-07_JPRB, 0.40524510E-07_JPRB, 0.39345853E-07_JPRB, 0.37906339E-07_JPRB, &
  & 0.36699964E-07_JPRB, 0.35613336E-07_JPRB, 0.34423669E-07_JPRB, 0.33210297E-07_JPRB, 0.32381117E-07_JPRB, 0.33647625E-07_JPRB, &
  & 0.37467879E-07_JPRB, 0.41531923E-07_JPRB, 0.46326474E-07_JPRB, 0.51200895E-07_JPRB, 0.55468852E-07_JPRB, 0.58814618E-07_JPRB, &
  & 0.61913190E-07_JPRB, 0.64442336E-07_JPRB, 0.66443104E-07_JPRB, 0.67884375E-07_JPRB, 0.68658113E-07_JPRB, 0.70363523E-07_JPRB, &
  & 0.71259352E-07_JPRB, 0.71474715E-07_JPRB, 0.71315227E-07_JPRB, 0.71553755E-07_JPRB, 0.72144461E-07_JPRB, 0.70950286E-07_JPRB, &
  & 0.69573935E-07_JPRB, 0.68638482E-07_JPRB, 0.69552010E-07_JPRB, 0.70956170E-07_JPRB, 0.72513802E-07_JPRB, 0.74846626E-07_JPRB, &
  & 0.81969668E-07_JPRB, 0.92875601E-07_JPRB, 0.11421008E-06_JPRB, 0.13920542E-06_JPRB  /)

RGHG7(:,58, 8) = (/ &
  & 0.35281719E-07_JPRB, 0.32918268E-07_JPRB, 0.31827088E-07_JPRB, 0.32433237E-07_JPRB, 0.33242251E-07_JPRB, 0.33117939E-07_JPRB, &
  & 0.32794700E-07_JPRB, 0.32549350E-07_JPRB, 0.33489997E-07_JPRB, 0.36152994E-07_JPRB, 0.38973260E-07_JPRB, 0.41022657E-07_JPRB, &
  & 0.42611246E-07_JPRB, 0.44062985E-07_JPRB, 0.46212656E-07_JPRB, 0.48721424E-07_JPRB, 0.49927921E-07_JPRB, 0.50572324E-07_JPRB, &
  & 0.51757419E-07_JPRB, 0.51172755E-07_JPRB, 0.50576564E-07_JPRB, 0.50727659E-07_JPRB, 0.49280182E-07_JPRB, 0.45853129E-07_JPRB, &
  & 0.43381363E-07_JPRB, 0.41703040E-07_JPRB, 0.40695657E-07_JPRB, 0.40201310E-07_JPRB, 0.39170821E-07_JPRB, 0.37654529E-07_JPRB, &
  & 0.36603730E-07_JPRB, 0.35649107E-07_JPRB, 0.34373907E-07_JPRB, 0.33098573E-07_JPRB, 0.32093612E-07_JPRB, 0.33162113E-07_JPRB, &
  & 0.37040287E-07_JPRB, 0.41018124E-07_JPRB, 0.45747346E-07_JPRB, 0.50497171E-07_JPRB, 0.54499098E-07_JPRB, 0.57752595E-07_JPRB, &
  & 0.60871372E-07_JPRB, 0.63307576E-07_JPRB, 0.65021436E-07_JPRB, 0.66208126E-07_JPRB, 0.66859289E-07_JPRB, 0.68133663E-07_JPRB, &
  & 0.68462410E-07_JPRB, 0.68134938E-07_JPRB, 0.67656214E-07_JPRB, 0.67252903E-07_JPRB, 0.67067071E-07_JPRB, 0.65656032E-07_JPRB, &
  & 0.64447380E-07_JPRB, 0.63542908E-07_JPRB, 0.64066483E-07_JPRB, 0.64902888E-07_JPRB, 0.65535814E-07_JPRB, 0.66654330E-07_JPRB, &
  & 0.71017396E-07_JPRB, 0.77227734E-07_JPRB, 0.90544953E-07_JPRB, 0.10643062E-06_JPRB  /)

RGHG7(:,59, 8) = (/ &
  & 0.31470028E-07_JPRB, 0.29637838E-07_JPRB, 0.28776847E-07_JPRB, 0.29184910E-07_JPRB, 0.29722929E-07_JPRB, 0.29580028E-07_JPRB, &
  & 0.29344631E-07_JPRB, 0.29187356E-07_JPRB, 0.29768385E-07_JPRB, 0.31672737E-07_JPRB, 0.33872795E-07_JPRB, 0.35597448E-07_JPRB, &
  & 0.37036588E-07_JPRB, 0.38340258E-07_JPRB, 0.40070815E-07_JPRB, 0.42313487E-07_JPRB, 0.43723015E-07_JPRB, 0.44778923E-07_JPRB, &
  & 0.46115285E-07_JPRB, 0.46413481E-07_JPRB, 0.46409852E-07_JPRB, 0.47345086E-07_JPRB, 0.47046202E-07_JPRB, 0.44723610E-07_JPRB, &
  & 0.42686704E-07_JPRB, 0.41272976E-07_JPRB, 0.40358998E-07_JPRB, 0.39796320E-07_JPRB, 0.38878343E-07_JPRB, 0.37423310E-07_JPRB, &
  & 0.36582975E-07_JPRB, 0.35761079E-07_JPRB, 0.34473437E-07_JPRB, 0.33097148E-07_JPRB, 0.31885296E-07_JPRB, 0.32710267E-07_JPRB, &
  & 0.36505981E-07_JPRB, 0.40456579E-07_JPRB, 0.45047972E-07_JPRB, 0.49598340E-07_JPRB, 0.53364132E-07_JPRB, 0.56614570E-07_JPRB, &
  & 0.59741275E-07_JPRB, 0.62146550E-07_JPRB, 0.63739569E-07_JPRB, 0.64714275E-07_JPRB, 0.65332710E-07_JPRB, 0.66295223E-07_JPRB, &
  & 0.66322195E-07_JPRB, 0.65669419E-07_JPRB, 0.65029775E-07_JPRB, 0.64176258E-07_JPRB, 0.63505142E-07_JPRB, 0.61960595E-07_JPRB, &
  & 0.60882157E-07_JPRB, 0.60022673E-07_JPRB, 0.60257200E-07_JPRB, 0.60683973E-07_JPRB, 0.60803797E-07_JPRB, 0.61183170E-07_JPRB, &
  & 0.63790183E-07_JPRB, 0.67209845E-07_JPRB, 0.75355701E-07_JPRB, 0.85107777E-07_JPRB  /)

RGHG7(:,60, 8) = (/ &
  & 0.28437134E-07_JPRB, 0.27028483E-07_JPRB, 0.26328293E-07_JPRB, 0.26566958E-07_JPRB, 0.26892192E-07_JPRB, 0.26730383E-07_JPRB, &
  & 0.26577992E-07_JPRB, 0.26515096E-07_JPRB, 0.26830562E-07_JPRB, 0.28160189E-07_JPRB, 0.29830869E-07_JPRB, 0.31260877E-07_JPRB, &
  & 0.32601660E-07_JPRB, 0.33819575E-07_JPRB, 0.35216342E-07_JPRB, 0.37198057E-07_JPRB, 0.38712332E-07_JPRB, 0.40106918E-07_JPRB, &
  & 0.41461917E-07_JPRB, 0.42402780E-07_JPRB, 0.42836994E-07_JPRB, 0.44293628E-07_JPRB, 0.44927325E-07_JPRB, 0.43635792E-07_JPRB, &
  & 0.42008956E-07_JPRB, 0.40828918E-07_JPRB, 0.40002706E-07_JPRB, 0.39319803E-07_JPRB, 0.38505839E-07_JPRB, 0.37152497E-07_JPRB, &
  & 0.36526577E-07_JPRB, 0.35839592E-07_JPRB, 0.34573818E-07_JPRB, 0.33075846E-07_JPRB, 0.31637186E-07_JPRB, 0.32217834E-07_JPRB, &
  & 0.35860016E-07_JPRB, 0.39801739E-07_JPRB, 0.44193089E-07_JPRB, 0.48507232E-07_JPRB, 0.52059921E-07_JPRB, 0.55348021E-07_JPRB, &
  & 0.58482288E-07_JPRB, 0.60908874E-07_JPRB, 0.62455581E-07_JPRB, 0.63243459E-07_JPRB, 0.63868734E-07_JPRB, 0.64565743E-07_JPRB, &
  & 0.64379640E-07_JPRB, 0.63480762E-07_JPRB, 0.62727390E-07_JPRB, 0.61501754E-07_JPRB, 0.60456885E-07_JPRB, 0.58811508E-07_JPRB, &
  & 0.57840922E-07_JPRB, 0.57034679E-07_JPRB, 0.57013915E-07_JPRB, 0.57099366E-07_JPRB, 0.56867330E-07_JPRB, 0.56710950E-07_JPRB, &
  & 0.57945044E-07_JPRB, 0.59359689E-07_JPRB, 0.63533993E-07_JPRB, 0.68489734E-07_JPRB  /)

RGHG7(:,61, 8) = (/ &
  & 0.26464989E-07_JPRB, 0.25305350E-07_JPRB, 0.24677455E-07_JPRB, 0.24801471E-07_JPRB, 0.25008407E-07_JPRB, 0.24829072E-07_JPRB, &
  & 0.24727068E-07_JPRB, 0.24714558E-07_JPRB, 0.24906613E-07_JPRB, 0.25925886E-07_JPRB, 0.27235096E-07_JPRB, 0.28446031E-07_JPRB, &
  & 0.29719633E-07_JPRB, 0.30915640E-07_JPRB, 0.32155405E-07_JPRB, 0.33969164E-07_JPRB, 0.35464452E-07_JPRB, 0.37056934E-07_JPRB, &
  & 0.38430920E-07_JPRB, 0.39630289E-07_JPRB, 0.40375586E-07_JPRB, 0.41986301E-07_JPRB, 0.43161109E-07_JPRB, 0.42663349E-07_JPRB, &
  & 0.41409668E-07_JPRB, 0.40400506E-07_JPRB, 0.39547275E-07_JPRB, 0.38731468E-07_JPRB, 0.38015357E-07_JPRB, 0.36737230E-07_JPRB, &
  & 0.36237642E-07_JPRB, 0.35671877E-07_JPRB, 0.34471825E-07_JPRB, 0.32836568E-07_JPRB, 0.31165691E-07_JPRB, 0.31595908E-07_JPRB, &
  & 0.34997110E-07_JPRB, 0.38931531E-07_JPRB, 0.42992811E-07_JPRB, 0.47053560E-07_JPRB, 0.50483567E-07_JPRB, 0.53856375E-07_JPRB, &
  & 0.57011089E-07_JPRB, 0.59590297E-07_JPRB, 0.61191772E-07_JPRB, 0.61871574E-07_JPRB, 0.62550156E-07_JPRB, 0.63062414E-07_JPRB, &
  & 0.62722960E-07_JPRB, 0.61664889E-07_JPRB, 0.60807822E-07_JPRB, 0.59345588E-07_JPRB, 0.58072883E-07_JPRB, 0.56370547E-07_JPRB, &
  & 0.55446697E-07_JPRB, 0.54701064E-07_JPRB, 0.54475832E-07_JPRB, 0.54353164E-07_JPRB, 0.53961935E-07_JPRB, 0.53583561E-07_JPRB, &
  & 0.53955968E-07_JPRB, 0.54478987E-07_JPRB, 0.56608611E-07_JPRB, 0.59223924E-07_JPRB  /)

RGHG7(:,62, 8) = (/ &
  & 0.24936027E-07_JPRB, 0.23952253E-07_JPRB, 0.23368143E-07_JPRB, 0.23403048E-07_JPRB, 0.23518725E-07_JPRB, 0.23325089E-07_JPRB, &
  & 0.23254536E-07_JPRB, 0.23254016E-07_JPRB, 0.23373865E-07_JPRB, 0.24192900E-07_JPRB, 0.25232906E-07_JPRB, 0.26295087E-07_JPRB, &
  & 0.27490714E-07_JPRB, 0.28655465E-07_JPRB, 0.29834854E-07_JPRB, 0.31515304E-07_JPRB, 0.32982892E-07_JPRB, 0.34672002E-07_JPRB, &
  & 0.36066661E-07_JPRB, 0.37431148E-07_JPRB, 0.38430416E-07_JPRB, 0.40071464E-07_JPRB, 0.41595968E-07_JPRB, 0.41689166E-07_JPRB, &
  & 0.40871355E-07_JPRB, 0.40056900E-07_JPRB, 0.39129297E-07_JPRB, 0.38159589E-07_JPRB, 0.37383353E-07_JPRB, 0.36160135E-07_JPRB, &
  & 0.35716305E-07_JPRB, 0.35236704E-07_JPRB, 0.34047166E-07_JPRB, 0.32120499E-07_JPRB, 0.30179725E-07_JPRB, 0.30632572E-07_JPRB, &
  & 0.33896472E-07_JPRB, 0.37800652E-07_JPRB, 0.41508361E-07_JPRB, 0.45326015E-07_JPRB, 0.48689435E-07_JPRB, 0.52115595E-07_JPRB, &
  & 0.55394662E-07_JPRB, 0.58137304E-07_JPRB, 0.59858004E-07_JPRB, 0.60463044E-07_JPRB, 0.61211770E-07_JPRB, 0.61563117E-07_JPRB, &
  & 0.61077314E-07_JPRB, 0.59890653E-07_JPRB, 0.58926585E-07_JPRB, 0.57294268E-07_JPRB, 0.55864308E-07_JPRB, 0.54145362E-07_JPRB, &
  & 0.53262170E-07_JPRB, 0.52575296E-07_JPRB, 0.52169348E-07_JPRB, 0.51900039E-07_JPRB, 0.51444010E-07_JPRB, 0.51034962E-07_JPRB, &
  & 0.50782013E-07_JPRB, 0.50804472E-07_JPRB, 0.51680513E-07_JPRB, 0.52895458E-07_JPRB  /)

RGHG7(:,63, 8) = (/ &
  & 0.23671358E-07_JPRB, 0.22825169E-07_JPRB, 0.22266506E-07_JPRB, 0.22226405E-07_JPRB, 0.22264818E-07_JPRB, 0.22059043E-07_JPRB, &
  & 0.22002789E-07_JPRB, 0.21993270E-07_JPRB, 0.22066732E-07_JPRB, 0.22747585E-07_JPRB, 0.23583921E-07_JPRB, 0.24534183E-07_JPRB, &
  & 0.25647655E-07_JPRB, 0.26767177E-07_JPRB, 0.27941178E-07_JPRB, 0.29504015E-07_JPRB, 0.30946475E-07_JPRB, 0.32674086E-07_JPRB, &
  & 0.34103135E-07_JPRB, 0.35561830E-07_JPRB, 0.36778789E-07_JPRB, 0.38392013E-07_JPRB, 0.40139575E-07_JPRB, 0.40679086E-07_JPRB, &
  & 0.40340003E-07_JPRB, 0.39742324E-07_JPRB, 0.38734713E-07_JPRB, 0.37630568E-07_JPRB, 0.36665231E-07_JPRB, 0.35517479E-07_JPRB, &
  & 0.35046665E-07_JPRB, 0.34605653E-07_JPRB, 0.33313853E-07_JPRB, 0.31004306E-07_JPRB, 0.28812429E-07_JPRB, 0.29379286E-07_JPRB, &
  & 0.32618374E-07_JPRB, 0.36483504E-07_JPRB, 0.39813840E-07_JPRB, 0.43416996E-07_JPRB, 0.46751334E-07_JPRB, 0.50203680E-07_JPRB, &
  & 0.53649402E-07_JPRB, 0.56541439E-07_JPRB, 0.58433033E-07_JPRB, 0.58981750E-07_JPRB, 0.59800680E-07_JPRB, 0.60013593E-07_JPRB, &
  & 0.59376821E-07_JPRB, 0.58083308E-07_JPRB, 0.57013038E-07_JPRB, 0.55254822E-07_JPRB, 0.53718218E-07_JPRB, 0.52022867E-07_JPRB, &
  & 0.51171378E-07_JPRB, 0.50533072E-07_JPRB, 0.49972750E-07_JPRB, 0.49587413E-07_JPRB, 0.49146660E-07_JPRB, 0.48813254E-07_JPRB, &
  & 0.48105597E-07_JPRB, 0.47828594E-07_JPRB, 0.47911809E-07_JPRB, 0.48224357E-07_JPRB  /)

RGHG7(:,64, 8) = (/ &
  & 0.22660454E-07_JPRB, 0.21926080E-07_JPRB, 0.21375404E-07_JPRB, 0.21272207E-07_JPRB, 0.21243532E-07_JPRB, 0.21028173E-07_JPRB, &
  & 0.20962335E-07_JPRB, 0.20931251E-07_JPRB, 0.20971967E-07_JPRB, 0.21561772E-07_JPRB, 0.22271119E-07_JPRB, 0.23133527E-07_JPRB, &
  & 0.24168729E-07_JPRB, 0.25219565E-07_JPRB, 0.26426312E-07_JPRB, 0.27879730E-07_JPRB, 0.29313405E-07_JPRB, 0.31037023E-07_JPRB, &
  & 0.32531562E-07_JPRB, 0.33999841E-07_JPRB, 0.35394107E-07_JPRB, 0.36962604E-07_JPRB, 0.38805209E-07_JPRB, 0.39621061E-07_JPRB, &
  & 0.39784343E-07_JPRB, 0.39425467E-07_JPRB, 0.38375527E-07_JPRB, 0.37212280E-07_JPRB, 0.35905909E-07_JPRB, 0.34902718E-07_JPRB, &
  & 0.34272168E-07_JPRB, 0.33785633E-07_JPRB, 0.32171168E-07_JPRB, 0.29423949E-07_JPRB, 0.27076330E-07_JPRB, 0.27802922E-07_JPRB, &
  & 0.31192160E-07_JPRB, 0.35021350E-07_JPRB, 0.37953947E-07_JPRB, 0.41411744E-07_JPRB, 0.44754069E-07_JPRB, 0.48196032E-07_JPRB, &
  & 0.51800690E-07_JPRB, 0.54790165E-07_JPRB, 0.56908583E-07_JPRB, 0.57414970E-07_JPRB, 0.58284216E-07_JPRB, 0.58395698E-07_JPRB, &
  & 0.57595198E-07_JPRB, 0.56221817E-07_JPRB, 0.55054908E-07_JPRB, 0.53217623E-07_JPRB, 0.51632300E-07_JPRB, 0.50018413E-07_JPRB, &
  & 0.49181301E-07_JPRB, 0.48566156E-07_JPRB, 0.47898812E-07_JPRB, 0.47415238E-07_JPRB, 0.47091890E-07_JPRB, 0.46899850E-07_JPRB, &
  & 0.45938214E-07_JPRB, 0.45473523E-07_JPRB, 0.45131844E-07_JPRB, 0.44854172E-07_JPRB  /)

RGHG7(:,65, 8) = (/ &
  & 0.21888422E-07_JPRB, 0.21228061E-07_JPRB, 0.20666105E-07_JPRB, 0.20501562E-07_JPRB, 0.20428330E-07_JPRB, 0.20201827E-07_JPRB, &
  & 0.20093624E-07_JPRB, 0.20036352E-07_JPRB, 0.20038126E-07_JPRB, 0.20585993E-07_JPRB, 0.21235028E-07_JPRB, 0.22008911E-07_JPRB, &
  & 0.22968963E-07_JPRB, 0.23953563E-07_JPRB, 0.25156880E-07_JPRB, 0.26540187E-07_JPRB, 0.27971700E-07_JPRB, 0.29640002E-07_JPRB, &
  & 0.31211683E-07_JPRB, 0.32671035E-07_JPRB, 0.34139145E-07_JPRB, 0.35676699E-07_JPRB, 0.37566009E-07_JPRB, 0.38583744E-07_JPRB, &
  & 0.39106782E-07_JPRB, 0.38966231E-07_JPRB, 0.38055017E-07_JPRB, 0.36847828E-07_JPRB, 0.35389609E-07_JPRB, 0.34379691E-07_JPRB, &
  & 0.33574065E-07_JPRB, 0.32771076E-07_JPRB, 0.30695452E-07_JPRB, 0.27643255E-07_JPRB, 0.25229397E-07_JPRB, 0.26250003E-07_JPRB, &
  & 0.29834395E-07_JPRB, 0.33422947E-07_JPRB, 0.36115336E-07_JPRB, 0.39506206E-07_JPRB, 0.42832047E-07_JPRB, 0.46247937E-07_JPRB, &
  & 0.49925028E-07_JPRB, 0.53020118E-07_JPRB, 0.55298700E-07_JPRB, 0.55787709E-07_JPRB, 0.56664541E-07_JPRB, 0.56681994E-07_JPRB, &
  & 0.55715030E-07_JPRB, 0.54292394E-07_JPRB, 0.53089063E-07_JPRB, 0.51239009E-07_JPRB, 0.49638790E-07_JPRB, 0.48146387E-07_JPRB, &
  & 0.47334167E-07_JPRB, 0.46697016E-07_JPRB, 0.45967179E-07_JPRB, 0.45424760E-07_JPRB, 0.45280667E-07_JPRB, 0.45224380E-07_JPRB, &
  & 0.44227606E-07_JPRB, 0.43658538E-07_JPRB, 0.43102811E-07_JPRB, 0.42357532E-07_JPRB  /)

RGHG7(:,66, 8) = (/ &
  & 0.21234220E-07_JPRB, 0.20607530E-07_JPRB, 0.20026659E-07_JPRB, 0.19800542E-07_JPRB, 0.19700904E-07_JPRB, 0.19458056E-07_JPRB, &
  & 0.19295474E-07_JPRB, 0.19212668E-07_JPRB, 0.19173271E-07_JPRB, 0.19686984E-07_JPRB, 0.20294323E-07_JPRB, 0.20998079E-07_JPRB, &
  & 0.21878699E-07_JPRB, 0.22812048E-07_JPRB, 0.23976990E-07_JPRB, 0.25307527E-07_JPRB, 0.26722422E-07_JPRB, 0.28327974E-07_JPRB, &
  & 0.29951912E-07_JPRB, 0.31400886E-07_JPRB, 0.32916621E-07_JPRB, 0.34429356E-07_JPRB, 0.36343200E-07_JPRB, 0.37555323E-07_JPRB, &
  & 0.38337827E-07_JPRB, 0.38404459E-07_JPRB, 0.37683585E-07_JPRB, 0.36423764E-07_JPRB, 0.34959410E-07_JPRB, 0.33928027E-07_JPRB, &
  & 0.32907097E-07_JPRB, 0.31616430E-07_JPRB, 0.29122965E-07_JPRB, 0.25847266E-07_JPRB, 0.23492529E-07_JPRB, 0.24861160E-07_JPRB, &
  & 0.28520746E-07_JPRB, 0.31791875E-07_JPRB, 0.34353572E-07_JPRB, 0.37612035E-07_JPRB, 0.40956096E-07_JPRB, 0.44376778E-07_JPRB, &
  & 0.48077845E-07_JPRB, 0.51250252E-07_JPRB, 0.53655364E-07_JPRB, 0.54163985E-07_JPRB, 0.54995493E-07_JPRB, 0.54903500E-07_JPRB, &
  & 0.53786288E-07_JPRB, 0.52326841E-07_JPRB, 0.51111342E-07_JPRB, 0.49290233E-07_JPRB, 0.47688306E-07_JPRB, 0.46318454E-07_JPRB, &
  & 0.45536337E-07_JPRB, 0.44862761E-07_JPRB, 0.44118756E-07_JPRB, 0.43567308E-07_JPRB, 0.43581122E-07_JPRB, 0.43653081E-07_JPRB, &
  & 0.42701448E-07_JPRB, 0.42106892E-07_JPRB, 0.41402321E-07_JPRB, 0.40231531E-07_JPRB  /)

RGHG7(:,67, 8) = (/ &
  & 0.20686430E-07_JPRB, 0.20048860E-07_JPRB, 0.19446374E-07_JPRB, 0.19160276E-07_JPRB, 0.19049057E-07_JPRB, 0.18784021E-07_JPRB, &
  & 0.18560780E-07_JPRB, 0.18454930E-07_JPRB, 0.18375534E-07_JPRB, 0.18856176E-07_JPRB, 0.19434088E-07_JPRB, 0.20085189E-07_JPRB, &
  & 0.20886577E-07_JPRB, 0.21779225E-07_JPRB, 0.22879409E-07_JPRB, 0.24161853E-07_JPRB, 0.25548147E-07_JPRB, 0.27086676E-07_JPRB, &
  & 0.28734436E-07_JPRB, 0.30176313E-07_JPRB, 0.31728289E-07_JPRB, 0.33230277E-07_JPRB, 0.35142136E-07_JPRB, 0.36534587E-07_JPRB, &
  & 0.37498757E-07_JPRB, 0.37739924E-07_JPRB, 0.37199383E-07_JPRB, 0.35898229E-07_JPRB, 0.34558652E-07_JPRB, 0.33496771E-07_JPRB, &
  & 0.32197046E-07_JPRB, 0.30329449E-07_JPRB, 0.27460687E-07_JPRB, 0.24075219E-07_JPRB, 0.21955856E-07_JPRB, 0.23657727E-07_JPRB, &
  & 0.27243655E-07_JPRB, 0.30166366E-07_JPRB, 0.32660630E-07_JPRB, 0.35753624E-07_JPRB, 0.39154331E-07_JPRB, 0.42609987E-07_JPRB, &
  & 0.46309005E-07_JPRB, 0.49518710E-07_JPRB, 0.52010288E-07_JPRB, 0.52581290E-07_JPRB, 0.53315570E-07_JPRB, 0.53093405E-07_JPRB, &
  & 0.51849987E-07_JPRB, 0.50370496E-07_JPRB, 0.49147671E-07_JPRB, 0.47379034E-07_JPRB, 0.45791271E-07_JPRB, 0.44535841E-07_JPRB, &
  & 0.43784694E-07_JPRB, 0.43084590E-07_JPRB, 0.42368591E-07_JPRB, 0.41865856E-07_JPRB, 0.42006765E-07_JPRB, 0.42206469E-07_JPRB, &
  & 0.41353693E-07_JPRB, 0.40804493E-07_JPRB, 0.39985701E-07_JPRB, 0.38440087E-07_JPRB  /)

RGHG7(:,68, 8) = (/ &
  & 0.20230835E-07_JPRB, 0.19531348E-07_JPRB, 0.18912870E-07_JPRB, 0.18571826E-07_JPRB, 0.18456506E-07_JPRB, 0.18162767E-07_JPRB, &
  & 0.17880480E-07_JPRB, 0.17756588E-07_JPRB, 0.17644387E-07_JPRB, 0.18086075E-07_JPRB, 0.18641434E-07_JPRB, 0.19249891E-07_JPRB, &
  & 0.19982391E-07_JPRB, 0.20831574E-07_JPRB, 0.21859590E-07_JPRB, 0.23074376E-07_JPRB, 0.24429917E-07_JPRB, 0.25894638E-07_JPRB, &
  & 0.27539117E-07_JPRB, 0.28983864E-07_JPRB, 0.30578895E-07_JPRB, 0.32102205E-07_JPRB, 0.33972240E-07_JPRB, 0.35506567E-07_JPRB, &
  & 0.36622044E-07_JPRB, 0.36960392E-07_JPRB, 0.36484228E-07_JPRB, 0.35200296E-07_JPRB, 0.34087475E-07_JPRB, 0.32971468E-07_JPRB, &
  & 0.31283018E-07_JPRB, 0.28905324E-07_JPRB, 0.25658500E-07_JPRB, 0.22350120E-07_JPRB, 0.20740444E-07_JPRB, 0.22631757E-07_JPRB, &
  & 0.25971658E-07_JPRB, 0.28586423E-07_JPRB, 0.30980637E-07_JPRB, 0.33973988E-07_JPRB, 0.37464907E-07_JPRB, 0.40973868E-07_JPRB, &
  & 0.44687648E-07_JPRB, 0.47878901E-07_JPRB, 0.50399592E-07_JPRB, 0.51084587E-07_JPRB, 0.51675351E-07_JPRB, 0.51294497E-07_JPRB, &
  & 0.49959229E-07_JPRB, 0.48488349E-07_JPRB, 0.47227390E-07_JPRB, 0.45499347E-07_JPRB, 0.43950949E-07_JPRB, 0.42791470E-07_JPRB, &
  & 0.42064106E-07_JPRB, 0.41393525E-07_JPRB, 0.40731652E-07_JPRB, 0.40348240E-07_JPRB, 0.40584690E-07_JPRB, 0.40929141E-07_JPRB, &
  & 0.40196918E-07_JPRB, 0.39744079E-07_JPRB, 0.38804323E-07_JPRB, 0.36961426E-07_JPRB  /)

RGHG7(:,69, 8) = (/ &
  & 0.19819764E-07_JPRB, 0.19042696E-07_JPRB, 0.18404871E-07_JPRB, 0.18032029E-07_JPRB, 0.17907384E-07_JPRB, 0.17571139E-07_JPRB, &
  & 0.17238026E-07_JPRB, 0.17094603E-07_JPRB, 0.16953710E-07_JPRB, 0.17364661E-07_JPRB, 0.17890381E-07_JPRB, 0.18469262E-07_JPRB, &
  & 0.19150428E-07_JPRB, 0.19937120E-07_JPRB, 0.20906417E-07_JPRB, 0.22028180E-07_JPRB, 0.23340658E-07_JPRB, 0.24729345E-07_JPRB, &
  & 0.26327999E-07_JPRB, 0.27792037E-07_JPRB, 0.29411828E-07_JPRB, 0.30976237E-07_JPRB, 0.32797363E-07_JPRB, 0.34408230E-07_JPRB, &
  & 0.35671255E-07_JPRB, 0.35993687E-07_JPRB, 0.35468810E-07_JPRB, 0.34303606E-07_JPRB, 0.33388764E-07_JPRB, 0.32135417E-07_JPRB, &
  & 0.29994871E-07_JPRB, 0.27228462E-07_JPRB, 0.23882796E-07_JPRB, 0.20892951E-07_JPRB, 0.19657025E-07_JPRB, 0.21533605E-07_JPRB, &
  & 0.24599533E-07_JPRB, 0.26957165E-07_JPRB, 0.29303593E-07_JPRB, 0.32302937E-07_JPRB, 0.35805677E-07_JPRB, 0.39344797E-07_JPRB, &
  & 0.43138272E-07_JPRB, 0.46261068E-07_JPRB, 0.48756754E-07_JPRB, 0.49609088E-07_JPRB, 0.50060093E-07_JPRB, 0.49517596E-07_JPRB, &
  & 0.48108780E-07_JPRB, 0.46689801E-07_JPRB, 0.45357873E-07_JPRB, 0.43642054E-07_JPRB, 0.42134506E-07_JPRB, 0.41064616E-07_JPRB, &
  & 0.40375212E-07_JPRB, 0.39757287E-07_JPRB, 0.39207003E-07_JPRB, 0.39000738E-07_JPRB, 0.39349132E-07_JPRB, 0.39839049E-07_JPRB, &
  & 0.39228104E-07_JPRB, 0.38836154E-07_JPRB, 0.37804940E-07_JPRB, 0.35813720E-07_JPRB  /)

RGHG7(:,70, 8) = (/ &
  & 0.19416477E-07_JPRB, 0.18571565E-07_JPRB, 0.17905205E-07_JPRB, 0.17510888E-07_JPRB, 0.17376385E-07_JPRB, 0.16992611E-07_JPRB, &
  & 0.16615578E-07_JPRB, 0.16437900E-07_JPRB, 0.16259132E-07_JPRB, 0.16660350E-07_JPRB, 0.17156863E-07_JPRB, 0.17713357E-07_JPRB, &
  & 0.18350775E-07_JPRB, 0.19080360E-07_JPRB, 0.19990717E-07_JPRB, 0.21005567E-07_JPRB, 0.22262718E-07_JPRB, 0.23573330E-07_JPRB, &
  & 0.25097563E-07_JPRB, 0.26588509E-07_JPRB, 0.28207236E-07_JPRB, 0.29803101E-07_JPRB, 0.31568803E-07_JPRB, 0.33219891E-07_JPRB, &
  & 0.34598220E-07_JPRB, 0.34913080E-07_JPRB, 0.34324891E-07_JPRB, 0.33241017E-07_JPRB, 0.32554117E-07_JPRB, 0.31135877E-07_JPRB, &
  & 0.28676422E-07_JPRB, 0.25638538E-07_JPRB, 0.22391772E-07_JPRB, 0.19630079E-07_JPRB, 0.18609879E-07_JPRB, 0.20373860E-07_JPRB, &
  & 0.23177995E-07_JPRB, 0.25341611E-07_JPRB, 0.27649607E-07_JPRB, 0.30702079E-07_JPRB, 0.34142206E-07_JPRB, 0.37704493E-07_JPRB, &
  & 0.41538721E-07_JPRB, 0.44575833E-07_JPRB, 0.47035401E-07_JPRB, 0.48102616E-07_JPRB, 0.48435400E-07_JPRB, 0.47748751E-07_JPRB, &
  & 0.46248984E-07_JPRB, 0.44897244E-07_JPRB, 0.43520750E-07_JPRB, 0.41796746E-07_JPRB, 0.40333851E-07_JPRB, 0.39360727E-07_JPRB, &
  & 0.38725770E-07_JPRB, 0.38168849E-07_JPRB, 0.37769172E-07_JPRB, 0.37766135E-07_JPRB, 0.38229747E-07_JPRB, 0.38847622E-07_JPRB, &
  & 0.38353028E-07_JPRB, 0.37995475E-07_JPRB, 0.36869335E-07_JPRB, 0.34801864E-07_JPRB  /)

RGHG7(:,71, 8) = (/ &
  & 0.19012344E-07_JPRB, 0.18118724E-07_JPRB, 0.17413936E-07_JPRB, 0.17002769E-07_JPRB, 0.16856444E-07_JPRB, 0.16425554E-07_JPRB, &
  & 0.16010431E-07_JPRB, 0.15781469E-07_JPRB, 0.15556480E-07_JPRB, 0.15968312E-07_JPRB, 0.16437413E-07_JPRB, 0.16975523E-07_JPRB, &
  & 0.17568857E-07_JPRB, 0.18253094E-07_JPRB, 0.19105960E-07_JPRB, 0.20006416E-07_JPRB, 0.21194831E-07_JPRB, 0.22422239E-07_JPRB, &
  & 0.23858492E-07_JPRB, 0.25367633E-07_JPRB, 0.26967049E-07_JPRB, 0.28576925E-07_JPRB, 0.30292161E-07_JPRB, 0.31945817E-07_JPRB, &
  & 0.33366959E-07_JPRB, 0.33680536E-07_JPRB, 0.33058355E-07_JPRB, 0.32003842E-07_JPRB, 0.31559440E-07_JPRB, 0.30013369E-07_JPRB, &
  & 0.27392330E-07_JPRB, 0.24217933E-07_JPRB, 0.21176853E-07_JPRB, 0.18539592E-07_JPRB, 0.17601671E-07_JPRB, 0.19186802E-07_JPRB, &
  & 0.21730449E-07_JPRB, 0.23756861E-07_JPRB, 0.26027360E-07_JPRB, 0.29162414E-07_JPRB, 0.32485950E-07_JPRB, 0.36047076E-07_JPRB, &
  & 0.39875983E-07_JPRB, 0.42826577E-07_JPRB, 0.45255709E-07_JPRB, 0.46553163E-07_JPRB, 0.46813230E-07_JPRB, 0.46003195E-07_JPRB, &
  & 0.44382561E-07_JPRB, 0.43102580E-07_JPRB, 0.41718069E-07_JPRB, 0.39973529E-07_JPRB, 0.38560560E-07_JPRB, 0.37680000E-07_JPRB, &
  & 0.37125859E-07_JPRB, 0.36641793E-07_JPRB, 0.36421239E-07_JPRB, 0.36640971E-07_JPRB, 0.37214524E-07_JPRB, 0.37936974E-07_JPRB, &
  & 0.37555343E-07_JPRB, 0.37199122E-07_JPRB, 0.35954766E-07_JPRB, 0.33848554E-07_JPRB  /)

RGHG7(:,72, 8) = (/ &
  & 0.18596858E-07_JPRB, 0.17686819E-07_JPRB, 0.16933186E-07_JPRB, 0.16501497E-07_JPRB, 0.16337522E-07_JPRB, 0.15868459E-07_JPRB, &
  & 0.15419269E-07_JPRB, 0.15119708E-07_JPRB, 0.14844233E-07_JPRB, 0.15283566E-07_JPRB, 0.15728039E-07_JPRB, 0.16246858E-07_JPRB, &
  & 0.16782316E-07_JPRB, 0.17440285E-07_JPRB, 0.18243075E-07_JPRB, 0.19031066E-07_JPRB, 0.20134516E-07_JPRB, 0.21267108E-07_JPRB, &
  & 0.22627427E-07_JPRB, 0.24116045E-07_JPRB, 0.25693707E-07_JPRB, 0.27290859E-07_JPRB, 0.28982699E-07_JPRB, 0.30591615E-07_JPRB, &
  & 0.31909322E-07_JPRB, 0.32198271E-07_JPRB, 0.31636428E-07_JPRB, 0.30559339E-07_JPRB, 0.30330838E-07_JPRB, 0.28808163E-07_JPRB, &
  & 0.26191228E-07_JPRB, 0.23053362E-07_JPRB, 0.20168666E-07_JPRB, 0.17594615E-07_JPRB, 0.16655053E-07_JPRB, 0.18031672E-07_JPRB, &
  & 0.20285536E-07_JPRB, 0.22217542E-07_JPRB, 0.24444123E-07_JPRB, 0.27670298E-07_JPRB, 0.30860436E-07_JPRB, 0.34358352E-07_JPRB, &
  & 0.38142928E-07_JPRB, 0.41030723E-07_JPRB, 0.43458624E-07_JPRB, 0.44941605E-07_JPRB, 0.45218089E-07_JPRB, 0.44307493E-07_JPRB, &
  & 0.42518160E-07_JPRB, 0.41299748E-07_JPRB, 0.39951768E-07_JPRB, 0.38187937E-07_JPRB, 0.36832842E-07_JPRB, 0.36015903E-07_JPRB, &
  & 0.35588593E-07_JPRB, 0.35199753E-07_JPRB, 0.35171703E-07_JPRB, 0.35629090E-07_JPRB, 0.36293765E-07_JPRB, 0.37089686E-07_JPRB, &
  & 0.36822162E-07_JPRB, 0.36418739E-07_JPRB, 0.35000349E-07_JPRB, 0.32842830E-07_JPRB  /)

RGHG7(:,73, 8) = (/ &
  & 0.18171634E-07_JPRB, 0.17261463E-07_JPRB, 0.16457178E-07_JPRB, 0.15994942E-07_JPRB, 0.15813595E-07_JPRB, 0.15314901E-07_JPRB, &
  & 0.14838302E-07_JPRB, 0.14439923E-07_JPRB, 0.14117859E-07_JPRB, 0.14600471E-07_JPRB, 0.15019792E-07_JPRB, 0.15519208E-07_JPRB, &
  & 0.15984647E-07_JPRB, 0.16607431E-07_JPRB, 0.17372807E-07_JPRB, 0.18060251E-07_JPRB, 0.19078244E-07_JPRB, 0.20111279E-07_JPRB, &
  & 0.21387984E-07_JPRB, 0.22812531E-07_JPRB, 0.24362979E-07_JPRB, 0.25953047E-07_JPRB, 0.27642308E-07_JPRB, 0.29109080E-07_JPRB, &
  & 0.30231703E-07_JPRB, 0.30338927E-07_JPRB, 0.29784057E-07_JPRB, 0.28837025E-07_JPRB, 0.28789868E-07_JPRB, 0.27414537E-07_JPRB, &
  & 0.24884397E-07_JPRB, 0.22007277E-07_JPRB, 0.19245206E-07_JPRB, 0.16777400E-07_JPRB, 0.15845710E-07_JPRB, 0.16993939E-07_JPRB, &
  & 0.18958243E-07_JPRB, 0.20788819E-07_JPRB, 0.22986464E-07_JPRB, 0.26252099E-07_JPRB, 0.29405970E-07_JPRB, 0.32726021E-07_JPRB, &
  & 0.36373438E-07_JPRB, 0.39311975E-07_JPRB, 0.41732161E-07_JPRB, 0.43264220E-07_JPRB, 0.43599123E-07_JPRB, 0.42628143E-07_JPRB, &
  & 0.40739229E-07_JPRB, 0.39548838E-07_JPRB, 0.38216267E-07_JPRB, 0.36428842E-07_JPRB, 0.35128529E-07_JPRB, 0.34360342E-07_JPRB, &
  & 0.34060599E-07_JPRB, 0.33770206E-07_JPRB, 0.34004350E-07_JPRB, 0.34687057E-07_JPRB, 0.35431954E-07_JPRB, 0.36273964E-07_JPRB, &
  & 0.36107114E-07_JPRB, 0.35583452E-07_JPRB, 0.33917255E-07_JPRB, 0.31690225E-07_JPRB  /)

RGHG7(:,74, 8) = (/ &
  & 0.17744294E-07_JPRB, 0.16830899E-07_JPRB, 0.15986275E-07_JPRB, 0.15490203E-07_JPRB, 0.15296485E-07_JPRB, 0.14768165E-07_JPRB, &
  & 0.14269456E-07_JPRB, 0.13760820E-07_JPRB, 0.13397998E-07_JPRB, 0.13931863E-07_JPRB, 0.14335435E-07_JPRB, 0.14807775E-07_JPRB, &
  & 0.15212161E-07_JPRB, 0.15768563E-07_JPRB, 0.16498126E-07_JPRB, 0.17124552E-07_JPRB, 0.18055650E-07_JPRB, 0.18977932E-07_JPRB, &
  & 0.20185090E-07_JPRB, 0.21515946E-07_JPRB, 0.23005042E-07_JPRB, 0.24552321E-07_JPRB, 0.26167144E-07_JPRB, 0.27430193E-07_JPRB, &
  & 0.28273643E-07_JPRB, 0.28201241E-07_JPRB, 0.27729647E-07_JPRB, 0.27059961E-07_JPRB, 0.27174687E-07_JPRB, 0.26013974E-07_JPRB, &
  & 0.23636732E-07_JPRB, 0.21085289E-07_JPRB, 0.18390078E-07_JPRB, 0.16056065E-07_JPRB, 0.15163030E-07_JPRB, 0.16088631E-07_JPRB, &
  & 0.17797660E-07_JPRB, 0.19518890E-07_JPRB, 0.21665840E-07_JPRB, 0.24918461E-07_JPRB, 0.28105744E-07_JPRB, 0.31193366E-07_JPRB, &
  & 0.34738841E-07_JPRB, 0.37741582E-07_JPRB, 0.40156491E-07_JPRB, 0.41673303E-07_JPRB, 0.42032173E-07_JPRB, 0.41005247E-07_JPRB, &
  & 0.39085381E-07_JPRB, 0.37867365E-07_JPRB, 0.36526598E-07_JPRB, 0.34700371E-07_JPRB, 0.33459725E-07_JPRB, 0.32708996E-07_JPRB, &
  & 0.32529311E-07_JPRB, 0.32376689E-07_JPRB, 0.32857541E-07_JPRB, 0.33756853E-07_JPRB, 0.34562626E-07_JPRB, 0.35432261E-07_JPRB, &
  & 0.35340557E-07_JPRB, 0.34628428E-07_JPRB, 0.32720877E-07_JPRB, 0.30386941E-07_JPRB  /)

RGHG7(:,75, 8) = (/ &
  & 0.17322209E-07_JPRB, 0.16394913E-07_JPRB, 0.15518208E-07_JPRB, 0.14989475E-07_JPRB, 0.14789204E-07_JPRB, 0.14230731E-07_JPRB, &
  & 0.13715139E-07_JPRB, 0.13095689E-07_JPRB, 0.12696628E-07_JPRB, 0.13279226E-07_JPRB, 0.13676970E-07_JPRB, 0.14118805E-07_JPRB, &
  & 0.14479671E-07_JPRB, 0.14959205E-07_JPRB, 0.15640991E-07_JPRB, 0.16231688E-07_JPRB, 0.17080706E-07_JPRB, 0.17896779E-07_JPRB, &
  & 0.19034836E-07_JPRB, 0.20263524E-07_JPRB, 0.21658402E-07_JPRB, 0.23098785E-07_JPRB, 0.24560451E-07_JPRB, 0.25586196E-07_JPRB, &
  & 0.26165687E-07_JPRB, 0.26015995E-07_JPRB, 0.25713297E-07_JPRB, 0.25357035E-07_JPRB, 0.25582589E-07_JPRB, 0.24642571E-07_JPRB, &
  & 0.22465270E-07_JPRB, 0.20272883E-07_JPRB, 0.17641181E-07_JPRB, 0.15452336E-07_JPRB, 0.14599207E-07_JPRB, 0.15318904E-07_JPRB, &
  & 0.16822217E-07_JPRB, 0.18426621E-07_JPRB, 0.20486364E-07_JPRB, 0.23692086E-07_JPRB, 0.26928434E-07_JPRB, 0.29804353E-07_JPRB, &
  & 0.33258510E-07_JPRB, 0.36313934E-07_JPRB, 0.38734075E-07_JPRB, 0.40229439E-07_JPRB, 0.40575937E-07_JPRB, 0.39474776E-07_JPRB, &
  & 0.37569928E-07_JPRB, 0.36272770E-07_JPRB, 0.34902665E-07_JPRB, 0.33045498E-07_JPRB, 0.31857924E-07_JPRB, 0.31099611E-07_JPRB, &
  & 0.31011661E-07_JPRB, 0.31014448E-07_JPRB, 0.31719087E-07_JPRB, 0.32807447E-07_JPRB, 0.33661777E-07_JPRB, 0.34542828E-07_JPRB, &
  & 0.34501443E-07_JPRB, 0.33564770E-07_JPRB, 0.31463253E-07_JPRB, 0.29048086E-07_JPRB  /)

RGHG7(:,76, 8) = (/ &
  & 0.16914891E-07_JPRB, 0.15953519E-07_JPRB, 0.15048075E-07_JPRB, 0.14493888E-07_JPRB, 0.14293617E-07_JPRB, 0.13704763E-07_JPRB, &
  & 0.13177676E-07_JPRB, 0.12461336E-07_JPRB, 0.12028199E-07_JPRB, 0.12641588E-07_JPRB, 0.13043027E-07_JPRB, 0.13458586E-07_JPRB, &
  & 0.13804261E-07_JPRB, 0.14232067E-07_JPRB, 0.14833794E-07_JPRB, 0.15387952E-07_JPRB, 0.16169639E-07_JPRB, 0.16909759E-07_JPRB, &
  & 0.17954211E-07_JPRB, 0.19103251E-07_JPRB, 0.20376195E-07_JPRB, 0.21604731E-07_JPRB, 0.22834845E-07_JPRB, 0.23627396E-07_JPRB, &
  & 0.24114102E-07_JPRB, 0.24127400E-07_JPRB, 0.24077603E-07_JPRB, 0.23897058E-07_JPRB, 0.24129181E-07_JPRB, 0.23327929E-07_JPRB, &
  & 0.21371506E-07_JPRB, 0.19546565E-07_JPRB, 0.17061431E-07_JPRB, 0.15006426E-07_JPRB, 0.14144676E-07_JPRB, 0.14688655E-07_JPRB, &
  & 0.16055665E-07_JPRB, 0.17536081E-07_JPRB, 0.19452952E-07_JPRB, 0.22606534E-07_JPRB, 0.25826459E-07_JPRB, 0.28621910E-07_JPRB, &
  & 0.31937711E-07_JPRB, 0.35009146E-07_JPRB, 0.37456794E-07_JPRB, 0.39005941E-07_JPRB, 0.39310973E-07_JPRB, 0.38085824E-07_JPRB, &
  & 0.36207252E-07_JPRB, 0.34787749E-07_JPRB, 0.33370841E-07_JPRB, 0.31528865E-07_JPRB, 0.30368386E-07_JPRB, 0.29589136E-07_JPRB, &
  & 0.29532387E-07_JPRB, 0.29669425E-07_JPRB, 0.30575646E-07_JPRB, 0.31794973E-07_JPRB, 0.32697749E-07_JPRB, 0.33575925E-07_JPRB, &
  & 0.33562459E-07_JPRB, 0.32413940E-07_JPRB, 0.30219638E-07_JPRB, 0.27852095E-07_JPRB  /)

RGHG7(:,77, 8) = (/ &
  & 0.16503099E-07_JPRB, 0.15493738E-07_JPRB, 0.14568623E-07_JPRB, 0.14006390E-07_JPRB, 0.13810069E-07_JPRB, 0.13201853E-07_JPRB, &
  & 0.12655997E-07_JPRB, 0.11870213E-07_JPRB, 0.11396590E-07_JPRB, 0.12014355E-07_JPRB, 0.12434549E-07_JPRB, 0.12840045E-07_JPRB, &
  & 0.13207436E-07_JPRB, 0.13611603E-07_JPRB, 0.14153456E-07_JPRB, 0.14679637E-07_JPRB, 0.15435684E-07_JPRB, 0.16122859E-07_JPRB, &
  & 0.17045513E-07_JPRB, 0.18103502E-07_JPRB, 0.19238949E-07_JPRB, 0.20305537E-07_JPRB, 0.21421246E-07_JPRB, 0.22181057E-07_JPRB, &
  & 0.22676334E-07_JPRB, 0.22893256E-07_JPRB, 0.22932914E-07_JPRB, 0.22806192E-07_JPRB, 0.22959674E-07_JPRB, 0.22234402E-07_JPRB, &
  & 0.20350752E-07_JPRB, 0.18790290E-07_JPRB, 0.16627187E-07_JPRB, 0.14709118E-07_JPRB, 0.13793996E-07_JPRB, 0.14224914E-07_JPRB, &
  & 0.15512124E-07_JPRB, 0.16917729E-07_JPRB, 0.18717333E-07_JPRB, 0.21699948E-07_JPRB, 0.24851482E-07_JPRB, 0.27676685E-07_JPRB, &
  & 0.30830829E-07_JPRB, 0.33925218E-07_JPRB, 0.36526352E-07_JPRB, 0.38168356E-07_JPRB, 0.38320752E-07_JPRB, 0.36903499E-07_JPRB, &
  & 0.35061055E-07_JPRB, 0.33526940E-07_JPRB, 0.32106397E-07_JPRB, 0.30250209E-07_JPRB, 0.29064689E-07_JPRB, 0.28248799E-07_JPRB, &
  & 0.28181441E-07_JPRB, 0.28271400E-07_JPRB, 0.29310993E-07_JPRB, 0.30603521E-07_JPRB, 0.31622966E-07_JPRB, 0.32529426E-07_JPRB, &
  & 0.32470425E-07_JPRB, 0.31069520E-07_JPRB, 0.28807568E-07_JPRB, 0.26675919E-07_JPRB  /)

RGHG7(:,78, 8) = (/ &
  & 0.16095446E-07_JPRB, 0.15038566E-07_JPRB, 0.14112862E-07_JPRB, 0.13548065E-07_JPRB, 0.13354838E-07_JPRB, 0.12734814E-07_JPRB, &
  & 0.12163514E-07_JPRB, 0.11329885E-07_JPRB, 0.10811343E-07_JPRB, 0.11428841E-07_JPRB, 0.11850040E-07_JPRB, 0.12252483E-07_JPRB, &
  & 0.12668395E-07_JPRB, 0.13064042E-07_JPRB, 0.13574325E-07_JPRB, 0.14088439E-07_JPRB, 0.14787919E-07_JPRB, 0.15448201E-07_JPRB, &
  & 0.16307189E-07_JPRB, 0.17299749E-07_JPRB, 0.18316127E-07_JPRB, 0.19299472E-07_JPRB, 0.20354714E-07_JPRB, 0.21106420E-07_JPRB, &
  & 0.21612377E-07_JPRB, 0.21928370E-07_JPRB, 0.22000301E-07_JPRB, 0.21881890E-07_JPRB, 0.21966348E-07_JPRB, 0.21258584E-07_JPRB, &
  & 0.19395395E-07_JPRB, 0.18074521E-07_JPRB, 0.16251162E-07_JPRB, 0.14463079E-07_JPRB, 0.13513476E-07_JPRB, 0.13883323E-07_JPRB, &
  & 0.15113441E-07_JPRB, 0.16491376E-07_JPRB, 0.18244571E-07_JPRB, 0.21111132E-07_JPRB, 0.24127150E-07_JPRB, 0.26957122E-07_JPRB, &
  & 0.30011595E-07_JPRB, 0.33150916E-07_JPRB, 0.35879374E-07_JPRB, 0.37600177E-07_JPRB, 0.37592799E-07_JPRB, 0.36043339E-07_JPRB, &
  & 0.34164717E-07_JPRB, 0.32513402E-07_JPRB, 0.31052216E-07_JPRB, 0.29154338E-07_JPRB, 0.27909799E-07_JPRB, 0.27058658E-07_JPRB, &
  & 0.26942203E-07_JPRB, 0.26929538E-07_JPRB, 0.28006501E-07_JPRB, 0.29319864E-07_JPRB, 0.30448986E-07_JPRB, 0.31367360E-07_JPRB, &
  & 0.31222461E-07_JPRB, 0.29598812E-07_JPRB, 0.27300725E-07_JPRB, 0.25425822E-07_JPRB  /)

RGHG7(:,79, 8) = (/ &
  & 0.15685429E-07_JPRB, 0.14590181E-07_JPRB, 0.13681497E-07_JPRB, 0.13120914E-07_JPRB, 0.12929375E-07_JPRB, 0.12306639E-07_JPRB, &
  & 0.11703405E-07_JPRB, 0.10837124E-07_JPRB, 0.10275061E-07_JPRB, 0.10882990E-07_JPRB, 0.11303513E-07_JPRB, 0.11707159E-07_JPRB, &
  & 0.12186610E-07_JPRB, 0.12586961E-07_JPRB, 0.13083114E-07_JPRB, 0.13593134E-07_JPRB, 0.14239710E-07_JPRB, 0.14893642E-07_JPRB, &
  & 0.15727375E-07_JPRB, 0.16683907E-07_JPRB, 0.17622263E-07_JPRB, 0.18564499E-07_JPRB, 0.19583923E-07_JPRB, 0.20327316E-07_JPRB, &
  & 0.20836546E-07_JPRB, 0.21171589E-07_JPRB, 0.21238205E-07_JPRB, 0.21102480E-07_JPRB, 0.21113991E-07_JPRB, 0.20404977E-07_JPRB, &
  & 0.18586751E-07_JPRB, 0.17463670E-07_JPRB, 0.15935542E-07_JPRB, 0.14263646E-07_JPRB, 0.13301092E-07_JPRB, 0.13650262E-07_JPRB, &
  & 0.14839283E-07_JPRB, 0.16215135E-07_JPRB, 0.17970263E-07_JPRB, 0.20780376E-07_JPRB, 0.23678084E-07_JPRB, 0.26476953E-07_JPRB, &
  & 0.29446635E-07_JPRB, 0.32628591E-07_JPRB, 0.35461817E-07_JPRB, 0.37238170E-07_JPRB, 0.37081911E-07_JPRB, 0.35449682E-07_JPRB, &
  & 0.33491207E-07_JPRB, 0.31716901E-07_JPRB, 0.30186496E-07_JPRB, 0.28226269E-07_JPRB, 0.26892696E-07_JPRB, 0.25999398E-07_JPRB, &
  & 0.25823445E-07_JPRB, 0.25660910E-07_JPRB, 0.26686142E-07_JPRB, 0.27991300E-07_JPRB, 0.29208121E-07_JPRB, 0.30140391E-07_JPRB, &
  & 0.29875015E-07_JPRB, 0.28118207E-07_JPRB, 0.25815476E-07_JPRB, 0.24153401E-07_JPRB  /)

RGHG7(:,80, 8) = (/ &
  & 0.15266841E-07_JPRB, 0.14150362E-07_JPRB, 0.13273535E-07_JPRB, 0.12725783E-07_JPRB, 0.12534203E-07_JPRB, 0.11919560E-07_JPRB, &
  & 0.11278233E-07_JPRB, 0.10387329E-07_JPRB, 0.97897441E-08_JPRB, 0.10372614E-07_JPRB, 0.10810952E-07_JPRB, 0.11217012E-07_JPRB, &
  & 0.11761787E-07_JPRB, 0.12178185E-07_JPRB, 0.12664712E-07_JPRB, 0.13168956E-07_JPRB, 0.13810033E-07_JPRB, 0.14471198E-07_JPRB, &
  & 0.15289183E-07_JPRB, 0.16240449E-07_JPRB, 0.17164212E-07_JPRB, 0.18063209E-07_JPRB, 0.19042244E-07_JPRB, 0.19760982E-07_JPRB, &
  & 0.20262202E-07_JPRB, 0.20575329E-07_JPRB, 0.20615103E-07_JPRB, 0.20454545E-07_JPRB, 0.20366566E-07_JPRB, 0.19682059E-07_JPRB, &
  & 0.18014034E-07_JPRB, 0.17023972E-07_JPRB, 0.15687864E-07_JPRB, 0.14111047E-07_JPRB, 0.13155104E-07_JPRB, 0.13510485E-07_JPRB, &
  & 0.14668795E-07_JPRB, 0.16043574E-07_JPRB, 0.17819710E-07_JPRB, 0.20625683E-07_JPRB, 0.23518106E-07_JPRB, 0.26247171E-07_JPRB, &
  & 0.29087995E-07_JPRB, 0.32281883E-07_JPRB, 0.35212214E-07_JPRB, 0.37014651E-07_JPRB, 0.36733279E-07_JPRB, 0.35046738E-07_JPRB, &
  & 0.33003251E-07_JPRB, 0.31097838E-07_JPRB, 0.29485333E-07_JPRB, 0.27450158E-07_JPRB, 0.26001550E-07_JPRB, 0.25049007E-07_JPRB, &
  & 0.24834823E-07_JPRB, 0.24476910E-07_JPRB, 0.25373914E-07_JPRB, 0.26670492E-07_JPRB, 0.27940682E-07_JPRB, 0.28913750E-07_JPRB, &
  & 0.28497780E-07_JPRB, 0.26759073E-07_JPRB, 0.24482497E-07_JPRB, 0.22926902E-07_JPRB  /)

RGHG7(:,81, 8) = (/ &
  & 0.14788638E-07_JPRB, 0.13716064E-07_JPRB, 0.12875544E-07_JPRB, 0.12362410E-07_JPRB, 0.12174208E-07_JPRB, 0.11575185E-07_JPRB, &
  & 0.10899662E-07_JPRB, 0.99906044E-08_JPRB, 0.93516468E-08_JPRB, 0.98838556E-08_JPRB, 0.10355545E-07_JPRB, 0.10801712E-07_JPRB, &
  & 0.11422901E-07_JPRB, 0.11881938E-07_JPRB, 0.12342712E-07_JPRB, 0.12845268E-07_JPRB, 0.13496054E-07_JPRB, 0.14175373E-07_JPRB, &
  & 0.14994624E-07_JPRB, 0.15936181E-07_JPRB, 0.16868387E-07_JPRB, 0.17747964E-07_JPRB, 0.18677183E-07_JPRB, 0.19346105E-07_JPRB, &
  & 0.19824949E-07_JPRB, 0.20101347E-07_JPRB, 0.20101015E-07_JPRB, 0.19905416E-07_JPRB, 0.19827569E-07_JPRB, 0.19205122E-07_JPRB, &
  & 0.17613510E-07_JPRB, 0.16682553E-07_JPRB, 0.15457053E-07_JPRB, 0.13995490E-07_JPRB, 0.13075009E-07_JPRB, 0.13464587E-07_JPRB, &
  & 0.14594612E-07_JPRB, 0.15955458E-07_JPRB, 0.17740460E-07_JPRB, 0.20546433E-07_JPRB, 0.23465031E-07_JPRB, 0.26145968E-07_JPRB, &
  & 0.28857185E-07_JPRB, 0.32057405E-07_JPRB, 0.35037975E-07_JPRB, 0.36840412E-07_JPRB, 0.36496559E-07_JPRB, 0.34747536E-07_JPRB, &
  & 0.32646633E-07_JPRB, 0.30592193E-07_JPRB, 0.28886809E-07_JPRB, 0.26783664E-07_JPRB, 0.25226558E-07_JPRB, 0.24208578E-07_JPRB, &
  & 0.23971597E-07_JPRB, 0.23472678E-07_JPRB, 0.24153529E-07_JPRB, 0.25268994E-07_JPRB, 0.26645573E-07_JPRB, 0.27565869E-07_JPRB, &
  & 0.27071797E-07_JPRB, 0.25342800E-07_JPRB, 0.23060313E-07_JPRB, 0.21670210E-07_JPRB  /)

RGHG7(:,82, 8) = (/ &
  & 0.14288888E-07_JPRB, 0.13306478E-07_JPRB, 0.12486035E-07_JPRB, 0.12020097E-07_JPRB, 0.11844558E-07_JPRB, 0.11252330E-07_JPRB, &
  & 0.10546610E-07_JPRB, 0.96308590E-08_JPRB, 0.89481748E-08_JPRB, 0.94457528E-08_JPRB, 0.99517446E-08_JPRB, 0.10474120E-07_JPRB, &
  & 0.11171815E-07_JPRB, 0.11644134E-07_JPRB, 0.12087464E-07_JPRB, 0.12596486E-07_JPRB, 0.13255175E-07_JPRB, 0.13949332E-07_JPRB, &
  & 0.14773332E-07_JPRB, 0.15700587E-07_JPRB, 0.16640892E-07_JPRB, 0.17497682E-07_JPRB, 0.18387001E-07_JPRB, 0.19013987E-07_JPRB, &
  & 0.19459546E-07_JPRB, 0.19720974E-07_JPRB, 0.19690680E-07_JPRB, 0.19482952E-07_JPRB, 0.19450367E-07_JPRB, 0.18838682E-07_JPRB, &
  & 0.17265986E-07_JPRB, 0.16362634E-07_JPRB, 0.15223769E-07_JPRB, 0.13879631E-07_JPRB, 0.13019110E-07_JPRB, 0.13468262E-07_JPRB, &
  & 0.14564073E-07_JPRB, 0.15883736E-07_JPRB, 0.17673475E-07_JPRB, 0.20458215E-07_JPRB, 0.23395549E-07_JPRB, 0.26029538E-07_JPRB, &
  & 0.28652987E-07_JPRB, 0.31887712E-07_JPRB, 0.34870208E-07_JPRB, 0.36642105E-07_JPRB, 0.36270781E-07_JPRB, 0.34467529E-07_JPRB, &
  & 0.32304923E-07_JPRB, 0.30136729E-07_JPRB, 0.28305321E-07_JPRB, 0.26140166E-07_JPRB, 0.24481653E-07_JPRB, 0.23433558E-07_JPRB, &
  & 0.23215518E-07_JPRB, 0.22604416E-07_JPRB, 0.23053625E-07_JPRB, 0.23950740E-07_JPRB, 0.25327444E-07_JPRB, 0.26154876E-07_JPRB, &
  & 0.25589599E-07_JPRB, 0.23894682E-07_JPRB, 0.21705507E-07_JPRB, 0.20625270E-07_JPRB  /)

RGHG7(:,83, 8) = (/ &
  & 0.13759074E-07_JPRB, 0.12913065E-07_JPRB, 0.12098267E-07_JPRB, 0.11691669E-07_JPRB, 0.11537440E-07_JPRB, 0.10940551E-07_JPRB, &
  & 0.10203324E-07_JPRB, 0.92957373E-08_JPRB, 0.85730565E-08_JPRB, 0.90518819E-08_JPRB, 0.96073838E-08_JPRB, 0.10223204E-07_JPRB, &
  & 0.10986870E-07_JPRB, 0.11458477E-07_JPRB, 0.11890336E-07_JPRB, 0.12408213E-07_JPRB, 0.13076552E-07_JPRB, 0.13779992E-07_JPRB, &
  & 0.14604430E-07_JPRB, 0.15517235E-07_JPRB, 0.16464799E-07_JPRB, 0.17300364E-07_JPRB, 0.18156904E-07_JPRB, 0.18753516E-07_JPRB, &
  & 0.19168635E-07_JPRB, 0.19418532E-07_JPRB, 0.19373015E-07_JPRB, 0.19174165E-07_JPRB, 0.19191582E-07_JPRB, 0.18568894E-07_JPRB, &
  & 0.16988670E-07_JPRB, 0.16084543E-07_JPRB, 0.15016066E-07_JPRB, 0.13782234E-07_JPRB, 0.12995073E-07_JPRB, 0.13526929E-07_JPRB, &
  & 0.14577434E-07_JPRB, 0.15835891E-07_JPRB, 0.17620808E-07_JPRB, 0.20370832E-07_JPRB, 0.23325490E-07_JPRB, 0.25917174E-07_JPRB, &
  & 0.28478985E-07_JPRB, 0.31730490E-07_JPRB, 0.34692240E-07_JPRB, 0.36398708E-07_JPRB, 0.36026439E-07_JPRB, 0.34175595E-07_JPRB, &
  & 0.31952340E-07_JPRB, 0.29702346E-07_JPRB, 0.27744870E-07_JPRB, 0.25520648E-07_JPRB, 0.23770023E-07_JPRB, 0.22698990E-07_JPRB, &
  & 0.22530700E-07_JPRB, 0.21833167E-07_JPRB, 0.22058328E-07_JPRB, 0.22678099E-07_JPRB, 0.23940795E-07_JPRB, 0.24619903E-07_JPRB, &
  & 0.23977801E-07_JPRB, 0.22365096E-07_JPRB, 0.20426504E-07_JPRB, 0.19723108E-07_JPRB  /)

RGHG7(:,84, 8) = (/ &
  & 0.13195936E-07_JPRB, 0.12527314E-07_JPRB, 0.11707157E-07_JPRB, 0.11370406E-07_JPRB, 0.11244849E-07_JPRB, 0.10631789E-07_JPRB, &
  & 0.98592192E-08_JPRB, 0.89747990E-08_JPRB, 0.82220171E-08_JPRB, 0.86978548E-08_JPRB, 0.93264813E-08_JPRB, 0.10037496E-07_JPRB, &
  & 0.10848582E-07_JPRB, 0.11316813E-07_JPRB, 0.11741441E-07_JPRB, 0.12266085E-07_JPRB, 0.12947496E-07_JPRB, 0.13653755E-07_JPRB, &
  & 0.14469253E-07_JPRB, 0.15370044E-07_JPRB, 0.16323351E-07_JPRB, 0.17142745E-07_JPRB, 0.17970894E-07_JPRB, 0.18550131E-07_JPRB, &
  & 0.18946978E-07_JPRB, 0.19175279E-07_JPRB, 0.19130557E-07_JPRB, 0.18957739E-07_JPRB, 0.19006891E-07_JPRB, 0.18374847E-07_JPRB, &
  & 0.16785676E-07_JPRB, 0.15859196E-07_JPRB, 0.14850918E-07_JPRB, 0.13711356E-07_JPRB, 0.12997663E-07_JPRB, 0.13625597E-07_JPRB, &
  & 0.14619130E-07_JPRB, 0.15808444E-07_JPRB, 0.17575661E-07_JPRB, 0.20285677E-07_JPRB, 0.23259307E-07_JPRB, 0.25816339E-07_JPRB, &
  & 0.28329484E-07_JPRB, 0.31547602E-07_JPRB, 0.34483164E-07_JPRB, 0.36090725E-07_JPRB, 0.35737856E-07_JPRB, 0.33844372E-07_JPRB, &
  & 0.31568105E-07_JPRB, 0.29263699E-07_JPRB, 0.27205501E-07_JPRB, 0.24922960E-07_JPRB, 0.23091277E-07_JPRB, 0.21985439E-07_JPRB, &
  & 0.21887197E-07_JPRB, 0.21125336E-07_JPRB, 0.21154638E-07_JPRB, 0.21429273E-07_JPRB, 0.22469227E-07_JPRB, 0.22947448E-07_JPRB, &
  & 0.22222778E-07_JPRB, 0.20757660E-07_JPRB, 0.19234877E-07_JPRB, 0.18905876E-07_JPRB  /)

RGHG7(:,85, 8) = (/ &
  & 0.12543000E-07_JPRB, 0.12082056E-07_JPRB, 0.11262325E-07_JPRB, 0.11006858E-07_JPRB, 0.10917049E-07_JPRB, 0.10290796E-07_JPRB, &
  & 0.94931179E-08_JPRB, 0.86295508E-08_JPRB, 0.78814501E-08_JPRB, 0.83845243E-08_JPRB, 0.91042232E-08_JPRB, 0.99152475E-08_JPRB, &
  & 0.10747611E-07_JPRB, 0.11197969E-07_JPRB, 0.11623874E-07_JPRB, 0.12152348E-07_JPRB, 0.12840142E-07_JPRB, 0.13548529E-07_JPRB, &
  & 0.14349558E-07_JPRB, 0.15229496E-07_JPRB, 0.16182377E-07_JPRB, 0.16988579E-07_JPRB, 0.17785661E-07_JPRB, 0.18350854E-07_JPRB, &
  & 0.18731529E-07_JPRB, 0.18926635E-07_JPRB, 0.18882339E-07_JPRB, 0.18739737E-07_JPRB, 0.18798677E-07_JPRB, 0.18164505E-07_JPRB, &
  & 0.16573632E-07_JPRB, 0.15639917E-07_JPRB, 0.14680154E-07_JPRB, 0.13592938E-07_JPRB, 0.12898821E-07_JPRB, 0.13551438E-07_JPRB, &
  & 0.14505392E-07_JPRB, 0.15689600E-07_JPRB, 0.17424473E-07_JPRB, 0.20108530E-07_JPRB, 0.23084287E-07_JPRB, 0.25621317E-07_JPRB, &
  & 0.28092331E-07_JPRB, 0.31221504E-07_JPRB, 0.34079186E-07_JPRB, 0.35576099E-07_JPRB, 0.35290470E-07_JPRB, 0.33352727E-07_JPRB, &
  & 0.31064544E-07_JPRB, 0.28724816E-07_JPRB, 0.26596399E-07_JPRB, 0.24251723E-07_JPRB, 0.22350672E-07_JPRB, 0.21222279E-07_JPRB, &
  & 0.21215110E-07_JPRB, 0.20406436E-07_JPRB, 0.20305088E-07_JPRB, 0.20171174E-07_JPRB, 0.20907269E-07_JPRB, 0.21260798E-07_JPRB, &
  & 0.20563790E-07_JPRB, 0.19374017E-07_JPRB, 0.18129557E-07_JPRB, 0.18093776E-07_JPRB  /)

RGHG7(:,86, 8) = (/ &
  & 0.11816965E-07_JPRB, 0.11545102E-07_JPRB, 0.10734457E-07_JPRB, 0.10574006E-07_JPRB, 0.10518461E-07_JPRB, 0.99215752E-08_JPRB, &
  & 0.90963301E-08_JPRB, 0.82517232E-08_JPRB, 0.75649410E-08_JPRB, 0.81103755E-08_JPRB, 0.89355939E-08_JPRB, 0.98321470E-08_JPRB, &
  & 0.10672576E-07_JPRB, 0.11107633E-07_JPRB, 0.11532158E-07_JPRB, 0.12058153E-07_JPRB, 0.12752031E-07_JPRB, 0.13459226E-07_JPRB, &
  & 0.14242382E-07_JPRB, 0.15088041E-07_JPRB, 0.16024176E-07_JPRB, 0.16811124E-07_JPRB, 0.17582977E-07_JPRB, 0.18121400E-07_JPRB, &
  & 0.18487154E-07_JPRB, 0.18648565E-07_JPRB, 0.18590709E-07_JPRB, 0.18499789E-07_JPRB, 0.18571564E-07_JPRB, 0.17931923E-07_JPRB, &
  & 0.16361984E-07_JPRB, 0.15434319E-07_JPRB, 0.14502337E-07_JPRB, 0.13466398E-07_JPRB, 0.12785628E-07_JPRB, 0.13442074E-07_JPRB, &
  & 0.14352586E-07_JPRB, 0.15526000E-07_JPRB, 0.17225036E-07_JPRB, 0.19867350E-07_JPRB, 0.22778974E-07_JPRB, 0.25280582E-07_JPRB, &
  & 0.27731231E-07_JPRB, 0.30769345E-07_JPRB, 0.33466498E-07_JPRB, 0.34856532E-07_JPRB, 0.34636818E-07_JPRB, 0.32606637E-07_JPRB, &
  & 0.30367420E-07_JPRB, 0.28026493E-07_JPRB, 0.25883782E-07_JPRB, 0.23496307E-07_JPRB, 0.21516879E-07_JPRB, 0.20358823E-07_JPRB, &
  & 0.20468496E-07_JPRB, 0.19651736E-07_JPRB, 0.19443388E-07_JPRB, 0.18867889E-07_JPRB, 0.19379515E-07_JPRB, 0.19685980E-07_JPRB, &
  & 0.19064064E-07_JPRB, 0.18170343E-07_JPRB, 0.17291866E-07_JPRB, 0.17546123E-07_JPRB  /)

RGHG7(:,87, 8) = (/ &
  & 0.10996175E-07_JPRB, 0.10891162E-07_JPRB, 0.10084928E-07_JPRB, 0.10018397E-07_JPRB, 0.10027769E-07_JPRB, 0.95080559E-08_JPRB, &
  & 0.86594612E-08_JPRB, 0.78679031E-08_JPRB, 0.72737188E-08_JPRB, 0.78837996E-08_JPRB, 0.88084753E-08_JPRB, 0.97713799E-08_JPRB, &
  & 0.10615266E-07_JPRB, 0.11039101E-07_JPRB, 0.11456797E-07_JPRB, 0.11977562E-07_JPRB, 0.12676634E-07_JPRB, 0.13380548E-07_JPRB, &
  & 0.14140820E-07_JPRB, 0.14937395E-07_JPRB, 0.15832519E-07_JPRB, 0.16583546E-07_JPRB, 0.17335276E-07_JPRB, 0.17841969E-07_JPRB, &
  & 0.18190735E-07_JPRB, 0.18324702E-07_JPRB, 0.18264113E-07_JPRB, 0.18234277E-07_JPRB, 0.18307093E-07_JPRB, 0.17649627E-07_JPRB, &
  & 0.16126560E-07_JPRB, 0.15206226E-07_JPRB, 0.14286642E-07_JPRB, 0.13316367E-07_JPRB, 0.12645775E-07_JPRB, 0.13298274E-07_JPRB, &
  & 0.14162500E-07_JPRB, 0.15306241E-07_JPRB, 0.16964148E-07_JPRB, 0.19552894E-07_JPRB, 0.22340330E-07_JPRB, 0.24748099E-07_JPRB, &
  & 0.27212795E-07_JPRB, 0.30125349E-07_JPRB, 0.32621071E-07_JPRB, 0.33878305E-07_JPRB, 0.33700001E-07_JPRB, 0.31550112E-07_JPRB, &
  & 0.29421023E-07_JPRB, 0.27119384E-07_JPRB, 0.25024532E-07_JPRB, 0.22615672E-07_JPRB, 0.20578087E-07_JPRB, 0.19392985E-07_JPRB, &
  & 0.19594933E-07_JPRB, 0.18797401E-07_JPRB, 0.18516891E-07_JPRB, 0.17499257E-07_JPRB, 0.17886543E-07_JPRB, 0.18181561E-07_JPRB, &
  & 0.17707884E-07_JPRB, 0.17077849E-07_JPRB, 0.16695772E-07_JPRB, 0.17182279E-07_JPRB  /)

RGHG7(:,88, 8) = (/ &
  & 0.10033145E-07_JPRB, 0.10095991E-07_JPRB, 0.92903031E-08_JPRB, 0.92740129E-08_JPRB, 0.94055703E-08_JPRB, 0.90152429E-08_JPRB, &
  & 0.81759712E-08_JPRB, 0.74984776E-08_JPRB, 0.70136065E-08_JPRB, 0.77099487E-08_JPRB, 0.87154563E-08_JPRB, 0.97241258E-08_JPRB, &
  & 0.10570087E-07_JPRB, 0.10985994E-07_JPRB, 0.11392646E-07_JPRB, 0.11905731E-07_JPRB, 0.12606864E-07_JPRB, 0.13304263E-07_JPRB, &
  & 0.14035209E-07_JPRB, 0.14766892E-07_JPRB, 0.15586449E-07_JPRB, 0.16280698E-07_JPRB, 0.17003870E-07_JPRB, 0.17480239E-07_JPRB, &
  & 0.17806759E-07_JPRB, 0.17932905E-07_JPRB, 0.17890760E-07_JPRB, 0.17926304E-07_JPRB, 0.17976807E-07_JPRB, 0.17285644E-07_JPRB, &
  & 0.15835149E-07_JPRB, 0.14916544E-07_JPRB, 0.13997786E-07_JPRB, 0.13113856E-07_JPRB, 0.12460881E-07_JPRB, 0.13106286E-07_JPRB, &
  & 0.13927469E-07_JPRB, 0.15016169E-07_JPRB, 0.16618041E-07_JPRB, 0.19132599E-07_JPRB, 0.21732707E-07_JPRB, 0.23973705E-07_JPRB, &
  & 0.26467080E-07_JPRB, 0.29203855E-07_JPRB, 0.31454905E-07_JPRB, 0.32522540E-07_JPRB, 0.32339637E-07_JPRB, 0.30062955E-07_JPRB, &
  & 0.28118145E-07_JPRB, 0.25896123E-07_JPRB, 0.23928650E-07_JPRB, 0.21551872E-07_JPRB, 0.19506652E-07_JPRB, 0.18277906E-07_JPRB, &
  & 0.18529671E-07_JPRB, 0.17757400E-07_JPRB, 0.17442467E-07_JPRB, 0.16007001E-07_JPRB, 0.16386753E-07_JPRB, 0.16732200E-07_JPRB, &
  & 0.16474070E-07_JPRB, 0.16047307E-07_JPRB, 0.16304111E-07_JPRB, 0.16948635E-07_JPRB  /)

RGHG7(:,89, 8) = (/ &
  & 0.89043289E-08_JPRB, 0.91924783E-08_JPRB, 0.84022897E-08_JPRB, 0.83110717E-08_JPRB, 0.86218321E-08_JPRB, 0.84193788E-08_JPRB, &
  & 0.76892892E-08_JPRB, 0.71856458E-08_JPRB, 0.68097601E-08_JPRB, 0.75946886E-08_JPRB, 0.86505475E-08_JPRB, 0.96862657E-08_JPRB, &
  & 0.10532456E-07_JPRB, 0.10940923E-07_JPRB, 0.11338104E-07_JPRB, 0.11840060E-07_JPRB, 0.12537522E-07_JPRB, 0.13220652E-07_JPRB, &
  & 0.13913644E-07_JPRB, 0.14571154E-07_JPRB, 0.15272133E-07_JPRB, 0.15896480E-07_JPRB, 0.16556647E-07_JPRB, 0.17006135E-07_JPRB, &
  & 0.17306368E-07_JPRB, 0.17465716E-07_JPRB, 0.17462682E-07_JPRB, 0.17563505E-07_JPRB, 0.17565530E-07_JPRB, 0.16833282E-07_JPRB, &
  & 0.15464619E-07_JPRB, 0.14536677E-07_JPRB, 0.13615588E-07_JPRB, 0.12829477E-07_JPRB, 0.12218749E-07_JPRB, 0.12853668E-07_JPRB, &
  & 0.13649828E-07_JPRB, 0.14667186E-07_JPRB, 0.16174397E-07_JPRB, 0.18574156E-07_JPRB, 0.20935984E-07_JPRB, 0.22965232E-07_JPRB, &
  & 0.25429483E-07_JPRB, 0.27943394E-07_JPRB, 0.29877279E-07_JPRB, 0.30687145E-07_JPRB, 0.30428974E-07_JPRB, 0.28060588E-07_JPRB, &
  & 0.26370873E-07_JPRB, 0.24256059E-07_JPRB, 0.22516425E-07_JPRB, 0.20296640E-07_JPRB, 0.18335518E-07_JPRB, 0.17003774E-07_JPRB, &
  & 0.17256594E-07_JPRB, 0.16470045E-07_JPRB, 0.16156474E-07_JPRB, 0.14418544E-07_JPRB, 0.14915138E-07_JPRB, 0.15434922E-07_JPRB, &
  & 0.15403842E-07_JPRB, 0.15097158E-07_JPRB, 0.16051997E-07_JPRB, 0.16794373E-07_JPRB  /)

RGHG7(:,90, 8) = (/ &
  & 0.76194857E-08_JPRB, 0.82597982E-08_JPRB, 0.75247580E-08_JPRB, 0.72058974E-08_JPRB, 0.76382943E-08_JPRB, 0.77596252E-08_JPRB, &
  & 0.73247036E-08_JPRB, 0.69500070E-08_JPRB, 0.66788221E-08_JPRB, 0.75220926E-08_JPRB, 0.85990214E-08_JPRB, 0.96519562E-08_JPRB, &
  & 0.10496561E-07_JPRB, 0.10898571E-07_JPRB, 0.11286259E-07_JPRB, 0.11778788E-07_JPRB, 0.12476314E-07_JPRB, 0.13128043E-07_JPRB, &
  & 0.13758246E-07_JPRB, 0.14348729E-07_JPRB, 0.14887789E-07_JPRB, 0.15446463E-07_JPRB, 0.16014473E-07_JPRB, 0.16398909E-07_JPRB, &
  & 0.16692008E-07_JPRB, 0.16921479E-07_JPRB, 0.16985814E-07_JPRB, 0.17155034E-07_JPRB, 0.17123394E-07_JPRB, 0.16375420E-07_JPRB, &
  & 0.15053566E-07_JPRB, 0.14096657E-07_JPRB, 0.13193251E-07_JPRB, 0.12495642E-07_JPRB, 0.11942081E-07_JPRB, 0.12565904E-07_JPRB, &
  & 0.13358349E-07_JPRB, 0.14329882E-07_JPRB, 0.15651336E-07_JPRB, 0.17875003E-07_JPRB, 0.20004735E-07_JPRB, 0.21822295E-07_JPRB, &
  & 0.24103823E-07_JPRB, 0.26322889E-07_JPRB, 0.27846627E-07_JPRB, 0.28414751E-07_JPRB, 0.28004313E-07_JPRB, 0.25633225E-07_JPRB, &
  & 0.24176608E-07_JPRB, 0.22204693E-07_JPRB, 0.20803536E-07_JPRB, 0.18926038E-07_JPRB, 0.17167429E-07_JPRB, 0.15697319E-07_JPRB, &
  & 0.15823889E-07_JPRB, 0.14937271E-07_JPRB, 0.14681200E-07_JPRB, 0.13042835E-07_JPRB, 0.13769337E-07_JPRB, 0.14441472E-07_JPRB, &
  & 0.14623822E-07_JPRB, 0.14341061E-07_JPRB, 0.15878976E-07_JPRB, 0.16684081E-07_JPRB  /)

RGHG7(:,91, 8) = (/ &
  & 0.68312015E-08_JPRB, 0.78216412E-08_JPRB, 0.69496177E-08_JPRB, 0.60584947E-08_JPRB, 0.66347506E-08_JPRB, 0.71569825E-08_JPRB, &
  & 0.70140099E-08_JPRB, 0.68000968E-08_JPRB, 0.65812723E-08_JPRB, 0.74642098E-08_JPRB, 0.85496008E-08_JPRB, 0.96115269E-08_JPRB, &
  & 0.10451900E-07_JPRB, 0.10848622E-07_JPRB, 0.11226790E-07_JPRB, 0.11711914E-07_JPRB, 0.12396218E-07_JPRB, 0.13018858E-07_JPRB, &
  & 0.13560735E-07_JPRB, 0.14066596E-07_JPRB, 0.14396743E-07_JPRB, 0.14882958E-07_JPRB, 0.15397551E-07_JPRB, 0.15652937E-07_JPRB, &
  & 0.15965075E-07_JPRB, 0.16254840E-07_JPRB, 0.16368891E-07_JPRB, 0.16711589E-07_JPRB, 0.16731779E-07_JPRB, 0.16006548E-07_JPRB, &
  & 0.14696330E-07_JPRB, 0.13695522E-07_JPRB, 0.12800579E-07_JPRB, 0.12147926E-07_JPRB, 0.11673170E-07_JPRB, 0.12282713E-07_JPRB, &
  & 0.13095256E-07_JPRB, 0.14055682E-07_JPRB, 0.15163992E-07_JPRB, 0.17128501E-07_JPRB, 0.19048262E-07_JPRB, 0.20689173E-07_JPRB, &
  & 0.22746450E-07_JPRB, 0.24698953E-07_JPRB, 0.25935502E-07_JPRB, 0.25990072E-07_JPRB, 0.25628821E-07_JPRB, 0.23187919E-07_JPRB, &
  & 0.22018490E-07_JPRB, 0.20311551E-07_JPRB, 0.19225614E-07_JPRB, 0.17768058E-07_JPRB, 0.16186628E-07_JPRB, 0.14579005E-07_JPRB, &
  & 0.14446947E-07_JPRB, 0.13410123E-07_JPRB, 0.13304257E-07_JPRB, 0.12089536E-07_JPRB, 0.12941915E-07_JPRB, 0.13780651E-07_JPRB, &
  & 0.14103158E-07_JPRB, 0.13903433E-07_JPRB, 0.15720603E-07_JPRB, 0.16566433E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ---GEMS----

RGHG7(:, 1, 9) = (/ &
  & 0.80489592E-07_JPRB, 0.75164188E-07_JPRB, 0.75511217E-07_JPRB, 0.75549067E-07_JPRB, 0.75394738E-07_JPRB, 0.74630428E-07_JPRB, &
  & 0.73642425E-07_JPRB, 0.71755480E-07_JPRB, 0.70294938E-07_JPRB, 0.69501567E-07_JPRB, 0.69212042E-07_JPRB, 0.69221635E-07_JPRB, &
  & 0.69434698E-07_JPRB, 0.69818221E-07_JPRB, 0.70139997E-07_JPRB, 0.70382654E-07_JPRB, 0.70546918E-07_JPRB, 0.70631970E-07_JPRB, &
  & 0.70637476E-07_JPRB, 0.70573535E-07_JPRB, 0.70432108E-07_JPRB, 0.70179219E-07_JPRB, 0.69929428E-07_JPRB, 0.69704086E-07_JPRB, &
  & 0.69415130E-07_JPRB, 0.69095805E-07_JPRB, 0.68782775E-07_JPRB, 0.68429294E-07_JPRB, 0.67992893E-07_JPRB, 0.67520716E-07_JPRB, &
  & 0.67160371E-07_JPRB, 0.67008514E-07_JPRB, 0.66945077E-07_JPRB, 0.67051502E-07_JPRB, 0.67285043E-07_JPRB, 0.67678741E-07_JPRB, &
  & 0.68140203E-07_JPRB, 0.68748861E-07_JPRB, 0.69319213E-07_JPRB, 0.69877643E-07_JPRB, 0.70224829E-07_JPRB, 0.70483821E-07_JPRB, &
  & 0.70536629E-07_JPRB, 0.70483026E-07_JPRB, 0.70343461E-07_JPRB, 0.70084610E-07_JPRB, 0.69862899E-07_JPRB, 0.69546836E-07_JPRB, &
  & 0.69347173E-07_JPRB, 0.69096068E-07_JPRB, 0.68930952E-07_JPRB, 0.68683484E-07_JPRB, 0.68523086E-07_JPRB, 0.68355590E-07_JPRB, &
  & 0.68270438E-07_JPRB, 0.68181158E-07_JPRB, 0.68151216E-07_JPRB, 0.68117252E-07_JPRB, 0.68214376E-07_JPRB, 0.68469951E-07_JPRB, &
  & 0.68827276E-07_JPRB, 0.69518116E-07_JPRB, 0.71631732E-07_JPRB, 0.60364218E-05_JPRB  /)

RGHG7(:, 2, 9) = (/ &
  & 0.10702075E-05_JPRB, 0.11417412E-05_JPRB, 0.12199289E-05_JPRB, 0.12352770E-05_JPRB, 0.12139589E-05_JPRB, 0.11312768E-05_JPRB, &
  & 0.10132203E-05_JPRB, 0.80345058E-06_JPRB, 0.62288154E-06_JPRB, 0.50010374E-06_JPRB, 0.42216755E-06_JPRB, 0.37147922E-06_JPRB, &
  & 0.33608470E-06_JPRB, 0.30988792E-06_JPRB, 0.29032495E-06_JPRB, 0.27514184E-06_JPRB, 0.26323937E-06_JPRB, 0.25372975E-06_JPRB, &
  & 0.24629048E-06_JPRB, 0.24068933E-06_JPRB, 0.23691180E-06_JPRB, 0.23490043E-06_JPRB, 0.23428777E-06_JPRB, 0.23401563E-06_JPRB, &
  & 0.23314215E-06_JPRB, 0.23223130E-06_JPRB, 0.23080916E-06_JPRB, 0.22895013E-06_JPRB, 0.22690745E-06_JPRB, 0.22420637E-06_JPRB, &
  & 0.22240552E-06_JPRB, 0.22600507E-06_JPRB, 0.22426545E-06_JPRB, 0.22173002E-06_JPRB, 0.21895188E-06_JPRB, 0.21636701E-06_JPRB, &
  & 0.21446338E-06_JPRB, 0.21243299E-06_JPRB, 0.21029379E-06_JPRB, 0.20823408E-06_JPRB, 0.20601048E-06_JPRB, 0.20412207E-06_JPRB, &
  & 0.20259461E-06_JPRB, 0.20151960E-06_JPRB, 0.20093478E-06_JPRB, 0.20086043E-06_JPRB, 0.20070186E-06_JPRB, 0.20070371E-06_JPRB, &
  & 0.19985923E-06_JPRB, 0.19816643E-06_JPRB, 0.19522516E-06_JPRB, 0.19126408E-06_JPRB, 0.18575375E-06_JPRB, 0.17911987E-06_JPRB, &
  & 0.17131603E-06_JPRB, 0.16438068E-06_JPRB, 0.15571733E-06_JPRB, 0.14249413E-06_JPRB, 0.12788763E-06_JPRB, 0.11429958E-06_JPRB, &
  & 0.10245804E-06_JPRB, 0.95137587E-07_JPRB, 0.10349138E-06_JPRB, 0.39410947E-05_JPRB  /)

RGHG7(:, 3, 9) = (/ &
  & 0.67970336E-05_JPRB, 0.38361222E-05_JPRB, 0.32701307E-05_JPRB, 0.28757556E-05_JPRB, 0.25650379E-05_JPRB, 0.21765989E-05_JPRB, &
  & 0.17919464E-05_JPRB, 0.13245497E-05_JPRB, 0.97972440E-06_JPRB, 0.78328117E-06_JPRB, 0.67774084E-06_JPRB, 0.61988050E-06_JPRB, &
  & 0.58427202E-06_JPRB, 0.55753571E-06_JPRB, 0.53462247E-06_JPRB, 0.51484784E-06_JPRB, 0.49813298E-06_JPRB, 0.48371794E-06_JPRB, &
  & 0.47156826E-06_JPRB, 0.46179593E-06_JPRB, 0.45447570E-06_JPRB, 0.44912994E-06_JPRB, 0.44511617E-06_JPRB, 0.44298909E-06_JPRB, &
  & 0.44309755E-06_JPRB, 0.44354962E-06_JPRB, 0.44218248E-06_JPRB, 0.43804809E-06_JPRB, 0.43219273E-06_JPRB, 0.42456244E-06_JPRB, &
  & 0.42487844E-06_JPRB, 0.43219470E-06_JPRB, 0.42917657E-06_JPRB, 0.42339144E-06_JPRB, 0.41694642E-06_JPRB, 0.41368685E-06_JPRB, &
  & 0.40895384E-06_JPRB, 0.40572567E-06_JPRB, 0.40244115E-06_JPRB, 0.39888852E-06_JPRB, 0.39463995E-06_JPRB, 0.39040427E-06_JPRB, &
  & 0.38651072E-06_JPRB, 0.38332442E-06_JPRB, 0.38052988E-06_JPRB, 0.37887006E-06_JPRB, 0.37623337E-06_JPRB, 0.37474342E-06_JPRB, &
  & 0.37094307E-06_JPRB, 0.36721295E-06_JPRB, 0.36035465E-06_JPRB, 0.35269917E-06_JPRB, 0.34094009E-06_JPRB, 0.32819386E-06_JPRB, &
  & 0.31456224E-06_JPRB, 0.30656275E-06_JPRB, 0.29686925E-06_JPRB, 0.28296870E-06_JPRB, 0.26637613E-06_JPRB, 0.25548792E-06_JPRB, &
  & 0.24581806E-06_JPRB, 0.23088549E-06_JPRB, 0.22562335E-06_JPRB, 0.22985475E-05_JPRB  /)

RGHG7(:, 4, 9) = (/ &
  & 0.37272771E-05_JPRB, 0.19609443E-05_JPRB, 0.18243135E-05_JPRB, 0.17912589E-05_JPRB, 0.17690654E-05_JPRB, 0.17335241E-05_JPRB, &
  & 0.17329208E-05_JPRB, 0.16484100E-05_JPRB, 0.15685030E-05_JPRB, 0.15407539E-05_JPRB, 0.15193214E-05_JPRB, 0.14990400E-05_JPRB, &
  & 0.14547958E-05_JPRB, 0.13895630E-05_JPRB, 0.12957812E-05_JPRB, 0.12015217E-05_JPRB, 0.11184159E-05_JPRB, 0.10681220E-05_JPRB, &
  & 0.10501044E-05_JPRB, 0.10637960E-05_JPRB, 0.10738960E-05_JPRB, 0.10772381E-05_JPRB, 0.10774336E-05_JPRB, 0.10757193E-05_JPRB, &
  & 0.10730774E-05_JPRB, 0.10708483E-05_JPRB, 0.10632043E-05_JPRB, 0.10457188E-05_JPRB, 0.10165108E-05_JPRB, 0.98091882E-06_JPRB, &
  & 0.94675341E-06_JPRB, 0.92274973E-06_JPRB, 0.88884418E-06_JPRB, 0.85315801E-06_JPRB, 0.81878236E-06_JPRB, 0.79259112E-06_JPRB, &
  & 0.76710724E-06_JPRB, 0.73826680E-06_JPRB, 0.71957155E-06_JPRB, 0.70955686E-06_JPRB, 0.70972737E-06_JPRB, 0.72168710E-06_JPRB, &
  & 0.74207069E-06_JPRB, 0.77254391E-06_JPRB, 0.80826703E-06_JPRB, 0.84396034E-06_JPRB, 0.87889727E-06_JPRB, 0.91551770E-06_JPRB, &
  & 0.95365009E-06_JPRB, 0.99552927E-06_JPRB, 0.10416128E-05_JPRB, 0.10865005E-05_JPRB, 0.11344998E-05_JPRB, 0.11807444E-05_JPRB, &
  & 0.12200614E-05_JPRB, 0.12549753E-05_JPRB, 0.12878969E-05_JPRB, 0.13224288E-05_JPRB, 0.13590938E-05_JPRB, 0.13944464E-05_JPRB, &
  & 0.14104893E-05_JPRB, 0.14106688E-05_JPRB, 0.14117025E-05_JPRB, 0.19819376E-05_JPRB  /)

RGHG7(:, 5, 9) = (/ &
  & 0.23205817E-05_JPRB, 0.23019824E-05_JPRB, 0.23102877E-05_JPRB, 0.23253199E-05_JPRB, 0.23251175E-05_JPRB, 0.22996164E-05_JPRB, &
  & 0.22781400E-05_JPRB, 0.22648201E-05_JPRB, 0.22375329E-05_JPRB, 0.22263085E-05_JPRB, 0.22050561E-05_JPRB, 0.21852268E-05_JPRB, &
  & 0.21271891E-05_JPRB, 0.20302262E-05_JPRB, 0.18738039E-05_JPRB, 0.17049186E-05_JPRB, 0.15417900E-05_JPRB, 0.14330464E-05_JPRB, &
  & 0.13837824E-05_JPRB, 0.14005030E-05_JPRB, 0.14182978E-05_JPRB, 0.14286913E-05_JPRB, 0.14376741E-05_JPRB, 0.14386650E-05_JPRB, &
  & 0.14352560E-05_JPRB, 0.14318931E-05_JPRB, 0.14239852E-05_JPRB, 0.14012345E-05_JPRB, 0.13598389E-05_JPRB, 0.13069187E-05_JPRB, &
  & 0.12421001E-05_JPRB, 0.11771892E-05_JPRB, 0.11044657E-05_JPRB, 0.10379292E-05_JPRB, 0.97333844E-06_JPRB, 0.92351952E-06_JPRB, &
  & 0.87974030E-06_JPRB, 0.82769282E-06_JPRB, 0.79423164E-06_JPRB, 0.78003482E-06_JPRB, 0.79097955E-06_JPRB, 0.82775479E-06_JPRB, &
  & 0.88239872E-06_JPRB, 0.95318232E-06_JPRB, 0.10315983E-05_JPRB, 0.11080382E-05_JPRB, 0.11846282E-05_JPRB, 0.12624874E-05_JPRB, &
  & 0.13466307E-05_JPRB, 0.14392083E-05_JPRB, 0.15434180E-05_JPRB, 0.16463441E-05_JPRB, 0.17574622E-05_JPRB, 0.18648907E-05_JPRB, &
  & 0.19618548E-05_JPRB, 0.20435971E-05_JPRB, 0.21303549E-05_JPRB, 0.22246278E-05_JPRB, 0.23247972E-05_JPRB, 0.24182741E-05_JPRB, &
  & 0.24842142E-05_JPRB, 0.25139287E-05_JPRB, 0.24611663E-05_JPRB, 0.23469500E-05_JPRB  /)

RGHG7(:, 6, 9) = (/ &
  & 0.23865332E-05_JPRB, 0.23715489E-05_JPRB, 0.23668093E-05_JPRB, 0.23499947E-05_JPRB, 0.23375890E-05_JPRB, 0.23188017E-05_JPRB, &
  & 0.22957377E-05_JPRB, 0.22783437E-05_JPRB, 0.22484743E-05_JPRB, 0.22394878E-05_JPRB, 0.22278564E-05_JPRB, 0.22176863E-05_JPRB, &
  & 0.21841890E-05_JPRB, 0.21247729E-05_JPRB, 0.20038700E-05_JPRB, 0.18514723E-05_JPRB, 0.16820891E-05_JPRB, 0.15516553E-05_JPRB, &
  & 0.14747524E-05_JPRB, 0.14693427E-05_JPRB, 0.14796205E-05_JPRB, 0.14933804E-05_JPRB, 0.15142795E-05_JPRB, 0.15216014E-05_JPRB, &
  & 0.15180586E-05_JPRB, 0.15129360E-05_JPRB, 0.15075720E-05_JPRB, 0.14967567E-05_JPRB, 0.14714088E-05_JPRB, 0.14343834E-05_JPRB, &
  & 0.13828583E-05_JPRB, 0.13229970E-05_JPRB, 0.12517463E-05_JPRB, 0.11864340E-05_JPRB, 0.11170996E-05_JPRB, 0.10607392E-05_JPRB, &
  & 0.10141100E-05_JPRB, 0.96127830E-06_JPRB, 0.92129472E-06_JPRB, 0.90394190E-06_JPRB, 0.91588124E-06_JPRB, 0.95588900E-06_JPRB, &
  & 0.10147218E-05_JPRB, 0.10844151E-05_JPRB, 0.11561748E-05_JPRB, 0.12245430E-05_JPRB, 0.12915885E-05_JPRB, 0.13581243E-05_JPRB, &
  & 0.14304279E-05_JPRB, 0.15122177E-05_JPRB, 0.16061561E-05_JPRB, 0.16999011E-05_JPRB, 0.17991985E-05_JPRB, 0.18970825E-05_JPRB, &
  & 0.19887292E-05_JPRB, 0.20670095E-05_JPRB, 0.21525432E-05_JPRB, 0.22503737E-05_JPRB, 0.23554780E-05_JPRB, 0.24539088E-05_JPRB, &
  & 0.25255489E-05_JPRB, 0.25525856E-05_JPRB, 0.24662739E-05_JPRB, 0.23152949E-05_JPRB  /)

RGHG7(:, 7, 9) = (/ &
  & 0.24985400E-05_JPRB, 0.24827282E-05_JPRB, 0.24794533E-05_JPRB, 0.24540814E-05_JPRB, 0.24177078E-05_JPRB, 0.23929128E-05_JPRB, &
  & 0.23707311E-05_JPRB, 0.23587463E-05_JPRB, 0.23406353E-05_JPRB, 0.23390448E-05_JPRB, 0.23373448E-05_JPRB, 0.23407342E-05_JPRB, &
  & 0.23327799E-05_JPRB, 0.23148952E-05_JPRB, 0.22366257E-05_JPRB, 0.21185301E-05_JPRB, 0.19639724E-05_JPRB, 0.18215910E-05_JPRB, &
  & 0.17187602E-05_JPRB, 0.16832257E-05_JPRB, 0.16737301E-05_JPRB, 0.16751255E-05_JPRB, 0.16929119E-05_JPRB, 0.17117165E-05_JPRB, &
  & 0.17166216E-05_JPRB, 0.17143640E-05_JPRB, 0.17109192E-05_JPRB, 0.17033228E-05_JPRB, 0.16833191E-05_JPRB, 0.16591447E-05_JPRB, &
  & 0.16275996E-05_JPRB, 0.15853416E-05_JPRB, 0.15277918E-05_JPRB, 0.14725652E-05_JPRB, 0.14102886E-05_JPRB, 0.13543740E-05_JPRB, &
  & 0.13037734E-05_JPRB, 0.12503476E-05_JPRB, 0.12131477E-05_JPRB, 0.12010539E-05_JPRB, 0.12174588E-05_JPRB, 0.12579582E-05_JPRB, &
  & 0.13143010E-05_JPRB, 0.13760013E-05_JPRB, 0.14363183E-05_JPRB, 0.14934964E-05_JPRB, 0.15490286E-05_JPRB, 0.15998425E-05_JPRB, &
  & 0.16548433E-05_JPRB, 0.17179120E-05_JPRB, 0.17908256E-05_JPRB, 0.18636388E-05_JPRB, 0.19416863E-05_JPRB, 0.20198733E-05_JPRB, &
  & 0.20997045E-05_JPRB, 0.21707600E-05_JPRB, 0.22512710E-05_JPRB, 0.23462579E-05_JPRB, 0.24499625E-05_JPRB, 0.25488734E-05_JPRB, &
  & 0.26199016E-05_JPRB, 0.26389109E-05_JPRB, 0.25255940E-05_JPRB, 0.23340488E-05_JPRB  /)

RGHG7(:, 8, 9) = (/ &
  & 0.26406382E-05_JPRB, 0.26345358E-05_JPRB, 0.26393675E-05_JPRB, 0.26202976E-05_JPRB, 0.25771937E-05_JPRB, 0.25524812E-05_JPRB, &
  & 0.25389890E-05_JPRB, 0.25417519E-05_JPRB, 0.25483562E-05_JPRB, 0.25681811E-05_JPRB, 0.25864003E-05_JPRB, 0.26151649E-05_JPRB, &
  & 0.26407213E-05_JPRB, 0.26623736E-05_JPRB, 0.26320671E-05_JPRB, 0.25604710E-05_JPRB, 0.24386899E-05_JPRB, 0.23063538E-05_JPRB, &
  & 0.21871748E-05_JPRB, 0.21192307E-05_JPRB, 0.20776191E-05_JPRB, 0.20511614E-05_JPRB, 0.20435053E-05_JPRB, 0.20543198E-05_JPRB, &
  & 0.20598992E-05_JPRB, 0.20542542E-05_JPRB, 0.20496968E-05_JPRB, 0.20442691E-05_JPRB, 0.20319494E-05_JPRB, 0.20218877E-05_JPRB, &
  & 0.20099481E-05_JPRB, 0.19889701E-05_JPRB, 0.19532171E-05_JPRB, 0.19171260E-05_JPRB, 0.18737213E-05_JPRB, 0.18304603E-05_JPRB, &
  & 0.17903597E-05_JPRB, 0.17508270E-05_JPRB, 0.17295519E-05_JPRB, 0.17297244E-05_JPRB, 0.17519887E-05_JPRB, 0.17889835E-05_JPRB, &
  & 0.18355234E-05_JPRB, 0.18829373E-05_JPRB, 0.19275876E-05_JPRB, 0.19703837E-05_JPRB, 0.20101356E-05_JPRB, 0.20432552E-05_JPRB, &
  & 0.20777175E-05_JPRB, 0.21162125E-05_JPRB, 0.21584867E-05_JPRB, 0.21989017E-05_JPRB, 0.22437700E-05_JPRB, 0.22911757E-05_JPRB, &
  & 0.23479563E-05_JPRB, 0.24002826E-05_JPRB, 0.24650524E-05_JPRB, 0.25475553E-05_JPRB, 0.26424410E-05_JPRB, 0.27360967E-05_JPRB, &
  & 0.28011020E-05_JPRB, 0.28058639E-05_JPRB, 0.26712408E-05_JPRB, 0.24688430E-05_JPRB  /)

RGHG7(:, 9, 9) = (/ &
  & 0.28042313E-05_JPRB, 0.28262175E-05_JPRB, 0.28573726E-05_JPRB, 0.28671859E-05_JPRB, 0.28555366E-05_JPRB, 0.28565292E-05_JPRB, &
  & 0.28741295E-05_JPRB, 0.29073466E-05_JPRB, 0.29534437E-05_JPRB, 0.30145531E-05_JPRB, 0.30751503E-05_JPRB, 0.31521883E-05_JPRB, &
  & 0.32266169E-05_JPRB, 0.32915704E-05_JPRB, 0.33119713E-05_JPRB, 0.32898465E-05_JPRB, 0.32095835E-05_JPRB, 0.31014490E-05_JPRB, &
  & 0.29727317E-05_JPRB, 0.28693592E-05_JPRB, 0.27846413E-05_JPRB, 0.27148198E-05_JPRB, 0.26614696E-05_JPRB, 0.26327869E-05_JPRB, &
  & 0.26161901E-05_JPRB, 0.25926356E-05_JPRB, 0.25796854E-05_JPRB, 0.25737768E-05_JPRB, 0.25686914E-05_JPRB, 0.25691341E-05_JPRB, &
  & 0.25687948E-05_JPRB, 0.25653883E-05_JPRB, 0.25537324E-05_JPRB, 0.25424791E-05_JPRB, 0.25294008E-05_JPRB, 0.25170104E-05_JPRB, &
  & 0.25126318E-05_JPRB, 0.25082179E-05_JPRB, 0.25171168E-05_JPRB, 0.25371382E-05_JPRB, 0.25644583E-05_JPRB, 0.25951381E-05_JPRB, &
  & 0.26270064E-05_JPRB, 0.26561733E-05_JPRB, 0.26825542E-05_JPRB, 0.27071390E-05_JPRB, 0.27270109E-05_JPRB, 0.27434627E-05_JPRB, &
  & 0.27584851E-05_JPRB, 0.27719254E-05_JPRB, 0.27820695E-05_JPRB, 0.27858755E-05_JPRB, 0.27914604E-05_JPRB, 0.27999686E-05_JPRB, &
  & 0.28239406E-05_JPRB, 0.28473285E-05_JPRB, 0.28862589E-05_JPRB, 0.29450060E-05_JPRB, 0.30198239E-05_JPRB, 0.30955438E-05_JPRB, &
  & 0.31364661E-05_JPRB, 0.31061877E-05_JPRB, 0.29514776E-05_JPRB, 0.27749976E-05_JPRB  /)

RGHG7(:,10, 9) = (/ &
  & 0.29873278E-05_JPRB, 0.30646374E-05_JPRB, 0.31629969E-05_JPRB, 0.32409012E-05_JPRB, 0.33040397E-05_JPRB, 0.33699461E-05_JPRB, &
  & 0.34501003E-05_JPRB, 0.35347104E-05_JPRB, 0.36348819E-05_JPRB, 0.37571775E-05_JPRB, 0.38913317E-05_JPRB, 0.40483156E-05_JPRB, &
  & 0.41982379E-05_JPRB, 0.43272878E-05_JPRB, 0.44033541E-05_JPRB, 0.44208017E-05_JPRB, 0.43630362E-05_JPRB, 0.42503207E-05_JPRB, &
  & 0.40914116E-05_JPRB, 0.39357256E-05_JPRB, 0.37969285E-05_JPRB, 0.36722266E-05_JPRB, 0.35679772E-05_JPRB, 0.34830015E-05_JPRB, &
  & 0.34229494E-05_JPRB, 0.33679827E-05_JPRB, 0.33363983E-05_JPRB, 0.33214017E-05_JPRB, 0.33103470E-05_JPRB, 0.33075927E-05_JPRB, &
  & 0.33072164E-05_JPRB, 0.33090812E-05_JPRB, 0.33109462E-05_JPRB, 0.33171977E-05_JPRB, 0.33337162E-05_JPRB, 0.33614963E-05_JPRB, &
  & 0.34068200E-05_JPRB, 0.34479630E-05_JPRB, 0.34941077E-05_JPRB, 0.35412855E-05_JPRB, 0.35768286E-05_JPRB, 0.36059627E-05_JPRB, &
  & 0.36282620E-05_JPRB, 0.36444465E-05_JPRB, 0.36556325E-05_JPRB, 0.36618222E-05_JPRB, 0.36624375E-05_JPRB, 0.36667296E-05_JPRB, &
  & 0.36708143E-05_JPRB, 0.36703615E-05_JPRB, 0.36646609E-05_JPRB, 0.36503840E-05_JPRB, 0.36371575E-05_JPRB, 0.36227254E-05_JPRB, &
  & 0.36271828E-05_JPRB, 0.36354058E-05_JPRB, 0.36577419E-05_JPRB, 0.36914286E-05_JPRB, 0.37272436E-05_JPRB, 0.37457895E-05_JPRB, &
  & 0.36972802E-05_JPRB, 0.35573055E-05_JPRB, 0.33303870E-05_JPRB, 0.31480979E-05_JPRB  /)

RGHG7(:,11, 9) = (/ &
  & 0.32447705E-05_JPRB, 0.33810984E-05_JPRB, 0.35657992E-05_JPRB, 0.37455231E-05_JPRB, 0.39056057E-05_JPRB, 0.40569982E-05_JPRB, &
  & 0.42088362E-05_JPRB, 0.43569301E-05_JPRB, 0.45222206E-05_JPRB, 0.47170055E-05_JPRB, 0.49382571E-05_JPRB, 0.51875062E-05_JPRB, &
  & 0.54267353E-05_JPRB, 0.56298457E-05_JPRB, 0.57712066E-05_JPRB, 0.58345221E-05_JPRB, 0.57929576E-05_JPRB, 0.56590434E-05_JPRB, &
  & 0.54631106E-05_JPRB, 0.52518039E-05_JPRB, 0.50533384E-05_JPRB, 0.48719714E-05_JPRB, 0.47185653E-05_JPRB, 0.45847299E-05_JPRB, &
  & 0.44850796E-05_JPRB, 0.43951130E-05_JPRB, 0.43317287E-05_JPRB, 0.42879715E-05_JPRB, 0.42501017E-05_JPRB, 0.42253094E-05_JPRB, &
  & 0.42132530E-05_JPRB, 0.42050372E-05_JPRB, 0.42040852E-05_JPRB, 0.42115124E-05_JPRB, 0.42403051E-05_JPRB, 0.42960482E-05_JPRB, &
  & 0.43807775E-05_JPRB, 0.44668396E-05_JPRB, 0.45577395E-05_JPRB, 0.46427074E-05_JPRB, 0.47023872E-05_JPRB, 0.47398112E-05_JPRB, &
  & 0.47588869E-05_JPRB, 0.47679586E-05_JPRB, 0.47673194E-05_JPRB, 0.47589342E-05_JPRB, 0.47427525E-05_JPRB, 0.47377088E-05_JPRB, &
  & 0.47390741E-05_JPRB, 0.47387874E-05_JPRB, 0.47364415E-05_JPRB, 0.47319949E-05_JPRB, 0.47344816E-05_JPRB, 0.47317887E-05_JPRB, &
  & 0.47425128E-05_JPRB, 0.47528816E-05_JPRB, 0.47600772E-05_JPRB, 0.47505021E-05_JPRB, 0.46945622E-05_JPRB, 0.45701366E-05_JPRB, &
  & 0.43233118E-05_JPRB, 0.39761687E-05_JPRB, 0.35944271E-05_JPRB, 0.33295859E-05_JPRB  /)

RGHG7(:,12, 9) = (/ &
  & 0.35955208E-05_JPRB, 0.37311795E-05_JPRB, 0.39509508E-05_JPRB, 0.42022212E-05_JPRB, 0.44519199E-05_JPRB, 0.46910591E-05_JPRB, &
  & 0.49147307E-05_JPRB, 0.51227515E-05_JPRB, 0.53489433E-05_JPRB, 0.56030951E-05_JPRB, 0.58912135E-05_JPRB, 0.62016146E-05_JPRB, &
  & 0.64937640E-05_JPRB, 0.67524586E-05_JPRB, 0.69558638E-05_JPRB, 0.70821851E-05_JPRB, 0.71066878E-05_JPRB, 0.70332042E-05_JPRB, &
  & 0.68925932E-05_JPRB, 0.67111180E-05_JPRB, 0.65160865E-05_JPRB, 0.63278003E-05_JPRB, 0.61615878E-05_JPRB, 0.60061469E-05_JPRB, &
  & 0.58771708E-05_JPRB, 0.57454943E-05_JPRB, 0.56319376E-05_JPRB, 0.55299388E-05_JPRB, 0.54424021E-05_JPRB, 0.53715115E-05_JPRB, &
  & 0.53189075E-05_JPRB, 0.52778978E-05_JPRB, 0.52579550E-05_JPRB, 0.52559044E-05_JPRB, 0.52838881E-05_JPRB, 0.53587831E-05_JPRB, &
  & 0.54790291E-05_JPRB, 0.56162651E-05_JPRB, 0.57573073E-05_JPRB, 0.58833686E-05_JPRB, 0.59733544E-05_JPRB, 0.60230362E-05_JPRB, &
  & 0.60354700E-05_JPRB, 0.60270758E-05_JPRB, 0.60028923E-05_JPRB, 0.59720588E-05_JPRB, 0.59342242E-05_JPRB, 0.59120397E-05_JPRB, &
  & 0.58994627E-05_JPRB, 0.58907171E-05_JPRB, 0.58871516E-05_JPRB, 0.58873378E-05_JPRB, 0.58931823E-05_JPRB, 0.58878215E-05_JPRB, &
  & 0.58748294E-05_JPRB, 0.58395235E-05_JPRB, 0.57657614E-05_JPRB, 0.56419531E-05_JPRB, 0.54263491E-05_JPRB, 0.51074989E-05_JPRB, &
  & 0.46548020E-05_JPRB, 0.41405304E-05_JPRB, 0.36601705E-05_JPRB, 0.33483508E-05_JPRB  /)

RGHG7(:,13, 9) = (/ &
  & 0.38610138E-05_JPRB, 0.39728673E-05_JPRB, 0.41715785E-05_JPRB, 0.44487990E-05_JPRB, 0.47680927E-05_JPRB, 0.50879643E-05_JPRB, &
  & 0.53897708E-05_JPRB, 0.56610229E-05_JPRB, 0.59416600E-05_JPRB, 0.62370177E-05_JPRB, 0.65585356E-05_JPRB, 0.68869566E-05_JPRB, &
  & 0.71886181E-05_JPRB, 0.74669131E-05_JPRB, 0.76952518E-05_JPRB, 0.78550073E-05_JPRB, 0.79541481E-05_JPRB, 0.79881349E-05_JPRB, &
  & 0.79714432E-05_JPRB, 0.79136023E-05_JPRB, 0.78259486E-05_JPRB, 0.77164340E-05_JPRB, 0.76053976E-05_JPRB, 0.74918234E-05_JPRB, &
  & 0.73761229E-05_JPRB, 0.72267027E-05_JPRB, 0.70770937E-05_JPRB, 0.69290809E-05_JPRB, 0.67887368E-05_JPRB, 0.66574813E-05_JPRB, &
  & 0.65428056E-05_JPRB, 0.64504962E-05_JPRB, 0.64027899E-05_JPRB, 0.63974786E-05_JPRB, 0.64311491E-05_JPRB, 0.65232237E-05_JPRB, &
  & 0.66659887E-05_JPRB, 0.68319294E-05_JPRB, 0.69918769E-05_JPRB, 0.71272001E-05_JPRB, 0.72217784E-05_JPRB, 0.72700924E-05_JPRB, &
  & 0.72742645E-05_JPRB, 0.72468162E-05_JPRB, 0.71963673E-05_JPRB, 0.71420810E-05_JPRB, 0.70819873E-05_JPRB, 0.70299244E-05_JPRB, &
  & 0.69836460E-05_JPRB, 0.69450596E-05_JPRB, 0.69147568E-05_JPRB, 0.68836981E-05_JPRB, 0.68460674E-05_JPRB, 0.67849428E-05_JPRB, &
  & 0.66907217E-05_JPRB, 0.65573721E-05_JPRB, 0.63635926E-05_JPRB, 0.61078583E-05_JPRB, 0.57494599E-05_JPRB, 0.52933545E-05_JPRB, &
  & 0.47326845E-05_JPRB, 0.41531548E-05_JPRB, 0.36544130E-05_JPRB, 0.33381872E-05_JPRB  /)

RGHG7(:,14, 9) = (/ &
  & 0.39982516E-05_JPRB, 0.40784138E-05_JPRB, 0.42379203E-05_JPRB, 0.45040065E-05_JPRB, 0.48474312E-05_JPRB, 0.52176827E-05_JPRB, &
  & 0.55867969E-05_JPRB, 0.59303394E-05_JPRB, 0.62686921E-05_JPRB, 0.66039227E-05_JPRB, 0.69409708E-05_JPRB, 0.72704603E-05_JPRB, &
  & 0.75648690E-05_JPRB, 0.78317621E-05_JPRB, 0.80463074E-05_JPRB, 0.82072945E-05_JPRB, 0.83387110E-05_JPRB, 0.84386332E-05_JPRB, &
  & 0.85080614E-05_JPRB, 0.85546417E-05_JPRB, 0.85840428E-05_JPRB, 0.85863096E-05_JPRB, 0.85697906E-05_JPRB, 0.85408358E-05_JPRB, &
  & 0.84914997E-05_JPRB, 0.83915978E-05_JPRB, 0.82800237E-05_JPRB, 0.81522349E-05_JPRB, 0.80097913E-05_JPRB, 0.78673667E-05_JPRB, &
  & 0.77446145E-05_JPRB, 0.76523860E-05_JPRB, 0.76081660E-05_JPRB, 0.76133714E-05_JPRB, 0.76441397E-05_JPRB, 0.77191904E-05_JPRB, &
  & 0.78308089E-05_JPRB, 0.79535388E-05_JPRB, 0.80620525E-05_JPRB, 0.81454187E-05_JPRB, 0.82006581E-05_JPRB, 0.82212281E-05_JPRB, &
  & 0.82144192E-05_JPRB, 0.81811570E-05_JPRB, 0.81233592E-05_JPRB, 0.80547151E-05_JPRB, 0.79684636E-05_JPRB, 0.78727897E-05_JPRB, &
  & 0.77842014E-05_JPRB, 0.77022908E-05_JPRB, 0.76201588E-05_JPRB, 0.75196498E-05_JPRB, 0.73966144E-05_JPRB, 0.72433764E-05_JPRB, &
  & 0.70510663E-05_JPRB, 0.68254716E-05_JPRB, 0.65441165E-05_JPRB, 0.62045845E-05_JPRB, 0.57657469E-05_JPRB, 0.52436640E-05_JPRB, &
  & 0.46453277E-05_JPRB, 0.40496962E-05_JPRB, 0.35701180E-05_JPRB, 0.32847120E-05_JPRB  /)

RGHG7(:,15, 9) = (/ &
  & 0.40604981E-05_JPRB, 0.41160716E-05_JPRB, 0.42346744E-05_JPRB, 0.44538169E-05_JPRB, 0.47627610E-05_JPRB, 0.51345667E-05_JPRB, &
  & 0.55354116E-05_JPRB, 0.59361867E-05_JPRB, 0.63324631E-05_JPRB, 0.67148901E-05_JPRB, 0.70708123E-05_JPRB, 0.74041962E-05_JPRB, &
  & 0.76904308E-05_JPRB, 0.79346012E-05_JPRB, 0.81279133E-05_JPRB, 0.82752483E-05_JPRB, 0.83997883E-05_JPRB, 0.85145999E-05_JPRB, &
  & 0.86128265E-05_JPRB, 0.87027860E-05_JPRB, 0.87931754E-05_JPRB, 0.88755206E-05_JPRB, 0.89462820E-05_JPRB, 0.90069090E-05_JPRB, &
  & 0.90535494E-05_JPRB, 0.90684805E-05_JPRB, 0.90691985E-05_JPRB, 0.90461959E-05_JPRB, 0.90187777E-05_JPRB, 0.90009737E-05_JPRB, &
  & 0.89886273E-05_JPRB, 0.89743559E-05_JPRB, 0.89607349E-05_JPRB, 0.89414469E-05_JPRB, 0.89053024E-05_JPRB, 0.88842595E-05_JPRB, &
  & 0.88773796E-05_JPRB, 0.88751379E-05_JPRB, 0.88674272E-05_JPRB, 0.88486154E-05_JPRB, 0.88284764E-05_JPRB, 0.87943342E-05_JPRB, &
  & 0.87581586E-05_JPRB, 0.87143621E-05_JPRB, 0.86466132E-05_JPRB, 0.85494332E-05_JPRB, 0.84230410E-05_JPRB, 0.82806876E-05_JPRB, &
  & 0.81461572E-05_JPRB, 0.80136908E-05_JPRB, 0.78729108E-05_JPRB, 0.77033614E-05_JPRB, 0.75023086E-05_JPRB, 0.72769557E-05_JPRB, &
  & 0.70225407E-05_JPRB, 0.67431751E-05_JPRB, 0.64143559E-05_JPRB, 0.60296532E-05_JPRB, 0.55520147E-05_JPRB, 0.50111832E-05_JPRB, &
  & 0.44242051E-05_JPRB, 0.38445311E-05_JPRB, 0.34250481E-05_JPRB, 0.32053855E-05_JPRB  /)

RGHG7(:,16, 9) = (/ &
  & 0.40012575E-05_JPRB, 0.40469213E-05_JPRB, 0.41404330E-05_JPRB, 0.43052036E-05_JPRB, 0.45517955E-05_JPRB, 0.48747752E-05_JPRB, &
  & 0.52604101E-05_JPRB, 0.56844786E-05_JPRB, 0.61243603E-05_JPRB, 0.65584050E-05_JPRB, 0.69511828E-05_JPRB, 0.72956991E-05_JPRB, &
  & 0.75839224E-05_JPRB, 0.78118877E-05_JPRB, 0.79901793E-05_JPRB, 0.81243505E-05_JPRB, 0.82288534E-05_JPRB, 0.83313118E-05_JPRB, &
  & 0.84321279E-05_JPRB, 0.85430156E-05_JPRB, 0.86683135E-05_JPRB, 0.87980083E-05_JPRB, 0.89360765E-05_JPRB, 0.90775776E-05_JPRB, &
  & 0.92132752E-05_JPRB, 0.93437529E-05_JPRB, 0.94683001E-05_JPRB, 0.95877750E-05_JPRB, 0.97470275E-05_JPRB, 0.99423071E-05_JPRB, &
  & 0.10119933E-04_JPRB, 0.10216428E-04_JPRB, 0.10217263E-04_JPRB, 0.10127978E-04_JPRB, 0.99757618E-05_JPRB, 0.98220911E-05_JPRB, &
  & 0.96768230E-05_JPRB, 0.95426664E-05_JPRB, 0.94153404E-05_JPRB, 0.92896762E-05_JPRB, 0.91824771E-05_JPRB, 0.90758466E-05_JPRB, &
  & 0.89861906E-05_JPRB, 0.88995448E-05_JPRB, 0.87899076E-05_JPRB, 0.86429316E-05_JPRB, 0.84701265E-05_JPRB, 0.82902041E-05_JPRB, &
  & 0.81159261E-05_JPRB, 0.79392118E-05_JPRB, 0.77423956E-05_JPRB, 0.75131439E-05_JPRB, 0.72463673E-05_JPRB, 0.69729102E-05_JPRB, &
  & 0.66835717E-05_JPRB, 0.63744228E-05_JPRB, 0.60188145E-05_JPRB, 0.56133618E-05_JPRB, 0.51357008E-05_JPRB, 0.46314776E-05_JPRB, &
  & 0.41014121E-05_JPRB, 0.35819662E-05_JPRB, 0.32485219E-05_JPRB, 0.31027059E-05_JPRB  /)

RGHG7(:,17, 9) = (/ &
  & 0.39160475E-05_JPRB, 0.39430925E-05_JPRB, 0.40070905E-05_JPRB, 0.41212678E-05_JPRB, 0.43007438E-05_JPRB, 0.45462925E-05_JPRB, &
  & 0.48680319E-05_JPRB, 0.52627315E-05_JPRB, 0.57063631E-05_JPRB, 0.61676951E-05_JPRB, 0.65965276E-05_JPRB, 0.69567453E-05_JPRB, &
  & 0.72557886E-05_JPRB, 0.74812905E-05_JPRB, 0.76567080E-05_JPRB, 0.77812402E-05_JPRB, 0.78682089E-05_JPRB, 0.79569582E-05_JPRB, &
  & 0.80597863E-05_JPRB, 0.81790009E-05_JPRB, 0.83241654E-05_JPRB, 0.84837303E-05_JPRB, 0.86650255E-05_JPRB, 0.88714488E-05_JPRB, &
  & 0.90827780E-05_JPRB, 0.92948425E-05_JPRB, 0.95022297E-05_JPRB, 0.97083528E-05_JPRB, 0.99752626E-05_JPRB, 0.10301951E-04_JPRB, &
  & 0.10608467E-04_JPRB, 0.10784479E-04_JPRB, 0.10803496E-04_JPRB, 0.10690652E-04_JPRB, 0.10489549E-04_JPRB, 0.10282473E-04_JPRB, &
  & 0.10091487E-04_JPRB, 0.99035115E-05_JPRB, 0.97115646E-05_JPRB, 0.95201832E-05_JPRB, 0.93458300E-05_JPRB, 0.91779449E-05_JPRB, &
  & 0.90282542E-05_JPRB, 0.88858984E-05_JPRB, 0.87192805E-05_JPRB, 0.85066955E-05_JPRB, 0.82732312E-05_JPRB, 0.80532615E-05_JPRB, &
  & 0.78454974E-05_JPRB, 0.76232674E-05_JPRB, 0.73783457E-05_JPRB, 0.71122837E-05_JPRB, 0.68158413E-05_JPRB, 0.65279906E-05_JPRB, &
  & 0.62323351E-05_JPRB, 0.59237732E-05_JPRB, 0.55743771E-05_JPRB, 0.51782476E-05_JPRB, 0.47332112E-05_JPRB, 0.42897693E-05_JPRB, &
  & 0.38286546E-05_JPRB, 0.33847023E-05_JPRB, 0.31328217E-05_JPRB, 0.30266480E-05_JPRB  /)

RGHG7(:,18, 9) = (/ &
  & 0.38664854E-05_JPRB, 0.38758392E-05_JPRB, 0.39071062E-05_JPRB, 0.39769792E-05_JPRB, 0.40922602E-05_JPRB, 0.42607657E-05_JPRB, &
  & 0.45011768E-05_JPRB, 0.48243902E-05_JPRB, 0.52215023E-05_JPRB, 0.56608648E-05_JPRB, 0.60945356E-05_JPRB, 0.64690689E-05_JPRB, &
  & 0.67817467E-05_JPRB, 0.70185050E-05_JPRB, 0.72058733E-05_JPRB, 0.73312944E-05_JPRB, 0.74157649E-05_JPRB, 0.75001856E-05_JPRB, &
  & 0.76001276E-05_JPRB, 0.77146101E-05_JPRB, 0.78568000E-05_JPRB, 0.80261698E-05_JPRB, 0.82212630E-05_JPRB, 0.84559384E-05_JPRB, &
  & 0.87237759E-05_JPRB, 0.89956997E-05_JPRB, 0.92564849E-05_JPRB, 0.95149865E-05_JPRB, 0.98180256E-05_JPRB, 0.10174541E-04_JPRB, &
  & 0.10547359E-04_JPRB, 0.10790034E-04_JPRB, 0.10837848E-04_JPRB, 0.10738591E-04_JPRB, 0.10551485E-04_JPRB, 0.10355777E-04_JPRB, &
  & 0.10179101E-04_JPRB, 0.99982562E-05_JPRB, 0.97994197E-05_JPRB, 0.95955310E-05_JPRB, 0.93956447E-05_JPRB, 0.91964633E-05_JPRB, &
  & 0.89958572E-05_JPRB, 0.87953488E-05_JPRB, 0.85716989E-05_JPRB, 0.82953126E-05_JPRB, 0.80049809E-05_JPRB, 0.77478284E-05_JPRB, &
  & 0.75233930E-05_JPRB, 0.72751668E-05_JPRB, 0.70065328E-05_JPRB, 0.67200819E-05_JPRB, 0.64221388E-05_JPRB, 0.61370670E-05_JPRB, &
  & 0.58468909E-05_JPRB, 0.55509028E-05_JPRB, 0.52184119E-05_JPRB, 0.48422613E-05_JPRB, 0.44416941E-05_JPRB, 0.40525756E-05_JPRB, &
  & 0.36396209E-05_JPRB, 0.32435991E-05_JPRB, 0.30607862E-05_JPRB, 0.29691270E-05_JPRB  /)

RGHG7(:,19, 9) = (/ &
  & 0.38175179E-05_JPRB, 0.38186214E-05_JPRB, 0.38273648E-05_JPRB, 0.38622053E-05_JPRB, 0.39312248E-05_JPRB, 0.40402241E-05_JPRB, &
  & 0.42055338E-05_JPRB, 0.44446656E-05_JPRB, 0.47625184E-05_JPRB, 0.51404838E-05_JPRB, 0.55467677E-05_JPRB, 0.59269724E-05_JPRB, &
  & 0.62520081E-05_JPRB, 0.65059678E-05_JPRB, 0.67118006E-05_JPRB, 0.68490621E-05_JPRB, 0.69439084E-05_JPRB, 0.70278494E-05_JPRB, &
  & 0.71208762E-05_JPRB, 0.72231096E-05_JPRB, 0.73484322E-05_JPRB, 0.75077857E-05_JPRB, 0.76929316E-05_JPRB, 0.79380633E-05_JPRB, &
  & 0.82254700E-05_JPRB, 0.85139277E-05_JPRB, 0.87993385E-05_JPRB, 0.90873292E-05_JPRB, 0.93927659E-05_JPRB, 0.97244520E-05_JPRB, &
  & 0.10106200E-04_JPRB, 0.10390971E-04_JPRB, 0.10474730E-04_JPRB, 0.10416305E-04_JPRB, 0.10281282E-04_JPRB, 0.10129972E-04_JPRB, &
  & 0.99954291E-05_JPRB, 0.98516160E-05_JPRB, 0.96820148E-05_JPRB, 0.95007008E-05_JPRB, 0.93095992E-05_JPRB, 0.91042944E-05_JPRB, &
  & 0.88766510E-05_JPRB, 0.86481335E-05_JPRB, 0.83910874E-05_JPRB, 0.80750752E-05_JPRB, 0.77484794E-05_JPRB, 0.74652030E-05_JPRB, &
  & 0.72279681E-05_JPRB, 0.69645749E-05_JPRB, 0.66813969E-05_JPRB, 0.63791516E-05_JPRB, 0.60795528E-05_JPRB, 0.57938536E-05_JPRB, &
  & 0.55144491E-05_JPRB, 0.52304699E-05_JPRB, 0.49084774E-05_JPRB, 0.45514489E-05_JPRB, 0.41899033E-05_JPRB, 0.38534061E-05_JPRB, &
  & 0.34839984E-05_JPRB, 0.31303425E-05_JPRB, 0.29930293E-05_JPRB, 0.29216286E-05_JPRB  /)

RGHG7(:,20, 9) = (/ &
  & 0.37103783E-05_JPRB, 0.37070391E-05_JPRB, 0.37058106E-05_JPRB, 0.37196426E-05_JPRB, 0.37620847E-05_JPRB, 0.38357968E-05_JPRB, &
  & 0.39492166E-05_JPRB, 0.41180353E-05_JPRB, 0.43548330E-05_JPRB, 0.46600748E-05_JPRB, 0.50239576E-05_JPRB, 0.54031540E-05_JPRB, &
  & 0.57396676E-05_JPRB, 0.60086240E-05_JPRB, 0.62338304E-05_JPRB, 0.63888641E-05_JPRB, 0.64973223E-05_JPRB, 0.65814802E-05_JPRB, &
  & 0.66638680E-05_JPRB, 0.67497672E-05_JPRB, 0.68537812E-05_JPRB, 0.69907054E-05_JPRB, 0.71553152E-05_JPRB, 0.73867431E-05_JPRB, &
  & 0.76543782E-05_JPRB, 0.79256932E-05_JPRB, 0.82102921E-05_JPRB, 0.85076379E-05_JPRB, 0.87908741E-05_JPRB, 0.90806879E-05_JPRB, &
  & 0.94323628E-05_JPRB, 0.97079093E-05_JPRB, 0.98141846E-05_JPRB, 0.98053034E-05_JPRB, 0.97297618E-05_JPRB, 0.96314240E-05_JPRB, &
  & 0.95435934E-05_JPRB, 0.94468266E-05_JPRB, 0.93226528E-05_JPRB, 0.91784958E-05_JPRB, 0.90179373E-05_JPRB, 0.88330461E-05_JPRB, &
  & 0.86118837E-05_JPRB, 0.83918308E-05_JPRB, 0.81304479E-05_JPRB, 0.78053554E-05_JPRB, 0.74737168E-05_JPRB, 0.71838985E-05_JPRB, &
  & 0.69415191E-05_JPRB, 0.66712703E-05_JPRB, 0.63785670E-05_JPRB, 0.60634273E-05_JPRB, 0.57545460E-05_JPRB, 0.54690539E-05_JPRB, &
  & 0.52001020E-05_JPRB, 0.49237624E-05_JPRB, 0.46116356E-05_JPRB, 0.42750238E-05_JPRB, 0.39472995E-05_JPRB, 0.36645545E-05_JPRB, &
  & 0.33517879E-05_JPRB, 0.30497276E-05_JPRB, 0.29371027E-05_JPRB, 0.28817263E-05_JPRB  /)

RGHG7(:,21, 9) = (/ &
  & 0.35083817E-05_JPRB, 0.35000561E-05_JPRB, 0.34952880E-05_JPRB, 0.35005913E-05_JPRB, 0.35322873E-05_JPRB, 0.35943604E-05_JPRB, &
  & 0.36854214E-05_JPRB, 0.38140108E-05_JPRB, 0.39923162E-05_JPRB, 0.42379524E-05_JPRB, 0.45616428E-05_JPRB, 0.49370922E-05_JPRB, &
  & 0.52849344E-05_JPRB, 0.55642741E-05_JPRB, 0.58060470E-05_JPRB, 0.59802243E-05_JPRB, 0.61000552E-05_JPRB, 0.61829483E-05_JPRB, &
  & 0.62521318E-05_JPRB, 0.63203850E-05_JPRB, 0.64023321E-05_JPRB, 0.65109215E-05_JPRB, 0.66495183E-05_JPRB, 0.68437711E-05_JPRB, &
  & 0.70615372E-05_JPRB, 0.72926807E-05_JPRB, 0.75520069E-05_JPRB, 0.78322540E-05_JPRB, 0.80723416E-05_JPRB, 0.83133976E-05_JPRB, &
  & 0.86063264E-05_JPRB, 0.88306965E-05_JPRB, 0.89434374E-05_JPRB, 0.89784726E-05_JPRB, 0.89544563E-05_JPRB, 0.89061829E-05_JPRB, &
  & 0.88579362E-05_JPRB, 0.88018636E-05_JPRB, 0.87225457E-05_JPRB, 0.86177993E-05_JPRB, 0.84991302E-05_JPRB, 0.83566578E-05_JPRB, &
  & 0.81746441E-05_JPRB, 0.79924384E-05_JPRB, 0.77552332E-05_JPRB, 0.74529086E-05_JPRB, 0.71473214E-05_JPRB, 0.68724025E-05_JPRB, &
  & 0.66360722E-05_JPRB, 0.63693571E-05_JPRB, 0.60746405E-05_JPRB, 0.57502434E-05_JPRB, 0.54326579E-05_JPRB, 0.51557093E-05_JPRB, &
  & 0.48975842E-05_JPRB, 0.46294825E-05_JPRB, 0.43324494E-05_JPRB, 0.40197875E-05_JPRB, 0.37261126E-05_JPRB, 0.34971105E-05_JPRB, &
  & 0.32502140E-05_JPRB, 0.30091382E-05_JPRB, 0.29057335E-05_JPRB, 0.28598076E-05_JPRB  /)

RGHG7(:,22, 9) = (/ &
  & 0.31755130E-05_JPRB, 0.31589757E-05_JPRB, 0.31478207E-05_JPRB, 0.31536310E-05_JPRB, 0.31868476E-05_JPRB, 0.32606807E-05_JPRB, &
  & 0.33648195E-05_JPRB, 0.35005055E-05_JPRB, 0.36684702E-05_JPRB, 0.38932224E-05_JPRB, 0.41969412E-05_JPRB, 0.45700589E-05_JPRB, &
  & 0.49294583E-05_JPRB, 0.52143737E-05_JPRB, 0.54659804E-05_JPRB, 0.56563783E-05_JPRB, 0.57818864E-05_JPRB, 0.58597106E-05_JPRB, &
  & 0.59148024E-05_JPRB, 0.59670378E-05_JPRB, 0.60271885E-05_JPRB, 0.61069864E-05_JPRB, 0.62140544E-05_JPRB, 0.63522447E-05_JPRB, &
  & 0.65014788E-05_JPRB, 0.66755461E-05_JPRB, 0.68813444E-05_JPRB, 0.71031973E-05_JPRB, 0.72804300E-05_JPRB, 0.74622809E-05_JPRB, &
  & 0.76698488E-05_JPRB, 0.78274104E-05_JPRB, 0.79370085E-05_JPRB, 0.79966787E-05_JPRB, 0.80069285E-05_JPRB, 0.79989024E-05_JPRB, &
  & 0.79746824E-05_JPRB, 0.79347291E-05_JPRB, 0.78823779E-05_JPRB, 0.78103769E-05_JPRB, 0.77362130E-05_JPRB, 0.76517292E-05_JPRB, &
  & 0.75392613E-05_JPRB, 0.74153484E-05_JPRB, 0.72323808E-05_JPRB, 0.69889572E-05_JPRB, 0.67389256E-05_JPRB, 0.65014154E-05_JPRB, &
  & 0.62857664E-05_JPRB, 0.60384146E-05_JPRB, 0.57554579E-05_JPRB, 0.54273098E-05_JPRB, 0.51174291E-05_JPRB, 0.48660279E-05_JPRB, &
  & 0.46233124E-05_JPRB, 0.43735602E-05_JPRB, 0.41016691E-05_JPRB, 0.38179001E-05_JPRB, 0.35651822E-05_JPRB, 0.33860584E-05_JPRB, &
  & 0.31984685E-05_JPRB, 0.30212612E-05_JPRB, 0.29151194E-05_JPRB, 0.28766955E-05_JPRB  /)

RGHG7(:,23, 9) = (/ &
  & 0.27273603E-05_JPRB, 0.27115512E-05_JPRB, 0.26892334E-05_JPRB, 0.26833266E-05_JPRB, 0.27100613E-05_JPRB, 0.27913077E-05_JPRB, &
  & 0.29252260E-05_JPRB, 0.31153401E-05_JPRB, 0.33459299E-05_JPRB, 0.36176843E-05_JPRB, 0.39455646E-05_JPRB, 0.43212422E-05_JPRB, &
  & 0.46829515E-05_JPRB, 0.49640192E-05_JPRB, 0.52076207E-05_JPRB, 0.53934345E-05_JPRB, 0.55138160E-05_JPRB, 0.55826015E-05_JPRB, &
  & 0.56247754E-05_JPRB, 0.56633921E-05_JPRB, 0.57058860E-05_JPRB, 0.57594570E-05_JPRB, 0.58309979E-05_JPRB, 0.59154944E-05_JPRB, &
  & 0.60032591E-05_JPRB, 0.61087605E-05_JPRB, 0.62323199E-05_JPRB, 0.63706197E-05_JPRB, 0.64789179E-05_JPRB, 0.65946242E-05_JPRB, &
  & 0.67271336E-05_JPRB, 0.68363232E-05_JPRB, 0.69360512E-05_JPRB, 0.70059560E-05_JPRB, 0.70343800E-05_JPRB, 0.70406456E-05_JPRB, &
  & 0.70208659E-05_JPRB, 0.69751476E-05_JPRB, 0.69230922E-05_JPRB, 0.68717554E-05_JPRB, 0.68289755E-05_JPRB, 0.67907413E-05_JPRB, &
  & 0.67416311E-05_JPRB, 0.66710987E-05_JPRB, 0.65533128E-05_JPRB, 0.63842656E-05_JPRB, 0.62000480E-05_JPRB, 0.60081224E-05_JPRB, &
  & 0.58195206E-05_JPRB, 0.56086642E-05_JPRB, 0.53518305E-05_JPRB, 0.50565259E-05_JPRB, 0.47935611E-05_JPRB, 0.45899165E-05_JPRB, &
  & 0.43894607E-05_JPRB, 0.41743559E-05_JPRB, 0.39373128E-05_JPRB, 0.36911128E-05_JPRB, 0.34754276E-05_JPRB, 0.33293414E-05_JPRB, &
  & 0.31845205E-05_JPRB, 0.30654750E-05_JPRB, 0.29566458E-05_JPRB, 0.29071718E-05_JPRB  /)

RGHG7(:,24, 9) = (/ &
  & 0.22656948E-05_JPRB, 0.22578284E-05_JPRB, 0.22267935E-05_JPRB, 0.22070428E-05_JPRB, 0.22222364E-05_JPRB, 0.23005172E-05_JPRB, &
  & 0.24533388E-05_JPRB, 0.26982482E-05_JPRB, 0.30082189E-05_JPRB, 0.33508755E-05_JPRB, 0.37204941E-05_JPRB, 0.41011327E-05_JPRB, &
  & 0.44560617E-05_JPRB, 0.47246818E-05_JPRB, 0.49481619E-05_JPRB, 0.51168077E-05_JPRB, 0.52248664E-05_JPRB, 0.52828269E-05_JPRB, &
  & 0.53125041E-05_JPRB, 0.53356587E-05_JPRB, 0.53597227E-05_JPRB, 0.53861923E-05_JPRB, 0.54190611E-05_JPRB, 0.54534648E-05_JPRB, &
  & 0.54846469E-05_JPRB, 0.55192291E-05_JPRB, 0.55573020E-05_JPRB, 0.56116305E-05_JPRB, 0.56565302E-05_JPRB, 0.57141822E-05_JPRB, &
  & 0.57853212E-05_JPRB, 0.58580567E-05_JPRB, 0.59472145E-05_JPRB, 0.60214807E-05_JPRB, 0.60630921E-05_JPRB, 0.60763302E-05_JPRB, &
  & 0.60550361E-05_JPRB, 0.60013287E-05_JPRB, 0.59453622E-05_JPRB, 0.59072270E-05_JPRB, 0.58882719E-05_JPRB, 0.58871592E-05_JPRB, &
  & 0.58889786E-05_JPRB, 0.58675437E-05_JPRB, 0.58127546E-05_JPRB, 0.57170163E-05_JPRB, 0.55949388E-05_JPRB, 0.54465988E-05_JPRB, &
  & 0.52857861E-05_JPRB, 0.51101866E-05_JPRB, 0.48928249E-05_JPRB, 0.46517022E-05_JPRB, 0.44501719E-05_JPRB, 0.42967555E-05_JPRB, &
  & 0.41405866E-05_JPRB, 0.39664056E-05_JPRB, 0.37693223E-05_JPRB, 0.35649225E-05_JPRB, 0.33875263E-05_JPRB, 0.32702009E-05_JPRB, &
  & 0.31684636E-05_JPRB, 0.31023905E-05_JPRB, 0.29924641E-05_JPRB, 0.29332731E-05_JPRB  /)

RGHG7(:,25, 9) = (/ &
  & 0.18267961E-05_JPRB, 0.18372871E-05_JPRB, 0.18033357E-05_JPRB, 0.17693451E-05_JPRB, 0.17663529E-05_JPRB, 0.18243891E-05_JPRB, &
  & 0.19722352E-05_JPRB, 0.22594782E-05_JPRB, 0.26585339E-05_JPRB, 0.30959800E-05_JPRB, 0.35266756E-05_JPRB, 0.39152062E-05_JPRB, &
  & 0.42496332E-05_JPRB, 0.44932478E-05_JPRB, 0.46800559E-05_JPRB, 0.48146890E-05_JPRB, 0.49006588E-05_JPRB, 0.49460093E-05_JPRB, &
  & 0.49642345E-05_JPRB, 0.49688172E-05_JPRB, 0.49729797E-05_JPRB, 0.49714413E-05_JPRB, 0.49627058E-05_JPRB, 0.49551190E-05_JPRB, &
  & 0.49393352E-05_JPRB, 0.49046053E-05_JPRB, 0.48617426E-05_JPRB, 0.48407971E-05_JPRB, 0.48363291E-05_JPRB, 0.48544354E-05_JPRB, &
  & 0.48889024E-05_JPRB, 0.49437952E-05_JPRB, 0.50231309E-05_JPRB, 0.50943948E-05_JPRB, 0.51433835E-05_JPRB, 0.51561497E-05_JPRB, &
  & 0.51272639E-05_JPRB, 0.50669084E-05_JPRB, 0.50057521E-05_JPRB, 0.49697185E-05_JPRB, 0.49630732E-05_JPRB, 0.49838779E-05_JPRB, &
  & 0.50137052E-05_JPRB, 0.50326738E-05_JPRB, 0.50317131E-05_JPRB, 0.50006118E-05_JPRB, 0.49290600E-05_JPRB, 0.48169631E-05_JPRB, &
  & 0.46825714E-05_JPRB, 0.45345938E-05_JPRB, 0.43753496E-05_JPRB, 0.42155486E-05_JPRB, 0.40895925E-05_JPRB, 0.39835280E-05_JPRB, &
  & 0.38672050E-05_JPRB, 0.37395609E-05_JPRB, 0.35875134E-05_JPRB, 0.34285782E-05_JPRB, 0.32908563E-05_JPRB, 0.31972068E-05_JPRB, &
  & 0.31408913E-05_JPRB, 0.31174949E-05_JPRB, 0.30093271E-05_JPRB, 0.29473910E-05_JPRB  /)

RGHG7(:,26, 9) = (/ &
  & 0.15225530E-05_JPRB, 0.15508478E-05_JPRB, 0.15250335E-05_JPRB, 0.14887560E-05_JPRB, 0.14730910E-05_JPRB, 0.15044937E-05_JPRB, &
  & 0.16277824E-05_JPRB, 0.19097762E-05_JPRB, 0.23461128E-05_JPRB, 0.28502223E-05_JPRB, 0.33297135E-05_JPRB, 0.37199146E-05_JPRB, &
  & 0.40227806E-05_JPRB, 0.42264499E-05_JPRB, 0.43671502E-05_JPRB, 0.44615425E-05_JPRB, 0.45206502E-05_JPRB, 0.45483170E-05_JPRB, &
  & 0.45516482E-05_JPRB, 0.45385405E-05_JPRB, 0.45211606E-05_JPRB, 0.44916062E-05_JPRB, 0.44468588E-05_JPRB, 0.44033851E-05_JPRB, &
  & 0.43496773E-05_JPRB, 0.42656913E-05_JPRB, 0.41683255E-05_JPRB, 0.41069049E-05_JPRB, 0.40864325E-05_JPRB, 0.40927164E-05_JPRB, &
  & 0.41170459E-05_JPRB, 0.41665610E-05_JPRB, 0.42399911E-05_JPRB, 0.43095930E-05_JPRB, 0.43592132E-05_JPRB, 0.43702453E-05_JPRB, &
  & 0.43367724E-05_JPRB, 0.42733484E-05_JPRB, 0.42146480E-05_JPRB, 0.41820467E-05_JPRB, 0.41796414E-05_JPRB, 0.42067492E-05_JPRB, &
  & 0.42506339E-05_JPRB, 0.42941670E-05_JPRB, 0.43272476E-05_JPRB, 0.43362948E-05_JPRB, 0.43002367E-05_JPRB, 0.42174924E-05_JPRB, &
  & 0.41122270E-05_JPRB, 0.40026476E-05_JPRB, 0.39026983E-05_JPRB, 0.38127316E-05_JPRB, 0.37423615E-05_JPRB, 0.36714965E-05_JPRB, &
  & 0.35890579E-05_JPRB, 0.34952980E-05_JPRB, 0.33820538E-05_JPRB, 0.32646055E-05_JPRB, 0.31629836E-05_JPRB, 0.30945489E-05_JPRB, &
  & 0.30684631E-05_JPRB, 0.30629080E-05_JPRB, 0.29757428E-05_JPRB, 0.29258599E-05_JPRB  /)

RGHG7(:,27, 9) = (/ &
  & 0.12543891E-05_JPRB, 0.13010931E-05_JPRB, 0.12878849E-05_JPRB, 0.12536484E-05_JPRB, 0.12267779E-05_JPRB, 0.12279657E-05_JPRB, &
  & 0.13183182E-05_JPRB, 0.15771806E-05_JPRB, 0.20332870E-05_JPRB, 0.25966657E-05_JPRB, 0.31226197E-05_JPRB, 0.35122605E-05_JPRB, &
  & 0.37780283E-05_JPRB, 0.39343943E-05_JPRB, 0.40233892E-05_JPRB, 0.40733997E-05_JPRB, 0.41026527E-05_JPRB, 0.41099494E-05_JPRB, &
  & 0.40964324E-05_JPRB, 0.40651557E-05_JPRB, 0.40246445E-05_JPRB, 0.39657956E-05_JPRB, 0.38854707E-05_JPRB, 0.38067397E-05_JPRB, &
  & 0.37167340E-05_JPRB, 0.35886863E-05_JPRB, 0.34441372E-05_JPRB, 0.33533022E-05_JPRB, 0.33284677E-05_JPRB, 0.33326706E-05_JPRB, &
  & 0.33562396E-05_JPRB, 0.34047543E-05_JPRB, 0.34734620E-05_JPRB, 0.35418233E-05_JPRB, 0.35896027E-05_JPRB, 0.35983536E-05_JPRB, &
  & 0.35611989E-05_JPRB, 0.34958940E-05_JPRB, 0.34425962E-05_JPRB, 0.34140770E-05_JPRB, 0.34131123E-05_JPRB, 0.34410205E-05_JPRB, &
  & 0.34944300E-05_JPRB, 0.35577728E-05_JPRB, 0.36191073E-05_JPRB, 0.36610507E-05_JPRB, 0.36565281E-05_JPRB, 0.36019176E-05_JPRB, &
  & 0.35281077E-05_JPRB, 0.34626700E-05_JPRB, 0.34251514E-05_JPRB, 0.34039386E-05_JPRB, 0.33842734E-05_JPRB, 0.33457044E-05_JPRB, &
  & 0.32964820E-05_JPRB, 0.32334572E-05_JPRB, 0.31584719E-05_JPRB, 0.30829242E-05_JPRB, 0.30177203E-05_JPRB, 0.29762188E-05_JPRB, &
  & 0.29761058E-05_JPRB, 0.29799953E-05_JPRB, 0.29219245E-05_JPRB, 0.28901305E-05_JPRB  /)

RGHG7(:,28, 9) = (/ &
  & 0.11638220E-05_JPRB, 0.12167109E-05_JPRB, 0.12079159E-05_JPRB, 0.11754528E-05_JPRB, 0.11414023E-05_JPRB, 0.11290522E-05_JPRB, &
  & 0.11935258E-05_JPRB, 0.14093489E-05_JPRB, 0.18208656E-05_JPRB, 0.23746889E-05_JPRB, 0.29039468E-05_JPRB, 0.32778789E-05_JPRB, &
  & 0.35048889E-05_JPRB, 0.36136798E-05_JPRB, 0.36596077E-05_JPRB, 0.36746742E-05_JPRB, 0.36772896E-05_JPRB, 0.36650446E-05_JPRB, &
  & 0.36364235E-05_JPRB, 0.35916508E-05_JPRB, 0.35313564E-05_JPRB, 0.34524324E-05_JPRB, 0.33492620E-05_JPRB, 0.32432163E-05_JPRB, &
  & 0.31298556E-05_JPRB, 0.29928051E-05_JPRB, 0.28484762E-05_JPRB, 0.27655482E-05_JPRB, 0.27505186E-05_JPRB, 0.27656121E-05_JPRB, &
  & 0.28026634E-05_JPRB, 0.28549400E-05_JPRB, 0.29190466E-05_JPRB, 0.29797399E-05_JPRB, 0.30220520E-05_JPRB, 0.30302485E-05_JPRB, &
  & 0.29967503E-05_JPRB, 0.29366004E-05_JPRB, 0.28937404E-05_JPRB, 0.28751422E-05_JPRB, 0.28802266E-05_JPRB, 0.29113867E-05_JPRB, &
  & 0.29696857E-05_JPRB, 0.30420406E-05_JPRB, 0.31147444E-05_JPRB, 0.31686713E-05_JPRB, 0.31826520E-05_JPRB, 0.31650194E-05_JPRB, &
  & 0.31325508E-05_JPRB, 0.31077082E-05_JPRB, 0.31030877E-05_JPRB, 0.31082156E-05_JPRB, 0.31088863E-05_JPRB, 0.30918883E-05_JPRB, &
  & 0.30633269E-05_JPRB, 0.30246503E-05_JPRB, 0.29789070E-05_JPRB, 0.29294080E-05_JPRB, 0.28855553E-05_JPRB, 0.28631399E-05_JPRB, &
  & 0.28716672E-05_JPRB, 0.28780859E-05_JPRB, 0.28437178E-05_JPRB, 0.28130499E-05_JPRB  /)

RGHG7(:,29, 9) = (/ &
  & 0.10755590E-05_JPRB, 0.11344714E-05_JPRB, 0.11299971E-05_JPRB, 0.10994015E-05_JPRB, 0.10579178E-05_JPRB, 0.10319461E-05_JPRB, &
  & 0.10693049E-05_JPRB, 0.12386612E-05_JPRB, 0.16001409E-05_JPRB, 0.21408553E-05_JPRB, 0.26717427E-05_JPRB, 0.30283733E-05_JPRB, &
  & 0.32142442E-05_JPRB, 0.32726136E-05_JPRB, 0.32732830E-05_JPRB, 0.32517326E-05_JPRB, 0.32262629E-05_JPRB, 0.31933476E-05_JPRB, &
  & 0.31487982E-05_JPRB, 0.30899280E-05_JPRB, 0.30088169E-05_JPRB, 0.29090212E-05_JPRB, 0.27821963E-05_JPRB, 0.26475528E-05_JPRB, &
  & 0.25100066E-05_JPRB, 0.23649370E-05_JPRB, 0.22228966E-05_JPRB, 0.21499651E-05_JPRB, 0.21459388E-05_JPRB, 0.21731342E-05_JPRB, &
  & 0.22250886E-05_JPRB, 0.22815579E-05_JPRB, 0.23407944E-05_JPRB, 0.23930841E-05_JPRB, 0.24294460E-05_JPRB, 0.24371298E-05_JPRB, &
  & 0.24078243E-05_JPRB, 0.23534415E-05_JPRB, 0.23218595E-05_JPRB, 0.23140267E-05_JPRB, 0.23257205E-05_JPRB, 0.23604324E-05_JPRB, &
  & 0.24237113E-05_JPRB, 0.25051473E-05_JPRB, 0.25891656E-05_JPRB, 0.26548831E-05_JPRB, 0.26879047E-05_JPRB, 0.27098366E-05_JPRB, &
  & 0.27216013E-05_JPRB, 0.27396187E-05_JPRB, 0.27685759E-05_JPRB, 0.27997750E-05_JPRB, 0.28206767E-05_JPRB, 0.28260698E-05_JPRB, &
  & 0.28188561E-05_JPRB, 0.28057015E-05_JPRB, 0.27905516E-05_JPRB, 0.27679661E-05_JPRB, 0.27460835E-05_JPRB, 0.27435511E-05_JPRB, &
  & 0.27604819E-05_JPRB, 0.27692808E-05_JPRB, 0.27597938E-05_JPRB, 0.27295836E-05_JPRB  /)

RGHG7(:,30, 9) = (/ &
  & 0.98855509E-06_JPRB, 0.10314375E-05_JPRB, 0.10200351E-05_JPRB, 0.99582633E-06_JPRB, 0.96437212E-06_JPRB, 0.94710557E-06_JPRB, &
  & 0.98509939E-06_JPRB, 0.11343736E-05_JPRB, 0.14438741E-05_JPRB, 0.19331090E-05_JPRB, 0.24305277E-05_JPRB, 0.27641270E-05_JPRB, &
  & 0.29228920E-05_JPRB, 0.29477299E-05_JPRB, 0.29182981E-05_JPRB, 0.28721228E-05_JPRB, 0.28287911E-05_JPRB, 0.27830546E-05_JPRB, &
  & 0.27270392E-05_JPRB, 0.26579754E-05_JPRB, 0.25652975E-05_JPRB, 0.24547230E-05_JPRB, 0.23219902E-05_JPRB, 0.21806784E-05_JPRB, &
  & 0.20438342E-05_JPRB, 0.19090992E-05_JPRB, 0.17876962E-05_JPRB, 0.17286217E-05_JPRB, 0.17325668E-05_JPRB, 0.17654023E-05_JPRB, &
  & 0.18159065E-05_JPRB, 0.18685999E-05_JPRB, 0.19183909E-05_JPRB, 0.19616662E-05_JPRB, 0.19930850E-05_JPRB, 0.20001090E-05_JPRB, &
  & 0.19775302E-05_JPRB, 0.19341378E-05_JPRB, 0.19101414E-05_JPRB, 0.19094272E-05_JPRB, 0.19304233E-05_JPRB, 0.19733089E-05_JPRB, &
  & 0.20415782E-05_JPRB, 0.21259335E-05_JPRB, 0.22117474E-05_JPRB, 0.22827348E-05_JPRB, 0.23340606E-05_JPRB, 0.23799607E-05_JPRB, &
  & 0.24183837E-05_JPRB, 0.24581205E-05_JPRB, 0.24997818E-05_JPRB, 0.25386602E-05_JPRB, 0.25683618E-05_JPRB, 0.25850658E-05_JPRB, &
  & 0.25906418E-05_JPRB, 0.25913582E-05_JPRB, 0.25907915E-05_JPRB, 0.25818531E-05_JPRB, 0.25728894E-05_JPRB, 0.25794299E-05_JPRB, &
  & 0.25939880E-05_JPRB, 0.26075176E-05_JPRB, 0.26064809E-05_JPRB, 0.25791179E-05_JPRB  /)

RGHG7(:,31, 9) = (/ &
  & 0.89688434E-06_JPRB, 0.92285572E-06_JPRB, 0.90414274E-06_JPRB, 0.88666787E-06_JPRB, 0.86579787E-06_JPRB, 0.85772466E-06_JPRB, &
  & 0.89641393E-06_JPRB, 0.10245536E-05_JPRB, 0.12792842E-05_JPRB, 0.17142411E-05_JPRB, 0.21763621E-05_JPRB, 0.24856890E-05_JPRB, &
  & 0.26159071E-05_JPRB, 0.26054303E-05_JPRB, 0.25442969E-05_JPRB, 0.24721868E-05_JPRB, 0.24100443E-05_JPRB, 0.23508062E-05_JPRB, &
  & 0.22827140E-05_JPRB, 0.22029133E-05_JPRB, 0.20980567E-05_JPRB, 0.19761347E-05_JPRB, 0.18371939E-05_JPRB, 0.16888769E-05_JPRB, &
  & 0.15527959E-05_JPRB, 0.14289674E-05_JPRB, 0.13293265E-05_JPRB, 0.12848562E-05_JPRB, 0.12971974E-05_JPRB, 0.13359696E-05_JPRB, &
  & 0.13849303E-05_JPRB, 0.14336376E-05_JPRB, 0.14734720E-05_JPRB, 0.15072486E-05_JPRB, 0.15334602E-05_JPRB, 0.15397887E-05_JPRB, &
  & 0.15243000E-05_JPRB, 0.14924925E-05_JPRB, 0.14764851E-05_JPRB, 0.14832682E-05_JPRB, 0.15140682E-05_JPRB, 0.15655704E-05_JPRB, &
  & 0.16390979E-05_JPRB, 0.17265233E-05_JPRB, 0.18142200E-05_JPRB, 0.18907539E-05_JPRB, 0.19613654E-05_JPRB, 0.20325048E-05_JPRB, &
  & 0.20989997E-05_JPRB, 0.21616011E-05_JPRB, 0.22166284E-05_JPRB, 0.22635807E-05_JPRB, 0.23025434E-05_JPRB, 0.23311546E-05_JPRB, &
  & 0.23501983E-05_JPRB, 0.23655189E-05_JPRB, 0.23803028E-05_JPRB, 0.23857311E-05_JPRB, 0.23903708E-05_JPRB, 0.24064609E-05_JPRB, &
  & 0.24185086E-05_JPRB, 0.24370250E-05_JPRB, 0.24448763E-05_JPRB, 0.24205156E-05_JPRB  /)

RGHG7(:,32, 9) = (/ &
  & 0.80913485E-06_JPRB, 0.82244614E-06_JPRB, 0.79873150E-06_JPRB, 0.78039144E-06_JPRB, 0.76618289E-06_JPRB, 0.76404357E-06_JPRB, &
  & 0.80742494E-06_JPRB, 0.92881309E-06_JPRB, 0.11472735E-05_JPRB, 0.15247417E-05_JPRB, 0.19401471E-05_JPRB, 0.22251980E-05_JPRB, &
  & 0.23420268E-05_JPRB, 0.23163187E-05_JPRB, 0.22407091E-05_JPRB, 0.21579159E-05_JPRB, 0.20904672E-05_JPRB, 0.20275487E-05_JPRB, &
  & 0.19528208E-05_JPRB, 0.18665602E-05_JPRB, 0.17579104E-05_JPRB, 0.16367522E-05_JPRB, 0.15071593E-05_JPRB, 0.13745193E-05_JPRB, &
  & 0.12499241E-05_JPRB, 0.11368753E-05_JPRB, 0.10491211E-05_JPRB, 0.10076340E-05_JPRB, 0.10180244E-05_JPRB, 0.10545596E-05_JPRB, &
  & 0.10969728E-05_JPRB, 0.11374968E-05_JPRB, 0.11684044E-05_JPRB, 0.11949025E-05_JPRB, 0.12166185E-05_JPRB, 0.12233888E-05_JPRB, &
  & 0.12153214E-05_JPRB, 0.11948740E-05_JPRB, 0.11842029E-05_JPRB, 0.11944926E-05_JPRB, 0.12287136E-05_JPRB, 0.12829590E-05_JPRB, &
  & 0.13545157E-05_JPRB, 0.14373794E-05_JPRB, 0.15233867E-05_JPRB, 0.16039487E-05_JPRB, 0.16823904E-05_JPRB, 0.17641904E-05_JPRB, &
  & 0.18442132E-05_JPRB, 0.19159425E-05_JPRB, 0.19787859E-05_JPRB, 0.20333504E-05_JPRB, 0.20787188E-05_JPRB, 0.21137011E-05_JPRB, &
  & 0.21407498E-05_JPRB, 0.21642558E-05_JPRB, 0.21858059E-05_JPRB, 0.21987106E-05_JPRB, 0.22105101E-05_JPRB, 0.22295833E-05_JPRB, &
  & 0.22441656E-05_JPRB, 0.22649412E-05_JPRB, 0.22760846E-05_JPRB, 0.22610545E-05_JPRB  /)

RGHG7(:,33, 9) = (/ &
  & 0.71844913E-06_JPRB, 0.71915382E-06_JPRB, 0.69054016E-06_JPRB, 0.67031709E-06_JPRB, 0.66252354E-06_JPRB, 0.66612900E-06_JPRB, &
  & 0.71490408E-06_JPRB, 0.83113788E-06_JPRB, 0.10142998E-05_JPRB, 0.13316075E-05_JPRB, 0.16969853E-05_JPRB, 0.19568071E-05_JPRB, &
  & 0.20616836E-05_JPRB, 0.20227466E-05_JPRB, 0.19343229E-05_JPRB, 0.18424019E-05_JPRB, 0.17711871E-05_JPRB, 0.17057154E-05_JPRB, &
  & 0.16247959E-05_JPRB, 0.15323757E-05_JPRB, 0.14208695E-05_JPRB, 0.13020729E-05_JPRB, 0.11842090E-05_JPRB, 0.10707981E-05_JPRB, &
  & 0.95952750E-06_JPRB, 0.85766507E-06_JPRB, 0.78098555E-06_JPRB, 0.74109424E-06_JPRB, 0.74811751E-06_JPRB, 0.78126969E-06_JPRB, &
  & 0.81623067E-06_JPRB, 0.84770660E-06_JPRB, 0.86947045E-06_JPRB, 0.88869184E-06_JPRB, 0.90582792E-06_JPRB, 0.91320467E-06_JPRB, &
  & 0.91289272E-06_JPRB, 0.90422209E-06_JPRB, 0.89875317E-06_JPRB, 0.91217064E-06_JPRB, 0.94912041E-06_JPRB, 0.10054563E-05_JPRB, &
  & 0.10740289E-05_JPRB, 0.11511638E-05_JPRB, 0.12349530E-05_JPRB, 0.13195043E-05_JPRB, 0.14046004E-05_JPRB, 0.14955921E-05_JPRB, &
  & 0.15877906E-05_JPRB, 0.16672275E-05_JPRB, 0.17374753E-05_JPRB, 0.17998910E-05_JPRB, 0.18515467E-05_JPRB, 0.18924334E-05_JPRB, &
  & 0.19270939E-05_JPRB, 0.19582756E-05_JPRB, 0.19857459E-05_JPRB, 0.20055284E-05_JPRB, 0.20239344E-05_JPRB, 0.20452577E-05_JPRB, &
  & 0.20631273E-05_JPRB, 0.20858976E-05_JPRB, 0.20997379E-05_JPRB, 0.20952239E-05_JPRB  /)

RGHG7(:,34, 9) = (/ &
  & 0.63080791E-06_JPRB, 0.62756525E-06_JPRB, 0.60130768E-06_JPRB, 0.58276350E-06_JPRB, 0.57808569E-06_JPRB, 0.58530431E-06_JPRB, &
  & 0.63433792E-06_JPRB, 0.74437856E-06_JPRB, 0.90370220E-06_JPRB, 0.11703996E-05_JPRB, 0.14884832E-05_JPRB, 0.17231691E-05_JPRB, &
  & 0.18197621E-05_JPRB, 0.17788802E-05_JPRB, 0.16874201E-05_JPRB, 0.15939492E-05_JPRB, 0.15223646E-05_JPRB, 0.14550340E-05_JPRB, &
  & 0.13722933E-05_JPRB, 0.12787350E-05_JPRB, 0.11702457E-05_JPRB, 0.10560881E-05_JPRB, 0.94661589E-06_JPRB, 0.84638024E-06_JPRB, &
  & 0.74975871E-06_JPRB, 0.66283259E-06_JPRB, 0.59827560E-06_JPRB, 0.56285467E-06_JPRB, 0.56621093E-06_JPRB, 0.59291421E-06_JPRB, &
  & 0.62048463E-06_JPRB, 0.64410598E-06_JPRB, 0.65965507E-06_JPRB, 0.67381173E-06_JPRB, 0.68720368E-06_JPRB, 0.69489761E-06_JPRB, &
  & 0.69905079E-06_JPRB, 0.69762525E-06_JPRB, 0.69698195E-06_JPRB, 0.71214208E-06_JPRB, 0.74679143E-06_JPRB, 0.79802034E-06_JPRB, &
  & 0.86050744E-06_JPRB, 0.93166143E-06_JPRB, 0.10119067E-05_JPRB, 0.10960858E-05_JPRB, 0.11821483E-05_JPRB, 0.12753932E-05_JPRB, &
  & 0.13720681E-05_JPRB, 0.14561367E-05_JPRB, 0.15301948E-05_JPRB, 0.15970690E-05_JPRB, 0.16521822E-05_JPRB, 0.16961300E-05_JPRB, &
  & 0.17352750E-05_JPRB, 0.17707896E-05_JPRB, 0.18006826E-05_JPRB, 0.18252240E-05_JPRB, 0.18480201E-05_JPRB, 0.18712261E-05_JPRB, &
  & 0.18927266E-05_JPRB, 0.19177078E-05_JPRB, 0.19336661E-05_JPRB, 0.19358910E-05_JPRB  /)

RGHG7(:,35, 9) = (/ &
  & 0.54226360E-06_JPRB, 0.53940594E-06_JPRB, 0.51929361E-06_JPRB, 0.50430330E-06_JPRB, 0.50113589E-06_JPRB, 0.51097549E-06_JPRB, &
  & 0.55763985E-06_JPRB, 0.66078005E-06_JPRB, 0.80147547E-06_JPRB, 0.10210396E-05_JPRB, 0.12919012E-05_JPRB, 0.15007918E-05_JPRB, &
  & 0.15907509E-05_JPRB, 0.15536598E-05_JPRB, 0.14640951E-05_JPRB, 0.13729195E-05_JPRB, 0.13026971E-05_JPRB, 0.12338117E-05_JPRB, &
  & 0.11514413E-05_JPRB, 0.10592897E-05_JPRB, 0.95691601E-06_JPRB, 0.84869635E-06_JPRB, 0.74613936E-06_JPRB, 0.65634321E-06_JPRB, &
  & 0.57546238E-06_JPRB, 0.50581697E-06_JPRB, 0.45426124E-06_JPRB, 0.42491151E-06_JPRB, 0.42434370E-06_JPRB, 0.44284345E-06_JPRB, &
  & 0.46284709E-06_JPRB, 0.47900530E-06_JPRB, 0.48966782E-06_JPRB, 0.49975233E-06_JPRB, 0.50972368E-06_JPRB, 0.51759530E-06_JPRB, &
  & 0.52465081E-06_JPRB, 0.52834877E-06_JPRB, 0.53247358E-06_JPRB, 0.54871469E-06_JPRB, 0.57841822E-06_JPRB, 0.62070322E-06_JPRB, &
  & 0.67534218E-06_JPRB, 0.74021766E-06_JPRB, 0.81613907E-06_JPRB, 0.89769714E-06_JPRB, 0.98183464E-06_JPRB, 0.10738357E-05_JPRB, &
  & 0.11711622E-05_JPRB, 0.12584144E-05_JPRB, 0.13345456E-05_JPRB, 0.14042629E-05_JPRB, 0.14614789E-05_JPRB, 0.15071147E-05_JPRB, &
  & 0.15492657E-05_JPRB, 0.15875197E-05_JPRB, 0.16181087E-05_JPRB, 0.16464558E-05_JPRB, 0.16726280E-05_JPRB, 0.16975813E-05_JPRB, &
  & 0.17229910E-05_JPRB, 0.17503563E-05_JPRB, 0.17681952E-05_JPRB, 0.17754104E-05_JPRB  /)

RGHG7(:,36, 9) = (/ &
  & 0.46586557E-06_JPRB, 0.46365563E-06_JPRB, 0.45020866E-06_JPRB, 0.43943950E-06_JPRB, 0.43710071E-06_JPRB, 0.44827152E-06_JPRB, &
  & 0.49100751E-06_JPRB, 0.58513322E-06_JPRB, 0.70798940E-06_JPRB, 0.88485690E-06_JPRB, 0.11108431E-05_JPRB, 0.12939623E-05_JPRB, &
  & 0.13774128E-05_JPRB, 0.13455509E-05_JPRB, 0.12599295E-05_JPRB, 0.11721749E-05_JPRB, 0.11039540E-05_JPRB, 0.10344623E-05_JPRB, &
  & 0.95329391E-06_JPRB, 0.86384598E-06_JPRB, 0.76753059E-06_JPRB, 0.66518598E-06_JPRB, 0.56957424E-06_JPRB, 0.48984233E-06_JPRB, &
  & 0.42331064E-06_JPRB, 0.36940988E-06_JPRB, 0.32997769E-06_JPRB, 0.30679435E-06_JPRB, 0.30340351E-06_JPRB, 0.31461706E-06_JPRB, &
  & 0.32781389E-06_JPRB, 0.33769798E-06_JPRB, 0.34431063E-06_JPRB, 0.35083864E-06_JPRB, 0.35771802E-06_JPRB, 0.36529261E-06_JPRB, &
  & 0.37402499E-06_JPRB, 0.38146917E-06_JPRB, 0.38936937E-06_JPRB, 0.40610049E-06_JPRB, 0.43136513E-06_JPRB, 0.46569460E-06_JPRB, &
  & 0.51257389E-06_JPRB, 0.57036784E-06_JPRB, 0.64090385E-06_JPRB, 0.71882669E-06_JPRB, 0.80013603E-06_JPRB, 0.88960193E-06_JPRB, &
  & 0.98566015E-06_JPRB, 0.10746620E-05_JPRB, 0.11518815E-05_JPRB, 0.12226328E-05_JPRB, 0.12804906E-05_JPRB, 0.13268230E-05_JPRB, &
  & 0.13704071E-05_JPRB, 0.14103007E-05_JPRB, 0.14411381E-05_JPRB, 0.14722136E-05_JPRB, 0.15015013E-05_JPRB, 0.15281073E-05_JPRB, &
  & 0.15566299E-05_JPRB, 0.15859136E-05_JPRB, 0.16058996E-05_JPRB, 0.16176191E-05_JPRB  /)

RGHG7(:,37, 9) = (/ &
  & 0.42206877E-06_JPRB, 0.42106860E-06_JPRB, 0.41506476E-06_JPRB, 0.40978398E-06_JPRB, 0.40665919E-06_JPRB, 0.41612129E-06_JPRB, &
  & 0.45159868E-06_JPRB, 0.53242378E-06_JPRB, 0.64035948E-06_JPRB, 0.78735871E-06_JPRB, 0.97664176E-06_JPRB, 0.11356477E-05_JPRB, &
  & 0.12132817E-05_JPRB, 0.11896217E-05_JPRB, 0.11123934E-05_JPRB, 0.10304279E-05_JPRB, 0.96554923E-06_JPRB, 0.89766372E-06_JPRB, &
  & 0.81953004E-06_JPRB, 0.73559099E-06_JPRB, 0.64482550E-06_JPRB, 0.54784624E-06_JPRB, 0.45881645E-06_JPRB, 0.38766228E-06_JPRB, &
  & 0.33139653E-06_JPRB, 0.28873909E-06_JPRB, 0.25866379E-06_JPRB, 0.24148145E-06_JPRB, 0.23796758E-06_JPRB, 0.24445142E-06_JPRB, &
  & 0.25300739E-06_JPRB, 0.25973379E-06_JPRB, 0.26446685E-06_JPRB, 0.26884189E-06_JPRB, 0.27357512E-06_JPRB, 0.27978275E-06_JPRB, &
  & 0.28727801E-06_JPRB, 0.29507761E-06_JPRB, 0.30424225E-06_JPRB, 0.32007801E-06_JPRB, 0.34234216E-06_JPRB, 0.37147714E-06_JPRB, &
  & 0.41128237E-06_JPRB, 0.46059428E-06_JPRB, 0.52364612E-06_JPRB, 0.59583453E-06_JPRB, 0.67242099E-06_JPRB, 0.75654888E-06_JPRB, &
  & 0.84701619E-06_JPRB, 0.93437085E-06_JPRB, 0.10103533E-05_JPRB, 0.10779264E-05_JPRB, 0.11330365E-05_JPRB, 0.11777491E-05_JPRB, &
  & 0.12190709E-05_JPRB, 0.12579802E-05_JPRB, 0.12880248E-05_JPRB, 0.13191891E-05_JPRB, 0.13508006E-05_JPRB, 0.13787395E-05_JPRB, &
  & 0.14083557E-05_JPRB, 0.14383707E-05_JPRB, 0.14609813E-05_JPRB, 0.14758106E-05_JPRB  /)

RGHG7(:,38, 9) = (/ &
  & 0.37347232E-06_JPRB, 0.37381449E-06_JPRB, 0.37606949E-06_JPRB, 0.37687856E-06_JPRB, 0.37288163E-06_JPRB, 0.38044776E-06_JPRB, &
  & 0.40787108E-06_JPRB, 0.47393797E-06_JPRB, 0.56531809E-06_JPRB, 0.67917582E-06_JPRB, 0.82773350E-06_JPRB, 0.95998356E-06_JPRB, &
  & 0.10311637E-05_JPRB, 0.10166043E-05_JPRB, 0.94868904E-06_JPRB, 0.87314703E-06_JPRB, 0.81197689E-06_JPRB, 0.74587359E-06_JPRB, &
  & 0.67110714E-06_JPRB, 0.59328069E-06_JPRB, 0.50867330E-06_JPRB, 0.41764738E-06_JPRB, 0.33592086E-06_JPRB, 0.27428444E-06_JPRB, &
  & 0.22940966E-06_JPRB, 0.19922768E-06_JPRB, 0.17953470E-06_JPRB, 0.16901099E-06_JPRB, 0.16536061E-06_JPRB, 0.16659641E-06_JPRB, &
  & 0.17000294E-06_JPRB, 0.17322559E-06_JPRB, 0.17587309E-06_JPRB, 0.17785921E-06_JPRB, 0.18021111E-06_JPRB, 0.18490196E-06_JPRB, &
  & 0.19102455E-06_JPRB, 0.19921850E-06_JPRB, 0.20978616E-06_JPRB, 0.22462843E-06_JPRB, 0.24356326E-06_JPRB, 0.26693451E-06_JPRB, &
  & 0.29889043E-06_JPRB, 0.33879076E-06_JPRB, 0.39353827E-06_JPRB, 0.45936382E-06_JPRB, 0.53070982E-06_JPRB, 0.60891471E-06_JPRB, &
  & 0.69317842E-06_JPRB, 0.77870537E-06_JPRB, 0.85331509E-06_JPRB, 0.91736171E-06_JPRB, 0.96942312E-06_JPRB, 0.10123383E-05_JPRB, &
  & 0.10511498E-05_JPRB, 0.10889671E-05_JPRB, 0.11181320E-05_JPRB, 0.11493949E-05_JPRB, 0.11835849E-05_JPRB, 0.12130026E-05_JPRB, &
  & 0.12438323E-05_JPRB, 0.12746587E-05_JPRB, 0.13001815E-05_JPRB, 0.13184615E-05_JPRB  /)

RGHG7(:,39, 9) = (/ &
  & 0.35795663E-06_JPRB, 0.36052493E-06_JPRB, 0.36584682E-06_JPRB, 0.36946285E-06_JPRB, 0.36551740E-06_JPRB, 0.37096968E-06_JPRB, &
  & 0.39241651E-06_JPRB, 0.44672833E-06_JPRB, 0.52380429E-06_JPRB, 0.61901579E-06_JPRB, 0.74220100E-06_JPRB, 0.85549516E-06_JPRB, &
  & 0.91990183E-06_JPRB, 0.91092330E-06_JPRB, 0.85144591E-06_JPRB, 0.78233546E-06_JPRB, 0.72513736E-06_JPRB, 0.66243767E-06_JPRB, &
  & 0.59066875E-06_JPRB, 0.51667754E-06_JPRB, 0.43698555E-06_JPRB, 0.35326642E-06_JPRB, 0.27977552E-06_JPRB, 0.22564744E-06_JPRB, &
  & 0.18817199E-06_JPRB, 0.16377651E-06_JPRB, 0.14809206E-06_JPRB, 0.13970852E-06_JPRB, 0.13588871E-06_JPRB, 0.13530420E-06_JPRB, &
  & 0.13680975E-06_JPRB, 0.13884006E-06_JPRB, 0.14085056E-06_JPRB, 0.14209712E-06_JPRB, 0.14311581E-06_JPRB, 0.14602285E-06_JPRB, &
  & 0.15066835E-06_JPRB, 0.15823417E-06_JPRB, 0.16906076E-06_JPRB, 0.18350874E-06_JPRB, 0.20078165E-06_JPRB, 0.22091671E-06_JPRB, &
  & 0.24777760E-06_JPRB, 0.28067896E-06_JPRB, 0.32793022E-06_JPRB, 0.38746800E-06_JPRB, 0.45313267E-06_JPRB, 0.52526724E-06_JPRB, &
  & 0.60365541E-06_JPRB, 0.68402765E-06_JPRB, 0.75429110E-06_JPRB, 0.81347155E-06_JPRB, 0.86199075E-06_JPRB, 0.90168051E-06_JPRB, &
  & 0.93625201E-06_JPRB, 0.96992097E-06_JPRB, 0.99796365E-06_JPRB, 0.10280877E-05_JPRB, 0.10631332E-05_JPRB, 0.10936100E-05_JPRB, &
  & 0.11238790E-05_JPRB, 0.11535447E-05_JPRB, 0.11800784E-05_JPRB, 0.12000897E-05_JPRB  /)

RGHG7(:,40, 9) = (/ &
  & 0.34515973E-06_JPRB, 0.35048517E-06_JPRB, 0.35855689E-06_JPRB, 0.36493006E-06_JPRB, 0.36119613E-06_JPRB, 0.36413198E-06_JPRB, &
  & 0.37890481E-06_JPRB, 0.41991236E-06_JPRB, 0.48056953E-06_JPRB, 0.55626959E-06_JPRB, 0.65218982E-06_JPRB, 0.74451373E-06_JPRB, &
  & 0.80091889E-06_JPRB, 0.79791414E-06_JPRB, 0.74819612E-06_JPRB, 0.68663496E-06_JPRB, 0.63414149E-06_JPRB, 0.57570150E-06_JPRB, &
  & 0.50738993E-06_JPRB, 0.43752713E-06_JPRB, 0.36340046E-06_JPRB, 0.28847789E-06_JPRB, 0.22480472E-06_JPRB, 0.17915956E-06_JPRB, &
  & 0.14971480E-06_JPRB, 0.13101593E-06_JPRB, 0.11899308E-06_JPRB, 0.11238198E-06_JPRB, 0.10835793E-06_JPRB, 0.10619792E-06_JPRB, &
  & 0.10600397E-06_JPRB, 0.10701312E-06_JPRB, 0.10851304E-06_JPRB, 0.10916149E-06_JPRB, 0.10878703E-06_JPRB, 0.10955692E-06_JPRB, &
  & 0.11245187E-06_JPRB, 0.11911323E-06_JPRB, 0.13005652E-06_JPRB, 0.14413980E-06_JPRB, 0.15973509E-06_JPRB, 0.17648574E-06_JPRB, &
  & 0.19781778E-06_JPRB, 0.22289997E-06_JPRB, 0.26148596E-06_JPRB, 0.31365679E-06_JPRB, 0.37258181E-06_JPRB, 0.43756826E-06_JPRB, &
  & 0.50911466E-06_JPRB, 0.58289312E-06_JPRB, 0.64756937E-06_JPRB, 0.70081980E-06_JPRB, 0.74510119E-06_JPRB, 0.78077195E-06_JPRB, &
  & 0.81008448E-06_JPRB, 0.83838505E-06_JPRB, 0.86507105E-06_JPRB, 0.89365604E-06_JPRB, 0.92942367E-06_JPRB, 0.96107481E-06_JPRB, &
  & 0.99039559E-06_JPRB, 0.10183764E-05_JPRB, 0.10457853E-05_JPRB, 0.10675472E-05_JPRB  /)

RGHG7(:,41, 9) = (/ &
  & 0.32951368E-06_JPRB, 0.33821010E-06_JPRB, 0.34964390E-06_JPRB, 0.35938806E-06_JPRB, 0.35591276E-06_JPRB, 0.35577191E-06_JPRB, &
  & 0.36238479E-06_JPRB, 0.38712596E-06_JPRB, 0.42770878E-06_JPRB, 0.47955326E-06_JPRB, 0.54213811E-06_JPRB, 0.60882285E-06_JPRB, &
  & 0.65544500E-06_JPRB, 0.65974406E-06_JPRB, 0.62195829E-06_JPRB, 0.56962724E-06_JPRB, 0.52288585E-06_JPRB, 0.46965396E-06_JPRB, &
  & 0.40556951E-06_JPRB, 0.34075428E-06_JPRB, 0.27343203E-06_JPRB, 0.20926453E-06_JPRB, 0.15759495E-06_JPRB, 0.12232139E-06_JPRB, &
  & 0.10269532E-06_JPRB, 0.90961386E-07_JPRB, 0.83415350E-07_JPRB, 0.78971323E-07_JPRB, 0.74697572E-07_JPRB, 0.70611280E-07_JPRB, &
  & 0.68339442E-07_JPRB, 0.68100070E-07_JPRB, 0.68975735E-07_JPRB, 0.68892908E-07_JPRB, 0.66815117E-07_JPRB, 0.64972044E-07_JPRB, &
  & 0.65726677E-07_JPRB, 0.71282209E-07_JPRB, 0.82368191E-07_JPRB, 0.96005573E-07_JPRB, 0.10954973E-06_JPRB, 0.12216244E-06_JPRB, &
  & 0.13673465E-06_JPRB, 0.15225678E-06_JPRB, 0.18024822E-06_JPRB, 0.22341190E-06_JPRB, 0.27409671E-06_JPRB, 0.33034355E-06_JPRB, &
  & 0.39352489E-06_JPRB, 0.45924151E-06_JPRB, 0.51708659E-06_JPRB, 0.56308671E-06_JPRB, 0.60218675E-06_JPRB, 0.63294372E-06_JPRB, &
  & 0.65582638E-06_JPRB, 0.67756333E-06_JPRB, 0.70259058E-06_JPRB, 0.72929388E-06_JPRB, 0.76594439E-06_JPRB, 0.79903133E-06_JPRB, &
  & 0.82719277E-06_JPRB, 0.85311350E-06_JPRB, 0.88159263E-06_JPRB, 0.90549476E-06_JPRB  /)

RGHG7(:,42, 9) = (/ &
  & 0.33321463E-06_JPRB, 0.34140164E-06_JPRB, 0.35206026E-06_JPRB, 0.35914494E-06_JPRB, 0.35766885E-06_JPRB, 0.35835182E-06_JPRB, &
  & 0.36509974E-06_JPRB, 0.38784893E-06_JPRB, 0.42352033E-06_JPRB, 0.47037524E-06_JPRB, 0.52797577E-06_JPRB, 0.58717585E-06_JPRB, &
  & 0.62832517E-06_JPRB, 0.63254572E-06_JPRB, 0.59956661E-06_JPRB, 0.55268944E-06_JPRB, 0.50856799E-06_JPRB, 0.45683376E-06_JPRB, &
  & 0.39457447E-06_JPRB, 0.33113975E-06_JPRB, 0.26755145E-06_JPRB, 0.20823459E-06_JPRB, 0.16018104E-06_JPRB, 0.12729712E-06_JPRB, &
  & 0.10751567E-06_JPRB, 0.94898839E-07_JPRB, 0.86919818E-07_JPRB, 0.81849422E-07_JPRB, 0.77712678E-07_JPRB, 0.74669521E-07_JPRB, &
  & 0.73309820E-07_JPRB, 0.73013082E-07_JPRB, 0.73122485E-07_JPRB, 0.72237075E-07_JPRB, 0.70046379E-07_JPRB, 0.68943480E-07_JPRB, &
  & 0.70369718E-07_JPRB, 0.75607783E-07_JPRB, 0.85585205E-07_JPRB, 0.98025142E-07_JPRB, 0.11120578E-06_JPRB, 0.12399529E-06_JPRB, &
  & 0.13793639E-06_JPRB, 0.15320272E-06_JPRB, 0.17882286E-06_JPRB, 0.21737241E-06_JPRB, 0.26395889E-06_JPRB, 0.31711418E-06_JPRB, &
  & 0.37690203E-06_JPRB, 0.43724068E-06_JPRB, 0.48881905E-06_JPRB, 0.52995527E-06_JPRB, 0.56606024E-06_JPRB, 0.59457338E-06_JPRB, &
  & 0.61562809E-06_JPRB, 0.63518555E-06_JPRB, 0.65645365E-06_JPRB, 0.68237610E-06_JPRB, 0.71638317E-06_JPRB, 0.74656600E-06_JPRB, &
  & 0.77065571E-06_JPRB, 0.79471304E-06_JPRB, 0.81933238E-06_JPRB, 0.84107811E-06_JPRB  /)

RGHG7(:,43, 9) = (/ &
  & 0.32986118E-06_JPRB, 0.33903344E-06_JPRB, 0.35043100E-06_JPRB, 0.35653923E-06_JPRB, 0.35699845E-06_JPRB, 0.35710963E-06_JPRB, &
  & 0.36047075E-06_JPRB, 0.37440548E-06_JPRB, 0.39696074E-06_JPRB, 0.42900173E-06_JPRB, 0.46771538E-06_JPRB, 0.50905782E-06_JPRB, &
  & 0.54100561E-06_JPRB, 0.54829628E-06_JPRB, 0.52483537E-06_JPRB, 0.48690462E-06_JPRB, 0.44764784E-06_JPRB, 0.39952032E-06_JPRB, &
  & 0.34074460E-06_JPRB, 0.28074066E-06_JPRB, 0.22348609E-06_JPRB, 0.17322122E-06_JPRB, 0.13363025E-06_JPRB, 0.10738797E-06_JPRB, &
  & 0.91688265E-07_JPRB, 0.81261854E-07_JPRB, 0.74813489E-07_JPRB, 0.70103764E-07_JPRB, 0.65984614E-07_JPRB, 0.63064613E-07_JPRB, &
  & 0.61643334E-07_JPRB, 0.60757206E-07_JPRB, 0.59898954E-07_JPRB, 0.57966716E-07_JPRB, 0.54940318E-07_JPRB, 0.53388778E-07_JPRB, &
  & 0.54507126E-07_JPRB, 0.58979863E-07_JPRB, 0.68007224E-07_JPRB, 0.79162818E-07_JPRB, 0.91129486E-07_JPRB, 0.10230037E-06_JPRB, &
  & 0.11275792E-06_JPRB, 0.12367859E-06_JPRB, 0.14257792E-06_JPRB, 0.17304315E-06_JPRB, 0.21234582E-06_JPRB, 0.25892105E-06_JPRB, &
  & 0.31201449E-06_JPRB, 0.36397853E-06_JPRB, 0.40690078E-06_JPRB, 0.44048048E-06_JPRB, 0.47162402E-06_JPRB, 0.49597624E-06_JPRB, &
  & 0.51259733E-06_JPRB, 0.52734290E-06_JPRB, 0.54446768E-06_JPRB, 0.56886827E-06_JPRB, 0.60084326E-06_JPRB, 0.62899401E-06_JPRB, &
  & 0.64887003E-06_JPRB, 0.67034107E-06_JPRB, 0.69189911E-06_JPRB, 0.71259801E-06_JPRB  /)

RGHG7(:,44, 9) = (/ &
  & 0.32313693E-06_JPRB, 0.33092302E-06_JPRB, 0.34020777E-06_JPRB, 0.34588633E-06_JPRB, 0.34676733E-06_JPRB, 0.34735494E-06_JPRB, &
  & 0.35058416E-06_JPRB, 0.36255682E-06_JPRB, 0.38236565E-06_JPRB, 0.40985565E-06_JPRB, 0.44278802E-06_JPRB, 0.47696949E-06_JPRB, &
  & 0.50412242E-06_JPRB, 0.51198553E-06_JPRB, 0.49301155E-06_JPRB, 0.45999870E-06_JPRB, 0.42379016E-06_JPRB, 0.37824804E-06_JPRB, &
  & 0.32223052E-06_JPRB, 0.26497548E-06_JPRB, 0.21040155E-06_JPRB, 0.16312569E-06_JPRB, 0.12634287E-06_JPRB, 0.10203476E-06_JPRB, &
  & 0.86905120E-07_JPRB, 0.76966904E-07_JPRB, 0.70845032E-07_JPRB, 0.66280940E-07_JPRB, 0.62360647E-07_JPRB, 0.59536857E-07_JPRB, &
  & 0.58095889E-07_JPRB, 0.57059197E-07_JPRB, 0.56054465E-07_JPRB, 0.54117142E-07_JPRB, 0.51111488E-07_JPRB, 0.49871161E-07_JPRB, &
  & 0.51251004E-07_JPRB, 0.55801086E-07_JPRB, 0.64308708E-07_JPRB, 0.74636870E-07_JPRB, 0.85696309E-07_JPRB, 0.95811638E-07_JPRB, &
  & 0.10532205E-06_JPRB, 0.11523970E-06_JPRB, 0.13180824E-06_JPRB, 0.15880578E-06_JPRB, 0.19454055E-06_JPRB, 0.23746601E-06_JPRB, &
  & 0.28640708E-06_JPRB, 0.33437488E-06_JPRB, 0.37394972E-06_JPRB, 0.40457148E-06_JPRB, 0.43293136E-06_JPRB, 0.45582813E-06_JPRB, &
  & 0.47172117E-06_JPRB, 0.48492440E-06_JPRB, 0.49918611E-06_JPRB, 0.52134207E-06_JPRB, 0.55034854E-06_JPRB, 0.57473891E-06_JPRB, &
  & 0.59169904E-06_JPRB, 0.61160053E-06_JPRB, 0.62999357E-06_JPRB, 0.64688717E-06_JPRB  /)

RGHG7(:,45, 9) = (/ &
  & 0.31505825E-06_JPRB, 0.32139075E-06_JPRB, 0.32836355E-06_JPRB, 0.33342962E-06_JPRB, 0.33503526E-06_JPRB, 0.33609302E-06_JPRB, &
  & 0.33874426E-06_JPRB, 0.34736977E-06_JPRB, 0.36239512E-06_JPRB, 0.38283283E-06_JPRB, 0.40679779E-06_JPRB, 0.43057120E-06_JPRB, &
  & 0.45110317E-06_JPRB, 0.46000579E-06_JPRB, 0.44734221E-06_JPRB, 0.42105815E-06_JPRB, 0.38893433E-06_JPRB, 0.34679112E-06_JPRB, &
  & 0.29435366E-06_JPRB, 0.24066143E-06_JPRB, 0.18993931E-06_JPRB, 0.14720969E-06_JPRB, 0.11469275E-06_JPRB, 0.93425538E-07_JPRB, &
  & 0.79460500E-07_JPRB, 0.70354756E-07_JPRB, 0.64797930E-07_JPRB, 0.60445192E-07_JPRB, 0.56753505E-07_JPRB, 0.54054802E-07_JPRB, &
  & 0.52583640E-07_JPRB, 0.51301088E-07_JPRB, 0.50007363E-07_JPRB, 0.47932014E-07_JPRB, 0.44844407E-07_JPRB, 0.43901699E-07_JPRB, &
  & 0.45540342E-07_JPRB, 0.50081797E-07_JPRB, 0.57877720E-07_JPRB, 0.67101670E-07_JPRB, 0.76974944E-07_JPRB, 0.85684127E-07_JPRB, &
  & 0.93676248E-07_JPRB, 0.10190307E-06_JPRB, 0.11496919E-06_JPRB, 0.13699777E-06_JPRB, 0.16775065E-06_JPRB, 0.20568990E-06_JPRB, &
  & 0.24905815E-06_JPRB, 0.29141863E-06_JPRB, 0.32608920E-06_JPRB, 0.35238901E-06_JPRB, 0.37695317E-06_JPRB, 0.39766739E-06_JPRB, &
  & 0.41217154E-06_JPRB, 0.42301106E-06_JPRB, 0.43348998E-06_JPRB, 0.45289835E-06_JPRB, 0.47826869E-06_JPRB, 0.49812144E-06_JPRB, &
  & 0.51122977E-06_JPRB, 0.52901772E-06_JPRB, 0.54342093E-06_JPRB, 0.55585024E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART18',0,ZHOOK_HANDLE)



RGHG7(:,46, 9) = (/ &
  & 0.29891153E-06_JPRB, 0.30378862E-06_JPRB, 0.30865828E-06_JPRB, 0.31296766E-06_JPRB, 0.31484896E-06_JPRB, 0.31597213E-06_JPRB, &
  & 0.31852650E-06_JPRB, 0.32605952E-06_JPRB, 0.33943035E-06_JPRB, 0.35761514E-06_JPRB, 0.37807204E-06_JPRB, 0.39706959E-06_JPRB, &
  & 0.41350387E-06_JPRB, 0.42186866E-06_JPRB, 0.41286085E-06_JPRB, 0.39108686E-06_JPRB, 0.36269720E-06_JPRB, 0.32437387E-06_JPRB, &
  & 0.27606918E-06_JPRB, 0.22596575E-06_JPRB, 0.17793962E-06_JPRB, 0.13772709E-06_JPRB, 0.10744082E-06_JPRB, 0.87652707E-07_JPRB, &
  & 0.74575227E-07_JPRB, 0.66277132E-07_JPRB, 0.61171014E-07_JPRB, 0.57069452E-07_JPRB, 0.53637755E-07_JPRB, 0.51161910E-07_JPRB, &
  & 0.49658014E-07_JPRB, 0.48301835E-07_JPRB, 0.46874678E-07_JPRB, 0.44760314E-07_JPRB, 0.41840190E-07_JPRB, 0.41236791E-07_JPRB, &
  & 0.43080014E-07_JPRB, 0.47623359E-07_JPRB, 0.54966078E-07_JPRB, 0.63320718E-07_JPRB, 0.72205701E-07_JPRB, 0.79866185E-07_JPRB, &
  & 0.86912875E-07_JPRB, 0.94200592E-07_JPRB, 0.10526070E-06_JPRB, 0.12412818E-06_JPRB, 0.15134032E-06_JPRB, 0.18481898E-06_JPRB, &
  & 0.22353408E-06_JPRB, 0.26200447E-06_JPRB, 0.29391373E-06_JPRB, 0.31832413E-06_JPRB, 0.34084265E-06_JPRB, 0.36044533E-06_JPRB, &
  & 0.37462103E-06_JPRB, 0.38482941E-06_JPRB, 0.39422472E-06_JPRB, 0.41127754E-06_JPRB, 0.43391094E-06_JPRB, 0.45192151E-06_JPRB, &
  & 0.46416912E-06_JPRB, 0.48089652E-06_JPRB, 0.49383649E-06_JPRB, 0.50404713E-06_JPRB  /)

RGHG7(:,47, 9) = (/ &
  & 0.27834840E-06_JPRB, 0.28151731E-06_JPRB, 0.28396093E-06_JPRB, 0.28735352E-06_JPRB, 0.28946834E-06_JPRB, 0.29058719E-06_JPRB, &
  & 0.29312425E-06_JPRB, 0.29982697E-06_JPRB, 0.31188316E-06_JPRB, 0.32838571E-06_JPRB, 0.34581979E-06_JPRB, 0.36034148E-06_JPRB, &
  & 0.37247288E-06_JPRB, 0.37989062E-06_JPRB, 0.37464079E-06_JPRB, 0.35771456E-06_JPRB, 0.33363643E-06_JPRB, 0.29987977E-06_JPRB, &
  & 0.25653528E-06_JPRB, 0.21064824E-06_JPRB, 0.16555412E-06_JPRB, 0.12788872E-06_JPRB, 0.99812265E-07_JPRB, 0.81446915E-07_JPRB, &
  & 0.69355422E-07_JPRB, 0.62000067E-07_JPRB, 0.57399915E-07_JPRB, 0.53601069E-07_JPRB, 0.50480735E-07_JPRB, 0.48285983E-07_JPRB, &
  & 0.46743166E-07_JPRB, 0.45335093E-07_JPRB, 0.43782525E-07_JPRB, 0.41642215E-07_JPRB, 0.38968587E-07_JPRB, 0.38771691E-07_JPRB, &
  & 0.40844113E-07_JPRB, 0.45391783E-07_JPRB, 0.52254481E-07_JPRB, 0.59636109E-07_JPRB, 0.67401047E-07_JPRB, 0.73902565E-07_JPRB, &
  & 0.79954620E-07_JPRB, 0.86290948E-07_JPRB, 0.95296918E-07_JPRB, 0.11081723E-06_JPRB, 0.13416327E-06_JPRB, 0.16251308E-06_JPRB, &
  & 0.19595229E-06_JPRB, 0.23020197E-06_JPRB, 0.25930031E-06_JPRB, 0.28198090E-06_JPRB, 0.30244961E-06_JPRB, 0.32096251E-06_JPRB, &
  & 0.33496524E-06_JPRB, 0.34478009E-06_JPRB, 0.35344456E-06_JPRB, 0.36781186E-06_JPRB, 0.38741378E-06_JPRB, 0.40380268E-06_JPRB, &
  & 0.41563945E-06_JPRB, 0.43133329E-06_JPRB, 0.44306241E-06_JPRB, 0.45111944E-06_JPRB  /)

RGHG7(:,48, 9) = (/ &
  & 0.25199586E-06_JPRB, 0.25390327E-06_JPRB, 0.25535095E-06_JPRB, 0.25819826E-06_JPRB, 0.26053447E-06_JPRB, 0.26131963E-06_JPRB, &
  & 0.26351354E-06_JPRB, 0.26948304E-06_JPRB, 0.28071050E-06_JPRB, 0.29683140E-06_JPRB, 0.31303333E-06_JPRB, 0.32528339E-06_JPRB, &
  & 0.33476447E-06_JPRB, 0.34072455E-06_JPRB, 0.33732716E-06_JPRB, 0.32367867E-06_JPRB, 0.30346379E-06_JPRB, 0.27455956E-06_JPRB, &
  & 0.23654288E-06_JPRB, 0.19560804E-06_JPRB, 0.15433935E-06_JPRB, 0.11948381E-06_JPRB, 0.93383125E-07_JPRB, 0.76412143E-07_JPRB, &
  & 0.65346377E-07_JPRB, 0.58745600E-07_JPRB, 0.54656405E-07_JPRB, 0.51209911E-07_JPRB, 0.48390461E-07_JPRB, 0.46331508E-07_JPRB, &
  & 0.44746109E-07_JPRB, 0.43246216E-07_JPRB, 0.41716814E-07_JPRB, 0.39617254E-07_JPRB, 0.37225631E-07_JPRB, 0.37331737E-07_JPRB, &
  & 0.39570316E-07_JPRB, 0.44051053E-07_JPRB, 0.50560937E-07_JPRB, 0.57213272E-07_JPRB, 0.64004386E-07_JPRB, 0.69580421E-07_JPRB, &
  & 0.74811650E-07_JPRB, 0.80365310E-07_JPRB, 0.87935212E-07_JPRB, 0.10099529E-06_JPRB, 0.12077251E-06_JPRB, 0.14440177E-06_JPRB, &
  & 0.17294409E-06_JPRB, 0.20289665E-06_JPRB, 0.22886968E-06_JPRB, 0.24962045E-06_JPRB, 0.26853501E-06_JPRB, 0.28578741E-06_JPRB, &
  & 0.29936473E-06_JPRB, 0.30941452E-06_JPRB, 0.31813336E-06_JPRB, 0.33073024E-06_JPRB, 0.34899237E-06_JPRB, 0.36521612E-06_JPRB, &
  & 0.37789938E-06_JPRB, 0.39285483E-06_JPRB, 0.40458668E-06_JPRB, 0.41288066E-06_JPRB  /)

RGHG7(:,49, 9) = (/ &
  & 0.22018095E-06_JPRB, 0.22089446E-06_JPRB, 0.22188943E-06_JPRB, 0.22430178E-06_JPRB, 0.22687767E-06_JPRB, 0.22714354E-06_JPRB, &
  & 0.22880929E-06_JPRB, 0.23401097E-06_JPRB, 0.24454161E-06_JPRB, 0.26083116E-06_JPRB, 0.27648275E-06_JPRB, 0.28721935E-06_JPRB, &
  & 0.29451679E-06_JPRB, 0.29863054E-06_JPRB, 0.29641817E-06_JPRB, 0.28568564E-06_JPRB, 0.26954512E-06_JPRB, 0.24614438E-06_JPRB, &
  & 0.21419485E-06_JPRB, 0.17907863E-06_JPRB, 0.14245239E-06_JPRB, 0.11082793E-06_JPRB, 0.86808809E-07_JPRB, 0.71369039E-07_JPRB, &
  & 0.61457230E-07_JPRB, 0.55606526E-07_JPRB, 0.52085433E-07_JPRB, 0.49051701E-07_JPRB, 0.46560685E-07_JPRB, 0.44586060E-07_JPRB, &
  & 0.42951839E-07_JPRB, 0.41332112E-07_JPRB, 0.39895915E-07_JPRB, 0.37871806E-07_JPRB, 0.35808616E-07_JPRB, 0.36203212E-07_JPRB, &
  & 0.38597131E-07_JPRB, 0.42971349E-07_JPRB, 0.49148361E-07_JPRB, 0.55103883E-07_JPRB, 0.60883066E-07_JPRB, 0.65540373E-07_JPRB, &
  & 0.69941640E-07_JPRB, 0.74705283E-07_JPRB, 0.80965887E-07_JPRB, 0.91704733E-07_JPRB, 0.10766502E-06_JPRB, 0.12625237E-06_JPRB, &
  & 0.14954419E-06_JPRB, 0.17470339E-06_JPRB, 0.19707252E-06_JPRB, 0.21559526E-06_JPRB, 0.23301412E-06_JPRB, 0.24879300E-06_JPRB, &
  & 0.26178446E-06_JPRB, 0.27238016E-06_JPRB, 0.28151620E-06_JPRB, 0.29256856E-06_JPRB, 0.31011612E-06_JPRB, 0.32681921E-06_JPRB, &
  & 0.34101149E-06_JPRB, 0.35528344E-06_JPRB, 0.36757008E-06_JPRB, 0.37721330E-06_JPRB  /)

RGHG7(:,50, 9) = (/ &
  & 0.18932914E-06_JPRB, 0.18915605E-06_JPRB, 0.19009384E-06_JPRB, 0.19252114E-06_JPRB, 0.19522156E-06_JPRB, 0.19500319E-06_JPRB, &
  & 0.19590489E-06_JPRB, 0.20020788E-06_JPRB, 0.20941452E-06_JPRB, 0.22556164E-06_JPRB, 0.24072460E-06_JPRB, 0.25062298E-06_JPRB, &
  & 0.25672166E-06_JPRB, 0.25948738E-06_JPRB, 0.25733950E-06_JPRB, 0.24853558E-06_JPRB, 0.23525635E-06_JPRB, 0.21656597E-06_JPRB, &
  & 0.19052505E-06_JPRB, 0.16153181E-06_JPRB, 0.13031940E-06_JPRB, 0.10277895E-06_JPRB, 0.81175623E-07_JPRB, 0.67275053E-07_JPRB, &
  & 0.58355040E-07_JPRB, 0.53173667E-07_JPRB, 0.50102301E-07_JPRB, 0.47474704E-07_JPRB, 0.45200712E-07_JPRB, 0.43270973E-07_JPRB, &
  & 0.41535692E-07_JPRB, 0.39925811E-07_JPRB, 0.38560479E-07_JPRB, 0.36602871E-07_JPRB, 0.34808627E-07_JPRB, 0.35433143E-07_JPRB, &
  & 0.37983150E-07_JPRB, 0.42279264E-07_JPRB, 0.48180111E-07_JPRB, 0.53640927E-07_JPRB, 0.58655044E-07_JPRB, 0.62576325E-07_JPRB, &
  & 0.66306653E-07_JPRB, 0.70448476E-07_JPRB, 0.75620329E-07_JPRB, 0.84626508E-07_JPRB, 0.97351061E-07_JPRB, 0.11193861E-06_JPRB, &
  & 0.13068645E-06_JPRB, 0.15128965E-06_JPRB, 0.16976149E-06_JPRB, 0.18539363E-06_JPRB, 0.20078300E-06_JPRB, 0.21427138E-06_JPRB, &
  & 0.22580638E-06_JPRB, 0.23567344E-06_JPRB, 0.24466035E-06_JPRB, 0.25476625E-06_JPRB, 0.27215656E-06_JPRB, 0.28933659E-06_JPRB, &
  & 0.30446515E-06_JPRB, 0.31813426E-06_JPRB, 0.33061821E-06_JPRB, 0.34141660E-06_JPRB  /)

RGHG7(:,51, 9) = (/ &
  & 0.15646482E-06_JPRB, 0.15549430E-06_JPRB, 0.15657812E-06_JPRB, 0.15925811E-06_JPRB, 0.16203271E-06_JPRB, 0.16130898E-06_JPRB, &
  & 0.16126025E-06_JPRB, 0.16452239E-06_JPRB, 0.17196724E-06_JPRB, 0.18779678E-06_JPRB, 0.20246365E-06_JPRB, 0.21181032E-06_JPRB, &
  & 0.21713011E-06_JPRB, 0.21869967E-06_JPRB, 0.21603253E-06_JPRB, 0.20879567E-06_JPRB, 0.19797366E-06_JPRB, 0.18396128E-06_JPRB, &
  & 0.16422802E-06_JPRB, 0.14201765E-06_JPRB, 0.11706653E-06_JPRB, 0.94391852E-07_JPRB, 0.75577248E-07_JPRB, 0.63345737E-07_JPRB, &
  & 0.55413251E-07_JPRB, 0.50913410E-07_JPRB, 0.48266264E-07_JPRB, 0.46074477E-07_JPRB, 0.43976664E-07_JPRB, 0.42074742E-07_JPRB, &
  & 0.40202691E-07_JPRB, 0.38671627E-07_JPRB, 0.37371203E-07_JPRB, 0.35480821E-07_JPRB, 0.33946208E-07_JPRB, 0.34788630E-07_JPRB, &
  & 0.37507861E-07_JPRB, 0.41734430E-07_JPRB, 0.47366373E-07_JPRB, 0.52398333E-07_JPRB, 0.56714691E-07_JPRB, 0.59935894E-07_JPRB, &
  & 0.63024098E-07_JPRB, 0.66581751E-07_JPRB, 0.70691896E-07_JPRB, 0.78133332E-07_JPRB, 0.87663490E-07_JPRB, 0.98472472E-07_JPRB, &
  & 0.11267676E-06_JPRB, 0.12847678E-06_JPRB, 0.14257893E-06_JPRB, 0.15473618E-06_JPRB, 0.16764977E-06_JPRB, 0.17823121E-06_JPRB, &
  & 0.18773321E-06_JPRB, 0.19614215E-06_JPRB, 0.20467008E-06_JPRB, 0.21406662E-06_JPRB, 0.23157979E-06_JPRB, 0.24927445E-06_JPRB, &
  & 0.26511469E-06_JPRB, 0.27817412E-06_JPRB, 0.29068357E-06_JPRB, 0.30262944E-06_JPRB  /)

RGHG7(:,52, 9) = (/ &
  & 0.13010928E-06_JPRB, 0.12890733E-06_JPRB, 0.12990480E-06_JPRB, 0.13265406E-06_JPRB, 0.13534180E-06_JPRB, 0.13421726E-06_JPRB, &
  & 0.13353532E-06_JPRB, 0.13592488E-06_JPRB, 0.14156368E-06_JPRB, 0.15613847E-06_JPRB, 0.16966334E-06_JPRB, 0.17838960E-06_JPRB, &
  & 0.18311102E-06_JPRB, 0.18450441E-06_JPRB, 0.18157391E-06_JPRB, 0.17534866E-06_JPRB, 0.16643127E-06_JPRB, 0.15577301E-06_JPRB, &
  & 0.14086666E-06_JPRB, 0.12460814E-06_JPRB, 0.10515900E-06_JPRB, 0.86875065E-07_JPRB, 0.70939623E-07_JPRB, 0.60224387E-07_JPRB, &
  & 0.53178781E-07_JPRB, 0.49238622E-07_JPRB, 0.46956176E-07_JPRB, 0.45090621E-07_JPRB, 0.43108513E-07_JPRB, 0.41169038E-07_JPRB, &
  & 0.39213147E-07_JPRB, 0.37700999E-07_JPRB, 0.36427479E-07_JPRB, 0.34597803E-07_JPRB, 0.33242178E-07_JPRB, 0.34246055E-07_JPRB, &
  & 0.37133951E-07_JPRB, 0.41407098E-07_JPRB, 0.46824436E-07_JPRB, 0.51475547E-07_JPRB, 0.55319276E-07_JPRB, 0.58019112E-07_JPRB, &
  & 0.60703986E-07_JPRB, 0.63785468E-07_JPRB, 0.67193527E-07_JPRB, 0.73426432E-07_JPRB, 0.80784837E-07_JPRB, 0.88964152E-07_JPRB, &
  & 0.99754810E-07_JPRB, 0.11190910E-06_JPRB, 0.12230937E-06_JPRB, 0.13134525E-06_JPRB, 0.14153608E-06_JPRB, 0.14943654E-06_JPRB, &
  & 0.15666166E-06_JPRB, 0.16301187E-06_JPRB, 0.17029792E-06_JPRB, 0.17868601E-06_JPRB, 0.19531337E-06_JPRB, 0.21218134E-06_JPRB, &
  & 0.22730608E-06_JPRB, 0.23952250E-06_JPRB, 0.25097466E-06_JPRB, 0.26185240E-06_JPRB  /)

RGHG7(:,53, 9) = (/ &
  & 0.10391263E-06_JPRB, 0.10267644E-06_JPRB, 0.10349045E-06_JPRB, 0.10624461E-06_JPRB, 0.10877579E-06_JPRB, 0.10725498E-06_JPRB, &
  & 0.10600554E-06_JPRB, 0.10750961E-06_JPRB, 0.11116462E-06_JPRB, 0.12401246E-06_JPRB, 0.13604520E-06_JPRB, 0.14406943E-06_JPRB, &
  & 0.14820867E-06_JPRB, 0.14980264E-06_JPRB, 0.14668379E-06_JPRB, 0.14134648E-06_JPRB, 0.13429058E-06_JPRB, 0.12677557E-06_JPRB, &
  & 0.11655597E-06_JPRB, 0.10645920E-06_JPRB, 0.92709493E-07_JPRB, 0.79024239E-07_JPRB, 0.66258955E-07_JPRB, 0.57136136E-07_JPRB, &
  & 0.51017605E-07_JPRB, 0.47640051E-07_JPRB, 0.45731860E-07_JPRB, 0.44179407E-07_JPRB, 0.42300036E-07_JPRB, 0.40294516E-07_JPRB, &
  & 0.38267688E-07_JPRB, 0.36753093E-07_JPRB, 0.35494250E-07_JPRB, 0.33728172E-07_JPRB, 0.32536437E-07_JPRB, 0.33694419E-07_JPRB, &
  & 0.36765773E-07_JPRB, 0.41134319E-07_JPRB, 0.46338845E-07_JPRB, 0.50593686E-07_JPRB, 0.54009346E-07_JPRB, 0.56210176E-07_JPRB, &
  & 0.58547702E-07_JPRB, 0.61152193E-07_JPRB, 0.63934048E-07_JPRB, 0.68987928E-07_JPRB, 0.74374769E-07_JPRB, 0.80132436E-07_JPRB, &
  & 0.87640414E-07_JPRB, 0.96269856E-07_JPRB, 0.10289579E-06_JPRB, 0.10866856E-06_JPRB, 0.11579930E-06_JPRB, 0.12086717E-06_JPRB, &
  & 0.12551898E-06_JPRB, 0.12939617E-06_JPRB, 0.13502865E-06_JPRB, 0.14220347E-06_JPRB, 0.15747814E-06_JPRB, 0.17292981E-06_JPRB, &
  & 0.18672631E-06_JPRB, 0.19793494E-06_JPRB, 0.20781913E-06_JPRB, 0.21668128E-06_JPRB  /)

RGHG7(:,54, 9) = (/ &
  & 0.86558904E-07_JPRB, 0.85702326E-07_JPRB, 0.86392149E-07_JPRB, 0.88816985E-07_JPRB, 0.91020562E-07_JPRB, 0.89487006E-07_JPRB, &
  & 0.88029690E-07_JPRB, 0.88897364E-07_JPRB, 0.91197305E-07_JPRB, 0.10204823E-06_JPRB, 0.11239485E-06_JPRB, 0.11944509E-06_JPRB, &
  & 0.12289113E-06_JPRB, 0.12506660E-06_JPRB, 0.12268586E-06_JPRB, 0.11840301E-06_JPRB, 0.11274469E-06_JPRB, 0.10726488E-06_JPRB, &
  & 0.99927030E-07_JPRB, 0.93384804E-07_JPRB, 0.83517532E-07_JPRB, 0.73127718E-07_JPRB, 0.62867504E-07_JPRB, 0.55016324E-07_JPRB, &
  & 0.49678916E-07_JPRB, 0.46597727E-07_JPRB, 0.44975334E-07_JPRB, 0.43633076E-07_JPRB, 0.41901783E-07_JPRB, 0.39817002E-07_JPRB, &
  & 0.37776361E-07_JPRB, 0.36188209E-07_JPRB, 0.34870190E-07_JPRB, 0.33095157E-07_JPRB, 0.31957466E-07_JPRB, 0.33258507E-07_JPRB, &
  & 0.36471847E-07_JPRB, 0.40961512E-07_JPRB, 0.46049209E-07_JPRB, 0.49953089E-07_JPRB, 0.53111796E-07_JPRB, 0.55083743E-07_JPRB, &
  & 0.57211627E-07_JPRB, 0.59428316E-07_JPRB, 0.61917527E-07_JPRB, 0.66180295E-07_JPRB, 0.70388237E-07_JPRB, 0.74732845E-07_JPRB, &
  & 0.80187682E-07_JPRB, 0.86546657E-07_JPRB, 0.90822236E-07_JPRB, 0.94373261E-07_JPRB, 0.99348833E-07_JPRB, 0.10281447E-06_JPRB, &
  & 0.10591881E-06_JPRB, 0.10844974E-06_JPRB, 0.11279257E-06_JPRB, 0.11850982E-06_JPRB, 0.13115924E-06_JPRB, 0.14402080E-06_JPRB, &
  & 0.15565224E-06_JPRB, 0.16508584E-06_JPRB, 0.17293136E-06_JPRB, 0.18013769E-06_JPRB  /)

RGHG7(:,55, 9) = (/ &
  & 0.68498454E-07_JPRB, 0.68116830E-07_JPRB, 0.68676884E-07_JPRB, 0.70692948E-07_JPRB, 0.72511111E-07_JPRB, 0.71013890E-07_JPRB, &
  & 0.69373600E-07_JPRB, 0.69569071E-07_JPRB, 0.70450636E-07_JPRB, 0.79053963E-07_JPRB, 0.87507254E-07_JPRB, 0.93442776E-07_JPRB, &
  & 0.96106305E-07_JPRB, 0.98976039E-07_JPRB, 0.97534831E-07_JPRB, 0.94441963E-07_JPRB, 0.90270793E-07_JPRB, 0.86899734E-07_JPRB, &
  & 0.82516723E-07_JPRB, 0.79569099E-07_JPRB, 0.73763598E-07_JPRB, 0.66852892E-07_JPRB, 0.59280195E-07_JPRB, 0.52795483E-07_JPRB, &
  & 0.48304169E-07_JPRB, 0.45516258E-07_JPRB, 0.44198822E-07_JPRB, 0.43075874E-07_JPRB, 0.41514578E-07_JPRB, 0.39340256E-07_JPRB, &
  & 0.37291830E-07_JPRB, 0.35612839E-07_JPRB, 0.34219554E-07_JPRB, 0.32425056E-07_JPRB, 0.31332784E-07_JPRB, 0.32790846E-07_JPRB, &
  & 0.36156015E-07_JPRB, 0.40783236E-07_JPRB, 0.45754140E-07_JPRB, 0.49275202E-07_JPRB, 0.52171775E-07_JPRB, 0.53925710E-07_JPRB, &
  & 0.55839475E-07_JPRB, 0.57638308E-07_JPRB, 0.59847218E-07_JPRB, 0.63284655E-07_JPRB, 0.66290935E-07_JPRB, 0.69202893E-07_JPRB, &
  & 0.72545091E-07_JPRB, 0.76553948E-07_JPRB, 0.78413228E-07_JPRB, 0.79640089E-07_JPRB, 0.82347298E-07_JPRB, 0.84199911E-07_JPRB, &
  & 0.85724953E-07_JPRB, 0.86912774E-07_JPRB, 0.89874868E-07_JPRB, 0.93945346E-07_JPRB, 0.10351924E-06_JPRB, 0.11335718E-06_JPRB, &
  & 0.12248018E-06_JPRB, 0.12984656E-06_JPRB, 0.13537182E-06_JPRB, 0.14079122E-06_JPRB  /)

RGHG7(:,56, 9) = (/ &
  & 0.59473895E-07_JPRB, 0.59527543E-07_JPRB, 0.59988814E-07_JPRB, 0.61586279E-07_JPRB, 0.63063278E-07_JPRB, 0.61827508E-07_JPRB, &
  & 0.60226687E-07_JPRB, 0.60033678E-07_JPRB, 0.60461994E-07_JPRB, 0.67291460E-07_JPRB, 0.74221737E-07_JPRB, 0.79204776E-07_JPRB, &
  & 0.81204058E-07_JPRB, 0.84197685E-07_JPRB, 0.83556279E-07_JPRB, 0.81727900E-07_JPRB, 0.78554149E-07_JPRB, 0.76392438E-07_JPRB, &
  & 0.73488572E-07_JPRB, 0.71640980E-07_JPRB, 0.67726405E-07_JPRB, 0.62780758E-07_JPRB, 0.57025359E-07_JPRB, 0.51478323E-07_JPRB, &
  & 0.47616995E-07_JPRB, 0.45003042E-07_JPRB, 0.43899665E-07_JPRB, 0.42946057E-07_JPRB, 0.41486832E-07_JPRB, 0.39187925E-07_JPRB, &
  & 0.37172334E-07_JPRB, 0.35535162E-07_JPRB, 0.33998886E-07_JPRB, 0.32162486E-07_JPRB, 0.30924624E-07_JPRB, 0.32415724E-07_JPRB, &
  & 0.35954501E-07_JPRB, 0.40643513E-07_JPRB, 0.45595751E-07_JPRB, 0.48919401E-07_JPRB, 0.51668605E-07_JPRB, 0.53295986E-07_JPRB, &
  & 0.55120114E-07_JPRB, 0.56652486E-07_JPRB, 0.58764783E-07_JPRB, 0.61764977E-07_JPRB, 0.64108085E-07_JPRB, 0.66317827E-07_JPRB, &
  & 0.68726846E-07_JPRB, 0.71419339E-07_JPRB, 0.72182477E-07_JPRB, 0.72551057E-07_JPRB, 0.74325135E-07_JPRB, 0.75547926E-07_JPRB, &
  & 0.76584395E-07_JPRB, 0.77488281E-07_JPRB, 0.79841424E-07_JPRB, 0.82841594E-07_JPRB, 0.90041231E-07_JPRB, 0.97283708E-07_JPRB, &
  & 0.10416531E-06_JPRB, 0.10947624E-06_JPRB, 0.11343343E-06_JPRB, 0.11813528E-06_JPRB  /)

RGHG7(:,57, 9) = (/ &
  & 0.50708547E-07_JPRB, 0.51134404E-07_JPRB, 0.51479400E-07_JPRB, 0.52687253E-07_JPRB, 0.53834317E-07_JPRB, 0.52824979E-07_JPRB, &
  & 0.51280459E-07_JPRB, 0.50740651E-07_JPRB, 0.50706475E-07_JPRB, 0.55832843E-07_JPRB, 0.61246401E-07_JPRB, 0.65289948E-07_JPRB, &
  & 0.66717933E-07_JPRB, 0.69739049E-07_JPRB, 0.69794398E-07_JPRB, 0.69104716E-07_JPRB, 0.66956135E-07_JPRB, 0.65964313E-07_JPRB, &
  & 0.64542226E-07_JPRB, 0.63862940E-07_JPRB, 0.61811016E-07_JPRB, 0.58690604E-07_JPRB, 0.54782444E-07_JPRB, 0.50191182E-07_JPRB, &
  & 0.46972234E-07_JPRB, 0.44561336E-07_JPRB, 0.43587343E-07_JPRB, 0.42782083E-07_JPRB, 0.41383761E-07_JPRB, 0.39027877E-07_JPRB, &
  & 0.37092333E-07_JPRB, 0.35513498E-07_JPRB, 0.33860845E-07_JPRB, 0.31978273E-07_JPRB, 0.30547558E-07_JPRB, 0.32039012E-07_JPRB, &
  & 0.35744400E-07_JPRB, 0.40484288E-07_JPRB, 0.45405769E-07_JPRB, 0.48517014E-07_JPRB, 0.51095424E-07_JPRB, 0.52625510E-07_JPRB, &
  & 0.54369487E-07_JPRB, 0.55676107E-07_JPRB, 0.57672629E-07_JPRB, 0.60209493E-07_JPRB, 0.61899646E-07_JPRB, 0.63395672E-07_JPRB, &
  & 0.64887214E-07_JPRB, 0.66283108E-07_JPRB, 0.66032246E-07_JPRB, 0.65610918E-07_JPRB, 0.66503087E-07_JPRB, 0.67099735E-07_JPRB, &
  & 0.67598956E-07_JPRB, 0.68181430E-07_JPRB, 0.69909512E-07_JPRB, 0.71914736E-07_JPRB, 0.76908069E-07_JPRB, 0.81740084E-07_JPRB, &
  & 0.86522015E-07_JPRB, 0.89880041E-07_JPRB, 0.92359935E-07_JPRB, 0.96228061E-07_JPRB  /)

RGHG7(:,58, 9) = (/ &
  & 0.44780071E-07_JPRB, 0.45434242E-07_JPRB, 0.45648581E-07_JPRB, 0.46545280E-07_JPRB, 0.47416211E-07_JPRB, 0.46598146E-07_JPRB, &
  & 0.45175528E-07_JPRB, 0.44440407E-07_JPRB, 0.44146262E-07_JPRB, 0.47914868E-07_JPRB, 0.52013767E-07_JPRB, 0.55245754E-07_JPRB, &
  & 0.56327564E-07_JPRB, 0.59104202E-07_JPRB, 0.59600015E-07_JPRB, 0.59758935E-07_JPRB, 0.58508120E-07_JPRB, 0.58356818E-07_JPRB, &
  & 0.58025117E-07_JPRB, 0.58067816E-07_JPRB, 0.57273977E-07_JPRB, 0.55311973E-07_JPRB, 0.52989891E-07_JPRB, 0.49227699E-07_JPRB, &
  & 0.46579873E-07_JPRB, 0.44382472E-07_JPRB, 0.43367396E-07_JPRB, 0.42653731E-07_JPRB, 0.41229143E-07_JPRB, 0.38928485E-07_JPRB, &
  & 0.37153906E-07_JPRB, 0.35681483E-07_JPRB, 0.33954073E-07_JPRB, 0.32017621E-07_JPRB, 0.30293937E-07_JPRB, 0.31707265E-07_JPRB, &
  & 0.35558128E-07_JPRB, 0.40312159E-07_JPRB, 0.45203333E-07_JPRB, 0.48128693E-07_JPRB, 0.50531995E-07_JPRB, 0.52039183E-07_JPRB, &
  & 0.53748811E-07_JPRB, 0.54944979E-07_JPRB, 0.56837109E-07_JPRB, 0.58976612E-07_JPRB, 0.60184544E-07_JPRB, 0.61141775E-07_JPRB, &
  & 0.62037275E-07_JPRB, 0.62468054E-07_JPRB, 0.61670989E-07_JPRB, 0.60913588E-07_JPRB, 0.61331617E-07_JPRB, 0.61543027E-07_JPRB, &
  & 0.61670480E-07_JPRB, 0.62092662E-07_JPRB, 0.63363443E-07_JPRB, 0.64689112E-07_JPRB, 0.68068754E-07_JPRB, 0.71076950E-07_JPRB, &
  & 0.74217578E-07_JPRB, 0.75955179E-07_JPRB, 0.77370954E-07_JPRB, 0.80476685E-07_JPRB  /)

RGHG7(:,59, 9) = (/ &
  & 0.40969085E-07_JPRB, 0.41700141E-07_JPRB, 0.41821021E-07_JPRB, 0.42460690E-07_JPRB, 0.43083680E-07_JPRB, 0.42384166E-07_JPRB, &
  & 0.41107041E-07_JPRB, 0.40288745E-07_JPRB, 0.39872829E-07_JPRB, 0.42652356E-07_JPRB, 0.45778671E-07_JPRB, 0.48362581E-07_JPRB, &
  & 0.49236825E-07_JPRB, 0.51702451E-07_JPRB, 0.52454591E-07_JPRB, 0.53102031E-07_JPRB, 0.52602078E-07_JPRB, 0.52972145E-07_JPRB, &
  & 0.53372157E-07_JPRB, 0.53887726E-07_JPRB, 0.53997637E-07_JPRB, 0.52663234E-07_JPRB, 0.51440313E-07_JPRB, 0.48519867E-07_JPRB, &
  & 0.46317500E-07_JPRB, 0.44339593E-07_JPRB, 0.43202372E-07_JPRB, 0.42417893E-07_JPRB, 0.40880424E-07_JPRB, 0.38751794E-07_JPRB, &
  & 0.37158373E-07_JPRB, 0.35760851E-07_JPRB, 0.34044990E-07_JPRB, 0.31960878E-07_JPRB, 0.30029698E-07_JPRB, 0.31410384E-07_JPRB, &
  & 0.35358220E-07_JPRB, 0.40096523E-07_JPRB, 0.44900260E-07_JPRB, 0.47627313E-07_JPRB, 0.49869367E-07_JPRB, 0.51448499E-07_JPRB, &
  & 0.53160438E-07_JPRB, 0.54379294E-07_JPRB, 0.56143938E-07_JPRB, 0.57939050E-07_JPRB, 0.58832655E-07_JPRB, 0.59354968E-07_JPRB, &
  & 0.59823410E-07_JPRB, 0.59625375E-07_JPRB, 0.58587164E-07_JPRB, 0.57695432E-07_JPRB, 0.57836078E-07_JPRB, 0.57809224E-07_JPRB, &
  & 0.57689060E-07_JPRB, 0.57993504E-07_JPRB, 0.58942274E-07_JPRB, 0.59855846E-07_JPRB, 0.62191208E-07_JPRB, 0.64007790E-07_JPRB, &
  & 0.66048706E-07_JPRB, 0.66715335E-07_JPRB, 0.67398567E-07_JPRB, 0.69845139E-07_JPRB  /)

RGHG7(:,60, 9) = (/ &
  & 0.37985307E-07_JPRB, 0.38732056E-07_JPRB, 0.38777059E-07_JPRB, 0.39178826E-07_JPRB, 0.39561210E-07_JPRB, 0.38949228E-07_JPRB, &
  & 0.37826690E-07_JPRB, 0.36969643E-07_JPRB, 0.36485152E-07_JPRB, 0.38424880E-07_JPRB, 0.40717626E-07_JPRB, 0.42715374E-07_JPRB, &
  & 0.43434110E-07_JPRB, 0.45554283E-07_JPRB, 0.46488125E-07_JPRB, 0.47477871E-07_JPRB, 0.47658970E-07_JPRB, 0.48440874E-07_JPRB, &
  & 0.49415119E-07_JPRB, 0.50307233E-07_JPRB, 0.51167172E-07_JPRB, 0.50283192E-07_JPRB, 0.49927116E-07_JPRB, 0.47861790E-07_JPRB, &
  & 0.46086492E-07_JPRB, 0.44317438E-07_JPRB, 0.43009280E-07_JPRB, 0.42084882E-07_JPRB, 0.40403705E-07_JPRB, 0.38454226E-07_JPRB, &
  & 0.37068784E-07_JPRB, 0.35749067E-07_JPRB, 0.34046816E-07_JPRB, 0.31760426E-07_JPRB, 0.29677952E-07_JPRB, 0.31074041E-07_JPRB, &
  & 0.35095901E-07_JPRB, 0.39807151E-07_JPRB, 0.44482108E-07_JPRB, 0.47019861E-07_JPRB, 0.49116960E-07_JPRB, 0.50816260E-07_JPRB, &
  & 0.52550391E-07_JPRB, 0.53851683E-07_JPRB, 0.55473844E-07_JPRB, 0.56945675E-07_JPRB, 0.57585406E-07_JPRB, 0.57716386E-07_JPRB, &
  & 0.57813398E-07_JPRB, 0.57121399E-07_JPRB, 0.55960459E-07_JPRB, 0.55007087E-07_JPRB, 0.54940626E-07_JPRB, 0.54733099E-07_JPRB, &
  & 0.54426323E-07_JPRB, 0.54624195E-07_JPRB, 0.55304456E-07_JPRB, 0.55915757E-07_JPRB, 0.57435002E-07_JPRB, 0.58322903E-07_JPRB, &
  & 0.59482756E-07_JPRB, 0.59307754E-07_JPRB, 0.59389810E-07_JPRB, 0.61193470E-07_JPRB  /)

RGHG7(:,61, 9) = (/ &
  & 0.36172051E-07_JPRB, 0.36874255E-07_JPRB, 0.36880190E-07_JPRB, 0.37091729E-07_JPRB, 0.37266359E-07_JPRB, 0.36693445E-07_JPRB, &
  & 0.35707828E-07_JPRB, 0.34857353E-07_JPRB, 0.34357161E-07_JPRB, 0.35733872E-07_JPRB, 0.37460680E-07_JPRB, 0.39011884E-07_JPRB, &
  & 0.39636784E-07_JPRB, 0.41410822E-07_JPRB, 0.42426086E-07_JPRB, 0.43562977E-07_JPRB, 0.44216908E-07_JPRB, 0.45302227E-07_JPRB, &
  & 0.46570395E-07_JPRB, 0.47701299E-07_JPRB, 0.49012528E-07_JPRB, 0.48456791E-07_JPRB, 0.48497237E-07_JPRB, 0.47188079E-07_JPRB, &
  & 0.45855672E-07_JPRB, 0.44210759E-07_JPRB, 0.42662717E-07_JPRB, 0.41544805E-07_JPRB, 0.39727072E-07_JPRB, 0.37808629E-07_JPRB, &
  & 0.36681692E-07_JPRB, 0.35479179E-07_JPRB, 0.33687108E-07_JPRB, 0.31126877E-07_JPRB, 0.29038562E-07_JPRB, 0.30586176E-07_JPRB, &
  & 0.34637976E-07_JPRB, 0.39318190E-07_JPRB, 0.43788680E-07_JPRB, 0.46220182E-07_JPRB, 0.48244622E-07_JPRB, 0.50121372E-07_JPRB, &
  & 0.51908810E-07_JPRB, 0.53354325E-07_JPRB, 0.54824960E-07_JPRB, 0.56044492E-07_JPRB, 0.56504949E-07_JPRB, 0.56353690E-07_JPRB, &
  & 0.56151667E-07_JPRB, 0.55169032E-07_JPRB, 0.54001520E-07_JPRB, 0.53037194E-07_JPRB, 0.52834177E-07_JPRB, 0.52523686E-07_JPRB, &
  & 0.52151918E-07_JPRB, 0.52251938E-07_JPRB, 0.52753654E-07_JPRB, 0.53220368E-07_JPRB, 0.54263860E-07_JPRB, 0.54643877E-07_JPRB, &
  & 0.55269922E-07_JPRB, 0.54627930E-07_JPRB, 0.54321131E-07_JPRB, 0.55520516E-07_JPRB  /)

RGHG7(:,62, 9) = (/ &
  & 0.34878818E-07_JPRB, 0.35540192E-07_JPRB, 0.35526085E-07_JPRB, 0.35575386E-07_JPRB, 0.35578074E-07_JPRB, 0.35023580E-07_JPRB, &
  & 0.34142759E-07_JPRB, 0.33297444E-07_JPRB, 0.32779159E-07_JPRB, 0.33739509E-07_JPRB, 0.35001261E-07_JPRB, 0.36210341E-07_JPRB, &
  & 0.36770308E-07_JPRB, 0.38239609E-07_JPRB, 0.39248072E-07_JPRB, 0.40458683E-07_JPRB, 0.41445374E-07_JPRB, 0.42748371E-07_JPRB, &
  & 0.44181983E-07_JPRB, 0.45496853E-07_JPRB, 0.47111585E-07_JPRB, 0.46932944E-07_JPRB, 0.47149560E-07_JPRB, 0.46463370E-07_JPRB, &
  & 0.45562844E-07_JPRB, 0.44121715E-07_JPRB, 0.42288836E-07_JPRB, 0.40934207E-07_JPRB, 0.38940694E-07_JPRB, 0.36993730E-07_JPRB, &
  & 0.35977581E-07_JPRB, 0.34785998E-07_JPRB, 0.32783663E-07_JPRB, 0.29984916E-07_JPRB, 0.28008693E-07_JPRB, 0.29805107E-07_JPRB, &
  & 0.33858339E-07_JPRB, 0.38543019E-07_JPRB, 0.42824954E-07_JPRB, 0.45173036E-07_JPRB, 0.47251433E-07_JPRB, 0.49289396E-07_JPRB, &
  & 0.51157521E-07_JPRB, 0.52732667E-07_JPRB, 0.54120196E-07_JPRB, 0.55131550E-07_JPRB, 0.55442964E-07_JPRB, 0.55099935E-07_JPRB, &
  & 0.54647185E-07_JPRB, 0.53454113E-07_JPRB, 0.52301173E-07_JPRB, 0.51340950E-07_JPRB, 0.50995131E-07_JPRB, 0.50621099E-07_JPRB, &
  & 0.50246058E-07_JPRB, 0.50250780E-07_JPRB, 0.50670161E-07_JPRB, 0.51026868E-07_JPRB, 0.51787294E-07_JPRB, 0.51844332E-07_JPRB, &
  & 0.52118485E-07_JPRB, 0.51187873E-07_JPRB, 0.50595776E-07_JPRB, 0.51224592E-07_JPRB  /)

RGHG7(:,63, 9) = (/ &
  & 0.33910525E-07_JPRB, 0.34536710E-07_JPRB, 0.34524315E-07_JPRB, 0.34425627E-07_JPRB, 0.34271711E-07_JPRB, 0.33722064E-07_JPRB, &
  & 0.32923415E-07_JPRB, 0.32078513E-07_JPRB, 0.31526797E-07_JPRB, 0.32167862E-07_JPRB, 0.33022029E-07_JPRB, 0.33949505E-07_JPRB, &
  & 0.34458931E-07_JPRB, 0.35658706E-07_JPRB, 0.36620320E-07_JPRB, 0.37847060E-07_JPRB, 0.39058683E-07_JPRB, 0.40506736E-07_JPRB, &
  & 0.42042524E-07_JPRB, 0.43497134E-07_JPRB, 0.45325996E-07_JPRB, 0.45568667E-07_JPRB, 0.45840033E-07_JPRB, 0.45713107E-07_JPRB, &
  & 0.45199904E-07_JPRB, 0.44030142E-07_JPRB, 0.41894587E-07_JPRB, 0.40268369E-07_JPRB, 0.38092845E-07_JPRB, 0.36083312E-07_JPRB, &
  & 0.35011525E-07_JPRB, 0.33679792E-07_JPRB, 0.31447002E-07_JPRB, 0.28443804E-07_JPRB, 0.26654305E-07_JPRB, 0.28741543E-07_JPRB, &
  & 0.32815212E-07_JPRB, 0.37522799E-07_JPRB, 0.41634393E-07_JPRB, 0.43915516E-07_JPRB, 0.46131193E-07_JPRB, 0.48317934E-07_JPRB, &
  & 0.50295685E-07_JPRB, 0.51970353E-07_JPRB, 0.53320885E-07_JPRB, 0.54167912E-07_JPRB, 0.54353092E-07_JPRB, 0.53870191E-07_JPRB, &
  & 0.53211502E-07_JPRB, 0.51865619E-07_JPRB, 0.50727975E-07_JPRB, 0.49774147E-07_JPRB, 0.49286623E-07_JPRB, 0.48885728E-07_JPRB, &
  & 0.48528047E-07_JPRB, 0.48458385E-07_JPRB, 0.48846575E-07_JPRB, 0.49113801E-07_JPRB, 0.49717334E-07_JPRB, 0.49564615E-07_JPRB, &
  & 0.49605636E-07_JPRB, 0.48500501E-07_JPRB, 0.47697166E-07_JPRB, 0.47779953E-07_JPRB  /)

RGHG7(:,64, 9) = (/ &
  & 0.33256666E-07_JPRB, 0.33859290E-07_JPRB, 0.33883235E-07_JPRB, 0.33649171E-07_JPRB, 0.33346303E-07_JPRB, 0.32788669E-07_JPRB, &
  & 0.32045528E-07_JPRB, 0.31190642E-07_JPRB, 0.30571039E-07_JPRB, 0.30996861E-07_JPRB, 0.31499214E-07_JPRB, 0.32199866E-07_JPRB, &
  & 0.32666963E-07_JPRB, 0.33653093E-07_JPRB, 0.34560397E-07_JPRB, 0.35734424E-07_JPRB, 0.37037096E-07_JPRB, 0.38531472E-07_JPRB, &
  & 0.40139540E-07_JPRB, 0.41674416E-07_JPRB, 0.43637855E-07_JPRB, 0.44345354E-07_JPRB, 0.44592760E-07_JPRB, 0.44980978E-07_JPRB, &
  & 0.44740122E-07_JPRB, 0.43917784E-07_JPRB, 0.41493109E-07_JPRB, 0.39563395E-07_JPRB, 0.37237720E-07_JPRB, 0.35144326E-07_JPRB, &
  & 0.33755865E-07_JPRB, 0.32022001E-07_JPRB, 0.29641057E-07_JPRB, 0.26490104E-07_JPRB, 0.24944999E-07_JPRB, 0.27316565E-07_JPRB, &
  & 0.31486474E-07_JPRB, 0.36225608E-07_JPRB, 0.40202626E-07_JPRB, 0.42437027E-07_JPRB, 0.44862355E-07_JPRB, 0.47177683E-07_JPRB, &
  & 0.49304785E-07_JPRB, 0.51014995E-07_JPRB, 0.52374711E-07_JPRB, 0.53127894E-07_JPRB, 0.53217633E-07_JPRB, 0.52636894E-07_JPRB, &
  & 0.51842430E-07_JPRB, 0.50411090E-07_JPRB, 0.49268254E-07_JPRB, 0.48310833E-07_JPRB, 0.47696319E-07_JPRB, 0.47320583E-07_JPRB, &
  & 0.46967694E-07_JPRB, 0.46876068E-07_JPRB, 0.47263060E-07_JPRB, 0.47460003E-07_JPRB, 0.48029592E-07_JPRB, 0.47767854E-07_JPRB, &
  & 0.47694266E-07_JPRB, 0.46522841E-07_JPRB, 0.45594913E-07_JPRB, 0.45179727E-07_JPRB  /)

RGHG7(:,65, 9) = (/ &
  & 0.32897371E-07_JPRB, 0.33461387E-07_JPRB, 0.33545736E-07_JPRB, 0.33194592E-07_JPRB, 0.32765422E-07_JPRB, 0.32148449E-07_JPRB, &
  & 0.31443398E-07_JPRB, 0.30572878E-07_JPRB, 0.29850676E-07_JPRB, 0.30117596E-07_JPRB, 0.30350191E-07_JPRB, 0.30860202E-07_JPRB, &
  & 0.31269407E-07_JPRB, 0.32083377E-07_JPRB, 0.32906223E-07_JPRB, 0.34032710E-07_JPRB, 0.35329746E-07_JPRB, 0.36799808E-07_JPRB, &
  & 0.38426070E-07_JPRB, 0.39975667E-07_JPRB, 0.41989594E-07_JPRB, 0.43117520E-07_JPRB, 0.43401366E-07_JPRB, 0.44192695E-07_JPRB, &
  & 0.44159733E-07_JPRB, 0.43585628E-07_JPRB, 0.41117909E-07_JPRB, 0.38902083E-07_JPRB, 0.36564492E-07_JPRB, 0.34316722E-07_JPRB, &
  & 0.32406607E-07_JPRB, 0.30220712E-07_JPRB, 0.27652201E-07_JPRB, 0.24545640E-07_JPRB, 0.23364243E-07_JPRB, 0.25807475E-07_JPRB, &
  & 0.30041651E-07_JPRB, 0.34760167E-07_JPRB, 0.38552148E-07_JPRB, 0.40784072E-07_JPRB, 0.43449642E-07_JPRB, 0.45901970E-07_JPRB, &
  & 0.48160608E-07_JPRB, 0.49890648E-07_JPRB, 0.51265565E-07_JPRB, 0.51982170E-07_JPRB, 0.52011049E-07_JPRB, 0.51343248E-07_JPRB, &
  & 0.50481850E-07_JPRB, 0.49049514E-07_JPRB, 0.47884722E-07_JPRB, 0.46923679E-07_JPRB, 0.46222093E-07_JPRB, 0.45876910E-07_JPRB, &
  & 0.45525876E-07_JPRB, 0.45455606E-07_JPRB, 0.45875213E-07_JPRB, 0.46022523E-07_JPRB, 0.46591732E-07_JPRB, 0.46343913E-07_JPRB, &
  & 0.46233636E-07_JPRB, 0.45026265E-07_JPRB, 0.44039696E-07_JPRB, 0.43327162E-07_JPRB  /)

RGHG7(:,66, 9) = (/ &
  & 0.32684524E-07_JPRB, 0.33187292E-07_JPRB, 0.33312663E-07_JPRB, 0.32865449E-07_JPRB, 0.32335677E-07_JPRB, 0.31625648E-07_JPRB, &
  & 0.30947437E-07_JPRB, 0.30069489E-07_JPRB, 0.29244093E-07_JPRB, 0.29353045E-07_JPRB, 0.29366875E-07_JPRB, 0.29689957E-07_JPRB, &
  & 0.30040333E-07_JPRB, 0.30698032E-07_JPRB, 0.31419836E-07_JPRB, 0.32479368E-07_JPRB, 0.33747774E-07_JPRB, 0.35175984E-07_JPRB, &
  & 0.36784281E-07_JPRB, 0.38339753E-07_JPRB, 0.40343907E-07_JPRB, 0.41778383E-07_JPRB, 0.42199803E-07_JPRB, 0.43302981E-07_JPRB, &
  & 0.43492186E-07_JPRB, 0.43058557E-07_JPRB, 0.40680840E-07_JPRB, 0.38269632E-07_JPRB, 0.35920393E-07_JPRB, 0.33500339E-07_JPRB, &
  & 0.31174283E-07_JPRB, 0.28646287E-07_JPRB, 0.25827876E-07_JPRB, 0.22869643E-07_JPRB, 0.22014576E-07_JPRB, 0.24494940E-07_JPRB, &
  & 0.28730453E-07_JPRB, 0.33273339E-07_JPRB, 0.36843511E-07_JPRB, 0.39131919E-07_JPRB, 0.41961661E-07_JPRB, 0.44589407E-07_JPRB, &
  & 0.46929541E-07_JPRB, 0.48676249E-07_JPRB, 0.50064041E-07_JPRB, 0.50766665E-07_JPRB, 0.50734894E-07_JPRB, 0.50005971E-07_JPRB, &
  & 0.49108756E-07_JPRB, 0.47703147E-07_JPRB, 0.46516086E-07_JPRB, 0.45550667E-07_JPRB, 0.44800007E-07_JPRB, 0.44465648E-07_JPRB, &
  & 0.44127018E-07_JPRB, 0.44096103E-07_JPRB, 0.44545541E-07_JPRB, 0.44689703E-07_JPRB, 0.45247781E-07_JPRB, 0.45061447E-07_JPRB, &
  & 0.44929456E-07_JPRB, 0.43694060E-07_JPRB, 0.42658999E-07_JPRB, 0.41780218E-07_JPRB  /)

RGHG7(:,67, 9) = (/ &
  & 0.32595933E-07_JPRB, 0.33017190E-07_JPRB, 0.33148104E-07_JPRB, 0.32626759E-07_JPRB, 0.32027855E-07_JPRB, 0.31195590E-07_JPRB, &
  & 0.30537362E-07_JPRB, 0.29655032E-07_JPRB, 0.28742613E-07_JPRB, 0.28687941E-07_JPRB, 0.28525696E-07_JPRB, 0.28669693E-07_JPRB, &
  & 0.28959316E-07_JPRB, 0.29473079E-07_JPRB, 0.30087810E-07_JPRB, 0.31065371E-07_JPRB, 0.32282200E-07_JPRB, 0.33653995E-07_JPRB, &
  & 0.35213308E-07_JPRB, 0.36773745E-07_JPRB, 0.38722785E-07_JPRB, 0.40337164E-07_JPRB, 0.40971377E-07_JPRB, 0.42306646E-07_JPRB, &
  & 0.42726606E-07_JPRB, 0.42308765E-07_JPRB, 0.40132785E-07_JPRB, 0.37653093E-07_JPRB, 0.35275339E-07_JPRB, 0.32686463E-07_JPRB, &
  & 0.30112822E-07_JPRB, 0.27356283E-07_JPRB, 0.24303150E-07_JPRB, 0.21538593E-07_JPRB, 0.20929058E-07_JPRB, 0.23430276E-07_JPRB, &
  & 0.27586955E-07_JPRB, 0.31781476E-07_JPRB, 0.35131328E-07_JPRB, 0.37524848E-07_JPRB, 0.40440926E-07_JPRB, 0.43250476E-07_JPRB, &
  & 0.45640275E-07_JPRB, 0.47399796E-07_JPRB, 0.48808443E-07_JPRB, 0.49500077E-07_JPRB, 0.49405130E-07_JPRB, 0.48642056E-07_JPRB, &
  & 0.47739597E-07_JPRB, 0.46371912E-07_JPRB, 0.45168749E-07_JPRB, 0.44201273E-07_JPRB, 0.43436246E-07_JPRB, 0.43094109E-07_JPRB, &
  & 0.42781834E-07_JPRB, 0.42798519E-07_JPRB, 0.43265493E-07_JPRB, 0.43455961E-07_JPRB, 0.43994773E-07_JPRB, 0.43911557E-07_JPRB, &
  & 0.43759041E-07_JPRB, 0.42505674E-07_JPRB, 0.41450794E-07_JPRB, 0.40492914E-07_JPRB  /)

RGHG7(:,68, 9) = (/ &
  & 0.32604667E-07_JPRB, 0.32930794E-07_JPRB, 0.33007171E-07_JPRB, 0.32432930E-07_JPRB, 0.31805734E-07_JPRB, 0.30828311E-07_JPRB, &
  & 0.30192226E-07_JPRB, 0.29294315E-07_JPRB, 0.28338841E-07_JPRB, 0.28109488E-07_JPRB, 0.27797166E-07_JPRB, 0.27782476E-07_JPRB, &
  & 0.28003621E-07_JPRB, 0.28380429E-07_JPRB, 0.28901259E-07_JPRB, 0.29795991E-07_JPRB, 0.30924249E-07_JPRB, 0.32221006E-07_JPRB, &
  & 0.33708971E-07_JPRB, 0.35279659E-07_JPRB, 0.37157761E-07_JPRB, 0.38820525E-07_JPRB, 0.39676984E-07_JPRB, 0.41193083E-07_JPRB, &
  & 0.41827087E-07_JPRB, 0.41271881E-07_JPRB, 0.39382113E-07_JPRB, 0.37017644E-07_JPRB, 0.34584944E-07_JPRB, 0.31864444E-07_JPRB, &
  & 0.29274400E-07_JPRB, 0.26369834E-07_JPRB, 0.23267086E-07_JPRB, 0.20631283E-07_JPRB, 0.20130411E-07_JPRB, 0.22641880E-07_JPRB, &
  & 0.26611168E-07_JPRB, 0.30270578E-07_JPRB, 0.33479375E-07_JPRB, 0.36000008E-07_JPRB, 0.38947251E-07_JPRB, 0.41871203E-07_JPRB, &
  & 0.44327430E-07_JPRB, 0.46092281E-07_JPRB, 0.47553825E-07_JPRB, 0.48201173E-07_JPRB, 0.48040619E-07_JPRB, 0.47267703E-07_JPRB, &
  & 0.46395178E-07_JPRB, 0.45051686E-07_JPRB, 0.43848933E-07_JPRB, 0.42888427E-07_JPRB, 0.42134882E-07_JPRB, 0.41774703E-07_JPRB, &
  & 0.41507123E-07_JPRB, 0.41563582E-07_JPRB, 0.42023175E-07_JPRB, 0.42308775E-07_JPRB, 0.42834875E-07_JPRB, 0.42897636E-07_JPRB, &
  & 0.42707805E-07_JPRB, 0.41454849E-07_JPRB, 0.40458605E-07_JPRB, 0.39420766E-07_JPRB  /)

RGHG7(:,69, 9) = (/ &
  & 0.32674708E-07_JPRB, 0.32893779E-07_JPRB, 0.32883535E-07_JPRB, 0.32251556E-07_JPRB, 0.31622942E-07_JPRB, 0.30516064E-07_JPRB, &
  & 0.29884577E-07_JPRB, 0.28962504E-07_JPRB, 0.27995705E-07_JPRB, 0.27615962E-07_JPRB, 0.27145007E-07_JPRB, 0.27007111E-07_JPRB, &
  & 0.27142998E-07_JPRB, 0.27398176E-07_JPRB, 0.27831841E-07_JPRB, 0.28639653E-07_JPRB, 0.29658085E-07_JPRB, 0.30844364E-07_JPRB, &
  & 0.32272190E-07_JPRB, 0.33824764E-07_JPRB, 0.35650601E-07_JPRB, 0.37287849E-07_JPRB, 0.38225442E-07_JPRB, 0.39902560E-07_JPRB, &
  & 0.40650178E-07_JPRB, 0.39916580E-07_JPRB, 0.38334991E-07_JPRB, 0.36113713E-07_JPRB, 0.33770504E-07_JPRB, 0.31008718E-07_JPRB, &
  & 0.28455270E-07_JPRB, 0.25593408E-07_JPRB, 0.22419781E-07_JPRB, 0.19762684E-07_JPRB, 0.19337613E-07_JPRB, 0.21815667E-07_JPRB, &
  & 0.25492356E-07_JPRB, 0.28718264E-07_JPRB, 0.31857311E-07_JPRB, 0.34509514E-07_JPRB, 0.37540535E-07_JPRB, 0.40483330E-07_JPRB, &
  & 0.42988432E-07_JPRB, 0.44825416E-07_JPRB, 0.46342458E-07_JPRB, 0.46883205E-07_JPRB, 0.46671611E-07_JPRB, 0.45904530E-07_JPRB, &
  & 0.45082086E-07_JPRB, 0.43748600E-07_JPRB, 0.42549243E-07_JPRB, 0.41599065E-07_JPRB, 0.40852147E-07_JPRB, 0.40484379E-07_JPRB, &
  & 0.40304404E-07_JPRB, 0.40358832E-07_JPRB, 0.40814405E-07_JPRB, 0.41202581E-07_JPRB, 0.41740230E-07_JPRB, 0.41981782E-07_JPRB, &
  & 0.41781515E-07_JPRB, 0.40573752E-07_JPRB, 0.39696218E-07_JPRB, 0.38572091E-07_JPRB  /)

RGHG7(:,70, 9) = (/ &
  & 0.32754181E-07_JPRB, 0.32854796E-07_JPRB, 0.32761262E-07_JPRB, 0.32075479E-07_JPRB, 0.31448097E-07_JPRB, 0.30242363E-07_JPRB, &
  & 0.29588492E-07_JPRB, 0.28641361E-07_JPRB, 0.27665869E-07_JPRB, 0.27163568E-07_JPRB, 0.26542347E-07_JPRB, 0.26294033E-07_JPRB, &
  & 0.26341403E-07_JPRB, 0.26490041E-07_JPRB, 0.26838221E-07_JPRB, 0.27549003E-07_JPRB, 0.28451240E-07_JPRB, 0.29520221E-07_JPRB, &
  & 0.30860776E-07_JPRB, 0.32392876E-07_JPRB, 0.34177956E-07_JPRB, 0.35759465E-07_JPRB, 0.36683410E-07_JPRB, 0.38376701E-07_JPRB, &
  & 0.39270426E-07_JPRB, 0.38435761E-07_JPRB, 0.37087217E-07_JPRB, 0.34997644E-07_JPRB, 0.32819605E-07_JPRB, 0.30149992E-07_JPRB, &
  & 0.27631295E-07_JPRB, 0.24770527E-07_JPRB, 0.21465637E-07_JPRB, 0.18737361E-07_JPRB, 0.18426462E-07_JPRB, 0.20872681E-07_JPRB, &
  & 0.24281064E-07_JPRB, 0.27183424E-07_JPRB, 0.30264148E-07_JPRB, 0.33030992E-07_JPRB, 0.36133282E-07_JPRB, 0.39075994E-07_JPRB, &
  & 0.41642873E-07_JPRB, 0.43590658E-07_JPRB, 0.45140930E-07_JPRB, 0.45548456E-07_JPRB, 0.45301930E-07_JPRB, 0.44553205E-07_JPRB, &
  & 0.43768633E-07_JPRB, 0.42453782E-07_JPRB, 0.41253118E-07_JPRB, 0.40299800E-07_JPRB, 0.39566431E-07_JPRB, 0.39205434E-07_JPRB, &
  & 0.39113663E-07_JPRB, 0.39155734E-07_JPRB, 0.39626673E-07_JPRB, 0.40118130E-07_JPRB, 0.40681898E-07_JPRB, 0.41098691E-07_JPRB, &
  & 0.40911112E-07_JPRB, 0.39808099E-07_JPRB, 0.39024468E-07_JPRB, 0.37829457E-07_JPRB  /)

RGHG7(:,71, 9) = (/ &
  & 0.32823834E-07_JPRB, 0.32806197E-07_JPRB, 0.32634517E-07_JPRB, 0.31901207E-07_JPRB, 0.31272784E-07_JPRB, 0.30001198E-07_JPRB, &
  & 0.29298703E-07_JPRB, 0.28324448E-07_JPRB, 0.27338370E-07_JPRB, 0.26740000E-07_JPRB, 0.25985759E-07_JPRB, 0.25633932E-07_JPRB, &
  & 0.25589585E-07_JPRB, 0.25640040E-07_JPRB, 0.25917866E-07_JPRB, 0.26529996E-07_JPRB, 0.27302879E-07_JPRB, 0.28254809E-07_JPRB, &
  & 0.29484746E-07_JPRB, 0.30985763E-07_JPRB, 0.32723621E-07_JPRB, 0.34230562E-07_JPRB, 0.35091927E-07_JPRB, 0.36645945E-07_JPRB, &
  & 0.37671028E-07_JPRB, 0.36822474E-07_JPRB, 0.35606426E-07_JPRB, 0.33663971E-07_JPRB, 0.31720950E-07_JPRB, 0.29240330E-07_JPRB, &
  & 0.26774154E-07_JPRB, 0.23841726E-07_JPRB, 0.20387266E-07_JPRB, 0.17603597E-07_JPRB, 0.17430674E-07_JPRB, 0.19820846E-07_JPRB, &
  & 0.22984917E-07_JPRB, 0.25665238E-07_JPRB, 0.28694124E-07_JPRB, 0.31535654E-07_JPRB, 0.34680356E-07_JPRB, 0.37640994E-07_JPRB, &
  & 0.40283784E-07_JPRB, 0.42380672E-07_JPRB, 0.43931558E-07_JPRB, 0.44199168E-07_JPRB, 0.43930784E-07_JPRB, 0.43212792E-07_JPRB, &
  & 0.42450883E-07_JPRB, 0.41169249E-07_JPRB, 0.39954767E-07_JPRB, 0.38977556E-07_JPRB, 0.38269490E-07_JPRB, 0.37932675E-07_JPRB, &
  & 0.37923966E-07_JPRB, 0.37955914E-07_JPRB, 0.38457877E-07_JPRB, 0.39049024E-07_JPRB, 0.39659594E-07_JPRB, 0.40233110E-07_JPRB, &
  & 0.40067987E-07_JPRB, 0.39115455E-07_JPRB, 0.38395441E-07_JPRB, 0.37144588E-07_JPRB  /)

RGHG7(:,72, 9) = (/ &
  & 0.32857291E-07_JPRB, 0.32743607E-07_JPRB, 0.32494761E-07_JPRB, 0.31722868E-07_JPRB, 0.31086646E-07_JPRB, 0.29784276E-07_JPRB, &
  & 0.29009541E-07_JPRB, 0.28002039E-07_JPRB, 0.27000774E-07_JPRB, 0.26329753E-07_JPRB, 0.25473308E-07_JPRB, 0.25018046E-07_JPRB, &
  & 0.24875600E-07_JPRB, 0.24823030E-07_JPRB, 0.25072945E-07_JPRB, 0.25602163E-07_JPRB, 0.26215378E-07_JPRB, 0.27057715E-07_JPRB, &
  & 0.28168210E-07_JPRB, 0.29605606E-07_JPRB, 0.31256036E-07_JPRB, 0.32681707E-07_JPRB, 0.33509415E-07_JPRB, 0.34770366E-07_JPRB, &
  & 0.35792165E-07_JPRB, 0.35012979E-07_JPRB, 0.33798162E-07_JPRB, 0.32079817E-07_JPRB, 0.30447512E-07_JPRB, 0.28175404E-07_JPRB, &
  & 0.25829902E-07_JPRB, 0.22739859E-07_JPRB, 0.19206591E-07_JPRB, 0.16489826E-07_JPRB, 0.16436347E-07_JPRB, 0.18685731E-07_JPRB, &
  & 0.21601066E-07_JPRB, 0.24144294E-07_JPRB, 0.27130903E-07_JPRB, 0.29966276E-07_JPRB, 0.33106053E-07_JPRB, 0.36158633E-07_JPRB, &
  & 0.38888030E-07_JPRB, 0.41179063E-07_JPRB, 0.42682337E-07_JPRB, 0.42833787E-07_JPRB, 0.42550627E-07_JPRB, 0.41876554E-07_JPRB, &
  & 0.41122854E-07_JPRB, 0.39896221E-07_JPRB, 0.38641514E-07_JPRB, 0.37608481E-07_JPRB, 0.36944744E-07_JPRB, 0.36655132E-07_JPRB, &
  & 0.36722357E-07_JPRB, 0.36764156E-07_JPRB, 0.37302650E-07_JPRB, 0.37983277E-07_JPRB, 0.38675938E-07_JPRB, 0.39366435E-07_JPRB, &
  & 0.39208700E-07_JPRB, 0.38424044E-07_JPRB, 0.37744256E-07_JPRB, 0.36447431E-07_JPRB  /)

RGHG7(:,73, 9) = (/ &
  & 0.32837982E-07_JPRB, 0.32679504E-07_JPRB, 0.32336662E-07_JPRB, 0.31532058E-07_JPRB, 0.30873896E-07_JPRB, 0.29563421E-07_JPRB, &
  & 0.28698883E-07_JPRB, 0.27654893E-07_JPRB, 0.26629971E-07_JPRB, 0.25895021E-07_JPRB, 0.24978446E-07_JPRB, 0.24411529E-07_JPRB, &
  & 0.24205842E-07_JPRB, 0.24087365E-07_JPRB, 0.24283682E-07_JPRB, 0.24751221E-07_JPRB, 0.25221365E-07_JPRB, 0.25921474E-07_JPRB, &
  & 0.26908022E-07_JPRB, 0.28236475E-07_JPRB, 0.29762017E-07_JPRB, 0.31114326E-07_JPRB, 0.31919229E-07_JPRB, 0.32875507E-07_JPRB, &
  & 0.33819717E-07_JPRB, 0.33077158E-07_JPRB, 0.31829674E-07_JPRB, 0.30382455E-07_JPRB, 0.28991050E-07_JPRB, 0.26858951E-07_JPRB, &
  & 0.24626824E-07_JPRB, 0.21543585E-07_JPRB, 0.18133721E-07_JPRB, 0.15640060E-07_JPRB, 0.15552430E-07_JPRB, 0.17603066E-07_JPRB, &
  & 0.20242315E-07_JPRB, 0.22659464E-07_JPRB, 0.25618026E-07_JPRB, 0.28415588E-07_JPRB, 0.31523743E-07_JPRB, 0.34630323E-07_JPRB, &
  & 0.37478067E-07_JPRB, 0.39914850E-07_JPRB, 0.41371758E-07_JPRB, 0.41462375E-07_JPRB, 0.41152162E-07_JPRB, 0.40535215E-07_JPRB, &
  & 0.39730343E-07_JPRB, 0.38573126E-07_JPRB, 0.37297390E-07_JPRB, 0.36193734E-07_JPRB, 0.35564679E-07_JPRB, 0.35354544E-07_JPRB, &
  & 0.35494716E-07_JPRB, 0.35578805E-07_JPRB, 0.36157089E-07_JPRB, 0.36887334E-07_JPRB, 0.37687325E-07_JPRB, 0.38455481E-07_JPRB, &
  & 0.38281558E-07_JPRB, 0.37616992E-07_JPRB, 0.36940327E-07_JPRB, 0.35674218E-07_JPRB  /)

RGHG7(:,74, 9) = (/ &
  & 0.32798353E-07_JPRB, 0.32606876E-07_JPRB, 0.32155092E-07_JPRB, 0.31326733E-07_JPRB, 0.30646705E-07_JPRB, 0.29330536E-07_JPRB, &
  & 0.28368618E-07_JPRB, 0.27289642E-07_JPRB, 0.26225257E-07_JPRB, 0.25448495E-07_JPRB, 0.24481343E-07_JPRB, 0.23844336E-07_JPRB, &
  & 0.23578162E-07_JPRB, 0.23409858E-07_JPRB, 0.23539817E-07_JPRB, 0.23939598E-07_JPRB, 0.24301930E-07_JPRB, 0.24857961E-07_JPRB, &
  & 0.25701233E-07_JPRB, 0.26872680E-07_JPRB, 0.28256190E-07_JPRB, 0.29452602E-07_JPRB, 0.30184331E-07_JPRB, 0.30833056E-07_JPRB, &
  & 0.31568590E-07_JPRB, 0.30985279E-07_JPRB, 0.29904315E-07_JPRB, 0.28685536E-07_JPRB, 0.27436944E-07_JPRB, 0.25440921E-07_JPRB, &
  & 0.23306314E-07_JPRB, 0.20491314E-07_JPRB, 0.17234869E-07_JPRB, 0.14971018E-07_JPRB, 0.14794959E-07_JPRB, 0.16648134E-07_JPRB, &
  & 0.19045231E-07_JPRB, 0.21324723E-07_JPRB, 0.24218049E-07_JPRB, 0.26980133E-07_JPRB, 0.30090642E-07_JPRB, 0.33218229E-07_JPRB, &
  & 0.36159600E-07_JPRB, 0.38658093E-07_JPRB, 0.40102003E-07_JPRB, 0.40141960E-07_JPRB, 0.39786588E-07_JPRB, 0.39194357E-07_JPRB, &
  & 0.38301398E-07_JPRB, 0.37190693E-07_JPRB, 0.35925060E-07_JPRB, 0.34782329E-07_JPRB, 0.34172979E-07_JPRB, 0.34025370E-07_JPRB, &
  & 0.34259971E-07_JPRB, 0.34387793E-07_JPRB, 0.35011800E-07_JPRB, 0.35782803E-07_JPRB, 0.36672800E-07_JPRB, 0.37467634E-07_JPRB, &
  & 0.37289189E-07_JPRB, 0.36697931E-07_JPRB, 0.36004660E-07_JPRB, 0.34795513E-07_JPRB  /)

RGHG7(:,75, 9) = (/ &
  & 0.32746211E-07_JPRB, 0.32518455E-07_JPRB, 0.31943869E-07_JPRB, 0.31100358E-07_JPRB, 0.30405595E-07_JPRB, 0.29085327E-07_JPRB, &
  & 0.28021840E-07_JPRB, 0.26905597E-07_JPRB, 0.25788424E-07_JPRB, 0.24985683E-07_JPRB, 0.23986239E-07_JPRB, 0.23319761E-07_JPRB, &
  & 0.22994689E-07_JPRB, 0.22794214E-07_JPRB, 0.22847630E-07_JPRB, 0.23175258E-07_JPRB, 0.23454115E-07_JPRB, 0.23873651E-07_JPRB, &
  & 0.24564900E-07_JPRB, 0.25544668E-07_JPRB, 0.26754768E-07_JPRB, 0.27745267E-07_JPRB, 0.28392057E-07_JPRB, 0.28805084E-07_JPRB, &
  & 0.29277081E-07_JPRB, 0.28909702E-07_JPRB, 0.28105988E-07_JPRB, 0.27061016E-07_JPRB, 0.25873443E-07_JPRB, 0.24017744E-07_JPRB, &
  & 0.21953212E-07_JPRB, 0.19582034E-07_JPRB, 0.16535270E-07_JPRB, 0.14457751E-07_JPRB, 0.14167425E-07_JPRB, 0.15832155E-07_JPRB, &
  & 0.18032596E-07_JPRB, 0.20188013E-07_JPRB, 0.22982172E-07_JPRB, 0.25709090E-07_JPRB, 0.28848209E-07_JPRB, 0.31967255E-07_JPRB, &
  & 0.34975860E-07_JPRB, 0.37493679E-07_JPRB, 0.38949483E-07_JPRB, 0.38922185E-07_JPRB, 0.38485888E-07_JPRB, 0.37878282E-07_JPRB, &
  & 0.36868889E-07_JPRB, 0.35766812E-07_JPRB, 0.34527852E-07_JPRB, 0.33385568E-07_JPRB, 0.32797758E-07_JPRB, 0.32687595E-07_JPRB, &
  & 0.33015714E-07_JPRB, 0.33183491E-07_JPRB, 0.33849376E-07_JPRB, 0.34660596E-07_JPRB, 0.35624815E-07_JPRB, 0.36400732E-07_JPRB, &
  & 0.36237497E-07_JPRB, 0.35669383E-07_JPRB, 0.34936154E-07_JPRB, 0.33780026E-07_JPRB  /)

RGHG7(:,76, 9) = (/ &
  & 0.32688756E-07_JPRB, 0.32403112E-07_JPRB, 0.31692632E-07_JPRB, 0.30841732E-07_JPRB, 0.30148611E-07_JPRB, 0.28827522E-07_JPRB, &
  & 0.27661807E-07_JPRB, 0.26499172E-07_JPRB, 0.25320415E-07_JPRB, 0.24495915E-07_JPRB, 0.23501397E-07_JPRB, 0.22838204E-07_JPRB, &
  & 0.22458528E-07_JPRB, 0.22249432E-07_JPRB, 0.22217863E-07_JPRB, 0.22475286E-07_JPRB, 0.22675317E-07_JPRB, 0.22976203E-07_JPRB, &
  & 0.23524990E-07_JPRB, 0.24298660E-07_JPRB, 0.25277207E-07_JPRB, 0.26074747E-07_JPRB, 0.26694439E-07_JPRB, 0.27061895E-07_JPRB, &
  & 0.27342574E-07_JPRB, 0.27122584E-07_JPRB, 0.26536053E-07_JPRB, 0.25603573E-07_JPRB, 0.24423389E-07_JPRB, 0.22716311E-07_JPRB, &
  & 0.20676823E-07_JPRB, 0.18780245E-07_JPRB, 0.16068082E-07_JPRB, 0.14075137E-07_JPRB, 0.13674373E-07_JPRB, 0.15162974E-07_JPRB, &
  & 0.17222186E-07_JPRB, 0.19310271E-07_JPRB, 0.21982906E-07_JPRB, 0.24666716E-07_JPRB, 0.27840322E-07_JPRB, 0.30925292E-07_JPRB, &
  & 0.33979879E-07_JPRB, 0.36544912E-07_JPRB, 0.38020012E-07_JPRB, 0.37872421E-07_JPRB, 0.37291199E-07_JPRB, 0.36621599E-07_JPRB, &
  & 0.35476724E-07_JPRB, 0.34326202E-07_JPRB, 0.33106126E-07_JPRB, 0.32010646E-07_JPRB, 0.31473745E-07_JPRB, 0.31369740E-07_JPRB, &
  & 0.31751642E-07_JPRB, 0.31951852E-07_JPRB, 0.32639907E-07_JPRB, 0.33499572E-07_JPRB, 0.34530711E-07_JPRB, 0.35251203E-07_JPRB, &
  & 0.35131077E-07_JPRB, 0.34529298E-07_JPRB, 0.33723811E-07_JPRB, 0.32576305E-07_JPRB  /)

RGHG7(:,77, 9) = (/ &
  & 0.32618291E-07_JPRB, 0.32226936E-07_JPRB, 0.31376255E-07_JPRB, 0.30513120E-07_JPRB, 0.29867081E-07_JPRB, 0.28545554E-07_JPRB, &
  & 0.27292344E-07_JPRB, 0.26070017E-07_JPRB, 0.24833143E-07_JPRB, 0.23975910E-07_JPRB, 0.23003766E-07_JPRB, 0.22373523E-07_JPRB, &
  & 0.22006787E-07_JPRB, 0.21778283E-07_JPRB, 0.21687372E-07_JPRB, 0.21846734E-07_JPRB, 0.21991299E-07_JPRB, 0.22193957E-07_JPRB, &
  & 0.22584032E-07_JPRB, 0.23183812E-07_JPRB, 0.23986742E-07_JPRB, 0.24692433E-07_JPRB, 0.25395616E-07_JPRB, 0.25752789E-07_JPRB, &
  & 0.26027799E-07_JPRB, 0.25894903E-07_JPRB, 0.25369499E-07_JPRB, 0.24510043E-07_JPRB, 0.23347228E-07_JPRB, 0.21693740E-07_JPRB, &
  & 0.19695055E-07_JPRB, 0.18116349E-07_JPRB, 0.15752251E-07_JPRB, 0.13794931E-07_JPRB, 0.13306242E-07_JPRB, 0.14651747E-07_JPRB, &
  & 0.16638799E-07_JPRB, 0.18709143E-07_JPRB, 0.21313020E-07_JPRB, 0.23987466E-07_JPRB, 0.27094553E-07_JPRB, 0.30149701E-07_JPRB, &
  & 0.33284890E-07_JPRB, 0.35853973E-07_JPRB, 0.37347065E-07_JPRB, 0.37068777E-07_JPRB, 0.36391507E-07_JPRB, 0.35630989E-07_JPRB, &
  & 0.34286694E-07_JPRB, 0.33021873E-07_JPRB, 0.31758554E-07_JPRB, 0.30703436E-07_JPRB, 0.30236731E-07_JPRB, 0.30115672E-07_JPRB, &
  & 0.30427327E-07_JPRB, 0.30643452E-07_JPRB, 0.31283302E-07_JPRB, 0.32269115E-07_JPRB, 0.33340879E-07_JPRB, 0.34039119E-07_JPRB, &
  & 0.33928752E-07_JPRB, 0.33225690E-07_JPRB, 0.32305447E-07_JPRB, 0.31116531E-07_JPRB  /)

RGHG7(:,78, 9) = (/ &
  & 0.32522838E-07_JPRB, 0.32002646E-07_JPRB, 0.31023152E-07_JPRB, 0.30145446E-07_JPRB, 0.29571554E-07_JPRB, 0.28247232E-07_JPRB, &
  & 0.26920355E-07_JPRB, 0.25642056E-07_JPRB, 0.24335308E-07_JPRB, 0.23434018E-07_JPRB, 0.22525845E-07_JPRB, 0.21942755E-07_JPRB, &
  & 0.21589982E-07_JPRB, 0.21360323E-07_JPRB, 0.21221220E-07_JPRB, 0.21290077E-07_JPRB, 0.21372206E-07_JPRB, 0.21508534E-07_JPRB, &
  & 0.21795384E-07_JPRB, 0.22310948E-07_JPRB, 0.22987734E-07_JPRB, 0.23633394E-07_JPRB, 0.24368200E-07_JPRB, 0.24720771E-07_JPRB, &
  & 0.24990565E-07_JPRB, 0.24897757E-07_JPRB, 0.24397432E-07_JPRB, 0.23563872E-07_JPRB, 0.22410977E-07_JPRB, 0.20759906E-07_JPRB, &
  & 0.18857475E-07_JPRB, 0.17588954E-07_JPRB, 0.15496217E-07_JPRB, 0.13573548E-07_JPRB, 0.13020711E-07_JPRB, 0.14261956E-07_JPRB, &
  & 0.16192287E-07_JPRB, 0.18271747E-07_JPRB, 0.20848629E-07_JPRB, 0.23513750E-07_JPRB, 0.26589466E-07_JPRB, 0.29640519E-07_JPRB, &
  & 0.32821690E-07_JPRB, 0.35368637E-07_JPRB, 0.36833573E-07_JPRB, 0.36473153E-07_JPRB, 0.35746510E-07_JPRB, 0.34879277E-07_JPRB, &
  & 0.33339660E-07_JPRB, 0.31913976E-07_JPRB, 0.30584061E-07_JPRB, 0.29516975E-07_JPRB, 0.29060980E-07_JPRB, 0.28877495E-07_JPRB, &
  & 0.29059721E-07_JPRB, 0.29266467E-07_JPRB, 0.29883239E-07_JPRB, 0.30945065E-07_JPRB, 0.32089702E-07_JPRB, 0.32794304E-07_JPRB, &
  & 0.32717739E-07_JPRB, 0.31893655E-07_JPRB, 0.30869701E-07_JPRB, 0.29619323E-07_JPRB  /)

RGHG7(:,79, 9) = (/ &
  & 0.32380471E-07_JPRB, 0.31730298E-07_JPRB, 0.30636095E-07_JPRB, 0.29750860E-07_JPRB, 0.29261886E-07_JPRB, 0.27931723E-07_JPRB, &
  & 0.26544436E-07_JPRB, 0.25215106E-07_JPRB, 0.23830383E-07_JPRB, 0.22884394E-07_JPRB, 0.22070707E-07_JPRB, 0.21538158E-07_JPRB, &
  & 0.21196851E-07_JPRB, 0.20981166E-07_JPRB, 0.20818358E-07_JPRB, 0.20822030E-07_JPRB, 0.20856881E-07_JPRB, 0.20953039E-07_JPRB, &
  & 0.21192825E-07_JPRB, 0.21670034E-07_JPRB, 0.22259151E-07_JPRB, 0.22853611E-07_JPRB, 0.23559529E-07_JPRB, 0.23903302E-07_JPRB, &
  & 0.24157224E-07_JPRB, 0.24075351E-07_JPRB, 0.23576624E-07_JPRB, 0.22733207E-07_JPRB, 0.21592659E-07_JPRB, 0.19940960E-07_JPRB, &
  & 0.18171489E-07_JPRB, 0.17173178E-07_JPRB, 0.15288845E-07_JPRB, 0.13404453E-07_JPRB, 0.12812920E-07_JPRB, 0.13985778E-07_JPRB, &
  & 0.15863905E-07_JPRB, 0.17965286E-07_JPRB, 0.20535238E-07_JPRB, 0.23200042E-07_JPRB, 0.26273161E-07_JPRB, 0.29346519E-07_JPRB, &
  & 0.32524177E-07_JPRB, 0.35035083E-07_JPRB, 0.36449742E-07_JPRB, 0.36052738E-07_JPRB, 0.35297255E-07_JPRB, 0.34316558E-07_JPRB, &
  & 0.32611196E-07_JPRB, 0.31004349E-07_JPRB, 0.29587453E-07_JPRB, 0.28467223E-07_JPRB, 0.27975972E-07_JPRB, 0.27663750E-07_JPRB, &
  & 0.27658967E-07_JPRB, 0.27847723E-07_JPRB, 0.28474346E-07_JPRB, 0.29577496E-07_JPRB, 0.30819731E-07_JPRB, 0.31525530E-07_JPRB, &
  & 0.31475686E-07_JPRB, 0.30534447E-07_JPRB, 0.29424301E-07_JPRB, 0.28084727E-07_JPRB  /)

RGHG7(:,80, 9) = (/ &
  & 0.32170339E-07_JPRB, 0.31411717E-07_JPRB, 0.30218848E-07_JPRB, 0.29343107E-07_JPRB, 0.28939084E-07_JPRB, 0.27599291E-07_JPRB, &
  & 0.26163980E-07_JPRB, 0.24788558E-07_JPRB, 0.23323707E-07_JPRB, 0.22343652E-07_JPRB, 0.21640107E-07_JPRB, 0.21149690E-07_JPRB, &
  & 0.20817301E-07_JPRB, 0.20624981E-07_JPRB, 0.20478490E-07_JPRB, 0.20459508E-07_JPRB, 0.20488828E-07_JPRB, 0.20562961E-07_JPRB, &
  & 0.20807203E-07_JPRB, 0.21237599E-07_JPRB, 0.21764742E-07_JPRB, 0.22295316E-07_JPRB, 0.22913911E-07_JPRB, 0.23236059E-07_JPRB, &
  & 0.23463716E-07_JPRB, 0.23383473E-07_JPRB, 0.22869799E-07_JPRB, 0.21994649E-07_JPRB, 0.20880052E-07_JPRB, 0.19275878E-07_JPRB, &
  & 0.17652487E-07_JPRB, 0.16839161E-07_JPRB, 0.15123160E-07_JPRB, 0.13282134E-07_JPRB, 0.12678267E-07_JPRB, 0.13813913E-07_JPRB, &
  & 0.15635479E-07_JPRB, 0.17757342E-07_JPRB, 0.20316435E-07_JPRB, 0.23002095E-07_JPRB, 0.26084350E-07_JPRB, 0.29205583E-07_JPRB, &
  & 0.32318803E-07_JPRB, 0.34792956E-07_JPRB, 0.36165750E-07_JPRB, 0.35769355E-07_JPRB, 0.34975672E-07_JPRB, 0.33884872E-07_JPRB, &
  & 0.32066951E-07_JPRB, 0.30287395E-07_JPRB, 0.28764318E-07_JPRB, 0.27566288E-07_JPRB, 0.27015943E-07_JPRB, 0.26487767E-07_JPRB, &
  & 0.26236926E-07_JPRB, 0.26420650E-07_JPRB, 0.27092443E-07_JPRB, 0.28228921E-07_JPRB, 0.29581963E-07_JPRB, 0.30244400E-07_JPRB, &
  & 0.30176599E-07_JPRB, 0.29145669E-07_JPRB, 0.27969315E-07_JPRB, 0.26500973E-07_JPRB  /)

RGHG7(:,81, 9) = (/ &
  & 0.31805198E-07_JPRB, 0.31009848E-07_JPRB, 0.29724522E-07_JPRB, 0.28885511E-07_JPRB, 0.28543969E-07_JPRB, 0.27213042E-07_JPRB, &
  & 0.25743113E-07_JPRB, 0.24344471E-07_JPRB, 0.22760567E-07_JPRB, 0.21824418E-07_JPRB, 0.21223040E-07_JPRB, 0.20809458E-07_JPRB, &
  & 0.20527307E-07_JPRB, 0.20354408E-07_JPRB, 0.20228181E-07_JPRB, 0.20199488E-07_JPRB, 0.20241051E-07_JPRB, 0.20321940E-07_JPRB, &
  & 0.20540007E-07_JPRB, 0.20938318E-07_JPRB, 0.21420288E-07_JPRB, 0.21892602E-07_JPRB, 0.22439427E-07_JPRB, 0.22700783E-07_JPRB, &
  & 0.22874824E-07_JPRB, 0.22796692E-07_JPRB, 0.22252198E-07_JPRB, 0.21364805E-07_JPRB, 0.20364196E-07_JPRB, 0.18836013E-07_JPRB, &
  & 0.17253150E-07_JPRB, 0.16550011E-07_JPRB, 0.14951797E-07_JPRB, 0.13188451E-07_JPRB, 0.12611603E-07_JPRB, 0.13743027E-07_JPRB, &
  & 0.15516888E-07_JPRB, 0.17622708E-07_JPRB, 0.20155204E-07_JPRB, 0.22862395E-07_JPRB, 0.25976735E-07_JPRB, 0.29110633E-07_JPRB, &
  & 0.32176992E-07_JPRB, 0.34608928E-07_JPRB, 0.35951325E-07_JPRB, 0.35573084E-07_JPRB, 0.34754070E-07_JPRB, 0.33523531E-07_JPRB, &
  & 0.31632152E-07_JPRB, 0.29720034E-07_JPRB, 0.28109567E-07_JPRB, 0.26839767E-07_JPRB, 0.26177124E-07_JPRB, 0.25463191E-07_JPRB, &
  & 0.25016462E-07_JPRB, 0.25033849E-07_JPRB, 0.25702265E-07_JPRB, 0.26856052E-07_JPRB, 0.28187564E-07_JPRB, 0.28943723E-07_JPRB, &
  & 0.28751381E-07_JPRB, 0.27638971E-07_JPRB, 0.26493859E-07_JPRB, 0.25060135E-07_JPRB  /)

RGHG7(:,82, 9) = (/ &
  & 0.31316844E-07_JPRB, 0.30545207E-07_JPRB, 0.29167726E-07_JPRB, 0.28381497E-07_JPRB, 0.28088949E-07_JPRB, 0.26786900E-07_JPRB, &
  & 0.25288391E-07_JPRB, 0.23832648E-07_JPRB, 0.22154011E-07_JPRB, 0.21292609E-07_JPRB, 0.20833465E-07_JPRB, 0.20513099E-07_JPRB, &
  & 0.20304716E-07_JPRB, 0.20147913E-07_JPRB, 0.20029896E-07_JPRB, 0.20000863E-07_JPRB, 0.20046156E-07_JPRB, 0.20123575E-07_JPRB, &
  & 0.20322034E-07_JPRB, 0.20689919E-07_JPRB, 0.21135440E-07_JPRB, 0.21568191E-07_JPRB, 0.22047777E-07_JPRB, 0.22262980E-07_JPRB, &
  & 0.22390437E-07_JPRB, 0.22312075E-07_JPRB, 0.21752085E-07_JPRB, 0.20880450E-07_JPRB, 0.19966921E-07_JPRB, 0.18456945E-07_JPRB, &
  & 0.16898936E-07_JPRB, 0.16264561E-07_JPRB, 0.14767383E-07_JPRB, 0.13104489E-07_JPRB, 0.12575721E-07_JPRB, 0.13724184E-07_JPRB, &
  & 0.15455588E-07_JPRB, 0.17521326E-07_JPRB, 0.20013725E-07_JPRB, 0.22727185E-07_JPRB, 0.25859443E-07_JPRB, 0.29016106E-07_JPRB, &
  & 0.32041138E-07_JPRB, 0.34445669E-07_JPRB, 0.35738377E-07_JPRB, 0.35382245E-07_JPRB, 0.34533991E-07_JPRB, 0.33207943E-07_JPRB, &
  & 0.31239211E-07_JPRB, 0.29218356E-07_JPRB, 0.27535600E-07_JPRB, 0.26221830E-07_JPRB, 0.25462149E-07_JPRB, 0.24600876E-07_JPRB, &
  & 0.24020591E-07_JPRB, 0.23840709E-07_JPRB, 0.24401641E-07_JPRB, 0.25555174E-07_JPRB, 0.26840278E-07_JPRB, 0.27652622E-07_JPRB, &
  & 0.27406341E-07_JPRB, 0.26178360E-07_JPRB, 0.25069233E-07_JPRB, 0.23797013E-07_JPRB  /)

RGHG7(:,83, 9) = (/ &
  & 0.30709251E-07_JPRB, 0.30007510E-07_JPRB, 0.28537066E-07_JPRB, 0.27820149E-07_JPRB, 0.27572701E-07_JPRB, 0.26305189E-07_JPRB, &
  & 0.24787174E-07_JPRB, 0.23256985E-07_JPRB, 0.21518263E-07_JPRB, 0.20766866E-07_JPRB, 0.20491112E-07_JPRB, 0.20278795E-07_JPRB, &
  & 0.20134686E-07_JPRB, 0.19985190E-07_JPRB, 0.19870407E-07_JPRB, 0.19843023E-07_JPRB, 0.19889928E-07_JPRB, 0.19959283E-07_JPRB, &
  & 0.20142231E-07_JPRB, 0.20482838E-07_JPRB, 0.20897203E-07_JPRB, 0.21303268E-07_JPRB, 0.21730693E-07_JPRB, 0.21912985E-07_JPRB, &
  & 0.22006366E-07_JPRB, 0.21920795E-07_JPRB, 0.21358192E-07_JPRB, 0.20504114E-07_JPRB, 0.19662721E-07_JPRB, 0.18170648E-07_JPRB, &
  & 0.16623114E-07_JPRB, 0.16016834E-07_JPRB, 0.14602682E-07_JPRB, 0.13044124E-07_JPRB, 0.12579432E-07_JPRB, 0.13762157E-07_JPRB, &
  & 0.15447989E-07_JPRB, 0.17456467E-07_JPRB, 0.19900371E-07_JPRB, 0.22600202E-07_JPRB, 0.25753292E-07_JPRB, 0.28925713E-07_JPRB, &
  & 0.31915122E-07_JPRB, 0.34288865E-07_JPRB, 0.35527782E-07_JPRB, 0.35167162E-07_JPRB, 0.34299889E-07_JPRB, 0.32905870E-07_JPRB, &
  & 0.30863516E-07_JPRB, 0.28760216E-07_JPRB, 0.27013282E-07_JPRB, 0.25675633E-07_JPRB, 0.24826265E-07_JPRB, 0.23853419E-07_JPRB, &
  & 0.23210822E-07_JPRB, 0.22832412E-07_JPRB, 0.23237717E-07_JPRB, 0.24323891E-07_JPRB, 0.25545401E-07_JPRB, 0.26391783E-07_JPRB, &
  & 0.26150177E-07_JPRB, 0.24809817E-07_JPRB, 0.23793810E-07_JPRB, 0.22731353E-07_JPRB  /)

RGHG7(:,84, 9) = (/ &
  & 0.29992755E-07_JPRB, 0.29390594E-07_JPRB, 0.27825931E-07_JPRB, 0.27194534E-07_JPRB, 0.26996403E-07_JPRB, 0.25759351E-07_JPRB, &
  & 0.24233228E-07_JPRB, 0.22627555E-07_JPRB, 0.20872005E-07_JPRB, 0.20265576E-07_JPRB, 0.20208173E-07_JPRB, 0.20114452E-07_JPRB, &
  & 0.20003018E-07_JPRB, 0.19849194E-07_JPRB, 0.19737872E-07_JPRB, 0.19708696E-07_JPRB, 0.19759395E-07_JPRB, 0.19820931E-07_JPRB, &
  & 0.19989968E-07_JPRB, 0.20307435E-07_JPRB, 0.20693303E-07_JPRB, 0.21079616E-07_JPRB, 0.21475725E-07_JPRB, 0.21635879E-07_JPRB, &
  & 0.21711871E-07_JPRB, 0.21608248E-07_JPRB, 0.21050429E-07_JPRB, 0.20199208E-07_JPRB, 0.19424820E-07_JPRB, 0.17988513E-07_JPRB, &
  & 0.16439520E-07_JPRB, 0.15826499E-07_JPRB, 0.14476449E-07_JPRB, 0.13009037E-07_JPRB, 0.12615884E-07_JPRB, 0.13841912E-07_JPRB, &
  & 0.15475179E-07_JPRB, 0.17419241E-07_JPRB, 0.19811839E-07_JPRB, 0.22478784E-07_JPRB, 0.25664562E-07_JPRB, 0.28832951E-07_JPRB, &
  & 0.31794410E-07_JPRB, 0.34124141E-07_JPRB, 0.35313878E-07_JPRB, 0.34903583E-07_JPRB, 0.34038544E-07_JPRB, 0.32590272E-07_JPRB, &
  & 0.30482809E-07_JPRB, 0.28324144E-07_JPRB, 0.26516677E-07_JPRB, 0.25168387E-07_JPRB, 0.24231303E-07_JPRB, 0.23178928E-07_JPRB, &
  & 0.22546015E-07_JPRB, 0.21996174E-07_JPRB, 0.22244618E-07_JPRB, 0.23172554E-07_JPRB, 0.24322382E-07_JPRB, 0.25190748E-07_JPRB, &
  & 0.24995074E-07_JPRB, 0.23570313E-07_JPRB, 0.22726827E-07_JPRB, 0.21853872E-07_JPRB  /)

RGHG7(:,85, 9) = (/ &
  & 0.29073332E-07_JPRB, 0.28567351E-07_JPRB, 0.26899700E-07_JPRB, 0.26386611E-07_JPRB, 0.26260827E-07_JPRB, 0.25070162E-07_JPRB, &
  & 0.23556381E-07_JPRB, 0.21910279E-07_JPRB, 0.20227076E-07_JPRB, 0.19800664E-07_JPRB, 0.19960728E-07_JPRB, 0.19978932E-07_JPRB, &
  & 0.19893032E-07_JPRB, 0.19731123E-07_JPRB, 0.19619801E-07_JPRB, 0.19586369E-07_JPRB, 0.19636216E-07_JPRB, 0.19695625E-07_JPRB, &
  & 0.19844235E-07_JPRB, 0.20141274E-07_JPRB, 0.20500757E-07_JPRB, 0.20858982E-07_JPRB, 0.21226578E-07_JPRB, 0.21363751E-07_JPRB, &
  & 0.21451234E-07_JPRB, 0.21302925E-07_JPRB, 0.20715741E-07_JPRB, 0.19893034E-07_JPRB, 0.19190994E-07_JPRB, 0.17799797E-07_JPRB, &
  & 0.16245697E-07_JPRB, 0.15629272E-07_JPRB, 0.14315821E-07_JPRB, 0.12893519E-07_JPRB, 0.12532710E-07_JPRB, 0.13756185E-07_JPRB, &
  & 0.15352853E-07_JPRB, 0.17274359E-07_JPRB, 0.19625676E-07_JPRB, 0.22276450E-07_JPRB, 0.25462228E-07_JPRB, 0.28595294E-07_JPRB, &
  & 0.31565265E-07_JPRB, 0.33879249E-07_JPRB, 0.34979616E-07_JPRB, 0.34497400E-07_JPRB, 0.33676194E-07_JPRB, 0.32182387E-07_JPRB, &
  & 0.30002151E-07_JPRB, 0.27817952E-07_JPRB, 0.25962821E-07_JPRB, 0.24616659E-07_JPRB, 0.23595311E-07_JPRB, 0.22492719E-07_JPRB, &
  & 0.21925344E-07_JPRB, 0.21306135E-07_JPRB, 0.21420098E-07_JPRB, 0.22196956E-07_JPRB, 0.23292737E-07_JPRB, 0.24136420E-07_JPRB, &
  & 0.23962875E-07_JPRB, 0.22438530E-07_JPRB, 0.21689096E-07_JPRB, 0.20891893E-07_JPRB  /)

RGHG7(:,86, 9) = (/ &
  & 0.27932076E-07_JPRB, 0.27511770E-07_JPRB, 0.25715633E-07_JPRB, 0.25360748E-07_JPRB, 0.25363957E-07_JPRB, 0.24243559E-07_JPRB, &
  & 0.22771488E-07_JPRB, 0.21152356E-07_JPRB, 0.19649098E-07_JPRB, 0.19398285E-07_JPRB, 0.19751605E-07_JPRB, 0.19859987E-07_JPRB, &
  & 0.19791759E-07_JPRB, 0.19626384E-07_JPRB, 0.19517060E-07_JPRB, 0.19477020E-07_JPRB, 0.19526346E-07_JPRB, 0.19580285E-07_JPRB, &
  & 0.19708031E-07_JPRB, 0.19978546E-07_JPRB, 0.20303850E-07_JPRB, 0.20626186E-07_JPRB, 0.20951804E-07_JPRB, 0.21066212E-07_JPRB, &
  & 0.21162247E-07_JPRB, 0.20965697E-07_JPRB, 0.20376974E-07_JPRB, 0.19621888E-07_JPRB, 0.18958259E-07_JPRB, 0.17600079E-07_JPRB, &
  & 0.16061494E-07_JPRB, 0.15437651E-07_JPRB, 0.14146997E-07_JPRB, 0.12767702E-07_JPRB, 0.12428078E-07_JPRB, 0.13641327E-07_JPRB, &
  & 0.15198213E-07_JPRB, 0.17087726E-07_JPRB, 0.19385565E-07_JPRB, 0.22003434E-07_JPRB, 0.25125938E-07_JPRB, 0.28177547E-07_JPRB, &
  & 0.31190373E-07_JPRB, 0.33509179E-07_JPRB, 0.34486755E-07_JPRB, 0.33936916E-07_JPRB, 0.33162763E-07_JPRB, 0.31610534E-07_JPRB, &
  & 0.29400784E-07_JPRB, 0.27197581E-07_JPRB, 0.25305868E-07_JPRB, 0.23952520E-07_JPRB, 0.22893773E-07_JPRB, 0.21778341E-07_JPRB, &
  & 0.21281830E-07_JPRB, 0.20631533E-07_JPRB, 0.20689262E-07_JPRB, 0.21267988E-07_JPRB, 0.22409022E-07_JPRB, 0.23211579E-07_JPRB, &
  & 0.23033634E-07_JPRB, 0.21418194E-07_JPRB, 0.20658051E-07_JPRB, 0.19962958E-07_JPRB  /)

RGHG7(:,87, 9) = (/ &
  & 0.26473578E-07_JPRB, 0.26123588E-07_JPRB, 0.24131426E-07_JPRB, 0.24041697E-07_JPRB, 0.24269114E-07_JPRB, 0.23229792E-07_JPRB, &
  & 0.21869968E-07_JPRB, 0.20378908E-07_JPRB, 0.19133507E-07_JPRB, 0.19071694E-07_JPRB, 0.19579393E-07_JPRB, 0.19756733E-07_JPRB, &
  & 0.19700595E-07_JPRB, 0.19532605E-07_JPRB, 0.19425888E-07_JPRB, 0.19376245E-07_JPRB, 0.19425136E-07_JPRB, 0.19468125E-07_JPRB, &
  & 0.19573255E-07_JPRB, 0.19806228E-07_JPRB, 0.20085960E-07_JPRB, 0.20364090E-07_JPRB, 0.20648547E-07_JPRB, 0.20738380E-07_JPRB, &
  & 0.20837134E-07_JPRB, 0.20608587E-07_JPRB, 0.20031924E-07_JPRB, 0.19364087E-07_JPRB, 0.18710051E-07_JPRB, 0.17367432E-07_JPRB, &
  & 0.15864316E-07_JPRB, 0.15220919E-07_JPRB, 0.13940288E-07_JPRB, 0.12621739E-07_JPRB, 0.12289051E-07_JPRB, 0.13487928E-07_JPRB, &
  & 0.14987581E-07_JPRB, 0.16830154E-07_JPRB, 0.19075760E-07_JPRB, 0.21634779E-07_JPRB, 0.24645476E-07_JPRB, 0.27572475E-07_JPRB, &
  & 0.30612126E-07_JPRB, 0.32904541E-07_JPRB, 0.33773827E-07_JPRB, 0.33163084E-07_JPRB, 0.32429159E-07_JPRB, 0.30795094E-07_JPRB, &
  & 0.28621627E-07_JPRB, 0.26400604E-07_JPRB, 0.24507381E-07_JPRB, 0.23145150E-07_JPRB, 0.22104870E-07_JPRB, 0.21007222E-07_JPRB, &
  & 0.20587454E-07_JPRB, 0.19910752E-07_JPRB, 0.19969196E-07_JPRB, 0.20347071E-07_JPRB, 0.21594532E-07_JPRB, 0.22336416E-07_JPRB, &
  & 0.22165155E-07_JPRB, 0.20493274E-07_JPRB, 0.19719357E-07_JPRB, 0.19176717E-07_JPRB  /)

RGHG7(:,88, 9) = (/ &
  & 0.24521580E-07_JPRB, 0.24258639E-07_JPRB, 0.22083691E-07_JPRB, 0.22322122E-07_JPRB, 0.22884196E-07_JPRB, 0.21984572E-07_JPRB, &
  & 0.20876075E-07_JPRB, 0.19623738E-07_JPRB, 0.18680940E-07_JPRB, 0.18826317E-07_JPRB, 0.19437241E-07_JPRB, 0.19667006E-07_JPRB, &
  & 0.19618527E-07_JPRB, 0.19447746E-07_JPRB, 0.19342186E-07_JPRB, 0.19279210E-07_JPRB, 0.19326074E-07_JPRB, 0.19350780E-07_JPRB, &
  & 0.19428265E-07_JPRB, 0.19610651E-07_JPRB, 0.19828593E-07_JPRB, 0.20054199E-07_JPRB, 0.20302597E-07_JPRB, 0.20359889E-07_JPRB, &
  & 0.20453223E-07_JPRB, 0.20224406E-07_JPRB, 0.19666860E-07_JPRB, 0.19093954E-07_JPRB, 0.18423551E-07_JPRB, 0.17073842E-07_JPRB, &
  & 0.15624042E-07_JPRB, 0.14943355E-07_JPRB, 0.13659897E-07_JPRB, 0.12426066E-07_JPRB, 0.12087711E-07_JPRB, 0.13267264E-07_JPRB, &
  & 0.14691982E-07_JPRB, 0.16464678E-07_JPRB, 0.18653939E-07_JPRB, 0.21120648E-07_JPRB, 0.23962303E-07_JPRB, 0.26750105E-07_JPRB, &
  & 0.29750503E-07_JPRB, 0.31938940E-07_JPRB, 0.32711304E-07_JPRB, 0.32046116E-07_JPRB, 0.31334199E-07_JPRB, 0.29592473E-07_JPRB, &
  & 0.27541966E-07_JPRB, 0.25305372E-07_JPRB, 0.23475712E-07_JPRB, 0.22134248E-07_JPRB, 0.21186961E-07_JPRB, 0.20141483E-07_JPRB, &
  & 0.19791543E-07_JPRB, 0.19080386E-07_JPRB, 0.19196393E-07_JPRB, 0.19379418E-07_JPRB, 0.20791163E-07_JPRB, 0.21431136E-07_JPRB, &
  & 0.21279782E-07_JPRB, 0.19621598E-07_JPRB, 0.18913810E-07_JPRB, 0.18556157E-07_JPRB  /)

RGHG7(:,89, 9) = (/ &
  & 0.21940651E-07_JPRB, 0.21909003E-07_JPRB, 0.19747779E-07_JPRB, 0.20172482E-07_JPRB, 0.21138141E-07_JPRB, 0.20554316E-07_JPRB, &
  & 0.19929457E-07_JPRB, 0.18986648E-07_JPRB, 0.18319676E-07_JPRB, 0.18662087E-07_JPRB, 0.19315507E-07_JPRB, 0.19589573E-07_JPRB, &
  & 0.19544733E-07_JPRB, 0.19372231E-07_JPRB, 0.19263656E-07_JPRB, 0.19183751E-07_JPRB, 0.19225069E-07_JPRB, 0.19222377E-07_JPRB, &
  & 0.19260955E-07_JPRB, 0.19384983E-07_JPRB, 0.19519419E-07_JPRB, 0.19691094E-07_JPRB, 0.19902163E-07_JPRB, 0.19911018E-07_JPRB, &
  & 0.19991893E-07_JPRB, 0.19803647E-07_JPRB, 0.19274325E-07_JPRB, 0.18787803E-07_JPRB, 0.18084991E-07_JPRB, 0.16705275E-07_JPRB, &
  & 0.15314617E-07_JPRB, 0.14577612E-07_JPRB, 0.13283770E-07_JPRB, 0.12145591E-07_JPRB, 0.11796204E-07_JPRB, 0.12942314E-07_JPRB, &
  & 0.14295399E-07_JPRB, 0.15975224E-07_JPRB, 0.18080228E-07_JPRB, 0.20411434E-07_JPRB, 0.23012773E-07_JPRB, 0.25714020E-07_JPRB, &
  & 0.28549137E-07_JPRB, 0.30507538E-07_JPRB, 0.31130395E-07_JPRB, 0.30430661E-07_JPRB, 0.29709612E-07_JPRB, 0.27858049E-07_JPRB, &
  & 0.26027870E-07_JPRB, 0.23786326E-07_JPRB, 0.22121046E-07_JPRB, 0.20906818E-07_JPRB, 0.20142090E-07_JPRB, 0.19181539E-07_JPRB, &
  & 0.18858956E-07_JPRB, 0.18108616E-07_JPRB, 0.18338442E-07_JPRB, 0.18341090E-07_JPRB, 0.19981896E-07_JPRB, 0.20460938E-07_JPRB, &
  & 0.20298192E-07_JPRB, 0.18756479E-07_JPRB, 0.18290043E-07_JPRB, 0.18070308E-07_JPRB  /)

RGHG7(:,90, 9) = (/ &
  & 0.18898269E-07_JPRB, 0.19602077E-07_JPRB, 0.17416309E-07_JPRB, 0.17697805E-07_JPRB, 0.19037344E-07_JPRB, 0.19033835E-07_JPRB, &
  & 0.19153446E-07_JPRB, 0.18533127E-07_JPRB, 0.18078535E-07_JPRB, 0.18540793E-07_JPRB, 0.19208902E-07_JPRB, 0.19518863E-07_JPRB, &
  & 0.19473054E-07_JPRB, 0.19300269E-07_JPRB, 0.19187432E-07_JPRB, 0.19087930E-07_JPRB, 0.19127744E-07_JPRB, 0.19081876E-07_JPRB, &
  & 0.19055940E-07_JPRB, 0.19122647E-07_JPRB, 0.19134552E-07_JPRB, 0.19268826E-07_JPRB, 0.19414997E-07_JPRB, 0.19366734E-07_JPRB, &
  & 0.19443433E-07_JPRB, 0.19307799E-07_JPRB, 0.18847542E-07_JPRB, 0.18432767E-07_JPRB, 0.17713980E-07_JPRB, 0.16308198E-07_JPRB, &
  & 0.14958921E-07_JPRB, 0.14148223E-07_JPRB, 0.12869964E-07_JPRB, 0.11819738E-07_JPRB, 0.11451119E-07_JPRB, 0.12513933E-07_JPRB, &
  & 0.13822430E-07_JPRB, 0.15430867E-07_JPRB, 0.17400770E-07_JPRB, 0.19498002E-07_JPRB, 0.21813904E-07_JPRB, 0.24474178E-07_JPRB, &
  & 0.27003450E-07_JPRB, 0.28573508E-07_JPRB, 0.28876827E-07_JPRB, 0.28239555E-07_JPRB, 0.27498652E-07_JPRB, 0.25613412E-07_JPRB, &
  & 0.24091546E-07_JPRB, 0.21866346E-07_JPRB, 0.20470837E-07_JPRB, 0.19603792E-07_JPRB, 0.19067035E-07_JPRB, 0.18160099E-07_JPRB, &
  & 0.17793063E-07_JPRB, 0.16995985E-07_JPRB, 0.17326191E-07_JPRB, 0.17282943E-07_JPRB, 0.19181672E-07_JPRB, 0.19553967E-07_JPRB, &
  & 0.19262222E-07_JPRB, 0.17845246E-07_JPRB, 0.17872561E-07_JPRB, 0.17700358E-07_JPRB  /)

RGHG7(:,91, 9) = (/ &
  & 0.16826999E-07_JPRB, 0.18282100E-07_JPRB, 0.15925235E-07_JPRB, 0.15551433E-07_JPRB, 0.16912128E-07_JPRB, 0.17588246E-07_JPRB, &
  & 0.18484008E-07_JPRB, 0.18185784E-07_JPRB, 0.17876374E-07_JPRB, 0.18426164E-07_JPRB, 0.19099826E-07_JPRB, 0.19435703E-07_JPRB, &
  & 0.19382225E-07_JPRB, 0.19215787E-07_JPRB, 0.19098189E-07_JPRB, 0.18975680E-07_JPRB, 0.19006239E-07_JPRB, 0.18933662E-07_JPRB, &
  & 0.18795600E-07_JPRB, 0.18763404E-07_JPRB, 0.18626162E-07_JPRB, 0.18709926E-07_JPRB, 0.18853717E-07_JPRB, 0.18720567E-07_JPRB, &
  & 0.18772408E-07_JPRB, 0.18678821E-07_JPRB, 0.18245538E-07_JPRB, 0.18018255E-07_JPRB, 0.17321946E-07_JPRB, 0.15948427E-07_JPRB, &
  & 0.14615017E-07_JPRB, 0.13707796E-07_JPRB, 0.12516540E-07_JPRB, 0.11516823E-07_JPRB, 0.11113826E-07_JPRB, 0.12067158E-07_JPRB, &
  & 0.13373011E-07_JPRB, 0.14972721E-07_JPRB, 0.16786072E-07_JPRB, 0.18629436E-07_JPRB, 0.20677982E-07_JPRB, 0.23243848E-07_JPRB, &
  & 0.25480114E-07_JPRB, 0.26520485E-07_JPRB, 0.26503296E-07_JPRB, 0.25723222E-07_JPRB, 0.25073024E-07_JPRB, 0.23338254E-07_JPRB, &
  & 0.22110982E-07_JPRB, 0.20088083E-07_JPRB, 0.19091095E-07_JPRB, 0.18569682E-07_JPRB, 0.18151133E-07_JPRB, 0.17218809E-07_JPRB, &
  & 0.16678297E-07_JPRB, 0.15887036E-07_JPRB, 0.16270661E-07_JPRB, 0.16411997E-07_JPRB, 0.18541851E-07_JPRB, 0.18926841E-07_JPRB, &
  & 0.18495467E-07_JPRB, 0.17144868E-07_JPRB, 0.17525218E-07_JPRB, 0.17463554E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ---GEMS----

RGHG7(:, 1,10) = (/ &
  & 0.19165664E-06_JPRB, 0.12794892E-06_JPRB, 0.10331865E-06_JPRB, 0.88503690E-07_JPRB, 0.80152610E-07_JPRB, 0.76933517E-07_JPRB, &
  & 0.74725797E-07_JPRB, 0.74291954E-07_JPRB, 0.72561249E-07_JPRB, 0.72182701E-07_JPRB, 0.71943546E-07_JPRB, 0.71580850E-07_JPRB, &
  & 0.71423067E-07_JPRB, 0.71553323E-07_JPRB, 0.71417070E-07_JPRB, 0.71368603E-07_JPRB, 0.71396521E-07_JPRB, 0.71447907E-07_JPRB, &
  & 0.71203672E-07_JPRB, 0.71046159E-07_JPRB, 0.70776451E-07_JPRB, 0.70527904E-07_JPRB, 0.70288230E-07_JPRB, 0.70121096E-07_JPRB, &
  & 0.69780008E-07_JPRB, 0.69362294E-07_JPRB, 0.68880460E-07_JPRB, 0.68307848E-07_JPRB, 0.67702700E-07_JPRB, 0.67133989E-07_JPRB, &
  & 0.66688727E-07_JPRB, 0.66467798E-07_JPRB, 0.66543443E-07_JPRB, 0.66943592E-07_JPRB, 0.67475327E-07_JPRB, 0.68148744E-07_JPRB, &
  & 0.68851591E-07_JPRB, 0.69310424E-07_JPRB, 0.69554652E-07_JPRB, 0.69814462E-07_JPRB, 0.69892586E-07_JPRB, 0.69765861E-07_JPRB, &
  & 0.69626303E-07_JPRB, 0.69310353E-07_JPRB, 0.68954762E-07_JPRB, 0.68601977E-07_JPRB, 0.68356883E-07_JPRB, 0.68049467E-07_JPRB, &
  & 0.67685797E-07_JPRB, 0.67329523E-07_JPRB, 0.66933950E-07_JPRB, 0.66578139E-07_JPRB, 0.66315735E-07_JPRB, 0.66165313E-07_JPRB, &
  & 0.66071721E-07_JPRB, 0.66116655E-07_JPRB, 0.66324311E-07_JPRB, 0.66913913E-07_JPRB, 0.68961931E-07_JPRB, 0.59134172E-05_JPRB, &
  & 0.59357362E-05_JPRB, 0.59546387E-05_JPRB, 0.59663212E-05_JPRB, 0.59713607E-05_JPRB  /)

RGHG7(:, 2,10) = (/ &
  & 0.16559411E-05_JPRB, 0.16239048E-05_JPRB, 0.14784320E-05_JPRB, 0.13585759E-05_JPRB, 0.12246060E-05_JPRB, 0.11149673E-05_JPRB, &
  & 0.95933183E-06_JPRB, 0.78062834E-06_JPRB, 0.57777658E-06_JPRB, 0.44446151E-06_JPRB, 0.37301919E-06_JPRB, 0.32861504E-06_JPRB, &
  & 0.30163233E-06_JPRB, 0.28300997E-06_JPRB, 0.26668934E-06_JPRB, 0.25436191E-06_JPRB, 0.24666073E-06_JPRB, 0.24222024E-06_JPRB, &
  & 0.23501656E-06_JPRB, 0.22979330E-06_JPRB, 0.22608776E-06_JPRB, 0.22438647E-06_JPRB, 0.22538302E-06_JPRB, 0.23112260E-06_JPRB, &
  & 0.23294777E-06_JPRB, 0.23362671E-06_JPRB, 0.23390912E-06_JPRB, 0.23368327E-06_JPRB, 0.23317904E-06_JPRB, 0.23251842E-06_JPRB, &
  & 0.23185677E-06_JPRB, 0.23132650E-06_JPRB, 0.23249197E-06_JPRB, 0.23692316E-06_JPRB, 0.23252289E-06_JPRB, 0.22699928E-06_JPRB, &
  & 0.22056950E-06_JPRB, 0.21546452E-06_JPRB, 0.21090813E-06_JPRB, 0.20457178E-06_JPRB, 0.19961618E-06_JPRB, 0.19718077E-06_JPRB, &
  & 0.19851140E-06_JPRB, 0.19713663E-06_JPRB, 0.19637351E-06_JPRB, 0.19593088E-06_JPRB, 0.19512885E-06_JPRB, 0.19462712E-06_JPRB, &
  & 0.19421573E-06_JPRB, 0.19502470E-06_JPRB, 0.19195248E-06_JPRB, 0.18774639E-06_JPRB, 0.18276593E-06_JPRB, 0.17718149E-06_JPRB, &
  & 0.16783660E-06_JPRB, 0.15851951E-06_JPRB, 0.14884002E-06_JPRB, 0.14364984E-06_JPRB, 0.14781341E-06_JPRB, 0.45790111E-05_JPRB, &
  & 0.46236896E-05_JPRB, 0.46121813E-05_JPRB, 0.46034202E-05_JPRB, 0.46790187E-05_JPRB  /)

RGHG7(:, 3,10) = (/ &
  & 0.16916425E-05_JPRB, 0.16980010E-05_JPRB, 0.15610185E-05_JPRB, 0.14116944E-05_JPRB, 0.12759099E-05_JPRB, 0.12154750E-05_JPRB, &
  & 0.11383735E-05_JPRB, 0.10050339E-05_JPRB, 0.79905044E-06_JPRB, 0.67283491E-06_JPRB, 0.60327261E-06_JPRB, 0.56248274E-06_JPRB, &
  & 0.53693697E-06_JPRB, 0.51293631E-06_JPRB, 0.49168290E-06_JPRB, 0.47495047E-06_JPRB, 0.46662353E-06_JPRB, 0.45866670E-06_JPRB, &
  & 0.44913020E-06_JPRB, 0.44010727E-06_JPRB, 0.43408807E-06_JPRB, 0.43107693E-06_JPRB, 0.43481285E-06_JPRB, 0.44444289E-06_JPRB, &
  & 0.44270641E-06_JPRB, 0.44261628E-06_JPRB, 0.44115941E-06_JPRB, 0.43907067E-06_JPRB, 0.43650437E-06_JPRB, 0.43346623E-06_JPRB, &
  & 0.42981966E-06_JPRB, 0.42642731E-06_JPRB, 0.42824195E-06_JPRB, 0.43460895E-06_JPRB, 0.42690453E-06_JPRB, 0.42224795E-06_JPRB, &
  & 0.41353965E-06_JPRB, 0.40165094E-06_JPRB, 0.38983671E-06_JPRB, 0.38214347E-06_JPRB, 0.37679723E-06_JPRB, 0.37562606E-06_JPRB, &
  & 0.37714003E-06_JPRB, 0.37196500E-06_JPRB, 0.36930837E-06_JPRB, 0.36455208E-06_JPRB, 0.36062195E-06_JPRB, 0.35665443E-06_JPRB, &
  & 0.35325027E-06_JPRB, 0.35165576E-06_JPRB, 0.34234429E-06_JPRB, 0.32647350E-06_JPRB, 0.30411593E-06_JPRB, 0.27950054E-06_JPRB, &
  & 0.24913456E-06_JPRB, 0.22238939E-06_JPRB, 0.19704088E-06_JPRB, 0.17993840E-06_JPRB, 0.18402177E-06_JPRB, 0.20222190E-05_JPRB, &
  & 0.21622218E-05_JPRB, 0.23116593E-05_JPRB, 0.24017538E-05_JPRB, 0.25089994E-05_JPRB  /)

RGHG7(:, 4,10) = (/ &
  & 0.19712503E-05_JPRB, 0.18683463E-05_JPRB, 0.17084359E-05_JPRB, 0.15648273E-05_JPRB, 0.14564339E-05_JPRB, 0.13825213E-05_JPRB, &
  & 0.13304197E-05_JPRB, 0.12805901E-05_JPRB, 0.12234640E-05_JPRB, 0.12030109E-05_JPRB, 0.11912753E-05_JPRB, 0.11800072E-05_JPRB, &
  & 0.11612578E-05_JPRB, 0.11430863E-05_JPRB, 0.11223528E-05_JPRB, 0.11003513E-05_JPRB, 0.10693074E-05_JPRB, 0.10380828E-05_JPRB, &
  & 0.10149727E-05_JPRB, 0.99973379E-06_JPRB, 0.99479746E-06_JPRB, 0.10017289E-05_JPRB, 0.10243604E-05_JPRB, 0.10469665E-05_JPRB, &
  & 0.10587065E-05_JPRB, 0.10630564E-05_JPRB, 0.10668474E-05_JPRB, 0.10647875E-05_JPRB, 0.10590850E-05_JPRB, 0.10515625E-05_JPRB, &
  & 0.10413058E-05_JPRB, 0.10345273E-05_JPRB, 0.10290802E-05_JPRB, 0.10264053E-05_JPRB, 0.10158525E-05_JPRB, 0.10158258E-05_JPRB, &
  & 0.10130273E-05_JPRB, 0.10010343E-05_JPRB, 0.99280513E-06_JPRB, 0.99187739E-06_JPRB, 0.98708852E-06_JPRB, 0.98751756E-06_JPRB, &
  & 0.98473656E-06_JPRB, 0.98073716E-06_JPRB, 0.98150109E-06_JPRB, 0.99049109E-06_JPRB, 0.10091337E-05_JPRB, 0.10376901E-05_JPRB, &
  & 0.10753020E-05_JPRB, 0.11133090E-05_JPRB, 0.11503118E-05_JPRB, 0.11943361E-05_JPRB, 0.12573643E-05_JPRB, 0.13302860E-05_JPRB, &
  & 0.14069925E-05_JPRB, 0.14865515E-05_JPRB, 0.15600500E-05_JPRB, 0.16122512E-05_JPRB, 0.16859980E-05_JPRB, 0.24636652E-05_JPRB, &
  & 0.24674039E-05_JPRB, 0.24558405E-05_JPRB, 0.24486584E-05_JPRB, 0.24396824E-05_JPRB  /)

RGHG7(:, 5,10) = (/ &
  & 0.19679600E-05_JPRB, 0.19162541E-05_JPRB, 0.18396346E-05_JPRB, 0.17501144E-05_JPRB, 0.16828390E-05_JPRB, 0.16355312E-05_JPRB, &
  & 0.16220017E-05_JPRB, 0.16301565E-05_JPRB, 0.16271647E-05_JPRB, 0.16260621E-05_JPRB, 0.16131576E-05_JPRB, 0.15976177E-05_JPRB, &
  & 0.15639698E-05_JPRB, 0.15414452E-05_JPRB, 0.15136957E-05_JPRB, 0.14816148E-05_JPRB, 0.14252997E-05_JPRB, 0.13701591E-05_JPRB, &
  & 0.13270723E-05_JPRB, 0.13017193E-05_JPRB, 0.12920859E-05_JPRB, 0.13022426E-05_JPRB, 0.13300693E-05_JPRB, 0.13625730E-05_JPRB, &
  & 0.13858118E-05_JPRB, 0.14003508E-05_JPRB, 0.14109105E-05_JPRB, 0.14124662E-05_JPRB, 0.14093134E-05_JPRB, 0.14043798E-05_JPRB, &
  & 0.13965744E-05_JPRB, 0.13920053E-05_JPRB, 0.13788088E-05_JPRB, 0.13667388E-05_JPRB, 0.13619447E-05_JPRB, 0.13693303E-05_JPRB, &
  & 0.13750723E-05_JPRB, 0.13575088E-05_JPRB, 0.13527972E-05_JPRB, 0.13596799E-05_JPRB, 0.13624183E-05_JPRB, 0.13698140E-05_JPRB, &
  & 0.13689962E-05_JPRB, 0.13782861E-05_JPRB, 0.13947175E-05_JPRB, 0.14306872E-05_JPRB, 0.14847381E-05_JPRB, 0.15537336E-05_JPRB, &
  & 0.16393885E-05_JPRB, 0.17275731E-05_JPRB, 0.18329141E-05_JPRB, 0.19531245E-05_JPRB, 0.21062698E-05_JPRB, 0.22659539E-05_JPRB, &
  & 0.24291407E-05_JPRB, 0.25913227E-05_JPRB, 0.27403924E-05_JPRB, 0.28511602E-05_JPRB, 0.29508909E-05_JPRB, 0.30476726E-05_JPRB, &
  & 0.30797443E-05_JPRB, 0.30883345E-05_JPRB, 0.30907376E-05_JPRB, 0.30760891E-05_JPRB  /)

RGHG7(:, 6,10) = (/ &
  & 0.19154245E-05_JPRB, 0.18888902E-05_JPRB, 0.18393740E-05_JPRB, 0.17665711E-05_JPRB, 0.17154964E-05_JPRB, 0.16855562E-05_JPRB, &
  & 0.16763686E-05_JPRB, 0.16897834E-05_JPRB, 0.16913248E-05_JPRB, 0.16834702E-05_JPRB, 0.16632017E-05_JPRB, 0.16441233E-05_JPRB, &
  & 0.16131723E-05_JPRB, 0.15986047E-05_JPRB, 0.15765742E-05_JPRB, 0.15524694E-05_JPRB, 0.15064448E-05_JPRB, 0.14594715E-05_JPRB, &
  & 0.14139364E-05_JPRB, 0.13869958E-05_JPRB, 0.13717773E-05_JPRB, 0.13771522E-05_JPRB, 0.14027601E-05_JPRB, 0.14347856E-05_JPRB, &
  & 0.14609700E-05_JPRB, 0.14803483E-05_JPRB, 0.14910800E-05_JPRB, 0.14943572E-05_JPRB, 0.14934997E-05_JPRB, 0.14918369E-05_JPRB, &
  & 0.14902670E-05_JPRB, 0.14895041E-05_JPRB, 0.14813955E-05_JPRB, 0.14701672E-05_JPRB, 0.14613563E-05_JPRB, 0.14626595E-05_JPRB, &
  & 0.14618026E-05_JPRB, 0.14444494E-05_JPRB, 0.14368687E-05_JPRB, 0.14389314E-05_JPRB, 0.14413829E-05_JPRB, 0.14507678E-05_JPRB, &
  & 0.14513654E-05_JPRB, 0.14606553E-05_JPRB, 0.14782917E-05_JPRB, 0.15169775E-05_JPRB, 0.15708563E-05_JPRB, 0.16362367E-05_JPRB, &
  & 0.17192520E-05_JPRB, 0.18074366E-05_JPRB, 0.19201799E-05_JPRB, 0.20467023E-05_JPRB, 0.22048781E-05_JPRB, 0.23666279E-05_JPRB, &
  & 0.25294322E-05_JPRB, 0.26819549E-05_JPRB, 0.28240623E-05_JPRB, 0.29348109E-05_JPRB, 0.30294921E-05_JPRB, 0.31070891E-05_JPRB, &
  & 0.31281435E-05_JPRB, 0.31108162E-05_JPRB, 0.30854465E-05_JPRB, 0.30576385E-05_JPRB  /)

RGHG7(:, 7,10) = (/ &
  & 0.19676891E-05_JPRB, 0.19535428E-05_JPRB, 0.19144914E-05_JPRB, 0.18522584E-05_JPRB, 0.18133809E-05_JPRB, 0.17972477E-05_JPRB, &
  & 0.18021779E-05_JPRB, 0.18230134E-05_JPRB, 0.18329173E-05_JPRB, 0.18339455E-05_JPRB, 0.18153344E-05_JPRB, 0.17986442E-05_JPRB, &
  & 0.17755051E-05_JPRB, 0.17654330E-05_JPRB, 0.17487731E-05_JPRB, 0.17288828E-05_JPRB, 0.16916211E-05_JPRB, 0.16571613E-05_JPRB, &
  & 0.16173808E-05_JPRB, 0.15856703E-05_JPRB, 0.15685051E-05_JPRB, 0.15668562E-05_JPRB, 0.15836742E-05_JPRB, 0.16120948E-05_JPRB, &
  & 0.16385328E-05_JPRB, 0.16610587E-05_JPRB, 0.16728848E-05_JPRB, 0.16806240E-05_JPRB, 0.16875201E-05_JPRB, 0.16954329E-05_JPRB, &
  & 0.17038042E-05_JPRB, 0.17105781E-05_JPRB, 0.17048458E-05_JPRB, 0.16920157E-05_JPRB, 0.16745027E-05_JPRB, 0.16632464E-05_JPRB, &
  & 0.16557563E-05_JPRB, 0.16382372E-05_JPRB, 0.16294539E-05_JPRB, 0.16269750E-05_JPRB, 0.16276608E-05_JPRB, 0.16363092E-05_JPRB, &
  & 0.16379199E-05_JPRB, 0.16508980E-05_JPRB, 0.16749947E-05_JPRB, 0.17200767E-05_JPRB, 0.17744978E-05_JPRB, 0.18405531E-05_JPRB, &
  & 0.19261308E-05_JPRB, 0.20218663E-05_JPRB, 0.21435856E-05_JPRB, 0.22732296E-05_JPRB, 0.24278591E-05_JPRB, 0.25847590E-05_JPRB, &
  & 0.27364869E-05_JPRB, 0.28761266E-05_JPRB, 0.30084490E-05_JPRB, 0.31148957E-05_JPRB, 0.32039326E-05_JPRB, 0.32742019E-05_JPRB, &
  & 0.32814993E-05_JPRB, 0.32303324E-05_JPRB, 0.31643719E-05_JPRB, 0.31192875E-05_JPRB  /)

RGHG7(:, 8,10) = (/ &
  & 0.21172407E-05_JPRB, 0.21034449E-05_JPRB, 0.20673642E-05_JPRB, 0.20213915E-05_JPRB, 0.19998908E-05_JPRB, 0.19993648E-05_JPRB, &
  & 0.20235286E-05_JPRB, 0.20595441E-05_JPRB, 0.20864085E-05_JPRB, 0.21065618E-05_JPRB, 0.21072560E-05_JPRB, 0.21082407E-05_JPRB, &
  & 0.21006771E-05_JPRB, 0.21002286E-05_JPRB, 0.20910892E-05_JPRB, 0.20793273E-05_JPRB, 0.20512080E-05_JPRB, 0.20288480E-05_JPRB, &
  & 0.19988407E-05_JPRB, 0.19664084E-05_JPRB, 0.19465428E-05_JPRB, 0.19353842E-05_JPRB, 0.19375121E-05_JPRB, 0.19525788E-05_JPRB, &
  & 0.19700151E-05_JPRB, 0.19867362E-05_JPRB, 0.19988415E-05_JPRB, 0.20110022E-05_JPRB, 0.20244665E-05_JPRB, 0.20411711E-05_JPRB, &
  & 0.20581055E-05_JPRB, 0.20719112E-05_JPRB, 0.20716888E-05_JPRB, 0.20600164E-05_JPRB, 0.20372511E-05_JPRB, 0.20191748E-05_JPRB, &
  & 0.20078209E-05_JPRB, 0.19914460E-05_JPRB, 0.19839892E-05_JPRB, 0.19831009E-05_JPRB, 0.19856857E-05_JPRB, 0.19982772E-05_JPRB, &
  & 0.20077395E-05_JPRB, 0.20305508E-05_JPRB, 0.20636262E-05_JPRB, 0.21155765E-05_JPRB, 0.21733196E-05_JPRB, 0.22427456E-05_JPRB, &
  & 0.23301393E-05_JPRB, 0.24289250E-05_JPRB, 0.25492349E-05_JPRB, 0.26684501E-05_JPRB, 0.28056994E-05_JPRB, 0.29428178E-05_JPRB, &
  & 0.30729121E-05_JPRB, 0.31922679E-05_JPRB, 0.33054893E-05_JPRB, 0.33957258E-05_JPRB, 0.34720820E-05_JPRB, 0.35242301E-05_JPRB, &
  & 0.35026978E-05_JPRB, 0.34092790E-05_JPRB, 0.32970178E-05_JPRB, 0.32282448E-05_JPRB  /)

RGHG7(:, 9,10) = (/ &
  & 0.23866417E-05_JPRB, 0.23704306E-05_JPRB, 0.23399406E-05_JPRB, 0.23179728E-05_JPRB, 0.23198599E-05_JPRB, 0.23424643E-05_JPRB, &
  & 0.23925040E-05_JPRB, 0.24556140E-05_JPRB, 0.25118542E-05_JPRB, 0.25655919E-05_JPRB, 0.26074608E-05_JPRB, 0.26455320E-05_JPRB, &
  & 0.26659960E-05_JPRB, 0.26860676E-05_JPRB, 0.26917359E-05_JPRB, 0.26944175E-05_JPRB, 0.26773763E-05_JPRB, 0.26649593E-05_JPRB, &
  & 0.26436378E-05_JPRB, 0.26120095E-05_JPRB, 0.25860704E-05_JPRB, 0.25630699E-05_JPRB, 0.25486385E-05_JPRB, 0.25418037E-05_JPRB, &
  & 0.25403619E-05_JPRB, 0.25386250E-05_JPRB, 0.25441182E-05_JPRB, 0.25524305E-05_JPRB, 0.25626679E-05_JPRB, 0.25776327E-05_JPRB, &
  & 0.25931401E-05_JPRB, 0.26076668E-05_JPRB, 0.26155277E-05_JPRB, 0.26135975E-05_JPRB, 0.25990054E-05_JPRB, 0.25909402E-05_JPRB, &
  & 0.25883579E-05_JPRB, 0.25818196E-05_JPRB, 0.25852923E-05_JPRB, 0.26000007E-05_JPRB, 0.26169005E-05_JPRB, 0.26462086E-05_JPRB, &
  & 0.26731835E-05_JPRB, 0.27118956E-05_JPRB, 0.27537011E-05_JPRB, 0.28092873E-05_JPRB, 0.28698925E-05_JPRB, 0.29421697E-05_JPRB, &
  & 0.30268443E-05_JPRB, 0.31168883E-05_JPRB, 0.32187494E-05_JPRB, 0.33097390E-05_JPRB, 0.34107691E-05_JPRB, 0.35095536E-05_JPRB, &
  & 0.36052748E-05_JPRB, 0.36905892E-05_JPRB, 0.37656613E-05_JPRB, 0.38189314E-05_JPRB, 0.38618270E-05_JPRB, 0.38739048E-05_JPRB, &
  & 0.38042216E-05_JPRB, 0.36576614E-05_JPRB, 0.34965856E-05_JPRB, 0.34057210E-05_JPRB  /)

RGHG7(:,10,10) = (/ &
  & 0.27788891E-05_JPRB, 0.27730357E-05_JPRB, 0.27621542E-05_JPRB, 0.27688372E-05_JPRB, 0.28021070E-05_JPRB, 0.28632732E-05_JPRB, &
  & 0.29514449E-05_JPRB, 0.30552984E-05_JPRB, 0.31557041E-05_JPRB, 0.32591709E-05_JPRB, 0.33547390E-05_JPRB, 0.34442847E-05_JPRB, &
  & 0.35093926E-05_JPRB, 0.35639268E-05_JPRB, 0.35949250E-05_JPRB, 0.36148335E-05_JPRB, 0.36087935E-05_JPRB, 0.35999743E-05_JPRB, &
  & 0.35770380E-05_JPRB, 0.35356003E-05_JPRB, 0.34945157E-05_JPRB, 0.34543258E-05_JPRB, 0.34265462E-05_JPRB, 0.33988635E-05_JPRB, &
  & 0.33791948E-05_JPRB, 0.33537513E-05_JPRB, 0.33397882E-05_JPRB, 0.33282147E-05_JPRB, 0.33204311E-05_JPRB, 0.33181391E-05_JPRB, &
  & 0.33188084E-05_JPRB, 0.33228865E-05_JPRB, 0.33344805E-05_JPRB, 0.33498665E-05_JPRB, 0.33596515E-05_JPRB, 0.33810212E-05_JPRB, &
  & 0.34107924E-05_JPRB, 0.34355429E-05_JPRB, 0.34682757E-05_JPRB, 0.35169520E-05_JPRB, 0.35688837E-05_JPRB, 0.36297741E-05_JPRB, &
  & 0.36803578E-05_JPRB, 0.37400060E-05_JPRB, 0.37945848E-05_JPRB, 0.38557085E-05_JPRB, 0.39175903E-05_JPRB, 0.39908139E-05_JPRB, &
  & 0.40707641E-05_JPRB, 0.41445277E-05_JPRB, 0.42179850E-05_JPRB, 0.42725949E-05_JPRB, 0.43238955E-05_JPRB, 0.43704674E-05_JPRB, &
  & 0.44120374E-05_JPRB, 0.44338188E-05_JPRB, 0.44343880E-05_JPRB, 0.44135409E-05_JPRB, 0.43784775E-05_JPRB, 0.43154848E-05_JPRB, &
  & 0.41761713E-05_JPRB, 0.39634722E-05_JPRB, 0.37536432E-05_JPRB, 0.36396181E-05_JPRB  /)

RGHG7(:,11,10) = (/ &
  & 0.32611287E-05_JPRB, 0.32684940E-05_JPRB, 0.32870898E-05_JPRB, 0.33356556E-05_JPRB, 0.34221417E-05_JPRB, 0.35394296E-05_JPRB, &
  & 0.36805576E-05_JPRB, 0.38364516E-05_JPRB, 0.39943152E-05_JPRB, 0.41567001E-05_JPRB, 0.43121568E-05_JPRB, 0.44633034E-05_JPRB, &
  & 0.45904285E-05_JPRB, 0.46957852E-05_JPRB, 0.47636480E-05_JPRB, 0.48082261E-05_JPRB, 0.48169217E-05_JPRB, 0.48108855E-05_JPRB, &
  & 0.47829702E-05_JPRB, 0.47233890E-05_JPRB, 0.46570834E-05_JPRB, 0.45880095E-05_JPRB, 0.45386629E-05_JPRB, 0.44884711E-05_JPRB, &
  & 0.44513354E-05_JPRB, 0.43998010E-05_JPRB, 0.43529738E-05_JPRB, 0.43087075E-05_JPRB, 0.42724878E-05_JPRB, 0.42453936E-05_JPRB, &
  & 0.42264918E-05_JPRB, 0.42134922E-05_JPRB, 0.42183609E-05_JPRB, 0.42408177E-05_JPRB, 0.42743827E-05_JPRB, 0.43302280E-05_JPRB, &
  & 0.44073997E-05_JPRB, 0.44889889E-05_JPRB, 0.45732457E-05_JPRB, 0.46714595E-05_JPRB, 0.47697461E-05_JPRB, 0.48620401E-05_JPRB, &
  & 0.49357538E-05_JPRB, 0.50128703E-05_JPRB, 0.50831430E-05_JPRB, 0.51534850E-05_JPRB, 0.52116463E-05_JPRB, 0.52737014E-05_JPRB, &
  & 0.53342643E-05_JPRB, 0.53824822E-05_JPRB, 0.54202701E-05_JPRB, 0.54335274E-05_JPRB, 0.54290108E-05_JPRB, 0.54100283E-05_JPRB, &
  & 0.53692214E-05_JPRB, 0.52930192E-05_JPRB, 0.51862795E-05_JPRB, 0.50571824E-05_JPRB, 0.49151763E-05_JPRB, 0.47535272E-05_JPRB, &
  & 0.45365822E-05_JPRB, 0.42725135E-05_JPRB, 0.40276113E-05_JPRB, 0.38719912E-05_JPRB  /)

RGHG7(:,12,10) = (/ &
  & 0.37794160E-05_JPRB, 0.38005634E-05_JPRB, 0.38582721E-05_JPRB, 0.39653747E-05_JPRB, 0.41163526E-05_JPRB, 0.42974493E-05_JPRB, &
  & 0.44959688E-05_JPRB, 0.47017295E-05_JPRB, 0.49107653E-05_JPRB, 0.51271890E-05_JPRB, 0.53403674E-05_JPRB, 0.55492069E-05_JPRB, &
  & 0.57403044E-05_JPRB, 0.59092271E-05_JPRB, 0.60384189E-05_JPRB, 0.61377413E-05_JPRB, 0.61981753E-05_JPRB, 0.62372116E-05_JPRB, &
  & 0.62415018E-05_JPRB, 0.61953181E-05_JPRB, 0.61275706E-05_JPRB, 0.60414681E-05_JPRB, 0.59646035E-05_JPRB, 0.58862805E-05_JPRB, &
  & 0.58110386E-05_JPRB, 0.57142995E-05_JPRB, 0.56161995E-05_JPRB, 0.55194191E-05_JPRB, 0.54330323E-05_JPRB, 0.53632092E-05_JPRB, &
  & 0.53114380E-05_JPRB, 0.52738296E-05_JPRB, 0.52615157E-05_JPRB, 0.52738882E-05_JPRB, 0.53213211E-05_JPRB, 0.54108313E-05_JPRB, &
  & 0.55370551E-05_JPRB, 0.56852645E-05_JPRB, 0.58351964E-05_JPRB, 0.59852134E-05_JPRB, 0.61153113E-05_JPRB, 0.62192971E-05_JPRB, &
  & 0.62949093E-05_JPRB, 0.63554892E-05_JPRB, 0.64033913E-05_JPRB, 0.64419645E-05_JPRB, 0.64571944E-05_JPRB, 0.64615190E-05_JPRB, &
  & 0.64558830E-05_JPRB, 0.64465760E-05_JPRB, 0.64284397E-05_JPRB, 0.63862790E-05_JPRB, 0.63201362E-05_JPRB, 0.62295606E-05_JPRB, &
  & 0.61019619E-05_JPRB, 0.59362210E-05_JPRB, 0.57420651E-05_JPRB, 0.55305622E-05_JPRB, 0.53177313E-05_JPRB, 0.51017814E-05_JPRB, &
  & 0.48631513E-05_JPRB, 0.46046252E-05_JPRB, 0.43605502E-05_JPRB, 0.41942379E-05_JPRB  /)

RGHG7(:,13,10) = (/ &
  & 0.43197858E-05_JPRB, 0.43587822E-05_JPRB, 0.44498993E-05_JPRB, 0.46087563E-05_JPRB, 0.48110067E-05_JPRB, 0.50405209E-05_JPRB, &
  & 0.52778422E-05_JPRB, 0.55104547E-05_JPRB, 0.57431498E-05_JPRB, 0.59817335E-05_JPRB, 0.62227877E-05_JPRB, 0.64607387E-05_JPRB, &
  & 0.66866530E-05_JPRB, 0.68962013E-05_JPRB, 0.70810962E-05_JPRB, 0.72422484E-05_JPRB, 0.73751150E-05_JPRB, 0.74885980E-05_JPRB, &
  & 0.75709884E-05_JPRB, 0.76035483E-05_JPRB, 0.75972602E-05_JPRB, 0.75510918E-05_JPRB, 0.74863612E-05_JPRB, 0.74015075E-05_JPRB, &
  & 0.72916868E-05_JPRB, 0.71452616E-05_JPRB, 0.69974167E-05_JPRB, 0.68442302E-05_JPRB, 0.66964918E-05_JPRB, 0.65673944E-05_JPRB, &
  & 0.64611818E-05_JPRB, 0.63836949E-05_JPRB, 0.63513271E-05_JPRB, 0.63566627E-05_JPRB, 0.64129258E-05_JPRB, 0.65367951E-05_JPRB, &
  & 0.67086852E-05_JPRB, 0.69029838E-05_JPRB, 0.70886563E-05_JPRB, 0.72547604E-05_JPRB, 0.73794263E-05_JPRB, 0.74562278E-05_JPRB, &
  & 0.74897807E-05_JPRB, 0.74984430E-05_JPRB, 0.74825722E-05_JPRB, 0.74442395E-05_JPRB, 0.73855995E-05_JPRB, 0.73070395E-05_JPRB, &
  & 0.72224327E-05_JPRB, 0.71467428E-05_JPRB, 0.70671628E-05_JPRB, 0.69657942E-05_JPRB, 0.68390361E-05_JPRB, 0.66861716E-05_JPRB, &
  & 0.64910782E-05_JPRB, 0.62652828E-05_JPRB, 0.60226813E-05_JPRB, 0.57647514E-05_JPRB, 0.55137567E-05_JPRB, 0.52843048E-05_JPRB, &
  & 0.50669049E-05_JPRB, 0.48446217E-05_JPRB, 0.46365607E-05_JPRB, 0.44943914E-05_JPRB  /)

RGHG7(:,14,10) = (/ &
  & 0.48142482E-05_JPRB, 0.48717611E-05_JPRB, 0.49916396E-05_JPRB, 0.51802934E-05_JPRB, 0.54113534E-05_JPRB, 0.56644923E-05_JPRB, &
  & 0.59162276E-05_JPRB, 0.61522892E-05_JPRB, 0.63837659E-05_JPRB, 0.66175129E-05_JPRB, 0.68557814E-05_JPRB, 0.70881960E-05_JPRB, &
  & 0.73112243E-05_JPRB, 0.75205683E-05_JPRB, 0.77165226E-05_JPRB, 0.78974403E-05_JPRB, 0.80674770E-05_JPRB, 0.82296051E-05_JPRB, &
  & 0.83788257E-05_JPRB, 0.85038832E-05_JPRB, 0.85950561E-05_JPRB, 0.86398196E-05_JPRB, 0.86410504E-05_JPRB, 0.85983441E-05_JPRB, &
  & 0.85123606E-05_JPRB, 0.83601307E-05_JPRB, 0.81978059E-05_JPRB, 0.80335172E-05_JPRB, 0.78685551E-05_JPRB, 0.77078206E-05_JPRB, &
  & 0.75597404E-05_JPRB, 0.74569613E-05_JPRB, 0.74126378E-05_JPRB, 0.74185927E-05_JPRB, 0.74766639E-05_JPRB, 0.76110056E-05_JPRB, &
  & 0.77919254E-05_JPRB, 0.79747052E-05_JPRB, 0.81292484E-05_JPRB, 0.82485805E-05_JPRB, 0.83231228E-05_JPRB, 0.83451516E-05_JPRB, &
  & 0.83195285E-05_JPRB, 0.82668598E-05_JPRB, 0.81747171E-05_JPRB, 0.80577033E-05_JPRB, 0.79256329E-05_JPRB, 0.77743375E-05_JPRB, &
  & 0.76210738E-05_JPRB, 0.74854925E-05_JPRB, 0.73497914E-05_JPRB, 0.71914639E-05_JPRB, 0.70084789E-05_JPRB, 0.68055934E-05_JPRB, &
  & 0.65652132E-05_JPRB, 0.63021279E-05_JPRB, 0.60240236E-05_JPRB, 0.57389089E-05_JPRB, 0.54663419E-05_JPRB, 0.52267591E-05_JPRB, &
  & 0.50149997E-05_JPRB, 0.48208682E-05_JPRB, 0.46601505E-05_JPRB, 0.45595590E-05_JPRB  /)

RGHG7(:,15,10) = (/ &
  & 0.51874609E-05_JPRB, 0.52544079E-05_JPRB, 0.53914470E-05_JPRB, 0.55853443E-05_JPRB, 0.58146337E-05_JPRB, 0.60639121E-05_JPRB, &
  & 0.63164510E-05_JPRB, 0.65500348E-05_JPRB, 0.67720921E-05_JPRB, 0.69888893E-05_JPRB, 0.72080696E-05_JPRB, 0.74214183E-05_JPRB, &
  & 0.76209773E-05_JPRB, 0.78060277E-05_JPRB, 0.79820413E-05_JPRB, 0.81480841E-05_JPRB, 0.83146332E-05_JPRB, 0.84831814E-05_JPRB, &
  & 0.86547579E-05_JPRB, 0.88288034E-05_JPRB, 0.89894882E-05_JPRB, 0.91198771E-05_JPRB, 0.92069511E-05_JPRB, 0.92395273E-05_JPRB, &
  & 0.92348352E-05_JPRB, 0.91616228E-05_JPRB, 0.90648262E-05_JPRB, 0.89715616E-05_JPRB, 0.88818170E-05_JPRB, 0.87917731E-05_JPRB, &
  & 0.86971883E-05_JPRB, 0.86154228E-05_JPRB, 0.85631522E-05_JPRB, 0.85476475E-05_JPRB, 0.85632933E-05_JPRB, 0.86333555E-05_JPRB, &
  & 0.87264339E-05_JPRB, 0.88051961E-05_JPRB, 0.88569004E-05_JPRB, 0.88789280E-05_JPRB, 0.88689278E-05_JPRB, 0.88258893E-05_JPRB, &
  & 0.87524110E-05_JPRB, 0.86456212E-05_JPRB, 0.84890635E-05_JPRB, 0.83052049E-05_JPRB, 0.81117905E-05_JPRB, 0.79031288E-05_JPRB, &
  & 0.76947942E-05_JPRB, 0.75063327E-05_JPRB, 0.73210281E-05_JPRB, 0.71115678E-05_JPRB, 0.68794003E-05_JPRB, 0.66354737E-05_JPRB, &
  & 0.63686035E-05_JPRB, 0.60855638E-05_JPRB, 0.57838925E-05_JPRB, 0.54800776E-05_JPRB, 0.51958759E-05_JPRB, 0.49555267E-05_JPRB, &
  & 0.47544599E-05_JPRB, 0.45847845E-05_JPRB, 0.44671117E-05_JPRB, 0.44030516E-05_JPRB  /)

RGHG7(:,16,10) = (/ &
  & 0.53490508E-05_JPRB, 0.54202648E-05_JPRB, 0.55553853E-05_JPRB, 0.57457098E-05_JPRB, 0.59663106E-05_JPRB, 0.62045698E-05_JPRB, &
  & 0.64552106E-05_JPRB, 0.66876098E-05_JPRB, 0.69048961E-05_JPRB, 0.71071927E-05_JPRB, 0.73031264E-05_JPRB, 0.74951266E-05_JPRB, &
  & 0.76688932E-05_JPRB, 0.78242749E-05_JPRB, 0.79707389E-05_JPRB, 0.81094977E-05_JPRB, 0.82546631E-05_JPRB, 0.84091702E-05_JPRB, &
  & 0.85795652E-05_JPRB, 0.87702516E-05_JPRB, 0.89661780E-05_JPRB, 0.91481109E-05_JPRB, 0.93076732E-05_JPRB, 0.94210141E-05_JPRB, &
  & 0.95066317E-05_JPRB, 0.95456184E-05_JPRB, 0.95612653E-05_JPRB, 0.95991618E-05_JPRB, 0.96663683E-05_JPRB, 0.97513541E-05_JPRB, &
  & 0.98229933E-05_JPRB, 0.98441783E-05_JPRB, 0.98142895E-05_JPRB, 0.97366518E-05_JPRB, 0.96304822E-05_JPRB, 0.95429247E-05_JPRB, &
  & 0.94593359E-05_JPRB, 0.93761090E-05_JPRB, 0.92939050E-05_JPRB, 0.92026710E-05_JPRB, 0.90884160E-05_JPRB, 0.89740686E-05_JPRB, &
  & 0.88549550E-05_JPRB, 0.87020114E-05_JPRB, 0.84920775E-05_JPRB, 0.82499978E-05_JPRB, 0.80050009E-05_JPRB, 0.77440424E-05_JPRB, &
  & 0.74767223E-05_JPRB, 0.72323266E-05_JPRB, 0.70059053E-05_JPRB, 0.67650446E-05_JPRB, 0.65089975E-05_JPRB, 0.62473084E-05_JPRB, &
  & 0.59775854E-05_JPRB, 0.57010707E-05_JPRB, 0.54024811E-05_JPRB, 0.50965648E-05_JPRB, 0.48155299E-05_JPRB, 0.45851283E-05_JPRB, &
  & 0.44097212E-05_JPRB, 0.42718620E-05_JPRB, 0.41877866E-05_JPRB, 0.41433170E-05_JPRB  /)

RGHG7(:,17,10) = (/ &
  & 0.52609869E-05_JPRB, 0.53451674E-05_JPRB, 0.54794849E-05_JPRB, 0.56699661E-05_JPRB, 0.58916943E-05_JPRB, 0.61258475E-05_JPRB, &
  & 0.63741152E-05_JPRB, 0.66160169E-05_JPRB, 0.68321084E-05_JPRB, 0.70262710E-05_JPRB, 0.72064285E-05_JPRB, 0.73772854E-05_JPRB, &
  & 0.75298081E-05_JPRB, 0.76602940E-05_JPRB, 0.77802419E-05_JPRB, 0.78931376E-05_JPRB, 0.80121413E-05_JPRB, 0.81442581E-05_JPRB, &
  & 0.82970870E-05_JPRB, 0.84751323E-05_JPRB, 0.86751181E-05_JPRB, 0.88722203E-05_JPRB, 0.90678306E-05_JPRB, 0.92545292E-05_JPRB, &
  & 0.94285181E-05_JPRB, 0.95709498E-05_JPRB, 0.96759394E-05_JPRB, 0.98040804E-05_JPRB, 0.99893486E-05_JPRB, 0.10207427E-04_JPRB, &
  & 0.10423085E-04_JPRB, 0.10577228E-04_JPRB, 0.10608279E-04_JPRB, 0.10491265E-04_JPRB, 0.10274361E-04_JPRB, 0.10060448E-04_JPRB, &
  & 0.98677253E-05_JPRB, 0.96857872E-05_JPRB, 0.95113961E-05_JPRB, 0.93267919E-05_JPRB, 0.91263478E-05_JPRB, 0.89499360E-05_JPRB, &
  & 0.87775045E-05_JPRB, 0.85611913E-05_JPRB, 0.82932198E-05_JPRB, 0.80005618E-05_JPRB, 0.77050374E-05_JPRB, 0.73982394E-05_JPRB, &
  & 0.70838421E-05_JPRB, 0.68061497E-05_JPRB, 0.65671479E-05_JPRB, 0.63279875E-05_JPRB, 0.60825303E-05_JPRB, 0.58357129E-05_JPRB, &
  & 0.55848762E-05_JPRB, 0.53288925E-05_JPRB, 0.50512942E-05_JPRB, 0.47672243E-05_JPRB, 0.45013138E-05_JPRB, 0.42784239E-05_JPRB, &
  & 0.41195728E-05_JPRB, 0.40064601E-05_JPRB, 0.39376708E-05_JPRB, 0.39021383E-05_JPRB  /)

RGHG7(:,18,10) = (/ &
  & 0.50099195E-05_JPRB, 0.51001864E-05_JPRB, 0.52400945E-05_JPRB, 0.54343426E-05_JPRB, 0.56642664E-05_JPRB, 0.58971113E-05_JPRB, &
  & 0.61424646E-05_JPRB, 0.63892701E-05_JPRB, 0.66078553E-05_JPRB, 0.67996436E-05_JPRB, 0.69765931E-05_JPRB, 0.71348884E-05_JPRB, &
  & 0.72734687E-05_JPRB, 0.73885783E-05_JPRB, 0.74890140E-05_JPRB, 0.75847498E-05_JPRB, 0.76836636E-05_JPRB, 0.77910141E-05_JPRB, &
  & 0.79166610E-05_JPRB, 0.80658362E-05_JPRB, 0.82433918E-05_JPRB, 0.84268098E-05_JPRB, 0.86158064E-05_JPRB, 0.88312491E-05_JPRB, &
  & 0.90598728E-05_JPRB, 0.93001967E-05_JPRB, 0.95059133E-05_JPRB, 0.97010583E-05_JPRB, 0.99337650E-05_JPRB, 0.10203293E-04_JPRB, &
  & 0.10484822E-04_JPRB, 0.10700347E-04_JPRB, 0.10758286E-04_JPRB, 0.10637153E-04_JPRB, 0.10399003E-04_JPRB, 0.10163634E-04_JPRB, &
  & 0.99569097E-05_JPRB, 0.97588266E-05_JPRB, 0.95591620E-05_JPRB, 0.93349529E-05_JPRB, 0.90864386E-05_JPRB, 0.88545493E-05_JPRB, &
  & 0.86357100E-05_JPRB, 0.83593131E-05_JPRB, 0.80507810E-05_JPRB, 0.77275622E-05_JPRB, 0.74043476E-05_JPRB, 0.70699718E-05_JPRB, &
  & 0.67328090E-05_JPRB, 0.64444309E-05_JPRB, 0.62082844E-05_JPRB, 0.59805604E-05_JPRB, 0.57547400E-05_JPRB, 0.55353717E-05_JPRB, &
  & 0.53042106E-05_JPRB, 0.50621446E-05_JPRB, 0.48053113E-05_JPRB, 0.45446941E-05_JPRB, 0.42958194E-05_JPRB, 0.40812376E-05_JPRB, &
  & 0.39266413E-05_JPRB, 0.38230874E-05_JPRB, 0.37532032E-05_JPRB, 0.37111899E-05_JPRB  /)

RGHG7(:,19,10) = (/ &
  & 0.46661380E-05_JPRB, 0.47591234E-05_JPRB, 0.49052615E-05_JPRB, 0.51043983E-05_JPRB, 0.53375366E-05_JPRB, 0.55737111E-05_JPRB, &
  & 0.58177996E-05_JPRB, 0.60616116E-05_JPRB, 0.62843404E-05_JPRB, 0.64782570E-05_JPRB, 0.66537017E-05_JPRB, 0.68047369E-05_JPRB, &
  & 0.69311193E-05_JPRB, 0.70360210E-05_JPRB, 0.71247879E-05_JPRB, 0.72080205E-05_JPRB, 0.72906620E-05_JPRB, 0.73770606E-05_JPRB, &
  & 0.74772575E-05_JPRB, 0.75971372E-05_JPRB, 0.77425328E-05_JPRB, 0.78991190E-05_JPRB, 0.80609801E-05_JPRB, 0.82648845E-05_JPRB, &
  & 0.85036833E-05_JPRB, 0.87896799E-05_JPRB, 0.90695590E-05_JPRB, 0.93299322E-05_JPRB, 0.95871215E-05_JPRB, 0.98615110E-05_JPRB, &
  & 0.10154600E-04_JPRB, 0.10388485E-04_JPRB, 0.10457526E-04_JPRB, 0.10350069E-04_JPRB, 0.10146078E-04_JPRB, 0.99482669E-05_JPRB, &
  & 0.97749074E-05_JPRB, 0.96013799E-05_JPRB, 0.94191600E-05_JPRB, 0.92083543E-05_JPRB, 0.89547970E-05_JPRB, 0.86910271E-05_JPRB, &
  & 0.84414028E-05_JPRB, 0.81425945E-05_JPRB, 0.78270836E-05_JPRB, 0.74941847E-05_JPRB, 0.71630836E-05_JPRB, 0.68173520E-05_JPRB, &
  & 0.64820875E-05_JPRB, 0.61951965E-05_JPRB, 0.59603983E-05_JPRB, 0.57368101E-05_JPRB, 0.55211464E-05_JPRB, 0.53182789E-05_JPRB, &
  & 0.51013019E-05_JPRB, 0.48669540E-05_JPRB, 0.46207134E-05_JPRB, 0.43783784E-05_JPRB, 0.41448456E-05_JPRB, 0.39434435E-05_JPRB, &
  & 0.37949046E-05_JPRB, 0.36971298E-05_JPRB, 0.36253083E-05_JPRB, 0.35686015E-05_JPRB  /)

RGHG7(:,20,10) = (/ &
  & 0.42964145E-05_JPRB, 0.43832132E-05_JPRB, 0.45298118E-05_JPRB, 0.47291154E-05_JPRB, 0.49615222E-05_JPRB, 0.52014537E-05_JPRB, &
  & 0.54455843E-05_JPRB, 0.56837115E-05_JPRB, 0.59060473E-05_JPRB, 0.61033889E-05_JPRB, 0.62754153E-05_JPRB, 0.64223473E-05_JPRB, &
  & 0.65399355E-05_JPRB, 0.66369907E-05_JPRB, 0.67173444E-05_JPRB, 0.67907960E-05_JPRB, 0.68636572E-05_JPRB, 0.69343491E-05_JPRB, &
  & 0.70124126E-05_JPRB, 0.71067901E-05_JPRB, 0.72199944E-05_JPRB, 0.73451407E-05_JPRB, 0.74752720E-05_JPRB, 0.76480744E-05_JPRB, &
  & 0.78664076E-05_JPRB, 0.81476953E-05_JPRB, 0.84481631E-05_JPRB, 0.87473971E-05_JPRB, 0.90144355E-05_JPRB, 0.92716319E-05_JPRB, &
  & 0.95361585E-05_JPRB, 0.97371015E-05_JPRB, 0.97960425E-05_JPRB, 0.97222358E-05_JPRB, 0.95826005E-05_JPRB, 0.94436710E-05_JPRB, &
  & 0.93205417E-05_JPRB, 0.91930584E-05_JPRB, 0.90556277E-05_JPRB, 0.88908675E-05_JPRB, 0.86720160E-05_JPRB, 0.84182273E-05_JPRB, &
  & 0.81653579E-05_JPRB, 0.78825741E-05_JPRB, 0.75851878E-05_JPRB, 0.72606036E-05_JPRB, 0.69358958E-05_JPRB, 0.65945045E-05_JPRB, &
  & 0.62796974E-05_JPRB, 0.60070467E-05_JPRB, 0.57722344E-05_JPRB, 0.55485620E-05_JPRB, 0.53339780E-05_JPRB, 0.51386869E-05_JPRB, &
  & 0.49305949E-05_JPRB, 0.47008784E-05_JPRB, 0.44595490E-05_JPRB, 0.42338172E-05_JPRB, 0.40171188E-05_JPRB, 0.38307666E-05_JPRB, &
  & 0.36949383E-05_JPRB, 0.36026770E-05_JPRB, 0.35292218E-05_JPRB, 0.34624027E-05_JPRB  /)

RGHG7(:,21,10) = (/ &
  & 0.39251455E-05_JPRB, 0.40001391E-05_JPRB, 0.41396551E-05_JPRB, 0.43331389E-05_JPRB, 0.45618038E-05_JPRB, 0.48035918E-05_JPRB, &
  & 0.50482709E-05_JPRB, 0.52816770E-05_JPRB, 0.54998901E-05_JPRB, 0.56996102E-05_JPRB, 0.58685655E-05_JPRB, 0.60147964E-05_JPRB, &
  & 0.61296147E-05_JPRB, 0.62212269E-05_JPRB, 0.62956158E-05_JPRB, 0.63639271E-05_JPRB, 0.64327363E-05_JPRB, 0.64925224E-05_JPRB, &
  & 0.65514562E-05_JPRB, 0.66232725E-05_JPRB, 0.67076960E-05_JPRB, 0.68011928E-05_JPRB, 0.68998710E-05_JPRB, 0.70351835E-05_JPRB, &
  & 0.72131887E-05_JPRB, 0.74524550E-05_JPRB, 0.77233768E-05_JPRB, 0.80185003E-05_JPRB, 0.82732660E-05_JPRB, 0.84943164E-05_JPRB, &
  & 0.87011369E-05_JPRB, 0.88353022E-05_JPRB, 0.88714891E-05_JPRB, 0.88406618E-05_JPRB, 0.87750978E-05_JPRB, 0.86974003E-05_JPRB, &
  & 0.86240467E-05_JPRB, 0.85473029E-05_JPRB, 0.84636134E-05_JPRB, 0.83588245E-05_JPRB, 0.82019904E-05_JPRB, 0.79977413E-05_JPRB, &
  & 0.77743656E-05_JPRB, 0.75388782E-05_JPRB, 0.72782357E-05_JPRB, 0.69797704E-05_JPRB, 0.66764542E-05_JPRB, 0.63560514E-05_JPRB, &
  & 0.60773848E-05_JPRB, 0.58321263E-05_JPRB, 0.56011079E-05_JPRB, 0.53803465E-05_JPRB, 0.51659131E-05_JPRB, 0.49756093E-05_JPRB, &
  & 0.47753454E-05_JPRB, 0.45502537E-05_JPRB, 0.43138876E-05_JPRB, 0.41045173E-05_JPRB, 0.39086775E-05_JPRB, 0.37385043E-05_JPRB, &
  & 0.36181201E-05_JPRB, 0.35310785E-05_JPRB, 0.34551831E-05_JPRB, 0.33812968E-05_JPRB  /)

RGHG7(:,22,10) = (/ &
  & 0.35602618E-05_JPRB, 0.36267396E-05_JPRB, 0.37513528E-05_JPRB, 0.39337864E-05_JPRB, 0.41549999E-05_JPRB, 0.43956220E-05_JPRB, &
  & 0.46405546E-05_JPRB, 0.48727948E-05_JPRB, 0.50878653E-05_JPRB, 0.52868757E-05_JPRB, 0.54581627E-05_JPRB, 0.56090063E-05_JPRB, &
  & 0.57306170E-05_JPRB, 0.58210633E-05_JPRB, 0.58941343E-05_JPRB, 0.59666528E-05_JPRB, 0.60347017E-05_JPRB, 0.60881516E-05_JPRB, &
  & 0.61312196E-05_JPRB, 0.61814930E-05_JPRB, 0.62423966E-05_JPRB, 0.63076087E-05_JPRB, 0.63754171E-05_JPRB, 0.64752471E-05_JPRB, &
  & 0.65986092E-05_JPRB, 0.67692927E-05_JPRB, 0.69730004E-05_JPRB, 0.72057761E-05_JPRB, 0.74103593E-05_JPRB, 0.75668315E-05_JPRB, &
  & 0.76949314E-05_JPRB, 0.77624402E-05_JPRB, 0.77817981E-05_JPRB, 0.77832600E-05_JPRB, 0.77807029E-05_JPRB, 0.77545058E-05_JPRB, &
  & 0.77163812E-05_JPRB, 0.76757790E-05_JPRB, 0.76325903E-05_JPRB, 0.75851310E-05_JPRB, 0.75027089E-05_JPRB, 0.73784477E-05_JPRB, &
  & 0.72229956E-05_JPRB, 0.70608558E-05_JPRB, 0.68540454E-05_JPRB, 0.66032281E-05_JPRB, 0.63424403E-05_JPRB, 0.60633493E-05_JPRB, &
  & 0.58374503E-05_JPRB, 0.56334529E-05_JPRB, 0.54173372E-05_JPRB, 0.52111743E-05_JPRB, 0.50072843E-05_JPRB, 0.48258005E-05_JPRB, &
  & 0.46384117E-05_JPRB, 0.44210754E-05_JPRB, 0.41952527E-05_JPRB, 0.40012920E-05_JPRB, 0.38323682E-05_JPRB, 0.36805446E-05_JPRB, &
  & 0.35702982E-05_JPRB, 0.34869063E-05_JPRB, 0.34066516E-05_JPRB, 0.33191298E-05_JPRB  /)

RGHG7(:,23,10) = (/ &
  & 0.31047497E-05_JPRB, 0.31721231E-05_JPRB, 0.32871545E-05_JPRB, 0.34596740E-05_JPRB, 0.36764595E-05_JPRB, 0.39243696E-05_JPRB, &
  & 0.41836855E-05_JPRB, 0.44359152E-05_JPRB, 0.46689783E-05_JPRB, 0.48820620E-05_JPRB, 0.50680470E-05_JPRB, 0.52342892E-05_JPRB, &
  & 0.53709391E-05_JPRB, 0.54730685E-05_JPRB, 0.55518781E-05_JPRB, 0.56220077E-05_JPRB, 0.56831565E-05_JPRB, 0.57276265E-05_JPRB, &
  & 0.57573349E-05_JPRB, 0.57863510E-05_JPRB, 0.58251296E-05_JPRB, 0.58638090E-05_JPRB, 0.59036241E-05_JPRB, 0.59659090E-05_JPRB, &
  & 0.60357775E-05_JPRB, 0.61339780E-05_JPRB, 0.62578165E-05_JPRB, 0.63977228E-05_JPRB, 0.65201618E-05_JPRB, 0.66013359E-05_JPRB, &
  & 0.66646011E-05_JPRB, 0.66970613E-05_JPRB, 0.67158140E-05_JPRB, 0.67400661E-05_JPRB, 0.67732755E-05_JPRB, 0.67778390E-05_JPRB, &
  & 0.67492876E-05_JPRB, 0.67133210E-05_JPRB, 0.66821137E-05_JPRB, 0.66636121E-05_JPRB, 0.66315475E-05_JPRB, 0.65772637E-05_JPRB, &
  & 0.64968415E-05_JPRB, 0.64051005E-05_JPRB, 0.62608858E-05_JPRB, 0.60724919E-05_JPRB, 0.58739943E-05_JPRB, 0.56591532E-05_JPRB, &
  & 0.54869801E-05_JPRB, 0.53321464E-05_JPRB, 0.51549269E-05_JPRB, 0.49823437E-05_JPRB, 0.48068590E-05_JPRB, 0.46477395E-05_JPRB, &
  & 0.44832928E-05_JPRB, 0.42893703E-05_JPRB, 0.40881626E-05_JPRB, 0.39125907E-05_JPRB, 0.37702875E-05_JPRB, 0.36332323E-05_JPRB, &
  & 0.35277166E-05_JPRB, 0.34523163E-05_JPRB, 0.33770948E-05_JPRB, 0.32817871E-05_JPRB  /)

RGHG7(:,24,10) = (/ &
  & 0.25716800E-05_JPRB, 0.26407576E-05_JPRB, 0.27489007E-05_JPRB, 0.29131687E-05_JPRB, 0.31312587E-05_JPRB, 0.33938190E-05_JPRB, &
  & 0.36763555E-05_JPRB, 0.39595988E-05_JPRB, 0.42228481E-05_JPRB, 0.44622607E-05_JPRB, 0.46720760E-05_JPRB, 0.48588241E-05_JPRB, &
  & 0.50137439E-05_JPRB, 0.51288659E-05_JPRB, 0.52117033E-05_JPRB, 0.52750177E-05_JPRB, 0.53244916E-05_JPRB, 0.53555946E-05_JPRB, &
  & 0.53695147E-05_JPRB, 0.53775851E-05_JPRB, 0.53932309E-05_JPRB, 0.54056600E-05_JPRB, 0.54162450E-05_JPRB, 0.54387693E-05_JPRB, &
  & 0.54557747E-05_JPRB, 0.54847388E-05_JPRB, 0.55278895E-05_JPRB, 0.55741670E-05_JPRB, 0.56136811E-05_JPRB, 0.56281660E-05_JPRB, &
  & 0.56420014E-05_JPRB, 0.56554431E-05_JPRB, 0.56813221E-05_JPRB, 0.57264574E-05_JPRB, 0.57825950E-05_JPRB, 0.58050110E-05_JPRB, &
  & 0.57791639E-05_JPRB, 0.57412828E-05_JPRB, 0.57146748E-05_JPRB, 0.57125076E-05_JPRB, 0.57156003E-05_JPRB, 0.57187646E-05_JPRB, &
  & 0.57056444E-05_JPRB, 0.56771152E-05_JPRB, 0.55960977E-05_JPRB, 0.54723702E-05_JPRB, 0.53380458E-05_JPRB, 0.51908637E-05_JPRB, &
  & 0.50710291E-05_JPRB, 0.49645222E-05_JPRB, 0.48350667E-05_JPRB, 0.47043191E-05_JPRB, 0.45633615E-05_JPRB, 0.44328835E-05_JPRB, &
  & 0.42971826E-05_JPRB, 0.41320186E-05_JPRB, 0.39613829E-05_JPRB, 0.38109192E-05_JPRB, 0.36946975E-05_JPRB, 0.35741315E-05_JPRB, &
  & 0.34774252E-05_JPRB, 0.34135531E-05_JPRB, 0.33475988E-05_JPRB, 0.32532826E-05_JPRB  /)

RGHG7(:,25,10) = (/ &
  & 0.19455661E-05_JPRB, 0.20155873E-05_JPRB, 0.21207280E-05_JPRB, 0.22798062E-05_JPRB, 0.25086189E-05_JPRB, 0.27963135E-05_JPRB, &
  & 0.31135061E-05_JPRB, 0.34411417E-05_JPRB, 0.37500701E-05_JPRB, 0.40330173E-05_JPRB, 0.42789898E-05_JPRB, 0.44919444E-05_JPRB, &
  & 0.46681811E-05_JPRB, 0.47951411E-05_JPRB, 0.48772065E-05_JPRB, 0.49276535E-05_JPRB, 0.49588987E-05_JPRB, 0.49700573E-05_JPRB, &
  & 0.49640330E-05_JPRB, 0.49525879E-05_JPRB, 0.49440431E-05_JPRB, 0.49315095E-05_JPRB, 0.49113416E-05_JPRB, 0.48924329E-05_JPRB, &
  & 0.48598133E-05_JPRB, 0.48292873E-05_JPRB, 0.47967780E-05_JPRB, 0.47591604E-05_JPRB, 0.47252877E-05_JPRB, 0.46937504E-05_JPRB, &
  & 0.46845532E-05_JPRB, 0.47011259E-05_JPRB, 0.47438612E-05_JPRB, 0.48076970E-05_JPRB, 0.48691103E-05_JPRB, 0.48903682E-05_JPRB, &
  & 0.48607038E-05_JPRB, 0.48164747E-05_JPRB, 0.47875935E-05_JPRB, 0.47850403E-05_JPRB, 0.48001855E-05_JPRB, 0.48382632E-05_JPRB, &
  & 0.48741247E-05_JPRB, 0.48938909E-05_JPRB, 0.48723206E-05_JPRB, 0.48109997E-05_JPRB, 0.47368516E-05_JPRB, 0.46551644E-05_JPRB, &
  & 0.45826388E-05_JPRB, 0.45190230E-05_JPRB, 0.44454976E-05_JPRB, 0.43650613E-05_JPRB, 0.42639068E-05_JPRB, 0.41688569E-05_JPRB, &
  & 0.40686269E-05_JPRB, 0.39368752E-05_JPRB, 0.38028256E-05_JPRB, 0.36875756E-05_JPRB, 0.35953729E-05_JPRB, 0.34944082E-05_JPRB, &
  & 0.34145581E-05_JPRB, 0.33669846E-05_JPRB, 0.33152702E-05_JPRB, 0.32361375E-05_JPRB  /)

RGHG7(:,26,10) = (/ &
  & 0.14224673E-05_JPRB, 0.14852759E-05_JPRB, 0.15793453E-05_JPRB, 0.17291813E-05_JPRB, 0.19627227E-05_JPRB, 0.22630159E-05_JPRB, &
  & 0.25995103E-05_JPRB, 0.29526417E-05_JPRB, 0.32958513E-05_JPRB, 0.36198366E-05_JPRB, 0.39029663E-05_JPRB, 0.41397637E-05_JPRB, &
  & 0.43300863E-05_JPRB, 0.44568113E-05_JPRB, 0.45280219E-05_JPRB, 0.45604635E-05_JPRB, 0.45710564E-05_JPRB, 0.45606897E-05_JPRB, &
  & 0.45349485E-05_JPRB, 0.45027968E-05_JPRB, 0.44711347E-05_JPRB, 0.44336993E-05_JPRB, 0.43806995E-05_JPRB, 0.43261630E-05_JPRB, &
  & 0.42559685E-05_JPRB, 0.41831093E-05_JPRB, 0.41018579E-05_JPRB, 0.40140202E-05_JPRB, 0.39449135E-05_JPRB, 0.39017515E-05_JPRB, &
  & 0.38942383E-05_JPRB, 0.39175928E-05_JPRB, 0.39670298E-05_JPRB, 0.40400281E-05_JPRB, 0.41031051E-05_JPRB, 0.41188607E-05_JPRB, &
  & 0.40860494E-05_JPRB, 0.40386892E-05_JPRB, 0.40089020E-05_JPRB, 0.40059652E-05_JPRB, 0.40260458E-05_JPRB, 0.40760612E-05_JPRB, &
  & 0.41360204E-05_JPRB, 0.41851864E-05_JPRB, 0.42045252E-05_JPRB, 0.41900873E-05_JPRB, 0.41613342E-05_JPRB, 0.41287232E-05_JPRB, &
  & 0.40929117E-05_JPRB, 0.40627342E-05_JPRB, 0.40326162E-05_JPRB, 0.39900756E-05_JPRB, 0.39270892E-05_JPRB, 0.38648236E-05_JPRB, &
  & 0.37951569E-05_JPRB, 0.36988546E-05_JPRB, 0.35985142E-05_JPRB, 0.35159641E-05_JPRB, 0.34470316E-05_JPRB, 0.33689717E-05_JPRB, &
  & 0.33113078E-05_JPRB, 0.32839378E-05_JPRB, 0.32497687E-05_JPRB, 0.31928928E-05_JPRB  /)

RGHG7(:,27,10) = (/ &
  & 0.91375321E-06_JPRB, 0.96599665E-06_JPRB, 0.10454989E-05_JPRB, 0.11841694E-05_JPRB, 0.14204321E-05_JPRB, 0.17292495E-05_JPRB, &
  & 0.20802310E-05_JPRB, 0.24530121E-05_JPRB, 0.28278373E-05_JPRB, 0.31938033E-05_JPRB, 0.35161522E-05_JPRB, 0.37770015E-05_JPRB, &
  & 0.39793700E-05_JPRB, 0.41013726E-05_JPRB, 0.41574959E-05_JPRB, 0.41692073E-05_JPRB, 0.41573090E-05_JPRB, 0.41238510E-05_JPRB, &
  & 0.40775797E-05_JPRB, 0.40233371E-05_JPRB, 0.39679033E-05_JPRB, 0.39044551E-05_JPRB, 0.38163580E-05_JPRB, 0.37267242E-05_JPRB, &
  & 0.36217126E-05_JPRB, 0.35109548E-05_JPRB, 0.33887232E-05_JPRB, 0.32608659E-05_JPRB, 0.31690680E-05_JPRB, 0.31265063E-05_JPRB, &
  & 0.31299185E-05_JPRB, 0.31617172E-05_JPRB, 0.32143957E-05_JPRB, 0.32934370E-05_JPRB, 0.33569142E-05_JPRB, 0.33653062E-05_JPRB, &
  & 0.33294534E-05_JPRB, 0.32800121E-05_JPRB, 0.32497847E-05_JPRB, 0.32464477E-05_JPRB, 0.32690496E-05_JPRB, 0.33230270E-05_JPRB, &
  & 0.33989540E-05_JPRB, 0.34718516E-05_JPRB, 0.35270881E-05_JPRB, 0.35559116E-05_JPRB, 0.35691391E-05_JPRB, 0.35817503E-05_JPRB, &
  & 0.35803957E-05_JPRB, 0.35816737E-05_JPRB, 0.35922958E-05_JPRB, 0.35847725E-05_JPRB, 0.35610853E-05_JPRB, 0.35321161E-05_JPRB, &
  & 0.34925843E-05_JPRB, 0.34341006E-05_JPRB, 0.33679370E-05_JPRB, 0.33186433E-05_JPRB, 0.32737626E-05_JPRB, 0.32208751E-05_JPRB, &
  & 0.31883835E-05_JPRB, 0.31835847E-05_JPRB, 0.31689852E-05_JPRB, 0.31380020E-05_JPRB  /)

RGHG7(:,28,10) = (/ &
  & 0.65995879E-06_JPRB, 0.69336126E-06_JPRB, 0.75406443E-06_JPRB, 0.87463394E-06_JPRB, 0.10929432E-05_JPRB, 0.13916379E-05_JPRB, &
  & 0.17314032E-05_JPRB, 0.20901498E-05_JPRB, 0.24584160E-05_JPRB, 0.28331370E-05_JPRB, 0.31716354E-05_JPRB, 0.34448840E-05_JPRB, &
  & 0.36432773E-05_JPRB, 0.37486607E-05_JPRB, 0.37833748E-05_JPRB, 0.37742189E-05_JPRB, 0.37433760E-05_JPRB, 0.36941037E-05_JPRB, &
  & 0.36318865E-05_JPRB, 0.35599434E-05_JPRB, 0.34858467E-05_JPRB, 0.34015559E-05_JPRB, 0.32934874E-05_JPRB, 0.31848119E-05_JPRB, &
  & 0.30620311E-05_JPRB, 0.29395912E-05_JPRB, 0.28177406E-05_JPRB, 0.26959127E-05_JPRB, 0.26162369E-05_JPRB, 0.25878417E-05_JPRB, &
  & 0.26043655E-05_JPRB, 0.26418412E-05_JPRB, 0.26898001E-05_JPRB, 0.27571936E-05_JPRB, 0.28112579E-05_JPRB, 0.28175013E-05_JPRB, &
  & 0.27845833E-05_JPRB, 0.27432604E-05_JPRB, 0.27203196E-05_JPRB, 0.27254990E-05_JPRB, 0.27562010E-05_JPRB, 0.28146833E-05_JPRB, &
  & 0.28951223E-05_JPRB, 0.29766884E-05_JPRB, 0.30473794E-05_JPRB, 0.30974911E-05_JPRB, 0.31372685E-05_JPRB, 0.31754281E-05_JPRB, &
  & 0.32003608E-05_JPRB, 0.32226622E-05_JPRB, 0.32489623E-05_JPRB, 0.32626024E-05_JPRB, 0.32666544E-05_JPRB, 0.32612045E-05_JPRB, &
  & 0.32443373E-05_JPRB, 0.32118082E-05_JPRB, 0.31738796E-05_JPRB, 0.31475392E-05_JPRB, 0.31237228E-05_JPRB, 0.30888893E-05_JPRB, &
  & 0.30734226E-05_JPRB, 0.30801348E-05_JPRB, 0.30705542E-05_JPRB, 0.30454360E-05_JPRB  /)

RGHG7(:,29,10) = (/ &
  & 0.40209547E-06_JPRB, 0.41517556E-06_JPRB, 0.45577604E-06_JPRB, 0.55686536E-06_JPRB, 0.75525501E-06_JPRB, 0.10424154E-05_JPRB, &
  & 0.13691817E-05_JPRB, 0.17115971E-05_JPRB, 0.20712584E-05_JPRB, 0.24538154E-05_JPRB, 0.28084253E-05_JPRB, 0.30943066E-05_JPRB, &
  & 0.32877933E-05_JPRB, 0.33750513E-05_JPRB, 0.33868066E-05_JPRB, 0.33555341E-05_JPRB, 0.33047717E-05_JPRB, 0.32390584E-05_JPRB, &
  & 0.31601438E-05_JPRB, 0.30696360E-05_JPRB, 0.29759858E-05_JPRB, 0.28698347E-05_JPRB, 0.27412608E-05_JPRB, 0.26131050E-05_JPRB, &
  & 0.24722355E-05_JPRB, 0.23385543E-05_JPRB, 0.22189006E-05_JPRB, 0.21054580E-05_JPRB, 0.20401361E-05_JPRB, 0.20273396E-05_JPRB, &
  & 0.20578511E-05_JPRB, 0.21012222E-05_JPRB, 0.21438350E-05_JPRB, 0.21981196E-05_JPRB, 0.22417847E-05_JPRB, 0.22459775E-05_JPRB, &
  & 0.22164283E-05_JPRB, 0.21841498E-05_JPRB, 0.21692647E-05_JPRB, 0.21838547E-05_JPRB, 0.22233814E-05_JPRB, 0.22866604E-05_JPRB, &
  & 0.23713836E-05_JPRB, 0.24614814E-05_JPRB, 0.25476614E-05_JPRB, 0.26193771E-05_JPRB, 0.26866171E-05_JPRB, 0.27509945E-05_JPRB, &
  & 0.28034265E-05_JPRB, 0.28475515E-05_JPRB, 0.28893772E-05_JPRB, 0.29248410E-05_JPRB, 0.29577838E-05_JPRB, 0.29768305E-05_JPRB, &
  & 0.29836544E-05_JPRB, 0.29781121E-05_JPRB, 0.29698431E-05_JPRB, 0.29673769E-05_JPRB, 0.29657504E-05_JPRB, 0.29497380E-05_JPRB, &
  & 0.29519573E-05_JPRB, 0.29703869E-05_JPRB, 0.29654932E-05_JPRB, 0.29457211E-05_JPRB  /)

RGHG7(:,30,10) = (/ &
  & 0.28224341E-06_JPRB, 0.29154163E-06_JPRB, 0.31813122E-06_JPRB, 0.40273333E-06_JPRB, 0.57874875E-06_JPRB, 0.84566554E-06_JPRB, &
  & 0.11527658E-05_JPRB, 0.14710411E-05_JPRB, 0.18025803E-05_JPRB, 0.21587993E-05_JPRB, 0.25012001E-05_JPRB, 0.27775714E-05_JPRB, &
  & 0.29569000E-05_JPRB, 0.30256454E-05_JPRB, 0.30185300E-05_JPRB, 0.29698351E-05_JPRB, 0.29051262E-05_JPRB, 0.28305200E-05_JPRB, &
  & 0.27451247E-05_JPRB, 0.26454325E-05_JPRB, 0.25401201E-05_JPRB, 0.24241062E-05_JPRB, 0.22946131E-05_JPRB, 0.21612931E-05_JPRB, &
  & 0.20224659E-05_JPRB, 0.19017702E-05_JPRB, 0.17997140E-05_JPRB, 0.17088926E-05_JPRB, 0.16575764E-05_JPRB, 0.16493617E-05_JPRB, &
  & 0.16760258E-05_JPRB, 0.17149630E-05_JPRB, 0.17500760E-05_JPRB, 0.17925434E-05_JPRB, 0.18272245E-05_JPRB, 0.18311903E-05_JPRB, &
  & 0.18104901E-05_JPRB, 0.17891888E-05_JPRB, 0.17835108E-05_JPRB, 0.18029666E-05_JPRB, 0.18485487E-05_JPRB, 0.19165928E-05_JPRB, &
  & 0.20030891E-05_JPRB, 0.20945134E-05_JPRB, 0.21828303E-05_JPRB, 0.22635402E-05_JPRB, 0.23443474E-05_JPRB, 0.24225481E-05_JPRB, &
  & 0.24904130E-05_JPRB, 0.25480680E-05_JPRB, 0.26000404E-05_JPRB, 0.26476509E-05_JPRB, 0.26911384E-05_JPRB, 0.27209511E-05_JPRB, &
  & 0.27405346E-05_JPRB, 0.27488806E-05_JPRB, 0.27551137E-05_JPRB, 0.27632521E-05_JPRB, 0.27703951E-05_JPRB, 0.27651113E-05_JPRB, &
  & 0.27679898E-05_JPRB, 0.27826986E-05_JPRB, 0.27731127E-05_JPRB, 0.27479413E-05_JPRB  /)

RGHG7(:,31,10) = (/ &
  & 0.15609189E-06_JPRB, 0.16142103E-06_JPRB, 0.17325379E-06_JPRB, 0.24048693E-06_JPRB, 0.39292533E-06_JPRB, 0.63850407E-06_JPRB, &
  & 0.92487695E-06_JPRB, 0.12177094E-05_JPRB, 0.15195993E-05_JPRB, 0.18480347E-05_JPRB, 0.21775445E-05_JPRB, 0.24438742E-05_JPRB, &
  & 0.26082764E-05_JPRB, 0.26575157E-05_JPRB, 0.26305210E-05_JPRB, 0.25634733E-05_JPRB, 0.24840754E-05_JPRB, 0.24001062E-05_JPRB, &
  & 0.23078923E-05_JPRB, 0.21985318E-05_JPRB, 0.20809390E-05_JPRB, 0.19545444E-05_JPRB, 0.18241015E-05_JPRB, 0.16853536E-05_JPRB, &
  & 0.15486976E-05_JPRB, 0.14417070E-05_JPRB, 0.13582072E-05_JPRB, 0.12912342E-05_JPRB, 0.12546748E-05_JPRB, 0.12512773E-05_JPRB, &
  & 0.12738705E-05_JPRB, 0.13081263E-05_JPRB, 0.13353351E-05_JPRB, 0.13653524E-05_JPRB, 0.13905688E-05_JPRB, 0.13942971E-05_JPRB, &
  & 0.13829259E-05_JPRB, 0.13731927E-05_JPRB, 0.13772168E-05_JPRB, 0.14017951E-05_JPRB, 0.14537549E-05_JPRB, 0.15268197E-05_JPRB, &
  & 0.16151818E-05_JPRB, 0.17079970E-05_JPRB, 0.17985529E-05_JPRB, 0.18887275E-05_JPRB, 0.19838166E-05_JPRB, 0.20765706E-05_JPRB, &
  & 0.21606850E-05_JPRB, 0.22325880E-05_JPRB, 0.22952463E-05_JPRB, 0.23556461E-05_JPRB, 0.24102267E-05_JPRB, 0.24513699E-05_JPRB, &
  & 0.24843872E-05_JPRB, 0.25073544E-05_JPRB, 0.25288532E-05_JPRB, 0.25481524E-05_JPRB, 0.25645227E-05_JPRB, 0.25705356E-05_JPRB, &
  & 0.25740926E-05_JPRB, 0.25848662E-05_JPRB, 0.25703274E-05_JPRB, 0.25394568E-05_JPRB  /)

RGHG7(:,32,10) = (/ &
  & 0.13018654E-06_JPRB, 0.13380616E-06_JPRB, 0.13970312E-06_JPRB, 0.18723457E-06_JPRB, 0.31150076E-06_JPRB, 0.52757145E-06_JPRB, &
  & 0.78511835E-06_JPRB, 0.10491896E-05_JPRB, 0.13174420E-05_JPRB, 0.16112997E-05_JPRB, 0.19130154E-05_JPRB, 0.21609741E-05_JPRB, &
  & 0.23109153E-05_JPRB, 0.23489820E-05_JPRB, 0.23117974E-05_JPRB, 0.22372686E-05_JPRB, 0.21531713E-05_JPRB, 0.20663216E-05_JPRB, &
  & 0.19710175E-05_JPRB, 0.18638628E-05_JPRB, 0.17470260E-05_JPRB, 0.16216661E-05_JPRB, 0.14955145E-05_JPRB, 0.13668292E-05_JPRB, &
  & 0.12455150E-05_JPRB, 0.11501467E-05_JPRB, 0.10778235E-05_JPRB, 0.10231731E-05_JPRB, 0.99264506E-06_JPRB, 0.98803352E-06_JPRB, &
  & 0.10056153E-05_JPRB, 0.10329897E-05_JPRB, 0.10559912E-05_JPRB, 0.10785943E-05_JPRB, 0.10971094E-05_JPRB, 0.11011800E-05_JPRB, &
  & 0.10959216E-05_JPRB, 0.10945154E-05_JPRB, 0.11036560E-05_JPRB, 0.11302627E-05_JPRB, 0.11805941E-05_JPRB, 0.12490812E-05_JPRB, &
  & 0.13313282E-05_JPRB, 0.14207474E-05_JPRB, 0.15115650E-05_JPRB, 0.16059285E-05_JPRB, 0.17066141E-05_JPRB, 0.18050766E-05_JPRB, &
  & 0.18974494E-05_JPRB, 0.19783995E-05_JPRB, 0.20499016E-05_JPRB, 0.21179307E-05_JPRB, 0.21784782E-05_JPRB, 0.22250548E-05_JPRB, &
  & 0.22639159E-05_JPRB, 0.22948520E-05_JPRB, 0.23224795E-05_JPRB, 0.23461146E-05_JPRB, 0.23657736E-05_JPRB, 0.23767382E-05_JPRB, &
  & 0.23804113E-05_JPRB, 0.23856697E-05_JPRB, 0.23720432E-05_JPRB, 0.23431082E-05_JPRB  /)

RGHG7(:,33,10) = (/ &
  & 0.11624348E-06_JPRB, 0.11837904E-06_JPRB, 0.11924932E-06_JPRB, 0.14600382E-06_JPRB, 0.24039715E-06_JPRB, 0.42474389E-06_JPRB, &
  & 0.65128495E-06_JPRB, 0.88503648E-06_JPRB, 0.11178149E-05_JPRB, 0.13748581E-05_JPRB, 0.16457595E-05_JPRB, 0.18735477E-05_JPRB, &
  & 0.20085205E-05_JPRB, 0.20360551E-05_JPRB, 0.19895352E-05_JPRB, 0.19086393E-05_JPRB, 0.18209516E-05_JPRB, 0.17319475E-05_JPRB, &
  & 0.16339146E-05_JPRB, 0.15305899E-05_JPRB, 0.14162265E-05_JPRB, 0.12934198E-05_JPRB, 0.11724066E-05_JPRB, 0.10561842E-05_JPRB, &
  & 0.95251935E-06_JPRB, 0.86895976E-06_JPRB, 0.80729624E-06_JPRB, 0.76395986E-06_JPRB, 0.73857025E-06_JPRB, 0.73191613E-06_JPRB, &
  & 0.74416800E-06_JPRB, 0.76410608E-06_JPRB, 0.78321396E-06_JPRB, 0.79876374E-06_JPRB, 0.81067230E-06_JPRB, 0.81517382E-06_JPRB, &
  & 0.81585171E-06_JPRB, 0.82267962E-06_JPRB, 0.83654369E-06_JPRB, 0.86485786E-06_JPRB, 0.91246054E-06_JPRB, 0.97494758E-06_JPRB, &
  & 0.10498061E-05_JPRB, 0.11350763E-05_JPRB, 0.12259099E-05_JPRB, 0.13239437E-05_JPRB, 0.14293208E-05_JPRB, 0.15325706E-05_JPRB, &
  & 0.16324915E-05_JPRB, 0.17221704E-05_JPRB, 0.18026248E-05_JPRB, 0.18779147E-05_JPRB, 0.19439995E-05_JPRB, 0.19954591E-05_JPRB, &
  & 0.20394108E-05_JPRB, 0.20777672E-05_JPRB, 0.21105809E-05_JPRB, 0.21378384E-05_JPRB, 0.21601464E-05_JPRB, 0.21754355E-05_JPRB, &
  & 0.21791565E-05_JPRB, 0.21784786E-05_JPRB, 0.21665597E-05_JPRB, 0.21406247E-05_JPRB  /)

RGHG7(:,34,10) = (/ &
  & 0.10984370E-06_JPRB, 0.11096635E-06_JPRB, 0.11052817E-06_JPRB, 0.12684898E-06_JPRB, 0.19789414E-06_JPRB, 0.35093626E-06_JPRB, &
  & 0.54973597E-06_JPRB, 0.75771359E-06_JPRB, 0.96071542E-06_JPRB, 0.11851339E-05_JPRB, 0.14251008E-05_JPRB, 0.16310032E-05_JPRB, &
  & 0.17541808E-05_JPRB, 0.17762874E-05_JPRB, 0.17262176E-05_JPRB, 0.16453347E-05_JPRB, 0.15597086E-05_JPRB, 0.14716878E-05_JPRB, &
  & 0.13744662E-05_JPRB, 0.12741555E-05_JPRB, 0.11636035E-05_JPRB, 0.10466524E-05_JPRB, 0.93350838E-06_JPRB, 0.82896766E-06_JPRB, &
  & 0.73942205E-06_JPRB, 0.66757608E-06_JPRB, 0.61623486E-06_JPRB, 0.58105594E-06_JPRB, 0.55964444E-06_JPRB, 0.55327103E-06_JPRB, &
  & 0.56158671E-06_JPRB, 0.57565755E-06_JPRB, 0.59006803E-06_JPRB, 0.60091568E-06_JPRB, 0.60885693E-06_JPRB, 0.61433776E-06_JPRB, &
  & 0.61851002E-06_JPRB, 0.62835797E-06_JPRB, 0.64286272E-06_JPRB, 0.66903603E-06_JPRB, 0.71189681E-06_JPRB, 0.76797635E-06_JPRB, &
  & 0.83621498E-06_JPRB, 0.91657790E-06_JPRB, 0.10055913E-05_JPRB, 0.11041937E-05_JPRB, 0.12096245E-05_JPRB, 0.13136227E-05_JPRB, &
  & 0.14167290E-05_JPRB, 0.15105727E-05_JPRB, 0.15961212E-05_JPRB, 0.16752792E-05_JPRB, 0.17446103E-05_JPRB, 0.17996364E-05_JPRB, &
  & 0.18462340E-05_JPRB, 0.18871089E-05_JPRB, 0.19212938E-05_JPRB, 0.19492578E-05_JPRB, 0.19738216E-05_JPRB, 0.19906850E-05_JPRB, &
  & 0.19941433E-05_JPRB, 0.19912488E-05_JPRB, 0.19795621E-05_JPRB, 0.19576619E-05_JPRB  /)

RGHG7(:,35,10) = (/ &
  & 0.10713464E-06_JPRB, 0.10745766E-06_JPRB, 0.10758218E-06_JPRB, 0.11848334E-06_JPRB, 0.16887160E-06_JPRB, 0.28994366E-06_JPRB, &
  & 0.46189682E-06_JPRB, 0.64570810E-06_JPRB, 0.82101933E-06_JPRB, 0.10140453E-05_JPRB, 0.12221457E-05_JPRB, 0.14046666E-05_JPRB, &
  & 0.15173455E-05_JPRB, 0.15364905E-05_JPRB, 0.14857396E-05_JPRB, 0.14081440E-05_JPRB, 0.13275377E-05_JPRB, 0.12421379E-05_JPRB, &
  & 0.11475669E-05_JPRB, 0.10499364E-05_JPRB, 0.94398971E-06_JPRB, 0.83475341E-06_JPRB, 0.73110122E-06_JPRB, 0.63816982E-06_JPRB, &
  & 0.56132932E-06_JPRB, 0.50147766E-06_JPRB, 0.46057595E-06_JPRB, 0.43216420E-06_JPRB, 0.41424734E-06_JPRB, 0.40935471E-06_JPRB, &
  & 0.41433864E-06_JPRB, 0.42318232E-06_JPRB, 0.43235083E-06_JPRB, 0.43957057E-06_JPRB, 0.44478718E-06_JPRB, 0.45155629E-06_JPRB, &
  & 0.45806818E-06_JPRB, 0.46834557E-06_JPRB, 0.48141395E-06_JPRB, 0.50341147E-06_JPRB, 0.54036393E-06_JPRB, 0.58964669E-06_JPRB, &
  & 0.65147353E-06_JPRB, 0.72640199E-06_JPRB, 0.81260195E-06_JPRB, 0.91019741E-06_JPRB, 0.10133033E-05_JPRB, 0.11159984E-05_JPRB, &
  & 0.12201413E-05_JPRB, 0.13159249E-05_JPRB, 0.14047311E-05_JPRB, 0.14861250E-05_JPRB, 0.15576180E-05_JPRB, 0.16156353E-05_JPRB, &
  & 0.16636989E-05_JPRB, 0.17046478E-05_JPRB, 0.17382849E-05_JPRB, 0.17654788E-05_JPRB, 0.17921602E-05_JPRB, 0.18092309E-05_JPRB, &
  & 0.18122597E-05_JPRB, 0.18089951E-05_JPRB, 0.17967901E-05_JPRB, 0.17795691E-05_JPRB  /)

RGHG7(:,36,10) = (/ &
  & 0.10357145E-06_JPRB, 0.10387706E-06_JPRB, 0.10448979E-06_JPRB, 0.11149378E-06_JPRB, 0.14486474E-06_JPRB, 0.23683671E-06_JPRB, &
  & 0.38260663E-06_JPRB, 0.54386327E-06_JPRB, 0.69429638E-06_JPRB, 0.85798471E-06_JPRB, 0.10356157E-05_JPRB, 0.11955973E-05_JPRB, &
  & 0.12979901E-05_JPRB, 0.13152660E-05_JPRB, 0.12659485E-05_JPRB, 0.11930682E-05_JPRB, 0.11178314E-05_JPRB, 0.10357135E-05_JPRB, &
  & 0.94452580E-06_JPRB, 0.85002459E-06_JPRB, 0.74992745E-06_JPRB, 0.64895498E-06_JPRB, 0.55527204E-06_JPRB, 0.47380424E-06_JPRB, &
  & 0.40900192E-06_JPRB, 0.35995619E-06_JPRB, 0.32783872E-06_JPRB, 0.30526216E-06_JPRB, 0.29045174E-06_JPRB, 0.28620382E-06_JPRB, &
  & 0.28819268E-06_JPRB, 0.29271727E-06_JPRB, 0.29749694E-06_JPRB, 0.30161298E-06_JPRB, 0.30462931E-06_JPRB, 0.31188958E-06_JPRB, &
  & 0.31947377E-06_JPRB, 0.32948045E-06_JPRB, 0.34108936E-06_JPRB, 0.35975090E-06_JPRB, 0.39152848E-06_JPRB, 0.43483232E-06_JPRB, &
  & 0.49064881E-06_JPRB, 0.55974006E-06_JPRB, 0.64199257E-06_JPRB, 0.73720199E-06_JPRB, 0.83638990E-06_JPRB, 0.93578211E-06_JPRB, &
  & 0.10386973E-05_JPRB, 0.11348251E-05_JPRB, 0.12246401E-05_JPRB, 0.13067831E-05_JPRB, 0.13793915E-05_JPRB, 0.14396417E-05_JPRB, &
  & 0.14882167E-05_JPRB, 0.15283677E-05_JPRB, 0.15610616E-05_JPRB, 0.15873155E-05_JPRB, 0.16152416E-05_JPRB, 0.16325609E-05_JPRB, &
  & 0.16357294E-05_JPRB, 0.16323120E-05_JPRB, 0.16197603E-05_JPRB, 0.16063088E-05_JPRB  /)

RGHG7(:,37,10) = (/ &
  & 0.98271667E-07_JPRB, 0.10035434E-06_JPRB, 0.10125413E-06_JPRB, 0.10809409E-06_JPRB, 0.13385103E-06_JPRB, 0.20511342E-06_JPRB, &
  & 0.32784991E-06_JPRB, 0.47165036E-06_JPRB, 0.60520140E-06_JPRB, 0.74608869E-06_JPRB, 0.89834874E-06_JPRB, 0.10391244E-05_JPRB, &
  & 0.11323585E-05_JPRB, 0.11503863E-05_JPRB, 0.11072611E-05_JPRB, 0.10420769E-05_JPRB, 0.97267702E-06_JPRB, 0.89515216E-06_JPRB, &
  & 0.80881717E-06_JPRB, 0.71828017E-06_JPRB, 0.62652154E-06_JPRB, 0.53455740E-06_JPRB, 0.45131810E-06_JPRB, 0.38026661E-06_JPRB, &
  & 0.32522444E-06_JPRB, 0.28358769E-06_JPRB, 0.25591287E-06_JPRB, 0.23667171E-06_JPRB, 0.22388441E-06_JPRB, 0.21832419E-06_JPRB, &
  & 0.21827627E-06_JPRB, 0.22083243E-06_JPRB, 0.22345229E-06_JPRB, 0.22585962E-06_JPRB, 0.22801476E-06_JPRB, 0.23390806E-06_JPRB, &
  & 0.23959216E-06_JPRB, 0.24773976E-06_JPRB, 0.25792703E-06_JPRB, 0.27538563E-06_JPRB, 0.30399185E-06_JPRB, 0.34356385E-06_JPRB, &
  & 0.39466431E-06_JPRB, 0.45735814E-06_JPRB, 0.53330892E-06_JPRB, 0.62311881E-06_JPRB, 0.71497977E-06_JPRB, 0.80668961E-06_JPRB, &
  & 0.90326206E-06_JPRB, 0.99605442E-06_JPRB, 0.10816591E-05_JPRB, 0.11610956E-05_JPRB, 0.12323507E-05_JPRB, 0.12929563E-05_JPRB, &
  & 0.13398226E-05_JPRB, 0.13772260E-05_JPRB, 0.14081291E-05_JPRB, 0.14331118E-05_JPRB, 0.14602040E-05_JPRB, 0.14778514E-05_JPRB, &
  & 0.14824552E-05_JPRB, 0.14793932E-05_JPRB, 0.14669099E-05_JPRB, 0.14549074E-05_JPRB  /)

RGHG7(:,38,10) = (/ &
  & 0.92391088E-07_JPRB, 0.96445568E-07_JPRB, 0.97663883E-07_JPRB, 0.10432183E-06_JPRB, 0.12163033E-06_JPRB, 0.16991361E-06_JPRB, &
  & 0.26709247E-06_JPRB, 0.39152372E-06_JPRB, 0.50634261E-06_JPRB, 0.62193011E-06_JPRB, 0.74603885E-06_JPRB, 0.86550387E-06_JPRB, &
  & 0.94857554E-06_JPRB, 0.96743754E-06_JPRB, 0.93118334E-06_JPRB, 0.87453860E-06_JPRB, 0.81161534E-06_JPRB, 0.73918684E-06_JPRB, &
  & 0.65823640E-06_JPRB, 0.57209805E-06_JPRB, 0.48959174E-06_JPRB, 0.40762313E-06_JPRB, 0.33597198E-06_JPRB, 0.27647830E-06_JPRB, &
  & 0.23226590E-06_JPRB, 0.19885006E-06_JPRB, 0.17610475E-06_JPRB, 0.16056452E-06_JPRB, 0.15002204E-06_JPRB, 0.14300573E-06_JPRB, &
  & 0.14069781E-06_JPRB, 0.14106981E-06_JPRB, 0.14129317E-06_JPRB, 0.14180453E-06_JPRB, 0.14300411E-06_JPRB, 0.14738063E-06_JPRB, &
  & 0.15095642E-06_JPRB, 0.15704121E-06_JPRB, 0.16565103E-06_JPRB, 0.18177488E-06_JPRB, 0.20686217E-06_JPRB, 0.24229339E-06_JPRB, &
  & 0.28816097E-06_JPRB, 0.34375630E-06_JPRB, 0.41271477E-06_JPRB, 0.49653340E-06_JPRB, 0.58026445E-06_JPRB, 0.66345003E-06_JPRB, &
  & 0.75298465E-06_JPRB, 0.84207608E-06_JPRB, 0.92300914E-06_JPRB, 0.99944236E-06_JPRB, 0.10691959E-05_JPRB, 0.11301958E-05_JPRB, &
  & 0.11751662E-05_JPRB, 0.12095208E-05_JPRB, 0.12384370E-05_JPRB, 0.12620091E-05_JPRB, 0.12881760E-05_JPRB, 0.13061875E-05_JPRB, &
  & 0.13123839E-05_JPRB, 0.13097163E-05_JPRB, 0.12973088E-05_JPRB, 0.12869141E-05_JPRB  /)

RGHG7(:,39,10) = (/ &
  & 0.96322674E-07_JPRB, 0.10208027E-06_JPRB, 0.10373575E-06_JPRB, 0.10950412E-06_JPRB, 0.12257160E-06_JPRB, 0.15997586E-06_JPRB, &
  & 0.23941455E-06_JPRB, 0.34807373E-06_JPRB, 0.45083134E-06_JPRB, 0.55061938E-06_JPRB, 0.65700881E-06_JPRB, 0.76127152E-06_JPRB, &
  & 0.83613415E-06_JPRB, 0.85656007E-06_JPRB, 0.82732130E-06_JPRB, 0.77707244E-06_JPRB, 0.71950174E-06_JPRB, 0.65146054E-06_JPRB, &
  & 0.57601815E-06_JPRB, 0.49733458E-06_JPRB, 0.42133318E-06_JPRB, 0.34710593E-06_JPRB, 0.28321642E-06_JPRB, 0.23154068E-06_JPRB, &
  & 0.19313162E-06_JPRB, 0.16427263E-06_JPRB, 0.14455779E-06_JPRB, 0.13092133E-06_JPRB, 0.12156989E-06_JPRB, 0.11510636E-06_JPRB, &
  & 0.11257649E-06_JPRB, 0.11243580E-06_JPRB, 0.11220230E-06_JPRB, 0.11219260E-06_JPRB, 0.11271342E-06_JPRB, 0.11583525E-06_JPRB, &
  & 0.11860216E-06_JPRB, 0.12386182E-06_JPRB, 0.13206045E-06_JPRB, 0.14641730E-06_JPRB, 0.16827033E-06_JPRB, 0.19933843E-06_JPRB, &
  & 0.23969470E-06_JPRB, 0.28941955E-06_JPRB, 0.35183867E-06_JPRB, 0.42774585E-06_JPRB, 0.50388199E-06_JPRB, 0.57915167E-06_JPRB, &
  & 0.66090316E-06_JPRB, 0.74359612E-06_JPRB, 0.81853015E-06_JPRB, 0.88927210E-06_JPRB, 0.95413446E-06_JPRB, 0.10125426E-05_JPRB, &
  & 0.10548154E-05_JPRB, 0.10863097E-05_JPRB, 0.11128500E-05_JPRB, 0.11356604E-05_JPRB, 0.11604486E-05_JPRB, 0.11783901E-05_JPRB, &
  & 0.11851577E-05_JPRB, 0.11836074E-05_JPRB, 0.11742639E-05_JPRB, 0.11668914E-05_JPRB  /)

RGHG7(:,40,10) = (/ &
  & 0.10254201E-06_JPRB, 0.11025439E-06_JPRB, 0.11244234E-06_JPRB, 0.11705096E-06_JPRB, 0.12582956E-06_JPRB, 0.15244600E-06_JPRB, &
  & 0.21234407E-06_JPRB, 0.30308188E-06_JPRB, 0.39277594E-06_JPRB, 0.47557626E-06_JPRB, 0.56287729E-06_JPRB, 0.65029815E-06_JPRB, &
  & 0.71584634E-06_JPRB, 0.73822706E-06_JPRB, 0.71724509E-06_JPRB, 0.67415165E-06_JPRB, 0.62267874E-06_JPRB, 0.55967039E-06_JPRB, &
  & 0.49071237E-06_JPRB, 0.42127759E-06_JPRB, 0.35246078E-06_JPRB, 0.28694986E-06_JPRB, 0.23154328E-06_JPRB, 0.18843069E-06_JPRB, &
  & 0.15601000E-06_JPRB, 0.13189940E-06_JPRB, 0.11543040E-06_JPRB, 0.10373414E-06_JPRB, 0.95608095E-07_JPRB, 0.90121959E-07_JPRB, &
  & 0.87665026E-07_JPRB, 0.87196106E-07_JPRB, 0.86743795E-07_JPRB, 0.86347508E-07_JPRB, 0.86117051E-07_JPRB, 0.87809249E-07_JPRB, &
  & 0.89839463E-07_JPRB, 0.94333253E-07_JPRB, 0.10224013E-06_JPRB, 0.11445254E-06_JPRB, 0.13255646E-06_JPRB, 0.15846770E-06_JPRB, &
  & 0.19231042E-06_JPRB, 0.23534667E-06_JPRB, 0.29016545E-06_JPRB, 0.35647373E-06_JPRB, 0.42378413E-06_JPRB, 0.48986337E-06_JPRB, &
  & 0.56235877E-06_JPRB, 0.63710127E-06_JPRB, 0.70477777E-06_JPRB, 0.76840078E-06_JPRB, 0.82696841E-06_JPRB, 0.88184622E-06_JPRB, &
  & 0.92082220E-06_JPRB, 0.94899041E-06_JPRB, 0.97267875E-06_JPRB, 0.99470136E-06_JPRB, 0.10177974E-05_JPRB, 0.10355857E-05_JPRB, &
  & 0.10428566E-05_JPRB, 0.10427360E-05_JPRB, 0.10374770E-05_JPRB, 0.10338829E-05_JPRB  /)

RGHG7(:,41,10) = (/ &
  & 0.11014604E-06_JPRB, 0.12024844E-06_JPRB, 0.12308740E-06_JPRB, 0.12627807E-06_JPRB, 0.12981290E-06_JPRB, 0.14323966E-06_JPRB, &
  & 0.17924648E-06_JPRB, 0.24807284E-06_JPRB, 0.32179481E-06_JPRB, 0.38382517E-06_JPRB, 0.44778787E-06_JPRB, 0.51461714E-06_JPRB, &
  & 0.56877708E-06_JPRB, 0.59354781E-06_JPRB, 0.58266099E-06_JPRB, 0.54831607E-06_JPRB, 0.50429858E-06_JPRB, 0.44744364E-06_JPRB, &
  & 0.38641370E-06_JPRB, 0.32828690E-06_JPRB, 0.26825430E-06_JPRB, 0.21340035E-06_JPRB, 0.16836537E-06_JPRB, 0.13572248E-06_JPRB, &
  & 0.11062345E-06_JPRB, 0.92318451E-07_JPRB, 0.79817943E-07_JPRB, 0.70493862E-07_JPRB, 0.63866038E-07_JPRB, 0.59574910E-07_JPRB, &
  & 0.57207157E-07_JPRB, 0.56336928E-07_JPRB, 0.55617078E-07_JPRB, 0.54748139E-07_JPRB, 0.53599130E-07_JPRB, 0.53543406E-07_JPRB, &
  & 0.54672905E-07_JPRB, 0.58230308E-07_JPRB, 0.65780468E-07_JPRB, 0.75370996E-07_JPRB, 0.88891072E-07_JPRB, 0.10849730E-06_JPRB, &
  & 0.13437628E-06_JPRB, 0.16923475E-06_JPRB, 0.21476101E-06_JPRB, 0.26933323E-06_JPRB, 0.32585288E-06_JPRB, 0.38069548E-06_JPRB, &
  & 0.44187398E-06_JPRB, 0.50689589E-06_JPRB, 0.56569901E-06_JPRB, 0.62061807E-06_JPRB, 0.67148950E-06_JPRB, 0.72205101E-06_JPRB, &
  & 0.75699606E-06_JPRB, 0.78109768E-06_JPRB, 0.80129909E-06_JPRB, 0.82235856E-06_JPRB, 0.84338564E-06_JPRB, 0.86098665E-06_JPRB, &
  & 0.86887286E-06_JPRB, 0.87050019E-06_JPRB, 0.87023531E-06_JPRB, 0.87126069E-06_JPRB  /)

RGHG7(:,42,10) = (/ &
  & 0.13268282E-06_JPRB, 0.14163916E-06_JPRB, 0.14477861E-06_JPRB, 0.14660341E-06_JPRB, 0.14919733E-06_JPRB, 0.16054104E-06_JPRB, &
  & 0.19243321E-06_JPRB, 0.25123649E-06_JPRB, 0.31588581E-06_JPRB, 0.37376656E-06_JPRB, 0.43283329E-06_JPRB, 0.49214109E-06_JPRB, &
  & 0.54145966E-06_JPRB, 0.56556641E-06_JPRB, 0.55723813E-06_JPRB, 0.52613483E-06_JPRB, 0.48377033E-06_JPRB, 0.43207468E-06_JPRB, &
  & 0.37726674E-06_JPRB, 0.32265969E-06_JPRB, 0.26599651E-06_JPRB, 0.21355192E-06_JPRB, 0.16979781E-06_JPRB, 0.13726147E-06_JPRB, &
  & 0.11286612E-06_JPRB, 0.95227519E-07_JPRB, 0.82803641E-07_JPRB, 0.73874910E-07_JPRB, 0.67697731E-07_JPRB, 0.63778442E-07_JPRB, &
  & 0.61850723E-07_JPRB, 0.61285392E-07_JPRB, 0.60662749E-07_JPRB, 0.59640623E-07_JPRB, 0.58423308E-07_JPRB, 0.58950610E-07_JPRB, &
  & 0.60822926E-07_JPRB, 0.64484338E-07_JPRB, 0.71392784E-07_JPRB, 0.80512854E-07_JPRB, 0.93504006E-07_JPRB, 0.11161872E-06_JPRB, &
  & 0.13541910E-06_JPRB, 0.16675723E-06_JPRB, 0.20814135E-06_JPRB, 0.25804582E-06_JPRB, 0.30976057E-06_JPRB, 0.36138724E-06_JPRB, &
  & 0.41736292E-06_JPRB, 0.47590878E-06_JPRB, 0.52960083E-06_JPRB, 0.57941572E-06_JPRB, 0.62552741E-06_JPRB, 0.66909936E-06_JPRB, &
  & 0.70124937E-06_JPRB, 0.72331516E-06_JPRB, 0.74183416E-06_JPRB, 0.76144832E-06_JPRB, 0.78053907E-06_JPRB, 0.79697498E-06_JPRB, &
  & 0.80481212E-06_JPRB, 0.80788115E-06_JPRB, 0.80987047E-06_JPRB, 0.81481142E-06_JPRB  /)

RGHG7(:,43,10) = (/ &
  & 0.15651607E-06_JPRB, 0.16545481E-06_JPRB, 0.16914846E-06_JPRB, 0.16911713E-06_JPRB, 0.16859696E-06_JPRB, 0.17236656E-06_JPRB, &
  & 0.19022772E-06_JPRB, 0.23046081E-06_JPRB, 0.27996193E-06_JPRB, 0.32512241E-06_JPRB, 0.36968310E-06_JPRB, 0.41327090E-06_JPRB, &
  & 0.45327358E-06_JPRB, 0.47780258E-06_JPRB, 0.47615112E-06_JPRB, 0.45176863E-06_JPRB, 0.41411925E-06_JPRB, 0.36977778E-06_JPRB, &
  & 0.32405701E-06_JPRB, 0.27752548E-06_JPRB, 0.22771506E-06_JPRB, 0.18205286E-06_JPRB, 0.14392874E-06_JPRB, 0.11599317E-06_JPRB, &
  & 0.95389269E-07_JPRB, 0.80855962E-07_JPRB, 0.70209051E-07_JPRB, 0.62661428E-07_JPRB, 0.57539873E-07_JPRB, 0.54473881E-07_JPRB, &
  & 0.52986005E-07_JPRB, 0.52526236E-07_JPRB, 0.51877203E-07_JPRB, 0.50511999E-07_JPRB, 0.48837247E-07_JPRB, 0.49144628E-07_JPRB, &
  & 0.51307240E-07_JPRB, 0.54660762E-07_JPRB, 0.60830271E-07_JPRB, 0.68393296E-07_JPRB, 0.78930120E-07_JPRB, 0.92971884E-07_JPRB, &
  & 0.11145016E-06_JPRB, 0.13605868E-06_JPRB, 0.16966637E-06_JPRB, 0.21026375E-06_JPRB, 0.25295292E-06_JPRB, 0.29681195E-06_JPRB, &
  & 0.34317266E-06_JPRB, 0.39162851E-06_JPRB, 0.43684038E-06_JPRB, 0.47825426E-06_JPRB, 0.51671267E-06_JPRB, 0.55205075E-06_JPRB, &
  & 0.57991669E-06_JPRB, 0.59837576E-06_JPRB, 0.61385984E-06_JPRB, 0.63174103E-06_JPRB, 0.64817512E-06_JPRB, 0.66346743E-06_JPRB, &
  & 0.67152449E-06_JPRB, 0.67666079E-06_JPRB, 0.68285501E-06_JPRB, 0.69335558E-06_JPRB  /)

RGHG7(:,44,10) = (/ &
  & 0.17492972E-06_JPRB, 0.18174109E-06_JPRB, 0.18448665E-06_JPRB, 0.18376711E-06_JPRB, 0.18297111E-06_JPRB, 0.18475847E-06_JPRB, &
  & 0.19784916E-06_JPRB, 0.22990916E-06_JPRB, 0.27076655E-06_JPRB, 0.30975701E-06_JPRB, 0.34847845E-06_JPRB, 0.38597144E-06_JPRB, &
  & 0.41952486E-06_JPRB, 0.44107823E-06_JPRB, 0.44056137E-06_JPRB, 0.41901738E-06_JPRB, 0.38545203E-06_JPRB, 0.34559134E-06_JPRB, &
  & 0.30345811E-06_JPRB, 0.25998606E-06_JPRB, 0.21377242E-06_JPRB, 0.17105934E-06_JPRB, 0.13560680E-06_JPRB, 0.10919911E-06_JPRB, &
  & 0.89818866E-07_JPRB, 0.76229196E-07_JPRB, 0.66483875E-07_JPRB, 0.59605182E-07_JPRB, 0.54984075E-07_JPRB, 0.52297005E-07_JPRB, &
  & 0.50957343E-07_JPRB, 0.50432817E-07_JPRB, 0.49654102E-07_JPRB, 0.48198146E-07_JPRB, 0.46464276E-07_JPRB, 0.46902147E-07_JPRB, &
  & 0.49350811E-07_JPRB, 0.52689242E-07_JPRB, 0.58406517E-07_JPRB, 0.65642187E-07_JPRB, 0.75113886E-07_JPRB, 0.87644970E-07_JPRB, &
  & 0.10406918E-06_JPRB, 0.12556360E-06_JPRB, 0.15515793E-06_JPRB, 0.19078651E-06_JPRB, 0.22938118E-06_JPRB, 0.26956687E-06_JPRB, &
  & 0.31149686E-06_JPRB, 0.35545346E-06_JPRB, 0.39629056E-06_JPRB, 0.43362777E-06_JPRB, 0.46802884E-06_JPRB, 0.49923762E-06_JPRB, &
  & 0.52469182E-06_JPRB, 0.54136494E-06_JPRB, 0.55540881E-06_JPRB, 0.57060276E-06_JPRB, 0.58506591E-06_JPRB, 0.59901126E-06_JPRB, &
  & 0.60689615E-06_JPRB, 0.61185232E-06_JPRB, 0.61714044E-06_JPRB, 0.62845250E-06_JPRB  /)

RGHG7(:,45,10) = (/ &
  & 0.19890300E-06_JPRB, 0.20329027E-06_JPRB, 0.20502652E-06_JPRB, 0.20328903E-06_JPRB, 0.20178565E-06_JPRB, 0.20035957E-06_JPRB, &
  & 0.20624701E-06_JPRB, 0.22665671E-06_JPRB, 0.25576027E-06_JPRB, 0.28611976E-06_JPRB, 0.31636120E-06_JPRB, 0.34492992E-06_JPRB, &
  & 0.36996451E-06_JPRB, 0.38818367E-06_JPRB, 0.38980192E-06_JPRB, 0.37233833E-06_JPRB, 0.34401799E-06_JPRB, 0.31018734E-06_JPRB, &
  & 0.27328617E-06_JPRB, 0.23431724E-06_JPRB, 0.19306393E-06_JPRB, 0.15456497E-06_JPRB, 0.12286502E-06_JPRB, 0.98777908E-07_JPRB, &
  & 0.81269646E-07_JPRB, 0.69146508E-07_JPRB, 0.60652052E-07_JPRB, 0.54709351E-07_JPRB, 0.50791317E-07_JPRB, 0.48643413E-07_JPRB, &
  & 0.47528044E-07_JPRB, 0.46943132E-07_JPRB, 0.46013450E-07_JPRB, 0.44410841E-07_JPRB, 0.42551884E-07_JPRB, 0.43110529E-07_JPRB, &
  & 0.45921513E-07_JPRB, 0.49203870E-07_JPRB, 0.54312966E-07_JPRB, 0.60979277E-07_JPRB, 0.68928371E-07_JPRB, 0.79225150E-07_JPRB, &
  & 0.92638659E-07_JPRB, 0.10973780E-06_JPRB, 0.13378087E-06_JPRB, 0.16257714E-06_JPRB, 0.19537038E-06_JPRB, 0.23039302E-06_JPRB, &
  & 0.26606436E-06_JPRB, 0.30362430E-06_JPRB, 0.33840979E-06_JPRB, 0.37004479E-06_JPRB, 0.39886010E-06_JPRB, 0.42432783E-06_JPRB, &
  & 0.44649528E-06_JPRB, 0.46067961E-06_JPRB, 0.47270053E-06_JPRB, 0.48461635E-06_JPRB, 0.49650013E-06_JPRB, 0.50876759E-06_JPRB, &
  & 0.51648427E-06_JPRB, 0.52149650E-06_JPRB, 0.52628428E-06_JPRB, 0.53922247E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART20',0,ZHOOK_HANDLE)



RGHG7(:,46,10) = (/ &
  & 0.20960150E-06_JPRB, 0.21133413E-06_JPRB, 0.21160735E-06_JPRB, 0.20963642E-06_JPRB, 0.20839505E-06_JPRB, 0.20669872E-06_JPRB, &
  & 0.20978865E-06_JPRB, 0.22384995E-06_JPRB, 0.24590376E-06_JPRB, 0.27085566E-06_JPRB, 0.29662128E-06_JPRB, 0.32009850E-06_JPRB, &
  & 0.33982686E-06_JPRB, 0.35416002E-06_JPRB, 0.35505707E-06_JPRB, 0.33972155E-06_JPRB, 0.31507476E-06_JPRB, 0.28479603E-06_JPRB, &
  & 0.25116673E-06_JPRB, 0.21560577E-06_JPRB, 0.17837800E-06_JPRB, 0.14323542E-06_JPRB, 0.11442792E-06_JPRB, 0.92048557E-07_JPRB, &
  & 0.75836358E-07_JPRB, 0.64786466E-07_JPRB, 0.57251960E-07_JPRB, 0.52050156E-07_JPRB, 0.48565180E-07_JPRB, 0.46750883E-07_JPRB, &
  & 0.45806731E-07_JPRB, 0.45172089E-07_JPRB, 0.44251874E-07_JPRB, 0.42546033E-07_JPRB, 0.40678280E-07_JPRB, 0.41383602E-07_JPRB, &
  & 0.44275751E-07_JPRB, 0.47464937E-07_JPRB, 0.52179995E-07_JPRB, 0.58391821E-07_JPRB, 0.65385412E-07_JPRB, 0.74245151E-07_JPRB, &
  & 0.85661395E-07_JPRB, 0.10004510E-06_JPRB, 0.12027238E-06_JPRB, 0.14462533E-06_JPRB, 0.17287689E-06_JPRB, 0.20376573E-06_JPRB, &
  & 0.23571960E-06_JPRB, 0.26968989E-06_JPRB, 0.30116586E-06_JPRB, 0.32985392E-06_JPRB, 0.35584946E-06_JPRB, 0.37826071E-06_JPRB, &
  & 0.39859526E-06_JPRB, 0.41170838E-06_JPRB, 0.42255603E-06_JPRB, 0.43266854E-06_JPRB, 0.44329476E-06_JPRB, 0.45381912E-06_JPRB, &
  & 0.46062983E-06_JPRB, 0.46485381E-06_JPRB, 0.46903032E-06_JPRB, 0.48073868E-06_JPRB  /)

RGHG7(:,47,10) = (/ &
  & 0.21949618E-06_JPRB, 0.21806759E-06_JPRB, 0.21653317E-06_JPRB, 0.21444548E-06_JPRB, 0.21370576E-06_JPRB, 0.21228187E-06_JPRB, &
  & 0.21297170E-06_JPRB, 0.22064572E-06_JPRB, 0.23536950E-06_JPRB, 0.25462171E-06_JPRB, 0.27593742E-06_JPRB, 0.29420795E-06_JPRB, &
  & 0.30835337E-06_JPRB, 0.31801607E-06_JPRB, 0.31749469E-06_JPRB, 0.30426520E-06_JPRB, 0.28361425E-06_JPRB, 0.25700702E-06_JPRB, &
  & 0.22682435E-06_JPRB, 0.19504300E-06_JPRB, 0.16235162E-06_JPRB, 0.13097569E-06_JPRB, 0.10538993E-06_JPRB, 0.84891731E-07_JPRB, &
  & 0.70084994E-07_JPRB, 0.60215690E-07_JPRB, 0.53749335E-07_JPRB, 0.49377835E-07_JPRB, 0.46346932E-07_JPRB, 0.44882919E-07_JPRB, &
  & 0.44129045E-07_JPRB, 0.43438185E-07_JPRB, 0.42561214E-07_JPRB, 0.40742936E-07_JPRB, 0.38888157E-07_JPRB, 0.39770784E-07_JPRB, &
  & 0.42701853E-07_JPRB, 0.45774277E-07_JPRB, 0.50069859E-07_JPRB, 0.55771394E-07_JPRB, 0.61757376E-07_JPRB, 0.69090568E-07_JPRB, &
  & 0.78366184E-07_JPRB, 0.89900044E-07_JPRB, 0.10599743E-06_JPRB, 0.12561505E-06_JPRB, 0.14878965E-06_JPRB, 0.17503398E-06_JPRB, &
  & 0.20313472E-06_JPRB, 0.23345513E-06_JPRB, 0.26159691E-06_JPRB, 0.28737890E-06_JPRB, 0.31061974E-06_JPRB, 0.32998222E-06_JPRB, &
  & 0.34845723E-06_JPRB, 0.36059734E-06_JPRB, 0.37023845E-06_JPRB, 0.37853035E-06_JPRB, 0.38794571E-06_JPRB, 0.39641161E-06_JPRB, &
  & 0.40201146E-06_JPRB, 0.40514134E-06_JPRB, 0.40857837E-06_JPRB, 0.41827150E-06_JPRB  /)

RGHG7(:,48,10) = (/ &
  & 0.21890109E-06_JPRB, 0.21453790E-06_JPRB, 0.21048558E-06_JPRB, 0.20813376E-06_JPRB, 0.20830436E-06_JPRB, 0.20760617E-06_JPRB, &
  & 0.20793982E-06_JPRB, 0.21268642E-06_JPRB, 0.22268118E-06_JPRB, 0.23790335E-06_JPRB, 0.25616935E-06_JPRB, 0.27081047E-06_JPRB, &
  & 0.28101809E-06_JPRB, 0.28685797E-06_JPRB, 0.28465792E-06_JPRB, 0.27233691E-06_JPRB, 0.25438047E-06_JPRB, 0.23088762E-06_JPRB, &
  & 0.20417439E-06_JPRB, 0.17628333E-06_JPRB, 0.14792697E-06_JPRB, 0.12030257E-06_JPRB, 0.97565334E-07_JPRB, 0.78908887E-07_JPRB, &
  & 0.65417608E-07_JPRB, 0.56590893E-07_JPRB, 0.51013644E-07_JPRB, 0.47422244E-07_JPRB, 0.44807636E-07_JPRB, 0.43583382E-07_JPRB, &
  & 0.42954502E-07_JPRB, 0.42289899E-07_JPRB, 0.41415571E-07_JPRB, 0.39540416E-07_JPRB, 0.37822955E-07_JPRB, 0.38798387E-07_JPRB, &
  & 0.41669751E-07_JPRB, 0.44624372E-07_JPRB, 0.48556348E-07_JPRB, 0.53742826E-07_JPRB, 0.58941143E-07_JPRB, 0.65082748E-07_JPRB, &
  & 0.72767842E-07_JPRB, 0.82345641E-07_JPRB, 0.95458043E-07_JPRB, 0.11142434E-06_JPRB, 0.13020604E-06_JPRB, 0.15214356E-06_JPRB, &
  & 0.17682985E-06_JPRB, 0.20403222E-06_JPRB, 0.22959252E-06_JPRB, 0.25306966E-06_JPRB, 0.27449009E-06_JPRB, 0.29176190E-06_JPRB, &
  & 0.30889727E-06_JPRB, 0.32058227E-06_JPRB, 0.32958381E-06_JPRB, 0.33692102E-06_JPRB, 0.34561600E-06_JPRB, 0.35304378E-06_JPRB, &
  & 0.35759934E-06_JPRB, 0.35966066E-06_JPRB, 0.36267219E-06_JPRB, 0.37056695E-06_JPRB  /)

RGHG7(:,49,10) = (/ &
  & 0.21347297E-06_JPRB, 0.20596303E-06_JPRB, 0.19879945E-06_JPRB, 0.19608813E-06_JPRB, 0.19745263E-06_JPRB, 0.19776415E-06_JPRB, &
  & 0.19863262E-06_JPRB, 0.20171042E-06_JPRB, 0.20765079E-06_JPRB, 0.21916920E-06_JPRB, 0.23469456E-06_JPRB, 0.24603358E-06_JPRB, &
  & 0.25262843E-06_JPRB, 0.25462031E-06_JPRB, 0.25044300E-06_JPRB, 0.23858357E-06_JPRB, 0.22301937E-06_JPRB, 0.20272209E-06_JPRB, &
  & 0.17986131E-06_JPRB, 0.15632866E-06_JPRB, 0.13268133E-06_JPRB, 0.10920452E-06_JPRB, 0.89452039E-07_JPRB, 0.72817236E-07_JPRB, &
  & 0.60741774E-07_JPRB, 0.53006880E-07_JPRB, 0.48332826E-07_JPRB, 0.45582483E-07_JPRB, 0.43411705E-07_JPRB, 0.42402708E-07_JPRB, &
  & 0.41882567E-07_JPRB, 0.41284538E-07_JPRB, 0.40394676E-07_JPRB, 0.38481795E-07_JPRB, 0.36972934E-07_JPRB, 0.38012722E-07_JPRB, &
  & 0.40773128E-07_JPRB, 0.43596819E-07_JPRB, 0.47151540E-07_JPRB, 0.51765478E-07_JPRB, 0.56191531E-07_JPRB, 0.61165864E-07_JPRB, &
  & 0.67339717E-07_JPRB, 0.75157732E-07_JPRB, 0.85485102E-07_JPRB, 0.97900765E-07_JPRB, 0.11212877E-06_JPRB, 0.12945045E-06_JPRB, &
  & 0.15055504E-06_JPRB, 0.17454631E-06_JPRB, 0.19759009E-06_JPRB, 0.21878816E-06_JPRB, 0.23861747E-06_JPRB, 0.25400965E-06_JPRB, &
  & 0.26989786E-06_JPRB, 0.28131434E-06_JPRB, 0.28986540E-06_JPRB, 0.29653909E-06_JPRB, 0.30465931E-06_JPRB, 0.31140137E-06_JPRB, &
  & 0.31487620E-06_JPRB, 0.31576581E-06_JPRB, 0.31844891E-06_JPRB, 0.32445073E-06_JPRB  /)

RGHG7(:,50,10) = (/ &
  & 0.20167156E-06_JPRB, 0.19131380E-06_JPRB, 0.18126066E-06_JPRB, 0.17846061E-06_JPRB, 0.18102901E-06_JPRB, 0.18219285E-06_JPRB, &
  & 0.18370495E-06_JPRB, 0.18606392E-06_JPRB, 0.18953029E-06_JPRB, 0.19848169E-06_JPRB, 0.21161655E-06_JPRB, 0.22069011E-06_JPRB, &
  & 0.22468136E-06_JPRB, 0.22441384E-06_JPRB, 0.21892356E-06_JPRB, 0.20737951E-06_JPRB, 0.19397503E-06_JPRB, 0.17699008E-06_JPRB, &
  & 0.15762616E-06_JPRB, 0.13818851E-06_JPRB, 0.11907104E-06_JPRB, 0.99535204E-07_JPRB, 0.82688611E-07_JPRB, 0.67952432E-07_JPRB, &
  & 0.57006327E-07_JPRB, 0.50196756E-07_JPRB, 0.46234897E-07_JPRB, 0.44088451E-07_JPRB, 0.42313778E-07_JPRB, 0.41481907E-07_JPRB, &
  & 0.40993001E-07_JPRB, 0.40468666E-07_JPRB, 0.39500168E-07_JPRB, 0.37638409E-07_JPRB, 0.36357861E-07_JPRB, 0.37470617E-07_JPRB, &
  & 0.40124064E-07_JPRB, 0.42822727E-07_JPRB, 0.46114169E-07_JPRB, 0.50210585E-07_JPRB, 0.54001875E-07_JPRB, 0.58099765E-07_JPRB, &
  & 0.63111611E-07_JPRB, 0.69595471E-07_JPRB, 0.77897150E-07_JPRB, 0.87583865E-07_JPRB, 0.98346717E-07_JPRB, 0.11209640E-06_JPRB, &
  & 0.12976671E-06_JPRB, 0.15021413E-06_JPRB, 0.17062199E-06_JPRB, 0.18937428E-06_JPRB, 0.20707510E-06_JPRB, 0.22057906E-06_JPRB, &
  & 0.23488106E-06_JPRB, 0.24573666E-06_JPRB, 0.25374377E-06_JPRB, 0.25998556E-06_JPRB, 0.26736398E-06_JPRB, 0.27360776E-06_JPRB, &
  & 0.27637867E-06_JPRB, 0.27668749E-06_JPRB, 0.27891848E-06_JPRB, 0.28367962E-06_JPRB  /)

RGHG7(:,51,10) = (/ &
  & 0.18555651E-06_JPRB, 0.17227559E-06_JPRB, 0.15921351E-06_JPRB, 0.15645982E-06_JPRB, 0.16033565E-06_JPRB, 0.16233865E-06_JPRB, &
  & 0.16460415E-06_JPRB, 0.16668494E-06_JPRB, 0.16830607E-06_JPRB, 0.17507842E-06_JPRB, 0.18581169E-06_JPRB, 0.19297974E-06_JPRB, &
  & 0.19468530E-06_JPRB, 0.19280900E-06_JPRB, 0.18624774E-06_JPRB, 0.17496795E-06_JPRB, 0.16377730E-06_JPRB, 0.15043646E-06_JPRB, &
  & 0.13466797E-06_JPRB, 0.11952120E-06_JPRB, 0.10520923E-06_JPRB, 0.89827498E-07_JPRB, 0.76082573E-07_JPRB, 0.63335357E-07_JPRB, &
  & 0.53460232E-07_JPRB, 0.47564007E-07_JPRB, 0.44272091E-07_JPRB, 0.42654180E-07_JPRB, 0.41282863E-07_JPRB, 0.40622534E-07_JPRB, &
  & 0.40126674E-07_JPRB, 0.39685792E-07_JPRB, 0.38599069E-07_JPRB, 0.36839308E-07_JPRB, 0.35816073E-07_JPRB, 0.37012282E-07_JPRB, &
  & 0.39552141E-07_JPRB, 0.42118669E-07_JPRB, 0.45185252E-07_JPRB, 0.48750814E-07_JPRB, 0.51927798E-07_JPRB, 0.55230566E-07_JPRB, &
  & 0.59169115E-07_JPRB, 0.64433634E-07_JPRB, 0.70943391E-07_JPRB, 0.78110291E-07_JPRB, 0.85697293E-07_JPRB, 0.96132036E-07_JPRB, &
  & 0.11016519E-06_JPRB, 0.12660455E-06_JPRB, 0.14409851E-06_JPRB, 0.16011772E-06_JPRB, 0.17523381E-06_JPRB, 0.18669085E-06_JPRB, &
  & 0.19909893E-06_JPRB, 0.20919419E-06_JPRB, 0.21656381E-06_JPRB, 0.22246020E-06_JPRB, 0.22894845E-06_JPRB, 0.23475178E-06_JPRB, &
  & 0.23695939E-06_JPRB, 0.23695062E-06_JPRB, 0.23862758E-06_JPRB, 0.24238960E-06_JPRB  /)

RGHG7(:,52,10) = (/ &
  & 0.16686129E-06_JPRB, 0.15207032E-06_JPRB, 0.13792643E-06_JPRB, 0.13543715E-06_JPRB, 0.13970160E-06_JPRB, 0.14210708E-06_JPRB, &
  & 0.14441573E-06_JPRB, 0.14608114E-06_JPRB, 0.14678652E-06_JPRB, 0.15195427E-06_JPRB, 0.16095845E-06_JPRB, 0.16711201E-06_JPRB, &
  & 0.16798351E-06_JPRB, 0.16592042E-06_JPRB, 0.15929451E-06_JPRB, 0.14871528E-06_JPRB, 0.13944122E-06_JPRB, 0.12900865E-06_JPRB, &
  & 0.11625939E-06_JPRB, 0.10445530E-06_JPRB, 0.93704199E-07_JPRB, 0.81797091E-07_JPRB, 0.70874432E-07_JPRB, 0.59966019E-07_JPRB, &
  & 0.50982961E-07_JPRB, 0.45672910E-07_JPRB, 0.42858808E-07_JPRB, 0.41558969E-07_JPRB, 0.40481343E-07_JPRB, 0.39937999E-07_JPRB, &
  & 0.39450283E-07_JPRB, 0.38983053E-07_JPRB, 0.37800732E-07_JPRB, 0.36192086E-07_JPRB, 0.35379600E-07_JPRB, 0.36657349E-07_JPRB, &
  & 0.39126059E-07_JPRB, 0.41592529E-07_JPRB, 0.44527378E-07_JPRB, 0.47608280E-07_JPRB, 0.50335253E-07_JPRB, 0.53125037E-07_JPRB, &
  & 0.56242286E-07_JPRB, 0.60705473E-07_JPRB, 0.65993037E-07_JPRB, 0.71386706E-07_JPRB, 0.77018423E-07_JPRB, 0.85071512E-07_JPRB, &
  & 0.96160029E-07_JPRB, 0.10913551E-06_JPRB, 0.12359230E-06_JPRB, 0.13684315E-06_JPRB, 0.14889681E-06_JPRB, 0.15817127E-06_JPRB, &
  & 0.16854045E-06_JPRB, 0.17717574E-06_JPRB, 0.18342786E-06_JPRB, 0.18857512E-06_JPRB, 0.19395046E-06_JPRB, 0.19863211E-06_JPRB, &
  & 0.20023123E-06_JPRB, 0.20002669E-06_JPRB, 0.20145278E-06_JPRB, 0.20435228E-06_JPRB  /)

RGHG7(:,53,10) = (/ &
  & 0.14550982E-06_JPRB, 0.12961809E-06_JPRB, 0.11503758E-06_JPRB, 0.11292010E-06_JPRB, 0.11725426E-06_JPRB, 0.11993005E-06_JPRB, &
  & 0.12201243E-06_JPRB, 0.12317272E-06_JPRB, 0.12323843E-06_JPRB, 0.12687981E-06_JPRB, 0.13425978E-06_JPRB, 0.13965138E-06_JPRB, &
  & 0.14017308E-06_JPRB, 0.13845367E-06_JPRB, 0.13214454E-06_JPRB, 0.12249605E-06_JPRB, 0.11519477E-06_JPRB, 0.10764617E-06_JPRB, &
  & 0.97963104E-07_JPRB, 0.89434360E-07_JPRB, 0.82082123E-07_JPRB, 0.73697413E-07_JPRB, 0.65740662E-07_JPRB, 0.56776906E-07_JPRB, &
  & 0.48696463E-07_JPRB, 0.43898872E-07_JPRB, 0.41531185E-07_JPRB, 0.40496749E-07_JPRB, 0.39696756E-07_JPRB, 0.39259818E-07_JPRB, &
  & 0.38786778E-07_JPRB, 0.38248611E-07_JPRB, 0.36970892E-07_JPRB, 0.35545704E-07_JPRB, 0.34944807E-07_JPRB, 0.36310616E-07_JPRB, &
  & 0.38718173E-07_JPRB, 0.41088022E-07_JPRB, 0.43915241E-07_JPRB, 0.46486130E-07_JPRB, 0.48786256E-07_JPRB, 0.51125957E-07_JPRB, &
  & 0.53445773E-07_JPRB, 0.57197142E-07_JPRB, 0.61372950E-07_JPRB, 0.65122833E-07_JPRB, 0.69094866E-07_JPRB, 0.74913434E-07_JPRB, &
  & 0.83061727E-07_JPRB, 0.92474448E-07_JPRB, 0.10357641E-06_JPRB, 0.11379896E-06_JPRB, 0.12233390E-06_JPRB, 0.12917937E-06_JPRB, &
  & 0.13727245E-06_JPRB, 0.14404870E-06_JPRB, 0.14889919E-06_JPRB, 0.15307535E-06_JPRB, 0.15715302E-06_JPRB, 0.16035112E-06_JPRB, &
  & 0.16127022E-06_JPRB, 0.16089934E-06_JPRB, 0.16216887E-06_JPRB, 0.16418166E-06_JPRB  /)

RGHG7(:,54,10) = (/ &
  & 0.12673747E-06_JPRB, 0.11149854E-06_JPRB, 0.98126125E-07_JPRB, 0.96261723E-07_JPRB, 0.99889154E-07_JPRB, 0.10224180E-06_JPRB, &
  & 0.10357451E-06_JPRB, 0.10426234E-06_JPRB, 0.10400990E-06_JPRB, 0.10671753E-06_JPRB, 0.11298479E-06_JPRB, 0.11802850E-06_JPRB, &
  & 0.11907642E-06_JPRB, 0.11825213E-06_JPRB, 0.11310017E-06_JPRB, 0.10489183E-06_JPRB, 0.98951783E-07_JPRB, 0.93235990E-07_JPRB, &
  & 0.85644866E-07_JPRB, 0.79229217E-07_JPRB, 0.73851355E-07_JPRB, 0.67704392E-07_JPRB, 0.61909566E-07_JPRB, 0.54690437E-07_JPRB, &
  & 0.47581190E-07_JPRB, 0.42937469E-07_JPRB, 0.40713500E-07_JPRB, 0.39820324E-07_JPRB, 0.39116815E-07_JPRB, 0.38703737E-07_JPRB, &
  & 0.38230161E-07_JPRB, 0.37699124E-07_JPRB, 0.36347405E-07_JPRB, 0.35007658E-07_JPRB, 0.34596758E-07_JPRB, 0.36001234E-07_JPRB, &
  & 0.38396017E-07_JPRB, 0.40714773E-07_JPRB, 0.43492872E-07_JPRB, 0.45705962E-07_JPRB, 0.47777536E-07_JPRB, 0.49834909E-07_JPRB, &
  & 0.51696263E-07_JPRB, 0.55017104E-07_JPRB, 0.58430930E-07_JPRB, 0.61325710E-07_JPRB, 0.64433622E-07_JPRB, 0.68806637E-07_JPRB, &
  & 0.74923479E-07_JPRB, 0.82040766E-07_JPRB, 0.90419099E-07_JPRB, 0.98212378E-07_JPRB, 0.10402095E-06_JPRB, 0.10905887E-06_JPRB, &
  & 0.11521089E-06_JPRB, 0.12022332E-06_JPRB, 0.12383081E-06_JPRB, 0.12681594E-06_JPRB, 0.12969095E-06_JPRB, 0.13147399E-06_JPRB, &
  & 0.13219840E-06_JPRB, 0.13142976E-06_JPRB, 0.13224498E-06_JPRB, 0.13400554E-06_JPRB  /)

RGHG7(:,55,10) = (/ &
  & 0.10628157E-06_JPRB, 0.91996440E-07_JPRB, 0.80178660E-07_JPRB, 0.78578987E-07_JPRB, 0.81321393E-07_JPRB, 0.83238011E-07_JPRB, &
  & 0.83671429E-07_JPRB, 0.83840179E-07_JPRB, 0.83277588E-07_JPRB, 0.85028828E-07_JPRB, 0.90130756E-07_JPRB, 0.94843552E-07_JPRB, &
  & 0.96589637E-07_JPRB, 0.96829449E-07_JPRB, 0.93069913E-07_JPRB, 0.86523915E-07_JPRB, 0.82011326E-07_JPRB, 0.78187566E-07_JPRB, &
  & 0.72785645E-07_JPRB, 0.68557902E-07_JPRB, 0.65179781E-07_JPRB, 0.61342707E-07_JPRB, 0.57837007E-07_JPRB, 0.52524185E-07_JPRB, &
  & 0.46499807E-07_JPRB, 0.41979366E-07_JPRB, 0.39874786E-07_JPRB, 0.39121760E-07_JPRB, 0.38501303E-07_JPRB, 0.38103798E-07_JPRB, &
  & 0.37627626E-07_JPRB, 0.37114756E-07_JPRB, 0.35683879E-07_JPRB, 0.34425886E-07_JPRB, 0.34222617E-07_JPRB, 0.35663427E-07_JPRB, &
  & 0.38050425E-07_JPRB, 0.40318570E-07_JPRB, 0.43049953E-07_JPRB, 0.44886713E-07_JPRB, 0.46731191E-07_JPRB, 0.48497881E-07_JPRB, &
  & 0.49895960E-07_JPRB, 0.52776884E-07_JPRB, 0.55392630E-07_JPRB, 0.57443911E-07_JPRB, 0.59699240E-07_JPRB, 0.62574721E-07_JPRB, &
  & 0.66560755E-07_JPRB, 0.71301971E-07_JPRB, 0.76746226E-07_JPRB, 0.81927254E-07_JPRB, 0.84819916E-07_JPRB, 0.87937254E-07_JPRB, &
  & 0.91983119E-07_JPRB, 0.95054210E-07_JPRB, 0.97305611E-07_JPRB, 0.98942438E-07_JPRB, 0.10049770E-06_JPRB, 0.10072221E-06_JPRB, &
  & 0.10129479E-06_JPRB, 0.10005509E-06_JPRB, 0.10032788E-06_JPRB, 0.10189248E-06_JPRB  /)

RGHG7(:,56,10) = (/ &
  & 0.92664589E-07_JPRB, 0.80203333E-07_JPRB, 0.70126793E-07_JPRB, 0.68706027E-07_JPRB, 0.70662606E-07_JPRB, 0.71912587E-07_JPRB, &
  & 0.71714349E-07_JPRB, 0.71420780E-07_JPRB, 0.70711274E-07_JPRB, 0.72061723E-07_JPRB, 0.76252811E-07_JPRB, 0.80373816E-07_JPRB, &
  & 0.82413706E-07_JPRB, 0.83312392E-07_JPRB, 0.80873806E-07_JPRB, 0.76073610E-07_JPRB, 0.72698886E-07_JPRB, 0.69958450E-07_JPRB, &
  & 0.65823024E-07_JPRB, 0.62801674E-07_JPRB, 0.60287705E-07_JPRB, 0.57543434E-07_JPRB, 0.55013990E-07_JPRB, 0.51140824E-07_JPRB, &
  & 0.46115603E-07_JPRB, 0.41733545E-07_JPRB, 0.39568342E-07_JPRB, 0.38878861E-07_JPRB, 0.38212016E-07_JPRB, 0.37572207E-07_JPRB, &
  & 0.37097052E-07_JPRB, 0.36692050E-07_JPRB, 0.35311923E-07_JPRB, 0.34058270E-07_JPRB, 0.33840853E-07_JPRB, 0.35324922E-07_JPRB, &
  & 0.37694189E-07_JPRB, 0.40030302E-07_JPRB, 0.42735654E-07_JPRB, 0.44507878E-07_JPRB, 0.46291355E-07_JPRB, 0.47837354E-07_JPRB, &
  & 0.49067460E-07_JPRB, 0.51629264E-07_JPRB, 0.53841076E-07_JPRB, 0.55645790E-07_JPRB, 0.57416020E-07_JPRB, 0.59521884E-07_JPRB, &
  & 0.62387908E-07_JPRB, 0.65945531E-07_JPRB, 0.69870645E-07_JPRB, 0.73664135E-07_JPRB, 0.75332546E-07_JPRB, 0.77397138E-07_JPRB, &
  & 0.80259652E-07_JPRB, 0.82421201E-07_JPRB, 0.83972603E-07_JPRB, 0.84943093E-07_JPRB, 0.85865859E-07_JPRB, 0.85800773E-07_JPRB, &
  & 0.86358367E-07_JPRB, 0.84968291E-07_JPRB, 0.85080915E-07_JPRB, 0.86743408E-07_JPRB  /)

RGHG7(:,57,10) = (/ &
  & 0.79374216E-07_JPRB, 0.68716458E-07_JPRB, 0.60338208E-07_JPRB, 0.59067075E-07_JPRB, 0.60290064E-07_JPRB, 0.60925790E-07_JPRB, &
  & 0.60194764E-07_JPRB, 0.59427240E-07_JPRB, 0.58584285E-07_JPRB, 0.59526213E-07_JPRB, 0.62745087E-07_JPRB, 0.66246448E-07_JPRB, &
  & 0.68449348E-07_JPRB, 0.69922275E-07_JPRB, 0.68738628E-07_JPRB, 0.65578927E-07_JPRB, 0.63391645E-07_JPRB, 0.61802175E-07_JPRB, &
  & 0.58927337E-07_JPRB, 0.57059982E-07_JPRB, 0.55427005E-07_JPRB, 0.53780757E-07_JPRB, 0.52214015E-07_JPRB, 0.49702857E-07_JPRB, &
  & 0.45633845E-07_JPRB, 0.41552918E-07_JPRB, 0.39321251E-07_JPRB, 0.38649117E-07_JPRB, 0.37979353E-07_JPRB, 0.37110437E-07_JPRB, &
  & 0.36547511E-07_JPRB, 0.36179440E-07_JPRB, 0.34884286E-07_JPRB, 0.33628679E-07_JPRB, 0.33383830E-07_JPRB, 0.34933751E-07_JPRB, &
  & 0.37330593E-07_JPRB, 0.39746083E-07_JPRB, 0.42409083E-07_JPRB, 0.44150162E-07_JPRB, 0.45855353E-07_JPRB, 0.47178425E-07_JPRB, &
  & 0.48243436E-07_JPRB, 0.50483560E-07_JPRB, 0.52301326E-07_JPRB, 0.53834299E-07_JPRB, 0.55123700E-07_JPRB, 0.56489299E-07_JPRB, &
  & 0.58270129E-07_JPRB, 0.60665612E-07_JPRB, 0.63158546E-07_JPRB, 0.65629711E-07_JPRB, 0.66149044E-07_JPRB, 0.67259338E-07_JPRB, &
  & 0.69054639E-07_JPRB, 0.70335213E-07_JPRB, 0.71231960E-07_JPRB, 0.71598970E-07_JPRB, 0.71977740E-07_JPRB, 0.71659769E-07_JPRB, &
  & 0.72177172E-07_JPRB, 0.70751109E-07_JPRB, 0.70775673E-07_JPRB, 0.72353531E-07_JPRB  /)

RGHG7(:,58,10) = (/ &
  & 0.68986688E-07_JPRB, 0.60116044E-07_JPRB, 0.53261909E-07_JPRB, 0.52062841E-07_JPRB, 0.52718075E-07_JPRB, 0.52834200E-07_JPRB, &
  & 0.51830410E-07_JPRB, 0.50618044E-07_JPRB, 0.49705718E-07_JPRB, 0.50363096E-07_JPRB, 0.52632008E-07_JPRB, 0.55467620E-07_JPRB, &
  & 0.57523699E-07_JPRB, 0.59305759E-07_JPRB, 0.59151210E-07_JPRB, 0.57337823E-07_JPRB, 0.56271907E-07_JPRB, 0.55703453E-07_JPRB, &
  & 0.53804843E-07_JPRB, 0.52726148E-07_JPRB, 0.51718847E-07_JPRB, 0.50862943E-07_JPRB, 0.49912447E-07_JPRB, 0.48435102E-07_JPRB, &
  & 0.45156771E-07_JPRB, 0.41630466E-07_JPRB, 0.39294071E-07_JPRB, 0.38545495E-07_JPRB, 0.37922202E-07_JPRB, 0.36816553E-07_JPRB, &
  & 0.36023629E-07_JPRB, 0.35586525E-07_JPRB, 0.34451663E-07_JPRB, 0.33169115E-07_JPRB, 0.32835029E-07_JPRB, 0.34484964E-07_JPRB, &
  & 0.36981820E-07_JPRB, 0.39511804E-07_JPRB, 0.42112169E-07_JPRB, 0.43939455E-07_JPRB, 0.45574602E-07_JPRB, 0.46702024E-07_JPRB, &
  & 0.47675441E-07_JPRB, 0.49638085E-07_JPRB, 0.51184097E-07_JPRB, 0.52536573E-07_JPRB, 0.53459931E-07_JPRB, 0.54330849E-07_JPRB, &
  & 0.55362081E-07_JPRB, 0.56948699E-07_JPRB, 0.58536794E-07_JPRB, 0.60131744E-07_JPRB, 0.60038535E-07_JPRB, 0.60600269E-07_JPRB, &
  & 0.61783364E-07_JPRB, 0.62495511E-07_JPRB, 0.62989845E-07_JPRB, 0.63035935E-07_JPRB, 0.63192789E-07_JPRB, 0.62942168E-07_JPRB, &
  & 0.63405691E-07_JPRB, 0.62199861E-07_JPRB, 0.62336898E-07_JPRB, 0.63583734E-07_JPRB  /)

RGHG7(:,59,10) = (/ &
  & 0.61476935E-07_JPRB, 0.54069946E-07_JPRB, 0.48351775E-07_JPRB, 0.47200379E-07_JPRB, 0.47461403E-07_JPRB, 0.47189510E-07_JPRB, &
  & 0.46116069E-07_JPRB, 0.44615492E-07_JPRB, 0.43615877E-07_JPRB, 0.44048673E-07_JPRB, 0.45577087E-07_JPRB, 0.47847298E-07_JPRB, &
  & 0.49677214E-07_JPRB, 0.51537027E-07_JPRB, 0.52046331E-07_JPRB, 0.51155003E-07_JPRB, 0.50941856E-07_JPRB, 0.51195054E-07_JPRB, &
  & 0.50084995E-07_JPRB, 0.49526612E-07_JPRB, 0.48955488E-07_JPRB, 0.48677019E-07_JPRB, 0.48150008E-07_JPRB, 0.47389652E-07_JPRB, &
  & 0.44773791E-07_JPRB, 0.41774248E-07_JPRB, 0.39432362E-07_JPRB, 0.38586453E-07_JPRB, 0.37914321E-07_JPRB, 0.36639346E-07_JPRB, &
  & 0.35617786E-07_JPRB, 0.35040669E-07_JPRB, 0.33916894E-07_JPRB, 0.32554504E-07_JPRB, 0.32150897E-07_JPRB, 0.33909504E-07_JPRB, &
  & 0.36640244E-07_JPRB, 0.39343241E-07_JPRB, 0.41899214E-07_JPRB, 0.43828239E-07_JPRB, 0.45343523E-07_JPRB, 0.46350572E-07_JPRB, &
  & 0.47262534E-07_JPRB, 0.48998877E-07_JPRB, 0.50360722E-07_JPRB, 0.51566618E-07_JPRB, 0.52222544E-07_JPRB, 0.52760234E-07_JPRB, &
  & 0.53332960E-07_JPRB, 0.54391338E-07_JPRB, 0.55456927E-07_JPRB, 0.56459830E-07_JPRB, 0.56053541E-07_JPRB, 0.56334882E-07_JPRB, &
  & 0.57149822E-07_JPRB, 0.57567454E-07_JPRB, 0.57842977E-07_JPRB, 0.57752842E-07_JPRB, 0.57841386E-07_JPRB, 0.57760440E-07_JPRB, &
  & 0.58195240E-07_JPRB, 0.57296241E-07_JPRB, 0.57526346E-07_JPRB, 0.58349895E-07_JPRB  /)

RGHG7(:,60,10) = (/ &
  & 0.55092179E-07_JPRB, 0.49015693E-07_JPRB, 0.44277363E-07_JPRB, 0.43167234E-07_JPRB, 0.43104377E-07_JPRB, 0.42490838E-07_JPRB, &
  & 0.41426742E-07_JPRB, 0.39710027E-07_JPRB, 0.38622325E-07_JPRB, 0.38844537E-07_JPRB, 0.39725008E-07_JPRB, 0.41467591E-07_JPRB, &
  & 0.43049903E-07_JPRB, 0.44881645E-07_JPRB, 0.45907260E-07_JPRB, 0.45777271E-07_JPRB, 0.46293151E-07_JPRB, 0.47268825E-07_JPRB, &
  & 0.46904369E-07_JPRB, 0.46753226E-07_JPRB, 0.46543948E-07_JPRB, 0.46753383E-07_JPRB, 0.46582479E-07_JPRB, 0.46405089E-07_JPRB, &
  & 0.44417103E-07_JPRB, 0.41910038E-07_JPRB, 0.39630468E-07_JPRB, 0.38668108E-07_JPRB, 0.37870918E-07_JPRB, 0.36452092E-07_JPRB, &
  & 0.35224813E-07_JPRB, 0.34486249E-07_JPRB, 0.33298360E-07_JPRB, 0.31819030E-07_JPRB, 0.31337482E-07_JPRB, 0.33225688E-07_JPRB, &
  & 0.36281787E-07_JPRB, 0.39168100E-07_JPRB, 0.41702693E-07_JPRB, 0.43729694E-07_JPRB, 0.45120972E-07_JPRB, 0.46041266E-07_JPRB, &
  & 0.46903864E-07_JPRB, 0.48430225E-07_JPRB, 0.49642446E-07_JPRB, 0.50707983E-07_JPRB, 0.51136408E-07_JPRB, 0.51403402E-07_JPRB, &
  & 0.51631145E-07_JPRB, 0.52271166E-07_JPRB, 0.52960798E-07_JPRB, 0.53477754E-07_JPRB, 0.52879980E-07_JPRB, 0.52980509E-07_JPRB, &
  & 0.53519448E-07_JPRB, 0.53751369E-07_JPRB, 0.53882700E-07_JPRB, 0.53731030E-07_JPRB, 0.53810223E-07_JPRB, 0.53937648E-07_JPRB, &
  & 0.54366518E-07_JPRB, 0.53795262E-07_JPRB, 0.54097949E-07_JPRB, 0.54501676E-07_JPRB  /)

RGHG7(:,61,10) = (/ &
  & 0.50676073E-07_JPRB, 0.45582859E-07_JPRB, 0.41521828E-07_JPRB, 0.40451132E-07_JPRB, 0.40183442E-07_JPRB, 0.39305555E-07_JPRB, &
  & 0.38314119E-07_JPRB, 0.36511600E-07_JPRB, 0.35369495E-07_JPRB, 0.35396003E-07_JPRB, 0.35844899E-07_JPRB, 0.37171610E-07_JPRB, &
  & 0.38559311E-07_JPRB, 0.40228939E-07_JPRB, 0.41548842E-07_JPRB, 0.41939882E-07_JPRB, 0.42903036E-07_JPRB, 0.44332921E-07_JPRB, &
  & 0.44657084E-07_JPRB, 0.44726474E-07_JPRB, 0.44757811E-07_JPRB, 0.45281250E-07_JPRB, 0.45378711E-07_JPRB, 0.45545265E-07_JPRB, &
  & 0.44105692E-07_JPRB, 0.41907155E-07_JPRB, 0.39830957E-07_JPRB, 0.38719262E-07_JPRB, 0.37626688E-07_JPRB, 0.36105629E-07_JPRB, &
  & 0.34797658E-07_JPRB, 0.33926190E-07_JPRB, 0.32566694E-07_JPRB, 0.30904803E-07_JPRB, 0.30298383E-07_JPRB, 0.32369880E-07_JPRB, &
  & 0.35902828E-07_JPRB, 0.38910726E-07_JPRB, 0.41498262E-07_JPRB, 0.43572364E-07_JPRB, 0.44905952E-07_JPRB, 0.45795211E-07_JPRB, &
  & 0.46627504E-07_JPRB, 0.47979337E-07_JPRB, 0.49095897E-07_JPRB, 0.50025973E-07_JPRB, 0.50301413E-07_JPRB, 0.50391687E-07_JPRB, &
  & 0.50424091E-07_JPRB, 0.50805606E-07_JPRB, 0.51292960E-07_JPRB, 0.51474735E-07_JPRB, 0.50832781E-07_JPRB, 0.50847872E-07_JPRB, &
  & 0.51221776E-07_JPRB, 0.51394547E-07_JPRB, 0.51476587E-07_JPRB, 0.51343903E-07_JPRB, 0.51461069E-07_JPRB, 0.51791501E-07_JPRB, &
  & 0.52276600E-07_JPRB, 0.51955817E-07_JPRB, 0.52260330E-07_JPRB, 0.52443159E-07_JPRB  /)

RGHG7(:,62,10) = (/ &
  & 0.47308941E-07_JPRB, 0.42999523E-07_JPRB, 0.39487107E-07_JPRB, 0.38415476E-07_JPRB, 0.37970478E-07_JPRB, 0.36892252E-07_JPRB, &
  & 0.35942546E-07_JPRB, 0.34119872E-07_JPRB, 0.32974067E-07_JPRB, 0.32789438E-07_JPRB, 0.32896251E-07_JPRB, 0.33876536E-07_JPRB, &
  & 0.35119103E-07_JPRB, 0.36677669E-07_JPRB, 0.38087169E-07_JPRB, 0.38886921E-07_JPRB, 0.40134027E-07_JPRB, 0.41880431E-07_JPRB, &
  & 0.42759753E-07_JPRB, 0.43022382E-07_JPRB, 0.43239569E-07_JPRB, 0.43940254E-07_JPRB, 0.44266795E-07_JPRB, 0.44650681E-07_JPRB, &
  & 0.43721599E-07_JPRB, 0.41815481E-07_JPRB, 0.39892108E-07_JPRB, 0.38575229E-07_JPRB, 0.37256239E-07_JPRB, 0.35562651E-07_JPRB, &
  & 0.34173036E-07_JPRB, 0.33268220E-07_JPRB, 0.31680828E-07_JPRB, 0.29729462E-07_JPRB, 0.28949319E-07_JPRB, 0.31300503E-07_JPRB, &
  & 0.35341996E-07_JPRB, 0.38527794E-07_JPRB, 0.41194559E-07_JPRB, 0.43266177E-07_JPRB, 0.44646734E-07_JPRB, 0.45533701E-07_JPRB, &
  & 0.46369321E-07_JPRB, 0.47574846E-07_JPRB, 0.48614047E-07_JPRB, 0.49418939E-07_JPRB, 0.49574356E-07_JPRB, 0.49506602E-07_JPRB, &
  & 0.49433933E-07_JPRB, 0.49634922E-07_JPRB, 0.49960310E-07_JPRB, 0.49866491E-07_JPRB, 0.49236252E-07_JPRB, 0.49239674E-07_JPRB, &
  & 0.49490042E-07_JPRB, 0.49617725E-07_JPRB, 0.49695933E-07_JPRB, 0.49617980E-07_JPRB, 0.49791899E-07_JPRB, 0.50272888E-07_JPRB, &
  & 0.50831686E-07_JPRB, 0.50701250E-07_JPRB, 0.50970885E-07_JPRB, 0.51027403E-07_JPRB  /)

RGHG7(:,63,10) = (/ &
  & 0.44611052E-07_JPRB, 0.40974751E-07_JPRB, 0.37929604E-07_JPRB, 0.36815002E-07_JPRB, 0.36210999E-07_JPRB, 0.34978740E-07_JPRB, &
  & 0.34033194E-07_JPRB, 0.32229009E-07_JPRB, 0.31109591E-07_JPRB, 0.30705068E-07_JPRB, 0.30509216E-07_JPRB, 0.31186653E-07_JPRB, &
  & 0.32309210E-07_JPRB, 0.33778957E-07_JPRB, 0.35176698E-07_JPRB, 0.36290008E-07_JPRB, 0.37718522E-07_JPRB, 0.39677338E-07_JPRB, &
  & 0.41006762E-07_JPRB, 0.41484144E-07_JPRB, 0.41864423E-07_JPRB, 0.42645354E-07_JPRB, 0.43170673E-07_JPRB, 0.43677622E-07_JPRB, &
  & 0.43203346E-07_JPRB, 0.41616843E-07_JPRB, 0.39826463E-07_JPRB, 0.38327085E-07_JPRB, 0.36818091E-07_JPRB, 0.34907733E-07_JPRB, &
  & 0.33400964E-07_JPRB, 0.32414335E-07_JPRB, 0.30577494E-07_JPRB, 0.28273822E-07_JPRB, 0.27349035E-07_JPRB, 0.30054479E-07_JPRB, &
  & 0.34604404E-07_JPRB, 0.38020114E-07_JPRB, 0.40780324E-07_JPRB, 0.42849875E-07_JPRB, 0.44317863E-07_JPRB, 0.45222124E-07_JPRB, &
  & 0.46096159E-07_JPRB, 0.47176481E-07_JPRB, 0.48139145E-07_JPRB, 0.48832680E-07_JPRB, 0.48890442E-07_JPRB, 0.48680989E-07_JPRB, &
  & 0.48566354E-07_JPRB, 0.48636388E-07_JPRB, 0.48818452E-07_JPRB, 0.48500628E-07_JPRB, 0.47905975E-07_JPRB, 0.47940356E-07_JPRB, &
  & 0.48088558E-07_JPRB, 0.48165322E-07_JPRB, 0.48277055E-07_JPRB, 0.48286929E-07_JPRB, 0.48533760E-07_JPRB, 0.49126106E-07_JPRB, &
  & 0.49751732E-07_JPRB, 0.49769617E-07_JPRB, 0.49974839E-07_JPRB, 0.49969563E-07_JPRB  /)

RGHG7(:,64,10) = (/ &
  & 0.42611057E-07_JPRB, 0.39550200E-07_JPRB, 0.36883225E-07_JPRB, 0.35663997E-07_JPRB, 0.34924618E-07_JPRB, 0.33594123E-07_JPRB, &
  & 0.32590673E-07_JPRB, 0.30833211E-07_JPRB, 0.29762113E-07_JPRB, 0.29140350E-07_JPRB, 0.28660170E-07_JPRB, 0.29084029E-07_JPRB, &
  & 0.30103157E-07_JPRB, 0.31490641E-07_JPRB, 0.32834472E-07_JPRB, 0.34127084E-07_JPRB, 0.35641855E-07_JPRB, 0.37686528E-07_JPRB, &
  & 0.39323441E-07_JPRB, 0.40088744E-07_JPRB, 0.40625164E-07_JPRB, 0.41381736E-07_JPRB, 0.42062796E-07_JPRB, 0.42582924E-07_JPRB, &
  & 0.42445687E-07_JPRB, 0.41250535E-07_JPRB, 0.39590338E-07_JPRB, 0.38029462E-07_JPRB, 0.36357938E-07_JPRB, 0.34201189E-07_JPRB, &
  & 0.32494353E-07_JPRB, 0.31206225E-07_JPRB, 0.29133775E-07_JPRB, 0.26444743E-07_JPRB, 0.25503584E-07_JPRB, 0.28636318E-07_JPRB, &
  & 0.33641886E-07_JPRB, 0.37350309E-07_JPRB, 0.40208756E-07_JPRB, 0.42328224E-07_JPRB, 0.43873684E-07_JPRB, 0.44813885E-07_JPRB, &
  & 0.45777771E-07_JPRB, 0.46761453E-07_JPRB, 0.47633867E-07_JPRB, 0.48244340E-07_JPRB, 0.48230222E-07_JPRB, 0.47906159E-07_JPRB, &
  & 0.47815883E-07_JPRB, 0.47803654E-07_JPRB, 0.47853138E-07_JPRB, 0.47387560E-07_JPRB, 0.46829246E-07_JPRB, 0.46923927E-07_JPRB, &
  & 0.46984675E-07_JPRB, 0.46983568E-07_JPRB, 0.47173970E-07_JPRB, 0.47314027E-07_JPRB, 0.47651907E-07_JPRB, 0.48307349E-07_JPRB, &
  & 0.48962127E-07_JPRB, 0.49079446E-07_JPRB, 0.49186831E-07_JPRB, 0.49185948E-07_JPRB  /)

RGHG7(:,65,10) = (/ &
  & 0.41252031E-07_JPRB, 0.38669540E-07_JPRB, 0.36273976E-07_JPRB, 0.34919961E-07_JPRB, 0.34056440E-07_JPRB, 0.32683454E-07_JPRB, &
  & 0.31587835E-07_JPRB, 0.29859612E-07_JPRB, 0.28833113E-07_JPRB, 0.28012154E-07_JPRB, 0.27266663E-07_JPRB, 0.27470318E-07_JPRB, &
  & 0.28375937E-07_JPRB, 0.29664548E-07_JPRB, 0.30966694E-07_JPRB, 0.32299482E-07_JPRB, 0.33836867E-07_JPRB, 0.35829416E-07_JPRB, &
  & 0.37607050E-07_JPRB, 0.38695550E-07_JPRB, 0.39416435E-07_JPRB, 0.40141399E-07_JPRB, 0.40906168E-07_JPRB, 0.41416158E-07_JPRB, &
  & 0.41460569E-07_JPRB, 0.40588389E-07_JPRB, 0.39007334E-07_JPRB, 0.37445819E-07_JPRB, 0.35641003E-07_JPRB, 0.33269063E-07_JPRB, &
  & 0.31263625E-07_JPRB, 0.29726706E-07_JPRB, 0.27345861E-07_JPRB, 0.24420917E-07_JPRB, 0.23784762E-07_JPRB, 0.27281143E-07_JPRB, &
  & 0.32562593E-07_JPRB, 0.36509467E-07_JPRB, 0.39482139E-07_JPRB, 0.41626631E-07_JPRB, 0.43285462E-07_JPRB, 0.44342532E-07_JPRB, &
  & 0.45340459E-07_JPRB, 0.46275454E-07_JPRB, 0.47052470E-07_JPRB, 0.47610468E-07_JPRB, 0.47548080E-07_JPRB, 0.47179896E-07_JPRB, &
  & 0.47149475E-07_JPRB, 0.47110479E-07_JPRB, 0.47036035E-07_JPRB, 0.46484760E-07_JPRB, 0.45962692E-07_JPRB, 0.46101407E-07_JPRB, &
  & 0.46064741E-07_JPRB, 0.45987772E-07_JPRB, 0.46283089E-07_JPRB, 0.46599668E-07_JPRB, 0.47042671E-07_JPRB, 0.47752769E-07_JPRB, &
  & 0.48380054E-07_JPRB, 0.48497957E-07_JPRB, 0.48552846E-07_JPRB, 0.48519964E-07_JPRB  /)

RGHG7(:,66,10) = (/ &
  & 0.40173843E-07_JPRB, 0.38043739E-07_JPRB, 0.35850143E-07_JPRB, 0.34375207E-07_JPRB, 0.33389128E-07_JPRB, 0.31993228E-07_JPRB, &
  & 0.30805731E-07_JPRB, 0.29078509E-07_JPRB, 0.28081456E-07_JPRB, 0.27082799E-07_JPRB, 0.26095247E-07_JPRB, 0.26089028E-07_JPRB, &
  & 0.26871236E-07_JPRB, 0.28040184E-07_JPRB, 0.29292676E-07_JPRB, 0.30609955E-07_JPRB, 0.32125086E-07_JPRB, 0.34034178E-07_JPRB, &
  & 0.35868267E-07_JPRB, 0.37193255E-07_JPRB, 0.38133500E-07_JPRB, 0.38892543E-07_JPRB, 0.39683171E-07_JPRB, 0.40186067E-07_JPRB, &
  & 0.40305265E-07_JPRB, 0.39677920E-07_JPRB, 0.38241155E-07_JPRB, 0.36670548E-07_JPRB, 0.34706151E-07_JPRB, 0.32215169E-07_JPRB, &
  & 0.30006416E-07_JPRB, 0.28181935E-07_JPRB, 0.25430330E-07_JPRB, 0.22503871E-07_JPRB, 0.22351324E-07_JPRB, 0.26106076E-07_JPRB, &
  & 0.31445030E-07_JPRB, 0.35547800E-07_JPRB, 0.38611625E-07_JPRB, 0.40772358E-07_JPRB, 0.42608155E-07_JPRB, 0.43819098E-07_JPRB, &
  & 0.44852440E-07_JPRB, 0.45711222E-07_JPRB, 0.46418957E-07_JPRB, 0.46924236E-07_JPRB, 0.46834577E-07_JPRB, 0.46477958E-07_JPRB, &
  & 0.46508636E-07_JPRB, 0.46450469E-07_JPRB, 0.46267985E-07_JPRB, 0.45655682E-07_JPRB, 0.45177841E-07_JPRB, 0.45329382E-07_JPRB, &
  & 0.45206236E-07_JPRB, 0.45067049E-07_JPRB, 0.45475855E-07_JPRB, 0.45971781E-07_JPRB, 0.46534248E-07_JPRB, 0.47294357E-07_JPRB, &
  & 0.47885710E-07_JPRB, 0.47971975E-07_JPRB, 0.48010725E-07_JPRB, 0.47930391E-07_JPRB  /)

RGHG7(:,67,10) = (/ &
  & 0.39326233E-07_JPRB, 0.37632031E-07_JPRB, 0.35574393E-07_JPRB, 0.34005853E-07_JPRB, 0.32905506E-07_JPRB, 0.31493467E-07_JPRB, &
  & 0.30219083E-07_JPRB, 0.28469110E-07_JPRB, 0.27478052E-07_JPRB, 0.26328169E-07_JPRB, 0.25137175E-07_JPRB, 0.24925620E-07_JPRB, &
  & 0.25572497E-07_JPRB, 0.26607448E-07_JPRB, 0.27800054E-07_JPRB, 0.29055242E-07_JPRB, 0.30504011E-07_JPRB, 0.32318967E-07_JPRB, &
  & 0.34138329E-07_JPRB, 0.35586770E-07_JPRB, 0.36761285E-07_JPRB, 0.37626812E-07_JPRB, 0.38407653E-07_JPRB, 0.38917055E-07_JPRB, &
  & 0.39021442E-07_JPRB, 0.38504878E-07_JPRB, 0.37285654E-07_JPRB, 0.35731057E-07_JPRB, 0.33633929E-07_JPRB, 0.31103050E-07_JPRB, &
  & 0.28768469E-07_JPRB, 0.26587910E-07_JPRB, 0.23482195E-07_JPRB, 0.20815610E-07_JPRB, 0.21230342E-07_JPRB, 0.25129521E-07_JPRB, &
  & 0.30327120E-07_JPRB, 0.34479062E-07_JPRB, 0.37597225E-07_JPRB, 0.39781696E-07_JPRB, 0.41833699E-07_JPRB, 0.43233668E-07_JPRB, &
  & 0.44315919E-07_JPRB, 0.45075757E-07_JPRB, 0.45739794E-07_JPRB, 0.46192068E-07_JPRB, 0.46094036E-07_JPRB, 0.45798930E-07_JPRB, &
  & 0.45886449E-07_JPRB, 0.45807499E-07_JPRB, 0.45535205E-07_JPRB, 0.44883856E-07_JPRB, 0.44456779E-07_JPRB, 0.44592439E-07_JPRB, &
  & 0.44399054E-07_JPRB, 0.44213690E-07_JPRB, 0.44744343E-07_JPRB, 0.45407897E-07_JPRB, 0.46096370E-07_JPRB, 0.46899313E-07_JPRB, &
  & 0.47473246E-07_JPRB, 0.47522703E-07_JPRB, 0.47568985E-07_JPRB, 0.47420443E-07_JPRB  /)

RGHG7(:,68,10) = (/ &
  & 0.38646778E-07_JPRB, 0.37385585E-07_JPRB, 0.35403396E-07_JPRB, 0.33786470E-07_JPRB, 0.32594683E-07_JPRB, 0.31151890E-07_JPRB, &
  & 0.29797547E-07_JPRB, 0.28013951E-07_JPRB, 0.26990909E-07_JPRB, 0.25722932E-07_JPRB, 0.24394983E-07_JPRB, 0.23971434E-07_JPRB, &
  & 0.24465364E-07_JPRB, 0.25365820E-07_JPRB, 0.26487077E-07_JPRB, 0.27638524E-07_JPRB, 0.28976170E-07_JPRB, 0.30709527E-07_JPRB, &
  & 0.32458771E-07_JPRB, 0.33892040E-07_JPRB, 0.35273219E-07_JPRB, 0.36315476E-07_JPRB, 0.37098367E-07_JPRB, 0.37645083E-07_JPRB, &
  & 0.37677712E-07_JPRB, 0.37026243E-07_JPRB, 0.36091591E-07_JPRB, 0.34664108E-07_JPRB, 0.32585022E-07_JPRB, 0.30038561E-07_JPRB, &
  & 0.27572356E-07_JPRB, 0.24919013E-07_JPRB, 0.21640668E-07_JPRB, 0.19527236E-07_JPRB, 0.20417212E-07_JPRB, 0.24344274E-07_JPRB, &
  & 0.29260581E-07_JPRB, 0.33314112E-07_JPRB, 0.36430225E-07_JPRB, 0.38678253E-07_JPRB, 0.40927899E-07_JPRB, 0.42557493E-07_JPRB, &
  & 0.43717243E-07_JPRB, 0.44380721E-07_JPRB, 0.45017284E-07_JPRB, 0.45421582E-07_JPRB, 0.45328882E-07_JPRB, 0.45133826E-07_JPRB, &
  & 0.45269731E-07_JPRB, 0.45157568E-07_JPRB, 0.44815156E-07_JPRB, 0.44146584E-07_JPRB, 0.43772404E-07_JPRB, 0.43873209E-07_JPRB, &
  & 0.43631439E-07_JPRB, 0.43417372E-07_JPRB, 0.44082520E-07_JPRB, 0.44881799E-07_JPRB, 0.45687136E-07_JPRB, 0.46520422E-07_JPRB, &
  & 0.47143561E-07_JPRB, 0.47196708E-07_JPRB, 0.47247090E-07_JPRB, 0.46993987E-07_JPRB  /)

RGHG7(:,69,10) = (/ &
  & 0.38068210E-07_JPRB, 0.37205612E-07_JPRB, 0.35318264E-07_JPRB, 0.33668262E-07_JPRB, 0.32438046E-07_JPRB, 0.30920841E-07_JPRB, &
  & 0.29482449E-07_JPRB, 0.27685761E-07_JPRB, 0.26587824E-07_JPRB, 0.25213717E-07_JPRB, 0.23808176E-07_JPRB, 0.23197304E-07_JPRB, &
  & 0.23530850E-07_JPRB, 0.24290491E-07_JPRB, 0.25318768E-07_JPRB, 0.26334024E-07_JPRB, 0.27549745E-07_JPRB, 0.29185844E-07_JPRB, &
  & 0.30839978E-07_JPRB, 0.32182692E-07_JPRB, 0.33701828E-07_JPRB, 0.34900257E-07_JPRB, 0.35779617E-07_JPRB, 0.36386032E-07_JPRB, &
  & 0.36228612E-07_JPRB, 0.35325452E-07_JPRB, 0.34585379E-07_JPRB, 0.33361866E-07_JPRB, 0.31488165E-07_JPRB, 0.28928737E-07_JPRB, &
  & 0.26166724E-07_JPRB, 0.23267962E-07_JPRB, 0.20212982E-07_JPRB, 0.18546239E-07_JPRB, 0.19700888E-07_JPRB, 0.23549840E-07_JPRB, &
  & 0.28196850E-07_JPRB, 0.32021368E-07_JPRB, 0.35165660E-07_JPRB, 0.37546275E-07_JPRB, 0.39867013E-07_JPRB, 0.41697455E-07_JPRB, &
  & 0.42971262E-07_JPRB, 0.43631697E-07_JPRB, 0.44250868E-07_JPRB, 0.44614291E-07_JPRB, 0.44549685E-07_JPRB, 0.44470710E-07_JPRB, &
  & 0.44648274E-07_JPRB, 0.44466329E-07_JPRB, 0.44066128E-07_JPRB, 0.43411686E-07_JPRB, 0.43068373E-07_JPRB, 0.43103729E-07_JPRB, &
  & 0.42846424E-07_JPRB, 0.42643591E-07_JPRB, 0.43457018E-07_JPRB, 0.44350572E-07_JPRB, 0.45236177E-07_JPRB, 0.46145705E-07_JPRB, &
  & 0.46876632E-07_JPRB, 0.46989822E-07_JPRB, 0.46987951E-07_JPRB, 0.46706811E-07_JPRB  /)

RGHG7(:,70,10) = (/ &
  & 0.37545720E-07_JPRB, 0.37014069E-07_JPRB, 0.35277044E-07_JPRB, 0.33592314E-07_JPRB, 0.32335257E-07_JPRB, 0.30745138E-07_JPRB, &
  & 0.29193290E-07_JPRB, 0.27398617E-07_JPRB, 0.26193518E-07_JPRB, 0.24739747E-07_JPRB, 0.23271849E-07_JPRB, 0.22509310E-07_JPRB, &
  & 0.22695237E-07_JPRB, 0.23301004E-07_JPRB, 0.24213485E-07_JPRB, 0.25099319E-07_JPRB, 0.26191566E-07_JPRB, 0.27706265E-07_JPRB, &
  & 0.29244045E-07_JPRB, 0.30510266E-07_JPRB, 0.32101519E-07_JPRB, 0.33400075E-07_JPRB, 0.34382558E-07_JPRB, 0.35030272E-07_JPRB, &
  & 0.34702675E-07_JPRB, 0.33567957E-07_JPRB, 0.32927473E-07_JPRB, 0.31980980E-07_JPRB, 0.30290821E-07_JPRB, 0.27786333E-07_JPRB, &
  & 0.24722671E-07_JPRB, 0.21819666E-07_JPRB, 0.19046178E-07_JPRB, 0.17658052E-07_JPRB, 0.18968714E-07_JPRB, 0.22710111E-07_JPRB, &
  & 0.27085605E-07_JPRB, 0.30661086E-07_JPRB, 0.33822063E-07_JPRB, 0.36332099E-07_JPRB, 0.38706576E-07_JPRB, 0.40705642E-07_JPRB, &
  & 0.42117362E-07_JPRB, 0.42836144E-07_JPRB, 0.43469147E-07_JPRB, 0.43800175E-07_JPRB, 0.43773116E-07_JPRB, 0.43814897E-07_JPRB, &
  & 0.44011856E-07_JPRB, 0.43733028E-07_JPRB, 0.43282095E-07_JPRB, 0.42653961E-07_JPRB, 0.42317481E-07_JPRB, 0.42288048E-07_JPRB, &
  & 0.42029857E-07_JPRB, 0.41868911E-07_JPRB, 0.42834659E-07_JPRB, 0.43799285E-07_JPRB, 0.44738117E-07_JPRB, 0.45757403E-07_JPRB, &
  & 0.46619752E-07_JPRB, 0.46839415E-07_JPRB, 0.46777240E-07_JPRB, 0.46548001E-07_JPRB  /)

RGHG7(:,71,10) = (/ &
  & 0.37083030E-07_JPRB, 0.36800489E-07_JPRB, 0.35259444E-07_JPRB, 0.33545600E-07_JPRB, 0.32258094E-07_JPRB, 0.30611987E-07_JPRB, &
  & 0.28915380E-07_JPRB, 0.27127247E-07_JPRB, 0.25788507E-07_JPRB, 0.24283661E-07_JPRB, 0.22767338E-07_JPRB, 0.21889658E-07_JPRB, &
  & 0.21945732E-07_JPRB, 0.22387492E-07_JPRB, 0.23162736E-07_JPRB, 0.23935152E-07_JPRB, 0.24901071E-07_JPRB, 0.26268759E-07_JPRB, &
  & 0.27680046E-07_JPRB, 0.28895395E-07_JPRB, 0.30482326E-07_JPRB, 0.31810150E-07_JPRB, 0.32882830E-07_JPRB, 0.33553318E-07_JPRB, &
  & 0.33098305E-07_JPRB, 0.31789955E-07_JPRB, 0.31167835E-07_JPRB, 0.30521249E-07_JPRB, 0.29026779E-07_JPRB, 0.26617739E-07_JPRB, &
  & 0.23332110E-07_JPRB, 0.20599366E-07_JPRB, 0.18096724E-07_JPRB, 0.16824328E-07_JPRB, 0.18208914E-07_JPRB, 0.21820454E-07_JPRB, &
  & 0.25913595E-07_JPRB, 0.29251761E-07_JPRB, 0.32388305E-07_JPRB, 0.35007109E-07_JPRB, 0.37443585E-07_JPRB, 0.39589911E-07_JPRB, &
  & 0.41164154E-07_JPRB, 0.41997348E-07_JPRB, 0.42676629E-07_JPRB, 0.42997082E-07_JPRB, 0.43007678E-07_JPRB, 0.43163595E-07_JPRB, &
  & 0.43348127E-07_JPRB, 0.42957688E-07_JPRB, 0.42455584E-07_JPRB, 0.41850286E-07_JPRB, 0.41509213E-07_JPRB, 0.41415688E-07_JPRB, &
  & 0.41173883E-07_JPRB, 0.41080342E-07_JPRB, 0.42197025E-07_JPRB, 0.43207586E-07_JPRB, 0.44181427E-07_JPRB, 0.45331026E-07_JPRB, &
  & 0.46331145E-07_JPRB, 0.46712714E-07_JPRB, 0.46608254E-07_JPRB, 0.46485312E-07_JPRB  /)

RGHG7(:,72,10) = (/ &
  & 0.36696601E-07_JPRB, 0.36559772E-07_JPRB, 0.35235448E-07_JPRB, 0.33515858E-07_JPRB, 0.32173350E-07_JPRB, 0.30508773E-07_JPRB, &
  & 0.28636491E-07_JPRB, 0.26840149E-07_JPRB, 0.25349128E-07_JPRB, 0.23823349E-07_JPRB, 0.22279526E-07_JPRB, 0.21323038E-07_JPRB, &
  & 0.21272393E-07_JPRB, 0.21546276E-07_JPRB, 0.22164725E-07_JPRB, 0.22849304E-07_JPRB, 0.23681004E-07_JPRB, 0.24873837E-07_JPRB, &
  & 0.26168554E-07_JPRB, 0.27362559E-07_JPRB, 0.28845644E-07_JPRB, 0.30109027E-07_JPRB, 0.31239581E-07_JPRB, 0.31922382E-07_JPRB, &
  & 0.31398413E-07_JPRB, 0.30019464E-07_JPRB, 0.29360403E-07_JPRB, 0.28941621E-07_JPRB, 0.27766486E-07_JPRB, 0.25427634E-07_JPRB, &
  & 0.22133386E-07_JPRB, 0.19617774E-07_JPRB, 0.17314204E-07_JPRB, 0.16014307E-07_JPRB, 0.17419006E-07_JPRB, 0.20874982E-07_JPRB, &
  & 0.24659870E-07_JPRB, 0.27810046E-07_JPRB, 0.30831252E-07_JPRB, 0.33519424E-07_JPRB, 0.36053177E-07_JPRB, 0.38347268E-07_JPRB, &
  & 0.40114015E-07_JPRB, 0.41115907E-07_JPRB, 0.41872765E-07_JPRB, 0.42230569E-07_JPRB, 0.42263740E-07_JPRB, 0.42507906E-07_JPRB, &
  & 0.42632100E-07_JPRB, 0.42136584E-07_JPRB, 0.41569218E-07_JPRB, 0.40956942E-07_JPRB, 0.40624489E-07_JPRB, 0.40460775E-07_JPRB, &
  & 0.40262068E-07_JPRB, 0.40254313E-07_JPRB, 0.41512604E-07_JPRB, 0.42535889E-07_JPRB, 0.43541336E-07_JPRB, 0.44820228E-07_JPRB, &
  & 0.45938969E-07_JPRB, 0.46559424E-07_JPRB, 0.46471383E-07_JPRB, 0.46460496E-07_JPRB  /)

RGHG7(:,73,10) = (/ &
  & 0.36377808E-07_JPRB, 0.36275155E-07_JPRB, 0.35142906E-07_JPRB, 0.33474298E-07_JPRB, 0.32062756E-07_JPRB, 0.30406267E-07_JPRB, &
  & 0.28344718E-07_JPRB, 0.26504690E-07_JPRB, 0.24857458E-07_JPRB, 0.23335005E-07_JPRB, 0.21776094E-07_JPRB, 0.20772722E-07_JPRB, &
  & 0.20644453E-07_JPRB, 0.20788723E-07_JPRB, 0.21239562E-07_JPRB, 0.21827411E-07_JPRB, 0.22545065E-07_JPRB, 0.23557457E-07_JPRB, &
  & 0.24701022E-07_JPRB, 0.25908607E-07_JPRB, 0.27203433E-07_JPRB, 0.28304856E-07_JPRB, 0.29395715E-07_JPRB, 0.29990710E-07_JPRB, &
  & 0.29584433E-07_JPRB, 0.28188952E-07_JPRB, 0.27520927E-07_JPRB, 0.27222698E-07_JPRB, 0.26390849E-07_JPRB, 0.24173260E-07_JPRB, &
  & 0.21030725E-07_JPRB, 0.18777697E-07_JPRB, 0.16632068E-07_JPRB, 0.15293463E-07_JPRB, 0.16679914E-07_JPRB, 0.19961519E-07_JPRB, &
  & 0.23480173E-07_JPRB, 0.26458793E-07_JPRB, 0.29368181E-07_JPRB, 0.32012597E-07_JPRB, 0.34646861E-07_JPRB, 0.37102146E-07_JPRB, &
  & 0.39020610E-07_JPRB, 0.40202846E-07_JPRB, 0.41055636E-07_JPRB, 0.41486819E-07_JPRB, 0.41502315E-07_JPRB, 0.41794098E-07_JPRB, &
  & 0.41800080E-07_JPRB, 0.41222115E-07_JPRB, 0.40570059E-07_JPRB, 0.39920670E-07_JPRB, 0.39599553E-07_JPRB, 0.39380101E-07_JPRB, &
  & 0.39274647E-07_JPRB, 0.39377938E-07_JPRB, 0.40714277E-07_JPRB, 0.41714550E-07_JPRB, 0.42822263E-07_JPRB, 0.44157675E-07_JPRB, &
  & 0.45398013E-07_JPRB, 0.46176454E-07_JPRB, 0.46074831E-07_JPRB, 0.46215126E-07_JPRB  /)

RGHG7(:,74,10) = (/ &
  & 0.36088079E-07_JPRB, 0.35963089E-07_JPRB, 0.34999814E-07_JPRB, 0.33411197E-07_JPRB, 0.31930753E-07_JPRB, 0.30285570E-07_JPRB, &
  & 0.28048190E-07_JPRB, 0.26153607E-07_JPRB, 0.24357932E-07_JPRB, 0.22840100E-07_JPRB, 0.21271621E-07_JPRB, 0.20243186E-07_JPRB, &
  & 0.20061388E-07_JPRB, 0.20093779E-07_JPRB, 0.20389167E-07_JPRB, 0.20880388E-07_JPRB, 0.21489780E-07_JPRB, 0.22328395E-07_JPRB, &
  & 0.23290797E-07_JPRB, 0.24464076E-07_JPRB, 0.25576136E-07_JPRB, 0.26471134E-07_JPRB, 0.27452663E-07_JPRB, 0.27940617E-07_JPRB, &
  & 0.27649268E-07_JPRB, 0.26376160E-07_JPRB, 0.25763745E-07_JPRB, 0.25518671E-07_JPRB, 0.24879073E-07_JPRB, 0.22916791E-07_JPRB, &
  & 0.19974986E-07_JPRB, 0.18053269E-07_JPRB, 0.16010645E-07_JPRB, 0.14671592E-07_JPRB, 0.16021965E-07_JPRB, 0.19138957E-07_JPRB, &
  & 0.22446754E-07_JPRB, 0.25292067E-07_JPRB, 0.28104182E-07_JPRB, 0.30670339E-07_JPRB, 0.33329928E-07_JPRB, 0.35919108E-07_JPRB, &
  & 0.37953473E-07_JPRB, 0.39305685E-07_JPRB, 0.40245438E-07_JPRB, 0.40713046E-07_JPRB, 0.40688167E-07_JPRB, 0.41004517E-07_JPRB, &
  & 0.40880606E-07_JPRB, 0.40230859E-07_JPRB, 0.39493562E-07_JPRB, 0.38801341E-07_JPRB, 0.38501691E-07_JPRB, 0.38247853E-07_JPRB, &
  & 0.38249686E-07_JPRB, 0.38454875E-07_JPRB, 0.39819217E-07_JPRB, 0.40809359E-07_JPRB, 0.42029881E-07_JPRB, 0.43381922E-07_JPRB, &
  & 0.44746950E-07_JPRB, 0.45610720E-07_JPRB, 0.45458801E-07_JPRB, 0.45763817E-07_JPRB  /)

RGHG7(:,75,10) = (/ &
  & 0.35816658E-07_JPRB, 0.35634763E-07_JPRB, 0.34817460E-07_JPRB, 0.33325631E-07_JPRB, 0.31781267E-07_JPRB, 0.30142677E-07_JPRB, &
  & 0.27758443E-07_JPRB, 0.25801693E-07_JPRB, 0.23869594E-07_JPRB, 0.22346670E-07_JPRB, 0.20775926E-07_JPRB, 0.19745262E-07_JPRB, &
  & 0.19526304E-07_JPRB, 0.19463123E-07_JPRB, 0.19624065E-07_JPRB, 0.20023839E-07_JPRB, 0.20516637E-07_JPRB, 0.21181764E-07_JPRB, &
  & 0.21951892E-07_JPRB, 0.23025791E-07_JPRB, 0.23952991E-07_JPRB, 0.24633419E-07_JPRB, 0.25467891E-07_JPRB, 0.25873344E-07_JPRB, &
  & 0.25692299E-07_JPRB, 0.24664614E-07_JPRB, 0.24126737E-07_JPRB, 0.23875721E-07_JPRB, 0.23292215E-07_JPRB, 0.21661218E-07_JPRB, &
  & 0.18981911E-07_JPRB, 0.17449176E-07_JPRB, 0.15480955E-07_JPRB, 0.14155368E-07_JPRB, 0.15446880E-07_JPRB, 0.18419822E-07_JPRB, &
  & 0.21571388E-07_JPRB, 0.24329433E-07_JPRB, 0.27067310E-07_JPRB, 0.29558827E-07_JPRB, 0.32174973E-07_JPRB, 0.34825883E-07_JPRB, &
  & 0.36953230E-07_JPRB, 0.38446432E-07_JPRB, 0.39463401E-07_JPRB, 0.39916563E-07_JPRB, 0.39833145E-07_JPRB, 0.40126692E-07_JPRB, &
  & 0.39860336E-07_JPRB, 0.39153957E-07_JPRB, 0.38342304E-07_JPRB, 0.37606367E-07_JPRB, 0.37342427E-07_JPRB, 0.37065102E-07_JPRB, &
  & 0.37190056E-07_JPRB, 0.37493455E-07_JPRB, 0.38832965E-07_JPRB, 0.39817154E-07_JPRB, 0.41152852E-07_JPRB, 0.42497996E-07_JPRB, &
  & 0.43986853E-07_JPRB, 0.44877863E-07_JPRB, 0.44651518E-07_JPRB, 0.45112942E-07_JPRB  /)

RGHG7(:,76,10) = (/ &
  & 0.35551791E-07_JPRB, 0.35304208E-07_JPRB, 0.34609660E-07_JPRB, 0.33216775E-07_JPRB, 0.31619039E-07_JPRB, 0.29973059E-07_JPRB, &
  & 0.27491935E-07_JPRB, 0.25466622E-07_JPRB, 0.23415052E-07_JPRB, 0.21862978E-07_JPRB, 0.20301267E-07_JPRB, 0.19294826E-07_JPRB, &
  & 0.19043844E-07_JPRB, 0.18902247E-07_JPRB, 0.18960551E-07_JPRB, 0.19280678E-07_JPRB, 0.19627729E-07_JPRB, 0.20107286E-07_JPRB, &
  & 0.20702517E-07_JPRB, 0.21594952E-07_JPRB, 0.22309485E-07_JPRB, 0.22816249E-07_JPRB, 0.23511132E-07_JPRB, 0.23916585E-07_JPRB, &
  & 0.23866097E-07_JPRB, 0.23173013E-07_JPRB, 0.22651558E-07_JPRB, 0.22341422E-07_JPRB, 0.21723840E-07_JPRB, 0.20398706E-07_JPRB, &
  & 0.18082328E-07_JPRB, 0.16977801E-07_JPRB, 0.15098670E-07_JPRB, 0.13755018E-07_JPRB, 0.14953335E-07_JPRB, 0.17815838E-07_JPRB, &
  & 0.20863533E-07_JPRB, 0.23590376E-07_JPRB, 0.26289251E-07_JPRB, 0.28758599E-07_JPRB, 0.31282370E-07_JPRB, 0.33856095E-07_JPRB, &
  & 0.36072943E-07_JPRB, 0.37651541E-07_JPRB, 0.38738715E-07_JPRB, 0.39113871E-07_JPRB, 0.38957785E-07_JPRB, 0.39138841E-07_JPRB, &
  & 0.38708673E-07_JPRB, 0.37969860E-07_JPRB, 0.37110173E-07_JPRB, 0.36333591E-07_JPRB, 0.36125487E-07_JPRB, 0.35818191E-07_JPRB, &
  & 0.36090944E-07_JPRB, 0.36502730E-07_JPRB, 0.37756844E-07_JPRB, 0.38718453E-07_JPRB, 0.40167874E-07_JPRB, 0.41503165E-07_JPRB, &
  & 0.43109029E-07_JPRB, 0.43989776E-07_JPRB, 0.43685015E-07_JPRB, 0.44263857E-07_JPRB  /)

RGHG7(:,77,10) = (/ &
  & 0.35251699E-07_JPRB, 0.34974219E-07_JPRB, 0.34388381E-07_JPRB, 0.33057938E-07_JPRB, 0.31477155E-07_JPRB, 0.29781817E-07_JPRB, &
  & 0.27266793E-07_JPRB, 0.25139555E-07_JPRB, 0.22977077E-07_JPRB, 0.21380431E-07_JPRB, 0.19840124E-07_JPRB, 0.18892214E-07_JPRB, &
  & 0.18603224E-07_JPRB, 0.18417240E-07_JPRB, 0.18395927E-07_JPRB, 0.18609599E-07_JPRB, 0.18806850E-07_JPRB, 0.19115170E-07_JPRB, &
  & 0.19581586E-07_JPRB, 0.20285622E-07_JPRB, 0.20876472E-07_JPRB, 0.21361114E-07_JPRB, 0.21974052E-07_JPRB, 0.22507460E-07_JPRB, &
  & 0.22634017E-07_JPRB, 0.22134977E-07_JPRB, 0.21593451E-07_JPRB, 0.21108428E-07_JPRB, 0.20415211E-07_JPRB, 0.19145182E-07_JPRB, &
  & 0.17136094E-07_JPRB, 0.16510511E-07_JPRB, 0.14843773E-07_JPRB, 0.13466398E-07_JPRB, 0.14536620E-07_JPRB, 0.17347136E-07_JPRB, &
  & 0.20346349E-07_JPRB, 0.23083407E-07_JPRB, 0.25763259E-07_JPRB, 0.28316355E-07_JPRB, 0.30776843E-07_JPRB, 0.33286895E-07_JPRB, &
  & 0.35614662E-07_JPRB, 0.37226953E-07_JPRB, 0.38218280E-07_JPRB, 0.38423090E-07_JPRB, 0.38095358E-07_JPRB, 0.38056477E-07_JPRB, &
  & 0.37444759E-07_JPRB, 0.36671074E-07_JPRB, 0.35783993E-07_JPRB, 0.34985932E-07_JPRB, 0.34820638E-07_JPRB, 0.34480574E-07_JPRB, &
  & 0.34898892E-07_JPRB, 0.35430088E-07_JPRB, 0.36570340E-07_JPRB, 0.37430060E-07_JPRB, 0.38976266E-07_JPRB, 0.40318149E-07_JPRB, &
  & 0.42052565E-07_JPRB, 0.42811532E-07_JPRB, 0.42409070E-07_JPRB, 0.42937978E-07_JPRB  /)

RGHG7(:,78,10) = (/ &
  & 0.34911271E-07_JPRB, 0.34636910E-07_JPRB, 0.34162043E-07_JPRB, 0.32859279E-07_JPRB, 0.31346323E-07_JPRB, 0.29578348E-07_JPRB, &
  & 0.27067918E-07_JPRB, 0.24815616E-07_JPRB, 0.22554483E-07_JPRB, 0.20900154E-07_JPRB, 0.19385024E-07_JPRB, 0.18505514E-07_JPRB, &
  & 0.18187052E-07_JPRB, 0.17970618E-07_JPRB, 0.17874687E-07_JPRB, 0.17980032E-07_JPRB, 0.18079640E-07_JPRB, 0.18303291E-07_JPRB, &
  & 0.18665058E-07_JPRB, 0.19225700E-07_JPRB, 0.19738413E-07_JPRB, 0.20248488E-07_JPRB, 0.20844299E-07_JPRB, 0.21397472E-07_JPRB, &
  & 0.21641631E-07_JPRB, 0.21281377E-07_JPRB, 0.20724192E-07_JPRB, 0.20093995E-07_JPRB, 0.19326839E-07_JPRB, 0.18077025E-07_JPRB, &
  & 0.16360448E-07_JPRB, 0.16126507E-07_JPRB, 0.14609410E-07_JPRB, 0.13216083E-07_JPRB, 0.14187439E-07_JPRB, 0.16983224E-07_JPRB, &
  & 0.19949345E-07_JPRB, 0.22687224E-07_JPRB, 0.25385712E-07_JPRB, 0.28019083E-07_JPRB, 0.30481848E-07_JPRB, 0.32964903E-07_JPRB, &
  & 0.35343540E-07_JPRB, 0.36959849E-07_JPRB, 0.37867966E-07_JPRB, 0.37873919E-07_JPRB, 0.37311295E-07_JPRB, 0.37012479E-07_JPRB, &
  & 0.36217058E-07_JPRB, 0.35381527E-07_JPRB, 0.34503985E-07_JPRB, 0.33660196E-07_JPRB, 0.33480515E-07_JPRB, 0.33102363E-07_JPRB, &
  & 0.33682239E-07_JPRB, 0.34314501E-07_JPRB, 0.35365658E-07_JPRB, 0.36196451E-07_JPRB, 0.37710701E-07_JPRB, 0.39149431E-07_JPRB, &
  & 0.40981618E-07_JPRB, 0.41624492E-07_JPRB, 0.41189999E-07_JPRB, 0.41726054E-07_JPRB  /)

RGHG7(:,79,10) = (/ &
  & 0.34522555E-07_JPRB, 0.34288853E-07_JPRB, 0.33908664E-07_JPRB, 0.32618935E-07_JPRB, 0.31211321E-07_JPRB, 0.29361080E-07_JPRB, &
  & 0.26882519E-07_JPRB, 0.24501696E-07_JPRB, 0.22140858E-07_JPRB, 0.20413815E-07_JPRB, 0.18943697E-07_JPRB, 0.18127911E-07_JPRB, &
  & 0.17783242E-07_JPRB, 0.17542875E-07_JPRB, 0.17395482E-07_JPRB, 0.17427791E-07_JPRB, 0.17489432E-07_JPRB, 0.17681633E-07_JPRB, &
  & 0.17970405E-07_JPRB, 0.18433258E-07_JPRB, 0.18895788E-07_JPRB, 0.19433471E-07_JPRB, 0.20022155E-07_JPRB, 0.20526217E-07_JPRB, &
  & 0.20827667E-07_JPRB, 0.20565610E-07_JPRB, 0.20006193E-07_JPRB, 0.19267762E-07_JPRB, 0.18461689E-07_JPRB, 0.17235538E-07_JPRB, &
  & 0.15767947E-07_JPRB, 0.15814329E-07_JPRB, 0.14391539E-07_JPRB, 0.12997978E-07_JPRB, 0.13910253E-07_JPRB, 0.16714399E-07_JPRB, &
  & 0.19653846E-07_JPRB, 0.22381335E-07_JPRB, 0.25109574E-07_JPRB, 0.27826377E-07_JPRB, 0.30325307E-07_JPRB, 0.32803599E-07_JPRB, &
  & 0.35187149E-07_JPRB, 0.36784935E-07_JPRB, 0.37625730E-07_JPRB, 0.37446063E-07_JPRB, 0.36629054E-07_JPRB, 0.36062184E-07_JPRB, &
  & 0.35077868E-07_JPRB, 0.34174088E-07_JPRB, 0.33302711E-07_JPRB, 0.32399308E-07_JPRB, 0.32145464E-07_JPRB, 0.31720770E-07_JPRB, &
  & 0.32454716E-07_JPRB, 0.33159224E-07_JPRB, 0.34166747E-07_JPRB, 0.35008719E-07_JPRB, 0.36431943E-07_JPRB, 0.38010439E-07_JPRB, &
  & 0.39907314E-07_JPRB, 0.40423923E-07_JPRB, 0.39994290E-07_JPRB, 0.40548479E-07_JPRB  /)

RGHG7(:,80,10) = (/ &
  & 0.34079825E-07_JPRB, 0.33928790E-07_JPRB, 0.33606125E-07_JPRB, 0.32336576E-07_JPRB, 0.31057153E-07_JPRB, 0.29129196E-07_JPRB, &
  & 0.26697653E-07_JPRB, 0.24207035E-07_JPRB, 0.21730202E-07_JPRB, 0.19913188E-07_JPRB, 0.18525723E-07_JPRB, 0.17754068E-07_JPRB, &
  & 0.17378807E-07_JPRB, 0.17113578E-07_JPRB, 0.16958632E-07_JPRB, 0.16992593E-07_JPRB, 0.17079879E-07_JPRB, 0.17250508E-07_JPRB, &
  & 0.17507088E-07_JPRB, 0.17913993E-07_JPRB, 0.18336852E-07_JPRB, 0.18860276E-07_JPRB, 0.19389284E-07_JPRB, 0.19837168E-07_JPRB, &
  & 0.20142870E-07_JPRB, 0.19949975E-07_JPRB, 0.19409449E-07_JPRB, 0.18597614E-07_JPRB, 0.17821751E-07_JPRB, 0.16651218E-07_JPRB, &
  & 0.15355648E-07_JPRB, 0.15554957E-07_JPRB, 0.14193092E-07_JPRB, 0.12809603E-07_JPRB, 0.13708974E-07_JPRB, 0.16529370E-07_JPRB, &
  & 0.19441340E-07_JPRB, 0.22149051E-07_JPRB, 0.24887006E-07_JPRB, 0.27705011E-07_JPRB, 0.30234970E-07_JPRB, 0.32712388E-07_JPRB, &
  & 0.35077208E-07_JPRB, 0.36641123E-07_JPRB, 0.37422137E-07_JPRB, 0.37112725E-07_JPRB, 0.36068713E-07_JPRB, 0.35257798E-07_JPRB, &
  & 0.34075377E-07_JPRB, 0.33122064E-07_JPRB, 0.32206767E-07_JPRB, 0.31244738E-07_JPRB, 0.30858433E-07_JPRB, 0.30375577E-07_JPRB, &
  & 0.31230718E-07_JPRB, 0.31969037E-07_JPRB, 0.32996907E-07_JPRB, 0.33841631E-07_JPRB, 0.35202862E-07_JPRB, 0.36906241E-07_JPRB, &
  & 0.38836615E-07_JPRB, 0.39190928E-07_JPRB, 0.38764871E-07_JPRB, 0.39281512E-07_JPRB  /)

RGHG7(:,81,10) = (/ &
  & 0.33549905E-07_JPRB, 0.33479083E-07_JPRB, 0.33124333E-07_JPRB, 0.31966660E-07_JPRB, 0.30803335E-07_JPRB, 0.28831049E-07_JPRB, &
  & 0.26483097E-07_JPRB, 0.23861604E-07_JPRB, 0.21287249E-07_JPRB, 0.19411976E-07_JPRB, 0.18140186E-07_JPRB, 0.17417081E-07_JPRB, &
  & 0.17072217E-07_JPRB, 0.16808677E-07_JPRB, 0.16696370E-07_JPRB, 0.16764949E-07_JPRB, 0.16854346E-07_JPRB, 0.16994157E-07_JPRB, &
  & 0.17242292E-07_JPRB, 0.17619224E-07_JPRB, 0.18001553E-07_JPRB, 0.18471362E-07_JPRB, 0.18936200E-07_JPRB, 0.19304714E-07_JPRB, &
  & 0.19601129E-07_JPRB, 0.19475359E-07_JPRB, 0.18913303E-07_JPRB, 0.18042786E-07_JPRB, 0.17302385E-07_JPRB, 0.16223464E-07_JPRB, &
  & 0.14980243E-07_JPRB, 0.15304516E-07_JPRB, 0.13971781E-07_JPRB, 0.12645708E-07_JPRB, 0.13585185E-07_JPRB, 0.16431333E-07_JPRB, &
  & 0.19287154E-07_JPRB, 0.21952648E-07_JPRB, 0.24674560E-07_JPRB, 0.27580800E-07_JPRB, 0.30147065E-07_JPRB, 0.32628283E-07_JPRB, &
  & 0.34966928E-07_JPRB, 0.36489893E-07_JPRB, 0.37215602E-07_JPRB, 0.36815845E-07_JPRB, 0.35643914E-07_JPRB, 0.34607559E-07_JPRB, &
  & 0.33235582E-07_JPRB, 0.32235408E-07_JPRB, 0.31288447E-07_JPRB, 0.30278291E-07_JPRB, 0.29752246E-07_JPRB, 0.29217041E-07_JPRB, &
  & 0.29978882E-07_JPRB, 0.30763217E-07_JPRB, 0.31854835E-07_JPRB, 0.32745998E-07_JPRB, 0.33994931E-07_JPRB, 0.35676780E-07_JPRB, &
  & 0.37541716E-07_JPRB, 0.37792597E-07_JPRB, 0.37310391E-07_JPRB, 0.37747663E-07_JPRB  /)

RGHG7(:,82,10) = (/ &
  & 0.32897120E-07_JPRB, 0.32918506E-07_JPRB, 0.32487955E-07_JPRB, 0.31493217E-07_JPRB, 0.30416453E-07_JPRB, 0.28431535E-07_JPRB, &
  & 0.26171294E-07_JPRB, 0.23477063E-07_JPRB, 0.20820061E-07_JPRB, 0.18943036E-07_JPRB, 0.17812942E-07_JPRB, 0.17149711E-07_JPRB, &
  & 0.16838540E-07_JPRB, 0.16592384E-07_JPRB, 0.16503538E-07_JPRB, 0.16591099E-07_JPRB, 0.16675031E-07_JPRB, 0.16792655E-07_JPRB, &
  & 0.17030656E-07_JPRB, 0.17388275E-07_JPRB, 0.17734698E-07_JPRB, 0.18150942E-07_JPRB, 0.18545330E-07_JPRB, 0.18867268E-07_JPRB, &
  & 0.19155327E-07_JPRB, 0.19067168E-07_JPRB, 0.18470629E-07_JPRB, 0.17557802E-07_JPRB, 0.16856710E-07_JPRB, 0.15846709E-07_JPRB, &
  & 0.14641543E-07_JPRB, 0.15061185E-07_JPRB, 0.13744887E-07_JPRB, 0.12510767E-07_JPRB, 0.13502892E-07_JPRB, 0.16374338E-07_JPRB, &
  & 0.19158953E-07_JPRB, 0.21764756E-07_JPRB, 0.24456185E-07_JPRB, 0.27434389E-07_JPRB, 0.30042256E-07_JPRB, 0.32536265E-07_JPRB, &
  & 0.34845122E-07_JPRB, 0.36319835E-07_JPRB, 0.37001936E-07_JPRB, 0.36526372E-07_JPRB, 0.35264861E-07_JPRB, 0.34063549E-07_JPRB, &
  & 0.32550346E-07_JPRB, 0.31470161E-07_JPRB, 0.30458872E-07_JPRB, 0.29419220E-07_JPRB, 0.28820354E-07_JPRB, 0.28229934E-07_JPRB, &
  & 0.28880164E-07_JPRB, 0.29643906E-07_JPRB, 0.30784904E-07_JPRB, 0.31808595E-07_JPRB, 0.32873232E-07_JPRB, 0.34482786E-07_JPRB, &
  & 0.36022673E-07_JPRB, 0.36252805E-07_JPRB, 0.35713354E-07_JPRB, 0.36046750E-07_JPRB  /)

RGHG7(:,83,10) = (/ &
  & 0.32100222E-07_JPRB, 0.32217723E-07_JPRB, 0.31677602E-07_JPRB, 0.30887922E-07_JPRB, 0.29889524E-07_JPRB, 0.27929700E-07_JPRB, &
  & 0.25769754E-07_JPRB, 0.23037543E-07_JPRB, 0.20325299E-07_JPRB, 0.18495482E-07_JPRB, 0.17525849E-07_JPRB, 0.16938372E-07_JPRB, &
  & 0.16665686E-07_JPRB, 0.16440756E-07_JPRB, 0.16358828E-07_JPRB, 0.16452491E-07_JPRB, 0.16530426E-07_JPRB, 0.16632809E-07_JPRB, &
  & 0.16858867E-07_JPRB, 0.17200800E-07_JPRB, 0.17515463E-07_JPRB, 0.17882170E-07_JPRB, 0.18217943E-07_JPRB, 0.18513814E-07_JPRB, &
  & 0.18800092E-07_JPRB, 0.18724391E-07_JPRB, 0.18085663E-07_JPRB, 0.17167866E-07_JPRB, 0.16508666E-07_JPRB, 0.15553449E-07_JPRB, &
  & 0.14377962E-07_JPRB, 0.14851996E-07_JPRB, 0.13536362E-07_JPRB, 0.12415496E-07_JPRB, 0.13473174E-07_JPRB, 0.16363939E-07_JPRB, &
  & 0.19065222E-07_JPRB, 0.21597127E-07_JPRB, 0.24247440E-07_JPRB, 0.27262887E-07_JPRB, 0.29923131E-07_JPRB, 0.32434101E-07_JPRB, &
  & 0.34711922E-07_JPRB, 0.36137243E-07_JPRB, 0.36775920E-07_JPRB, 0.36238073E-07_JPRB, 0.34916430E-07_JPRB, 0.33606438E-07_JPRB, &
  & 0.31984971E-07_JPRB, 0.30797887E-07_JPRB, 0.29711620E-07_JPRB, 0.28662194E-07_JPRB, 0.28050038E-07_JPRB, 0.27403946E-07_JPRB, &
  & 0.27937305E-07_JPRB, 0.28623510E-07_JPRB, 0.29801713E-07_JPRB, 0.30969082E-07_JPRB, 0.31827460E-07_JPRB, 0.33245362E-07_JPRB, &
  & 0.34325217E-07_JPRB, 0.34529974E-07_JPRB, 0.33987903E-07_JPRB, 0.34123216E-07_JPRB  /)

RGHG7(:,84,10) = (/ &
  & 0.31150300E-07_JPRB, 0.31362830E-07_JPRB, 0.30690898E-07_JPRB, 0.30134386E-07_JPRB, 0.29222791E-07_JPRB, 0.27330089E-07_JPRB, &
  & 0.25290496E-07_JPRB, 0.22540025E-07_JPRB, 0.19812502E-07_JPRB, 0.18071111E-07_JPRB, 0.17269952E-07_JPRB, 0.16771799E-07_JPRB, &
  & 0.16540895E-07_JPRB, 0.16331424E-07_JPRB, 0.16243578E-07_JPRB, 0.16333681E-07_JPRB, 0.16409977E-07_JPRB, 0.16502720E-07_JPRB, &
  & 0.16714969E-07_JPRB, 0.17039479E-07_JPRB, 0.17325700E-07_JPRB, 0.17649662E-07_JPRB, 0.17949817E-07_JPRB, 0.18230127E-07_JPRB, &
  & 0.18524297E-07_JPRB, 0.18441832E-07_JPRB, 0.17758718E-07_JPRB, 0.16885790E-07_JPRB, 0.16267326E-07_JPRB, 0.15358781E-07_JPRB, &
  & 0.14208517E-07_JPRB, 0.14691152E-07_JPRB, 0.13359839E-07_JPRB, 0.12358227E-07_JPRB, 0.13489218E-07_JPRB, 0.16389139E-07_JPRB, &
  & 0.19002223E-07_JPRB, 0.21453312E-07_JPRB, 0.24055582E-07_JPRB, 0.27064425E-07_JPRB, 0.29787773E-07_JPRB, 0.32315048E-07_JPRB, &
  & 0.34565452E-07_JPRB, 0.35945262E-07_JPRB, 0.36532184E-07_JPRB, 0.35944108E-07_JPRB, 0.34583913E-07_JPRB, 0.33213233E-07_JPRB, &
  & 0.31504904E-07_JPRB, 0.30193838E-07_JPRB, 0.29040116E-07_JPRB, 0.28000033E-07_JPRB, 0.27422132E-07_JPRB, 0.26722913E-07_JPRB, &
  & 0.27143810E-07_JPRB, 0.27707702E-07_JPRB, 0.28914394E-07_JPRB, 0.30184560E-07_JPRB, 0.30853820E-07_JPRB, 0.31931881E-07_JPRB, &
  & 0.32532013E-07_JPRB, 0.32638398E-07_JPRB, 0.32160942E-07_JPRB, 0.31976689E-07_JPRB  /)

RGHG7(:,85,10) = (/ &
  & 0.29888108E-07_JPRB, 0.30223628E-07_JPRB, 0.29411683E-07_JPRB, 0.29076042E-07_JPRB, 0.28278501E-07_JPRB, 0.26537302E-07_JPRB, &
  & 0.24684110E-07_JPRB, 0.21994921E-07_JPRB, 0.19365705E-07_JPRB, 0.17778370E-07_JPRB, 0.17112970E-07_JPRB, 0.16661629E-07_JPRB, &
  & 0.16447748E-07_JPRB, 0.16239554E-07_JPRB, 0.16142771E-07_JPRB, 0.16224788E-07_JPRB, 0.16299381E-07_JPRB, 0.16391699E-07_JPRB, &
  & 0.16585223E-07_JPRB, 0.16888454E-07_JPRB, 0.17142757E-07_JPRB, 0.17427141E-07_JPRB, 0.17691123E-07_JPRB, 0.17968454E-07_JPRB, &
  & 0.18272412E-07_JPRB, 0.18179733E-07_JPRB, 0.17461722E-07_JPRB, 0.16683271E-07_JPRB, 0.16070765E-07_JPRB, 0.15190308E-07_JPRB, &
  & 0.14050257E-07_JPRB, 0.14509486E-07_JPRB, 0.13153916E-07_JPRB, 0.12230183E-07_JPRB, 0.13384580E-07_JPRB, 0.16276841E-07_JPRB, &
  & 0.18849070E-07_JPRB, 0.21260581E-07_JPRB, 0.23805399E-07_JPRB, 0.26793815E-07_JPRB, 0.29549932E-07_JPRB, 0.32079760E-07_JPRB, &
  & 0.34347613E-07_JPRB, 0.35686567E-07_JPRB, 0.36205398E-07_JPRB, 0.35574765E-07_JPRB, 0.34200101E-07_JPRB, 0.32785586E-07_JPRB, &
  & 0.31026615E-07_JPRB, 0.29610007E-07_JPRB, 0.28408621E-07_JPRB, 0.27396200E-07_JPRB, 0.26863835E-07_JPRB, 0.26125038E-07_JPRB, &
  & 0.26420817E-07_JPRB, 0.26823417E-07_JPRB, 0.28069262E-07_JPRB, 0.29463695E-07_JPRB, 0.29954215E-07_JPRB, 0.30699479E-07_JPRB, &
  & 0.30968516E-07_JPRB, 0.30818707E-07_JPRB, 0.30122507E-07_JPRB, 0.29713127E-07_JPRB  /)

RGHG7(:,86,10) = (/ &
  & 0.28244564E-07_JPRB, 0.28785952E-07_JPRB, 0.27887902E-07_JPRB, 0.27690993E-07_JPRB, 0.27153279E-07_JPRB, 0.25623960E-07_JPRB, &
  & 0.23987749E-07_JPRB, 0.21448403E-07_JPRB, 0.18984929E-07_JPRB, 0.17562420E-07_JPRB, 0.17002825E-07_JPRB, 0.16572225E-07_JPRB, &
  & 0.16369125E-07_JPRB, 0.16159883E-07_JPRB, 0.16054118E-07_JPRB, 0.16124345E-07_JPRB, 0.16200225E-07_JPRB, 0.16293447E-07_JPRB, &
  & 0.16467818E-07_JPRB, 0.16739006E-07_JPRB, 0.16963561E-07_JPRB, 0.17206835E-07_JPRB, 0.17439455E-07_JPRB, 0.17711794E-07_JPRB, &
  & 0.18021927E-07_JPRB, 0.17929973E-07_JPRB, 0.17220181E-07_JPRB, 0.16504381E-07_JPRB, 0.15887539E-07_JPRB, 0.15017329E-07_JPRB, &
  & 0.13900199E-07_JPRB, 0.14315588E-07_JPRB, 0.12957284E-07_JPRB, 0.12090178E-07_JPRB, 0.13263771E-07_JPRB, 0.16147001E-07_JPRB, &
  & 0.18692822E-07_JPRB, 0.21048236E-07_JPRB, 0.23519992E-07_JPRB, 0.26460903E-07_JPRB, 0.29196338E-07_JPRB, 0.31675782E-07_JPRB, &
  & 0.34011458E-07_JPRB, 0.35324337E-07_JPRB, 0.35785056E-07_JPRB, 0.35099995E-07_JPRB, 0.33709123E-07_JPRB, 0.32263874E-07_JPRB, &
  & 0.30472986E-07_JPRB, 0.28993263E-07_JPRB, 0.27768282E-07_JPRB, 0.26806309E-07_JPRB, 0.26343022E-07_JPRB, 0.25546796E-07_JPRB, &
  & 0.25746797E-07_JPRB, 0.25992618E-07_JPRB, 0.27270487E-07_JPRB, 0.28767170E-07_JPRB, 0.29182948E-07_JPRB, 0.29678320E-07_JPRB, &
  & 0.29528003E-07_JPRB, 0.29098726E-07_JPRB, 0.27991856E-07_JPRB, 0.27432472E-07_JPRB  /)

RGHG7(:,87,10) = (/ &
  & 0.26135595E-07_JPRB, 0.26984996E-07_JPRB, 0.26040546E-07_JPRB, 0.25926569E-07_JPRB, 0.25897569E-07_JPRB, 0.24597334E-07_JPRB, &
  & 0.23201810E-07_JPRB, 0.20893577E-07_JPRB, 0.18655907E-07_JPRB, 0.17391714E-07_JPRB, 0.16916317E-07_JPRB, 0.16497189E-07_JPRB, &
  & 0.16302768E-07_JPRB, 0.16090014E-07_JPRB, 0.15976235E-07_JPRB, 0.16030991E-07_JPRB, 0.16108156E-07_JPRB, 0.16200463E-07_JPRB, &
  & 0.16356616E-07_JPRB, 0.16585309E-07_JPRB, 0.16777220E-07_JPRB, 0.16983899E-07_JPRB, 0.17186332E-07_JPRB, 0.17463224E-07_JPRB, &
  & 0.17769478E-07_JPRB, 0.17676555E-07_JPRB, 0.16997815E-07_JPRB, 0.16328778E-07_JPRB, 0.15698121E-07_JPRB, 0.14826693E-07_JPRB, &
  & 0.13738935E-07_JPRB, 0.14084864E-07_JPRB, 0.12735579E-07_JPRB, 0.11927051E-07_JPRB, 0.13109132E-07_JPRB, 0.15971053E-07_JPRB, &
  & 0.18484528E-07_JPRB, 0.20766504E-07_JPRB, 0.23155862E-07_JPRB, 0.26027873E-07_JPRB, 0.28678922E-07_JPRB, 0.31059528E-07_JPRB, &
  & 0.33469520E-07_JPRB, 0.34773770E-07_JPRB, 0.35179780E-07_JPRB, 0.34435630E-07_JPRB, 0.33047329E-07_JPRB, 0.31580033E-07_JPRB, &
  & 0.29781281E-07_JPRB, 0.28269819E-07_JPRB, 0.27062487E-07_JPRB, 0.26191108E-07_JPRB, 0.25826442E-07_JPRB, 0.24973444E-07_JPRB, &
  & 0.25096798E-07_JPRB, 0.25201781E-07_JPRB, 0.26469258E-07_JPRB, 0.28047950E-07_JPRB, 0.28481310E-07_JPRB, 0.28807846E-07_JPRB, &
  & 0.28255170E-07_JPRB, 0.27474063E-07_JPRB, 0.25861284E-07_JPRB, 0.25431895E-07_JPRB  /)

RGHG7(:,88,10) = (/ &
  & 0.23445283E-07_JPRB, 0.24708519E-07_JPRB, 0.23767593E-07_JPRB, 0.23705871E-07_JPRB, 0.24479790E-07_JPRB, 0.23436326E-07_JPRB, &
  & 0.22325133E-07_JPRB, 0.20331769E-07_JPRB, 0.18361966E-07_JPRB, 0.17246841E-07_JPRB, 0.16841221E-07_JPRB, 0.16431317E-07_JPRB, &
  & 0.16245934E-07_JPRB, 0.16027065E-07_JPRB, 0.15906531E-07_JPRB, 0.15942763E-07_JPRB, 0.16018548E-07_JPRB, 0.16106754E-07_JPRB, &
  & 0.16242018E-07_JPRB, 0.16420869E-07_JPRB, 0.16572720E-07_JPRB, 0.16744806E-07_JPRB, 0.16912439E-07_JPRB, 0.17201069E-07_JPRB, &
  & 0.17490329E-07_JPRB, 0.17395160E-07_JPRB, 0.16760630E-07_JPRB, 0.16132734E-07_JPRB, 0.15479575E-07_JPRB, 0.14596614E-07_JPRB, &
  & 0.13540497E-07_JPRB, 0.13781678E-07_JPRB, 0.12439677E-07_JPRB, 0.11710989E-07_JPRB, 0.12889016E-07_JPRB, 0.15701614E-07_JPRB, &
  & 0.18177831E-07_JPRB, 0.20358375E-07_JPRB, 0.22645723E-07_JPRB, 0.25420204E-07_JPRB, 0.27896106E-07_JPRB, 0.30147484E-07_JPRB, &
  & 0.32598532E-07_JPRB, 0.33884272E-07_JPRB, 0.34227374E-07_JPRB, 0.33440939E-07_JPRB, 0.32077552E-07_JPRB, 0.30612821E-07_JPRB, &
  & 0.28832588E-07_JPRB, 0.27332433E-07_JPRB, 0.26210435E-07_JPRB, 0.25500580E-07_JPRB, 0.25267324E-07_JPRB, 0.24373733E-07_JPRB, &
  & 0.24423206E-07_JPRB, 0.24407696E-07_JPRB, 0.25595397E-07_JPRB, 0.27230723E-07_JPRB, 0.27786860E-07_JPRB, 0.27987810E-07_JPRB, &
  & 0.27079010E-07_JPRB, 0.25890810E-07_JPRB, 0.23888697E-07_JPRB, 0.23849366E-07_JPRB  /)

RGHG7(:,89,10) = (/ &
  & 0.20347885E-07_JPRB, 0.22069689E-07_JPRB, 0.21132610E-07_JPRB, 0.21133128E-07_JPRB, 0.22880785E-07_JPRB, 0.22171762E-07_JPRB, &
  & 0.21425119E-07_JPRB, 0.19805760E-07_JPRB, 0.18093436E-07_JPRB, 0.17118287E-07_JPRB, 0.16773599E-07_JPRB, 0.16371073E-07_JPRB, &
  & 0.16196175E-07_JPRB, 0.15968894E-07_JPRB, 0.15842702E-07_JPRB, 0.15860489E-07_JPRB, 0.15930016E-07_JPRB, 0.16010620E-07_JPRB, &
  & 0.16114803E-07_JPRB, 0.16244648E-07_JPRB, 0.16344185E-07_JPRB, 0.16474538E-07_JPRB, 0.16594846E-07_JPRB, 0.16885369E-07_JPRB, &
  & 0.17146613E-07_JPRB, 0.17060886E-07_JPRB, 0.16474976E-07_JPRB, 0.15890863E-07_JPRB, 0.15210680E-07_JPRB, 0.14308519E-07_JPRB, &
  & 0.13280672E-07_JPRB, 0.13377068E-07_JPRB, 0.12029242E-07_JPRB, 0.11409878E-07_JPRB, 0.12567396E-07_JPRB, 0.15281772E-07_JPRB, &
  & 0.17740048E-07_JPRB, 0.19782657E-07_JPRB, 0.21920737E-07_JPRB, 0.24541542E-07_JPRB, 0.26722948E-07_JPRB, 0.28863104E-07_JPRB, &
  & 0.31256313E-07_JPRB, 0.32433877E-07_JPRB, 0.32679711E-07_JPRB, 0.31941171E-07_JPRB, 0.30621947E-07_JPRB, 0.29217647E-07_JPRB, &
  & 0.27484489E-07_JPRB, 0.26083369E-07_JPRB, 0.25154912E-07_JPRB, 0.24714368E-07_JPRB, 0.24633141E-07_JPRB, 0.23732058E-07_JPRB, &
  & 0.23679691E-07_JPRB, 0.23562355E-07_JPRB, 0.24584721E-07_JPRB, 0.26234975E-07_JPRB, 0.27051199E-07_JPRB, 0.27100462E-07_JPRB, &
  & 0.25853369E-07_JPRB, 0.24299430E-07_JPRB, 0.22432114E-07_JPRB, 0.22753026E-07_JPRB  /)

RGHG7(:,90,10) = (/ &
  & 0.17870956E-07_JPRB, 0.19966216E-07_JPRB, 0.18547358E-07_JPRB, 0.18660393E-07_JPRB, 0.21140063E-07_JPRB, 0.20880546E-07_JPRB, &
  & 0.20607882E-07_JPRB, 0.19341781E-07_JPRB, 0.17861570E-07_JPRB, 0.17004879E-07_JPRB, 0.16709733E-07_JPRB, 0.16313146E-07_JPRB, &
  & 0.16149227E-07_JPRB, 0.15911178E-07_JPRB, 0.15779387E-07_JPRB, 0.15781956E-07_JPRB, 0.15844551E-07_JPRB, 0.15910538E-07_JPRB, &
  & 0.15974963E-07_JPRB, 0.16045910E-07_JPRB, 0.16067996E-07_JPRB, 0.16148631E-07_JPRB, 0.16205929E-07_JPRB, 0.16483838E-07_JPRB, &
  & 0.16712828E-07_JPRB, 0.16653710E-07_JPRB, 0.16107887E-07_JPRB, 0.15580318E-07_JPRB, 0.14877898E-07_JPRB, 0.13975013E-07_JPRB, &
  & 0.12971520E-07_JPRB, 0.12902791E-07_JPRB, 0.11598159E-07_JPRB, 0.11069220E-07_JPRB, 0.12147296E-07_JPRB, 0.14707727E-07_JPRB, &
  & 0.17179886E-07_JPRB, 0.19088824E-07_JPRB, 0.20990043E-07_JPRB, 0.23312512E-07_JPRB, 0.25107113E-07_JPRB, 0.27177856E-07_JPRB, &
  & 0.29294960E-07_JPRB, 0.30151509E-07_JPRB, 0.30207085E-07_JPRB, 0.29792903E-07_JPRB, 0.28606214E-07_JPRB, 0.27297692E-07_JPRB, &
  & 0.25676594E-07_JPRB, 0.24547286E-07_JPRB, 0.23976518E-07_JPRB, 0.23905677E-07_JPRB, 0.23968014E-07_JPRB, 0.23084599E-07_JPRB, &
  & 0.22853494E-07_JPRB, 0.22616953E-07_JPRB, 0.23399552E-07_JPRB, 0.25015349E-07_JPRB, 0.26280888E-07_JPRB, 0.26206395E-07_JPRB, &
  & 0.24546079E-07_JPRB, 0.22613961E-07_JPRB, 0.21532784E-07_JPRB, 0.22025356E-07_JPRB  /)

RGHG7(:,91,10) = (/ &
  & 0.16281405E-07_JPRB, 0.18833629E-07_JPRB, 0.16898042E-07_JPRB, 0.16669941E-07_JPRB, 0.19442354E-07_JPRB, 0.19825706E-07_JPRB, &
  & 0.19885187E-07_JPRB, 0.18942768E-07_JPRB, 0.17642645E-07_JPRB, 0.16890675E-07_JPRB, 0.16632288E-07_JPRB, 0.16239932E-07_JPRB, &
  & 0.16086591E-07_JPRB, 0.15844574E-07_JPRB, 0.15704057E-07_JPRB, 0.15684412E-07_JPRB, 0.15741983E-07_JPRB, 0.15789459E-07_JPRB, &
  & 0.15820564E-07_JPRB, 0.15788640E-07_JPRB, 0.15732979E-07_JPRB, 0.15740892E-07_JPRB, 0.15763811E-07_JPRB, 0.15994914E-07_JPRB, &
  & 0.16183179E-07_JPRB, 0.16169810E-07_JPRB, 0.15637209E-07_JPRB, 0.15199288E-07_JPRB, 0.14527808E-07_JPRB, 0.13632592E-07_JPRB, &
  & 0.12664799E-07_JPRB, 0.12408048E-07_JPRB, 0.11244896E-07_JPRB, 0.10745310E-07_JPRB, 0.11713376E-07_JPRB, 0.14102710E-07_JPRB, &
  & 0.16631196E-07_JPRB, 0.18474287E-07_JPRB, 0.20152578E-07_JPRB, 0.22113812E-07_JPRB, 0.23472870E-07_JPRB, 0.25520871E-07_JPRB, &
  & 0.27047730E-07_JPRB, 0.27468736E-07_JPRB, 0.27504479E-07_JPRB, 0.27159053E-07_JPRB, 0.26322227E-07_JPRB, 0.24998366E-07_JPRB, &
  & 0.23691695E-07_JPRB, 0.22880517E-07_JPRB, 0.22894705E-07_JPRB, 0.23101797E-07_JPRB, 0.23236857E-07_JPRB, 0.22407125E-07_JPRB, &
  & 0.21909722E-07_JPRB, 0.21544924E-07_JPRB, 0.22089256E-07_JPRB, 0.23945171E-07_JPRB, 0.25573530E-07_JPRB, 0.25455933E-07_JPRB, &
  & 0.23305069E-07_JPRB, 0.21087084E-07_JPRB, 0.20997317E-07_JPRB, 0.21518184E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ---GEMS----

RGHG7(:, 1,11) = (/ &
  & 0.19546465E-06_JPRB, 0.13800866E-06_JPRB, 0.11801129E-06_JPRB, 0.10077249E-06_JPRB, 0.91063100E-07_JPRB, 0.82920941E-07_JPRB, &
  & 0.77615496E-07_JPRB, 0.73615425E-07_JPRB, 0.71258249E-07_JPRB, 0.70014018E-07_JPRB, 0.70006649E-07_JPRB, 0.70076105E-07_JPRB, &
  & 0.70415695E-07_JPRB, 0.70806536E-07_JPRB, 0.71039217E-07_JPRB, 0.71347138E-07_JPRB, 0.71358741E-07_JPRB, 0.71415187E-07_JPRB, &
  & 0.71162980E-07_JPRB, 0.70854568E-07_JPRB, 0.70510126E-07_JPRB, 0.70319849E-07_JPRB, 0.70006934E-07_JPRB, 0.69650149E-07_JPRB, &
  & 0.69329374E-07_JPRB, 0.69009516E-07_JPRB, 0.68748307E-07_JPRB, 0.68412149E-07_JPRB, 0.68067017E-07_JPRB, 0.67803732E-07_JPRB, &
  & 0.67678606E-07_JPRB, 0.67726383E-07_JPRB, 0.67967292E-07_JPRB, 0.68455819E-07_JPRB, 0.68989131E-07_JPRB, 0.69496672E-07_JPRB, &
  & 0.69872677E-07_JPRB, 0.70012369E-07_JPRB, 0.69893957E-07_JPRB, 0.69676219E-07_JPRB, 0.69159917E-07_JPRB, 0.68598816E-07_JPRB, &
  & 0.68025905E-07_JPRB, 0.67387845E-07_JPRB, 0.66771690E-07_JPRB, 0.66223301E-07_JPRB, 0.65688276E-07_JPRB, 0.65196438E-07_JPRB, &
  & 0.64776749E-07_JPRB, 0.64522091E-07_JPRB, 0.64403231E-07_JPRB, 0.64495225E-07_JPRB, 0.64754815E-07_JPRB, 0.65224050E-07_JPRB, &
  & 0.65953209E-07_JPRB, 0.67346356E-07_JPRB, 0.59405897E-05_JPRB, 0.59620347E-05_JPRB, 0.59632353E-05_JPRB, 0.59645954E-05_JPRB, &
  & 0.59626509E-05_JPRB, 0.59707004E-05_JPRB, 0.59565750E-05_JPRB, 0.59258650E-05_JPRB  /)

RGHG7(:, 2,11) = (/ &
  & 0.79857870E-06_JPRB, 0.10183896E-05_JPRB, 0.99954025E-06_JPRB, 0.88380358E-06_JPRB, 0.76436402E-06_JPRB, 0.64844664E-06_JPRB, &
  & 0.53967875E-06_JPRB, 0.43985980E-06_JPRB, 0.35743247E-06_JPRB, 0.29851296E-06_JPRB, 0.27800314E-06_JPRB, 0.26102086E-06_JPRB, &
  & 0.25012321E-06_JPRB, 0.24390010E-06_JPRB, 0.23517131E-06_JPRB, 0.23306042E-06_JPRB, 0.22632581E-06_JPRB, 0.22581216E-06_JPRB, &
  & 0.22088263E-06_JPRB, 0.21715462E-06_JPRB, 0.21541612E-06_JPRB, 0.21906227E-06_JPRB, 0.21990265E-06_JPRB, 0.21992271E-06_JPRB, &
  & 0.22006903E-06_JPRB, 0.22023455E-06_JPRB, 0.22450972E-06_JPRB, 0.22535319E-06_JPRB, 0.22448103E-06_JPRB, 0.22358479E-06_JPRB, &
  & 0.22280661E-06_JPRB, 0.22243377E-06_JPRB, 0.22291327E-06_JPRB, 0.22976803E-06_JPRB, 0.23164829E-06_JPRB, 0.23061642E-06_JPRB, &
  & 0.22815240E-06_JPRB, 0.22428122E-06_JPRB, 0.21995208E-06_JPRB, 0.22007310E-06_JPRB, 0.21646531E-06_JPRB, 0.21492254E-06_JPRB, &
  & 0.21230080E-06_JPRB, 0.20988112E-06_JPRB, 0.21033752E-06_JPRB, 0.21343901E-06_JPRB, 0.21571894E-06_JPRB, 0.21810369E-06_JPRB, &
  & 0.21792196E-06_JPRB, 0.21723757E-06_JPRB, 0.21194639E-06_JPRB, 0.20411233E-06_JPRB, 0.19226549E-06_JPRB, 0.18086909E-06_JPRB, &
  & 0.17084494E-06_JPRB, 0.16729442E-06_JPRB, 0.52036021E-05_JPRB, 0.51228326E-05_JPRB, 0.50422900E-05_JPRB, 0.49246132E-05_JPRB, &
  & 0.47432354E-05_JPRB, 0.45668348E-05_JPRB, 0.43165455E-05_JPRB, 0.39043457E-05_JPRB  /)

RGHG7(:, 3,11) = (/ &
  & 0.10167822E-05_JPRB, 0.13059671E-05_JPRB, 0.12933401E-05_JPRB, 0.11926720E-05_JPRB, 0.10804195E-05_JPRB, 0.96306394E-06_JPRB, &
  & 0.84939666E-06_JPRB, 0.72866754E-06_JPRB, 0.62099616E-06_JPRB, 0.54281020E-06_JPRB, 0.52361253E-06_JPRB, 0.49037675E-06_JPRB, &
  & 0.47626935E-06_JPRB, 0.45853122E-06_JPRB, 0.44804668E-06_JPRB, 0.44068793E-06_JPRB, 0.43295148E-06_JPRB, 0.43148506E-06_JPRB, &
  & 0.42153215E-06_JPRB, 0.41660897E-06_JPRB, 0.41622903E-06_JPRB, 0.42320826E-06_JPRB, 0.42122264E-06_JPRB, 0.41996458E-06_JPRB, &
  & 0.41859948E-06_JPRB, 0.41982440E-06_JPRB, 0.42717633E-06_JPRB, 0.42542010E-06_JPRB, 0.42225744E-06_JPRB, 0.41858951E-06_JPRB, &
  & 0.41552235E-06_JPRB, 0.41387554E-06_JPRB, 0.41549742E-06_JPRB, 0.42407444E-06_JPRB, 0.42229163E-06_JPRB, 0.41792845E-06_JPRB, &
  & 0.41210279E-06_JPRB, 0.40628856E-06_JPRB, 0.40193294E-06_JPRB, 0.40361851E-06_JPRB, 0.39667049E-06_JPRB, 0.38980380E-06_JPRB, &
  & 0.38384459E-06_JPRB, 0.37967826E-06_JPRB, 0.37752204E-06_JPRB, 0.37943991E-06_JPRB, 0.37555273E-06_JPRB, 0.36755955E-06_JPRB, &
  & 0.35469731E-06_JPRB, 0.34130593E-06_JPRB, 0.32394064E-06_JPRB, 0.30813766E-06_JPRB, 0.28721107E-06_JPRB, 0.26648351E-06_JPRB, &
  & 0.25030820E-06_JPRB, 0.25497596E-06_JPRB, 0.29686773E-05_JPRB, 0.30278773E-05_JPRB, 0.29611490E-05_JPRB, 0.28699205E-05_JPRB, &
  & 0.27535330E-05_JPRB, 0.26488322E-05_JPRB, 0.24806384E-05_JPRB, 0.22391371E-05_JPRB  /)

RGHG7(:, 4,11) = (/ &
  & 0.88926086E-06_JPRB, 0.10067139E-05_JPRB, 0.10213205E-05_JPRB, 0.10136051E-05_JPRB, 0.10111418E-05_JPRB, 0.99414961E-06_JPRB, &
  & 0.96888252E-06_JPRB, 0.93877103E-06_JPRB, 0.93335546E-06_JPRB, 0.94671505E-06_JPRB, 0.95700274E-06_JPRB, 0.95470627E-06_JPRB, &
  & 0.95047753E-06_JPRB, 0.93983935E-06_JPRB, 0.93517569E-06_JPRB, 0.92705993E-06_JPRB, 0.92052625E-06_JPRB, 0.91377881E-06_JPRB, &
  & 0.89784426E-06_JPRB, 0.88505102E-06_JPRB, 0.87731749E-06_JPRB, 0.87580116E-06_JPRB, 0.86619747E-06_JPRB, 0.86105062E-06_JPRB, &
  & 0.85451914E-06_JPRB, 0.85184345E-06_JPRB, 0.85265864E-06_JPRB, 0.84651600E-06_JPRB, 0.84290632E-06_JPRB, 0.83828106E-06_JPRB, &
  & 0.83434117E-06_JPRB, 0.83770176E-06_JPRB, 0.85131195E-06_JPRB, 0.87595159E-06_JPRB, 0.90243657E-06_JPRB, 0.93551159E-06_JPRB, &
  & 0.96894996E-06_JPRB, 0.99598751E-06_JPRB, 0.10323801E-05_JPRB, 0.10708554E-05_JPRB, 0.10912112E-05_JPRB, 0.11055110E-05_JPRB, &
  & 0.11138924E-05_JPRB, 0.11311461E-05_JPRB, 0.11499876E-05_JPRB, 0.11836140E-05_JPRB, 0.12322306E-05_JPRB, 0.12903872E-05_JPRB, &
  & 0.13656557E-05_JPRB, 0.14438877E-05_JPRB, 0.15246193E-05_JPRB, 0.15897768E-05_JPRB, 0.16454484E-05_JPRB, 0.16823740E-05_JPRB, &
  & 0.17007866E-05_JPRB, 0.17146604E-05_JPRB, 0.24960203E-05_JPRB, 0.24993589E-05_JPRB, 0.25010268E-05_JPRB, 0.25020894E-05_JPRB, &
  & 0.24961733E-05_JPRB, 0.24852390E-05_JPRB, 0.24760867E-05_JPRB, 0.24430581E-05_JPRB  /)

RGHG7(:, 5,11) = (/ &
  & 0.67980459E-06_JPRB, 0.74104979E-06_JPRB, 0.80714821E-06_JPRB, 0.89194009E-06_JPRB, 0.99541665E-06_JPRB, 0.10750220E-05_JPRB, &
  & 0.11150037E-05_JPRB, 0.11274364E-05_JPRB, 0.11432846E-05_JPRB, 0.11802310E-05_JPRB, 0.11983613E-05_JPRB, 0.12054071E-05_JPRB, &
  & 0.11983027E-05_JPRB, 0.11861686E-05_JPRB, 0.11702684E-05_JPRB, 0.11570847E-05_JPRB, 0.11415388E-05_JPRB, 0.11282261E-05_JPRB, &
  & 0.11104868E-05_JPRB, 0.10903879E-05_JPRB, 0.10726849E-05_JPRB, 0.10583423E-05_JPRB, 0.10480687E-05_JPRB, 0.10406640E-05_JPRB, &
  & 0.10327266E-05_JPRB, 0.10255308E-05_JPRB, 0.10184004E-05_JPRB, 0.10147536E-05_JPRB, 0.10132322E-05_JPRB, 0.10116161E-05_JPRB, &
  & 0.10126035E-05_JPRB, 0.10261015E-05_JPRB, 0.10556477E-05_JPRB, 0.11048449E-05_JPRB, 0.11756859E-05_JPRB, 0.12583980E-05_JPRB, &
  & 0.13399539E-05_JPRB, 0.14039574E-05_JPRB, 0.14726415E-05_JPRB, 0.15367087E-05_JPRB, 0.15828329E-05_JPRB, 0.16179031E-05_JPRB, &
  & 0.16471700E-05_JPRB, 0.16912830E-05_JPRB, 0.17355123E-05_JPRB, 0.18066925E-05_JPRB, 0.19155379E-05_JPRB, 0.20527514E-05_JPRB, &
  & 0.22210638E-05_JPRB, 0.23910208E-05_JPRB, 0.25709967E-05_JPRB, 0.27229746E-05_JPRB, 0.28574649E-05_JPRB, 0.29510221E-05_JPRB, &
  & 0.29992689E-05_JPRB, 0.29983724E-05_JPRB, 0.29693481E-05_JPRB, 0.29782629E-05_JPRB, 0.30317534E-05_JPRB, 0.31038340E-05_JPRB, &
  & 0.31692401E-05_JPRB, 0.32364039E-05_JPRB, 0.33070582E-05_JPRB, 0.33416514E-05_JPRB  /)

RGHG7(:, 6,11) = (/ &
  & 0.78962742E-06_JPRB, 0.83710098E-06_JPRB, 0.89183781E-06_JPRB, 0.97364583E-06_JPRB, 0.10720345E-05_JPRB, 0.11445245E-05_JPRB, &
  & 0.11777735E-05_JPRB, 0.11798391E-05_JPRB, 0.11891076E-05_JPRB, 0.12269721E-05_JPRB, 0.12482392E-05_JPRB, 0.12616353E-05_JPRB, &
  & 0.12580504E-05_JPRB, 0.12474847E-05_JPRB, 0.12296718E-05_JPRB, 0.12164115E-05_JPRB, 0.12061447E-05_JPRB, 0.12006742E-05_JPRB, &
  & 0.11907389E-05_JPRB, 0.11789795E-05_JPRB, 0.11666704E-05_JPRB, 0.11558854E-05_JPRB, 0.11490930E-05_JPRB, 0.11439453E-05_JPRB, &
  & 0.11383032E-05_JPRB, 0.11356214E-05_JPRB, 0.11319722E-05_JPRB, 0.11297408E-05_JPRB, 0.11287550E-05_JPRB, 0.11273302E-05_JPRB, &
  & 0.11323343E-05_JPRB, 0.11480128E-05_JPRB, 0.11817669E-05_JPRB, 0.12400305E-05_JPRB, 0.13201290E-05_JPRB, 0.14107599E-05_JPRB, &
  & 0.14948406E-05_JPRB, 0.15578494E-05_JPRB, 0.16106580E-05_JPRB, 0.16542207E-05_JPRB, 0.16841632E-05_JPRB, 0.17031282E-05_JPRB, &
  & 0.17239791E-05_JPRB, 0.17589111E-05_JPRB, 0.17933089E-05_JPRB, 0.18593630E-05_JPRB, 0.19675198E-05_JPRB, 0.21164775E-05_JPRB, &
  & 0.22906045E-05_JPRB, 0.24656111E-05_JPRB, 0.26474998E-05_JPRB, 0.27986361E-05_JPRB, 0.29257815E-05_JPRB, 0.30207159E-05_JPRB, &
  & 0.30693452E-05_JPRB, 0.30572784E-05_JPRB, 0.30287132E-05_JPRB, 0.30333817E-05_JPRB, 0.30860306E-05_JPRB, 0.31506134E-05_JPRB, &
  & 0.32199597E-05_JPRB, 0.32925173E-05_JPRB, 0.33669206E-05_JPRB, 0.33972293E-05_JPRB  /)

RGHG7(:, 7,11) = (/ &
  & 0.10059198E-05_JPRB, 0.10447137E-05_JPRB, 0.10928234E-05_JPRB, 0.11656430E-05_JPRB, 0.12496308E-05_JPRB, 0.13026677E-05_JPRB, &
  & 0.13188324E-05_JPRB, 0.13143282E-05_JPRB, 0.13318497E-05_JPRB, 0.13768311E-05_JPRB, 0.14010857E-05_JPRB, 0.14186783E-05_JPRB, &
  & 0.14190094E-05_JPRB, 0.14125999E-05_JPRB, 0.13998774E-05_JPRB, 0.13935023E-05_JPRB, 0.13905934E-05_JPRB, 0.13947302E-05_JPRB, &
  & 0.13955750E-05_JPRB, 0.13938444E-05_JPRB, 0.13919652E-05_JPRB, 0.13885935E-05_JPRB, 0.13858861E-05_JPRB, 0.13828997E-05_JPRB, &
  & 0.13818685E-05_JPRB, 0.13867390E-05_JPRB, 0.13889643E-05_JPRB, 0.13916962E-05_JPRB, 0.13969423E-05_JPRB, 0.14073298E-05_JPRB, &
  & 0.14241349E-05_JPRB, 0.14462409E-05_JPRB, 0.14833565E-05_JPRB, 0.15410174E-05_JPRB, 0.16160019E-05_JPRB, 0.16935113E-05_JPRB, &
  & 0.17635993E-05_JPRB, 0.18029380E-05_JPRB, 0.18283859E-05_JPRB, 0.18487163E-05_JPRB, 0.18618161E-05_JPRB, 0.18726352E-05_JPRB, &
  & 0.18912590E-05_JPRB, 0.19269078E-05_JPRB, 0.19647214E-05_JPRB, 0.20396326E-05_JPRB, 0.21617872E-05_JPRB, 0.23206138E-05_JPRB, &
  & 0.25012164E-05_JPRB, 0.26707592E-05_JPRB, 0.28492159E-05_JPRB, 0.29917625E-05_JPRB, 0.31072342E-05_JPRB, 0.31871798E-05_JPRB, &
  & 0.32179259E-05_JPRB, 0.31899631E-05_JPRB, 0.31592823E-05_JPRB, 0.31631153E-05_JPRB, 0.32180425E-05_JPRB, 0.32778254E-05_JPRB, &
  & 0.33472644E-05_JPRB, 0.34168524E-05_JPRB, 0.34838569E-05_JPRB, 0.35086544E-05_JPRB  /)

RGHG7(:, 8,11) = (/ &
  & 0.13311529E-05_JPRB, 0.13654330E-05_JPRB, 0.14087415E-05_JPRB, 0.14732073E-05_JPRB, 0.15460281E-05_JPRB, 0.15837799E-05_JPRB, &
  & 0.15912066E-05_JPRB, 0.15896572E-05_JPRB, 0.16185125E-05_JPRB, 0.16718035E-05_JPRB, 0.17001806E-05_JPRB, 0.17245023E-05_JPRB, &
  & 0.17325876E-05_JPRB, 0.17365183E-05_JPRB, 0.17327766E-05_JPRB, 0.17356208E-05_JPRB, 0.17396973E-05_JPRB, 0.17510942E-05_JPRB, &
  & 0.17616893E-05_JPRB, 0.17700629E-05_JPRB, 0.17799215E-05_JPRB, 0.17860847E-05_JPRB, 0.17907789E-05_JPRB, 0.17939093E-05_JPRB, &
  & 0.17994843E-05_JPRB, 0.18111134E-05_JPRB, 0.18210258E-05_JPRB, 0.18335388E-05_JPRB, 0.18498936E-05_JPRB, 0.18741863E-05_JPRB, &
  & 0.19021424E-05_JPRB, 0.19286266E-05_JPRB, 0.19594898E-05_JPRB, 0.19990716E-05_JPRB, 0.20479359E-05_JPRB, 0.20926315E-05_JPRB, &
  & 0.21302161E-05_JPRB, 0.21385844E-05_JPRB, 0.21416409E-05_JPRB, 0.21477468E-05_JPRB, 0.21533462E-05_JPRB, 0.21676685E-05_JPRB, &
  & 0.21977887E-05_JPRB, 0.22521631E-05_JPRB, 0.23136919E-05_JPRB, 0.24112150E-05_JPRB, 0.25513924E-05_JPRB, 0.27147246E-05_JPRB, &
  & 0.28909936E-05_JPRB, 0.30498432E-05_JPRB, 0.32114654E-05_JPRB, 0.33394954E-05_JPRB, 0.34391982E-05_JPRB, 0.34901808E-05_JPRB, &
  & 0.34869691E-05_JPRB, 0.34333856E-05_JPRB, 0.33873710E-05_JPRB, 0.33841322E-05_JPRB, 0.34319665E-05_JPRB, 0.34885757E-05_JPRB, &
  & 0.35427879E-05_JPRB, 0.35985282E-05_JPRB, 0.36444213E-05_JPRB, 0.36683033E-05_JPRB  /)

RGHG7(:, 9,11) = (/ &
  & 0.17922454E-05_JPRB, 0.18239691E-05_JPRB, 0.18631444E-05_JPRB, 0.19218357E-05_JPRB, 0.19902737E-05_JPRB, 0.20254933E-05_JPRB, &
  & 0.20404234E-05_JPRB, 0.20551119E-05_JPRB, 0.20966434E-05_JPRB, 0.21604479E-05_JPRB, 0.21982827E-05_JPRB, 0.22345973E-05_JPRB, &
  & 0.22560768E-05_JPRB, 0.22768661E-05_JPRB, 0.22852004E-05_JPRB, 0.22973914E-05_JPRB, 0.23058010E-05_JPRB, 0.23192096E-05_JPRB, &
  & 0.23344220E-05_JPRB, 0.23496587E-05_JPRB, 0.23700561E-05_JPRB, 0.23882967E-05_JPRB, 0.24069530E-05_JPRB, 0.24233671E-05_JPRB, &
  & 0.24379589E-05_JPRB, 0.24537514E-05_JPRB, 0.24702823E-05_JPRB, 0.24915429E-05_JPRB, 0.25161913E-05_JPRB, 0.25446994E-05_JPRB, &
  & 0.25715050E-05_JPRB, 0.25936638E-05_JPRB, 0.26101242E-05_JPRB, 0.26208914E-05_JPRB, 0.26309661E-05_JPRB, 0.26355634E-05_JPRB, &
  & 0.26367337E-05_JPRB, 0.26227567E-05_JPRB, 0.26216096E-05_JPRB, 0.26360230E-05_JPRB, 0.26594851E-05_JPRB, 0.27034311E-05_JPRB, &
  & 0.27673602E-05_JPRB, 0.28635820E-05_JPRB, 0.29708031E-05_JPRB, 0.31067254E-05_JPRB, 0.32664842E-05_JPRB, 0.34236455E-05_JPRB, &
  & 0.35787748E-05_JPRB, 0.37146207E-05_JPRB, 0.38401843E-05_JPRB, 0.39383360E-05_JPRB, 0.40043871E-05_JPRB, 0.40048507E-05_JPRB, &
  & 0.39406990E-05_JPRB, 0.38411093E-05_JPRB, 0.37558700E-05_JPRB, 0.37221942E-05_JPRB, 0.37373922E-05_JPRB, 0.37790955E-05_JPRB, &
  & 0.38027662E-05_JPRB, 0.38256890E-05_JPRB, 0.38349821E-05_JPRB, 0.38530359E-05_JPRB  /)

RGHG7(:,10,11) = (/ &
  & 0.23951009E-05_JPRB, 0.24167738E-05_JPRB, 0.24499096E-05_JPRB, 0.25002651E-05_JPRB, 0.25599016E-05_JPRB, 0.25945347E-05_JPRB, &
  & 0.26233064E-05_JPRB, 0.26670626E-05_JPRB, 0.27322600E-05_JPRB, 0.28187757E-05_JPRB, 0.28791721E-05_JPRB, 0.29375030E-05_JPRB, &
  & 0.29795233E-05_JPRB, 0.30197187E-05_JPRB, 0.30404466E-05_JPRB, 0.30601068E-05_JPRB, 0.30680464E-05_JPRB, 0.30786859E-05_JPRB, &
  & 0.30921530E-05_JPRB, 0.31085151E-05_JPRB, 0.31376729E-05_JPRB, 0.31712039E-05_JPRB, 0.32103429E-05_JPRB, 0.32470833E-05_JPRB, &
  & 0.32761702E-05_JPRB, 0.32962564E-05_JPRB, 0.33130575E-05_JPRB, 0.33298853E-05_JPRB, 0.33477633E-05_JPRB, 0.33633999E-05_JPRB, &
  & 0.33749024E-05_JPRB, 0.33843188E-05_JPRB, 0.33912357E-05_JPRB, 0.33900939E-05_JPRB, 0.33845180E-05_JPRB, 0.33771524E-05_JPRB, &
  & 0.33741836E-05_JPRB, 0.33712363E-05_JPRB, 0.33963816E-05_JPRB, 0.34510951E-05_JPRB, 0.35274620E-05_JPRB, 0.36342820E-05_JPRB, &
  & 0.37561544E-05_JPRB, 0.39079408E-05_JPRB, 0.40647223E-05_JPRB, 0.42426493E-05_JPRB, 0.44242875E-05_JPRB, 0.45775924E-05_JPRB, &
  & 0.47088963E-05_JPRB, 0.47999787E-05_JPRB, 0.48566234E-05_JPRB, 0.48717159E-05_JPRB, 0.48343267E-05_JPRB, 0.47278855E-05_JPRB, &
  & 0.45595985E-05_JPRB, 0.43823315E-05_JPRB, 0.42374040E-05_JPRB, 0.41436934E-05_JPRB, 0.40957614E-05_JPRB, 0.40827493E-05_JPRB, &
  & 0.40642826E-05_JPRB, 0.40317798E-05_JPRB, 0.39931136E-05_JPRB, 0.39799232E-05_JPRB  /)

RGHG7(:,11,11) = (/ &
  & 0.31088918E-05_JPRB, 0.31154985E-05_JPRB, 0.31378145E-05_JPRB, 0.31730407E-05_JPRB, 0.32150072E-05_JPRB, 0.32414968E-05_JPRB, &
  & 0.32856577E-05_JPRB, 0.33736684E-05_JPRB, 0.34857537E-05_JPRB, 0.36178873E-05_JPRB, 0.37200166E-05_JPRB, 0.38160192E-05_JPRB, &
  & 0.38894315E-05_JPRB, 0.39535635E-05_JPRB, 0.39876696E-05_JPRB, 0.40124279E-05_JPRB, 0.40129959E-05_JPRB, 0.40181953E-05_JPRB, &
  & 0.40267059E-05_JPRB, 0.40387430E-05_JPRB, 0.40731206E-05_JPRB, 0.41191607E-05_JPRB, 0.41776766E-05_JPRB, 0.42380154E-05_JPRB, &
  & 0.42882494E-05_JPRB, 0.43126921E-05_JPRB, 0.43186897E-05_JPRB, 0.43142029E-05_JPRB, 0.43083587E-05_JPRB, 0.43028245E-05_JPRB, &
  & 0.43005876E-05_JPRB, 0.42985949E-05_JPRB, 0.42991763E-05_JPRB, 0.43019581E-05_JPRB, 0.43128013E-05_JPRB, 0.43367347E-05_JPRB, &
  & 0.43760978E-05_JPRB, 0.44338929E-05_JPRB, 0.45254277E-05_JPRB, 0.46515972E-05_JPRB, 0.47985593E-05_JPRB, 0.49697150E-05_JPRB, &
  & 0.51484592E-05_JPRB, 0.53349161E-05_JPRB, 0.55087954E-05_JPRB, 0.56890331E-05_JPRB, 0.58650165E-05_JPRB, 0.60064593E-05_JPRB, &
  & 0.60986485E-05_JPRB, 0.61099212E-05_JPRB, 0.60446351E-05_JPRB, 0.59062423E-05_JPRB, 0.56925677E-05_JPRB, 0.54363094E-05_JPRB, &
  & 0.51679274E-05_JPRB, 0.49183816E-05_JPRB, 0.47298007E-05_JPRB, 0.45850048E-05_JPRB, 0.44707331E-05_JPRB, 0.43797438E-05_JPRB, &
  & 0.43055666E-05_JPRB, 0.42181551E-05_JPRB, 0.41378191E-05_JPRB, 0.40820675E-05_JPRB  /)

RGHG7(:,12,11) = (/ &
  & 0.38776202E-05_JPRB, 0.38802026E-05_JPRB, 0.38953676E-05_JPRB, 0.39253145E-05_JPRB, 0.39697513E-05_JPRB, 0.40158410E-05_JPRB, &
  & 0.40988002E-05_JPRB, 0.42424917E-05_JPRB, 0.44142683E-05_JPRB, 0.46073428E-05_JPRB, 0.47726865E-05_JPRB, 0.49235101E-05_JPRB, &
  & 0.50436966E-05_JPRB, 0.51459544E-05_JPRB, 0.52100249E-05_JPRB, 0.52520658E-05_JPRB, 0.52558581E-05_JPRB, 0.52612319E-05_JPRB, &
  & 0.52642118E-05_JPRB, 0.52683434E-05_JPRB, 0.52975452E-05_JPRB, 0.53431253E-05_JPRB, 0.54123576E-05_JPRB, 0.54856415E-05_JPRB, &
  & 0.55434453E-05_JPRB, 0.55590030E-05_JPRB, 0.55383082E-05_JPRB, 0.54930317E-05_JPRB, 0.54405652E-05_JPRB, 0.53948678E-05_JPRB, &
  & 0.53615192E-05_JPRB, 0.53395048E-05_JPRB, 0.53276035E-05_JPRB, 0.53268534E-05_JPRB, 0.53591997E-05_JPRB, 0.54375203E-05_JPRB, &
  & 0.55484713E-05_JPRB, 0.56901221E-05_JPRB, 0.58560357E-05_JPRB, 0.60461127E-05_JPRB, 0.62363870E-05_JPRB, 0.64203637E-05_JPRB, &
  & 0.65896763E-05_JPRB, 0.67373614E-05_JPRB, 0.68620242E-05_JPRB, 0.69788680E-05_JPRB, 0.70784784E-05_JPRB, 0.71313288E-05_JPRB, &
  & 0.71124394E-05_JPRB, 0.70037369E-05_JPRB, 0.68123017E-05_JPRB, 0.65495409E-05_JPRB, 0.62370482E-05_JPRB, 0.59335861E-05_JPRB, &
  & 0.56652223E-05_JPRB, 0.54188952E-05_JPRB, 0.52291258E-05_JPRB, 0.50649486E-05_JPRB, 0.49133388E-05_JPRB, 0.47889777E-05_JPRB, &
  & 0.46852322E-05_JPRB, 0.45864781E-05_JPRB, 0.45146481E-05_JPRB, 0.44601429E-05_JPRB  /)

RGHG7(:,13,11) = (/ &
  & 0.45244586E-05_JPRB, 0.45347282E-05_JPRB, 0.45633499E-05_JPRB, 0.46091132E-05_JPRB, 0.46787595E-05_JPRB, 0.47726356E-05_JPRB, &
  & 0.49126750E-05_JPRB, 0.51145580E-05_JPRB, 0.53436820E-05_JPRB, 0.55938563E-05_JPRB, 0.58258843E-05_JPRB, 0.60421080E-05_JPRB, &
  & 0.62247385E-05_JPRB, 0.63861207E-05_JPRB, 0.65121808E-05_JPRB, 0.66152107E-05_JPRB, 0.66782430E-05_JPRB, 0.67208926E-05_JPRB, &
  & 0.67383843E-05_JPRB, 0.67464088E-05_JPRB, 0.67682586E-05_JPRB, 0.68014821E-05_JPRB, 0.68569815E-05_JPRB, 0.69041669E-05_JPRB, &
  & 0.69308193E-05_JPRB, 0.69128440E-05_JPRB, 0.68532927E-05_JPRB, 0.67565586E-05_JPRB, 0.66438245E-05_JPRB, 0.65375677E-05_JPRB, &
  & 0.64487548E-05_JPRB, 0.63855583E-05_JPRB, 0.63510776E-05_JPRB, 0.63486542E-05_JPRB, 0.64033653E-05_JPRB, 0.65308883E-05_JPRB, &
  & 0.67015841E-05_JPRB, 0.68929775E-05_JPRB, 0.70811083E-05_JPRB, 0.72643116E-05_JPRB, 0.74220420E-05_JPRB, 0.75428713E-05_JPRB, &
  & 0.76282838E-05_JPRB, 0.76821944E-05_JPRB, 0.77188212E-05_JPRB, 0.77472613E-05_JPRB, 0.77448350E-05_JPRB, 0.76860702E-05_JPRB, &
  & 0.75510644E-05_JPRB, 0.73502673E-05_JPRB, 0.70936944E-05_JPRB, 0.67888480E-05_JPRB, 0.64794569E-05_JPRB, 0.62135597E-05_JPRB, &
  & 0.59938954E-05_JPRB, 0.57943164E-05_JPRB, 0.56251253E-05_JPRB, 0.54647419E-05_JPRB, 0.53135258E-05_JPRB, 0.51891943E-05_JPRB, &
  & 0.50819387E-05_JPRB, 0.50141420E-05_JPRB, 0.49819170E-05_JPRB, 0.49600122E-05_JPRB  /)

RGHG7(:,14,11) = (/ &
  & 0.49559391E-05_JPRB, 0.49742401E-05_JPRB, 0.50195932E-05_JPRB, 0.50883888E-05_JPRB, 0.51933400E-05_JPRB, 0.53415441E-05_JPRB, &
  & 0.55340173E-05_JPRB, 0.57775727E-05_JPRB, 0.60409556E-05_JPRB, 0.63190042E-05_JPRB, 0.65832621E-05_JPRB, 0.68402754E-05_JPRB, &
  & 0.70819221E-05_JPRB, 0.73079183E-05_JPRB, 0.75081233E-05_JPRB, 0.76906353E-05_JPRB, 0.78538792E-05_JPRB, 0.79896086E-05_JPRB, &
  & 0.80810543E-05_JPRB, 0.81344588E-05_JPRB, 0.81703376E-05_JPRB, 0.81938772E-05_JPRB, 0.82135200E-05_JPRB, 0.82055470E-05_JPRB, &
  & 0.81757260E-05_JPRB, 0.81136144E-05_JPRB, 0.80210036E-05_JPRB, 0.78928579E-05_JPRB, 0.77380288E-05_JPRB, 0.75797730E-05_JPRB, &
  & 0.74335256E-05_JPRB, 0.73252615E-05_JPRB, 0.72657263E-05_JPRB, 0.72605413E-05_JPRB, 0.73261589E-05_JPRB, 0.74745118E-05_JPRB, &
  & 0.76671646E-05_JPRB, 0.78578832E-05_JPRB, 0.80035155E-05_JPRB, 0.81023814E-05_JPRB, 0.81569940E-05_JPRB, 0.81696029E-05_JPRB, &
  & 0.81523973E-05_JPRB, 0.81145442E-05_JPRB, 0.80753646E-05_JPRB, 0.80290782E-05_JPRB, 0.79431550E-05_JPRB, 0.77990406E-05_JPRB, &
  & 0.75795263E-05_JPRB, 0.73172936E-05_JPRB, 0.70293992E-05_JPRB, 0.67311533E-05_JPRB, 0.64681816E-05_JPRB, 0.62580320E-05_JPRB, &
  & 0.60805898E-05_JPRB, 0.59163434E-05_JPRB, 0.57664485E-05_JPRB, 0.56170018E-05_JPRB, 0.54632827E-05_JPRB, 0.53315431E-05_JPRB, &
  & 0.52233840E-05_JPRB, 0.51619877E-05_JPRB, 0.51357582E-05_JPRB, 0.51182108E-05_JPRB  /)

RGHG7(:,15,11) = (/ &
  & 0.52328833E-05_JPRB, 0.52561906E-05_JPRB, 0.53088326E-05_JPRB, 0.53982960E-05_JPRB, 0.55328975E-05_JPRB, 0.57161059E-05_JPRB, &
  & 0.59310447E-05_JPRB, 0.61794964E-05_JPRB, 0.64383763E-05_JPRB, 0.67040161E-05_JPRB, 0.69588350E-05_JPRB, 0.72129930E-05_JPRB, &
  & 0.74739788E-05_JPRB, 0.77345104E-05_JPRB, 0.79720196E-05_JPRB, 0.81971572E-05_JPRB, 0.84260551E-05_JPRB, 0.86461624E-05_JPRB, &
  & 0.88360337E-05_JPRB, 0.89817981E-05_JPRB, 0.90851057E-05_JPRB, 0.91381246E-05_JPRB, 0.91373574E-05_JPRB, 0.90882160E-05_JPRB, &
  & 0.90263054E-05_JPRB, 0.89545525E-05_JPRB, 0.88718258E-05_JPRB, 0.87660619E-05_JPRB, 0.86330666E-05_JPRB, 0.84831469E-05_JPRB, &
  & 0.83233901E-05_JPRB, 0.82000470E-05_JPRB, 0.81253791E-05_JPRB, 0.81060799E-05_JPRB, 0.81547464E-05_JPRB, 0.82789265E-05_JPRB, &
  & 0.84325742E-05_JPRB, 0.85550972E-05_JPRB, 0.86028435E-05_JPRB, 0.85751344E-05_JPRB, 0.85039189E-05_JPRB, 0.84170950E-05_JPRB, &
  & 0.83196545E-05_JPRB, 0.82193809E-05_JPRB, 0.81280075E-05_JPRB, 0.80242134E-05_JPRB, 0.78586165E-05_JPRB, 0.76272103E-05_JPRB, &
  & 0.73237533E-05_JPRB, 0.70050054E-05_JPRB, 0.66988335E-05_JPRB, 0.64292832E-05_JPRB, 0.62161121E-05_JPRB, 0.60513189E-05_JPRB, &
  & 0.59086706E-05_JPRB, 0.57667755E-05_JPRB, 0.56265177E-05_JPRB, 0.54796308E-05_JPRB, 0.53159589E-05_JPRB, 0.51589059E-05_JPRB, &
  & 0.50295989E-05_JPRB, 0.49302205E-05_JPRB, 0.48572160E-05_JPRB, 0.48223666E-05_JPRB  /)

RGHG7(:,16,11) = (/ &
  & 0.54166995E-05_JPRB, 0.54596777E-05_JPRB, 0.55213613E-05_JPRB, 0.56210716E-05_JPRB, 0.57596940E-05_JPRB, 0.59428535E-05_JPRB, &
  & 0.61486323E-05_JPRB, 0.63730389E-05_JPRB, 0.65971992E-05_JPRB, 0.68200558E-05_JPRB, 0.70393556E-05_JPRB, 0.72554456E-05_JPRB, &
  & 0.74888181E-05_JPRB, 0.77440872E-05_JPRB, 0.79822128E-05_JPRB, 0.82106485E-05_JPRB, 0.84525302E-05_JPRB, 0.86958034E-05_JPRB, &
  & 0.89395765E-05_JPRB, 0.91576655E-05_JPRB, 0.93470649E-05_JPRB, 0.94874928E-05_JPRB, 0.95270198E-05_JPRB, 0.94875250E-05_JPRB, &
  & 0.94360507E-05_JPRB, 0.94003747E-05_JPRB, 0.93765313E-05_JPRB, 0.93515456E-05_JPRB, 0.93234298E-05_JPRB, 0.92802117E-05_JPRB, &
  & 0.92082843E-05_JPRB, 0.91361189E-05_JPRB, 0.90698572E-05_JPRB, 0.90169853E-05_JPRB, 0.89854393E-05_JPRB, 0.89960566E-05_JPRB, &
  & 0.90227943E-05_JPRB, 0.90147874E-05_JPRB, 0.89392443E-05_JPRB, 0.87800990E-05_JPRB, 0.85959968E-05_JPRB, 0.84295902E-05_JPRB, &
  & 0.82769673E-05_JPRB, 0.81269607E-05_JPRB, 0.79896806E-05_JPRB, 0.78240180E-05_JPRB, 0.75663948E-05_JPRB, 0.72363567E-05_JPRB, &
  & 0.68582402E-05_JPRB, 0.64971842E-05_JPRB, 0.61854500E-05_JPRB, 0.59478981E-05_JPRB, 0.57858959E-05_JPRB, 0.56574393E-05_JPRB, &
  & 0.55409895E-05_JPRB, 0.54192332E-05_JPRB, 0.52844279E-05_JPRB, 0.51345291E-05_JPRB, 0.49604634E-05_JPRB, 0.47758966E-05_JPRB, &
  & 0.46087663E-05_JPRB, 0.44585541E-05_JPRB, 0.43436178E-05_JPRB, 0.42910964E-05_JPRB  /)

RGHG7(:,17,11) = (/ &
  & 0.55030593E-05_JPRB, 0.55700009E-05_JPRB, 0.56393264E-05_JPRB, 0.57343636E-05_JPRB, 0.58641151E-05_JPRB, 0.60335883E-05_JPRB, &
  & 0.62114792E-05_JPRB, 0.64029008E-05_JPRB, 0.65886588E-05_JPRB, 0.67630007E-05_JPRB, 0.69388319E-05_JPRB, 0.71151023E-05_JPRB, &
  & 0.73074280E-05_JPRB, 0.75286627E-05_JPRB, 0.77465424E-05_JPRB, 0.79588543E-05_JPRB, 0.81813440E-05_JPRB, 0.84010148E-05_JPRB, &
  & 0.86399768E-05_JPRB, 0.88856263E-05_JPRB, 0.91283615E-05_JPRB, 0.93680806E-05_JPRB, 0.95010770E-05_JPRB, 0.95109618E-05_JPRB, &
  & 0.94948263E-05_JPRB, 0.95054182E-05_JPRB, 0.95481300E-05_JPRB, 0.96142699E-05_JPRB, 0.97022844E-05_JPRB, 0.98012921E-05_JPRB, &
  & 0.98859742E-05_JPRB, 0.99339909E-05_JPRB, 0.99173886E-05_JPRB, 0.98267559E-05_JPRB, 0.96766397E-05_JPRB, 0.95300257E-05_JPRB, &
  & 0.94034137E-05_JPRB, 0.92675722E-05_JPRB, 0.90798381E-05_JPRB, 0.88066541E-05_JPRB, 0.85216896E-05_JPRB, 0.82895568E-05_JPRB, &
  & 0.80929908E-05_JPRB, 0.79053787E-05_JPRB, 0.77348131E-05_JPRB, 0.75153252E-05_JPRB, 0.71880091E-05_JPRB, 0.67953879E-05_JPRB, &
  & 0.63796584E-05_JPRB, 0.60112705E-05_JPRB, 0.57106106E-05_JPRB, 0.55019305E-05_JPRB, 0.53832645E-05_JPRB, 0.52811425E-05_JPRB, &
  & 0.51734869E-05_JPRB, 0.50521177E-05_JPRB, 0.49074074E-05_JPRB, 0.47472797E-05_JPRB, 0.45624254E-05_JPRB, 0.43656968E-05_JPRB, &
  & 0.41784494E-05_JPRB, 0.40067590E-05_JPRB, 0.38792366E-05_JPRB, 0.38192928E-05_JPRB  /)

RGHG7(:,18,11) = (/ &
  & 0.54763395E-05_JPRB, 0.55473076E-05_JPRB, 0.56246485E-05_JPRB, 0.57178568E-05_JPRB, 0.58422446E-05_JPRB, 0.60086858E-05_JPRB, &
  & 0.61695062E-05_JPRB, 0.63274326E-05_JPRB, 0.64837514E-05_JPRB, 0.66230052E-05_JPRB, 0.67664219E-05_JPRB, 0.69102724E-05_JPRB, &
  & 0.70635980E-05_JPRB, 0.72413168E-05_JPRB, 0.74257684E-05_JPRB, 0.76088903E-05_JPRB, 0.78014338E-05_JPRB, 0.79817802E-05_JPRB, &
  & 0.81836401E-05_JPRB, 0.84106504E-05_JPRB, 0.86467844E-05_JPRB, 0.89182300E-05_JPRB, 0.91508894E-05_JPRB, 0.92575759E-05_JPRB, &
  & 0.93103175E-05_JPRB, 0.93870818E-05_JPRB, 0.94969679E-05_JPRB, 0.96310029E-05_JPRB, 0.97869973E-05_JPRB, 0.99664426E-05_JPRB, &
  & 0.10150055E-04_JPRB, 0.10279618E-04_JPRB, 0.10299839E-04_JPRB, 0.10190606E-04_JPRB, 0.99805922E-05_JPRB, 0.97525332E-05_JPRB, &
  & 0.95414501E-05_JPRB, 0.93405254E-05_JPRB, 0.90860289E-05_JPRB, 0.87350164E-05_JPRB, 0.83804433E-05_JPRB, 0.80965299E-05_JPRB, &
  & 0.78727644E-05_JPRB, 0.76757518E-05_JPRB, 0.74939475E-05_JPRB, 0.72430763E-05_JPRB, 0.68852621E-05_JPRB, 0.64956115E-05_JPRB, &
  & 0.60934918E-05_JPRB, 0.57423929E-05_JPRB, 0.54597287E-05_JPRB, 0.52686877E-05_JPRB, 0.51571333E-05_JPRB, 0.50521335E-05_JPRB, &
  & 0.49324558E-05_JPRB, 0.47890477E-05_JPRB, 0.46192030E-05_JPRB, 0.44355147E-05_JPRB, 0.42359133E-05_JPRB, 0.40348832E-05_JPRB, &
  & 0.38509705E-05_JPRB, 0.36914866E-05_JPRB, 0.35729127E-05_JPRB, 0.35121439E-05_JPRB  /)

RGHG7(:,19,11) = (/ &
  & 0.53361294E-05_JPRB, 0.53875728E-05_JPRB, 0.54726792E-05_JPRB, 0.55777045E-05_JPRB, 0.57069379E-05_JPRB, 0.58758308E-05_JPRB, &
  & 0.60352945E-05_JPRB, 0.61733962E-05_JPRB, 0.63072928E-05_JPRB, 0.64229762E-05_JPRB, 0.65393091E-05_JPRB, 0.66512107E-05_JPRB, &
  & 0.67668701E-05_JPRB, 0.68979375E-05_JPRB, 0.70448027E-05_JPRB, 0.71993270E-05_JPRB, 0.73571045E-05_JPRB, 0.75045755E-05_JPRB, &
  & 0.76691110E-05_JPRB, 0.78612731E-05_JPRB, 0.80623259E-05_JPRB, 0.83112923E-05_JPRB, 0.85792249E-05_JPRB, 0.87798258E-05_JPRB, &
  & 0.89131671E-05_JPRB, 0.90544141E-05_JPRB, 0.92267803E-05_JPRB, 0.94140666E-05_JPRB, 0.96137236E-05_JPRB, 0.98252321E-05_JPRB, &
  & 0.10037341E-04_JPRB, 0.10188527E-04_JPRB, 0.10211460E-04_JPRB, 0.10096647E-04_JPRB, 0.98892345E-05_JPRB, 0.96587019E-05_JPRB, &
  & 0.94365054E-05_JPRB, 0.92287154E-05_JPRB, 0.89623778E-05_JPRB, 0.85866646E-05_JPRB, 0.81970619E-05_JPRB, 0.78930847E-05_JPRB, &
  & 0.76670669E-05_JPRB, 0.74858808E-05_JPRB, 0.73086678E-05_JPRB, 0.70462482E-05_JPRB, 0.66924882E-05_JPRB, 0.63383424E-05_JPRB, &
  & 0.59698461E-05_JPRB, 0.56450118E-05_JPRB, 0.53848956E-05_JPRB, 0.51989735E-05_JPRB, 0.50644465E-05_JPRB, 0.49332033E-05_JPRB, &
  & 0.47874298E-05_JPRB, 0.46156546E-05_JPRB, 0.44182262E-05_JPRB, 0.42127954E-05_JPRB, 0.40026773E-05_JPRB, 0.37958406E-05_JPRB, &
  & 0.36144066E-05_JPRB, 0.34704900E-05_JPRB, 0.33674691E-05_JPRB, 0.33110622E-05_JPRB  /)

RGHG7(:,20,11) = (/ &
  & 0.50854902E-05_JPRB, 0.51156263E-05_JPRB, 0.52040166E-05_JPRB, 0.53267439E-05_JPRB, 0.54728622E-05_JPRB, 0.56467056E-05_JPRB, &
  & 0.58128727E-05_JPRB, 0.59482729E-05_JPRB, 0.60684226E-05_JPRB, 0.61685079E-05_JPRB, 0.62643383E-05_JPRB, 0.63510008E-05_JPRB, &
  & 0.64360861E-05_JPRB, 0.65280230E-05_JPRB, 0.66374771E-05_JPRB, 0.67647775E-05_JPRB, 0.68935028E-05_JPRB, 0.70148421E-05_JPRB, &
  & 0.71484884E-05_JPRB, 0.73038798E-05_JPRB, 0.74684986E-05_JPRB, 0.76745636E-05_JPRB, 0.79256520E-05_JPRB, 0.81715537E-05_JPRB, &
  & 0.83583467E-05_JPRB, 0.85390254E-05_JPRB, 0.87481539E-05_JPRB, 0.89668233E-05_JPRB, 0.91811963E-05_JPRB, 0.93784000E-05_JPRB, &
  & 0.95559854E-05_JPRB, 0.96761792E-05_JPRB, 0.96843547E-05_JPRB, 0.95859737E-05_JPRB, 0.94249790E-05_JPRB, 0.92479713E-05_JPRB, &
  & 0.90722370E-05_JPRB, 0.89055174E-05_JPRB, 0.86763427E-05_JPRB, 0.83296564E-05_JPRB, 0.79529917E-05_JPRB, 0.76636710E-05_JPRB, &
  & 0.74600006E-05_JPRB, 0.73043775E-05_JPRB, 0.71356129E-05_JPRB, 0.68795070E-05_JPRB, 0.65529949E-05_JPRB, 0.62442930E-05_JPRB, &
  & 0.59171023E-05_JPRB, 0.56210769E-05_JPRB, 0.53850398E-05_JPRB, 0.52004541E-05_JPRB, 0.50337912E-05_JPRB, 0.48637746E-05_JPRB, &
  & 0.46834609E-05_JPRB, 0.44851550E-05_JPRB, 0.42675148E-05_JPRB, 0.40480396E-05_JPRB, 0.38318000E-05_JPRB, 0.36230437E-05_JPRB, &
  & 0.34416585E-05_JPRB, 0.33056851E-05_JPRB, 0.32134832E-05_JPRB, 0.31637443E-05_JPRB  /)

RGHG7(:,21,11) = (/ &
  & 0.47435683E-05_JPRB, 0.47661417E-05_JPRB, 0.48536592E-05_JPRB, 0.49937057E-05_JPRB, 0.51657413E-05_JPRB, 0.53499145E-05_JPRB, &
  & 0.55262071E-05_JPRB, 0.56704363E-05_JPRB, 0.57859553E-05_JPRB, 0.58782513E-05_JPRB, 0.59623848E-05_JPRB, 0.60330084E-05_JPRB, &
  & 0.60966048E-05_JPRB, 0.61604280E-05_JPRB, 0.62370397E-05_JPRB, 0.63382321E-05_JPRB, 0.64446408E-05_JPRB, 0.65428943E-05_JPRB, &
  & 0.66494504E-05_JPRB, 0.67699640E-05_JPRB, 0.69040871E-05_JPRB, 0.70651466E-05_JPRB, 0.72690263E-05_JPRB, 0.75047924E-05_JPRB, &
  & 0.77029683E-05_JPRB, 0.78891258E-05_JPRB, 0.81005192E-05_JPRB, 0.83191286E-05_JPRB, 0.85125665E-05_JPRB, 0.86572068E-05_JPRB, &
  & 0.87604842E-05_JPRB, 0.88189681E-05_JPRB, 0.88092932E-05_JPRB, 0.87458474E-05_JPRB, 0.86543808E-05_JPRB, 0.85602377E-05_JPRB, &
  & 0.84630575E-05_JPRB, 0.83648472E-05_JPRB, 0.82019886E-05_JPRB, 0.79263445E-05_JPRB, 0.76130463E-05_JPRB, 0.73717729E-05_JPRB, &
  & 0.72108447E-05_JPRB, 0.70841358E-05_JPRB, 0.69259871E-05_JPRB, 0.66909238E-05_JPRB, 0.64081270E-05_JPRB, 0.61484407E-05_JPRB, &
  & 0.58681680E-05_JPRB, 0.56051522E-05_JPRB, 0.53937408E-05_JPRB, 0.52133730E-05_JPRB, 0.50207375E-05_JPRB, 0.48130152E-05_JPRB, &
  & 0.45974866E-05_JPRB, 0.43768675E-05_JPRB, 0.41482072E-05_JPRB, 0.39226242E-05_JPRB, 0.37036579E-05_JPRB, 0.34994255E-05_JPRB, &
  & 0.33204248E-05_JPRB, 0.31873882E-05_JPRB, 0.31013336E-05_JPRB, 0.30603445E-05_JPRB  /)

RGHG7(:,22,11) = (/ &
  & 0.43319850E-05_JPRB, 0.43738203E-05_JPRB, 0.44589554E-05_JPRB, 0.46113701E-05_JPRB, 0.48136673E-05_JPRB, 0.50201438E-05_JPRB, &
  & 0.52079936E-05_JPRB, 0.53640334E-05_JPRB, 0.54847734E-05_JPRB, 0.55800600E-05_JPRB, 0.56648526E-05_JPRB, 0.57294441E-05_JPRB, &
  & 0.57815847E-05_JPRB, 0.58295422E-05_JPRB, 0.58842560E-05_JPRB, 0.59614217E-05_JPRB, 0.60487204E-05_JPRB, 0.61234542E-05_JPRB, &
  & 0.62019790E-05_JPRB, 0.62902035E-05_JPRB, 0.63985763E-05_JPRB, 0.65227340E-05_JPRB, 0.66662934E-05_JPRB, 0.68423981E-05_JPRB, &
  & 0.70024556E-05_JPRB, 0.71536374E-05_JPRB, 0.73267097E-05_JPRB, 0.74994453E-05_JPRB, 0.76263787E-05_JPRB, 0.76896119E-05_JPRB, &
  & 0.77072243E-05_JPRB, 0.76997107E-05_JPRB, 0.76798979E-05_JPRB, 0.76595380E-05_JPRB, 0.76408614E-05_JPRB, 0.76325860E-05_JPRB, &
  & 0.76177253E-05_JPRB, 0.75905815E-05_JPRB, 0.74983839E-05_JPRB, 0.73226992E-05_JPRB, 0.71248713E-05_JPRB, 0.69667285E-05_JPRB, &
  & 0.68653096E-05_JPRB, 0.67701801E-05_JPRB, 0.66293672E-05_JPRB, 0.64276575E-05_JPRB, 0.62025959E-05_JPRB, 0.59961335E-05_JPRB, &
  & 0.57699463E-05_JPRB, 0.55497123E-05_JPRB, 0.53633921E-05_JPRB, 0.51955953E-05_JPRB, 0.49966743E-05_JPRB, 0.47689804E-05_JPRB, &
  & 0.45277523E-05_JPRB, 0.42901522E-05_JPRB, 0.40589575E-05_JPRB, 0.38345404E-05_JPRB, 0.36158781E-05_JPRB, 0.34232537E-05_JPRB, &
  & 0.32556580E-05_JPRB, 0.31282479E-05_JPRB, 0.30490365E-05_JPRB, 0.30204662E-05_JPRB  /)

RGHG7(:,23,11) = (/ &
  & 0.39271227E-05_JPRB, 0.39929017E-05_JPRB, 0.40890588E-05_JPRB, 0.42508102E-05_JPRB, 0.44623225E-05_JPRB, 0.46849402E-05_JPRB, &
  & 0.48884869E-05_JPRB, 0.50564620E-05_JPRB, 0.51872658E-05_JPRB, 0.52939780E-05_JPRB, 0.53837237E-05_JPRB, 0.54451761E-05_JPRB, &
  & 0.54922360E-05_JPRB, 0.55326402E-05_JPRB, 0.55746052E-05_JPRB, 0.56297501E-05_JPRB, 0.56904206E-05_JPRB, 0.57381905E-05_JPRB, &
  & 0.57879531E-05_JPRB, 0.58459681E-05_JPRB, 0.59212792E-05_JPRB, 0.60087803E-05_JPRB, 0.61003034E-05_JPRB, 0.62079138E-05_JPRB, &
  & 0.63033150E-05_JPRB, 0.63962025E-05_JPRB, 0.65029424E-05_JPRB, 0.66000675E-05_JPRB, 0.66580986E-05_JPRB, 0.66657509E-05_JPRB, &
  & 0.66363349E-05_JPRB, 0.65979195E-05_JPRB, 0.65776906E-05_JPRB, 0.65878291E-05_JPRB, 0.66123112E-05_JPRB, 0.66437886E-05_JPRB, &
  & 0.66592893E-05_JPRB, 0.66556747E-05_JPRB, 0.66107509E-05_JPRB, 0.65287045E-05_JPRB, 0.64369072E-05_JPRB, 0.63678457E-05_JPRB, &
  & 0.63292589E-05_JPRB, 0.62704283E-05_JPRB, 0.61689470E-05_JPRB, 0.60163167E-05_JPRB, 0.58567905E-05_JPRB, 0.57082988E-05_JPRB, &
  & 0.55418730E-05_JPRB, 0.53773853E-05_JPRB, 0.52258267E-05_JPRB, 0.50791636E-05_JPRB, 0.49024780E-05_JPRB, 0.46901553E-05_JPRB, &
  & 0.44516372E-05_JPRB, 0.42107937E-05_JPRB, 0.39853214E-05_JPRB, 0.37697050E-05_JPRB, 0.35580931E-05_JPRB, 0.33773809E-05_JPRB, &
  & 0.32305457E-05_JPRB, 0.31178016E-05_JPRB, 0.30520625E-05_JPRB, 0.30358991E-05_JPRB  /)

RGHG7(:,24,11) = (/ &
  & 0.34971473E-05_JPRB, 0.35825594E-05_JPRB, 0.36917892E-05_JPRB, 0.38604505E-05_JPRB, 0.40753889E-05_JPRB, 0.43096540E-05_JPRB, &
  & 0.45308514E-05_JPRB, 0.47157935E-05_JPRB, 0.48617467E-05_JPRB, 0.49830828E-05_JPRB, 0.50791775E-05_JPRB, 0.51390489E-05_JPRB, &
  & 0.51831367E-05_JPRB, 0.52172817E-05_JPRB, 0.52476671E-05_JPRB, 0.52812995E-05_JPRB, 0.53137131E-05_JPRB, 0.53337770E-05_JPRB, &
  & 0.53549829E-05_JPRB, 0.53836932E-05_JPRB, 0.54240755E-05_JPRB, 0.54725364E-05_JPRB, 0.55134239E-05_JPRB, 0.55544233E-05_JPRB, &
  & 0.55861816E-05_JPRB, 0.56186382E-05_JPRB, 0.56563643E-05_JPRB, 0.56811278E-05_JPRB, 0.56789402E-05_JPRB, 0.56466693E-05_JPRB, &
  & 0.55900864E-05_JPRB, 0.55388120E-05_JPRB, 0.55249500E-05_JPRB, 0.55553304E-05_JPRB, 0.56036270E-05_JPRB, 0.56509971E-05_JPRB, &
  & 0.56757666E-05_JPRB, 0.56815616E-05_JPRB, 0.56754459E-05_JPRB, 0.56727314E-05_JPRB, 0.56716789E-05_JPRB, 0.56823364E-05_JPRB, &
  & 0.57005879E-05_JPRB, 0.56811635E-05_JPRB, 0.56257790E-05_JPRB, 0.55286407E-05_JPRB, 0.54356288E-05_JPRB, 0.53434823E-05_JPRB, &
  & 0.52361125E-05_JPRB, 0.51276427E-05_JPRB, 0.50140424E-05_JPRB, 0.48940709E-05_JPRB, 0.47480591E-05_JPRB, 0.45628509E-05_JPRB, &
  & 0.43421528E-05_JPRB, 0.41106139E-05_JPRB, 0.38972485E-05_JPRB, 0.36970166E-05_JPRB, 0.35003731E-05_JPRB, 0.33363056E-05_JPRB, &
  & 0.32119582E-05_JPRB, 0.31170000E-05_JPRB, 0.30641953E-05_JPRB, 0.30581926E-05_JPRB  /)

RGHG7(:,25,11) = (/ &
  & 0.30405165E-05_JPRB, 0.31359866E-05_JPRB, 0.32583196E-05_JPRB, 0.34299619E-05_JPRB, 0.36426485E-05_JPRB, 0.38814601E-05_JPRB, &
  & 0.41220443E-05_JPRB, 0.43320777E-05_JPRB, 0.45004201E-05_JPRB, 0.46394917E-05_JPRB, 0.47431567E-05_JPRB, 0.48036286E-05_JPRB, &
  & 0.48471802E-05_JPRB, 0.48757708E-05_JPRB, 0.48951117E-05_JPRB, 0.49086496E-05_JPRB, 0.49128838E-05_JPRB, 0.49059476E-05_JPRB, &
  & 0.49004109E-05_JPRB, 0.49022713E-05_JPRB, 0.49076330E-05_JPRB, 0.49145324E-05_JPRB, 0.49076819E-05_JPRB, 0.48903923E-05_JPRB, &
  & 0.48691371E-05_JPRB, 0.48453419E-05_JPRB, 0.48187098E-05_JPRB, 0.47868141E-05_JPRB, 0.47430435E-05_JPRB, 0.46945812E-05_JPRB, &
  & 0.46385559E-05_JPRB, 0.45990765E-05_JPRB, 0.46011271E-05_JPRB, 0.46354964E-05_JPRB, 0.46789249E-05_JPRB, 0.47095674E-05_JPRB, &
  & 0.47175022E-05_JPRB, 0.47179572E-05_JPRB, 0.47391632E-05_JPRB, 0.47882827E-05_JPRB, 0.48489291E-05_JPRB, 0.49177899E-05_JPRB, &
  & 0.49789541E-05_JPRB, 0.50016058E-05_JPRB, 0.49972833E-05_JPRB, 0.49609647E-05_JPRB, 0.49314531E-05_JPRB, 0.48891676E-05_JPRB, &
  & 0.48356692E-05_JPRB, 0.47782612E-05_JPRB, 0.47043997E-05_JPRB, 0.46178403E-05_JPRB, 0.45096586E-05_JPRB, 0.43632026E-05_JPRB, &
  & 0.41799056E-05_JPRB, 0.39763960E-05_JPRB, 0.37840473E-05_JPRB, 0.36084564E-05_JPRB, 0.34386199E-05_JPRB, 0.32987644E-05_JPRB, &
  & 0.31968491E-05_JPRB, 0.31223715E-05_JPRB, 0.30794746E-05_JPRB, 0.30791979E-05_JPRB  /)

RGHG7(:,26,11) = (/ &
  & 0.25883601E-05_JPRB, 0.26773931E-05_JPRB, 0.27955697E-05_JPRB, 0.29701682E-05_JPRB, 0.31829717E-05_JPRB, 0.34247254E-05_JPRB, &
  & 0.36781979E-05_JPRB, 0.39128984E-05_JPRB, 0.41067404E-05_JPRB, 0.42636649E-05_JPRB, 0.43765313E-05_JPRB, 0.44439560E-05_JPRB, &
  & 0.44898397E-05_JPRB, 0.45127236E-05_JPRB, 0.45211483E-05_JPRB, 0.45168514E-05_JPRB, 0.44978847E-05_JPRB, 0.44667990E-05_JPRB, &
  & 0.44367139E-05_JPRB, 0.44125286E-05_JPRB, 0.43885610E-05_JPRB, 0.43596858E-05_JPRB, 0.43109652E-05_JPRB, 0.42508797E-05_JPRB, &
  & 0.41908942E-05_JPRB, 0.41287077E-05_JPRB, 0.40698976E-05_JPRB, 0.40127560E-05_JPRB, 0.39544964E-05_JPRB, 0.38994499E-05_JPRB, &
  & 0.38518920E-05_JPRB, 0.38275236E-05_JPRB, 0.38389252E-05_JPRB, 0.38726434E-05_JPRB, 0.39057130E-05_JPRB, 0.39206455E-05_JPRB, &
  & 0.39157525E-05_JPRB, 0.39146259E-05_JPRB, 0.39456408E-05_JPRB, 0.40151967E-05_JPRB, 0.41057284E-05_JPRB, 0.42046897E-05_JPRB, &
  & 0.42901286E-05_JPRB, 0.43457510E-05_JPRB, 0.43833071E-05_JPRB, 0.43946853E-05_JPRB, 0.44061691E-05_JPRB, 0.43999096E-05_JPRB, &
  & 0.43848009E-05_JPRB, 0.43640018E-05_JPRB, 0.43243779E-05_JPRB, 0.42695383E-05_JPRB, 0.41938937E-05_JPRB, 0.40849916E-05_JPRB, &
  & 0.39450405E-05_JPRB, 0.37826070E-05_JPRB, 0.36224767E-05_JPRB, 0.34779764E-05_JPRB, 0.33434000E-05_JPRB, 0.32329687E-05_JPRB, &
  & 0.31523681E-05_JPRB, 0.30937071E-05_JPRB, 0.30521891E-05_JPRB, 0.30431120E-05_JPRB  /)

RGHG7(:,27,11) = (/ &
  & 0.21172799E-05_JPRB, 0.21934665E-05_JPRB, 0.23008979E-05_JPRB, 0.24785779E-05_JPRB, 0.26923819E-05_JPRB, 0.29366168E-05_JPRB, &
  & 0.32011547E-05_JPRB, 0.34614878E-05_JPRB, 0.36831435E-05_JPRB, 0.38587773E-05_JPRB, 0.39818687E-05_JPRB, 0.40589181E-05_JPRB, &
  & 0.41083036E-05_JPRB, 0.41251644E-05_JPRB, 0.41222236E-05_JPRB, 0.41001179E-05_JPRB, 0.40587401E-05_JPRB, 0.40034626E-05_JPRB, &
  & 0.39485253E-05_JPRB, 0.38974067E-05_JPRB, 0.38448850E-05_JPRB, 0.37807525E-05_JPRB, 0.36904314E-05_JPRB, 0.35913468E-05_JPRB, &
  & 0.34961639E-05_JPRB, 0.34004610E-05_JPRB, 0.33199401E-05_JPRB, 0.32480513E-05_JPRB, 0.31846892E-05_JPRB, 0.31263210E-05_JPRB, &
  & 0.30905489E-05_JPRB, 0.30832089E-05_JPRB, 0.31019542E-05_JPRB, 0.31332711E-05_JPRB, 0.31534744E-05_JPRB, 0.31523590E-05_JPRB, &
  & 0.31355402E-05_JPRB, 0.31341534E-05_JPRB, 0.31689301E-05_JPRB, 0.32482109E-05_JPRB, 0.33581922E-05_JPRB, 0.34782038E-05_JPRB, &
  & 0.35821118E-05_JPRB, 0.36688295E-05_JPRB, 0.37467654E-05_JPRB, 0.38031458E-05_JPRB, 0.38491466E-05_JPRB, 0.38754231E-05_JPRB, &
  & 0.38947113E-05_JPRB, 0.39068284E-05_JPRB, 0.39009612E-05_JPRB, 0.38786575E-05_JPRB, 0.38350687E-05_JPRB, 0.37649857E-05_JPRB, &
  & 0.36725580E-05_JPRB, 0.35579080E-05_JPRB, 0.34356163E-05_JPRB, 0.33260132E-05_JPRB, 0.32314365E-05_JPRB, 0.31537012E-05_JPRB, &
  & 0.30949714E-05_JPRB, 0.30511177E-05_JPRB, 0.30078789E-05_JPRB, 0.29842146E-05_JPRB  /)

RGHG7(:,28,11) = (/ &
  & 0.16863213E-05_JPRB, 0.17508812E-05_JPRB, 0.18453242E-05_JPRB, 0.20100448E-05_JPRB, 0.22217301E-05_JPRB, 0.24667100E-05_JPRB, &
  & 0.27384224E-05_JPRB, 0.30142381E-05_JPRB, 0.32578363E-05_JPRB, 0.34525814E-05_JPRB, 0.35919938E-05_JPRB, 0.36831330E-05_JPRB, &
  & 0.37357436E-05_JPRB, 0.37485830E-05_JPRB, 0.37382069E-05_JPRB, 0.37033995E-05_JPRB, 0.36472801E-05_JPRB, 0.35757632E-05_JPRB, &
  & 0.35021536E-05_JPRB, 0.34300899E-05_JPRB, 0.33571569E-05_JPRB, 0.32710382E-05_JPRB, 0.31573528E-05_JPRB, 0.30409321E-05_JPRB, &
  & 0.29348540E-05_JPRB, 0.28353601E-05_JPRB, 0.27544506E-05_JPRB, 0.26910455E-05_JPRB, 0.26373761E-05_JPRB, 0.25858326E-05_JPRB, &
  & 0.25630068E-05_JPRB, 0.25648187E-05_JPRB, 0.25804828E-05_JPRB, 0.26027416E-05_JPRB, 0.26161146E-05_JPRB, 0.26118950E-05_JPRB, &
  & 0.25994544E-05_JPRB, 0.26039171E-05_JPRB, 0.26418131E-05_JPRB, 0.27206793E-05_JPRB, 0.28300474E-05_JPRB, 0.29535259E-05_JPRB, &
  & 0.30691158E-05_JPRB, 0.31730580E-05_JPRB, 0.32674878E-05_JPRB, 0.33427847E-05_JPRB, 0.34028080E-05_JPRB, 0.34465814E-05_JPRB, &
  & 0.34830081E-05_JPRB, 0.35123050E-05_JPRB, 0.35281326E-05_JPRB, 0.35299823E-05_JPRB, 0.35103620E-05_JPRB, 0.34718007E-05_JPRB, &
  & 0.34185406E-05_JPRB, 0.33488286E-05_JPRB, 0.32675980E-05_JPRB, 0.31910720E-05_JPRB, 0.31299558E-05_JPRB, 0.30830864E-05_JPRB, &
  & 0.30500661E-05_JPRB, 0.30202070E-05_JPRB, 0.29873583E-05_JPRB, 0.29676856E-05_JPRB  /)

RGHG7(:,29,11) = (/ &
  & 0.12314246E-05_JPRB, 0.12837178E-05_JPRB, 0.13643013E-05_JPRB, 0.15145949E-05_JPRB, 0.17239001E-05_JPRB, 0.19695940E-05_JPRB, &
  & 0.22487397E-05_JPRB, 0.25405203E-05_JPRB, 0.28071140E-05_JPRB, 0.30221265E-05_JPRB, 0.31790967E-05_JPRB, 0.32853587E-05_JPRB, &
  & 0.33413747E-05_JPRB, 0.33500397E-05_JPRB, 0.33319557E-05_JPRB, 0.32839114E-05_JPRB, 0.32125044E-05_JPRB, 0.31241254E-05_JPRB, &
  & 0.30309990E-05_JPRB, 0.29370018E-05_JPRB, 0.28427944E-05_JPRB, 0.27339548E-05_JPRB, 0.25963036E-05_JPRB, 0.24624534E-05_JPRB, &
  & 0.23458845E-05_JPRB, 0.22436626E-05_JPRB, 0.21632658E-05_JPRB, 0.21098571E-05_JPRB, 0.20670995E-05_JPRB, 0.20232273E-05_JPRB, &
  & 0.20141695E-05_JPRB, 0.20253369E-05_JPRB, 0.20372845E-05_JPRB, 0.20496567E-05_JPRB, 0.20560542E-05_JPRB, 0.20491066E-05_JPRB, &
  & 0.20420121E-05_JPRB, 0.20529377E-05_JPRB, 0.20941108E-05_JPRB, 0.21720983E-05_JPRB, 0.22799468E-05_JPRB, 0.24063363E-05_JPRB, &
  & 0.25340097E-05_JPRB, 0.26556013E-05_JPRB, 0.27664721E-05_JPRB, 0.28606816E-05_JPRB, 0.29346743E-05_JPRB, 0.29963350E-05_JPRB, &
  & 0.30501731E-05_JPRB, 0.30969912E-05_JPRB, 0.31352832E-05_JPRB, 0.31623620E-05_JPRB, 0.31677877E-05_JPRB, 0.31623097E-05_JPRB, &
  & 0.31501887E-05_JPRB, 0.31279689E-05_JPRB, 0.30903856E-05_JPRB, 0.30488288E-05_JPRB, 0.30228831E-05_JPRB, 0.30086394E-05_JPRB, &
  & 0.30030268E-05_JPRB, 0.29879610E-05_JPRB, 0.29666466E-05_JPRB, 0.29520087E-05_JPRB  /)

RGHG7(:,30,11) = (/ &
  & 0.90110546E-06_JPRB, 0.94561917E-06_JPRB, 0.10132590E-05_JPRB, 0.11427111E-05_JPRB, 0.13348208E-05_JPRB, 0.15747574E-05_JPRB, &
  & 0.18525909E-05_JPRB, 0.21432922E-05_JPRB, 0.24158736E-05_JPRB, 0.26425811E-05_JPRB, 0.28138495E-05_JPRB, 0.29281990E-05_JPRB, &
  & 0.29846523E-05_JPRB, 0.29909815E-05_JPRB, 0.29669074E-05_JPRB, 0.29094101E-05_JPRB, 0.28303817E-05_JPRB, 0.27361974E-05_JPRB, &
  & 0.26352047E-05_JPRB, 0.25290928E-05_JPRB, 0.24217580E-05_JPRB, 0.23030709E-05_JPRB, 0.21647709E-05_JPRB, 0.20347328E-05_JPRB, &
  & 0.19228831E-05_JPRB, 0.18306468E-05_JPRB, 0.17597879E-05_JPRB, 0.17118245E-05_JPRB, 0.16740467E-05_JPRB, 0.16395903E-05_JPRB, &
  & 0.16330539E-05_JPRB, 0.16419620E-05_JPRB, 0.16485342E-05_JPRB, 0.16566675E-05_JPRB, 0.16602441E-05_JPRB, 0.16523452E-05_JPRB, &
  & 0.16486009E-05_JPRB, 0.16657084E-05_JPRB, 0.17094579E-05_JPRB, 0.17835684E-05_JPRB, 0.18826660E-05_JPRB, 0.20037183E-05_JPRB, &
  & 0.21338635E-05_JPRB, 0.22606659E-05_JPRB, 0.23800276E-05_JPRB, 0.24856575E-05_JPRB, 0.25687500E-05_JPRB, 0.26410260E-05_JPRB, &
  & 0.27036453E-05_JPRB, 0.27596791E-05_JPRB, 0.28110352E-05_JPRB, 0.28515505E-05_JPRB, 0.28731306E-05_JPRB, 0.28833801E-05_JPRB, &
  & 0.28902749E-05_JPRB, 0.28888618E-05_JPRB, 0.28741888E-05_JPRB, 0.28559204E-05_JPRB, 0.28468621E-05_JPRB, 0.28455951E-05_JPRB, &
  & 0.28587446E-05_JPRB, 0.28574437E-05_JPRB, 0.28448249E-05_JPRB, 0.28394396E-05_JPRB  /)

RGHG7(:,31,11) = (/ &
  & 0.55318177E-06_JPRB, 0.58950290E-06_JPRB, 0.64350532E-06_JPRB, 0.75099188E-06_JPRB, 0.92496930E-06_JPRB, 0.11588335E-05_JPRB, &
  & 0.14352761E-05_JPRB, 0.17248240E-05_JPRB, 0.20036983E-05_JPRB, 0.22427201E-05_JPRB, 0.24290506E-05_JPRB, 0.25519151E-05_JPRB, &
  & 0.26088264E-05_JPRB, 0.26126960E-05_JPRB, 0.25823122E-05_JPRB, 0.25148582E-05_JPRB, 0.24278068E-05_JPRB, 0.23275163E-05_JPRB, &
  & 0.22182461E-05_JPRB, 0.20993789E-05_JPRB, 0.19782202E-05_JPRB, 0.18491694E-05_JPRB, 0.17102078E-05_JPRB, 0.15842067E-05_JPRB, &
  & 0.14773438E-05_JPRB, 0.13956408E-05_JPRB, 0.13348404E-05_JPRB, 0.12926100E-05_JPRB, 0.12600734E-05_JPRB, 0.12355398E-05_JPRB, &
  & 0.12316494E-05_JPRB, 0.12381658E-05_JPRB, 0.12390728E-05_JPRB, 0.12427452E-05_JPRB, 0.12433534E-05_JPRB, 0.12344537E-05_JPRB, &
  & 0.12342375E-05_JPRB, 0.12578584E-05_JPRB, 0.13043218E-05_JPRB, 0.13743444E-05_JPRB, 0.14642148E-05_JPRB, 0.15796358E-05_JPRB, &
  & 0.17123761E-05_JPRB, 0.18446573E-05_JPRB, 0.19729579E-05_JPRB, 0.20906137E-05_JPRB, 0.21832897E-05_JPRB, 0.22667435E-05_JPRB, &
  & 0.23386071E-05_JPRB, 0.24043430E-05_JPRB, 0.24694553E-05_JPRB, 0.25241167E-05_JPRB, 0.25627097E-05_JPRB, 0.25895139E-05_JPRB, &
  & 0.26164237E-05_JPRB, 0.26369084E-05_JPRB, 0.26463552E-05_JPRB, 0.26526138E-05_JPRB, 0.26613314E-05_JPRB, 0.26737188E-05_JPRB, &
  & 0.27066289E-05_JPRB, 0.27198304E-05_JPRB, 0.27163710E-05_JPRB, 0.27207388E-05_JPRB  /)

RGHG7(:,32,11) = (/ &
  & 0.40752877E-06_JPRB, 0.43338449E-06_JPRB, 0.47525332E-06_JPRB, 0.56292493E-06_JPRB, 0.70818637E-06_JPRB, 0.91457505E-06_JPRB, &
  & 0.11668734E-05_JPRB, 0.14360856E-05_JPRB, 0.16999958E-05_JPRB, 0.19345652E-05_JPRB, 0.21217314E-05_JPRB, 0.22443512E-05_JPRB, &
  & 0.22988692E-05_JPRB, 0.23012922E-05_JPRB, 0.22683387E-05_JPRB, 0.21992219E-05_JPRB, 0.21114592E-05_JPRB, 0.20102191E-05_JPRB, &
  & 0.19003870E-05_JPRB, 0.17798883E-05_JPRB, 0.16578262E-05_JPRB, 0.15331982E-05_JPRB, 0.14055099E-05_JPRB, 0.12918076E-05_JPRB, &
  & 0.11936759E-05_JPRB, 0.11162529E-05_JPRB, 0.10582326E-05_JPRB, 0.10181393E-05_JPRB, 0.98861372E-06_JPRB, 0.96846993E-06_JPRB, &
  & 0.96473616E-06_JPRB, 0.96908975E-06_JPRB, 0.97044782E-06_JPRB, 0.97167343E-06_JPRB, 0.96922202E-06_JPRB, 0.96026609E-06_JPRB, &
  & 0.96029052E-06_JPRB, 0.98455104E-06_JPRB, 0.10285979E-05_JPRB, 0.10908082E-05_JPRB, 0.11719555E-05_JPRB, 0.12780687E-05_JPRB, &
  & 0.14049249E-05_JPRB, 0.15343858E-05_JPRB, 0.16658886E-05_JPRB, 0.17918812E-05_JPRB, 0.18934290E-05_JPRB, 0.19841835E-05_JPRB, &
  & 0.20625054E-05_JPRB, 0.21351055E-05_JPRB, 0.22087052E-05_JPRB, 0.22704500E-05_JPRB, 0.23156792E-05_JPRB, 0.23480996E-05_JPRB, &
  & 0.23813775E-05_JPRB, 0.24086846E-05_JPRB, 0.24263743E-05_JPRB, 0.24432829E-05_JPRB, 0.24603600E-05_JPRB, 0.24786975E-05_JPRB, &
  & 0.25171693E-05_JPRB, 0.25372068E-05_JPRB, 0.25380117E-05_JPRB, 0.25466960E-05_JPRB  /)

RGHG7(:,33,11) = (/ &
  & 0.28234754E-06_JPRB, 0.29703285E-06_JPRB, 0.32648658E-06_JPRB, 0.39384402E-06_JPRB, 0.50789216E-06_JPRB, 0.68295584E-06_JPRB, &
  & 0.90721649E-06_JPRB, 0.11528112E-05_JPRB, 0.13984180E-05_JPRB, 0.16261894E-05_JPRB, 0.18123822E-05_JPRB, 0.19336136E-05_JPRB, &
  & 0.19852752E-05_JPRB, 0.19863258E-05_JPRB, 0.19511861E-05_JPRB, 0.18814150E-05_JPRB, 0.17938598E-05_JPRB, 0.16923006E-05_JPRB, &
  & 0.15828834E-05_JPRB, 0.14621293E-05_JPRB, 0.13408013E-05_JPRB, 0.12226840E-05_JPRB, 0.11082565E-05_JPRB, 0.10084056E-05_JPRB, &
  & 0.91983257E-06_JPRB, 0.84604793E-06_JPRB, 0.78997442E-06_JPRB, 0.75163652E-06_JPRB, 0.72495140E-06_JPRB, 0.70865343E-06_JPRB, &
  & 0.70476008E-06_JPRB, 0.70689555E-06_JPRB, 0.70951427E-06_JPRB, 0.70845793E-06_JPRB, 0.70281498E-06_JPRB, 0.69392288E-06_JPRB, &
  & 0.69377177E-06_JPRB, 0.71793655E-06_JPRB, 0.75880785E-06_JPRB, 0.81241691E-06_JPRB, 0.88456406E-06_JPRB, 0.98052814E-06_JPRB, &
  & 0.11001714E-05_JPRB, 0.12256270E-05_JPRB, 0.13597149E-05_JPRB, 0.14938939E-05_JPRB, 0.16045694E-05_JPRB, 0.17024092E-05_JPRB, &
  & 0.17870823E-05_JPRB, 0.18664484E-05_JPRB, 0.19481866E-05_JPRB, 0.20163783E-05_JPRB, 0.20671608E-05_JPRB, 0.21040014E-05_JPRB, &
  & 0.21421305E-05_JPRB, 0.21745760E-05_JPRB, 0.21987765E-05_JPRB, 0.22249565E-05_JPRB, 0.22495017E-05_JPRB, 0.22730255E-05_JPRB, &
  & 0.23154389E-05_JPRB, 0.23415882E-05_JPRB, 0.23461911E-05_JPRB, 0.23586573E-05_JPRB  /)

RGHG7(:,34,11) = (/ &
  & 0.21792696E-06_JPRB, 0.22752901E-06_JPRB, 0.24809361E-06_JPRB, 0.30080961E-06_JPRB, 0.39008333E-06_JPRB, 0.53491674E-06_JPRB, &
  & 0.72836025E-06_JPRB, 0.94783766E-06_JPRB, 0.11710081E-05_JPRB, 0.13825085E-05_JPRB, 0.15593173E-05_JPRB, 0.16755037E-05_JPRB, &
  & 0.17238124E-05_JPRB, 0.17233108E-05_JPRB, 0.16890958E-05_JPRB, 0.16210284E-05_JPRB, 0.15348297E-05_JPRB, 0.14351241E-05_JPRB, &
  & 0.13285928E-05_JPRB, 0.12127112E-05_JPRB, 0.10970943E-05_JPRB, 0.98787949E-06_JPRB, 0.88663869E-06_JPRB, 0.79835518E-06_JPRB, &
  & 0.71924786E-06_JPRB, 0.65309239E-06_JPRB, 0.60318178E-06_JPRB, 0.56875250E-06_JPRB, 0.54540535E-06_JPRB, 0.53082972E-06_JPRB, &
  & 0.52613385E-06_JPRB, 0.52682948E-06_JPRB, 0.52898403E-06_JPRB, 0.52672600E-06_JPRB, 0.52052968E-06_JPRB, 0.51324408E-06_JPRB, &
  & 0.51318825E-06_JPRB, 0.53356460E-06_JPRB, 0.56852683E-06_JPRB, 0.61516985E-06_JPRB, 0.68040068E-06_JPRB, 0.76776889E-06_JPRB, &
  & 0.87759375E-06_JPRB, 0.99664299E-06_JPRB, 0.11292666E-05_JPRB, 0.12645378E-05_JPRB, 0.13781273E-05_JPRB, 0.14791330E-05_JPRB, &
  & 0.15688894E-05_JPRB, 0.16529293E-05_JPRB, 0.17377132E-05_JPRB, 0.18088200E-05_JPRB, 0.18601255E-05_JPRB, 0.18982745E-05_JPRB, &
  & 0.19374998E-05_JPRB, 0.19717810E-05_JPRB, 0.19999265E-05_JPRB, 0.20284439E-05_JPRB, 0.20547838E-05_JPRB, 0.20802456E-05_JPRB, &
  & 0.21212811E-05_JPRB, 0.21506662E-05_JPRB, 0.21588394E-05_JPRB, 0.21729875E-05_JPRB  /)

RGHG7(:,35,11) = (/ &
  & 0.18287290E-06_JPRB, 0.19037225E-06_JPRB, 0.20360698E-06_JPRB, 0.24418057E-06_JPRB, 0.31128700E-06_JPRB, 0.42560152E-06_JPRB, &
  & 0.58593478E-06_JPRB, 0.77727736E-06_JPRB, 0.97525974E-06_JPRB, 0.11651703E-05_JPRB, 0.13280153E-05_JPRB, 0.14371385E-05_JPRB, &
  & 0.14817451E-05_JPRB, 0.14795555E-05_JPRB, 0.14478874E-05_JPRB, 0.13827816E-05_JPRB, 0.12985671E-05_JPRB, 0.12018823E-05_JPRB, &
  & 0.10995861E-05_JPRB, 0.99134527E-06_JPRB, 0.88415402E-06_JPRB, 0.78531951E-06_JPRB, 0.69759824E-06_JPRB, 0.62003558E-06_JPRB, &
  & 0.55061257E-06_JPRB, 0.49434871E-06_JPRB, 0.45293778E-06_JPRB, 0.42363200E-06_JPRB, 0.40397200E-06_JPRB, 0.39007753E-06_JPRB, &
  & 0.38422665E-06_JPRB, 0.38384131E-06_JPRB, 0.38463354E-06_JPRB, 0.38169436E-06_JPRB, 0.37628285E-06_JPRB, 0.37144053E-06_JPRB, &
  & 0.37162163E-06_JPRB, 0.38620813E-06_JPRB, 0.41369242E-06_JPRB, 0.45401250E-06_JPRB, 0.51320174E-06_JPRB, 0.59252932E-06_JPRB, &
  & 0.69092255E-06_JPRB, 0.80215326E-06_JPRB, 0.93119339E-06_JPRB, 0.10639472E-05_JPRB, 0.11773443E-05_JPRB, 0.12795939E-05_JPRB, &
  & 0.13739258E-05_JPRB, 0.14616973E-05_JPRB, 0.15469995E-05_JPRB, 0.16192909E-05_JPRB, 0.16685529E-05_JPRB, 0.17064501E-05_JPRB, &
  & 0.17448759E-05_JPRB, 0.17793496E-05_JPRB, 0.18102345E-05_JPRB, 0.18375969E-05_JPRB, 0.18628706E-05_JPRB, 0.18886582E-05_JPRB, &
  & 0.19255475E-05_JPRB, 0.19567836E-05_JPRB, 0.19685106E-05_JPRB, 0.19833103E-05_JPRB  /)

RGHG7(:,36,11) = (/ &
  & 0.15554398E-06_JPRB, 0.16133943E-06_JPRB, 0.16877123E-06_JPRB, 0.19851843E-06_JPRB, 0.24669778E-06_JPRB, 0.33408460E-06_JPRB, &
  & 0.46360303E-06_JPRB, 0.62717526E-06_JPRB, 0.80033763E-06_JPRB, 0.96859547E-06_JPRB, 0.11164610E-05_JPRB, 0.12176685E-05_JPRB, &
  & 0.12589454E-05_JPRB, 0.12554858E-05_JPRB, 0.12262769E-05_JPRB, 0.11647497E-05_JPRB, 0.10838815E-05_JPRB, 0.99173984E-06_JPRB, &
  & 0.89482304E-06_JPRB, 0.79496280E-06_JPRB, 0.69689950E-06_JPRB, 0.60849553E-06_JPRB, 0.53266688E-06_JPRB, 0.46512059E-06_JPRB, &
  & 0.40510950E-06_JPRB, 0.35829043E-06_JPRB, 0.32481172E-06_JPRB, 0.30050043E-06_JPRB, 0.28425697E-06_JPRB, 0.27144679E-06_JPRB, &
  & 0.26483543E-06_JPRB, 0.26324285E-06_JPRB, 0.26264932E-06_JPRB, 0.25922671E-06_JPRB, 0.25475725E-06_JPRB, 0.25203402E-06_JPRB, &
  & 0.25270908E-06_JPRB, 0.26276755E-06_JPRB, 0.28396721E-06_JPRB, 0.31846271E-06_JPRB, 0.37095650E-06_JPRB, 0.44164093E-06_JPRB, &
  & 0.52849779E-06_JPRB, 0.63129802E-06_JPRB, 0.75434629E-06_JPRB, 0.88170412E-06_JPRB, 0.99261191E-06_JPRB, 0.10945637E-05_JPRB, &
  & 0.11916437E-05_JPRB, 0.12817334E-05_JPRB, 0.13662102E-05_JPRB, 0.14385383E-05_JPRB, 0.14855927E-05_JPRB, 0.15235694E-05_JPRB, &
  & 0.15611949E-05_JPRB, 0.15947431E-05_JPRB, 0.16270814E-05_JPRB, 0.16530613E-05_JPRB, 0.16765924E-05_JPRB, 0.17027509E-05_JPRB, &
  & 0.17351658E-05_JPRB, 0.17680329E-05_JPRB, 0.17828280E-05_JPRB, 0.17976077E-05_JPRB  /)

RGHG7(:,37,11) = (/ &
  & 0.14762693E-06_JPRB, 0.15273890E-06_JPRB, 0.15822960E-06_JPRB, 0.18084122E-06_JPRB, 0.21869996E-06_JPRB, 0.28906801E-06_JPRB, &
  & 0.39495155E-06_JPRB, 0.53331688E-06_JPRB, 0.68404728E-06_JPRB, 0.83185527E-06_JPRB, 0.96334453E-06_JPRB, 0.10551746E-05_JPRB, &
  & 0.10941824E-05_JPRB, 0.10904904E-05_JPRB, 0.10633866E-05_JPRB, 0.10066301E-05_JPRB, 0.93202262E-06_JPRB, 0.84763167E-06_JPRB, &
  & 0.75838357E-06_JPRB, 0.66807844E-06_JPRB, 0.58018539E-06_JPRB, 0.50167828E-06_JPRB, 0.43327226E-06_JPRB, 0.37350403E-06_JPRB, &
  & 0.32169475E-06_JPRB, 0.28270841E-06_JPRB, 0.25536740E-06_JPRB, 0.23544408E-06_JPRB, 0.22178419E-06_JPRB, 0.21091510E-06_JPRB, &
  & 0.20449512E-06_JPRB, 0.20148089E-06_JPRB, 0.19953406E-06_JPRB, 0.19611145E-06_JPRB, 0.19288593E-06_JPRB, 0.19140665E-06_JPRB, &
  & 0.19313428E-06_JPRB, 0.20183945E-06_JPRB, 0.21988141E-06_JPRB, 0.25005729E-06_JPRB, 0.29477302E-06_JPRB, 0.35597069E-06_JPRB, &
  & 0.43176877E-06_JPRB, 0.52525993E-06_JPRB, 0.63716741E-06_JPRB, 0.75286499E-06_JPRB, 0.85617244E-06_JPRB, 0.95431036E-06_JPRB, &
  & 0.10497774E-05_JPRB, 0.11388009E-05_JPRB, 0.12194228E-05_JPRB, 0.12891537E-05_JPRB, 0.13337611E-05_JPRB, 0.13725717E-05_JPRB, &
  & 0.14094454E-05_JPRB, 0.14395625E-05_JPRB, 0.14703151E-05_JPRB, 0.14944769E-05_JPRB, 0.15148230E-05_JPRB, 0.15414326E-05_JPRB, &
  & 0.15688991E-05_JPRB, 0.16027914E-05_JPRB, 0.16193499E-05_JPRB, 0.16325712E-05_JPRB  /)

RGHG7(:,38,11) = (/ &
  & 0.13884226E-06_JPRB, 0.14319585E-06_JPRB, 0.14653273E-06_JPRB, 0.16122679E-06_JPRB, 0.18763389E-06_JPRB, 0.23911812E-06_JPRB, &
  & 0.31877663E-06_JPRB, 0.42917266E-06_JPRB, 0.55501281E-06_JPRB, 0.68012987E-06_JPRB, 0.79344819E-06_JPRB, 0.87487318E-06_JPRB, &
  & 0.91136311E-06_JPRB, 0.90741326E-06_JPRB, 0.88264533E-06_JPRB, 0.83118239E-06_JPRB, 0.76352170E-06_JPRB, 0.68773086E-06_JPRB, &
  & 0.60699186E-06_JPRB, 0.52728897E-06_JPRB, 0.45068072E-06_JPRB, 0.38315505E-06_JPRB, 0.32298512E-06_JPRB, 0.27184733E-06_JPRB, &
  & 0.22913869E-06_JPRB, 0.19884346E-06_JPRB, 0.17831276E-06_JPRB, 0.16325828E-06_JPRB, 0.15246509E-06_JPRB, 0.14374983E-06_JPRB, &
  & 0.13754219E-06_JPRB, 0.13295052E-06_JPRB, 0.12950208E-06_JPRB, 0.12607947E-06_JPRB, 0.12423422E-06_JPRB, 0.12413519E-06_JPRB, &
  & 0.12703074E-06_JPRB, 0.13423430E-06_JPRB, 0.14877252E-06_JPRB, 0.17415540E-06_JPRB, 0.21024068E-06_JPRB, 0.26091195E-06_JPRB, &
  & 0.32443933E-06_JPRB, 0.40760127E-06_JPRB, 0.50714704E-06_JPRB, 0.60990655E-06_JPRB, 0.70478073E-06_JPRB, 0.79868686E-06_JPRB, &
  & 0.89236406E-06_JPRB, 0.98020447E-06_JPRB, 0.10565491E-05_JPRB, 0.11233981E-05_JPRB, 0.11652906E-05_JPRB, 0.12050263E-05_JPRB, &
  & 0.12410658E-05_JPRB, 0.12673758E-05_JPRB, 0.12963689E-05_JPRB, 0.13185135E-05_JPRB, 0.13353255E-05_JPRB, 0.13624356E-05_JPRB, &
  & 0.13844114E-05_JPRB, 0.14194413E-05_JPRB, 0.14379564E-05_JPRB, 0.14494486E-05_JPRB  /)

RGHG7(:,39,11) = (/ &
  & 0.14059140E-06_JPRB, 0.14381035E-06_JPRB, 0.14696008E-06_JPRB, 0.15899993E-06_JPRB, 0.17989307E-06_JPRB, 0.22191028E-06_JPRB, &
  & 0.28716710E-06_JPRB, 0.37863332E-06_JPRB, 0.48639494E-06_JPRB, 0.59501168E-06_JPRB, 0.69495188E-06_JPRB, 0.76785448E-06_JPRB, &
  & 0.80101444E-06_JPRB, 0.79781306E-06_JPRB, 0.77443823E-06_JPRB, 0.72751217E-06_JPRB, 0.66649980E-06_JPRB, 0.59875960E-06_JPRB, &
  & 0.52660012E-06_JPRB, 0.45514919E-06_JPRB, 0.38678367E-06_JPRB, 0.32686905E-06_JPRB, 0.27347790E-06_JPRB, 0.22816892E-06_JPRB, &
  & 0.19105752E-06_JPRB, 0.16509848E-06_JPRB, 0.14746290E-06_JPRB, 0.13459690E-06_JPRB, 0.12542540E-06_JPRB, 0.11787368E-06_JPRB, &
  & 0.11227568E-06_JPRB, 0.10796012E-06_JPRB, 0.10463888E-06_JPRB, 0.10177811E-06_JPRB, 0.10043447E-06_JPRB, 0.10098433E-06_JPRB, &
  & 0.10438824E-06_JPRB, 0.11094989E-06_JPRB, 0.12322118E-06_JPRB, 0.14454297E-06_JPRB, 0.17465762E-06_JPRB, 0.21745713E-06_JPRB, &
  & 0.27268661E-06_JPRB, 0.34596085E-06_JPRB, 0.43562662E-06_JPRB, 0.52743739E-06_JPRB, 0.61315222E-06_JPRB, 0.70014219E-06_JPRB, &
  & 0.78844568E-06_JPRB, 0.87120481E-06_JPRB, 0.94329507E-06_JPRB, 0.10068896E-05_JPRB, 0.10473589E-05_JPRB, 0.10860842E-05_JPRB, &
  & 0.11202052E-05_JPRB, 0.11440584E-05_JPRB, 0.11703544E-05_JPRB, 0.11903647E-05_JPRB, 0.12061989E-05_JPRB, 0.12303538E-05_JPRB, &
  & 0.12510141E-05_JPRB, 0.12871487E-05_JPRB, 0.13032467E-05_JPRB, 0.13123073E-05_JPRB  /)

RGHG7(:,40,11) = (/ &
  & 0.14436752E-06_JPRB, 0.14619331E-06_JPRB, 0.14944515E-06_JPRB, 0.15923116E-06_JPRB, 0.17462462E-06_JPRB, 0.20707211E-06_JPRB, &
  & 0.25736164E-06_JPRB, 0.32809101E-06_JPRB, 0.41575037E-06_JPRB, 0.50601540E-06_JPRB, 0.59103938E-06_JPRB, 0.65424825E-06_JPRB, &
  & 0.68336733E-06_JPRB, 0.68120900E-06_JPRB, 0.65931485E-06_JPRB, 0.61758941E-06_JPRB, 0.56433057E-06_JPRB, 0.50594856E-06_JPRB, &
  & 0.44386939E-06_JPRB, 0.38171831E-06_JPRB, 0.32252864E-06_JPRB, 0.27099483E-06_JPRB, 0.22532073E-06_JPRB, 0.18639401E-06_JPRB, &
  & 0.15527827E-06_JPRB, 0.13369563E-06_JPRB, 0.11881718E-06_JPRB, 0.10808103E-06_JPRB, 0.10060903E-06_JPRB, 0.94260821E-07_JPRB, &
  & 0.89443282E-07_JPRB, 0.85755004E-07_JPRB, 0.82849524E-07_JPRB, 0.80740033E-07_JPRB, 0.79841326E-07_JPRB, 0.81033064E-07_JPRB, &
  & 0.84925670E-07_JPRB, 0.90874620E-07_JPRB, 0.10068783E-06_JPRB, 0.11736335E-06_JPRB, 0.14090611E-06_JPRB, 0.17490176E-06_JPRB, &
  & 0.22104291E-06_JPRB, 0.28278534E-06_JPRB, 0.36126211E-06_JPRB, 0.44054909E-06_JPRB, 0.51539586E-06_JPRB, 0.59382996E-06_JPRB, &
  & 0.67524062E-06_JPRB, 0.75139868E-06_JPRB, 0.81849984E-06_JPRB, 0.87821395E-06_JPRB, 0.91722447E-06_JPRB, 0.95444720E-06_JPRB, &
  & 0.98613928E-06_JPRB, 0.10073302E-05_JPRB, 0.10303074E-05_JPRB, 0.10477940E-05_JPRB, 0.10628988E-05_JPRB, 0.10830201E-05_JPRB, &
  & 0.11028197E-05_JPRB, 0.11402453E-05_JPRB, 0.11527912E-05_JPRB, 0.11588831E-05_JPRB  /)

RGHG7(:,41,11) = (/ &
  & 0.14898436E-06_JPRB, 0.14910682E-06_JPRB, 0.15248352E-06_JPRB, 0.15951387E-06_JPRB, 0.16818318E-06_JPRB, 0.18893029E-06_JPRB, &
  & 0.22092014E-06_JPRB, 0.26629572E-06_JPRB, 0.32937715E-06_JPRB, 0.39720457E-06_JPRB, 0.46399129E-06_JPRB, 0.51534818E-06_JPRB, &
  & 0.53952670E-06_JPRB, 0.53864364E-06_JPRB, 0.51855984E-06_JPRB, 0.48319291E-06_JPRB, 0.43941387E-06_JPRB, 0.39247363E-06_JPRB, &
  & 0.34271909E-06_JPRB, 0.29193843E-06_JPRB, 0.24396757E-06_JPRB, 0.20268050E-06_JPRB, 0.16644162E-06_JPRB, 0.13531812E-06_JPRB, &
  & 0.11153296E-06_JPRB, 0.95301097E-07_JPRB, 0.83793641E-07_JPRB, 0.75661537E-07_JPRB, 0.70267426E-07_JPRB, 0.65390681E-07_JPRB, &
  & 0.61527366E-07_JPRB, 0.58606033E-07_JPRB, 0.56208877E-07_JPRB, 0.55017938E-07_JPRB, 0.54663227E-07_JPRB, 0.56639747E-07_JPRB, &
  & 0.61129857E-07_JPRB, 0.66329697E-07_JPRB, 0.73137552E-07_JPRB, 0.84132321E-07_JPRB, 0.99639985E-07_JPRB, 0.12287165E-06_JPRB, &
  & 0.15790101E-06_JPRB, 0.20554412E-06_JPRB, 0.27034073E-06_JPRB, 0.33431554E-06_JPRB, 0.39587454E-06_JPRB, 0.46384786E-06_JPRB, &
  & 0.53683104E-06_JPRB, 0.60491833E-06_JPRB, 0.66591960E-06_JPRB, 0.72088934E-06_JPRB, 0.75811627E-06_JPRB, 0.79350190E-06_JPRB, &
  & 0.82222429E-06_JPRB, 0.84016015E-06_JPRB, 0.85907966E-06_JPRB, 0.87348070E-06_JPRB, 0.88769367E-06_JPRB, 0.90288331E-06_JPRB, &
  & 0.92163064E-06_JPRB, 0.96063472E-06_JPRB, 0.96883754E-06_JPRB, 0.97129984E-06_JPRB  /)

RGHG7(:,42,11) = (/ &
  & 0.16593465E-06_JPRB, 0.16664804E-06_JPRB, 0.16821111E-06_JPRB, 0.17512332E-06_JPRB, 0.18315435E-06_JPRB, 0.19943864E-06_JPRB, &
  & 0.22888138E-06_JPRB, 0.27034976E-06_JPRB, 0.32526300E-06_JPRB, 0.38587042E-06_JPRB, 0.44551051E-06_JPRB, 0.49168545E-06_JPRB, &
  & 0.51408592E-06_JPRB, 0.51243771E-06_JPRB, 0.49452787E-06_JPRB, 0.46258447E-06_JPRB, 0.42311959E-06_JPRB, 0.38033022E-06_JPRB, &
  & 0.33622899E-06_JPRB, 0.28925682E-06_JPRB, 0.24374861E-06_JPRB, 0.20329027E-06_JPRB, 0.16703823E-06_JPRB, 0.13741339E-06_JPRB, &
  & 0.11432771E-06_JPRB, 0.98118569E-07_JPRB, 0.86564494E-07_JPRB, 0.78361688E-07_JPRB, 0.72257912E-07_JPRB, 0.67169517E-07_JPRB, &
  & 0.63781918E-07_JPRB, 0.61472802E-07_JPRB, 0.59462696E-07_JPRB, 0.57983326E-07_JPRB, 0.57439636E-07_JPRB, 0.59354697E-07_JPRB, &
  & 0.63447413E-07_JPRB, 0.68267666E-07_JPRB, 0.75190799E-07_JPRB, 0.86183427E-07_JPRB, 0.10169014E-06_JPRB, 0.12410553E-06_JPRB, &
  & 0.15686283E-06_JPRB, 0.20200328E-06_JPRB, 0.26023336E-06_JPRB, 0.31899919E-06_JPRB, 0.37632311E-06_JPRB, 0.43901780E-06_JPRB, &
  & 0.50450071E-06_JPRB, 0.56529556E-06_JPRB, 0.62225966E-06_JPRB, 0.67160828E-06_JPRB, 0.70755495E-06_JPRB, 0.73939086E-06_JPRB, &
  & 0.76374767E-06_JPRB, 0.78155015E-06_JPRB, 0.79901777E-06_JPRB, 0.81309949E-06_JPRB, 0.82429086E-06_JPRB, 0.83866240E-06_JPRB, &
  & 0.85757804E-06_JPRB, 0.89082433E-06_JPRB, 0.89705417E-06_JPRB, 0.89893297E-06_JPRB  /)

RGHG7(:,43,11) = (/ &
  & 0.18338589E-06_JPRB, 0.18390574E-06_JPRB, 0.18386779E-06_JPRB, 0.18948685E-06_JPRB, 0.19404312E-06_JPRB, 0.20122265E-06_JPRB, &
  & 0.22046982E-06_JPRB, 0.24746735E-06_JPRB, 0.28435581E-06_JPRB, 0.32872421E-06_JPRB, 0.37399901E-06_JPRB, 0.41034785E-06_JPRB, &
  & 0.42900085E-06_JPRB, 0.42720310E-06_JPRB, 0.41205547E-06_JPRB, 0.38597079E-06_JPRB, 0.35451986E-06_JPRB, 0.32043939E-06_JPRB, &
  & 0.28679764E-06_JPRB, 0.24819128E-06_JPRB, 0.20975576E-06_JPRB, 0.17446118E-06_JPRB, 0.14225570E-06_JPRB, 0.11735477E-06_JPRB, &
  & 0.98060546E-07_JPRB, 0.84173781E-07_JPRB, 0.74027204E-07_JPRB, 0.66880022E-07_JPRB, 0.61022559E-07_JPRB, 0.56374007E-07_JPRB, &
  & 0.53830907E-07_JPRB, 0.52410276E-07_JPRB, 0.50971966E-07_JPRB, 0.49624548E-07_JPRB, 0.49142437E-07_JPRB, 0.51338998E-07_JPRB, &
  & 0.55326151E-07_JPRB, 0.59477842E-07_JPRB, 0.65213398E-07_JPRB, 0.73760497E-07_JPRB, 0.85810037E-07_JPRB, 0.10285055E-06_JPRB, &
  & 0.12875508E-06_JPRB, 0.16554730E-06_JPRB, 0.21190161E-06_JPRB, 0.25932828E-06_JPRB, 0.30707241E-06_JPRB, 0.36045122E-06_JPRB, &
  & 0.41546585E-06_JPRB, 0.46613551E-06_JPRB, 0.51679225E-06_JPRB, 0.55897143E-06_JPRB, 0.59298279E-06_JPRB, 0.62078972E-06_JPRB, &
  & 0.63988601E-06_JPRB, 0.65616663E-06_JPRB, 0.67056414E-06_JPRB, 0.68302724E-06_JPRB, 0.69107813E-06_JPRB, 0.70258189E-06_JPRB, &
  & 0.72119844E-06_JPRB, 0.74987036E-06_JPRB, 0.75243190E-06_JPRB, 0.75221705E-06_JPRB  /)

RGHG7(:,44,11) = (/ &
  & 0.19470458E-06_JPRB, 0.19553008E-06_JPRB, 0.19532878E-06_JPRB, 0.19933710E-06_JPRB, 0.20238451E-06_JPRB, 0.20685367E-06_JPRB, &
  & 0.22150343E-06_JPRB, 0.24376793E-06_JPRB, 0.27449150E-06_JPRB, 0.31126926E-06_JPRB, 0.34937446E-06_JPRB, 0.38040668E-06_JPRB, &
  & 0.39662630E-06_JPRB, 0.39491334E-06_JPRB, 0.38159612E-06_JPRB, 0.35831677E-06_JPRB, 0.33030346E-06_JPRB, 0.30023517E-06_JPRB, &
  & 0.26992260E-06_JPRB, 0.23457842E-06_JPRB, 0.19852937E-06_JPRB, 0.16455244E-06_JPRB, 0.13391361E-06_JPRB, 0.11060647E-06_JPRB, &
  & 0.92702607E-07_JPRB, 0.79683434E-07_JPRB, 0.70324101E-07_JPRB, 0.63631901E-07_JPRB, 0.58000959E-07_JPRB, 0.53591553E-07_JPRB, &
  & 0.51257854E-07_JPRB, 0.49871244E-07_JPRB, 0.48483152E-07_JPRB, 0.47193081E-07_JPRB, 0.46946623E-07_JPRB, 0.49066482E-07_JPRB, &
  & 0.52898639E-07_JPRB, 0.56844140E-07_JPRB, 0.62173456E-07_JPRB, 0.70059860E-07_JPRB, 0.81413194E-07_JPRB, 0.97076125E-07_JPRB, &
  & 0.12066830E-06_JPRB, 0.15340831E-06_JPRB, 0.19418089E-06_JPRB, 0.23688698E-06_JPRB, 0.28021164E-06_JPRB, 0.32900529E-06_JPRB, &
  & 0.37814561E-06_JPRB, 0.42296731E-06_JPRB, 0.46840575E-06_JPRB, 0.50554184E-06_JPRB, 0.53649817E-06_JPRB, 0.56061475E-06_JPRB, &
  & 0.57720306E-06_JPRB, 0.59274701E-06_JPRB, 0.60563623E-06_JPRB, 0.61691495E-06_JPRB, 0.62479903E-06_JPRB, 0.63573063E-06_JPRB, &
  & 0.65092114E-06_JPRB, 0.67317841E-06_JPRB, 0.67766633E-06_JPRB, 0.67659260E-06_JPRB  /)

RGHG7(:,45,11) = (/ &
  & 0.20979458E-06_JPRB, 0.21094357E-06_JPRB, 0.21035408E-06_JPRB, 0.21236533E-06_JPRB, 0.21325607E-06_JPRB, 0.21348954E-06_JPRB, &
  & 0.22161755E-06_JPRB, 0.23666585E-06_JPRB, 0.25809420E-06_JPRB, 0.28417921E-06_JPRB, 0.31230768E-06_JPRB, 0.33604607E-06_JPRB, &
  & 0.34902206E-06_JPRB, 0.34738674E-06_JPRB, 0.33650224E-06_JPRB, 0.31715664E-06_JPRB, 0.29406915E-06_JPRB, 0.26966858E-06_JPRB, &
  & 0.24446730E-06_JPRB, 0.21389367E-06_JPRB, 0.18145487E-06_JPRB, 0.14963030E-06_JPRB, 0.12128616E-06_JPRB, 0.10039017E-06_JPRB, &
  & 0.84548074E-07_JPRB, 0.72809959E-07_JPRB, 0.64524645E-07_JPRB, 0.58483758E-07_JPRB, 0.53141809E-07_JPRB, 0.49060216E-07_JPRB, &
  & 0.47071583E-07_JPRB, 0.45835940E-07_JPRB, 0.44577247E-07_JPRB, 0.43369129E-07_JPRB, 0.43398725E-07_JPRB, 0.45466823E-07_JPRB, &
  & 0.49109194E-07_JPRB, 0.52735509E-07_JPRB, 0.57452332E-07_JPRB, 0.64277657E-07_JPRB, 0.74401693E-07_JPRB, 0.87817379E-07_JPRB, &
  & 0.10791144E-06_JPRB, 0.13498374E-06_JPRB, 0.16790175E-06_JPRB, 0.20380140E-06_JPRB, 0.24088468E-06_JPRB, 0.28328167E-06_JPRB, &
  & 0.32441214E-06_JPRB, 0.36129730E-06_JPRB, 0.39999832E-06_JPRB, 0.43048758E-06_JPRB, 0.45772151E-06_JPRB, 0.47712793E-06_JPRB, &
  & 0.49019656E-06_JPRB, 0.50470962E-06_JPRB, 0.51549394E-06_JPRB, 0.52521986E-06_JPRB, 0.53251733E-06_JPRB, 0.54243529E-06_JPRB, &
  & 0.55368774E-06_JPRB, 0.56806456E-06_JPRB, 0.57428212E-06_JPRB, 0.57196616E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART22',0,ZHOOK_HANDLE)



RGHG7(:,46,11) = (/ &
  & 0.21469654E-06_JPRB, 0.21514349E-06_JPRB, 0.21430221E-06_JPRB, 0.21535173E-06_JPRB, 0.21500878E-06_JPRB, 0.21425944E-06_JPRB, &
  & 0.21942490E-06_JPRB, 0.23078923E-06_JPRB, 0.24772991E-06_JPRB, 0.26831445E-06_JPRB, 0.29048022E-06_JPRB, 0.30960726E-06_JPRB, &
  & 0.31991613E-06_JPRB, 0.31786086E-06_JPRB, 0.30769941E-06_JPRB, 0.29033773E-06_JPRB, 0.26999581E-06_JPRB, 0.24854659E-06_JPRB, &
  & 0.22547575E-06_JPRB, 0.19755264E-06_JPRB, 0.16796034E-06_JPRB, 0.13819675E-06_JPRB, 0.11203193E-06_JPRB, 0.93099295E-07_JPRB, &
  & 0.78961844E-07_JPRB, 0.68465102E-07_JPRB, 0.60997476E-07_JPRB, 0.55460799E-07_JPRB, 0.50626891E-07_JPRB, 0.46819753E-07_JPRB, &
  & 0.44871994E-07_JPRB, 0.43664660E-07_JPRB, 0.42544460E-07_JPRB, 0.41360884E-07_JPRB, 0.41562948E-07_JPRB, 0.43610908E-07_JPRB, &
  & 0.47077649E-07_JPRB, 0.50484282E-07_JPRB, 0.54749775E-07_JPRB, 0.60932438E-07_JPRB, 0.70175220E-07_JPRB, 0.82092169E-07_JPRB, &
  & 0.99796799E-07_JPRB, 0.12310873E-06_JPRB, 0.15126436E-06_JPRB, 0.18237820E-06_JPRB, 0.21427955E-06_JPRB, 0.25187493E-06_JPRB, &
  & 0.28801577E-06_JPRB, 0.32061140E-06_JPRB, 0.35461536E-06_JPRB, 0.38173033E-06_JPRB, 0.40533015E-06_JPRB, 0.42202559E-06_JPRB, &
  & 0.43330920E-06_JPRB, 0.44604759E-06_JPRB, 0.45543577E-06_JPRB, 0.46372644E-06_JPRB, 0.47094152E-06_JPRB, 0.48074001E-06_JPRB, &
  & 0.48997958E-06_JPRB, 0.49989246E-06_JPRB, 0.50556896E-06_JPRB, 0.50291130E-06_JPRB  /)

RGHG7(:,47,11) = (/ &
  & 0.21840775E-06_JPRB, 0.21782547E-06_JPRB, 0.21671608E-06_JPRB, 0.21684448E-06_JPRB, 0.21523877E-06_JPRB, 0.21398779E-06_JPRB, &
  & 0.21638989E-06_JPRB, 0.22413894E-06_JPRB, 0.23677675E-06_JPRB, 0.25194702E-06_JPRB, 0.26792010E-06_JPRB, 0.28217343E-06_JPRB, &
  & 0.28946812E-06_JPRB, 0.28682040E-06_JPRB, 0.27716491E-06_JPRB, 0.26174061E-06_JPRB, 0.24418367E-06_JPRB, 0.22565348E-06_JPRB, &
  & 0.20448542E-06_JPRB, 0.17924783E-06_JPRB, 0.15284269E-06_JPRB, 0.12547919E-06_JPRB, 0.10184853E-06_JPRB, 0.85130037E-07_JPRB, &
  & 0.72921312E-07_JPRB, 0.63873278E-07_JPRB, 0.57313796E-07_JPRB, 0.52339305E-07_JPRB, 0.48145422E-07_JPRB, 0.44649649E-07_JPRB, &
  & 0.42688916E-07_JPRB, 0.41490231E-07_JPRB, 0.40534362E-07_JPRB, 0.39368084E-07_JPRB, 0.39751777E-07_JPRB, 0.41782439E-07_JPRB, &
  & 0.45045928E-07_JPRB, 0.48214714E-07_JPRB, 0.51982889E-07_JPRB, 0.57495255E-07_JPRB, 0.65773674E-07_JPRB, 0.76081909E-07_JPRB, &
  & 0.91204813E-07_JPRB, 0.11048631E-06_JPRB, 0.13367309E-06_JPRB, 0.15957591E-06_JPRB, 0.18560892E-06_JPRB, 0.21788948E-06_JPRB, &
  & 0.24878038E-06_JPRB, 0.27707314E-06_JPRB, 0.30597419E-06_JPRB, 0.32978524E-06_JPRB, 0.34913840E-06_JPRB, 0.36305319E-06_JPRB, &
  & 0.37258970E-06_JPRB, 0.38309665E-06_JPRB, 0.39098856E-06_JPRB, 0.39761862E-06_JPRB, 0.40483802E-06_JPRB, 0.41467543E-06_JPRB, &
  & 0.42193871E-06_JPRB, 0.42729789E-06_JPRB, 0.43188461E-06_JPRB, 0.42900640E-06_JPRB  /)

RGHG7(:,48,11) = (/ &
  & 0.21272888E-06_JPRB, 0.21095912E-06_JPRB, 0.20949749E-06_JPRB, 0.20931517E-06_JPRB, 0.20707059E-06_JPRB, 0.20601314E-06_JPRB, &
  & 0.20751860E-06_JPRB, 0.21364286E-06_JPRB, 0.22381929E-06_JPRB, 0.23596035E-06_JPRB, 0.24822873E-06_JPRB, 0.25861855E-06_JPRB, &
  & 0.26322033E-06_JPRB, 0.25934319E-06_JPRB, 0.24937751E-06_JPRB, 0.23496176E-06_JPRB, 0.21946561E-06_JPRB, 0.20299260E-06_JPRB, &
  & 0.18368679E-06_JPRB, 0.16129223E-06_JPRB, 0.13828386E-06_JPRB, 0.11411788E-06_JPRB, 0.93227952E-07_JPRB, 0.78530533E-07_JPRB, &
  & 0.67999825E-07_JPRB, 0.60284098E-07_JPRB, 0.54533055E-07_JPRB, 0.50019112E-07_JPRB, 0.46373785E-07_JPRB, 0.43195943E-07_JPRB, &
  & 0.41234276E-07_JPRB, 0.40023902E-07_JPRB, 0.39147117E-07_JPRB, 0.38029915E-07_JPRB, 0.38526140E-07_JPRB, 0.40587284E-07_JPRB, &
  & 0.43616873E-07_JPRB, 0.46511855E-07_JPRB, 0.49906555E-07_JPRB, 0.54924063E-07_JPRB, 0.62231352E-07_JPRB, 0.71150764E-07_JPRB, &
  & 0.84155553E-07_JPRB, 0.10039009E-06_JPRB, 0.11969847E-06_JPRB, 0.14097899E-06_JPRB, 0.16224954E-06_JPRB, 0.18954090E-06_JPRB, &
  & 0.21651562E-06_JPRB, 0.24152585E-06_JPRB, 0.26672968E-06_JPRB, 0.28828771E-06_JPRB, 0.30512198E-06_JPRB, 0.31712784E-06_JPRB, &
  & 0.32559610E-06_JPRB, 0.33409825E-06_JPRB, 0.34087558E-06_JPRB, 0.34600084E-06_JPRB, 0.35267881E-06_JPRB, 0.36205020E-06_JPRB, &
  & 0.36839872E-06_JPRB, 0.37170087E-06_JPRB, 0.37504270E-06_JPRB, 0.37176503E-06_JPRB  /)

RGHG7(:,49,11) = (/ &
  & 0.20217093E-06_JPRB, 0.19901420E-06_JPRB, 0.19712428E-06_JPRB, 0.19687539E-06_JPRB, 0.19420694E-06_JPRB, 0.19367987E-06_JPRB, &
  & 0.19504109E-06_JPRB, 0.20027103E-06_JPRB, 0.20855897E-06_JPRB, 0.21842983E-06_JPRB, 0.22772677E-06_JPRB, 0.23429744E-06_JPRB, &
  & 0.23606315E-06_JPRB, 0.23053496E-06_JPRB, 0.21985472E-06_JPRB, 0.20613356E-06_JPRB, 0.19259026E-06_JPRB, 0.17800353E-06_JPRB, &
  & 0.16074155E-06_JPRB, 0.14156698E-06_JPRB, 0.12241549E-06_JPRB, 0.10215300E-06_JPRB, 0.84392064E-07_JPRB, 0.71845000E-07_JPRB, &
  & 0.63058544E-07_JPRB, 0.56765291E-07_JPRB, 0.51864182E-07_JPRB, 0.47814041E-07_JPRB, 0.44734596E-07_JPRB, 0.41911819E-07_JPRB, &
  & 0.39954590E-07_JPRB, 0.38722024E-07_JPRB, 0.37894061E-07_JPRB, 0.36845652E-07_JPRB, 0.37435082E-07_JPRB, 0.39551704E-07_JPRB, &
  & 0.42308338E-07_JPRB, 0.44883763E-07_JPRB, 0.47921179E-07_JPRB, 0.52470448E-07_JPRB, 0.58699229E-07_JPRB, 0.66180633E-07_JPRB, &
  & 0.77050601E-07_JPRB, 0.90358086E-07_JPRB, 0.10586728E-06_JPRB, 0.12229674E-06_JPRB, 0.13879612E-06_JPRB, 0.16071048E-06_JPRB, &
  & 0.18395481E-06_JPRB, 0.20579388E-06_JPRB, 0.22754249E-06_JPRB, 0.24708332E-06_JPRB, 0.26191370E-06_JPRB, 0.27220193E-06_JPRB, &
  & 0.27979585E-06_JPRB, 0.28618093E-06_JPRB, 0.29189750E-06_JPRB, 0.29542720E-06_JPRB, 0.30125745E-06_JPRB, 0.30988321E-06_JPRB, &
  & 0.31570136E-06_JPRB, 0.31786064E-06_JPRB, 0.31975337E-06_JPRB, 0.31595198E-06_JPRB  /)

RGHG7(:,50,11) = (/ &
  & 0.18509949E-06_JPRB, 0.18115167E-06_JPRB, 0.17911014E-06_JPRB, 0.17925341E-06_JPRB, 0.17677806E-06_JPRB, 0.17685424E-06_JPRB, &
  & 0.17831107E-06_JPRB, 0.18319661E-06_JPRB, 0.19039242E-06_JPRB, 0.19912998E-06_JPRB, 0.20667055E-06_JPRB, 0.21038406E-06_JPRB, &
  & 0.20969346E-06_JPRB, 0.20287245E-06_JPRB, 0.19167871E-06_JPRB, 0.17869384E-06_JPRB, 0.16680888E-06_JPRB, 0.15437360E-06_JPRB, &
  & 0.13993335E-06_JPRB, 0.12419446E-06_JPRB, 0.10874175E-06_JPRB, 0.92258189E-07_JPRB, 0.77336381E-07_JPRB, 0.66642057E-07_JPRB, &
  & 0.59219288E-07_JPRB, 0.53979688E-07_JPRB, 0.49815183E-07_JPRB, 0.46095565E-07_JPRB, 0.43440604E-07_JPRB, 0.40902692E-07_JPRB, &
  & 0.38993067E-07_JPRB, 0.37714302E-07_JPRB, 0.36877787E-07_JPRB, 0.35949951E-07_JPRB, 0.36620341E-07_JPRB, 0.38791164E-07_JPRB, &
  & 0.41327284E-07_JPRB, 0.43636667E-07_JPRB, 0.46421664E-07_JPRB, 0.50552422E-07_JPRB, 0.55851582E-07_JPRB, 0.62124258E-07_JPRB, &
  & 0.71296561E-07_JPRB, 0.82260760E-07_JPRB, 0.94752037E-07_JPRB, 0.10727295E-06_JPRB, 0.11990289E-06_JPRB, 0.13740788E-06_JPRB, &
  & 0.15731208E-06_JPRB, 0.17610353E-06_JPRB, 0.19483423E-06_JPRB, 0.21244615E-06_JPRB, 0.22560293E-06_JPRB, 0.23405736E-06_JPRB, &
  & 0.24067305E-06_JPRB, 0.24555954E-06_JPRB, 0.25041863E-06_JPRB, 0.25278615E-06_JPRB, 0.25790072E-06_JPRB, 0.26549082E-06_JPRB, &
  & 0.27062927E-06_JPRB, 0.27216384E-06_JPRB, 0.27294806E-06_JPRB, 0.26919172E-06_JPRB  /)

RGHG7(:,51,11) = (/ &
  & 0.16321047E-06_JPRB, 0.15872021E-06_JPRB, 0.15666013E-06_JPRB, 0.15746870E-06_JPRB, 0.15552653E-06_JPRB, 0.15629352E-06_JPRB, &
  & 0.15797983E-06_JPRB, 0.16278192E-06_JPRB, 0.16921507E-06_JPRB, 0.17732442E-06_JPRB, 0.18360391E-06_JPRB, 0.18473270E-06_JPRB, &
  & 0.18158487E-06_JPRB, 0.17355380E-06_JPRB, 0.16191034E-06_JPRB, 0.14974377E-06_JPRB, 0.13949773E-06_JPRB, 0.12952896E-06_JPRB, &
  & 0.11854968E-06_JPRB, 0.10664036E-06_JPRB, 0.95105305E-07_JPRB, 0.82643711E-07_JPRB, 0.70640438E-07_JPRB, 0.61793671E-07_JPRB, &
  & 0.55645878E-07_JPRB, 0.51352078E-07_JPRB, 0.47924741E-07_JPRB, 0.44492572E-07_JPRB, 0.42222422E-07_JPRB, 0.39955732E-07_JPRB, &
  & 0.38120288E-07_JPRB, 0.36778934E-07_JPRB, 0.35903010E-07_JPRB, 0.35132807E-07_JPRB, 0.35884332E-07_JPRB, 0.38113108E-07_JPRB, &
  & 0.40438278E-07_JPRB, 0.42488029E-07_JPRB, 0.45055121E-07_JPRB, 0.48759342E-07_JPRB, 0.53131246E-07_JPRB, 0.58217036E-07_JPRB, &
  & 0.65782869E-07_JPRB, 0.74519338E-07_JPRB, 0.84156986E-07_JPRB, 0.92945700E-07_JPRB, 0.10186430E-06_JPRB, 0.11510855E-06_JPRB, &
  & 0.13160509E-06_JPRB, 0.14716506E-06_JPRB, 0.16286131E-06_JPRB, 0.17843327E-06_JPRB, 0.18995345E-06_JPRB, 0.19636328E-06_JPRB, &
  & 0.20186626E-06_JPRB, 0.20545690E-06_JPRB, 0.20949538E-06_JPRB, 0.21083364E-06_JPRB, 0.21524349E-06_JPRB, 0.22156094E-06_JPRB, &
  & 0.22588573E-06_JPRB, 0.22701694E-06_JPRB, 0.22678118E-06_JPRB, 0.22337256E-06_JPRB  /)

RGHG7(:,52,11) = (/ &
  & 0.14110009E-06_JPRB, 0.13706077E-06_JPRB, 0.13507553E-06_JPRB, 0.13614077E-06_JPRB, 0.13484653E-06_JPRB, 0.13592830E-06_JPRB, &
  & 0.13762308E-06_JPRB, 0.14177348E-06_JPRB, 0.14766809E-06_JPRB, 0.15545326E-06_JPRB, 0.16109066E-06_JPRB, 0.16107993E-06_JPRB, &
  & 0.15669390E-06_JPRB, 0.14845398E-06_JPRB, 0.13736037E-06_JPRB, 0.12637428E-06_JPRB, 0.11772130E-06_JPRB, 0.10992513E-06_JPRB, &
  & 0.10187022E-06_JPRB, 0.93036264E-07_JPRB, 0.84447699E-07_JPRB, 0.75235356E-07_JPRB, 0.65687024E-07_JPRB, 0.58384041E-07_JPRB, &
  & 0.53148375E-07_JPRB, 0.49439262E-07_JPRB, 0.46566213E-07_JPRB, 0.43374239E-07_JPRB, 0.41276751E-07_JPRB, 0.39158049E-07_JPRB, &
  & 0.37400893E-07_JPRB, 0.35971827E-07_JPRB, 0.35097234E-07_JPRB, 0.34465283E-07_JPRB, 0.35303553E-07_JPRB, 0.37616341E-07_JPRB, &
  & 0.39780211E-07_JPRB, 0.41689979E-07_JPRB, 0.44079848E-07_JPRB, 0.47394695E-07_JPRB, 0.51047328E-07_JPRB, 0.55219920E-07_JPRB, &
  & 0.61595377E-07_JPRB, 0.68736117E-07_JPRB, 0.76193043E-07_JPRB, 0.82404860E-07_JPRB, 0.88679807E-07_JPRB, 0.98971822E-07_JPRB, &
  & 0.11269485E-06_JPRB, 0.12549576E-06_JPRB, 0.13834248E-06_JPRB, 0.15151707E-06_JPRB, 0.16092942E-06_JPRB, 0.16536642E-06_JPRB, &
  & 0.16973821E-06_JPRB, 0.17231999E-06_JPRB, 0.17546205E-06_JPRB, 0.17650672E-06_JPRB, 0.18023216E-06_JPRB, 0.18535093E-06_JPRB, &
  & 0.18915457E-06_JPRB, 0.19000039E-06_JPRB, 0.18890579E-06_JPRB, 0.18558381E-06_JPRB  /)

RGHG7(:,53,11) = (/ &
  & 0.11693707E-06_JPRB, 0.11377102E-06_JPRB, 0.11190319E-06_JPRB, 0.11309074E-06_JPRB, 0.11254622E-06_JPRB, 0.11382613E-06_JPRB, &
  & 0.11544508E-06_JPRB, 0.11866718E-06_JPRB, 0.12406156E-06_JPRB, 0.13161068E-06_JPRB, 0.13678699E-06_JPRB, 0.13609135E-06_JPRB, &
  & 0.13082595E-06_JPRB, 0.12274380E-06_JPRB, 0.11263353E-06_JPRB, 0.10307229E-06_JPRB, 0.96136481E-07_JPRB, 0.90593180E-07_JPRB, &
  & 0.85516410E-07_JPRB, 0.79741311E-07_JPRB, 0.73987786E-07_JPRB, 0.68016538E-07_JPRB, 0.60963238E-07_JPRB, 0.55224542E-07_JPRB, &
  & 0.50842568E-07_JPRB, 0.47631238E-07_JPRB, 0.45291441E-07_JPRB, 0.42342855E-07_JPRB, 0.40351773E-07_JPRB, 0.38346814E-07_JPRB, &
  & 0.36676496E-07_JPRB, 0.35142247E-07_JPRB, 0.34284777E-07_JPRB, 0.33795923E-07_JPRB, 0.34730814E-07_JPRB, 0.37145116E-07_JPRB, &
  & 0.39152435E-07_JPRB, 0.40955798E-07_JPRB, 0.43168323E-07_JPRB, 0.46073447E-07_JPRB, 0.49022824E-07_JPRB, 0.52306255E-07_JPRB, &
  & 0.57545494E-07_JPRB, 0.63191661E-07_JPRB, 0.68532703E-07_JPRB, 0.72382801E-07_JPRB, 0.76189623E-07_JPRB, 0.83770126E-07_JPRB, &
  & 0.94716819E-07_JPRB, 0.10469492E-06_JPRB, 0.11450969E-06_JPRB, 0.12493607E-06_JPRB, 0.13187174E-06_JPRB, 0.13418796E-06_JPRB, &
  & 0.13732080E-06_JPRB, 0.13891435E-06_JPRB, 0.14105106E-06_JPRB, 0.14205903E-06_JPRB, 0.14504697E-06_JPRB, 0.14888887E-06_JPRB, &
  & 0.15223754E-06_JPRB, 0.15281796E-06_JPRB, 0.15085010E-06_JPRB, 0.14752200E-06_JPRB  /)

RGHG7(:,54,11) = (/ &
  & 0.98752063E-07_JPRB, 0.96602778E-07_JPRB, 0.94735891E-07_JPRB, 0.95702393E-07_JPRB, 0.95501333E-07_JPRB, 0.96668243E-07_JPRB, &
  & 0.97823121E-07_JPRB, 0.99824181E-07_JPRB, 0.10446232E-06_JPRB, 0.11158796E-06_JPRB, 0.11625984E-06_JPRB, 0.11578469E-06_JPRB, &
  & 0.11120866E-06_JPRB, 0.10424064E-06_JPRB, 0.95780288E-07_JPRB, 0.87897511E-07_JPRB, 0.82325637E-07_JPRB, 0.78140831E-07_JPRB, &
  & 0.74757653E-07_JPRB, 0.70944399E-07_JPRB, 0.66928963E-07_JPRB, 0.63035762E-07_JPRB, 0.57755664E-07_JPRB, 0.53039025E-07_JPRB, &
  & 0.49392165E-07_JPRB, 0.46566131E-07_JPRB, 0.44534244E-07_JPRB, 0.41820391E-07_JPRB, 0.39668352E-07_JPRB, 0.37646672E-07_JPRB, &
  & 0.36037926E-07_JPRB, 0.34471570E-07_JPRB, 0.33620630E-07_JPRB, 0.33266336E-07_JPRB, 0.34342896E-07_JPRB, 0.36860119E-07_JPRB, &
  & 0.38880664E-07_JPRB, 0.40635560E-07_JPRB, 0.42659628E-07_JPRB, 0.45165243E-07_JPRB, 0.47630552E-07_JPRB, 0.50365156E-07_JPRB, &
  & 0.54861805E-07_JPRB, 0.59480226E-07_JPRB, 0.63416056E-07_JPRB, 0.66017571E-07_JPRB, 0.68599594E-07_JPRB, 0.74551455E-07_JPRB, &
  & 0.83360009E-07_JPRB, 0.91045826E-07_JPRB, 0.98570714E-07_JPRB, 0.10651797E-06_JPRB, 0.11144626E-06_JPRB, 0.11259287E-06_JPRB, &
  & 0.11488530E-06_JPRB, 0.11550171E-06_JPRB, 0.11702229E-06_JPRB, 0.11791694E-06_JPRB, 0.12035697E-06_JPRB, 0.12364502E-06_JPRB, &
  & 0.12674906E-06_JPRB, 0.12683795E-06_JPRB, 0.12442191E-06_JPRB, 0.12132771E-06_JPRB  /)

RGHG7(:,55,11) = (/ &
  & 0.79393888E-07_JPRB, 0.78389815E-07_JPRB, 0.76508653E-07_JPRB, 0.77185122E-07_JPRB, 0.77311079E-07_JPRB, 0.78311885E-07_JPRB, &
  & 0.78901619E-07_JPRB, 0.79511555E-07_JPRB, 0.83278298E-07_JPRB, 0.89910168E-07_JPRB, 0.94017544E-07_JPRB, 0.93905749E-07_JPRB, &
  & 0.90299749E-07_JPRB, 0.84691707E-07_JPRB, 0.78146744E-07_JPRB, 0.72156648E-07_JPRB, 0.68049218E-07_JPRB, 0.65251643E-07_JPRB, &
  & 0.63575577E-07_JPRB, 0.61791262E-07_JPRB, 0.59556906E-07_JPRB, 0.57812680E-07_JPRB, 0.54401905E-07_JPRB, 0.50746128E-07_JPRB, &
  & 0.47897996E-07_JPRB, 0.45483979E-07_JPRB, 0.43763537E-07_JPRB, 0.41308574E-07_JPRB, 0.38943065E-07_JPRB, 0.36885698E-07_JPRB, &
  & 0.35341837E-07_JPRB, 0.33749527E-07_JPRB, 0.32904426E-07_JPRB, 0.32698069E-07_JPRB, 0.33937490E-07_JPRB, 0.36568909E-07_JPRB, &
  & 0.38626438E-07_JPRB, 0.40335266E-07_JPRB, 0.42149109E-07_JPRB, 0.44213509E-07_JPRB, 0.46171420E-07_JPRB, 0.48342827E-07_JPRB, &
  & 0.52068648E-07_JPRB, 0.55609986E-07_JPRB, 0.58082670E-07_JPRB, 0.59447486E-07_JPRB, 0.60836283E-07_JPRB, 0.65126451E-07_JPRB, &
  & 0.71650421E-07_JPRB, 0.76866734E-07_JPRB, 0.81952612E-07_JPRB, 0.87188993E-07_JPRB, 0.89955326E-07_JPRB, 0.89931421E-07_JPRB, &
  & 0.91345320E-07_JPRB, 0.90880757E-07_JPRB, 0.91770001E-07_JPRB, 0.92529051E-07_JPRB, 0.94387060E-07_JPRB, 0.97156683E-07_JPRB, &
  & 0.10001741E-06_JPRB, 0.99532075E-07_JPRB, 0.96675462E-07_JPRB, 0.93871948E-07_JPRB  /)

RGHG7(:,56,11) = (/ &
  & 0.68749839E-07_JPRB, 0.68091121E-07_JPRB, 0.66233907E-07_JPRB, 0.66702765E-07_JPRB, 0.66753952E-07_JPRB, 0.67520592E-07_JPRB, &
  & 0.67633670E-07_JPRB, 0.67354032E-07_JPRB, 0.70260516E-07_JPRB, 0.75728689E-07_JPRB, 0.79266511E-07_JPRB, 0.79539502E-07_JPRB, &
  & 0.77242077E-07_JPRB, 0.73067786E-07_JPRB, 0.68113042E-07_JPRB, 0.63736088E-07_JPRB, 0.60718266E-07_JPRB, 0.58661826E-07_JPRB, &
  & 0.57664098E-07_JPRB, 0.56843499E-07_JPRB, 0.55548391E-07_JPRB, 0.54718953E-07_JPRB, 0.52394338E-07_JPRB, 0.49243374E-07_JPRB, &
  & 0.46868363E-07_JPRB, 0.44734697E-07_JPRB, 0.43344567E-07_JPRB, 0.41160673E-07_JPRB, 0.38546131E-07_JPRB, 0.36369230E-07_JPRB, &
  & 0.34799259E-07_JPRB, 0.33309935E-07_JPRB, 0.32427393E-07_JPRB, 0.32326555E-07_JPRB, 0.33728509E-07_JPRB, 0.36530615E-07_JPRB, &
  & 0.38651409E-07_JPRB, 0.40247541E-07_JPRB, 0.41899915E-07_JPRB, 0.43571933E-07_JPRB, 0.45275255E-07_JPRB, 0.47255146E-07_JPRB, &
  & 0.50536919E-07_JPRB, 0.53432086E-07_JPRB, 0.55261776E-07_JPRB, 0.56193606E-07_JPRB, 0.57265209E-07_JPRB, 0.60637935E-07_JPRB, &
  & 0.65651030E-07_JPRB, 0.69414880E-07_JPRB, 0.73133845E-07_JPRB, 0.76781657E-07_JPRB, 0.78627896E-07_JPRB, 0.78494534E-07_JPRB, &
  & 0.79372545E-07_JPRB, 0.78628723E-07_JPRB, 0.79468644E-07_JPRB, 0.80050676E-07_JPRB, 0.81479161E-07_JPRB, 0.83832100E-07_JPRB, &
  & 0.86119880E-07_JPRB, 0.85365445E-07_JPRB, 0.82867230E-07_JPRB, 0.80641828E-07_JPRB  /)

RGHG7(:,57,11) = (/ &
  & 0.58329557E-07_JPRB, 0.57948191E-07_JPRB, 0.56165571E-07_JPRB, 0.56457418E-07_JPRB, 0.56452664E-07_JPRB, 0.56966462E-07_JPRB, &
  & 0.56676900E-07_JPRB, 0.55603855E-07_JPRB, 0.57649295E-07_JPRB, 0.61960957E-07_JPRB, 0.64899805E-07_JPRB, 0.65482622E-07_JPRB, &
  & 0.64357346E-07_JPRB, 0.61604254E-07_JPRB, 0.58175131E-07_JPRB, 0.55323742E-07_JPRB, 0.53395951E-07_JPRB, 0.52110319E-07_JPRB, &
  & 0.51777424E-07_JPRB, 0.51879540E-07_JPRB, 0.51537472E-07_JPRB, 0.51584489E-07_JPRB, 0.50337516E-07_JPRB, 0.47753077E-07_JPRB, &
  & 0.45814565E-07_JPRB, 0.43969092E-07_JPRB, 0.42885457E-07_JPRB, 0.40962565E-07_JPRB, 0.38177586E-07_JPRB, 0.35852117E-07_JPRB, &
  & 0.34263130E-07_JPRB, 0.32831996E-07_JPRB, 0.31919931E-07_JPRB, 0.31918606E-07_JPRB, 0.33519800E-07_JPRB, 0.36498333E-07_JPRB, &
  & 0.38695121E-07_JPRB, 0.40159559E-07_JPRB, 0.41626941E-07_JPRB, 0.42925979E-07_JPRB, 0.44402657E-07_JPRB, 0.46180324E-07_JPRB, &
  & 0.49001608E-07_JPRB, 0.51272113E-07_JPRB, 0.52480271E-07_JPRB, 0.52979751E-07_JPRB, 0.53716663E-07_JPRB, 0.56192465E-07_JPRB, &
  & 0.59735352E-07_JPRB, 0.62122268E-07_JPRB, 0.64530319E-07_JPRB, 0.66733130E-07_JPRB, 0.67699055E-07_JPRB, 0.67429669E-07_JPRB, &
  & 0.67820667E-07_JPRB, 0.66906315E-07_JPRB, 0.67673635E-07_JPRB, 0.68075090E-07_JPRB, 0.69071987E-07_JPRB, 0.70965926E-07_JPRB, &
  & 0.72686836E-07_JPRB, 0.71695181E-07_JPRB, 0.69584478E-07_JPRB, 0.67837829E-07_JPRB  /)

RGHG7(:,58,11) = (/ &
  & 0.50759087E-07_JPRB, 0.50367955E-07_JPRB, 0.48746637E-07_JPRB, 0.48942848E-07_JPRB, 0.48843132E-07_JPRB, 0.49080123E-07_JPRB, &
  & 0.48561910E-07_JPRB, 0.47015737E-07_JPRB, 0.48270159E-07_JPRB, 0.51404892E-07_JPRB, 0.53742309E-07_JPRB, 0.54487439E-07_JPRB, &
  & 0.54273062E-07_JPRB, 0.52819475E-07_JPRB, 0.50623182E-07_JPRB, 0.48974315E-07_JPRB, 0.47979313E-07_JPRB, 0.47331479E-07_JPRB, &
  & 0.47394262E-07_JPRB, 0.48075918E-07_JPRB, 0.48475703E-07_JPRB, 0.49032555E-07_JPRB, 0.48615325E-07_JPRB, 0.46551833E-07_JPRB, &
  & 0.44891811E-07_JPRB, 0.43299908E-07_JPRB, 0.42461425E-07_JPRB, 0.40763816E-07_JPRB, 0.37948193E-07_JPRB, 0.35421350E-07_JPRB, &
  & 0.33809801E-07_JPRB, 0.32380687E-07_JPRB, 0.31446734E-07_JPRB, 0.31518819E-07_JPRB, 0.33365165E-07_JPRB, 0.36526214E-07_JPRB, &
  & 0.38819313E-07_JPRB, 0.40118071E-07_JPRB, 0.41384752E-07_JPRB, 0.42382738E-07_JPRB, 0.43745595E-07_JPRB, 0.45388901E-07_JPRB, &
  & 0.47820233E-07_JPRB, 0.49633436E-07_JPRB, 0.50460059E-07_JPRB, 0.50713714E-07_JPRB, 0.51277538E-07_JPRB, 0.53102746E-07_JPRB, &
  & 0.55507430E-07_JPRB, 0.56946403E-07_JPRB, 0.58444565E-07_JPRB, 0.59771498E-07_JPRB, 0.60227926E-07_JPRB, 0.59987500E-07_JPRB, &
  & 0.60077446E-07_JPRB, 0.59340223E-07_JPRB, 0.60110574E-07_JPRB, 0.60332206E-07_JPRB, 0.60957334E-07_JPRB, 0.62376797E-07_JPRB, &
  & 0.63524902E-07_JPRB, 0.62426161E-07_JPRB, 0.60870753E-07_JPRB, 0.59450412E-07_JPRB  /)

RGHG7(:,59,11) = (/ &
  & 0.45430336E-07_JPRB, 0.44905404E-07_JPRB, 0.43441275E-07_JPRB, 0.43634412E-07_JPRB, 0.43464862E-07_JPRB, 0.43430488E-07_JPRB, &
  & 0.42842107E-07_JPRB, 0.41068457E-07_JPRB, 0.41684378E-07_JPRB, 0.43914739E-07_JPRB, 0.45783304E-07_JPRB, 0.46582347E-07_JPRB, &
  & 0.46935829E-07_JPRB, 0.46417512E-07_JPRB, 0.45130481E-07_JPRB, 0.44293507E-07_JPRB, 0.44002255E-07_JPRB, 0.43850719E-07_JPRB, &
  & 0.44208874E-07_JPRB, 0.45174350E-07_JPRB, 0.46068184E-07_JPRB, 0.46907486E-07_JPRB, 0.47085399E-07_JPRB, 0.45554538E-07_JPRB, &
  & 0.44139356E-07_JPRB, 0.42817228E-07_JPRB, 0.42078967E-07_JPRB, 0.40501440E-07_JPRB, 0.37735274E-07_JPRB, 0.35008018E-07_JPRB, &
  & 0.33376742E-07_JPRB, 0.31860277E-07_JPRB, 0.30895254E-07_JPRB, 0.31065782E-07_JPRB, 0.33135469E-07_JPRB, 0.36533761E-07_JPRB, &
  & 0.38903024E-07_JPRB, 0.40072570E-07_JPRB, 0.41219772E-07_JPRB, 0.42041543E-07_JPRB, 0.43338460E-07_JPRB, 0.44840115E-07_JPRB, &
  & 0.46984751E-07_JPRB, 0.48469931E-07_JPRB, 0.49026755E-07_JPRB, 0.49169835E-07_JPRB, 0.49609226E-07_JPRB, 0.51005417E-07_JPRB, &
  & 0.52592549E-07_JPRB, 0.53482326E-07_JPRB, 0.54431689E-07_JPRB, 0.55235141E-07_JPRB, 0.55430373E-07_JPRB, 0.55244390E-07_JPRB, &
  & 0.55243600E-07_JPRB, 0.54724827E-07_JPRB, 0.55436298E-07_JPRB, 0.55499486E-07_JPRB, 0.55895295E-07_JPRB, 0.56903981E-07_JPRB, &
  & 0.57609887E-07_JPRB, 0.56572536E-07_JPRB, 0.55412305E-07_JPRB, 0.54139139E-07_JPRB  /)

RGHG7(:,60,11) = (/ &
  & 0.40961809E-07_JPRB, 0.40267790E-07_JPRB, 0.38957323E-07_JPRB, 0.39166076E-07_JPRB, 0.38938621E-07_JPRB, 0.38639747E-07_JPRB, &
  & 0.38035431E-07_JPRB, 0.36134480E-07_JPRB, 0.36177730E-07_JPRB, 0.37619856E-07_JPRB, 0.39064847E-07_JPRB, 0.39884740E-07_JPRB, &
  & 0.40665276E-07_JPRB, 0.40914135E-07_JPRB, 0.40402091E-07_JPRB, 0.40226978E-07_JPRB, 0.40536349E-07_JPRB, 0.40842567E-07_JPRB, &
  & 0.41457561E-07_JPRB, 0.42594174E-07_JPRB, 0.43863196E-07_JPRB, 0.44897608E-07_JPRB, 0.45578080E-07_JPRB, 0.44583148E-07_JPRB, &
  & 0.43420007E-07_JPRB, 0.42372573E-07_JPRB, 0.41685790E-07_JPRB, 0.40149855E-07_JPRB, 0.37443084E-07_JPRB, 0.34548984E-07_JPRB, &
  & 0.32893548E-07_JPRB, 0.31287266E-07_JPRB, 0.30299508E-07_JPRB, 0.30531934E-07_JPRB, 0.32815979E-07_JPRB, 0.36481095E-07_JPRB, &
  & 0.38936516E-07_JPRB, 0.40026421E-07_JPRB, 0.41077655E-07_JPRB, 0.41780385E-07_JPRB, 0.43019157E-07_JPRB, 0.44381249E-07_JPRB, &
  & 0.46282268E-07_JPRB, 0.47490252E-07_JPRB, 0.47820478E-07_JPRB, 0.47901215E-07_JPRB, 0.48235834E-07_JPRB, 0.49284023E-07_JPRB, &
  & 0.50191515E-07_JPRB, 0.50686461E-07_JPRB, 0.51232798E-07_JPRB, 0.51645761E-07_JPRB, 0.51680618E-07_JPRB, 0.51560828E-07_JPRB, &
  & 0.51543595E-07_JPRB, 0.51248144E-07_JPRB, 0.51869969E-07_JPRB, 0.51783870E-07_JPRB, 0.52011782E-07_JPRB, 0.52644432E-07_JPRB, &
  & 0.52972530E-07_JPRB, 0.52059358E-07_JPRB, 0.51219046E-07_JPRB, 0.50035126E-07_JPRB  /)

RGHG7(:,61,11) = (/ &
  & 0.37879686E-07_JPRB, 0.37057145E-07_JPRB, 0.35866437E-07_JPRB, 0.36047076E-07_JPRB, 0.35787855E-07_JPRB, 0.35288165E-07_JPRB, &
  & 0.34690786E-07_JPRB, 0.32780341E-07_JPRB, 0.32418307E-07_JPRB, 0.33327356E-07_JPRB, 0.34433514E-07_JPRB, 0.35273488E-07_JPRB, &
  & 0.36272732E-07_JPRB, 0.36941116E-07_JPRB, 0.36941703E-07_JPRB, 0.37205100E-07_JPRB, 0.37887991E-07_JPRB, 0.38600589E-07_JPRB, &
  & 0.39401065E-07_JPRB, 0.40596462E-07_JPRB, 0.42009342E-07_JPRB, 0.43139416E-07_JPRB, 0.44161276E-07_JPRB, 0.43614714E-07_JPRB, &
  & 0.42735271E-07_JPRB, 0.41917864E-07_JPRB, 0.41259195E-07_JPRB, 0.39571004E-07_JPRB, 0.36852915E-07_JPRB, 0.33954799E-07_JPRB, &
  & 0.32257374E-07_JPRB, 0.30679206E-07_JPRB, 0.29718102E-07_JPRB, 0.29821275E-07_JPRB, 0.32276197E-07_JPRB, 0.36216615E-07_JPRB, &
  & 0.38810782E-07_JPRB, 0.39990142E-07_JPRB, 0.40953747E-07_JPRB, 0.41631648E-07_JPRB, 0.42792649E-07_JPRB, 0.44055428E-07_JPRB, &
  & 0.45796889E-07_JPRB, 0.46815740E-07_JPRB, 0.46990425E-07_JPRB, 0.47044142E-07_JPRB, 0.47309388E-07_JPRB, 0.48115136E-07_JPRB, &
  & 0.48608581E-07_JPRB, 0.48896503E-07_JPRB, 0.49241658E-07_JPRB, 0.49422769E-07_JPRB, 0.49419654E-07_JPRB, 0.49371062E-07_JPRB, &
  & 0.49376467E-07_JPRB, 0.49235828E-07_JPRB, 0.49735336E-07_JPRB, 0.49534224E-07_JPRB, 0.49691303E-07_JPRB, 0.50069463E-07_JPRB, &
  & 0.50177758E-07_JPRB, 0.49411364E-07_JPRB, 0.48735357E-07_JPRB, 0.47617159E-07_JPRB  /)

RGHG7(:,62,11) = (/ &
  & 0.35515720E-07_JPRB, 0.34635969E-07_JPRB, 0.33566679E-07_JPRB, 0.33637757E-07_JPRB, 0.33341163E-07_JPRB, 0.32695879E-07_JPRB, &
  & 0.32051330E-07_JPRB, 0.30166228E-07_JPRB, 0.29475992E-07_JPRB, 0.30007414E-07_JPRB, 0.30824209E-07_JPRB, 0.31670580E-07_JPRB, &
  & 0.32754681E-07_JPRB, 0.33719738E-07_JPRB, 0.34067123E-07_JPRB, 0.34668410E-07_JPRB, 0.35598339E-07_JPRB, 0.36661892E-07_JPRB, &
  & 0.37627276E-07_JPRB, 0.38839544E-07_JPRB, 0.40274370E-07_JPRB, 0.41466937E-07_JPRB, 0.42753226E-07_JPRB, 0.42593378E-07_JPRB, &
  & 0.41979113E-07_JPRB, 0.41342846E-07_JPRB, 0.40711026E-07_JPRB, 0.38712464E-07_JPRB, 0.35949448E-07_JPRB, 0.33169903E-07_JPRB, &
  & 0.31445098E-07_JPRB, 0.29947028E-07_JPRB, 0.28942879E-07_JPRB, 0.28896459E-07_JPRB, 0.31452835E-07_JPRB, 0.35691660E-07_JPRB, &
  & 0.38446838E-07_JPRB, 0.39847708E-07_JPRB, 0.40768192E-07_JPRB, 0.41482101E-07_JPRB, 0.42532578E-07_JPRB, 0.43777210E-07_JPRB, &
  & 0.45420517E-07_JPRB, 0.46283667E-07_JPRB, 0.46342179E-07_JPRB, 0.46357744E-07_JPRB, 0.46593571E-07_JPRB, 0.47189421E-07_JPRB, &
  & 0.47399412E-07_JPRB, 0.47561285E-07_JPRB, 0.47760740E-07_JPRB, 0.47788560E-07_JPRB, 0.47781399E-07_JPRB, 0.47778436E-07_JPRB, &
  & 0.47813417E-07_JPRB, 0.47797388E-07_JPRB, 0.48170410E-07_JPRB, 0.47887647E-07_JPRB, 0.48006232E-07_JPRB, 0.48209904E-07_JPRB, &
  & 0.48196802E-07_JPRB, 0.47560244E-07_JPRB, 0.47008101E-07_JPRB, 0.45990157E-07_JPRB  /)

RGHG7(:,63,11) = (/ &
  & 0.33615012E-07_JPRB, 0.32732275E-07_JPRB, 0.31792633E-07_JPRB, 0.31700064E-07_JPRB, 0.31352507E-07_JPRB, 0.30594489E-07_JPRB, &
  & 0.29864310E-07_JPRB, 0.28010972E-07_JPRB, 0.27042795E-07_JPRB, 0.27281452E-07_JPRB, 0.27842216E-07_JPRB, 0.28679770E-07_JPRB, &
  & 0.29752505E-07_JPRB, 0.30939259E-07_JPRB, 0.31541928E-07_JPRB, 0.32409938E-07_JPRB, 0.33516795E-07_JPRB, 0.34853391E-07_JPRB, &
  & 0.35972284E-07_JPRB, 0.37193413E-07_JPRB, 0.38605315E-07_JPRB, 0.39840535E-07_JPRB, 0.41315057E-07_JPRB, 0.41510849E-07_JPRB, &
  & 0.41129549E-07_JPRB, 0.40621875E-07_JPRB, 0.39986042E-07_JPRB, 0.37670226E-07_JPRB, 0.34909442E-07_JPRB, 0.32287289E-07_JPRB, &
  & 0.30514563E-07_JPRB, 0.29080958E-07_JPRB, 0.27977153E-07_JPRB, 0.27784450E-07_JPRB, 0.30366479E-07_JPRB, 0.34939737E-07_JPRB, &
  & 0.37917785E-07_JPRB, 0.39595952E-07_JPRB, 0.40532884E-07_JPRB, 0.41304042E-07_JPRB, 0.42239685E-07_JPRB, 0.43513954E-07_JPRB, &
  & 0.45092170E-07_JPRB, 0.45817133E-07_JPRB, 0.45795626E-07_JPRB, 0.45773407E-07_JPRB, 0.46007042E-07_JPRB, 0.46407976E-07_JPRB, &
  & 0.46412276E-07_JPRB, 0.46497628E-07_JPRB, 0.46584579E-07_JPRB, 0.46511566E-07_JPRB, 0.46514226E-07_JPRB, 0.46540879E-07_JPRB, &
  & 0.46604820E-07_JPRB, 0.46688379E-07_JPRB, 0.46936830E-07_JPRB, 0.46606203E-07_JPRB, 0.46700482E-07_JPRB, 0.46774224E-07_JPRB, &
  & 0.46696492E-07_JPRB, 0.46178105E-07_JPRB, 0.45738392E-07_JPRB, 0.44839731E-07_JPRB  /)

RGHG7(:,64,11) = (/ &
  & 0.32206867E-07_JPRB, 0.31383232E-07_JPRB, 0.30586951E-07_JPRB, 0.30285929E-07_JPRB, 0.29861300E-07_JPRB, 0.29020219E-07_JPRB, &
  & 0.28167444E-07_JPRB, 0.26324888E-07_JPRB, 0.25135878E-07_JPRB, 0.25145316E-07_JPRB, 0.25492435E-07_JPRB, 0.26297642E-07_JPRB, &
  & 0.27256966E-07_JPRB, 0.28595868E-07_JPRB, 0.29385825E-07_JPRB, 0.30435932E-07_JPRB, 0.31667782E-07_JPRB, 0.33129371E-07_JPRB, &
  & 0.34388430E-07_JPRB, 0.35641107E-07_JPRB, 0.37044224E-07_JPRB, 0.38305001E-07_JPRB, 0.39849407E-07_JPRB, 0.40372655E-07_JPRB, &
  & 0.40153885E-07_JPRB, 0.39688940E-07_JPRB, 0.38973639E-07_JPRB, 0.36498089E-07_JPRB, 0.33891449E-07_JPRB, 0.31391493E-07_JPRB, &
  & 0.29506553E-07_JPRB, 0.28042599E-07_JPRB, 0.26773468E-07_JPRB, 0.26469350E-07_JPRB, 0.28958334E-07_JPRB, 0.33918948E-07_JPRB, &
  & 0.37242422E-07_JPRB, 0.39190541E-07_JPRB, 0.40246076E-07_JPRB, 0.41062758E-07_JPRB, 0.41910947E-07_JPRB, 0.43249509E-07_JPRB, &
  & 0.44784596E-07_JPRB, 0.45386165E-07_JPRB, 0.45337503E-07_JPRB, 0.45291324E-07_JPRB, 0.45549718E-07_JPRB, 0.45767356E-07_JPRB, &
  & 0.45633885E-07_JPRB, 0.45686091E-07_JPRB, 0.45690779E-07_JPRB, 0.45571044E-07_JPRB, 0.45582889E-07_JPRB, 0.45624317E-07_JPRB, &
  & 0.45707427E-07_JPRB, 0.45855278E-07_JPRB, 0.45993113E-07_JPRB, 0.45666480E-07_JPRB, 0.45739593E-07_JPRB, 0.45717495E-07_JPRB, &
  & 0.45618199E-07_JPRB, 0.45201642E-07_JPRB, 0.44882929E-07_JPRB, 0.44110857E-07_JPRB  /)

RGHG7(:,65,11) = (/ &
  & 0.31286766E-07_JPRB, 0.30549445E-07_JPRB, 0.29866770E-07_JPRB, 0.29352731E-07_JPRB, 0.28825168E-07_JPRB, 0.27919347E-07_JPRB, &
  & 0.26931147E-07_JPRB, 0.25057456E-07_JPRB, 0.23680494E-07_JPRB, 0.23511743E-07_JPRB, 0.23710118E-07_JPRB, 0.24419546E-07_JPRB, &
  & 0.25252700E-07_JPRB, 0.26612963E-07_JPRB, 0.27534027E-07_JPRB, 0.28656490E-07_JPRB, 0.29944782E-07_JPRB, 0.31452405E-07_JPRB, &
  & 0.32794347E-07_JPRB, 0.34095910E-07_JPRB, 0.35573801E-07_JPRB, 0.36846207E-07_JPRB, 0.38338004E-07_JPRB, 0.39147720E-07_JPRB, &
  & 0.39114649E-07_JPRB, 0.38629202E-07_JPRB, 0.37772871E-07_JPRB, 0.35390968E-07_JPRB, 0.33138495E-07_JPRB, 0.30659829E-07_JPRB, &
  & 0.28641376E-07_JPRB, 0.27045002E-07_JPRB, 0.25595904E-07_JPRB, 0.25143097E-07_JPRB, 0.27449122E-07_JPRB, 0.32757305E-07_JPRB, &
  & 0.36463778E-07_JPRB, 0.38686137E-07_JPRB, 0.39889056E-07_JPRB, 0.40763503E-07_JPRB, 0.41591216E-07_JPRB, 0.42950704E-07_JPRB, &
  & 0.44409626E-07_JPRB, 0.44925884E-07_JPRB, 0.44912674E-07_JPRB, 0.44888440E-07_JPRB, 0.45160260E-07_JPRB, 0.45228885E-07_JPRB, &
  & 0.45017176E-07_JPRB, 0.45066091E-07_JPRB, 0.45018366E-07_JPRB, 0.44871994E-07_JPRB, 0.44886032E-07_JPRB, 0.44955357E-07_JPRB, &
  & 0.45044400E-07_JPRB, 0.45207231E-07_JPRB, 0.45256650E-07_JPRB, 0.44981986E-07_JPRB, 0.45011101E-07_JPRB, 0.44904696E-07_JPRB, &
  & 0.44808574E-07_JPRB, 0.44480130E-07_JPRB, 0.44277020E-07_JPRB, 0.43613919E-07_JPRB  /)

RGHG7(:,66,11) = (/ &
  & 0.30627446E-07_JPRB, 0.29958146E-07_JPRB, 0.29329822E-07_JPRB, 0.28631533E-07_JPRB, 0.27989243E-07_JPRB, 0.27026130E-07_JPRB, &
  & 0.25901903E-07_JPRB, 0.23973207E-07_JPRB, 0.22402869E-07_JPRB, 0.22079098E-07_JPRB, 0.22177590E-07_JPRB, 0.22756705E-07_JPRB, &
  & 0.23473990E-07_JPRB, 0.24796397E-07_JPRB, 0.25809801E-07_JPRB, 0.26953028E-07_JPRB, 0.28258797E-07_JPRB, 0.29782538E-07_JPRB, &
  & 0.31163625E-07_JPRB, 0.32493964E-07_JPRB, 0.34058694E-07_JPRB, 0.35364659E-07_JPRB, 0.36801446E-07_JPRB, 0.37838629E-07_JPRB, &
  & 0.37997870E-07_JPRB, 0.37520487E-07_JPRB, 0.36527231E-07_JPRB, 0.34345011E-07_JPRB, 0.32424441E-07_JPRB, 0.29922074E-07_JPRB, &
  & 0.27810966E-07_JPRB, 0.26107323E-07_JPRB, 0.24438492E-07_JPRB, 0.23816118E-07_JPRB, 0.26078702E-07_JPRB, 0.31577817E-07_JPRB, &
  & 0.35678765E-07_JPRB, 0.38108781E-07_JPRB, 0.39439655E-07_JPRB, 0.40426378E-07_JPRB, 0.41252335E-07_JPRB, 0.42613686E-07_JPRB, &
  & 0.43975046E-07_JPRB, 0.44429815E-07_JPRB, 0.44487800E-07_JPRB, 0.44500226E-07_JPRB, 0.44769713E-07_JPRB, 0.44722955E-07_JPRB, &
  & 0.44475593E-07_JPRB, 0.44524629E-07_JPRB, 0.44428164E-07_JPRB, 0.44256018E-07_JPRB, 0.44267239E-07_JPRB, 0.44365016E-07_JPRB, &
  & 0.44467621E-07_JPRB, 0.44631169E-07_JPRB, 0.44602901E-07_JPRB, 0.44385441E-07_JPRB, 0.44346249E-07_JPRB, 0.44173149E-07_JPRB, &
  & 0.44094040E-07_JPRB, 0.43850248E-07_JPRB, 0.43729453E-07_JPRB, 0.43187978E-07_JPRB  /)

RGHG7(:,67,11) = (/ &
  & 0.30207708E-07_JPRB, 0.29567394E-07_JPRB, 0.28930278E-07_JPRB, 0.28087797E-07_JPRB, 0.27322340E-07_JPRB, 0.26308572E-07_JPRB, &
  & 0.25055445E-07_JPRB, 0.23046579E-07_JPRB, 0.21273145E-07_JPRB, 0.20818713E-07_JPRB, 0.20859319E-07_JPRB, 0.21290729E-07_JPRB, &
  & 0.21905951E-07_JPRB, 0.23141711E-07_JPRB, 0.24202308E-07_JPRB, 0.25329792E-07_JPRB, 0.26620149E-07_JPRB, 0.28131371E-07_JPRB, &
  & 0.29517647E-07_JPRB, 0.30853476E-07_JPRB, 0.32498513E-07_JPRB, 0.33864567E-07_JPRB, 0.35275156E-07_JPRB, 0.36457662E-07_JPRB, &
  & 0.36798112E-07_JPRB, 0.36369511E-07_JPRB, 0.35262297E-07_JPRB, 0.33339008E-07_JPRB, 0.31686551E-07_JPRB, 0.29131398E-07_JPRB, &
  & 0.26964323E-07_JPRB, 0.25201663E-07_JPRB, 0.23271488E-07_JPRB, 0.22533133E-07_JPRB, 0.24900629E-07_JPRB, 0.30408856E-07_JPRB, &
  & 0.34878976E-07_JPRB, 0.37462482E-07_JPRB, 0.38900413E-07_JPRB, 0.40027836E-07_JPRB, 0.40885138E-07_JPRB, 0.42229520E-07_JPRB, &
  & 0.43476985E-07_JPRB, 0.43903797E-07_JPRB, 0.44057352E-07_JPRB, 0.44110064E-07_JPRB, 0.44366205E-07_JPRB, 0.44239688E-07_JPRB, &
  & 0.43996127E-07_JPRB, 0.44044006E-07_JPRB, 0.43900130E-07_JPRB, 0.43701321E-07_JPRB, 0.43706485E-07_JPRB, 0.43829599E-07_JPRB, &
  & 0.43955875E-07_JPRB, 0.44113830E-07_JPRB, 0.44021692E-07_JPRB, 0.43851028E-07_JPRB, 0.43729152E-07_JPRB, 0.43511185E-07_JPRB, &
  & 0.43454077E-07_JPRB, 0.43286353E-07_JPRB, 0.43218653E-07_JPRB, 0.42813275E-07_JPRB  /)

RGHG7(:,68,11) = (/ &
  & 0.30007761E-07_JPRB, 0.29323572E-07_JPRB, 0.28615107E-07_JPRB, 0.27682416E-07_JPRB, 0.26788615E-07_JPRB, 0.25730151E-07_JPRB, &
  & 0.24367542E-07_JPRB, 0.22247144E-07_JPRB, 0.20256796E-07_JPRB, 0.19701082E-07_JPRB, 0.19710934E-07_JPRB, 0.20007850E-07_JPRB, &
  & 0.20535731E-07_JPRB, 0.21646017E-07_JPRB, 0.22694313E-07_JPRB, 0.23792683E-07_JPRB, 0.25043676E-07_JPRB, 0.26508153E-07_JPRB, &
  & 0.27886227E-07_JPRB, 0.29206065E-07_JPRB, 0.30899898E-07_JPRB, 0.32354931E-07_JPRB, 0.33810625E-07_JPRB, 0.35015684E-07_JPRB, &
  & 0.35493910E-07_JPRB, 0.35161670E-07_JPRB, 0.33988848E-07_JPRB, 0.32311177E-07_JPRB, 0.30823559E-07_JPRB, 0.28210999E-07_JPRB, &
  & 0.26000459E-07_JPRB, 0.24248871E-07_JPRB, 0.22015261E-07_JPRB, 0.21369576E-07_JPRB, 0.23957678E-07_JPRB, 0.29271133E-07_JPRB, &
  & 0.34016394E-07_JPRB, 0.36745466E-07_JPRB, 0.38278528E-07_JPRB, 0.39510103E-07_JPRB, 0.40471557E-07_JPRB, 0.41776574E-07_JPRB, &
  & 0.42901846E-07_JPRB, 0.43356130E-07_JPRB, 0.43610146E-07_JPRB, 0.43689102E-07_JPRB, 0.43932531E-07_JPRB, 0.43763370E-07_JPRB, &
  & 0.43557533E-07_JPRB, 0.43598031E-07_JPRB, 0.43407409E-07_JPRB, 0.43180717E-07_JPRB, 0.43180140E-07_JPRB, 0.43320477E-07_JPRB, &
  & 0.43481606E-07_JPRB, 0.43638332E-07_JPRB, 0.43503549E-07_JPRB, 0.43344776E-07_JPRB, 0.43147452E-07_JPRB, 0.42912673E-07_JPRB, &
  & 0.42865406E-07_JPRB, 0.42753448E-07_JPRB, 0.42726343E-07_JPRB, 0.42470631E-07_JPRB  /)

RGHG7(:,69,11) = (/ &
  & 0.29977575E-07_JPRB, 0.29153607E-07_JPRB, 0.28372688E-07_JPRB, 0.27382272E-07_JPRB, 0.26371346E-07_JPRB, 0.25255880E-07_JPRB, &
  & 0.23808813E-07_JPRB, 0.21564587E-07_JPRB, 0.19371918E-07_JPRB, 0.18733975E-07_JPRB, 0.18689195E-07_JPRB, 0.18895304E-07_JPRB, &
  & 0.19322427E-07_JPRB, 0.20294573E-07_JPRB, 0.21299967E-07_JPRB, 0.22341985E-07_JPRB, 0.23529737E-07_JPRB, 0.24926205E-07_JPRB, &
  & 0.26319218E-07_JPRB, 0.27639114E-07_JPRB, 0.29338816E-07_JPRB, 0.30851837E-07_JPRB, 0.32360839E-07_JPRB, 0.33523509E-07_JPRB, &
  & 0.34076415E-07_JPRB, 0.33814768E-07_JPRB, 0.32622627E-07_JPRB, 0.31188289E-07_JPRB, 0.29738219E-07_JPRB, 0.27144769E-07_JPRB, &
  & 0.24759033E-07_JPRB, 0.22930066E-07_JPRB, 0.20757319E-07_JPRB, 0.20462914E-07_JPRB, 0.23159993E-07_JPRB, 0.28151452E-07_JPRB, &
  & 0.32888920E-07_JPRB, 0.35844142E-07_JPRB, 0.37510011E-07_JPRB, 0.38871095E-07_JPRB, 0.39946758E-07_JPRB, 0.41186668E-07_JPRB, &
  & 0.42247240E-07_JPRB, 0.42798408E-07_JPRB, 0.43140925E-07_JPRB, 0.43228205E-07_JPRB, 0.43454073E-07_JPRB, 0.43275116E-07_JPRB, &
  & 0.43100653E-07_JPRB, 0.43125187E-07_JPRB, 0.42903503E-07_JPRB, 0.42661622E-07_JPRB, 0.42665009E-07_JPRB, 0.42813981E-07_JPRB, &
  & 0.43003240E-07_JPRB, 0.43162467E-07_JPRB, 0.43000722E-07_JPRB, 0.42828088E-07_JPRB, 0.42597500E-07_JPRB, 0.42372409E-07_JPRB, &
  & 0.42284600E-07_JPRB, 0.42205260E-07_JPRB, 0.42228072E-07_JPRB, 0.42171635E-07_JPRB  /)

RGHG7(:,70,11) = (/ &
  & 0.30001826E-07_JPRB, 0.29019991E-07_JPRB, 0.28182566E-07_JPRB, 0.27134893E-07_JPRB, 0.26019629E-07_JPRB, 0.24839874E-07_JPRB, &
  & 0.23323993E-07_JPRB, 0.20944707E-07_JPRB, 0.18574104E-07_JPRB, 0.17852073E-07_JPRB, 0.17752337E-07_JPRB, 0.17861762E-07_JPRB, &
  & 0.18197321E-07_JPRB, 0.19046480E-07_JPRB, 0.19986087E-07_JPRB, 0.20950604E-07_JPRB, 0.22064766E-07_JPRB, 0.23403618E-07_JPRB, &
  & 0.24793392E-07_JPRB, 0.26128752E-07_JPRB, 0.27808889E-07_JPRB, 0.29360753E-07_JPRB, 0.30885613E-07_JPRB, 0.31986771E-07_JPRB, &
  & 0.32567769E-07_JPRB, 0.32375980E-07_JPRB, 0.31171435E-07_JPRB, 0.29955197E-07_JPRB, 0.28550916E-07_JPRB, 0.25983452E-07_JPRB, &
  & 0.23380332E-07_JPRB, 0.21530390E-07_JPRB, 0.19620439E-07_JPRB, 0.19647073E-07_JPRB, 0.22399678E-07_JPRB, 0.27043780E-07_JPRB, &
  & 0.31592766E-07_JPRB, 0.34724882E-07_JPRB, 0.36557806E-07_JPRB, 0.38075708E-07_JPRB, 0.39299687E-07_JPRB, 0.40517806E-07_JPRB, &
  & 0.41555445E-07_JPRB, 0.42208159E-07_JPRB, 0.42635553E-07_JPRB, 0.42740605E-07_JPRB, 0.42933863E-07_JPRB, 0.42772162E-07_JPRB, &
  & 0.42608492E-07_JPRB, 0.42613801E-07_JPRB, 0.42371357E-07_JPRB, 0.42103833E-07_JPRB, 0.42127400E-07_JPRB, 0.42285368E-07_JPRB, &
  & 0.42500958E-07_JPRB, 0.42654959E-07_JPRB, 0.42474417E-07_JPRB, 0.42281777E-07_JPRB, 0.42037989E-07_JPRB, 0.41840234E-07_JPRB, &
  & 0.41696819E-07_JPRB, 0.41641205E-07_JPRB, 0.41706138E-07_JPRB, 0.41861423E-07_JPRB  /)

RGHG7(:,71,11) = (/ &
  & 0.30044924E-07_JPRB, 0.28907153E-07_JPRB, 0.28029916E-07_JPRB, 0.26930638E-07_JPRB, 0.25725970E-07_JPRB, 0.24477721E-07_JPRB, &
  & 0.22903207E-07_JPRB, 0.20378386E-07_JPRB, 0.17863302E-07_JPRB, 0.17046847E-07_JPRB, 0.16896193E-07_JPRB, 0.16904485E-07_JPRB, &
  & 0.17160486E-07_JPRB, 0.17900702E-07_JPRB, 0.18750289E-07_JPRB, 0.19624130E-07_JPRB, 0.20655604E-07_JPRB, 0.21945573E-07_JPRB, &
  & 0.23310038E-07_JPRB, 0.24668281E-07_JPRB, 0.26307095E-07_JPRB, 0.27879248E-07_JPRB, 0.29366771E-07_JPRB, 0.30396554E-07_JPRB, &
  & 0.30962160E-07_JPRB, 0.30816318E-07_JPRB, 0.29604813E-07_JPRB, 0.28565158E-07_JPRB, 0.27251953E-07_JPRB, 0.24728458E-07_JPRB, &
  & 0.21916861E-07_JPRB, 0.20150674E-07_JPRB, 0.18609704E-07_JPRB, 0.18894878E-07_JPRB, 0.21660449E-07_JPRB, 0.25947903E-07_JPRB, &
  & 0.30159508E-07_JPRB, 0.33405164E-07_JPRB, 0.35418357E-07_JPRB, 0.37103599E-07_JPRB, 0.38516638E-07_JPRB, 0.39771994E-07_JPRB, &
  & 0.40838138E-07_JPRB, 0.41578575E-07_JPRB, 0.42087599E-07_JPRB, 0.42218839E-07_JPRB, 0.42370621E-07_JPRB, 0.42250660E-07_JPRB, &
  & 0.42079261E-07_JPRB, 0.42060624E-07_JPRB, 0.41802770E-07_JPRB, 0.41502806E-07_JPRB, 0.41554593E-07_JPRB, 0.41720766E-07_JPRB, &
  & 0.41962548E-07_JPRB, 0.42105251E-07_JPRB, 0.41913224E-07_JPRB, 0.41701609E-07_JPRB, 0.41464963E-07_JPRB, 0.41308303E-07_JPRB, &
  & 0.41102042E-07_JPRB, 0.41064083E-07_JPRB, 0.41165268E-07_JPRB, 0.41512941E-07_JPRB  /)

RGHG7(:,72,11) = (/ &
  & 0.30062820E-07_JPRB, 0.28792882E-07_JPRB, 0.27890607E-07_JPRB, 0.26762187E-07_JPRB, 0.25486921E-07_JPRB, 0.24170536E-07_JPRB, &
  & 0.22538968E-07_JPRB, 0.19858584E-07_JPRB, 0.17248273E-07_JPRB, 0.16314428E-07_JPRB, 0.16120265E-07_JPRB, 0.16035794E-07_JPRB, &
  & 0.16224891E-07_JPRB, 0.16862082E-07_JPRB, 0.17592226E-07_JPRB, 0.18375767E-07_JPRB, 0.19314477E-07_JPRB, 0.20554370E-07_JPRB, &
  & 0.21872043E-07_JPRB, 0.23245474E-07_JPRB, 0.24823950E-07_JPRB, 0.26396103E-07_JPRB, 0.27770750E-07_JPRB, 0.28727061E-07_JPRB, &
  & 0.29235203E-07_JPRB, 0.29060629E-07_JPRB, 0.27853229E-07_JPRB, 0.26921524E-07_JPRB, 0.25789331E-07_JPRB, 0.23364756E-07_JPRB, &
  & 0.20433305E-07_JPRB, 0.18921602E-07_JPRB, 0.17708177E-07_JPRB, 0.18187497E-07_JPRB, 0.20931314E-07_JPRB, 0.24860849E-07_JPRB, &
  & 0.28621361E-07_JPRB, 0.31916273E-07_JPRB, 0.34083798E-07_JPRB, 0.35914751E-07_JPRB, 0.37567087E-07_JPRB, 0.38936140E-07_JPRB, &
  & 0.40105719E-07_JPRB, 0.40897873E-07_JPRB, 0.41484474E-07_JPRB, 0.41642804E-07_JPRB, 0.41758056E-07_JPRB, 0.41701304E-07_JPRB, &
  & 0.41510204E-07_JPRB, 0.41458731E-07_JPRB, 0.41182406E-07_JPRB, 0.40854941E-07_JPRB, 0.40926020E-07_JPRB, 0.41095477E-07_JPRB, &
  & 0.41365579E-07_JPRB, 0.41496380E-07_JPRB, 0.41300248E-07_JPRB, 0.41080424E-07_JPRB, 0.40877025E-07_JPRB, 0.40770030E-07_JPRB, &
  & 0.40500969E-07_JPRB, 0.40476965E-07_JPRB, 0.40615913E-07_JPRB, 0.41083029E-07_JPRB  /)

RGHG7(:,73,11) = (/ &
  & 0.30064346E-07_JPRB, 0.28662997E-07_JPRB, 0.27718777E-07_JPRB, 0.26614379E-07_JPRB, 0.25293628E-07_JPRB, 0.23911759E-07_JPRB, &
  & 0.22222426E-07_JPRB, 0.19389385E-07_JPRB, 0.16703866E-07_JPRB, 0.15642044E-07_JPRB, 0.15395358E-07_JPRB, 0.15245776E-07_JPRB, &
  & 0.15372913E-07_JPRB, 0.15920957E-07_JPRB, 0.16524488E-07_JPRB, 0.17213776E-07_JPRB, 0.18058422E-07_JPRB, 0.19214805E-07_JPRB, &
  & 0.20454557E-07_JPRB, 0.21805929E-07_JPRB, 0.23298956E-07_JPRB, 0.24803298E-07_JPRB, 0.26074319E-07_JPRB, 0.26891207E-07_JPRB, &
  & 0.27293551E-07_JPRB, 0.27088173E-07_JPRB, 0.26110428E-07_JPRB, 0.25153203E-07_JPRB, 0.24056785E-07_JPRB, 0.21939326E-07_JPRB, &
  & 0.19110948E-07_JPRB, 0.17840349E-07_JPRB, 0.16848179E-07_JPRB, 0.17499153E-07_JPRB, 0.20216899E-07_JPRB, 0.23834818E-07_JPRB, &
  & 0.27185810E-07_JPRB, 0.30402642E-07_JPRB, 0.32665965E-07_JPRB, 0.34664430E-07_JPRB, 0.36529642E-07_JPRB, 0.38026766E-07_JPRB, &
  & 0.39359048E-07_JPRB, 0.40179220E-07_JPRB, 0.40837371E-07_JPRB, 0.40976473E-07_JPRB, 0.41082410E-07_JPRB, 0.41103332E-07_JPRB, &
  & 0.40901939E-07_JPRB, 0.40797628E-07_JPRB, 0.40511869E-07_JPRB, 0.40144172E-07_JPRB, 0.40226274E-07_JPRB, 0.40393700E-07_JPRB, &
  & 0.40675526E-07_JPRB, 0.40788640E-07_JPRB, 0.40616951E-07_JPRB, 0.40383918E-07_JPRB, 0.40261198E-07_JPRB, 0.40182823E-07_JPRB, &
  & 0.39859359E-07_JPRB, 0.39849011E-07_JPRB, 0.40069751E-07_JPRB, 0.40576621E-07_JPRB  /)

RGHG7(:,74,11) = (/ &
  & 0.30071104E-07_JPRB, 0.28513020E-07_JPRB, 0.27510110E-07_JPRB, 0.26456737E-07_JPRB, 0.25132072E-07_JPRB, 0.23669150E-07_JPRB, &
  & 0.21934694E-07_JPRB, 0.18963285E-07_JPRB, 0.16214486E-07_JPRB, 0.15028643E-07_JPRB, 0.14722040E-07_JPRB, 0.14520649E-07_JPRB, &
  & 0.14583582E-07_JPRB, 0.15028873E-07_JPRB, 0.15520691E-07_JPRB, 0.16118963E-07_JPRB, 0.16867803E-07_JPRB, 0.17918125E-07_JPRB, &
  & 0.19071223E-07_JPRB, 0.20372641E-07_JPRB, 0.21734079E-07_JPRB, 0.23065341E-07_JPRB, 0.24255436E-07_JPRB, 0.24969391E-07_JPRB, &
  & 0.25309077E-07_JPRB, 0.25136453E-07_JPRB, 0.24362725E-07_JPRB, 0.23431735E-07_JPRB, 0.22380646E-07_JPRB, 0.20581540E-07_JPRB, &
  & 0.17985174E-07_JPRB, 0.16905714E-07_JPRB, 0.16076047E-07_JPRB, 0.16873796E-07_JPRB, 0.19573067E-07_JPRB, 0.22944574E-07_JPRB, &
  & 0.25942529E-07_JPRB, 0.29013397E-07_JPRB, 0.31322135E-07_JPRB, 0.33482328E-07_JPRB, 0.35553007E-07_JPRB, 0.37165146E-07_JPRB, &
  & 0.38616859E-07_JPRB, 0.39455836E-07_JPRB, 0.40161656E-07_JPRB, 0.40283600E-07_JPRB, 0.40357490E-07_JPRB, 0.40467380E-07_JPRB, &
  & 0.40260958E-07_JPRB, 0.40089792E-07_JPRB, 0.39798342E-07_JPRB, 0.39416155E-07_JPRB, 0.39491469E-07_JPRB, 0.39647001E-07_JPRB, &
  & 0.39937903E-07_JPRB, 0.40024436E-07_JPRB, 0.39869899E-07_JPRB, 0.39639609E-07_JPRB, 0.39610394E-07_JPRB, 0.39543223E-07_JPRB, &
  & 0.39181489E-07_JPRB, 0.39163441E-07_JPRB, 0.39460417E-07_JPRB, 0.40036234E-07_JPRB  /)

RGHG7(:,75,11) = (/ &
  & 0.30092111E-07_JPRB, 0.28347603E-07_JPRB, 0.27265744E-07_JPRB, 0.26287643E-07_JPRB, 0.24989746E-07_JPRB, 0.23438313E-07_JPRB, &
  & 0.21668143E-07_JPRB, 0.18577028E-07_JPRB, 0.15773559E-07_JPRB, 0.14474535E-07_JPRB, 0.14112035E-07_JPRB, 0.13865634E-07_JPRB, &
  & 0.13860455E-07_JPRB, 0.14191133E-07_JPRB, 0.14591384E-07_JPRB, 0.15096639E-07_JPRB, 0.15750368E-07_JPRB, 0.16675289E-07_JPRB, &
  & 0.17733880E-07_JPRB, 0.18948475E-07_JPRB, 0.20154316E-07_JPRB, 0.21239977E-07_JPRB, 0.22372573E-07_JPRB, 0.23049596E-07_JPRB, &
  & 0.23388355E-07_JPRB, 0.23303581E-07_JPRB, 0.22679025E-07_JPRB, 0.21800020E-07_JPRB, 0.20826215E-07_JPRB, 0.19302367E-07_JPRB, &
  & 0.17025852E-07_JPRB, 0.16117775E-07_JPRB, 0.15392200E-07_JPRB, 0.16316329E-07_JPRB, 0.19023231E-07_JPRB, 0.22230546E-07_JPRB, &
  & 0.24924307E-07_JPRB, 0.27791644E-07_JPRB, 0.30104582E-07_JPRB, 0.32420804E-07_JPRB, 0.34677432E-07_JPRB, 0.36374569E-07_JPRB, &
  & 0.37901699E-07_JPRB, 0.38757054E-07_JPRB, 0.39485764E-07_JPRB, 0.39587948E-07_JPRB, 0.39609303E-07_JPRB, 0.39788633E-07_JPRB, &
  & 0.39577313E-07_JPRB, 0.39335573E-07_JPRB, 0.39035874E-07_JPRB, 0.38664706E-07_JPRB, 0.38722370E-07_JPRB, 0.38860137E-07_JPRB, &
  & 0.39157791E-07_JPRB, 0.39204044E-07_JPRB, 0.39058615E-07_JPRB, 0.38843382E-07_JPRB, 0.38911405E-07_JPRB, 0.38843239E-07_JPRB, &
  & 0.38465002E-07_JPRB, 0.38425031E-07_JPRB, 0.38791962E-07_JPRB, 0.39470367E-07_JPRB  /)

RGHG7(:,76,11) = (/ &
  & 0.30138911E-07_JPRB, 0.28173935E-07_JPRB, 0.26986564E-07_JPRB, 0.26108228E-07_JPRB, 0.24848923E-07_JPRB, 0.23216611E-07_JPRB, &
  & 0.21413186E-07_JPRB, 0.18226411E-07_JPRB, 0.15372855E-07_JPRB, 0.13980225E-07_JPRB, 0.13583649E-07_JPRB, 0.13290855E-07_JPRB, &
  & 0.13211777E-07_JPRB, 0.13422163E-07_JPRB, 0.13756315E-07_JPRB, 0.14156878E-07_JPRB, 0.14719874E-07_JPRB, 0.15502744E-07_JPRB, &
  & 0.16456644E-07_JPRB, 0.17530830E-07_JPRB, 0.18594209E-07_JPRB, 0.19416704E-07_JPRB, 0.20514814E-07_JPRB, 0.21254242E-07_JPRB, &
  & 0.21671416E-07_JPRB, 0.21708166E-07_JPRB, 0.21167363E-07_JPRB, 0.20298622E-07_JPRB, 0.19447983E-07_JPRB, 0.18098620E-07_JPRB, &
  & 0.16181340E-07_JPRB, 0.15478129E-07_JPRB, 0.14790735E-07_JPRB, 0.15828178E-07_JPRB, 0.18597073E-07_JPRB, 0.21748142E-07_JPRB, &
  & 0.24172580E-07_JPRB, 0.26784553E-07_JPRB, 0.29072857E-07_JPRB, 0.31543858E-07_JPRB, 0.33945000E-07_JPRB, 0.35673751E-07_JPRB, &
  & 0.37245220E-07_JPRB, 0.38123156E-07_JPRB, 0.38850634E-07_JPRB, 0.38915869E-07_JPRB, 0.38874409E-07_JPRB, 0.39054970E-07_JPRB, &
  & 0.38831333E-07_JPRB, 0.38530474E-07_JPRB, 0.38210657E-07_JPRB, 0.37870692E-07_JPRB, 0.37911933E-07_JPRB, 0.38032868E-07_JPRB, &
  & 0.38333396E-07_JPRB, 0.38318065E-07_JPRB, 0.38177563E-07_JPRB, 0.37981216E-07_JPRB, 0.38141203E-07_JPRB, 0.38067289E-07_JPRB, &
  & 0.37702600E-07_JPRB, 0.37640460E-07_JPRB, 0.38077184E-07_JPRB, 0.38884093E-07_JPRB  /)

RGHG7(:,77,11) = (/ &
  & 0.30169215E-07_JPRB, 0.27987735E-07_JPRB, 0.26678733E-07_JPRB, 0.25894871E-07_JPRB, 0.24697220E-07_JPRB, 0.23008545E-07_JPRB, &
  & 0.21148485E-07_JPRB, 0.17878509E-07_JPRB, 0.15001400E-07_JPRB, 0.13534759E-07_JPRB, 0.13111125E-07_JPRB, 0.12798921E-07_JPRB, &
  & 0.12653972E-07_JPRB, 0.12737215E-07_JPRB, 0.13019332E-07_JPRB, 0.13352018E-07_JPRB, 0.13803636E-07_JPRB, 0.14446376E-07_JPRB, &
  & 0.15254599E-07_JPRB, 0.16210857E-07_JPRB, 0.17115524E-07_JPRB, 0.17914768E-07_JPRB, 0.19026475E-07_JPRB, 0.19843809E-07_JPRB, &
  & 0.20308529E-07_JPRB, 0.20396661E-07_JPRB, 0.19859846E-07_JPRB, 0.18966367E-07_JPRB, 0.18162456E-07_JPRB, 0.17075372E-07_JPRB, &
  & 0.15440703E-07_JPRB, 0.14985959E-07_JPRB, 0.14287532E-07_JPRB, 0.15397251E-07_JPRB, 0.18276811E-07_JPRB, 0.21471932E-07_JPRB, &
  & 0.23725095E-07_JPRB, 0.26140853E-07_JPRB, 0.28399828E-07_JPRB, 0.30940538E-07_JPRB, 0.33423489E-07_JPRB, 0.35215897E-07_JPRB, &
  & 0.36830365E-07_JPRB, 0.37690921E-07_JPRB, 0.38350012E-07_JPRB, 0.38313002E-07_JPRB, 0.38205857E-07_JPRB, 0.38344225E-07_JPRB, &
  & 0.38046488E-07_JPRB, 0.37666709E-07_JPRB, 0.37288180E-07_JPRB, 0.36938000E-07_JPRB, 0.36986675E-07_JPRB, 0.37097645E-07_JPRB, &
  & 0.37414516E-07_JPRB, 0.37366738E-07_JPRB, 0.37191740E-07_JPRB, 0.37020076E-07_JPRB, 0.37246090E-07_JPRB, 0.37200310E-07_JPRB, &
  & 0.36883327E-07_JPRB, 0.36803834E-07_JPRB, 0.37306609E-07_JPRB, 0.38223714E-07_JPRB  /)

RGHG7(:,78,11) = (/ &
  & 0.30120485E-07_JPRB, 0.27748113E-07_JPRB, 0.26344017E-07_JPRB, 0.25648435E-07_JPRB, 0.24537010E-07_JPRB, 0.22823144E-07_JPRB, &
  & 0.20895061E-07_JPRB, 0.17569584E-07_JPRB, 0.14689244E-07_JPRB, 0.13144392E-07_JPRB, 0.12691277E-07_JPRB, 0.12354345E-07_JPRB, &
  & 0.12164307E-07_JPRB, 0.12170742E-07_JPRB, 0.12372440E-07_JPRB, 0.12617844E-07_JPRB, 0.12986447E-07_JPRB, 0.13513217E-07_JPRB, &
  & 0.14245705E-07_JPRB, 0.15114267E-07_JPRB, 0.15976261E-07_JPRB, 0.16806790E-07_JPRB, 0.17915651E-07_JPRB, 0.18721290E-07_JPRB, &
  & 0.19194133E-07_JPRB, 0.19333827E-07_JPRB, 0.18786813E-07_JPRB, 0.17804360E-07_JPRB, 0.17013977E-07_JPRB, 0.16194086E-07_JPRB, &
  & 0.14816403E-07_JPRB, 0.14560041E-07_JPRB, 0.13852143E-07_JPRB, 0.15004380E-07_JPRB, 0.18016966E-07_JPRB, 0.21286350E-07_JPRB, &
  & 0.23419483E-07_JPRB, 0.25694306E-07_JPRB, 0.27947865E-07_JPRB, 0.30548055E-07_JPRB, 0.33044545E-07_JPRB, 0.34882835E-07_JPRB, &
  & 0.36492207E-07_JPRB, 0.37341975E-07_JPRB, 0.37939551E-07_JPRB, 0.37764295E-07_JPRB, 0.37544219E-07_JPRB, 0.37616745E-07_JPRB, &
  & 0.37262671E-07_JPRB, 0.36781758E-07_JPRB, 0.36331242E-07_JPRB, 0.35976539E-07_JPRB, 0.35981843E-07_JPRB, 0.36109970E-07_JPRB, &
  & 0.36416628E-07_JPRB, 0.36357693E-07_JPRB, 0.36149861E-07_JPRB, 0.35988301E-07_JPRB, 0.36293741E-07_JPRB, 0.36294777E-07_JPRB, &
  & 0.36028787E-07_JPRB, 0.35955540E-07_JPRB, 0.36485840E-07_JPRB, 0.37476027E-07_JPRB  /)

RGHG7(:,79,11) = (/ &
  & 0.29966223E-07_JPRB, 0.27432815E-07_JPRB, 0.25973660E-07_JPRB, 0.25358518E-07_JPRB, 0.24347779E-07_JPRB, 0.22638295E-07_JPRB, &
  & 0.20634469E-07_JPRB, 0.17298166E-07_JPRB, 0.14418676E-07_JPRB, 0.12798417E-07_JPRB, 0.12317359E-07_JPRB, 0.11966549E-07_JPRB, &
  & 0.11752938E-07_JPRB, 0.11705810E-07_JPRB, 0.11812064E-07_JPRB, 0.11973108E-07_JPRB, 0.12288806E-07_JPRB, 0.12739517E-07_JPRB, &
  & 0.13447192E-07_JPRB, 0.14263293E-07_JPRB, 0.15155802E-07_JPRB, 0.16027937E-07_JPRB, 0.17104738E-07_JPRB, 0.17848268E-07_JPRB, &
  & 0.18302894E-07_JPRB, 0.18494690E-07_JPRB, 0.17947916E-07_JPRB, 0.16872257E-07_JPRB, 0.16081222E-07_JPRB, 0.15478701E-07_JPRB, &
  & 0.14306226E-07_JPRB, 0.14193970E-07_JPRB, 0.13474838E-07_JPRB, 0.14660762E-07_JPRB, 0.17813235E-07_JPRB, 0.21169918E-07_JPRB, &
  & 0.23211551E-07_JPRB, 0.25390959E-07_JPRB, 0.27655542E-07_JPRB, 0.30323348E-07_JPRB, 0.32803559E-07_JPRB, 0.34655075E-07_JPRB, &
  & 0.36212751E-07_JPRB, 0.37045415E-07_JPRB, 0.37591739E-07_JPRB, 0.37255650E-07_JPRB, 0.36892858E-07_JPRB, 0.36880772E-07_JPRB, &
  & 0.36464080E-07_JPRB, 0.35883995E-07_JPRB, 0.35360831E-07_JPRB, 0.34990460E-07_JPRB, 0.34922691E-07_JPRB, 0.35073810E-07_JPRB, &
  & 0.35365400E-07_JPRB, 0.35307649E-07_JPRB, 0.35068074E-07_JPRB, 0.34902636E-07_JPRB, 0.35289037E-07_JPRB, 0.35337544E-07_JPRB, &
  & 0.35114219E-07_JPRB, 0.35083158E-07_JPRB, 0.35604756E-07_JPRB, 0.36611443E-07_JPRB  /)

RGHG7(:,80,11) = (/ &
  & 0.29685952E-07_JPRB, 0.27023247E-07_JPRB, 0.25560316E-07_JPRB, 0.25016038E-07_JPRB, 0.24108077E-07_JPRB, 0.22429790E-07_JPRB, &
  & 0.20345167E-07_JPRB, 0.17059334E-07_JPRB, 0.14166631E-07_JPRB, 0.12483400E-07_JPRB, 0.11980660E-07_JPRB, 0.11647209E-07_JPRB, &
  & 0.11431260E-07_JPRB, 0.11318581E-07_JPRB, 0.11331912E-07_JPRB, 0.11440434E-07_JPRB, 0.11731132E-07_JPRB, 0.12160978E-07_JPRB, &
  & 0.12865197E-07_JPRB, 0.13668881E-07_JPRB, 0.14606969E-07_JPRB, 0.15493532E-07_JPRB, 0.16499358E-07_JPRB, 0.17182610E-07_JPRB, &
  & 0.17608330E-07_JPRB, 0.17849008E-07_JPRB, 0.17336929E-07_JPRB, 0.16233230E-07_JPRB, 0.15446014E-07_JPRB, 0.14955735E-07_JPRB, &
  & 0.13904551E-07_JPRB, 0.13885100E-07_JPRB, 0.13145671E-07_JPRB, 0.14379141E-07_JPRB, 0.17662534E-07_JPRB, 0.21104745E-07_JPRB, &
  & 0.23060551E-07_JPRB, 0.25178415E-07_JPRB, 0.27459475E-07_JPRB, 0.30218723E-07_JPRB, 0.32696896E-07_JPRB, 0.34516356E-07_JPRB, &
  & 0.35981642E-07_JPRB, 0.36773595E-07_JPRB, 0.37277950E-07_JPRB, 0.36772107E-07_JPRB, 0.36260598E-07_JPRB, 0.36150309E-07_JPRB, &
  & 0.35633006E-07_JPRB, 0.34983371E-07_JPRB, 0.34399296E-07_JPRB, 0.33980119E-07_JPRB, 0.33838854E-07_JPRB, 0.33993551E-07_JPRB, &
  & 0.34292200E-07_JPRB, 0.34238548E-07_JPRB, 0.33965224E-07_JPRB, 0.33785255E-07_JPRB, 0.34238535E-07_JPRB, 0.34315800E-07_JPRB, &
  & 0.34115296E-07_JPRB, 0.34174533E-07_JPRB, 0.34657178E-07_JPRB, 0.35604282E-07_JPRB  /)

RGHG7(:,81,11) = (/ &
  & 0.29168249E-07_JPRB, 0.26481057E-07_JPRB, 0.25056544E-07_JPRB, 0.24575592E-07_JPRB, 0.23796817E-07_JPRB, 0.22140904E-07_JPRB, &
  & 0.20061347E-07_JPRB, 0.16881902E-07_JPRB, 0.13986244E-07_JPRB, 0.12237576E-07_JPRB, 0.11747501E-07_JPRB, 0.11416583E-07_JPRB, &
  & 0.11188392E-07_JPRB, 0.11052493E-07_JPRB, 0.11046404E-07_JPRB, 0.11115664E-07_JPRB, 0.11419450E-07_JPRB, 0.11862805E-07_JPRB, &
  & 0.12544649E-07_JPRB, 0.13313714E-07_JPRB, 0.14248847E-07_JPRB, 0.15106280E-07_JPRB, 0.16058068E-07_JPRB, 0.16692770E-07_JPRB, &
  & 0.17112157E-07_JPRB, 0.17350724E-07_JPRB, 0.16811205E-07_JPRB, 0.15732413E-07_JPRB, 0.14971795E-07_JPRB, 0.14546952E-07_JPRB, &
  & 0.13600468E-07_JPRB, 0.13610147E-07_JPRB, 0.12871562E-07_JPRB, 0.14179334E-07_JPRB, 0.17558561E-07_JPRB, 0.21049744E-07_JPRB, &
  & 0.22912672E-07_JPRB, 0.24984097E-07_JPRB, 0.27306529E-07_JPRB, 0.30139236E-07_JPRB, 0.32649072E-07_JPRB, 0.34414493E-07_JPRB, &
  & 0.35781835E-07_JPRB, 0.36516372E-07_JPRB, 0.36964579E-07_JPRB, 0.36321530E-07_JPRB, 0.35644950E-07_JPRB, 0.35403787E-07_JPRB, &
  & 0.34749278E-07_JPRB, 0.34030406E-07_JPRB, 0.33415935E-07_JPRB, 0.32958340E-07_JPRB, 0.32765992E-07_JPRB, 0.32898736E-07_JPRB, &
  & 0.33229893E-07_JPRB, 0.33145422E-07_JPRB, 0.32821015E-07_JPRB, 0.32541413E-07_JPRB, 0.33010736E-07_JPRB, 0.33106577E-07_JPRB, &
  & 0.32970665E-07_JPRB, 0.33095339E-07_JPRB, 0.33512125E-07_JPRB, 0.34387459E-07_JPRB  /)

RGHG7(:,82,11) = (/ &
  & 0.28461001E-07_JPRB, 0.25858553E-07_JPRB, 0.24435273E-07_JPRB, 0.24048656E-07_JPRB, 0.23402312E-07_JPRB, 0.21810516E-07_JPRB, &
  & 0.19786021E-07_JPRB, 0.16718102E-07_JPRB, 0.13824161E-07_JPRB, 0.12039269E-07_JPRB, 0.11558579E-07_JPRB, 0.11229015E-07_JPRB, &
  & 0.10997384E-07_JPRB, 0.10861974E-07_JPRB, 0.10848805E-07_JPRB, 0.10902322E-07_JPRB, 0.11202242E-07_JPRB, 0.11646223E-07_JPRB, &
  & 0.12309906E-07_JPRB, 0.13040793E-07_JPRB, 0.13957284E-07_JPRB, 0.14791299E-07_JPRB, 0.15697247E-07_JPRB, 0.16301742E-07_JPRB, &
  & 0.16694477E-07_JPRB, 0.16896334E-07_JPRB, 0.16337984E-07_JPRB, 0.15283651E-07_JPRB, 0.14552368E-07_JPRB, 0.14212614E-07_JPRB, &
  & 0.13346600E-07_JPRB, 0.13366608E-07_JPRB, 0.12641078E-07_JPRB, 0.14020061E-07_JPRB, 0.17477057E-07_JPRB, 0.21000611E-07_JPRB, &
  & 0.22764564E-07_JPRB, 0.24803808E-07_JPRB, 0.27139717E-07_JPRB, 0.30032324E-07_JPRB, 0.32572749E-07_JPRB, 0.34299311E-07_JPRB, &
  & 0.35587076E-07_JPRB, 0.36266892E-07_JPRB, 0.36663380E-07_JPRB, 0.35915122E-07_JPRB, 0.35082090E-07_JPRB, 0.34692273E-07_JPRB, &
  & 0.33905215E-07_JPRB, 0.33131801E-07_JPRB, 0.32479856E-07_JPRB, 0.32001540E-07_JPRB, 0.31753782E-07_JPRB, 0.31834754E-07_JPRB, &
  & 0.32183668E-07_JPRB, 0.32090681E-07_JPRB, 0.31734423E-07_JPRB, 0.31289217E-07_JPRB, 0.31692457E-07_JPRB, 0.31815771E-07_JPRB, &
  & 0.31722807E-07_JPRB, 0.31838621E-07_JPRB, 0.32201894E-07_JPRB, 0.32913132E-07_JPRB  /)

RGHG7(:,83,11) = (/ &
  & 0.27586521E-07_JPRB, 0.25142037E-07_JPRB, 0.23700398E-07_JPRB, 0.23437857E-07_JPRB, 0.22931873E-07_JPRB, 0.21433301E-07_JPRB, &
  & 0.19498717E-07_JPRB, 0.16545551E-07_JPRB, 0.13667116E-07_JPRB, 0.11877138E-07_JPRB, 0.11405158E-07_JPRB, 0.11079647E-07_JPRB, &
  & 0.10849400E-07_JPRB, 0.10723838E-07_JPRB, 0.10709005E-07_JPRB, 0.10757598E-07_JPRB, 0.11046609E-07_JPRB, 0.11483504E-07_JPRB, &
  & 0.12133704E-07_JPRB, 0.12827491E-07_JPRB, 0.13718608E-07_JPRB, 0.14535692E-07_JPRB, 0.15405589E-07_JPRB, 0.15989166E-07_JPRB, &
  & 0.16347672E-07_JPRB, 0.16499561E-07_JPRB, 0.15939287E-07_JPRB, 0.14937278E-07_JPRB, 0.14231848E-07_JPRB, 0.13984465E-07_JPRB, &
  & 0.13173737E-07_JPRB, 0.13179712E-07_JPRB, 0.12480219E-07_JPRB, 0.13923834E-07_JPRB, 0.17432250E-07_JPRB, 0.20964327E-07_JPRB, &
  & 0.22623172E-07_JPRB, 0.24637271E-07_JPRB, 0.26967499E-07_JPRB, 0.29895075E-07_JPRB, 0.32468832E-07_JPRB, 0.34173839E-07_JPRB, &
  & 0.35396597E-07_JPRB, 0.36029292E-07_JPRB, 0.36373380E-07_JPRB, 0.35537826E-07_JPRB, 0.34572946E-07_JPRB, 0.34028849E-07_JPRB, &
  & 0.33099281E-07_JPRB, 0.32294949E-07_JPRB, 0.31609423E-07_JPRB, 0.31134003E-07_JPRB, 0.30826840E-07_JPRB, 0.30819330E-07_JPRB, &
  & 0.31143704E-07_JPRB, 0.31067272E-07_JPRB, 0.30703350E-07_JPRB, 0.30052635E-07_JPRB, 0.30321027E-07_JPRB, 0.30478600E-07_JPRB, &
  & 0.30413434E-07_JPRB, 0.30470988E-07_JPRB, 0.30728096E-07_JPRB, 0.31169543E-07_JPRB  /)

RGHG7(:,84,11) = (/ &
  & 0.26568375E-07_JPRB, 0.24326862E-07_JPRB, 0.22864523E-07_JPRB, 0.22751569E-07_JPRB, 0.22398410E-07_JPRB, 0.21009306E-07_JPRB, &
  & 0.19184520E-07_JPRB, 0.16346794E-07_JPRB, 0.13504495E-07_JPRB, 0.11740683E-07_JPRB, 0.11279204E-07_JPRB, 0.10962535E-07_JPRB, &
  & 0.10735335E-07_JPRB, 0.10617872E-07_JPRB, 0.10601374E-07_JPRB, 0.10645867E-07_JPRB, 0.10924729E-07_JPRB, 0.11351273E-07_JPRB, &
  & 0.11992478E-07_JPRB, 0.12653517E-07_JPRB, 0.13519827E-07_JPRB, 0.14325515E-07_JPRB, 0.15168562E-07_JPRB, 0.15734119E-07_JPRB, &
  & 0.16061383E-07_JPRB, 0.16168871E-07_JPRB, 0.15626793E-07_JPRB, 0.14719854E-07_JPRB, 0.14032112E-07_JPRB, 0.13870728E-07_JPRB, &
  & 0.13090153E-07_JPRB, 0.13056975E-07_JPRB, 0.12393675E-07_JPRB, 0.13891146E-07_JPRB, 0.17421069E-07_JPRB, 0.20936892E-07_JPRB, &
  & 0.22490334E-07_JPRB, 0.24481518E-07_JPRB, 0.26795804E-07_JPRB, 0.29727388E-07_JPRB, 0.32337190E-07_JPRB, 0.34036793E-07_JPRB, &
  & 0.35207209E-07_JPRB, 0.35803539E-07_JPRB, 0.36092220E-07_JPRB, 0.35176534E-07_JPRB, 0.34114677E-07_JPRB, 0.33422302E-07_JPRB, &
  & 0.32336240E-07_JPRB, 0.31530529E-07_JPRB, 0.30820598E-07_JPRB, 0.30370994E-07_JPRB, 0.30004971E-07_JPRB, 0.29868450E-07_JPRB, &
  & 0.30110486E-07_JPRB, 0.30068945E-07_JPRB, 0.29722951E-07_JPRB, 0.28855417E-07_JPRB, 0.28939004E-07_JPRB, 0.29133871E-07_JPRB, &
  & 0.29086725E-07_JPRB, 0.29055884E-07_JPRB, 0.29109366E-07_JPRB, 0.29192292E-07_JPRB  /)

RGHG7(:,85,11) = (/ &
  & 0.25227068E-07_JPRB, 0.23299627E-07_JPRB, 0.21857716E-07_JPRB, 0.21918395E-07_JPRB, 0.21773766E-07_JPRB, 0.20498289E-07_JPRB, &
  & 0.18792663E-07_JPRB, 0.16071969E-07_JPRB, 0.13306699E-07_JPRB, 0.11613958E-07_JPRB, 0.11173757E-07_JPRB, 0.10863472E-07_JPRB, &
  & 0.10642230E-07_JPRB, 0.10531575E-07_JPRB, 0.10512950E-07_JPRB, 0.10553187E-07_JPRB, 0.10823113E-07_JPRB, 0.11237314E-07_JPRB, &
  & 0.11869583E-07_JPRB, 0.12497427E-07_JPRB, 0.13341182E-07_JPRB, 0.14123463E-07_JPRB, 0.14929060E-07_JPRB, 0.15489085E-07_JPRB, &
  & 0.15795495E-07_JPRB, 0.15893621E-07_JPRB, 0.15366438E-07_JPRB, 0.14550997E-07_JPRB, 0.13869638E-07_JPRB, 0.13738044E-07_JPRB, &
  & 0.12953639E-07_JPRB, 0.12876627E-07_JPRB, 0.12226946E-07_JPRB, 0.13743993E-07_JPRB, 0.17279874E-07_JPRB, 0.20793995E-07_JPRB, &
  & 0.22308285E-07_JPRB, 0.24289254E-07_JPRB, 0.26594178E-07_JPRB, 0.29509164E-07_JPRB, 0.32123648E-07_JPRB, 0.33810058E-07_JPRB, &
  & 0.34960472E-07_JPRB, 0.35527437E-07_JPRB, 0.35770583E-07_JPRB, 0.34781698E-07_JPRB, 0.33647919E-07_JPRB, 0.32829575E-07_JPRB, &
  & 0.31640951E-07_JPRB, 0.30876521E-07_JPRB, 0.30112116E-07_JPRB, 0.29663363E-07_JPRB, 0.29290531E-07_JPRB, 0.28951438E-07_JPRB, &
  & 0.29070484E-07_JPRB, 0.28982130E-07_JPRB, 0.28672310E-07_JPRB, 0.27651570E-07_JPRB, 0.27544926E-07_JPRB, 0.27758943E-07_JPRB, &
  & 0.27717331E-07_JPRB, 0.27526474E-07_JPRB, 0.27242053E-07_JPRB, 0.27123683E-07_JPRB  /)

RGHG7(:,86,11) = (/ &
  & 0.23626491E-07_JPRB, 0.22155577E-07_JPRB, 0.20777156E-07_JPRB, 0.20964724E-07_JPRB, 0.21094618E-07_JPRB, 0.19930346E-07_JPRB, &
  & 0.18352475E-07_JPRB, 0.15764058E-07_JPRB, 0.13095521E-07_JPRB, 0.11493524E-07_JPRB, 0.11081702E-07_JPRB, 0.10779831E-07_JPRB, &
  & 0.10565910E-07_JPRB, 0.10458103E-07_JPRB, 0.10439003E-07_JPRB, 0.10473298E-07_JPRB, 0.10730912E-07_JPRB, 0.11136040E-07_JPRB, &
  & 0.11759992E-07_JPRB, 0.12354807E-07_JPRB, 0.13177225E-07_JPRB, 0.13937313E-07_JPRB, 0.14707934E-07_JPRB, 0.15260734E-07_JPRB, &
  & 0.15551514E-07_JPRB, 0.15654883E-07_JPRB, 0.15148332E-07_JPRB, 0.14388551E-07_JPRB, 0.13713276E-07_JPRB, 0.13587645E-07_JPRB, &
  & 0.12804385E-07_JPRB, 0.12696306E-07_JPRB, 0.12059313E-07_JPRB, 0.13574388E-07_JPRB, 0.17104935E-07_JPRB, 0.20620009E-07_JPRB, &
  & 0.22098612E-07_JPRB, 0.24038345E-07_JPRB, 0.26342185E-07_JPRB, 0.29230499E-07_JPRB, 0.31817717E-07_JPRB, 0.33459231E-07_JPRB, &
  & 0.34608858E-07_JPRB, 0.35175616E-07_JPRB, 0.35373994E-07_JPRB, 0.34330523E-07_JPRB, 0.33125125E-07_JPRB, 0.32221470E-07_JPRB, &
  & 0.30976388E-07_JPRB, 0.30282752E-07_JPRB, 0.29490574E-07_JPRB, 0.29020031E-07_JPRB, 0.28653343E-07_JPRB, 0.28100331E-07_JPRB, &
  & 0.28061796E-07_JPRB, 0.27830483E-07_JPRB, 0.27575002E-07_JPRB, 0.26467220E-07_JPRB, 0.26214009E-07_JPRB, 0.26411974E-07_JPRB, &
  & 0.26343285E-07_JPRB, 0.25961300E-07_JPRB, 0.25358247E-07_JPRB, 0.25154455E-07_JPRB  /)

RGHG7(:,87,11) = (/ &
  & 0.21890818E-07_JPRB, 0.20964833E-07_JPRB, 0.19627160E-07_JPRB, 0.19890821E-07_JPRB, 0.20352878E-07_JPRB, 0.19341040E-07_JPRB, &
  & 0.17894787E-07_JPRB, 0.15451156E-07_JPRB, 0.12870700E-07_JPRB, 0.11377533E-07_JPRB, 0.11003650E-07_JPRB, 0.10711567E-07_JPRB, &
  & 0.10505465E-07_JPRB, 0.10395404E-07_JPRB, 0.10376526E-07_JPRB, 0.10401422E-07_JPRB, 0.10646234E-07_JPRB, 0.11044882E-07_JPRB, &
  & 0.11655259E-07_JPRB, 0.12220616E-07_JPRB, 0.13014652E-07_JPRB, 0.13755911E-07_JPRB, 0.14494662E-07_JPRB, 0.15037203E-07_JPRB, &
  & 0.15319413E-07_JPRB, 0.15423470E-07_JPRB, 0.14931747E-07_JPRB, 0.14214688E-07_JPRB, 0.13542168E-07_JPRB, 0.13411455E-07_JPRB, &
  & 0.12636346E-07_JPRB, 0.12496695E-07_JPRB, 0.11870526E-07_JPRB, 0.13368478E-07_JPRB, 0.16858628E-07_JPRB, 0.20376992E-07_JPRB, &
  & 0.21828611E-07_JPRB, 0.23692684E-07_JPRB, 0.25982527E-07_JPRB, 0.28826676E-07_JPRB, 0.31348587E-07_JPRB, 0.32922726E-07_JPRB, &
  & 0.34075579E-07_JPRB, 0.34670104E-07_JPRB, 0.34835055E-07_JPRB, 0.33754266E-07_JPRB, 0.32485413E-07_JPRB, 0.31527438E-07_JPRB, &
  & 0.30277284E-07_JPRB, 0.29695723E-07_JPRB, 0.28895766E-07_JPRB, 0.28427817E-07_JPRB, 0.28068460E-07_JPRB, 0.27263049E-07_JPRB, &
  & 0.27041355E-07_JPRB, 0.26601225E-07_JPRB, 0.26403245E-07_JPRB, 0.25252334E-07_JPRB, 0.24973355E-07_JPRB, 0.25110673E-07_JPRB, &
  & 0.24962043E-07_JPRB, 0.24366101E-07_JPRB, 0.23470993E-07_JPRB, 0.23134378E-07_JPRB  /)

RGHG7(:,88,11) = (/ &
  & 0.20151715E-07_JPRB, 0.19784820E-07_JPRB, 0.18386302E-07_JPRB, 0.18668051E-07_JPRB, 0.19542886E-07_JPRB, 0.18734518E-07_JPRB, &
  & 0.17427505E-07_JPRB, 0.15138478E-07_JPRB, 0.12625156E-07_JPRB, 0.11263268E-07_JPRB, 0.10937952E-07_JPRB, 0.10657444E-07_JPRB, &
  & 0.10458877E-07_JPRB, 0.10341005E-07_JPRB, 0.10323630E-07_JPRB, 0.10335131E-07_JPRB, 0.10567335E-07_JPRB, 0.10959930E-07_JPRB, &
  & 0.11548253E-07_JPRB, 0.12087944E-07_JPRB, 0.12841196E-07_JPRB, 0.13559263E-07_JPRB, 0.14264647E-07_JPRB, 0.14793993E-07_JPRB, &
  & 0.15074067E-07_JPRB, 0.15167444E-07_JPRB, 0.14679918E-07_JPRB, 0.14009242E-07_JPRB, 0.13335219E-07_JPRB, 0.13193117E-07_JPRB, &
  & 0.12427526E-07_JPRB, 0.12243029E-07_JPRB, 0.11626546E-07_JPRB, 0.13095557E-07_JPRB, 0.16494249E-07_JPRB, 0.20002288E-07_JPRB, &
  & 0.21461797E-07_JPRB, 0.23206741E-07_JPRB, 0.25438909E-07_JPRB, 0.28202236E-07_JPRB, 0.30584914E-07_JPRB, 0.32085880E-07_JPRB, &
  & 0.33231774E-07_JPRB, 0.33874851E-07_JPRB, 0.34017647E-07_JPRB, 0.32922391E-07_JPRB, 0.31613636E-07_JPRB, 0.30638916E-07_JPRB, &
  & 0.29469076E-07_JPRB, 0.29055094E-07_JPRB, 0.28272920E-07_JPRB, 0.27858618E-07_JPRB, 0.27512519E-07_JPRB, 0.26423037E-07_JPRB, &
  & 0.25958410E-07_JPRB, 0.25241344E-07_JPRB, 0.25102134E-07_JPRB, 0.23988847E-07_JPRB, 0.23843637E-07_JPRB, 0.23876844E-07_JPRB, &
  & 0.23590791E-07_JPRB, 0.22761063E-07_JPRB, 0.21645300E-07_JPRB, 0.21123055E-07_JPRB  /)

RGHG7(:,89,11) = (/ &
  & 0.18731785E-07_JPRB, 0.18764890E-07_JPRB, 0.17104312E-07_JPRB, 0.17362404E-07_JPRB, 0.18720013E-07_JPRB, 0.18120327E-07_JPRB, &
  & 0.16969007E-07_JPRB, 0.14829241E-07_JPRB, 0.12361781E-07_JPRB, 0.11152623E-07_JPRB, 0.10882286E-07_JPRB, 0.10615475E-07_JPRB, &
  & 0.10422856E-07_JPRB, 0.10293378E-07_JPRB, 0.10280170E-07_JPRB, 0.10276252E-07_JPRB, 0.10495897E-07_JPRB, 0.10878197E-07_JPRB, &
  & 0.11437155E-07_JPRB, 0.11951280E-07_JPRB, 0.12649706E-07_JPRB, 0.13321183E-07_JPRB, 0.13983838E-07_JPRB, 0.14498556E-07_JPRB, &
  & 0.14777929E-07_JPRB, 0.14853176E-07_JPRB, 0.14364725E-07_JPRB, 0.13756215E-07_JPRB, 0.13077840E-07_JPRB, 0.12917570E-07_JPRB, &
  & 0.12151249E-07_JPRB, 0.11903656E-07_JPRB, 0.11296233E-07_JPRB, 0.12725223E-07_JPRB, 0.15977177E-07_JPRB, 0.19421684E-07_JPRB, &
  & 0.20975682E-07_JPRB, 0.22561046E-07_JPRB, 0.24642975E-07_JPRB, 0.27241836E-07_JPRB, 0.29346925E-07_JPRB, 0.30795386E-07_JPRB, &
  & 0.31894649E-07_JPRB, 0.32584160E-07_JPRB, 0.32707823E-07_JPRB, 0.31637280E-07_JPRB, 0.30351748E-07_JPRB, 0.29435360E-07_JPRB, &
  & 0.28486514E-07_JPRB, 0.28313063E-07_JPRB, 0.27583486E-07_JPRB, 0.27286666E-07_JPRB, 0.26984139E-07_JPRB, 0.25660133E-07_JPRB, &
  & 0.24825995E-07_JPRB, 0.23732166E-07_JPRB, 0.23647101E-07_JPRB, 0.22746692E-07_JPRB, 0.22883394E-07_JPRB, 0.22795647E-07_JPRB, &
  & 0.22333777E-07_JPRB, 0.21257239E-07_JPRB, 0.20122542E-07_JPRB, 0.19499995E-07_JPRB  /)

RGHG7(:,90,11) = (/ &
  & 0.17966161E-07_JPRB, 0.18064998E-07_JPRB, 0.15959974E-07_JPRB, 0.16293710E-07_JPRB, 0.17958719E-07_JPRB, 0.17486905E-07_JPRB, &
  & 0.16535610E-07_JPRB, 0.14523369E-07_JPRB, 0.12101391E-07_JPRB, 0.11047386E-07_JPRB, 0.10832794E-07_JPRB, 0.10579432E-07_JPRB, &
  & 0.10391267E-07_JPRB, 0.10251846E-07_JPRB, 0.10242040E-07_JPRB, 0.10224208E-07_JPRB, 0.10432857E-07_JPRB, 0.10795451E-07_JPRB, &
  & 0.11324591E-07_JPRB, 0.11799018E-07_JPRB, 0.12426921E-07_JPRB, 0.13016338E-07_JPRB, 0.13631471E-07_JPRB, 0.14124142E-07_JPRB, &
  & 0.14393850E-07_JPRB, 0.14448303E-07_JPRB, 0.13988215E-07_JPRB, 0.13448976E-07_JPRB, 0.12765797E-07_JPRB, 0.12575020E-07_JPRB, &
  & 0.11816997E-07_JPRB, 0.11534694E-07_JPRB, 0.10929124E-07_JPRB, 0.12284691E-07_JPRB, 0.15341631E-07_JPRB, 0.18627527E-07_JPRB, &
  & 0.20379261E-07_JPRB, 0.21827279E-07_JPRB, 0.23626201E-07_JPRB, 0.25857938E-07_JPRB, 0.27513972E-07_JPRB, 0.28891324E-07_JPRB, &
  & 0.29812237E-07_JPRB, 0.30520458E-07_JPRB, 0.30639592E-07_JPRB, 0.29651206E-07_JPRB, 0.28533484E-07_JPRB, 0.27853249E-07_JPRB, &
  & 0.27253633E-07_JPRB, 0.27458231E-07_JPRB, 0.26785223E-07_JPRB, 0.26687658E-07_JPRB, 0.26489631E-07_JPRB, 0.25133860E-07_JPRB, &
  & 0.23793407E-07_JPRB, 0.22106809E-07_JPRB, 0.21985048E-07_JPRB, 0.21505761E-07_JPRB, 0.22018822E-07_JPRB, 0.21835239E-07_JPRB, &
  & 0.21155665E-07_JPRB, 0.19786802E-07_JPRB, 0.19041300E-07_JPRB, 0.18364091E-07_JPRB  /)

RGHG7(:,91,11) = (/ &
  & 0.17584273E-07_JPRB, 0.17650848E-07_JPRB, 0.15107901E-07_JPRB, 0.15279795E-07_JPRB, 0.17119339E-07_JPRB, 0.16774459E-07_JPRB, &
  & 0.16059050E-07_JPRB, 0.14193313E-07_JPRB, 0.11817349E-07_JPRB, 0.10926771E-07_JPRB, 0.10776705E-07_JPRB, 0.10535507E-07_JPRB, &
  & 0.10350516E-07_JPRB, 0.10202632E-07_JPRB, 0.10193355E-07_JPRB, 0.10163887E-07_JPRB, 0.10361429E-07_JPRB, 0.10697579E-07_JPRB, &
  & 0.11186523E-07_JPRB, 0.11599070E-07_JPRB, 0.12169323E-07_JPRB, 0.12657722E-07_JPRB, 0.13208330E-07_JPRB, 0.13646524E-07_JPRB, &
  & 0.13886085E-07_JPRB, 0.13971214E-07_JPRB, 0.13612146E-07_JPRB, 0.13121564E-07_JPRB, 0.12439443E-07_JPRB, 0.12186785E-07_JPRB, &
  & 0.11461554E-07_JPRB, 0.11122131E-07_JPRB, 0.10590076E-07_JPRB, 0.11827171E-07_JPRB, 0.14745012E-07_JPRB, 0.17850027E-07_JPRB, &
  & 0.19826541E-07_JPRB, 0.21214794E-07_JPRB, 0.22800043E-07_JPRB, 0.24545727E-07_JPRB, 0.25664406E-07_JPRB, 0.26904775E-07_JPRB, &
  & 0.27251838E-07_JPRB, 0.27939962E-07_JPRB, 0.28236275E-07_JPRB, 0.27123599E-07_JPRB, 0.26293594E-07_JPRB, 0.25844486E-07_JPRB, &
  & 0.25746261E-07_JPRB, 0.26430564E-07_JPRB, 0.25924158E-07_JPRB, 0.26053488E-07_JPRB, 0.25977636E-07_JPRB, 0.24596477E-07_JPRB, &
  & 0.22819688E-07_JPRB, 0.20777145E-07_JPRB, 0.20155051E-07_JPRB, 0.20460641E-07_JPRB, 0.21217522E-07_JPRB, 0.20940854E-07_JPRB, &
  & 0.20032269E-07_JPRB, 0.18552339E-07_JPRB, 0.18302410E-07_JPRB, 0.17625200E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ---GEMS----

RGHG7(:, 1,12) = (/ &
  & 0.13507636E-06_JPRB, 0.10668850E-06_JPRB, 0.96417857E-07_JPRB, 0.85160650E-07_JPRB, 0.79439232E-07_JPRB, 0.74467195E-07_JPRB, &
  & 0.71678343E-07_JPRB, 0.69675416E-07_JPRB, 0.68739574E-07_JPRB, 0.68407161E-07_JPRB, 0.68597799E-07_JPRB, 0.68934128E-07_JPRB, &
  & 0.69515792E-07_JPRB, 0.70126710E-07_JPRB, 0.70598205E-07_JPRB, 0.71085076E-07_JPRB, 0.71205932E-07_JPRB, 0.71132568E-07_JPRB, &
  & 0.71139624E-07_JPRB, 0.70870840E-07_JPRB, 0.70454476E-07_JPRB, 0.70034531E-07_JPRB, 0.69717942E-07_JPRB, 0.69226765E-07_JPRB, &
  & 0.68762887E-07_JPRB, 0.68340093E-07_JPRB, 0.67897162E-07_JPRB, 0.67543382E-07_JPRB, 0.67227070E-07_JPRB, 0.67021361E-07_JPRB, &
  & 0.66985287E-07_JPRB, 0.67162247E-07_JPRB, 0.67569516E-07_JPRB, 0.68231174E-07_JPRB, 0.68923967E-07_JPRB, 0.69546211E-07_JPRB, &
  & 0.69977119E-07_JPRB, 0.70131605E-07_JPRB, 0.69985916E-07_JPRB, 0.69686003E-07_JPRB, 0.69134295E-07_JPRB, 0.68545667E-07_JPRB, &
  & 0.67968358E-07_JPRB, 0.67465834E-07_JPRB, 0.67060761E-07_JPRB, 0.66623819E-07_JPRB, 0.66152701E-07_JPRB, 0.65618337E-07_JPRB, &
  & 0.65120247E-07_JPRB, 0.64695257E-07_JPRB, 0.64435646E-07_JPRB, 0.64434566E-07_JPRB, 0.64680471E-07_JPRB, 0.65235362E-07_JPRB, &
  & 0.66238286E-07_JPRB, 0.68917572E-07_JPRB, 0.59361810E-05_JPRB, 0.59655049E-05_JPRB, 0.59796507E-05_JPRB, 0.59881954E-05_JPRB, &
  & 0.59787581E-05_JPRB, 0.59823997E-05_JPRB, 0.59878071E-05_JPRB, 0.59843260E-05_JPRB  /)

RGHG7(:, 2,12) = (/ &
  & 0.49619928E-06_JPRB, 0.62017415E-06_JPRB, 0.61107107E-06_JPRB, 0.53676393E-06_JPRB, 0.46084628E-06_JPRB, 0.39120502E-06_JPRB, &
  & 0.33187888E-06_JPRB, 0.28403383E-06_JPRB, 0.24797961E-06_JPRB, 0.22437520E-06_JPRB, 0.21505981E-06_JPRB, 0.21122804E-06_JPRB, &
  & 0.21216184E-06_JPRB, 0.21264454E-06_JPRB, 0.21049307E-06_JPRB, 0.21095587E-06_JPRB, 0.20720546E-06_JPRB, 0.20427727E-06_JPRB, &
  & 0.20620990E-06_JPRB, 0.20538225E-06_JPRB, 0.20464027E-06_JPRB, 0.20525941E-06_JPRB, 0.20940384E-06_JPRB, 0.21114649E-06_JPRB, &
  & 0.21222719E-06_JPRB, 0.21291291E-06_JPRB, 0.21255983E-06_JPRB, 0.21565099E-06_JPRB, 0.21628277E-06_JPRB, 0.21666462E-06_JPRB, &
  & 0.21667282E-06_JPRB, 0.21586867E-06_JPRB, 0.21601295E-06_JPRB, 0.22294140E-06_JPRB, 0.22603251E-06_JPRB, 0.22741395E-06_JPRB, &
  & 0.22704371E-06_JPRB, 0.22393878E-06_JPRB, 0.22068576E-06_JPRB, 0.22245422E-06_JPRB, 0.22083867E-06_JPRB, 0.22103521E-06_JPRB, &
  & 0.21898165E-06_JPRB, 0.21911700E-06_JPRB, 0.22191722E-06_JPRB, 0.22489252E-06_JPRB, 0.22762165E-06_JPRB, 0.22731311E-06_JPRB, &
  & 0.22759569E-06_JPRB, 0.22557116E-06_JPRB, 0.22142045E-06_JPRB, 0.21570351E-06_JPRB, 0.20630198E-06_JPRB, 0.19692804E-06_JPRB, &
  & 0.18933109E-06_JPRB, 0.19357360E-06_JPRB, 0.56898671E-05_JPRB, 0.55702676E-05_JPRB, 0.54668958E-05_JPRB, 0.53895146E-05_JPRB, &
  & 0.53250874E-05_JPRB, 0.52211822E-05_JPRB, 0.50708077E-05_JPRB, 0.47820008E-05_JPRB  /)

RGHG7(:, 3,12) = (/ &
  & 0.70406821E-06_JPRB, 0.89680458E-06_JPRB, 0.89454193E-06_JPRB, 0.83834226E-06_JPRB, 0.76619830E-06_JPRB, 0.69516653E-06_JPRB, &
  & 0.62397498E-06_JPRB, 0.55787478E-06_JPRB, 0.50110020E-06_JPRB, 0.46404685E-06_JPRB, 0.44822113E-06_JPRB, 0.43514581E-06_JPRB, &
  & 0.43045935E-06_JPRB, 0.42255337E-06_JPRB, 0.41551550E-06_JPRB, 0.41276357E-06_JPRB, 0.40337517E-06_JPRB, 0.40240735E-06_JPRB, &
  & 0.40558447E-06_JPRB, 0.40170502E-06_JPRB, 0.40078609E-06_JPRB, 0.40263780E-06_JPRB, 0.40977577E-06_JPRB, 0.40979953E-06_JPRB, &
  & 0.40927358E-06_JPRB, 0.40801075E-06_JPRB, 0.40847192E-06_JPRB, 0.41529765E-06_JPRB, 0.41425770E-06_JPRB, 0.41202702E-06_JPRB, &
  & 0.41006561E-06_JPRB, 0.40949845E-06_JPRB, 0.41202102E-06_JPRB, 0.42177879E-06_JPRB, 0.42212690E-06_JPRB, 0.41955565E-06_JPRB, &
  & 0.41537572E-06_JPRB, 0.41095277E-06_JPRB, 0.40787484E-06_JPRB, 0.41125728E-06_JPRB, 0.40760193E-06_JPRB, 0.40333191E-06_JPRB, &
  & 0.40027638E-06_JPRB, 0.39881425E-06_JPRB, 0.40276083E-06_JPRB, 0.40244024E-06_JPRB, 0.40150462E-06_JPRB, 0.40043406E-06_JPRB, &
  & 0.40130351E-06_JPRB, 0.39403881E-06_JPRB, 0.37905639E-06_JPRB, 0.36083091E-06_JPRB, 0.33950576E-06_JPRB, 0.32347990E-06_JPRB, &
  & 0.31729385E-06_JPRB, 0.35786852E-06_JPRB, 0.36926617E-05_JPRB, 0.38234602E-05_JPRB, 0.38252447E-05_JPRB, 0.37515726E-05_JPRB, &
  & 0.36314273E-05_JPRB, 0.35068201E-05_JPRB, 0.33275792E-05_JPRB, 0.30041319E-05_JPRB  /)

RGHG7(:, 4,12) = (/ &
  & 0.47259159E-06_JPRB, 0.52831203E-06_JPRB, 0.52337575E-06_JPRB, 0.50539491E-06_JPRB, 0.49351171E-06_JPRB, 0.50234635E-06_JPRB, &
  & 0.54191684E-06_JPRB, 0.60121674E-06_JPRB, 0.63100526E-06_JPRB, 0.64800804E-06_JPRB, 0.67994979E-06_JPRB, 0.70480328E-06_JPRB, &
  & 0.72531303E-06_JPRB, 0.74114834E-06_JPRB, 0.75523860E-06_JPRB, 0.76965690E-06_JPRB, 0.77652447E-06_JPRB, 0.78960040E-06_JPRB, &
  & 0.80055424E-06_JPRB, 0.80495593E-06_JPRB, 0.81072910E-06_JPRB, 0.81738206E-06_JPRB, 0.82552894E-06_JPRB, 0.82207038E-06_JPRB, &
  & 0.81581141E-06_JPRB, 0.80024545E-06_JPRB, 0.78130196E-06_JPRB, 0.76280497E-06_JPRB, 0.73226144E-06_JPRB, 0.70271307E-06_JPRB, &
  & 0.67237976E-06_JPRB, 0.64886191E-06_JPRB, 0.63852233E-06_JPRB, 0.64268031E-06_JPRB, 0.66134505E-06_JPRB, 0.71227045E-06_JPRB, &
  & 0.78612895E-06_JPRB, 0.85922249E-06_JPRB, 0.92027714E-06_JPRB, 0.98462555E-06_JPRB, 0.10430440E-05_JPRB, 0.10942386E-05_JPRB, &
  & 0.11276106E-05_JPRB, 0.11713395E-05_JPRB, 0.12264461E-05_JPRB, 0.12898375E-05_JPRB, 0.13742935E-05_JPRB, 0.14713957E-05_JPRB, &
  & 0.15607543E-05_JPRB, 0.16398173E-05_JPRB, 0.17042938E-05_JPRB, 0.17384174E-05_JPRB, 0.17488538E-05_JPRB, 0.17384672E-05_JPRB, &
  & 0.17225908E-05_JPRB, 0.17739270E-05_JPRB, 0.26482194E-05_JPRB, 0.26943735E-05_JPRB, 0.27054138E-05_JPRB, 0.27031622E-05_JPRB, &
  & 0.26726389E-05_JPRB, 0.26519622E-05_JPRB, 0.26204565E-05_JPRB, 0.25351609E-05_JPRB  /)

RGHG7(:, 5,12) = (/ &
  & 0.82242893E-07_JPRB, 0.79441897E-07_JPRB, 0.89869142E-07_JPRB, 0.11845902E-06_JPRB, 0.17428677E-06_JPRB, 0.26897982E-06_JPRB, &
  & 0.42130723E-06_JPRB, 0.59825783E-06_JPRB, 0.68111605E-06_JPRB, 0.70667652E-06_JPRB, 0.75202662E-06_JPRB, 0.78560390E-06_JPRB, &
  & 0.81653507E-06_JPRB, 0.84631116E-06_JPRB, 0.87087331E-06_JPRB, 0.89322128E-06_JPRB, 0.91020421E-06_JPRB, 0.92456207E-06_JPRB, &
  & 0.93861383E-06_JPRB, 0.95179943E-06_JPRB, 0.96328578E-06_JPRB, 0.97117935E-06_JPRB, 0.97540587E-06_JPRB, 0.97238523E-06_JPRB, &
  & 0.95994575E-06_JPRB, 0.93219723E-06_JPRB, 0.89037346E-06_JPRB, 0.84264236E-06_JPRB, 0.78735292E-06_JPRB, 0.73317216E-06_JPRB, &
  & 0.67900536E-06_JPRB, 0.63655671E-06_JPRB, 0.61361953E-06_JPRB, 0.61847464E-06_JPRB, 0.67763671E-06_JPRB, 0.80399178E-06_JPRB, &
  & 0.97023532E-06_JPRB, 0.11210843E-05_JPRB, 0.12447308E-05_JPRB, 0.13689380E-05_JPRB, 0.14885429E-05_JPRB, 0.15940007E-05_JPRB, &
  & 0.16645059E-05_JPRB, 0.17561068E-05_JPRB, 0.18663759E-05_JPRB, 0.20028021E-05_JPRB, 0.21725256E-05_JPRB, 0.23612407E-05_JPRB, &
  & 0.25520624E-05_JPRB, 0.27300980E-05_JPRB, 0.28701934E-05_JPRB, 0.29466638E-05_JPRB, 0.29774692E-05_JPRB, 0.29656710E-05_JPRB, &
  & 0.29262620E-05_JPRB, 0.28922244E-05_JPRB, 0.29055896E-05_JPRB, 0.29451876E-05_JPRB, 0.29822878E-05_JPRB, 0.30008564E-05_JPRB, &
  & 0.30107491E-05_JPRB, 0.30497062E-05_JPRB, 0.30883831E-05_JPRB, 0.30982497E-05_JPRB  /)

RGHG7(:, 6,12) = (/ &
  & 0.13876440E-06_JPRB, 0.13975060E-06_JPRB, 0.14753828E-06_JPRB, 0.17934154E-06_JPRB, 0.24966777E-06_JPRB, 0.36444446E-06_JPRB, &
  & 0.54733725E-06_JPRB, 0.74823520E-06_JPRB, 0.83748192E-06_JPRB, 0.85359352E-06_JPRB, 0.88203511E-06_JPRB, 0.90367698E-06_JPRB, &
  & 0.93120349E-06_JPRB, 0.96029099E-06_JPRB, 0.98450886E-06_JPRB, 0.10035669E-05_JPRB, 0.10161506E-05_JPRB, 0.10274863E-05_JPRB, &
  & 0.10407348E-05_JPRB, 0.10556418E-05_JPRB, 0.10701503E-05_JPRB, 0.10799948E-05_JPRB, 0.10840683E-05_JPRB, 0.10788672E-05_JPRB, &
  & 0.10637499E-05_JPRB, 0.10341269E-05_JPRB, 0.99058166E-06_JPRB, 0.94024925E-06_JPRB, 0.88377392E-06_JPRB, 0.83054952E-06_JPRB, &
  & 0.77818068E-06_JPRB, 0.73730048E-06_JPRB, 0.71237406E-06_JPRB, 0.72128415E-06_JPRB, 0.79727822E-06_JPRB, 0.94302834E-06_JPRB, &
  & 0.11170758E-05_JPRB, 0.12572135E-05_JPRB, 0.13713347E-05_JPRB, 0.14876614E-05_JPRB, 0.15933416E-05_JPRB, 0.16875908E-05_JPRB, &
  & 0.17494123E-05_JPRB, 0.18362314E-05_JPRB, 0.19435931E-05_JPRB, 0.20837300E-05_JPRB, 0.22432778E-05_JPRB, 0.24068214E-05_JPRB, &
  & 0.25907573E-05_JPRB, 0.27586171E-05_JPRB, 0.28809242E-05_JPRB, 0.29503940E-05_JPRB, 0.29786364E-05_JPRB, 0.29737240E-05_JPRB, &
  & 0.29376814E-05_JPRB, 0.29107974E-05_JPRB, 0.29351799E-05_JPRB, 0.29889321E-05_JPRB, 0.30193759E-05_JPRB, 0.30196589E-05_JPRB, &
  & 0.30210973E-05_JPRB, 0.30351890E-05_JPRB, 0.30596735E-05_JPRB, 0.30652555E-05_JPRB  /)

RGHG7(:, 7,12) = (/ &
  & 0.42579648E-06_JPRB, 0.42589283E-06_JPRB, 0.43604658E-06_JPRB, 0.47006277E-06_JPRB, 0.55009088E-06_JPRB, 0.67821829E-06_JPRB, &
  & 0.85996708E-06_JPRB, 0.10251949E-05_JPRB, 0.10857779E-05_JPRB, 0.11042696E-05_JPRB, 0.11264999E-05_JPRB, 0.11420860E-05_JPRB, &
  & 0.11695104E-05_JPRB, 0.12002437E-05_JPRB, 0.12253717E-05_JPRB, 0.12445190E-05_JPRB, 0.12574671E-05_JPRB, 0.12722045E-05_JPRB, &
  & 0.12910975E-05_JPRB, 0.13130200E-05_JPRB, 0.13351257E-05_JPRB, 0.13472616E-05_JPRB, 0.13484758E-05_JPRB, 0.13405135E-05_JPRB, &
  & 0.13244396E-05_JPRB, 0.12973812E-05_JPRB, 0.12593907E-05_JPRB, 0.12183261E-05_JPRB, 0.11727209E-05_JPRB, 0.11315947E-05_JPRB, &
  & 0.10917519E-05_JPRB, 0.10636262E-05_JPRB, 0.10495842E-05_JPRB, 0.10652378E-05_JPRB, 0.11443768E-05_JPRB, 0.12691150E-05_JPRB, &
  & 0.14090304E-05_JPRB, 0.15150073E-05_JPRB, 0.16110709E-05_JPRB, 0.17114997E-05_JPRB, 0.17960387E-05_JPRB, 0.18781399E-05_JPRB, &
  & 0.19367351E-05_JPRB, 0.20190619E-05_JPRB, 0.21323734E-05_JPRB, 0.22673757E-05_JPRB, 0.24115211E-05_JPRB, 0.25726281E-05_JPRB, &
  & 0.27492344E-05_JPRB, 0.29013427E-05_JPRB, 0.30067918E-05_JPRB, 0.30687407E-05_JPRB, 0.30949520E-05_JPRB, 0.30896437E-05_JPRB, &
  & 0.30575822E-05_JPRB, 0.30319999E-05_JPRB, 0.30536628E-05_JPRB, 0.31031872E-05_JPRB, 0.31255928E-05_JPRB, 0.31177185E-05_JPRB, &
  & 0.31141308E-05_JPRB, 0.31299330E-05_JPRB, 0.31583778E-05_JPRB, 0.31481482E-05_JPRB  /)

RGHG7(:, 8,12) = (/ &
  & 0.90634539E-06_JPRB, 0.91046718E-06_JPRB, 0.92772970E-06_JPRB, 0.96254160E-06_JPRB, 0.10408349E-05_JPRB, 0.11641983E-05_JPRB, &
  & 0.13166755E-05_JPRB, 0.14230329E-05_JPRB, 0.14469367E-05_JPRB, 0.14733134E-05_JPRB, 0.15015720E-05_JPRB, 0.15201639E-05_JPRB, &
  & 0.15509318E-05_JPRB, 0.15841329E-05_JPRB, 0.16110205E-05_JPRB, 0.16330166E-05_JPRB, 0.16509526E-05_JPRB, 0.16712770E-05_JPRB, &
  & 0.16969729E-05_JPRB, 0.17260960E-05_JPRB, 0.17572313E-05_JPRB, 0.17786334E-05_JPRB, 0.17882244E-05_JPRB, 0.17902944E-05_JPRB, &
  & 0.17881085E-05_JPRB, 0.17807048E-05_JPRB, 0.17668167E-05_JPRB, 0.17554256E-05_JPRB, 0.17413736E-05_JPRB, 0.17308995E-05_JPRB, &
  & 0.17180748E-05_JPRB, 0.17107672E-05_JPRB, 0.17099480E-05_JPRB, 0.17223081E-05_JPRB, 0.17747498E-05_JPRB, 0.18401922E-05_JPRB, &
  & 0.19123219E-05_JPRB, 0.19599514E-05_JPRB, 0.20131944E-05_JPRB, 0.20768614E-05_JPRB, 0.21317514E-05_JPRB, 0.21963693E-05_JPRB, &
  & 0.22530124E-05_JPRB, 0.23381548E-05_JPRB, 0.24508434E-05_JPRB, 0.25809723E-05_JPRB, 0.27158442E-05_JPRB, 0.28746561E-05_JPRB, &
  & 0.30356793E-05_JPRB, 0.31663631E-05_JPRB, 0.32585274E-05_JPRB, 0.33136064E-05_JPRB, 0.33341843E-05_JPRB, 0.33243778E-05_JPRB, &
  & 0.32886706E-05_JPRB, 0.32547430E-05_JPRB, 0.32584631E-05_JPRB, 0.32906955E-05_JPRB, 0.33008112E-05_JPRB, 0.32816692E-05_JPRB, &
  & 0.32689084E-05_JPRB, 0.32880335E-05_JPRB, 0.33149202E-05_JPRB, 0.33051157E-05_JPRB  /)

RGHG7(:, 9,12) = (/ &
  & 0.15412610E-05_JPRB, 0.15571376E-05_JPRB, 0.15860239E-05_JPRB, 0.16230663E-05_JPRB, 0.16898441E-05_JPRB, 0.17871123E-05_JPRB, &
  & 0.18891440E-05_JPRB, 0.19364374E-05_JPRB, 0.19322310E-05_JPRB, 0.19720199E-05_JPRB, 0.20206056E-05_JPRB, 0.20537704E-05_JPRB, &
  & 0.20917563E-05_JPRB, 0.21290158E-05_JPRB, 0.21604192E-05_JPRB, 0.21901425E-05_JPRB, 0.22191196E-05_JPRB, 0.22479202E-05_JPRB, &
  & 0.22821691E-05_JPRB, 0.23181572E-05_JPRB, 0.23589628E-05_JPRB, 0.23986696E-05_JPRB, 0.24345447E-05_JPRB, 0.24680299E-05_JPRB, &
  & 0.25002693E-05_JPRB, 0.25317344E-05_JPRB, 0.25587905E-05_JPRB, 0.25911843E-05_JPRB, 0.26193793E-05_JPRB, 0.26446448E-05_JPRB, &
  & 0.26599721E-05_JPRB, 0.26692119E-05_JPRB, 0.26702688E-05_JPRB, 0.26613856E-05_JPRB, 0.26618381E-05_JPRB, 0.26535817E-05_JPRB, &
  & 0.26495985E-05_JPRB, 0.26323112E-05_JPRB, 0.26279266E-05_JPRB, 0.26458409E-05_JPRB, 0.26713120E-05_JPRB, 0.27218543E-05_JPRB, &
  & 0.27836045E-05_JPRB, 0.28807885E-05_JPRB, 0.29915097E-05_JPRB, 0.31225711E-05_JPRB, 0.32581119E-05_JPRB, 0.34038065E-05_JPRB, &
  & 0.35373105E-05_JPRB, 0.36408388E-05_JPRB, 0.37150601E-05_JPRB, 0.37545490E-05_JPRB, 0.37567116E-05_JPRB, 0.37278346E-05_JPRB, &
  & 0.36690397E-05_JPRB, 0.36052782E-05_JPRB, 0.35719513E-05_JPRB, 0.35659757E-05_JPRB, 0.35481886E-05_JPRB, 0.35045966E-05_JPRB, &
  & 0.34709850E-05_JPRB, 0.34768977E-05_JPRB, 0.34917481E-05_JPRB, 0.35032853E-05_JPRB  /)

RGHG7(:,10,12) = (/ &
  & 0.22047706E-05_JPRB, 0.22329358E-05_JPRB, 0.22715057E-05_JPRB, 0.23145756E-05_JPRB, 0.23756494E-05_JPRB, 0.24433067E-05_JPRB, &
  & 0.25010307E-05_JPRB, 0.25150040E-05_JPRB, 0.25085935E-05_JPRB, 0.25689050E-05_JPRB, 0.26453632E-05_JPRB, 0.26994302E-05_JPRB, &
  & 0.27480779E-05_JPRB, 0.27954107E-05_JPRB, 0.28384708E-05_JPRB, 0.28826957E-05_JPRB, 0.29276991E-05_JPRB, 0.29694261E-05_JPRB, &
  & 0.30171365E-05_JPRB, 0.30647368E-05_JPRB, 0.31204934E-05_JPRB, 0.31853738E-05_JPRB, 0.32586967E-05_JPRB, 0.33383761E-05_JPRB, &
  & 0.34154837E-05_JPRB, 0.34877429E-05_JPRB, 0.35470102E-05_JPRB, 0.36050087E-05_JPRB, 0.36522516E-05_JPRB, 0.36865006E-05_JPRB, &
  & 0.37062977E-05_JPRB, 0.37137337E-05_JPRB, 0.37032659E-05_JPRB, 0.36714203E-05_JPRB, 0.36374181E-05_JPRB, 0.35953171E-05_JPRB, &
  & 0.35573653E-05_JPRB, 0.35117514E-05_JPRB, 0.34855266E-05_JPRB, 0.34980934E-05_JPRB, 0.35278921E-05_JPRB, 0.35962370E-05_JPRB, &
  & 0.36849188E-05_JPRB, 0.38040662E-05_JPRB, 0.39278349E-05_JPRB, 0.40605295E-05_JPRB, 0.41904951E-05_JPRB, 0.43014097E-05_JPRB, &
  & 0.43829816E-05_JPRB, 0.44313923E-05_JPRB, 0.44466261E-05_JPRB, 0.44290248E-05_JPRB, 0.43778610E-05_JPRB, 0.42961957E-05_JPRB, &
  & 0.41868211E-05_JPRB, 0.40680125E-05_JPRB, 0.39792805E-05_JPRB, 0.39096602E-05_JPRB, 0.38349276E-05_JPRB, 0.37440079E-05_JPRB, &
  & 0.36614361E-05_JPRB, 0.36142369E-05_JPRB, 0.36002849E-05_JPRB, 0.36210846E-05_JPRB  /)

RGHG7(:,11,12) = (/ &
  & 0.29325661E-05_JPRB, 0.29580193E-05_JPRB, 0.29944825E-05_JPRB, 0.30348227E-05_JPRB, 0.30893934E-05_JPRB, 0.31289509E-05_JPRB, &
  & 0.31525771E-05_JPRB, 0.31571127E-05_JPRB, 0.31723079E-05_JPRB, 0.32578680E-05_JPRB, 0.33621733E-05_JPRB, 0.34372453E-05_JPRB, &
  & 0.35008351E-05_JPRB, 0.35676027E-05_JPRB, 0.36309939E-05_JPRB, 0.36947252E-05_JPRB, 0.37571973E-05_JPRB, 0.38155724E-05_JPRB, &
  & 0.38827117E-05_JPRB, 0.39525072E-05_JPRB, 0.40360309E-05_JPRB, 0.41317409E-05_JPRB, 0.42421076E-05_JPRB, 0.43634495E-05_JPRB, &
  & 0.44778027E-05_JPRB, 0.45727017E-05_JPRB, 0.46365669E-05_JPRB, 0.46865592E-05_JPRB, 0.47234691E-05_JPRB, 0.47468141E-05_JPRB, &
  & 0.47597107E-05_JPRB, 0.47619829E-05_JPRB, 0.47493058E-05_JPRB, 0.47180137E-05_JPRB, 0.46866956E-05_JPRB, 0.46525297E-05_JPRB, &
  & 0.46304925E-05_JPRB, 0.46158842E-05_JPRB, 0.46392193E-05_JPRB, 0.47152064E-05_JPRB, 0.48083696E-05_JPRB, 0.49294556E-05_JPRB, &
  & 0.50557508E-05_JPRB, 0.51889259E-05_JPRB, 0.53011597E-05_JPRB, 0.53956809E-05_JPRB, 0.54690208E-05_JPRB, 0.55059857E-05_JPRB, &
  & 0.54901450E-05_JPRB, 0.54267334E-05_JPRB, 0.53273172E-05_JPRB, 0.52039385E-05_JPRB, 0.50653141E-05_JPRB, 0.49094757E-05_JPRB, &
  & 0.47428961E-05_JPRB, 0.45736766E-05_JPRB, 0.44273222E-05_JPRB, 0.42957893E-05_JPRB, 0.41535604E-05_JPRB, 0.40024935E-05_JPRB, &
  & 0.38500818E-05_JPRB, 0.37190148E-05_JPRB, 0.36543452E-05_JPRB, 0.36509766E-05_JPRB  /)

RGHG7(:,12,12) = (/ &
  & 0.39138239E-05_JPRB, 0.39200161E-05_JPRB, 0.39366266E-05_JPRB, 0.39522734E-05_JPRB, 0.39745384E-05_JPRB, 0.39741023E-05_JPRB, &
  & 0.39660055E-05_JPRB, 0.39735806E-05_JPRB, 0.40134426E-05_JPRB, 0.41243292E-05_JPRB, 0.42589540E-05_JPRB, 0.43587225E-05_JPRB, &
  & 0.44436033E-05_JPRB, 0.45343835E-05_JPRB, 0.46230880E-05_JPRB, 0.47106689E-05_JPRB, 0.47925645E-05_JPRB, 0.48739987E-05_JPRB, &
  & 0.49692607E-05_JPRB, 0.50703480E-05_JPRB, 0.51894861E-05_JPRB, 0.53143846E-05_JPRB, 0.54542112E-05_JPRB, 0.55975173E-05_JPRB, &
  & 0.57251260E-05_JPRB, 0.58174218E-05_JPRB, 0.58660905E-05_JPRB, 0.58920446E-05_JPRB, 0.59077825E-05_JPRB, 0.59143521E-05_JPRB, &
  & 0.59152518E-05_JPRB, 0.59075918E-05_JPRB, 0.58881507E-05_JPRB, 0.58610768E-05_JPRB, 0.58482186E-05_JPRB, 0.58507871E-05_JPRB, &
  & 0.58835811E-05_JPRB, 0.59412071E-05_JPRB, 0.60404721E-05_JPRB, 0.61788275E-05_JPRB, 0.63108315E-05_JPRB, 0.64373517E-05_JPRB, &
  & 0.65421824E-05_JPRB, 0.66172358E-05_JPRB, 0.66434152E-05_JPRB, 0.66398170E-05_JPRB, 0.66091783E-05_JPRB, 0.65483877E-05_JPRB, &
  & 0.64311087E-05_JPRB, 0.62598845E-05_JPRB, 0.60572659E-05_JPRB, 0.58444067E-05_JPRB, 0.56347436E-05_JPRB, 0.54284714E-05_JPRB, &
  & 0.52389825E-05_JPRB, 0.50540734E-05_JPRB, 0.48865589E-05_JPRB, 0.47324897E-05_JPRB, 0.45586471E-05_JPRB, 0.43779252E-05_JPRB, &
  & 0.41978479E-05_JPRB, 0.40253422E-05_JPRB, 0.39304362E-05_JPRB, 0.38973003E-05_JPRB  /)

RGHG7(:,13,12) = (/ &
  & 0.49386601E-05_JPRB, 0.49237959E-05_JPRB, 0.49042184E-05_JPRB, 0.48844686E-05_JPRB, 0.48728671E-05_JPRB, 0.48529357E-05_JPRB, &
  & 0.48429078E-05_JPRB, 0.48729668E-05_JPRB, 0.49486603E-05_JPRB, 0.51003101E-05_JPRB, 0.52809289E-05_JPRB, 0.54222866E-05_JPRB, &
  & 0.55456788E-05_JPRB, 0.56721770E-05_JPRB, 0.57945410E-05_JPRB, 0.59140270E-05_JPRB, 0.60250968E-05_JPRB, 0.61383904E-05_JPRB, &
  & 0.62653557E-05_JPRB, 0.63976367E-05_JPRB, 0.65460669E-05_JPRB, 0.66883800E-05_JPRB, 0.68349962E-05_JPRB, 0.69707868E-05_JPRB, &
  & 0.70799431E-05_JPRB, 0.71426622E-05_JPRB, 0.71553991E-05_JPRB, 0.71411114E-05_JPRB, 0.71142663E-05_JPRB, 0.70759102E-05_JPRB, &
  & 0.70353561E-05_JPRB, 0.69938515E-05_JPRB, 0.69518756E-05_JPRB, 0.69198230E-05_JPRB, 0.69274641E-05_JPRB, 0.69808859E-05_JPRB, &
  & 0.70736043E-05_JPRB, 0.71807909E-05_JPRB, 0.72937962E-05_JPRB, 0.74046406E-05_JPRB, 0.74807580E-05_JPRB, 0.75294213E-05_JPRB, &
  & 0.75417729E-05_JPRB, 0.75178132E-05_JPRB, 0.74580616E-05_JPRB, 0.73725302E-05_JPRB, 0.72645758E-05_JPRB, 0.71355014E-05_JPRB, &
  & 0.69650798E-05_JPRB, 0.67432950E-05_JPRB, 0.64797727E-05_JPRB, 0.62083330E-05_JPRB, 0.59576648E-05_JPRB, 0.57371210E-05_JPRB, &
  & 0.55661040E-05_JPRB, 0.54014347E-05_JPRB, 0.52467451E-05_JPRB, 0.51003558E-05_JPRB, 0.49441626E-05_JPRB, 0.47856417E-05_JPRB, &
  & 0.46268940E-05_JPRB, 0.44707819E-05_JPRB, 0.43547174E-05_JPRB, 0.42845977E-05_JPRB  /)

RGHG7(:,14,12) = (/ &
  & 0.56357016E-05_JPRB, 0.56059418E-05_JPRB, 0.55680336E-05_JPRB, 0.55316581E-05_JPRB, 0.55182823E-05_JPRB, 0.55214315E-05_JPRB, &
  & 0.55482714E-05_JPRB, 0.56265083E-05_JPRB, 0.57548479E-05_JPRB, 0.59618446E-05_JPRB, 0.62015213E-05_JPRB, 0.63999583E-05_JPRB, &
  & 0.65808731E-05_JPRB, 0.67561912E-05_JPRB, 0.69202462E-05_JPRB, 0.70826929E-05_JPRB, 0.72371799E-05_JPRB, 0.73921427E-05_JPRB, &
  & 0.75488898E-05_JPRB, 0.77030693E-05_JPRB, 0.78593398E-05_JPRB, 0.79967252E-05_JPRB, 0.81252761E-05_JPRB, 0.82343464E-05_JPRB, &
  & 0.83154862E-05_JPRB, 0.83439179E-05_JPRB, 0.83170434E-05_JPRB, 0.82540489E-05_JPRB, 0.81650759E-05_JPRB, 0.80515254E-05_JPRB, &
  & 0.79379229E-05_JPRB, 0.78431443E-05_JPRB, 0.77682413E-05_JPRB, 0.77297639E-05_JPRB, 0.77558873E-05_JPRB, 0.78435358E-05_JPRB, &
  & 0.79517578E-05_JPRB, 0.80393973E-05_JPRB, 0.80897850E-05_JPRB, 0.81113618E-05_JPRB, 0.80920147E-05_JPRB, 0.80426307E-05_JPRB, &
  & 0.79697764E-05_JPRB, 0.78815927E-05_JPRB, 0.77737018E-05_JPRB, 0.76467386E-05_JPRB, 0.74921116E-05_JPRB, 0.73163328E-05_JPRB, &
  & 0.71158454E-05_JPRB, 0.68735014E-05_JPRB, 0.65720007E-05_JPRB, 0.62678662E-05_JPRB, 0.60131228E-05_JPRB, 0.58086171E-05_JPRB, &
  & 0.56710536E-05_JPRB, 0.55395600E-05_JPRB, 0.54110656E-05_JPRB, 0.52871898E-05_JPRB, 0.51662969E-05_JPRB, 0.50368006E-05_JPRB, &
  & 0.48916701E-05_JPRB, 0.47413897E-05_JPRB, 0.46032764E-05_JPRB, 0.45097212E-05_JPRB  /)

RGHG7(:,15,12) = (/ &
  & 0.58454525E-05_JPRB, 0.58224853E-05_JPRB, 0.57991503E-05_JPRB, 0.57797107E-05_JPRB, 0.57901303E-05_JPRB, 0.58362677E-05_JPRB, &
  & 0.59112185E-05_JPRB, 0.60412183E-05_JPRB, 0.62178218E-05_JPRB, 0.64665342E-05_JPRB, 0.67481397E-05_JPRB, 0.69956780E-05_JPRB, &
  & 0.72323433E-05_JPRB, 0.74596091E-05_JPRB, 0.76714324E-05_JPRB, 0.78827647E-05_JPRB, 0.80826940E-05_JPRB, 0.82771715E-05_JPRB, &
  & 0.84679412E-05_JPRB, 0.86444665E-05_JPRB, 0.87987017E-05_JPRB, 0.89209309E-05_JPRB, 0.90246925E-05_JPRB, 0.91046858E-05_JPRB, &
  & 0.91654719E-05_JPRB, 0.91861155E-05_JPRB, 0.91562676E-05_JPRB, 0.90854124E-05_JPRB, 0.89784559E-05_JPRB, 0.88255281E-05_JPRB, &
  & 0.86565323E-05_JPRB, 0.85161703E-05_JPRB, 0.84124721E-05_JPRB, 0.83713690E-05_JPRB, 0.84050919E-05_JPRB, 0.84845056E-05_JPRB, &
  & 0.85398186E-05_JPRB, 0.85404440E-05_JPRB, 0.84940391E-05_JPRB, 0.84137396E-05_JPRB, 0.83016479E-05_JPRB, 0.81730706E-05_JPRB, &
  & 0.80553793E-05_JPRB, 0.79378188E-05_JPRB, 0.77998027E-05_JPRB, 0.76409279E-05_JPRB, 0.74525169E-05_JPRB, 0.72360191E-05_JPRB, &
  & 0.69985545E-05_JPRB, 0.67231156E-05_JPRB, 0.64002340E-05_JPRB, 0.60966729E-05_JPRB, 0.58681043E-05_JPRB, 0.56980968E-05_JPRB, &
  & 0.55899324E-05_JPRB, 0.54919735E-05_JPRB, 0.53941227E-05_JPRB, 0.53031846E-05_JPRB, 0.52103393E-05_JPRB, 0.50865704E-05_JPRB, &
  & 0.49271598E-05_JPRB, 0.47580904E-05_JPRB, 0.46140535E-05_JPRB, 0.45179929E-05_JPRB  /)

RGHG7(:,16,12) = (/ &
  & 0.57800249E-05_JPRB, 0.57702788E-05_JPRB, 0.57668586E-05_JPRB, 0.57748062E-05_JPRB, 0.58107616E-05_JPRB, 0.58818608E-05_JPRB, &
  & 0.59825414E-05_JPRB, 0.61343134E-05_JPRB, 0.63269314E-05_JPRB, 0.65834905E-05_JPRB, 0.68717253E-05_JPRB, 0.71418461E-05_JPRB, &
  & 0.74098545E-05_JPRB, 0.76784762E-05_JPRB, 0.79324655E-05_JPRB, 0.81766802E-05_JPRB, 0.84017155E-05_JPRB, 0.86216293E-05_JPRB, &
  & 0.88460785E-05_JPRB, 0.90502792E-05_JPRB, 0.92171708E-05_JPRB, 0.93382432E-05_JPRB, 0.94297730E-05_JPRB, 0.94852162E-05_JPRB, &
  & 0.95313416E-05_JPRB, 0.95666039E-05_JPRB, 0.95799439E-05_JPRB, 0.95742326E-05_JPRB, 0.95430356E-05_JPRB, 0.94682447E-05_JPRB, &
  & 0.93518401E-05_JPRB, 0.92291442E-05_JPRB, 0.91243486E-05_JPRB, 0.90613391E-05_JPRB, 0.90422515E-05_JPRB, 0.90268810E-05_JPRB, &
  & 0.89486080E-05_JPRB, 0.88182438E-05_JPRB, 0.86553883E-05_JPRB, 0.84607532E-05_JPRB, 0.82630782E-05_JPRB, 0.80805841E-05_JPRB, &
  & 0.79255857E-05_JPRB, 0.77837863E-05_JPRB, 0.76228380E-05_JPRB, 0.74383487E-05_JPRB, 0.72244996E-05_JPRB, 0.69745561E-05_JPRB, &
  & 0.66977741E-05_JPRB, 0.63964738E-05_JPRB, 0.60789800E-05_JPRB, 0.58099477E-05_JPRB, 0.56270345E-05_JPRB, 0.55030971E-05_JPRB, &
  & 0.54228951E-05_JPRB, 0.53566537E-05_JPRB, 0.52838648E-05_JPRB, 0.52157770E-05_JPRB, 0.51314387E-05_JPRB, 0.49981937E-05_JPRB, &
  & 0.48173621E-05_JPRB, 0.46313421E-05_JPRB, 0.44917755E-05_JPRB, 0.44040048E-05_JPRB  /)

RGHG7(:,17,12) = (/ &
  & 0.55957059E-05_JPRB, 0.55987166E-05_JPRB, 0.56154528E-05_JPRB, 0.56467832E-05_JPRB, 0.56990332E-05_JPRB, 0.57821534E-05_JPRB, &
  & 0.58905894E-05_JPRB, 0.60380640E-05_JPRB, 0.62216112E-05_JPRB, 0.64608243E-05_JPRB, 0.67281691E-05_JPRB, 0.69911592E-05_JPRB, &
  & 0.72640557E-05_JPRB, 0.75581470E-05_JPRB, 0.78415183E-05_JPRB, 0.80970718E-05_JPRB, 0.83329110E-05_JPRB, 0.85702327E-05_JPRB, &
  & 0.88172861E-05_JPRB, 0.90522645E-05_JPRB, 0.92420684E-05_JPRB, 0.93677328E-05_JPRB, 0.94585199E-05_JPRB, 0.95074785E-05_JPRB, &
  & 0.95516013E-05_JPRB, 0.96063860E-05_JPRB, 0.96708711E-05_JPRB, 0.97447284E-05_JPRB, 0.98216598E-05_JPRB, 0.98776626E-05_JPRB, &
  & 0.98874825E-05_JPRB, 0.98621247E-05_JPRB, 0.98031955E-05_JPRB, 0.97087487E-05_JPRB, 0.95950476E-05_JPRB, 0.94403271E-05_JPRB, &
  & 0.92033283E-05_JPRB, 0.89392304E-05_JPRB, 0.86600748E-05_JPRB, 0.83497160E-05_JPRB, 0.80607908E-05_JPRB, 0.78326262E-05_JPRB, &
  & 0.76445259E-05_JPRB, 0.74841898E-05_JPRB, 0.73189839E-05_JPRB, 0.71310122E-05_JPRB, 0.69122295E-05_JPRB, 0.66434369E-05_JPRB, &
  & 0.63482463E-05_JPRB, 0.60519643E-05_JPRB, 0.57669498E-05_JPRB, 0.55528122E-05_JPRB, 0.54228639E-05_JPRB, 0.53387221E-05_JPRB, &
  & 0.52750225E-05_JPRB, 0.52174632E-05_JPRB, 0.51525335E-05_JPRB, 0.50866682E-05_JPRB, 0.49865084E-05_JPRB, 0.48328628E-05_JPRB, &
  & 0.46334448E-05_JPRB, 0.44513923E-05_JPRB, 0.43278563E-05_JPRB, 0.42642910E-05_JPRB  /)

RGHG7(:,18,12) = (/ &
  & 0.53713639E-05_JPRB, 0.53803263E-05_JPRB, 0.54111383E-05_JPRB, 0.54622297E-05_JPRB, 0.55287280E-05_JPRB, 0.56167274E-05_JPRB, &
  & 0.57223809E-05_JPRB, 0.58592715E-05_JPRB, 0.60330599E-05_JPRB, 0.62497192E-05_JPRB, 0.64845724E-05_JPRB, 0.67190562E-05_JPRB, &
  & 0.69684773E-05_JPRB, 0.72545173E-05_JPRB, 0.75475511E-05_JPRB, 0.78038815E-05_JPRB, 0.80377942E-05_JPRB, 0.82757139E-05_JPRB, &
  & 0.85283237E-05_JPRB, 0.87883167E-05_JPRB, 0.90037327E-05_JPRB, 0.91365485E-05_JPRB, 0.92273525E-05_JPRB, 0.92849368E-05_JPRB, &
  & 0.93473304E-05_JPRB, 0.94386638E-05_JPRB, 0.95615321E-05_JPRB, 0.97015271E-05_JPRB, 0.98519581E-05_JPRB, 0.99809169E-05_JPRB, &
  & 0.10064880E-04_JPRB, 0.10110581E-04_JPRB, 0.10088272E-04_JPRB, 0.99824946E-05_JPRB, 0.98129633E-05_JPRB, 0.95833894E-05_JPRB, &
  & 0.92573289E-05_JPRB, 0.89145923E-05_JPRB, 0.85656408E-05_JPRB, 0.81780287E-05_JPRB, 0.78089883E-05_JPRB, 0.75422730E-05_JPRB, &
  & 0.73228460E-05_JPRB, 0.71663303E-05_JPRB, 0.70156944E-05_JPRB, 0.68393808E-05_JPRB, 0.66352096E-05_JPRB, 0.63745315E-05_JPRB, &
  & 0.60878077E-05_JPRB, 0.58138118E-05_JPRB, 0.55736344E-05_JPRB, 0.54034874E-05_JPRB, 0.53034496E-05_JPRB, 0.52339246E-05_JPRB, &
  & 0.51678255E-05_JPRB, 0.50945691E-05_JPRB, 0.50202196E-05_JPRB, 0.49338569E-05_JPRB, 0.47950071E-05_JPRB, 0.46088712E-05_JPRB, &
  & 0.44107374E-05_JPRB, 0.42525850E-05_JPRB, 0.41520783E-05_JPRB, 0.41195835E-05_JPRB  /)

RGHG7(:,19,12) = (/ &
  & 0.51436707E-05_JPRB, 0.51516005E-05_JPRB, 0.51902233E-05_JPRB, 0.52526454E-05_JPRB, 0.53241173E-05_JPRB, 0.54080455E-05_JPRB, &
  & 0.55055261E-05_JPRB, 0.56322214E-05_JPRB, 0.57915926E-05_JPRB, 0.59828216E-05_JPRB, 0.61803973E-05_JPRB, 0.63763331E-05_JPRB, &
  & 0.65842689E-05_JPRB, 0.68275525E-05_JPRB, 0.70925683E-05_JPRB, 0.73317639E-05_JPRB, 0.75539635E-05_JPRB, 0.77788886E-05_JPRB, &
  & 0.80262821E-05_JPRB, 0.83055279E-05_JPRB, 0.85467356E-05_JPRB, 0.86943159E-05_JPRB, 0.87968096E-05_JPRB, 0.88810970E-05_JPRB, &
  & 0.89777610E-05_JPRB, 0.91062426E-05_JPRB, 0.92683591E-05_JPRB, 0.94445015E-05_JPRB, 0.96218052E-05_JPRB, 0.97676320E-05_JPRB, &
  & 0.98755251E-05_JPRB, 0.99506892E-05_JPRB, 0.99535738E-05_JPRB, 0.98531418E-05_JPRB, 0.96743077E-05_JPRB, 0.94256122E-05_JPRB, &
  & 0.90912520E-05_JPRB, 0.87382105E-05_JPRB, 0.83777851E-05_JPRB, 0.79713335E-05_JPRB, 0.75596272E-05_JPRB, 0.72595058E-05_JPRB, &
  & 0.70354095E-05_JPRB, 0.68948433E-05_JPRB, 0.67645782E-05_JPRB, 0.66079449E-05_JPRB, 0.64254839E-05_JPRB, 0.61941732E-05_JPRB, &
  & 0.59340870E-05_JPRB, 0.56870824E-05_JPRB, 0.54856141E-05_JPRB, 0.53362328E-05_JPRB, 0.52405936E-05_JPRB, 0.51645707E-05_JPRB, &
  & 0.50772588E-05_JPRB, 0.49726125E-05_JPRB, 0.48642157E-05_JPRB, 0.47419180E-05_JPRB, 0.45701257E-05_JPRB, 0.43640978E-05_JPRB, &
  & 0.41799817E-05_JPRB, 0.40422797E-05_JPRB, 0.39635810E-05_JPRB, 0.39417856E-05_JPRB  /)

RGHG7(:,20,12) = (/ &
  & 0.49352010E-05_JPRB, 0.49418263E-05_JPRB, 0.49835934E-05_JPRB, 0.50506640E-05_JPRB, 0.51193397E-05_JPRB, 0.51942766E-05_JPRB, &
  & 0.52802578E-05_JPRB, 0.53917272E-05_JPRB, 0.55310101E-05_JPRB, 0.56933702E-05_JPRB, 0.58557953E-05_JPRB, 0.60131659E-05_JPRB, &
  & 0.61775585E-05_JPRB, 0.63639512E-05_JPRB, 0.65694385E-05_JPRB, 0.67659256E-05_JPRB, 0.69621090E-05_JPRB, 0.71632404E-05_JPRB, &
  & 0.73916076E-05_JPRB, 0.76750800E-05_JPRB, 0.79407233E-05_JPRB, 0.81139727E-05_JPRB, 0.82377131E-05_JPRB, 0.83531950E-05_JPRB, &
  & 0.84784522E-05_JPRB, 0.86252436E-05_JPRB, 0.87901454E-05_JPRB, 0.89620411E-05_JPRB, 0.91206393E-05_JPRB, 0.92393829E-05_JPRB, &
  & 0.93286412E-05_JPRB, 0.93971078E-05_JPRB, 0.94071642E-05_JPRB, 0.93224935E-05_JPRB, 0.91713714E-05_JPRB, 0.89596761E-05_JPRB, &
  & 0.86904377E-05_JPRB, 0.83957625E-05_JPRB, 0.80730701E-05_JPRB, 0.76956718E-05_JPRB, 0.72873208E-05_JPRB, 0.69790848E-05_JPRB, &
  & 0.67803211E-05_JPRB, 0.66665679E-05_JPRB, 0.65630207E-05_JPRB, 0.64326749E-05_JPRB, 0.62739118E-05_JPRB, 0.60787216E-05_JPRB, &
  & 0.58515306E-05_JPRB, 0.56371630E-05_JPRB, 0.54621750E-05_JPRB, 0.53200549E-05_JPRB, 0.52110883E-05_JPRB, 0.51098745E-05_JPRB, &
  & 0.49866957E-05_JPRB, 0.48408938E-05_JPRB, 0.46875356E-05_JPRB, 0.45238207E-05_JPRB, 0.43286855E-05_JPRB, 0.41191163E-05_JPRB, &
  & 0.39473378E-05_JPRB, 0.38201185E-05_JPRB, 0.37556671E-05_JPRB, 0.37327547E-05_JPRB  /)

RGHG7(:,21,12) = (/ &
  & 0.47613682E-05_JPRB, 0.47718801E-05_JPRB, 0.48162128E-05_JPRB, 0.48841921E-05_JPRB, 0.49459309E-05_JPRB, 0.50092821E-05_JPRB, &
  & 0.50809441E-05_JPRB, 0.51722592E-05_JPRB, 0.52873698E-05_JPRB, 0.54179522E-05_JPRB, 0.55480139E-05_JPRB, 0.56707667E-05_JPRB, &
  & 0.57954921E-05_JPRB, 0.59251002E-05_JPRB, 0.60595217E-05_JPRB, 0.61961258E-05_JPRB, 0.63497917E-05_JPRB, 0.65147677E-05_JPRB, &
  & 0.67097703E-05_JPRB, 0.69713632E-05_JPRB, 0.72509437E-05_JPRB, 0.74553450E-05_JPRB, 0.76006640E-05_JPRB, 0.77373948E-05_JPRB, &
  & 0.78728369E-05_JPRB, 0.80115168E-05_JPRB, 0.81454064E-05_JPRB, 0.82771804E-05_JPRB, 0.83810774E-05_JPRB, 0.84406114E-05_JPRB, &
  & 0.84790030E-05_JPRB, 0.85128065E-05_JPRB, 0.85134574E-05_JPRB, 0.84552849E-05_JPRB, 0.83607912E-05_JPRB, 0.82296135E-05_JPRB, &
  & 0.80692468E-05_JPRB, 0.78788116E-05_JPRB, 0.76320526E-05_JPRB, 0.73202495E-05_JPRB, 0.69610244E-05_JPRB, 0.66846938E-05_JPRB, &
  & 0.65364176E-05_JPRB, 0.64560864E-05_JPRB, 0.63841557E-05_JPRB, 0.62870447E-05_JPRB, 0.61567011E-05_JPRB, 0.59982794E-05_JPRB, &
  & 0.58061344E-05_JPRB, 0.56277700E-05_JPRB, 0.54707358E-05_JPRB, 0.53291853E-05_JPRB, 0.51978285E-05_JPRB, 0.50608233E-05_JPRB, &
  & 0.48950011E-05_JPRB, 0.47053556E-05_JPRB, 0.45069525E-05_JPRB, 0.43030917E-05_JPRB, 0.40925149E-05_JPRB, 0.38896838E-05_JPRB, &
  & 0.37232617E-05_JPRB, 0.35966437E-05_JPRB, 0.35366865E-05_JPRB, 0.35091702E-05_JPRB  /)

RGHG7(:,22,12) = (/ &
  & 0.46433995E-05_JPRB, 0.46682564E-05_JPRB, 0.47201418E-05_JPRB, 0.47879184E-05_JPRB, 0.48422565E-05_JPRB, 0.48921751E-05_JPRB, &
  & 0.49464506E-05_JPRB, 0.50165269E-05_JPRB, 0.51058366E-05_JPRB, 0.52031160E-05_JPRB, 0.53015983E-05_JPRB, 0.53957623E-05_JPRB, &
  & 0.54861709E-05_JPRB, 0.55698545E-05_JPRB, 0.56480615E-05_JPRB, 0.57240411E-05_JPRB, 0.58166264E-05_JPRB, 0.59278717E-05_JPRB, &
  & 0.60754290E-05_JPRB, 0.62736095E-05_JPRB, 0.65407205E-05_JPRB, 0.67715309E-05_JPRB, 0.69259233E-05_JPRB, 0.70577879E-05_JPRB, &
  & 0.71750832E-05_JPRB, 0.72741241E-05_JPRB, 0.73519006E-05_JPRB, 0.74159029E-05_JPRB, 0.74391024E-05_JPRB, 0.74160635E-05_JPRB, &
  & 0.73806514E-05_JPRB, 0.73575814E-05_JPRB, 0.73369934E-05_JPRB, 0.73212480E-05_JPRB, 0.73086682E-05_JPRB, 0.72838368E-05_JPRB, &
  & 0.72372170E-05_JPRB, 0.71651414E-05_JPRB, 0.70255904E-05_JPRB, 0.68101478E-05_JPRB, 0.65480943E-05_JPRB, 0.63596589E-05_JPRB, &
  & 0.62822465E-05_JPRB, 0.62350661E-05_JPRB, 0.61958301E-05_JPRB, 0.61402337E-05_JPRB, 0.60498840E-05_JPRB, 0.59272489E-05_JPRB, &
  & 0.57722592E-05_JPRB, 0.56277047E-05_JPRB, 0.54869418E-05_JPRB, 0.53420964E-05_JPRB, 0.51874226E-05_JPRB, 0.50152896E-05_JPRB, &
  & 0.48099804E-05_JPRB, 0.45826727E-05_JPRB, 0.43478240E-05_JPRB, 0.41111671E-05_JPRB, 0.38919731E-05_JPRB, 0.36976072E-05_JPRB, &
  & 0.35283972E-05_JPRB, 0.33931619E-05_JPRB, 0.33262603E-05_JPRB, 0.32956013E-05_JPRB  /)

RGHG7(:,23,12) = (/ &
  & 0.46078935E-05_JPRB, 0.46347292E-05_JPRB, 0.46810944E-05_JPRB, 0.47396547E-05_JPRB, 0.47896511E-05_JPRB, 0.48330566E-05_JPRB, &
  & 0.48693657E-05_JPRB, 0.49166061E-05_JPRB, 0.49781710E-05_JPRB, 0.50425460E-05_JPRB, 0.51079148E-05_JPRB, 0.51707538E-05_JPRB, &
  & 0.52241116E-05_JPRB, 0.52660901E-05_JPRB, 0.53028038E-05_JPRB, 0.53388498E-05_JPRB, 0.53849179E-05_JPRB, 0.54434175E-05_JPRB, &
  & 0.55281711E-05_JPRB, 0.56573139E-05_JPRB, 0.58593915E-05_JPRB, 0.60804349E-05_JPRB, 0.62237527E-05_JPRB, 0.63225290E-05_JPRB, &
  & 0.63977804E-05_JPRB, 0.64493323E-05_JPRB, 0.64778447E-05_JPRB, 0.64870761E-05_JPRB, 0.64507021E-05_JPRB, 0.63707412E-05_JPRB, &
  & 0.62883062E-05_JPRB, 0.62260074E-05_JPRB, 0.61913335E-05_JPRB, 0.62022219E-05_JPRB, 0.62510060E-05_JPRB, 0.62972663E-05_JPRB, &
  & 0.63166848E-05_JPRB, 0.63119333E-05_JPRB, 0.62615548E-05_JPRB, 0.61595063E-05_JPRB, 0.60294058E-05_JPRB, 0.59447820E-05_JPRB, &
  & 0.59285371E-05_JPRB, 0.59182762E-05_JPRB, 0.59101422E-05_JPRB, 0.58922058E-05_JPRB, 0.58468045E-05_JPRB, 0.57648132E-05_JPRB, &
  & 0.56559844E-05_JPRB, 0.55456816E-05_JPRB, 0.54262676E-05_JPRB, 0.52919785E-05_JPRB, 0.51321378E-05_JPRB, 0.49443948E-05_JPRB, &
  & 0.47232265E-05_JPRB, 0.44809506E-05_JPRB, 0.42321175E-05_JPRB, 0.39873713E-05_JPRB, 0.37677309E-05_JPRB, 0.35741168E-05_JPRB, &
  & 0.34015283E-05_JPRB, 0.32637095E-05_JPRB, 0.31896950E-05_JPRB, 0.31645690E-05_JPRB  /)

RGHG7(:,24,12) = (/ &
  & 0.45757213E-05_JPRB, 0.45932516E-05_JPRB, 0.46265523E-05_JPRB, 0.46741886E-05_JPRB, 0.47194613E-05_JPRB, 0.47554934E-05_JPRB, &
  & 0.47749919E-05_JPRB, 0.47999325E-05_JPRB, 0.48331243E-05_JPRB, 0.48652825E-05_JPRB, 0.48972742E-05_JPRB, 0.49261003E-05_JPRB, &
  & 0.49414811E-05_JPRB, 0.49457293E-05_JPRB, 0.49471481E-05_JPRB, 0.49487208E-05_JPRB, 0.49539436E-05_JPRB, 0.49654712E-05_JPRB, &
  & 0.49941894E-05_JPRB, 0.50584729E-05_JPRB, 0.51876188E-05_JPRB, 0.53758246E-05_JPRB, 0.54937215E-05_JPRB, 0.55499206E-05_JPRB, &
  & 0.55779266E-05_JPRB, 0.55842260E-05_JPRB, 0.55729953E-05_JPRB, 0.55416148E-05_JPRB, 0.54673137E-05_JPRB, 0.53537635E-05_JPRB, &
  & 0.52452320E-05_JPRB, 0.51618476E-05_JPRB, 0.51209388E-05_JPRB, 0.51457388E-05_JPRB, 0.52277778E-05_JPRB, 0.53135731E-05_JPRB, &
  & 0.53740118E-05_JPRB, 0.54176837E-05_JPRB, 0.54421322E-05_JPRB, 0.54477611E-05_JPRB, 0.54467181E-05_JPRB, 0.54617386E-05_JPRB, &
  & 0.55001687E-05_JPRB, 0.55272321E-05_JPRB, 0.55511304E-05_JPRB, 0.55696708E-05_JPRB, 0.55674198E-05_JPRB, 0.55294466E-05_JPRB, &
  & 0.54691212E-05_JPRB, 0.53961876E-05_JPRB, 0.53023344E-05_JPRB, 0.51854924E-05_JPRB, 0.50317426E-05_JPRB, 0.48412154E-05_JPRB, &
  & 0.46172040E-05_JPRB, 0.43729960E-05_JPRB, 0.41237946E-05_JPRB, 0.38830575E-05_JPRB, 0.36684645E-05_JPRB, 0.34773532E-05_JPRB, &
  & 0.33079944E-05_JPRB, 0.31743739E-05_JPRB, 0.30968562E-05_JPRB, 0.30779208E-05_JPRB  /)

RGHG7(:,25,12) = (/ &
  & 0.45323563E-05_JPRB, 0.45237874E-05_JPRB, 0.45341841E-05_JPRB, 0.45703899E-05_JPRB, 0.46097865E-05_JPRB, 0.46356963E-05_JPRB, &
  & 0.46413196E-05_JPRB, 0.46462729E-05_JPRB, 0.46516926E-05_JPRB, 0.46542131E-05_JPRB, 0.46542079E-05_JPRB, 0.46464050E-05_JPRB, &
  & 0.46244919E-05_JPRB, 0.45988021E-05_JPRB, 0.45741859E-05_JPRB, 0.45478579E-05_JPRB, 0.45208480E-05_JPRB, 0.44975265E-05_JPRB, &
  & 0.44881788E-05_JPRB, 0.44991915E-05_JPRB, 0.45565161E-05_JPRB, 0.46806210E-05_JPRB, 0.47533536E-05_JPRB, 0.47584264E-05_JPRB, &
  & 0.47374721E-05_JPRB, 0.47062847E-05_JPRB, 0.46724288E-05_JPRB, 0.46244280E-05_JPRB, 0.45475105E-05_JPRB, 0.44374560E-05_JPRB, &
  & 0.43350579E-05_JPRB, 0.42597156E-05_JPRB, 0.42251547E-05_JPRB, 0.42442502E-05_JPRB, 0.43128643E-05_JPRB, 0.43884300E-05_JPRB, &
  & 0.44544446E-05_JPRB, 0.45223499E-05_JPRB, 0.45968953E-05_JPRB, 0.46913948E-05_JPRB, 0.48006464E-05_JPRB, 0.48998623E-05_JPRB, &
  & 0.49811835E-05_JPRB, 0.50437608E-05_JPRB, 0.51002564E-05_JPRB, 0.51524020E-05_JPRB, 0.51870589E-05_JPRB, 0.51960086E-05_JPRB, &
  & 0.51841288E-05_JPRB, 0.51523064E-05_JPRB, 0.50891848E-05_JPRB, 0.49980989E-05_JPRB, 0.48660306E-05_JPRB, 0.46911800E-05_JPRB, &
  & 0.44822020E-05_JPRB, 0.42541426E-05_JPRB, 0.40236632E-05_JPRB, 0.38026345E-05_JPRB, 0.36007588E-05_JPRB, 0.34168747E-05_JPRB, &
  & 0.32624420E-05_JPRB, 0.31434902E-05_JPRB, 0.30690607E-05_JPRB, 0.30552508E-05_JPRB  /)

RGHG7(:,26,12) = (/ &
  & 0.44264310E-05_JPRB, 0.43999952E-05_JPRB, 0.43877951E-05_JPRB, 0.44100026E-05_JPRB, 0.44366149E-05_JPRB, 0.44492362E-05_JPRB, &
  & 0.44453919E-05_JPRB, 0.44350109E-05_JPRB, 0.44164040E-05_JPRB, 0.43943104E-05_JPRB, 0.43688617E-05_JPRB, 0.43343742E-05_JPRB, &
  & 0.42883858E-05_JPRB, 0.42407301E-05_JPRB, 0.41926691E-05_JPRB, 0.41423514E-05_JPRB, 0.40915174E-05_JPRB, 0.40420904E-05_JPRB, &
  & 0.40076742E-05_JPRB, 0.39856393E-05_JPRB, 0.39960320E-05_JPRB, 0.40546556E-05_JPRB, 0.40745219E-05_JPRB, 0.40381655E-05_JPRB, &
  & 0.39845575E-05_JPRB, 0.39330164E-05_JPRB, 0.38918104E-05_JPRB, 0.38446858E-05_JPRB, 0.37786119E-05_JPRB, 0.36859036E-05_JPRB, &
  & 0.35995360E-05_JPRB, 0.35394100E-05_JPRB, 0.35135327E-05_JPRB, 0.35252998E-05_JPRB, 0.35698146E-05_JPRB, 0.36192071E-05_JPRB, &
  & 0.36703493E-05_JPRB, 0.37436524E-05_JPRB, 0.38478855E-05_JPRB, 0.39888637E-05_JPRB, 0.41548512E-05_JPRB, 0.42990959E-05_JPRB, &
  & 0.44133327E-05_JPRB, 0.45047750E-05_JPRB, 0.45880864E-05_JPRB, 0.46676649E-05_JPRB, 0.47343208E-05_JPRB, 0.47822147E-05_JPRB, &
  & 0.48085192E-05_JPRB, 0.48124241E-05_JPRB, 0.47825668E-05_JPRB, 0.47224395E-05_JPRB, 0.46201641E-05_JPRB, 0.44728422E-05_JPRB, &
  & 0.42943042E-05_JPRB, 0.40985309E-05_JPRB, 0.39002626E-05_JPRB, 0.37079170E-05_JPRB, 0.35273276E-05_JPRB, 0.33637727E-05_JPRB, &
  & 0.32272769E-05_JPRB, 0.31234114E-05_JPRB, 0.30566849E-05_JPRB, 0.30404446E-05_JPRB  /)

RGHG7(:,27,12) = (/ &
  & 0.42924870E-05_JPRB, 0.42504235E-05_JPRB, 0.42147118E-05_JPRB, 0.42213316E-05_JPRB, 0.42320161E-05_JPRB, 0.42295700E-05_JPRB, &
  & 0.42174617E-05_JPRB, 0.41927736E-05_JPRB, 0.41504350E-05_JPRB, 0.41044697E-05_JPRB, 0.40548491E-05_JPRB, 0.39961497E-05_JPRB, &
  & 0.39298913E-05_JPRB, 0.38622257E-05_JPRB, 0.37906132E-05_JPRB, 0.37166638E-05_JPRB, 0.36440391E-05_JPRB, 0.35705603E-05_JPRB, &
  & 0.35147535E-05_JPRB, 0.34656653E-05_JPRB, 0.34362184E-05_JPRB, 0.34258681E-05_JPRB, 0.33876058E-05_JPRB, 0.33115298E-05_JPRB, &
  & 0.32298280E-05_JPRB, 0.31633596E-05_JPRB, 0.31201325E-05_JPRB, 0.30804116E-05_JPRB, 0.30306658E-05_JPRB, 0.29612289E-05_JPRB, &
  & 0.28952913E-05_JPRB, 0.28537345E-05_JPRB, 0.28378021E-05_JPRB, 0.28413051E-05_JPRB, 0.28566655E-05_JPRB, 0.28727817E-05_JPRB, &
  & 0.29007925E-05_JPRB, 0.29727550E-05_JPRB, 0.31004596E-05_JPRB, 0.32743140E-05_JPRB, 0.34797609E-05_JPRB, 0.36565616E-05_JPRB, &
  & 0.38015136E-05_JPRB, 0.39206695E-05_JPRB, 0.40298736E-05_JPRB, 0.41358451E-05_JPRB, 0.42341365E-05_JPRB, 0.43197890E-05_JPRB, &
  & 0.43822114E-05_JPRB, 0.44214736E-05_JPRB, 0.44273338E-05_JPRB, 0.44015034E-05_JPRB, 0.43333848E-05_JPRB, 0.42192392E-05_JPRB, &
  & 0.40782398E-05_JPRB, 0.39222061E-05_JPRB, 0.37626168E-05_JPRB, 0.36035876E-05_JPRB, 0.34484306E-05_JPRB, 0.33109886E-05_JPRB, &
  & 0.31943626E-05_JPRB, 0.31064249E-05_JPRB, 0.30494632E-05_JPRB, 0.30278803E-05_JPRB  /)

RGHG7(:,28,12) = (/ &
  & 0.40577202E-05_JPRB, 0.40081867E-05_JPRB, 0.39575904E-05_JPRB, 0.39525587E-05_JPRB, 0.39526904E-05_JPRB, 0.39408873E-05_JPRB, &
  & 0.39214491E-05_JPRB, 0.38778726E-05_JPRB, 0.38244918E-05_JPRB, 0.37714794E-05_JPRB, 0.37140197E-05_JPRB, 0.36438941E-05_JPRB, &
  & 0.35669455E-05_JPRB, 0.34863423E-05_JPRB, 0.34047571E-05_JPRB, 0.33213300E-05_JPRB, 0.32389346E-05_JPRB, 0.31580198E-05_JPRB, &
  & 0.30893540E-05_JPRB, 0.30262213E-05_JPRB, 0.29768822E-05_JPRB, 0.29323973E-05_JPRB, 0.28648422E-05_JPRB, 0.27720161E-05_JPRB, &
  & 0.26832008E-05_JPRB, 0.26163115E-05_JPRB, 0.25730382E-05_JPRB, 0.25405802E-05_JPRB, 0.25029300E-05_JPRB, 0.24495136E-05_JPRB, &
  & 0.24004809E-05_JPRB, 0.23726516E-05_JPRB, 0.23625383E-05_JPRB, 0.23598733E-05_JPRB, 0.23582350E-05_JPRB, 0.23576219E-05_JPRB, &
  & 0.23763572E-05_JPRB, 0.24499103E-05_JPRB, 0.25796331E-05_JPRB, 0.27470280E-05_JPRB, 0.29414435E-05_JPRB, 0.31219808E-05_JPRB, &
  & 0.32797268E-05_JPRB, 0.34141151E-05_JPRB, 0.35382144E-05_JPRB, 0.36625867E-05_JPRB, 0.37807632E-05_JPRB, 0.38825908E-05_JPRB, &
  & 0.39612730E-05_JPRB, 0.40205003E-05_JPRB, 0.40533115E-05_JPRB, 0.40562022E-05_JPRB, 0.40187413E-05_JPRB, 0.39413237E-05_JPRB, &
  & 0.38405103E-05_JPRB, 0.37283015E-05_JPRB, 0.36106198E-05_JPRB, 0.34917767E-05_JPRB, 0.33733254E-05_JPRB, 0.32701093E-05_JPRB, &
  & 0.31783671E-05_JPRB, 0.31069581E-05_JPRB, 0.30654859E-05_JPRB, 0.30452699E-05_JPRB  /)

RGHG7(:,29,12) = (/ &
  & 0.38045938E-05_JPRB, 0.37474989E-05_JPRB, 0.36815053E-05_JPRB, 0.36642984E-05_JPRB, 0.36534816E-05_JPRB, 0.36320117E-05_JPRB, &
  & 0.36048473E-05_JPRB, 0.35410583E-05_JPRB, 0.34765276E-05_JPRB, 0.34167777E-05_JPRB, 0.33517200E-05_JPRB, 0.32700418E-05_JPRB, &
  & 0.31821813E-05_JPRB, 0.30881764E-05_JPRB, 0.29966131E-05_JPRB, 0.29037571E-05_JPRB, 0.28115300E-05_JPRB, 0.27234567E-05_JPRB, &
  & 0.26415355E-05_JPRB, 0.25640856E-05_JPRB, 0.24945340E-05_JPRB, 0.24153911E-05_JPRB, 0.23180482E-05_JPRB, 0.22084699E-05_JPRB, &
  & 0.21130269E-05_JPRB, 0.20463208E-05_JPRB, 0.20030841E-05_JPRB, 0.19783156E-05_JPRB, 0.19532982E-05_JPRB, 0.19165426E-05_JPRB, &
  & 0.18852691E-05_JPRB, 0.18717753E-05_JPRB, 0.18676488E-05_JPRB, 0.18585392E-05_JPRB, 0.18394163E-05_JPRB, 0.18217947E-05_JPRB, &
  & 0.18313025E-05_JPRB, 0.19066681E-05_JPRB, 0.20375994E-05_JPRB, 0.21964441E-05_JPRB, 0.23769819E-05_JPRB, 0.25602288E-05_JPRB, &
  & 0.27307541E-05_JPRB, 0.28807412E-05_JPRB, 0.30201464E-05_JPRB, 0.31636693E-05_JPRB, 0.33024062E-05_JPRB, 0.34204368E-05_JPRB, &
  & 0.35154868E-05_JPRB, 0.35952012E-05_JPRB, 0.36561891E-05_JPRB, 0.36892704E-05_JPRB, 0.36841423E-05_JPRB, 0.36457949E-05_JPRB, &
  & 0.35876769E-05_JPRB, 0.35220814E-05_JPRB, 0.34489441E-05_JPRB, 0.33729795E-05_JPRB, 0.32939096E-05_JPRB, 0.32273104E-05_JPRB, &
  & 0.31621521E-05_JPRB, 0.31082826E-05_JPRB, 0.30834711E-05_JPRB, 0.30649944E-05_JPRB  /)

RGHG7(:,30,12) = (/ &
  & 0.34332843E-05_JPRB, 0.33863474E-05_JPRB, 0.33213050E-05_JPRB, 0.32953216E-05_JPRB, 0.32793160E-05_JPRB, 0.32524815E-05_JPRB, &
  & 0.32163033E-05_JPRB, 0.31521101E-05_JPRB, 0.30930378E-05_JPRB, 0.30397314E-05_JPRB, 0.29793311E-05_JPRB, 0.29031110E-05_JPRB, &
  & 0.28211112E-05_JPRB, 0.27323536E-05_JPRB, 0.26441749E-05_JPRB, 0.25525006E-05_JPRB, 0.24591710E-05_JPRB, 0.23669577E-05_JPRB, &
  & 0.22783338E-05_JPRB, 0.21936334E-05_JPRB, 0.21137057E-05_JPRB, 0.20270206E-05_JPRB, 0.19267075E-05_JPRB, 0.18218105E-05_JPRB, &
  & 0.17346125E-05_JPRB, 0.16713967E-05_JPRB, 0.16288034E-05_JPRB, 0.16042670E-05_JPRB, 0.15831050E-05_JPRB, 0.15526048E-05_JPRB, &
  & 0.15261563E-05_JPRB, 0.15148949E-05_JPRB, 0.15065760E-05_JPRB, 0.14922013E-05_JPRB, 0.14709074E-05_JPRB, 0.14541873E-05_JPRB, &
  & 0.14669678E-05_JPRB, 0.15378799E-05_JPRB, 0.16486112E-05_JPRB, 0.17865073E-05_JPRB, 0.19489063E-05_JPRB, 0.21218138E-05_JPRB, &
  & 0.22882171E-05_JPRB, 0.24458741E-05_JPRB, 0.25962139E-05_JPRB, 0.27491308E-05_JPRB, 0.28956868E-05_JPRB, 0.30199242E-05_JPRB, &
  & 0.31234972E-05_JPRB, 0.32183165E-05_JPRB, 0.32930813E-05_JPRB, 0.33424504E-05_JPRB, 0.33568288E-05_JPRB, 0.33446203E-05_JPRB, &
  & 0.33180646E-05_JPRB, 0.32842282E-05_JPRB, 0.32391005E-05_JPRB, 0.31908383E-05_JPRB, 0.31413336E-05_JPRB, 0.30985068E-05_JPRB, &
  & 0.30483463E-05_JPRB, 0.30074077E-05_JPRB, 0.29944006E-05_JPRB, 0.29836135E-05_JPRB  /)

RGHG7(:,31,12) = (/ &
  & 0.30419405E-05_JPRB, 0.30057236E-05_JPRB, 0.29416988E-05_JPRB, 0.29064712E-05_JPRB, 0.28850039E-05_JPRB, 0.28525211E-05_JPRB, &
  & 0.28068443E-05_JPRB, 0.27422439E-05_JPRB, 0.26889388E-05_JPRB, 0.26424340E-05_JPRB, 0.25869527E-05_JPRB, 0.25164996E-05_JPRB, &
  & 0.24406909E-05_JPRB, 0.23574798E-05_JPRB, 0.22728801E-05_JPRB, 0.21824610E-05_JPRB, 0.20879780E-05_JPRB, 0.19914055E-05_JPRB, &
  & 0.18957254E-05_JPRB, 0.18033922E-05_JPRB, 0.17125410E-05_JPRB, 0.16179347E-05_JPRB, 0.15145176E-05_JPRB, 0.14145735E-05_JPRB, &
  & 0.13360769E-05_JPRB, 0.12765418E-05_JPRB, 0.12346270E-05_JPRB, 0.12103281E-05_JPRB, 0.11932200E-05_JPRB, 0.11693010E-05_JPRB, &
  & 0.11479241E-05_JPRB, 0.11390035E-05_JPRB, 0.11262575E-05_JPRB, 0.11063363E-05_JPRB, 0.10827695E-05_JPRB, 0.10670161E-05_JPRB, &
  & 0.10832569E-05_JPRB, 0.11494706E-05_JPRB, 0.12388977E-05_JPRB, 0.13547095E-05_JPRB, 0.14979924E-05_JPRB, 0.16599935E-05_JPRB, &
  & 0.18220376E-05_JPRB, 0.19877684E-05_JPRB, 0.21496253E-05_JPRB, 0.23124310E-05_JPRB, 0.24672135E-05_JPRB, 0.25979812E-05_JPRB, &
  & 0.27105270E-05_JPRB, 0.28212566E-05_JPRB, 0.29105238E-05_JPRB, 0.29770414E-05_JPRB, 0.30119606E-05_JPRB, 0.30272812E-05_JPRB, &
  & 0.30339709E-05_JPRB, 0.30335832E-05_JPRB, 0.30179523E-05_JPRB, 0.29988645E-05_JPRB, 0.29805018E-05_JPRB, 0.29627107E-05_JPRB, &
  & 0.29283418E-05_JPRB, 0.29010236E-05_JPRB, 0.29004495E-05_JPRB, 0.28977702E-05_JPRB  /)

RGHG7(:,32,12) = (/ &
  & 0.26420507E-05_JPRB, 0.26197606E-05_JPRB, 0.25631808E-05_JPRB, 0.25246625E-05_JPRB, 0.24985076E-05_JPRB, 0.24665460E-05_JPRB, &
  & 0.24273129E-05_JPRB, 0.23746831E-05_JPRB, 0.23331312E-05_JPRB, 0.22961595E-05_JPRB, 0.22524877E-05_JPRB, 0.21968736E-05_JPRB, &
  & 0.21326194E-05_JPRB, 0.20601540E-05_JPRB, 0.19834878E-05_JPRB, 0.18976316E-05_JPRB, 0.18042771E-05_JPRB, 0.17075220E-05_JPRB, &
  & 0.16096129E-05_JPRB, 0.15156149E-05_JPRB, 0.14240452E-05_JPRB, 0.13311829E-05_JPRB, 0.12362970E-05_JPRB, 0.11481662E-05_JPRB, &
  & 0.10766277E-05_JPRB, 0.10208592E-05_JPRB, 0.98060345E-06_JPRB, 0.95481525E-06_JPRB, 0.93735063E-06_JPRB, 0.91689150E-06_JPRB, &
  & 0.89826109E-06_JPRB, 0.88929940E-06_JPRB, 0.87565336E-06_JPRB, 0.85634656E-06_JPRB, 0.83676073E-06_JPRB, 0.82596169E-06_JPRB, &
  & 0.84128867E-06_JPRB, 0.89442013E-06_JPRB, 0.96704119E-06_JPRB, 0.10638441E-05_JPRB, 0.11852246E-05_JPRB, 0.13292503E-05_JPRB, &
  & 0.14849949E-05_JPRB, 0.16493263E-05_JPRB, 0.18136333E-05_JPRB, 0.19791183E-05_JPRB, 0.21336379E-05_JPRB, 0.22650198E-05_JPRB, &
  & 0.23820142E-05_JPRB, 0.24990121E-05_JPRB, 0.25984470E-05_JPRB, 0.26742511E-05_JPRB, 0.27197338E-05_JPRB, 0.27489318E-05_JPRB, &
  & 0.27736275E-05_JPRB, 0.27894524E-05_JPRB, 0.27897600E-05_JPRB, 0.27872989E-05_JPRB, 0.27853301E-05_JPRB, 0.27783820E-05_JPRB, &
  & 0.27495173E-05_JPRB, 0.27286781E-05_JPRB, 0.27313520E-05_JPRB, 0.27292568E-05_JPRB  /)

RGHG7(:,33,12) = (/ &
  & 0.22253599E-05_JPRB, 0.22179583E-05_JPRB, 0.21699478E-05_JPRB, 0.21287805E-05_JPRB, 0.20978542E-05_JPRB, 0.20672331E-05_JPRB, &
  & 0.20367609E-05_JPRB, 0.19981738E-05_JPRB, 0.19696114E-05_JPRB, 0.19429006E-05_JPRB, 0.19123939E-05_JPRB, 0.18733758E-05_JPRB, &
  & 0.18218240E-05_JPRB, 0.17611992E-05_JPRB, 0.16933417E-05_JPRB, 0.16126558E-05_JPRB, 0.15207693E-05_JPRB, 0.14243653E-05_JPRB, &
  & 0.13247648E-05_JPRB, 0.12298092E-05_JPRB, 0.11388140E-05_JPRB, 0.10490156E-05_JPRB, 0.96450227E-06_JPRB, 0.88953655E-06_JPRB, &
  & 0.82500350E-06_JPRB, 0.77316065E-06_JPRB, 0.73475594E-06_JPRB, 0.70719645E-06_JPRB, 0.68879032E-06_JPRB, 0.67152274E-06_JPRB, &
  & 0.65544556E-06_JPRB, 0.64613280E-06_JPRB, 0.63200802E-06_JPRB, 0.61413742E-06_JPRB, 0.59949848E-06_JPRB, 0.59436443E-06_JPRB, &
  & 0.60817542E-06_JPRB, 0.64662578E-06_JPRB, 0.70236358E-06_JPRB, 0.77980977E-06_JPRB, 0.87806757E-06_JPRB, 0.10024972E-05_JPRB, &
  & 0.11514438E-05_JPRB, 0.13130943E-05_JPRB, 0.14787737E-05_JPRB, 0.16461098E-05_JPRB, 0.17992570E-05_JPRB, 0.19305112E-05_JPRB, &
  & 0.20515429E-05_JPRB, 0.21738069E-05_JPRB, 0.22832473E-05_JPRB, 0.23676845E-05_JPRB, 0.24228535E-05_JPRB, 0.24647060E-05_JPRB, &
  & 0.25061413E-05_JPRB, 0.25365835E-05_JPRB, 0.25516999E-05_JPRB, 0.25648933E-05_JPRB, 0.25780524E-05_JPRB, 0.25805354E-05_JPRB, &
  & 0.25560590E-05_JPRB, 0.25410284E-05_JPRB, 0.25458885E-05_JPRB, 0.25434263E-05_JPRB  /)

RGHG7(:,34,12) = (/ &
  & 0.18480595E-05_JPRB, 0.18504282E-05_JPRB, 0.18128702E-05_JPRB, 0.17779498E-05_JPRB, 0.17499602E-05_JPRB, 0.17249446E-05_JPRB, &
  & 0.17046331E-05_JPRB, 0.16795987E-05_JPRB, 0.16627781E-05_JPRB, 0.16481109E-05_JPRB, 0.16309031E-05_JPRB, 0.16063262E-05_JPRB, &
  & 0.15678039E-05_JPRB, 0.15176256E-05_JPRB, 0.14571491E-05_JPRB, 0.13814223E-05_JPRB, 0.12925418E-05_JPRB, 0.11990312E-05_JPRB, &
  & 0.11025952E-05_JPRB, 0.10103377E-05_JPRB, 0.92283873E-06_JPRB, 0.83793224E-06_JPRB, 0.76085938E-06_JPRB, 0.69428311E-06_JPRB, &
  & 0.63680931E-06_JPRB, 0.59160561E-06_JPRB, 0.55771785E-06_JPRB, 0.53296970E-06_JPRB, 0.51651749E-06_JPRB, 0.50179204E-06_JPRB, &
  & 0.48800605E-06_JPRB, 0.47953716E-06_JPRB, 0.46675177E-06_JPRB, 0.45224159E-06_JPRB, 0.44251620E-06_JPRB, 0.44113208E-06_JPRB, &
  & 0.45271860E-06_JPRB, 0.48019956E-06_JPRB, 0.52212113E-06_JPRB, 0.58226631E-06_JPRB, 0.66236319E-06_JPRB, 0.76978680E-06_JPRB, &
  & 0.90688179E-06_JPRB, 0.10596558E-05_JPRB, 0.12206425E-05_JPRB, 0.13840505E-05_JPRB, 0.15349154E-05_JPRB, 0.16644170E-05_JPRB, &
  & 0.17856495E-05_JPRB, 0.19095611E-05_JPRB, 0.20234951E-05_JPRB, 0.21139291E-05_JPRB, 0.21766944E-05_JPRB, 0.22250466E-05_JPRB, &
  & 0.22739766E-05_JPRB, 0.23118217E-05_JPRB, 0.23346643E-05_JPRB, 0.23538958E-05_JPRB, 0.23722164E-05_JPRB, 0.23785694E-05_JPRB, &
  & 0.23572450E-05_JPRB, 0.23424670E-05_JPRB, 0.23439333E-05_JPRB, 0.23392929E-05_JPRB  /)

RGHG7(:,35,12) = (/ &
  & 0.14803584E-05_JPRB, 0.14901458E-05_JPRB, 0.14643008E-05_JPRB, 0.14403678E-05_JPRB, 0.14193526E-05_JPRB, 0.14022888E-05_JPRB, &
  & 0.13931425E-05_JPRB, 0.13817905E-05_JPRB, 0.13764014E-05_JPRB, 0.13750317E-05_JPRB, 0.13715656E-05_JPRB, 0.13607303E-05_JPRB, &
  & 0.13357719E-05_JPRB, 0.12956185E-05_JPRB, 0.12419980E-05_JPRB, 0.11712614E-05_JPRB, 0.10862606E-05_JPRB, 0.99702951E-06_JPRB, &
  & 0.90633892E-06_JPRB, 0.81873104E-06_JPRB, 0.73632596E-06_JPRB, 0.65738702E-06_JPRB, 0.58645940E-06_JPRB, 0.52605799E-06_JPRB, &
  & 0.47586963E-06_JPRB, 0.43888425E-06_JPRB, 0.41100847E-06_JPRB, 0.39150228E-06_JPRB, 0.37854472E-06_JPRB, 0.36609967E-06_JPRB, &
  & 0.35453484E-06_JPRB, 0.34754674E-06_JPRB, 0.33707137E-06_JPRB, 0.32700353E-06_JPRB, 0.32231279E-06_JPRB, 0.32380138E-06_JPRB, &
  & 0.33273731E-06_JPRB, 0.35084493E-06_JPRB, 0.38013544E-06_JPRB, 0.42354780E-06_JPRB, 0.48751897E-06_JPRB, 0.57878727E-06_JPRB, &
  & 0.70110406E-06_JPRB, 0.84157283E-06_JPRB, 0.99462251E-06_JPRB, 0.11510264E-05_JPRB, 0.12990779E-05_JPRB, 0.14259437E-05_JPRB, &
  & 0.15454140E-05_JPRB, 0.16691627E-05_JPRB, 0.17848885E-05_JPRB, 0.18801350E-05_JPRB, 0.19496379E-05_JPRB, 0.20015143E-05_JPRB, &
  & 0.20534059E-05_JPRB, 0.20951603E-05_JPRB, 0.21223119E-05_JPRB, 0.21428168E-05_JPRB, 0.21613300E-05_JPRB, 0.21688084E-05_JPRB, &
  & 0.21500902E-05_JPRB, 0.21327208E-05_JPRB, 0.21278345E-05_JPRB, 0.21200252E-05_JPRB  /)

RGHG7(:,36,12) = (/ &
  & 0.11441347E-05_JPRB, 0.11599404E-05_JPRB, 0.11470163E-05_JPRB, 0.11351972E-05_JPRB, 0.11218231E-05_JPRB, 0.11126031E-05_JPRB, &
  & 0.11132171E-05_JPRB, 0.11138226E-05_JPRB, 0.11186413E-05_JPRB, 0.11288711E-05_JPRB, 0.11373156E-05_JPRB, 0.11382047E-05_JPRB, &
  & 0.11251578E-05_JPRB, 0.10939006E-05_JPRB, 0.10464534E-05_JPRB, 0.98085368E-06_JPRB, 0.90095893E-06_JPRB, 0.81704153E-06_JPRB, &
  & 0.73303509E-06_JPRB, 0.65102478E-06_JPRB, 0.57443947E-06_JPRB, 0.50209689E-06_JPRB, 0.43743052E-06_JPRB, 0.38302364E-06_JPRB, &
  & 0.33946991E-06_JPRB, 0.30938773E-06_JPRB, 0.28681540E-06_JPRB, 0.27182076E-06_JPRB, 0.26164804E-06_JPRB, 0.25132919E-06_JPRB, &
  & 0.24200086E-06_JPRB, 0.23636411E-06_JPRB, 0.22830254E-06_JPRB, 0.22229299E-06_JPRB, 0.22165356E-06_JPRB, 0.22527403E-06_JPRB, &
  & 0.23226533E-06_JPRB, 0.24331438E-06_JPRB, 0.26256148E-06_JPRB, 0.29209693E-06_JPRB, 0.34136955E-06_JPRB, 0.41686042E-06_JPRB, &
  & 0.52344201E-06_JPRB, 0.65054840E-06_JPRB, 0.79356021E-06_JPRB, 0.94099033E-06_JPRB, 0.10844554E-05_JPRB, 0.12084350E-05_JPRB, &
  & 0.13257577E-05_JPRB, 0.14484725E-05_JPRB, 0.15650298E-05_JPRB, 0.16630317E-05_JPRB, 0.17369524E-05_JPRB, 0.17914993E-05_JPRB, &
  & 0.18447057E-05_JPRB, 0.18884390E-05_JPRB, 0.19180183E-05_JPRB, 0.19378065E-05_JPRB, 0.19547044E-05_JPRB, 0.19622960E-05_JPRB, &
  & 0.19458802E-05_JPRB, 0.19261258E-05_JPRB, 0.19150512E-05_JPRB, 0.19040493E-05_JPRB  /)

RGHG7(:,37,12) = (/ &
  & 0.90099828E-06_JPRB, 0.91923718E-06_JPRB, 0.92119935E-06_JPRB, 0.92332334E-06_JPRB, 0.91864314E-06_JPRB, 0.91653138E-06_JPRB, &
  & 0.92307810E-06_JPRB, 0.93094214E-06_JPRB, 0.94252732E-06_JPRB, 0.95974238E-06_JPRB, 0.97515838E-06_JPRB, 0.98241764E-06_JPRB, &
  & 0.97675235E-06_JPRB, 0.95125005E-06_JPRB, 0.90802676E-06_JPRB, 0.84758056E-06_JPRB, 0.77528615E-06_JPRB, 0.69872305E-06_JPRB, &
  & 0.62313714E-06_JPRB, 0.54854947E-06_JPRB, 0.47908606E-06_JPRB, 0.41437118E-06_JPRB, 0.35584250E-06_JPRB, 0.30664377E-06_JPRB, &
  & 0.26781975E-06_JPRB, 0.24119599E-06_JPRB, 0.22197274E-06_JPRB, 0.20953433E-06_JPRB, 0.20034584E-06_JPRB, 0.19166734E-06_JPRB, &
  & 0.18447149E-06_JPRB, 0.17980528E-06_JPRB, 0.17424527E-06_JPRB, 0.17116104E-06_JPRB, 0.17206628E-06_JPRB, 0.17598748E-06_JPRB, &
  & 0.18277374E-06_JPRB, 0.19251050E-06_JPRB, 0.20827183E-06_JPRB, 0.23134151E-06_JPRB, 0.27010214E-06_JPRB, 0.33166360E-06_JPRB, &
  & 0.42129477E-06_JPRB, 0.53344652E-06_JPRB, 0.66222818E-06_JPRB, 0.79672677E-06_JPRB, 0.93182595E-06_JPRB, 0.10525248E-05_JPRB, &
  & 0.11669495E-05_JPRB, 0.12866981E-05_JPRB, 0.14018338E-05_JPRB, 0.14977032E-05_JPRB, 0.15704483E-05_JPRB, 0.16255419E-05_JPRB, &
  & 0.16762058E-05_JPRB, 0.17173692E-05_JPRB, 0.17449117E-05_JPRB, 0.17594644E-05_JPRB, 0.17707030E-05_JPRB, 0.17760802E-05_JPRB, &
  & 0.17611270E-05_JPRB, 0.17396093E-05_JPRB, 0.17231078E-05_JPRB, 0.17090576E-05_JPRB  /)

RGHG7(:,38,12) = (/ &
  & 0.63121683E-06_JPRB, 0.65215558E-06_JPRB, 0.67063542E-06_JPRB, 0.68823050E-06_JPRB, 0.69319698E-06_JPRB, 0.69897244E-06_JPRB, &
  & 0.71210196E-06_JPRB, 0.72802007E-06_JPRB, 0.74711327E-06_JPRB, 0.77207904E-06_JPRB, 0.79523059E-06_JPRB, 0.80955801E-06_JPRB, &
  & 0.81208330E-06_JPRB, 0.79296662E-06_JPRB, 0.75443016E-06_JPRB, 0.69970219E-06_JPRB, 0.63584105E-06_JPRB, 0.56743819E-06_JPRB, &
  & 0.50119560E-06_JPRB, 0.43484401E-06_JPRB, 0.37328300E-06_JPRB, 0.31703170E-06_JPRB, 0.26531334E-06_JPRB, 0.22189352E-06_JPRB, &
  & 0.18831754E-06_JPRB, 0.16553122E-06_JPRB, 0.15002406E-06_JPRB, 0.14042202E-06_JPRB, 0.13232560E-06_JPRB, 0.12546723E-06_JPRB, &
  & 0.12063754E-06_JPRB, 0.11704825E-06_JPRB, 0.11426393E-06_JPRB, 0.11442559E-06_JPRB, 0.11704478E-06_JPRB, 0.12129968E-06_JPRB, &
  & 0.12785842E-06_JPRB, 0.13613908E-06_JPRB, 0.14803263E-06_JPRB, 0.16392798E-06_JPRB, 0.19102462E-06_JPRB, 0.23713016E-06_JPRB, &
  & 0.30795334E-06_JPRB, 0.40351159E-06_JPRB, 0.51650363E-06_JPRB, 0.63665355E-06_JPRB, 0.76247008E-06_JPRB, 0.87952869E-06_JPRB, &
  & 0.99073785E-06_JPRB, 0.11071950E-05_JPRB, 0.12207532E-05_JPRB, 0.13142565E-05_JPRB, 0.13856972E-05_JPRB, 0.14413975E-05_JPRB, &
  & 0.14892401E-05_JPRB, 0.15275521E-05_JPRB, 0.15528346E-05_JPRB, 0.15615780E-05_JPRB, 0.15665372E-05_JPRB, 0.15694572E-05_JPRB, &
  & 0.15561270E-05_JPRB, 0.15326526E-05_JPRB, 0.15101295E-05_JPRB, 0.14926969E-05_JPRB  /)

RGHG7(:,39,12) = (/ &
  & 0.50504869E-06_JPRB, 0.52632322E-06_JPRB, 0.54970952E-06_JPRB, 0.57415580E-06_JPRB, 0.58400630E-06_JPRB, 0.59317956E-06_JPRB, &
  & 0.60960730E-06_JPRB, 0.62761811E-06_JPRB, 0.64717716E-06_JPRB, 0.67207663E-06_JPRB, 0.69536731E-06_JPRB, 0.71065224E-06_JPRB, &
  & 0.71497601E-06_JPRB, 0.69872431E-06_JPRB, 0.66417048E-06_JPRB, 0.61542777E-06_JPRB, 0.55842409E-06_JPRB, 0.49722165E-06_JPRB, &
  & 0.43804605E-06_JPRB, 0.37852234E-06_JPRB, 0.32321380E-06_JPRB, 0.27308729E-06_JPRB, 0.22681686E-06_JPRB, 0.18726237E-06_JPRB, &
  & 0.15726858E-06_JPRB, 0.13707365E-06_JPRB, 0.12315574E-06_JPRB, 0.11440256E-06_JPRB, 0.10732887E-06_JPRB, 0.10184960E-06_JPRB, &
  & 0.97985791E-07_JPRB, 0.94937362E-07_JPRB, 0.92978112E-07_JPRB, 0.93656910E-07_JPRB, 0.96594897E-07_JPRB, 0.10119063E-06_JPRB, &
  & 0.10761244E-06_JPRB, 0.11540402E-06_JPRB, 0.12569524E-06_JPRB, 0.13912003E-06_JPRB, 0.16110220E-06_JPRB, 0.19928380E-06_JPRB, &
  & 0.25932920E-06_JPRB, 0.34305510E-06_JPRB, 0.44352767E-06_JPRB, 0.55135077E-06_JPRB, 0.66665489E-06_JPRB, 0.77734973E-06_JPRB, &
  & 0.88420533E-06_JPRB, 0.99619054E-06_JPRB, 0.11035174E-05_JPRB, 0.11924928E-05_JPRB, 0.12603647E-05_JPRB, 0.13131337E-05_JPRB, &
  & 0.13575765E-05_JPRB, 0.13902266E-05_JPRB, 0.14103779E-05_JPRB, 0.14153614E-05_JPRB, 0.14157722E-05_JPRB, 0.14168915E-05_JPRB, &
  & 0.14049217E-05_JPRB, 0.13823098E-05_JPRB, 0.13612755E-05_JPRB, 0.13447054E-05_JPRB  /)

RGHG7(:,40,12) = (/ &
  & 0.38047519E-06_JPRB, 0.40175702E-06_JPRB, 0.42900184E-06_JPRB, 0.46007837E-06_JPRB, 0.47488150E-06_JPRB, 0.48730788E-06_JPRB, &
  & 0.50706897E-06_JPRB, 0.52656047E-06_JPRB, 0.54551412E-06_JPRB, 0.56905691E-06_JPRB, 0.59126806E-06_JPRB, 0.60667699E-06_JPRB, &
  & 0.61206569E-06_JPRB, 0.59860030E-06_JPRB, 0.56860522E-06_JPRB, 0.52693040E-06_JPRB, 0.47771670E-06_JPRB, 0.42480755E-06_JPRB, &
  & 0.37355323E-06_JPRB, 0.32181221E-06_JPRB, 0.27357156E-06_JPRB, 0.23025035E-06_JPRB, 0.19015065E-06_JPRB, 0.15481938E-06_JPRB, &
  & 0.12875706E-06_JPRB, 0.11139950E-06_JPRB, 0.98998737E-07_JPRB, 0.90916602E-07_JPRB, 0.85031839E-07_JPRB, 0.81098898E-07_JPRB, &
  & 0.78139544E-07_JPRB, 0.75638164E-07_JPRB, 0.74328080E-07_JPRB, 0.75167346E-07_JPRB, 0.78251214E-07_JPRB, 0.83248120E-07_JPRB, &
  & 0.89524045E-07_JPRB, 0.96899873E-07_JPRB, 0.10568123E-06_JPRB, 0.11697617E-06_JPRB, 0.13402760E-06_JPRB, 0.16414204E-06_JPRB, &
  & 0.21285256E-06_JPRB, 0.28347114E-06_JPRB, 0.36978606E-06_JPRB, 0.46347339E-06_JPRB, 0.56623912E-06_JPRB, 0.66901996E-06_JPRB, &
  & 0.77058013E-06_JPRB, 0.87712401E-06_JPRB, 0.97637640E-06_JPRB, 0.10596844E-05_JPRB, 0.11229975E-05_JPRB, 0.11717475E-05_JPRB, &
  & 0.12121057E-05_JPRB, 0.12376515E-05_JPRB, 0.12513111E-05_JPRB, 0.12522172E-05_JPRB, 0.12475733E-05_JPRB, 0.12466867E-05_JPRB, &
  & 0.12362706E-05_JPRB, 0.12151320E-05_JPRB, 0.11970737E-05_JPRB, 0.11822104E-05_JPRB  /)

RGHG7(:,41,12) = (/ &
  & 0.22816604E-06_JPRB, 0.24945679E-06_JPRB, 0.28141922E-06_JPRB, 0.32060218E-06_JPRB, 0.34146061E-06_JPRB, 0.35786441E-06_JPRB, &
  & 0.38170101E-06_JPRB, 0.40300286E-06_JPRB, 0.42121632E-06_JPRB, 0.44310036E-06_JPRB, 0.46399166E-06_JPRB, 0.47955220E-06_JPRB, &
  & 0.48624292E-06_JPRB, 0.47618419E-06_JPRB, 0.45176285E-06_JPRB, 0.41872954E-06_JPRB, 0.37904024E-06_JPRB, 0.33627081E-06_JPRB, &
  & 0.29470141E-06_JPRB, 0.25247587E-06_JPRB, 0.21287674E-06_JPRB, 0.17787599E-06_JPRB, 0.14532089E-06_JPRB, 0.11515313E-06_JPRB, &
  & 0.93897595E-07_JPRB, 0.80009128E-07_JPRB, 0.69463303E-07_JPRB, 0.62201622E-07_JPRB, 0.57770487E-07_JPRB, 0.55728157E-07_JPRB, &
  & 0.53874631E-07_JPRB, 0.52042100E-07_JPRB, 0.51525715E-07_JPRB, 0.52561176E-07_JPRB, 0.55823403E-07_JPRB, 0.61310798E-07_JPRB, &
  & 0.67408363E-07_JPRB, 0.74275867E-07_JPRB, 0.81211202E-07_JPRB, 0.89902099E-07_JPRB, 0.10092498E-06_JPRB, 0.12117614E-06_JPRB, &
  & 0.15602813E-06_JPRB, 0.21062112E-06_JPRB, 0.27962625E-06_JPRB, 0.35603055E-06_JPRB, 0.44346629E-06_JPRB, 0.53657114E-06_JPRB, &
  & 0.63165685E-06_JPRB, 0.73154793E-06_JPRB, 0.82092812E-06_JPRB, 0.89730684E-06_JPRB, 0.95504625E-06_JPRB, 0.99888247E-06_JPRB, &
  & 0.10342466E-05_JPRB, 0.10511062E-05_JPRB, 0.10568289E-05_JPRB, 0.10527498E-05_JPRB, 0.10419257E-05_JPRB, 0.10385867E-05_JPRB, &
  & 0.10300701E-05_JPRB, 0.10107330E-05_JPRB, 0.99631322E-06_JPRB, 0.98353676E-06_JPRB  /)

RGHG7(:,42,12) = (/ &
  & 0.26017201E-06_JPRB, 0.27606892E-06_JPRB, 0.30055257E-06_JPRB, 0.32984919E-06_JPRB, 0.34700436E-06_JPRB, 0.36126303E-06_JPRB, &
  & 0.38068106E-06_JPRB, 0.39761988E-06_JPRB, 0.41246067E-06_JPRB, 0.43068198E-06_JPRB, 0.44768328E-06_JPRB, 0.45972066E-06_JPRB, &
  & 0.46389816E-06_JPRB, 0.45475943E-06_JPRB, 0.43336028E-06_JPRB, 0.40366725E-06_JPRB, 0.36751905E-06_JPRB, 0.32825130E-06_JPRB, &
  & 0.28912532E-06_JPRB, 0.24891207E-06_JPRB, 0.21134197E-06_JPRB, 0.17762494E-06_JPRB, 0.14561057E-06_JPRB, 0.11680723E-06_JPRB, &
  & 0.96158692E-07_JPRB, 0.82186999E-07_JPRB, 0.71865792E-07_JPRB, 0.65065762E-07_JPRB, 0.60739916E-07_JPRB, 0.58095496E-07_JPRB, &
  & 0.56173776E-07_JPRB, 0.54710464E-07_JPRB, 0.54128416E-07_JPRB, 0.54811059E-07_JPRB, 0.57526402E-07_JPRB, 0.62348685E-07_JPRB, &
  & 0.68270016E-07_JPRB, 0.75087926E-07_JPRB, 0.82141532E-07_JPRB, 0.90922415E-07_JPRB, 0.10239637E-06_JPRB, 0.12272752E-06_JPRB, &
  & 0.15699770E-06_JPRB, 0.20895490E-06_JPRB, 0.27463771E-06_JPRB, 0.34722499E-06_JPRB, 0.42767646E-06_JPRB, 0.51371539E-06_JPRB, &
  & 0.60328217E-06_JPRB, 0.69440241E-06_JPRB, 0.77414811E-06_JPRB, 0.84239734E-06_JPRB, 0.89427030E-06_JPRB, 0.93170719E-06_JPRB, &
  & 0.96170287E-06_JPRB, 0.97532041E-06_JPRB, 0.97819015E-06_JPRB, 0.97398351E-06_JPRB, 0.96630448E-06_JPRB, 0.96472911E-06_JPRB, &
  & 0.95647392E-06_JPRB, 0.94008628E-06_JPRB, 0.93114371E-06_JPRB, 0.92025660E-06_JPRB  /)

RGHG7(:,43,12) = (/ &
  & 0.22385813E-06_JPRB, 0.23483759E-06_JPRB, 0.25452695E-06_JPRB, 0.27829033E-06_JPRB, 0.29467138E-06_JPRB, 0.30868374E-06_JPRB, &
  & 0.32582337E-06_JPRB, 0.33956014E-06_JPRB, 0.35100533E-06_JPRB, 0.36517128E-06_JPRB, 0.37805566E-06_JPRB, 0.38694376E-06_JPRB, &
  & 0.38938827E-06_JPRB, 0.38255432E-06_JPRB, 0.36631014E-06_JPRB, 0.34338190E-06_JPRB, 0.31456149E-06_JPRB, 0.28285025E-06_JPRB, &
  & 0.25011959E-06_JPRB, 0.21583544E-06_JPRB, 0.18383375E-06_JPRB, 0.15486703E-06_JPRB, 0.12659132E-06_JPRB, 0.10125395E-06_JPRB, &
  & 0.83226883E-07_JPRB, 0.70671486E-07_JPRB, 0.61353122E-07_JPRB, 0.55327216E-07_JPRB, 0.51722713E-07_JPRB, 0.49342200E-07_JPRB, &
  & 0.47833933E-07_JPRB, 0.46995198E-07_JPRB, 0.46694650E-07_JPRB, 0.47139777E-07_JPRB, 0.49432871E-07_JPRB, 0.53859294E-07_JPRB, &
  & 0.59543111E-07_JPRB, 0.66097114E-07_JPRB, 0.72464564E-07_JPRB, 0.80207417E-07_JPRB, 0.89499753E-07_JPRB, 0.10566118E-06_JPRB, &
  & 0.13343927E-06_JPRB, 0.17609818E-06_JPRB, 0.23130392E-06_JPRB, 0.29297429E-06_JPRB, 0.36045918E-06_JPRB, 0.43588908E-06_JPRB, &
  & 0.51763545E-06_JPRB, 0.59789156E-06_JPRB, 0.66460030E-06_JPRB, 0.72245163E-06_JPRB, 0.76657455E-06_JPRB, 0.79605907E-06_JPRB, &
  & 0.81900846E-06_JPRB, 0.82593158E-06_JPRB, 0.82278427E-06_JPRB, 0.81631682E-06_JPRB, 0.80884892E-06_JPRB, 0.80782776E-06_JPRB, &
  & 0.80062819E-06_JPRB, 0.78770651E-06_JPRB, 0.78532641E-06_JPRB, 0.77706077E-06_JPRB  /)

RGHG7(:,44,12) = (/ &
  & 0.22754541E-06_JPRB, 0.23625920E-06_JPRB, 0.25289629E-06_JPRB, 0.27173436E-06_JPRB, 0.28591284E-06_JPRB, 0.29820208E-06_JPRB, &
  & 0.31223003E-06_JPRB, 0.32317736E-06_JPRB, 0.33203646E-06_JPRB, 0.34368194E-06_JPRB, 0.35397690E-06_JPRB, 0.36032736E-06_JPRB, &
  & 0.36132738E-06_JPRB, 0.35488937E-06_JPRB, 0.34074052E-06_JPRB, 0.32041099E-06_JPRB, 0.29463452E-06_JPRB, 0.26525227E-06_JPRB, &
  & 0.23499461E-06_JPRB, 0.20337916E-06_JPRB, 0.17370731E-06_JPRB, 0.14578965E-06_JPRB, 0.11875103E-06_JPRB, 0.95203861E-07_JPRB, &
  & 0.78515115E-07_JPRB, 0.66666420E-07_JPRB, 0.58047592E-07_JPRB, 0.52678402E-07_JPRB, 0.49357587E-07_JPRB, 0.47008411E-07_JPRB, &
  & 0.45590665E-07_JPRB, 0.44856913E-07_JPRB, 0.44578173E-07_JPRB, 0.44958723E-07_JPRB, 0.47094073E-07_JPRB, 0.51291624E-07_JPRB, &
  & 0.56736576E-07_JPRB, 0.63016755E-07_JPRB, 0.69179968E-07_JPRB, 0.76439365E-07_JPRB, 0.85200854E-07_JPRB, 0.10008209E-06_JPRB, &
  & 0.12576924E-06_JPRB, 0.16492844E-06_JPRB, 0.21569682E-06_JPRB, 0.27200870E-06_JPRB, 0.33338500E-06_JPRB, 0.40240683E-06_JPRB, &
  & 0.47726140E-06_JPRB, 0.54868257E-06_JPRB, 0.60769164E-06_JPRB, 0.65746710E-06_JPRB, 0.69587254E-06_JPRB, 0.72115484E-06_JPRB, &
  & 0.73918768E-06_JPRB, 0.74351186E-06_JPRB, 0.73945605E-06_JPRB, 0.73254990E-06_JPRB, 0.72641498E-06_JPRB, 0.72687817E-06_JPRB, &
  & 0.72146347E-06_JPRB, 0.71276444E-06_JPRB, 0.71120200E-06_JPRB, 0.70597209E-06_JPRB  /)

RGHG7(:,45,12) = (/ &
  & 0.22715585E-06_JPRB, 0.23266915E-06_JPRB, 0.24522583E-06_JPRB, 0.25775781E-06_JPRB, 0.26933104E-06_JPRB, 0.27962752E-06_JPRB, &
  & 0.28982524E-06_JPRB, 0.29719250E-06_JPRB, 0.30267858E-06_JPRB, 0.31094241E-06_JPRB, 0.31776946E-06_JPRB, 0.32083315E-06_JPRB, &
  & 0.31996982E-06_JPRB, 0.31427370E-06_JPRB, 0.30316144E-06_JPRB, 0.28664489E-06_JPRB, 0.26525939E-06_JPRB, 0.23948308E-06_JPRB, &
  & 0.21284861E-06_JPRB, 0.18502026E-06_JPRB, 0.15870418E-06_JPRB, 0.13258087E-06_JPRB, 0.10742286E-06_JPRB, 0.86351546E-07_JPRB, &
  & 0.71517531E-07_JPRB, 0.60652275E-07_JPRB, 0.52956499E-07_JPRB, 0.48432722E-07_JPRB, 0.45525986E-07_JPRB, 0.43245824E-07_JPRB, &
  & 0.41983358E-07_JPRB, 0.41448018E-07_JPRB, 0.41229665E-07_JPRB, 0.41506695E-07_JPRB, 0.43409125E-07_JPRB, 0.47296117E-07_JPRB, &
  & 0.52439136E-07_JPRB, 0.58374248E-07_JPRB, 0.64218276E-07_JPRB, 0.70796166E-07_JPRB, 0.78677736E-07_JPRB, 0.91574843E-07_JPRB, &
  & 0.11406150E-06_JPRB, 0.14806196E-06_JPRB, 0.19245524E-06_JPRB, 0.24128780E-06_JPRB, 0.29407196E-06_JPRB, 0.35445850E-06_JPRB, &
  & 0.42047937E-06_JPRB, 0.48047022E-06_JPRB, 0.52906691E-06_JPRB, 0.56833511E-06_JPRB, 0.59925261E-06_JPRB, 0.61874643E-06_JPRB, &
  & 0.63029201E-06_JPRB, 0.63081184E-06_JPRB, 0.62496169E-06_JPRB, 0.61727051E-06_JPRB, 0.61267976E-06_JPRB, 0.61490279E-06_JPRB, &
  & 0.61165338E-06_JPRB, 0.60819936E-06_JPRB, 0.60839676E-06_JPRB, 0.60695395E-06_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART24',0,ZHOOK_HANDLE)



RGHG7(:,46,12) = (/ &
  & 0.23016522E-06_JPRB, 0.23400616E-06_JPRB, 0.24340853E-06_JPRB, 0.25271979E-06_JPRB, 0.26181973E-06_JPRB, 0.27002499E-06_JPRB, &
  & 0.27742912E-06_JPRB, 0.28230056E-06_JPRB, 0.28570191E-06_JPRB, 0.29181365E-06_JPRB, 0.29643825E-06_JPRB, 0.29731332E-06_JPRB, &
  & 0.29495686E-06_JPRB, 0.28898487E-06_JPRB, 0.27843503E-06_JPRB, 0.26279243E-06_JPRB, 0.24299476E-06_JPRB, 0.21916401E-06_JPRB, &
  & 0.19498128E-06_JPRB, 0.17030225E-06_JPRB, 0.14674834E-06_JPRB, 0.12268102E-06_JPRB, 0.99588437E-07_JPRB, 0.80370287E-07_JPRB, &
  & 0.66914815E-07_JPRB, 0.56907553E-07_JPRB, 0.49998007E-07_JPRB, 0.46057111E-07_JPRB, 0.43490926E-07_JPRB, 0.41375077E-07_JPRB, &
  & 0.40179325E-07_JPRB, 0.39694955E-07_JPRB, 0.39472815E-07_JPRB, 0.39737898E-07_JPRB, 0.41555996E-07_JPRB, 0.45230859E-07_JPRB, &
  & 0.50078013E-07_JPRB, 0.55616531E-07_JPRB, 0.61067738E-07_JPRB, 0.67077204E-07_JPRB, 0.74279570E-07_JPRB, 0.85864260E-07_JPRB, &
  & 0.10622209E-06_JPRB, 0.13699286E-06_JPRB, 0.17668210E-06_JPRB, 0.21990040E-06_JPRB, 0.26677580E-06_JPRB, 0.32087268E-06_JPRB, &
  & 0.37911117E-06_JPRB, 0.43106690E-06_JPRB, 0.47220819E-06_JPRB, 0.50469656E-06_JPRB, 0.53012130E-06_JPRB, 0.54564510E-06_JPRB, &
  & 0.55399077E-06_JPRB, 0.55267148E-06_JPRB, 0.54665411E-06_JPRB, 0.53874143E-06_JPRB, 0.53545246E-06_JPRB, 0.53838542E-06_JPRB, &
  & 0.53736886E-06_JPRB, 0.53669122E-06_JPRB, 0.53829740E-06_JPRB, 0.53937430E-06_JPRB  /)

RGHG7(:,47,12) = (/ &
  & 0.23437737E-06_JPRB, 0.23656202E-06_JPRB, 0.24244858E-06_JPRB, 0.24859863E-06_JPRB, 0.25482277E-06_JPRB, 0.26055442E-06_JPRB, &
  & 0.26488816E-06_JPRB, 0.26704814E-06_JPRB, 0.26826129E-06_JPRB, 0.27209402E-06_JPRB, 0.27438771E-06_JPRB, 0.27291458E-06_JPRB, &
  & 0.26888021E-06_JPRB, 0.26238064E-06_JPRB, 0.25199513E-06_JPRB, 0.23678930E-06_JPRB, 0.21829331E-06_JPRB, 0.19641291E-06_JPRB, &
  & 0.17487245E-06_JPRB, 0.15376112E-06_JPRB, 0.13332950E-06_JPRB, 0.11172715E-06_JPRB, 0.91095205E-07_JPRB, 0.73926868E-07_JPRB, &
  & 0.61993620E-07_JPRB, 0.52968018E-07_JPRB, 0.46953644E-07_JPRB, 0.43644125E-07_JPRB, 0.41462820E-07_JPRB, 0.39558872E-07_JPRB, &
  & 0.38423663E-07_JPRB, 0.37969564E-07_JPRB, 0.37730126E-07_JPRB, 0.37999533E-07_JPRB, 0.39748440E-07_JPRB, 0.43194105E-07_JPRB, &
  & 0.47695299E-07_JPRB, 0.52758122E-07_JPRB, 0.57733634E-07_JPRB, 0.63098749E-07_JPRB, 0.69544328E-07_JPRB, 0.79723555E-07_JPRB, &
  & 0.97798051E-07_JPRB, 0.12516544E-06_JPRB, 0.15966961E-06_JPRB, 0.19667360E-06_JPRB, 0.23715306E-06_JPRB, 0.28433940E-06_JPRB, &
  & 0.33365644E-06_JPRB, 0.37686371E-06_JPRB, 0.40984900E-06_JPRB, 0.43512842E-06_JPRB, 0.45450752E-06_JPRB, 0.46573709E-06_JPRB, &
  & 0.47098642E-06_JPRB, 0.46790273E-06_JPRB, 0.46201510E-06_JPRB, 0.45395539E-06_JPRB, 0.45214539E-06_JPRB, 0.45570108E-06_JPRB, &
  & 0.45731814E-06_JPRB, 0.45940386E-06_JPRB, 0.46259280E-06_JPRB, 0.46637252E-06_JPRB  /)

RGHG7(:,48,12) = (/ &
  & 0.23438770E-06_JPRB, 0.23503614E-06_JPRB, 0.23807809E-06_JPRB, 0.24182771E-06_JPRB, 0.24633970E-06_JPRB, 0.25005573E-06_JPRB, &
  & 0.25199842E-06_JPRB, 0.25205367E-06_JPRB, 0.25192527E-06_JPRB, 0.25456051E-06_JPRB, 0.25543703E-06_JPRB, 0.25222345E-06_JPRB, &
  & 0.24651588E-06_JPRB, 0.23879440E-06_JPRB, 0.22759864E-06_JPRB, 0.21226138E-06_JPRB, 0.19432893E-06_JPRB, 0.17424650E-06_JPRB, &
  & 0.15552085E-06_JPRB, 0.13796821E-06_JPRB, 0.12074968E-06_JPRB, 0.10219183E-06_JPRB, 0.84273534E-07_JPRB, 0.69159419E-07_JPRB, &
  & 0.58382401E-07_JPRB, 0.50119865E-07_JPRB, 0.44741094E-07_JPRB, 0.41910842E-07_JPRB, 0.40031929E-07_JPRB, 0.38303310E-07_JPRB, &
  & 0.37208454E-07_JPRB, 0.36760324E-07_JPRB, 0.36527217E-07_JPRB, 0.36829137E-07_JPRB, 0.38520967E-07_JPRB, 0.41811841E-07_JPRB, &
  & 0.45959461E-07_JPRB, 0.50602537E-07_JPRB, 0.55186715E-07_JPRB, 0.59878418E-07_JPRB, 0.65492840E-07_JPRB, 0.74507201E-07_JPRB, &
  & 0.90732275E-07_JPRB, 0.11506047E-06_JPRB, 0.14480216E-06_JPRB, 0.17629516E-06_JPRB, 0.21134715E-06_JPRB, 0.25225727E-06_JPRB, &
  & 0.29443152E-06_JPRB, 0.33089582E-06_JPRB, 0.35791294E-06_JPRB, 0.37820451E-06_JPRB, 0.39304798E-06_JPRB, 0.40129731E-06_JPRB, &
  & 0.40482712E-06_JPRB, 0.40101678E-06_JPRB, 0.39507031E-06_JPRB, 0.38756164E-06_JPRB, 0.38683278E-06_JPRB, 0.39047311E-06_JPRB, &
  & 0.39360114E-06_JPRB, 0.39679234E-06_JPRB, 0.40103864E-06_JPRB, 0.40530953E-06_JPRB  /)

RGHG7(:,49,12) = (/ &
  & 0.23248880E-06_JPRB, 0.23149063E-06_JPRB, 0.23168763E-06_JPRB, 0.23312490E-06_JPRB, 0.23626989E-06_JPRB, 0.23796206E-06_JPRB, &
  & 0.23756576E-06_JPRB, 0.23556608E-06_JPRB, 0.23433699E-06_JPRB, 0.23613783E-06_JPRB, 0.23586038E-06_JPRB, 0.23099577E-06_JPRB, &
  & 0.22343742E-06_JPRB, 0.21404714E-06_JPRB, 0.20151101E-06_JPRB, 0.18576987E-06_JPRB, 0.16812591E-06_JPRB, 0.14996526E-06_JPRB, &
  & 0.13443519E-06_JPRB, 0.12081931E-06_JPRB, 0.10720025E-06_JPRB, 0.92277360E-07_JPRB, 0.77479191E-07_JPRB, 0.64641922E-07_JPRB, &
  & 0.54978917E-07_JPRB, 0.47462015E-07_JPRB, 0.42669100E-07_JPRB, 0.40300430E-07_JPRB, 0.38718883E-07_JPRB, 0.37167796E-07_JPRB, &
  & 0.36108446E-07_JPRB, 0.35655878E-07_JPRB, 0.35440524E-07_JPRB, 0.35791266E-07_JPRB, 0.37425398E-07_JPRB, 0.40578684E-07_JPRB, &
  & 0.44331296E-07_JPRB, 0.48534981E-07_JPRB, 0.52724150E-07_JPRB, 0.56656904E-07_JPRB, 0.61317092E-07_JPRB, 0.69150865E-07_JPRB, &
  & 0.83525170E-07_JPRB, 0.10465336E-06_JPRB, 0.12931319E-06_JPRB, 0.15502309E-06_JPRB, 0.18450502E-06_JPRB, 0.21875326E-06_JPRB, &
  & 0.25382622E-06_JPRB, 0.28373516E-06_JPRB, 0.30513784E-06_JPRB, 0.32091565E-06_JPRB, 0.33142291E-06_JPRB, 0.33696931E-06_JPRB, &
  & 0.33922089E-06_JPRB, 0.33507768E-06_JPRB, 0.32898031E-06_JPRB, 0.32239924E-06_JPRB, 0.32268676E-06_JPRB, 0.32617618E-06_JPRB, &
  & 0.33046705E-06_JPRB, 0.33412870E-06_JPRB, 0.33930705E-06_JPRB, 0.34311635E-06_JPRB  /)

RGHG7(:,50,12) = (/ &
  & 0.22520661E-06_JPRB, 0.22250314E-06_JPRB, 0.22021353E-06_JPRB, 0.22023400E-06_JPRB, 0.22214445E-06_JPRB, 0.22199929E-06_JPRB, &
  & 0.21941309E-06_JPRB, 0.21581110E-06_JPRB, 0.21391339E-06_JPRB, 0.21559566E-06_JPRB, 0.21483987E-06_JPRB, 0.20899828E-06_JPRB, &
  & 0.20057072E-06_JPRB, 0.19006787E-06_JPRB, 0.17698377E-06_JPRB, 0.16146389E-06_JPRB, 0.14479839E-06_JPRB, 0.12907916E-06_JPRB, &
  & 0.11663354E-06_JPRB, 0.10626663E-06_JPRB, 0.95846785E-07_JPRB, 0.84260212E-07_JPRB, 0.72107884E-07_JPRB, 0.61304622E-07_JPRB, &
  & 0.52581410E-07_JPRB, 0.45595372E-07_JPRB, 0.41197415E-07_JPRB, 0.39105179E-07_JPRB, 0.37701650E-07_JPRB, 0.36285064E-07_JPRB, &
  & 0.35271940E-07_JPRB, 0.34789075E-07_JPRB, 0.34595392E-07_JPRB, 0.34977965E-07_JPRB, 0.36578805E-07_JPRB, 0.39658249E-07_JPRB, &
  & 0.43115817E-07_JPRB, 0.47033017E-07_JPRB, 0.50855029E-07_JPRB, 0.54060744E-07_JPRB, 0.57987717E-07_JPRB, 0.64930596E-07_JPRB, &
  & 0.77597733E-07_JPRB, 0.95715019E-07_JPRB, 0.11593796E-06_JPRB, 0.13673500E-06_JPRB, 0.16119491E-06_JPRB, 0.18938474E-06_JPRB, &
  & 0.21832772E-06_JPRB, 0.24288230E-06_JPRB, 0.26028975E-06_JPRB, 0.27246692E-06_JPRB, 0.27971428E-06_JPRB, 0.28341906E-06_JPRB, &
  & 0.28493097E-06_JPRB, 0.28052747E-06_JPRB, 0.27445718E-06_JPRB, 0.26875783E-06_JPRB, 0.26956668E-06_JPRB, 0.27290002E-06_JPRB, &
  & 0.27735485E-06_JPRB, 0.28037567E-06_JPRB, 0.28548096E-06_JPRB, 0.28858693E-06_JPRB  /)

RGHG7(:,51,12) = (/ &
  & 0.21450015E-06_JPRB, 0.20992130E-06_JPRB, 0.20513042E-06_JPRB, 0.20408918E-06_JPRB, 0.20473393E-06_JPRB, 0.20269948E-06_JPRB, &
  & 0.19782297E-06_JPRB, 0.19272578E-06_JPRB, 0.19033198E-06_JPRB, 0.19226230E-06_JPRB, 0.19134423E-06_JPRB, 0.18480025E-06_JPRB, &
  & 0.17594847E-06_JPRB, 0.16453459E-06_JPRB, 0.15127431E-06_JPRB, 0.13632238E-06_JPRB, 0.12107789E-06_JPRB, 0.10827256E-06_JPRB, &
  & 0.99104789E-07_JPRB, 0.91890547E-07_JPRB, 0.84720737E-07_JPRB, 0.76585871E-07_JPRB, 0.67046086E-07_JPRB, 0.58315239E-07_JPRB, &
  & 0.50516964E-07_JPRB, 0.43992235E-07_JPRB, 0.39921136E-07_JPRB, 0.38030578E-07_JPRB, 0.36756865E-07_JPRB, 0.35463140E-07_JPRB, &
  & 0.34505651E-07_JPRB, 0.33976424E-07_JPRB, 0.33808240E-07_JPRB, 0.34216313E-07_JPRB, 0.35793972E-07_JPRB, 0.38827053E-07_JPRB, &
  & 0.42018034E-07_JPRB, 0.45705739E-07_JPRB, 0.49145258E-07_JPRB, 0.51581351E-07_JPRB, 0.54831428E-07_JPRB, 0.60962959E-07_JPRB, &
  & 0.71859038E-07_JPRB, 0.86819020E-07_JPRB, 0.10258186E-06_JPRB, 0.11852240E-06_JPRB, 0.13783836E-06_JPRB, 0.15979241E-06_JPRB, &
  & 0.18261550E-06_JPRB, 0.20200991E-06_JPRB, 0.21594710E-06_JPRB, 0.22470965E-06_JPRB, 0.22899675E-06_JPRB, 0.23116228E-06_JPRB, &
  & 0.23215726E-06_JPRB, 0.22751034E-06_JPRB, 0.22156292E-06_JPRB, 0.21679314E-06_JPRB, 0.21790566E-06_JPRB, 0.22106747E-06_JPRB, &
  & 0.22517457E-06_JPRB, 0.22691810E-06_JPRB, 0.23141604E-06_JPRB, 0.23363416E-06_JPRB  /)

RGHG7(:,52,12) = (/ &
  & 0.19949968E-06_JPRB, 0.19284114E-06_JPRB, 0.18622211E-06_JPRB, 0.18450535E-06_JPRB, 0.18415574E-06_JPRB, 0.18037324E-06_JPRB, &
  & 0.17362240E-06_JPRB, 0.16751742E-06_JPRB, 0.16507545E-06_JPRB, 0.16733277E-06_JPRB, 0.16683045E-06_JPRB, 0.16090148E-06_JPRB, &
  & 0.15294315E-06_JPRB, 0.14206989E-06_JPRB, 0.12975619E-06_JPRB, 0.11634678E-06_JPRB, 0.10319285E-06_JPRB, 0.92901006E-07_JPRB, &
  & 0.86125951E-07_JPRB, 0.81187098E-07_JPRB, 0.76286556E-07_JPRB, 0.70671130E-07_JPRB, 0.63352037E-07_JPRB, 0.56197950E-07_JPRB, &
  & 0.49207141E-07_JPRB, 0.42963846E-07_JPRB, 0.39094264E-07_JPRB, 0.37299513E-07_JPRB, 0.36049731E-07_JPRB, 0.34766502E-07_JPRB, &
  & 0.33853415E-07_JPRB, 0.33295485E-07_JPRB, 0.33109061E-07_JPRB, 0.33543709E-07_JPRB, 0.35160131E-07_JPRB, 0.38139613E-07_JPRB, &
  & 0.41275938E-07_JPRB, 0.44900411E-07_JPRB, 0.47931348E-07_JPRB, 0.49793061E-07_JPRB, 0.52644009E-07_JPRB, 0.58128854E-07_JPRB, &
  & 0.67505268E-07_JPRB, 0.79783654E-07_JPRB, 0.92074977E-07_JPRB, 0.10437744E-06_JPRB, 0.11960682E-06_JPRB, 0.13666806E-06_JPRB, &
  & 0.15451574E-06_JPRB, 0.16971310E-06_JPRB, 0.18046872E-06_JPRB, 0.18655056E-06_JPRB, 0.18892953E-06_JPRB, 0.18990978E-06_JPRB, &
  & 0.19057394E-06_JPRB, 0.18588340E-06_JPRB, 0.18016889E-06_JPRB, 0.17600031E-06_JPRB, 0.17716057E-06_JPRB, 0.18013319E-06_JPRB, &
  & 0.18351049E-06_JPRB, 0.18412551E-06_JPRB, 0.18789889E-06_JPRB, 0.18999311E-06_JPRB  /)

RGHG7(:,53,12) = (/ &
  & 0.18151238E-06_JPRB, 0.17251047E-06_JPRB, 0.16415959E-06_JPRB, 0.16185576E-06_JPRB, 0.16052771E-06_JPRB, 0.15489596E-06_JPRB, &
  & 0.14626406E-06_JPRB, 0.13924912E-06_JPRB, 0.13692701E-06_JPRB, 0.13957082E-06_JPRB, 0.13974363E-06_JPRB, 0.13499123E-06_JPRB, &
  & 0.12851280E-06_JPRB, 0.11878677E-06_JPRB, 0.10793584E-06_JPRB, 0.96581165E-07_JPRB, 0.85961401E-07_JPRB, 0.78252649E-07_JPRB, &
  & 0.73742691E-07_JPRB, 0.70944183E-07_JPRB, 0.68137511E-07_JPRB, 0.64907041E-07_JPRB, 0.59855492E-07_JPRB, 0.54227778E-07_JPRB, &
  & 0.48071092E-07_JPRB, 0.42065069E-07_JPRB, 0.38366715E-07_JPRB, 0.36635563E-07_JPRB, 0.35371104E-07_JPRB, 0.34056075E-07_JPRB, &
  & 0.33187018E-07_JPRB, 0.32604628E-07_JPRB, 0.32381512E-07_JPRB, 0.32845513E-07_JPRB, 0.34527980E-07_JPRB, 0.37446310E-07_JPRB, &
  & 0.40604649E-07_JPRB, 0.44224230E-07_JPRB, 0.46800190E-07_JPRB, 0.48111529E-07_JPRB, 0.50634698E-07_JPRB, 0.55478663E-07_JPRB, &
  & 0.63296905E-07_JPRB, 0.72838094E-07_JPRB, 0.81729326E-07_JPRB, 0.90538747E-07_JPRB, 0.10172471E-06_JPRB, 0.11397445E-06_JPRB, &
  & 0.12684429E-06_JPRB, 0.13784169E-06_JPRB, 0.14524369E-06_JPRB, 0.14868862E-06_JPRB, 0.14939445E-06_JPRB, 0.14922014E-06_JPRB, &
  & 0.14959566E-06_JPRB, 0.14493448E-06_JPRB, 0.13951594E-06_JPRB, 0.13587572E-06_JPRB, 0.13698951E-06_JPRB, 0.13974931E-06_JPRB, &
  & 0.14218486E-06_JPRB, 0.14162820E-06_JPRB, 0.14456745E-06_JPRB, 0.14682067E-06_JPRB  /)

RGHG7(:,54,12) = (/ &
  & 0.16198355E-06_JPRB, 0.15179468E-06_JPRB, 0.14244533E-06_JPRB, 0.13930432E-06_JPRB, 0.13740644E-06_JPRB, 0.13116793E-06_JPRB, &
  & 0.12194685E-06_JPRB, 0.11469397E-06_JPRB, 0.11251756E-06_JPRB, 0.11548092E-06_JPRB, 0.11654110E-06_JPRB, 0.11326437E-06_JPRB, &
  & 0.10857652E-06_JPRB, 0.10096492E-06_JPRB, 0.92414798E-07_JPRB, 0.83449936E-07_JPRB, 0.75114857E-07_JPRB, 0.69225826E-07_JPRB, &
  & 0.66040059E-07_JPRB, 0.64431036E-07_JPRB, 0.62740853E-07_JPRB, 0.60836825E-07_JPRB, 0.57487735E-07_JPRB, 0.52913132E-07_JPRB, &
  & 0.47527702E-07_JPRB, 0.41723828E-07_JPRB, 0.37997575E-07_JPRB, 0.36213487E-07_JPRB, 0.34916057E-07_JPRB, 0.33463623E-07_JPRB, &
  & 0.32580391E-07_JPRB, 0.32044618E-07_JPRB, 0.31801902E-07_JPRB, 0.32296243E-07_JPRB, 0.34090432E-07_JPRB, 0.37051485E-07_JPRB, &
  & 0.40511636E-07_JPRB, 0.43954782E-07_JPRB, 0.46051038E-07_JPRB, 0.47134325E-07_JPRB, 0.49517991E-07_JPRB, 0.53704404E-07_JPRB, &
  & 0.60354119E-07_JPRB, 0.67940904E-07_JPRB, 0.74684857E-07_JPRB, 0.81247081E-07_JPRB, 0.89610150E-07_JPRB, 0.98629820E-07_JPRB, &
  & 0.10810953E-06_JPRB, 0.11591873E-06_JPRB, 0.12084959E-06_JPRB, 0.12272040E-06_JPRB, 0.12257743E-06_JPRB, 0.12174654E-06_JPRB, &
  & 0.12215425E-06_JPRB, 0.11771293E-06_JPRB, 0.11307031E-06_JPRB, 0.11026523E-06_JPRB, 0.11103901E-06_JPRB, 0.11340974E-06_JPRB, &
  & 0.11535370E-06_JPRB, 0.11421508E-06_JPRB, 0.11670350E-06_JPRB, 0.11930658E-06_JPRB  /)

RGHG7(:,55,12) = (/ &
  & 0.14014760E-06_JPRB, 0.12879600E-06_JPRB, 0.11843704E-06_JPRB, 0.11433574E-06_JPRB, 0.11186040E-06_JPRB, 0.10511319E-06_JPRB, &
  & 0.95409365E-07_JPRB, 0.87981294E-07_JPRB, 0.85969696E-07_JPRB, 0.89278243E-07_JPRB, 0.91349319E-07_JPRB, 0.89746611E-07_JPRB, &
  & 0.87083157E-07_JPRB, 0.81941059E-07_JPRB, 0.76049909E-07_JPRB, 0.69776457E-07_JPRB, 0.63939432E-07_JPRB, 0.59965793E-07_JPRB, &
  & 0.58123135E-07_JPRB, 0.57706689E-07_JPRB, 0.57124734E-07_JPRB, 0.56550838E-07_JPRB, 0.55013325E-07_JPRB, 0.51543056E-07_JPRB, &
  & 0.47003721E-07_JPRB, 0.41419156E-07_JPRB, 0.37635805E-07_JPRB, 0.35777749E-07_JPRB, 0.34441388E-07_JPRB, 0.32822849E-07_JPRB, &
  & 0.31916259E-07_JPRB, 0.31441478E-07_JPRB, 0.31179296E-07_JPRB, 0.31707377E-07_JPRB, 0.33631335E-07_JPRB, 0.36653379E-07_JPRB, &
  & 0.40484670E-07_JPRB, 0.43709804E-07_JPRB, 0.45271412E-07_JPRB, 0.46144473E-07_JPRB, 0.48398370E-07_JPRB, 0.51854182E-07_JPRB, &
  & 0.57260710E-07_JPRB, 0.62785466E-07_JPRB, 0.67315559E-07_JPRB, 0.71552321E-07_JPRB, 0.76948870E-07_JPRB, 0.82598438E-07_JPRB, &
  & 0.88531561E-07_JPRB, 0.92942107E-07_JPRB, 0.95251635E-07_JPRB, 0.95518496E-07_JPRB, 0.94543710E-07_JPRB, 0.93050999E-07_JPRB, &
  & 0.93536568E-07_JPRB, 0.89363875E-07_JPRB, 0.85643913E-07_JPRB, 0.83804312E-07_JPRB, 0.84162830E-07_JPRB, 0.86079363E-07_JPRB, &
  & 0.87537988E-07_JPRB, 0.85832278E-07_JPRB, 0.87871695E-07_JPRB, 0.90887442E-07_JPRB  /)

RGHG7(:,56,12) = (/ &
  & 0.12082756E-06_JPRB, 0.10996055E-06_JPRB, 0.99688849E-07_JPRB, 0.95258590E-07_JPRB, 0.92678016E-07_JPRB, 0.86642667E-07_JPRB, &
  & 0.77996566E-07_JPRB, 0.71458985E-07_JPRB, 0.69685872E-07_JPRB, 0.72794776E-07_JPRB, 0.75167714E-07_JPRB, 0.74626370E-07_JPRB, &
  & 0.73224357E-07_JPRB, 0.70091633E-07_JPRB, 0.66295646E-07_JPRB, 0.62111919E-07_JPRB, 0.58014716E-07_JPRB, 0.55239933E-07_JPRB, &
  & 0.54040018E-07_JPRB, 0.54081461E-07_JPRB, 0.53962384E-07_JPRB, 0.53892930E-07_JPRB, 0.53345578E-07_JPRB, 0.50657306E-07_JPRB, &
  & 0.46804756E-07_JPRB, 0.41587636E-07_JPRB, 0.37574518E-07_JPRB, 0.35571923E-07_JPRB, 0.34150375E-07_JPRB, 0.32362781E-07_JPRB, &
  & 0.31346893E-07_JPRB, 0.30951774E-07_JPRB, 0.30848568E-07_JPRB, 0.31393217E-07_JPRB, 0.33479684E-07_JPRB, 0.36845993E-07_JPRB, &
  & 0.40866456E-07_JPRB, 0.43608999E-07_JPRB, 0.44825909E-07_JPRB, 0.45737685E-07_JPRB, 0.47837386E-07_JPRB, 0.50766548E-07_JPRB, &
  & 0.55326679E-07_JPRB, 0.59652877E-07_JPRB, 0.63123894E-07_JPRB, 0.66212998E-07_JPRB, 0.69944838E-07_JPRB, 0.73808302E-07_JPRB, &
  & 0.77764011E-07_JPRB, 0.80329676E-07_JPRB, 0.81549267E-07_JPRB, 0.81527353E-07_JPRB, 0.80479096E-07_JPRB, 0.79131356E-07_JPRB, &
  & 0.79571185E-07_JPRB, 0.76167073E-07_JPRB, 0.73474832E-07_JPRB, 0.72297414E-07_JPRB, 0.72354513E-07_JPRB, 0.73842879E-07_JPRB, &
  & 0.75053165E-07_JPRB, 0.73511076E-07_JPRB, 0.75254672E-07_JPRB, 0.77641205E-07_JPRB  /)

RGHG7(:,57,12) = (/ &
  & 0.10149324E-06_JPRB, 0.91273420E-07_JPRB, 0.81351183E-07_JPRB, 0.76765830E-07_JPRB, 0.74143600E-07_JPRB, 0.68864855E-07_JPRB, &
  & 0.61280363E-07_JPRB, 0.55658969E-07_JPRB, 0.54163035E-07_JPRB, 0.56985350E-07_JPRB, 0.59553575E-07_JPRB, 0.59983848E-07_JPRB, &
  & 0.59767385E-07_JPRB, 0.58466550E-07_JPRB, 0.56618378E-07_JPRB, 0.54419880E-07_JPRB, 0.52030634E-07_JPRB, 0.50478096E-07_JPRB, &
  & 0.49966203E-07_JPRB, 0.50458389E-07_JPRB, 0.50837212E-07_JPRB, 0.51235561E-07_JPRB, 0.51633116E-07_JPRB, 0.49735366E-07_JPRB, &
  & 0.46539301E-07_JPRB, 0.41748252E-07_JPRB, 0.37519510E-07_JPRB, 0.35387090E-07_JPRB, 0.33829282E-07_JPRB, 0.31893712E-07_JPRB, &
  & 0.30754624E-07_JPRB, 0.30450537E-07_JPRB, 0.30515670E-07_JPRB, 0.31099391E-07_JPRB, 0.33383480E-07_JPRB, 0.37059485E-07_JPRB, &
  & 0.41192275E-07_JPRB, 0.43486968E-07_JPRB, 0.44436831E-07_JPRB, 0.45396320E-07_JPRB, 0.47259807E-07_JPRB, 0.49678660E-07_JPRB, &
  & 0.53376435E-07_JPRB, 0.56539989E-07_JPRB, 0.58955952E-07_JPRB, 0.60887100E-07_JPRB, 0.63034928E-07_JPRB, 0.65193295E-07_JPRB, &
  & 0.67243388E-07_JPRB, 0.68168505E-07_JPRB, 0.68422831E-07_JPRB, 0.68100060E-07_JPRB, 0.67020732E-07_JPRB, 0.65795886E-07_JPRB, &
  & 0.66126165E-07_JPRB, 0.63470870E-07_JPRB, 0.61701928E-07_JPRB, 0.61077301E-07_JPRB, 0.60926923E-07_JPRB, 0.62010451E-07_JPRB, &
  & 0.62925177E-07_JPRB, 0.61547277E-07_JPRB, 0.62927734E-07_JPRB, 0.64691794E-07_JPRB  /)

RGHG7(:,58,12) = (/ &
  & 0.84161755E-07_JPRB, 0.75120546E-07_JPRB, 0.66168139E-07_JPRB, 0.61852184E-07_JPRB, 0.59387551E-07_JPRB, 0.55108944E-07_JPRB, &
  & 0.48796007E-07_JPRB, 0.44260284E-07_JPRB, 0.43098403E-07_JPRB, 0.45408190E-07_JPRB, 0.47843062E-07_JPRB, 0.48900358E-07_JPRB, &
  & 0.49502863E-07_JPRB, 0.49500524E-07_JPRB, 0.49088912E-07_JPRB, 0.48426653E-07_JPRB, 0.47412006E-07_JPRB, 0.46888566E-07_JPRB, &
  & 0.46954530E-07_JPRB, 0.47711399E-07_JPRB, 0.48486236E-07_JPRB, 0.49098083E-07_JPRB, 0.50134110E-07_JPRB, 0.48917261E-07_JPRB, &
  & 0.46243827E-07_JPRB, 0.41971368E-07_JPRB, 0.37535863E-07_JPRB, 0.35295684E-07_JPRB, 0.33517644E-07_JPRB, 0.31481050E-07_JPRB, &
  & 0.30189079E-07_JPRB, 0.29991404E-07_JPRB, 0.30260606E-07_JPRB, 0.30915043E-07_JPRB, 0.33446305E-07_JPRB, 0.37401809E-07_JPRB, &
  & 0.41473985E-07_JPRB, 0.43365928E-07_JPRB, 0.44236993E-07_JPRB, 0.45302220E-07_JPRB, 0.46805388E-07_JPRB, 0.48820819E-07_JPRB, &
  & 0.51773037E-07_JPRB, 0.54090010E-07_JPRB, 0.55759069E-07_JPRB, 0.56828819E-07_JPRB, 0.57900405E-07_JPRB, 0.58924608E-07_JPRB, &
  & 0.59637817E-07_JPRB, 0.59690761E-07_JPRB, 0.59555135E-07_JPRB, 0.59181851E-07_JPRB, 0.58287734E-07_JPRB, 0.57289855E-07_JPRB, &
  & 0.57388452E-07_JPRB, 0.55482082E-07_JPRB, 0.54405491E-07_JPRB, 0.54047567E-07_JPRB, 0.53886414E-07_JPRB, 0.54641950E-07_JPRB, &
  & 0.55249563E-07_JPRB, 0.54160592E-07_JPRB, 0.55122136E-07_JPRB, 0.56129863E-07_JPRB  /)

RGHG7(:,59,12) = (/ &
  & 0.70353142E-07_JPRB, 0.62698204E-07_JPRB, 0.55064781E-07_JPRB, 0.51182854E-07_JPRB, 0.48944587E-07_JPRB, 0.45608938E-07_JPRB, &
  & 0.40350115E-07_JPRB, 0.36688495E-07_JPRB, 0.35765549E-07_JPRB, 0.37652398E-07_JPRB, 0.39829274E-07_JPRB, 0.41169624E-07_JPRB, &
  & 0.42253882E-07_JPRB, 0.43012480E-07_JPRB, 0.43488912E-07_JPRB, 0.43825904E-07_JPRB, 0.43788122E-07_JPRB, 0.44060019E-07_JPRB, &
  & 0.44615648E-07_JPRB, 0.45621663E-07_JPRB, 0.46659800E-07_JPRB, 0.47412460E-07_JPRB, 0.48766147E-07_JPRB, 0.48141296E-07_JPRB, &
  & 0.45890058E-07_JPRB, 0.42165356E-07_JPRB, 0.37631937E-07_JPRB, 0.35151855E-07_JPRB, 0.33134948E-07_JPRB, 0.31085898E-07_JPRB, &
  & 0.29688401E-07_JPRB, 0.29490082E-07_JPRB, 0.29929229E-07_JPRB, 0.30767210E-07_JPRB, 0.33513927E-07_JPRB, 0.37716602E-07_JPRB, &
  & 0.41639783E-07_JPRB, 0.43377140E-07_JPRB, 0.44224814E-07_JPRB, 0.45333675E-07_JPRB, 0.46531558E-07_JPRB, 0.48178940E-07_JPRB, &
  & 0.50473377E-07_JPRB, 0.52216309E-07_JPRB, 0.53356399E-07_JPRB, 0.53879700E-07_JPRB, 0.54271287E-07_JPRB, 0.54639920E-07_JPRB, &
  & 0.54615502E-07_JPRB, 0.54276282E-07_JPRB, 0.54010278E-07_JPRB, 0.53658214E-07_JPRB, 0.52889575E-07_JPRB, 0.52091904E-07_JPRB, &
  & 0.51986300E-07_JPRB, 0.50629506E-07_JPRB, 0.49939030E-07_JPRB, 0.49706044E-07_JPRB, 0.49611867E-07_JPRB, 0.50107427E-07_JPRB, &
  & 0.50464457E-07_JPRB, 0.49617835E-07_JPRB, 0.50235365E-07_JPRB, 0.50740381E-07_JPRB  /)

RGHG7(:,60,12) = (/ &
  & 0.57986381E-07_JPRB, 0.51788529E-07_JPRB, 0.45617538E-07_JPRB, 0.42225993E-07_JPRB, 0.40249965E-07_JPRB, 0.37796635E-07_JPRB, &
  & 0.33500292E-07_JPRB, 0.30624789E-07_JPRB, 0.29886885E-07_JPRB, 0.31383023E-07_JPRB, 0.33263750E-07_JPRB, 0.34754675E-07_JPRB, &
  & 0.36178930E-07_JPRB, 0.37468675E-07_JPRB, 0.38618015E-07_JPRB, 0.39728490E-07_JPRB, 0.40499763E-07_JPRB, 0.41459430E-07_JPRB, &
  & 0.42477129E-07_JPRB, 0.43731498E-07_JPRB, 0.44976832E-07_JPRB, 0.45855883E-07_JPRB, 0.47392458E-07_JPRB, 0.47319215E-07_JPRB, &
  & 0.45486106E-07_JPRB, 0.42298382E-07_JPRB, 0.37740406E-07_JPRB, 0.34974214E-07_JPRB, 0.32689771E-07_JPRB, 0.30642336E-07_JPRB, &
  & 0.29167499E-07_JPRB, 0.28938738E-07_JPRB, 0.29524978E-07_JPRB, 0.30583617E-07_JPRB, 0.33517735E-07_JPRB, 0.37952863E-07_JPRB, &
  & 0.41717403E-07_JPRB, 0.43424674E-07_JPRB, 0.44277975E-07_JPRB, 0.45392349E-07_JPRB, 0.46325793E-07_JPRB, 0.47604609E-07_JPRB, &
  & 0.49287085E-07_JPRB, 0.50549193E-07_JPRB, 0.51253114E-07_JPRB, 0.51354768E-07_JPRB, 0.51229384E-07_JPRB, 0.51137673E-07_JPRB, &
  & 0.50626105E-07_JPRB, 0.50074722E-07_JPRB, 0.49768607E-07_JPRB, 0.49449387E-07_JPRB, 0.48781158E-07_JPRB, 0.48162924E-07_JPRB, &
  & 0.47885279E-07_JPRB, 0.46982987E-07_JPRB, 0.46556333E-07_JPRB, 0.46399705E-07_JPRB, 0.46391082E-07_JPRB, 0.46653730E-07_JPRB, &
  & 0.46785795E-07_JPRB, 0.46147276E-07_JPRB, 0.46464985E-07_JPRB, 0.46578011E-07_JPRB  /)

RGHG7(:,61,12) = (/ &
  & 0.49025796E-07_JPRB, 0.44076294E-07_JPRB, 0.39275239E-07_JPRB, 0.36316363E-07_JPRB, 0.34619653E-07_JPRB, 0.32731531E-07_JPRB, &
  & 0.29144619E-07_JPRB, 0.26837974E-07_JPRB, 0.26155935E-07_JPRB, 0.27342085E-07_JPRB, 0.28976719E-07_JPRB, 0.30489551E-07_JPRB, &
  & 0.32048172E-07_JPRB, 0.33527415E-07_JPRB, 0.35059037E-07_JPRB, 0.36578082E-07_JPRB, 0.37847746E-07_JPRB, 0.39241908E-07_JPRB, &
  & 0.40646635E-07_JPRB, 0.42125919E-07_JPRB, 0.43484441E-07_JPRB, 0.44502968E-07_JPRB, 0.46049766E-07_JPRB, 0.46387285E-07_JPRB, &
  & 0.45016055E-07_JPRB, 0.42197834E-07_JPRB, 0.37780795E-07_JPRB, 0.34753541E-07_JPRB, 0.32151077E-07_JPRB, 0.30049969E-07_JPRB, &
  & 0.28565274E-07_JPRB, 0.28325194E-07_JPRB, 0.28984824E-07_JPRB, 0.30236977E-07_JPRB, 0.33253978E-07_JPRB, 0.37865094E-07_JPRB, &
  & 0.41569389E-07_JPRB, 0.43444981E-07_JPRB, 0.44351225E-07_JPRB, 0.45393304E-07_JPRB, 0.46201877E-07_JPRB, 0.47124334E-07_JPRB, &
  & 0.48369030E-07_JPRB, 0.49262365E-07_JPRB, 0.49702669E-07_JPRB, 0.49560421E-07_JPRB, 0.49164118E-07_JPRB, 0.48875971E-07_JPRB, &
  & 0.48217990E-07_JPRB, 0.47614394E-07_JPRB, 0.47313755E-07_JPRB, 0.46978471E-07_JPRB, 0.46367931E-07_JPRB, 0.45849375E-07_JPRB, &
  & 0.45523899E-07_JPRB, 0.44867699E-07_JPRB, 0.44551677E-07_JPRB, 0.44440689E-07_JPRB, 0.44480992E-07_JPRB, 0.44572398E-07_JPRB, &
  & 0.44548556E-07_JPRB, 0.44003873E-07_JPRB, 0.44155452E-07_JPRB, 0.44069852E-07_JPRB  /)

RGHG7(:,62,12) = (/ &
  & 0.42216333E-07_JPRB, 0.38249827E-07_JPRB, 0.34606965E-07_JPRB, 0.31986978E-07_JPRB, 0.30544437E-07_JPRB, 0.28990603E-07_JPRB, &
  & 0.25972217E-07_JPRB, 0.24061743E-07_JPRB, 0.23370044E-07_JPRB, 0.24276324E-07_JPRB, 0.25695401E-07_JPRB, 0.27185969E-07_JPRB, &
  & 0.28794041E-07_JPRB, 0.30323945E-07_JPRB, 0.32120838E-07_JPRB, 0.33902549E-07_JPRB, 0.35515130E-07_JPRB, 0.37177353E-07_JPRB, &
  & 0.38870360E-07_JPRB, 0.40542539E-07_JPRB, 0.42014615E-07_JPRB, 0.43156794E-07_JPRB, 0.44655216E-07_JPRB, 0.45280906E-07_JPRB, &
  & 0.44297627E-07_JPRB, 0.41820689E-07_JPRB, 0.37551515E-07_JPRB, 0.34375156E-07_JPRB, 0.31567245E-07_JPRB, 0.29319932E-07_JPRB, &
  & 0.27862636E-07_JPRB, 0.27641420E-07_JPRB, 0.28321098E-07_JPRB, 0.29615353E-07_JPRB, 0.32784914E-07_JPRB, 0.37521680E-07_JPRB, &
  & 0.41249223E-07_JPRB, 0.43345806E-07_JPRB, 0.44361552E-07_JPRB, 0.45354710E-07_JPRB, 0.46045511E-07_JPRB, 0.46695389E-07_JPRB, &
  & 0.47623221E-07_JPRB, 0.48194137E-07_JPRB, 0.48453777E-07_JPRB, 0.48159319E-07_JPRB, 0.47606442E-07_JPRB, 0.47188575E-07_JPRB, &
  & 0.46473575E-07_JPRB, 0.45887461E-07_JPRB, 0.45563822E-07_JPRB, 0.45193039E-07_JPRB, 0.44634459E-07_JPRB, 0.44145510E-07_JPRB, &
  & 0.43821493E-07_JPRB, 0.43332738E-07_JPRB, 0.43080330E-07_JPRB, 0.42998598E-07_JPRB, 0.43046681E-07_JPRB, 0.43000036E-07_JPRB, &
  & 0.42883971E-07_JPRB, 0.42361785E-07_JPRB, 0.42425458E-07_JPRB, 0.42221393E-07_JPRB  /)

RGHG7(:,63,12) = (/ &
  & 0.36828202E-07_JPRB, 0.33674169E-07_JPRB, 0.30999808E-07_JPRB, 0.28668613E-07_JPRB, 0.27445653E-07_JPRB, 0.26083578E-07_JPRB, &
  & 0.23530362E-07_JPRB, 0.21889108E-07_JPRB, 0.21134771E-07_JPRB, 0.21795489E-07_JPRB, 0.23010920E-07_JPRB, 0.24448008E-07_JPRB, &
  & 0.26047577E-07_JPRB, 0.27554873E-07_JPRB, 0.29537035E-07_JPRB, 0.31489038E-07_JPRB, 0.33336822E-07_JPRB, 0.35173496E-07_JPRB, &
  & 0.37095662E-07_JPRB, 0.38939652E-07_JPRB, 0.40522827E-07_JPRB, 0.41773957E-07_JPRB, 0.43175872E-07_JPRB, 0.43991756E-07_JPRB, &
  & 0.43345056E-07_JPRB, 0.41193960E-07_JPRB, 0.37062482E-07_JPRB, 0.33857218E-07_JPRB, 0.30951236E-07_JPRB, 0.28529964E-07_JPRB, &
  & 0.27087783E-07_JPRB, 0.26875734E-07_JPRB, 0.27522576E-07_JPRB, 0.28778757E-07_JPRB, 0.32143899E-07_JPRB, 0.37057599E-07_JPRB, &
  & 0.40821869E-07_JPRB, 0.43144378E-07_JPRB, 0.44290891E-07_JPRB, 0.45253370E-07_JPRB, 0.45841962E-07_JPRB, 0.46291541E-07_JPRB, &
  & 0.46963099E-07_JPRB, 0.47267423E-07_JPRB, 0.47395403E-07_JPRB, 0.47005141E-07_JPRB, 0.46358536E-07_JPRB, 0.45852059E-07_JPRB, &
  & 0.45124197E-07_JPRB, 0.44579618E-07_JPRB, 0.44213107E-07_JPRB, 0.43805608E-07_JPRB, 0.43284681E-07_JPRB, 0.42794547E-07_JPRB, &
  & 0.42485766E-07_JPRB, 0.42117980E-07_JPRB, 0.41911397E-07_JPRB, 0.41843253E-07_JPRB, 0.41874433E-07_JPRB, 0.41718694E-07_JPRB, &
  & 0.41547930E-07_JPRB, 0.41010725E-07_JPRB, 0.41029795E-07_JPRB, 0.40749583E-07_JPRB  /)

RGHG7(:,64,12) = (/ &
  & 0.32987477E-07_JPRB, 0.30461201E-07_JPRB, 0.28461719E-07_JPRB, 0.26379311E-07_JPRB, 0.25306901E-07_JPRB, 0.24010716E-07_JPRB, &
  & 0.21791346E-07_JPRB, 0.20269494E-07_JPRB, 0.19390164E-07_JPRB, 0.19869583E-07_JPRB, 0.20887742E-07_JPRB, 0.22240970E-07_JPRB, &
  & 0.23775048E-07_JPRB, 0.25220446E-07_JPRB, 0.27301244E-07_JPRB, 0.29336310E-07_JPRB, 0.31301099E-07_JPRB, 0.33242799E-07_JPRB, &
  & 0.35339076E-07_JPRB, 0.37328424E-07_JPRB, 0.39011832E-07_JPRB, 0.40347222E-07_JPRB, 0.41596591E-07_JPRB, 0.42476768E-07_JPRB, &
  & 0.42101217E-07_JPRB, 0.40253618E-07_JPRB, 0.36221973E-07_JPRB, 0.33173649E-07_JPRB, 0.30325571E-07_JPRB, 0.27762934E-07_JPRB, &
  & 0.26266443E-07_JPRB, 0.26008070E-07_JPRB, 0.26546293E-07_JPRB, 0.27721409E-07_JPRB, 0.31310179E-07_JPRB, 0.36573299E-07_JPRB, &
  & 0.40320797E-07_JPRB, 0.42818615E-07_JPRB, 0.44085727E-07_JPRB, 0.45040219E-07_JPRB, 0.45562122E-07_JPRB, 0.45913464E-07_JPRB, &
  & 0.46365787E-07_JPRB, 0.46505584E-07_JPRB, 0.46544112E-07_JPRB, 0.46108326E-07_JPRB, 0.45411005E-07_JPRB, 0.44853413E-07_JPRB, &
  & 0.44131542E-07_JPRB, 0.43615315E-07_JPRB, 0.43187306E-07_JPRB, 0.42761438E-07_JPRB, 0.42246900E-07_JPRB, 0.41750777E-07_JPRB, &
  & 0.41440398E-07_JPRB, 0.41153677E-07_JPRB, 0.40995014E-07_JPRB, 0.40917686E-07_JPRB, 0.40913325E-07_JPRB, 0.40690897E-07_JPRB, &
  & 0.40495773E-07_JPRB, 0.39923825E-07_JPRB, 0.39927721E-07_JPRB, 0.39597592E-07_JPRB  /)

RGHG7(:,65,12) = (/ &
  & 0.30570998E-07_JPRB, 0.28492171E-07_JPRB, 0.26783197E-07_JPRB, 0.24977862E-07_JPRB, 0.23932266E-07_JPRB, 0.22662705E-07_JPRB, &
  & 0.20638861E-07_JPRB, 0.19046650E-07_JPRB, 0.18006808E-07_JPRB, 0.18382341E-07_JPRB, 0.19216218E-07_JPRB, 0.20457070E-07_JPRB, &
  & 0.21888732E-07_JPRB, 0.23255408E-07_JPRB, 0.25331896E-07_JPRB, 0.27346216E-07_JPRB, 0.29324833E-07_JPRB, 0.31344112E-07_JPRB, &
  & 0.33558961E-07_JPRB, 0.35695148E-07_JPRB, 0.37455395E-07_JPRB, 0.38873086E-07_JPRB, 0.40012231E-07_JPRB, 0.40817069E-07_JPRB, &
  & 0.40649692E-07_JPRB, 0.38941391E-07_JPRB, 0.35236695E-07_JPRB, 0.32435338E-07_JPRB, 0.29703587E-07_JPRB, 0.27178399E-07_JPRB, &
  & 0.25604884E-07_JPRB, 0.25224012E-07_JPRB, 0.25563584E-07_JPRB, 0.26718715E-07_JPRB, 0.30370768E-07_JPRB, 0.36037263E-07_JPRB, &
  & 0.39838109E-07_JPRB, 0.42389176E-07_JPRB, 0.43780037E-07_JPRB, 0.44774057E-07_JPRB, 0.45243257E-07_JPRB, 0.45532781E-07_JPRB, &
  & 0.45815487E-07_JPRB, 0.45876476E-07_JPRB, 0.45850144E-07_JPRB, 0.45394133E-07_JPRB, 0.44671727E-07_JPRB, 0.44096452E-07_JPRB, &
  & 0.43385076E-07_JPRB, 0.42881809E-07_JPRB, 0.42375850E-07_JPRB, 0.41936304E-07_JPRB, 0.41404046E-07_JPRB, 0.40915639E-07_JPRB, &
  & 0.40593987E-07_JPRB, 0.40351410E-07_JPRB, 0.40229511E-07_JPRB, 0.40108362E-07_JPRB, 0.40070047E-07_JPRB, 0.39851040E-07_JPRB, &
  & 0.39646610E-07_JPRB, 0.39043743E-07_JPRB, 0.39044985E-07_JPRB, 0.38689833E-07_JPRB  /)

RGHG7(:,66,12) = (/ &
  & 0.28793827E-07_JPRB, 0.27021311E-07_JPRB, 0.25428974E-07_JPRB, 0.23932663E-07_JPRB, 0.22872192E-07_JPRB, 0.21640822E-07_JPRB, &
  & 0.19740992E-07_JPRB, 0.17981823E-07_JPRB, 0.16776031E-07_JPRB, 0.17071520E-07_JPRB, 0.17742160E-07_JPRB, 0.18865279E-07_JPRB, &
  & 0.20177123E-07_JPRB, 0.21453676E-07_JPRB, 0.23460439E-07_JPRB, 0.25413586E-07_JPRB, 0.27349978E-07_JPRB, 0.29412803E-07_JPRB, &
  & 0.31712021E-07_JPRB, 0.33962301E-07_JPRB, 0.35832184E-07_JPRB, 0.37317922E-07_JPRB, 0.38384494E-07_JPRB, 0.39137460E-07_JPRB, &
  & 0.39135058E-07_JPRB, 0.37474494E-07_JPRB, 0.34200726E-07_JPRB, 0.31663185E-07_JPRB, 0.29059209E-07_JPRB, 0.26650771E-07_JPRB, &
  & 0.25064456E-07_JPRB, 0.24549224E-07_JPRB, 0.24716342E-07_JPRB, 0.25777931E-07_JPRB, 0.29484343E-07_JPRB, 0.35371373E-07_JPRB, &
  & 0.39336884E-07_JPRB, 0.41884092E-07_JPRB, 0.43440474E-07_JPRB, 0.44506439E-07_JPRB, 0.44911452E-07_JPRB, 0.45130613E-07_JPRB, &
  & 0.45289349E-07_JPRB, 0.45301801E-07_JPRB, 0.45226547E-07_JPRB, 0.44738587E-07_JPRB, 0.44021247E-07_JPRB, 0.43422910E-07_JPRB, &
  & 0.42725833E-07_JPRB, 0.42214733E-07_JPRB, 0.41635859E-07_JPRB, 0.41177692E-07_JPRB, 0.40625902E-07_JPRB, 0.40152562E-07_JPRB, &
  & 0.39819368E-07_JPRB, 0.39605545E-07_JPRB, 0.39503583E-07_JPRB, 0.39329935E-07_JPRB, 0.39271149E-07_JPRB, 0.39080730E-07_JPRB, &
  & 0.38873054E-07_JPRB, 0.38256025E-07_JPRB, 0.38237371E-07_JPRB, 0.37890329E-07_JPRB  /)

RGHG7(:,67,12) = (/ &
  & 0.27538978E-07_JPRB, 0.25934252E-07_JPRB, 0.24338668E-07_JPRB, 0.23161562E-07_JPRB, 0.22062906E-07_JPRB, 0.20884544E-07_JPRB, &
  & 0.19047172E-07_JPRB, 0.17047080E-07_JPRB, 0.15686408E-07_JPRB, 0.15912540E-07_JPRB, 0.16445230E-07_JPRB, 0.17448618E-07_JPRB, &
  & 0.18630754E-07_JPRB, 0.19806081E-07_JPRB, 0.21689115E-07_JPRB, 0.23546526E-07_JPRB, 0.25397125E-07_JPRB, 0.27470737E-07_JPRB, &
  & 0.29807690E-07_JPRB, 0.32127736E-07_JPRB, 0.34134148E-07_JPRB, 0.35681482E-07_JPRB, 0.36718387E-07_JPRB, 0.37458677E-07_JPRB, &
  & 0.37577872E-07_JPRB, 0.35924307E-07_JPRB, 0.33099573E-07_JPRB, 0.30822387E-07_JPRB, 0.28403270E-07_JPRB, 0.26163679E-07_JPRB, &
  & 0.24645167E-07_JPRB, 0.23986495E-07_JPRB, 0.23989605E-07_JPRB, 0.24887243E-07_JPRB, 0.28657047E-07_JPRB, 0.34563508E-07_JPRB, &
  & 0.38790708E-07_JPRB, 0.41310875E-07_JPRB, 0.43063441E-07_JPRB, 0.44230978E-07_JPRB, 0.44568655E-07_JPRB, 0.44702884E-07_JPRB, &
  & 0.44777890E-07_JPRB, 0.44772909E-07_JPRB, 0.44664726E-07_JPRB, 0.44131922E-07_JPRB, 0.43441443E-07_JPRB, 0.42812877E-07_JPRB, &
  & 0.42131441E-07_JPRB, 0.41594505E-07_JPRB, 0.40952261E-07_JPRB, 0.40463017E-07_JPRB, 0.39894112E-07_JPRB, 0.39442945E-07_JPRB, &
  & 0.39103217E-07_JPRB, 0.38905225E-07_JPRB, 0.38805820E-07_JPRB, 0.38577412E-07_JPRB, 0.38514100E-07_JPRB, 0.38371818E-07_JPRB, &
  & 0.38168310E-07_JPRB, 0.37556858E-07_JPRB, 0.37499308E-07_JPRB, 0.37199096E-07_JPRB  /)

RGHG7(:,68,12) = (/ &
  & 0.26661349E-07_JPRB, 0.25093527E-07_JPRB, 0.23457348E-07_JPRB, 0.22565224E-07_JPRB, 0.21429665E-07_JPRB, 0.20316090E-07_JPRB, &
  & 0.18492249E-07_JPRB, 0.16208816E-07_JPRB, 0.14731690E-07_JPRB, 0.14879503E-07_JPRB, 0.15303941E-07_JPRB, 0.16186776E-07_JPRB, &
  & 0.17240567E-07_JPRB, 0.18302311E-07_JPRB, 0.20026247E-07_JPRB, 0.21754084E-07_JPRB, 0.23494380E-07_JPRB, 0.25552000E-07_JPRB, &
  & 0.27851639E-07_JPRB, 0.30181936E-07_JPRB, 0.32328173E-07_JPRB, 0.33951367E-07_JPRB, 0.35011234E-07_JPRB, 0.35777767E-07_JPRB, &
  & 0.35974871E-07_JPRB, 0.34386503E-07_JPRB, 0.31870944E-07_JPRB, 0.29824614E-07_JPRB, 0.27756087E-07_JPRB, 0.25697327E-07_JPRB, &
  & 0.24342423E-07_JPRB, 0.23523013E-07_JPRB, 0.23305928E-07_JPRB, 0.24004284E-07_JPRB, 0.27856097E-07_JPRB, 0.33598949E-07_JPRB, &
  & 0.38143935E-07_JPRB, 0.40675994E-07_JPRB, 0.42624562E-07_JPRB, 0.43920033E-07_JPRB, 0.44209735E-07_JPRB, 0.44239811E-07_JPRB, &
  & 0.44257002E-07_JPRB, 0.44276623E-07_JPRB, 0.44152038E-07_JPRB, 0.43566338E-07_JPRB, 0.42904562E-07_JPRB, 0.42242373E-07_JPRB, &
  & 0.41572828E-07_JPRB, 0.40999808E-07_JPRB, 0.40307948E-07_JPRB, 0.39760888E-07_JPRB, 0.39181732E-07_JPRB, 0.38760498E-07_JPRB, &
  & 0.38428561E-07_JPRB, 0.38235489E-07_JPRB, 0.38122143E-07_JPRB, 0.37844939E-07_JPRB, 0.37795159E-07_JPRB, 0.37716845E-07_JPRB, &
  & 0.37529328E-07_JPRB, 0.36946169E-07_JPRB, 0.36833263E-07_JPRB, 0.36627772E-07_JPRB  /)

RGHG7(:,69,12) = (/ &
  & 0.26012452E-07_JPRB, 0.24410993E-07_JPRB, 0.22753633E-07_JPRB, 0.22030002E-07_JPRB, 0.20866501E-07_JPRB, 0.19843079E-07_JPRB, &
  & 0.17984998E-07_JPRB, 0.15459700E-07_JPRB, 0.13896744E-07_JPRB, 0.13964761E-07_JPRB, 0.14315673E-07_JPRB, 0.15070139E-07_JPRB, &
  & 0.15990385E-07_JPRB, 0.16961705E-07_JPRB, 0.18495597E-07_JPRB, 0.20083807E-07_JPRB, 0.21694788E-07_JPRB, 0.23699845E-07_JPRB, &
  & 0.25887537E-07_JPRB, 0.28183673E-07_JPRB, 0.30408133E-07_JPRB, 0.32110903E-07_JPRB, 0.33187384E-07_JPRB, 0.33954032E-07_JPRB, &
  & 0.34188351E-07_JPRB, 0.32740555E-07_JPRB, 0.30464699E-07_JPRB, 0.28676800E-07_JPRB, 0.26988280E-07_JPRB, 0.25109571E-07_JPRB, &
  & 0.23789866E-07_JPRB, 0.22854904E-07_JPRB, 0.22426621E-07_JPRB, 0.23182491E-07_JPRB, 0.27057333E-07_JPRB, 0.32429482E-07_JPRB, &
  & 0.37315707E-07_JPRB, 0.40030206E-07_JPRB, 0.42132569E-07_JPRB, 0.43510421E-07_JPRB, 0.43811122E-07_JPRB, 0.43743410E-07_JPRB, &
  & 0.43716976E-07_JPRB, 0.43751493E-07_JPRB, 0.43629169E-07_JPRB, 0.43016333E-07_JPRB, 0.42375791E-07_JPRB, 0.41701630E-07_JPRB, &
  & 0.41029792E-07_JPRB, 0.40428532E-07_JPRB, 0.39671019E-07_JPRB, 0.39059808E-07_JPRB, 0.38481598E-07_JPRB, 0.38080216E-07_JPRB, &
  & 0.37785551E-07_JPRB, 0.37580232E-07_JPRB, 0.37441004E-07_JPRB, 0.37135167E-07_JPRB, 0.37110484E-07_JPRB, 0.37105829E-07_JPRB, &
  & 0.36944004E-07_JPRB, 0.36389880E-07_JPRB, 0.36248498E-07_JPRB, 0.36176522E-07_JPRB  /)

RGHG7(:,70,12) = (/ &
  & 0.25439487E-07_JPRB, 0.23783539E-07_JPRB, 0.22139042E-07_JPRB, 0.21487196E-07_JPRB, 0.20326370E-07_JPRB, 0.19397216E-07_JPRB, &
  & 0.17500824E-07_JPRB, 0.14774204E-07_JPRB, 0.13118261E-07_JPRB, 0.13109986E-07_JPRB, 0.13401615E-07_JPRB, 0.14030972E-07_JPRB, &
  & 0.14830472E-07_JPRB, 0.15717048E-07_JPRB, 0.17063892E-07_JPRB, 0.18520018E-07_JPRB, 0.19995735E-07_JPRB, 0.21893997E-07_JPRB, &
  & 0.23951188E-07_JPRB, 0.26190123E-07_JPRB, 0.28453521E-07_JPRB, 0.30188975E-07_JPRB, 0.31243112E-07_JPRB, 0.31980607E-07_JPRB, &
  & 0.32244149E-07_JPRB, 0.30966809E-07_JPRB, 0.28990049E-07_JPRB, 0.27425695E-07_JPRB, 0.26045552E-07_JPRB, 0.24304525E-07_JPRB, &
  & 0.22935926E-07_JPRB, 0.21938967E-07_JPRB, 0.21421239E-07_JPRB, 0.22449528E-07_JPRB, 0.26322322E-07_JPRB, 0.31233713E-07_JPRB, &
  & 0.36353136E-07_JPRB, 0.39350680E-07_JPRB, 0.41568667E-07_JPRB, 0.42996450E-07_JPRB, 0.43343779E-07_JPRB, 0.43212786E-07_JPRB, &
  & 0.43176210E-07_JPRB, 0.43200626E-07_JPRB, 0.43089797E-07_JPRB, 0.42446357E-07_JPRB, 0.41823018E-07_JPRB, 0.41158061E-07_JPRB, &
  & 0.40472518E-07_JPRB, 0.39850884E-07_JPRB, 0.39038869E-07_JPRB, 0.38361801E-07_JPRB, 0.37780641E-07_JPRB, 0.37392436E-07_JPRB, &
  & 0.37143986E-07_JPRB, 0.36928512E-07_JPRB, 0.36760743E-07_JPRB, 0.36443931E-07_JPRB, 0.36445062E-07_JPRB, 0.36505400E-07_JPRB, &
  & 0.36360507E-07_JPRB, 0.35833881E-07_JPRB, 0.35692831E-07_JPRB, 0.35755372E-07_JPRB  /)

RGHG7(:,71,12) = (/ &
  & 0.24889118E-07_JPRB, 0.23186147E-07_JPRB, 0.21591337E-07_JPRB, 0.20939221E-07_JPRB, 0.19815032E-07_JPRB, 0.18969393E-07_JPRB, &
  & 0.17047097E-07_JPRB, 0.14143215E-07_JPRB, 0.12383842E-07_JPRB, 0.12305968E-07_JPRB, 0.12546975E-07_JPRB, 0.13061674E-07_JPRB, &
  & 0.13757606E-07_JPRB, 0.14558927E-07_JPRB, 0.15729284E-07_JPRB, 0.17064988E-07_JPRB, 0.18405995E-07_JPRB, 0.20145811E-07_JPRB, &
  & 0.22068502E-07_JPRB, 0.24227898E-07_JPRB, 0.26478074E-07_JPRB, 0.28194418E-07_JPRB, 0.29205780E-07_JPRB, 0.29884158E-07_JPRB, &
  & 0.30183189E-07_JPRB, 0.29089337E-07_JPRB, 0.27461432E-07_JPRB, 0.26084537E-07_JPRB, 0.24914940E-07_JPRB, 0.23263761E-07_JPRB, &
  & 0.21822018E-07_JPRB, 0.20811173E-07_JPRB, 0.20365701E-07_JPRB, 0.21834735E-07_JPRB, 0.25697814E-07_JPRB, 0.30088704E-07_JPRB, &
  & 0.35255508E-07_JPRB, 0.38586010E-07_JPRB, 0.40880203E-07_JPRB, 0.42356062E-07_JPRB, 0.42791215E-07_JPRB, 0.42641662E-07_JPRB, &
  & 0.42631149E-07_JPRB, 0.42631972E-07_JPRB, 0.42535607E-07_JPRB, 0.41848673E-07_JPRB, 0.41240949E-07_JPRB, 0.40606230E-07_JPRB, &
  & 0.39899325E-07_JPRB, 0.39265179E-07_JPRB, 0.38409530E-07_JPRB, 0.37669433E-07_JPRB, 0.37073535E-07_JPRB, 0.36696951E-07_JPRB, &
  & 0.36498405E-07_JPRB, 0.36277708E-07_JPRB, 0.36084394E-07_JPRB, 0.35766753E-07_JPRB, 0.35784567E-07_JPRB, 0.35897655E-07_JPRB, &
  & 0.35766857E-07_JPRB, 0.35268070E-07_JPRB, 0.35150874E-07_JPRB, 0.35329247E-07_JPRB  /)

RGHG7(:,72,12) = (/ &
  & 0.24288624E-07_JPRB, 0.22590579E-07_JPRB, 0.21085659E-07_JPRB, 0.20403168E-07_JPRB, 0.19352452E-07_JPRB, 0.18555246E-07_JPRB, &
  & 0.16642391E-07_JPRB, 0.13553393E-07_JPRB, 0.11681144E-07_JPRB, 0.11545395E-07_JPRB, 0.11737969E-07_JPRB, 0.12159904E-07_JPRB, &
  & 0.12774155E-07_JPRB, 0.13481072E-07_JPRB, 0.14492582E-07_JPRB, 0.15723619E-07_JPRB, 0.16939847E-07_JPRB, 0.18476487E-07_JPRB, &
  & 0.20276451E-07_JPRB, 0.22329949E-07_JPRB, 0.24483667E-07_JPRB, 0.26129002E-07_JPRB, 0.27119431E-07_JPRB, 0.27707099E-07_JPRB, &
  & 0.28068929E-07_JPRB, 0.27149521E-07_JPRB, 0.25876662E-07_JPRB, 0.24661898E-07_JPRB, 0.23573982E-07_JPRB, 0.21962207E-07_JPRB, &
  & 0.20529083E-07_JPRB, 0.19541223E-07_JPRB, 0.19387587E-07_JPRB, 0.21389804E-07_JPRB, 0.25261913E-07_JPRB, 0.29103201E-07_JPRB, &
  & 0.34004029E-07_JPRB, 0.37636217E-07_JPRB, 0.39963247E-07_JPRB, 0.41542130E-07_JPRB, 0.42123406E-07_JPRB, 0.42014898E-07_JPRB, &
  & 0.42068828E-07_JPRB, 0.42057747E-07_JPRB, 0.41968771E-07_JPRB, 0.41212880E-07_JPRB, 0.40623216E-07_JPRB, 0.40040214E-07_JPRB, &
  & 0.39310734E-07_JPRB, 0.38672074E-07_JPRB, 0.37777431E-07_JPRB, 0.36984795E-07_JPRB, 0.36349904E-07_JPRB, 0.35992611E-07_JPRB, &
  & 0.35842089E-07_JPRB, 0.35622623E-07_JPRB, 0.35415765E-07_JPRB, 0.35093608E-07_JPRB, 0.35101981E-07_JPRB, 0.35252421E-07_JPRB, &
  & 0.35148303E-07_JPRB, 0.34681942E-07_JPRB, 0.34602097E-07_JPRB, 0.34847375E-07_JPRB  /)

RGHG7(:,73,12) = (/ &
  & 0.23609431E-07_JPRB, 0.21972722E-07_JPRB, 0.20589071E-07_JPRB, 0.19900793E-07_JPRB, 0.18919784E-07_JPRB, 0.18134722E-07_JPRB, &
  & 0.16261077E-07_JPRB, 0.12993506E-07_JPRB, 0.11012298E-07_JPRB, 0.10822910E-07_JPRB, 0.10967911E-07_JPRB, 0.11322831E-07_JPRB, &
  & 0.11861403E-07_JPRB, 0.12497747E-07_JPRB, 0.13373488E-07_JPRB, 0.14488965E-07_JPRB, 0.15621595E-07_JPRB, 0.16950450E-07_JPRB, &
  & 0.18646785E-07_JPRB, 0.20543483E-07_JPRB, 0.22495802E-07_JPRB, 0.24000381E-07_JPRB, 0.24988803E-07_JPRB, 0.25561805E-07_JPRB, &
  & 0.25971943E-07_JPRB, 0.25181897E-07_JPRB, 0.24122143E-07_JPRB, 0.23164166E-07_JPRB, 0.22101643E-07_JPRB, 0.20530643E-07_JPRB, &
  & 0.19214762E-07_JPRB, 0.18407356E-07_JPRB, 0.18613536E-07_JPRB, 0.21039651E-07_JPRB, 0.24963891E-07_JPRB, 0.28336577E-07_JPRB, &
  & 0.32697499E-07_JPRB, 0.36400742E-07_JPRB, 0.38734132E-07_JPRB, 0.40453972E-07_JPRB, 0.41296125E-07_JPRB, 0.41305093E-07_JPRB, &
  & 0.41467268E-07_JPRB, 0.41449167E-07_JPRB, 0.41340954E-07_JPRB, 0.40538945E-07_JPRB, 0.39958684E-07_JPRB, 0.39432652E-07_JPRB, &
  & 0.38703704E-07_JPRB, 0.38044122E-07_JPRB, 0.37136165E-07_JPRB, 0.36314685E-07_JPRB, 0.35637527E-07_JPRB, 0.35271066E-07_JPRB, &
  & 0.35158559E-07_JPRB, 0.34943380E-07_JPRB, 0.34739279E-07_JPRB, 0.34410677E-07_JPRB, 0.34383268E-07_JPRB, 0.34549943E-07_JPRB, &
  & 0.34485993E-07_JPRB, 0.34072437E-07_JPRB, 0.34002732E-07_JPRB, 0.34276445E-07_JPRB  /)

RGHG7(:,74,12) = (/ &
  & 0.22875385E-07_JPRB, 0.21328981E-07_JPRB, 0.20060186E-07_JPRB, 0.19430407E-07_JPRB, 0.18515492E-07_JPRB, 0.17708277E-07_JPRB, &
  & 0.15903816E-07_JPRB, 0.12493612E-07_JPRB, 0.10397199E-07_JPRB, 0.10155577E-07_JPRB, 0.10254369E-07_JPRB, 0.10546742E-07_JPRB, &
  & 0.11019640E-07_JPRB, 0.11592450E-07_JPRB, 0.12366979E-07_JPRB, 0.13362138E-07_JPRB, 0.14406049E-07_JPRB, 0.15541083E-07_JPRB, &
  & 0.17133276E-07_JPRB, 0.18845763E-07_JPRB, 0.20555849E-07_JPRB, 0.21864385E-07_JPRB, 0.22844215E-07_JPRB, 0.23450109E-07_JPRB, &
  & 0.23869856E-07_JPRB, 0.23283067E-07_JPRB, 0.22435153E-07_JPRB, 0.21632594E-07_JPRB, 0.20606067E-07_JPRB, 0.19162169E-07_JPRB, &
  & 0.18036489E-07_JPRB, 0.17444899E-07_JPRB, 0.17989458E-07_JPRB, 0.20748028E-07_JPRB, 0.24725985E-07_JPRB, 0.27714967E-07_JPRB, &
  & 0.31440898E-07_JPRB, 0.35030891E-07_JPRB, 0.37412773E-07_JPRB, 0.39224559E-07_JPRB, 0.40312922E-07_JPRB, 0.40513085E-07_JPRB, &
  & 0.40793518E-07_JPRB, 0.40799054E-07_JPRB, 0.40695164E-07_JPRB, 0.39874040E-07_JPRB, 0.39286333E-07_JPRB, 0.38803029E-07_JPRB, &
  & 0.38082009E-07_JPRB, 0.37419727E-07_JPRB, 0.36503604E-07_JPRB, 0.35664724E-07_JPRB, 0.34946308E-07_JPRB, 0.34559619E-07_JPRB, &
  & 0.34470366E-07_JPRB, 0.34255512E-07_JPRB, 0.34053058E-07_JPRB, 0.33722068E-07_JPRB, 0.33664384E-07_JPRB, 0.33799150E-07_JPRB, &
  & 0.33785383E-07_JPRB, 0.33425051E-07_JPRB, 0.33345835E-07_JPRB, 0.33657605E-07_JPRB  /)

RGHG7(:,75,12) = (/ &
  & 0.22092104E-07_JPRB, 0.20666641E-07_JPRB, 0.19509550E-07_JPRB, 0.18973102E-07_JPRB, 0.18128675E-07_JPRB, 0.17286848E-07_JPRB, &
  & 0.15558259E-07_JPRB, 0.12054932E-07_JPRB, 0.98419120E-08_JPRB, 0.95507860E-08_JPRB, 0.96055633E-08_JPRB, 0.98454448E-08_JPRB, &
  & 0.10259542E-07_JPRB, 0.10771592E-07_JPRB, 0.11471021E-07_JPRB, 0.12345258E-07_JPRB, 0.13287663E-07_JPRB, 0.14239440E-07_JPRB, &
  & 0.15707536E-07_JPRB, 0.17217790E-07_JPRB, 0.18664702E-07_JPRB, 0.19763383E-07_JPRB, 0.20698308E-07_JPRB, 0.21352574E-07_JPRB, &
  & 0.21821767E-07_JPRB, 0.21508604E-07_JPRB, 0.20848280E-07_JPRB, 0.20088424E-07_JPRB, 0.19121625E-07_JPRB, 0.17918607E-07_JPRB, &
  & 0.17016147E-07_JPRB, 0.16638785E-07_JPRB, 0.17470798E-07_JPRB, 0.20496602E-07_JPRB, 0.24540344E-07_JPRB, 0.27225803E-07_JPRB, &
  & 0.30307348E-07_JPRB, 0.33649901E-07_JPRB, 0.36092620E-07_JPRB, 0.37946943E-07_JPRB, 0.39201500E-07_JPRB, 0.39641132E-07_JPRB, &
  & 0.40061055E-07_JPRB, 0.40121575E-07_JPRB, 0.40049994E-07_JPRB, 0.39229015E-07_JPRB, 0.38616724E-07_JPRB, 0.38159520E-07_JPRB, &
  & 0.37447863E-07_JPRB, 0.36799164E-07_JPRB, 0.35883347E-07_JPRB, 0.35032902E-07_JPRB, 0.34274386E-07_JPRB, 0.33862910E-07_JPRB, &
  & 0.33780942E-07_JPRB, 0.33558618E-07_JPRB, 0.33356619E-07_JPRB, 0.33015811E-07_JPRB, 0.32938937E-07_JPRB, 0.33007745E-07_JPRB, &
  & 0.33045850E-07_JPRB, 0.32727321E-07_JPRB, 0.32621323E-07_JPRB, 0.32988912E-07_JPRB  /)

RGHG7(:,76,12) = (/ &
  & 0.21261635E-07_JPRB, 0.19995467E-07_JPRB, 0.18957848E-07_JPRB, 0.18498173E-07_JPRB, 0.17741605E-07_JPRB, 0.16886639E-07_JPRB, &
  & 0.15204032E-07_JPRB, 0.11675252E-07_JPRB, 0.93530243E-08_JPRB, 0.90175585E-08_JPRB, 0.90316909E-08_JPRB, 0.92411914E-08_JPRB, &
  & 0.95978110E-08_JPRB, 0.10047457E-07_JPRB, 0.10683250E-07_JPRB, 0.11441301E-07_JPRB, 0.12263413E-07_JPRB, 0.13034136E-07_JPRB, &
  & 0.14329389E-07_JPRB, 0.15629850E-07_JPRB, 0.16813597E-07_JPRB, 0.17751341E-07_JPRB, 0.18560636E-07_JPRB, 0.19232556E-07_JPRB, &
  & 0.19920163E-07_JPRB, 0.19930517E-07_JPRB, 0.19376527E-07_JPRB, 0.18554677E-07_JPRB, 0.17683126E-07_JPRB, 0.16869314E-07_JPRB, &
  & 0.16166382E-07_JPRB, 0.15961453E-07_JPRB, 0.16995869E-07_JPRB, 0.20261847E-07_JPRB, 0.24406585E-07_JPRB, 0.26861724E-07_JPRB, &
  & 0.29397232E-07_JPRB, 0.32426943E-07_JPRB, 0.34886085E-07_JPRB, 0.36744513E-07_JPRB, 0.37999070E-07_JPRB, 0.38688318E-07_JPRB, &
  & 0.39292580E-07_JPRB, 0.39437675E-07_JPRB, 0.39426855E-07_JPRB, 0.38612856E-07_JPRB, 0.37959098E-07_JPRB, 0.37510106E-07_JPRB, &
  & 0.36802143E-07_JPRB, 0.36175615E-07_JPRB, 0.35277041E-07_JPRB, 0.34413869E-07_JPRB, 0.33615940E-07_JPRB, 0.33182704E-07_JPRB, &
  & 0.33090473E-07_JPRB, 0.32847621E-07_JPRB, 0.32647264E-07_JPRB, 0.32269917E-07_JPRB, 0.32189347E-07_JPRB, 0.32183435E-07_JPRB, &
  & 0.32262595E-07_JPRB, 0.31958436E-07_JPRB, 0.31810561E-07_JPRB, 0.32258208E-07_JPRB  /)

RGHG7(:,77,12) = (/ &
  & 0.20502678E-07_JPRB, 0.19365694E-07_JPRB, 0.18424765E-07_JPRB, 0.17985300E-07_JPRB, 0.17332851E-07_JPRB, 0.16475619E-07_JPRB, &
  & 0.14822273E-07_JPRB, 0.11388128E-07_JPRB, 0.89519752E-08_JPRB, 0.85616637E-08_JPRB, 0.85302272E-08_JPRB, 0.87223407E-08_JPRB, &
  & 0.90178982E-08_JPRB, 0.93935865E-08_JPRB, 0.99490386E-08_JPRB, 0.10617285E-07_JPRB, 0.11341874E-07_JPRB, 0.12000045E-07_JPRB, &
  & 0.13077732E-07_JPRB, 0.14235308E-07_JPRB, 0.15330246E-07_JPRB, 0.16234293E-07_JPRB, 0.17031089E-07_JPRB, 0.17683397E-07_JPRB, &
  & 0.18409290E-07_JPRB, 0.18587436E-07_JPRB, 0.18040985E-07_JPRB, 0.17172450E-07_JPRB, 0.16447662E-07_JPRB, 0.16008467E-07_JPRB, &
  & 0.15429716E-07_JPRB, 0.15377959E-07_JPRB, 0.16516566E-07_JPRB, 0.20011927E-07_JPRB, 0.24320711E-07_JPRB, 0.26623992E-07_JPRB, &
  & 0.28857635E-07_JPRB, 0.31652974E-07_JPRB, 0.34009505E-07_JPRB, 0.35831815E-07_JPRB, 0.37044510E-07_JPRB, 0.37869249E-07_JPRB, &
  & 0.38557009E-07_JPRB, 0.38808421E-07_JPRB, 0.38864759E-07_JPRB, 0.38023480E-07_JPRB, 0.37306734E-07_JPRB, 0.36848298E-07_JPRB, &
  & 0.36127497E-07_JPRB, 0.35512001E-07_JPRB, 0.34648688E-07_JPRB, 0.33791169E-07_JPRB, 0.32964323E-07_JPRB, 0.32504673E-07_JPRB, &
  & 0.32370832E-07_JPRB, 0.32104790E-07_JPRB, 0.31883588E-07_JPRB, 0.31438376E-07_JPRB, 0.31388812E-07_JPRB, 0.31337522E-07_JPRB, &
  & 0.31399874E-07_JPRB, 0.31082645E-07_JPRB, 0.30846879E-07_JPRB, 0.31341368E-07_JPRB  /)

RGHG7(:,78,12) = (/ &
  & 0.19750846E-07_JPRB, 0.18700454E-07_JPRB, 0.17878930E-07_JPRB, 0.17442473E-07_JPRB, 0.16891743E-07_JPRB, 0.16071191E-07_JPRB, &
  & 0.14462207E-07_JPRB, 0.11186066E-07_JPRB, 0.86403831E-08_JPRB, 0.81623283E-08_JPRB, 0.80952689E-08_JPRB, 0.82609914E-08_JPRB, &
  & 0.85113812E-08_JPRB, 0.88169814E-08_JPRB, 0.92824816E-08_JPRB, 0.98732843E-08_JPRB, 0.10529464E-07_JPRB, 0.11125280E-07_JPRB, &
  & 0.12071534E-07_JPRB, 0.13134066E-07_JPRB, 0.14174974E-07_JPRB, 0.15067784E-07_JPRB, 0.15894049E-07_JPRB, 0.16508109E-07_JPRB, &
  & 0.17199832E-07_JPRB, 0.17485548E-07_JPRB, 0.16981893E-07_JPRB, 0.16131147E-07_JPRB, 0.15499884E-07_JPRB, 0.15244848E-07_JPRB, &
  & 0.14772980E-07_JPRB, 0.14864834E-07_JPRB, 0.16073812E-07_JPRB, 0.19754540E-07_JPRB, 0.24245038E-07_JPRB, 0.26433866E-07_JPRB, &
  & 0.28444451E-07_JPRB, 0.31096542E-07_JPRB, 0.33318909E-07_JPRB, 0.35025019E-07_JPRB, 0.36246587E-07_JPRB, 0.37133666E-07_JPRB, &
  & 0.37906205E-07_JPRB, 0.38231948E-07_JPRB, 0.38334129E-07_JPRB, 0.37443691E-07_JPRB, 0.36648728E-07_JPRB, 0.36186787E-07_JPRB, &
  & 0.35412357E-07_JPRB, 0.34802218E-07_JPRB, 0.33976348E-07_JPRB, 0.33110929E-07_JPRB, 0.32280176E-07_JPRB, 0.31798978E-07_JPRB, &
  & 0.31623015E-07_JPRB, 0.31345357E-07_JPRB, 0.31084170E-07_JPRB, 0.30561160E-07_JPRB, 0.30565814E-07_JPRB, 0.30474631E-07_JPRB, &
  & 0.30490877E-07_JPRB, 0.30128179E-07_JPRB, 0.29839865E-07_JPRB, 0.30385804E-07_JPRB  /)

RGHG7(:,79,12) = (/ &
  & 0.18979424E-07_JPRB, 0.18003140E-07_JPRB, 0.17313907E-07_JPRB, 0.16898038E-07_JPRB, 0.16451304E-07_JPRB, 0.15679892E-07_JPRB, &
  & 0.14133658E-07_JPRB, 0.11047980E-07_JPRB, 0.84119515E-08_JPRB, 0.78291049E-08_JPRB, 0.77292853E-08_JPRB, 0.78650545E-08_JPRB, &
  & 0.80826781E-08_JPRB, 0.83288685E-08_JPRB, 0.87145510E-08_JPRB, 0.92330109E-08_JPRB, 0.98470166E-08_JPRB, 0.10423101E-07_JPRB, &
  & 0.11316726E-07_JPRB, 0.12323427E-07_JPRB, 0.13328247E-07_JPRB, 0.14219633E-07_JPRB, 0.15081363E-07_JPRB, 0.15654123E-07_JPRB, &
  & 0.16278841E-07_JPRB, 0.16629832E-07_JPRB, 0.16183409E-07_JPRB, 0.15393719E-07_JPRB, 0.14824774E-07_JPRB, 0.14636521E-07_JPRB, &
  & 0.14235320E-07_JPRB, 0.14422982E-07_JPRB, 0.15679473E-07_JPRB, 0.19509232E-07_JPRB, 0.24181089E-07_JPRB, 0.26289010E-07_JPRB, &
  & 0.28123269E-07_JPRB, 0.30681621E-07_JPRB, 0.32774851E-07_JPRB, 0.34343930E-07_JPRB, 0.35596810E-07_JPRB, 0.36499694E-07_JPRB, &
  & 0.37336114E-07_JPRB, 0.37711135E-07_JPRB, 0.37836889E-07_JPRB, 0.36874049E-07_JPRB, 0.35982528E-07_JPRB, 0.35516655E-07_JPRB, &
  & 0.34678357E-07_JPRB, 0.34057661E-07_JPRB, 0.33262541E-07_JPRB, 0.32384045E-07_JPRB, 0.31552933E-07_JPRB, 0.31062369E-07_JPRB, &
  & 0.30848008E-07_JPRB, 0.30559865E-07_JPRB, 0.30235677E-07_JPRB, 0.29629175E-07_JPRB, 0.29708721E-07_JPRB, 0.29586412E-07_JPRB, &
  & 0.29519572E-07_JPRB, 0.29076332E-07_JPRB, 0.28792465E-07_JPRB, 0.29395301E-07_JPRB  /)

RGHG7(:,80,12) = (/ &
  & 0.18166167E-07_JPRB, 0.17284326E-07_JPRB, 0.16725132E-07_JPRB, 0.16383293E-07_JPRB, 0.16049710E-07_JPRB, 0.15308098E-07_JPRB, &
  & 0.13844296E-07_JPRB, 0.10949372E-07_JPRB, 0.82577500E-08_JPRB, 0.75728072E-08_JPRB, 0.74339753E-08_JPRB, 0.75441493E-08_JPRB, &
  & 0.77360046E-08_JPRB, 0.79396819E-08_JPRB, 0.82771721E-08_JPRB, 0.87205886E-08_JPRB, 0.93145767E-08_JPRB, 0.99051131E-08_JPRB, &
  & 0.10806233E-07_JPRB, 0.11787043E-07_JPRB, 0.12763799E-07_JPRB, 0.13656400E-07_JPRB, 0.14523772E-07_JPRB, 0.15068602E-07_JPRB, &
  & 0.15631282E-07_JPRB, 0.16020211E-07_JPRB, 0.15612912E-07_JPRB, 0.14899993E-07_JPRB, 0.14394734E-07_JPRB, 0.14252059E-07_JPRB, &
  & 0.13860830E-07_JPRB, 0.14053624E-07_JPRB, 0.15343137E-07_JPRB, 0.19297222E-07_JPRB, 0.24132965E-07_JPRB, 0.26191175E-07_JPRB, &
  & 0.27869603E-07_JPRB, 0.30335432E-07_JPRB, 0.32339444E-07_JPRB, 0.33820190E-07_JPRB, 0.35088420E-07_JPRB, 0.35988764E-07_JPRB, &
  & 0.36837454E-07_JPRB, 0.37248950E-07_JPRB, 0.37377764E-07_JPRB, 0.36317769E-07_JPRB, 0.35308177E-07_JPRB, 0.34829335E-07_JPRB, &
  & 0.33953236E-07_JPRB, 0.33294701E-07_JPRB, 0.32514778E-07_JPRB, 0.31629383E-07_JPRB, 0.30775674E-07_JPRB, 0.30295822E-07_JPRB, &
  & 0.30049977E-07_JPRB, 0.29739990E-07_JPRB, 0.29325799E-07_JPRB, 0.28634358E-07_JPRB, 0.28806622E-07_JPRB, 0.28667580E-07_JPRB, &
  & 0.28470913E-07_JPRB, 0.27910740E-07_JPRB, 0.27706604E-07_JPRB, 0.28369699E-07_JPRB  /)

RGHG7(:,81,12) = (/ &
  & 0.17227273E-07_JPRB, 0.16616467E-07_JPRB, 0.16226143E-07_JPRB, 0.15994069E-07_JPRB, 0.15719168E-07_JPRB, 0.14978401E-07_JPRB, &
  & 0.13580035E-07_JPRB, 0.10866224E-07_JPRB, 0.81496933E-08_JPRB, 0.73820045E-08_JPRB, 0.72165757E-08_JPRB, 0.72862210E-08_JPRB, &
  & 0.74519016E-08_JPRB, 0.76446024E-08_JPRB, 0.79614061E-08_JPRB, 0.83790700E-08_JPRB, 0.89506829E-08_JPRB, 0.95787928E-08_JPRB, &
  & 0.10510731E-07_JPRB, 0.11475499E-07_JPRB, 0.12410460E-07_JPRB, 0.13270976E-07_JPRB, 0.14116817E-07_JPRB, 0.14643071E-07_JPRB, &
  & 0.15200262E-07_JPRB, 0.15601857E-07_JPRB, 0.15211867E-07_JPRB, 0.14518790E-07_JPRB, 0.14054060E-07_JPRB, 0.13977243E-07_JPRB, &
  & 0.13583059E-07_JPRB, 0.13762344E-07_JPRB, 0.15094496E-07_JPRB, 0.19141882E-07_JPRB, 0.24086545E-07_JPRB, 0.26112670E-07_JPRB, &
  & 0.27666558E-07_JPRB, 0.30011222E-07_JPRB, 0.31997504E-07_JPRB, 0.33455874E-07_JPRB, 0.34721571E-07_JPRB, 0.35626559E-07_JPRB, &
  & 0.36419100E-07_JPRB, 0.36827218E-07_JPRB, 0.36908327E-07_JPRB, 0.35733501E-07_JPRB, 0.34592612E-07_JPRB, 0.34090551E-07_JPRB, &
  & 0.33190388E-07_JPRB, 0.32476549E-07_JPRB, 0.31706758E-07_JPRB, 0.30844160E-07_JPRB, 0.30010293E-07_JPRB, 0.29500467E-07_JPRB, &
  & 0.29187496E-07_JPRB, 0.28834870E-07_JPRB, 0.28330756E-07_JPRB, 0.27507175E-07_JPRB, 0.27784559E-07_JPRB, 0.27591058E-07_JPRB, &
  & 0.27276604E-07_JPRB, 0.26559382E-07_JPRB, 0.26404219E-07_JPRB, 0.27151748E-07_JPRB  /)

RGHG7(:,82,12) = (/ &
  & 0.16543552E-07_JPRB, 0.16091814E-07_JPRB, 0.15794239E-07_JPRB, 0.15655814E-07_JPRB, 0.15433403E-07_JPRB, 0.14680094E-07_JPRB, &
  & 0.13320570E-07_JPRB, 0.10772463E-07_JPRB, 0.80497983E-08_JPRB, 0.72190887E-08_JPRB, 0.70374130E-08_JPRB, 0.70772595E-08_JPRB, &
  & 0.72279852E-08_JPRB, 0.74173420E-08_JPRB, 0.77292978E-08_JPRB, 0.81341715E-08_JPRB, 0.86922779E-08_JPRB, 0.93414330E-08_JPRB, &
  & 0.10286832E-07_JPRB, 0.11227516E-07_JPRB, 0.12124439E-07_JPRB, 0.12959474E-07_JPRB, 0.13776068E-07_JPRB, 0.14290555E-07_JPRB, &
  & 0.14844329E-07_JPRB, 0.15240183E-07_JPRB, 0.14861575E-07_JPRB, 0.14204502E-07_JPRB, 0.13774224E-07_JPRB, 0.13762555E-07_JPRB, &
  & 0.13354091E-07_JPRB, 0.13510936E-07_JPRB, 0.14883129E-07_JPRB, 0.18996169E-07_JPRB, 0.24017354E-07_JPRB, 0.26013052E-07_JPRB, &
  & 0.27473153E-07_JPRB, 0.29743093E-07_JPRB, 0.31694595E-07_JPRB, 0.33155165E-07_JPRB, 0.34419218E-07_JPRB, 0.35330856E-07_JPRB, &
  & 0.36072551E-07_JPRB, 0.36432812E-07_JPRB, 0.36452849E-07_JPRB, 0.35150836E-07_JPRB, 0.33874546E-07_JPRB, 0.33351740E-07_JPRB, &
  & 0.32447446E-07_JPRB, 0.31687672E-07_JPRB, 0.30892463E-07_JPRB, 0.30101091E-07_JPRB, 0.29279668E-07_JPRB, 0.28742386E-07_JPRB, &
  & 0.28318216E-07_JPRB, 0.27904025E-07_JPRB, 0.27325397E-07_JPRB, 0.26377791E-07_JPRB, 0.26713378E-07_JPRB, 0.26481180E-07_JPRB, &
  & 0.26028168E-07_JPRB, 0.25124360E-07_JPRB, 0.24969282E-07_JPRB, 0.25834738E-07_JPRB  /)

RGHG7(:,83,12) = (/ &
  & 0.16083046E-07_JPRB, 0.15681572E-07_JPRB, 0.15407293E-07_JPRB, 0.15348849E-07_JPRB, 0.15182383E-07_JPRB, 0.14419957E-07_JPRB, &
  & 0.13073130E-07_JPRB, 0.10670682E-07_JPRB, 0.79542866E-08_JPRB, 0.70756246E-08_JPRB, 0.68847189E-08_JPRB, 0.69057304E-08_JPRB, &
  & 0.70534015E-08_JPRB, 0.72467865E-08_JPRB, 0.75635614E-08_JPRB, 0.79637806E-08_JPRB, 0.85097417E-08_JPRB, 0.91685955E-08_JPRB, &
  & 0.10116112E-07_JPRB, 0.11026764E-07_JPRB, 0.11893782E-07_JPRB, 0.12711350E-07_JPRB, 0.13502428E-07_JPRB, 0.14013980E-07_JPRB, &
  & 0.14566064E-07_JPRB, 0.14944002E-07_JPRB, 0.14580413E-07_JPRB, 0.13978913E-07_JPRB, 0.13578155E-07_JPRB, 0.13621453E-07_JPRB, &
  & 0.13184671E-07_JPRB, 0.13305158E-07_JPRB, 0.14713780E-07_JPRB, 0.18864273E-07_JPRB, 0.23927940E-07_JPRB, 0.25893783E-07_JPRB, &
  & 0.27285458E-07_JPRB, 0.29511796E-07_JPRB, 0.31424186E-07_JPRB, 0.32901196E-07_JPRB, 0.34166740E-07_JPRB, 0.35077970E-07_JPRB, &
  & 0.35778342E-07_JPRB, 0.36073406E-07_JPRB, 0.36029628E-07_JPRB, 0.34596076E-07_JPRB, 0.33173198E-07_JPRB, 0.32615213E-07_JPRB, &
  & 0.31726290E-07_JPRB, 0.30944254E-07_JPRB, 0.30108281E-07_JPRB, 0.29391435E-07_JPRB, 0.28609778E-07_JPRB, 0.28023410E-07_JPRB, &
  & 0.27462692E-07_JPRB, 0.26954866E-07_JPRB, 0.26317875E-07_JPRB, 0.25267228E-07_JPRB, 0.25586274E-07_JPRB, 0.25337769E-07_JPRB, &
  & 0.24740984E-07_JPRB, 0.23630060E-07_JPRB, 0.23417514E-07_JPRB, 0.24391627E-07_JPRB  /)

RGHG7(:,84,12) = (/ &
  & 0.15803884E-07_JPRB, 0.15358424E-07_JPRB, 0.15048422E-07_JPRB, 0.15057589E-07_JPRB, 0.14958702E-07_JPRB, 0.14201630E-07_JPRB, &
  & 0.12844175E-07_JPRB, 0.10563463E-07_JPRB, 0.78601338E-08_JPRB, 0.69444644E-08_JPRB, 0.67486864E-08_JPRB, 0.67621018E-08_JPRB, &
  & 0.69180204E-08_JPRB, 0.71214519E-08_JPRB, 0.74465092E-08_JPRB, 0.78462898E-08_JPRB, 0.83763884E-08_JPRB, 0.90378865E-08_JPRB, &
  & 0.99816115E-08_JPRB, 0.10858365E-07_JPRB, 0.11706135E-07_JPRB, 0.12513866E-07_JPRB, 0.13290366E-07_JPRB, 0.13808347E-07_JPRB, &
  & 0.14359869E-07_JPRB, 0.14714278E-07_JPRB, 0.14375670E-07_JPRB, 0.13846399E-07_JPRB, 0.13469868E-07_JPRB, 0.13550721E-07_JPRB, &
  & 0.13071786E-07_JPRB, 0.13141275E-07_JPRB, 0.14580532E-07_JPRB, 0.18741952E-07_JPRB, 0.23817709E-07_JPRB, 0.25756419E-07_JPRB, &
  & 0.27100595E-07_JPRB, 0.29300131E-07_JPRB, 0.31179001E-07_JPRB, 0.32677003E-07_JPRB, 0.33948948E-07_JPRB, 0.34846172E-07_JPRB, &
  & 0.35516208E-07_JPRB, 0.35750916E-07_JPRB, 0.35651255E-07_JPRB, 0.34090616E-07_JPRB, 0.32507100E-07_JPRB, 0.31886796E-07_JPRB, &
  & 0.31029039E-07_JPRB, 0.30257060E-07_JPRB, 0.29383297E-07_JPRB, 0.28715399E-07_JPRB, 0.28018677E-07_JPRB, 0.27345209E-07_JPRB, &
  & 0.26638795E-07_JPRB, 0.26002324E-07_JPRB, 0.25319458E-07_JPRB, 0.24196322E-07_JPRB, 0.24406479E-07_JPRB, 0.24169578E-07_JPRB, &
  & 0.23436135E-07_JPRB, 0.22107022E-07_JPRB, 0.21781420E-07_JPRB, 0.22823895E-07_JPRB  /)

RGHG7(:,85,12) = (/ &
  & 0.15608685E-07_JPRB, 0.15096410E-07_JPRB, 0.14703421E-07_JPRB, 0.14756422E-07_JPRB, 0.14765205E-07_JPRB, 0.14014091E-07_JPRB, &
  & 0.12633230E-07_JPRB, 0.10439760E-07_JPRB, 0.77555812E-08_JPRB, 0.68126752E-08_JPRB, 0.66190250E-08_JPRB, 0.66469099E-08_JPRB, &
  & 0.68185747E-08_JPRB, 0.70292408E-08_JPRB, 0.73513192E-08_JPRB, 0.77566322E-08_JPRB, 0.82722614E-08_JPRB, 0.89265247E-08_JPRB, &
  & 0.98647173E-08_JPRB, 0.10701892E-07_JPRB, 0.11536470E-07_JPRB, 0.12327604E-07_JPRB, 0.13085378E-07_JPRB, 0.13614425E-07_JPRB, &
  & 0.14162967E-07_JPRB, 0.14503333E-07_JPRB, 0.14196643E-07_JPRB, 0.13704822E-07_JPRB, 0.13328291E-07_JPRB, 0.13419783E-07_JPRB, &
  & 0.12898290E-07_JPRB, 0.12925223E-07_JPRB, 0.14368735E-07_JPRB, 0.18519941E-07_JPRB, 0.23617828E-07_JPRB, 0.25572284E-07_JPRB, &
  & 0.26900289E-07_JPRB, 0.29069609E-07_JPRB, 0.30921668E-07_JPRB, 0.32429884E-07_JPRB, 0.33718852E-07_JPRB, 0.34581179E-07_JPRB, &
  & 0.35213338E-07_JPRB, 0.35403362E-07_JPRB, 0.35288806E-07_JPRB, 0.33628583E-07_JPRB, 0.31873137E-07_JPRB, 0.31136652E-07_JPRB, &
  & 0.30298470E-07_JPRB, 0.29566069E-07_JPRB, 0.28690605E-07_JPRB, 0.28114630E-07_JPRB, 0.27474934E-07_JPRB, 0.26663156E-07_JPRB, &
  & 0.25796727E-07_JPRB, 0.25047479E-07_JPRB, 0.24279073E-07_JPRB, 0.23126999E-07_JPRB, 0.23091601E-07_JPRB, 0.22926621E-07_JPRB, &
  & 0.22055719E-07_JPRB, 0.20492542E-07_JPRB, 0.20051184E-07_JPRB, 0.21124300E-07_JPRB  /)

RGHG7(:,86,12) = (/ &
  & 0.15466298E-07_JPRB, 0.14881209E-07_JPRB, 0.14369181E-07_JPRB, 0.14451584E-07_JPRB, 0.14570579E-07_JPRB, 0.13828118E-07_JPRB, &
  & 0.12431724E-07_JPRB, 0.10314281E-07_JPRB, 0.76443548E-08_JPRB, 0.66787369E-08_JPRB, 0.65025443E-08_JPRB, 0.65516322E-08_JPRB, &
  & 0.67367915E-08_JPRB, 0.69527308E-08_JPRB, 0.72724812E-08_JPRB, 0.76790253E-08_JPRB, 0.81834422E-08_JPRB, 0.88254389E-08_JPRB, &
  & 0.97580711E-08_JPRB, 0.10555468E-07_JPRB, 0.11384446E-07_JPRB, 0.12153903E-07_JPRB, 0.12897520E-07_JPRB, 0.13428363E-07_JPRB, &
  & 0.13971913E-07_JPRB, 0.14311485E-07_JPRB, 0.14030879E-07_JPRB, 0.13564709E-07_JPRB, 0.13180186E-07_JPRB, 0.13267718E-07_JPRB, &
  & 0.12722435E-07_JPRB, 0.12734569E-07_JPRB, 0.14151055E-07_JPRB, 0.18263689E-07_JPRB, 0.23369497E-07_JPRB, 0.25339446E-07_JPRB, &
  & 0.26658191E-07_JPRB, 0.28780492E-07_JPRB, 0.30617260E-07_JPRB, 0.32122420E-07_JPRB, 0.33425167E-07_JPRB, 0.34233105E-07_JPRB, &
  & 0.34819205E-07_JPRB, 0.34996621E-07_JPRB, 0.34883746E-07_JPRB, 0.33145082E-07_JPRB, 0.31267788E-07_JPRB, 0.30431519E-07_JPRB, &
  & 0.29569054E-07_JPRB, 0.28886755E-07_JPRB, 0.28031226E-07_JPRB, 0.27532653E-07_JPRB, 0.26960929E-07_JPRB, 0.25964517E-07_JPRB, &
  & 0.24929938E-07_JPRB, 0.24065678E-07_JPRB, 0.23245601E-07_JPRB, 0.22144367E-07_JPRB, 0.21775255E-07_JPRB, 0.21686556E-07_JPRB, &
  & 0.20681163E-07_JPRB, 0.18935689E-07_JPRB, 0.18287409E-07_JPRB, 0.19271100E-07_JPRB  /)

RGHG7(:,87,12) = (/ &
  & 0.15369687E-07_JPRB, 0.14682403E-07_JPRB, 0.14043396E-07_JPRB, 0.14126817E-07_JPRB, 0.14363645E-07_JPRB, 0.13622315E-07_JPRB, &
  & 0.12215337E-07_JPRB, 0.10186601E-07_JPRB, 0.75228330E-08_JPRB, 0.65428119E-08_JPRB, 0.64011915E-08_JPRB, 0.64732941E-08_JPRB, &
  & 0.66701553E-08_JPRB, 0.68882123E-08_JPRB, 0.72055689E-08_JPRB, 0.76096739E-08_JPRB, 0.81049953E-08_JPRB, 0.87313170E-08_JPRB, &
  & 0.96560845E-08_JPRB, 0.10416629E-07_JPRB, 0.11239470E-07_JPRB, 0.11989683E-07_JPRB, 0.12713171E-07_JPRB, 0.13241593E-07_JPRB, &
  & 0.13780605E-07_JPRB, 0.14127652E-07_JPRB, 0.13856730E-07_JPRB, 0.13414258E-07_JPRB, 0.13018422E-07_JPRB, 0.13089053E-07_JPRB, &
  & 0.12533516E-07_JPRB, 0.12538921E-07_JPRB, 0.13904060E-07_JPRB, 0.17962026E-07_JPRB, 0.23025844E-07_JPRB, 0.25026067E-07_JPRB, &
  & 0.26346961E-07_JPRB, 0.28416255E-07_JPRB, 0.30209151E-07_JPRB, 0.31685631E-07_JPRB, 0.32982341E-07_JPRB, 0.33719040E-07_JPRB, &
  & 0.34262038E-07_JPRB, 0.34442631E-07_JPRB, 0.34346915E-07_JPRB, 0.32569648E-07_JPRB, 0.30621234E-07_JPRB, 0.29716464E-07_JPRB, &
  & 0.28813979E-07_JPRB, 0.28210825E-07_JPRB, 0.27402638E-07_JPRB, 0.26939989E-07_JPRB, 0.26452129E-07_JPRB, 0.25230850E-07_JPRB, &
  & 0.24022266E-07_JPRB, 0.23003020E-07_JPRB, 0.22155671E-07_JPRB, 0.21201663E-07_JPRB, 0.20515079E-07_JPRB, 0.20472857E-07_JPRB, &
  & 0.19352548E-07_JPRB, 0.17463606E-07_JPRB, 0.16478338E-07_JPRB, 0.17322958E-07_JPRB  /)

RGHG7(:,88,12) = (/ &
  & 0.15305892E-07_JPRB, 0.14479994E-07_JPRB, 0.13707247E-07_JPRB, 0.13756002E-07_JPRB, 0.14116089E-07_JPRB, 0.13368789E-07_JPRB, &
  & 0.11963449E-07_JPRB, 0.10048309E-07_JPRB, 0.73847410E-08_JPRB, 0.64075980E-08_JPRB, 0.63158403E-08_JPRB, 0.64091127E-08_JPRB, &
  & 0.66165005E-08_JPRB, 0.68331854E-08_JPRB, 0.71480740E-08_JPRB, 0.75462571E-08_JPRB, 0.80336508E-08_JPRB, 0.86403318E-08_JPRB, &
  & 0.95539795E-08_JPRB, 0.10281193E-07_JPRB, 0.11086288E-07_JPRB, 0.11818741E-07_JPRB, 0.12510221E-07_JPRB, 0.13037037E-07_JPRB, &
  & 0.13575423E-07_JPRB, 0.13926238E-07_JPRB, 0.13646249E-07_JPRB, 0.13234297E-07_JPRB, 0.12826770E-07_JPRB, 0.12861185E-07_JPRB, &
  & 0.12306387E-07_JPRB, 0.12297105E-07_JPRB, 0.13593673E-07_JPRB, 0.17573797E-07_JPRB, 0.22528530E-07_JPRB, 0.24585905E-07_JPRB, &
  & 0.25945227E-07_JPRB, 0.27949255E-07_JPRB, 0.29630151E-07_JPRB, 0.31029737E-07_JPRB, 0.32258646E-07_JPRB, 0.32914063E-07_JPRB, &
  & 0.33419374E-07_JPRB, 0.33592550E-07_JPRB, 0.33521043E-07_JPRB, 0.31774872E-07_JPRB, 0.29831463E-07_JPRB, 0.28913936E-07_JPRB, &
  & 0.27974593E-07_JPRB, 0.27525584E-07_JPRB, 0.26776259E-07_JPRB, 0.26320299E-07_JPRB, 0.25927233E-07_JPRB, 0.24430173E-07_JPRB, &
  & 0.23024996E-07_JPRB, 0.21775028E-07_JPRB, 0.20931387E-07_JPRB, 0.20214112E-07_JPRB, 0.19327094E-07_JPRB, 0.19277798E-07_JPRB, &
  & 0.18053131E-07_JPRB, 0.16065458E-07_JPRB, 0.14646424E-07_JPRB, 0.15322103E-07_JPRB  /)

RGHG7(:,89,12) = (/ &
  & 0.15250924E-07_JPRB, 0.14267200E-07_JPRB, 0.13334951E-07_JPRB, 0.13312319E-07_JPRB, 0.13785104E-07_JPRB, 0.13043494E-07_JPRB, &
  & 0.11669100E-07_JPRB, 0.98873966E-08_JPRB, 0.72285232E-08_JPRB, 0.62869025E-08_JPRB, 0.62490704E-08_JPRB, 0.63574519E-08_JPRB, &
  & 0.65744771E-08_JPRB, 0.67871631E-08_JPRB, 0.71003311E-08_JPRB, 0.74897491E-08_JPRB, 0.79695167E-08_JPRB, 0.85526333E-08_JPRB, &
  & 0.94508290E-08_JPRB, 0.10146300E-07_JPRB, 0.10906997E-07_JPRB, 0.11614485E-07_JPRB, 0.12261724E-07_JPRB, 0.12794050E-07_JPRB, &
  & 0.13337665E-07_JPRB, 0.13666899E-07_JPRB, 0.13367512E-07_JPRB, 0.13003126E-07_JPRB, 0.12584827E-07_JPRB, 0.12556037E-07_JPRB, &
  & 0.12009694E-07_JPRB, 0.11967578E-07_JPRB, 0.13200829E-07_JPRB, 0.17055282E-07_JPRB, 0.21846161E-07_JPRB, 0.23986589E-07_JPRB, &
  & 0.25470422E-07_JPRB, 0.27378330E-07_JPRB, 0.28836100E-07_JPRB, 0.30065658E-07_JPRB, 0.31086481E-07_JPRB, 0.31662997E-07_JPRB, &
  & 0.32117816E-07_JPRB, 0.32241556E-07_JPRB, 0.32170614E-07_JPRB, 0.30571155E-07_JPRB, 0.28763214E-07_JPRB, 0.27939117E-07_JPRB, &
  & 0.26999710E-07_JPRB, 0.26844896E-07_JPRB, 0.26128453E-07_JPRB, 0.25714487E-07_JPRB, 0.25396458E-07_JPRB, 0.23590222E-07_JPRB, &
  & 0.21918124E-07_JPRB, 0.20334439E-07_JPRB, 0.19552399E-07_JPRB, 0.19098442E-07_JPRB, 0.18266250E-07_JPRB, 0.18125502E-07_JPRB, &
  & 0.16772232E-07_JPRB, 0.14759273E-07_JPRB, 0.12984784E-07_JPRB, 0.13456020E-07_JPRB  /)

RGHG7(:,90,12) = (/ &
  & 0.15188578E-07_JPRB, 0.14036808E-07_JPRB, 0.12887847E-07_JPRB, 0.12739915E-07_JPRB, 0.13317812E-07_JPRB, 0.12645115E-07_JPRB, &
  & 0.11331835E-07_JPRB, 0.96882094E-08_JPRB, 0.70558792E-08_JPRB, 0.61874764E-08_JPRB, 0.61963765E-08_JPRB, 0.63162202E-08_JPRB, &
  & 0.65406696E-08_JPRB, 0.67478832E-08_JPRB, 0.70604666E-08_JPRB, 0.74394235E-08_JPRB, 0.79111824E-08_JPRB, 0.84748616E-08_JPRB, &
  & 0.93416538E-08_JPRB, 0.99938182E-08_JPRB, 0.10684207E-07_JPRB, 0.11354137E-07_JPRB, 0.11948853E-07_JPRB, 0.12491132E-07_JPRB, &
  & 0.13026889E-07_JPRB, 0.13309458E-07_JPRB, 0.12995566E-07_JPRB, 0.12707079E-07_JPRB, 0.12268993E-07_JPRB, 0.12174594E-07_JPRB, &
  & 0.11636260E-07_JPRB, 0.11581338E-07_JPRB, 0.12807562E-07_JPRB, 0.16461367E-07_JPRB, 0.21078798E-07_JPRB, 0.23274962E-07_JPRB, &
  & 0.24995826E-07_JPRB, 0.26778372E-07_JPRB, 0.27882703E-07_JPRB, 0.28756511E-07_JPRB, 0.29367279E-07_JPRB, 0.29831611E-07_JPRB, &
  & 0.30111191E-07_JPRB, 0.30214323E-07_JPRB, 0.30062038E-07_JPRB, 0.28737317E-07_JPRB, 0.27229696E-07_JPRB, 0.26694520E-07_JPRB, &
  & 0.25897925E-07_JPRB, 0.26153601E-07_JPRB, 0.25485656E-07_JPRB, 0.25221743E-07_JPRB, 0.24901756E-07_JPRB, 0.22921696E-07_JPRB, &
  & 0.20780679E-07_JPRB, 0.18761258E-07_JPRB, 0.18137847E-07_JPRB, 0.17891852E-07_JPRB, 0.17419040E-07_JPRB, 0.17032993E-07_JPRB, &
  & 0.15480873E-07_JPRB, 0.13514688E-07_JPRB, 0.11735177E-07_JPRB, 0.11975832E-07_JPRB  /)

RGHG7(:,91,12) = (/ &
  & 0.15090871E-07_JPRB, 0.13704801E-07_JPRB, 0.12221051E-07_JPRB, 0.11813961E-07_JPRB, 0.12563749E-07_JPRB, 0.12050248E-07_JPRB, &
  & 0.10863903E-07_JPRB, 0.94096212E-08_JPRB, 0.68666739E-08_JPRB, 0.60950586E-08_JPRB, 0.61436256E-08_JPRB, 0.62740471E-08_JPRB, &
  & 0.65037855E-08_JPRB, 0.67062390E-08_JPRB, 0.70156491E-08_JPRB, 0.73850859E-08_JPRB, 0.78483825E-08_JPRB, 0.83940794E-08_JPRB, &
  & 0.92164445E-08_JPRB, 0.97845149E-08_JPRB, 0.10408792E-07_JPRB, 0.11038526E-07_JPRB, 0.11578766E-07_JPRB, 0.12099361E-07_JPRB, &
  & 0.12631415E-07_JPRB, 0.12876433E-07_JPRB, 0.12593217E-07_JPRB, 0.12379303E-07_JPRB, 0.11927466E-07_JPRB, 0.11747386E-07_JPRB, &
  & 0.11217515E-07_JPRB, 0.11185864E-07_JPRB, 0.12464978E-07_JPRB, 0.15924150E-07_JPRB, 0.20396136E-07_JPRB, 0.22686971E-07_JPRB, &
  & 0.24605641E-07_JPRB, 0.26294573E-07_JPRB, 0.27084742E-07_JPRB, 0.27465093E-07_JPRB, 0.27685008E-07_JPRB, 0.27907107E-07_JPRB, &
  & 0.27436716E-07_JPRB, 0.27728664E-07_JPRB, 0.27832892E-07_JPRB, 0.26309307E-07_JPRB, 0.25012185E-07_JPRB, 0.24876853E-07_JPRB, &
  & 0.24616555E-07_JPRB, 0.25413818E-07_JPRB, 0.24917234E-07_JPRB, 0.24762802E-07_JPRB, 0.24487771E-07_JPRB, 0.22396115E-07_JPRB, &
  & 0.19732023E-07_JPRB, 0.17426999E-07_JPRB, 0.16848015E-07_JPRB, 0.16828915E-07_JPRB, 0.16537513E-07_JPRB, 0.16332877E-07_JPRB, &
  & 0.14140267E-07_JPRB, 0.11606051E-07_JPRB, 0.11114924E-07_JPRB, 0.11132386E-07_JPRB  /)


IF (LHOOK) CALL DR_HOOK('SU_GOZOCLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24




 END SUBROUTINE SU_GOZOCLIM
