!option! -Nv -NO
#ifdef VPP
!OCL SCALAR
#endif
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE SU_MCICA

!**** *SU_MCICA*   - INITIALIZE COMMON YOE_MCICA

!     PURPOSE.
!     --------
!           INITIALIZE YOE_MCICA, THE COMMON THAT CONTAINS COEFFICIENTS
!           NEEDED TO RUN THE RAISANEN-COLE-BARKER VERSION OF McICA

!**   INTERFACE.
!     ----------
!        *CALL* *SU_MCICA* FROM *SUECRAD*


!        IMPLICIT ARGUMENTS :
!        --------------------
!        COMMON YOE_MCICA


!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE IFS

!     AUTHOR.
!     -------
!        JEAN-JACQUES MORCRETTE *ECMWF*
!        from Jason Cole's XCW_DATA.dat

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 2006-01-05

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOE_MCICA, ONLY : NMCI1, NMCI2, XCW

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ----------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_MCICA',0,ZHOOK_HANDLE)

NMCI1 = 1000
NMCI2 = 140

CALL PART1
CALL PART2
CALL PART3
CALL PART4
CALL PART5
CALL PART6
CALL PART7
CALL PART8
CALL PART9
CALL PART10
CALL PART11
CALL PART12
CALL PART13
CALL PART14
CALL PART15
CALL PART16
CALL PART17
CALL PART18
CALL PART19
CALL PART20
CALL PART21
CALL PART22
CALL PART23
CALL PART24
CALL PART25
CALL PART26
CALL PART27
CALL PART28
CALL PART29
CALL PART30
CALL PART31
CALL PART32
CALL PART33
CALL PART34
CALL PART35
CALL PART36
CALL PART37
CALL PART38
CALL PART39
CALL PART40
CALL PART41
CALL PART42
CALL PART43
CALL PART44
CALL PART45
CALL PART46
CALL PART47
CALL PART48
CALL PART49
CALL PART50
CALL PART51
CALL PART52
CALL PART53
CALL PART54
CALL PART55
CALL PART56
CALL PART57
CALL PART58
CALL PART59
CALL PART60
CALL PART61
CALL PART62
CALL PART63
CALL PART64
CALL PART65
CALL PART66
CALL PART67
CALL PART68
CALL PART69
CALL PART70
CALL PART71
CALL PART72
CALL PART73
CALL PART74
CALL PART75
CALL PART76
CALL PART77
CALL PART78
CALL PART79
CALL PART80
CALL PART81
CALL PART82
CALL PART83
CALL PART84
CALL PART85
CALL PART86
CALL PART87
CALL PART88
CALL PART89
CALL PART90
CALL PART91
CALL PART92
CALL PART93
CALL PART94
CALL PART95
CALL PART96
CALL PART97
CALL PART98
CALL PART99
CALL PART100
CALL PART101
CALL PART102
CALL PART103
CALL PART104
CALL PART105
CALL PART106
CALL PART107
CALL PART108
CALL PART109
CALL PART110
CALL PART111
CALL PART112
CALL PART113
CALL PART114
CALL PART115
CALL PART116
CALL PART117
CALL PART118
CALL PART119
CALL PART120
CALL PART121
CALL PART122
CALL PART123
CALL PART124
CALL PART125
CALL PART126
CALL PART127
CALL PART128
CALL PART129
CALL PART130
CALL PART131
CALL PART132
CALL PART133
CALL PART134
CALL PART135
CALL PART136
CALL PART137
CALL PART138
CALL PART139
CALL PART140
CALL PART141
CALL PART142
CALL PART143

  
!     ----------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SU_MCICA',1,ZHOOK_HANDLE)

CONTAINS

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART1

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART1',0,ZHOOK_HANDLE)

XCW(   1, :) = (/ &
  &  0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   2, :) = (/ &
  &  0.719238E+00_JPRB, 0.657746E+00_JPRB, 0.599658E+00_JPRB, 0.544932E+00_JPRB &
  &, 0.493515E+00_JPRB, 0.445349E+00_JPRB, 0.400372E+00_JPRB &
  &, 0.358514E+00_JPRB, 0.319698E+00_JPRB, 0.283841E+00_JPRB, 0.250852E+00_JPRB &
  &, 0.220633E+00_JPRB, 0.193079E+00_JPRB, 0.168076E+00_JPRB &
  &, 0.145509E+00_JPRB, 0.125249E+00_JPRB, 0.107167E+00_JPRB, 0.911265E-01_JPRB &
  &, 0.769881E-01_JPRB, 0.646107E-01_JPRB, 0.538483E-01_JPRB &
  &, 0.445637E-01_JPRB, 0.366111E-01_JPRB, 0.298526E-01_JPRB, 0.241559E-01_JPRB &
  &, 0.193935E-01_JPRB, 0.154439E-01_JPRB, 0.122027E-01_JPRB &
  &, 0.956228E-02_JPRB, 0.743081E-02_JPRB, 0.572660E-02_JPRB, 0.437533E-02_JPRB &
  &, 0.331126E-02_JPRB, 0.248752E-02_JPRB, 0.185158E-02_JPRB &
  &, 0.136799E-02_JPRB, 0.992284E-03_JPRB, 0.723804E-03_JPRB, 0.521300E-03_JPRB &
  &, 0.369758E-03_JPRB, 0.262914E-03_JPRB, 0.182853E-03_JPRB &
  &, 0.120745E-03_JPRB, 0.781102E-04_JPRB, 0.565393E-04_JPRB, 0.338478E-04_JPRB &
  &, 0.222189E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   3, :) = (/ &
  &  0.736354E+00_JPRB, 0.677916E+00_JPRB, 0.622423E+00_JPRB, 0.569848E+00_JPRB &
  &, 0.520155E+00_JPRB, 0.473308E+00_JPRB, 0.429266E+00_JPRB &
  &, 0.387977E+00_JPRB, 0.349393E+00_JPRB, 0.313452E+00_JPRB, 0.280090E+00_JPRB &
  &, 0.249239E+00_JPRB, 0.220818E+00_JPRB, 0.194749E+00_JPRB &
  &, 0.170941E+00_JPRB, 0.149301E+00_JPRB, 0.129726E+00_JPRB, 0.112113E+00_JPRB &
  &, 0.963518E-01_JPRB, 0.823288E-01_JPRB, 0.699278E-01_JPRB &
  &, 0.590260E-01_JPRB, 0.495089E-01_JPRB, 0.412566E-01_JPRB, 0.341524E-01_JPRB &
  &, 0.280759E-01_JPRB, 0.229205E-01_JPRB, 0.185757E-01_JPRB &
  &, 0.149503E-01_JPRB, 0.119426E-01_JPRB, 0.946786E-02_JPRB, 0.744832E-02_JPRB &
  &, 0.581849E-02_JPRB, 0.450936E-02_JPRB, 0.346636E-02_JPRB &
  &, 0.264227E-02_JPRB, 0.200318E-02_JPRB, 0.149628E-02_JPRB, 0.111280E-02_JPRB &
  &, 0.822026E-03_JPRB, 0.600133E-03_JPRB, 0.442133E-03_JPRB &
  &, 0.309012E-03_JPRB, 0.225682E-03_JPRB, 0.161253E-03_JPRB, 0.105391E-03_JPRB &
  &, 0.710947E-04_JPRB, 0.475598E-04_JPRB, 0.356538E-04_JPRB &
  &, 0.231398E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   4, :) = (/ &
  &  0.747015E+00_JPRB, 0.690526E+00_JPRB, 0.636713E+00_JPRB, 0.585555E+00_JPRB &
  &, 0.537027E+00_JPRB, 0.491103E+00_JPRB, 0.447751E+00_JPRB &
  &, 0.406935E+00_JPRB, 0.368614E+00_JPRB, 0.332744E+00_JPRB, 0.299273E+00_JPRB &
  &, 0.268143E+00_JPRB, 0.239300E+00_JPRB, 0.212671E+00_JPRB &
  &, 0.188187E+00_JPRB, 0.165768E+00_JPRB, 0.145335E+00_JPRB, 0.126795E+00_JPRB &
  &, 0.110061E+00_JPRB, 0.950281E-01_JPRB, 0.816072E-01_JPRB &
  &, 0.696853E-01_JPRB, 0.591577E-01_JPRB, 0.499224E-01_JPRB, 0.418719E-01_JPRB &
  &, 0.348996E-01_JPRB, 0.289033E-01_JPRB, 0.237772E-01_JPRB &
  &, 0.194313E-01_JPRB, 0.157732E-01_JPRB, 0.127163E-01_JPRB, 0.101803E-01_JPRB &
  &, 0.808838E-02_JPRB, 0.638520E-02_JPRB, 0.500403E-02_JPRB &
  &, 0.388864E-02_JPRB, 0.300453E-02_JPRB, 0.229808E-02_JPRB, 0.175444E-02_JPRB &
  &, 0.132569E-02_JPRB, 0.990042E-03_JPRB, 0.733823E-03_JPRB &
  &, 0.541578E-03_JPRB, 0.395958E-03_JPRB, 0.289236E-03_JPRB, 0.200782E-03_JPRB &
  &, 0.144408E-03_JPRB, 0.976396E-04_JPRB, 0.741345E-04_JPRB &
  &, 0.494195E-04_JPRB, 0.369174E-04_JPRB, 0.237836E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   5, :) = (/ &
  &  0.754906E+00_JPRB, 0.699885E+00_JPRB, 0.647346E+00_JPRB, 0.597275E+00_JPRB &
  &, 0.549655E+00_JPRB, 0.504464E+00_JPRB, 0.461678E+00_JPRB &
  &, 0.421269E+00_JPRB, 0.383205E+00_JPRB, 0.347448E+00_JPRB, 0.313958E+00_JPRB &
  &, 0.282687E+00_JPRB, 0.253587E+00_JPRB, 0.226601E+00_JPRB &
  &, 0.201668E+00_JPRB, 0.178721E+00_JPRB, 0.157691E+00_JPRB, 0.138500E+00_JPRB &
  &, 0.121068E+00_JPRB, 0.105310E+00_JPRB, 0.911369E-01_JPRB &
  &, 0.784581E-01_JPRB, 0.671787E-01_JPRB, 0.572000E-01_JPRB, 0.484225E-01_JPRB &
  &, 0.407522E-01_JPRB, 0.340926E-01_JPRB, 0.283452E-01_JPRB &
  &, 0.234156E-01_JPRB, 0.192232E-01_JPRB, 0.156814E-01_JPRB, 0.127061E-01_JPRB &
  &, 0.102245E-01_JPRB, 0.817698E-02_JPRB, 0.649181E-02_JPRB &
  &, 0.511641E-02_JPRB, 0.400589E-02_JPRB, 0.311945E-02_JPRB, 0.240609E-02_JPRB &
  &, 0.183963E-02_JPRB, 0.140103E-02_JPRB, 0.105792E-02_JPRB &
  &, 0.796292E-03_JPRB, 0.588936E-03_JPRB, 0.440488E-03_JPRB, 0.320021E-03_JPRB &
  &, 0.229941E-03_JPRB, 0.160239E-03_JPRB, 0.112615E-03_JPRB &
  &, 0.756992E-04_JPRB, 0.503762E-04_JPRB, 0.375671E-04_JPRB, 0.241144E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   6, :) = (/ &
  &  0.761234E+00_JPRB, 0.707403E+00_JPRB, 0.655904E+00_JPRB, 0.606728E+00_JPRB &
  &, 0.559862E+00_JPRB, 0.515289E+00_JPRB, 0.472990E+00_JPRB &
  &, 0.432943E+00_JPRB, 0.395121E+00_JPRB, 0.359494E+00_JPRB, 0.326027E+00_JPRB &
  &, 0.294681E+00_JPRB, 0.265414E+00_JPRB, 0.238177E+00_JPRB &
  &, 0.212918E+00_JPRB, 0.189579E+00_JPRB, 0.168099E+00_JPRB, 0.148410E+00_JPRB &
  &, 0.130440E+00_JPRB, 0.114114E+00_JPRB, 0.993501E-01_JPRB &
  &, 0.860705E-01_JPRB, 0.741787E-01_JPRB, 0.635961E-01_JPRB, 0.542272E-01_JPRB &
  &, 0.459791E-01_JPRB, 0.387641E-01_JPRB, 0.324933E-01_JPRB &
  &, 0.270715E-01_JPRB, 0.224207E-01_JPRB, 0.184534E-01_JPRB, 0.150929E-01_JPRB &
  &, 0.122657E-01_JPRB, 0.990682E-02_JPRB, 0.794784E-02_JPRB &
  &, 0.633488E-02_JPRB, 0.501679E-02_JPRB, 0.394081E-02_JPRB, 0.307780E-02_JPRB &
  &, 0.238441E-02_JPRB, 0.184363E-02_JPRB, 0.140363E-02_JPRB &
  &, 0.107316E-02_JPRB, 0.804619E-03_JPRB, 0.603376E-03_JPRB, 0.451184E-03_JPRB &
  &, 0.327692E-03_JPRB, 0.235359E-03_JPRB, 0.176750E-03_JPRB &
  &, 0.128259E-03_JPRB, 0.907523E-04_JPRB, 0.651343E-04_JPRB, 0.382287E-04_JPRB &
  &, 0.244511E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   7, :) = (/ &
  &  0.766547E+00_JPRB, 0.713724E+00_JPRB, 0.663112E+00_JPRB, 0.614703E+00_JPRB &
  &, 0.568488E+00_JPRB, 0.524455E+00_JPRB, 0.482589E+00_JPRB &
  &, 0.442870E+00_JPRB, 0.405277E+00_JPRB, 0.369786E+00_JPRB, 0.336366E+00_JPRB &
  &, 0.304984E+00_JPRB, 0.275603E+00_JPRB, 0.248182E+00_JPRB &
  &, 0.222674E+00_JPRB, 0.199029E+00_JPRB, 0.177192E+00_JPRB, 0.157102E+00_JPRB &
  &, 0.138695E+00_JPRB, 0.121902E+00_JPRB, 0.106652E+00_JPRB &
  &, 0.928706E-01_JPRB, 0.804699E-01_JPRB, 0.693779E-01_JPRB, 0.595026E-01_JPRB &
  &, 0.507622E-01_JPRB, 0.430706E-01_JPRB, 0.363401E-01_JPRB &
  &, 0.304850E-01_JPRB, 0.254259E-01_JPRB, 0.210818E-01_JPRB, 0.173745E-01_JPRB &
  &, 0.142335E-01_JPRB, 0.115880E-01_JPRB, 0.937665E-02_JPRB &
  &, 0.753475E-02_JPRB, 0.601814E-02_JPRB, 0.478173E-02_JPRB, 0.376956E-02_JPRB &
  &, 0.294974E-02_JPRB, 0.229677E-02_JPRB, 0.177094E-02_JPRB &
  &, 0.136109E-02_JPRB, 0.104300E-02_JPRB, 0.789533E-03_JPRB, 0.594271E-03_JPRB &
  &, 0.437663E-03_JPRB, 0.322999E-03_JPRB, 0.240884E-03_JPRB &
  &, 0.167678E-03_JPRB, 0.131128E-03_JPRB, 0.927014E-04_JPRB, 0.664575E-04_JPRB &
  &, 0.389023E-04_JPRB, 0.247939E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART2

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART2',0,ZHOOK_HANDLE)

XCW(   8, :) = (/ &
  &  0.771146E+00_JPRB, 0.719203E+00_JPRB, 0.669367E+00_JPRB, 0.621634E+00_JPRB &
  &, 0.575996E+00_JPRB, 0.532446E+00_JPRB, 0.490970E+00_JPRB &
  &, 0.451554E+00_JPRB, 0.414179E+00_JPRB, 0.378824E+00_JPRB, 0.345465E+00_JPRB &
  &, 0.314072E+00_JPRB, 0.284613E+00_JPRB, 0.257053E+00_JPRB &
  &, 0.231348E+00_JPRB, 0.207455E+00_JPRB, 0.185325E+00_JPRB, 0.164903E+00_JPRB &
  &, 0.146130E+00_JPRB, 0.128945E+00_JPRB, 0.113280E+00_JPRB &
  &, 0.990673E-01_JPRB, 0.862287E-01_JPRB, 0.746946E-01_JPRB, 0.643801E-01_JPRB &
  &, 0.552071E-01_JPRB, 0.470902E-01_JPRB, 0.399540E-01_JPRB &
  &, 0.337147E-01_JPRB, 0.282868E-01_JPRB, 0.236033E-01_JPRB, 0.195761E-01_JPRB &
  &, 0.161452E-01_JPRB, 0.132338E-01_JPRB, 0.107828E-01_JPRB &
  &, 0.873461E-02_JPRB, 0.702904E-02_JPRB, 0.562265E-02_JPRB, 0.447134E-02_JPRB &
  &, 0.352535E-02_JPRB, 0.277098E-02_JPRB, 0.215986E-02_JPRB &
  &, 0.167118E-02_JPRB, 0.129274E-02_JPRB, 0.987325E-03_JPRB, 0.749282E-03_JPRB &
  &, 0.559852E-03_JPRB, 0.423158E-03_JPRB, 0.317846E-03_JPRB &
  &, 0.233377E-03_JPRB, 0.171505E-03_JPRB, 0.120269E-03_JPRB, 0.805719E-04_JPRB &
  &, 0.533534E-04_JPRB, 0.395877E-04_JPRB, 0.251426E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(   9, :) = (/ &
  &  0.775213E+00_JPRB, 0.724053E+00_JPRB, 0.674911E+00_JPRB, 0.627784E+00_JPRB &
  &, 0.582668E+00_JPRB, 0.539556E+00_JPRB, 0.498439E+00_JPRB &
  &, 0.459304E+00_JPRB, 0.422136E+00_JPRB, 0.386918E+00_JPRB, 0.353627E+00_JPRB &
  &, 0.322241E+00_JPRB, 0.292729E+00_JPRB, 0.265061E+00_JPRB &
  &, 0.239196E+00_JPRB, 0.215099E+00_JPRB, 0.192722E+00_JPRB, 0.172018E+00_JPRB &
  &, 0.152932E+00_JPRB, 0.135407E+00_JPRB, 0.119382E+00_JPRB &
  &, 0.104797E+00_JPRB, 0.915737E-01_JPRB, 0.796470E-01_JPRB, 0.689414E-01_JPRB &
  &, 0.593791E-01_JPRB, 0.508862E-01_JPRB, 0.433847E-01_JPRB &
  &, 0.367919E-01_JPRB, 0.310316E-01_JPRB, 0.260304E-01_JPRB, 0.217104E-01_JPRB &
  &, 0.180051E-01_JPRB, 0.148486E-01_JPRB, 0.121753E-01_JPRB &
  &, 0.991588E-02_JPRB, 0.803993E-02_JPRB, 0.647335E-02_JPRB, 0.518315E-02_JPRB &
  &, 0.412152E-02_JPRB, 0.325573E-02_JPRB, 0.255959E-02_JPRB &
  &, 0.199234E-02_JPRB, 0.155383E-02_JPRB, 0.119675E-02_JPRB, 0.916216E-03_JPRB &
  &, 0.694261E-03_JPRB, 0.523318E-03_JPRB, 0.394807E-03_JPRB &
  &, 0.285937E-03_JPRB, 0.211881E-03_JPRB, 0.161619E-03_JPRB, 0.108801E-03_JPRB &
  &, 0.822557E-04_JPRB, 0.543816E-04_JPRB, 0.402851E-04_JPRB &
  &, 0.254972E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  10, :) = (/ &
  &  0.778867E+00_JPRB, 0.728416E+00_JPRB, 0.679903E+00_JPRB, 0.633328E+00_JPRB &
  &, 0.588688E+00_JPRB, 0.545980E+00_JPRB, 0.505195E+00_JPRB &
  &, 0.466324E+00_JPRB, 0.429355E+00_JPRB, 0.394272E+00_JPRB, 0.361057E+00_JPRB &
  &, 0.329688E+00_JPRB, 0.300143E+00_JPRB, 0.272388E+00_JPRB &
  &, 0.246394E+00_JPRB, 0.222123E+00_JPRB, 0.199536E+00_JPRB, 0.178587E+00_JPRB &
  &, 0.159228E+00_JPRB, 0.141406E+00_JPRB, 0.125066E+00_JPRB &
  &, 0.110144E+00_JPRB, 0.965796E-01_JPRB, 0.843044E-01_JPRB, 0.732469E-01_JPRB &
  &, 0.633366E-01_JPRB, 0.544997E-01_JPRB, 0.466590E-01_JPRB &
  &, 0.397401E-01_JPRB, 0.336721E-01_JPRB, 0.283795E-01_JPRB, 0.237899E-01_JPRB &
  &, 0.198305E-01_JPRB, 0.164369E-01_JPRB, 0.135497E-01_JPRB &
  &, 0.110971E-01_JPRB, 0.904129E-02_JPRB, 0.732404E-02_JPRB, 0.589496E-02_JPRB &
  &, 0.471770E-02_JPRB, 0.376156E-02_JPRB, 0.297011E-02_JPRB &
  &, 0.233565E-02_JPRB, 0.182627E-02_JPRB, 0.141781E-02_JPRB, 0.109507E-02_JPRB &
  &, 0.840888E-03_JPRB, 0.635997E-03_JPRB, 0.484596E-03_JPRB &
  &, 0.364776E-03_JPRB, 0.265716E-03_JPRB, 0.202970E-03_JPRB, 0.151144E-03_JPRB &
  &, 0.111158E-03_JPRB, 0.691755E-04_JPRB, 0.554277E-04_JPRB &
  &, 0.409944E-04_JPRB, 0.258578E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  11, :) = (/ &
  &  0.782192E+00_JPRB, 0.732388E+00_JPRB, 0.684452E+00_JPRB, 0.638386E+00_JPRB &
  &, 0.594186E+00_JPRB, 0.551852E+00_JPRB, 0.511378E+00_JPRB &
  &, 0.472757E+00_JPRB, 0.435978E+00_JPRB, 0.401028E+00_JPRB, 0.367892E+00_JPRB &
  &, 0.336551E+00_JPRB, 0.306983E+00_JPRB, 0.279163E+00_JPRB &
  &, 0.253060E+00_JPRB, 0.228642E+00_JPRB, 0.205872E+00_JPRB, 0.184711E+00_JPRB &
  &, 0.165112E+00_JPRB, 0.147025E+00_JPRB, 0.130400E+00_JPRB &
  &, 0.115181E+00_JPRB, 0.101307E+00_JPRB, 0.887154E-01_JPRB, 0.773358E-01_JPRB &
  &, 0.671049E-01_JPRB, 0.579531E-01_JPRB, 0.498036E-01_JPRB &
  &, 0.425866E-01_JPRB, 0.362325E-01_JPRB, 0.306628E-01_JPRB, 0.258147E-01_JPRB &
  &, 0.216171E-01_JPRB, 0.180030E-01_JPRB, 0.149105E-01_JPRB &
  &, 0.122784E-01_JPRB, 0.100522E-01_JPRB, 0.818452E-02_JPRB, 0.662682E-02_JPRB &
  &, 0.533442E-02_JPRB, 0.426739E-02_JPRB, 0.339144E-02_JPRB &
  &, 0.269004E-02_JPRB, 0.211006E-02_JPRB, 0.165051E-02_JPRB, 0.127393E-02_JPRB &
  &, 0.987515E-03_JPRB, 0.761197E-03_JPRB, 0.574384E-03_JPRB &
  &, 0.430475E-03_JPRB, 0.333009E-03_JPRB, 0.244321E-03_JPRB, 0.179372E-03_JPRB &
  &, 0.125609E-03_JPRB, 0.987632E-04_JPRB, 0.705702E-04_JPRB &
  &, 0.409944E-04_JPRB, 0.258578E-04_JPRB, 0.262244E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  12, :) = (/ &
  &  0.785247E+00_JPRB, 0.736041E+00_JPRB, 0.688639E+00_JPRB, 0.643044E+00_JPRB &
  &, 0.599255E+00_JPRB, 0.557271E+00_JPRB, 0.517091E+00_JPRB &
  &, 0.478706E+00_JPRB, 0.442109E+00_JPRB, 0.407291E+00_JPRB, 0.374237E+00_JPRB &
  &, 0.342929E+00_JPRB, 0.313351E+00_JPRB, 0.285478E+00_JPRB &
  &, 0.259284E+00_JPRB, 0.234740E+00_JPRB, 0.211810E+00_JPRB, 0.190461E+00_JPRB &
  &, 0.170647E+00_JPRB, 0.152323E+00_JPRB, 0.135442E+00_JPRB &
  &, 0.119955E+00_JPRB, 0.105798E+00_JPRB, 0.929146E-01_JPRB, 0.812435E-01_JPRB &
  &, 0.707204E-01_JPRB, 0.612723E-01_JPRB, 0.528374E-01_JPRB &
  &, 0.453432E-01_JPRB, 0.387168E-01_JPRB, 0.328928E-01_JPRB, 0.278016E-01_JPRB &
  &, 0.233777E-01_JPRB, 0.195515E-01_JPRB, 0.162622E-01_JPRB &
  &, 0.134504E-01_JPRB, 0.110631E-01_JPRB, 0.905477E-02_JPRB, 0.736871E-02_JPRB &
  &, 0.596143E-02_JPRB, 0.479429E-02_JPRB, 0.383438E-02_JPRB &
  &, 0.304442E-02_JPRB, 0.240521E-02_JPRB, 0.189484E-02_JPRB, 0.147664E-02_JPRB &
  &, 0.114636E-02_JPRB, 0.886396E-03_JPRB, 0.676999E-03_JPRB &
  &, 0.522454E-03_JPRB, 0.386844E-03_JPRB, 0.299455E-03_JPRB, 0.221716E-03_JPRB &
  &, 0.154511E-03_JPRB, 0.113557E-03_JPRB, 0.857127E-04_JPRB &
  &, 0.564916E-04_JPRB, 0.417156E-04_JPRB, 0.262244E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  13, :) = (/ &
  &  0.788076E+00_JPRB, 0.739426E+00_JPRB, 0.692522E+00_JPRB, 0.647367E+00_JPRB &
  &, 0.603964E+00_JPRB, 0.562311E+00_JPRB, 0.522407E+00_JPRB &
  &, 0.484248E+00_JPRB, 0.447829E+00_JPRB, 0.413139E+00_JPRB, 0.380168E+00_JPRB &
  &, 0.348900E+00_JPRB, 0.319320E+00_JPRB, 0.291406E+00_JPRB &
  &, 0.265135E+00_JPRB, 0.240481E+00_JPRB, 0.217412E+00_JPRB, 0.195892E+00_JPRB &
  &, 0.175886E+00_JPRB, 0.157348E+00_JPRB, 0.140235E+00_JPRB &
  &, 0.124501E+00_JPRB, 0.110085E+00_JPRB, 0.969369E-01_JPRB, 0.849948E-01_JPRB &
  &, 0.741941E-01_JPRB, 0.644761E-01_JPRB, 0.557721E-01_JPRB &
  &, 0.480177E-01_JPRB, 0.411370E-01_JPRB, 0.350735E-01_JPRB, 0.297506E-01_JPRB &
  &, 0.251082E-01_JPRB, 0.210778E-01_JPRB, 0.176048E-01_JPRB &
  &, 0.146223E-01_JPRB, 0.120835E-01_JPRB, 0.992503E-02_JPRB, 0.811060E-02_JPRB &
  &, 0.658844E-02_JPRB, 0.533174E-02_JPRB, 0.427732E-02_JPRB &
  &, 0.342096E-02_JPRB, 0.271170E-02_JPRB, 0.215081E-02_JPRB, 0.167935E-02_JPRB &
  &, 0.131743E-02_JPRB, 0.102412E-02_JPRB, 0.792442E-03_JPRB &
  &, 0.601293E-03_JPRB, 0.454138E-03_JPRB, 0.340806E-03_JPRB, 0.264059E-03_JPRB &
  &, 0.197865E-03_JPRB, 0.143145E-03_JPRB, 0.100855E-03_JPRB &
  &, 0.719888E-04_JPRB, 0.575734E-04_JPRB, 0.424488E-04_JPRB, 0.265969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  14, :) = (/ &
  &  0.790713E+00_JPRB, 0.742585E+00_JPRB, 0.696148E+00_JPRB, 0.651408E+00_JPRB &
  &, 0.608367E+00_JPRB, 0.567027E+00_JPRB, 0.527387E+00_JPRB &
  &, 0.489445E+00_JPRB, 0.453196E+00_JPRB, 0.418632E+00_JPRB, 0.385744E+00_JPRB &
  &, 0.354521E+00_JPRB, 0.324945E+00_JPRB, 0.297001E+00_JPRB &
  &, 0.270666E+00_JPRB, 0.245915E+00_JPRB, 0.222719E+00_JPRB, 0.201049E+00_JPRB &
  &, 0.180868E+00_JPRB, 0.162135E+00_JPRB, 0.144810E+00_JPRB &
  &, 0.128847E+00_JPRB, 0.114195E+00_JPRB, 0.100800E+00_JPRB, 0.886041E-01_JPRB &
  &, 0.775514E-01_JPRB, 0.675792E-01_JPRB, 0.586227E-01_JPRB &
  &, 0.506179E-01_JPRB, 0.435011E-01_JPRB, 0.372049E-01_JPRB, 0.316660E-01_JPRB &
  &, 0.268128E-01_JPRB, 0.225909E-01_JPRB, 0.189338E-01_JPRB &
  &, 0.157850E-01_JPRB, 0.130944E-01_JPRB, 0.108051E-01_JPRB, 0.886251E-02_JPRB &
  &, 0.723601E-02_JPRB, 0.586918E-02_JPRB, 0.474186E-02_JPRB &
  &, 0.380856E-02_JPRB, 0.304090E-02_JPRB, 0.240677E-02_JPRB, 0.190590E-02_JPRB &
  &, 0.148849E-02_JPRB, 0.116184E-02_JPRB, 0.895057E-03_JPRB &
  &, 0.693271E-03_JPRB, 0.534890E-03_JPRB, 0.409723E-03_JPRB, 0.306402E-03_JPRB &
  &, 0.226767E-03_JPRB, 0.172732E-03_JPRB, 0.131140E-03_JPRB &
  &, 0.874860E-04_JPRB, 0.575734E-04_JPRB, 0.424488E-04_JPRB, 0.265969E-04_JPRB &
  &, 0.269754E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART3

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART3',0,ZHOOK_HANDLE)

XCW(  15, :) = (/ &
  &  0.793186E+00_JPRB, 0.745548E+00_JPRB, 0.699551E+00_JPRB, 0.655203E+00_JPRB &
  &, 0.612506E+00_JPRB, 0.571464E+00_JPRB, 0.532076E+00_JPRB &
  &, 0.494341E+00_JPRB, 0.458258E+00_JPRB, 0.423819E+00_JPRB, 0.391016E+00_JPRB &
  &, 0.359839E+00_JPRB, 0.330274E+00_JPRB, 0.302307E+00_JPRB &
  &, 0.275917E+00_JPRB, 0.251081E+00_JPRB, 0.227774E+00_JPRB, 0.205967E+00_JPRB &
  &, 0.185626E+00_JPRB, 0.166716E+00_JPRB, 0.149197E+00_JPRB &
  &, 0.133021E+00_JPRB, 0.118150E+00_JPRB, 0.104523E+00_JPRB, 0.920926E-01_JPRB &
  &, 0.808032E-01_JPRB, 0.705893E-01_JPRB, 0.613971E-01_JPRB &
  &, 0.531594E-01_JPRB, 0.458171E-01_JPRB, 0.392993E-01_JPRB, 0.335477E-01_JPRB &
  &, 0.285001E-01_JPRB, 0.240906E-01_JPRB, 0.202583E-01_JPRB &
  &, 0.169477E-01_JPRB, 0.141053E-01_JPRB, 0.116851E-01_JPRB, 0.962445E-02_JPRB &
  &, 0.788357E-02_JPRB, 0.642770E-02_JPRB, 0.520640E-02_JPRB &
  &, 0.419617E-02_JPRB, 0.335875E-02_JPRB, 0.268601E-02_JPRB, 0.212053E-02_JPRB &
  &, 0.167178E-02_JPRB, 0.131207E-02_JPRB, 0.102333E-02_JPRB &
  &, 0.785250E-03_JPRB, 0.615642E-03_JPRB, 0.464858E-03_JPRB, 0.348745E-03_JPRB &
  &, 0.270120E-03_JPRB, 0.202320E-03_JPRB, 0.146283E-03_JPRB &
  &, 0.102983E-03_JPRB, 0.734312E-04_JPRB, 0.586731E-04_JPRB, 0.431938E-04_JPRB &
  &, 0.269754E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  16, :) = (/ &
  &  0.795517E+00_JPRB, 0.748342E+00_JPRB, 0.702762E+00_JPRB, 0.658786E+00_JPRB &
  &, 0.616416E+00_JPRB, 0.575658E+00_JPRB, 0.536511E+00_JPRB &
  &, 0.498977E+00_JPRB, 0.463054E+00_JPRB, 0.428737E+00_JPRB, 0.396019E+00_JPRB &
  &, 0.364890E+00_JPRB, 0.335342E+00_JPRB, 0.307358E+00_JPRB &
  &, 0.280921E+00_JPRB, 0.256011E+00_JPRB, 0.232603E+00_JPRB, 0.210672E+00_JPRB &
  &, 0.190186E+00_JPRB, 0.171113E+00_JPRB, 0.153412E+00_JPRB &
  &, 0.137043E+00_JPRB, 0.121965E+00_JPRB, 0.108122E+00_JPRB, 0.954745E-01_JPRB &
  &, 0.839568E-01_JPRB, 0.735211E-01_JPRB, 0.641028E-01_JPRB &
  &, 0.556423E-01_JPRB, 0.480810E-01_JPRB, 0.413568E-01_JPRB, 0.354041E-01_JPRB &
  &, 0.301658E-01_JPRB, 0.255772E-01_JPRB, 0.215782E-01_JPRB &
  &, 0.181103E-01_JPRB, 0.151257E-01_JPRB, 0.125651E-01_JPRB, 0.103864E-01_JPRB &
  &, 0.854141E-02_JPRB, 0.698622E-02_JPRB, 0.568175E-02_JPRB &
  &, 0.459486E-02_JPRB, 0.369930E-02_JPRB, 0.296524E-02_JPRB, 0.235901E-02_JPRB &
  &, 0.186728E-02_JPRB, 0.147483E-02_JPRB, 0.115159E-02_JPRB &
  &, 0.890369E-03_JPRB, 0.696395E-03_JPRB, 0.533775E-03_JPRB, 0.405202E-03_JPRB &
  &, 0.313474E-03_JPRB, 0.231908E-03_JPRB, 0.176568E-03_JPRB &
  &, 0.133978E-03_JPRB, 0.892890E-04_JPRB, 0.586731E-04_JPRB, 0.431938E-04_JPRB &
  &, 0.269754E-04_JPRB, 0.273598E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  17, :) = (/ &
  &  0.797721E+00_JPRB, 0.750986E+00_JPRB, 0.705803E+00_JPRB, 0.662181E+00_JPRB &
  &, 0.620124E+00_JPRB, 0.579637E+00_JPRB, 0.540723E+00_JPRB &
  &, 0.503383E+00_JPRB, 0.467615E+00_JPRB, 0.433418E+00_JPRB, 0.400785E+00_JPRB &
  &, 0.369709E+00_JPRB, 0.340180E+00_JPRB, 0.312185E+00_JPRB &
  &, 0.285709E+00_JPRB, 0.260733E+00_JPRB, 0.237235E+00_JPRB, 0.215190E+00_JPRB &
  &, 0.194571E+00_JPRB, 0.175345E+00_JPRB, 0.157475E+00_JPRB &
  &, 0.140926E+00_JPRB, 0.125655E+00_JPRB, 0.111614E+00_JPRB, 0.987534E-01_JPRB &
  &, 0.870268E-01_JPRB, 0.763746E-01_JPRB, 0.667436E-01_JPRB &
  &, 0.580744E-01_JPRB, 0.503088E-01_JPRB, 0.433814E-01_JPRB, 0.372353E-01_JPRB &
  &, 0.318143E-01_JPRB, 0.270504E-01_JPRB, 0.228846E-01_JPRB &
  &, 0.192637E-01_JPRB, 0.161366E-01_JPRB, 0.134549E-01_JPRB, 0.111583E-01_JPRB &
  &, 0.920954E-02_JPRB, 0.755527E-02_JPRB, 0.616790E-02_JPRB &
  &, 0.500462E-02_JPRB, 0.405120E-02_JPRB, 0.325611E-02_JPRB, 0.259749E-02_JPRB &
  &, 0.206278E-02_JPRB, 0.163759E-02_JPRB, 0.127986E-02_JPRB &
  &, 0.100863E-02_JPRB, 0.777147E-03_JPRB, 0.602693E-03_JPRB, 0.461660E-03_JPRB &
  &, 0.356827E-03_JPRB, 0.261496E-03_JPRB, 0.206853E-03_JPRB &
  &, 0.149475E-03_JPRB, 0.105147E-03_JPRB, 0.748975E-04_JPRB, 0.597907E-04_JPRB &
  &, 0.439508E-04_JPRB, 0.273598E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  18, :) = (/ &
  &  0.799815E+00_JPRB, 0.753498E+00_JPRB, 0.708694E+00_JPRB, 0.665410E+00_JPRB &
  &, 0.623652E+00_JPRB, 0.583427E+00_JPRB, 0.544737E+00_JPRB &
  &, 0.507584E+00_JPRB, 0.471968E+00_JPRB, 0.437889E+00_JPRB, 0.405341E+00_JPRB &
  &, 0.374317E+00_JPRB, 0.344811E+00_JPRB, 0.316810E+00_JPRB &
  &, 0.290302E+00_JPRB, 0.265266E+00_JPRB, 0.241687E+00_JPRB, 0.219539E+00_JPRB &
  &, 0.198797E+00_JPRB, 0.179428E+00_JPRB, 0.161405E+00_JPRB &
  &, 0.144685E+00_JPRB, 0.129233E+00_JPRB, 0.115001E+00_JPRB, 0.101947E+00_JPRB &
  &, 0.900167E-01_JPRB, 0.791649E-01_JPRB, 0.693310E-01_JPRB &
  &, 0.604595E-01_JPRB, 0.524966E-01_JPRB, 0.453773E-01_JPRB, 0.390454E-01_JPRB &
  &, 0.334455E-01_JPRB, 0.285104E-01_JPRB, 0.241909E-01_JPRB &
  &, 0.204263E-01_JPRB, 0.171570E-01_JPRB, 0.143447E-01_JPRB, 0.119303E-01_JPRB &
  &, 0.987766E-02_JPRB, 0.813487E-02_JPRB, 0.666485E-02_JPRB &
  &, 0.542545E-02_JPRB, 0.440311E-02_JPRB, 0.354698E-02_JPRB, 0.284789E-02_JPRB &
  &, 0.227050E-02_JPRB, 0.180035E-02_JPRB, 0.142096E-02_JPRB &
  &, 0.111375E-02_JPRB, 0.871358E-03_JPRB, 0.671611E-03_JPRB, 0.518117E-03_JPRB &
  &, 0.400181E-03_JPRB, 0.305877E-03_JPRB, 0.221996E-03_JPRB &
  &, 0.164972E-03_JPRB, 0.121005E-03_JPRB, 0.911219E-04_JPRB, 0.597907E-04_JPRB &
  &, 0.439508E-04_JPRB, 0.273598E-04_JPRB, 0.277503E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  19, :) = (/ &
  &  0.801808E+00_JPRB, 0.755892E+00_JPRB, 0.711450E+00_JPRB, 0.668491E+00_JPRB &
  &, 0.627020E+00_JPRB, 0.587046E+00_JPRB, 0.548572E+00_JPRB &
  &, 0.511601E+00_JPRB, 0.476134E+00_JPRB, 0.442171E+00_JPRB, 0.409707E+00_JPRB &
  &, 0.378738E+00_JPRB, 0.349258E+00_JPRB, 0.321256E+00_JPRB &
  &, 0.294720E+00_JPRB, 0.269633E+00_JPRB, 0.245979E+00_JPRB, 0.223736E+00_JPRB &
  &, 0.202879E+00_JPRB, 0.183381E+00_JPRB, 0.165208E+00_JPRB &
  &, 0.148332E+00_JPRB, 0.132709E+00_JPRB, 0.118298E+00_JPRB, 0.105059E+00_JPRB &
  &, 0.929375E-01_JPRB, 0.818918E-01_JPRB, 0.718649E-01_JPRB &
  &, 0.628017E-01_JPRB, 0.546483E-01_JPRB, 0.473445E-01_JPRB, 0.408344E-01_JPRB &
  &, 0.350594E-01_JPRB, 0.299615E-01_JPRB, 0.254882E-01_JPRB &
  &, 0.215797E-01_JPRB, 0.181775E-01_JPRB, 0.152443E-01_JPRB, 0.127123E-01_JPRB &
  &, 0.105561E-01_JPRB, 0.871446E-02_JPRB, 0.716181E-02_JPRB &
  &, 0.585735E-02_JPRB, 0.476636E-02_JPRB, 0.384949E-02_JPRB, 0.309829E-02_JPRB &
  &, 0.247823E-02_JPRB, 0.197563E-02_JPRB, 0.156206E-02_JPRB &
  &, 0.123200E-02_JPRB, 0.965569E-03_JPRB, 0.754312E-03_JPRB, 0.588689E-03_JPRB &
  &, 0.443534E-03_JPRB, 0.350259E-03_JPRB, 0.267423E-03_JPRB &
  &, 0.195966E-03_JPRB, 0.152720E-03_JPRB, 0.107346E-03_JPRB, 0.763876E-04_JPRB &
  &, 0.609262E-04_JPRB, 0.447197E-04_JPRB, 0.277503E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  20, :) = (/ &
  &  0.803713E+00_JPRB, 0.758180E+00_JPRB, 0.714085E+00_JPRB, 0.671438E+00_JPRB &
  &, 0.630244E+00_JPRB, 0.590513E+00_JPRB, 0.552248E+00_JPRB &
  &, 0.515454E+00_JPRB, 0.480131E+00_JPRB, 0.446281E+00_JPRB, 0.413902E+00_JPRB &
  &, 0.382990E+00_JPRB, 0.353538E+00_JPRB, 0.325537E+00_JPRB &
  &, 0.298979E+00_JPRB, 0.273847E+00_JPRB, 0.250126E+00_JPRB, 0.227794E+00_JPRB &
  &, 0.206833E+00_JPRB, 0.187210E+00_JPRB, 0.168901E+00_JPRB &
  &, 0.151873E+00_JPRB, 0.136091E+00_JPRB, 0.121511E+00_JPRB, 0.108093E+00_JPRB &
  &, 0.957928E-01_JPRB, 0.845628E-01_JPRB, 0.743492E-01_JPRB &
  &, 0.651008E-01_JPRB, 0.567640E-01_JPRB, 0.492828E-01_JPRB, 0.426025E-01_JPRB &
  &, 0.366604E-01_JPRB, 0.314082E-01_JPRB, 0.267809E-01_JPRB &
  &, 0.227238E-01_JPRB, 0.191979E-01_JPRB, 0.161341E-01_JPRB, 0.135043E-01_JPRB &
  &, 0.112345E-01_JPRB, 0.930460E-02_JPRB, 0.766956E-02_JPRB &
  &, 0.628926E-02_JPRB, 0.512961E-02_JPRB, 0.416363E-02_JPRB, 0.336062E-02_JPRB &
  &, 0.269817E-02_JPRB, 0.216343E-02_JPRB, 0.171598E-02_JPRB &
  &, 0.136340E-02_JPRB, 0.107324E-02_JPRB, 0.837014E-03_JPRB, 0.645147E-03_JPRB &
  &, 0.501339E-03_JPRB, 0.379847E-03_JPRB, 0.297708E-03_JPRB &
  &, 0.226961E-03_JPRB, 0.168578E-03_JPRB, 0.123571E-03_JPRB, 0.929845E-04_JPRB &
  &, 0.609262E-04_JPRB, 0.447197E-04_JPRB, 0.277503E-04_JPRB &
  &, 0.281466E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  21, :) = (/ &
  &  0.805537E+00_JPRB, 0.760373E+00_JPRB, 0.716611E+00_JPRB, 0.674264E+00_JPRB &
  &, 0.633338E+00_JPRB, 0.593841E+00_JPRB, 0.555779E+00_JPRB &
  &, 0.519156E+00_JPRB, 0.483975E+00_JPRB, 0.450238E+00_JPRB, 0.417942E+00_JPRB &
  &, 0.387087E+00_JPRB, 0.357665E+00_JPRB, 0.329660E+00_JPRB &
  &, 0.303093E+00_JPRB, 0.277920E+00_JPRB, 0.254138E+00_JPRB, 0.231727E+00_JPRB &
  &, 0.210666E+00_JPRB, 0.190928E+00_JPRB, 0.172494E+00_JPRB &
  &, 0.155325E+00_JPRB, 0.139387E+00_JPRB, 0.124649E+00_JPRB, 0.111063E+00_JPRB &
  &, 0.985900E-01_JPRB, 0.871817E-01_JPRB, 0.767916E-01_JPRB &
  &, 0.673686E-01_JPRB, 0.588556E-01_JPRB, 0.512007E-01_JPRB, 0.443536E-01_JPRB &
  &, 0.382485E-01_JPRB, 0.328416E-01_JPRB, 0.280691E-01_JPRB &
  &, 0.238771E-01_JPRB, 0.202183E-01_JPRB, 0.170435E-01_JPRB, 0.142963E-01_JPRB &
  &, 0.119334E-01_JPRB, 0.990527E-02_JPRB, 0.818812E-02_JPRB &
  &, 0.673224E-02_JPRB, 0.551557E-02_JPRB, 0.448940E-02_JPRB, 0.363487E-02_JPRB &
  &, 0.293033E-02_JPRB, 0.235123E-02_JPRB, 0.186990E-02_JPRB &
  &, 0.148166E-02_JPRB, 0.116745E-02_JPRB, 0.919715E-03_JPRB, 0.715718E-03_JPRB &
  &, 0.559143E-03_JPRB, 0.424228E-03_JPRB, 0.327994E-03_JPRB &
  &, 0.257955E-03_JPRB, 0.184436E-03_JPRB, 0.139795E-03_JPRB, 0.109581E-03_JPRB &
  &, 0.779016E-04_JPRB, 0.620795E-04_JPRB, 0.455005E-04_JPRB &
  &, 0.281466E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART4

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART4',0,ZHOOK_HANDLE)

XCW(  22, :) = (/ &
  &  0.807289E+00_JPRB, 0.762478E+00_JPRB, 0.719039E+00_JPRB, 0.676981E+00_JPRB &
  &, 0.636312E+00_JPRB, 0.597043E+00_JPRB, 0.559178E+00_JPRB &
  &, 0.522722E+00_JPRB, 0.487680E+00_JPRB, 0.454053E+00_JPRB, 0.421842E+00_JPRB &
  &, 0.391042E+00_JPRB, 0.361653E+00_JPRB, 0.333668E+00_JPRB &
  &, 0.307076E+00_JPRB, 0.281868E+00_JPRB, 0.258029E+00_JPRB, 0.235542E+00_JPRB &
  &, 0.214390E+00_JPRB, 0.194548E+00_JPRB, 0.175990E+00_JPRB &
  &, 0.158687E+00_JPRB, 0.142606E+00_JPRB, 0.127713E+00_JPRB, 0.113968E+00_JPRB &
  &, 0.101329E+00_JPRB, 0.897521E-01_JPRB, 0.791920E-01_JPRB &
  &, 0.695973E-01_JPRB, 0.609151E-01_JPRB, 0.530980E-01_JPRB, 0.460838E-01_JPRB &
  &, 0.398279E-01_JPRB, 0.342662E-01_JPRB, 0.293528E-01_JPRB &
  &, 0.250212E-01_JPRB, 0.212388E-01_JPRB, 0.179431E-01_JPRB, 0.150883E-01_JPRB &
  &, 0.126221E-01_JPRB, 0.105165E-01_JPRB, 0.871749E-02_JPRB &
  &, 0.718630E-02_JPRB, 0.590153E-02_JPRB, 0.481518E-02_JPRB, 0.390912E-02_JPRB &
  &, 0.316249E-02_JPRB, 0.253903E-02_JPRB, 0.203665E-02_JPRB &
  &, 0.162620E-02_JPRB, 0.128858E-02_JPRB, 0.101620E-02_JPRB, 0.786290E-03_JPRB &
  &, 0.616948E-03_JPRB, 0.483404E-03_JPRB, 0.373421E-03_JPRB &
  &, 0.273452E-03_JPRB, 0.216151E-03_JPRB, 0.156019E-03_JPRB, 0.126178E-03_JPRB &
  &, 0.948770E-04_JPRB, 0.620795E-04_JPRB, 0.455005E-04_JPRB &
  &, 0.281466E-04_JPRB, 0.285490E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  23, :) = (/ &
  &  0.808973E+00_JPRB, 0.764504E+00_JPRB, 0.721375E+00_JPRB, 0.679597E+00_JPRB &
  &, 0.639179E+00_JPRB, 0.600130E+00_JPRB, 0.562456E+00_JPRB &
  &, 0.526164E+00_JPRB, 0.491258E+00_JPRB, 0.457739E+00_JPRB, 0.425610E+00_JPRB &
  &, 0.394870E+00_JPRB, 0.365514E+00_JPRB, 0.337540E+00_JPRB &
  &, 0.310937E+00_JPRB, 0.285698E+00_JPRB, 0.261808E+00_JPRB, 0.239253E+00_JPRB &
  &, 0.218014E+00_JPRB, 0.198069E+00_JPRB, 0.179397E+00_JPRB &
  &, 0.161966E+00_JPRB, 0.145750E+00_JPRB, 0.130712E+00_JPRB, 0.116814E+00_JPRB &
  &, 0.104017E+00_JPRB, 0.922816E-01_JPRB, 0.815542E-01_JPRB &
  &, 0.717948E-01_JPRB, 0.629507E-01_JPRB, 0.549707E-01_JPRB, 0.478013E-01_JPRB &
  &, 0.413901E-01_JPRB, 0.356863E-01_JPRB, 0.306319E-01_JPRB &
  &, 0.261745E-01_JPRB, 0.222592E-01_JPRB, 0.188525E-01_JPRB, 0.158904E-01_JPRB &
  &, 0.133313E-01_JPRB, 0.111277E-01_JPRB, 0.924685E-02_JPRB &
  &, 0.764035E-02_JPRB, 0.628749E-02_JPRB, 0.515259E-02_JPRB, 0.419529E-02_JPRB &
  &, 0.340687E-02_JPRB, 0.273935E-02_JPRB, 0.220340E-02_JPRB &
  &, 0.175760E-02_JPRB, 0.139625E-02_JPRB, 0.109890E-02_JPRB, 0.870977E-03_JPRB &
  &, 0.674752E-03_JPRB, 0.527785E-03_JPRB, 0.403706E-03_JPRB &
  &, 0.319944E-03_JPRB, 0.232009E-03_JPRB, 0.172244E-03_JPRB, 0.142775E-03_JPRB &
  &, 0.948770E-04_JPRB, 0.794394E-04_JPRB, 0.455005E-04_JPRB &
  &, 0.281466E-04_JPRB, 0.285490E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  24, :) = (/ &
  &  0.810596E+00_JPRB, 0.766457E+00_JPRB, 0.723628E+00_JPRB, 0.682121E+00_JPRB &
  &, 0.641946E+00_JPRB, 0.603110E+00_JPRB, 0.565623E+00_JPRB &
  &, 0.529490E+00_JPRB, 0.494717E+00_JPRB, 0.461307E+00_JPRB, 0.429261E+00_JPRB &
  &, 0.398579E+00_JPRB, 0.369259E+00_JPRB, 0.341298E+00_JPRB &
  &, 0.314687E+00_JPRB, 0.289419E+00_JPRB, 0.265483E+00_JPRB, 0.242864E+00_JPRB &
  &, 0.221544E+00_JPRB, 0.201505E+00_JPRB, 0.182724E+00_JPRB &
  &, 0.165175E+00_JPRB, 0.148826E+00_JPRB, 0.133648E+00_JPRB, 0.119606E+00_JPRB &
  &, 0.106658E+00_JPRB, 0.947664E-01_JPRB, 0.838821E-01_JPRB &
  &, 0.739649E-01_JPRB, 0.649621E-01_JPRB, 0.568270E-01_JPRB, 0.495062E-01_JPRB &
  &, 0.429479E-01_JPRB, 0.370977E-01_JPRB, 0.319065E-01_JPRB &
  &, 0.273186E-01_JPRB, 0.232892E-01_JPRB, 0.197618E-01_JPRB, 0.166924E-01_JPRB &
  &, 0.140303E-01_JPRB, 0.117494E-01_JPRB, 0.978702E-02_JPRB &
  &, 0.810548E-02_JPRB, 0.668480E-02_JPRB, 0.549000E-02_JPRB, 0.448146E-02_JPRB &
  &, 0.365124E-02_JPRB, 0.295219E-02_JPRB, 0.237015E-02_JPRB &
  &, 0.190214E-02_JPRB, 0.151738E-02_JPRB, 0.119539E-02_JPRB, 0.941548E-03_JPRB &
  &, 0.747008E-03_JPRB, 0.572167E-03_JPRB, 0.449134E-03_JPRB &
  &, 0.350938E-03_JPRB, 0.263725E-03_JPRB, 0.204692E-03_JPRB, 0.159372E-03_JPRB &
  &, 0.111852E-03_JPRB, 0.794394E-04_JPRB, 0.632508E-04_JPRB &
  &, 0.462932E-04_JPRB, 0.285490E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  25, :) = (/ &
  &  0.812163E+00_JPRB, 0.768343E+00_JPRB, 0.725804E+00_JPRB, 0.684561E+00_JPRB &
  &, 0.644621E+00_JPRB, 0.605994E+00_JPRB, 0.568689E+00_JPRB &
  &, 0.532712E+00_JPRB, 0.498069E+00_JPRB, 0.464764E+00_JPRB, 0.432801E+00_JPRB &
  &, 0.402177E+00_JPRB, 0.372894E+00_JPRB, 0.344948E+00_JPRB &
  &, 0.318332E+00_JPRB, 0.293041E+00_JPRB, 0.269062E+00_JPRB, 0.246383E+00_JPRB &
  &, 0.224990E+00_JPRB, 0.204862E+00_JPRB, 0.185976E+00_JPRB &
  &, 0.168312E+00_JPRB, 0.151841E+00_JPRB, 0.136528E+00_JPRB, 0.122345E+00_JPRB &
  &, 0.109251E+00_JPRB, 0.972102E-01_JPRB, 0.861756E-01_JPRB &
  &, 0.761037E-01_JPRB, 0.669496E-01_JPRB, 0.586627E-01_JPRB, 0.511942E-01_JPRB &
  &, 0.444885E-01_JPRB, 0.385045E-01_JPRB, 0.331766E-01_JPRB &
  &, 0.284627E-01_JPRB, 0.243096E-01_JPRB, 0.206712E-01_JPRB, 0.175045E-01_JPRB &
  &, 0.147498E-01_JPRB, 0.123712E-01_JPRB, 0.103272E-01_JPRB &
  &, 0.858169E-02_JPRB, 0.709346E-02_JPRB, 0.583904E-02_JPRB, 0.477956E-02_JPRB &
  &, 0.389562E-02_JPRB, 0.316503E-02_JPRB, 0.254973E-02_JPRB &
  &, 0.204667E-02_JPRB, 0.163851E-02_JPRB, 0.130565E-02_JPRB, 0.102623E-02_JPRB &
  &, 0.804813E-03_JPRB, 0.631342E-03_JPRB, 0.494562E-03_JPRB &
  &, 0.381933E-03_JPRB, 0.295441E-03_JPRB, 0.220917E-03_JPRB, 0.175969E-03_JPRB &
  &, 0.128828E-03_JPRB, 0.967992E-04_JPRB, 0.632508E-04_JPRB &
  &, 0.462932E-04_JPRB, 0.285490E-04_JPRB, 0.289572E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  26, :) = (/ &
  &  0.813677E+00_JPRB, 0.770167E+00_JPRB, 0.727911E+00_JPRB, 0.686922E+00_JPRB &
  &, 0.647211E+00_JPRB, 0.608787E+00_JPRB, 0.571659E+00_JPRB &
  &, 0.535835E+00_JPRB, 0.501321E+00_JPRB, 0.468121E+00_JPRB, 0.436238E+00_JPRB &
  &, 0.405674E+00_JPRB, 0.376429E+00_JPRB, 0.348499E+00_JPRB &
  &, 0.321883E+00_JPRB, 0.296569E+00_JPRB, 0.272552E+00_JPRB, 0.249818E+00_JPRB &
  &, 0.228353E+00_JPRB, 0.208139E+00_JPRB, 0.189157E+00_JPRB &
  &, 0.171385E+00_JPRB, 0.154795E+00_JPRB, 0.139357E+00_JPRB, 0.125038E+00_JPRB &
  &, 0.111805E+00_JPRB, 0.996204E-01_JPRB, 0.884386E-01_JPRB &
  &, 0.782190E-01_JPRB, 0.689170E-01_JPRB, 0.604820E-01_JPRB, 0.528696E-01_JPRB &
  &, 0.460248E-01_JPRB, 0.399026E-01_JPRB, 0.344466E-01_JPRB &
  &, 0.296067E-01_JPRB, 0.253396E-01_JPRB, 0.215903E-01_JPRB, 0.183165E-01_JPRB &
  &, 0.154693E-01_JPRB, 0.130035E-01_JPRB, 0.108782E-01_JPRB &
  &, 0.905789E-02_JPRB, 0.751347E-02_JPRB, 0.619972E-02_JPRB, 0.508958E-02_JPRB &
  &, 0.415222E-02_JPRB, 0.337787E-02_JPRB, 0.274213E-02_JPRB &
  &, 0.220435E-02_JPRB, 0.175963E-02_JPRB, 0.140214E-02_JPRB, 0.111092E-02_JPRB &
  &, 0.877068E-03_JPRB, 0.690518E-03_JPRB, 0.539989E-03_JPRB &
  &, 0.412927E-03_JPRB, 0.327156E-03_JPRB, 0.253366E-03_JPRB, 0.192566E-03_JPRB &
  &, 0.145803E-03_JPRB, 0.967992E-04_JPRB, 0.810010E-04_JPRB &
  &, 0.644399E-04_JPRB, 0.470979E-04_JPRB, 0.289572E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  27, :) = (/ &
  &  0.815145E+00_JPRB, 0.771933E+00_JPRB, 0.729952E+00_JPRB, 0.689211E+00_JPRB &
  &, 0.649723E+00_JPRB, 0.611497E+00_JPRB, 0.574542E+00_JPRB &
  &, 0.538868E+00_JPRB, 0.504480E+00_JPRB, 0.471383E+00_JPRB, 0.439581E+00_JPRB &
  &, 0.409076E+00_JPRB, 0.379871E+00_JPRB, 0.351960E+00_JPRB &
  &, 0.325342E+00_JPRB, 0.300012E+00_JPRB, 0.275958E+00_JPRB, 0.253173E+00_JPRB &
  &, 0.231642E+00_JPRB, 0.211349E+00_JPRB, 0.192277E+00_JPRB &
  &, 0.174399E+00_JPRB, 0.157694E+00_JPRB, 0.142133E+00_JPRB, 0.127688E+00_JPRB &
  &, 0.114318E+00_JPRB, 0.101993E+00_JPRB, 0.906711E-01_JPRB &
  &, 0.803070E-01_JPRB, 0.708603E-01_JPRB, 0.622848E-01_JPRB, 0.545324E-01_JPRB &
  &, 0.475481E-01_JPRB, 0.412917E-01_JPRB, 0.357121E-01_JPRB &
  &, 0.307508E-01_JPRB, 0.263695E-01_JPRB, 0.225095E-01_JPRB, 0.191286E-01_JPRB &
  &, 0.161888E-01_JPRB, 0.136358E-01_JPRB, 0.114291E-01_JPRB &
  &, 0.954517E-02_JPRB, 0.793348E-02_JPRB, 0.656040E-02_JPRB, 0.539960E-02_JPRB &
  &, 0.442104E-02_JPRB, 0.360322E-02_JPRB, 0.292171E-02_JPRB &
  &, 0.236203E-02_JPRB, 0.189422E-02_JPRB, 0.151241E-02_JPRB, 0.120972E-02_JPRB &
  &, 0.949324E-03_JPRB, 0.749693E-03_JPRB, 0.585417E-03_JPRB &
  &, 0.459419E-03_JPRB, 0.358872E-03_JPRB, 0.269590E-03_JPRB, 0.209163E-03_JPRB &
  &, 0.162779E-03_JPRB, 0.114159E-03_JPRB, 0.810010E-04_JPRB &
  &, 0.644399E-04_JPRB, 0.470979E-04_JPRB, 0.289572E-04_JPRB, 0.293715E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  28, :) = (/ &
  &  0.816566E+00_JPRB, 0.773647E+00_JPRB, 0.731931E+00_JPRB, 0.691432E+00_JPRB &
  &, 0.652161E+00_JPRB, 0.614128E+00_JPRB, 0.577344E+00_JPRB &
  &, 0.541816E+00_JPRB, 0.507551E+00_JPRB, 0.474557E+00_JPRB, 0.442835E+00_JPRB &
  &, 0.412391E+00_JPRB, 0.383224E+00_JPRB, 0.355334E+00_JPRB &
  &, 0.328719E+00_JPRB, 0.303372E+00_JPRB, 0.279287E+00_JPRB, 0.256454E+00_JPRB &
  &, 0.234860E+00_JPRB, 0.214490E+00_JPRB, 0.195331E+00_JPRB &
  &, 0.177356E+00_JPRB, 0.160543E+00_JPRB, 0.144864E+00_JPRB, 0.130292E+00_JPRB &
  &, 0.116795E+00_JPRB, 0.104337E+00_JPRB, 0.928768E-01_JPRB &
  &, 0.823715E-01_JPRB, 0.727876E-01_JPRB, 0.640713E-01_JPRB, 0.561825E-01_JPRB &
  &, 0.490671E-01_JPRB, 0.426809E-01_JPRB, 0.369731E-01_JPRB &
  &, 0.318948E-01_JPRB, 0.273900E-01_JPRB, 0.234286E-01_JPRB, 0.199507E-01_JPRB &
  &, 0.169186E-01_JPRB, 0.142786E-01_JPRB, 0.120017E-01_JPRB &
  &, 0.100325E-01_JPRB, 0.835350E-02_JPRB, 0.692108E-02_JPRB, 0.570962E-02_JPRB &
  &, 0.468985E-02_JPRB, 0.382858E-02_JPRB, 0.311411E-02_JPRB &
  &, 0.251971E-02_JPRB, 0.202881E-02_JPRB, 0.163646E-02_JPRB, 0.129441E-02_JPRB &
  &, 0.103603E-02_JPRB, 0.808869E-03_JPRB, 0.645987E-03_JPRB &
  &, 0.505910E-03_JPRB, 0.390587E-03_JPRB, 0.302039E-03_JPRB, 0.225760E-03_JPRB &
  &, 0.179754E-03_JPRB, 0.131519E-03_JPRB, 0.987513E-04_JPRB &
  &, 0.644399E-04_JPRB, 0.470979E-04_JPRB, 0.289572E-04_JPRB, 0.293715E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART5

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART5',0,ZHOOK_HANDLE)

XCW(  29, :) = (/ &
  &  0.817947E+00_JPRB, 0.775311E+00_JPRB, 0.733854E+00_JPRB, 0.693591E+00_JPRB &
  &, 0.654531E+00_JPRB, 0.616687E+00_JPRB, 0.580069E+00_JPRB &
  &, 0.544685E+00_JPRB, 0.510542E+00_JPRB, 0.477648E+00_JPRB, 0.446007E+00_JPRB &
  &, 0.415622E+00_JPRB, 0.386496E+00_JPRB, 0.358628E+00_JPRB &
  &, 0.332016E+00_JPRB, 0.306657E+00_JPRB, 0.282543E+00_JPRB, 0.259664E+00_JPRB &
  &, 0.238014E+00_JPRB, 0.217574E+00_JPRB, 0.198327E+00_JPRB &
  &, 0.180257E+00_JPRB, 0.163341E+00_JPRB, 0.147550E+00_JPRB, 0.132860E+00_JPRB &
  &, 0.119236E+00_JPRB, 0.106646E+00_JPRB, 0.950520E-01_JPRB &
  &, 0.844165E-01_JPRB, 0.746949E-01_JPRB, 0.658454E-01_JPRB, 0.578201E-01_JPRB &
  &, 0.505775E-01_JPRB, 0.440613E-01_JPRB, 0.382296E-01_JPRB &
  &, 0.330296E-01_JPRB, 0.284199E-01_JPRB, 0.243575E-01_JPRB, 0.207728E-01_JPRB &
  &, 0.176484E-01_JPRB, 0.149214E-01_JPRB, 0.125635E-01_JPRB &
  &, 0.105308E-01_JPRB, 0.878486E-02_JPRB, 0.729340E-02_JPRB, 0.603157E-02_JPRB &
  &, 0.497089E-02_JPRB, 0.406646E-02_JPRB, 0.331934E-02_JPRB &
  &, 0.269053E-02_JPRB, 0.217685E-02_JPRB, 0.174673E-02_JPRB, 0.139321E-02_JPRB &
  &, 0.110829E-02_JPRB, 0.882838E-03_JPRB, 0.691415E-03_JPRB &
  &, 0.536905E-03_JPRB, 0.422303E-03_JPRB, 0.334488E-03_JPRB, 0.258954E-03_JPRB &
  &, 0.196729E-03_JPRB, 0.148879E-03_JPRB, 0.116502E-03_JPRB &
  &, 0.825865E-04_JPRB, 0.656469E-04_JPRB, 0.479145E-04_JPRB, 0.293715E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  30, :) = (/ &
  &  0.819288E+00_JPRB, 0.776928E+00_JPRB, 0.735724E+00_JPRB, 0.695691E+00_JPRB &
  &, 0.656838E+00_JPRB, 0.619179E+00_JPRB, 0.582723E+00_JPRB &
  &, 0.547480E+00_JPRB, 0.513458E+00_JPRB, 0.480663E+00_JPRB, 0.449101E+00_JPRB &
  &, 0.418776E+00_JPRB, 0.389692E+00_JPRB, 0.361847E+00_JPRB &
  &, 0.335240E+00_JPRB, 0.309869E+00_JPRB, 0.285729E+00_JPRB, 0.262811E+00_JPRB &
  &, 0.241104E+00_JPRB, 0.220594E+00_JPRB, 0.201268E+00_JPRB &
  &, 0.183109E+00_JPRB, 0.166092E+00_JPRB, 0.150195E+00_JPRB, 0.135390E+00_JPRB &
  &, 0.121644E+00_JPRB, 0.108930E+00_JPRB, 0.972082E-01_JPRB &
  &, 0.864380E-01_JPRB, 0.765862E-01_JPRB, 0.676031E-01_JPRB, 0.594492E-01_JPRB &
  &, 0.520750E-01_JPRB, 0.454372E-01_JPRB, 0.394860E-01_JPRB &
  &, 0.341737E-01_JPRB, 0.294499E-01_JPRB, 0.252767E-01_JPRB, 0.216049E-01_JPRB &
  &, 0.183885E-01_JPRB, 0.155748E-01_JPRB, 0.131360E-01_JPRB &
  &, 0.110292E-01_JPRB, 0.922757E-02_JPRB, 0.767734E-02_JPRB, 0.636544E-02_JPRB &
  &, 0.525193E-02_JPRB, 0.430434E-02_JPRB, 0.352457E-02_JPRB &
  &, 0.286134E-02_JPRB, 0.231144E-02_JPRB, 0.187078E-02_JPRB, 0.149201E-02_JPRB &
  &, 0.119499E-02_JPRB, 0.942013E-03_JPRB, 0.751985E-03_JPRB &
  &, 0.583396E-03_JPRB, 0.454019E-03_JPRB, 0.350712E-03_JPRB, 0.275550E-03_JPRB &
  &, 0.213705E-03_JPRB, 0.166239E-03_JPRB, 0.116502E-03_JPRB &
  &, 0.825865E-04_JPRB, 0.656469E-04_JPRB, 0.479145E-04_JPRB, 0.293715E-04_JPRB &
  &, 0.297917E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  31, :) = (/ &
  &  0.820593E+00_JPRB, 0.778502E+00_JPRB, 0.737544E+00_JPRB, 0.697735E+00_JPRB &
  &, 0.659085E+00_JPRB, 0.621606E+00_JPRB, 0.585310E+00_JPRB &
  &, 0.550206E+00_JPRB, 0.516301E+00_JPRB, 0.483605E+00_JPRB, 0.452123E+00_JPRB &
  &, 0.421858E+00_JPRB, 0.392815E+00_JPRB, 0.364994E+00_JPRB &
  &, 0.338395E+00_JPRB, 0.313017E+00_JPRB, 0.288851E+00_JPRB, 0.265895E+00_JPRB &
  &, 0.244135E+00_JPRB, 0.223560E+00_JPRB, 0.204160E+00_JPRB &
  &, 0.185914E+00_JPRB, 0.168802E+00_JPRB, 0.152798E+00_JPRB, 0.137880E+00_JPRB &
  &, 0.124019E+00_JPRB, 0.111184E+00_JPRB, 0.993376E-01_JPRB &
  &, 0.884399E-01_JPRB, 0.784614E-01_JPRB, 0.693485E-01_JPRB, 0.610699E-01_JPRB &
  &, 0.535724E-01_JPRB, 0.468087E-01_JPRB, 0.407425E-01_JPRB &
  &, 0.353177E-01_JPRB, 0.304894E-01_JPRB, 0.262056E-01_JPRB, 0.224370E-01_JPRB &
  &, 0.191286E-01_JPRB, 0.162387E-01_JPRB, 0.137194E-01_JPRB &
  &, 0.115386E-01_JPRB, 0.967029E-02_JPRB, 0.806129E-02_JPRB, 0.669931E-02_JPRB &
  &, 0.553296E-02_JPRB, 0.455474E-02_JPRB, 0.372980E-02_JPRB &
  &, 0.303216E-02_JPRB, 0.245949E-02_JPRB, 0.199483E-02_JPRB, 0.160492E-02_JPRB &
  &, 0.128170E-02_JPRB, 0.101598E-02_JPRB, 0.812555E-03_JPRB &
  &, 0.629888E-03_JPRB, 0.501592E-03_JPRB, 0.383161E-03_JPRB, 0.292147E-03_JPRB &
  &, 0.230680E-03_JPRB, 0.183598E-03_JPRB, 0.134252E-03_JPRB &
  &, 0.100733E-03_JPRB, 0.656469E-04_JPRB, 0.479145E-04_JPRB, 0.293715E-04_JPRB &
  &, 0.297917E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  32, :) = (/ &
  &  0.821863E+00_JPRB, 0.780035E+00_JPRB, 0.739318E+00_JPRB, 0.699727E+00_JPRB &
  &, 0.661275E+00_JPRB, 0.623974E+00_JPRB, 0.587834E+00_JPRB &
  &, 0.552866E+00_JPRB, 0.519078E+00_JPRB, 0.486479E+00_JPRB, 0.455075E+00_JPRB &
  &, 0.424871E+00_JPRB, 0.395870E+00_JPRB, 0.368075E+00_JPRB &
  &, 0.341486E+00_JPRB, 0.316099E+00_JPRB, 0.291913E+00_JPRB, 0.268919E+00_JPRB &
  &, 0.247111E+00_JPRB, 0.226476E+00_JPRB, 0.207004E+00_JPRB &
  &, 0.188672E+00_JPRB, 0.171467E+00_JPRB, 0.155366E+00_JPRB, 0.140342E+00_JPRB &
  &, 0.126365E+00_JPRB, 0.113411E+00_JPRB, 0.101444E+00_JPRB &
  &, 0.904262E-01_JPRB, 0.803166E-01_JPRB, 0.710815E-01_JPRB, 0.626779E-01_JPRB &
  &, 0.550569E-01_JPRB, 0.481757E-01_JPRB, 0.419898E-01_JPRB &
  &, 0.364525E-01_JPRB, 0.315194E-01_JPRB, 0.271345E-01_JPRB, 0.232691E-01_JPRB &
  &, 0.198687E-01_JPRB, 0.168920E-01_JPRB, 0.143028E-01_JPRB &
  &, 0.120591E-01_JPRB, 0.101244E-01_JPRB, 0.845688E-02_JPRB, 0.703318E-02_JPRB &
  &, 0.582622E-02_JPRB, 0.480514E-02_JPRB, 0.393503E-02_JPRB &
  &, 0.321612E-02_JPRB, 0.262099E-02_JPRB, 0.211889E-02_JPRB, 0.170372E-02_JPRB &
  &, 0.136841E-02_JPRB, 0.108995E-02_JPRB, 0.873125E-03_JPRB &
  &, 0.691877E-03_JPRB, 0.533308E-03_JPRB, 0.415609E-03_JPRB, 0.325341E-03_JPRB &
  &, 0.247656E-03_JPRB, 0.200958E-03_JPRB, 0.152002E-03_JPRB &
  &, 0.118880E-03_JPRB, 0.841958E-04_JPRB, 0.668717E-04_JPRB, 0.487430E-04_JPRB &
  &, 0.297917E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  33, :) = (/ &
  &  0.823102E+00_JPRB, 0.781529E+00_JPRB, 0.741047E+00_JPRB, 0.701671E+00_JPRB &
  &, 0.663413E+00_JPRB, 0.626280E+00_JPRB, 0.590299E+00_JPRB &
  &, 0.555465E+00_JPRB, 0.521792E+00_JPRB, 0.489290E+00_JPRB, 0.457963E+00_JPRB &
  &, 0.427819E+00_JPRB, 0.398861E+00_JPRB, 0.371092E+00_JPRB &
  &, 0.344513E+00_JPRB, 0.319122E+00_JPRB, 0.294915E+00_JPRB, 0.271889E+00_JPRB &
  &, 0.250035E+00_JPRB, 0.229340E+00_JPRB, 0.209799E+00_JPRB &
  &, 0.191388E+00_JPRB, 0.174096E+00_JPRB, 0.157896E+00_JPRB, 0.142768E+00_JPRB &
  &, 0.128686E+00_JPRB, 0.115613E+00_JPRB, 0.103528E+00_JPRB &
  &, 0.923891E-01_JPRB, 0.821598E-01_JPRB, 0.728063E-01_JPRB, 0.642776E-01_JPRB &
  &, 0.565371E-01_JPRB, 0.495384E-01_JPRB, 0.432417E-01_JPRB &
  &, 0.375872E-01_JPRB, 0.325493E-01_JPRB, 0.280732E-01_JPRB, 0.241113E-01_JPRB &
  &, 0.206190E-01_JPRB, 0.175665E-01_JPRB, 0.148970E-01_JPRB &
  &, 0.125796E-01_JPRB, 0.105784E-01_JPRB, 0.885246E-02_JPRB, 0.737897E-02_JPRB &
  &, 0.611947E-02_JPRB, 0.505554E-02_JPRB, 0.415309E-02_JPRB &
  &, 0.340008E-02_JPRB, 0.276904E-02_JPRB, 0.225672E-02_JPRB, 0.181664E-02_JPRB &
  &, 0.145511E-02_JPRB, 0.116392E-02_JPRB, 0.933696E-03_JPRB &
  &, 0.738368E-03_JPRB, 0.580881E-03_JPRB, 0.448058E-03_JPRB, 0.358535E-03_JPRB &
  &, 0.281606E-03_JPRB, 0.218318E-03_JPRB, 0.152002E-03_JPRB &
  &, 0.118880E-03_JPRB, 0.841958E-04_JPRB, 0.668717E-04_JPRB, 0.487430E-04_JPRB &
  &, 0.297917E-04_JPRB, 0.302179E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  34, :) = (/ &
  &  0.824310E+00_JPRB, 0.782987E+00_JPRB, 0.742736E+00_JPRB, 0.703569E+00_JPRB &
  &, 0.665501E+00_JPRB, 0.628543E+00_JPRB, 0.592708E+00_JPRB &
  &, 0.558006E+00_JPRB, 0.524447E+00_JPRB, 0.492039E+00_JPRB, 0.460791E+00_JPRB &
  &, 0.430707E+00_JPRB, 0.401793E+00_JPRB, 0.374051E+00_JPRB &
  &, 0.347482E+00_JPRB, 0.322088E+00_JPRB, 0.297864E+00_JPRB, 0.274807E+00_JPRB &
  &, 0.252909E+00_JPRB, 0.232161E+00_JPRB, 0.212552E+00_JPRB &
  &, 0.194063E+00_JPRB, 0.176687E+00_JPRB, 0.160395E+00_JPRB, 0.145166E+00_JPRB &
  &, 0.130973E+00_JPRB, 0.117796E+00_JPRB, 0.105592E+00_JPRB &
  &, 0.943363E-01_JPRB, 0.839910E-01_JPRB, 0.745148E-01_JPRB, 0.658688E-01_JPRB &
  &, 0.580129E-01_JPRB, 0.509010E-01_JPRB, 0.444891E-01_JPRB &
  &, 0.387313E-01_JPRB, 0.335888E-01_JPRB, 0.290119E-01_JPRB, 0.249534E-01_JPRB &
  &, 0.213796E-01_JPRB, 0.182304E-01_JPRB, 0.154912E-01_JPRB &
  &, 0.131001E-01_JPRB, 0.110325E-01_JPRB, 0.925968E-02_JPRB, 0.772476E-02_JPRB &
  &, 0.642494E-02_JPRB, 0.531846E-02_JPRB, 0.438398E-02_JPRB &
  &, 0.359717E-02_JPRB, 0.293054E-02_JPRB, 0.238077E-02_JPRB, 0.192955E-02_JPRB &
  &, 0.155627E-02_JPRB, 0.125268E-02_JPRB, 0.994266E-03_JPRB &
  &, 0.784860E-03_JPRB, 0.628454E-03_JPRB, 0.496731E-03_JPRB, 0.375132E-03_JPRB &
  &, 0.298582E-03_JPRB, 0.235678E-03_JPRB, 0.169752E-03_JPRB &
  &, 0.137026E-03_JPRB, 0.102745E-03_JPRB, 0.668717E-04_JPRB, 0.487430E-04_JPRB &
  &, 0.297917E-04_JPRB, 0.302179E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  35, :) = (/ &
  &  0.825489E+00_JPRB, 0.784411E+00_JPRB, 0.744385E+00_JPRB, 0.705424E+00_JPRB &
  &, 0.667541E+00_JPRB, 0.630751E+00_JPRB, 0.595064E+00_JPRB &
  &, 0.560492E+00_JPRB, 0.527045E+00_JPRB, 0.494732E+00_JPRB, 0.463560E+00_JPRB &
  &, 0.433536E+00_JPRB, 0.404666E+00_JPRB, 0.376952E+00_JPRB &
  &, 0.350396E+00_JPRB, 0.325000E+00_JPRB, 0.300761E+00_JPRB, 0.277675E+00_JPRB &
  &, 0.255736E+00_JPRB, 0.234933E+00_JPRB, 0.215259E+00_JPRB &
  &, 0.196702E+00_JPRB, 0.179241E+00_JPRB, 0.162859E+00_JPRB, 0.147532E+00_JPRB &
  &, 0.133240E+00_JPRB, 0.119953E+00_JPRB, 0.107638E+00_JPRB &
  &, 0.962678E-01_JPRB, 0.858061E-01_JPRB, 0.762149E-01_JPRB, 0.674516E-01_JPRB &
  &, 0.594801E-01_JPRB, 0.522548E-01_JPRB, 0.457320E-01_JPRB &
  &, 0.398661E-01_JPRB, 0.346188E-01_JPRB, 0.299506E-01_JPRB, 0.257956E-01_JPRB &
  &, 0.221300E-01_JPRB, 0.189153E-01_JPRB, 0.160962E-01_JPRB &
  &, 0.136317E-01_JPRB, 0.114979E-01_JPRB, 0.966690E-02_JPRB, 0.808248E-02_JPRB &
  &, 0.673042E-02_JPRB, 0.558138E-02_JPRB, 0.461486E-02_JPRB &
  &, 0.379427E-02_JPRB, 0.310551E-02_JPRB, 0.251861E-02_JPRB, 0.204247E-02_JPRB &
  &, 0.165743E-02_JPRB, 0.132665E-02_JPRB, 0.105484E-02_JPRB &
  &, 0.846849E-03_JPRB, 0.676028E-03_JPRB, 0.529180E-03_JPRB, 0.408326E-03_JPRB &
  &, 0.315557E-03_JPRB, 0.253038E-03_JPRB, 0.187503E-03_JPRB &
  &, 0.137026E-03_JPRB, 0.102745E-03_JPRB, 0.858290E-04_JPRB, 0.681145E-04_JPRB &
  &, 0.495834E-04_JPRB, 0.302179E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART6

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART6',0,ZHOOK_HANDLE)

XCW(  36, :) = (/ &
  &  0.826642E+00_JPRB, 0.785803E+00_JPRB, 0.745996E+00_JPRB, 0.707237E+00_JPRB &
  &, 0.669537E+00_JPRB, 0.632911E+00_JPRB, 0.597370E+00_JPRB &
  &, 0.562926E+00_JPRB, 0.529589E+00_JPRB, 0.497370E+00_JPRB, 0.466275E+00_JPRB &
  &, 0.436310E+00_JPRB, 0.407484E+00_JPRB, 0.379800E+00_JPRB &
  &, 0.353259E+00_JPRB, 0.327862E+00_JPRB, 0.303609E+00_JPRB, 0.280496E+00_JPRB &
  &, 0.258517E+00_JPRB, 0.237665E+00_JPRB, 0.217931E+00_JPRB &
  &, 0.199302E+00_JPRB, 0.181760E+00_JPRB, 0.165291E+00_JPRB, 0.149873E+00_JPRB &
  &, 0.135480E+00_JPRB, 0.122088E+00_JPRB, 0.109664E+00_JPRB &
  &, 0.981838E-01_JPRB, 0.876092E-01_JPRB, 0.779028E-01_JPRB, 0.690260E-01_JPRB &
  &, 0.609387E-01_JPRB, 0.536042E-01_JPRB, 0.469748E-01_JPRB &
  &, 0.410101E-01_JPRB, 0.356583E-01_JPRB, 0.308893E-01_JPRB, 0.266477E-01_JPRB &
  &, 0.229009E-01_JPRB, 0.195898E-01_JPRB, 0.167011E-01_JPRB &
  &, 0.141743E-01_JPRB, 0.119747E-01_JPRB, 0.100741E-01_JPRB, 0.844020E-02_JPRB &
  &, 0.704811E-02_JPRB, 0.585681E-02_JPRB, 0.484574E-02_JPRB &
  &, 0.399137E-02_JPRB, 0.326701E-02_JPRB, 0.267023E-02_JPRB, 0.216950E-02_JPRB &
  &, 0.175859E-02_JPRB, 0.141542E-02_JPRB, 0.113055E-02_JPRB &
  &, 0.908837E-03_JPRB, 0.707744E-03_JPRB, 0.561629E-03_JPRB, 0.441520E-03_JPRB &
  &, 0.349508E-03_JPRB, 0.270398E-03_JPRB, 0.205253E-03_JPRB &
  &, 0.155173E-03_JPRB, 0.121294E-03_JPRB, 0.858290E-04_JPRB, 0.681145E-04_JPRB &
  &, 0.495834E-04_JPRB, 0.302179E-04_JPRB, 0.306500E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  37, :) = (/ &
  &  0.827767E+00_JPRB, 0.787164E+00_JPRB, 0.747573E+00_JPRB, 0.709011E+00_JPRB &
  &, 0.671491E+00_JPRB, 0.635026E+00_JPRB, 0.599629E+00_JPRB &
  &, 0.565311E+00_JPRB, 0.532084E+00_JPRB, 0.499956E+00_JPRB, 0.468937E+00_JPRB &
  &, 0.439034E+00_JPRB, 0.410251E+00_JPRB, 0.382597E+00_JPRB &
  &, 0.356070E+00_JPRB, 0.330675E+00_JPRB, 0.306410E+00_JPRB, 0.283271E+00_JPRB &
  &, 0.261256E+00_JPRB, 0.240358E+00_JPRB, 0.220564E+00_JPRB &
  &, 0.201868E+00_JPRB, 0.184250E+00_JPRB, 0.167696E+00_JPRB, 0.152186E+00_JPRB &
  &, 0.137695E+00_JPRB, 0.124200E+00_JPRB, 0.111675E+00_JPRB &
  &, 0.100084E+00_JPRB, 0.893963E-01_JPRB, 0.795784E-01_JPRB, 0.705919E-01_JPRB &
  &, 0.623973E-01_JPRB, 0.549535E-01_JPRB, 0.482176E-01_JPRB &
  &, 0.421449E-01_JPRB, 0.366978E-01_JPRB, 0.318280E-01_JPRB, 0.274999E-01_JPRB &
  &, 0.236615E-01_JPRB, 0.202747E-01_JPRB, 0.173061E-01_JPRB &
  &, 0.147170E-01_JPRB, 0.124515E-01_JPRB, 0.104930E-01_JPRB, 0.880984E-02_JPRB &
  &, 0.736580E-02_JPRB, 0.613225E-02_JPRB, 0.507663E-02_JPRB &
  &, 0.418847E-02_JPRB, 0.344197E-02_JPRB, 0.280806E-02_JPRB, 0.229653E-02_JPRB &
  &, 0.185975E-02_JPRB, 0.150418E-02_JPRB, 0.120626E-02_JPRB &
  &, 0.955329E-03_JPRB, 0.771175E-03_JPRB, 0.610302E-03_JPRB, 0.474713E-03_JPRB &
  &, 0.366483E-03_JPRB, 0.287757E-03_JPRB, 0.223003E-03_JPRB &
  &, 0.173320E-03_JPRB, 0.139843E-03_JPRB, 0.104786E-03_JPRB, 0.681145E-04_JPRB &
  &, 0.495834E-04_JPRB, 0.302179E-04_JPRB, 0.306500E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  38, :) = (/ &
  &  0.828871E+00_JPRB, 0.788496E+00_JPRB, 0.749117E+00_JPRB, 0.710749E+00_JPRB &
  &, 0.673404E+00_JPRB, 0.637098E+00_JPRB, 0.601842E+00_JPRB &
  &, 0.567649E+00_JPRB, 0.534530E+00_JPRB, 0.502494E+00_JPRB, 0.471550E+00_JPRB &
  &, 0.441706E+00_JPRB, 0.412970E+00_JPRB, 0.385344E+00_JPRB &
  &, 0.358834E+00_JPRB, 0.333442E+00_JPRB, 0.309165E+00_JPRB, 0.286005E+00_JPRB &
  &, 0.263955E+00_JPRB, 0.243010E+00_JPRB, 0.223161E+00_JPRB &
  &, 0.204398E+00_JPRB, 0.186709E+00_JPRB, 0.170070E+00_JPRB, 0.154473E+00_JPRB &
  &, 0.139889E+00_JPRB, 0.126297E+00_JPRB, 0.113667E+00_JPRB &
  &, 0.101969E+00_JPRB, 0.911754E-01_JPRB, 0.812498E-01_JPRB, 0.721537E-01_JPRB &
  &, 0.638473E-01_JPRB, 0.562940E-01_JPRB, 0.494559E-01_JPRB &
  &, 0.432796E-01_JPRB, 0.377373E-01_JPRB, 0.327765E-01_JPRB, 0.283521E-01_JPRB &
  &, 0.244325E-01_JPRB, 0.209703E-01_JPRB, 0.179219E-01_JPRB &
  &, 0.152596E-01_JPRB, 0.129396E-01_JPRB, 0.109235E-01_JPRB, 0.917948E-02_JPRB &
  &, 0.768350E-02_JPRB, 0.640769E-02_JPRB, 0.532034E-02_JPRB &
  &, 0.439870E-02_JPRB, 0.361694E-02_JPRB, 0.295968E-02_JPRB, 0.242356E-02_JPRB &
  &, 0.196090E-02_JPRB, 0.159294E-02_JPRB, 0.128197E-02_JPRB &
  &, 0.101732E-02_JPRB, 0.818748E-03_JPRB, 0.642751E-03_JPRB, 0.507907E-03_JPRB &
  &, 0.400434E-03_JPRB, 0.305117E-03_JPRB, 0.240753E-03_JPRB &
  &, 0.191466E-03_JPRB, 0.139843E-03_JPRB, 0.104786E-03_JPRB, 0.874860E-04_JPRB &
  &, 0.495834E-04_JPRB, 0.504358E-04_JPRB, 0.306500E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  39, :) = (/ &
  &  0.829949E+00_JPRB, 0.789801E+00_JPRB, 0.750629E+00_JPRB, 0.712451E+00_JPRB &
  &, 0.675280E+00_JPRB, 0.639129E+00_JPRB, 0.604013E+00_JPRB &
  &, 0.569942E+00_JPRB, 0.536929E+00_JPRB, 0.504984E+00_JPRB, 0.474116E+00_JPRB &
  &, 0.444331E+00_JPRB, 0.415640E+00_JPRB, 0.388046E+00_JPRB &
  &, 0.361553E+00_JPRB, 0.336164E+00_JPRB, 0.311879E+00_JPRB, 0.288697E+00_JPRB &
  &, 0.266615E+00_JPRB, 0.245624E+00_JPRB, 0.225723E+00_JPRB &
  &, 0.206897E+00_JPRB, 0.189137E+00_JPRB, 0.172420E+00_JPRB, 0.156736E+00_JPRB &
  &, 0.142060E+00_JPRB, 0.128372E+00_JPRB, 0.115640E+00_JPRB &
  &, 0.103842E+00_JPRB, 0.929424E-01_JPRB, 0.829090E-01_JPRB, 0.737028E-01_JPRB &
  &, 0.652929E-01_JPRB, 0.576346E-01_JPRB, 0.506942E-01_JPRB &
  &, 0.444144E-01_JPRB, 0.387768E-01_JPRB, 0.337250E-01_JPRB, 0.292143E-01_JPRB &
  &, 0.252034E-01_JPRB, 0.216658E-01_JPRB, 0.185485E-01_JPRB &
  &, 0.158134E-01_JPRB, 0.134277E-01_JPRB, 0.113539E-01_JPRB, 0.956105E-02_JPRB &
  &, 0.801341E-02_JPRB, 0.669565E-02_JPRB, 0.556405E-02_JPRB &
  &, 0.460894E-02_JPRB, 0.379190E-02_JPRB, 0.311130E-02_JPRB, 0.255059E-02_JPRB &
  &, 0.207651E-02_JPRB, 0.168171E-02_JPRB, 0.135769E-02_JPRB &
  &, 0.107931E-02_JPRB, 0.866322E-03_JPRB, 0.691424E-03_JPRB, 0.541101E-03_JPRB &
  &, 0.434385E-03_JPRB, 0.339837E-03_JPRB, 0.258504E-03_JPRB &
  &, 0.209613E-03_JPRB, 0.158392E-03_JPRB, 0.123743E-03_JPRB, 0.874860E-04_JPRB &
  &, 0.693751E-04_JPRB, 0.504358E-04_JPRB, 0.306500E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  40, :) = (/ &
  &  0.831007E+00_JPRB, 0.791079E+00_JPRB, 0.752111E+00_JPRB, 0.714120E+00_JPRB &
  &, 0.677119E+00_JPRB, 0.641122E+00_JPRB, 0.606143E+00_JPRB &
  &, 0.572193E+00_JPRB, 0.539286E+00_JPRB, 0.507430E+00_JPRB, 0.476636E+00_JPRB &
  &, 0.446913E+00_JPRB, 0.418266E+00_JPRB, 0.390703E+00_JPRB &
  &, 0.364228E+00_JPRB, 0.338844E+00_JPRB, 0.314552E+00_JPRB, 0.291350E+00_JPRB &
  &, 0.269237E+00_JPRB, 0.248207E+00_JPRB, 0.228252E+00_JPRB &
  &, 0.209367E+00_JPRB, 0.191535E+00_JPRB, 0.174745E+00_JPRB, 0.158978E+00_JPRB &
  &, 0.144213E+00_JPRB, 0.130429E+00_JPRB, 0.117602E+00_JPRB &
  &, 0.105699E+00_JPRB, 0.946975E-01_JPRB, 0.845599E-01_JPRB, 0.752477E-01_JPRB &
  &, 0.667343E-01_JPRB, 0.589751E-01_JPRB, 0.519280E-01_JPRB &
  &, 0.455584E-01_JPRB, 0.398163E-01_JPRB, 0.346735E-01_JPRB, 0.300764E-01_JPRB &
  &, 0.259846E-01_JPRB, 0.223613E-01_JPRB, 0.191751E-01_JPRB &
  &, 0.163671E-01_JPRB, 0.139158E-01_JPRB, 0.117844E-01_JPRB, 0.994261E-02_JPRB &
  &, 0.834332E-02_JPRB, 0.698361E-02_JPRB, 0.582059E-02_JPRB &
  &, 0.481918E-02_JPRB, 0.398032E-02_JPRB, 0.327670E-02_JPRB, 0.267762E-02_JPRB &
  &, 0.219212E-02_JPRB, 0.177047E-02_JPRB, 0.143340E-02_JPRB &
  &, 0.115679E-02_JPRB, 0.929753E-03_JPRB, 0.740097E-03_JPRB, 0.590892E-03_JPRB &
  &, 0.451360E-03_JPRB, 0.357197E-03_JPRB, 0.276254E-03_JPRB &
  &, 0.209613E-03_JPRB, 0.158392E-03_JPRB, 0.123743E-03_JPRB, 0.874860E-04_JPRB &
  &, 0.693751E-04_JPRB, 0.504358E-04_JPRB, 0.306500E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  41, :) = (/ &
  &  0.832042E+00_JPRB, 0.792332E+00_JPRB, 0.753564E+00_JPRB, 0.715757E+00_JPRB &
  &, 0.678923E+00_JPRB, 0.643078E+00_JPRB, 0.608234E+00_JPRB &
  &, 0.574404E+00_JPRB, 0.541601E+00_JPRB, 0.509834E+00_JPRB, 0.479115E+00_JPRB &
  &, 0.449451E+00_JPRB, 0.420849E+00_JPRB, 0.393318E+00_JPRB &
  &, 0.366863E+00_JPRB, 0.341484E+00_JPRB, 0.317185E+00_JPRB, 0.293966E+00_JPRB &
  &, 0.271822E+00_JPRB, 0.250754E+00_JPRB, 0.230752E+00_JPRB &
  &, 0.211804E+00_JPRB, 0.193909E+00_JPRB, 0.177042E+00_JPRB, 0.161194E+00_JPRB &
  &, 0.146345E+00_JPRB, 0.132466E+00_JPRB, 0.119544E+00_JPRB &
  &, 0.107544E+00_JPRB, 0.964405E-01_JPRB, 0.861985E-01_JPRB, 0.767884E-01_JPRB &
  &, 0.681713E-01_JPRB, 0.603067E-01_JPRB, 0.531618E-01_JPRB &
  &, 0.466932E-01_JPRB, 0.408558E-01_JPRB, 0.356220E-01_JPRB, 0.309386E-01_JPRB &
  &, 0.267657E-01_JPRB, 0.230673E-01_JPRB, 0.198017E-01_JPRB &
  &, 0.169319E-01_JPRB, 0.144153E-01_JPRB, 0.122266E-01_JPRB, 0.103242E-01_JPRB &
  &, 0.868545E-02_JPRB, 0.727157E-02_JPRB, 0.607713E-02_JPRB &
  &, 0.504256E-02_JPRB, 0.416874E-02_JPRB, 0.344211E-02_JPRB, 0.281876E-02_JPRB &
  &, 0.230773E-02_JPRB, 0.187403E-02_JPRB, 0.150911E-02_JPRB &
  &, 0.121878E-02_JPRB, 0.977326E-03_JPRB, 0.788770E-03_JPRB, 0.624086E-03_JPRB &
  &, 0.485311E-03_JPRB, 0.391917E-03_JPRB, 0.294004E-03_JPRB &
  &, 0.227760E-03_JPRB, 0.176941E-03_JPRB, 0.142701E-03_JPRB, 0.106858E-03_JPRB &
  &, 0.693751E-04_JPRB, 0.504358E-04_JPRB, 0.513000E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  42, :) = (/ &
  &  0.833059E+00_JPRB, 0.793561E+00_JPRB, 0.754990E+00_JPRB, 0.717364E+00_JPRB &
  &, 0.680694E+00_JPRB, 0.644998E+00_JPRB, 0.610288E+00_JPRB &
  &, 0.576576E+00_JPRB, 0.543875E+00_JPRB, 0.512197E+00_JPRB, 0.481552E+00_JPRB &
  &, 0.451947E+00_JPRB, 0.423392E+00_JPRB, 0.395894E+00_JPRB &
  &, 0.369458E+00_JPRB, 0.344086E+00_JPRB, 0.319781E+00_JPRB, 0.296545E+00_JPRB &
  &, 0.274375E+00_JPRB, 0.253267E+00_JPRB, 0.233216E+00_JPRB &
  &, 0.214218E+00_JPRB, 0.196256E+00_JPRB, 0.179319E+00_JPRB, 0.163390E+00_JPRB &
  &, 0.148455E+00_JPRB, 0.134489E+00_JPRB, 0.121475E+00_JPRB &
  &, 0.109378E+00_JPRB, 0.981755E-01_JPRB, 0.878330E-01_JPRB, 0.783207E-01_JPRB &
  &, 0.696040E-01_JPRB, 0.616384E-01_JPRB, 0.543955E-01_JPRB &
  &, 0.478280E-01_JPRB, 0.419049E-01_JPRB, 0.365704E-01_JPRB, 0.318008E-01_JPRB &
  &, 0.275469E-01_JPRB, 0.237734E-01_JPRB, 0.204391E-01_JPRB &
  &, 0.174967E-01_JPRB, 0.149148E-01_JPRB, 0.126687E-01_JPRB, 0.107177E-01_JPRB &
  &, 0.902758E-02_JPRB, 0.757205E-02_JPRB, 0.633367E-02_JPRB &
  &, 0.526593E-02_JPRB, 0.437062E-02_JPRB, 0.360751E-02_JPRB, 0.295990E-02_JPRB &
  &, 0.242334E-02_JPRB, 0.197758E-02_JPRB, 0.159997E-02_JPRB &
  &, 0.129627E-02_JPRB, 0.104076E-02_JPRB, 0.837443E-03_JPRB, 0.657279E-03_JPRB &
  &, 0.519262E-03_JPRB, 0.409276E-03_JPRB, 0.329505E-03_JPRB &
  &, 0.245906E-03_JPRB, 0.195490E-03_JPRB, 0.142701E-03_JPRB, 0.106858E-03_JPRB &
  &, 0.891668E-04_JPRB, 0.706537E-04_JPRB, 0.513000E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.315322E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART7

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART7',0,ZHOOK_HANDLE)

XCW(  43, :) = (/ &
  &  0.834056E+00_JPRB, 0.794767E+00_JPRB, 0.756390E+00_JPRB, 0.718941E+00_JPRB &
  &, 0.682434E+00_JPRB, 0.646884E+00_JPRB, 0.612306E+00_JPRB &
  &, 0.578711E+00_JPRB, 0.546112E+00_JPRB, 0.514522E+00_JPRB, 0.483950E+00_JPRB &
  &, 0.454404E+00_JPRB, 0.425895E+00_JPRB, 0.398430E+00_JPRB &
  &, 0.372013E+00_JPRB, 0.346650E+00_JPRB, 0.322342E+00_JPRB, 0.299091E+00_JPRB &
  &, 0.276895E+00_JPRB, 0.255751E+00_JPRB, 0.235655E+00_JPRB &
  &, 0.216602E+00_JPRB, 0.198576E+00_JPRB, 0.181568E+00_JPRB, 0.165568E+00_JPRB &
  &, 0.150550E+00_JPRB, 0.136497E+00_JPRB, 0.123391E+00_JPRB &
  &, 0.111200E+00_JPRB, 0.998984E-01_JPRB, 0.894592E-01_JPRB, 0.798488E-01_JPRB &
  &, 0.710281E-01_JPRB, 0.629701E-01_JPRB, 0.556293E-01_JPRB &
  &, 0.489627E-01_JPRB, 0.429444E-01_JPRB, 0.375287E-01_JPRB, 0.326731E-01_JPRB &
  &, 0.283384E-01_JPRB, 0.244794E-01_JPRB, 0.210765E-01_JPRB &
  &, 0.180615E-01_JPRB, 0.154256E-01_JPRB, 0.131224E-01_JPRB, 0.111112E-01_JPRB &
  &, 0.938193E-02_JPRB, 0.788505E-02_JPRB, 0.659020E-02_JPRB &
  &, 0.548931E-02_JPRB, 0.455905E-02_JPRB, 0.377291E-02_JPRB, 0.310105E-02_JPRB &
  &, 0.253895E-02_JPRB, 0.208114E-02_JPRB, 0.169082E-02_JPRB &
  &, 0.135826E-02_JPRB, 0.110419E-02_JPRB, 0.886116E-03_JPRB, 0.707070E-03_JPRB &
  &, 0.553213E-03_JPRB, 0.443996E-03_JPRB, 0.347255E-03_JPRB &
  &, 0.264053E-03_JPRB, 0.214039E-03_JPRB, 0.161658E-03_JPRB, 0.126229E-03_JPRB &
  &, 0.891668E-04_JPRB, 0.706537E-04_JPRB, 0.513000E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.315322E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  44, :) = (/ &
  &  0.835035E+00_JPRB, 0.795952E+00_JPRB, 0.757765E+00_JPRB, 0.720491E+00_JPRB &
  &, 0.684143E+00_JPRB, 0.648739E+00_JPRB, 0.614290E+00_JPRB &
  &, 0.580811E+00_JPRB, 0.548313E+00_JPRB, 0.516809E+00_JPRB, 0.486310E+00_JPRB &
  &, 0.456824E+00_JPRB, 0.428361E+00_JPRB, 0.400930E+00_JPRB &
  &, 0.374533E+00_JPRB, 0.349179E+00_JPRB, 0.324868E+00_JPRB, 0.301603E+00_JPRB &
  &, 0.279382E+00_JPRB, 0.258203E+00_JPRB, 0.238067E+00_JPRB &
  &, 0.218959E+00_JPRB, 0.200872E+00_JPRB, 0.183799E+00_JPRB, 0.167720E+00_JPRB &
  &, 0.152623E+00_JPRB, 0.138490E+00_JPRB, 0.125291E+00_JPRB &
  &, 0.113007E+00_JPRB, 0.101613E+00_JPRB, 0.910773E-01_JPRB, 0.813684E-01_JPRB &
  &, 0.724521E-01_JPRB, 0.642929E-01_JPRB, 0.568585E-01_JPRB &
  &, 0.500975E-01_JPRB, 0.439934E-01_JPRB, 0.384870E-01_JPRB, 0.335453E-01_JPRB &
  &, 0.291299E-01_JPRB, 0.251960E-01_JPRB, 0.217139E-01_JPRB &
  &, 0.186374E-01_JPRB, 0.159364E-01_JPRB, 0.135762E-01_JPRB, 0.115166E-01_JPRB &
  &, 0.973628E-02_JPRB, 0.818552E-02_JPRB, 0.685957E-02_JPRB &
  &, 0.572583E-02_JPRB, 0.476093E-02_JPRB, 0.393831E-02_JPRB, 0.325631E-02_JPRB &
  &, 0.266901E-02_JPRB, 0.218470E-02_JPRB, 0.178168E-02_JPRB &
  &, 0.143574E-02_JPRB, 0.116762E-02_JPRB, 0.934789E-03_JPRB, 0.740264E-03_JPRB &
  &, 0.587163E-03_JPRB, 0.461356E-03_JPRB, 0.365005E-03_JPRB &
  &, 0.282199E-03_JPRB, 0.232587E-03_JPRB, 0.180615E-03_JPRB, 0.126229E-03_JPRB &
  &, 0.108959E-03_JPRB, 0.706537E-04_JPRB, 0.513000E-04_JPRB &
  &, 0.310881E-04_JPRB, 0.315322E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  45, :) = (/ &
  &  0.835997E+00_JPRB, 0.797115E+00_JPRB, 0.759115E+00_JPRB, 0.722014E+00_JPRB &
  &, 0.685824E+00_JPRB, 0.650562E+00_JPRB, 0.616241E+00_JPRB &
  &, 0.582876E+00_JPRB, 0.550479E+00_JPRB, 0.519061E+00_JPRB, 0.488634E+00_JPRB &
  &, 0.459208E+00_JPRB, 0.430792E+00_JPRB, 0.403393E+00_JPRB &
  &, 0.377019E+00_JPRB, 0.351673E+00_JPRB, 0.327361E+00_JPRB, 0.304083E+00_JPRB &
  &, 0.281840E+00_JPRB, 0.260630E+00_JPRB, 0.240450E+00_JPRB &
  &, 0.221290E+00_JPRB, 0.203147E+00_JPRB, 0.186007E+00_JPRB, 0.169859E+00_JPRB &
  &, 0.154682E+00_JPRB, 0.140464E+00_JPRB, 0.127180E+00_JPRB &
  &, 0.114805E+00_JPRB, 0.103320E+00_JPRB, 0.926871E-01_JPRB, 0.828839E-01_JPRB &
  &, 0.738719E-01_JPRB, 0.656201E-01_JPRB, 0.580878E-01_JPRB &
  &, 0.512415E-01_JPRB, 0.450425E-01_JPRB, 0.394452E-01_JPRB, 0.344175E-01_JPRB &
  &, 0.299213E-01_JPRB, 0.259232E-01_JPRB, 0.223621E-01_JPRB &
  &, 0.192243E-01_JPRB, 0.164586E-01_JPRB, 0.140416E-01_JPRB, 0.119220E-01_JPRB &
  &, 0.100906E-01_JPRB, 0.849852E-02_JPRB, 0.714176E-02_JPRB &
  &, 0.596234E-02_JPRB, 0.496281E-02_JPRB, 0.411750E-02_JPRB, 0.339745E-02_JPRB &
  &, 0.279907E-02_JPRB, 0.228825E-02_JPRB, 0.187253E-02_JPRB &
  &, 0.151323E-02_JPRB, 0.123105E-02_JPRB, 0.983462E-03_JPRB, 0.790054E-03_JPRB &
  &, 0.621114E-03_JPRB, 0.496076E-03_JPRB, 0.400506E-03_JPRB &
  &, 0.300346E-03_JPRB, 0.232587E-03_JPRB, 0.180615E-03_JPRB, 0.145600E-03_JPRB &
  &, 0.108959E-03_JPRB, 0.908716E-04_JPRB, 0.513000E-04_JPRB &
  &, 0.521762E-04_JPRB, 0.315322E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  46, :) = (/ &
  &  0.836941E+00_JPRB, 0.798259E+00_JPRB, 0.760443E+00_JPRB, 0.723511E+00_JPRB &
  &, 0.687477E+00_JPRB, 0.652355E+00_JPRB, 0.618162E+00_JPRB &
  &, 0.584909E+00_JPRB, 0.552610E+00_JPRB, 0.521278E+00_JPRB, 0.490923E+00_JPRB &
  &, 0.461556E+00_JPRB, 0.433187E+00_JPRB, 0.405822E+00_JPRB &
  &, 0.379470E+00_JPRB, 0.354135E+00_JPRB, 0.329823E+00_JPRB, 0.306534E+00_JPRB &
  &, 0.284269E+00_JPRB, 0.263029E+00_JPRB, 0.242807E+00_JPRB &
  &, 0.223601E+00_JPRB, 0.205399E+00_JPRB, 0.188197E+00_JPRB, 0.171976E+00_JPRB &
  &, 0.156726E+00_JPRB, 0.142424E+00_JPRB, 0.129054E+00_JPRB &
  &, 0.116596E+00_JPRB, 0.105015E+00_JPRB, 0.942929E-01_JPRB, 0.843909E-01_JPRB &
  &, 0.752873E-01_JPRB, 0.669385E-01_JPRB, 0.593170E-01_JPRB &
  &, 0.523763E-01_JPRB, 0.460820E-01_JPRB, 0.404035E-01_JPRB, 0.352997E-01_JPRB &
  &, 0.307231E-01_JPRB, 0.266398E-01_JPRB, 0.230211E-01_JPRB &
  &, 0.198113E-01_JPRB, 0.169808E-01_JPRB, 0.144953E-01_JPRB, 0.123393E-01_JPRB &
  &, 0.104450E-01_JPRB, 0.882404E-02_JPRB, 0.741113E-02_JPRB &
  &, 0.621200E-02_JPRB, 0.517815E-02_JPRB, 0.429669E-02_JPRB, 0.355271E-02_JPRB &
  &, 0.292913E-02_JPRB, 0.240661E-02_JPRB, 0.196339E-02_JPRB &
  &, 0.159071E-02_JPRB, 0.129448E-02_JPRB, 0.103214E-02_JPRB, 0.839845E-03_JPRB &
  &, 0.672040E-03_JPRB, 0.530795E-03_JPRB, 0.418256E-03_JPRB &
  &, 0.336639E-03_JPRB, 0.251136E-03_JPRB, 0.199572E-03_JPRB, 0.145600E-03_JPRB &
  &, 0.108959E-03_JPRB, 0.908716E-04_JPRB, 0.719501E-04_JPRB &
  &, 0.521762E-04_JPRB, 0.315322E-04_JPRB, 0.319822E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  47, :) = (/ &
  &  0.837869E+00_JPRB, 0.799384E+00_JPRB, 0.761750E+00_JPRB, 0.724984E+00_JPRB &
  &, 0.689103E+00_JPRB, 0.654120E+00_JPRB, 0.620052E+00_JPRB &
  &, 0.586910E+00_JPRB, 0.554710E+00_JPRB, 0.523463E+00_JPRB, 0.493180E+00_JPRB &
  &, 0.463872E+00_JPRB, 0.435549E+00_JPRB, 0.408219E+00_JPRB &
  &, 0.381890E+00_JPRB, 0.356566E+00_JPRB, 0.332253E+00_JPRB, 0.308955E+00_JPRB &
  &, 0.286669E+00_JPRB, 0.265398E+00_JPRB, 0.245139E+00_JPRB &
  &, 0.225885E+00_JPRB, 0.207631E+00_JPRB, 0.190366E+00_JPRB, 0.174076E+00_JPRB &
  &, 0.158752E+00_JPRB, 0.144372E+00_JPRB, 0.130920E+00_JPRB &
  &, 0.118371E+00_JPRB, 0.106702E+00_JPRB, 0.958904E-01_JPRB, 0.858979E-01_JPRB &
  &, 0.766985E-01_JPRB, 0.682569E-01_JPRB, 0.605417E-01_JPRB &
  &, 0.535111E-01_JPRB, 0.471310E-01_JPRB, 0.413715E-01_JPRB, 0.361820E-01_JPRB &
  &, 0.315248E-01_JPRB, 0.273669E-01_JPRB, 0.236693E-01_JPRB &
  &, 0.203982E-01_JPRB, 0.175030E-01_JPRB, 0.149724E-01_JPRB, 0.127447E-01_JPRB &
  &, 0.108115E-01_JPRB, 0.913704E-02_JPRB, 0.769332E-02_JPRB &
  &, 0.644852E-02_JPRB, 0.538003E-02_JPRB, 0.447587E-02_JPRB, 0.370797E-02_JPRB &
  &, 0.305919E-02_JPRB, 0.251016E-02_JPRB, 0.205424E-02_JPRB &
  &, 0.166820E-02_JPRB, 0.135791E-02_JPRB, 0.109703E-02_JPRB, 0.889636E-03_JPRB &
  &, 0.705991E-03_JPRB, 0.565515E-03_JPRB, 0.453756E-03_JPRB &
  &, 0.354786E-03_JPRB, 0.269685E-03_JPRB, 0.218530E-03_JPRB, 0.164972E-03_JPRB &
  &, 0.128750E-03_JPRB, 0.908716E-04_JPRB, 0.719501E-04_JPRB &
  &, 0.521762E-04_JPRB, 0.315322E-04_JPRB, 0.319822E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  48, :) = (/ &
  &  0.838783E+00_JPRB, 0.800490E+00_JPRB, 0.763034E+00_JPRB, 0.726434E+00_JPRB &
  &, 0.690703E+00_JPRB, 0.655858E+00_JPRB, 0.621913E+00_JPRB &
  &, 0.588882E+00_JPRB, 0.556778E+00_JPRB, 0.525616E+00_JPRB, 0.495405E+00_JPRB &
  &, 0.466155E+00_JPRB, 0.437879E+00_JPRB, 0.410584E+00_JPRB &
  &, 0.384278E+00_JPRB, 0.358967E+00_JPRB, 0.334655E+00_JPRB, 0.311347E+00_JPRB &
  &, 0.289043E+00_JPRB, 0.267743E+00_JPRB, 0.247447E+00_JPRB &
  &, 0.228146E+00_JPRB, 0.209839E+00_JPRB, 0.192514E+00_JPRB, 0.176157E+00_JPRB &
  &, 0.160763E+00_JPRB, 0.146306E+00_JPRB, 0.132771E+00_JPRB &
  &, 0.120139E+00_JPRB, 0.108385E+00_JPRB, 0.974797E-01_JPRB, 0.873965E-01_JPRB &
  &, 0.781053E-01_JPRB, 0.695753E-01_JPRB, 0.617664E-01_JPRB &
  &, 0.546458E-01_JPRB, 0.481896E-01_JPRB, 0.423395E-01_JPRB, 0.370642E-01_JPRB &
  &, 0.323369E-01_JPRB, 0.281046E-01_JPRB, 0.243283E-01_JPRB &
  &, 0.209962E-01_JPRB, 0.180365E-01_JPRB, 0.154494E-01_JPRB, 0.131740E-01_JPRB &
  &, 0.111903E-01_JPRB, 0.946256E-02_JPRB, 0.797551E-02_JPRB &
  &, 0.669818E-02_JPRB, 0.560883E-02_JPRB, 0.466884E-02_JPRB, 0.387734E-02_JPRB &
  &, 0.320370E-02_JPRB, 0.262851E-02_JPRB, 0.216024E-02_JPRB &
  &, 0.176118E-02_JPRB, 0.142134E-02_JPRB, 0.116193E-02_JPRB, 0.922830E-03_JPRB &
  &, 0.739942E-03_JPRB, 0.600235E-03_JPRB, 0.471507E-03_JPRB &
  &, 0.372933E-03_JPRB, 0.288234E-03_JPRB, 0.237487E-03_JPRB, 0.184343E-03_JPRB &
  &, 0.128750E-03_JPRB, 0.111089E-03_JPRB, 0.719501E-04_JPRB &
  &, 0.521762E-04_JPRB, 0.315322E-04_JPRB, 0.319822E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  49, :) = (/ &
  &  0.839682E+00_JPRB, 0.801578E+00_JPRB, 0.764299E+00_JPRB, 0.727861E+00_JPRB &
  &, 0.692279E+00_JPRB, 0.657570E+00_JPRB, 0.623747E+00_JPRB &
  &, 0.590825E+00_JPRB, 0.558818E+00_JPRB, 0.527739E+00_JPRB, 0.497598E+00_JPRB &
  &, 0.468408E+00_JPRB, 0.440179E+00_JPRB, 0.412918E+00_JPRB &
  &, 0.386636E+00_JPRB, 0.361338E+00_JPRB, 0.337029E+00_JPRB, 0.313712E+00_JPRB &
  &, 0.291391E+00_JPRB, 0.270065E+00_JPRB, 0.249730E+00_JPRB &
  &, 0.230388E+00_JPRB, 0.212030E+00_JPRB, 0.194645E+00_JPRB, 0.178225E+00_JPRB &
  &, 0.162757E+00_JPRB, 0.148228E+00_JPRB, 0.134614E+00_JPRB &
  &, 0.121898E+00_JPRB, 0.110056E+00_JPRB, 0.990608E-01_JPRB, 0.888909E-01_JPRB &
  &, 0.795121E-01_JPRB, 0.708893E-01_JPRB, 0.629911E-01_JPRB &
  &, 0.557899E-01_JPRB, 0.492386E-01_JPRB, 0.433076E-01_JPRB, 0.379465E-01_JPRB &
  &, 0.331386E-01_JPRB, 0.288317E-01_JPRB, 0.249981E-01_JPRB &
  &, 0.215943E-01_JPRB, 0.185814E-01_JPRB, 0.159264E-01_JPRB, 0.135913E-01_JPRB &
  &, 0.115691E-01_JPRB, 0.980060E-02_JPRB, 0.827053E-02_JPRB &
  &, 0.694783E-02_JPRB, 0.582417E-02_JPRB, 0.486181E-02_JPRB, 0.403260E-02_JPRB &
  &, 0.333376E-02_JPRB, 0.274687E-02_JPRB, 0.225110E-02_JPRB &
  &, 0.183867E-02_JPRB, 0.150063E-02_JPRB, 0.121060E-02_JPRB, 0.989217E-03_JPRB &
  &, 0.790868E-03_JPRB, 0.634954E-03_JPRB, 0.507007E-03_JPRB &
  &, 0.391079E-03_JPRB, 0.306783E-03_JPRB, 0.237487E-03_JPRB, 0.184343E-03_JPRB &
  &, 0.148542E-03_JPRB, 0.111089E-03_JPRB, 0.926001E-04_JPRB &
  &, 0.521762E-04_JPRB, 0.530643E-04_JPRB, 0.319822E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART8

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART8',0,ZHOOK_HANDLE)

XCW(  50, :) = (/ &
  &  0.840566E+00_JPRB, 0.802650E+00_JPRB, 0.765543E+00_JPRB, 0.729266E+00_JPRB &
  &, 0.693831E+00_JPRB, 0.659256E+00_JPRB, 0.625554E+00_JPRB &
  &, 0.592741E+00_JPRB, 0.560829E+00_JPRB, 0.529832E+00_JPRB, 0.499762E+00_JPRB &
  &, 0.470631E+00_JPRB, 0.442448E+00_JPRB, 0.415223E+00_JPRB &
  &, 0.388966E+00_JPRB, 0.363680E+00_JPRB, 0.339374E+00_JPRB, 0.316052E+00_JPRB &
  &, 0.293714E+00_JPRB, 0.272362E+00_JPRB, 0.251993E+00_JPRB &
  &, 0.232609E+00_JPRB, 0.214200E+00_JPRB, 0.196758E+00_JPRB, 0.180275E+00_JPRB &
  &, 0.164739E+00_JPRB, 0.150135E+00_JPRB, 0.136442E+00_JPRB &
  &, 0.123646E+00_JPRB, 0.111719E+00_JPRB, 0.100638E+00_JPRB, 0.903811E-01_JPRB &
  &, 0.809103E-01_JPRB, 0.721989E-01_JPRB, 0.642158E-01_JPRB &
  &, 0.569246E-01_JPRB, 0.502877E-01_JPRB, 0.442756E-01_JPRB, 0.388387E-01_JPRB &
  &, 0.339506E-01_JPRB, 0.295693E-01_JPRB, 0.256679E-01_JPRB &
  &, 0.221923E-01_JPRB, 0.191149E-01_JPRB, 0.164035E-01_JPRB, 0.140206E-01_JPRB &
  &, 0.119479E-01_JPRB, 0.101386E-01_JPRB, 0.856555E-02_JPRB &
  &, 0.721063E-02_JPRB, 0.603951E-02_JPRB, 0.505478E-02_JPRB, 0.420197E-02_JPRB &
  &, 0.347827E-02_JPRB, 0.286522E-02_JPRB, 0.235710E-02_JPRB &
  &, 0.193165E-02_JPRB, 0.157992E-02_JPRB, 0.127550E-02_JPRB, 0.103901E-02_JPRB &
  &, 0.824819E-03_JPRB, 0.669674E-03_JPRB, 0.524757E-03_JPRB &
  &, 0.427372E-03_JPRB, 0.325332E-03_JPRB, 0.256444E-03_JPRB, 0.203715E-03_JPRB &
  &, 0.148542E-03_JPRB, 0.111089E-03_JPRB, 0.926001E-04_JPRB &
  &, 0.732644E-04_JPRB, 0.530643E-04_JPRB, 0.319822E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  51, :) = (/ &
  &  0.841436E+00_JPRB, 0.803705E+00_JPRB, 0.766770E+00_JPRB, 0.730650E+00_JPRB &
  &, 0.695361E+00_JPRB, 0.660918E+00_JPRB, 0.627336E+00_JPRB &
  &, 0.594629E+00_JPRB, 0.562812E+00_JPRB, 0.531898E+00_JPRB, 0.501898E+00_JPRB &
  &, 0.472824E+00_JPRB, 0.444689E+00_JPRB, 0.417501E+00_JPRB &
  &, 0.391267E+00_JPRB, 0.365996E+00_JPRB, 0.341695E+00_JPRB, 0.318365E+00_JPRB &
  &, 0.296012E+00_JPRB, 0.274633E+00_JPRB, 0.254234E+00_JPRB &
  &, 0.234807E+00_JPRB, 0.216350E+00_JPRB, 0.198854E+00_JPRB, 0.182310E+00_JPRB &
  &, 0.166707E+00_JPRB, 0.152028E+00_JPRB, 0.138263E+00_JPRB &
  &, 0.125386E+00_JPRB, 0.113374E+00_JPRB, 0.102211E+00_JPRB, 0.918671E-01_JPRB &
  &, 0.823084E-01_JPRB, 0.735128E-01_JPRB, 0.654405E-01_JPRB &
  &, 0.580594E-01_JPRB, 0.513367E-01_JPRB, 0.452436E-01_JPRB, 0.397310E-01_JPRB &
  &, 0.347729E-01_JPRB, 0.303176E-01_JPRB, 0.263377E-01_JPRB &
  &, 0.228014E-01_JPRB, 0.196598E-01_JPRB, 0.168921E-01_JPRB, 0.144618E-01_JPRB &
  &, 0.123267E-01_JPRB, 0.104767E-01_JPRB, 0.886057E-02_JPRB &
  &, 0.747343E-02_JPRB, 0.626830E-02_JPRB, 0.524775E-02_JPRB, 0.437134E-02_JPRB &
  &, 0.362278E-02_JPRB, 0.299836E-02_JPRB, 0.246309E-02_JPRB &
  &, 0.202464E-02_JPRB, 0.164335E-02_JPRB, 0.134040E-02_JPRB, 0.108880E-02_JPRB &
  &, 0.875745E-03_JPRB, 0.704394E-03_JPRB, 0.560258E-03_JPRB &
  &, 0.445519E-03_JPRB, 0.343881E-03_JPRB, 0.275401E-03_JPRB, 0.223086E-03_JPRB &
  &, 0.168334E-03_JPRB, 0.131307E-03_JPRB, 0.926001E-04_JPRB &
  &, 0.732644E-04_JPRB, 0.530643E-04_JPRB, 0.319822E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  52, :) = (/ &
  &  0.842294E+00_JPRB, 0.804744E+00_JPRB, 0.767978E+00_JPRB, 0.732014E+00_JPRB &
  &, 0.696869E+00_JPRB, 0.662556E+00_JPRB, 0.629092E+00_JPRB &
  &, 0.596491E+00_JPRB, 0.564768E+00_JPRB, 0.533936E+00_JPRB, 0.504006E+00_JPRB &
  &, 0.474992E+00_JPRB, 0.446903E+00_JPRB, 0.419750E+00_JPRB &
  &, 0.393541E+00_JPRB, 0.368285E+00_JPRB, 0.343988E+00_JPRB, 0.320654E+00_JPRB &
  &, 0.298286E+00_JPRB, 0.276886E+00_JPRB, 0.256455E+00_JPRB &
  &, 0.236989E+00_JPRB, 0.218484E+00_JPRB, 0.200933E+00_JPRB, 0.184328E+00_JPRB &
  &, 0.168660E+00_JPRB, 0.153913E+00_JPRB, 0.140072E+00_JPRB &
  &, 0.127114E+00_JPRB, 0.115025E+00_JPRB, 0.103775E+00_JPRB, 0.933447E-01_JPRB &
  &, 0.837023E-01_JPRB, 0.748180E-01_JPRB, 0.666606E-01_JPRB &
  &, 0.591941E-01_JPRB, 0.523953E-01_JPRB, 0.462214E-01_JPRB, 0.406233E-01_JPRB &
  &, 0.355850E-01_JPRB, 0.310658E-01_JPRB, 0.270183E-01_JPRB &
  &, 0.234105E-01_JPRB, 0.202160E-01_JPRB, 0.173808E-01_JPRB, 0.149030E-01_JPRB &
  &, 0.127177E-01_JPRB, 0.108147E-01_JPRB, 0.916841E-02_JPRB &
  &, 0.773622E-02_JPRB, 0.651056E-02_JPRB, 0.545451E-02_JPRB, 0.454071E-02_JPRB &
  &, 0.378175E-02_JPRB, 0.313151E-02_JPRB, 0.256909E-02_JPRB &
  &, 0.211762E-02_JPRB, 0.172264E-02_JPRB, 0.140530E-02_JPRB, 0.113859E-02_JPRB &
  &, 0.926671E-03_JPRB, 0.739113E-03_JPRB, 0.595758E-03_JPRB &
  &, 0.463666E-03_JPRB, 0.380979E-03_JPRB, 0.294359E-03_JPRB, 0.223086E-03_JPRB &
  &, 0.188125E-03_JPRB, 0.131307E-03_JPRB, 0.113250E-03_JPRB &
  &, 0.732644E-04_JPRB, 0.530643E-04_JPRB, 0.319822E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  53, :) = (/ &
  &  0.843139E+00_JPRB, 0.805768E+00_JPRB, 0.769168E+00_JPRB, 0.733359E+00_JPRB &
  &, 0.698355E+00_JPRB, 0.664172E+00_JPRB, 0.630825E+00_JPRB &
  &, 0.598329E+00_JPRB, 0.566699E+00_JPRB, 0.535948E+00_JPRB, 0.506088E+00_JPRB &
  &, 0.477132E+00_JPRB, 0.449089E+00_JPRB, 0.421973E+00_JPRB &
  &, 0.395791E+00_JPRB, 0.370550E+00_JPRB, 0.346259E+00_JPRB, 0.322919E+00_JPRB &
  &, 0.300538E+00_JPRB, 0.279116E+00_JPRB, 0.258654E+00_JPRB &
  &, 0.239151E+00_JPRB, 0.220600E+00_JPRB, 0.202998E+00_JPRB, 0.186335E+00_JPRB &
  &, 0.170603E+00_JPRB, 0.155787E+00_JPRB, 0.141869E+00_JPRB &
  &, 0.128835E+00_JPRB, 0.116667E+00_JPRB, 0.105336E+00_JPRB, 0.948222E-01_JPRB &
  &, 0.850962E-01_JPRB, 0.761275E-01_JPRB, 0.678853E-01_JPRB &
  &, 0.603382E-01_JPRB, 0.534539E-01_JPRB, 0.471895E-01_JPRB, 0.415256E-01_JPRB &
  &, 0.364073E-01_JPRB, 0.318140E-01_JPRB, 0.276989E-01_JPRB &
  &, 0.240307E-01_JPRB, 0.207609E-01_JPRB, 0.178811E-01_JPRB, 0.153441E-01_JPRB &
  &, 0.131087E-01_JPRB, 0.111653E-01_JPRB, 0.947626E-02_JPRB &
  &, 0.801216E-02_JPRB, 0.673936E-02_JPRB, 0.564748E-02_JPRB, 0.472420E-02_JPRB &
  &, 0.392626E-02_JPRB, 0.324986E-02_JPRB, 0.269023E-02_JPRB &
  &, 0.221060E-02_JPRB, 0.180193E-02_JPRB, 0.147019E-02_JPRB, 0.120498E-02_JPRB &
  &, 0.960622E-03_JPRB, 0.773833E-03_JPRB, 0.631259E-03_JPRB &
  &, 0.499959E-03_JPRB, 0.399528E-03_JPRB, 0.313316E-03_JPRB, 0.242458E-03_JPRB &
  &, 0.188125E-03_JPRB, 0.151525E-03_JPRB, 0.113250E-03_JPRB &
  &, 0.943525E-04_JPRB, 0.530643E-04_JPRB, 0.539644E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  54, :) = (/ &
  &  0.843971E+00_JPRB, 0.806777E+00_JPRB, 0.770342E+00_JPRB, 0.734685E+00_JPRB &
  &, 0.699821E+00_JPRB, 0.665766E+00_JPRB, 0.632535E+00_JPRB &
  &, 0.600143E+00_JPRB, 0.568605E+00_JPRB, 0.537934E+00_JPRB, 0.508144E+00_JPRB &
  &, 0.479245E+00_JPRB, 0.451251E+00_JPRB, 0.424172E+00_JPRB &
  &, 0.398015E+00_JPRB, 0.372790E+00_JPRB, 0.348504E+00_JPRB, 0.325162E+00_JPRB &
  &, 0.302769E+00_JPRB, 0.281324E+00_JPRB, 0.260832E+00_JPRB &
  &, 0.241292E+00_JPRB, 0.222699E+00_JPRB, 0.205046E+00_JPRB, 0.188324E+00_JPRB &
  &, 0.172530E+00_JPRB, 0.157645E+00_JPRB, 0.143659E+00_JPRB &
  &, 0.130551E+00_JPRB, 0.118302E+00_JPRB, 0.106892E+00_JPRB, 0.962956E-01_JPRB &
  &, 0.864814E-01_JPRB, 0.774282E-01_JPRB, 0.691055E-01_JPRB &
  &, 0.614730E-01_JPRB, 0.545029E-01_JPRB, 0.481673E-01_JPRB, 0.424178E-01_JPRB &
  &, 0.372296E-01_JPRB, 0.325622E-01_JPRB, 0.283796E-01_JPRB &
  &, 0.246398E-01_JPRB, 0.213285E-01_JPRB, 0.183814E-01_JPRB, 0.157853E-01_JPRB &
  &, 0.135119E-01_JPRB, 0.115158E-01_JPRB, 0.978411E-02_JPRB &
  &, 0.827496E-02_JPRB, 0.698162E-02_JPRB, 0.585423E-02_JPRB, 0.490769E-02_JPRB &
  &, 0.408522E-02_JPRB, 0.338300E-02_JPRB, 0.279623E-02_JPRB &
  &, 0.230359E-02_JPRB, 0.189708E-02_JPRB, 0.155132E-02_JPRB, 0.125477E-02_JPRB &
  &, 0.101155E-02_JPRB, 0.825913E-03_JPRB, 0.666759E-03_JPRB &
  &, 0.518106E-03_JPRB, 0.418077E-03_JPRB, 0.332273E-03_JPRB, 0.261829E-03_JPRB &
  &, 0.207917E-03_JPRB, 0.151525E-03_JPRB, 0.113250E-03_JPRB &
  &, 0.943525E-04_JPRB, 0.745965E-04_JPRB, 0.539644E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  55, :) = (/ &
  &  0.844791E+00_JPRB, 0.807772E+00_JPRB, 0.771500E+00_JPRB, 0.735993E+00_JPRB &
  &, 0.701267E+00_JPRB, 0.667338E+00_JPRB, 0.634222E+00_JPRB &
  &, 0.601934E+00_JPRB, 0.570487E+00_JPRB, 0.539897E+00_JPRB, 0.510175E+00_JPRB &
  &, 0.481335E+00_JPRB, 0.453387E+00_JPRB, 0.426345E+00_JPRB &
  &, 0.400214E+00_JPRB, 0.375006E+00_JPRB, 0.350728E+00_JPRB, 0.327383E+00_JPRB &
  &, 0.304977E+00_JPRB, 0.283513E+00_JPRB, 0.262995E+00_JPRB &
  &, 0.243418E+00_JPRB, 0.224782E+00_JPRB, 0.207076E+00_JPRB, 0.190303E+00_JPRB &
  &, 0.174447E+00_JPRB, 0.159497E+00_JPRB, 0.145437E+00_JPRB &
  &, 0.132256E+00_JPRB, 0.119929E+00_JPRB, 0.108441E+00_JPRB, 0.977605E-01_JPRB &
  &, 0.878666E-01_JPRB, 0.787333E-01_JPRB, 0.703257E-01_JPRB &
  &, 0.626170E-01_JPRB, 0.555615E-01_JPRB, 0.491451E-01_JPRB, 0.433201E-01_JPRB &
  &, 0.380622E-01_JPRB, 0.333209E-01_JPRB, 0.290710E-01_JPRB &
  &, 0.252710E-01_JPRB, 0.218847E-01_JPRB, 0.188933E-01_JPRB, 0.162384E-01_JPRB &
  &, 0.139152E-01_JPRB, 0.118789E-01_JPRB, 0.101048E-01_JPRB &
  &, 0.855089E-02_JPRB, 0.722387E-02_JPRB, 0.607477E-02_JPRB, 0.509117E-02_JPRB &
  &, 0.424418E-02_JPRB, 0.353094E-02_JPRB, 0.291737E-02_JPRB &
  &, 0.241207E-02_JPRB, 0.197637E-02_JPRB, 0.161621E-02_JPRB, 0.132116E-02_JPRB &
  &, 0.106247E-02_JPRB, 0.860632E-03_JPRB, 0.702260E-03_JPRB &
  &, 0.554399E-03_JPRB, 0.436626E-03_JPRB, 0.351230E-03_JPRB, 0.281201E-03_JPRB &
  &, 0.207917E-03_JPRB, 0.171743E-03_JPRB, 0.133900E-03_JPRB &
  &, 0.943525E-04_JPRB, 0.745965E-04_JPRB, 0.539644E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  56, :) = (/ &
  &  0.845601E+00_JPRB, 0.808753E+00_JPRB, 0.772642E+00_JPRB, 0.737283E+00_JPRB &
  &, 0.702694E+00_JPRB, 0.668890E+00_JPRB, 0.635888E+00_JPRB &
  &, 0.603701E+00_JPRB, 0.572346E+00_JPRB, 0.541835E+00_JPRB, 0.512182E+00_JPRB &
  &, 0.483400E+00_JPRB, 0.455500E+00_JPRB, 0.428494E+00_JPRB &
  &, 0.402390E+00_JPRB, 0.377199E+00_JPRB, 0.352927E+00_JPRB, 0.329581E+00_JPRB &
  &, 0.307166E+00_JPRB, 0.285683E+00_JPRB, 0.265139E+00_JPRB &
  &, 0.245526E+00_JPRB, 0.226847E+00_JPRB, 0.209096E+00_JPRB, 0.192268E+00_JPRB &
  &, 0.176350E+00_JPRB, 0.161333E+00_JPRB, 0.147208E+00_JPRB &
  &, 0.133953E+00_JPRB, 0.121552E+00_JPRB, 0.109985E+00_JPRB, 0.992254E-01_JPRB &
  &, 0.892519E-01_JPRB, 0.800340E-01_JPRB, 0.715458E-01_JPRB &
  &, 0.637518E-01_JPRB, 0.566201E-01_JPRB, 0.501229E-01_JPRB, 0.442324E-01_JPRB &
  &, 0.388947E-01_JPRB, 0.340796E-01_JPRB, 0.297624E-01_JPRB &
  &, 0.259023E-01_JPRB, 0.224523E-01_JPRB, 0.194052E-01_JPRB, 0.167035E-01_JPRB &
  &, 0.143184E-01_JPRB, 0.122420E-01_JPRB, 0.104255E-01_JPRB &
  &, 0.883997E-02_JPRB, 0.746613E-02_JPRB, 0.628152E-02_JPRB, 0.527466E-02_JPRB &
  &, 0.440315E-02_JPRB, 0.366408E-02_JPRB, 0.303851E-02_JPRB &
  &, 0.250505E-02_JPRB, 0.205566E-02_JPRB, 0.169733E-02_JPRB, 0.137095E-02_JPRB &
  &, 0.111340E-02_JPRB, 0.912712E-03_JPRB, 0.737760E-03_JPRB &
  &, 0.590692E-03_JPRB, 0.473724E-03_JPRB, 0.370188E-03_JPRB, 0.300572E-03_JPRB &
  &, 0.227709E-03_JPRB, 0.171743E-03_JPRB, 0.133900E-03_JPRB &
  &, 0.115441E-03_JPRB, 0.745965E-04_JPRB, 0.539644E-04_JPRB, 0.324382E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART9

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART9',0,ZHOOK_HANDLE)

XCW(  57, :) = (/ &
  &  0.846399E+00_JPRB, 0.809722E+00_JPRB, 0.773768E+00_JPRB, 0.738557E+00_JPRB &
  &, 0.704103E+00_JPRB, 0.670423E+00_JPRB, 0.637533E+00_JPRB &
  &, 0.605448E+00_JPRB, 0.574182E+00_JPRB, 0.543750E+00_JPRB, 0.514167E+00_JPRB &
  &, 0.485441E+00_JPRB, 0.457590E+00_JPRB, 0.430620E+00_JPRB &
  &, 0.404544E+00_JPRB, 0.379370E+00_JPRB, 0.355107E+00_JPRB, 0.331759E+00_JPRB &
  &, 0.309334E+00_JPRB, 0.287834E+00_JPRB, 0.267262E+00_JPRB &
  &, 0.247615E+00_JPRB, 0.228896E+00_JPRB, 0.211098E+00_JPRB, 0.194218E+00_JPRB &
  &, 0.178241E+00_JPRB, 0.163163E+00_JPRB, 0.148971E+00_JPRB &
  &, 0.135642E+00_JPRB, 0.123167E+00_JPRB, 0.111525E+00_JPRB, 0.100686E+00_JPRB &
  &, 0.906328E-01_JPRB, 0.813347E-01_JPRB, 0.727660E-01_JPRB &
  &, 0.648865E-01_JPRB, 0.576882E-01_JPRB, 0.511105E-01_JPRB, 0.451347E-01_JPRB &
  &, 0.397273E-01_JPRB, 0.348384E-01_JPRB, 0.304538E-01_JPRB &
  &, 0.265335E-01_JPRB, 0.230312E-01_JPRB, 0.199172E-01_JPRB, 0.171566E-01_JPRB &
  &, 0.147338E-01_JPRB, 0.126051E-01_JPRB, 0.107461E-01_JPRB &
  &, 0.912904E-02_JPRB, 0.772185E-02_JPRB, 0.650206E-02_JPRB, 0.545815E-02_JPRB &
  &, 0.456211E-02_JPRB, 0.381202E-02_JPRB, 0.315965E-02_JPRB &
  &, 0.261353E-02_JPRB, 0.215080E-02_JPRB, 0.176223E-02_JPRB, 0.143733E-02_JPRB &
  &, 0.118130E-02_JPRB, 0.947432E-03_JPRB, 0.773261E-03_JPRB &
  &, 0.608839E-03_JPRB, 0.492273E-03_JPRB, 0.389145E-03_JPRB, 0.300572E-03_JPRB &
  &, 0.247501E-03_JPRB, 0.191961E-03_JPRB, 0.154550E-03_JPRB &
  &, 0.115441E-03_JPRB, 0.961287E-04_JPRB, 0.539644E-04_JPRB, 0.548763E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.333680E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  58, :) = (/ &
  &  0.847186E+00_JPRB, 0.810677E+00_JPRB, 0.774880E+00_JPRB, 0.739814E+00_JPRB &
  &, 0.705494E+00_JPRB, 0.671937E+00_JPRB, 0.639158E+00_JPRB &
  &, 0.607173E+00_JPRB, 0.575997E+00_JPRB, 0.545644E+00_JPRB, 0.516128E+00_JPRB &
  &, 0.487460E+00_JPRB, 0.459656E+00_JPRB, 0.432723E+00_JPRB &
  &, 0.406675E+00_JPRB, 0.381520E+00_JPRB, 0.357265E+00_JPRB, 0.333918E+00_JPRB &
  &, 0.311483E+00_JPRB, 0.289966E+00_JPRB, 0.269370E+00_JPRB &
  &, 0.249691E+00_JPRB, 0.230934E+00_JPRB, 0.213090E+00_JPRB, 0.196154E+00_JPRB &
  &, 0.180122E+00_JPRB, 0.164984E+00_JPRB, 0.150723E+00_JPRB &
  &, 0.137327E+00_JPRB, 0.124777E+00_JPRB, 0.113057E+00_JPRB, 0.102143E+00_JPRB &
  &, 0.920094E-01_JPRB, 0.826310E-01_JPRB, 0.739816E-01_JPRB &
  &, 0.660306E-01_JPRB, 0.587467E-01_JPRB, 0.520981E-01_JPRB, 0.460471E-01_JPRB &
  &, 0.405599E-01_JPRB, 0.356077E-01_JPRB, 0.311560E-01_JPRB &
  &, 0.271648E-01_JPRB, 0.235988E-01_JPRB, 0.204291E-01_JPRB, 0.176216E-01_JPRB &
  &, 0.151493E-01_JPRB, 0.129807E-01_JPRB, 0.110668E-01_JPRB &
  &, 0.941812E-02_JPRB, 0.797756E-02_JPRB, 0.672260E-02_JPRB, 0.565575E-02_JPRB &
  &, 0.473552E-02_JPRB, 0.394517E-02_JPRB, 0.328079E-02_JPRB &
  &, 0.272201E-02_JPRB, 0.224595E-02_JPRB, 0.184335E-02_JPRB, 0.150372E-02_JPRB &
  &, 0.123223E-02_JPRB, 0.999511E-03_JPRB, 0.808761E-03_JPRB &
  &, 0.645132E-03_JPRB, 0.510822E-03_JPRB, 0.408102E-03_JPRB, 0.319944E-03_JPRB &
  &, 0.267292E-03_JPRB, 0.212179E-03_JPRB, 0.154550E-03_JPRB &
  &, 0.115441E-03_JPRB, 0.961287E-04_JPRB, 0.759466E-04_JPRB, 0.548763E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.333680E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  59, :) = (/ &
  &  0.847964E+00_JPRB, 0.811620E+00_JPRB, 0.775978E+00_JPRB, 0.741055E+00_JPRB &
  &, 0.706868E+00_JPRB, 0.673432E+00_JPRB, 0.640764E+00_JPRB &
  &, 0.608878E+00_JPRB, 0.577791E+00_JPRB, 0.547516E+00_JPRB, 0.518068E+00_JPRB &
  &, 0.489458E+00_JPRB, 0.461701E+00_JPRB, 0.434806E+00_JPRB &
  &, 0.408785E+00_JPRB, 0.383648E+00_JPRB, 0.359403E+00_JPRB, 0.336056E+00_JPRB &
  &, 0.313613E+00_JPRB, 0.292082E+00_JPRB, 0.271458E+00_JPRB &
  &, 0.251750E+00_JPRB, 0.232955E+00_JPRB, 0.215065E+00_JPRB, 0.198083E+00_JPRB &
  &, 0.181995E+00_JPRB, 0.166791E+00_JPRB, 0.152467E+00_JPRB &
  &, 0.139001E+00_JPRB, 0.126380E+00_JPRB, 0.114584E+00_JPRB, 0.103595E+00_JPRB &
  &, 0.933860E-01_JPRB, 0.839273E-01_JPRB, 0.752017E-01_JPRB &
  &, 0.671654E-01_JPRB, 0.598053E-01_JPRB, 0.530759E-01_JPRB, 0.469594E-01_JPRB &
  &, 0.414028E-01_JPRB, 0.363770E-01_JPRB, 0.318582E-01_JPRB &
  &, 0.278071E-01_JPRB, 0.241778E-01_JPRB, 0.209527E-01_JPRB, 0.180986E-01_JPRB &
  &, 0.155647E-01_JPRB, 0.133437E-01_JPRB, 0.114003E-01_JPRB &
  &, 0.970720E-02_JPRB, 0.823328E-02_JPRB, 0.695692E-02_JPRB, 0.585335E-02_JPRB &
  &, 0.490894E-02_JPRB, 0.409311E-02_JPRB, 0.341707E-02_JPRB &
  &, 0.283049E-02_JPRB, 0.234110E-02_JPRB, 0.192448E-02_JPRB, 0.157011E-02_JPRB &
  &, 0.128315E-02_JPRB, 0.105159E-02_JPRB, 0.844262E-03_JPRB &
  &, 0.681425E-03_JPRB, 0.547920E-03_JPRB, 0.427059E-03_JPRB, 0.339316E-03_JPRB &
  &, 0.267292E-03_JPRB, 0.212179E-03_JPRB, 0.175200E-03_JPRB &
  &, 0.136529E-03_JPRB, 0.961287E-04_JPRB, 0.759466E-04_JPRB, 0.548763E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.333680E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  60, :) = (/ &
  &  0.848730E+00_JPRB, 0.812552E+00_JPRB, 0.777062E+00_JPRB, 0.742282E+00_JPRB &
  &, 0.708225E+00_JPRB, 0.674909E+00_JPRB, 0.642350E+00_JPRB &
  &, 0.610563E+00_JPRB, 0.579565E+00_JPRB, 0.549368E+00_JPRB, 0.519985E+00_JPRB &
  &, 0.491434E+00_JPRB, 0.463724E+00_JPRB, 0.436867E+00_JPRB &
  &, 0.410875E+00_JPRB, 0.385757E+00_JPRB, 0.361521E+00_JPRB, 0.338175E+00_JPRB &
  &, 0.315726E+00_JPRB, 0.294176E+00_JPRB, 0.273533E+00_JPRB &
  &, 0.253795E+00_JPRB, 0.234960E+00_JPRB, 0.217029E+00_JPRB, 0.199994E+00_JPRB &
  &, 0.183854E+00_JPRB, 0.168594E+00_JPRB, 0.154203E+00_JPRB &
  &, 0.140671E+00_JPRB, 0.127979E+00_JPRB, 0.116112E+00_JPRB, 0.105043E+00_JPRB &
  &, 0.947583E-01_JPRB, 0.852236E-01_JPRB, 0.764174E-01_JPRB &
  &, 0.683094E-01_JPRB, 0.608734E-01_JPRB, 0.540635E-01_JPRB, 0.478717E-01_JPRB &
  &, 0.422456E-01_JPRB, 0.371568E-01_JPRB, 0.325712E-01_JPRB &
  &, 0.284494E-01_JPRB, 0.247680E-01_JPRB, 0.214879E-01_JPRB, 0.185755E-01_JPRB &
  &, 0.159924E-01_JPRB, 0.137319E-01_JPRB, 0.117338E-01_JPRB &
  &, 0.999627E-02_JPRB, 0.848899E-02_JPRB, 0.717745E-02_JPRB, 0.605095E-02_JPRB &
  &, 0.508235E-02_JPRB, 0.425584E-02_JPRB, 0.353821E-02_JPRB &
  &, 0.293897E-02_JPRB, 0.243624E-02_JPRB, 0.200560E-02_JPRB, 0.163650E-02_JPRB &
  &, 0.133408E-02_JPRB, 0.108631E-02_JPRB, 0.879762E-03_JPRB &
  &, 0.717718E-03_JPRB, 0.566469E-03_JPRB, 0.464974E-03_JPRB, 0.358687E-03_JPRB &
  &, 0.287084E-03_JPRB, 0.232397E-03_JPRB, 0.175200E-03_JPRB &
  &, 0.136529E-03_JPRB, 0.961287E-04_JPRB, 0.759466E-04_JPRB, 0.548763E-04_JPRB &
  &, 0.329001E-04_JPRB, 0.333680E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  61, :) = (/ &
  &  0.849488E+00_JPRB, 0.813471E+00_JPRB, 0.778133E+00_JPRB, 0.743493E+00_JPRB &
  &, 0.709566E+00_JPRB, 0.676369E+00_JPRB, 0.643919E+00_JPRB &
  &, 0.612230E+00_JPRB, 0.581318E+00_JPRB, 0.551198E+00_JPRB, 0.521885E+00_JPRB &
  &, 0.493390E+00_JPRB, 0.465726E+00_JPRB, 0.438909E+00_JPRB &
  &, 0.412944E+00_JPRB, 0.387845E+00_JPRB, 0.363620E+00_JPRB, 0.340276E+00_JPRB &
  &, 0.317821E+00_JPRB, 0.296257E+00_JPRB, 0.275592E+00_JPRB &
  &, 0.255824E+00_JPRB, 0.236954E+00_JPRB, 0.218980E+00_JPRB, 0.201898E+00_JPRB &
  &, 0.185701E+00_JPRB, 0.170382E+00_JPRB, 0.155932E+00_JPRB &
  &, 0.142332E+00_JPRB, 0.129574E+00_JPRB, 0.117632E+00_JPRB, 0.106491E+00_JPRB &
  &, 0.961263E-01_JPRB, 0.865198E-01_JPRB, 0.776375E-01_JPRB &
  &, 0.694535E-01_JPRB, 0.619320E-01_JPRB, 0.550609E-01_JPRB, 0.487840E-01_JPRB &
  &, 0.430885E-01_JPRB, 0.379260E-01_JPRB, 0.332735E-01_JPRB &
  &, 0.290917E-01_JPRB, 0.253470E-01_JPRB, 0.220114E-01_JPRB, 0.190525E-01_JPRB &
  &, 0.164200E-01_JPRB, 0.141075E-01_JPRB, 0.120801E-01_JPRB &
  &, 0.102985E-01_JPRB, 0.875817E-02_JPRB, 0.741177E-02_JPRB, 0.624855E-02_JPRB &
  &, 0.525576E-02_JPRB, 0.440378E-02_JPRB, 0.367450E-02_JPRB &
  &, 0.304745E-02_JPRB, 0.253139E-02_JPRB, 0.208672E-02_JPRB, 0.171948E-02_JPRB &
  &, 0.140198E-02_JPRB, 0.113839E-02_JPRB, 0.933013E-03_JPRB &
  &, 0.754012E-03_JPRB, 0.603567E-03_JPRB, 0.483931E-03_JPRB, 0.378058E-03_JPRB &
  &, 0.306876E-03_JPRB, 0.232397E-03_JPRB, 0.195850E-03_JPRB &
  &, 0.136529E-03_JPRB, 0.117661E-03_JPRB, 0.759466E-04_JPRB, 0.548763E-04_JPRB &
  &, 0.558002E-04_JPRB, 0.333680E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  62, :) = (/ &
  &  0.850236E+00_JPRB, 0.814379E+00_JPRB, 0.779191E+00_JPRB, 0.744690E+00_JPRB &
  &, 0.710891E+00_JPRB, 0.677812E+00_JPRB, 0.645469E+00_JPRB &
  &, 0.613878E+00_JPRB, 0.583053E+00_JPRB, 0.553010E+00_JPRB, 0.523763E+00_JPRB &
  &, 0.495325E+00_JPRB, 0.467709E+00_JPRB, 0.440928E+00_JPRB &
  &, 0.414994E+00_JPRB, 0.389915E+00_JPRB, 0.365700E+00_JPRB, 0.342360E+00_JPRB &
  &, 0.319898E+00_JPRB, 0.298322E+00_JPRB, 0.277635E+00_JPRB &
  &, 0.257837E+00_JPRB, 0.238934E+00_JPRB, 0.220920E+00_JPRB, 0.203788E+00_JPRB &
  &, 0.187542E+00_JPRB, 0.172167E+00_JPRB, 0.157653E+00_JPRB &
  &, 0.143986E+00_JPRB, 0.131160E+00_JPRB, 0.119147E+00_JPRB, 0.107935E+00_JPRB &
  &, 0.974942E-01_JPRB, 0.878117E-01_JPRB, 0.788532E-01_JPRB &
  &, 0.705882E-01_JPRB, 0.630001E-01_JPRB, 0.560485E-01_JPRB, 0.497064E-01_JPRB &
  &, 0.439416E-01_JPRB, 0.387059E-01_JPRB, 0.339865E-01_JPRB &
  &, 0.297451E-01_JPRB, 0.259486E-01_JPRB, 0.225466E-01_JPRB, 0.195294E-01_JPRB &
  &, 0.168599E-01_JPRB, 0.144956E-01_JPRB, 0.124264E-01_JPRB &
  &, 0.106138E-01_JPRB, 0.902734E-02_JPRB, 0.764609E-02_JPRB, 0.646027E-02_JPRB &
  &, 0.544363E-02_JPRB, 0.456651E-02_JPRB, 0.381078E-02_JPRB &
  &, 0.317143E-02_JPRB, 0.262654E-02_JPRB, 0.216784E-02_JPRB, 0.178587E-02_JPRB &
  &, 0.146988E-02_JPRB, 0.119047E-02_JPRB, 0.968514E-03_JPRB &
  &, 0.790305E-03_JPRB, 0.640665E-03_JPRB, 0.502888E-03_JPRB, 0.397430E-03_JPRB &
  &, 0.326667E-03_JPRB, 0.252615E-03_JPRB, 0.195850E-03_JPRB &
  &, 0.157617E-03_JPRB, 0.117661E-03_JPRB, 0.979287E-04_JPRB, 0.773145E-04_JPRB &
  &, 0.558002E-04_JPRB, 0.333680E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  63, :) = (/ &
  &  0.850975E+00_JPRB, 0.815277E+00_JPRB, 0.780237E+00_JPRB, 0.745873E+00_JPRB &
  &, 0.712201E+00_JPRB, 0.679239E+00_JPRB, 0.647003E+00_JPRB &
  &, 0.615507E+00_JPRB, 0.584769E+00_JPRB, 0.554803E+00_JPRB, 0.525622E+00_JPRB &
  &, 0.497241E+00_JPRB, 0.469673E+00_JPRB, 0.442931E+00_JPRB &
  &, 0.417025E+00_JPRB, 0.391965E+00_JPRB, 0.367763E+00_JPRB, 0.344425E+00_JPRB &
  &, 0.321959E+00_JPRB, 0.300368E+00_JPRB, 0.279662E+00_JPRB &
  &, 0.259839E+00_JPRB, 0.240901E+00_JPRB, 0.222846E+00_JPRB, 0.205671E+00_JPRB &
  &, 0.189371E+00_JPRB, 0.173940E+00_JPRB, 0.159366E+00_JPRB &
  &, 0.145636E+00_JPRB, 0.132739E+00_JPRB, 0.120658E+00_JPRB, 0.109375E+00_JPRB &
  &, 0.988622E-01_JPRB, 0.891035E-01_JPRB, 0.800688E-01_JPRB &
  &, 0.717323E-01_JPRB, 0.640682E-01_JPRB, 0.570458E-01_JPRB, 0.506287E-01_JPRB &
  &, 0.447845E-01_JPRB, 0.394962E-01_JPRB, 0.347103E-01_JPRB &
  &, 0.303985E-01_JPRB, 0.265389E-01_JPRB, 0.230935E-01_JPRB, 0.200183E-01_JPRB &
  &, 0.172876E-01_JPRB, 0.148837E-01_JPRB, 0.127728E-01_JPRB &
  &, 0.109161E-01_JPRB, 0.929652E-02_JPRB, 0.789420E-02_JPRB, 0.667198E-02_JPRB &
  &, 0.561704E-02_JPRB, 0.471445E-02_JPRB, 0.394706E-02_JPRB &
  &, 0.329541E-02_JPRB, 0.272168E-02_JPRB, 0.224896E-02_JPRB, 0.185226E-02_JPRB &
  &, 0.152081E-02_JPRB, 0.124255E-02_JPRB, 0.102176E-02_JPRB &
  &, 0.826598E-03_JPRB, 0.659214E-03_JPRB, 0.540803E-03_JPRB, 0.436173E-03_JPRB &
  &, 0.346459E-03_JPRB, 0.272833E-03_JPRB, 0.216500E-03_JPRB &
  &, 0.157617E-03_JPRB, 0.117661E-03_JPRB, 0.979287E-04_JPRB, 0.773145E-04_JPRB &
  &, 0.558002E-04_JPRB, 0.333680E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART10

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART10',0,ZHOOK_HANDLE)

XCW(  64, :) = (/ &
  &  0.851705E+00_JPRB, 0.816164E+00_JPRB, 0.781270E+00_JPRB, 0.747042E+00_JPRB &
  &, 0.713496E+00_JPRB, 0.680650E+00_JPRB, 0.648519E+00_JPRB &
  &, 0.617120E+00_JPRB, 0.586468E+00_JPRB, 0.556577E+00_JPRB, 0.527463E+00_JPRB &
  &, 0.499139E+00_JPRB, 0.471618E+00_JPRB, 0.444914E+00_JPRB &
  &, 0.419038E+00_JPRB, 0.393999E+00_JPRB, 0.369807E+00_JPRB, 0.346473E+00_JPRB &
  &, 0.324002E+00_JPRB, 0.302402E+00_JPRB, 0.281675E+00_JPRB &
  &, 0.261825E+00_JPRB, 0.242855E+00_JPRB, 0.224758E+00_JPRB, 0.207540E+00_JPRB &
  &, 0.191190E+00_JPRB, 0.175706E+00_JPRB, 0.161072E+00_JPRB &
  &, 0.147279E+00_JPRB, 0.134318E+00_JPRB, 0.122165E+00_JPRB, 0.110810E+00_JPRB &
  &, 0.100226E+00_JPRB, 0.903910E-01_JPRB, 0.812844E-01_JPRB &
  &, 0.728763E-01_JPRB, 0.651364E-01_JPRB, 0.580334E-01_JPRB, 0.515511E-01_JPRB &
  &, 0.456376E-01_JPRB, 0.402760E-01_JPRB, 0.354341E-01_JPRB &
  &, 0.310630E-01_JPRB, 0.271406E-01_JPRB, 0.236287E-01_JPRB, 0.205072E-01_JPRB &
  &, 0.177397E-01_JPRB, 0.152843E-01_JPRB, 0.131191E-01_JPRB &
  &, 0.112314E-01_JPRB, 0.957915E-02_JPRB, 0.812852E-02_JPRB, 0.688370E-02_JPRB &
  &, 0.580491E-02_JPRB, 0.487718E-02_JPRB, 0.408335E-02_JPRB &
  &, 0.340389E-02_JPRB, 0.283269E-02_JPRB, 0.234631E-02_JPRB, 0.193524E-02_JPRB &
  &, 0.158871E-02_JPRB, 0.129463E-02_JPRB, 0.105727E-02_JPRB &
  &, 0.862891E-03_JPRB, 0.696311E-03_JPRB, 0.559760E-03_JPRB, 0.455544E-03_JPRB &
  &, 0.366251E-03_JPRB, 0.293050E-03_JPRB, 0.216500E-03_JPRB &
  &, 0.178705E-03_JPRB, 0.139193E-03_JPRB, 0.979287E-04_JPRB, 0.773145E-04_JPRB &
  &, 0.558002E-04_JPRB, 0.333680E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  65, :) = (/ &
  &  0.852427E+00_JPRB, 0.817041E+00_JPRB, 0.782291E+00_JPRB, 0.748198E+00_JPRB &
  &, 0.714777E+00_JPRB, 0.682046E+00_JPRB, 0.650020E+00_JPRB &
  &, 0.618715E+00_JPRB, 0.588148E+00_JPRB, 0.558334E+00_JPRB, 0.529285E+00_JPRB &
  &, 0.501018E+00_JPRB, 0.473545E+00_JPRB, 0.446879E+00_JPRB &
  &, 0.421032E+00_JPRB, 0.396013E+00_JPRB, 0.371835E+00_JPRB, 0.348506E+00_JPRB &
  &, 0.326032E+00_JPRB, 0.304420E+00_JPRB, 0.283673E+00_JPRB &
  &, 0.263798E+00_JPRB, 0.244795E+00_JPRB, 0.226663E+00_JPRB, 0.209401E+00_JPRB &
  &, 0.193001E+00_JPRB, 0.177460E+00_JPRB, 0.162770E+00_JPRB &
  &, 0.148917E+00_JPRB, 0.135889E+00_JPRB, 0.123669E+00_JPRB, 0.112241E+00_JPRB &
  &, 0.101585E+00_JPRB, 0.916828E-01_JPRB, 0.825000E-01_JPRB &
  &, 0.740111E-01_JPRB, 0.662045E-01_JPRB, 0.590308E-01_JPRB, 0.524734E-01_JPRB &
  &, 0.465011E-01_JPRB, 0.410664E-01_JPRB, 0.361580E-01_JPRB &
  &, 0.317275E-01_JPRB, 0.277422E-01_JPRB, 0.241755E-01_JPRB, 0.209961E-01_JPRB &
  &, 0.181796E-01_JPRB, 0.156850E-01_JPRB, 0.134783E-01_JPRB &
  &, 0.115468E-01_JPRB, 0.984832E-02_JPRB, 0.837662E-02_JPRB, 0.709541E-02_JPRB &
  &, 0.599277E-02_JPRB, 0.503991E-02_JPRB, 0.423477E-02_JPRB &
  &, 0.352786E-02_JPRB, 0.294369E-02_JPRB, 0.244366E-02_JPRB, 0.201823E-02_JPRB &
  &, 0.165661E-02_JPRB, 0.136407E-02_JPRB, 0.111052E-02_JPRB &
  &, 0.899185E-03_JPRB, 0.733409E-03_JPRB, 0.578718E-03_JPRB, 0.474916E-03_JPRB &
  &, 0.386043E-03_JPRB, 0.293050E-03_JPRB, 0.237150E-03_JPRB &
  &, 0.178705E-03_JPRB, 0.139193E-03_JPRB, 0.119911E-03_JPRB, 0.773145E-04_JPRB &
  &, 0.558002E-04_JPRB, 0.567360E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  66, :) = (/ &
  &  0.853141E+00_JPRB, 0.817907E+00_JPRB, 0.783301E+00_JPRB, 0.749342E+00_JPRB &
  &, 0.716044E+00_JPRB, 0.683427E+00_JPRB, 0.651504E+00_JPRB &
  &, 0.620294E+00_JPRB, 0.589812E+00_JPRB, 0.560072E+00_JPRB, 0.531090E+00_JPRB &
  &, 0.502878E+00_JPRB, 0.475453E+00_JPRB, 0.448827E+00_JPRB &
  &, 0.423008E+00_JPRB, 0.398012E+00_JPRB, 0.373847E+00_JPRB, 0.350521E+00_JPRB &
  &, 0.328044E+00_JPRB, 0.306421E+00_JPRB, 0.285657E+00_JPRB &
  &, 0.265758E+00_JPRB, 0.246725E+00_JPRB, 0.228555E+00_JPRB, 0.211248E+00_JPRB &
  &, 0.194802E+00_JPRB, 0.179211E+00_JPRB, 0.164461E+00_JPRB &
  &, 0.150547E+00_JPRB, 0.137455E+00_JPRB, 0.125172E+00_JPRB, 0.113673E+00_JPRB &
  &, 0.102949E+00_JPRB, 0.929702E-01_JPRB, 0.837156E-01_JPRB &
  &, 0.751552E-01_JPRB, 0.672726E-01_JPRB, 0.600282E-01_JPRB, 0.534058E-01_JPRB &
  &, 0.473542E-01_JPRB, 0.418673E-01_JPRB, 0.368818E-01_JPRB &
  &, 0.323919E-01_JPRB, 0.283552E-01_JPRB, 0.247340E-01_JPRB, 0.214969E-01_JPRB &
  &, 0.186317E-01_JPRB, 0.160856E-01_JPRB, 0.138374E-01_JPRB &
  &, 0.118621E-01_JPRB, 0.101310E-01_JPRB, 0.862473E-02_JPRB, 0.732124E-02_JPRB &
  &, 0.619509E-02_JPRB, 0.521744E-02_JPRB, 0.437105E-02_JPRB &
  &, 0.365184E-02_JPRB, 0.305470E-02_JPRB, 0.252478E-02_JPRB, 0.208461E-02_JPRB &
  &, 0.172451E-02_JPRB, 0.141615E-02_JPRB, 0.116377E-02_JPRB &
  &, 0.935478E-03_JPRB, 0.770507E-03_JPRB, 0.616632E-03_JPRB, 0.494287E-03_JPRB &
  &, 0.386043E-03_JPRB, 0.313268E-03_JPRB, 0.257800E-03_JPRB &
  &, 0.199793E-03_JPRB, 0.160725E-03_JPRB, 0.119911E-03_JPRB, 0.997526E-04_JPRB &
  &, 0.787003E-04_JPRB, 0.567360E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  67, :) = (/ &
  &  0.853846E+00_JPRB, 0.818764E+00_JPRB, 0.784300E+00_JPRB, 0.750473E+00_JPRB &
  &, 0.717298E+00_JPRB, 0.684793E+00_JPRB, 0.652974E+00_JPRB &
  &, 0.621857E+00_JPRB, 0.591459E+00_JPRB, 0.561794E+00_JPRB, 0.532878E+00_JPRB &
  &, 0.504724E+00_JPRB, 0.477345E+00_JPRB, 0.450756E+00_JPRB &
  &, 0.424968E+00_JPRB, 0.399993E+00_JPRB, 0.375842E+00_JPRB, 0.352522E+00_JPRB &
  &, 0.330042E+00_JPRB, 0.308410E+00_JPRB, 0.287628E+00_JPRB &
  &, 0.267707E+00_JPRB, 0.248641E+00_JPRB, 0.230436E+00_JPRB, 0.213088E+00_JPRB &
  &, 0.196595E+00_JPRB, 0.180951E+00_JPRB, 0.166148E+00_JPRB &
  &, 0.152174E+00_JPRB, 0.139018E+00_JPRB, 0.126666E+00_JPRB, 0.115100E+00_JPRB &
  &, 0.104304E+00_JPRB, 0.942577E-01_JPRB, 0.849313E-01_JPRB &
  &, 0.762992E-01_JPRB, 0.683407E-01_JPRB, 0.610353E-01_JPRB, 0.543381E-01_JPRB &
  &, 0.482176E-01_JPRB, 0.426577E-01_JPRB, 0.376164E-01_JPRB &
  &, 0.330564E-01_JPRB, 0.289568E-01_JPRB, 0.252808E-01_JPRB, 0.219977E-01_JPRB &
  &, 0.190838E-01_JPRB, 0.164862E-01_JPRB, 0.141966E-01_JPRB &
  &, 0.121906E-01_JPRB, 0.104270E-01_JPRB, 0.888662E-02_JPRB, 0.754707E-02_JPRB &
  &, 0.638295E-02_JPRB, 0.538017E-02_JPRB, 0.452248E-02_JPRB &
  &, 0.379132E-02_JPRB, 0.314985E-02_JPRB, 0.262212E-02_JPRB, 0.216760E-02_JPRB &
  &, 0.179242E-02_JPRB, 0.146823E-02_JPRB, 0.119927E-02_JPRB &
  &, 0.989918E-03_JPRB, 0.789056E-03_JPRB, 0.635589E-03_JPRB, 0.513659E-03_JPRB &
  &, 0.405834E-03_JPRB, 0.333486E-03_JPRB, 0.257800E-03_JPRB &
  &, 0.199793E-03_JPRB, 0.160725E-03_JPRB, 0.119911E-03_JPRB, 0.997526E-04_JPRB &
  &, 0.787003E-04_JPRB, 0.567360E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  68, :) = (/ &
  &  0.854543E+00_JPRB, 0.819611E+00_JPRB, 0.785288E+00_JPRB, 0.751592E+00_JPRB &
  &, 0.718538E+00_JPRB, 0.686145E+00_JPRB, 0.654427E+00_JPRB &
  &, 0.623404E+00_JPRB, 0.593090E+00_JPRB, 0.563499E+00_JPRB, 0.534648E+00_JPRB &
  &, 0.506550E+00_JPRB, 0.479220E+00_JPRB, 0.452669E+00_JPRB &
  &, 0.426912E+00_JPRB, 0.401960E+00_JPRB, 0.377821E+00_JPRB, 0.354507E+00_JPRB &
  &, 0.332027E+00_JPRB, 0.310384E+00_JPRB, 0.289587E+00_JPRB &
  &, 0.269643E+00_JPRB, 0.250550E+00_JPRB, 0.232306E+00_JPRB, 0.214918E+00_JPRB &
  &, 0.198381E+00_JPRB, 0.182683E+00_JPRB, 0.167823E+00_JPRB &
  &, 0.153793E+00_JPRB, 0.140573E+00_JPRB, 0.128157E+00_JPRB, 0.116527E+00_JPRB &
  &, 0.105659E+00_JPRB, 0.955407E-01_JPRB, 0.861424E-01_JPRB &
  &, 0.774433E-01_JPRB, 0.694183E-01_JPRB, 0.620327E-01_JPRB, 0.552705E-01_JPRB &
  &, 0.490810E-01_JPRB, 0.434586E-01_JPRB, 0.383510E-01_JPRB &
  &, 0.337320E-01_JPRB, 0.295812E-01_JPRB, 0.258509E-01_JPRB, 0.225104E-01_JPRB &
  &, 0.195359E-01_JPRB, 0.168994E-01_JPRB, 0.145685E-01_JPRB &
  &, 0.125191E-01_JPRB, 0.107097E-01_JPRB, 0.914850E-02_JPRB, 0.777290E-02_JPRB &
  &, 0.658527E-02_JPRB, 0.555770E-02_JPRB, 0.467391E-02_JPRB &
  &, 0.391529E-02_JPRB, 0.327671E-02_JPRB, 0.271947E-02_JPRB, 0.225058E-02_JPRB &
  &, 0.186032E-02_JPRB, 0.153767E-02_JPRB, 0.125252E-02_JPRB &
  &, 0.102621E-02_JPRB, 0.826154E-03_JPRB, 0.673504E-03_JPRB, 0.552402E-03_JPRB &
  &, 0.445418E-03_JPRB, 0.353704E-03_JPRB, 0.278450E-03_JPRB &
  &, 0.220881E-03_JPRB, 0.160725E-03_JPRB, 0.141893E-03_JPRB, 0.997526E-04_JPRB &
  &, 0.787003E-04_JPRB, 0.567360E-04_JPRB, 0.338418E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  69, :) = (/ &
  &  0.855233E+00_JPRB, 0.820450E+00_JPRB, 0.786266E+00_JPRB, 0.752699E+00_JPRB &
  &, 0.719766E+00_JPRB, 0.687483E+00_JPRB, 0.655868E+00_JPRB &
  &, 0.624937E+00_JPRB, 0.594705E+00_JPRB, 0.565189E+00_JPRB, 0.536403E+00_JPRB &
  &, 0.508361E+00_JPRB, 0.481078E+00_JPRB, 0.454566E+00_JPRB &
  &, 0.428840E+00_JPRB, 0.403909E+00_JPRB, 0.379785E+00_JPRB, 0.356477E+00_JPRB &
  &, 0.333995E+00_JPRB, 0.312344E+00_JPRB, 0.291532E+00_JPRB &
  &, 0.271566E+00_JPRB, 0.252443E+00_JPRB, 0.234170E+00_JPRB, 0.216740E+00_JPRB &
  &, 0.200156E+00_JPRB, 0.184408E+00_JPRB, 0.169494E+00_JPRB &
  &, 0.155408E+00_JPRB, 0.142127E+00_JPRB, 0.129648E+00_JPRB, 0.117950E+00_JPRB &
  &, 0.107014E+00_JPRB, 0.968281E-01_JPRB, 0.873580E-01_JPRB &
  &, 0.785873E-01_JPRB, 0.704865E-01_JPRB, 0.630398E-01_JPRB, 0.562029E-01_JPRB &
  &, 0.499547E-01_JPRB, 0.442594E-01_JPRB, 0.390857E-01_JPRB &
  &, 0.344075E-01_JPRB, 0.301942E-01_JPRB, 0.264094E-01_JPRB, 0.230231E-01_JPRB &
  &, 0.200002E-01_JPRB, 0.173126E-01_JPRB, 0.149405E-01_JPRB &
  &, 0.128476E-01_JPRB, 0.110058E-01_JPRB, 0.939661E-02_JPRB, 0.799873E-02_JPRB &
  &, 0.678758E-02_JPRB, 0.573523E-02_JPRB, 0.482533E-02_JPRB &
  &, 0.405477E-02_JPRB, 0.338771E-02_JPRB, 0.281682E-02_JPRB, 0.233357E-02_JPRB &
  &, 0.192822E-02_JPRB, 0.158975E-02_JPRB, 0.130577E-02_JPRB &
  &, 0.106250E-02_JPRB, 0.863252E-03_JPRB, 0.711418E-03_JPRB, 0.571773E-03_JPRB &
  &, 0.465209E-03_JPRB, 0.373922E-03_JPRB, 0.299100E-03_JPRB &
  &, 0.220881E-03_JPRB, 0.182257E-03_JPRB, 0.141893E-03_JPRB, 0.997526E-04_JPRB &
  &, 0.787003E-04_JPRB, 0.567360E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.348074E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  70, :) = (/ &
  &  0.855916E+00_JPRB, 0.821280E+00_JPRB, 0.787233E+00_JPRB, 0.753795E+00_JPRB &
  &, 0.720981E+00_JPRB, 0.688808E+00_JPRB, 0.657294E+00_JPRB &
  &, 0.626455E+00_JPRB, 0.596305E+00_JPRB, 0.566863E+00_JPRB, 0.538142E+00_JPRB &
  &, 0.510156E+00_JPRB, 0.482920E+00_JPRB, 0.456448E+00_JPRB &
  &, 0.430752E+00_JPRB, 0.405843E+00_JPRB, 0.381734E+00_JPRB, 0.358434E+00_JPRB &
  &, 0.335950E+00_JPRB, 0.314292E+00_JPRB, 0.293468E+00_JPRB &
  &, 0.273476E+00_JPRB, 0.254328E+00_JPRB, 0.236020E+00_JPRB, 0.218552E+00_JPRB &
  &, 0.201924E+00_JPRB, 0.186129E+00_JPRB, 0.171162E+00_JPRB &
  &, 0.157015E+00_JPRB, 0.143674E+00_JPRB, 0.131130E+00_JPRB, 0.119368E+00_JPRB &
  &, 0.108369E+00_JPRB, 0.981111E-01_JPRB, 0.885736E-01_JPRB &
  &, 0.797314E-01_JPRB, 0.715641E-01_JPRB, 0.640470E-01_JPRB, 0.571353E-01_JPRB &
  &, 0.508284E-01_JPRB, 0.450603E-01_JPRB, 0.398311E-01_JPRB &
  &, 0.350941E-01_JPRB, 0.308185E-01_JPRB, 0.269795E-01_JPRB, 0.235359E-01_JPRB &
  &, 0.204645E-01_JPRB, 0.177382E-01_JPRB, 0.153125E-01_JPRB &
  &, 0.131893E-01_JPRB, 0.113153E-01_JPRB, 0.967228E-02_JPRB, 0.823868E-02_JPRB &
  &, 0.698990E-02_JPRB, 0.591275E-02_JPRB, 0.497676E-02_JPRB &
  &, 0.417875E-02_JPRB, 0.349872E-02_JPRB, 0.291416E-02_JPRB, 0.243315E-02_JPRB &
  &, 0.201310E-02_JPRB, 0.165919E-02_JPRB, 0.135902E-02_JPRB &
  &, 0.111694E-02_JPRB, 0.900350E-03_JPRB, 0.730375E-03_JPRB, 0.591145E-03_JPRB &
  &, 0.485001E-03_JPRB, 0.394140E-03_JPRB, 0.299100E-03_JPRB &
  &, 0.241969E-03_JPRB, 0.182257E-03_JPRB, 0.141893E-03_JPRB, 0.122191E-03_JPRB &
  &, 0.787003E-04_JPRB, 0.567360E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.348074E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART11

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART11',0,ZHOOK_HANDLE)

XCW(  71, :) = (/ &
  &  0.856591E+00_JPRB, 0.822100E+00_JPRB, 0.788191E+00_JPRB, 0.754880E+00_JPRB &
  &, 0.722184E+00_JPRB, 0.690121E+00_JPRB, 0.658706E+00_JPRB &
  &, 0.627958E+00_JPRB, 0.597891E+00_JPRB, 0.568522E+00_JPRB, 0.539865E+00_JPRB &
  &, 0.511934E+00_JPRB, 0.484747E+00_JPRB, 0.458314E+00_JPRB &
  &, 0.432649E+00_JPRB, 0.407763E+00_JPRB, 0.383668E+00_JPRB, 0.360376E+00_JPRB &
  &, 0.337893E+00_JPRB, 0.316227E+00_JPRB, 0.295388E+00_JPRB &
  &, 0.275379E+00_JPRB, 0.256200E+00_JPRB, 0.237859E+00_JPRB, 0.220353E+00_JPRB &
  &, 0.203681E+00_JPRB, 0.187839E+00_JPRB, 0.172822E+00_JPRB &
  &, 0.158618E+00_JPRB, 0.145221E+00_JPRB, 0.132613E+00_JPRB, 0.120787E+00_JPRB &
  &, 0.109720E+00_JPRB, 0.993941E-01_JPRB, 0.897892E-01_JPRB &
  &, 0.808755E-01_JPRB, 0.726418E-01_JPRB, 0.650541E-01_JPRB, 0.580776E-01_JPRB &
  &, 0.516919E-01_JPRB, 0.458718E-01_JPRB, 0.405765E-01_JPRB &
  &, 0.357807E-01_JPRB, 0.314428E-01_JPRB, 0.275496E-01_JPRB, 0.240605E-01_JPRB &
  &, 0.209288E-01_JPRB, 0.181639E-01_JPRB, 0.156973E-01_JPRB &
  &, 0.135178E-01_JPRB, 0.116114E-01_JPRB, 0.993417E-02_JPRB, 0.846451E-02_JPRB &
  &, 0.719222E-02_JPRB, 0.609028E-02_JPRB, 0.514332E-02_JPRB &
  &, 0.431822E-02_JPRB, 0.362558E-02_JPRB, 0.302773E-02_JPRB, 0.251613E-02_JPRB &
  &, 0.208100E-02_JPRB, 0.172862E-02_JPRB, 0.141227E-02_JPRB &
  &, 0.115324E-02_JPRB, 0.955997E-03_JPRB, 0.768290E-03_JPRB, 0.629888E-03_JPRB &
  &, 0.504793E-03_JPRB, 0.394140E-03_JPRB, 0.319750E-03_JPRB &
  &, 0.263057E-03_JPRB, 0.203790E-03_JPRB, 0.163875E-03_JPRB, 0.122191E-03_JPRB &
  &, 0.101600E-03_JPRB, 0.801040E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.348074E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  72, :) = (/ &
  &  0.857259E+00_JPRB, 0.822913E+00_JPRB, 0.789139E+00_JPRB, 0.755954E+00_JPRB &
  &, 0.723375E+00_JPRB, 0.691420E+00_JPRB, 0.660105E+00_JPRB &
  &, 0.629447E+00_JPRB, 0.599461E+00_JPRB, 0.570165E+00_JPRB, 0.541573E+00_JPRB &
  &, 0.513699E+00_JPRB, 0.486558E+00_JPRB, 0.460165E+00_JPRB &
  &, 0.434531E+00_JPRB, 0.409668E+00_JPRB, 0.385589E+00_JPRB, 0.362304E+00_JPRB &
  &, 0.339821E+00_JPRB, 0.318150E+00_JPRB, 0.297298E+00_JPRB &
  &, 0.277266E+00_JPRB, 0.258066E+00_JPRB, 0.239691E+00_JPRB, 0.222147E+00_JPRB &
  &, 0.205434E+00_JPRB, 0.189545E+00_JPRB, 0.174474E+00_JPRB &
  &, 0.160217E+00_JPRB, 0.146759E+00_JPRB, 0.134091E+00_JPRB, 0.122201E+00_JPRB &
  &, 0.111066E+00_JPRB, 0.100673E+00_JPRB, 0.910003E-01_JPRB &
  &, 0.820195E-01_JPRB, 0.737194E-01_JPRB, 0.660613E-01_JPRB, 0.590200E-01_JPRB &
  &, 0.525758E-01_JPRB, 0.466832E-01_JPRB, 0.413219E-01_JPRB &
  &, 0.364674E-01_JPRB, 0.320785E-01_JPRB, 0.281197E-01_JPRB, 0.245732E-01_JPRB &
  &, 0.214054E-01_JPRB, 0.185896E-01_JPRB, 0.160821E-01_JPRB &
  &, 0.138725E-01_JPRB, 0.119210E-01_JPRB, 0.102098E-01_JPRB, 0.870445E-02_JPRB &
  &, 0.740898E-02_JPRB, 0.628260E-02_JPRB, 0.530989E-02_JPRB &
  &, 0.445770E-02_JPRB, 0.373658E-02_JPRB, 0.312508E-02_JPRB, 0.259912E-02_JPRB &
  &, 0.216588E-02_JPRB, 0.178070E-02_JPRB, 0.146552E-02_JPRB &
  &, 0.120768E-02_JPRB, 0.993095E-03_JPRB, 0.806204E-03_JPRB, 0.649259E-03_JPRB &
  &, 0.524585E-03_JPRB, 0.414358E-03_JPRB, 0.340400E-03_JPRB &
  &, 0.263057E-03_JPRB, 0.203790E-03_JPRB, 0.163875E-03_JPRB, 0.122191E-03_JPRB &
  &, 0.101600E-03_JPRB, 0.801040E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.348074E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  73, :) = (/ &
  &  0.857920E+00_JPRB, 0.823718E+00_JPRB, 0.790077E+00_JPRB, 0.757017E+00_JPRB &
  &, 0.724554E+00_JPRB, 0.692707E+00_JPRB, 0.661491E+00_JPRB &
  &, 0.630923E+00_JPRB, 0.601019E+00_JPRB, 0.571795E+00_JPRB, 0.543267E+00_JPRB &
  &, 0.515448E+00_JPRB, 0.488355E+00_JPRB, 0.462000E+00_JPRB &
  &, 0.436397E+00_JPRB, 0.411559E+00_JPRB, 0.387496E+00_JPRB, 0.364219E+00_JPRB &
  &, 0.341737E+00_JPRB, 0.320060E+00_JPRB, 0.299194E+00_JPRB &
  &, 0.279146E+00_JPRB, 0.259918E+00_JPRB, 0.241513E+00_JPRB, 0.223934E+00_JPRB &
  &, 0.207180E+00_JPRB, 0.191244E+00_JPRB, 0.176123E+00_JPRB &
  &, 0.161808E+00_JPRB, 0.148294E+00_JPRB, 0.135566E+00_JPRB, 0.123611E+00_JPRB &
  &, 0.112417E+00_JPRB, 0.101956E+00_JPRB, 0.922159E-01_JPRB &
  &, 0.831729E-01_JPRB, 0.747971E-01_JPRB, 0.670684E-01_JPRB, 0.599624E-01_JPRB &
  &, 0.534495E-01_JPRB, 0.474946E-01_JPRB, 0.420782E-01_JPRB &
  &, 0.371540E-01_JPRB, 0.327142E-01_JPRB, 0.287015E-01_JPRB, 0.251098E-01_JPRB &
  &, 0.218819E-01_JPRB, 0.190153E-01_JPRB, 0.164669E-01_JPRB &
  &, 0.142142E-01_JPRB, 0.122305E-01_JPRB, 0.104855E-01_JPRB, 0.895851E-02_JPRB &
  &, 0.762575E-02_JPRB, 0.647492E-02_JPRB, 0.546132E-02_JPRB &
  &, 0.461267E-02_JPRB, 0.386345E-02_JPRB, 0.323865E-02_JPRB, 0.269870E-02_JPRB &
  &, 0.223378E-02_JPRB, 0.185014E-02_JPRB, 0.153652E-02_JPRB &
  &, 0.126212E-02_JPRB, 0.103019E-02_JPRB, 0.844119E-03_JPRB, 0.688002E-03_JPRB &
  &, 0.544376E-03_JPRB, 0.434576E-03_JPRB, 0.361050E-03_JPRB &
  &, 0.284145E-03_JPRB, 0.225322E-03_JPRB, 0.185857E-03_JPRB, 0.144629E-03_JPRB &
  &, 0.101600E-03_JPRB, 0.801040E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.343217E-04_JPRB, 0.348074E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  74, :) = (/ &
  &  0.858575E+00_JPRB, 0.824514E+00_JPRB, 0.791005E+00_JPRB, 0.758070E+00_JPRB &
  &, 0.725723E+00_JPRB, 0.693982E+00_JPRB, 0.662864E+00_JPRB &
  &, 0.632385E+00_JPRB, 0.602562E+00_JPRB, 0.573410E+00_JPRB, 0.544946E+00_JPRB &
  &, 0.517183E+00_JPRB, 0.490137E+00_JPRB, 0.463823E+00_JPRB &
  &, 0.438251E+00_JPRB, 0.413435E+00_JPRB, 0.389389E+00_JPRB, 0.366120E+00_JPRB &
  &, 0.343641E+00_JPRB, 0.321957E+00_JPRB, 0.301081E+00_JPRB &
  &, 0.281012E+00_JPRB, 0.261763E+00_JPRB, 0.243329E+00_JPRB, 0.225710E+00_JPRB &
  &, 0.208915E+00_JPRB, 0.192935E+00_JPRB, 0.177764E+00_JPRB &
  &, 0.163396E+00_JPRB, 0.149825E+00_JPRB, 0.137040E+00_JPRB, 0.125022E+00_JPRB &
  &, 0.113759E+00_JPRB, 0.103234E+00_JPRB, 0.934270E-01_JPRB &
  &, 0.843169E-01_JPRB, 0.758747E-01_JPRB, 0.680854E-01_JPRB, 0.609149E-01_JPRB &
  &, 0.543335E-01_JPRB, 0.483166E-01_JPRB, 0.428344E-01_JPRB &
  &, 0.378517E-01_JPRB, 0.333499E-01_JPRB, 0.292832E-01_JPRB, 0.256345E-01_JPRB &
  &, 0.223707E-01_JPRB, 0.194535E-01_JPRB, 0.168517E-01_JPRB &
  &, 0.145689E-01_JPRB, 0.125401E-01_JPRB, 0.107612E-01_JPRB, 0.919845E-02_JPRB &
  &, 0.784252E-02_JPRB, 0.665245E-02_JPRB, 0.564303E-02_JPRB &
  &, 0.475214E-02_JPRB, 0.399031E-02_JPRB, 0.335222E-02_JPRB, 0.279828E-02_JPRB &
  &, 0.231865E-02_JPRB, 0.191958E-02_JPRB, 0.158977E-02_JPRB &
  &, 0.129841E-02_JPRB, 0.106729E-02_JPRB, 0.882033E-03_JPRB, 0.707374E-03_JPRB &
  &, 0.583960E-03_JPRB, 0.454794E-03_JPRB, 0.361050E-03_JPRB &
  &, 0.305234E-03_JPRB, 0.225322E-03_JPRB, 0.185857E-03_JPRB, 0.144629E-03_JPRB &
  &, 0.101600E-03_JPRB, 0.801040E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.348074E-04_JPRB, 0.352992E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  75, :) = (/ &
  &  0.859223E+00_JPRB, 0.825302E+00_JPRB, 0.791926E+00_JPRB, 0.759114E+00_JPRB &
  &, 0.726880E+00_JPRB, 0.695246E+00_JPRB, 0.664225E+00_JPRB &
  &, 0.633834E+00_JPRB, 0.604091E+00_JPRB, 0.575012E+00_JPRB, 0.546611E+00_JPRB &
  &, 0.518904E+00_JPRB, 0.491906E+00_JPRB, 0.465630E+00_JPRB &
  &, 0.440090E+00_JPRB, 0.415299E+00_JPRB, 0.391269E+00_JPRB, 0.368010E+00_JPRB &
  &, 0.345532E+00_JPRB, 0.323844E+00_JPRB, 0.302956E+00_JPRB &
  &, 0.282872E+00_JPRB, 0.263594E+00_JPRB, 0.245130E+00_JPRB, 0.227483E+00_JPRB &
  &, 0.210646E+00_JPRB, 0.194619E+00_JPRB, 0.179401E+00_JPRB &
  &, 0.164983E+00_JPRB, 0.151355E+00_JPRB, 0.138510E+00_JPRB, 0.126432E+00_JPRB &
  &, 0.115105E+00_JPRB, 0.104517E+00_JPRB, 0.946427E-01_JPRB &
  &, 0.854610E-01_JPRB, 0.769524E-01_JPRB, 0.690925E-01_JPRB, 0.618573E-01_JPRB &
  &, 0.552175E-01_JPRB, 0.491386E-01_JPRB, 0.435906E-01_JPRB &
  &, 0.385494E-01_JPRB, 0.339856E-01_JPRB, 0.298766E-01_JPRB, 0.261710E-01_JPRB &
  &, 0.228472E-01_JPRB, 0.198917E-01_JPRB, 0.172494E-01_JPRB &
  &, 0.149106E-01_JPRB, 0.128496E-01_JPRB, 0.110369E-01_JPRB, 0.945251E-02_JPRB &
  &, 0.805928E-02_JPRB, 0.685956E-02_JPRB, 0.580960E-02_JPRB &
  &, 0.490711E-02_JPRB, 0.411717E-02_JPRB, 0.344957E-02_JPRB, 0.288126E-02_JPRB &
  &, 0.240353E-02_JPRB, 0.198902E-02_JPRB, 0.164302E-02_JPRB &
  &, 0.135285E-02_JPRB, 0.110439E-02_JPRB, 0.900991E-03_JPRB, 0.746117E-03_JPRB &
  &, 0.603751E-03_JPRB, 0.475011E-03_JPRB, 0.381700E-03_JPRB &
  &, 0.305234E-03_JPRB, 0.246854E-03_JPRB, 0.185857E-03_JPRB, 0.144629E-03_JPRB &
  &, 0.124500E-03_JPRB, 0.801040E-04_JPRB, 0.576837E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.348074E-04_JPRB, 0.352992E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  76, :) = (/ &
  &  0.859865E+00_JPRB, 0.826083E+00_JPRB, 0.792837E+00_JPRB, 0.760147E+00_JPRB &
  &, 0.728028E+00_JPRB, 0.696497E+00_JPRB, 0.665573E+00_JPRB &
  &, 0.635271E+00_JPRB, 0.605608E+00_JPRB, 0.576600E+00_JPRB, 0.548263E+00_JPRB &
  &, 0.520611E+00_JPRB, 0.493661E+00_JPRB, 0.467424E+00_JPRB &
  &, 0.441916E+00_JPRB, 0.417149E+00_JPRB, 0.393135E+00_JPRB, 0.369886E+00_JPRB &
  &, 0.347411E+00_JPRB, 0.325719E+00_JPRB, 0.304820E+00_JPRB &
  &, 0.284719E+00_JPRB, 0.265419E+00_JPRB, 0.246927E+00_JPRB, 0.229241E+00_JPRB &
  &, 0.212367E+00_JPRB, 0.196299E+00_JPRB, 0.181031E+00_JPRB &
  &, 0.166559E+00_JPRB, 0.152878E+00_JPRB, 0.139976E+00_JPRB, 0.127838E+00_JPRB &
  &, 0.116447E+00_JPRB, 0.105796E+00_JPRB, 0.958583E-01_JPRB &
  &, 0.866144E-01_JPRB, 0.780396E-01_JPRB, 0.701094E-01_JPRB, 0.628097E-01_JPRB &
  &, 0.561015E-01_JPRB, 0.499605E-01_JPRB, 0.443577E-01_JPRB &
  &, 0.392581E-01_JPRB, 0.346327E-01_JPRB, 0.304583E-01_JPRB, 0.267076E-01_JPRB &
  &, 0.233360E-01_JPRB, 0.203299E-01_JPRB, 0.176470E-01_JPRB &
  &, 0.152785E-01_JPRB, 0.131726E-01_JPRB, 0.113263E-01_JPRB, 0.970657E-02_JPRB &
  &, 0.829050E-02_JPRB, 0.705188E-02_JPRB, 0.597616E-02_JPRB &
  &, 0.504659E-02_JPRB, 0.425989E-02_JPRB, 0.356314E-02_JPRB, 0.298085E-02_JPRB &
  &, 0.248841E-02_JPRB, 0.205846E-02_JPRB, 0.171402E-02_JPRB &
  &, 0.140729E-02_JPRB, 0.116004E-02_JPRB, 0.938905E-03_JPRB, 0.765488E-03_JPRB &
  &, 0.623543E-03_JPRB, 0.515447E-03_JPRB, 0.402350E-03_JPRB &
  &, 0.326322E-03_JPRB, 0.268386E-03_JPRB, 0.207840E-03_JPRB, 0.167067E-03_JPRB &
  &, 0.124500E-03_JPRB, 0.103472E-03_JPRB, 0.815255E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.348074E-04_JPRB, 0.352992E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  77, :) = (/ &
  &  0.860500E+00_JPRB, 0.826857E+00_JPRB, 0.793740E+00_JPRB, 0.761171E+00_JPRB &
  &, 0.729164E+00_JPRB, 0.697739E+00_JPRB, 0.666910E+00_JPRB &
  &, 0.636695E+00_JPRB, 0.607112E+00_JPRB, 0.578175E+00_JPRB, 0.549901E+00_JPRB &
  &, 0.522305E+00_JPRB, 0.495402E+00_JPRB, 0.469205E+00_JPRB &
  &, 0.443729E+00_JPRB, 0.418987E+00_JPRB, 0.394990E+00_JPRB, 0.371751E+00_JPRB &
  &, 0.349279E+00_JPRB, 0.327585E+00_JPRB, 0.306675E+00_JPRB &
  &, 0.286556E+00_JPRB, 0.267233E+00_JPRB, 0.248715E+00_JPRB, 0.230996E+00_JPRB &
  &, 0.214084E+00_JPRB, 0.197972E+00_JPRB, 0.182656E+00_JPRB &
  &, 0.168135E+00_JPRB, 0.154401E+00_JPRB, 0.141438E+00_JPRB, 0.129240E+00_JPRB &
  &, 0.117789E+00_JPRB, 0.107074E+00_JPRB, 0.970694E-01_JPRB &
  &, 0.877584E-01_JPRB, 0.791172E-01_JPRB, 0.711263E-01_JPRB, 0.637621E-01_JPRB &
  &, 0.569855E-01_JPRB, 0.507825E-01_JPRB, 0.451139E-01_JPRB &
  &, 0.399669E-01_JPRB, 0.352797E-01_JPRB, 0.310517E-01_JPRB, 0.272442E-01_JPRB &
  &, 0.238369E-01_JPRB, 0.207806E-01_JPRB, 0.180575E-01_JPRB &
  &, 0.156333E-01_JPRB, 0.134956E-01_JPRB, 0.116158E-01_JPRB, 0.996063E-02_JPRB &
  &, 0.850727E-02_JPRB, 0.724420E-02_JPRB, 0.615788E-02_JPRB &
  &, 0.520156E-02_JPRB, 0.438675E-02_JPRB, 0.369293E-02_JPRB, 0.308043E-02_JPRB &
  &, 0.257328E-02_JPRB, 0.214526E-02_JPRB, 0.176728E-02_JPRB &
  &, 0.146173E-02_JPRB, 0.119713E-02_JPRB, 0.976820E-03_JPRB, 0.804232E-03_JPRB &
  &, 0.663127E-03_JPRB, 0.535665E-03_JPRB, 0.423000E-03_JPRB &
  &, 0.347410E-03_JPRB, 0.268386E-03_JPRB, 0.207840E-03_JPRB, 0.167067E-03_JPRB &
  &, 0.124500E-03_JPRB, 0.103472E-03_JPRB, 0.815255E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.348074E-04_JPRB, 0.352992E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART12

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART12',0,ZHOOK_HANDLE)

XCW(  78, :) = (/ &
  &  0.861131E+00_JPRB, 0.827623E+00_JPRB, 0.794635E+00_JPRB, 0.762186E+00_JPRB &
  &, 0.730291E+00_JPRB, 0.698968E+00_JPRB, 0.668235E+00_JPRB &
  &, 0.638108E+00_JPRB, 0.608603E+00_JPRB, 0.579738E+00_JPRB, 0.551527E+00_JPRB &
  &, 0.523986E+00_JPRB, 0.497129E+00_JPRB, 0.470972E+00_JPRB &
  &, 0.445529E+00_JPRB, 0.420810E+00_JPRB, 0.396832E+00_JPRB, 0.373603E+00_JPRB &
  &, 0.351134E+00_JPRB, 0.329437E+00_JPRB, 0.308517E+00_JPRB &
  &, 0.288383E+00_JPRB, 0.269041E+00_JPRB, 0.250492E+00_JPRB, 0.232744E+00_JPRB &
  &, 0.215790E+00_JPRB, 0.199637E+00_JPRB, 0.184278E+00_JPRB &
  &, 0.169707E+00_JPRB, 0.155915E+00_JPRB, 0.142896E+00_JPRB, 0.130641E+00_JPRB &
  &, 0.119132E+00_JPRB, 0.108349E+00_JPRB, 0.982850E-01_JPRB &
  &, 0.889118E-01_JPRB, 0.802044E-01_JPRB, 0.721531E-01_JPRB, 0.647145E-01_JPRB &
  &, 0.578797E-01_JPRB, 0.516150E-01_JPRB, 0.458918E-01_JPRB &
  &, 0.406757E-01_JPRB, 0.359381E-01_JPRB, 0.316567E-01_JPRB, 0.277927E-01_JPRB &
  &, 0.243257E-01_JPRB, 0.212313E-01_JPRB, 0.184551E-01_JPRB &
  &, 0.160012E-01_JPRB, 0.138186E-01_JPRB, 0.119052E-01_JPRB, 0.102147E-01_JPRB &
  &, 0.873849E-02_JPRB, 0.745131E-02_JPRB, 0.632444E-02_JPRB &
  &, 0.535653E-02_JPRB, 0.452947E-02_JPRB, 0.380650E-02_JPRB, 0.319661E-02_JPRB &
  &, 0.265816E-02_JPRB, 0.221470E-02_JPRB, 0.183828E-02_JPRB &
  &, 0.151617E-02_JPRB, 0.125278E-02_JPRB, 0.103369E-02_JPRB, 0.842974E-03_JPRB &
  &, 0.682918E-03_JPRB, 0.555883E-03_JPRB, 0.443650E-03_JPRB &
  &, 0.347410E-03_JPRB, 0.289918E-03_JPRB, 0.229822E-03_JPRB, 0.189505E-03_JPRB &
  &, 0.147401E-03_JPRB, 0.103472E-03_JPRB, 0.815255E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.348074E-04_JPRB, 0.352992E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  79, :) = (/ &
  &  0.861754E+00_JPRB, 0.828382E+00_JPRB, 0.795521E+00_JPRB, 0.763191E+00_JPRB &
  &, 0.731407E+00_JPRB, 0.700188E+00_JPRB, 0.669549E+00_JPRB &
  &, 0.639509E+00_JPRB, 0.610083E+00_JPRB, 0.581288E+00_JPRB, 0.553140E+00_JPRB &
  &, 0.525654E+00_JPRB, 0.498845E+00_JPRB, 0.472727E+00_JPRB &
  &, 0.447316E+00_JPRB, 0.422624E+00_JPRB, 0.398662E+00_JPRB, 0.375445E+00_JPRB &
  &, 0.352980E+00_JPRB, 0.331277E+00_JPRB, 0.310349E+00_JPRB &
  &, 0.290199E+00_JPRB, 0.270838E+00_JPRB, 0.252262E+00_JPRB, 0.234481E+00_JPRB &
  &, 0.217492E+00_JPRB, 0.201298E+00_JPRB, 0.185892E+00_JPRB &
  &, 0.171271E+00_JPRB, 0.157430E+00_JPRB, 0.144354E+00_JPRB, 0.132039E+00_JPRB &
  &, 0.120469E+00_JPRB, 0.109627E+00_JPRB, 0.994961E-01_JPRB &
  &, 0.900558E-01_JPRB, 0.812916E-01_JPRB, 0.731700E-01_JPRB, 0.656770E-01_JPRB &
  &, 0.587740E-01_JPRB, 0.524475E-01_JPRB, 0.466588E-01_JPRB &
  &, 0.413845E-01_JPRB, 0.365965E-01_JPRB, 0.322617E-01_JPRB, 0.283412E-01_JPRB &
  &, 0.248267E-01_JPRB, 0.216820E-01_JPRB, 0.188656E-01_JPRB &
  &, 0.163691E-01_JPRB, 0.141551E-01_JPRB, 0.121947E-01_JPRB, 0.104829E-01_JPRB &
  &, 0.896971E-02_JPRB, 0.765843E-02_JPRB, 0.650615E-02_JPRB &
  &, 0.552700E-02_JPRB, 0.465634E-02_JPRB, 0.392007E-02_JPRB, 0.329619E-02_JPRB &
  &, 0.276001E-02_JPRB, 0.230150E-02_JPRB, 0.190928E-02_JPRB &
  &, 0.157061E-02_JPRB, 0.128988E-02_JPRB, 0.107161E-02_JPRB, 0.862346E-03_JPRB &
  &, 0.702710E-03_JPRB, 0.576101E-03_JPRB, 0.464300E-03_JPRB &
  &, 0.368498E-03_JPRB, 0.289918E-03_JPRB, 0.229822E-03_JPRB, 0.189505E-03_JPRB &
  &, 0.147401E-03_JPRB, 0.103472E-03_JPRB, 0.815255E-04_JPRB &
  &, 0.586433E-04_JPRB, 0.596149E-04_JPRB, 0.352992E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  80, :) = (/ &
  &  0.862372E+00_JPRB, 0.829134E+00_JPRB, 0.796400E+00_JPRB, 0.764188E+00_JPRB &
  &, 0.732514E+00_JPRB, 0.701396E+00_JPRB, 0.670852E+00_JPRB &
  &, 0.640898E+00_JPRB, 0.611550E+00_JPRB, 0.582826E+00_JPRB, 0.554741E+00_JPRB &
  &, 0.527309E+00_JPRB, 0.500547E+00_JPRB, 0.474470E+00_JPRB &
  &, 0.449091E+00_JPRB, 0.424424E+00_JPRB, 0.400481E+00_JPRB, 0.377274E+00_JPRB &
  &, 0.354814E+00_JPRB, 0.333111E+00_JPRB, 0.312174E+00_JPRB &
  &, 0.292010E+00_JPRB, 0.272626E+00_JPRB, 0.254025E+00_JPRB, 0.236211E+00_JPRB &
  &, 0.219187E+00_JPRB, 0.202952E+00_JPRB, 0.187503E+00_JPRB &
  &, 0.172835E+00_JPRB, 0.158940E+00_JPRB, 0.145812E+00_JPRB, 0.133437E+00_JPRB &
  &, 0.121807E+00_JPRB, 0.110906E+00_JPRB, 0.100712E+00_JPRB &
  &, 0.912092E-01_JPRB, 0.823788E-01_JPRB, 0.741967E-01_JPRB, 0.666294E-01_JPRB &
  &, 0.596682E-01_JPRB, 0.532801E-01_JPRB, 0.474366E-01_JPRB &
  &, 0.421043E-01_JPRB, 0.372549E-01_JPRB, 0.328667E-01_JPRB, 0.289016E-01_JPRB &
  &, 0.253399E-01_JPRB, 0.221327E-01_JPRB, 0.192888E-01_JPRB &
  &, 0.167370E-01_JPRB, 0.144916E-01_JPRB, 0.124979E-01_JPRB, 0.107510E-01_JPRB &
  &, 0.921537E-02_JPRB, 0.786554E-02_JPRB, 0.670301E-02_JPRB &
  &, 0.568197E-02_JPRB, 0.479906E-02_JPRB, 0.404987E-02_JPRB, 0.339577E-02_JPRB &
  &, 0.284489E-02_JPRB, 0.237094E-02_JPRB, 0.198028E-02_JPRB &
  &, 0.162505E-02_JPRB, 0.134552E-02_JPRB, 0.110952E-02_JPRB, 0.901089E-03_JPRB &
  &, 0.742293E-03_JPRB, 0.596319E-03_JPRB, 0.484950E-03_JPRB &
  &, 0.389586E-03_JPRB, 0.311450E-03_JPRB, 0.251804E-03_JPRB, 0.189505E-03_JPRB &
  &, 0.147401E-03_JPRB, 0.126840E-03_JPRB, 0.105367E-03_JPRB &
  &, 0.829650E-04_JPRB, 0.596149E-04_JPRB, 0.352992E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  81, :) = (/ &
  &  0.862984E+00_JPRB, 0.829880E+00_JPRB, 0.797271E+00_JPRB, 0.765176E+00_JPRB &
  &, 0.733612E+00_JPRB, 0.702595E+00_JPRB, 0.672145E+00_JPRB &
  &, 0.642276E+00_JPRB, 0.613006E+00_JPRB, 0.584352E+00_JPRB, 0.556329E+00_JPRB &
  &, 0.528953E+00_JPRB, 0.502238E+00_JPRB, 0.476201E+00_JPRB &
  &, 0.450854E+00_JPRB, 0.426212E+00_JPRB, 0.402287E+00_JPRB, 0.379093E+00_JPRB &
  &, 0.356637E+00_JPRB, 0.334932E+00_JPRB, 0.313987E+00_JPRB &
  &, 0.293810E+00_JPRB, 0.274406E+00_JPRB, 0.255781E+00_JPRB, 0.237938E+00_JPRB &
  &, 0.220878E+00_JPRB, 0.204603E+00_JPRB, 0.189109E+00_JPRB &
  &, 0.174391E+00_JPRB, 0.160447E+00_JPRB, 0.147262E+00_JPRB, 0.134834E+00_JPRB &
  &, 0.123145E+00_JPRB, 0.112180E+00_JPRB, 0.101923E+00_JPRB &
  &, 0.923626E-01_JPRB, 0.834660E-01_JPRB, 0.752136E-01_JPRB, 0.675918E-01_JPRB &
  &, 0.605728E-01_JPRB, 0.541126E-01_JPRB, 0.482145E-01_JPRB &
  &, 0.428242E-01_JPRB, 0.379133E-01_JPRB, 0.334717E-01_JPRB, 0.294620E-01_JPRB &
  &, 0.258408E-01_JPRB, 0.225960E-01_JPRB, 0.196993E-01_JPRB &
  &, 0.171181E-01_JPRB, 0.148281E-01_JPRB, 0.128011E-01_JPRB, 0.110192E-01_JPRB &
  &, 0.944659E-02_JPRB, 0.807266E-02_JPRB, 0.688472E-02_JPRB &
  &, 0.583695E-02_JPRB, 0.494178E-02_JPRB, 0.417966E-02_JPRB, 0.351195E-02_JPRB &
  &, 0.292977E-02_JPRB, 0.245774E-02_JPRB, 0.203353E-02_JPRB &
  &, 0.169764E-02_JPRB, 0.140117E-02_JPRB, 0.114743E-02_JPRB, 0.939832E-03_JPRB &
  &, 0.762085E-03_JPRB, 0.616537E-03_JPRB, 0.505600E-03_JPRB &
  &, 0.410674E-03_JPRB, 0.332983E-03_JPRB, 0.251804E-03_JPRB, 0.211943E-03_JPRB &
  &, 0.170301E-03_JPRB, 0.126840E-03_JPRB, 0.105367E-03_JPRB &
  &, 0.829650E-04_JPRB, 0.596149E-04_JPRB, 0.352992E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  82, :) = (/ &
  &  0.863590E+00_JPRB, 0.830619E+00_JPRB, 0.798134E+00_JPRB, 0.766156E+00_JPRB &
  &, 0.734699E+00_JPRB, 0.703784E+00_JPRB, 0.673426E+00_JPRB &
  &, 0.643643E+00_JPRB, 0.614451E+00_JPRB, 0.585867E+00_JPRB, 0.557906E+00_JPRB &
  &, 0.530584E+00_JPRB, 0.503917E+00_JPRB, 0.477919E+00_JPRB &
  &, 0.452606E+00_JPRB, 0.427989E+00_JPRB, 0.404083E+00_JPRB, 0.380899E+00_JPRB &
  &, 0.358450E+00_JPRB, 0.336744E+00_JPRB, 0.315793E+00_JPRB &
  &, 0.295600E+00_JPRB, 0.276176E+00_JPRB, 0.257526E+00_JPRB, 0.239654E+00_JPRB &
  &, 0.222562E+00_JPRB, 0.206246E+00_JPRB, 0.190708E+00_JPRB &
  &, 0.175943E+00_JPRB, 0.161950E+00_JPRB, 0.148711E+00_JPRB, 0.136228E+00_JPRB &
  &, 0.124478E+00_JPRB, 0.113454E+00_JPRB, 0.103138E+00_JPRB &
  &, 0.935066E-01_JPRB, 0.845531E-01_JPRB, 0.762403E-01_JPRB, 0.685543E-01_JPRB &
  &, 0.614670E-01_JPRB, 0.549556E-01_JPRB, 0.489923E-01_JPRB &
  &, 0.435440E-01_JPRB, 0.385831E-01_JPRB, 0.340884E-01_JPRB, 0.300225E-01_JPRB &
  &, 0.263540E-01_JPRB, 0.230592E-01_JPRB, 0.201226E-01_JPRB &
  &, 0.174991E-01_JPRB, 0.151645E-01_JPRB, 0.131044E-01_JPRB, 0.112874E-01_JPRB &
  &, 0.969226E-02_JPRB, 0.829456E-02_JPRB, 0.706643E-02_JPRB &
  &, 0.600742E-02_JPRB, 0.508450E-02_JPRB, 0.429324E-02_JPRB, 0.361153E-02_JPRB &
  &, 0.303162E-02_JPRB, 0.252718E-02_JPRB, 0.210453E-02_JPRB &
  &, 0.175208E-02_JPRB, 0.145682E-02_JPRB, 0.118535E-02_JPRB, 0.978575E-03_JPRB &
  &, 0.801669E-03_JPRB, 0.656972E-03_JPRB, 0.526251E-03_JPRB &
  &, 0.431762E-03_JPRB, 0.332983E-03_JPRB, 0.273786E-03_JPRB, 0.211943E-03_JPRB &
  &, 0.170301E-03_JPRB, 0.126840E-03_JPRB, 0.105367E-03_JPRB &
  &, 0.829650E-04_JPRB, 0.596149E-04_JPRB, 0.352992E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  83, :) = (/ &
  &  0.864193E+00_JPRB, 0.831352E+00_JPRB, 0.798990E+00_JPRB, 0.767127E+00_JPRB &
  &, 0.735779E+00_JPRB, 0.704964E+00_JPRB, 0.674698E+00_JPRB &
  &, 0.644999E+00_JPRB, 0.615884E+00_JPRB, 0.587370E+00_JPRB, 0.559471E+00_JPRB &
  &, 0.532204E+00_JPRB, 0.505583E+00_JPRB, 0.479627E+00_JPRB &
  &, 0.454346E+00_JPRB, 0.429755E+00_JPRB, 0.405868E+00_JPRB, 0.382697E+00_JPRB &
  &, 0.360253E+00_JPRB, 0.338546E+00_JPRB, 0.317586E+00_JPRB &
  &, 0.297384E+00_JPRB, 0.277940E+00_JPRB, 0.259268E+00_JPRB, 0.241366E+00_JPRB &
  &, 0.224239E+00_JPRB, 0.207885E+00_JPRB, 0.192304E+00_JPRB &
  &, 0.177495E+00_JPRB, 0.163448E+00_JPRB, 0.150161E+00_JPRB, 0.137617E+00_JPRB &
  &, 0.125812E+00_JPRB, 0.114728E+00_JPRB, 0.104354E+00_JPRB &
  &, 0.946600E-01_JPRB, 0.856403E-01_JPRB, 0.772670E-01_JPRB, 0.695267E-01_JPRB &
  &, 0.623716E-01_JPRB, 0.557987E-01_JPRB, 0.497702E-01_JPRB &
  &, 0.442638E-01_JPRB, 0.392528E-01_JPRB, 0.347050E-01_JPRB, 0.305829E-01_JPRB &
  &, 0.268672E-01_JPRB, 0.235350E-01_JPRB, 0.205459E-01_JPRB &
  &, 0.178802E-01_JPRB, 0.155144E-01_JPRB, 0.134214E-01_JPRB, 0.115697E-01_JPRB &
  &, 0.993793E-02_JPRB, 0.851647E-02_JPRB, 0.726328E-02_JPRB &
  &, 0.617788E-02_JPRB, 0.524308E-02_JPRB, 0.442303E-02_JPRB, 0.372771E-02_JPRB &
  &, 0.313347E-02_JPRB, 0.261398E-02_JPRB, 0.217553E-02_JPRB &
  &, 0.180652E-02_JPRB, 0.149392E-02_JPRB, 0.124222E-02_JPRB, 0.101732E-02_JPRB &
  &, 0.841252E-03_JPRB, 0.677190E-03_JPRB, 0.546901E-03_JPRB &
  &, 0.452850E-03_JPRB, 0.354515E-03_JPRB, 0.295768E-03_JPRB, 0.234382E-03_JPRB &
  &, 0.170301E-03_JPRB, 0.150208E-03_JPRB, 0.105367E-03_JPRB &
  &, 0.829650E-04_JPRB, 0.596149E-04_JPRB, 0.605984E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  84, :) = (/ &
  &  0.864789E+00_JPRB, 0.832078E+00_JPRB, 0.799839E+00_JPRB, 0.768091E+00_JPRB &
  &, 0.736849E+00_JPRB, 0.706133E+00_JPRB, 0.675960E+00_JPRB &
  &, 0.646346E+00_JPRB, 0.617307E+00_JPRB, 0.588862E+00_JPRB, 0.561024E+00_JPRB &
  &, 0.533812E+00_JPRB, 0.507240E+00_JPRB, 0.481322E+00_JPRB &
  &, 0.456075E+00_JPRB, 0.431510E+00_JPRB, 0.407643E+00_JPRB, 0.384483E+00_JPRB &
  &, 0.362045E+00_JPRB, 0.340338E+00_JPRB, 0.319372E+00_JPRB &
  &, 0.299158E+00_JPRB, 0.279697E+00_JPRB, 0.261000E+00_JPRB, 0.243071E+00_JPRB &
  &, 0.225909E+00_JPRB, 0.209516E+00_JPRB, 0.193895E+00_JPRB &
  &, 0.179040E+00_JPRB, 0.164943E+00_JPRB, 0.151603E+00_JPRB, 0.139006E+00_JPRB &
  &, 0.127145E+00_JPRB, 0.116002E+00_JPRB, 0.105565E+00_JPRB &
  &, 0.958134E-01_JPRB, 0.867371E-01_JPRB, 0.783035E-01_JPRB, 0.704892E-01_JPRB &
  &, 0.632864E-01_JPRB, 0.566522E-01_JPRB, 0.505588E-01_JPRB &
  &, 0.449948E-01_JPRB, 0.399226E-01_JPRB, 0.353217E-01_JPRB, 0.311552E-01_JPRB &
  &, 0.273926E-01_JPRB, 0.240107E-01_JPRB, 0.209820E-01_JPRB &
  &, 0.182744E-01_JPRB, 0.158644E-01_JPRB, 0.137246E-01_JPRB, 0.118378E-01_JPRB &
  &, 0.101836E-01_JPRB, 0.872359E-02_JPRB, 0.746013E-02_JPRB &
  &, 0.634835E-02_JPRB, 0.538580E-02_JPRB, 0.455282E-02_JPRB, 0.384389E-02_JPRB &
  &, 0.323533E-02_JPRB, 0.270078E-02_JPRB, 0.226428E-02_JPRB &
  &, 0.187910E-02_JPRB, 0.154956E-02_JPRB, 0.128014E-02_JPRB, 0.105606E-02_JPRB &
  &, 0.861044E-03_JPRB, 0.697408E-03_JPRB, 0.567551E-03_JPRB &
  &, 0.473939E-03_JPRB, 0.376047E-03_JPRB, 0.295768E-03_JPRB, 0.234382E-03_JPRB &
  &, 0.193201E-03_JPRB, 0.150208E-03_JPRB, 0.105367E-03_JPRB &
  &, 0.829650E-04_JPRB, 0.596149E-04_JPRB, 0.605984E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART13

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART13',0,ZHOOK_HANDLE)

XCW(  85, :) = (/ &
  &  0.865380E+00_JPRB, 0.832799E+00_JPRB, 0.800680E+00_JPRB, 0.769044E+00_JPRB &
  &, 0.737911E+00_JPRB, 0.707294E+00_JPRB, 0.677212E+00_JPRB &
  &, 0.647681E+00_JPRB, 0.618720E+00_JPRB, 0.590343E+00_JPRB, 0.562567E+00_JPRB &
  &, 0.535408E+00_JPRB, 0.508884E+00_JPRB, 0.483007E+00_JPRB &
  &, 0.457792E+00_JPRB, 0.433254E+00_JPRB, 0.409405E+00_JPRB, 0.386259E+00_JPRB &
  &, 0.363827E+00_JPRB, 0.342121E+00_JPRB, 0.321149E+00_JPRB &
  &, 0.300922E+00_JPRB, 0.281447E+00_JPRB, 0.262725E+00_JPRB, 0.244769E+00_JPRB &
  &, 0.227575E+00_JPRB, 0.211144E+00_JPRB, 0.195483E+00_JPRB &
  &, 0.180580E+00_JPRB, 0.166437E+00_JPRB, 0.153044E+00_JPRB, 0.140395E+00_JPRB &
  &, 0.128479E+00_JPRB, 0.117277E+00_JPRB, 0.106781E+00_JPRB &
  &, 0.969667E-01_JPRB, 0.878242E-01_JPRB, 0.793302E-01_JPRB, 0.714617E-01_JPRB &
  &, 0.641909E-01_JPRB, 0.574953E-01_JPRB, 0.513474E-01_JPRB &
  &, 0.457257E-01_JPRB, 0.406037E-01_JPRB, 0.359383E-01_JPRB, 0.317276E-01_JPRB &
  &, 0.279181E-01_JPRB, 0.244865E-01_JPRB, 0.214053E-01_JPRB &
  &, 0.186554E-01_JPRB, 0.162143E-01_JPRB, 0.140417E-01_JPRB, 0.121342E-01_JPRB &
  &, 0.104437E-01_JPRB, 0.896029E-02_JPRB, 0.765699E-02_JPRB &
  &, 0.651882E-02_JPRB, 0.554438E-02_JPRB, 0.469884E-02_JPRB, 0.396006E-02_JPRB &
  &, 0.333718E-02_JPRB, 0.278757E-02_JPRB, 0.233528E-02_JPRB &
  &, 0.193354E-02_JPRB, 0.160521E-02_JPRB, 0.133701E-02_JPRB, 0.109480E-02_JPRB &
  &, 0.900627E-03_JPRB, 0.737844E-03_JPRB, 0.608851E-03_JPRB &
  &, 0.495027E-03_JPRB, 0.397579E-03_JPRB, 0.317751E-03_JPRB, 0.256820E-03_JPRB &
  &, 0.193201E-03_JPRB, 0.150208E-03_JPRB, 0.129209E-03_JPRB &
  &, 0.107287E-03_JPRB, 0.844223E-04_JPRB, 0.605984E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  86, :) = (/ &
  &  0.865968E+00_JPRB, 0.833513E+00_JPRB, 0.801515E+00_JPRB, 0.769993E+00_JPRB &
  &, 0.738964E+00_JPRB, 0.708446E+00_JPRB, 0.678454E+00_JPRB &
  &, 0.649007E+00_JPRB, 0.620121E+00_JPRB, 0.591813E+00_JPRB, 0.564099E+00_JPRB &
  &, 0.536995E+00_JPRB, 0.510517E+00_JPRB, 0.484681E+00_JPRB &
  &, 0.459499E+00_JPRB, 0.434987E+00_JPRB, 0.411159E+00_JPRB, 0.388026E+00_JPRB &
  &, 0.365503E+00_JPRB, 0.343894E+00_JPRB, 0.322920E+00_JPRB &
  &, 0.302679E+00_JPRB, 0.283187E+00_JPRB, 0.264443E+00_JPRB, 0.246460E+00_JPRB &
  &, 0.229233E+00_JPRB, 0.212769E+00_JPRB, 0.197066E+00_JPRB &
  &, 0.182121E+00_JPRB, 0.167928E+00_JPRB, 0.154486E+00_JPRB, 0.141784E+00_JPRB &
  &, 0.129808E+00_JPRB, 0.118551E+00_JPRB, 0.107996E+00_JPRB &
  &, 0.981201E-01_JPRB, 0.889210E-01_JPRB, 0.803667E-01_JPRB, 0.724341E-01_JPRB &
  &, 0.651057E-01_JPRB, 0.583489E-01_JPRB, 0.521469E-01_JPRB &
  &, 0.464677E-01_JPRB, 0.412848E-01_JPRB, 0.365666E-01_JPRB, 0.322999E-01_JPRB &
  &, 0.284435E-01_JPRB, 0.249623E-01_JPRB, 0.218414E-01_JPRB &
  &, 0.190628E-01_JPRB, 0.165777E-01_JPRB, 0.143587E-01_JPRB, 0.124165E-01_JPRB &
  &, 0.106894E-01_JPRB, 0.918220E-02_JPRB, 0.785384E-02_JPRB &
  &, 0.670479E-02_JPRB, 0.570295E-02_JPRB, 0.482864E-02_JPRB, 0.407624E-02_JPRB &
  &, 0.343903E-02_JPRB, 0.287437E-02_JPRB, 0.240628E-02_JPRB &
  &, 0.200613E-02_JPRB, 0.166086E-02_JPRB, 0.137492E-02_JPRB, 0.113355E-02_JPRB &
  &, 0.940211E-03_JPRB, 0.758062E-03_JPRB, 0.629501E-03_JPRB &
  &, 0.516115E-03_JPRB, 0.419111E-03_JPRB, 0.339733E-03_JPRB, 0.256820E-03_JPRB &
  &, 0.216101E-03_JPRB, 0.173576E-03_JPRB, 0.129209E-03_JPRB &
  &, 0.107287E-03_JPRB, 0.844223E-04_JPRB, 0.605984E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  87, :) = (/ &
  &  0.866548E+00_JPRB, 0.834220E+00_JPRB, 0.802343E+00_JPRB, 0.770934E+00_JPRB &
  &, 0.740009E+00_JPRB, 0.709588E+00_JPRB, 0.679687E+00_JPRB &
  &, 0.650322E+00_JPRB, 0.621513E+00_JPRB, 0.593273E+00_JPRB, 0.565621E+00_JPRB &
  &, 0.538571E+00_JPRB, 0.512141E+00_JPRB, 0.486322E+00_JPRB &
  &, 0.461195E+00_JPRB, 0.436710E+00_JPRB, 0.412901E+00_JPRB, 0.389783E+00_JPRB &
  &, 0.367366E+00_JPRB, 0.345661E+00_JPRB, 0.324677E+00_JPRB &
  &, 0.304430E+00_JPRB, 0.284920E+00_JPRB, 0.266157E+00_JPRB, 0.248144E+00_JPRB &
  &, 0.230888E+00_JPRB, 0.214385E+00_JPRB, 0.198642E+00_JPRB &
  &, 0.183654E+00_JPRB, 0.169418E+00_JPRB, 0.155923E+00_JPRB, 0.143169E+00_JPRB &
  &, 0.131137E+00_JPRB, 0.119825E+00_JPRB, 0.109207E+00_JPRB &
  &, 0.992734E-01_JPRB, 0.900177E-01_JPRB, 0.813934E-01_JPRB, 0.734066E-01_JPRB &
  &, 0.660103E-01_JPRB, 0.592025E-01_JPRB, 0.529463E-01_JPRB &
  &, 0.472097E-01_JPRB, 0.419659E-01_JPRB, 0.372065E-01_JPRB, 0.328842E-01_JPRB &
  &, 0.289689E-01_JPRB, 0.254505E-01_JPRB, 0.222903E-01_JPRB &
  &, 0.194570E-01_JPRB, 0.169276E-01_JPRB, 0.146895E-01_JPRB, 0.126988E-01_JPRB &
  &, 0.109495E-01_JPRB, 0.940410E-02_JPRB, 0.806584E-02_JPRB &
  &, 0.687526E-02_JPRB, 0.586153E-02_JPRB, 0.497466E-02_JPRB, 0.419242E-02_JPRB &
  &, 0.354088E-02_JPRB, 0.297853E-02_JPRB, 0.249504E-02_JPRB &
  &, 0.207872E-02_JPRB, 0.171650E-02_JPRB, 0.143179E-02_JPRB, 0.117229E-02_JPRB &
  &, 0.960002E-03_JPRB, 0.798498E-03_JPRB, 0.650151E-03_JPRB &
  &, 0.537203E-03_JPRB, 0.419111E-03_JPRB, 0.339733E-03_JPRB, 0.279258E-03_JPRB &
  &, 0.216101E-03_JPRB, 0.173576E-03_JPRB, 0.129209E-03_JPRB &
  &, 0.107287E-03_JPRB, 0.844223E-04_JPRB, 0.605984E-04_JPRB, 0.357969E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  88, :) = (/ &
  &  0.867125E+00_JPRB, 0.834923E+00_JPRB, 0.803164E+00_JPRB, 0.771867E+00_JPRB &
  &, 0.741047E+00_JPRB, 0.710722E+00_JPRB, 0.680911E+00_JPRB &
  &, 0.651629E+00_JPRB, 0.622895E+00_JPRB, 0.594723E+00_JPRB, 0.567132E+00_JPRB &
  &, 0.540136E+00_JPRB, 0.513753E+00_JPRB, 0.487996E+00_JPRB &
  &, 0.462881E+00_JPRB, 0.438423E+00_JPRB, 0.414636E+00_JPRB, 0.391530E+00_JPRB &
  &, 0.369121E+00_JPRB, 0.347416E+00_JPRB, 0.326431E+00_JPRB &
  &, 0.306170E+00_JPRB, 0.286646E+00_JPRB, 0.267861E+00_JPRB, 0.249824E+00_JPRB &
  &, 0.232536E+00_JPRB, 0.216002E+00_JPRB, 0.200218E+00_JPRB &
  &, 0.185187E+00_JPRB, 0.170901E+00_JPRB, 0.157360E+00_JPRB, 0.144550E+00_JPRB &
  &, 0.132466E+00_JPRB, 0.121095E+00_JPRB, 0.110423E+00_JPRB &
  &, 0.100436E+00_JPRB, 0.911144E-01_JPRB, 0.824299E-01_JPRB, 0.743791E-01_JPRB &
  &, 0.669353E-01_JPRB, 0.600560E-01_JPRB, 0.537350E-01_JPRB &
  &, 0.479517E-01_JPRB, 0.426583E-01_JPRB, 0.378348E-01_JPRB, 0.334565E-01_JPRB &
  &, 0.295065E-01_JPRB, 0.259388E-01_JPRB, 0.227265E-01_JPRB &
  &, 0.198511E-01_JPRB, 0.172910E-01_JPRB, 0.150203E-01_JPRB, 0.129952E-01_JPRB &
  &, 0.112096E-01_JPRB, 0.964081E-02_JPRB, 0.826269E-02_JPRB &
  &, 0.706122E-02_JPRB, 0.602011E-02_JPRB, 0.510445E-02_JPRB, 0.432520E-02_JPRB &
  &, 0.364273E-02_JPRB, 0.306533E-02_JPRB, 0.256604E-02_JPRB &
  &, 0.215130E-02_JPRB, 0.179070E-02_JPRB, 0.146971E-02_JPRB, 0.123040E-02_JPRB &
  &, 0.999586E-03_JPRB, 0.818715E-03_JPRB, 0.670801E-03_JPRB &
  &, 0.558291E-03_JPRB, 0.440643E-03_JPRB, 0.361715E-03_JPRB, 0.279258E-03_JPRB &
  &, 0.239001E-03_JPRB, 0.173576E-03_JPRB, 0.153051E-03_JPRB &
  &, 0.107287E-03_JPRB, 0.844223E-04_JPRB, 0.605984E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.368102E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  89, :) = (/ &
  &  0.867697E+00_JPRB, 0.835621E+00_JPRB, 0.803980E+00_JPRB, 0.772792E+00_JPRB &
  &, 0.742076E+00_JPRB, 0.711848E+00_JPRB, 0.682126E+00_JPRB &
  &, 0.652926E+00_JPRB, 0.624267E+00_JPRB, 0.596162E+00_JPRB, 0.568633E+00_JPRB &
  &, 0.541690E+00_JPRB, 0.515354E+00_JPRB, 0.489639E+00_JPRB &
  &, 0.464558E+00_JPRB, 0.440127E+00_JPRB, 0.416358E+00_JPRB, 0.393268E+00_JPRB &
  &, 0.370866E+00_JPRB, 0.349164E+00_JPRB, 0.328172E+00_JPRB &
  &, 0.307904E+00_JPRB, 0.288362E+00_JPRB, 0.269558E+00_JPRB, 0.251497E+00_JPRB &
  &, 0.234180E+00_JPRB, 0.217608E+00_JPRB, 0.201787E+00_JPRB &
  &, 0.186715E+00_JPRB, 0.172384E+00_JPRB, 0.158794E+00_JPRB, 0.145931E+00_JPRB &
  &, 0.133795E+00_JPRB, 0.122369E+00_JPRB, 0.111639E+00_JPRB &
  &, 0.101589E+00_JPRB, 0.922111E-01_JPRB, 0.834664E-01_JPRB, 0.753616E-01_JPRB &
  &, 0.678502E-01_JPRB, 0.609202E-01_JPRB, 0.545452E-01_JPRB &
  &, 0.486937E-01_JPRB, 0.433508E-01_JPRB, 0.384747E-01_JPRB, 0.340527E-01_JPRB &
  &, 0.300442E-01_JPRB, 0.264271E-01_JPRB, 0.231754E-01_JPRB &
  &, 0.202585E-01_JPRB, 0.176544E-01_JPRB, 0.153511E-01_JPRB, 0.132916E-01_JPRB &
  &, 0.114698E-01_JPRB, 0.987751E-02_JPRB, 0.847469E-02_JPRB &
  &, 0.724719E-02_JPRB, 0.617869E-02_JPRB, 0.525047E-02_JPRB, 0.444137E-02_JPRB &
  &, 0.376156E-02_JPRB, 0.315213E-02_JPRB, 0.265479E-02_JPRB &
  &, 0.220574E-02_JPRB, 0.184635E-02_JPRB, 0.152658E-02_JPRB, 0.126915E-02_JPRB &
  &, 0.103917E-02_JPRB, 0.859151E-03_JPRB, 0.691451E-03_JPRB &
  &, 0.579379E-03_JPRB, 0.462176E-03_JPRB, 0.383697E-03_JPRB, 0.301696E-03_JPRB &
  &, 0.239001E-03_JPRB, 0.196944E-03_JPRB, 0.153051E-03_JPRB &
  &, 0.107287E-03_JPRB, 0.844223E-04_JPRB, 0.605984E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.368102E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  90, :) = (/ &
  &  0.868265E+00_JPRB, 0.836312E+00_JPRB, 0.804788E+00_JPRB, 0.773711E+00_JPRB &
  &, 0.743097E+00_JPRB, 0.712965E+00_JPRB, 0.683332E+00_JPRB &
  &, 0.654214E+00_JPRB, 0.625629E+00_JPRB, 0.597593E+00_JPRB, 0.570124E+00_JPRB &
  &, 0.543236E+00_JPRB, 0.516946E+00_JPRB, 0.491271E+00_JPRB &
  &, 0.466224E+00_JPRB, 0.441820E+00_JPRB, 0.418073E+00_JPRB, 0.394996E+00_JPRB &
  &, 0.372603E+00_JPRB, 0.350902E+00_JPRB, 0.329910E+00_JPRB &
  &, 0.309632E+00_JPRB, 0.290075E+00_JPRB, 0.271252E+00_JPRB, 0.253163E+00_JPRB &
  &, 0.235817E+00_JPRB, 0.219213E+00_JPRB, 0.203355E+00_JPRB &
  &, 0.188236E+00_JPRB, 0.173862E+00_JPRB, 0.160223E+00_JPRB, 0.147311E+00_JPRB &
  &, 0.135120E+00_JPRB, 0.123638E+00_JPRB, 0.112854E+00_JPRB &
  &, 0.102743E+00_JPRB, 0.933079E-01_JPRB, 0.845126E-01_JPRB, 0.763341E-01_JPRB &
  &, 0.687753E-01_JPRB, 0.617843E-01_JPRB, 0.553447E-01_JPRB &
  &, 0.494467E-01_JPRB, 0.440432E-01_JPRB, 0.391146E-01_JPRB, 0.346370E-01_JPRB &
  &, 0.305818E-01_JPRB, 0.269154E-01_JPRB, 0.236243E-01_JPRB &
  &, 0.206658E-01_JPRB, 0.180312E-01_JPRB, 0.156819E-01_JPRB, 0.135880E-01_JPRB &
  &, 0.117443E-01_JPRB, 0.101142E-01_JPRB, 0.868668E-02_JPRB &
  &, 0.743316E-02_JPRB, 0.633727E-02_JPRB, 0.539649E-02_JPRB, 0.457415E-02_JPRB &
  &, 0.386341E-02_JPRB, 0.325629E-02_JPRB, 0.272579E-02_JPRB &
  &, 0.227833E-02_JPRB, 0.190199E-02_JPRB, 0.158345E-02_JPRB, 0.130789E-02_JPRB &
  &, 0.107875E-02_JPRB, 0.879369E-03_JPRB, 0.732751E-03_JPRB &
  &, 0.600467E-03_JPRB, 0.483708E-03_JPRB, 0.383697E-03_JPRB, 0.324134E-03_JPRB &
  &, 0.261901E-03_JPRB, 0.196944E-03_JPRB, 0.153051E-03_JPRB &
  &, 0.131608E-03_JPRB, 0.844223E-04_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.368102E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  91, :) = (/ &
  &  0.868828E+00_JPRB, 0.836998E+00_JPRB, 0.805590E+00_JPRB, 0.774623E+00_JPRB &
  &, 0.744111E+00_JPRB, 0.714075E+00_JPRB, 0.684529E+00_JPRB &
  &, 0.655493E+00_JPRB, 0.626982E+00_JPRB, 0.599014E+00_JPRB, 0.571606E+00_JPRB &
  &, 0.544772E+00_JPRB, 0.518529E+00_JPRB, 0.492894E+00_JPRB &
  &, 0.467881E+00_JPRB, 0.443503E+00_JPRB, 0.419778E+00_JPRB, 0.396715E+00_JPRB &
  &, 0.374331E+00_JPRB, 0.352634E+00_JPRB, 0.331635E+00_JPRB &
  &, 0.311349E+00_JPRB, 0.291781E+00_JPRB, 0.272935E+00_JPRB, 0.254826E+00_JPRB &
  &, 0.237450E+00_JPRB, 0.220811E+00_JPRB, 0.204916E+00_JPRB &
  &, 0.189757E+00_JPRB, 0.175341E+00_JPRB, 0.161652E+00_JPRB, 0.148692E+00_JPRB &
  &, 0.136449E+00_JPRB, 0.124913E+00_JPRB, 0.114070E+00_JPRB &
  &, 0.103905E+00_JPRB, 0.944046E-01_JPRB, 0.855491E-01_JPRB, 0.773166E-01_JPRB &
  &, 0.696901E-01_JPRB, 0.626484E-01_JPRB, 0.561549E-01_JPRB &
  &, 0.501998E-01_JPRB, 0.447357E-01_JPRB, 0.397662E-01_JPRB, 0.352332E-01_JPRB &
  &, 0.311316E-01_JPRB, 0.274162E-01_JPRB, 0.240861E-01_JPRB &
  &, 0.210863E-01_JPRB, 0.184081E-01_JPRB, 0.160127E-01_JPRB, 0.138985E-01_JPRB &
  &, 0.120189E-01_JPRB, 0.103509E-01_JPRB, 0.889868E-02_JPRB &
  &, 0.761912E-02_JPRB, 0.651170E-02_JPRB, 0.554251E-02_JPRB, 0.470692E-02_JPRB &
  &, 0.398224E-02_JPRB, 0.334309E-02_JPRB, 0.281454E-02_JPRB &
  &, 0.235091E-02_JPRB, 0.197619E-02_JPRB, 0.164032E-02_JPRB, 0.136600E-02_JPRB &
  &, 0.111834E-02_JPRB, 0.919805E-03_JPRB, 0.753401E-03_JPRB &
  &, 0.621555E-03_JPRB, 0.505240E-03_JPRB, 0.405679E-03_JPRB, 0.324134E-03_JPRB &
  &, 0.261901E-03_JPRB, 0.220312E-03_JPRB, 0.176893E-03_JPRB &
  &, 0.131608E-03_JPRB, 0.109230E-03_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.368102E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART14

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART14',0,ZHOOK_HANDLE)

XCW(  92, :) = (/ &
  &  0.869385E+00_JPRB, 0.837680E+00_JPRB, 0.806387E+00_JPRB, 0.775527E+00_JPRB &
  &, 0.745118E+00_JPRB, 0.715176E+00_JPRB, 0.685718E+00_JPRB &
  &, 0.656762E+00_JPRB, 0.628326E+00_JPRB, 0.600425E+00_JPRB, 0.573077E+00_JPRB &
  &, 0.546297E+00_JPRB, 0.520102E+00_JPRB, 0.494507E+00_JPRB &
  &, 0.469528E+00_JPRB, 0.445178E+00_JPRB, 0.421474E+00_JPRB, 0.398426E+00_JPRB &
  &, 0.376050E+00_JPRB, 0.354357E+00_JPRB, 0.333357E+00_JPRB &
  &, 0.313060E+00_JPRB, 0.293480E+00_JPRB, 0.274615E+00_JPRB, 0.256481E+00_JPRB &
  &, 0.239076E+00_JPRB, 0.222406E+00_JPRB, 0.206473E+00_JPRB &
  &, 0.191278E+00_JPRB, 0.176815E+00_JPRB, 0.163081E+00_JPRB, 0.150069E+00_JPRB &
  &, 0.137774E+00_JPRB, 0.126182E+00_JPRB, 0.115286E+00_JPRB &
  &, 0.105059E+00_JPRB, 0.955013E-01_JPRB, 0.865954E-01_JPRB, 0.783091E-01_JPRB &
  &, 0.706152E-01_JPRB, 0.635125E-01_JPRB, 0.569652E-01_JPRB &
  &, 0.509529E-01_JPRB, 0.454395E-01_JPRB, 0.404061E-01_JPRB, 0.358294E-01_JPRB &
  &, 0.316815E-01_JPRB, 0.279170E-01_JPRB, 0.245351E-01_JPRB &
  &, 0.215068E-01_JPRB, 0.187849E-01_JPRB, 0.163573E-01_JPRB, 0.141949E-01_JPRB &
  &, 0.122935E-01_JPRB, 0.106024E-01_JPRB, 0.911067E-02_JPRB &
  &, 0.782059E-02_JPRB, 0.668614E-02_JPRB, 0.568853E-02_JPRB, 0.483970E-02_JPRB &
  &, 0.408409E-02_JPRB, 0.344725E-02_JPRB, 0.290329E-02_JPRB &
  &, 0.244165E-02_JPRB, 0.203184E-02_JPRB, 0.169719E-02_JPRB, 0.140475E-02_JPRB &
  &, 0.115792E-02_JPRB, 0.960241E-03_JPRB, 0.794701E-03_JPRB &
  &, 0.642643E-03_JPRB, 0.526772E-03_JPRB, 0.427662E-03_JPRB, 0.346572E-03_JPRB &
  &, 0.284801E-03_JPRB, 0.220312E-03_JPRB, 0.176893E-03_JPRB &
  &, 0.131608E-03_JPRB, 0.109230E-03_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.363005E-04_JPRB, 0.368102E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  93, :) = (/ &
  &  0.869941E+00_JPRB, 0.838355E+00_JPRB, 0.807177E+00_JPRB, 0.776426E+00_JPRB &
  &, 0.746117E+00_JPRB, 0.716269E+00_JPRB, 0.686899E+00_JPRB &
  &, 0.658024E+00_JPRB, 0.629661E+00_JPRB, 0.601828E+00_JPRB, 0.574539E+00_JPRB &
  &, 0.547813E+00_JPRB, 0.521664E+00_JPRB, 0.496110E+00_JPRB &
  &, 0.471165E+00_JPRB, 0.446843E+00_JPRB, 0.423161E+00_JPRB, 0.400128E+00_JPRB &
  &, 0.377761E+00_JPRB, 0.356070E+00_JPRB, 0.335069E+00_JPRB &
  &, 0.314767E+00_JPRB, 0.295169E+00_JPRB, 0.276291E+00_JPRB, 0.258130E+00_JPRB &
  &, 0.240698E+00_JPRB, 0.223997E+00_JPRB, 0.208030E+00_JPRB &
  &, 0.192792E+00_JPRB, 0.178286E+00_JPRB, 0.164506E+00_JPRB, 0.151445E+00_JPRB &
  &, 0.139099E+00_JPRB, 0.127452E+00_JPRB, 0.116501E+00_JPRB &
  &, 0.106222E+00_JPRB, 0.966076E-01_JPRB, 0.876416E-01_JPRB, 0.792916E-01_JPRB &
  &, 0.715505E-01_JPRB, 0.643872E-01_JPRB, 0.577862E-01_JPRB &
  &, 0.517059E-01_JPRB, 0.461433E-01_JPRB, 0.410576E-01_JPRB, 0.364375E-01_JPRB &
  &, 0.322313E-01_JPRB, 0.284303E-01_JPRB, 0.249968E-01_JPRB &
  &, 0.219141E-01_JPRB, 0.191618E-01_JPRB, 0.167019E-01_JPRB, 0.145055E-01_JPRB &
  &, 0.125680E-01_JPRB, 0.108539E-01_JPRB, 0.933781E-02_JPRB &
  &, 0.800656E-02_JPRB, 0.686057E-02_JPRB, 0.585077E-02_JPRB, 0.497247E-02_JPRB &
  &, 0.420292E-02_JPRB, 0.355141E-02_JPRB, 0.299204E-02_JPRB &
  &, 0.251423E-02_JPRB, 0.210603E-02_JPRB, 0.175407E-02_JPRB, 0.144349E-02_JPRB &
  &, 0.119750E-02_JPRB, 0.100068E-02_JPRB, 0.815351E-03_JPRB &
  &, 0.663732E-03_JPRB, 0.548304E-03_JPRB, 0.449644E-03_JPRB, 0.346572E-03_JPRB &
  &, 0.284801E-03_JPRB, 0.220312E-03_JPRB, 0.176893E-03_JPRB &
  &, 0.155930E-03_JPRB, 0.109230E-03_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  94, :) = (/ &
  &  0.870491E+00_JPRB, 0.839026E+00_JPRB, 0.807962E+00_JPRB, 0.777318E+00_JPRB &
  &, 0.747109E+00_JPRB, 0.717355E+00_JPRB, 0.688072E+00_JPRB &
  &, 0.659277E+00_JPRB, 0.630988E+00_JPRB, 0.603221E+00_JPRB, 0.575993E+00_JPRB &
  &, 0.549320E+00_JPRB, 0.523219E+00_JPRB, 0.497705E+00_JPRB &
  &, 0.472793E+00_JPRB, 0.448500E+00_JPRB, 0.424838E+00_JPRB, 0.401822E+00_JPRB &
  &, 0.379465E+00_JPRB, 0.357777E+00_JPRB, 0.336775E+00_JPRB &
  &, 0.316465E+00_JPRB, 0.296854E+00_JPRB, 0.277957E+00_JPRB, 0.259775E+00_JPRB &
  &, 0.242317E+00_JPRB, 0.225583E+00_JPRB, 0.209579E+00_JPRB &
  &, 0.194305E+00_JPRB, 0.179752E+00_JPRB, 0.165927E+00_JPRB, 0.152818E+00_JPRB &
  &, 0.140419E+00_JPRB, 0.128722E+00_JPRB, 0.117717E+00_JPRB &
  &, 0.107384E+00_JPRB, 0.977138E-01_JPRB, 0.886781E-01_JPRB, 0.802741E-01_JPRB &
  &, 0.724756E-01_JPRB, 0.652619E-01_JPRB, 0.585965E-01_JPRB &
  &, 0.524701E-01_JPRB, 0.468584E-01_JPRB, 0.417208E-01_JPRB, 0.370337E-01_JPRB &
  &, 0.327812E-01_JPRB, 0.289436E-01_JPRB, 0.254714E-01_JPRB &
  &, 0.223477E-01_JPRB, 0.195521E-01_JPRB, 0.170465E-01_JPRB, 0.148160E-01_JPRB &
  &, 0.128426E-01_JPRB, 0.111054E-01_JPRB, 0.956495E-02_JPRB &
  &, 0.820802E-02_JPRB, 0.703501E-02_JPRB, 0.599679E-02_JPRB, 0.510525E-02_JPRB &
  &, 0.432175E-02_JPRB, 0.365557E-02_JPRB, 0.308079E-02_JPRB &
  &, 0.258682E-02_JPRB, 0.216168E-02_JPRB, 0.181094E-02_JPRB, 0.150161E-02_JPRB &
  &, 0.123709E-02_JPRB, 0.102089E-02_JPRB, 0.836001E-03_JPRB &
  &, 0.684820E-03_JPRB, 0.569836E-03_JPRB, 0.449644E-03_JPRB, 0.369011E-03_JPRB &
  &, 0.307701E-03_JPRB, 0.243680E-03_JPRB, 0.200735E-03_JPRB &
  &, 0.155930E-03_JPRB, 0.109230E-03_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  95, :) = (/ &
  &  0.871035E+00_JPRB, 0.839691E+00_JPRB, 0.808741E+00_JPRB, 0.778203E+00_JPRB &
  &, 0.748095E+00_JPRB, 0.718433E+00_JPRB, 0.689237E+00_JPRB &
  &, 0.660521E+00_JPRB, 0.632305E+00_JPRB, 0.604605E+00_JPRB, 0.577437E+00_JPRB &
  &, 0.550817E+00_JPRB, 0.524763E+00_JPRB, 0.499289E+00_JPRB &
  &, 0.474413E+00_JPRB, 0.450147E+00_JPRB, 0.426507E+00_JPRB, 0.403508E+00_JPRB &
  &, 0.381160E+00_JPRB, 0.359477E+00_JPRB, 0.338474E+00_JPRB &
  &, 0.318156E+00_JPRB, 0.298533E+00_JPRB, 0.279619E+00_JPRB, 0.261416E+00_JPRB &
  &, 0.243917E+00_JPRB, 0.227167E+00_JPRB, 0.211125E+00_JPRB &
  &, 0.195810E+00_JPRB, 0.181219E+00_JPRB, 0.167348E+00_JPRB, 0.154194E+00_JPRB &
  &, 0.141744E+00_JPRB, 0.129996E+00_JPRB, 0.118932E+00_JPRB &
  &, 0.108547E+00_JPRB, 0.988106E-01_JPRB, 0.897341E-01_JPRB, 0.812666E-01_JPRB &
  &, 0.734110E-01_JPRB, 0.661365E-01_JPRB, 0.594175E-01_JPRB &
  &, 0.532342E-01_JPRB, 0.475622E-01_JPRB, 0.423724E-01_JPRB, 0.376418E-01_JPRB &
  &, 0.333433E-01_JPRB, 0.294569E-01_JPRB, 0.259332E-01_JPRB &
  &, 0.227682E-01_JPRB, 0.199289E-01_JPRB, 0.173911E-01_JPRB, 0.151406E-01_JPRB &
  &, 0.131316E-01_JPRB, 0.113569E-01_JPRB, 0.979209E-02_JPRB &
  &, 0.840948E-02_JPRB, 0.720944E-02_JPRB, 0.615904E-02_JPRB, 0.523802E-02_JPRB &
  &, 0.444058E-02_JPRB, 0.375973E-02_JPRB, 0.316954E-02_JPRB &
  &, 0.265941E-02_JPRB, 0.223587E-02_JPRB, 0.186781E-02_JPRB, 0.155972E-02_JPRB &
  &, 0.129646E-02_JPRB, 0.106133E-02_JPRB, 0.877301E-03_JPRB &
  &, 0.726996E-03_JPRB, 0.591369E-03_JPRB, 0.471626E-03_JPRB, 0.391449E-03_JPRB &
  &, 0.307701E-03_JPRB, 0.243680E-03_JPRB, 0.200735E-03_JPRB &
  &, 0.155930E-03_JPRB, 0.134037E-03_JPRB, 0.858975E-04_JPRB, 0.615938E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  96, :) = (/ &
  &  0.871578E+00_JPRB, 0.840352E+00_JPRB, 0.809514E+00_JPRB, 0.779082E+00_JPRB &
  &, 0.749073E+00_JPRB, 0.719504E+00_JPRB, 0.690394E+00_JPRB &
  &, 0.661758E+00_JPRB, 0.633615E+00_JPRB, 0.605981E+00_JPRB, 0.578873E+00_JPRB &
  &, 0.552306E+00_JPRB, 0.526300E+00_JPRB, 0.500867E+00_JPRB &
  &, 0.476024E+00_JPRB, 0.451786E+00_JPRB, 0.428169E+00_JPRB, 0.405184E+00_JPRB &
  &, 0.382848E+00_JPRB, 0.361168E+00_JPRB, 0.340163E+00_JPRB &
  &, 0.319840E+00_JPRB, 0.300205E+00_JPRB, 0.281275E+00_JPRB, 0.263050E+00_JPRB &
  &, 0.245540E+00_JPRB, 0.228746E+00_JPRB, 0.212671E+00_JPRB &
  &, 0.197316E+00_JPRB, 0.182685E+00_JPRB, 0.168769E+00_JPRB, 0.155562E+00_JPRB &
  &, 0.143065E+00_JPRB, 0.131266E+00_JPRB, 0.120148E+00_JPRB &
  &, 0.109700E+00_JPRB, 0.999168E-01_JPRB, 0.907804E-01_JPRB, 0.822591E-01_JPRB &
  &, 0.743464E-01_JPRB, 0.670112E-01_JPRB, 0.602386E-01_JPRB &
  &, 0.540094E-01_JPRB, 0.482774E-01_JPRB, 0.430356E-01_JPRB, 0.382619E-01_JPRB &
  &, 0.339053E-01_JPRB, 0.299702E-01_JPRB, 0.264078E-01_JPRB &
  &, 0.232018E-01_JPRB, 0.203192E-01_JPRB, 0.177494E-01_JPRB, 0.154511E-01_JPRB &
  &, 0.134207E-01_JPRB, 0.116084E-01_JPRB, 0.100192E-01_JPRB &
  &, 0.861095E-02_JPRB, 0.738388E-02_JPRB, 0.630506E-02_JPRB, 0.537080E-02_JPRB &
  &, 0.457638E-02_JPRB, 0.386389E-02_JPRB, 0.325830E-02_JPRB &
  &, 0.275014E-02_JPRB, 0.231007E-02_JPRB, 0.192468E-02_JPRB, 0.159846E-02_JPRB &
  &, 0.133604E-02_JPRB, 0.110177E-02_JPRB, 0.897951E-03_JPRB &
  &, 0.748084E-03_JPRB, 0.612901E-03_JPRB, 0.493608E-03_JPRB, 0.413887E-03_JPRB &
  &, 0.330601E-03_JPRB, 0.267048E-03_JPRB, 0.200735E-03_JPRB &
  &, 0.155930E-03_JPRB, 0.134037E-03_JPRB, 0.111197E-03_JPRB, 0.873906E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  97, :) = (/ &
  &  0.872115E+00_JPRB, 0.841008E+00_JPRB, 0.810282E+00_JPRB, 0.779955E+00_JPRB &
  &, 0.750045E+00_JPRB, 0.720568E+00_JPRB, 0.691543E+00_JPRB &
  &, 0.662986E+00_JPRB, 0.634916E+00_JPRB, 0.607348E+00_JPRB, 0.580299E+00_JPRB &
  &, 0.553787E+00_JPRB, 0.527826E+00_JPRB, 0.502434E+00_JPRB &
  &, 0.477626E+00_JPRB, 0.453417E+00_JPRB, 0.429821E+00_JPRB, 0.406854E+00_JPRB &
  &, 0.384528E+00_JPRB, 0.362853E+00_JPRB, 0.341846E+00_JPRB &
  &, 0.321518E+00_JPRB, 0.301874E+00_JPRB, 0.282927E+00_JPRB, 0.264680E+00_JPRB &
  &, 0.247144E+00_JPRB, 0.230318E+00_JPRB, 0.214212E+00_JPRB &
  &, 0.198821E+00_JPRB, 0.184144E+00_JPRB, 0.170186E+00_JPRB, 0.156934E+00_JPRB &
  &, 0.144389E+00_JPRB, 0.132535E+00_JPRB, 0.121368E+00_JPRB &
  &, 0.110863E+00_JPRB, 0.101023E+00_JPRB, 0.918267E-01_JPRB, 0.832516E-01_JPRB &
  &, 0.752817E-01_JPRB, 0.678964E-01_JPRB, 0.610704E-01_JPRB &
  &, 0.547736E-01_JPRB, 0.489926E-01_JPRB, 0.436987E-01_JPRB, 0.388700E-01_JPRB &
  &, 0.344796E-01_JPRB, 0.304836E-01_JPRB, 0.268824E-01_JPRB &
  &, 0.236354E-01_JPRB, 0.207230E-01_JPRB, 0.181078E-01_JPRB, 0.157758E-01_JPRB &
  &, 0.137097E-01_JPRB, 0.118747E-01_JPRB, 0.102464E-01_JPRB &
  &, 0.882791E-02_JPRB, 0.757417E-02_JPRB, 0.646730E-02_JPRB, 0.552017E-02_JPRB &
  &, 0.469521E-02_JPRB, 0.398540E-02_JPRB, 0.336480E-02_JPRB &
  &, 0.282273E-02_JPRB, 0.236572E-02_JPRB, 0.198155E-02_JPRB, 0.165658E-02_JPRB &
  &, 0.137563E-02_JPRB, 0.114220E-02_JPRB, 0.939251E-03_JPRB &
  &, 0.769172E-03_JPRB, 0.634433E-03_JPRB, 0.515590E-03_JPRB, 0.413887E-03_JPRB &
  &, 0.330601E-03_JPRB, 0.267048E-03_JPRB, 0.224577E-03_JPRB &
  &, 0.180252E-03_JPRB, 0.134037E-03_JPRB, 0.111197E-03_JPRB, 0.873906E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW(  98, :) = (/ &
  &  0.872650E+00_JPRB, 0.841660E+00_JPRB, 0.811045E+00_JPRB, 0.780823E+00_JPRB &
  &, 0.751010E+00_JPRB, 0.721625E+00_JPRB, 0.692685E+00_JPRB &
  &, 0.664207E+00_JPRB, 0.636209E+00_JPRB, 0.608707E+00_JPRB, 0.581718E+00_JPRB &
  &, 0.555258E+00_JPRB, 0.529344E+00_JPRB, 0.503993E+00_JPRB &
  &, 0.479220E+00_JPRB, 0.455040E+00_JPRB, 0.431466E+00_JPRB, 0.408516E+00_JPRB &
  &, 0.386197E+00_JPRB, 0.364531E+00_JPRB, 0.343526E+00_JPRB &
  &, 0.323189E+00_JPRB, 0.303536E+00_JPRB, 0.284568E+00_JPRB, 0.266304E+00_JPRB &
  &, 0.248741E+00_JPRB, 0.231887E+00_JPRB, 0.215746E+00_JPRB &
  &, 0.200318E+00_JPRB, 0.185606E+00_JPRB, 0.171603E+00_JPRB, 0.158303E+00_JPRB &
  &, 0.145710E+00_JPRB, 0.133805E+00_JPRB, 0.122584E+00_JPRB &
  &, 0.112026E+00_JPRB, 0.102139E+00_JPRB, 0.928827E-01_JPRB, 0.842542E-01_JPRB &
  &, 0.762274E-01_JPRB, 0.687816E-01_JPRB, 0.618915E-01_JPRB &
  &, 0.555488E-01_JPRB, 0.497191E-01_JPRB, 0.443736E-01_JPRB, 0.394900E-01_JPRB &
  &, 0.350417E-01_JPRB, 0.310094E-01_JPRB, 0.273698E-01_JPRB &
  &, 0.240690E-01_JPRB, 0.211133E-01_JPRB, 0.184662E-01_JPRB, 0.161004E-01_JPRB &
  &, 0.139987E-01_JPRB, 0.121262E-01_JPRB, 0.104886E-01_JPRB &
  &, 0.902937E-02_JPRB, 0.774861E-02_JPRB, 0.664577E-02_JPRB, 0.566954E-02_JPRB &
  &, 0.481404E-02_JPRB, 0.408956E-02_JPRB, 0.345355E-02_JPRB &
  &, 0.291346E-02_JPRB, 0.243991E-02_JPRB, 0.205738E-02_JPRB, 0.171469E-02_JPRB &
  &, 0.141521E-02_JPRB, 0.118264E-02_JPRB, 0.980551E-03_JPRB &
  &, 0.811348E-03_JPRB, 0.655965E-03_JPRB, 0.537572E-03_JPRB, 0.436325E-03_JPRB &
  &, 0.353501E-03_JPRB, 0.290416E-03_JPRB, 0.224577E-03_JPRB &
  &, 0.180252E-03_JPRB, 0.134037E-03_JPRB, 0.111197E-03_JPRB, 0.873906E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.368102E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART15

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART15',0,ZHOOK_HANDLE)

XCW(  99, :) = (/ &
  &  0.873179E+00_JPRB, 0.842306E+00_JPRB, 0.811802E+00_JPRB, 0.781684E+00_JPRB &
  &, 0.751968E+00_JPRB, 0.722675E+00_JPRB, 0.693820E+00_JPRB &
  &, 0.665420E+00_JPRB, 0.637494E+00_JPRB, 0.610057E+00_JPRB, 0.583128E+00_JPRB &
  &, 0.556721E+00_JPRB, 0.530855E+00_JPRB, 0.505544E+00_JPRB &
  &, 0.480805E+00_JPRB, 0.456653E+00_JPRB, 0.433103E+00_JPRB, 0.410169E+00_JPRB &
  &, 0.387865E+00_JPRB, 0.366203E+00_JPRB, 0.345196E+00_JPRB &
  &, 0.324853E+00_JPRB, 0.305187E+00_JPRB, 0.286210E+00_JPRB, 0.267924E+00_JPRB &
  &, 0.250337E+00_JPRB, 0.233455E+00_JPRB, 0.217281E+00_JPRB &
  &, 0.201816E+00_JPRB, 0.187061E+00_JPRB, 0.173015E+00_JPRB, 0.159671E+00_JPRB &
  &, 0.147026E+00_JPRB, 0.135075E+00_JPRB, 0.123799E+00_JPRB &
  &, 0.113197E+00_JPRB, 0.103245E+00_JPRB, 0.939387E-01_JPRB, 0.852467E-01_JPRB &
  &, 0.771628E-01_JPRB, 0.696668E-01_JPRB, 0.627233E-01_JPRB &
  &, 0.563240E-01_JPRB, 0.504456E-01_JPRB, 0.450484E-01_JPRB, 0.401101E-01_JPRB &
  &, 0.356160E-01_JPRB, 0.315477E-01_JPRB, 0.278444E-01_JPRB &
  &, 0.245158E-01_JPRB, 0.215170E-01_JPRB, 0.188383E-01_JPRB, 0.164250E-01_JPRB &
  &, 0.142877E-01_JPRB, 0.123925E-01_JPRB, 0.107158E-01_JPRB &
  &, 0.924633E-02_JPRB, 0.793890E-02_JPRB, 0.680801E-02_JPRB, 0.581892E-02_JPRB &
  &, 0.494984E-02_JPRB, 0.419372E-02_JPRB, 0.356005E-02_JPRB &
  &, 0.300419E-02_JPRB, 0.251411E-02_JPRB, 0.211425E-02_JPRB, 0.177281E-02_JPRB &
  &, 0.147459E-02_JPRB, 0.122307E-02_JPRB, 0.100120E-02_JPRB &
  &, 0.832436E-03_JPRB, 0.677497E-03_JPRB, 0.559555E-03_JPRB, 0.458763E-03_JPRB &
  &, 0.376402E-03_JPRB, 0.290416E-03_JPRB, 0.248418E-03_JPRB &
  &, 0.180252E-03_JPRB, 0.158845E-03_JPRB, 0.111197E-03_JPRB, 0.873906E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.636203E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 100, :) = (/ &
  &  0.873706E+00_JPRB, 0.842949E+00_JPRB, 0.812554E+00_JPRB, 0.782539E+00_JPRB &
  &, 0.752921E+00_JPRB, 0.723718E+00_JPRB, 0.694947E+00_JPRB &
  &, 0.666626E+00_JPRB, 0.638771E+00_JPRB, 0.611400E+00_JPRB, 0.584530E+00_JPRB &
  &, 0.558176E+00_JPRB, 0.532358E+00_JPRB, 0.507087E+00_JPRB &
  &, 0.482383E+00_JPRB, 0.458260E+00_JPRB, 0.434733E+00_JPRB, 0.411814E+00_JPRB &
  &, 0.389522E+00_JPRB, 0.367865E+00_JPRB, 0.346859E+00_JPRB &
  &, 0.326511E+00_JPRB, 0.306839E+00_JPRB, 0.287844E+00_JPRB, 0.269537E+00_JPRB &
  &, 0.251927E+00_JPRB, 0.235016E+00_JPRB, 0.218811E+00_JPRB &
  &, 0.203310E+00_JPRB, 0.188515E+00_JPRB, 0.174428E+00_JPRB, 0.161039E+00_JPRB &
  &, 0.148347E+00_JPRB, 0.136345E+00_JPRB, 0.125020E+00_JPRB &
  &, 0.114360E+00_JPRB, 0.104351E+00_JPRB, 0.949948E-01_JPRB, 0.862493E-01_JPRB &
  &, 0.781084E-01_JPRB, 0.705520E-01_JPRB, 0.635660E-01_JPRB &
  &, 0.571103E-01_JPRB, 0.511721E-01_JPRB, 0.457232E-01_JPRB, 0.407420E-01_JPRB &
  &, 0.362025E-01_JPRB, 0.320736E-01_JPRB, 0.283318E-01_JPRB &
  &, 0.249625E-01_JPRB, 0.219208E-01_JPRB, 0.191967E-01_JPRB, 0.167638E-01_JPRB &
  &, 0.145912E-01_JPRB, 0.126735E-01_JPRB, 0.109581E-01_JPRB &
  &, 0.944779E-02_JPRB, 0.812920E-02_JPRB, 0.697026E-02_JPRB, 0.596829E-02_JPRB &
  &, 0.508564E-02_JPRB, 0.431524E-02_JPRB, 0.364880E-02_JPRB &
  &, 0.307678E-02_JPRB, 0.258831E-02_JPRB, 0.217113E-02_JPRB, 0.181155E-02_JPRB &
  &, 0.151417E-02_JPRB, 0.126351E-02_JPRB, 0.104250E-02_JPRB &
  &, 0.853525E-03_JPRB, 0.699029E-03_JPRB, 0.581537E-03_JPRB, 0.481201E-03_JPRB &
  &, 0.376402E-03_JPRB, 0.313784E-03_JPRB, 0.248418E-03_JPRB &
  &, 0.204573E-03_JPRB, 0.158845E-03_JPRB, 0.136496E-03_JPRB, 0.873906E-04_JPRB &
  &, 0.626011E-04_JPRB, 0.636203E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 101, :) = (/ &
  &  0.874229E+00_JPRB, 0.843587E+00_JPRB, 0.813300E+00_JPRB, 0.783389E+00_JPRB &
  &, 0.753867E+00_JPRB, 0.724754E+00_JPRB, 0.696067E+00_JPRB &
  &, 0.667824E+00_JPRB, 0.640040E+00_JPRB, 0.612735E+00_JPRB, 0.585924E+00_JPRB &
  &, 0.559624E+00_JPRB, 0.533851E+00_JPRB, 0.508622E+00_JPRB &
  &, 0.483953E+00_JPRB, 0.459859E+00_JPRB, 0.436354E+00_JPRB, 0.413453E+00_JPRB &
  &, 0.391172E+00_JPRB, 0.369521E+00_JPRB, 0.348516E+00_JPRB &
  &, 0.328165E+00_JPRB, 0.308480E+00_JPRB, 0.289472E+00_JPRB, 0.271146E+00_JPRB &
  &, 0.253513E+00_JPRB, 0.236577E+00_JPRB, 0.220337E+00_JPRB &
  &, 0.204803E+00_JPRB, 0.189970E+00_JPRB, 0.175837E+00_JPRB, 0.162407E+00_JPRB &
  &, 0.149667E+00_JPRB, 0.137614E+00_JPRB, 0.126235E+00_JPRB &
  &, 0.115523E+00_JPRB, 0.105467E+00_JPRB, 0.960508E-01_JPRB, 0.872518E-01_JPRB &
  &, 0.790541E-01_JPRB, 0.714477E-01_JPRB, 0.643979E-01_JPRB &
  &, 0.578966E-01_JPRB, 0.518986E-01_JPRB, 0.463980E-01_JPRB, 0.413740E-01_JPRB &
  &, 0.367768E-01_JPRB, 0.326119E-01_JPRB, 0.288321E-01_JPRB &
  &, 0.254093E-01_JPRB, 0.223380E-01_JPRB, 0.195689E-01_JPRB, 0.171025E-01_JPRB &
  &, 0.148947E-01_JPRB, 0.129398E-01_JPRB, 0.112003E-01_JPRB &
  &, 0.966475E-02_JPRB, 0.831949E-02_JPRB, 0.714873E-02_JPRB, 0.611766E-02_JPRB &
  &, 0.520447E-02_JPRB, 0.443676E-02_JPRB, 0.375530E-02_JPRB &
  &, 0.316751E-02_JPRB, 0.268105E-02_JPRB, 0.224696E-02_JPRB, 0.186966E-02_JPRB &
  &, 0.157355E-02_JPRB, 0.130394E-02_JPRB, 0.108380E-02_JPRB &
  &, 0.895701E-03_JPRB, 0.742094E-03_JPRB, 0.603519E-03_JPRB, 0.481201E-03_JPRB &
  &, 0.399302E-03_JPRB, 0.313784E-03_JPRB, 0.248418E-03_JPRB &
  &, 0.204573E-03_JPRB, 0.158845E-03_JPRB, 0.136496E-03_JPRB, 0.113188E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.636203E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 102, :) = (/ &
  &  0.874749E+00_JPRB, 0.844221E+00_JPRB, 0.814043E+00_JPRB, 0.784233E+00_JPRB &
  &, 0.754807E+00_JPRB, 0.725784E+00_JPRB, 0.697181E+00_JPRB &
  &, 0.669015E+00_JPRB, 0.641303E+00_JPRB, 0.614062E+00_JPRB, 0.587310E+00_JPRB &
  &, 0.561063E+00_JPRB, 0.535336E+00_JPRB, 0.510149E+00_JPRB &
  &, 0.485514E+00_JPRB, 0.461448E+00_JPRB, 0.437968E+00_JPRB, 0.415085E+00_JPRB &
  &, 0.392815E+00_JPRB, 0.371171E+00_JPRB, 0.350166E+00_JPRB &
  &, 0.329813E+00_JPRB, 0.310119E+00_JPRB, 0.291096E+00_JPRB, 0.272752E+00_JPRB &
  &, 0.255095E+00_JPRB, 0.238130E+00_JPRB, 0.221860E+00_JPRB &
  &, 0.206293E+00_JPRB, 0.191420E+00_JPRB, 0.177249E+00_JPRB, 0.163771E+00_JPRB &
  &, 0.150983E+00_JPRB, 0.138884E+00_JPRB, 0.127455E+00_JPRB &
  &, 0.116695E+00_JPRB, 0.106583E+00_JPRB, 0.971069E-01_JPRB, 0.882544E-01_JPRB &
  &, 0.800100E-01_JPRB, 0.723435E-01_JPRB, 0.652405E-01_JPRB &
  &, 0.586829E-01_JPRB, 0.526364E-01_JPRB, 0.470845E-01_JPRB, 0.420060E-01_JPRB &
  &, 0.373633E-01_JPRB, 0.331503E-01_JPRB, 0.293195E-01_JPRB &
  &, 0.258561E-01_JPRB, 0.227418E-01_JPRB, 0.199410E-01_JPRB, 0.174412E-01_JPRB &
  &, 0.151981E-01_JPRB, 0.132061E-01_JPRB, 0.114426E-01_JPRB &
  &, 0.989721E-02_JPRB, 0.852564E-02_JPRB, 0.731097E-02_JPRB, 0.626703E-02_JPRB &
  &, 0.534027E-02_JPRB, 0.454092E-02_JPRB, 0.386181E-02_JPRB &
  &, 0.325825E-02_JPRB, 0.275525E-02_JPRB, 0.230383E-02_JPRB, 0.192778E-02_JPRB &
  &, 0.161313E-02_JPRB, 0.134438E-02_JPRB, 0.112510E-02_JPRB &
  &, 0.916789E-03_JPRB, 0.763626E-03_JPRB, 0.625501E-03_JPRB, 0.503640E-03_JPRB &
  &, 0.422202E-03_JPRB, 0.337152E-03_JPRB, 0.272260E-03_JPRB &
  &, 0.204573E-03_JPRB, 0.183652E-03_JPRB, 0.136496E-03_JPRB, 0.113188E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.636203E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 103, :) = (/ &
  &  0.875264E+00_JPRB, 0.844851E+00_JPRB, 0.814780E+00_JPRB, 0.785072E+00_JPRB &
  &, 0.755741E+00_JPRB, 0.726808E+00_JPRB, 0.698287E+00_JPRB &
  &, 0.670198E+00_JPRB, 0.642557E+00_JPRB, 0.615382E+00_JPRB, 0.588689E+00_JPRB &
  &, 0.562494E+00_JPRB, 0.536815E+00_JPRB, 0.511668E+00_JPRB &
  &, 0.487068E+00_JPRB, 0.463032E+00_JPRB, 0.439574E+00_JPRB, 0.416709E+00_JPRB &
  &, 0.394451E+00_JPRB, 0.372814E+00_JPRB, 0.351810E+00_JPRB &
  &, 0.331454E+00_JPRB, 0.311750E+00_JPRB, 0.292713E+00_JPRB, 0.274354E+00_JPRB &
  &, 0.256674E+00_JPRB, 0.239684E+00_JPRB, 0.223383E+00_JPRB &
  &, 0.207779E+00_JPRB, 0.192867E+00_JPRB, 0.178654E+00_JPRB, 0.165135E+00_JPRB &
  &, 0.152304E+00_JPRB, 0.140154E+00_JPRB, 0.128676E+00_JPRB &
  &, 0.117857E+00_JPRB, 0.107699E+00_JPRB, 0.981629E-01_JPRB, 0.892569E-01_JPRB &
  &, 0.809556E-01_JPRB, 0.732392E-01_JPRB, 0.660832E-01_JPRB &
  &, 0.594692E-01_JPRB, 0.533743E-01_JPRB, 0.477709E-01_JPRB, 0.426379E-01_JPRB &
  &, 0.379498E-01_JPRB, 0.336887E-01_JPRB, 0.298197E-01_JPRB &
  &, 0.263159E-01_JPRB, 0.231590E-01_JPRB, 0.203270E-01_JPRB, 0.177800E-01_JPRB &
  &, 0.155161E-01_JPRB, 0.134872E-01_JPRB, 0.117000E-01_JPRB &
  &, 0.101142E-01_JPRB, 0.871594E-02_JPRB, 0.748944E-02_JPRB, 0.641641E-02_JPRB &
  &, 0.547608E-02_JPRB, 0.466244E-02_JPRB, 0.396831E-02_JPRB &
  &, 0.334898E-02_JPRB, 0.282944E-02_JPRB, 0.237966E-02_JPRB, 0.198589E-02_JPRB &
  &, 0.167250E-02_JPRB, 0.138482E-02_JPRB, 0.114575E-02_JPRB &
  &, 0.958965E-03_JPRB, 0.785158E-03_JPRB, 0.647483E-03_JPRB, 0.526078E-03_JPRB &
  &, 0.422202E-03_JPRB, 0.337152E-03_JPRB, 0.272260E-03_JPRB &
  &, 0.228895E-03_JPRB, 0.183652E-03_JPRB, 0.136496E-03_JPRB, 0.113188E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.636203E-04_JPRB, 0.373257E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 104, :) = (/ &
  &  0.875776E+00_JPRB, 0.845476E+00_JPRB, 0.815512E+00_JPRB, 0.785905E+00_JPRB &
  &, 0.756670E+00_JPRB, 0.727825E+00_JPRB, 0.699387E+00_JPRB &
  &, 0.671374E+00_JPRB, 0.643805E+00_JPRB, 0.616694E+00_JPRB, 0.590060E+00_JPRB &
  &, 0.563918E+00_JPRB, 0.538284E+00_JPRB, 0.513179E+00_JPRB &
  &, 0.488615E+00_JPRB, 0.464607E+00_JPRB, 0.441173E+00_JPRB, 0.418326E+00_JPRB &
  &, 0.396082E+00_JPRB, 0.374451E+00_JPRB, 0.353451E+00_JPRB &
  &, 0.333089E+00_JPRB, 0.313378E+00_JPRB, 0.294327E+00_JPRB, 0.275949E+00_JPRB &
  &, 0.258249E+00_JPRB, 0.241230E+00_JPRB, 0.224901E+00_JPRB &
  &, 0.209261E+00_JPRB, 0.194313E+00_JPRB, 0.180062E+00_JPRB, 0.166499E+00_JPRB &
  &, 0.153620E+00_JPRB, 0.141419E+00_JPRB, 0.129896E+00_JPRB &
  &, 0.119029E+00_JPRB, 0.108805E+00_JPRB, 0.992287E-01_JPRB, 0.902695E-01_JPRB &
  &, 0.819116E-01_JPRB, 0.741349E-01_JPRB, 0.669258E-01_JPRB &
  &, 0.602555E-01_JPRB, 0.541122E-01_JPRB, 0.484574E-01_JPRB, 0.432818E-01_JPRB &
  &, 0.385485E-01_JPRB, 0.342395E-01_JPRB, 0.303200E-01_JPRB &
  &, 0.267758E-01_JPRB, 0.235762E-01_JPRB, 0.206991E-01_JPRB, 0.181329E-01_JPRB &
  &, 0.158195E-01_JPRB, 0.137683E-01_JPRB, 0.119575E-01_JPRB &
  &, 0.103466E-01_JPRB, 0.892209E-02_JPRB, 0.766791E-02_JPRB, 0.658237E-02_JPRB &
  &, 0.562886E-02_JPRB, 0.478396E-02_JPRB, 0.407481E-02_JPRB &
  &, 0.343971E-02_JPRB, 0.290364E-02_JPRB, 0.245549E-02_JPRB, 0.206338E-02_JPRB &
  &, 0.171209E-02_JPRB, 0.142525E-02_JPRB, 0.118705E-02_JPRB &
  &, 0.980053E-03_JPRB, 0.806690E-03_JPRB, 0.669466E-03_JPRB, 0.548516E-03_JPRB &
  &, 0.445102E-03_JPRB, 0.360520E-03_JPRB, 0.296102E-03_JPRB &
  &, 0.228895E-03_JPRB, 0.183652E-03_JPRB, 0.161795E-03_JPRB, 0.113188E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.636203E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 105, :) = (/ &
  &  0.876285E+00_JPRB, 0.846097E+00_JPRB, 0.816240E+00_JPRB, 0.786733E+00_JPRB &
  &, 0.757592E+00_JPRB, 0.728836E+00_JPRB, 0.700481E+00_JPRB &
  &, 0.672545E+00_JPRB, 0.645046E+00_JPRB, 0.617999E+00_JPRB, 0.591423E+00_JPRB &
  &, 0.565333E+00_JPRB, 0.539747E+00_JPRB, 0.514682E+00_JPRB &
  &, 0.490153E+00_JPRB, 0.466175E+00_JPRB, 0.442765E+00_JPRB, 0.419936E+00_JPRB &
  &, 0.397704E+00_JPRB, 0.376082E+00_JPRB, 0.355082E+00_JPRB &
  &, 0.334717E+00_JPRB, 0.314999E+00_JPRB, 0.295938E+00_JPRB, 0.277540E+00_JPRB &
  &, 0.259816E+00_JPRB, 0.242776E+00_JPRB, 0.226416E+00_JPRB &
  &, 0.210743E+00_JPRB, 0.195760E+00_JPRB, 0.181467E+00_JPRB, 0.167858E+00_JPRB &
  &, 0.154936E+00_JPRB, 0.142689E+00_JPRB, 0.131116E+00_JPRB &
  &, 0.120192E+00_JPRB, 0.109930E+00_JPRB, 0.100295E+00_JPRB, 0.912821E-01_JPRB &
  &, 0.828675E-01_JPRB, 0.750412E-01_JPRB, 0.677793E-01_JPRB &
  &, 0.610528E-01_JPRB, 0.548500E-01_JPRB, 0.491555E-01_JPRB, 0.439257E-01_JPRB &
  &, 0.391473E-01_JPRB, 0.347779E-01_JPRB, 0.308202E-01_JPRB &
  &, 0.272357E-01_JPRB, 0.240069E-01_JPRB, 0.210851E-01_JPRB, 0.184716E-01_JPRB &
  &, 0.161375E-01_JPRB, 0.140494E-01_JPRB, 0.121998E-01_JPRB &
  &, 0.105636E-01_JPRB, 0.912824E-02_JPRB, 0.784637E-02_JPRB, 0.673175E-02_JPRB &
  &, 0.576466E-02_JPRB, 0.492284E-02_JPRB, 0.418131E-02_JPRB &
  &, 0.354859E-02_JPRB, 0.299638E-02_JPRB, 0.253131E-02_JPRB, 0.212149E-02_JPRB &
  &, 0.177146E-02_JPRB, 0.148591E-02_JPRB, 0.122835E-02_JPRB &
  &, 0.102223E-02_JPRB, 0.849755E-03_JPRB, 0.691448E-03_JPRB, 0.570954E-03_JPRB &
  &, 0.468002E-03_JPRB, 0.383888E-03_JPRB, 0.296102E-03_JPRB &
  &, 0.253217E-03_JPRB, 0.208460E-03_JPRB, 0.161795E-03_JPRB, 0.113188E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.636203E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART16

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART16',0,ZHOOK_HANDLE)

XCW( 106, :) = (/ &
  &  0.876790E+00_JPRB, 0.846714E+00_JPRB, 0.816963E+00_JPRB, 0.787556E+00_JPRB &
  &, 0.758509E+00_JPRB, 0.729841E+00_JPRB, 0.701568E+00_JPRB &
  &, 0.673709E+00_JPRB, 0.646279E+00_JPRB, 0.619296E+00_JPRB, 0.592779E+00_JPRB &
  &, 0.566742E+00_JPRB, 0.541204E+00_JPRB, 0.516178E+00_JPRB &
  &, 0.491684E+00_JPRB, 0.467737E+00_JPRB, 0.444350E+00_JPRB, 0.421540E+00_JPRB &
  &, 0.399321E+00_JPRB, 0.377706E+00_JPRB, 0.356710E+00_JPRB &
  &, 0.336341E+00_JPRB, 0.316617E+00_JPRB, 0.297541E+00_JPRB, 0.279128E+00_JPRB &
  &, 0.261384E+00_JPRB, 0.244314E+00_JPRB, 0.227928E+00_JPRB &
  &, 0.212221E+00_JPRB, 0.197202E+00_JPRB, 0.182871E+00_JPRB, 0.169222E+00_JPRB &
  &, 0.156252E+00_JPRB, 0.143959E+00_JPRB, 0.132336E+00_JPRB &
  &, 0.121364E+00_JPRB, 0.111046E+00_JPRB, 0.101360E+00_JPRB, 0.922946E-01_JPRB &
  &, 0.838234E-01_JPRB, 0.759475E-01_JPRB, 0.686328E-01_JPRB &
  &, 0.618502E-01_JPRB, 0.555992E-01_JPRB, 0.498536E-01_JPRB, 0.445696E-01_JPRB &
  &, 0.397460E-01_JPRB, 0.353413E-01_JPRB, 0.313333E-01_JPRB &
  &, 0.277088E-01_JPRB, 0.244241E-01_JPRB, 0.214710E-01_JPRB, 0.188245E-01_JPRB &
  &, 0.164554E-01_JPRB, 0.143453E-01_JPRB, 0.124572E-01_JPRB &
  &, 0.107961E-01_JPRB, 0.933439E-02_JPRB, 0.804107E-02_JPRB, 0.689772E-02_JPRB &
  &, 0.590046E-02_JPRB, 0.504435E-02_JPRB, 0.428781E-02_JPRB &
  &, 0.363933E-02_JPRB, 0.307058E-02_JPRB, 0.258819E-02_JPRB, 0.217961E-02_JPRB &
  &, 0.183084E-02_JPRB, 0.152634E-02_JPRB, 0.126965E-02_JPRB &
  &, 0.106441E-02_JPRB, 0.871287E-03_JPRB, 0.713430E-03_JPRB, 0.593392E-03_JPRB &
  &, 0.490902E-03_JPRB, 0.383888E-03_JPRB, 0.319944E-03_JPRB &
  &, 0.253217E-03_JPRB, 0.208460E-03_JPRB, 0.161795E-03_JPRB, 0.138984E-03_JPRB &
  &, 0.889016E-04_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 107, :) = (/ &
  &  0.877294E+00_JPRB, 0.847327E+00_JPRB, 0.817681E+00_JPRB, 0.788374E+00_JPRB &
  &, 0.759421E+00_JPRB, 0.730840E+00_JPRB, 0.702649E+00_JPRB &
  &, 0.674865E+00_JPRB, 0.647505E+00_JPRB, 0.620587E+00_JPRB, 0.594128E+00_JPRB &
  &, 0.568144E+00_JPRB, 0.542651E+00_JPRB, 0.517667E+00_JPRB &
  &, 0.493209E+00_JPRB, 0.469291E+00_JPRB, 0.445928E+00_JPRB, 0.423137E+00_JPRB &
  &, 0.400931E+00_JPRB, 0.379324E+00_JPRB, 0.358328E+00_JPRB &
  &, 0.337959E+00_JPRB, 0.318228E+00_JPRB, 0.299141E+00_JPRB, 0.280713E+00_JPRB &
  &, 0.262948E+00_JPRB, 0.245853E+00_JPRB, 0.229435E+00_JPRB &
  &, 0.213699E+00_JPRB, 0.198645E+00_JPRB, 0.184272E+00_JPRB, 0.170582E+00_JPRB &
  &, 0.157569E+00_JPRB, 0.145228E+00_JPRB, 0.133556E+00_JPRB &
  &, 0.122536E+00_JPRB, 0.112162E+00_JPRB, 0.102426E+00_JPRB, 0.933072E-01_JPRB &
  &, 0.847896E-01_JPRB, 0.768538E-01_JPRB, 0.694862E-01_JPRB &
  &, 0.626586E-01_JPRB, 0.563485E-01_JPRB, 0.505516E-01_JPRB, 0.452254E-01_JPRB &
  &, 0.403447E-01_JPRB, 0.358922E-01_JPRB, 0.318464E-01_JPRB &
  &, 0.281687E-01_JPRB, 0.248548E-01_JPRB, 0.218707E-01_JPRB, 0.191773E-01_JPRB &
  &, 0.167733E-01_JPRB, 0.146263E-01_JPRB, 0.127297E-01_JPRB &
  &, 0.110285E-01_JPRB, 0.954054E-02_JPRB, 0.821953E-02_JPRB, 0.706368E-02_JPRB &
  &, 0.605324E-02_JPRB, 0.516587E-02_JPRB, 0.441206E-02_JPRB &
  &, 0.373006E-02_JPRB, 0.316332E-02_JPRB, 0.266401E-02_JPRB, 0.223772E-02_JPRB &
  &, 0.189021E-02_JPRB, 0.156678E-02_JPRB, 0.131095E-02_JPRB &
  &, 0.108549E-02_JPRB, 0.892819E-03_JPRB, 0.735412E-03_JPRB, 0.615830E-03_JPRB &
  &, 0.490902E-03_JPRB, 0.407256E-03_JPRB, 0.319944E-03_JPRB &
  &, 0.277538E-03_JPRB, 0.208460E-03_JPRB, 0.161795E-03_JPRB, 0.138984E-03_JPRB &
  &, 0.115202E-03_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 108, :) = (/ &
  &  0.877792E+00_JPRB, 0.847937E+00_JPRB, 0.818395E+00_JPRB, 0.789187E+00_JPRB &
  &, 0.760326E+00_JPRB, 0.731833E+00_JPRB, 0.703723E+00_JPRB &
  &, 0.676015E+00_JPRB, 0.648725E+00_JPRB, 0.621871E+00_JPRB, 0.595470E+00_JPRB &
  &, 0.569538E+00_JPRB, 0.544092E+00_JPRB, 0.519150E+00_JPRB &
  &, 0.494726E+00_JPRB, 0.470837E+00_JPRB, 0.447499E+00_JPRB, 0.424726E+00_JPRB &
  &, 0.402535E+00_JPRB, 0.380936E+00_JPRB, 0.359946E+00_JPRB &
  &, 0.339574E+00_JPRB, 0.319835E+00_JPRB, 0.300737E+00_JPRB, 0.282290E+00_JPRB &
  &, 0.264505E+00_JPRB, 0.247388E+00_JPRB, 0.230942E+00_JPRB &
  &, 0.215173E+00_JPRB, 0.200083E+00_JPRB, 0.185672E+00_JPRB, 0.171942E+00_JPRB &
  &, 0.158885E+00_JPRB, 0.146498E+00_JPRB, 0.134776E+00_JPRB &
  &, 0.123708E+00_JPRB, 0.113287E+00_JPRB, 0.103492E+00_JPRB, 0.943198E-01_JPRB &
  &, 0.857456E-01_JPRB, 0.777600E-01_JPRB, 0.703397E-01_JPRB &
  &, 0.634560E-01_JPRB, 0.571090E-01_JPRB, 0.512497E-01_JPRB, 0.458693E-01_JPRB &
  &, 0.409435E-01_JPRB, 0.364556E-01_JPRB, 0.323595E-01_JPRB &
  &, 0.286548E-01_JPRB, 0.252855E-01_JPRB, 0.222567E-01_JPRB, 0.195443E-01_JPRB &
  &, 0.171057E-01_JPRB, 0.149222E-01_JPRB, 0.129872E-01_JPRB &
  &, 0.112765E-01_JPRB, 0.974669E-02_JPRB, 0.841423E-02_JPRB, 0.722965E-02_JPRB &
  &, 0.620602E-02_JPRB, 0.530475E-02_JPRB, 0.451856E-02_JPRB &
  &, 0.383894E-02_JPRB, 0.325607E-02_JPRB, 0.273984E-02_JPRB, 0.231521E-02_JPRB &
  &, 0.194959E-02_JPRB, 0.162743E-02_JPRB, 0.135225E-02_JPRB &
  &, 0.112767E-02_JPRB, 0.935883E-03_JPRB, 0.779376E-03_JPRB, 0.638268E-03_JPRB &
  &, 0.513802E-03_JPRB, 0.430624E-03_JPRB, 0.343786E-03_JPRB &
  &, 0.277538E-03_JPRB, 0.233267E-03_JPRB, 0.187094E-03_JPRB, 0.138984E-03_JPRB &
  &, 0.115202E-03_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.378473E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 109, :) = (/ &
  &  0.878288E+00_JPRB, 0.848542E+00_JPRB, 0.819105E+00_JPRB, 0.789994E+00_JPRB &
  &, 0.761227E+00_JPRB, 0.732820E+00_JPRB, 0.704792E+00_JPRB &
  &, 0.677159E+00_JPRB, 0.649938E+00_JPRB, 0.623148E+00_JPRB, 0.596805E+00_JPRB &
  &, 0.570925E+00_JPRB, 0.545526E+00_JPRB, 0.520625E+00_JPRB &
  &, 0.496237E+00_JPRB, 0.472378E+00_JPRB, 0.449065E+00_JPRB, 0.426311E+00_JPRB &
  &, 0.404132E+00_JPRB, 0.382541E+00_JPRB, 0.361554E+00_JPRB &
  &, 0.341182E+00_JPRB, 0.321436E+00_JPRB, 0.302327E+00_JPRB, 0.283867E+00_JPRB &
  &, 0.266062E+00_JPRB, 0.248919E+00_JPRB, 0.232446E+00_JPRB &
  &, 0.216643E+00_JPRB, 0.201518E+00_JPRB, 0.187073E+00_JPRB, 0.173297E+00_JPRB &
  &, 0.160197E+00_JPRB, 0.147768E+00_JPRB, 0.135997E+00_JPRB &
  &, 0.124880E+00_JPRB, 0.114403E+00_JPRB, 0.104568E+00_JPRB, 0.953424E-01_JPRB &
  &, 0.867118E-01_JPRB, 0.786768E-01_JPRB, 0.712040E-01_JPRB &
  &, 0.642644E-01_JPRB, 0.578582E-01_JPRB, 0.519595E-01_JPRB, 0.465251E-01_JPRB &
  &, 0.415544E-01_JPRB, 0.370190E-01_JPRB, 0.328854E-01_JPRB &
  &, 0.291279E-01_JPRB, 0.257296E-01_JPRB, 0.226564E-01_JPRB, 0.198971E-01_JPRB &
  &, 0.174381E-01_JPRB, 0.152181E-01_JPRB, 0.132597E-01_JPRB &
  &, 0.115089E-01_JPRB, 0.996870E-02_JPRB, 0.859269E-02_JPRB, 0.739562E-02_JPRB &
  &, 0.635880E-02_JPRB, 0.542627E-02_JPRB, 0.464282E-02_JPRB &
  &, 0.394782E-02_JPRB, 0.334881E-02_JPRB, 0.281567E-02_JPRB, 0.237332E-02_JPRB &
  &, 0.198917E-02_JPRB, 0.166787E-02_JPRB, 0.139355E-02_JPRB &
  &, 0.116985E-02_JPRB, 0.957415E-03_JPRB, 0.801359E-03_JPRB, 0.660707E-03_JPRB &
  &, 0.536702E-03_JPRB, 0.430624E-03_JPRB, 0.367628E-03_JPRB &
  &, 0.277538E-03_JPRB, 0.233267E-03_JPRB, 0.187094E-03_JPRB, 0.138984E-03_JPRB &
  &, 0.115202E-03_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 110, :) = (/ &
  &  0.878779E+00_JPRB, 0.849144E+00_JPRB, 0.819810E+00_JPRB, 0.790798E+00_JPRB &
  &, 0.762122E+00_JPRB, 0.733802E+00_JPRB, 0.705854E+00_JPRB &
  &, 0.678296E+00_JPRB, 0.651145E+00_JPRB, 0.624418E+00_JPRB, 0.598133E+00_JPRB &
  &, 0.572306E+00_JPRB, 0.546953E+00_JPRB, 0.522092E+00_JPRB &
  &, 0.497740E+00_JPRB, 0.473911E+00_JPRB, 0.450622E+00_JPRB, 0.427888E+00_JPRB &
  &, 0.405722E+00_JPRB, 0.384140E+00_JPRB, 0.363159E+00_JPRB &
  &, 0.342783E+00_JPRB, 0.323033E+00_JPRB, 0.303913E+00_JPRB, 0.285437E+00_JPRB &
  &, 0.267611E+00_JPRB, 0.250446E+00_JPRB, 0.233946E+00_JPRB &
  &, 0.218113E+00_JPRB, 0.202956E+00_JPRB, 0.188469E+00_JPRB, 0.174657E+00_JPRB &
  &, 0.161513E+00_JPRB, 0.149037E+00_JPRB, 0.137221E+00_JPRB &
  &, 0.126052E+00_JPRB, 0.115528E+00_JPRB, 0.105633E+00_JPRB, 0.963550E-01_JPRB &
  &, 0.876780E-01_JPRB, 0.795937E-01_JPRB, 0.720574E-01_JPRB &
  &, 0.650840E-01_JPRB, 0.586188E-01_JPRB, 0.526692E-01_JPRB, 0.471929E-01_JPRB &
  &, 0.421776E-01_JPRB, 0.375824E-01_JPRB, 0.333984E-01_JPRB &
  &, 0.296009E-01_JPRB, 0.261603E-01_JPRB, 0.230561E-01_JPRB, 0.202641E-01_JPRB &
  &, 0.177560E-01_JPRB, 0.155288E-01_JPRB, 0.135323E-01_JPRB &
  &, 0.117569E-01_JPRB, 0.101749E-01_JPRB, 0.878739E-02_JPRB, 0.757819E-02_JPRB &
  &, 0.649460E-02_JPRB, 0.556515E-02_JPRB, 0.474932E-02_JPRB &
  &, 0.403855E-02_JPRB, 0.342301E-02_JPRB, 0.291046E-02_JPRB, 0.245081E-02_JPRB &
  &, 0.204855E-02_JPRB, 0.172852E-02_JPRB, 0.143485E-02_JPRB &
  &, 0.119093E-02_JPRB, 0.100048E-02_JPRB, 0.823341E-03_JPRB, 0.683145E-03_JPRB &
  &, 0.559602E-03_JPRB, 0.453992E-03_JPRB, 0.367628E-03_JPRB &
  &, 0.301860E-03_JPRB, 0.233267E-03_JPRB, 0.187094E-03_JPRB, 0.164781E-03_JPRB &
  &, 0.115202E-03_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 111, :) = (/ &
  &  0.879270E+00_JPRB, 0.849742E+00_JPRB, 0.820511E+00_JPRB, 0.791596E+00_JPRB &
  &, 0.763012E+00_JPRB, 0.734778E+00_JPRB, 0.706910E+00_JPRB &
  &, 0.679427E+00_JPRB, 0.652346E+00_JPRB, 0.625682E+00_JPRB, 0.599455E+00_JPRB &
  &, 0.573680E+00_JPRB, 0.548374E+00_JPRB, 0.523555E+00_JPRB &
  &, 0.499237E+00_JPRB, 0.475438E+00_JPRB, 0.452175E+00_JPRB, 0.429458E+00_JPRB &
  &, 0.407309E+00_JPRB, 0.385736E+00_JPRB, 0.364757E+00_JPRB &
  &, 0.344381E+00_JPRB, 0.324624E+00_JPRB, 0.305495E+00_JPRB, 0.287004E+00_JPRB &
  &, 0.269161E+00_JPRB, 0.251970E+00_JPRB, 0.235446E+00_JPRB &
  &, 0.219583E+00_JPRB, 0.204387E+00_JPRB, 0.189865E+00_JPRB, 0.176012E+00_JPRB &
  &, 0.162829E+00_JPRB, 0.150307E+00_JPRB, 0.138441E+00_JPRB &
  &, 0.127224E+00_JPRB, 0.116654E+00_JPRB, 0.106709E+00_JPRB, 0.973776E-01_JPRB &
  &, 0.886545E-01_JPRB, 0.805105E-01_JPRB, 0.729217E-01_JPRB &
  &, 0.658924E-01_JPRB, 0.593794E-01_JPRB, 0.533789E-01_JPRB, 0.478606E-01_JPRB &
  &, 0.427885E-01_JPRB, 0.381583E-01_JPRB, 0.339244E-01_JPRB &
  &, 0.300871E-01_JPRB, 0.266044E-01_JPRB, 0.234696E-01_JPRB, 0.206311E-01_JPRB &
  &, 0.181028E-01_JPRB, 0.158246E-01_JPRB, 0.138049E-01_JPRB &
  &, 0.119893E-01_JPRB, 0.103969E-01_JPRB, 0.898208E-02_JPRB, 0.774416E-02_JPRB &
  &, 0.666435E-02_JPRB, 0.570403E-02_JPRB, 0.487357E-02_JPRB &
  &, 0.414743E-02_JPRB, 0.351575E-02_JPRB, 0.298629E-02_JPRB, 0.250892E-02_JPRB &
  &, 0.212771E-02_JPRB, 0.176896E-02_JPRB, 0.147615E-02_JPRB &
  &, 0.123311E-02_JPRB, 0.102201E-02_JPRB, 0.845323E-03_JPRB, 0.705583E-03_JPRB &
  &, 0.582502E-03_JPRB, 0.477360E-03_JPRB, 0.391470E-03_JPRB &
  &, 0.301860E-03_JPRB, 0.258074E-03_JPRB, 0.212393E-03_JPRB, 0.164781E-03_JPRB &
  &, 0.115202E-03_JPRB, 0.904305E-04_JPRB, 0.646515E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 112, :) = (/ &
  &  0.879756E+00_JPRB, 0.850337E+00_JPRB, 0.821208E+00_JPRB, 0.792390E+00_JPRB &
  &, 0.763897E+00_JPRB, 0.735749E+00_JPRB, 0.707961E+00_JPRB &
  &, 0.680552E+00_JPRB, 0.653539E+00_JPRB, 0.626940E+00_JPRB, 0.600770E+00_JPRB &
  &, 0.575046E+00_JPRB, 0.549787E+00_JPRB, 0.525009E+00_JPRB &
  &, 0.500728E+00_JPRB, 0.476959E+00_JPRB, 0.453720E+00_JPRB, 0.431025E+00_JPRB &
  &, 0.408888E+00_JPRB, 0.387325E+00_JPRB, 0.366350E+00_JPRB &
  &, 0.345973E+00_JPRB, 0.326211E+00_JPRB, 0.307071E+00_JPRB, 0.288567E+00_JPRB &
  &, 0.270707E+00_JPRB, 0.253493E+00_JPRB, 0.236938E+00_JPRB &
  &, 0.221046E+00_JPRB, 0.205821E+00_JPRB, 0.191262E+00_JPRB, 0.177368E+00_JPRB &
  &, 0.164141E+00_JPRB, 0.151577E+00_JPRB, 0.139666E+00_JPRB &
  &, 0.128405E+00_JPRB, 0.117779E+00_JPRB, 0.107785E+00_JPRB, 0.984002E-01_JPRB &
  &, 0.896207E-01_JPRB, 0.814273E-01_JPRB, 0.737968E-01_JPRB &
  &, 0.667119E-01_JPRB, 0.601513E-01_JPRB, 0.541003E-01_JPRB, 0.485283E-01_JPRB &
  &, 0.434117E-01_JPRB, 0.387342E-01_JPRB, 0.344631E-01_JPRB &
  &, 0.305733E-01_JPRB, 0.270620E-01_JPRB, 0.238694E-01_JPRB, 0.210122E-01_JPRB &
  &, 0.184352E-01_JPRB, 0.161353E-01_JPRB, 0.140774E-01_JPRB &
  &, 0.122373E-01_JPRB, 0.106189E-01_JPRB, 0.919300E-02_JPRB, 0.792672E-02_JPRB &
  &, 0.681713E-02_JPRB, 0.584291E-02_JPRB, 0.499782E-02_JPRB &
  &, 0.425631E-02_JPRB, 0.360850E-02_JPRB, 0.306212E-02_JPRB, 0.258641E-02_JPRB &
  &, 0.218709E-02_JPRB, 0.182961E-02_JPRB, 0.153810E-02_JPRB &
  &, 0.127529E-02_JPRB, 0.106508E-02_JPRB, 0.889287E-03_JPRB, 0.728021E-03_JPRB &
  &, 0.605402E-03_JPRB, 0.500728E-03_JPRB, 0.391470E-03_JPRB &
  &, 0.326182E-03_JPRB, 0.258074E-03_JPRB, 0.212393E-03_JPRB, 0.164781E-03_JPRB &
  &, 0.141503E-03_JPRB, 0.117241E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART17

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART17',0,ZHOOK_HANDLE)

XCW( 113, :) = (/ &
  &  0.880240E+00_JPRB, 0.850928E+00_JPRB, 0.821901E+00_JPRB, 0.793179E+00_JPRB &
  &, 0.764777E+00_JPRB, 0.736714E+00_JPRB, 0.709006E+00_JPRB &
  &, 0.681671E+00_JPRB, 0.654727E+00_JPRB, 0.628190E+00_JPRB, 0.602078E+00_JPRB &
  &, 0.576407E+00_JPRB, 0.551195E+00_JPRB, 0.526457E+00_JPRB &
  &, 0.502211E+00_JPRB, 0.478474E+00_JPRB, 0.455259E+00_JPRB, 0.432583E+00_JPRB &
  &, 0.410461E+00_JPRB, 0.388908E+00_JPRB, 0.367938E+00_JPRB &
  &, 0.347561E+00_JPRB, 0.327795E+00_JPRB, 0.308646E+00_JPRB, 0.290127E+00_JPRB &
  &, 0.272245E+00_JPRB, 0.255013E+00_JPRB, 0.238434E+00_JPRB &
  &, 0.222512E+00_JPRB, 0.207252E+00_JPRB, 0.192654E+00_JPRB, 0.178723E+00_JPRB &
  &, 0.165453E+00_JPRB, 0.152842E+00_JPRB, 0.140886E+00_JPRB &
  &, 0.129577E+00_JPRB, 0.118904E+00_JPRB, 0.108860E+00_JPRB, 0.994328E-01_JPRB &
  &, 0.905972E-01_JPRB, 0.823441E-01_JPRB, 0.746610E-01_JPRB &
  &, 0.675314E-01_JPRB, 0.609232E-01_JPRB, 0.548100E-01_JPRB, 0.491961E-01_JPRB &
  &, 0.440348E-01_JPRB, 0.393101E-01_JPRB, 0.349890E-01_JPRB &
  &, 0.310726E-01_JPRB, 0.275062E-01_JPRB, 0.242829E-01_JPRB, 0.213792E-01_JPRB &
  &, 0.187820E-01_JPRB, 0.164460E-01_JPRB, 0.143500E-01_JPRB &
  &, 0.125007E-01_JPRB, 0.108409E-01_JPRB, 0.938769E-02_JPRB, 0.810929E-02_JPRB &
  &, 0.696991E-02_JPRB, 0.598179E-02_JPRB, 0.512207E-02_JPRB &
  &, 0.436519E-02_JPRB, 0.371979E-02_JPRB, 0.315690E-02_JPRB, 0.266390E-02_JPRB &
  &, 0.224646E-02_JPRB, 0.189026E-02_JPRB, 0.157940E-02_JPRB &
  &, 0.131746E-02_JPRB, 0.108661E-02_JPRB, 0.911270E-03_JPRB, 0.750459E-03_JPRB &
  &, 0.628303E-03_JPRB, 0.500728E-03_JPRB, 0.415311E-03_JPRB &
  &, 0.326182E-03_JPRB, 0.282882E-03_JPRB, 0.212393E-03_JPRB, 0.164781E-03_JPRB &
  &, 0.141503E-03_JPRB, 0.117241E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 114, :) = (/ &
  &  0.880720E+00_JPRB, 0.851515E+00_JPRB, 0.822590E+00_JPRB, 0.793964E+00_JPRB &
  &, 0.765652E+00_JPRB, 0.737674E+00_JPRB, 0.710046E+00_JPRB &
  &, 0.682785E+00_JPRB, 0.655909E+00_JPRB, 0.629435E+00_JPRB, 0.603380E+00_JPRB &
  &, 0.577761E+00_JPRB, 0.552595E+00_JPRB, 0.527899E+00_JPRB &
  &, 0.503689E+00_JPRB, 0.479982E+00_JPRB, 0.456792E+00_JPRB, 0.434136E+00_JPRB &
  &, 0.412029E+00_JPRB, 0.390485E+00_JPRB, 0.369521E+00_JPRB &
  &, 0.349146E+00_JPRB, 0.329372E+00_JPRB, 0.310215E+00_JPRB, 0.291682E+00_JPRB &
  &, 0.273784E+00_JPRB, 0.256529E+00_JPRB, 0.239922E+00_JPRB &
  &, 0.223970E+00_JPRB, 0.208678E+00_JPRB, 0.194046E+00_JPRB, 0.180079E+00_JPRB &
  &, 0.166769E+00_JPRB, 0.154112E+00_JPRB, 0.142111E+00_JPRB &
  &, 0.130749E+00_JPRB, 0.120030E+00_JPRB, 0.109936E+00_JPRB, 0.100455E+00_JPRB &
  &, 0.915736E-01_JPRB, 0.832715E-01_JPRB, 0.755361E-01_JPRB &
  &, 0.683509E-01_JPRB, 0.616951E-01_JPRB, 0.555430E-01_JPRB, 0.498638E-01_JPRB &
  &, 0.446580E-01_JPRB, 0.398860E-01_JPRB, 0.355277E-01_JPRB &
  &, 0.315587E-01_JPRB, 0.279638E-01_JPRB, 0.246964E-01_JPRB, 0.217602E-01_JPRB &
  &, 0.191144E-01_JPRB, 0.167567E-01_JPRB, 0.146377E-01_JPRB &
  &, 0.127487E-01_JPRB, 0.110787E-01_JPRB, 0.959860E-02_JPRB, 0.829186E-02_JPRB &
  &, 0.713967E-02_JPRB, 0.612066E-02_JPRB, 0.524632E-02_JPRB &
  &, 0.447407E-02_JPRB, 0.381254E-02_JPRB, 0.323273E-02_JPRB, 0.274138E-02_JPRB &
  &, 0.230584E-02_JPRB, 0.193070E-02_JPRB, 0.162070E-02_JPRB &
  &, 0.135964E-02_JPRB, 0.112967E-02_JPRB, 0.933252E-03_JPRB, 0.772897E-03_JPRB &
  &, 0.651203E-03_JPRB, 0.524096E-03_JPRB, 0.439153E-03_JPRB &
  &, 0.350503E-03_JPRB, 0.282882E-03_JPRB, 0.237693E-03_JPRB, 0.190578E-03_JPRB &
  &, 0.141503E-03_JPRB, 0.117241E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.383748E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 115, :) = (/ &
  &  0.881198E+00_JPRB, 0.852099E+00_JPRB, 0.823275E+00_JPRB, 0.794744E+00_JPRB &
  &, 0.766523E+00_JPRB, 0.738629E+00_JPRB, 0.711080E+00_JPRB &
  &, 0.683892E+00_JPRB, 0.657084E+00_JPRB, 0.630673E+00_JPRB, 0.604676E+00_JPRB &
  &, 0.579109E+00_JPRB, 0.553989E+00_JPRB, 0.529335E+00_JPRB &
  &, 0.505160E+00_JPRB, 0.481484E+00_JPRB, 0.458318E+00_JPRB, 0.435684E+00_JPRB &
  &, 0.413591E+00_JPRB, 0.392059E+00_JPRB, 0.371096E+00_JPRB &
  &, 0.350724E+00_JPRB, 0.330946E+00_JPRB, 0.311780E+00_JPRB, 0.293235E+00_JPRB &
  &, 0.275319E+00_JPRB, 0.258042E+00_JPRB, 0.241410E+00_JPRB &
  &, 0.225429E+00_JPRB, 0.210105E+00_JPRB, 0.195438E+00_JPRB, 0.181430E+00_JPRB &
  &, 0.168081E+00_JPRB, 0.155382E+00_JPRB, 0.143336E+00_JPRB &
  &, 0.131930E+00_JPRB, 0.121165E+00_JPRB, 0.111021E+00_JPRB, 0.101488E+00_JPRB &
  &, 0.925501E-01_JPRB, 0.841988E-01_JPRB, 0.764112E-01_JPRB &
  &, 0.691815E-01_JPRB, 0.624670E-01_JPRB, 0.562643E-01_JPRB, 0.505435E-01_JPRB &
  &, 0.452934E-01_JPRB, 0.404745E-01_JPRB, 0.360664E-01_JPRB &
  &, 0.320581E-01_JPRB, 0.284214E-01_JPRB, 0.251237E-01_JPRB, 0.221413E-01_JPRB &
  &, 0.194612E-01_JPRB, 0.170673E-01_JPRB, 0.149254E-01_JPRB &
  &, 0.130121E-01_JPRB, 0.113008E-01_JPRB, 0.979330E-02_JPRB, 0.847442E-02_JPRB &
  &, 0.729244E-02_JPRB, 0.627690E-02_JPRB, 0.537058E-02_JPRB &
  &, 0.458295E-02_JPRB, 0.390528E-02_JPRB, 0.332752E-02_JPRB, 0.281887E-02_JPRB &
  &, 0.236521E-02_JPRB, 0.199135E-02_JPRB, 0.168265E-02_JPRB &
  &, 0.140182E-02_JPRB, 0.117274E-02_JPRB, 0.977216E-03_JPRB, 0.795336E-03_JPRB &
  &, 0.651203E-03_JPRB, 0.547464E-03_JPRB, 0.439153E-03_JPRB &
  &, 0.374825E-03_JPRB, 0.282882E-03_JPRB, 0.237693E-03_JPRB, 0.190578E-03_JPRB &
  &, 0.141503E-03_JPRB, 0.117241E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.667496E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 116, :) = (/ &
  &  0.881674E+00_JPRB, 0.852680E+00_JPRB, 0.823956E+00_JPRB, 0.795520E+00_JPRB &
  &, 0.767388E+00_JPRB, 0.739578E+00_JPRB, 0.712108E+00_JPRB &
  &, 0.684994E+00_JPRB, 0.658255E+00_JPRB, 0.631906E+00_JPRB, 0.605966E+00_JPRB &
  &, 0.580450E+00_JPRB, 0.555378E+00_JPRB, 0.530763E+00_JPRB &
  &, 0.506625E+00_JPRB, 0.482978E+00_JPRB, 0.459840E+00_JPRB, 0.437224E+00_JPRB &
  &, 0.415149E+00_JPRB, 0.393626E+00_JPRB, 0.372669E+00_JPRB &
  &, 0.352296E+00_JPRB, 0.332516E+00_JPRB, 0.313342E+00_JPRB, 0.294780E+00_JPRB &
  &, 0.276850E+00_JPRB, 0.259551E+00_JPRB, 0.242895E+00_JPRB &
  &, 0.226887E+00_JPRB, 0.211531E+00_JPRB, 0.196830E+00_JPRB, 0.182785E+00_JPRB &
  &, 0.169393E+00_JPRB, 0.156651E+00_JPRB, 0.144560E+00_JPRB &
  &, 0.133112E+00_JPRB, 0.122290E+00_JPRB, 0.112097E+00_JPRB, 0.102521E+00_JPRB &
  &, 0.935369E-01_JPRB, 0.851262E-01_JPRB, 0.772970E-01_JPRB &
  &, 0.700011E-01_JPRB, 0.632503E-01_JPRB, 0.569973E-01_JPRB, 0.512232E-01_JPRB &
  &, 0.459166E-01_JPRB, 0.410629E-01_JPRB, 0.366180E-01_JPRB &
  &, 0.325574E-01_JPRB, 0.288790E-01_JPRB, 0.255372E-01_JPRB, 0.225365E-01_JPRB &
  &, 0.198225E-01_JPRB, 0.173780E-01_JPRB, 0.152131E-01_JPRB &
  &, 0.132601E-01_JPRB, 0.115386E-01_JPRB, 0.100042E-01_JPRB, 0.865699E-02_JPRB &
  &, 0.746220E-02_JPRB, 0.641578E-02_JPRB, 0.549483E-02_JPRB &
  &, 0.470998E-02_JPRB, 0.401657E-02_JPRB, 0.340335E-02_JPRB, 0.287698E-02_JPRB &
  &, 0.244438E-02_JPRB, 0.205201E-02_JPRB, 0.172395E-02_JPRB &
  &, 0.144399E-02_JPRB, 0.119427E-02_JPRB, 0.999198E-03_JPRB, 0.840212E-03_JPRB &
  &, 0.674103E-03_JPRB, 0.570832E-03_JPRB, 0.462995E-03_JPRB &
  &, 0.374825E-03_JPRB, 0.307689E-03_JPRB, 0.237693E-03_JPRB, 0.190578E-03_JPRB &
  &, 0.167803E-03_JPRB, 0.117241E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.656946E-04_JPRB, 0.667496E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 117, :) = (/ &
  &  0.882147E+00_JPRB, 0.853258E+00_JPRB, 0.824633E+00_JPRB, 0.796292E+00_JPRB &
  &, 0.768249E+00_JPRB, 0.740523E+00_JPRB, 0.713131E+00_JPRB &
  &, 0.686091E+00_JPRB, 0.659419E+00_JPRB, 0.633132E+00_JPRB, 0.607249E+00_JPRB &
  &, 0.581786E+00_JPRB, 0.556759E+00_JPRB, 0.532186E+00_JPRB &
  &, 0.508084E+00_JPRB, 0.484469E+00_JPRB, 0.461355E+00_JPRB, 0.438760E+00_JPRB &
  &, 0.416700E+00_JPRB, 0.395187E+00_JPRB, 0.374238E+00_JPRB &
  &, 0.353864E+00_JPRB, 0.334080E+00_JPRB, 0.314897E+00_JPRB, 0.296326E+00_JPRB &
  &, 0.278378E+00_JPRB, 0.261059E+00_JPRB, 0.244379E+00_JPRB &
  &, 0.228342E+00_JPRB, 0.212954E+00_JPRB, 0.198218E+00_JPRB, 0.184137E+00_JPRB &
  &, 0.170705E+00_JPRB, 0.157921E+00_JPRB, 0.145790E+00_JPRB &
  &, 0.134293E+00_JPRB, 0.123425E+00_JPRB, 0.113182E+00_JPRB, 0.103553E+00_JPRB &
  &, 0.945134E-01_JPRB, 0.860641E-01_JPRB, 0.781721E-01_JPRB &
  &, 0.708427E-01_JPRB, 0.640222E-01_JPRB, 0.577303E-01_JPRB, 0.519147E-01_JPRB &
  &, 0.465642E-01_JPRB, 0.416513E-01_JPRB, 0.371567E-01_JPRB &
  &, 0.330698E-01_JPRB, 0.293500E-01_JPRB, 0.259645E-01_JPRB, 0.229176E-01_JPRB &
  &, 0.201693E-01_JPRB, 0.177035E-01_JPRB, 0.155008E-01_JPRB &
  &, 0.135236E-01_JPRB, 0.117765E-01_JPRB, 0.102151E-01_JPRB, 0.883955E-02_JPRB &
  &, 0.763195E-02_JPRB, 0.657202E-02_JPRB, 0.563683E-02_JPRB &
  &, 0.481886E-02_JPRB, 0.410932E-02_JPRB, 0.349813E-02_JPRB, 0.295447E-02_JPRB &
  &, 0.250376E-02_JPRB, 0.211266E-02_JPRB, 0.176525E-02_JPRB &
  &, 0.148617E-02_JPRB, 0.123733E-02_JPRB, 0.104316E-02_JPRB, 0.862650E-03_JPRB &
  &, 0.719903E-03_JPRB, 0.594200E-03_JPRB, 0.486837E-03_JPRB &
  &, 0.399147E-03_JPRB, 0.307689E-03_JPRB, 0.262992E-03_JPRB, 0.216375E-03_JPRB &
  &, 0.167803E-03_JPRB, 0.144051E-03_JPRB, 0.919772E-04_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 118, :) = (/ &
  &  0.882615E+00_JPRB, 0.853832E+00_JPRB, 0.825306E+00_JPRB, 0.797059E+00_JPRB &
  &, 0.769105E+00_JPRB, 0.741462E+00_JPRB, 0.714149E+00_JPRB &
  &, 0.687181E+00_JPRB, 0.660577E+00_JPRB, 0.634353E+00_JPRB, 0.608527E+00_JPRB &
  &, 0.583115E+00_JPRB, 0.558135E+00_JPRB, 0.533604E+00_JPRB &
  &, 0.509537E+00_JPRB, 0.485953E+00_JPRB, 0.462865E+00_JPRB, 0.440292E+00_JPRB &
  &, 0.418246E+00_JPRB, 0.396744E+00_JPRB, 0.375801E+00_JPRB &
  &, 0.355429E+00_JPRB, 0.335640E+00_JPRB, 0.316451E+00_JPRB, 0.297867E+00_JPRB &
  &, 0.279902E+00_JPRB, 0.262564E+00_JPRB, 0.245860E+00_JPRB &
  &, 0.229796E+00_JPRB, 0.214376E+00_JPRB, 0.199606E+00_JPRB, 0.185488E+00_JPRB &
  &, 0.172016E+00_JPRB, 0.159195E+00_JPRB, 0.147014E+00_JPRB &
  &, 0.135474E+00_JPRB, 0.124560E+00_JPRB, 0.114267E+00_JPRB, 0.104586E+00_JPRB &
  &, 0.955002E-01_JPRB, 0.870019E-01_JPRB, 0.790580E-01_JPRB &
  &, 0.716733E-01_JPRB, 0.648168E-01_JPRB, 0.584633E-01_JPRB, 0.525944E-01_JPRB &
  &, 0.471996E-01_JPRB, 0.422398E-01_JPRB, 0.377083E-01_JPRB &
  &, 0.335691E-01_JPRB, 0.298076E-01_JPRB, 0.263917E-01_JPRB, 0.233128E-01_JPRB &
  &, 0.205306E-01_JPRB, 0.180289E-01_JPRB, 0.157885E-01_JPRB &
  &, 0.137870E-01_JPRB, 0.120144E-01_JPRB, 0.104260E-01_JPRB, 0.903872E-02_JPRB &
  &, 0.780171E-02_JPRB, 0.671090E-02_JPRB, 0.576108E-02_JPRB &
  &, 0.492774E-02_JPRB, 0.422061E-02_JPRB, 0.359292E-02_JPRB, 0.305133E-02_JPRB &
  &, 0.258292E-02_JPRB, 0.217331E-02_JPRB, 0.182720E-02_JPRB &
  &, 0.152834E-02_JPRB, 0.128040E-02_JPRB, 0.106514E-02_JPRB, 0.885088E-03_JPRB &
  &, 0.742803E-03_JPRB, 0.594200E-03_JPRB, 0.486837E-03_JPRB &
  &, 0.399147E-03_JPRB, 0.332497E-03_JPRB, 0.262992E-03_JPRB, 0.216375E-03_JPRB &
  &, 0.167803E-03_JPRB, 0.144051E-03_JPRB, 0.119303E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 119, :) = (/ &
  &  0.883084E+00_JPRB, 0.854403E+00_JPRB, 0.825976E+00_JPRB, 0.797823E+00_JPRB &
  &, 0.769957E+00_JPRB, 0.742398E+00_JPRB, 0.715162E+00_JPRB &
  &, 0.688267E+00_JPRB, 0.661730E+00_JPRB, 0.635568E+00_JPRB, 0.609799E+00_JPRB &
  &, 0.584439E+00_JPRB, 0.559505E+00_JPRB, 0.535015E+00_JPRB &
  &, 0.510984E+00_JPRB, 0.487430E+00_JPRB, 0.464370E+00_JPRB, 0.441817E+00_JPRB &
  &, 0.419787E+00_JPRB, 0.398296E+00_JPRB, 0.377358E+00_JPRB &
  &, 0.356987E+00_JPRB, 0.337200E+00_JPRB, 0.317999E+00_JPRB, 0.299405E+00_JPRB &
  &, 0.281426E+00_JPRB, 0.264066E+00_JPRB, 0.247337E+00_JPRB &
  &, 0.231247E+00_JPRB, 0.215799E+00_JPRB, 0.200995E+00_JPRB, 0.186839E+00_JPRB &
  &, 0.173328E+00_JPRB, 0.160465E+00_JPRB, 0.148239E+00_JPRB &
  &, 0.136655E+00_JPRB, 0.125695E+00_JPRB, 0.115353E+00_JPRB, 0.105619E+00_JPRB &
  &, 0.964869E-01_JPRB, 0.879398E-01_JPRB, 0.799439E-01_JPRB &
  &, 0.725039E-01_JPRB, 0.656001E-01_JPRB, 0.591963E-01_JPRB, 0.532860E-01_JPRB &
  &, 0.478472E-01_JPRB, 0.428407E-01_JPRB, 0.382598E-01_JPRB &
  &, 0.340816E-01_JPRB, 0.302787E-01_JPRB, 0.268328E-01_JPRB, 0.237080E-01_JPRB &
  &, 0.208919E-01_JPRB, 0.183544E-01_JPRB, 0.160914E-01_JPRB &
  &, 0.140660E-01_JPRB, 0.122522E-01_JPRB, 0.106532E-01_JPRB, 0.922128E-02_JPRB &
  &, 0.797146E-02_JPRB, 0.686714E-02_JPRB, 0.590308E-02_JPRB &
  &, 0.505476E-02_JPRB, 0.431336E-02_JPRB, 0.368771E-02_JPRB, 0.312881E-02_JPRB &
  &, 0.264230E-02_JPRB, 0.223397E-02_JPRB, 0.188915E-02_JPRB &
  &, 0.157052E-02_JPRB, 0.132346E-02_JPRB, 0.110911E-02_JPRB, 0.907526E-03_JPRB &
  &, 0.765703E-03_JPRB, 0.617568E-03_JPRB, 0.510679E-03_JPRB &
  &, 0.423468E-03_JPRB, 0.332497E-03_JPRB, 0.288291E-03_JPRB, 0.216375E-03_JPRB &
  &, 0.167803E-03_JPRB, 0.144051E-03_JPRB, 0.119303E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.389082E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART18

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART18',0,ZHOOK_HANDLE)

XCW( 120, :) = (/ &
  &  0.883547E+00_JPRB, 0.854971E+00_JPRB, 0.826642E+00_JPRB, 0.798579E+00_JPRB &
  &, 0.770804E+00_JPRB, 0.743327E+00_JPRB, 0.716169E+00_JPRB &
  &, 0.689347E+00_JPRB, 0.662877E+00_JPRB, 0.636777E+00_JPRB, 0.611065E+00_JPRB &
  &, 0.585755E+00_JPRB, 0.560869E+00_JPRB, 0.536420E+00_JPRB &
  &, 0.512426E+00_JPRB, 0.488903E+00_JPRB, 0.465867E+00_JPRB, 0.443336E+00_JPRB &
  &, 0.421322E+00_JPRB, 0.399844E+00_JPRB, 0.378911E+00_JPRB &
  &, 0.358545E+00_JPRB, 0.338750E+00_JPRB, 0.319547E+00_JPRB, 0.300940E+00_JPRB &
  &, 0.282943E+00_JPRB, 0.265567E+00_JPRB, 0.248814E+00_JPRB &
  &, 0.232698E+00_JPRB, 0.217217E+00_JPRB, 0.202383E+00_JPRB, 0.188191E+00_JPRB &
  &, 0.174640E+00_JPRB, 0.161735E+00_JPRB, 0.149468E+00_JPRB &
  &, 0.137837E+00_JPRB, 0.126829E+00_JPRB, 0.116438E+00_JPRB, 0.106661E+00_JPRB &
  &, 0.974737E-01_JPRB, 0.888777E-01_JPRB, 0.808405E-01_JPRB &
  &, 0.733456E-01_JPRB, 0.663947E-01_JPRB, 0.599409E-01_JPRB, 0.539776E-01_JPRB &
  &, 0.484948E-01_JPRB, 0.434417E-01_JPRB, 0.388242E-01_JPRB &
  &, 0.346072E-01_JPRB, 0.307632E-01_JPRB, 0.272601E-01_JPRB, 0.241032E-01_JPRB &
  &, 0.212532E-01_JPRB, 0.186947E-01_JPRB, 0.163942E-01_JPRB &
  &, 0.143294E-01_JPRB, 0.124901E-01_JPRB, 0.108641E-01_JPRB, 0.942044E-02_JPRB &
  &, 0.814121E-02_JPRB, 0.702338E-02_JPRB, 0.604509E-02_JPRB &
  &, 0.518179E-02_JPRB, 0.442465E-02_JPRB, 0.376354E-02_JPRB, 0.320630E-02_JPRB &
  &, 0.272146E-02_JPRB, 0.229462E-02_JPRB, 0.193045E-02_JPRB &
  &, 0.163378E-02_JPRB, 0.136653E-02_JPRB, 0.113109E-02_JPRB, 0.952403E-03_JPRB &
  &, 0.788603E-03_JPRB, 0.640936E-03_JPRB, 0.534521E-03_JPRB &
  &, 0.447790E-03_JPRB, 0.357304E-03_JPRB, 0.288291E-03_JPRB, 0.242172E-03_JPRB &
  &, 0.194104E-03_JPRB, 0.144051E-03_JPRB, 0.119303E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 121, :) = (/ &
  &  0.884009E+00_JPRB, 0.855535E+00_JPRB, 0.827305E+00_JPRB, 0.799337E+00_JPRB &
  &, 0.771647E+00_JPRB, 0.744253E+00_JPRB, 0.717172E+00_JPRB &
  &, 0.690421E+00_JPRB, 0.664019E+00_JPRB, 0.637981E+00_JPRB, 0.612325E+00_JPRB &
  &, 0.587067E+00_JPRB, 0.562227E+00_JPRB, 0.537819E+00_JPRB &
  &, 0.513861E+00_JPRB, 0.490370E+00_JPRB, 0.467360E+00_JPRB, 0.444851E+00_JPRB &
  &, 0.422853E+00_JPRB, 0.401386E+00_JPRB, 0.380461E+00_JPRB &
  &, 0.360094E+00_JPRB, 0.340300E+00_JPRB, 0.321088E+00_JPRB, 0.302471E+00_JPRB &
  &, 0.284459E+00_JPRB, 0.267065E+00_JPRB, 0.250291E+00_JPRB &
  &, 0.234144E+00_JPRB, 0.218635E+00_JPRB, 0.203767E+00_JPRB, 0.189538E+00_JPRB &
  &, 0.175952E+00_JPRB, 0.163005E+00_JPRB, 0.150697E+00_JPRB &
  &, 0.139018E+00_JPRB, 0.127964E+00_JPRB, 0.117533E+00_JPRB, 0.107704E+00_JPRB &
  &, 0.984707E-01_JPRB, 0.898156E-01_JPRB, 0.817264E-01_JPRB &
  &, 0.741872E-01_JPRB, 0.671780E-01_JPRB, 0.606856E-01_JPRB, 0.546811E-01_JPRB &
  &, 0.491424E-01_JPRB, 0.440552E-01_JPRB, 0.393886E-01_JPRB &
  &, 0.351196E-01_JPRB, 0.312342E-01_JPRB, 0.277012E-01_JPRB, 0.245125E-01_JPRB &
  &, 0.216145E-01_JPRB, 0.190201E-01_JPRB, 0.166971E-01_JPRB &
  &, 0.146084E-01_JPRB, 0.127438E-01_JPRB, 0.110912E-01_JPRB, 0.961961E-02_JPRB &
  &, 0.832794E-02_JPRB, 0.717962E-02_JPRB, 0.618709E-02_JPRB &
  &, 0.530881E-02_JPRB, 0.453595E-02_JPRB, 0.387728E-02_JPRB, 0.328378E-02_JPRB &
  &, 0.278084E-02_JPRB, 0.235527E-02_JPRB, 0.199240E-02_JPRB &
  &, 0.167596E-02_JPRB, 0.140959E-02_JPRB, 0.117506E-02_JPRB, 0.974841E-03_JPRB &
  &, 0.811503E-03_JPRB, 0.664304E-03_JPRB, 0.558363E-03_JPRB &
  &, 0.447790E-03_JPRB, 0.357304E-03_JPRB, 0.288291E-03_JPRB, 0.242172E-03_JPRB &
  &, 0.194104E-03_JPRB, 0.144051E-03_JPRB, 0.119303E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 122, :) = (/ &
  &  0.884468E+00_JPRB, 0.856097E+00_JPRB, 0.827964E+00_JPRB, 0.800088E+00_JPRB &
  &, 0.772485E+00_JPRB, 0.745173E+00_JPRB, 0.718170E+00_JPRB &
  &, 0.691491E+00_JPRB, 0.665155E+00_JPRB, 0.639179E+00_JPRB, 0.613580E+00_JPRB &
  &, 0.588374E+00_JPRB, 0.563579E+00_JPRB, 0.539214E+00_JPRB &
  &, 0.515292E+00_JPRB, 0.491831E+00_JPRB, 0.468849E+00_JPRB, 0.446359E+00_JPRB &
  &, 0.424378E+00_JPRB, 0.402921E+00_JPRB, 0.382004E+00_JPRB &
  &, 0.361642E+00_JPRB, 0.341843E+00_JPRB, 0.322625E+00_JPRB, 0.303999E+00_JPRB &
  &, 0.285973E+00_JPRB, 0.268558E+00_JPRB, 0.251760E+00_JPRB &
  &, 0.235591E+00_JPRB, 0.220054E+00_JPRB, 0.205151E+00_JPRB, 0.190889E+00_JPRB &
  &, 0.177264E+00_JPRB, 0.164274E+00_JPRB, 0.151922E+00_JPRB &
  &, 0.140199E+00_JPRB, 0.129099E+00_JPRB, 0.118619E+00_JPRB, 0.108746E+00_JPRB &
  &, 0.994678E-01_JPRB, 0.907640E-01_JPRB, 0.826231E-01_JPRB &
  &, 0.750400E-01_JPRB, 0.679839E-01_JPRB, 0.614302E-01_JPRB, 0.553846E-01_JPRB &
  &, 0.497900E-01_JPRB, 0.446561E-01_JPRB, 0.399530E-01_JPRB &
  &, 0.356452E-01_JPRB, 0.317187E-01_JPRB, 0.281423E-01_JPRB, 0.249078E-01_JPRB &
  &, 0.219902E-01_JPRB, 0.193604E-01_JPRB, 0.169999E-01_JPRB &
  &, 0.148873E-01_JPRB, 0.129975E-01_JPRB, 0.113184E-01_JPRB, 0.981877E-02_JPRB &
  &, 0.849770E-02_JPRB, 0.733585E-02_JPRB, 0.632909E-02_JPRB &
  &, 0.541769E-02_JPRB, 0.464724E-02_JPRB, 0.397206E-02_JPRB, 0.338064E-02_JPRB &
  &, 0.286001E-02_JPRB, 0.241593E-02_JPRB, 0.205435E-02_JPRB &
  &, 0.171814E-02_JPRB, 0.143112E-02_JPRB, 0.119704E-02_JPRB, 0.997279E-03_JPRB &
  &, 0.834403E-03_JPRB, 0.687672E-03_JPRB, 0.558363E-03_JPRB &
  &, 0.472112E-03_JPRB, 0.382112E-03_JPRB, 0.313590E-03_JPRB, 0.242172E-03_JPRB &
  &, 0.194104E-03_JPRB, 0.170861E-03_JPRB, 0.119303E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.667496E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 123, :) = (/ &
  &  0.884926E+00_JPRB, 0.856656E+00_JPRB, 0.828619E+00_JPRB, 0.800836E+00_JPRB &
  &, 0.773320E+00_JPRB, 0.746090E+00_JPRB, 0.719163E+00_JPRB &
  &, 0.692556E+00_JPRB, 0.666287E+00_JPRB, 0.640372E+00_JPRB, 0.614829E+00_JPRB &
  &, 0.589674E+00_JPRB, 0.564927E+00_JPRB, 0.540601E+00_JPRB &
  &, 0.516717E+00_JPRB, 0.493288E+00_JPRB, 0.470330E+00_JPRB, 0.447863E+00_JPRB &
  &, 0.425900E+00_JPRB, 0.404453E+00_JPRB, 0.383544E+00_JPRB &
  &, 0.363184E+00_JPRB, 0.343386E+00_JPRB, 0.324159E+00_JPRB, 0.305523E+00_JPRB &
  &, 0.287482E+00_JPRB, 0.270048E+00_JPRB, 0.253233E+00_JPRB &
  &, 0.237034E+00_JPRB, 0.221468E+00_JPRB, 0.206535E+00_JPRB, 0.192236E+00_JPRB &
  &, 0.178576E+00_JPRB, 0.165548E+00_JPRB, 0.153151E+00_JPRB &
  &, 0.141390E+00_JPRB, 0.130244E+00_JPRB, 0.119714E+00_JPRB, 0.109789E+00_JPRB &
  &, 0.100465E+00_JPRB, 0.917125E-01_JPRB, 0.835198E-01_JPRB &
  &, 0.758816E-01_JPRB, 0.687786E-01_JPRB, 0.621865E-01_JPRB, 0.560881E-01_JPRB &
  &, 0.504498E-01_JPRB, 0.452696E-01_JPRB, 0.405174E-01_JPRB &
  &, 0.361708E-01_JPRB, 0.322033E-01_JPRB, 0.285971E-01_JPRB, 0.253171E-01_JPRB &
  &, 0.223659E-01_JPRB, 0.197006E-01_JPRB, 0.173028E-01_JPRB &
  &, 0.151663E-01_JPRB, 0.132513E-01_JPRB, 0.115455E-01_JPRB, 0.100179E-01_JPRB &
  &, 0.868443E-02_JPRB, 0.750945E-02_JPRB, 0.647109E-02_JPRB &
  &, 0.554472E-02_JPRB, 0.475853E-02_JPRB, 0.406685E-02_JPRB, 0.345813E-02_JPRB &
  &, 0.293917E-02_JPRB, 0.249680E-02_JPRB, 0.209565E-02_JPRB &
  &, 0.176031E-02_JPRB, 0.147419E-02_JPRB, 0.124100E-02_JPRB, 0.104216E-02_JPRB &
  &, 0.857304E-03_JPRB, 0.711040E-03_JPRB, 0.582204E-03_JPRB &
  &, 0.472112E-03_JPRB, 0.406919E-03_JPRB, 0.313590E-03_JPRB, 0.267969E-03_JPRB &
  &, 0.220404E-03_JPRB, 0.170861E-03_JPRB, 0.146629E-03_JPRB &
  &, 0.935418E-04_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 124, :) = (/ &
  &  0.885380E+00_JPRB, 0.857211E+00_JPRB, 0.829272E+00_JPRB, 0.801580E+00_JPRB &
  &, 0.774150E+00_JPRB, 0.747001E+00_JPRB, 0.720151E+00_JPRB &
  &, 0.693615E+00_JPRB, 0.667413E+00_JPRB, 0.641559E+00_JPRB, 0.616073E+00_JPRB &
  &, 0.590970E+00_JPRB, 0.566269E+00_JPRB, 0.541985E+00_JPRB &
  &, 0.518136E+00_JPRB, 0.494738E+00_JPRB, 0.471808E+00_JPRB, 0.449362E+00_JPRB &
  &, 0.427415E+00_JPRB, 0.405982E+00_JPRB, 0.385081E+00_JPRB &
  &, 0.364722E+00_JPRB, 0.344922E+00_JPRB, 0.325693E+00_JPRB, 0.307043E+00_JPRB &
  &, 0.288988E+00_JPRB, 0.271539E+00_JPRB, 0.254698E+00_JPRB &
  &, 0.238477E+00_JPRB, 0.222883E+00_JPRB, 0.207919E+00_JPRB, 0.193583E+00_JPRB &
  &, 0.179883E+00_JPRB, 0.166818E+00_JPRB, 0.154385E+00_JPRB &
  &, 0.142571E+00_JPRB, 0.131388E+00_JPRB, 0.120809E+00_JPRB, 0.110842E+00_JPRB &
  &, 0.101462E+00_JPRB, 0.926609E-01_JPRB, 0.844273E-01_JPRB &
  &, 0.767344E-01_JPRB, 0.695845E-01_JPRB, 0.629427E-01_JPRB, 0.567916E-01_JPRB &
  &, 0.511096E-01_JPRB, 0.458831E-01_JPRB, 0.410946E-01_JPRB &
  &, 0.366964E-01_JPRB, 0.326878E-01_JPRB, 0.290382E-01_JPRB, 0.257405E-01_JPRB &
  &, 0.227416E-01_JPRB, 0.200409E-01_JPRB, 0.176208E-01_JPRB &
  &, 0.154452E-01_JPRB, 0.135050E-01_JPRB, 0.117727E-01_JPRB, 0.102337E-01_JPRB &
  &, 0.887116E-02_JPRB, 0.766569E-02_JPRB, 0.661309E-02_JPRB &
  &, 0.568989E-02_JPRB, 0.486983E-02_JPRB, 0.416164E-02_JPRB, 0.355498E-02_JPRB &
  &, 0.301834E-02_JPRB, 0.255745E-02_JPRB, 0.215760E-02_JPRB &
  &, 0.182358E-02_JPRB, 0.153878E-02_JPRB, 0.128497E-02_JPRB, 0.106459E-02_JPRB &
  &, 0.880204E-03_JPRB, 0.734408E-03_JPRB, 0.606046E-03_JPRB &
  &, 0.496433E-03_JPRB, 0.406919E-03_JPRB, 0.338889E-03_JPRB, 0.267969E-03_JPRB &
  &, 0.220404E-03_JPRB, 0.170861E-03_JPRB, 0.146629E-03_JPRB &
  &, 0.121389E-03_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 125, :) = (/ &
  &  0.885831E+00_JPRB, 0.857764E+00_JPRB, 0.829920E+00_JPRB, 0.802319E+00_JPRB &
  &, 0.774976E+00_JPRB, 0.747909E+00_JPRB, 0.721134E+00_JPRB &
  &, 0.694670E+00_JPRB, 0.668533E+00_JPRB, 0.642741E+00_JPRB, 0.617311E+00_JPRB &
  &, 0.592260E+00_JPRB, 0.567605E+00_JPRB, 0.543361E+00_JPRB &
  &, 0.519549E+00_JPRB, 0.496183E+00_JPRB, 0.473279E+00_JPRB, 0.450856E+00_JPRB &
  &, 0.428926E+00_JPRB, 0.407505E+00_JPRB, 0.386612E+00_JPRB &
  &, 0.366257E+00_JPRB, 0.346455E+00_JPRB, 0.327220E+00_JPRB, 0.308564E+00_JPRB &
  &, 0.290494E+00_JPRB, 0.273025E+00_JPRB, 0.256164E+00_JPRB &
  &, 0.239920E+00_JPRB, 0.224297E+00_JPRB, 0.209298E+00_JPRB, 0.194930E+00_JPRB &
  &, 0.181195E+00_JPRB, 0.168088E+00_JPRB, 0.155614E+00_JPRB &
  &, 0.143762E+00_JPRB, 0.132523E+00_JPRB, 0.121904E+00_JPRB, 0.111884E+00_JPRB &
  &, 0.102459E+00_JPRB, 0.936093E-01_JPRB, 0.853239E-01_JPRB &
  &, 0.775871E-01_JPRB, 0.703905E-01_JPRB, 0.636990E-01_JPRB, 0.575070E-01_JPRB &
  &, 0.517817E-01_JPRB, 0.465091E-01_JPRB, 0.416590E-01_JPRB &
  &, 0.372352E-01_JPRB, 0.331857E-01_JPRB, 0.294930E-01_JPRB, 0.261498E-01_JPRB &
  &, 0.231174E-01_JPRB, 0.203959E-01_JPRB, 0.179388E-01_JPRB &
  &, 0.157242E-01_JPRB, 0.137587E-01_JPRB, 0.119998E-01_JPRB, 0.104329E-01_JPRB &
  &, 0.905789E-02_JPRB, 0.783929E-02_JPRB, 0.675510E-02_JPRB &
  &, 0.581692E-02_JPRB, 0.498112E-02_JPRB, 0.425642E-02_JPRB, 0.363247E-02_JPRB &
  &, 0.309751E-02_JPRB, 0.261811E-02_JPRB, 0.221955E-02_JPRB &
  &, 0.186575E-02_JPRB, 0.158185E-02_JPRB, 0.130695E-02_JPRB, 0.110947E-02_JPRB &
  &, 0.926004E-03_JPRB, 0.757776E-03_JPRB, 0.629888E-03_JPRB &
  &, 0.520755E-03_JPRB, 0.431727E-03_JPRB, 0.338889E-03_JPRB, 0.293766E-03_JPRB &
  &, 0.220404E-03_JPRB, 0.170861E-03_JPRB, 0.146629E-03_JPRB &
  &, 0.121389E-03_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.394477E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 126, :) = (/ &
  &  0.886281E+00_JPRB, 0.858314E+00_JPRB, 0.830566E+00_JPRB, 0.803055E+00_JPRB &
  &, 0.775798E+00_JPRB, 0.748811E+00_JPRB, 0.722113E+00_JPRB &
  &, 0.695720E+00_JPRB, 0.669649E+00_JPRB, 0.643918E+00_JPRB, 0.618545E+00_JPRB &
  &, 0.593544E+00_JPRB, 0.568935E+00_JPRB, 0.544733E+00_JPRB &
  &, 0.520957E+00_JPRB, 0.497624E+00_JPRB, 0.474747E+00_JPRB, 0.452344E+00_JPRB &
  &, 0.430432E+00_JPRB, 0.409025E+00_JPRB, 0.388139E+00_JPRB &
  &, 0.367789E+00_JPRB, 0.347985E+00_JPRB, 0.328744E+00_JPRB, 0.310077E+00_JPRB &
  &, 0.291996E+00_JPRB, 0.274511E+00_JPRB, 0.257629E+00_JPRB &
  &, 0.241358E+00_JPRB, 0.225708E+00_JPRB, 0.210678E+00_JPRB, 0.196277E+00_JPRB &
  &, 0.182507E+00_JPRB, 0.169362E+00_JPRB, 0.156844E+00_JPRB &
  &, 0.144943E+00_JPRB, 0.133667E+00_JPRB, 0.122999E+00_JPRB, 0.112937E+00_JPRB &
  &, 0.103466E+00_JPRB, 0.945683E-01_JPRB, 0.862314E-01_JPRB &
  &, 0.784509E-01_JPRB, 0.711965E-01_JPRB, 0.644552E-01_JPRB, 0.582106E-01_JPRB &
  &, 0.524415E-01_JPRB, 0.471226E-01_JPRB, 0.422490E-01_JPRB &
  &, 0.377607E-01_JPRB, 0.336837E-01_JPRB, 0.299479E-01_JPRB, 0.265732E-01_JPRB &
  &, 0.235076E-01_JPRB, 0.207362E-01_JPRB, 0.182568E-01_JPRB &
  &, 0.160186E-01_JPRB, 0.140124E-01_JPRB, 0.122270E-01_JPRB, 0.106486E-01_JPRB &
  &, 0.924462E-02_JPRB, 0.799553E-02_JPRB, 0.691485E-02_JPRB &
  &, 0.594395E-02_JPRB, 0.511096E-02_JPRB, 0.437017E-02_JPRB, 0.372933E-02_JPRB &
  &, 0.317667E-02_JPRB, 0.269898E-02_JPRB, 0.228150E-02_JPRB &
  &, 0.192902E-02_JPRB, 0.162491E-02_JPRB, 0.135091E-02_JPRB, 0.113191E-02_JPRB &
  &, 0.948904E-03_JPRB, 0.781144E-03_JPRB, 0.653730E-03_JPRB &
  &, 0.545077E-03_JPRB, 0.431727E-03_JPRB, 0.364189E-03_JPRB, 0.293766E-03_JPRB &
  &, 0.246705E-03_JPRB, 0.197671E-03_JPRB, 0.146629E-03_JPRB &
  &, 0.121389E-03_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART19

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART19',0,ZHOOK_HANDLE)

XCW( 127, :) = (/ &
  &  0.886728E+00_JPRB, 0.858861E+00_JPRB, 0.831208E+00_JPRB, 0.803788E+00_JPRB &
  &, 0.776615E+00_JPRB, 0.749710E+00_JPRB, 0.723087E+00_JPRB &
  &, 0.696765E+00_JPRB, 0.670760E+00_JPRB, 0.645091E+00_JPRB, 0.619773E+00_JPRB &
  &, 0.594823E+00_JPRB, 0.570261E+00_JPRB, 0.546101E+00_JPRB &
  &, 0.522361E+00_JPRB, 0.499059E+00_JPRB, 0.476209E+00_JPRB, 0.453829E+00_JPRB &
  &, 0.431933E+00_JPRB, 0.410538E+00_JPRB, 0.389660E+00_JPRB &
  &, 0.369314E+00_JPRB, 0.349511E+00_JPRB, 0.330264E+00_JPRB, 0.311590E+00_JPRB &
  &, 0.293495E+00_JPRB, 0.275994E+00_JPRB, 0.259091E+00_JPRB &
  &, 0.242797E+00_JPRB, 0.227118E+00_JPRB, 0.212058E+00_JPRB, 0.197624E+00_JPRB &
  &, 0.183819E+00_JPRB, 0.170636E+00_JPRB, 0.158077E+00_JPRB &
  &, 0.146133E+00_JPRB, 0.134812E+00_JPRB, 0.124104E+00_JPRB, 0.113990E+00_JPRB &
  &, 0.104463E+00_JPRB, 0.955273E-01_JPRB, 0.871389E-01_JPRB &
  &, 0.793147E-01_JPRB, 0.720138E-01_JPRB, 0.652231E-01_JPRB, 0.589379E-01_JPRB &
  &, 0.531135E-01_JPRB, 0.477486E-01_JPRB, 0.428262E-01_JPRB &
  &, 0.382995E-01_JPRB, 0.341817E-01_JPRB, 0.304165E-01_JPRB, 0.269967E-01_JPRB &
  &, 0.238977E-01_JPRB, 0.210913E-01_JPRB, 0.185748E-01_JPRB &
  &, 0.163131E-01_JPRB, 0.142820E-01_JPRB, 0.124703E-01_JPRB, 0.108644E-01_JPRB &
  &, 0.943134E-02_JPRB, 0.816913E-02_JPRB, 0.705685E-02_JPRB &
  &, 0.608912E-02_JPRB, 0.522226E-02_JPRB, 0.448391E-02_JPRB, 0.382619E-02_JPRB &
  &, 0.325584E-02_JPRB, 0.275963E-02_JPRB, 0.234345E-02_JPRB &
  &, 0.197119E-02_JPRB, 0.166798E-02_JPRB, 0.139488E-02_JPRB, 0.117678E-02_JPRB &
  &, 0.971804E-03_JPRB, 0.804512E-03_JPRB, 0.677572E-03_JPRB &
  &, 0.545077E-03_JPRB, 0.456534E-03_JPRB, 0.364189E-03_JPRB, 0.293766E-03_JPRB &
  &, 0.246705E-03_JPRB, 0.197671E-03_JPRB, 0.146629E-03_JPRB &
  &, 0.121389E-03_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 128, :) = (/ &
  &  0.887173E+00_JPRB, 0.859406E+00_JPRB, 0.831847E+00_JPRB, 0.804517E+00_JPRB &
  &, 0.777430E+00_JPRB, 0.750605E+00_JPRB, 0.724057E+00_JPRB &
  &, 0.697806E+00_JPRB, 0.671867E+00_JPRB, 0.646258E+00_JPRB, 0.620996E+00_JPRB &
  &, 0.596097E+00_JPRB, 0.571582E+00_JPRB, 0.547462E+00_JPRB &
  &, 0.523760E+00_JPRB, 0.500489E+00_JPRB, 0.477666E+00_JPRB, 0.455308E+00_JPRB &
  &, 0.433430E+00_JPRB, 0.412048E+00_JPRB, 0.391180E+00_JPRB &
  &, 0.370836E+00_JPRB, 0.351034E+00_JPRB, 0.331784E+00_JPRB, 0.313100E+00_JPRB &
  &, 0.294993E+00_JPRB, 0.277473E+00_JPRB, 0.260548E+00_JPRB &
  &, 0.244232E+00_JPRB, 0.228529E+00_JPRB, 0.213438E+00_JPRB, 0.198971E+00_JPRB &
  &, 0.185126E+00_JPRB, 0.171906E+00_JPRB, 0.159307E+00_JPRB &
  &, 0.147324E+00_JPRB, 0.135956E+00_JPRB, 0.125199E+00_JPRB, 0.115042E+00_JPRB &
  &, 0.105471E+00_JPRB, 0.964862E-01_JPRB, 0.880572E-01_JPRB &
  &, 0.801675E-01_JPRB, 0.728198E-01_JPRB, 0.659910E-01_JPRB, 0.596534E-01_JPRB &
  &, 0.537856E-01_JPRB, 0.483871E-01_JPRB, 0.434163E-01_JPRB &
  &, 0.388514E-01_JPRB, 0.346797E-01_JPRB, 0.308714E-01_JPRB, 0.274201E-01_JPRB &
  &, 0.242879E-01_JPRB, 0.214463E-01_JPRB, 0.188928E-01_JPRB &
  &, 0.166075E-01_JPRB, 0.145516E-01_JPRB, 0.127137E-01_JPRB, 0.110801E-01_JPRB &
  &, 0.963505E-02_JPRB, 0.834272E-02_JPRB, 0.721660E-02_JPRB &
  &, 0.621615E-02_JPRB, 0.535210E-02_JPRB, 0.457870E-02_JPRB, 0.392304E-02_JPRB &
  &, 0.333501E-02_JPRB, 0.284050E-02_JPRB, 0.240540E-02_JPRB &
  &, 0.203446E-02_JPRB, 0.171104E-02_JPRB, 0.143884E-02_JPRB, 0.119922E-02_JPRB &
  &, 0.994704E-03_JPRB, 0.827880E-03_JPRB, 0.701414E-03_JPRB &
  &, 0.569398E-03_JPRB, 0.481341E-03_JPRB, 0.389488E-03_JPRB, 0.319563E-03_JPRB &
  &, 0.246705E-03_JPRB, 0.197671E-03_JPRB, 0.173954E-03_JPRB &
  &, 0.121389E-03_JPRB, 0.951244E-04_JPRB, 0.678165E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 129, :) = (/ &
  &  0.887615E+00_JPRB, 0.859947E+00_JPRB, 0.832483E+00_JPRB, 0.805242E+00_JPRB &
  &, 0.778240E+00_JPRB, 0.751495E+00_JPRB, 0.725023E+00_JPRB &
  &, 0.698841E+00_JPRB, 0.672968E+00_JPRB, 0.647420E+00_JPRB, 0.622213E+00_JPRB &
  &, 0.597366E+00_JPRB, 0.572897E+00_JPRB, 0.548819E+00_JPRB &
  &, 0.525153E+00_JPRB, 0.501914E+00_JPRB, 0.479117E+00_JPRB, 0.456783E+00_JPRB &
  &, 0.434924E+00_JPRB, 0.413555E+00_JPRB, 0.392695E+00_JPRB &
  &, 0.372354E+00_JPRB, 0.352553E+00_JPRB, 0.333297E+00_JPRB, 0.314606E+00_JPRB &
  &, 0.296485E+00_JPRB, 0.278952E+00_JPRB, 0.262010E+00_JPRB &
  &, 0.245667E+00_JPRB, 0.229935E+00_JPRB, 0.214818E+00_JPRB, 0.200318E+00_JPRB &
  &, 0.186438E+00_JPRB, 0.173180E+00_JPRB, 0.160540E+00_JPRB &
  &, 0.148514E+00_JPRB, 0.137110E+00_JPRB, 0.126304E+00_JPRB, 0.116105E+00_JPRB &
  &, 0.106488E+00_JPRB, 0.974452E-01_JPRB, 0.889646E-01_JPRB &
  &, 0.810424E-01_JPRB, 0.736371E-01_JPRB, 0.667589E-01_JPRB, 0.603807E-01_JPRB &
  &, 0.544698E-01_JPRB, 0.490131E-01_JPRB, 0.439935E-01_JPRB &
  &, 0.393901E-01_JPRB, 0.351776E-01_JPRB, 0.313400E-01_JPRB, 0.278435E-01_JPRB &
  &, 0.246781E-01_JPRB, 0.218014E-01_JPRB, 0.192259E-01_JPRB &
  &, 0.169019E-01_JPRB, 0.148212E-01_JPRB, 0.129571E-01_JPRB, 0.112959E-01_JPRB &
  &, 0.982178E-02_JPRB, 0.851632E-02_JPRB, 0.737636E-02_JPRB &
  &, 0.636132E-02_JPRB, 0.546339E-02_JPRB, 0.469244E-02_JPRB, 0.401990E-02_JPRB &
  &, 0.341417E-02_JPRB, 0.290116E-02_JPRB, 0.246735E-02_JPRB &
  &, 0.207664E-02_JPRB, 0.175411E-02_JPRB, 0.148281E-02_JPRB, 0.124410E-02_JPRB &
  &, 0.104050E-02_JPRB, 0.851248E-03_JPRB, 0.725255E-03_JPRB &
  &, 0.593720E-03_JPRB, 0.481341E-03_JPRB, 0.389488E-03_JPRB, 0.319563E-03_JPRB &
  &, 0.273005E-03_JPRB, 0.224481E-03_JPRB, 0.173954E-03_JPRB &
  &, 0.149236E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 130, :) = (/ &
  &  0.888056E+00_JPRB, 0.860485E+00_JPRB, 0.833116E+00_JPRB, 0.805964E+00_JPRB &
  &, 0.779046E+00_JPRB, 0.752381E+00_JPRB, 0.725984E+00_JPRB &
  &, 0.699872E+00_JPRB, 0.674065E+00_JPRB, 0.648577E+00_JPRB, 0.623426E+00_JPRB &
  &, 0.598630E+00_JPRB, 0.574206E+00_JPRB, 0.550170E+00_JPRB &
  &, 0.526541E+00_JPRB, 0.503334E+00_JPRB, 0.480566E+00_JPRB, 0.458252E+00_JPRB &
  &, 0.436411E+00_JPRB, 0.415056E+00_JPRB, 0.394206E+00_JPRB &
  &, 0.373869E+00_JPRB, 0.354066E+00_JPRB, 0.334810E+00_JPRB, 0.316109E+00_JPRB &
  &, 0.297976E+00_JPRB, 0.280427E+00_JPRB, 0.263464E+00_JPRB &
  &, 0.247102E+00_JPRB, 0.231341E+00_JPRB, 0.216194E+00_JPRB, 0.201661E+00_JPRB &
  &, 0.187750E+00_JPRB, 0.174454E+00_JPRB, 0.161774E+00_JPRB &
  &, 0.149705E+00_JPRB, 0.138254E+00_JPRB, 0.127409E+00_JPRB, 0.117158E+00_JPRB &
  &, 0.107496E+00_JPRB, 0.984042E-01_JPRB, 0.898829E-01_JPRB &
  &, 0.819062E-01_JPRB, 0.744658E-01_JPRB, 0.675385E-01_JPRB, 0.611081E-01_JPRB &
  &, 0.551541E-01_JPRB, 0.496516E-01_JPRB, 0.445963E-01_JPRB &
  &, 0.399420E-01_JPRB, 0.356891E-01_JPRB, 0.318087E-01_JPRB, 0.282811E-01_JPRB &
  &, 0.250683E-01_JPRB, 0.221712E-01_JPRB, 0.195590E-01_JPRB &
  &, 0.171964E-01_JPRB, 0.150908E-01_JPRB, 0.132004E-01_JPRB, 0.115117E-01_JPRB &
  &, 0.100255E-01_JPRB, 0.870728E-02_JPRB, 0.753611E-02_JPRB &
  &, 0.650649E-02_JPRB, 0.559324E-02_JPRB, 0.480618E-02_JPRB, 0.411676E-02_JPRB &
  &, 0.351313E-02_JPRB, 0.298203E-02_JPRB, 0.252930E-02_JPRB &
  &, 0.213990E-02_JPRB, 0.181870E-02_JPRB, 0.152677E-02_JPRB, 0.126654E-02_JPRB &
  &, 0.106340E-02_JPRB, 0.897984E-03_JPRB, 0.749097E-03_JPRB &
  &, 0.618042E-03_JPRB, 0.506149E-03_JPRB, 0.414787E-03_JPRB, 0.345359E-03_JPRB &
  &, 0.273005E-03_JPRB, 0.224481E-03_JPRB, 0.173954E-03_JPRB &
  &, 0.149236E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.399930E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 131, :) = (/ &
  &  0.888493E+00_JPRB, 0.861022E+00_JPRB, 0.833745E+00_JPRB, 0.806683E+00_JPRB &
  &, 0.779849E+00_JPRB, 0.753263E+00_JPRB, 0.726940E+00_JPRB &
  &, 0.700899E+00_JPRB, 0.675156E+00_JPRB, 0.649729E+00_JPRB, 0.624635E+00_JPRB &
  &, 0.599890E+00_JPRB, 0.575512E+00_JPRB, 0.551517E+00_JPRB &
  &, 0.527924E+00_JPRB, 0.504750E+00_JPRB, 0.482008E+00_JPRB, 0.459718E+00_JPRB &
  &, 0.437896E+00_JPRB, 0.416553E+00_JPRB, 0.395710E+00_JPRB &
  &, 0.375381E+00_JPRB, 0.355578E+00_JPRB, 0.336316E+00_JPRB, 0.317608E+00_JPRB &
  &, 0.299467E+00_JPRB, 0.281899E+00_JPRB, 0.264918E+00_JPRB &
  &, 0.248533E+00_JPRB, 0.232748E+00_JPRB, 0.217574E+00_JPRB, 0.203008E+00_JPRB &
  &, 0.189058E+00_JPRB, 0.175724E+00_JPRB, 0.163008E+00_JPRB &
  &, 0.150905E+00_JPRB, 0.139408E+00_JPRB, 0.128514E+00_JPRB, 0.118221E+00_JPRB &
  &, 0.108513E+00_JPRB, 0.993737E-01_JPRB, 0.908012E-01_JPRB &
  &, 0.827811E-01_JPRB, 0.752831E-01_JPRB, 0.683064E-01_JPRB, 0.618354E-01_JPRB &
  &, 0.558384E-01_JPRB, 0.502901E-01_JPRB, 0.451864E-01_JPRB &
  &, 0.404938E-01_JPRB, 0.362005E-01_JPRB, 0.322773E-01_JPRB, 0.287186E-01_JPRB &
  &, 0.254729E-01_JPRB, 0.225411E-01_JPRB, 0.198922E-01_JPRB &
  &, 0.175063E-01_JPRB, 0.153604E-01_JPRB, 0.134438E-01_JPRB, 0.117440E-01_JPRB &
  &, 0.102292E-01_JPRB, 0.888088E-02_JPRB, 0.769586E-02_JPRB &
  &, 0.663352E-02_JPRB, 0.572308E-02_JPRB, 0.491993E-02_JPRB, 0.421362E-02_JPRB &
  &, 0.359230E-02_JPRB, 0.306290E-02_JPRB, 0.259125E-02_JPRB &
  &, 0.220316E-02_JPRB, 0.186177E-02_JPRB, 0.157074E-02_JPRB, 0.131141E-02_JPRB &
  &, 0.110920E-02_JPRB, 0.921352E-03_JPRB, 0.772939E-03_JPRB &
  &, 0.642363E-03_JPRB, 0.530956E-03_JPRB, 0.440086E-03_JPRB, 0.345359E-03_JPRB &
  &, 0.299306E-03_JPRB, 0.224481E-03_JPRB, 0.173954E-03_JPRB &
  &, 0.149236E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 132, :) = (/ &
  &  0.888929E+00_JPRB, 0.861556E+00_JPRB, 0.834372E+00_JPRB, 0.807398E+00_JPRB &
  &, 0.780648E+00_JPRB, 0.754141E+00_JPRB, 0.727893E+00_JPRB &
  &, 0.701922E+00_JPRB, 0.676244E+00_JPRB, 0.650877E+00_JPRB, 0.625838E+00_JPRB &
  &, 0.601143E+00_JPRB, 0.576811E+00_JPRB, 0.552860E+00_JPRB &
  &, 0.529303E+00_JPRB, 0.506159E+00_JPRB, 0.483446E+00_JPRB, 0.461179E+00_JPRB &
  &, 0.439374E+00_JPRB, 0.418047E+00_JPRB, 0.397215E+00_JPRB &
  &, 0.376890E+00_JPRB, 0.357087E+00_JPRB, 0.337823E+00_JPRB, 0.319107E+00_JPRB &
  &, 0.300951E+00_JPRB, 0.283370E+00_JPRB, 0.266372E+00_JPRB &
  &, 0.249964E+00_JPRB, 0.234154E+00_JPRB, 0.218949E+00_JPRB, 0.204351E+00_JPRB &
  &, 0.190370E+00_JPRB, 0.176998E+00_JPRB, 0.164242E+00_JPRB &
  &, 0.152095E+00_JPRB, 0.140562E+00_JPRB, 0.129619E+00_JPRB, 0.119283E+00_JPRB &
  &, 0.109520E+00_JPRB, 0.100343E+00_JPRB, 0.917195E-01_JPRB &
  &, 0.836560E-01_JPRB, 0.761118E-01_JPRB, 0.690859E-01_JPRB, 0.625628E-01_JPRB &
  &, 0.565226E-01_JPRB, 0.509286E-01_JPRB, 0.457892E-01_JPRB &
  &, 0.410588E-01_JPRB, 0.367254E-01_JPRB, 0.327597E-01_JPRB, 0.291562E-01_JPRB &
  &, 0.258775E-01_JPRB, 0.229109E-01_JPRB, 0.202253E-01_JPRB &
  &, 0.178163E-01_JPRB, 0.156458E-01_JPRB, 0.137034E-01_JPRB, 0.119764E-01_JPRB &
  &, 0.104329E-01_JPRB, 0.905448E-02_JPRB, 0.785561E-02_JPRB &
  &, 0.677869E-02_JPRB, 0.585292E-02_JPRB, 0.503367E-02_JPRB, 0.431047E-02_JPRB &
  &, 0.369126E-02_JPRB, 0.314377E-02_JPRB, 0.267385E-02_JPRB &
  &, 0.226643E-02_JPRB, 0.190483E-02_JPRB, 0.161470E-02_JPRB, 0.135629E-02_JPRB &
  &, 0.113210E-02_JPRB, 0.944720E-03_JPRB, 0.796781E-03_JPRB &
  &, 0.642363E-03_JPRB, 0.530956E-03_JPRB, 0.440086E-03_JPRB, 0.371156E-03_JPRB &
  &, 0.299306E-03_JPRB, 0.251291E-03_JPRB, 0.201280E-03_JPRB &
  &, 0.149236E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 133, :) = (/ &
  &  0.889363E+00_JPRB, 0.862087E+00_JPRB, 0.834996E+00_JPRB, 0.808109E+00_JPRB &
  &, 0.781443E+00_JPRB, 0.755015E+00_JPRB, 0.728841E+00_JPRB &
  &, 0.702940E+00_JPRB, 0.677327E+00_JPRB, 0.652020E+00_JPRB, 0.627037E+00_JPRB &
  &, 0.602393E+00_JPRB, 0.578107E+00_JPRB, 0.554197E+00_JPRB &
  &, 0.530678E+00_JPRB, 0.507566E+00_JPRB, 0.484880E+00_JPRB, 0.462636E+00_JPRB &
  &, 0.440849E+00_JPRB, 0.419535E+00_JPRB, 0.398713E+00_JPRB &
  &, 0.378395E+00_JPRB, 0.358593E+00_JPRB, 0.339325E+00_JPRB, 0.320603E+00_JPRB &
  &, 0.302435E+00_JPRB, 0.284842E+00_JPRB, 0.267822E+00_JPRB &
  &, 0.251392E+00_JPRB, 0.235557E+00_JPRB, 0.220325E+00_JPRB, 0.205698E+00_JPRB &
  &, 0.191682E+00_JPRB, 0.178272E+00_JPRB, 0.165480E+00_JPRB &
  &, 0.153295E+00_JPRB, 0.141707E+00_JPRB, 0.130734E+00_JPRB, 0.120346E+00_JPRB &
  &, 0.110538E+00_JPRB, 0.101313E+00_JPRB, 0.926486E-01_JPRB &
  &, 0.845309E-01_JPRB, 0.769404E-01_JPRB, 0.698771E-01_JPRB, 0.633021E-01_JPRB &
  &, 0.572069E-01_JPRB, 0.515797E-01_JPRB, 0.463921E-01_JPRB &
  &, 0.416107E-01_JPRB, 0.372368E-01_JPRB, 0.332422E-01_JPRB, 0.295937E-01_JPRB &
  &, 0.262822E-01_JPRB, 0.232807E-01_JPRB, 0.205584E-01_JPRB &
  &, 0.181107E-01_JPRB, 0.159154E-01_JPRB, 0.139467E-01_JPRB, 0.121921E-01_JPRB &
  &, 0.106366E-01_JPRB, 0.924544E-02_JPRB, 0.801536E-02_JPRB &
  &, 0.692386E-02_JPRB, 0.598276E-02_JPRB, 0.514741E-02_JPRB, 0.440733E-02_JPRB &
  &, 0.377043E-02_JPRB, 0.322464E-02_JPRB, 0.273580E-02_JPRB &
  &, 0.232969E-02_JPRB, 0.196943E-02_JPRB, 0.165866E-02_JPRB, 0.140117E-02_JPRB &
  &, 0.115500E-02_JPRB, 0.968088E-03_JPRB, 0.820623E-03_JPRB &
  &, 0.666685E-03_JPRB, 0.555764E-03_JPRB, 0.465385E-03_JPRB, 0.371156E-03_JPRB &
  &, 0.299306E-03_JPRB, 0.251291E-03_JPRB, 0.201280E-03_JPRB &
  &, 0.149236E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.688953E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART20

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART20',0,ZHOOK_HANDLE)

XCW( 134, :) = (/ &
  &  0.889795E+00_JPRB, 0.862614E+00_JPRB, 0.835616E+00_JPRB, 0.808818E+00_JPRB &
  &, 0.782235E+00_JPRB, 0.755885E+00_JPRB, 0.729786E+00_JPRB &
  &, 0.703954E+00_JPRB, 0.678405E+00_JPRB, 0.653158E+00_JPRB, 0.628230E+00_JPRB &
  &, 0.603638E+00_JPRB, 0.579399E+00_JPRB, 0.555528E+00_JPRB &
  &, 0.532047E+00_JPRB, 0.508968E+00_JPRB, 0.486310E+00_JPRB, 0.464088E+00_JPRB &
  &, 0.442321E+00_JPRB, 0.421023E+00_JPRB, 0.400208E+00_JPRB &
  &, 0.379894E+00_JPRB, 0.360096E+00_JPRB, 0.340825E+00_JPRB, 0.322095E+00_JPRB &
  &, 0.303919E+00_JPRB, 0.286306E+00_JPRB, 0.269272E+00_JPRB &
  &, 0.252819E+00_JPRB, 0.236959E+00_JPRB, 0.221697E+00_JPRB, 0.207041E+00_JPRB &
  &, 0.192989E+00_JPRB, 0.179546E+00_JPRB, 0.166714E+00_JPRB &
  &, 0.154486E+00_JPRB, 0.142861E+00_JPRB, 0.131839E+00_JPRB, 0.121409E+00_JPRB &
  &, 0.111566E+00_JPRB, 0.102293E+00_JPRB, 0.935777E-01_JPRB &
  &, 0.854057E-01_JPRB, 0.777804E-01_JPRB, 0.706566E-01_JPRB, 0.640413E-01_JPRB &
  &, 0.579033E-01_JPRB, 0.522307E-01_JPRB, 0.469950E-01_JPRB &
  &, 0.421757E-01_JPRB, 0.377617E-01_JPRB, 0.337246E-01_JPRB, 0.300454E-01_JPRB &
  &, 0.266868E-01_JPRB, 0.236506E-01_JPRB, 0.209067E-01_JPRB &
  &, 0.184362E-01_JPRB, 0.162008E-01_JPRB, 0.142063E-01_JPRB, 0.124245E-01_JPRB &
  &, 0.108403E-01_JPRB, 0.943640E-02_JPRB, 0.817512E-02_JPRB &
  &, 0.708718E-02_JPRB, 0.611261E-02_JPRB, 0.526116E-02_JPRB, 0.450419E-02_JPRB &
  &, 0.386938E-02_JPRB, 0.330552E-02_JPRB, 0.279775E-02_JPRB &
  &, 0.237187E-02_JPRB, 0.201249E-02_JPRB, 0.170263E-02_JPRB, 0.142360E-02_JPRB &
  &, 0.120080E-02_JPRB, 0.101482E-02_JPRB, 0.844465E-03_JPRB &
  &, 0.691007E-03_JPRB, 0.580571E-03_JPRB, 0.465385E-03_JPRB, 0.396953E-03_JPRB &
  &, 0.325606E-03_JPRB, 0.251291E-03_JPRB, 0.201280E-03_JPRB &
  &, 0.177084E-03_JPRB, 0.123499E-03_JPRB, 0.967247E-04_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 135, :) = (/ &
  &  0.890225E+00_JPRB, 0.863140E+00_JPRB, 0.836234E+00_JPRB, 0.809523E+00_JPRB &
  &, 0.783023E+00_JPRB, 0.756752E+00_JPRB, 0.730726E+00_JPRB &
  &, 0.704963E+00_JPRB, 0.679479E+00_JPRB, 0.654292E+00_JPRB, 0.629420E+00_JPRB &
  &, 0.604878E+00_JPRB, 0.580685E+00_JPRB, 0.556857E+00_JPRB &
  &, 0.533411E+00_JPRB, 0.510364E+00_JPRB, 0.487735E+00_JPRB, 0.465536E+00_JPRB &
  &, 0.443788E+00_JPRB, 0.422501E+00_JPRB, 0.401699E+00_JPRB &
  &, 0.381392E+00_JPRB, 0.361595E+00_JPRB, 0.342320E+00_JPRB, 0.323583E+00_JPRB &
  &, 0.305396E+00_JPRB, 0.287773E+00_JPRB, 0.270719E+00_JPRB &
  &, 0.254246E+00_JPRB, 0.238361E+00_JPRB, 0.223072E+00_JPRB, 0.208384E+00_JPRB &
  &, 0.194301E+00_JPRB, 0.180825E+00_JPRB, 0.167952E+00_JPRB &
  &, 0.155686E+00_JPRB, 0.144024E+00_JPRB, 0.132953E+00_JPRB, 0.122481E+00_JPRB &
  &, 0.112584E+00_JPRB, 0.103262E+00_JPRB, 0.945067E-01_JPRB &
  &, 0.862917E-01_JPRB, 0.786091E-01_JPRB, 0.714478E-01_JPRB, 0.647806E-01_JPRB &
  &, 0.585998E-01_JPRB, 0.528817E-01_JPRB, 0.476107E-01_JPRB &
  &, 0.427407E-01_JPRB, 0.382866E-01_JPRB, 0.342070E-01_JPRB, 0.304829E-01_JPRB &
  &, 0.271059E-01_JPRB, 0.240352E-01_JPRB, 0.212550E-01_JPRB &
  &, 0.187461E-01_JPRB, 0.164863E-01_JPRB, 0.144659E-01_JPRB, 0.126568E-01_JPRB &
  &, 0.110610E-01_JPRB, 0.962735E-02_JPRB, 0.835262E-02_JPRB &
  &, 0.723236E-02_JPRB, 0.624245E-02_JPRB, 0.537490E-02_JPRB, 0.462042E-02_JPRB &
  &, 0.394855E-02_JPRB, 0.338639E-02_JPRB, 0.288035E-02_JPRB &
  &, 0.243513E-02_JPRB, 0.207709E-02_JPRB, 0.174659E-02_JPRB, 0.146848E-02_JPRB &
  &, 0.122371E-02_JPRB, 0.103819E-02_JPRB, 0.868307E-03_JPRB &
  &, 0.715328E-03_JPRB, 0.605379E-03_JPRB, 0.490684E-03_JPRB, 0.396953E-03_JPRB &
  &, 0.325606E-03_JPRB, 0.278102E-03_JPRB, 0.228606E-03_JPRB &
  &, 0.177084E-03_JPRB, 0.151874E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 136, :) = (/ &
  &  0.890652E+00_JPRB, 0.863664E+00_JPRB, 0.836849E+00_JPRB, 0.810225E+00_JPRB &
  &, 0.783807E+00_JPRB, 0.757614E+00_JPRB, 0.731662E+00_JPRB &
  &, 0.705967E+00_JPRB, 0.680549E+00_JPRB, 0.655422E+00_JPRB, 0.630605E+00_JPRB &
  &, 0.606113E+00_JPRB, 0.581967E+00_JPRB, 0.558180E+00_JPRB &
  &, 0.534770E+00_JPRB, 0.511757E+00_JPRB, 0.489155E+00_JPRB, 0.466981E+00_JPRB &
  &, 0.445251E+00_JPRB, 0.423980E+00_JPRB, 0.403187E+00_JPRB &
  &, 0.382884E+00_JPRB, 0.363090E+00_JPRB, 0.343813E+00_JPRB, 0.325072E+00_JPRB &
  &, 0.306873E+00_JPRB, 0.289234E+00_JPRB, 0.272165E+00_JPRB &
  &, 0.255669E+00_JPRB, 0.239764E+00_JPRB, 0.224448E+00_JPRB, 0.209727E+00_JPRB &
  &, 0.195613E+00_JPRB, 0.182099E+00_JPRB, 0.169190E+00_JPRB &
  &, 0.156886E+00_JPRB, 0.145178E+00_JPRB, 0.134068E+00_JPRB, 0.123544E+00_JPRB &
  &, 0.113611E+00_JPRB, 0.104242E+00_JPRB, 0.954358E-01_JPRB &
  &, 0.871777E-01_JPRB, 0.794491E-01_JPRB, 0.722389E-01_JPRB, 0.655318E-01_JPRB &
  &, 0.593085E-01_JPRB, 0.535453E-01_JPRB, 0.482135E-01_JPRB &
  &, 0.433189E-01_JPRB, 0.388249E-01_JPRB, 0.347032E-01_JPRB, 0.309346E-01_JPRB &
  &, 0.275250E-01_JPRB, 0.244199E-01_JPRB, 0.216033E-01_JPRB &
  &, 0.190561E-01_JPRB, 0.167876E-01_JPRB, 0.147255E-01_JPRB, 0.129058E-01_JPRB &
  &, 0.112647E-01_JPRB, 0.981831E-02_JPRB, 0.853012E-02_JPRB &
  &, 0.737753E-02_JPRB, 0.637229E-02_JPRB, 0.548865E-02_JPRB, 0.471727E-02_JPRB &
  &, 0.404751E-02_JPRB, 0.346726E-02_JPRB, 0.294230E-02_JPRB &
  &, 0.249840E-02_JPRB, 0.212015E-02_JPRB, 0.179056E-02_JPRB, 0.151336E-02_JPRB &
  &, 0.126951E-02_JPRB, 0.106156E-02_JPRB, 0.892148E-03_JPRB &
  &, 0.739650E-03_JPRB, 0.605379E-03_JPRB, 0.515984E-03_JPRB, 0.422750E-03_JPRB &
  &, 0.351907E-03_JPRB, 0.278102E-03_JPRB, 0.228606E-03_JPRB &
  &, 0.177084E-03_JPRB, 0.151874E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.405444E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 137, :) = (/ &
  &  0.891078E+00_JPRB, 0.864185E+00_JPRB, 0.837461E+00_JPRB, 0.810924E+00_JPRB &
  &, 0.784589E+00_JPRB, 0.758473E+00_JPRB, 0.732594E+00_JPRB &
  &, 0.706969E+00_JPRB, 0.681614E+00_JPRB, 0.656547E+00_JPRB, 0.631785E+00_JPRB &
  &, 0.607344E+00_JPRB, 0.583243E+00_JPRB, 0.559499E+00_JPRB &
  &, 0.536126E+00_JPRB, 0.513145E+00_JPRB, 0.490570E+00_JPRB, 0.468421E+00_JPRB &
  &, 0.446709E+00_JPRB, 0.425455E+00_JPRB, 0.404672E+00_JPRB &
  &, 0.384376E+00_JPRB, 0.364583E+00_JPRB, 0.345305E+00_JPRB, 0.326557E+00_JPRB &
  &, 0.308350E+00_JPRB, 0.290698E+00_JPRB, 0.273607E+00_JPRB &
  &, 0.257093E+00_JPRB, 0.241162E+00_JPRB, 0.225820E+00_JPRB, 0.211070E+00_JPRB &
  &, 0.196920E+00_JPRB, 0.183373E+00_JPRB, 0.170429E+00_JPRB &
  &, 0.158086E+00_JPRB, 0.146332E+00_JPRB, 0.135183E+00_JPRB, 0.124617E+00_JPRB &
  &, 0.114639E+00_JPRB, 0.105222E+00_JPRB, 0.963757E-01_JPRB &
  &, 0.880636E-01_JPRB, 0.802892E-01_JPRB, 0.730418E-01_JPRB, 0.662830E-01_JPRB &
  &, 0.600050E-01_JPRB, 0.541963E-01_JPRB, 0.488292E-01_JPRB &
  &, 0.438970E-01_JPRB, 0.393498E-01_JPRB, 0.351994E-01_JPRB, 0.314004E-01_JPRB &
  &, 0.279440E-01_JPRB, 0.248045E-01_JPRB, 0.219516E-01_JPRB &
  &, 0.193815E-01_JPRB, 0.170730E-01_JPRB, 0.150013E-01_JPRB, 0.131382E-01_JPRB &
  &, 0.114854E-01_JPRB, 0.100093E-01_JPRB, 0.868987E-02_JPRB &
  &, 0.754085E-02_JPRB, 0.652068E-02_JPRB, 0.562135E-02_JPRB, 0.483350E-02_JPRB &
  &, 0.414647E-02_JPRB, 0.354813E-02_JPRB, 0.302490E-02_JPRB &
  &, 0.256166E-02_JPRB, 0.218475E-02_JPRB, 0.183452E-02_JPRB, 0.155823E-02_JPRB &
  &, 0.131531E-02_JPRB, 0.108493E-02_JPRB, 0.915990E-03_JPRB &
  &, 0.763972E-03_JPRB, 0.630186E-03_JPRB, 0.515984E-03_JPRB, 0.422750E-03_JPRB &
  &, 0.351907E-03_JPRB, 0.278102E-03_JPRB, 0.228606E-03_JPRB &
  &, 0.177084E-03_JPRB, 0.151874E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 138, :) = (/ &
  &  0.891501E+00_JPRB, 0.864704E+00_JPRB, 0.838071E+00_JPRB, 0.811620E+00_JPRB &
  &, 0.785366E+00_JPRB, 0.759329E+00_JPRB, 0.733523E+00_JPRB &
  &, 0.707966E+00_JPRB, 0.682675E+00_JPRB, 0.657668E+00_JPRB, 0.632960E+00_JPRB &
  &, 0.608570E+00_JPRB, 0.584515E+00_JPRB, 0.560812E+00_JPRB &
  &, 0.537478E+00_JPRB, 0.514528E+00_JPRB, 0.491983E+00_JPRB, 0.469856E+00_JPRB &
  &, 0.448164E+00_JPRB, 0.426924E+00_JPRB, 0.406151E+00_JPRB &
  &, 0.385862E+00_JPRB, 0.366072E+00_JPRB, 0.346790E+00_JPRB, 0.328038E+00_JPRB &
  &, 0.309823E+00_JPRB, 0.292154E+00_JPRB, 0.275050E+00_JPRB &
  &, 0.258516E+00_JPRB, 0.242561E+00_JPRB, 0.227192E+00_JPRB, 0.212412E+00_JPRB &
  &, 0.198232E+00_JPRB, 0.184652E+00_JPRB, 0.171667E+00_JPRB &
  &, 0.159285E+00_JPRB, 0.147496E+00_JPRB, 0.136298E+00_JPRB, 0.125690E+00_JPRB &
  &, 0.115667E+00_JPRB, 0.106213E+00_JPRB, 0.973048E-01_JPRB &
  &, 0.889607E-01_JPRB, 0.811406E-01_JPRB, 0.738329E-01_JPRB, 0.670342E-01_JPRB &
  &, 0.607137E-01_JPRB, 0.548599E-01_JPRB, 0.494577E-01_JPRB &
  &, 0.444752E-01_JPRB, 0.398882E-01_JPRB, 0.356956E-01_JPRB, 0.318520E-01_JPRB &
  &, 0.283631E-01_JPRB, 0.251892E-01_JPRB, 0.223150E-01_JPRB &
  &, 0.197069E-01_JPRB, 0.173743E-01_JPRB, 0.152609E-01_JPRB, 0.133871E-01_JPRB &
  &, 0.117060E-01_JPRB, 0.102002E-01_JPRB, 0.886738E-02_JPRB &
  &, 0.770417E-02_JPRB, 0.665053E-02_JPRB, 0.573509E-02_JPRB, 0.494973E-02_JPRB &
  &, 0.424543E-02_JPRB, 0.362900E-02_JPRB, 0.310750E-02_JPRB &
  &, 0.264601E-02_JPRB, 0.222781E-02_JPRB, 0.190047E-02_JPRB, 0.160311E-02_JPRB &
  &, 0.133821E-02_JPRB, 0.113166E-02_JPRB, 0.939832E-03_JPRB &
  &, 0.788293E-03_JPRB, 0.654994E-03_JPRB, 0.541283E-03_JPRB, 0.448547E-03_JPRB &
  &, 0.378208E-03_JPRB, 0.304912E-03_JPRB, 0.255932E-03_JPRB &
  &, 0.204931E-03_JPRB, 0.151874E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 139, :) = (/ &
  &  0.891922E+00_JPRB, 0.865220E+00_JPRB, 0.838677E+00_JPRB, 0.812312E+00_JPRB &
  &, 0.786141E+00_JPRB, 0.760180E+00_JPRB, 0.734447E+00_JPRB &
  &, 0.708959E+00_JPRB, 0.683732E+00_JPRB, 0.658783E+00_JPRB, 0.634133E+00_JPRB &
  &, 0.609792E+00_JPRB, 0.585784E+00_JPRB, 0.562122E+00_JPRB &
  &, 0.538824E+00_JPRB, 0.515909E+00_JPRB, 0.493390E+00_JPRB, 0.471287E+00_JPRB &
  &, 0.449616E+00_JPRB, 0.428389E+00_JPRB, 0.407630E+00_JPRB &
  &, 0.387347E+00_JPRB, 0.367557E+00_JPRB, 0.348276E+00_JPRB, 0.329516E+00_JPRB &
  &, 0.311292E+00_JPRB, 0.293615E+00_JPRB, 0.276492E+00_JPRB &
  &, 0.259939E+00_JPRB, 0.243959E+00_JPRB, 0.228563E+00_JPRB, 0.213755E+00_JPRB &
  &, 0.199544E+00_JPRB, 0.185926E+00_JPRB, 0.172905E+00_JPRB &
  &, 0.160485E+00_JPRB, 0.148659E+00_JPRB, 0.137422E+00_JPRB, 0.126772E+00_JPRB &
  &, 0.116695E+00_JPRB, 0.107193E+00_JPRB, 0.982447E-01_JPRB &
  &, 0.898466E-01_JPRB, 0.819806E-01_JPRB, 0.746357E-01_JPRB, 0.677855E-01_JPRB &
  &, 0.614224E-01_JPRB, 0.555234E-01_JPRB, 0.500734E-01_JPRB &
  &, 0.450534E-01_JPRB, 0.404265E-01_JPRB, 0.361919E-01_JPRB, 0.323178E-01_JPRB &
  &, 0.287822E-01_JPRB, 0.255738E-01_JPRB, 0.226633E-01_JPRB &
  &, 0.200324E-01_JPRB, 0.176597E-01_JPRB, 0.155367E-01_JPRB, 0.136195E-01_JPRB &
  &, 0.119267E-01_JPRB, 0.104085E-01_JPRB, 0.904488E-02_JPRB &
  &, 0.784934E-02_JPRB, 0.679892E-02_JPRB, 0.586779E-02_JPRB, 0.504659E-02_JPRB &
  &, 0.434439E-02_JPRB, 0.370987E-02_JPRB, 0.316945E-02_JPRB &
  &, 0.270928E-02_JPRB, 0.229241E-02_JPRB, 0.194443E-02_JPRB, 0.164799E-02_JPRB &
  &, 0.138401E-02_JPRB, 0.115503E-02_JPRB, 0.963674E-03_JPRB &
  &, 0.812615E-03_JPRB, 0.679801E-03_JPRB, 0.566582E-03_JPRB, 0.448547E-03_JPRB &
  &, 0.378208E-03_JPRB, 0.304912E-03_JPRB, 0.255932E-03_JPRB &
  &, 0.204931E-03_JPRB, 0.151874E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.699861E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 140, :) = (/ &
  &  0.892341E+00_JPRB, 0.865734E+00_JPRB, 0.839281E+00_JPRB, 0.813002E+00_JPRB &
  &, 0.786912E+00_JPRB, 0.761028E+00_JPRB, 0.735368E+00_JPRB &
  &, 0.709948E+00_JPRB, 0.684785E+00_JPRB, 0.659896E+00_JPRB, 0.635300E+00_JPRB &
  &, 0.611011E+00_JPRB, 0.587047E+00_JPRB, 0.563428E+00_JPRB &
  &, 0.540167E+00_JPRB, 0.517284E+00_JPRB, 0.494793E+00_JPRB, 0.472715E+00_JPRB &
  &, 0.451063E+00_JPRB, 0.429852E+00_JPRB, 0.409102E+00_JPRB &
  &, 0.388826E+00_JPRB, 0.369042E+00_JPRB, 0.349758E+00_JPRB, 0.330994E+00_JPRB &
  &, 0.312762E+00_JPRB, 0.295068E+00_JPRB, 0.277931E+00_JPRB &
  &, 0.261358E+00_JPRB, 0.245358E+00_JPRB, 0.229935E+00_JPRB, 0.215098E+00_JPRB &
  &, 0.200856E+00_JPRB, 0.187205E+00_JPRB, 0.174148E+00_JPRB &
  &, 0.161685E+00_JPRB, 0.149813E+00_JPRB, 0.138537E+00_JPRB, 0.127845E+00_JPRB &
  &, 0.117733E+00_JPRB, 0.108184E+00_JPRB, 0.991954E-01_JPRB &
  &, 0.907437E-01_JPRB, 0.828320E-01_JPRB, 0.754385E-01_JPRB, 0.685486E-01_JPRB &
  &, 0.621433E-01_JPRB, 0.561995E-01_JPRB, 0.507019E-01_JPRB &
  &, 0.456315E-01_JPRB, 0.409783E-01_JPRB, 0.367018E-01_JPRB, 0.327836E-01_JPRB &
  &, 0.292157E-01_JPRB, 0.259732E-01_JPRB, 0.230267E-01_JPRB &
  &, 0.203733E-01_JPRB, 0.179610E-01_JPRB, 0.158125E-01_JPRB, 0.138684E-01_JPRB &
  &, 0.121474E-01_JPRB, 0.105995E-01_JPRB, 0.924013E-02_JPRB &
  &, 0.801266E-02_JPRB, 0.694731E-02_JPRB, 0.600049E-02_JPRB, 0.516282E-02_JPRB &
  &, 0.444334E-02_JPRB, 0.381096E-02_JPRB, 0.325205E-02_JPRB &
  &, 0.277254E-02_JPRB, 0.235701E-02_JPRB, 0.198840E-02_JPRB, 0.169286E-02_JPRB &
  &, 0.142981E-02_JPRB, 0.120177E-02_JPRB, 0.101136E-02_JPRB &
  &, 0.836937E-03_JPRB, 0.704608E-03_JPRB, 0.566582E-03_JPRB, 0.474344E-03_JPRB &
  &, 0.404508E-03_JPRB, 0.331722E-03_JPRB, 0.255932E-03_JPRB &
  &, 0.204931E-03_JPRB, 0.180249E-03_JPRB, 0.125633E-03_JPRB, 0.983430E-04_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART21

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART21',0,ZHOOK_HANDLE)

XCW( 141, :) = (/ &
  &  0.892760E+00_JPRB, 0.866246E+00_JPRB, 0.839882E+00_JPRB, 0.813689E+00_JPRB &
  &, 0.787680E+00_JPRB, 0.761873E+00_JPRB, 0.736285E+00_JPRB &
  &, 0.710933E+00_JPRB, 0.685834E+00_JPRB, 0.661005E+00_JPRB, 0.636463E+00_JPRB &
  &, 0.612224E+00_JPRB, 0.588307E+00_JPRB, 0.564728E+00_JPRB &
  &, 0.541506E+00_JPRB, 0.518654E+00_JPRB, 0.496194E+00_JPRB, 0.474138E+00_JPRB &
  &, 0.452505E+00_JPRB, 0.431311E+00_JPRB, 0.410574E+00_JPRB &
  &, 0.390304E+00_JPRB, 0.370521E+00_JPRB, 0.351240E+00_JPRB, 0.332468E+00_JPRB &
  &, 0.314228E+00_JPRB, 0.296524E+00_JPRB, 0.279370E+00_JPRB &
  &, 0.262778E+00_JPRB, 0.246752E+00_JPRB, 0.231307E+00_JPRB, 0.216441E+00_JPRB &
  &, 0.202164E+00_JPRB, 0.188479E+00_JPRB, 0.175391E+00_JPRB &
  &, 0.162885E+00_JPRB, 0.150976E+00_JPRB, 0.139661E+00_JPRB, 0.128928E+00_JPRB &
  &, 0.118761E+00_JPRB, 0.109174E+00_JPRB, 0.100135E+00_JPRB &
  &, 0.916518E-01_JPRB, 0.836947E-01_JPRB, 0.762530E-01_JPRB, 0.693117E-01_JPRB &
  &, 0.628642E-01_JPRB, 0.568756E-01_JPRB, 0.513305E-01_JPRB &
  &, 0.462228E-01_JPRB, 0.415167E-01_JPRB, 0.371981E-01_JPRB, 0.332493E-01_JPRB &
  &, 0.296493E-01_JPRB, 0.263727E-01_JPRB, 0.233901E-01_JPRB &
  &, 0.206988E-01_JPRB, 0.182782E-01_JPRB, 0.160884E-01_JPRB, 0.141174E-01_JPRB &
  &, 0.123681E-01_JPRB, 0.108078E-01_JPRB, 0.941763E-02_JPRB &
  &, 0.817598E-02_JPRB, 0.709570E-02_JPRB, 0.613319E-02_JPRB, 0.527905E-02_JPRB &
  &, 0.454230E-02_JPRB, 0.389183E-02_JPRB, 0.333465E-02_JPRB &
  &, 0.283581E-02_JPRB, 0.242160E-02_JPRB, 0.205434E-02_JPRB, 0.173774E-02_JPRB &
  &, 0.145271E-02_JPRB, 0.122514E-02_JPRB, 0.103520E-02_JPRB &
  &, 0.861258E-03_JPRB, 0.704608E-03_JPRB, 0.591881E-03_JPRB, 0.500141E-03_JPRB &
  &, 0.404508E-03_JPRB, 0.331722E-03_JPRB, 0.283257E-03_JPRB &
  &, 0.232778E-03_JPRB, 0.180249E-03_JPRB, 0.154541E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 142, :) = (/ &
  &  0.893175E+00_JPRB, 0.866754E+00_JPRB, 0.840481E+00_JPRB, 0.814373E+00_JPRB &
  &, 0.788445E+00_JPRB, 0.762715E+00_JPRB, 0.737198E+00_JPRB &
  &, 0.711914E+00_JPRB, 0.686879E+00_JPRB, 0.662109E+00_JPRB, 0.637622E+00_JPRB &
  &, 0.613434E+00_JPRB, 0.589562E+00_JPRB, 0.566026E+00_JPRB &
  &, 0.542839E+00_JPRB, 0.520022E+00_JPRB, 0.497589E+00_JPRB, 0.475559E+00_JPRB &
  &, 0.453946E+00_JPRB, 0.432767E+00_JPRB, 0.412039E+00_JPRB &
  &, 0.391780E+00_JPRB, 0.372000E+00_JPRB, 0.352714E+00_JPRB, 0.333942E+00_JPRB &
  &, 0.315690E+00_JPRB, 0.297973E+00_JPRB, 0.280805E+00_JPRB &
  &, 0.264193E+00_JPRB, 0.248146E+00_JPRB, 0.232674E+00_JPRB, 0.217784E+00_JPRB &
  &, 0.203475E+00_JPRB, 0.189757E+00_JPRB, 0.176629E+00_JPRB &
  &, 0.164094E+00_JPRB, 0.152150E+00_JPRB, 0.140786E+00_JPRB, 0.130011E+00_JPRB &
  &, 0.119799E+00_JPRB, 0.110165E+00_JPRB, 0.101086E+00_JPRB &
  &, 0.925488E-01_JPRB, 0.845461E-01_JPRB, 0.770558E-01_JPRB, 0.700748E-01_JPRB &
  &, 0.635852E-01_JPRB, 0.575517E-01_JPRB, 0.519718E-01_JPRB &
  &, 0.468141E-01_JPRB, 0.420685E-01_JPRB, 0.377080E-01_JPRB, 0.337292E-01_JPRB &
  &, 0.300828E-01_JPRB, 0.267721E-01_JPRB, 0.237687E-01_JPRB &
  &, 0.210397E-01_JPRB, 0.185795E-01_JPRB, 0.163642E-01_JPRB, 0.143829E-01_JPRB &
  &, 0.126057E-01_JPRB, 0.110161E-01_JPRB, 0.959514E-02_JPRB &
  &, 0.833930E-02_JPRB, 0.724409E-02_JPRB, 0.626589E-02_JPRB, 0.539528E-02_JPRB &
  &, 0.464126E-02_JPRB, 0.399292E-02_JPRB, 0.341725E-02_JPRB &
  &, 0.292016E-02_JPRB, 0.248620E-02_JPRB, 0.209831E-02_JPRB, 0.178261E-02_JPRB &
  &, 0.149851E-02_JPRB, 0.127187E-02_JPRB, 0.105904E-02_JPRB &
  &, 0.885580E-03_JPRB, 0.729416E-03_JPRB, 0.617180E-03_JPRB, 0.500141E-03_JPRB &
  &, 0.430809E-03_JPRB, 0.331722E-03_JPRB, 0.283257E-03_JPRB &
  &, 0.232778E-03_JPRB, 0.180249E-03_JPRB, 0.154541E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.411017E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 143, :) = (/ &
  &  0.893589E+00_JPRB, 0.867262E+00_JPRB, 0.841077E+00_JPRB, 0.815054E+00_JPRB &
  &, 0.789206E+00_JPRB, 0.763552E+00_JPRB, 0.738109E+00_JPRB &
  &, 0.712892E+00_JPRB, 0.687920E+00_JPRB, 0.663209E+00_JPRB, 0.638777E+00_JPRB &
  &, 0.614639E+00_JPRB, 0.590814E+00_JPRB, 0.567318E+00_JPRB &
  &, 0.544170E+00_JPRB, 0.521385E+00_JPRB, 0.498981E+00_JPRB, 0.476974E+00_JPRB &
  &, 0.455382E+00_JPRB, 0.434217E+00_JPRB, 0.413502E+00_JPRB &
  &, 0.393249E+00_JPRB, 0.373472E+00_JPRB, 0.354189E+00_JPRB, 0.335413E+00_JPRB &
  &, 0.317152E+00_JPRB, 0.299426E+00_JPRB, 0.282240E+00_JPRB &
  &, 0.265609E+00_JPRB, 0.249541E+00_JPRB, 0.234046E+00_JPRB, 0.219127E+00_JPRB &
  &, 0.204787E+00_JPRB, 0.191036E+00_JPRB, 0.177872E+00_JPRB &
  &, 0.165294E+00_JPRB, 0.153313E+00_JPRB, 0.141910E+00_JPRB, 0.131093E+00_JPRB &
  &, 0.120837E+00_JPRB, 0.111166E+00_JPRB, 0.102037E+00_JPRB &
  &, 0.934569E-01_JPRB, 0.854088E-01_JPRB, 0.778702E-01_JPRB, 0.708499E-01_JPRB &
  &, 0.643061E-01_JPRB, 0.582278E-01_JPRB, 0.526003E-01_JPRB &
  &, 0.474054E-01_JPRB, 0.426203E-01_JPRB, 0.382318E-01_JPRB, 0.342091E-01_JPRB &
  &, 0.305308E-01_JPRB, 0.271715E-01_JPRB, 0.241321E-01_JPRB &
  &, 0.213806E-01_JPRB, 0.188808E-01_JPRB, 0.166400E-01_JPRB, 0.146319E-01_JPRB &
  &, 0.128264E-01_JPRB, 0.112245E-01_JPRB, 0.979039E-02_JPRB &
  &, 0.852077E-02_JPRB, 0.739248E-02_JPRB, 0.639859E-02_JPRB, 0.551151E-02_JPRB &
  &, 0.476001E-02_JPRB, 0.407380E-02_JPRB, 0.349985E-02_JPRB &
  &, 0.298342E-02_JPRB, 0.252926E-02_JPRB, 0.216425E-02_JPRB, 0.182749E-02_JPRB &
  &, 0.154431E-02_JPRB, 0.129524E-02_JPRB, 0.108288E-02_JPRB &
  &, 0.909902E-03_JPRB, 0.754223E-03_JPRB, 0.642480E-03_JPRB, 0.525938E-03_JPRB &
  &, 0.430809E-03_JPRB, 0.358532E-03_JPRB, 0.283257E-03_JPRB &
  &, 0.232778E-03_JPRB, 0.180249E-03_JPRB, 0.154541E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 144, :) = (/ &
  &  0.894001E+00_JPRB, 0.867766E+00_JPRB, 0.841671E+00_JPRB, 0.815732E+00_JPRB &
  &, 0.789964E+00_JPRB, 0.764387E+00_JPRB, 0.739015E+00_JPRB &
  &, 0.713866E+00_JPRB, 0.688957E+00_JPRB, 0.664305E+00_JPRB, 0.639927E+00_JPRB &
  &, 0.615839E+00_JPRB, 0.592061E+00_JPRB, 0.568607E+00_JPRB &
  &, 0.545496E+00_JPRB, 0.522744E+00_JPRB, 0.500368E+00_JPRB, 0.478386E+00_JPRB &
  &, 0.456814E+00_JPRB, 0.435667E+00_JPRB, 0.414964E+00_JPRB &
  &, 0.394717E+00_JPRB, 0.374944E+00_JPRB, 0.355661E+00_JPRB, 0.336880E+00_JPRB &
  &, 0.318611E+00_JPRB, 0.300872E+00_JPRB, 0.283675E+00_JPRB &
  &, 0.267024E+00_JPRB, 0.250935E+00_JPRB, 0.235413E+00_JPRB, 0.220465E+00_JPRB &
  &, 0.206099E+00_JPRB, 0.192315E+00_JPRB, 0.179119E+00_JPRB &
  &, 0.166503E+00_JPRB, 0.154476E+00_JPRB, 0.143035E+00_JPRB, 0.132176E+00_JPRB &
  &, 0.121886E+00_JPRB, 0.112156E+00_JPRB, 0.102987E+00_JPRB &
  &, 0.943650E-01_JPRB, 0.862715E-01_JPRB, 0.786963E-01_JPRB, 0.716130E-01_JPRB &
  &, 0.650270E-01_JPRB, 0.589163E-01_JPRB, 0.532417E-01_JPRB &
  &, 0.480098E-01_JPRB, 0.431856E-01_JPRB, 0.387418E-01_JPRB, 0.346749E-01_JPRB &
  &, 0.309643E-01_JPRB, 0.275858E-01_JPRB, 0.245106E-01_JPRB &
  &, 0.217216E-01_JPRB, 0.191979E-01_JPRB, 0.169320E-01_JPRB, 0.148974E-01_JPRB &
  &, 0.130641E-01_JPRB, 0.114328E-01_JPRB, 0.996789E-02_JPRB &
  &, 0.868409E-02_JPRB, 0.754088E-02_JPRB, 0.653129E-02_JPRB, 0.564711E-02_JPRB &
  &, 0.485897E-02_JPRB, 0.417488E-02_JPRB, 0.358245E-02_JPRB &
  &, 0.304669E-02_JPRB, 0.259386E-02_JPRB, 0.220822E-02_JPRB, 0.187237E-02_JPRB &
  &, 0.159011E-02_JPRB, 0.134198E-02_JPRB, 0.113057E-02_JPRB &
  &, 0.934223E-03_JPRB, 0.779031E-03_JPRB, 0.642480E-03_JPRB, 0.551734E-03_JPRB &
  &, 0.457109E-03_JPRB, 0.358532E-03_JPRB, 0.310583E-03_JPRB &
  &, 0.232778E-03_JPRB, 0.208623E-03_JPRB, 0.154541E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 145, :) = (/ &
  &  0.894411E+00_JPRB, 0.868269E+00_JPRB, 0.842262E+00_JPRB, 0.816407E+00_JPRB &
  &, 0.790720E+00_JPRB, 0.765218E+00_JPRB, 0.739918E+00_JPRB &
  &, 0.714836E+00_JPRB, 0.689990E+00_JPRB, 0.665397E+00_JPRB, 0.641074E+00_JPRB &
  &, 0.617037E+00_JPRB, 0.593303E+00_JPRB, 0.569891E+00_JPRB &
  &, 0.546817E+00_JPRB, 0.524098E+00_JPRB, 0.501752E+00_JPRB, 0.479795E+00_JPRB &
  &, 0.458242E+00_JPRB, 0.437114E+00_JPRB, 0.416420E+00_JPRB &
  &, 0.396183E+00_JPRB, 0.376416E+00_JPRB, 0.357129E+00_JPRB, 0.338344E+00_JPRB &
  &, 0.320069E+00_JPRB, 0.302321E+00_JPRB, 0.285106E+00_JPRB &
  &, 0.268440E+00_JPRB, 0.252330E+00_JPRB, 0.236781E+00_JPRB, 0.221808E+00_JPRB &
  &, 0.207411E+00_JPRB, 0.193593E+00_JPRB, 0.180362E+00_JPRB &
  &, 0.167712E+00_JPRB, 0.155649E+00_JPRB, 0.144169E+00_JPRB, 0.133259E+00_JPRB &
  &, 0.122924E+00_JPRB, 0.113157E+00_JPRB, 0.103949E+00_JPRB &
  &, 0.952731E-01_JPRB, 0.871342E-01_JPRB, 0.795107E-01_JPRB, 0.723881E-01_JPRB &
  &, 0.657601E-01_JPRB, 0.596049E-01_JPRB, 0.538830E-01_JPRB &
  &, 0.486142E-01_JPRB, 0.437374E-01_JPRB, 0.392656E-01_JPRB, 0.351689E-01_JPRB &
  &, 0.314123E-01_JPRB, 0.280000E-01_JPRB, 0.248892E-01_JPRB &
  &, 0.220625E-01_JPRB, 0.195151E-01_JPRB, 0.172241E-01_JPRB, 0.151464E-01_JPRB &
  &, 0.133017E-01_JPRB, 0.116411E-01_JPRB, 0.101631E-01_JPRB &
  &, 0.884741E-02_JPRB, 0.768927E-02_JPRB, 0.666399E-02_JPRB, 0.576334E-02_JPRB &
  &, 0.495793E-02_JPRB, 0.427597E-02_JPRB, 0.366505E-02_JPRB &
  &, 0.313104E-02_JPRB, 0.265846E-02_JPRB, 0.227416E-02_JPRB, 0.191724E-02_JPRB &
  &, 0.163591E-02_JPRB, 0.136534E-02_JPRB, 0.115441E-02_JPRB &
  &, 0.958545E-03_JPRB, 0.803838E-03_JPRB, 0.667779E-03_JPRB, 0.551734E-03_JPRB &
  &, 0.457109E-03_JPRB, 0.385342E-03_JPRB, 0.310583E-03_JPRB &
  &, 0.260626E-03_JPRB, 0.208623E-03_JPRB, 0.154541E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.710888E-04_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 146, :) = (/ &
  &  0.894820E+00_JPRB, 0.868769E+00_JPRB, 0.842850E+00_JPRB, 0.817079E+00_JPRB &
  &, 0.791472E+00_JPRB, 0.766046E+00_JPRB, 0.740817E+00_JPRB &
  &, 0.715803E+00_JPRB, 0.691020E+00_JPRB, 0.666485E+00_JPRB, 0.642216E+00_JPRB &
  &, 0.618230E+00_JPRB, 0.594542E+00_JPRB, 0.571172E+00_JPRB &
  &, 0.548136E+00_JPRB, 0.525450E+00_JPRB, 0.503132E+00_JPRB, 0.481199E+00_JPRB &
  &, 0.459668E+00_JPRB, 0.438554E+00_JPRB, 0.417876E+00_JPRB &
  &, 0.397645E+00_JPRB, 0.377881E+00_JPRB, 0.358597E+00_JPRB, 0.339807E+00_JPRB &
  &, 0.321524E+00_JPRB, 0.303766E+00_JPRB, 0.286537E+00_JPRB &
  &, 0.269851E+00_JPRB, 0.253720E+00_JPRB, 0.238153E+00_JPRB, 0.223151E+00_JPRB &
  &, 0.208723E+00_JPRB, 0.194876E+00_JPRB, 0.181605E+00_JPRB &
  &, 0.168922E+00_JPRB, 0.156823E+00_JPRB, 0.145293E+00_JPRB, 0.134352E+00_JPRB &
  &, 0.123972E+00_JPRB, 0.114159E+00_JPRB, 0.104900E+00_JPRB &
  &, 0.961813E-01_JPRB, 0.879970E-01_JPRB, 0.803368E-01_JPRB, 0.731751E-01_JPRB &
  &, 0.664933E-01_JPRB, 0.602935E-01_JPRB, 0.545372E-01_JPRB &
  &, 0.492187E-01_JPRB, 0.443026E-01_JPRB, 0.397894E-01_JPRB, 0.356488E-01_JPRB &
  &, 0.318603E-01_JPRB, 0.284142E-01_JPRB, 0.252678E-01_JPRB &
  &, 0.224189E-01_JPRB, 0.198323E-01_JPRB, 0.174999E-01_JPRB, 0.154119E-01_JPRB &
  &, 0.135394E-01_JPRB, 0.118668E-01_JPRB, 0.103584E-01_JPRB &
  &, 0.902887E-02_JPRB, 0.785621E-02_JPRB, 0.679669E-02_JPRB, 0.587956E-02_JPRB &
  &, 0.507668E-02_JPRB, 0.435685E-02_JPRB, 0.374765E-02_JPRB &
  &, 0.319431E-02_JPRB, 0.274459E-02_JPRB, 0.231813E-02_JPRB, 0.198456E-02_JPRB &
  &, 0.168171E-02_JPRB, 0.141208E-02_JPRB, 0.117825E-02_JPRB &
  &, 0.100719E-02_JPRB, 0.828646E-03_JPRB, 0.693078E-03_JPRB, 0.577531E-03_JPRB &
  &, 0.483410E-03_JPRB, 0.385342E-03_JPRB, 0.310583E-03_JPRB &
  &, 0.260626E-03_JPRB, 0.208623E-03_JPRB, 0.183449E-03_JPRB, 0.127791E-03_JPRB &
  &, 0.999792E-04_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 147, :) = (/ &
  &  0.895226E+00_JPRB, 0.869269E+00_JPRB, 0.843436E+00_JPRB, 0.817749E+00_JPRB &
  &, 0.792221E+00_JPRB, 0.766870E+00_JPRB, 0.741713E+00_JPRB &
  &, 0.716766E+00_JPRB, 0.692046E+00_JPRB, 0.667570E+00_JPRB, 0.643355E+00_JPRB &
  &, 0.619418E+00_JPRB, 0.595777E+00_JPRB, 0.572448E+00_JPRB &
  &, 0.549449E+00_JPRB, 0.526798E+00_JPRB, 0.504509E+00_JPRB, 0.482601E+00_JPRB &
  &, 0.461090E+00_JPRB, 0.439991E+00_JPRB, 0.419325E+00_JPRB &
  &, 0.399104E+00_JPRB, 0.379346E+00_JPRB, 0.360061E+00_JPRB, 0.341267E+00_JPRB &
  &, 0.322979E+00_JPRB, 0.305208E+00_JPRB, 0.287968E+00_JPRB &
  &, 0.271263E+00_JPRB, 0.255110E+00_JPRB, 0.239520E+00_JPRB, 0.224490E+00_JPRB &
  &, 0.210035E+00_JPRB, 0.196155E+00_JPRB, 0.182852E+00_JPRB &
  &, 0.170131E+00_JPRB, 0.157986E+00_JPRB, 0.146428E+00_JPRB, 0.135444E+00_JPRB &
  &, 0.125021E+00_JPRB, 0.115170E+00_JPRB, 0.105861E+00_JPRB &
  &, 0.971004E-01_JPRB, 0.888711E-01_JPRB, 0.811628E-01_JPRB, 0.739501E-01_JPRB &
  &, 0.672264E-01_JPRB, 0.609821E-01_JPRB, 0.551785E-01_JPRB &
  &, 0.498231E-01_JPRB, 0.448679E-01_JPRB, 0.403131E-01_JPRB, 0.361428E-01_JPRB &
  &, 0.323227E-01_JPRB, 0.288284E-01_JPRB, 0.256463E-01_JPRB &
  &, 0.227599E-01_JPRB, 0.201494E-01_JPRB, 0.178081E-01_JPRB, 0.156775E-01_JPRB &
  &, 0.137770E-01_JPRB, 0.120751E-01_JPRB, 0.105537E-01_JPRB &
  &, 0.921034E-02_JPRB, 0.800460E-02_JPRB, 0.694835E-02_JPRB, 0.601517E-02_JPRB &
  &, 0.519543E-02_JPRB, 0.445794E-02_JPRB, 0.383025E-02_JPRB &
  &, 0.327866E-02_JPRB, 0.280918E-02_JPRB, 0.238408E-02_JPRB, 0.202943E-02_JPRB &
  &, 0.170461E-02_JPRB, 0.145882E-02_JPRB, 0.122593E-02_JPRB &
  &, 0.103151E-02_JPRB, 0.853453E-03_JPRB, 0.718377E-03_JPRB, 0.603328E-03_JPRB &
  &, 0.483410E-03_JPRB, 0.412152E-03_JPRB, 0.337909E-03_JPRB &
  &, 0.260626E-03_JPRB, 0.236998E-03_JPRB, 0.183449E-03_JPRB, 0.157238E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART22

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART22',0,ZHOOK_HANDLE)

XCW( 148, :) = (/ &
  &  0.895631E+00_JPRB, 0.869765E+00_JPRB, 0.844020E+00_JPRB, 0.818416E+00_JPRB &
  &, 0.792967E+00_JPRB, 0.767692E+00_JPRB, 0.742606E+00_JPRB &
  &, 0.717725E+00_JPRB, 0.693067E+00_JPRB, 0.668651E+00_JPRB, 0.644490E+00_JPRB &
  &, 0.620604E+00_JPRB, 0.597009E+00_JPRB, 0.573722E+00_JPRB &
  &, 0.550761E+00_JPRB, 0.528141E+00_JPRB, 0.505881E+00_JPRB, 0.483998E+00_JPRB &
  &, 0.462509E+00_JPRB, 0.441428E+00_JPRB, 0.420775E+00_JPRB &
  &, 0.400559E+00_JPRB, 0.380804E+00_JPRB, 0.361522E+00_JPRB, 0.342727E+00_JPRB &
  &, 0.324430E+00_JPRB, 0.306649E+00_JPRB, 0.289395E+00_JPRB &
  &, 0.272674E+00_JPRB, 0.256505E+00_JPRB, 0.240888E+00_JPRB, 0.225833E+00_JPRB &
  &, 0.211347E+00_JPRB, 0.197433E+00_JPRB, 0.184100E+00_JPRB &
  &, 0.171340E+00_JPRB, 0.159159E+00_JPRB, 0.147562E+00_JPRB, 0.136537E+00_JPRB &
  &, 0.126069E+00_JPRB, 0.116171E+00_JPRB, 0.106823E+00_JPRB &
  &, 0.980196E-01_JPRB, 0.897451E-01_JPRB, 0.819889E-01_JPRB, 0.747371E-01_JPRB &
  &, 0.679718E-01_JPRB, 0.616833E-01_JPRB, 0.558327E-01_JPRB &
  &, 0.504275E-01_JPRB, 0.454466E-01_JPRB, 0.408507E-01_JPRB, 0.366368E-01_JPRB &
  &, 0.327707E-01_JPRB, 0.292427E-01_JPRB, 0.260400E-01_JPRB &
  &, 0.231163E-01_JPRB, 0.204824E-01_JPRB, 0.181002E-01_JPRB, 0.159430E-01_JPRB &
  &, 0.140147E-01_JPRB, 0.123008E-01_JPRB, 0.107489E-01_JPRB &
  &, 0.939181E-02_JPRB, 0.817154E-02_JPRB, 0.708105E-02_JPRB, 0.613139E-02_JPRB &
  &, 0.529439E-02_JPRB, 0.455902E-02_JPRB, 0.391285E-02_JPRB &
  &, 0.336301E-02_JPRB, 0.287378E-02_JPRB, 0.245002E-02_JPRB, 0.207431E-02_JPRB &
  &, 0.175041E-02_JPRB, 0.148218E-02_JPRB, 0.124978E-02_JPRB &
  &, 0.105583E-02_JPRB, 0.878260E-03_JPRB, 0.743676E-03_JPRB, 0.603328E-03_JPRB &
  &, 0.509710E-03_JPRB, 0.412152E-03_JPRB, 0.337909E-03_JPRB &
  &, 0.288473E-03_JPRB, 0.236998E-03_JPRB, 0.183449E-03_JPRB, 0.157238E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.416650E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 149, :) = (/ &
  &  0.896035E+00_JPRB, 0.870259E+00_JPRB, 0.844601E+00_JPRB, 0.819080E+00_JPRB &
  &, 0.793711E+00_JPRB, 0.768510E+00_JPRB, 0.743492E+00_JPRB &
  &, 0.718681E+00_JPRB, 0.694086E+00_JPRB, 0.669727E+00_JPRB, 0.645622E+00_JPRB &
  &, 0.621785E+00_JPRB, 0.598235E+00_JPRB, 0.574991E+00_JPRB &
  &, 0.552067E+00_JPRB, 0.529481E+00_JPRB, 0.507251E+00_JPRB, 0.485393E+00_JPRB &
  &, 0.463924E+00_JPRB, 0.442859E+00_JPRB, 0.422218E+00_JPRB &
  &, 0.402015E+00_JPRB, 0.382263E+00_JPRB, 0.362984E+00_JPRB, 0.344184E+00_JPRB &
  &, 0.325882E+00_JPRB, 0.308091E+00_JPRB, 0.290822E+00_JPRB &
  &, 0.274086E+00_JPRB, 0.257891E+00_JPRB, 0.242251E+00_JPRB, 0.227171E+00_JPRB &
  &, 0.212659E+00_JPRB, 0.198716E+00_JPRB, 0.185347E+00_JPRB &
  &, 0.172549E+00_JPRB, 0.160342E+00_JPRB, 0.148696E+00_JPRB, 0.137630E+00_JPRB &
  &, 0.127128E+00_JPRB, 0.117183E+00_JPRB, 0.107795E+00_JPRB &
  &, 0.989388E-01_JPRB, 0.906192E-01_JPRB, 0.828266E-01_JPRB, 0.755241E-01_JPRB &
  &, 0.687171E-01_JPRB, 0.623844E-01_JPRB, 0.564997E-01_JPRB &
  &, 0.510451E-01_JPRB, 0.460119E-01_JPRB, 0.413883E-01_JPRB, 0.371308E-01_JPRB &
  &, 0.332332E-01_JPRB, 0.296717E-01_JPRB, 0.264186E-01_JPRB &
  &, 0.234728E-01_JPRB, 0.208154E-01_JPRB, 0.183922E-01_JPRB, 0.162252E-01_JPRB &
  &, 0.142693E-01_JPRB, 0.125264E-01_JPRB, 0.109619E-01_JPRB &
  &, 0.957327E-02_JPRB, 0.831993E-02_JPRB, 0.723271E-02_JPRB, 0.626699E-02_JPRB &
  &, 0.541314E-02_JPRB, 0.466011E-02_JPRB, 0.401610E-02_JPRB &
  &, 0.344736E-02_JPRB, 0.293837E-02_JPRB, 0.251597E-02_JPRB, 0.214163E-02_JPRB &
  &, 0.179621E-02_JPRB, 0.152892E-02_JPRB, 0.129746E-02_JPRB &
  &, 0.108015E-02_JPRB, 0.903068E-03_JPRB, 0.768975E-03_JPRB, 0.629125E-03_JPRB &
  &, 0.536011E-03_JPRB, 0.438963E-03_JPRB, 0.365235E-03_JPRB &
  &, 0.288473E-03_JPRB, 0.236998E-03_JPRB, 0.183449E-03_JPRB, 0.157238E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.733299E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 150, :) = (/ &
  &  0.896436E+00_JPRB, 0.870751E+00_JPRB, 0.845180E+00_JPRB, 0.819742E+00_JPRB &
  &, 0.794451E+00_JPRB, 0.769325E+00_JPRB, 0.744380E+00_JPRB &
  &, 0.719633E+00_JPRB, 0.695101E+00_JPRB, 0.670801E+00_JPRB, 0.646749E+00_JPRB &
  &, 0.622963E+00_JPRB, 0.599459E+00_JPRB, 0.576255E+00_JPRB &
  &, 0.553370E+00_JPRB, 0.530818E+00_JPRB, 0.508616E+00_JPRB, 0.486783E+00_JPRB &
  &, 0.465335E+00_JPRB, 0.444287E+00_JPRB, 0.423661E+00_JPRB &
  &, 0.403464E+00_JPRB, 0.383721E+00_JPRB, 0.364441E+00_JPRB, 0.345640E+00_JPRB &
  &, 0.327329E+00_JPRB, 0.309529E+00_JPRB, 0.292246E+00_JPRB &
  &, 0.275493E+00_JPRB, 0.259282E+00_JPRB, 0.243619E+00_JPRB, 0.228514E+00_JPRB &
  &, 0.213970E+00_JPRB, 0.199999E+00_JPRB, 0.186595E+00_JPRB &
  &, 0.173768E+00_JPRB, 0.161515E+00_JPRB, 0.149831E+00_JPRB, 0.138723E+00_JPRB &
  &, 0.128176E+00_JPRB, 0.118195E+00_JPRB, 0.108756E+00_JPRB &
  &, 0.998691E-01_JPRB, 0.915047E-01_JPRB, 0.836527E-01_JPRB, 0.763110E-01_JPRB &
  &, 0.694625E-01_JPRB, 0.630855E-01_JPRB, 0.571539E-01_JPRB &
  &, 0.516627E-01_JPRB, 0.465906E-01_JPRB, 0.419258E-01_JPRB, 0.376248E-01_JPRB &
  &, 0.336956E-01_JPRB, 0.301007E-01_JPRB, 0.268123E-01_JPRB &
  &, 0.238447E-01_JPRB, 0.211326E-01_JPRB, 0.187005E-01_JPRB, 0.164907E-01_JPRB &
  &, 0.145240E-01_JPRB, 0.127521E-01_JPRB, 0.111572E-01_JPRB &
  &, 0.975474E-02_JPRB, 0.848687E-02_JPRB, 0.738437E-02_JPRB, 0.640260E-02_JPRB &
  &, 0.553189E-02_JPRB, 0.476120E-02_JPRB, 0.409870E-02_JPRB &
  &, 0.351063E-02_JPRB, 0.300297E-02_JPRB, 0.255993E-02_JPRB, 0.218650E-02_JPRB &
  &, 0.186491E-02_JPRB, 0.157566E-02_JPRB, 0.132130E-02_JPRB &
  &, 0.110447E-02_JPRB, 0.927875E-03_JPRB, 0.794275E-03_JPRB, 0.654922E-03_JPRB &
  &, 0.536011E-03_JPRB, 0.438963E-03_JPRB, 0.365235E-03_JPRB &
  &, 0.316320E-03_JPRB, 0.236998E-03_JPRB, 0.212358E-03_JPRB, 0.157238E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.733299E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 151, :) = (/ &
  &  0.896836E+00_JPRB, 0.871241E+00_JPRB, 0.845757E+00_JPRB, 0.820401E+00_JPRB &
  &, 0.795189E+00_JPRB, 0.770138E+00_JPRB, 0.745263E+00_JPRB &
  &, 0.720582E+00_JPRB, 0.696113E+00_JPRB, 0.671870E+00_JPRB, 0.647873E+00_JPRB &
  &, 0.624136E+00_JPRB, 0.600679E+00_JPRB, 0.577518E+00_JPRB &
  &, 0.554669E+00_JPRB, 0.532150E+00_JPRB, 0.509978E+00_JPRB, 0.488171E+00_JPRB &
  &, 0.466743E+00_JPRB, 0.445714E+00_JPRB, 0.425097E+00_JPRB &
  &, 0.404913E+00_JPRB, 0.385172E+00_JPRB, 0.365895E+00_JPRB, 0.347090E+00_JPRB &
  &, 0.328777E+00_JPRB, 0.310967E+00_JPRB, 0.293673E+00_JPRB &
  &, 0.276901E+00_JPRB, 0.260672E+00_JPRB, 0.244986E+00_JPRB, 0.229853E+00_JPRB &
  &, 0.215282E+00_JPRB, 0.201278E+00_JPRB, 0.187846E+00_JPRB &
  &, 0.174977E+00_JPRB, 0.162688E+00_JPRB, 0.150975E+00_JPRB, 0.139825E+00_JPRB &
  &, 0.129235E+00_JPRB, 0.119206E+00_JPRB, 0.109729E+00_JPRB &
  &, 0.100788E+00_JPRB, 0.923901E-01_JPRB, 0.845020E-01_JPRB, 0.771099E-01_JPRB &
  &, 0.702078E-01_JPRB, 0.637866E-01_JPRB, 0.578209E-01_JPRB &
  &, 0.522934E-01_JPRB, 0.471828E-01_JPRB, 0.424634E-01_JPRB, 0.381329E-01_JPRB &
  &, 0.341580E-01_JPRB, 0.305297E-01_JPRB, 0.272212E-01_JPRB &
  &, 0.242011E-01_JPRB, 0.214656E-01_JPRB, 0.190087E-01_JPRB, 0.167729E-01_JPRB &
  &, 0.147786E-01_JPRB, 0.129778E-01_JPRB, 0.113702E-01_JPRB &
  &, 0.993620E-02_JPRB, 0.865381E-02_JPRB, 0.753603E-02_JPRB, 0.653820E-02_JPRB &
  &, 0.565064E-02_JPRB, 0.488251E-02_JPRB, 0.420195E-02_JPRB &
  &, 0.359498E-02_JPRB, 0.308910E-02_JPRB, 0.262588E-02_JPRB, 0.223138E-02_JPRB &
  &, 0.191071E-02_JPRB, 0.162239E-02_JPRB, 0.136899E-02_JPRB &
  &, 0.115312E-02_JPRB, 0.952683E-03_JPRB, 0.794275E-03_JPRB, 0.680719E-03_JPRB &
  &, 0.562311E-03_JPRB, 0.465773E-03_JPRB, 0.392560E-03_JPRB &
  &, 0.316320E-03_JPRB, 0.265373E-03_JPRB, 0.212358E-03_JPRB, 0.157238E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.722034E-04_JPRB &
  &, 0.733299E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 152, :) = (/ &
  &  0.897233E+00_JPRB, 0.871729E+00_JPRB, 0.846331E+00_JPRB, 0.821058E+00_JPRB &
  &, 0.795924E+00_JPRB, 0.770946E+00_JPRB, 0.746143E+00_JPRB &
  &, 0.721529E+00_JPRB, 0.697120E+00_JPRB, 0.672937E+00_JPRB, 0.648993E+00_JPRB &
  &, 0.625307E+00_JPRB, 0.601896E+00_JPRB, 0.578774E+00_JPRB &
  &, 0.555964E+00_JPRB, 0.533478E+00_JPRB, 0.511337E+00_JPRB, 0.489555E+00_JPRB &
  &, 0.468149E+00_JPRB, 0.447135E+00_JPRB, 0.426533E+00_JPRB &
  &, 0.406358E+00_JPRB, 0.386624E+00_JPRB, 0.367346E+00_JPRB, 0.348543E+00_JPRB &
  &, 0.330221E+00_JPRB, 0.312401E+00_JPRB, 0.295096E+00_JPRB &
  &, 0.278309E+00_JPRB, 0.262058E+00_JPRB, 0.246350E+00_JPRB, 0.231196E+00_JPRB &
  &, 0.216599E+00_JPRB, 0.202561E+00_JPRB, 0.189094E+00_JPRB &
  &, 0.176195E+00_JPRB, 0.163870E+00_JPRB, 0.152109E+00_JPRB, 0.140918E+00_JPRB &
  &, 0.130294E+00_JPRB, 0.120229E+00_JPRB, 0.110701E+00_JPRB &
  &, 0.101719E+00_JPRB, 0.932755E-01_JPRB, 0.853397E-01_JPRB, 0.779088E-01_JPRB &
  &, 0.709654E-01_JPRB, 0.645002E-01_JPRB, 0.584879E-01_JPRB &
  &, 0.529110E-01_JPRB, 0.477615E-01_JPRB, 0.430147E-01_JPRB, 0.386410E-01_JPRB &
  &, 0.346349E-01_JPRB, 0.309588E-01_JPRB, 0.276149E-01_JPRB &
  &, 0.245731E-01_JPRB, 0.218145E-01_JPRB, 0.193170E-01_JPRB, 0.170550E-01_JPRB &
  &, 0.150332E-01_JPRB, 0.132035E-01_JPRB, 0.115832E-01_JPRB &
  &, 0.101177E-01_JPRB, 0.882075E-02_JPRB, 0.768769E-02_JPRB, 0.667380E-02_JPRB &
  &, 0.576939E-02_JPRB, 0.498360E-02_JPRB, 0.428455E-02_JPRB &
  &, 0.367933E-02_JPRB, 0.315370E-02_JPRB, 0.269183E-02_JPRB, 0.229869E-02_JPRB &
  &, 0.195651E-02_JPRB, 0.164576E-02_JPRB, 0.139283E-02_JPRB &
  &, 0.117744E-02_JPRB, 0.977490E-03_JPRB, 0.819574E-03_JPRB, 0.680719E-03_JPRB &
  &, 0.588612E-03_JPRB, 0.465773E-03_JPRB, 0.392560E-03_JPRB &
  &, 0.316320E-03_JPRB, 0.265373E-03_JPRB, 0.212358E-03_JPRB, 0.186686E-03_JPRB &
  &, 0.129972E-03_JPRB, 0.101633E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 153, :) = (/ &
  &  0.897630E+00_JPRB, 0.872215E+00_JPRB, 0.846903E+00_JPRB, 0.821712E+00_JPRB &
  &, 0.796656E+00_JPRB, 0.771753E+00_JPRB, 0.747018E+00_JPRB &
  &, 0.722470E+00_JPRB, 0.698125E+00_JPRB, 0.673999E+00_JPRB, 0.650110E+00_JPRB &
  &, 0.626474E+00_JPRB, 0.603107E+00_JPRB, 0.580030E+00_JPRB &
  &, 0.557256E+00_JPRB, 0.534805E+00_JPRB, 0.512691E+00_JPRB, 0.490936E+00_JPRB &
  &, 0.469551E+00_JPRB, 0.448557E+00_JPRB, 0.427967E+00_JPRB &
  &, 0.407800E+00_JPRB, 0.388072E+00_JPRB, 0.368797E+00_JPRB, 0.349992E+00_JPRB &
  &, 0.331665E+00_JPRB, 0.313835E+00_JPRB, 0.296516E+00_JPRB &
  &, 0.279716E+00_JPRB, 0.263445E+00_JPRB, 0.247717E+00_JPRB, 0.232534E+00_JPRB &
  &, 0.217910E+00_JPRB, 0.203844E+00_JPRB, 0.190346E+00_JPRB &
  &, 0.177414E+00_JPRB, 0.165053E+00_JPRB, 0.153253E+00_JPRB, 0.142021E+00_JPRB &
  &, 0.131353E+00_JPRB, 0.121240E+00_JPRB, 0.111684E+00_JPRB &
  &, 0.102660E+00_JPRB, 0.941610E-01_JPRB, 0.861775E-01_JPRB, 0.787077E-01_JPRB &
  &, 0.717230E-01_JPRB, 0.652139E-01_JPRB, 0.591549E-01_JPRB &
  &, 0.535417E-01_JPRB, 0.483537E-01_JPRB, 0.435523E-01_JPRB, 0.391491E-01_JPRB &
  &, 0.350974E-01_JPRB, 0.314026E-01_JPRB, 0.280237E-01_JPRB &
  &, 0.249450E-01_JPRB, 0.221475E-01_JPRB, 0.196253E-01_JPRB, 0.173372E-01_JPRB &
  &, 0.152879E-01_JPRB, 0.134292E-01_JPRB, 0.117784E-01_JPRB &
  &, 0.103173E-01_JPRB, 0.900624E-02_JPRB, 0.783934E-02_JPRB, 0.680940E-02_JPRB &
  &, 0.588814E-02_JPRB, 0.508469E-02_JPRB, 0.438780E-02_JPRB &
  &, 0.376368E-02_JPRB, 0.323983E-02_JPRB, 0.275777E-02_JPRB, 0.234357E-02_JPRB &
  &, 0.200231E-02_JPRB, 0.169250E-02_JPRB, 0.144051E-02_JPRB &
  &, 0.120176E-02_JPRB, 0.102711E-02_JPRB, 0.844873E-03_JPRB, 0.706516E-03_JPRB &
  &, 0.588612E-03_JPRB, 0.492583E-03_JPRB, 0.419886E-03_JPRB &
  &, 0.344167E-03_JPRB, 0.265373E-03_JPRB, 0.212358E-03_JPRB, 0.186686E-03_JPRB &
  &, 0.159965E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.422342E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 154, :) = (/ &
  &  0.898025E+00_JPRB, 0.872699E+00_JPRB, 0.847473E+00_JPRB, 0.822363E+00_JPRB &
  &, 0.797385E+00_JPRB, 0.772555E+00_JPRB, 0.747892E+00_JPRB &
  &, 0.723410E+00_JPRB, 0.699126E+00_JPRB, 0.675058E+00_JPRB, 0.651222E+00_JPRB &
  &, 0.627636E+00_JPRB, 0.604316E+00_JPRB, 0.581280E+00_JPRB &
  &, 0.558545E+00_JPRB, 0.536127E+00_JPRB, 0.514044E+00_JPRB, 0.492312E+00_JPRB &
  &, 0.470950E+00_JPRB, 0.449972E+00_JPRB, 0.429396E+00_JPRB &
  &, 0.409243E+00_JPRB, 0.389520E+00_JPRB, 0.370247E+00_JPRB, 0.351438E+00_JPRB &
  &, 0.333109E+00_JPRB, 0.315270E+00_JPRB, 0.297939E+00_JPRB &
  &, 0.281120E+00_JPRB, 0.264835E+00_JPRB, 0.249081E+00_JPRB, 0.233877E+00_JPRB &
  &, 0.219222E+00_JPRB, 0.205131E+00_JPRB, 0.191598E+00_JPRB &
  &, 0.178632E+00_JPRB, 0.166235E+00_JPRB, 0.154397E+00_JPRB, 0.143124E+00_JPRB &
  &, 0.132422E+00_JPRB, 0.122262E+00_JPRB, 0.112656E+00_JPRB &
  &, 0.103590E+00_JPRB, 0.950577E-01_JPRB, 0.870268E-01_JPRB, 0.795067E-01_JPRB &
  &, 0.724805E-01_JPRB, 0.659275E-01_JPRB, 0.598347E-01_JPRB &
  &, 0.541724E-01_JPRB, 0.489459E-01_JPRB, 0.441036E-01_JPRB, 0.396573E-01_JPRB &
  &, 0.355743E-01_JPRB, 0.318464E-01_JPRB, 0.284326E-01_JPRB &
  &, 0.253169E-01_JPRB, 0.224964E-01_JPRB, 0.199335E-01_JPRB, 0.176193E-01_JPRB &
  &, 0.155425E-01_JPRB, 0.136722E-01_JPRB, 0.119914E-01_JPRB &
  &, 0.104987E-01_JPRB, 0.917318E-02_JPRB, 0.799100E-02_JPRB, 0.694500E-02_JPRB &
  &, 0.600689E-02_JPRB, 0.520600E-02_JPRB, 0.449105E-02_JPRB &
  &, 0.384804E-02_JPRB, 0.330442E-02_JPRB, 0.282372E-02_JPRB, 0.241088E-02_JPRB &
  &, 0.204811E-02_JPRB, 0.173923E-02_JPRB, 0.146435E-02_JPRB &
  &, 0.125041E-02_JPRB, 0.105191E-02_JPRB, 0.870172E-03_JPRB, 0.732313E-03_JPRB &
  &, 0.614912E-03_JPRB, 0.519393E-03_JPRB, 0.419886E-03_JPRB &
  &, 0.344167E-03_JPRB, 0.293748E-03_JPRB, 0.241266E-03_JPRB, 0.186686E-03_JPRB &
  &, 0.159965E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART23

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART23',0,ZHOOK_HANDLE)

XCW( 155, :) = (/ &
  &  0.898419E+00_JPRB, 0.873182E+00_JPRB, 0.848041E+00_JPRB, 0.823012E+00_JPRB &
  &, 0.798112E+00_JPRB, 0.773356E+00_JPRB, 0.748762E+00_JPRB &
  &, 0.724346E+00_JPRB, 0.700124E+00_JPRB, 0.676114E+00_JPRB, 0.652332E+00_JPRB &
  &, 0.628796E+00_JPRB, 0.605522E+00_JPRB, 0.582527E+00_JPRB &
  &, 0.559829E+00_JPRB, 0.537445E+00_JPRB, 0.515391E+00_JPRB, 0.493687E+00_JPRB &
  &, 0.472346E+00_JPRB, 0.451387E+00_JPRB, 0.430826E+00_JPRB &
  &, 0.410678E+00_JPRB, 0.390962E+00_JPRB, 0.371691E+00_JPRB, 0.352884E+00_JPRB &
  &, 0.334546E+00_JPRB, 0.316700E+00_JPRB, 0.299359E+00_JPRB &
  &, 0.282527E+00_JPRB, 0.266214E+00_JPRB, 0.250448E+00_JPRB, 0.235216E+00_JPRB &
  &, 0.220538E+00_JPRB, 0.206414E+00_JPRB, 0.192850E+00_JPRB &
  &, 0.179851E+00_JPRB, 0.167418E+00_JPRB, 0.155541E+00_JPRB, 0.144237E+00_JPRB &
  &, 0.133480E+00_JPRB, 0.123285E+00_JPRB, 0.113639E+00_JPRB &
  &, 0.104531E+00_JPRB, 0.959432E-01_JPRB, 0.878761E-01_JPRB, 0.803175E-01_JPRB &
  &, 0.732503E-01_JPRB, 0.666537E-01_JPRB, 0.605145E-01_JPRB &
  &, 0.548162E-01_JPRB, 0.495381E-01_JPRB, 0.446687E-01_JPRB, 0.401795E-01_JPRB &
  &, 0.360511E-01_JPRB, 0.322902E-01_JPRB, 0.288414E-01_JPRB &
  &, 0.256889E-01_JPRB, 0.228452E-01_JPRB, 0.202580E-01_JPRB, 0.179181E-01_JPRB &
  &, 0.157971E-01_JPRB, 0.139152E-01_JPRB, 0.122222E-01_JPRB &
  &, 0.106984E-01_JPRB, 0.934013E-02_JPRB, 0.814266E-02_JPRB, 0.708060E-02_JPRB &
  &, 0.614543E-02_JPRB, 0.530709E-02_JPRB, 0.457365E-02_JPRB &
  &, 0.393239E-02_JPRB, 0.339055E-02_JPRB, 0.288967E-02_JPRB, 0.247820E-02_JPRB &
  &, 0.209391E-02_JPRB, 0.178597E-02_JPRB, 0.151204E-02_JPRB &
  &, 0.127473E-02_JPRB, 0.107672E-02_JPRB, 0.895471E-03_JPRB, 0.758110E-03_JPRB &
  &, 0.641213E-03_JPRB, 0.519393E-03_JPRB, 0.447212E-03_JPRB &
  &, 0.372015E-03_JPRB, 0.293748E-03_JPRB, 0.241266E-03_JPRB, 0.186686E-03_JPRB &
  &, 0.159965E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 156, :) = (/ &
  &  0.898809E+00_JPRB, 0.873663E+00_JPRB, 0.848606E+00_JPRB, 0.823659E+00_JPRB &
  &, 0.798835E+00_JPRB, 0.774154E+00_JPRB, 0.749629E+00_JPRB &
  &, 0.725278E+00_JPRB, 0.701118E+00_JPRB, 0.677166E+00_JPRB, 0.653438E+00_JPRB &
  &, 0.629952E+00_JPRB, 0.606723E+00_JPRB, 0.583771E+00_JPRB &
  &, 0.561111E+00_JPRB, 0.538760E+00_JPRB, 0.516737E+00_JPRB, 0.495057E+00_JPRB &
  &, 0.473738E+00_JPRB, 0.452795E+00_JPRB, 0.432250E+00_JPRB &
  &, 0.412114E+00_JPRB, 0.392403E+00_JPRB, 0.373135E+00_JPRB, 0.354326E+00_JPRB &
  &, 0.335986E+00_JPRB, 0.318131E+00_JPRB, 0.300775E+00_JPRB &
  &, 0.283931E+00_JPRB, 0.267604E+00_JPRB, 0.251812E+00_JPRB, 0.236559E+00_JPRB &
  &, 0.221850E+00_JPRB, 0.207697E+00_JPRB, 0.194106E+00_JPRB &
  &, 0.181069E+00_JPRB, 0.168600E+00_JPRB, 0.156685E+00_JPRB, 0.145340E+00_JPRB &
  &, 0.134549E+00_JPRB, 0.124317E+00_JPRB, 0.114623E+00_JPRB &
  &, 0.105473E+00_JPRB, 0.968400E-01_JPRB, 0.887371E-01_JPRB, 0.811283E-01_JPRB &
  &, 0.740079E-01_JPRB, 0.673673E-01_JPRB, 0.611944E-01_JPRB &
  &, 0.554470E-01_JPRB, 0.501303E-01_JPRB, 0.452201E-01_JPRB, 0.407017E-01_JPRB &
  &, 0.365425E-01_JPRB, 0.327340E-01_JPRB, 0.292503E-01_JPRB &
  &, 0.260763E-01_JPRB, 0.231941E-01_JPRB, 0.205663E-01_JPRB, 0.182002E-01_JPRB &
  &, 0.160687E-01_JPRB, 0.141583E-01_JPRB, 0.124352E-01_JPRB &
  &, 0.108980E-01_JPRB, 0.952561E-02_JPRB, 0.829432E-02_JPRB, 0.721620E-02_JPRB &
  &, 0.626418E-02_JPRB, 0.542839E-02_JPRB, 0.467690E-02_JPRB &
  &, 0.403783E-02_JPRB, 0.345515E-02_JPRB, 0.295561E-02_JPRB, 0.252307E-02_JPRB &
  &, 0.216261E-02_JPRB, 0.183270E-02_JPRB, 0.155972E-02_JPRB &
  &, 0.132337E-02_JPRB, 0.110153E-02_JPRB, 0.920771E-03_JPRB, 0.783906E-03_JPRB &
  &, 0.641213E-03_JPRB, 0.546203E-03_JPRB, 0.447212E-03_JPRB &
  &, 0.372015E-03_JPRB, 0.293748E-03_JPRB, 0.241266E-03_JPRB, 0.216134E-03_JPRB &
  &, 0.159965E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 157, :) = (/ &
  &  0.899201E+00_JPRB, 0.874141E+00_JPRB, 0.849169E+00_JPRB, 0.824303E+00_JPRB &
  &, 0.799557E+00_JPRB, 0.774948E+00_JPRB, 0.750493E+00_JPRB &
  &, 0.726208E+00_JPRB, 0.702109E+00_JPRB, 0.678215E+00_JPRB, 0.654541E+00_JPRB &
  &, 0.631104E+00_JPRB, 0.607922E+00_JPRB, 0.585011E+00_JPRB &
  &, 0.562388E+00_JPRB, 0.540072E+00_JPRB, 0.518078E+00_JPRB, 0.496425E+00_JPRB &
  &, 0.475128E+00_JPRB, 0.454204E+00_JPRB, 0.433673E+00_JPRB &
  &, 0.413546E+00_JPRB, 0.393841E+00_JPRB, 0.374578E+00_JPRB, 0.355765E+00_JPRB &
  &, 0.337423E+00_JPRB, 0.319561E+00_JPRB, 0.302194E+00_JPRB &
  &, 0.285331E+00_JPRB, 0.268990E+00_JPRB, 0.253175E+00_JPRB, 0.237897E+00_JPRB &
  &, 0.223166E+00_JPRB, 0.208985E+00_JPRB, 0.195358E+00_JPRB &
  &, 0.182287E+00_JPRB, 0.169783E+00_JPRB, 0.157839E+00_JPRB, 0.146452E+00_JPRB &
  &, 0.135618E+00_JPRB, 0.125340E+00_JPRB, 0.115606E+00_JPRB &
  &, 0.106414E+00_JPRB, 0.977481E-01_JPRB, 0.895865E-01_JPRB, 0.819391E-01_JPRB &
  &, 0.747777E-01_JPRB, 0.681060E-01_JPRB, 0.618742E-01_JPRB &
  &, 0.560908E-01_JPRB, 0.507359E-01_JPRB, 0.457852E-01_JPRB, 0.412240E-01_JPRB &
  &, 0.370338E-01_JPRB, 0.331778E-01_JPRB, 0.296591E-01_JPRB &
  &, 0.264482E-01_JPRB, 0.235430E-01_JPRB, 0.208908E-01_JPRB, 0.184990E-01_JPRB &
  &, 0.163403E-01_JPRB, 0.144013E-01_JPRB, 0.126482E-01_JPRB &
  &, 0.110976E-01_JPRB, 0.971110E-02_JPRB, 0.846493E-02_JPRB, 0.737117E-02_JPRB &
  &, 0.640272E-02_JPRB, 0.552948E-02_JPRB, 0.478015E-02_JPRB &
  &, 0.412218E-02_JPRB, 0.354128E-02_JPRB, 0.304354E-02_JPRB, 0.259039E-02_JPRB &
  &, 0.220841E-02_JPRB, 0.187944E-02_JPRB, 0.158356E-02_JPRB &
  &, 0.134769E-02_JPRB, 0.112633E-02_JPRB, 0.946070E-03_JPRB, 0.809703E-03_JPRB &
  &, 0.667514E-03_JPRB, 0.546203E-03_JPRB, 0.474538E-03_JPRB &
  &, 0.372015E-03_JPRB, 0.322123E-03_JPRB, 0.270174E-03_JPRB, 0.216134E-03_JPRB &
  &, 0.159965E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.733299E-04_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 158, :) = (/ &
  &  0.899590E+00_JPRB, 0.874617E+00_JPRB, 0.849731E+00_JPRB, 0.824945E+00_JPRB &
  &, 0.800275E+00_JPRB, 0.775740E+00_JPRB, 0.751354E+00_JPRB &
  &, 0.727134E+00_JPRB, 0.703097E+00_JPRB, 0.679260E+00_JPRB, 0.655640E+00_JPRB &
  &, 0.632253E+00_JPRB, 0.609117E+00_JPRB, 0.586248E+00_JPRB &
  &, 0.563664E+00_JPRB, 0.541381E+00_JPRB, 0.519417E+00_JPRB, 0.497789E+00_JPRB &
  &, 0.476514E+00_JPRB, 0.455609E+00_JPRB, 0.435090E+00_JPRB &
  &, 0.414975E+00_JPRB, 0.395279E+00_JPRB, 0.376019E+00_JPRB, 0.357204E+00_JPRB &
  &, 0.338856E+00_JPRB, 0.320988E+00_JPRB, 0.303610E+00_JPRB &
  &, 0.286735E+00_JPRB, 0.270377E+00_JPRB, 0.254538E+00_JPRB, 0.239240E+00_JPRB &
  &, 0.224483E+00_JPRB, 0.210272E+00_JPRB, 0.196614E+00_JPRB &
  &, 0.183515E+00_JPRB, 0.170965E+00_JPRB, 0.158983E+00_JPRB, 0.147565E+00_JPRB &
  &, 0.136698E+00_JPRB, 0.126372E+00_JPRB, 0.116600E+00_JPRB &
  &, 0.107355E+00_JPRB, 0.986449E-01_JPRB, 0.904474E-01_JPRB, 0.827619E-01_JPRB &
  &, 0.755597E-01_JPRB, 0.688321E-01_JPRB, 0.625668E-01_JPRB &
  &, 0.567347E-01_JPRB, 0.513416E-01_JPRB, 0.463503E-01_JPRB, 0.417462E-01_JPRB &
  &, 0.375107E-01_JPRB, 0.336365E-01_JPRB, 0.300831E-01_JPRB &
  &, 0.268357E-01_JPRB, 0.238919E-01_JPRB, 0.212153E-01_JPRB, 0.187977E-01_JPRB &
  &, 0.166119E-01_JPRB, 0.146443E-01_JPRB, 0.128789E-01_JPRB &
  &, 0.112972E-01_JPRB, 0.987804E-02_JPRB, 0.863555E-02_JPRB, 0.750677E-02_JPRB &
  &, 0.652147E-02_JPRB, 0.565079E-02_JPRB, 0.488341E-02_JPRB &
  &, 0.420653E-02_JPRB, 0.362740E-02_JPRB, 0.310949E-02_JPRB, 0.265770E-02_JPRB &
  &, 0.225421E-02_JPRB, 0.192618E-02_JPRB, 0.163125E-02_JPRB &
  &, 0.137201E-02_JPRB, 0.117595E-02_JPRB, 0.971369E-03_JPRB, 0.835500E-03_JPRB &
  &, 0.693814E-03_JPRB, 0.573013E-03_JPRB, 0.474538E-03_JPRB &
  &, 0.399862E-03_JPRB, 0.322123E-03_JPRB, 0.270174E-03_JPRB, 0.216134E-03_JPRB &
  &, 0.189958E-03_JPRB, 0.132178E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 159, :) = (/ &
  &  0.899977E+00_JPRB, 0.875093E+00_JPRB, 0.850289E+00_JPRB, 0.825584E+00_JPRB &
  &, 0.800992E+00_JPRB, 0.776529E+00_JPRB, 0.752212E+00_JPRB &
  &, 0.728058E+00_JPRB, 0.704082E+00_JPRB, 0.680303E+00_JPRB, 0.656736E+00_JPRB &
  &, 0.633399E+00_JPRB, 0.610308E+00_JPRB, 0.587481E+00_JPRB &
  &, 0.564934E+00_JPRB, 0.542686E+00_JPRB, 0.520753E+00_JPRB, 0.499152E+00_JPRB &
  &, 0.477898E+00_JPRB, 0.457011E+00_JPRB, 0.436507E+00_JPRB &
  &, 0.416404E+00_JPRB, 0.396714E+00_JPRB, 0.377456E+00_JPRB, 0.358642E+00_JPRB &
  &, 0.340289E+00_JPRB, 0.322415E+00_JPRB, 0.305026E+00_JPRB &
  &, 0.288134E+00_JPRB, 0.271759E+00_JPRB, 0.255906E+00_JPRB, 0.240579E+00_JPRB &
  &, 0.225795E+00_JPRB, 0.211560E+00_JPRB, 0.197871E+00_JPRB &
  &, 0.184734E+00_JPRB, 0.172158E+00_JPRB, 0.160137E+00_JPRB, 0.148678E+00_JPRB &
  &, 0.137767E+00_JPRB, 0.127405E+00_JPRB, 0.117593E+00_JPRB &
  &, 0.108308E+00_JPRB, 0.995530E-01_JPRB, 0.913084E-01_JPRB, 0.835727E-01_JPRB &
  &, 0.763295E-01_JPRB, 0.695583E-01_JPRB, 0.632595E-01_JPRB &
  &, 0.573917E-01_JPRB, 0.519472E-01_JPRB, 0.469155E-01_JPRB, 0.422825E-01_JPRB &
  &, 0.380165E-01_JPRB, 0.340951E-01_JPRB, 0.305071E-01_JPRB &
  &, 0.272386E-01_JPRB, 0.242566E-01_JPRB, 0.215397E-01_JPRB, 0.190964E-01_JPRB &
  &, 0.168835E-01_JPRB, 0.148874E-01_JPRB, 0.131097E-01_JPRB &
  &, 0.114968E-01_JPRB, 0.100635E-01_JPRB, 0.878721E-02_JPRB, 0.766174E-02_JPRB &
  &, 0.666002E-02_JPRB, 0.577210E-02_JPRB, 0.498666E-02_JPRB &
  &, 0.431198E-02_JPRB, 0.369200E-02_JPRB, 0.317543E-02_JPRB, 0.272502E-02_JPRB &
  &, 0.232291E-02_JPRB, 0.197291E-02_JPRB, 0.167893E-02_JPRB &
  &, 0.142066E-02_JPRB, 0.120076E-02_JPRB, 0.102197E-02_JPRB, 0.835500E-03_JPRB &
  &, 0.720115E-03_JPRB, 0.599824E-03_JPRB, 0.501863E-03_JPRB &
  &, 0.399862E-03_JPRB, 0.350497E-03_JPRB, 0.270174E-03_JPRB, 0.216134E-03_JPRB &
  &, 0.189958E-03_JPRB, 0.162722E-03_JPRB, 0.103305E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.428094E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 160, :) = (/ &
  &  0.900363E+00_JPRB, 0.875566E+00_JPRB, 0.850846E+00_JPRB, 0.826222E+00_JPRB &
  &, 0.801705E+00_JPRB, 0.777315E+00_JPRB, 0.753067E+00_JPRB &
  &, 0.728978E+00_JPRB, 0.705064E+00_JPRB, 0.681342E+00_JPRB, 0.657829E+00_JPRB &
  &, 0.634541E+00_JPRB, 0.611495E+00_JPRB, 0.588711E+00_JPRB &
  &, 0.566202E+00_JPRB, 0.543988E+00_JPRB, 0.522085E+00_JPRB, 0.500510E+00_JPRB &
  &, 0.479280E+00_JPRB, 0.458410E+00_JPRB, 0.437921E+00_JPRB &
  &, 0.417830E+00_JPRB, 0.398145E+00_JPRB, 0.378892E+00_JPRB, 0.360077E+00_JPRB &
  &, 0.341723E+00_JPRB, 0.323838E+00_JPRB, 0.306438E+00_JPRB &
  &, 0.289538E+00_JPRB, 0.273142E+00_JPRB, 0.257269E+00_JPRB, 0.241922E+00_JPRB &
  &, 0.227111E+00_JPRB, 0.212847E+00_JPRB, 0.199127E+00_JPRB &
  &, 0.185962E+00_JPRB, 0.173350E+00_JPRB, 0.161291E+00_JPRB, 0.149791E+00_JPRB &
  &, 0.138846E+00_JPRB, 0.128438E+00_JPRB, 0.118587E+00_JPRB &
  &, 0.109260E+00_JPRB, 0.100461E+00_JPRB, 0.921810E-01_JPRB, 0.843954E-01_JPRB &
  &, 0.771115E-01_JPRB, 0.702970E-01_JPRB, 0.639521E-01_JPRB &
  &, 0.580486E-01_JPRB, 0.525663E-01_JPRB, 0.474944E-01_JPRB, 0.428189E-01_JPRB &
  &, 0.385078E-01_JPRB, 0.345537E-01_JPRB, 0.309311E-01_JPRB &
  &, 0.276260E-01_JPRB, 0.246055E-01_JPRB, 0.218805E-01_JPRB, 0.193952E-01_JPRB &
  &, 0.171551E-01_JPRB, 0.151478E-01_JPRB, 0.133227E-01_JPRB &
  &, 0.116964E-01_JPRB, 0.102490E-01_JPRB, 0.895782E-02_JPRB, 0.781671E-02_JPRB &
  &, 0.679856E-02_JPRB, 0.589341E-02_JPRB, 0.508991E-02_JPRB &
  &, 0.439633E-02_JPRB, 0.377813E-02_JPRB, 0.324138E-02_JPRB, 0.279233E-02_JPRB &
  &, 0.236871E-02_JPRB, 0.201965E-02_JPRB, 0.172661E-02_JPRB &
  &, 0.146930E-02_JPRB, 0.122556E-02_JPRB, 0.104727E-02_JPRB, 0.861297E-03_JPRB &
  &, 0.720115E-03_JPRB, 0.599824E-03_JPRB, 0.501863E-03_JPRB &
  &, 0.427709E-03_JPRB, 0.350497E-03_JPRB, 0.299082E-03_JPRB, 0.245581E-03_JPRB &
  &, 0.189958E-03_JPRB, 0.162722E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 161, :) = (/ &
  &  0.900746E+00_JPRB, 0.876037E+00_JPRB, 0.851402E+00_JPRB, 0.826856E+00_JPRB &
  &, 0.802416E+00_JPRB, 0.778099E+00_JPRB, 0.753920E+00_JPRB &
  &, 0.729895E+00_JPRB, 0.706042E+00_JPRB, 0.682378E+00_JPRB, 0.658919E+00_JPRB &
  &, 0.635680E+00_JPRB, 0.612680E+00_JPRB, 0.589938E+00_JPRB &
  &, 0.567467E+00_JPRB, 0.545287E+00_JPRB, 0.523414E+00_JPRB, 0.501865E+00_JPRB &
  &, 0.480657E+00_JPRB, 0.459806E+00_JPRB, 0.439335E+00_JPRB &
  &, 0.419252E+00_JPRB, 0.399576E+00_JPRB, 0.380326E+00_JPRB, 0.361513E+00_JPRB &
  &, 0.343152E+00_JPRB, 0.325261E+00_JPRB, 0.307854E+00_JPRB &
  &, 0.290938E+00_JPRB, 0.274528E+00_JPRB, 0.258633E+00_JPRB, 0.243264E+00_JPRB &
  &, 0.228427E+00_JPRB, 0.214134E+00_JPRB, 0.200384E+00_JPRB &
  &, 0.187189E+00_JPRB, 0.174542E+00_JPRB, 0.162444E+00_JPRB, 0.150914E+00_JPRB &
  &, 0.139925E+00_JPRB, 0.129481E+00_JPRB, 0.119581E+00_JPRB &
  &, 0.110213E+00_JPRB, 0.101369E+00_JPRB, 0.930420E-01_JPRB, 0.852301E-01_JPRB &
  &, 0.778935E-01_JPRB, 0.710357E-01_JPRB, 0.646448E-01_JPRB &
  &, 0.586925E-01_JPRB, 0.531854E-01_JPRB, 0.480733E-01_JPRB, 0.433552E-01_JPRB &
  &, 0.390136E-01_JPRB, 0.350123E-01_JPRB, 0.313551E-01_JPRB &
  &, 0.280134E-01_JPRB, 0.249702E-01_JPRB, 0.222049E-01_JPRB, 0.197105E-01_JPRB &
  &, 0.174437E-01_JPRB, 0.153908E-01_JPRB, 0.135534E-01_JPRB &
  &, 0.119142E-01_JPRB, 0.104345E-01_JPRB, 0.912844E-02_JPRB, 0.797169E-02_JPRB &
  &, 0.691731E-02_JPRB, 0.601471E-02_JPRB, 0.521381E-02_JPRB &
  &, 0.450177E-02_JPRB, 0.386426E-02_JPRB, 0.332931E-02_JPRB, 0.285965E-02_JPRB &
  &, 0.243741E-02_JPRB, 0.206638E-02_JPRB, 0.177430E-02_JPRB &
  &, 0.149362E-02_JPRB, 0.127518E-02_JPRB, 0.107257E-02_JPRB, 0.887094E-03_JPRB &
  &, 0.746415E-03_JPRB, 0.626634E-03_JPRB, 0.529189E-03_JPRB &
  &, 0.427709E-03_JPRB, 0.350497E-03_JPRB, 0.299082E-03_JPRB, 0.245581E-03_JPRB &
  &, 0.189958E-03_JPRB, 0.162722E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART24

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART24',0,ZHOOK_HANDLE)

XCW( 162, :) = (/ &
  &  0.901130E+00_JPRB, 0.876507E+00_JPRB, 0.851955E+00_JPRB, 0.827489E+00_JPRB &
  &, 0.803125E+00_JPRB, 0.778880E+00_JPRB, 0.754770E+00_JPRB &
  &, 0.730810E+00_JPRB, 0.707018E+00_JPRB, 0.683411E+00_JPRB, 0.660004E+00_JPRB &
  &, 0.636816E+00_JPRB, 0.613863E+00_JPRB, 0.591161E+00_JPRB &
  &, 0.568728E+00_JPRB, 0.546582E+00_JPRB, 0.524740E+00_JPRB, 0.503218E+00_JPRB &
  &, 0.482033E+00_JPRB, 0.461202E+00_JPRB, 0.440742E+00_JPRB &
  &, 0.420671E+00_JPRB, 0.401004E+00_JPRB, 0.381755E+00_JPRB, 0.362944E+00_JPRB &
  &, 0.344582E+00_JPRB, 0.326684E+00_JPRB, 0.309266E+00_JPRB &
  &, 0.292334E+00_JPRB, 0.275910E+00_JPRB, 0.259996E+00_JPRB, 0.244603E+00_JPRB &
  &, 0.229743E+00_JPRB, 0.215422E+00_JPRB, 0.201645E+00_JPRB &
  &, 0.188408E+00_JPRB, 0.175734E+00_JPRB, 0.163608E+00_JPRB, 0.152027E+00_JPRB &
  &, 0.141004E+00_JPRB, 0.130524E+00_JPRB, 0.120575E+00_JPRB &
  &, 0.111176E+00_JPRB, 0.102289E+00_JPRB, 0.939146E-01_JPRB, 0.860529E-01_JPRB &
  &, 0.786755E-01_JPRB, 0.717869E-01_JPRB, 0.653503E-01_JPRB &
  &, 0.593626E-01_JPRB, 0.538045E-01_JPRB, 0.486522E-01_JPRB, 0.438916E-01_JPRB &
  &, 0.395050E-01_JPRB, 0.354857E-01_JPRB, 0.317942E-01_JPRB &
  &, 0.284164E-01_JPRB, 0.253508E-01_JPRB, 0.225457E-01_JPRB, 0.200093E-01_JPRB &
  &, 0.177153E-01_JPRB, 0.156512E-01_JPRB, 0.138019E-01_JPRB &
  &, 0.121319E-01_JPRB, 0.106386E-01_JPRB, 0.929905E-02_JPRB, 0.810729E-02_JPRB &
  &, 0.705585E-02_JPRB, 0.613602E-02_JPRB, 0.531706E-02_JPRB &
  &, 0.458612E-02_JPRB, 0.395039E-02_JPRB, 0.339526E-02_JPRB, 0.292696E-02_JPRB &
  &, 0.248321E-02_JPRB, 0.213649E-02_JPRB, 0.182198E-02_JPRB &
  &, 0.154226E-02_JPRB, 0.129999E-02_JPRB, 0.109786E-02_JPRB, 0.912891E-03_JPRB &
  &, 0.772716E-03_JPRB, 0.653444E-03_JPRB, 0.529189E-03_JPRB &
  &, 0.455557E-03_JPRB, 0.378872E-03_JPRB, 0.299082E-03_JPRB, 0.245581E-03_JPRB &
  &, 0.189958E-03_JPRB, 0.162722E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 163, :) = (/ &
  &  0.901510E+00_JPRB, 0.876975E+00_JPRB, 0.852505E+00_JPRB, 0.828120E+00_JPRB &
  &, 0.803831E+00_JPRB, 0.779658E+00_JPRB, 0.755616E+00_JPRB &
  &, 0.731722E+00_JPRB, 0.707991E+00_JPRB, 0.684440E+00_JPRB, 0.661088E+00_JPRB &
  &, 0.637948E+00_JPRB, 0.615041E+00_JPRB, 0.592381E+00_JPRB &
  &, 0.569987E+00_JPRB, 0.547876E+00_JPRB, 0.526063E+00_JPRB, 0.504567E+00_JPRB &
  &, 0.483405E+00_JPRB, 0.462592E+00_JPRB, 0.442149E+00_JPRB &
  &, 0.422090E+00_JPRB, 0.402428E+00_JPRB, 0.383185E+00_JPRB, 0.364376E+00_JPRB &
  &, 0.346011E+00_JPRB, 0.328107E+00_JPRB, 0.310674E+00_JPRB &
  &, 0.293734E+00_JPRB, 0.277293E+00_JPRB, 0.261360E+00_JPRB, 0.245946E+00_JPRB &
  &, 0.231059E+00_JPRB, 0.216709E+00_JPRB, 0.202901E+00_JPRB &
  &, 0.189636E+00_JPRB, 0.176926E+00_JPRB, 0.164762E+00_JPRB, 0.153149E+00_JPRB &
  &, 0.142084E+00_JPRB, 0.131557E+00_JPRB, 0.121580E+00_JPRB &
  &, 0.112129E+00_JPRB, 0.103208E+00_JPRB, 0.947988E-01_JPRB, 0.868875E-01_JPRB &
  &, 0.794698E-01_JPRB, 0.725255E-01_JPRB, 0.660558E-01_JPRB &
  &, 0.600196E-01_JPRB, 0.544236E-01_JPRB, 0.492311E-01_JPRB, 0.444420E-01_JPRB &
  &, 0.400108E-01_JPRB, 0.359591E-01_JPRB, 0.322333E-01_JPRB &
  &, 0.288193E-01_JPRB, 0.257155E-01_JPRB, 0.228864E-01_JPRB, 0.203246E-01_JPRB &
  &, 0.180039E-01_JPRB, 0.159116E-01_JPRB, 0.140327E-01_JPRB &
  &, 0.123316E-01_JPRB, 0.108240E-01_JPRB, 0.946967E-02_JPRB, 0.826226E-02_JPRB &
  &, 0.721418E-02_JPRB, 0.625733E-02_JPRB, 0.542031E-02_JPRB &
  &, 0.469156E-02_JPRB, 0.403652E-02_JPRB, 0.348319E-02_JPRB, 0.299428E-02_JPRB &
  &, 0.255191E-02_JPRB, 0.218322E-02_JPRB, 0.184582E-02_JPRB &
  &, 0.156659E-02_JPRB, 0.132479E-02_JPRB, 0.112316E-02_JPRB, 0.938688E-03_JPRB &
  &, 0.799016E-03_JPRB, 0.653444E-03_JPRB, 0.556515E-03_JPRB &
  &, 0.455557E-03_JPRB, 0.378872E-03_JPRB, 0.327991E-03_JPRB, 0.245581E-03_JPRB &
  &, 0.219951E-03_JPRB, 0.162722E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.744684E-04_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 164, :) = (/ &
  &  0.901889E+00_JPRB, 0.877441E+00_JPRB, 0.853055E+00_JPRB, 0.828747E+00_JPRB &
  &, 0.804535E+00_JPRB, 0.780434E+00_JPRB, 0.756460E+00_JPRB &
  &, 0.732630E+00_JPRB, 0.708960E+00_JPRB, 0.685467E+00_JPRB, 0.662168E+00_JPRB &
  &, 0.639078E+00_JPRB, 0.616216E+00_JPRB, 0.593599E+00_JPRB &
  &, 0.571243E+00_JPRB, 0.549166E+00_JPRB, 0.527384E+00_JPRB, 0.505914E+00_JPRB &
  &, 0.484775E+00_JPRB, 0.463981E+00_JPRB, 0.443553E+00_JPRB &
  &, 0.423506E+00_JPRB, 0.403853E+00_JPRB, 0.384615E+00_JPRB, 0.365804E+00_JPRB &
  &, 0.347437E+00_JPRB, 0.329526E+00_JPRB, 0.312086E+00_JPRB &
  &, 0.295130E+00_JPRB, 0.278671E+00_JPRB, 0.262719E+00_JPRB, 0.247285E+00_JPRB &
  &, 0.232376E+00_JPRB, 0.218001E+00_JPRB, 0.204162E+00_JPRB &
  &, 0.190873E+00_JPRB, 0.178118E+00_JPRB, 0.165925E+00_JPRB, 0.154272E+00_JPRB &
  &, 0.143163E+00_JPRB, 0.132611E+00_JPRB, 0.122585E+00_JPRB &
  &, 0.113092E+00_JPRB, 0.104128E+00_JPRB, 0.956715E-01_JPRB, 0.877222E-01_JPRB &
  &, 0.802640E-01_JPRB, 0.732767E-01_JPRB, 0.667612E-01_JPRB &
  &, 0.606898E-01_JPRB, 0.550427E-01_JPRB, 0.498238E-01_JPRB, 0.449784E-01_JPRB &
  &, 0.405310E-01_JPRB, 0.364325E-01_JPRB, 0.326725E-01_JPRB &
  &, 0.292222E-01_JPRB, 0.260961E-01_JPRB, 0.232271E-01_JPRB, 0.206400E-01_JPRB &
  &, 0.182925E-01_JPRB, 0.161720E-01_JPRB, 0.142635E-01_JPRB &
  &, 0.125493E-01_JPRB, 0.110281E-01_JPRB, 0.965924E-02_JPRB, 0.843660E-02_JPRB &
  &, 0.735273E-02_JPRB, 0.637863E-02_JPRB, 0.554421E-02_JPRB &
  &, 0.479700E-02_JPRB, 0.412264E-02_JPRB, 0.354913E-02_JPRB, 0.306159E-02_JPRB &
  &, 0.262061E-02_JPRB, 0.222996E-02_JPRB, 0.189351E-02_JPRB &
  &, 0.161523E-02_JPRB, 0.137441E-02_JPRB, 0.114846E-02_JPRB, 0.964485E-03_JPRB &
  &, 0.825317E-03_JPRB, 0.680254E-03_JPRB, 0.583841E-03_JPRB &
  &, 0.483404E-03_JPRB, 0.407247E-03_JPRB, 0.327991E-03_JPRB, 0.275029E-03_JPRB &
  &, 0.219951E-03_JPRB, 0.193266E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 165, :) = (/ &
  &  0.902269E+00_JPRB, 0.877906E+00_JPRB, 0.853601E+00_JPRB, 0.829373E+00_JPRB &
  &, 0.805237E+00_JPRB, 0.781207E+00_JPRB, 0.757301E+00_JPRB &
  &, 0.733536E+00_JPRB, 0.709927E+00_JPRB, 0.686490E+00_JPRB, 0.663242E+00_JPRB &
  &, 0.640204E+00_JPRB, 0.617389E+00_JPRB, 0.594813E+00_JPRB &
  &, 0.572496E+00_JPRB, 0.550451E+00_JPRB, 0.528701E+00_JPRB, 0.507258E+00_JPRB &
  &, 0.486141E+00_JPRB, 0.465368E+00_JPRB, 0.444954E+00_JPRB &
  &, 0.424918E+00_JPRB, 0.405274E+00_JPRB, 0.386041E+00_JPRB, 0.367229E+00_JPRB &
  &, 0.348859E+00_JPRB, 0.330946E+00_JPRB, 0.313494E+00_JPRB &
  &, 0.296529E+00_JPRB, 0.280053E+00_JPRB, 0.264083E+00_JPRB, 0.248627E+00_JPRB &
  &, 0.233696E+00_JPRB, 0.219293E+00_JPRB, 0.205428E+00_JPRB &
  &, 0.192100E+00_JPRB, 0.179320E+00_JPRB, 0.167089E+00_JPRB, 0.155395E+00_JPRB &
  &, 0.144253E+00_JPRB, 0.133654E+00_JPRB, 0.123589E+00_JPRB &
  &, 0.114056E+00_JPRB, 0.105047E+00_JPRB, 0.965557E-01_JPRB, 0.885569E-01_JPRB &
  &, 0.810582E-01_JPRB, 0.740279E-01_JPRB, 0.674667E-01_JPRB &
  &, 0.613599E-01_JPRB, 0.556753E-01_JPRB, 0.504027E-01_JPRB, 0.455288E-01_JPRB &
  &, 0.410368E-01_JPRB, 0.369059E-01_JPRB, 0.331116E-01_JPRB &
  &, 0.296406E-01_JPRB, 0.264608E-01_JPRB, 0.235840E-01_JPRB, 0.209553E-01_JPRB &
  &, 0.185811E-01_JPRB, 0.164324E-01_JPRB, 0.145120E-01_JPRB &
  &, 0.127671E-01_JPRB, 0.112136E-01_JPRB, 0.982985E-02_JPRB, 0.859157E-02_JPRB &
  &, 0.749127E-02_JPRB, 0.652016E-02_JPRB, 0.564746E-02_JPRB &
  &, 0.488135E-02_JPRB, 0.423030E-02_JPRB, 0.363706E-02_JPRB, 0.312890E-02_JPRB &
  &, 0.266641E-02_JPRB, 0.227670E-02_JPRB, 0.194119E-02_JPRB &
  &, 0.166387E-02_JPRB, 0.139922E-02_JPRB, 0.119906E-02_JPRB, 0.990281E-03_JPRB &
  &, 0.851617E-03_JPRB, 0.707064E-03_JPRB, 0.583841E-03_JPRB &
  &, 0.483404E-03_JPRB, 0.407247E-03_JPRB, 0.327991E-03_JPRB, 0.275029E-03_JPRB &
  &, 0.219951E-03_JPRB, 0.193266E-03_JPRB, 0.134407E-03_JPRB &
  &, 0.104995E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.433905E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 166, :) = (/ &
  &  0.902646E+00_JPRB, 0.878368E+00_JPRB, 0.854146E+00_JPRB, 0.829998E+00_JPRB &
  &, 0.805936E+00_JPRB, 0.781978E+00_JPRB, 0.758140E+00_JPRB &
  &, 0.734439E+00_JPRB, 0.710890E+00_JPRB, 0.687511E+00_JPRB, 0.664318E+00_JPRB &
  &, 0.641327E+00_JPRB, 0.618557E+00_JPRB, 0.596024E+00_JPRB &
  &, 0.573744E+00_JPRB, 0.551736E+00_JPRB, 0.530015E+00_JPRB, 0.508600E+00_JPRB &
  &, 0.487506E+00_JPRB, 0.466751E+00_JPRB, 0.446355E+00_JPRB &
  &, 0.426331E+00_JPRB, 0.406695E+00_JPRB, 0.387464E+00_JPRB, 0.368657E+00_JPRB &
  &, 0.350285E+00_JPRB, 0.332361E+00_JPRB, 0.314902E+00_JPRB &
  &, 0.297925E+00_JPRB, 0.281436E+00_JPRB, 0.265446E+00_JPRB, 0.249970E+00_JPRB &
  &, 0.235012E+00_JPRB, 0.220585E+00_JPRB, 0.206689E+00_JPRB &
  &, 0.193328E+00_JPRB, 0.180521E+00_JPRB, 0.168253E+00_JPRB, 0.156528E+00_JPRB &
  &, 0.145342E+00_JPRB, 0.134708E+00_JPRB, 0.124594E+00_JPRB &
  &, 0.115030E+00_JPRB, 0.105978E+00_JPRB, 0.974400E-01_JPRB, 0.894035E-01_JPRB &
  &, 0.818525E-01_JPRB, 0.747916E-01_JPRB, 0.681850E-01_JPRB &
  &, 0.620300E-01_JPRB, 0.563078E-01_JPRB, 0.509954E-01_JPRB, 0.460934E-01_JPRB &
  &, 0.415570E-01_JPRB, 0.373793E-01_JPRB, 0.335507E-01_JPRB &
  &, 0.300436E-01_JPRB, 0.268414E-01_JPRB, 0.239247E-01_JPRB, 0.212706E-01_JPRB &
  &, 0.188697E-01_JPRB, 0.167102E-01_JPRB, 0.147427E-01_JPRB &
  &, 0.129848E-01_JPRB, 0.114176E-01_JPRB, 0.100005E-01_JPRB, 0.874655E-02_JPRB &
  &, 0.762981E-02_JPRB, 0.664147E-02_JPRB, 0.577136E-02_JPRB &
  &, 0.498680E-02_JPRB, 0.431643E-02_JPRB, 0.372499E-02_JPRB, 0.319622E-02_JPRB &
  &, 0.273511E-02_JPRB, 0.234680E-02_JPRB, 0.198887E-02_JPRB &
  &, 0.168820E-02_JPRB, 0.144883E-02_JPRB, 0.122436E-02_JPRB, 0.104188E-02_JPRB &
  &, 0.877918E-03_JPRB, 0.733874E-03_JPRB, 0.611166E-03_JPRB &
  &, 0.511251E-03_JPRB, 0.407247E-03_JPRB, 0.356899E-03_JPRB, 0.275029E-03_JPRB &
  &, 0.219951E-03_JPRB, 0.193266E-03_JPRB, 0.165508E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 167, :) = (/ &
  &  0.903021E+00_JPRB, 0.878829E+00_JPRB, 0.854690E+00_JPRB, 0.830619E+00_JPRB &
  &, 0.806632E+00_JPRB, 0.782746E+00_JPRB, 0.758976E+00_JPRB &
  &, 0.735339E+00_JPRB, 0.711851E+00_JPRB, 0.688529E+00_JPRB, 0.665389E+00_JPRB &
  &, 0.642448E+00_JPRB, 0.619723E+00_JPRB, 0.597231E+00_JPRB &
  &, 0.574990E+00_JPRB, 0.553016E+00_JPRB, 0.531326E+00_JPRB, 0.509938E+00_JPRB &
  &, 0.488868E+00_JPRB, 0.468134E+00_JPRB, 0.447752E+00_JPRB &
  &, 0.427740E+00_JPRB, 0.408113E+00_JPRB, 0.388887E+00_JPRB, 0.370081E+00_JPRB &
  &, 0.351704E+00_JPRB, 0.333777E+00_JPRB, 0.316310E+00_JPRB &
  &, 0.299321E+00_JPRB, 0.282814E+00_JPRB, 0.266809E+00_JPRB, 0.251313E+00_JPRB &
  &, 0.236328E+00_JPRB, 0.221877E+00_JPRB, 0.207950E+00_JPRB &
  &, 0.194565E+00_JPRB, 0.181713E+00_JPRB, 0.169416E+00_JPRB, 0.157651E+00_JPRB &
  &, 0.146432E+00_JPRB, 0.135751E+00_JPRB, 0.125610E+00_JPRB &
  &, 0.115994E+00_JPRB, 0.106898E+00_JPRB, 0.983242E-01_JPRB, 0.902501E-01_JPRB &
  &, 0.826589E-01_JPRB, 0.755554E-01_JPRB, 0.689033E-01_JPRB &
  &, 0.627133E-01_JPRB, 0.569404E-01_JPRB, 0.516019E-01_JPRB, 0.466439E-01_JPRB &
  &, 0.420773E-01_JPRB, 0.378675E-01_JPRB, 0.340050E-01_JPRB &
  &, 0.304620E-01_JPRB, 0.272220E-01_JPRB, 0.242817E-01_JPRB, 0.216026E-01_JPRB &
  &, 0.191752E-01_JPRB, 0.169706E-01_JPRB, 0.149912E-01_JPRB &
  &, 0.132207E-01_JPRB, 0.116216E-01_JPRB, 0.101900E-01_JPRB, 0.892089E-02_JPRB &
  &, 0.778814E-02_JPRB, 0.678299E-02_JPRB, 0.589526E-02_JPRB &
  &, 0.509224E-02_JPRB, 0.440256E-02_JPRB, 0.379094E-02_JPRB, 0.326353E-02_JPRB &
  &, 0.280381E-02_JPRB, 0.239354E-02_JPRB, 0.203656E-02_JPRB &
  &, 0.173684E-02_JPRB, 0.147364E-02_JPRB, 0.124966E-02_JPRB, 0.106767E-02_JPRB &
  &, 0.877918E-03_JPRB, 0.760685E-03_JPRB, 0.638492E-03_JPRB &
  &, 0.511251E-03_JPRB, 0.435622E-03_JPRB, 0.356899E-03_JPRB, 0.304477E-03_JPRB &
  &, 0.249944E-03_JPRB, 0.193266E-03_JPRB, 0.165508E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 168, :) = (/ &
  &  0.903396E+00_JPRB, 0.879290E+00_JPRB, 0.855231E+00_JPRB, 0.831239E+00_JPRB &
  &, 0.807327E+00_JPRB, 0.783512E+00_JPRB, 0.759809E+00_JPRB &
  &, 0.736237E+00_JPRB, 0.712809E+00_JPRB, 0.689544E+00_JPRB, 0.666457E+00_JPRB &
  &, 0.643565E+00_JPRB, 0.620886E+00_JPRB, 0.598436E+00_JPRB &
  &, 0.576234E+00_JPRB, 0.554294E+00_JPRB, 0.532635E+00_JPRB, 0.511273E+00_JPRB &
  &, 0.490226E+00_JPRB, 0.469511E+00_JPRB, 0.449146E+00_JPRB &
  &, 0.429146E+00_JPRB, 0.409527E+00_JPRB, 0.390307E+00_JPRB, 0.371502E+00_JPRB &
  &, 0.353126E+00_JPRB, 0.335193E+00_JPRB, 0.317719E+00_JPRB &
  &, 0.300717E+00_JPRB, 0.284197E+00_JPRB, 0.268173E+00_JPRB, 0.252652E+00_JPRB &
  &, 0.237649E+00_JPRB, 0.223169E+00_JPRB, 0.209215E+00_JPRB &
  &, 0.195793E+00_JPRB, 0.182915E+00_JPRB, 0.170580E+00_JPRB, 0.158784E+00_JPRB &
  &, 0.147531E+00_JPRB, 0.136805E+00_JPRB, 0.126625E+00_JPRB &
  &, 0.116968E+00_JPRB, 0.107840E+00_JPRB, 0.992085E-01_JPRB, 0.910967E-01_JPRB &
  &, 0.834654E-01_JPRB, 0.763191E-01_JPRB, 0.696216E-01_JPRB &
  &, 0.633834E-01_JPRB, 0.575864E-01_JPRB, 0.521946E-01_JPRB, 0.472085E-01_JPRB &
  &, 0.425975E-01_JPRB, 0.383557E-01_JPRB, 0.344593E-01_JPRB &
  &, 0.308804E-01_JPRB, 0.276184E-01_JPRB, 0.246386E-01_JPRB, 0.219345E-01_JPRB &
  &, 0.194638E-01_JPRB, 0.172483E-01_JPRB, 0.152397E-01_JPRB &
  &, 0.134385E-01_JPRB, 0.118257E-01_JPRB, 0.103796E-01_JPRB, 0.907586E-02_JPRB &
  &, 0.792669E-02_JPRB, 0.690430E-02_JPRB, 0.599851E-02_JPRB &
  &, 0.519768E-02_JPRB, 0.451022E-02_JPRB, 0.387886E-02_JPRB, 0.333085E-02_JPRB &
  &, 0.287251E-02_JPRB, 0.246364E-02_JPRB, 0.210808E-02_JPRB &
  &, 0.178548E-02_JPRB, 0.152325E-02_JPRB, 0.127496E-02_JPRB, 0.109347E-02_JPRB &
  &, 0.904218E-03_JPRB, 0.760685E-03_JPRB, 0.638492E-03_JPRB &
  &, 0.539098E-03_JPRB, 0.435622E-03_JPRB, 0.356899E-03_JPRB, 0.304477E-03_JPRB &
  &, 0.249944E-03_JPRB, 0.193266E-03_JPRB, 0.165508E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART25

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART25',0,ZHOOK_HANDLE)

XCW( 169, :) = (/ &
  &  0.903769E+00_JPRB, 0.879747E+00_JPRB, 0.855770E+00_JPRB, 0.831856E+00_JPRB &
  &, 0.808019E+00_JPRB, 0.784275E+00_JPRB, 0.760640E+00_JPRB &
  &, 0.737131E+00_JPRB, 0.713764E+00_JPRB, 0.690555E+00_JPRB, 0.667521E+00_JPRB &
  &, 0.644679E+00_JPRB, 0.622046E+00_JPRB, 0.599639E+00_JPRB &
  &, 0.577474E+00_JPRB, 0.555568E+00_JPRB, 0.533940E+00_JPRB, 0.512607E+00_JPRB &
  &, 0.491583E+00_JPRB, 0.470888E+00_JPRB, 0.450538E+00_JPRB &
  &, 0.430551E+00_JPRB, 0.410941E+00_JPRB, 0.391726E+00_JPRB, 0.372923E+00_JPRB &
  &, 0.354544E+00_JPRB, 0.336608E+00_JPRB, 0.319123E+00_JPRB &
  &, 0.302109E+00_JPRB, 0.285575E+00_JPRB, 0.269532E+00_JPRB, 0.253995E+00_JPRB &
  &, 0.238969E+00_JPRB, 0.224460E+00_JPRB, 0.210481E+00_JPRB &
  &, 0.197030E+00_JPRB, 0.184117E+00_JPRB, 0.171743E+00_JPRB, 0.159917E+00_JPRB &
  &, 0.148621E+00_JPRB, 0.137869E+00_JPRB, 0.127641E+00_JPRB &
  &, 0.117943E+00_JPRB, 0.108771E+00_JPRB, 0.100104E+00_JPRB, 0.919433E-01_JPRB &
  &, 0.842718E-01_JPRB, 0.770828E-01_JPRB, 0.703528E-01_JPRB &
  &, 0.640667E-01_JPRB, 0.582324E-01_JPRB, 0.528011E-01_JPRB, 0.477730E-01_JPRB &
  &, 0.431322E-01_JPRB, 0.388439E-01_JPRB, 0.349136E-01_JPRB &
  &, 0.312988E-01_JPRB, 0.279990E-01_JPRB, 0.249955E-01_JPRB, 0.222499E-01_JPRB &
  &, 0.197694E-01_JPRB, 0.175261E-01_JPRB, 0.154882E-01_JPRB &
  &, 0.136744E-01_JPRB, 0.120297E-01_JPRB, 0.105692E-01_JPRB, 0.925021E-02_JPRB &
  &, 0.808502E-02_JPRB, 0.704583E-02_JPRB, 0.612241E-02_JPRB &
  &, 0.530312E-02_JPRB, 0.459635E-02_JPRB, 0.396679E-02_JPRB, 0.342060E-02_JPRB &
  &, 0.294121E-02_JPRB, 0.251038E-02_JPRB, 0.215577E-02_JPRB &
  &, 0.183413E-02_JPRB, 0.154806E-02_JPRB, 0.132556E-02_JPRB, 0.111927E-02_JPRB &
  &, 0.930519E-03_JPRB, 0.787495E-03_JPRB, 0.665818E-03_JPRB &
  &, 0.566946E-03_JPRB, 0.463997E-03_JPRB, 0.385807E-03_JPRB, 0.304477E-03_JPRB &
  &, 0.249944E-03_JPRB, 0.223811E-03_JPRB, 0.165508E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.756187E-04_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 170, :) = (/ &
  &  0.904141E+00_JPRB, 0.880204E+00_JPRB, 0.856308E+00_JPRB, 0.832472E+00_JPRB &
  &, 0.808709E+00_JPRB, 0.785035E+00_JPRB, 0.761468E+00_JPRB &
  &, 0.738023E+00_JPRB, 0.714716E+00_JPRB, 0.691564E+00_JPRB, 0.668584E+00_JPRB &
  &, 0.645791E+00_JPRB, 0.623204E+00_JPRB, 0.600838E+00_JPRB &
  &, 0.578711E+00_JPRB, 0.556841E+00_JPRB, 0.535244E+00_JPRB, 0.513937E+00_JPRB &
  &, 0.492937E+00_JPRB, 0.472261E+00_JPRB, 0.451928E+00_JPRB &
  &, 0.431954E+00_JPRB, 0.412352E+00_JPRB, 0.393145E+00_JPRB, 0.374341E+00_JPRB &
  &, 0.355963E+00_JPRB, 0.338020E+00_JPRB, 0.320531E+00_JPRB &
  &, 0.303505E+00_JPRB, 0.286957E+00_JPRB, 0.270896E+00_JPRB, 0.255337E+00_JPRB &
  &, 0.240286E+00_JPRB, 0.225757E+00_JPRB, 0.211746E+00_JPRB &
  &, 0.198267E+00_JPRB, 0.185328E+00_JPRB, 0.172917E+00_JPRB, 0.161049E+00_JPRB &
  &, 0.149721E+00_JPRB, 0.138923E+00_JPRB, 0.128656E+00_JPRB &
  &, 0.118928E+00_JPRB, 0.109701E+00_JPRB, 0.101000E+00_JPRB, 0.928018E-01_JPRB &
  &, 0.850905E-01_JPRB, 0.778465E-01_JPRB, 0.710839E-01_JPRB &
  &, 0.647631E-01_JPRB, 0.588784E-01_JPRB, 0.534075E-01_JPRB, 0.483376E-01_JPRB &
  &, 0.436524E-01_JPRB, 0.393469E-01_JPRB, 0.353679E-01_JPRB &
  &, 0.317328E-01_JPRB, 0.283955E-01_JPRB, 0.253525E-01_JPRB, 0.225818E-01_JPRB &
  &, 0.200749E-01_JPRB, 0.178038E-01_JPRB, 0.157545E-01_JPRB &
  &, 0.138922E-01_JPRB, 0.122338E-01_JPRB, 0.107588E-01_JPRB, 0.942455E-02_JPRB &
  &, 0.824335E-02_JPRB, 0.718735E-02_JPRB, 0.624631E-02_JPRB &
  &, 0.542965E-02_JPRB, 0.470401E-02_JPRB, 0.405472E-02_JPRB, 0.348791E-02_JPRB &
  &, 0.300991E-02_JPRB, 0.258048E-02_JPRB, 0.220345E-02_JPRB &
  &, 0.188277E-02_JPRB, 0.159768E-02_JPRB, 0.135086E-02_JPRB, 0.114506E-02_JPRB &
  &, 0.956820E-03_JPRB, 0.814305E-03_JPRB, 0.693144E-03_JPRB &
  &, 0.566946E-03_JPRB, 0.463997E-03_JPRB, 0.385807E-03_JPRB, 0.333924E-03_JPRB &
  &, 0.279937E-03_JPRB, 0.223811E-03_JPRB, 0.165508E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 171, :) = (/ &
  &  0.904512E+00_JPRB, 0.880658E+00_JPRB, 0.856844E+00_JPRB, 0.833085E+00_JPRB &
  &, 0.809396E+00_JPRB, 0.785794E+00_JPRB, 0.762294E+00_JPRB &
  &, 0.738912E+00_JPRB, 0.715666E+00_JPRB, 0.692570E+00_JPRB, 0.669643E+00_JPRB &
  &, 0.646900E+00_JPRB, 0.624357E+00_JPRB, 0.602035E+00_JPRB &
  &, 0.579945E+00_JPRB, 0.558110E+00_JPRB, 0.536543E+00_JPRB, 0.515265E+00_JPRB &
  &, 0.494288E+00_JPRB, 0.473632E+00_JPRB, 0.453316E+00_JPRB &
  &, 0.433353E+00_JPRB, 0.413763E+00_JPRB, 0.394558E+00_JPRB, 0.375761E+00_JPRB &
  &, 0.357378E+00_JPRB, 0.339432E+00_JPRB, 0.321936E+00_JPRB &
  &, 0.304897E+00_JPRB, 0.288336E+00_JPRB, 0.272259E+00_JPRB, 0.256680E+00_JPRB &
  &, 0.241606E+00_JPRB, 0.227049E+00_JPRB, 0.213016E+00_JPRB &
  &, 0.199504E+00_JPRB, 0.186529E+00_JPRB, 0.174090E+00_JPRB, 0.162182E+00_JPRB &
  &, 0.150821E+00_JPRB, 0.139987E+00_JPRB, 0.129682E+00_JPRB &
  &, 0.119903E+00_JPRB, 0.110644E+00_JPRB, 0.101896E+00_JPRB, 0.936603E-01_JPRB &
  &, 0.858969E-01_JPRB, 0.786227E-01_JPRB, 0.718150E-01_JPRB &
  &, 0.654464E-01_JPRB, 0.595245E-01_JPRB, 0.540140E-01_JPRB, 0.489163E-01_JPRB &
  &, 0.441871E-01_JPRB, 0.398351E-01_JPRB, 0.358373E-01_JPRB &
  &, 0.321512E-01_JPRB, 0.287919E-01_JPRB, 0.257256E-01_JPRB, 0.229303E-01_JPRB &
  &, 0.203805E-01_JPRB, 0.180816E-01_JPRB, 0.160030E-01_JPRB &
  &, 0.141281E-01_JPRB, 0.124563E-01_JPRB, 0.109483E-01_JPRB, 0.959889E-02_JPRB &
  &, 0.838189E-02_JPRB, 0.732887E-02_JPRB, 0.637021E-02_JPRB &
  &, 0.553509E-02_JPRB, 0.479014E-02_JPRB, 0.414265E-02_JPRB, 0.357767E-02_JPRB &
  &, 0.307861E-02_JPRB, 0.262722E-02_JPRB, 0.225113E-02_JPRB &
  &, 0.193141E-02_JPRB, 0.164729E-02_JPRB, 0.140145E-02_JPRB, 0.117086E-02_JPRB &
  &, 0.983120E-03_JPRB, 0.841115E-03_JPRB, 0.693144E-03_JPRB &
  &, 0.594793E-03_JPRB, 0.492371E-03_JPRB, 0.414715E-03_JPRB, 0.333924E-03_JPRB &
  &, 0.279937E-03_JPRB, 0.223811E-03_JPRB, 0.196610E-03_JPRB &
  &, 0.136660E-03_JPRB, 0.106703E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.439776E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 172, :) = (/ &
  &  0.904880E+00_JPRB, 0.881111E+00_JPRB, 0.857378E+00_JPRB, 0.833697E+00_JPRB &
  &, 0.810082E+00_JPRB, 0.786550E+00_JPRB, 0.763117E+00_JPRB &
  &, 0.739799E+00_JPRB, 0.716612E+00_JPRB, 0.693573E+00_JPRB, 0.670699E+00_JPRB &
  &, 0.648005E+00_JPRB, 0.625509E+00_JPRB, 0.603227E+00_JPRB &
  &, 0.581178E+00_JPRB, 0.559377E+00_JPRB, 0.537841E+00_JPRB, 0.516589E+00_JPRB &
  &, 0.495638E+00_JPRB, 0.475002E+00_JPRB, 0.454701E+00_JPRB &
  &, 0.434752E+00_JPRB, 0.415170E+00_JPRB, 0.395974E+00_JPRB, 0.377175E+00_JPRB &
  &, 0.358793E+00_JPRB, 0.340844E+00_JPRB, 0.323336E+00_JPRB &
  &, 0.306289E+00_JPRB, 0.289714E+00_JPRB, 0.273623E+00_JPRB, 0.258023E+00_JPRB &
  &, 0.242927E+00_JPRB, 0.228345E+00_JPRB, 0.214282E+00_JPRB &
  &, 0.200741E+00_JPRB, 0.187741E+00_JPRB, 0.175263E+00_JPRB, 0.163325E+00_JPRB &
  &, 0.151921E+00_JPRB, 0.141052E+00_JPRB, 0.130709E+00_JPRB &
  &, 0.120889E+00_JPRB, 0.111586E+00_JPRB, 0.102804E+00_JPRB, 0.945188E-01_JPRB &
  &, 0.867156E-01_JPRB, 0.793990E-01_JPRB, 0.725462E-01_JPRB &
  &, 0.661428E-01_JPRB, 0.601839E-01_JPRB, 0.546343E-01_JPRB, 0.494950E-01_JPRB &
  &, 0.447363E-01_JPRB, 0.403381E-01_JPRB, 0.362916E-01_JPRB &
  &, 0.325851E-01_JPRB, 0.291884E-01_JPRB, 0.260826E-01_JPRB, 0.232623E-01_JPRB &
  &, 0.207030E-01_JPRB, 0.183767E-01_JPRB, 0.162692E-01_JPRB &
  &, 0.143640E-01_JPRB, 0.126604E-01_JPRB, 0.111379E-01_JPRB, 0.977324E-02_JPRB &
  &, 0.854023E-02_JPRB, 0.747040E-02_JPRB, 0.649411E-02_JPRB &
  &, 0.564053E-02_JPRB, 0.489780E-02_JPRB, 0.423058E-02_JPRB, 0.364498E-02_JPRB &
  &, 0.314731E-02_JPRB, 0.269732E-02_JPRB, 0.229882E-02_JPRB &
  &, 0.198006E-02_JPRB, 0.167210E-02_JPRB, 0.142675E-02_JPRB, 0.119666E-02_JPRB &
  &, 0.100942E-02_JPRB, 0.867925E-03_JPRB, 0.720469E-03_JPRB &
  &, 0.594793E-03_JPRB, 0.492371E-03_JPRB, 0.414715E-03_JPRB, 0.333924E-03_JPRB &
  &, 0.279937E-03_JPRB, 0.223811E-03_JPRB, 0.196610E-03_JPRB &
  &, 0.168325E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 173, :) = (/ &
  &  0.905248E+00_JPRB, 0.881563E+00_JPRB, 0.857910E+00_JPRB, 0.834306E+00_JPRB &
  &, 0.810765E+00_JPRB, 0.787304E+00_JPRB, 0.763938E+00_JPRB &
  &, 0.740683E+00_JPRB, 0.717557E+00_JPRB, 0.694574E+00_JPRB, 0.671753E+00_JPRB &
  &, 0.649108E+00_JPRB, 0.626657E+00_JPRB, 0.604418E+00_JPRB &
  &, 0.582407E+00_JPRB, 0.560641E+00_JPRB, 0.539136E+00_JPRB, 0.517912E+00_JPRB &
  &, 0.496984E+00_JPRB, 0.476370E+00_JPRB, 0.456085E+00_JPRB &
  &, 0.436148E+00_JPRB, 0.416578E+00_JPRB, 0.397386E+00_JPRB, 0.378593E+00_JPRB &
  &, 0.360208E+00_JPRB, 0.342252E+00_JPRB, 0.324740E+00_JPRB &
  &, 0.307681E+00_JPRB, 0.291093E+00_JPRB, 0.274982E+00_JPRB, 0.259366E+00_JPRB &
  &, 0.244247E+00_JPRB, 0.229641E+00_JPRB, 0.215552E+00_JPRB &
  &, 0.201988E+00_JPRB, 0.188942E+00_JPRB, 0.176437E+00_JPRB, 0.164468E+00_JPRB &
  &, 0.153020E+00_JPRB, 0.142116E+00_JPRB, 0.131735E+00_JPRB &
  &, 0.121874E+00_JPRB, 0.112539E+00_JPRB, 0.103711E+00_JPRB, 0.953774E-01_JPRB &
  &, 0.875343E-01_JPRB, 0.801752E-01_JPRB, 0.732901E-01_JPRB &
  &, 0.668392E-01_JPRB, 0.608300E-01_JPRB, 0.552545E-01_JPRB, 0.500737E-01_JPRB &
  &, 0.452710E-01_JPRB, 0.408411E-01_JPRB, 0.367610E-01_JPRB &
  &, 0.330190E-01_JPRB, 0.296007E-01_JPRB, 0.264557E-01_JPRB, 0.236108E-01_JPRB &
  &, 0.210086E-01_JPRB, 0.186545E-01_JPRB, 0.165177E-01_JPRB &
  &, 0.145999E-01_JPRB, 0.128830E-01_JPRB, 0.113275E-01_JPRB, 0.994758E-02_JPRB &
  &, 0.869856E-02_JPRB, 0.761193E-02_JPRB, 0.661801E-02_JPRB &
  &, 0.576706E-02_JPRB, 0.500546E-02_JPRB, 0.431851E-02_JPRB, 0.373473E-02_JPRB &
  &, 0.321601E-02_JPRB, 0.276742E-02_JPRB, 0.237034E-02_JPRB &
  &, 0.202870E-02_JPRB, 0.172171E-02_JPRB, 0.145205E-02_JPRB, 0.124825E-02_JPRB &
  &, 0.103572E-02_JPRB, 0.894735E-03_JPRB, 0.747795E-03_JPRB &
  &, 0.622640E-03_JPRB, 0.520746E-03_JPRB, 0.443624E-03_JPRB, 0.363372E-03_JPRB &
  &, 0.309930E-03_JPRB, 0.254355E-03_JPRB, 0.196610E-03_JPRB &
  &, 0.168325E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 174, :) = (/ &
  &  0.905614E+00_JPRB, 0.882012E+00_JPRB, 0.858440E+00_JPRB, 0.834914E+00_JPRB &
  &, 0.811445E+00_JPRB, 0.788055E+00_JPRB, 0.764756E+00_JPRB &
  &, 0.741565E+00_JPRB, 0.718498E+00_JPRB, 0.695572E+00_JPRB, 0.672803E+00_JPRB &
  &, 0.650208E+00_JPRB, 0.627803E+00_JPRB, 0.605605E+00_JPRB &
  &, 0.583632E+00_JPRB, 0.561902E+00_JPRB, 0.540428E+00_JPRB, 0.519232E+00_JPRB &
  &, 0.498328E+00_JPRB, 0.477734E+00_JPRB, 0.457467E+00_JPRB &
  &, 0.437544E+00_JPRB, 0.417982E+00_JPRB, 0.398795E+00_JPRB, 0.380003E+00_JPRB &
  &, 0.361623E+00_JPRB, 0.343664E+00_JPRB, 0.326141E+00_JPRB &
  &, 0.309073E+00_JPRB, 0.292471E+00_JPRB, 0.276345E+00_JPRB, 0.260709E+00_JPRB &
  &, 0.245568E+00_JPRB, 0.230937E+00_JPRB, 0.216822E+00_JPRB &
  &, 0.203225E+00_JPRB, 0.190153E+00_JPRB, 0.177620E+00_JPRB, 0.165611E+00_JPRB &
  &, 0.154130E+00_JPRB, 0.143181E+00_JPRB, 0.132761E+00_JPRB &
  &, 0.122860E+00_JPRB, 0.113482E+00_JPRB, 0.104619E+00_JPRB, 0.962478E-01_JPRB &
  &, 0.883652E-01_JPRB, 0.809640E-01_JPRB, 0.740213E-01_JPRB &
  &, 0.675487E-01_JPRB, 0.614894E-01_JPRB, 0.558748E-01_JPRB, 0.506524E-01_JPRB &
  &, 0.458201E-01_JPRB, 0.413588E-01_JPRB, 0.372455E-01_JPRB &
  &, 0.334685E-01_JPRB, 0.299971E-01_JPRB, 0.268289E-01_JPRB, 0.239427E-01_JPRB &
  &, 0.213311E-01_JPRB, 0.189496E-01_JPRB, 0.167840E-01_JPRB &
  &, 0.148539E-01_JPRB, 0.131056E-01_JPRB, 0.115360E-01_JPRB, 0.101219E-01_JPRB &
  &, 0.887669E-02_JPRB, 0.775345E-02_JPRB, 0.676256E-02_JPRB &
  &, 0.587250E-02_JPRB, 0.509159E-02_JPRB, 0.440644E-02_JPRB, 0.380205E-02_JPRB &
  &, 0.328471E-02_JPRB, 0.281416E-02_JPRB, 0.241803E-02_JPRB &
  &, 0.207734E-02_JPRB, 0.177133E-02_JPRB, 0.150265E-02_JPRB, 0.127405E-02_JPRB &
  &, 0.108832E-02_JPRB, 0.894735E-03_JPRB, 0.775121E-03_JPRB &
  &, 0.650487E-03_JPRB, 0.549121E-03_JPRB, 0.443624E-03_JPRB, 0.363372E-03_JPRB &
  &, 0.309930E-03_JPRB, 0.254355E-03_JPRB, 0.196610E-03_JPRB &
  &, 0.168325E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 175, :) = (/ &
  &  0.905979E+00_JPRB, 0.882462E+00_JPRB, 0.858969E+00_JPRB, 0.835519E+00_JPRB &
  &, 0.812125E+00_JPRB, 0.788804E+00_JPRB, 0.765572E+00_JPRB &
  &, 0.742444E+00_JPRB, 0.719437E+00_JPRB, 0.696567E+00_JPRB, 0.673851E+00_JPRB &
  &, 0.651305E+00_JPRB, 0.628945E+00_JPRB, 0.606790E+00_JPRB &
  &, 0.584856E+00_JPRB, 0.563160E+00_JPRB, 0.541719E+00_JPRB, 0.520549E+00_JPRB &
  &, 0.499670E+00_JPRB, 0.479095E+00_JPRB, 0.458845E+00_JPRB &
  &, 0.438936E+00_JPRB, 0.419383E+00_JPRB, 0.400204E+00_JPRB, 0.381417E+00_JPRB &
  &, 0.363034E+00_JPRB, 0.345072E+00_JPRB, 0.327530E+00_JPRB &
  &, 0.310465E+00_JPRB, 0.293849E+00_JPRB, 0.277709E+00_JPRB, 0.262052E+00_JPRB &
  &, 0.246892E+00_JPRB, 0.232238E+00_JPRB, 0.218092E+00_JPRB &
  &, 0.204471E+00_JPRB, 0.191365E+00_JPRB, 0.178793E+00_JPRB, 0.166754E+00_JPRB &
  &, 0.155241E+00_JPRB, 0.144255E+00_JPRB, 0.133798E+00_JPRB &
  &, 0.123857E+00_JPRB, 0.114435E+00_JPRB, 0.105526E+00_JPRB, 0.971182E-01_JPRB &
  &, 0.891961E-01_JPRB, 0.817527E-01_JPRB, 0.747781E-01_JPRB &
  &, 0.682452E-01_JPRB, 0.621624E-01_JPRB, 0.564950E-01_JPRB, 0.512310E-01_JPRB &
  &, 0.463693E-01_JPRB, 0.418618E-01_JPRB, 0.377149E-01_JPRB &
  &, 0.339024E-01_JPRB, 0.304094E-01_JPRB, 0.272183E-01_JPRB, 0.242913E-01_JPRB &
  &, 0.216367E-01_JPRB, 0.192447E-01_JPRB, 0.170502E-01_JPRB &
  &, 0.150898E-01_JPRB, 0.133096E-01_JPRB, 0.117256E-01_JPRB, 0.102963E-01_JPRB &
  &, 0.903502E-02_JPRB, 0.789498E-02_JPRB, 0.688646E-02_JPRB &
  &, 0.599902E-02_JPRB, 0.519925E-02_JPRB, 0.451635E-02_JPRB, 0.389180E-02_JPRB &
  &, 0.335341E-02_JPRB, 0.288426E-02_JPRB, 0.246571E-02_JPRB &
  &, 0.212598E-02_JPRB, 0.179614E-02_JPRB, 0.152795E-02_JPRB, 0.129984E-02_JPRB &
  &, 0.111462E-02_JPRB, 0.921545E-03_JPRB, 0.775121E-03_JPRB &
  &, 0.650487E-03_JPRB, 0.549121E-03_JPRB, 0.472532E-03_JPRB, 0.392820E-03_JPRB &
  &, 0.309930E-03_JPRB, 0.254355E-03_JPRB, 0.227712E-03_JPRB &
  &, 0.168325E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART25',1,ZHOOK_HANDLE)
END SUBROUTINE PART25

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART26

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART26',0,ZHOOK_HANDLE)

XCW( 176, :) = (/ &
  &  0.906343E+00_JPRB, 0.882908E+00_JPRB, 0.859496E+00_JPRB, 0.836123E+00_JPRB &
  &, 0.812802E+00_JPRB, 0.789551E+00_JPRB, 0.766385E+00_JPRB &
  &, 0.743321E+00_JPRB, 0.720373E+00_JPRB, 0.697560E+00_JPRB, 0.674896E+00_JPRB &
  &, 0.652400E+00_JPRB, 0.630086E+00_JPRB, 0.607973E+00_JPRB &
  &, 0.586078E+00_JPRB, 0.564416E+00_JPRB, 0.543006E+00_JPRB, 0.521864E+00_JPRB &
  &, 0.501008E+00_JPRB, 0.480456E+00_JPRB, 0.460223E+00_JPRB &
  &, 0.440325E+00_JPRB, 0.420783E+00_JPRB, 0.401613E+00_JPRB, 0.382827E+00_JPRB &
  &, 0.364445E+00_JPRB, 0.346476E+00_JPRB, 0.328942E+00_JPRB &
  &, 0.311857E+00_JPRB, 0.295228E+00_JPRB, 0.279068E+00_JPRB, 0.263395E+00_JPRB &
  &, 0.248213E+00_JPRB, 0.233534E+00_JPRB, 0.219367E+00_JPRB &
  &, 0.205708E+00_JPRB, 0.192576E+00_JPRB, 0.179977E+00_JPRB, 0.167897E+00_JPRB &
  &, 0.156351E+00_JPRB, 0.145320E+00_JPRB, 0.134825E+00_JPRB &
  &, 0.124853E+00_JPRB, 0.115389E+00_JPRB, 0.106434E+00_JPRB, 0.979887E-01_JPRB &
  &, 0.900269E-01_JPRB, 0.825415E-01_JPRB, 0.755220E-01_JPRB &
  &, 0.689547E-01_JPRB, 0.628219E-01_JPRB, 0.571291E-01_JPRB, 0.518239E-01_JPRB &
  &, 0.469184E-01_JPRB, 0.423796E-01_JPRB, 0.381995E-01_JPRB &
  &, 0.343518E-01_JPRB, 0.308217E-01_JPRB, 0.275914E-01_JPRB, 0.246398E-01_JPRB &
  &, 0.219592E-01_JPRB, 0.195398E-01_JPRB, 0.173342E-01_JPRB &
  &, 0.153439E-01_JPRB, 0.135507E-01_JPRB, 0.119341E-01_JPRB, 0.104900E-01_JPRB &
  &, 0.919336E-02_JPRB, 0.803650E-02_JPRB, 0.701036E-02_JPRB &
  &, 0.610447E-02_JPRB, 0.530691E-02_JPRB, 0.460428E-02_JPRB, 0.398155E-02_JPRB &
  &, 0.342211E-02_JPRB, 0.295437E-02_JPRB, 0.253724E-02_JPRB &
  &, 0.217463E-02_JPRB, 0.184575E-02_JPRB, 0.157855E-02_JPRB, 0.135144E-02_JPRB &
  &, 0.114092E-02_JPRB, 0.948356E-03_JPRB, 0.802447E-03_JPRB &
  &, 0.678335E-03_JPRB, 0.577496E-03_JPRB, 0.472532E-03_JPRB, 0.392820E-03_JPRB &
  &, 0.339924E-03_JPRB, 0.254355E-03_JPRB, 0.227712E-03_JPRB &
  &, 0.168325E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.767810E-04_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 177, :) = (/ &
  &  0.906707E+00_JPRB, 0.883355E+00_JPRB, 0.860022E+00_JPRB, 0.836725E+00_JPRB &
  &, 0.813477E+00_JPRB, 0.790296E+00_JPRB, 0.767196E+00_JPRB &
  &, 0.744195E+00_JPRB, 0.721307E+00_JPRB, 0.698550E+00_JPRB, 0.675939E+00_JPRB &
  &, 0.653491E+00_JPRB, 0.631224E+00_JPRB, 0.609152E+00_JPRB &
  &, 0.587295E+00_JPRB, 0.565670E+00_JPRB, 0.544290E+00_JPRB, 0.523177E+00_JPRB &
  &, 0.502345E+00_JPRB, 0.481814E+00_JPRB, 0.461598E+00_JPRB &
  &, 0.441715E+00_JPRB, 0.422184E+00_JPRB, 0.403019E+00_JPRB, 0.384238E+00_JPRB &
  &, 0.365853E+00_JPRB, 0.347885E+00_JPRB, 0.330343E+00_JPRB &
  &, 0.313245E+00_JPRB, 0.296606E+00_JPRB, 0.280432E+00_JPRB, 0.264737E+00_JPRB &
  &, 0.249538E+00_JPRB, 0.234835E+00_JPRB, 0.220637E+00_JPRB &
  &, 0.206955E+00_JPRB, 0.193796E+00_JPRB, 0.181160E+00_JPRB, 0.169040E+00_JPRB &
  &, 0.157461E+00_JPRB, 0.146405E+00_JPRB, 0.135862E+00_JPRB &
  &, 0.125850E+00_JPRB, 0.116354E+00_JPRB, 0.107353E+00_JPRB, 0.988591E-01_JPRB &
  &, 0.908578E-01_JPRB, 0.833302E-01_JPRB, 0.762660E-01_JPRB &
  &, 0.696643E-01_JPRB, 0.634948E-01_JPRB, 0.577493E-01_JPRB, 0.524167E-01_JPRB &
  &, 0.474675E-01_JPRB, 0.428974E-01_JPRB, 0.386841E-01_JPRB &
  &, 0.348012E-01_JPRB, 0.312340E-01_JPRB, 0.279808E-01_JPRB, 0.250049E-01_JPRB &
  &, 0.222987E-01_JPRB, 0.198349E-01_JPRB, 0.176005E-01_JPRB &
  &, 0.155798E-01_JPRB, 0.137733E-01_JPRB, 0.121426E-01_JPRB, 0.106643E-01_JPRB &
  &, 0.937148E-02_JPRB, 0.819824E-02_JPRB, 0.715491E-02_JPRB &
  &, 0.623099E-02_JPRB, 0.541457E-02_JPRB, 0.469221E-02_JPRB, 0.407131E-02_JPRB &
  &, 0.351371E-02_JPRB, 0.302447E-02_JPRB, 0.258492E-02_JPRB &
  &, 0.222327E-02_JPRB, 0.189537E-02_JPRB, 0.160385E-02_JPRB, 0.137723E-02_JPRB &
  &, 0.116722E-02_JPRB, 0.975166E-03_JPRB, 0.829772E-03_JPRB &
  &, 0.706182E-03_JPRB, 0.577496E-03_JPRB, 0.501440E-03_JPRB, 0.392820E-03_JPRB &
  &, 0.339924E-03_JPRB, 0.284900E-03_JPRB, 0.227712E-03_JPRB &
  &, 0.199990E-03_JPRB, 0.138937E-03_JPRB, 0.108428E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.445707E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 178, :) = (/ &
  &  0.907068E+00_JPRB, 0.883799E+00_JPRB, 0.860545E+00_JPRB, 0.837325E+00_JPRB &
  &, 0.814150E+00_JPRB, 0.791038E+00_JPRB, 0.768005E+00_JPRB &
  &, 0.745066E+00_JPRB, 0.722238E+00_JPRB, 0.699537E+00_JPRB, 0.676979E+00_JPRB &
  &, 0.654581E+00_JPRB, 0.632358E+00_JPRB, 0.610330E+00_JPRB &
  &, 0.588512E+00_JPRB, 0.566920E+00_JPRB, 0.545573E+00_JPRB, 0.524487E+00_JPRB &
  &, 0.503681E+00_JPRB, 0.483168E+00_JPRB, 0.462969E+00_JPRB &
  &, 0.443104E+00_JPRB, 0.423581E+00_JPRB, 0.404425E+00_JPRB, 0.385644E+00_JPRB &
  &, 0.367261E+00_JPRB, 0.349289E+00_JPRB, 0.331743E+00_JPRB &
  &, 0.314637E+00_JPRB, 0.297980E+00_JPRB, 0.281795E+00_JPRB, 0.266084E+00_JPRB &
  &, 0.250858E+00_JPRB, 0.236131E+00_JPRB, 0.221911E+00_JPRB &
  &, 0.208201E+00_JPRB, 0.195008E+00_JPRB, 0.182343E+00_JPRB, 0.170193E+00_JPRB &
  &, 0.158571E+00_JPRB, 0.147480E+00_JPRB, 0.136899E+00_JPRB &
  &, 0.126847E+00_JPRB, 0.117307E+00_JPRB, 0.108272E+00_JPRB, 0.997415E-01_JPRB &
  &, 0.916887E-01_JPRB, 0.841315E-01_JPRB, 0.770228E-01_JPRB &
  &, 0.703870E-01_JPRB, 0.641677E-01_JPRB, 0.583834E-01_JPRB, 0.530095E-01_JPRB &
  &, 0.480311E-01_JPRB, 0.434152E-01_JPRB, 0.391686E-01_JPRB &
  &, 0.352506E-01_JPRB, 0.316463E-01_JPRB, 0.283702E-01_JPRB, 0.253535E-01_JPRB &
  &, 0.226212E-01_JPRB, 0.201301E-01_JPRB, 0.178668E-01_JPRB &
  &, 0.158339E-01_JPRB, 0.139959E-01_JPRB, 0.123512E-01_JPRB, 0.108580E-01_JPRB &
  &, 0.952981E-02_JPRB, 0.833977E-02_JPRB, 0.729946E-02_JPRB &
  &, 0.635752E-02_JPRB, 0.552224E-02_JPRB, 0.480212E-02_JPRB, 0.413862E-02_JPRB &
  &, 0.358241E-02_JPRB, 0.309458E-02_JPRB, 0.265645E-02_JPRB &
  &, 0.227192E-02_JPRB, 0.194498E-02_JPRB, 0.165445E-02_JPRB, 0.140303E-02_JPRB &
  &, 0.119352E-02_JPRB, 0.100198E-02_JPRB, 0.857098E-03_JPRB &
  &, 0.706182E-03_JPRB, 0.605870E-03_JPRB, 0.501440E-03_JPRB, 0.422267E-03_JPRB &
  &, 0.339924E-03_JPRB, 0.284900E-03_JPRB, 0.227712E-03_JPRB &
  &, 0.199990E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 179, :) = (/ &
  &  0.907428E+00_JPRB, 0.884243E+00_JPRB, 0.861068E+00_JPRB, 0.837923E+00_JPRB &
  &, 0.814820E+00_JPRB, 0.791779E+00_JPRB, 0.768812E+00_JPRB &
  &, 0.745935E+00_JPRB, 0.723167E+00_JPRB, 0.700522E+00_JPRB, 0.678016E+00_JPRB &
  &, 0.655667E+00_JPRB, 0.633491E+00_JPRB, 0.611504E+00_JPRB &
  &, 0.589725E+00_JPRB, 0.568168E+00_JPRB, 0.546852E+00_JPRB, 0.525795E+00_JPRB &
  &, 0.505013E+00_JPRB, 0.484523E+00_JPRB, 0.464341E+00_JPRB &
  &, 0.444486E+00_JPRB, 0.424978E+00_JPRB, 0.405827E+00_JPRB, 0.387051E+00_JPRB &
  &, 0.368668E+00_JPRB, 0.350693E+00_JPRB, 0.333140E+00_JPRB &
  &, 0.316025E+00_JPRB, 0.299359E+00_JPRB, 0.283154E+00_JPRB, 0.267427E+00_JPRB &
  &, 0.252183E+00_JPRB, 0.237432E+00_JPRB, 0.223186E+00_JPRB &
  &, 0.209447E+00_JPRB, 0.196228E+00_JPRB, 0.183526E+00_JPRB, 0.171346E+00_JPRB &
  &, 0.159691E+00_JPRB, 0.148555E+00_JPRB, 0.137947E+00_JPRB &
  &, 0.127854E+00_JPRB, 0.118272E+00_JPRB, 0.109203E+00_JPRB, 0.100624E+00_JPRB &
  &, 0.925318E-01_JPRB, 0.849328E-01_JPRB, 0.777924E-01_JPRB &
  &, 0.710965E-01_JPRB, 0.648541E-01_JPRB, 0.590312E-01_JPRB, 0.536164E-01_JPRB &
  &, 0.485947E-01_JPRB, 0.439478E-01_JPRB, 0.396532E-01_JPRB &
  &, 0.357000E-01_JPRB, 0.320745E-01_JPRB, 0.287596E-01_JPRB, 0.257186E-01_JPRB &
  &, 0.229438E-01_JPRB, 0.204252E-01_JPRB, 0.181508E-01_JPRB &
  &, 0.160879E-01_JPRB, 0.142185E-01_JPRB, 0.125597E-01_JPRB, 0.110518E-01_JPRB &
  &, 0.970794E-02_JPRB, 0.850151E-02_JPRB, 0.742336E-02_JPRB &
  &, 0.648405E-02_JPRB, 0.562990E-02_JPRB, 0.489005E-02_JPRB, 0.422837E-02_JPRB &
  &, 0.365111E-02_JPRB, 0.316468E-02_JPRB, 0.270413E-02_JPRB &
  &, 0.232056E-02_JPRB, 0.199460E-02_JPRB, 0.170505E-02_JPRB, 0.145463E-02_JPRB &
  &, 0.121982E-02_JPRB, 0.102879E-02_JPRB, 0.884424E-03_JPRB &
  &, 0.734029E-03_JPRB, 0.605870E-03_JPRB, 0.530348E-03_JPRB, 0.422267E-03_JPRB &
  &, 0.369917E-03_JPRB, 0.284900E-03_JPRB, 0.258814E-03_JPRB &
  &, 0.199990E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 180, :) = (/ &
  &  0.907788E+00_JPRB, 0.884683E+00_JPRB, 0.861588E+00_JPRB, 0.838519E+00_JPRB &
  &, 0.815490E+00_JPRB, 0.792517E+00_JPRB, 0.769616E+00_JPRB &
  &, 0.746803E+00_JPRB, 0.724093E+00_JPRB, 0.701504E+00_JPRB, 0.679051E+00_JPRB &
  &, 0.656751E+00_JPRB, 0.634620E+00_JPRB, 0.612676E+00_JPRB &
  &, 0.590934E+00_JPRB, 0.569413E+00_JPRB, 0.548131E+00_JPRB, 0.527100E+00_JPRB &
  &, 0.506343E+00_JPRB, 0.485874E+00_JPRB, 0.465709E+00_JPRB &
  &, 0.445872E+00_JPRB, 0.426372E+00_JPRB, 0.407229E+00_JPRB, 0.388458E+00_JPRB &
  &, 0.370076E+00_JPRB, 0.352098E+00_JPRB, 0.334540E+00_JPRB &
  &, 0.317413E+00_JPRB, 0.300737E+00_JPRB, 0.284518E+00_JPRB, 0.268770E+00_JPRB &
  &, 0.253508E+00_JPRB, 0.238737E+00_JPRB, 0.224465E+00_JPRB &
  &, 0.210694E+00_JPRB, 0.197449E+00_JPRB, 0.184709E+00_JPRB, 0.172499E+00_JPRB &
  &, 0.160812E+00_JPRB, 0.149640E+00_JPRB, 0.138995E+00_JPRB &
  &, 0.128862E+00_JPRB, 0.119237E+00_JPRB, 0.110122E+00_JPRB, 0.101506E+00_JPRB &
  &, 0.933749E-01_JPRB, 0.857341E-01_JPRB, 0.785492E-01_JPRB &
  &, 0.718192E-01_JPRB, 0.655271E-01_JPRB, 0.596653E-01_JPRB, 0.542092E-01_JPRB &
  &, 0.491583E-01_JPRB, 0.444656E-01_JPRB, 0.401378E-01_JPRB &
  &, 0.361650E-01_JPRB, 0.325026E-01_JPRB, 0.291490E-01_JPRB, 0.260837E-01_JPRB &
  &, 0.232833E-01_JPRB, 0.207377E-01_JPRB, 0.184348E-01_JPRB &
  &, 0.163420E-01_JPRB, 0.144596E-01_JPRB, 0.127682E-01_JPRB, 0.112455E-01_JPRB &
  &, 0.986627E-02_JPRB, 0.866326E-02_JPRB, 0.756791E-02_JPRB &
  &, 0.661058E-02_JPRB, 0.575909E-02_JPRB, 0.499996E-02_JPRB, 0.431813E-02_JPRB &
  &, 0.374272E-02_JPRB, 0.323478E-02_JPRB, 0.277565E-02_JPRB &
  &, 0.236920E-02_JPRB, 0.204421E-02_JPRB, 0.173034E-02_JPRB, 0.148042E-02_JPRB &
  &, 0.124613E-02_JPRB, 0.105560E-02_JPRB, 0.911749E-03_JPRB &
  &, 0.761877E-03_JPRB, 0.634245E-03_JPRB, 0.530348E-03_JPRB, 0.451715E-03_JPRB &
  &, 0.369917E-03_JPRB, 0.315444E-03_JPRB, 0.258814E-03_JPRB &
  &, 0.199990E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 181, :) = (/ &
  &  0.908147E+00_JPRB, 0.885123E+00_JPRB, 0.862107E+00_JPRB, 0.839113E+00_JPRB &
  &, 0.816156E+00_JPRB, 0.793253E+00_JPRB, 0.770417E+00_JPRB &
  &, 0.747667E+00_JPRB, 0.725017E+00_JPRB, 0.702484E+00_JPRB, 0.680083E+00_JPRB &
  &, 0.657832E+00_JPRB, 0.635747E+00_JPRB, 0.613844E+00_JPRB &
  &, 0.592143E+00_JPRB, 0.570656E+00_JPRB, 0.549405E+00_JPRB, 0.528403E+00_JPRB &
  &, 0.507671E+00_JPRB, 0.487223E+00_JPRB, 0.467077E+00_JPRB &
  &, 0.447252E+00_JPRB, 0.427763E+00_JPRB, 0.408627E+00_JPRB, 0.389861E+00_JPRB &
  &, 0.371480E+00_JPRB, 0.353499E+00_JPRB, 0.335937E+00_JPRB &
  &, 0.318801E+00_JPRB, 0.302100E+00_JPRB, 0.285881E+00_JPRB, 0.270117E+00_JPRB &
  &, 0.254833E+00_JPRB, 0.240038E+00_JPRB, 0.225740E+00_JPRB &
  &, 0.211949E+00_JPRB, 0.198670E+00_JPRB, 0.185902E+00_JPRB, 0.173652E+00_JPRB &
  &, 0.161932E+00_JPRB, 0.150726E+00_JPRB, 0.140032E+00_JPRB &
  &, 0.129870E+00_JPRB, 0.120202E+00_JPRB, 0.111053E+00_JPRB, 0.102401E+00_JPRB &
  &, 0.942303E-01_JPRB, 0.865353E-01_JPRB, 0.793188E-01_JPRB &
  &, 0.725419E-01_JPRB, 0.662134E-01_JPRB, 0.603131E-01_JPRB, 0.548161E-01_JPRB &
  &, 0.497219E-01_JPRB, 0.449981E-01_JPRB, 0.406375E-01_JPRB &
  &, 0.366144E-01_JPRB, 0.329308E-01_JPRB, 0.295384E-01_JPRB, 0.264489E-01_JPRB &
  &, 0.236228E-01_JPRB, 0.210501E-01_JPRB, 0.187188E-01_JPRB &
  &, 0.165960E-01_JPRB, 0.147008E-01_JPRB, 0.129768E-01_JPRB, 0.114392E-01_JPRB &
  &, 0.100444E-01_JPRB, 0.882500E-02_JPRB, 0.771246E-02_JPRB &
  &, 0.673711E-02_JPRB, 0.586675E-02_JPRB, 0.508788E-02_JPRB, 0.440788E-02_JPRB &
  &, 0.381142E-02_JPRB, 0.330489E-02_JPRB, 0.284718E-02_JPRB &
  &, 0.244217E-02_JPRB, 0.209383E-02_JPRB, 0.178094E-02_JPRB, 0.150622E-02_JPRB &
  &, 0.129873E-02_JPRB, 0.108241E-02_JPRB, 0.911749E-03_JPRB &
  &, 0.789724E-03_JPRB, 0.662620E-03_JPRB, 0.559257E-03_JPRB, 0.451715E-03_JPRB &
  &, 0.369917E-03_JPRB, 0.315444E-03_JPRB, 0.258814E-03_JPRB &
  &, 0.199990E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 182, :) = (/ &
  &  0.908503E+00_JPRB, 0.885562E+00_JPRB, 0.862624E+00_JPRB, 0.839706E+00_JPRB &
  &, 0.816821E+00_JPRB, 0.793987E+00_JPRB, 0.771217E+00_JPRB &
  &, 0.748527E+00_JPRB, 0.725938E+00_JPRB, 0.703456E+00_JPRB, 0.681113E+00_JPRB &
  &, 0.658910E+00_JPRB, 0.636872E+00_JPRB, 0.615011E+00_JPRB &
  &, 0.593348E+00_JPRB, 0.571897E+00_JPRB, 0.550677E+00_JPRB, 0.529705E+00_JPRB &
  &, 0.508997E+00_JPRB, 0.488571E+00_JPRB, 0.468443E+00_JPRB &
  &, 0.448631E+00_JPRB, 0.429153E+00_JPRB, 0.410026E+00_JPRB, 0.391264E+00_JPRB &
  &, 0.372884E+00_JPRB, 0.354903E+00_JPRB, 0.337334E+00_JPRB &
  &, 0.320193E+00_JPRB, 0.303490E+00_JPRB, 0.287245E+00_JPRB, 0.271464E+00_JPRB &
  &, 0.256158E+00_JPRB, 0.241343E+00_JPRB, 0.227019E+00_JPRB &
  &, 0.213196E+00_JPRB, 0.199890E+00_JPRB, 0.187095E+00_JPRB, 0.174814E+00_JPRB &
  &, 0.163053E+00_JPRB, 0.151811E+00_JPRB, 0.141091E+00_JPRB &
  &, 0.130878E+00_JPRB, 0.121178E+00_JPRB, 0.111983E+00_JPRB, 0.103283E+00_JPRB &
  &, 0.950734E-01_JPRB, 0.873491E-01_JPRB, 0.800884E-01_JPRB &
  &, 0.732777E-01_JPRB, 0.668998E-01_JPRB, 0.609609E-01_JPRB, 0.554371E-01_JPRB &
  &, 0.503000E-01_JPRB, 0.455307E-01_JPRB, 0.411372E-01_JPRB &
  &, 0.370793E-01_JPRB, 0.333590E-01_JPRB, 0.299440E-01_JPRB, 0.268140E-01_JPRB &
  &, 0.239623E-01_JPRB, 0.213626E-01_JPRB, 0.190028E-01_JPRB &
  &, 0.168682E-01_JPRB, 0.149419E-01_JPRB, 0.131853E-01_JPRB, 0.116329E-01_JPRB &
  &, 0.102225E-01_JPRB, 0.896652E-02_JPRB, 0.785701E-02_JPRB &
  &, 0.686364E-02_JPRB, 0.597441E-02_JPRB, 0.519780E-02_JPRB, 0.449763E-02_JPRB &
  &, 0.390302E-02_JPRB, 0.337499E-02_JPRB, 0.289486E-02_JPRB &
  &, 0.249081E-02_JPRB, 0.214344E-02_JPRB, 0.183154E-02_JPRB, 0.155781E-02_JPRB &
  &, 0.132503E-02_JPRB, 0.110922E-02_JPRB, 0.939075E-03_JPRB &
  &, 0.789724E-03_JPRB, 0.662620E-03_JPRB, 0.559257E-03_JPRB, 0.481163E-03_JPRB &
  &, 0.399910E-03_JPRB, 0.315444E-03_JPRB, 0.258814E-03_JPRB &
  &, 0.231655E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.779552E-04_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART26',1,ZHOOK_HANDLE)
END SUBROUTINE PART26

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART27

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART27',0,ZHOOK_HANDLE)

XCW( 183, :) = (/ &
  &  0.908859E+00_JPRB, 0.885999E+00_JPRB, 0.863139E+00_JPRB, 0.840297E+00_JPRB &
  &, 0.817484E+00_JPRB, 0.794718E+00_JPRB, 0.772015E+00_JPRB &
  &, 0.749389E+00_JPRB, 0.726858E+00_JPRB, 0.704436E+00_JPRB, 0.682140E+00_JPRB &
  &, 0.659987E+00_JPRB, 0.637993E+00_JPRB, 0.616175E+00_JPRB &
  &, 0.594551E+00_JPRB, 0.573136E+00_JPRB, 0.551948E+00_JPRB, 0.531004E+00_JPRB &
  &, 0.510320E+00_JPRB, 0.489916E+00_JPRB, 0.469808E+00_JPRB &
  &, 0.450010E+00_JPRB, 0.430544E+00_JPRB, 0.411425E+00_JPRB, 0.392667E+00_JPRB &
  &, 0.374288E+00_JPRB, 0.356304E+00_JPRB, 0.338731E+00_JPRB &
  &, 0.321577E+00_JPRB, 0.304868E+00_JPRB, 0.288604E+00_JPRB, 0.272807E+00_JPRB &
  &, 0.257482E+00_JPRB, 0.242644E+00_JPRB, 0.228298E+00_JPRB &
  &, 0.214451E+00_JPRB, 0.201111E+00_JPRB, 0.188288E+00_JPRB, 0.175967E+00_JPRB &
  &, 0.164173E+00_JPRB, 0.152897E+00_JPRB, 0.142139E+00_JPRB &
  &, 0.131886E+00_JPRB, 0.122154E+00_JPRB, 0.112914E+00_JPRB, 0.104177E+00_JPRB &
  &, 0.959287E-01_JPRB, 0.881629E-01_JPRB, 0.808580E-01_JPRB &
  &, 0.740004E-01_JPRB, 0.675997E-01_JPRB, 0.616087E-01_JPRB, 0.560440E-01_JPRB &
  &, 0.508636E-01_JPRB, 0.460781E-01_JPRB, 0.416369E-01_JPRB &
  &, 0.375597E-01_JPRB, 0.337871E-01_JPRB, 0.303496E-01_JPRB, 0.271791E-01_JPRB &
  &, 0.243018E-01_JPRB, 0.216751E-01_JPRB, 0.192868E-01_JPRB &
  &, 0.171223E-01_JPRB, 0.151830E-01_JPRB, 0.134128E-01_JPRB, 0.118266E-01_JPRB &
  &, 0.104006E-01_JPRB, 0.912827E-02_JPRB, 0.800156E-02_JPRB &
  &, 0.699017E-02_JPRB, 0.610360E-02_JPRB, 0.530771E-02_JPRB, 0.460982E-02_JPRB &
  &, 0.399462E-02_JPRB, 0.344509E-02_JPRB, 0.296639E-02_JPRB &
  &, 0.253945E-02_JPRB, 0.219305E-02_JPRB, 0.185684E-02_JPRB, 0.158361E-02_JPRB &
  &, 0.135133E-02_JPRB, 0.116284E-02_JPRB, 0.966401E-03_JPRB &
  &, 0.817571E-03_JPRB, 0.690995E-03_JPRB, 0.588165E-03_JPRB, 0.481163E-03_JPRB &
  &, 0.399910E-03_JPRB, 0.345988E-03_JPRB, 0.289915E-03_JPRB &
  &, 0.231655E-03_JPRB, 0.171171E-03_JPRB, 0.141237E-03_JPRB, 0.110172E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.451697E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 184, :) = (/ &
  &  0.909213E+00_JPRB, 0.886436E+00_JPRB, 0.863654E+00_JPRB, 0.840886E+00_JPRB &
  &, 0.818145E+00_JPRB, 0.795449E+00_JPRB, 0.772810E+00_JPRB &
  &, 0.750247E+00_JPRB, 0.727774E+00_JPRB, 0.705408E+00_JPRB, 0.683165E+00_JPRB &
  &, 0.661061E+00_JPRB, 0.639113E+00_JPRB, 0.617338E+00_JPRB &
  &, 0.595751E+00_JPRB, 0.574372E+00_JPRB, 0.553215E+00_JPRB, 0.532299E+00_JPRB &
  &, 0.511641E+00_JPRB, 0.491258E+00_JPRB, 0.471166E+00_JPRB &
  &, 0.451386E+00_JPRB, 0.431931E+00_JPRB, 0.412820E+00_JPRB, 0.394067E+00_JPRB &
  &, 0.375688E+00_JPRB, 0.357704E+00_JPRB, 0.340123E+00_JPRB &
  &, 0.322965E+00_JPRB, 0.306243E+00_JPRB, 0.289967E+00_JPRB, 0.274154E+00_JPRB &
  &, 0.258811E+00_JPRB, 0.243949E+00_JPRB, 0.229577E+00_JPRB &
  &, 0.215707E+00_JPRB, 0.202332E+00_JPRB, 0.189481E+00_JPRB, 0.177130E+00_JPRB &
  &, 0.165304E+00_JPRB, 0.153993E+00_JPRB, 0.143187E+00_JPRB &
  &, 0.132904E+00_JPRB, 0.123130E+00_JPRB, 0.113857E+00_JPRB, 0.105071E+00_JPRB &
  &, 0.967840E-01_JPRB, 0.889767E-01_JPRB, 0.816276E-01_JPRB &
  &, 0.747362E-01_JPRB, 0.682861E-01_JPRB, 0.622704E-01_JPRB, 0.566651E-01_JPRB &
  &, 0.514561E-01_JPRB, 0.466107E-01_JPRB, 0.421517E-01_JPRB &
  &, 0.380246E-01_JPRB, 0.342311E-01_JPRB, 0.307552E-01_JPRB, 0.275609E-01_JPRB &
  &, 0.246413E-01_JPRB, 0.219876E-01_JPRB, 0.195885E-01_JPRB &
  &, 0.173945E-01_JPRB, 0.154242E-01_JPRB, 0.136403E-01_JPRB, 0.120397E-01_JPRB &
  &, 0.105986E-01_JPRB, 0.931023E-02_JPRB, 0.814611E-02_JPRB &
  &, 0.711670E-02_JPRB, 0.621126E-02_JPRB, 0.541762E-02_JPRB, 0.469958E-02_JPRB &
  &, 0.406332E-02_JPRB, 0.351520E-02_JPRB, 0.303791E-02_JPRB &
  &, 0.261242E-02_JPRB, 0.224267E-02_JPRB, 0.190744E-02_JPRB, 0.163520E-02_JPRB &
  &, 0.137763E-02_JPRB, 0.118965E-02_JPRB, 0.993727E-03_JPRB &
  &, 0.845418E-03_JPRB, 0.719370E-03_JPRB, 0.588165E-03_JPRB, 0.510610E-03_JPRB &
  &, 0.429903E-03_JPRB, 0.345988E-03_JPRB, 0.289915E-03_JPRB &
  &, 0.231655E-03_JPRB, 0.203405E-03_JPRB, 0.141237E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 185, :) = (/ &
  &  0.909567E+00_JPRB, 0.886870E+00_JPRB, 0.864166E+00_JPRB, 0.841473E+00_JPRB &
  &, 0.818805E+00_JPRB, 0.796176E+00_JPRB, 0.773604E+00_JPRB &
  &, 0.751102E+00_JPRB, 0.728688E+00_JPRB, 0.706378E+00_JPRB, 0.684187E+00_JPRB &
  &, 0.662133E+00_JPRB, 0.640229E+00_JPRB, 0.618494E+00_JPRB &
  &, 0.596949E+00_JPRB, 0.575605E+00_JPRB, 0.554481E+00_JPRB, 0.533595E+00_JPRB &
  &, 0.512961E+00_JPRB, 0.492600E+00_JPRB, 0.472528E+00_JPRB &
  &, 0.452762E+00_JPRB, 0.433318E+00_JPRB, 0.414215E+00_JPRB, 0.395467E+00_JPRB &
  &, 0.377089E+00_JPRB, 0.359101E+00_JPRB, 0.341520E+00_JPRB &
  &, 0.324353E+00_JPRB, 0.307621E+00_JPRB, 0.291331E+00_JPRB, 0.275501E+00_JPRB &
  &, 0.260136E+00_JPRB, 0.245254E+00_JPRB, 0.230861E+00_JPRB &
  &, 0.216963E+00_JPRB, 0.203562E+00_JPRB, 0.190674E+00_JPRB, 0.178293E+00_JPRB &
  &, 0.166434E+00_JPRB, 0.155089E+00_JPRB, 0.144245E+00_JPRB &
  &, 0.133923E+00_JPRB, 0.124107E+00_JPRB, 0.114799E+00_JPRB, 0.105978E+00_JPRB &
  &, 0.976516E-01_JPRB, 0.897905E-01_JPRB, 0.824101E-01_JPRB &
  &, 0.754721E-01_JPRB, 0.689859E-01_JPRB, 0.629320E-01_JPRB, 0.572861E-01_JPRB &
  &, 0.520341E-01_JPRB, 0.471580E-01_JPRB, 0.426514E-01_JPRB &
  &, 0.385050E-01_JPRB, 0.346752E-01_JPRB, 0.311608E-01_JPRB, 0.279426E-01_JPRB &
  &, 0.249978E-01_JPRB, 0.223174E-01_JPRB, 0.198725E-01_JPRB &
  &, 0.176667E-01_JPRB, 0.156653E-01_JPRB, 0.138677E-01_JPRB, 0.122334E-01_JPRB &
  &, 0.107767E-01_JPRB, 0.947197E-02_JPRB, 0.829066E-02_JPRB &
  &, 0.726431E-02_JPRB, 0.634046E-02_JPRB, 0.552753E-02_JPRB, 0.478933E-02_JPRB &
  &, 0.415492E-02_JPRB, 0.358530E-02_JPRB, 0.308560E-02_JPRB &
  &, 0.266106E-02_JPRB, 0.229228E-02_JPRB, 0.195804E-02_JPRB, 0.166100E-02_JPRB &
  &, 0.143023E-02_JPRB, 0.121646E-02_JPRB, 0.102105E-02_JPRB &
  &, 0.873266E-03_JPRB, 0.719370E-03_JPRB, 0.617073E-03_JPRB, 0.510610E-03_JPRB &
  &, 0.429903E-03_JPRB, 0.345988E-03_JPRB, 0.289915E-03_JPRB &
  &, 0.231655E-03_JPRB, 0.203405E-03_JPRB, 0.174047E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 186, :) = (/ &
  &  0.909919E+00_JPRB, 0.887303E+00_JPRB, 0.864677E+00_JPRB, 0.842059E+00_JPRB &
  &, 0.819462E+00_JPRB, 0.796902E+00_JPRB, 0.774394E+00_JPRB &
  &, 0.751955E+00_JPRB, 0.729600E+00_JPRB, 0.707345E+00_JPRB, 0.685207E+00_JPRB &
  &, 0.663201E+00_JPRB, 0.641344E+00_JPRB, 0.619653E+00_JPRB &
  &, 0.598145E+00_JPRB, 0.576837E+00_JPRB, 0.555745E+00_JPRB, 0.534886E+00_JPRB &
  &, 0.514279E+00_JPRB, 0.493939E+00_JPRB, 0.473887E+00_JPRB &
  &, 0.454135E+00_JPRB, 0.434702E+00_JPRB, 0.415606E+00_JPRB, 0.396863E+00_JPRB &
  &, 0.378489E+00_JPRB, 0.360502E+00_JPRB, 0.342913E+00_JPRB &
  &, 0.325741E+00_JPRB, 0.308995E+00_JPRB, 0.292694E+00_JPRB, 0.276848E+00_JPRB &
  &, 0.261465E+00_JPRB, 0.246559E+00_JPRB, 0.232144E+00_JPRB &
  &, 0.218218E+00_JPRB, 0.204792E+00_JPRB, 0.191867E+00_JPRB, 0.179456E+00_JPRB &
  &, 0.167565E+00_JPRB, 0.156185E+00_JPRB, 0.145304E+00_JPRB &
  &, 0.134942E+00_JPRB, 0.125094E+00_JPRB, 0.115742E+00_JPRB, 0.106884E+00_JPRB &
  &, 0.985069E-01_JPRB, 0.906169E-01_JPRB, 0.831925E-01_JPRB &
  &, 0.762210E-01_JPRB, 0.696858E-01_JPRB, 0.635936E-01_JPRB, 0.579071E-01_JPRB &
  &, 0.526121E-01_JPRB, 0.477054E-01_JPRB, 0.431663E-01_JPRB &
  &, 0.389855E-01_JPRB, 0.351192E-01_JPRB, 0.315664E-01_JPRB, 0.283243E-01_JPRB &
  &, 0.253543E-01_JPRB, 0.226472E-01_JPRB, 0.201743E-01_JPRB &
  &, 0.179389E-01_JPRB, 0.159065E-01_JPRB, 0.140763E-01_JPRB, 0.124465E-01_JPRB &
  &, 0.109548E-01_JPRB, 0.963372E-02_JPRB, 0.845586E-02_JPRB &
  &, 0.739084E-02_JPRB, 0.644812E-02_JPRB, 0.561546E-02_JPRB, 0.487908E-02_JPRB &
  &, 0.424652E-02_JPRB, 0.367878E-02_JPRB, 0.315712E-02_JPRB &
  &, 0.273403E-02_JPRB, 0.234190E-02_JPRB, 0.200864E-02_JPRB, 0.171259E-02_JPRB &
  &, 0.145653E-02_JPRB, 0.124327E-02_JPRB, 0.104838E-02_JPRB &
  &, 0.901113E-03_JPRB, 0.747744E-03_JPRB, 0.645981E-03_JPRB, 0.540058E-03_JPRB &
  &, 0.429903E-03_JPRB, 0.376533E-03_JPRB, 0.289915E-03_JPRB &
  &, 0.263320E-03_JPRB, 0.203405E-03_JPRB, 0.174047E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 187, :) = (/ &
  &  0.910271E+00_JPRB, 0.887735E+00_JPRB, 0.865187E+00_JPRB, 0.842643E+00_JPRB &
  &, 0.820117E+00_JPRB, 0.797626E+00_JPRB, 0.775182E+00_JPRB &
  &, 0.752806E+00_JPRB, 0.730510E+00_JPRB, 0.708311E+00_JPRB, 0.686224E+00_JPRB &
  &, 0.664267E+00_JPRB, 0.642457E+00_JPRB, 0.620808E+00_JPRB &
  &, 0.599339E+00_JPRB, 0.578065E+00_JPRB, 0.557006E+00_JPRB, 0.536177E+00_JPRB &
  &, 0.515594E+00_JPRB, 0.495277E+00_JPRB, 0.475242E+00_JPRB &
  &, 0.455504E+00_JPRB, 0.436086E+00_JPRB, 0.416998E+00_JPRB, 0.398263E+00_JPRB &
  &, 0.379889E+00_JPRB, 0.361899E+00_JPRB, 0.344306E+00_JPRB &
  &, 0.327126E+00_JPRB, 0.310374E+00_JPRB, 0.294058E+00_JPRB, 0.278195E+00_JPRB &
  &, 0.262795E+00_JPRB, 0.247869E+00_JPRB, 0.233423E+00_JPRB &
  &, 0.219474E+00_JPRB, 0.206023E+00_JPRB, 0.193069E+00_JPRB, 0.180629E+00_JPRB &
  &, 0.168696E+00_JPRB, 0.157280E+00_JPRB, 0.146374E+00_JPRB &
  &, 0.135972E+00_JPRB, 0.126082E+00_JPRB, 0.116684E+00_JPRB, 0.107790E+00_JPRB &
  &, 0.993744E-01_JPRB, 0.914432E-01_JPRB, 0.839750E-01_JPRB &
  &, 0.769700E-01_JPRB, 0.703991E-01_JPRB, 0.642552E-01_JPRB, 0.585282E-01_JPRB &
  &, 0.532046E-01_JPRB, 0.482676E-01_JPRB, 0.436811E-01_JPRB &
  &, 0.394659E-01_JPRB, 0.355632E-01_JPRB, 0.319882E-01_JPRB, 0.287060E-01_JPRB &
  &, 0.257108E-01_JPRB, 0.229597E-01_JPRB, 0.204760E-01_JPRB &
  &, 0.182111E-01_JPRB, 0.161661E-01_JPRB, 0.143227E-01_JPRB, 0.126402E-01_JPRB &
  &, 0.111527E-01_JPRB, 0.981568E-02_JPRB, 0.860041E-02_JPRB &
  &, 0.753846E-02_JPRB, 0.657731E-02_JPRB, 0.574735E-02_JPRB, 0.499127E-02_JPRB &
  &, 0.433812E-02_JPRB, 0.374888E-02_JPRB, 0.322865E-02_JPRB &
  &, 0.278267E-02_JPRB, 0.239151E-02_JPRB, 0.205923E-02_JPRB, 0.176419E-02_JPRB &
  &, 0.150913E-02_JPRB, 0.127008E-02_JPRB, 0.107570E-02_JPRB &
  &, 0.928960E-03_JPRB, 0.776119E-03_JPRB, 0.645981E-03_JPRB, 0.540058E-03_JPRB &
  &, 0.459896E-03_JPRB, 0.376533E-03_JPRB, 0.321017E-03_JPRB &
  &, 0.263320E-03_JPRB, 0.203405E-03_JPRB, 0.174047E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 188, :) = (/ &
  &  0.910622E+00_JPRB, 0.888165E+00_JPRB, 0.865695E+00_JPRB, 0.843226E+00_JPRB &
  &, 0.820771E+00_JPRB, 0.798347E+00_JPRB, 0.775970E+00_JPRB &
  &, 0.753655E+00_JPRB, 0.731417E+00_JPRB, 0.709274E+00_JPRB, 0.687240E+00_JPRB &
  &, 0.665332E+00_JPRB, 0.643566E+00_JPRB, 0.621960E+00_JPRB &
  &, 0.600530E+00_JPRB, 0.579293E+00_JPRB, 0.558265E+00_JPRB, 0.537463E+00_JPRB &
  &, 0.516908E+00_JPRB, 0.496613E+00_JPRB, 0.476594E+00_JPRB &
  &, 0.456873E+00_JPRB, 0.437466E+00_JPRB, 0.418390E+00_JPRB, 0.399659E+00_JPRB &
  &, 0.381286E+00_JPRB, 0.363296E+00_JPRB, 0.345699E+00_JPRB &
  &, 0.328514E+00_JPRB, 0.311748E+00_JPRB, 0.295421E+00_JPRB, 0.279543E+00_JPRB &
  &, 0.264124E+00_JPRB, 0.244648E+00_JPRB, 0.234712E+00_JPRB &
  &, 0.220730E+00_JPRB, 0.207253E+00_JPRB, 0.194272E+00_JPRB, 0.181802E+00_JPRB &
  &, 0.169837E+00_JPRB, 0.158376E+00_JPRB, 0.147432E+00_JPRB &
  &, 0.137002E+00_JPRB, 0.127070E+00_JPRB, 0.117638E+00_JPRB, 0.108696E+00_JPRB &
  &, 0.100242E+00_JPRB, 0.922695E-01_JPRB, 0.847702E-01_JPRB &
  &, 0.777190E-01_JPRB, 0.711124E-01_JPRB, 0.649306E-01_JPRB, 0.591633E-01_JPRB &
  &, 0.537971E-01_JPRB, 0.488150E-01_JPRB, 0.442111E-01_JPRB &
  &, 0.399463E-01_JPRB, 0.360231E-01_JPRB, 0.324101E-01_JPRB, 0.290878E-01_JPRB &
  &, 0.260672E-01_JPRB, 0.232896E-01_JPRB, 0.207778E-01_JPRB &
  &, 0.184833E-01_JPRB, 0.164258E-01_JPRB, 0.145502E-01_JPRB, 0.128533E-01_JPRB &
  &, 0.113309E-01_JPRB, 0.997742E-02_JPRB, 0.876561E-02_JPRB &
  &, 0.766499E-02_JPRB, 0.670650E-02_JPRB, 0.585726E-02_JPRB, 0.508102E-02_JPRB &
  &, 0.440682E-02_JPRB, 0.381898E-02_JPRB, 0.330018E-02_JPRB &
  &, 0.285563E-02_JPRB, 0.244113E-02_JPRB, 0.210983E-02_JPRB, 0.178998E-02_JPRB &
  &, 0.153543E-02_JPRB, 0.129689E-02_JPRB, 0.110303E-02_JPRB &
  &, 0.928960E-03_JPRB, 0.804494E-03_JPRB, 0.674890E-03_JPRB, 0.569506E-03_JPRB &
  &, 0.459896E-03_JPRB, 0.376533E-03_JPRB, 0.321017E-03_JPRB &
  &, 0.263320E-03_JPRB, 0.235639E-03_JPRB, 0.174047E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.791414E-04_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 189, :) = (/ &
  &  0.910970E+00_JPRB, 0.888595E+00_JPRB, 0.866201E+00_JPRB, 0.843806E+00_JPRB &
  &, 0.821422E+00_JPRB, 0.799068E+00_JPRB, 0.776755E+00_JPRB &
  &, 0.754501E+00_JPRB, 0.732323E+00_JPRB, 0.710234E+00_JPRB, 0.688253E+00_JPRB &
  &, 0.666391E+00_JPRB, 0.644674E+00_JPRB, 0.623109E+00_JPRB &
  &, 0.601718E+00_JPRB, 0.580517E+00_JPRB, 0.559521E+00_JPRB, 0.538750E+00_JPRB &
  &, 0.518219E+00_JPRB, 0.497945E+00_JPRB, 0.477946E+00_JPRB &
  &, 0.458242E+00_JPRB, 0.438846E+00_JPRB, 0.419778E+00_JPRB, 0.401051E+00_JPRB &
  &, 0.382687E+00_JPRB, 0.364693E+00_JPRB, 0.347092E+00_JPRB &
  &, 0.329898E+00_JPRB, 0.313123E+00_JPRB, 0.296785E+00_JPRB, 0.280890E+00_JPRB &
  &, 0.265453E+00_JPRB, 0.250483E+00_JPRB, 0.235995E+00_JPRB &
  &, 0.221995E+00_JPRB, 0.208483E+00_JPRB, 0.195475E+00_JPRB, 0.182965E+00_JPRB &
  &, 0.170967E+00_JPRB, 0.159483E+00_JPRB, 0.148502E+00_JPRB &
  &, 0.138032E+00_JPRB, 0.128057E+00_JPRB, 0.118592E+00_JPRB, 0.109614E+00_JPRB &
  &, 0.101122E+00_JPRB, 0.931083E-01_JPRB, 0.855527E-01_JPRB &
  &, 0.784679E-01_JPRB, 0.718257E-01_JPRB, 0.656060E-01_JPRB, 0.597985E-01_JPRB &
  &, 0.543896E-01_JPRB, 0.493771E-01_JPRB, 0.447260E-01_JPRB &
  &, 0.404267E-01_JPRB, 0.364671E-01_JPRB, 0.328319E-01_JPRB, 0.294861E-01_JPRB &
  &, 0.264237E-01_JPRB, 0.236367E-01_JPRB, 0.210796E-01_JPRB &
  &, 0.187736E-01_JPRB, 0.166670E-01_JPRB, 0.147777E-01_JPRB, 0.130664E-01_JPRB &
  &, 0.115288E-01_JPRB, 0.101594E-01_JPRB, 0.891016E-02_JPRB &
  &, 0.781260E-02_JPRB, 0.683570E-02_JPRB, 0.596717E-02_JPRB, 0.519321E-02_JPRB &
  &, 0.449842E-02_JPRB, 0.391245E-02_JPRB, 0.337170E-02_JPRB &
  &, 0.290428E-02_JPRB, 0.251555E-02_JPRB, 0.216043E-02_JPRB, 0.184158E-02_JPRB &
  &, 0.156173E-02_JPRB, 0.135051E-02_JPRB, 0.113036E-02_JPRB &
  &, 0.956808E-03_JPRB, 0.804494E-03_JPRB, 0.674890E-03_JPRB, 0.569506E-03_JPRB &
  &, 0.489889E-03_JPRB, 0.407077E-03_JPRB, 0.321017E-03_JPRB &
  &, 0.263320E-03_JPRB, 0.235639E-03_JPRB, 0.174047E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.457747E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART27',1,ZHOOK_HANDLE)
END SUBROUTINE PART27

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART28

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART28',0,ZHOOK_HANDLE)

XCW( 190, :) = (/ &
  &  0.911319E+00_JPRB, 0.889023E+00_JPRB, 0.866706E+00_JPRB, 0.844385E+00_JPRB &
  &, 0.822072E+00_JPRB, 0.799785E+00_JPRB, 0.777538E+00_JPRB &
  &, 0.755346E+00_JPRB, 0.733226E+00_JPRB, 0.711192E+00_JPRB, 0.689263E+00_JPRB &
  &, 0.667453E+00_JPRB, 0.645778E+00_JPRB, 0.624258E+00_JPRB &
  &, 0.602905E+00_JPRB, 0.581738E+00_JPRB, 0.560776E+00_JPRB, 0.540033E+00_JPRB &
  &, 0.519529E+00_JPRB, 0.499278E+00_JPRB, 0.479298E+00_JPRB &
  &, 0.459608E+00_JPRB, 0.440227E+00_JPRB, 0.421166E+00_JPRB, 0.402447E+00_JPRB &
  &, 0.384083E+00_JPRB, 0.366090E+00_JPRB, 0.348485E+00_JPRB &
  &, 0.331286E+00_JPRB, 0.314501E+00_JPRB, 0.298148E+00_JPRB, 0.282237E+00_JPRB &
  &, 0.266782E+00_JPRB, 0.251793E+00_JPRB, 0.237283E+00_JPRB &
  &, 0.223250E+00_JPRB, 0.209713E+00_JPRB, 0.196678E+00_JPRB, 0.184138E+00_JPRB &
  &, 0.172108E+00_JPRB, 0.160589E+00_JPRB, 0.149571E+00_JPRB &
  &, 0.139062E+00_JPRB, 0.129056E+00_JPRB, 0.119546E+00_JPRB, 0.110521E+00_JPRB &
  &, 0.102002E+00_JPRB, 0.939472E-01_JPRB, 0.863479E-01_JPRB &
  &, 0.792169E-01_JPRB, 0.725390E-01_JPRB, 0.662814E-01_JPRB, 0.604336E-01_JPRB &
  &, 0.549966E-01_JPRB, 0.499393E-01_JPRB, 0.452559E-01_JPRB &
  &, 0.409226E-01_JPRB, 0.369270E-01_JPRB, 0.332537E-01_JPRB, 0.298844E-01_JPRB &
  &, 0.267802E-01_JPRB, 0.239666E-01_JPRB, 0.213991E-01_JPRB &
  &, 0.190458E-01_JPRB, 0.169266E-01_JPRB, 0.150241E-01_JPRB, 0.132795E-01_JPRB &
  &, 0.117267E-01_JPRB, 0.103211E-01_JPRB, 0.907536E-02_JPRB &
  &, 0.796022E-02_JPRB, 0.696489E-02_JPRB, 0.607708E-02_JPRB, 0.530541E-02_JPRB &
  &, 0.459002E-02_JPRB, 0.398256E-02_JPRB, 0.344323E-02_JPRB &
  &, 0.297724E-02_JPRB, 0.256517E-02_JPRB, 0.221103E-02_JPRB, 0.189317E-02_JPRB &
  &, 0.161433E-02_JPRB, 0.137732E-02_JPRB, 0.115768E-02_JPRB &
  &, 0.984655E-03_JPRB, 0.832869E-03_JPRB, 0.703798E-03_JPRB, 0.598953E-03_JPRB &
  &, 0.489889E-03_JPRB, 0.407077E-03_JPRB, 0.352119E-03_JPRB &
  &, 0.294985E-03_JPRB, 0.235639E-03_JPRB, 0.206856E-03_JPRB, 0.143562E-03_JPRB &
  &, 0.111933E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 191, :) = (/ &
  &  0.911666E+00_JPRB, 0.889450E+00_JPRB, 0.867210E+00_JPRB, 0.844963E+00_JPRB &
  &, 0.822721E+00_JPRB, 0.800501E+00_JPRB, 0.778319E+00_JPRB &
  &, 0.756188E+00_JPRB, 0.734126E+00_JPRB, 0.712149E+00_JPRB, 0.690272E+00_JPRB &
  &, 0.668510E+00_JPRB, 0.646882E+00_JPRB, 0.625402E+00_JPRB &
  &, 0.604090E+00_JPRB, 0.582958E+00_JPRB, 0.562029E+00_JPRB, 0.541315E+00_JPRB &
  &, 0.520836E+00_JPRB, 0.500607E+00_JPRB, 0.480647E+00_JPRB &
  &, 0.460974E+00_JPRB, 0.441604E+00_JPRB, 0.422551E+00_JPRB, 0.403840E+00_JPRB &
  &, 0.385476E+00_JPRB, 0.367483E+00_JPRB, 0.349878E+00_JPRB &
  &, 0.332670E+00_JPRB, 0.315875E+00_JPRB, 0.299512E+00_JPRB, 0.283584E+00_JPRB &
  &, 0.268115E+00_JPRB, 0.253107E+00_JPRB, 0.238572E+00_JPRB &
  &, 0.224515E+00_JPRB, 0.210953E+00_JPRB, 0.197880E+00_JPRB, 0.185321E+00_JPRB &
  &, 0.173249E+00_JPRB, 0.161696E+00_JPRB, 0.150641E+00_JPRB &
  &, 0.140092E+00_JPRB, 0.130044E+00_JPRB, 0.120500E+00_JPRB, 0.111451E+00_JPRB &
  &, 0.102869E+00_JPRB, 0.947860E-01_JPRB, 0.871560E-01_JPRB &
  &, 0.799790E-01_JPRB, 0.732524E-01_JPRB, 0.669568E-01_JPRB, 0.610829E-01_JPRB &
  &, 0.556035E-01_JPRB, 0.505163E-01_JPRB, 0.457859E-01_JPRB &
  &, 0.414185E-01_JPRB, 0.373869E-01_JPRB, 0.336756E-01_JPRB, 0.302828E-01_JPRB &
  &, 0.271537E-01_JPRB, 0.242964E-01_JPRB, 0.217008E-01_JPRB &
  &, 0.193362E-01_JPRB, 0.171863E-01_JPRB, 0.152516E-01_JPRB, 0.134926E-01_JPRB &
  &, 0.119246E-01_JPRB, 0.105031E-01_JPRB, 0.924056E-02_JPRB &
  &, 0.810784E-02_JPRB, 0.709408E-02_JPRB, 0.618699E-02_JPRB, 0.539516E-02_JPRB &
  &, 0.470452E-02_JPRB, 0.407603E-02_JPRB, 0.351475E-02_JPRB &
  &, 0.305021E-02_JPRB, 0.261478E-02_JPRB, 0.226163E-02_JPRB, 0.191897E-02_JPRB &
  &, 0.164063E-02_JPRB, 0.140413E-02_JPRB, 0.118501E-02_JPRB &
  &, 0.101250E-02_JPRB, 0.861244E-03_JPRB, 0.732706E-03_JPRB, 0.598953E-03_JPRB &
  &, 0.519882E-03_JPRB, 0.437621E-03_JPRB, 0.352119E-03_JPRB &
  &, 0.294985E-03_JPRB, 0.235639E-03_JPRB, 0.206856E-03_JPRB, 0.176953E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 192, :) = (/ &
  &  0.912011E+00_JPRB, 0.889875E+00_JPRB, 0.867712E+00_JPRB, 0.845538E+00_JPRB &
  &, 0.823368E+00_JPRB, 0.801215E+00_JPRB, 0.779097E+00_JPRB &
  &, 0.757029E+00_JPRB, 0.735026E+00_JPRB, 0.713103E+00_JPRB, 0.691278E+00_JPRB &
  &, 0.669565E+00_JPRB, 0.647983E+00_JPRB, 0.626545E+00_JPRB &
  &, 0.605271E+00_JPRB, 0.584177E+00_JPRB, 0.563279E+00_JPRB, 0.542594E+00_JPRB &
  &, 0.522141E+00_JPRB, 0.501936E+00_JPRB, 0.481996E+00_JPRB &
  &, 0.462337E+00_JPRB, 0.442981E+00_JPRB, 0.423939E+00_JPRB, 0.405229E+00_JPRB &
  &, 0.386873E+00_JPRB, 0.368880E+00_JPRB, 0.351271E+00_JPRB &
  &, 0.334054E+00_JPRB, 0.317254E+00_JPRB, 0.300875E+00_JPRB, 0.284935E+00_JPRB &
  &, 0.269445E+00_JPRB, 0.254416E+00_JPRB, 0.239860E+00_JPRB &
  &, 0.225780E+00_JPRB, 0.212183E+00_JPRB, 0.199093E+00_JPRB, 0.186494E+00_JPRB &
  &, 0.174400E+00_JPRB, 0.162802E+00_JPRB, 0.151721E+00_JPRB &
  &, 0.141133E+00_JPRB, 0.131054E+00_JPRB, 0.121466E+00_JPRB, 0.112369E+00_JPRB &
  &, 0.103761E+00_JPRB, 0.956248E-01_JPRB, 0.879513E-01_JPRB &
  &, 0.807411E-01_JPRB, 0.739791E-01_JPRB, 0.676459E-01_JPRB, 0.617180E-01_JPRB &
  &, 0.562105E-01_JPRB, 0.510784E-01_JPRB, 0.463159E-01_JPRB &
  &, 0.419144E-01_JPRB, 0.378626E-01_JPRB, 0.341136E-01_JPRB, 0.306811E-01_JPRB &
  &, 0.275271E-01_JPRB, 0.246436E-01_JPRB, 0.220203E-01_JPRB &
  &, 0.196265E-01_JPRB, 0.174646E-01_JPRB, 0.154981E-01_JPRB, 0.137250E-01_JPRB &
  &, 0.121225E-01_JPRB, 0.106850E-01_JPRB, 0.940576E-02_JPRB &
  &, 0.825545E-02_JPRB, 0.722328E-02_JPRB, 0.631889E-02_JPRB, 0.550735E-02_JPRB &
  &, 0.479612E-02_JPRB, 0.414613E-02_JPRB, 0.361012E-02_JPRB &
  &, 0.309885E-02_JPRB, 0.268920E-02_JPRB, 0.231223E-02_JPRB, 0.197056E-02_JPRB &
  &, 0.169323E-02_JPRB, 0.143094E-02_JPRB, 0.123966E-02_JPRB &
  &, 0.104035E-02_JPRB, 0.889618E-03_JPRB, 0.732706E-03_JPRB, 0.628401E-03_JPRB &
  &, 0.519882E-03_JPRB, 0.437621E-03_JPRB, 0.352119E-03_JPRB &
  &, 0.294985E-03_JPRB, 0.267873E-03_JPRB, 0.206856E-03_JPRB, 0.176953E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 193, :) = (/ &
  &  0.912357E+00_JPRB, 0.890300E+00_JPRB, 0.868213E+00_JPRB, 0.846112E+00_JPRB &
  &, 0.824012E+00_JPRB, 0.801928E+00_JPRB, 0.779874E+00_JPRB &
  &, 0.757867E+00_JPRB, 0.735922E+00_JPRB, 0.714055E+00_JPRB, 0.692281E+00_JPRB &
  &, 0.670617E+00_JPRB, 0.649081E+00_JPRB, 0.627686E+00_JPRB &
  &, 0.606450E+00_JPRB, 0.585392E+00_JPRB, 0.564528E+00_JPRB, 0.543873E+00_JPRB &
  &, 0.523445E+00_JPRB, 0.503263E+00_JPRB, 0.483342E+00_JPRB &
  &, 0.463700E+00_JPRB, 0.444354E+00_JPRB, 0.425324E+00_JPRB, 0.406621E+00_JPRB &
  &, 0.388266E+00_JPRB, 0.370274E+00_JPRB, 0.352660E+00_JPRB &
  &, 0.335438E+00_JPRB, 0.318628E+00_JPRB, 0.302238E+00_JPRB, 0.286282E+00_JPRB &
  &, 0.270778E+00_JPRB, 0.255730E+00_JPRB, 0.241148E+00_JPRB &
  &, 0.227045E+00_JPRB, 0.213423E+00_JPRB, 0.200305E+00_JPRB, 0.187667E+00_JPRB &
  &, 0.175541E+00_JPRB, 0.163919E+00_JPRB, 0.152791E+00_JPRB &
  &, 0.142174E+00_JPRB, 0.132053E+00_JPRB, 0.122432E+00_JPRB, 0.113287E+00_JPRB &
  &, 0.104641E+00_JPRB, 0.964637E-01_JPRB, 0.887594E-01_JPRB &
  &, 0.815164E-01_JPRB, 0.747059E-01_JPRB, 0.683351E-01_JPRB, 0.623673E-01_JPRB &
  &, 0.568174E-01_JPRB, 0.516554E-01_JPRB, 0.468610E-01_JPRB &
  &, 0.424258E-01_JPRB, 0.383225E-01_JPRB, 0.345517E-01_JPRB, 0.310794E-01_JPRB &
  &, 0.279006E-01_JPRB, 0.249908E-01_JPRB, 0.223398E-01_JPRB &
  &, 0.199168E-01_JPRB, 0.177243E-01_JPRB, 0.157445E-01_JPRB, 0.139381E-01_JPRB &
  &, 0.123204E-01_JPRB, 0.108670E-01_JPRB, 0.957096E-02_JPRB &
  &, 0.840307E-02_JPRB, 0.735247E-02_JPRB, 0.642880E-02_JPRB, 0.561954E-02_JPRB &
  &, 0.488772E-02_JPRB, 0.423961E-02_JPRB, 0.368164E-02_JPRB &
  &, 0.317182E-02_JPRB, 0.273882E-02_JPRB, 0.236282E-02_JPRB, 0.202216E-02_JPRB &
  &, 0.171954E-02_JPRB, 0.148456E-02_JPRB, 0.126698E-02_JPRB &
  &, 0.106820E-02_JPRB, 0.917993E-03_JPRB, 0.761614E-03_JPRB, 0.657849E-03_JPRB &
  &, 0.549875E-03_JPRB, 0.468166E-03_JPRB, 0.383220E-03_JPRB &
  &, 0.326650E-03_JPRB, 0.267873E-03_JPRB, 0.206856E-03_JPRB, 0.176953E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 194, :) = (/ &
  &  0.912701E+00_JPRB, 0.890723E+00_JPRB, 0.868712E+00_JPRB, 0.846685E+00_JPRB &
  &, 0.824655E+00_JPRB, 0.802638E+00_JPRB, 0.780649E+00_JPRB &
  &, 0.758703E+00_JPRB, 0.736816E+00_JPRB, 0.715004E+00_JPRB, 0.693283E+00_JPRB &
  &, 0.671668E+00_JPRB, 0.650177E+00_JPRB, 0.628825E+00_JPRB &
  &, 0.607629E+00_JPRB, 0.586607E+00_JPRB, 0.565773E+00_JPRB, 0.545147E+00_JPRB &
  &, 0.524746E+00_JPRB, 0.504585E+00_JPRB, 0.484684E+00_JPRB &
  &, 0.465059E+00_JPRB, 0.445728E+00_JPRB, 0.426705E+00_JPRB, 0.408010E+00_JPRB &
  &, 0.389659E+00_JPRB, 0.371667E+00_JPRB, 0.354049E+00_JPRB &
  &, 0.336823E+00_JPRB, 0.320002E+00_JPRB, 0.303602E+00_JPRB, 0.287633E+00_JPRB &
  &, 0.272111E+00_JPRB, 0.257040E+00_JPRB, 0.242441E+00_JPRB &
  &, 0.228310E+00_JPRB, 0.214663E+00_JPRB, 0.201508E+00_JPRB, 0.188850E+00_JPRB &
  &, 0.176693E+00_JPRB, 0.165037E+00_JPRB, 0.153871E+00_JPRB &
  &, 0.143215E+00_JPRB, 0.133052E+00_JPRB, 0.123397E+00_JPRB, 0.114217E+00_JPRB &
  &, 0.105533E+00_JPRB, 0.973150E-01_JPRB, 0.895675E-01_JPRB &
  &, 0.822785E-01_JPRB, 0.754327E-01_JPRB, 0.690243E-01_JPRB, 0.630307E-01_JPRB &
  &, 0.574388E-01_JPRB, 0.522323E-01_JPRB, 0.474062E-01_JPRB &
  &, 0.429217E-01_JPRB, 0.387982E-01_JPRB, 0.349898E-01_JPRB, 0.314943E-01_JPRB &
  &, 0.282740E-01_JPRB, 0.253380E-01_JPRB, 0.226593E-01_JPRB &
  &, 0.202072E-01_JPRB, 0.180025E-01_JPRB, 0.159910E-01_JPRB, 0.141706E-01_JPRB &
  &, 0.125382E-01_JPRB, 0.110490E-01_JPRB, 0.973616E-02_JPRB &
  &, 0.855069E-02_JPRB, 0.750320E-02_JPRB, 0.656069E-02_JPRB, 0.573173E-02_JPRB &
  &, 0.497932E-02_JPRB, 0.433308E-02_JPRB, 0.375317E-02_JPRB &
  &, 0.324478E-02_JPRB, 0.278843E-02_JPRB, 0.241342E-02_JPRB, 0.207375E-02_JPRB &
  &, 0.177214E-02_JPRB, 0.151137E-02_JPRB, 0.129431E-02_JPRB &
  &, 0.109604E-02_JPRB, 0.917993E-03_JPRB, 0.790523E-03_JPRB, 0.657849E-03_JPRB &
  &, 0.549875E-03_JPRB, 0.468166E-03_JPRB, 0.383220E-03_JPRB &
  &, 0.326650E-03_JPRB, 0.267873E-03_JPRB, 0.206856E-03_JPRB, 0.176953E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.803394E-04_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 195, :) = (/ &
  &  0.913043E+00_JPRB, 0.891144E+00_JPRB, 0.869210E+00_JPRB, 0.847256E+00_JPRB &
  &, 0.825296E+00_JPRB, 0.803347E+00_JPRB, 0.781422E+00_JPRB &
  &, 0.759537E+00_JPRB, 0.737704E+00_JPRB, 0.715952E+00_JPRB, 0.694283E+00_JPRB &
  &, 0.672717E+00_JPRB, 0.651271E+00_JPRB, 0.629961E+00_JPRB &
  &, 0.608804E+00_JPRB, 0.587818E+00_JPRB, 0.567018E+00_JPRB, 0.546422E+00_JPRB &
  &, 0.526047E+00_JPRB, 0.505908E+00_JPRB, 0.486026E+00_JPRB &
  &, 0.466419E+00_JPRB, 0.447098E+00_JPRB, 0.428086E+00_JPRB, 0.409399E+00_JPRB &
  &, 0.391053E+00_JPRB, 0.373060E+00_JPRB, 0.355442E+00_JPRB &
  &, 0.338211E+00_JPRB, 0.321381E+00_JPRB, 0.304965E+00_JPRB, 0.288985E+00_JPRB &
  &, 0.273445E+00_JPRB, 0.258354E+00_JPRB, 0.243733E+00_JPRB &
  &, 0.229575E+00_JPRB, 0.215912E+00_JPRB, 0.202720E+00_JPRB, 0.190033E+00_JPRB &
  &, 0.177844E+00_JPRB, 0.166154E+00_JPRB, 0.154951E+00_JPRB &
  &, 0.144267E+00_JPRB, 0.134062E+00_JPRB, 0.124363E+00_JPRB, 0.115147E+00_JPRB &
  &, 0.106425E+00_JPRB, 0.981664E-01_JPRB, 0.903884E-01_JPRB &
  &, 0.830538E-01_JPRB, 0.761729E-01_JPRB, 0.697135E-01_JPRB, 0.636799E-01_JPRB &
  &, 0.580458E-01_JPRB, 0.528093E-01_JPRB, 0.479513E-01_JPRB &
  &, 0.434332E-01_JPRB, 0.392739E-01_JPRB, 0.354278E-01_JPRB, 0.318927E-01_JPRB &
  &, 0.286475E-01_JPRB, 0.256852E-01_JPRB, 0.229788E-01_JPRB &
  &, 0.205157E-01_JPRB, 0.182622E-01_JPRB, 0.162374E-01_JPRB, 0.144030E-01_JPRB &
  &, 0.127361E-01_JPRB, 0.112511E-01_JPRB, 0.990136E-02_JPRB &
  &, 0.869830E-02_JPRB, 0.763239E-02_JPRB, 0.669258E-02_JPRB, 0.584392E-02_JPRB &
  &, 0.509382E-02_JPRB, 0.442655E-02_JPRB, 0.382470E-02_JPRB &
  &, 0.331775E-02_JPRB, 0.286286E-02_JPRB, 0.246402E-02_JPRB, 0.212534E-02_JPRB &
  &, 0.182474E-02_JPRB, 0.153818E-02_JPRB, 0.132164E-02_JPRB &
  &, 0.112389E-02_JPRB, 0.946368E-03_JPRB, 0.819431E-03_JPRB, 0.687296E-03_JPRB &
  &, 0.579868E-03_JPRB, 0.468166E-03_JPRB, 0.414322E-03_JPRB &
  &, 0.326650E-03_JPRB, 0.267873E-03_JPRB, 0.239666E-03_JPRB, 0.176953E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 196, :) = (/ &
  &  0.913386E+00_JPRB, 0.891566E+00_JPRB, 0.869707E+00_JPRB, 0.847826E+00_JPRB &
  &, 0.825936E+00_JPRB, 0.804054E+00_JPRB, 0.782193E+00_JPRB &
  &, 0.760370E+00_JPRB, 0.738599E+00_JPRB, 0.716897E+00_JPRB, 0.695280E+00_JPRB &
  &, 0.673762E+00_JPRB, 0.652362E+00_JPRB, 0.631095E+00_JPRB &
  &, 0.609978E+00_JPRB, 0.589028E+00_JPRB, 0.568260E+00_JPRB, 0.547693E+00_JPRB &
  &, 0.527345E+00_JPRB, 0.507231E+00_JPRB, 0.487369E+00_JPRB &
  &, 0.467775E+00_JPRB, 0.448471E+00_JPRB, 0.429468E+00_JPRB, 0.410788E+00_JPRB &
  &, 0.392442E+00_JPRB, 0.374453E+00_JPRB, 0.356831E+00_JPRB &
  &, 0.339595E+00_JPRB, 0.322755E+00_JPRB, 0.306333E+00_JPRB, 0.290336E+00_JPRB &
  &, 0.274778E+00_JPRB, 0.259672E+00_JPRB, 0.245026E+00_JPRB &
  &, 0.230850E+00_JPRB, 0.217152E+00_JPRB, 0.203943E+00_JPRB, 0.191216E+00_JPRB &
  &, 0.178995E+00_JPRB, 0.167271E+00_JPRB, 0.156043E+00_JPRB &
  &, 0.145308E+00_JPRB, 0.135072E+00_JPRB, 0.125340E+00_JPRB, 0.116089E+00_JPRB &
  &, 0.107317E+00_JPRB, 0.990303E-01_JPRB, 0.911965E-01_JPRB &
  &, 0.838290E-01_JPRB, 0.768997E-01_JPRB, 0.704164E-01_JPRB, 0.643433E-01_JPRB &
  &, 0.586672E-01_JPRB, 0.534011E-01_JPRB, 0.484964E-01_JPRB &
  &, 0.439446E-01_JPRB, 0.397497E-01_JPRB, 0.358821E-01_JPRB, 0.323076E-01_JPRB &
  &, 0.290379E-01_JPRB, 0.260324E-01_JPRB, 0.232983E-01_JPRB &
  &, 0.208060E-01_JPRB, 0.185404E-01_JPRB, 0.164838E-01_JPRB, 0.146161E-01_JPRB &
  &, 0.129538E-01_JPRB, 0.114331E-01_JPRB, 0.100872E-01_JPRB &
  &, 0.886701E-02_JPRB, 0.778311E-02_JPRB, 0.680250E-02_JPRB, 0.595611E-02_JPRB &
  &, 0.518542E-02_JPRB, 0.449665E-02_JPRB, 0.392006E-02_JPRB &
  &, 0.339071E-02_JPRB, 0.291247E-02_JPRB, 0.251462E-02_JPRB, 0.217694E-02_JPRB &
  &, 0.185104E-02_JPRB, 0.159180E-02_JPRB, 0.134896E-02_JPRB &
  &, 0.115174E-02_JPRB, 0.974743E-03_JPRB, 0.819431E-03_JPRB, 0.687296E-03_JPRB &
  &, 0.579868E-03_JPRB, 0.498710E-03_JPRB, 0.414322E-03_JPRB &
  &, 0.358315E-03_JPRB, 0.300108E-03_JPRB, 0.239666E-03_JPRB, 0.210343E-03_JPRB &
  &, 0.145910E-03_JPRB, 0.113712E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.463856E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART28',1,ZHOOK_HANDLE)
END SUBROUTINE PART28

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART29

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART29',0,ZHOOK_HANDLE)

XCW( 197, :) = (/ &
  &  0.913727E+00_JPRB, 0.891985E+00_JPRB, 0.870202E+00_JPRB, 0.848394E+00_JPRB &
  &, 0.826574E+00_JPRB, 0.804759E+00_JPRB, 0.782962E+00_JPRB &
  &, 0.761199E+00_JPRB, 0.739488E+00_JPRB, 0.717840E+00_JPRB, 0.696275E+00_JPRB &
  &, 0.674807E+00_JPRB, 0.653452E+00_JPRB, 0.632227E+00_JPRB &
  &, 0.611149E+00_JPRB, 0.590234E+00_JPRB, 0.569500E+00_JPRB, 0.548964E+00_JPRB &
  &, 0.528640E+00_JPRB, 0.508548E+00_JPRB, 0.488708E+00_JPRB &
  &, 0.469131E+00_JPRB, 0.449838E+00_JPRB, 0.430849E+00_JPRB, 0.412174E+00_JPRB &
  &, 0.393831E+00_JPRB, 0.375843E+00_JPRB, 0.358220E+00_JPRB &
  &, 0.340979E+00_JPRB, 0.324130E+00_JPRB, 0.307696E+00_JPRB, 0.291687E+00_JPRB &
  &, 0.276112E+00_JPRB, 0.260986E+00_JPRB, 0.246319E+00_JPRB &
  &, 0.232115E+00_JPRB, 0.218392E+00_JPRB, 0.205155E+00_JPRB, 0.192409E+00_JPRB &
  &, 0.180146E+00_JPRB, 0.168388E+00_JPRB, 0.157123E+00_JPRB &
  &, 0.146360E+00_JPRB, 0.136094E+00_JPRB, 0.126318E+00_JPRB, 0.117019E+00_JPRB &
  &, 0.108221E+00_JPRB, 0.998816E-01_JPRB, 0.920174E-01_JPRB &
  &, 0.846042E-01_JPRB, 0.776399E-01_JPRB, 0.711194E-01_JPRB, 0.650067E-01_JPRB &
  &, 0.593030E-01_JPRB, 0.539780E-01_JPRB, 0.490416E-01_JPRB &
  &, 0.444715E-01_JPRB, 0.402254E-01_JPRB, 0.363201E-01_JPRB, 0.327225E-01_JPRB &
  &, 0.294284E-01_JPRB, 0.263970E-01_JPRB, 0.236356E-01_JPRB &
  &, 0.211145E-01_JPRB, 0.188186E-01_JPRB, 0.167303E-01_JPRB, 0.148486E-01_JPRB &
  &, 0.131517E-01_JPRB, 0.116353E-01_JPRB, 0.102524E-01_JPRB &
  &, 0.901463E-02_JPRB, 0.791231E-02_JPRB, 0.693439E-02_JPRB, 0.606830E-02_JPRB &
  &, 0.527702E-02_JPRB, 0.459013E-02_JPRB, 0.399159E-02_JPRB &
  &, 0.346368E-02_JPRB, 0.298689E-02_JPRB, 0.256522E-02_JPRB, 0.220273E-02_JPRB &
  &, 0.190364E-02_JPRB, 0.161861E-02_JPRB, 0.137629E-02_JPRB &
  &, 0.117959E-02_JPRB, 0.100312E-02_JPRB, 0.848339E-03_JPRB, 0.716744E-03_JPRB &
  &, 0.609861E-03_JPRB, 0.498710E-03_JPRB, 0.414322E-03_JPRB &
  &, 0.358315E-03_JPRB, 0.300108E-03_JPRB, 0.239666E-03_JPRB, 0.210343E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 198, :) = (/ &
  &  0.914067E+00_JPRB, 0.892403E+00_JPRB, 0.870696E+00_JPRB, 0.848961E+00_JPRB &
  &, 0.827211E+00_JPRB, 0.805462E+00_JPRB, 0.783729E+00_JPRB &
  &, 0.762028E+00_JPRB, 0.740373E+00_JPRB, 0.718782E+00_JPRB, 0.697268E+00_JPRB &
  &, 0.675848E+00_JPRB, 0.654539E+00_JPRB, 0.633357E+00_JPRB &
  &, 0.612318E+00_JPRB, 0.591440E+00_JPRB, 0.570738E+00_JPRB, 0.550231E+00_JPRB &
  &, 0.529935E+00_JPRB, 0.509868E+00_JPRB, 0.490044E+00_JPRB &
  &, 0.470487E+00_JPRB, 0.451208E+00_JPRB, 0.432227E+00_JPRB, 0.413559E+00_JPRB &
  &, 0.395225E+00_JPRB, 0.377232E+00_JPRB, 0.359609E+00_JPRB &
  &, 0.342359E+00_JPRB, 0.325508E+00_JPRB, 0.309064E+00_JPRB, 0.293038E+00_JPRB &
  &, 0.277445E+00_JPRB, 0.262305E+00_JPRB, 0.247616E+00_JPRB &
  &, 0.233389E+00_JPRB, 0.219641E+00_JPRB, 0.206377E+00_JPRB, 0.193592E+00_JPRB &
  &, 0.181308E+00_JPRB, 0.169515E+00_JPRB, 0.158214E+00_JPRB &
  &, 0.147412E+00_JPRB, 0.137104E+00_JPRB, 0.127295E+00_JPRB, 0.117961E+00_JPRB &
  &, 0.109125E+00_JPRB, 0.100745E+00_JPRB, 0.928383E-01_JPRB &
  &, 0.853926E-01_JPRB, 0.783936E-01_JPRB, 0.718224E-01_JPRB, 0.656701E-01_JPRB &
  &, 0.599244E-01_JPRB, 0.545698E-01_JPRB, 0.496018E-01_JPRB &
  &, 0.449829E-01_JPRB, 0.407170E-01_JPRB, 0.367744E-01_JPRB, 0.331540E-01_JPRB &
  &, 0.298188E-01_JPRB, 0.267615E-01_JPRB, 0.239728E-01_JPRB &
  &, 0.214230E-01_JPRB, 0.190969E-01_JPRB, 0.169957E-01_JPRB, 0.151004E-01_JPRB &
  &, 0.133694E-01_JPRB, 0.118172E-01_JPRB, 0.104176E-01_JPRB &
  &, 0.918333E-02_JPRB, 0.806303E-02_JPRB, 0.706628E-02_JPRB, 0.618049E-02_JPRB &
  &, 0.539152E-02_JPRB, 0.468360E-02_JPRB, 0.406311E-02_JPRB &
  &, 0.353664E-02_JPRB, 0.306132E-02_JPRB, 0.264112E-02_JPRB, 0.225433E-02_JPRB &
  &, 0.195624E-02_JPRB, 0.167223E-02_JPRB, 0.143094E-02_JPRB &
  &, 0.120743E-02_JPRB, 0.103149E-02_JPRB, 0.877247E-03_JPRB, 0.746192E-03_JPRB &
  &, 0.609861E-03_JPRB, 0.529255E-03_JPRB, 0.445424E-03_JPRB &
  &, 0.358315E-03_JPRB, 0.300108E-03_JPRB, 0.239666E-03_JPRB, 0.210343E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 199, :) = (/ &
  &  0.914407E+00_JPRB, 0.892821E+00_JPRB, 0.871188E+00_JPRB, 0.849526E+00_JPRB &
  &, 0.827846E+00_JPRB, 0.806163E+00_JPRB, 0.784495E+00_JPRB &
  &, 0.762855E+00_JPRB, 0.741258E+00_JPRB, 0.719721E+00_JPRB, 0.698259E+00_JPRB &
  &, 0.676888E+00_JPRB, 0.655624E+00_JPRB, 0.634485E+00_JPRB &
  &, 0.613486E+00_JPRB, 0.592644E+00_JPRB, 0.571975E+00_JPRB, 0.551497E+00_JPRB &
  &, 0.531229E+00_JPRB, 0.511184E+00_JPRB, 0.491383E+00_JPRB &
  &, 0.471839E+00_JPRB, 0.452575E+00_JPRB, 0.433604E+00_JPRB, 0.414945E+00_JPRB &
  &, 0.396610E+00_JPRB, 0.378626E+00_JPRB, 0.360998E+00_JPRB &
  &, 0.343743E+00_JPRB, 0.326882E+00_JPRB, 0.310427E+00_JPRB, 0.294390E+00_JPRB &
  &, 0.278783E+00_JPRB, 0.263619E+00_JPRB, 0.248909E+00_JPRB &
  &, 0.234663E+00_JPRB, 0.220890E+00_JPRB, 0.207590E+00_JPRB, 0.194785E+00_JPRB &
  &, 0.182469E+00_JPRB, 0.170643E+00_JPRB, 0.159305E+00_JPRB &
  &, 0.148475E+00_JPRB, 0.138126E+00_JPRB, 0.128272E+00_JPRB, 0.118915E+00_JPRB &
  &, 0.110029E+00_JPRB, 0.101609E+00_JPRB, 0.936721E-01_JPRB &
  &, 0.861810E-01_JPRB, 0.791338E-01_JPRB, 0.725253E-01_JPRB, 0.663334E-01_JPRB &
  &, 0.605603E-01_JPRB, 0.551615E-01_JPRB, 0.501621E-01_JPRB &
  &, 0.455098E-01_JPRB, 0.412086E-01_JPRB, 0.372287E-01_JPRB, 0.335689E-01_JPRB &
  &, 0.302092E-01_JPRB, 0.271261E-01_JPRB, 0.242923E-01_JPRB &
  &, 0.217315E-01_JPRB, 0.193751E-01_JPRB, 0.172611E-01_JPRB, 0.153329E-01_JPRB &
  &, 0.135871E-01_JPRB, 0.120194E-01_JPRB, 0.106035E-01_JPRB &
  &, 0.933095E-02_JPRB, 0.821376E-02_JPRB, 0.719817E-02_JPRB, 0.629268E-02_JPRB &
  &, 0.548312E-02_JPRB, 0.477707E-02_JPRB, 0.415848E-02_JPRB &
  &, 0.360961E-02_JPRB, 0.311093E-02_JPRB, 0.269171E-02_JPRB, 0.230592E-02_JPRB &
  &, 0.198254E-02_JPRB, 0.169904E-02_JPRB, 0.145826E-02_JPRB &
  &, 0.123528E-02_JPRB, 0.105987E-02_JPRB, 0.906156E-03_JPRB, 0.746192E-03_JPRB &
  &, 0.639854E-03_JPRB, 0.529255E-03_JPRB, 0.445424E-03_JPRB &
  &, 0.389979E-03_JPRB, 0.300108E-03_JPRB, 0.272475E-03_JPRB, 0.210343E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 200, :) = (/ &
  &  0.914744E+00_JPRB, 0.893236E+00_JPRB, 0.871680E+00_JPRB, 0.850089E+00_JPRB &
  &, 0.828478E+00_JPRB, 0.806864E+00_JPRB, 0.785259E+00_JPRB &
  &, 0.763678E+00_JPRB, 0.742140E+00_JPRB, 0.720658E+00_JPRB, 0.699248E+00_JPRB &
  &, 0.677926E+00_JPRB, 0.656708E+00_JPRB, 0.635611E+00_JPRB &
  &, 0.614652E+00_JPRB, 0.593845E+00_JPRB, 0.573209E+00_JPRB, 0.552763E+00_JPRB &
  &, 0.532519E+00_JPRB, 0.512498E+00_JPRB, 0.492716E+00_JPRB &
  &, 0.473192E+00_JPRB, 0.453942E+00_JPRB, 0.434979E+00_JPRB, 0.416327E+00_JPRB &
  &, 0.398000E+00_JPRB, 0.380015E+00_JPRB, 0.362383E+00_JPRB &
  &, 0.345128E+00_JPRB, 0.328261E+00_JPRB, 0.311795E+00_JPRB, 0.295741E+00_JPRB &
  &, 0.280121E+00_JPRB, 0.264937E+00_JPRB, 0.250211E+00_JPRB &
  &, 0.235937E+00_JPRB, 0.222140E+00_JPRB, 0.208812E+00_JPRB, 0.195978E+00_JPRB &
  &, 0.183631E+00_JPRB, 0.171770E+00_JPRB, 0.160407E+00_JPRB &
  &, 0.149527E+00_JPRB, 0.139148E+00_JPRB, 0.129261E+00_JPRB, 0.119857E+00_JPRB &
  &, 0.110934E+00_JPRB, 0.102486E+00_JPRB, 0.944930E-01_JPRB &
  &, 0.869694E-01_JPRB, 0.798875E-01_JPRB, 0.732421E-01_JPRB, 0.670109E-01_JPRB &
  &, 0.611961E-01_JPRB, 0.557681E-01_JPRB, 0.507224E-01_JPRB &
  &, 0.460367E-01_JPRB, 0.417002E-01_JPRB, 0.376830E-01_JPRB, 0.340005E-01_JPRB &
  &, 0.305997E-01_JPRB, 0.274906E-01_JPRB, 0.246296E-01_JPRB &
  &, 0.220400E-01_JPRB, 0.196719E-01_JPRB, 0.175265E-01_JPRB, 0.155653E-01_JPRB &
  &, 0.138048E-01_JPRB, 0.122216E-01_JPRB, 0.107893E-01_JPRB &
  &, 0.949965E-02_JPRB, 0.834295E-02_JPRB, 0.733007E-02_JPRB, 0.640488E-02_JPRB &
  &, 0.559762E-02_JPRB, 0.487054E-02_JPRB, 0.425385E-02_JPRB &
  &, 0.368257E-02_JPRB, 0.318535E-02_JPRB, 0.274231E-02_JPRB, 0.235752E-02_JPRB &
  &, 0.203514E-02_JPRB, 0.175266E-02_JPRB, 0.148559E-02_JPRB &
  &, 0.126313E-02_JPRB, 0.108824E-02_JPRB, 0.935064E-03_JPRB, 0.775639E-03_JPRB &
  &, 0.669847E-03_JPRB, 0.559799E-03_JPRB, 0.476525E-03_JPRB &
  &, 0.389979E-03_JPRB, 0.332342E-03_JPRB, 0.272475E-03_JPRB, 0.210343E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.815494E-04_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 201, :) = (/ &
  &  0.915082E+00_JPRB, 0.893652E+00_JPRB, 0.872170E+00_JPRB, 0.850652E+00_JPRB &
  &, 0.829110E+00_JPRB, 0.807562E+00_JPRB, 0.786020E+00_JPRB &
  &, 0.764502E+00_JPRB, 0.743020E+00_JPRB, 0.721593E+00_JPRB, 0.700235E+00_JPRB &
  &, 0.678962E+00_JPRB, 0.657790E+00_JPRB, 0.636734E+00_JPRB &
  &, 0.615814E+00_JPRB, 0.595044E+00_JPRB, 0.574443E+00_JPRB, 0.554025E+00_JPRB &
  &, 0.533809E+00_JPRB, 0.513811E+00_JPRB, 0.494048E+00_JPRB &
  &, 0.474541E+00_JPRB, 0.455305E+00_JPRB, 0.436356E+00_JPRB, 0.417712E+00_JPRB &
  &, 0.399389E+00_JPRB, 0.381405E+00_JPRB, 0.363772E+00_JPRB &
  &, 0.346512E+00_JPRB, 0.329635E+00_JPRB, 0.313158E+00_JPRB, 0.297096E+00_JPRB &
  &, 0.281459E+00_JPRB, 0.266260E+00_JPRB, 0.251508E+00_JPRB &
  &, 0.237212E+00_JPRB, 0.223389E+00_JPRB, 0.210044E+00_JPRB, 0.197171E+00_JPRB &
  &, 0.184792E+00_JPRB, 0.172898E+00_JPRB, 0.161498E+00_JPRB &
  &, 0.150590E+00_JPRB, 0.140181E+00_JPRB, 0.130250E+00_JPRB, 0.120811E+00_JPRB &
  &, 0.111850E+00_JPRB, 0.103350E+00_JPRB, 0.953268E-01_JPRB &
  &, 0.877578E-01_JPRB, 0.806412E-01_JPRB, 0.739588E-01_JPRB, 0.676884E-01_JPRB &
  &, 0.618320E-01_JPRB, 0.563746E-01_JPRB, 0.512827E-01_JPRB &
  &, 0.465636E-01_JPRB, 0.421918E-01_JPRB, 0.381535E-01_JPRB, 0.344320E-01_JPRB &
  &, 0.310071E-01_JPRB, 0.278552E-01_JPRB, 0.249846E-01_JPRB &
  &, 0.223485E-01_JPRB, 0.199501E-01_JPRB, 0.177729E-01_JPRB, 0.158171E-01_JPRB &
  &, 0.140225E-01_JPRB, 0.124238E-01_JPRB, 0.109752E-01_JPRB &
  &, 0.966836E-02_JPRB, 0.849367E-02_JPRB, 0.746196E-02_JPRB, 0.653950E-02_JPRB &
  &, 0.571212E-02_JPRB, 0.498738E-02_JPRB, 0.432537E-02_JPRB &
  &, 0.375554E-02_JPRB, 0.325977E-02_JPRB, 0.281821E-02_JPRB, 0.243491E-02_JPRB &
  &, 0.208774E-02_JPRB, 0.177947E-02_JPRB, 0.154024E-02_JPRB &
  &, 0.131882E-02_JPRB, 0.111662E-02_JPRB, 0.935064E-03_JPRB, 0.805087E-03_JPRB &
  &, 0.669847E-03_JPRB, 0.559799E-03_JPRB, 0.476525E-03_JPRB &
  &, 0.389979E-03_JPRB, 0.332342E-03_JPRB, 0.272475E-03_JPRB, 0.243734E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 202, :) = (/ &
  &  0.915418E+00_JPRB, 0.894066E+00_JPRB, 0.872659E+00_JPRB, 0.851212E+00_JPRB &
  &, 0.829740E+00_JPRB, 0.808258E+00_JPRB, 0.786780E+00_JPRB &
  &, 0.765322E+00_JPRB, 0.743899E+00_JPRB, 0.722526E+00_JPRB, 0.701220E+00_JPRB &
  &, 0.679995E+00_JPRB, 0.658868E+00_JPRB, 0.637856E+00_JPRB &
  &, 0.616975E+00_JPRB, 0.596242E+00_JPRB, 0.575674E+00_JPRB, 0.555285E+00_JPRB &
  &, 0.535096E+00_JPRB, 0.515121E+00_JPRB, 0.495381E+00_JPRB &
  &, 0.475891E+00_JPRB, 0.456669E+00_JPRB, 0.437731E+00_JPRB, 0.419094E+00_JPRB &
  &, 0.400775E+00_JPRB, 0.382791E+00_JPRB, 0.365161E+00_JPRB &
  &, 0.347896E+00_JPRB, 0.331013E+00_JPRB, 0.314526E+00_JPRB, 0.298448E+00_JPRB &
  &, 0.282796E+00_JPRB, 0.267578E+00_JPRB, 0.252805E+00_JPRB &
  &, 0.238486E+00_JPRB, 0.224638E+00_JPRB, 0.211267E+00_JPRB, 0.198364E+00_JPRB &
  &, 0.185954E+00_JPRB, 0.174036E+00_JPRB, 0.162600E+00_JPRB &
  &, 0.151654E+00_JPRB, 0.141202E+00_JPRB, 0.131239E+00_JPRB, 0.121765E+00_JPRB &
  &, 0.112754E+00_JPRB, 0.104226E+00_JPRB, 0.961733E-01_JPRB &
  &, 0.885593E-01_JPRB, 0.813949E-01_JPRB, 0.746756E-01_JPRB, 0.683659E-01_JPRB &
  &, 0.624678E-01_JPRB, 0.569664E-01_JPRB, 0.518581E-01_JPRB &
  &, 0.470905E-01_JPRB, 0.426834E-01_JPRB, 0.386078E-01_JPRB, 0.348635E-01_JPRB &
  &, 0.313975E-01_JPRB, 0.282197E-01_JPRB, 0.253219E-01_JPRB &
  &, 0.226751E-01_JPRB, 0.202469E-01_JPRB, 0.180573E-01_JPRB, 0.160496E-01_JPRB &
  &, 0.142402E-01_JPRB, 0.126260E-01_JPRB, 0.111610E-01_JPRB &
  &, 0.983706E-02_JPRB, 0.864440E-02_JPRB, 0.759385E-02_JPRB, 0.665170E-02_JPRB &
  &, 0.582662E-02_JPRB, 0.508085E-02_JPRB, 0.442074E-02_JPRB &
  &, 0.382850E-02_JPRB, 0.333420E-02_JPRB, 0.286881E-02_JPRB, 0.248650E-02_JPRB &
  &, 0.214034E-02_JPRB, 0.183309E-02_JPRB, 0.156757E-02_JPRB &
  &, 0.134667E-02_JPRB, 0.114499E-02_JPRB, 0.963972E-03_JPRB, 0.834535E-03_JPRB &
  &, 0.699840E-03_JPRB, 0.590343E-03_JPRB, 0.476525E-03_JPRB &
  &, 0.421644E-03_JPRB, 0.332342E-03_JPRB, 0.272475E-03_JPRB, 0.243734E-03_JPRB &
  &, 0.179888E-03_JPRB, 0.148283E-03_JPRB, 0.115509E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.470026E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 203, :) = (/ &
  &  0.915755E+00_JPRB, 0.894479E+00_JPRB, 0.873146E+00_JPRB, 0.851772E+00_JPRB &
  &, 0.830369E+00_JPRB, 0.808953E+00_JPRB, 0.787538E+00_JPRB &
  &, 0.766141E+00_JPRB, 0.744776E+00_JPRB, 0.723457E+00_JPRB, 0.702203E+00_JPRB &
  &, 0.681026E+00_JPRB, 0.659945E+00_JPRB, 0.638977E+00_JPRB &
  &, 0.618135E+00_JPRB, 0.597437E+00_JPRB, 0.576902E+00_JPRB, 0.556545E+00_JPRB &
  &, 0.536382E+00_JPRB, 0.516431E+00_JPRB, 0.496711E+00_JPRB &
  &, 0.477240E+00_JPRB, 0.458032E+00_JPRB, 0.439105E+00_JPRB, 0.420476E+00_JPRB &
  &, 0.402161E+00_JPRB, 0.384180E+00_JPRB, 0.366547E+00_JPRB &
  &, 0.349280E+00_JPRB, 0.332388E+00_JPRB, 0.315893E+00_JPRB, 0.299803E+00_JPRB &
  &, 0.284134E+00_JPRB, 0.268901E+00_JPRB, 0.254107E+00_JPRB &
  &, 0.239770E+00_JPRB, 0.225897E+00_JPRB, 0.212489E+00_JPRB, 0.199567E+00_JPRB &
  &, 0.187125E+00_JPRB, 0.175164E+00_JPRB, 0.163702E+00_JPRB &
  &, 0.152728E+00_JPRB, 0.142235E+00_JPRB, 0.132240E+00_JPRB, 0.122719E+00_JPRB &
  &, 0.113683E+00_JPRB, 0.105115E+00_JPRB, 0.970071E-01_JPRB &
  &, 0.893609E-01_JPRB, 0.821620E-01_JPRB, 0.753923E-01_JPRB, 0.690575E-01_JPRB &
  &, 0.631181E-01_JPRB, 0.575877E-01_JPRB, 0.524184E-01_JPRB &
  &, 0.476329E-01_JPRB, 0.431908E-01_JPRB, 0.390783E-01_JPRB, 0.352950E-01_JPRB &
  &, 0.318049E-01_JPRB, 0.286017E-01_JPRB, 0.256769E-01_JPRB &
  &, 0.229836E-01_JPRB, 0.205437E-01_JPRB, 0.183227E-01_JPRB, 0.163014E-01_JPRB &
  &, 0.144777E-01_JPRB, 0.128281E-01_JPRB, 0.113469E-01_JPRB &
  &, 0.100058E-01_JPRB, 0.881666E-02_JPRB, 0.772575E-02_JPRB, 0.678632E-02_JPRB &
  &, 0.591822E-02_JPRB, 0.517433E-02_JPRB, 0.451611E-02_JPRB &
  &, 0.392579E-02_JPRB, 0.338381E-02_JPRB, 0.294471E-02_JPRB, 0.253809E-02_JPRB &
  &, 0.219294E-02_JPRB, 0.185990E-02_JPRB, 0.159489E-02_JPRB &
  &, 0.137452E-02_JPRB, 0.117337E-02_JPRB, 0.992880E-03_JPRB, 0.834535E-03_JPRB &
  &, 0.699840E-03_JPRB, 0.590343E-03_JPRB, 0.507627E-03_JPRB &
  &, 0.421644E-03_JPRB, 0.364576E-03_JPRB, 0.305284E-03_JPRB, 0.243734E-03_JPRB &
  &, 0.213866E-03_JPRB, 0.148283E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART29',1,ZHOOK_HANDLE)
END SUBROUTINE PART29

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART30

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART30',0,ZHOOK_HANDLE)

XCW( 204, :) = (/ &
  &  0.916088E+00_JPRB, 0.894890E+00_JPRB, 0.873632E+00_JPRB, 0.852330E+00_JPRB &
  &, 0.830996E+00_JPRB, 0.809646E+00_JPRB, 0.788294E+00_JPRB &
  &, 0.766958E+00_JPRB, 0.745650E+00_JPRB, 0.724387E+00_JPRB, 0.703184E+00_JPRB &
  &, 0.682057E+00_JPRB, 0.661021E+00_JPRB, 0.640094E+00_JPRB &
  &, 0.619292E+00_JPRB, 0.598631E+00_JPRB, 0.578129E+00_JPRB, 0.557802E+00_JPRB &
  &, 0.537666E+00_JPRB, 0.517742E+00_JPRB, 0.498040E+00_JPRB &
  &, 0.478586E+00_JPRB, 0.459392E+00_JPRB, 0.440476E+00_JPRB, 0.421854E+00_JPRB &
  &, 0.403547E+00_JPRB, 0.385570E+00_JPRB, 0.367936E+00_JPRB &
  &, 0.350660E+00_JPRB, 0.333766E+00_JPRB, 0.317257E+00_JPRB, 0.301159E+00_JPRB &
  &, 0.285476E+00_JPRB, 0.270224E+00_JPRB, 0.255409E+00_JPRB &
  &, 0.241053E+00_JPRB, 0.227146E+00_JPRB, 0.213721E+00_JPRB, 0.200770E+00_JPRB &
  &, 0.188297E+00_JPRB, 0.176302E+00_JPRB, 0.164804E+00_JPRB &
  &, 0.153791E+00_JPRB, 0.143268E+00_JPRB, 0.133229E+00_JPRB, 0.123673E+00_JPRB &
  &, 0.114599E+00_JPRB, 0.105991E+00_JPRB, 0.978537E-01_JPRB &
  &, 0.901624E-01_JPRB, 0.829292E-01_JPRB, 0.761228E-01_JPRB, 0.697350E-01_JPRB &
  &, 0.637684E-01_JPRB, 0.581943E-01_JPRB, 0.529938E-01_JPRB &
  &, 0.481753E-01_JPRB, 0.436983E-01_JPRB, 0.395488E-01_JPRB, 0.357265E-01_JPRB &
  &, 0.322123E-01_JPRB, 0.289836E-01_JPRB, 0.260141E-01_JPRB &
  &, 0.233103E-01_JPRB, 0.208405E-01_JPRB, 0.185881E-01_JPRB, 0.165533E-01_JPRB &
  &, 0.146955E-01_JPRB, 0.130303E-01_JPRB, 0.115327E-01_JPRB &
  &, 0.101745E-01_JPRB, 0.896738E-02_JPRB, 0.787962E-02_JPRB, 0.689851E-02_JPRB &
  &, 0.603272E-02_JPRB, 0.526780E-02_JPRB, 0.458763E-02_JPRB &
  &, 0.399875E-02_JPRB, 0.345823E-02_JPRB, 0.299530E-02_JPRB, 0.258969E-02_JPRB &
  &, 0.221925E-02_JPRB, 0.191352E-02_JPRB, 0.164954E-02_JPRB &
  &, 0.140236E-02_JPRB, 0.120174E-02_JPRB, 0.102179E-02_JPRB, 0.863982E-03_JPRB &
  &, 0.729833E-03_JPRB, 0.620888E-03_JPRB, 0.507627E-03_JPRB &
  &, 0.421644E-03_JPRB, 0.364576E-03_JPRB, 0.305284E-03_JPRB, 0.243734E-03_JPRB &
  &, 0.213866E-03_JPRB, 0.182853E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 205, :) = (/ &
  &  0.916422E+00_JPRB, 0.895301E+00_JPRB, 0.874117E+00_JPRB, 0.852886E+00_JPRB &
  &, 0.831621E+00_JPRB, 0.810338E+00_JPRB, 0.789050E+00_JPRB &
  &, 0.767773E+00_JPRB, 0.746522E+00_JPRB, 0.725314E+00_JPRB, 0.704162E+00_JPRB &
  &, 0.683084E+00_JPRB, 0.662094E+00_JPRB, 0.641210E+00_JPRB &
  &, 0.620449E+00_JPRB, 0.599823E+00_JPRB, 0.579354E+00_JPRB, 0.559058E+00_JPRB &
  &, 0.538950E+00_JPRB, 0.519045E+00_JPRB, 0.499369E+00_JPRB &
  &, 0.479933E+00_JPRB, 0.460752E+00_JPRB, 0.441847E+00_JPRB, 0.423236E+00_JPRB &
  &, 0.404933E+00_JPRB, 0.386955E+00_JPRB, 0.369321E+00_JPRB &
  &, 0.352044E+00_JPRB, 0.335141E+00_JPRB, 0.318624E+00_JPRB, 0.302514E+00_JPRB &
  &, 0.286814E+00_JPRB, 0.271547E+00_JPRB, 0.256715E+00_JPRB &
  &, 0.242327E+00_JPRB, 0.228405E+00_JPRB, 0.214953E+00_JPRB, 0.201974E+00_JPRB &
  &, 0.189469E+00_JPRB, 0.177450E+00_JPRB, 0.165917E+00_JPRB &
  &, 0.154865E+00_JPRB, 0.144301E+00_JPRB, 0.134229E+00_JPRB, 0.124639E+00_JPRB &
  &, 0.115528E+00_JPRB, 0.106880E+00_JPRB, 0.987002E-01_JPRB &
  &, 0.909771E-01_JPRB, 0.836963E-01_JPRB, 0.768534E-01_JPRB, 0.704266E-01_JPRB &
  &, 0.644187E-01_JPRB, 0.588156E-01_JPRB, 0.535843E-01_JPRB &
  &, 0.487177E-01_JPRB, 0.442057E-01_JPRB, 0.400355E-01_JPRB, 0.361747E-01_JPRB &
  &, 0.326197E-01_JPRB, 0.293655E-01_JPRB, 0.263691E-01_JPRB &
  &, 0.236369E-01_JPRB, 0.211373E-01_JPRB, 0.188725E-01_JPRB, 0.168051E-01_JPRB &
  &, 0.149330E-01_JPRB, 0.132325E-01_JPRB, 0.117186E-01_JPRB &
  &, 0.103432E-01_JPRB, 0.911811E-02_JPRB, 0.801151E-02_JPRB, 0.703314E-02_JPRB &
  &, 0.614722E-02_JPRB, 0.538464E-02_JPRB, 0.468300E-02_JPRB &
  &, 0.407172E-02_JPRB, 0.353266E-02_JPRB, 0.307120E-02_JPRB, 0.264128E-02_JPRB &
  &, 0.227185E-02_JPRB, 0.196714E-02_JPRB, 0.167687E-02_JPRB &
  &, 0.143021E-02_JPRB, 0.123012E-02_JPRB, 0.105070E-02_JPRB, 0.893430E-03_JPRB &
  &, 0.759826E-03_JPRB, 0.620888E-03_JPRB, 0.538729E-03_JPRB &
  &, 0.453309E-03_JPRB, 0.364576E-03_JPRB, 0.305284E-03_JPRB, 0.243734E-03_JPRB &
  &, 0.213866E-03_JPRB, 0.182853E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 206, :) = (/ &
  &  0.916754E+00_JPRB, 0.895710E+00_JPRB, 0.874600E+00_JPRB, 0.853441E+00_JPRB &
  &, 0.832245E+00_JPRB, 0.811027E+00_JPRB, 0.789803E+00_JPRB &
  &, 0.768587E+00_JPRB, 0.747393E+00_JPRB, 0.726239E+00_JPRB, 0.705140E+00_JPRB &
  &, 0.684110E+00_JPRB, 0.663166E+00_JPRB, 0.642325E+00_JPRB &
  &, 0.621601E+00_JPRB, 0.601014E+00_JPRB, 0.580578E+00_JPRB, 0.560311E+00_JPRB &
  &, 0.540231E+00_JPRB, 0.520352E+00_JPRB, 0.500695E+00_JPRB &
  &, 0.481275E+00_JPRB, 0.462112E+00_JPRB, 0.443218E+00_JPRB, 0.424615E+00_JPRB &
  &, 0.406319E+00_JPRB, 0.388341E+00_JPRB, 0.370706E+00_JPRB &
  &, 0.353429E+00_JPRB, 0.336519E+00_JPRB, 0.319992E+00_JPRB, 0.303870E+00_JPRB &
  &, 0.288156E+00_JPRB, 0.272869E+00_JPRB, 0.258017E+00_JPRB &
  &, 0.243611E+00_JPRB, 0.229664E+00_JPRB, 0.216185E+00_JPRB, 0.203177E+00_JPRB &
  &, 0.190641E+00_JPRB, 0.178589E+00_JPRB, 0.167019E+00_JPRB &
  &, 0.155939E+00_JPRB, 0.145346E+00_JPRB, 0.135230E+00_JPRB, 0.125604E+00_JPRB &
  &, 0.116444E+00_JPRB, 0.107769E+00_JPRB, 0.995468E-01_JPRB &
  &, 0.917786E-01_JPRB, 0.844635E-01_JPRB, 0.775839E-01_JPRB, 0.711323E-01_JPRB &
  &, 0.650835E-01_JPRB, 0.594222E-01_JPRB, 0.541598E-01_JPRB &
  &, 0.492601E-01_JPRB, 0.447132E-01_JPRB, 0.405060E-01_JPRB, 0.366228E-01_JPRB &
  &, 0.330441E-01_JPRB, 0.297474E-01_JPRB, 0.267241E-01_JPRB &
  &, 0.239635E-01_JPRB, 0.214340E-01_JPRB, 0.191379E-01_JPRB, 0.170569E-01_JPRB &
  &, 0.151705E-01_JPRB, 0.134549E-01_JPRB, 0.119044E-01_JPRB &
  &, 0.105330E-01_JPRB, 0.926883E-02_JPRB, 0.816539E-02_JPRB, 0.716777E-02_JPRB &
  &, 0.626173E-02_JPRB, 0.547811E-02_JPRB, 0.477837E-02_JPRB &
  &, 0.416900E-02_JPRB, 0.360708E-02_JPRB, 0.312180E-02_JPRB, 0.269288E-02_JPRB &
  &, 0.232445E-02_JPRB, 0.199395E-02_JPRB, 0.173152E-02_JPRB &
  &, 0.148591E-02_JPRB, 0.125849E-02_JPRB, 0.107960E-02_JPRB, 0.922878E-03_JPRB &
  &, 0.759826E-03_JPRB, 0.651432E-03_JPRB, 0.538729E-03_JPRB &
  &, 0.453309E-03_JPRB, 0.396810E-03_JPRB, 0.338094E-03_JPRB, 0.277124E-03_JPRB &
  &, 0.213866E-03_JPRB, 0.182853E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 207, :) = (/ &
  &  0.917086E+00_JPRB, 0.896119E+00_JPRB, 0.875083E+00_JPRB, 0.853995E+00_JPRB &
  &, 0.832867E+00_JPRB, 0.811716E+00_JPRB, 0.790554E+00_JPRB &
  &, 0.769398E+00_JPRB, 0.748263E+00_JPRB, 0.727163E+00_JPRB, 0.706115E+00_JPRB &
  &, 0.685134E+00_JPRB, 0.664235E+00_JPRB, 0.643437E+00_JPRB &
  &, 0.622754E+00_JPRB, 0.602202E+00_JPRB, 0.581800E+00_JPRB, 0.561564E+00_JPRB &
  &, 0.541511E+00_JPRB, 0.521656E+00_JPRB, 0.502018E+00_JPRB &
  &, 0.482618E+00_JPRB, 0.463469E+00_JPRB, 0.444588E+00_JPRB, 0.425993E+00_JPRB &
  &, 0.407701E+00_JPRB, 0.389731E+00_JPRB, 0.372095E+00_JPRB &
  &, 0.354809E+00_JPRB, 0.337893E+00_JPRB, 0.321359E+00_JPRB, 0.305225E+00_JPRB &
  &, 0.289498E+00_JPRB, 0.274192E+00_JPRB, 0.259323E+00_JPRB &
  &, 0.244895E+00_JPRB, 0.230923E+00_JPRB, 0.217417E+00_JPRB, 0.204380E+00_JPRB &
  &, 0.191823E+00_JPRB, 0.179737E+00_JPRB, 0.168131E+00_JPRB &
  &, 0.157025E+00_JPRB, 0.146390E+00_JPRB, 0.136242E+00_JPRB, 0.126570E+00_JPRB &
  &, 0.117385E+00_JPRB, 0.108658E+00_JPRB, 0.100406E+00_JPRB &
  &, 0.925933E-01_JPRB, 0.852441E-01_JPRB, 0.783282E-01_JPRB, 0.718239E-01_JPRB &
  &, 0.657338E-01_JPRB, 0.600583E-01_JPRB, 0.547503E-01_JPRB &
  &, 0.498180E-01_JPRB, 0.452365E-01_JPRB, 0.409928E-01_JPRB, 0.370709E-01_JPRB &
  &, 0.334515E-01_JPRB, 0.301293E-01_JPRB, 0.270791E-01_JPRB &
  &, 0.242902E-01_JPRB, 0.217494E-01_JPRB, 0.194222E-01_JPRB, 0.173088E-01_JPRB &
  &, 0.154080E-01_JPRB, 0.136773E-01_JPRB, 0.121109E-01_JPRB &
  &, 0.107017E-01_JPRB, 0.944109E-02_JPRB, 0.829728E-02_JPRB, 0.730240E-02_JPRB &
  &, 0.639913E-02_JPRB, 0.559495E-02_JPRB, 0.487374E-02_JPRB &
  &, 0.424197E-02_JPRB, 0.368150E-02_JPRB, 0.319770E-02_JPRB, 0.277027E-02_JPRB &
  &, 0.237705E-02_JPRB, 0.204757E-02_JPRB, 0.175885E-02_JPRB &
  &, 0.151375E-02_JPRB, 0.128687E-02_JPRB, 0.110851E-02_JPRB, 0.922878E-03_JPRB &
  &, 0.789819E-03_JPRB, 0.681977E-03_JPRB, 0.569830E-03_JPRB &
  &, 0.484974E-03_JPRB, 0.396810E-03_JPRB, 0.338094E-03_JPRB, 0.277124E-03_JPRB &
  &, 0.213866E-03_JPRB, 0.182853E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.827713E-04_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 208, :) = (/ &
  &  0.917419E+00_JPRB, 0.896527E+00_JPRB, 0.875564E+00_JPRB, 0.854548E+00_JPRB &
  &, 0.833488E+00_JPRB, 0.812402E+00_JPRB, 0.791304E+00_JPRB &
  &, 0.770208E+00_JPRB, 0.749130E+00_JPRB, 0.728085E+00_JPRB, 0.707088E+00_JPRB &
  &, 0.686155E+00_JPRB, 0.665302E+00_JPRB, 0.644547E+00_JPRB &
  &, 0.623903E+00_JPRB, 0.603388E+00_JPRB, 0.583020E+00_JPRB, 0.562814E+00_JPRB &
  &, 0.542788E+00_JPRB, 0.522957E+00_JPRB, 0.503345E+00_JPRB &
  &, 0.483961E+00_JPRB, 0.464825E+00_JPRB, 0.445956E+00_JPRB, 0.427371E+00_JPRB &
  &, 0.409083E+00_JPRB, 0.391117E+00_JPRB, 0.373481E+00_JPRB &
  &, 0.356193E+00_JPRB, 0.339272E+00_JPRB, 0.322731E+00_JPRB, 0.306581E+00_JPRB &
  &, 0.290840E+00_JPRB, 0.275519E+00_JPRB, 0.260630E+00_JPRB &
  &, 0.246187E+00_JPRB, 0.232191E+00_JPRB, 0.218659E+00_JPRB, 0.205593E+00_JPRB &
  &, 0.192995E+00_JPRB, 0.180886E+00_JPRB, 0.169255E+00_JPRB &
  &, 0.158099E+00_JPRB, 0.147434E+00_JPRB, 0.137254E+00_JPRB, 0.127548E+00_JPRB &
  &, 0.118314E+00_JPRB, 0.109560E+00_JPRB, 0.101253E+00_JPRB &
  &, 0.934211E-01_JPRB, 0.860247E-01_JPRB, 0.790587E-01_JPRB, 0.725296E-01_JPRB &
  &, 0.663985E-01_JPRB, 0.606796E-01_JPRB, 0.553409E-01_JPRB &
  &, 0.503759E-01_JPRB, 0.457598E-01_JPRB, 0.414795E-01_JPRB, 0.375190E-01_JPRB &
  &, 0.338759E-01_JPRB, 0.305286E-01_JPRB, 0.274519E-01_JPRB &
  &, 0.246350E-01_JPRB, 0.220647E-01_JPRB, 0.197066E-01_JPRB, 0.175800E-01_JPRB &
  &, 0.156455E-01_JPRB, 0.138795E-01_JPRB, 0.122968E-01_JPRB &
  &, 0.108704E-01_JPRB, 0.959182E-02_JPRB, 0.845116E-02_JPRB, 0.741459E-02_JPRB &
  &, 0.651363E-02_JPRB, 0.568842E-02_JPRB, 0.496910E-02_JPRB &
  &, 0.433926E-02_JPRB, 0.375592E-02_JPRB, 0.327359E-02_JPRB, 0.282186E-02_JPRB &
  &, 0.242965E-02_JPRB, 0.210119E-02_JPRB, 0.181350E-02_JPRB &
  &, 0.154160E-02_JPRB, 0.131524E-02_JPRB, 0.113742E-02_JPRB, 0.952325E-03_JPRB &
  &, 0.819812E-03_JPRB, 0.681977E-03_JPRB, 0.569830E-03_JPRB &
  &, 0.484974E-03_JPRB, 0.396810E-03_JPRB, 0.338094E-03_JPRB, 0.277124E-03_JPRB &
  &, 0.247843E-03_JPRB, 0.182853E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.476254E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 209, :) = (/ &
  &  0.917749E+00_JPRB, 0.896933E+00_JPRB, 0.876044E+00_JPRB, 0.855098E+00_JPRB &
  &, 0.834107E+00_JPRB, 0.813088E+00_JPRB, 0.792052E+00_JPRB &
  &, 0.771016E+00_JPRB, 0.749996E+00_JPRB, 0.729005E+00_JPRB, 0.708060E+00_JPRB &
  &, 0.687176E+00_JPRB, 0.666369E+00_JPRB, 0.645655E+00_JPRB &
  &, 0.625051E+00_JPRB, 0.604573E+00_JPRB, 0.584239E+00_JPRB, 0.564063E+00_JPRB &
  &, 0.544065E+00_JPRB, 0.524258E+00_JPRB, 0.504664E+00_JPRB &
  &, 0.485300E+00_JPRB, 0.466182E+00_JPRB, 0.447323E+00_JPRB, 0.428746E+00_JPRB &
  &, 0.410469E+00_JPRB, 0.392502E+00_JPRB, 0.374866E+00_JPRB &
  &, 0.357577E+00_JPRB, 0.340650E+00_JPRB, 0.324099E+00_JPRB, 0.307940E+00_JPRB &
  &, 0.292178E+00_JPRB, 0.276847E+00_JPRB, 0.261941E+00_JPRB &
  &, 0.247471E+00_JPRB, 0.233450E+00_JPRB, 0.219891E+00_JPRB, 0.206796E+00_JPRB &
  &, 0.194177E+00_JPRB, 0.182034E+00_JPRB, 0.170368E+00_JPRB &
  &, 0.159184E+00_JPRB, 0.148479E+00_JPRB, 0.138267E+00_JPRB, 0.128514E+00_JPRB &
  &, 0.119255E+00_JPRB, 0.110448E+00_JPRB, 0.102125E+00_JPRB &
  &, 0.942358E-01_JPRB, 0.868053E-01_JPRB, 0.798030E-01_JPRB, 0.732353E-01_JPRB &
  &, 0.670777E-01_JPRB, 0.613158E-01_JPRB, 0.559314E-01_JPRB &
  &, 0.509338E-01_JPRB, 0.462831E-01_JPRB, 0.419662E-01_JPRB, 0.379837E-01_JPRB &
  &, 0.343003E-01_JPRB, 0.309279E-01_JPRB, 0.278069E-01_JPRB &
  &, 0.249616E-01_JPRB, 0.223615E-01_JPRB, 0.199909E-01_JPRB, 0.178318E-01_JPRB &
  &, 0.158830E-01_JPRB, 0.141019E-01_JPRB, 0.125033E-01_JPRB &
  &, 0.110602E-01_JPRB, 0.976407E-02_JPRB, 0.860503E-02_JPRB, 0.754922E-02_JPRB &
  &, 0.662813E-02_JPRB, 0.580526E-02_JPRB, 0.506447E-02_JPRB &
  &, 0.441222E-02_JPRB, 0.383035E-02_JPRB, 0.332419E-02_JPRB, 0.287345E-02_JPRB &
  &, 0.248225E-02_JPRB, 0.215481E-02_JPRB, 0.184082E-02_JPRB &
  &, 0.156945E-02_JPRB, 0.134362E-02_JPRB, 0.116633E-02_JPRB, 0.981773E-03_JPRB &
  &, 0.849805E-03_JPRB, 0.712521E-03_JPRB, 0.600932E-03_JPRB &
  &, 0.516639E-03_JPRB, 0.429044E-03_JPRB, 0.338094E-03_JPRB, 0.310515E-03_JPRB &
  &, 0.247843E-03_JPRB, 0.217424E-03_JPRB, 0.150679E-03_JPRB &
  &, 0.117324E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 210, :) = (/ &
  &  0.918076E+00_JPRB, 0.897338E+00_JPRB, 0.876523E+00_JPRB, 0.855648E+00_JPRB &
  &, 0.834726E+00_JPRB, 0.813771E+00_JPRB, 0.792799E+00_JPRB &
  &, 0.771823E+00_JPRB, 0.750859E+00_JPRB, 0.729923E+00_JPRB, 0.709029E+00_JPRB &
  &, 0.688193E+00_JPRB, 0.667432E+00_JPRB, 0.646762E+00_JPRB &
  &, 0.626198E+00_JPRB, 0.605757E+00_JPRB, 0.585455E+00_JPRB, 0.565311E+00_JPRB &
  &, 0.545339E+00_JPRB, 0.525559E+00_JPRB, 0.505987E+00_JPRB &
  &, 0.486640E+00_JPRB, 0.467535E+00_JPRB, 0.448691E+00_JPRB, 0.430124E+00_JPRB &
  &, 0.411851E+00_JPRB, 0.393888E+00_JPRB, 0.376251E+00_JPRB &
  &, 0.358957E+00_JPRB, 0.342024E+00_JPRB, 0.325466E+00_JPRB, 0.309296E+00_JPRB &
  &, 0.293529E+00_JPRB, 0.278174E+00_JPRB, 0.263247E+00_JPRB &
  &, 0.248755E+00_JPRB, 0.234719E+00_JPRB, 0.221133E+00_JPRB, 0.208009E+00_JPRB &
  &, 0.195359E+00_JPRB, 0.183183E+00_JPRB, 0.171491E+00_JPRB &
  &, 0.160270E+00_JPRB, 0.149535E+00_JPRB, 0.139279E+00_JPRB, 0.129492E+00_JPRB &
  &, 0.120196E+00_JPRB, 0.111350E+00_JPRB, 0.102984E+00_JPRB &
  &, 0.950636E-01_JPRB, 0.875859E-01_JPRB, 0.805611E-01_JPRB, 0.739411E-01_JPRB &
  &, 0.677425E-01_JPRB, 0.619371E-01_JPRB, 0.565371E-01_JPRB &
  &, 0.514917E-01_JPRB, 0.468064E-01_JPRB, 0.424530E-01_JPRB, 0.384484E-01_JPRB &
  &, 0.347417E-01_JPRB, 0.313272E-01_JPRB, 0.281797E-01_JPRB &
  &, 0.253064E-01_JPRB, 0.226768E-01_JPRB, 0.202753E-01_JPRB, 0.181030E-01_JPRB &
  &, 0.161205E-01_JPRB, 0.143243E-01_JPRB, 0.127098E-01_JPRB &
  &, 0.112500E-01_JPRB, 0.993633E-02_JPRB, 0.875891E-02_JPRB, 0.770629E-02_JPRB &
  &, 0.674263E-02_JPRB, 0.592210E-02_JPRB, 0.515984E-02_JPRB &
  &, 0.450951E-02_JPRB, 0.392958E-02_JPRB, 0.340009E-02_JPRB, 0.295084E-02_JPRB &
  &, 0.253485E-02_JPRB, 0.218162E-02_JPRB, 0.189548E-02_JPRB &
  &, 0.162514E-02_JPRB, 0.140036E-02_JPRB, 0.119524E-02_JPRB, 0.101122E-02_JPRB &
  &, 0.849805E-03_JPRB, 0.712521E-03_JPRB, 0.600932E-03_JPRB &
  &, 0.516639E-03_JPRB, 0.429044E-03_JPRB, 0.370903E-03_JPRB, 0.310515E-03_JPRB &
  &, 0.247843E-03_JPRB, 0.217424E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART30',1,ZHOOK_HANDLE)
END SUBROUTINE PART30

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART31

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART31',0,ZHOOK_HANDLE)

XCW( 211, :) = (/ &
  &  0.918405E+00_JPRB, 0.897743E+00_JPRB, 0.877001E+00_JPRB, 0.856197E+00_JPRB &
  &, 0.835343E+00_JPRB, 0.814453E+00_JPRB, 0.793543E+00_JPRB &
  &, 0.772628E+00_JPRB, 0.751721E+00_JPRB, 0.730839E+00_JPRB, 0.709997E+00_JPRB &
  &, 0.689210E+00_JPRB, 0.668495E+00_JPRB, 0.647867E+00_JPRB &
  &, 0.627342E+00_JPRB, 0.606939E+00_JPRB, 0.586671E+00_JPRB, 0.566557E+00_JPRB &
  &, 0.546613E+00_JPRB, 0.526856E+00_JPRB, 0.507307E+00_JPRB &
  &, 0.487976E+00_JPRB, 0.468888E+00_JPRB, 0.450058E+00_JPRB, 0.431499E+00_JPRB &
  &, 0.413230E+00_JPRB, 0.395270E+00_JPRB, 0.377637E+00_JPRB &
  &, 0.360342E+00_JPRB, 0.343403E+00_JPRB, 0.326838E+00_JPRB, 0.310655E+00_JPRB &
  &, 0.294875E+00_JPRB, 0.279506E+00_JPRB, 0.264558E+00_JPRB &
  &, 0.250047E+00_JPRB, 0.235987E+00_JPRB, 0.222374E+00_JPRB, 0.209222E+00_JPRB &
  &, 0.196551E+00_JPRB, 0.184342E+00_JPRB, 0.172604E+00_JPRB &
  &, 0.161355E+00_JPRB, 0.150590E+00_JPRB, 0.140291E+00_JPRB, 0.130481E+00_JPRB &
  &, 0.121136E+00_JPRB, 0.112264E+00_JPRB, 0.103844E+00_JPRB &
  &, 0.958914E-01_JPRB, 0.883799E-01_JPRB, 0.813055E-01_JPRB, 0.746609E-01_JPRB &
  &, 0.684217E-01_JPRB, 0.625880E-01_JPRB, 0.571277E-01_JPRB &
  &, 0.520496E-01_JPRB, 0.473297E-01_JPRB, 0.429559E-01_JPRB, 0.389131E-01_JPRB &
  &, 0.351660E-01_JPRB, 0.317264E-01_JPRB, 0.285524E-01_JPRB &
  &, 0.256512E-01_JPRB, 0.229922E-01_JPRB, 0.205786E-01_JPRB, 0.183742E-01_JPRB &
  &, 0.163580E-01_JPRB, 0.145467E-01_JPRB, 0.129163E-01_JPRB &
  &, 0.114398E-01_JPRB, 0.101086E-01_JPRB, 0.891278E-02_JPRB, 0.784092E-02_JPRB &
  &, 0.688003E-02_JPRB, 0.601557E-02_JPRB, 0.525521E-02_JPRB &
  &, 0.458247E-02_JPRB, 0.400400E-02_JPRB, 0.347599E-02_JPRB, 0.300244E-02_JPRB &
  &, 0.258745E-02_JPRB, 0.223524E-02_JPRB, 0.192280E-02_JPRB &
  &, 0.165299E-02_JPRB, 0.142874E-02_JPRB, 0.122415E-02_JPRB, 0.104067E-02_JPRB &
  &, 0.879798E-03_JPRB, 0.743065E-03_JPRB, 0.632034E-03_JPRB &
  &, 0.516639E-03_JPRB, 0.461279E-03_JPRB, 0.370903E-03_JPRB, 0.310515E-03_JPRB &
  &, 0.247843E-03_JPRB, 0.217424E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 212, :) = (/ &
  &  0.918733E+00_JPRB, 0.898146E+00_JPRB, 0.877477E+00_JPRB, 0.856744E+00_JPRB &
  &, 0.835958E+00_JPRB, 0.815134E+00_JPRB, 0.794286E+00_JPRB &
  &, 0.773431E+00_JPRB, 0.752582E+00_JPRB, 0.731753E+00_JPRB, 0.710963E+00_JPRB &
  &, 0.690224E+00_JPRB, 0.669555E+00_JPRB, 0.648969E+00_JPRB &
  &, 0.628485E+00_JPRB, 0.608118E+00_JPRB, 0.587884E+00_JPRB, 0.567801E+00_JPRB &
  &, 0.547883E+00_JPRB, 0.528154E+00_JPRB, 0.508623E+00_JPRB &
  &, 0.489315E+00_JPRB, 0.470241E+00_JPRB, 0.451422E+00_JPRB, 0.432874E+00_JPRB &
  &, 0.414612E+00_JPRB, 0.396656E+00_JPRB, 0.379022E+00_JPRB &
  &, 0.361726E+00_JPRB, 0.344781E+00_JPRB, 0.328205E+00_JPRB, 0.312015E+00_JPRB &
  &, 0.296221E+00_JPRB, 0.280833E+00_JPRB, 0.265873E+00_JPRB &
  &, 0.251340E+00_JPRB, 0.237255E+00_JPRB, 0.223616E+00_JPRB, 0.210445E+00_JPRB &
  &, 0.197733E+00_JPRB, 0.185501E+00_JPRB, 0.173738E+00_JPRB &
  &, 0.162451E+00_JPRB, 0.151646E+00_JPRB, 0.141315E+00_JPRB, 0.131459E+00_JPRB &
  &, 0.122077E+00_JPRB, 0.113165E+00_JPRB, 0.104716E+00_JPRB &
  &, 0.967192E-01_JPRB, 0.891740E-01_JPRB, 0.820636E-01_JPRB, 0.753666E-01_JPRB &
  &, 0.691009E-01_JPRB, 0.632242E-01_JPRB, 0.577334E-01_JPRB &
  &, 0.526230E-01_JPRB, 0.478689E-01_JPRB, 0.434589E-01_JPRB, 0.393779E-01_JPRB &
  &, 0.356074E-01_JPRB, 0.321257E-01_JPRB, 0.289252E-01_JPRB &
  &, 0.259960E-01_JPRB, 0.233260E-01_JPRB, 0.208630E-01_JPRB, 0.186454E-01_JPRB &
  &, 0.166152E-01_JPRB, 0.147691E-01_JPRB, 0.131228E-01_JPRB &
  &, 0.116085E-01_JPRB, 0.102593E-01_JPRB, 0.906666E-02_JPRB, 0.797555E-02_JPRB &
  &, 0.699453E-02_JPRB, 0.613241E-02_JPRB, 0.537442E-02_JPRB &
  &, 0.467976E-02_JPRB, 0.407842E-02_JPRB, 0.355189E-02_JPRB, 0.307983E-02_JPRB &
  &, 0.266635E-02_JPRB, 0.228886E-02_JPRB, 0.197745E-02_JPRB &
  &, 0.170868E-02_JPRB, 0.145711E-02_JPRB, 0.125305E-02_JPRB, 0.107012E-02_JPRB &
  &, 0.909791E-03_JPRB, 0.773610E-03_JPRB, 0.663136E-03_JPRB &
  &, 0.548304E-03_JPRB, 0.461279E-03_JPRB, 0.370903E-03_JPRB, 0.310515E-03_JPRB &
  &, 0.281821E-03_JPRB, 0.217424E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 213, :) = (/ &
  &  0.919060E+00_JPRB, 0.898548E+00_JPRB, 0.877953E+00_JPRB, 0.857290E+00_JPRB &
  &, 0.836572E+00_JPRB, 0.815813E+00_JPRB, 0.795028E+00_JPRB &
  &, 0.774232E+00_JPRB, 0.753440E+00_JPRB, 0.732667E+00_JPRB, 0.711928E+00_JPRB &
  &, 0.691238E+00_JPRB, 0.670614E+00_JPRB, 0.650071E+00_JPRB &
  &, 0.629626E+00_JPRB, 0.609295E+00_JPRB, 0.589095E+00_JPRB, 0.569043E+00_JPRB &
  &, 0.549156E+00_JPRB, 0.529448E+00_JPRB, 0.509940E+00_JPRB &
  &, 0.490651E+00_JPRB, 0.471591E+00_JPRB, 0.452786E+00_JPRB, 0.434245E+00_JPRB &
  &, 0.415994E+00_JPRB, 0.398042E+00_JPRB, 0.380407E+00_JPRB &
  &, 0.363106E+00_JPRB, 0.346160E+00_JPRB, 0.329577E+00_JPRB, 0.313375E+00_JPRB &
  &, 0.297568E+00_JPRB, 0.282165E+00_JPRB, 0.267184E+00_JPRB &
  &, 0.252633E+00_JPRB, 0.238524E+00_JPRB, 0.224858E+00_JPRB, 0.211658E+00_JPRB &
  &, 0.198926E+00_JPRB, 0.186661E+00_JPRB, 0.174862E+00_JPRB &
  &, 0.163548E+00_JPRB, 0.152702E+00_JPRB, 0.142339E+00_JPRB, 0.132449E+00_JPRB &
  &, 0.123030E+00_JPRB, 0.114079E+00_JPRB, 0.105588E+00_JPRB &
  &, 0.975601E-01_JPRB, 0.899681E-01_JPRB, 0.828216E-01_JPRB, 0.760864E-01_JPRB &
  &, 0.697801E-01_JPRB, 0.638603E-01_JPRB, 0.583391E-01_JPRB &
  &, 0.531964E-01_JPRB, 0.484080E-01_JPRB, 0.439618E-01_JPRB, 0.398426E-01_JPRB &
  &, 0.360318E-01_JPRB, 0.325250E-01_JPRB, 0.293157E-01_JPRB &
  &, 0.263408E-01_JPRB, 0.236414E-01_JPRB, 0.211663E-01_JPRB, 0.189166E-01_JPRB &
  &, 0.168725E-01_JPRB, 0.150117E-01_JPRB, 0.133293E-01_JPRB &
  &, 0.118193E-01_JPRB, 0.104531E-01_JPRB, 0.922053E-02_JPRB, 0.811018E-02_JPRB &
  &, 0.713193E-02_JPRB, 0.624925E-02_JPRB, 0.546978E-02_JPRB &
  &, 0.477705E-02_JPRB, 0.415284E-02_JPRB, 0.362778E-02_JPRB, 0.313142E-02_JPRB &
  &, 0.271896E-02_JPRB, 0.234248E-02_JPRB, 0.203211E-02_JPRB &
  &, 0.173653E-02_JPRB, 0.148549E-02_JPRB, 0.128196E-02_JPRB, 0.109956E-02_JPRB &
  &, 0.939784E-03_JPRB, 0.773610E-03_JPRB, 0.663136E-03_JPRB &
  &, 0.548304E-03_JPRB, 0.461279E-03_JPRB, 0.403712E-03_JPRB, 0.343905E-03_JPRB &
  &, 0.281821E-03_JPRB, 0.217424E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.840051E-04_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 214, :) = (/ &
  &  0.919386E+00_JPRB, 0.898950E+00_JPRB, 0.878427E+00_JPRB, 0.857835E+00_JPRB &
  &, 0.837184E+00_JPRB, 0.816490E+00_JPRB, 0.795768E+00_JPRB &
  &, 0.775031E+00_JPRB, 0.754297E+00_JPRB, 0.733577E+00_JPRB, 0.712890E+00_JPRB &
  &, 0.692249E+00_JPRB, 0.671670E+00_JPRB, 0.651170E+00_JPRB &
  &, 0.630765E+00_JPRB, 0.610472E+00_JPRB, 0.590307E+00_JPRB, 0.570285E+00_JPRB &
  &, 0.550425E+00_JPRB, 0.530742E+00_JPRB, 0.511256E+00_JPRB &
  &, 0.491984E+00_JPRB, 0.472944E+00_JPRB, 0.454150E+00_JPRB, 0.435620E+00_JPRB &
  &, 0.417373E+00_JPRB, 0.399424E+00_JPRB, 0.381792E+00_JPRB &
  &, 0.364490E+00_JPRB, 0.347538E+00_JPRB, 0.330949E+00_JPRB, 0.314735E+00_JPRB &
  &, 0.298914E+00_JPRB, 0.283496E+00_JPRB, 0.268499E+00_JPRB &
  &, 0.253926E+00_JPRB, 0.239792E+00_JPRB, 0.226110E+00_JPRB, 0.212881E+00_JPRB &
  &, 0.200118E+00_JPRB, 0.187820E+00_JPRB, 0.175996E+00_JPRB &
  &, 0.164644E+00_JPRB, 0.153769E+00_JPRB, 0.143363E+00_JPRB, 0.133438E+00_JPRB &
  &, 0.123983E+00_JPRB, 0.114993E+00_JPRB, 0.106473E+00_JPRB &
  &, 0.984011E-01_JPRB, 0.907756E-01_JPRB, 0.835797E-01_JPRB, 0.768204E-01_JPRB &
  &, 0.704593E-01_JPRB, 0.645112E-01_JPRB, 0.589599E-01_JPRB &
  &, 0.537698E-01_JPRB, 0.489472E-01_JPRB, 0.444648E-01_JPRB, 0.403073E-01_JPRB &
  &, 0.364731E-01_JPRB, 0.329416E-01_JPRB, 0.296884E-01_JPRB &
  &, 0.267037E-01_JPRB, 0.239753E-01_JPRB, 0.214696E-01_JPRB, 0.191878E-01_JPRB &
  &, 0.171100E-01_JPRB, 0.152341E-01_JPRB, 0.135358E-01_JPRB &
  &, 0.120091E-01_JPRB, 0.106254E-01_JPRB, 0.937441E-02_JPRB, 0.826724E-02_JPRB &
  &, 0.726933E-02_JPRB, 0.636609E-02_JPRB, 0.556515E-02_JPRB &
  &, 0.487433E-02_JPRB, 0.425207E-02_JPRB, 0.367838E-02_JPRB, 0.320881E-02_JPRB &
  &, 0.277156E-02_JPRB, 0.239610E-02_JPRB, 0.205943E-02_JPRB &
  &, 0.176438E-02_JPRB, 0.151386E-02_JPRB, 0.131087E-02_JPRB, 0.112901E-02_JPRB &
  &, 0.939784E-03_JPRB, 0.804154E-03_JPRB, 0.694237E-03_JPRB &
  &, 0.579969E-03_JPRB, 0.493513E-03_JPRB, 0.403712E-03_JPRB, 0.343905E-03_JPRB &
  &, 0.281821E-03_JPRB, 0.251995E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.482543E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 215, :) = (/ &
  &  0.919712E+00_JPRB, 0.899349E+00_JPRB, 0.878900E+00_JPRB, 0.858378E+00_JPRB &
  &, 0.837795E+00_JPRB, 0.817166E+00_JPRB, 0.796507E+00_JPRB &
  &, 0.775830E+00_JPRB, 0.755152E+00_JPRB, 0.734487E+00_JPRB, 0.713850E+00_JPRB &
  &, 0.693258E+00_JPRB, 0.672725E+00_JPRB, 0.652268E+00_JPRB &
  &, 0.631904E+00_JPRB, 0.611646E+00_JPRB, 0.591515E+00_JPRB, 0.571525E+00_JPRB &
  &, 0.551693E+00_JPRB, 0.532037E+00_JPRB, 0.512573E+00_JPRB &
  &, 0.493317E+00_JPRB, 0.474294E+00_JPRB, 0.455510E+00_JPRB, 0.436991E+00_JPRB &
  &, 0.418751E+00_JPRB, 0.400806E+00_JPRB, 0.383178E+00_JPRB &
  &, 0.365874E+00_JPRB, 0.348916E+00_JPRB, 0.332312E+00_JPRB, 0.316094E+00_JPRB &
  &, 0.300261E+00_JPRB, 0.284832E+00_JPRB, 0.269815E+00_JPRB &
  &, 0.255219E+00_JPRB, 0.241070E+00_JPRB, 0.227361E+00_JPRB, 0.214104E+00_JPRB &
  &, 0.201310E+00_JPRB, 0.188979E+00_JPRB, 0.177120E+00_JPRB &
  &, 0.165740E+00_JPRB, 0.154836E+00_JPRB, 0.144398E+00_JPRB, 0.134428E+00_JPRB &
  &, 0.124936E+00_JPRB, 0.115920E+00_JPRB, 0.107358E+00_JPRB &
  &, 0.992420E-01_JPRB, 0.915697E-01_JPRB, 0.843516E-01_JPRB, 0.775402E-01_JPRB &
  &, 0.711530E-01_JPRB, 0.651622E-01_JPRB, 0.595657E-01_JPRB &
  &, 0.543432E-01_JPRB, 0.494864E-01_JPRB, 0.449677E-01_JPRB, 0.407886E-01_JPRB &
  &, 0.369315E-01_JPRB, 0.333583E-01_JPRB, 0.300789E-01_JPRB &
  &, 0.270666E-01_JPRB, 0.242906E-01_JPRB, 0.217729E-01_JPRB, 0.194784E-01_JPRB &
  &, 0.173673E-01_JPRB, 0.154767E-01_JPRB, 0.137423E-01_JPRB &
  &, 0.121989E-01_JPRB, 0.107976E-01_JPRB, 0.952829E-02_JPRB, 0.840187E-02_JPRB &
  &, 0.738383E-02_JPRB, 0.648293E-02_JPRB, 0.568436E-02_JPRB &
  &, 0.497162E-02_JPRB, 0.432650E-02_JPRB, 0.375428E-02_JPRB, 0.326041E-02_JPRB &
  &, 0.282416E-02_JPRB, 0.244972E-02_JPRB, 0.211408E-02_JPRB &
  &, 0.182007E-02_JPRB, 0.157061E-02_JPRB, 0.133978E-02_JPRB, 0.112901E-02_JPRB &
  &, 0.969778E-03_JPRB, 0.834698E-03_JPRB, 0.694237E-03_JPRB &
  &, 0.579969E-03_JPRB, 0.493513E-03_JPRB, 0.403712E-03_JPRB, 0.343905E-03_JPRB &
  &, 0.281821E-03_JPRB, 0.251995E-03_JPRB, 0.185849E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.119157E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 216, :) = (/ &
  &  0.920036E+00_JPRB, 0.899750E+00_JPRB, 0.879373E+00_JPRB, 0.858920E+00_JPRB &
  &, 0.838404E+00_JPRB, 0.817841E+00_JPRB, 0.797241E+00_JPRB &
  &, 0.776627E+00_JPRB, 0.756004E+00_JPRB, 0.735394E+00_JPRB, 0.714809E+00_JPRB &
  &, 0.694266E+00_JPRB, 0.673779E+00_JPRB, 0.653364E+00_JPRB &
  &, 0.633039E+00_JPRB, 0.612819E+00_JPRB, 0.592722E+00_JPRB, 0.572762E+00_JPRB &
  &, 0.552959E+00_JPRB, 0.533328E+00_JPRB, 0.513886E+00_JPRB &
  &, 0.494650E+00_JPRB, 0.475641E+00_JPRB, 0.456874E+00_JPRB, 0.438362E+00_JPRB &
  &, 0.420130E+00_JPRB, 0.402192E+00_JPRB, 0.384559E+00_JPRB &
  &, 0.367258E+00_JPRB, 0.350295E+00_JPRB, 0.333688E+00_JPRB, 0.317458E+00_JPRB &
  &, 0.301611E+00_JPRB, 0.286164E+00_JPRB, 0.271130E+00_JPRB &
  &, 0.256521E+00_JPRB, 0.242338E+00_JPRB, 0.228613E+00_JPRB, 0.215327E+00_JPRB &
  &, 0.202503E+00_JPRB, 0.190149E+00_JPRB, 0.178254E+00_JPRB &
  &, 0.166837E+00_JPRB, 0.155903E+00_JPRB, 0.145434E+00_JPRB, 0.135430E+00_JPRB &
  &, 0.125902E+00_JPRB, 0.116834E+00_JPRB, 0.108231E+00_JPRB &
  &, 0.100083E+00_JPRB, 0.923772E-01_JPRB, 0.851097E-01_JPRB, 0.782742E-01_JPRB &
  &, 0.718466E-01_JPRB, 0.658279E-01_JPRB, 0.601865E-01_JPRB &
  &, 0.549321E-01_JPRB, 0.500414E-01_JPRB, 0.454869E-01_JPRB, 0.412699E-01_JPRB &
  &, 0.373728E-01_JPRB, 0.337749E-01_JPRB, 0.303984E-01_JPRB &
  &, 0.274114E-01_JPRB, 0.246245E-01_JPRB, 0.220762E-01_JPRB, 0.197496E-01_JPRB &
  &, 0.176246E-01_JPRB, 0.157193E-01_JPRB, 0.139694E-01_JPRB &
  &, 0.123887E-01_JPRB, 0.109699E-01_JPRB, 0.970414E-02_JPRB, 0.855894E-02_JPRB &
  &, 0.752123E-02_JPRB, 0.659977E-02_JPRB, 0.577973E-02_JPRB &
  &, 0.506891E-02_JPRB, 0.442572E-02_JPRB, 0.385548E-02_JPRB, 0.333780E-02_JPRB &
  &, 0.290306E-02_JPRB, 0.250334E-02_JPRB, 0.216873E-02_JPRB &
  &, 0.184792E-02_JPRB, 0.159899E-02_JPRB, 0.136869E-02_JPRB, 0.115846E-02_JPRB &
  &, 0.999771E-03_JPRB, 0.834698E-03_JPRB, 0.725339E-03_JPRB &
  &, 0.611634E-03_JPRB, 0.525747E-03_JPRB, 0.436522E-03_JPRB, 0.377296E-03_JPRB &
  &, 0.315799E-03_JPRB, 0.251995E-03_JPRB, 0.221018E-03_JPRB &
  &, 0.153099E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 217, :) = (/ &
  &  0.920359E+00_JPRB, 0.900148E+00_JPRB, 0.879843E+00_JPRB, 0.859461E+00_JPRB &
  &, 0.839013E+00_JPRB, 0.818514E+00_JPRB, 0.797979E+00_JPRB &
  &, 0.777421E+00_JPRB, 0.756857E+00_JPRB, 0.736300E+00_JPRB, 0.715767E+00_JPRB &
  &, 0.695272E+00_JPRB, 0.674830E+00_JPRB, 0.654459E+00_JPRB &
  &, 0.634174E+00_JPRB, 0.613991E+00_JPRB, 0.593928E+00_JPRB, 0.573999E+00_JPRB &
  &, 0.554224E+00_JPRB, 0.534616E+00_JPRB, 0.515199E+00_JPRB &
  &, 0.495983E+00_JPRB, 0.476991E+00_JPRB, 0.458234E+00_JPRB, 0.439734E+00_JPRB &
  &, 0.421508E+00_JPRB, 0.403574E+00_JPRB, 0.385944E+00_JPRB &
  &, 0.368639E+00_JPRB, 0.351673E+00_JPRB, 0.335060E+00_JPRB, 0.318818E+00_JPRB &
  &, 0.302962E+00_JPRB, 0.287500E+00_JPRB, 0.272450E+00_JPRB &
  &, 0.257814E+00_JPRB, 0.243616E+00_JPRB, 0.229865E+00_JPRB, 0.216551E+00_JPRB &
  &, 0.203705E+00_JPRB, 0.191319E+00_JPRB, 0.179399E+00_JPRB &
  &, 0.167944E+00_JPRB, 0.156970E+00_JPRB, 0.146469E+00_JPRB, 0.136431E+00_JPRB &
  &, 0.126867E+00_JPRB, 0.117760E+00_JPRB, 0.109129E+00_JPRB &
  &, 0.100937E+00_JPRB, 0.931982E-01_JPRB, 0.858954E-01_JPRB, 0.790081E-01_JPRB &
  &, 0.725403E-01_JPRB, 0.664788E-01_JPRB, 0.608073E-01_JPRB &
  &, 0.555210E-01_JPRB, 0.505805E-01_JPRB, 0.460061E-01_JPRB, 0.417512E-01_JPRB &
  &, 0.378312E-01_JPRB, 0.341915E-01_JPRB, 0.308599E-01_JPRB &
  &, 0.277743E-01_JPRB, 0.249583E-01_JPRB, 0.223796E-01_JPRB, 0.200401E-01_JPRB &
  &, 0.179017E-01_JPRB, 0.159417E-01_JPRB, 0.141759E-01_JPRB &
  &, 0.125996E-01_JPRB, 0.111637E-01_JPRB, 0.985802E-02_JPRB, 0.869357E-02_JPRB &
  &, 0.765863E-02_JPRB, 0.671661E-02_JPRB, 0.589894E-02_JPRB &
  &, 0.516619E-02_JPRB, 0.450015E-02_JPRB, 0.393137E-02_JPRB, 0.341519E-02_JPRB &
  &, 0.295566E-02_JPRB, 0.255696E-02_JPRB, 0.219606E-02_JPRB &
  &, 0.190362E-02_JPRB, 0.162736E-02_JPRB, 0.139760E-02_JPRB, 0.118791E-02_JPRB &
  &, 0.102976E-02_JPRB, 0.865243E-03_JPRB, 0.725339E-03_JPRB &
  &, 0.611634E-03_JPRB, 0.525747E-03_JPRB, 0.436522E-03_JPRB, 0.377296E-03_JPRB &
  &, 0.315799E-03_JPRB, 0.251995E-03_JPRB, 0.221018E-03_JPRB &
  &, 0.188874E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART31',1,ZHOOK_HANDLE)
END SUBROUTINE PART31

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART32

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART32',0,ZHOOK_HANDLE)

XCW( 218, :) = (/ &
  &  0.920681E+00_JPRB, 0.900545E+00_JPRB, 0.880313E+00_JPRB, 0.860001E+00_JPRB &
  &, 0.839620E+00_JPRB, 0.819186E+00_JPRB, 0.798713E+00_JPRB &
  &, 0.778215E+00_JPRB, 0.757707E+00_JPRB, 0.737205E+00_JPRB, 0.716722E+00_JPRB &
  &, 0.696275E+00_JPRB, 0.675880E+00_JPRB, 0.655552E+00_JPRB &
  &, 0.635307E+00_JPRB, 0.615162E+00_JPRB, 0.595132E+00_JPRB, 0.575235E+00_JPRB &
  &, 0.555486E+00_JPRB, 0.535907E+00_JPRB, 0.516509E+00_JPRB &
  &, 0.497312E+00_JPRB, 0.478337E+00_JPRB, 0.459595E+00_JPRB, 0.441105E+00_JPRB &
  &, 0.422887E+00_JPRB, 0.404956E+00_JPRB, 0.387330E+00_JPRB &
  &, 0.370023E+00_JPRB, 0.353051E+00_JPRB, 0.336435E+00_JPRB, 0.320182E+00_JPRB &
  &, 0.304313E+00_JPRB, 0.288836E+00_JPRB, 0.273766E+00_JPRB &
  &, 0.259116E+00_JPRB, 0.244894E+00_JPRB, 0.231116E+00_JPRB, 0.217784E+00_JPRB &
  &, 0.204908E+00_JPRB, 0.192488E+00_JPRB, 0.180534E+00_JPRB &
  &, 0.169052E+00_JPRB, 0.158048E+00_JPRB, 0.147505E+00_JPRB, 0.137433E+00_JPRB &
  &, 0.127832E+00_JPRB, 0.118699E+00_JPRB, 0.110014E+00_JPRB &
  &, 0.101791E+00_JPRB, 0.940057E-01_JPRB, 0.866673E-01_JPRB, 0.797421E-01_JPRB &
  &, 0.732484E-01_JPRB, 0.671446E-01_JPRB, 0.614433E-01_JPRB &
  &, 0.561099E-01_JPRB, 0.511356E-01_JPRB, 0.465253E-01_JPRB, 0.422491E-01_JPRB &
  &, 0.382725E-01_JPRB, 0.346255E-01_JPRB, 0.312504E-01_JPRB &
  &, 0.281373E-01_JPRB, 0.252922E-01_JPRB, 0.227018E-01_JPRB, 0.203307E-01_JPRB &
  &, 0.181590E-01_JPRB, 0.161843E-01_JPRB, 0.144031E-01_JPRB &
  &, 0.127894E-01_JPRB, 0.113359E-01_JPRB, 0.100339E-01_JPRB, 0.885063E-02_JPRB &
  &, 0.779603E-02_JPRB, 0.685682E-02_JPRB, 0.599430E-02_JPRB &
  &, 0.526348E-02_JPRB, 0.459938E-02_JPRB, 0.400727E-02_JPRB, 0.346678E-02_JPRB &
  &, 0.300826E-02_JPRB, 0.261059E-02_JPRB, 0.225071E-02_JPRB &
  &, 0.195931E-02_JPRB, 0.168411E-02_JPRB, 0.142650E-02_JPRB, 0.121735E-02_JPRB &
  &, 0.105976E-02_JPRB, 0.895787E-03_JPRB, 0.756441E-03_JPRB &
  &, 0.643299E-03_JPRB, 0.557981E-03_JPRB, 0.469331E-03_JPRB, 0.377296E-03_JPRB &
  &, 0.315799E-03_JPRB, 0.251995E-03_JPRB, 0.221018E-03_JPRB &
  &, 0.188874E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 219, :) = (/ &
  &  0.921004E+00_JPRB, 0.900941E+00_JPRB, 0.880782E+00_JPRB, 0.860539E+00_JPRB &
  &, 0.840225E+00_JPRB, 0.819856E+00_JPRB, 0.799445E+00_JPRB &
  &, 0.779006E+00_JPRB, 0.758556E+00_JPRB, 0.738107E+00_JPRB, 0.717676E+00_JPRB &
  &, 0.697277E+00_JPRB, 0.676928E+00_JPRB, 0.656642E+00_JPRB &
  &, 0.636438E+00_JPRB, 0.616329E+00_JPRB, 0.596334E+00_JPRB, 0.576468E+00_JPRB &
  &, 0.556749E+00_JPRB, 0.537192E+00_JPRB, 0.517819E+00_JPRB &
  &, 0.498642E+00_JPRB, 0.479683E+00_JPRB, 0.460955E+00_JPRB, 0.442476E+00_JPRB &
  &, 0.424265E+00_JPRB, 0.406338E+00_JPRB, 0.388715E+00_JPRB &
  &, 0.371407E+00_JPRB, 0.354430E+00_JPRB, 0.337807E+00_JPRB, 0.321546E+00_JPRB &
  &, 0.305663E+00_JPRB, 0.290172E+00_JPRB, 0.275086E+00_JPRB &
  &, 0.260418E+00_JPRB, 0.246172E+00_JPRB, 0.232368E+00_JPRB, 0.219017E+00_JPRB &
  &, 0.206110E+00_JPRB, 0.193658E+00_JPRB, 0.181679E+00_JPRB &
  &, 0.170170E+00_JPRB, 0.159115E+00_JPRB, 0.148540E+00_JPRB, 0.138435E+00_JPRB &
  &, 0.128798E+00_JPRB, 0.119626E+00_JPRB, 0.110911E+00_JPRB &
  &, 0.102645E+00_JPRB, 0.948267E-01_JPRB, 0.874391E-01_JPRB, 0.804901E-01_JPRB &
  &, 0.739420E-01_JPRB, 0.678103E-01_JPRB, 0.620642E-01_JPRB &
  &, 0.566988E-01_JPRB, 0.517064E-01_JPRB, 0.470445E-01_JPRB, 0.427304E-01_JPRB &
  &, 0.387309E-01_JPRB, 0.350422E-01_JPRB, 0.316410E-01_JPRB &
  &, 0.285183E-01_JPRB, 0.256447E-01_JPRB, 0.230051E-01_JPRB, 0.206019E-01_JPRB &
  &, 0.184163E-01_JPRB, 0.164269E-01_JPRB, 0.146302E-01_JPRB &
  &, 0.130003E-01_JPRB, 0.115297E-01_JPRB, 0.101878E-01_JPRB, 0.900770E-02_JPRB &
  &, 0.793343E-02_JPRB, 0.697366E-02_JPRB, 0.611351E-02_JPRB &
  &, 0.536077E-02_JPRB, 0.467380E-02_JPRB, 0.408317E-02_JPRB, 0.354417E-02_JPRB &
  &, 0.308716E-02_JPRB, 0.266421E-02_JPRB, 0.230536E-02_JPRB &
  &, 0.198716E-02_JPRB, 0.171249E-02_JPRB, 0.145541E-02_JPRB, 0.124680E-02_JPRB &
  &, 0.108975E-02_JPRB, 0.926332E-03_JPRB, 0.787542E-03_JPRB &
  &, 0.674964E-03_JPRB, 0.557981E-03_JPRB, 0.469331E-03_JPRB, 0.410686E-03_JPRB &
  &, 0.315799E-03_JPRB, 0.286565E-03_JPRB, 0.221018E-03_JPRB &
  &, 0.188874E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.852508E-04_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 220, :) = (/ &
  &  0.921324E+00_JPRB, 0.901338E+00_JPRB, 0.881250E+00_JPRB, 0.861077E+00_JPRB &
  &, 0.840830E+00_JPRB, 0.820525E+00_JPRB, 0.800176E+00_JPRB &
  &, 0.779797E+00_JPRB, 0.759403E+00_JPRB, 0.739008E+00_JPRB, 0.718628E+00_JPRB &
  &, 0.698278E+00_JPRB, 0.677975E+00_JPRB, 0.657732E+00_JPRB &
  &, 0.637567E+00_JPRB, 0.617496E+00_JPRB, 0.597535E+00_JPRB, 0.577700E+00_JPRB &
  &, 0.558010E+00_JPRB, 0.538480E+00_JPRB, 0.519129E+00_JPRB &
  &, 0.499971E+00_JPRB, 0.481026E+00_JPRB, 0.462312E+00_JPRB, 0.443844E+00_JPRB &
  &, 0.425644E+00_JPRB, 0.407720E+00_JPRB, 0.390096E+00_JPRB &
  &, 0.372791E+00_JPRB, 0.355812E+00_JPRB, 0.339179E+00_JPRB, 0.322910E+00_JPRB &
  &, 0.307014E+00_JPRB, 0.291513E+00_JPRB, 0.276410E+00_JPRB &
  &, 0.261721E+00_JPRB, 0.247460E+00_JPRB, 0.233629E+00_JPRB, 0.220240E+00_JPRB &
  &, 0.207313E+00_JPRB, 0.194838E+00_JPRB, 0.182824E+00_JPRB &
  &, 0.171278E+00_JPRB, 0.160194E+00_JPRB, 0.149587E+00_JPRB, 0.139448E+00_JPRB &
  &, 0.129775E+00_JPRB, 0.120565E+00_JPRB, 0.111809E+00_JPRB &
  &, 0.103512E+00_JPRB, 0.956477E-01_JPRB, 0.882248E-01_JPRB, 0.812382E-01_JPRB &
  &, 0.746501E-01_JPRB, 0.684908E-01_JPRB, 0.627002E-01_JPRB &
  &, 0.573031E-01_JPRB, 0.522615E-01_JPRB, 0.475799E-01_JPRB, 0.432283E-01_JPRB &
  &, 0.392062E-01_JPRB, 0.354762E-01_JPRB, 0.320492E-01_JPRB &
  &, 0.288813E-01_JPRB, 0.259785E-01_JPRB, 0.233274E-01_JPRB, 0.209118E-01_JPRB &
  &, 0.186934E-01_JPRB, 0.166898E-01_JPRB, 0.148574E-01_JPRB &
  &, 0.132112E-01_JPRB, 0.117020E-01_JPRB, 0.103636E-01_JPRB, 0.916477E-02_JPRB &
  &, 0.807083E-02_JPRB, 0.709050E-02_JPRB, 0.623272E-02_JPRB &
  &, 0.545805E-02_JPRB, 0.477303E-02_JPRB, 0.415907E-02_JPRB, 0.362156E-02_JPRB &
  &, 0.313976E-02_JPRB, 0.271783E-02_JPRB, 0.236001E-02_JPRB &
  &, 0.204285E-02_JPRB, 0.174086E-02_JPRB, 0.151323E-02_JPRB, 0.127625E-02_JPRB &
  &, 0.108975E-02_JPRB, 0.926332E-03_JPRB, 0.787542E-03_JPRB &
  &, 0.674964E-03_JPRB, 0.557981E-03_JPRB, 0.469331E-03_JPRB, 0.410686E-03_JPRB &
  &, 0.349776E-03_JPRB, 0.286565E-03_JPRB, 0.221018E-03_JPRB &
  &, 0.188874E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.488890E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 221, :) = (/ &
  &  0.921645E+00_JPRB, 0.901733E+00_JPRB, 0.881716E+00_JPRB, 0.861611E+00_JPRB &
  &, 0.841433E+00_JPRB, 0.821193E+00_JPRB, 0.800905E+00_JPRB &
  &, 0.780585E+00_JPRB, 0.760248E+00_JPRB, 0.739908E+00_JPRB, 0.719579E+00_JPRB &
  &, 0.699278E+00_JPRB, 0.679020E+00_JPRB, 0.658820E+00_JPRB &
  &, 0.638695E+00_JPRB, 0.618661E+00_JPRB, 0.598735E+00_JPRB, 0.578932E+00_JPRB &
  &, 0.559270E+00_JPRB, 0.539765E+00_JPRB, 0.520436E+00_JPRB &
  &, 0.501298E+00_JPRB, 0.482373E+00_JPRB, 0.463669E+00_JPRB, 0.445215E+00_JPRB &
  &, 0.427019E+00_JPRB, 0.409102E+00_JPRB, 0.391482E+00_JPRB &
  &, 0.374171E+00_JPRB, 0.357191E+00_JPRB, 0.340554E+00_JPRB, 0.324273E+00_JPRB &
  &, 0.308369E+00_JPRB, 0.292849E+00_JPRB, 0.277730E+00_JPRB &
  &, 0.263023E+00_JPRB, 0.248738E+00_JPRB, 0.234891E+00_JPRB, 0.221483E+00_JPRB &
  &, 0.208516E+00_JPRB, 0.196019E+00_JPRB, 0.183969E+00_JPRB &
  &, 0.172396E+00_JPRB, 0.161284E+00_JPRB, 0.150634E+00_JPRB, 0.140462E+00_JPRB &
  &, 0.130753E+00_JPRB, 0.121504E+00_JPRB, 0.112707E+00_JPRB &
  &, 0.104367E+00_JPRB, 0.964686E-01_JPRB, 0.890105E-01_JPRB, 0.819863E-01_JPRB &
  &, 0.753727E-01_JPRB, 0.691565E-01_JPRB, 0.633361E-01_JPRB &
  &, 0.579075E-01_JPRB, 0.528324E-01_JPRB, 0.481153E-01_JPRB, 0.437262E-01_JPRB &
  &, 0.396645E-01_JPRB, 0.359102E-01_JPRB, 0.324397E-01_JPRB &
  &, 0.292624E-01_JPRB, 0.263310E-01_JPRB, 0.236497E-01_JPRB, 0.212024E-01_JPRB &
  &, 0.189705E-01_JPRB, 0.169324E-01_JPRB, 0.150845E-01_JPRB &
  &, 0.134010E-01_JPRB, 0.118958E-01_JPRB, 0.105395E-01_JPRB, 0.932184E-02_JPRB &
  &, 0.820823E-02_JPRB, 0.723071E-02_JPRB, 0.635193E-02_JPRB &
  &, 0.555534E-02_JPRB, 0.487226E-02_JPRB, 0.423496E-02_JPRB, 0.369895E-02_JPRB &
  &, 0.321867E-02_JPRB, 0.279826E-02_JPRB, 0.241467E-02_JPRB &
  &, 0.207070E-02_JPRB, 0.179761E-02_JPRB, 0.154214E-02_JPRB, 0.130570E-02_JPRB &
  &, 0.111974E-02_JPRB, 0.956876E-03_JPRB, 0.818644E-03_JPRB &
  &, 0.706629E-03_JPRB, 0.590215E-03_JPRB, 0.502140E-03_JPRB, 0.410686E-03_JPRB &
  &, 0.349776E-03_JPRB, 0.286565E-03_JPRB, 0.256188E-03_JPRB &
  &, 0.188874E-03_JPRB, 0.155543E-03_JPRB, 0.121008E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 222, :) = (/ &
  &  0.921965E+00_JPRB, 0.902126E+00_JPRB, 0.882182E+00_JPRB, 0.862147E+00_JPRB &
  &, 0.842035E+00_JPRB, 0.821859E+00_JPRB, 0.801633E+00_JPRB &
  &, 0.781373E+00_JPRB, 0.761092E+00_JPRB, 0.740805E+00_JPRB, 0.720528E+00_JPRB &
  &, 0.700276E+00_JPRB, 0.680063E+00_JPRB, 0.659906E+00_JPRB &
  &, 0.639822E+00_JPRB, 0.619825E+00_JPRB, 0.599933E+00_JPRB, 0.580162E+00_JPRB &
  &, 0.560528E+00_JPRB, 0.541050E+00_JPRB, 0.521743E+00_JPRB &
  &, 0.502624E+00_JPRB, 0.483716E+00_JPRB, 0.465029E+00_JPRB, 0.446583E+00_JPRB &
  &, 0.428397E+00_JPRB, 0.410484E+00_JPRB, 0.392867E+00_JPRB &
  &, 0.375556E+00_JPRB, 0.358573E+00_JPRB, 0.341926E+00_JPRB, 0.325642E+00_JPRB &
  &, 0.309724E+00_JPRB, 0.294189E+00_JPRB, 0.279055E+00_JPRB &
  &, 0.264325E+00_JPRB, 0.250025E+00_JPRB, 0.236152E+00_JPRB, 0.222716E+00_JPRB &
  &, 0.209729E+00_JPRB, 0.197199E+00_JPRB, 0.185125E+00_JPRB &
  &, 0.173515E+00_JPRB, 0.162362E+00_JPRB, 0.151693E+00_JPRB, 0.141475E+00_JPRB &
  &, 0.131730E+00_JPRB, 0.122443E+00_JPRB, 0.113618E+00_JPRB &
  &, 0.105234E+00_JPRB, 0.973031E-01_JPRB, 0.898099E-01_JPRB, 0.827343E-01_JPRB &
  &, 0.760808E-01_JPRB, 0.698370E-01_JPRB, 0.639873E-01_JPRB &
  &, 0.585119E-01_JPRB, 0.534032E-01_JPRB, 0.486507E-01_JPRB, 0.442242E-01_JPRB &
  &, 0.401398E-01_JPRB, 0.363442E-01_JPRB, 0.328480E-01_JPRB &
  &, 0.296434E-01_JPRB, 0.266834E-01_JPRB, 0.239720E-01_JPRB, 0.214930E-01_JPRB &
  &, 0.192475E-01_JPRB, 0.171750E-01_JPRB, 0.153117E-01_JPRB &
  &, 0.136118E-01_JPRB, 0.120895E-01_JPRB, 0.107153E-01_JPRB, 0.947890E-02_JPRB &
  &, 0.834563E-02_JPRB, 0.734755E-02_JPRB, 0.647114E-02_JPRB &
  &, 0.567695E-02_JPRB, 0.494668E-02_JPRB, 0.433616E-02_JPRB, 0.377634E-02_JPRB &
  &, 0.327127E-02_JPRB, 0.285188E-02_JPRB, 0.246932E-02_JPRB &
  &, 0.212639E-02_JPRB, 0.182599E-02_JPRB, 0.157105E-02_JPRB, 0.136459E-02_JPRB &
  &, 0.114974E-02_JPRB, 0.987421E-03_JPRB, 0.849746E-03_JPRB &
  &, 0.706629E-03_JPRB, 0.590215E-03_JPRB, 0.502140E-03_JPRB, 0.444077E-03_JPRB &
  &, 0.349776E-03_JPRB, 0.286565E-03_JPRB, 0.256188E-03_JPRB &
  &, 0.224648E-03_JPRB, 0.155543E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 223, :) = (/ &
  &  0.922283E+00_JPRB, 0.902519E+00_JPRB, 0.882646E+00_JPRB, 0.862681E+00_JPRB &
  &, 0.842635E+00_JPRB, 0.822524E+00_JPRB, 0.802360E+00_JPRB &
  &, 0.782159E+00_JPRB, 0.761924E+00_JPRB, 0.741702E+00_JPRB, 0.721476E+00_JPRB &
  &, 0.701271E+00_JPRB, 0.681104E+00_JPRB, 0.660991E+00_JPRB &
  &, 0.640946E+00_JPRB, 0.620987E+00_JPRB, 0.601129E+00_JPRB, 0.581389E+00_JPRB &
  &, 0.561783E+00_JPRB, 0.542331E+00_JPRB, 0.523049E+00_JPRB &
  &, 0.503950E+00_JPRB, 0.485056E+00_JPRB, 0.466386E+00_JPRB, 0.447950E+00_JPRB &
  &, 0.429772E+00_JPRB, 0.411866E+00_JPRB, 0.394248E+00_JPRB &
  &, 0.376940E+00_JPRB, 0.359951E+00_JPRB, 0.343302E+00_JPRB, 0.327005E+00_JPRB &
  &, 0.311079E+00_JPRB, 0.295534E+00_JPRB, 0.280384E+00_JPRB &
  &, 0.265636E+00_JPRB, 0.251312E+00_JPRB, 0.237413E+00_JPRB, 0.223949E+00_JPRB &
  &, 0.210942E+00_JPRB, 0.198379E+00_JPRB, 0.186270E+00_JPRB &
  &, 0.174633E+00_JPRB, 0.163452E+00_JPRB, 0.152740E+00_JPRB, 0.142501E+00_JPRB &
  &, 0.132708E+00_JPRB, 0.123394E+00_JPRB, 0.114529E+00_JPRB &
  &, 0.106101E+00_JPRB, 0.981375E-01_JPRB, 0.905956E-01_JPRB, 0.834965E-01_JPRB &
  &, 0.768033E-01_JPRB, 0.705176E-01_JPRB, 0.646233E-01_JPRB &
  &, 0.591163E-01_JPRB, 0.539741E-01_JPRB, 0.491861E-01_JPRB, 0.447387E-01_JPRB &
  &, 0.405982E-01_JPRB, 0.367781E-01_JPRB, 0.332562E-01_JPRB &
  &, 0.300245E-01_JPRB, 0.270358E-01_JPRB, 0.242942E-01_JPRB, 0.218029E-01_JPRB &
  &, 0.195246E-01_JPRB, 0.174378E-01_JPRB, 0.155388E-01_JPRB &
  &, 0.138438E-01_JPRB, 0.122833E-01_JPRB, 0.108912E-01_JPRB, 0.963597E-02_JPRB &
  &, 0.850593E-02_JPRB, 0.748776E-02_JPRB, 0.659035E-02_JPRB &
  &, 0.577424E-02_JPRB, 0.504591E-02_JPRB, 0.441206E-02_JPRB, 0.385374E-02_JPRB &
  &, 0.335017E-02_JPRB, 0.290550E-02_JPRB, 0.252397E-02_JPRB &
  &, 0.218209E-02_JPRB, 0.188274E-02_JPRB, 0.159995E-02_JPRB, 0.139404E-02_JPRB &
  &, 0.117973E-02_JPRB, 0.101796E-02_JPRB, 0.849746E-03_JPRB &
  &, 0.738294E-03_JPRB, 0.622449E-03_JPRB, 0.534950E-03_JPRB, 0.444077E-03_JPRB &
  &, 0.383754E-03_JPRB, 0.321136E-03_JPRB, 0.256188E-03_JPRB &
  &, 0.224648E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 224, :) = (/ &
  &  0.922601E+00_JPRB, 0.902911E+00_JPRB, 0.883110E+00_JPRB, 0.863214E+00_JPRB &
  &, 0.843234E+00_JPRB, 0.823187E+00_JPRB, 0.803085E+00_JPRB &
  &, 0.782943E+00_JPRB, 0.762775E+00_JPRB, 0.742596E+00_JPRB, 0.722421E+00_JPRB &
  &, 0.702265E+00_JPRB, 0.682145E+00_JPRB, 0.662074E+00_JPRB &
  &, 0.642070E+00_JPRB, 0.622147E+00_JPRB, 0.602324E+00_JPRB, 0.582616E+00_JPRB &
  &, 0.563040E+00_JPRB, 0.543613E+00_JPRB, 0.524353E+00_JPRB &
  &, 0.505276E+00_JPRB, 0.486399E+00_JPRB, 0.467740E+00_JPRB, 0.449318E+00_JPRB &
  &, 0.431147E+00_JPRB, 0.413248E+00_JPRB, 0.395634E+00_JPRB &
  &, 0.378324E+00_JPRB, 0.361334E+00_JPRB, 0.344678E+00_JPRB, 0.328374E+00_JPRB &
  &, 0.312434E+00_JPRB, 0.296875E+00_JPRB, 0.281708E+00_JPRB &
  &, 0.266948E+00_JPRB, 0.252600E+00_JPRB, 0.238675E+00_JPRB, 0.225193E+00_JPRB &
  &, 0.212154E+00_JPRB, 0.199559E+00_JPRB, 0.187426E+00_JPRB &
  &, 0.175752E+00_JPRB, 0.164541E+00_JPRB, 0.153799E+00_JPRB, 0.143514E+00_JPRB &
  &, 0.133697E+00_JPRB, 0.124333E+00_JPRB, 0.115439E+00_JPRB &
  &, 0.106981E+00_JPRB, 0.989720E-01_JPRB, 0.913950E-01_JPRB, 0.842587E-01_JPRB &
  &, 0.775259E-01_JPRB, 0.711981E-01_JPRB, 0.652744E-01_JPRB &
  &, 0.597207E-01_JPRB, 0.545450E-01_JPRB, 0.497215E-01_JPRB, 0.452366E-01_JPRB &
  &, 0.410735E-01_JPRB, 0.372295E-01_JPRB, 0.336822E-01_JPRB &
  &, 0.304056E-01_JPRB, 0.273883E-01_JPRB, 0.246355E-01_JPRB, 0.220935E-01_JPRB &
  &, 0.198017E-01_JPRB, 0.177007E-01_JPRB, 0.157866E-01_JPRB &
  &, 0.140547E-01_JPRB, 0.124771E-01_JPRB, 0.110670E-01_JPRB, 0.979304E-02_JPRB &
  &, 0.864334E-02_JPRB, 0.762796E-02_JPRB, 0.670956E-02_JPRB &
  &, 0.587152E-02_JPRB, 0.514514E-02_JPRB, 0.448796E-02_JPRB, 0.393113E-02_JPRB &
  &, 0.340277E-02_JPRB, 0.295912E-02_JPRB, 0.257862E-02_JPRB &
  &, 0.220994E-02_JPRB, 0.191111E-02_JPRB, 0.165777E-02_JPRB, 0.142349E-02_JPRB &
  &, 0.120972E-02_JPRB, 0.104851E-02_JPRB, 0.880847E-03_JPRB &
  &, 0.738294E-03_JPRB, 0.622449E-03_JPRB, 0.534950E-03_JPRB, 0.444077E-03_JPRB &
  &, 0.383754E-03_JPRB, 0.321136E-03_JPRB, 0.256188E-03_JPRB &
  &, 0.224648E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART32',1,ZHOOK_HANDLE)
END SUBROUTINE PART32

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART33

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART33',0,ZHOOK_HANDLE)

XCW( 225, :) = (/ &
  &  0.922919E+00_JPRB, 0.903302E+00_JPRB, 0.883572E+00_JPRB, 0.863746E+00_JPRB &
  &, 0.843833E+00_JPRB, 0.823849E+00_JPRB, 0.803809E+00_JPRB &
  &, 0.783726E+00_JPRB, 0.763614E+00_JPRB, 0.743489E+00_JPRB, 0.723366E+00_JPRB &
  &, 0.703259E+00_JPRB, 0.683182E+00_JPRB, 0.663156E+00_JPRB &
  &, 0.643191E+00_JPRB, 0.623307E+00_JPRB, 0.603518E+00_JPRB, 0.583842E+00_JPRB &
  &, 0.564295E+00_JPRB, 0.544895E+00_JPRB, 0.525656E+00_JPRB &
  &, 0.506599E+00_JPRB, 0.487738E+00_JPRB, 0.469097E+00_JPRB, 0.450686E+00_JPRB &
  &, 0.432522E+00_JPRB, 0.414627E+00_JPRB, 0.397019E+00_JPRB &
  &, 0.379708E+00_JPRB, 0.362712E+00_JPRB, 0.346053E+00_JPRB, 0.329742E+00_JPRB &
  &, 0.313789E+00_JPRB, 0.298220E+00_JPRB, 0.283037E+00_JPRB &
  &, 0.268250E+00_JPRB, 0.253887E+00_JPRB, 0.239946E+00_JPRB, 0.226436E+00_JPRB &
  &, 0.213367E+00_JPRB, 0.200750E+00_JPRB, 0.188593E+00_JPRB &
  &, 0.176881E+00_JPRB, 0.165643E+00_JPRB, 0.154858E+00_JPRB, 0.144540E+00_JPRB &
  &, 0.134687E+00_JPRB, 0.125285E+00_JPRB, 0.116350E+00_JPRB &
  &, 0.107862E+00_JPRB, 0.998064E-01_JPRB, 0.921945E-01_JPRB, 0.850208E-01_JPRB &
  &, 0.782485E-01_JPRB, 0.718934E-01_JPRB, 0.659255E-01_JPRB &
  &, 0.603406E-01_JPRB, 0.551317E-01_JPRB, 0.502731E-01_JPRB, 0.457511E-01_JPRB &
  &, 0.415658E-01_JPRB, 0.376809E-01_JPRB, 0.340905E-01_JPRB &
  &, 0.307867E-01_JPRB, 0.277407E-01_JPRB, 0.249577E-01_JPRB, 0.224035E-01_JPRB &
  &, 0.200788E-01_JPRB, 0.179433E-01_JPRB, 0.160138E-01_JPRB &
  &, 0.142656E-01_JPRB, 0.126709E-01_JPRB, 0.112429E-01_JPRB, 0.995010E-02_JPRB &
  &, 0.880364E-02_JPRB, 0.774480E-02_JPRB, 0.682877E-02_JPRB &
  &, 0.599313E-02_JPRB, 0.524437E-02_JPRB, 0.458915E-02_JPRB, 0.400852E-02_JPRB &
  &, 0.348167E-02_JPRB, 0.303955E-02_JPRB, 0.263327E-02_JPRB &
  &, 0.226563E-02_JPRB, 0.196786E-02_JPRB, 0.168668E-02_JPRB, 0.145294E-02_JPRB &
  &, 0.123971E-02_JPRB, 0.107905E-02_JPRB, 0.911949E-03_JPRB &
  &, 0.769959E-03_JPRB, 0.654684E-03_JPRB, 0.567759E-03_JPRB, 0.477467E-03_JPRB &
  &, 0.383754E-03_JPRB, 0.321136E-03_JPRB, 0.291358E-03_JPRB &
  &, 0.224648E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.865085E-04_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 226, :) = (/ &
  &  0.923236E+00_JPRB, 0.903692E+00_JPRB, 0.884034E+00_JPRB, 0.864276E+00_JPRB &
  &, 0.844429E+00_JPRB, 0.824511E+00_JPRB, 0.804531E+00_JPRB &
  &, 0.784507E+00_JPRB, 0.764451E+00_JPRB, 0.744380E+00_JPRB, 0.724309E+00_JPRB &
  &, 0.704250E+00_JPRB, 0.684220E+00_JPRB, 0.664235E+00_JPRB &
  &, 0.644312E+00_JPRB, 0.624464E+00_JPRB, 0.604710E+00_JPRB, 0.585066E+00_JPRB &
  &, 0.565548E+00_JPRB, 0.546173E+00_JPRB, 0.526960E+00_JPRB &
  &, 0.507922E+00_JPRB, 0.489081E+00_JPRB, 0.470450E+00_JPRB, 0.452050E+00_JPRB &
  &, 0.433897E+00_JPRB, 0.416009E+00_JPRB, 0.398400E+00_JPRB &
  &, 0.381092E+00_JPRB, 0.364095E+00_JPRB, 0.347429E+00_JPRB, 0.331110E+00_JPRB &
  &, 0.315149E+00_JPRB, 0.299565E+00_JPRB, 0.284366E+00_JPRB &
  &, 0.269562E+00_JPRB, 0.255175E+00_JPRB, 0.241217E+00_JPRB, 0.227679E+00_JPRB &
  &, 0.214590E+00_JPRB, 0.201941E+00_JPRB, 0.189749E+00_JPRB &
  &, 0.178011E+00_JPRB, 0.166732E+00_JPRB, 0.155917E+00_JPRB, 0.145565E+00_JPRB &
  &, 0.135677E+00_JPRB, 0.126249E+00_JPRB, 0.117274E+00_JPRB &
  &, 0.108742E+00_JPRB, 0.100654E+00_JPRB, 0.930077E-01_JPRB, 0.857830E-01_JPRB &
  &, 0.789855E-01_JPRB, 0.725887E-01_JPRB, 0.665767E-01_JPRB &
  &, 0.609605E-01_JPRB, 0.557185E-01_JPRB, 0.508247E-01_JPRB, 0.462656E-01_JPRB &
  &, 0.420411E-01_JPRB, 0.381322E-01_JPRB, 0.345165E-01_JPRB &
  &, 0.311859E-01_JPRB, 0.281117E-01_JPRB, 0.252990E-01_JPRB, 0.227134E-01_JPRB &
  &, 0.203559E-01_JPRB, 0.182061E-01_JPRB, 0.162616E-01_JPRB &
  &, 0.144975E-01_JPRB, 0.128862E-01_JPRB, 0.114407E-01_JPRB, 0.101296E-01_JPRB &
  &, 0.894104E-02_JPRB, 0.788501E-02_JPRB, 0.694798E-02_JPRB &
  &, 0.609042E-02_JPRB, 0.534360E-02_JPRB, 0.466505E-02_JPRB, 0.408591E-02_JPRB &
  &, 0.356057E-02_JPRB, 0.309317E-02_JPRB, 0.268792E-02_JPRB &
  &, 0.232132E-02_JPRB, 0.199623E-02_JPRB, 0.171559E-02_JPRB, 0.148238E-02_JPRB &
  &, 0.126971E-02_JPRB, 0.107905E-02_JPRB, 0.943051E-03_JPRB &
  &, 0.801624E-03_JPRB, 0.686918E-03_JPRB, 0.567759E-03_JPRB, 0.477467E-03_JPRB &
  &, 0.417731E-03_JPRB, 0.355707E-03_JPRB, 0.291358E-03_JPRB &
  &, 0.224648E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.495298E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 227, :) = (/ &
  &  0.923551E+00_JPRB, 0.904081E+00_JPRB, 0.884494E+00_JPRB, 0.864805E+00_JPRB &
  &, 0.845025E+00_JPRB, 0.825170E+00_JPRB, 0.805252E+00_JPRB &
  &, 0.785287E+00_JPRB, 0.765288E+00_JPRB, 0.745271E+00_JPRB, 0.725249E+00_JPRB &
  &, 0.705239E+00_JPRB, 0.685255E+00_JPRB, 0.665313E+00_JPRB &
  &, 0.645430E+00_JPRB, 0.625621E+00_JPRB, 0.605902E+00_JPRB, 0.586289E+00_JPRB &
  &, 0.566801E+00_JPRB, 0.547452E+00_JPRB, 0.528260E+00_JPRB &
  &, 0.509245E+00_JPRB, 0.490421E+00_JPRB, 0.471804E+00_JPRB, 0.453418E+00_JPRB &
  &, 0.435272E+00_JPRB, 0.417391E+00_JPRB, 0.399786E+00_JPRB &
  &, 0.382476E+00_JPRB, 0.365477E+00_JPRB, 0.348805E+00_JPRB, 0.332478E+00_JPRB &
  &, 0.316508E+00_JPRB, 0.300910E+00_JPRB, 0.285695E+00_JPRB &
  &, 0.270873E+00_JPRB, 0.256472E+00_JPRB, 0.242488E+00_JPRB, 0.228932E+00_JPRB &
  &, 0.215814E+00_JPRB, 0.203132E+00_JPRB, 0.190916E+00_JPRB &
  &, 0.179141E+00_JPRB, 0.167833E+00_JPRB, 0.156987E+00_JPRB, 0.146602E+00_JPRB &
  &, 0.136679E+00_JPRB, 0.127200E+00_JPRB, 0.118184E+00_JPRB &
  &, 0.109622E+00_JPRB, 0.101502E+00_JPRB, 0.938209E-01_JPRB, 0.865593E-01_JPRB &
  &, 0.797080E-01_JPRB, 0.732840E-01_JPRB, 0.672429E-01_JPRB &
  &, 0.615804E-01_JPRB, 0.563052E-01_JPRB, 0.513764E-01_JPRB, 0.467801E-01_JPRB &
  &, 0.425334E-01_JPRB, 0.385836E-01_JPRB, 0.349425E-01_JPRB &
  &, 0.315670E-01_JPRB, 0.284826E-01_JPRB, 0.256402E-01_JPRB, 0.230233E-01_JPRB &
  &, 0.206528E-01_JPRB, 0.184892E-01_JPRB, 0.165094E-01_JPRB &
  &, 0.147084E-01_JPRB, 0.130800E-01_JPRB, 0.116166E-01_JPRB, 0.102867E-01_JPRB &
  &, 0.910134E-02_JPRB, 0.802522E-02_JPRB, 0.706719E-02_JPRB &
  &, 0.621203E-02_JPRB, 0.544283E-02_JPRB, 0.476625E-02_JPRB, 0.416330E-02_JPRB &
  &, 0.363947E-02_JPRB, 0.314679E-02_JPRB, 0.274257E-02_JPRB &
  &, 0.237702E-02_JPRB, 0.205298E-02_JPRB, 0.177340E-02_JPRB, 0.151183E-02_JPRB &
  &, 0.129970E-02_JPRB, 0.110960E-02_JPRB, 0.943051E-03_JPRB &
  &, 0.801624E-03_JPRB, 0.686918E-03_JPRB, 0.600569E-03_JPRB, 0.510858E-03_JPRB &
  &, 0.417731E-03_JPRB, 0.355707E-03_JPRB, 0.291358E-03_JPRB &
  &, 0.260423E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 228, :) = (/ &
  &  0.923867E+00_JPRB, 0.904471E+00_JPRB, 0.884954E+00_JPRB, 0.865333E+00_JPRB &
  &, 0.845620E+00_JPRB, 0.825828E+00_JPRB, 0.805972E+00_JPRB &
  &, 0.786065E+00_JPRB, 0.766123E+00_JPRB, 0.746159E+00_JPRB, 0.726189E+00_JPRB &
  &, 0.706227E+00_JPRB, 0.686290E+00_JPRB, 0.666391E+00_JPRB &
  &, 0.646548E+00_JPRB, 0.626776E+00_JPRB, 0.607091E+00_JPRB, 0.587511E+00_JPRB &
  &, 0.568051E+00_JPRB, 0.548727E+00_JPRB, 0.529560E+00_JPRB &
  &, 0.510564E+00_JPRB, 0.491757E+00_JPRB, 0.473157E+00_JPRB, 0.454782E+00_JPRB &
  &, 0.436647E+00_JPRB, 0.418769E+00_JPRB, 0.401171E+00_JPRB &
  &, 0.383861E+00_JPRB, 0.366859E+00_JPRB, 0.350185E+00_JPRB, 0.333846E+00_JPRB &
  &, 0.317867E+00_JPRB, 0.302255E+00_JPRB, 0.287029E+00_JPRB &
  &, 0.272194E+00_JPRB, 0.257769E+00_JPRB, 0.243759E+00_JPRB, 0.230175E+00_JPRB &
  &, 0.217027E+00_JPRB, 0.204333E+00_JPRB, 0.192082E+00_JPRB &
  &, 0.180281E+00_JPRB, 0.168935E+00_JPRB, 0.158057E+00_JPRB, 0.147640E+00_JPRB &
  &, 0.137669E+00_JPRB, 0.128164E+00_JPRB, 0.119121E+00_JPRB &
  &, 0.110516E+00_JPRB, 0.102350E+00_JPRB, 0.946342E-01_JPRB, 0.873356E-01_JPRB &
  &, 0.804450E-01_JPRB, 0.739793E-01_JPRB, 0.679092E-01_JPRB &
  &, 0.622158E-01_JPRB, 0.568920E-01_JPRB, 0.519280E-01_JPRB, 0.473112E-01_JPRB &
  &, 0.430087E-01_JPRB, 0.390349E-01_JPRB, 0.353685E-01_JPRB &
  &, 0.319662E-01_JPRB, 0.288536E-01_JPRB, 0.259814E-01_JPRB, 0.233527E-01_JPRB &
  &, 0.209496E-01_JPRB, 0.187520E-01_JPRB, 0.167572E-01_JPRB &
  &, 0.149404E-01_JPRB, 0.132953E-01_JPRB, 0.118144E-01_JPRB, 0.104662E-01_JPRB &
  &, 0.926164E-02_JPRB, 0.816543E-02_JPRB, 0.718640E-02_JPRB &
  &, 0.633363E-02_JPRB, 0.554206E-02_JPRB, 0.486744E-02_JPRB, 0.424069E-02_JPRB &
  &, 0.369208E-02_JPRB, 0.322722E-02_JPRB, 0.279723E-02_JPRB &
  &, 0.243271E-02_JPRB, 0.208136E-02_JPRB, 0.180231E-02_JPRB, 0.154128E-02_JPRB &
  &, 0.132969E-02_JPRB, 0.114014E-02_JPRB, 0.974152E-03_JPRB &
  &, 0.833289E-03_JPRB, 0.719152E-03_JPRB, 0.600569E-03_JPRB, 0.510858E-03_JPRB &
  &, 0.417731E-03_JPRB, 0.355707E-03_JPRB, 0.291358E-03_JPRB &
  &, 0.260423E-03_JPRB, 0.191928E-03_JPRB, 0.158010E-03_JPRB, 0.122876E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 229, :) = (/ &
  &  0.924182E+00_JPRB, 0.904857E+00_JPRB, 0.885412E+00_JPRB, 0.865860E+00_JPRB &
  &, 0.846213E+00_JPRB, 0.826485E+00_JPRB, 0.806690E+00_JPRB &
  &, 0.786842E+00_JPRB, 0.766956E+00_JPRB, 0.747046E+00_JPRB, 0.727127E+00_JPRB &
  &, 0.707214E+00_JPRB, 0.687323E+00_JPRB, 0.667467E+00_JPRB &
  &, 0.647663E+00_JPRB, 0.627930E+00_JPRB, 0.608280E+00_JPRB, 0.588731E+00_JPRB &
  &, 0.569301E+00_JPRB, 0.550005E+00_JPRB, 0.530860E+00_JPRB &
  &, 0.511884E+00_JPRB, 0.493097E+00_JPRB, 0.474511E+00_JPRB, 0.456146E+00_JPRB &
  &, 0.438022E+00_JPRB, 0.420151E+00_JPRB, 0.402552E+00_JPRB &
  &, 0.385245E+00_JPRB, 0.368242E+00_JPRB, 0.351561E+00_JPRB, 0.335218E+00_JPRB &
  &, 0.319227E+00_JPRB, 0.303604E+00_JPRB, 0.288362E+00_JPRB &
  &, 0.273505E+00_JPRB, 0.259066E+00_JPRB, 0.245030E+00_JPRB, 0.231428E+00_JPRB &
  &, 0.218260E+00_JPRB, 0.205524E+00_JPRB, 0.193249E+00_JPRB &
  &, 0.181422E+00_JPRB, 0.170047E+00_JPRB, 0.159128E+00_JPRB, 0.148677E+00_JPRB &
  &, 0.138671E+00_JPRB, 0.129128E+00_JPRB, 0.120044E+00_JPRB &
  &, 0.111410E+00_JPRB, 0.103211E+00_JPRB, 0.954474E-01_JPRB, 0.881119E-01_JPRB &
  &, 0.811965E-01_JPRB, 0.746894E-01_JPRB, 0.685755E-01_JPRB &
  &, 0.628356E-01_JPRB, 0.574787E-01_JPRB, 0.524796E-01_JPRB, 0.478257E-01_JPRB &
  &, 0.435010E-01_JPRB, 0.395036E-01_JPRB, 0.357945E-01_JPRB &
  &, 0.323654E-01_JPRB, 0.292246E-01_JPRB, 0.263227E-01_JPRB, 0.236626E-01_JPRB &
  &, 0.212267E-01_JPRB, 0.190148E-01_JPRB, 0.170050E-01_JPRB &
  &, 0.151724E-01_JPRB, 0.134891E-01_JPRB, 0.119903E-01_JPRB, 0.106233E-01_JPRB &
  &, 0.939904E-02_JPRB, 0.830564E-02_JPRB, 0.732945E-02_JPRB &
  &, 0.643092E-02_JPRB, 0.566610E-02_JPRB, 0.494334E-02_JPRB, 0.431808E-02_JPRB &
  &, 0.377098E-02_JPRB, 0.328084E-02_JPRB, 0.285188E-02_JPRB &
  &, 0.248841E-02_JPRB, 0.213811E-02_JPRB, 0.186013E-02_JPRB, 0.160017E-02_JPRB &
  &, 0.135969E-02_JPRB, 0.117069E-02_JPRB, 0.100525E-02_JPRB &
  &, 0.864954E-03_JPRB, 0.719152E-03_JPRB, 0.633378E-03_JPRB, 0.510858E-03_JPRB &
  &, 0.451709E-03_JPRB, 0.355707E-03_JPRB, 0.326527E-03_JPRB &
  &, 0.260423E-03_JPRB, 0.228314E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 230, :) = (/ &
  &  0.924496E+00_JPRB, 0.905244E+00_JPRB, 0.885870E+00_JPRB, 0.866386E+00_JPRB &
  &, 0.846804E+00_JPRB, 0.827140E+00_JPRB, 0.807407E+00_JPRB &
  &, 0.787618E+00_JPRB, 0.767788E+00_JPRB, 0.747932E+00_JPRB, 0.728064E+00_JPRB &
  &, 0.708199E+00_JPRB, 0.688353E+00_JPRB, 0.668541E+00_JPRB &
  &, 0.648779E+00_JPRB, 0.629081E+00_JPRB, 0.609467E+00_JPRB, 0.589950E+00_JPRB &
  &, 0.570549E+00_JPRB, 0.551278E+00_JPRB, 0.532157E+00_JPRB &
  &, 0.513204E+00_JPRB, 0.494433E+00_JPRB, 0.475864E+00_JPRB, 0.457510E+00_JPRB &
  &, 0.439393E+00_JPRB, 0.421530E+00_JPRB, 0.403938E+00_JPRB &
  &, 0.386629E+00_JPRB, 0.369624E+00_JPRB, 0.352940E+00_JPRB, 0.336591E+00_JPRB &
  &, 0.320590E+00_JPRB, 0.304953E+00_JPRB, 0.289696E+00_JPRB &
  &, 0.274826E+00_JPRB, 0.260363E+00_JPRB, 0.246311E+00_JPRB, 0.232682E+00_JPRB &
  &, 0.219483E+00_JPRB, 0.206725E+00_JPRB, 0.194416E+00_JPRB &
  &, 0.182552E+00_JPRB, 0.171148E+00_JPRB, 0.160198E+00_JPRB, 0.149715E+00_JPRB &
  &, 0.139685E+00_JPRB, 0.130105E+00_JPRB, 0.120981E+00_JPRB &
  &, 0.112303E+00_JPRB, 0.104059E+00_JPRB, 0.962606E-01_JPRB, 0.888882E-01_JPRB &
  &, 0.819335E-01_JPRB, 0.753847E-01_JPRB, 0.692417E-01_JPRB &
  &, 0.634710E-01_JPRB, 0.580813E-01_JPRB, 0.530475E-01_JPRB, 0.483568E-01_JPRB &
  &, 0.440102E-01_JPRB, 0.399724E-01_JPRB, 0.362205E-01_JPRB &
  &, 0.327647E-01_JPRB, 0.295956E-01_JPRB, 0.266639E-01_JPRB, 0.239919E-01_JPRB &
  &, 0.215236E-01_JPRB, 0.192979E-01_JPRB, 0.172528E-01_JPRB &
  &, 0.153832E-01_JPRB, 0.137045E-01_JPRB, 0.121881E-01_JPRB, 0.108028E-01_JPRB &
  &, 0.955934E-02_JPRB, 0.844584E-02_JPRB, 0.744866E-02_JPRB &
  &, 0.655253E-02_JPRB, 0.576533E-02_JPRB, 0.504454E-02_JPRB, 0.442127E-02_JPRB &
  &, 0.384988E-02_JPRB, 0.336127E-02_JPRB, 0.290653E-02_JPRB &
  &, 0.251626E-02_JPRB, 0.219486E-02_JPRB, 0.188904E-02_JPRB, 0.162962E-02_JPRB &
  &, 0.138968E-02_JPRB, 0.120123E-02_JPRB, 0.103636E-02_JPRB &
  &, 0.864954E-03_JPRB, 0.751386E-03_JPRB, 0.633378E-03_JPRB, 0.544248E-03_JPRB &
  &, 0.451709E-03_JPRB, 0.390278E-03_JPRB, 0.326527E-03_JPRB &
  &, 0.260423E-03_JPRB, 0.228314E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 231, :) = (/ &
  &  0.924809E+00_JPRB, 0.905631E+00_JPRB, 0.886326E+00_JPRB, 0.866911E+00_JPRB &
  &, 0.847396E+00_JPRB, 0.827795E+00_JPRB, 0.808122E+00_JPRB &
  &, 0.788392E+00_JPRB, 0.768618E+00_JPRB, 0.748816E+00_JPRB, 0.728999E+00_JPRB &
  &, 0.709183E+00_JPRB, 0.689383E+00_JPRB, 0.669613E+00_JPRB &
  &, 0.649891E+00_JPRB, 0.630232E+00_JPRB, 0.610653E+00_JPRB, 0.591168E+00_JPRB &
  &, 0.571796E+00_JPRB, 0.552553E+00_JPRB, 0.533458E+00_JPRB &
  &, 0.514523E+00_JPRB, 0.495769E+00_JPRB, 0.477214E+00_JPRB, 0.458874E+00_JPRB &
  &, 0.440768E+00_JPRB, 0.422912E+00_JPRB, 0.405319E+00_JPRB &
  &, 0.388013E+00_JPRB, 0.371006E+00_JPRB, 0.354320E+00_JPRB, 0.337963E+00_JPRB &
  &, 0.321950E+00_JPRB, 0.306303E+00_JPRB, 0.291029E+00_JPRB &
  &, 0.276147E+00_JPRB, 0.261660E+00_JPRB, 0.247583E+00_JPRB, 0.233935E+00_JPRB &
  &, 0.220717E+00_JPRB, 0.207927E+00_JPRB, 0.195594E+00_JPRB &
  &, 0.183703E+00_JPRB, 0.172261E+00_JPRB, 0.161280E+00_JPRB, 0.150752E+00_JPRB &
  &, 0.140687E+00_JPRB, 0.131069E+00_JPRB, 0.121917E+00_JPRB &
  &, 0.113197E+00_JPRB, 0.104921E+00_JPRB, 0.970876E-01_JPRB, 0.896786E-01_JPRB &
  &, 0.826850E-01_JPRB, 0.761096E-01_JPRB, 0.699232E-01_JPRB &
  &, 0.641219E-01_JPRB, 0.586839E-01_JPRB, 0.536153E-01_JPRB, 0.488879E-01_JPRB &
  &, 0.445025E-01_JPRB, 0.404411E-01_JPRB, 0.366643E-01_JPRB &
  &, 0.331820E-01_JPRB, 0.299666E-01_JPRB, 0.270241E-01_JPRB, 0.243019E-01_JPRB &
  &, 0.218403E-01_JPRB, 0.195607E-01_JPRB, 0.175006E-01_JPRB &
  &, 0.156152E-01_JPRB, 0.139198E-01_JPRB, 0.123860E-01_JPRB, 0.109823E-01_JPRB &
  &, 0.971964E-02_JPRB, 0.860942E-02_JPRB, 0.759171E-02_JPRB &
  &, 0.667414E-02_JPRB, 0.586456E-02_JPRB, 0.514573E-02_JPRB, 0.449866E-02_JPRB &
  &, 0.392878E-02_JPRB, 0.341489E-02_JPRB, 0.298851E-02_JPRB &
  &, 0.257195E-02_JPRB, 0.222323E-02_JPRB, 0.191794E-02_JPRB, 0.165907E-02_JPRB &
  &, 0.141967E-02_JPRB, 0.123178E-02_JPRB, 0.106746E-02_JPRB &
  &, 0.896619E-03_JPRB, 0.751386E-03_JPRB, 0.666187E-03_JPRB, 0.544248E-03_JPRB &
  &, 0.451709E-03_JPRB, 0.390278E-03_JPRB, 0.326527E-03_JPRB &
  &, 0.260423E-03_JPRB, 0.228314E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART33',1,ZHOOK_HANDLE)
END SUBROUTINE PART33

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART34

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART34',0,ZHOOK_HANDLE)

XCW( 232, :) = (/ &
  &  0.925119E+00_JPRB, 0.906016E+00_JPRB, 0.886782E+00_JPRB, 0.867435E+00_JPRB &
  &, 0.847985E+00_JPRB, 0.828448E+00_JPRB, 0.808837E+00_JPRB &
  &, 0.789166E+00_JPRB, 0.769448E+00_JPRB, 0.749699E+00_JPRB, 0.729933E+00_JPRB &
  &, 0.710165E+00_JPRB, 0.690410E+00_JPRB, 0.670684E+00_JPRB &
  &, 0.651003E+00_JPRB, 0.631382E+00_JPRB, 0.611837E+00_JPRB, 0.592385E+00_JPRB &
  &, 0.573043E+00_JPRB, 0.553825E+00_JPRB, 0.534751E+00_JPRB &
  &, 0.515839E+00_JPRB, 0.497106E+00_JPRB, 0.478564E+00_JPRB, 0.460238E+00_JPRB &
  &, 0.442139E+00_JPRB, 0.424290E+00_JPRB, 0.406704E+00_JPRB &
  &, 0.389401E+00_JPRB, 0.372393E+00_JPRB, 0.355700E+00_JPRB, 0.339335E+00_JPRB &
  &, 0.323313E+00_JPRB, 0.307657E+00_JPRB, 0.292367E+00_JPRB &
  &, 0.277468E+00_JPRB, 0.262957E+00_JPRB, 0.248863E+00_JPRB, 0.235188E+00_JPRB &
  &, 0.221940E+00_JPRB, 0.209138E+00_JPRB, 0.196760E+00_JPRB &
  &, 0.184844E+00_JPRB, 0.173373E+00_JPRB, 0.162362E+00_JPRB, 0.151801E+00_JPRB &
  &, 0.141701E+00_JPRB, 0.132045E+00_JPRB, 0.122853E+00_JPRB &
  &, 0.114103E+00_JPRB, 0.105796E+00_JPRB, 0.979147E-01_JPRB, 0.904690E-01_JPRB &
  &, 0.834364E-01_JPRB, 0.768197E-01_JPRB, 0.705894E-01_JPRB &
  &, 0.647573E-01_JPRB, 0.592865E-01_JPRB, 0.541832E-01_JPRB, 0.494356E-01_JPRB &
  &, 0.450118E-01_JPRB, 0.409098E-01_JPRB, 0.371080E-01_JPRB &
  &, 0.335813E-01_JPRB, 0.303561E-01_JPRB, 0.273653E-01_JPRB, 0.246312E-01_JPRB &
  &, 0.221371E-01_JPRB, 0.198437E-01_JPRB, 0.177484E-01_JPRB &
  &, 0.158683E-01_JPRB, 0.141351E-01_JPRB, 0.125838E-01_JPRB, 0.111618E-01_JPRB &
  &, 0.987994E-02_JPRB, 0.874963E-02_JPRB, 0.771092E-02_JPRB &
  &, 0.679575E-02_JPRB, 0.596379E-02_JPRB, 0.524693E-02_JPRB, 0.457605E-02_JPRB &
  &, 0.400768E-02_JPRB, 0.349532E-02_JPRB, 0.304316E-02_JPRB &
  &, 0.262764E-02_JPRB, 0.227998E-02_JPRB, 0.197576E-02_JPRB, 0.171796E-02_JPRB &
  &, 0.147966E-02_JPRB, 0.126232E-02_JPRB, 0.106746E-02_JPRB &
  &, 0.928284E-03_JPRB, 0.783620E-03_JPRB, 0.666187E-03_JPRB, 0.577639E-03_JPRB &
  &, 0.485687E-03_JPRB, 0.390278E-03_JPRB, 0.326527E-03_JPRB &
  &, 0.296198E-03_JPRB, 0.228314E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.877781E-04_JPRB, 0.890596E-04_JPRB &
  &, 0.501765E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 233, :) = (/ &
  &  0.925433E+00_JPRB, 0.906401E+00_JPRB, 0.887237E+00_JPRB, 0.867957E+00_JPRB &
  &, 0.848574E+00_JPRB, 0.829100E+00_JPRB, 0.809550E+00_JPRB &
  &, 0.789937E+00_JPRB, 0.770275E+00_JPRB, 0.750580E+00_JPRB, 0.730865E+00_JPRB &
  &, 0.711145E+00_JPRB, 0.691438E+00_JPRB, 0.671755E+00_JPRB &
  &, 0.652114E+00_JPRB, 0.632531E+00_JPRB, 0.613020E+00_JPRB, 0.593602E+00_JPRB &
  &, 0.574288E+00_JPRB, 0.555097E+00_JPRB, 0.536048E+00_JPRB &
  &, 0.517156E+00_JPRB, 0.498442E+00_JPRB, 0.479918E+00_JPRB, 0.461602E+00_JPRB &
  &, 0.443514E+00_JPRB, 0.425672E+00_JPRB, 0.408090E+00_JPRB &
  &, 0.390785E+00_JPRB, 0.373775E+00_JPRB, 0.357080E+00_JPRB, 0.340708E+00_JPRB &
  &, 0.324677E+00_JPRB, 0.309006E+00_JPRB, 0.293706E+00_JPRB &
  &, 0.278788E+00_JPRB, 0.264263E+00_JPRB, 0.250144E+00_JPRB, 0.236451E+00_JPRB &
  &, 0.223019E+00_JPRB, 0.210340E+00_JPRB, 0.197949E+00_JPRB &
  &, 0.185996E+00_JPRB, 0.174497E+00_JPRB, 0.163444E+00_JPRB, 0.152851E+00_JPRB &
  &, 0.142715E+00_JPRB, 0.133034E+00_JPRB, 0.123790E+00_JPRB &
  &, 0.115010E+00_JPRB, 0.106657E+00_JPRB, 0.987417E-01_JPRB, 0.912594E-01_JPRB &
  &, 0.841879E-01_JPRB, 0.775299E-01_JPRB, 0.712708E-01_JPRB &
  &, 0.654082E-01_JPRB, 0.599049E-01_JPRB, 0.547673E-01_JPRB, 0.499667E-01_JPRB &
  &, 0.455210E-01_JPRB, 0.413785E-01_JPRB, 0.375518E-01_JPRB &
  &, 0.339986E-01_JPRB, 0.307271E-01_JPRB, 0.277255E-01_JPRB, 0.249605E-01_JPRB &
  &, 0.224340E-01_JPRB, 0.201268E-01_JPRB, 0.180168E-01_JPRB &
  &, 0.161002E-01_JPRB, 0.143504E-01_JPRB, 0.127816E-01_JPRB, 0.113413E-01_JPRB &
  &, 0.100631E-01_JPRB, 0.888984E-02_JPRB, 0.785397E-02_JPRB &
  &, 0.691735E-02_JPRB, 0.608782E-02_JPRB, 0.534813E-02_JPRB, 0.467924E-02_JPRB &
  &, 0.408658E-02_JPRB, 0.357575E-02_JPRB, 0.309781E-02_JPRB &
  &, 0.268334E-02_JPRB, 0.233673E-02_JPRB, 0.203358E-02_JPRB, 0.174741E-02_JPRB &
  &, 0.150965E-02_JPRB, 0.129286E-02_JPRB, 0.109856E-02_JPRB &
  &, 0.959949E-03_JPRB, 0.815855E-03_JPRB, 0.698997E-03_JPRB, 0.577639E-03_JPRB &
  &, 0.485687E-03_JPRB, 0.424848E-03_JPRB, 0.361697E-03_JPRB &
  &, 0.296198E-03_JPRB, 0.228314E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 234, :) = (/ &
  &  0.925744E+00_JPRB, 0.906783E+00_JPRB, 0.887690E+00_JPRB, 0.868479E+00_JPRB &
  &, 0.849161E+00_JPRB, 0.829751E+00_JPRB, 0.810261E+00_JPRB &
  &, 0.790707E+00_JPRB, 0.771102E+00_JPRB, 0.751460E+00_JPRB, 0.731796E+00_JPRB &
  &, 0.712126E+00_JPRB, 0.692463E+00_JPRB, 0.672823E+00_JPRB &
  &, 0.653222E+00_JPRB, 0.633677E+00_JPRB, 0.614202E+00_JPRB, 0.594815E+00_JPRB &
  &, 0.575532E+00_JPRB, 0.556369E+00_JPRB, 0.537342E+00_JPRB &
  &, 0.518472E+00_JPRB, 0.499775E+00_JPRB, 0.481268E+00_JPRB, 0.462963E+00_JPRB &
  &, 0.444886E+00_JPRB, 0.427051E+00_JPRB, 0.409471E+00_JPRB &
  &, 0.392169E+00_JPRB, 0.375162E+00_JPRB, 0.358460E+00_JPRB, 0.342084E+00_JPRB &
  &, 0.326045E+00_JPRB, 0.310360E+00_JPRB, 0.295044E+00_JPRB &
  &, 0.280109E+00_JPRB, 0.265570E+00_JPRB, 0.251435E+00_JPRB, 0.237714E+00_JPRB &
  &, 0.224417E+00_JPRB, 0.211552E+00_JPRB, 0.199126E+00_JPRB &
  &, 0.187147E+00_JPRB, 0.175609E+00_JPRB, 0.164538E+00_JPRB, 0.153912E+00_JPRB &
  &, 0.143729E+00_JPRB, 0.134011E+00_JPRB, 0.124739E+00_JPRB &
  &, 0.115916E+00_JPRB, 0.107532E+00_JPRB, 0.995825E-01_JPRB, 0.920639E-01_JPRB &
  &, 0.849538E-01_JPRB, 0.782548E-01_JPRB, 0.719674E-01_JPRB &
  &, 0.660436E-01_JPRB, 0.605234E-01_JPRB, 0.553351E-01_JPRB, 0.505144E-01_JPRB &
  &, 0.460303E-01_JPRB, 0.418646E-01_JPRB, 0.379955E-01_JPRB &
  &, 0.344160E-01_JPRB, 0.311166E-01_JPRB, 0.280857E-01_JPRB, 0.253092E-01_JPRB &
  &, 0.227507E-01_JPRB, 0.204098E-01_JPRB, 0.182853E-01_JPRB &
  &, 0.163322E-01_JPRB, 0.145657E-01_JPRB, 0.129795E-01_JPRB, 0.115208E-01_JPRB &
  &, 0.102234E-01_JPRB, 0.905341E-02_JPRB, 0.799702E-02_JPRB &
  &, 0.703896E-02_JPRB, 0.618705E-02_JPRB, 0.544932E-02_JPRB, 0.475663E-02_JPRB &
  &, 0.416549E-02_JPRB, 0.362937E-02_JPRB, 0.317979E-02_JPRB &
  &, 0.273903E-02_JPRB, 0.239348E-02_JPRB, 0.206249E-02_JPRB, 0.177686E-02_JPRB &
  &, 0.153965E-02_JPRB, 0.132341E-02_JPRB, 0.112966E-02_JPRB &
  &, 0.959949E-03_JPRB, 0.815855E-03_JPRB, 0.698997E-03_JPRB, 0.611029E-03_JPRB &
  &, 0.519664E-03_JPRB, 0.424848E-03_JPRB, 0.361697E-03_JPRB &
  &, 0.296198E-03_JPRB, 0.264700E-03_JPRB, 0.195013E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.124763E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 235, :) = (/ &
  &  0.926054E+00_JPRB, 0.907166E+00_JPRB, 0.888143E+00_JPRB, 0.869000E+00_JPRB &
  &, 0.849748E+00_JPRB, 0.830400E+00_JPRB, 0.810972E+00_JPRB &
  &, 0.791476E+00_JPRB, 0.771927E+00_JPRB, 0.752339E+00_JPRB, 0.732726E+00_JPRB &
  &, 0.713103E+00_JPRB, 0.693486E+00_JPRB, 0.673890E+00_JPRB &
  &, 0.654330E+00_JPRB, 0.634823E+00_JPRB, 0.615384E+00_JPRB, 0.596028E+00_JPRB &
  &, 0.576775E+00_JPRB, 0.557638E+00_JPRB, 0.538636E+00_JPRB &
  &, 0.519788E+00_JPRB, 0.501107E+00_JPRB, 0.482614E+00_JPRB, 0.464327E+00_JPRB &
  &, 0.446261E+00_JPRB, 0.428429E+00_JPRB, 0.410856E+00_JPRB &
  &, 0.393558E+00_JPRB, 0.376544E+00_JPRB, 0.359840E+00_JPRB, 0.343456E+00_JPRB &
  &, 0.327409E+00_JPRB, 0.311713E+00_JPRB, 0.296386E+00_JPRB &
  &, 0.281430E+00_JPRB, 0.266876E+00_JPRB, 0.252716E+00_JPRB, 0.238978E+00_JPRB &
  &, 0.225650E+00_JPRB, 0.212764E+00_JPRB, 0.200304E+00_JPRB &
  &, 0.188299E+00_JPRB, 0.176733E+00_JPRB, 0.165620E+00_JPRB, 0.154961E+00_JPRB &
  &, 0.144756E+00_JPRB, 0.135000E+00_JPRB, 0.125688E+00_JPRB &
  &, 0.116823E+00_JPRB, 0.108407E+00_JPRB, 0.100423E+00_JPRB, 0.928543E-01_JPRB &
  &, 0.857197E-01_JPRB, 0.789796E-01_JPRB, 0.726488E-01_JPRB &
  &, 0.667099E-01_JPRB, 0.611260E-01_JPRB, 0.559192E-01_JPRB, 0.510621E-01_JPRB &
  &, 0.465396E-01_JPRB, 0.423333E-01_JPRB, 0.384393E-01_JPRB &
  &, 0.348334E-01_JPRB, 0.315061E-01_JPRB, 0.284459E-01_JPRB, 0.256385E-01_JPRB &
  &, 0.230673E-01_JPRB, 0.206929E-01_JPRB, 0.185331E-01_JPRB &
  &, 0.165853E-01_JPRB, 0.148026E-01_JPRB, 0.131773E-01_JPRB, 0.117227E-01_JPRB &
  &, 0.103837E-01_JPRB, 0.919362E-02_JPRB, 0.814007E-02_JPRB &
  &, 0.716057E-02_JPRB, 0.631109E-02_JPRB, 0.555052E-02_JPRB, 0.485981E-02_JPRB &
  &, 0.424439E-02_JPRB, 0.370980E-02_JPRB, 0.323444E-02_JPRB &
  &, 0.282258E-02_JPRB, 0.245023E-02_JPRB, 0.212030E-02_JPRB, 0.183576E-02_JPRB &
  &, 0.156964E-02_JPRB, 0.135395E-02_JPRB, 0.116076E-02_JPRB &
  &, 0.991614E-03_JPRB, 0.848089E-03_JPRB, 0.731806E-03_JPRB, 0.611029E-03_JPRB &
  &, 0.519664E-03_JPRB, 0.424848E-03_JPRB, 0.361697E-03_JPRB &
  &, 0.296198E-03_JPRB, 0.264700E-03_JPRB, 0.232015E-03_JPRB, 0.160502E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 236, :) = (/ &
  &  0.926364E+00_JPRB, 0.907549E+00_JPRB, 0.888595E+00_JPRB, 0.869520E+00_JPRB &
  &, 0.850333E+00_JPRB, 0.831049E+00_JPRB, 0.811681E+00_JPRB &
  &, 0.792244E+00_JPRB, 0.772750E+00_JPRB, 0.753216E+00_JPRB, 0.733654E+00_JPRB &
  &, 0.714080E+00_JPRB, 0.694509E+00_JPRB, 0.674956E+00_JPRB &
  &, 0.655437E+00_JPRB, 0.635967E+00_JPRB, 0.616562E+00_JPRB, 0.597240E+00_JPRB &
  &, 0.578016E+00_JPRB, 0.558907E+00_JPRB, 0.539930E+00_JPRB &
  &, 0.521104E+00_JPRB, 0.502440E+00_JPRB, 0.483964E+00_JPRB, 0.465688E+00_JPRB &
  &, 0.447632E+00_JPRB, 0.429811E+00_JPRB, 0.412242E+00_JPRB &
  &, 0.394942E+00_JPRB, 0.377930E+00_JPRB, 0.361224E+00_JPRB, 0.344833E+00_JPRB &
  &, 0.328777E+00_JPRB, 0.313072E+00_JPRB, 0.297729E+00_JPRB &
  &, 0.282760E+00_JPRB, 0.268183E+00_JPRB, 0.254007E+00_JPRB, 0.240241E+00_JPRB &
  &, 0.226894E+00_JPRB, 0.213975E+00_JPRB, 0.201492E+00_JPRB &
  &, 0.189451E+00_JPRB, 0.177857E+00_JPRB, 0.166714E+00_JPRB, 0.156022E+00_JPRB &
  &, 0.145782E+00_JPRB, 0.135989E+00_JPRB, 0.126650E+00_JPRB &
  &, 0.117743E+00_JPRB, 0.109281E+00_JPRB, 0.101264E+00_JPRB, 0.936588E-01_JPRB &
  &, 0.864856E-01_JPRB, 0.797193E-01_JPRB, 0.733454E-01_JPRB &
  &, 0.673608E-01_JPRB, 0.617603E-01_JPRB, 0.565033E-01_JPRB, 0.516098E-01_JPRB &
  &, 0.470658E-01_JPRB, 0.428194E-01_JPRB, 0.389008E-01_JPRB &
  &, 0.352689E-01_JPRB, 0.319142E-01_JPRB, 0.288250E-01_JPRB, 0.259678E-01_JPRB &
  &, 0.233642E-01_JPRB, 0.209962E-01_JPRB, 0.188015E-01_JPRB &
  &, 0.168172E-01_JPRB, 0.150179E-01_JPRB, 0.133752E-01_JPRB, 0.119022E-01_JPRB &
  &, 0.105669E-01_JPRB, 0.935720E-02_JPRB, 0.825928E-02_JPRB &
  &, 0.730650E-02_JPRB, 0.643513E-02_JPRB, 0.565172E-02_JPRB, 0.493720E-02_JPRB &
  &, 0.432329E-02_JPRB, 0.379023E-02_JPRB, 0.328909E-02_JPRB &
  &, 0.287827E-02_JPRB, 0.247861E-02_JPRB, 0.214921E-02_JPRB, 0.186520E-02_JPRB &
  &, 0.159963E-02_JPRB, 0.138450E-02_JPRB, 0.119186E-02_JPRB &
  &, 0.102328E-02_JPRB, 0.880323E-03_JPRB, 0.731806E-03_JPRB, 0.644420E-03_JPRB &
  &, 0.519664E-03_JPRB, 0.459419E-03_JPRB, 0.396867E-03_JPRB &
  &, 0.331972E-03_JPRB, 0.264700E-03_JPRB, 0.232015E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 237, :) = (/ &
  &  0.926673E+00_JPRB, 0.907930E+00_JPRB, 0.889046E+00_JPRB, 0.870038E+00_JPRB &
  &, 0.850917E+00_JPRB, 0.831696E+00_JPRB, 0.812389E+00_JPRB &
  &, 0.793010E+00_JPRB, 0.773573E+00_JPRB, 0.754092E+00_JPRB, 0.734581E+00_JPRB &
  &, 0.715054E+00_JPRB, 0.695530E+00_JPRB, 0.676020E+00_JPRB &
  &, 0.656542E+00_JPRB, 0.637110E+00_JPRB, 0.617741E+00_JPRB, 0.598451E+00_JPRB &
  &, 0.579257E+00_JPRB, 0.560176E+00_JPRB, 0.541223E+00_JPRB &
  &, 0.522417E+00_JPRB, 0.503773E+00_JPRB, 0.485314E+00_JPRB, 0.467052E+00_JPRB &
  &, 0.449003E+00_JPRB, 0.431189E+00_JPRB, 0.413627E+00_JPRB &
  &, 0.396330E+00_JPRB, 0.379317E+00_JPRB, 0.362604E+00_JPRB, 0.346209E+00_JPRB &
  &, 0.330145E+00_JPRB, 0.314430E+00_JPRB, 0.299071E+00_JPRB &
  &, 0.284090E+00_JPRB, 0.269489E+00_JPRB, 0.255297E+00_JPRB, 0.241504E+00_JPRB &
  &, 0.228138E+00_JPRB, 0.215198E+00_JPRB, 0.202681E+00_JPRB &
  &, 0.190614E+00_JPRB, 0.178992E+00_JPRB, 0.167807E+00_JPRB, 0.157084E+00_JPRB &
  &, 0.146808E+00_JPRB, 0.136978E+00_JPRB, 0.127599E+00_JPRB &
  &, 0.118663E+00_JPRB, 0.110170E+00_JPRB, 0.102105E+00_JPRB, 0.944775E-01_JPRB &
  &, 0.872515E-01_JPRB, 0.804442E-01_JPRB, 0.740419E-01_JPRB &
  &, 0.680272E-01_JPRB, 0.623788E-01_JPRB, 0.571036E-01_JPRB, 0.521741E-01_JPRB &
  &, 0.475751E-01_JPRB, 0.433055E-01_JPRB, 0.393623E-01_JPRB &
  &, 0.356863E-01_JPRB, 0.323037E-01_JPRB, 0.291852E-01_JPRB, 0.263165E-01_JPRB &
  &, 0.236809E-01_JPRB, 0.212792E-01_JPRB, 0.190700E-01_JPRB &
  &, 0.170703E-01_JPRB, 0.152548E-01_JPRB, 0.135950E-01_JPRB, 0.120817E-01_JPRB &
  &, 0.107272E-01_JPRB, 0.952077E-02_JPRB, 0.840233E-02_JPRB &
  &, 0.742811E-02_JPRB, 0.653436E-02_JPRB, 0.575291E-02_JPRB, 0.504039E-02_JPRB &
  &, 0.442849E-02_JPRB, 0.387066E-02_JPRB, 0.337107E-02_JPRB &
  &, 0.293396E-02_JPRB, 0.253536E-02_JPRB, 0.220703E-02_JPRB, 0.189465E-02_JPRB &
  &, 0.162962E-02_JPRB, 0.141504E-02_JPRB, 0.122297E-02_JPRB &
  &, 0.105494E-02_JPRB, 0.880323E-03_JPRB, 0.764615E-03_JPRB, 0.644420E-03_JPRB &
  &, 0.553642E-03_JPRB, 0.459419E-03_JPRB, 0.396867E-03_JPRB &
  &, 0.331972E-03_JPRB, 0.264700E-03_JPRB, 0.232015E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 238, :) = (/ &
  &  0.926982E+00_JPRB, 0.908310E+00_JPRB, 0.889496E+00_JPRB, 0.870556E+00_JPRB &
  &, 0.851500E+00_JPRB, 0.832342E+00_JPRB, 0.813095E+00_JPRB &
  &, 0.793775E+00_JPRB, 0.774394E+00_JPRB, 0.754965E+00_JPRB, 0.735506E+00_JPRB &
  &, 0.716029E+00_JPRB, 0.696550E+00_JPRB, 0.677084E+00_JPRB &
  &, 0.657646E+00_JPRB, 0.638252E+00_JPRB, 0.618918E+00_JPRB, 0.599661E+00_JPRB &
  &, 0.580497E+00_JPRB, 0.561442E+00_JPRB, 0.542514E+00_JPRB &
  &, 0.523730E+00_JPRB, 0.505106E+00_JPRB, 0.486661E+00_JPRB, 0.468412E+00_JPRB &
  &, 0.450374E+00_JPRB, 0.432568E+00_JPRB, 0.415008E+00_JPRB &
  &, 0.397718E+00_JPRB, 0.380703E+00_JPRB, 0.363988E+00_JPRB, 0.347586E+00_JPRB &
  &, 0.331517E+00_JPRB, 0.315788E+00_JPRB, 0.300419E+00_JPRB &
  &, 0.285420E+00_JPRB, 0.270806E+00_JPRB, 0.256588E+00_JPRB, 0.242777E+00_JPRB &
  &, 0.229382E+00_JPRB, 0.216410E+00_JPRB, 0.203880E+00_JPRB &
  &, 0.191777E+00_JPRB, 0.180116E+00_JPRB, 0.168913E+00_JPRB, 0.158145E+00_JPRB &
  &, 0.147835E+00_JPRB, 0.137980E+00_JPRB, 0.128561E+00_JPRB &
  &, 0.119582E+00_JPRB, 0.111058E+00_JPRB, 0.102959E+00_JPRB, 0.952820E-01_JPRB &
  &, 0.880319E-01_JPRB, 0.811839E-01_JPRB, 0.747385E-01_JPRB &
  &, 0.686781E-01_JPRB, 0.630131E-01_JPRB, 0.576877E-01_JPRB, 0.527218E-01_JPRB &
  &, 0.481013E-01_JPRB, 0.438089E-01_JPRB, 0.398061E-01_JPRB &
  &, 0.361218E-01_JPRB, 0.327118E-01_JPRB, 0.295644E-01_JPRB, 0.266652E-01_JPRB &
  &, 0.240173E-01_JPRB, 0.215825E-01_JPRB, 0.193591E-01_JPRB &
  &, 0.173233E-01_JPRB, 0.154701E-01_JPRB, 0.137928E-01_JPRB, 0.122837E-01_JPRB &
  &, 0.109104E-01_JPRB, 0.966098E-02_JPRB, 0.854538E-02_JPRB &
  &, 0.754972E-02_JPRB, 0.665839E-02_JPRB, 0.585411E-02_JPRB, 0.514358E-02_JPRB &
  &, 0.450739E-02_JPRB, 0.392428E-02_JPRB, 0.342572E-02_JPRB &
  &, 0.298966E-02_JPRB, 0.259211E-02_JPRB, 0.226484E-02_JPRB, 0.195355E-02_JPRB &
  &, 0.168961E-02_JPRB, 0.144559E-02_JPRB, 0.125407E-02_JPRB &
  &, 0.105494E-02_JPRB, 0.912557E-03_JPRB, 0.764615E-03_JPRB, 0.677810E-03_JPRB &
  &, 0.553642E-03_JPRB, 0.459419E-03_JPRB, 0.396867E-03_JPRB &
  &, 0.331972E-03_JPRB, 0.264700E-03_JPRB, 0.232015E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.890596E-04_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART34',1,ZHOOK_HANDLE)
END SUBROUTINE PART34

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART35

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART35',0,ZHOOK_HANDLE)

XCW( 239, :) = (/ &
  &  0.927289E+00_JPRB, 0.908689E+00_JPRB, 0.889945E+00_JPRB, 0.871073E+00_JPRB &
  &, 0.852082E+00_JPRB, 0.832987E+00_JPRB, 0.813801E+00_JPRB &
  &, 0.794539E+00_JPRB, 0.775213E+00_JPRB, 0.755839E+00_JPRB, 0.736430E+00_JPRB &
  &, 0.717002E+00_JPRB, 0.697568E+00_JPRB, 0.678145E+00_JPRB &
  &, 0.658749E+00_JPRB, 0.639393E+00_JPRB, 0.620094E+00_JPRB, 0.600870E+00_JPRB &
  &, 0.581736E+00_JPRB, 0.562708E+00_JPRB, 0.543804E+00_JPRB &
  &, 0.525043E+00_JPRB, 0.506439E+00_JPRB, 0.488007E+00_JPRB, 0.469773E+00_JPRB &
  &, 0.451746E+00_JPRB, 0.433950E+00_JPRB, 0.416394E+00_JPRB &
  &, 0.399102E+00_JPRB, 0.382090E+00_JPRB, 0.365372E+00_JPRB, 0.348967E+00_JPRB &
  &, 0.332885E+00_JPRB, 0.317146E+00_JPRB, 0.301761E+00_JPRB &
  &, 0.286750E+00_JPRB, 0.272112E+00_JPRB, 0.257879E+00_JPRB, 0.244051E+00_JPRB &
  &, 0.230625E+00_JPRB, 0.217632E+00_JPRB, 0.205068E+00_JPRB &
  &, 0.192939E+00_JPRB, 0.181251E+00_JPRB, 0.170018E+00_JPRB, 0.159218E+00_JPRB &
  &, 0.148873E+00_JPRB, 0.138981E+00_JPRB, 0.129523E+00_JPRB &
  &, 0.120515E+00_JPRB, 0.111946E+00_JPRB, 0.103814E+00_JPRB, 0.961006E-01_JPRB &
  &, 0.888122E-01_JPRB, 0.819236E-01_JPRB, 0.754502E-01_JPRB &
  &, 0.693600E-01_JPRB, 0.636315E-01_JPRB, 0.582880E-01_JPRB, 0.532861E-01_JPRB &
  &, 0.486275E-01_JPRB, 0.442950E-01_JPRB, 0.402853E-01_JPRB &
  &, 0.365573E-01_JPRB, 0.331199E-01_JPRB, 0.299435E-01_JPRB, 0.270139E-01_JPRB &
  &, 0.243340E-01_JPRB, 0.218655E-01_JPRB, 0.196275E-01_JPRB &
  &, 0.175764E-01_JPRB, 0.157070E-01_JPRB, 0.140127E-01_JPRB, 0.124632E-01_JPRB &
  &, 0.110936E-01_JPRB, 0.982456E-02_JPRB, 0.871227E-02_JPRB &
  &, 0.769565E-02_JPRB, 0.678243E-02_JPRB, 0.595531E-02_JPRB, 0.524677E-02_JPRB &
  &, 0.458629E-02_JPRB, 0.400471E-02_JPRB, 0.350769E-02_JPRB &
  &, 0.304535E-02_JPRB, 0.264886E-02_JPRB, 0.229375E-02_JPRB, 0.198299E-02_JPRB &
  &, 0.171960E-02_JPRB, 0.147613E-02_JPRB, 0.128517E-02_JPRB &
  &, 0.108661E-02_JPRB, 0.944791E-03_JPRB, 0.797425E-03_JPRB, 0.677810E-03_JPRB &
  &, 0.587619E-03_JPRB, 0.493990E-03_JPRB, 0.396867E-03_JPRB &
  &, 0.331972E-03_JPRB, 0.301085E-03_JPRB, 0.232015E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.508292E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 240, :) = (/ &
  &  0.927595E+00_JPRB, 0.909068E+00_JPRB, 0.890394E+00_JPRB, 0.871588E+00_JPRB &
  &, 0.852662E+00_JPRB, 0.833630E+00_JPRB, 0.814505E+00_JPRB &
  &, 0.795301E+00_JPRB, 0.776031E+00_JPRB, 0.756710E+00_JPRB, 0.737353E+00_JPRB &
  &, 0.717972E+00_JPRB, 0.698586E+00_JPRB, 0.679206E+00_JPRB &
  &, 0.659849E+00_JPRB, 0.640531E+00_JPRB, 0.621270E+00_JPRB, 0.602078E+00_JPRB &
  &, 0.582974E+00_JPRB, 0.563974E+00_JPRB, 0.545095E+00_JPRB &
  &, 0.526353E+00_JPRB, 0.507768E+00_JPRB, 0.489354E+00_JPRB, 0.471134E+00_JPRB &
  &, 0.453117E+00_JPRB, 0.435328E+00_JPRB, 0.417779E+00_JPRB &
  &, 0.400490E+00_JPRB, 0.383476E+00_JPRB, 0.366755E+00_JPRB, 0.350343E+00_JPRB &
  &, 0.334257E+00_JPRB, 0.318505E+00_JPRB, 0.303113E+00_JPRB &
  &, 0.288080E+00_JPRB, 0.273428E+00_JPRB, 0.259179E+00_JPRB, 0.245324E+00_JPRB &
  &, 0.231879E+00_JPRB, 0.218855E+00_JPRB, 0.206267E+00_JPRB &
  &, 0.194113E+00_JPRB, 0.182386E+00_JPRB, 0.171123E+00_JPRB, 0.160291E+00_JPRB &
  &, 0.149912E+00_JPRB, 0.139983E+00_JPRB, 0.130485E+00_JPRB &
  &, 0.121448E+00_JPRB, 0.112834E+00_JPRB, 0.104669E+00_JPRB, 0.969193E-01_JPRB &
  &, 0.895926E-01_JPRB, 0.826781E-01_JPRB, 0.761467E-01_JPRB &
  &, 0.700263E-01_JPRB, 0.642817E-01_JPRB, 0.588883E-01_JPRB, 0.538504E-01_JPRB &
  &, 0.491707E-01_JPRB, 0.447984E-01_JPRB, 0.407468E-01_JPRB &
  &, 0.369928E-01_JPRB, 0.335094E-01_JPRB, 0.303226E-01_JPRB, 0.273626E-01_JPRB &
  &, 0.246507E-01_JPRB, 0.221688E-01_JPRB, 0.198960E-01_JPRB &
  &, 0.178295E-01_JPRB, 0.159438E-01_JPRB, 0.142325E-01_JPRB, 0.126651E-01_JPRB &
  &, 0.112539E-01_JPRB, 0.998813E-02_JPRB, 0.885533E-02_JPRB &
  &, 0.781726E-02_JPRB, 0.690647E-02_JPRB, 0.608180E-02_JPRB, 0.532416E-02_JPRB &
  &, 0.466520E-02_JPRB, 0.408514E-02_JPRB, 0.356235E-02_JPRB &
  &, 0.310105E-02_JPRB, 0.270560E-02_JPRB, 0.235157E-02_JPRB, 0.204189E-02_JPRB &
  &, 0.174960E-02_JPRB, 0.150668E-02_JPRB, 0.131627E-02_JPRB &
  &, 0.111827E-02_JPRB, 0.944791E-03_JPRB, 0.830234E-03_JPRB, 0.711201E-03_JPRB &
  &, 0.587619E-03_JPRB, 0.493990E-03_JPRB, 0.432037E-03_JPRB &
  &, 0.367747E-03_JPRB, 0.301085E-03_JPRB, 0.232015E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 241, :) = (/ &
  &  0.927903E+00_JPRB, 0.909446E+00_JPRB, 0.890841E+00_JPRB, 0.872103E+00_JPRB &
  &, 0.853242E+00_JPRB, 0.834273E+00_JPRB, 0.815209E+00_JPRB &
  &, 0.796062E+00_JPRB, 0.776848E+00_JPRB, 0.757581E+00_JPRB, 0.738275E+00_JPRB &
  &, 0.718942E+00_JPRB, 0.699601E+00_JPRB, 0.680264E+00_JPRB &
  &, 0.660949E+00_JPRB, 0.641670E+00_JPRB, 0.622442E+00_JPRB, 0.603284E+00_JPRB &
  &, 0.584210E+00_JPRB, 0.565236E+00_JPRB, 0.546382E+00_JPRB &
  &, 0.527666E+00_JPRB, 0.509098E+00_JPRB, 0.490701E+00_JPRB, 0.472494E+00_JPRB &
  &, 0.454488E+00_JPRB, 0.436707E+00_JPRB, 0.419164E+00_JPRB &
  &, 0.401878E+00_JPRB, 0.384866E+00_JPRB, 0.368140E+00_JPRB, 0.351724E+00_JPRB &
  &, 0.335629E+00_JPRB, 0.319867E+00_JPRB, 0.304460E+00_JPRB &
  &, 0.289411E+00_JPRB, 0.274744E+00_JPRB, 0.260470E+00_JPRB, 0.246597E+00_JPRB &
  &, 0.233133E+00_JPRB, 0.220087E+00_JPRB, 0.207466E+00_JPRB &
  &, 0.195276E+00_JPRB, 0.183533E+00_JPRB, 0.172229E+00_JPRB, 0.161364E+00_JPRB &
  &, 0.150951E+00_JPRB, 0.140985E+00_JPRB, 0.131460E+00_JPRB &
  &, 0.122381E+00_JPRB, 0.113736E+00_JPRB, 0.105523E+00_JPRB, 0.977379E-01_JPRB &
  &, 0.903730E-01_JPRB, 0.834178E-01_JPRB, 0.768584E-01_JPRB &
  &, 0.707082E-01_JPRB, 0.649160E-01_JPRB, 0.594886E-01_JPRB, 0.544313E-01_JPRB &
  &, 0.496970E-01_JPRB, 0.453018E-01_JPRB, 0.412261E-01_JPRB &
  &, 0.374283E-01_JPRB, 0.339360E-01_JPRB, 0.307018E-01_JPRB, 0.277112E-01_JPRB &
  &, 0.249871E-01_JPRB, 0.224721E-01_JPRB, 0.201851E-01_JPRB &
  &, 0.180825E-01_JPRB, 0.161807E-01_JPRB, 0.144523E-01_JPRB, 0.128671E-01_JPRB &
  &, 0.114371E-01_JPRB, 0.101517E-01_JPRB, 0.899838E-02_JPRB &
  &, 0.796319E-02_JPRB, 0.703051E-02_JPRB, 0.618300E-02_JPRB, 0.542734E-02_JPRB &
  &, 0.477040E-02_JPRB, 0.416557E-02_JPRB, 0.364432E-02_JPRB &
  &, 0.318459E-02_JPRB, 0.276235E-02_JPRB, 0.240938E-02_JPRB, 0.207134E-02_JPRB &
  &, 0.180958E-02_JPRB, 0.153722E-02_JPRB, 0.134737E-02_JPRB &
  &, 0.114994E-02_JPRB, 0.977025E-03_JPRB, 0.830234E-03_JPRB, 0.711201E-03_JPRB &
  &, 0.621597E-03_JPRB, 0.528560E-03_JPRB, 0.432037E-03_JPRB &
  &, 0.367747E-03_JPRB, 0.301085E-03_JPRB, 0.269018E-03_JPRB, 0.198127E-03_JPRB &
  &, 0.163017E-03_JPRB, 0.126667E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 242, :) = (/ &
  &  0.928209E+00_JPRB, 0.909824E+00_JPRB, 0.891288E+00_JPRB, 0.872617E+00_JPRB &
  &, 0.853821E+00_JPRB, 0.834915E+00_JPRB, 0.815910E+00_JPRB &
  &, 0.796822E+00_JPRB, 0.777664E+00_JPRB, 0.758450E+00_JPRB, 0.739195E+00_JPRB &
  &, 0.719911E+00_JPRB, 0.700616E+00_JPRB, 0.681323E+00_JPRB &
  &, 0.662048E+00_JPRB, 0.642806E+00_JPRB, 0.623615E+00_JPRB, 0.604490E+00_JPRB &
  &, 0.585446E+00_JPRB, 0.566499E+00_JPRB, 0.547673E+00_JPRB &
  &, 0.528975E+00_JPRB, 0.510427E+00_JPRB, 0.492047E+00_JPRB, 0.473855E+00_JPRB &
  &, 0.455860E+00_JPRB, 0.438085E+00_JPRB, 0.420550E+00_JPRB &
  &, 0.403266E+00_JPRB, 0.386253E+00_JPRB, 0.369528E+00_JPRB, 0.353105E+00_JPRB &
  &, 0.337002E+00_JPRB, 0.321230E+00_JPRB, 0.305812E+00_JPRB &
  &, 0.290750E+00_JPRB, 0.276070E+00_JPRB, 0.261771E+00_JPRB, 0.247870E+00_JPRB &
  &, 0.234387E+00_JPRB, 0.221310E+00_JPRB, 0.208666E+00_JPRB &
  &, 0.196450E+00_JPRB, 0.184679E+00_JPRB, 0.173334E+00_JPRB, 0.162449E+00_JPRB &
  &, 0.152001E+00_JPRB, 0.141999E+00_JPRB, 0.132435E+00_JPRB &
  &, 0.123314E+00_JPRB, 0.114638E+00_JPRB, 0.106392E+00_JPRB, 0.985707E-01_JPRB &
  &, 0.911678E-01_JPRB, 0.841723E-01_JPRB, 0.775853E-01_JPRB &
  &, 0.713746E-01_JPRB, 0.655503E-01_JPRB, 0.601051E-01_JPRB, 0.549955E-01_JPRB &
  &, 0.502402E-01_JPRB, 0.458053E-01_JPRB, 0.416876E-01_JPRB &
  &, 0.378820E-01_JPRB, 0.343441E-01_JPRB, 0.310809E-01_JPRB, 0.280793E-01_JPRB &
  &, 0.253236E-01_JPRB, 0.227753E-01_JPRB, 0.204742E-01_JPRB &
  &, 0.183567E-01_JPRB, 0.164175E-01_JPRB, 0.146721E-01_JPRB, 0.130690E-01_JPRB &
  &, 0.116203E-01_JPRB, 0.103153E-01_JPRB, 0.914143E-02_JPRB &
  &, 0.808479E-02_JPRB, 0.715454E-02_JPRB, 0.628420E-02_JPRB, 0.553053E-02_JPRB &
  &, 0.484930E-02_JPRB, 0.424601E-02_JPRB, 0.372630E-02_JPRB &
  &, 0.324028E-02_JPRB, 0.281910E-02_JPRB, 0.243829E-02_JPRB, 0.213023E-02_JPRB &
  &, 0.183958E-02_JPRB, 0.159831E-02_JPRB, 0.137847E-02_JPRB &
  &, 0.118160E-02_JPRB, 0.100926E-02_JPRB, 0.863044E-03_JPRB, 0.744591E-03_JPRB &
  &, 0.621597E-03_JPRB, 0.528560E-03_JPRB, 0.432037E-03_JPRB &
  &, 0.367747E-03_JPRB, 0.301085E-03_JPRB, 0.269018E-03_JPRB, 0.235753E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 243, :) = (/ &
  &  0.928514E+00_JPRB, 0.910200E+00_JPRB, 0.891734E+00_JPRB, 0.873130E+00_JPRB &
  &, 0.854398E+00_JPRB, 0.835555E+00_JPRB, 0.816611E+00_JPRB &
  &, 0.797581E+00_JPRB, 0.778479E+00_JPRB, 0.759318E+00_JPRB, 0.740113E+00_JPRB &
  &, 0.720878E+00_JPRB, 0.701628E+00_JPRB, 0.682380E+00_JPRB &
  &, 0.663145E+00_JPRB, 0.643943E+00_JPRB, 0.624786E+00_JPRB, 0.605694E+00_JPRB &
  &, 0.586680E+00_JPRB, 0.567762E+00_JPRB, 0.548960E+00_JPRB &
  &, 0.530285E+00_JPRB, 0.511757E+00_JPRB, 0.493394E+00_JPRB, 0.475212E+00_JPRB &
  &, 0.457231E+00_JPRB, 0.439467E+00_JPRB, 0.421935E+00_JPRB &
  &, 0.404654E+00_JPRB, 0.387643E+00_JPRB, 0.370912E+00_JPRB, 0.354486E+00_JPRB &
  &, 0.338374E+00_JPRB, 0.322597E+00_JPRB, 0.307164E+00_JPRB &
  &, 0.292089E+00_JPRB, 0.277386E+00_JPRB, 0.263071E+00_JPRB, 0.249153E+00_JPRB &
  &, 0.235641E+00_JPRB, 0.222543E+00_JPRB, 0.209876E+00_JPRB &
  &, 0.197624E+00_JPRB, 0.185815E+00_JPRB, 0.174451E+00_JPRB, 0.163522E+00_JPRB &
  &, 0.153040E+00_JPRB, 0.143013E+00_JPRB, 0.133410E+00_JPRB &
  &, 0.124260E+00_JPRB, 0.115540E+00_JPRB, 0.107260E+00_JPRB, 0.994034E-01_JPRB &
  &, 0.919626E-01_JPRB, 0.849268E-01_JPRB, 0.782970E-01_JPRB &
  &, 0.720565E-01_JPRB, 0.662005E-01_JPRB, 0.607054E-01_JPRB, 0.555764E-01_JPRB &
  &, 0.507834E-01_JPRB, 0.463261E-01_JPRB, 0.421669E-01_JPRB &
  &, 0.383175E-01_JPRB, 0.347522E-01_JPRB, 0.314790E-01_JPRB, 0.284474E-01_JPRB &
  &, 0.256601E-01_JPRB, 0.230988E-01_JPRB, 0.207426E-01_JPRB &
  &, 0.186097E-01_JPRB, 0.166544E-01_JPRB, 0.148919E-01_JPRB, 0.132710E-01_JPRB &
  &, 0.118035E-01_JPRB, 0.105022E-01_JPRB, 0.930832E-02_JPRB &
  &, 0.823072E-02_JPRB, 0.727858E-02_JPRB, 0.641069E-02_JPRB, 0.563372E-02_JPRB &
  &, 0.495450E-02_JPRB, 0.432644E-02_JPRB, 0.378095E-02_JPRB &
  &, 0.329598E-02_JPRB, 0.287585E-02_JPRB, 0.249611E-02_JPRB, 0.215968E-02_JPRB &
  &, 0.186957E-02_JPRB, 0.162885E-02_JPRB, 0.140958E-02_JPRB &
  &, 0.121327E-02_JPRB, 0.104149E-02_JPRB, 0.895853E-03_JPRB, 0.744591E-03_JPRB &
  &, 0.655575E-03_JPRB, 0.528560E-03_JPRB, 0.467206E-03_JPRB &
  &, 0.403522E-03_JPRB, 0.337471E-03_JPRB, 0.269018E-03_JPRB, 0.235753E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 244, :) = (/ &
  &  0.928819E+00_JPRB, 0.910576E+00_JPRB, 0.892179E+00_JPRB, 0.873642E+00_JPRB &
  &, 0.854975E+00_JPRB, 0.836194E+00_JPRB, 0.817311E+00_JPRB &
  &, 0.798339E+00_JPRB, 0.779292E+00_JPRB, 0.760185E+00_JPRB, 0.741030E+00_JPRB &
  &, 0.721844E+00_JPRB, 0.702640E+00_JPRB, 0.683435E+00_JPRB &
  &, 0.664242E+00_JPRB, 0.645077E+00_JPRB, 0.625958E+00_JPRB, 0.606897E+00_JPRB &
  &, 0.587914E+00_JPRB, 0.569024E+00_JPRB, 0.550244E+00_JPRB &
  &, 0.531595E+00_JPRB, 0.513086E+00_JPRB, 0.494740E+00_JPRB, 0.476572E+00_JPRB &
  &, 0.458602E+00_JPRB, 0.440845E+00_JPRB, 0.423320E+00_JPRB &
  &, 0.406042E+00_JPRB, 0.389030E+00_JPRB, 0.372300E+00_JPRB, 0.355866E+00_JPRB &
  &, 0.339751E+00_JPRB, 0.323959E+00_JPRB, 0.308515E+00_JPRB &
  &, 0.293429E+00_JPRB, 0.278712E+00_JPRB, 0.264372E+00_JPRB, 0.250437E+00_JPRB &
  &, 0.236896E+00_JPRB, 0.223776E+00_JPRB, 0.211075E+00_JPRB &
  &, 0.198809E+00_JPRB, 0.186972E+00_JPRB, 0.175568E+00_JPRB, 0.164608E+00_JPRB &
  &, 0.154091E+00_JPRB, 0.144027E+00_JPRB, 0.134398E+00_JPRB &
  &, 0.125206E+00_JPRB, 0.116455E+00_JPRB, 0.108128E+00_JPRB, 0.100236E+00_JPRB &
  &, 0.927574E-01_JPRB, 0.856961E-01_JPRB, 0.790238E-01_JPRB &
  &, 0.727539E-01_JPRB, 0.668507E-01_JPRB, 0.613219E-01_JPRB, 0.561573E-01_JPRB &
  &, 0.513266E-01_JPRB, 0.468295E-01_JPRB, 0.426461E-01_JPRB &
  &, 0.387712E-01_JPRB, 0.351788E-01_JPRB, 0.318582E-01_JPRB, 0.287960E-01_JPRB &
  &, 0.259965E-01_JPRB, 0.234021E-01_JPRB, 0.210317E-01_JPRB &
  &, 0.188839E-01_JPRB, 0.169128E-01_JPRB, 0.151118E-01_JPRB, 0.134729E-01_JPRB &
  &, 0.120096E-01_JPRB, 0.106658E-01_JPRB, 0.945137E-02_JPRB &
  &, 0.837665E-02_JPRB, 0.740262E-02_JPRB, 0.651189E-02_JPRB, 0.573691E-02_JPRB &
  &, 0.503340E-02_JPRB, 0.440687E-02_JPRB, 0.386293E-02_JPRB &
  &, 0.337952E-02_JPRB, 0.293260E-02_JPRB, 0.255393E-02_JPRB, 0.221857E-02_JPRB &
  &, 0.192956E-02_JPRB, 0.165940E-02_JPRB, 0.144068E-02_JPRB &
  &, 0.124493E-02_JPRB, 0.104149E-02_JPRB, 0.895853E-03_JPRB, 0.777982E-03_JPRB &
  &, 0.655575E-03_JPRB, 0.563131E-03_JPRB, 0.467206E-03_JPRB &
  &, 0.403522E-03_JPRB, 0.337471E-03_JPRB, 0.269018E-03_JPRB, 0.235753E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.903530E-04_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 245, :) = (/ &
  &  0.929123E+00_JPRB, 0.910950E+00_JPRB, 0.892622E+00_JPRB, 0.874153E+00_JPRB &
  &, 0.855551E+00_JPRB, 0.836832E+00_JPRB, 0.818009E+00_JPRB &
  &, 0.799095E+00_JPRB, 0.780104E+00_JPRB, 0.761050E+00_JPRB, 0.741947E+00_JPRB &
  &, 0.722809E+00_JPRB, 0.703651E+00_JPRB, 0.684489E+00_JPRB &
  &, 0.665337E+00_JPRB, 0.646210E+00_JPRB, 0.627126E+00_JPRB, 0.608100E+00_JPRB &
  &, 0.589147E+00_JPRB, 0.570284E+00_JPRB, 0.551531E+00_JPRB &
  &, 0.532901E+00_JPRB, 0.514412E+00_JPRB, 0.496083E+00_JPRB, 0.477933E+00_JPRB &
  &, 0.459973E+00_JPRB, 0.442224E+00_JPRB, 0.424705E+00_JPRB &
  &, 0.407430E+00_JPRB, 0.390420E+00_JPRB, 0.373688E+00_JPRB, 0.357251E+00_JPRB &
  &, 0.341127E+00_JPRB, 0.325327E+00_JPRB, 0.309871E+00_JPRB &
  &, 0.294768E+00_JPRB, 0.280028E+00_JPRB, 0.265682E+00_JPRB, 0.251720E+00_JPRB &
  &, 0.238160E+00_JPRB, 0.225009E+00_JPRB, 0.212285E+00_JPRB &
  &, 0.199983E+00_JPRB, 0.188119E+00_JPRB, 0.176685E+00_JPRB, 0.165705E+00_JPRB &
  &, 0.155154E+00_JPRB, 0.145041E+00_JPRB, 0.135385E+00_JPRB &
  &, 0.126152E+00_JPRB, 0.117370E+00_JPRB, 0.109010E+00_JPRB, 0.101069E+00_JPRB &
  &, 0.935522E-01_JPRB, 0.864506E-01_JPRB, 0.797507E-01_JPRB &
  &, 0.734357E-01_JPRB, 0.675167E-01_JPRB, 0.619547E-01_JPRB, 0.567382E-01_JPRB &
  &, 0.518868E-01_JPRB, 0.473503E-01_JPRB, 0.431431E-01_JPRB &
  &, 0.392249E-01_JPRB, 0.356054E-01_JPRB, 0.322563E-01_JPRB, 0.291641E-01_JPRB &
  &, 0.263330E-01_JPRB, 0.237256E-01_JPRB, 0.213208E-01_JPRB &
  &, 0.191369E-01_JPRB, 0.171496E-01_JPRB, 0.153316E-01_JPRB, 0.136748E-01_JPRB &
  &, 0.121929E-01_JPRB, 0.108294E-01_JPRB, 0.961827E-02_JPRB &
  &, 0.852258E-02_JPRB, 0.752666E-02_JPRB, 0.663839E-02_JPRB, 0.584010E-02_JPRB &
  &, 0.513860E-02_JPRB, 0.451411E-02_JPRB, 0.394491E-02_JPRB &
  &, 0.343522E-02_JPRB, 0.298935E-02_JPRB, 0.261174E-02_JPRB, 0.227747E-02_JPRB &
  &, 0.195955E-02_JPRB, 0.168994E-02_JPRB, 0.147178E-02_JPRB &
  &, 0.127660E-02_JPRB, 0.107373E-02_JPRB, 0.928662E-03_JPRB, 0.777982E-03_JPRB &
  &, 0.689552E-03_JPRB, 0.563131E-03_JPRB, 0.502376E-03_JPRB &
  &, 0.403522E-03_JPRB, 0.337471E-03_JPRB, 0.306020E-03_JPRB, 0.235753E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.514878E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART35',1,ZHOOK_HANDLE)
END SUBROUTINE PART35

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART36

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART36',0,ZHOOK_HANDLE)

XCW( 246, :) = (/ &
  &  0.929426E+00_JPRB, 0.911325E+00_JPRB, 0.893066E+00_JPRB, 0.874663E+00_JPRB &
  &, 0.856126E+00_JPRB, 0.837469E+00_JPRB, 0.818706E+00_JPRB &
  &, 0.799850E+00_JPRB, 0.780915E+00_JPRB, 0.761914E+00_JPRB, 0.742862E+00_JPRB &
  &, 0.723772E+00_JPRB, 0.704660E+00_JPRB, 0.685542E+00_JPRB &
  &, 0.666431E+00_JPRB, 0.647343E+00_JPRB, 0.628294E+00_JPRB, 0.609301E+00_JPRB &
  &, 0.590380E+00_JPRB, 0.571546E+00_JPRB, 0.552815E+00_JPRB &
  &, 0.534207E+00_JPRB, 0.515742E+00_JPRB, 0.497430E+00_JPRB, 0.479290E+00_JPRB &
  &, 0.461345E+00_JPRB, 0.443606E+00_JPRB, 0.426091E+00_JPRB &
  &, 0.408822E+00_JPRB, 0.391810E+00_JPRB, 0.375076E+00_JPRB, 0.358636E+00_JPRB &
  &, 0.342504E+00_JPRB, 0.326694E+00_JPRB, 0.311228E+00_JPRB &
  &, 0.296107E+00_JPRB, 0.281353E+00_JPRB, 0.266982E+00_JPRB, 0.253003E+00_JPRB &
  &, 0.239424E+00_JPRB, 0.226252E+00_JPRB, 0.213495E+00_JPRB &
  &, 0.201168E+00_JPRB, 0.189277E+00_JPRB, 0.177813E+00_JPRB, 0.166790E+00_JPRB &
  &, 0.156205E+00_JPRB, 0.146068E+00_JPRB, 0.136373E+00_JPRB &
  &, 0.127112E+00_JPRB, 0.118285E+00_JPRB, 0.109879E+00_JPRB, 0.101916E+00_JPRB &
  &, 0.943615E-01_JPRB, 0.872198E-01_JPRB, 0.804775E-01_JPRB &
  &, 0.741331E-01_JPRB, 0.681669E-01_JPRB, 0.625712E-01_JPRB, 0.573357E-01_JPRB &
  &, 0.524300E-01_JPRB, 0.478711E-01_JPRB, 0.436224E-01_JPRB &
  &, 0.396785E-01_JPRB, 0.360321E-01_JPRB, 0.326544E-01_JPRB, 0.295322E-01_JPRB &
  &, 0.266694E-01_JPRB, 0.240491E-01_JPRB, 0.216306E-01_JPRB &
  &, 0.194111E-01_JPRB, 0.174080E-01_JPRB, 0.155734E-01_JPRB, 0.138992E-01_JPRB &
  &, 0.123761E-01_JPRB, 0.110163E-01_JPRB, 0.978516E-02_JPRB &
  &, 0.866851E-02_JPRB, 0.765069E-02_JPRB, 0.676488E-02_JPRB, 0.594328E-02_JPRB &
  &, 0.524381E-02_JPRB, 0.459454E-02_JPRB, 0.402688E-02_JPRB &
  &, 0.351876E-02_JPRB, 0.307448E-02_JPRB, 0.266956E-02_JPRB, 0.230692E-02_JPRB &
  &, 0.201953E-02_JPRB, 0.175103E-02_JPRB, 0.150288E-02_JPRB &
  &, 0.127660E-02_JPRB, 0.110596E-02_JPRB, 0.961472E-03_JPRB, 0.811372E-03_JPRB &
  &, 0.689552E-03_JPRB, 0.597702E-03_JPRB, 0.502376E-03_JPRB &
  &, 0.439296E-03_JPRB, 0.373856E-03_JPRB, 0.306020E-03_JPRB, 0.235753E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 247, :) = (/ &
  &  0.929728E+00_JPRB, 0.911699E+00_JPRB, 0.893508E+00_JPRB, 0.875171E+00_JPRB &
  &, 0.856699E+00_JPRB, 0.838105E+00_JPRB, 0.819403E+00_JPRB &
  &, 0.800604E+00_JPRB, 0.781725E+00_JPRB, 0.762777E+00_JPRB, 0.743776E+00_JPRB &
  &, 0.724734E+00_JPRB, 0.705669E+00_JPRB, 0.686593E+00_JPRB &
  &, 0.667523E+00_JPRB, 0.648475E+00_JPRB, 0.629462E+00_JPRB, 0.610502E+00_JPRB &
  &, 0.591610E+00_JPRB, 0.572803E+00_JPRB, 0.554099E+00_JPRB &
  &, 0.535517E+00_JPRB, 0.517068E+00_JPRB, 0.498773E+00_JPRB, 0.480651E+00_JPRB &
  &, 0.462712E+00_JPRB, 0.444984E+00_JPRB, 0.427476E+00_JPRB &
  &, 0.410210E+00_JPRB, 0.393201E+00_JPRB, 0.376464E+00_JPRB, 0.360021E+00_JPRB &
  &, 0.343880E+00_JPRB, 0.328065E+00_JPRB, 0.312584E+00_JPRB &
  &, 0.297447E+00_JPRB, 0.282688E+00_JPRB, 0.268293E+00_JPRB, 0.254297E+00_JPRB &
  &, 0.240688E+00_JPRB, 0.227496E+00_JPRB, 0.214715E+00_JPRB &
  &, 0.202353E+00_JPRB, 0.190435E+00_JPRB, 0.178942E+00_JPRB, 0.167887E+00_JPRB &
  &, 0.157268E+00_JPRB, 0.147094E+00_JPRB, 0.137361E+00_JPRB &
  &, 0.128058E+00_JPRB, 0.119200E+00_JPRB, 0.110775E+00_JPRB, 0.102763E+00_JPRB &
  &, 0.951707E-01_JPRB, 0.879891E-01_JPRB, 0.812195E-01_JPRB &
  &, 0.748305E-01_JPRB, 0.688329E-01_JPRB, 0.632039E-01_JPRB, 0.579166E-01_JPRB &
  &, 0.529902E-01_JPRB, 0.483919E-01_JPRB, 0.441194E-01_JPRB &
  &, 0.401503E-01_JPRB, 0.364587E-01_JPRB, 0.330525E-01_JPRB, 0.299196E-01_JPRB &
  &, 0.270257E-01_JPRB, 0.243523E-01_JPRB, 0.219197E-01_JPRB &
  &, 0.196852E-01_JPRB, 0.176448E-01_JPRB, 0.157932E-01_JPRB, 0.141012E-01_JPRB &
  &, 0.125822E-01_JPRB, 0.111799E-01_JPRB, 0.992821E-02_JPRB &
  &, 0.881444E-02_JPRB, 0.779954E-02_JPRB, 0.686608E-02_JPRB, 0.607227E-02_JPRB &
  &, 0.532271E-02_JPRB, 0.467497E-02_JPRB, 0.410886E-02_JPRB &
  &, 0.357445E-02_JPRB, 0.313123E-02_JPRB, 0.272737E-02_JPRB, 0.236581E-02_JPRB &
  &, 0.204953E-02_JPRB, 0.178157E-02_JPRB, 0.153398E-02_JPRB &
  &, 0.130826E-02_JPRB, 0.113820E-02_JPRB, 0.961472E-03_JPRB, 0.844763E-03_JPRB &
  &, 0.723530E-03_JPRB, 0.597702E-03_JPRB, 0.502376E-03_JPRB &
  &, 0.439296E-03_JPRB, 0.373856E-03_JPRB, 0.306020E-03_JPRB, 0.273378E-03_JPRB &
  &, 0.201271E-03_JPRB, 0.165556E-03_JPRB, 0.128589E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 248, :) = (/ &
  &  0.930031E+00_JPRB, 0.912071E+00_JPRB, 0.893950E+00_JPRB, 0.875680E+00_JPRB &
  &, 0.857271E+00_JPRB, 0.838740E+00_JPRB, 0.820098E+00_JPRB &
  &, 0.801358E+00_JPRB, 0.782533E+00_JPRB, 0.763639E+00_JPRB, 0.744688E+00_JPRB &
  &, 0.725696E+00_JPRB, 0.706677E+00_JPRB, 0.687643E+00_JPRB &
  &, 0.668615E+00_JPRB, 0.649604E+00_JPRB, 0.630628E+00_JPRB, 0.611700E+00_JPRB &
  &, 0.592841E+00_JPRB, 0.574062E+00_JPRB, 0.555383E+00_JPRB &
  &, 0.536823E+00_JPRB, 0.518394E+00_JPRB, 0.500116E+00_JPRB, 0.482008E+00_JPRB &
  &, 0.464084E+00_JPRB, 0.446363E+00_JPRB, 0.428861E+00_JPRB &
  &, 0.411599E+00_JPRB, 0.394591E+00_JPRB, 0.377856E+00_JPRB, 0.361406E+00_JPRB &
  &, 0.345261E+00_JPRB, 0.329437E+00_JPRB, 0.313945E+00_JPRB &
  &, 0.298795E+00_JPRB, 0.284014E+00_JPRB, 0.269603E+00_JPRB, 0.255580E+00_JPRB &
  &, 0.241953E+00_JPRB, 0.228739E+00_JPRB, 0.215936E+00_JPRB &
  &, 0.203549E+00_JPRB, 0.191593E+00_JPRB, 0.180070E+00_JPRB, 0.168984E+00_JPRB &
  &, 0.158331E+00_JPRB, 0.148121E+00_JPRB, 0.138348E+00_JPRB &
  &, 0.129017E+00_JPRB, 0.120129E+00_JPRB, 0.111657E+00_JPRB, 0.103609E+00_JPRB &
  &, 0.959800E-01_JPRB, 0.887732E-01_JPRB, 0.819615E-01_JPRB &
  &, 0.755434E-01_JPRB, 0.694989E-01_JPRB, 0.638367E-01_JPRB, 0.585141E-01_JPRB &
  &, 0.535504E-01_JPRB, 0.489300E-01_JPRB, 0.446164E-01_JPRB &
  &, 0.406040E-01_JPRB, 0.369039E-01_JPRB, 0.334695E-01_JPRB, 0.302877E-01_JPRB &
  &, 0.273621E-01_JPRB, 0.246758E-01_JPRB, 0.222294E-01_JPRB &
  &, 0.199594E-01_JPRB, 0.179032E-01_JPRB, 0.160350E-01_JPRB, 0.143255E-01_JPRB &
  &, 0.127654E-01_JPRB, 0.113668E-01_JPRB, 0.100951E-01_JPRB &
  &, 0.896037E-02_JPRB, 0.792357E-02_JPRB, 0.699257E-02_JPRB, 0.617545E-02_JPRB &
  &, 0.542791E-02_JPRB, 0.475540E-02_JPRB, 0.419084E-02_JPRB &
  &, 0.365799E-02_JPRB, 0.318798E-02_JPRB, 0.278519E-02_JPRB, 0.242471E-02_JPRB &
  &, 0.210951E-02_JPRB, 0.181212E-02_JPRB, 0.156508E-02_JPRB &
  &, 0.133993E-02_JPRB, 0.117043E-02_JPRB, 0.994281E-03_JPRB, 0.844763E-03_JPRB &
  &, 0.723530E-03_JPRB, 0.632272E-03_JPRB, 0.537546E-03_JPRB &
  &, 0.439296E-03_JPRB, 0.373856E-03_JPRB, 0.306020E-03_JPRB, 0.273378E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.165556E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 249, :) = (/ &
  &  0.930332E+00_JPRB, 0.912445E+00_JPRB, 0.894391E+00_JPRB, 0.876187E+00_JPRB &
  &, 0.857844E+00_JPRB, 0.839374E+00_JPRB, 0.820791E+00_JPRB &
  &, 0.802109E+00_JPRB, 0.783340E+00_JPRB, 0.764499E+00_JPRB, 0.745600E+00_JPRB &
  &, 0.726656E+00_JPRB, 0.707682E+00_JPRB, 0.688693E+00_JPRB &
  &, 0.669706E+00_JPRB, 0.650734E+00_JPRB, 0.631793E+00_JPRB, 0.612900E+00_JPRB &
  &, 0.594069E+00_JPRB, 0.575318E+00_JPRB, 0.556667E+00_JPRB &
  &, 0.538130E+00_JPRB, 0.519720E+00_JPRB, 0.501459E+00_JPRB, 0.483365E+00_JPRB &
  &, 0.465455E+00_JPRB, 0.447745E+00_JPRB, 0.430250E+00_JPRB &
  &, 0.412991E+00_JPRB, 0.395986E+00_JPRB, 0.379244E+00_JPRB, 0.362791E+00_JPRB &
  &, 0.346642E+00_JPRB, 0.330808E+00_JPRB, 0.315301E+00_JPRB &
  &, 0.300144E+00_JPRB, 0.285349E+00_JPRB, 0.270913E+00_JPRB, 0.256873E+00_JPRB &
  &, 0.243227E+00_JPRB, 0.229983E+00_JPRB, 0.217146E+00_JPRB &
  &, 0.204745E+00_JPRB, 0.192750E+00_JPRB, 0.181199E+00_JPRB, 0.170081E+00_JPRB &
  &, 0.159406E+00_JPRB, 0.149160E+00_JPRB, 0.139349E+00_JPRB &
  &, 0.129989E+00_JPRB, 0.121044E+00_JPRB, 0.112539E+00_JPRB, 0.104470E+00_JPRB &
  &, 0.968037E-01_JPRB, 0.895573E-01_JPRB, 0.827035E-01_JPRB &
  &, 0.762407E-01_JPRB, 0.701649E-01_JPRB, 0.644694E-01_JPRB, 0.591116E-01_JPRB &
  &, 0.541276E-01_JPRB, 0.494508E-01_JPRB, 0.451134E-01_JPRB &
  &, 0.410758E-01_JPRB, 0.373305E-01_JPRB, 0.338676E-01_JPRB, 0.306751E-01_JPRB &
  &, 0.277184E-01_JPRB, 0.250195E-01_JPRB, 0.225185E-01_JPRB &
  &, 0.202546E-01_JPRB, 0.181616E-01_JPRB, 0.162548E-01_JPRB, 0.145275E-01_JPRB &
  &, 0.129715E-01_JPRB, 0.115538E-01_JPRB, 0.102620E-01_JPRB &
  &, 0.910630E-02_JPRB, 0.804761E-02_JPRB, 0.711907E-02_JPRB, 0.627864E-02_JPRB &
  &, 0.553311E-02_JPRB, 0.486264E-02_JPRB, 0.424549E-02_JPRB &
  &, 0.371369E-02_JPRB, 0.324473E-02_JPRB, 0.284301E-02_JPRB, 0.245416E-02_JPRB &
  &, 0.213951E-02_JPRB, 0.184266E-02_JPRB, 0.159619E-02_JPRB &
  &, 0.137159E-02_JPRB, 0.120266E-02_JPRB, 0.102709E-02_JPRB, 0.878153E-03_JPRB &
  &, 0.757508E-03_JPRB, 0.632272E-03_JPRB, 0.537546E-03_JPRB &
  &, 0.475071E-03_JPRB, 0.373856E-03_JPRB, 0.343023E-03_JPRB, 0.273378E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 250, :) = (/ &
  &  0.930633E+00_JPRB, 0.912815E+00_JPRB, 0.894831E+00_JPRB, 0.876693E+00_JPRB &
  &, 0.858414E+00_JPRB, 0.840007E+00_JPRB, 0.821484E+00_JPRB &
  &, 0.802859E+00_JPRB, 0.784146E+00_JPRB, 0.765359E+00_JPRB, 0.746509E+00_JPRB &
  &, 0.727614E+00_JPRB, 0.708686E+00_JPRB, 0.689742E+00_JPRB &
  &, 0.670796E+00_JPRB, 0.651862E+00_JPRB, 0.632957E+00_JPRB, 0.614097E+00_JPRB &
  &, 0.595299E+00_JPRB, 0.576578E+00_JPRB, 0.557948E+00_JPRB &
  &, 0.539433E+00_JPRB, 0.521046E+00_JPRB, 0.502802E+00_JPRB, 0.484725E+00_JPRB &
  &, 0.466823E+00_JPRB, 0.449123E+00_JPRB, 0.431636E+00_JPRB &
  &, 0.414383E+00_JPRB, 0.397376E+00_JPRB, 0.380636E+00_JPRB, 0.364180E+00_JPRB &
  &, 0.348023E+00_JPRB, 0.332180E+00_JPRB, 0.316666E+00_JPRB &
  &, 0.301493E+00_JPRB, 0.286675E+00_JPRB, 0.272233E+00_JPRB, 0.258166E+00_JPRB &
  &, 0.244502E+00_JPRB, 0.231226E+00_JPRB, 0.218378E+00_JPRB &
  &, 0.205930E+00_JPRB, 0.193920E+00_JPRB, 0.182339E+00_JPRB, 0.171190E+00_JPRB &
  &, 0.160469E+00_JPRB, 0.150199E+00_JPRB, 0.140349E+00_JPRB &
  &, 0.130948E+00_JPRB, 0.121986E+00_JPRB, 0.113435E+00_JPRB, 0.105317E+00_JPRB &
  &, 0.976274E-01_JPRB, 0.903413E-01_JPRB, 0.834455E-01_JPRB &
  &, 0.769536E-01_JPRB, 0.708468E-01_JPRB, 0.651022E-01_JPRB, 0.597257E-01_JPRB &
  &, 0.546877E-01_JPRB, 0.499890E-01_JPRB, 0.456104E-01_JPRB &
  &, 0.415476E-01_JPRB, 0.377757E-01_JPRB, 0.342847E-01_JPRB, 0.310625E-01_JPRB &
  &, 0.280747E-01_JPRB, 0.253430E-01_JPRB, 0.228283E-01_JPRB &
  &, 0.205287E-01_JPRB, 0.184200E-01_JPRB, 0.164966E-01_JPRB, 0.147519E-01_JPRB &
  &, 0.131776E-01_JPRB, 0.117407E-01_JPRB, 0.104289E-01_JPRB &
  &, 0.925223E-02_JPRB, 0.819646E-02_JPRB, 0.724557E-02_JPRB, 0.638183E-02_JPRB &
  &, 0.563831E-02_JPRB, 0.494307E-02_JPRB, 0.432747E-02_JPRB &
  &, 0.379723E-02_JPRB, 0.332985E-02_JPRB, 0.290082E-02_JPRB, 0.251305E-02_JPRB &
  &, 0.219949E-02_JPRB, 0.190375E-02_JPRB, 0.162729E-02_JPRB &
  &, 0.140326E-02_JPRB, 0.123490E-02_JPRB, 0.105990E-02_JPRB, 0.911544E-03_JPRB &
  &, 0.757508E-03_JPRB, 0.666843E-03_JPRB, 0.572715E-03_JPRB &
  &, 0.475071E-03_JPRB, 0.410242E-03_JPRB, 0.343023E-03_JPRB, 0.273378E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.916583E-04_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 251, :) = (/ &
  &  0.930935E+00_JPRB, 0.913186E+00_JPRB, 0.895270E+00_JPRB, 0.877199E+00_JPRB &
  &, 0.858984E+00_JPRB, 0.840639E+00_JPRB, 0.822176E+00_JPRB &
  &, 0.803609E+00_JPRB, 0.784951E+00_JPRB, 0.766217E+00_JPRB, 0.747419E+00_JPRB &
  &, 0.728572E+00_JPRB, 0.709690E+00_JPRB, 0.690789E+00_JPRB &
  &, 0.671884E+00_JPRB, 0.652988E+00_JPRB, 0.634120E+00_JPRB, 0.615294E+00_JPRB &
  &, 0.596526E+00_JPRB, 0.577831E+00_JPRB, 0.559232E+00_JPRB &
  &, 0.540739E+00_JPRB, 0.522372E+00_JPRB, 0.504145E+00_JPRB, 0.486082E+00_JPRB &
  &, 0.468194E+00_JPRB, 0.450501E+00_JPRB, 0.433009E+00_JPRB &
  &, 0.415759E+00_JPRB, 0.398770E+00_JPRB, 0.382029E+00_JPRB, 0.365569E+00_JPRB &
  &, 0.349404E+00_JPRB, 0.333551E+00_JPRB, 0.318027E+00_JPRB &
  &, 0.302842E+00_JPRB, 0.288010E+00_JPRB, 0.273553E+00_JPRB, 0.259470E+00_JPRB &
  &, 0.245776E+00_JPRB, 0.232480E+00_JPRB, 0.219599E+00_JPRB &
  &, 0.207137E+00_JPRB, 0.195089E+00_JPRB, 0.183479E+00_JPRB, 0.172298E+00_JPRB &
  &, 0.161544E+00_JPRB, 0.151238E+00_JPRB, 0.141363E+00_JPRB &
  &, 0.131921E+00_JPRB, 0.122915E+00_JPRB, 0.114331E+00_JPRB, 0.106178E+00_JPRB &
  &, 0.984512E-01_JPRB, 0.911254E-01_JPRB, 0.842026E-01_JPRB &
  &, 0.776665E-01_JPRB, 0.715129E-01_JPRB, 0.657512E-01_JPRB, 0.603232E-01_JPRB &
  &, 0.552649E-01_JPRB, 0.505271E-01_JPRB, 0.461252E-01_JPRB &
  &, 0.420194E-01_JPRB, 0.382208E-01_JPRB, 0.347018E-01_JPRB, 0.314499E-01_JPRB &
  &, 0.284309E-01_JPRB, 0.256665E-01_JPRB, 0.231380E-01_JPRB &
  &, 0.208029E-01_JPRB, 0.186784E-01_JPRB, 0.167384E-01_JPRB, 0.149763E-01_JPRB &
  &, 0.133837E-01_JPRB, 0.119277E-01_JPRB, 0.105958E-01_JPRB &
  &, 0.939816E-02_JPRB, 0.834530E-02_JPRB, 0.737206E-02_JPRB, 0.651081E-02_JPRB &
  &, 0.574352E-02_JPRB, 0.505031E-02_JPRB, 0.443677E-02_JPRB &
  &, 0.388077E-02_JPRB, 0.338660E-02_JPRB, 0.295864E-02_JPRB, 0.257195E-02_JPRB &
  &, 0.222949E-02_JPRB, 0.193430E-02_JPRB, 0.168949E-02_JPRB &
  &, 0.143492E-02_JPRB, 0.123490E-02_JPRB, 0.105990E-02_JPRB, 0.911544E-03_JPRB &
  &, 0.791485E-03_JPRB, 0.666843E-03_JPRB, 0.572715E-03_JPRB &
  &, 0.475071E-03_JPRB, 0.410242E-03_JPRB, 0.343023E-03_JPRB, 0.273378E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.521524E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 252, :) = (/ &
  &  0.931233E+00_JPRB, 0.913557E+00_JPRB, 0.895708E+00_JPRB, 0.877704E+00_JPRB &
  &, 0.859553E+00_JPRB, 0.841270E+00_JPRB, 0.822867E+00_JPRB &
  &, 0.804357E+00_JPRB, 0.785755E+00_JPRB, 0.767073E+00_JPRB, 0.748326E+00_JPRB &
  &, 0.729527E+00_JPRB, 0.710692E+00_JPRB, 0.691835E+00_JPRB &
  &, 0.672970E+00_JPRB, 0.654115E+00_JPRB, 0.635283E+00_JPRB, 0.616489E+00_JPRB &
  &, 0.597752E+00_JPRB, 0.579087E+00_JPRB, 0.560513E+00_JPRB &
  &, 0.542042E+00_JPRB, 0.523695E+00_JPRB, 0.505488E+00_JPRB, 0.487439E+00_JPRB &
  &, 0.469565E+00_JPRB, 0.451883E+00_JPRB, 0.434410E+00_JPRB &
  &, 0.417163E+00_JPRB, 0.400161E+00_JPRB, 0.383421E+00_JPRB, 0.366958E+00_JPRB &
  &, 0.350789E+00_JPRB, 0.334927E+00_JPRB, 0.319392E+00_JPRB &
  &, 0.304190E+00_JPRB, 0.289345E+00_JPRB, 0.274864E+00_JPRB, 0.260763E+00_JPRB &
  &, 0.247051E+00_JPRB, 0.233734E+00_JPRB, 0.220830E+00_JPRB &
  &, 0.208333E+00_JPRB, 0.196258E+00_JPRB, 0.184620E+00_JPRB, 0.173407E+00_JPRB &
  &, 0.162620E+00_JPRB, 0.152278E+00_JPRB, 0.142376E+00_JPRB &
  &, 0.132893E+00_JPRB, 0.123857E+00_JPRB, 0.115241E+00_JPRB, 0.107053E+00_JPRB &
  &, 0.992749E-01_JPRB, 0.919095E-01_JPRB, 0.849597E-01_JPRB &
  &, 0.783793E-01_JPRB, 0.721947E-01_JPRB, 0.663839E-01_JPRB, 0.609372E-01_JPRB &
  &, 0.558421E-01_JPRB, 0.510827E-01_JPRB, 0.466399E-01_JPRB &
  &, 0.425094E-01_JPRB, 0.386660E-01_JPRB, 0.351188E-01_JPRB, 0.318374E-01_JPRB &
  &, 0.288069E-01_JPRB, 0.260102E-01_JPRB, 0.234478E-01_JPRB &
  &, 0.210981E-01_JPRB, 0.189583E-01_JPRB, 0.169802E-01_JPRB, 0.152006E-01_JPRB &
  &, 0.135669E-01_JPRB, 0.121146E-01_JPRB, 0.107627E-01_JPRB &
  &, 0.956842E-02_JPRB, 0.846934E-02_JPRB, 0.749856E-02_JPRB, 0.661400E-02_JPRB &
  &, 0.584872E-02_JPRB, 0.513074E-02_JPRB, 0.451875E-02_JPRB &
  &, 0.396431E-02_JPRB, 0.344335E-02_JPRB, 0.301646E-02_JPRB, 0.263084E-02_JPRB &
  &, 0.228947E-02_JPRB, 0.199539E-02_JPRB, 0.172059E-02_JPRB &
  &, 0.146659E-02_JPRB, 0.126713E-02_JPRB, 0.109271E-02_JPRB, 0.944934E-03_JPRB &
  &, 0.791485E-03_JPRB, 0.701414E-03_JPRB, 0.572715E-03_JPRB &
  &, 0.510846E-03_JPRB, 0.410242E-03_JPRB, 0.343023E-03_JPRB, 0.311003E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART36',1,ZHOOK_HANDLE)
END SUBROUTINE PART36

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART37

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART37',0,ZHOOK_HANDLE)

XCW( 253, :) = (/ &
  &  0.931534E+00_JPRB, 0.913926E+00_JPRB, 0.896146E+00_JPRB, 0.878207E+00_JPRB &
  &, 0.860120E+00_JPRB, 0.841900E+00_JPRB, 0.823556E+00_JPRB &
  &, 0.805104E+00_JPRB, 0.786558E+00_JPRB, 0.767929E+00_JPRB, 0.749233E+00_JPRB &
  &, 0.730482E+00_JPRB, 0.711694E+00_JPRB, 0.692880E+00_JPRB &
  &, 0.674057E+00_JPRB, 0.655240E+00_JPRB, 0.636444E+00_JPRB, 0.617684E+00_JPRB &
  &, 0.598979E+00_JPRB, 0.580340E+00_JPRB, 0.561794E+00_JPRB &
  &, 0.543345E+00_JPRB, 0.525021E+00_JPRB, 0.506831E+00_JPRB, 0.488796E+00_JPRB &
  &, 0.470936E+00_JPRB, 0.453262E+00_JPRB, 0.435795E+00_JPRB &
  &, 0.418555E+00_JPRB, 0.401555E+00_JPRB, 0.384817E+00_JPRB, 0.368348E+00_JPRB &
  &, 0.352175E+00_JPRB, 0.336303E+00_JPRB, 0.320758E+00_JPRB &
  &, 0.305548E+00_JPRB, 0.290680E+00_JPRB, 0.276184E+00_JPRB, 0.262066E+00_JPRB &
  &, 0.248326E+00_JPRB, 0.234988E+00_JPRB, 0.222062E+00_JPRB &
  &, 0.209540E+00_JPRB, 0.197439E+00_JPRB, 0.185760E+00_JPRB, 0.174516E+00_JPRB &
  &, 0.163707E+00_JPRB, 0.153329E+00_JPRB, 0.143389E+00_JPRB &
  &, 0.133879E+00_JPRB, 0.124799E+00_JPRB, 0.116150E+00_JPRB, 0.107914E+00_JPRB &
  &, 0.100113E+00_JPRB, 0.927083E-01_JPRB, 0.857168E-01_JPRB &
  &, 0.791077E-01_JPRB, 0.728925E-01_JPRB, 0.670329E-01_JPRB, 0.615513E-01_JPRB &
  &, 0.564192E-01_JPRB, 0.516208E-01_JPRB, 0.471547E-01_JPRB &
  &, 0.429812E-01_JPRB, 0.391112E-01_JPRB, 0.355359E-01_JPRB, 0.322248E-01_JPRB &
  &, 0.291632E-01_JPRB, 0.263539E-01_JPRB, 0.237575E-01_JPRB &
  &, 0.213933E-01_JPRB, 0.192167E-01_JPRB, 0.172440E-01_JPRB, 0.154250E-01_JPRB &
  &, 0.137959E-01_JPRB, 0.123016E-01_JPRB, 0.109534E-01_JPRB &
  &, 0.971435E-02_JPRB, 0.861818E-02_JPRB, 0.762505E-02_JPRB, 0.674299E-02_JPRB &
  &, 0.595392E-02_JPRB, 0.523798E-02_JPRB, 0.460072E-02_JPRB &
  &, 0.402001E-02_JPRB, 0.352847E-02_JPRB, 0.307427E-02_JPRB, 0.268974E-02_JPRB &
  &, 0.231946E-02_JPRB, 0.202593E-02_JPRB, 0.175169E-02_JPRB &
  &, 0.152992E-02_JPRB, 0.129937E-02_JPRB, 0.112552E-02_JPRB, 0.978325E-03_JPRB &
  &, 0.825463E-03_JPRB, 0.701414E-03_JPRB, 0.607885E-03_JPRB &
  &, 0.510846E-03_JPRB, 0.446628E-03_JPRB, 0.380026E-03_JPRB, 0.311003E-03_JPRB &
  &, 0.239526E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.130529E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 254, :) = (/ &
  &  0.931833E+00_JPRB, 0.914285E+00_JPRB, 0.896582E+00_JPRB, 0.878710E+00_JPRB &
  &, 0.860687E+00_JPRB, 0.842528E+00_JPRB, 0.824245E+00_JPRB &
  &, 0.805850E+00_JPRB, 0.787359E+00_JPRB, 0.768784E+00_JPRB, 0.750138E+00_JPRB &
  &, 0.731436E+00_JPRB, 0.712693E+00_JPRB, 0.693923E+00_JPRB &
  &, 0.675142E+00_JPRB, 0.656363E+00_JPRB, 0.637603E+00_JPRB, 0.618878E+00_JPRB &
  &, 0.600204E+00_JPRB, 0.581597E+00_JPRB, 0.563071E+00_JPRB &
  &, 0.544648E+00_JPRB, 0.526344E+00_JPRB, 0.508171E+00_JPRB, 0.490153E+00_JPRB &
  &, 0.472304E+00_JPRB, 0.454644E+00_JPRB, 0.437184E+00_JPRB &
  &, 0.419919E+00_JPRB, 0.402950E+00_JPRB, 0.386209E+00_JPRB, 0.369741E+00_JPRB &
  &, 0.353560E+00_JPRB, 0.337683E+00_JPRB, 0.322123E+00_JPRB &
  &, 0.306897E+00_JPRB, 0.292025E+00_JPRB, 0.277513E+00_JPRB, 0.263370E+00_JPRB &
  &, 0.249610E+00_JPRB, 0.236253E+00_JPRB, 0.223293E+00_JPRB &
  &, 0.210747E+00_JPRB, 0.198619E+00_JPRB, 0.186912E+00_JPRB, 0.175637E+00_JPRB &
  &, 0.164795E+00_JPRB, 0.154381E+00_JPRB, 0.144403E+00_JPRB &
  &, 0.134851E+00_JPRB, 0.125741E+00_JPRB, 0.117060E+00_JPRB, 0.108789E+00_JPRB &
  &, 0.100937E+00_JPRB, 0.935072E-01_JPRB, 0.864740E-01_JPRB &
  &, 0.798361E-01_JPRB, 0.735744E-01_JPRB, 0.676981E-01_JPRB, 0.621820E-01_JPRB &
  &, 0.570134E-01_JPRB, 0.521763E-01_JPRB, 0.476694E-01_JPRB &
  &, 0.434712E-01_JPRB, 0.395749E-01_JPRB, 0.359719E-01_JPRB, 0.326122E-01_JPRB &
  &, 0.295392E-01_JPRB, 0.266976E-01_JPRB, 0.240879E-01_JPRB &
  &, 0.216886E-01_JPRB, 0.194966E-01_JPRB, 0.174858E-01_JPRB, 0.156494E-01_JPRB &
  &, 0.140020E-01_JPRB, 0.124885E-01_JPRB, 0.111203E-01_JPRB &
  &, 0.988460E-02_JPRB, 0.876703E-02_JPRB, 0.775155E-02_JPRB, 0.687197E-02_JPRB &
  &, 0.605912E-02_JPRB, 0.531841E-02_JPRB, 0.468270E-02_JPRB &
  &, 0.410355E-02_JPRB, 0.358522E-02_JPRB, 0.313209E-02_JPRB, 0.274863E-02_JPRB &
  &, 0.237945E-02_JPRB, 0.205647E-02_JPRB, 0.178280E-02_JPRB &
  &, 0.156158E-02_JPRB, 0.133160E-02_JPRB, 0.115833E-02_JPRB, 0.978325E-03_JPRB &
  &, 0.859440E-03_JPRB, 0.735984E-03_JPRB, 0.607885E-03_JPRB &
  &, 0.510846E-03_JPRB, 0.446628E-03_JPRB, 0.380026E-03_JPRB, 0.311003E-03_JPRB &
  &, 0.277780E-03_JPRB, 0.204445E-03_JPRB, 0.168119E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 255, :) = (/ &
  &  0.932132E+00_JPRB, 0.914664E+00_JPRB, 0.897019E+00_JPRB, 0.879212E+00_JPRB &
  &, 0.861253E+00_JPRB, 0.843156E+00_JPRB, 0.824932E+00_JPRB &
  &, 0.806596E+00_JPRB, 0.788159E+00_JPRB, 0.769637E+00_JPRB, 0.751043E+00_JPRB &
  &, 0.732390E+00_JPRB, 0.713692E+00_JPRB, 0.694966E+00_JPRB &
  &, 0.676226E+00_JPRB, 0.657485E+00_JPRB, 0.638762E+00_JPRB, 0.620072E+00_JPRB &
  &, 0.601428E+00_JPRB, 0.582850E+00_JPRB, 0.564352E+00_JPRB &
  &, 0.545951E+00_JPRB, 0.527666E+00_JPRB, 0.509514E+00_JPRB, 0.491510E+00_JPRB &
  &, 0.473675E+00_JPRB, 0.456022E+00_JPRB, 0.438573E+00_JPRB &
  &, 0.421342E+00_JPRB, 0.404348E+00_JPRB, 0.387606E+00_JPRB, 0.371130E+00_JPRB &
  &, 0.354945E+00_JPRB, 0.339064E+00_JPRB, 0.323493E+00_JPRB &
  &, 0.308255E+00_JPRB, 0.293369E+00_JPRB, 0.278833E+00_JPRB, 0.264673E+00_JPRB &
  &, 0.250895E+00_JPRB, 0.237507E+00_JPRB, 0.224525E+00_JPRB &
  &, 0.211954E+00_JPRB, 0.199800E+00_JPRB, 0.188064E+00_JPRB, 0.176758E+00_JPRB &
  &, 0.165882E+00_JPRB, 0.155433E+00_JPRB, 0.145416E+00_JPRB &
  &, 0.135836E+00_JPRB, 0.126683E+00_JPRB, 0.117970E+00_JPRB, 0.109665E+00_JPRB &
  &, 0.101789E+00_JPRB, 0.943061E-01_JPRB, 0.872462E-01_JPRB &
  &, 0.805644E-01_JPRB, 0.742721E-01_JPRB, 0.683471E-01_JPRB, 0.627961E-01_JPRB &
  &, 0.575905E-01_JPRB, 0.527318E-01_JPRB, 0.481842E-01_JPRB &
  &, 0.439611E-01_JPRB, 0.400386E-01_JPRB, 0.363890E-01_JPRB, 0.330190E-01_JPRB &
  &, 0.299153E-01_JPRB, 0.270413E-01_JPRB, 0.243977E-01_JPRB &
  &, 0.219838E-01_JPRB, 0.197550E-01_JPRB, 0.177276E-01_JPRB, 0.158962E-01_JPRB &
  &, 0.142081E-01_JPRB, 0.126755E-01_JPRB, 0.112872E-01_JPRB &
  &, 0.100548E-01_JPRB, 0.891587E-02_JPRB, 0.790334E-02_JPRB, 0.697516E-02_JPRB &
  &, 0.616433E-02_JPRB, 0.542565E-02_JPRB, 0.476468E-02_JPRB &
  &, 0.418709E-02_JPRB, 0.367035E-02_JPRB, 0.318991E-02_JPRB, 0.280753E-02_JPRB &
  &, 0.243944E-02_JPRB, 0.211756E-02_JPRB, 0.184500E-02_JPRB &
  &, 0.159325E-02_JPRB, 0.136384E-02_JPRB, 0.119114E-02_JPRB, 0.101172E-02_JPRB &
  &, 0.859440E-03_JPRB, 0.735984E-03_JPRB, 0.643055E-03_JPRB &
  &, 0.546620E-03_JPRB, 0.446628E-03_JPRB, 0.380026E-03_JPRB, 0.311003E-03_JPRB &
  &, 0.277780E-03_JPRB, 0.243334E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 256, :) = (/ &
  &  0.932428E+00_JPRB, 0.915031E+00_JPRB, 0.897455E+00_JPRB, 0.879714E+00_JPRB &
  &, 0.861818E+00_JPRB, 0.843783E+00_JPRB, 0.825619E+00_JPRB &
  &, 0.807339E+00_JPRB, 0.788959E+00_JPRB, 0.770490E+00_JPRB, 0.751945E+00_JPRB &
  &, 0.733342E+00_JPRB, 0.714690E+00_JPRB, 0.696008E+00_JPRB &
  &, 0.677308E+00_JPRB, 0.658608E+00_JPRB, 0.639920E+00_JPRB, 0.621262E+00_JPRB &
  &, 0.602651E+00_JPRB, 0.584100E+00_JPRB, 0.565630E+00_JPRB &
  &, 0.547254E+00_JPRB, 0.528989E+00_JPRB, 0.510850E+00_JPRB, 0.492867E+00_JPRB &
  &, 0.475043E+00_JPRB, 0.457404E+00_JPRB, 0.439962E+00_JPRB &
  &, 0.422734E+00_JPRB, 0.405742E+00_JPRB, 0.389002E+00_JPRB, 0.372524E+00_JPRB &
  &, 0.356335E+00_JPRB, 0.340439E+00_JPRB, 0.324863E+00_JPRB &
  &, 0.309613E+00_JPRB, 0.294705E+00_JPRB, 0.280163E+00_JPRB, 0.265976E+00_JPRB &
  &, 0.252180E+00_JPRB, 0.238772E+00_JPRB, 0.225767E+00_JPRB &
  &, 0.213162E+00_JPRB, 0.200980E+00_JPRB, 0.189215E+00_JPRB, 0.177879E+00_JPRB &
  &, 0.166970E+00_JPRB, 0.156484E+00_JPRB, 0.146442E+00_JPRB &
  &, 0.136822E+00_JPRB, 0.127639E+00_JPRB, 0.118879E+00_JPRB, 0.110540E+00_JPRB &
  &, 0.102628E+00_JPRB, 0.951197E-01_JPRB, 0.880034E-01_JPRB &
  &, 0.812928E-01_JPRB, 0.749699E-01_JPRB, 0.690123E-01_JPRB, 0.634268E-01_JPRB &
  &, 0.581847E-01_JPRB, 0.532874E-01_JPRB, 0.487167E-01_JPRB &
  &, 0.444511E-01_JPRB, 0.405024E-01_JPRB, 0.368250E-01_JPRB, 0.334258E-01_JPRB &
  &, 0.302913E-01_JPRB, 0.273850E-01_JPRB, 0.247281E-01_JPRB &
  &, 0.222791E-01_JPRB, 0.200349E-01_JPRB, 0.179914E-01_JPRB, 0.161206E-01_JPRB &
  &, 0.144142E-01_JPRB, 0.128858E-01_JPRB, 0.114779E-01_JPRB &
  &, 0.102008E-01_JPRB, 0.906472E-02_JPRB, 0.802984E-02_JPRB, 0.710414E-02_JPRB &
  &, 0.626953E-02_JPRB, 0.553289E-02_JPRB, 0.487398E-02_JPRB &
  &, 0.427063E-02_JPRB, 0.372710E-02_JPRB, 0.327663E-02_JPRB, 0.286642E-02_JPRB &
  &, 0.249942E-02_JPRB, 0.214811E-02_JPRB, 0.187610E-02_JPRB &
  &, 0.162491E-02_JPRB, 0.139607E-02_JPRB, 0.119114E-02_JPRB, 0.104511E-02_JPRB &
  &, 0.893418E-03_JPRB, 0.770555E-03_JPRB, 0.643055E-03_JPRB &
  &, 0.546620E-03_JPRB, 0.483013E-03_JPRB, 0.380026E-03_JPRB, 0.348629E-03_JPRB &
  &, 0.277780E-03_JPRB, 0.243334E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 257, :) = (/ &
  &  0.932726E+00_JPRB, 0.915397E+00_JPRB, 0.897889E+00_JPRB, 0.880214E+00_JPRB &
  &, 0.862383E+00_JPRB, 0.844409E+00_JPRB, 0.826304E+00_JPRB &
  &, 0.808083E+00_JPRB, 0.789757E+00_JPRB, 0.771341E+00_JPRB, 0.752848E+00_JPRB &
  &, 0.734292E+00_JPRB, 0.715687E+00_JPRB, 0.697048E+00_JPRB &
  &, 0.678390E+00_JPRB, 0.659728E+00_JPRB, 0.641078E+00_JPRB, 0.622455E+00_JPRB &
  &, 0.603875E+00_JPRB, 0.585353E+00_JPRB, 0.566907E+00_JPRB &
  &, 0.548553E+00_JPRB, 0.530312E+00_JPRB, 0.512197E+00_JPRB, 0.494224E+00_JPRB &
  &, 0.476414E+00_JPRB, 0.458783E+00_JPRB, 0.441348E+00_JPRB &
  &, 0.424126E+00_JPRB, 0.407137E+00_JPRB, 0.390398E+00_JPRB, 0.373921E+00_JPRB &
  &, 0.357724E+00_JPRB, 0.341824E+00_JPRB, 0.326237E+00_JPRB &
  &, 0.310971E+00_JPRB, 0.296049E+00_JPRB, 0.281493E+00_JPRB, 0.267290E+00_JPRB &
  &, 0.253475E+00_JPRB, 0.240036E+00_JPRB, 0.227010E+00_JPRB &
  &, 0.214380E+00_JPRB, 0.202161E+00_JPRB, 0.190367E+00_JPRB, 0.179000E+00_JPRB &
  &, 0.168057E+00_JPRB, 0.157549E+00_JPRB, 0.147468E+00_JPRB &
  &, 0.137821E+00_JPRB, 0.128595E+00_JPRB, 0.119803E+00_JPRB, 0.111429E+00_JPRB &
  &, 0.103480E+00_JPRB, 0.959334E-01_JPRB, 0.887908E-01_JPRB &
  &, 0.820367E-01_JPRB, 0.756676E-01_JPRB, 0.696775E-01_JPRB, 0.640575E-01_JPRB &
  &, 0.587788E-01_JPRB, 0.538429E-01_JPRB, 0.492492E-01_JPRB &
  &, 0.449592E-01_JPRB, 0.409661E-01_JPRB, 0.372610E-01_JPRB, 0.338326E-01_JPRB &
  &, 0.306674E-01_JPRB, 0.277489E-01_JPRB, 0.250585E-01_JPRB &
  &, 0.225743E-01_JPRB, 0.203148E-01_JPRB, 0.182552E-01_JPRB, 0.163674E-01_JPRB &
  &, 0.146432E-01_JPRB, 0.130727E-01_JPRB, 0.116687E-01_JPRB &
  &, 0.103710E-01_JPRB, 0.921356E-02_JPRB, 0.815634E-02_JPRB, 0.723313E-02_JPRB &
  &, 0.637473E-02_JPRB, 0.564013E-02_JPRB, 0.495596E-02_JPRB &
  &, 0.435418E-02_JPRB, 0.381222E-02_JPRB, 0.333445E-02_JPRB, 0.292532E-02_JPRB &
  &, 0.252942E-02_JPRB, 0.220920E-02_JPRB, 0.190720E-02_JPRB &
  &, 0.165658E-02_JPRB, 0.142830E-02_JPRB, 0.122395E-02_JPRB, 0.107850E-02_JPRB &
  &, 0.927396E-03_JPRB, 0.770555E-03_JPRB, 0.678224E-03_JPRB &
  &, 0.582395E-03_JPRB, 0.483013E-03_JPRB, 0.417028E-03_JPRB, 0.348629E-03_JPRB &
  &, 0.277780E-03_JPRB, 0.243334E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.929756E-04_JPRB, 0.943048E-04_JPRB &
  &, 0.528229E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 258, :) = (/ &
  &  0.933022E+00_JPRB, 0.915763E+00_JPRB, 0.898323E+00_JPRB, 0.880713E+00_JPRB &
  &, 0.862946E+00_JPRB, 0.845034E+00_JPRB, 0.826989E+00_JPRB &
  &, 0.808824E+00_JPRB, 0.790554E+00_JPRB, 0.772191E+00_JPRB, 0.753749E+00_JPRB &
  &, 0.735241E+00_JPRB, 0.716683E+00_JPRB, 0.698088E+00_JPRB &
  &, 0.679471E+00_JPRB, 0.660849E+00_JPRB, 0.642234E+00_JPRB, 0.623645E+00_JPRB &
  &, 0.605097E+00_JPRB, 0.586603E+00_JPRB, 0.568185E+00_JPRB &
  &, 0.549856E+00_JPRB, 0.531634E+00_JPRB, 0.513536E+00_JPRB, 0.495581E+00_JPRB &
  &, 0.477786E+00_JPRB, 0.460165E+00_JPRB, 0.442737E+00_JPRB &
  &, 0.425522E+00_JPRB, 0.408535E+00_JPRB, 0.391794E+00_JPRB, 0.375314E+00_JPRB &
  &, 0.359114E+00_JPRB, 0.343205E+00_JPRB, 0.327607E+00_JPRB &
  &, 0.312338E+00_JPRB, 0.297404E+00_JPRB, 0.282823E+00_JPRB, 0.268603E+00_JPRB &
  &, 0.254760E+00_JPRB, 0.241311E+00_JPRB, 0.228252E+00_JPRB &
  &, 0.215598E+00_JPRB, 0.203353E+00_JPRB, 0.191531E+00_JPRB, 0.180132E+00_JPRB &
  &, 0.169157E+00_JPRB, 0.158613E+00_JPRB, 0.148507E+00_JPRB &
  &, 0.138819E+00_JPRB, 0.129564E+00_JPRB, 0.120726E+00_JPRB, 0.112318E+00_JPRB &
  &, 0.104318E+00_JPRB, 0.967471E-01_JPRB, 0.895630E-01_JPRB &
  &, 0.827805E-01_JPRB, 0.763812E-01_JPRB, 0.703427E-01_JPRB, 0.646881E-01_JPRB &
  &, 0.593730E-01_JPRB, 0.544157E-01_JPRB, 0.497817E-01_JPRB &
  &, 0.454492E-01_JPRB, 0.414298E-01_JPRB, 0.376970E-01_JPRB, 0.342394E-01_JPRB &
  &, 0.310434E-01_JPRB, 0.280926E-01_JPRB, 0.253889E-01_JPRB &
  &, 0.228906E-01_JPRB, 0.205948E-01_JPRB, 0.185190E-01_JPRB, 0.165918E-01_JPRB &
  &, 0.148493E-01_JPRB, 0.132830E-01_JPRB, 0.118356E-01_JPRB &
  &, 0.105413E-01_JPRB, 0.936241E-02_JPRB, 0.830813E-02_JPRB, 0.736211E-02_JPRB &
  &, 0.650623E-02_JPRB, 0.572056E-02_JPRB, 0.503794E-02_JPRB &
  &, 0.443772E-02_JPRB, 0.389735E-02_JPRB, 0.339226E-02_JPRB, 0.298421E-02_JPRB &
  &, 0.258940E-02_JPRB, 0.223974E-02_JPRB, 0.196941E-02_JPRB &
  &, 0.168824E-02_JPRB, 0.146054E-02_JPRB, 0.125676E-02_JPRB, 0.107850E-02_JPRB &
  &, 0.927396E-03_JPRB, 0.805126E-03_JPRB, 0.678224E-03_JPRB &
  &, 0.582395E-03_JPRB, 0.483013E-03_JPRB, 0.417028E-03_JPRB, 0.348629E-03_JPRB &
  &, 0.316034E-03_JPRB, 0.243334E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 259, :) = (/ &
  &  0.933318E+00_JPRB, 0.916130E+00_JPRB, 0.898756E+00_JPRB, 0.881212E+00_JPRB &
  &, 0.863508E+00_JPRB, 0.845657E+00_JPRB, 0.827672E+00_JPRB &
  &, 0.809565E+00_JPRB, 0.791350E+00_JPRB, 0.773040E+00_JPRB, 0.754649E+00_JPRB &
  &, 0.736189E+00_JPRB, 0.717677E+00_JPRB, 0.699127E+00_JPRB &
  &, 0.680552E+00_JPRB, 0.661968E+00_JPRB, 0.643390E+00_JPRB, 0.624834E+00_JPRB &
  &, 0.606317E+00_JPRB, 0.587853E+00_JPRB, 0.569462E+00_JPRB &
  &, 0.551156E+00_JPRB, 0.532957E+00_JPRB, 0.514879E+00_JPRB, 0.496938E+00_JPRB &
  &, 0.479153E+00_JPRB, 0.461547E+00_JPRB, 0.444126E+00_JPRB &
  &, 0.426918E+00_JPRB, 0.409934E+00_JPRB, 0.393191E+00_JPRB, 0.376708E+00_JPRB &
  &, 0.360503E+00_JPRB, 0.344589E+00_JPRB, 0.328986E+00_JPRB &
  &, 0.313696E+00_JPRB, 0.298748E+00_JPRB, 0.284153E+00_JPRB, 0.269916E+00_JPRB &
  &, 0.256055E+00_JPRB, 0.242576E+00_JPRB, 0.229494E+00_JPRB &
  &, 0.216816E+00_JPRB, 0.204545E+00_JPRB, 0.192694E+00_JPRB, 0.181265E+00_JPRB &
  &, 0.170257E+00_JPRB, 0.159689E+00_JPRB, 0.149533E+00_JPRB &
  &, 0.139818E+00_JPRB, 0.130519E+00_JPRB, 0.121650E+00_JPRB, 0.113207E+00_JPRB &
  &, 0.105185E+00_JPRB, 0.975607E-01_JPRB, 0.903505E-01_JPRB &
  &, 0.835244E-01_JPRB, 0.770790E-01_JPRB, 0.710241E-01_JPRB, 0.653188E-01_JPRB &
  &, 0.599841E-01_JPRB, 0.549886E-01_JPRB, 0.503142E-01_JPRB &
  &, 0.459573E-01_JPRB, 0.419121E-01_JPRB, 0.381330E-01_JPRB, 0.346462E-01_JPRB &
  &, 0.314392E-01_JPRB, 0.284566E-01_JPRB, 0.257193E-01_JPRB &
  &, 0.231858E-01_JPRB, 0.208962E-01_JPRB, 0.187828E-01_JPRB, 0.168386E-01_JPRB &
  &, 0.150783E-01_JPRB, 0.134700E-01_JPRB, 0.120263E-01_JPRB &
  &, 0.107115E-01_JPRB, 0.951125E-02_JPRB, 0.845993E-02_JPRB, 0.749110E-02_JPRB &
  &, 0.661144E-02_JPRB, 0.582781E-02_JPRB, 0.514724E-02_JPRB &
  &, 0.452126E-02_JPRB, 0.395409E-02_JPRB, 0.347899E-02_JPRB, 0.304311E-02_JPRB &
  &, 0.264939E-02_JPRB, 0.230083E-02_JPRB, 0.200051E-02_JPRB &
  &, 0.171991E-02_JPRB, 0.149277E-02_JPRB, 0.128957E-02_JPRB, 0.111189E-02_JPRB &
  &, 0.961373E-03_JPRB, 0.805126E-03_JPRB, 0.713394E-03_JPRB &
  &, 0.582395E-03_JPRB, 0.519399E-03_JPRB, 0.417028E-03_JPRB, 0.348629E-03_JPRB &
  &, 0.316034E-03_JPRB, 0.243334E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART37',1,ZHOOK_HANDLE)
END SUBROUTINE PART37

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART38

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART38',0,ZHOOK_HANDLE)

XCW( 260, :) = (/ &
  &  0.933612E+00_JPRB, 0.916494E+00_JPRB, 0.899188E+00_JPRB, 0.881710E+00_JPRB &
  &, 0.864070E+00_JPRB, 0.846280E+00_JPRB, 0.828355E+00_JPRB &
  &, 0.810305E+00_JPRB, 0.792146E+00_JPRB, 0.773888E+00_JPRB, 0.755548E+00_JPRB &
  &, 0.737137E+00_JPRB, 0.718671E+00_JPRB, 0.700164E+00_JPRB &
  &, 0.681630E+00_JPRB, 0.663086E+00_JPRB, 0.644544E+00_JPRB, 0.626024E+00_JPRB &
  &, 0.607538E+00_JPRB, 0.589103E+00_JPRB, 0.570737E+00_JPRB &
  &, 0.552456E+00_JPRB, 0.534276E+00_JPRB, 0.516219E+00_JPRB, 0.498295E+00_JPRB &
  &, 0.480525E+00_JPRB, 0.462925E+00_JPRB, 0.445515E+00_JPRB &
  &, 0.428314E+00_JPRB, 0.411332E+00_JPRB, 0.394591E+00_JPRB, 0.378105E+00_JPRB &
  &, 0.361897E+00_JPRB, 0.345974E+00_JPRB, 0.330360E+00_JPRB &
  &, 0.315063E+00_JPRB, 0.300102E+00_JPRB, 0.285483E+00_JPRB, 0.271230E+00_JPRB &
  &, 0.257350E+00_JPRB, 0.243851E+00_JPRB, 0.230748E+00_JPRB &
  &, 0.218034E+00_JPRB, 0.205748E+00_JPRB, 0.193858E+00_JPRB, 0.182398E+00_JPRB &
  &, 0.171368E+00_JPRB, 0.160754E+00_JPRB, 0.150572E+00_JPRB &
  &, 0.140816E+00_JPRB, 0.131488E+00_JPRB, 0.122587E+00_JPRB, 0.114111E+00_JPRB &
  &, 0.106038E+00_JPRB, 0.983892E-01_JPRB, 0.911227E-01_JPRB &
  &, 0.842683E-01_JPRB, 0.777925E-01_JPRB, 0.717055E-01_JPRB, 0.659661E-01_JPRB &
  &, 0.605952E-01_JPRB, 0.555615E-01_JPRB, 0.508467E-01_JPRB &
  &, 0.464654E-01_JPRB, 0.423758E-01_JPRB, 0.385880E-01_JPRB, 0.350724E-01_JPRB &
  &, 0.318153E-01_JPRB, 0.288205E-01_JPRB, 0.260497E-01_JPRB &
  &, 0.235022E-01_JPRB, 0.211761E-01_JPRB, 0.190466E-01_JPRB, 0.170854E-01_JPRB &
  &, 0.153073E-01_JPRB, 0.136803E-01_JPRB, 0.122170E-01_JPRB &
  &, 0.108818E-01_JPRB, 0.968490E-02_JPRB, 0.858642E-02_JPRB, 0.762008E-02_JPRB &
  &, 0.674294E-02_JPRB, 0.593505E-02_JPRB, 0.522922E-02_JPRB &
  &, 0.460480E-02_JPRB, 0.403922E-02_JPRB, 0.353681E-02_JPRB, 0.310200E-02_JPRB &
  &, 0.270937E-02_JPRB, 0.236192E-02_JPRB, 0.203161E-02_JPRB &
  &, 0.178324E-02_JPRB, 0.152501E-02_JPRB, 0.132237E-02_JPRB, 0.114528E-02_JPRB &
  &, 0.995351E-03_JPRB, 0.839696E-03_JPRB, 0.713394E-03_JPRB &
  &, 0.618170E-03_JPRB, 0.519399E-03_JPRB, 0.454031E-03_JPRB, 0.386254E-03_JPRB &
  &, 0.316034E-03_JPRB, 0.282223E-03_JPRB, 0.207649E-03_JPRB &
  &, 0.170706E-03_JPRB, 0.132488E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 261, :) = (/ &
  &  0.933908E+00_JPRB, 0.916858E+00_JPRB, 0.899619E+00_JPRB, 0.882207E+00_JPRB &
  &, 0.864630E+00_JPRB, 0.846903E+00_JPRB, 0.829037E+00_JPRB &
  &, 0.811045E+00_JPRB, 0.792939E+00_JPRB, 0.774735E+00_JPRB, 0.756446E+00_JPRB &
  &, 0.738083E+00_JPRB, 0.719663E+00_JPRB, 0.701200E+00_JPRB &
  &, 0.682708E+00_JPRB, 0.664202E+00_JPRB, 0.645699E+00_JPRB, 0.627211E+00_JPRB &
  &, 0.608758E+00_JPRB, 0.590353E+00_JPRB, 0.572014E+00_JPRB &
  &, 0.553755E+00_JPRB, 0.535599E+00_JPRB, 0.517559E+00_JPRB, 0.499653E+00_JPRB &
  &, 0.481896E+00_JPRB, 0.464307E+00_JPRB, 0.446908E+00_JPRB &
  &, 0.429706E+00_JPRB, 0.412730E+00_JPRB, 0.395992E+00_JPRB, 0.379503E+00_JPRB &
  &, 0.363291E+00_JPRB, 0.347363E+00_JPRB, 0.331739E+00_JPRB &
  &, 0.316431E+00_JPRB, 0.301457E+00_JPRB, 0.286822E+00_JPRB, 0.272553E+00_JPRB &
  &, 0.258645E+00_JPRB, 0.245126E+00_JPRB, 0.232001E+00_JPRB &
  &, 0.219264E+00_JPRB, 0.206940E+00_JPRB, 0.195033E+00_JPRB, 0.183543E+00_JPRB &
  &, 0.172468E+00_JPRB, 0.161830E+00_JPRB, 0.151611E+00_JPRB &
  &, 0.141828E+00_JPRB, 0.132457E+00_JPRB, 0.123525E+00_JPRB, 0.115000E+00_JPRB &
  &, 0.106905E+00_JPRB, 0.992029E-01_JPRB, 0.919253E-01_JPRB &
  &, 0.850276E-01_JPRB, 0.785220E-01_JPRB, 0.723869E-01_JPRB, 0.666134E-01_JPRB &
  &, 0.612063E-01_JPRB, 0.561344E-01_JPRB, 0.513970E-01_JPRB &
  &, 0.469735E-01_JPRB, 0.428581E-01_JPRB, 0.390430E-01_JPRB, 0.354986E-01_JPRB &
  &, 0.322111E-01_JPRB, 0.291844E-01_JPRB, 0.263801E-01_JPRB &
  &, 0.238185E-01_JPRB, 0.214560E-01_JPRB, 0.193104E-01_JPRB, 0.173323E-01_JPRB &
  &, 0.155363E-01_JPRB, 0.138906E-01_JPRB, 0.124078E-01_JPRB &
  &, 0.110520E-01_JPRB, 0.983375E-02_JPRB, 0.873822E-02_JPRB, 0.774906E-02_JPRB &
  &, 0.684814E-02_JPRB, 0.604229E-02_JPRB, 0.533852E-02_JPRB &
  &, 0.468834E-02_JPRB, 0.412434E-02_JPRB, 0.359462E-02_JPRB, 0.316090E-02_JPRB &
  &, 0.276936E-02_JPRB, 0.239246E-02_JPRB, 0.209381E-02_JPRB &
  &, 0.181490E-02_JPRB, 0.155724E-02_JPRB, 0.135518E-02_JPRB, 0.117867E-02_JPRB &
  &, 0.995351E-03_JPRB, 0.874267E-03_JPRB, 0.748564E-03_JPRB &
  &, 0.618170E-03_JPRB, 0.555785E-03_JPRB, 0.454031E-03_JPRB, 0.386254E-03_JPRB &
  &, 0.316034E-03_JPRB, 0.282223E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 262, :) = (/ &
  &  0.934203E+00_JPRB, 0.917223E+00_JPRB, 0.900051E+00_JPRB, 0.882704E+00_JPRB &
  &, 0.865190E+00_JPRB, 0.847523E+00_JPRB, 0.829717E+00_JPRB &
  &, 0.811782E+00_JPRB, 0.793732E+00_JPRB, 0.775581E+00_JPRB, 0.757342E+00_JPRB &
  &, 0.739028E+00_JPRB, 0.720654E+00_JPRB, 0.702235E+00_JPRB &
  &, 0.683784E+00_JPRB, 0.665318E+00_JPRB, 0.646851E+00_JPRB, 0.628399E+00_JPRB &
  &, 0.609977E+00_JPRB, 0.591599E+00_JPRB, 0.573288E+00_JPRB &
  &, 0.555055E+00_JPRB, 0.536918E+00_JPRB, 0.518898E+00_JPRB, 0.501006E+00_JPRB &
  &, 0.483267E+00_JPRB, 0.465689E+00_JPRB, 0.448297E+00_JPRB &
  &, 0.431102E+00_JPRB, 0.414129E+00_JPRB, 0.397392E+00_JPRB, 0.380905E+00_JPRB &
  &, 0.364685E+00_JPRB, 0.348752E+00_JPRB, 0.333118E+00_JPRB &
  &, 0.317798E+00_JPRB, 0.302811E+00_JPRB, 0.288162E+00_JPRB, 0.273866E+00_JPRB &
  &, 0.259951E+00_JPRB, 0.246401E+00_JPRB, 0.233254E+00_JPRB &
  &, 0.220493E+00_JPRB, 0.208143E+00_JPRB, 0.196208E+00_JPRB, 0.184687E+00_JPRB &
  &, 0.173580E+00_JPRB, 0.162907E+00_JPRB, 0.152663E+00_JPRB &
  &, 0.142840E+00_JPRB, 0.133440E+00_JPRB, 0.124462E+00_JPRB, 0.115903E+00_JPRB &
  &, 0.107772E+00_JPRB, 0.100046E+00_JPRB, 0.927127E-01_JPRB &
  &, 0.857870E-01_JPRB, 0.792356E-01_JPRB, 0.730684E-01_JPRB, 0.672607E-01_JPRB &
  &, 0.618174E-01_JPRB, 0.567072E-01_JPRB, 0.519472E-01_JPRB &
  &, 0.474816E-01_JPRB, 0.433404E-01_JPRB, 0.394979E-01_JPRB, 0.359054E-01_JPRB &
  &, 0.326070E-01_JPRB, 0.295483E-01_JPRB, 0.267311E-01_JPRB &
  &, 0.241348E-01_JPRB, 0.217575E-01_JPRB, 0.195741E-01_JPRB, 0.175791E-01_JPRB &
  &, 0.157653E-01_JPRB, 0.141009E-01_JPRB, 0.125985E-01_JPRB &
  &, 0.112223E-01_JPRB, 0.100074E-01_JPRB, 0.889001E-02_JPRB, 0.787805E-02_JPRB &
  &, 0.697964E-02_JPRB, 0.614953E-02_JPRB, 0.542050E-02_JPRB &
  &, 0.477189E-02_JPRB, 0.420947E-02_JPRB, 0.368135E-02_JPRB, 0.321980E-02_JPRB &
  &, 0.279935E-02_JPRB, 0.245355E-02_JPRB, 0.212492E-02_JPRB &
  &, 0.184657E-02_JPRB, 0.158947E-02_JPRB, 0.138799E-02_JPRB, 0.121206E-02_JPRB &
  &, 0.102933E-02_JPRB, 0.874267E-03_JPRB, 0.748564E-03_JPRB &
  &, 0.653945E-03_JPRB, 0.555785E-03_JPRB, 0.454031E-03_JPRB, 0.386254E-03_JPRB &
  &, 0.354288E-03_JPRB, 0.282223E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 263, :) = (/ &
  &  0.934497E+00_JPRB, 0.917584E+00_JPRB, 0.900481E+00_JPRB, 0.883199E+00_JPRB &
  &, 0.865749E+00_JPRB, 0.848144E+00_JPRB, 0.830396E+00_JPRB &
  &, 0.812518E+00_JPRB, 0.794524E+00_JPRB, 0.776426E+00_JPRB, 0.758238E+00_JPRB &
  &, 0.739973E+00_JPRB, 0.721646E+00_JPRB, 0.703270E+00_JPRB &
  &, 0.684861E+00_JPRB, 0.666434E+00_JPRB, 0.648004E+00_JPRB, 0.629585E+00_JPRB &
  &, 0.611194E+00_JPRB, 0.592846E+00_JPRB, 0.574563E+00_JPRB &
  &, 0.556355E+00_JPRB, 0.538241E+00_JPRB, 0.520238E+00_JPRB, 0.502363E+00_JPRB &
  &, 0.484635E+00_JPRB, 0.467071E+00_JPRB, 0.449686E+00_JPRB &
  &, 0.432502E+00_JPRB, 0.415531E+00_JPRB, 0.398792E+00_JPRB, 0.382302E+00_JPRB &
  &, 0.366079E+00_JPRB, 0.350142E+00_JPRB, 0.334497E+00_JPRB &
  &, 0.319165E+00_JPRB, 0.304165E+00_JPRB, 0.289501E+00_JPRB, 0.275190E+00_JPRB &
  &, 0.261246E+00_JPRB, 0.247687E+00_JPRB, 0.234507E+00_JPRB &
  &, 0.221722E+00_JPRB, 0.209347E+00_JPRB, 0.197383E+00_JPRB, 0.185832E+00_JPRB &
  &, 0.174692E+00_JPRB, 0.163984E+00_JPRB, 0.153702E+00_JPRB &
  &, 0.143852E+00_JPRB, 0.134422E+00_JPRB, 0.125413E+00_JPRB, 0.116821E+00_JPRB &
  &, 0.108639E+00_JPRB, 0.100875E+00_JPRB, 0.935152E-01_JPRB &
  &, 0.865464E-01_JPRB, 0.799651E-01_JPRB, 0.737498E-01_JPRB, 0.679245E-01_JPRB &
  &, 0.624285E-01_JPRB, 0.572975E-01_JPRB, 0.524975E-01_JPRB &
  &, 0.480078E-01_JPRB, 0.438226E-01_JPRB, 0.399529E-01_JPRB, 0.363316E-01_JPRB &
  &, 0.330028E-01_JPRB, 0.299123E-01_JPRB, 0.270822E-01_JPRB &
  &, 0.244511E-01_JPRB, 0.220589E-01_JPRB, 0.198599E-01_JPRB, 0.178259E-01_JPRB &
  &, 0.159943E-01_JPRB, 0.143112E-01_JPRB, 0.127892E-01_JPRB &
  &, 0.114169E-01_JPRB, 0.101562E-01_JPRB, 0.901651E-02_JPRB, 0.800703E-02_JPRB &
  &, 0.708485E-02_JPRB, 0.625677E-02_JPRB, 0.552980E-02_JPRB &
  &, 0.485543E-02_JPRB, 0.426622E-02_JPRB, 0.373916E-02_JPRB, 0.327869E-02_JPRB &
  &, 0.285934E-02_JPRB, 0.251464E-02_JPRB, 0.218712E-02_JPRB &
  &, 0.187823E-02_JPRB, 0.165394E-02_JPRB, 0.142080E-02_JPRB, 0.121206E-02_JPRB &
  &, 0.106331E-02_JPRB, 0.908838E-03_JPRB, 0.783734E-03_JPRB &
  &, 0.653945E-03_JPRB, 0.555785E-03_JPRB, 0.491033E-03_JPRB, 0.423880E-03_JPRB &
  &, 0.354288E-03_JPRB, 0.282223E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.943048E-04_JPRB &
  &, 0.956459E-04_JPRB, 0.534995E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 264, :) = (/ &
  &  0.934791E+00_JPRB, 0.917948E+00_JPRB, 0.900910E+00_JPRB, 0.883694E+00_JPRB &
  &, 0.866307E+00_JPRB, 0.848763E+00_JPRB, 0.831075E+00_JPRB &
  &, 0.813254E+00_JPRB, 0.795316E+00_JPRB, 0.777270E+00_JPRB, 0.759133E+00_JPRB &
  &, 0.740915E+00_JPRB, 0.722634E+00_JPRB, 0.704303E+00_JPRB &
  &, 0.685936E+00_JPRB, 0.667548E+00_JPRB, 0.649154E+00_JPRB, 0.630768E+00_JPRB &
  &, 0.612411E+00_JPRB, 0.594096E+00_JPRB, 0.575837E+00_JPRB &
  &, 0.557651E+00_JPRB, 0.539560E+00_JPRB, 0.521577E+00_JPRB, 0.503720E+00_JPRB &
  &, 0.486006E+00_JPRB, 0.468453E+00_JPRB, 0.451079E+00_JPRB &
  &, 0.433898E+00_JPRB, 0.416930E+00_JPRB, 0.400193E+00_JPRB, 0.383704E+00_JPRB &
  &, 0.367477E+00_JPRB, 0.351531E+00_JPRB, 0.335880E+00_JPRB &
  &, 0.320533E+00_JPRB, 0.305519E+00_JPRB, 0.290841E+00_JPRB, 0.276513E+00_JPRB &
  &, 0.262551E+00_JPRB, 0.248972E+00_JPRB, 0.235771E+00_JPRB &
  &, 0.222962E+00_JPRB, 0.210550E+00_JPRB, 0.198558E+00_JPRB, 0.186977E+00_JPRB &
  &, 0.175816E+00_JPRB, 0.165073E+00_JPRB, 0.154754E+00_JPRB &
  &, 0.144864E+00_JPRB, 0.135405E+00_JPRB, 0.126350E+00_JPRB, 0.117724E+00_JPRB &
  &, 0.109521E+00_JPRB, 0.101718E+00_JPRB, 0.943178E-01_JPRB &
  &, 0.873057E-01_JPRB, 0.806945E-01_JPRB, 0.744474E-01_JPRB, 0.685718E-01_JPRB &
  &, 0.630566E-01_JPRB, 0.578877E-01_JPRB, 0.530478E-01_JPRB &
  &, 0.485341E-01_JPRB, 0.443235E-01_JPRB, 0.404079E-01_JPRB, 0.367771E-01_JPRB &
  &, 0.333986E-01_JPRB, 0.302964E-01_JPRB, 0.274332E-01_JPRB &
  &, 0.247885E-01_JPRB, 0.223604E-01_JPRB, 0.201237E-01_JPRB, 0.180952E-01_JPRB &
  &, 0.162233E-01_JPRB, 0.145215E-01_JPRB, 0.129800E-01_JPRB &
  &, 0.115871E-01_JPRB, 0.103299E-01_JPRB, 0.916830E-02_JPRB, 0.813602E-02_JPRB &
  &, 0.721635E-02_JPRB, 0.639082E-02_JPRB, 0.563910E-02_JPRB &
  &, 0.496682E-02_JPRB, 0.435134E-02_JPRB, 0.382589E-02_JPRB, 0.333759E-02_JPRB &
  &, 0.291933E-02_JPRB, 0.254518E-02_JPRB, 0.221822E-02_JPRB &
  &, 0.194156E-02_JPRB, 0.168618E-02_JPRB, 0.145361E-02_JPRB, 0.124545E-02_JPRB &
  &, 0.106331E-02_JPRB, 0.943409E-03_JPRB, 0.783734E-03_JPRB &
  &, 0.689719E-03_JPRB, 0.592170E-03_JPRB, 0.491033E-03_JPRB, 0.423880E-03_JPRB &
  &, 0.354288E-03_JPRB, 0.282223E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 265, :) = (/ &
  &  0.935083E+00_JPRB, 0.918309E+00_JPRB, 0.901339E+00_JPRB, 0.884188E+00_JPRB &
  &, 0.866864E+00_JPRB, 0.849382E+00_JPRB, 0.831752E+00_JPRB &
  &, 0.813989E+00_JPRB, 0.796105E+00_JPRB, 0.778113E+00_JPRB, 0.760026E+00_JPRB &
  &, 0.741857E+00_JPRB, 0.723623E+00_JPRB, 0.705336E+00_JPRB &
  &, 0.687010E+00_JPRB, 0.668661E+00_JPRB, 0.650305E+00_JPRB, 0.631956E+00_JPRB &
  &, 0.613629E+00_JPRB, 0.595340E+00_JPRB, 0.577111E+00_JPRB &
  &, 0.558951E+00_JPRB, 0.540880E+00_JPRB, 0.522917E+00_JPRB, 0.505077E+00_JPRB &
  &, 0.487377E+00_JPRB, 0.469836E+00_JPRB, 0.452468E+00_JPRB &
  &, 0.435293E+00_JPRB, 0.418332E+00_JPRB, 0.401597E+00_JPRB, 0.385106E+00_JPRB &
  &, 0.368875E+00_JPRB, 0.352924E+00_JPRB, 0.337264E+00_JPRB &
  &, 0.321909E+00_JPRB, 0.306883E+00_JPRB, 0.292190E+00_JPRB, 0.277846E+00_JPRB &
  &, 0.263867E+00_JPRB, 0.250258E+00_JPRB, 0.237024E+00_JPRB &
  &, 0.224192E+00_JPRB, 0.211764E+00_JPRB, 0.199745E+00_JPRB, 0.188133E+00_JPRB &
  &, 0.176940E+00_JPRB, 0.166162E+00_JPRB, 0.155818E+00_JPRB &
  &, 0.145888E+00_JPRB, 0.136387E+00_JPRB, 0.127301E+00_JPRB, 0.118641E+00_JPRB &
  &, 0.110388E+00_JPRB, 0.102561E+00_JPRB, 0.951204E-01_JPRB &
  &, 0.880806E-01_JPRB, 0.814240E-01_JPRB, 0.751451E-01_JPRB, 0.692357E-01_JPRB &
  &, 0.636847E-01_JPRB, 0.584779E-01_JPRB, 0.536158E-01_JPRB &
  &, 0.490603E-01_JPRB, 0.448243E-01_JPRB, 0.408629E-01_JPRB, 0.372033E-01_JPRB &
  &, 0.338142E-01_JPRB, 0.306805E-01_JPRB, 0.277843E-01_JPRB &
  &, 0.251049E-01_JPRB, 0.226618E-01_JPRB, 0.204095E-01_JPRB, 0.183420E-01_JPRB &
  &, 0.164752E-01_JPRB, 0.147552E-01_JPRB, 0.131945E-01_JPRB &
  &, 0.117817E-01_JPRB, 0.104787E-01_JPRB, 0.932010E-02_JPRB, 0.829080E-02_JPRB &
  &, 0.734785E-02_JPRB, 0.649806E-02_JPRB, 0.572108E-02_JPRB &
  &, 0.505036E-02_JPRB, 0.443647E-02_JPRB, 0.391261E-02_JPRB, 0.342593E-02_JPRB &
  &, 0.297931E-02_JPRB, 0.260627E-02_JPRB, 0.228042E-02_JPRB &
  &, 0.197323E-02_JPRB, 0.171841E-02_JPRB, 0.148642E-02_JPRB, 0.127884E-02_JPRB &
  &, 0.109728E-02_JPRB, 0.943409E-03_JPRB, 0.818903E-03_JPRB &
  &, 0.689719E-03_JPRB, 0.592170E-03_JPRB, 0.491033E-03_JPRB, 0.423880E-03_JPRB &
  &, 0.354288E-03_JPRB, 0.321112E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 266, :) = (/ &
  &  0.935377E+00_JPRB, 0.918671E+00_JPRB, 0.901767E+00_JPRB, 0.884681E+00_JPRB &
  &, 0.867421E+00_JPRB, 0.849999E+00_JPRB, 0.832429E+00_JPRB &
  &, 0.814723E+00_JPRB, 0.796894E+00_JPRB, 0.778954E+00_JPRB, 0.760919E+00_JPRB &
  &, 0.742798E+00_JPRB, 0.724611E+00_JPRB, 0.706368E+00_JPRB &
  &, 0.688083E+00_JPRB, 0.669774E+00_JPRB, 0.651455E+00_JPRB, 0.633139E+00_JPRB &
  &, 0.614846E+00_JPRB, 0.596587E+00_JPRB, 0.578382E+00_JPRB &
  &, 0.560247E+00_JPRB, 0.542199E+00_JPRB, 0.524257E+00_JPRB, 0.506434E+00_JPRB &
  &, 0.488749E+00_JPRB, 0.471218E+00_JPRB, 0.453861E+00_JPRB &
  &, 0.436693E+00_JPRB, 0.419735E+00_JPRB, 0.403002E+00_JPRB, 0.386508E+00_JPRB &
  &, 0.370273E+00_JPRB, 0.354318E+00_JPRB, 0.338647E+00_JPRB &
  &, 0.323286E+00_JPRB, 0.308237E+00_JPRB, 0.293530E+00_JPRB, 0.279170E+00_JPRB &
  &, 0.265173E+00_JPRB, 0.251544E+00_JPRB, 0.238299E+00_JPRB &
  &, 0.225432E+00_JPRB, 0.212979E+00_JPRB, 0.200932E+00_JPRB, 0.189290E+00_JPRB &
  &, 0.178064E+00_JPRB, 0.167251E+00_JPRB, 0.156870E+00_JPRB &
  &, 0.146913E+00_JPRB, 0.137383E+00_JPRB, 0.128266E+00_JPRB, 0.119559E+00_JPRB &
  &, 0.111284E+00_JPRB, 0.103404E+00_JPRB, 0.959229E-01_JPRB &
  &, 0.888554E-01_JPRB, 0.821534E-01_JPRB, 0.758427E-01_JPRB, 0.698996E-01_JPRB &
  &, 0.643128E-01_JPRB, 0.590855E-01_JPRB, 0.541660E-01_JPRB &
  &, 0.495866E-01_JPRB, 0.453066E-01_JPRB, 0.413368E-01_JPRB, 0.376488E-01_JPRB &
  &, 0.342101E-01_JPRB, 0.310445E-01_JPRB, 0.281353E-01_JPRB &
  &, 0.254423E-01_JPRB, 0.229633E-01_JPRB, 0.206952E-01_JPRB, 0.186112E-01_JPRB &
  &, 0.167042E-01_JPRB, 0.149655E-01_JPRB, 0.133853E-01_JPRB &
  &, 0.119519E-01_JPRB, 0.106524E-01_JPRB, 0.947189E-02_JPRB, 0.841978E-02_JPRB &
  &, 0.745305E-02_JPRB, 0.660530E-02_JPRB, 0.583038E-02_JPRB &
  &, 0.513390E-02_JPRB, 0.452159E-02_JPRB, 0.397043E-02_JPRB, 0.348482E-02_JPRB &
  &, 0.303930E-02_JPRB, 0.266736E-02_JPRB, 0.231153E-02_JPRB &
  &, 0.200489E-02_JPRB, 0.175065E-02_JPRB, 0.151923E-02_JPRB, 0.131223E-02_JPRB &
  &, 0.113126E-02_JPRB, 0.977979E-03_JPRB, 0.854073E-03_JPRB &
  &, 0.725494E-03_JPRB, 0.628556E-03_JPRB, 0.528036E-03_JPRB, 0.461505E-03_JPRB &
  &, 0.392543E-03_JPRB, 0.321112E-03_JPRB, 0.247179E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.134463E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART38',1,ZHOOK_HANDLE)
END SUBROUTINE PART38

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART39

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART39',0,ZHOOK_HANDLE)

XCW( 267, :) = (/ &
  &  0.935668E+00_JPRB, 0.919031E+00_JPRB, 0.902194E+00_JPRB, 0.885173E+00_JPRB &
  &, 0.867976E+00_JPRB, 0.850616E+00_JPRB, 0.833105E+00_JPRB &
  &, 0.815456E+00_JPRB, 0.797682E+00_JPRB, 0.779795E+00_JPRB, 0.761810E+00_JPRB &
  &, 0.743739E+00_JPRB, 0.725598E+00_JPRB, 0.707398E+00_JPRB &
  &, 0.689156E+00_JPRB, 0.670886E+00_JPRB, 0.652604E+00_JPRB, 0.634323E+00_JPRB &
  &, 0.616059E+00_JPRB, 0.597833E+00_JPRB, 0.579657E+00_JPRB &
  &, 0.561547E+00_JPRB, 0.543522E+00_JPRB, 0.525596E+00_JPRB, 0.507788E+00_JPRB &
  &, 0.490116E+00_JPRB, 0.472600E+00_JPRB, 0.455250E+00_JPRB &
  &, 0.438093E+00_JPRB, 0.421137E+00_JPRB, 0.404406E+00_JPRB, 0.387914E+00_JPRB &
  &, 0.371676E+00_JPRB, 0.355712E+00_JPRB, 0.340035E+00_JPRB &
  &, 0.324662E+00_JPRB, 0.309601E+00_JPRB, 0.294879E+00_JPRB, 0.280503E+00_JPRB &
  &, 0.266488E+00_JPRB, 0.252829E+00_JPRB, 0.239563E+00_JPRB &
  &, 0.226684E+00_JPRB, 0.214194E+00_JPRB, 0.202118E+00_JPRB, 0.190447E+00_JPRB &
  &, 0.179189E+00_JPRB, 0.168353E+00_JPRB, 0.157935E+00_JPRB &
  &, 0.147938E+00_JPRB, 0.138366E+00_JPRB, 0.129217E+00_JPRB, 0.120490E+00_JPRB &
  &, 0.112165E+00_JPRB, 0.104248E+00_JPRB, 0.967406E-01_JPRB &
  &, 0.896303E-01_JPRB, 0.828988E-01_JPRB, 0.765566E-01_JPRB, 0.705800E-01_JPRB &
  &, 0.649579E-01_JPRB, 0.596758E-01_JPRB, 0.547340E-01_JPRB &
  &, 0.501128E-01_JPRB, 0.458074E-01_JPRB, 0.418107E-01_JPRB, 0.380750E-01_JPRB &
  &, 0.346257E-01_JPRB, 0.314286E-01_JPRB, 0.284864E-01_JPRB &
  &, 0.257586E-01_JPRB, 0.232647E-01_JPRB, 0.209810E-01_JPRB, 0.188581E-01_JPRB &
  &, 0.169561E-01_JPRB, 0.151992E-01_JPRB, 0.135999E-01_JPRB &
  &, 0.121465E-01_JPRB, 0.108260E-01_JPRB, 0.964899E-02_JPRB, 0.857456E-02_JPRB &
  &, 0.758456E-02_JPRB, 0.671254E-02_JPRB, 0.593969E-02_JPRB &
  &, 0.524529E-02_JPRB, 0.460671E-02_JPRB, 0.405715E-02_JPRB, 0.354372E-02_JPRB &
  &, 0.309928E-02_JPRB, 0.272845E-02_JPRB, 0.237373E-02_JPRB &
  &, 0.206822E-02_JPRB, 0.178288E-02_JPRB, 0.155204E-02_JPRB, 0.134562E-02_JPRB &
  &, 0.116524E-02_JPRB, 0.101255E-02_JPRB, 0.854073E-03_JPRB &
  &, 0.725494E-03_JPRB, 0.628556E-03_JPRB, 0.528036E-03_JPRB, 0.461505E-03_JPRB &
  &, 0.392543E-03_JPRB, 0.321112E-03_JPRB, 0.286708E-03_JPRB &
  &, 0.210882E-03_JPRB, 0.173317E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 268, :) = (/ &
  &  0.935958E+00_JPRB, 0.919391E+00_JPRB, 0.902622E+00_JPRB, 0.885665E+00_JPRB &
  &, 0.868530E+00_JPRB, 0.851232E+00_JPRB, 0.833780E+00_JPRB &
  &, 0.816188E+00_JPRB, 0.798469E+00_JPRB, 0.780635E+00_JPRB, 0.762701E+00_JPRB &
  &, 0.744679E+00_JPRB, 0.726582E+00_JPRB, 0.708428E+00_JPRB &
  &, 0.690228E+00_JPRB, 0.671997E+00_JPRB, 0.653751E+00_JPRB, 0.635505E+00_JPRB &
  &, 0.617276E+00_JPRB, 0.599077E+00_JPRB, 0.580928E+00_JPRB &
  &, 0.562843E+00_JPRB, 0.544837E+00_JPRB, 0.526932E+00_JPRB, 0.509145E+00_JPRB &
  &, 0.491488E+00_JPRB, 0.473982E+00_JPRB, 0.456643E+00_JPRB &
  &, 0.439493E+00_JPRB, 0.422539E+00_JPRB, 0.405811E+00_JPRB, 0.389316E+00_JPRB &
  &, 0.373078E+00_JPRB, 0.357105E+00_JPRB, 0.341423E+00_JPRB &
  &, 0.326039E+00_JPRB, 0.310965E+00_JPRB, 0.296229E+00_JPRB, 0.281837E+00_JPRB &
  &, 0.267794E+00_JPRB, 0.254126E+00_JPRB, 0.240827E+00_JPRB &
  &, 0.227924E+00_JPRB, 0.215408E+00_JPRB, 0.203305E+00_JPRB, 0.191603E+00_JPRB &
  &, 0.180325E+00_JPRB, 0.169455E+00_JPRB, 0.159000E+00_JPRB &
  &, 0.148976E+00_JPRB, 0.139375E+00_JPRB, 0.130182E+00_JPRB, 0.121408E+00_JPRB &
  &, 0.113061E+00_JPRB, 0.105106E+00_JPRB, 0.975583E-01_JPRB &
  &, 0.904052E-01_JPRB, 0.836441E-01_JPRB, 0.772705E-01_JPRB, 0.712439E-01_JPRB &
  &, 0.655859E-01_JPRB, 0.602834E-01_JPRB, 0.553020E-01_JPRB &
  &, 0.506572E-01_JPRB, 0.463267E-01_JPRB, 0.422847E-01_JPRB, 0.385205E-01_JPRB &
  &, 0.350413E-01_JPRB, 0.318330E-01_JPRB, 0.288374E-01_JPRB &
  &, 0.260960E-01_JPRB, 0.235877E-01_JPRB, 0.212668E-01_JPRB, 0.191273E-01_JPRB &
  &, 0.171851E-01_JPRB, 0.154095E-01_JPRB, 0.137906E-01_JPRB &
  &, 0.123411E-01_JPRB, 0.109997E-01_JPRB, 0.980078E-02_JPRB, 0.870355E-02_JPRB &
  &, 0.771606E-02_JPRB, 0.684659E-02_JPRB, 0.604899E-02_JPRB &
  &, 0.532883E-02_JPRB, 0.469184E-02_JPRB, 0.414388E-02_JPRB, 0.363206E-02_JPRB &
  &, 0.315927E-02_JPRB, 0.275900E-02_JPRB, 0.240483E-02_JPRB &
  &, 0.209989E-02_JPRB, 0.181511E-02_JPRB, 0.158485E-02_JPRB, 0.137901E-02_JPRB &
  &, 0.119922E-02_JPRB, 0.101255E-02_JPRB, 0.889243E-03_JPRB &
  &, 0.761269E-03_JPRB, 0.628556E-03_JPRB, 0.565038E-03_JPRB, 0.461505E-03_JPRB &
  &, 0.392543E-03_JPRB, 0.321112E-03_JPRB, 0.286708E-03_JPRB &
  &, 0.251059E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 269, :) = (/ &
  &  0.936250E+00_JPRB, 0.919751E+00_JPRB, 0.903048E+00_JPRB, 0.886156E+00_JPRB &
  &, 0.869084E+00_JPRB, 0.851847E+00_JPRB, 0.834444E+00_JPRB &
  &, 0.816919E+00_JPRB, 0.799255E+00_JPRB, 0.781474E+00_JPRB, 0.763591E+00_JPRB &
  &, 0.745617E+00_JPRB, 0.727567E+00_JPRB, 0.709457E+00_JPRB &
  &, 0.691299E+00_JPRB, 0.673107E+00_JPRB, 0.654899E+00_JPRB, 0.636688E+00_JPRB &
  &, 0.618490E+00_JPRB, 0.600321E+00_JPRB, 0.582199E+00_JPRB &
  &, 0.564140E+00_JPRB, 0.546157E+00_JPRB, 0.528272E+00_JPRB, 0.510502E+00_JPRB &
  &, 0.492859E+00_JPRB, 0.475364E+00_JPRB, 0.458036E+00_JPRB &
  &, 0.440893E+00_JPRB, 0.423946E+00_JPRB, 0.407215E+00_JPRB, 0.390721E+00_JPRB &
  &, 0.374481E+00_JPRB, 0.358503E+00_JPRB, 0.342811E+00_JPRB &
  &, 0.327416E+00_JPRB, 0.312338E+00_JPRB, 0.297588E+00_JPRB, 0.283170E+00_JPRB &
  &, 0.269120E+00_JPRB, 0.255422E+00_JPRB, 0.242102E+00_JPRB &
  &, 0.229175E+00_JPRB, 0.216634E+00_JPRB, 0.204504E+00_JPRB, 0.192772E+00_JPRB &
  &, 0.181449E+00_JPRB, 0.170557E+00_JPRB, 0.160077E+00_JPRB &
  &, 0.150014E+00_JPRB, 0.140371E+00_JPRB, 0.131147E+00_JPRB, 0.122339E+00_JPRB &
  &, 0.113943E+00_JPRB, 0.105964E+00_JPRB, 0.983760E-01_JPRB &
  &, 0.911955E-01_JPRB, 0.843894E-01_JPRB, 0.779681E-01_JPRB, 0.719244E-01_JPRB &
  &, 0.662310E-01_JPRB, 0.608910E-01_JPRB, 0.558878E-01_JPRB &
  &, 0.512016E-01_JPRB, 0.468276E-01_JPRB, 0.427586E-01_JPRB, 0.389855E-01_JPRB &
  &, 0.354570E-01_JPRB, 0.322171E-01_JPRB, 0.292091E-01_JPRB &
  &, 0.264334E-01_JPRB, 0.238892E-01_JPRB, 0.215525E-01_JPRB, 0.193966E-01_JPRB &
  &, 0.174370E-01_JPRB, 0.156432E-01_JPRB, 0.140052E-01_JPRB &
  &, 0.125357E-01_JPRB, 0.111733E-01_JPRB, 0.995258E-02_JPRB, 0.885833E-02_JPRB &
  &, 0.784756E-02_JPRB, 0.695383E-02_JPRB, 0.615829E-02_JPRB &
  &, 0.544022E-02_JPRB, 0.477696E-02_JPRB, 0.420170E-02_JPRB, 0.369096E-02_JPRB &
  &, 0.324925E-02_JPRB, 0.282008E-02_JPRB, 0.246703E-02_JPRB &
  &, 0.216322E-02_JPRB, 0.187958E-02_JPRB, 0.161766E-02_JPRB, 0.141240E-02_JPRB &
  &, 0.119922E-02_JPRB, 0.104712E-02_JPRB, 0.889243E-03_JPRB &
  &, 0.761269E-03_JPRB, 0.664942E-03_JPRB, 0.565038E-03_JPRB, 0.499131E-03_JPRB &
  &, 0.392543E-03_JPRB, 0.360001E-03_JPRB, 0.286708E-03_JPRB &
  &, 0.251059E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.956459E-04_JPRB, 0.969989E-04_JPRB, 0.541819E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 270, :) = (/ &
  &  0.936540E+00_JPRB, 0.920109E+00_JPRB, 0.903473E+00_JPRB, 0.886646E+00_JPRB &
  &, 0.869638E+00_JPRB, 0.852461E+00_JPRB, 0.835127E+00_JPRB &
  &, 0.817649E+00_JPRB, 0.800040E+00_JPRB, 0.782312E+00_JPRB, 0.764480E+00_JPRB &
  &, 0.746554E+00_JPRB, 0.728552E+00_JPRB, 0.710484E+00_JPRB &
  &, 0.692368E+00_JPRB, 0.674216E+00_JPRB, 0.656045E+00_JPRB, 0.637868E+00_JPRB &
  &, 0.619704E+00_JPRB, 0.601564E+00_JPRB, 0.583470E+00_JPRB &
  &, 0.565436E+00_JPRB, 0.547476E+00_JPRB, 0.529612E+00_JPRB, 0.511859E+00_JPRB &
  &, 0.494230E+00_JPRB, 0.476750E+00_JPRB, 0.459429E+00_JPRB &
  &, 0.442293E+00_JPRB, 0.425352E+00_JPRB, 0.408624E+00_JPRB, 0.392132E+00_JPRB &
  &, 0.375883E+00_JPRB, 0.359901E+00_JPRB, 0.344204E+00_JPRB &
  &, 0.328802E+00_JPRB, 0.313702E+00_JPRB, 0.298937E+00_JPRB, 0.284513E+00_JPRB &
  &, 0.270435E+00_JPRB, 0.256718E+00_JPRB, 0.243377E+00_JPRB &
  &, 0.230427E+00_JPRB, 0.217860E+00_JPRB, 0.205702E+00_JPRB, 0.193940E+00_JPRB &
  &, 0.182598E+00_JPRB, 0.171658E+00_JPRB, 0.161142E+00_JPRB &
  &, 0.151052E+00_JPRB, 0.141380E+00_JPRB, 0.132125E+00_JPRB, 0.123271E+00_JPRB &
  &, 0.114853E+00_JPRB, 0.106822E+00_JPRB, 0.992088E-01_JPRB &
  &, 0.919859E-01_JPRB, 0.851506E-01_JPRB, 0.786982E-01_JPRB, 0.726049E-01_JPRB &
  &, 0.668761E-01_JPRB, 0.614986E-01_JPRB, 0.564558E-01_JPRB &
  &, 0.517460E-01_JPRB, 0.473469E-01_JPRB, 0.432515E-01_JPRB, 0.394310E-01_JPRB &
  &, 0.358924E-01_JPRB, 0.326012E-01_JPRB, 0.295808E-01_JPRB &
  &, 0.267919E-01_JPRB, 0.242122E-01_JPRB, 0.218383E-01_JPRB, 0.196658E-01_JPRB &
  &, 0.176889E-01_JPRB, 0.158769E-01_JPRB, 0.142197E-01_JPRB &
  &, 0.127302E-01_JPRB, 0.113470E-01_JPRB, 0.101297E-01_JPRB, 0.898731E-02_JPRB &
  &, 0.797906E-02_JPRB, 0.708788E-02_JPRB, 0.626759E-02_JPRB &
  &, 0.552376E-02_JPRB, 0.486209E-02_JPRB, 0.428842E-02_JPRB, 0.377930E-02_JPRB &
  &, 0.330924E-02_JPRB, 0.288117E-02_JPRB, 0.252924E-02_JPRB &
  &, 0.219488E-02_JPRB, 0.191182E-02_JPRB, 0.165047E-02_JPRB, 0.144579E-02_JPRB &
  &, 0.123319E-02_JPRB, 0.108169E-02_JPRB, 0.924413E-03_JPRB &
  &, 0.797043E-03_JPRB, 0.664942E-03_JPRB, 0.565038E-03_JPRB, 0.499131E-03_JPRB &
  &, 0.430797E-03_JPRB, 0.360001E-03_JPRB, 0.286708E-03_JPRB &
  &, 0.251059E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 271, :) = (/ &
  &  0.936830E+00_JPRB, 0.920468E+00_JPRB, 0.903898E+00_JPRB, 0.887136E+00_JPRB &
  &, 0.870190E+00_JPRB, 0.853074E+00_JPRB, 0.835799E+00_JPRB &
  &, 0.818378E+00_JPRB, 0.800824E+00_JPRB, 0.783149E+00_JPRB, 0.765367E+00_JPRB &
  &, 0.747491E+00_JPRB, 0.729533E+00_JPRB, 0.711512E+00_JPRB &
  &, 0.693436E+00_JPRB, 0.675325E+00_JPRB, 0.657190E+00_JPRB, 0.639050E+00_JPRB &
  &, 0.620917E+00_JPRB, 0.602808E+00_JPRB, 0.584741E+00_JPRB &
  &, 0.566732E+00_JPRB, 0.548795E+00_JPRB, 0.530951E+00_JPRB, 0.513212E+00_JPRB &
  &, 0.495601E+00_JPRB, 0.478132E+00_JPRB, 0.460822E+00_JPRB &
  &, 0.443692E+00_JPRB, 0.426755E+00_JPRB, 0.410032E+00_JPRB, 0.393538E+00_JPRB &
  &, 0.377290E+00_JPRB, 0.361304E+00_JPRB, 0.345596E+00_JPRB &
  &, 0.330178E+00_JPRB, 0.315075E+00_JPRB, 0.300296E+00_JPRB, 0.285847E+00_JPRB &
  &, 0.271751E+00_JPRB, 0.258025E+00_JPRB, 0.244662E+00_JPRB &
  &, 0.231678E+00_JPRB, 0.219086E+00_JPRB, 0.206900E+00_JPRB, 0.195109E+00_JPRB &
  &, 0.183734E+00_JPRB, 0.172773E+00_JPRB, 0.162219E+00_JPRB &
  &, 0.152090E+00_JPRB, 0.142390E+00_JPRB, 0.133090E+00_JPRB, 0.124216E+00_JPRB &
  &, 0.115749E+00_JPRB, 0.107695E+00_JPRB, 0.100042E+00_JPRB &
  &, 0.927762E-01_JPRB, 0.859117E-01_JPRB, 0.794121E-01_JPRB, 0.732853E-01_JPRB &
  &, 0.675381E-01_JPRB, 0.621235E-01_JPRB, 0.570416E-01_JPRB &
  &, 0.522904E-01_JPRB, 0.478663E-01_JPRB, 0.437254E-01_JPRB, 0.398765E-01_JPRB &
  &, 0.363080E-01_JPRB, 0.330056E-01_JPRB, 0.299525E-01_JPRB &
  &, 0.271293E-01_JPRB, 0.245351E-01_JPRB, 0.221461E-01_JPRB, 0.199575E-01_JPRB &
  &, 0.179408E-01_JPRB, 0.161105E-01_JPRB, 0.144343E-01_JPRB &
  &, 0.129248E-01_JPRB, 0.115207E-01_JPRB, 0.102815E-01_JPRB, 0.914210E-02_JPRB &
  &, 0.813687E-02_JPRB, 0.719512E-02_JPRB, 0.637690E-02_JPRB &
  &, 0.563515E-02_JPRB, 0.497559E-02_JPRB, 0.437514E-02_JPRB, 0.383820E-02_JPRB &
  &, 0.336922E-02_JPRB, 0.294226E-02_JPRB, 0.256034E-02_JPRB &
  &, 0.225821E-02_JPRB, 0.194405E-02_JPRB, 0.168328E-02_JPRB, 0.147918E-02_JPRB &
  &, 0.126717E-02_JPRB, 0.108169E-02_JPRB, 0.959582E-03_JPRB &
  &, 0.797043E-03_JPRB, 0.701327E-03_JPRB, 0.602041E-03_JPRB, 0.499131E-03_JPRB &
  &, 0.430797E-03_JPRB, 0.360001E-03_JPRB, 0.326238E-03_JPRB &
  &, 0.251059E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 272, :) = (/ &
  &  0.937120E+00_JPRB, 0.920826E+00_JPRB, 0.904322E+00_JPRB, 0.887624E+00_JPRB &
  &, 0.870741E+00_JPRB, 0.853686E+00_JPRB, 0.836471E+00_JPRB &
  &, 0.819107E+00_JPRB, 0.801607E+00_JPRB, 0.783985E+00_JPRB, 0.766254E+00_JPRB &
  &, 0.748426E+00_JPRB, 0.730515E+00_JPRB, 0.712538E+00_JPRB &
  &, 0.694504E+00_JPRB, 0.676432E+00_JPRB, 0.658335E+00_JPRB, 0.640230E+00_JPRB &
  &, 0.622130E+00_JPRB, 0.604051E+00_JPRB, 0.586012E+00_JPRB &
  &, 0.568025E+00_JPRB, 0.550115E+00_JPRB, 0.532287E+00_JPRB, 0.514569E+00_JPRB &
  &, 0.496973E+00_JPRB, 0.479518E+00_JPRB, 0.462218E+00_JPRB &
  &, 0.445092E+00_JPRB, 0.428161E+00_JPRB, 0.411441E+00_JPRB, 0.394948E+00_JPRB &
  &, 0.378697E+00_JPRB, 0.362706E+00_JPRB, 0.346989E+00_JPRB &
  &, 0.331564E+00_JPRB, 0.316448E+00_JPRB, 0.301656E+00_JPRB, 0.287190E+00_JPRB &
  &, 0.273077E+00_JPRB, 0.259321E+00_JPRB, 0.245937E+00_JPRB &
  &, 0.232941E+00_JPRB, 0.220324E+00_JPRB, 0.208099E+00_JPRB, 0.196289E+00_JPRB &
  &, 0.184883E+00_JPRB, 0.173887E+00_JPRB, 0.163309E+00_JPRB &
  &, 0.153142E+00_JPRB, 0.143399E+00_JPRB, 0.134069E+00_JPRB, 0.125162E+00_JPRB &
  &, 0.116660E+00_JPRB, 0.108567E+00_JPRB, 0.100875E+00_JPRB &
  &, 0.935821E-01_JPRB, 0.866729E-01_JPRB, 0.801422E-01_JPRB, 0.739824E-01_JPRB &
  &, 0.681832E-01_JPRB, 0.627311E-01_JPRB, 0.576273E-01_JPRB &
  &, 0.528530E-01_JPRB, 0.483857E-01_JPRB, 0.442183E-01_JPRB, 0.403415E-01_JPRB &
  &, 0.367434E-01_JPRB, 0.334100E-01_JPRB, 0.303242E-01_JPRB &
  &, 0.274667E-01_JPRB, 0.248581E-01_JPRB, 0.224318E-01_JPRB, 0.202268E-01_JPRB &
  &, 0.181927E-01_JPRB, 0.163442E-01_JPRB, 0.146489E-01_JPRB &
  &, 0.131194E-01_JPRB, 0.117191E-01_JPRB, 0.104586E-01_JPRB, 0.929688E-02_JPRB &
  &, 0.826837E-02_JPRB, 0.732917E-02_JPRB, 0.648620E-02_JPRB &
  &, 0.574654E-02_JPRB, 0.506071E-02_JPRB, 0.446187E-02_JPRB, 0.392654E-02_JPRB &
  &, 0.342921E-02_JPRB, 0.300335E-02_JPRB, 0.262254E-02_JPRB &
  &, 0.228988E-02_JPRB, 0.200852E-02_JPRB, 0.174890E-02_JPRB, 0.151257E-02_JPRB &
  &, 0.130115E-02_JPRB, 0.111626E-02_JPRB, 0.959582E-03_JPRB &
  &, 0.832818E-03_JPRB, 0.701327E-03_JPRB, 0.602041E-03_JPRB, 0.536756E-03_JPRB &
  &, 0.430797E-03_JPRB, 0.360001E-03_JPRB, 0.326238E-03_JPRB &
  &, 0.251059E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.136457E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 273, :) = (/ &
  &  0.937410E+00_JPRB, 0.921182E+00_JPRB, 0.904746E+00_JPRB, 0.888113E+00_JPRB &
  &, 0.871292E+00_JPRB, 0.854298E+00_JPRB, 0.837141E+00_JPRB &
  &, 0.819834E+00_JPRB, 0.802389E+00_JPRB, 0.784820E+00_JPRB, 0.767140E+00_JPRB &
  &, 0.749361E+00_JPRB, 0.731497E+00_JPRB, 0.713562E+00_JPRB &
  &, 0.695572E+00_JPRB, 0.677540E+00_JPRB, 0.659479E+00_JPRB, 0.641408E+00_JPRB &
  &, 0.623341E+00_JPRB, 0.605292E+00_JPRB, 0.587280E+00_JPRB &
  &, 0.569322E+00_JPRB, 0.551431E+00_JPRB, 0.533627E+00_JPRB, 0.515926E+00_JPRB &
  &, 0.498344E+00_JPRB, 0.480900E+00_JPRB, 0.463611E+00_JPRB &
  &, 0.446496E+00_JPRB, 0.429572E+00_JPRB, 0.412850E+00_JPRB, 0.396358E+00_JPRB &
  &, 0.380104E+00_JPRB, 0.364109E+00_JPRB, 0.348386E+00_JPRB &
  &, 0.332950E+00_JPRB, 0.317822E+00_JPRB, 0.303015E+00_JPRB, 0.288534E+00_JPRB &
  &, 0.274403E+00_JPRB, 0.260628E+00_JPRB, 0.247223E+00_JPRB &
  &, 0.234192E+00_JPRB, 0.221550E+00_JPRB, 0.209309E+00_JPRB, 0.197470E+00_JPRB &
  &, 0.186031E+00_JPRB, 0.175001E+00_JPRB, 0.164387E+00_JPRB &
  &, 0.154193E+00_JPRB, 0.144409E+00_JPRB, 0.135048E+00_JPRB, 0.126108E+00_JPRB &
  &, 0.117570E+00_JPRB, 0.109440E+00_JPRB, 0.101707E+00_JPRB &
  &, 0.943724E-01_JPRB, 0.874341E-01_JPRB, 0.808723E-01_JPRB, 0.746795E-01_JPRB &
  &, 0.688452E-01_JPRB, 0.633561E-01_JPRB, 0.582131E-01_JPRB &
  &, 0.533974E-01_JPRB, 0.489050E-01_JPRB, 0.447112E-01_JPRB, 0.408064E-01_JPRB &
  &, 0.371788E-01_JPRB, 0.338143E-01_JPRB, 0.306959E-01_JPRB &
  &, 0.278252E-01_JPRB, 0.251811E-01_JPRB, 0.227396E-01_JPRB, 0.204960E-01_JPRB &
  &, 0.184446E-01_JPRB, 0.165779E-01_JPRB, 0.148635E-01_JPRB &
  &, 0.133140E-01_JPRB, 0.118928E-01_JPRB, 0.106104E-01_JPRB, 0.945166E-02_JPRB &
  &, 0.839987E-02_JPRB, 0.746322E-02_JPRB, 0.659550E-02_JPRB &
  &, 0.583008E-02_JPRB, 0.514584E-02_JPRB, 0.454859E-02_JPRB, 0.398543E-02_JPRB &
  &, 0.348919E-02_JPRB, 0.306444E-02_JPRB, 0.268475E-02_JPRB &
  &, 0.235321E-02_JPRB, 0.204075E-02_JPRB, 0.178171E-02_JPRB, 0.154596E-02_JPRB &
  &, 0.133513E-02_JPRB, 0.115083E-02_JPRB, 0.994752E-03_JPRB &
  &, 0.868593E-03_JPRB, 0.737713E-03_JPRB, 0.639043E-03_JPRB, 0.536756E-03_JPRB &
  &, 0.469051E-03_JPRB, 0.398890E-03_JPRB, 0.326238E-03_JPRB &
  &, 0.291235E-03_JPRB, 0.214146E-03_JPRB, 0.175951E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART39',1,ZHOOK_HANDLE)
END SUBROUTINE PART39

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART40

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART40',0,ZHOOK_HANDLE)

XCW( 274, :) = (/ &
  &  0.937697E+00_JPRB, 0.921540E+00_JPRB, 0.905169E+00_JPRB, 0.888600E+00_JPRB &
  &, 0.871842E+00_JPRB, 0.854908E+00_JPRB, 0.837811E+00_JPRB &
  &, 0.820561E+00_JPRB, 0.803171E+00_JPRB, 0.785655E+00_JPRB, 0.768024E+00_JPRB &
  &, 0.750295E+00_JPRB, 0.732476E+00_JPRB, 0.714587E+00_JPRB &
  &, 0.696639E+00_JPRB, 0.678646E+00_JPRB, 0.660624E+00_JPRB, 0.642587E+00_JPRB &
  &, 0.624552E+00_JPRB, 0.606535E+00_JPRB, 0.588551E+00_JPRB &
  &, 0.570618E+00_JPRB, 0.552750E+00_JPRB, 0.534967E+00_JPRB, 0.517283E+00_JPRB &
  &, 0.499715E+00_JPRB, 0.482285E+00_JPRB, 0.465008E+00_JPRB &
  &, 0.447900E+00_JPRB, 0.430978E+00_JPRB, 0.414262E+00_JPRB, 0.397768E+00_JPRB &
  &, 0.381510E+00_JPRB, 0.365511E+00_JPRB, 0.349783E+00_JPRB &
  &, 0.334336E+00_JPRB, 0.319205E+00_JPRB, 0.304374E+00_JPRB, 0.289887E+00_JPRB &
  &, 0.275739E+00_JPRB, 0.261934E+00_JPRB, 0.248508E+00_JPRB &
  &, 0.235455E+00_JPRB, 0.222787E+00_JPRB, 0.210519E+00_JPRB, 0.198650E+00_JPRB &
  &, 0.187180E+00_JPRB, 0.176116E+00_JPRB, 0.165477E+00_JPRB &
  &, 0.155244E+00_JPRB, 0.145431E+00_JPRB, 0.136040E+00_JPRB, 0.127053E+00_JPRB &
  &, 0.118480E+00_JPRB, 0.110313E+00_JPRB, 0.102555E+00_JPRB &
  &, 0.951783E-01_JPRB, 0.882111E-01_JPRB, 0.816024E-01_JPRB, 0.753765E-01_JPRB &
  &, 0.695073E-01_JPRB, 0.639984E-01_JPRB, 0.588166E-01_JPRB &
  &, 0.539599E-01_JPRB, 0.494430E-01_JPRB, 0.452041E-01_JPRB, 0.412713E-01_JPRB &
  &, 0.376143E-01_JPRB, 0.342187E-01_JPRB, 0.310883E-01_JPRB &
  &, 0.281837E-01_JPRB, 0.255041E-01_JPRB, 0.230473E-01_JPRB, 0.207877E-01_JPRB &
  &, 0.187194E-01_JPRB, 0.168116E-01_JPRB, 0.151019E-01_JPRB &
  &, 0.135085E-01_JPRB, 0.120912E-01_JPRB, 0.107875E-01_JPRB, 0.960644E-02_JPRB &
  &, 0.853137E-02_JPRB, 0.757047E-02_JPRB, 0.673213E-02_JPRB &
  &, 0.594147E-02_JPRB, 0.525934E-02_JPRB, 0.463532E-02_JPRB, 0.407378E-02_JPRB &
  &, 0.357917E-02_JPRB, 0.312553E-02_JPRB, 0.274695E-02_JPRB &
  &, 0.238487E-02_JPRB, 0.207299E-02_JPRB, 0.181452E-02_JPRB, 0.157935E-02_JPRB &
  &, 0.136910E-02_JPRB, 0.118540E-02_JPRB, 0.102992E-02_JPRB &
  &, 0.868593E-03_JPRB, 0.737713E-03_JPRB, 0.639043E-03_JPRB, 0.536756E-03_JPRB &
  &, 0.469051E-03_JPRB, 0.398890E-03_JPRB, 0.326238E-03_JPRB &
  &, 0.291235E-03_JPRB, 0.254975E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 275, :) = (/ &
  &  0.937985E+00_JPRB, 0.921896E+00_JPRB, 0.905591E+00_JPRB, 0.889087E+00_JPRB &
  &, 0.872391E+00_JPRB, 0.855519E+00_JPRB, 0.838479E+00_JPRB &
  &, 0.821286E+00_JPRB, 0.803951E+00_JPRB, 0.786488E+00_JPRB, 0.768909E+00_JPRB &
  &, 0.751226E+00_JPRB, 0.733456E+00_JPRB, 0.715610E+00_JPRB &
  &, 0.697704E+00_JPRB, 0.679750E+00_JPRB, 0.661767E+00_JPRB, 0.643765E+00_JPRB &
  &, 0.625763E+00_JPRB, 0.607776E+00_JPRB, 0.589819E+00_JPRB &
  &, 0.571911E+00_JPRB, 0.554066E+00_JPRB, 0.536303E+00_JPRB, 0.518637E+00_JPRB &
  &, 0.501087E+00_JPRB, 0.483671E+00_JPRB, 0.466401E+00_JPRB &
  &, 0.449303E+00_JPRB, 0.432388E+00_JPRB, 0.415675E+00_JPRB, 0.399179E+00_JPRB &
  &, 0.382922E+00_JPRB, 0.366918E+00_JPRB, 0.351185E+00_JPRB &
  &, 0.335731E+00_JPRB, 0.320578E+00_JPRB, 0.305743E+00_JPRB, 0.291230E+00_JPRB &
  &, 0.277065E+00_JPRB, 0.263252E+00_JPRB, 0.249805E+00_JPRB &
  &, 0.236728E+00_JPRB, 0.224036E+00_JPRB, 0.211729E+00_JPRB, 0.199831E+00_JPRB &
  &, 0.188328E+00_JPRB, 0.177242E+00_JPRB, 0.166567E+00_JPRB &
  &, 0.156308E+00_JPRB, 0.146454E+00_JPRB, 0.137032E+00_JPRB, 0.128013E+00_JPRB &
  &, 0.119405E+00_JPRB, 0.111201E+00_JPRB, 0.103403E+00_JPRB &
  &, 0.959996E-01_JPRB, 0.889723E-01_JPRB, 0.823487E-01_JPRB, 0.760736E-01_JPRB &
  &, 0.701693E-01_JPRB, 0.646233E-01_JPRB, 0.594201E-01_JPRB &
  &, 0.545225E-01_JPRB, 0.499623E-01_JPRB, 0.457159E-01_JPRB, 0.417362E-01_JPRB &
  &, 0.380497E-01_JPRB, 0.346230E-01_JPRB, 0.314600E-01_JPRB &
  &, 0.285422E-01_JPRB, 0.258271E-01_JPRB, 0.233551E-01_JPRB, 0.210794E-01_JPRB &
  &, 0.189713E-01_JPRB, 0.170686E-01_JPRB, 0.153165E-01_JPRB &
  &, 0.137274E-01_JPRB, 0.122649E-01_JPRB, 0.109645E-01_JPRB, 0.976122E-02_JPRB &
  &, 0.868918E-02_JPRB, 0.770452E-02_JPRB, 0.684144E-02_JPRB &
  &, 0.605286E-02_JPRB, 0.534446E-02_JPRB, 0.472204E-02_JPRB, 0.413267E-02_JPRB &
  &, 0.363916E-02_JPRB, 0.318662E-02_JPRB, 0.280915E-02_JPRB &
  &, 0.244820E-02_JPRB, 0.213746E-02_JPRB, 0.184732E-02_JPRB, 0.161274E-02_JPRB &
  &, 0.140308E-02_JPRB, 0.121997E-02_JPRB, 0.102992E-02_JPRB &
  &, 0.904368E-03_JPRB, 0.774099E-03_JPRB, 0.676046E-03_JPRB, 0.574381E-03_JPRB &
  &, 0.469051E-03_JPRB, 0.398890E-03_JPRB, 0.326238E-03_JPRB &
  &, 0.291235E-03_JPRB, 0.254975E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.969989E-04_JPRB, 0.983639E-04_JPRB &
  &, 0.548704E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 276, :) = (/ &
  &  0.938274E+00_JPRB, 0.922249E+00_JPRB, 0.906012E+00_JPRB, 0.889573E+00_JPRB &
  &, 0.872939E+00_JPRB, 0.856127E+00_JPRB, 0.839147E+00_JPRB &
  &, 0.822011E+00_JPRB, 0.804731E+00_JPRB, 0.787320E+00_JPRB, 0.769792E+00_JPRB &
  &, 0.752159E+00_JPRB, 0.734434E+00_JPRB, 0.716633E+00_JPRB &
  &, 0.698769E+00_JPRB, 0.680855E+00_JPRB, 0.662908E+00_JPRB, 0.644942E+00_JPRB &
  &, 0.626974E+00_JPRB, 0.609016E+00_JPRB, 0.591090E+00_JPRB &
  &, 0.573204E+00_JPRB, 0.555385E+00_JPRB, 0.537642E+00_JPRB, 0.519994E+00_JPRB &
  &, 0.502458E+00_JPRB, 0.485053E+00_JPRB, 0.467798E+00_JPRB &
  &, 0.450707E+00_JPRB, 0.433795E+00_JPRB, 0.417088E+00_JPRB, 0.400593E+00_JPRB &
  &, 0.384333E+00_JPRB, 0.368325E+00_JPRB, 0.352582E+00_JPRB &
  &, 0.337117E+00_JPRB, 0.321961E+00_JPRB, 0.307112E+00_JPRB, 0.292584E+00_JPRB &
  &, 0.278401E+00_JPRB, 0.264569E+00_JPRB, 0.251090E+00_JPRB &
  &, 0.237991E+00_JPRB, 0.225273E+00_JPRB, 0.212950E+00_JPRB, 0.201023E+00_JPRB &
  &, 0.189489E+00_JPRB, 0.178369E+00_JPRB, 0.167671E+00_JPRB &
  &, 0.157373E+00_JPRB, 0.147491E+00_JPRB, 0.138025E+00_JPRB, 0.128973E+00_JPRB &
  &, 0.120330E+00_JPRB, 0.112088E+00_JPRB, 0.104251E+00_JPRB &
  &, 0.968055E-01_JPRB, 0.897493E-01_JPRB, 0.830788E-01_JPRB, 0.767873E-01_JPRB &
  &, 0.708483E-01_JPRB, 0.652656E-01_JPRB, 0.600059E-01_JPRB &
  &, 0.551032E-01_JPRB, 0.505003E-01_JPRB, 0.462088E-01_JPRB, 0.422205E-01_JPRB &
  &, 0.385049E-01_JPRB, 0.350476E-01_JPRB, 0.318523E-01_JPRB &
  &, 0.289007E-01_JPRB, 0.261716E-01_JPRB, 0.236628E-01_JPRB, 0.213487E-01_JPRB &
  &, 0.192461E-01_JPRB, 0.173023E-01_JPRB, 0.155310E-01_JPRB &
  &, 0.139220E-01_JPRB, 0.124633E-01_JPRB, 0.111163E-01_JPRB, 0.991600E-02_JPRB &
  &, 0.882068E-02_JPRB, 0.783857E-02_JPRB, 0.695074E-02_JPRB &
  &, 0.616425E-02_JPRB, 0.542958E-02_JPRB, 0.480877E-02_JPRB, 0.422102E-02_JPRB &
  &, 0.369915E-02_JPRB, 0.324771E-02_JPRB, 0.284025E-02_JPRB &
  &, 0.247987E-02_JPRB, 0.216969E-02_JPRB, 0.188013E-02_JPRB, 0.164614E-02_JPRB &
  &, 0.143706E-02_JPRB, 0.121997E-02_JPRB, 0.106509E-02_JPRB &
  &, 0.904368E-03_JPRB, 0.774099E-03_JPRB, 0.676046E-03_JPRB, 0.574381E-03_JPRB &
  &, 0.507305E-03_JPRB, 0.437779E-03_JPRB, 0.365768E-03_JPRB &
  &, 0.291235E-03_JPRB, 0.254975E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 277, :) = (/ &
  &  0.938253E+00_JPRB, 0.922605E+00_JPRB, 0.906433E+00_JPRB, 0.890057E+00_JPRB &
  &, 0.873488E+00_JPRB, 0.856736E+00_JPRB, 0.839814E+00_JPRB &
  &, 0.822735E+00_JPRB, 0.805509E+00_JPRB, 0.788152E+00_JPRB, 0.770675E+00_JPRB &
  &, 0.753089E+00_JPRB, 0.735412E+00_JPRB, 0.717655E+00_JPRB &
  &, 0.699832E+00_JPRB, 0.681960E+00_JPRB, 0.664049E+00_JPRB, 0.646119E+00_JPRB &
  &, 0.628184E+00_JPRB, 0.610257E+00_JPRB, 0.592357E+00_JPRB &
  &, 0.574501E+00_JPRB, 0.556701E+00_JPRB, 0.538978E+00_JPRB, 0.521351E+00_JPRB &
  &, 0.503833E+00_JPRB, 0.486439E+00_JPRB, 0.469194E+00_JPRB &
  &, 0.452111E+00_JPRB, 0.435205E+00_JPRB, 0.418501E+00_JPRB, 0.402007E+00_JPRB &
  &, 0.385748E+00_JPRB, 0.369732E+00_JPRB, 0.353983E+00_JPRB &
  &, 0.338512E+00_JPRB, 0.323343E+00_JPRB, 0.308481E+00_JPRB, 0.293937E+00_JPRB &
  &, 0.279738E+00_JPRB, 0.265875E+00_JPRB, 0.252387E+00_JPRB &
  &, 0.239264E+00_JPRB, 0.226522E+00_JPRB, 0.214172E+00_JPRB, 0.202215E+00_JPRB &
  &, 0.190650E+00_JPRB, 0.179508E+00_JPRB, 0.168761E+00_JPRB &
  &, 0.158437E+00_JPRB, 0.148527E+00_JPRB, 0.139017E+00_JPRB, 0.129933E+00_JPRB &
  &, 0.121255E+00_JPRB, 0.112976E+00_JPRB, 0.105099E+00_JPRB &
  &, 0.976269E-01_JPRB, 0.905422E-01_JPRB, 0.838251E-01_JPRB, 0.774843E-01_JPRB &
  &, 0.715273E-01_JPRB, 0.658906E-01_JPRB, 0.606271E-01_JPRB &
  &, 0.556657E-01_JPRB, 0.510382E-01_JPRB, 0.467207E-01_JPRB, 0.426854E-01_JPRB &
  &, 0.389403E-01_JPRB, 0.354722E-01_JPRB, 0.322447E-01_JPRB &
  &, 0.292592E-01_JPRB, 0.265161E-01_JPRB, 0.239706E-01_JPRB, 0.216404E-01_JPRB &
  &, 0.195209E-01_JPRB, 0.175594E-01_JPRB, 0.157695E-01_JPRB &
  &, 0.141409E-01_JPRB, 0.126618E-01_JPRB, 0.112934E-01_JPRB, 0.100708E-01_JPRB &
  &, 0.897848E-02_JPRB, 0.797262E-02_JPRB, 0.708737E-02_JPRB &
  &, 0.627564E-02_JPRB, 0.554308E-02_JPRB, 0.489549E-02_JPRB, 0.430936E-02_JPRB &
  &, 0.378912E-02_JPRB, 0.330879E-02_JPRB, 0.290246E-02_JPRB &
  &, 0.254320E-02_JPRB, 0.223416E-02_JPRB, 0.194575E-02_JPRB, 0.167953E-02_JPRB &
  &, 0.147104E-02_JPRB, 0.125454E-02_JPRB, 0.110026E-02_JPRB &
  &, 0.940142E-03_JPRB, 0.810484E-03_JPRB, 0.676046E-03_JPRB, 0.574381E-03_JPRB &
  &, 0.507305E-03_JPRB, 0.437779E-03_JPRB, 0.365768E-03_JPRB &
  &, 0.291235E-03_JPRB, 0.254975E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 278, :) = (/ &
  &  0.938848E+00_JPRB, 0.922960E+00_JPRB, 0.906854E+00_JPRB, 0.890542E+00_JPRB &
  &, 0.874034E+00_JPRB, 0.857344E+00_JPRB, 0.840480E+00_JPRB &
  &, 0.823458E+00_JPRB, 0.806288E+00_JPRB, 0.788982E+00_JPRB, 0.771556E+00_JPRB &
  &, 0.754019E+00_JPRB, 0.736388E+00_JPRB, 0.718675E+00_JPRB &
  &, 0.700896E+00_JPRB, 0.683063E+00_JPRB, 0.665191E+00_JPRB, 0.647295E+00_JPRB &
  &, 0.629392E+00_JPRB, 0.611497E+00_JPRB, 0.593625E+00_JPRB &
  &, 0.575794E+00_JPRB, 0.558020E+00_JPRB, 0.540318E+00_JPRB, 0.522708E+00_JPRB &
  &, 0.505204E+00_JPRB, 0.487825E+00_JPRB, 0.470591E+00_JPRB &
  &, 0.453514E+00_JPRB, 0.436616E+00_JPRB, 0.419913E+00_JPRB, 0.403422E+00_JPRB &
  &, 0.387159E+00_JPRB, 0.371143E+00_JPRB, 0.355389E+00_JPRB &
  &, 0.339907E+00_JPRB, 0.324726E+00_JPRB, 0.309850E+00_JPRB, 0.295291E+00_JPRB &
  &, 0.281074E+00_JPRB, 0.267203E+00_JPRB, 0.253683E+00_JPRB &
  &, 0.240538E+00_JPRB, 0.227770E+00_JPRB, 0.215394E+00_JPRB, 0.203408E+00_JPRB &
  &, 0.191823E+00_JPRB, 0.180635E+00_JPRB, 0.169864E+00_JPRB &
  &, 0.159501E+00_JPRB, 0.149563E+00_JPRB, 0.140023E+00_JPRB, 0.130893E+00_JPRB &
  &, 0.122180E+00_JPRB, 0.113878E+00_JPRB, 0.105962E+00_JPRB &
  &, 0.984482E-01_JPRB, 0.913193E-01_JPRB, 0.845714E-01_JPRB, 0.782146E-01_JPRB &
  &, 0.722064E-01_JPRB, 0.665503E-01_JPRB, 0.612306E-01_JPRB &
  &, 0.562464E-01_JPRB, 0.515761E-01_JPRB, 0.472325E-01_JPRB, 0.431697E-01_JPRB &
  &, 0.393955E-01_JPRB, 0.358765E-01_JPRB, 0.326370E-01_JPRB &
  &, 0.296177E-01_JPRB, 0.268606E-01_JPRB, 0.243003E-01_JPRB, 0.219321E-01_JPRB &
  &, 0.197728E-01_JPRB, 0.178164E-01_JPRB, 0.160079E-01_JPRB &
  &, 0.143598E-01_JPRB, 0.128354E-01_JPRB, 0.114705E-01_JPRB, 0.102514E-01_JPRB &
  &, 0.913629E-02_JPRB, 0.810667E-02_JPRB, 0.719667E-02_JPRB &
  &, 0.638703E-02_JPRB, 0.562821E-02_JPRB, 0.498222E-02_JPRB, 0.439770E-02_JPRB &
  &, 0.384911E-02_JPRB, 0.340043E-02_JPRB, 0.296466E-02_JPRB &
  &, 0.260653E-02_JPRB, 0.226639E-02_JPRB, 0.197856E-02_JPRB, 0.171292E-02_JPRB &
  &, 0.150502E-02_JPRB, 0.128912E-02_JPRB, 0.110026E-02_JPRB &
  &, 0.975917E-03_JPRB, 0.810484E-03_JPRB, 0.713049E-03_JPRB, 0.612007E-03_JPRB &
  &, 0.507305E-03_JPRB, 0.437779E-03_JPRB, 0.365768E-03_JPRB &
  &, 0.331412E-03_JPRB, 0.254975E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.138469E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 279, :) = (/ &
  &  0.939135E+00_JPRB, 0.923314E+00_JPRB, 0.907274E+00_JPRB, 0.891026E+00_JPRB &
  &, 0.874581E+00_JPRB, 0.857950E+00_JPRB, 0.841146E+00_JPRB &
  &, 0.824180E+00_JPRB, 0.807065E+00_JPRB, 0.789812E+00_JPRB, 0.772436E+00_JPRB &
  &, 0.754949E+00_JPRB, 0.737364E+00_JPRB, 0.719696E+00_JPRB &
  &, 0.701958E+00_JPRB, 0.684164E+00_JPRB, 0.666331E+00_JPRB, 0.648470E+00_JPRB &
  &, 0.630601E+00_JPRB, 0.612734E+00_JPRB, 0.594893E+00_JPRB &
  &, 0.577087E+00_JPRB, 0.559336E+00_JPRB, 0.541654E+00_JPRB, 0.524065E+00_JPRB &
  &, 0.506575E+00_JPRB, 0.489211E+00_JPRB, 0.471988E+00_JPRB &
  &, 0.454922E+00_JPRB, 0.438030E+00_JPRB, 0.421330E+00_JPRB, 0.404840E+00_JPRB &
  &, 0.388575E+00_JPRB, 0.372554E+00_JPRB, 0.356795E+00_JPRB &
  &, 0.341302E+00_JPRB, 0.326109E+00_JPRB, 0.311219E+00_JPRB, 0.296654E+00_JPRB &
  &, 0.282410E+00_JPRB, 0.268521E+00_JPRB, 0.254979E+00_JPRB &
  &, 0.241811E+00_JPRB, 0.229019E+00_JPRB, 0.216615E+00_JPRB, 0.204600E+00_JPRB &
  &, 0.192984E+00_JPRB, 0.181775E+00_JPRB, 0.170967E+00_JPRB &
  &, 0.160579E+00_JPRB, 0.150600E+00_JPRB, 0.141030E+00_JPRB, 0.131866E+00_JPRB &
  &, 0.123119E+00_JPRB, 0.114766E+00_JPRB, 0.106826E+00_JPRB &
  &, 0.992696E-01_JPRB, 0.921121E-01_JPRB, 0.853340E-01_JPRB, 0.789283E-01_JPRB &
  &, 0.728854E-01_JPRB, 0.671926E-01_JPRB, 0.618519E-01_JPRB &
  &, 0.568271E-01_JPRB, 0.521326E-01_JPRB, 0.477444E-01_JPRB, 0.436540E-01_JPRB &
  &, 0.398507E-01_JPRB, 0.363011E-01_JPRB, 0.330294E-01_JPRB &
  &, 0.299973E-01_JPRB, 0.272051E-01_JPRB, 0.246081E-01_JPRB, 0.222462E-01_JPRB &
  &, 0.200476E-01_JPRB, 0.180501E-01_JPRB, 0.162225E-01_JPRB &
  &, 0.145544E-01_JPRB, 0.130339E-01_JPRB, 0.116729E-01_JPRB, 0.104061E-01_JPRB &
  &, 0.926779E-02_JPRB, 0.824072E-02_JPRB, 0.733330E-02_JPRB &
  &, 0.649842E-02_JPRB, 0.574171E-02_JPRB, 0.506894E-02_JPRB, 0.445660E-02_JPRB &
  &, 0.393909E-02_JPRB, 0.346152E-02_JPRB, 0.302686E-02_JPRB &
  &, 0.263819E-02_JPRB, 0.229863E-02_JPRB, 0.201137E-02_JPRB, 0.174631E-02_JPRB &
  &, 0.153899E-02_JPRB, 0.132369E-02_JPRB, 0.113543E-02_JPRB &
  &, 0.975917E-03_JPRB, 0.846870E-03_JPRB, 0.713049E-03_JPRB, 0.612007E-03_JPRB &
  &, 0.545560E-03_JPRB, 0.437779E-03_JPRB, 0.405298E-03_JPRB &
  &, 0.331412E-03_JPRB, 0.295804E-03_JPRB, 0.217439E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 280, :) = (/ &
  &  0.939420E+00_JPRB, 0.923666E+00_JPRB, 0.907693E+00_JPRB, 0.891509E+00_JPRB &
  &, 0.875126E+00_JPRB, 0.858557E+00_JPRB, 0.841811E+00_JPRB &
  &, 0.824901E+00_JPRB, 0.807840E+00_JPRB, 0.790641E+00_JPRB, 0.773316E+00_JPRB &
  &, 0.755876E+00_JPRB, 0.738339E+00_JPRB, 0.720715E+00_JPRB &
  &, 0.703019E+00_JPRB, 0.685266E+00_JPRB, 0.667469E+00_JPRB, 0.649646E+00_JPRB &
  &, 0.631809E+00_JPRB, 0.613975E+00_JPRB, 0.596161E+00_JPRB &
  &, 0.578380E+00_JPRB, 0.560652E+00_JPRB, 0.542994E+00_JPRB, 0.525422E+00_JPRB &
  &, 0.507950E+00_JPRB, 0.490600E+00_JPRB, 0.473385E+00_JPRB &
  &, 0.456330E+00_JPRB, 0.439441E+00_JPRB, 0.422747E+00_JPRB, 0.406259E+00_JPRB &
  &, 0.389990E+00_JPRB, 0.373970E+00_JPRB, 0.358202E+00_JPRB &
  &, 0.342707E+00_JPRB, 0.327501E+00_JPRB, 0.312597E+00_JPRB, 0.298008E+00_JPRB &
  &, 0.283757E+00_JPRB, 0.269848E+00_JPRB, 0.256287E+00_JPRB &
  &, 0.243096E+00_JPRB, 0.230279E+00_JPRB, 0.217849E+00_JPRB, 0.205805E+00_JPRB &
  &, 0.194157E+00_JPRB, 0.182914E+00_JPRB, 0.172083E+00_JPRB &
  &, 0.161656E+00_JPRB, 0.151636E+00_JPRB, 0.142036E+00_JPRB, 0.132840E+00_JPRB &
  &, 0.124059E+00_JPRB, 0.115668E+00_JPRB, 0.107689E+00_JPRB &
  &, 0.100106E+00_JPRB, 0.929050E-01_JPRB, 0.860965E-01_JPRB, 0.796420E-01_JPRB &
  &, 0.735644E-01_JPRB, 0.678349E-01_JPRB, 0.624554E-01_JPRB &
  &, 0.574078E-01_JPRB, 0.526890E-01_JPRB, 0.482562E-01_JPRB, 0.441383E-01_JPRB &
  &, 0.403059E-01_JPRB, 0.367459E-01_JPRB, 0.334424E-01_JPRB &
  &, 0.303769E-01_JPRB, 0.275496E-01_JPRB, 0.249378E-01_JPRB, 0.225379E-01_JPRB &
  &, 0.203453E-01_JPRB, 0.183071E-01_JPRB, 0.164609E-01_JPRB &
  &, 0.147733E-01_JPRB, 0.132324E-01_JPRB, 0.118500E-01_JPRB, 0.105867E-01_JPRB &
  &, 0.942559E-02_JPRB, 0.837477E-02_JPRB, 0.744260E-02_JPRB &
  &, 0.660981E-02_JPRB, 0.585521E-02_JPRB, 0.515567E-02_JPRB, 0.454494E-02_JPRB &
  &, 0.399908E-02_JPRB, 0.352261E-02_JPRB, 0.308907E-02_JPRB &
  &, 0.270152E-02_JPRB, 0.236310E-02_JPRB, 0.207699E-02_JPRB, 0.177970E-02_JPRB &
  &, 0.157297E-02_JPRB, 0.135826E-02_JPRB, 0.117060E-02_JPRB &
  &, 0.101169E-02_JPRB, 0.883256E-03_JPRB, 0.750051E-03_JPRB, 0.649632E-03_JPRB &
  &, 0.545560E-03_JPRB, 0.476668E-03_JPRB, 0.405298E-03_JPRB &
  &, 0.331412E-03_JPRB, 0.295804E-03_JPRB, 0.258927E-03_JPRB, 0.178610E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART40',1,ZHOOK_HANDLE)
END SUBROUTINE PART40

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART41

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART41',0,ZHOOK_HANDLE)

XCW( 281, :) = (/ &
  &  0.939705E+00_JPRB, 0.924019E+00_JPRB, 0.908111E+00_JPRB, 0.891991E+00_JPRB &
  &, 0.875671E+00_JPRB, 0.859161E+00_JPRB, 0.842474E+00_JPRB &
  &, 0.825622E+00_JPRB, 0.808616E+00_JPRB, 0.791470E+00_JPRB, 0.774194E+00_JPRB &
  &, 0.756805E+00_JPRB, 0.739313E+00_JPRB, 0.721734E+00_JPRB &
  &, 0.704080E+00_JPRB, 0.686368E+00_JPRB, 0.668609E+00_JPRB, 0.650820E+00_JPRB &
  &, 0.633017E+00_JPRB, 0.615212E+00_JPRB, 0.597425E+00_JPRB &
  &, 0.579673E+00_JPRB, 0.561971E+00_JPRB, 0.544333E+00_JPRB, 0.526779E+00_JPRB &
  &, 0.509322E+00_JPRB, 0.491986E+00_JPRB, 0.474785E+00_JPRB &
  &, 0.457733E+00_JPRB, 0.440855E+00_JPRB, 0.424164E+00_JPRB, 0.407678E+00_JPRB &
  &, 0.391410E+00_JPRB, 0.375381E+00_JPRB, 0.359608E+00_JPRB &
  &, 0.344102E+00_JPRB, 0.328884E+00_JPRB, 0.313976E+00_JPRB, 0.299371E+00_JPRB &
  &, 0.285103E+00_JPRB, 0.271166E+00_JPRB, 0.257594E+00_JPRB &
  &, 0.244381E+00_JPRB, 0.231539E+00_JPRB, 0.219082E+00_JPRB, 0.207009E+00_JPRB &
  &, 0.195330E+00_JPRB, 0.184066E+00_JPRB, 0.173199E+00_JPRB &
  &, 0.162734E+00_JPRB, 0.152686E+00_JPRB, 0.143056E+00_JPRB, 0.133814E+00_JPRB &
  &, 0.124998E+00_JPRB, 0.116586E+00_JPRB, 0.108567E+00_JPRB &
  &, 0.100943E+00_JPRB, 0.937138E-01_JPRB, 0.868591E-01_JPRB, 0.803722E-01_JPRB &
  &, 0.742604E-01_JPRB, 0.684946E-01_JPRB, 0.630767E-01_JPRB &
  &, 0.580066E-01_JPRB, 0.532455E-01_JPRB, 0.487870E-01_JPRB, 0.446419E-01_JPRB &
  &, 0.407611E-01_JPRB, 0.371705E-01_JPRB, 0.338347E-01_JPRB &
  &, 0.307565E-01_JPRB, 0.278942E-01_JPRB, 0.252675E-01_JPRB, 0.228296E-01_JPRB &
  &, 0.206201E-01_JPRB, 0.185642E-01_JPRB, 0.166993E-01_JPRB &
  &, 0.149921E-01_JPRB, 0.134556E-01_JPRB, 0.120271E-01_JPRB, 0.107415E-01_JPRB &
  &, 0.958340E-02_JPRB, 0.853563E-02_JPRB, 0.757923E-02_JPRB &
  &, 0.672119E-02_JPRB, 0.594033E-02_JPRB, 0.527130E-02_JPRB, 0.463328E-02_JPRB &
  &, 0.408905E-02_JPRB, 0.358369E-02_JPRB, 0.315127E-02_JPRB &
  &, 0.276485E-02_JPRB, 0.242756E-02_JPRB, 0.210980E-02_JPRB, 0.184648E-02_JPRB &
  &, 0.160695E-02_JPRB, 0.139283E-02_JPRB, 0.120577E-02_JPRB &
  &, 0.104747E-02_JPRB, 0.883256E-03_JPRB, 0.750051E-03_JPRB, 0.649632E-03_JPRB &
  &, 0.545560E-03_JPRB, 0.476668E-03_JPRB, 0.405298E-03_JPRB &
  &, 0.331412E-03_JPRB, 0.295804E-03_JPRB, 0.258927E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.983639E-04_JPRB &
  &, 0.997407E-04_JPRB, 0.555648E-04_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 282, :) = (/ &
  &  0.939991E+00_JPRB, 0.924373E+00_JPRB, 0.908529E+00_JPRB, 0.892474E+00_JPRB &
  &, 0.876215E+00_JPRB, 0.859766E+00_JPRB, 0.843137E+00_JPRB &
  &, 0.826341E+00_JPRB, 0.809390E+00_JPRB, 0.792297E+00_JPRB, 0.775072E+00_JPRB &
  &, 0.757731E+00_JPRB, 0.740286E+00_JPRB, 0.722751E+00_JPRB &
  &, 0.705141E+00_JPRB, 0.687468E+00_JPRB, 0.669746E+00_JPRB, 0.651994E+00_JPRB &
  &, 0.634224E+00_JPRB, 0.616452E+00_JPRB, 0.598693E+00_JPRB &
  &, 0.580966E+00_JPRB, 0.563287E+00_JPRB, 0.545669E+00_JPRB, 0.528132E+00_JPRB &
  &, 0.510697E+00_JPRB, 0.493372E+00_JPRB, 0.476182E+00_JPRB &
  &, 0.459141E+00_JPRB, 0.442270E+00_JPRB, 0.425581E+00_JPRB, 0.409096E+00_JPRB &
  &, 0.392830E+00_JPRB, 0.376797E+00_JPRB, 0.361018E+00_JPRB &
  &, 0.345507E+00_JPRB, 0.330277E+00_JPRB, 0.315355E+00_JPRB, 0.300735E+00_JPRB &
  &, 0.286450E+00_JPRB, 0.272504E+00_JPRB, 0.258901E+00_JPRB &
  &, 0.245665E+00_JPRB, 0.232799E+00_JPRB, 0.220315E+00_JPRB, 0.208213E+00_JPRB &
  &, 0.196515E+00_JPRB, 0.185218E+00_JPRB, 0.174315E+00_JPRB &
  &, 0.163824E+00_JPRB, 0.153735E+00_JPRB, 0.144062E+00_JPRB, 0.134802E+00_JPRB &
  &, 0.125952E+00_JPRB, 0.117488E+00_JPRB, 0.109445E+00_JPRB &
  &, 0.101780E+00_JPRB, 0.945067E-01_JPRB, 0.876216E-01_JPRB, 0.811025E-01_JPRB &
  &, 0.749564E-01_JPRB, 0.691543E-01_JPRB, 0.637157E-01_JPRB &
  &, 0.585873E-01_JPRB, 0.538020E-01_JPRB, 0.493178E-01_JPRB, 0.451262E-01_JPRB &
  &, 0.412361E-01_JPRB, 0.376153E-01_JPRB, 0.342477E-01_JPRB &
  &, 0.311361E-01_JPRB, 0.282387E-01_JPRB, 0.255973E-01_JPRB, 0.231437E-01_JPRB &
  &, 0.208949E-01_JPRB, 0.188446E-01_JPRB, 0.169377E-01_JPRB &
  &, 0.152110E-01_JPRB, 0.136541E-01_JPRB, 0.122042E-01_JPRB, 0.109221E-01_JPRB &
  &, 0.974120E-02_JPRB, 0.866968E-02_JPRB, 0.771586E-02_JPRB &
  &, 0.683258E-02_JPRB, 0.605383E-02_JPRB, 0.535802E-02_JPRB, 0.472163E-02_JPRB &
  &, 0.414904E-02_JPRB, 0.367533E-02_JPRB, 0.321347E-02_JPRB &
  &, 0.282818E-02_JPRB, 0.245980E-02_JPRB, 0.214261E-02_JPRB, 0.187987E-02_JPRB &
  &, 0.164093E-02_JPRB, 0.142740E-02_JPRB, 0.124094E-02_JPRB &
  &, 0.104747E-02_JPRB, 0.919641E-03_JPRB, 0.787054E-03_JPRB, 0.687258E-03_JPRB &
  &, 0.583814E-03_JPRB, 0.476668E-03_JPRB, 0.405298E-03_JPRB &
  &, 0.371589E-03_JPRB, 0.295804E-03_JPRB, 0.258927E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 283, :) = (/ &
  &  0.940276E+00_JPRB, 0.924724E+00_JPRB, 0.908946E+00_JPRB, 0.892955E+00_JPRB &
  &, 0.876758E+00_JPRB, 0.860369E+00_JPRB, 0.843799E+00_JPRB &
  &, 0.827060E+00_JPRB, 0.810164E+00_JPRB, 0.793122E+00_JPRB, 0.775949E+00_JPRB &
  &, 0.758657E+00_JPRB, 0.741258E+00_JPRB, 0.723769E+00_JPRB &
  &, 0.706200E+00_JPRB, 0.688566E+00_JPRB, 0.670885E+00_JPRB, 0.653167E+00_JPRB &
  &, 0.635430E+00_JPRB, 0.617690E+00_JPRB, 0.599961E+00_JPRB &
  &, 0.582259E+00_JPRB, 0.564603E+00_JPRB, 0.547009E+00_JPRB, 0.529465E+00_JPRB &
  &, 0.512071E+00_JPRB, 0.494761E+00_JPRB, 0.477582E+00_JPRB &
  &, 0.460553E+00_JPRB, 0.443684E+00_JPRB, 0.427002E+00_JPRB, 0.410515E+00_JPRB &
  &, 0.394249E+00_JPRB, 0.378217E+00_JPRB, 0.362429E+00_JPRB &
  &, 0.346911E+00_JPRB, 0.331679E+00_JPRB, 0.316733E+00_JPRB, 0.302108E+00_JPRB &
  &, 0.287796E+00_JPRB, 0.273832E+00_JPRB, 0.260208E+00_JPRB &
  &, 0.246950E+00_JPRB, 0.234059E+00_JPRB, 0.221549E+00_JPRB, 0.209429E+00_JPRB &
  &, 0.197700E+00_JPRB, 0.186369E+00_JPRB, 0.175431E+00_JPRB &
  &, 0.164915E+00_JPRB, 0.154799E+00_JPRB, 0.145082E+00_JPRB, 0.135790E+00_JPRB &
  &, 0.126891E+00_JPRB, 0.118405E+00_JPRB, 0.110323E+00_JPRB &
  &, 0.102617E+00_JPRB, 0.953154E-01_JPRB, 0.883842E-01_JPRB, 0.818327E-01_JPRB &
  &, 0.756524E-01_JPRB, 0.698313E-01_JPRB, 0.643369E-01_JPRB &
  &, 0.591861E-01_JPRB, 0.543584E-01_JPRB, 0.498486E-01_JPRB, 0.456299E-01_JPRB &
  &, 0.416913E-01_JPRB, 0.380398E-01_JPRB, 0.346607E-01_JPRB &
  &, 0.315156E-01_JPRB, 0.286047E-01_JPRB, 0.259270E-01_JPRB, 0.234579E-01_JPRB &
  &, 0.211926E-01_JPRB, 0.191016E-01_JPRB, 0.172000E-01_JPRB &
  &, 0.154543E-01_JPRB, 0.138526E-01_JPRB, 0.124066E-01_JPRB, 0.110769E-01_JPRB &
  &, 0.989900E-02_JPRB, 0.880373E-02_JPRB, 0.782516E-02_JPRB &
  &, 0.694397E-02_JPRB, 0.616733E-02_JPRB, 0.544475E-02_JPRB, 0.480997E-02_JPRB &
  &, 0.423902E-02_JPRB, 0.373642E-02_JPRB, 0.327568E-02_JPRB &
  &, 0.285985E-02_JPRB, 0.252427E-02_JPRB, 0.220823E-02_JPRB, 0.191326E-02_JPRB &
  &, 0.167490E-02_JPRB, 0.146197E-02_JPRB, 0.124094E-02_JPRB &
  &, 0.108324E-02_JPRB, 0.919641E-03_JPRB, 0.787054E-03_JPRB, 0.687258E-03_JPRB &
  &, 0.583814E-03_JPRB, 0.515558E-03_JPRB, 0.444828E-03_JPRB &
  &, 0.371589E-03_JPRB, 0.295804E-03_JPRB, 0.258927E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 284, :) = (/ &
  &  0.940559E+00_JPRB, 0.925076E+00_JPRB, 0.909363E+00_JPRB, 0.893436E+00_JPRB &
  &, 0.877301E+00_JPRB, 0.860973E+00_JPRB, 0.844461E+00_JPRB &
  &, 0.827778E+00_JPRB, 0.810937E+00_JPRB, 0.793948E+00_JPRB, 0.776826E+00_JPRB &
  &, 0.759581E+00_JPRB, 0.742230E+00_JPRB, 0.724785E+00_JPRB &
  &, 0.707258E+00_JPRB, 0.689665E+00_JPRB, 0.672022E+00_JPRB, 0.654340E+00_JPRB &
  &, 0.636637E+00_JPRB, 0.618927E+00_JPRB, 0.601226E+00_JPRB &
  &, 0.583552E+00_JPRB, 0.565919E+00_JPRB, 0.548345E+00_JPRB, 0.530850E+00_JPRB &
  &, 0.513443E+00_JPRB, 0.496147E+00_JPRB, 0.478983E+00_JPRB &
  &, 0.461960E+00_JPRB, 0.445102E+00_JPRB, 0.428423E+00_JPRB, 0.411938E+00_JPRB &
  &, 0.395669E+00_JPRB, 0.379633E+00_JPRB, 0.363844E+00_JPRB &
  &, 0.348316E+00_JPRB, 0.333071E+00_JPRB, 0.318122E+00_JPRB, 0.303472E+00_JPRB &
  &, 0.289153E+00_JPRB, 0.275170E+00_JPRB, 0.261526E+00_JPRB &
  &, 0.248246E+00_JPRB, 0.235331E+00_JPRB, 0.222793E+00_JPRB, 0.210646E+00_JPRB &
  &, 0.198886E+00_JPRB, 0.187521E+00_JPRB, 0.176560E+00_JPRB &
  &, 0.166006E+00_JPRB, 0.155848E+00_JPRB, 0.146116E+00_JPRB, 0.136778E+00_JPRB &
  &, 0.127845E+00_JPRB, 0.119323E+00_JPRB, 0.111202E+00_JPRB &
  &, 0.103469E+00_JPRB, 0.961242E-01_JPRB, 0.891630E-01_JPRB, 0.825796E-01_JPRB &
  &, 0.763653E-01_JPRB, 0.704910E-01_JPRB, 0.649759E-01_JPRB &
  &, 0.597850E-01_JPRB, 0.549335E-01_JPRB, 0.503794E-01_JPRB, 0.461335E-01_JPRB &
  &, 0.421663E-01_JPRB, 0.384846E-01_JPRB, 0.350737E-01_JPRB &
  &, 0.318952E-01_JPRB, 0.289708E-01_JPRB, 0.262567E-01_JPRB, 0.237720E-01_JPRB &
  &, 0.214674E-01_JPRB, 0.193587E-01_JPRB, 0.174384E-01_JPRB &
  &, 0.156732E-01_JPRB, 0.140510E-01_JPRB, 0.125837E-01_JPRB, 0.112574E-01_JPRB &
  &, 0.100568E-01_JPRB, 0.896459E-02_JPRB, 0.796179E-02_JPRB &
  &, 0.708321E-02_JPRB, 0.628083E-02_JPRB, 0.556038E-02_JPRB, 0.489831E-02_JPRB &
  &, 0.432900E-02_JPRB, 0.379750E-02_JPRB, 0.333788E-02_JPRB &
  &, 0.292318E-02_JPRB, 0.255650E-02_JPRB, 0.224104E-02_JPRB, 0.194665E-02_JPRB &
  &, 0.170888E-02_JPRB, 0.146197E-02_JPRB, 0.127611E-02_JPRB &
  &, 0.111902E-02_JPRB, 0.956027E-03_JPRB, 0.824056E-03_JPRB, 0.724883E-03_JPRB &
  &, 0.622068E-03_JPRB, 0.515558E-03_JPRB, 0.444828E-03_JPRB &
  &, 0.371589E-03_JPRB, 0.336633E-03_JPRB, 0.258927E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 285, :) = (/ &
  &  0.940843E+00_JPRB, 0.925426E+00_JPRB, 0.909780E+00_JPRB, 0.893916E+00_JPRB &
  &, 0.877843E+00_JPRB, 0.861575E+00_JPRB, 0.845122E+00_JPRB &
  &, 0.828495E+00_JPRB, 0.811708E+00_JPRB, 0.794773E+00_JPRB, 0.777702E+00_JPRB &
  &, 0.760506E+00_JPRB, 0.743201E+00_JPRB, 0.725800E+00_JPRB &
  &, 0.708317E+00_JPRB, 0.690764E+00_JPRB, 0.673157E+00_JPRB, 0.655512E+00_JPRB &
  &, 0.637842E+00_JPRB, 0.620164E+00_JPRB, 0.602490E+00_JPRB &
  &, 0.584845E+00_JPRB, 0.567235E+00_JPRB, 0.549685E+00_JPRB, 0.532207E+00_JPRB &
  &, 0.514818E+00_JPRB, 0.497537E+00_JPRB, 0.480383E+00_JPRB &
  &, 0.463372E+00_JPRB, 0.446517E+00_JPRB, 0.429843E+00_JPRB, 0.413361E+00_JPRB &
  &, 0.397093E+00_JPRB, 0.381053E+00_JPRB, 0.365259E+00_JPRB &
  &, 0.349720E+00_JPRB, 0.334463E+00_JPRB, 0.319501E+00_JPRB, 0.304845E+00_JPRB &
  &, 0.290510E+00_JPRB, 0.276498E+00_JPRB, 0.262844E+00_JPRB &
  &, 0.249541E+00_JPRB, 0.236602E+00_JPRB, 0.224038E+00_JPRB, 0.211862E+00_JPRB &
  &, 0.200071E+00_JPRB, 0.188673E+00_JPRB, 0.177688E+00_JPRB &
  &, 0.167096E+00_JPRB, 0.156912E+00_JPRB, 0.147136E+00_JPRB, 0.137766E+00_JPRB &
  &, 0.128813E+00_JPRB, 0.120255E+00_JPRB, 0.112095E+00_JPRB &
  &, 0.104322E+00_JPRB, 0.969488E-01_JPRB, 0.899417E-01_JPRB, 0.833265E-01_JPRB &
  &, 0.770613E-01_JPRB, 0.711680E-01_JPRB, 0.656149E-01_JPRB &
  &, 0.604020E-01_JPRB, 0.555085E-01_JPRB, 0.509102E-01_JPRB, 0.466372E-01_JPRB &
  &, 0.426413E-01_JPRB, 0.389294E-01_JPRB, 0.354867E-01_JPRB &
  &, 0.322959E-01_JPRB, 0.293368E-01_JPRB, 0.266084E-01_JPRB, 0.240861E-01_JPRB &
  &, 0.217651E-01_JPRB, 0.196391E-01_JPRB, 0.176768E-01_JPRB &
  &, 0.158920E-01_JPRB, 0.142743E-01_JPRB, 0.127861E-01_JPRB, 0.114380E-01_JPRB &
  &, 0.102146E-01_JPRB, 0.909864E-02_JPRB, 0.809842E-02_JPRB &
  &, 0.719460E-02_JPRB, 0.639433E-02_JPRB, 0.564711E-02_JPRB, 0.498666E-02_JPRB &
  &, 0.441898E-02_JPRB, 0.388914E-02_JPRB, 0.340008E-02_JPRB &
  &, 0.298651E-02_JPRB, 0.262097E-02_JPRB, 0.227385E-02_JPRB, 0.201343E-02_JPRB &
  &, 0.174286E-02_JPRB, 0.149654E-02_JPRB, 0.131128E-02_JPRB &
  &, 0.111902E-02_JPRB, 0.992412E-03_JPRB, 0.861059E-03_JPRB, 0.724883E-03_JPRB &
  &, 0.622068E-03_JPRB, 0.515558E-03_JPRB, 0.444828E-03_JPRB &
  &, 0.371589E-03_JPRB, 0.336633E-03_JPRB, 0.258927E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.140498E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 286, :) = (/ &
  &  0.941125E+00_JPRB, 0.925777E+00_JPRB, 0.910195E+00_JPRB, 0.894395E+00_JPRB &
  &, 0.878384E+00_JPRB, 0.862176E+00_JPRB, 0.845781E+00_JPRB &
  &, 0.829212E+00_JPRB, 0.812480E+00_JPRB, 0.795597E+00_JPRB, 0.778576E+00_JPRB &
  &, 0.761429E+00_JPRB, 0.744172E+00_JPRB, 0.726814E+00_JPRB &
  &, 0.709374E+00_JPRB, 0.691861E+00_JPRB, 0.674294E+00_JPRB, 0.656683E+00_JPRB &
  &, 0.639048E+00_JPRB, 0.621398E+00_JPRB, 0.603758E+00_JPRB &
  &, 0.586135E+00_JPRB, 0.568551E+00_JPRB, 0.551021E+00_JPRB, 0.533564E+00_JPRB &
  &, 0.516193E+00_JPRB, 0.498926E+00_JPRB, 0.481784E+00_JPRB &
  &, 0.464779E+00_JPRB, 0.447935E+00_JPRB, 0.431264E+00_JPRB, 0.414788E+00_JPRB &
  &, 0.398517E+00_JPRB, 0.382473E+00_JPRB, 0.366675E+00_JPRB &
  &, 0.351134E+00_JPRB, 0.335865E+00_JPRB, 0.320889E+00_JPRB, 0.306219E+00_JPRB &
  &, 0.291867E+00_JPRB, 0.277847E+00_JPRB, 0.264162E+00_JPRB &
  &, 0.250837E+00_JPRB, 0.237873E+00_JPRB, 0.225283E+00_JPRB, 0.213078E+00_JPRB &
  &, 0.201268E+00_JPRB, 0.189837E+00_JPRB, 0.178817E+00_JPRB &
  &, 0.168200E+00_JPRB, 0.157988E+00_JPRB, 0.148170E+00_JPRB, 0.138768E+00_JPRB &
  &, 0.129767E+00_JPRB, 0.121172E+00_JPRB, 0.112973E+00_JPRB &
  &, 0.105174E+00_JPRB, 0.977575E-01_JPRB, 0.907367E-01_JPRB, 0.840733E-01_JPRB &
  &, 0.777743E-01_JPRB, 0.718450E-01_JPRB, 0.662539E-01_JPRB &
  &, 0.610008E-01_JPRB, 0.560835E-01_JPRB, 0.514600E-01_JPRB, 0.471602E-01_JPRB &
  &, 0.431361E-01_JPRB, 0.393944E-01_JPRB, 0.358997E-01_JPRB &
  &, 0.326755E-01_JPRB, 0.297029E-01_JPRB, 0.269382E-01_JPRB, 0.244003E-01_JPRB &
  &, 0.220628E-01_JPRB, 0.198962E-01_JPRB, 0.179391E-01_JPRB &
  &, 0.161353E-01_JPRB, 0.144975E-01_JPRB, 0.129885E-01_JPRB, 0.116186E-01_JPRB &
  &, 0.103724E-01_JPRB, 0.925950E-02_JPRB, 0.823505E-02_JPRB &
  &, 0.733384E-02_JPRB, 0.650783E-02_JPRB, 0.576274E-02_JPRB, 0.507500E-02_JPRB &
  &, 0.447896E-02_JPRB, 0.395023E-02_JPRB, 0.346229E-02_JPRB &
  &, 0.304984E-02_JPRB, 0.268544E-02_JPRB, 0.233947E-02_JPRB, 0.204682E-02_JPRB &
  &, 0.177684E-02_JPRB, 0.153111E-02_JPRB, 0.134645E-02_JPRB &
  &, 0.115479E-02_JPRB, 0.992412E-03_JPRB, 0.861059E-03_JPRB, 0.762508E-03_JPRB &
  &, 0.622068E-03_JPRB, 0.554447E-03_JPRB, 0.484358E-03_JPRB &
  &, 0.411765E-03_JPRB, 0.336633E-03_JPRB, 0.300415E-03_JPRB, 0.220762E-03_JPRB &
  &, 0.181292E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 287, :) = (/ &
  &  0.941408E+00_JPRB, 0.926126E+00_JPRB, 0.910610E+00_JPRB, 0.894873E+00_JPRB &
  &, 0.878924E+00_JPRB, 0.862777E+00_JPRB, 0.846441E+00_JPRB &
  &, 0.829927E+00_JPRB, 0.813250E+00_JPRB, 0.796420E+00_JPRB, 0.779450E+00_JPRB &
  &, 0.762353E+00_JPRB, 0.745141E+00_JPRB, 0.727829E+00_JPRB &
  &, 0.710430E+00_JPRB, 0.692958E+00_JPRB, 0.675428E+00_JPRB, 0.657854E+00_JPRB &
  &, 0.640250E+00_JPRB, 0.622636E+00_JPRB, 0.605023E+00_JPRB &
  &, 0.587428E+00_JPRB, 0.569867E+00_JPRB, 0.552360E+00_JPRB, 0.534921E+00_JPRB &
  &, 0.517568E+00_JPRB, 0.500316E+00_JPRB, 0.483185E+00_JPRB &
  &, 0.466191E+00_JPRB, 0.449354E+00_JPRB, 0.432689E+00_JPRB, 0.416210E+00_JPRB &
  &, 0.399941E+00_JPRB, 0.383898E+00_JPRB, 0.368094E+00_JPRB &
  &, 0.352548E+00_JPRB, 0.337267E+00_JPRB, 0.322278E+00_JPRB, 0.307592E+00_JPRB &
  &, 0.293223E+00_JPRB, 0.279185E+00_JPRB, 0.265480E+00_JPRB &
  &, 0.252133E+00_JPRB, 0.239156E+00_JPRB, 0.226540E+00_JPRB, 0.214306E+00_JPRB &
  &, 0.202466E+00_JPRB, 0.191014E+00_JPRB, 0.179959E+00_JPRB &
  &, 0.169304E+00_JPRB, 0.159052E+00_JPRB, 0.149217E+00_JPRB, 0.139770E+00_JPRB &
  &, 0.130735E+00_JPRB, 0.122104E+00_JPRB, 0.113882E+00_JPRB &
  &, 0.106042E+00_JPRB, 0.985821E-01_JPRB, 0.915155E-01_JPRB, 0.848202E-01_JPRB &
  &, 0.784872E-01_JPRB, 0.725221E-01_JPRB, 0.668930E-01_JPRB &
  &, 0.616178E-01_JPRB, 0.566585E-01_JPRB, 0.520097E-01_JPRB, 0.476639E-01_JPRB &
  &, 0.436111E-01_JPRB, 0.398392E-01_JPRB, 0.363334E-01_JPRB &
  &, 0.330762E-01_JPRB, 0.300689E-01_JPRB, 0.272899E-01_JPRB, 0.247144E-01_JPRB &
  &, 0.223605E-01_JPRB, 0.201766E-01_JPRB, 0.182013E-01_JPRB &
  &, 0.163785E-01_JPRB, 0.146960E-01_JPRB, 0.131909E-01_JPRB, 0.117992E-01_JPRB &
  &, 0.105565E-01_JPRB, 0.942037E-02_JPRB, 0.837168E-02_JPRB &
  &, 0.744522E-02_JPRB, 0.662132E-02_JPRB, 0.584947E-02_JPRB, 0.519279E-02_JPRB &
  &, 0.456894E-02_JPRB, 0.404186E-02_JPRB, 0.355559E-02_JPRB &
  &, 0.311317E-02_JPRB, 0.271767E-02_JPRB, 0.237227E-02_JPRB, 0.208021E-02_JPRB &
  &, 0.181081E-02_JPRB, 0.156568E-02_JPRB, 0.138162E-02_JPRB &
  &, 0.119057E-02_JPRB, 0.102880E-02_JPRB, 0.898061E-03_JPRB, 0.762508E-03_JPRB &
  &, 0.660322E-03_JPRB, 0.554447E-03_JPRB, 0.484358E-03_JPRB &
  &, 0.411765E-03_JPRB, 0.336633E-03_JPRB, 0.300415E-03_JPRB, 0.262914E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.562651E-04_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART41',1,ZHOOK_HANDLE)
END SUBROUTINE PART41

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART42

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART42',0,ZHOOK_HANDLE)

XCW( 288, :) = (/ &
  &  0.941692E+00_JPRB, 0.926475E+00_JPRB, 0.911024E+00_JPRB, 0.895352E+00_JPRB &
  &, 0.879465E+00_JPRB, 0.863377E+00_JPRB, 0.847099E+00_JPRB &
  &, 0.830642E+00_JPRB, 0.814020E+00_JPRB, 0.797242E+00_JPRB, 0.780323E+00_JPRB &
  &, 0.763275E+00_JPRB, 0.746109E+00_JPRB, 0.728842E+00_JPRB &
  &, 0.711487E+00_JPRB, 0.694056E+00_JPRB, 0.676563E+00_JPRB, 0.659025E+00_JPRB &
  &, 0.641456E+00_JPRB, 0.623873E+00_JPRB, 0.606287E+00_JPRB &
  &, 0.588721E+00_JPRB, 0.571186E+00_JPRB, 0.553700E+00_JPRB, 0.536278E+00_JPRB &
  &, 0.518942E+00_JPRB, 0.501705E+00_JPRB, 0.484585E+00_JPRB &
  &, 0.467602E+00_JPRB, 0.450772E+00_JPRB, 0.434110E+00_JPRB, 0.417638E+00_JPRB &
  &, 0.401370E+00_JPRB, 0.385323E+00_JPRB, 0.369514E+00_JPRB &
  &, 0.353952E+00_JPRB, 0.338669E+00_JPRB, 0.323676E+00_JPRB, 0.308976E+00_JPRB &
  &, 0.294590E+00_JPRB, 0.280523E+00_JPRB, 0.266809E+00_JPRB &
  &, 0.253440E+00_JPRB, 0.240428E+00_JPRB, 0.227796E+00_JPRB, 0.215534E+00_JPRB &
  &, 0.203663E+00_JPRB, 0.192179E+00_JPRB, 0.181100E+00_JPRB &
  &, 0.170407E+00_JPRB, 0.160128E+00_JPRB, 0.150251E+00_JPRB, 0.140787E+00_JPRB &
  &, 0.131718E+00_JPRB, 0.123051E+00_JPRB, 0.114775E+00_JPRB &
  &, 0.106894E+00_JPRB, 0.994067E-01_JPRB, 0.923105E-01_JPRB, 0.855836E-01_JPRB &
  &, 0.792172E-01_JPRB, 0.732165E-01_JPRB, 0.675497E-01_JPRB &
  &, 0.622348E-01_JPRB, 0.572335E-01_JPRB, 0.525595E-01_JPRB, 0.481869E-01_JPRB &
  &, 0.441059E-01_JPRB, 0.403043E-01_JPRB, 0.367670E-01_JPRB &
  &, 0.334768E-01_JPRB, 0.304350E-01_JPRB, 0.276416E-01_JPRB, 0.250510E-01_JPRB &
  &, 0.226582E-01_JPRB, 0.204570E-01_JPRB, 0.184397E-01_JPRB &
  &, 0.165974E-01_JPRB, 0.149193E-01_JPRB, 0.133933E-01_JPRB, 0.119798E-01_JPRB &
  &, 0.107143E-01_JPRB, 0.955442E-02_JPRB, 0.850831E-02_JPRB &
  &, 0.758446E-02_JPRB, 0.673482E-02_JPRB, 0.596510E-02_JPRB, 0.528113E-02_JPRB &
  &, 0.465892E-02_JPRB, 0.410295E-02_JPRB, 0.361780E-02_JPRB &
  &, 0.317650E-02_JPRB, 0.278214E-02_JPRB, 0.243789E-02_JPRB, 0.211360E-02_JPRB &
  &, 0.184479E-02_JPRB, 0.160025E-02_JPRB, 0.141679E-02_JPRB &
  &, 0.122634E-02_JPRB, 0.106518E-02_JPRB, 0.898061E-03_JPRB, 0.800134E-03_JPRB &
  &, 0.660322E-03_JPRB, 0.593336E-03_JPRB, 0.484358E-03_JPRB &
  &, 0.411765E-03_JPRB, 0.336633E-03_JPRB, 0.300415E-03_JPRB, 0.262914E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.997407E-04_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 289, :) = (/ &
  &  0.941973E+00_JPRB, 0.926824E+00_JPRB, 0.911439E+00_JPRB, 0.895829E+00_JPRB &
  &, 0.880004E+00_JPRB, 0.863976E+00_JPRB, 0.847757E+00_JPRB &
  &, 0.831357E+00_JPRB, 0.814788E+00_JPRB, 0.798064E+00_JPRB, 0.781196E+00_JPRB &
  &, 0.764195E+00_JPRB, 0.747077E+00_JPRB, 0.729855E+00_JPRB &
  &, 0.712542E+00_JPRB, 0.695150E+00_JPRB, 0.677697E+00_JPRB, 0.660196E+00_JPRB &
  &, 0.642659E+00_JPRB, 0.625107E+00_JPRB, 0.607552E+00_JPRB &
  &, 0.590011E+00_JPRB, 0.572502E+00_JPRB, 0.555036E+00_JPRB, 0.537635E+00_JPRB &
  &, 0.520317E+00_JPRB, 0.503095E+00_JPRB, 0.485989E+00_JPRB &
  &, 0.469018E+00_JPRB, 0.452195E+00_JPRB, 0.435535E+00_JPRB, 0.419065E+00_JPRB &
  &, 0.402798E+00_JPRB, 0.386747E+00_JPRB, 0.370934E+00_JPRB &
  &, 0.355375E+00_JPRB, 0.340080E+00_JPRB, 0.325064E+00_JPRB, 0.310349E+00_JPRB &
  &, 0.295958E+00_JPRB, 0.281872E+00_JPRB, 0.268138E+00_JPRB &
  &, 0.254746E+00_JPRB, 0.241710E+00_JPRB, 0.229053E+00_JPRB, 0.216763E+00_JPRB &
  &, 0.204861E+00_JPRB, 0.193356E+00_JPRB, 0.182242E+00_JPRB &
  &, 0.171524E+00_JPRB, 0.161205E+00_JPRB, 0.151298E+00_JPRB, 0.141789E+00_JPRB &
  &, 0.132686E+00_JPRB, 0.123983E+00_JPRB, 0.115684E+00_JPRB &
  &, 0.107762E+00_JPRB, 0.100247E+00_JPRB, 0.931055E-01_JPRB, 0.863471E-01_JPRB &
  &, 0.799471E-01_JPRB, 0.738935E-01_JPRB, 0.682065E-01_JPRB &
  &, 0.628518E-01_JPRB, 0.578271E-01_JPRB, 0.531093E-01_JPRB, 0.487100E-01_JPRB &
  &, 0.446007E-01_JPRB, 0.407693E-01_JPRB, 0.372007E-01_JPRB &
  &, 0.338775E-01_JPRB, 0.308225E-01_JPRB, 0.279933E-01_JPRB, 0.253651E-01_JPRB &
  &, 0.229559E-01_JPRB, 0.207374E-01_JPRB, 0.187020E-01_JPRB &
  &, 0.168406E-01_JPRB, 0.151425E-01_JPRB, 0.135957E-01_JPRB, 0.121603E-01_JPRB &
  &, 0.108721E-01_JPRB, 0.971528E-02_JPRB, 0.867226E-02_JPRB &
  &, 0.769585E-02_JPRB, 0.684832E-02_JPRB, 0.608073E-02_JPRB, 0.536948E-02_JPRB &
  &, 0.474890E-02_JPRB, 0.419458E-02_JPRB, 0.368000E-02_JPRB &
  &, 0.323983E-02_JPRB, 0.284661E-02_JPRB, 0.250351E-02_JPRB, 0.218038E-02_JPRB &
  &, 0.191275E-02_JPRB, 0.163482E-02_JPRB, 0.145196E-02_JPRB &
  &, 0.126211E-02_JPRB, 0.106518E-02_JPRB, 0.935064E-03_JPRB, 0.800134E-03_JPRB &
  &, 0.698577E-03_JPRB, 0.593336E-03_JPRB, 0.523887E-03_JPRB &
  &, 0.411765E-03_JPRB, 0.377463E-03_JPRB, 0.300415E-03_JPRB, 0.262914E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 290, :) = (/ &
  &  0.942255E+00_JPRB, 0.927172E+00_JPRB, 0.911852E+00_JPRB, 0.896306E+00_JPRB &
  &, 0.880543E+00_JPRB, 0.864574E+00_JPRB, 0.848414E+00_JPRB &
  &, 0.832070E+00_JPRB, 0.815557E+00_JPRB, 0.798885E+00_JPRB, 0.782067E+00_JPRB &
  &, 0.765116E+00_JPRB, 0.748045E+00_JPRB, 0.730866E+00_JPRB &
  &, 0.713597E+00_JPRB, 0.696246E+00_JPRB, 0.678830E+00_JPRB, 0.661365E+00_JPRB &
  &, 0.643864E+00_JPRB, 0.626341E+00_JPRB, 0.608816E+00_JPRB &
  &, 0.591304E+00_JPRB, 0.573818E+00_JPRB, 0.556376E+00_JPRB, 0.538996E+00_JPRB &
  &, 0.521692E+00_JPRB, 0.504488E+00_JPRB, 0.487394E+00_JPRB &
  &, 0.470429E+00_JPRB, 0.453613E+00_JPRB, 0.436965E+00_JPRB, 0.420496E+00_JPRB &
  &, 0.404227E+00_JPRB, 0.388176E+00_JPRB, 0.372358E+00_JPRB &
  &, 0.356789E+00_JPRB, 0.341482E+00_JPRB, 0.326463E+00_JPRB, 0.311733E+00_JPRB &
  &, 0.297325E+00_JPRB, 0.283221E+00_JPRB, 0.269467E+00_JPRB &
  &, 0.256053E+00_JPRB, 0.243004E+00_JPRB, 0.230310E+00_JPRB, 0.218003E+00_JPRB &
  &, 0.206070E+00_JPRB, 0.194532E+00_JPRB, 0.183384E+00_JPRB &
  &, 0.172641E+00_JPRB, 0.162295E+00_JPRB, 0.152346E+00_JPRB, 0.142805E+00_JPRB &
  &, 0.133669E+00_JPRB, 0.124929E+00_JPRB, 0.116592E+00_JPRB &
  &, 0.108645E+00_JPRB, 0.101088E+00_JPRB, 0.939005E-01_JPRB, 0.871106E-01_JPRB &
  &, 0.806771E-01_JPRB, 0.745879E-01_JPRB, 0.688632E-01_JPRB &
  &, 0.634687E-01_JPRB, 0.584207E-01_JPRB, 0.536780E-01_JPRB, 0.492330E-01_JPRB &
  &, 0.450955E-01_JPRB, 0.412343E-01_JPRB, 0.376343E-01_JPRB &
  &, 0.342993E-01_JPRB, 0.312101E-01_JPRB, 0.283450E-01_JPRB, 0.257017E-01_JPRB &
  &, 0.232536E-01_JPRB, 0.210178E-01_JPRB, 0.189643E-01_JPRB &
  &, 0.170838E-01_JPRB, 0.153658E-01_JPRB, 0.137981E-01_JPRB, 0.123667E-01_JPRB &
  &, 0.110562E-01_JPRB, 0.987614E-02_JPRB, 0.880889E-02_JPRB &
  &, 0.783509E-02_JPRB, 0.696182E-02_JPRB, 0.616746E-02_JPRB, 0.545782E-02_JPRB &
  &, 0.483888E-02_JPRB, 0.425567E-02_JPRB, 0.374220E-02_JPRB &
  &, 0.330316E-02_JPRB, 0.291108E-02_JPRB, 0.253632E-02_JPRB, 0.221377E-02_JPRB &
  &, 0.194672E-02_JPRB, 0.170396E-02_JPRB, 0.145196E-02_JPRB &
  &, 0.126211E-02_JPRB, 0.110157E-02_JPRB, 0.935064E-03_JPRB, 0.837759E-03_JPRB &
  &, 0.698577E-03_JPRB, 0.593336E-03_JPRB, 0.523887E-03_JPRB &
  &, 0.451942E-03_JPRB, 0.377463E-03_JPRB, 0.300415E-03_JPRB, 0.262914E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 291, :) = (/ &
  &  0.942536E+00_JPRB, 0.927521E+00_JPRB, 0.912265E+00_JPRB, 0.896782E+00_JPRB &
  &, 0.881081E+00_JPRB, 0.865173E+00_JPRB, 0.849070E+00_JPRB &
  &, 0.832783E+00_JPRB, 0.816324E+00_JPRB, 0.799704E+00_JPRB, 0.782938E+00_JPRB &
  &, 0.766036E+00_JPRB, 0.749012E+00_JPRB, 0.731878E+00_JPRB &
  &, 0.714650E+00_JPRB, 0.697340E+00_JPRB, 0.679964E+00_JPRB, 0.662535E+00_JPRB &
  &, 0.645066E+00_JPRB, 0.627578E+00_JPRB, 0.610081E+00_JPRB &
  &, 0.592593E+00_JPRB, 0.575134E+00_JPRB, 0.557712E+00_JPRB, 0.540353E+00_JPRB &
  &, 0.523067E+00_JPRB, 0.505878E+00_JPRB, 0.488798E+00_JPRB &
  &, 0.471845E+00_JPRB, 0.455036E+00_JPRB, 0.438390E+00_JPRB, 0.421927E+00_JPRB &
  &, 0.405659E+00_JPRB, 0.389605E+00_JPRB, 0.373782E+00_JPRB &
  &, 0.358203E+00_JPRB, 0.342894E+00_JPRB, 0.327861E+00_JPRB, 0.313126E+00_JPRB &
  &, 0.298692E+00_JPRB, 0.284581E+00_JPRB, 0.270796E+00_JPRB &
  &, 0.257371E+00_JPRB, 0.244287E+00_JPRB, 0.231578E+00_JPRB, 0.219243E+00_JPRB &
  &, 0.207280E+00_JPRB, 0.195709E+00_JPRB, 0.184538E+00_JPRB &
  &, 0.173758E+00_JPRB, 0.163372E+00_JPRB, 0.153393E+00_JPRB, 0.143821E+00_JPRB &
  &, 0.134651E+00_JPRB, 0.125876E+00_JPRB, 0.117501E+00_JPRB &
  &, 0.109513E+00_JPRB, 0.101928E+00_JPRB, 0.947117E-01_JPRB, 0.878740E-01_JPRB &
  &, 0.814070E-01_JPRB, 0.752823E-01_JPRB, 0.695200E-01_JPRB &
  &, 0.641039E-01_JPRB, 0.590142E-01_JPRB, 0.542277E-01_JPRB, 0.497560E-01_JPRB &
  &, 0.455903E-01_JPRB, 0.416993E-01_JPRB, 0.380680E-01_JPRB &
  &, 0.347000E-01_JPRB, 0.315762E-01_JPRB, 0.286967E-01_JPRB, 0.260383E-01_JPRB &
  &, 0.235742E-01_JPRB, 0.213216E-01_JPRB, 0.192265E-01_JPRB &
  &, 0.173270E-01_JPRB, 0.155891E-01_JPRB, 0.140004E-01_JPRB, 0.125473E-01_JPRB &
  &, 0.112403E-01_JPRB, 0.100370E-01_JPRB, 0.894552E-02_JPRB &
  &, 0.797432E-02_JPRB, 0.707532E-02_JPRB, 0.628309E-02_JPRB, 0.557561E-02_JPRB &
  &, 0.492886E-02_JPRB, 0.434730E-02_JPRB, 0.383551E-02_JPRB &
  &, 0.336649E-02_JPRB, 0.294331E-02_JPRB, 0.260194E-02_JPRB, 0.228055E-02_JPRB &
  &, 0.198070E-02_JPRB, 0.173853E-02_JPRB, 0.148713E-02_JPRB &
  &, 0.129789E-02_JPRB, 0.113795E-02_JPRB, 0.972066E-03_JPRB, 0.837759E-03_JPRB &
  &, 0.736831E-03_JPRB, 0.632225E-03_JPRB, 0.523887E-03_JPRB &
  &, 0.451942E-03_JPRB, 0.377463E-03_JPRB, 0.341902E-03_JPRB, 0.262914E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.142546E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 292, :) = (/ &
  &  0.942817E+00_JPRB, 0.927868E+00_JPRB, 0.912677E+00_JPRB, 0.897257E+00_JPRB &
  &, 0.881617E+00_JPRB, 0.865770E+00_JPRB, 0.849725E+00_JPRB &
  &, 0.833495E+00_JPRB, 0.817090E+00_JPRB, 0.800524E+00_JPRB, 0.783808E+00_JPRB &
  &, 0.766954E+00_JPRB, 0.749977E+00_JPRB, 0.732889E+00_JPRB &
  &, 0.715704E+00_JPRB, 0.698434E+00_JPRB, 0.681096E+00_JPRB, 0.663703E+00_JPRB &
  &, 0.646269E+00_JPRB, 0.628812E+00_JPRB, 0.611345E+00_JPRB &
  &, 0.593886E+00_JPRB, 0.576450E+00_JPRB, 0.559052E+00_JPRB, 0.541713E+00_JPRB &
  &, 0.524446E+00_JPRB, 0.507267E+00_JPRB, 0.490203E+00_JPRB &
  &, 0.473256E+00_JPRB, 0.456458E+00_JPRB, 0.439819E+00_JPRB, 0.423358E+00_JPRB &
  &, 0.407092E+00_JPRB, 0.391034E+00_JPRB, 0.375211E+00_JPRB &
  &, 0.359626E+00_JPRB, 0.344305E+00_JPRB, 0.329259E+00_JPRB, 0.314510E+00_JPRB &
  &, 0.300059E+00_JPRB, 0.285930E+00_JPRB, 0.272135E+00_JPRB &
  &, 0.258678E+00_JPRB, 0.245581E+00_JPRB, 0.232846E+00_JPRB, 0.220483E+00_JPRB &
  &, 0.208490E+00_JPRB, 0.196899E+00_JPRB, 0.185692E+00_JPRB &
  &, 0.174875E+00_JPRB, 0.164462E+00_JPRB, 0.154455E+00_JPRB, 0.144852E+00_JPRB &
  &, 0.135634E+00_JPRB, 0.126838E+00_JPRB, 0.118425E+00_JPRB &
  &, 0.110397E+00_JPRB, 0.102769E+00_JPRB, 0.955229E-01_JPRB, 0.886541E-01_JPRB &
  &, 0.821370E-01_JPRB, 0.759940E-01_JPRB, 0.701945E-01_JPRB &
  &, 0.647390E-01_JPRB, 0.596078E-01_JPRB, 0.547965E-01_JPRB, 0.502984E-01_JPRB &
  &, 0.460851E-01_JPRB, 0.421643E-01_JPRB, 0.385223E-01_JPRB &
  &, 0.351217E-01_JPRB, 0.319637E-01_JPRB, 0.290485E-01_JPRB, 0.263748E-01_JPRB &
  &, 0.238948E-01_JPRB, 0.216020E-01_JPRB, 0.195126E-01_JPRB &
  &, 0.175702E-01_JPRB, 0.158123E-01_JPRB, 0.142028E-01_JPRB, 0.127537E-01_JPRB &
  &, 0.113981E-01_JPRB, 0.101979E-01_JPRB, 0.910947E-02_JPRB &
  &, 0.811356E-02_JPRB, 0.721720E-02_JPRB, 0.639872E-02_JPRB, 0.566395E-02_JPRB &
  &, 0.501884E-02_JPRB, 0.443894E-02_JPRB, 0.389771E-02_JPRB &
  &, 0.342982E-02_JPRB, 0.300778E-02_JPRB, 0.263475E-02_JPRB, 0.231395E-02_JPRB &
  &, 0.201468E-02_JPRB, 0.177310E-02_JPRB, 0.152230E-02_JPRB &
  &, 0.133366E-02_JPRB, 0.113795E-02_JPRB, 0.100907E-02_JPRB, 0.875385E-03_JPRB &
  &, 0.736831E-03_JPRB, 0.632225E-03_JPRB, 0.563417E-03_JPRB &
  &, 0.451942E-03_JPRB, 0.377463E-03_JPRB, 0.341902E-03_JPRB, 0.305067E-03_JPRB &
  &, 0.224115E-03_JPRB, 0.183998E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 293, :) = (/ &
  &  0.943097E+00_JPRB, 0.928215E+00_JPRB, 0.913088E+00_JPRB, 0.897733E+00_JPRB &
  &, 0.882154E+00_JPRB, 0.866367E+00_JPRB, 0.850380E+00_JPRB &
  &, 0.834206E+00_JPRB, 0.817856E+00_JPRB, 0.801342E+00_JPRB, 0.784677E+00_JPRB &
  &, 0.767872E+00_JPRB, 0.750942E+00_JPRB, 0.733899E+00_JPRB &
  &, 0.716756E+00_JPRB, 0.699527E+00_JPRB, 0.682227E+00_JPRB, 0.664870E+00_JPRB &
  &, 0.647471E+00_JPRB, 0.630046E+00_JPRB, 0.612610E+00_JPRB &
  &, 0.595176E+00_JPRB, 0.577766E+00_JPRB, 0.560391E+00_JPRB, 0.543070E+00_JPRB &
  &, 0.525821E+00_JPRB, 0.508660E+00_JPRB, 0.491607E+00_JPRB &
  &, 0.474660E+00_JPRB, 0.457880E+00_JPRB, 0.441248E+00_JPRB, 0.424790E+00_JPRB &
  &, 0.408525E+00_JPRB, 0.392467E+00_JPRB, 0.376636E+00_JPRB &
  &, 0.361049E+00_JPRB, 0.345717E+00_JPRB, 0.330667E+00_JPRB, 0.315903E+00_JPRB &
  &, 0.301436E+00_JPRB, 0.287289E+00_JPRB, 0.273475E+00_JPRB &
  &, 0.259996E+00_JPRB, 0.246875E+00_JPRB, 0.234114E+00_JPRB, 0.221723E+00_JPRB &
  &, 0.209711E+00_JPRB, 0.198088E+00_JPRB, 0.186847E+00_JPRB &
  &, 0.176005E+00_JPRB, 0.165566E+00_JPRB, 0.155516E+00_JPRB, 0.145868E+00_JPRB &
  &, 0.136631E+00_JPRB, 0.127785E+00_JPRB, 0.119333E+00_JPRB &
  &, 0.111280E+00_JPRB, 0.103625E+00_JPRB, 0.963341E-01_JPRB, 0.894175E-01_JPRB &
  &, 0.828839E-01_JPRB, 0.767058E-01_JPRB, 0.708690E-01_JPRB &
  &, 0.653742E-01_JPRB, 0.602199E-01_JPRB, 0.553652E-01_JPRB, 0.508408E-01_JPRB &
  &, 0.465997E-01_JPRB, 0.426495E-01_JPRB, 0.389559E-01_JPRB &
  &, 0.355435E-01_JPRB, 0.323729E-01_JPRB, 0.294222E-01_JPRB, 0.267114E-01_JPRB &
  &, 0.241925E-01_JPRB, 0.218824E-01_JPRB, 0.197749E-01_JPRB &
  &, 0.178378E-01_JPRB, 0.160356E-01_JPRB, 0.144305E-01_JPRB, 0.129342E-01_JPRB &
  &, 0.115822E-01_JPRB, 0.103587E-01_JPRB, 0.924610E-02_JPRB &
  &, 0.822495E-02_JPRB, 0.733069E-02_JPRB, 0.651436E-02_JPRB, 0.578174E-02_JPRB &
  &, 0.510882E-02_JPRB, 0.450003E-02_JPRB, 0.399102E-02_JPRB &
  &, 0.349315E-02_JPRB, 0.307225E-02_JPRB, 0.270037E-02_JPRB, 0.234734E-02_JPRB &
  &, 0.204866E-02_JPRB, 0.180768E-02_JPRB, 0.155747E-02_JPRB &
  &, 0.136944E-02_JPRB, 0.117434E-02_JPRB, 0.100907E-02_JPRB, 0.875385E-03_JPRB &
  &, 0.775085E-03_JPRB, 0.671114E-03_JPRB, 0.563417E-03_JPRB &
  &, 0.492118E-03_JPRB, 0.418292E-03_JPRB, 0.341902E-03_JPRB, 0.305067E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.569714E-04_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 294, :) = (/ &
  &  0.943377E+00_JPRB, 0.928560E+00_JPRB, 0.913500E+00_JPRB, 0.898207E+00_JPRB &
  &, 0.882691E+00_JPRB, 0.866962E+00_JPRB, 0.851034E+00_JPRB &
  &, 0.834917E+00_JPRB, 0.818621E+00_JPRB, 0.802160E+00_JPRB, 0.785546E+00_JPRB &
  &, 0.768790E+00_JPRB, 0.751907E+00_JPRB, 0.734908E+00_JPRB &
  &, 0.717808E+00_JPRB, 0.700620E+00_JPRB, 0.683360E+00_JPRB, 0.666038E+00_JPRB &
  &, 0.648675E+00_JPRB, 0.631280E+00_JPRB, 0.613871E+00_JPRB &
  &, 0.596466E+00_JPRB, 0.579082E+00_JPRB, 0.561731E+00_JPRB, 0.544431E+00_JPRB &
  &, 0.527199E+00_JPRB, 0.510054E+00_JPRB, 0.493011E+00_JPRB &
  &, 0.476091E+00_JPRB, 0.459307E+00_JPRB, 0.442677E+00_JPRB, 0.426225E+00_JPRB &
  &, 0.409957E+00_JPRB, 0.393901E+00_JPRB, 0.378069E+00_JPRB &
  &, 0.362472E+00_JPRB, 0.347138E+00_JPRB, 0.332066E+00_JPRB, 0.317287E+00_JPRB &
  &, 0.302814E+00_JPRB, 0.288648E+00_JPRB, 0.274814E+00_JPRB &
  &, 0.261325E+00_JPRB, 0.248169E+00_JPRB, 0.235394E+00_JPRB, 0.222975E+00_JPRB &
  &, 0.210933E+00_JPRB, 0.199277E+00_JPRB, 0.188014E+00_JPRB &
  &, 0.177135E+00_JPRB, 0.166656E+00_JPRB, 0.156578E+00_JPRB, 0.146898E+00_JPRB &
  &, 0.137628E+00_JPRB, 0.128746E+00_JPRB, 0.120272E+00_JPRB &
  &, 0.112179E+00_JPRB, 0.104465E+00_JPRB, 0.971453E-01_JPRB, 0.901976E-01_JPRB &
  &, 0.836308E-01_JPRB, 0.774175E-01_JPRB, 0.715435E-01_JPRB &
  &, 0.660093E-01_JPRB, 0.608135E-01_JPRB, 0.559528E-01_JPRB, 0.513832E-01_JPRB &
  &, 0.471143E-01_JPRB, 0.431145E-01_JPRB, 0.394102E-01_JPRB &
  &, 0.359652E-01_JPRB, 0.327604E-01_JPRB, 0.297959E-01_JPRB, 0.270480E-01_JPRB &
  &, 0.245131E-01_JPRB, 0.221862E-01_JPRB, 0.200372E-01_JPRB &
  &, 0.180810E-01_JPRB, 0.162837E-01_JPRB, 0.146329E-01_JPRB, 0.131406E-01_JPRB &
  &, 0.117663E-01_JPRB, 0.105196E-01_JPRB, 0.941005E-02_JPRB &
  &, 0.836418E-02_JPRB, 0.744419E-02_JPRB, 0.662999E-02_JPRB, 0.587009E-02_JPRB &
  &, 0.519880E-02_JPRB, 0.459166E-02_JPRB, 0.405322E-02_JPRB &
  &, 0.355648E-02_JPRB, 0.313672E-02_JPRB, 0.276599E-02_JPRB, 0.241412E-02_JPRB &
  &, 0.211661E-02_JPRB, 0.184225E-02_JPRB, 0.159264E-02_JPRB &
  &, 0.140521E-02_JPRB, 0.121073E-02_JPRB, 0.104607E-02_JPRB, 0.913010E-03_JPRB &
  &, 0.775085E-03_JPRB, 0.671114E-03_JPRB, 0.563417E-03_JPRB &
  &, 0.492118E-03_JPRB, 0.418292E-03_JPRB, 0.341902E-03_JPRB, 0.305067E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.101130E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART42',1,ZHOOK_HANDLE)
END SUBROUTINE PART42

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART43

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART43',0,ZHOOK_HANDLE)

XCW( 295, :) = (/ &
  &  0.943656E+00_JPRB, 0.928907E+00_JPRB, 0.913910E+00_JPRB, 0.898681E+00_JPRB &
  &, 0.883226E+00_JPRB, 0.867558E+00_JPRB, 0.851687E+00_JPRB &
  &, 0.835626E+00_JPRB, 0.819385E+00_JPRB, 0.802977E+00_JPRB, 0.786413E+00_JPRB &
  &, 0.769707E+00_JPRB, 0.752870E+00_JPRB, 0.735916E+00_JPRB &
  &, 0.718859E+00_JPRB, 0.701713E+00_JPRB, 0.684491E+00_JPRB, 0.667206E+00_JPRB &
  &, 0.649875E+00_JPRB, 0.632515E+00_JPRB, 0.615136E+00_JPRB &
  &, 0.597759E+00_JPRB, 0.580397E+00_JPRB, 0.563067E+00_JPRB, 0.545788E+00_JPRB &
  &, 0.528578E+00_JPRB, 0.511447E+00_JPRB, 0.494419E+00_JPRB &
  &, 0.477507E+00_JPRB, 0.460733E+00_JPRB, 0.444110E+00_JPRB, 0.427661E+00_JPRB &
  &, 0.411394E+00_JPRB, 0.395334E+00_JPRB, 0.379498E+00_JPRB &
  &, 0.363895E+00_JPRB, 0.348549E+00_JPRB, 0.333474E+00_JPRB, 0.318690E+00_JPRB &
  &, 0.304191E+00_JPRB, 0.290018E+00_JPRB, 0.276165E+00_JPRB &
  &, 0.262643E+00_JPRB, 0.249475E+00_JPRB, 0.236662E+00_JPRB, 0.224227E+00_JPRB &
  &, 0.212155E+00_JPRB, 0.200467E+00_JPRB, 0.189168E+00_JPRB &
  &, 0.178265E+00_JPRB, 0.167759E+00_JPRB, 0.157653E+00_JPRB, 0.147943E+00_JPRB &
  &, 0.138625E+00_JPRB, 0.129708E+00_JPRB, 0.121196E+00_JPRB &
  &, 0.113062E+00_JPRB, 0.105338E+00_JPRB, 0.979728E-01_JPRB, 0.909942E-01_JPRB &
  &, 0.843777E-01_JPRB, 0.781293E-01_JPRB, 0.722180E-01_JPRB &
  &, 0.666626E-01_JPRB, 0.614256E-01_JPRB, 0.565215E-01_JPRB, 0.519256E-01_JPRB &
  &, 0.476289E-01_JPRB, 0.435998E-01_JPRB, 0.398645E-01_JPRB &
  &, 0.363870E-01_JPRB, 0.331480E-01_JPRB, 0.301696E-01_JPRB, 0.273846E-01_JPRB &
  &, 0.248337E-01_JPRB, 0.224900E-01_JPRB, 0.203233E-01_JPRB &
  &, 0.183242E-01_JPRB, 0.165070E-01_JPRB, 0.148606E-01_JPRB, 0.133212E-01_JPRB &
  &, 0.119504E-01_JPRB, 0.106804E-01_JPRB, 0.954668E-02_JPRB &
  &, 0.850342E-02_JPRB, 0.758607E-02_JPRB, 0.674562E-02_JPRB, 0.598788E-02_JPRB &
  &, 0.528878E-02_JPRB, 0.468329E-02_JPRB, 0.411542E-02_JPRB &
  &, 0.365147E-02_JPRB, 0.320118E-02_JPRB, 0.279880E-02_JPRB, 0.244751E-02_JPRB &
  &, 0.215059E-02_JPRB, 0.187682E-02_JPRB, 0.162781E-02_JPRB &
  &, 0.144099E-02_JPRB, 0.124711E-02_JPRB, 0.108307E-02_JPRB, 0.913010E-03_JPRB &
  &, 0.813339E-03_JPRB, 0.671114E-03_JPRB, 0.602947E-03_JPRB &
  &, 0.492118E-03_JPRB, 0.418292E-03_JPRB, 0.383390E-03_JPRB, 0.305067E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 296, :) = (/ &
  &  0.943936E+00_JPRB, 0.929253E+00_JPRB, 0.914312E+00_JPRB, 0.899154E+00_JPRB &
  &, 0.883760E+00_JPRB, 0.868153E+00_JPRB, 0.852340E+00_JPRB &
  &, 0.836335E+00_JPRB, 0.820149E+00_JPRB, 0.803794E+00_JPRB, 0.787281E+00_JPRB &
  &, 0.770622E+00_JPRB, 0.753834E+00_JPRB, 0.736925E+00_JPRB &
  &, 0.719911E+00_JPRB, 0.702804E+00_JPRB, 0.685620E+00_JPRB, 0.668373E+00_JPRB &
  &, 0.651077E+00_JPRB, 0.633745E+00_JPRB, 0.616400E+00_JPRB &
  &, 0.599049E+00_JPRB, 0.581713E+00_JPRB, 0.564407E+00_JPRB, 0.547149E+00_JPRB &
  &, 0.529953E+00_JPRB, 0.512840E+00_JPRB, 0.495824E+00_JPRB &
  &, 0.478926E+00_JPRB, 0.462160E+00_JPRB, 0.445544E+00_JPRB, 0.429096E+00_JPRB &
  &, 0.412831E+00_JPRB, 0.396772E+00_JPRB, 0.380931E+00_JPRB &
  &, 0.365328E+00_JPRB, 0.349970E+00_JPRB, 0.334882E+00_JPRB, 0.320084E+00_JPRB &
  &, 0.305579E+00_JPRB, 0.291378E+00_JPRB, 0.277504E+00_JPRB &
  &, 0.263972E+00_JPRB, 0.250780E+00_JPRB, 0.237942E+00_JPRB, 0.225479E+00_JPRB &
  &, 0.213389E+00_JPRB, 0.201669E+00_JPRB, 0.190349E+00_JPRB &
  &, 0.179408E+00_JPRB, 0.168863E+00_JPRB, 0.158728E+00_JPRB, 0.148973E+00_JPRB &
  &, 0.139637E+00_JPRB, 0.130684E+00_JPRB, 0.122135E+00_JPRB &
  &, 0.113961E+00_JPRB, 0.106194E+00_JPRB, 0.988002E-01_JPRB, 0.917743E-01_JPRB &
  &, 0.851246E-01_JPRB, 0.788410E-01_JPRB, 0.729103E-01_JPRB &
  &, 0.673158E-01_JPRB, 0.620377E-01_JPRB, 0.571092E-01_JPRB, 0.524680E-01_JPRB &
  &, 0.481434E-01_JPRB, 0.440850E-01_JPRB, 0.403188E-01_JPRB &
  &, 0.368088E-01_JPRB, 0.335571E-01_JPRB, 0.305433E-01_JPRB, 0.277436E-01_JPRB &
  &, 0.251543E-01_JPRB, 0.227938E-01_JPRB, 0.206094E-01_JPRB &
  &, 0.185918E-01_JPRB, 0.167550E-01_JPRB, 0.150630E-01_JPRB, 0.135276E-01_JPRB &
  &, 0.121345E-01_JPRB, 0.108681E-01_JPRB, 0.971064E-02_JPRB &
  &, 0.867051E-02_JPRB, 0.769957E-02_JPRB, 0.686125E-02_JPRB, 0.607622E-02_JPRB &
  &, 0.537876E-02_JPRB, 0.477492E-02_JPRB, 0.420873E-02_JPRB &
  &, 0.371480E-02_JPRB, 0.326565E-02_JPRB, 0.286442E-02_JPRB, 0.251429E-02_JPRB &
  &, 0.218457E-02_JPRB, 0.191139E-02_JPRB, 0.166298E-02_JPRB &
  &, 0.144099E-02_JPRB, 0.128350E-02_JPRB, 0.108307E-02_JPRB, 0.950636E-03_JPRB &
  &, 0.813339E-03_JPRB, 0.710003E-03_JPRB, 0.602947E-03_JPRB &
  &, 0.532294E-03_JPRB, 0.459121E-03_JPRB, 0.383390E-03_JPRB, 0.305067E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 297, :) = (/ &
  &  0.944215E+00_JPRB, 0.929598E+00_JPRB, 0.914730E+00_JPRB, 0.899627E+00_JPRB &
  &, 0.884295E+00_JPRB, 0.868746E+00_JPRB, 0.852993E+00_JPRB &
  &, 0.837044E+00_JPRB, 0.820912E+00_JPRB, 0.804609E+00_JPRB, 0.788148E+00_JPRB &
  &, 0.771539E+00_JPRB, 0.754796E+00_JPRB, 0.737932E+00_JPRB &
  &, 0.720960E+00_JPRB, 0.703896E+00_JPRB, 0.686750E+00_JPRB, 0.669539E+00_JPRB &
  &, 0.652278E+00_JPRB, 0.634980E+00_JPRB, 0.617662E+00_JPRB &
  &, 0.600338E+00_JPRB, 0.583029E+00_JPRB, 0.565746E+00_JPRB, 0.548509E+00_JPRB &
  &, 0.531331E+00_JPRB, 0.514233E+00_JPRB, 0.497232E+00_JPRB &
  &, 0.480345E+00_JPRB, 0.463586E+00_JPRB, 0.446977E+00_JPRB, 0.430531E+00_JPRB &
  &, 0.414273E+00_JPRB, 0.398210E+00_JPRB, 0.382369E+00_JPRB &
  &, 0.366751E+00_JPRB, 0.351391E+00_JPRB, 0.336300E+00_JPRB, 0.321477E+00_JPRB &
  &, 0.306966E+00_JPRB, 0.292748E+00_JPRB, 0.278855E+00_JPRB &
  &, 0.265300E+00_JPRB, 0.252086E+00_JPRB, 0.239233E+00_JPRB, 0.226731E+00_JPRB &
  &, 0.214611E+00_JPRB, 0.202871E+00_JPRB, 0.191516E+00_JPRB &
  &, 0.180551E+00_JPRB, 0.169980E+00_JPRB, 0.159803E+00_JPRB, 0.150018E+00_JPRB &
  &, 0.140648E+00_JPRB, 0.131661E+00_JPRB, 0.123074E+00_JPRB &
  &, 0.114875E+00_JPRB, 0.107066E+00_JPRB, 0.996277E-01_JPRB, 0.925709E-01_JPRB &
  &, 0.858885E-01_JPRB, 0.795702E-01_JPRB, 0.736026E-01_JPRB &
  &, 0.679691E-01_JPRB, 0.626684E-01_JPRB, 0.576969E-01_JPRB, 0.530298E-01_JPRB &
  &, 0.486580E-01_JPRB, 0.445904E-01_JPRB, 0.407938E-01_JPRB &
  &, 0.372516E-01_JPRB, 0.339662E-01_JPRB, 0.309169E-01_JPRB, 0.281026E-01_JPRB &
  &, 0.254978E-01_JPRB, 0.230976E-01_JPRB, 0.208955E-01_JPRB &
  &, 0.188593E-01_JPRB, 0.170031E-01_JPRB, 0.152907E-01_JPRB, 0.137339E-01_JPRB &
  &, 0.123187E-01_JPRB, 0.110290E-01_JPRB, 0.987459E-02_JPRB &
  &, 0.880974E-02_JPRB, 0.784144E-02_JPRB, 0.697689E-02_JPRB, 0.619401E-02_JPRB &
  &, 0.549873E-02_JPRB, 0.486656E-02_JPRB, 0.430203E-02_JPRB &
  &, 0.377813E-02_JPRB, 0.333012E-02_JPRB, 0.293003E-02_JPRB, 0.258107E-02_JPRB &
  &, 0.225252E-02_JPRB, 0.194596E-02_JPRB, 0.169815E-02_JPRB &
  &, 0.147676E-02_JPRB, 0.128350E-02_JPRB, 0.112008E-02_JPRB, 0.988261E-03_JPRB &
  &, 0.851594E-03_JPRB, 0.710003E-03_JPRB, 0.602947E-03_JPRB &
  &, 0.532294E-03_JPRB, 0.459121E-03_JPRB, 0.383390E-03_JPRB, 0.347219E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.144611E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 298, :) = (/ &
  &  0.944494E+00_JPRB, 0.929942E+00_JPRB, 0.915139E+00_JPRB, 0.900099E+00_JPRB &
  &, 0.884828E+00_JPRB, 0.869340E+00_JPRB, 0.853644E+00_JPRB &
  &, 0.837751E+00_JPRB, 0.821674E+00_JPRB, 0.805424E+00_JPRB, 0.789013E+00_JPRB &
  &, 0.772453E+00_JPRB, 0.755757E+00_JPRB, 0.738939E+00_JPRB &
  &, 0.722011E+00_JPRB, 0.704986E+00_JPRB, 0.687879E+00_JPRB, 0.670705E+00_JPRB &
  &, 0.653479E+00_JPRB, 0.636214E+00_JPRB, 0.618926E+00_JPRB &
  &, 0.601631E+00_JPRB, 0.584345E+00_JPRB, 0.567086E+00_JPRB, 0.549870E+00_JPRB &
  &, 0.532710E+00_JPRB, 0.515627E+00_JPRB, 0.498640E+00_JPRB &
  &, 0.481765E+00_JPRB, 0.465013E+00_JPRB, 0.448410E+00_JPRB, 0.431971E+00_JPRB &
  &, 0.415710E+00_JPRB, 0.399652E+00_JPRB, 0.383802E+00_JPRB &
  &, 0.368183E+00_JPRB, 0.352812E+00_JPRB, 0.337708E+00_JPRB, 0.322881E+00_JPRB &
  &, 0.308343E+00_JPRB, 0.294118E+00_JPRB, 0.280216E+00_JPRB &
  &, 0.266629E+00_JPRB, 0.253403E+00_JPRB, 0.240513E+00_JPRB, 0.227995E+00_JPRB &
  &, 0.215845E+00_JPRB, 0.204085E+00_JPRB, 0.192696E+00_JPRB &
  &, 0.181694E+00_JPRB, 0.171097E+00_JPRB, 0.160878E+00_JPRB, 0.151076E+00_JPRB &
  &, 0.141660E+00_JPRB, 0.132637E+00_JPRB, 0.124012E+00_JPRB &
  &, 0.115774E+00_JPRB, 0.107922E+00_JPRB, 0.100471E+00_JPRB, 0.933676E-01_JPRB &
  &, 0.866524E-01_JPRB, 0.802993E-01_JPRB, 0.742948E-01_JPRB &
  &, 0.686224E-01_JPRB, 0.632990E-01_JPRB, 0.582846E-01_JPRB, 0.535916E-01_JPRB &
  &, 0.491924E-01_JPRB, 0.450757E-01_JPRB, 0.412481E-01_JPRB &
  &, 0.376734E-01_JPRB, 0.343753E-01_JPRB, 0.312906E-01_JPRB, 0.284616E-01_JPRB &
  &, 0.258184E-01_JPRB, 0.234014E-01_JPRB, 0.211577E-01_JPRB &
  &, 0.191268E-01_JPRB, 0.172512E-01_JPRB, 0.155184E-01_JPRB, 0.139403E-01_JPRB &
  &, 0.125028E-01_JPRB, 0.112166E-01_JPRB, 0.100112E-01_JPRB &
  &, 0.894898E-02_JPRB, 0.798331E-02_JPRB, 0.709252E-02_JPRB, 0.631180E-02_JPRB &
  &, 0.558871E-02_JPRB, 0.495819E-02_JPRB, 0.436424E-02_JPRB &
  &, 0.384146E-02_JPRB, 0.339459E-02_JPRB, 0.299565E-02_JPRB, 0.261446E-02_JPRB &
  &, 0.228650E-02_JPRB, 0.201510E-02_JPRB, 0.173332E-02_JPRB &
  &, 0.151254E-02_JPRB, 0.131988E-02_JPRB, 0.115708E-02_JPRB, 0.988261E-03_JPRB &
  &, 0.851594E-03_JPRB, 0.748892E-03_JPRB, 0.642477E-03_JPRB &
  &, 0.532294E-03_JPRB, 0.459121E-03_JPRB, 0.383390E-03_JPRB, 0.347219E-03_JPRB &
  &, 0.266938E-03_JPRB, 0.227497E-03_JPRB, 0.186728E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 299, :) = (/ &
  &  0.944772E+00_JPRB, 0.930286E+00_JPRB, 0.915548E+00_JPRB, 0.900571E+00_JPRB &
  &, 0.885361E+00_JPRB, 0.869933E+00_JPRB, 0.854294E+00_JPRB &
  &, 0.838458E+00_JPRB, 0.822436E+00_JPRB, 0.806238E+00_JPRB, 0.789879E+00_JPRB &
  &, 0.773368E+00_JPRB, 0.756718E+00_JPRB, 0.739943E+00_JPRB &
  &, 0.723059E+00_JPRB, 0.706076E+00_JPRB, 0.689009E+00_JPRB, 0.671872E+00_JPRB &
  &, 0.654679E+00_JPRB, 0.637445E+00_JPRB, 0.620188E+00_JPRB &
  &, 0.602921E+00_JPRB, 0.585661E+00_JPRB, 0.568425E+00_JPRB, 0.551230E+00_JPRB &
  &, 0.534088E+00_JPRB, 0.517024E+00_JPRB, 0.500048E+00_JPRB &
  &, 0.483184E+00_JPRB, 0.466443E+00_JPRB, 0.449847E+00_JPRB, 0.433411E+00_JPRB &
  &, 0.417155E+00_JPRB, 0.401090E+00_JPRB, 0.385240E+00_JPRB &
  &, 0.369616E+00_JPRB, 0.354242E+00_JPRB, 0.339125E+00_JPRB, 0.324285E+00_JPRB &
  &, 0.309741E+00_JPRB, 0.295498E+00_JPRB, 0.281566E+00_JPRB &
  &, 0.267969E+00_JPRB, 0.254708E+00_JPRB, 0.241805E+00_JPRB, 0.229259E+00_JPRB &
  &, 0.217092E+00_JPRB, 0.205287E+00_JPRB, 0.193876E+00_JPRB &
  &, 0.182851E+00_JPRB, 0.172214E+00_JPRB, 0.161967E+00_JPRB, 0.152121E+00_JPRB &
  &, 0.142672E+00_JPRB, 0.133613E+00_JPRB, 0.124951E+00_JPRB &
  &, 0.116688E+00_JPRB, 0.108810E+00_JPRB, 0.101299E+00_JPRB, 0.941808E-01_JPRB &
  &, 0.874163E-01_JPRB, 0.810284E-01_JPRB, 0.749871E-01_JPRB &
  &, 0.692757E-01_JPRB, 0.639112E-01_JPRB, 0.588723E-01_JPRB, 0.541533E-01_JPRB &
  &, 0.497268E-01_JPRB, 0.455811E-01_JPRB, 0.417230E-01_JPRB &
  &, 0.381162E-01_JPRB, 0.347845E-01_JPRB, 0.316863E-01_JPRB, 0.288206E-01_JPRB &
  &, 0.261619E-01_JPRB, 0.237051E-01_JPRB, 0.214677E-01_JPRB &
  &, 0.193944E-01_JPRB, 0.174744E-01_JPRB, 0.157461E-01_JPRB, 0.141467E-01_JPRB &
  &, 0.127132E-01_JPRB, 0.113775E-01_JPRB, 0.101752E-01_JPRB &
  &, 0.908821E-02_JPRB, 0.809681E-02_JPRB, 0.720815E-02_JPRB, 0.640014E-02_JPRB &
  &, 0.567869E-02_JPRB, 0.504982E-02_JPRB, 0.445754E-02_JPRB &
  &, 0.393645E-02_JPRB, 0.345906E-02_JPRB, 0.302846E-02_JPRB, 0.268124E-02_JPRB &
  &, 0.235446E-02_JPRB, 0.204967E-02_JPRB, 0.180366E-02_JPRB &
  &, 0.154831E-02_JPRB, 0.135627E-02_JPRB, 0.119408E-02_JPRB, 0.102589E-02_JPRB &
  &, 0.889848E-03_JPRB, 0.748892E-03_JPRB, 0.642477E-03_JPRB &
  &, 0.572471E-03_JPRB, 0.499950E-03_JPRB, 0.424878E-03_JPRB, 0.347219E-03_JPRB &
  &, 0.309761E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.576837E-04_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 300, :) = (/ &
  &  0.945050E+00_JPRB, 0.930630E+00_JPRB, 0.915956E+00_JPRB, 0.901042E+00_JPRB &
  &, 0.885894E+00_JPRB, 0.870524E+00_JPRB, 0.854944E+00_JPRB &
  &, 0.839165E+00_JPRB, 0.823196E+00_JPRB, 0.807052E+00_JPRB, 0.790742E+00_JPRB &
  &, 0.774280E+00_JPRB, 0.757679E+00_JPRB, 0.740951E+00_JPRB &
  &, 0.724108E+00_JPRB, 0.707166E+00_JPRB, 0.690137E+00_JPRB, 0.673036E+00_JPRB &
  &, 0.655879E+00_JPRB, 0.638679E+00_JPRB, 0.621449E+00_JPRB &
  &, 0.604211E+00_JPRB, 0.586977E+00_JPRB, 0.569765E+00_JPRB, 0.552591E+00_JPRB &
  &, 0.535467E+00_JPRB, 0.518421E+00_JPRB, 0.501460E+00_JPRB &
  &, 0.484603E+00_JPRB, 0.467874E+00_JPRB, 0.451285E+00_JPRB, 0.434850E+00_JPRB &
  &, 0.418597E+00_JPRB, 0.402532E+00_JPRB, 0.386683E+00_JPRB &
  &, 0.371057E+00_JPRB, 0.355673E+00_JPRB, 0.340543E+00_JPRB, 0.325698E+00_JPRB &
  &, 0.311129E+00_JPRB, 0.296868E+00_JPRB, 0.282928E+00_JPRB &
  &, 0.269309E+00_JPRB, 0.256025E+00_JPRB, 0.243096E+00_JPRB, 0.230535E+00_JPRB &
  &, 0.218326E+00_JPRB, 0.206501E+00_JPRB, 0.195056E+00_JPRB &
  &, 0.183994E+00_JPRB, 0.173331E+00_JPRB, 0.163056E+00_JPRB, 0.153179E+00_JPRB &
  &, 0.143698E+00_JPRB, 0.134605E+00_JPRB, 0.125905E+00_JPRB &
  &, 0.117603E+00_JPRB, 0.109683E+00_JPRB, 0.102142E+00_JPRB, 0.949941E-01_JPRB &
  &, 0.881972E-01_JPRB, 0.817575E-01_JPRB, 0.756793E-01_JPRB &
  &, 0.699471E-01_JPRB, 0.645418E-01_JPRB, 0.594789E-01_JPRB, 0.547151E-01_JPRB &
  &, 0.502612E-01_JPRB, 0.460866E-01_JPRB, 0.421980E-01_JPRB &
  &, 0.385591E-01_JPRB, 0.351936E-01_JPRB, 0.320600E-01_JPRB, 0.291796E-01_JPRB &
  &, 0.265054E-01_JPRB, 0.240323E-01_JPRB, 0.217538E-01_JPRB &
  &, 0.196619E-01_JPRB, 0.177225E-01_JPRB, 0.159738E-01_JPRB, 0.143789E-01_JPRB &
  &, 0.128973E-01_JPRB, 0.115652E-01_JPRB, 0.103391E-01_JPRB &
  &, 0.925530E-02_JPRB, 0.823869E-02_JPRB, 0.735269E-02_JPRB, 0.651793E-02_JPRB &
  &, 0.579866E-02_JPRB, 0.514146E-02_JPRB, 0.455085E-02_JPRB &
  &, 0.399978E-02_JPRB, 0.352353E-02_JPRB, 0.309408E-02_JPRB, 0.271463E-02_JPRB &
  &, 0.238843E-02_JPRB, 0.208424E-02_JPRB, 0.183883E-02_JPRB &
  &, 0.158409E-02_JPRB, 0.139265E-02_JPRB, 0.119408E-02_JPRB, 0.102589E-02_JPRB &
  &, 0.889848E-03_JPRB, 0.787781E-03_JPRB, 0.682006E-03_JPRB &
  &, 0.572471E-03_JPRB, 0.499950E-03_JPRB, 0.424878E-03_JPRB, 0.347219E-03_JPRB &
  &, 0.309761E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.102530E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 301, :) = (/ &
  &  0.945328E+00_JPRB, 0.930973E+00_JPRB, 0.916364E+00_JPRB, 0.901512E+00_JPRB &
  &, 0.886425E+00_JPRB, 0.871116E+00_JPRB, 0.855594E+00_JPRB &
  &, 0.839870E+00_JPRB, 0.823956E+00_JPRB, 0.807865E+00_JPRB, 0.791606E+00_JPRB &
  &, 0.775194E+00_JPRB, 0.758639E+00_JPRB, 0.741955E+00_JPRB &
  &, 0.725156E+00_JPRB, 0.708256E+00_JPRB, 0.691265E+00_JPRB, 0.674201E+00_JPRB &
  &, 0.657078E+00_JPRB, 0.639910E+00_JPRB, 0.622714E+00_JPRB &
  &, 0.605504E+00_JPRB, 0.588293E+00_JPRB, 0.571105E+00_JPRB, 0.553951E+00_JPRB &
  &, 0.536849E+00_JPRB, 0.519814E+00_JPRB, 0.502868E+00_JPRB &
  &, 0.486027E+00_JPRB, 0.469304E+00_JPRB, 0.452722E+00_JPRB, 0.436294E+00_JPRB &
  &, 0.420042E+00_JPRB, 0.403979E+00_JPRB, 0.388125E+00_JPRB &
  &, 0.372490E+00_JPRB, 0.357103E+00_JPRB, 0.341961E+00_JPRB, 0.327102E+00_JPRB &
  &, 0.312527E+00_JPRB, 0.298249E+00_JPRB, 0.284289E+00_JPRB &
  &, 0.270649E+00_JPRB, 0.257353E+00_JPRB, 0.244399E+00_JPRB, 0.231799E+00_JPRB &
  &, 0.219572E+00_JPRB, 0.207716E+00_JPRB, 0.196249E+00_JPRB &
  &, 0.185150E+00_JPRB, 0.174462E+00_JPRB, 0.164145E+00_JPRB, 0.154238E+00_JPRB &
  &, 0.144724E+00_JPRB, 0.135596E+00_JPRB, 0.126859E+00_JPRB &
  &, 0.118517E+00_JPRB, 0.110571E+00_JPRB, 0.103002E+00_JPRB, 0.957907E-01_JPRB &
  &, 0.889780E-01_JPRB, 0.825040E-01_JPRB, 0.763893E-01_JPRB &
  &, 0.706185E-01_JPRB, 0.651910E-01_JPRB, 0.600855E-01_JPRB, 0.552769E-01_JPRB &
  &, 0.507955E-01_JPRB, 0.465920E-01_JPRB, 0.426729E-01_JPRB &
  &, 0.390230E-01_JPRB, 0.356242E-01_JPRB, 0.324557E-01_JPRB, 0.295386E-01_JPRB &
  &, 0.268260E-01_JPRB, 0.243361E-01_JPRB, 0.220399E-01_JPRB &
  &, 0.199294E-01_JPRB, 0.179954E-01_JPRB, 0.162015E-01_JPRB, 0.145852E-01_JPRB &
  &, 0.131077E-01_JPRB, 0.117529E-01_JPRB, 0.105031E-01_JPRB &
  &, 0.939453E-02_JPRB, 0.838056E-02_JPRB, 0.746833E-02_JPRB, 0.663573E-02_JPRB &
  &, 0.588864E-02_JPRB, 0.523309E-02_JPRB, 0.461305E-02_JPRB &
  &, 0.409478E-02_JPRB, 0.358799E-02_JPRB, 0.315970E-02_JPRB, 0.278141E-02_JPRB &
  &, 0.245639E-02_JPRB, 0.215338E-02_JPRB, 0.187399E-02_JPRB &
  &, 0.161986E-02_JPRB, 0.142904E-02_JPRB, 0.123108E-02_JPRB, 0.106351E-02_JPRB &
  &, 0.928102E-03_JPRB, 0.787781E-03_JPRB, 0.682006E-03_JPRB &
  &, 0.572471E-03_JPRB, 0.499950E-03_JPRB, 0.424878E-03_JPRB, 0.389372E-03_JPRB &
  &, 0.309761E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART43',1,ZHOOK_HANDLE)
END SUBROUTINE PART43

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART44

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART44',0,ZHOOK_HANDLE)

XCW( 302, :) = (/ &
  &  0.945605E+00_JPRB, 0.931316E+00_JPRB, 0.916771E+00_JPRB, 0.901982E+00_JPRB &
  &, 0.886957E+00_JPRB, 0.871707E+00_JPRB, 0.856242E+00_JPRB &
  &, 0.840575E+00_JPRB, 0.824716E+00_JPRB, 0.808677E+00_JPRB, 0.792469E+00_JPRB &
  &, 0.776105E+00_JPRB, 0.759599E+00_JPRB, 0.742960E+00_JPRB &
  &, 0.726204E+00_JPRB, 0.709344E+00_JPRB, 0.692393E+00_JPRB, 0.675366E+00_JPRB &
  &, 0.658278E+00_JPRB, 0.641140E+00_JPRB, 0.623975E+00_JPRB &
  &, 0.606794E+00_JPRB, 0.589612E+00_JPRB, 0.572444E+00_JPRB, 0.555312E+00_JPRB &
  &, 0.538228E+00_JPRB, 0.521211E+00_JPRB, 0.504280E+00_JPRB &
  &, 0.487450E+00_JPRB, 0.470735E+00_JPRB, 0.454160E+00_JPRB, 0.437738E+00_JPRB &
  &, 0.421488E+00_JPRB, 0.405426E+00_JPRB, 0.389567E+00_JPRB &
  &, 0.373931E+00_JPRB, 0.358534E+00_JPRB, 0.343389E+00_JPRB, 0.328515E+00_JPRB &
  &, 0.313925E+00_JPRB, 0.299629E+00_JPRB, 0.285650E+00_JPRB &
  &, 0.271989E+00_JPRB, 0.258670E+00_JPRB, 0.245702E+00_JPRB, 0.233075E+00_JPRB &
  &, 0.220818E+00_JPRB, 0.208943E+00_JPRB, 0.197442E+00_JPRB &
  &, 0.186320E+00_JPRB, 0.175592E+00_JPRB, 0.165247E+00_JPRB, 0.155296E+00_JPRB &
  &, 0.145750E+00_JPRB, 0.136587E+00_JPRB, 0.127828E+00_JPRB &
  &, 0.119447E+00_JPRB, 0.111459E+00_JPRB, 0.103846E+00_JPRB, 0.966206E-01_JPRB &
  &, 0.897589E-01_JPRB, 0.832505E-01_JPRB, 0.770994E-01_JPRB &
  &, 0.712899E-01_JPRB, 0.658217E-01_JPRB, 0.606921E-01_JPRB, 0.558580E-01_JPRB &
  &, 0.513299E-01_JPRB, 0.470975E-01_JPRB, 0.431479E-01_JPRB &
  &, 0.394659E-01_JPRB, 0.360333E-01_JPRB, 0.328514E-01_JPRB, 0.298976E-01_JPRB &
  &, 0.271695E-01_JPRB, 0.246632E-01_JPRB, 0.223498E-01_JPRB &
  &, 0.201970E-01_JPRB, 0.182435E-01_JPRB, 0.164545E-01_JPRB, 0.147916E-01_JPRB &
  &, 0.132918E-01_JPRB, 0.119137E-01_JPRB, 0.106670E-01_JPRB &
  &, 0.953377E-02_JPRB, 0.852244E-02_JPRB, 0.758396E-02_JPRB, 0.675352E-02_JPRB &
  &, 0.600861E-02_JPRB, 0.532472E-02_JPRB, 0.470636E-02_JPRB &
  &, 0.415811E-02_JPRB, 0.365246E-02_JPRB, 0.322532E-02_JPRB, 0.284819E-02_JPRB &
  &, 0.249037E-02_JPRB, 0.218795E-02_JPRB, 0.190916E-02_JPRB &
  &, 0.165564E-02_JPRB, 0.146543E-02_JPRB, 0.126809E-02_JPRB, 0.110114E-02_JPRB &
  &, 0.928102E-03_JPRB, 0.826670E-03_JPRB, 0.721536E-03_JPRB &
  &, 0.612648E-03_JPRB, 0.499950E-03_JPRB, 0.424878E-03_JPRB, 0.389372E-03_JPRB &
  &, 0.309761E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 303, :) = (/ &
  &  0.945881E+00_JPRB, 0.931659E+00_JPRB, 0.917178E+00_JPRB, 0.902451E+00_JPRB &
  &, 0.887488E+00_JPRB, 0.872297E+00_JPRB, 0.856891E+00_JPRB &
  &, 0.841280E+00_JPRB, 0.825474E+00_JPRB, 0.809489E+00_JPRB, 0.793332E+00_JPRB &
  &, 0.777017E+00_JPRB, 0.760557E+00_JPRB, 0.743964E+00_JPRB &
  &, 0.727251E+00_JPRB, 0.710431E+00_JPRB, 0.693521E+00_JPRB, 0.676531E+00_JPRB &
  &, 0.659477E+00_JPRB, 0.642375E+00_JPRB, 0.625236E+00_JPRB &
  &, 0.608083E+00_JPRB, 0.590928E+00_JPRB, 0.573784E+00_JPRB, 0.556673E+00_JPRB &
  &, 0.539610E+00_JPRB, 0.522608E+00_JPRB, 0.505692E+00_JPRB &
  &, 0.488873E+00_JPRB, 0.472169E+00_JPRB, 0.455601E+00_JPRB, 0.439182E+00_JPRB &
  &, 0.422934E+00_JPRB, 0.406873E+00_JPRB, 0.391010E+00_JPRB &
  &, 0.375373E+00_JPRB, 0.359965E+00_JPRB, 0.344816E+00_JPRB, 0.329929E+00_JPRB &
  &, 0.315323E+00_JPRB, 0.301020E+00_JPRB, 0.287022E+00_JPRB &
  &, 0.273341E+00_JPRB, 0.259998E+00_JPRB, 0.247006E+00_JPRB, 0.234362E+00_JPRB &
  &, 0.222077E+00_JPRB, 0.210170E+00_JPRB, 0.198635E+00_JPRB &
  &, 0.187489E+00_JPRB, 0.176723E+00_JPRB, 0.166350E+00_JPRB, 0.156369E+00_JPRB &
  &, 0.146790E+00_JPRB, 0.137593E+00_JPRB, 0.128782E+00_JPRB &
  &, 0.120377E+00_JPRB, 0.112347E+00_JPRB, 0.104706E+00_JPRB, 0.974338E-01_JPRB &
  &, 0.905398E-01_JPRB, 0.839969E-01_JPRB, 0.778094E-01_JPRB &
  &, 0.719795E-01_JPRB, 0.664709E-01_JPRB, 0.612988E-01_JPRB, 0.564392E-01_JPRB &
  &, 0.518841E-01_JPRB, 0.476231E-01_JPRB, 0.436228E-01_JPRB &
  &, 0.399087E-01_JPRB, 0.364640E-01_JPRB, 0.332471E-01_JPRB, 0.302791E-01_JPRB &
  &, 0.275359E-01_JPRB, 0.249904E-01_JPRB, 0.226359E-01_JPRB &
  &, 0.204888E-01_JPRB, 0.184915E-01_JPRB, 0.166822E-01_JPRB, 0.150238E-01_JPRB &
  &, 0.135022E-01_JPRB, 0.121014E-01_JPRB, 0.108583E-01_JPRB &
  &, 0.970086E-02_JPRB, 0.866431E-02_JPRB, 0.772850E-02_JPRB, 0.687131E-02_JPRB &
  &, 0.609859E-02_JPRB, 0.541636E-02_JPRB, 0.479966E-02_JPRB &
  &, 0.425310E-02_JPRB, 0.374916E-02_JPRB, 0.329094E-02_JPRB, 0.288158E-02_JPRB &
  &, 0.255832E-02_JPRB, 0.222252E-02_JPRB, 0.194433E-02_JPRB &
  &, 0.169141E-02_JPRB, 0.146543E-02_JPRB, 0.130509E-02_JPRB, 0.110114E-02_JPRB &
  &, 0.966356E-03_JPRB, 0.826670E-03_JPRB, 0.721536E-03_JPRB &
  &, 0.612648E-03_JPRB, 0.540779E-03_JPRB, 0.466366E-03_JPRB, 0.389372E-03_JPRB &
  &, 0.309761E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.146694E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 304, :) = (/ &
  &  0.946157E+00_JPRB, 0.932000E+00_JPRB, 0.917584E+00_JPRB, 0.902921E+00_JPRB &
  &, 0.888016E+00_JPRB, 0.872886E+00_JPRB, 0.857538E+00_JPRB &
  &, 0.841983E+00_JPRB, 0.826233E+00_JPRB, 0.810299E+00_JPRB, 0.794194E+00_JPRB &
  &, 0.777927E+00_JPRB, 0.761514E+00_JPRB, 0.744967E+00_JPRB &
  &, 0.728297E+00_JPRB, 0.711520E+00_JPRB, 0.694647E+00_JPRB, 0.677694E+00_JPRB &
  &, 0.660675E+00_JPRB, 0.643605E+00_JPRB, 0.626501E+00_JPRB &
  &, 0.609373E+00_JPRB, 0.592244E+00_JPRB, 0.575127E+00_JPRB, 0.558037E+00_JPRB &
  &, 0.540989E+00_JPRB, 0.524009E+00_JPRB, 0.507104E+00_JPRB &
  &, 0.490296E+00_JPRB, 0.473604E+00_JPRB, 0.457043E+00_JPRB, 0.440630E+00_JPRB &
  &, 0.424384E+00_JPRB, 0.408319E+00_JPRB, 0.392457E+00_JPRB &
  &, 0.376815E+00_JPRB, 0.361405E+00_JPRB, 0.346234E+00_JPRB, 0.331342E+00_JPRB &
  &, 0.316721E+00_JPRB, 0.302400E+00_JPRB, 0.288383E+00_JPRB &
  &, 0.274692E+00_JPRB, 0.261326E+00_JPRB, 0.248309E+00_JPRB, 0.235638E+00_JPRB &
  &, 0.223336E+00_JPRB, 0.211397E+00_JPRB, 0.199828E+00_JPRB &
  &, 0.188659E+00_JPRB, 0.177854E+00_JPRB, 0.167453E+00_JPRB, 0.157442E+00_JPRB &
  &, 0.147816E+00_JPRB, 0.138599E+00_JPRB, 0.129751E+00_JPRB &
  &, 0.121307E+00_JPRB, 0.113251E+00_JPRB, 0.105566E+00_JPRB, 0.982637E-01_JPRB &
  &, 0.913206E-01_JPRB, 0.847608E-01_JPRB, 0.785371E-01_JPRB &
  &, 0.726509E-01_JPRB, 0.671201E-01_JPRB, 0.619054E-01_JPRB, 0.570203E-01_JPRB &
  &, 0.524185E-01_JPRB, 0.481286E-01_JPRB, 0.441184E-01_JPRB &
  &, 0.403727E-01_JPRB, 0.368946E-01_JPRB, 0.336647E-01_JPRB, 0.306605E-01_JPRB &
  &, 0.278794E-01_JPRB, 0.253175E-01_JPRB, 0.229459E-01_JPRB &
  &, 0.207564E-01_JPRB, 0.187644E-01_JPRB, 0.169099E-01_JPRB, 0.152302E-01_JPRB &
  &, 0.137126E-01_JPRB, 0.122891E-01_JPRB, 0.110223E-01_JPRB &
  &, 0.986794E-02_JPRB, 0.880618E-02_JPRB, 0.784413E-02_JPRB, 0.698910E-02_JPRB &
  &, 0.621856E-02_JPRB, 0.550799E-02_JPRB, 0.489297E-02_JPRB &
  &, 0.431643E-02_JPRB, 0.381363E-02_JPRB, 0.335656E-02_JPRB, 0.294837E-02_JPRB &
  &, 0.259230E-02_JPRB, 0.229167E-02_JPRB, 0.197950E-02_JPRB &
  &, 0.172719E-02_JPRB, 0.150181E-02_JPRB, 0.130509E-02_JPRB, 0.113876E-02_JPRB &
  &, 0.100461E-02_JPRB, 0.865559E-03_JPRB, 0.721536E-03_JPRB &
  &, 0.652824E-03_JPRB, 0.540779E-03_JPRB, 0.466366E-03_JPRB, 0.389372E-03_JPRB &
  &, 0.352584E-03_JPRB, 0.270997E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 305, :) = (/ &
  &  0.946432E+00_JPRB, 0.932342E+00_JPRB, 0.917990E+00_JPRB, 0.903389E+00_JPRB &
  &, 0.888547E+00_JPRB, 0.873476E+00_JPRB, 0.858185E+00_JPRB &
  &, 0.842686E+00_JPRB, 0.826990E+00_JPRB, 0.811110E+00_JPRB, 0.795054E+00_JPRB &
  &, 0.778838E+00_JPRB, 0.762472E+00_JPRB, 0.745969E+00_JPRB &
  &, 0.729344E+00_JPRB, 0.712607E+00_JPRB, 0.695774E+00_JPRB, 0.678858E+00_JPRB &
  &, 0.661874E+00_JPRB, 0.644836E+00_JPRB, 0.627762E+00_JPRB &
  &, 0.610659E+00_JPRB, 0.593560E+00_JPRB, 0.576466E+00_JPRB, 0.559397E+00_JPRB &
  &, 0.542371E+00_JPRB, 0.525406E+00_JPRB, 0.508516E+00_JPRB &
  &, 0.491720E+00_JPRB, 0.475038E+00_JPRB, 0.458484E+00_JPRB, 0.442078E+00_JPRB &
  &, 0.425834E+00_JPRB, 0.409770E+00_JPRB, 0.393908E+00_JPRB &
  &, 0.378257E+00_JPRB, 0.362835E+00_JPRB, 0.347671E+00_JPRB, 0.332756E+00_JPRB &
  &, 0.318129E+00_JPRB, 0.303792E+00_JPRB, 0.289755E+00_JPRB &
  &, 0.276043E+00_JPRB, 0.262666E+00_JPRB, 0.249612E+00_JPRB, 0.236926E+00_JPRB &
  &, 0.224594E+00_JPRB, 0.212624E+00_JPRB, 0.201033E+00_JPRB &
  &, 0.189828E+00_JPRB, 0.178998E+00_JPRB, 0.168569E+00_JPRB, 0.158514E+00_JPRB &
  &, 0.148871E+00_JPRB, 0.139605E+00_JPRB, 0.130736E+00_JPRB &
  &, 0.122252E+00_JPRB, 0.114154E+00_JPRB, 0.106426E+00_JPRB, 0.990935E-01_JPRB &
  &, 0.921185E-01_JPRB, 0.855072E-01_JPRB, 0.792649E-01_JPRB &
  &, 0.733405E-01_JPRB, 0.677693E-01_JPRB, 0.625310E-01_JPRB, 0.576015E-01_JPRB &
  &, 0.529924E-01_JPRB, 0.486542E-01_JPRB, 0.446140E-01_JPRB &
  &, 0.408366E-01_JPRB, 0.373252E-01_JPRB, 0.340604E-01_JPRB, 0.310420E-01_JPRB &
  &, 0.282229E-01_JPRB, 0.256447E-01_JPRB, 0.232558E-01_JPRB &
  &, 0.210482E-01_JPRB, 0.190125E-01_JPRB, 0.171628E-01_JPRB, 0.154623E-01_JPRB &
  &, 0.138967E-01_JPRB, 0.124767E-01_JPRB, 0.111862E-01_JPRB &
  &, 0.100072E-01_JPRB, 0.894806E-02_JPRB, 0.798868E-02_JPRB, 0.710689E-02_JPRB &
  &, 0.630854E-02_JPRB, 0.559962E-02_JPRB, 0.498627E-02_JPRB &
  &, 0.441143E-02_JPRB, 0.387810E-02_JPRB, 0.342217E-02_JPRB, 0.301515E-02_JPRB &
  &, 0.266025E-02_JPRB, 0.232624E-02_JPRB, 0.204984E-02_JPRB &
  &, 0.176296E-02_JPRB, 0.153820E-02_JPRB, 0.134209E-02_JPRB, 0.117639E-02_JPRB &
  &, 0.100461E-02_JPRB, 0.865559E-03_JPRB, 0.761066E-03_JPRB &
  &, 0.652824E-03_JPRB, 0.581608E-03_JPRB, 0.466366E-03_JPRB, 0.431524E-03_JPRB &
  &, 0.352584E-03_JPRB, 0.314496E-03_JPRB, 0.230910E-03_JPRB &
  &, 0.189481E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.584019E-04_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 306, :) = (/ &
  &  0.946710E+00_JPRB, 0.932683E+00_JPRB, 0.918395E+00_JPRB, 0.903856E+00_JPRB &
  &, 0.889076E+00_JPRB, 0.874064E+00_JPRB, 0.858831E+00_JPRB &
  &, 0.843388E+00_JPRB, 0.827747E+00_JPRB, 0.811920E+00_JPRB, 0.795916E+00_JPRB &
  &, 0.779748E+00_JPRB, 0.763429E+00_JPRB, 0.746971E+00_JPRB &
  &, 0.730389E+00_JPRB, 0.713694E+00_JPRB, 0.696899E+00_JPRB, 0.680021E+00_JPRB &
  &, 0.663073E+00_JPRB, 0.646067E+00_JPRB, 0.629023E+00_JPRB &
  &, 0.611956E+00_JPRB, 0.594876E+00_JPRB, 0.577806E+00_JPRB, 0.560762E+00_JPRB &
  &, 0.543753E+00_JPRB, 0.526803E+00_JPRB, 0.509928E+00_JPRB &
  &, 0.493147E+00_JPRB, 0.476473E+00_JPRB, 0.459930E+00_JPRB, 0.443526E+00_JPRB &
  &, 0.427284E+00_JPRB, 0.411221E+00_JPRB, 0.395360E+00_JPRB &
  &, 0.379698E+00_JPRB, 0.364275E+00_JPRB, 0.349099E+00_JPRB, 0.334180E+00_JPRB &
  &, 0.319537E+00_JPRB, 0.305183E+00_JPRB, 0.291138E+00_JPRB &
  &, 0.277405E+00_JPRB, 0.263994E+00_JPRB, 0.250926E+00_JPRB, 0.238214E+00_JPRB &
  &, 0.225853E+00_JPRB, 0.213863E+00_JPRB, 0.202239E+00_JPRB &
  &, 0.190997E+00_JPRB, 0.180141E+00_JPRB, 0.169672E+00_JPRB, 0.159601E+00_JPRB &
  &, 0.149912E+00_JPRB, 0.140611E+00_JPRB, 0.131705E+00_JPRB &
  &, 0.123182E+00_JPRB, 0.115058E+00_JPRB, 0.107302E+00_JPRB, 0.999234E-01_JPRB &
  &, 0.929163E-01_JPRB, 0.862711E-01_JPRB, 0.799749E-01_JPRB &
  &, 0.740482E-01_JPRB, 0.684371E-01_JPRB, 0.631566E-01_JPRB, 0.582020E-01_JPRB &
  &, 0.535466E-01_JPRB, 0.491799E-01_JPRB, 0.451096E-01_JPRB &
  &, 0.413005E-01_JPRB, 0.377559E-01_JPRB, 0.344781E-01_JPRB, 0.314234E-01_JPRB &
  &, 0.285893E-01_JPRB, 0.259718E-01_JPRB, 0.235657E-01_JPRB &
  &, 0.213401E-01_JPRB, 0.192854E-01_JPRB, 0.174158E-01_JPRB, 0.156945E-01_JPRB &
  &, 0.141071E-01_JPRB, 0.126912E-01_JPRB, 0.113775E-01_JPRB &
  &, 0.101743E-01_JPRB, 0.908993E-02_JPRB, 0.813322E-02_JPRB, 0.722468E-02_JPRB &
  &, 0.642851E-02_JPRB, 0.572180E-02_JPRB, 0.504847E-02_JPRB &
  &, 0.447476E-02_JPRB, 0.397480E-02_JPRB, 0.348779E-02_JPRB, 0.308193E-02_JPRB &
  &, 0.269423E-02_JPRB, 0.236081E-02_JPRB, 0.208501E-02_JPRB &
  &, 0.179874E-02_JPRB, 0.157458E-02_JPRB, 0.137909E-02_JPRB, 0.121401E-02_JPRB &
  &, 0.104286E-02_JPRB, 0.904448E-03_JPRB, 0.761066E-03_JPRB &
  &, 0.652824E-03_JPRB, 0.581608E-03_JPRB, 0.507854E-03_JPRB, 0.431524E-03_JPRB &
  &, 0.352584E-03_JPRB, 0.314496E-03_JPRB, 0.275092E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.103943E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 307, :) = (/ &
  &  0.946985E+00_JPRB, 0.933024E+00_JPRB, 0.918799E+00_JPRB, 0.904324E+00_JPRB &
  &, 0.889604E+00_JPRB, 0.874651E+00_JPRB, 0.859476E+00_JPRB &
  &, 0.844090E+00_JPRB, 0.828504E+00_JPRB, 0.812728E+00_JPRB, 0.796775E+00_JPRB &
  &, 0.780656E+00_JPRB, 0.764385E+00_JPRB, 0.747974E+00_JPRB &
  &, 0.731434E+00_JPRB, 0.714779E+00_JPRB, 0.698025E+00_JPRB, 0.681184E+00_JPRB &
  &, 0.664270E+00_JPRB, 0.647298E+00_JPRB, 0.630285E+00_JPRB &
  &, 0.613246E+00_JPRB, 0.596195E+00_JPRB, 0.579149E+00_JPRB, 0.562122E+00_JPRB &
  &, 0.545135E+00_JPRB, 0.528203E+00_JPRB, 0.511344E+00_JPRB &
  &, 0.494574E+00_JPRB, 0.477911E+00_JPRB, 0.461371E+00_JPRB, 0.444975E+00_JPRB &
  &, 0.428738E+00_JPRB, 0.412677E+00_JPRB, 0.396811E+00_JPRB &
  &, 0.381149E+00_JPRB, 0.365725E+00_JPRB, 0.350536E+00_JPRB, 0.335603E+00_JPRB &
  &, 0.320945E+00_JPRB, 0.306584E+00_JPRB, 0.292510E+00_JPRB &
  &, 0.278756E+00_JPRB, 0.265333E+00_JPRB, 0.252241E+00_JPRB, 0.239502E+00_JPRB &
  &, 0.227123E+00_JPRB, 0.215103E+00_JPRB, 0.203458E+00_JPRB &
  &, 0.192180E+00_JPRB, 0.181299E+00_JPRB, 0.170802E+00_JPRB, 0.160688E+00_JPRB &
  &, 0.150967E+00_JPRB, 0.141632E+00_JPRB, 0.132689E+00_JPRB &
  &, 0.124143E+00_JPRB, 0.115962E+00_JPRB, 0.108178E+00_JPRB, 0.100770E+00_JPRB &
  &, 0.937142E-01_JPRB, 0.870349E-01_JPRB, 0.807204E-01_JPRB &
  &, 0.747378E-01_JPRB, 0.691049E-01_JPRB, 0.637822E-01_JPRB, 0.587831E-01_JPRB &
  &, 0.541008E-01_JPRB, 0.497056E-01_JPRB, 0.456052E-01_JPRB &
  &, 0.417856E-01_JPRB, 0.382081E-01_JPRB, 0.348957E-01_JPRB, 0.318049E-01_JPRB &
  &, 0.289557E-01_JPRB, 0.262990E-01_JPRB, 0.238757E-01_JPRB &
  &, 0.216320E-01_JPRB, 0.195583E-01_JPRB, 0.176435E-01_JPRB, 0.159267E-01_JPRB &
  &, 0.143175E-01_JPRB, 0.128789E-01_JPRB, 0.115415E-01_JPRB &
  &, 0.103413E-01_JPRB, 0.926018E-02_JPRB, 0.824885E-02_JPRB, 0.737192E-02_JPRB &
  &, 0.654848E-02_JPRB, 0.581343E-02_JPRB, 0.514178E-02_JPRB &
  &, 0.456975E-02_JPRB, 0.403927E-02_JPRB, 0.355341E-02_JPRB, 0.314871E-02_JPRB &
  &, 0.276219E-02_JPRB, 0.242995E-02_JPRB, 0.212018E-02_JPRB &
  &, 0.187028E-02_JPRB, 0.161097E-02_JPRB, 0.141610E-02_JPRB, 0.121401E-02_JPRB &
  &, 0.108112E-02_JPRB, 0.904448E-03_JPRB, 0.800596E-03_JPRB &
  &, 0.693000E-03_JPRB, 0.581608E-03_JPRB, 0.507854E-03_JPRB, 0.431524E-03_JPRB &
  &, 0.352584E-03_JPRB, 0.314496E-03_JPRB, 0.275092E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 308, :) = (/ &
  &  0.947258E+00_JPRB, 0.933364E+00_JPRB, 0.919204E+00_JPRB, 0.904791E+00_JPRB &
  &, 0.890132E+00_JPRB, 0.875239E+00_JPRB, 0.860122E+00_JPRB &
  &, 0.844791E+00_JPRB, 0.829259E+00_JPRB, 0.813537E+00_JPRB, 0.797634E+00_JPRB &
  &, 0.781566E+00_JPRB, 0.765342E+00_JPRB, 0.748974E+00_JPRB &
  &, 0.732479E+00_JPRB, 0.715863E+00_JPRB, 0.699151E+00_JPRB, 0.682346E+00_JPRB &
  &, 0.665469E+00_JPRB, 0.648529E+00_JPRB, 0.631546E+00_JPRB &
  &, 0.614535E+00_JPRB, 0.597511E+00_JPRB, 0.580489E+00_JPRB, 0.563486E+00_JPRB &
  &, 0.546517E+00_JPRB, 0.529604E+00_JPRB, 0.512760E+00_JPRB &
  &, 0.496001E+00_JPRB, 0.479349E+00_JPRB, 0.462817E+00_JPRB, 0.446427E+00_JPRB &
  &, 0.430192E+00_JPRB, 0.414133E+00_JPRB, 0.398263E+00_JPRB &
  &, 0.382600E+00_JPRB, 0.367165E+00_JPRB, 0.351964E+00_JPRB, 0.337027E+00_JPRB &
  &, 0.322364E+00_JPRB, 0.307975E+00_JPRB, 0.293893E+00_JPRB &
  &, 0.280129E+00_JPRB, 0.266673E+00_JPRB, 0.253568E+00_JPRB, 0.240801E+00_JPRB &
  &, 0.228394E+00_JPRB, 0.216342E+00_JPRB, 0.204663E+00_JPRB &
  &, 0.193363E+00_JPRB, 0.182456E+00_JPRB, 0.171919E+00_JPRB, 0.161775E+00_JPRB &
  &, 0.152022E+00_JPRB, 0.142652E+00_JPRB, 0.133673E+00_JPRB &
  &, 0.125088E+00_JPRB, 0.116882E+00_JPRB, 0.109054E+00_JPRB, 0.101600E+00_JPRB &
  &, 0.945290E-01_JPRB, 0.878161E-01_JPRB, 0.814482E-01_JPRB &
  &, 0.754455E-01_JPRB, 0.697541E-01_JPRB, 0.644078E-01_JPRB, 0.593836E-01_JPRB &
  &, 0.546747E-01_JPRB, 0.502514E-01_JPRB, 0.461215E-01_JPRB &
  &, 0.422495E-01_JPRB, 0.386602E-01_JPRB, 0.353134E-01_JPRB, 0.321863E-01_JPRB &
  &, 0.293221E-01_JPRB, 0.266495E-01_JPRB, 0.241856E-01_JPRB &
  &, 0.219238E-01_JPRB, 0.198311E-01_JPRB, 0.178965E-01_JPRB, 0.161588E-01_JPRB &
  &, 0.145279E-01_JPRB, 0.130665E-01_JPRB, 0.117327E-01_JPRB &
  &, 0.105084E-01_JPRB, 0.940205E-02_JPRB, 0.839339E-02_JPRB, 0.748971E-02_JPRB &
  &, 0.666846E-02_JPRB, 0.590507E-02_JPRB, 0.526619E-02_JPRB &
  &, 0.466475E-02_JPRB, 0.410374E-02_JPRB, 0.361903E-02_JPRB, 0.318210E-02_JPRB &
  &, 0.283014E-02_JPRB, 0.246452E-02_JPRB, 0.215535E-02_JPRB &
  &, 0.190606E-02_JPRB, 0.164735E-02_JPRB, 0.145310E-02_JPRB, 0.125164E-02_JPRB &
  &, 0.108112E-02_JPRB, 0.943337E-03_JPRB, 0.800596E-03_JPRB &
  &, 0.693000E-03_JPRB, 0.622438E-03_JPRB, 0.507854E-03_JPRB, 0.431524E-03_JPRB &
  &, 0.395407E-03_JPRB, 0.314496E-03_JPRB, 0.275092E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART44',1,ZHOOK_HANDLE)
END SUBROUTINE PART44

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART45

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART45',0,ZHOOK_HANDLE)

XCW( 309, :) = (/ &
  &  0.947533E+00_JPRB, 0.933703E+00_JPRB, 0.919608E+00_JPRB, 0.905257E+00_JPRB &
  &, 0.890659E+00_JPRB, 0.875825E+00_JPRB, 0.860766E+00_JPRB &
  &, 0.845492E+00_JPRB, 0.830014E+00_JPRB, 0.814344E+00_JPRB, 0.798493E+00_JPRB &
  &, 0.782472E+00_JPRB, 0.766296E+00_JPRB, 0.749975E+00_JPRB &
  &, 0.733522E+00_JPRB, 0.716950E+00_JPRB, 0.700276E+00_JPRB, 0.683509E+00_JPRB &
  &, 0.666666E+00_JPRB, 0.649760E+00_JPRB, 0.632811E+00_JPRB &
  &, 0.615825E+00_JPRB, 0.598827E+00_JPRB, 0.581832E+00_JPRB, 0.564850E+00_JPRB &
  &, 0.547903E+00_JPRB, 0.531005E+00_JPRB, 0.514176E+00_JPRB &
  &, 0.497432E+00_JPRB, 0.480788E+00_JPRB, 0.464266E+00_JPRB, 0.447879E+00_JPRB &
  &, 0.431651E+00_JPRB, 0.415588E+00_JPRB, 0.399719E+00_JPRB &
  &, 0.384051E+00_JPRB, 0.368614E+00_JPRB, 0.353392E+00_JPRB, 0.338461E+00_JPRB &
  &, 0.323772E+00_JPRB, 0.309377E+00_JPRB, 0.295276E+00_JPRB &
  &, 0.281491E+00_JPRB, 0.268023E+00_JPRB, 0.254894E+00_JPRB, 0.242101E+00_JPRB &
  &, 0.229665E+00_JPRB, 0.217594E+00_JPRB, 0.205882E+00_JPRB &
  &, 0.194558E+00_JPRB, 0.183614E+00_JPRB, 0.173049E+00_JPRB, 0.162862E+00_JPRB &
  &, 0.153076E+00_JPRB, 0.143673E+00_JPRB, 0.134673E+00_JPRB &
  &, 0.126049E+00_JPRB, 0.117802E+00_JPRB, 0.109946E+00_JPRB, 0.102463E+00_JPRB &
  &, 0.953438E-01_JPRB, 0.885799E-01_JPRB, 0.821937E-01_JPRB &
  &, 0.761351E-01_JPRB, 0.704404E-01_JPRB, 0.650523E-01_JPRB, 0.599842E-01_JPRB &
  &, 0.552487E-01_JPRB, 0.507771E-01_JPRB, 0.466171E-01_JPRB &
  &, 0.427345E-01_JPRB, 0.390909E-01_JPRB, 0.357310E-01_JPRB, 0.325902E-01_JPRB &
  &, 0.296885E-01_JPRB, 0.269767E-01_JPRB, 0.244956E-01_JPRB &
  &, 0.222157E-01_JPRB, 0.201040E-01_JPRB, 0.181495E-01_JPRB, 0.163910E-01_JPRB &
  &, 0.147646E-01_JPRB, 0.132542E-01_JPRB, 0.118967E-01_JPRB &
  &, 0.106755E-01_JPRB, 0.954393E-02_JPRB, 0.853793E-02_JPRB, 0.760750E-02_JPRB &
  &, 0.678843E-02_JPRB, 0.602724E-02_JPRB, 0.535949E-02_JPRB &
  &, 0.472808E-02_JPRB, 0.420044E-02_JPRB, 0.368465E-02_JPRB, 0.324888E-02_JPRB &
  &, 0.286412E-02_JPRB, 0.253366E-02_JPRB, 0.222569E-02_JPRB &
  &, 0.194183E-02_JPRB, 0.168374E-02_JPRB, 0.149010E-02_JPRB, 0.128926E-02_JPRB &
  &, 0.111937E-02_JPRB, 0.982226E-03_JPRB, 0.840126E-03_JPRB &
  &, 0.733177E-03_JPRB, 0.622438E-03_JPRB, 0.549341E-03_JPRB, 0.473676E-03_JPRB &
  &, 0.395407E-03_JPRB, 0.314496E-03_JPRB, 0.275092E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.148795E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 310, :) = (/ &
  &  0.947808E+00_JPRB, 0.934044E+00_JPRB, 0.920011E+00_JPRB, 0.905723E+00_JPRB &
  &, 0.891186E+00_JPRB, 0.876411E+00_JPRB, 0.861410E+00_JPRB &
  &, 0.846191E+00_JPRB, 0.830768E+00_JPRB, 0.815151E+00_JPRB, 0.799351E+00_JPRB &
  &, 0.783379E+00_JPRB, 0.767250E+00_JPRB, 0.750974E+00_JPRB &
  &, 0.734566E+00_JPRB, 0.718036E+00_JPRB, 0.701401E+00_JPRB, 0.684671E+00_JPRB &
  &, 0.667863E+00_JPRB, 0.650991E+00_JPRB, 0.634072E+00_JPRB &
  &, 0.617118E+00_JPRB, 0.600146E+00_JPRB, 0.583171E+00_JPRB, 0.566215E+00_JPRB &
  &, 0.549285E+00_JPRB, 0.532405E+00_JPRB, 0.515592E+00_JPRB &
  &, 0.498859E+00_JPRB, 0.482226E+00_JPRB, 0.465712E+00_JPRB, 0.449336E+00_JPRB &
  &, 0.433105E+00_JPRB, 0.417048E+00_JPRB, 0.401175E+00_JPRB &
  &, 0.385502E+00_JPRB, 0.370054E+00_JPRB, 0.354849E+00_JPRB, 0.339884E+00_JPRB &
  &, 0.325190E+00_JPRB, 0.310778E+00_JPRB, 0.296670E+00_JPRB &
  &, 0.282854E+00_JPRB, 0.269374E+00_JPRB, 0.256220E+00_JPRB, 0.243401E+00_JPRB &
  &, 0.230948E+00_JPRB, 0.218846E+00_JPRB, 0.207113E+00_JPRB &
  &, 0.195754E+00_JPRB, 0.184771E+00_JPRB, 0.174179E+00_JPRB, 0.163963E+00_JPRB &
  &, 0.154146E+00_JPRB, 0.144709E+00_JPRB, 0.135657E+00_JPRB &
  &, 0.126994E+00_JPRB, 0.118722E+00_JPRB, 0.110822E+00_JPRB, 0.103309E+00_JPRB &
  &, 0.961586E-01_JPRB, 0.893611E-01_JPRB, 0.829392E-01_JPRB &
  &, 0.768610E-01_JPRB, 0.711081E-01_JPRB, 0.656969E-01_JPRB, 0.606040E-01_JPRB &
  &, 0.558226E-01_JPRB, 0.513230E-01_JPRB, 0.471333E-01_JPRB &
  &, 0.431985E-01_JPRB, 0.395431E-01_JPRB, 0.361487E-01_JPRB, 0.329941E-01_JPRB &
  &, 0.300549E-01_JPRB, 0.273272E-01_JPRB, 0.248294E-01_JPRB &
  &, 0.225075E-01_JPRB, 0.203769E-01_JPRB, 0.184278E-01_JPRB, 0.166232E-01_JPRB &
  &, 0.149750E-01_JPRB, 0.134687E-01_JPRB, 0.120880E-01_JPRB &
  &, 0.108426E-01_JPRB, 0.971418E-02_JPRB, 0.868247E-02_JPRB, 0.772529E-02_JPRB &
  &, 0.690840E-02_JPRB, 0.611888E-02_JPRB, 0.545280E-02_JPRB &
  &, 0.482307E-02_JPRB, 0.426491E-02_JPRB, 0.378308E-02_JPRB, 0.331566E-02_JPRB &
  &, 0.293208E-02_JPRB, 0.256823E-02_JPRB, 0.226086E-02_JPRB &
  &, 0.197761E-02_JPRB, 0.172013E-02_JPRB, 0.149010E-02_JPRB, 0.132689E-02_JPRB &
  &, 0.115763E-02_JPRB, 0.982226E-03_JPRB, 0.840126E-03_JPRB &
  &, 0.733177E-03_JPRB, 0.622438E-03_JPRB, 0.549341E-03_JPRB, 0.473676E-03_JPRB &
  &, 0.395407E-03_JPRB, 0.357996E-03_JPRB, 0.275092E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 311, :) = (/ &
  &  0.948082E+00_JPRB, 0.934384E+00_JPRB, 0.920414E+00_JPRB, 0.906188E+00_JPRB &
  &, 0.891711E+00_JPRB, 0.876997E+00_JPRB, 0.862053E+00_JPRB &
  &, 0.846891E+00_JPRB, 0.831523E+00_JPRB, 0.815957E+00_JPRB, 0.800209E+00_JPRB &
  &, 0.784286E+00_JPRB, 0.768204E+00_JPRB, 0.751975E+00_JPRB &
  &, 0.735608E+00_JPRB, 0.719120E+00_JPRB, 0.702524E+00_JPRB, 0.685833E+00_JPRB &
  &, 0.669060E+00_JPRB, 0.652222E+00_JPRB, 0.635333E+00_JPRB &
  &, 0.618408E+00_JPRB, 0.601462E+00_JPRB, 0.584515E+00_JPRB, 0.567579E+00_JPRB &
  &, 0.550671E+00_JPRB, 0.533810E+00_JPRB, 0.517011E+00_JPRB &
  &, 0.500290E+00_JPRB, 0.483669E+00_JPRB, 0.467162E+00_JPRB, 0.450788E+00_JPRB &
  &, 0.434564E+00_JPRB, 0.418508E+00_JPRB, 0.402635E+00_JPRB &
  &, 0.386963E+00_JPRB, 0.371513E+00_JPRB, 0.356286E+00_JPRB, 0.341318E+00_JPRB &
  &, 0.326619E+00_JPRB, 0.312190E+00_JPRB, 0.298052E+00_JPRB &
  &, 0.284227E+00_JPRB, 0.270725E+00_JPRB, 0.257547E+00_JPRB, 0.244712E+00_JPRB &
  &, 0.232219E+00_JPRB, 0.220098E+00_JPRB, 0.208332E+00_JPRB &
  &, 0.196950E+00_JPRB, 0.185942E+00_JPRB, 0.175309E+00_JPRB, 0.165063E+00_JPRB &
  &, 0.155215E+00_JPRB, 0.145744E+00_JPRB, 0.136656E+00_JPRB &
  &, 0.127970E+00_JPRB, 0.119657E+00_JPRB, 0.111715E+00_JPRB, 0.104172E+00_JPRB &
  &, 0.969735E-01_JPRB, 0.901597E-01_JPRB, 0.836847E-01_JPRB &
  &, 0.775687E-01_JPRB, 0.717945E-01_JPRB, 0.663414E-01_JPRB, 0.612046E-01_JPRB &
  &, 0.563966E-01_JPRB, 0.518689E-01_JPRB, 0.476496E-01_JPRB &
  &, 0.437046E-01_JPRB, 0.400168E-01_JPRB, 0.365664E-01_JPRB, 0.333755E-01_JPRB &
  &, 0.304213E-01_JPRB, 0.276777E-01_JPRB, 0.251393E-01_JPRB &
  &, 0.227994E-01_JPRB, 0.206498E-01_JPRB, 0.186808E-01_JPRB, 0.168554E-01_JPRB &
  &, 0.151854E-01_JPRB, 0.136832E-01_JPRB, 0.122793E-01_JPRB &
  &, 0.110097E-01_JPRB, 0.985605E-02_JPRB, 0.882701E-02_JPRB, 0.787253E-02_JPRB &
  &, 0.702837E-02_JPRB, 0.624106E-02_JPRB, 0.554610E-02_JPRB &
  &, 0.491807E-02_JPRB, 0.436161E-02_JPRB, 0.384870E-02_JPRB, 0.338244E-02_JPRB &
  &, 0.300003E-02_JPRB, 0.263737E-02_JPRB, 0.229603E-02_JPRB &
  &, 0.201338E-02_JPRB, 0.175651E-02_JPRB, 0.152710E-02_JPRB, 0.132689E-02_JPRB &
  &, 0.115763E-02_JPRB, 0.102111E-02_JPRB, 0.879655E-03_JPRB &
  &, 0.773353E-03_JPRB, 0.663267E-03_JPRB, 0.549341E-03_JPRB, 0.473676E-03_JPRB &
  &, 0.395407E-03_JPRB, 0.357996E-03_JPRB, 0.319274E-03_JPRB &
  &, 0.234352E-03_JPRB, 0.192259E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.591261E-04_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 312, :) = (/ &
  &  0.948356E+00_JPRB, 0.934722E+00_JPRB, 0.920817E+00_JPRB, 0.906653E+00_JPRB &
  &, 0.892237E+00_JPRB, 0.877582E+00_JPRB, 0.862695E+00_JPRB &
  &, 0.847590E+00_JPRB, 0.832276E+00_JPRB, 0.816763E+00_JPRB, 0.801066E+00_JPRB &
  &, 0.785193E+00_JPRB, 0.769158E+00_JPRB, 0.752973E+00_JPRB &
  &, 0.736652E+00_JPRB, 0.720204E+00_JPRB, 0.703648E+00_JPRB, 0.686994E+00_JPRB &
  &, 0.670257E+00_JPRB, 0.653453E+00_JPRB, 0.636595E+00_JPRB &
  &, 0.619698E+00_JPRB, 0.602781E+00_JPRB, 0.585858E+00_JPRB, 0.568943E+00_JPRB &
  &, 0.552053E+00_JPRB, 0.535211E+00_JPRB, 0.518427E+00_JPRB &
  &, 0.501722E+00_JPRB, 0.485111E+00_JPRB, 0.468615E+00_JPRB, 0.452244E+00_JPRB &
  &, 0.436027E+00_JPRB, 0.419972E+00_JPRB, 0.404096E+00_JPRB &
  &, 0.388423E+00_JPRB, 0.372963E+00_JPRB, 0.357733E+00_JPRB, 0.342751E+00_JPRB &
  &, 0.328038E+00_JPRB, 0.313602E+00_JPRB, 0.299446E+00_JPRB &
  &, 0.285600E+00_JPRB, 0.272076E+00_JPRB, 0.258885E+00_JPRB, 0.246024E+00_JPRB &
  &, 0.233514E+00_JPRB, 0.221350E+00_JPRB, 0.209563E+00_JPRB &
  &, 0.198146E+00_JPRB, 0.187113E+00_JPRB, 0.176453E+00_JPRB, 0.166178E+00_JPRB &
  &, 0.156285E+00_JPRB, 0.146780E+00_JPRB, 0.137671E+00_JPRB &
  &, 0.128931E+00_JPRB, 0.120593E+00_JPRB, 0.112623E+00_JPRB, 0.105019E+00_JPRB &
  &, 0.978053E-01_JPRB, 0.909409E-01_JPRB, 0.844480E-01_JPRB &
  &, 0.782946E-01_JPRB, 0.724808E-01_JPRB, 0.669860E-01_JPRB, 0.618245E-01_JPRB &
  &, 0.569706E-01_JPRB, 0.524350E-01_JPRB, 0.481658E-01_JPRB &
  &, 0.441896E-01_JPRB, 0.404689E-01_JPRB, 0.370060E-01_JPRB, 0.337794E-01_JPRB &
  &, 0.308106E-01_JPRB, 0.280282E-01_JPRB, 0.254731E-01_JPRB &
  &, 0.231156E-01_JPRB, 0.209475E-01_JPRB, 0.189338E-01_JPRB, 0.171133E-01_JPRB &
  &, 0.154221E-01_JPRB, 0.138709E-01_JPRB, 0.124705E-01_JPRB &
  &, 0.111768E-01_JPRB, 0.100263E-01_JPRB, 0.897156E-02_JPRB, 0.799032E-02_JPRB &
  &, 0.714835E-02_JPRB, 0.636323E-02_JPRB, 0.563941E-02_JPRB &
  &, 0.501306E-02_JPRB, 0.442608E-02_JPRB, 0.391431E-02_JPRB, 0.344922E-02_JPRB &
  &, 0.303401E-02_JPRB, 0.267194E-02_JPRB, 0.236637E-02_JPRB &
  &, 0.204916E-02_JPRB, 0.179290E-02_JPRB, 0.156411E-02_JPRB, 0.136452E-02_JPRB &
  &, 0.119588E-02_JPRB, 0.102111E-02_JPRB, 0.919185E-03_JPRB &
  &, 0.773353E-03_JPRB, 0.663267E-03_JPRB, 0.590829E-03_JPRB, 0.515829E-03_JPRB &
  &, 0.438230E-03_JPRB, 0.357996E-03_JPRB, 0.319274E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.105367E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 313, :) = (/ &
  &  0.948629E+00_JPRB, 0.935060E+00_JPRB, 0.921219E+00_JPRB, 0.907117E+00_JPRB &
  &, 0.892763E+00_JPRB, 0.878166E+00_JPRB, 0.863338E+00_JPRB &
  &, 0.848288E+00_JPRB, 0.833028E+00_JPRB, 0.817569E+00_JPRB, 0.801922E+00_JPRB &
  &, 0.786099E+00_JPRB, 0.770111E+00_JPRB, 0.753972E+00_JPRB &
  &, 0.737694E+00_JPRB, 0.721288E+00_JPRB, 0.704771E+00_JPRB, 0.688155E+00_JPRB &
  &, 0.671454E+00_JPRB, 0.654684E+00_JPRB, 0.637856E+00_JPRB &
  &, 0.620991E+00_JPRB, 0.604097E+00_JPRB, 0.587201E+00_JPRB, 0.570307E+00_JPRB &
  &, 0.553439E+00_JPRB, 0.536615E+00_JPRB, 0.519847E+00_JPRB &
  &, 0.503153E+00_JPRB, 0.486554E+00_JPRB, 0.470065E+00_JPRB, 0.453705E+00_JPRB &
  &, 0.437489E+00_JPRB, 0.421432E+00_JPRB, 0.405561E+00_JPRB &
  &, 0.389883E+00_JPRB, 0.374413E+00_JPRB, 0.359180E+00_JPRB, 0.344195E+00_JPRB &
  &, 0.329466E+00_JPRB, 0.315004E+00_JPRB, 0.300840E+00_JPRB &
  &, 0.286984E+00_JPRB, 0.273438E+00_JPRB, 0.260211E+00_JPRB, 0.247336E+00_JPRB &
  &, 0.234797E+00_JPRB, 0.222615E+00_JPRB, 0.210795E+00_JPRB &
  &, 0.199354E+00_JPRB, 0.188284E+00_JPRB, 0.177584E+00_JPRB, 0.167279E+00_JPRB &
  &, 0.157354E+00_JPRB, 0.147815E+00_JPRB, 0.138670E+00_JPRB &
  &, 0.129908E+00_JPRB, 0.121528E+00_JPRB, 0.113516E+00_JPRB, 0.105898E+00_JPRB &
  &, 0.986370E-01_JPRB, 0.917394E-01_JPRB, 0.851935E-01_JPRB &
  &, 0.790023E-01_JPRB, 0.731671E-01_JPRB, 0.676495E-01_JPRB, 0.624443E-01_JPRB &
  &, 0.575643E-01_JPRB, 0.529809E-01_JPRB, 0.486821E-01_JPRB &
  &, 0.446746E-01_JPRB, 0.409211E-01_JPRB, 0.374457E-01_JPRB, 0.342058E-01_JPRB &
  &, 0.311770E-01_JPRB, 0.283787E-01_JPRB, 0.258069E-01_JPRB &
  &, 0.234318E-01_JPRB, 0.212204E-01_JPRB, 0.192121E-01_JPRB, 0.173455E-01_JPRB &
  &, 0.156325E-01_JPRB, 0.140853E-01_JPRB, 0.126618E-01_JPRB &
  &, 0.113717E-01_JPRB, 0.101965E-01_JPRB, 0.911610E-02_JPRB, 0.813756E-02_JPRB &
  &, 0.726832E-02_JPRB, 0.645487E-02_JPRB, 0.573271E-02_JPRB &
  &, 0.510806E-02_JPRB, 0.452279E-02_JPRB, 0.397993E-02_JPRB, 0.351600E-02_JPRB &
  &, 0.310196E-02_JPRB, 0.274108E-02_JPRB, 0.240154E-02_JPRB &
  &, 0.212071E-02_JPRB, 0.182928E-02_JPRB, 0.160111E-02_JPRB, 0.140214E-02_JPRB &
  &, 0.123414E-02_JPRB, 0.106000E-02_JPRB, 0.919185E-03_JPRB &
  &, 0.813530E-03_JPRB, 0.704096E-03_JPRB, 0.590829E-03_JPRB, 0.515829E-03_JPRB &
  &, 0.438230E-03_JPRB, 0.357996E-03_JPRB, 0.319274E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 314, :) = (/ &
  &  0.948900E+00_JPRB, 0.935398E+00_JPRB, 0.921620E+00_JPRB, 0.907581E+00_JPRB &
  &, 0.893287E+00_JPRB, 0.878749E+00_JPRB, 0.863979E+00_JPRB &
  &, 0.848985E+00_JPRB, 0.833780E+00_JPRB, 0.818374E+00_JPRB, 0.802778E+00_JPRB &
  &, 0.787003E+00_JPRB, 0.771064E+00_JPRB, 0.754970E+00_JPRB &
  &, 0.738734E+00_JPRB, 0.722372E+00_JPRB, 0.705895E+00_JPRB, 0.689317E+00_JPRB &
  &, 0.672651E+00_JPRB, 0.655911E+00_JPRB, 0.639117E+00_JPRB &
  &, 0.622280E+00_JPRB, 0.605416E+00_JPRB, 0.588540E+00_JPRB, 0.571675E+00_JPRB &
  &, 0.554825E+00_JPRB, 0.538019E+00_JPRB, 0.521266E+00_JPRB &
  &, 0.504588E+00_JPRB, 0.488000E+00_JPRB, 0.471519E+00_JPRB, 0.455162E+00_JPRB &
  &, 0.438952E+00_JPRB, 0.422897E+00_JPRB, 0.407026E+00_JPRB &
  &, 0.391343E+00_JPRB, 0.375872E+00_JPRB, 0.360628E+00_JPRB, 0.345629E+00_JPRB &
  &, 0.330895E+00_JPRB, 0.316427E+00_JPRB, 0.302244E+00_JPRB &
  &, 0.288369E+00_JPRB, 0.274800E+00_JPRB, 0.261561E+00_JPRB, 0.248647E+00_JPRB &
  &, 0.236092E+00_JPRB, 0.223879E+00_JPRB, 0.212039E+00_JPRB &
  &, 0.200563E+00_JPRB, 0.189455E+00_JPRB, 0.178741E+00_JPRB, 0.168394E+00_JPRB &
  &, 0.158438E+00_JPRB, 0.148866E+00_JPRB, 0.139685E+00_JPRB &
  &, 0.130884E+00_JPRB, 0.122464E+00_JPRB, 0.114424E+00_JPRB, 0.106761E+00_JPRB &
  &, 0.994688E-01_JPRB, 0.925380E-01_JPRB, 0.859567E-01_JPRB &
  &, 0.797463E-01_JPRB, 0.738534E-01_JPRB, 0.682940E-01_JPRB, 0.630642E-01_JPRB &
  &, 0.581581E-01_JPRB, 0.535470E-01_JPRB, 0.492190E-01_JPRB &
  &, 0.451807E-01_JPRB, 0.413948E-01_JPRB, 0.378853E-01_JPRB, 0.346096E-01_JPRB &
  &, 0.315663E-01_JPRB, 0.287526E-01_JPRB, 0.261407E-01_JPRB &
  &, 0.237236E-01_JPRB, 0.215181E-01_JPRB, 0.194651E-01_JPRB, 0.176035E-01_JPRB &
  &, 0.158692E-01_JPRB, 0.142998E-01_JPRB, 0.128531E-01_JPRB &
  &, 0.115388E-01_JPRB, 0.103384E-01_JPRB, 0.926064E-02_JPRB, 0.828479E-02_JPRB &
  &, 0.738829E-02_JPRB, 0.657704E-02_JPRB, 0.585712E-02_JPRB &
  &, 0.520305E-02_JPRB, 0.458725E-02_JPRB, 0.407836E-02_JPRB, 0.358279E-02_JPRB &
  &, 0.316992E-02_JPRB, 0.277565E-02_JPRB, 0.243671E-02_JPRB &
  &, 0.215648E-02_JPRB, 0.190205E-02_JPRB, 0.163811E-02_JPRB, 0.143977E-02_JPRB &
  &, 0.123414E-02_JPRB, 0.109889E-02_JPRB, 0.958715E-03_JPRB &
  &, 0.813530E-03_JPRB, 0.704096E-03_JPRB, 0.590829E-03_JPRB, 0.515829E-03_JPRB &
  &, 0.438230E-03_JPRB, 0.401495E-03_JPRB, 0.319274E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 315, :) = (/ &
  &  0.949174E+00_JPRB, 0.935734E+00_JPRB, 0.922021E+00_JPRB, 0.908044E+00_JPRB &
  &, 0.893811E+00_JPRB, 0.879333E+00_JPRB, 0.864620E+00_JPRB &
  &, 0.849683E+00_JPRB, 0.834531E+00_JPRB, 0.819178E+00_JPRB, 0.803633E+00_JPRB &
  &, 0.787909E+00_JPRB, 0.772015E+00_JPRB, 0.755968E+00_JPRB &
  &, 0.739776E+00_JPRB, 0.723455E+00_JPRB, 0.707018E+00_JPRB, 0.690477E+00_JPRB &
  &, 0.673847E+00_JPRB, 0.657142E+00_JPRB, 0.640379E+00_JPRB &
  &, 0.623570E+00_JPRB, 0.606736E+00_JPRB, 0.589880E+00_JPRB, 0.573039E+00_JPRB &
  &, 0.556211E+00_JPRB, 0.539424E+00_JPRB, 0.522686E+00_JPRB &
  &, 0.506023E+00_JPRB, 0.489443E+00_JPRB, 0.472973E+00_JPRB, 0.456622E+00_JPRB &
  &, 0.440415E+00_JPRB, 0.424366E+00_JPRB, 0.408491E+00_JPRB &
  &, 0.392804E+00_JPRB, 0.377331E+00_JPRB, 0.362084E+00_JPRB, 0.347072E+00_JPRB &
  &, 0.332324E+00_JPRB, 0.317839E+00_JPRB, 0.303648E+00_JPRB &
  &, 0.289753E+00_JPRB, 0.276163E+00_JPRB, 0.262899E+00_JPRB, 0.249971E+00_JPRB &
  &, 0.237387E+00_JPRB, 0.225156E+00_JPRB, 0.213283E+00_JPRB &
  &, 0.201772E+00_JPRB, 0.190639E+00_JPRB, 0.179885E+00_JPRB, 0.169509E+00_JPRB &
  &, 0.159522E+00_JPRB, 0.149916E+00_JPRB, 0.140699E+00_JPRB &
  &, 0.131860E+00_JPRB, 0.123415E+00_JPRB, 0.115333E+00_JPRB, 0.107641E+00_JPRB &
  &, 0.100301E+00_JPRB, 0.933365E-01_JPRB, 0.867377E-01_JPRB &
  &, 0.804721E-01_JPRB, 0.745583E-01_JPRB, 0.689575E-01_JPRB, 0.637035E-01_JPRB &
  &, 0.587518E-01_JPRB, 0.541131E-01_JPRB, 0.497559E-01_JPRB &
  &, 0.456658E-01_JPRB, 0.418685E-01_JPRB, 0.383249E-01_JPRB, 0.350135E-01_JPRB &
  &, 0.319556E-01_JPRB, 0.291032E-01_JPRB, 0.264745E-01_JPRB &
  &, 0.240398E-01_JPRB, 0.218157E-01_JPRB, 0.197434E-01_JPRB, 0.178356E-01_JPRB &
  &, 0.161059E-01_JPRB, 0.145143E-01_JPRB, 0.130444E-01_JPRB &
  &, 0.117337E-01_JPRB, 0.105087E-01_JPRB, 0.940518E-02_JPRB, 0.840259E-02_JPRB &
  &, 0.750826E-02_JPRB, 0.669922E-02_JPRB, 0.595042E-02_JPRB &
  &, 0.529805E-02_JPRB, 0.468396E-02_JPRB, 0.414398E-02_JPRB, 0.364957E-02_JPRB &
  &, 0.323787E-02_JPRB, 0.284480E-02_JPRB, 0.250705E-02_JPRB &
  &, 0.219226E-02_JPRB, 0.193844E-02_JPRB, 0.167511E-02_JPRB, 0.147739E-02_JPRB &
  &, 0.127239E-02_JPRB, 0.109889E-02_JPRB, 0.958715E-03_JPRB &
  &, 0.853706E-03_JPRB, 0.704096E-03_JPRB, 0.632317E-03_JPRB, 0.515829E-03_JPRB &
  &, 0.481052E-03_JPRB, 0.401495E-03_JPRB, 0.319274E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.150914E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART45',1,ZHOOK_HANDLE)
END SUBROUTINE PART45

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART46

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART46',0,ZHOOK_HANDLE)

XCW( 316, :) = (/ &
  &  0.949448E+00_JPRB, 0.936072E+00_JPRB, 0.922422E+00_JPRB, 0.908507E+00_JPRB &
  &, 0.894335E+00_JPRB, 0.879916E+00_JPRB, 0.865261E+00_JPRB &
  &, 0.850379E+00_JPRB, 0.835283E+00_JPRB, 0.819982E+00_JPRB, 0.804488E+00_JPRB &
  &, 0.788812E+00_JPRB, 0.772967E+00_JPRB, 0.756964E+00_JPRB &
  &, 0.740817E+00_JPRB, 0.724538E+00_JPRB, 0.708140E+00_JPRB, 0.691637E+00_JPRB &
  &, 0.675044E+00_JPRB, 0.658373E+00_JPRB, 0.641640E+00_JPRB &
  &, 0.624863E+00_JPRB, 0.608052E+00_JPRB, 0.591230E+00_JPRB, 0.574406E+00_JPRB &
  &, 0.557600E+00_JPRB, 0.540828E+00_JPRB, 0.524109E+00_JPRB &
  &, 0.507458E+00_JPRB, 0.490889E+00_JPRB, 0.474426E+00_JPRB, 0.458087E+00_JPRB &
  &, 0.441882E+00_JPRB, 0.425834E+00_JPRB, 0.409961E+00_JPRB &
  &, 0.394273E+00_JPRB, 0.378790E+00_JPRB, 0.363532E+00_JPRB, 0.348516E+00_JPRB &
  &, 0.333753E+00_JPRB, 0.319261E+00_JPRB, 0.305053E+00_JPRB &
  &, 0.291137E+00_JPRB, 0.277525E+00_JPRB, 0.264248E+00_JPRB, 0.251294E+00_JPRB &
  &, 0.238683E+00_JPRB, 0.226421E+00_JPRB, 0.214527E+00_JPRB &
  &, 0.202994E+00_JPRB, 0.191824E+00_JPRB, 0.181043E+00_JPRB, 0.170639E+00_JPRB &
  &, 0.160620E+00_JPRB, 0.150981E+00_JPRB, 0.141729E+00_JPRB &
  &, 0.132852E+00_JPRB, 0.124367E+00_JPRB, 0.116258E+00_JPRB, 0.108521E+00_JPRB &
  &, 0.101149E+00_JPRB, 0.941524E-01_JPRB, 0.875010E-01_JPRB &
  &, 0.811980E-01_JPRB, 0.752446E-01_JPRB, 0.696400E-01_JPRB, 0.643427E-01_JPRB &
  &, 0.593456E-01_JPRB, 0.546792E-01_JPRB, 0.502928E-01_JPRB &
  &, 0.461719E-01_JPRB, 0.423422E-01_JPRB, 0.387646E-01_JPRB, 0.354398E-01_JPRB &
  &, 0.323449E-01_JPRB, 0.294770E-01_JPRB, 0.268082E-01_JPRB &
  &, 0.243560E-01_JPRB, 0.220886E-01_JPRB, 0.200217E-01_JPRB, 0.180936E-01_JPRB &
  &, 0.163426E-01_JPRB, 0.147288E-01_JPRB, 0.132630E-01_JPRB &
  &, 0.119008E-01_JPRB, 0.106789E-01_JPRB, 0.957863E-02_JPRB, 0.854982E-02_JPRB &
  &, 0.762823E-02_JPRB, 0.679085E-02_JPRB, 0.604373E-02_JPRB &
  &, 0.539304E-02_JPRB, 0.478066E-02_JPRB, 0.420960E-02_JPRB, 0.374974E-02_JPRB &
  &, 0.330583E-02_JPRB, 0.291394E-02_JPRB, 0.254222E-02_JPRB &
  &, 0.222803E-02_JPRB, 0.197483E-02_JPRB, 0.171212E-02_JPRB, 0.151502E-02_JPRB &
  &, 0.131064E-02_JPRB, 0.113778E-02_JPRB, 0.998245E-03_JPRB &
  &, 0.853706E-03_JPRB, 0.744925E-03_JPRB, 0.632317E-03_JPRB, 0.557981E-03_JPRB &
  &, 0.481052E-03_JPRB, 0.401495E-03_JPRB, 0.363455E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 317, :) = (/ &
  &  0.949720E+00_JPRB, 0.936410E+00_JPRB, 0.922822E+00_JPRB, 0.908970E+00_JPRB &
  &, 0.894858E+00_JPRB, 0.880498E+00_JPRB, 0.865900E+00_JPRB &
  &, 0.851075E+00_JPRB, 0.836033E+00_JPRB, 0.820785E+00_JPRB, 0.805342E+00_JPRB &
  &, 0.789716E+00_JPRB, 0.773918E+00_JPRB, 0.757961E+00_JPRB &
  &, 0.741858E+00_JPRB, 0.725620E+00_JPRB, 0.709262E+00_JPRB, 0.692797E+00_JPRB &
  &, 0.676240E+00_JPRB, 0.659604E+00_JPRB, 0.642901E+00_JPRB &
  &, 0.626153E+00_JPRB, 0.609371E+00_JPRB, 0.592573E+00_JPRB, 0.575771E+00_JPRB &
  &, 0.558986E+00_JPRB, 0.542233E+00_JPRB, 0.525529E+00_JPRB &
  &, 0.508893E+00_JPRB, 0.492336E+00_JPRB, 0.475884E+00_JPRB, 0.459548E+00_JPRB &
  &, 0.443350E+00_JPRB, 0.427303E+00_JPRB, 0.411431E+00_JPRB &
  &, 0.395743E+00_JPRB, 0.380259E+00_JPRB, 0.364989E+00_JPRB, 0.349970E+00_JPRB &
  &, 0.335192E+00_JPRB, 0.320684E+00_JPRB, 0.306457E+00_JPRB &
  &, 0.292522E+00_JPRB, 0.278898E+00_JPRB, 0.265598E+00_JPRB, 0.252618E+00_JPRB &
  &, 0.239990E+00_JPRB, 0.227698E+00_JPRB, 0.215771E+00_JPRB &
  &, 0.204216E+00_JPRB, 0.193021E+00_JPRB, 0.182201E+00_JPRB, 0.171768E+00_JPRB &
  &, 0.161704E+00_JPRB, 0.152032E+00_JPRB, 0.142744E+00_JPRB &
  &, 0.133844E+00_JPRB, 0.125318E+00_JPRB, 0.117166E+00_JPRB, 0.109400E+00_JPRB &
  &, 0.101998E+00_JPRB, 0.949510E-01_JPRB, 0.882820E-01_JPRB &
  &, 0.819420E-01_JPRB, 0.759680E-01_JPRB, 0.703035E-01_JPRB, 0.649820E-01_JPRB &
  &, 0.599591E-01_JPRB, 0.552453E-01_JPRB, 0.508297E-01_JPRB &
  &, 0.466991E-01_JPRB, 0.428159E-01_JPRB, 0.392262E-01_JPRB, 0.358662E-01_JPRB &
  &, 0.327342E-01_JPRB, 0.298509E-01_JPRB, 0.271659E-01_JPRB &
  &, 0.246965E-01_JPRB, 0.223863E-01_JPRB, 0.202999E-01_JPRB, 0.183516E-01_JPRB &
  &, 0.165793E-01_JPRB, 0.149433E-01_JPRB, 0.134543E-01_JPRB &
  &, 0.120957E-01_JPRB, 0.108492E-01_JPRB, 0.972317E-02_JPRB, 0.869706E-02_JPRB &
  &, 0.777820E-02_JPRB, 0.691303E-02_JPRB, 0.616814E-02_JPRB &
  &, 0.548804E-02_JPRB, 0.484513E-02_JPRB, 0.430803E-02_JPRB, 0.381652E-02_JPRB &
  &, 0.337378E-02_JPRB, 0.294851E-02_JPRB, 0.261256E-02_JPRB &
  &, 0.229958E-02_JPRB, 0.201121E-02_JPRB, 0.174912E-02_JPRB, 0.155264E-02_JPRB &
  &, 0.134890E-02_JPRB, 0.117667E-02_JPRB, 0.998245E-03_JPRB &
  &, 0.893883E-03_JPRB, 0.744925E-03_JPRB, 0.673805E-03_JPRB, 0.557981E-03_JPRB &
  &, 0.481052E-03_JPRB, 0.401495E-03_JPRB, 0.363455E-03_JPRB &
  &, 0.279222E-03_JPRB, 0.237824E-03_JPRB, 0.195060E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.598563E-04_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 318, :) = (/ &
  &  0.949989E+00_JPRB, 0.936746E+00_JPRB, 0.923222E+00_JPRB, 0.909432E+00_JPRB &
  &, 0.895380E+00_JPRB, 0.881080E+00_JPRB, 0.866540E+00_JPRB &
  &, 0.851768E+00_JPRB, 0.836783E+00_JPRB, 0.821587E+00_JPRB, 0.806196E+00_JPRB &
  &, 0.790619E+00_JPRB, 0.774868E+00_JPRB, 0.758957E+00_JPRB &
  &, 0.742897E+00_JPRB, 0.726701E+00_JPRB, 0.710384E+00_JPRB, 0.693958E+00_JPRB &
  &, 0.677435E+00_JPRB, 0.660832E+00_JPRB, 0.644163E+00_JPRB &
  &, 0.627446E+00_JPRB, 0.610690E+00_JPRB, 0.593916E+00_JPRB, 0.577138E+00_JPRB &
  &, 0.560376E+00_JPRB, 0.543641E+00_JPRB, 0.526952E+00_JPRB &
  &, 0.510328E+00_JPRB, 0.493786E+00_JPRB, 0.477342E+00_JPRB, 0.461013E+00_JPRB &
  &, 0.444821E+00_JPRB, 0.428776E+00_JPRB, 0.412900E+00_JPRB &
  &, 0.397213E+00_JPRB, 0.381718E+00_JPRB, 0.366455E+00_JPRB, 0.351413E+00_JPRB &
  &, 0.336631E+00_JPRB, 0.322107E+00_JPRB, 0.307862E+00_JPRB &
  &, 0.293917E+00_JPRB, 0.280272E+00_JPRB, 0.266948E+00_JPRB, 0.253953E+00_JPRB &
  &, 0.241297E+00_JPRB, 0.228987E+00_JPRB, 0.217028E+00_JPRB &
  &, 0.205438E+00_JPRB, 0.194219E+00_JPRB, 0.183373E+00_JPRB, 0.172897E+00_JPRB &
  &, 0.162802E+00_JPRB, 0.153097E+00_JPRB, 0.143773E+00_JPRB &
  &, 0.134836E+00_JPRB, 0.126286E+00_JPRB, 0.118091E+00_JPRB, 0.110296E+00_JPRB &
  &, 0.102847E+00_JPRB, 0.957843E-01_JPRB, 0.890630E-01_JPRB &
  &, 0.826860E-01_JPRB, 0.766728E-01_JPRB, 0.709859E-01_JPRB, 0.656213E-01_JPRB &
  &, 0.605726E-01_JPRB, 0.558114E-01_JPRB, 0.513666E-01_JPRB &
  &, 0.472052E-01_JPRB, 0.433112E-01_JPRB, 0.396659E-01_JPRB, 0.362925E-01_JPRB &
  &, 0.331464E-01_JPRB, 0.302248E-01_JPRB, 0.275235E-01_JPRB &
  &, 0.250127E-01_JPRB, 0.227088E-01_JPRB, 0.205782E-01_JPRB, 0.186095E-01_JPRB &
  &, 0.168160E-01_JPRB, 0.151577E-01_JPRB, 0.136455E-01_JPRB &
  &, 0.122628E-01_JPRB, 0.110194E-01_JPRB, 0.986771E-02_JPRB, 0.884430E-02_JPRB &
  &, 0.789817E-02_JPRB, 0.703521E-02_JPRB, 0.626144E-02_JPRB &
  &, 0.558303E-02_JPRB, 0.494183E-02_JPRB, 0.437365E-02_JPRB, 0.388330E-02_JPRB &
  &, 0.344174E-02_JPRB, 0.301765E-02_JPRB, 0.264773E-02_JPRB &
  &, 0.233536E-02_JPRB, 0.204760E-02_JPRB, 0.178612E-02_JPRB, 0.155264E-02_JPRB &
  &, 0.138715E-02_JPRB, 0.117667E-02_JPRB, 0.103777E-02_JPRB &
  &, 0.893883E-03_JPRB, 0.785754E-03_JPRB, 0.673805E-03_JPRB, 0.600133E-03_JPRB &
  &, 0.481052E-03_JPRB, 0.444995E-03_JPRB, 0.363455E-03_JPRB &
  &, 0.324093E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.106804E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 319, :) = (/ &
  &  0.950262E+00_JPRB, 0.937082E+00_JPRB, 0.923621E+00_JPRB, 0.909893E+00_JPRB &
  &, 0.895902E+00_JPRB, 0.881661E+00_JPRB, 0.867179E+00_JPRB &
  &, 0.852466E+00_JPRB, 0.837532E+00_JPRB, 0.822389E+00_JPRB, 0.807049E+00_JPRB &
  &, 0.791522E+00_JPRB, 0.775818E+00_JPRB, 0.759953E+00_JPRB &
  &, 0.743938E+00_JPRB, 0.727784E+00_JPRB, 0.711506E+00_JPRB, 0.695118E+00_JPRB &
  &, 0.678631E+00_JPRB, 0.662063E+00_JPRB, 0.645427E+00_JPRB &
  &, 0.628736E+00_JPRB, 0.612010E+00_JPRB, 0.595263E+00_JPRB, 0.578506E+00_JPRB &
  &, 0.561762E+00_JPRB, 0.545049E+00_JPRB, 0.528376E+00_JPRB &
  &, 0.511766E+00_JPRB, 0.495237E+00_JPRB, 0.478800E+00_JPRB, 0.462482E+00_JPRB &
  &, 0.446293E+00_JPRB, 0.430250E+00_JPRB, 0.414374E+00_JPRB &
  &, 0.398682E+00_JPRB, 0.383186E+00_JPRB, 0.367912E+00_JPRB, 0.352867E+00_JPRB &
  &, 0.338070E+00_JPRB, 0.323540E+00_JPRB, 0.309277E+00_JPRB &
  &, 0.295312E+00_JPRB, 0.281657E+00_JPRB, 0.268309E+00_JPRB, 0.255289E+00_JPRB &
  &, 0.242605E+00_JPRB, 0.230264E+00_JPRB, 0.218286E+00_JPRB &
  &, 0.206660E+00_JPRB, 0.195417E+00_JPRB, 0.184531E+00_JPRB, 0.174026E+00_JPRB &
  &, 0.163915E+00_JPRB, 0.154177E+00_JPRB, 0.144818E+00_JPRB &
  &, 0.135843E+00_JPRB, 0.127237E+00_JPRB, 0.119032E+00_JPRB, 0.111176E+00_JPRB &
  &, 0.103713E+00_JPRB, 0.966002E-01_JPRB, 0.898440E-01_JPRB &
  &, 0.834482E-01_JPRB, 0.773777E-01_JPRB, 0.716684E-01_JPRB, 0.662605E-01_JPRB &
  &, 0.611862E-01_JPRB, 0.563977E-01_JPRB, 0.519242E-01_JPRB &
  &, 0.477113E-01_JPRB, 0.437849E-01_JPRB, 0.401275E-01_JPRB, 0.367188E-01_JPRB &
  &, 0.335357E-01_JPRB, 0.305987E-01_JPRB, 0.278573E-01_JPRB &
  &, 0.253289E-01_JPRB, 0.230065E-01_JPRB, 0.208565E-01_JPRB, 0.188675E-01_JPRB &
  &, 0.170527E-01_JPRB, 0.153990E-01_JPRB, 0.138642E-01_JPRB &
  &, 0.124577E-01_JPRB, 0.111897E-01_JPRB, 0.100412E-01_JPRB, 0.899154E-02_JPRB &
  &, 0.801814E-02_JPRB, 0.715739E-02_JPRB, 0.638585E-02_JPRB &
  &, 0.567803E-02_JPRB, 0.503853E-02_JPRB, 0.447207E-02_JPRB, 0.395008E-02_JPRB &
  &, 0.350969E-02_JPRB, 0.308679E-02_JPRB, 0.271807E-02_JPRB &
  &, 0.237113E-02_JPRB, 0.208398E-02_JPRB, 0.182313E-02_JPRB, 0.159027E-02_JPRB &
  &, 0.138715E-02_JPRB, 0.121556E-02_JPRB, 0.107730E-02_JPRB &
  &, 0.934059E-03_JPRB, 0.785754E-03_JPRB, 0.673805E-03_JPRB, 0.600133E-03_JPRB &
  &, 0.523875E-03_JPRB, 0.444995E-03_JPRB, 0.363455E-03_JPRB &
  &, 0.324093E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 320, :) = (/ &
  &  0.950531E+00_JPRB, 0.937418E+00_JPRB, 0.924020E+00_JPRB, 0.910354E+00_JPRB &
  &, 0.896424E+00_JPRB, 0.882242E+00_JPRB, 0.867817E+00_JPRB &
  &, 0.853160E+00_JPRB, 0.838280E+00_JPRB, 0.823191E+00_JPRB, 0.807902E+00_JPRB &
  &, 0.792423E+00_JPRB, 0.776768E+00_JPRB, 0.760948E+00_JPRB &
  &, 0.744977E+00_JPRB, 0.728865E+00_JPRB, 0.712627E+00_JPRB, 0.696277E+00_JPRB &
  &, 0.679827E+00_JPRB, 0.663291E+00_JPRB, 0.646689E+00_JPRB &
  &, 0.630029E+00_JPRB, 0.613329E+00_JPRB, 0.596606E+00_JPRB, 0.579874E+00_JPRB &
  &, 0.563151E+00_JPRB, 0.546457E+00_JPRB, 0.529799E+00_JPRB &
  &, 0.513205E+00_JPRB, 0.496688E+00_JPRB, 0.480262E+00_JPRB, 0.463947E+00_JPRB &
  &, 0.447764E+00_JPRB, 0.431723E+00_JPRB, 0.415848E+00_JPRB &
  &, 0.400152E+00_JPRB, 0.384655E+00_JPRB, 0.369379E+00_JPRB, 0.354321E+00_JPRB &
  &, 0.339519E+00_JPRB, 0.324973E+00_JPRB, 0.310692E+00_JPRB &
  &, 0.296719E+00_JPRB, 0.283030E+00_JPRB, 0.269670E+00_JPRB, 0.256624E+00_JPRB &
  &, 0.243912E+00_JPRB, 0.231554E+00_JPRB, 0.219543E+00_JPRB &
  &, 0.207895E+00_JPRB, 0.196615E+00_JPRB, 0.185702E+00_JPRB, 0.175169E+00_JPRB &
  &, 0.165013E+00_JPRB, 0.155242E+00_JPRB, 0.145848E+00_JPRB &
  &, 0.136850E+00_JPRB, 0.128220E+00_JPRB, 0.119957E+00_JPRB, 0.112072E+00_JPRB &
  &, 0.104561E+00_JPRB, 0.974161E-01_JPRB, 0.906428E-01_JPRB &
  &, 0.841922E-01_JPRB, 0.781011E-01_JPRB, 0.723509E-01_JPRB, 0.669192E-01_JPRB &
  &, 0.617997E-01_JPRB, 0.569840E-01_JPRB, 0.524611E-01_JPRB &
  &, 0.482385E-01_JPRB, 0.442801E-01_JPRB, 0.405891E-01_JPRB, 0.371452E-01_JPRB &
  &, 0.339479E-01_JPRB, 0.309726E-01_JPRB, 0.282149E-01_JPRB &
  &, 0.256694E-01_JPRB, 0.233042E-01_JPRB, 0.211348E-01_JPRB, 0.191255E-01_JPRB &
  &, 0.172895E-01_JPRB, 0.156135E-01_JPRB, 0.140554E-01_JPRB &
  &, 0.126527E-01_JPRB, 0.113599E-01_JPRB, 0.101857E-01_JPRB, 0.913878E-02_JPRB &
  &, 0.816811E-02_JPRB, 0.727957E-02_JPRB, 0.647915E-02_JPRB &
  &, 0.577302E-02_JPRB, 0.513523E-02_JPRB, 0.453769E-02_JPRB, 0.401686E-02_JPRB &
  &, 0.357765E-02_JPRB, 0.315593E-02_JPRB, 0.275324E-02_JPRB &
  &, 0.244268E-02_JPRB, 0.215675E-02_JPRB, 0.186013E-02_JPRB, 0.162789E-02_JPRB &
  &, 0.142541E-02_JPRB, 0.125445E-02_JPRB, 0.107730E-02_JPRB &
  &, 0.934059E-03_JPRB, 0.826583E-03_JPRB, 0.715293E-03_JPRB, 0.600133E-03_JPRB &
  &, 0.523875E-03_JPRB, 0.444995E-03_JPRB, 0.363455E-03_JPRB &
  &, 0.324093E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 321, :) = (/ &
  &  0.950803E+00_JPRB, 0.937753E+00_JPRB, 0.924419E+00_JPRB, 0.910814E+00_JPRB &
  &, 0.896945E+00_JPRB, 0.882822E+00_JPRB, 0.868454E+00_JPRB &
  &, 0.853853E+00_JPRB, 0.839029E+00_JPRB, 0.823991E+00_JPRB, 0.808753E+00_JPRB &
  &, 0.793324E+00_JPRB, 0.777717E+00_JPRB, 0.761944E+00_JPRB &
  &, 0.746015E+00_JPRB, 0.729946E+00_JPRB, 0.713749E+00_JPRB, 0.697435E+00_JPRB &
  &, 0.681022E+00_JPRB, 0.664521E+00_JPRB, 0.647950E+00_JPRB &
  &, 0.631318E+00_JPRB, 0.614648E+00_JPRB, 0.597952E+00_JPRB, 0.581245E+00_JPRB &
  &, 0.564541E+00_JPRB, 0.547865E+00_JPRB, 0.531226E+00_JPRB &
  &, 0.514644E+00_JPRB, 0.498138E+00_JPRB, 0.481724E+00_JPRB, 0.465416E+00_JPRB &
  &, 0.449236E+00_JPRB, 0.433201E+00_JPRB, 0.417327E+00_JPRB &
  &, 0.401631E+00_JPRB, 0.386133E+00_JPRB, 0.370836E+00_JPRB, 0.355775E+00_JPRB &
  &, 0.340958E+00_JPRB, 0.326406E+00_JPRB, 0.312118E+00_JPRB &
  &, 0.298114E+00_JPRB, 0.284415E+00_JPRB, 0.271031E+00_JPRB, 0.257960E+00_JPRB &
  &, 0.245232E+00_JPRB, 0.232843E+00_JPRB, 0.220812E+00_JPRB &
  &, 0.209130E+00_JPRB, 0.197826E+00_JPRB, 0.186888E+00_JPRB, 0.176313E+00_JPRB &
  &, 0.166126E+00_JPRB, 0.156322E+00_JPRB, 0.146893E+00_JPRB &
  &, 0.137858E+00_JPRB, 0.129188E+00_JPRB, 0.120898E+00_JPRB, 0.112985E+00_JPRB &
  &, 0.105444E+00_JPRB, 0.982494E-01_JPRB, 0.914238E-01_JPRB &
  &, 0.849544E-01_JPRB, 0.788245E-01_JPRB, 0.730333E-01_JPRB, 0.675778E-01_JPRB &
  &, 0.624133E-01_JPRB, 0.575703E-01_JPRB, 0.530186E-01_JPRB &
  &, 0.487657E-01_JPRB, 0.447754E-01_JPRB, 0.410507E-01_JPRB, 0.375939E-01_JPRB &
  &, 0.343601E-01_JPRB, 0.313465E-01_JPRB, 0.285725E-01_JPRB &
  &, 0.260099E-01_JPRB, 0.236267E-01_JPRB, 0.214131E-01_JPRB, 0.194093E-01_JPRB &
  &, 0.175525E-01_JPRB, 0.158280E-01_JPRB, 0.142740E-01_JPRB &
  &, 0.128476E-01_JPRB, 0.115585E-01_JPRB, 0.103592E-01_JPRB, 0.928601E-02_JPRB &
  &, 0.828808E-02_JPRB, 0.740174E-02_JPRB, 0.660356E-02_JPRB &
  &, 0.586802E-02_JPRB, 0.523194E-02_JPRB, 0.463612E-02_JPRB, 0.411703E-02_JPRB &
  &, 0.364561E-02_JPRB, 0.319050E-02_JPRB, 0.282358E-02_JPRB &
  &, 0.247845E-02_JPRB, 0.219314E-02_JPRB, 0.193413E-02_JPRB, 0.166552E-02_JPRB &
  &, 0.146366E-02_JPRB, 0.129334E-02_JPRB, 0.111683E-02_JPRB &
  &, 0.974236E-03_JPRB, 0.826583E-03_JPRB, 0.715293E-03_JPRB, 0.642286E-03_JPRB &
  &, 0.523875E-03_JPRB, 0.444995E-03_JPRB, 0.407637E-03_JPRB &
  &, 0.324093E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.153051E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 322, :) = (/ &
  &  0.951073E+00_JPRB, 0.938088E+00_JPRB, 0.924818E+00_JPRB, 0.911275E+00_JPRB &
  &, 0.897466E+00_JPRB, 0.883402E+00_JPRB, 0.869092E+00_JPRB &
  &, 0.854547E+00_JPRB, 0.839776E+00_JPRB, 0.824793E+00_JPRB, 0.809605E+00_JPRB &
  &, 0.794225E+00_JPRB, 0.778665E+00_JPRB, 0.762937E+00_JPRB &
  &, 0.747054E+00_JPRB, 0.731028E+00_JPRB, 0.714870E+00_JPRB, 0.698596E+00_JPRB &
  &, 0.682218E+00_JPRB, 0.665752E+00_JPRB, 0.649211E+00_JPRB &
  &, 0.632611E+00_JPRB, 0.615967E+00_JPRB, 0.599295E+00_JPRB, 0.582612E+00_JPRB &
  &, 0.565934E+00_JPRB, 0.549274E+00_JPRB, 0.532654E+00_JPRB &
  &, 0.516087E+00_JPRB, 0.499592E+00_JPRB, 0.483186E+00_JPRB, 0.466885E+00_JPRB &
  &, 0.450712E+00_JPRB, 0.434678E+00_JPRB, 0.418806E+00_JPRB &
  &, 0.403110E+00_JPRB, 0.387602E+00_JPRB, 0.372312E+00_JPRB, 0.357238E+00_JPRB &
  &, 0.342407E+00_JPRB, 0.327839E+00_JPRB, 0.313534E+00_JPRB &
  &, 0.299521E+00_JPRB, 0.285800E+00_JPRB, 0.272393E+00_JPRB, 0.259307E+00_JPRB &
  &, 0.246552E+00_JPRB, 0.234146E+00_JPRB, 0.222082E+00_JPRB &
  &, 0.210379E+00_JPRB, 0.199038E+00_JPRB, 0.188059E+00_JPRB, 0.177470E+00_JPRB &
  &, 0.167253E+00_JPRB, 0.157402E+00_JPRB, 0.147953E+00_JPRB &
  &, 0.138865E+00_JPRB, 0.130171E+00_JPRB, 0.121839E+00_JPRB, 0.113881E+00_JPRB &
  &, 0.106310E+00_JPRB, 0.990826E-01_JPRB, 0.922226E-01_JPRB &
  &, 0.857165E-01_JPRB, 0.795665E-01_JPRB, 0.737347E-01_JPRB, 0.682364E-01_JPRB &
  &, 0.630466E-01_JPRB, 0.581769E-01_JPRB, 0.535968E-01_JPRB &
  &, 0.492929E-01_JPRB, 0.452706E-01_JPRB, 0.415343E-01_JPRB, 0.380202E-01_JPRB &
  &, 0.347723E-01_JPRB, 0.317437E-01_JPRB, 0.289302E-01_JPRB &
  &, 0.263260E-01_JPRB, 0.239244E-01_JPRB, 0.217167E-01_JPRB, 0.196672E-01_JPRB &
  &, 0.177892E-01_JPRB, 0.160693E-01_JPRB, 0.144926E-01_JPRB &
  &, 0.130425E-01_JPRB, 0.117288E-01_JPRB, 0.105326E-01_JPRB, 0.943325E-02_JPRB &
  &, 0.843805E-02_JPRB, 0.752392E-02_JPRB, 0.672797E-02_JPRB &
  &, 0.599468E-02_JPRB, 0.532864E-02_JPRB, 0.473455E-02_JPRB, 0.418381E-02_JPRB &
  &, 0.371356E-02_JPRB, 0.325964E-02_JPRB, 0.289392E-02_JPRB &
  &, 0.255000E-02_JPRB, 0.222952E-02_JPRB, 0.197114E-02_JPRB, 0.170314E-02_JPRB &
  &, 0.150192E-02_JPRB, 0.129334E-02_JPRB, 0.115636E-02_JPRB &
  &, 0.974236E-03_JPRB, 0.867413E-03_JPRB, 0.756781E-03_JPRB, 0.642286E-03_JPRB &
  &, 0.566698E-03_JPRB, 0.488494E-03_JPRB, 0.407637E-03_JPRB &
  &, 0.368963E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART46',1,ZHOOK_HANDLE)
END SUBROUTINE PART46

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART47

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART47',0,ZHOOK_HANDLE)

XCW( 323, :) = (/ &
  &  0.951344E+00_JPRB, 0.938422E+00_JPRB, 0.925216E+00_JPRB, 0.911735E+00_JPRB &
  &, 0.897986E+00_JPRB, 0.883980E+00_JPRB, 0.869729E+00_JPRB &
  &, 0.855239E+00_JPRB, 0.840523E+00_JPRB, 0.825592E+00_JPRB, 0.810456E+00_JPRB &
  &, 0.795126E+00_JPRB, 0.779614E+00_JPRB, 0.763932E+00_JPRB &
  &, 0.748092E+00_JPRB, 0.732107E+00_JPRB, 0.715990E+00_JPRB, 0.699754E+00_JPRB &
  &, 0.683413E+00_JPRB, 0.666980E+00_JPRB, 0.650473E+00_JPRB &
  &, 0.633904E+00_JPRB, 0.617287E+00_JPRB, 0.600642E+00_JPRB, 0.583980E+00_JPRB &
  &, 0.567323E+00_JPRB, 0.550682E+00_JPRB, 0.534081E+00_JPRB &
  &, 0.517526E+00_JPRB, 0.501043E+00_JPRB, 0.484648E+00_JPRB, 0.468359E+00_JPRB &
  &, 0.452192E+00_JPRB, 0.436160E+00_JPRB, 0.420289E+00_JPRB &
  &, 0.404588E+00_JPRB, 0.389080E+00_JPRB, 0.373779E+00_JPRB, 0.358702E+00_JPRB &
  &, 0.343857E+00_JPRB, 0.329273E+00_JPRB, 0.314960E+00_JPRB &
  &, 0.300927E+00_JPRB, 0.287197E+00_JPRB, 0.273766E+00_JPRB, 0.260655E+00_JPRB &
  &, 0.247883E+00_JPRB, 0.235435E+00_JPRB, 0.223352E+00_JPRB &
  &, 0.211614E+00_JPRB, 0.200249E+00_JPRB, 0.189245E+00_JPRB, 0.178613E+00_JPRB &
  &, 0.168366E+00_JPRB, 0.158497E+00_JPRB, 0.148998E+00_JPRB &
  &, 0.139888E+00_JPRB, 0.131154E+00_JPRB, 0.122796E+00_JPRB, 0.114794E+00_JPRB &
  &, 0.107176E+00_JPRB, 0.999333E-01_JPRB, 0.930391E-01_JPRB &
  &, 0.864968E-01_JPRB, 0.802899E-01_JPRB, 0.744362E-01_JPRB, 0.688950E-01_JPRB &
  &, 0.636799E-01_JPRB, 0.587632E-01_JPRB, 0.541544E-01_JPRB &
  &, 0.498201E-01_JPRB, 0.457874E-01_JPRB, 0.419960E-01_JPRB, 0.384690E-01_JPRB &
  &, 0.351845E-01_JPRB, 0.321410E-01_JPRB, 0.293116E-01_JPRB &
  &, 0.266665E-01_JPRB, 0.242469E-01_JPRB, 0.220203E-01_JPRB, 0.199510E-01_JPRB &
  &, 0.180522E-01_JPRB, 0.163106E-01_JPRB, 0.147112E-01_JPRB &
  &, 0.132375E-01_JPRB, 0.118990E-01_JPRB, 0.107061E-01_JPRB, 0.958049E-02_JPRB &
  &, 0.858801E-02_JPRB, 0.767664E-02_JPRB, 0.685237E-02_JPRB &
  &, 0.608967E-02_JPRB, 0.542534E-02_JPRB, 0.480017E-02_JPRB, 0.425060E-02_JPRB &
  &, 0.378152E-02_JPRB, 0.332879E-02_JPRB, 0.292909E-02_JPRB &
  &, 0.258578E-02_JPRB, 0.226591E-02_JPRB, 0.200814E-02_JPRB, 0.174077E-02_JPRB &
  &, 0.154017E-02_JPRB, 0.133223E-02_JPRB, 0.115636E-02_JPRB &
  &, 0.101441E-02_JPRB, 0.867413E-03_JPRB, 0.756781E-03_JPRB, 0.642286E-03_JPRB &
  &, 0.566698E-03_JPRB, 0.488494E-03_JPRB, 0.407637E-03_JPRB &
  &, 0.368963E-03_JPRB, 0.283389E-03_JPRB, 0.241326E-03_JPRB, 0.197886E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.605924E-04_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 324, :) = (/ &
  &  0.951612E+00_JPRB, 0.938757E+00_JPRB, 0.925613E+00_JPRB, 0.912194E+00_JPRB &
  &, 0.898505E+00_JPRB, 0.884559E+00_JPRB, 0.870365E+00_JPRB &
  &, 0.855931E+00_JPRB, 0.841270E+00_JPRB, 0.826391E+00_JPRB, 0.811307E+00_JPRB &
  &, 0.796026E+00_JPRB, 0.780562E+00_JPRB, 0.764926E+00_JPRB &
  &, 0.749130E+00_JPRB, 0.733187E+00_JPRB, 0.717111E+00_JPRB, 0.700913E+00_JPRB &
  &, 0.684609E+00_JPRB, 0.668211E+00_JPRB, 0.651734E+00_JPRB &
  &, 0.635194E+00_JPRB, 0.618609E+00_JPRB, 0.601988E+00_JPRB, 0.585351E+00_JPRB &
  &, 0.568716E+00_JPRB, 0.552094E+00_JPRB, 0.535508E+00_JPRB &
  &, 0.518969E+00_JPRB, 0.502501E+00_JPRB, 0.486114E+00_JPRB, 0.469832E+00_JPRB &
  &, 0.453668E+00_JPRB, 0.437642E+00_JPRB, 0.421772E+00_JPRB &
  &, 0.406067E+00_JPRB, 0.390558E+00_JPRB, 0.375246E+00_JPRB, 0.360166E+00_JPRB &
  &, 0.345316E+00_JPRB, 0.330716E+00_JPRB, 0.316386E+00_JPRB &
  &, 0.302345E+00_JPRB, 0.288581E+00_JPRB, 0.275138E+00_JPRB, 0.262014E+00_JPRB &
  &, 0.249203E+00_JPRB, 0.236750E+00_JPRB, 0.224635E+00_JPRB &
  &, 0.212862E+00_JPRB, 0.201474E+00_JPRB, 0.190444E+00_JPRB, 0.179771E+00_JPRB &
  &, 0.169493E+00_JPRB, 0.159591E+00_JPRB, 0.150058E+00_JPRB &
  &, 0.140911E+00_JPRB, 0.132137E+00_JPRB, 0.123737E+00_JPRB, 0.115724E+00_JPRB &
  &, 0.108058E+00_JPRB, 0.100767E+00_JPRB, 0.938378E-01_JPRB &
  &, 0.872590E-01_JPRB, 0.810318E-01_JPRB, 0.751376E-01_JPRB, 0.695537E-01_JPRB &
  &, 0.643133E-01_JPRB, 0.593697E-01_JPRB, 0.547326E-01_JPRB &
  &, 0.503684E-01_JPRB, 0.462826E-01_JPRB, 0.424796E-01_JPRB, 0.389178E-01_JPRB &
  &, 0.355967E-01_JPRB, 0.325382E-01_JPRB, 0.296693E-01_JPRB &
  &, 0.270314E-01_JPRB, 0.245694E-01_JPRB, 0.222986E-01_JPRB, 0.202090E-01_JPRB &
  &, 0.183152E-01_JPRB, 0.165519E-01_JPRB, 0.149299E-01_JPRB &
  &, 0.134602E-01_JPRB, 0.120977E-01_JPRB, 0.108506E-01_JPRB, 0.972773E-02_JPRB &
  &, 0.870798E-02_JPRB, 0.779882E-02_JPRB, 0.694568E-02_JPRB &
  &, 0.618467E-02_JPRB, 0.552204E-02_JPRB, 0.489860E-02_JPRB, 0.435077E-02_JPRB &
  &, 0.384947E-02_JPRB, 0.339793E-02_JPRB, 0.299943E-02_JPRB &
  &, 0.265733E-02_JPRB, 0.233868E-02_JPRB, 0.204514E-02_JPRB, 0.177839E-02_JPRB &
  &, 0.157842E-02_JPRB, 0.137112E-02_JPRB, 0.119589E-02_JPRB &
  &, 0.105459E-02_JPRB, 0.908242E-03_JPRB, 0.798268E-03_JPRB, 0.684438E-03_JPRB &
  &, 0.566698E-03_JPRB, 0.488494E-03_JPRB, 0.407637E-03_JPRB &
  &, 0.368963E-03_JPRB, 0.328953E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.108252E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 325, :) = (/ &
  &  0.951883E+00_JPRB, 0.939090E+00_JPRB, 0.926011E+00_JPRB, 0.912653E+00_JPRB &
  &, 0.899024E+00_JPRB, 0.885137E+00_JPRB, 0.871000E+00_JPRB &
  &, 0.856623E+00_JPRB, 0.842016E+00_JPRB, 0.827190E+00_JPRB, 0.812156E+00_JPRB &
  &, 0.796925E+00_JPRB, 0.781510E+00_JPRB, 0.765919E+00_JPRB &
  &, 0.750168E+00_JPRB, 0.734267E+00_JPRB, 0.718231E+00_JPRB, 0.702072E+00_JPRB &
  &, 0.685804E+00_JPRB, 0.669439E+00_JPRB, 0.652998E+00_JPRB &
  &, 0.636487E+00_JPRB, 0.619929E+00_JPRB, 0.603335E+00_JPRB, 0.586723E+00_JPRB &
  &, 0.570106E+00_JPRB, 0.553505E+00_JPRB, 0.536935E+00_JPRB &
  &, 0.520412E+00_JPRB, 0.503956E+00_JPRB, 0.487580E+00_JPRB, 0.471305E+00_JPRB &
  &, 0.455148E+00_JPRB, 0.439125E+00_JPRB, 0.423256E+00_JPRB &
  &, 0.407556E+00_JPRB, 0.392037E+00_JPRB, 0.376722E+00_JPRB, 0.361629E+00_JPRB &
  &, 0.346776E+00_JPRB, 0.332160E+00_JPRB, 0.317822E+00_JPRB &
  &, 0.303751E+00_JPRB, 0.289989E+00_JPRB, 0.276511E+00_JPRB, 0.263361E+00_JPRB &
  &, 0.250535E+00_JPRB, 0.238052E+00_JPRB, 0.225905E+00_JPRB &
  &, 0.214124E+00_JPRB, 0.202698E+00_JPRB, 0.191629E+00_JPRB, 0.180942E+00_JPRB &
  &, 0.170620E+00_JPRB, 0.160686E+00_JPRB, 0.151118E+00_JPRB &
  &, 0.141933E+00_JPRB, 0.133136E+00_JPRB, 0.124694E+00_JPRB, 0.116636E+00_JPRB &
  &, 0.108958E+00_JPRB, 0.101617E+00_JPRB, 0.946544E-01_JPRB &
  &, 0.880393E-01_JPRB, 0.817738E-01_JPRB, 0.758390E-01_JPRB, 0.702317E-01_JPRB &
  &, 0.649466E-01_JPRB, 0.599763E-01_JPRB, 0.552901E-01_JPRB &
  &, 0.509167E-01_JPRB, 0.467994E-01_JPRB, 0.429632E-01_JPRB, 0.393665E-01_JPRB &
  &, 0.360318E-01_JPRB, 0.329355E-01_JPRB, 0.300507E-01_JPRB &
  &, 0.273719E-01_JPRB, 0.248919E-01_JPRB, 0.226022E-01_JPRB, 0.204927E-01_JPRB &
  &, 0.185519E-01_JPRB, 0.167932E-01_JPRB, 0.151485E-01_JPRB &
  &, 0.136552E-01_JPRB, 0.122963E-01_JPRB, 0.110240E-01_JPRB, 0.990442E-02_JPRB &
  &, 0.885795E-02_JPRB, 0.792100E-02_JPRB, 0.707008E-02_JPRB &
  &, 0.631133E-02_JPRB, 0.561875E-02_JPRB, 0.499702E-02_JPRB, 0.441755E-02_JPRB &
  &, 0.391743E-02_JPRB, 0.346707E-02_JPRB, 0.306976E-02_JPRB &
  &, 0.269310E-02_JPRB, 0.237507E-02_JPRB, 0.208214E-02_JPRB, 0.181602E-02_JPRB &
  &, 0.161668E-02_JPRB, 0.141001E-02_JPRB, 0.123542E-02_JPRB &
  &, 0.105459E-02_JPRB, 0.908242E-03_JPRB, 0.798268E-03_JPRB, 0.684438E-03_JPRB &
  &, 0.609521E-03_JPRB, 0.531994E-03_JPRB, 0.451819E-03_JPRB &
  &, 0.368963E-03_JPRB, 0.328953E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 326, :) = (/ &
  &  0.952153E+00_JPRB, 0.939424E+00_JPRB, 0.926407E+00_JPRB, 0.913111E+00_JPRB &
  &, 0.899543E+00_JPRB, 0.885715E+00_JPRB, 0.871635E+00_JPRB &
  &, 0.857314E+00_JPRB, 0.842761E+00_JPRB, 0.827989E+00_JPRB, 0.813006E+00_JPRB &
  &, 0.797824E+00_JPRB, 0.782455E+00_JPRB, 0.766912E+00_JPRB &
  &, 0.751204E+00_JPRB, 0.735346E+00_JPRB, 0.719350E+00_JPRB, 0.703231E+00_JPRB &
  &, 0.686998E+00_JPRB, 0.670670E+00_JPRB, 0.654260E+00_JPRB &
  &, 0.637780E+00_JPRB, 0.621224E+00_JPRB, 0.604681E+00_JPRB, 0.588094E+00_JPRB &
  &, 0.571499E+00_JPRB, 0.554917E+00_JPRB, 0.538367E+00_JPRB &
  &, 0.521858E+00_JPRB, 0.505415E+00_JPRB, 0.489051E+00_JPRB, 0.472783E+00_JPRB &
  &, 0.456632E+00_JPRB, 0.440611E+00_JPRB, 0.424743E+00_JPRB &
  &, 0.409034E+00_JPRB, 0.393524E+00_JPRB, 0.378199E+00_JPRB, 0.363103E+00_JPRB &
  &, 0.348236E+00_JPRB, 0.333614E+00_JPRB, 0.319259E+00_JPRB &
  &, 0.305180E+00_JPRB, 0.291385E+00_JPRB, 0.277896E+00_JPRB, 0.264721E+00_JPRB &
  &, 0.251879E+00_JPRB, 0.239366E+00_JPRB, 0.227187E+00_JPRB &
  &, 0.215372E+00_JPRB, 0.203923E+00_JPRB, 0.192828E+00_JPRB, 0.182099E+00_JPRB &
  &, 0.171762E+00_JPRB, 0.161781E+00_JPRB, 0.152193E+00_JPRB &
  &, 0.142972E+00_JPRB, 0.134119E+00_JPRB, 0.125652E+00_JPRB, 0.117566E+00_JPRB &
  &, 0.109841E+00_JPRB, 0.102485E+00_JPRB, 0.954709E-01_JPRB &
  &, 0.888196E-01_JPRB, 0.825158E-01_JPRB, 0.765594E-01_JPRB, 0.709097E-01_JPRB &
  &, 0.655997E-01_JPRB, 0.605828E-01_JPRB, 0.558683E-01_JPRB &
  &, 0.514650E-01_JPRB, 0.473162E-01_JPRB, 0.434468E-01_JPRB, 0.398377E-01_JPRB &
  &, 0.364669E-01_JPRB, 0.333328E-01_JPRB, 0.304084E-01_JPRB &
  &, 0.277124E-01_JPRB, 0.252144E-01_JPRB, 0.229058E-01_JPRB, 0.207765E-01_JPRB &
  &, 0.188149E-01_JPRB, 0.170345E-01_JPRB, 0.153671E-01_JPRB &
  &, 0.138501E-01_JPRB, 0.124665E-01_JPRB, 0.111975E-01_JPRB, 0.100517E-01_JPRB &
  &, 0.900791E-02_JPRB, 0.807372E-02_JPRB, 0.719449E-02_JPRB &
  &, 0.640632E-02_JPRB, 0.571545E-02_JPRB, 0.509545E-02_JPRB, 0.451772E-02_JPRB &
  &, 0.398538E-02_JPRB, 0.353621E-02_JPRB, 0.310493E-02_JPRB &
  &, 0.276465E-02_JPRB, 0.241145E-02_JPRB, 0.211915E-02_JPRB, 0.185365E-02_JPRB &
  &, 0.165493E-02_JPRB, 0.144889E-02_JPRB, 0.123542E-02_JPRB &
  &, 0.109477E-02_JPRB, 0.949071E-03_JPRB, 0.798268E-03_JPRB, 0.726591E-03_JPRB &
  &, 0.609521E-03_JPRB, 0.531994E-03_JPRB, 0.451819E-03_JPRB &
  &, 0.368963E-03_JPRB, 0.328953E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 327, :) = (/ &
  &  0.952421E+00_JPRB, 0.939758E+00_JPRB, 0.926803E+00_JPRB, 0.913569E+00_JPRB &
  &, 0.900062E+00_JPRB, 0.886292E+00_JPRB, 0.872270E+00_JPRB &
  &, 0.858005E+00_JPRB, 0.843507E+00_JPRB, 0.828787E+00_JPRB, 0.813856E+00_JPRB &
  &, 0.798723E+00_JPRB, 0.783403E+00_JPRB, 0.767904E+00_JPRB &
  &, 0.752242E+00_JPRB, 0.736426E+00_JPRB, 0.720471E+00_JPRB, 0.704386E+00_JPRB &
  &, 0.688194E+00_JPRB, 0.671901E+00_JPRB, 0.655521E+00_JPRB &
  &, 0.639073E+00_JPRB, 0.622571E+00_JPRB, 0.606028E+00_JPRB, 0.589465E+00_JPRB &
  &, 0.572892E+00_JPRB, 0.556333E+00_JPRB, 0.539798E+00_JPRB &
  &, 0.523305E+00_JPRB, 0.506873E+00_JPRB, 0.490517E+00_JPRB, 0.474261E+00_JPRB &
  &, 0.458113E+00_JPRB, 0.442098E+00_JPRB, 0.426231E+00_JPRB &
  &, 0.410523E+00_JPRB, 0.395002E+00_JPRB, 0.379685E+00_JPRB, 0.364577E+00_JPRB &
  &, 0.349695E+00_JPRB, 0.335069E+00_JPRB, 0.320696E+00_JPRB &
  &, 0.306597E+00_JPRB, 0.292793E+00_JPRB, 0.279280E+00_JPRB, 0.266080E+00_JPRB &
  &, 0.253211E+00_JPRB, 0.240681E+00_JPRB, 0.228483E+00_JPRB &
  &, 0.216633E+00_JPRB, 0.205148E+00_JPRB, 0.194027E+00_JPRB, 0.183271E+00_JPRB &
  &, 0.172889E+00_JPRB, 0.162890E+00_JPRB, 0.153253E+00_JPRB &
  &, 0.144010E+00_JPRB, 0.135134E+00_JPRB, 0.126625E+00_JPRB, 0.118495E+00_JPRB &
  &, 0.110740E+00_JPRB, 0.103336E+00_JPRB, 0.963051E-01_JPRB &
  &, 0.896180E-01_JPRB, 0.832763E-01_JPRB, 0.772608E-01_JPRB, 0.715877E-01_JPRB &
  &, 0.662331E-01_JPRB, 0.611893E-01_JPRB, 0.564672E-01_JPRB &
  &, 0.520133E-01_JPRB, 0.478329E-01_JPRB, 0.439304E-01_JPRB, 0.402865E-01_JPRB &
  &, 0.369021E-01_JPRB, 0.337300E-01_JPRB, 0.307898E-01_JPRB &
  &, 0.280772E-01_JPRB, 0.255369E-01_JPRB, 0.232093E-01_JPRB, 0.210603E-01_JPRB &
  &, 0.190779E-01_JPRB, 0.172757E-01_JPRB, 0.155857E-01_JPRB &
  &, 0.140729E-01_JPRB, 0.126652E-01_JPRB, 0.113998E-01_JPRB, 0.102283E-01_JPRB &
  &, 0.915788E-02_JPRB, 0.819590E-02_JPRB, 0.731890E-02_JPRB &
  &, 0.653298E-02_JPRB, 0.581215E-02_JPRB, 0.516107E-02_JPRB, 0.458450E-02_JPRB &
  &, 0.408731E-02_JPRB, 0.360535E-02_JPRB, 0.317527E-02_JPRB &
  &, 0.280043E-02_JPRB, 0.248422E-02_JPRB, 0.215615E-02_JPRB, 0.189127E-02_JPRB &
  &, 0.165493E-02_JPRB, 0.144889E-02_JPRB, 0.127495E-02_JPRB &
  &, 0.109477E-02_JPRB, 0.949071E-03_JPRB, 0.839756E-03_JPRB, 0.726591E-03_JPRB &
  &, 0.609521E-03_JPRB, 0.531994E-03_JPRB, 0.451819E-03_JPRB &
  &, 0.413833E-03_JPRB, 0.328953E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.155206E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 328, :) = (/ &
  &  0.952690E+00_JPRB, 0.940091E+00_JPRB, 0.927199E+00_JPRB, 0.914027E+00_JPRB &
  &, 0.900579E+00_JPRB, 0.886869E+00_JPRB, 0.872904E+00_JPRB &
  &, 0.858695E+00_JPRB, 0.844251E+00_JPRB, 0.829584E+00_JPRB, 0.814704E+00_JPRB &
  &, 0.799621E+00_JPRB, 0.784349E+00_JPRB, 0.768896E+00_JPRB &
  &, 0.753278E+00_JPRB, 0.737505E+00_JPRB, 0.721590E+00_JPRB, 0.705547E+00_JPRB &
  &, 0.689390E+00_JPRB, 0.673128E+00_JPRB, 0.656782E+00_JPRB &
  &, 0.640366E+00_JPRB, 0.623893E+00_JPRB, 0.607378E+00_JPRB, 0.590836E+00_JPRB &
  &, 0.574289E+00_JPRB, 0.557745E+00_JPRB, 0.541229E+00_JPRB &
  &, 0.524752E+00_JPRB, 0.508332E+00_JPRB, 0.491987E+00_JPRB, 0.475738E+00_JPRB &
  &, 0.459601E+00_JPRB, 0.443589E+00_JPRB, 0.427723E+00_JPRB &
  &, 0.412020E+00_JPRB, 0.396490E+00_JPRB, 0.381162E+00_JPRB, 0.366051E+00_JPRB &
  &, 0.351165E+00_JPRB, 0.336512E+00_JPRB, 0.322133E+00_JPRB &
  &, 0.308015E+00_JPRB, 0.294189E+00_JPRB, 0.280665E+00_JPRB, 0.267451E+00_JPRB &
  &, 0.254555E+00_JPRB, 0.241996E+00_JPRB, 0.229778E+00_JPRB &
  &, 0.217908E+00_JPRB, 0.206386E+00_JPRB, 0.195240E+00_JPRB, 0.184457E+00_JPRB &
  &, 0.174031E+00_JPRB, 0.164000E+00_JPRB, 0.154328E+00_JPRB &
  &, 0.145048E+00_JPRB, 0.136133E+00_JPRB, 0.127598E+00_JPRB, 0.119425E+00_JPRB &
  &, 0.111640E+00_JPRB, 0.104204E+00_JPRB, 0.971216E-01_JPRB &
  &, 0.903983E-01_JPRB, 0.840368E-01_JPRB, 0.779812E-01_JPRB, 0.722851E-01_JPRB &
  &, 0.668862E-01_JPRB, 0.618161E-01_JPRB, 0.570454E-01_JPRB &
  &, 0.525616E-01_JPRB, 0.483497E-01_JPRB, 0.444360E-01_JPRB, 0.407577E-01_JPRB &
  &, 0.373372E-01_JPRB, 0.341273E-01_JPRB, 0.311713E-01_JPRB &
  &, 0.284177E-01_JPRB, 0.258842E-01_JPRB, 0.235382E-01_JPRB, 0.213440E-01_JPRB &
  &, 0.193409E-01_JPRB, 0.175170E-01_JPRB, 0.158316E-01_JPRB &
  &, 0.142678E-01_JPRB, 0.128638E-01_JPRB, 0.115733E-01_JPRB, 0.103756E-01_JPRB &
  &, 0.930785E-02_JPRB, 0.834862E-02_JPRB, 0.744331E-02_JPRB &
  &, 0.665964E-02_JPRB, 0.590886E-02_JPRB, 0.525950E-02_JPRB, 0.468467E-02_JPRB &
  &, 0.415527E-02_JPRB, 0.367449E-02_JPRB, 0.324561E-02_JPRB &
  &, 0.287198E-02_JPRB, 0.252061E-02_JPRB, 0.223015E-02_JPRB, 0.196652E-02_JPRB &
  &, 0.169319E-02_JPRB, 0.148778E-02_JPRB, 0.131448E-02_JPRB &
  &, 0.113494E-02_JPRB, 0.989900E-03_JPRB, 0.839756E-03_JPRB, 0.726591E-03_JPRB &
  &, 0.652344E-03_JPRB, 0.575493E-03_JPRB, 0.496001E-03_JPRB &
  &, 0.413833E-03_JPRB, 0.328953E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 329, :) = (/ &
  &  0.952959E+00_JPRB, 0.940424E+00_JPRB, 0.927595E+00_JPRB, 0.914483E+00_JPRB &
  &, 0.901097E+00_JPRB, 0.887446E+00_JPRB, 0.873538E+00_JPRB &
  &, 0.859384E+00_JPRB, 0.844995E+00_JPRB, 0.830382E+00_JPRB, 0.815553E+00_JPRB &
  &, 0.800519E+00_JPRB, 0.785294E+00_JPRB, 0.769888E+00_JPRB &
  &, 0.754312E+00_JPRB, 0.738584E+00_JPRB, 0.722709E+00_JPRB, 0.706705E+00_JPRB &
  &, 0.690584E+00_JPRB, 0.674359E+00_JPRB, 0.658047E+00_JPRB &
  &, 0.641659E+00_JPRB, 0.625213E+00_JPRB, 0.608725E+00_JPRB, 0.592208E+00_JPRB &
  &, 0.575682E+00_JPRB, 0.559160E+00_JPRB, 0.542660E+00_JPRB &
  &, 0.526199E+00_JPRB, 0.509794E+00_JPRB, 0.493461E+00_JPRB, 0.477220E+00_JPRB &
  &, 0.461086E+00_JPRB, 0.445080E+00_JPRB, 0.429216E+00_JPRB &
  &, 0.413508E+00_JPRB, 0.397978E+00_JPRB, 0.382648E+00_JPRB, 0.367524E+00_JPRB &
  &, 0.352625E+00_JPRB, 0.337977E+00_JPRB, 0.323570E+00_JPRB &
  &, 0.309444E+00_JPRB, 0.295608E+00_JPRB, 0.282061E+00_JPRB, 0.268822E+00_JPRB &
  &, 0.255899E+00_JPRB, 0.243323E+00_JPRB, 0.231074E+00_JPRB &
  &, 0.219169E+00_JPRB, 0.207624E+00_JPRB, 0.196453E+00_JPRB, 0.185628E+00_JPRB &
  &, 0.175187E+00_JPRB, 0.165110E+00_JPRB, 0.155418E+00_JPRB &
  &, 0.146087E+00_JPRB, 0.137148E+00_JPRB, 0.128572E+00_JPRB, 0.120371E+00_JPRB &
  &, 0.112540E+00_JPRB, 0.105072E+00_JPRB, 0.979559E-01_JPRB &
  &, 0.911968E-01_JPRB, 0.847973E-01_JPRB, 0.787205E-01_JPRB, 0.729824E-01_JPRB &
  &, 0.675591E-01_JPRB, 0.624428E-01_JPRB, 0.576442E-01_JPRB &
  &, 0.531099E-01_JPRB, 0.488880E-01_JPRB, 0.449196E-01_JPRB, 0.412289E-01_JPRB &
  &, 0.377723E-01_JPRB, 0.345479E-01_JPRB, 0.315528E-01_JPRB &
  &, 0.287825E-01_JPRB, 0.262067E-01_JPRB, 0.238418E-01_JPRB, 0.216536E-01_JPRB &
  &, 0.196302E-01_JPRB, 0.177583E-01_JPRB, 0.160502E-01_JPRB &
  &, 0.144906E-01_JPRB, 0.130624E-01_JPRB, 0.117467E-01_JPRB, 0.105523E-01_JPRB &
  &, 0.945781E-02_JPRB, 0.847080E-02_JPRB, 0.756771E-02_JPRB &
  &, 0.675464E-02_JPRB, 0.603779E-02_JPRB, 0.535793E-02_JPRB, 0.475145E-02_JPRB &
  &, 0.422322E-02_JPRB, 0.374363E-02_JPRB, 0.331595E-02_JPRB &
  &, 0.290775E-02_JPRB, 0.259338E-02_JPRB, 0.226716E-02_JPRB, 0.200415E-02_JPRB &
  &, 0.173144E-02_JPRB, 0.152667E-02_JPRB, 0.135401E-02_JPRB &
  &, 0.117512E-02_JPRB, 0.103073E-02_JPRB, 0.881244E-03_JPRB, 0.768743E-03_JPRB &
  &, 0.652344E-03_JPRB, 0.575493E-03_JPRB, 0.496001E-03_JPRB &
  &, 0.413833E-03_JPRB, 0.374518E-03_JPRB, 0.287591E-03_JPRB, 0.244857E-03_JPRB &
  &, 0.200735E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.613345E-04_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART47',1,ZHOOK_HANDLE)
END SUBROUTINE PART47

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART48

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART48',0,ZHOOK_HANDLE)

XCW( 330, :) = (/ &
  &  0.953227E+00_JPRB, 0.940756E+00_JPRB, 0.927989E+00_JPRB, 0.914941E+00_JPRB &
  &, 0.901614E+00_JPRB, 0.888021E+00_JPRB, 0.874171E+00_JPRB &
  &, 0.860074E+00_JPRB, 0.845740E+00_JPRB, 0.831178E+00_JPRB, 0.816400E+00_JPRB &
  &, 0.801416E+00_JPRB, 0.786239E+00_JPRB, 0.770881E+00_JPRB &
  &, 0.755350E+00_JPRB, 0.739663E+00_JPRB, 0.723828E+00_JPRB, 0.707863E+00_JPRB &
  &, 0.691779E+00_JPRB, 0.675587E+00_JPRB, 0.659308E+00_JPRB &
  &, 0.642953E+00_JPRB, 0.626535E+00_JPRB, 0.610075E+00_JPRB, 0.593582E+00_JPRB &
  &, 0.577079E+00_JPRB, 0.560576E+00_JPRB, 0.544091E+00_JPRB &
  &, 0.527645E+00_JPRB, 0.511253E+00_JPRB, 0.494936E+00_JPRB, 0.478702E+00_JPRB &
  &, 0.462575E+00_JPRB, 0.446570E+00_JPRB, 0.430708E+00_JPRB &
  &, 0.415006E+00_JPRB, 0.399475E+00_JPRB, 0.384134E+00_JPRB, 0.369008E+00_JPRB &
  &, 0.354095E+00_JPRB, 0.339431E+00_JPRB, 0.325017E+00_JPRB &
  &, 0.310883E+00_JPRB, 0.297016E+00_JPRB, 0.283457E+00_JPRB, 0.270194E+00_JPRB &
  &, 0.257255E+00_JPRB, 0.244650E+00_JPRB, 0.232369E+00_JPRB &
  &, 0.220444E+00_JPRB, 0.208876E+00_JPRB, 0.197666E+00_JPRB, 0.186814E+00_JPRB &
  &, 0.176343E+00_JPRB, 0.166234E+00_JPRB, 0.156493E+00_JPRB &
  &, 0.147140E+00_JPRB, 0.138163E+00_JPRB, 0.129545E+00_JPRB, 0.121317E+00_JPRB &
  &, 0.113440E+00_JPRB, 0.105940E+00_JPRB, 0.987902E-01_JPRB &
  &, 0.919952E-01_JPRB, 0.855578E-01_JPRB, 0.794409E-01_JPRB, 0.736604E-01_JPRB &
  &, 0.682122E-01_JPRB, 0.630696E-01_JPRB, 0.582224E-01_JPRB &
  &, 0.536793E-01_JPRB, 0.494263E-01_JPRB, 0.454252E-01_JPRB, 0.417001E-01_JPRB &
  &, 0.382074E-01_JPRB, 0.349685E-01_JPRB, 0.319581E-01_JPRB &
  &, 0.291474E-01_JPRB, 0.265540E-01_JPRB, 0.241454E-01_JPRB, 0.219373E-01_JPRB &
  &, 0.198932E-01_JPRB, 0.180264E-01_JPRB, 0.162961E-01_JPRB &
  &, 0.147134E-01_JPRB, 0.132610E-01_JPRB, 0.119202E-01_JPRB, 0.107290E-01_JPRB &
  &, 0.960778E-02_JPRB, 0.862352E-02_JPRB, 0.769212E-02_JPRB &
  &, 0.688130E-02_JPRB, 0.613449E-02_JPRB, 0.545635E-02_JPRB, 0.485162E-02_JPRB &
  &, 0.432516E-02_JPRB, 0.381278E-02_JPRB, 0.338629E-02_JPRB &
  &, 0.297930E-02_JPRB, 0.262977E-02_JPRB, 0.230416E-02_JPRB, 0.204177E-02_JPRB &
  &, 0.176970E-02_JPRB, 0.156556E-02_JPRB, 0.135401E-02_JPRB &
  &, 0.117512E-02_JPRB, 0.103073E-02_JPRB, 0.881244E-03_JPRB, 0.768743E-03_JPRB &
  &, 0.695167E-03_JPRB, 0.575493E-03_JPRB, 0.496001E-03_JPRB &
  &, 0.413833E-03_JPRB, 0.374518E-03_JPRB, 0.333856E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.109713E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 331, :) = (/ &
  &  0.953496E+00_JPRB, 0.941088E+00_JPRB, 0.928384E+00_JPRB, 0.915397E+00_JPRB &
  &, 0.902130E+00_JPRB, 0.888596E+00_JPRB, 0.874804E+00_JPRB &
  &, 0.860762E+00_JPRB, 0.846483E+00_JPRB, 0.831974E+00_JPRB, 0.817248E+00_JPRB &
  &, 0.802314E+00_JPRB, 0.787185E+00_JPRB, 0.771872E+00_JPRB &
  &, 0.756385E+00_JPRB, 0.740741E+00_JPRB, 0.724947E+00_JPRB, 0.709021E+00_JPRB &
  &, 0.692973E+00_JPRB, 0.676818E+00_JPRB, 0.660570E+00_JPRB &
  &, 0.644246E+00_JPRB, 0.627858E+00_JPRB, 0.611425E+00_JPRB, 0.594957E+00_JPRB &
  &, 0.578472E+00_JPRB, 0.561992E+00_JPRB, 0.545526E+00_JPRB &
  &, 0.529096E+00_JPRB, 0.512719E+00_JPRB, 0.496410E+00_JPRB, 0.480183E+00_JPRB &
  &, 0.464063E+00_JPRB, 0.448066E+00_JPRB, 0.432205E+00_JPRB &
  &, 0.416494E+00_JPRB, 0.400963E+00_JPRB, 0.385620E+00_JPRB, 0.370482E+00_JPRB &
  &, 0.355575E+00_JPRB, 0.340896E+00_JPRB, 0.326465E+00_JPRB &
  &, 0.312312E+00_JPRB, 0.298435E+00_JPRB, 0.284854E+00_JPRB, 0.271577E+00_JPRB &
  &, 0.258612E+00_JPRB, 0.245977E+00_JPRB, 0.233678E+00_JPRB &
  &, 0.221718E+00_JPRB, 0.210128E+00_JPRB, 0.198879E+00_JPRB, 0.187999E+00_JPRB &
  &, 0.177499E+00_JPRB, 0.167358E+00_JPRB, 0.157583E+00_JPRB &
  &, 0.148194E+00_JPRB, 0.139178E+00_JPRB, 0.130535E+00_JPRB, 0.122263E+00_JPRB &
  &, 0.114356E+00_JPRB, 0.106825E+00_JPRB, 0.996422E-01_JPRB &
  &, 0.928118E-01_JPRB, 0.863183E-01_JPRB, 0.801802E-01_JPRB, 0.743772E-01_JPRB &
  &, 0.688852E-01_JPRB, 0.636963E-01_JPRB, 0.588213E-01_JPRB &
  &, 0.542486E-01_JPRB, 0.499646E-01_JPRB, 0.459308E-01_JPRB, 0.421713E-01_JPRB &
  &, 0.386654E-01_JPRB, 0.353891E-01_JPRB, 0.323395E-01_JPRB &
  &, 0.295122E-01_JPRB, 0.269013E-01_JPRB, 0.244743E-01_JPRB, 0.222469E-01_JPRB &
  &, 0.201825E-01_JPRB, 0.182677E-01_JPRB, 0.165147E-01_JPRB &
  &, 0.149361E-01_JPRB, 0.134596E-01_JPRB, 0.121226E-01_JPRB, 0.108762E-01_JPRB &
  &, 0.978773E-02_JPRB, 0.874570E-02_JPRB, 0.784763E-02_JPRB &
  &, 0.700796E-02_JPRB, 0.623120E-02_JPRB, 0.555478E-02_JPRB, 0.495180E-02_JPRB &
  &, 0.439311E-02_JPRB, 0.388192E-02_JPRB, 0.345663E-02_JPRB &
  &, 0.305085E-02_JPRB, 0.266615E-02_JPRB, 0.237816E-02_JPRB, 0.207940E-02_JPRB &
  &, 0.180795E-02_JPRB, 0.160445E-02_JPRB, 0.139354E-02_JPRB &
  &, 0.121529E-02_JPRB, 0.107156E-02_JPRB, 0.922732E-03_JPRB, 0.810895E-03_JPRB &
  &, 0.695167E-03_JPRB, 0.618992E-03_JPRB, 0.496001E-03_JPRB &
  &, 0.458704E-03_JPRB, 0.374518E-03_JPRB, 0.333856E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 332, :) = (/ &
  &  0.953763E+00_JPRB, 0.941420E+00_JPRB, 0.928779E+00_JPRB, 0.915852E+00_JPRB &
  &, 0.902647E+00_JPRB, 0.889171E+00_JPRB, 0.875436E+00_JPRB &
  &, 0.861451E+00_JPRB, 0.847225E+00_JPRB, 0.832769E+00_JPRB, 0.818094E+00_JPRB &
  &, 0.803210E+00_JPRB, 0.788129E+00_JPRB, 0.772862E+00_JPRB &
  &, 0.757421E+00_JPRB, 0.741818E+00_JPRB, 0.726066E+00_JPRB, 0.710178E+00_JPRB &
  &, 0.694169E+00_JPRB, 0.678049E+00_JPRB, 0.661834E+00_JPRB &
  &, 0.645539E+00_JPRB, 0.629181E+00_JPRB, 0.612771E+00_JPRB, 0.596328E+00_JPRB &
  &, 0.579868E+00_JPRB, 0.563407E+00_JPRB, 0.546961E+00_JPRB &
  &, 0.530546E+00_JPRB, 0.514182E+00_JPRB, 0.497884E+00_JPRB, 0.481669E+00_JPRB &
  &, 0.465557E+00_JPRB, 0.449561E+00_JPRB, 0.433702E+00_JPRB &
  &, 0.417992E+00_JPRB, 0.402460E+00_JPRB, 0.387116E+00_JPRB, 0.371976E+00_JPRB &
  &, 0.357045E+00_JPRB, 0.342361E+00_JPRB, 0.327924E+00_JPRB &
  &, 0.313752E+00_JPRB, 0.299854E+00_JPRB, 0.286250E+00_JPRB, 0.272948E+00_JPRB &
  &, 0.259968E+00_JPRB, 0.247304E+00_JPRB, 0.234986E+00_JPRB &
  &, 0.223006E+00_JPRB, 0.211379E+00_JPRB, 0.200106E+00_JPRB, 0.189199E+00_JPRB &
  &, 0.178655E+00_JPRB, 0.168483E+00_JPRB, 0.158689E+00_JPRB &
  &, 0.149264E+00_JPRB, 0.140209E+00_JPRB, 0.131525E+00_JPRB, 0.123225E+00_JPRB &
  &, 0.115273E+00_JPRB, 0.107710E+00_JPRB, 0.100494E+00_JPRB &
  &, 0.936284E-01_JPRB, 0.870974E-01_JPRB, 0.809195E-01_JPRB, 0.750746E-01_JPRB &
  &, 0.695581E-01_JPRB, 0.643433E-01_JPRB, 0.594408E-01_JPRB &
  &, 0.548180E-01_JPRB, 0.505029E-01_JPRB, 0.464364E-01_JPRB, 0.426425E-01_JPRB &
  &, 0.391005E-01_JPRB, 0.358098E-01_JPRB, 0.327449E-01_JPRB &
  &, 0.298770E-01_JPRB, 0.272486E-01_JPRB, 0.248032E-01_JPRB, 0.225307E-01_JPRB &
  &, 0.204455E-01_JPRB, 0.185358E-01_JPRB, 0.167607E-01_JPRB &
  &, 0.151311E-01_JPRB, 0.136583E-01_JPRB, 0.122960E-01_JPRB, 0.110529E-01_JPRB &
  &, 0.993770E-02_JPRB, 0.889842E-02_JPRB, 0.797203E-02_JPRB &
  &, 0.713462E-02_JPRB, 0.636013E-02_JPRB, 0.565321E-02_JPRB, 0.505197E-02_JPRB &
  &, 0.446107E-02_JPRB, 0.395106E-02_JPRB, 0.352697E-02_JPRB &
  &, 0.308662E-02_JPRB, 0.273892E-02_JPRB, 0.241517E-02_JPRB, 0.211702E-02_JPRB &
  &, 0.184620E-02_JPRB, 0.164334E-02_JPRB, 0.143307E-02_JPRB &
  &, 0.125547E-02_JPRB, 0.107156E-02_JPRB, 0.964220E-03_JPRB, 0.810895E-03_JPRB &
  &, 0.695167E-03_JPRB, 0.618992E-03_JPRB, 0.540183E-03_JPRB &
  &, 0.458704E-03_JPRB, 0.374518E-03_JPRB, 0.333856E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 333, :) = (/ &
  &  0.954029E+00_JPRB, 0.941751E+00_JPRB, 0.929172E+00_JPRB, 0.916308E+00_JPRB &
  &, 0.903162E+00_JPRB, 0.889746E+00_JPRB, 0.876068E+00_JPRB &
  &, 0.862139E+00_JPRB, 0.847968E+00_JPRB, 0.833565E+00_JPRB, 0.818941E+00_JPRB &
  &, 0.804106E+00_JPRB, 0.789074E+00_JPRB, 0.773850E+00_JPRB &
  &, 0.758456E+00_JPRB, 0.742896E+00_JPRB, 0.727185E+00_JPRB, 0.711336E+00_JPRB &
  &, 0.695363E+00_JPRB, 0.679277E+00_JPRB, 0.663096E+00_JPRB &
  &, 0.646835E+00_JPRB, 0.630503E+00_JPRB, 0.614121E+00_JPRB, 0.597703E+00_JPRB &
  &, 0.581269E+00_JPRB, 0.564827E+00_JPRB, 0.548399E+00_JPRB &
  &, 0.532001E+00_JPRB, 0.515648E+00_JPRB, 0.499363E+00_JPRB, 0.483155E+00_JPRB &
  &, 0.467050E+00_JPRB, 0.451061E+00_JPRB, 0.435203E+00_JPRB &
  &, 0.419498E+00_JPRB, 0.403957E+00_JPRB, 0.388613E+00_JPRB, 0.373460E+00_JPRB &
  &, 0.358525E+00_JPRB, 0.343826E+00_JPRB, 0.329382E+00_JPRB &
  &, 0.315191E+00_JPRB, 0.301273E+00_JPRB, 0.287658E+00_JPRB, 0.274331E+00_JPRB &
  &, 0.261324E+00_JPRB, 0.248644E+00_JPRB, 0.236294E+00_JPRB &
  &, 0.224294E+00_JPRB, 0.212631E+00_JPRB, 0.201333E+00_JPRB, 0.190399E+00_JPRB &
  &, 0.179825E+00_JPRB, 0.169622E+00_JPRB, 0.159779E+00_JPRB &
  &, 0.150317E+00_JPRB, 0.141240E+00_JPRB, 0.132531E+00_JPRB, 0.124188E+00_JPRB &
  &, 0.116207E+00_JPRB, 0.108596E+00_JPRB, 0.101328E+00_JPRB &
  &, 0.944450E-01_JPRB, 0.878764E-01_JPRB, 0.816589E-01_JPRB, 0.757913E-01_JPRB &
  &, 0.702310E-01_JPRB, 0.649903E-01_JPRB, 0.600396E-01_JPRB &
  &, 0.554085E-01_JPRB, 0.510412E-01_JPRB, 0.469639E-01_JPRB, 0.431361E-01_JPRB &
  &, 0.395585E-01_JPRB, 0.362304E-01_JPRB, 0.331502E-01_JPRB &
  &, 0.302662E-01_JPRB, 0.275959E-01_JPRB, 0.251321E-01_JPRB, 0.228402E-01_JPRB &
  &, 0.207348E-01_JPRB, 0.188039E-01_JPRB, 0.170066E-01_JPRB &
  &, 0.153539E-01_JPRB, 0.138569E-01_JPRB, 0.124984E-01_JPRB, 0.112296E-01_JPRB &
  &, 0.100877E-01_JPRB, 0.905114E-02_JPRB, 0.809644E-02_JPRB &
  &, 0.722961E-02_JPRB, 0.645684E-02_JPRB, 0.575164E-02_JPRB, 0.511875E-02_JPRB &
  &, 0.456300E-02_JPRB, 0.405477E-02_JPRB, 0.356214E-02_JPRB &
  &, 0.315817E-02_JPRB, 0.281169E-02_JPRB, 0.245217E-02_JPRB, 0.215465E-02_JPRB &
  &, 0.188446E-02_JPRB, 0.168223E-02_JPRB, 0.147260E-02_JPRB &
  &, 0.129565E-02_JPRB, 0.111239E-02_JPRB, 0.964220E-03_JPRB, 0.853048E-03_JPRB &
  &, 0.737990E-03_JPRB, 0.618992E-03_JPRB, 0.540183E-03_JPRB &
  &, 0.458704E-03_JPRB, 0.420083E-03_JPRB, 0.333856E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.157378E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 334, :) = (/ &
  &  0.954297E+00_JPRB, 0.942081E+00_JPRB, 0.929566E+00_JPRB, 0.916764E+00_JPRB &
  &, 0.903678E+00_JPRB, 0.890320E+00_JPRB, 0.876700E+00_JPRB &
  &, 0.862826E+00_JPRB, 0.848707E+00_JPRB, 0.834359E+00_JPRB, 0.819787E+00_JPRB &
  &, 0.805002E+00_JPRB, 0.790017E+00_JPRB, 0.774843E+00_JPRB &
  &, 0.759491E+00_JPRB, 0.743974E+00_JPRB, 0.728303E+00_JPRB, 0.712494E+00_JPRB &
  &, 0.696557E+00_JPRB, 0.680507E+00_JPRB, 0.664360E+00_JPRB &
  &, 0.648128E+00_JPRB, 0.631826E+00_JPRB, 0.615471E+00_JPRB, 0.599081E+00_JPRB &
  &, 0.582666E+00_JPRB, 0.566246E+00_JPRB, 0.549834E+00_JPRB &
  &, 0.533452E+00_JPRB, 0.517115E+00_JPRB, 0.500837E+00_JPRB, 0.484641E+00_JPRB &
  &, 0.468543E+00_JPRB, 0.452561E+00_JPRB, 0.436705E+00_JPRB &
  &, 0.420996E+00_JPRB, 0.405464E+00_JPRB, 0.390109E+00_JPRB, 0.374953E+00_JPRB &
  &, 0.360005E+00_JPRB, 0.345301E+00_JPRB, 0.330830E+00_JPRB &
  &, 0.316631E+00_JPRB, 0.302703E+00_JPRB, 0.289065E+00_JPRB, 0.275726E+00_JPRB &
  &, 0.262693E+00_JPRB, 0.249983E+00_JPRB, 0.237616E+00_JPRB &
  &, 0.225582E+00_JPRB, 0.213896E+00_JPRB, 0.202559E+00_JPRB, 0.191598E+00_JPRB &
  &, 0.180982E+00_JPRB, 0.170746E+00_JPRB, 0.160884E+00_JPRB &
  &, 0.151387E+00_JPRB, 0.142270E+00_JPRB, 0.133520E+00_JPRB, 0.125151E+00_JPRB &
  &, 0.117140E+00_JPRB, 0.109481E+00_JPRB, 0.102198E+00_JPRB &
  &, 0.952616E-01_JPRB, 0.886740E-01_JPRB, 0.824172E-01_JPRB, 0.765081E-01_JPRB &
  &, 0.709039E-01_JPRB, 0.656373E-01_JPRB, 0.606591E-01_JPRB &
  &, 0.559779E-01_JPRB, 0.515795E-01_JPRB, 0.474695E-01_JPRB, 0.436298E-01_JPRB &
  &, 0.400165E-01_JPRB, 0.366744E-01_JPRB, 0.335555E-01_JPRB &
  &, 0.306310E-01_JPRB, 0.279432E-01_JPRB, 0.254610E-01_JPRB, 0.231498E-01_JPRB &
  &, 0.210241E-01_JPRB, 0.190452E-01_JPRB, 0.172525E-01_JPRB &
  &, 0.156045E-01_JPRB, 0.140839E-01_JPRB, 0.126718E-01_JPRB, 0.114062E-01_JPRB &
  &, 0.102676E-01_JPRB, 0.920386E-02_JPRB, 0.825195E-02_JPRB &
  &, 0.735627E-02_JPRB, 0.658577E-02_JPRB, 0.585007E-02_JPRB, 0.521892E-02_JPRB &
  &, 0.463096E-02_JPRB, 0.412391E-02_JPRB, 0.363248E-02_JPRB &
  &, 0.322972E-02_JPRB, 0.284808E-02_JPRB, 0.252617E-02_JPRB, 0.222990E-02_JPRB &
  &, 0.196097E-02_JPRB, 0.172112E-02_JPRB, 0.151213E-02_JPRB &
  &, 0.129565E-02_JPRB, 0.115322E-02_JPRB, 0.100571E-02_JPRB, 0.853048E-03_JPRB &
  &, 0.737990E-03_JPRB, 0.662492E-03_JPRB, 0.540183E-03_JPRB &
  &, 0.458704E-03_JPRB, 0.420083E-03_JPRB, 0.333856E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.620825E-04_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 335, :) = (/ &
  &  0.954562E+00_JPRB, 0.942412E+00_JPRB, 0.929960E+00_JPRB, 0.917218E+00_JPRB &
  &, 0.904193E+00_JPRB, 0.890894E+00_JPRB, 0.877331E+00_JPRB &
  &, 0.863513E+00_JPRB, 0.849451E+00_JPRB, 0.835153E+00_JPRB, 0.820633E+00_JPRB &
  &, 0.805898E+00_JPRB, 0.790961E+00_JPRB, 0.775832E+00_JPRB &
  &, 0.760525E+00_JPRB, 0.745051E+00_JPRB, 0.729422E+00_JPRB, 0.713652E+00_JPRB &
  &, 0.697752E+00_JPRB, 0.681738E+00_JPRB, 0.665625E+00_JPRB &
  &, 0.649424E+00_JPRB, 0.633152E+00_JPRB, 0.616825E+00_JPRB, 0.600456E+00_JPRB &
  &, 0.584062E+00_JPRB, 0.567665E+00_JPRB, 0.551273E+00_JPRB &
  &, 0.534906E+00_JPRB, 0.518581E+00_JPRB, 0.502320E+00_JPRB, 0.486132E+00_JPRB &
  &, 0.470040E+00_JPRB, 0.454060E+00_JPRB, 0.438210E+00_JPRB &
  &, 0.422503E+00_JPRB, 0.406962E+00_JPRB, 0.391605E+00_JPRB, 0.376437E+00_JPRB &
  &, 0.361495E+00_JPRB, 0.346776E+00_JPRB, 0.332299E+00_JPRB &
  &, 0.318082E+00_JPRB, 0.304133E+00_JPRB, 0.290473E+00_JPRB, 0.277110E+00_JPRB &
  &, 0.264061E+00_JPRB, 0.251335E+00_JPRB, 0.238937E+00_JPRB &
  &, 0.226869E+00_JPRB, 0.215161E+00_JPRB, 0.203800E+00_JPRB, 0.192798E+00_JPRB &
  &, 0.182167E+00_JPRB, 0.171900E+00_JPRB, 0.161990E+00_JPRB &
  &, 0.152471E+00_JPRB, 0.143317E+00_JPRB, 0.134526E+00_JPRB, 0.126113E+00_JPRB &
  &, 0.118057E+00_JPRB, 0.110384E+00_JPRB, 0.103050E+00_JPRB &
  &, 0.960782E-01_JPRB, 0.894531E-01_JPRB, 0.831755E-01_JPRB, 0.772248E-01_JPRB &
  &, 0.715966E-01_JPRB, 0.662842E-01_JPRB, 0.612786E-01_JPRB &
  &, 0.565683E-01_JPRB, 0.521394E-01_JPRB, 0.479971E-01_JPRB, 0.441234E-01_JPRB &
  &, 0.404745E-01_JPRB, 0.370950E-01_JPRB, 0.339608E-01_JPRB &
  &, 0.310201E-01_JPRB, 0.283153E-01_JPRB, 0.257899E-01_JPRB, 0.234594E-01_JPRB &
  &, 0.213134E-01_JPRB, 0.193133E-01_JPRB, 0.174985E-01_JPRB &
  &, 0.158273E-01_JPRB, 0.142825E-01_JPRB, 0.128742E-01_JPRB, 0.115829E-01_JPRB &
  &, 0.104176E-01_JPRB, 0.935658E-02_JPRB, 0.837636E-02_JPRB &
  &, 0.748293E-02_JPRB, 0.668248E-02_JPRB, 0.598130E-02_JPRB, 0.531909E-02_JPRB &
  &, 0.473289E-02_JPRB, 0.419305E-02_JPRB, 0.370282E-02_JPRB &
  &, 0.330127E-02_JPRB, 0.292085E-02_JPRB, 0.256318E-02_JPRB, 0.226753E-02_JPRB &
  &, 0.199922E-02_JPRB, 0.176001E-02_JPRB, 0.151213E-02_JPRB &
  &, 0.133582E-02_JPRB, 0.115322E-02_JPRB, 0.100571E-02_JPRB, 0.895200E-03_JPRB &
  &, 0.780813E-03_JPRB, 0.662492E-03_JPRB, 0.584365E-03_JPRB &
  &, 0.503574E-03_JPRB, 0.420083E-03_JPRB, 0.380121E-03_JPRB, 0.291829E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.203608E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 336, :) = (/ &
  &  0.954830E+00_JPRB, 0.942742E+00_JPRB, 0.930353E+00_JPRB, 0.917673E+00_JPRB &
  &, 0.904707E+00_JPRB, 0.891467E+00_JPRB, 0.877961E+00_JPRB &
  &, 0.864200E+00_JPRB, 0.850192E+00_JPRB, 0.835948E+00_JPRB, 0.821478E+00_JPRB &
  &, 0.806793E+00_JPRB, 0.791903E+00_JPRB, 0.776811E+00_JPRB &
  &, 0.761560E+00_JPRB, 0.746128E+00_JPRB, 0.730540E+00_JPRB, 0.714809E+00_JPRB &
  &, 0.698946E+00_JPRB, 0.682969E+00_JPRB, 0.666886E+00_JPRB &
  &, 0.650717E+00_JPRB, 0.634475E+00_JPRB, 0.618175E+00_JPRB, 0.601831E+00_JPRB &
  &, 0.585463E+00_JPRB, 0.569085E+00_JPRB, 0.552712E+00_JPRB &
  &, 0.536361E+00_JPRB, 0.520052E+00_JPRB, 0.503798E+00_JPRB, 0.487622E+00_JPRB &
  &, 0.471538E+00_JPRB, 0.455565E+00_JPRB, 0.439716E+00_JPRB &
  &, 0.424010E+00_JPRB, 0.408468E+00_JPRB, 0.393101E+00_JPRB, 0.377931E+00_JPRB &
  &, 0.362975E+00_JPRB, 0.348252E+00_JPRB, 0.333757E+00_JPRB &
  &, 0.319532E+00_JPRB, 0.305564E+00_JPRB, 0.291893E+00_JPRB, 0.278505E+00_JPRB &
  &, 0.265442E+00_JPRB, 0.252688E+00_JPRB, 0.240258E+00_JPRB &
  &, 0.228170E+00_JPRB, 0.216426E+00_JPRB, 0.205041E+00_JPRB, 0.194012E+00_JPRB &
  &, 0.183337E+00_JPRB, 0.173039E+00_JPRB, 0.163110E+00_JPRB &
  &, 0.153541E+00_JPRB, 0.144364E+00_JPRB, 0.135532E+00_JPRB, 0.127093E+00_JPRB &
  &, 0.119008E+00_JPRB, 0.111287E+00_JPRB, 0.103920E+00_JPRB &
  &, 0.969130E-01_JPRB, 0.902507E-01_JPRB, 0.839337E-01_JPRB, 0.779415E-01_JPRB &
  &, 0.722893E-01_JPRB, 0.669312E-01_JPRB, 0.618981E-01_JPRB &
  &, 0.571588E-01_JPRB, 0.526992E-01_JPRB, 0.485247E-01_JPRB, 0.446171E-01_JPRB &
  &, 0.409554E-01_JPRB, 0.375390E-01_JPRB, 0.343661E-01_JPRB &
  &, 0.314093E-01_JPRB, 0.286626E-01_JPRB, 0.261188E-01_JPRB, 0.237689E-01_JPRB &
  &, 0.216027E-01_JPRB, 0.195814E-01_JPRB, 0.177444E-01_JPRB &
  &, 0.160500E-01_JPRB, 0.145095E-01_JPRB, 0.130765E-01_JPRB, 0.117596E-01_JPRB &
  &, 0.105975E-01_JPRB, 0.950931E-02_JPRB, 0.853186E-02_JPRB &
  &, 0.760959E-02_JPRB, 0.681141E-02_JPRB, 0.607973E-02_JPRB, 0.541926E-02_JPRB &
  &, 0.480084E-02_JPRB, 0.426219E-02_JPRB, 0.380833E-02_JPRB &
  &, 0.337282E-02_JPRB, 0.295724E-02_JPRB, 0.260018E-02_JPRB, 0.230515E-02_JPRB &
  &, 0.203748E-02_JPRB, 0.179890E-02_JPRB, 0.155166E-02_JPRB &
  &, 0.137600E-02_JPRB, 0.119405E-02_JPRB, 0.104720E-02_JPRB, 0.895200E-03_JPRB &
  &, 0.780813E-03_JPRB, 0.662492E-03_JPRB, 0.584365E-03_JPRB &
  &, 0.503574E-03_JPRB, 0.420083E-03_JPRB, 0.380121E-03_JPRB, 0.338800E-03_JPRB &
  &, 0.248419E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.111185E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART48',1,ZHOOK_HANDLE)
END SUBROUTINE PART48

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART49

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART49',0,ZHOOK_HANDLE)

XCW( 337, :) = (/ &
  &  0.955096E+00_JPRB, 0.943074E+00_JPRB, 0.930745E+00_JPRB, 0.918127E+00_JPRB &
  &, 0.905221E+00_JPRB, 0.892040E+00_JPRB, 0.878592E+00_JPRB &
  &, 0.864885E+00_JPRB, 0.850932E+00_JPRB, 0.836741E+00_JPRB, 0.822323E+00_JPRB &
  &, 0.807687E+00_JPRB, 0.792846E+00_JPRB, 0.777811E+00_JPRB &
  &, 0.762593E+00_JPRB, 0.747204E+00_JPRB, 0.731659E+00_JPRB, 0.715966E+00_JPRB &
  &, 0.700142E+00_JPRB, 0.684197E+00_JPRB, 0.668151E+00_JPRB &
  &, 0.652014E+00_JPRB, 0.635801E+00_JPRB, 0.619528E+00_JPRB, 0.603209E+00_JPRB &
  &, 0.586863E+00_JPRB, 0.570504E+00_JPRB, 0.554150E+00_JPRB &
  &, 0.537819E+00_JPRB, 0.521522E+00_JPRB, 0.505280E+00_JPRB, 0.489116E+00_JPRB &
  &, 0.473039E+00_JPRB, 0.457069E+00_JPRB, 0.441222E+00_JPRB &
  &, 0.425516E+00_JPRB, 0.409975E+00_JPRB, 0.394607E+00_JPRB, 0.379435E+00_JPRB &
  &, 0.364466E+00_JPRB, 0.349727E+00_JPRB, 0.335227E+00_JPRB &
  &, 0.320983E+00_JPRB, 0.307005E+00_JPRB, 0.293312E+00_JPRB, 0.279912E+00_JPRB &
  &, 0.266811E+00_JPRB, 0.254040E+00_JPRB, 0.241592E+00_JPRB &
  &, 0.229471E+00_JPRB, 0.217705E+00_JPRB, 0.206281E+00_JPRB, 0.195226E+00_JPRB &
  &, 0.184522E+00_JPRB, 0.174193E+00_JPRB, 0.164231E+00_JPRB &
  &, 0.154626E+00_JPRB, 0.145410E+00_JPRB, 0.136554E+00_JPRB, 0.128072E+00_JPRB &
  &, 0.119941E+00_JPRB, 0.112189E+00_JPRB, 0.104790E+00_JPRB &
  &, 0.977477E-01_JPRB, 0.910483E-01_JPRB, 0.846920E-01_JPRB, 0.786777E-01_JPRB &
  &, 0.729820E-01_JPRB, 0.675984E-01_JPRB, 0.625176E-01_JPRB &
  &, 0.577493E-01_JPRB, 0.532590E-01_JPRB, 0.490523E-01_JPRB, 0.451107E-01_JPRB &
  &, 0.414134E-01_JPRB, 0.379830E-01_JPRB, 0.347714E-01_JPRB &
  &, 0.317984E-01_JPRB, 0.290347E-01_JPRB, 0.264729E-01_JPRB, 0.240785E-01_JPRB &
  &, 0.218920E-01_JPRB, 0.198763E-01_JPRB, 0.179903E-01_JPRB &
  &, 0.163007E-01_JPRB, 0.147081E-01_JPRB, 0.132789E-01_JPRB, 0.119658E-01_JPRB &
  &, 0.107475E-01_JPRB, 0.966203E-02_JPRB, 0.865627E-02_JPRB &
  &, 0.773625E-02_JPRB, 0.694035E-02_JPRB, 0.617816E-02_JPRB, 0.551944E-02_JPRB &
  &, 0.490278E-02_JPRB, 0.436591E-02_JPRB, 0.387867E-02_JPRB &
  &, 0.340860E-02_JPRB, 0.303001E-02_JPRB, 0.267418E-02_JPRB, 0.234278E-02_JPRB &
  &, 0.207573E-02_JPRB, 0.183779E-02_JPRB, 0.159119E-02_JPRB &
  &, 0.141618E-02_JPRB, 0.123488E-02_JPRB, 0.104720E-02_JPRB, 0.937353E-03_JPRB &
  &, 0.823636E-03_JPRB, 0.705991E-03_JPRB, 0.584365E-03_JPRB &
  &, 0.503574E-03_JPRB, 0.465648E-03_JPRB, 0.380121E-03_JPRB, 0.338800E-03_JPRB &
  &, 0.296102E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.161777E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 338, :) = (/ &
  &  0.955362E+00_JPRB, 0.943402E+00_JPRB, 0.931138E+00_JPRB, 0.918580E+00_JPRB &
  &, 0.905735E+00_JPRB, 0.892612E+00_JPRB, 0.879221E+00_JPRB &
  &, 0.865571E+00_JPRB, 0.851672E+00_JPRB, 0.837534E+00_JPRB, 0.823166E+00_JPRB &
  &, 0.808582E+00_JPRB, 0.793789E+00_JPRB, 0.778800E+00_JPRB &
  &, 0.763627E+00_JPRB, 0.748281E+00_JPRB, 0.732776E+00_JPRB, 0.717123E+00_JPRB &
  &, 0.701336E+00_JPRB, 0.685428E+00_JPRB, 0.669415E+00_JPRB &
  &, 0.653307E+00_JPRB, 0.637124E+00_JPRB, 0.620878E+00_JPRB, 0.604588E+00_JPRB &
  &, 0.588263E+00_JPRB, 0.571927E+00_JPRB, 0.555593E+00_JPRB &
  &, 0.539274E+00_JPRB, 0.522993E+00_JPRB, 0.506767E+00_JPRB, 0.490611E+00_JPRB &
  &, 0.474541E+00_JPRB, 0.458573E+00_JPRB, 0.442733E+00_JPRB &
  &, 0.427033E+00_JPRB, 0.411482E+00_JPRB, 0.396112E+00_JPRB, 0.380939E+00_JPRB &
  &, 0.365956E+00_JPRB, 0.351213E+00_JPRB, 0.336696E+00_JPRB &
  &, 0.322434E+00_JPRB, 0.308447E+00_JPRB, 0.294732E+00_JPRB, 0.281307E+00_JPRB &
  &, 0.268191E+00_JPRB, 0.255392E+00_JPRB, 0.242926E+00_JPRB &
  &, 0.230785E+00_JPRB, 0.218983E+00_JPRB, 0.207535E+00_JPRB, 0.196440E+00_JPRB &
  &, 0.185707E+00_JPRB, 0.175347E+00_JPRB, 0.165351E+00_JPRB &
  &, 0.155726E+00_JPRB, 0.146457E+00_JPRB, 0.137576E+00_JPRB, 0.129051E+00_JPRB &
  &, 0.120892E+00_JPRB, 0.113109E+00_JPRB, 0.105660E+00_JPRB &
  &, 0.985825E-01_JPRB, 0.918644E-01_JPRB, 0.854693E-01_JPRB, 0.794138E-01_JPRB &
  &, 0.736748E-01_JPRB, 0.682656E-01_JPRB, 0.631578E-01_JPRB &
  &, 0.583397E-01_JPRB, 0.538189E-01_JPRB, 0.495798E-01_JPRB, 0.456043E-01_JPRB &
  &, 0.418943E-01_JPRB, 0.384270E-01_JPRB, 0.352006E-01_JPRB &
  &, 0.321876E-01_JPRB, 0.294068E-01_JPRB, 0.268018E-01_JPRB, 0.244139E-01_JPRB &
  &, 0.221814E-01_JPRB, 0.201444E-01_JPRB, 0.182636E-01_JPRB &
  &, 0.165234E-01_JPRB, 0.149351E-01_JPRB, 0.134812E-01_JPRB, 0.121424E-01_JPRB &
  &, 0.109275E-01_JPRB, 0.981475E-02_JPRB, 0.881178E-02_JPRB &
  &, 0.789457E-02_JPRB, 0.703705E-02_JPRB, 0.630940E-02_JPRB, 0.561961E-02_JPRB &
  &, 0.500471E-02_JPRB, 0.443505E-02_JPRB, 0.394901E-02_JPRB &
  &, 0.348015E-02_JPRB, 0.310278E-02_JPRB, 0.271119E-02_JPRB, 0.241803E-02_JPRB &
  &, 0.211398E-02_JPRB, 0.187667E-02_JPRB, 0.163072E-02_JPRB &
  &, 0.141618E-02_JPRB, 0.123488E-02_JPRB, 0.108868E-02_JPRB, 0.937353E-03_JPRB &
  &, 0.823636E-03_JPRB, 0.705991E-03_JPRB, 0.628547E-03_JPRB &
  &, 0.548444E-03_JPRB, 0.465648E-03_JPRB, 0.380121E-03_JPRB, 0.338800E-03_JPRB &
  &, 0.296102E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.161777E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 339, :) = (/ &
  &  0.955629E+00_JPRB, 0.943732E+00_JPRB, 0.931530E+00_JPRB, 0.919033E+00_JPRB &
  &, 0.906248E+00_JPRB, 0.893184E+00_JPRB, 0.879850E+00_JPRB &
  &, 0.866257E+00_JPRB, 0.852412E+00_JPRB, 0.838325E+00_JPRB, 0.824011E+00_JPRB &
  &, 0.809475E+00_JPRB, 0.794731E+00_JPRB, 0.779788E+00_JPRB &
  &, 0.764660E+00_JPRB, 0.749358E+00_JPRB, 0.733894E+00_JPRB, 0.718281E+00_JPRB &
  &, 0.702532E+00_JPRB, 0.686659E+00_JPRB, 0.670680E+00_JPRB &
  &, 0.654603E+00_JPRB, 0.638450E+00_JPRB, 0.622232E+00_JPRB, 0.605966E+00_JPRB &
  &, 0.589664E+00_JPRB, 0.573350E+00_JPRB, 0.557032E+00_JPRB &
  &, 0.540732E+00_JPRB, 0.524467E+00_JPRB, 0.508250E+00_JPRB, 0.492105E+00_JPRB &
  &, 0.476043E+00_JPRB, 0.460082E+00_JPRB, 0.444243E+00_JPRB &
  &, 0.428539E+00_JPRB, 0.412998E+00_JPRB, 0.397618E+00_JPRB, 0.382432E+00_JPRB &
  &, 0.367457E+00_JPRB, 0.352699E+00_JPRB, 0.338165E+00_JPRB &
  &, 0.323896E+00_JPRB, 0.309889E+00_JPRB, 0.296151E+00_JPRB, 0.282714E+00_JPRB &
  &, 0.269584E+00_JPRB, 0.256757E+00_JPRB, 0.244260E+00_JPRB &
  &, 0.232086E+00_JPRB, 0.220262E+00_JPRB, 0.208790E+00_JPRB, 0.197668E+00_JPRB &
  &, 0.186907E+00_JPRB, 0.176501E+00_JPRB, 0.166472E+00_JPRB &
  &, 0.156811E+00_JPRB, 0.147519E+00_JPRB, 0.138599E+00_JPRB, 0.130030E+00_JPRB &
  &, 0.121842E+00_JPRB, 0.114012E+00_JPRB, 0.106547E+00_JPRB &
  &, 0.994354E-01_JPRB, 0.926621E-01_JPRB, 0.862465E-01_JPRB, 0.801499E-01_JPRB &
  &, 0.743873E-01_JPRB, 0.689328E-01_JPRB, 0.637979E-01_JPRB &
  &, 0.589513E-01_JPRB, 0.544003E-01_JPRB, 0.501294E-01_JPRB, 0.461204E-01_JPRB &
  &, 0.423752E-01_JPRB, 0.388710E-01_JPRB, 0.356297E-01_JPRB &
  &, 0.325767E-01_JPRB, 0.297541E-01_JPRB, 0.271560E-01_JPRB, 0.247234E-01_JPRB &
  &, 0.224970E-01_JPRB, 0.204125E-01_JPRB, 0.185095E-01_JPRB &
  &, 0.167741E-01_JPRB, 0.151621E-01_JPRB, 0.136836E-01_JPRB, 0.123191E-01_JPRB &
  &, 0.111074E-01_JPRB, 0.996747E-02_JPRB, 0.893619E-02_JPRB &
  &, 0.802123E-02_JPRB, 0.716599E-02_JPRB, 0.640783E-02_JPRB, 0.571978E-02_JPRB &
  &, 0.507267E-02_JPRB, 0.453876E-02_JPRB, 0.401935E-02_JPRB &
  &, 0.355170E-02_JPRB, 0.313917E-02_JPRB, 0.278519E-02_JPRB, 0.245565E-02_JPRB &
  &, 0.215224E-02_JPRB, 0.191556E-02_JPRB, 0.167025E-02_JPRB &
  &, 0.145635E-02_JPRB, 0.127570E-02_JPRB, 0.113017E-02_JPRB, 0.979505E-03_JPRB &
  &, 0.823636E-03_JPRB, 0.749491E-03_JPRB, 0.628547E-03_JPRB &
  &, 0.548444E-03_JPRB, 0.465648E-03_JPRB, 0.426386E-03_JPRB, 0.338800E-03_JPRB &
  &, 0.296102E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.159569E-03_JPRB, 0.161777E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 340, :) = (/ &
  &  0.955893E+00_JPRB, 0.944061E+00_JPRB, 0.931921E+00_JPRB, 0.919486E+00_JPRB &
  &, 0.906761E+00_JPRB, 0.893755E+00_JPRB, 0.880479E+00_JPRB &
  &, 0.866941E+00_JPRB, 0.853151E+00_JPRB, 0.839119E+00_JPRB, 0.824855E+00_JPRB &
  &, 0.810369E+00_JPRB, 0.795673E+00_JPRB, 0.780778E+00_JPRB &
  &, 0.765694E+00_JPRB, 0.750435E+00_JPRB, 0.735012E+00_JPRB, 0.719438E+00_JPRB &
  &, 0.703726E+00_JPRB, 0.687890E+00_JPRB, 0.671941E+00_JPRB &
  &, 0.655900E+00_JPRB, 0.639776E+00_JPRB, 0.623585E+00_JPRB, 0.607344E+00_JPRB &
  &, 0.591068E+00_JPRB, 0.574773E+00_JPRB, 0.558474E+00_JPRB &
  &, 0.542191E+00_JPRB, 0.525942E+00_JPRB, 0.509736E+00_JPRB, 0.493599E+00_JPRB &
  &, 0.477549E+00_JPRB, 0.461595E+00_JPRB, 0.445758E+00_JPRB &
  &, 0.430055E+00_JPRB, 0.414515E+00_JPRB, 0.399134E+00_JPRB, 0.383946E+00_JPRB &
  &, 0.368958E+00_JPRB, 0.354185E+00_JPRB, 0.339645E+00_JPRB &
  &, 0.325358E+00_JPRB, 0.311330E+00_JPRB, 0.297582E+00_JPRB, 0.284121E+00_JPRB &
  &, 0.270965E+00_JPRB, 0.258121E+00_JPRB, 0.245594E+00_JPRB &
  &, 0.233400E+00_JPRB, 0.221554E+00_JPRB, 0.210044E+00_JPRB, 0.198896E+00_JPRB &
  &, 0.188106E+00_JPRB, 0.177670E+00_JPRB, 0.167608E+00_JPRB &
  &, 0.157911E+00_JPRB, 0.148582E+00_JPRB, 0.139621E+00_JPRB, 0.131026E+00_JPRB &
  &, 0.122810E+00_JPRB, 0.114932E+00_JPRB, 0.107435E+00_JPRB &
  &, 0.100288E+00_JPRB, 0.934782E-01_JPRB, 0.870238E-01_JPRB, 0.808860E-01_JPRB &
  &, 0.750800E-01_JPRB, 0.696000E-01_JPRB, 0.644381E-01_JPRB &
  &, 0.595628E-01_JPRB, 0.549816E-01_JPRB, 0.506789E-01_JPRB, 0.466365E-01_JPRB &
  &, 0.428561E-01_JPRB, 0.393383E-01_JPRB, 0.360350E-01_JPRB &
  &, 0.329902E-01_JPRB, 0.301510E-01_JPRB, 0.275102E-01_JPRB, 0.250588E-01_JPRB &
  &, 0.227863E-01_JPRB, 0.207074E-01_JPRB, 0.187828E-01_JPRB &
  &, 0.169968E-01_JPRB, 0.153891E-01_JPRB, 0.138860E-01_JPRB, 0.125253E-01_JPRB &
  &, 0.112874E-01_JPRB, 0.101202E-01_JPRB, 0.909169E-02_JPRB &
  &, 0.814789E-02_JPRB, 0.729492E-02_JPRB, 0.650625E-02_JPRB, 0.581995E-02_JPRB &
  &, 0.517460E-02_JPRB, 0.460790E-02_JPRB, 0.408969E-02_JPRB &
  &, 0.362324E-02_JPRB, 0.321194E-02_JPRB, 0.282219E-02_JPRB, 0.249328E-02_JPRB &
  &, 0.219049E-02_JPRB, 0.195445E-02_JPRB, 0.170978E-02_JPRB &
  &, 0.149653E-02_JPRB, 0.131653E-02_JPRB, 0.113017E-02_JPRB, 0.979505E-03_JPRB &
  &, 0.866459E-03_JPRB, 0.749491E-03_JPRB, 0.672729E-03_JPRB &
  &, 0.548444E-03_JPRB, 0.465648E-03_JPRB, 0.426386E-03_JPRB, 0.338800E-03_JPRB &
  &, 0.296102E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.628365E-04_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 341, :) = (/ &
  &  0.956158E+00_JPRB, 0.944390E+00_JPRB, 0.932313E+00_JPRB, 0.919939E+00_JPRB &
  &, 0.907273E+00_JPRB, 0.894327E+00_JPRB, 0.881108E+00_JPRB &
  &, 0.867625E+00_JPRB, 0.853890E+00_JPRB, 0.839911E+00_JPRB, 0.825698E+00_JPRB &
  &, 0.811262E+00_JPRB, 0.796614E+00_JPRB, 0.781766E+00_JPRB &
  &, 0.766728E+00_JPRB, 0.751510E+00_JPRB, 0.736129E+00_JPRB, 0.720595E+00_JPRB &
  &, 0.704921E+00_JPRB, 0.689121E+00_JPRB, 0.673206E+00_JPRB &
  &, 0.657196E+00_JPRB, 0.641102E+00_JPRB, 0.624939E+00_JPRB, 0.608723E+00_JPRB &
  &, 0.592472E+00_JPRB, 0.576196E+00_JPRB, 0.559920E+00_JPRB &
  &, 0.543653E+00_JPRB, 0.527417E+00_JPRB, 0.511227E+00_JPRB, 0.495098E+00_JPRB &
  &, 0.479055E+00_JPRB, 0.463108E+00_JPRB, 0.447273E+00_JPRB &
  &, 0.431571E+00_JPRB, 0.416031E+00_JPRB, 0.400649E+00_JPRB, 0.385450E+00_JPRB &
  &, 0.370458E+00_JPRB, 0.355671E+00_JPRB, 0.341125E+00_JPRB &
  &, 0.326819E+00_JPRB, 0.312783E+00_JPRB, 0.299013E+00_JPRB, 0.285540E+00_JPRB &
  &, 0.272358E+00_JPRB, 0.259486E+00_JPRB, 0.246941E+00_JPRB &
  &, 0.234727E+00_JPRB, 0.222846E+00_JPRB, 0.211312E+00_JPRB, 0.200124E+00_JPRB &
  &, 0.189305E+00_JPRB, 0.178838E+00_JPRB, 0.168743E+00_JPRB &
  &, 0.159011E+00_JPRB, 0.149644E+00_JPRB, 0.140659E+00_JPRB, 0.132022E+00_JPRB &
  &, 0.123761E+00_JPRB, 0.115870E+00_JPRB, 0.108322E+00_JPRB &
  &, 0.101141E+00_JPRB, 0.942943E-01_JPRB, 0.878010E-01_JPRB, 0.816415E-01_JPRB &
  &, 0.757925E-01_JPRB, 0.702874E-01_JPRB, 0.650782E-01_JPRB &
  &, 0.601744E-01_JPRB, 0.555415E-01_JPRB, 0.512065E-01_JPRB, 0.471526E-01_JPRB &
  &, 0.433370E-01_JPRB, 0.397823E-01_JPRB, 0.364880E-01_JPRB &
  &, 0.333793E-01_JPRB, 0.305232E-01_JPRB, 0.278644E-01_JPRB, 0.253941E-01_JPRB &
  &, 0.231019E-01_JPRB, 0.209755E-01_JPRB, 0.190287E-01_JPRB &
  &, 0.172475E-01_JPRB, 0.156161E-01_JPRB, 0.140883E-01_JPRB, 0.127019E-01_JPRB &
  &, 0.114374E-01_JPRB, 0.103035E-01_JPRB, 0.924720E-02_JPRB &
  &, 0.827455E-02_JPRB, 0.742386E-02_JPRB, 0.663749E-02_JPRB, 0.592012E-02_JPRB &
  &, 0.527653E-02_JPRB, 0.467704E-02_JPRB, 0.416003E-02_JPRB &
  &, 0.369479E-02_JPRB, 0.328471E-02_JPRB, 0.289620E-02_JPRB, 0.256853E-02_JPRB &
  &, 0.226700E-02_JPRB, 0.199334E-02_JPRB, 0.174931E-02_JPRB &
  &, 0.153671E-02_JPRB, 0.131653E-02_JPRB, 0.117166E-02_JPRB, 0.102166E-02_JPRB &
  &, 0.866459E-03_JPRB, 0.749491E-03_JPRB, 0.672729E-03_JPRB &
  &, 0.593315E-03_JPRB, 0.511212E-03_JPRB, 0.426386E-03_JPRB, 0.385772E-03_JPRB &
  &, 0.296102E-03_JPRB, 0.252010E-03_JPRB, 0.206505E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.112669E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 342, :) = (/ &
  &  0.956423E+00_JPRB, 0.944718E+00_JPRB, 0.932704E+00_JPRB, 0.920391E+00_JPRB &
  &, 0.907785E+00_JPRB, 0.894897E+00_JPRB, 0.881736E+00_JPRB &
  &, 0.868310E+00_JPRB, 0.854628E+00_JPRB, 0.840702E+00_JPRB, 0.826541E+00_JPRB &
  &, 0.812155E+00_JPRB, 0.797556E+00_JPRB, 0.782754E+00_JPRB &
  &, 0.767760E+00_JPRB, 0.752587E+00_JPRB, 0.737247E+00_JPRB, 0.721752E+00_JPRB &
  &, 0.706115E+00_JPRB, 0.690352E+00_JPRB, 0.674470E+00_JPRB &
  &, 0.658492E+00_JPRB, 0.642428E+00_JPRB, 0.626292E+00_JPRB, 0.610105E+00_JPRB &
  &, 0.593876E+00_JPRB, 0.577623E+00_JPRB, 0.561363E+00_JPRB &
  &, 0.545115E+00_JPRB, 0.528891E+00_JPRB, 0.512714E+00_JPRB, 0.496601E+00_JPRB &
  &, 0.480561E+00_JPRB, 0.464621E+00_JPRB, 0.448793E+00_JPRB &
  &, 0.433097E+00_JPRB, 0.417547E+00_JPRB, 0.402165E+00_JPRB, 0.386964E+00_JPRB &
  &, 0.371959E+00_JPRB, 0.357167E+00_JPRB, 0.342605E+00_JPRB &
  &, 0.328292E+00_JPRB, 0.314236E+00_JPRB, 0.300456E+00_JPRB, 0.286959E+00_JPRB &
  &, 0.273751E+00_JPRB, 0.260863E+00_JPRB, 0.248288E+00_JPRB &
  &, 0.236041E+00_JPRB, 0.224138E+00_JPRB, 0.212580E+00_JPRB, 0.201366E+00_JPRB &
  &, 0.190505E+00_JPRB, 0.180022E+00_JPRB, 0.169879E+00_JPRB &
  &, 0.160127E+00_JPRB, 0.150723E+00_JPRB, 0.141697E+00_JPRB, 0.133034E+00_JPRB &
  &, 0.124728E+00_JPRB, 0.116668E+00_JPRB, 0.109227E+00_JPRB &
  &, 0.101994E+00_JPRB, 0.951290E-01_JPRB, 0.885783E-01_JPRB, 0.823970E-01_JPRB &
  &, 0.765248E-01_JPRB, 0.709748E-01_JPRB, 0.657184E-01_JPRB &
  &, 0.607859E-01_JPRB, 0.561444E-01_JPRB, 0.517780E-01_JPRB, 0.476687E-01_JPRB &
  &, 0.438408E-01_JPRB, 0.402497E-01_JPRB, 0.369172E-01_JPRB &
  &, 0.337928E-01_JPRB, 0.308953E-01_JPRB, 0.282186E-01_JPRB, 0.257037E-01_JPRB &
  &, 0.234175E-01_JPRB, 0.212705E-01_JPRB, 0.193020E-01_JPRB &
  &, 0.174981E-01_JPRB, 0.158431E-01_JPRB, 0.143196E-01_JPRB, 0.129081E-01_JPRB &
  &, 0.116173E-01_JPRB, 0.104562E-01_JPRB, 0.940271E-02_JPRB &
  &, 0.843288E-02_JPRB, 0.755280E-02_JPRB, 0.673592E-02_JPRB, 0.602029E-02_JPRB &
  &, 0.537846E-02_JPRB, 0.478075E-02_JPRB, 0.426554E-02_JPRB &
  &, 0.376634E-02_JPRB, 0.335748E-02_JPRB, 0.297020E-02_JPRB, 0.260615E-02_JPRB &
  &, 0.230526E-02_JPRB, 0.203223E-02_JPRB, 0.178884E-02_JPRB &
  &, 0.157688E-02_JPRB, 0.135736E-02_JPRB, 0.121315E-02_JPRB, 0.102166E-02_JPRB &
  &, 0.909282E-03_JPRB, 0.792990E-03_JPRB, 0.672729E-03_JPRB &
  &, 0.593315E-03_JPRB, 0.511212E-03_JPRB, 0.426386E-03_JPRB, 0.385772E-03_JPRB &
  &, 0.343786E-03_JPRB, 0.252010E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 343, :) = (/ &
  &  0.956689E+00_JPRB, 0.945047E+00_JPRB, 0.933094E+00_JPRB, 0.920843E+00_JPRB &
  &, 0.908297E+00_JPRB, 0.895468E+00_JPRB, 0.882364E+00_JPRB &
  &, 0.868994E+00_JPRB, 0.855367E+00_JPRB, 0.841494E+00_JPRB, 0.827384E+00_JPRB &
  &, 0.813047E+00_JPRB, 0.798496E+00_JPRB, 0.783741E+00_JPRB &
  &, 0.768793E+00_JPRB, 0.753662E+00_JPRB, 0.738364E+00_JPRB, 0.722909E+00_JPRB &
  &, 0.707311E+00_JPRB, 0.691582E+00_JPRB, 0.675735E+00_JPRB &
  &, 0.659789E+00_JPRB, 0.643754E+00_JPRB, 0.627649E+00_JPRB, 0.611483E+00_JPRB &
  &, 0.595280E+00_JPRB, 0.579050E+00_JPRB, 0.562809E+00_JPRB &
  &, 0.546578E+00_JPRB, 0.530370E+00_JPRB, 0.514204E+00_JPRB, 0.498099E+00_JPRB &
  &, 0.482071E+00_JPRB, 0.466134E+00_JPRB, 0.450312E+00_JPRB &
  &, 0.434613E+00_JPRB, 0.419064E+00_JPRB, 0.403681E+00_JPRB, 0.388478E+00_JPRB &
  &, 0.373460E+00_JPRB, 0.358663E+00_JPRB, 0.344096E+00_JPRB &
  &, 0.329765E+00_JPRB, 0.315689E+00_JPRB, 0.301899E+00_JPRB, 0.288378E+00_JPRB &
  &, 0.275156E+00_JPRB, 0.262240E+00_JPRB, 0.249647E+00_JPRB &
  &, 0.237368E+00_JPRB, 0.225444E+00_JPRB, 0.213848E+00_JPRB, 0.202608E+00_JPRB &
  &, 0.191719E+00_JPRB, 0.181190E+00_JPRB, 0.171030E+00_JPRB &
  &, 0.161227E+00_JPRB, 0.151801E+00_JPRB, 0.142736E+00_JPRB, 0.134047E+00_JPRB &
  &, 0.125713E+00_JPRB, 0.117727E+00_JPRB, 0.110115E+00_JPRB &
  &, 0.102865E+00_JPRB, 0.959452E-01_JPRB, 0.893745E-01_JPRB, 0.831525E-01_JPRB &
  &, 0.772373E-01_JPRB, 0.716622E-01_JPRB, 0.663792E-01_JPRB &
  &, 0.613975E-01_JPRB, 0.567257E-01_JPRB, 0.523276E-01_JPRB, 0.482072E-01_JPRB &
  &, 0.443446E-01_JPRB, 0.407170E-01_JPRB, 0.373463E-01_JPRB &
  &, 0.342063E-01_JPRB, 0.312922E-01_JPRB, 0.285728E-01_JPRB, 0.260391E-01_JPRB &
  &, 0.237331E-01_JPRB, 0.215654E-01_JPRB, 0.195752E-01_JPRB &
  &, 0.177487E-01_JPRB, 0.160701E-01_JPRB, 0.145219E-01_JPRB, 0.131142E-01_JPRB &
  &, 0.118273E-01_JPRB, 0.106394E-01_JPRB, 0.955822E-02_JPRB &
  &, 0.855954E-02_JPRB, 0.768173E-02_JPRB, 0.686716E-02_JPRB, 0.612046E-02_JPRB &
  &, 0.548040E-02_JPRB, 0.488447E-02_JPRB, 0.433587E-02_JPRB &
  &, 0.383789E-02_JPRB, 0.339387E-02_JPRB, 0.300721E-02_JPRB, 0.268140E-02_JPRB &
  &, 0.234351E-02_JPRB, 0.207112E-02_JPRB, 0.182837E-02_JPRB &
  &, 0.157688E-02_JPRB, 0.139819E-02_JPRB, 0.121315E-02_JPRB, 0.106381E-02_JPRB &
  &, 0.909282E-03_JPRB, 0.792990E-03_JPRB, 0.716911E-03_JPRB &
  &, 0.593315E-03_JPRB, 0.511212E-03_JPRB, 0.472651E-03_JPRB, 0.385772E-03_JPRB &
  &, 0.343786E-03_JPRB, 0.300412E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART49',1,ZHOOK_HANDLE)
END SUBROUTINE PART49

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART50

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART50',0,ZHOOK_HANDLE)

XCW( 344, :) = (/ &
  &  0.956954E+00_JPRB, 0.945374E+00_JPRB, 0.933485E+00_JPRB, 0.921294E+00_JPRB &
  &, 0.908808E+00_JPRB, 0.896038E+00_JPRB, 0.882990E+00_JPRB &
  &, 0.869677E+00_JPRB, 0.856104E+00_JPRB, 0.842284E+00_JPRB, 0.828227E+00_JPRB &
  &, 0.813939E+00_JPRB, 0.799437E+00_JPRB, 0.784728E+00_JPRB &
  &, 0.769825E+00_JPRB, 0.754733E+00_JPRB, 0.739482E+00_JPRB, 0.724067E+00_JPRB &
  &, 0.708505E+00_JPRB, 0.692813E+00_JPRB, 0.677003E+00_JPRB &
  &, 0.661088E+00_JPRB, 0.645083E+00_JPRB, 0.629003E+00_JPRB, 0.612865E+00_JPRB &
  &, 0.596684E+00_JPRB, 0.580476E+00_JPRB, 0.564256E+00_JPRB &
  &, 0.548040E+00_JPRB, 0.531852E+00_JPRB, 0.515699E+00_JPRB, 0.499602E+00_JPRB &
  &, 0.483582E+00_JPRB, 0.467656E+00_JPRB, 0.451836E+00_JPRB &
  &, 0.436138E+00_JPRB, 0.420590E+00_JPRB, 0.405196E+00_JPRB, 0.389992E+00_JPRB &
  &, 0.374971E+00_JPRB, 0.360160E+00_JPRB, 0.345587E+00_JPRB &
  &, 0.331238E+00_JPRB, 0.317154E+00_JPRB, 0.303341E+00_JPRB, 0.289797E+00_JPRB &
  &, 0.276561E+00_JPRB, 0.263617E+00_JPRB, 0.251007E+00_JPRB &
  &, 0.238708E+00_JPRB, 0.226749E+00_JPRB, 0.215130E+00_JPRB, 0.203850E+00_JPRB &
  &, 0.192933E+00_JPRB, 0.182374E+00_JPRB, 0.172181E+00_JPRB &
  &, 0.162359E+00_JPRB, 0.152879E+00_JPRB, 0.143790E+00_JPRB, 0.135059E+00_JPRB &
  &, 0.126680E+00_JPRB, 0.118682E+00_JPRB, 0.111020E+00_JPRB &
  &, 0.103736E+00_JPRB, 0.967799E-01_JPRB, 0.901707E-01_JPRB, 0.839080E-01_JPRB &
  &, 0.779696E-01_JPRB, 0.723496E-01_JPRB, 0.670400E-01_JPRB &
  &, 0.620301E-01_JPRB, 0.573071E-01_JPRB, 0.528772E-01_JPRB, 0.487232E-01_JPRB &
  &, 0.448255E-01_JPRB, 0.411844E-01_JPRB, 0.377993E-01_JPRB &
  &, 0.346197E-01_JPRB, 0.316643E-01_JPRB, 0.289270E-01_JPRB, 0.264002E-01_JPRB &
  &, 0.240487E-01_JPRB, 0.218603E-01_JPRB, 0.198485E-01_JPRB &
  &, 0.179993E-01_JPRB, 0.162971E-01_JPRB, 0.147532E-01_JPRB, 0.133203E-01_JPRB &
  &, 0.120072E-01_JPRB, 0.107922E-01_JPRB, 0.971373E-02_JPRB &
  &, 0.871786E-02_JPRB, 0.781067E-02_JPRB, 0.699840E-02_JPRB, 0.625403E-02_JPRB &
  &, 0.558233E-02_JPRB, 0.495361E-02_JPRB, 0.440621E-02_JPRB &
  &, 0.390944E-02_JPRB, 0.346664E-02_JPRB, 0.308121E-02_JPRB, 0.271903E-02_JPRB &
  &, 0.238176E-02_JPRB, 0.211001E-02_JPRB, 0.186790E-02_JPRB &
  &, 0.161706E-02_JPRB, 0.143902E-02_JPRB, 0.125463E-02_JPRB, 0.110596E-02_JPRB &
  &, 0.952105E-03_JPRB, 0.836490E-03_JPRB, 0.716911E-03_JPRB &
  &, 0.638185E-03_JPRB, 0.556777E-03_JPRB, 0.472651E-03_JPRB, 0.385772E-03_JPRB &
  &, 0.343786E-03_JPRB, 0.300412E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 345, :) = (/ &
  &  0.957218E+00_JPRB, 0.945703E+00_JPRB, 0.933875E+00_JPRB, 0.921745E+00_JPRB &
  &, 0.909319E+00_JPRB, 0.896608E+00_JPRB, 0.883618E+00_JPRB &
  &, 0.870360E+00_JPRB, 0.856842E+00_JPRB, 0.843075E+00_JPRB, 0.829068E+00_JPRB &
  &, 0.814830E+00_JPRB, 0.800377E+00_JPRB, 0.785716E+00_JPRB &
  &, 0.770857E+00_JPRB, 0.755815E+00_JPRB, 0.740598E+00_JPRB, 0.725224E+00_JPRB &
  &, 0.709700E+00_JPRB, 0.694044E+00_JPRB, 0.678267E+00_JPRB &
  &, 0.662385E+00_JPRB, 0.646410E+00_JPRB, 0.630359E+00_JPRB, 0.614247E+00_JPRB &
  &, 0.598092E+00_JPRB, 0.581903E+00_JPRB, 0.565702E+00_JPRB &
  &, 0.549506E+00_JPRB, 0.533331E+00_JPRB, 0.517190E+00_JPRB, 0.501109E+00_JPRB &
  &, 0.485097E+00_JPRB, 0.469173E+00_JPRB, 0.453356E+00_JPRB &
  &, 0.437664E+00_JPRB, 0.422115E+00_JPRB, 0.406722E+00_JPRB, 0.391505E+00_JPRB &
  &, 0.376482E+00_JPRB, 0.361667E+00_JPRB, 0.347078E+00_JPRB &
  &, 0.332722E+00_JPRB, 0.318618E+00_JPRB, 0.304784E+00_JPRB, 0.291227E+00_JPRB &
  &, 0.277966E+00_JPRB, 0.265007E+00_JPRB, 0.252367E+00_JPRB &
  &, 0.240035E+00_JPRB, 0.228055E+00_JPRB, 0.216398E+00_JPRB, 0.205106E+00_JPRB &
  &, 0.194161E+00_JPRB, 0.183572E+00_JPRB, 0.173332E+00_JPRB &
  &, 0.163474E+00_JPRB, 0.153973E+00_JPRB, 0.144845E+00_JPRB, 0.136071E+00_JPRB &
  &, 0.127665E+00_JPRB, 0.119619E+00_JPRB, 0.111943E+00_JPRB &
  &, 0.104607E+00_JPRB, 0.976146E-01_JPRB, 0.909858E-01_JPRB, 0.846828E-01_JPRB &
  &, 0.787019E-01_JPRB, 0.730370E-01_JPRB, 0.677008E-01_JPRB &
  &, 0.626628E-01_JPRB, 0.579100E-01_JPRB, 0.534487E-01_JPRB, 0.492618E-01_JPRB &
  &, 0.453293E-01_JPRB, 0.416751E-01_JPRB, 0.382285E-01_JPRB &
  &, 0.350332E-01_JPRB, 0.320612E-01_JPRB, 0.293065E-01_JPRB, 0.267356E-01_JPRB &
  &, 0.243643E-01_JPRB, 0.221552E-01_JPRB, 0.201217E-01_JPRB &
  &, 0.182500E-01_JPRB, 0.165525E-01_JPRB, 0.149556E-01_JPRB, 0.134970E-01_JPRB &
  &, 0.121872E-01_JPRB, 0.109754E-01_JPRB, 0.986924E-02_JPRB &
  &, 0.884452E-02_JPRB, 0.793961E-02_JPRB, 0.709682E-02_JPRB, 0.635420E-02_JPRB &
  &, 0.568426E-02_JPRB, 0.505732E-02_JPRB, 0.447655E-02_JPRB &
  &, 0.398099E-02_JPRB, 0.353941E-02_JPRB, 0.311821E-02_JPRB, 0.275666E-02_JPRB &
  &, 0.245827E-02_JPRB, 0.214890E-02_JPRB, 0.190743E-02_JPRB &
  &, 0.165724E-02_JPRB, 0.147985E-02_JPRB, 0.129612E-02_JPRB, 0.110596E-02_JPRB &
  &, 0.994928E-03_JPRB, 0.836490E-03_JPRB, 0.716911E-03_JPRB &
  &, 0.638185E-03_JPRB, 0.556777E-03_JPRB, 0.472651E-03_JPRB, 0.432743E-03_JPRB &
  &, 0.343786E-03_JPRB, 0.300412E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.161777E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 346, :) = (/ &
  &  0.957481E+00_JPRB, 0.946030E+00_JPRB, 0.934264E+00_JPRB, 0.922196E+00_JPRB &
  &, 0.909830E+00_JPRB, 0.897177E+00_JPRB, 0.884244E+00_JPRB &
  &, 0.871041E+00_JPRB, 0.857579E+00_JPRB, 0.843865E+00_JPRB, 0.829910E+00_JPRB &
  &, 0.815723E+00_JPRB, 0.801317E+00_JPRB, 0.786703E+00_JPRB &
  &, 0.771890E+00_JPRB, 0.756890E+00_JPRB, 0.741716E+00_JPRB, 0.726380E+00_JPRB &
  &, 0.710896E+00_JPRB, 0.695275E+00_JPRB, 0.679532E+00_JPRB &
  &, 0.663681E+00_JPRB, 0.647739E+00_JPRB, 0.631716E+00_JPRB, 0.615629E+00_JPRB &
  &, 0.599496E+00_JPRB, 0.583334E+00_JPRB, 0.567152E+00_JPRB &
  &, 0.550973E+00_JPRB, 0.534813E+00_JPRB, 0.518689E+00_JPRB, 0.502612E+00_JPRB &
  &, 0.486611E+00_JPRB, 0.470695E+00_JPRB, 0.454884E+00_JPRB &
  &, 0.439189E+00_JPRB, 0.423641E+00_JPRB, 0.408247E+00_JPRB, 0.393029E+00_JPRB &
  &, 0.378003E+00_JPRB, 0.363174E+00_JPRB, 0.348569E+00_JPRB &
  &, 0.334206E+00_JPRB, 0.320082E+00_JPRB, 0.306238E+00_JPRB, 0.292658E+00_JPRB &
  &, 0.279372E+00_JPRB, 0.266397E+00_JPRB, 0.253726E+00_JPRB &
  &, 0.241376E+00_JPRB, 0.229360E+00_JPRB, 0.217694E+00_JPRB, 0.206362E+00_JPRB &
  &, 0.195375E+00_JPRB, 0.184756E+00_JPRB, 0.174498E+00_JPRB &
  &, 0.164606E+00_JPRB, 0.155068E+00_JPRB, 0.145900E+00_JPRB, 0.137100E+00_JPRB &
  &, 0.128650E+00_JPRB, 0.120574E+00_JPRB, 0.112848E+00_JPRB &
  &, 0.105478E+00_JPRB, 0.984679E-01_JPRB, 0.917820E-01_JPRB, 0.854577E-01_JPRB &
  &, 0.794341E-01_JPRB, 0.737446E-01_JPRB, 0.683616E-01_JPRB &
  &, 0.632954E-01_JPRB, 0.585129E-01_JPRB, 0.540202E-01_JPRB, 0.498003E-01_JPRB &
  &, 0.458560E-01_JPRB, 0.421425E-01_JPRB, 0.386815E-01_JPRB &
  &, 0.354710E-01_JPRB, 0.324581E-01_JPRB, 0.296606E-01_JPRB, 0.270709E-01_JPRB &
  &, 0.246799E-01_JPRB, 0.224501E-01_JPRB, 0.204223E-01_JPRB &
  &, 0.185284E-01_JPRB, 0.167795E-01_JPRB, 0.151868E-01_JPRB, 0.137032E-01_JPRB &
  &, 0.123671E-01_JPRB, 0.111587E-01_JPRB, 0.100247E-01_JPRB &
  &, 0.900285E-02_JPRB, 0.806855E-02_JPRB, 0.722806E-02_JPRB, 0.645437E-02_JPRB &
  &, 0.578620E-02_JPRB, 0.512646E-02_JPRB, 0.458206E-02_JPRB &
  &, 0.405254E-02_JPRB, 0.361218E-02_JPRB, 0.319222E-02_JPRB, 0.283191E-02_JPRB &
  &, 0.249653E-02_JPRB, 0.218779E-02_JPRB, 0.194696E-02_JPRB &
  &, 0.169741E-02_JPRB, 0.147985E-02_JPRB, 0.129612E-02_JPRB, 0.114811E-02_JPRB &
  &, 0.994928E-03_JPRB, 0.879989E-03_JPRB, 0.761093E-03_JPRB &
  &, 0.638185E-03_JPRB, 0.556777E-03_JPRB, 0.472651E-03_JPRB, 0.432743E-03_JPRB &
  &, 0.343786E-03_JPRB, 0.300412E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.635965E-04_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 347, :) = (/ &
  &  0.957745E+00_JPRB, 0.946357E+00_JPRB, 0.934654E+00_JPRB, 0.922646E+00_JPRB &
  &, 0.910340E+00_JPRB, 0.897745E+00_JPRB, 0.884870E+00_JPRB &
  &, 0.871724E+00_JPRB, 0.858315E+00_JPRB, 0.844654E+00_JPRB, 0.830751E+00_JPRB &
  &, 0.816615E+00_JPRB, 0.802258E+00_JPRB, 0.787689E+00_JPRB &
  &, 0.772922E+00_JPRB, 0.757965E+00_JPRB, 0.742833E+00_JPRB, 0.727537E+00_JPRB &
  &, 0.712092E+00_JPRB, 0.696506E+00_JPRB, 0.680800E+00_JPRB &
  &, 0.664981E+00_JPRB, 0.649068E+00_JPRB, 0.633073E+00_JPRB, 0.617014E+00_JPRB &
  &, 0.600903E+00_JPRB, 0.584761E+00_JPRB, 0.568602E+00_JPRB &
  &, 0.552439E+00_JPRB, 0.536296E+00_JPRB, 0.520184E+00_JPRB, 0.504123E+00_JPRB &
  &, 0.488126E+00_JPRB, 0.472217E+00_JPRB, 0.456413E+00_JPRB &
  &, 0.440724E+00_JPRB, 0.425177E+00_JPRB, 0.409772E+00_JPRB, 0.394553E+00_JPRB &
  &, 0.379514E+00_JPRB, 0.364681E+00_JPRB, 0.350070E+00_JPRB &
  &, 0.335690E+00_JPRB, 0.321558E+00_JPRB, 0.307693E+00_JPRB, 0.294101E+00_JPRB &
  &, 0.280789E+00_JPRB, 0.267787E+00_JPRB, 0.255099E+00_JPRB &
  &, 0.242729E+00_JPRB, 0.230679E+00_JPRB, 0.218976E+00_JPRB, 0.207618E+00_JPRB &
  &, 0.196618E+00_JPRB, 0.185954E+00_JPRB, 0.175664E+00_JPRB &
  &, 0.165737E+00_JPRB, 0.156162E+00_JPRB, 0.146954E+00_JPRB, 0.138129E+00_JPRB &
  &, 0.129651E+00_JPRB, 0.121529E+00_JPRB, 0.113771E+00_JPRB &
  &, 0.106367E+00_JPRB, 0.993211E-01_JPRB, 0.925972E-01_JPRB, 0.862326E-01_JPRB &
  &, 0.801862E-01_JPRB, 0.744523E-01_JPRB, 0.690430E-01_JPRB &
  &, 0.639281E-01_JPRB, 0.591158E-01_JPRB, 0.545918E-01_JPRB, 0.503388E-01_JPRB &
  &, 0.463598E-01_JPRB, 0.426332E-01_JPRB, 0.391345E-01_JPRB &
  &, 0.358845E-01_JPRB, 0.328551E-01_JPRB, 0.300401E-01_JPRB, 0.274321E-01_JPRB &
  &, 0.249955E-01_JPRB, 0.227718E-01_JPRB, 0.206956E-01_JPRB &
  &, 0.187791E-01_JPRB, 0.170349E-01_JPRB, 0.154181E-01_JPRB, 0.139093E-01_JPRB &
  &, 0.125771E-01_JPRB, 0.113114E-01_JPRB, 0.101803E-01_JPRB &
  &, 0.916117E-02_JPRB, 0.819748E-02_JPRB, 0.735930E-02_JPRB, 0.658793E-02_JPRB &
  &, 0.588813E-02_JPRB, 0.523017E-02_JPRB, 0.465240E-02_JPRB &
  &, 0.415987E-02_JPRB, 0.368495E-02_JPRB, 0.326622E-02_JPRB, 0.286953E-02_JPRB &
  &, 0.253478E-02_JPRB, 0.226556E-02_JPRB, 0.198649E-02_JPRB &
  &, 0.173759E-02_JPRB, 0.152068E-02_JPRB, 0.133761E-02_JPRB, 0.119027E-02_JPRB &
  &, 0.103775E-02_JPRB, 0.879989E-03_JPRB, 0.761093E-03_JPRB &
  &, 0.683056E-03_JPRB, 0.602342E-03_JPRB, 0.518916E-03_JPRB, 0.432743E-03_JPRB &
  &, 0.391470E-03_JPRB, 0.300412E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.209425E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.114165E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 348, :) = (/ &
  &  0.958008E+00_JPRB, 0.946684E+00_JPRB, 0.935043E+00_JPRB, 0.923096E+00_JPRB &
  &, 0.910850E+00_JPRB, 0.898314E+00_JPRB, 0.885496E+00_JPRB &
  &, 0.872406E+00_JPRB, 0.859051E+00_JPRB, 0.845443E+00_JPRB, 0.831592E+00_JPRB &
  &, 0.817506E+00_JPRB, 0.803196E+00_JPRB, 0.788676E+00_JPRB &
  &, 0.773952E+00_JPRB, 0.759041E+00_JPRB, 0.743951E+00_JPRB, 0.728694E+00_JPRB &
  &, 0.713287E+00_JPRB, 0.697737E+00_JPRB, 0.682064E+00_JPRB &
  &, 0.666280E+00_JPRB, 0.650394E+00_JPRB, 0.634430E+00_JPRB, 0.618396E+00_JPRB &
  &, 0.602315E+00_JPRB, 0.586191E+00_JPRB, 0.570052E+00_JPRB &
  &, 0.553909E+00_JPRB, 0.537778E+00_JPRB, 0.521683E+00_JPRB, 0.505630E+00_JPRB &
  &, 0.489645E+00_JPRB, 0.473744E+00_JPRB, 0.457942E+00_JPRB &
  &, 0.442259E+00_JPRB, 0.426703E+00_JPRB, 0.411308E+00_JPRB, 0.396077E+00_JPRB &
  &, 0.381035E+00_JPRB, 0.366198E+00_JPRB, 0.351572E+00_JPRB &
  &, 0.337174E+00_JPRB, 0.323034E+00_JPRB, 0.309147E+00_JPRB, 0.295532E+00_JPRB &
  &, 0.282206E+00_JPRB, 0.269189E+00_JPRB, 0.256471E+00_JPRB &
  &, 0.244069E+00_JPRB, 0.232011E+00_JPRB, 0.220271E+00_JPRB, 0.208889E+00_JPRB &
  &, 0.197846E+00_JPRB, 0.187167E+00_JPRB, 0.176830E+00_JPRB &
  &, 0.166868E+00_JPRB, 0.157272E+00_JPRB, 0.148025E+00_JPRB, 0.139158E+00_JPRB &
  &, 0.130636E+00_JPRB, 0.122501E+00_JPRB, 0.114694E+00_JPRB &
  &, 0.107257E+00_JPRB, 0.100174E+00_JPRB, 0.934124E-01_JPRB, 0.870074E-01_JPRB &
  &, 0.809185E-01_JPRB, 0.751599E-01_JPRB, 0.697245E-01_JPRB &
  &, 0.645818E-01_JPRB, 0.597402E-01_JPRB, 0.551853E-01_JPRB, 0.508997E-01_JPRB &
  &, 0.468865E-01_JPRB, 0.431239E-01_JPRB, 0.396113E-01_JPRB &
  &, 0.363223E-01_JPRB, 0.332768E-01_JPRB, 0.304196E-01_JPRB, 0.277932E-01_JPRB &
  &, 0.253374E-01_JPRB, 0.230667E-01_JPRB, 0.209688E-01_JPRB &
  &, 0.190575E-01_JPRB, 0.172619E-01_JPRB, 0.156205E-01_JPRB, 0.141449E-01_JPRB &
  &, 0.127570E-01_JPRB, 0.114947E-01_JPRB, 0.103358E-01_JPRB &
  &, 0.928783E-02_JPRB, 0.835865E-02_JPRB, 0.749054E-02_JPRB, 0.668810E-02_JPRB &
  &, 0.599006E-02_JPRB, 0.533389E-02_JPRB, 0.475791E-02_JPRB &
  &, 0.423141E-02_JPRB, 0.375772E-02_JPRB, 0.334023E-02_JPRB, 0.294478E-02_JPRB &
  &, 0.261129E-02_JPRB, 0.230445E-02_JPRB, 0.202602E-02_JPRB &
  &, 0.177777E-02_JPRB, 0.156151E-02_JPRB, 0.137910E-02_JPRB, 0.119027E-02_JPRB &
  &, 0.103775E-02_JPRB, 0.923489E-03_JPRB, 0.805275E-03_JPRB &
  &, 0.683056E-03_JPRB, 0.602342E-03_JPRB, 0.518916E-03_JPRB, 0.432743E-03_JPRB &
  &, 0.391470E-03_JPRB, 0.348814E-03_JPRB, 0.255631E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 349, :) = (/ &
  &  0.958271E+00_JPRB, 0.947010E+00_JPRB, 0.935432E+00_JPRB, 0.923546E+00_JPRB &
  &, 0.911360E+00_JPRB, 0.898882E+00_JPRB, 0.886121E+00_JPRB &
  &, 0.873087E+00_JPRB, 0.859788E+00_JPRB, 0.846233E+00_JPRB, 0.832433E+00_JPRB &
  &, 0.818397E+00_JPRB, 0.804137E+00_JPRB, 0.789662E+00_JPRB &
  &, 0.774984E+00_JPRB, 0.760116E+00_JPRB, 0.745067E+00_JPRB, 0.729851E+00_JPRB &
  &, 0.714481E+00_JPRB, 0.698971E+00_JPRB, 0.683332E+00_JPRB &
  &, 0.667577E+00_JPRB, 0.651724E+00_JPRB, 0.635787E+00_JPRB, 0.619782E+00_JPRB &
  &, 0.603722E+00_JPRB, 0.587625E+00_JPRB, 0.571502E+00_JPRB &
  &, 0.555379E+00_JPRB, 0.539265E+00_JPRB, 0.523182E+00_JPRB, 0.507141E+00_JPRB &
  &, 0.491134E+00_JPRB, 0.475270E+00_JPRB, 0.459475E+00_JPRB &
  &, 0.443793E+00_JPRB, 0.428238E+00_JPRB, 0.412843E+00_JPRB, 0.397611E+00_JPRB &
  &, 0.382556E+00_JPRB, 0.367705E+00_JPRB, 0.353074E+00_JPRB &
  &, 0.338669E+00_JPRB, 0.324510E+00_JPRB, 0.310601E+00_JPRB, 0.296975E+00_JPRB &
  &, 0.283636E+00_JPRB, 0.270591E+00_JPRB, 0.257844E+00_JPRB &
  &, 0.245423E+00_JPRB, 0.233330E+00_JPRB, 0.221567E+00_JPRB, 0.210159E+00_JPRB &
  &, 0.199089E+00_JPRB, 0.188365E+00_JPRB, 0.178011E+00_JPRB &
  &, 0.168015E+00_JPRB, 0.158382E+00_JPRB, 0.149096E+00_JPRB, 0.140187E+00_JPRB &
  &, 0.131654E+00_JPRB, 0.123456E+00_JPRB, 0.115635E+00_JPRB &
  &, 0.108146E+00_JPRB, 0.101028E+00_JPRB, 0.942465E-01_JPRB, 0.878016E-01_JPRB &
  &, 0.816706E-01_JPRB, 0.758877E-01_JPRB, 0.704059E-01_JPRB &
  &, 0.652355E-01_JPRB, 0.603431E-01_JPRB, 0.557568E-01_JPRB, 0.514383E-01_JPRB &
  &, 0.473903E-01_JPRB, 0.436147E-01_JPRB, 0.400643E-01_JPRB &
  &, 0.367600E-01_JPRB, 0.336737E-01_JPRB, 0.307991E-01_JPRB, 0.281286E-01_JPRB &
  &, 0.256793E-01_JPRB, 0.233885E-01_JPRB, 0.212694E-01_JPRB &
  &, 0.193082E-01_JPRB, 0.175172E-01_JPRB, 0.158517E-01_JPRB, 0.143510E-01_JPRB &
  &, 0.129670E-01_JPRB, 0.116780E-01_JPRB, 0.105224E-01_JPRB &
  &, 0.944616E-02_JPRB, 0.848759E-02_JPRB, 0.762177E-02_JPRB, 0.682166E-02_JPRB &
  &, 0.609199E-02_JPRB, 0.543760E-02_JPRB, 0.482825E-02_JPRB &
  &, 0.430296E-02_JPRB, 0.383049E-02_JPRB, 0.337723E-02_JPRB, 0.302003E-02_JPRB &
  &, 0.264954E-02_JPRB, 0.234334E-02_JPRB, 0.206555E-02_JPRB &
  &, 0.181794E-02_JPRB, 0.160234E-02_JPRB, 0.142059E-02_JPRB, 0.123242E-02_JPRB &
  &, 0.108057E-02_JPRB, 0.923489E-03_JPRB, 0.805275E-03_JPRB &
  &, 0.727926E-03_JPRB, 0.602342E-03_JPRB, 0.518916E-03_JPRB, 0.479714E-03_JPRB &
  &, 0.391470E-03_JPRB, 0.348814E-03_JPRB, 0.304757E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 350, :) = (/ &
  &  0.958536E+00_JPRB, 0.947337E+00_JPRB, 0.935820E+00_JPRB, 0.923995E+00_JPRB &
  &, 0.911869E+00_JPRB, 0.899450E+00_JPRB, 0.886747E+00_JPRB &
  &, 0.873767E+00_JPRB, 0.860522E+00_JPRB, 0.847021E+00_JPRB, 0.833273E+00_JPRB &
  &, 0.819287E+00_JPRB, 0.805076E+00_JPRB, 0.790648E+00_JPRB &
  &, 0.776017E+00_JPRB, 0.761191E+00_JPRB, 0.746184E+00_JPRB, 0.731009E+00_JPRB &
  &, 0.715677E+00_JPRB, 0.700202E+00_JPRB, 0.684596E+00_JPRB &
  &, 0.668876E+00_JPRB, 0.653057E+00_JPRB, 0.637148E+00_JPRB, 0.621167E+00_JPRB &
  &, 0.605134E+00_JPRB, 0.589056E+00_JPRB, 0.572956E+00_JPRB &
  &, 0.556849E+00_JPRB, 0.540752E+00_JPRB, 0.524681E+00_JPRB, 0.508653E+00_JPRB &
  &, 0.492687E+00_JPRB, 0.476801E+00_JPRB, 0.461008E+00_JPRB &
  &, 0.445328E+00_JPRB, 0.429773E+00_JPRB, 0.414378E+00_JPRB, 0.399135E+00_JPRB &
  &, 0.384088E+00_JPRB, 0.369223E+00_JPRB, 0.354575E+00_JPRB &
  &, 0.340164E+00_JPRB, 0.325985E+00_JPRB, 0.312067E+00_JPRB, 0.298429E+00_JPRB &
  &, 0.285066E+00_JPRB, 0.271993E+00_JPRB, 0.259229E+00_JPRB &
  &, 0.246776E+00_JPRB, 0.234663E+00_JPRB, 0.222876E+00_JPRB, 0.211429E+00_JPRB &
  &, 0.200332E+00_JPRB, 0.189579E+00_JPRB, 0.179192E+00_JPRB &
  &, 0.169162E+00_JPRB, 0.159492E+00_JPRB, 0.150183E+00_JPRB, 0.141233E+00_JPRB &
  &, 0.132656E+00_JPRB, 0.124428E+00_JPRB, 0.116558E+00_JPRB &
  &, 0.109053E+00_JPRB, 0.101881E+00_JPRB, 0.950617E-01_JPRB, 0.885959E-01_JPRB &
  &, 0.824425E-01_JPRB, 0.765954E-01_JPRB, 0.710874E-01_JPRB &
  &, 0.658893E-01_JPRB, 0.609676E-01_JPRB, 0.563503E-01_JPRB, 0.519992E-01_JPRB &
  &, 0.479170E-01_JPRB, 0.441054E-01_JPRB, 0.405411E-01_JPRB &
  &, 0.371978E-01_JPRB, 0.340954E-01_JPRB, 0.311786E-01_JPRB, 0.284898E-01_JPRB &
  &, 0.259949E-01_JPRB, 0.236834E-01_JPRB, 0.215700E-01_JPRB &
  &, 0.195866E-01_JPRB, 0.177726E-01_JPRB, 0.160830E-01_JPRB, 0.145571E-01_JPRB &
  &, 0.131470E-01_JPRB, 0.118612E-01_JPRB, 0.106779E-01_JPRB &
  &, 0.960448E-02_JPRB, 0.861653E-02_JPRB, 0.775301E-02_JPRB, 0.692184E-02_JPRB &
  &, 0.619393E-02_JPRB, 0.554131E-02_JPRB, 0.493376E-02_JPRB &
  &, 0.437451E-02_JPRB, 0.390326E-02_JPRB, 0.345124E-02_JPRB, 0.305766E-02_JPRB &
  &, 0.272605E-02_JPRB, 0.238223E-02_JPRB, 0.210508E-02_JPRB &
  &, 0.185812E-02_JPRB, 0.164317E-02_JPRB, 0.142059E-02_JPRB, 0.127457E-02_JPRB &
  &, 0.108057E-02_JPRB, 0.966988E-03_JPRB, 0.849457E-03_JPRB &
  &, 0.727926E-03_JPRB, 0.647907E-03_JPRB, 0.565181E-03_JPRB, 0.479714E-03_JPRB &
  &, 0.391470E-03_JPRB, 0.348814E-03_JPRB, 0.304757E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART50',1,ZHOOK_HANDLE)
END SUBROUTINE PART50

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART51

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART51',0,ZHOOK_HANDLE)

XCW( 351, :) = (/ &
  &  0.958798E+00_JPRB, 0.947663E+00_JPRB, 0.936208E+00_JPRB, 0.924445E+00_JPRB &
  &, 0.912378E+00_JPRB, 0.900017E+00_JPRB, 0.887371E+00_JPRB &
  &, 0.874448E+00_JPRB, 0.861258E+00_JPRB, 0.847810E+00_JPRB, 0.834113E+00_JPRB &
  &, 0.820178E+00_JPRB, 0.806015E+00_JPRB, 0.791634E+00_JPRB &
  &, 0.777047E+00_JPRB, 0.762265E+00_JPRB, 0.747302E+00_JPRB, 0.732166E+00_JPRB &
  &, 0.716874E+00_JPRB, 0.701433E+00_JPRB, 0.685864E+00_JPRB &
  &, 0.670176E+00_JPRB, 0.654386E+00_JPRB, 0.638508E+00_JPRB, 0.622552E+00_JPRB &
  &, 0.606545E+00_JPRB, 0.590490E+00_JPRB, 0.574410E+00_JPRB &
  &, 0.558324E+00_JPRB, 0.542242E+00_JPRB, 0.526184E+00_JPRB, 0.510168E+00_JPRB &
  &, 0.494211E+00_JPRB, 0.478331E+00_JPRB, 0.462546E+00_JPRB &
  &, 0.446863E+00_JPRB, 0.431318E+00_JPRB, 0.415913E+00_JPRB, 0.400679E+00_JPRB &
  &, 0.385609E+00_JPRB, 0.370751E+00_JPRB, 0.356088E+00_JPRB &
  &, 0.341659E+00_JPRB, 0.327472E+00_JPRB, 0.313533E+00_JPRB, 0.299872E+00_JPRB &
  &, 0.286495E+00_JPRB, 0.273396E+00_JPRB, 0.260614E+00_JPRB &
  &, 0.248143E+00_JPRB, 0.235995E+00_JPRB, 0.224186E+00_JPRB, 0.212699E+00_JPRB &
  &, 0.201574E+00_JPRB, 0.190792E+00_JPRB, 0.180373E+00_JPRB &
  &, 0.170309E+00_JPRB, 0.160602E+00_JPRB, 0.151270E+00_JPRB, 0.142279E+00_JPRB &
  &, 0.133674E+00_JPRB, 0.125400E+00_JPRB, 0.117499E+00_JPRB &
  &, 0.109960E+00_JPRB, 0.102753E+00_JPRB, 0.958958E-01_JPRB, 0.893901E-01_JPRB &
  &, 0.831946E-01_JPRB, 0.773232E-01_JPRB, 0.717895E-01_JPRB &
  &, 0.665430E-01_JPRB, 0.615920E-01_JPRB, 0.569439E-01_JPRB, 0.525602E-01_JPRB &
  &, 0.484437E-01_JPRB, 0.445961E-01_JPRB, 0.409941E-01_JPRB &
  &, 0.376356E-01_JPRB, 0.344923E-01_JPRB, 0.315834E-01_JPRB, 0.288509E-01_JPRB &
  &, 0.263368E-01_JPRB, 0.240051E-01_JPRB, 0.218433E-01_JPRB &
  &, 0.198651E-01_JPRB, 0.180280E-01_JPRB, 0.163432E-01_JPRB, 0.147927E-01_JPRB &
  &, 0.133569E-01_JPRB, 0.120445E-01_JPRB, 0.108645E-01_JPRB &
  &, 0.976281E-02_JPRB, 0.877770E-02_JPRB, 0.788425E-02_JPRB, 0.705540E-02_JPRB &
  &, 0.629586E-02_JPRB, 0.564502E-02_JPRB, 0.500410E-02_JPRB &
  &, 0.448184E-02_JPRB, 0.397604E-02_JPRB, 0.352524E-02_JPRB, 0.313291E-02_JPRB &
  &, 0.276431E-02_JPRB, 0.246001E-02_JPRB, 0.214461E-02_JPRB &
  &, 0.189830E-02_JPRB, 0.168400E-02_JPRB, 0.146207E-02_JPRB, 0.127457E-02_JPRB &
  &, 0.112340E-02_JPRB, 0.966988E-03_JPRB, 0.849457E-03_JPRB &
  &, 0.727926E-03_JPRB, 0.647907E-03_JPRB, 0.565181E-03_JPRB, 0.479714E-03_JPRB &
  &, 0.391470E-03_JPRB, 0.348814E-03_JPRB, 0.304757E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.164003E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.643624E-04_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 352, :) = (/ &
  &  0.959060E+00_JPRB, 0.947989E+00_JPRB, 0.936595E+00_JPRB, 0.924894E+00_JPRB &
  &, 0.912887E+00_JPRB, 0.900584E+00_JPRB, 0.887996E+00_JPRB &
  &, 0.875128E+00_JPRB, 0.861993E+00_JPRB, 0.848597E+00_JPRB, 0.834953E+00_JPRB &
  &, 0.821067E+00_JPRB, 0.806952E+00_JPRB, 0.792619E+00_JPRB &
  &, 0.778078E+00_JPRB, 0.763340E+00_JPRB, 0.748418E+00_JPRB, 0.733323E+00_JPRB &
  &, 0.718069E+00_JPRB, 0.702667E+00_JPRB, 0.687132E+00_JPRB &
  &, 0.671476E+00_JPRB, 0.655716E+00_JPRB, 0.639865E+00_JPRB, 0.623941E+00_JPRB &
  &, 0.607956E+00_JPRB, 0.591924E+00_JPRB, 0.575864E+00_JPRB &
  &, 0.559798E+00_JPRB, 0.543733E+00_JPRB, 0.527687E+00_JPRB, 0.511684E+00_JPRB &
  &, 0.495738E+00_JPRB, 0.479862E+00_JPRB, 0.464083E+00_JPRB &
  &, 0.448407E+00_JPRB, 0.432863E+00_JPRB, 0.417458E+00_JPRB, 0.402213E+00_JPRB &
  &, 0.387141E+00_JPRB, 0.372268E+00_JPRB, 0.357600E+00_JPRB &
  &, 0.343166E+00_JPRB, 0.328959E+00_JPRB, 0.315011E+00_JPRB, 0.301327E+00_JPRB &
  &, 0.287925E+00_JPRB, 0.274810E+00_JPRB, 0.262000E+00_JPRB &
  &, 0.249509E+00_JPRB, 0.237341E+00_JPRB, 0.225495E+00_JPRB, 0.213984E+00_JPRB &
  &, 0.202832E+00_JPRB, 0.192020E+00_JPRB, 0.181569E+00_JPRB &
  &, 0.171471E+00_JPRB, 0.161728E+00_JPRB, 0.152357E+00_JPRB, 0.143341E+00_JPRB &
  &, 0.134693E+00_JPRB, 0.126390E+00_JPRB, 0.118457E+00_JPRB &
  &, 0.110868E+00_JPRB, 0.103624E+00_JPRB, 0.967488E-01_JPRB, 0.901843E-01_JPRB &
  &, 0.839664E-01_JPRB, 0.780713E-01_JPRB, 0.724709E-01_JPRB &
  &, 0.671967E-01_JPRB, 0.622164E-01_JPRB, 0.575374E-01_JPRB, 0.531211E-01_JPRB &
  &, 0.489933E-01_JPRB, 0.451102E-01_JPRB, 0.414710E-01_JPRB &
  &, 0.380734E-01_JPRB, 0.349141E-01_JPRB, 0.319629E-01_JPRB, 0.292379E-01_JPRB &
  &, 0.266787E-01_JPRB, 0.243268E-01_JPRB, 0.221439E-01_JPRB &
  &, 0.201436E-01_JPRB, 0.182834E-01_JPRB, 0.165744E-01_JPRB, 0.149989E-01_JPRB &
  &, 0.135669E-01_JPRB, 0.122278E-01_JPRB, 0.110200E-01_JPRB &
  &, 0.992113E-02_JPRB, 0.890663E-02_JPRB, 0.801549E-02_JPRB, 0.715557E-02_JPRB &
  &, 0.643177E-02_JPRB, 0.571416E-02_JPRB, 0.510961E-02_JPRB &
  &, 0.455339E-02_JPRB, 0.404881E-02_JPRB, 0.359925E-02_JPRB, 0.317054E-02_JPRB &
  &, 0.284081E-02_JPRB, 0.249890E-02_JPRB, 0.218414E-02_JPRB &
  &, 0.193847E-02_JPRB, 0.172483E-02_JPRB, 0.150356E-02_JPRB, 0.131672E-02_JPRB &
  &, 0.116622E-02_JPRB, 0.101049E-02_JPRB, 0.893639E-03_JPRB &
  &, 0.772796E-03_JPRB, 0.647907E-03_JPRB, 0.565181E-03_JPRB, 0.479714E-03_JPRB &
  &, 0.439153E-03_JPRB, 0.348814E-03_JPRB, 0.304757E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 353, :) = (/ &
  &  0.959323E+00_JPRB, 0.948314E+00_JPRB, 0.936983E+00_JPRB, 0.925342E+00_JPRB &
  &, 0.913394E+00_JPRB, 0.901151E+00_JPRB, 0.888620E+00_JPRB &
  &, 0.875809E+00_JPRB, 0.862727E+00_JPRB, 0.849385E+00_JPRB, 0.835792E+00_JPRB &
  &, 0.821956E+00_JPRB, 0.807891E+00_JPRB, 0.793605E+00_JPRB &
  &, 0.779110E+00_JPRB, 0.764416E+00_JPRB, 0.749536E+00_JPRB, 0.734480E+00_JPRB &
  &, 0.719265E+00_JPRB, 0.703898E+00_JPRB, 0.688400E+00_JPRB &
  &, 0.672779E+00_JPRB, 0.657049E+00_JPRB, 0.641229E+00_JPRB, 0.625327E+00_JPRB &
  &, 0.609367E+00_JPRB, 0.593359E+00_JPRB, 0.577322E+00_JPRB &
  &, 0.561272E+00_JPRB, 0.545223E+00_JPRB, 0.529194E+00_JPRB, 0.513203E+00_JPRB &
  &, 0.497266E+00_JPRB, 0.481397E+00_JPRB, 0.465621E+00_JPRB &
  &, 0.449951E+00_JPRB, 0.434408E+00_JPRB, 0.419003E+00_JPRB, 0.403747E+00_JPRB &
  &, 0.388683E+00_JPRB, 0.373796E+00_JPRB, 0.359124E+00_JPRB &
  &, 0.344672E+00_JPRB, 0.330446E+00_JPRB, 0.316489E+00_JPRB, 0.302782E+00_JPRB &
  &, 0.289367E+00_JPRB, 0.276225E+00_JPRB, 0.263398E+00_JPRB &
  &, 0.250876E+00_JPRB, 0.238673E+00_JPRB, 0.226805E+00_JPRB, 0.215282E+00_JPRB &
  &, 0.204089E+00_JPRB, 0.193247E+00_JPRB, 0.182765E+00_JPRB &
  &, 0.172633E+00_JPRB, 0.162854E+00_JPRB, 0.153444E+00_JPRB, 0.144403E+00_JPRB &
  &, 0.135711E+00_JPRB, 0.127379E+00_JPRB, 0.119398E+00_JPRB &
  &, 0.111775E+00_JPRB, 0.104515E+00_JPRB, 0.975830E-01_JPRB, 0.909979E-01_JPRB &
  &, 0.847383E-01_JPRB, 0.787991E-01_JPRB, 0.731730E-01_JPRB &
  &, 0.678716E-01_JPRB, 0.628624E-01_JPRB, 0.581309E-01_JPRB, 0.537045E-01_JPRB &
  &, 0.495200E-01_JPRB, 0.456243E-01_JPRB, 0.419478E-01_JPRB &
  &, 0.385355E-01_JPRB, 0.353358E-01_JPRB, 0.323677E-01_JPRB, 0.295990E-01_JPRB &
  &, 0.270470E-01_JPRB, 0.246485E-01_JPRB, 0.224444E-01_JPRB &
  &, 0.204221E-01_JPRB, 0.185387E-01_JPRB, 0.168057E-01_JPRB, 0.152344E-01_JPRB &
  &, 0.137768E-01_JPRB, 0.124416E-01_JPRB, 0.112066E-01_JPRB &
  &, 0.100795E-01_JPRB, 0.906780E-02_JPRB, 0.814672E-02_JPRB, 0.728913E-02_JPRB &
  &, 0.653370E-02_JPRB, 0.581788E-02_JPRB, 0.521512E-02_JPRB &
  &, 0.462494E-02_JPRB, 0.412158E-02_JPRB, 0.367325E-02_JPRB, 0.324579E-02_JPRB &
  &, 0.287907E-02_JPRB, 0.253779E-02_JPRB, 0.226320E-02_JPRB &
  &, 0.197865E-02_JPRB, 0.172483E-02_JPRB, 0.154505E-02_JPRB, 0.135888E-02_JPRB &
  &, 0.116622E-02_JPRB, 0.101049E-02_JPRB, 0.893639E-03_JPRB &
  &, 0.772796E-03_JPRB, 0.693472E-03_JPRB, 0.565181E-03_JPRB, 0.526686E-03_JPRB &
  &, 0.439153E-03_JPRB, 0.397216E-03_JPRB, 0.304757E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.212370E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.115673E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 354, :) = (/ &
  &  0.959586E+00_JPRB, 0.948639E+00_JPRB, 0.937370E+00_JPRB, 0.925790E+00_JPRB &
  &, 0.913902E+00_JPRB, 0.901717E+00_JPRB, 0.889243E+00_JPRB &
  &, 0.876488E+00_JPRB, 0.863462E+00_JPRB, 0.850173E+00_JPRB, 0.836631E+00_JPRB &
  &, 0.822846E+00_JPRB, 0.808829E+00_JPRB, 0.794590E+00_JPRB &
  &, 0.780141E+00_JPRB, 0.765490E+00_JPRB, 0.750652E+00_JPRB, 0.735639E+00_JPRB &
  &, 0.720461E+00_JPRB, 0.705132E+00_JPRB, 0.689668E+00_JPRB &
  &, 0.674078E+00_JPRB, 0.658382E+00_JPRB, 0.642590E+00_JPRB, 0.626716E+00_JPRB &
  &, 0.610779E+00_JPRB, 0.594796E+00_JPRB, 0.578780E+00_JPRB &
  &, 0.562746E+00_JPRB, 0.546714E+00_JPRB, 0.530701E+00_JPRB, 0.514719E+00_JPRB &
  &, 0.498794E+00_JPRB, 0.482937E+00_JPRB, 0.467163E+00_JPRB &
  &, 0.451495E+00_JPRB, 0.435953E+00_JPRB, 0.420548E+00_JPRB, 0.405290E+00_JPRB &
  &, 0.390214E+00_JPRB, 0.375324E+00_JPRB, 0.360636E+00_JPRB &
  &, 0.346178E+00_JPRB, 0.331945E+00_JPRB, 0.317966E+00_JPRB, 0.304248E+00_JPRB &
  &, 0.290809E+00_JPRB, 0.277652E+00_JPRB, 0.264796E+00_JPRB &
  &, 0.252255E+00_JPRB, 0.240033E+00_JPRB, 0.228128E+00_JPRB, 0.216567E+00_JPRB &
  &, 0.205346E+00_JPRB, 0.194475E+00_JPRB, 0.183962E+00_JPRB &
  &, 0.173796E+00_JPRB, 0.163996E+00_JPRB, 0.154547E+00_JPRB, 0.145465E+00_JPRB &
  &, 0.136730E+00_JPRB, 0.128369E+00_JPRB, 0.120357E+00_JPRB &
  &, 0.112701E+00_JPRB, 0.105405E+00_JPRB, 0.984360E-01_JPRB, 0.918115E-01_JPRB &
  &, 0.855102E-01_JPRB, 0.795472E-01_JPRB, 0.738958E-01_JPRB &
  &, 0.685464E-01_JPRB, 0.634868E-01_JPRB, 0.587464E-01_JPRB, 0.542655E-01_JPRB &
  &, 0.500696E-01_JPRB, 0.461150E-01_JPRB, 0.424247E-01_JPRB &
  &, 0.389976E-01_JPRB, 0.357575E-01_JPRB, 0.327724E-01_JPRB, 0.299860E-01_JPRB &
  &, 0.273889E-01_JPRB, 0.249703E-01_JPRB, 0.227450E-01_JPRB &
  &, 0.207005E-01_JPRB, 0.187941E-01_JPRB, 0.170659E-01_JPRB, 0.154406E-01_JPRB &
  &, 0.139868E-01_JPRB, 0.126248E-01_JPRB, 0.113932E-01_JPRB &
  &, 0.102378E-01_JPRB, 0.922898E-02_JPRB, 0.827796E-02_JPRB, 0.742269E-02_JPRB &
  &, 0.663564E-02_JPRB, 0.595616E-02_JPRB, 0.528546E-02_JPRB &
  &, 0.473226E-02_JPRB, 0.419435E-02_JPRB, 0.374726E-02_JPRB, 0.332104E-02_JPRB &
  &, 0.295558E-02_JPRB, 0.261557E-02_JPRB, 0.230273E-02_JPRB &
  &, 0.201882E-02_JPRB, 0.176565E-02_JPRB, 0.158654E-02_JPRB, 0.135888E-02_JPRB &
  &, 0.120904E-02_JPRB, 0.105399E-02_JPRB, 0.937821E-03_JPRB &
  &, 0.817667E-03_JPRB, 0.693472E-03_JPRB, 0.611447E-03_JPRB, 0.526686E-03_JPRB &
  &, 0.439153E-03_JPRB, 0.397216E-03_JPRB, 0.353883E-03_JPRB &
  &, 0.259281E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 355, :) = (/ &
  &  0.959845E+00_JPRB, 0.948965E+00_JPRB, 0.937757E+00_JPRB, 0.926238E+00_JPRB &
  &, 0.914410E+00_JPRB, 0.902284E+00_JPRB, 0.889866E+00_JPRB &
  &, 0.877167E+00_JPRB, 0.864195E+00_JPRB, 0.850960E+00_JPRB, 0.837470E+00_JPRB &
  &, 0.823735E+00_JPRB, 0.809768E+00_JPRB, 0.795575E+00_JPRB &
  &, 0.781171E+00_JPRB, 0.766565E+00_JPRB, 0.751769E+00_JPRB, 0.736796E+00_JPRB &
  &, 0.721658E+00_JPRB, 0.706366E+00_JPRB, 0.690936E+00_JPRB &
  &, 0.675381E+00_JPRB, 0.659714E+00_JPRB, 0.643950E+00_JPRB, 0.628105E+00_JPRB &
  &, 0.612194E+00_JPRB, 0.596234E+00_JPRB, 0.580238E+00_JPRB &
  &, 0.564224E+00_JPRB, 0.548208E+00_JPRB, 0.532209E+00_JPRB, 0.516243E+00_JPRB &
  &, 0.500326E+00_JPRB, 0.484472E+00_JPRB, 0.468710E+00_JPRB &
  &, 0.453039E+00_JPRB, 0.437498E+00_JPRB, 0.422093E+00_JPRB, 0.406834E+00_JPRB &
  &, 0.391756E+00_JPRB, 0.376863E+00_JPRB, 0.362159E+00_JPRB &
  &, 0.347684E+00_JPRB, 0.333443E+00_JPRB, 0.319444E+00_JPRB, 0.305715E+00_JPRB &
  &, 0.292250E+00_JPRB, 0.279080E+00_JPRB, 0.266194E+00_JPRB &
  &, 0.253635E+00_JPRB, 0.241379E+00_JPRB, 0.229451E+00_JPRB, 0.217865E+00_JPRB &
  &, 0.206618E+00_JPRB, 0.195718E+00_JPRB, 0.185158E+00_JPRB &
  &, 0.174958E+00_JPRB, 0.165121E+00_JPRB, 0.155650E+00_JPRB, 0.146527E+00_JPRB &
  &, 0.137765E+00_JPRB, 0.129376E+00_JPRB, 0.121315E+00_JPRB &
  &, 0.113626E+00_JPRB, 0.106277E+00_JPRB, 0.992891E-01_JPRB, 0.926251E-01_JPRB &
  &, 0.863019E-01_JPRB, 0.802952E-01_JPRB, 0.745979E-01_JPRB &
  &, 0.692212E-01_JPRB, 0.641328E-01_JPRB, 0.593619E-01_JPRB, 0.548489E-01_JPRB &
  &, 0.506192E-01_JPRB, 0.466525E-01_JPRB, 0.429253E-01_JPRB &
  &, 0.394354E-01_JPRB, 0.362041E-01_JPRB, 0.331772E-01_JPRB, 0.303471E-01_JPRB &
  &, 0.277308E-01_JPRB, 0.253188E-01_JPRB, 0.230729E-01_JPRB &
  &, 0.209790E-01_JPRB, 0.190779E-01_JPRB, 0.172971E-01_JPRB, 0.156762E-01_JPRB &
  &, 0.141967E-01_JPRB, 0.128081E-01_JPRB, 0.115487E-01_JPRB &
  &, 0.104278E-01_JPRB, 0.935791E-02_JPRB, 0.840920E-02_JPRB, 0.755626E-02_JPRB &
  &, 0.677155E-02_JPRB, 0.605987E-02_JPRB, 0.539097E-02_JPRB &
  &, 0.480381E-02_JPRB, 0.430351E-02_JPRB, 0.382126E-02_JPRB, 0.339629E-02_JPRB &
  &, 0.299383E-02_JPRB, 0.265445E-02_JPRB, 0.234226E-02_JPRB &
  &, 0.205900E-02_JPRB, 0.180648E-02_JPRB, 0.158654E-02_JPRB, 0.140103E-02_JPRB &
  &, 0.125187E-02_JPRB, 0.109749E-02_JPRB, 0.937821E-03_JPRB &
  &, 0.817667E-03_JPRB, 0.693472E-03_JPRB, 0.611447E-03_JPRB, 0.526686E-03_JPRB &
  &, 0.439153E-03_JPRB, 0.397216E-03_JPRB, 0.353883E-03_JPRB &
  &, 0.309138E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 356, :) = (/ &
  &  0.960109E+00_JPRB, 0.949290E+00_JPRB, 0.938145E+00_JPRB, 0.926686E+00_JPRB &
  &, 0.914917E+00_JPRB, 0.902849E+00_JPRB, 0.890489E+00_JPRB &
  &, 0.877846E+00_JPRB, 0.864928E+00_JPRB, 0.851746E+00_JPRB, 0.838309E+00_JPRB &
  &, 0.824624E+00_JPRB, 0.810705E+00_JPRB, 0.796560E+00_JPRB &
  &, 0.782202E+00_JPRB, 0.767640E+00_JPRB, 0.752886E+00_JPRB, 0.737953E+00_JPRB &
  &, 0.722853E+00_JPRB, 0.707600E+00_JPRB, 0.692203E+00_JPRB &
  &, 0.676681E+00_JPRB, 0.661047E+00_JPRB, 0.645314E+00_JPRB, 0.629494E+00_JPRB &
  &, 0.613609E+00_JPRB, 0.597672E+00_JPRB, 0.581695E+00_JPRB &
  &, 0.565702E+00_JPRB, 0.549703E+00_JPRB, 0.533720E+00_JPRB, 0.517762E+00_JPRB &
  &, 0.501858E+00_JPRB, 0.486016E+00_JPRB, 0.470257E+00_JPRB &
  &, 0.454592E+00_JPRB, 0.439053E+00_JPRB, 0.423648E+00_JPRB, 0.408388E+00_JPRB &
  &, 0.393298E+00_JPRB, 0.378391E+00_JPRB, 0.363693E+00_JPRB &
  &, 0.349201E+00_JPRB, 0.334942E+00_JPRB, 0.320933E+00_JPRB, 0.307182E+00_JPRB &
  &, 0.293705E+00_JPRB, 0.280507E+00_JPRB, 0.267605E+00_JPRB &
  &, 0.255015E+00_JPRB, 0.242738E+00_JPRB, 0.230788E+00_JPRB, 0.219164E+00_JPRB &
  &, 0.207890E+00_JPRB, 0.196961E+00_JPRB, 0.186369E+00_JPRB &
  &, 0.176136E+00_JPRB, 0.166263E+00_JPRB, 0.156754E+00_JPRB, 0.147606E+00_JPRB &
  &, 0.138801E+00_JPRB, 0.130365E+00_JPRB, 0.122291E+00_JPRB &
  &, 0.114552E+00_JPRB, 0.107186E+00_JPRB, 0.100142E+00_JPRB, 0.934387E-01_JPRB &
  &, 0.870737E-01_JPRB, 0.810433E-01_JPRB, 0.753206E-01_JPRB &
  &, 0.698960E-01_JPRB, 0.648003E-01_JPRB, 0.599774E-01_JPRB, 0.554323E-01_JPRB &
  &, 0.511688E-01_JPRB, 0.471666E-01_JPRB, 0.434260E-01_JPRB &
  &, 0.398975E-01_JPRB, 0.366258E-01_JPRB, 0.335820E-01_JPRB, 0.307341E-01_JPRB &
  &, 0.280990E-01_JPRB, 0.256405E-01_JPRB, 0.233735E-01_JPRB &
  &, 0.212853E-01_JPRB, 0.193332E-01_JPRB, 0.175573E-01_JPRB, 0.159117E-01_JPRB &
  &, 0.144067E-01_JPRB, 0.130219E-01_JPRB, 0.117353E-01_JPRB &
  &, 0.105861E-01_JPRB, 0.951908E-02_JPRB, 0.854043E-02_JPRB, 0.768982E-02_JPRB &
  &, 0.687348E-02_JPRB, 0.616358E-02_JPRB, 0.549647E-02_JPRB &
  &, 0.491113E-02_JPRB, 0.437628E-02_JPRB, 0.389527E-02_JPRB, 0.343391E-02_JPRB &
  &, 0.307034E-02_JPRB, 0.269334E-02_JPRB, 0.238179E-02_JPRB &
  &, 0.209918E-02_JPRB, 0.184731E-02_JPRB, 0.162802E-02_JPRB, 0.144318E-02_JPRB &
  &, 0.125187E-02_JPRB, 0.109749E-02_JPRB, 0.982002E-03_JPRB &
  &, 0.817667E-03_JPRB, 0.739036E-03_JPRB, 0.611447E-03_JPRB, 0.526686E-03_JPRB &
  &, 0.486837E-03_JPRB, 0.397216E-03_JPRB, 0.353883E-03_JPRB &
  &, 0.309138E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 357, :) = (/ &
  &  0.960371E+00_JPRB, 0.949613E+00_JPRB, 0.938531E+00_JPRB, 0.927133E+00_JPRB &
  &, 0.915425E+00_JPRB, 0.903414E+00_JPRB, 0.891112E+00_JPRB &
  &, 0.878525E+00_JPRB, 0.865661E+00_JPRB, 0.852533E+00_JPRB, 0.839147E+00_JPRB &
  &, 0.825513E+00_JPRB, 0.811643E+00_JPRB, 0.797545E+00_JPRB &
  &, 0.783233E+00_JPRB, 0.768714E+00_JPRB, 0.754003E+00_JPRB, 0.739111E+00_JPRB &
  &, 0.724050E+00_JPRB, 0.708831E+00_JPRB, 0.693471E+00_JPRB &
  &, 0.677984E+00_JPRB, 0.662380E+00_JPRB, 0.646674E+00_JPRB, 0.630886E+00_JPRB &
  &, 0.615027E+00_JPRB, 0.599110E+00_JPRB, 0.583157E+00_JPRB &
  &, 0.567180E+00_JPRB, 0.551202E+00_JPRB, 0.535231E+00_JPRB, 0.519286E+00_JPRB &
  &, 0.503389E+00_JPRB, 0.487556E+00_JPRB, 0.471803E+00_JPRB &
  &, 0.456146E+00_JPRB, 0.440607E+00_JPRB, 0.425193E+00_JPRB, 0.409932E+00_JPRB &
  &, 0.394840E+00_JPRB, 0.379929E+00_JPRB, 0.365217E+00_JPRB &
  &, 0.350718E+00_JPRB, 0.336452E+00_JPRB, 0.322422E+00_JPRB, 0.308660E+00_JPRB &
  &, 0.295159E+00_JPRB, 0.281934E+00_JPRB, 0.269016E+00_JPRB &
  &, 0.256394E+00_JPRB, 0.244097E+00_JPRB, 0.232125E+00_JPRB, 0.220476E+00_JPRB &
  &, 0.209161E+00_JPRB, 0.198203E+00_JPRB, 0.187581E+00_JPRB &
  &, 0.177329E+00_JPRB, 0.167421E+00_JPRB, 0.157873E+00_JPRB, 0.148685E+00_JPRB &
  &, 0.139853E+00_JPRB, 0.131372E+00_JPRB, 0.123268E+00_JPRB &
  &, 0.115495E+00_JPRB, 0.108076E+00_JPRB, 0.101014E+00_JPRB, 0.942717E-01_JPRB &
  &, 0.878654E-01_JPRB, 0.817913E-01_JPRB, 0.760434E-01_JPRB &
  &, 0.705919E-01_JPRB, 0.654463E-01_JPRB, 0.605929E-01_JPRB, 0.560156E-01_JPRB &
  &, 0.517184E-01_JPRB, 0.476807E-01_JPRB, 0.439028E-01_JPRB &
  &, 0.403840E-01_JPRB, 0.370723E-01_JPRB, 0.339868E-01_JPRB, 0.311210E-01_JPRB &
  &, 0.284672E-01_JPRB, 0.259890E-01_JPRB, 0.237014E-01_JPRB &
  &, 0.215638E-01_JPRB, 0.196170E-01_JPRB, 0.178175E-01_JPRB, 0.161473E-01_JPRB &
  &, 0.146166E-01_JPRB, 0.132052E-01_JPRB, 0.119219E-01_JPRB &
  &, 0.107444E-01_JPRB, 0.968025E-02_JPRB, 0.870448E-02_JPRB, 0.782338E-02_JPRB &
  &, 0.700939E-02_JPRB, 0.626729E-02_JPRB, 0.560198E-02_JPRB &
  &, 0.498268E-02_JPRB, 0.444905E-02_JPRB, 0.396927E-02_JPRB, 0.350916E-02_JPRB &
  &, 0.310859E-02_JPRB, 0.277112E-02_JPRB, 0.246085E-02_JPRB &
  &, 0.213935E-02_JPRB, 0.188814E-02_JPRB, 0.166951E-02_JPRB, 0.148533E-02_JPRB &
  &, 0.129469E-02_JPRB, 0.114099E-02_JPRB, 0.982002E-03_JPRB &
  &, 0.862537E-03_JPRB, 0.739036E-03_JPRB, 0.657712E-03_JPRB, 0.573657E-03_JPRB &
  &, 0.486837E-03_JPRB, 0.397216E-03_JPRB, 0.353883E-03_JPRB &
  &, 0.309138E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.166248E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.651343E-04_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART51',1,ZHOOK_HANDLE)
END SUBROUTINE PART51

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART52

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART52',0,ZHOOK_HANDLE)

XCW( 358, :) = (/ &
  &  0.960632E+00_JPRB, 0.949939E+00_JPRB, 0.938917E+00_JPRB, 0.927580E+00_JPRB &
  &, 0.915931E+00_JPRB, 0.903980E+00_JPRB, 0.891734E+00_JPRB &
  &, 0.879203E+00_JPRB, 0.866395E+00_JPRB, 0.853318E+00_JPRB, 0.839984E+00_JPRB &
  &, 0.826401E+00_JPRB, 0.812580E+00_JPRB, 0.798529E+00_JPRB &
  &, 0.784261E+00_JPRB, 0.769788E+00_JPRB, 0.755121E+00_JPRB, 0.740269E+00_JPRB &
  &, 0.725248E+00_JPRB, 0.710065E+00_JPRB, 0.694742E+00_JPRB &
  &, 0.679287E+00_JPRB, 0.663713E+00_JPRB, 0.648038E+00_JPRB, 0.632275E+00_JPRB &
  &, 0.616442E+00_JPRB, 0.600552E+00_JPRB, 0.584619E+00_JPRB &
  &, 0.568662E+00_JPRB, 0.552696E+00_JPRB, 0.536742E+00_JPRB, 0.520814E+00_JPRB &
  &, 0.504926E+00_JPRB, 0.489100E+00_JPRB, 0.473355E+00_JPRB &
  &, 0.457699E+00_JPRB, 0.442162E+00_JPRB, 0.426757E+00_JPRB, 0.411486E+00_JPRB &
  &, 0.396392E+00_JPRB, 0.381478E+00_JPRB, 0.366751E+00_JPRB &
  &, 0.352247E+00_JPRB, 0.337961E+00_JPRB, 0.323923E+00_JPRB, 0.310127E+00_JPRB &
  &, 0.296613E+00_JPRB, 0.283374E+00_JPRB, 0.270427E+00_JPRB &
  &, 0.257787E+00_JPRB, 0.245470E+00_JPRB, 0.233462E+00_JPRB, 0.221789E+00_JPRB &
  &, 0.210447E+00_JPRB, 0.199446E+00_JPRB, 0.188807E+00_JPRB &
  &, 0.178507E+00_JPRB, 0.168578E+00_JPRB, 0.158993E+00_JPRB, 0.149764E+00_JPRB &
  &, 0.140906E+00_JPRB, 0.132396E+00_JPRB, 0.124244E+00_JPRB &
  &, 0.116439E+00_JPRB, 0.108985E+00_JPRB, 0.101867E+00_JPRB, 0.951047E-01_JPRB &
  &, 0.886769E-01_JPRB, 0.825596E-01_JPRB, 0.767661E-01_JPRB &
  &, 0.712878E-01_JPRB, 0.660922E-01_JPRB, 0.612084E-01_JPRB, 0.566215E-01_JPRB &
  &, 0.522909E-01_JPRB, 0.482182E-01_JPRB, 0.444035E-01_JPRB &
  &, 0.408461E-01_JPRB, 0.375189E-01_JPRB, 0.344169E-01_JPRB, 0.315080E-01_JPRB &
  &, 0.288354E-01_JPRB, 0.263376E-01_JPRB, 0.240020E-01_JPRB &
  &, 0.218701E-01_JPRB, 0.199007E-01_JPRB, 0.180487E-01_JPRB, 0.163829E-01_JPRB &
  &, 0.148266E-01_JPRB, 0.134190E-01_JPRB, 0.121086E-01_JPRB &
  &, 0.109344E-01_JPRB, 0.984143E-02_JPRB, 0.883572E-02_JPRB, 0.795694E-02_JPRB &
  &, 0.711132E-02_JPRB, 0.637101E-02_JPRB, 0.570749E-02_JPRB &
  &, 0.509001E-02_JPRB, 0.452182E-02_JPRB, 0.404328E-02_JPRB, 0.358441E-02_JPRB &
  &, 0.318510E-02_JPRB, 0.281001E-02_JPRB, 0.250038E-02_JPRB &
  &, 0.221971E-02_JPRB, 0.192897E-02_JPRB, 0.171100E-02_JPRB, 0.148533E-02_JPRB &
  &, 0.133751E-02_JPRB, 0.114099E-02_JPRB, 0.102618E-02_JPRB &
  &, 0.862537E-03_JPRB, 0.784601E-03_JPRB, 0.657712E-03_JPRB, 0.573657E-03_JPRB &
  &, 0.486837E-03_JPRB, 0.445618E-03_JPRB, 0.353883E-03_JPRB &
  &, 0.309138E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 359, :) = (/ &
  &  0.960892E+00_JPRB, 0.950262E+00_JPRB, 0.939303E+00_JPRB, 0.928027E+00_JPRB &
  &, 0.916437E+00_JPRB, 0.904545E+00_JPRB, 0.892356E+00_JPRB &
  &, 0.879880E+00_JPRB, 0.867127E+00_JPRB, 0.854105E+00_JPRB, 0.840823E+00_JPRB &
  &, 0.827289E+00_JPRB, 0.813517E+00_JPRB, 0.799514E+00_JPRB &
  &, 0.785293E+00_JPRB, 0.770863E+00_JPRB, 0.756237E+00_JPRB, 0.741427E+00_JPRB &
  &, 0.726443E+00_JPRB, 0.711299E+00_JPRB, 0.696010E+00_JPRB &
  &, 0.680590E+00_JPRB, 0.665049E+00_JPRB, 0.649405E+00_JPRB, 0.633668E+00_JPRB &
  &, 0.617861E+00_JPRB, 0.601994E+00_JPRB, 0.586080E+00_JPRB &
  &, 0.570144E+00_JPRB, 0.554199E+00_JPRB, 0.538258E+00_JPRB, 0.522342E+00_JPRB &
  &, 0.506466E+00_JPRB, 0.490648E+00_JPRB, 0.474906E+00_JPRB &
  &, 0.459261E+00_JPRB, 0.443716E+00_JPRB, 0.428312E+00_JPRB, 0.413050E+00_JPRB &
  &, 0.397944E+00_JPRB, 0.383017E+00_JPRB, 0.368285E+00_JPRB &
  &, 0.353764E+00_JPRB, 0.339471E+00_JPRB, 0.325413E+00_JPRB, 0.311617E+00_JPRB &
  &, 0.298079E+00_JPRB, 0.284814E+00_JPRB, 0.271851E+00_JPRB &
  &, 0.259193E+00_JPRB, 0.246829E+00_JPRB, 0.234799E+00_JPRB, 0.223102E+00_JPRB &
  &, 0.211734E+00_JPRB, 0.200704E+00_JPRB, 0.190034E+00_JPRB &
  &, 0.179700E+00_JPRB, 0.169736E+00_JPRB, 0.160112E+00_JPRB, 0.150859E+00_JPRB &
  &, 0.141958E+00_JPRB, 0.133403E+00_JPRB, 0.125220E+00_JPRB &
  &, 0.117382E+00_JPRB, 0.109894E+00_JPRB, 0.102758E+00_JPRB, 0.959377E-01_JPRB &
  &, 0.894685E-01_JPRB, 0.833279E-01_JPRB, 0.774889E-01_JPRB &
  &, 0.719837E-01_JPRB, 0.667597E-01_JPRB, 0.618459E-01_JPRB, 0.572049E-01_JPRB &
  &, 0.528405E-01_JPRB, 0.487556E-01_JPRB, 0.449042E-01_JPRB &
  &, 0.413325E-01_JPRB, 0.379654E-01_JPRB, 0.348217E-01_JPRB, 0.319207E-01_JPRB &
  &, 0.292036E-01_JPRB, 0.266593E-01_JPRB, 0.243299E-01_JPRB &
  &, 0.221764E-01_JPRB, 0.201561E-01_JPRB, 0.183089E-01_JPRB, 0.166185E-01_JPRB &
  &, 0.150665E-01_JPRB, 0.136328E-01_JPRB, 0.122952E-01_JPRB &
  &, 0.110927E-01_JPRB, 0.100026E-01_JPRB, 0.899977E-02_JPRB, 0.809050E-02_JPRB &
  &, 0.724723E-02_JPRB, 0.647472E-02_JPRB, 0.581300E-02_JPRB &
  &, 0.519733E-02_JPRB, 0.463098E-02_JPRB, 0.411728E-02_JPRB, 0.365967E-02_JPRB &
  &, 0.326161E-02_JPRB, 0.288779E-02_JPRB, 0.253991E-02_JPRB &
  &, 0.225988E-02_JPRB, 0.196980E-02_JPRB, 0.175249E-02_JPRB, 0.152749E-02_JPRB &
  &, 0.133751E-02_JPRB, 0.118449E-02_JPRB, 0.102618E-02_JPRB &
  &, 0.907407E-03_JPRB, 0.784601E-03_JPRB, 0.703977E-03_JPRB, 0.573657E-03_JPRB &
  &, 0.534521E-03_JPRB, 0.445618E-03_JPRB, 0.403009E-03_JPRB &
  &, 0.309138E-03_JPRB, 0.262962E-03_JPRB, 0.215338E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.117193E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 360, :) = (/ &
  &  0.961154E+00_JPRB, 0.950586E+00_JPRB, 0.939688E+00_JPRB, 0.928473E+00_JPRB &
  &, 0.916943E+00_JPRB, 0.905109E+00_JPRB, 0.892978E+00_JPRB &
  &, 0.880559E+00_JPRB, 0.867860E+00_JPRB, 0.854889E+00_JPRB, 0.841660E+00_JPRB &
  &, 0.828177E+00_JPRB, 0.814454E+00_JPRB, 0.800498E+00_JPRB &
  &, 0.786323E+00_JPRB, 0.771939E+00_JPRB, 0.757354E+00_JPRB, 0.742585E+00_JPRB &
  &, 0.727640E+00_JPRB, 0.712537E+00_JPRB, 0.697281E+00_JPRB &
  &, 0.681893E+00_JPRB, 0.666385E+00_JPRB, 0.650769E+00_JPRB, 0.635061E+00_JPRB &
  &, 0.619279E+00_JPRB, 0.603435E+00_JPRB, 0.587546E+00_JPRB &
  &, 0.571629E+00_JPRB, 0.555697E+00_JPRB, 0.539773E+00_JPRB, 0.523870E+00_JPRB &
  &, 0.508007E+00_JPRB, 0.492197E+00_JPRB, 0.476462E+00_JPRB &
  &, 0.460815E+00_JPRB, 0.445280E+00_JPRB, 0.429876E+00_JPRB, 0.414604E+00_JPRB &
  &, 0.399496E+00_JPRB, 0.384566E+00_JPRB, 0.369830E+00_JPRB &
  &, 0.355292E+00_JPRB, 0.340992E+00_JPRB, 0.326913E+00_JPRB, 0.313096E+00_JPRB &
  &, 0.299545E+00_JPRB, 0.286266E+00_JPRB, 0.273275E+00_JPRB &
  &, 0.260586E+00_JPRB, 0.248216E+00_JPRB, 0.236150E+00_JPRB, 0.224414E+00_JPRB &
  &, 0.213020E+00_JPRB, 0.201961E+00_JPRB, 0.191260E+00_JPRB &
  &, 0.180893E+00_JPRB, 0.170894E+00_JPRB, 0.161248E+00_JPRB, 0.151955E+00_JPRB &
  &, 0.143011E+00_JPRB, 0.134427E+00_JPRB, 0.126214E+00_JPRB &
  &, 0.118326E+00_JPRB, 0.110803E+00_JPRB, 0.103630E+00_JPRB, 0.967900E-01_JPRB &
  &, 0.902800E-01_JPRB, 0.840962E-01_JPRB, 0.782323E-01_JPRB &
  &, 0.726796E-01_JPRB, 0.674272E-01_JPRB, 0.624834E-01_JPRB, 0.578107E-01_JPRB &
  &, 0.534130E-01_JPRB, 0.492931E-01_JPRB, 0.454287E-01_JPRB &
  &, 0.417946E-01_JPRB, 0.384119E-01_JPRB, 0.352518E-01_JPRB, 0.323077E-01_JPRB &
  &, 0.295718E-01_JPRB, 0.270078E-01_JPRB, 0.246578E-01_JPRB &
  &, 0.224828E-01_JPRB, 0.204398E-01_JPRB, 0.185691E-01_JPRB, 0.168541E-01_JPRB &
  &, 0.152765E-01_JPRB, 0.138161E-01_JPRB, 0.124818E-01_JPRB &
  &, 0.112827E-01_JPRB, 0.101638E-01_JPRB, 0.913100E-02_JPRB, 0.822407E-02_JPRB &
  &, 0.738314E-02_JPRB, 0.661300E-02_JPRB, 0.591851E-02_JPRB &
  &, 0.526888E-02_JPRB, 0.470375E-02_JPRB, 0.419129E-02_JPRB, 0.373492E-02_JPRB &
  &, 0.329987E-02_JPRB, 0.292668E-02_JPRB, 0.257944E-02_JPRB &
  &, 0.230006E-02_JPRB, 0.201063E-02_JPRB, 0.179398E-02_JPRB, 0.156964E-02_JPRB &
  &, 0.138033E-02_JPRB, 0.122798E-02_JPRB, 0.107037E-02_JPRB &
  &, 0.907407E-03_JPRB, 0.784601E-03_JPRB, 0.703977E-03_JPRB, 0.620629E-03_JPRB &
  &, 0.534521E-03_JPRB, 0.445618E-03_JPRB, 0.403009E-03_JPRB &
  &, 0.358994E-03_JPRB, 0.262962E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.170789E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 361, :) = (/ &
  &  0.961415E+00_JPRB, 0.950909E+00_JPRB, 0.940074E+00_JPRB, 0.928919E+00_JPRB &
  &, 0.917449E+00_JPRB, 0.905673E+00_JPRB, 0.893599E+00_JPRB &
  &, 0.881236E+00_JPRB, 0.868591E+00_JPRB, 0.855676E+00_JPRB, 0.842498E+00_JPRB &
  &, 0.829065E+00_JPRB, 0.815390E+00_JPRB, 0.801483E+00_JPRB &
  &, 0.787354E+00_JPRB, 0.773013E+00_JPRB, 0.758472E+00_JPRB, 0.743743E+00_JPRB &
  &, 0.728839E+00_JPRB, 0.713771E+00_JPRB, 0.698552E+00_JPRB &
  &, 0.683196E+00_JPRB, 0.667722E+00_JPRB, 0.652133E+00_JPRB, 0.636457E+00_JPRB &
  &, 0.620698E+00_JPRB, 0.604877E+00_JPRB, 0.589011E+00_JPRB &
  &, 0.573111E+00_JPRB, 0.557200E+00_JPRB, 0.541288E+00_JPRB, 0.525398E+00_JPRB &
  &, 0.509548E+00_JPRB, 0.493750E+00_JPRB, 0.478018E+00_JPRB &
  &, 0.462377E+00_JPRB, 0.446844E+00_JPRB, 0.431441E+00_JPRB, 0.416168E+00_JPRB &
  &, 0.401058E+00_JPRB, 0.386115E+00_JPRB, 0.371375E+00_JPRB &
  &, 0.356831E+00_JPRB, 0.342502E+00_JPRB, 0.328426E+00_JPRB, 0.314586E+00_JPRB &
  &, 0.301011E+00_JPRB, 0.287718E+00_JPRB, 0.274698E+00_JPRB &
  &, 0.261992E+00_JPRB, 0.249588E+00_JPRB, 0.237501E+00_JPRB, 0.225741E+00_JPRB &
  &, 0.214320E+00_JPRB, 0.203233E+00_JPRB, 0.192487E+00_JPRB &
  &, 0.182102E+00_JPRB, 0.172067E+00_JPRB, 0.162384E+00_JPRB, 0.153050E+00_JPRB &
  &, 0.144080E+00_JPRB, 0.135469E+00_JPRB, 0.127208E+00_JPRB &
  &, 0.119288E+00_JPRB, 0.111730E+00_JPRB, 0.104521E+00_JPRB, 0.976424E-01_JPRB &
  &, 0.910915E-01_JPRB, 0.848645E-01_JPRB, 0.789757E-01_JPRB &
  &, 0.733966E-01_JPRB, 0.681162E-01_JPRB, 0.631208E-01_JPRB, 0.584165E-01_JPRB &
  &, 0.539855E-01_JPRB, 0.498306E-01_JPRB, 0.459294E-01_JPRB &
  &, 0.422811E-01_JPRB, 0.388585E-01_JPRB, 0.356818E-01_JPRB, 0.326946E-01_JPRB &
  &, 0.299400E-01_JPRB, 0.273564E-01_JPRB, 0.249857E-01_JPRB &
  &, 0.227891E-01_JPRB, 0.207236E-01_JPRB, 0.188582E-01_JPRB, 0.171191E-01_JPRB &
  &, 0.155164E-01_JPRB, 0.140299E-01_JPRB, 0.126995E-01_JPRB &
  &, 0.114410E-01_JPRB, 0.103249E-01_JPRB, 0.929505E-02_JPRB, 0.835763E-02_JPRB &
  &, 0.748508E-02_JPRB, 0.671671E-02_JPRB, 0.602402E-02_JPRB &
  &, 0.537620E-02_JPRB, 0.477652E-02_JPRB, 0.426529E-02_JPRB, 0.381017E-02_JPRB &
  &, 0.337637E-02_JPRB, 0.300446E-02_JPRB, 0.265850E-02_JPRB &
  &, 0.234024E-02_JPRB, 0.205146E-02_JPRB, 0.183546E-02_JPRB, 0.161179E-02_JPRB &
  &, 0.142316E-02_JPRB, 0.122798E-02_JPRB, 0.107037E-02_JPRB &
  &, 0.952278E-03_JPRB, 0.830166E-03_JPRB, 0.703977E-03_JPRB, 0.620629E-03_JPRB &
  &, 0.534521E-03_JPRB, 0.445618E-03_JPRB, 0.403009E-03_JPRB &
  &, 0.358994E-03_JPRB, 0.313555E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.170789E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 362, :) = (/ &
  &  0.961676E+00_JPRB, 0.951232E+00_JPRB, 0.940459E+00_JPRB, 0.929364E+00_JPRB &
  &, 0.917954E+00_JPRB, 0.906237E+00_JPRB, 0.894221E+00_JPRB &
  &, 0.881913E+00_JPRB, 0.869323E+00_JPRB, 0.856461E+00_JPRB, 0.843335E+00_JPRB &
  &, 0.829953E+00_JPRB, 0.816328E+00_JPRB, 0.802467E+00_JPRB &
  &, 0.788383E+00_JPRB, 0.774086E+00_JPRB, 0.759589E+00_JPRB, 0.744901E+00_JPRB &
  &, 0.730036E+00_JPRB, 0.715005E+00_JPRB, 0.699823E+00_JPRB &
  &, 0.684502E+00_JPRB, 0.669058E+00_JPRB, 0.653501E+00_JPRB, 0.637849E+00_JPRB &
  &, 0.622120E+00_JPRB, 0.606323E+00_JPRB, 0.590477E+00_JPRB &
  &, 0.574597E+00_JPRB, 0.558702E+00_JPRB, 0.542808E+00_JPRB, 0.526931E+00_JPRB &
  &, 0.511088E+00_JPRB, 0.495298E+00_JPRB, 0.479578E+00_JPRB &
  &, 0.463940E+00_JPRB, 0.448408E+00_JPRB, 0.433005E+00_JPRB, 0.417732E+00_JPRB &
  &, 0.402621E+00_JPRB, 0.387675E+00_JPRB, 0.372920E+00_JPRB &
  &, 0.358360E+00_JPRB, 0.344034E+00_JPRB, 0.329927E+00_JPRB, 0.316077E+00_JPRB &
  &, 0.302490E+00_JPRB, 0.289171E+00_JPRB, 0.276135E+00_JPRB &
  &, 0.263398E+00_JPRB, 0.250975E+00_JPRB, 0.238865E+00_JPRB, 0.227068E+00_JPRB &
  &, 0.215621E+00_JPRB, 0.204506E+00_JPRB, 0.193729E+00_JPRB &
  &, 0.183311E+00_JPRB, 0.173241E+00_JPRB, 0.163519E+00_JPRB, 0.154145E+00_JPRB &
  &, 0.145150E+00_JPRB, 0.136493E+00_JPRB, 0.128202E+00_JPRB &
  &, 0.120250E+00_JPRB, 0.112658E+00_JPRB, 0.105393E+00_JPRB, 0.984947E-01_JPRB &
  &, 0.919029E-01_JPRB, 0.856530E-01_JPRB, 0.797191E-01_JPRB &
  &, 0.740926E-01_JPRB, 0.687837E-01_JPRB, 0.637583E-01_JPRB, 0.590224E-01_JPRB &
  &, 0.545809E-01_JPRB, 0.503914E-01_JPRB, 0.464539E-01_JPRB &
  &, 0.427675E-01_JPRB, 0.393298E-01_JPRB, 0.361119E-01_JPRB, 0.331074E-01_JPRB &
  &, 0.303082E-01_JPRB, 0.277317E-01_JPRB, 0.253136E-01_JPRB &
  &, 0.230954E-01_JPRB, 0.210073E-01_JPRB, 0.191183E-01_JPRB, 0.173547E-01_JPRB &
  &, 0.157264E-01_JPRB, 0.142437E-01_JPRB, 0.128861E-01_JPRB &
  &, 0.116310E-01_JPRB, 0.104861E-01_JPRB, 0.945910E-02_JPRB, 0.849119E-02_JPRB &
  &, 0.762099E-02_JPRB, 0.682042E-02_JPRB, 0.612953E-02_JPRB &
  &, 0.548353E-02_JPRB, 0.488568E-02_JPRB, 0.433930E-02_JPRB, 0.388542E-02_JPRB &
  &, 0.345288E-02_JPRB, 0.304335E-02_JPRB, 0.269803E-02_JPRB &
  &, 0.238041E-02_JPRB, 0.213312E-02_JPRB, 0.187695E-02_JPRB, 0.165394E-02_JPRB &
  &, 0.142316E-02_JPRB, 0.127148E-02_JPRB, 0.111455E-02_JPRB &
  &, 0.952278E-03_JPRB, 0.830166E-03_JPRB, 0.750242E-03_JPRB, 0.620629E-03_JPRB &
  &, 0.534521E-03_JPRB, 0.494019E-03_JPRB, 0.403009E-03_JPRB &
  &, 0.358994E-03_JPRB, 0.313555E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.170789E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 363, :) = (/ &
  &  0.961936E+00_JPRB, 0.951556E+00_JPRB, 0.940843E+00_JPRB, 0.929810E+00_JPRB &
  &, 0.918459E+00_JPRB, 0.906800E+00_JPRB, 0.894841E+00_JPRB &
  &, 0.882589E+00_JPRB, 0.870055E+00_JPRB, 0.857246E+00_JPRB, 0.844172E+00_JPRB &
  &, 0.830840E+00_JPRB, 0.817264E+00_JPRB, 0.803451E+00_JPRB &
  &, 0.789414E+00_JPRB, 0.775162E+00_JPRB, 0.760706E+00_JPRB, 0.746060E+00_JPRB &
  &, 0.731233E+00_JPRB, 0.716239E+00_JPRB, 0.701094E+00_JPRB &
  &, 0.685805E+00_JPRB, 0.670394E+00_JPRB, 0.654868E+00_JPRB, 0.639245E+00_JPRB &
  &, 0.623539E+00_JPRB, 0.607768E+00_JPRB, 0.591942E+00_JPRB &
  &, 0.576087E+00_JPRB, 0.560209E+00_JPRB, 0.544332E+00_JPRB, 0.528467E+00_JPRB &
  &, 0.512637E+00_JPRB, 0.496855E+00_JPRB, 0.481138E+00_JPRB &
  &, 0.465512E+00_JPRB, 0.449982E+00_JPRB, 0.434570E+00_JPRB, 0.419296E+00_JPRB &
  &, 0.404183E+00_JPRB, 0.389224E+00_JPRB, 0.374464E+00_JPRB &
  &, 0.359899E+00_JPRB, 0.345556E+00_JPRB, 0.331439E+00_JPRB, 0.317567E+00_JPRB &
  &, 0.303968E+00_JPRB, 0.290623E+00_JPRB, 0.277571E+00_JPRB &
  &, 0.264817E+00_JPRB, 0.252361E+00_JPRB, 0.240216E+00_JPRB, 0.228409E+00_JPRB &
  &, 0.216922E+00_JPRB, 0.205778E+00_JPRB, 0.194970E+00_JPRB &
  &, 0.184520E+00_JPRB, 0.174414E+00_JPRB, 0.164655E+00_JPRB, 0.155257E+00_JPRB &
  &, 0.146219E+00_JPRB, 0.137535E+00_JPRB, 0.129196E+00_JPRB &
  &, 0.121229E+00_JPRB, 0.113585E+00_JPRB, 0.106303E+00_JPRB, 0.993471E-01_JPRB &
  &, 0.927342E-01_JPRB, 0.864415E-01_JPRB, 0.804625E-01_JPRB &
  &, 0.748095E-01_JPRB, 0.694728E-01_JPRB, 0.644178E-01_JPRB, 0.596506E-01_JPRB &
  &, 0.551534E-01_JPRB, 0.509289E-01_JPRB, 0.469784E-01_JPRB &
  &, 0.432539E-01_JPRB, 0.398011E-01_JPRB, 0.365420E-01_JPRB, 0.335202E-01_JPRB &
  &, 0.307027E-01_JPRB, 0.280802E-01_JPRB, 0.256415E-01_JPRB &
  &, 0.234017E-01_JPRB, 0.213195E-01_JPRB, 0.193785E-01_JPRB, 0.176197E-01_JPRB &
  &, 0.159663E-01_JPRB, 0.144575E-01_JPRB, 0.130727E-01_JPRB &
  &, 0.118210E-01_JPRB, 0.106473E-01_JPRB, 0.959033E-02_JPRB, 0.862475E-02_JPRB &
  &, 0.775690E-02_JPRB, 0.695871E-02_JPRB, 0.623504E-02_JPRB &
  &, 0.555508E-02_JPRB, 0.495845E-02_JPRB, 0.445031E-02_JPRB, 0.396067E-02_JPRB &
  &, 0.352939E-02_JPRB, 0.312112E-02_JPRB, 0.277709E-02_JPRB &
  &, 0.246077E-02_JPRB, 0.217395E-02_JPRB, 0.191844E-02_JPRB, 0.169610E-02_JPRB &
  &, 0.146598E-02_JPRB, 0.131498E-02_JPRB, 0.111455E-02_JPRB &
  &, 0.997148E-03_JPRB, 0.875731E-03_JPRB, 0.750242E-03_JPRB, 0.667600E-03_JPRB &
  &, 0.582205E-03_JPRB, 0.494019E-03_JPRB, 0.403009E-03_JPRB &
  &, 0.358994E-03_JPRB, 0.313555E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.168510E-03_JPRB, 0.170789E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.659121E-04_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 364, :) = (/ &
  &  0.962196E+00_JPRB, 0.951879E+00_JPRB, 0.941228E+00_JPRB, 0.930255E+00_JPRB &
  &, 0.918964E+00_JPRB, 0.907363E+00_JPRB, 0.895462E+00_JPRB &
  &, 0.883266E+00_JPRB, 0.870786E+00_JPRB, 0.858031E+00_JPRB, 0.845008E+00_JPRB &
  &, 0.831727E+00_JPRB, 0.818200E+00_JPRB, 0.804435E+00_JPRB &
  &, 0.790443E+00_JPRB, 0.776236E+00_JPRB, 0.761823E+00_JPRB, 0.747219E+00_JPRB &
  &, 0.732432E+00_JPRB, 0.717476E+00_JPRB, 0.702365E+00_JPRB &
  &, 0.687112E+00_JPRB, 0.671730E+00_JPRB, 0.656235E+00_JPRB, 0.640641E+00_JPRB &
  &, 0.624961E+00_JPRB, 0.609213E+00_JPRB, 0.593411E+00_JPRB &
  &, 0.577573E+00_JPRB, 0.561716E+00_JPRB, 0.545851E+00_JPRB, 0.530004E+00_JPRB &
  &, 0.514182E+00_JPRB, 0.498413E+00_JPRB, 0.482703E+00_JPRB &
  &, 0.467075E+00_JPRB, 0.451555E+00_JPRB, 0.436144E+00_JPRB, 0.420870E+00_JPRB &
  &, 0.405745E+00_JPRB, 0.390794E+00_JPRB, 0.376020E+00_JPRB &
  &, 0.361438E+00_JPRB, 0.347088E+00_JPRB, 0.332952E+00_JPRB, 0.319070E+00_JPRB &
  &, 0.305447E+00_JPRB, 0.292088E+00_JPRB, 0.279008E+00_JPRB &
  &, 0.266236E+00_JPRB, 0.253747E+00_JPRB, 0.241595E+00_JPRB, 0.229750E+00_JPRB &
  &, 0.218237E+00_JPRB, 0.207065E+00_JPRB, 0.196227E+00_JPRB &
  &, 0.185728E+00_JPRB, 0.175603E+00_JPRB, 0.165807E+00_JPRB, 0.156386E+00_JPRB &
  &, 0.147306E+00_JPRB, 0.138576E+00_JPRB, 0.130208E+00_JPRB &
  &, 0.122191E+00_JPRB, 0.114531E+00_JPRB, 0.107194E+00_JPRB, 0.100219E+00_JPRB &
  &, 0.935654E-01_JPRB, 0.872300E-01_JPRB, 0.812265E-01_JPRB &
  &, 0.755476E-01_JPRB, 0.701618E-01_JPRB, 0.650553E-01_JPRB, 0.602565E-01_JPRB &
  &, 0.557488E-01_JPRB, 0.514897E-01_JPRB, 0.475030E-01_JPRB &
  &, 0.437647E-01_JPRB, 0.402477E-01_JPRB, 0.369974E-01_JPRB, 0.339329E-01_JPRB &
  &, 0.310972E-01_JPRB, 0.284556E-01_JPRB, 0.259968E-01_JPRB &
  &, 0.237080E-01_JPRB, 0.216032E-01_JPRB, 0.196676E-01_JPRB, 0.178553E-01_JPRB &
  &, 0.162062E-01_JPRB, 0.146713E-01_JPRB, 0.132904E-01_JPRB &
  &, 0.120110E-01_JPRB, 0.108407E-01_JPRB, 0.975438E-02_JPRB, 0.879171E-02_JPRB &
  &, 0.789281E-02_JPRB, 0.706242E-02_JPRB, 0.634055E-02_JPRB &
  &, 0.566240E-02_JPRB, 0.506761E-02_JPRB, 0.452431E-02_JPRB, 0.403592E-02_JPRB &
  &, 0.356765E-02_JPRB, 0.316001E-02_JPRB, 0.281662E-02_JPRB &
  &, 0.250094E-02_JPRB, 0.221478E-02_JPRB, 0.195993E-02_JPRB, 0.169610E-02_JPRB &
  &, 0.150880E-02_JPRB, 0.131498E-02_JPRB, 0.115873E-02_JPRB &
  &, 0.997148E-03_JPRB, 0.875731E-03_JPRB, 0.796507E-03_JPRB, 0.667600E-03_JPRB &
  &, 0.582205E-03_JPRB, 0.494019E-03_JPRB, 0.452135E-03_JPRB &
  &, 0.358994E-03_JPRB, 0.313555E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.170789E-03_JPRB, 0.118725E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART52',1,ZHOOK_HANDLE)
END SUBROUTINE PART52

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART53

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART53',0,ZHOOK_HANDLE)

XCW( 365, :) = (/ &
  &  0.962455E+00_JPRB, 0.952201E+00_JPRB, 0.941613E+00_JPRB, 0.930700E+00_JPRB &
  &, 0.919468E+00_JPRB, 0.907926E+00_JPRB, 0.896082E+00_JPRB &
  &, 0.883943E+00_JPRB, 0.871517E+00_JPRB, 0.858815E+00_JPRB, 0.845844E+00_JPRB &
  &, 0.832614E+00_JPRB, 0.819136E+00_JPRB, 0.805418E+00_JPRB &
  &, 0.791474E+00_JPRB, 0.777311E+00_JPRB, 0.762941E+00_JPRB, 0.748376E+00_JPRB &
  &, 0.733629E+00_JPRB, 0.718710E+00_JPRB, 0.703636E+00_JPRB &
  &, 0.688418E+00_JPRB, 0.673070E+00_JPRB, 0.657603E+00_JPRB, 0.642038E+00_JPRB &
  &, 0.626379E+00_JPRB, 0.610663E+00_JPRB, 0.594880E+00_JPRB &
  &, 0.579063E+00_JPRB, 0.563222E+00_JPRB, 0.547375E+00_JPRB, 0.531540E+00_JPRB &
  &, 0.515731E+00_JPRB, 0.499970E+00_JPRB, 0.484268E+00_JPRB &
  &, 0.468646E+00_JPRB, 0.453129E+00_JPRB, 0.437718E+00_JPRB, 0.422444E+00_JPRB &
  &, 0.407318E+00_JPRB, 0.392354E+00_JPRB, 0.377576E+00_JPRB &
  &, 0.362989E+00_JPRB, 0.348621E+00_JPRB, 0.334476E+00_JPRB, 0.320572E+00_JPRB &
  &, 0.306925E+00_JPRB, 0.293553E+00_JPRB, 0.280458E+00_JPRB &
  &, 0.267655E+00_JPRB, 0.255147E+00_JPRB, 0.242959E+00_JPRB, 0.231090E+00_JPRB &
  &, 0.219552E+00_JPRB, 0.208337E+00_JPRB, 0.197484E+00_JPRB &
  &, 0.186953E+00_JPRB, 0.176793E+00_JPRB, 0.166959E+00_JPRB, 0.157498E+00_JPRB &
  &, 0.148392E+00_JPRB, 0.139635E+00_JPRB, 0.131220E+00_JPRB &
  &, 0.123171E+00_JPRB, 0.115459E+00_JPRB, 0.108104E+00_JPRB, 0.101071E+00_JPRB &
  &, 0.943967E-01_JPRB, 0.880387E-01_JPRB, 0.819906E-01_JPRB &
  &, 0.762646E-01_JPRB, 0.708508E-01_JPRB, 0.657147E-01_JPRB, 0.608847E-01_JPRB &
  &, 0.563442E-01_JPRB, 0.520505E-01_JPRB, 0.480275E-01_JPRB &
  &, 0.442511E-01_JPRB, 0.407190E-01_JPRB, 0.374275E-01_JPRB, 0.343456E-01_JPRB &
  &, 0.314917E-01_JPRB, 0.288041E-01_JPRB, 0.263247E-01_JPRB &
  &, 0.240422E-01_JPRB, 0.219153E-01_JPRB, 0.199278E-01_JPRB, 0.181203E-01_JPRB &
  &, 0.164462E-01_JPRB, 0.149157E-01_JPRB, 0.134770E-01_JPRB &
  &, 0.122010E-01_JPRB, 0.110019E-01_JPRB, 0.991843E-02_JPRB, 0.892527E-02_JPRB &
  &, 0.802872E-02_JPRB, 0.720070E-02_JPRB, 0.644606E-02_JPRB &
  &, 0.576973E-02_JPRB, 0.517676E-02_JPRB, 0.459832E-02_JPRB, 0.411117E-02_JPRB &
  &, 0.364415E-02_JPRB, 0.323779E-02_JPRB, 0.289567E-02_JPRB &
  &, 0.254112E-02_JPRB, 0.225560E-02_JPRB, 0.200141E-02_JPRB, 0.173825E-02_JPRB &
  &, 0.155163E-02_JPRB, 0.135848E-02_JPRB, 0.120291E-02_JPRB &
  &, 0.104202E-02_JPRB, 0.921295E-03_JPRB, 0.796507E-03_JPRB, 0.667600E-03_JPRB &
  &, 0.582205E-03_JPRB, 0.542421E-03_JPRB, 0.452135E-03_JPRB &
  &, 0.408850E-03_JPRB, 0.313555E-03_JPRB, 0.266672E-03_JPRB, 0.218330E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.170789E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 366, :) = (/ &
  &  0.962714E+00_JPRB, 0.952522E+00_JPRB, 0.941997E+00_JPRB, 0.931145E+00_JPRB &
  &, 0.919973E+00_JPRB, 0.908489E+00_JPRB, 0.896702E+00_JPRB &
  &, 0.884618E+00_JPRB, 0.872248E+00_JPRB, 0.859599E+00_JPRB, 0.846680E+00_JPRB &
  &, 0.833502E+00_JPRB, 0.820072E+00_JPRB, 0.806404E+00_JPRB &
  &, 0.792503E+00_JPRB, 0.778385E+00_JPRB, 0.764058E+00_JPRB, 0.749535E+00_JPRB &
  &, 0.734828E+00_JPRB, 0.719947E+00_JPRB, 0.704911E+00_JPRB &
  &, 0.689724E+00_JPRB, 0.674406E+00_JPRB, 0.658974E+00_JPRB, 0.643434E+00_JPRB &
  &, 0.627809E+00_JPRB, 0.612108E+00_JPRB, 0.596353E+00_JPRB &
  &, 0.580556E+00_JPRB, 0.564733E+00_JPRB, 0.548902E+00_JPRB, 0.533081E+00_JPRB &
  &, 0.517268E+00_JPRB, 0.501532E+00_JPRB, 0.485838E+00_JPRB &
  &, 0.470218E+00_JPRB, 0.454702E+00_JPRB, 0.439293E+00_JPRB, 0.424018E+00_JPRB &
  &, 0.408891E+00_JPRB, 0.393913E+00_JPRB, 0.379131E+00_JPRB &
  &, 0.364539E+00_JPRB, 0.350153E+00_JPRB, 0.336000E+00_JPRB, 0.322086E+00_JPRB &
  &, 0.308416E+00_JPRB, 0.295030E+00_JPRB, 0.281907E+00_JPRB &
  &, 0.269074E+00_JPRB, 0.256547E+00_JPRB, 0.244337E+00_JPRB, 0.232445E+00_JPRB &
  &, 0.220867E+00_JPRB, 0.209639E+00_JPRB, 0.198741E+00_JPRB &
  &, 0.188177E+00_JPRB, 0.177982E+00_JPRB, 0.168127E+00_JPRB, 0.158627E+00_JPRB &
  &, 0.149478E+00_JPRB, 0.140694E+00_JPRB, 0.132249E+00_JPRB &
  &, 0.124151E+00_JPRB, 0.116405E+00_JPRB, 0.109014E+00_JPRB, 0.101962E+00_JPRB &
  &, 0.952279E-01_JPRB, 0.888272E-01_JPRB, 0.827546E-01_JPRB &
  &, 0.770027E-01_JPRB, 0.715399E-01_JPRB, 0.663962E-01_JPRB, 0.615130E-01_JPRB &
  &, 0.569396E-01_JPRB, 0.526114E-01_JPRB, 0.485758E-01_JPRB &
  &, 0.447619E-01_JPRB, 0.412152E-01_JPRB, 0.378829E-01_JPRB, 0.347842E-01_JPRB &
  &, 0.318863E-01_JPRB, 0.291795E-01_JPRB, 0.266799E-01_JPRB &
  &, 0.243485E-01_JPRB, 0.221991E-01_JPRB, 0.202169E-01_JPRB, 0.183853E-01_JPRB &
  &, 0.166861E-01_JPRB, 0.151295E-01_JPRB, 0.136947E-01_JPRB &
  &, 0.123910E-01_JPRB, 0.111953E-01_JPRB, 0.100825E-01_JPRB, 0.905883E-02_JPRB &
  &, 0.816463E-02_JPRB, 0.733898E-02_JPRB, 0.655157E-02_JPRB &
  &, 0.587705E-02_JPRB, 0.524953E-02_JPRB, 0.467232E-02_JPRB, 0.418642E-02_JPRB &
  &, 0.372066E-02_JPRB, 0.331557E-02_JPRB, 0.293520E-02_JPRB &
  &, 0.258130E-02_JPRB, 0.229643E-02_JPRB, 0.204290E-02_JPRB, 0.178040E-02_JPRB &
  &, 0.159445E-02_JPRB, 0.140198E-02_JPRB, 0.120291E-02_JPRB &
  &, 0.108689E-02_JPRB, 0.921295E-03_JPRB, 0.796507E-03_JPRB, 0.714572E-03_JPRB &
  &, 0.629888E-03_JPRB, 0.542421E-03_JPRB, 0.452135E-03_JPRB &
  &, 0.408850E-03_JPRB, 0.364147E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.170789E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 367, :) = (/ &
  &  0.962973E+00_JPRB, 0.952846E+00_JPRB, 0.942381E+00_JPRB, 0.931590E+00_JPRB &
  &, 0.920477E+00_JPRB, 0.909052E+00_JPRB, 0.897321E+00_JPRB &
  &, 0.885294E+00_JPRB, 0.872978E+00_JPRB, 0.860362E+00_JPRB, 0.847516E+00_JPRB &
  &, 0.834388E+00_JPRB, 0.821009E+00_JPRB, 0.807386E+00_JPRB &
  &, 0.793534E+00_JPRB, 0.779460E+00_JPRB, 0.765176E+00_JPRB, 0.750695E+00_JPRB &
  &, 0.736026E+00_JPRB, 0.721185E+00_JPRB, 0.706182E+00_JPRB &
  &, 0.691031E+00_JPRB, 0.675746E+00_JPRB, 0.660344E+00_JPRB, 0.644833E+00_JPRB &
  &, 0.629235E+00_JPRB, 0.613557E+00_JPRB, 0.597826E+00_JPRB &
  &, 0.582046E+00_JPRB, 0.566244E+00_JPRB, 0.550426E+00_JPRB, 0.534622E+00_JPRB &
  &, 0.518834E+00_JPRB, 0.503093E+00_JPRB, 0.487407E+00_JPRB &
  &, 0.471800E+00_JPRB, 0.456276E+00_JPRB, 0.440877E+00_JPRB, 0.425592E+00_JPRB &
  &, 0.410463E+00_JPRB, 0.395483E+00_JPRB, 0.380687E+00_JPRB &
  &, 0.366090E+00_JPRB, 0.351697E+00_JPRB, 0.337524E+00_JPRB, 0.323589E+00_JPRB &
  &, 0.309919E+00_JPRB, 0.296495E+00_JPRB, 0.283356E+00_JPRB &
  &, 0.270507E+00_JPRB, 0.257960E+00_JPRB, 0.245716E+00_JPRB, 0.233786E+00_JPRB &
  &, 0.222196E+00_JPRB, 0.210926E+00_JPRB, 0.199998E+00_JPRB &
  &, 0.189417E+00_JPRB, 0.179171E+00_JPRB, 0.169295E+00_JPRB, 0.159755E+00_JPRB &
  &, 0.150582E+00_JPRB, 0.141753E+00_JPRB, 0.133208E+00_JPRB &
  &, 0.125149E+00_JPRB, 0.117369E+00_JPRB, 0.109924E+00_JPRB, 0.102834E+00_JPRB &
  &, 0.960790E-01_JPRB, 0.896359E-01_JPRB, 0.835393E-01_JPRB &
  &, 0.777408E-01_JPRB, 0.722504E-01_JPRB, 0.670557E-01_JPRB, 0.621637E-01_JPRB &
  &, 0.575350E-01_JPRB, 0.531956E-01_JPRB, 0.491004E-01_JPRB &
  &, 0.452726E-01_JPRB, 0.416865E-01_JPRB, 0.383383E-01_JPRB, 0.351969E-01_JPRB &
  &, 0.322808E-01_JPRB, 0.295548E-01_JPRB, 0.270352E-01_JPRB &
  &, 0.246827E-01_JPRB, 0.225112E-01_JPRB, 0.205059E-01_JPRB, 0.186504E-01_JPRB &
  &, 0.169261E-01_JPRB, 0.153433E-01_JPRB, 0.139125E-01_JPRB &
  &, 0.125810E-01_JPRB, 0.113564E-01_JPRB, 0.102465E-01_JPRB, 0.922578E-02_JPRB &
  &, 0.830054E-02_JPRB, 0.744270E-02_JPRB, 0.669225E-02_JPRB &
  &, 0.598437E-02_JPRB, 0.535869E-02_JPRB, 0.478333E-02_JPRB, 0.426167E-02_JPRB &
  &, 0.379717E-02_JPRB, 0.335446E-02_JPRB, 0.297473E-02_JPRB &
  &, 0.266165E-02_JPRB, 0.233726E-02_JPRB, 0.208439E-02_JPRB, 0.182255E-02_JPRB &
  &, 0.159445E-02_JPRB, 0.140198E-02_JPRB, 0.124709E-02_JPRB &
  &, 0.108689E-02_JPRB, 0.966860E-03_JPRB, 0.842772E-03_JPRB, 0.714572E-03_JPRB &
  &, 0.629888E-03_JPRB, 0.542421E-03_JPRB, 0.452135E-03_JPRB &
  &, 0.408850E-03_JPRB, 0.364147E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.170789E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 368, :) = (/ &
  &  0.963234E+00_JPRB, 0.953169E+00_JPRB, 0.942764E+00_JPRB, 0.932033E+00_JPRB &
  &, 0.920981E+00_JPRB, 0.909614E+00_JPRB, 0.897940E+00_JPRB &
  &, 0.885970E+00_JPRB, 0.873707E+00_JPRB, 0.861166E+00_JPRB, 0.848347E+00_JPRB &
  &, 0.835275E+00_JPRB, 0.821945E+00_JPRB, 0.808370E+00_JPRB &
  &, 0.794563E+00_JPRB, 0.780534E+00_JPRB, 0.766294E+00_JPRB, 0.751854E+00_JPRB &
  &, 0.737225E+00_JPRB, 0.722422E+00_JPRB, 0.707456E+00_JPRB &
  &, 0.692340E+00_JPRB, 0.677086E+00_JPRB, 0.661715E+00_JPRB, 0.646233E+00_JPRB &
  &, 0.630661E+00_JPRB, 0.615010E+00_JPRB, 0.599299E+00_JPRB &
  &, 0.583540E+00_JPRB, 0.567754E+00_JPRB, 0.551958E+00_JPRB, 0.536162E+00_JPRB &
  &, 0.520392E+00_JPRB, 0.504655E+00_JPRB, 0.488981E+00_JPRB &
  &, 0.473372E+00_JPRB, 0.457859E+00_JPRB, 0.442451E+00_JPRB, 0.427176E+00_JPRB &
  &, 0.412036E+00_JPRB, 0.397064E+00_JPRB, 0.382254E+00_JPRB &
  &, 0.367640E+00_JPRB, 0.353241E+00_JPRB, 0.339060E+00_JPRB, 0.325115E+00_JPRB &
  &, 0.311410E+00_JPRB, 0.297972E+00_JPRB, 0.284819E+00_JPRB &
  &, 0.271939E+00_JPRB, 0.259373E+00_JPRB, 0.247108E+00_JPRB, 0.235155E+00_JPRB &
  &, 0.223526E+00_JPRB, 0.212228E+00_JPRB, 0.201270E+00_JPRB &
  &, 0.190657E+00_JPRB, 0.180377E+00_JPRB, 0.170463E+00_JPRB, 0.160900E+00_JPRB &
  &, 0.151668E+00_JPRB, 0.142812E+00_JPRB, 0.134308E+00_JPRB &
  &, 0.126129E+00_JPRB, 0.118315E+00_JPRB, 0.110853E+00_JPRB, 0.103725E+00_JPRB &
  &, 0.969300E-01_JPRB, 0.904648E-01_JPRB, 0.843034E-01_JPRB &
  &, 0.784789E-01_JPRB, 0.729610E-01_JPRB, 0.677371E-01_JPRB, 0.627920E-01_JPRB &
  &, 0.581533E-01_JPRB, 0.537798E-01_JPRB, 0.496487E-01_JPRB &
  &, 0.457834E-01_JPRB, 0.421827E-01_JPRB, 0.387936E-01_JPRB, 0.356355E-01_JPRB &
  &, 0.326753E-01_JPRB, 0.299301E-01_JPRB, 0.273904E-01_JPRB &
  &, 0.250169E-01_JPRB, 0.228233E-01_JPRB, 0.207950E-01_JPRB, 0.189154E-01_JPRB &
  &, 0.171660E-01_JPRB, 0.155876E-01_JPRB, 0.141302E-01_JPRB &
  &, 0.127710E-01_JPRB, 0.115498E-01_JPRB, 0.104106E-01_JPRB, 0.939273E-02_JPRB &
  &, 0.843645E-02_JPRB, 0.758098E-02_JPRB, 0.679775E-02_JPRB &
  &, 0.609170E-02_JPRB, 0.543146E-02_JPRB, 0.485733E-02_JPRB, 0.433692E-02_JPRB &
  &, 0.387368E-02_JPRB, 0.343224E-02_JPRB, 0.305379E-02_JPRB &
  &, 0.270183E-02_JPRB, 0.237809E-02_JPRB, 0.212588E-02_JPRB, 0.186471E-02_JPRB &
  &, 0.163727E-02_JPRB, 0.144548E-02_JPRB, 0.129128E-02_JPRB &
  &, 0.113176E-02_JPRB, 0.966860E-03_JPRB, 0.842772E-03_JPRB, 0.761543E-03_JPRB &
  &, 0.629888E-03_JPRB, 0.542421E-03_JPRB, 0.501261E-03_JPRB &
  &, 0.408850E-03_JPRB, 0.364147E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.170789E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.666959E-04_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 369, :) = (/ &
  &  0.963494E+00_JPRB, 0.953488E+00_JPRB, 0.943148E+00_JPRB, 0.932478E+00_JPRB &
  &, 0.921484E+00_JPRB, 0.910175E+00_JPRB, 0.898559E+00_JPRB &
  &, 0.886644E+00_JPRB, 0.874438E+00_JPRB, 0.861950E+00_JPRB, 0.849187E+00_JPRB &
  &, 0.836161E+00_JPRB, 0.822880E+00_JPRB, 0.809354E+00_JPRB &
  &, 0.795594E+00_JPRB, 0.781609E+00_JPRB, 0.767411E+00_JPRB, 0.753013E+00_JPRB &
  &, 0.738425E+00_JPRB, 0.723659E+00_JPRB, 0.708727E+00_JPRB &
  &, 0.693646E+00_JPRB, 0.678429E+00_JPRB, 0.663086E+00_JPRB, 0.647633E+00_JPRB &
  &, 0.632086E+00_JPRB, 0.616463E+00_JPRB, 0.600773E+00_JPRB &
  &, 0.585037E+00_JPRB, 0.569269E+00_JPRB, 0.553486E+00_JPRB, 0.537707E+00_JPRB &
  &, 0.521946E+00_JPRB, 0.506226E+00_JPRB, 0.490555E+00_JPRB &
  &, 0.474953E+00_JPRB, 0.459442E+00_JPRB, 0.444045E+00_JPRB, 0.428760E+00_JPRB &
  &, 0.413619E+00_JPRB, 0.398634E+00_JPRB, 0.383831E+00_JPRB &
  &, 0.369202E+00_JPRB, 0.354785E+00_JPRB, 0.340596E+00_JPRB, 0.326629E+00_JPRB &
  &, 0.312913E+00_JPRB, 0.299462E+00_JPRB, 0.286281E+00_JPRB &
  &, 0.273384E+00_JPRB, 0.260786E+00_JPRB, 0.248486E+00_JPRB, 0.236510E+00_JPRB &
  &, 0.224855E+00_JPRB, 0.213530E+00_JPRB, 0.202542E+00_JPRB &
  &, 0.191896E+00_JPRB, 0.181598E+00_JPRB, 0.171631E+00_JPRB, 0.162029E+00_JPRB &
  &, 0.152789E+00_JPRB, 0.143888E+00_JPRB, 0.135338E+00_JPRB &
  &, 0.127145E+00_JPRB, 0.119280E+00_JPRB, 0.111782E+00_JPRB, 0.104616E+00_JPRB &
  &, 0.977811E-01_JPRB, 0.912735E-01_JPRB, 0.850881E-01_JPRB &
  &, 0.792170E-01_JPRB, 0.736715E-01_JPRB, 0.684186E-01_JPRB, 0.634427E-01_JPRB &
  &, 0.587487E-01_JPRB, 0.543406E-01_JPRB, 0.501971E-01_JPRB &
  &, 0.463185E-01_JPRB, 0.426540E-01_JPRB, 0.392490E-01_JPRB, 0.360482E-01_JPRB &
  &, 0.330961E-01_JPRB, 0.303055E-01_JPRB, 0.277456E-01_JPRB &
  &, 0.253510E-01_JPRB, 0.231354E-01_JPRB, 0.210841E-01_JPRB, 0.191804E-01_JPRB &
  &, 0.174360E-01_JPRB, 0.158015E-01_JPRB, 0.143479E-01_JPRB &
  &, 0.129610E-01_JPRB, 0.117110E-01_JPRB, 0.105746E-01_JPRB, 0.952630E-02_JPRB &
  &, 0.857236E-02_JPRB, 0.771926E-02_JPRB, 0.690326E-02_JPRB &
  &, 0.619902E-02_JPRB, 0.554062E-02_JPRB, 0.496834E-02_JPRB, 0.441217E-02_JPRB &
  &, 0.395019E-02_JPRB, 0.351001E-02_JPRB, 0.313285E-02_JPRB &
  &, 0.278218E-02_JPRB, 0.245975E-02_JPRB, 0.216737E-02_JPRB, 0.190686E-02_JPRB &
  &, 0.168009E-02_JPRB, 0.148898E-02_JPRB, 0.129128E-02_JPRB &
  &, 0.113176E-02_JPRB, 0.101242E-02_JPRB, 0.889037E-03_JPRB, 0.761543E-03_JPRB &
  &, 0.677572E-03_JPRB, 0.590823E-03_JPRB, 0.501261E-03_JPRB &
  &, 0.408850E-03_JPRB, 0.364147E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 370, :) = (/ &
  &  0.963752E+00_JPRB, 0.953810E+00_JPRB, 0.943530E+00_JPRB, 0.932922E+00_JPRB &
  &, 0.921986E+00_JPRB, 0.910737E+00_JPRB, 0.899178E+00_JPRB &
  &, 0.887319E+00_JPRB, 0.875168E+00_JPRB, 0.862733E+00_JPRB, 0.850023E+00_JPRB &
  &, 0.837047E+00_JPRB, 0.823816E+00_JPRB, 0.810337E+00_JPRB &
  &, 0.796623E+00_JPRB, 0.782683E+00_JPRB, 0.768530E+00_JPRB, 0.754173E+00_JPRB &
  &, 0.739624E+00_JPRB, 0.724896E+00_JPRB, 0.710001E+00_JPRB &
  &, 0.694956E+00_JPRB, 0.679768E+00_JPRB, 0.664457E+00_JPRB, 0.649032E+00_JPRB &
  &, 0.633516E+00_JPRB, 0.617916E+00_JPRB, 0.602249E+00_JPRB &
  &, 0.586531E+00_JPRB, 0.570783E+00_JPRB, 0.555017E+00_JPRB, 0.539252E+00_JPRB &
  &, 0.523503E+00_JPRB, 0.507792E+00_JPRB, 0.492129E+00_JPRB &
  &, 0.476534E+00_JPRB, 0.461035E+00_JPRB, 0.445629E+00_JPRB, 0.430344E+00_JPRB &
  &, 0.415202E+00_JPRB, 0.400215E+00_JPRB, 0.385397E+00_JPRB &
  &, 0.370763E+00_JPRB, 0.356340E+00_JPRB, 0.342132E+00_JPRB, 0.328156E+00_JPRB &
  &, 0.314416E+00_JPRB, 0.300952E+00_JPRB, 0.287743E+00_JPRB &
  &, 0.274830E+00_JPRB, 0.262213E+00_JPRB, 0.249892E+00_JPRB, 0.237879E+00_JPRB &
  &, 0.226199E+00_JPRB, 0.214846E+00_JPRB, 0.203829E+00_JPRB &
  &, 0.193136E+00_JPRB, 0.182803E+00_JPRB, 0.172816E+00_JPRB, 0.163174E+00_JPRB &
  &, 0.153892E+00_JPRB, 0.144965E+00_JPRB, 0.136385E+00_JPRB &
  &, 0.128143E+00_JPRB, 0.120263E+00_JPRB, 0.112711E+00_JPRB, 0.105507E+00_JPRB &
  &, 0.986321E-01_JPRB, 0.921025E-01_JPRB, 0.858728E-01_JPRB &
  &, 0.799761E-01_JPRB, 0.743821E-01_JPRB, 0.691000E-01_JPRB, 0.640934E-01_JPRB &
  &, 0.593670E-01_JPRB, 0.549248E-01_JPRB, 0.507455E-01_JPRB &
  &, 0.468292E-01_JPRB, 0.431501E-01_JPRB, 0.397044E-01_JPRB, 0.364868E-01_JPRB &
  &, 0.334906E-01_JPRB, 0.307076E-01_JPRB, 0.281009E-01_JPRB &
  &, 0.256852E-01_JPRB, 0.234476E-01_JPRB, 0.213732E-01_JPRB, 0.194455E-01_JPRB &
  &, 0.176759E-01_JPRB, 0.160458E-01_JPRB, 0.145345E-01_JPRB &
  &, 0.131826E-01_JPRB, 0.119044E-01_JPRB, 0.107387E-01_JPRB, 0.969325E-02_JPRB &
  &, 0.870827E-02_JPRB, 0.785755E-02_JPRB, 0.704394E-02_JPRB &
  &, 0.630635E-02_JPRB, 0.564978E-02_JPRB, 0.504235E-02_JPRB, 0.452505E-02_JPRB &
  &, 0.402670E-02_JPRB, 0.358779E-02_JPRB, 0.317238E-02_JPRB &
  &, 0.282235E-02_JPRB, 0.250058E-02_JPRB, 0.220885E-02_JPRB, 0.194901E-02_JPRB &
  &, 0.172292E-02_JPRB, 0.153248E-02_JPRB, 0.133546E-02_JPRB &
  &, 0.117663E-02_JPRB, 0.101242E-02_JPRB, 0.889037E-03_JPRB, 0.761543E-03_JPRB &
  &, 0.677572E-03_JPRB, 0.590823E-03_JPRB, 0.501261E-03_JPRB &
  &, 0.458707E-03_JPRB, 0.364147E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.221346E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.120269E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 371, :) = (/ &
  &  0.964009E+00_JPRB, 0.954132E+00_JPRB, 0.943913E+00_JPRB, 0.933365E+00_JPRB &
  &, 0.922490E+00_JPRB, 0.911298E+00_JPRB, 0.899797E+00_JPRB &
  &, 0.887994E+00_JPRB, 0.875897E+00_JPRB, 0.863516E+00_JPRB, 0.850858E+00_JPRB &
  &, 0.837933E+00_JPRB, 0.824751E+00_JPRB, 0.811321E+00_JPRB &
  &, 0.797654E+00_JPRB, 0.783759E+00_JPRB, 0.769648E+00_JPRB, 0.755332E+00_JPRB &
  &, 0.740824E+00_JPRB, 0.726134E+00_JPRB, 0.711276E+00_JPRB &
  &, 0.696266E+00_JPRB, 0.681111E+00_JPRB, 0.665831E+00_JPRB, 0.650435E+00_JPRB &
  &, 0.634942E+00_JPRB, 0.619369E+00_JPRB, 0.603726E+00_JPRB &
  &, 0.588028E+00_JPRB, 0.572302E+00_JPRB, 0.556553E+00_JPRB, 0.540801E+00_JPRB &
  &, 0.525066E+00_JPRB, 0.509362E+00_JPRB, 0.493707E+00_JPRB &
  &, 0.478124E+00_JPRB, 0.462618E+00_JPRB, 0.447223E+00_JPRB, 0.431938E+00_JPRB &
  &, 0.416795E+00_JPRB, 0.401796E+00_JPRB, 0.386975E+00_JPRB &
  &, 0.372336E+00_JPRB, 0.357895E+00_JPRB, 0.343668E+00_JPRB, 0.329682E+00_JPRB &
  &, 0.315931E+00_JPRB, 0.302442E+00_JPRB, 0.289218E+00_JPRB &
  &, 0.276275E+00_JPRB, 0.263626E+00_JPRB, 0.251284E+00_JPRB, 0.239249E+00_JPRB &
  &, 0.227543E+00_JPRB, 0.216163E+00_JPRB, 0.205101E+00_JPRB &
  &, 0.194391E+00_JPRB, 0.184024E+00_JPRB, 0.174000E+00_JPRB, 0.164336E+00_JPRB &
  &, 0.155012E+00_JPRB, 0.146041E+00_JPRB, 0.137432E+00_JPRB &
  &, 0.129160E+00_JPRB, 0.121227E+00_JPRB, 0.113659E+00_JPRB, 0.106418E+00_JPRB &
  &, 0.995029E-01_JPRB, 0.929314E-01_JPRB, 0.866781E-01_JPRB &
  &, 0.807353E-01_JPRB, 0.751142E-01_JPRB, 0.697815E-01_JPRB, 0.647441E-01_JPRB &
  &, 0.600082E-01_JPRB, 0.555324E-01_JPRB, 0.513177E-01_JPRB &
  &, 0.473643E-01_JPRB, 0.436463E-01_JPRB, 0.401851E-01_JPRB, 0.369253E-01_JPRB &
  &, 0.339114E-01_JPRB, 0.310830E-01_JPRB, 0.284561E-01_JPRB &
  &, 0.260194E-01_JPRB, 0.237597E-01_JPRB, 0.216623E-01_JPRB, 0.197399E-01_JPRB &
  &, 0.179458E-01_JPRB, 0.162902E-01_JPRB, 0.147833E-01_JPRB &
  &, 0.133726E-01_JPRB, 0.120978E-01_JPRB, 0.109355E-01_JPRB, 0.986020E-02_JPRB &
  &, 0.887816E-02_JPRB, 0.796126E-02_JPRB, 0.714945E-02_JPRB &
  &, 0.641367E-02_JPRB, 0.575893E-02_JPRB, 0.515335E-02_JPRB, 0.460030E-02_JPRB &
  &, 0.410320E-02_JPRB, 0.366557E-02_JPRB, 0.325144E-02_JPRB &
  &, 0.286253E-02_JPRB, 0.254141E-02_JPRB, 0.225034E-02_JPRB, 0.199116E-02_JPRB &
  &, 0.176574E-02_JPRB, 0.153248E-02_JPRB, 0.137964E-02_JPRB &
  &, 0.117663E-02_JPRB, 0.105799E-02_JPRB, 0.935302E-03_JPRB, 0.808514E-03_JPRB &
  &, 0.677572E-03_JPRB, 0.590823E-03_JPRB, 0.550388E-03_JPRB &
  &, 0.458707E-03_JPRB, 0.414739E-03_JPRB, 0.318007E-03_JPRB, 0.270413E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART53',1,ZHOOK_HANDLE)
END SUBROUTINE PART53

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART54

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART54',0,ZHOOK_HANDLE)

XCW( 372, :) = (/ &
  &  0.964269E+00_JPRB, 0.954453E+00_JPRB, 0.944296E+00_JPRB, 0.933808E+00_JPRB &
  &, 0.922992E+00_JPRB, 0.911860E+00_JPRB, 0.900415E+00_JPRB &
  &, 0.888668E+00_JPRB, 0.876627E+00_JPRB, 0.864299E+00_JPRB, 0.851693E+00_JPRB &
  &, 0.838818E+00_JPRB, 0.825685E+00_JPRB, 0.812304E+00_JPRB &
  &, 0.798683E+00_JPRB, 0.784833E+00_JPRB, 0.770765E+00_JPRB, 0.756492E+00_JPRB &
  &, 0.742024E+00_JPRB, 0.727371E+00_JPRB, 0.712553E+00_JPRB &
  &, 0.697575E+00_JPRB, 0.682454E+00_JPRB, 0.667202E+00_JPRB, 0.651839E+00_JPRB &
  &, 0.636346E+00_JPRB, 0.620821E+00_JPRB, 0.605203E+00_JPRB &
  &, 0.589530E+00_JPRB, 0.573817E+00_JPRB, 0.558085E+00_JPRB, 0.542350E+00_JPRB &
  &, 0.526628E+00_JPRB, 0.510937E+00_JPRB, 0.495290E+00_JPRB &
  &, 0.479706E+00_JPRB, 0.464211E+00_JPRB, 0.448807E+00_JPRB, 0.433532E+00_JPRB &
  &, 0.418378E+00_JPRB, 0.403387E+00_JPRB, 0.388552E+00_JPRB &
  &, 0.373897E+00_JPRB, 0.359450E+00_JPRB, 0.345215E+00_JPRB, 0.331208E+00_JPRB &
  &, 0.317446E+00_JPRB, 0.303932E+00_JPRB, 0.290693E+00_JPRB &
  &, 0.277734E+00_JPRB, 0.265066E+00_JPRB, 0.252690E+00_JPRB, 0.240632E+00_JPRB &
  &, 0.228887E+00_JPRB, 0.217480E+00_JPRB, 0.206403E+00_JPRB &
  &, 0.195647E+00_JPRB, 0.185261E+00_JPRB, 0.175201E+00_JPRB, 0.165498E+00_JPRB &
  &, 0.156133E+00_JPRB, 0.147135E+00_JPRB, 0.138480E+00_JPRB &
  &, 0.130176E+00_JPRB, 0.122211E+00_JPRB, 0.114588E+00_JPRB, 0.107309E+00_JPRB &
  &, 0.100374E+00_JPRB, 0.937603E-01_JPRB, 0.874628E-01_JPRB &
  &, 0.814945E-01_JPRB, 0.758463E-01_JPRB, 0.704849E-01_JPRB, 0.654172E-01_JPRB &
  &, 0.606265E-01_JPRB, 0.561166E-01_JPRB, 0.518660E-01_JPRB &
  &, 0.478994E-01_JPRB, 0.441672E-01_JPRB, 0.406658E-01_JPRB, 0.373897E-01_JPRB &
  &, 0.343322E-01_JPRB, 0.314851E-01_JPRB, 0.288387E-01_JPRB &
  &, 0.263535E-01_JPRB, 0.240718E-01_JPRB, 0.219514E-01_JPRB, 0.200050E-01_JPRB &
  &, 0.181858E-01_JPRB, 0.165345E-01_JPRB, 0.150010E-01_JPRB &
  &, 0.135943E-01_JPRB, 0.122912E-01_JPRB, 0.110996E-01_JPRB, 0.100272E-01_JPRB &
  &, 0.901407E-02_JPRB, 0.809954E-02_JPRB, 0.729013E-02_JPRB &
  &, 0.652100E-02_JPRB, 0.586809E-02_JPRB, 0.522736E-02_JPRB, 0.467555E-02_JPRB &
  &, 0.417971E-02_JPRB, 0.370446E-02_JPRB, 0.329097E-02_JPRB &
  &, 0.294288E-02_JPRB, 0.262307E-02_JPRB, 0.229183E-02_JPRB, 0.203331E-02_JPRB &
  &, 0.180856E-02_JPRB, 0.157598E-02_JPRB, 0.137964E-02_JPRB &
  &, 0.122150E-02_JPRB, 0.105799E-02_JPRB, 0.935302E-03_JPRB, 0.808514E-03_JPRB &
  &, 0.725256E-03_JPRB, 0.639225E-03_JPRB, 0.550388E-03_JPRB &
  &, 0.458707E-03_JPRB, 0.414739E-03_JPRB, 0.369341E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 373, :) = (/ &
  &  0.964527E+00_JPRB, 0.954774E+00_JPRB, 0.944678E+00_JPRB, 0.934251E+00_JPRB &
  &, 0.923495E+00_JPRB, 0.912420E+00_JPRB, 0.901032E+00_JPRB &
  &, 0.889342E+00_JPRB, 0.877355E+00_JPRB, 0.865081E+00_JPRB, 0.852528E+00_JPRB &
  &, 0.839705E+00_JPRB, 0.826622E+00_JPRB, 0.813287E+00_JPRB &
  &, 0.799712E+00_JPRB, 0.785908E+00_JPRB, 0.771884E+00_JPRB, 0.757652E+00_JPRB &
  &, 0.743225E+00_JPRB, 0.728611E+00_JPRB, 0.713828E+00_JPRB &
  &, 0.698885E+00_JPRB, 0.683797E+00_JPRB, 0.668576E+00_JPRB, 0.653242E+00_JPRB &
  &, 0.637804E+00_JPRB, 0.622278E+00_JPRB, 0.606684E+00_JPRB &
  &, 0.591031E+00_JPRB, 0.575339E+00_JPRB, 0.559625E+00_JPRB, 0.543904E+00_JPRB &
  &, 0.528194E+00_JPRB, 0.512512E+00_JPRB, 0.496873E+00_JPRB &
  &, 0.481296E+00_JPRB, 0.465803E+00_JPRB, 0.450410E+00_JPRB, 0.435126E+00_JPRB &
  &, 0.419971E+00_JPRB, 0.404968E+00_JPRB, 0.390129E+00_JPRB &
  &, 0.375481E+00_JPRB, 0.361017E+00_JPRB, 0.346762E+00_JPRB, 0.332746E+00_JPRB &
  &, 0.318961E+00_JPRB, 0.305434E+00_JPRB, 0.292169E+00_JPRB &
  &, 0.279192E+00_JPRB, 0.266493E+00_JPRB, 0.254096E+00_JPRB, 0.242015E+00_JPRB &
  &, 0.230246E+00_JPRB, 0.218796E+00_JPRB, 0.207690E+00_JPRB &
  &, 0.196917E+00_JPRB, 0.186482E+00_JPRB, 0.176401E+00_JPRB, 0.166660E+00_JPRB &
  &, 0.157270E+00_JPRB, 0.148228E+00_JPRB, 0.139527E+00_JPRB &
  &, 0.131192E+00_JPRB, 0.123194E+00_JPRB, 0.115535E+00_JPRB, 0.108219E+00_JPRB &
  &, 0.101245E+00_JPRB, 0.946095E-01_JPRB, 0.882682E-01_JPRB &
  &, 0.822747E-01_JPRB, 0.765784E-01_JPRB, 0.711663E-01_JPRB, 0.660679E-01_JPRB &
  &, 0.612678E-01_JPRB, 0.567241E-01_JPRB, 0.524382E-01_JPRB &
  &, 0.484344E-01_JPRB, 0.446634E-01_JPRB, 0.411212E-01_JPRB, 0.378282E-01_JPRB &
  &, 0.347530E-01_JPRB, 0.318873E-01_JPRB, 0.291939E-01_JPRB &
  &, 0.267155E-01_JPRB, 0.244123E-01_JPRB, 0.222693E-01_JPRB, 0.202994E-01_JPRB &
  &, 0.184557E-01_JPRB, 0.167789E-01_JPRB, 0.152187E-01_JPRB &
  &, 0.137843E-01_JPRB, 0.124846E-01_JPRB, 0.112636E-01_JPRB, 0.101607E-01_JPRB &
  &, 0.918396E-02_JPRB, 0.823782E-02_JPRB, 0.743081E-02_JPRB &
  &, 0.666409E-02_JPRB, 0.597725E-02_JPRB, 0.533837E-02_JPRB, 0.475080E-02_JPRB &
  &, 0.425622E-02_JPRB, 0.378224E-02_JPRB, 0.337003E-02_JPRB &
  &, 0.298306E-02_JPRB, 0.266390E-02_JPRB, 0.237480E-02_JPRB, 0.207547E-02_JPRB &
  &, 0.185139E-02_JPRB, 0.161948E-02_JPRB, 0.142382E-02_JPRB &
  &, 0.126637E-02_JPRB, 0.110355E-02_JPRB, 0.981568E-03_JPRB, 0.855486E-03_JPRB &
  &, 0.725256E-03_JPRB, 0.639225E-03_JPRB, 0.550388E-03_JPRB &
  &, 0.458707E-03_JPRB, 0.414739E-03_JPRB, 0.369341E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 374, :) = (/ &
  &  0.964784E+00_JPRB, 0.955094E+00_JPRB, 0.945061E+00_JPRB, 0.934693E+00_JPRB &
  &, 0.923998E+00_JPRB, 0.912981E+00_JPRB, 0.901651E+00_JPRB &
  &, 0.890016E+00_JPRB, 0.878084E+00_JPRB, 0.865863E+00_JPRB, 0.853363E+00_JPRB &
  &, 0.840590E+00_JPRB, 0.827556E+00_JPRB, 0.814270E+00_JPRB &
  &, 0.800743E+00_JPRB, 0.786983E+00_JPRB, 0.773002E+00_JPRB, 0.758812E+00_JPRB &
  &, 0.744425E+00_JPRB, 0.729849E+00_JPRB, 0.715102E+00_JPRB &
  &, 0.700195E+00_JPRB, 0.685140E+00_JPRB, 0.669954E+00_JPRB, 0.654645E+00_JPRB &
  &, 0.639234E+00_JPRB, 0.623735E+00_JPRB, 0.608157E+00_JPRB &
  &, 0.592533E+00_JPRB, 0.576858E+00_JPRB, 0.561161E+00_JPRB, 0.545457E+00_JPRB &
  &, 0.529761E+00_JPRB, 0.514087E+00_JPRB, 0.498461E+00_JPRB &
  &, 0.482887E+00_JPRB, 0.467396E+00_JPRB, 0.452004E+00_JPRB, 0.436720E+00_JPRB &
  &, 0.421565E+00_JPRB, 0.406559E+00_JPRB, 0.391717E+00_JPRB &
  &, 0.377054E+00_JPRB, 0.362583E+00_JPRB, 0.348321E+00_JPRB, 0.334285E+00_JPRB &
  &, 0.320488E+00_JPRB, 0.306937E+00_JPRB, 0.293656E+00_JPRB &
  &, 0.280651E+00_JPRB, 0.267933E+00_JPRB, 0.255516E+00_JPRB, 0.243398E+00_JPRB &
  &, 0.231604E+00_JPRB, 0.220128E+00_JPRB, 0.208992E+00_JPRB &
  &, 0.198188E+00_JPRB, 0.187719E+00_JPRB, 0.177602E+00_JPRB, 0.167821E+00_JPRB &
  &, 0.158407E+00_JPRB, 0.149322E+00_JPRB, 0.140592E+00_JPRB &
  &, 0.132226E+00_JPRB, 0.124177E+00_JPRB, 0.116502E+00_JPRB, 0.109149E+00_JPRB &
  &, 0.102135E+00_JPRB, 0.954384E-01_JPRB, 0.890942E-01_JPRB &
  &, 0.830339E-01_JPRB, 0.773105E-01_JPRB, 0.718698E-01_JPRB, 0.667411E-01_JPRB &
  &, 0.618861E-01_JPRB, 0.573317E-01_JPRB, 0.530104E-01_JPRB &
  &, 0.489695E-01_JPRB, 0.451844E-01_JPRB, 0.416272E-01_JPRB, 0.382926E-01_JPRB &
  &, 0.351738E-01_JPRB, 0.322894E-01_JPRB, 0.295765E-01_JPRB &
  &, 0.270776E-01_JPRB, 0.247244E-01_JPRB, 0.225584E-01_JPRB, 0.205645E-01_JPRB &
  &, 0.187257E-01_JPRB, 0.170232E-01_JPRB, 0.154364E-01_JPRB &
  &, 0.140059E-01_JPRB, 0.126780E-01_JPRB, 0.114605E-01_JPRB, 0.103277E-01_JPRB &
  &, 0.931987E-02_JPRB, 0.837610E-02_JPRB, 0.753632E-02_JPRB &
  &, 0.677142E-02_JPRB, 0.608640E-02_JPRB, 0.544938E-02_JPRB, 0.486368E-02_JPRB &
  &, 0.433273E-02_JPRB, 0.386001E-02_JPRB, 0.344909E-02_JPRB &
  &, 0.306341E-02_JPRB, 0.270473E-02_JPRB, 0.241629E-02_JPRB, 0.211762E-02_JPRB &
  &, 0.189421E-02_JPRB, 0.166298E-02_JPRB, 0.146800E-02_JPRB &
  &, 0.126637E-02_JPRB, 0.114912E-02_JPRB, 0.981568E-03_JPRB, 0.855486E-03_JPRB &
  &, 0.772939E-03_JPRB, 0.639225E-03_JPRB, 0.550388E-03_JPRB &
  &, 0.508563E-03_JPRB, 0.414739E-03_JPRB, 0.369341E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.173087E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.674857E-04_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 375, :) = (/ &
  &  0.965044E+00_JPRB, 0.955415E+00_JPRB, 0.945443E+00_JPRB, 0.935136E+00_JPRB &
  &, 0.924499E+00_JPRB, 0.913541E+00_JPRB, 0.902269E+00_JPRB &
  &, 0.890690E+00_JPRB, 0.878812E+00_JPRB, 0.866646E+00_JPRB, 0.854192E+00_JPRB &
  &, 0.841475E+00_JPRB, 0.828491E+00_JPRB, 0.815253E+00_JPRB &
  &, 0.801772E+00_JPRB, 0.788059E+00_JPRB, 0.774121E+00_JPRB, 0.759973E+00_JPRB &
  &, 0.745625E+00_JPRB, 0.731089E+00_JPRB, 0.716379E+00_JPRB &
  &, 0.701508E+00_JPRB, 0.686484E+00_JPRB, 0.671328E+00_JPRB, 0.656052E+00_JPRB &
  &, 0.640667E+00_JPRB, 0.625195E+00_JPRB, 0.609645E+00_JPRB &
  &, 0.594034E+00_JPRB, 0.578380E+00_JPRB, 0.562701E+00_JPRB, 0.547010E+00_JPRB &
  &, 0.531327E+00_JPRB, 0.515667E+00_JPRB, 0.500049E+00_JPRB &
  &, 0.484487E+00_JPRB, 0.468998E+00_JPRB, 0.453608E+00_JPRB, 0.438324E+00_JPRB &
  &, 0.423168E+00_JPRB, 0.408161E+00_JPRB, 0.393305E+00_JPRB &
  &, 0.378637E+00_JPRB, 0.364150E+00_JPRB, 0.349881E+00_JPRB, 0.335823E+00_JPRB &
  &, 0.322016E+00_JPRB, 0.308451E+00_JPRB, 0.295144E+00_JPRB &
  &, 0.282122E+00_JPRB, 0.269373E+00_JPRB, 0.256936E+00_JPRB, 0.244796E+00_JPRB &
  &, 0.232977E+00_JPRB, 0.221474E+00_JPRB, 0.210295E+00_JPRB &
  &, 0.199459E+00_JPRB, 0.188956E+00_JPRB, 0.178803E+00_JPRB, 0.169000E+00_JPRB &
  &, 0.159545E+00_JPRB, 0.150433E+00_JPRB, 0.141657E+00_JPRB &
  &, 0.133243E+00_JPRB, 0.125178E+00_JPRB, 0.117450E+00_JPRB, 0.110079E+00_JPRB &
  &, 0.103026E+00_JPRB, 0.962876E-01_JPRB, 0.898995E-01_JPRB &
  &, 0.838142E-01_JPRB, 0.780641E-01_JPRB, 0.725952E-01_JPRB, 0.674142E-01_JPRB &
  &, 0.625273E-01_JPRB, 0.579393E-01_JPRB, 0.535826E-01_JPRB &
  &, 0.495289E-01_JPRB, 0.456805E-01_JPRB, 0.421078E-01_JPRB, 0.387569E-01_JPRB &
  &, 0.356209E-01_JPRB, 0.326916E-01_JPRB, 0.299590E-01_JPRB &
  &, 0.274117E-01_JPRB, 0.250649E-01_JPRB, 0.228764E-01_JPRB, 0.208589E-01_JPRB &
  &, 0.189956E-01_JPRB, 0.172676E-01_JPRB, 0.156853E-01_JPRB &
  &, 0.142276E-01_JPRB, 0.128714E-01_JPRB, 0.116245E-01_JPRB, 0.104946E-01_JPRB &
  &, 0.948976E-02_JPRB, 0.854896E-02_JPRB, 0.767700E-02_JPRB &
  &, 0.687874E-02_JPRB, 0.619556E-02_JPRB, 0.552338E-02_JPRB, 0.493893E-02_JPRB &
  &, 0.440924E-02_JPRB, 0.393779E-02_JPRB, 0.352815E-02_JPRB &
  &, 0.310359E-02_JPRB, 0.278638E-02_JPRB, 0.245778E-02_JPRB, 0.215977E-02_JPRB &
  &, 0.193703E-02_JPRB, 0.170648E-02_JPRB, 0.151219E-02_JPRB &
  &, 0.131124E-02_JPRB, 0.114912E-02_JPRB, 0.102783E-02_JPRB, 0.902457E-03_JPRB &
  &, 0.772939E-03_JPRB, 0.687627E-03_JPRB, 0.599514E-03_JPRB &
  &, 0.508563E-03_JPRB, 0.414739E-03_JPRB, 0.369341E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 376, :) = (/ &
  &  0.965302E+00_JPRB, 0.955736E+00_JPRB, 0.945824E+00_JPRB, 0.935578E+00_JPRB &
  &, 0.925001E+00_JPRB, 0.914101E+00_JPRB, 0.902886E+00_JPRB &
  &, 0.891363E+00_JPRB, 0.879541E+00_JPRB, 0.867428E+00_JPRB, 0.855032E+00_JPRB &
  &, 0.842361E+00_JPRB, 0.829426E+00_JPRB, 0.816237E+00_JPRB &
  &, 0.802803E+00_JPRB, 0.789134E+00_JPRB, 0.775240E+00_JPRB, 0.761134E+00_JPRB &
  &, 0.746827E+00_JPRB, 0.732329E+00_JPRB, 0.717657E+00_JPRB &
  &, 0.702817E+00_JPRB, 0.687830E+00_JPRB, 0.672706E+00_JPRB, 0.657459E+00_JPRB &
  &, 0.642104E+00_JPRB, 0.626655E+00_JPRB, 0.611126E+00_JPRB &
  &, 0.595540E+00_JPRB, 0.579907E+00_JPRB, 0.564245E+00_JPRB, 0.548568E+00_JPRB &
  &, 0.532898E+00_JPRB, 0.517246E+00_JPRB, 0.501636E+00_JPRB &
  &, 0.486077E+00_JPRB, 0.470600E+00_JPRB, 0.455211E+00_JPRB, 0.439929E+00_JPRB &
  &, 0.424772E+00_JPRB, 0.409752E+00_JPRB, 0.394893E+00_JPRB &
  &, 0.380221E+00_JPRB, 0.365728E+00_JPRB, 0.351440E+00_JPRB, 0.337373E+00_JPRB &
  &, 0.323543E+00_JPRB, 0.309954E+00_JPRB, 0.296632E+00_JPRB &
  &, 0.283594E+00_JPRB, 0.270826E+00_JPRB, 0.258355E+00_JPRB, 0.246193E+00_JPRB &
  &, 0.234335E+00_JPRB, 0.222806E+00_JPRB, 0.211612E+00_JPRB &
  &, 0.200745E+00_JPRB, 0.190209E+00_JPRB, 0.180019E+00_JPRB, 0.170178E+00_JPRB &
  &, 0.160682E+00_JPRB, 0.151544E+00_JPRB, 0.142740E+00_JPRB &
  &, 0.134295E+00_JPRB, 0.126180E+00_JPRB, 0.118417E+00_JPRB, 0.110989E+00_JPRB &
  &, 0.103916E+00_JPRB, 0.971569E-01_JPRB, 0.907255E-01_JPRB &
  &, 0.846155E-01_JPRB, 0.787962E-01_JPRB, 0.732986E-01_JPRB, 0.681098E-01_JPRB &
  &, 0.631914E-01_JPRB, 0.585468E-01_JPRB, 0.541787E-01_JPRB &
  &, 0.500640E-01_JPRB, 0.462015E-01_JPRB, 0.425885E-01_JPRB, 0.391955E-01_JPRB &
  &, 0.360417E-01_JPRB, 0.330937E-01_JPRB, 0.303416E-01_JPRB &
  &, 0.277737E-01_JPRB, 0.254054E-01_JPRB, 0.231944E-01_JPRB, 0.211534E-01_JPRB &
  &, 0.192655E-01_JPRB, 0.175119E-01_JPRB, 0.159030E-01_JPRB &
  &, 0.144176E-01_JPRB, 0.130648E-01_JPRB, 0.118214E-01_JPRB, 0.106950E-01_JPRB &
  &, 0.962567E-02_JPRB, 0.868724E-02_JPRB, 0.781768E-02_JPRB &
  &, 0.702184E-02_JPRB, 0.630472E-02_JPRB, 0.563439E-02_JPRB, 0.505181E-02_JPRB &
  &, 0.448575E-02_JPRB, 0.401557E-02_JPRB, 0.356768E-02_JPRB &
  &, 0.318394E-02_JPRB, 0.282721E-02_JPRB, 0.249927E-02_JPRB, 0.220192E-02_JPRB &
  &, 0.197986E-02_JPRB, 0.174998E-02_JPRB, 0.151219E-02_JPRB &
  &, 0.135611E-02_JPRB, 0.119468E-02_JPRB, 0.102783E-02_JPRB, 0.902457E-03_JPRB &
  &, 0.772939E-03_JPRB, 0.687627E-03_JPRB, 0.599514E-03_JPRB &
  &, 0.508563E-03_JPRB, 0.465332E-03_JPRB, 0.369341E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.224386E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.121824E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 377, :) = (/ &
  &  0.965560E+00_JPRB, 0.956056E+00_JPRB, 0.946205E+00_JPRB, 0.936020E+00_JPRB &
  &, 0.925502E+00_JPRB, 0.914661E+00_JPRB, 0.903503E+00_JPRB &
  &, 0.892036E+00_JPRB, 0.880269E+00_JPRB, 0.868209E+00_JPRB, 0.855865E+00_JPRB &
  &, 0.843246E+00_JPRB, 0.830361E+00_JPRB, 0.817220E+00_JPRB &
  &, 0.803832E+00_JPRB, 0.790208E+00_JPRB, 0.776359E+00_JPRB, 0.762295E+00_JPRB &
  &, 0.748029E+00_JPRB, 0.733570E+00_JPRB, 0.718934E+00_JPRB &
  &, 0.704130E+00_JPRB, 0.689176E+00_JPRB, 0.674084E+00_JPRB, 0.658865E+00_JPRB &
  &, 0.643537E+00_JPRB, 0.628115E+00_JPRB, 0.612610E+00_JPRB &
  &, 0.597045E+00_JPRB, 0.581434E+00_JPRB, 0.565785E+00_JPRB, 0.550125E+00_JPRB &
  &, 0.534469E+00_JPRB, 0.518830E+00_JPRB, 0.503228E+00_JPRB &
  &, 0.487677E+00_JPRB, 0.472202E+00_JPRB, 0.456815E+00_JPRB, 0.441533E+00_JPRB &
  &, 0.426375E+00_JPRB, 0.411354E+00_JPRB, 0.396492E+00_JPRB &
  &, 0.381805E+00_JPRB, 0.367305E+00_JPRB, 0.352999E+00_JPRB, 0.338923E+00_JPRB &
  &, 0.325071E+00_JPRB, 0.311469E+00_JPRB, 0.298133E+00_JPRB &
  &, 0.285066E+00_JPRB, 0.272280E+00_JPRB, 0.259789E+00_JPRB, 0.247590E+00_JPRB &
  &, 0.235708E+00_JPRB, 0.224152E+00_JPRB, 0.212929E+00_JPRB &
  &, 0.202016E+00_JPRB, 0.191461E+00_JPRB, 0.181236E+00_JPRB, 0.171356E+00_JPRB &
  &, 0.161836E+00_JPRB, 0.152655E+00_JPRB, 0.143823E+00_JPRB &
  &, 0.135329E+00_JPRB, 0.127200E+00_JPRB, 0.119384E+00_JPRB, 0.111939E+00_JPRB &
  &, 0.104807E+00_JPRB, 0.980061E-01_JPRB, 0.915515E-01_JPRB &
  &, 0.853958E-01_JPRB, 0.795498E-01_JPRB, 0.740240E-01_JPRB, 0.687830E-01_JPRB &
  &, 0.638326E-01_JPRB, 0.591544E-01_JPRB, 0.547509E-01_JPRB &
  &, 0.506234E-01_JPRB, 0.467472E-01_JPRB, 0.430945E-01_JPRB, 0.396856E-01_JPRB &
  &, 0.364889E-01_JPRB, 0.334959E-01_JPRB, 0.307241E-01_JPRB &
  &, 0.281358E-01_JPRB, 0.257459E-01_JPRB, 0.235124E-01_JPRB, 0.214479E-01_JPRB &
  &, 0.195355E-01_JPRB, 0.177868E-01_JPRB, 0.161518E-01_JPRB &
  &, 0.146392E-01_JPRB, 0.132582E-01_JPRB, 0.120182E-01_JPRB, 0.108619E-01_JPRB &
  &, 0.979555E-02_JPRB, 0.882552E-02_JPRB, 0.792318E-02_JPRB &
  &, 0.712916E-02_JPRB, 0.641387E-02_JPRB, 0.574540E-02_JPRB, 0.512706E-02_JPRB &
  &, 0.460051E-02_JPRB, 0.409335E-02_JPRB, 0.364674E-02_JPRB &
  &, 0.326430E-02_JPRB, 0.286804E-02_JPRB, 0.254076E-02_JPRB, 0.228623E-02_JPRB &
  &, 0.202268E-02_JPRB, 0.174998E-02_JPRB, 0.155637E-02_JPRB &
  &, 0.135611E-02_JPRB, 0.119468E-02_JPRB, 0.107410E-02_JPRB, 0.949429E-03_JPRB &
  &, 0.820623E-03_JPRB, 0.687627E-03_JPRB, 0.599514E-03_JPRB &
  &, 0.558419E-03_JPRB, 0.465332E-03_JPRB, 0.420676E-03_JPRB, 0.322495E-03_JPRB &
  &, 0.274183E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.177736E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 378, :) = (/ &
  &  0.965818E+00_JPRB, 0.956375E+00_JPRB, 0.946587E+00_JPRB, 0.936462E+00_JPRB &
  &, 0.926004E+00_JPRB, 0.915220E+00_JPRB, 0.904119E+00_JPRB &
  &, 0.892709E+00_JPRB, 0.880997E+00_JPRB, 0.868991E+00_JPRB, 0.856700E+00_JPRB &
  &, 0.844131E+00_JPRB, 0.831297E+00_JPRB, 0.818203E+00_JPRB &
  &, 0.804863E+00_JPRB, 0.791283E+00_JPRB, 0.777478E+00_JPRB, 0.763456E+00_JPRB &
  &, 0.749231E+00_JPRB, 0.734810E+00_JPRB, 0.720212E+00_JPRB &
  &, 0.705443E+00_JPRB, 0.690523E+00_JPRB, 0.675462E+00_JPRB, 0.660272E+00_JPRB &
  &, 0.644974E+00_JPRB, 0.629576E+00_JPRB, 0.614099E+00_JPRB &
  &, 0.598554E+00_JPRB, 0.582960E+00_JPRB, 0.567334E+00_JPRB, 0.551687E+00_JPRB &
  &, 0.536044E+00_JPRB, 0.520418E+00_JPRB, 0.504825E+00_JPRB &
  &, 0.489277E+00_JPRB, 0.473814E+00_JPRB, 0.458428E+00_JPRB, 0.443147E+00_JPRB &
  &, 0.427979E+00_JPRB, 0.412956E+00_JPRB, 0.398091E+00_JPRB &
  &, 0.383388E+00_JPRB, 0.368883E+00_JPRB, 0.354569E+00_JPRB, 0.340473E+00_JPRB &
  &, 0.326610E+00_JPRB, 0.312996E+00_JPRB, 0.299634E+00_JPRB &
  &, 0.286537E+00_JPRB, 0.273733E+00_JPRB, 0.261222E+00_JPRB, 0.249002E+00_JPRB &
  &, 0.237095E+00_JPRB, 0.225513E+00_JPRB, 0.214247E+00_JPRB &
  &, 0.203318E+00_JPRB, 0.192714E+00_JPRB, 0.182469E+00_JPRB, 0.172551E+00_JPRB &
  &, 0.162991E+00_JPRB, 0.153766E+00_JPRB, 0.144905E+00_JPRB &
  &, 0.136382E+00_JPRB, 0.128202E+00_JPRB, 0.120370E+00_JPRB, 0.112868E+00_JPRB &
  &, 0.105718E+00_JPRB, 0.988755E-01_JPRB, 0.923776E-01_JPRB &
  &, 0.861971E-01_JPRB, 0.803250E-01_JPRB, 0.747494E-01_JPRB, 0.694785E-01_JPRB &
  &, 0.644967E-01_JPRB, 0.597853E-01_JPRB, 0.553469E-01_JPRB &
  &, 0.511828E-01_JPRB, 0.472682E-01_JPRB, 0.436005E-01_JPRB, 0.401499E-01_JPRB &
  &, 0.369360E-01_JPRB, 0.339249E-01_JPRB, 0.311067E-01_JPRB &
  &, 0.284978E-01_JPRB, 0.260864E-01_JPRB, 0.238304E-01_JPRB, 0.217424E-01_JPRB &
  &, 0.198054E-01_JPRB, 0.180312E-01_JPRB, 0.164006E-01_JPRB &
  &, 0.148609E-01_JPRB, 0.134839E-01_JPRB, 0.122151E-01_JPRB, 0.110289E-01_JPRB &
  &, 0.996544E-02_JPRB, 0.896381E-02_JPRB, 0.806386E-02_JPRB &
  &, 0.727226E-02_JPRB, 0.652303E-02_JPRB, 0.585640E-02_JPRB, 0.523993E-02_JPRB &
  &, 0.467702E-02_JPRB, 0.417113E-02_JPRB, 0.372580E-02_JPRB &
  &, 0.330447E-02_JPRB, 0.294970E-02_JPRB, 0.262373E-02_JPRB, 0.232838E-02_JPRB &
  &, 0.206550E-02_JPRB, 0.179348E-02_JPRB, 0.160055E-02_JPRB &
  &, 0.140098E-02_JPRB, 0.124025E-02_JPRB, 0.107410E-02_JPRB, 0.949429E-03_JPRB &
  &, 0.820623E-03_JPRB, 0.736029E-03_JPRB, 0.648640E-03_JPRB &
  &, 0.558419E-03_JPRB, 0.465332E-03_JPRB, 0.420676E-03_JPRB, 0.374578E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.177736E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART54',1,ZHOOK_HANDLE)
END SUBROUTINE PART54

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART55

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART55',0,ZHOOK_HANDLE)

XCW( 379, :) = (/ &
  &  0.966075E+00_JPRB, 0.956695E+00_JPRB, 0.946967E+00_JPRB, 0.936903E+00_JPRB &
  &, 0.926504E+00_JPRB, 0.915779E+00_JPRB, 0.904737E+00_JPRB &
  &, 0.893382E+00_JPRB, 0.881725E+00_JPRB, 0.869773E+00_JPRB, 0.857533E+00_JPRB &
  &, 0.845016E+00_JPRB, 0.832232E+00_JPRB, 0.819187E+00_JPRB &
  &, 0.805892E+00_JPRB, 0.792358E+00_JPRB, 0.778597E+00_JPRB, 0.764618E+00_JPRB &
  &, 0.750432E+00_JPRB, 0.736051E+00_JPRB, 0.721489E+00_JPRB &
  &, 0.706756E+00_JPRB, 0.691869E+00_JPRB, 0.676840E+00_JPRB, 0.661682E+00_JPRB &
  &, 0.646410E+00_JPRB, 0.631040E+00_JPRB, 0.615583E+00_JPRB &
  &, 0.600064E+00_JPRB, 0.584487E+00_JPRB, 0.568878E+00_JPRB, 0.553249E+00_JPRB &
  &, 0.537619E+00_JPRB, 0.522002E+00_JPRB, 0.506422E+00_JPRB &
  &, 0.490886E+00_JPRB, 0.475416E+00_JPRB, 0.460032E+00_JPRB, 0.444761E+00_JPRB &
  &, 0.429592E+00_JPRB, 0.414568E+00_JPRB, 0.399690E+00_JPRB &
  &, 0.384983E+00_JPRB, 0.370461E+00_JPRB, 0.356140E+00_JPRB, 0.342035E+00_JPRB &
  &, 0.328162E+00_JPRB, 0.314524E+00_JPRB, 0.301135E+00_JPRB &
  &, 0.288022E+00_JPRB, 0.275200E+00_JPRB, 0.262656E+00_JPRB, 0.250413E+00_JPRB &
  &, 0.238483E+00_JPRB, 0.226859E+00_JPRB, 0.215564E+00_JPRB &
  &, 0.204604E+00_JPRB, 0.193983E+00_JPRB, 0.183702E+00_JPRB, 0.173746E+00_JPRB &
  &, 0.164145E+00_JPRB, 0.154895E+00_JPRB, 0.145988E+00_JPRB &
  &, 0.137434E+00_JPRB, 0.129222E+00_JPRB, 0.121355E+00_JPRB, 0.113818E+00_JPRB &
  &, 0.106628E+00_JPRB, 0.997651E-01_JPRB, 0.932242E-01_JPRB &
  &, 0.869985E-01_JPRB, 0.810786E-01_JPRB, 0.754748E-01_JPRB, 0.701741E-01_JPRB &
  &, 0.651608E-01_JPRB, 0.604163E-01_JPRB, 0.559430E-01_JPRB &
  &, 0.517422E-01_JPRB, 0.477891E-01_JPRB, 0.440812E-01_JPRB, 0.406143E-01_JPRB &
  &, 0.373831E-01_JPRB, 0.343270E-01_JPRB, 0.315166E-01_JPRB &
  &, 0.288876E-01_JPRB, 0.264269E-01_JPRB, 0.241484E-01_JPRB, 0.220369E-01_JPRB &
  &, 0.201053E-01_JPRB, 0.183061E-01_JPRB, 0.166183E-01_JPRB &
  &, 0.150825E-01_JPRB, 0.136773E-01_JPRB, 0.123791E-01_JPRB, 0.111958E-01_JPRB &
  &, 0.101014E-01_JPRB, 0.913666E-02_JPRB, 0.820454E-02_JPRB &
  &, 0.737959E-02_JPRB, 0.663219E-02_JPRB, 0.593041E-02_JPRB, 0.531518E-02_JPRB &
  &, 0.475353E-02_JPRB, 0.424891E-02_JPRB, 0.380486E-02_JPRB &
  &, 0.338483E-02_JPRB, 0.299053E-02_JPRB, 0.266522E-02_JPRB, 0.237053E-02_JPRB &
  &, 0.210832E-02_JPRB, 0.183698E-02_JPRB, 0.164473E-02_JPRB &
  &, 0.144585E-02_JPRB, 0.128581E-02_JPRB, 0.112036E-02_JPRB, 0.996400E-03_JPRB &
  &, 0.868307E-03_JPRB, 0.736029E-03_JPRB, 0.648640E-03_JPRB &
  &, 0.558419E-03_JPRB, 0.465332E-03_JPRB, 0.420676E-03_JPRB, 0.374578E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.177736E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.682814E-04_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 380, :) = (/ &
  &  0.966332E+00_JPRB, 0.957014E+00_JPRB, 0.947349E+00_JPRB, 0.937345E+00_JPRB &
  &, 0.927005E+00_JPRB, 0.916339E+00_JPRB, 0.905353E+00_JPRB &
  &, 0.894054E+00_JPRB, 0.882453E+00_JPRB, 0.870554E+00_JPRB, 0.858368E+00_JPRB &
  &, 0.845901E+00_JPRB, 0.833166E+00_JPRB, 0.820170E+00_JPRB &
  &, 0.806923E+00_JPRB, 0.793435E+00_JPRB, 0.779716E+00_JPRB, 0.765780E+00_JPRB &
  &, 0.751634E+00_JPRB, 0.737291E+00_JPRB, 0.722767E+00_JPRB &
  &, 0.708072E+00_JPRB, 0.693219E+00_JPRB, 0.678221E+00_JPRB, 0.663093E+00_JPRB &
  &, 0.647847E+00_JPRB, 0.632504E+00_JPRB, 0.617071E+00_JPRB &
  &, 0.601573E+00_JPRB, 0.586018E+00_JPRB, 0.570426E+00_JPRB, 0.554815E+00_JPRB &
  &, 0.539198E+00_JPRB, 0.523595E+00_JPRB, 0.508018E+00_JPRB &
  &, 0.492495E+00_JPRB, 0.477028E+00_JPRB, 0.461655E+00_JPRB, 0.446375E+00_JPRB &
  &, 0.431206E+00_JPRB, 0.416180E+00_JPRB, 0.401300E+00_JPRB &
  &, 0.386589E+00_JPRB, 0.372050E+00_JPRB, 0.357722E+00_JPRB, 0.343597E+00_JPRB &
  &, 0.329701E+00_JPRB, 0.316051E+00_JPRB, 0.302648E+00_JPRB &
  &, 0.289520E+00_JPRB, 0.276667E+00_JPRB, 0.264089E+00_JPRB, 0.251824E+00_JPRB &
  &, 0.239870E+00_JPRB, 0.228220E+00_JPRB, 0.216897E+00_JPRB &
  &, 0.205906E+00_JPRB, 0.195251E+00_JPRB, 0.184935E+00_JPRB, 0.174958E+00_JPRB &
  &, 0.165316E+00_JPRB, 0.156040E+00_JPRB, 0.147089E+00_JPRB &
  &, 0.138505E+00_JPRB, 0.130242E+00_JPRB, 0.122341E+00_JPRB, 0.114767E+00_JPRB &
  &, 0.107538E+00_JPRB, 0.100634E+00_JPRB, 0.940502E-01_JPRB &
  &, 0.877998E-01_JPRB, 0.818538E-01_JPRB, 0.762222E-01_JPRB, 0.708697E-01_JPRB &
  &, 0.658249E-01_JPRB, 0.610472E-01_JPRB, 0.565629E-01_JPRB &
  &, 0.523259E-01_JPRB, 0.483349E-01_JPRB, 0.446125E-01_JPRB, 0.411044E-01_JPRB &
  &, 0.378302E-01_JPRB, 0.347560E-01_JPRB, 0.318991E-01_JPRB &
  &, 0.292496E-01_JPRB, 0.267674E-01_JPRB, 0.244664E-01_JPRB, 0.223608E-01_JPRB &
  &, 0.203753E-01_JPRB, 0.185504E-01_JPRB, 0.168671E-01_JPRB &
  &, 0.153358E-01_JPRB, 0.139029E-01_JPRB, 0.125760E-01_JPRB, 0.113962E-01_JPRB &
  &, 0.102712E-01_JPRB, 0.927494E-02_JPRB, 0.834522E-02_JPRB &
  &, 0.752269E-02_JPRB, 0.674134E-02_JPRB, 0.604142E-02_JPRB, 0.542806E-02_JPRB &
  &, 0.486829E-02_JPRB, 0.432668E-02_JPRB, 0.388392E-02_JPRB &
  &, 0.346518E-02_JPRB, 0.307219E-02_JPRB, 0.270671E-02_JPRB, 0.241269E-02_JPRB &
  &, 0.215115E-02_JPRB, 0.188048E-02_JPRB, 0.168891E-02_JPRB &
  &, 0.149072E-02_JPRB, 0.128581E-02_JPRB, 0.112036E-02_JPRB, 0.996400E-03_JPRB &
  &, 0.868307E-03_JPRB, 0.784431E-03_JPRB, 0.648640E-03_JPRB &
  &, 0.558419E-03_JPRB, 0.515924E-03_JPRB, 0.420676E-03_JPRB, 0.374578E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.175403E-03_JPRB, 0.177736E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 381, :) = (/ &
  &  0.966588E+00_JPRB, 0.957334E+00_JPRB, 0.947729E+00_JPRB, 0.937786E+00_JPRB &
  &, 0.927506E+00_JPRB, 0.916898E+00_JPRB, 0.905969E+00_JPRB &
  &, 0.894726E+00_JPRB, 0.883180E+00_JPRB, 0.871335E+00_JPRB, 0.859201E+00_JPRB &
  &, 0.846786E+00_JPRB, 0.834101E+00_JPRB, 0.821153E+00_JPRB &
  &, 0.807953E+00_JPRB, 0.794511E+00_JPRB, 0.780837E+00_JPRB, 0.766942E+00_JPRB &
  &, 0.752837E+00_JPRB, 0.738535E+00_JPRB, 0.724048E+00_JPRB &
  &, 0.709385E+00_JPRB, 0.694565E+00_JPRB, 0.679602E+00_JPRB, 0.664503E+00_JPRB &
  &, 0.649288E+00_JPRB, 0.633968E+00_JPRB, 0.618564E+00_JPRB &
  &, 0.603086E+00_JPRB, 0.587548E+00_JPRB, 0.571978E+00_JPRB, 0.556381E+00_JPRB &
  &, 0.540778E+00_JPRB, 0.525188E+00_JPRB, 0.509619E+00_JPRB &
  &, 0.494104E+00_JPRB, 0.478649E+00_JPRB, 0.463269E+00_JPRB, 0.447989E+00_JPRB &
  &, 0.432830E+00_JPRB, 0.417793E+00_JPRB, 0.402909E+00_JPRB &
  &, 0.388184E+00_JPRB, 0.373640E+00_JPRB, 0.359305E+00_JPRB, 0.345159E+00_JPRB &
  &, 0.331253E+00_JPRB, 0.317578E+00_JPRB, 0.304162E+00_JPRB &
  &, 0.291018E+00_JPRB, 0.278134E+00_JPRB, 0.265537E+00_JPRB, 0.253250E+00_JPRB &
  &, 0.241257E+00_JPRB, 0.229581E+00_JPRB, 0.218229E+00_JPRB &
  &, 0.207208E+00_JPRB, 0.196520E+00_JPRB, 0.186168E+00_JPRB, 0.176153E+00_JPRB &
  &, 0.166488E+00_JPRB, 0.157169E+00_JPRB, 0.148189E+00_JPRB &
  &, 0.139558E+00_JPRB, 0.131281E+00_JPRB, 0.123327E+00_JPRB, 0.115735E+00_JPRB &
  &, 0.108449E+00_JPRB, 0.101524E+00_JPRB, 0.948969E-01_JPRB &
  &, 0.886012E-01_JPRB, 0.826289E-01_JPRB, 0.769477E-01_JPRB, 0.715877E-01_JPRB &
  &, 0.664890E-01_JPRB, 0.616781E-01_JPRB, 0.571589E-01_JPRB &
  &, 0.528853E-01_JPRB, 0.488807E-01_JPRB, 0.451184E-01_JPRB, 0.415946E-01_JPRB &
  &, 0.382773E-01_JPRB, 0.351849E-01_JPRB, 0.323090E-01_JPRB &
  &, 0.296395E-01_JPRB, 0.271363E-01_JPRB, 0.248133E-01_JPRB, 0.226553E-01_JPRB &
  &, 0.206752E-01_JPRB, 0.188253E-01_JPRB, 0.171159E-01_JPRB &
  &, 0.155575E-01_JPRB, 0.140963E-01_JPRB, 0.127728E-01_JPRB, 0.115631E-01_JPRB &
  &, 0.104411E-01_JPRB, 0.941323E-02_JPRB, 0.848590E-02_JPRB &
  &, 0.763001E-02_JPRB, 0.688689E-02_JPRB, 0.615242E-02_JPRB, 0.554094E-02_JPRB &
  &, 0.494480E-02_JPRB, 0.440446E-02_JPRB, 0.396298E-02_JPRB &
  &, 0.350536E-02_JPRB, 0.311302E-02_JPRB, 0.278968E-02_JPRB, 0.245484E-02_JPRB &
  &, 0.219397E-02_JPRB, 0.192398E-02_JPRB, 0.168891E-02_JPRB &
  &, 0.149072E-02_JPRB, 0.133138E-02_JPRB, 0.116663E-02_JPRB, 0.104337E-02_JPRB &
  &, 0.915991E-03_JPRB, 0.784431E-03_JPRB, 0.697766E-03_JPRB &
  &, 0.608276E-03_JPRB, 0.515924E-03_JPRB, 0.472010E-03_JPRB, 0.374578E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.177736E-03_JPRB, 0.123392E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 382, :) = (/ &
  &  0.966846E+00_JPRB, 0.957654E+00_JPRB, 0.948110E+00_JPRB, 0.938227E+00_JPRB &
  &, 0.928005E+00_JPRB, 0.917456E+00_JPRB, 0.906585E+00_JPRB &
  &, 0.895399E+00_JPRB, 0.883907E+00_JPRB, 0.872116E+00_JPRB, 0.860034E+00_JPRB &
  &, 0.847672E+00_JPRB, 0.835035E+00_JPRB, 0.822136E+00_JPRB &
  &, 0.808982E+00_JPRB, 0.795586E+00_JPRB, 0.781956E+00_JPRB, 0.768104E+00_JPRB &
  &, 0.754041E+00_JPRB, 0.739775E+00_JPRB, 0.725325E+00_JPRB &
  &, 0.710701E+00_JPRB, 0.695915E+00_JPRB, 0.680983E+00_JPRB, 0.665913E+00_JPRB &
  &, 0.650728E+00_JPRB, 0.635436E+00_JPRB, 0.620052E+00_JPRB &
  &, 0.604599E+00_JPRB, 0.589083E+00_JPRB, 0.573527E+00_JPRB, 0.557947E+00_JPRB &
  &, 0.542357E+00_JPRB, 0.526780E+00_JPRB, 0.511225E+00_JPRB &
  &, 0.495713E+00_JPRB, 0.480261E+00_JPRB, 0.464892E+00_JPRB, 0.449613E+00_JPRB &
  &, 0.434444E+00_JPRB, 0.419405E+00_JPRB, 0.404519E+00_JPRB &
  &, 0.389789E+00_JPRB, 0.375240E+00_JPRB, 0.360887E+00_JPRB, 0.346733E+00_JPRB &
  &, 0.332805E+00_JPRB, 0.319118E+00_JPRB, 0.305688E+00_JPRB &
  &, 0.292516E+00_JPRB, 0.279615E+00_JPRB, 0.266998E+00_JPRB, 0.254676E+00_JPRB &
  &, 0.242659E+00_JPRB, 0.230957E+00_JPRB, 0.219577E+00_JPRB &
  &, 0.208525E+00_JPRB, 0.197804E+00_JPRB, 0.187418E+00_JPRB, 0.177381E+00_JPRB &
  &, 0.167676E+00_JPRB, 0.158314E+00_JPRB, 0.149307E+00_JPRB &
  &, 0.140628E+00_JPRB, 0.132320E+00_JPRB, 0.124332E+00_JPRB, 0.116685E+00_JPRB &
  &, 0.109379E+00_JPRB, 0.102414E+00_JPRB, 0.957641E-01_JPRB &
  &, 0.894236E-01_JPRB, 0.834041E-01_JPRB, 0.776950E-01_JPRB, 0.722833E-01_JPRB &
  &, 0.671760E-01_JPRB, 0.623324E-01_JPRB, 0.577788E-01_JPRB &
  &, 0.534690E-01_JPRB, 0.494264E-01_JPRB, 0.456244E-01_JPRB, 0.420847E-01_JPRB &
  &, 0.387507E-01_JPRB, 0.356139E-01_JPRB, 0.327189E-01_JPRB &
  &, 0.300015E-01_JPRB, 0.274768E-01_JPRB, 0.251313E-01_JPRB, 0.229792E-01_JPRB &
  &, 0.209451E-01_JPRB, 0.191002E-01_JPRB, 0.173647E-01_JPRB &
  &, 0.157792E-01_JPRB, 0.143220E-01_JPRB, 0.129697E-01_JPRB, 0.117635E-01_JPRB &
  &, 0.106110E-01_JPRB, 0.958608E-02_JPRB, 0.862658E-02_JPRB &
  &, 0.777311E-02_JPRB, 0.699604E-02_JPRB, 0.626343E-02_JPRB, 0.561619E-02_JPRB &
  &, 0.502131E-02_JPRB, 0.452113E-02_JPRB, 0.400251E-02_JPRB &
  &, 0.358571E-02_JPRB, 0.319468E-02_JPRB, 0.283117E-02_JPRB, 0.249699E-02_JPRB &
  &, 0.223679E-02_JPRB, 0.196748E-02_JPRB, 0.173310E-02_JPRB &
  &, 0.153559E-02_JPRB, 0.137694E-02_JPRB, 0.121289E-02_JPRB, 0.104337E-02_JPRB &
  &, 0.915991E-03_JPRB, 0.784431E-03_JPRB, 0.697766E-03_JPRB &
  &, 0.608276E-03_JPRB, 0.515924E-03_JPRB, 0.472010E-03_JPRB, 0.374578E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.227450E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.177736E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 383, :) = (/ &
  &  0.967104E+00_JPRB, 0.957972E+00_JPRB, 0.948490E+00_JPRB, 0.938667E+00_JPRB &
  &, 0.928505E+00_JPRB, 0.918015E+00_JPRB, 0.907201E+00_JPRB &
  &, 0.896071E+00_JPRB, 0.884634E+00_JPRB, 0.872897E+00_JPRB, 0.860868E+00_JPRB &
  &, 0.848555E+00_JPRB, 0.835969E+00_JPRB, 0.823120E+00_JPRB &
  &, 0.810013E+00_JPRB, 0.796663E+00_JPRB, 0.783077E+00_JPRB, 0.769267E+00_JPRB &
  &, 0.755244E+00_JPRB, 0.741019E+00_JPRB, 0.726606E+00_JPRB &
  &, 0.712018E+00_JPRB, 0.697265E+00_JPRB, 0.682365E+00_JPRB, 0.667327E+00_JPRB &
  &, 0.652168E+00_JPRB, 0.636903E+00_JPRB, 0.621544E+00_JPRB &
  &, 0.606112E+00_JPRB, 0.590618E+00_JPRB, 0.575083E+00_JPRB, 0.559517E+00_JPRB &
  &, 0.543945E+00_JPRB, 0.528377E+00_JPRB, 0.512831E+00_JPRB &
  &, 0.497322E+00_JPRB, 0.481882E+00_JPRB, 0.466515E+00_JPRB, 0.451237E+00_JPRB &
  &, 0.436068E+00_JPRB, 0.421028E+00_JPRB, 0.406129E+00_JPRB &
  &, 0.391395E+00_JPRB, 0.376841E+00_JPRB, 0.362469E+00_JPRB, 0.348307E+00_JPRB &
  &, 0.334369E+00_JPRB, 0.320621E+00_JPRB, 0.307214E+00_JPRB &
  &, 0.294014E+00_JPRB, 0.281095E+00_JPRB, 0.268445E+00_JPRB, 0.256101E+00_JPRB &
  &, 0.244061E+00_JPRB, 0.232333E+00_JPRB, 0.220925E+00_JPRB &
  &, 0.209842E+00_JPRB, 0.199089E+00_JPRB, 0.188667E+00_JPRB, 0.178593E+00_JPRB &
  &, 0.168847E+00_JPRB, 0.159460E+00_JPRB, 0.150408E+00_JPRB &
  &, 0.141717E+00_JPRB, 0.133358E+00_JPRB, 0.125336E+00_JPRB, 0.117653E+00_JPRB &
  &, 0.110309E+00_JPRB, 0.103303E+00_JPRB, 0.966108E-01_JPRB &
  &, 0.902461E-01_JPRB, 0.842008E-01_JPRB, 0.784424E-01_JPRB, 0.730013E-01_JPRB &
  &, 0.678630E-01_JPRB, 0.629867E-01_JPRB, 0.583748E-01_JPRB &
  &, 0.540527E-01_JPRB, 0.499722E-01_JPRB, 0.461557E-01_JPRB, 0.425749E-01_JPRB &
  &, 0.391978E-01_JPRB, 0.360697E-01_JPRB, 0.331288E-01_JPRB &
  &, 0.303914E-01_JPRB, 0.278457E-01_JPRB, 0.254782E-01_JPRB, 0.232737E-01_JPRB &
  &, 0.212451E-01_JPRB, 0.193751E-01_JPRB, 0.176136E-01_JPRB &
  &, 0.160325E-01_JPRB, 0.145476E-01_JPRB, 0.131994E-01_JPRB, 0.119304E-01_JPRB &
  &, 0.107809E-01_JPRB, 0.975893E-02_JPRB, 0.880243E-02_JPRB &
  &, 0.791621E-02_JPRB, 0.710520E-02_JPRB, 0.637444E-02_JPRB, 0.572906E-02_JPRB &
  &, 0.513607E-02_JPRB, 0.459891E-02_JPRB, 0.408157E-02_JPRB &
  &, 0.366606E-02_JPRB, 0.323550E-02_JPRB, 0.291415E-02_JPRB, 0.258130E-02_JPRB &
  &, 0.227962E-02_JPRB, 0.201098E-02_JPRB, 0.177728E-02_JPRB &
  &, 0.158046E-02_JPRB, 0.137694E-02_JPRB, 0.121289E-02_JPRB, 0.109034E-02_JPRB &
  &, 0.915991E-03_JPRB, 0.832833E-03_JPRB, 0.697766E-03_JPRB &
  &, 0.608276E-03_JPRB, 0.566517E-03_JPRB, 0.472010E-03_JPRB, 0.426660E-03_JPRB &
  &, 0.327019E-03_JPRB, 0.277982E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.177736E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 384, :) = (/ &
  &  0.967358E+00_JPRB, 0.958292E+00_JPRB, 0.948870E+00_JPRB, 0.939107E+00_JPRB &
  &, 0.929006E+00_JPRB, 0.918573E+00_JPRB, 0.907816E+00_JPRB &
  &, 0.896743E+00_JPRB, 0.885361E+00_JPRB, 0.873677E+00_JPRB, 0.861702E+00_JPRB &
  &, 0.849441E+00_JPRB, 0.836904E+00_JPRB, 0.824102E+00_JPRB &
  &, 0.811044E+00_JPRB, 0.797738E+00_JPRB, 0.784196E+00_JPRB, 0.770429E+00_JPRB &
  &, 0.756447E+00_JPRB, 0.742262E+00_JPRB, 0.727887E+00_JPRB &
  &, 0.713334E+00_JPRB, 0.698618E+00_JPRB, 0.683749E+00_JPRB, 0.668741E+00_JPRB &
  &, 0.653609E+00_JPRB, 0.638371E+00_JPRB, 0.623040E+00_JPRB &
  &, 0.607629E+00_JPRB, 0.592156E+00_JPRB, 0.576635E+00_JPRB, 0.561091E+00_JPRB &
  &, 0.545529E+00_JPRB, 0.529974E+00_JPRB, 0.514441E+00_JPRB &
  &, 0.498941E+00_JPRB, 0.483503E+00_JPRB, 0.468138E+00_JPRB, 0.452861E+00_JPRB &
  &, 0.437692E+00_JPRB, 0.422651E+00_JPRB, 0.407749E+00_JPRB &
  &, 0.393012E+00_JPRB, 0.378441E+00_JPRB, 0.364063E+00_JPRB, 0.349893E+00_JPRB &
  &, 0.335933E+00_JPRB, 0.322211E+00_JPRB, 0.308741E+00_JPRB &
  &, 0.295525E+00_JPRB, 0.282576E+00_JPRB, 0.269920E+00_JPRB, 0.257541E+00_JPRB &
  &, 0.245477E+00_JPRB, 0.233723E+00_JPRB, 0.222272E+00_JPRB &
  &, 0.211159E+00_JPRB, 0.200373E+00_JPRB, 0.189933E+00_JPRB, 0.179821E+00_JPRB &
  &, 0.170053E+00_JPRB, 0.160623E+00_JPRB, 0.151544E+00_JPRB &
  &, 0.142806E+00_JPRB, 0.134397E+00_JPRB, 0.126341E+00_JPRB, 0.118641E+00_JPRB &
  &, 0.111259E+00_JPRB, 0.104213E+00_JPRB, 0.974781E-01_JPRB &
  &, 0.910685E-01_JPRB, 0.849975E-01_JPRB, 0.792118E-01_JPRB, 0.737194E-01_JPRB &
  &, 0.685500E-01_JPRB, 0.636410E-01_JPRB, 0.590186E-01_JPRB &
  &, 0.546365E-01_JPRB, 0.505428E-01_JPRB, 0.466870E-01_JPRB, 0.430650E-01_JPRB &
  &, 0.396712E-01_JPRB, 0.364986E-01_JPRB, 0.335387E-01_JPRB &
  &, 0.307812E-01_JPRB, 0.282145E-01_JPRB, 0.258251E-01_JPRB, 0.235976E-01_JPRB &
  &, 0.215450E-01_JPRB, 0.196500E-01_JPRB, 0.178935E-01_JPRB &
  &, 0.162541E-01_JPRB, 0.147733E-01_JPRB, 0.133962E-01_JPRB, 0.121308E-01_JPRB &
  &, 0.109508E-01_JPRB, 0.989722E-02_JPRB, 0.894311E-02_JPRB &
  &, 0.805931E-02_JPRB, 0.725074E-02_JPRB, 0.648545E-02_JPRB, 0.584194E-02_JPRB &
  &, 0.521258E-02_JPRB, 0.467668E-02_JPRB, 0.416063E-02_JPRB &
  &, 0.374641E-02_JPRB, 0.331716E-02_JPRB, 0.295563E-02_JPRB, 0.262345E-02_JPRB &
  &, 0.232244E-02_JPRB, 0.205447E-02_JPRB, 0.182146E-02_JPRB &
  &, 0.162533E-02_JPRB, 0.142251E-02_JPRB, 0.125916E-02_JPRB, 0.109034E-02_JPRB &
  &, 0.963674E-03_JPRB, 0.832833E-03_JPRB, 0.746892E-03_JPRB &
  &, 0.658132E-03_JPRB, 0.566517E-03_JPRB, 0.472010E-03_JPRB, 0.426660E-03_JPRB &
  &, 0.379856E-03_JPRB, 0.331579E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.177736E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 385, :) = (/ &
  &  0.967617E+00_JPRB, 0.958609E+00_JPRB, 0.949251E+00_JPRB, 0.939548E+00_JPRB &
  &, 0.929505E+00_JPRB, 0.919131E+00_JPRB, 0.908432E+00_JPRB &
  &, 0.897415E+00_JPRB, 0.886087E+00_JPRB, 0.874458E+00_JPRB, 0.862535E+00_JPRB &
  &, 0.850324E+00_JPRB, 0.837839E+00_JPRB, 0.825086E+00_JPRB &
  &, 0.812075E+00_JPRB, 0.798815E+00_JPRB, 0.785316E+00_JPRB, 0.771592E+00_JPRB &
  &, 0.757652E+00_JPRB, 0.743506E+00_JPRB, 0.729171E+00_JPRB &
  &, 0.714653E+00_JPRB, 0.699968E+00_JPRB, 0.685131E+00_JPRB, 0.670155E+00_JPRB &
  &, 0.655053E+00_JPRB, 0.639843E+00_JPRB, 0.624532E+00_JPRB &
  &, 0.609146E+00_JPRB, 0.593695E+00_JPRB, 0.578196E+00_JPRB, 0.562662E+00_JPRB &
  &, 0.547117E+00_JPRB, 0.531576E+00_JPRB, 0.516051E+00_JPRB &
  &, 0.500559E+00_JPRB, 0.485125E+00_JPRB, 0.469761E+00_JPRB, 0.454496E+00_JPRB &
  &, 0.439326E+00_JPRB, 0.424284E+00_JPRB, 0.409370E+00_JPRB &
  &, 0.394629E+00_JPRB, 0.380053E+00_JPRB, 0.365657E+00_JPRB, 0.351467E+00_JPRB &
  &, 0.337497E+00_JPRB, 0.323763E+00_JPRB, 0.310267E+00_JPRB &
  &, 0.297036E+00_JPRB, 0.284070E+00_JPRB, 0.271381E+00_JPRB, 0.258980E+00_JPRB &
  &, 0.246893E+00_JPRB, 0.235099E+00_JPRB, 0.223635E+00_JPRB &
  &, 0.212492E+00_JPRB, 0.201674E+00_JPRB, 0.191182E+00_JPRB, 0.181049E+00_JPRB &
  &, 0.171241E+00_JPRB, 0.161786E+00_JPRB, 0.152662E+00_JPRB &
  &, 0.143895E+00_JPRB, 0.135454E+00_JPRB, 0.127365E+00_JPRB, 0.119610E+00_JPRB &
  &, 0.112189E+00_JPRB, 0.105103E+00_JPRB, 0.983454E-01_JPRB &
  &, 0.919120E-01_JPRB, 0.857942E-01_JPRB, 0.799812E-01_JPRB, 0.744598E-01_JPRB &
  &, 0.692370E-01_JPRB, 0.642953E-01_JPRB, 0.596385E-01_JPRB &
  &, 0.552445E-01_JPRB, 0.511133E-01_JPRB, 0.472183E-01_JPRB, 0.435551E-01_JPRB &
  &, 0.401446E-01_JPRB, 0.369544E-01_JPRB, 0.339759E-01_JPRB &
  &, 0.311711E-01_JPRB, 0.285834E-01_JPRB, 0.261720E-01_JPRB, 0.239215E-01_JPRB &
  &, 0.218449E-01_JPRB, 0.199249E-01_JPRB, 0.181423E-01_JPRB &
  &, 0.165074E-01_JPRB, 0.149989E-01_JPRB, 0.135931E-01_JPRB, 0.123311E-01_JPRB &
  &, 0.111547E-01_JPRB, 0.100701E-01_JPRB, 0.908379E-02_JPRB &
  &, 0.820241E-02_JPRB, 0.735990E-02_JPRB, 0.663346E-02_JPRB, 0.595482E-02_JPRB &
  &, 0.532734E-02_JPRB, 0.475446E-02_JPRB, 0.423969E-02_JPRB &
  &, 0.378659E-02_JPRB, 0.339882E-02_JPRB, 0.299712E-02_JPRB, 0.266560E-02_JPRB &
  &, 0.236526E-02_JPRB, 0.209797E-02_JPRB, 0.186564E-02_JPRB &
  &, 0.162533E-02_JPRB, 0.146807E-02_JPRB, 0.125916E-02_JPRB, 0.113731E-02_JPRB &
  &, 0.963674E-03_JPRB, 0.881235E-03_JPRB, 0.746892E-03_JPRB &
  &, 0.658132E-03_JPRB, 0.566517E-03_JPRB, 0.523345E-03_JPRB, 0.426660E-03_JPRB &
  &, 0.379856E-03_JPRB, 0.331579E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.177736E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.690831E-04_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART55',1,ZHOOK_HANDLE)
END SUBROUTINE PART55

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART56

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART56',0,ZHOOK_HANDLE)

XCW( 386, :) = (/ &
  &  0.967874E+00_JPRB, 0.958927E+00_JPRB, 0.949630E+00_JPRB, 0.939988E+00_JPRB &
  &, 0.930005E+00_JPRB, 0.919689E+00_JPRB, 0.909047E+00_JPRB &
  &, 0.898086E+00_JPRB, 0.886813E+00_JPRB, 0.875238E+00_JPRB, 0.863368E+00_JPRB &
  &, 0.851210E+00_JPRB, 0.838774E+00_JPRB, 0.826068E+00_JPRB &
  &, 0.813105E+00_JPRB, 0.799890E+00_JPRB, 0.786438E+00_JPRB, 0.772755E+00_JPRB &
  &, 0.758857E+00_JPRB, 0.744750E+00_JPRB, 0.730452E+00_JPRB &
  &, 0.715970E+00_JPRB, 0.701321E+00_JPRB, 0.686512E+00_JPRB, 0.671572E+00_JPRB &
  &, 0.656497E+00_JPRB, 0.641314E+00_JPRB, 0.626028E+00_JPRB &
  &, 0.610664E+00_JPRB, 0.595234E+00_JPRB, 0.579752E+00_JPRB, 0.564240E+00_JPRB &
  &, 0.548710E+00_JPRB, 0.533178E+00_JPRB, 0.517662E+00_JPRB &
  &, 0.502178E+00_JPRB, 0.486755E+00_JPRB, 0.471394E+00_JPRB, 0.456130E+00_JPRB &
  &, 0.440961E+00_JPRB, 0.425907E+00_JPRB, 0.411001E+00_JPRB &
  &, 0.396246E+00_JPRB, 0.381654E+00_JPRB, 0.367263E+00_JPRB, 0.353053E+00_JPRB &
  &, 0.339073E+00_JPRB, 0.325316E+00_JPRB, 0.311807E+00_JPRB &
  &, 0.298547E+00_JPRB, 0.285564E+00_JPRB, 0.272856E+00_JPRB, 0.260434E+00_JPRB &
  &, 0.248309E+00_JPRB, 0.236490E+00_JPRB, 0.224998E+00_JPRB &
  &, 0.213825E+00_JPRB, 0.202974E+00_JPRB, 0.192464E+00_JPRB, 0.182277E+00_JPRB &
  &, 0.172446E+00_JPRB, 0.162949E+00_JPRB, 0.153798E+00_JPRB &
  &, 0.144983E+00_JPRB, 0.136512E+00_JPRB, 0.128388E+00_JPRB, 0.120598E+00_JPRB &
  &, 0.113139E+00_JPRB, 0.106012E+00_JPRB, 0.992334E-01_JPRB &
  &, 0.927555E-01_JPRB, 0.865909E-01_JPRB, 0.807286E-01_JPRB, 0.751778E-01_JPRB &
  &, 0.699240E-01_JPRB, 0.649496E-01_JPRB, 0.602584E-01_JPRB &
  &, 0.558282E-01_JPRB, 0.516591E-01_JPRB, 0.477496E-01_JPRB, 0.440711E-01_JPRB &
  &, 0.406180E-01_JPRB, 0.374102E-01_JPRB, 0.343858E-01_JPRB &
  &, 0.315610E-01_JPRB, 0.289523E-01_JPRB, 0.265189E-01_JPRB, 0.242454E-01_JPRB &
  &, 0.221449E-01_JPRB, 0.201998E-01_JPRB, 0.184222E-01_JPRB &
  &, 0.167608E-01_JPRB, 0.152245E-01_JPRB, 0.138227E-01_JPRB, 0.124981E-01_JPRB &
  &, 0.113245E-01_JPRB, 0.102429E-01_JPRB, 0.922446E-02_JPRB &
  &, 0.830973E-02_JPRB, 0.750544E-02_JPRB, 0.674446E-02_JPRB, 0.603007E-02_JPRB &
  &, 0.540385E-02_JPRB, 0.487113E-02_JPRB, 0.435828E-02_JPRB &
  &, 0.386694E-02_JPRB, 0.343965E-02_JPRB, 0.308010E-02_JPRB, 0.274991E-02_JPRB &
  &, 0.240808E-02_JPRB, 0.214147E-02_JPRB, 0.190982E-02_JPRB &
  &, 0.167020E-02_JPRB, 0.146807E-02_JPRB, 0.130542E-02_JPRB, 0.113731E-02_JPRB &
  &, 0.101136E-02_JPRB, 0.881235E-03_JPRB, 0.796018E-03_JPRB &
  &, 0.658132E-03_JPRB, 0.566517E-03_JPRB, 0.523345E-03_JPRB, 0.426660E-03_JPRB &
  &, 0.379856E-03_JPRB, 0.331579E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 387, :) = (/ &
  &  0.968127E+00_JPRB, 0.959247E+00_JPRB, 0.950009E+00_JPRB, 0.940427E+00_JPRB &
  &, 0.930504E+00_JPRB, 0.920247E+00_JPRB, 0.909662E+00_JPRB &
  &, 0.898757E+00_JPRB, 0.887540E+00_JPRB, 0.876018E+00_JPRB, 0.864201E+00_JPRB &
  &, 0.852093E+00_JPRB, 0.839709E+00_JPRB, 0.827052E+00_JPRB &
  &, 0.814136E+00_JPRB, 0.800967E+00_JPRB, 0.787559E+00_JPRB, 0.773920E+00_JPRB &
  &, 0.760062E+00_JPRB, 0.745996E+00_JPRB, 0.731733E+00_JPRB &
  &, 0.717289E+00_JPRB, 0.702675E+00_JPRB, 0.687903E+00_JPRB, 0.672986E+00_JPRB &
  &, 0.657945E+00_JPRB, 0.642786E+00_JPRB, 0.627528E+00_JPRB &
  &, 0.612185E+00_JPRB, 0.596776E+00_JPRB, 0.581313E+00_JPRB, 0.565814E+00_JPRB &
  &, 0.550298E+00_JPRB, 0.534784E+00_JPRB, 0.519281E+00_JPRB &
  &, 0.503805E+00_JPRB, 0.488386E+00_JPRB, 0.473027E+00_JPRB, 0.457764E+00_JPRB &
  &, 0.442595E+00_JPRB, 0.427540E+00_JPRB, 0.412632E+00_JPRB &
  &, 0.397863E+00_JPRB, 0.383277E+00_JPRB, 0.368857E+00_JPRB, 0.354651E+00_JPRB &
  &, 0.340650E+00_JPRB, 0.326881E+00_JPRB, 0.313346E+00_JPRB &
  &, 0.300071E+00_JPRB, 0.287058E+00_JPRB, 0.274330E+00_JPRB, 0.261888E+00_JPRB &
  &, 0.249740E+00_JPRB, 0.237895E+00_JPRB, 0.226361E+00_JPRB &
  &, 0.215158E+00_JPRB, 0.204274E+00_JPRB, 0.193729E+00_JPRB, 0.183522E+00_JPRB &
  &, 0.173651E+00_JPRB, 0.164113E+00_JPRB, 0.154934E+00_JPRB &
  &, 0.146090E+00_JPRB, 0.137569E+00_JPRB, 0.129412E+00_JPRB, 0.121586E+00_JPRB &
  &, 0.114089E+00_JPRB, 0.106942E+00_JPRB, 0.100101E+00_JPRB &
  &, 0.935991E-01_JPRB, 0.874091E-01_JPRB, 0.815199E-01_JPRB, 0.759183E-01_JPRB &
  &, 0.706339E-01_JPRB, 0.656273E-01_JPRB, 0.609021E-01_JPRB &
  &, 0.564363E-01_JPRB, 0.522297E-01_JPRB, 0.482808E-01_JPRB, 0.445870E-01_JPRB &
  &, 0.411177E-01_JPRB, 0.378659E-01_JPRB, 0.348230E-01_JPRB &
  &, 0.319787E-01_JPRB, 0.293212E-01_JPRB, 0.268658E-01_JPRB, 0.245694E-01_JPRB &
  &, 0.224448E-01_JPRB, 0.205053E-01_JPRB, 0.186710E-01_JPRB &
  &, 0.169824E-01_JPRB, 0.154502E-01_JPRB, 0.140196E-01_JPRB, 0.126984E-01_JPRB &
  &, 0.114944E-01_JPRB, 0.104158E-01_JPRB, 0.940031E-02_JPRB &
  &, 0.845283E-02_JPRB, 0.761460E-02_JPRB, 0.685547E-02_JPRB, 0.614294E-02_JPRB &
  &, 0.551861E-02_JPRB, 0.494891E-02_JPRB, 0.443734E-02_JPRB &
  &, 0.394730E-02_JPRB, 0.352131E-02_JPRB, 0.312159E-02_JPRB, 0.279206E-02_JPRB &
  &, 0.249373E-02_JPRB, 0.218497E-02_JPRB, 0.195400E-02_JPRB &
  &, 0.171507E-02_JPRB, 0.151364E-02_JPRB, 0.135169E-02_JPRB, 0.118429E-02_JPRB &
  &, 0.101136E-02_JPRB, 0.929637E-03_JPRB, 0.796018E-03_JPRB &
  &, 0.707988E-03_JPRB, 0.617109E-03_JPRB, 0.523345E-03_JPRB, 0.478743E-03_JPRB &
  &, 0.379856E-03_JPRB, 0.331579E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.124971E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 388, :) = (/ &
  &  0.968384E+00_JPRB, 0.959564E+00_JPRB, 0.950388E+00_JPRB, 0.940867E+00_JPRB &
  &, 0.931003E+00_JPRB, 0.920804E+00_JPRB, 0.910276E+00_JPRB &
  &, 0.899428E+00_JPRB, 0.888266E+00_JPRB, 0.876799E+00_JPRB, 0.865034E+00_JPRB &
  &, 0.852979E+00_JPRB, 0.840643E+00_JPRB, 0.828036E+00_JPRB &
  &, 0.815167E+00_JPRB, 0.802044E+00_JPRB, 0.788680E+00_JPRB, 0.775083E+00_JPRB &
  &, 0.761267E+00_JPRB, 0.747240E+00_JPRB, 0.733017E+00_JPRB &
  &, 0.718609E+00_JPRB, 0.704028E+00_JPRB, 0.689288E+00_JPRB, 0.674404E+00_JPRB &
  &, 0.659389E+00_JPRB, 0.644257E+00_JPRB, 0.629028E+00_JPRB &
  &, 0.613706E+00_JPRB, 0.598319E+00_JPRB, 0.582874E+00_JPRB, 0.567393E+00_JPRB &
  &, 0.551894E+00_JPRB, 0.536389E+00_JPRB, 0.520896E+00_JPRB &
  &, 0.505433E+00_JPRB, 0.490017E+00_JPRB, 0.474670E+00_JPRB, 0.459398E+00_JPRB &
  &, 0.444229E+00_JPRB, 0.429184E+00_JPRB, 0.414264E+00_JPRB &
  &, 0.399491E+00_JPRB, 0.384889E+00_JPRB, 0.370463E+00_JPRB, 0.356248E+00_JPRB &
  &, 0.342226E+00_JPRB, 0.328446E+00_JPRB, 0.314898E+00_JPRB &
  &, 0.301596E+00_JPRB, 0.288565E+00_JPRB, 0.275805E+00_JPRB, 0.263342E+00_JPRB &
  &, 0.251171E+00_JPRB, 0.239301E+00_JPRB, 0.227739E+00_JPRB &
  &, 0.216506E+00_JPRB, 0.205591E+00_JPRB, 0.195011E+00_JPRB, 0.184767E+00_JPRB &
  &, 0.174857E+00_JPRB, 0.165293E+00_JPRB, 0.156070E+00_JPRB &
  &, 0.147179E+00_JPRB, 0.138645E+00_JPRB, 0.130455E+00_JPRB, 0.122593E+00_JPRB &
  &, 0.115059E+00_JPRB, 0.107872E+00_JPRB, 0.100989E+00_JPRB &
  &, 0.944426E-01_JPRB, 0.882058E-01_JPRB, 0.822893E-01_JPRB, 0.766812E-01_JPRB &
  &, 0.713438E-01_JPRB, 0.663050E-01_JPRB, 0.615458E-01_JPRB &
  &, 0.570443E-01_JPRB, 0.528250E-01_JPRB, 0.488374E-01_JPRB, 0.451030E-01_JPRB &
  &, 0.415912E-01_JPRB, 0.383217E-01_JPRB, 0.352329E-01_JPRB &
  &, 0.323685E-01_JPRB, 0.297184E-01_JPRB, 0.272127E-01_JPRB, 0.249227E-01_JPRB &
  &, 0.227747E-01_JPRB, 0.207802E-01_JPRB, 0.189509E-01_JPRB &
  &, 0.172357E-01_JPRB, 0.156758E-01_JPRB, 0.142493E-01_JPRB, 0.128987E-01_JPRB &
  &, 0.116983E-01_JPRB, 0.105886E-01_JPRB, 0.954099E-02_JPRB &
  &, 0.859593E-02_JPRB, 0.776014E-02_JPRB, 0.696648E-02_JPRB, 0.625582E-02_JPRB &
  &, 0.563337E-02_JPRB, 0.502669E-02_JPRB, 0.451640E-02_JPRB &
  &, 0.402765E-02_JPRB, 0.360297E-02_JPRB, 0.320456E-02_JPRB, 0.283421E-02_JPRB &
  &, 0.253655E-02_JPRB, 0.222847E-02_JPRB, 0.199819E-02_JPRB &
  &, 0.175994E-02_JPRB, 0.155920E-02_JPRB, 0.135169E-02_JPRB, 0.118429E-02_JPRB &
  &, 0.105904E-02_JPRB, 0.929637E-03_JPRB, 0.796018E-03_JPRB &
  &, 0.707988E-03_JPRB, 0.617109E-03_JPRB, 0.523345E-03_JPRB, 0.478743E-03_JPRB &
  &, 0.379856E-03_JPRB, 0.331579E-03_JPRB, 0.281812E-03_JPRB &
  &, 0.230537E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 389, :) = (/ &
  &  0.968640E+00_JPRB, 0.959883E+00_JPRB, 0.950768E+00_JPRB, 0.941307E+00_JPRB &
  &, 0.931502E+00_JPRB, 0.921361E+00_JPRB, 0.910891E+00_JPRB &
  &, 0.900099E+00_JPRB, 0.888992E+00_JPRB, 0.877579E+00_JPRB, 0.865866E+00_JPRB &
  &, 0.853862E+00_JPRB, 0.841577E+00_JPRB, 0.829019E+00_JPRB &
  &, 0.816197E+00_JPRB, 0.803121E+00_JPRB, 0.789802E+00_JPRB, 0.776248E+00_JPRB &
  &, 0.762473E+00_JPRB, 0.748487E+00_JPRB, 0.734301E+00_JPRB &
  &, 0.719929E+00_JPRB, 0.705384E+00_JPRB, 0.690676E+00_JPRB, 0.675825E+00_JPRB &
  &, 0.660836E+00_JPRB, 0.645732E+00_JPRB, 0.630527E+00_JPRB &
  &, 0.615231E+00_JPRB, 0.599862E+00_JPRB, 0.584438E+00_JPRB, 0.568976E+00_JPRB &
  &, 0.553491E+00_JPRB, 0.538000E+00_JPRB, 0.522515E+00_JPRB &
  &, 0.507061E+00_JPRB, 0.491657E+00_JPRB, 0.476313E+00_JPRB, 0.461042E+00_JPRB &
  &, 0.445874E+00_JPRB, 0.430818E+00_JPRB, 0.415895E+00_JPRB &
  &, 0.401119E+00_JPRB, 0.386513E+00_JPRB, 0.372080E+00_JPRB, 0.357846E+00_JPRB &
  &, 0.343814E+00_JPRB, 0.330011E+00_JPRB, 0.316450E+00_JPRB &
  &, 0.303133E+00_JPRB, 0.290072E+00_JPRB, 0.277294E+00_JPRB, 0.264796E+00_JPRB &
  &, 0.252601E+00_JPRB, 0.240706E+00_JPRB, 0.229117E+00_JPRB &
  &, 0.217854E+00_JPRB, 0.206907E+00_JPRB, 0.196292E+00_JPRB, 0.186012E+00_JPRB &
  &, 0.176079E+00_JPRB, 0.166474E+00_JPRB, 0.157224E+00_JPRB &
  &, 0.148304E+00_JPRB, 0.139721E+00_JPRB, 0.131479E+00_JPRB, 0.123581E+00_JPRB &
  &, 0.116029E+00_JPRB, 0.108782E+00_JPRB, 0.101877E+00_JPRB &
  &, 0.953072E-01_JPRB, 0.890240E-01_JPRB, 0.830807E-01_JPRB, 0.774217E-01_JPRB &
  &, 0.720537E-01_JPRB, 0.669827E-01_JPRB, 0.621895E-01_JPRB &
  &, 0.576524E-01_JPRB, 0.533956E-01_JPRB, 0.493940E-01_JPRB, 0.456189E-01_JPRB &
  &, 0.420909E-01_JPRB, 0.387775E-01_JPRB, 0.356701E-01_JPRB &
  &, 0.327863E-01_JPRB, 0.300873E-01_JPRB, 0.275885E-01_JPRB, 0.252466E-01_JPRB &
  &, 0.230747E-01_JPRB, 0.210856E-01_JPRB, 0.192308E-01_JPRB &
  &, 0.174891E-01_JPRB, 0.159015E-01_JPRB, 0.144461E-01_JPRB, 0.130991E-01_JPRB &
  &, 0.118682E-01_JPRB, 0.107615E-01_JPRB, 0.971684E-02_JPRB &
  &, 0.877480E-02_JPRB, 0.790568E-02_JPRB, 0.711449E-02_JPRB, 0.636870E-02_JPRB &
  &, 0.570988E-02_JPRB, 0.514335E-02_JPRB, 0.459546E-02_JPRB &
  &, 0.410800E-02_JPRB, 0.368463E-02_JPRB, 0.324605E-02_JPRB, 0.291852E-02_JPRB &
  &, 0.257938E-02_JPRB, 0.227197E-02_JPRB, 0.204237E-02_JPRB &
  &, 0.180482E-02_JPRB, 0.160477E-02_JPRB, 0.139795E-02_JPRB, 0.123126E-02_JPRB &
  &, 0.110673E-02_JPRB, 0.929637E-03_JPRB, 0.845144E-03_JPRB &
  &, 0.707988E-03_JPRB, 0.617109E-03_JPRB, 0.574679E-03_JPRB, 0.478743E-03_JPRB &
  &, 0.432692E-03_JPRB, 0.385175E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 390, :) = (/ &
  &  0.968895E+00_JPRB, 0.960199E+00_JPRB, 0.951147E+00_JPRB, 0.941746E+00_JPRB &
  &, 0.932001E+00_JPRB, 0.921919E+00_JPRB, 0.911506E+00_JPRB &
  &, 0.900770E+00_JPRB, 0.889718E+00_JPRB, 0.878359E+00_JPRB, 0.866699E+00_JPRB &
  &, 0.854748E+00_JPRB, 0.842512E+00_JPRB, 0.830002E+00_JPRB &
  &, 0.817228E+00_JPRB, 0.804197E+00_JPRB, 0.790922E+00_JPRB, 0.777413E+00_JPRB &
  &, 0.763678E+00_JPRB, 0.749734E+00_JPRB, 0.735585E+00_JPRB &
  &, 0.721251E+00_JPRB, 0.706738E+00_JPRB, 0.692065E+00_JPRB, 0.677242E+00_JPRB &
  &, 0.662288E+00_JPRB, 0.647211E+00_JPRB, 0.632027E+00_JPRB &
  &, 0.616755E+00_JPRB, 0.601408E+00_JPRB, 0.586007E+00_JPRB, 0.570559E+00_JPRB &
  &, 0.555088E+00_JPRB, 0.539610E+00_JPRB, 0.524139E+00_JPRB &
  &, 0.508689E+00_JPRB, 0.493288E+00_JPRB, 0.477955E+00_JPRB, 0.462686E+00_JPRB &
  &, 0.447519E+00_JPRB, 0.432462E+00_JPRB, 0.417537E+00_JPRB &
  &, 0.402758E+00_JPRB, 0.388136E+00_JPRB, 0.373697E+00_JPRB, 0.359444E+00_JPRB &
  &, 0.345403E+00_JPRB, 0.331588E+00_JPRB, 0.318002E+00_JPRB &
  &, 0.304657E+00_JPRB, 0.291593E+00_JPRB, 0.278783E+00_JPRB, 0.266263E+00_JPRB &
  &, 0.254047E+00_JPRB, 0.242112E+00_JPRB, 0.230510E+00_JPRB &
  &, 0.219202E+00_JPRB, 0.208239E+00_JPRB, 0.197590E+00_JPRB, 0.187273E+00_JPRB &
  &, 0.177301E+00_JPRB, 0.167671E+00_JPRB, 0.158378E+00_JPRB &
  &, 0.149411E+00_JPRB, 0.140797E+00_JPRB, 0.132540E+00_JPRB, 0.124588E+00_JPRB &
  &, 0.116999E+00_JPRB, 0.109732E+00_JPRB, 0.102785E+00_JPRB &
  &, 0.961718E-01_JPRB, 0.898637E-01_JPRB, 0.838720E-01_JPRB, 0.781845E-01_JPRB &
  &, 0.727865E-01_JPRB, 0.676603E-01_JPRB, 0.628333E-01_JPRB &
  &, 0.582847E-01_JPRB, 0.539910E-01_JPRB, 0.499506E-01_JPRB, 0.461348E-01_JPRB &
  &, 0.425906E-01_JPRB, 0.392333E-01_JPRB, 0.361073E-01_JPRB &
  &, 0.332040E-01_JPRB, 0.304845E-01_JPRB, 0.279354E-01_JPRB, 0.256000E-01_JPRB &
  &, 0.234046E-01_JPRB, 0.213605E-01_JPRB, 0.194797E-01_JPRB &
  &, 0.177424E-01_JPRB, 0.161593E-01_JPRB, 0.146758E-01_JPRB, 0.132994E-01_JPRB &
  &, 0.120721E-01_JPRB, 0.109343E-01_JPRB, 0.985752E-02_JPRB &
  &, 0.891790E-02_JPRB, 0.801484E-02_JPRB, 0.722550E-02_JPRB, 0.648157E-02_JPRB &
  &, 0.582465E-02_JPRB, 0.522113E-02_JPRB, 0.467452E-02_JPRB &
  &, 0.418836E-02_JPRB, 0.372545E-02_JPRB, 0.332902E-02_JPRB, 0.296067E-02_JPRB &
  &, 0.262220E-02_JPRB, 0.235897E-02_JPRB, 0.208655E-02_JPRB &
  &, 0.184969E-02_JPRB, 0.160477E-02_JPRB, 0.144422E-02_JPRB, 0.127823E-02_JPRB &
  &, 0.110673E-02_JPRB, 0.978039E-03_JPRB, 0.845144E-03_JPRB &
  &, 0.757844E-03_JPRB, 0.667701E-03_JPRB, 0.574679E-03_JPRB, 0.478743E-03_JPRB &
  &, 0.432692E-03_JPRB, 0.385175E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.698907E-04_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 391, :) = (/ &
  &  0.969151E+00_JPRB, 0.960518E+00_JPRB, 0.951526E+00_JPRB, 0.942185E+00_JPRB &
  &, 0.932498E+00_JPRB, 0.922475E+00_JPRB, 0.912119E+00_JPRB &
  &, 0.901440E+00_JPRB, 0.890444E+00_JPRB, 0.879139E+00_JPRB, 0.867532E+00_JPRB &
  &, 0.855631E+00_JPRB, 0.843446E+00_JPRB, 0.830985E+00_JPRB &
  &, 0.818259E+00_JPRB, 0.805276E+00_JPRB, 0.792044E+00_JPRB, 0.778578E+00_JPRB &
  &, 0.764885E+00_JPRB, 0.750977E+00_JPRB, 0.736869E+00_JPRB &
  &, 0.722571E+00_JPRB, 0.708094E+00_JPRB, 0.693456E+00_JPRB, 0.678663E+00_JPRB &
  &, 0.663735E+00_JPRB, 0.648687E+00_JPRB, 0.633531E+00_JPRB &
  &, 0.618280E+00_JPRB, 0.602959E+00_JPRB, 0.587572E+00_JPRB, 0.572146E+00_JPRB &
  &, 0.556689E+00_JPRB, 0.541221E+00_JPRB, 0.525763E+00_JPRB &
  &, 0.510326E+00_JPRB, 0.494928E+00_JPRB, 0.479598E+00_JPRB, 0.464341E+00_JPRB &
  &, 0.449173E+00_JPRB, 0.434116E+00_JPRB, 0.419179E+00_JPRB &
  &, 0.404397E+00_JPRB, 0.389770E+00_JPRB, 0.375314E+00_JPRB, 0.361054E+00_JPRB &
  &, 0.346991E+00_JPRB, 0.333166E+00_JPRB, 0.319554E+00_JPRB &
  &, 0.306208E+00_JPRB, 0.293114E+00_JPRB, 0.280285E+00_JPRB, 0.267745E+00_JPRB &
  &, 0.255492E+00_JPRB, 0.243532E+00_JPRB, 0.231888E+00_JPRB &
  &, 0.220566E+00_JPRB, 0.209555E+00_JPRB, 0.198888E+00_JPRB, 0.188534E+00_JPRB &
  &, 0.178540E+00_JPRB, 0.168869E+00_JPRB, 0.159532E+00_JPRB &
  &, 0.150536E+00_JPRB, 0.141891E+00_JPRB, 0.133583E+00_JPRB, 0.125615E+00_JPRB &
  &, 0.117969E+00_JPRB, 0.110663E+00_JPRB, 0.103694E+00_JPRB &
  &, 0.970364E-01_JPRB, 0.906820E-01_JPRB, 0.846634E-01_JPRB, 0.789250E-01_JPRB &
  &, 0.734964E-01_JPRB, 0.683614E-01_JPRB, 0.635008E-01_JPRB &
  &, 0.589171E-01_JPRB, 0.545864E-01_JPRB, 0.505072E-01_JPRB, 0.466766E-01_JPRB &
  &, 0.430903E-01_JPRB, 0.397158E-01_JPRB, 0.365718E-01_JPRB &
  &, 0.336217E-01_JPRB, 0.308818E-01_JPRB, 0.283112E-01_JPRB, 0.259239E-01_JPRB &
  &, 0.237345E-01_JPRB, 0.216660E-01_JPRB, 0.197596E-01_JPRB &
  &, 0.180274E-01_JPRB, 0.163850E-01_JPRB, 0.149055E-01_JPRB, 0.135332E-01_JPRB &
  &, 0.122419E-01_JPRB, 0.111072E-01_JPRB, 0.100334E-01_JPRB &
  &, 0.906100E-02_JPRB, 0.816038E-02_JPRB, 0.733651E-02_JPRB, 0.659445E-02_JPRB &
  &, 0.593941E-02_JPRB, 0.533780E-02_JPRB, 0.475357E-02_JPRB &
  &, 0.426871E-02_JPRB, 0.380711E-02_JPRB, 0.341200E-02_JPRB, 0.304497E-02_JPRB &
  &, 0.270785E-02_JPRB, 0.240247E-02_JPRB, 0.213073E-02_JPRB &
  &, 0.189456E-02_JPRB, 0.165033E-02_JPRB, 0.144422E-02_JPRB, 0.127823E-02_JPRB &
  &, 0.115441E-02_JPRB, 0.978039E-03_JPRB, 0.894271E-03_JPRB &
  &, 0.757844E-03_JPRB, 0.667701E-03_JPRB, 0.574679E-03_JPRB, 0.530825E-03_JPRB &
  &, 0.432692E-03_JPRB, 0.385175E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.233649E-03_JPRB, 0.180088E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.100000E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 392, :) = (/ &
  &  0.969408E+00_JPRB, 0.960835E+00_JPRB, 0.951905E+00_JPRB, 0.942624E+00_JPRB &
  &, 0.932997E+00_JPRB, 0.923031E+00_JPRB, 0.912734E+00_JPRB &
  &, 0.902111E+00_JPRB, 0.891169E+00_JPRB, 0.879918E+00_JPRB, 0.868364E+00_JPRB &
  &, 0.856515E+00_JPRB, 0.844381E+00_JPRB, 0.831969E+00_JPRB &
  &, 0.819291E+00_JPRB, 0.806352E+00_JPRB, 0.793168E+00_JPRB, 0.779743E+00_JPRB &
  &, 0.766093E+00_JPRB, 0.752227E+00_JPRB, 0.738156E+00_JPRB &
  &, 0.723894E+00_JPRB, 0.709451E+00_JPRB, 0.694844E+00_JPRB, 0.680031E+00_JPRB &
  &, 0.665187E+00_JPRB, 0.650165E+00_JPRB, 0.635034E+00_JPRB &
  &, 0.619809E+00_JPRB, 0.604506E+00_JPRB, 0.589140E+00_JPRB, 0.573733E+00_JPRB &
  &, 0.558290E+00_JPRB, 0.542840E+00_JPRB, 0.527391E+00_JPRB &
  &, 0.511963E+00_JPRB, 0.496578E+00_JPRB, 0.481241E+00_JPRB, 0.465985E+00_JPRB &
  &, 0.450818E+00_JPRB, 0.435760E+00_JPRB, 0.420832E+00_JPRB &
  &, 0.406036E+00_JPRB, 0.391394E+00_JPRB, 0.376932E+00_JPRB, 0.362664E+00_JPRB &
  &, 0.348592E+00_JPRB, 0.334743E+00_JPRB, 0.321119E+00_JPRB &
  &, 0.307745E+00_JPRB, 0.294635E+00_JPRB, 0.281787E+00_JPRB, 0.269213E+00_JPRB &
  &, 0.256937E+00_JPRB, 0.244952E+00_JPRB, 0.233281E+00_JPRB &
  &, 0.221930E+00_JPRB, 0.210903E+00_JPRB, 0.200186E+00_JPRB, 0.189812E+00_JPRB &
  &, 0.179762E+00_JPRB, 0.170067E+00_JPRB, 0.160703E+00_JPRB &
  &, 0.151680E+00_JPRB, 0.142985E+00_JPRB, 0.134644E+00_JPRB, 0.126641E+00_JPRB &
  &, 0.118958E+00_JPRB, 0.111613E+00_JPRB, 0.104602E+00_JPRB &
  &, 0.979010E-01_JPRB, 0.915217E-01_JPRB, 0.854548E-01_JPRB, 0.797103E-01_JPRB &
  &, 0.742292E-01_JPRB, 0.690624E-01_JPRB, 0.641684E-01_JPRB &
  &, 0.595251E-01_JPRB, 0.551818E-01_JPRB, 0.510637E-01_JPRB, 0.472183E-01_JPRB &
  &, 0.435900E-01_JPRB, 0.401984E-01_JPRB, 0.370091E-01_JPRB &
  &, 0.340394E-01_JPRB, 0.312790E-01_JPRB, 0.286870E-01_JPRB, 0.262773E-01_JPRB &
  &, 0.240344E-01_JPRB, 0.219714E-01_JPRB, 0.200706E-01_JPRB &
  &, 0.182807E-01_JPRB, 0.166428E-01_JPRB, 0.151351E-01_JPRB, 0.137335E-01_JPRB &
  &, 0.124458E-01_JPRB, 0.112800E-01_JPRB, 0.102092E-01_JPRB &
  &, 0.920410E-02_JPRB, 0.830593E-02_JPRB, 0.748452E-02_JPRB, 0.674495E-02_JPRB &
  &, 0.605417E-02_JPRB, 0.541558E-02_JPRB, 0.487216E-02_JPRB &
  &, 0.434906E-02_JPRB, 0.388877E-02_JPRB, 0.345349E-02_JPRB, 0.308712E-02_JPRB &
  &, 0.275067E-02_JPRB, 0.244597E-02_JPRB, 0.217491E-02_JPRB &
  &, 0.193943E-02_JPRB, 0.169590E-02_JPRB, 0.149048E-02_JPRB, 0.132520E-02_JPRB &
  &, 0.115441E-02_JPRB, 0.102644E-02_JPRB, 0.894271E-03_JPRB &
  &, 0.807701E-03_JPRB, 0.667701E-03_JPRB, 0.574679E-03_JPRB, 0.530825E-03_JPRB &
  &, 0.432692E-03_JPRB, 0.385175E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.233649E-03_JPRB, 0.236784E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.126563E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART56',1,ZHOOK_HANDLE)
END SUBROUTINE PART56

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART57

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART57',0,ZHOOK_HANDLE)

XCW( 393, :) = (/ &
  &  0.969662E+00_JPRB, 0.961152E+00_JPRB, 0.952282E+00_JPRB, 0.943063E+00_JPRB &
  &, 0.933495E+00_JPRB, 0.923588E+00_JPRB, 0.913348E+00_JPRB &
  &, 0.902781E+00_JPRB, 0.891896E+00_JPRB, 0.880698E+00_JPRB, 0.869197E+00_JPRB &
  &, 0.857400E+00_JPRB, 0.845316E+00_JPRB, 0.832953E+00_JPRB &
  &, 0.820321E+00_JPRB, 0.807431E+00_JPRB, 0.794290E+00_JPRB, 0.780909E+00_JPRB &
  &, 0.767301E+00_JPRB, 0.753474E+00_JPRB, 0.739440E+00_JPRB &
  &, 0.725217E+00_JPRB, 0.710811E+00_JPRB, 0.696236E+00_JPRB, 0.681509E+00_JPRB &
  &, 0.666641E+00_JPRB, 0.651644E+00_JPRB, 0.636542E+00_JPRB &
  &, 0.621338E+00_JPRB, 0.606060E+00_JPRB, 0.590713E+00_JPRB, 0.575320E+00_JPRB &
  &, 0.559895E+00_JPRB, 0.544455E+00_JPRB, 0.529019E+00_JPRB &
  &, 0.513600E+00_JPRB, 0.498219E+00_JPRB, 0.482893E+00_JPRB, 0.467639E+00_JPRB &
  &, 0.452473E+00_JPRB, 0.437414E+00_JPRB, 0.422474E+00_JPRB &
  &, 0.407675E+00_JPRB, 0.393040E+00_JPRB, 0.378560E+00_JPRB, 0.364273E+00_JPRB &
  &, 0.350193E+00_JPRB, 0.336333E+00_JPRB, 0.322697E+00_JPRB &
  &, 0.309295E+00_JPRB, 0.296156E+00_JPRB, 0.283290E+00_JPRB, 0.270695E+00_JPRB &
  &, 0.258396E+00_JPRB, 0.246387E+00_JPRB, 0.234689E+00_JPRB &
  &, 0.223309E+00_JPRB, 0.212235E+00_JPRB, 0.201501E+00_JPRB, 0.191090E+00_JPRB &
  &, 0.181002E+00_JPRB, 0.171265E+00_JPRB, 0.161875E+00_JPRB &
  &, 0.152805E+00_JPRB, 0.144080E+00_JPRB, 0.135706E+00_JPRB, 0.127649E+00_JPRB &
  &, 0.119948E+00_JPRB, 0.112563E+00_JPRB, 0.105511E+00_JPRB &
  &, 0.987867E-01_JPRB, 0.923615E-01_JPRB, 0.862681E-01_JPRB, 0.804732E-01_JPRB &
  &, 0.749620E-01_JPRB, 0.697635E-01_JPRB, 0.648360E-01_JPRB &
  &, 0.601818E-01_JPRB, 0.557771E-01_JPRB, 0.516456E-01_JPRB, 0.477600E-01_JPRB &
  &, 0.440897E-01_JPRB, 0.406810E-01_JPRB, 0.374736E-01_JPRB &
  &, 0.344571E-01_JPRB, 0.316763E-01_JPRB, 0.290628E-01_JPRB, 0.266307E-01_JPRB &
  &, 0.243644E-01_JPRB, 0.222769E-01_JPRB, 0.203505E-01_JPRB &
  &, 0.185340E-01_JPRB, 0.169007E-01_JPRB, 0.153648E-01_JPRB, 0.139338E-01_JPRB &
  &, 0.126497E-01_JPRB, 0.114529E-01_JPRB, 0.103499E-01_JPRB &
  &, 0.934720E-02_JPRB, 0.845147E-02_JPRB, 0.759552E-02_JPRB, 0.685783E-02_JPRB &
  &, 0.616893E-02_JPRB, 0.553224E-02_JPRB, 0.495122E-02_JPRB &
  &, 0.442941E-02_JPRB, 0.397043E-02_JPRB, 0.353646E-02_JPRB, 0.317143E-02_JPRB &
  &, 0.279349E-02_JPRB, 0.248947E-02_JPRB, 0.221910E-02_JPRB &
  &, 0.193943E-02_JPRB, 0.174146E-02_JPRB, 0.153675E-02_JPRB, 0.137217E-02_JPRB &
  &, 0.120209E-02_JPRB, 0.102644E-02_JPRB, 0.943397E-03_JPRB &
  &, 0.807701E-03_JPRB, 0.718294E-03_JPRB, 0.626014E-03_JPRB, 0.530825E-03_JPRB &
  &, 0.485529E-03_JPRB, 0.385175E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.233649E-03_JPRB, 0.236784E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 394, :) = (/ &
  &  0.969918E+00_JPRB, 0.961470E+00_JPRB, 0.952661E+00_JPRB, 0.943502E+00_JPRB &
  &, 0.933993E+00_JPRB, 0.924145E+00_JPRB, 0.913962E+00_JPRB &
  &, 0.903451E+00_JPRB, 0.892611E+00_JPRB, 0.881477E+00_JPRB, 0.870029E+00_JPRB &
  &, 0.858284E+00_JPRB, 0.846251E+00_JPRB, 0.833937E+00_JPRB &
  &, 0.821354E+00_JPRB, 0.808509E+00_JPRB, 0.795412E+00_JPRB, 0.782075E+00_JPRB &
  &, 0.768509E+00_JPRB, 0.754721E+00_JPRB, 0.740727E+00_JPRB &
  &, 0.726540E+00_JPRB, 0.712171E+00_JPRB, 0.697628E+00_JPRB, 0.682933E+00_JPRB &
  &, 0.668093E+00_JPRB, 0.653127E+00_JPRB, 0.638049E+00_JPRB &
  &, 0.622871E+00_JPRB, 0.607611E+00_JPRB, 0.592286E+00_JPRB, 0.576911E+00_JPRB &
  &, 0.561505E+00_JPRB, 0.546078E+00_JPRB, 0.530652E+00_JPRB &
  &, 0.515246E+00_JPRB, 0.499868E+00_JPRB, 0.484546E+00_JPRB, 0.469293E+00_JPRB &
  &, 0.454128E+00_JPRB, 0.439069E+00_JPRB, 0.424127E+00_JPRB &
  &, 0.409325E+00_JPRB, 0.394674E+00_JPRB, 0.380189E+00_JPRB, 0.365895E+00_JPRB &
  &, 0.351806E+00_JPRB, 0.337923E+00_JPRB, 0.324261E+00_JPRB &
  &, 0.310859E+00_JPRB, 0.297690E+00_JPRB, 0.284806E+00_JPRB, 0.272177E+00_JPRB &
  &, 0.259856E+00_JPRB, 0.247822E+00_JPRB, 0.236097E+00_JPRB &
  &, 0.224673E+00_JPRB, 0.213583E+00_JPRB, 0.202815E+00_JPRB, 0.192368E+00_JPRB &
  &, 0.182258E+00_JPRB, 0.172480E+00_JPRB, 0.163046E+00_JPRB &
  &, 0.153948E+00_JPRB, 0.145193E+00_JPRB, 0.136768E+00_JPRB, 0.128695E+00_JPRB &
  &, 0.120937E+00_JPRB, 0.113533E+00_JPRB, 0.106440E+00_JPRB &
  &, 0.996724E-01_JPRB, 0.932228E-01_JPRB, 0.870814E-01_JPRB, 0.812361E-01_JPRB &
  &, 0.757177E-01_JPRB, 0.704645E-01_JPRB, 0.655036E-01_JPRB &
  &, 0.608142E-01_JPRB, 0.563973E-01_JPRB, 0.522275E-01_JPRB, 0.483018E-01_JPRB &
  &, 0.446157E-01_JPRB, 0.411636E-01_JPRB, 0.379108E-01_JPRB &
  &, 0.349026E-01_JPRB, 0.320735E-01_JPRB, 0.294386E-01_JPRB, 0.269841E-01_JPRB &
  &, 0.246943E-01_JPRB, 0.225823E-01_JPRB, 0.206304E-01_JPRB &
  &, 0.188190E-01_JPRB, 0.171264E-01_JPRB, 0.155944E-01_JPRB, 0.141676E-01_JPRB &
  &, 0.128535E-01_JPRB, 0.116257E-01_JPRB, 0.105257E-01_JPRB &
  &, 0.952607E-02_JPRB, 0.859701E-02_JPRB, 0.774353E-02_JPRB, 0.697070E-02_JPRB &
  &, 0.628370E-02_JPRB, 0.561002E-02_JPRB, 0.503028E-02_JPRB &
  &, 0.450977E-02_JPRB, 0.405209E-02_JPRB, 0.361944E-02_JPRB, 0.321358E-02_JPRB &
  &, 0.287914E-02_JPRB, 0.253297E-02_JPRB, 0.226328E-02_JPRB &
  &, 0.198430E-02_JPRB, 0.178703E-02_JPRB, 0.158301E-02_JPRB, 0.137217E-02_JPRB &
  &, 0.120209E-02_JPRB, 0.107484E-02_JPRB, 0.943397E-03_JPRB &
  &, 0.807701E-03_JPRB, 0.718294E-03_JPRB, 0.626014E-03_JPRB, 0.530825E-03_JPRB &
  &, 0.485529E-03_JPRB, 0.438772E-03_JPRB, 0.336174E-03_JPRB &
  &, 0.285671E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 395, :) = (/ &
  &  0.970173E+00_JPRB, 0.961787E+00_JPRB, 0.953039E+00_JPRB, 0.943940E+00_JPRB &
  &, 0.934491E+00_JPRB, 0.924701E+00_JPRB, 0.914575E+00_JPRB &
  &, 0.904121E+00_JPRB, 0.893346E+00_JPRB, 0.882256E+00_JPRB, 0.870862E+00_JPRB &
  &, 0.859168E+00_JPRB, 0.847185E+00_JPRB, 0.834921E+00_JPRB &
  &, 0.822386E+00_JPRB, 0.809586E+00_JPRB, 0.796535E+00_JPRB, 0.783242E+00_JPRB &
  &, 0.769717E+00_JPRB, 0.755971E+00_JPRB, 0.742015E+00_JPRB &
  &, 0.727866E+00_JPRB, 0.713527E+00_JPRB, 0.699023E+00_JPRB, 0.684358E+00_JPRB &
  &, 0.669548E+00_JPRB, 0.654610E+00_JPRB, 0.639557E+00_JPRB &
  &, 0.624404E+00_JPRB, 0.609166E+00_JPRB, 0.593863E+00_JPRB, 0.578502E+00_JPRB &
  &, 0.563110E+00_JPRB, 0.547702E+00_JPRB, 0.532285E+00_JPRB &
  &, 0.516883E+00_JPRB, 0.501518E+00_JPRB, 0.486208E+00_JPRB, 0.470957E+00_JPRB &
  &, 0.455793E+00_JPRB, 0.440734E+00_JPRB, 0.425791E+00_JPRB &
  &, 0.410975E+00_JPRB, 0.396320E+00_JPRB, 0.381830E+00_JPRB, 0.367517E+00_JPRB &
  &, 0.353406E+00_JPRB, 0.339513E+00_JPRB, 0.325839E+00_JPRB &
  &, 0.312410E+00_JPRB, 0.299238E+00_JPRB, 0.286322E+00_JPRB, 0.273674E+00_JPRB &
  &, 0.261315E+00_JPRB, 0.249257E+00_JPRB, 0.237506E+00_JPRB &
  &, 0.226052E+00_JPRB, 0.214931E+00_JPRB, 0.204129E+00_JPRB, 0.193646E+00_JPRB &
  &, 0.183514E+00_JPRB, 0.173695E+00_JPRB, 0.164235E+00_JPRB &
  &, 0.155091E+00_JPRB, 0.146306E+00_JPRB, 0.137848E+00_JPRB, 0.129722E+00_JPRB &
  &, 0.121947E+00_JPRB, 0.114484E+00_JPRB, 0.107369E+00_JPRB &
  &, 0.100558E+00_JPRB, 0.940840E-01_JPRB, 0.878948E-01_JPRB, 0.820215E-01_JPRB &
  &, 0.764505E-01_JPRB, 0.711889E-01_JPRB, 0.661711E-01_JPRB &
  &, 0.614465E-01_JPRB, 0.569927E-01_JPRB, 0.528094E-01_JPRB, 0.488435E-01_JPRB &
  &, 0.451417E-01_JPRB, 0.416462E-01_JPRB, 0.383753E-01_JPRB &
  &, 0.353204E-01_JPRB, 0.324708E-01_JPRB, 0.298144E-01_JPRB, 0.273374E-01_JPRB &
  &, 0.250542E-01_JPRB, 0.229183E-01_JPRB, 0.209103E-01_JPRB &
  &, 0.191040E-01_JPRB, 0.173842E-01_JPRB, 0.158241E-01_JPRB, 0.143679E-01_JPRB &
  &, 0.130574E-01_JPRB, 0.118332E-01_JPRB, 0.107016E-01_JPRB &
  &, 0.966917E-02_JPRB, 0.874255E-02_JPRB, 0.789154E-02_JPRB, 0.708358E-02_JPRB &
  &, 0.639846E-02_JPRB, 0.572669E-02_JPRB, 0.514887E-02_JPRB &
  &, 0.459012E-02_JPRB, 0.413375E-02_JPRB, 0.366093E-02_JPRB, 0.329789E-02_JPRB &
  &, 0.292196E-02_JPRB, 0.261997E-02_JPRB, 0.230746E-02_JPRB &
  &, 0.202917E-02_JPRB, 0.183259E-02_JPRB, 0.158301E-02_JPRB, 0.141914E-02_JPRB &
  &, 0.124978E-02_JPRB, 0.107484E-02_JPRB, 0.943397E-03_JPRB &
  &, 0.857557E-03_JPRB, 0.718294E-03_JPRB, 0.626014E-03_JPRB, 0.582908E-03_JPRB &
  &, 0.485529E-03_JPRB, 0.438772E-03_JPRB, 0.390537E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.707043E-04_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 396, :) = (/ &
  &  0.970427E+00_JPRB, 0.962103E+00_JPRB, 0.953417E+00_JPRB, 0.944378E+00_JPRB &
  &, 0.934989E+00_JPRB, 0.925256E+00_JPRB, 0.915189E+00_JPRB &
  &, 0.904791E+00_JPRB, 0.894071E+00_JPRB, 0.883036E+00_JPRB, 0.871695E+00_JPRB &
  &, 0.860053E+00_JPRB, 0.848120E+00_JPRB, 0.835904E+00_JPRB &
  &, 0.823416E+00_JPRB, 0.810665E+00_JPRB, 0.797659E+00_JPRB, 0.784408E+00_JPRB &
  &, 0.770925E+00_JPRB, 0.757221E+00_JPRB, 0.743305E+00_JPRB &
  &, 0.729189E+00_JPRB, 0.714891E+00_JPRB, 0.700414E+00_JPRB, 0.685782E+00_JPRB &
  &, 0.671003E+00_JPRB, 0.656092E+00_JPRB, 0.641068E+00_JPRB &
  &, 0.625936E+00_JPRB, 0.610724E+00_JPRB, 0.595436E+00_JPRB, 0.580098E+00_JPRB &
  &, 0.564724E+00_JPRB, 0.549326E+00_JPRB, 0.533923E+00_JPRB &
  &, 0.518529E+00_JPRB, 0.503178E+00_JPRB, 0.487870E+00_JPRB, 0.472622E+00_JPRB &
  &, 0.457458E+00_JPRB, 0.442399E+00_JPRB, 0.427444E+00_JPRB &
  &, 0.412636E+00_JPRB, 0.397966E+00_JPRB, 0.383470E+00_JPRB, 0.369150E+00_JPRB &
  &, 0.355031E+00_JPRB, 0.341116E+00_JPRB, 0.327430E+00_JPRB &
  &, 0.313973E+00_JPRB, 0.300772E+00_JPRB, 0.287838E+00_JPRB, 0.275170E+00_JPRB &
  &, 0.262789E+00_JPRB, 0.250707E+00_JPRB, 0.238929E+00_JPRB &
  &, 0.227447E+00_JPRB, 0.216295E+00_JPRB, 0.205459E+00_JPRB, 0.194941E+00_JPRB &
  &, 0.184770E+00_JPRB, 0.174928E+00_JPRB, 0.165425E+00_JPRB &
  &, 0.156252E+00_JPRB, 0.147419E+00_JPRB, 0.138929E+00_JPRB, 0.130768E+00_JPRB &
  &, 0.122956E+00_JPRB, 0.115454E+00_JPRB, 0.108299E+00_JPRB &
  &, 0.101465E+00_JPRB, 0.949238E-01_JPRB, 0.887301E-01_JPRB, 0.828068E-01_JPRB &
  &, 0.772062E-01_JPRB, 0.718899E-01_JPRB, 0.668625E-01_JPRB &
  &, 0.621032E-01_JPRB, 0.576129E-01_JPRB, 0.533913E-01_JPRB, 0.494110E-01_JPRB &
  &, 0.456677E-01_JPRB, 0.421556E-01_JPRB, 0.388399E-01_JPRB &
  &, 0.357659E-01_JPRB, 0.328964E-01_JPRB, 0.302191E-01_JPRB, 0.277203E-01_JPRB &
  &, 0.253841E-01_JPRB, 0.232237E-01_JPRB, 0.212214E-01_JPRB &
  &, 0.193573E-01_JPRB, 0.176421E-01_JPRB, 0.160538E-01_JPRB, 0.146017E-01_JPRB &
  &, 0.132613E-01_JPRB, 0.120060E-01_JPRB, 0.108774E-01_JPRB &
  &, 0.984804E-02_JPRB, 0.888810E-02_JPRB, 0.800255E-02_JPRB, 0.723408E-02_JPRB &
  &, 0.651322E-02_JPRB, 0.584336E-02_JPRB, 0.522793E-02_JPRB &
  &, 0.471065E-02_JPRB, 0.421540E-02_JPRB, 0.374390E-02_JPRB, 0.334004E-02_JPRB &
  &, 0.296478E-02_JPRB, 0.266347E-02_JPRB, 0.235164E-02_JPRB &
  &, 0.207404E-02_JPRB, 0.183259E-02_JPRB, 0.162928E-02_JPRB, 0.146611E-02_JPRB &
  &, 0.129746E-02_JPRB, 0.112324E-02_JPRB, 0.992523E-03_JPRB &
  &, 0.857557E-03_JPRB, 0.768886E-03_JPRB, 0.677348E-03_JPRB, 0.582908E-03_JPRB &
  &, 0.485529E-03_JPRB, 0.438772E-03_JPRB, 0.390537E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.182457E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 397, :) = (/ &
  &  0.970682E+00_JPRB, 0.962420E+00_JPRB, 0.953795E+00_JPRB, 0.944816E+00_JPRB &
  &, 0.935486E+00_JPRB, 0.925812E+00_JPRB, 0.915802E+00_JPRB &
  &, 0.905461E+00_JPRB, 0.894797E+00_JPRB, 0.883816E+00_JPRB, 0.872527E+00_JPRB &
  &, 0.860937E+00_JPRB, 0.849055E+00_JPRB, 0.836890E+00_JPRB &
  &, 0.824448E+00_JPRB, 0.811744E+00_JPRB, 0.798783E+00_JPRB, 0.785576E+00_JPRB &
  &, 0.772134E+00_JPRB, 0.758471E+00_JPRB, 0.744592E+00_JPRB &
  &, 0.730515E+00_JPRB, 0.716251E+00_JPRB, 0.701810E+00_JPRB, 0.687210E+00_JPRB &
  &, 0.672461E+00_JPRB, 0.657579E+00_JPRB, 0.642579E+00_JPRB &
  &, 0.627473E+00_JPRB, 0.612283E+00_JPRB, 0.597017E+00_JPRB, 0.581697E+00_JPRB &
  &, 0.566333E+00_JPRB, 0.550954E+00_JPRB, 0.535565E+00_JPRB &
  &, 0.520185E+00_JPRB, 0.504837E+00_JPRB, 0.489533E+00_JPRB, 0.474286E+00_JPRB &
  &, 0.459123E+00_JPRB, 0.444064E+00_JPRB, 0.429108E+00_JPRB &
  &, 0.414297E+00_JPRB, 0.399624E+00_JPRB, 0.385111E+00_JPRB, 0.370784E+00_JPRB &
  &, 0.356644E+00_JPRB, 0.342718E+00_JPRB, 0.329007E+00_JPRB &
  &, 0.315550E+00_JPRB, 0.302320E+00_JPRB, 0.289368E+00_JPRB, 0.276680E+00_JPRB &
  &, 0.264264E+00_JPRB, 0.252157E+00_JPRB, 0.240337E+00_JPRB &
  &, 0.228842E+00_JPRB, 0.217658E+00_JPRB, 0.206790E+00_JPRB, 0.196235E+00_JPRB &
  &, 0.186026E+00_JPRB, 0.176160E+00_JPRB, 0.166614E+00_JPRB &
  &, 0.157414E+00_JPRB, 0.148550E+00_JPRB, 0.140009E+00_JPRB, 0.131814E+00_JPRB &
  &, 0.123966E+00_JPRB, 0.116445E+00_JPRB, 0.109228E+00_JPRB &
  &, 0.102351E+00_JPRB, 0.958066E-01_JPRB, 0.895434E-01_JPRB, 0.836146E-01_JPRB &
  &, 0.779619E-01_JPRB, 0.726144E-01_JPRB, 0.675540E-01_JPRB &
  &, 0.627599E-01_JPRB, 0.582331E-01_JPRB, 0.539732E-01_JPRB, 0.499528E-01_JPRB &
  &, 0.461937E-01_JPRB, 0.426382E-01_JPRB, 0.393317E-01_JPRB &
  &, 0.362115E-01_JPRB, 0.333220E-01_JPRB, 0.305949E-01_JPRB, 0.280736E-01_JPRB &
  &, 0.257140E-01_JPRB, 0.235597E-01_JPRB, 0.215324E-01_JPRB &
  &, 0.196423E-01_JPRB, 0.179000E-01_JPRB, 0.163163E-01_JPRB, 0.148354E-01_JPRB &
  &, 0.134651E-01_JPRB, 0.122135E-01_JPRB, 0.110533E-01_JPRB &
  &, 0.999114E-02_JPRB, 0.903364E-02_JPRB, 0.815056E-02_JPRB, 0.734696E-02_JPRB &
  &, 0.662799E-02_JPRB, 0.596002E-02_JPRB, 0.534652E-02_JPRB &
  &, 0.479100E-02_JPRB, 0.429706E-02_JPRB, 0.382688E-02_JPRB, 0.342434E-02_JPRB &
  &, 0.305043E-02_JPRB, 0.270697E-02_JPRB, 0.239582E-02_JPRB &
  &, 0.211891E-02_JPRB, 0.187816E-02_JPRB, 0.167554E-02_JPRB, 0.146611E-02_JPRB &
  &, 0.129746E-02_JPRB, 0.117165E-02_JPRB, 0.992523E-03_JPRB &
  &, 0.907413E-03_JPRB, 0.768886E-03_JPRB, 0.677348E-03_JPRB, 0.582908E-03_JPRB &
  &, 0.538365E-03_JPRB, 0.438772E-03_JPRB, 0.390537E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 398, :) = (/ &
  &  0.970934E+00_JPRB, 0.962736E+00_JPRB, 0.954172E+00_JPRB, 0.945254E+00_JPRB &
  &, 0.935984E+00_JPRB, 0.926369E+00_JPRB, 0.916416E+00_JPRB &
  &, 0.906130E+00_JPRB, 0.895522E+00_JPRB, 0.884595E+00_JPRB, 0.873359E+00_JPRB &
  &, 0.861821E+00_JPRB, 0.849990E+00_JPRB, 0.837873E+00_JPRB &
  &, 0.825480E+00_JPRB, 0.812822E+00_JPRB, 0.799906E+00_JPRB, 0.786744E+00_JPRB &
  &, 0.773344E+00_JPRB, 0.759721E+00_JPRB, 0.745883E+00_JPRB &
  &, 0.731841E+00_JPRB, 0.717614E+00_JPRB, 0.703208E+00_JPRB, 0.688638E+00_JPRB &
  &, 0.673920E+00_JPRB, 0.659065E+00_JPRB, 0.644090E+00_JPRB &
  &, 0.629010E+00_JPRB, 0.613842E+00_JPRB, 0.598598E+00_JPRB, 0.583293E+00_JPRB &
  &, 0.567952E+00_JPRB, 0.552582E+00_JPRB, 0.537207E+00_JPRB &
  &, 0.521831E+00_JPRB, 0.506496E+00_JPRB, 0.491195E+00_JPRB, 0.475960E+00_JPRB &
  &, 0.460799E+00_JPRB, 0.445729E+00_JPRB, 0.430782E+00_JPRB &
  &, 0.415958E+00_JPRB, 0.401281E+00_JPRB, 0.386763E+00_JPRB, 0.372417E+00_JPRB &
  &, 0.358269E+00_JPRB, 0.344321E+00_JPRB, 0.330611E+00_JPRB &
  &, 0.317114E+00_JPRB, 0.303881E+00_JPRB, 0.290898E+00_JPRB, 0.278190E+00_JPRB &
  &, 0.265752E+00_JPRB, 0.253606E+00_JPRB, 0.241776E+00_JPRB &
  &, 0.230236E+00_JPRB, 0.219022E+00_JPRB, 0.208120E+00_JPRB, 0.197546E+00_JPRB &
  &, 0.187300E+00_JPRB, 0.177393E+00_JPRB, 0.167821E+00_JPRB &
  &, 0.158575E+00_JPRB, 0.149682E+00_JPRB, 0.141109E+00_JPRB, 0.132879E+00_JPRB &
  &, 0.124975E+00_JPRB, 0.117415E+00_JPRB, 0.110178E+00_JPRB &
  &, 0.103279E+00_JPRB, 0.966679E-01_JPRB, 0.903788E-01_JPRB, 0.843999E-01_JPRB &
  &, 0.787405E-01_JPRB, 0.733388E-01_JPRB, 0.682454E-01_JPRB &
  &, 0.634166E-01_JPRB, 0.588781E-01_JPRB, 0.545803E-01_JPRB, 0.505203E-01_JPRB &
  &, 0.467198E-01_JPRB, 0.431476E-01_JPRB, 0.397963E-01_JPRB &
  &, 0.366570E-01_JPRB, 0.337192E-01_JPRB, 0.309996E-01_JPRB, 0.284564E-01_JPRB &
  &, 0.260740E-01_JPRB, 0.238652E-01_JPRB, 0.218123E-01_JPRB &
  &, 0.199273E-01_JPRB, 0.181578E-01_JPRB, 0.165459E-01_JPRB, 0.150691E-01_JPRB &
  &, 0.136690E-01_JPRB, 0.124209E-01_JPRB, 0.112291E-01_JPRB &
  &, 0.101700E-01_JPRB, 0.917918E-02_JPRB, 0.829857E-02_JPRB, 0.745983E-02_JPRB &
  &, 0.674275E-02_JPRB, 0.603780E-02_JPRB, 0.542558E-02_JPRB &
  &, 0.487136E-02_JPRB, 0.437872E-02_JPRB, 0.390985E-02_JPRB, 0.346650E-02_JPRB &
  &, 0.309325E-02_JPRB, 0.275047E-02_JPRB, 0.244001E-02_JPRB &
  &, 0.216378E-02_JPRB, 0.192372E-02_JPRB, 0.172181E-02_JPRB, 0.151309E-02_JPRB &
  &, 0.134514E-02_JPRB, 0.117165E-02_JPRB, 0.104165E-02_JPRB &
  &, 0.907413E-03_JPRB, 0.819479E-03_JPRB, 0.677348E-03_JPRB, 0.634990E-03_JPRB &
  &, 0.538365E-03_JPRB, 0.438772E-03_JPRB, 0.390537E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.128166E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 399, :) = (/ &
  &  0.971185E+00_JPRB, 0.963052E+00_JPRB, 0.954550E+00_JPRB, 0.945692E+00_JPRB &
  &, 0.936480E+00_JPRB, 0.926924E+00_JPRB, 0.917029E+00_JPRB &
  &, 0.906800E+00_JPRB, 0.896246E+00_JPRB, 0.885372E+00_JPRB, 0.874192E+00_JPRB &
  &, 0.862705E+00_JPRB, 0.850925E+00_JPRB, 0.838857E+00_JPRB &
  &, 0.826514E+00_JPRB, 0.813902E+00_JPRB, 0.801031E+00_JPRB, 0.787912E+00_JPRB &
  &, 0.774555E+00_JPRB, 0.760970E+00_JPRB, 0.747170E+00_JPRB &
  &, 0.733171E+00_JPRB, 0.718974E+00_JPRB, 0.704603E+00_JPRB, 0.690066E+00_JPRB &
  &, 0.675378E+00_JPRB, 0.660552E+00_JPRB, 0.645605E+00_JPRB &
  &, 0.630550E+00_JPRB, 0.615404E+00_JPRB, 0.600179E+00_JPRB, 0.584897E+00_JPRB &
  &, 0.569501E+00_JPRB, 0.554214E+00_JPRB, 0.538849E+00_JPRB &
  &, 0.523487E+00_JPRB, 0.508156E+00_JPRB, 0.492867E+00_JPRB, 0.477624E+00_JPRB &
  &, 0.462474E+00_JPRB, 0.447405E+00_JPRB, 0.432446E+00_JPRB &
  &, 0.417620E+00_JPRB, 0.402938E+00_JPRB, 0.388415E+00_JPRB, 0.374063E+00_JPRB &
  &, 0.359894E+00_JPRB, 0.345936E+00_JPRB, 0.332201E+00_JPRB &
  &, 0.318690E+00_JPRB, 0.305429E+00_JPRB, 0.292428E+00_JPRB, 0.279700E+00_JPRB &
  &, 0.267240E+00_JPRB, 0.255071E+00_JPRB, 0.243199E+00_JPRB &
  &, 0.231647E+00_JPRB, 0.220386E+00_JPRB, 0.209467E+00_JPRB, 0.198858E+00_JPRB &
  &, 0.188573E+00_JPRB, 0.178625E+00_JPRB, 0.169028E+00_JPRB &
  &, 0.159755E+00_JPRB, 0.150813E+00_JPRB, 0.142208E+00_JPRB, 0.133945E+00_JPRB &
  &, 0.126004E+00_JPRB, 0.118406E+00_JPRB, 0.111128E+00_JPRB &
  &, 0.104185E+00_JPRB, 0.975507E-01_JPRB, 0.912361E-01_JPRB, 0.852077E-01_JPRB &
  &, 0.794962E-01_JPRB, 0.740865E-01_JPRB, 0.689368E-01_JPRB &
  &, 0.640976E-01_JPRB, 0.594983E-01_JPRB, 0.551622E-01_JPRB, 0.510878E-01_JPRB &
  &, 0.472458E-01_JPRB, 0.436569E-01_JPRB, 0.402881E-01_JPRB &
  &, 0.371026E-01_JPRB, 0.341449E-01_JPRB, 0.314043E-01_JPRB, 0.288098E-01_JPRB &
  &, 0.264339E-01_JPRB, 0.242012E-01_JPRB, 0.221233E-01_JPRB &
  &, 0.202122E-01_JPRB, 0.184480E-01_JPRB, 0.168084E-01_JPRB, 0.152695E-01_JPRB &
  &, 0.138729E-01_JPRB, 0.125937E-01_JPRB, 0.114402E-01_JPRB &
  &, 0.103489E-01_JPRB, 0.936111E-02_JPRB, 0.844658E-02_JPRB, 0.761034E-02_JPRB &
  &, 0.685751E-02_JPRB, 0.615447E-02_JPRB, 0.554417E-02_JPRB &
  &, 0.495171E-02_JPRB, 0.446038E-02_JPRB, 0.399283E-02_JPRB, 0.355080E-02_JPRB &
  &, 0.317890E-02_JPRB, 0.283747E-02_JPRB, 0.252837E-02_JPRB &
  &, 0.225352E-02_JPRB, 0.196928E-02_JPRB, 0.176807E-02_JPRB, 0.156006E-02_JPRB &
  &, 0.139283E-02_JPRB, 0.122005E-02_JPRB, 0.104165E-02_JPRB &
  &, 0.957270E-03_JPRB, 0.819479E-03_JPRB, 0.728683E-03_JPRB, 0.634990E-03_JPRB &
  &, 0.538365E-03_JPRB, 0.492368E-03_JPRB, 0.390537E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.236784E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.187249E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART57',1,ZHOOK_HANDLE)
END SUBROUTINE PART57

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART58

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART58',0,ZHOOK_HANDLE)

XCW( 400, :) = (/ &
  &  0.971444E+00_JPRB, 0.963370E+00_JPRB, 0.954927E+00_JPRB, 0.946129E+00_JPRB &
  &, 0.936978E+00_JPRB, 0.927480E+00_JPRB, 0.917641E+00_JPRB &
  &, 0.907469E+00_JPRB, 0.896971E+00_JPRB, 0.886153E+00_JPRB, 0.875024E+00_JPRB &
  &, 0.863590E+00_JPRB, 0.851859E+00_JPRB, 0.839842E+00_JPRB &
  &, 0.827546E+00_JPRB, 0.814980E+00_JPRB, 0.802155E+00_JPRB, 0.789079E+00_JPRB &
  &, 0.775766E+00_JPRB, 0.762220E+00_JPRB, 0.748461E+00_JPRB &
  &, 0.734497E+00_JPRB, 0.720341E+00_JPRB, 0.706002E+00_JPRB, 0.691498E+00_JPRB &
  &, 0.676841E+00_JPRB, 0.662042E+00_JPRB, 0.647120E+00_JPRB &
  &, 0.632091E+00_JPRB, 0.616967E+00_JPRB, 0.601765E+00_JPRB, 0.586496E+00_JPRB &
  &, 0.571188E+00_JPRB, 0.555847E+00_JPRB, 0.540495E+00_JPRB &
  &, 0.525143E+00_JPRB, 0.509825E+00_JPRB, 0.494529E+00_JPRB, 0.479309E+00_JPRB &
  &, 0.464150E+00_JPRB, 0.449080E+00_JPRB, 0.434131E+00_JPRB &
  &, 0.419292E+00_JPRB, 0.404596E+00_JPRB, 0.390067E+00_JPRB, 0.375708E+00_JPRB &
  &, 0.361532E+00_JPRB, 0.347551E+00_JPRB, 0.333805E+00_JPRB &
  &, 0.320280E+00_JPRB, 0.307003E+00_JPRB, 0.293972E+00_JPRB, 0.281211E+00_JPRB &
  &, 0.268729E+00_JPRB, 0.256536E+00_JPRB, 0.244638E+00_JPRB &
  &, 0.233057E+00_JPRB, 0.221766E+00_JPRB, 0.210813E+00_JPRB, 0.200169E+00_JPRB &
  &, 0.189863E+00_JPRB, 0.179875E+00_JPRB, 0.170235E+00_JPRB &
  &, 0.160916E+00_JPRB, 0.151945E+00_JPRB, 0.143308E+00_JPRB, 0.135010E+00_JPRB &
  &, 0.127033E+00_JPRB, 0.119397E+00_JPRB, 0.112098E+00_JPRB &
  &, 0.105113E+00_JPRB, 0.984335E-01_JPRB, 0.920714E-01_JPRB, 0.860379E-01_JPRB &
  &, 0.802748E-01_JPRB, 0.748109E-01_JPRB, 0.696520E-01_JPRB &
  &, 0.647543E-01_JPRB, 0.601432E-01_JPRB, 0.557694E-01_JPRB, 0.516554E-01_JPRB &
  &, 0.477981E-01_JPRB, 0.441663E-01_JPRB, 0.407527E-01_JPRB &
  &, 0.375760E-01_JPRB, 0.345989E-01_JPRB, 0.318091E-01_JPRB, 0.291926E-01_JPRB &
  &, 0.267938E-01_JPRB, 0.245371E-01_JPRB, 0.224343E-01_JPRB &
  &, 0.204972E-01_JPRB, 0.187058E-01_JPRB, 0.170381E-01_JPRB, 0.155032E-01_JPRB &
  &, 0.141107E-01_JPRB, 0.128012E-01_JPRB, 0.116160E-01_JPRB &
  &, 0.105278E-01_JPRB, 0.950665E-02_JPRB, 0.859459E-02_JPRB, 0.776084E-02_JPRB &
  &, 0.697227E-02_JPRB, 0.627114E-02_JPRB, 0.562323E-02_JPRB &
  &, 0.507224E-02_JPRB, 0.454204E-02_JPRB, 0.407580E-02_JPRB, 0.363511E-02_JPRB &
  &, 0.322172E-02_JPRB, 0.288096E-02_JPRB, 0.257255E-02_JPRB &
  &, 0.229839E-02_JPRB, 0.201485E-02_JPRB, 0.181434E-02_JPRB, 0.160703E-02_JPRB &
  &, 0.139283E-02_JPRB, 0.122005E-02_JPRB, 0.109078E-02_JPRB &
  &, 0.957270E-03_JPRB, 0.819479E-03_JPRB, 0.728683E-03_JPRB, 0.634990E-03_JPRB &
  &, 0.538365E-03_JPRB, 0.492368E-03_JPRB, 0.444899E-03_JPRB &
  &, 0.340806E-03_JPRB, 0.289561E-03_JPRB, 0.293480E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.187249E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 401, :) = (/ &
  &  0.971700E+00_JPRB, 0.963685E+00_JPRB, 0.955304E+00_JPRB, 0.946566E+00_JPRB &
  &, 0.937474E+00_JPRB, 0.928034E+00_JPRB, 0.918254E+00_JPRB &
  &, 0.908139E+00_JPRB, 0.897696E+00_JPRB, 0.886933E+00_JPRB, 0.875856E+00_JPRB &
  &, 0.864474E+00_JPRB, 0.852794E+00_JPRB, 0.840826E+00_JPRB &
  &, 0.828578E+00_JPRB, 0.816060E+00_JPRB, 0.803280E+00_JPRB, 0.790249E+00_JPRB &
  &, 0.776977E+00_JPRB, 0.763473E+00_JPRB, 0.749754E+00_JPRB &
  &, 0.735826E+00_JPRB, 0.721704E+00_JPRB, 0.707401E+00_JPRB, 0.692930E+00_JPRB &
  &, 0.678299E+00_JPRB, 0.663532E+00_JPRB, 0.648639E+00_JPRB &
  &, 0.633631E+00_JPRB, 0.618530E+00_JPRB, 0.603350E+00_JPRB, 0.588104E+00_JPRB &
  &, 0.572811E+00_JPRB, 0.557484E+00_JPRB, 0.542146E+00_JPRB &
  &, 0.526807E+00_JPRB, 0.511484E+00_JPRB, 0.496211E+00_JPRB, 0.480983E+00_JPRB &
  &, 0.465825E+00_JPRB, 0.450766E+00_JPRB, 0.435806E+00_JPRB &
  &, 0.420964E+00_JPRB, 0.406264E+00_JPRB, 0.391719E+00_JPRB, 0.377354E+00_JPRB &
  &, 0.363169E+00_JPRB, 0.349179E+00_JPRB, 0.335408E+00_JPRB &
  &, 0.321870E+00_JPRB, 0.308565E+00_JPRB, 0.295516E+00_JPRB, 0.282735E+00_JPRB &
  &, 0.270232E+00_JPRB, 0.258015E+00_JPRB, 0.246092E+00_JPRB &
  &, 0.234467E+00_JPRB, 0.223161E+00_JPRB, 0.212160E+00_JPRB, 0.201496E+00_JPRB &
  &, 0.191153E+00_JPRB, 0.181143E+00_JPRB, 0.171460E+00_JPRB &
  &, 0.162114E+00_JPRB, 0.153095E+00_JPRB, 0.144426E+00_JPRB, 0.136075E+00_JPRB &
  &, 0.128082E+00_JPRB, 0.120408E+00_JPRB, 0.113048E+00_JPRB &
  &, 0.106020E+00_JPRB, 0.993164E-01_JPRB, 0.929287E-01_JPRB, 0.868457E-01_JPRB &
  &, 0.810534E-01_JPRB, 0.755587E-01_JPRB, 0.703673E-01_JPRB &
  &, 0.654353E-01_JPRB, 0.607882E-01_JPRB, 0.563766E-01_JPRB, 0.522487E-01_JPRB &
  &, 0.483504E-01_JPRB, 0.446757E-01_JPRB, 0.412445E-01_JPRB &
  &, 0.380215E-01_JPRB, 0.350245E-01_JPRB, 0.322138E-01_JPRB, 0.295755E-01_JPRB &
  &, 0.271537E-01_JPRB, 0.248731E-01_JPRB, 0.227453E-01_JPRB &
  &, 0.207822E-01_JPRB, 0.189637E-01_JPRB, 0.173005E-01_JPRB, 0.157369E-01_JPRB &
  &, 0.143146E-01_JPRB, 0.130086E-01_JPRB, 0.117919E-01_JPRB &
  &, 0.106709E-01_JPRB, 0.965220E-02_JPRB, 0.874260E-02_JPRB, 0.787371E-02_JPRB &
  &, 0.708704E-02_JPRB, 0.638780E-02_JPRB, 0.574182E-02_JPRB &
  &, 0.515259E-02_JPRB, 0.462370E-02_JPRB, 0.411729E-02_JPRB, 0.367726E-02_JPRB &
  &, 0.330737E-02_JPRB, 0.292446E-02_JPRB, 0.261673E-02_JPRB &
  &, 0.234326E-02_JPRB, 0.206041E-02_JPRB, 0.181434E-02_JPRB, 0.160703E-02_JPRB &
  &, 0.144051E-02_JPRB, 0.126845E-02_JPRB, 0.109078E-02_JPRB &
  &, 0.957270E-03_JPRB, 0.870071E-03_JPRB, 0.728683E-03_JPRB, 0.634990E-03_JPRB &
  &, 0.591202E-03_JPRB, 0.492368E-03_JPRB, 0.444899E-03_JPRB &
  &, 0.395940E-03_JPRB, 0.345473E-03_JPRB, 0.293480E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.187249E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.715239E-04_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.100000E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 402, :) = (/ &
  &  0.971953E+00_JPRB, 0.964000E+00_JPRB, 0.955681E+00_JPRB, 0.947004E+00_JPRB &
  &, 0.937971E+00_JPRB, 0.928589E+00_JPRB, 0.918867E+00_JPRB &
  &, 0.908807E+00_JPRB, 0.898420E+00_JPRB, 0.887712E+00_JPRB, 0.876689E+00_JPRB &
  &, 0.865358E+00_JPRB, 0.853730E+00_JPRB, 0.841811E+00_JPRB &
  &, 0.829612E+00_JPRB, 0.817139E+00_JPRB, 0.804405E+00_JPRB, 0.791418E+00_JPRB &
  &, 0.778188E+00_JPRB, 0.764727E+00_JPRB, 0.751045E+00_JPRB &
  &, 0.737156E+00_JPRB, 0.723071E+00_JPRB, 0.708799E+00_JPRB, 0.694361E+00_JPRB &
  &, 0.679765E+00_JPRB, 0.665026E+00_JPRB, 0.650158E+00_JPRB &
  &, 0.635176E+00_JPRB, 0.620097E+00_JPRB, 0.604935E+00_JPRB, 0.589708E+00_JPRB &
  &, 0.574433E+00_JPRB, 0.559121E+00_JPRB, 0.543797E+00_JPRB &
  &, 0.528463E+00_JPRB, 0.513163E+00_JPRB, 0.497883E+00_JPRB, 0.482667E+00_JPRB &
  &, 0.467511E+00_JPRB, 0.452452E+00_JPRB, 0.437491E+00_JPRB &
  &, 0.422647E+00_JPRB, 0.407944E+00_JPRB, 0.393383E+00_JPRB, 0.378999E+00_JPRB &
  &, 0.364807E+00_JPRB, 0.350806E+00_JPRB, 0.337024E+00_JPRB &
  &, 0.323460E+00_JPRB, 0.310139E+00_JPRB, 0.297073E+00_JPRB, 0.284259E+00_JPRB &
  &, 0.271735E+00_JPRB, 0.259494E+00_JPRB, 0.247545E+00_JPRB &
  &, 0.235893E+00_JPRB, 0.224541E+00_JPRB, 0.213523E+00_JPRB, 0.202824E+00_JPRB &
  &, 0.192443E+00_JPRB, 0.182393E+00_JPRB, 0.172684E+00_JPRB &
  &, 0.163293E+00_JPRB, 0.154245E+00_JPRB, 0.145545E+00_JPRB, 0.137160E+00_JPRB &
  &, 0.129131E+00_JPRB, 0.121418E+00_JPRB, 0.114019E+00_JPRB &
  &, 0.106969E+00_JPRB, 0.100221E+00_JPRB, 0.937860E-01_JPRB, 0.876759E-01_JPRB &
  &, 0.818549E-01_JPRB, 0.763299E-01_JPRB, 0.710826E-01_JPRB &
  &, 0.661163E-01_JPRB, 0.614332E-01_JPRB, 0.570091E-01_JPRB, 0.528420E-01_JPRB &
  &, 0.489027E-01_JPRB, 0.452119E-01_JPRB, 0.417364E-01_JPRB &
  &, 0.384949E-01_JPRB, 0.354501E-01_JPRB, 0.326185E-01_JPRB, 0.299583E-01_JPRB &
  &, 0.275136E-01_JPRB, 0.252091E-01_JPRB, 0.230564E-01_JPRB &
  &, 0.210989E-01_JPRB, 0.192538E-01_JPRB, 0.175630E-01_JPRB, 0.160041E-01_JPRB &
  &, 0.145524E-01_JPRB, 0.132160E-01_JPRB, 0.119677E-01_JPRB &
  &, 0.108497E-01_JPRB, 0.983412E-02_JPRB, 0.889061E-02_JPRB, 0.802421E-02_JPRB &
  &, 0.724005E-02_JPRB, 0.650447E-02_JPRB, 0.586041E-02_JPRB &
  &, 0.523294E-02_JPRB, 0.470535E-02_JPRB, 0.420027E-02_JPRB, 0.376156E-02_JPRB &
  &, 0.335019E-02_JPRB, 0.301146E-02_JPRB, 0.266092E-02_JPRB &
  &, 0.238813E-02_JPRB, 0.210598E-02_JPRB, 0.186060E-02_JPRB, 0.165400E-02_JPRB &
  &, 0.148819E-02_JPRB, 0.131685E-02_JPRB, 0.113990E-02_JPRB &
  &, 0.100713E-02_JPRB, 0.870071E-03_JPRB, 0.780017E-03_JPRB, 0.687073E-03_JPRB &
  &, 0.591202E-03_JPRB, 0.492368E-03_JPRB, 0.444899E-03_JPRB &
  &, 0.395940E-03_JPRB, 0.345473E-03_JPRB, 0.293480E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.184844E-03_JPRB, 0.187249E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 403, :) = (/ &
  &  0.972208E+00_JPRB, 0.964317E+00_JPRB, 0.956058E+00_JPRB, 0.947441E+00_JPRB &
  &, 0.938467E+00_JPRB, 0.929145E+00_JPRB, 0.919479E+00_JPRB &
  &, 0.909476E+00_JPRB, 0.899144E+00_JPRB, 0.888491E+00_JPRB, 0.877520E+00_JPRB &
  &, 0.866243E+00_JPRB, 0.854665E+00_JPRB, 0.842797E+00_JPRB &
  &, 0.830645E+00_JPRB, 0.818221E+00_JPRB, 0.805531E+00_JPRB, 0.792588E+00_JPRB &
  &, 0.779401E+00_JPRB, 0.765980E+00_JPRB, 0.752339E+00_JPRB &
  &, 0.738485E+00_JPRB, 0.724434E+00_JPRB, 0.710201E+00_JPRB, 0.695793E+00_JPRB &
  &, 0.681227E+00_JPRB, 0.666516E+00_JPRB, 0.651677E+00_JPRB &
  &, 0.636720E+00_JPRB, 0.621667E+00_JPRB, 0.606528E+00_JPRB, 0.591320E+00_JPRB &
  &, 0.576060E+00_JPRB, 0.560762E+00_JPRB, 0.545448E+00_JPRB &
  &, 0.530128E+00_JPRB, 0.514832E+00_JPRB, 0.499565E+00_JPRB, 0.484351E+00_JPRB &
  &, 0.469197E+00_JPRB, 0.454138E+00_JPRB, 0.439176E+00_JPRB &
  &, 0.424331E+00_JPRB, 0.409613E+00_JPRB, 0.395059E+00_JPRB, 0.380657E+00_JPRB &
  &, 0.366456E+00_JPRB, 0.352434E+00_JPRB, 0.338628E+00_JPRB &
  &, 0.325050E+00_JPRB, 0.311714E+00_JPRB, 0.298631E+00_JPRB, 0.285798E+00_JPRB &
  &, 0.273238E+00_JPRB, 0.260974E+00_JPRB, 0.248999E+00_JPRB &
  &, 0.237319E+00_JPRB, 0.225952E+00_JPRB, 0.214886E+00_JPRB, 0.204152E+00_JPRB &
  &, 0.193750E+00_JPRB, 0.183660E+00_JPRB, 0.173909E+00_JPRB &
  &, 0.164491E+00_JPRB, 0.155413E+00_JPRB, 0.146663E+00_JPRB, 0.138245E+00_JPRB &
  &, 0.130180E+00_JPRB, 0.122429E+00_JPRB, 0.114989E+00_JPRB &
  &, 0.107897E+00_JPRB, 0.101125E+00_JPRB, 0.946433E-01_JPRB, 0.884837E-01_JPRB &
  &, 0.826335E-01_JPRB, 0.770776E-01_JPRB, 0.717978E-01_JPRB &
  &, 0.667973E-01_JPRB, 0.620782E-01_JPRB, 0.576162E-01_JPRB, 0.534095E-01_JPRB &
  &, 0.494550E-01_JPRB, 0.457481E-01_JPRB, 0.422556E-01_JPRB &
  &, 0.389684E-01_JPRB, 0.359041E-01_JPRB, 0.330232E-01_JPRB, 0.303705E-01_JPRB &
  &, 0.278735E-01_JPRB, 0.255451E-01_JPRB, 0.233985E-01_JPRB &
  &, 0.213838E-01_JPRB, 0.195439E-01_JPRB, 0.178255E-01_JPRB, 0.162378E-01_JPRB &
  &, 0.147563E-01_JPRB, 0.134234E-01_JPRB, 0.121787E-01_JPRB &
  &, 0.110286E-01_JPRB, 0.997967E-02_JPRB, 0.903862E-02_JPRB, 0.813709E-02_JPRB &
  &, 0.735482E-02_JPRB, 0.662114E-02_JPRB, 0.593947E-02_JPRB &
  &, 0.535347E-02_JPRB, 0.478701E-02_JPRB, 0.428324E-02_JPRB, 0.384587E-02_JPRB &
  &, 0.343584E-02_JPRB, 0.305496E-02_JPRB, 0.274928E-02_JPRB &
  &, 0.243300E-02_JPRB, 0.215154E-02_JPRB, 0.190687E-02_JPRB, 0.170097E-02_JPRB &
  &, 0.148819E-02_JPRB, 0.131685E-02_JPRB, 0.118903E-02_JPRB &
  &, 0.100713E-02_JPRB, 0.920664E-03_JPRB, 0.780017E-03_JPRB, 0.687073E-03_JPRB &
  &, 0.591202E-03_JPRB, 0.545965E-03_JPRB, 0.444899E-03_JPRB &
  &, 0.395940E-03_JPRB, 0.345473E-03_JPRB, 0.293480E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.187249E-03_JPRB, 0.129781E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 404, :) = (/ &
  &  0.972462E+00_JPRB, 0.964632E+00_JPRB, 0.956435E+00_JPRB, 0.947878E+00_JPRB &
  &, 0.938964E+00_JPRB, 0.929700E+00_JPRB, 0.920091E+00_JPRB &
  &, 0.910146E+00_JPRB, 0.899870E+00_JPRB, 0.889269E+00_JPRB, 0.878353E+00_JPRB &
  &, 0.867127E+00_JPRB, 0.855600E+00_JPRB, 0.843782E+00_JPRB &
  &, 0.831679E+00_JPRB, 0.819300E+00_JPRB, 0.806656E+00_JPRB, 0.793757E+00_JPRB &
  &, 0.780614E+00_JPRB, 0.767233E+00_JPRB, 0.753632E+00_JPRB &
  &, 0.739818E+00_JPRB, 0.725805E+00_JPRB, 0.711603E+00_JPRB, 0.697228E+00_JPRB &
  &, 0.682693E+00_JPRB, 0.668013E+00_JPRB, 0.653199E+00_JPRB &
  &, 0.638269E+00_JPRB, 0.623238E+00_JPRB, 0.608118E+00_JPRB, 0.592928E+00_JPRB &
  &, 0.577687E+00_JPRB, 0.562408E+00_JPRB, 0.547109E+00_JPRB &
  &, 0.531802E+00_JPRB, 0.516510E+00_JPRB, 0.501247E+00_JPRB, 0.486036E+00_JPRB &
  &, 0.470893E+00_JPRB, 0.455825E+00_JPRB, 0.440862E+00_JPRB &
  &, 0.426014E+00_JPRB, 0.411293E+00_JPRB, 0.396722E+00_JPRB, 0.382326E+00_JPRB &
  &, 0.368106E+00_JPRB, 0.354074E+00_JPRB, 0.340257E+00_JPRB &
  &, 0.326653E+00_JPRB, 0.313302E+00_JPRB, 0.300188E+00_JPRB, 0.287336E+00_JPRB &
  &, 0.274755E+00_JPRB, 0.262468E+00_JPRB, 0.250453E+00_JPRB &
  &, 0.238744E+00_JPRB, 0.227348E+00_JPRB, 0.216265E+00_JPRB, 0.205496E+00_JPRB &
  &, 0.195057E+00_JPRB, 0.184927E+00_JPRB, 0.175152E+00_JPRB &
  &, 0.165689E+00_JPRB, 0.156582E+00_JPRB, 0.147801E+00_JPRB, 0.139349E+00_JPRB &
  &, 0.131229E+00_JPRB, 0.123440E+00_JPRB, 0.115981E+00_JPRB &
  &, 0.108846E+00_JPRB, 0.102029E+00_JPRB, 0.955226E-01_JPRB, 0.893363E-01_JPRB &
  &, 0.834350E-01_JPRB, 0.778488E-01_JPRB, 0.725369E-01_JPRB &
  &, 0.675026E-01_JPRB, 0.627480E-01_JPRB, 0.582487E-01_JPRB, 0.540029E-01_JPRB &
  &, 0.500336E-01_JPRB, 0.462843E-01_JPRB, 0.427475E-01_JPRB &
  &, 0.394418E-01_JPRB, 0.363581E-01_JPRB, 0.334568E-01_JPRB, 0.307534E-01_JPRB &
  &, 0.282335E-01_JPRB, 0.258811E-01_JPRB, 0.237095E-01_JPRB &
  &, 0.217005E-01_JPRB, 0.198018E-01_JPRB, 0.180880E-01_JPRB, 0.164715E-01_JPRB &
  &, 0.149941E-01_JPRB, 0.136308E-01_JPRB, 0.123897E-01_JPRB &
  &, 0.112075E-01_JPRB, 0.101616E-01_JPRB, 0.918663E-02_JPRB, 0.828759E-02_JPRB &
  &, 0.746958E-02_JPRB, 0.673780E-02_JPRB, 0.605806E-02_JPRB &
  &, 0.543383E-02_JPRB, 0.490950E-02_JPRB, 0.436622E-02_JPRB, 0.393017E-02_JPRB &
  &, 0.352148E-02_JPRB, 0.314196E-02_JPRB, 0.279346E-02_JPRB &
  &, 0.247787E-02_JPRB, 0.219711E-02_JPRB, 0.195314E-02_JPRB, 0.174794E-02_JPRB &
  &, 0.153588E-02_JPRB, 0.136525E-02_JPRB, 0.118903E-02_JPRB &
  &, 0.105698E-02_JPRB, 0.920664E-03_JPRB, 0.831352E-03_JPRB, 0.687073E-03_JPRB &
  &, 0.644038E-03_JPRB, 0.545965E-03_JPRB, 0.499262E-03_JPRB &
  &, 0.395940E-03_JPRB, 0.345473E-03_JPRB, 0.293480E-03_JPRB, 0.239943E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.187249E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 405, :) = (/ &
  &  0.972716E+00_JPRB, 0.964947E+00_JPRB, 0.956812E+00_JPRB, 0.948315E+00_JPRB &
  &, 0.939460E+00_JPRB, 0.930254E+00_JPRB, 0.920704E+00_JPRB &
  &, 0.910815E+00_JPRB, 0.900593E+00_JPRB, 0.890048E+00_JPRB, 0.879185E+00_JPRB &
  &, 0.868012E+00_JPRB, 0.856536E+00_JPRB, 0.844767E+00_JPRB &
  &, 0.832712E+00_JPRB, 0.820376E+00_JPRB, 0.807783E+00_JPRB, 0.794928E+00_JPRB &
  &, 0.781826E+00_JPRB, 0.768489E+00_JPRB, 0.754926E+00_JPRB &
  &, 0.741148E+00_JPRB, 0.727171E+00_JPRB, 0.713005E+00_JPRB, 0.698663E+00_JPRB &
  &, 0.684159E+00_JPRB, 0.669507E+00_JPRB, 0.654722E+00_JPRB &
  &, 0.639817E+00_JPRB, 0.624809E+00_JPRB, 0.609711E+00_JPRB, 0.594541E+00_JPRB &
  &, 0.579318E+00_JPRB, 0.564054E+00_JPRB, 0.548764E+00_JPRB &
  &, 0.533467E+00_JPRB, 0.518188E+00_JPRB, 0.502938E+00_JPRB, 0.487730E+00_JPRB &
  &, 0.472589E+00_JPRB, 0.457521E+00_JPRB, 0.442558E+00_JPRB &
  &, 0.427697E+00_JPRB, 0.412973E+00_JPRB, 0.398398E+00_JPRB, 0.383995E+00_JPRB &
  &, 0.369755E+00_JPRB, 0.355714E+00_JPRB, 0.341873E+00_JPRB &
  &, 0.328269E+00_JPRB, 0.314890E+00_JPRB, 0.301760E+00_JPRB, 0.288889E+00_JPRB &
  &, 0.276272E+00_JPRB, 0.263962E+00_JPRB, 0.251921E+00_JPRB &
  &, 0.240186E+00_JPRB, 0.228759E+00_JPRB, 0.217644E+00_JPRB, 0.206841E+00_JPRB &
  &, 0.196364E+00_JPRB, 0.186212E+00_JPRB, 0.176394E+00_JPRB &
  &, 0.166905E+00_JPRB, 0.157750E+00_JPRB, 0.148938E+00_JPRB, 0.140453E+00_JPRB &
  &, 0.132298E+00_JPRB, 0.124471E+00_JPRB, 0.116972E+00_JPRB &
  &, 0.109795E+00_JPRB, 0.102934E+00_JPRB, 0.964019E-01_JPRB, 0.901665E-01_JPRB &
  &, 0.842365E-01_JPRB, 0.785966E-01_JPRB, 0.732522E-01_JPRB &
  &, 0.682080E-01_JPRB, 0.634178E-01_JPRB, 0.588812E-01_JPRB, 0.546220E-01_JPRB &
  &, 0.505859E-01_JPRB, 0.468205E-01_JPRB, 0.432666E-01_JPRB &
  &, 0.399152E-01_JPRB, 0.368121E-01_JPRB, 0.338905E-01_JPRB, 0.311656E-01_JPRB &
  &, 0.286234E-01_JPRB, 0.262476E-01_JPRB, 0.240516E-01_JPRB &
  &, 0.219855E-01_JPRB, 0.200919E-01_JPRB, 0.183504E-01_JPRB, 0.167387E-01_JPRB &
  &, 0.152320E-01_JPRB, 0.138383E-01_JPRB, 0.125656E-01_JPRB &
  &, 0.113864E-01_JPRB, 0.103435E-01_JPRB, 0.933464E-02_JPRB, 0.843809E-02_JPRB &
  &, 0.762260E-02_JPRB, 0.685447E-02_JPRB, 0.617665E-02_JPRB &
  &, 0.555436E-02_JPRB, 0.499116E-02_JPRB, 0.444920E-02_JPRB, 0.401448E-02_JPRB &
  &, 0.356430E-02_JPRB, 0.318546E-02_JPRB, 0.283764E-02_JPRB &
  &, 0.252274E-02_JPRB, 0.224267E-02_JPRB, 0.199940E-02_JPRB, 0.179491E-02_JPRB &
  &, 0.158356E-02_JPRB, 0.136525E-02_JPRB, 0.123815E-02_JPRB &
  &, 0.105698E-02_JPRB, 0.971256E-03_JPRB, 0.831352E-03_JPRB, 0.739156E-03_JPRB &
  &, 0.644038E-03_JPRB, 0.545965E-03_JPRB, 0.499262E-03_JPRB &
  &, 0.395940E-03_JPRB, 0.345473E-03_JPRB, 0.293480E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.187249E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.100000E-04_JPRB/)
XCW( 406, :) = (/ &
  &  0.972970E+00_JPRB, 0.965263E+00_JPRB, 0.957188E+00_JPRB, 0.948752E+00_JPRB &
  &, 0.939956E+00_JPRB, 0.930809E+00_JPRB, 0.921316E+00_JPRB &
  &, 0.911483E+00_JPRB, 0.901318E+00_JPRB, 0.890827E+00_JPRB, 0.880018E+00_JPRB &
  &, 0.868896E+00_JPRB, 0.857471E+00_JPRB, 0.845752E+00_JPRB &
  &, 0.833746E+00_JPRB, 0.821461E+00_JPRB, 0.808909E+00_JPRB, 0.796099E+00_JPRB &
  &, 0.783041E+00_JPRB, 0.769742E+00_JPRB, 0.756220E+00_JPRB &
  &, 0.742481E+00_JPRB, 0.728541E+00_JPRB, 0.714411E+00_JPRB, 0.700102E+00_JPRB &
  &, 0.685628E+00_JPRB, 0.671005E+00_JPRB, 0.656248E+00_JPRB &
  &, 0.641369E+00_JPRB, 0.626383E+00_JPRB, 0.611309E+00_JPRB, 0.596157E+00_JPRB &
  &, 0.580950E+00_JPRB, 0.565700E+00_JPRB, 0.550429E+00_JPRB &
  &, 0.535141E+00_JPRB, 0.519867E+00_JPRB, 0.504620E+00_JPRB, 0.489424E+00_JPRB &
  &, 0.474285E+00_JPRB, 0.459218E+00_JPRB, 0.444254E+00_JPRB &
  &, 0.429392E+00_JPRB, 0.414665E+00_JPRB, 0.400085E+00_JPRB, 0.385665E+00_JPRB &
  &, 0.371417E+00_JPRB, 0.357354E+00_JPRB, 0.343502E+00_JPRB &
  &, 0.329872E+00_JPRB, 0.316478E+00_JPRB, 0.303331E+00_JPRB, 0.290427E+00_JPRB &
  &, 0.277804E+00_JPRB, 0.265456E+00_JPRB, 0.253390E+00_JPRB &
  &, 0.241627E+00_JPRB, 0.230170E+00_JPRB, 0.219023E+00_JPRB, 0.208185E+00_JPRB &
  &, 0.197672E+00_JPRB, 0.187496E+00_JPRB, 0.177637E+00_JPRB &
  &, 0.168120E+00_JPRB, 0.158937E+00_JPRB, 0.150076E+00_JPRB, 0.141558E+00_JPRB &
  &, 0.133367E+00_JPRB, 0.125502E+00_JPRB, 0.117963E+00_JPRB &
  &, 0.110744E+00_JPRB, 0.103860E+00_JPRB, 0.972812E-01_JPRB, 0.910192E-01_JPRB &
  &, 0.850609E-01_JPRB, 0.793911E-01_JPRB, 0.739913E-01_JPRB &
  &, 0.689133E-01_JPRB, 0.640876E-01_JPRB, 0.595137E-01_JPRB, 0.552153E-01_JPRB &
  &, 0.511646E-01_JPRB, 0.473567E-01_JPRB, 0.437585E-01_JPRB &
  &, 0.404164E-01_JPRB, 0.372661E-01_JPRB, 0.343241E-01_JPRB, 0.315485E-01_JPRB &
  &, 0.289833E-01_JPRB, 0.266142E-01_JPRB, 0.243626E-01_JPRB &
  &, 0.223021E-01_JPRB, 0.203820E-01_JPRB, 0.186129E-01_JPRB, 0.169724E-01_JPRB &
  &, 0.154698E-01_JPRB, 0.140457E-01_JPRB, 0.127766E-01_JPRB &
  &, 0.116010E-01_JPRB, 0.104891E-01_JPRB, 0.948265E-02_JPRB, 0.858860E-02_JPRB &
  &, 0.773736E-02_JPRB, 0.697114E-02_JPRB, 0.629524E-02_JPRB &
  &, 0.563471E-02_JPRB, 0.507282E-02_JPRB, 0.453217E-02_JPRB, 0.405663E-02_JPRB &
  &, 0.364995E-02_JPRB, 0.327246E-02_JPRB, 0.292601E-02_JPRB &
  &, 0.256761E-02_JPRB, 0.228824E-02_JPRB, 0.204567E-02_JPRB, 0.179491E-02_JPRB &
  &, 0.158356E-02_JPRB, 0.141366E-02_JPRB, 0.123815E-02_JPRB &
  &, 0.110684E-02_JPRB, 0.971256E-03_JPRB, 0.831352E-03_JPRB, 0.739156E-03_JPRB &
  &, 0.644038E-03_JPRB, 0.545965E-03_JPRB, 0.499262E-03_JPRB &
  &, 0.451074E-03_JPRB, 0.401385E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.187249E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.723494E-04_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.100000E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART58',1,ZHOOK_HANDLE)
END SUBROUTINE PART58

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART59

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART59',0,ZHOOK_HANDLE)

XCW( 407, :) = (/ &
  &  0.973221E+00_JPRB, 0.965579E+00_JPRB, 0.957564E+00_JPRB, 0.949188E+00_JPRB &
  &, 0.940452E+00_JPRB, 0.931364E+00_JPRB, 0.921928E+00_JPRB &
  &, 0.912152E+00_JPRB, 0.902043E+00_JPRB, 0.891606E+00_JPRB, 0.880850E+00_JPRB &
  &, 0.869781E+00_JPRB, 0.858407E+00_JPRB, 0.846737E+00_JPRB &
  &, 0.834780E+00_JPRB, 0.822542E+00_JPRB, 0.810037E+00_JPRB, 0.797270E+00_JPRB &
  &, 0.784255E+00_JPRB, 0.770999E+00_JPRB, 0.757517E+00_JPRB &
  &, 0.743817E+00_JPRB, 0.729912E+00_JPRB, 0.715813E+00_JPRB, 0.701537E+00_JPRB &
  &, 0.687098E+00_JPRB, 0.672502E+00_JPRB, 0.657775E+00_JPRB &
  &, 0.642918E+00_JPRB, 0.627958E+00_JPRB, 0.612906E+00_JPRB, 0.597774E+00_JPRB &
  &, 0.582585E+00_JPRB, 0.567350E+00_JPRB, 0.552089E+00_JPRB &
  &, 0.536816E+00_JPRB, 0.521555E+00_JPRB, 0.506322E+00_JPRB, 0.491119E+00_JPRB &
  &, 0.475981E+00_JPRB, 0.460914E+00_JPRB, 0.445950E+00_JPRB &
  &, 0.431086E+00_JPRB, 0.416356E+00_JPRB, 0.401760E+00_JPRB, 0.387334E+00_JPRB &
  &, 0.373079E+00_JPRB, 0.359007E+00_JPRB, 0.345144E+00_JPRB &
  &, 0.331489E+00_JPRB, 0.318080E+00_JPRB, 0.304902E+00_JPRB, 0.291980E+00_JPRB &
  &, 0.279336E+00_JPRB, 0.266965E+00_JPRB, 0.254874E+00_JPRB &
  &, 0.243084E+00_JPRB, 0.231597E+00_JPRB, 0.220418E+00_JPRB, 0.209546E+00_JPRB &
  &, 0.198996E+00_JPRB, 0.188781E+00_JPRB, 0.178897E+00_JPRB &
  &, 0.169336E+00_JPRB, 0.160106E+00_JPRB, 0.151213E+00_JPRB, 0.142662E+00_JPRB &
  &, 0.134435E+00_JPRB, 0.126534E+00_JPRB, 0.118954E+00_JPRB &
  &, 0.111714E+00_JPRB, 0.104786E+00_JPRB, 0.981824E-01_JPRB, 0.918718E-01_JPRB &
  &, 0.858625E-01_JPRB, 0.801622E-01_JPRB, 0.747542E-01_JPRB &
  &, 0.696186E-01_JPRB, 0.647574E-01_JPRB, 0.601715E-01_JPRB, 0.558345E-01_JPRB &
  &, 0.517432E-01_JPRB, 0.478929E-01_JPRB, 0.442777E-01_JPRB &
  &, 0.408898E-01_JPRB, 0.377201E-01_JPRB, 0.347577E-01_JPRB, 0.319607E-01_JPRB &
  &, 0.293732E-01_JPRB, 0.269502E-01_JPRB, 0.247047E-01_JPRB &
  &, 0.226188E-01_JPRB, 0.206721E-01_JPRB, 0.188754E-01_JPRB, 0.172395E-01_JPRB &
  &, 0.157077E-01_JPRB, 0.142877E-01_JPRB, 0.129876E-01_JPRB &
  &, 0.117799E-01_JPRB, 0.106710E-01_JPRB, 0.966767E-02_JPRB, 0.873910E-02_JPRB &
  &, 0.789038E-02_JPRB, 0.712669E-02_JPRB, 0.641383E-02_JPRB &
  &, 0.575524E-02_JPRB, 0.515448E-02_JPRB, 0.465663E-02_JPRB, 0.414093E-02_JPRB &
  &, 0.373560E-02_JPRB, 0.331596E-02_JPRB, 0.297019E-02_JPRB &
  &, 0.265735E-02_JPRB, 0.233380E-02_JPRB, 0.209193E-02_JPRB, 0.184189E-02_JPRB &
  &, 0.163125E-02_JPRB, 0.146206E-02_JPRB, 0.128728E-02_JPRB &
  &, 0.115669E-02_JPRB, 0.102185E-02_JPRB, 0.882686E-03_JPRB, 0.791238E-03_JPRB &
  &, 0.696875E-03_JPRB, 0.599561E-03_JPRB, 0.499262E-03_JPRB &
  &, 0.451074E-03_JPRB, 0.401385E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.187249E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 408, :) = (/ &
  &  0.973475E+00_JPRB, 0.965894E+00_JPRB, 0.957941E+00_JPRB, 0.949624E+00_JPRB &
  &, 0.940948E+00_JPRB, 0.931918E+00_JPRB, 0.922540E+00_JPRB &
  &, 0.912821E+00_JPRB, 0.902766E+00_JPRB, 0.892385E+00_JPRB, 0.881682E+00_JPRB &
  &, 0.870666E+00_JPRB, 0.859343E+00_JPRB, 0.847723E+00_JPRB &
  &, 0.835815E+00_JPRB, 0.823625E+00_JPRB, 0.811164E+00_JPRB, 0.798442E+00_JPRB &
  &, 0.785469E+00_JPRB, 0.772255E+00_JPRB, 0.758811E+00_JPRB &
  &, 0.745150E+00_JPRB, 0.731282E+00_JPRB, 0.717222E+00_JPRB, 0.702979E+00_JPRB &
  &, 0.688568E+00_JPRB, 0.674003E+00_JPRB, 0.659301E+00_JPRB &
  &, 0.644474E+00_JPRB, 0.629537E+00_JPRB, 0.614504E+00_JPRB, 0.599394E+00_JPRB &
  &, 0.584221E+00_JPRB, 0.569004E+00_JPRB, 0.553758E+00_JPRB &
  &, 0.538499E+00_JPRB, 0.523243E+00_JPRB, 0.508013E+00_JPRB, 0.492823E+00_JPRB &
  &, 0.477687E+00_JPRB, 0.462622E+00_JPRB, 0.447657E+00_JPRB &
  &, 0.432792E+00_JPRB, 0.418047E+00_JPRB, 0.403459E+00_JPRB, 0.389015E+00_JPRB &
  &, 0.374740E+00_JPRB, 0.360660E+00_JPRB, 0.346786E+00_JPRB &
  &, 0.333118E+00_JPRB, 0.319682E+00_JPRB, 0.306488E+00_JPRB, 0.293547E+00_JPRB &
  &, 0.280868E+00_JPRB, 0.268474E+00_JPRB, 0.256358E+00_JPRB &
  &, 0.244540E+00_JPRB, 0.233009E+00_JPRB, 0.221813E+00_JPRB, 0.210907E+00_JPRB &
  &, 0.200337E+00_JPRB, 0.190083E+00_JPRB, 0.180157E+00_JPRB &
  &, 0.170570E+00_JPRB, 0.161312E+00_JPRB, 0.152369E+00_JPRB, 0.143785E+00_JPRB &
  &, 0.135504E+00_JPRB, 0.127585E+00_JPRB, 0.119966E+00_JPRB &
  &, 0.112684E+00_JPRB, 0.105711E+00_JPRB, 0.990617E-01_JPRB, 0.927245E-01_JPRB &
  &, 0.866869E-01_JPRB, 0.809567E-01_JPRB, 0.754933E-01_JPRB &
  &, 0.703239E-01_JPRB, 0.654272E-01_JPRB, 0.608039E-01_JPRB, 0.564536E-01_JPRB &
  &, 0.523218E-01_JPRB, 0.484560E-01_JPRB, 0.447969E-01_JPRB &
  &, 0.413911E-01_JPRB, 0.381741E-01_JPRB, 0.351913E-01_JPRB, 0.323730E-01_JPRB &
  &, 0.297631E-01_JPRB, 0.273167E-01_JPRB, 0.250469E-01_JPRB &
  &, 0.229354E-01_JPRB, 0.209945E-01_JPRB, 0.191707E-01_JPRB, 0.174732E-01_JPRB &
  &, 0.159455E-01_JPRB, 0.144951E-01_JPRB, 0.131635E-01_JPRB &
  &, 0.119587E-01_JPRB, 0.108529E-01_JPRB, 0.981568E-02_JPRB, 0.888960E-02_JPRB &
  &, 0.800514E-02_JPRB, 0.724336E-02_JPRB, 0.653241E-02_JPRB &
  &, 0.587577E-02_JPRB, 0.527696E-02_JPRB, 0.473961E-02_JPRB, 0.422524E-02_JPRB &
  &, 0.377842E-02_JPRB, 0.340296E-02_JPRB, 0.301437E-02_JPRB &
  &, 0.270222E-02_JPRB, 0.242493E-02_JPRB, 0.213820E-02_JPRB, 0.188886E-02_JPRB &
  &, 0.167893E-02_JPRB, 0.151046E-02_JPRB, 0.133641E-02_JPRB &
  &, 0.115669E-02_JPRB, 0.102185E-02_JPRB, 0.882686E-03_JPRB, 0.791238E-03_JPRB &
  &, 0.696875E-03_JPRB, 0.599561E-03_JPRB, 0.553624E-03_JPRB &
  &, 0.451074E-03_JPRB, 0.401385E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.131409E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 409, :) = (/ &
  &  0.973730E+00_JPRB, 0.966211E+00_JPRB, 0.958316E+00_JPRB, 0.950061E+00_JPRB &
  &, 0.941444E+00_JPRB, 0.932472E+00_JPRB, 0.923152E+00_JPRB &
  &, 0.913489E+00_JPRB, 0.903491E+00_JPRB, 0.893164E+00_JPRB, 0.882514E+00_JPRB &
  &, 0.871550E+00_JPRB, 0.860279E+00_JPRB, 0.848709E+00_JPRB &
  &, 0.836848E+00_JPRB, 0.824706E+00_JPRB, 0.812292E+00_JPRB, 0.799615E+00_JPRB &
  &, 0.786685E+00_JPRB, 0.773511E+00_JPRB, 0.760108E+00_JPRB &
  &, 0.746486E+00_JPRB, 0.732655E+00_JPRB, 0.718628E+00_JPRB, 0.704418E+00_JPRB &
  &, 0.690041E+00_JPRB, 0.675505E+00_JPRB, 0.660832E+00_JPRB &
  &, 0.646014E+00_JPRB, 0.631115E+00_JPRB, 0.616105E+00_JPRB, 0.601015E+00_JPRB &
  &, 0.585860E+00_JPRB, 0.570659E+00_JPRB, 0.555427E+00_JPRB &
  &, 0.540173E+00_JPRB, 0.524931E+00_JPRB, 0.509715E+00_JPRB, 0.494527E+00_JPRB &
  &, 0.479393E+00_JPRB, 0.464329E+00_JPRB, 0.449364E+00_JPRB &
  &, 0.434497E+00_JPRB, 0.419750E+00_JPRB, 0.405146E+00_JPRB, 0.390697E+00_JPRB &
  &, 0.376415E+00_JPRB, 0.362325E+00_JPRB, 0.348427E+00_JPRB &
  &, 0.334747E+00_JPRB, 0.321283E+00_JPRB, 0.308073E+00_JPRB, 0.295113E+00_JPRB &
  &, 0.282414E+00_JPRB, 0.269983E+00_JPRB, 0.257842E+00_JPRB &
  &, 0.245997E+00_JPRB, 0.234452E+00_JPRB, 0.223209E+00_JPRB, 0.212284E+00_JPRB &
  &, 0.201678E+00_JPRB, 0.191385E+00_JPRB, 0.181435E+00_JPRB &
  &, 0.171804E+00_JPRB, 0.162499E+00_JPRB, 0.153545E+00_JPRB, 0.144909E+00_JPRB &
  &, 0.136593E+00_JPRB, 0.128636E+00_JPRB, 0.120978E+00_JPRB &
  &, 0.113654E+00_JPRB, 0.106659E+00_JPRB, 0.999630E-01_JPRB, 0.935996E-01_JPRB &
  &, 0.875113E-01_JPRB, 0.817279E-01_JPRB, 0.762562E-01_JPRB &
  &, 0.710536E-01_JPRB, 0.661218E-01_JPRB, 0.614617E-01_JPRB, 0.570727E-01_JPRB &
  &, 0.529267E-01_JPRB, 0.490190E-01_JPRB, 0.453434E-01_JPRB &
  &, 0.418923E-01_JPRB, 0.386565E-01_JPRB, 0.356250E-01_JPRB, 0.327853E-01_JPRB &
  &, 0.301530E-01_JPRB, 0.276832E-01_JPRB, 0.253890E-01_JPRB &
  &, 0.232521E-01_JPRB, 0.212846E-01_JPRB, 0.194331E-01_JPRB, 0.177404E-01_JPRB &
  &, 0.161833E-01_JPRB, 0.147371E-01_JPRB, 0.133745E-01_JPRB &
  &, 0.121734E-01_JPRB, 0.110349E-01_JPRB, 0.100007E-01_JPRB, 0.904010E-02_JPRB &
  &, 0.815816E-02_JPRB, 0.736003E-02_JPRB, 0.665100E-02_JPRB &
  &, 0.595612E-02_JPRB, 0.535862E-02_JPRB, 0.482259E-02_JPRB, 0.430954E-02_JPRB &
  &, 0.386407E-02_JPRB, 0.344646E-02_JPRB, 0.310274E-02_JPRB &
  &, 0.274709E-02_JPRB, 0.247050E-02_JPRB, 0.218446E-02_JPRB, 0.193583E-02_JPRB &
  &, 0.172661E-02_JPRB, 0.151046E-02_JPRB, 0.133641E-02_JPRB &
  &, 0.120655E-02_JPRB, 0.102185E-02_JPRB, 0.934021E-03_JPRB, 0.791238E-03_JPRB &
  &, 0.696875E-03_JPRB, 0.599561E-03_JPRB, 0.553624E-03_JPRB &
  &, 0.451074E-03_JPRB, 0.401385E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 410, :) = (/ &
  &  0.973982E+00_JPRB, 0.966523E+00_JPRB, 0.958692E+00_JPRB, 0.950497E+00_JPRB &
  &, 0.941939E+00_JPRB, 0.933026E+00_JPRB, 0.923763E+00_JPRB &
  &, 0.914157E+00_JPRB, 0.904215E+00_JPRB, 0.893943E+00_JPRB, 0.883347E+00_JPRB &
  &, 0.872435E+00_JPRB, 0.861214E+00_JPRB, 0.849694E+00_JPRB &
  &, 0.837883E+00_JPRB, 0.825789E+00_JPRB, 0.813420E+00_JPRB, 0.800787E+00_JPRB &
  &, 0.787901E+00_JPRB, 0.774770E+00_JPRB, 0.761405E+00_JPRB &
  &, 0.747822E+00_JPRB, 0.734026E+00_JPRB, 0.720037E+00_JPRB, 0.705861E+00_JPRB &
  &, 0.691514E+00_JPRB, 0.677010E+00_JPRB, 0.662362E+00_JPRB &
  &, 0.647586E+00_JPRB, 0.632694E+00_JPRB, 0.617707E+00_JPRB, 0.602640E+00_JPRB &
  &, 0.587487E+00_JPRB, 0.572318E+00_JPRB, 0.557097E+00_JPRB &
  &, 0.541857E+00_JPRB, 0.526628E+00_JPRB, 0.511416E+00_JPRB, 0.496232E+00_JPRB &
  &, 0.481099E+00_JPRB, 0.466047E+00_JPRB, 0.451071E+00_JPRB &
  &, 0.436203E+00_JPRB, 0.421453E+00_JPRB, 0.406845E+00_JPRB, 0.392378E+00_JPRB &
  &, 0.378089E+00_JPRB, 0.363977E+00_JPRB, 0.350069E+00_JPRB &
  &, 0.336377E+00_JPRB, 0.322898E+00_JPRB, 0.309672E+00_JPRB, 0.296680E+00_JPRB &
  &, 0.283960E+00_JPRB, 0.271507E+00_JPRB, 0.259341E+00_JPRB &
  &, 0.247469E+00_JPRB, 0.235879E+00_JPRB, 0.224620E+00_JPRB, 0.213662E+00_JPRB &
  &, 0.203019E+00_JPRB, 0.192687E+00_JPRB, 0.182696E+00_JPRB &
  &, 0.173038E+00_JPRB, 0.163705E+00_JPRB, 0.154701E+00_JPRB, 0.146032E+00_JPRB &
  &, 0.137701E+00_JPRB, 0.129688E+00_JPRB, 0.122010E+00_JPRB &
  &, 0.114645E+00_JPRB, 0.107606E+00_JPRB, 0.100864E+00_JPRB, 0.944522E-01_JPRB &
  &, 0.883586E-01_JPRB, 0.825457E-01_JPRB, 0.770192E-01_JPRB &
  &, 0.717832E-01_JPRB, 0.668164E-01_JPRB, 0.621195E-01_JPRB, 0.576918E-01_JPRB &
  &, 0.535053E-01_JPRB, 0.495820E-01_JPRB, 0.458626E-01_JPRB &
  &, 0.423936E-01_JPRB, 0.391388E-01_JPRB, 0.360875E-01_JPRB, 0.332270E-01_JPRB &
  &, 0.305429E-01_JPRB, 0.280498E-01_JPRB, 0.257311E-01_JPRB &
  &, 0.236004E-01_JPRB, 0.215747E-01_JPRB, 0.197284E-01_JPRB, 0.180075E-01_JPRB &
  &, 0.164212E-01_JPRB, 0.149445E-01_JPRB, 0.135855E-01_JPRB &
  &, 0.123523E-01_JPRB, 0.112168E-01_JPRB, 0.101487E-01_JPRB, 0.919060E-02_JPRB &
  &, 0.831117E-02_JPRB, 0.747670E-02_JPRB, 0.676959E-02_JPRB &
  &, 0.607665E-02_JPRB, 0.548111E-02_JPRB, 0.490556E-02_JPRB, 0.439385E-02_JPRB &
  &, 0.394971E-02_JPRB, 0.353346E-02_JPRB, 0.314692E-02_JPRB &
  &, 0.279196E-02_JPRB, 0.251606E-02_JPRB, 0.223073E-02_JPRB, 0.198280E-02_JPRB &
  &, 0.177430E-02_JPRB, 0.155886E-02_JPRB, 0.138553E-02_JPRB &
  &, 0.120655E-02_JPRB, 0.107244E-02_JPRB, 0.934021E-03_JPRB, 0.843321E-03_JPRB &
  &, 0.749711E-03_JPRB, 0.653158E-03_JPRB, 0.553624E-03_JPRB &
  &, 0.506209E-03_JPRB, 0.401385E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.243126E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 411, :) = (/ &
  &  0.974236E+00_JPRB, 0.966838E+00_JPRB, 0.959069E+00_JPRB, 0.950933E+00_JPRB &
  &, 0.942434E+00_JPRB, 0.933580E+00_JPRB, 0.924375E+00_JPRB &
  &, 0.914826E+00_JPRB, 0.904940E+00_JPRB, 0.894721E+00_JPRB, 0.884179E+00_JPRB &
  &, 0.873320E+00_JPRB, 0.862150E+00_JPRB, 0.850681E+00_JPRB &
  &, 0.838918E+00_JPRB, 0.826872E+00_JPRB, 0.814549E+00_JPRB, 0.801961E+00_JPRB &
  &, 0.789118E+00_JPRB, 0.776027E+00_JPRB, 0.762705E+00_JPRB &
  &, 0.749158E+00_JPRB, 0.735402E+00_JPRB, 0.721446E+00_JPRB, 0.707303E+00_JPRB &
  &, 0.692987E+00_JPRB, 0.678511E+00_JPRB, 0.663892E+00_JPRB &
  &, 0.649143E+00_JPRB, 0.634277E+00_JPRB, 0.619313E+00_JPRB, 0.604265E+00_JPRB &
  &, 0.589144E+00_JPRB, 0.573977E+00_JPRB, 0.558775E+00_JPRB &
  &, 0.543550E+00_JPRB, 0.528326E+00_JPRB, 0.513117E+00_JPRB, 0.497936E+00_JPRB &
  &, 0.482816E+00_JPRB, 0.467764E+00_JPRB, 0.452789E+00_JPRB &
  &, 0.437919E+00_JPRB, 0.423167E+00_JPRB, 0.408543E+00_JPRB, 0.394071E+00_JPRB &
  &, 0.379775E+00_JPRB, 0.365655E+00_JPRB, 0.351724E+00_JPRB &
  &, 0.338006E+00_JPRB, 0.324513E+00_JPRB, 0.311270E+00_JPRB, 0.298261E+00_JPRB &
  &, 0.285507E+00_JPRB, 0.273031E+00_JPRB, 0.260840E+00_JPRB &
  &, 0.248941E+00_JPRB, 0.237322E+00_JPRB, 0.226032E+00_JPRB, 0.215039E+00_JPRB &
  &, 0.204360E+00_JPRB, 0.194006E+00_JPRB, 0.183991E+00_JPRB &
  &, 0.174290E+00_JPRB, 0.164910E+00_JPRB, 0.155877E+00_JPRB, 0.147175E+00_JPRB &
  &, 0.138790E+00_JPRB, 0.130739E+00_JPRB, 0.123022E+00_JPRB &
  &, 0.115636E+00_JPRB, 0.108554E+00_JPRB, 0.101788E+00_JPRB, 0.953273E-01_JPRB &
  &, 0.891830E-01_JPRB, 0.833403E-01_JPRB, 0.777821E-01_JPRB &
  &, 0.725129E-01_JPRB, 0.675111E-01_JPRB, 0.627773E-01_JPRB, 0.583110E-01_JPRB &
  &, 0.541102E-01_JPRB, 0.501450E-01_JPRB, 0.464091E-01_JPRB &
  &, 0.428948E-01_JPRB, 0.396212E-01_JPRB, 0.365211E-01_JPRB, 0.336392E-01_JPRB &
  &, 0.309328E-01_JPRB, 0.284468E-01_JPRB, 0.261043E-01_JPRB &
  &, 0.239170E-01_JPRB, 0.218970E-01_JPRB, 0.200237E-01_JPRB, 0.182746E-01_JPRB &
  &, 0.166590E-01_JPRB, 0.151865E-01_JPRB, 0.137965E-01_JPRB &
  &, 0.125669E-01_JPRB, 0.113987E-01_JPRB, 0.103337E-01_JPRB, 0.934110E-02_JPRB &
  &, 0.846419E-02_JPRB, 0.763225E-02_JPRB, 0.688818E-02_JPRB &
  &, 0.619718E-02_JPRB, 0.556277E-02_JPRB, 0.498854E-02_JPRB, 0.447815E-02_JPRB &
  &, 0.403536E-02_JPRB, 0.362046E-02_JPRB, 0.323528E-02_JPRB &
  &, 0.288170E-02_JPRB, 0.256163E-02_JPRB, 0.227699E-02_JPRB, 0.202977E-02_JPRB &
  &, 0.177430E-02_JPRB, 0.160726E-02_JPRB, 0.138553E-02_JPRB &
  &, 0.125641E-02_JPRB, 0.112303E-02_JPRB, 0.985355E-03_JPRB, 0.843321E-03_JPRB &
  &, 0.749711E-03_JPRB, 0.653158E-03_JPRB, 0.553624E-03_JPRB &
  &, 0.506209E-03_JPRB, 0.457297E-03_JPRB, 0.350176E-03_JPRB, 0.297428E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.731809E-04_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 412, :) = (/ &
  &  0.974489E+00_JPRB, 0.967154E+00_JPRB, 0.959444E+00_JPRB, 0.951369E+00_JPRB &
  &, 0.942930E+00_JPRB, 0.934134E+00_JPRB, 0.924987E+00_JPRB &
  &, 0.915495E+00_JPRB, 0.905663E+00_JPRB, 0.895500E+00_JPRB, 0.885012E+00_JPRB &
  &, 0.874204E+00_JPRB, 0.863088E+00_JPRB, 0.851668E+00_JPRB &
  &, 0.839953E+00_JPRB, 0.827954E+00_JPRB, 0.815677E+00_JPRB, 0.803135E+00_JPRB &
  &, 0.790334E+00_JPRB, 0.777286E+00_JPRB, 0.764005E+00_JPRB &
  &, 0.750497E+00_JPRB, 0.736776E+00_JPRB, 0.722855E+00_JPRB, 0.708745E+00_JPRB &
  &, 0.694464E+00_JPRB, 0.680020E+00_JPRB, 0.665426E+00_JPRB &
  &, 0.650703E+00_JPRB, 0.635864E+00_JPRB, 0.620919E+00_JPRB, 0.605890E+00_JPRB &
  &, 0.590793E+00_JPRB, 0.575640E+00_JPRB, 0.560449E+00_JPRB &
  &, 0.545233E+00_JPRB, 0.530024E+00_JPRB, 0.514819E+00_JPRB, 0.499650E+00_JPRB &
  &, 0.484533E+00_JPRB, 0.469482E+00_JPRB, 0.454506E+00_JPRB &
  &, 0.439636E+00_JPRB, 0.424870E+00_JPRB, 0.410242E+00_JPRB, 0.395776E+00_JPRB &
  &, 0.381461E+00_JPRB, 0.367320E+00_JPRB, 0.353379E+00_JPRB &
  &, 0.339648E+00_JPRB, 0.326142E+00_JPRB, 0.312869E+00_JPRB, 0.299842E+00_JPRB &
  &, 0.287067E+00_JPRB, 0.274569E+00_JPRB, 0.262355E+00_JPRB &
  &, 0.250414E+00_JPRB, 0.238781E+00_JPRB, 0.227443E+00_JPRB, 0.216417E+00_JPRB &
  &, 0.205718E+00_JPRB, 0.195326E+00_JPRB, 0.185269E+00_JPRB &
  &, 0.175542E+00_JPRB, 0.166134E+00_JPRB, 0.157052E+00_JPRB, 0.148318E+00_JPRB &
  &, 0.139898E+00_JPRB, 0.131810E+00_JPRB, 0.124055E+00_JPRB &
  &, 0.116627E+00_JPRB, 0.109501E+00_JPRB, 0.102711E+00_JPRB, 0.962248E-01_JPRB &
  &, 0.900303E-01_JPRB, 0.841581E-01_JPRB, 0.785450E-01_JPRB &
  &, 0.732425E-01_JPRB, 0.682305E-01_JPRB, 0.634604E-01_JPRB, 0.589559E-01_JPRB &
  &, 0.547151E-01_JPRB, 0.507080E-01_JPRB, 0.469556E-01_JPRB &
  &, 0.434239E-01_JPRB, 0.401036E-01_JPRB, 0.369836E-01_JPRB, 0.340809E-01_JPRB &
  &, 0.313527E-01_JPRB, 0.288134E-01_JPRB, 0.264464E-01_JPRB &
  &, 0.242337E-01_JPRB, 0.221871E-01_JPRB, 0.203190E-01_JPRB, 0.185417E-01_JPRB &
  &, 0.169309E-01_JPRB, 0.154285E-01_JPRB, 0.140427E-01_JPRB &
  &, 0.127458E-01_JPRB, 0.115806E-01_JPRB, 0.104817E-01_JPRB, 0.949161E-02_JPRB &
  &, 0.857895E-02_JPRB, 0.774892E-02_JPRB, 0.700677E-02_JPRB &
  &, 0.631771E-02_JPRB, 0.568525E-02_JPRB, 0.511300E-02_JPRB, 0.456246E-02_JPRB &
  &, 0.412100E-02_JPRB, 0.366395E-02_JPRB, 0.327946E-02_JPRB &
  &, 0.292657E-02_JPRB, 0.260719E-02_JPRB, 0.232326E-02_JPRB, 0.207674E-02_JPRB &
  &, 0.182198E-02_JPRB, 0.160726E-02_JPRB, 0.143466E-02_JPRB &
  &, 0.125641E-02_JPRB, 0.112303E-02_JPRB, 0.985355E-03_JPRB, 0.895403E-03_JPRB &
  &, 0.749711E-03_JPRB, 0.653158E-03_JPRB, 0.607987E-03_JPRB &
  &, 0.506209E-03_JPRB, 0.457297E-03_JPRB, 0.406872E-03_JPRB, 0.354914E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 413, :) = (/ &
  &  0.974741E+00_JPRB, 0.967467E+00_JPRB, 0.959819E+00_JPRB, 0.951805E+00_JPRB &
  &, 0.943425E+00_JPRB, 0.934688E+00_JPRB, 0.925598E+00_JPRB &
  &, 0.916163E+00_JPRB, 0.906387E+00_JPRB, 0.896279E+00_JPRB, 0.885844E+00_JPRB &
  &, 0.875089E+00_JPRB, 0.864024E+00_JPRB, 0.852654E+00_JPRB &
  &, 0.840989E+00_JPRB, 0.829037E+00_JPRB, 0.816807E+00_JPRB, 0.804309E+00_JPRB &
  &, 0.791552E+00_JPRB, 0.778546E+00_JPRB, 0.765302E+00_JPRB &
  &, 0.751834E+00_JPRB, 0.738153E+00_JPRB, 0.724267E+00_JPRB, 0.710191E+00_JPRB &
  &, 0.695940E+00_JPRB, 0.681525E+00_JPRB, 0.666964E+00_JPRB &
  &, 0.652267E+00_JPRB, 0.637450E+00_JPRB, 0.622528E+00_JPRB, 0.607523E+00_JPRB &
  &, 0.592441E+00_JPRB, 0.577304E+00_JPRB, 0.562127E+00_JPRB &
  &, 0.546926E+00_JPRB, 0.531721E+00_JPRB, 0.516530E+00_JPRB, 0.501375E+00_JPRB &
  &, 0.486249E+00_JPRB, 0.471200E+00_JPRB, 0.456224E+00_JPRB &
  &, 0.441352E+00_JPRB, 0.426584E+00_JPRB, 0.411952E+00_JPRB, 0.397469E+00_JPRB &
  &, 0.383147E+00_JPRB, 0.368998E+00_JPRB, 0.355046E+00_JPRB &
  &, 0.341304E+00_JPRB, 0.327770E+00_JPRB, 0.314482E+00_JPRB, 0.301422E+00_JPRB &
  &, 0.288628E+00_JPRB, 0.276108E+00_JPRB, 0.263854E+00_JPRB &
  &, 0.251901E+00_JPRB, 0.240240E+00_JPRB, 0.228871E+00_JPRB, 0.217811E+00_JPRB &
  &, 0.207076E+00_JPRB, 0.196662E+00_JPRB, 0.186565E+00_JPRB &
  &, 0.176794E+00_JPRB, 0.167359E+00_JPRB, 0.158246E+00_JPRB, 0.149461E+00_JPRB &
  &, 0.141006E+00_JPRB, 0.132882E+00_JPRB, 0.125087E+00_JPRB &
  &, 0.117618E+00_JPRB, 0.110470E+00_JPRB, 0.103634E+00_JPRB, 0.970999E-01_JPRB &
  &, 0.908776E-01_JPRB, 0.849760E-01_JPRB, 0.793318E-01_JPRB &
  &, 0.739965E-01_JPRB, 0.689251E-01_JPRB, 0.641434E-01_JPRB, 0.596008E-01_JPRB &
  &, 0.553200E-01_JPRB, 0.512978E-01_JPRB, 0.475021E-01_JPRB &
  &, 0.439252E-01_JPRB, 0.405859E-01_JPRB, 0.374462E-01_JPRB, 0.344932E-01_JPRB &
  &, 0.317726E-01_JPRB, 0.292104E-01_JPRB, 0.268197E-01_JPRB &
  &, 0.245820E-01_JPRB, 0.225095E-01_JPRB, 0.206143E-01_JPRB, 0.188089E-01_JPRB &
  &, 0.171687E-01_JPRB, 0.156705E-01_JPRB, 0.142537E-01_JPRB &
  &, 0.129604E-01_JPRB, 0.117626E-01_JPRB, 0.106667E-01_JPRB, 0.967973E-02_JPRB &
  &, 0.873197E-02_JPRB, 0.790447E-02_JPRB, 0.712536E-02_JPRB &
  &, 0.643824E-02_JPRB, 0.576691E-02_JPRB, 0.519598E-02_JPRB, 0.464676E-02_JPRB &
  &, 0.416383E-02_JPRB, 0.375095E-02_JPRB, 0.336783E-02_JPRB &
  &, 0.297144E-02_JPRB, 0.265276E-02_JPRB, 0.236952E-02_JPRB, 0.212371E-02_JPRB &
  &, 0.186966E-02_JPRB, 0.165567E-02_JPRB, 0.148378E-02_JPRB &
  &, 0.130626E-02_JPRB, 0.117363E-02_JPRB, 0.103669E-02_JPRB, 0.895403E-03_JPRB &
  &, 0.802548E-03_JPRB, 0.706754E-03_JPRB, 0.607987E-03_JPRB &
  &, 0.506209E-03_JPRB, 0.457297E-03_JPRB, 0.406872E-03_JPRB, 0.354914E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.246332E-03_JPRB, 0.189672E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART59',1,ZHOOK_HANDLE)
END SUBROUTINE PART59

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART60

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART60',0,ZHOOK_HANDLE)

XCW( 414, :) = (/ &
  &  0.974995E+00_JPRB, 0.967782E+00_JPRB, 0.960195E+00_JPRB, 0.952240E+00_JPRB &
  &, 0.943920E+00_JPRB, 0.935241E+00_JPRB, 0.926209E+00_JPRB &
  &, 0.916831E+00_JPRB, 0.907112E+00_JPRB, 0.897058E+00_JPRB, 0.886677E+00_JPRB &
  &, 0.875974E+00_JPRB, 0.864960E+00_JPRB, 0.853641E+00_JPRB &
  &, 0.842024E+00_JPRB, 0.830121E+00_JPRB, 0.817936E+00_JPRB, 0.805483E+00_JPRB &
  &, 0.792770E+00_JPRB, 0.779805E+00_JPRB, 0.766606E+00_JPRB &
  &, 0.753173E+00_JPRB, 0.739530E+00_JPRB, 0.725680E+00_JPRB, 0.711637E+00_JPRB &
  &, 0.697417E+00_JPRB, 0.683034E+00_JPRB, 0.668498E+00_JPRB &
  &, 0.653831E+00_JPRB, 0.639037E+00_JPRB, 0.624142E+00_JPRB, 0.609152E+00_JPRB &
  &, 0.594090E+00_JPRB, 0.578972E+00_JPRB, 0.563810E+00_JPRB &
  &, 0.548619E+00_JPRB, 0.533428E+00_JPRB, 0.518251E+00_JPRB, 0.503089E+00_JPRB &
  &, 0.487976E+00_JPRB, 0.472928E+00_JPRB, 0.457952E+00_JPRB &
  &, 0.443069E+00_JPRB, 0.428309E+00_JPRB, 0.413674E+00_JPRB, 0.399174E+00_JPRB &
  &, 0.384846E+00_JPRB, 0.370688E+00_JPRB, 0.356714E+00_JPRB &
  &, 0.342947E+00_JPRB, 0.329399E+00_JPRB, 0.316095E+00_JPRB, 0.303017E+00_JPRB &
  &, 0.290203E+00_JPRB, 0.277646E+00_JPRB, 0.265383E+00_JPRB &
  &, 0.253389E+00_JPRB, 0.241699E+00_JPRB, 0.230299E+00_JPRB, 0.219222E+00_JPRB &
  &, 0.208451E+00_JPRB, 0.197999E+00_JPRB, 0.187861E+00_JPRB &
  &, 0.178065E+00_JPRB, 0.168583E+00_JPRB, 0.159440E+00_JPRB, 0.150623E+00_JPRB &
  &, 0.142134E+00_JPRB, 0.133974E+00_JPRB, 0.126140E+00_JPRB &
  &, 0.118631E+00_JPRB, 0.111439E+00_JPRB, 0.104557E+00_JPRB, 0.979974E-01_JPRB &
  &, 0.917478E-01_JPRB, 0.857939E-01_JPRB, 0.801186E-01_JPRB &
  &, 0.747505E-01_JPRB, 0.696445E-01_JPRB, 0.648265E-01_JPRB, 0.602457E-01_JPRB &
  &, 0.559513E-01_JPRB, 0.518877E-01_JPRB, 0.480487E-01_JPRB &
  &, 0.444543E-01_JPRB, 0.410683E-01_JPRB, 0.379087E-01_JPRB, 0.349349E-01_JPRB &
  &, 0.321626E-01_JPRB, 0.295770E-01_JPRB, 0.271618E-01_JPRB &
  &, 0.249303E-01_JPRB, 0.228318E-01_JPRB, 0.209096E-01_JPRB, 0.191094E-01_JPRB &
  &, 0.174405E-01_JPRB, 0.158779E-01_JPRB, 0.144648E-01_JPRB &
  &, 0.131751E-01_JPRB, 0.119445E-01_JPRB, 0.108517E-01_JPRB, 0.983023E-02_JPRB &
  &, 0.888498E-02_JPRB, 0.802114E-02_JPRB, 0.724395E-02_JPRB &
  &, 0.655877E-02_JPRB, 0.588940E-02_JPRB, 0.527895E-02_JPRB, 0.477322E-02_JPRB &
  &, 0.424947E-02_JPRB, 0.383795E-02_JPRB, 0.341201E-02_JPRB &
  &, 0.306119E-02_JPRB, 0.274389E-02_JPRB, 0.241579E-02_JPRB, 0.217069E-02_JPRB &
  &, 0.191735E-02_JPRB, 0.170407E-02_JPRB, 0.153291E-02_JPRB &
  &, 0.135612E-02_JPRB, 0.117363E-02_JPRB, 0.103669E-02_JPRB, 0.895403E-03_JPRB &
  &, 0.802548E-03_JPRB, 0.706754E-03_JPRB, 0.607987E-03_JPRB &
  &, 0.561343E-03_JPRB, 0.457297E-03_JPRB, 0.406872E-03_JPRB, 0.354914E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.246332E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.133048E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 415, :) = (/ &
  &  0.975247E+00_JPRB, 0.968097E+00_JPRB, 0.960570E+00_JPRB, 0.952676E+00_JPRB &
  &, 0.944416E+00_JPRB, 0.935795E+00_JPRB, 0.926822E+00_JPRB &
  &, 0.917499E+00_JPRB, 0.907836E+00_JPRB, 0.897837E+00_JPRB, 0.887509E+00_JPRB &
  &, 0.876859E+00_JPRB, 0.865898E+00_JPRB, 0.854629E+00_JPRB &
  &, 0.843061E+00_JPRB, 0.831205E+00_JPRB, 0.819067E+00_JPRB, 0.806658E+00_JPRB &
  &, 0.793989E+00_JPRB, 0.781068E+00_JPRB, 0.767906E+00_JPRB &
  &, 0.754516E+00_JPRB, 0.740907E+00_JPRB, 0.727092E+00_JPRB, 0.713086E+00_JPRB &
  &, 0.698898E+00_JPRB, 0.684546E+00_JPRB, 0.670040E+00_JPRB &
  &, 0.655395E+00_JPRB, 0.640628E+00_JPRB, 0.625752E+00_JPRB, 0.610785E+00_JPRB &
  &, 0.595743E+00_JPRB, 0.580640E+00_JPRB, 0.565497E+00_JPRB &
  &, 0.550321E+00_JPRB, 0.535135E+00_JPRB, 0.519962E+00_JPRB, 0.504813E+00_JPRB &
  &, 0.489703E+00_JPRB, 0.474656E+00_JPRB, 0.459681E+00_JPRB &
  &, 0.444796E+00_JPRB, 0.430035E+00_JPRB, 0.415385E+00_JPRB, 0.400880E+00_JPRB &
  &, 0.386544E+00_JPRB, 0.372366E+00_JPRB, 0.358381E+00_JPRB &
  &, 0.344602E+00_JPRB, 0.331041E+00_JPRB, 0.317707E+00_JPRB, 0.304612E+00_JPRB &
  &, 0.291778E+00_JPRB, 0.279200E+00_JPRB, 0.266897E+00_JPRB &
  &, 0.254892E+00_JPRB, 0.243158E+00_JPRB, 0.231743E+00_JPRB, 0.220616E+00_JPRB &
  &, 0.209826E+00_JPRB, 0.199336E+00_JPRB, 0.189174E+00_JPRB &
  &, 0.179335E+00_JPRB, 0.169826E+00_JPRB, 0.160635E+00_JPRB, 0.151786E+00_JPRB &
  &, 0.143262E+00_JPRB, 0.135065E+00_JPRB, 0.127193E+00_JPRB &
  &, 0.119643E+00_JPRB, 0.112408E+00_JPRB, 0.105503E+00_JPRB, 0.988950E-01_JPRB &
  &, 0.926180E-01_JPRB, 0.866118E-01_JPRB, 0.809054E-01_JPRB &
  &, 0.755045E-01_JPRB, 0.703639E-01_JPRB, 0.655096E-01_JPRB, 0.609164E-01_JPRB &
  &, 0.565562E-01_JPRB, 0.524775E-01_JPRB, 0.485952E-01_JPRB &
  &, 0.449834E-01_JPRB, 0.415791E-01_JPRB, 0.383712E-01_JPRB, 0.353766E-01_JPRB &
  &, 0.325825E-01_JPRB, 0.299740E-01_JPRB, 0.275350E-01_JPRB &
  &, 0.252786E-01_JPRB, 0.231541E-01_JPRB, 0.212049E-01_JPRB, 0.193765E-01_JPRB &
  &, 0.176784E-01_JPRB, 0.161199E-01_JPRB, 0.147109E-01_JPRB &
  &, 0.133540E-01_JPRB, 0.121628E-01_JPRB, 0.110368E-01_JPRB, 0.998074E-02_JPRB &
  &, 0.903800E-02_JPRB, 0.817670E-02_JPRB, 0.740207E-02_JPRB &
  &, 0.667930E-02_JPRB, 0.601189E-02_JPRB, 0.540341E-02_JPRB, 0.485752E-02_JPRB &
  &, 0.433512E-02_JPRB, 0.388145E-02_JPRB, 0.350037E-02_JPRB &
  &, 0.310606E-02_JPRB, 0.278945E-02_JPRB, 0.246205E-02_JPRB, 0.221766E-02_JPRB &
  &, 0.196503E-02_JPRB, 0.175247E-02_JPRB, 0.153291E-02_JPRB &
  &, 0.135612E-02_JPRB, 0.122422E-02_JPRB, 0.108802E-02_JPRB, 0.947486E-03_JPRB &
  &, 0.802548E-03_JPRB, 0.706754E-03_JPRB, 0.607987E-03_JPRB &
  &, 0.561343E-03_JPRB, 0.457297E-03_JPRB, 0.406872E-03_JPRB, 0.354914E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.246332E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.194572E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 416, :) = (/ &
  &  0.975499E+00_JPRB, 0.968411E+00_JPRB, 0.960946E+00_JPRB, 0.953112E+00_JPRB &
  &, 0.944910E+00_JPRB, 0.936349E+00_JPRB, 0.927433E+00_JPRB &
  &, 0.918167E+00_JPRB, 0.908559E+00_JPRB, 0.898615E+00_JPRB, 0.888342E+00_JPRB &
  &, 0.877746E+00_JPRB, 0.866834E+00_JPRB, 0.855615E+00_JPRB &
  &, 0.844097E+00_JPRB, 0.832289E+00_JPRB, 0.820198E+00_JPRB, 0.807834E+00_JPRB &
  &, 0.795209E+00_JPRB, 0.782327E+00_JPRB, 0.769209E+00_JPRB &
  &, 0.755855E+00_JPRB, 0.742284E+00_JPRB, 0.728508E+00_JPRB, 0.714532E+00_JPRB &
  &, 0.700378E+00_JPRB, 0.686055E+00_JPRB, 0.671578E+00_JPRB &
  &, 0.656963E+00_JPRB, 0.642219E+00_JPRB, 0.627370E+00_JPRB, 0.612423E+00_JPRB &
  &, 0.597400E+00_JPRB, 0.582312E+00_JPRB, 0.567184E+00_JPRB &
  &, 0.552023E+00_JPRB, 0.536852E+00_JPRB, 0.521683E+00_JPRB, 0.506538E+00_JPRB &
  &, 0.491440E+00_JPRB, 0.476384E+00_JPRB, 0.461420E+00_JPRB &
  &, 0.446535E+00_JPRB, 0.431760E+00_JPRB, 0.417107E+00_JPRB, 0.402597E+00_JPRB &
  &, 0.388242E+00_JPRB, 0.374056E+00_JPRB, 0.360061E+00_JPRB &
  &, 0.346271E+00_JPRB, 0.332683E+00_JPRB, 0.319334E+00_JPRB, 0.306221E+00_JPRB &
  &, 0.293354E+00_JPRB, 0.280753E+00_JPRB, 0.268427E+00_JPRB &
  &, 0.256380E+00_JPRB, 0.244633E+00_JPRB, 0.233187E+00_JPRB, 0.222027E+00_JPRB &
  &, 0.211201E+00_JPRB, 0.200672E+00_JPRB, 0.190488E+00_JPRB &
  &, 0.180605E+00_JPRB, 0.171068E+00_JPRB, 0.161848E+00_JPRB, 0.152948E+00_JPRB &
  &, 0.144391E+00_JPRB, 0.136157E+00_JPRB, 0.128247E+00_JPRB &
  &, 0.120655E+00_JPRB, 0.113398E+00_JPRB, 0.106448E+00_JPRB, 0.998149E-01_JPRB &
  &, 0.934882E-01_JPRB, 0.874530E-01_JPRB, 0.817160E-01_JPRB &
  &, 0.762584E-01_JPRB, 0.710833E-01_JPRB, 0.661927E-01_JPRB, 0.615614E-01_JPRB &
  &, 0.571874E-01_JPRB, 0.530673E-01_JPRB, 0.491690E-01_JPRB &
  &, 0.455125E-01_JPRB, 0.420898E-01_JPRB, 0.388627E-01_JPRB, 0.358478E-01_JPRB &
  &, 0.330024E-01_JPRB, 0.303711E-01_JPRB, 0.279082E-01_JPRB &
  &, 0.256269E-01_JPRB, 0.234765E-01_JPRB, 0.215001E-01_JPRB, 0.196770E-01_JPRB &
  &, 0.179502E-01_JPRB, 0.163965E-01_JPRB, 0.149220E-01_JPRB &
  &, 0.135686E-01_JPRB, 0.123447E-01_JPRB, 0.112218E-01_JPRB, 0.101689E-01_JPRB &
  &, 0.919102E-02_JPRB, 0.833225E-02_JPRB, 0.752066E-02_JPRB &
  &, 0.679983E-02_JPRB, 0.609355E-02_JPRB, 0.548639E-02_JPRB, 0.494183E-02_JPRB &
  &, 0.442076E-02_JPRB, 0.396845E-02_JPRB, 0.354455E-02_JPRB &
  &, 0.319580E-02_JPRB, 0.283502E-02_JPRB, 0.255458E-02_JPRB, 0.226463E-02_JPRB &
  &, 0.201272E-02_JPRB, 0.180087E-02_JPRB, 0.158204E-02_JPRB &
  &, 0.140598E-02_JPRB, 0.122422E-02_JPRB, 0.108802E-02_JPRB, 0.947486E-03_JPRB &
  &, 0.855384E-03_JPRB, 0.760351E-03_JPRB, 0.662349E-03_JPRB &
  &, 0.561343E-03_JPRB, 0.513209E-03_JPRB, 0.406872E-03_JPRB, 0.354914E-03_JPRB &
  &, 0.301407E-03_JPRB, 0.305415E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.194572E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.740184E-04_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 417, :) = (/ &
  &  0.975753E+00_JPRB, 0.968726E+00_JPRB, 0.961321E+00_JPRB, 0.953547E+00_JPRB &
  &, 0.945405E+00_JPRB, 0.936902E+00_JPRB, 0.928044E+00_JPRB &
  &, 0.918836E+00_JPRB, 0.909284E+00_JPRB, 0.899395E+00_JPRB, 0.889175E+00_JPRB &
  &, 0.878631E+00_JPRB, 0.867772E+00_JPRB, 0.856603E+00_JPRB &
  &, 0.845134E+00_JPRB, 0.833373E+00_JPRB, 0.821329E+00_JPRB, 0.809011E+00_JPRB &
  &, 0.796428E+00_JPRB, 0.783590E+00_JPRB, 0.770509E+00_JPRB &
  &, 0.757198E+00_JPRB, 0.743664E+00_JPRB, 0.729920E+00_JPRB, 0.715985E+00_JPRB &
  &, 0.701862E+00_JPRB, 0.687567E+00_JPRB, 0.673120E+00_JPRB &
  &, 0.658531E+00_JPRB, 0.643813E+00_JPRB, 0.628984E+00_JPRB, 0.614060E+00_JPRB &
  &, 0.599057E+00_JPRB, 0.583989E+00_JPRB, 0.568872E+00_JPRB &
  &, 0.553725E+00_JPRB, 0.538559E+00_JPRB, 0.523404E+00_JPRB, 0.508272E+00_JPRB &
  &, 0.493167E+00_JPRB, 0.478123E+00_JPRB, 0.463149E+00_JPRB &
  &, 0.448274E+00_JPRB, 0.433486E+00_JPRB, 0.418828E+00_JPRB, 0.404314E+00_JPRB &
  &, 0.389953E+00_JPRB, 0.375759E+00_JPRB, 0.361742E+00_JPRB &
  &, 0.347940E+00_JPRB, 0.334338E+00_JPRB, 0.320960E+00_JPRB, 0.307830E+00_JPRB &
  &, 0.294943E+00_JPRB, 0.282321E+00_JPRB, 0.269971E+00_JPRB &
  &, 0.257899E+00_JPRB, 0.246107E+00_JPRB, 0.234631E+00_JPRB, 0.223454E+00_JPRB &
  &, 0.212593E+00_JPRB, 0.202026E+00_JPRB, 0.191801E+00_JPRB &
  &, 0.181894E+00_JPRB, 0.172311E+00_JPRB, 0.163061E+00_JPRB, 0.154130E+00_JPRB &
  &, 0.145519E+00_JPRB, 0.137249E+00_JPRB, 0.129320E+00_JPRB &
  &, 0.121688E+00_JPRB, 0.114389E+00_JPRB, 0.107393E+00_JPRB, 0.100735E+00_JPRB &
  &, 0.943584E-01_JPRB, 0.882943E-01_JPRB, 0.825266E-01_JPRB &
  &, 0.770367E-01_JPRB, 0.718275E-01_JPRB, 0.669010E-01_JPRB, 0.622321E-01_JPRB &
  &, 0.578186E-01_JPRB, 0.536571E-01_JPRB, 0.497428E-01_JPRB &
  &, 0.460416E-01_JPRB, 0.425722E-01_JPRB, 0.393252E-01_JPRB, 0.362895E-01_JPRB &
  &, 0.334223E-01_JPRB, 0.307682E-01_JPRB, 0.282814E-01_JPRB &
  &, 0.259753E-01_JPRB, 0.237988E-01_JPRB, 0.217954E-01_JPRB, 0.199441E-01_JPRB &
  &, 0.182220E-01_JPRB, 0.166385E-01_JPRB, 0.151681E-01_JPRB &
  &, 0.137833E-01_JPRB, 0.125267E-01_JPRB, 0.114068E-01_JPRB, 0.103194E-01_JPRB &
  &, 0.934404E-02_JPRB, 0.844892E-02_JPRB, 0.763925E-02_JPRB &
  &, 0.692036E-02_JPRB, 0.621603E-02_JPRB, 0.561085E-02_JPRB, 0.502613E-02_JPRB &
  &, 0.450641E-02_JPRB, 0.405545E-02_JPRB, 0.363292E-02_JPRB &
  &, 0.324067E-02_JPRB, 0.288058E-02_JPRB, 0.260085E-02_JPRB, 0.231160E-02_JPRB &
  &, 0.206040E-02_JPRB, 0.180087E-02_JPRB, 0.163116E-02_JPRB &
  &, 0.145583E-02_JPRB, 0.127481E-02_JPRB, 0.113936E-02_JPRB, 0.999568E-03_JPRB &
  &, 0.855384E-03_JPRB, 0.760351E-03_JPRB, 0.662349E-03_JPRB &
  &, 0.561343E-03_JPRB, 0.513209E-03_JPRB, 0.463567E-03_JPRB, 0.412400E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.194572E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 418, :) = (/ &
  &  0.976003E+00_JPRB, 0.969041E+00_JPRB, 0.961696E+00_JPRB, 0.953982E+00_JPRB &
  &, 0.945900E+00_JPRB, 0.937456E+00_JPRB, 0.928655E+00_JPRB &
  &, 0.919503E+00_JPRB, 0.910008E+00_JPRB, 0.900173E+00_JPRB, 0.890008E+00_JPRB &
  &, 0.879516E+00_JPRB, 0.868709E+00_JPRB, 0.857590E+00_JPRB &
  &, 0.846171E+00_JPRB, 0.834457E+00_JPRB, 0.822460E+00_JPRB, 0.810188E+00_JPRB &
  &, 0.797648E+00_JPRB, 0.784853E+00_JPRB, 0.771816E+00_JPRB &
  &, 0.758541E+00_JPRB, 0.745044E+00_JPRB, 0.731340E+00_JPRB, 0.717434E+00_JPRB &
  &, 0.703346E+00_JPRB, 0.689083E+00_JPRB, 0.674665E+00_JPRB &
  &, 0.660102E+00_JPRB, 0.645408E+00_JPRB, 0.630606E+00_JPRB, 0.615702E+00_JPRB &
  &, 0.600718E+00_JPRB, 0.585666E+00_JPRB, 0.570564E+00_JPRB &
  &, 0.555428E+00_JPRB, 0.540276E+00_JPRB, 0.525135E+00_JPRB, 0.509997E+00_JPRB &
  &, 0.494904E+00_JPRB, 0.479862E+00_JPRB, 0.464888E+00_JPRB &
  &, 0.450013E+00_JPRB, 0.435223E+00_JPRB, 0.420562E+00_JPRB, 0.406043E+00_JPRB &
  &, 0.391664E+00_JPRB, 0.377461E+00_JPRB, 0.363435E+00_JPRB &
  &, 0.349608E+00_JPRB, 0.335993E+00_JPRB, 0.322601E+00_JPRB, 0.309439E+00_JPRB &
  &, 0.296533E+00_JPRB, 0.283889E+00_JPRB, 0.271501E+00_JPRB &
  &, 0.259402E+00_JPRB, 0.247598E+00_JPRB, 0.236091E+00_JPRB, 0.224881E+00_JPRB &
  &, 0.213985E+00_JPRB, 0.203398E+00_JPRB, 0.193133E+00_JPRB &
  &, 0.183182E+00_JPRB, 0.173573E+00_JPRB, 0.164275E+00_JPRB, 0.155311E+00_JPRB &
  &, 0.146667E+00_JPRB, 0.138361E+00_JPRB, 0.130374E+00_JPRB &
  &, 0.122722E+00_JPRB, 0.115379E+00_JPRB, 0.108360E+00_JPRB, 0.101655E+00_JPRB &
  &, 0.952286E-01_JPRB, 0.891355E-01_JPRB, 0.833134E-01_JPRB &
  &, 0.778150E-01_JPRB, 0.725718E-01_JPRB, 0.676094E-01_JPRB, 0.629028E-01_JPRB &
  &, 0.584498E-01_JPRB, 0.542738E-01_JPRB, 0.503167E-01_JPRB &
  &, 0.465985E-01_JPRB, 0.431113E-01_JPRB, 0.398167E-01_JPRB, 0.367312E-01_JPRB &
  &, 0.338722E-01_JPRB, 0.311653E-01_JPRB, 0.286547E-01_JPRB &
  &, 0.263236E-01_JPRB, 0.241534E-01_JPRB, 0.221235E-01_JPRB, 0.202447E-01_JPRB &
  &, 0.184938E-01_JPRB, 0.168805E-01_JPRB, 0.153792E-01_JPRB &
  &, 0.139979E-01_JPRB, 0.127450E-01_JPRB, 0.115918E-01_JPRB, 0.105075E-01_JPRB &
  &, 0.953531E-02_JPRB, 0.860448E-02_JPRB, 0.779737E-02_JPRB &
  &, 0.704089E-02_JPRB, 0.633852E-02_JPRB, 0.569383E-02_JPRB, 0.515259E-02_JPRB &
  &, 0.459206E-02_JPRB, 0.414245E-02_JPRB, 0.372128E-02_JPRB &
  &, 0.333041E-02_JPRB, 0.297171E-02_JPRB, 0.264711E-02_JPRB, 0.235857E-02_JPRB &
  &, 0.210808E-02_JPRB, 0.184927E-02_JPRB, 0.163116E-02_JPRB &
  &, 0.145583E-02_JPRB, 0.127481E-02_JPRB, 0.113936E-02_JPRB, 0.999568E-03_JPRB &
  &, 0.908221E-03_JPRB, 0.760351E-03_JPRB, 0.662349E-03_JPRB &
  &, 0.616477E-03_JPRB, 0.513209E-03_JPRB, 0.463567E-03_JPRB, 0.412400E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.192113E-03_JPRB, 0.194572E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 419, :) = (/ &
  &  0.976256E+00_JPRB, 0.969354E+00_JPRB, 0.962071E+00_JPRB, 0.954417E+00_JPRB &
  &, 0.946395E+00_JPRB, 0.938009E+00_JPRB, 0.929266E+00_JPRB &
  &, 0.920172E+00_JPRB, 0.910732E+00_JPRB, 0.900952E+00_JPRB, 0.890841E+00_JPRB &
  &, 0.880403E+00_JPRB, 0.869645E+00_JPRB, 0.858578E+00_JPRB &
  &, 0.847208E+00_JPRB, 0.835543E+00_JPRB, 0.823593E+00_JPRB, 0.811365E+00_JPRB &
  &, 0.798870E+00_JPRB, 0.786118E+00_JPRB, 0.773120E+00_JPRB &
  &, 0.759884E+00_JPRB, 0.746428E+00_JPRB, 0.732756E+00_JPRB, 0.718887E+00_JPRB &
  &, 0.704830E+00_JPRB, 0.690600E+00_JPRB, 0.676211E+00_JPRB &
  &, 0.661674E+00_JPRB, 0.647007E+00_JPRB, 0.632224E+00_JPRB, 0.617344E+00_JPRB &
  &, 0.602380E+00_JPRB, 0.587347E+00_JPRB, 0.572260E+00_JPRB &
  &, 0.557139E+00_JPRB, 0.542002E+00_JPRB, 0.526856E+00_JPRB, 0.511741E+00_JPRB &
  &, 0.496651E+00_JPRB, 0.481611E+00_JPRB, 0.466638E+00_JPRB &
  &, 0.451751E+00_JPRB, 0.436971E+00_JPRB, 0.422296E+00_JPRB, 0.407760E+00_JPRB &
  &, 0.393387E+00_JPRB, 0.379164E+00_JPRB, 0.365128E+00_JPRB &
  &, 0.351277E+00_JPRB, 0.337649E+00_JPRB, 0.324241E+00_JPRB, 0.311062E+00_JPRB &
  &, 0.298137E+00_JPRB, 0.285458E+00_JPRB, 0.273060E+00_JPRB &
  &, 0.260936E+00_JPRB, 0.249089E+00_JPRB, 0.237551E+00_JPRB, 0.226309E+00_JPRB &
  &, 0.215377E+00_JPRB, 0.204752E+00_JPRB, 0.194464E+00_JPRB &
  &, 0.184470E+00_JPRB, 0.174834E+00_JPRB, 0.165488E+00_JPRB, 0.156493E+00_JPRB &
  &, 0.147815E+00_JPRB, 0.139473E+00_JPRB, 0.131447E+00_JPRB &
  &, 0.123755E+00_JPRB, 0.116391E+00_JPRB, 0.109327E+00_JPRB, 0.102575E+00_JPRB &
  &, 0.961217E-01_JPRB, 0.899768E-01_JPRB, 0.841479E-01_JPRB &
  &, 0.785933E-01_JPRB, 0.733160E-01_JPRB, 0.683178E-01_JPRB, 0.635735E-01_JPRB &
  &, 0.591073E-01_JPRB, 0.548636E-01_JPRB, 0.508905E-01_JPRB &
  &, 0.471276E-01_JPRB, 0.436220E-01_JPRB, 0.403081E-01_JPRB, 0.372024E-01_JPRB &
  &, 0.342921E-01_JPRB, 0.315929E-01_JPRB, 0.290590E-01_JPRB &
  &, 0.266719E-01_JPRB, 0.244757E-01_JPRB, 0.224188E-01_JPRB, 0.205452E-01_JPRB &
  &, 0.187656E-01_JPRB, 0.171225E-01_JPRB, 0.156254E-01_JPRB &
  &, 0.142483E-01_JPRB, 0.129633E-01_JPRB, 0.117768E-01_JPRB, 0.106956E-01_JPRB &
  &, 0.968833E-02_JPRB, 0.876003E-02_JPRB, 0.791596E-02_JPRB &
  &, 0.716142E-02_JPRB, 0.646101E-02_JPRB, 0.581829E-02_JPRB, 0.523690E-02_JPRB &
  &, 0.472052E-02_JPRB, 0.422945E-02_JPRB, 0.376546E-02_JPRB &
  &, 0.337528E-02_JPRB, 0.301727E-02_JPRB, 0.269338E-02_JPRB, 0.240554E-02_JPRB &
  &, 0.215577E-02_JPRB, 0.189768E-02_JPRB, 0.168029E-02_JPRB &
  &, 0.150569E-02_JPRB, 0.132540E-02_JPRB, 0.119069E-02_JPRB, 0.105165E-02_JPRB &
  &, 0.908221E-03_JPRB, 0.813947E-03_JPRB, 0.716711E-03_JPRB &
  &, 0.616477E-03_JPRB, 0.513209E-03_JPRB, 0.463567E-03_JPRB, 0.412400E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.194572E-03_JPRB, 0.134699E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 420, :) = (/ &
  &  0.976508E+00_JPRB, 0.969668E+00_JPRB, 0.962446E+00_JPRB, 0.954853E+00_JPRB &
  &, 0.946889E+00_JPRB, 0.938562E+00_JPRB, 0.929878E+00_JPRB &
  &, 0.920840E+00_JPRB, 0.911455E+00_JPRB, 0.901732E+00_JPRB, 0.891674E+00_JPRB &
  &, 0.881288E+00_JPRB, 0.870583E+00_JPRB, 0.859567E+00_JPRB &
  &, 0.848246E+00_JPRB, 0.836628E+00_JPRB, 0.824725E+00_JPRB, 0.812543E+00_JPRB &
  &, 0.800092E+00_JPRB, 0.787381E+00_JPRB, 0.774423E+00_JPRB &
  &, 0.761230E+00_JPRB, 0.747809E+00_JPRB, 0.734175E+00_JPRB, 0.720340E+00_JPRB &
  &, 0.706318E+00_JPRB, 0.692116E+00_JPRB, 0.677756E+00_JPRB &
  &, 0.663246E+00_JPRB, 0.648606E+00_JPRB, 0.633851E+00_JPRB, 0.618990E+00_JPRB &
  &, 0.604041E+00_JPRB, 0.589028E+00_JPRB, 0.573957E+00_JPRB &
  &, 0.558850E+00_JPRB, 0.543718E+00_JPRB, 0.528596E+00_JPRB, 0.513476E+00_JPRB &
  &, 0.498388E+00_JPRB, 0.483361E+00_JPRB, 0.468388E+00_JPRB &
  &, 0.453501E+00_JPRB, 0.438708E+00_JPRB, 0.424041E+00_JPRB, 0.409501E+00_JPRB &
  &, 0.395097E+00_JPRB, 0.380867E+00_JPRB, 0.366821E+00_JPRB &
  &, 0.352959E+00_JPRB, 0.339318E+00_JPRB, 0.325881E+00_JPRB, 0.312686E+00_JPRB &
  &, 0.299727E+00_JPRB, 0.287041E+00_JPRB, 0.274605E+00_JPRB &
  &, 0.262455E+00_JPRB, 0.250595E+00_JPRB, 0.239011E+00_JPRB, 0.227753E+00_JPRB &
  &, 0.216786E+00_JPRB, 0.206123E+00_JPRB, 0.195795E+00_JPRB &
  &, 0.185777E+00_JPRB, 0.176095E+00_JPRB, 0.166720E+00_JPRB, 0.157694E+00_JPRB &
  &, 0.148982E+00_JPRB, 0.140605E+00_JPRB, 0.132542E+00_JPRB &
  &, 0.124809E+00_JPRB, 0.117382E+00_JPRB, 0.110295E+00_JPRB, 0.103495E+00_JPRB &
  &, 0.970148E-01_JPRB, 0.908414E-01_JPRB, 0.849585E-01_JPRB &
  &, 0.793716E-01_JPRB, 0.740602E-01_JPRB, 0.690262E-01_JPRB, 0.642442E-01_JPRB &
  &, 0.597385E-01_JPRB, 0.554802E-01_JPRB, 0.514644E-01_JPRB &
  &, 0.476846E-01_JPRB, 0.441328E-01_JPRB, 0.407995E-01_JPRB, 0.376736E-01_JPRB &
  &, 0.347420E-01_JPRB, 0.319900E-01_JPRB, 0.294322E-01_JPRB &
  &, 0.270519E-01_JPRB, 0.248303E-01_JPRB, 0.227469E-01_JPRB, 0.208457E-01_JPRB &
  &, 0.190375E-01_JPRB, 0.173991E-01_JPRB, 0.158715E-01_JPRB &
  &, 0.144630E-01_JPRB, 0.131452E-01_JPRB, 0.119618E-01_JPRB, 0.108461E-01_JPRB &
  &, 0.984134E-02_JPRB, 0.891559E-02_JPRB, 0.807408E-02_JPRB &
  &, 0.728195E-02_JPRB, 0.658350E-02_JPRB, 0.590127E-02_JPRB, 0.532120E-02_JPRB &
  &, 0.480617E-02_JPRB, 0.431645E-02_JPRB, 0.385383E-02_JPRB &
  &, 0.346502E-02_JPRB, 0.310840E-02_JPRB, 0.273964E-02_JPRB, 0.245251E-02_JPRB &
  &, 0.220345E-02_JPRB, 0.194608E-02_JPRB, 0.172941E-02_JPRB &
  &, 0.155555E-02_JPRB, 0.137600E-02_JPRB, 0.119069E-02_JPRB, 0.105165E-02_JPRB &
  &, 0.908221E-03_JPRB, 0.813947E-03_JPRB, 0.716711E-03_JPRB &
  &, 0.616477E-03_JPRB, 0.569121E-03_JPRB, 0.463567E-03_JPRB, 0.412400E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.249563E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.194572E-03_JPRB, 0.197048E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART60',1,ZHOOK_HANDLE)
END SUBROUTINE PART60

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART61

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART61',0,ZHOOK_HANDLE)

XCW( 421, :) = (/ &
  &  0.976761E+00_JPRB, 0.969981E+00_JPRB, 0.962821E+00_JPRB, 0.955287E+00_JPRB &
  &, 0.947384E+00_JPRB, 0.939116E+00_JPRB, 0.930488E+00_JPRB &
  &, 0.921507E+00_JPRB, 0.912180E+00_JPRB, 0.902510E+00_JPRB, 0.892506E+00_JPRB &
  &, 0.882175E+00_JPRB, 0.871522E+00_JPRB, 0.860555E+00_JPRB &
  &, 0.849284E+00_JPRB, 0.837716E+00_JPRB, 0.825858E+00_JPRB, 0.813722E+00_JPRB &
  &, 0.801314E+00_JPRB, 0.788647E+00_JPRB, 0.775730E+00_JPRB &
  &, 0.762576E+00_JPRB, 0.749192E+00_JPRB, 0.735595E+00_JPRB, 0.721797E+00_JPRB &
  &, 0.707806E+00_JPRB, 0.693636E+00_JPRB, 0.679306E+00_JPRB &
  &, 0.664826E+00_JPRB, 0.650208E+00_JPRB, 0.635473E+00_JPRB, 0.620636E+00_JPRB &
  &, 0.605711E+00_JPRB, 0.590714E+00_JPRB, 0.575657E+00_JPRB &
  &, 0.560562E+00_JPRB, 0.545444E+00_JPRB, 0.530327E+00_JPRB, 0.515220E+00_JPRB &
  &, 0.500136E+00_JPRB, 0.485110E+00_JPRB, 0.470139E+00_JPRB &
  &, 0.455251E+00_JPRB, 0.440456E+00_JPRB, 0.425775E+00_JPRB, 0.411230E+00_JPRB &
  &, 0.396832E+00_JPRB, 0.382582E+00_JPRB, 0.368527E+00_JPRB &
  &, 0.354654E+00_JPRB, 0.340987E+00_JPRB, 0.327535E+00_JPRB, 0.314309E+00_JPRB &
  &, 0.301345E+00_JPRB, 0.288623E+00_JPRB, 0.276165E+00_JPRB &
  &, 0.263989E+00_JPRB, 0.252086E+00_JPRB, 0.240488E+00_JPRB, 0.229180E+00_JPRB &
  &, 0.218195E+00_JPRB, 0.207512E+00_JPRB, 0.197144E+00_JPRB &
  &, 0.187084E+00_JPRB, 0.177375E+00_JPRB, 0.167971E+00_JPRB, 0.158895E+00_JPRB &
  &, 0.150150E+00_JPRB, 0.141717E+00_JPRB, 0.133636E+00_JPRB &
  &, 0.125864E+00_JPRB, 0.118394E+00_JPRB, 0.111262E+00_JPRB, 0.104437E+00_JPRB &
  &, 0.979308E-01_JPRB, 0.917060E-01_JPRB, 0.857930E-01_JPRB &
  &, 0.801742E-01_JPRB, 0.748044E-01_JPRB, 0.697345E-01_JPRB, 0.649408E-01_JPRB &
  &, 0.603960E-01_JPRB, 0.561237E-01_JPRB, 0.520655E-01_JPRB &
  &, 0.482415E-01_JPRB, 0.446719E-01_JPRB, 0.412910E-01_JPRB, 0.381447E-01_JPRB &
  &, 0.351918E-01_JPRB, 0.324176E-01_JPRB, 0.298365E-01_JPRB &
  &, 0.274002E-01_JPRB, 0.251527E-01_JPRB, 0.230750E-01_JPRB, 0.211462E-01_JPRB &
  &, 0.193433E-01_JPRB, 0.176756E-01_JPRB, 0.161177E-01_JPRB &
  &, 0.146776E-01_JPRB, 0.133635E-01_JPRB, 0.121468E-01_JPRB, 0.110342E-01_JPRB &
  &, 0.999436E-02_JPRB, 0.907115E-02_JPRB, 0.819267E-02_JPRB &
  &, 0.740248E-02_JPRB, 0.670598E-02_JPRB, 0.602573E-02_JPRB, 0.544766E-02_JPRB &
  &, 0.489182E-02_JPRB, 0.440345E-02_JPRB, 0.394219E-02_JPRB &
  &, 0.350989E-02_JPRB, 0.315397E-02_JPRB, 0.283217E-02_JPRB, 0.249949E-02_JPRB &
  &, 0.225113E-02_JPRB, 0.199448E-02_JPRB, 0.177854E-02_JPRB &
  &, 0.155555E-02_JPRB, 0.137600E-02_JPRB, 0.124203E-02_JPRB, 0.110373E-02_JPRB &
  &, 0.961057E-03_JPRB, 0.867544E-03_JPRB, 0.716711E-03_JPRB &
  &, 0.671611E-03_JPRB, 0.569121E-03_JPRB, 0.520263E-03_JPRB, 0.412400E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.194572E-03_JPRB, 0.197048E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.748618E-04_JPRB, 0.757111E-04_JPRB/)
XCW( 422, :) = (/ &
  &  0.977014E+00_JPRB, 0.970296E+00_JPRB, 0.963195E+00_JPRB, 0.955723E+00_JPRB &
  &, 0.947878E+00_JPRB, 0.939669E+00_JPRB, 0.931100E+00_JPRB &
  &, 0.922176E+00_JPRB, 0.912904E+00_JPRB, 0.903289E+00_JPRB, 0.893340E+00_JPRB &
  &, 0.883060E+00_JPRB, 0.872459E+00_JPRB, 0.861545E+00_JPRB &
  &, 0.850323E+00_JPRB, 0.838801E+00_JPRB, 0.826992E+00_JPRB, 0.814900E+00_JPRB &
  &, 0.802538E+00_JPRB, 0.789913E+00_JPRB, 0.777037E+00_JPRB &
  &, 0.763922E+00_JPRB, 0.750579E+00_JPRB, 0.737018E+00_JPRB, 0.723250E+00_JPRB &
  &, 0.709293E+00_JPRB, 0.695156E+00_JPRB, 0.680855E+00_JPRB &
  &, 0.666402E+00_JPRB, 0.651811E+00_JPRB, 0.637103E+00_JPRB, 0.622286E+00_JPRB &
  &, 0.607381E+00_JPRB, 0.592399E+00_JPRB, 0.577358E+00_JPRB &
  &, 0.562283E+00_JPRB, 0.547180E+00_JPRB, 0.532068E+00_JPRB, 0.516964E+00_JPRB &
  &, 0.501894E+00_JPRB, 0.486859E+00_JPRB, 0.471889E+00_JPRB &
  &, 0.457001E+00_JPRB, 0.442204E+00_JPRB, 0.427531E+00_JPRB, 0.412970E+00_JPRB &
  &, 0.398555E+00_JPRB, 0.384310E+00_JPRB, 0.370233E+00_JPRB &
  &, 0.356336E+00_JPRB, 0.342656E+00_JPRB, 0.329189E+00_JPRB, 0.315946E+00_JPRB &
  &, 0.302949E+00_JPRB, 0.290206E+00_JPRB, 0.277724E+00_JPRB &
  &, 0.265523E+00_JPRB, 0.253608E+00_JPRB, 0.241964E+00_JPRB, 0.230641E+00_JPRB &
  &, 0.219604E+00_JPRB, 0.208901E+00_JPRB, 0.198493E+00_JPRB &
  &, 0.188408E+00_JPRB, 0.178655E+00_JPRB, 0.169203E+00_JPRB, 0.160096E+00_JPRB &
  &, 0.151318E+00_JPRB, 0.142870E+00_JPRB, 0.134731E+00_JPRB &
  &, 0.126918E+00_JPRB, 0.119427E+00_JPRB, 0.112251E+00_JPRB, 0.105380E+00_JPRB &
  &, 0.988239E-01_JPRB, 0.925706E-01_JPRB, 0.866274E-01_JPRB &
  &, 0.809525E-01_JPRB, 0.755735E-01_JPRB, 0.704682E-01_JPRB, 0.656373E-01_JPRB &
  &, 0.610536E-01_JPRB, 0.567403E-01_JPRB, 0.526667E-01_JPRB &
  &, 0.488263E-01_JPRB, 0.452110E-01_JPRB, 0.418113E-01_JPRB, 0.386159E-01_JPRB &
  &, 0.356417E-01_JPRB, 0.328452E-01_JPRB, 0.302097E-01_JPRB &
  &, 0.277802E-01_JPRB, 0.255072E-01_JPRB, 0.234031E-01_JPRB, 0.214467E-01_JPRB &
  &, 0.196151E-01_JPRB, 0.179176E-01_JPRB, 0.163639E-01_JPRB &
  &, 0.149281E-01_JPRB, 0.135818E-01_JPRB, 0.123689E-01_JPRB, 0.112224E-01_JPRB &
  &, 0.101856E-01_JPRB, 0.922670E-02_JPRB, 0.835078E-02_JPRB &
  &, 0.756318E-02_JPRB, 0.682847E-02_JPRB, 0.615020E-02_JPRB, 0.553196E-02_JPRB &
  &, 0.497746E-02_JPRB, 0.449044E-02_JPRB, 0.403056E-02_JPRB &
  &, 0.359963E-02_JPRB, 0.319953E-02_JPRB, 0.287844E-02_JPRB, 0.254646E-02_JPRB &
  &, 0.229882E-02_JPRB, 0.204288E-02_JPRB, 0.182767E-02_JPRB &
  &, 0.160540E-02_JPRB, 0.142659E-02_JPRB, 0.124203E-02_JPRB, 0.110373E-02_JPRB &
  &, 0.961057E-03_JPRB, 0.867544E-03_JPRB, 0.771074E-03_JPRB &
  &, 0.671611E-03_JPRB, 0.569121E-03_JPRB, 0.520263E-03_JPRB, 0.469886E-03_JPRB &
  &, 0.359689E-03_JPRB, 0.305415E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.194572E-03_JPRB, 0.197048E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.757111E-04_JPRB/)
XCW( 423, :) = (/ &
  &  0.977266E+00_JPRB, 0.970608E+00_JPRB, 0.963569E+00_JPRB, 0.956157E+00_JPRB &
  &, 0.948372E+00_JPRB, 0.940222E+00_JPRB, 0.931711E+00_JPRB &
  &, 0.922844E+00_JPRB, 0.913627E+00_JPRB, 0.904069E+00_JPRB, 0.894173E+00_JPRB &
  &, 0.883946E+00_JPRB, 0.873398E+00_JPRB, 0.862533E+00_JPRB &
  &, 0.851361E+00_JPRB, 0.839888E+00_JPRB, 0.828126E+00_JPRB, 0.816080E+00_JPRB &
  &, 0.803761E+00_JPRB, 0.791178E+00_JPRB, 0.778347E+00_JPRB &
  &, 0.765271E+00_JPRB, 0.751963E+00_JPRB, 0.738441E+00_JPRB, 0.724710E+00_JPRB &
  &, 0.710785E+00_JPRB, 0.696679E+00_JPRB, 0.682405E+00_JPRB &
  &, 0.667981E+00_JPRB, 0.653418E+00_JPRB, 0.638730E+00_JPRB, 0.623936E+00_JPRB &
  &, 0.609051E+00_JPRB, 0.594089E+00_JPRB, 0.579069E+00_JPRB &
  &, 0.564003E+00_JPRB, 0.548906E+00_JPRB, 0.533808E+00_JPRB, 0.518719E+00_JPRB &
  &, 0.503651E+00_JPRB, 0.488619E+00_JPRB, 0.473650E+00_JPRB &
  &, 0.458762E+00_JPRB, 0.443963E+00_JPRB, 0.429277E+00_JPRB, 0.414711E+00_JPRB &
  &, 0.400290E+00_JPRB, 0.386038E+00_JPRB, 0.371939E+00_JPRB &
  &, 0.358044E+00_JPRB, 0.344338E+00_JPRB, 0.330857E+00_JPRB, 0.317597E+00_JPRB &
  &, 0.304568E+00_JPRB, 0.291804E+00_JPRB, 0.279299E+00_JPRB &
  &, 0.267073E+00_JPRB, 0.255115E+00_JPRB, 0.243457E+00_JPRB, 0.232101E+00_JPRB &
  &, 0.221030E+00_JPRB, 0.210290E+00_JPRB, 0.199842E+00_JPRB &
  &, 0.189733E+00_JPRB, 0.179935E+00_JPRB, 0.170455E+00_JPRB, 0.161316E+00_JPRB &
  &, 0.152505E+00_JPRB, 0.144002E+00_JPRB, 0.135825E+00_JPRB &
  &, 0.127973E+00_JPRB, 0.120461E+00_JPRB, 0.113240E+00_JPRB, 0.106344E+00_JPRB &
  &, 0.997399E-01_JPRB, 0.934586E-01_JPRB, 0.874619E-01_JPRB &
  &, 0.817551E-01_JPRB, 0.763425E-01_JPRB, 0.712019E-01_JPRB, 0.663338E-01_JPRB &
  &, 0.617374E-01_JPRB, 0.573569E-01_JPRB, 0.532679E-01_JPRB &
  &, 0.493832E-01_JPRB, 0.457502E-01_JPRB, 0.423028E-01_JPRB, 0.390871E-01_JPRB &
  &, 0.360916E-01_JPRB, 0.332728E-01_JPRB, 0.306141E-01_JPRB &
  &, 0.281601E-01_JPRB, 0.258618E-01_JPRB, 0.237312E-01_JPRB, 0.217472E-01_JPRB &
  &, 0.198869E-01_JPRB, 0.181942E-01_JPRB, 0.166101E-01_JPRB &
  &, 0.151427E-01_JPRB, 0.138002E-01_JPRB, 0.125539E-01_JPRB, 0.114105E-01_JPRB &
  &, 0.103386E-01_JPRB, 0.938226E-02_JPRB, 0.850890E-02_JPRB &
  &, 0.768371E-02_JPRB, 0.695096E-02_JPRB, 0.627466E-02_JPRB, 0.565842E-02_JPRB &
  &, 0.506311E-02_JPRB, 0.457744E-02_JPRB, 0.407474E-02_JPRB &
  &, 0.368937E-02_JPRB, 0.329066E-02_JPRB, 0.292470E-02_JPRB, 0.264040E-02_JPRB &
  &, 0.234650E-02_JPRB, 0.209128E-02_JPRB, 0.182767E-02_JPRB &
  &, 0.165526E-02_JPRB, 0.147718E-02_JPRB, 0.129336E-02_JPRB, 0.115582E-02_JPRB &
  &, 0.101389E-02_JPRB, 0.867544E-03_JPRB, 0.771074E-03_JPRB &
  &, 0.671611E-03_JPRB, 0.625033E-03_JPRB, 0.520263E-03_JPRB, 0.469886E-03_JPRB &
  &, 0.417970E-03_JPRB, 0.364499E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.194572E-03_JPRB, 0.197048E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.757111E-04_JPRB/)
XCW( 424, :) = (/ &
  &  0.977516E+00_JPRB, 0.970923E+00_JPRB, 0.963944E+00_JPRB, 0.956591E+00_JPRB &
  &, 0.948866E+00_JPRB, 0.940774E+00_JPRB, 0.932321E+00_JPRB &
  &, 0.923511E+00_JPRB, 0.914352E+00_JPRB, 0.904848E+00_JPRB, 0.895006E+00_JPRB &
  &, 0.884833E+00_JPRB, 0.874336E+00_JPRB, 0.863522E+00_JPRB &
  &, 0.852400E+00_JPRB, 0.840975E+00_JPRB, 0.829260E+00_JPRB, 0.817260E+00_JPRB &
  &, 0.804986E+00_JPRB, 0.792447E+00_JPRB, 0.779653E+00_JPRB &
  &, 0.766621E+00_JPRB, 0.753350E+00_JPRB, 0.739863E+00_JPRB, 0.726166E+00_JPRB &
  &, 0.712276E+00_JPRB, 0.698203E+00_JPRB, 0.683958E+00_JPRB &
  &, 0.669561E+00_JPRB, 0.655025E+00_JPRB, 0.640364E+00_JPRB, 0.625590E+00_JPRB &
  &, 0.610726E+00_JPRB, 0.595779E+00_JPRB, 0.580774E+00_JPRB &
  &, 0.565724E+00_JPRB, 0.550642E+00_JPRB, 0.535549E+00_JPRB, 0.520463E+00_JPRB &
  &, 0.505409E+00_JPRB, 0.490379E+00_JPRB, 0.475421E+00_JPRB &
  &, 0.460522E+00_JPRB, 0.445723E+00_JPRB, 0.431033E+00_JPRB, 0.416464E+00_JPRB &
  &, 0.402038E+00_JPRB, 0.387765E+00_JPRB, 0.373658E+00_JPRB &
  &, 0.359739E+00_JPRB, 0.346020E+00_JPRB, 0.332511E+00_JPRB, 0.319235E+00_JPRB &
  &, 0.306201E+00_JPRB, 0.293402E+00_JPRB, 0.280874E+00_JPRB &
  &, 0.268623E+00_JPRB, 0.256637E+00_JPRB, 0.244949E+00_JPRB, 0.233562E+00_JPRB &
  &, 0.222473E+00_JPRB, 0.211679E+00_JPRB, 0.201209E+00_JPRB &
  &, 0.191058E+00_JPRB, 0.181233E+00_JPRB, 0.171725E+00_JPRB, 0.162537E+00_JPRB &
  &, 0.153673E+00_JPRB, 0.145154E+00_JPRB, 0.136940E+00_JPRB &
  &, 0.129048E+00_JPRB, 0.121494E+00_JPRB, 0.114229E+00_JPRB, 0.107309E+00_JPRB &
  &, 0.100679E+00_JPRB, 0.943466E-01_JPRB, 0.883202E-01_JPRB &
  &, 0.825821E-01_JPRB, 0.771115E-01_JPRB, 0.719356E-01_JPRB, 0.670303E-01_JPRB &
  &, 0.623949E-01_JPRB, 0.580004E-01_JPRB, 0.538690E-01_JPRB &
  &, 0.499680E-01_JPRB, 0.462893E-01_JPRB, 0.428231E-01_JPRB, 0.395877E-01_JPRB &
  &, 0.365415E-01_JPRB, 0.337005E-01_JPRB, 0.310184E-01_JPRB &
  &, 0.285401E-01_JPRB, 0.262164E-01_JPRB, 0.240593E-01_JPRB, 0.220477E-01_JPRB &
  &, 0.201927E-01_JPRB, 0.184707E-01_JPRB, 0.168563E-01_JPRB &
  &, 0.153931E-01_JPRB, 0.140185E-01_JPRB, 0.127389E-01_JPRB, 0.115986E-01_JPRB &
  &, 0.105299E-01_JPRB, 0.953782E-02_JPRB, 0.862749E-02_JPRB &
  &, 0.780424E-02_JPRB, 0.707345E-02_JPRB, 0.635763E-02_JPRB, 0.574273E-02_JPRB &
  &, 0.514875E-02_JPRB, 0.466444E-02_JPRB, 0.416310E-02_JPRB &
  &, 0.373424E-02_JPRB, 0.333623E-02_JPRB, 0.301723E-02_JPRB, 0.268737E-02_JPRB &
  &, 0.239419E-02_JPRB, 0.213969E-02_JPRB, 0.187679E-02_JPRB &
  &, 0.170511E-02_JPRB, 0.147718E-02_JPRB, 0.134470E-02_JPRB, 0.115582E-02_JPRB &
  &, 0.101389E-02_JPRB, 0.921140E-03_JPRB, 0.825436E-03_JPRB &
  &, 0.726746E-03_JPRB, 0.625033E-03_JPRB, 0.520263E-03_JPRB, 0.469886E-03_JPRB &
  &, 0.417970E-03_JPRB, 0.364499E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.256096E-03_JPRB, 0.197048E-03_JPRB, 0.136362E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.757111E-04_JPRB/)
XCW( 425, :) = (/ &
  &  0.977768E+00_JPRB, 0.971235E+00_JPRB, 0.964318E+00_JPRB, 0.957027E+00_JPRB &
  &, 0.949361E+00_JPRB, 0.941328E+00_JPRB, 0.932932E+00_JPRB &
  &, 0.924179E+00_JPRB, 0.915076E+00_JPRB, 0.905627E+00_JPRB, 0.895840E+00_JPRB &
  &, 0.885719E+00_JPRB, 0.875275E+00_JPRB, 0.864512E+00_JPRB &
  &, 0.853439E+00_JPRB, 0.842064E+00_JPRB, 0.830394E+00_JPRB, 0.818440E+00_JPRB &
  &, 0.806211E+00_JPRB, 0.793716E+00_JPRB, 0.780963E+00_JPRB &
  &, 0.767970E+00_JPRB, 0.754741E+00_JPRB, 0.741290E+00_JPRB, 0.727626E+00_JPRB &
  &, 0.713771E+00_JPRB, 0.699727E+00_JPRB, 0.685515E+00_JPRB &
  &, 0.671144E+00_JPRB, 0.656636E+00_JPRB, 0.641994E+00_JPRB, 0.627245E+00_JPRB &
  &, 0.612400E+00_JPRB, 0.597474E+00_JPRB, 0.582484E+00_JPRB &
  &, 0.567445E+00_JPRB, 0.552378E+00_JPRB, 0.537299E+00_JPRB, 0.522218E+00_JPRB &
  &, 0.507167E+00_JPRB, 0.492149E+00_JPRB, 0.477182E+00_JPRB &
  &, 0.462294E+00_JPRB, 0.447494E+00_JPRB, 0.432790E+00_JPRB, 0.418217E+00_JPRB &
  &, 0.403785E+00_JPRB, 0.389493E+00_JPRB, 0.375377E+00_JPRB &
  &, 0.361447E+00_JPRB, 0.347716E+00_JPRB, 0.334193E+00_JPRB, 0.320886E+00_JPRB &
  &, 0.307834E+00_JPRB, 0.295014E+00_JPRB, 0.282464E+00_JPRB &
  &, 0.270173E+00_JPRB, 0.258175E+00_JPRB, 0.246442E+00_JPRB, 0.235022E+00_JPRB &
  &, 0.223898E+00_JPRB, 0.213085E+00_JPRB, 0.202576E+00_JPRB &
  &, 0.192401E+00_JPRB, 0.182532E+00_JPRB, 0.172995E+00_JPRB, 0.163777E+00_JPRB &
  &, 0.154880E+00_JPRB, 0.146307E+00_JPRB, 0.138055E+00_JPRB &
  &, 0.130124E+00_JPRB, 0.122528E+00_JPRB, 0.115241E+00_JPRB, 0.108274E+00_JPRB &
  &, 0.101595E+00_JPRB, 0.952346E-01_JPRB, 0.891785E-01_JPRB &
  &, 0.833847E-01_JPRB, 0.779054E-01_JPRB, 0.726946E-01_JPRB, 0.677526E-01_JPRB &
  &, 0.630787E-01_JPRB, 0.586438E-01_JPRB, 0.544702E-01_JPRB &
  &, 0.505250E-01_JPRB, 0.468284E-01_JPRB, 0.433435E-01_JPRB, 0.400588E-01_JPRB &
  &, 0.369914E-01_JPRB, 0.341281E-01_JPRB, 0.314227E-01_JPRB &
  &, 0.289201E-01_JPRB, 0.265710E-01_JPRB, 0.243874E-01_JPRB, 0.223816E-01_JPRB &
  &, 0.204985E-01_JPRB, 0.187473E-01_JPRB, 0.171376E-01_JPRB &
  &, 0.156078E-01_JPRB, 0.142368E-01_JPRB, 0.129609E-01_JPRB, 0.117868E-01_JPRB &
  &, 0.107212E-01_JPRB, 0.969337E-02_JPRB, 0.878561E-02_JPRB &
  &, 0.796495E-02_JPRB, 0.719593E-02_JPRB, 0.648210E-02_JPRB, 0.586918E-02_JPRB &
  &, 0.527722E-02_JPRB, 0.475144E-02_JPRB, 0.425147E-02_JPRB &
  &, 0.382398E-02_JPRB, 0.342736E-02_JPRB, 0.306350E-02_JPRB, 0.273434E-02_JPRB &
  &, 0.244187E-02_JPRB, 0.218809E-02_JPRB, 0.192592E-02_JPRB &
  &, 0.170511E-02_JPRB, 0.152777E-02_JPRB, 0.134470E-02_JPRB, 0.120790E-02_JPRB &
  &, 0.106673E-02_JPRB, 0.921140E-03_JPRB, 0.825436E-03_JPRB &
  &, 0.726746E-03_JPRB, 0.625033E-03_JPRB, 0.576959E-03_JPRB, 0.469886E-03_JPRB &
  &, 0.417970E-03_JPRB, 0.364499E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.256096E-03_JPRB, 0.197048E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.757111E-04_JPRB/)
XCW( 426, :) = (/ &
  &  0.978022E+00_JPRB, 0.971548E+00_JPRB, 0.964692E+00_JPRB, 0.957461E+00_JPRB &
  &, 0.949855E+00_JPRB, 0.941881E+00_JPRB, 0.933543E+00_JPRB &
  &, 0.924848E+00_JPRB, 0.915800E+00_JPRB, 0.906407E+00_JPRB, 0.896673E+00_JPRB &
  &, 0.886606E+00_JPRB, 0.876214E+00_JPRB, 0.865502E+00_JPRB &
  &, 0.854479E+00_JPRB, 0.843152E+00_JPRB, 0.831529E+00_JPRB, 0.819622E+00_JPRB &
  &, 0.807437E+00_JPRB, 0.794985E+00_JPRB, 0.782273E+00_JPRB &
  &, 0.769319E+00_JPRB, 0.756128E+00_JPRB, 0.742716E+00_JPRB, 0.729090E+00_JPRB &
  &, 0.715266E+00_JPRB, 0.701254E+00_JPRB, 0.687072E+00_JPRB &
  &, 0.672732E+00_JPRB, 0.658246E+00_JPRB, 0.643633E+00_JPRB, 0.628903E+00_JPRB &
  &, 0.614079E+00_JPRB, 0.599173E+00_JPRB, 0.584199E+00_JPRB &
  &, 0.569175E+00_JPRB, 0.554123E+00_JPRB, 0.539049E+00_JPRB, 0.523982E+00_JPRB &
  &, 0.508934E+00_JPRB, 0.493920E+00_JPRB, 0.478954E+00_JPRB &
  &, 0.464066E+00_JPRB, 0.449265E+00_JPRB, 0.434559E+00_JPRB, 0.419970E+00_JPRB &
  &, 0.405532E+00_JPRB, 0.391233E+00_JPRB, 0.377108E+00_JPRB &
  &, 0.363156E+00_JPRB, 0.349412E+00_JPRB, 0.335874E+00_JPRB, 0.322552E+00_JPRB &
  &, 0.309467E+00_JPRB, 0.296627E+00_JPRB, 0.284054E+00_JPRB &
  &, 0.271738E+00_JPRB, 0.259697E+00_JPRB, 0.247951E+00_JPRB, 0.236499E+00_JPRB &
  &, 0.225341E+00_JPRB, 0.214491E+00_JPRB, 0.203960E+00_JPRB &
  &, 0.193743E+00_JPRB, 0.183830E+00_JPRB, 0.174265E+00_JPRB, 0.164997E+00_JPRB &
  &, 0.156068E+00_JPRB, 0.147459E+00_JPRB, 0.139170E+00_JPRB &
  &, 0.131220E+00_JPRB, 0.123583E+00_JPRB, 0.116252E+00_JPRB, 0.109239E+00_JPRB &
  &, 0.102534E+00_JPRB, 0.961225E-01_JPRB, 0.900368E-01_JPRB &
  &, 0.842116E-01_JPRB, 0.786992E-01_JPRB, 0.734535E-01_JPRB, 0.684749E-01_JPRB &
  &, 0.637625E-01_JPRB, 0.592873E-01_JPRB, 0.550987E-01_JPRB &
  &, 0.511098E-01_JPRB, 0.473959E-01_JPRB, 0.438638E-01_JPRB, 0.405594E-01_JPRB &
  &, 0.374713E-01_JPRB, 0.345557E-01_JPRB, 0.318581E-01_JPRB &
  &, 0.293001E-01_JPRB, 0.269578E-01_JPRB, 0.247483E-01_JPRB, 0.226822E-01_JPRB &
  &, 0.208043E-01_JPRB, 0.190239E-01_JPRB, 0.173838E-01_JPRB &
  &, 0.158582E-01_JPRB, 0.144551E-01_JPRB, 0.131829E-01_JPRB, 0.119749E-01_JPRB &
  &, 0.108742E-01_JPRB, 0.988782E-02_JPRB, 0.894373E-02_JPRB &
  &, 0.808548E-02_JPRB, 0.731842E-02_JPRB, 0.660656E-02_JPRB, 0.595349E-02_JPRB &
  &, 0.536287E-02_JPRB, 0.483844E-02_JPRB, 0.433983E-02_JPRB &
  &, 0.391372E-02_JPRB, 0.347292E-02_JPRB, 0.310976E-02_JPRB, 0.278131E-02_JPRB &
  &, 0.248955E-02_JPRB, 0.223649E-02_JPRB, 0.197505E-02_JPRB &
  &, 0.175497E-02_JPRB, 0.157836E-02_JPRB, 0.139603E-02_JPRB, 0.120790E-02_JPRB &
  &, 0.106673E-02_JPRB, 0.974737E-03_JPRB, 0.825436E-03_JPRB &
  &, 0.726746E-03_JPRB, 0.625033E-03_JPRB, 0.576959E-03_JPRB, 0.469886E-03_JPRB &
  &, 0.417970E-03_JPRB, 0.364499E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.252817E-03_JPRB, 0.256096E-03_JPRB, 0.197048E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.757111E-04_JPRB/)
XCW( 427, :) = (/ &
  &  0.978272E+00_JPRB, 0.971862E+00_JPRB, 0.965067E+00_JPRB, 0.957895E+00_JPRB &
  &, 0.950348E+00_JPRB, 0.942434E+00_JPRB, 0.934154E+00_JPRB &
  &, 0.925515E+00_JPRB, 0.916524E+00_JPRB, 0.907186E+00_JPRB, 0.897508E+00_JPRB &
  &, 0.887494E+00_JPRB, 0.877153E+00_JPRB, 0.866492E+00_JPRB &
  &, 0.855519E+00_JPRB, 0.844241E+00_JPRB, 0.832666E+00_JPRB, 0.820804E+00_JPRB &
  &, 0.808663E+00_JPRB, 0.796254E+00_JPRB, 0.783586E+00_JPRB &
  &, 0.770672E+00_JPRB, 0.757518E+00_JPRB, 0.744142E+00_JPRB, 0.730550E+00_JPRB &
  &, 0.716761E+00_JPRB, 0.702781E+00_JPRB, 0.688629E+00_JPRB &
  &, 0.674315E+00_JPRB, 0.659857E+00_JPRB, 0.645272E+00_JPRB, 0.630566E+00_JPRB &
  &, 0.615762E+00_JPRB, 0.600872E+00_JPRB, 0.585918E+00_JPRB &
  &, 0.570905E+00_JPRB, 0.555868E+00_JPRB, 0.540809E+00_JPRB, 0.525747E+00_JPRB &
  &, 0.510702E+00_JPRB, 0.495690E+00_JPRB, 0.480726E+00_JPRB &
  &, 0.465838E+00_JPRB, 0.451035E+00_JPRB, 0.436327E+00_JPRB, 0.421735E+00_JPRB &
  &, 0.407280E+00_JPRB, 0.392974E+00_JPRB, 0.378840E+00_JPRB &
  &, 0.364877E+00_JPRB, 0.351108E+00_JPRB, 0.337556E+00_JPRB, 0.324217E+00_JPRB &
  &, 0.311114E+00_JPRB, 0.298254E+00_JPRB, 0.285644E+00_JPRB &
  &, 0.273303E+00_JPRB, 0.261236E+00_JPRB, 0.249460E+00_JPRB, 0.237976E+00_JPRB &
  &, 0.226801E+00_JPRB, 0.215914E+00_JPRB, 0.205345E+00_JPRB &
  &, 0.195086E+00_JPRB, 0.185147E+00_JPRB, 0.175535E+00_JPRB, 0.166237E+00_JPRB &
  &, 0.157275E+00_JPRB, 0.148632E+00_JPRB, 0.140306E+00_JPRB &
  &, 0.132317E+00_JPRB, 0.124638E+00_JPRB, 0.117263E+00_JPRB, 0.110204E+00_JPRB &
  &, 0.103473E+00_JPRB, 0.970339E-01_JPRB, 0.908951E-01_JPRB &
  &, 0.850385E-01_JPRB, 0.794931E-01_JPRB, 0.742125E-01_JPRB, 0.691972E-01_JPRB &
  &, 0.644463E-01_JPRB, 0.599575E-01_JPRB, 0.557272E-01_JPRB &
  &, 0.517224E-01_JPRB, 0.479350E-01_JPRB, 0.443842E-01_JPRB, 0.410600E-01_JPRB &
  &, 0.379512E-01_JPRB, 0.350139E-01_JPRB, 0.322625E-01_JPRB &
  &, 0.297117E-01_JPRB, 0.273124E-01_JPRB, 0.250764E-01_JPRB, 0.230161E-01_JPRB &
  &, 0.210761E-01_JPRB, 0.193004E-01_JPRB, 0.176300E-01_JPRB &
  &, 0.161086E-01_JPRB, 0.147098E-01_JPRB, 0.133679E-01_JPRB, 0.121630E-01_JPRB &
  &, 0.110655E-01_JPRB, 0.100434E-01_JPRB, 0.910185E-02_JPRB &
  &, 0.824618E-02_JPRB, 0.744091E-02_JPRB, 0.673102E-02_JPRB, 0.607994E-02_JPRB &
  &, 0.549134E-02_JPRB, 0.492544E-02_JPRB, 0.442819E-02_JPRB &
  &, 0.395859E-02_JPRB, 0.356405E-02_JPRB, 0.320229E-02_JPRB, 0.282829E-02_JPRB &
  &, 0.253724E-02_JPRB, 0.228489E-02_JPRB, 0.202417E-02_JPRB &
  &, 0.180483E-02_JPRB, 0.157836E-02_JPRB, 0.139603E-02_JPRB, 0.125998E-02_JPRB &
  &, 0.111957E-02_JPRB, 0.974737E-03_JPRB, 0.879799E-03_JPRB &
  &, 0.781880E-03_JPRB, 0.680946E-03_JPRB, 0.576959E-03_JPRB, 0.527371E-03_JPRB &
  &, 0.417970E-03_JPRB, 0.364499E-03_JPRB, 0.309454E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.256096E-03_JPRB, 0.197048E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART61',1,ZHOOK_HANDLE)
END SUBROUTINE PART61

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART62

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART62',0,ZHOOK_HANDLE)

XCW( 428, :) = (/ &
  &  0.978524E+00_JPRB, 0.972175E+00_JPRB, 0.965441E+00_JPRB, 0.958330E+00_JPRB &
  &, 0.950842E+00_JPRB, 0.942986E+00_JPRB, 0.934765E+00_JPRB &
  &, 0.926184E+00_JPRB, 0.917248E+00_JPRB, 0.907965E+00_JPRB, 0.898341E+00_JPRB &
  &, 0.888380E+00_JPRB, 0.878092E+00_JPRB, 0.867483E+00_JPRB &
  &, 0.856559E+00_JPRB, 0.845329E+00_JPRB, 0.833802E+00_JPRB, 0.821987E+00_JPRB &
  &, 0.809890E+00_JPRB, 0.797523E+00_JPRB, 0.784900E+00_JPRB &
  &, 0.772025E+00_JPRB, 0.758909E+00_JPRB, 0.745569E+00_JPRB, 0.732014E+00_JPRB &
  &, 0.718259E+00_JPRB, 0.704312E+00_JPRB, 0.690190E+00_JPRB &
  &, 0.675907E+00_JPRB, 0.661476E+00_JPRB, 0.646910E+00_JPRB, 0.632229E+00_JPRB &
  &, 0.617445E+00_JPRB, 0.602575E+00_JPRB, 0.587637E+00_JPRB &
  &, 0.572644E+00_JPRB, 0.557613E+00_JPRB, 0.542559E+00_JPRB, 0.527511E+00_JPRB &
  &, 0.512470E+00_JPRB, 0.497471E+00_JPRB, 0.482509E+00_JPRB &
  &, 0.467621E+00_JPRB, 0.452806E+00_JPRB, 0.438096E+00_JPRB, 0.423511E+00_JPRB &
  &, 0.409039E+00_JPRB, 0.394726E+00_JPRB, 0.380572E+00_JPRB &
  &, 0.366598E+00_JPRB, 0.352817E+00_JPRB, 0.339237E+00_JPRB, 0.325883E+00_JPRB &
  &, 0.312762E+00_JPRB, 0.299867E+00_JPRB, 0.287249E+00_JPRB &
  &, 0.274884E+00_JPRB, 0.262790E+00_JPRB, 0.250985E+00_JPRB, 0.239470E+00_JPRB &
  &, 0.228244E+00_JPRB, 0.217338E+00_JPRB, 0.206729E+00_JPRB &
  &, 0.196447E+00_JPRB, 0.186464E+00_JPRB, 0.176824E+00_JPRB, 0.167496E+00_JPRB &
  &, 0.158482E+00_JPRB, 0.149804E+00_JPRB, 0.141442E+00_JPRB &
  &, 0.133413E+00_JPRB, 0.125693E+00_JPRB, 0.118296E+00_JPRB, 0.111191E+00_JPRB &
  &, 0.104412E+00_JPRB, 0.979453E-01_JPRB, 0.917534E-01_JPRB &
  &, 0.858898E-01_JPRB, 0.802869E-01_JPRB, 0.749715E-01_JPRB, 0.699195E-01_JPRB &
  &, 0.651301E-01_JPRB, 0.606278E-01_JPRB, 0.563283E-01_JPRB &
  &, 0.523072E-01_JPRB, 0.485025E-01_JPRB, 0.449334E-01_JPRB, 0.415607E-01_JPRB &
  &, 0.384311E-01_JPRB, 0.354720E-01_JPRB, 0.326979E-01_JPRB &
  &, 0.300917E-01_JPRB, 0.276992E-01_JPRB, 0.254373E-01_JPRB, 0.233500E-01_JPRB &
  &, 0.213819E-01_JPRB, 0.195770E-01_JPRB, 0.179114E-01_JPRB &
  &, 0.163590E-01_JPRB, 0.149281E-01_JPRB, 0.135899E-01_JPRB, 0.123888E-01_JPRB &
  &, 0.112567E-01_JPRB, 0.101989E-01_JPRB, 0.925997E-02_JPRB &
  &, 0.836671E-02_JPRB, 0.760423E-02_JPRB, 0.685549E-02_JPRB, 0.620640E-02_JPRB &
  &, 0.557698E-02_JPRB, 0.501244E-02_JPRB, 0.451656E-02_JPRB &
  &, 0.404833E-02_JPRB, 0.365518E-02_JPRB, 0.324856E-02_JPRB, 0.292223E-02_JPRB &
  &, 0.258492E-02_JPRB, 0.233329E-02_JPRB, 0.207330E-02_JPRB &
  &, 0.185468E-02_JPRB, 0.162896E-02_JPRB, 0.144737E-02_JPRB, 0.125998E-02_JPRB &
  &, 0.111957E-02_JPRB, 0.102833E-02_JPRB, 0.879799E-03_JPRB &
  &, 0.781880E-03_JPRB, 0.680946E-03_JPRB, 0.576959E-03_JPRB, 0.527371E-03_JPRB &
  &, 0.476251E-03_JPRB, 0.423582E-03_JPRB, 0.369344E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.256096E-03_JPRB, 0.197048E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 429, :) = (/ &
  &  0.978775E+00_JPRB, 0.972489E+00_JPRB, 0.965815E+00_JPRB, 0.958764E+00_JPRB &
  &, 0.951337E+00_JPRB, 0.943539E+00_JPRB, 0.935376E+00_JPRB &
  &, 0.926852E+00_JPRB, 0.917972E+00_JPRB, 0.908746E+00_JPRB, 0.899175E+00_JPRB &
  &, 0.889268E+00_JPRB, 0.879032E+00_JPRB, 0.868473E+00_JPRB &
  &, 0.857599E+00_JPRB, 0.846419E+00_JPRB, 0.834939E+00_JPRB, 0.823170E+00_JPRB &
  &, 0.811118E+00_JPRB, 0.798796E+00_JPRB, 0.786213E+00_JPRB &
  &, 0.773378E+00_JPRB, 0.760303E+00_JPRB, 0.746999E+00_JPRB, 0.733481E+00_JPRB &
  &, 0.719758E+00_JPRB, 0.705844E+00_JPRB, 0.691750E+00_JPRB &
  &, 0.677494E+00_JPRB, 0.663091E+00_JPRB, 0.648553E+00_JPRB, 0.633892E+00_JPRB &
  &, 0.619132E+00_JPRB, 0.604278E+00_JPRB, 0.589356E+00_JPRB &
  &, 0.574374E+00_JPRB, 0.559359E+00_JPRB, 0.544319E+00_JPRB, 0.529276E+00_JPRB &
  &, 0.514249E+00_JPRB, 0.499252E+00_JPRB, 0.484291E+00_JPRB &
  &, 0.469404E+00_JPRB, 0.454589E+00_JPRB, 0.439876E+00_JPRB, 0.425276E+00_JPRB &
  &, 0.410811E+00_JPRB, 0.396479E+00_JPRB, 0.382316E+00_JPRB &
  &, 0.368333E+00_JPRB, 0.354526E+00_JPRB, 0.340933E+00_JPRB, 0.327562E+00_JPRB &
  &, 0.314409E+00_JPRB, 0.301509E+00_JPRB, 0.288854E+00_JPRB &
  &, 0.276465E+00_JPRB, 0.264344E+00_JPRB, 0.252510E+00_JPRB, 0.240964E+00_JPRB &
  &, 0.229721E+00_JPRB, 0.218761E+00_JPRB, 0.208132E+00_JPRB &
  &, 0.197808E+00_JPRB, 0.187800E+00_JPRB, 0.178113E+00_JPRB, 0.168755E+00_JPRB &
  &, 0.159709E+00_JPRB, 0.150977E+00_JPRB, 0.142598E+00_JPRB &
  &, 0.134510E+00_JPRB, 0.126748E+00_JPRB, 0.119307E+00_JPRB, 0.112201E+00_JPRB &
  &, 0.105373E+00_JPRB, 0.988566E-01_JPRB, 0.926356E-01_JPRB &
  &, 0.867167E-01_JPRB, 0.810807E-01_JPRB, 0.757305E-01_JPRB, 0.706419E-01_JPRB &
  &, 0.658403E-01_JPRB, 0.612712E-01_JPRB, 0.569842E-01_JPRB &
  &, 0.529198E-01_JPRB, 0.490700E-01_JPRB, 0.454827E-01_JPRB, 0.420907E-01_JPRB &
  &, 0.389110E-01_JPRB, 0.358997E-01_JPRB, 0.331333E-01_JPRB &
  &, 0.305034E-01_JPRB, 0.280537E-01_JPRB, 0.257982E-01_JPRB, 0.236839E-01_JPRB &
  &, 0.217217E-01_JPRB, 0.198881E-01_JPRB, 0.181927E-01_JPRB &
  &, 0.166095E-01_JPRB, 0.151464E-01_JPRB, 0.138120E-01_JPRB, 0.125769E-01_JPRB &
  &, 0.114480E-01_JPRB, 0.103934E-01_JPRB, 0.941809E-02_JPRB &
  &, 0.852742E-02_JPRB, 0.772671E-02_JPRB, 0.697995E-02_JPRB, 0.629071E-02_JPRB &
  &, 0.566263E-02_JPRB, 0.509944E-02_JPRB, 0.460492E-02_JPRB &
  &, 0.413807E-02_JPRB, 0.370075E-02_JPRB, 0.334109E-02_JPRB, 0.296920E-02_JPRB &
  &, 0.268029E-02_JPRB, 0.238170E-02_JPRB, 0.212242E-02_JPRB &
  &, 0.190454E-02_JPRB, 0.167955E-02_JPRB, 0.149870E-02_JPRB, 0.131206E-02_JPRB &
  &, 0.117240E-02_JPRB, 0.102833E-02_JPRB, 0.934161E-03_JPRB &
  &, 0.781880E-03_JPRB, 0.680946E-03_JPRB, 0.633655E-03_JPRB, 0.527371E-03_JPRB &
  &, 0.476251E-03_JPRB, 0.423582E-03_JPRB, 0.369344E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.256096E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.138037E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 430, :) = (/ &
  &  0.979028E+00_JPRB, 0.972800E+00_JPRB, 0.966189E+00_JPRB, 0.959199E+00_JPRB &
  &, 0.951831E+00_JPRB, 0.944092E+00_JPRB, 0.935986E+00_JPRB &
  &, 0.927519E+00_JPRB, 0.918697E+00_JPRB, 0.909525E+00_JPRB, 0.900009E+00_JPRB &
  &, 0.890155E+00_JPRB, 0.879972E+00_JPRB, 0.869464E+00_JPRB &
  &, 0.858636E+00_JPRB, 0.847509E+00_JPRB, 0.836077E+00_JPRB, 0.824353E+00_JPRB &
  &, 0.812346E+00_JPRB, 0.800068E+00_JPRB, 0.787526E+00_JPRB &
  &, 0.774731E+00_JPRB, 0.761697E+00_JPRB, 0.748432E+00_JPRB, 0.734948E+00_JPRB &
  &, 0.721257E+00_JPRB, 0.707375E+00_JPRB, 0.693315E+00_JPRB &
  &, 0.679090E+00_JPRB, 0.664710E+00_JPRB, 0.650196E+00_JPRB, 0.635559E+00_JPRB &
  &, 0.620819E+00_JPRB, 0.605986E+00_JPRB, 0.591084E+00_JPRB &
  &, 0.576114E+00_JPRB, 0.561113E+00_JPRB, 0.546089E+00_JPRB, 0.531050E+00_JPRB &
  &, 0.516027E+00_JPRB, 0.501033E+00_JPRB, 0.486084E+00_JPRB &
  &, 0.471187E+00_JPRB, 0.456371E+00_JPRB, 0.441656E+00_JPRB, 0.427053E+00_JPRB &
  &, 0.412570E+00_JPRB, 0.398244E+00_JPRB, 0.384060E+00_JPRB &
  &, 0.370067E+00_JPRB, 0.356249E+00_JPRB, 0.342628E+00_JPRB, 0.329242E+00_JPRB &
  &, 0.316071E+00_JPRB, 0.303136E+00_JPRB, 0.290459E+00_JPRB &
  &, 0.278045E+00_JPRB, 0.265898E+00_JPRB, 0.254035E+00_JPRB, 0.242458E+00_JPRB &
  &, 0.231181E+00_JPRB, 0.220202E+00_JPRB, 0.209534E+00_JPRB &
  &, 0.199169E+00_JPRB, 0.189135E+00_JPRB, 0.179421E+00_JPRB, 0.170014E+00_JPRB &
  &, 0.160936E+00_JPRB, 0.152170E+00_JPRB, 0.143734E+00_JPRB &
  &, 0.135628E+00_JPRB, 0.127825E+00_JPRB, 0.120362E+00_JPRB, 0.113188E+00_JPRB &
  &, 0.106335E+00_JPRB, 0.997913E-01_JPRB, 0.935177E-01_JPRB &
  &, 0.875680E-01_JPRB, 0.818994E-01_JPRB, 0.765147E-01_JPRB, 0.713900E-01_JPRB &
  &, 0.665504E-01_JPRB, 0.619415E-01_JPRB, 0.576127E-01_JPRB &
  &, 0.535046E-01_JPRB, 0.496659E-01_JPRB, 0.460030E-01_JPRB, 0.425913E-01_JPRB &
  &, 0.393909E-01_JPRB, 0.363578E-01_JPRB, 0.335376E-01_JPRB &
  &, 0.309150E-01_JPRB, 0.284405E-01_JPRB, 0.261591E-01_JPRB, 0.240178E-01_JPRB &
  &, 0.220275E-01_JPRB, 0.201647E-01_JPRB, 0.184389E-01_JPRB &
  &, 0.168599E-01_JPRB, 0.154011E-01_JPRB, 0.140340E-01_JPRB, 0.127650E-01_JPRB &
  &, 0.116393E-01_JPRB, 0.105489E-01_JPRB, 0.957621E-02_JPRB &
  &, 0.868812E-02_JPRB, 0.784920E-02_JPRB, 0.710441E-02_JPRB, 0.641716E-02_JPRB &
  &, 0.579110E-02_JPRB, 0.522994E-02_JPRB, 0.469328E-02_JPRB &
  &, 0.422782E-02_JPRB, 0.379188E-02_JPRB, 0.338735E-02_JPRB, 0.301617E-02_JPRB &
  &, 0.272797E-02_JPRB, 0.243010E-02_JPRB, 0.217155E-02_JPRB &
  &, 0.190454E-02_JPRB, 0.173014E-02_JPRB, 0.149870E-02_JPRB, 0.136415E-02_JPRB &
  &, 0.117240E-02_JPRB, 0.102833E-02_JPRB, 0.934161E-03_JPRB &
  &, 0.837014E-03_JPRB, 0.736858E-03_JPRB, 0.633655E-03_JPRB, 0.527371E-03_JPRB &
  &, 0.476251E-03_JPRB, 0.423582E-03_JPRB, 0.369344E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.256096E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 431, :) = (/ &
  &  0.979278E+00_JPRB, 0.973115E+00_JPRB, 0.966563E+00_JPRB, 0.959633E+00_JPRB &
  &, 0.952324E+00_JPRB, 0.944644E+00_JPRB, 0.936597E+00_JPRB &
  &, 0.928187E+00_JPRB, 0.919422E+00_JPRB, 0.910305E+00_JPRB, 0.900844E+00_JPRB &
  &, 0.891043E+00_JPRB, 0.880911E+00_JPRB, 0.870455E+00_JPRB &
  &, 0.859682E+00_JPRB, 0.848599E+00_JPRB, 0.837214E+00_JPRB, 0.825537E+00_JPRB &
  &, 0.813576E+00_JPRB, 0.801340E+00_JPRB, 0.788839E+00_JPRB &
  &, 0.776087E+00_JPRB, 0.763091E+00_JPRB, 0.749862E+00_JPRB, 0.736415E+00_JPRB &
  &, 0.722759E+00_JPRB, 0.708909E+00_JPRB, 0.694880E+00_JPRB &
  &, 0.680681E+00_JPRB, 0.666332E+00_JPRB, 0.651842E+00_JPRB, 0.637230E+00_JPRB &
  &, 0.622511E+00_JPRB, 0.607698E+00_JPRB, 0.592808E+00_JPRB &
  &, 0.577862E+00_JPRB, 0.562868E+00_JPRB, 0.547849E+00_JPRB, 0.532825E+00_JPRB &
  &, 0.517815E+00_JPRB, 0.502824E+00_JPRB, 0.487867E+00_JPRB &
  &, 0.472981E+00_JPRB, 0.458164E+00_JPRB, 0.443448E+00_JPRB, 0.428829E+00_JPRB &
  &, 0.414342E+00_JPRB, 0.399997E+00_JPRB, 0.385818E+00_JPRB &
  &, 0.371802E+00_JPRB, 0.357972E+00_JPRB, 0.344337E+00_JPRB, 0.330921E+00_JPRB &
  &, 0.317733E+00_JPRB, 0.304778E+00_JPRB, 0.292079E+00_JPRB &
  &, 0.279641E+00_JPRB, 0.267468E+00_JPRB, 0.255576E+00_JPRB, 0.243968E+00_JPRB &
  &, 0.232658E+00_JPRB, 0.221643E+00_JPRB, 0.210954E+00_JPRB &
  &, 0.200548E+00_JPRB, 0.190471E+00_JPRB, 0.180710E+00_JPRB, 0.171273E+00_JPRB &
  &, 0.162163E+00_JPRB, 0.153363E+00_JPRB, 0.144891E+00_JPRB &
  &, 0.136745E+00_JPRB, 0.128923E+00_JPRB, 0.121396E+00_JPRB, 0.114198E+00_JPRB &
  &, 0.107297E+00_JPRB, 0.100703E+00_JPRB, 0.944237E-01_JPRB &
  &, 0.884193E-01_JPRB, 0.827180E-01_JPRB, 0.772990E-01_JPRB, 0.721381E-01_JPRB &
  &, 0.672605E-01_JPRB, 0.626385E-01_JPRB, 0.582685E-01_JPRB &
  &, 0.541173E-01_JPRB, 0.502334E-01_JPRB, 0.465523E-01_JPRB, 0.431214E-01_JPRB &
  &, 0.398708E-01_JPRB, 0.368465E-01_JPRB, 0.340042E-01_JPRB &
  &, 0.313266E-01_JPRB, 0.288274E-01_JPRB, 0.265200E-01_JPRB, 0.243517E-01_JPRB &
  &, 0.223333E-01_JPRB, 0.204758E-01_JPRB, 0.187203E-01_JPRB &
  &, 0.171103E-01_JPRB, 0.156194E-01_JPRB, 0.142560E-01_JPRB, 0.129908E-01_JPRB &
  &, 0.118306E-01_JPRB, 0.107434E-01_JPRB, 0.973433E-02_JPRB &
  &, 0.884883E-02_JPRB, 0.801252E-02_JPRB, 0.722888E-02_JPRB, 0.654362E-02_JPRB &
  &, 0.587674E-02_JPRB, 0.531693E-02_JPRB, 0.478165E-02_JPRB &
  &, 0.431756E-02_JPRB, 0.383744E-02_JPRB, 0.347988E-02_JPRB, 0.311011E-02_JPRB &
  &, 0.277566E-02_JPRB, 0.247850E-02_JPRB, 0.222068E-02_JPRB &
  &, 0.195440E-02_JPRB, 0.173014E-02_JPRB, 0.155003E-02_JPRB, 0.136415E-02_JPRB &
  &, 0.122524E-02_JPRB, 0.108193E-02_JPRB, 0.934161E-03_JPRB &
  &, 0.837014E-03_JPRB, 0.736858E-03_JPRB, 0.633655E-03_JPRB, 0.584857E-03_JPRB &
  &, 0.476251E-03_JPRB, 0.423582E-03_JPRB, 0.369344E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.256096E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 432, :) = (/ &
  &  0.979529E+00_JPRB, 0.973426E+00_JPRB, 0.966937E+00_JPRB, 0.960067E+00_JPRB &
  &, 0.952818E+00_JPRB, 0.945197E+00_JPRB, 0.937207E+00_JPRB &
  &, 0.928855E+00_JPRB, 0.920146E+00_JPRB, 0.911085E+00_JPRB, 0.901678E+00_JPRB &
  &, 0.891931E+00_JPRB, 0.881852E+00_JPRB, 0.871447E+00_JPRB &
  &, 0.860724E+00_JPRB, 0.849690E+00_JPRB, 0.838353E+00_JPRB, 0.826722E+00_JPRB &
  &, 0.814806E+00_JPRB, 0.802412E+00_JPRB, 0.790156E+00_JPRB &
  &, 0.777443E+00_JPRB, 0.764488E+00_JPRB, 0.751295E+00_JPRB, 0.737886E+00_JPRB &
  &, 0.724265E+00_JPRB, 0.710448E+00_JPRB, 0.696448E+00_JPRB &
  &, 0.682280E+00_JPRB, 0.667955E+00_JPRB, 0.653489E+00_JPRB, 0.638901E+00_JPRB &
  &, 0.624203E+00_JPRB, 0.609410E+00_JPRB, 0.594541E+00_JPRB &
  &, 0.579602E+00_JPRB, 0.564632E+00_JPRB, 0.549619E+00_JPRB, 0.534609E+00_JPRB &
  &, 0.519594E+00_JPRB, 0.504616E+00_JPRB, 0.489660E+00_JPRB &
  &, 0.474775E+00_JPRB, 0.459958E+00_JPRB, 0.445240E+00_JPRB, 0.430618E+00_JPRB &
  &, 0.416126E+00_JPRB, 0.401775E+00_JPRB, 0.387575E+00_JPRB &
  &, 0.373536E+00_JPRB, 0.359694E+00_JPRB, 0.346046E+00_JPRB, 0.332615E+00_JPRB &
  &, 0.319409E+00_JPRB, 0.306435E+00_JPRB, 0.293700E+00_JPRB &
  &, 0.281238E+00_JPRB, 0.269038E+00_JPRB, 0.257118E+00_JPRB, 0.245478E+00_JPRB &
  &, 0.234135E+00_JPRB, 0.223101E+00_JPRB, 0.212356E+00_JPRB &
  &, 0.201946E+00_JPRB, 0.191825E+00_JPRB, 0.182038E+00_JPRB, 0.172552E+00_JPRB &
  &, 0.163410E+00_JPRB, 0.154576E+00_JPRB, 0.146068E+00_JPRB &
  &, 0.137863E+00_JPRB, 0.130000E+00_JPRB, 0.122451E+00_JPRB, 0.115208E+00_JPRB &
  &, 0.108282E+00_JPRB, 0.101637E+00_JPRB, 0.953297E-01_JPRB &
  &, 0.892948E-01_JPRB, 0.835367E-01_JPRB, 0.780833E-01_JPRB, 0.728862E-01_JPRB &
  &, 0.679706E-01_JPRB, 0.633088E-01_JPRB, 0.588970E-01_JPRB &
  &, 0.547578E-01_JPRB, 0.508292E-01_JPRB, 0.471304E-01_JPRB, 0.436514E-01_JPRB &
  &, 0.403806E-01_JPRB, 0.373047E-01_JPRB, 0.344396E-01_JPRB &
  &, 0.317383E-01_JPRB, 0.292142E-01_JPRB, 0.268809E-01_JPRB, 0.246856E-01_JPRB &
  &, 0.226731E-01_JPRB, 0.207524E-01_JPRB, 0.190016E-01_JPRB &
  &, 0.173965E-01_JPRB, 0.158741E-01_JPRB, 0.144780E-01_JPRB, 0.131789E-01_JPRB &
  &, 0.120218E-01_JPRB, 0.108989E-01_JPRB, 0.993198E-02_JPRB &
  &, 0.900954E-02_JPRB, 0.813500E-02_JPRB, 0.735334E-02_JPRB, 0.667008E-02_JPRB &
  &, 0.600521E-02_JPRB, 0.540393E-02_JPRB, 0.487001E-02_JPRB &
  &, 0.436243E-02_JPRB, 0.392857E-02_JPRB, 0.352615E-02_JPRB, 0.315709E-02_JPRB &
  &, 0.282334E-02_JPRB, 0.252690E-02_JPRB, 0.226980E-02_JPRB &
  &, 0.200425E-02_JPRB, 0.178073E-02_JPRB, 0.160137E-02_JPRB, 0.141623E-02_JPRB &
  &, 0.122524E-02_JPRB, 0.108193E-02_JPRB, 0.988523E-03_JPRB &
  &, 0.837014E-03_JPRB, 0.736858E-03_JPRB, 0.690351E-03_JPRB, 0.584857E-03_JPRB &
  &, 0.534533E-03_JPRB, 0.423582E-03_JPRB, 0.369344E-03_JPRB &
  &, 0.313522E-03_JPRB, 0.317620E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 433, :) = (/ &
  &  0.979780E+00_JPRB, 0.973740E+00_JPRB, 0.967310E+00_JPRB, 0.960501E+00_JPRB &
  &, 0.953312E+00_JPRB, 0.945749E+00_JPRB, 0.937818E+00_JPRB &
  &, 0.929524E+00_JPRB, 0.920870E+00_JPRB, 0.911865E+00_JPRB, 0.902513E+00_JPRB &
  &, 0.892820E+00_JPRB, 0.882793E+00_JPRB, 0.872440E+00_JPRB &
  &, 0.861766E+00_JPRB, 0.850780E+00_JPRB, 0.839492E+00_JPRB, 0.827908E+00_JPRB &
  &, 0.816037E+00_JPRB, 0.803887E+00_JPRB, 0.791472E+00_JPRB &
  &, 0.778802E+00_JPRB, 0.765882E+00_JPRB, 0.752732E+00_JPRB, 0.739356E+00_JPRB &
  &, 0.725767E+00_JPRB, 0.711983E+00_JPRB, 0.698017E+00_JPRB &
  &, 0.683876E+00_JPRB, 0.669578E+00_JPRB, 0.655140E+00_JPRB, 0.640577E+00_JPRB &
  &, 0.625899E+00_JPRB, 0.611127E+00_JPRB, 0.596273E+00_JPRB &
  &, 0.581350E+00_JPRB, 0.566387E+00_JPRB, 0.551399E+00_JPRB, 0.536394E+00_JPRB &
  &, 0.521392E+00_JPRB, 0.506407E+00_JPRB, 0.491464E+00_JPRB &
  &, 0.476580E+00_JPRB, 0.461763E+00_JPRB, 0.447031E+00_JPRB, 0.432406E+00_JPRB &
  &, 0.417910E+00_JPRB, 0.403540E+00_JPRB, 0.389332E+00_JPRB &
  &, 0.375297E+00_JPRB, 0.361430E+00_JPRB, 0.347769E+00_JPRB, 0.334309E+00_JPRB &
  &, 0.321085E+00_JPRB, 0.308092E+00_JPRB, 0.295335E+00_JPRB &
  &, 0.282849E+00_JPRB, 0.270623E+00_JPRB, 0.258675E+00_JPRB, 0.247005E+00_JPRB &
  &, 0.235628E+00_JPRB, 0.224560E+00_JPRB, 0.213794E+00_JPRB &
  &, 0.203325E+00_JPRB, 0.193179E+00_JPRB, 0.183346E+00_JPRB, 0.173830E+00_JPRB &
  &, 0.164657E+00_JPRB, 0.155789E+00_JPRB, 0.147224E+00_JPRB &
  &, 0.139002E+00_JPRB, 0.131098E+00_JPRB, 0.123506E+00_JPRB, 0.116217E+00_JPRB &
  &, 0.109243E+00_JPRB, 0.102595E+00_JPRB, 0.962357E-01_JPRB &
  &, 0.901461E-01_JPRB, 0.843801E-01_JPRB, 0.788676E-01_JPRB, 0.736601E-01_JPRB &
  &, 0.687070E-01_JPRB, 0.640059E-01_JPRB, 0.595528E-01_JPRB &
  &, 0.553704E-01_JPRB, 0.514251E-01_JPRB, 0.476797E-01_JPRB, 0.441815E-01_JPRB &
  &, 0.408605E-01_JPRB, 0.377629E-01_JPRB, 0.348750E-01_JPRB &
  &, 0.321499E-01_JPRB, 0.296332E-01_JPRB, 0.272418E-01_JPRB, 0.250529E-01_JPRB &
  &, 0.229789E-01_JPRB, 0.210635E-01_JPRB, 0.192830E-01_JPRB &
  &, 0.176469E-01_JPRB, 0.161288E-01_JPRB, 0.147000E-01_JPRB, 0.134046E-01_JPRB &
  &, 0.122131E-01_JPRB, 0.110934E-01_JPRB, 0.100901E-01_JPRB &
  &, 0.913007E-02_JPRB, 0.829832E-02_JPRB, 0.751929E-02_JPRB, 0.679654E-02_JPRB &
  &, 0.613368E-02_JPRB, 0.553443E-02_JPRB, 0.495838E-02_JPRB &
  &, 0.445217E-02_JPRB, 0.401970E-02_JPRB, 0.361868E-02_JPRB, 0.325103E-02_JPRB &
  &, 0.287102E-02_JPRB, 0.257530E-02_JPRB, 0.231893E-02_JPRB &
  &, 0.205411E-02_JPRB, 0.183133E-02_JPRB, 0.165270E-02_JPRB, 0.146831E-02_JPRB &
  &, 0.127808E-02_JPRB, 0.113553E-02_JPRB, 0.988523E-03_JPRB &
  &, 0.892149E-03_JPRB, 0.792770E-03_JPRB, 0.690351E-03_JPRB, 0.584857E-03_JPRB &
  &, 0.534533E-03_JPRB, 0.482665E-03_JPRB, 0.429235E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.317620E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 434, :) = (/ &
  &  0.980033E+00_JPRB, 0.974052E+00_JPRB, 0.967684E+00_JPRB, 0.960934E+00_JPRB &
  &, 0.953806E+00_JPRB, 0.946302E+00_JPRB, 0.938429E+00_JPRB &
  &, 0.930192E+00_JPRB, 0.921595E+00_JPRB, 0.912645E+00_JPRB, 0.903347E+00_JPRB &
  &, 0.893708E+00_JPRB, 0.883734E+00_JPRB, 0.873432E+00_JPRB &
  &, 0.862809E+00_JPRB, 0.851872E+00_JPRB, 0.840631E+00_JPRB, 0.829094E+00_JPRB &
  &, 0.817268E+00_JPRB, 0.805163E+00_JPRB, 0.792792E+00_JPRB &
  &, 0.780161E+00_JPRB, 0.767283E+00_JPRB, 0.754165E+00_JPRB, 0.740827E+00_JPRB &
  &, 0.727276E+00_JPRB, 0.713525E+00_JPRB, 0.699585E+00_JPRB &
  &, 0.685475E+00_JPRB, 0.671209E+00_JPRB, 0.656795E+00_JPRB, 0.642252E+00_JPRB &
  &, 0.627599E+00_JPRB, 0.612843E+00_JPRB, 0.598010E+00_JPRB &
  &, 0.583108E+00_JPRB, 0.568151E+00_JPRB, 0.553178E+00_JPRB, 0.538178E+00_JPRB &
  &, 0.523181E+00_JPRB, 0.508209E+00_JPRB, 0.493269E+00_JPRB &
  &, 0.478374E+00_JPRB, 0.463556E+00_JPRB, 0.448835E+00_JPRB, 0.434207E+00_JPRB &
  &, 0.419694E+00_JPRB, 0.405318E+00_JPRB, 0.391102E+00_JPRB &
  &, 0.377044E+00_JPRB, 0.363167E+00_JPRB, 0.349492E+00_JPRB, 0.336017E+00_JPRB &
  &, 0.322762E+00_JPRB, 0.309749E+00_JPRB, 0.296971E+00_JPRB &
  &, 0.284461E+00_JPRB, 0.272209E+00_JPRB, 0.260217E+00_JPRB, 0.248532E+00_JPRB &
  &, 0.237122E+00_JPRB, 0.226018E+00_JPRB, 0.215214E+00_JPRB &
  &, 0.204722E+00_JPRB, 0.194533E+00_JPRB, 0.184673E+00_JPRB, 0.175128E+00_JPRB &
  &, 0.165904E+00_JPRB, 0.157002E+00_JPRB, 0.148401E+00_JPRB &
  &, 0.140141E+00_JPRB, 0.132196E+00_JPRB, 0.124561E+00_JPRB, 0.117249E+00_JPRB &
  &, 0.110251E+00_JPRB, 0.103530E+00_JPRB, 0.971417E-01_JPRB &
  &, 0.910217E-01_JPRB, 0.852236E-01_JPRB, 0.796771E-01_JPRB, 0.744082E-01_JPRB &
  &, 0.694171E-01_JPRB, 0.647029E-01_JPRB, 0.602359E-01_JPRB &
  &, 0.560109E-01_JPRB, 0.520210E-01_JPRB, 0.482579E-01_JPRB, 0.447116E-01_JPRB &
  &, 0.413704E-01_JPRB, 0.382516E-01_JPRB, 0.353415E-01_JPRB &
  &, 0.325932E-01_JPRB, 0.300200E-01_JPRB, 0.276355E-01_JPRB, 0.253868E-01_JPRB &
  &, 0.233186E-01_JPRB, 0.213747E-01_JPRB, 0.195995E-01_JPRB &
  &, 0.179331E-01_JPRB, 0.163835E-01_JPRB, 0.149590E-01_JPRB, 0.136304E-01_JPRB &
  &, 0.124044E-01_JPRB, 0.112878E-01_JPRB, 0.102482E-01_JPRB &
  &, 0.929077E-02_JPRB, 0.842081E-02_JPRB, 0.764376E-02_JPRB, 0.692299E-02_JPRB &
  &, 0.621933E-02_JPRB, 0.562143E-02_JPRB, 0.504674E-02_JPRB &
  &, 0.454191E-02_JPRB, 0.411083E-02_JPRB, 0.366494E-02_JPRB, 0.329800E-02_JPRB &
  &, 0.296639E-02_JPRB, 0.262371E-02_JPRB, 0.236805E-02_JPRB &
  &, 0.210396E-02_JPRB, 0.188192E-02_JPRB, 0.165270E-02_JPRB, 0.146831E-02_JPRB &
  &, 0.133091E-02_JPRB, 0.113553E-02_JPRB, 0.104289E-02_JPRB &
  &, 0.892149E-03_JPRB, 0.792770E-03_JPRB, 0.690351E-03_JPRB, 0.642343E-03_JPRB &
  &, 0.534533E-03_JPRB, 0.482665E-03_JPRB, 0.429235E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.317620E-03_JPRB, 0.259398E-03_JPRB, 0.199543E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.139724E-03_JPRB, 0.141422E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART62',1,ZHOOK_HANDLE)
END SUBROUTINE PART62

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART63

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART63',0,ZHOOK_HANDLE)

XCW( 435, :) = (/ &
  &  0.980284E+00_JPRB, 0.974366E+00_JPRB, 0.968058E+00_JPRB, 0.961369E+00_JPRB &
  &, 0.954299E+00_JPRB, 0.946854E+00_JPRB, 0.939040E+00_JPRB &
  &, 0.930859E+00_JPRB, 0.922319E+00_JPRB, 0.913425E+00_JPRB, 0.904182E+00_JPRB &
  &, 0.894596E+00_JPRB, 0.884674E+00_JPRB, 0.874424E+00_JPRB &
  &, 0.863852E+00_JPRB, 0.852965E+00_JPRB, 0.841769E+00_JPRB, 0.830280E+00_JPRB &
  &, 0.818500E+00_JPRB, 0.806438E+00_JPRB, 0.794108E+00_JPRB &
  &, 0.781521E+00_JPRB, 0.768680E+00_JPRB, 0.755602E+00_JPRB, 0.742301E+00_JPRB &
  &, 0.728782E+00_JPRB, 0.715064E+00_JPRB, 0.701157E+00_JPRB &
  &, 0.687078E+00_JPRB, 0.672836E+00_JPRB, 0.658450E+00_JPRB, 0.643932E+00_JPRB &
  &, 0.629299E+00_JPRB, 0.614564E+00_JPRB, 0.599748E+00_JPRB &
  &, 0.584857E+00_JPRB, 0.569925E+00_JPRB, 0.554958E+00_JPRB, 0.539963E+00_JPRB &
  &, 0.524980E+00_JPRB, 0.510011E+00_JPRB, 0.495073E+00_JPRB &
  &, 0.480191E+00_JPRB, 0.465373E+00_JPRB, 0.450638E+00_JPRB, 0.436007E+00_JPRB &
  &, 0.421490E+00_JPRB, 0.407109E+00_JPRB, 0.392873E+00_JPRB &
  &, 0.378805E+00_JPRB, 0.364916E+00_JPRB, 0.351215E+00_JPRB, 0.337725E+00_JPRB &
  &, 0.324452E+00_JPRB, 0.311406E+00_JPRB, 0.298621E+00_JPRB &
  &, 0.286073E+00_JPRB, 0.273795E+00_JPRB, 0.261790E+00_JPRB, 0.250059E+00_JPRB &
  &, 0.238633E+00_JPRB, 0.227493E+00_JPRB, 0.216652E+00_JPRB &
  &, 0.206119E+00_JPRB, 0.195906E+00_JPRB, 0.186019E+00_JPRB, 0.176426E+00_JPRB &
  &, 0.167171E+00_JPRB, 0.158215E+00_JPRB, 0.149599E+00_JPRB &
  &, 0.141300E+00_JPRB, 0.133316E+00_JPRB, 0.125638E+00_JPRB, 0.118282E+00_JPRB &
  &, 0.111236E+00_JPRB, 0.104488E+00_JPRB, 0.980477E-01_JPRB &
  &, 0.919216E-01_JPRB, 0.860670E-01_JPRB, 0.804867E-01_JPRB, 0.751821E-01_JPRB &
  &, 0.701535E-01_JPRB, 0.654000E-01_JPRB, 0.608918E-01_JPRB &
  &, 0.566235E-01_JPRB, 0.526168E-01_JPRB, 0.488071E-01_JPRB, 0.452416E-01_JPRB &
  &, 0.418803E-01_JPRB, 0.387403E-01_JPRB, 0.357770E-01_JPRB &
  &, 0.330049E-01_JPRB, 0.304391E-01_JPRB, 0.279964E-01_JPRB, 0.257541E-01_JPRB &
  &, 0.236584E-01_JPRB, 0.216858E-01_JPRB, 0.198809E-01_JPRB &
  &, 0.181835E-01_JPRB, 0.166382E-01_JPRB, 0.151810E-01_JPRB, 0.138562E-01_JPRB &
  &, 0.125956E-01_JPRB, 0.114823E-01_JPRB, 0.104459E-01_JPRB &
  &, 0.945148E-02_JPRB, 0.858413E-02_JPRB, 0.776822E-02_JPRB, 0.704945E-02_JPRB &
  &, 0.634780E-02_JPRB, 0.575193E-02_JPRB, 0.517929E-02_JPRB &
  &, 0.463165E-02_JPRB, 0.420196E-02_JPRB, 0.375747E-02_JPRB, 0.334497E-02_JPRB &
  &, 0.301407E-02_JPRB, 0.272051E-02_JPRB, 0.241718E-02_JPRB &
  &, 0.215382E-02_JPRB, 0.193251E-02_JPRB, 0.170404E-02_JPRB, 0.152039E-02_JPRB &
  &, 0.133091E-02_JPRB, 0.118912E-02_JPRB, 0.104289E-02_JPRB &
  &, 0.947283E-03_JPRB, 0.792770E-03_JPRB, 0.747047E-03_JPRB, 0.642343E-03_JPRB &
  &, 0.534533E-03_JPRB, 0.482665E-03_JPRB, 0.429235E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.317620E-03_JPRB, 0.259398E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.204585E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 436, :) = (/ &
  &  0.980532E+00_JPRB, 0.974676E+00_JPRB, 0.968431E+00_JPRB, 0.961803E+00_JPRB &
  &, 0.954792E+00_JPRB, 0.947407E+00_JPRB, 0.939651E+00_JPRB &
  &, 0.931529E+00_JPRB, 0.923045E+00_JPRB, 0.914205E+00_JPRB, 0.905017E+00_JPRB &
  &, 0.895485E+00_JPRB, 0.885616E+00_JPRB, 0.875418E+00_JPRB &
  &, 0.864894E+00_JPRB, 0.854057E+00_JPRB, 0.842912E+00_JPRB, 0.831468E+00_JPRB &
  &, 0.819732E+00_JPRB, 0.807716E+00_JPRB, 0.795428E+00_JPRB &
  &, 0.782880E+00_JPRB, 0.770081E+00_JPRB, 0.757042E+00_JPRB, 0.743776E+00_JPRB &
  &, 0.730292E+00_JPRB, 0.716606E+00_JPRB, 0.702733E+00_JPRB &
  &, 0.688681E+00_JPRB, 0.674466E+00_JPRB, 0.660105E+00_JPRB, 0.645611E+00_JPRB &
  &, 0.630999E+00_JPRB, 0.616285E+00_JPRB, 0.601490E+00_JPRB &
  &, 0.586615E+00_JPRB, 0.571699E+00_JPRB, 0.556738E+00_JPRB, 0.541757E+00_JPRB &
  &, 0.526779E+00_JPRB, 0.511813E+00_JPRB, 0.496888E+00_JPRB &
  &, 0.481996E+00_JPRB, 0.467178E+00_JPRB, 0.452441E+00_JPRB, 0.437808E+00_JPRB &
  &, 0.423286E+00_JPRB, 0.408899E+00_JPRB, 0.394655E+00_JPRB &
  &, 0.380566E+00_JPRB, 0.366666E+00_JPRB, 0.352952E+00_JPRB, 0.339446E+00_JPRB &
  &, 0.326143E+00_JPRB, 0.313093E+00_JPRB, 0.300272E+00_JPRB &
  &, 0.287700E+00_JPRB, 0.275397E+00_JPRB, 0.263364E+00_JPRB, 0.251602E+00_JPRB &
  &, 0.240144E+00_JPRB, 0.228969E+00_JPRB, 0.218107E+00_JPRB &
  &, 0.207535E+00_JPRB, 0.197278E+00_JPRB, 0.187346E+00_JPRB, 0.177724E+00_JPRB &
  &, 0.168437E+00_JPRB, 0.159448E+00_JPRB, 0.150796E+00_JPRB &
  &, 0.142439E+00_JPRB, 0.134414E+00_JPRB, 0.126715E+00_JPRB, 0.119314E+00_JPRB &
  &, 0.112243E+00_JPRB, 0.105446E+00_JPRB, 0.989775E-01_JPRB &
  &, 0.927972E-01_JPRB, 0.869105E-01_JPRB, 0.812963E-01_JPRB, 0.759560E-01_JPRB &
  &, 0.709163E-01_JPRB, 0.661239E-01_JPRB, 0.615749E-01_JPRB &
  &, 0.572640E-01_JPRB, 0.532127E-01_JPRB, 0.493853E-01_JPRB, 0.458011E-01_JPRB &
  &, 0.424202E-01_JPRB, 0.392290E-01_JPRB, 0.362435E-01_JPRB &
  &, 0.334482E-01_JPRB, 0.308259E-01_JPRB, 0.283901E-01_JPRB, 0.261214E-01_JPRB &
  &, 0.239982E-01_JPRB, 0.219970E-01_JPRB, 0.201622E-01_JPRB &
  &, 0.184697E-01_JPRB, 0.168929E-01_JPRB, 0.154031E-01_JPRB, 0.140819E-01_JPRB &
  &, 0.128252E-01_JPRB, 0.116767E-01_JPRB, 0.106040E-01_JPRB &
  &, 0.961218E-02_JPRB, 0.874744E-02_JPRB, 0.789268E-02_JPRB, 0.717591E-02_JPRB &
  &, 0.647626E-02_JPRB, 0.583893E-02_JPRB, 0.526765E-02_JPRB &
  &, 0.472139E-02_JPRB, 0.424752E-02_JPRB, 0.385000E-02_JPRB, 0.343891E-02_JPRB &
  &, 0.306176E-02_JPRB, 0.276891E-02_JPRB, 0.246631E-02_JPRB &
  &, 0.220368E-02_JPRB, 0.198310E-02_JPRB, 0.175537E-02_JPRB, 0.157248E-02_JPRB &
  &, 0.138375E-02_JPRB, 0.124272E-02_JPRB, 0.109725E-02_JPRB &
  &, 0.947283E-03_JPRB, 0.848682E-03_JPRB, 0.747047E-03_JPRB, 0.642343E-03_JPRB &
  &, 0.592814E-03_JPRB, 0.482665E-03_JPRB, 0.429235E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.317620E-03_JPRB, 0.259398E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.204585E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 437, :) = (/ &
  &  0.980786E+00_JPRB, 0.974991E+00_JPRB, 0.968805E+00_JPRB, 0.962236E+00_JPRB &
  &, 0.955286E+00_JPRB, 0.947960E+00_JPRB, 0.940262E+00_JPRB &
  &, 0.932197E+00_JPRB, 0.923769E+00_JPRB, 0.914985E+00_JPRB, 0.905852E+00_JPRB &
  &, 0.896374E+00_JPRB, 0.886557E+00_JPRB, 0.876411E+00_JPRB &
  &, 0.865939E+00_JPRB, 0.855150E+00_JPRB, 0.844054E+00_JPRB, 0.832656E+00_JPRB &
  &, 0.820967E+00_JPRB, 0.808995E+00_JPRB, 0.796748E+00_JPRB &
  &, 0.784243E+00_JPRB, 0.771481E+00_JPRB, 0.758483E+00_JPRB, 0.745250E+00_JPRB &
  &, 0.731805E+00_JPRB, 0.718152E+00_JPRB, 0.704309E+00_JPRB &
  &, 0.690288E+00_JPRB, 0.676101E+00_JPRB, 0.661764E+00_JPRB, 0.647295E+00_JPRB &
  &, 0.632708E+00_JPRB, 0.618015E+00_JPRB, 0.603231E+00_JPRB &
  &, 0.588382E+00_JPRB, 0.573473E+00_JPRB, 0.558527E+00_JPRB, 0.543562E+00_JPRB &
  &, 0.528588E+00_JPRB, 0.513626E+00_JPRB, 0.498692E+00_JPRB &
  &, 0.483812E+00_JPRB, 0.468994E+00_JPRB, 0.454257E+00_JPRB, 0.439620E+00_JPRB &
  &, 0.425083E+00_JPRB, 0.410689E+00_JPRB, 0.396438E+00_JPRB &
  &, 0.382340E+00_JPRB, 0.368416E+00_JPRB, 0.354689E+00_JPRB, 0.341154E+00_JPRB &
  &, 0.327849E+00_JPRB, 0.314764E+00_JPRB, 0.301922E+00_JPRB &
  &, 0.289327E+00_JPRB, 0.276998E+00_JPRB, 0.264938E+00_JPRB, 0.253146E+00_JPRB &
  &, 0.241655E+00_JPRB, 0.230445E+00_JPRB, 0.219545E+00_JPRB &
  &, 0.208950E+00_JPRB, 0.198669E+00_JPRB, 0.188692E+00_JPRB, 0.179041E+00_JPRB &
  &, 0.169704E+00_JPRB, 0.160682E+00_JPRB, 0.151994E+00_JPRB &
  &, 0.143599E+00_JPRB, 0.135555E+00_JPRB, 0.127792E+00_JPRB, 0.120368E+00_JPRB &
  &, 0.113251E+00_JPRB, 0.106428E+00_JPRB, 0.999073E-01_JPRB &
  &, 0.936971E-01_JPRB, 0.877539E-01_JPRB, 0.821311E-01_JPRB, 0.767557E-01_JPRB &
  &, 0.716527E-01_JPRB, 0.668209E-01_JPRB, 0.622580E-01_JPRB &
  &, 0.579323E-01_JPRB, 0.538370E-01_JPRB, 0.499924E-01_JPRB, 0.463606E-01_JPRB &
  &, 0.429301E-01_JPRB, 0.397177E-01_JPRB, 0.367100E-01_JPRB &
  &, 0.338915E-01_JPRB, 0.312449E-01_JPRB, 0.287838E-01_JPRB, 0.264887E-01_JPRB &
  &, 0.243380E-01_JPRB, 0.223427E-01_JPRB, 0.204788E-01_JPRB &
  &, 0.187559E-01_JPRB, 0.171476E-01_JPRB, 0.156621E-01_JPRB, 0.143077E-01_JPRB &
  &, 0.130164E-01_JPRB, 0.118712E-01_JPRB, 0.108016E-01_JPRB &
  &, 0.981307E-02_JPRB, 0.886993E-02_JPRB, 0.805863E-02_JPRB, 0.730236E-02_JPRB &
  &, 0.660473E-02_JPRB, 0.596943E-02_JPRB, 0.535601E-02_JPRB &
  &, 0.481113E-02_JPRB, 0.433865E-02_JPRB, 0.389627E-02_JPRB, 0.348589E-02_JPRB &
  &, 0.315712E-02_JPRB, 0.281731E-02_JPRB, 0.251543E-02_JPRB &
  &, 0.225353E-02_JPRB, 0.198310E-02_JPRB, 0.180671E-02_JPRB, 0.157248E-02_JPRB &
  &, 0.138375E-02_JPRB, 0.124272E-02_JPRB, 0.109725E-02_JPRB &
  &, 0.100242E-02_JPRB, 0.848682E-03_JPRB, 0.747047E-03_JPRB, 0.642343E-03_JPRB &
  &, 0.592814E-03_JPRB, 0.541748E-03_JPRB, 0.429235E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.317620E-03_JPRB, 0.321747E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.204585E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 438, :) = (/ &
  &  0.981035E+00_JPRB, 0.975303E+00_JPRB, 0.969178E+00_JPRB, 0.962671E+00_JPRB &
  &, 0.955779E+00_JPRB, 0.948512E+00_JPRB, 0.940872E+00_JPRB &
  &, 0.932864E+00_JPRB, 0.924494E+00_JPRB, 0.915767E+00_JPRB, 0.906688E+00_JPRB &
  &, 0.897264E+00_JPRB, 0.887500E+00_JPRB, 0.877405E+00_JPRB &
  &, 0.866983E+00_JPRB, 0.856245E+00_JPRB, 0.845195E+00_JPRB, 0.833845E+00_JPRB &
  &, 0.822201E+00_JPRB, 0.810273E+00_JPRB, 0.798071E+00_JPRB &
  &, 0.785605E+00_JPRB, 0.772885E+00_JPRB, 0.759923E+00_JPRB, 0.746728E+00_JPRB &
  &, 0.733318E+00_JPRB, 0.719698E+00_JPRB, 0.705885E+00_JPRB &
  &, 0.691895E+00_JPRB, 0.677736E+00_JPRB, 0.663428E+00_JPRB, 0.648983E+00_JPRB &
  &, 0.634413E+00_JPRB, 0.619741E+00_JPRB, 0.604978E+00_JPRB &
  &, 0.590140E+00_JPRB, 0.575247E+00_JPRB, 0.560317E+00_JPRB, 0.545357E+00_JPRB &
  &, 0.530397E+00_JPRB, 0.515439E+00_JPRB, 0.500518E+00_JPRB &
  &, 0.485639E+00_JPRB, 0.470810E+00_JPRB, 0.456071E+00_JPRB, 0.441433E+00_JPRB &
  &, 0.426891E+00_JPRB, 0.412480E+00_JPRB, 0.398221E+00_JPRB &
  &, 0.384114E+00_JPRB, 0.370179E+00_JPRB, 0.356439E+00_JPRB, 0.342890E+00_JPRB &
  &, 0.329554E+00_JPRB, 0.316451E+00_JPRB, 0.303588E+00_JPRB &
  &, 0.290970E+00_JPRB, 0.278600E+00_JPRB, 0.266512E+00_JPRB, 0.254706E+00_JPRB &
  &, 0.243183E+00_JPRB, 0.231938E+00_JPRB, 0.221001E+00_JPRB &
  &, 0.210384E+00_JPRB, 0.200060E+00_JPRB, 0.190056E+00_JPRB, 0.180359E+00_JPRB &
  &, 0.170991E+00_JPRB, 0.161935E+00_JPRB, 0.153192E+00_JPRB &
  &, 0.144780E+00_JPRB, 0.136675E+00_JPRB, 0.128892E+00_JPRB, 0.121423E+00_JPRB &
  &, 0.114259E+00_JPRB, 0.107409E+00_JPRB, 0.100861E+00_JPRB &
  &, 0.945970E-01_JPRB, 0.886222E-01_JPRB, 0.829407E-01_JPRB, 0.775554E-01_JPRB &
  &, 0.724154E-01_JPRB, 0.675448E-01_JPRB, 0.629412E-01_JPRB &
  &, 0.585728E-01_JPRB, 0.544612E-01_JPRB, 0.505705E-01_JPRB, 0.468907E-01_JPRB &
  &, 0.434699E-01_JPRB, 0.402064E-01_JPRB, 0.371765E-01_JPRB &
  &, 0.343348E-01_JPRB, 0.316640E-01_JPRB, 0.291775E-01_JPRB, 0.268560E-01_JPRB &
  &, 0.246778E-01_JPRB, 0.226538E-01_JPRB, 0.207601E-01_JPRB &
  &, 0.190421E-01_JPRB, 0.174023E-01_JPRB, 0.159211E-01_JPRB, 0.145334E-01_JPRB &
  &, 0.132460E-01_JPRB, 0.120656E-01_JPRB, 0.109598E-01_JPRB &
  &, 0.997377E-02_JPRB, 0.903325E-02_JPRB, 0.818310E-02_JPRB, 0.742882E-02_JPRB &
  &, 0.669038E-02_JPRB, 0.605643E-02_JPRB, 0.548856E-02_JPRB &
  &, 0.494574E-02_JPRB, 0.442978E-02_JPRB, 0.398880E-02_JPRB, 0.357983E-02_JPRB &
  &, 0.320481E-02_JPRB, 0.286571E-02_JPRB, 0.256456E-02_JPRB &
  &, 0.230339E-02_JPRB, 0.203370E-02_JPRB, 0.180671E-02_JPRB, 0.162456E-02_JPRB &
  &, 0.143659E-02_JPRB, 0.129632E-02_JPRB, 0.115161E-02_JPRB &
  &, 0.100242E-02_JPRB, 0.904594E-03_JPRB, 0.803743E-03_JPRB, 0.699828E-03_JPRB &
  &, 0.592814E-03_JPRB, 0.541748E-03_JPRB, 0.489126E-03_JPRB &
  &, 0.374226E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.204585E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 439, :) = (/ &
  &  0.981287E+00_JPRB, 0.975615E+00_JPRB, 0.969551E+00_JPRB, 0.963104E+00_JPRB &
  &, 0.956272E+00_JPRB, 0.949065E+00_JPRB, 0.941483E+00_JPRB &
  &, 0.933533E+00_JPRB, 0.925218E+00_JPRB, 0.916547E+00_JPRB, 0.907524E+00_JPRB &
  &, 0.898153E+00_JPRB, 0.888442E+00_JPRB, 0.878398E+00_JPRB &
  &, 0.868028E+00_JPRB, 0.857339E+00_JPRB, 0.846338E+00_JPRB, 0.835034E+00_JPRB &
  &, 0.823436E+00_JPRB, 0.811552E+00_JPRB, 0.799393E+00_JPRB &
  &, 0.786968E+00_JPRB, 0.774289E+00_JPRB, 0.761363E+00_JPRB, 0.748209E+00_JPRB &
  &, 0.734831E+00_JPRB, 0.721244E+00_JPRB, 0.707465E+00_JPRB &
  &, 0.693502E+00_JPRB, 0.679375E+00_JPRB, 0.665091E+00_JPRB, 0.650671E+00_JPRB &
  &, 0.636126E+00_JPRB, 0.621475E+00_JPRB, 0.606729E+00_JPRB &
  &, 0.591907E+00_JPRB, 0.577030E+00_JPRB, 0.562106E+00_JPRB, 0.547161E+00_JPRB &
  &, 0.532206E+00_JPRB, 0.517262E+00_JPRB, 0.502343E+00_JPRB &
  &, 0.487456E+00_JPRB, 0.472638E+00_JPRB, 0.457898E+00_JPRB, 0.443245E+00_JPRB &
  &, 0.428699E+00_JPRB, 0.414282E+00_JPRB, 0.400017E+00_JPRB &
  &, 0.385888E+00_JPRB, 0.371942E+00_JPRB, 0.358176E+00_JPRB, 0.344612E+00_JPRB &
  &, 0.331273E+00_JPRB, 0.318137E+00_JPRB, 0.305254E+00_JPRB &
  &, 0.292613E+00_JPRB, 0.280217E+00_JPRB, 0.268102E+00_JPRB, 0.256266E+00_JPRB &
  &, 0.244710E+00_JPRB, 0.233448E+00_JPRB, 0.222474E+00_JPRB &
  &, 0.211817E+00_JPRB, 0.201452E+00_JPRB, 0.191421E+00_JPRB, 0.181676E+00_JPRB &
  &, 0.172277E+00_JPRB, 0.163189E+00_JPRB, 0.154410E+00_JPRB &
  &, 0.145940E+00_JPRB, 0.137816E+00_JPRB, 0.129991E+00_JPRB, 0.122477E+00_JPRB &
  &, 0.115289E+00_JPRB, 0.108391E+00_JPRB, 0.101791E+00_JPRB &
  &, 0.954969E-01_JPRB, 0.894905E-01_JPRB, 0.837756E-01_JPRB, 0.783293E-01_JPRB &
  &, 0.731781E-01_JPRB, 0.682687E-01_JPRB, 0.636243E-01_JPRB &
  &, 0.592412E-01_JPRB, 0.550855E-01_JPRB, 0.511487E-01_JPRB, 0.474796E-01_JPRB &
  &, 0.439798E-01_JPRB, 0.407257E-01_JPRB, 0.376430E-01_JPRB &
  &, 0.347781E-01_JPRB, 0.320830E-01_JPRB, 0.295712E-01_JPRB, 0.272233E-01_JPRB &
  &, 0.250175E-01_JPRB, 0.229649E-01_JPRB, 0.210767E-01_JPRB &
  &, 0.193283E-01_JPRB, 0.176570E-01_JPRB, 0.161431E-01_JPRB, 0.147592E-01_JPRB &
  &, 0.134372E-01_JPRB, 0.122600E-01_JPRB, 0.111574E-01_JPRB &
  &, 0.101345E-01_JPRB, 0.919656E-02_JPRB, 0.834905E-02_JPRB, 0.755528E-02_JPRB &
  &, 0.681885E-02_JPRB, 0.618692E-02_JPRB, 0.557692E-02_JPRB &
  &, 0.503548E-02_JPRB, 0.452091E-02_JPRB, 0.408133E-02_JPRB, 0.367377E-02_JPRB &
  &, 0.330018E-02_JPRB, 0.291412E-02_JPRB, 0.261369E-02_JPRB &
  &, 0.235325E-02_JPRB, 0.208429E-02_JPRB, 0.185804E-02_JPRB, 0.167664E-02_JPRB &
  &, 0.148942E-02_JPRB, 0.129632E-02_JPRB, 0.115161E-02_JPRB &
  &, 0.100242E-02_JPRB, 0.904594E-03_JPRB, 0.803743E-03_JPRB, 0.699828E-03_JPRB &
  &, 0.592814E-03_JPRB, 0.541748E-03_JPRB, 0.489126E-03_JPRB &
  &, 0.434930E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.202055E-03_JPRB, 0.204585E-03_JPRB, 0.141422E-03_JPRB/)
XCW( 440, :) = (/ &
  &  0.981539E+00_JPRB, 0.975928E+00_JPRB, 0.969925E+00_JPRB, 0.963538E+00_JPRB &
  &, 0.956766E+00_JPRB, 0.949618E+00_JPRB, 0.942094E+00_JPRB &
  &, 0.934201E+00_JPRB, 0.925944E+00_JPRB, 0.917328E+00_JPRB, 0.908359E+00_JPRB &
  &, 0.899042E+00_JPRB, 0.889385E+00_JPRB, 0.879392E+00_JPRB &
  &, 0.869073E+00_JPRB, 0.858433E+00_JPRB, 0.847481E+00_JPRB, 0.836225E+00_JPRB &
  &, 0.824672E+00_JPRB, 0.812834E+00_JPRB, 0.800716E+00_JPRB &
  &, 0.788334E+00_JPRB, 0.775694E+00_JPRB, 0.762807E+00_JPRB, 0.749687E+00_JPRB &
  &, 0.736348E+00_JPRB, 0.722794E+00_JPRB, 0.709045E+00_JPRB &
  &, 0.695113E+00_JPRB, 0.681014E+00_JPRB, 0.666758E+00_JPRB, 0.652359E+00_JPRB &
  &, 0.637839E+00_JPRB, 0.623209E+00_JPRB, 0.608484E+00_JPRB &
  &, 0.593674E+00_JPRB, 0.578813E+00_JPRB, 0.563905E+00_JPRB, 0.548966E+00_JPRB &
  &, 0.534025E+00_JPRB, 0.519085E+00_JPRB, 0.504169E+00_JPRB &
  &, 0.489283E+00_JPRB, 0.474465E+00_JPRB, 0.459725E+00_JPRB, 0.445070E+00_JPRB &
  &, 0.430520E+00_JPRB, 0.416098E+00_JPRB, 0.401813E+00_JPRB &
  &, 0.387675E+00_JPRB, 0.373718E+00_JPRB, 0.359940E+00_JPRB, 0.346363E+00_JPRB &
  &, 0.332979E+00_JPRB, 0.319838E+00_JPRB, 0.306919E+00_JPRB &
  &, 0.294255E+00_JPRB, 0.281851E+00_JPRB, 0.269692E+00_JPRB, 0.257826E+00_JPRB &
  &, 0.246238E+00_JPRB, 0.234941E+00_JPRB, 0.223947E+00_JPRB &
  &, 0.213251E+00_JPRB, 0.202861E+00_JPRB, 0.192786E+00_JPRB, 0.183013E+00_JPRB &
  &, 0.173564E+00_JPRB, 0.164442E+00_JPRB, 0.155629E+00_JPRB &
  &, 0.147142E+00_JPRB, 0.138957E+00_JPRB, 0.131090E+00_JPRB, 0.123555E+00_JPRB &
  &, 0.116320E+00_JPRB, 0.109372E+00_JPRB, 0.102745E+00_JPRB &
  &, 0.964211E-01_JPRB, 0.903835E-01_JPRB, 0.846105E-01_JPRB, 0.791548E-01_JPRB &
  &, 0.739408E-01_JPRB, 0.689925E-01_JPRB, 0.643348E-01_JPRB &
  &, 0.599095E-01_JPRB, 0.557097E-01_JPRB, 0.517558E-01_JPRB, 0.480391E-01_JPRB &
  &, 0.445197E-01_JPRB, 0.412449E-01_JPRB, 0.381407E-01_JPRB &
  &, 0.352214E-01_JPRB, 0.325021E-01_JPRB, 0.299649E-01_JPRB, 0.275906E-01_JPRB &
  &, 0.253573E-01_JPRB, 0.233106E-01_JPRB, 0.213932E-01_JPRB &
  &, 0.196145E-01_JPRB, 0.179481E-01_JPRB, 0.164021E-01_JPRB, 0.149849E-01_JPRB &
  &, 0.136668E-01_JPRB, 0.124545E-01_JPRB, 0.113550E-01_JPRB &
  &, 0.102952E-01_JPRB, 0.935988E-02_JPRB, 0.847351E-02_JPRB, 0.768174E-02_JPRB &
  &, 0.694732E-02_JPRB, 0.627392E-02_JPRB, 0.566529E-02_JPRB &
  &, 0.512522E-02_JPRB, 0.461204E-02_JPRB, 0.412760E-02_JPRB, 0.372074E-02_JPRB &
  &, 0.334786E-02_JPRB, 0.301092E-02_JPRB, 0.266281E-02_JPRB &
  &, 0.240310E-02_JPRB, 0.213488E-02_JPRB, 0.190938E-02_JPRB, 0.167664E-02_JPRB &
  &, 0.148942E-02_JPRB, 0.134991E-02_JPRB, 0.120597E-02_JPRB &
  &, 0.105755E-02_JPRB, 0.904594E-03_JPRB, 0.803743E-03_JPRB, 0.699828E-03_JPRB &
  &, 0.651096E-03_JPRB, 0.541748E-03_JPRB, 0.489126E-03_JPRB &
  &, 0.434930E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.204585E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 441, :) = (/ &
  &  0.981790E+00_JPRB, 0.976240E+00_JPRB, 0.970298E+00_JPRB, 0.963972E+00_JPRB &
  &, 0.957260E+00_JPRB, 0.950170E+00_JPRB, 0.942704E+00_JPRB &
  &, 0.934869E+00_JPRB, 0.926669E+00_JPRB, 0.918110E+00_JPRB, 0.909195E+00_JPRB &
  &, 0.899933E+00_JPRB, 0.890328E+00_JPRB, 0.880387E+00_JPRB &
  &, 0.870119E+00_JPRB, 0.859529E+00_JPRB, 0.848625E+00_JPRB, 0.837415E+00_JPRB &
  &, 0.825909E+00_JPRB, 0.814112E+00_JPRB, 0.802039E+00_JPRB &
  &, 0.789700E+00_JPRB, 0.777101E+00_JPRB, 0.764254E+00_JPRB, 0.751172E+00_JPRB &
  &, 0.737865E+00_JPRB, 0.724347E+00_JPRB, 0.710629E+00_JPRB &
  &, 0.696728E+00_JPRB, 0.682656E+00_JPRB, 0.668425E+00_JPRB, 0.654056E+00_JPRB &
  &, 0.639557E+00_JPRB, 0.624943E+00_JPRB, 0.610239E+00_JPRB &
  &, 0.595451E+00_JPRB, 0.580597E+00_JPRB, 0.565704E+00_JPRB, 0.550780E+00_JPRB &
  &, 0.535844E+00_JPRB, 0.520908E+00_JPRB, 0.505995E+00_JPRB &
  &, 0.491121E+00_JPRB, 0.476304E+00_JPRB, 0.461552E+00_JPRB, 0.446894E+00_JPRB &
  &, 0.432341E+00_JPRB, 0.417913E+00_JPRB, 0.403609E+00_JPRB &
  &, 0.389475E+00_JPRB, 0.375495E+00_JPRB, 0.361704E+00_JPRB, 0.348099E+00_JPRB &
  &, 0.334713E+00_JPRB, 0.321540E+00_JPRB, 0.308600E+00_JPRB &
  &, 0.295914E+00_JPRB, 0.283468E+00_JPRB, 0.271298E+00_JPRB, 0.259403E+00_JPRB &
  &, 0.247783E+00_JPRB, 0.236451E+00_JPRB, 0.225420E+00_JPRB &
  &, 0.214703E+00_JPRB, 0.204271E+00_JPRB, 0.194151E+00_JPRB, 0.184349E+00_JPRB &
  &, 0.174870E+00_JPRB, 0.165696E+00_JPRB, 0.156847E+00_JPRB &
  &, 0.148323E+00_JPRB, 0.140098E+00_JPRB, 0.132211E+00_JPRB, 0.124632E+00_JPRB &
  &, 0.117350E+00_JPRB, 0.110377E+00_JPRB, 0.103698E+00_JPRB &
  &, 0.973453E-01_JPRB, 0.912518E-01_JPRB, 0.854706E-01_JPRB, 0.799545E-01_JPRB &
  &, 0.747035E-01_JPRB, 0.697432E-01_JPRB, 0.650179E-01_JPRB &
  &, 0.605778E-01_JPRB, 0.563623E-01_JPRB, 0.523628E-01_JPRB, 0.485987E-01_JPRB &
  &, 0.450596E-01_JPRB, 0.417336E-01_JPRB, 0.386072E-01_JPRB &
  &, 0.356964E-01_JPRB, 0.329533E-01_JPRB, 0.303587E-01_JPRB, 0.279579E-01_JPRB &
  &, 0.257311E-01_JPRB, 0.236563E-01_JPRB, 0.217097E-01_JPRB &
  &, 0.199007E-01_JPRB, 0.182028E-01_JPRB, 0.166612E-01_JPRB, 0.152107E-01_JPRB &
  &, 0.138963E-01_JPRB, 0.126489E-01_JPRB, 0.115132E-01_JPRB &
  &, 0.104961E-01_JPRB, 0.952320E-02_JPRB, 0.863946E-02_JPRB, 0.785035E-02_JPRB &
  &, 0.707579E-02_JPRB, 0.640442E-02_JPRB, 0.579783E-02_JPRB &
  &, 0.521496E-02_JPRB, 0.470317E-02_JPRB, 0.422013E-02_JPRB, 0.381469E-02_JPRB &
  &, 0.339554E-02_JPRB, 0.305932E-02_JPRB, 0.276106E-02_JPRB &
  &, 0.245296E-02_JPRB, 0.218547E-02_JPRB, 0.196071E-02_JPRB, 0.172872E-02_JPRB &
  &, 0.154226E-02_JPRB, 0.134991E-02_JPRB, 0.120597E-02_JPRB &
  &, 0.105755E-02_JPRB, 0.960506E-03_JPRB, 0.860439E-03_JPRB, 0.757314E-03_JPRB &
  &, 0.651096E-03_JPRB, 0.600831E-03_JPRB, 0.489126E-03_JPRB &
  &, 0.434930E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.262724E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.204585E-03_JPRB, 0.207133E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART63',1,ZHOOK_HANDLE)
END SUBROUTINE PART63

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART64

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART64',0,ZHOOK_HANDLE)

XCW( 442, :) = (/ &
  &  0.982040E+00_JPRB, 0.976552E+00_JPRB, 0.970671E+00_JPRB, 0.964405E+00_JPRB &
  &, 0.957753E+00_JPRB, 0.950722E+00_JPRB, 0.943316E+00_JPRB &
  &, 0.935538E+00_JPRB, 0.927394E+00_JPRB, 0.918890E+00_JPRB, 0.910032E+00_JPRB &
  &, 0.900822E+00_JPRB, 0.891271E+00_JPRB, 0.881383E+00_JPRB &
  &, 0.871164E+00_JPRB, 0.860625E+00_JPRB, 0.849768E+00_JPRB, 0.838606E+00_JPRB &
  &, 0.827147E+00_JPRB, 0.815397E+00_JPRB, 0.803366E+00_JPRB &
  &, 0.791066E+00_JPRB, 0.778508E+00_JPRB, 0.765698E+00_JPRB, 0.752653E+00_JPRB &
  &, 0.739382E+00_JPRB, 0.725897E+00_JPRB, 0.712213E+00_JPRB &
  &, 0.698343E+00_JPRB, 0.684299E+00_JPRB, 0.670097E+00_JPRB, 0.655748E+00_JPRB &
  &, 0.641274E+00_JPRB, 0.626682E+00_JPRB, 0.611995E+00_JPRB &
  &, 0.597228E+00_JPRB, 0.582390E+00_JPRB, 0.567494E+00_JPRB, 0.552595E+00_JPRB &
  &, 0.537664E+00_JPRB, 0.522741E+00_JPRB, 0.507832E+00_JPRB &
  &, 0.492960E+00_JPRB, 0.478143E+00_JPRB, 0.463390E+00_JPRB, 0.448730E+00_JPRB &
  &, 0.434174E+00_JPRB, 0.419729E+00_JPRB, 0.405417E+00_JPRB &
  &, 0.391262E+00_JPRB, 0.377271E+00_JPRB, 0.363469E+00_JPRB, 0.349849E+00_JPRB &
  &, 0.336433E+00_JPRB, 0.323241E+00_JPRB, 0.310296E+00_JPRB &
  &, 0.297572E+00_JPRB, 0.285102E+00_JPRB, 0.272904E+00_JPRB, 0.260980E+00_JPRB &
  &, 0.249328E+00_JPRB, 0.237979E+00_JPRB, 0.226911E+00_JPRB &
  &, 0.216154E+00_JPRB, 0.205681E+00_JPRB, 0.195535E+00_JPRB, 0.185705E+00_JPRB &
  &, 0.176176E+00_JPRB, 0.166969E+00_JPRB, 0.158086E+00_JPRB &
  &, 0.149525E+00_JPRB, 0.141261E+00_JPRB, 0.133332E+00_JPRB, 0.125709E+00_JPRB &
  &, 0.118381E+00_JPRB, 0.111382E+00_JPRB, 0.104676E+00_JPRB &
  &, 0.982695E-01_JPRB, 0.921448E-01_JPRB, 0.863308E-01_JPRB, 0.807800E-01_JPRB &
  &, 0.754926E-01_JPRB, 0.704939E-01_JPRB, 0.657284E-01_JPRB &
  &, 0.612462E-01_JPRB, 0.569866E-01_JPRB, 0.529699E-01_JPRB, 0.491876E-01_JPRB &
  &, 0.456294E-01_JPRB, 0.422529E-01_JPRB, 0.391048E-01_JPRB &
  &, 0.361397E-01_JPRB, 0.333724E-01_JPRB, 0.307852E-01_JPRB, 0.283585E-01_JPRB &
  &, 0.261048E-01_JPRB, 0.239675E-01_JPRB, 0.220262E-01_JPRB &
  &, 0.201869E-01_JPRB, 0.184939E-01_JPRB, 0.169202E-01_JPRB, 0.154740E-01_JPRB &
  &, 0.141258E-01_JPRB, 0.128823E-01_JPRB, 0.117108E-01_JPRB &
  &, 0.106568E-01_JPRB, 0.968651E-02_JPRB, 0.880541E-02_JPRB, 0.797680E-02_JPRB &
  &, 0.720426E-02_JPRB, 0.653492E-02_JPRB, 0.588620E-02_JPRB &
  &, 0.530470E-02_JPRB, 0.479430E-02_JPRB, 0.431266E-02_JPRB, 0.386166E-02_JPRB &
  &, 0.349091E-02_JPRB, 0.310772E-02_JPRB, 0.281019E-02_JPRB &
  &, 0.250281E-02_JPRB, 0.223607E-02_JPRB, 0.201205E-02_JPRB, 0.178081E-02_JPRB &
  &, 0.159510E-02_JPRB, 0.140351E-02_JPRB, 0.126034E-02_JPRB &
  &, 0.111269E-02_JPRB, 0.960506E-03_JPRB, 0.860439E-03_JPRB, 0.757314E-03_JPRB &
  &, 0.651096E-03_JPRB, 0.600831E-03_JPRB, 0.489126E-03_JPRB &
  &, 0.434930E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.204585E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 443, :) = (/ &
  &  0.982290E+00_JPRB, 0.976864E+00_JPRB, 0.971045E+00_JPRB, 0.964839E+00_JPRB &
  &, 0.958246E+00_JPRB, 0.951275E+00_JPRB, 0.943927E+00_JPRB &
  &, 0.936207E+00_JPRB, 0.928121E+00_JPRB, 0.919671E+00_JPRB, 0.910868E+00_JPRB &
  &, 0.901713E+00_JPRB, 0.892215E+00_JPRB, 0.882379E+00_JPRB &
  &, 0.872211E+00_JPRB, 0.861721E+00_JPRB, 0.850914E+00_JPRB, 0.839800E+00_JPRB &
  &, 0.828384E+00_JPRB, 0.816679E+00_JPRB, 0.804692E+00_JPRB &
  &, 0.792435E+00_JPRB, 0.779916E+00_JPRB, 0.767145E+00_JPRB, 0.754138E+00_JPRB &
  &, 0.740902E+00_JPRB, 0.727454E+00_JPRB, 0.713800E+00_JPRB &
  &, 0.699962E+00_JPRB, 0.685946E+00_JPRB, 0.671768E+00_JPRB, 0.657448E+00_JPRB &
  &, 0.642996E+00_JPRB, 0.628425E+00_JPRB, 0.613759E+00_JPRB &
  &, 0.599004E+00_JPRB, 0.584183E+00_JPRB, 0.569312E+00_JPRB, 0.554410E+00_JPRB &
  &, 0.539493E+00_JPRB, 0.524575E+00_JPRB, 0.509668E+00_JPRB &
  &, 0.494798E+00_JPRB, 0.479982E+00_JPRB, 0.465228E+00_JPRB, 0.450567E+00_JPRB &
  &, 0.435994E+00_JPRB, 0.421557E+00_JPRB, 0.407239E+00_JPRB &
  &, 0.393075E+00_JPRB, 0.379061E+00_JPRB, 0.365233E+00_JPRB, 0.351599E+00_JPRB &
  &, 0.338181E+00_JPRB, 0.324957E+00_JPRB, 0.311977E+00_JPRB &
  &, 0.299245E+00_JPRB, 0.286751E+00_JPRB, 0.274526E+00_JPRB, 0.262573E+00_JPRB &
  &, 0.250889E+00_JPRB, 0.239506E+00_JPRB, 0.228403E+00_JPRB &
  &, 0.217606E+00_JPRB, 0.207109E+00_JPRB, 0.196938E+00_JPRB, 0.187061E+00_JPRB &
  &, 0.177502E+00_JPRB, 0.168263E+00_JPRB, 0.159325E+00_JPRB &
  &, 0.150727E+00_JPRB, 0.142424E+00_JPRB, 0.134453E+00_JPRB, 0.126786E+00_JPRB &
  &, 0.119434E+00_JPRB, 0.112387E+00_JPRB, 0.105653E+00_JPRB &
  &, 0.991938E-01_JPRB, 0.930379E-01_JPRB, 0.871910E-01_JPRB, 0.816055E-01_JPRB &
  &, 0.762816E-01_JPRB, 0.712446E-01_JPRB, 0.664662E-01_JPRB &
  &, 0.619145E-01_JPRB, 0.576392E-01_JPRB, 0.536059E-01_JPRB, 0.497766E-01_JPRB &
  &, 0.461693E-01_JPRB, 0.428027E-01_JPRB, 0.396025E-01_JPRB &
  &, 0.366147E-01_JPRB, 0.338237E-01_JPRB, 0.312117E-01_JPRB, 0.287592E-01_JPRB &
  &, 0.264446E-01_JPRB, 0.243132E-01_JPRB, 0.223428E-01_JPRB &
  &, 0.205089E-01_JPRB, 0.187850E-01_JPRB, 0.171792E-01_JPRB, 0.156998E-01_JPRB &
  &, 0.143553E-01_JPRB, 0.130767E-01_JPRB, 0.119085E-01_JPRB &
  &, 0.108577E-01_JPRB, 0.984983E-02_JPRB, 0.892988E-02_JPRB, 0.810326E-02_JPRB &
  &, 0.733272E-02_JPRB, 0.666542E-02_JPRB, 0.601874E-02_JPRB &
  &, 0.543931E-02_JPRB, 0.488543E-02_JPRB, 0.440519E-02_JPRB, 0.395560E-02_JPRB &
  &, 0.353859E-02_JPRB, 0.320453E-02_JPRB, 0.285932E-02_JPRB &
  &, 0.255267E-02_JPRB, 0.228666E-02_JPRB, 0.206338E-02_JPRB, 0.183289E-02_JPRB &
  &, 0.159510E-02_JPRB, 0.145711E-02_JPRB, 0.126034E-02_JPRB &
  &, 0.111269E-02_JPRB, 0.101642E-02_JPRB, 0.860439E-03_JPRB, 0.757314E-03_JPRB &
  &, 0.709377E-03_JPRB, 0.600831E-03_JPRB, 0.549017E-03_JPRB &
  &, 0.434930E-03_JPRB, 0.379143E-03_JPRB, 0.321747E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.204585E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 444, :) = (/ &
  &  0.982539E+00_JPRB, 0.977177E+00_JPRB, 0.971418E+00_JPRB, 0.965273E+00_JPRB &
  &, 0.958740E+00_JPRB, 0.951827E+00_JPRB, 0.944537E+00_JPRB &
  &, 0.936876E+00_JPRB, 0.928845E+00_JPRB, 0.920454E+00_JPRB, 0.911705E+00_JPRB &
  &, 0.902603E+00_JPRB, 0.893159E+00_JPRB, 0.883374E+00_JPRB &
  &, 0.873259E+00_JPRB, 0.862818E+00_JPRB, 0.852059E+00_JPRB, 0.840992E+00_JPRB &
  &, 0.829623E+00_JPRB, 0.817964E+00_JPRB, 0.806018E+00_JPRB &
  &, 0.793805E+00_JPRB, 0.781327E+00_JPRB, 0.768595E+00_JPRB, 0.755623E+00_JPRB &
  &, 0.742426E+00_JPRB, 0.729007E+00_JPRB, 0.715388E+00_JPRB &
  &, 0.701580E+00_JPRB, 0.687593E+00_JPRB, 0.673444E+00_JPRB, 0.659149E+00_JPRB &
  &, 0.644718E+00_JPRB, 0.630173E+00_JPRB, 0.615524E+00_JPRB &
  &, 0.600781E+00_JPRB, 0.585985E+00_JPRB, 0.571121E+00_JPRB, 0.556234E+00_JPRB &
  &, 0.541323E+00_JPRB, 0.526409E+00_JPRB, 0.511515E+00_JPRB &
  &, 0.496647E+00_JPRB, 0.481821E+00_JPRB, 0.467078E+00_JPRB, 0.452403E+00_JPRB &
  &, 0.437839E+00_JPRB, 0.423385E+00_JPRB, 0.409060E+00_JPRB &
  &, 0.394875E+00_JPRB, 0.380865E+00_JPRB, 0.367011E+00_JPRB, 0.353363E+00_JPRB &
  &, 0.339915E+00_JPRB, 0.326688E+00_JPRB, 0.313673E+00_JPRB &
  &, 0.300919E+00_JPRB, 0.288400E+00_JPRB, 0.276149E+00_JPRB, 0.264166E+00_JPRB &
  &, 0.252451E+00_JPRB, 0.241034E+00_JPRB, 0.229911E+00_JPRB &
  &, 0.219076E+00_JPRB, 0.208537E+00_JPRB, 0.198322E+00_JPRB, 0.188417E+00_JPRB &
  &, 0.178828E+00_JPRB, 0.169537E+00_JPRB, 0.160585E+00_JPRB &
  &, 0.151929E+00_JPRB, 0.143608E+00_JPRB, 0.135596E+00_JPRB, 0.127885E+00_JPRB &
  &, 0.120487E+00_JPRB, 0.113415E+00_JPRB, 0.106631E+00_JPRB &
  &, 0.100142E+00_JPRB, 0.939558E-01_JPRB, 0.880512E-01_JPRB, 0.824310E-01_JPRB &
  &, 0.770706E-01_JPRB, 0.719953E-01_JPRB, 0.671767E-01_JPRB &
  &, 0.626107E-01_JPRB, 0.582918E-01_JPRB, 0.542130E-01_JPRB, 0.503655E-01_JPRB &
  &, 0.467392E-01_JPRB, 0.433219E-01_JPRB, 0.401001E-01_JPRB &
  &, 0.370897E-01_JPRB, 0.342749E-01_JPRB, 0.316054E-01_JPRB, 0.291265E-01_JPRB &
  &, 0.268183E-01_JPRB, 0.246589E-01_JPRB, 0.226593E-01_JPRB &
  &, 0.207951E-01_JPRB, 0.190761E-01_JPRB, 0.174382E-01_JPRB, 0.159632E-01_JPRB &
  &, 0.145849E-01_JPRB, 0.133101E-01_JPRB, 0.121061E-01_JPRB &
  &, 0.110184E-01_JPRB, 0.100131E-01_JPRB, 0.909583E-02_JPRB, 0.827187E-02_JPRB &
  &, 0.750402E-02_JPRB, 0.679592E-02_JPRB, 0.610711E-02_JPRB &
  &, 0.552906E-02_JPRB, 0.497656E-02_JPRB, 0.449772E-02_JPRB, 0.404954E-02_JPRB &
  &, 0.363396E-02_JPRB, 0.325293E-02_JPRB, 0.290844E-02_JPRB &
  &, 0.260253E-02_JPRB, 0.233725E-02_JPRB, 0.206338E-02_JPRB, 0.188497E-02_JPRB &
  &, 0.164793E-02_JPRB, 0.145711E-02_JPRB, 0.131470E-02_JPRB &
  &, 0.116782E-02_JPRB, 0.101642E-02_JPRB, 0.917135E-03_JPRB, 0.814800E-03_JPRB &
  &, 0.709377E-03_JPRB, 0.600831E-03_JPRB, 0.549017E-03_JPRB &
  &, 0.495635E-03_JPRB, 0.440667E-03_JPRB, 0.384097E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.204585E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 445, :) = (/ &
  &  0.982791E+00_JPRB, 0.977487E+00_JPRB, 0.971791E+00_JPRB, 0.965706E+00_JPRB &
  &, 0.959234E+00_JPRB, 0.952380E+00_JPRB, 0.945149E+00_JPRB &
  &, 0.937544E+00_JPRB, 0.929571E+00_JPRB, 0.921235E+00_JPRB, 0.912542E+00_JPRB &
  &, 0.903495E+00_JPRB, 0.894102E+00_JPRB, 0.884370E+00_JPRB &
  &, 0.874305E+00_JPRB, 0.863915E+00_JPRB, 0.853206E+00_JPRB, 0.842186E+00_JPRB &
  &, 0.830864E+00_JPRB, 0.819248E+00_JPRB, 0.807347E+00_JPRB &
  &, 0.795174E+00_JPRB, 0.782738E+00_JPRB, 0.770046E+00_JPRB, 0.757111E+00_JPRB &
  &, 0.743950E+00_JPRB, 0.730568E+00_JPRB, 0.716979E+00_JPRB &
  &, 0.703199E+00_JPRB, 0.689244E+00_JPRB, 0.675119E+00_JPRB, 0.660850E+00_JPRB &
  &, 0.646444E+00_JPRB, 0.631920E+00_JPRB, 0.617288E+00_JPRB &
  &, 0.602567E+00_JPRB, 0.587778E+00_JPRB, 0.572940E+00_JPRB, 0.558059E+00_JPRB &
  &, 0.543153E+00_JPRB, 0.528253E+00_JPRB, 0.513352E+00_JPRB &
  &, 0.498497E+00_JPRB, 0.483683E+00_JPRB, 0.468928E+00_JPRB, 0.454251E+00_JPRB &
  &, 0.439672E+00_JPRB, 0.425212E+00_JPRB, 0.410882E+00_JPRB &
  &, 0.396688E+00_JPRB, 0.382655E+00_JPRB, 0.368803E+00_JPRB, 0.355128E+00_JPRB &
  &, 0.341664E+00_JPRB, 0.328419E+00_JPRB, 0.315384E+00_JPRB &
  &, 0.302593E+00_JPRB, 0.290049E+00_JPRB, 0.277771E+00_JPRB, 0.265760E+00_JPRB &
  &, 0.254030E+00_JPRB, 0.242579E+00_JPRB, 0.231402E+00_JPRB &
  &, 0.220546E+00_JPRB, 0.209984E+00_JPRB, 0.199725E+00_JPRB, 0.189793E+00_JPRB &
  &, 0.180154E+00_JPRB, 0.170831E+00_JPRB, 0.161844E+00_JPRB &
  &, 0.153152E+00_JPRB, 0.144792E+00_JPRB, 0.136739E+00_JPRB, 0.128985E+00_JPRB &
  &, 0.121564E+00_JPRB, 0.114443E+00_JPRB, 0.107608E+00_JPRB &
  &, 0.101091E+00_JPRB, 0.948737E-01_JPRB, 0.889113E-01_JPRB, 0.832565E-01_JPRB &
  &, 0.778859E-01_JPRB, 0.727728E-01_JPRB, 0.679145E-01_JPRB &
  &, 0.633069E-01_JPRB, 0.589444E-01_JPRB, 0.548489E-01_JPRB, 0.509545E-01_JPRB &
  &, 0.473090E-01_JPRB, 0.438412E-01_JPRB, 0.405977E-01_JPRB &
  &, 0.375646E-01_JPRB, 0.347262E-01_JPRB, 0.320319E-01_JPRB, 0.295272E-01_JPRB &
  &, 0.271921E-01_JPRB, 0.250392E-01_JPRB, 0.230110E-01_JPRB &
  &, 0.211171E-01_JPRB, 0.193308E-01_JPRB, 0.177342E-01_JPRB, 0.161889E-01_JPRB &
  &, 0.148144E-01_JPRB, 0.135045E-01_JPRB, 0.123038E-01_JPRB &
  &, 0.112192E-01_JPRB, 0.102173E-01_JPRB, 0.926178E-02_JPRB, 0.839833E-02_JPRB &
  &, 0.763248E-02_JPRB, 0.688291E-02_JPRB, 0.623965E-02_JPRB &
  &, 0.561880E-02_JPRB, 0.506769E-02_JPRB, 0.459025E-02_JPRB, 0.414349E-02_JPRB &
  &, 0.372933E-02_JPRB, 0.334973E-02_JPRB, 0.300669E-02_JPRB &
  &, 0.265238E-02_JPRB, 0.238784E-02_JPRB, 0.211471E-02_JPRB, 0.188497E-02_JPRB &
  &, 0.170077E-02_JPRB, 0.151070E-02_JPRB, 0.131470E-02_JPRB &
  &, 0.116782E-02_JPRB, 0.107233E-02_JPRB, 0.917135E-03_JPRB, 0.814800E-03_JPRB &
  &, 0.709377E-03_JPRB, 0.659914E-03_JPRB, 0.549017E-03_JPRB &
  &, 0.495635E-03_JPRB, 0.440667E-03_JPRB, 0.384097E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.269447E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 446, :) = (/ &
  &  0.983042E+00_JPRB, 0.977799E+00_JPRB, 0.972164E+00_JPRB, 0.966140E+00_JPRB &
  &, 0.959727E+00_JPRB, 0.952933E+00_JPRB, 0.945760E+00_JPRB &
  &, 0.938213E+00_JPRB, 0.930297E+00_JPRB, 0.922017E+00_JPRB, 0.913379E+00_JPRB &
  &, 0.904386E+00_JPRB, 0.895048E+00_JPRB, 0.885368E+00_JPRB &
  &, 0.875354E+00_JPRB, 0.865012E+00_JPRB, 0.854352E+00_JPRB, 0.843379E+00_JPRB &
  &, 0.832104E+00_JPRB, 0.820533E+00_JPRB, 0.808677E+00_JPRB &
  &, 0.796546E+00_JPRB, 0.784149E+00_JPRB, 0.771497E+00_JPRB, 0.758600E+00_JPRB &
  &, 0.745474E+00_JPRB, 0.732125E+00_JPRB, 0.718570E+00_JPRB &
  &, 0.704826E+00_JPRB, 0.690895E+00_JPRB, 0.676803E+00_JPRB, 0.662555E+00_JPRB &
  &, 0.648175E+00_JPRB, 0.633668E+00_JPRB, 0.619057E+00_JPRB &
  &, 0.604362E+00_JPRB, 0.589590E+00_JPRB, 0.574759E+00_JPRB, 0.559884E+00_JPRB &
  &, 0.544993E+00_JPRB, 0.530097E+00_JPRB, 0.515210E+00_JPRB &
  &, 0.500346E+00_JPRB, 0.485533E+00_JPRB, 0.470778E+00_JPRB, 0.456099E+00_JPRB &
  &, 0.441517E+00_JPRB, 0.427053E+00_JPRB, 0.412703E+00_JPRB &
  &, 0.398502E+00_JPRB, 0.384458E+00_JPRB, 0.370595E+00_JPRB, 0.356906E+00_JPRB &
  &, 0.343427E+00_JPRB, 0.330150E+00_JPRB, 0.317095E+00_JPRB &
  &, 0.304282E+00_JPRB, 0.291714E+00_JPRB, 0.279410E+00_JPRB, 0.267370E+00_JPRB &
  &, 0.255609E+00_JPRB, 0.244124E+00_JPRB, 0.232929E+00_JPRB &
  &, 0.222034E+00_JPRB, 0.211431E+00_JPRB, 0.201146E+00_JPRB, 0.191168E+00_JPRB &
  &, 0.181500E+00_JPRB, 0.172145E+00_JPRB, 0.163104E+00_JPRB &
  &, 0.154375E+00_JPRB, 0.145977E+00_JPRB, 0.137882E+00_JPRB, 0.130106E+00_JPRB &
  &, 0.122640E+00_JPRB, 0.115471E+00_JPRB, 0.108610E+00_JPRB &
  &, 0.102039E+00_JPRB, 0.957915E-01_JPRB, 0.897968E-01_JPRB, 0.841078E-01_JPRB &
  &, 0.786749E-01_JPRB, 0.735235E-01_JPRB, 0.686523E-01_JPRB &
  &, 0.640031E-01_JPRB, 0.596254E-01_JPRB, 0.554849E-01_JPRB, 0.515729E-01_JPRB &
  &, 0.478789E-01_JPRB, 0.443910E-01_JPRB, 0.411264E-01_JPRB &
  &, 0.380396E-01_JPRB, 0.351775E-01_JPRB, 0.324585E-01_JPRB, 0.299279E-01_JPRB &
  &, 0.275998E-01_JPRB, 0.253849E-01_JPRB, 0.233275E-01_JPRB &
  &, 0.214033E-01_JPRB, 0.196582E-01_JPRB, 0.179932E-01_JPRB, 0.164523E-01_JPRB &
  &, 0.150439E-01_JPRB, 0.137378E-01_JPRB, 0.125409E-01_JPRB &
  &, 0.114201E-01_JPRB, 0.103806E-01_JPRB, 0.942773E-02_JPRB, 0.856694E-02_JPRB &
  &, 0.776095E-02_JPRB, 0.701341E-02_JPRB, 0.637220E-02_JPRB &
  &, 0.575341E-02_JPRB, 0.520438E-02_JPRB, 0.468278E-02_JPRB, 0.419046E-02_JPRB &
  &, 0.377701E-02_JPRB, 0.339814E-02_JPRB, 0.305582E-02_JPRB &
  &, 0.275210E-02_JPRB, 0.243844E-02_JPRB, 0.216605E-02_JPRB, 0.193705E-02_JPRB &
  &, 0.175361E-02_JPRB, 0.156430E-02_JPRB, 0.136906E-02_JPRB &
  &, 0.122295E-02_JPRB, 0.107233E-02_JPRB, 0.973831E-03_JPRB, 0.872285E-03_JPRB &
  &, 0.767658E-03_JPRB, 0.659914E-03_JPRB, 0.549017E-03_JPRB &
  &, 0.495635E-03_JPRB, 0.440667E-03_JPRB, 0.384097E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.266073E-03_JPRB, 0.269447E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 447, :) = (/ &
  &  0.983292E+00_JPRB, 0.978112E+00_JPRB, 0.972537E+00_JPRB, 0.966573E+00_JPRB &
  &, 0.960221E+00_JPRB, 0.953485E+00_JPRB, 0.946371E+00_JPRB &
  &, 0.938881E+00_JPRB, 0.931023E+00_JPRB, 0.922799E+00_JPRB, 0.914216E+00_JPRB &
  &, 0.905278E+00_JPRB, 0.895992E+00_JPRB, 0.886364E+00_JPRB &
  &, 0.876402E+00_JPRB, 0.866111E+00_JPRB, 0.855499E+00_JPRB, 0.844575E+00_JPRB &
  &, 0.833346E+00_JPRB, 0.821821E+00_JPRB, 0.810006E+00_JPRB &
  &, 0.797919E+00_JPRB, 0.785563E+00_JPRB, 0.772951E+00_JPRB, 0.760092E+00_JPRB &
  &, 0.747002E+00_JPRB, 0.733686E+00_JPRB, 0.720166E+00_JPRB &
  &, 0.706448E+00_JPRB, 0.692550E+00_JPRB, 0.678483E+00_JPRB, 0.664264E+00_JPRB &
  &, 0.649905E+00_JPRB, 0.635420E+00_JPRB, 0.620831E+00_JPRB &
  &, 0.606148E+00_JPRB, 0.591392E+00_JPRB, 0.576577E+00_JPRB, 0.561718E+00_JPRB &
  &, 0.546833E+00_JPRB, 0.531941E+00_JPRB, 0.517058E+00_JPRB &
  &, 0.502207E+00_JPRB, 0.487395E+00_JPRB, 0.472640E+00_JPRB, 0.457959E+00_JPRB &
  &, 0.443374E+00_JPRB, 0.428893E+00_JPRB, 0.414550E+00_JPRB &
  &, 0.400328E+00_JPRB, 0.386275E+00_JPRB, 0.372387E+00_JPRB, 0.358684E+00_JPRB &
  &, 0.345175E+00_JPRB, 0.331881E+00_JPRB, 0.318821E+00_JPRB &
  &, 0.305971E+00_JPRB, 0.293379E+00_JPRB, 0.281049E+00_JPRB, 0.268979E+00_JPRB &
  &, 0.257187E+00_JPRB, 0.245669E+00_JPRB, 0.234438E+00_JPRB &
  &, 0.223522E+00_JPRB, 0.212878E+00_JPRB, 0.202568E+00_JPRB, 0.192543E+00_JPRB &
  &, 0.182846E+00_JPRB, 0.173439E+00_JPRB, 0.164364E+00_JPRB &
  &, 0.155619E+00_JPRB, 0.147161E+00_JPRB, 0.139047E+00_JPRB, 0.131228E+00_JPRB &
  &, 0.123716E+00_JPRB, 0.116499E+00_JPRB, 0.109611E+00_JPRB &
  &, 0.103012E+00_JPRB, 0.967094E-01_JPRB, 0.906823E-01_JPRB, 0.849591E-01_JPRB &
  &, 0.794902E-01_JPRB, 0.743010E-01_JPRB, 0.693901E-01_JPRB &
  &, 0.647271E-01_JPRB, 0.603064E-01_JPRB, 0.561209E-01_JPRB, 0.521618E-01_JPRB &
  &, 0.484488E-01_JPRB, 0.449408E-01_JPRB, 0.416241E-01_JPRB &
  &, 0.385462E-01_JPRB, 0.356288E-01_JPRB, 0.329178E-01_JPRB, 0.303620E-01_JPRB &
  &, 0.279736E-01_JPRB, 0.257306E-01_JPRB, 0.236792E-01_JPRB &
  &, 0.217252E-01_JPRB, 0.199493E-01_JPRB, 0.182523E-01_JPRB, 0.167157E-01_JPRB &
  &, 0.152734E-01_JPRB, 0.139712E-01_JPRB, 0.127386E-01_JPRB &
  &, 0.115808E-01_JPRB, 0.105439E-01_JPRB, 0.959368E-02_JPRB, 0.869339E-02_JPRB &
  &, 0.788942E-02_JPRB, 0.714391E-02_JPRB, 0.646056E-02_JPRB &
  &, 0.584315E-02_JPRB, 0.529551E-02_JPRB, 0.477531E-02_JPRB, 0.428440E-02_JPRB &
  &, 0.387238E-02_JPRB, 0.344654E-02_JPRB, 0.310495E-02_JPRB &
  &, 0.280195E-02_JPRB, 0.248903E-02_JPRB, 0.221738E-02_JPRB, 0.198914E-02_JPRB &
  &, 0.175361E-02_JPRB, 0.156430E-02_JPRB, 0.142342E-02_JPRB &
  &, 0.122295E-02_JPRB, 0.112824E-02_JPRB, 0.973831E-03_JPRB, 0.872285E-03_JPRB &
  &, 0.767658E-03_JPRB, 0.659914E-03_JPRB, 0.608907E-03_JPRB &
  &, 0.495635E-03_JPRB, 0.440667E-03_JPRB, 0.384097E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.269447E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 448, :) = (/ &
  &  0.983540E+00_JPRB, 0.978425E+00_JPRB, 0.972910E+00_JPRB, 0.967007E+00_JPRB &
  &, 0.960714E+00_JPRB, 0.954038E+00_JPRB, 0.946982E+00_JPRB &
  &, 0.939551E+00_JPRB, 0.931749E+00_JPRB, 0.923581E+00_JPRB, 0.915053E+00_JPRB &
  &, 0.906170E+00_JPRB, 0.896937E+00_JPRB, 0.887362E+00_JPRB &
  &, 0.877452E+00_JPRB, 0.867210E+00_JPRB, 0.856648E+00_JPRB, 0.845771E+00_JPRB &
  &, 0.834589E+00_JPRB, 0.823106E+00_JPRB, 0.811339E+00_JPRB &
  &, 0.799292E+00_JPRB, 0.786977E+00_JPRB, 0.774405E+00_JPRB, 0.761584E+00_JPRB &
  &, 0.748530E+00_JPRB, 0.735251E+00_JPRB, 0.721761E+00_JPRB &
  &, 0.708075E+00_JPRB, 0.694208E+00_JPRB, 0.680167E+00_JPRB, 0.665973E+00_JPRB &
  &, 0.651640E+00_JPRB, 0.637176E+00_JPRB, 0.622609E+00_JPRB &
  &, 0.607943E+00_JPRB, 0.593204E+00_JPRB, 0.578396E+00_JPRB, 0.563553E+00_JPRB &
  &, 0.548683E+00_JPRB, 0.533796E+00_JPRB, 0.518926E+00_JPRB &
  &, 0.504067E+00_JPRB, 0.489257E+00_JPRB, 0.474501E+00_JPRB, 0.459819E+00_JPRB &
  &, 0.445232E+00_JPRB, 0.430746E+00_JPRB, 0.416384E+00_JPRB &
  &, 0.402155E+00_JPRB, 0.388092E+00_JPRB, 0.374192E+00_JPRB, 0.360477E+00_JPRB &
  &, 0.346953E+00_JPRB, 0.333626E+00_JPRB, 0.320532E+00_JPRB &
  &, 0.307676E+00_JPRB, 0.295060E+00_JPRB, 0.282704E+00_JPRB, 0.270606E+00_JPRB &
  &, 0.258783E+00_JPRB, 0.247232E+00_JPRB, 0.235982E+00_JPRB &
  &, 0.225010E+00_JPRB, 0.214343E+00_JPRB, 0.203990E+00_JPRB, 0.193938E+00_JPRB &
  &, 0.184192E+00_JPRB, 0.174773E+00_JPRB, 0.165644E+00_JPRB &
  &, 0.156863E+00_JPRB, 0.148367E+00_JPRB, 0.140190E+00_JPRB, 0.132350E+00_JPRB &
  &, 0.124793E+00_JPRB, 0.117551E+00_JPRB, 0.110612E+00_JPRB &
  &, 0.103985E+00_JPRB, 0.976273E-01_JPRB, 0.915930E-01_JPRB, 0.858104E-01_JPRB &
  &, 0.803055E-01_JPRB, 0.751053E-01_JPRB, 0.701279E-01_JPRB &
  &, 0.654233E-01_JPRB, 0.609874E-01_JPRB, 0.567569E-01_JPRB, 0.527802E-01_JPRB &
  &, 0.490186E-01_JPRB, 0.454906E-01_JPRB, 0.421528E-01_JPRB &
  &, 0.390212E-01_JPRB, 0.360801E-01_JPRB, 0.333443E-01_JPRB, 0.307627E-01_JPRB &
  &, 0.283473E-01_JPRB, 0.261109E-01_JPRB, 0.239957E-01_JPRB &
  &, 0.220472E-01_JPRB, 0.202404E-01_JPRB, 0.185483E-01_JPRB, 0.169791E-01_JPRB &
  &, 0.155412E-01_JPRB, 0.141656E-01_JPRB, 0.129362E-01_JPRB &
  &, 0.117817E-01_JPRB, 0.107481E-01_JPRB, 0.975963E-02_JPRB, 0.886200E-02_JPRB &
  &, 0.806071E-02_JPRB, 0.727441E-02_JPRB, 0.659311E-02_JPRB &
  &, 0.597776E-02_JPRB, 0.538664E-02_JPRB, 0.486784E-02_JPRB, 0.437834E-02_JPRB &
  &, 0.392006E-02_JPRB, 0.354334E-02_JPRB, 0.320320E-02_JPRB &
  &, 0.285181E-02_JPRB, 0.253962E-02_JPRB, 0.226872E-02_JPRB, 0.204122E-02_JPRB &
  &, 0.180644E-02_JPRB, 0.161789E-02_JPRB, 0.142342E-02_JPRB &
  &, 0.127809E-02_JPRB, 0.112824E-02_JPRB, 0.103053E-02_JPRB, 0.872285E-03_JPRB &
  &, 0.767658E-03_JPRB, 0.718997E-03_JPRB, 0.608907E-03_JPRB &
  &, 0.556339E-03_JPRB, 0.440667E-03_JPRB, 0.384097E-03_JPRB, 0.325905E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.269447E-03_JPRB, 0.207133E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART64',1,ZHOOK_HANDLE)
END SUBROUTINE PART64

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART65

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART65',0,ZHOOK_HANDLE)

XCW( 449, :) = (/ &
  &  0.983793E+00_JPRB, 0.978736E+00_JPRB, 0.973283E+00_JPRB, 0.967440E+00_JPRB &
  &, 0.961207E+00_JPRB, 0.954590E+00_JPRB, 0.947593E+00_JPRB &
  &, 0.940219E+00_JPRB, 0.932475E+00_JPRB, 0.924363E+00_JPRB, 0.915891E+00_JPRB &
  &, 0.907062E+00_JPRB, 0.897883E+00_JPRB, 0.888360E+00_JPRB &
  &, 0.878501E+00_JPRB, 0.868310E+00_JPRB, 0.857797E+00_JPRB, 0.846968E+00_JPRB &
  &, 0.835831E+00_JPRB, 0.824397E+00_JPRB, 0.812671E+00_JPRB &
  &, 0.800668E+00_JPRB, 0.788391E+00_JPRB, 0.775859E+00_JPRB, 0.763076E+00_JPRB &
  &, 0.750057E+00_JPRB, 0.736816E+00_JPRB, 0.723360E+00_JPRB &
  &, 0.709705E+00_JPRB, 0.695867E+00_JPRB, 0.681855E+00_JPRB, 0.667686E+00_JPRB &
  &, 0.653375E+00_JPRB, 0.638937E+00_JPRB, 0.624387E+00_JPRB &
  &, 0.609738E+00_JPRB, 0.595016E+00_JPRB, 0.580225E+00_JPRB, 0.565398E+00_JPRB &
  &, 0.550533E+00_JPRB, 0.535661E+00_JPRB, 0.520785E+00_JPRB &
  &, 0.505939E+00_JPRB, 0.491130E+00_JPRB, 0.476374E+00_JPRB, 0.461680E+00_JPRB &
  &, 0.447089E+00_JPRB, 0.432599E+00_JPRB, 0.418231E+00_JPRB &
  &, 0.403994E+00_JPRB, 0.389909E+00_JPRB, 0.375998E+00_JPRB, 0.362255E+00_JPRB &
  &, 0.348716E+00_JPRB, 0.335387E+00_JPRB, 0.322274E+00_JPRB &
  &, 0.309381E+00_JPRB, 0.296741E+00_JPRB, 0.284358E+00_JPRB, 0.272232E+00_JPRB &
  &, 0.260379E+00_JPRB, 0.248794E+00_JPRB, 0.237508E+00_JPRB &
  &, 0.226516E+00_JPRB, 0.215809E+00_JPRB, 0.205412E+00_JPRB, 0.195333E+00_JPRB &
  &, 0.185557E+00_JPRB, 0.176088E+00_JPRB, 0.166945E+00_JPRB &
  &, 0.158108E+00_JPRB, 0.149572E+00_JPRB, 0.141377E+00_JPRB, 0.133472E+00_JPRB &
  &, 0.125892E+00_JPRB, 0.118603E+00_JPRB, 0.111638E+00_JPRB &
  &, 0.104958E+00_JPRB, 0.985700E-01_JPRB, 0.924785E-01_JPRB, 0.866875E-01_JPRB &
  &, 0.811472E-01_JPRB, 0.758827E-01_JPRB, 0.708930E-01_JPRB &
  &, 0.661473E-01_JPRB, 0.616684E-01_JPRB, 0.574218E-01_JPRB, 0.533986E-01_JPRB &
  &, 0.496185E-01_JPRB, 0.460404E-01_JPRB, 0.426815E-01_JPRB &
  &, 0.395279E-01_JPRB, 0.365636E-01_JPRB, 0.337708E-01_JPRB, 0.311967E-01_JPRB &
  &, 0.287551E-01_JPRB, 0.264911E-01_JPRB, 0.243474E-01_JPRB &
  &, 0.223692E-01_JPRB, 0.205315E-01_JPRB, 0.188443E-01_JPRB, 0.172424E-01_JPRB &
  &, 0.157708E-01_JPRB, 0.143989E-01_JPRB, 0.131734E-01_JPRB &
  &, 0.119826E-01_JPRB, 0.109114E-01_JPRB, 0.992558E-02_JPRB, 0.903061E-02_JPRB &
  &, 0.818918E-02_JPRB, 0.740491E-02_JPRB, 0.672565E-02_JPRB &
  &, 0.606750E-02_JPRB, 0.547777E-02_JPRB, 0.496037E-02_JPRB, 0.447229E-02_JPRB &
  &, 0.401543E-02_JPRB, 0.359174E-02_JPRB, 0.325233E-02_JPRB &
  &, 0.290166E-02_JPRB, 0.259021E-02_JPRB, 0.232005E-02_JPRB, 0.209330E-02_JPRB &
  &, 0.185928E-02_JPRB, 0.167149E-02_JPRB, 0.147779E-02_JPRB &
  &, 0.133322E-02_JPRB, 0.118415E-02_JPRB, 0.103053E-02_JPRB, 0.929771E-03_JPRB &
  &, 0.825940E-03_JPRB, 0.718997E-03_JPRB, 0.608907E-03_JPRB &
  &, 0.556339E-03_JPRB, 0.502191E-03_JPRB, 0.446446E-03_JPRB, 0.389085E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.269447E-03_JPRB, 0.207133E-03_JPRB/)
XCW( 450, :) = (/ &
  &  0.984044E+00_JPRB, 0.979046E+00_JPRB, 0.973655E+00_JPRB, 0.967874E+00_JPRB &
  &, 0.961700E+00_JPRB, 0.955144E+00_JPRB, 0.948204E+00_JPRB &
  &, 0.940889E+00_JPRB, 0.933201E+00_JPRB, 0.925146E+00_JPRB, 0.916729E+00_JPRB &
  &, 0.907954E+00_JPRB, 0.898829E+00_JPRB, 0.889359E+00_JPRB &
  &, 0.879550E+00_JPRB, 0.869410E+00_JPRB, 0.858946E+00_JPRB, 0.848165E+00_JPRB &
  &, 0.837026E+00_JPRB, 0.825685E+00_JPRB, 0.814004E+00_JPRB &
  &, 0.802044E+00_JPRB, 0.789809E+00_JPRB, 0.777317E+00_JPRB, 0.764572E+00_JPRB &
  &, 0.751592E+00_JPRB, 0.738384E+00_JPRB, 0.724959E+00_JPRB &
  &, 0.711336E+00_JPRB, 0.697526E+00_JPRB, 0.683542E+00_JPRB, 0.669399E+00_JPRB &
  &, 0.655114E+00_JPRB, 0.640698E+00_JPRB, 0.626169E+00_JPRB &
  &, 0.611542E+00_JPRB, 0.596828E+00_JPRB, 0.582063E+00_JPRB, 0.567242E+00_JPRB &
  &, 0.552383E+00_JPRB, 0.537516E+00_JPRB, 0.522654E+00_JPRB &
  &, 0.507811E+00_JPRB, 0.493003E+00_JPRB, 0.478236E+00_JPRB, 0.463552E+00_JPRB &
  &, 0.448958E+00_JPRB, 0.434465E+00_JPRB, 0.420078E+00_JPRB &
  &, 0.405834E+00_JPRB, 0.391739E+00_JPRB, 0.377790E+00_JPRB, 0.364062E+00_JPRB &
  &, 0.350493E+00_JPRB, 0.337147E+00_JPRB, 0.324000E+00_JPRB &
  &, 0.311101E+00_JPRB, 0.298438E+00_JPRB, 0.286013E+00_JPRB, 0.273859E+00_JPRB &
  &, 0.261974E+00_JPRB, 0.250374E+00_JPRB, 0.239053E+00_JPRB &
  &, 0.228022E+00_JPRB, 0.217292E+00_JPRB, 0.206853E+00_JPRB, 0.196728E+00_JPRB &
  &, 0.186923E+00_JPRB, 0.177422E+00_JPRB, 0.168225E+00_JPRB &
  &, 0.159352E+00_JPRB, 0.150800E+00_JPRB, 0.142542E+00_JPRB, 0.134617E+00_JPRB &
  &, 0.126991E+00_JPRB, 0.119677E+00_JPRB, 0.112663E+00_JPRB &
  &, 0.105931E+00_JPRB, 0.995127E-01_JPRB, 0.933893E-01_JPRB, 0.875388E-01_JPRB &
  &, 0.819888E-01_JPRB, 0.766870E-01_JPRB, 0.716581E-01_JPRB &
  &, 0.668713E-01_JPRB, 0.623494E-01_JPRB, 0.580867E-01_JPRB, 0.540170E-01_JPRB &
  &, 0.502184E-01_JPRB, 0.466207E-01_JPRB, 0.432103E-01_JPRB &
  &, 0.400345E-01_JPRB, 0.370471E-01_JPRB, 0.342302E-01_JPRB, 0.315974E-01_JPRB &
  &, 0.291288E-01_JPRB, 0.268368E-01_JPRB, 0.246991E-01_JPRB &
  &, 0.226912E-01_JPRB, 0.208590E-01_JPRB, 0.191033E-01_JPRB, 0.175058E-01_JPRB &
  &, 0.160385E-01_JPRB, 0.146323E-01_JPRB, 0.133711E-01_JPRB &
  &, 0.121835E-01_JPRB, 0.111155E-01_JPRB, 0.100915E-01_JPRB, 0.919922E-02_JPRB &
  &, 0.831765E-02_JPRB, 0.757891E-02_JPRB, 0.685820E-02_JPRB &
  &, 0.620211E-02_JPRB, 0.561447E-02_JPRB, 0.505290E-02_JPRB, 0.456623E-02_JPRB &
  &, 0.411080E-02_JPRB, 0.368855E-02_JPRB, 0.330145E-02_JPRB &
  &, 0.295152E-02_JPRB, 0.264081E-02_JPRB, 0.237139E-02_JPRB, 0.214538E-02_JPRB &
  &, 0.191211E-02_JPRB, 0.167149E-02_JPRB, 0.153215E-02_JPRB &
  &, 0.133322E-02_JPRB, 0.118415E-02_JPRB, 0.103053E-02_JPRB, 0.929771E-03_JPRB &
  &, 0.825940E-03_JPRB, 0.718997E-03_JPRB, 0.668798E-03_JPRB &
  &, 0.556339E-03_JPRB, 0.502191E-03_JPRB, 0.446446E-03_JPRB, 0.389085E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.269447E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 451, :) = (/ &
  &  0.984293E+00_JPRB, 0.979361E+00_JPRB, 0.974029E+00_JPRB, 0.968307E+00_JPRB &
  &, 0.962194E+00_JPRB, 0.955696E+00_JPRB, 0.948816E+00_JPRB &
  &, 0.941558E+00_JPRB, 0.933928E+00_JPRB, 0.925929E+00_JPRB, 0.917567E+00_JPRB &
  &, 0.908847E+00_JPRB, 0.899776E+00_JPRB, 0.890357E+00_JPRB &
  &, 0.880601E+00_JPRB, 0.870510E+00_JPRB, 0.860096E+00_JPRB, 0.849363E+00_JPRB &
  &, 0.838320E+00_JPRB, 0.826976E+00_JPRB, 0.815340E+00_JPRB &
  &, 0.803419E+00_JPRB, 0.791230E+00_JPRB, 0.778774E+00_JPRB, 0.766071E+00_JPRB &
  &, 0.753123E+00_JPRB, 0.739952E+00_JPRB, 0.726562E+00_JPRB &
  &, 0.712970E+00_JPRB, 0.699189E+00_JPRB, 0.685234E+00_JPRB, 0.671117E+00_JPRB &
  &, 0.656857E+00_JPRB, 0.642463E+00_JPRB, 0.627952E+00_JPRB &
  &, 0.613347E+00_JPRB, 0.598650E+00_JPRB, 0.583892E+00_JPRB, 0.569087E+00_JPRB &
  &, 0.554244E+00_JPRB, 0.539381E+00_JPRB, 0.524523E+00_JPRB &
  &, 0.509682E+00_JPRB, 0.494876E+00_JPRB, 0.480121E+00_JPRB, 0.465436E+00_JPRB &
  &, 0.450828E+00_JPRB, 0.436318E+00_JPRB, 0.421938E+00_JPRB &
  &, 0.407687E+00_JPRB, 0.393570E+00_JPRB, 0.379623E+00_JPRB, 0.365855E+00_JPRB &
  &, 0.352285E+00_JPRB, 0.338908E+00_JPRB, 0.325757E+00_JPRB &
  &, 0.312821E+00_JPRB, 0.300135E+00_JPRB, 0.287684E+00_JPRB, 0.275502E+00_JPRB &
  &, 0.263587E+00_JPRB, 0.251953E+00_JPRB, 0.240597E+00_JPRB &
  &, 0.229547E+00_JPRB, 0.218776E+00_JPRB, 0.208312E+00_JPRB, 0.198142E+00_JPRB &
  &, 0.188308E+00_JPRB, 0.178756E+00_JPRB, 0.169526E+00_JPRB &
  &, 0.160617E+00_JPRB, 0.152027E+00_JPRB, 0.143730E+00_JPRB, 0.135761E+00_JPRB &
  &, 0.128090E+00_JPRB, 0.120752E+00_JPRB, 0.113688E+00_JPRB &
  &, 0.106928E+00_JPRB, 0.100480E+00_JPRB, 0.943001E-01_JPRB, 0.884159E-01_JPRB &
  &, 0.828304E-01_JPRB, 0.774914E-01_JPRB, 0.724232E-01_JPRB &
  &, 0.676232E-01_JPRB, 0.630588E-01_JPRB, 0.587516E-01_JPRB, 0.546649E-01_JPRB &
  &, 0.508182E-01_JPRB, 0.471705E-01_JPRB, 0.437701E-01_JPRB &
  &, 0.405411E-01_JPRB, 0.375306E-01_JPRB, 0.346895E-01_JPRB, 0.320315E-01_JPRB &
  &, 0.295366E-01_JPRB, 0.272171E-01_JPRB, 0.250508E-01_JPRB &
  &, 0.230489E-01_JPRB, 0.211501E-01_JPRB, 0.193993E-01_JPRB, 0.177692E-01_JPRB &
  &, 0.162681E-01_JPRB, 0.148656E-01_JPRB, 0.136082E-01_JPRB &
  &, 0.123844E-01_JPRB, 0.112789E-01_JPRB, 0.102990E-01_JPRB, 0.932568E-02_JPRB &
  &, 0.848894E-02_JPRB, 0.770940E-02_JPRB, 0.699075E-02_JPRB &
  &, 0.629185E-02_JPRB, 0.570560E-02_JPRB, 0.514543E-02_JPRB, 0.466017E-02_JPRB &
  &, 0.420617E-02_JPRB, 0.378535E-02_JPRB, 0.339970E-02_JPRB &
  &, 0.305123E-02_JPRB, 0.274199E-02_JPRB, 0.242272E-02_JPRB, 0.219747E-02_JPRB &
  &, 0.196495E-02_JPRB, 0.172509E-02_JPRB, 0.153215E-02_JPRB &
  &, 0.138836E-02_JPRB, 0.124007E-02_JPRB, 0.108722E-02_JPRB, 0.987257E-03_JPRB &
  &, 0.825940E-03_JPRB, 0.718997E-03_JPRB, 0.668798E-03_JPRB &
  &, 0.556339E-03_JPRB, 0.502191E-03_JPRB, 0.446446E-03_JPRB, 0.389085E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.269447E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 452, :) = (/ &
  &  0.984545E+00_JPRB, 0.979672E+00_JPRB, 0.974401E+00_JPRB, 0.968740E+00_JPRB &
  &, 0.962687E+00_JPRB, 0.956249E+00_JPRB, 0.949427E+00_JPRB &
  &, 0.942227E+00_JPRB, 0.934654E+00_JPRB, 0.926711E+00_JPRB, 0.918405E+00_JPRB &
  &, 0.909740E+00_JPRB, 0.900722E+00_JPRB, 0.891357E+00_JPRB &
  &, 0.881652E+00_JPRB, 0.871612E+00_JPRB, 0.861247E+00_JPRB, 0.850561E+00_JPRB &
  &, 0.839567E+00_JPRB, 0.828268E+00_JPRB, 0.816676E+00_JPRB &
  &, 0.804799E+00_JPRB, 0.792648E+00_JPRB, 0.780235E+00_JPRB, 0.767566E+00_JPRB &
  &, 0.754658E+00_JPRB, 0.741521E+00_JPRB, 0.728164E+00_JPRB &
  &, 0.714605E+00_JPRB, 0.700856E+00_JPRB, 0.686926E+00_JPRB, 0.672839E+00_JPRB &
  &, 0.658600E+00_JPRB, 0.644228E+00_JPRB, 0.629739E+00_JPRB &
  &, 0.615151E+00_JPRB, 0.600471E+00_JPRB, 0.585730E+00_JPRB, 0.570932E+00_JPRB &
  &, 0.556104E+00_JPRB, 0.541257E+00_JPRB, 0.526402E+00_JPRB &
  &, 0.511565E+00_JPRB, 0.496760E+00_JPRB, 0.482006E+00_JPRB, 0.467308E+00_JPRB &
  &, 0.452697E+00_JPRB, 0.438196E+00_JPRB, 0.423798E+00_JPRB &
  &, 0.409539E+00_JPRB, 0.395414E+00_JPRB, 0.381456E+00_JPRB, 0.367675E+00_JPRB &
  &, 0.354077E+00_JPRB, 0.340683E+00_JPRB, 0.327498E+00_JPRB &
  &, 0.314541E+00_JPRB, 0.301832E+00_JPRB, 0.289356E+00_JPRB, 0.277145E+00_JPRB &
  &, 0.265217E+00_JPRB, 0.253550E+00_JPRB, 0.242159E+00_JPRB &
  &, 0.231071E+00_JPRB, 0.220260E+00_JPRB, 0.209772E+00_JPRB, 0.199575E+00_JPRB &
  &, 0.189674E+00_JPRB, 0.180111E+00_JPRB, 0.170848E+00_JPRB &
  &, 0.161882E+00_JPRB, 0.153254E+00_JPRB, 0.144939E+00_JPRB, 0.136928E+00_JPRB &
  &, 0.129212E+00_JPRB, 0.121827E+00_JPRB, 0.114737E+00_JPRB &
  &, 0.107925E+00_JPRB, 0.101448E+00_JPRB, 0.952361E-01_JPRB, 0.893188E-01_JPRB &
  &, 0.836720E-01_JPRB, 0.782957E-01_JPRB, 0.731883E-01_JPRB &
  &, 0.683472E-01_JPRB, 0.637681E-01_JPRB, 0.594164E-01_JPRB, 0.552833E-01_JPRB &
  &, 0.514181E-01_JPRB, 0.477509E-01_JPRB, 0.442988E-01_JPRB &
  &, 0.410478E-01_JPRB, 0.380141E-01_JPRB, 0.351488E-01_JPRB, 0.324656E-01_JPRB &
  &, 0.299443E-01_JPRB, 0.275974E-01_JPRB, 0.254025E-01_JPRB &
  &, 0.233709E-01_JPRB, 0.214775E-01_JPRB, 0.196954E-01_JPRB, 0.180702E-01_JPRB &
  &, 0.165358E-01_JPRB, 0.151378E-01_JPRB, 0.138059E-01_JPRB &
  &, 0.125852E-01_JPRB, 0.114830E-01_JPRB, 0.104649E-01_JPRB, 0.949429E-02_JPRB &
  &, 0.866024E-02_JPRB, 0.783990E-02_JPRB, 0.712329E-02_JPRB &
  &, 0.642646E-02_JPRB, 0.579673E-02_JPRB, 0.523796E-02_JPRB, 0.475411E-02_JPRB &
  &, 0.425385E-02_JPRB, 0.383375E-02_JPRB, 0.344883E-02_JPRB &
  &, 0.310109E-02_JPRB, 0.279258E-02_JPRB, 0.247406E-02_JPRB, 0.224955E-02_JPRB &
  &, 0.201779E-02_JPRB, 0.177868E-02_JPRB, 0.158651E-02_JPRB &
  &, 0.138836E-02_JPRB, 0.124007E-02_JPRB, 0.108722E-02_JPRB, 0.987257E-03_JPRB &
  &, 0.884221E-03_JPRB, 0.778080E-03_JPRB, 0.668798E-03_JPRB &
  &, 0.617043E-03_JPRB, 0.502191E-03_JPRB, 0.446446E-03_JPRB, 0.389085E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.334309E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 453, :) = (/ &
  &  0.984792E+00_JPRB, 0.979983E+00_JPRB, 0.974775E+00_JPRB, 0.969174E+00_JPRB &
  &, 0.963181E+00_JPRB, 0.956801E+00_JPRB, 0.950039E+00_JPRB &
  &, 0.942897E+00_JPRB, 0.935381E+00_JPRB, 0.927495E+00_JPRB, 0.919244E+00_JPRB &
  &, 0.910634E+00_JPRB, 0.901669E+00_JPRB, 0.892357E+00_JPRB &
  &, 0.882702E+00_JPRB, 0.872714E+00_JPRB, 0.862398E+00_JPRB, 0.851761E+00_JPRB &
  &, 0.840812E+00_JPRB, 0.829559E+00_JPRB, 0.818012E+00_JPRB &
  &, 0.806178E+00_JPRB, 0.794069E+00_JPRB, 0.781696E+00_JPRB, 0.769069E+00_JPRB &
  &, 0.756197E+00_JPRB, 0.743093E+00_JPRB, 0.729771E+00_JPRB &
  &, 0.716243E+00_JPRB, 0.702523E+00_JPRB, 0.688622E+00_JPRB, 0.674560E+00_JPRB &
  &, 0.660348E+00_JPRB, 0.645998E+00_JPRB, 0.631531E+00_JPRB &
  &, 0.616956E+00_JPRB, 0.602302E+00_JPRB, 0.587568E+00_JPRB, 0.572786E+00_JPRB &
  &, 0.557964E+00_JPRB, 0.543122E+00_JPRB, 0.528282E+00_JPRB &
  &, 0.513448E+00_JPRB, 0.498645E+00_JPRB, 0.483890E+00_JPRB, 0.469192E+00_JPRB &
  &, 0.454579E+00_JPRB, 0.440074E+00_JPRB, 0.425671E+00_JPRB &
  &, 0.411392E+00_JPRB, 0.397258E+00_JPRB, 0.383290E+00_JPRB, 0.369482E+00_JPRB &
  &, 0.355869E+00_JPRB, 0.342458E+00_JPRB, 0.329254E+00_JPRB &
  &, 0.316277E+00_JPRB, 0.303544E+00_JPRB, 0.291043E+00_JPRB, 0.278805E+00_JPRB &
  &, 0.266829E+00_JPRB, 0.255130E+00_JPRB, 0.243721E+00_JPRB &
  &, 0.232595E+00_JPRB, 0.221763E+00_JPRB, 0.211232E+00_JPRB, 0.200989E+00_JPRB &
  &, 0.191079E+00_JPRB, 0.181466E+00_JPRB, 0.172149E+00_JPRB &
  &, 0.163169E+00_JPRB, 0.154503E+00_JPRB, 0.146126E+00_JPRB, 0.138072E+00_JPRB &
  &, 0.130334E+00_JPRB, 0.122902E+00_JPRB, 0.115762E+00_JPRB &
  &, 0.108947E+00_JPRB, 0.102415E+00_JPRB, 0.961469E-01_JPRB, 0.901959E-01_JPRB &
  &, 0.845136E-01_JPRB, 0.791268E-01_JPRB, 0.739808E-01_JPRB &
  &, 0.690991E-01_JPRB, 0.644775E-01_JPRB, 0.600813E-01_JPRB, 0.559311E-01_JPRB &
  &, 0.520179E-01_JPRB, 0.483312E-01_JPRB, 0.448586E-01_JPRB &
  &, 0.415861E-01_JPRB, 0.384976E-01_JPRB, 0.356082E-01_JPRB, 0.328997E-01_JPRB &
  &, 0.303520E-01_JPRB, 0.279777E-01_JPRB, 0.257894E-01_JPRB &
  &, 0.237286E-01_JPRB, 0.218050E-01_JPRB, 0.199914E-01_JPRB, 0.183336E-01_JPRB &
  &, 0.168036E-01_JPRB, 0.153712E-01_JPRB, 0.140431E-01_JPRB &
  &, 0.128263E-01_JPRB, 0.116871E-01_JPRB, 0.106309E-01_JPRB, 0.966290E-02_JPRB &
  &, 0.878870E-02_JPRB, 0.797040E-02_JPRB, 0.725584E-02_JPRB &
  &, 0.656107E-02_JPRB, 0.593342E-02_JPRB, 0.537675E-02_JPRB, 0.484806E-02_JPRB &
  &, 0.434922E-02_JPRB, 0.393056E-02_JPRB, 0.354708E-02_JPRB &
  &, 0.315095E-02_JPRB, 0.284318E-02_JPRB, 0.252539E-02_JPRB, 0.230163E-02_JPRB &
  &, 0.201779E-02_JPRB, 0.183228E-02_JPRB, 0.164087E-02_JPRB &
  &, 0.144349E-02_JPRB, 0.129598E-02_JPRB, 0.114392E-02_JPRB, 0.987257E-03_JPRB &
  &, 0.884221E-03_JPRB, 0.778080E-03_JPRB, 0.668798E-03_JPRB &
  &, 0.617043E-03_JPRB, 0.563715E-03_JPRB, 0.446446E-03_JPRB, 0.389085E-03_JPRB &
  &, 0.330092E-03_JPRB, 0.334309E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 454, :) = (/ &
  &  0.985044E+00_JPRB, 0.980297E+00_JPRB, 0.975147E+00_JPRB, 0.969607E+00_JPRB &
  &, 0.963674E+00_JPRB, 0.957354E+00_JPRB, 0.950651E+00_JPRB &
  &, 0.943567E+00_JPRB, 0.936108E+00_JPRB, 0.928279E+00_JPRB, 0.920083E+00_JPRB &
  &, 0.911527E+00_JPRB, 0.902616E+00_JPRB, 0.893356E+00_JPRB &
  &, 0.883755E+00_JPRB, 0.873817E+00_JPRB, 0.863550E+00_JPRB, 0.852963E+00_JPRB &
  &, 0.842060E+00_JPRB, 0.830853E+00_JPRB, 0.819348E+00_JPRB &
  &, 0.807561E+00_JPRB, 0.795493E+00_JPRB, 0.783158E+00_JPRB, 0.770568E+00_JPRB &
  &, 0.757736E+00_JPRB, 0.744665E+00_JPRB, 0.731378E+00_JPRB &
  &, 0.717881E+00_JPRB, 0.704194E+00_JPRB, 0.690323E+00_JPRB, 0.676286E+00_JPRB &
  &, 0.662096E+00_JPRB, 0.647772E+00_JPRB, 0.633327E+00_JPRB &
  &, 0.618769E+00_JPRB, 0.604133E+00_JPRB, 0.589416E+00_JPRB, 0.574651E+00_JPRB &
  &, 0.559835E+00_JPRB, 0.544998E+00_JPRB, 0.530162E+00_JPRB &
  &, 0.515330E+00_JPRB, 0.500540E+00_JPRB, 0.485775E+00_JPRB, 0.471088E+00_JPRB &
  &, 0.456473E+00_JPRB, 0.441952E+00_JPRB, 0.427531E+00_JPRB &
  &, 0.413258E+00_JPRB, 0.399115E+00_JPRB, 0.385123E+00_JPRB, 0.371303E+00_JPRB &
  &, 0.357676E+00_JPRB, 0.344248E+00_JPRB, 0.331026E+00_JPRB &
  &, 0.318028E+00_JPRB, 0.305257E+00_JPRB, 0.292730E+00_JPRB, 0.280464E+00_JPRB &
  &, 0.268476E+00_JPRB, 0.256745E+00_JPRB, 0.245301E+00_JPRB &
  &, 0.234138E+00_JPRB, 0.223265E+00_JPRB, 0.212691E+00_JPRB, 0.202423E+00_JPRB &
  &, 0.192465E+00_JPRB, 0.182820E+00_JPRB, 0.173491E+00_JPRB &
  &, 0.164455E+00_JPRB, 0.155731E+00_JPRB, 0.147335E+00_JPRB, 0.139239E+00_JPRB &
  &, 0.131457E+00_JPRB, 0.124001E+00_JPRB, 0.116811E+00_JPRB &
  &, 0.109944E+00_JPRB, 0.103383E+00_JPRB, 0.970830E-01_JPRB, 0.910988E-01_JPRB &
  &, 0.853816E-01_JPRB, 0.799311E-01_JPRB, 0.747732E-01_JPRB &
  &, 0.698510E-01_JPRB, 0.651869E-01_JPRB, 0.607751E-01_JPRB, 0.565790E-01_JPRB &
  &, 0.526478E-01_JPRB, 0.489116E-01_JPRB, 0.454185E-01_JPRB &
  &, 0.420927E-01_JPRB, 0.389811E-01_JPRB, 0.360675E-01_JPRB, 0.333337E-01_JPRB &
  &, 0.307937E-01_JPRB, 0.283925E-01_JPRB, 0.261411E-01_JPRB &
  &, 0.240506E-01_JPRB, 0.220961E-01_JPRB, 0.202874E-01_JPRB, 0.186346E-01_JPRB &
  &, 0.170714E-01_JPRB, 0.156045E-01_JPRB, 0.142803E-01_JPRB &
  &, 0.130272E-01_JPRB, 0.118913E-01_JPRB, 0.108383E-01_JPRB, 0.983151E-02_JPRB &
  &, 0.896000E-02_JPRB, 0.814440E-02_JPRB, 0.738838E-02_JPRB &
  &, 0.669569E-02_JPRB, 0.602455E-02_JPRB, 0.546928E-02_JPRB, 0.494200E-02_JPRB &
  &, 0.444458E-02_JPRB, 0.402736E-02_JPRB, 0.359621E-02_JPRB &
  &, 0.325066E-02_JPRB, 0.289377E-02_JPRB, 0.262806E-02_JPRB, 0.235371E-02_JPRB &
  &, 0.207062E-02_JPRB, 0.188588E-02_JPRB, 0.164087E-02_JPRB &
  &, 0.149863E-02_JPRB, 0.129598E-02_JPRB, 0.114392E-02_JPRB, 0.104474E-02_JPRB &
  &, 0.942503E-03_JPRB, 0.837163E-03_JPRB, 0.728689E-03_JPRB &
  &, 0.617043E-03_JPRB, 0.563715E-03_JPRB, 0.508795E-03_JPRB, 0.452266E-03_JPRB &
  &, 0.394110E-03_JPRB, 0.334309E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 455, :) = (/ &
  &  0.985294E+00_JPRB, 0.980607E+00_JPRB, 0.975520E+00_JPRB, 0.970041E+00_JPRB &
  &, 0.964168E+00_JPRB, 0.957907E+00_JPRB, 0.951262E+00_JPRB &
  &, 0.944236E+00_JPRB, 0.936835E+00_JPRB, 0.929062E+00_JPRB, 0.920922E+00_JPRB &
  &, 0.912420E+00_JPRB, 0.903565E+00_JPRB, 0.894357E+00_JPRB &
  &, 0.884807E+00_JPRB, 0.874920E+00_JPRB, 0.864702E+00_JPRB, 0.854162E+00_JPRB &
  &, 0.843309E+00_JPRB, 0.832147E+00_JPRB, 0.820687E+00_JPRB &
  &, 0.808940E+00_JPRB, 0.796917E+00_JPRB, 0.784622E+00_JPRB, 0.772071E+00_JPRB &
  &, 0.759274E+00_JPRB, 0.746241E+00_JPRB, 0.732988E+00_JPRB &
  &, 0.719524E+00_JPRB, 0.705865E+00_JPRB, 0.692023E+00_JPRB, 0.678012E+00_JPRB &
  &, 0.663852E+00_JPRB, 0.649546E+00_JPRB, 0.635123E+00_JPRB &
  &, 0.620592E+00_JPRB, 0.605965E+00_JPRB, 0.591264E+00_JPRB, 0.576506E+00_JPRB &
  &, 0.561706E+00_JPRB, 0.546884E+00_JPRB, 0.532053E+00_JPRB &
  &, 0.517224E+00_JPRB, 0.502436E+00_JPRB, 0.487672E+00_JPRB, 0.472983E+00_JPRB &
  &, 0.458367E+00_JPRB, 0.443830E+00_JPRB, 0.429416E+00_JPRB &
  &, 0.415124E+00_JPRB, 0.400972E+00_JPRB, 0.386970E+00_JPRB, 0.373138E+00_JPRB &
  &, 0.359482E+00_JPRB, 0.346038E+00_JPRB, 0.332783E+00_JPRB &
  &, 0.319764E+00_JPRB, 0.306985E+00_JPRB, 0.294434E+00_JPRB, 0.282141E+00_JPRB &
  &, 0.270106E+00_JPRB, 0.258359E+00_JPRB, 0.246881E+00_JPRB &
  &, 0.235680E+00_JPRB, 0.224786E+00_JPRB, 0.214170E+00_JPRB, 0.203876E+00_JPRB &
  &, 0.193870E+00_JPRB, 0.184195E+00_JPRB, 0.174812E+00_JPRB &
  &, 0.165742E+00_JPRB, 0.157001E+00_JPRB, 0.148566E+00_JPRB, 0.140428E+00_JPRB &
  &, 0.132602E+00_JPRB, 0.125099E+00_JPRB, 0.117884E+00_JPRB &
  &, 0.110965E+00_JPRB, 0.104350E+00_JPRB, 0.980443E-01_JPRB, 0.920017E-01_JPRB &
  &, 0.862495E-01_JPRB, 0.807622E-01_JPRB, 0.755657E-01_JPRB &
  &, 0.706029E-01_JPRB, 0.658962E-01_JPRB, 0.614689E-01_JPRB, 0.572563E-01_JPRB &
  &, 0.532777E-01_JPRB, 0.495225E-01_JPRB, 0.459783E-01_JPRB &
  &, 0.426310E-01_JPRB, 0.394969E-01_JPRB, 0.365596E-01_JPRB, 0.338012E-01_JPRB &
  &, 0.312015E-01_JPRB, 0.287728E-01_JPRB, 0.265280E-01_JPRB &
  &, 0.244083E-01_JPRB, 0.224236E-01_JPRB, 0.206204E-01_JPRB, 0.188980E-01_JPRB &
  &, 0.173392E-01_JPRB, 0.158378E-01_JPRB, 0.145174E-01_JPRB &
  &, 0.132281E-01_JPRB, 0.120954E-01_JPRB, 0.110043E-01_JPRB, 0.100001E-01_JPRB &
  &, 0.913129E-02_JPRB, 0.827490E-02_JPRB, 0.752093E-02_JPRB &
  &, 0.678543E-02_JPRB, 0.616124E-02_JPRB, 0.556181E-02_JPRB, 0.503594E-02_JPRB &
  &, 0.453995E-02_JPRB, 0.407576E-02_JPRB, 0.369446E-02_JPRB &
  &, 0.330052E-02_JPRB, 0.294436E-02_JPRB, 0.267939E-02_JPRB, 0.240580E-02_JPRB &
  &, 0.212346E-02_JPRB, 0.188588E-02_JPRB, 0.169523E-02_JPRB &
  &, 0.149863E-02_JPRB, 0.135189E-02_JPRB, 0.120061E-02_JPRB, 0.104474E-02_JPRB &
  &, 0.942503E-03_JPRB, 0.837163E-03_JPRB, 0.728689E-03_JPRB &
  &, 0.617043E-03_JPRB, 0.563715E-03_JPRB, 0.508795E-03_JPRB, 0.452266E-03_JPRB &
  &, 0.394110E-03_JPRB, 0.334309E-03_JPRB, 0.272845E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART65',1,ZHOOK_HANDLE)
END SUBROUTINE PART65

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART66

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART66',0,ZHOOK_HANDLE)

XCW( 456, :) = (/ &
  &  0.985545E+00_JPRB, 0.980919E+00_JPRB, 0.975893E+00_JPRB, 0.970474E+00_JPRB &
  &, 0.964661E+00_JPRB, 0.958460E+00_JPRB, 0.951874E+00_JPRB &
  &, 0.944907E+00_JPRB, 0.937562E+00_JPRB, 0.929844E+00_JPRB, 0.921762E+00_JPRB &
  &, 0.913315E+00_JPRB, 0.904512E+00_JPRB, 0.895359E+00_JPRB &
  &, 0.885860E+00_JPRB, 0.876024E+00_JPRB, 0.865856E+00_JPRB, 0.855365E+00_JPRB &
  &, 0.844557E+00_JPRB, 0.833442E+00_JPRB, 0.822029E+00_JPRB &
  &, 0.810326E+00_JPRB, 0.798342E+00_JPRB, 0.786087E+00_JPRB, 0.773577E+00_JPRB &
  &, 0.760817E+00_JPRB, 0.747820E+00_JPRB, 0.734598E+00_JPRB &
  &, 0.721170E+00_JPRB, 0.707539E+00_JPRB, 0.693727E+00_JPRB, 0.679742E+00_JPRB &
  &, 0.665604E+00_JPRB, 0.651329E+00_JPRB, 0.636924E+00_JPRB &
  &, 0.622406E+00_JPRB, 0.607805E+00_JPRB, 0.593112E+00_JPRB, 0.578371E+00_JPRB &
  &, 0.563587E+00_JPRB, 0.548770E+00_JPRB, 0.533943E+00_JPRB &
  &, 0.519129E+00_JPRB, 0.504332E+00_JPRB, 0.489580E+00_JPRB, 0.474879E+00_JPRB &
  &, 0.460261E+00_JPRB, 0.445720E+00_JPRB, 0.431302E+00_JPRB &
  &, 0.416990E+00_JPRB, 0.402829E+00_JPRB, 0.388817E+00_JPRB, 0.374972E+00_JPRB &
  &, 0.361303E+00_JPRB, 0.347829E+00_JPRB, 0.334569E+00_JPRB &
  &, 0.321515E+00_JPRB, 0.308714E+00_JPRB, 0.296137E+00_JPRB, 0.283817E+00_JPRB &
  &, 0.271752E+00_JPRB, 0.259974E+00_JPRB, 0.248460E+00_JPRB &
  &, 0.237241E+00_JPRB, 0.226307E+00_JPRB, 0.215668E+00_JPRB, 0.205329E+00_JPRB &
  &, 0.195295E+00_JPRB, 0.185570E+00_JPRB, 0.176155E+00_JPRB &
  &, 0.167049E+00_JPRB, 0.158250E+00_JPRB, 0.149775E+00_JPRB, 0.141617E+00_JPRB &
  &, 0.133747E+00_JPRB, 0.126197E+00_JPRB, 0.118957E+00_JPRB &
  &, 0.112011E+00_JPRB, 0.105342E+00_JPRB, 0.989804E-01_JPRB, 0.929046E-01_JPRB &
  &, 0.871174E-01_JPRB, 0.815933E-01_JPRB, 0.763581E-01_JPRB &
  &, 0.713826E-01_JPRB, 0.666340E-01_JPRB, 0.621627E-01_JPRB, 0.579041E-01_JPRB &
  &, 0.539075E-01_JPRB, 0.501028E-01_JPRB, 0.465381E-01_JPRB &
  &, 0.431693E-01_JPRB, 0.400126E-01_JPRB, 0.370190E-01_JPRB, 0.342353E-01_JPRB &
  &, 0.316432E-01_JPRB, 0.291877E-01_JPRB, 0.268797E-01_JPRB &
  &, 0.247661E-01_JPRB, 0.227874E-01_JPRB, 0.209164E-01_JPRB, 0.191990E-01_JPRB &
  &, 0.176070E-01_JPRB, 0.161101E-01_JPRB, 0.147151E-01_JPRB &
  &, 0.134691E-01_JPRB, 0.122996E-01_JPRB, 0.112117E-01_JPRB, 0.102109E-01_JPRB &
  &, 0.925976E-02_JPRB, 0.840540E-02_JPRB, 0.765347E-02_JPRB &
  &, 0.692004E-02_JPRB, 0.625237E-02_JPRB, 0.565435E-02_JPRB, 0.512989E-02_JPRB &
  &, 0.463532E-02_JPRB, 0.417257E-02_JPRB, 0.374359E-02_JPRB &
  &, 0.335037E-02_JPRB, 0.304555E-02_JPRB, 0.273073E-02_JPRB, 0.245788E-02_JPRB &
  &, 0.217630E-02_JPRB, 0.193947E-02_JPRB, 0.174960E-02_JPRB &
  &, 0.155376E-02_JPRB, 0.135189E-02_JPRB, 0.120061E-02_JPRB, 0.110223E-02_JPRB &
  &, 0.942503E-03_JPRB, 0.837163E-03_JPRB, 0.728689E-03_JPRB &
  &, 0.677748E-03_JPRB, 0.563715E-03_JPRB, 0.508795E-03_JPRB, 0.452266E-03_JPRB &
  &, 0.394110E-03_JPRB, 0.334309E-03_JPRB, 0.272845E-03_JPRB/)
XCW( 457, :) = (/ &
  &  0.985794E+00_JPRB, 0.981230E+00_JPRB, 0.976266E+00_JPRB, 0.970908E+00_JPRB &
  &, 0.965155E+00_JPRB, 0.959014E+00_JPRB, 0.952486E+00_JPRB &
  &, 0.945576E+00_JPRB, 0.938289E+00_JPRB, 0.930629E+00_JPRB, 0.922602E+00_JPRB &
  &, 0.914210E+00_JPRB, 0.905461E+00_JPRB, 0.896360E+00_JPRB &
  &, 0.886914E+00_JPRB, 0.877129E+00_JPRB, 0.867010E+00_JPRB, 0.856568E+00_JPRB &
  &, 0.845808E+00_JPRB, 0.834739E+00_JPRB, 0.823368E+00_JPRB &
  &, 0.811708E+00_JPRB, 0.799766E+00_JPRB, 0.787555E+00_JPRB, 0.775083E+00_JPRB &
  &, 0.762359E+00_JPRB, 0.749400E+00_JPRB, 0.736213E+00_JPRB &
  &, 0.722816E+00_JPRB, 0.709218E+00_JPRB, 0.695432E+00_JPRB, 0.681477E+00_JPRB &
  &, 0.667365E+00_JPRB, 0.653107E+00_JPRB, 0.638725E+00_JPRB &
  &, 0.624229E+00_JPRB, 0.609636E+00_JPRB, 0.594970E+00_JPRB, 0.580245E+00_JPRB &
  &, 0.565468E+00_JPRB, 0.550657E+00_JPRB, 0.535845E+00_JPRB &
  &, 0.521022E+00_JPRB, 0.506239E+00_JPRB, 0.491488E+00_JPRB, 0.476787E+00_JPRB &
  &, 0.462155E+00_JPRB, 0.447623E+00_JPRB, 0.433188E+00_JPRB &
  &, 0.418869E+00_JPRB, 0.404700E+00_JPRB, 0.390664E+00_JPRB, 0.376807E+00_JPRB &
  &, 0.363124E+00_JPRB, 0.349633E+00_JPRB, 0.336341E+00_JPRB &
  &, 0.323282E+00_JPRB, 0.310442E+00_JPRB, 0.297841E+00_JPRB, 0.285493E+00_JPRB &
  &, 0.273416E+00_JPRB, 0.261588E+00_JPRB, 0.250058E+00_JPRB &
  &, 0.238801E+00_JPRB, 0.227828E+00_JPRB, 0.217146E+00_JPRB, 0.206781E+00_JPRB &
  &, 0.196720E+00_JPRB, 0.186945E+00_JPRB, 0.177497E+00_JPRB &
  &, 0.168356E+00_JPRB, 0.159520E+00_JPRB, 0.151006E+00_JPRB, 0.142806E+00_JPRB &
  &, 0.134914E+00_JPRB, 0.127319E+00_JPRB, 0.120030E+00_JPRB &
  &, 0.113033E+00_JPRB, 0.106335E+00_JPRB, 0.999418E-01_JPRB, 0.938333E-01_JPRB &
  &, 0.880116E-01_JPRB, 0.824512E-01_JPRB, 0.771779E-01_JPRB &
  &, 0.721345E-01_JPRB, 0.673717E-01_JPRB, 0.628565E-01_JPRB, 0.585814E-01_JPRB &
  &, 0.545374E-01_JPRB, 0.507137E-01_JPRB, 0.470980E-01_JPRB &
  &, 0.437076E-01_JPRB, 0.405284E-01_JPRB, 0.375111E-01_JPRB, 0.347027E-01_JPRB &
  &, 0.320509E-01_JPRB, 0.296025E-01_JPRB, 0.272665E-01_JPRB &
  &, 0.251238E-01_JPRB, 0.231149E-01_JPRB, 0.212495E-01_JPRB, 0.195000E-01_JPRB &
  &, 0.178747E-01_JPRB, 0.163823E-01_JPRB, 0.149523E-01_JPRB &
  &, 0.136700E-01_JPRB, 0.125037E-01_JPRB, 0.113777E-01_JPRB, 0.103795E-01_JPRB &
  &, 0.943105E-02_JPRB, 0.857939E-02_JPRB, 0.778602E-02_JPRB &
  &, 0.705465E-02_JPRB, 0.638907E-02_JPRB, 0.579314E-02_JPRB, 0.522383E-02_JPRB &
  &, 0.473069E-02_JPRB, 0.426937E-02_JPRB, 0.384184E-02_JPRB &
  &, 0.345008E-02_JPRB, 0.309614E-02_JPRB, 0.278206E-02_JPRB, 0.250996E-02_JPRB &
  &, 0.222913E-02_JPRB, 0.199307E-02_JPRB, 0.180396E-02_JPRB &
  &, 0.160889E-02_JPRB, 0.140780E-02_JPRB, 0.125731E-02_JPRB, 0.110223E-02_JPRB &
  &, 0.100078E-02_JPRB, 0.896246E-03_JPRB, 0.788580E-03_JPRB &
  &, 0.677748E-03_JPRB, 0.625239E-03_JPRB, 0.508795E-03_JPRB, 0.452266E-03_JPRB &
  &, 0.394110E-03_JPRB, 0.334309E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 458, :) = (/ &
  &  0.986045E+00_JPRB, 0.981543E+00_JPRB, 0.976640E+00_JPRB, 0.971341E+00_JPRB &
  &, 0.965648E+00_JPRB, 0.959566E+00_JPRB, 0.953097E+00_JPRB &
  &, 0.946246E+00_JPRB, 0.939016E+00_JPRB, 0.931414E+00_JPRB, 0.923442E+00_JPRB &
  &, 0.915105E+00_JPRB, 0.906411E+00_JPRB, 0.897362E+00_JPRB &
  &, 0.887968E+00_JPRB, 0.878233E+00_JPRB, 0.868165E+00_JPRB, 0.857771E+00_JPRB &
  &, 0.847058E+00_JPRB, 0.836037E+00_JPRB, 0.824711E+00_JPRB &
  &, 0.813094E+00_JPRB, 0.801194E+00_JPRB, 0.789023E+00_JPRB, 0.776589E+00_JPRB &
  &, 0.763905E+00_JPRB, 0.750979E+00_JPRB, 0.737827E+00_JPRB &
  &, 0.724462E+00_JPRB, 0.710897E+00_JPRB, 0.697140E+00_JPRB, 0.683211E+00_JPRB &
  &, 0.669126E+00_JPRB, 0.654890E+00_JPRB, 0.640530E+00_JPRB &
  &, 0.626052E+00_JPRB, 0.611486E+00_JPRB, 0.596828E+00_JPRB, 0.582110E+00_JPRB &
  &, 0.567349E+00_JPRB, 0.552554E+00_JPRB, 0.537746E+00_JPRB &
  &, 0.522938E+00_JPRB, 0.508146E+00_JPRB, 0.493396E+00_JPRB, 0.478695E+00_JPRB &
  &, 0.464061E+00_JPRB, 0.449526E+00_JPRB, 0.435086E+00_JPRB &
  &, 0.420761E+00_JPRB, 0.406571E+00_JPRB, 0.392525E+00_JPRB, 0.378656E+00_JPRB &
  &, 0.364959E+00_JPRB, 0.351438E+00_JPRB, 0.338143E+00_JPRB &
  &, 0.325048E+00_JPRB, 0.312187E+00_JPRB, 0.299561E+00_JPRB, 0.287186E+00_JPRB &
  &, 0.275079E+00_JPRB, 0.263220E+00_JPRB, 0.251655E+00_JPRB &
  &, 0.240362E+00_JPRB, 0.229368E+00_JPRB, 0.218663E+00_JPRB, 0.208254E+00_JPRB &
  &, 0.198145E+00_JPRB, 0.188340E+00_JPRB, 0.178860E+00_JPRB &
  &, 0.169685E+00_JPRB, 0.160812E+00_JPRB, 0.152259E+00_JPRB, 0.143996E+00_JPRB &
  &, 0.136059E+00_JPRB, 0.128440E+00_JPRB, 0.121103E+00_JPRB &
  &, 0.114079E+00_JPRB, 0.107352E+00_JPRB, 0.100903E+00_JPRB, 0.947619E-01_JPRB &
  &, 0.889058E-01_JPRB, 0.833092E-01_JPRB, 0.779703E-01_JPRB &
  &, 0.729142E-01_JPRB, 0.681095E-01_JPRB, 0.635503E-01_JPRB, 0.592587E-01_JPRB &
  &, 0.551672E-01_JPRB, 0.513246E-01_JPRB, 0.476889E-01_JPRB &
  &, 0.442459E-01_JPRB, 0.410441E-01_JPRB, 0.380032E-01_JPRB, 0.351702E-01_JPRB &
  &, 0.324926E-01_JPRB, 0.299828E-01_JPRB, 0.276534E-01_JPRB &
  &, 0.254816E-01_JPRB, 0.234424E-01_JPRB, 0.215455E-01_JPRB, 0.198010E-01_JPRB &
  &, 0.181425E-01_JPRB, 0.166156E-01_JPRB, 0.152290E-01_JPRB &
  &, 0.139111E-01_JPRB, 0.127079E-01_JPRB, 0.115851E-01_JPRB, 0.105481E-01_JPRB &
  &, 0.960234E-02_JPRB, 0.870989E-02_JPRB, 0.791857E-02_JPRB &
  &, 0.718926E-02_JPRB, 0.652576E-02_JPRB, 0.588567E-02_JPRB, 0.531777E-02_JPRB &
  &, 0.482605E-02_JPRB, 0.431777E-02_JPRB, 0.389097E-02_JPRB &
  &, 0.349994E-02_JPRB, 0.314673E-02_JPRB, 0.283340E-02_JPRB, 0.256204E-02_JPRB &
  &, 0.228197E-02_JPRB, 0.204667E-02_JPRB, 0.180396E-02_JPRB &
  &, 0.160889E-02_JPRB, 0.146372E-02_JPRB, 0.131401E-02_JPRB, 0.115971E-02_JPRB &
  &, 0.100078E-02_JPRB, 0.896246E-03_JPRB, 0.788580E-03_JPRB &
  &, 0.677748E-03_JPRB, 0.625239E-03_JPRB, 0.571145E-03_JPRB, 0.452266E-03_JPRB &
  &, 0.394110E-03_JPRB, 0.334309E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 459, :) = (/ &
  &  0.986296E+00_JPRB, 0.981853E+00_JPRB, 0.977011E+00_JPRB, 0.971775E+00_JPRB &
  &, 0.966142E+00_JPRB, 0.960120E+00_JPRB, 0.953710E+00_JPRB &
  &, 0.946917E+00_JPRB, 0.939744E+00_JPRB, 0.932198E+00_JPRB, 0.924282E+00_JPRB &
  &, 0.916001E+00_JPRB, 0.907359E+00_JPRB, 0.898365E+00_JPRB &
  &, 0.889023E+00_JPRB, 0.879340E+00_JPRB, 0.869322E+00_JPRB, 0.858975E+00_JPRB &
  &, 0.848311E+00_JPRB, 0.837335E+00_JPRB, 0.826053E+00_JPRB &
  &, 0.814480E+00_JPRB, 0.802625E+00_JPRB, 0.790494E+00_JPRB, 0.778099E+00_JPRB &
  &, 0.765451E+00_JPRB, 0.752562E+00_JPRB, 0.739445E+00_JPRB &
  &, 0.726112E+00_JPRB, 0.712576E+00_JPRB, 0.698852E+00_JPRB, 0.684950E+00_JPRB &
  &, 0.670886E+00_JPRB, 0.656678E+00_JPRB, 0.642340E+00_JPRB &
  &, 0.627885E+00_JPRB, 0.613327E+00_JPRB, 0.598696E+00_JPRB, 0.583995E+00_JPRB &
  &, 0.569240E+00_JPRB, 0.554451E+00_JPRB, 0.539647E+00_JPRB &
  &, 0.524843E+00_JPRB, 0.510064E+00_JPRB, 0.495304E+00_JPRB, 0.480615E+00_JPRB &
  &, 0.465979E+00_JPRB, 0.451429E+00_JPRB, 0.436984E+00_JPRB &
  &, 0.422653E+00_JPRB, 0.408455E+00_JPRB, 0.394399E+00_JPRB, 0.380505E+00_JPRB &
  &, 0.366794E+00_JPRB, 0.353258E+00_JPRB, 0.339930E+00_JPRB &
  &, 0.326815E+00_JPRB, 0.313931E+00_JPRB, 0.301280E+00_JPRB, 0.288863E+00_JPRB &
  &, 0.276743E+00_JPRB, 0.264869E+00_JPRB, 0.253271E+00_JPRB &
  &, 0.241941E+00_JPRB, 0.230907E+00_JPRB, 0.220161E+00_JPRB, 0.209726E+00_JPRB &
  &, 0.199590E+00_JPRB, 0.189755E+00_JPRB, 0.180223E+00_JPRB &
  &, 0.170992E+00_JPRB, 0.162104E+00_JPRB, 0.153490E+00_JPRB, 0.145207E+00_JPRB &
  &, 0.137227E+00_JPRB, 0.129562E+00_JPRB, 0.122199E+00_JPRB &
  &, 0.115124E+00_JPRB, 0.108369E+00_JPRB, 0.101890E+00_JPRB, 0.956906E-01_JPRB &
  &, 0.898001E-01_JPRB, 0.841671E-01_JPRB, 0.787901E-01_JPRB &
  &, 0.736939E-01_JPRB, 0.688756E-01_JPRB, 0.642730E-01_JPRB, 0.599360E-01_JPRB &
  &, 0.558271E-01_JPRB, 0.519355E-01_JPRB, 0.482798E-01_JPRB &
  &, 0.448159E-01_JPRB, 0.415599E-01_JPRB, 0.384954E-01_JPRB, 0.356377E-01_JPRB &
  &, 0.329343E-01_JPRB, 0.303976E-01_JPRB, 0.280403E-01_JPRB &
  &, 0.258393E-01_JPRB, 0.238062E-01_JPRB, 0.218785E-01_JPRB, 0.201020E-01_JPRB &
  &, 0.184103E-01_JPRB, 0.168878E-01_JPRB, 0.154661E-01_JPRB &
  &, 0.141521E-01_JPRB, 0.129120E-01_JPRB, 0.117925E-01_JPRB, 0.107167E-01_JPRB &
  &, 0.977363E-02_JPRB, 0.888389E-02_JPRB, 0.809529E-02_JPRB &
  &, 0.732387E-02_JPRB, 0.661689E-02_JPRB, 0.602447E-02_JPRB, 0.545869E-02_JPRB &
  &, 0.492142E-02_JPRB, 0.441458E-02_JPRB, 0.398922E-02_JPRB &
  &, 0.359965E-02_JPRB, 0.324791E-02_JPRB, 0.288473E-02_JPRB, 0.261413E-02_JPRB &
  &, 0.233481E-02_JPRB, 0.210026E-02_JPRB, 0.185832E-02_JPRB &
  &, 0.166403E-02_JPRB, 0.146372E-02_JPRB, 0.131401E-02_JPRB, 0.115971E-02_JPRB &
  &, 0.105907E-02_JPRB, 0.896246E-03_JPRB, 0.788580E-03_JPRB &
  &, 0.738452E-03_JPRB, 0.625239E-03_JPRB, 0.571145E-03_JPRB, 0.515447E-03_JPRB &
  &, 0.458128E-03_JPRB, 0.399171E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 460, :) = (/ &
  &  0.986545E+00_JPRB, 0.982165E+00_JPRB, 0.977385E+00_JPRB, 0.972208E+00_JPRB &
  &, 0.966636E+00_JPRB, 0.960673E+00_JPRB, 0.954322E+00_JPRB &
  &, 0.947587E+00_JPRB, 0.940472E+00_JPRB, 0.932983E+00_JPRB, 0.925123E+00_JPRB &
  &, 0.916897E+00_JPRB, 0.908309E+00_JPRB, 0.899367E+00_JPRB &
  &, 0.890078E+00_JPRB, 0.880446E+00_JPRB, 0.870478E+00_JPRB, 0.860181E+00_JPRB &
  &, 0.849564E+00_JPRB, 0.838632E+00_JPRB, 0.827399E+00_JPRB &
  &, 0.815869E+00_JPRB, 0.804057E+00_JPRB, 0.791966E+00_JPRB, 0.779609E+00_JPRB &
  &, 0.767000E+00_JPRB, 0.754149E+00_JPRB, 0.741067E+00_JPRB &
  &, 0.727766E+00_JPRB, 0.714259E+00_JPRB, 0.700565E+00_JPRB, 0.686692E+00_JPRB &
  &, 0.672656E+00_JPRB, 0.658469E+00_JPRB, 0.644154E+00_JPRB &
  &, 0.629717E+00_JPRB, 0.615177E+00_JPRB, 0.600563E+00_JPRB, 0.585870E+00_JPRB &
  &, 0.571132E+00_JPRB, 0.556347E+00_JPRB, 0.541560E+00_JPRB &
  &, 0.526759E+00_JPRB, 0.511983E+00_JPRB, 0.497224E+00_JPRB, 0.482534E+00_JPRB &
  &, 0.467898E+00_JPRB, 0.453345E+00_JPRB, 0.438883E+00_JPRB &
  &, 0.424545E+00_JPRB, 0.410339E+00_JPRB, 0.396274E+00_JPRB, 0.382368E+00_JPRB &
  &, 0.368630E+00_JPRB, 0.355078E+00_JPRB, 0.341732E+00_JPRB &
  &, 0.328597E+00_JPRB, 0.315691E+00_JPRB, 0.303016E+00_JPRB, 0.290589E+00_JPRB &
  &, 0.278423E+00_JPRB, 0.266518E+00_JPRB, 0.254886E+00_JPRB &
  &, 0.243520E+00_JPRB, 0.232447E+00_JPRB, 0.221677E+00_JPRB, 0.211198E+00_JPRB &
  &, 0.201034E+00_JPRB, 0.191150E+00_JPRB, 0.181586E+00_JPRB &
  &, 0.172342E+00_JPRB, 0.163396E+00_JPRB, 0.154743E+00_JPRB, 0.146419E+00_JPRB &
  &, 0.138418E+00_JPRB, 0.130707E+00_JPRB, 0.123296E+00_JPRB &
  &, 0.116195E+00_JPRB, 0.109386E+00_JPRB, 0.102876E+00_JPRB, 0.966451E-01_JPRB &
  &, 0.906943E-01_JPRB, 0.850250E-01_JPRB, 0.796372E-01_JPRB &
  &, 0.745015E-01_JPRB, 0.696133E-01_JPRB, 0.649957E-01_JPRB, 0.606133E-01_JPRB &
  &, 0.564869E-01_JPRB, 0.525464E-01_JPRB, 0.488708E-01_JPRB &
  &, 0.453542E-01_JPRB, 0.420756E-01_JPRB, 0.389875E-01_JPRB, 0.361051E-01_JPRB &
  &, 0.333760E-01_JPRB, 0.308470E-01_JPRB, 0.284623E-01_JPRB &
  &, 0.262329E-01_JPRB, 0.241337E-01_JPRB, 0.222115E-01_JPRB, 0.204030E-01_JPRB &
  &, 0.187163E-01_JPRB, 0.171601E-01_JPRB, 0.157033E-01_JPRB &
  &, 0.143530E-01_JPRB, 0.131162E-01_JPRB, 0.120000E-01_JPRB, 0.109275E-01_JPRB &
  &, 0.994492E-02_JPRB, 0.905789E-02_JPRB, 0.822784E-02_JPRB &
  &, 0.745848E-02_JPRB, 0.675359E-02_JPRB, 0.611700E-02_JPRB, 0.555263E-02_JPRB &
  &, 0.501679E-02_JPRB, 0.451138E-02_JPRB, 0.408747E-02_JPRB &
  &, 0.364951E-02_JPRB, 0.329851E-02_JPRB, 0.298740E-02_JPRB, 0.266621E-02_JPRB &
  &, 0.238764E-02_JPRB, 0.215386E-02_JPRB, 0.191268E-02_JPRB &
  &, 0.171916E-02_JPRB, 0.151963E-02_JPRB, 0.137070E-02_JPRB, 0.121720E-02_JPRB &
  &, 0.105907E-02_JPRB, 0.955330E-03_JPRB, 0.848470E-03_JPRB &
  &, 0.738452E-03_JPRB, 0.625239E-03_JPRB, 0.571145E-03_JPRB, 0.515447E-03_JPRB &
  &, 0.458128E-03_JPRB, 0.399171E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 461, :) = (/ &
  &  0.986793E+00_JPRB, 0.982478E+00_JPRB, 0.977757E+00_JPRB, 0.972642E+00_JPRB &
  &, 0.967130E+00_JPRB, 0.961226E+00_JPRB, 0.954934E+00_JPRB &
  &, 0.948258E+00_JPRB, 0.941201E+00_JPRB, 0.933768E+00_JPRB, 0.925964E+00_JPRB &
  &, 0.917793E+00_JPRB, 0.909259E+00_JPRB, 0.900371E+00_JPRB &
  &, 0.891134E+00_JPRB, 0.881553E+00_JPRB, 0.871634E+00_JPRB, 0.861387E+00_JPRB &
  &, 0.850817E+00_JPRB, 0.839933E+00_JPRB, 0.828745E+00_JPRB &
  &, 0.817258E+00_JPRB, 0.805488E+00_JPRB, 0.793437E+00_JPRB, 0.781122E+00_JPRB &
  &, 0.768550E+00_JPRB, 0.755677E+00_JPRB, 0.742689E+00_JPRB &
  &, 0.729420E+00_JPRB, 0.715946E+00_JPRB, 0.702282E+00_JPRB, 0.688435E+00_JPRB &
  &, 0.674425E+00_JPRB, 0.660261E+00_JPRB, 0.645969E+00_JPRB &
  &, 0.631549E+00_JPRB, 0.617037E+00_JPRB, 0.602431E+00_JPRB, 0.587754E+00_JPRB &
  &, 0.573023E+00_JPRB, 0.558255E+00_JPRB, 0.543472E+00_JPRB &
  &, 0.528675E+00_JPRB, 0.513901E+00_JPRB, 0.499155E+00_JPRB, 0.484454E+00_JPRB &
  &, 0.469816E+00_JPRB, 0.455260E+00_JPRB, 0.440794E+00_JPRB &
  &, 0.426450E+00_JPRB, 0.412224E+00_JPRB, 0.398148E+00_JPRB, 0.384231E+00_JPRB &
  &, 0.370479E+00_JPRB, 0.356912E+00_JPRB, 0.343549E+00_JPRB &
  &, 0.330395E+00_JPRB, 0.317452E+00_JPRB, 0.304752E+00_JPRB, 0.292298E+00_JPRB &
  &, 0.280104E+00_JPRB, 0.268167E+00_JPRB, 0.256501E+00_JPRB &
  &, 0.245116E+00_JPRB, 0.234005E+00_JPRB, 0.223213E+00_JPRB, 0.212690E+00_JPRB &
  &, 0.202479E+00_JPRB, 0.192565E+00_JPRB, 0.182969E+00_JPRB &
  &, 0.173671E+00_JPRB, 0.164688E+00_JPRB, 0.156018E+00_JPRB, 0.147653E+00_JPRB &
  &, 0.139586E+00_JPRB, 0.131852E+00_JPRB, 0.124393E+00_JPRB &
  &, 0.117265E+00_JPRB, 0.110403E+00_JPRB, 0.103863E+00_JPRB, 0.975996E-01_JPRB &
  &, 0.916148E-01_JPRB, 0.859097E-01_JPRB, 0.804570E-01_JPRB &
  &, 0.753091E-01_JPRB, 0.703795E-01_JPRB, 0.657184E-01_JPRB, 0.613200E-01_JPRB &
  &, 0.571468E-01_JPRB, 0.531878E-01_JPRB, 0.494617E-01_JPRB &
  &, 0.459242E-01_JPRB, 0.426236E-01_JPRB, 0.395125E-01_JPRB, 0.365726E-01_JPRB &
  &, 0.338177E-01_JPRB, 0.312619E-01_JPRB, 0.288492E-01_JPRB &
  &, 0.265906E-01_JPRB, 0.244975E-01_JPRB, 0.225446E-01_JPRB, 0.207040E-01_JPRB &
  &, 0.189841E-01_JPRB, 0.174323E-01_JPRB, 0.159405E-01_JPRB &
  &, 0.145941E-01_JPRB, 0.133611E-01_JPRB, 0.121659E-01_JPRB, 0.110961E-01_JPRB &
  &, 0.101162E-01_JPRB, 0.918839E-02_JPRB, 0.836038E-02_JPRB &
  &, 0.759309E-02_JPRB, 0.689028E-02_JPRB, 0.625579E-02_JPRB, 0.564657E-02_JPRB &
  &, 0.511216E-02_JPRB, 0.460818E-02_JPRB, 0.413660E-02_JPRB &
  &, 0.374922E-02_JPRB, 0.334910E-02_JPRB, 0.303874E-02_JPRB, 0.271829E-02_JPRB &
  &, 0.244048E-02_JPRB, 0.220746E-02_JPRB, 0.196705E-02_JPRB &
  &, 0.171916E-02_JPRB, 0.157554E-02_JPRB, 0.137070E-02_JPRB, 0.121720E-02_JPRB &
  &, 0.111735E-02_JPRB, 0.955330E-03_JPRB, 0.848470E-03_JPRB &
  &, 0.738452E-03_JPRB, 0.686763E-03_JPRB, 0.571145E-03_JPRB, 0.515447E-03_JPRB &
  &, 0.458128E-03_JPRB, 0.399171E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 462, :) = (/ &
  &  0.987045E+00_JPRB, 0.982789E+00_JPRB, 0.978130E+00_JPRB, 0.973075E+00_JPRB &
  &, 0.967623E+00_JPRB, 0.961779E+00_JPRB, 0.955547E+00_JPRB &
  &, 0.948929E+00_JPRB, 0.941929E+00_JPRB, 0.934554E+00_JPRB, 0.926805E+00_JPRB &
  &, 0.918689E+00_JPRB, 0.910211E+00_JPRB, 0.901376E+00_JPRB &
  &, 0.892191E+00_JPRB, 0.882661E+00_JPRB, 0.872792E+00_JPRB, 0.862594E+00_JPRB &
  &, 0.852072E+00_JPRB, 0.841233E+00_JPRB, 0.830090E+00_JPRB &
  &, 0.818651E+00_JPRB, 0.806919E+00_JPRB, 0.794912E+00_JPRB, 0.782636E+00_JPRB &
  &, 0.770103E+00_JPRB, 0.757323E+00_JPRB, 0.744311E+00_JPRB &
  &, 0.731078E+00_JPRB, 0.717633E+00_JPRB, 0.703998E+00_JPRB, 0.690178E+00_JPRB &
  &, 0.676194E+00_JPRB, 0.662058E+00_JPRB, 0.647788E+00_JPRB &
  &, 0.633391E+00_JPRB, 0.618887E+00_JPRB, 0.604299E+00_JPRB, 0.589639E+00_JPRB &
  &, 0.574924E+00_JPRB, 0.560173E+00_JPRB, 0.545384E+00_JPRB &
  &, 0.530602E+00_JPRB, 0.515831E+00_JPRB, 0.501087E+00_JPRB, 0.486386E+00_JPRB &
  &, 0.471747E+00_JPRB, 0.457176E+00_JPRB, 0.442718E+00_JPRB &
  &, 0.428355E+00_JPRB, 0.414121E+00_JPRB, 0.400037E+00_JPRB, 0.386095E+00_JPRB &
  &, 0.372329E+00_JPRB, 0.358746E+00_JPRB, 0.345366E+00_JPRB &
  &, 0.332177E+00_JPRB, 0.319228E+00_JPRB, 0.306505E+00_JPRB, 0.294024E+00_JPRB &
  &, 0.281802E+00_JPRB, 0.269834E+00_JPRB, 0.258134E+00_JPRB &
  &, 0.246713E+00_JPRB, 0.235582E+00_JPRB, 0.224729E+00_JPRB, 0.214181E+00_JPRB &
  &, 0.203944E+00_JPRB, 0.194001E+00_JPRB, 0.184353E+00_JPRB &
  &, 0.175020E+00_JPRB, 0.166001E+00_JPRB, 0.157293E+00_JPRB, 0.148887E+00_JPRB &
  &, 0.140777E+00_JPRB, 0.132997E+00_JPRB, 0.125513E+00_JPRB &
  &, 0.118335E+00_JPRB, 0.111445E+00_JPRB, 0.104850E+00_JPRB, 0.985541E-01_JPRB &
  &, 0.925353E-01_JPRB, 0.867945E-01_JPRB, 0.813041E-01_JPRB &
  &, 0.761166E-01_JPRB, 0.711456E-01_JPRB, 0.664701E-01_JPRB, 0.620268E-01_JPRB &
  &, 0.578066E-01_JPRB, 0.538292E-01_JPRB, 0.500526E-01_JPRB &
  &, 0.464942E-01_JPRB, 0.431716E-01_JPRB, 0.400046E-01_JPRB, 0.370735E-01_JPRB &
  &, 0.342934E-01_JPRB, 0.316767E-01_JPRB, 0.292360E-01_JPRB &
  &, 0.269841E-01_JPRB, 0.248614E-01_JPRB, 0.228776E-01_JPRB, 0.210050E-01_JPRB &
  &, 0.192901E-01_JPRB, 0.177045E-01_JPRB, 0.162172E-01_JPRB &
  &, 0.148351E-01_JPRB, 0.135653E-01_JPRB, 0.123734E-01_JPRB, 0.113068E-01_JPRB &
  &, 0.102875E-01_JPRB, 0.936238E-02_JPRB, 0.853711E-02_JPRB &
  &, 0.772770E-02_JPRB, 0.702697E-02_JPRB, 0.634832E-02_JPRB, 0.574052E-02_JPRB &
  &, 0.520752E-02_JPRB, 0.470499E-02_JPRB, 0.423485E-02_JPRB &
  &, 0.379908E-02_JPRB, 0.345028E-02_JPRB, 0.309007E-02_JPRB, 0.277037E-02_JPRB &
  &, 0.249332E-02_JPRB, 0.220746E-02_JPRB, 0.202141E-02_JPRB &
  &, 0.177430E-02_JPRB, 0.157554E-02_JPRB, 0.142740E-02_JPRB, 0.127469E-02_JPRB &
  &, 0.111735E-02_JPRB, 0.101441E-02_JPRB, 0.908361E-03_JPRB &
  &, 0.799156E-03_JPRB, 0.686763E-03_JPRB, 0.633494E-03_JPRB, 0.515447E-03_JPRB &
  &, 0.458128E-03_JPRB, 0.399171E-03_JPRB, 0.338556E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART66',1,ZHOOK_HANDLE)
END SUBROUTINE PART66

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART67

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART67',0,ZHOOK_HANDLE)

XCW( 463, :) = (/ &
  &  0.987294E+00_JPRB, 0.983101E+00_JPRB, 0.978503E+00_JPRB, 0.973509E+00_JPRB &
  &, 0.968117E+00_JPRB, 0.962333E+00_JPRB, 0.956159E+00_JPRB &
  &, 0.949599E+00_JPRB, 0.942658E+00_JPRB, 0.935338E+00_JPRB, 0.927646E+00_JPRB &
  &, 0.919585E+00_JPRB, 0.911162E+00_JPRB, 0.902381E+00_JPRB &
  &, 0.893247E+00_JPRB, 0.883768E+00_JPRB, 0.873951E+00_JPRB, 0.863802E+00_JPRB &
  &, 0.853328E+00_JPRB, 0.842537E+00_JPRB, 0.831439E+00_JPRB &
  &, 0.820040E+00_JPRB, 0.808354E+00_JPRB, 0.796387E+00_JPRB, 0.784153E+00_JPRB &
  &, 0.771656E+00_JPRB, 0.758914E+00_JPRB, 0.745936E+00_JPRB &
  &, 0.732736E+00_JPRB, 0.719324E+00_JPRB, 0.705719E+00_JPRB, 0.691929E+00_JPRB &
  &, 0.677972E+00_JPRB, 0.663858E+00_JPRB, 0.649607E+00_JPRB &
  &, 0.635233E+00_JPRB, 0.620756E+00_JPRB, 0.606176E+00_JPRB, 0.591534E+00_JPRB &
  &, 0.576826E+00_JPRB, 0.562080E+00_JPRB, 0.547307E+00_JPRB &
  &, 0.532529E+00_JPRB, 0.517761E+00_JPRB, 0.503018E+00_JPRB, 0.488318E+00_JPRB &
  &, 0.473677E+00_JPRB, 0.459104E+00_JPRB, 0.444642E+00_JPRB &
  &, 0.430274E+00_JPRB, 0.416032E+00_JPRB, 0.401925E+00_JPRB, 0.387972E+00_JPRB &
  &, 0.374193E+00_JPRB, 0.360596E+00_JPRB, 0.347183E+00_JPRB &
  &, 0.333990E+00_JPRB, 0.321004E+00_JPRB, 0.308257E+00_JPRB, 0.295750E+00_JPRB &
  &, 0.283499E+00_JPRB, 0.271501E+00_JPRB, 0.259767E+00_JPRB &
  &, 0.248328E+00_JPRB, 0.237158E+00_JPRB, 0.226284E+00_JPRB, 0.215692E+00_JPRB &
  &, 0.205408E+00_JPRB, 0.195416E+00_JPRB, 0.185757E+00_JPRB &
  &, 0.176370E+00_JPRB, 0.167315E+00_JPRB, 0.158568E+00_JPRB, 0.150121E+00_JPRB &
  &, 0.141991E+00_JPRB, 0.134166E+00_JPRB, 0.126634E+00_JPRB &
  &, 0.119405E+00_JPRB, 0.112487E+00_JPRB, 0.105862E+00_JPRB, 0.995086E-01_JPRB &
  &, 0.934558E-01_JPRB, 0.876792E-01_JPRB, 0.821512E-01_JPRB &
  &, 0.769242E-01_JPRB, 0.719401E-01_JPRB, 0.671928E-01_JPRB, 0.627335E-01_JPRB &
  &, 0.584665E-01_JPRB, 0.544401E-01_JPRB, 0.506747E-01_JPRB &
  &, 0.470641E-01_JPRB, 0.437195E-01_JPRB, 0.405296E-01_JPRB, 0.375409E-01_JPRB &
  &, 0.347351E-01_JPRB, 0.321262E-01_JPRB, 0.296581E-01_JPRB &
  &, 0.273419E-01_JPRB, 0.251889E-01_JPRB, 0.232106E-01_JPRB, 0.213436E-01_JPRB &
  &, 0.195962E-01_JPRB, 0.179767E-01_JPRB, 0.164544E-01_JPRB &
  &, 0.150762E-01_JPRB, 0.138103E-01_JPRB, 0.125808E-01_JPRB, 0.114755E-01_JPRB &
  &, 0.104588E-01_JPRB, 0.953638E-02_JPRB, 0.866966E-02_JPRB &
  &, 0.786232E-02_JPRB, 0.716367E-02_JPRB, 0.648712E-02_JPRB, 0.588143E-02_JPRB &
  &, 0.530289E-02_JPRB, 0.480179E-02_JPRB, 0.433310E-02_JPRB &
  &, 0.389879E-02_JPRB, 0.350088E-02_JPRB, 0.314140E-02_JPRB, 0.282246E-02_JPRB &
  &, 0.254615E-02_JPRB, 0.226105E-02_JPRB, 0.202141E-02_JPRB &
  &, 0.182943E-02_JPRB, 0.163145E-02_JPRB, 0.142740E-02_JPRB, 0.127469E-02_JPRB &
  &, 0.117563E-02_JPRB, 0.101441E-02_JPRB, 0.908361E-03_JPRB &
  &, 0.799156E-03_JPRB, 0.686763E-03_JPRB, 0.633494E-03_JPRB, 0.578628E-03_JPRB &
  &, 0.458128E-03_JPRB, 0.399171E-03_JPRB, 0.338556E-03_JPRB/)
XCW( 464, :) = (/ &
  &  0.987544E+00_JPRB, 0.983412E+00_JPRB, 0.978876E+00_JPRB, 0.973943E+00_JPRB &
  &, 0.968611E+00_JPRB, 0.962887E+00_JPRB, 0.956772E+00_JPRB &
  &, 0.950270E+00_JPRB, 0.943386E+00_JPRB, 0.936125E+00_JPRB, 0.928488E+00_JPRB &
  &, 0.920482E+00_JPRB, 0.912113E+00_JPRB, 0.903386E+00_JPRB &
  &, 0.894305E+00_JPRB, 0.884878E+00_JPRB, 0.875111E+00_JPRB, 0.865011E+00_JPRB &
  &, 0.854584E+00_JPRB, 0.843841E+00_JPRB, 0.832788E+00_JPRB &
  &, 0.821436E+00_JPRB, 0.809792E+00_JPRB, 0.797866E+00_JPRB, 0.785669E+00_JPRB &
  &, 0.773213E+00_JPRB, 0.760505E+00_JPRB, 0.747562E+00_JPRB &
  &, 0.734398E+00_JPRB, 0.721019E+00_JPRB, 0.707440E+00_JPRB, 0.693680E+00_JPRB &
  &, 0.679746E+00_JPRB, 0.665659E+00_JPRB, 0.651435E+00_JPRB &
  &, 0.637074E+00_JPRB, 0.622616E+00_JPRB, 0.608063E+00_JPRB, 0.593429E+00_JPRB &
  &, 0.578738E+00_JPRB, 0.563998E+00_JPRB, 0.549241E+00_JPRB &
  &, 0.534467E+00_JPRB, 0.519702E+00_JPRB, 0.504961E+00_JPRB, 0.490261E+00_JPRB &
  &, 0.475608E+00_JPRB, 0.461044E+00_JPRB, 0.446566E+00_JPRB &
  &, 0.432192E+00_JPRB, 0.417930E+00_JPRB, 0.403827E+00_JPRB, 0.389849E+00_JPRB &
  &, 0.376057E+00_JPRB, 0.362445E+00_JPRB, 0.349016E+00_JPRB &
  &, 0.335788E+00_JPRB, 0.322796E+00_JPRB, 0.310009E+00_JPRB, 0.297476E+00_JPRB &
  &, 0.285197E+00_JPRB, 0.273167E+00_JPRB, 0.261418E+00_JPRB &
  &, 0.249925E+00_JPRB, 0.238735E+00_JPRB, 0.227819E+00_JPRB, 0.217203E+00_JPRB &
  &, 0.206873E+00_JPRB, 0.196872E+00_JPRB, 0.187140E+00_JPRB &
  &, 0.177741E+00_JPRB, 0.168650E+00_JPRB, 0.159842E+00_JPRB, 0.151378E+00_JPRB &
  &, 0.143204E+00_JPRB, 0.135334E+00_JPRB, 0.127755E+00_JPRB &
  &, 0.120500E+00_JPRB, 0.113529E+00_JPRB, 0.106874E+00_JPRB, 0.100489E+00_JPRB &
  &, 0.943763E-01_JPRB, 0.885640E-01_JPRB, 0.830256E-01_JPRB &
  &, 0.777318E-01_JPRB, 0.727062E-01_JPRB, 0.679444E-01_JPRB, 0.634403E-01_JPRB &
  &, 0.591563E-01_JPRB, 0.551121E-01_JPRB, 0.512656E-01_JPRB &
  &, 0.476658E-01_JPRB, 0.442675E-01_JPRB, 0.410545E-01_JPRB, 0.380418E-01_JPRB &
  &, 0.352108E-01_JPRB, 0.325410E-01_JPRB, 0.300801E-01_JPRB &
  &, 0.277354E-01_JPRB, 0.255891E-01_JPRB, 0.235436E-01_JPRB, 0.216446E-01_JPRB &
  &, 0.199022E-01_JPRB, 0.182490E-01_JPRB, 0.167311E-01_JPRB &
  &, 0.153172E-01_JPRB, 0.140144E-01_JPRB, 0.128297E-01_JPRB, 0.116862E-01_JPRB &
  &, 0.106729E-01_JPRB, 0.971038E-02_JPRB, 0.884639E-02_JPRB &
  &, 0.804180E-02_JPRB, 0.730036E-02_JPRB, 0.662591E-02_JPRB, 0.597537E-02_JPRB &
  &, 0.539826E-02_JPRB, 0.489860E-02_JPRB, 0.443135E-02_JPRB &
  &, 0.399850E-02_JPRB, 0.360206E-02_JPRB, 0.324407E-02_JPRB, 0.292662E-02_JPRB &
  &, 0.259899E-02_JPRB, 0.231465E-02_JPRB, 0.207577E-02_JPRB &
  &, 0.188457E-02_JPRB, 0.168736E-02_JPRB, 0.148409E-02_JPRB, 0.133217E-02_JPRB &
  &, 0.117563E-02_JPRB, 0.107350E-02_JPRB, 0.908361E-03_JPRB &
  &, 0.799156E-03_JPRB, 0.748287E-03_JPRB, 0.633494E-03_JPRB, 0.578628E-03_JPRB &
  &, 0.522147E-03_JPRB, 0.464032E-03_JPRB, 0.404267E-03_JPRB/)
XCW( 465, :) = (/ &
  &  0.987795E+00_JPRB, 0.983723E+00_JPRB, 0.979249E+00_JPRB, 0.974376E+00_JPRB &
  &, 0.969105E+00_JPRB, 0.963440E+00_JPRB, 0.957384E+00_JPRB &
  &, 0.950941E+00_JPRB, 0.944115E+00_JPRB, 0.936910E+00_JPRB, 0.929330E+00_JPRB &
  &, 0.921380E+00_JPRB, 0.913065E+00_JPRB, 0.904391E+00_JPRB &
  &, 0.895363E+00_JPRB, 0.885987E+00_JPRB, 0.876271E+00_JPRB, 0.866220E+00_JPRB &
  &, 0.855842E+00_JPRB, 0.845145E+00_JPRB, 0.834137E+00_JPRB &
  &, 0.822829E+00_JPRB, 0.811230E+00_JPRB, 0.799344E+00_JPRB, 0.787186E+00_JPRB &
  &, 0.774770E+00_JPRB, 0.762099E+00_JPRB, 0.749192E+00_JPRB &
  &, 0.736059E+00_JPRB, 0.722714E+00_JPRB, 0.709164E+00_JPRB, 0.695432E+00_JPRB &
  &, 0.681528E+00_JPRB, 0.667464E+00_JPRB, 0.653262E+00_JPRB &
  &, 0.638925E+00_JPRB, 0.624485E+00_JPRB, 0.609941E+00_JPRB, 0.595324E+00_JPRB &
  &, 0.580650E+00_JPRB, 0.565927E+00_JPRB, 0.551174E+00_JPRB &
  &, 0.536405E+00_JPRB, 0.521643E+00_JPRB, 0.506904E+00_JPRB, 0.492205E+00_JPRB &
  &, 0.477563E+00_JPRB, 0.462985E+00_JPRB, 0.448503E+00_JPRB &
  &, 0.434111E+00_JPRB, 0.419855E+00_JPRB, 0.405729E+00_JPRB, 0.391740E+00_JPRB &
  &, 0.377936E+00_JPRB, 0.364294E+00_JPRB, 0.350848E+00_JPRB &
  &, 0.337601E+00_JPRB, 0.324588E+00_JPRB, 0.311778E+00_JPRB, 0.299219E+00_JPRB &
  &, 0.286911E+00_JPRB, 0.274851E+00_JPRB, 0.263069E+00_JPRB &
  &, 0.251559E+00_JPRB, 0.240330E+00_JPRB, 0.229374E+00_JPRB, 0.218714E+00_JPRB &
  &, 0.208357E+00_JPRB, 0.198307E+00_JPRB, 0.188565E+00_JPRB &
  &, 0.179111E+00_JPRB, 0.169985E+00_JPRB, 0.161139E+00_JPRB, 0.152634E+00_JPRB &
  &, 0.144418E+00_JPRB, 0.136502E+00_JPRB, 0.128899E+00_JPRB &
  &, 0.121594E+00_JPRB, 0.114596E+00_JPRB, 0.107886E+00_JPRB, 0.101469E+00_JPRB &
  &, 0.953232E-01_JPRB, 0.894755E-01_JPRB, 0.838727E-01_JPRB &
  &, 0.785672E-01_JPRB, 0.735007E-01_JPRB, 0.686960E-01_JPRB, 0.641470E-01_JPRB &
  &, 0.598461E-01_JPRB, 0.557535E-01_JPRB, 0.518876E-01_JPRB &
  &, 0.482357E-01_JPRB, 0.448155E-01_JPRB, 0.415795E-01_JPRB, 0.385427E-01_JPRB &
  &, 0.356865E-01_JPRB, 0.329904E-01_JPRB, 0.305021E-01_JPRB &
  &, 0.281289E-01_JPRB, 0.259530E-01_JPRB, 0.238766E-01_JPRB, 0.219832E-01_JPRB &
  &, 0.202082E-01_JPRB, 0.185601E-01_JPRB, 0.170078E-01_JPRB &
  &, 0.155583E-01_JPRB, 0.142594E-01_JPRB, 0.130372E-01_JPRB, 0.118970E-01_JPRB &
  &, 0.108442E-01_JPRB, 0.988438E-02_JPRB, 0.897893E-02_JPRB &
  &, 0.817641E-02_JPRB, 0.743706E-02_JPRB, 0.671844E-02_JPRB, 0.611629E-02_JPRB &
  &, 0.554131E-02_JPRB, 0.499540E-02_JPRB, 0.452960E-02_JPRB &
  &, 0.404836E-02_JPRB, 0.365265E-02_JPRB, 0.329541E-02_JPRB, 0.297870E-02_JPRB &
  &, 0.265183E-02_JPRB, 0.236825E-02_JPRB, 0.213013E-02_JPRB &
  &, 0.188457E-02_JPRB, 0.168736E-02_JPRB, 0.154079E-02_JPRB, 0.133217E-02_JPRB &
  &, 0.123391E-02_JPRB, 0.107350E-02_JPRB, 0.968252E-03_JPRB &
  &, 0.859861E-03_JPRB, 0.748287E-03_JPRB, 0.633494E-03_JPRB, 0.578628E-03_JPRB &
  &, 0.522147E-03_JPRB, 0.464032E-03_JPRB, 0.404267E-03_JPRB/)
XCW( 466, :) = (/ &
  &  0.988045E+00_JPRB, 0.984036E+00_JPRB, 0.979622E+00_JPRB, 0.974810E+00_JPRB &
  &, 0.969599E+00_JPRB, 0.963994E+00_JPRB, 0.957998E+00_JPRB &
  &, 0.951612E+00_JPRB, 0.944844E+00_JPRB, 0.937696E+00_JPRB, 0.930173E+00_JPRB &
  &, 0.922279E+00_JPRB, 0.914017E+00_JPRB, 0.905397E+00_JPRB &
  &, 0.896422E+00_JPRB, 0.887098E+00_JPRB, 0.877432E+00_JPRB, 0.867430E+00_JPRB &
  &, 0.857101E+00_JPRB, 0.846452E+00_JPRB, 0.835489E+00_JPRB &
  &, 0.824224E+00_JPRB, 0.812668E+00_JPRB, 0.800826E+00_JPRB, 0.788707E+00_JPRB &
  &, 0.776326E+00_JPRB, 0.763697E+00_JPRB, 0.750825E+00_JPRB &
  &, 0.737725E+00_JPRB, 0.724409E+00_JPRB, 0.710893E+00_JPRB, 0.697191E+00_JPRB &
  &, 0.683310E+00_JPRB, 0.669273E+00_JPRB, 0.655090E+00_JPRB &
  &, 0.640776E+00_JPRB, 0.626354E+00_JPRB, 0.611837E+00_JPRB, 0.597228E+00_JPRB &
  &, 0.582562E+00_JPRB, 0.567855E+00_JPRB, 0.553108E+00_JPRB &
  &, 0.538343E+00_JPRB, 0.523596E+00_JPRB, 0.508859E+00_JPRB, 0.494148E+00_JPRB &
  &, 0.479506E+00_JPRB, 0.464926E+00_JPRB, 0.450440E+00_JPRB &
  &, 0.436042E+00_JPRB, 0.421779E+00_JPRB, 0.407631E+00_JPRB, 0.393646E+00_JPRB &
  &, 0.379815E+00_JPRB, 0.366158E+00_JPRB, 0.352695E+00_JPRB &
  &, 0.339430E+00_JPRB, 0.326380E+00_JPRB, 0.313562E+00_JPRB, 0.300978E+00_JPRB &
  &, 0.288626E+00_JPRB, 0.276552E+00_JPRB, 0.264737E+00_JPRB &
  &, 0.253192E+00_JPRB, 0.241925E+00_JPRB, 0.230947E+00_JPRB, 0.220245E+00_JPRB &
  &, 0.209862E+00_JPRB, 0.199763E+00_JPRB, 0.189970E+00_JPRB &
  &, 0.180503E+00_JPRB, 0.171320E+00_JPRB, 0.162458E+00_JPRB, 0.153891E+00_JPRB &
  &, 0.145632E+00_JPRB, 0.137694E+00_JPRB, 0.130043E+00_JPRB &
  &, 0.122688E+00_JPRB, 0.115662E+00_JPRB, 0.108898E+00_JPRB, 0.102449E+00_JPRB &
  &, 0.962700E-01_JPRB, 0.903871E-01_JPRB, 0.847471E-01_JPRB &
  &, 0.794026E-01_JPRB, 0.742952E-01_JPRB, 0.694765E-01_JPRB, 0.648832E-01_JPRB &
  &, 0.605360E-01_JPRB, 0.564255E-01_JPRB, 0.525097E-01_JPRB &
  &, 0.488374E-01_JPRB, 0.453635E-01_JPRB, 0.421044E-01_JPRB, 0.390435E-01_JPRB &
  &, 0.361622E-01_JPRB, 0.334399E-01_JPRB, 0.309242E-01_JPRB &
  &, 0.285224E-01_JPRB, 0.263168E-01_JPRB, 0.242467E-01_JPRB, 0.223219E-01_JPRB &
  &, 0.205143E-01_JPRB, 0.188323E-01_JPRB, 0.172845E-01_JPRB &
  &, 0.158395E-01_JPRB, 0.145044E-01_JPRB, 0.132446E-01_JPRB, 0.121077E-01_JPRB &
  &, 0.110155E-01_JPRB, 0.100584E-01_JPRB, 0.915566E-02_JPRB &
  &, 0.831102E-02_JPRB, 0.757375E-02_JPRB, 0.685724E-02_JPRB, 0.621023E-02_JPRB &
  &, 0.563668E-02_JPRB, 0.509220E-02_JPRB, 0.457873E-02_JPRB &
  &, 0.414807E-02_JPRB, 0.375384E-02_JPRB, 0.334674E-02_JPRB, 0.303079E-02_JPRB &
  &, 0.270466E-02_JPRB, 0.242184E-02_JPRB, 0.218450E-02_JPRB &
  &, 0.193970E-02_JPRB, 0.174328E-02_JPRB, 0.154079E-02_JPRB, 0.138966E-02_JPRB &
  &, 0.123391E-02_JPRB, 0.107350E-02_JPRB, 0.968252E-03_JPRB &
  &, 0.859861E-03_JPRB, 0.748287E-03_JPRB, 0.695844E-03_JPRB, 0.578628E-03_JPRB &
  &, 0.522147E-03_JPRB, 0.464032E-03_JPRB, 0.404267E-03_JPRB/)
XCW( 467, :) = (/ &
  &  0.988294E+00_JPRB, 0.984347E+00_JPRB, 0.979995E+00_JPRB, 0.975243E+00_JPRB &
  &, 0.970092E+00_JPRB, 0.964548E+00_JPRB, 0.958610E+00_JPRB &
  &, 0.952284E+00_JPRB, 0.945573E+00_JPRB, 0.938483E+00_JPRB, 0.931016E+00_JPRB &
  &, 0.923176E+00_JPRB, 0.914970E+00_JPRB, 0.906405E+00_JPRB &
  &, 0.897482E+00_JPRB, 0.888210E+00_JPRB, 0.878593E+00_JPRB, 0.868642E+00_JPRB &
  &, 0.858360E+00_JPRB, 0.847759E+00_JPRB, 0.836841E+00_JPRB &
  &, 0.825624E+00_JPRB, 0.814106E+00_JPRB, 0.802308E+00_JPRB, 0.790231E+00_JPRB &
  &, 0.777890E+00_JPRB, 0.765295E+00_JPRB, 0.752458E+00_JPRB &
  &, 0.739395E+00_JPRB, 0.726112E+00_JPRB, 0.712622E+00_JPRB, 0.698946E+00_JPRB &
  &, 0.685097E+00_JPRB, 0.671083E+00_JPRB, 0.656928E+00_JPRB &
  &, 0.642637E+00_JPRB, 0.628233E+00_JPRB, 0.613725E+00_JPRB, 0.599133E+00_JPRB &
  &, 0.584484E+00_JPRB, 0.569783E+00_JPRB, 0.555042E+00_JPRB &
  &, 0.540292E+00_JPRB, 0.525537E+00_JPRB, 0.510802E+00_JPRB, 0.496104E+00_JPRB &
  &, 0.481461E+00_JPRB, 0.466879E+00_JPRB, 0.452377E+00_JPRB &
  &, 0.437987E+00_JPRB, 0.423704E+00_JPRB, 0.409547E+00_JPRB, 0.395537E+00_JPRB &
  &, 0.381693E+00_JPRB, 0.368022E+00_JPRB, 0.354542E+00_JPRB &
  &, 0.341258E+00_JPRB, 0.328187E+00_JPRB, 0.315347E+00_JPRB, 0.302721E+00_JPRB &
  &, 0.290357E+00_JPRB, 0.278254E+00_JPRB, 0.266406E+00_JPRB &
  &, 0.254825E+00_JPRB, 0.243521E+00_JPRB, 0.232502E+00_JPRB, 0.221794E+00_JPRB &
  &, 0.211366E+00_JPRB, 0.201239E+00_JPRB, 0.191394E+00_JPRB &
  &, 0.181874E+00_JPRB, 0.172676E+00_JPRB, 0.163755E+00_JPRB, 0.155147E+00_JPRB &
  &, 0.146868E+00_JPRB, 0.138886E+00_JPRB, 0.131188E+00_JPRB &
  &, 0.123807E+00_JPRB, 0.116729E+00_JPRB, 0.109935E+00_JPRB, 0.103430E+00_JPRB &
  &, 0.972168E-01_JPRB, 0.912986E-01_JPRB, 0.856216E-01_JPRB &
  &, 0.802380E-01_JPRB, 0.751180E-01_JPRB, 0.702281E-01_JPRB, 0.656194E-01_JPRB &
  &, 0.612258E-01_JPRB, 0.570669E-01_JPRB, 0.531628E-01_JPRB &
  &, 0.494390E-01_JPRB, 0.459437E-01_JPRB, 0.426622E-01_JPRB, 0.395444E-01_JPRB &
  &, 0.366379E-01_JPRB, 0.338893E-01_JPRB, 0.313462E-01_JPRB &
  &, 0.289517E-01_JPRB, 0.266807E-01_JPRB, 0.246167E-01_JPRB, 0.226605E-01_JPRB &
  &, 0.208203E-01_JPRB, 0.191045E-01_JPRB, 0.175612E-01_JPRB &
  &, 0.160806E-01_JPRB, 0.147085E-01_JPRB, 0.134521E-01_JPRB, 0.123185E-01_JPRB &
  &, 0.112296E-01_JPRB, 0.102324E-01_JPRB, 0.933239E-02_JPRB &
  &, 0.849050E-02_JPRB, 0.771045E-02_JPRB, 0.699603E-02_JPRB, 0.635114E-02_JPRB &
  &, 0.573205E-02_JPRB, 0.518901E-02_JPRB, 0.467698E-02_JPRB &
  &, 0.424779E-02_JPRB, 0.380443E-02_JPRB, 0.344941E-02_JPRB, 0.308287E-02_JPRB &
  &, 0.275750E-02_JPRB, 0.247544E-02_JPRB, 0.223886E-02_JPRB &
  &, 0.199483E-02_JPRB, 0.179919E-02_JPRB, 0.159749E-02_JPRB, 0.144714E-02_JPRB &
  &, 0.129219E-02_JPRB, 0.113258E-02_JPRB, 0.102814E-02_JPRB &
  &, 0.859861E-03_JPRB, 0.809811E-03_JPRB, 0.695844E-03_JPRB, 0.641809E-03_JPRB &
  &, 0.522147E-03_JPRB, 0.464032E-03_JPRB, 0.404267E-03_JPRB/)
XCW( 468, :) = (/ &
  &  0.988545E+00_JPRB, 0.984658E+00_JPRB, 0.980368E+00_JPRB, 0.975677E+00_JPRB &
  &, 0.970587E+00_JPRB, 0.965101E+00_JPRB, 0.959223E+00_JPRB &
  &, 0.952956E+00_JPRB, 0.946304E+00_JPRB, 0.939270E+00_JPRB, 0.931859E+00_JPRB &
  &, 0.924075E+00_JPRB, 0.915924E+00_JPRB, 0.907411E+00_JPRB &
  &, 0.898541E+00_JPRB, 0.889322E+00_JPRB, 0.879755E+00_JPRB, 0.869854E+00_JPRB &
  &, 0.859621E+00_JPRB, 0.849066E+00_JPRB, 0.838196E+00_JPRB &
  &, 0.827019E+00_JPRB, 0.815544E+00_JPRB, 0.803790E+00_JPRB, 0.791755E+00_JPRB &
  &, 0.779451E+00_JPRB, 0.766894E+00_JPRB, 0.754095E+00_JPRB &
  &, 0.741064E+00_JPRB, 0.727814E+00_JPRB, 0.714355E+00_JPRB, 0.700710E+00_JPRB &
  &, 0.686888E+00_JPRB, 0.672897E+00_JPRB, 0.658765E+00_JPRB &
  &, 0.644487E+00_JPRB, 0.630102E+00_JPRB, 0.615622E+00_JPRB, 0.601048E+00_JPRB &
  &, 0.586406E+00_JPRB, 0.571712E+00_JPRB, 0.556987E+00_JPRB &
  &, 0.542241E+00_JPRB, 0.527501E+00_JPRB, 0.512768E+00_JPRB, 0.498071E+00_JPRB &
  &, 0.483416E+00_JPRB, 0.468832E+00_JPRB, 0.454326E+00_JPRB &
  &, 0.439919E+00_JPRB, 0.425629E+00_JPRB, 0.411463E+00_JPRB, 0.397457E+00_JPRB &
  &, 0.383587E+00_JPRB, 0.369901E+00_JPRB, 0.356390E+00_JPRB &
  &, 0.343087E+00_JPRB, 0.329995E+00_JPRB, 0.317132E+00_JPRB, 0.304497E+00_JPRB &
  &, 0.292089E+00_JPRB, 0.279955E+00_JPRB, 0.268074E+00_JPRB &
  &, 0.256458E+00_JPRB, 0.245134E+00_JPRB, 0.234094E+00_JPRB, 0.223325E+00_JPRB &
  &, 0.212870E+00_JPRB, 0.202694E+00_JPRB, 0.192840E+00_JPRB &
  &, 0.183287E+00_JPRB, 0.174033E+00_JPRB, 0.165074E+00_JPRB, 0.156449E+00_JPRB &
  &, 0.148105E+00_JPRB, 0.140078E+00_JPRB, 0.132356E+00_JPRB &
  &, 0.124926E+00_JPRB, 0.117821E+00_JPRB, 0.110972E+00_JPRB, 0.104436E+00_JPRB &
  &, 0.981899E-01_JPRB, 0.922101E-01_JPRB, 0.865233E-01_JPRB &
  &, 0.811013E-01_JPRB, 0.759125E-01_JPRB, 0.710086E-01_JPRB, 0.663556E-01_JPRB &
  &, 0.619456E-01_JPRB, 0.577389E-01_JPRB, 0.537848E-01_JPRB &
  &, 0.500406E-01_JPRB, 0.465239E-01_JPRB, 0.431871E-01_JPRB, 0.400786E-01_JPRB &
  &, 0.371136E-01_JPRB, 0.343733E-01_JPRB, 0.317682E-01_JPRB &
  &, 0.293453E-01_JPRB, 0.270809E-01_JPRB, 0.249497E-01_JPRB, 0.229991E-01_JPRB &
  &, 0.211263E-01_JPRB, 0.194156E-01_JPRB, 0.178379E-01_JPRB &
  &, 0.163217E-01_JPRB, 0.149535E-01_JPRB, 0.137010E-01_JPRB, 0.125293E-01_JPRB &
  &, 0.114009E-01_JPRB, 0.104064E-01_JPRB, 0.950912E-02_JPRB &
  &, 0.862511E-02_JPRB, 0.784714E-02_JPRB, 0.713483E-02_JPRB, 0.644509E-02_JPRB &
  &, 0.587510E-02_JPRB, 0.528581E-02_JPRB, 0.477524E-02_JPRB &
  &, 0.434750E-02_JPRB, 0.390562E-02_JPRB, 0.350075E-02_JPRB, 0.318703E-02_JPRB &
  &, 0.286317E-02_JPRB, 0.252903E-02_JPRB, 0.229322E-02_JPRB &
  &, 0.204997E-02_JPRB, 0.185510E-02_JPRB, 0.165418E-02_JPRB, 0.144714E-02_JPRB &
  &, 0.129219E-02_JPRB, 0.113258E-02_JPRB, 0.102814E-02_JPRB &
  &, 0.920565E-03_JPRB, 0.809811E-03_JPRB, 0.695844E-03_JPRB, 0.641809E-03_JPRB &
  &, 0.522147E-03_JPRB, 0.464032E-03_JPRB, 0.404267E-03_JPRB/)
XCW( 469, :) = (/ &
  &  0.988795E+00_JPRB, 0.984972E+00_JPRB, 0.980741E+00_JPRB, 0.976111E+00_JPRB &
  &, 0.971081E+00_JPRB, 0.965655E+00_JPRB, 0.959836E+00_JPRB &
  &, 0.953628E+00_JPRB, 0.947033E+00_JPRB, 0.940057E+00_JPRB, 0.932703E+00_JPRB &
  &, 0.924973E+00_JPRB, 0.916879E+00_JPRB, 0.908419E+00_JPRB &
  &, 0.899602E+00_JPRB, 0.890433E+00_JPRB, 0.880919E+00_JPRB, 0.871068E+00_JPRB &
  &, 0.860884E+00_JPRB, 0.850373E+00_JPRB, 0.839552E+00_JPRB &
  &, 0.828422E+00_JPRB, 0.816992E+00_JPRB, 0.805275E+00_JPRB, 0.793279E+00_JPRB &
  &, 0.781015E+00_JPRB, 0.768496E+00_JPRB, 0.755732E+00_JPRB &
  &, 0.742734E+00_JPRB, 0.729517E+00_JPRB, 0.716093E+00_JPRB, 0.702474E+00_JPRB &
  &, 0.688679E+00_JPRB, 0.674715E+00_JPRB, 0.660602E+00_JPRB &
  &, 0.646357E+00_JPRB, 0.631990E+00_JPRB, 0.617519E+00_JPRB, 0.602963E+00_JPRB &
  &, 0.588338E+00_JPRB, 0.573662E+00_JPRB, 0.558942E+00_JPRB &
  &, 0.544201E+00_JPRB, 0.529464E+00_JPRB, 0.514734E+00_JPRB, 0.500039E+00_JPRB &
  &, 0.485383E+00_JPRB, 0.470798E+00_JPRB, 0.456289E+00_JPRB &
  &, 0.441876E+00_JPRB, 0.427567E+00_JPRB, 0.413393E+00_JPRB, 0.399362E+00_JPRB &
  &, 0.385494E+00_JPRB, 0.371780E+00_JPRB, 0.358268E+00_JPRB &
  &, 0.344931E+00_JPRB, 0.331819E+00_JPRB, 0.318916E+00_JPRB, 0.306256E+00_JPRB &
  &, 0.293837E+00_JPRB, 0.281673E+00_JPRB, 0.269761E+00_JPRB &
  &, 0.258128E+00_JPRB, 0.246748E+00_JPRB, 0.235668E+00_JPRB, 0.224874E+00_JPRB &
  &, 0.214374E+00_JPRB, 0.204170E+00_JPRB, 0.194285E+00_JPRB &
  &, 0.184679E+00_JPRB, 0.175389E+00_JPRB, 0.166371E+00_JPRB, 0.157728E+00_JPRB &
  &, 0.149364E+00_JPRB, 0.141293E+00_JPRB, 0.133524E+00_JPRB &
  &, 0.126069E+00_JPRB, 0.118887E+00_JPRB, 0.112035E+00_JPRB, 0.105442E+00_JPRB &
  &, 0.991630E-01_JPRB, 0.931485E-01_JPRB, 0.874250E-01_JPRB &
  &, 0.819367E-01_JPRB, 0.767354E-01_JPRB, 0.717892E-01_JPRB, 0.670918E-01_JPRB &
  &, 0.626355E-01_JPRB, 0.584109E-01_JPRB, 0.544380E-01_JPRB &
  &, 0.506739E-01_JPRB, 0.471041E-01_JPRB, 0.437449E-01_JPRB, 0.405795E-01_JPRB &
  &, 0.376232E-01_JPRB, 0.348227E-01_JPRB, 0.322255E-01_JPRB &
  &, 0.297746E-01_JPRB, 0.274812E-01_JPRB, 0.253197E-01_JPRB, 0.233378E-01_JPRB &
  &, 0.214706E-01_JPRB, 0.197267E-01_JPRB, 0.181146E-01_JPRB &
  &, 0.166029E-01_JPRB, 0.151985E-01_JPRB, 0.139084E-01_JPRB, 0.127400E-01_JPRB &
  &, 0.116150E-01_JPRB, 0.105804E-01_JPRB, 0.964166E-02_JPRB &
  &, 0.880459E-02_JPRB, 0.798383E-02_JPRB, 0.727362E-02_JPRB, 0.658600E-02_JPRB &
  &, 0.597046E-02_JPRB, 0.538262E-02_JPRB, 0.487349E-02_JPRB &
  &, 0.439735E-02_JPRB, 0.400680E-02_JPRB, 0.360341E-02_JPRB, 0.323912E-02_JPRB &
  &, 0.291601E-02_JPRB, 0.258263E-02_JPRB, 0.234758E-02_JPRB &
  &, 0.210510E-02_JPRB, 0.185510E-02_JPRB, 0.165418E-02_JPRB, 0.150463E-02_JPRB &
  &, 0.135047E-02_JPRB, 0.119166E-02_JPRB, 0.102814E-02_JPRB &
  &, 0.920565E-03_JPRB, 0.809811E-03_JPRB, 0.758193E-03_JPRB, 0.641809E-03_JPRB &
  &, 0.586165E-03_JPRB, 0.528894E-03_JPRB, 0.469978E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART67',1,ZHOOK_HANDLE)
END SUBROUTINE PART67

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART68

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART68',0,ZHOOK_HANDLE)

XCW( 470, :) = (/ &
  &  0.989045E+00_JPRB, 0.985282E+00_JPRB, 0.981114E+00_JPRB, 0.976545E+00_JPRB &
  &, 0.971575E+00_JPRB, 0.966210E+00_JPRB, 0.960449E+00_JPRB &
  &, 0.954299E+00_JPRB, 0.947763E+00_JPRB, 0.940844E+00_JPRB, 0.933546E+00_JPRB &
  &, 0.925874E+00_JPRB, 0.917833E+00_JPRB, 0.909428E+00_JPRB &
  &, 0.900663E+00_JPRB, 0.891547E+00_JPRB, 0.882083E+00_JPRB, 0.872281E+00_JPRB &
  &, 0.862146E+00_JPRB, 0.851683E+00_JPRB, 0.840907E+00_JPRB &
  &, 0.829821E+00_JPRB, 0.818437E+00_JPRB, 0.806760E+00_JPRB, 0.794806E+00_JPRB &
  &, 0.782583E+00_JPRB, 0.770101E+00_JPRB, 0.757373E+00_JPRB &
  &, 0.744411E+00_JPRB, 0.731224E+00_JPRB, 0.717830E+00_JPRB, 0.704242E+00_JPRB &
  &, 0.690474E+00_JPRB, 0.676533E+00_JPRB, 0.662448E+00_JPRB &
  &, 0.648217E+00_JPRB, 0.633869E+00_JPRB, 0.619425E+00_JPRB, 0.604878E+00_JPRB &
  &, 0.590271E+00_JPRB, 0.575601E+00_JPRB, 0.560876E+00_JPRB &
  &, 0.546162E+00_JPRB, 0.531428E+00_JPRB, 0.516701E+00_JPRB, 0.502006E+00_JPRB &
  &, 0.487350E+00_JPRB, 0.472763E+00_JPRB, 0.458251E+00_JPRB &
  &, 0.443821E+00_JPRB, 0.429518E+00_JPRB, 0.415336E+00_JPRB, 0.401282E+00_JPRB &
  &, 0.387387E+00_JPRB, 0.373673E+00_JPRB, 0.360130E+00_JPRB &
  &, 0.346791E+00_JPRB, 0.333642E+00_JPRB, 0.320733E+00_JPRB, 0.308032E+00_JPRB &
  &, 0.295586E+00_JPRB, 0.283392E+00_JPRB, 0.271447E+00_JPRB &
  &, 0.259779E+00_JPRB, 0.248381E+00_JPRB, 0.237260E+00_JPRB, 0.226443E+00_JPRB &
  &, 0.215898E+00_JPRB, 0.205666E+00_JPRB, 0.195731E+00_JPRB &
  &, 0.186092E+00_JPRB, 0.176768E+00_JPRB, 0.167734E+00_JPRB, 0.159029E+00_JPRB &
  &, 0.150601E+00_JPRB, 0.142508E+00_JPRB, 0.134693E+00_JPRB &
  &, 0.127188E+00_JPRB, 0.120004E+00_JPRB, 0.113097E+00_JPRB, 0.106474E+00_JPRB &
  &, 0.100136E+00_JPRB, 0.940869E-01_JPRB, 0.882995E-01_JPRB &
  &, 0.828000E-01_JPRB, 0.775583E-01_JPRB, 0.725986E-01_JPRB, 0.678574E-01_JPRB &
  &, 0.633553E-01_JPRB, 0.591134E-01_JPRB, 0.550911E-01_JPRB &
  &, 0.512756E-01_JPRB, 0.476844E-01_JPRB, 0.443026E-01_JPRB, 0.411137E-01_JPRB &
  &, 0.381329E-01_JPRB, 0.353067E-01_JPRB, 0.326475E-01_JPRB &
  &, 0.301681E-01_JPRB, 0.278450E-01_JPRB, 0.256898E-01_JPRB, 0.236764E-01_JPRB &
  &, 0.217767E-01_JPRB, 0.200379E-01_JPRB, 0.183914E-01_JPRB &
  &, 0.168841E-01_JPRB, 0.154434E-01_JPRB, 0.141573E-01_JPRB, 0.129508E-01_JPRB &
  &, 0.118291E-01_JPRB, 0.107979E-01_JPRB, 0.981839E-02_JPRB &
  &, 0.893920E-02_JPRB, 0.812053E-02_JPRB, 0.741242E-02_JPRB, 0.672692E-02_JPRB &
  &, 0.606583E-02_JPRB, 0.552782E-02_JPRB, 0.497174E-02_JPRB &
  &, 0.449707E-02_JPRB, 0.405739E-02_JPRB, 0.365475E-02_JPRB, 0.329120E-02_JPRB &
  &, 0.296885E-02_JPRB, 0.268982E-02_JPRB, 0.240195E-02_JPRB &
  &, 0.216024E-02_JPRB, 0.191101E-02_JPRB, 0.171088E-02_JPRB, 0.150463E-02_JPRB &
  &, 0.135047E-02_JPRB, 0.119166E-02_JPRB, 0.108803E-02_JPRB &
  &, 0.981270E-03_JPRB, 0.871335E-03_JPRB, 0.758193E-03_JPRB, 0.641809E-03_JPRB &
  &, 0.586165E-03_JPRB, 0.528894E-03_JPRB, 0.469978E-03_JPRB/)
XCW( 471, :) = (/ &
  &  0.989294E+00_JPRB, 0.985593E+00_JPRB, 0.981486E+00_JPRB, 0.976979E+00_JPRB &
  &, 0.972070E+00_JPRB, 0.966764E+00_JPRB, 0.961063E+00_JPRB &
  &, 0.954972E+00_JPRB, 0.948494E+00_JPRB, 0.941631E+00_JPRB, 0.934390E+00_JPRB &
  &, 0.926774E+00_JPRB, 0.918787E+00_JPRB, 0.910392E+00_JPRB &
  &, 0.901725E+00_JPRB, 0.892660E+00_JPRB, 0.883248E+00_JPRB, 0.873496E+00_JPRB &
  &, 0.863408E+00_JPRB, 0.852997E+00_JPRB, 0.842266E+00_JPRB &
  &, 0.831223E+00_JPRB, 0.819881E+00_JPRB, 0.808249E+00_JPRB, 0.796337E+00_JPRB &
  &, 0.784150E+00_JPRB, 0.771707E+00_JPRB, 0.759014E+00_JPRB &
  &, 0.746085E+00_JPRB, 0.732935E+00_JPRB, 0.719571E+00_JPRB, 0.706010E+00_JPRB &
  &, 0.692269E+00_JPRB, 0.678356E+00_JPRB, 0.664294E+00_JPRB &
  &, 0.650087E+00_JPRB, 0.635757E+00_JPRB, 0.621332E+00_JPRB, 0.606803E+00_JPRB &
  &, 0.592203E+00_JPRB, 0.577550E+00_JPRB, 0.562853E+00_JPRB &
  &, 0.548122E+00_JPRB, 0.533392E+00_JPRB, 0.518679E+00_JPRB, 0.503962E+00_JPRB &
  &, 0.489330E+00_JPRB, 0.474729E+00_JPRB, 0.460214E+00_JPRB &
  &, 0.445792E+00_JPRB, 0.431470E+00_JPRB, 0.417266E+00_JPRB, 0.403215E+00_JPRB &
  &, 0.389309E+00_JPRB, 0.375567E+00_JPRB, 0.362008E+00_JPRB &
  &, 0.348635E+00_JPRB, 0.335482E+00_JPRB, 0.322534E+00_JPRB, 0.309824E+00_JPRB &
  &, 0.297351E+00_JPRB, 0.285128E+00_JPRB, 0.273151E+00_JPRB &
  &, 0.261448E+00_JPRB, 0.250013E+00_JPRB, 0.238871E+00_JPRB, 0.228013E+00_JPRB &
  &, 0.217442E+00_JPRB, 0.207162E+00_JPRB, 0.197197E+00_JPRB &
  &, 0.187526E+00_JPRB, 0.178146E+00_JPRB, 0.169075E+00_JPRB, 0.160331E+00_JPRB &
  &, 0.151883E+00_JPRB, 0.143723E+00_JPRB, 0.135885E+00_JPRB &
  &, 0.128331E+00_JPRB, 0.121095E+00_JPRB, 0.114160E+00_JPRB, 0.107506E+00_JPRB &
  &, 0.101136E+00_JPRB, 0.950252E-01_JPRB, 0.892286E-01_JPRB &
  &, 0.836911E-01_JPRB, 0.784095E-01_JPRB, 0.733791E-01_JPRB, 0.686231E-01_JPRB &
  &, 0.640752E-01_JPRB, 0.598159E-01_JPRB, 0.557442E-01_JPRB &
  &, 0.519089E-01_JPRB, 0.482968E-01_JPRB, 0.448604E-01_JPRB, 0.416480E-01_JPRB &
  &, 0.386086E-01_JPRB, 0.357907E-01_JPRB, 0.331047E-01_JPRB &
  &, 0.305974E-01_JPRB, 0.282453E-01_JPRB, 0.260598E-01_JPRB, 0.240150E-01_JPRB &
  &, 0.221210E-01_JPRB, 0.203490E-01_JPRB, 0.186681E-01_JPRB &
  &, 0.171252E-01_JPRB, 0.157292E-01_JPRB, 0.143648E-01_JPRB, 0.131615E-01_JPRB &
  &, 0.120432E-01_JPRB, 0.109719E-01_JPRB, 0.999512E-02_JPRB &
  &, 0.911869E-02_JPRB, 0.830279E-02_JPRB, 0.755121E-02_JPRB, 0.682086E-02_JPRB &
  &, 0.620888E-02_JPRB, 0.562463E-02_JPRB, 0.506999E-02_JPRB &
  &, 0.459678E-02_JPRB, 0.415858E-02_JPRB, 0.375742E-02_JPRB, 0.339536E-02_JPRB &
  &, 0.302168E-02_JPRB, 0.274342E-02_JPRB, 0.245631E-02_JPRB &
  &, 0.221537E-02_JPRB, 0.196692E-02_JPRB, 0.176757E-02_JPRB, 0.156211E-02_JPRB &
  &, 0.140875E-02_JPRB, 0.125075E-02_JPRB, 0.108803E-02_JPRB &
  &, 0.981270E-03_JPRB, 0.871335E-03_JPRB, 0.758193E-03_JPRB, 0.704990E-03_JPRB &
  &, 0.586165E-03_JPRB, 0.528894E-03_JPRB, 0.469978E-03_JPRB/)
XCW( 472, :) = (/ &
  &  0.989542E+00_JPRB, 0.985906E+00_JPRB, 0.981859E+00_JPRB, 0.977413E+00_JPRB &
  &, 0.972565E+00_JPRB, 0.967318E+00_JPRB, 0.961677E+00_JPRB &
  &, 0.955645E+00_JPRB, 0.949224E+00_JPRB, 0.942420E+00_JPRB, 0.935235E+00_JPRB &
  &, 0.927674E+00_JPRB, 0.919742E+00_JPRB, 0.911446E+00_JPRB &
  &, 0.902787E+00_JPRB, 0.893775E+00_JPRB, 0.884415E+00_JPRB, 0.874711E+00_JPRB &
  &, 0.864674E+00_JPRB, 0.854307E+00_JPRB, 0.843624E+00_JPRB &
  &, 0.832626E+00_JPRB, 0.821330E+00_JPRB, 0.809738E+00_JPRB, 0.797865E+00_JPRB &
  &, 0.785722E+00_JPRB, 0.773316E+00_JPRB, 0.760659E+00_JPRB &
  &, 0.747766E+00_JPRB, 0.734646E+00_JPRB, 0.721316E+00_JPRB, 0.707782E+00_JPRB &
  &, 0.694068E+00_JPRB, 0.680183E+00_JPRB, 0.666144E+00_JPRB &
  &, 0.651956E+00_JPRB, 0.637655E+00_JPRB, 0.623239E+00_JPRB, 0.608728E+00_JPRB &
  &, 0.594146E+00_JPRB, 0.579500E+00_JPRB, 0.564808E+00_JPRB &
  &, 0.550093E+00_JPRB, 0.535367E+00_JPRB, 0.520656E+00_JPRB, 0.505965E+00_JPRB &
  &, 0.491309E+00_JPRB, 0.476707E+00_JPRB, 0.462189E+00_JPRB &
  &, 0.447750E+00_JPRB, 0.433421E+00_JPRB, 0.419223E+00_JPRB, 0.405149E+00_JPRB &
  &, 0.391231E+00_JPRB, 0.377475E+00_JPRB, 0.363885E+00_JPRB &
  &, 0.350510E+00_JPRB, 0.337321E+00_JPRB, 0.324351E+00_JPRB, 0.311617E+00_JPRB &
  &, 0.299116E+00_JPRB, 0.286864E+00_JPRB, 0.274855E+00_JPRB &
  &, 0.263118E+00_JPRB, 0.251664E+00_JPRB, 0.240483E+00_JPRB, 0.229582E+00_JPRB &
  &, 0.218986E+00_JPRB, 0.208659E+00_JPRB, 0.198663E+00_JPRB &
  &, 0.188938E+00_JPRB, 0.179545E+00_JPRB, 0.170438E+00_JPRB, 0.161632E+00_JPRB &
  &, 0.153143E+00_JPRB, 0.144962E+00_JPRB, 0.137077E+00_JPRB &
  &, 0.129499E+00_JPRB, 0.122211E+00_JPRB, 0.115222E+00_JPRB, 0.108537E+00_JPRB &
  &, 0.102109E+00_JPRB, 0.959904E-01_JPRB, 0.901303E-01_JPRB &
  &, 0.845543E-01_JPRB, 0.792324E-01_JPRB, 0.741886E-01_JPRB, 0.693887E-01_JPRB &
  &, 0.648250E-01_JPRB, 0.604879E-01_JPRB, 0.563974E-01_JPRB &
  &, 0.525422E-01_JPRB, 0.488770E-01_JPRB, 0.454182E-01_JPRB, 0.421822E-01_JPRB &
  &, 0.391182E-01_JPRB, 0.362401E-01_JPRB, 0.335619E-01_JPRB &
  &, 0.310267E-01_JPRB, 0.286455E-01_JPRB, 0.264298E-01_JPRB, 0.243913E-01_JPRB &
  &, 0.224270E-01_JPRB, 0.206601E-01_JPRB, 0.189843E-01_JPRB &
  &, 0.174064E-01_JPRB, 0.159742E-01_JPRB, 0.146137E-01_JPRB, 0.133723E-01_JPRB &
  &, 0.122145E-01_JPRB, 0.111459E-01_JPRB, 0.101718E-01_JPRB &
  &, 0.929817E-02_JPRB, 0.843948E-02_JPRB, 0.769001E-02_JPRB, 0.696177E-02_JPRB &
  &, 0.630425E-02_JPRB, 0.572143E-02_JPRB, 0.516824E-02_JPRB &
  &, 0.469649E-02_JPRB, 0.425976E-02_JPRB, 0.380875E-02_JPRB, 0.344745E-02_JPRB &
  &, 0.307452E-02_JPRB, 0.279702E-02_JPRB, 0.251067E-02_JPRB &
  &, 0.227051E-02_JPRB, 0.202284E-02_JPRB, 0.182427E-02_JPRB, 0.161960E-02_JPRB &
  &, 0.140875E-02_JPRB, 0.125075E-02_JPRB, 0.114792E-02_JPRB &
  &, 0.981270E-03_JPRB, 0.871335E-03_JPRB, 0.820543E-03_JPRB, 0.704990E-03_JPRB &
  &, 0.650184E-03_JPRB, 0.528894E-03_JPRB, 0.469978E-03_JPRB/)
XCW( 473, :) = (/ &
  &  0.989792E+00_JPRB, 0.986216E+00_JPRB, 0.982233E+00_JPRB, 0.977847E+00_JPRB &
  &, 0.973059E+00_JPRB, 0.967872E+00_JPRB, 0.962291E+00_JPRB &
  &, 0.956317E+00_JPRB, 0.949955E+00_JPRB, 0.943208E+00_JPRB, 0.936080E+00_JPRB &
  &, 0.928575E+00_JPRB, 0.920698E+00_JPRB, 0.912455E+00_JPRB &
  &, 0.903851E+00_JPRB, 0.894891E+00_JPRB, 0.885580E+00_JPRB, 0.875928E+00_JPRB &
  &, 0.865939E+00_JPRB, 0.855620E+00_JPRB, 0.844983E+00_JPRB &
  &, 0.834032E+00_JPRB, 0.822778E+00_JPRB, 0.811230E+00_JPRB, 0.799400E+00_JPRB &
  &, 0.787293E+00_JPRB, 0.774925E+00_JPRB, 0.762304E+00_JPRB &
  &, 0.749447E+00_JPRB, 0.736361E+00_JPRB, 0.723062E+00_JPRB, 0.709559E+00_JPRB &
  &, 0.695872E+00_JPRB, 0.682015E+00_JPRB, 0.667995E+00_JPRB &
  &, 0.653835E+00_JPRB, 0.639553E+00_JPRB, 0.625155E+00_JPRB, 0.610663E+00_JPRB &
  &, 0.596089E+00_JPRB, 0.581460E+00_JPRB, 0.566774E+00_JPRB &
  &, 0.552076E+00_JPRB, 0.537354E+00_JPRB, 0.522634E+00_JPRB, 0.507944E+00_JPRB &
  &, 0.493289E+00_JPRB, 0.478698E+00_JPRB, 0.464165E+00_JPRB &
  &, 0.449721E+00_JPRB, 0.435386E+00_JPRB, 0.421167E+00_JPRB, 0.407083E+00_JPRB &
  &, 0.393153E+00_JPRB, 0.379384E+00_JPRB, 0.365778E+00_JPRB &
  &, 0.352370E+00_JPRB, 0.339177E+00_JPRB, 0.326185E+00_JPRB, 0.313409E+00_JPRB &
  &, 0.300882E+00_JPRB, 0.288600E+00_JPRB, 0.276577E+00_JPRB &
  &, 0.264806E+00_JPRB, 0.253315E+00_JPRB, 0.242094E+00_JPRB, 0.231170E+00_JPRB &
  &, 0.220529E+00_JPRB, 0.210175E+00_JPRB, 0.200129E+00_JPRB &
  &, 0.190372E+00_JPRB, 0.180945E+00_JPRB, 0.171801E+00_JPRB, 0.162956E+00_JPRB &
  &, 0.154425E+00_JPRB, 0.146200E+00_JPRB, 0.138269E+00_JPRB &
  &, 0.130666E+00_JPRB, 0.123328E+00_JPRB, 0.116310E+00_JPRB, 0.109569E+00_JPRB &
  &, 0.103108E+00_JPRB, 0.969555E-01_JPRB, 0.910594E-01_JPRB &
  &, 0.854455E-01_JPRB, 0.800836E-01_JPRB, 0.749980E-01_JPRB, 0.701543E-01_JPRB &
  &, 0.655748E-01_JPRB, 0.611904E-01_JPRB, 0.570816E-01_JPRB &
  &, 0.531755E-01_JPRB, 0.494895E-01_JPRB, 0.460087E-01_JPRB, 0.427165E-01_JPRB &
  &, 0.396279E-01_JPRB, 0.367586E-01_JPRB, 0.340191E-01_JPRB &
  &, 0.314560E-01_JPRB, 0.290821E-01_JPRB, 0.268369E-01_JPRB, 0.247299E-01_JPRB &
  &, 0.227713E-01_JPRB, 0.209712E-01_JPRB, 0.192610E-01_JPRB &
  &, 0.176877E-01_JPRB, 0.162192E-01_JPRB, 0.148626E-01_JPRB, 0.136252E-01_JPRB &
  &, 0.124287E-01_JPRB, 0.113634E-01_JPRB, 0.103486E-01_JPRB &
  &, 0.943278E-02_JPRB, 0.857618E-02_JPRB, 0.782880E-02_JPRB, 0.710269E-02_JPRB &
  &, 0.644730E-02_JPRB, 0.586664E-02_JPRB, 0.526650E-02_JPRB &
  &, 0.479620E-02_JPRB, 0.431036E-02_JPRB, 0.391142E-02_JPRB, 0.349953E-02_JPRB &
  &, 0.318019E-02_JPRB, 0.285061E-02_JPRB, 0.256503E-02_JPRB &
  &, 0.227051E-02_JPRB, 0.207875E-02_JPRB, 0.182427E-02_JPRB, 0.161960E-02_JPRB &
  &, 0.146704E-02_JPRB, 0.130983E-02_JPRB, 0.114792E-02_JPRB &
  &, 0.104197E-02_JPRB, 0.932859E-03_JPRB, 0.820543E-03_JPRB, 0.704990E-03_JPRB &
  &, 0.650184E-03_JPRB, 0.528894E-03_JPRB, 0.469978E-03_JPRB/)
XCW( 474, :) = (/ &
  &  0.990043E+00_JPRB, 0.986529E+00_JPRB, 0.982606E+00_JPRB, 0.978281E+00_JPRB &
  &, 0.973553E+00_JPRB, 0.968427E+00_JPRB, 0.962905E+00_JPRB &
  &, 0.956989E+00_JPRB, 0.950686E+00_JPRB, 0.943996E+00_JPRB, 0.936925E+00_JPRB &
  &, 0.929476E+00_JPRB, 0.921655E+00_JPRB, 0.913466E+00_JPRB &
  &, 0.904914E+00_JPRB, 0.896007E+00_JPRB, 0.886748E+00_JPRB, 0.877146E+00_JPRB &
  &, 0.867206E+00_JPRB, 0.856937E+00_JPRB, 0.846345E+00_JPRB &
  &, 0.835437E+00_JPRB, 0.824229E+00_JPRB, 0.812723E+00_JPRB, 0.800934E+00_JPRB &
  &, 0.788868E+00_JPRB, 0.776538E+00_JPRB, 0.763953E+00_JPRB &
  &, 0.751129E+00_JPRB, 0.738076E+00_JPRB, 0.724807E+00_JPRB, 0.711339E+00_JPRB &
  &, 0.697680E+00_JPRB, 0.683846E+00_JPRB, 0.669855E+00_JPRB &
  &, 0.655714E+00_JPRB, 0.641451E+00_JPRB, 0.627072E+00_JPRB, 0.612598E+00_JPRB &
  &, 0.598041E+00_JPRB, 0.583420E+00_JPRB, 0.568751E+00_JPRB &
  &, 0.554047E+00_JPRB, 0.539340E+00_JPRB, 0.524624E+00_JPRB, 0.509936E+00_JPRB &
  &, 0.495280E+00_JPRB, 0.480688E+00_JPRB, 0.466153E+00_JPRB &
  &, 0.451705E+00_JPRB, 0.437365E+00_JPRB, 0.423124E+00_JPRB, 0.409030E+00_JPRB &
  &, 0.395090E+00_JPRB, 0.381292E+00_JPRB, 0.367686E+00_JPRB &
  &, 0.354245E+00_JPRB, 0.341032E+00_JPRB, 0.328018E+00_JPRB, 0.315218E+00_JPRB &
  &, 0.302664E+00_JPRB, 0.290353E+00_JPRB, 0.278298E+00_JPRB &
  &, 0.266493E+00_JPRB, 0.254984E+00_JPRB, 0.243724E+00_JPRB, 0.232759E+00_JPRB &
  &, 0.222093E+00_JPRB, 0.211691E+00_JPRB, 0.201616E+00_JPRB &
  &, 0.191827E+00_JPRB, 0.182344E+00_JPRB, 0.173164E+00_JPRB, 0.164280E+00_JPRB &
  &, 0.155708E+00_JPRB, 0.147439E+00_JPRB, 0.139485E+00_JPRB &
  &, 0.131833E+00_JPRB, 0.124469E+00_JPRB, 0.117398E+00_JPRB, 0.110627E+00_JPRB &
  &, 0.104134E+00_JPRB, 0.979207E-01_JPRB, 0.919885E-01_JPRB &
  &, 0.863366E-01_JPRB, 0.809349E-01_JPRB, 0.758074E-01_JPRB, 0.709494E-01_JPRB &
  &, 0.662946E-01_JPRB, 0.619235E-01_JPRB, 0.577658E-01_JPRB &
  &, 0.538088E-01_JPRB, 0.501019E-01_JPRB, 0.465993E-01_JPRB, 0.432841E-01_JPRB &
  &, 0.401715E-01_JPRB, 0.372426E-01_JPRB, 0.344763E-01_JPRB &
  &, 0.318853E-01_JPRB, 0.294824E-01_JPRB, 0.272069E-01_JPRB, 0.251062E-01_JPRB &
  &, 0.231156E-01_JPRB, 0.212823E-01_JPRB, 0.195772E-01_JPRB &
  &, 0.179689E-01_JPRB, 0.165050E-01_JPRB, 0.151116E-01_JPRB, 0.138360E-01_JPRB &
  &, 0.126428E-01_JPRB, 0.115374E-01_JPRB, 0.105695E-01_JPRB &
  &, 0.961226E-02_JPRB, 0.875844E-02_JPRB, 0.796760E-02_JPRB, 0.724360E-02_JPRB &
  &, 0.659035E-02_JPRB, 0.596344E-02_JPRB, 0.541388E-02_JPRB &
  &, 0.489592E-02_JPRB, 0.441154E-02_JPRB, 0.396276E-02_JPRB, 0.360369E-02_JPRB &
  &, 0.323303E-02_JPRB, 0.290421E-02_JPRB, 0.261940E-02_JPRB &
  &, 0.232564E-02_JPRB, 0.207875E-02_JPRB, 0.188097E-02_JPRB, 0.167709E-02_JPRB &
  &, 0.152532E-02_JPRB, 0.136891E-02_JPRB, 0.120781E-02_JPRB &
  &, 0.104197E-02_JPRB, 0.932859E-03_JPRB, 0.820543E-03_JPRB, 0.768171E-03_JPRB &
  &, 0.650184E-03_JPRB, 0.593756E-03_JPRB, 0.535689E-03_JPRB/)
XCW( 475, :) = (/ &
  &  0.990295E+00_JPRB, 0.986839E+00_JPRB, 0.982979E+00_JPRB, 0.978714E+00_JPRB &
  &, 0.974047E+00_JPRB, 0.968982E+00_JPRB, 0.963519E+00_JPRB &
  &, 0.957663E+00_JPRB, 0.951417E+00_JPRB, 0.944785E+00_JPRB, 0.937770E+00_JPRB &
  &, 0.930377E+00_JPRB, 0.922612E+00_JPRB, 0.914477E+00_JPRB &
  &, 0.905980E+00_JPRB, 0.897124E+00_JPRB, 0.887917E+00_JPRB, 0.878364E+00_JPRB &
  &, 0.868473E+00_JPRB, 0.858250E+00_JPRB, 0.847707E+00_JPRB &
  &, 0.836847E+00_JPRB, 0.825681E+00_JPRB, 0.814218E+00_JPRB, 0.802469E+00_JPRB &
  &, 0.790443E+00_JPRB, 0.778151E+00_JPRB, 0.765605E+00_JPRB &
  &, 0.752814E+00_JPRB, 0.739795E+00_JPRB, 0.726561E+00_JPRB, 0.713120E+00_JPRB &
  &, 0.699489E+00_JPRB, 0.685682E+00_JPRB, 0.671714E+00_JPRB &
  &, 0.657593E+00_JPRB, 0.643349E+00_JPRB, 0.628988E+00_JPRB, 0.614532E+00_JPRB &
  &, 0.599994E+00_JPRB, 0.585380E+00_JPRB, 0.570729E+00_JPRB &
  &, 0.556040E+00_JPRB, 0.541327E+00_JPRB, 0.526625E+00_JPRB, 0.511939E+00_JPRB &
  &, 0.497284E+00_JPRB, 0.482679E+00_JPRB, 0.468141E+00_JPRB &
  &, 0.453689E+00_JPRB, 0.439329E+00_JPRB, 0.425095E+00_JPRB, 0.410992E+00_JPRB &
  &, 0.397026E+00_JPRB, 0.383215E+00_JPRB, 0.369579E+00_JPRB &
  &, 0.356136E+00_JPRB, 0.342887E+00_JPRB, 0.329852E+00_JPRB, 0.317044E+00_JPRB &
  &, 0.304447E+00_JPRB, 0.292107E+00_JPRB, 0.280020E+00_JPRB &
  &, 0.268199E+00_JPRB, 0.256635E+00_JPRB, 0.245355E+00_JPRB, 0.234366E+00_JPRB &
  &, 0.223656E+00_JPRB, 0.213228E+00_JPRB, 0.203103E+00_JPRB &
  &, 0.193283E+00_JPRB, 0.183766E+00_JPRB, 0.174549E+00_JPRB, 0.165626E+00_JPRB &
  &, 0.157013E+00_JPRB, 0.148701E+00_JPRB, 0.140701E+00_JPRB &
  &, 0.133001E+00_JPRB, 0.125585E+00_JPRB, 0.118486E+00_JPRB, 0.111685E+00_JPRB &
  &, 0.105133E+00_JPRB, 0.988859E-01_JPRB, 0.929448E-01_JPRB &
  &, 0.872277E-01_JPRB, 0.818145E-01_JPRB, 0.766458E-01_JPRB, 0.717151E-01_JPRB &
  &, 0.670745E-01_JPRB, 0.626260E-01_JPRB, 0.584501E-01_JPRB &
  &, 0.544737E-01_JPRB, 0.507144E-01_JPRB, 0.471899E-01_JPRB, 0.438517E-01_JPRB &
  &, 0.406812E-01_JPRB, 0.377266E-01_JPRB, 0.349687E-01_JPRB &
  &, 0.323503E-01_JPRB, 0.298826E-01_JPRB, 0.276139E-01_JPRB, 0.254824E-01_JPRB &
  &, 0.234599E-01_JPRB, 0.215934E-01_JPRB, 0.198540E-01_JPRB &
  &, 0.182501E-01_JPRB, 0.167500E-01_JPRB, 0.153605E-01_JPRB, 0.140467E-01_JPRB &
  &, 0.128569E-01_JPRB, 0.117549E-01_JPRB, 0.107462E-01_JPRB &
  &, 0.979174E-02_JPRB, 0.889513E-02_JPRB, 0.810640E-02_JPRB, 0.738452E-02_JPRB &
  &, 0.668572E-02_JPRB, 0.606024E-02_JPRB, 0.551213E-02_JPRB &
  &, 0.499563E-02_JPRB, 0.451272E-02_JPRB, 0.406543E-02_JPRB, 0.365578E-02_JPRB &
  &, 0.328586E-02_JPRB, 0.295781E-02_JPRB, 0.267376E-02_JPRB &
  &, 0.238077E-02_JPRB, 0.213466E-02_JPRB, 0.193766E-02_JPRB, 0.173457E-02_JPRB &
  &, 0.152532E-02_JPRB, 0.136891E-02_JPRB, 0.120781E-02_JPRB &
  &, 0.110268E-02_JPRB, 0.994383E-03_JPRB, 0.882892E-03_JPRB, 0.768171E-03_JPRB &
  &, 0.650184E-03_JPRB, 0.593756E-03_JPRB, 0.535689E-03_JPRB/)
XCW( 476, :) = (/ &
  &  0.990542E+00_JPRB, 0.987151E+00_JPRB, 0.983352E+00_JPRB, 0.979149E+00_JPRB &
  &, 0.974543E+00_JPRB, 0.969537E+00_JPRB, 0.964133E+00_JPRB &
  &, 0.958336E+00_JPRB, 0.952149E+00_JPRB, 0.945575E+00_JPRB, 0.938617E+00_JPRB &
  &, 0.931280E+00_JPRB, 0.923569E+00_JPRB, 0.915489E+00_JPRB &
  &, 0.907045E+00_JPRB, 0.898241E+00_JPRB, 0.889085E+00_JPRB, 0.879583E+00_JPRB &
  &, 0.869742E+00_JPRB, 0.859567E+00_JPRB, 0.849068E+00_JPRB &
  &, 0.838256E+00_JPRB, 0.827136E+00_JPRB, 0.815714E+00_JPRB, 0.804007E+00_JPRB &
  &, 0.792022E+00_JPRB, 0.779768E+00_JPRB, 0.767257E+00_JPRB &
  &, 0.754503E+00_JPRB, 0.741518E+00_JPRB, 0.728314E+00_JPRB, 0.714901E+00_JPRB &
  &, 0.701301E+00_JPRB, 0.687518E+00_JPRB, 0.673574E+00_JPRB &
  &, 0.659481E+00_JPRB, 0.645256E+00_JPRB, 0.630915E+00_JPRB, 0.616477E+00_JPRB &
  &, 0.601947E+00_JPRB, 0.587350E+00_JPRB, 0.572706E+00_JPRB &
  &, 0.558023E+00_JPRB, 0.543325E+00_JPRB, 0.528626E+00_JPRB, 0.513942E+00_JPRB &
  &, 0.499288E+00_JPRB, 0.484682E+00_JPRB, 0.470142E+00_JPRB &
  &, 0.455673E+00_JPRB, 0.441321E+00_JPRB, 0.427066E+00_JPRB, 0.412940E+00_JPRB &
  &, 0.398963E+00_JPRB, 0.385153E+00_JPRB, 0.371502E+00_JPRB &
  &, 0.358026E+00_JPRB, 0.344759E+00_JPRB, 0.331701E+00_JPRB, 0.318853E+00_JPRB &
  &, 0.306246E+00_JPRB, 0.293877E+00_JPRB, 0.281760E+00_JPRB &
  &, 0.269905E+00_JPRB, 0.258323E+00_JPRB, 0.247004E+00_JPRB, 0.235974E+00_JPRB &
  &, 0.225220E+00_JPRB, 0.214764E+00_JPRB, 0.204610E+00_JPRB &
  &, 0.194738E+00_JPRB, 0.185187E+00_JPRB, 0.175933E+00_JPRB, 0.166972E+00_JPRB &
  &, 0.158318E+00_JPRB, 0.149962E+00_JPRB, 0.141941E+00_JPRB &
  &, 0.134193E+00_JPRB, 0.126751E+00_JPRB, 0.119599E+00_JPRB, 0.112742E+00_JPRB &
  &, 0.106159E+00_JPRB, 0.998778E-01_JPRB, 0.938739E-01_JPRB &
  &, 0.881466E-01_JPRB, 0.826657E-01_JPRB, 0.774841E-01_JPRB, 0.725102E-01_JPRB &
  &, 0.678243E-01_JPRB, 0.633591E-01_JPRB, 0.591343E-01_JPRB &
  &, 0.551387E-01_JPRB, 0.513268E-01_JPRB, 0.477804E-01_JPRB, 0.443860E-01_JPRB &
  &, 0.412249E-01_JPRB, 0.382452E-01_JPRB, 0.354259E-01_JPRB &
  &, 0.327796E-01_JPRB, 0.303192E-01_JPRB, 0.280209E-01_JPRB, 0.258587E-01_JPRB &
  &, 0.238424E-01_JPRB, 0.219434E-01_JPRB, 0.201702E-01_JPRB &
  &, 0.185314E-01_JPRB, 0.170358E-01_JPRB, 0.156094E-01_JPRB, 0.142997E-01_JPRB &
  &, 0.130710E-01_JPRB, 0.119724E-01_JPRB, 0.109229E-01_JPRB &
  &, 0.997122E-02_JPRB, 0.907739E-02_JPRB, 0.824519E-02_JPRB, 0.752543E-02_JPRB &
  &, 0.682877E-02_JPRB, 0.620545E-02_JPRB, 0.561038E-02_JPRB &
  &, 0.509534E-02_JPRB, 0.461391E-02_JPRB, 0.416809E-02_JPRB, 0.375994E-02_JPRB &
  &, 0.339154E-02_JPRB, 0.306500E-02_JPRB, 0.272812E-02_JPRB &
  &, 0.243591E-02_JPRB, 0.219057E-02_JPRB, 0.199436E-02_JPRB, 0.179206E-02_JPRB &
  &, 0.158360E-02_JPRB, 0.142799E-02_JPRB, 0.126771E-02_JPRB &
  &, 0.110268E-02_JPRB, 0.994383E-03_JPRB, 0.882892E-03_JPRB, 0.768171E-03_JPRB &
  &, 0.714202E-03_JPRB, 0.593756E-03_JPRB, 0.535689E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART68',1,ZHOOK_HANDLE)
END SUBROUTINE PART68

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART69

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART69',0,ZHOOK_HANDLE)

XCW( 477, :) = (/ &
  &  0.990793E+00_JPRB, 0.987463E+00_JPRB, 0.983724E+00_JPRB, 0.979583E+00_JPRB &
  &, 0.975037E+00_JPRB, 0.970091E+00_JPRB, 0.964748E+00_JPRB &
  &, 0.959010E+00_JPRB, 0.952881E+00_JPRB, 0.946364E+00_JPRB, 0.939463E+00_JPRB &
  &, 0.932183E+00_JPRB, 0.924527E+00_JPRB, 0.916501E+00_JPRB &
  &, 0.908110E+00_JPRB, 0.899360E+00_JPRB, 0.890256E+00_JPRB, 0.880804E+00_JPRB &
  &, 0.871012E+00_JPRB, 0.860887E+00_JPRB, 0.850434E+00_JPRB &
  &, 0.839668E+00_JPRB, 0.828591E+00_JPRB, 0.817213E+00_JPRB, 0.805545E+00_JPRB &
  &, 0.793600E+00_JPRB, 0.781385E+00_JPRB, 0.768914E+00_JPRB &
  &, 0.756196E+00_JPRB, 0.743241E+00_JPRB, 0.730068E+00_JPRB, 0.716690E+00_JPRB &
  &, 0.703113E+00_JPRB, 0.689363E+00_JPRB, 0.675443E+00_JPRB &
  &, 0.661369E+00_JPRB, 0.647173E+00_JPRB, 0.632851E+00_JPRB, 0.618422E+00_JPRB &
  &, 0.603911E+00_JPRB, 0.589332E+00_JPRB, 0.574693E+00_JPRB &
  &, 0.560016E+00_JPRB, 0.545323E+00_JPRB, 0.530627E+00_JPRB, 0.515945E+00_JPRB &
  &, 0.501292E+00_JPRB, 0.486685E+00_JPRB, 0.472143E+00_JPRB &
  &, 0.457670E+00_JPRB, 0.443300E+00_JPRB, 0.429051E+00_JPRB, 0.414916E+00_JPRB &
  &, 0.400913E+00_JPRB, 0.387077E+00_JPRB, 0.373410E+00_JPRB &
  &, 0.359932E+00_JPRB, 0.346646E+00_JPRB, 0.333551E+00_JPRB, 0.320695E+00_JPRB &
  &, 0.308062E+00_JPRB, 0.295666E+00_JPRB, 0.283517E+00_JPRB &
  &, 0.271629E+00_JPRB, 0.260011E+00_JPRB, 0.248653E+00_JPRB, 0.237582E+00_JPRB &
  &, 0.226803E+00_JPRB, 0.216321E+00_JPRB, 0.206118E+00_JPRB &
  &, 0.196214E+00_JPRB, 0.186608E+00_JPRB, 0.177318E+00_JPRB, 0.168319E+00_JPRB &
  &, 0.159624E+00_JPRB, 0.151248E+00_JPRB, 0.143156E+00_JPRB &
  &, 0.135384E+00_JPRB, 0.127892E+00_JPRB, 0.120712E+00_JPRB, 0.113800E+00_JPRB &
  &, 0.107211E+00_JPRB, 0.100870E+00_JPRB, 0.948303E-01_JPRB &
  &, 0.890656E-01_JPRB, 0.835454E-01_JPRB, 0.783224E-01_JPRB, 0.733347E-01_JPRB &
  &, 0.685741E-01_JPRB, 0.640921E-01_JPRB, 0.598186E-01_JPRB &
  &, 0.558036E-01_JPRB, 0.519715E-01_JPRB, 0.483710E-01_JPRB, 0.449536E-01_JPRB &
  &, 0.417685E-01_JPRB, 0.387292E-01_JPRB, 0.359183E-01_JPRB &
  &, 0.332447E-01_JPRB, 0.307559E-01_JPRB, 0.284280E-01_JPRB, 0.262349E-01_JPRB &
  &, 0.241867E-01_JPRB, 0.222545E-01_JPRB, 0.204864E-01_JPRB &
  &, 0.188528E-01_JPRB, 0.172807E-01_JPRB, 0.158583E-01_JPRB, 0.145526E-01_JPRB &
  &, 0.133279E-01_JPRB, 0.121898E-01_JPRB, 0.110997E-01_JPRB &
  &, 0.101507E-01_JPRB, 0.925965E-02_JPRB, 0.843025E-02_JPRB, 0.766634E-02_JPRB &
  &, 0.697182E-02_JPRB, 0.630225E-02_JPRB, 0.570863E-02_JPRB &
  &, 0.519506E-02_JPRB, 0.471509E-02_JPRB, 0.421943E-02_JPRB, 0.381203E-02_JPRB &
  &, 0.344437E-02_JPRB, 0.311860E-02_JPRB, 0.278248E-02_JPRB &
  &, 0.249104E-02_JPRB, 0.224649E-02_JPRB, 0.199436E-02_JPRB, 0.179206E-02_JPRB &
  &, 0.164188E-02_JPRB, 0.142799E-02_JPRB, 0.126771E-02_JPRB &
  &, 0.116338E-02_JPRB, 0.994383E-03_JPRB, 0.882892E-03_JPRB, 0.831352E-03_JPRB &
  &, 0.714202E-03_JPRB, 0.658618E-03_JPRB, 0.535689E-03_JPRB/)
XCW( 478, :) = (/ &
  &  0.991043E+00_JPRB, 0.987775E+00_JPRB, 0.984098E+00_JPRB, 0.980017E+00_JPRB &
  &, 0.975533E+00_JPRB, 0.970647E+00_JPRB, 0.965363E+00_JPRB &
  &, 0.959684E+00_JPRB, 0.953612E+00_JPRB, 0.947154E+00_JPRB, 0.940310E+00_JPRB &
  &, 0.933086E+00_JPRB, 0.925485E+00_JPRB, 0.917515E+00_JPRB &
  &, 0.909176E+00_JPRB, 0.900479E+00_JPRB, 0.891426E+00_JPRB, 0.882025E+00_JPRB &
  &, 0.872284E+00_JPRB, 0.862207E+00_JPRB, 0.851802E+00_JPRB &
  &, 0.841080E+00_JPRB, 0.830046E+00_JPRB, 0.818713E+00_JPRB, 0.807087E+00_JPRB &
  &, 0.795182E+00_JPRB, 0.783005E+00_JPRB, 0.770570E+00_JPRB &
  &, 0.757885E+00_JPRB, 0.744968E+00_JPRB, 0.731830E+00_JPRB, 0.718479E+00_JPRB &
  &, 0.704935E+00_JPRB, 0.691208E+00_JPRB, 0.677312E+00_JPRB &
  &, 0.663267E+00_JPRB, 0.649080E+00_JPRB, 0.634777E+00_JPRB, 0.620367E+00_JPRB &
  &, 0.605874E+00_JPRB, 0.591302E+00_JPRB, 0.576681E+00_JPRB &
  &, 0.562020E+00_JPRB, 0.547332E+00_JPRB, 0.532640E+00_JPRB, 0.517960E+00_JPRB &
  &, 0.503308E+00_JPRB, 0.488689E+00_JPRB, 0.474144E+00_JPRB &
  &, 0.459681E+00_JPRB, 0.445305E+00_JPRB, 0.431036E+00_JPRB, 0.416892E+00_JPRB &
  &, 0.402879E+00_JPRB, 0.389029E+00_JPRB, 0.375333E+00_JPRB &
  &, 0.361839E+00_JPRB, 0.348517E+00_JPRB, 0.335417E+00_JPRB, 0.322521E+00_JPRB &
  &, 0.309862E+00_JPRB, 0.297436E+00_JPRB, 0.285274E+00_JPRB &
  &, 0.273353E+00_JPRB, 0.261699E+00_JPRB, 0.250322E+00_JPRB, 0.239209E+00_JPRB &
  &, 0.228387E+00_JPRB, 0.217858E+00_JPRB, 0.207625E+00_JPRB &
  &, 0.197690E+00_JPRB, 0.188050E+00_JPRB, 0.178725E+00_JPRB, 0.169687E+00_JPRB &
  &, 0.160952E+00_JPRB, 0.152533E+00_JPRB, 0.144396E+00_JPRB &
  &, 0.136576E+00_JPRB, 0.129058E+00_JPRB, 0.121826E+00_JPRB, 0.114883E+00_JPRB &
  &, 0.108237E+00_JPRB, 0.101889E+00_JPRB, 0.957867E-01_JPRB &
  &, 0.899846E-01_JPRB, 0.844534E-01_JPRB, 0.791608E-01_JPRB, 0.741298E-01_JPRB &
  &, 0.693539E-01_JPRB, 0.648252E-01_JPRB, 0.605339E-01_JPRB &
  &, 0.564686E-01_JPRB, 0.526162E-01_JPRB, 0.489616E-01_JPRB, 0.455547E-01_JPRB &
  &, 0.423121E-01_JPRB, 0.392477E-01_JPRB, 0.364106E-01_JPRB &
  &, 0.337098E-01_JPRB, 0.311925E-01_JPRB, 0.288350E-01_JPRB, 0.266112E-01_JPRB &
  &, 0.245310E-01_JPRB, 0.226045E-01_JPRB, 0.208027E-01_JPRB &
  &, 0.191340E-01_JPRB, 0.175665E-01_JPRB, 0.161073E-01_JPRB, 0.147633E-01_JPRB &
  &, 0.135421E-01_JPRB, 0.123638E-01_JPRB, 0.113206E-01_JPRB &
  &, 0.103302E-01_JPRB, 0.939634E-02_JPRB, 0.856905E-02_JPRB, 0.780726E-02_JPRB &
  &, 0.706719E-02_JPRB, 0.644746E-02_JPRB, 0.585601E-02_JPRB &
  &, 0.529477E-02_JPRB, 0.476569E-02_JPRB, 0.432210E-02_JPRB, 0.391619E-02_JPRB &
  &, 0.355005E-02_JPRB, 0.317219E-02_JPRB, 0.283685E-02_JPRB &
  &, 0.254618E-02_JPRB, 0.230240E-02_JPRB, 0.205105E-02_JPRB, 0.184954E-02_JPRB &
  &, 0.164188E-02_JPRB, 0.148708E-02_JPRB, 0.132760E-02_JPRB &
  &, 0.116338E-02_JPRB, 0.105591E-02_JPRB, 0.945241E-03_JPRB, 0.831352E-03_JPRB &
  &, 0.714202E-03_JPRB, 0.658618E-03_JPRB, 0.601400E-03_JPRB/)
XCW( 479, :) = (/ &
  &  0.991291E+00_JPRB, 0.988087E+00_JPRB, 0.984471E+00_JPRB, 0.980451E+00_JPRB &
  &, 0.976027E+00_JPRB, 0.971202E+00_JPRB, 0.965977E+00_JPRB &
  &, 0.960358E+00_JPRB, 0.954345E+00_JPRB, 0.947944E+00_JPRB, 0.941157E+00_JPRB &
  &, 0.933989E+00_JPRB, 0.926445E+00_JPRB, 0.918528E+00_JPRB &
  &, 0.910244E+00_JPRB, 0.901599E+00_JPRB, 0.892599E+00_JPRB, 0.883248E+00_JPRB &
  &, 0.873555E+00_JPRB, 0.863526E+00_JPRB, 0.853167E+00_JPRB &
  &, 0.842493E+00_JPRB, 0.831504E+00_JPRB, 0.820208E+00_JPRB, 0.808629E+00_JPRB &
  &, 0.796765E+00_JPRB, 0.784626E+00_JPRB, 0.772230E+00_JPRB &
  &, 0.759582E+00_JPRB, 0.746699E+00_JPRB, 0.733591E+00_JPRB, 0.720272E+00_JPRB &
  &, 0.706756E+00_JPRB, 0.693053E+00_JPRB, 0.679185E+00_JPRB &
  &, 0.665164E+00_JPRB, 0.650997E+00_JPRB, 0.636713E+00_JPRB, 0.622322E+00_JPRB &
  &, 0.607848E+00_JPRB, 0.593283E+00_JPRB, 0.578669E+00_JPRB &
  &, 0.564014E+00_JPRB, 0.549341E+00_JPRB, 0.534653E+00_JPRB, 0.519976E+00_JPRB &
  &, 0.505324E+00_JPRB, 0.490717E+00_JPRB, 0.476158E+00_JPRB &
  &, 0.461691E+00_JPRB, 0.447297E+00_JPRB, 0.433021E+00_JPRB, 0.418868E+00_JPRB &
  &, 0.404844E+00_JPRB, 0.390982E+00_JPRB, 0.377271E+00_JPRB &
  &, 0.363745E+00_JPRB, 0.350420E+00_JPRB, 0.337282E+00_JPRB, 0.324380E+00_JPRB &
  &, 0.311678E+00_JPRB, 0.299242E+00_JPRB, 0.287032E+00_JPRB &
  &, 0.275077E+00_JPRB, 0.263405E+00_JPRB, 0.251990E+00_JPRB, 0.240856E+00_JPRB &
  &, 0.229990E+00_JPRB, 0.219435E+00_JPRB, 0.209153E+00_JPRB &
  &, 0.199187E+00_JPRB, 0.189515E+00_JPRB, 0.180132E+00_JPRB, 0.171056E+00_JPRB &
  &, 0.162280E+00_JPRB, 0.153818E+00_JPRB, 0.145660E+00_JPRB &
  &, 0.137792E+00_JPRB, 0.130224E+00_JPRB, 0.122964E+00_JPRB, 0.115993E+00_JPRB &
  &, 0.109289E+00_JPRB, 0.102881E+00_JPRB, 0.967705E-01_JPRB &
  &, 0.909035E-01_JPRB, 0.853330E-01_JPRB, 0.800280E-01_JPRB, 0.749543E-01_JPRB &
  &, 0.701338E-01_JPRB, 0.655888E-01_JPRB, 0.612492E-01_JPRB &
  &, 0.571336E-01_JPRB, 0.532609E-01_JPRB, 0.495850E-01_JPRB, 0.461223E-01_JPRB &
  &, 0.428558E-01_JPRB, 0.397663E-01_JPRB, 0.369030E-01_JPRB &
  &, 0.341748E-01_JPRB, 0.316291E-01_JPRB, 0.292420E-01_JPRB, 0.269874E-01_JPRB &
  &, 0.249135E-01_JPRB, 0.229545E-01_JPRB, 0.211189E-01_JPRB &
  &, 0.194153E-01_JPRB, 0.178523E-01_JPRB, 0.163977E-01_JPRB, 0.150163E-01_JPRB &
  &, 0.137562E-01_JPRB, 0.125813E-01_JPRB, 0.114973E-01_JPRB &
  &, 0.105097E-01_JPRB, 0.957860E-02_JPRB, 0.875411E-02_JPRB, 0.794817E-02_JPRB &
  &, 0.721024E-02_JPRB, 0.654426E-02_JPRB, 0.595426E-02_JPRB &
  &, 0.539448E-02_JPRB, 0.486687E-02_JPRB, 0.442477E-02_JPRB, 0.396827E-02_JPRB &
  &, 0.360288E-02_JPRB, 0.322579E-02_JPRB, 0.294557E-02_JPRB &
  &, 0.260131E-02_JPRB, 0.235831E-02_JPRB, 0.210775E-02_JPRB, 0.190703E-02_JPRB &
  &, 0.170016E-02_JPRB, 0.154616E-02_JPRB, 0.132760E-02_JPRB &
  &, 0.122409E-02_JPRB, 0.105591E-02_JPRB, 0.945241E-03_JPRB, 0.831352E-03_JPRB &
  &, 0.778220E-03_JPRB, 0.658618E-03_JPRB, 0.601400E-03_JPRB/)
XCW( 480, :) = (/ &
  &  0.991543E+00_JPRB, 0.988398E+00_JPRB, 0.984845E+00_JPRB, 0.980886E+00_JPRB &
  &, 0.976522E+00_JPRB, 0.971757E+00_JPRB, 0.966592E+00_JPRB &
  &, 0.961032E+00_JPRB, 0.955078E+00_JPRB, 0.948734E+00_JPRB, 0.942005E+00_JPRB &
  &, 0.934893E+00_JPRB, 0.927405E+00_JPRB, 0.919541E+00_JPRB &
  &, 0.911312E+00_JPRB, 0.902719E+00_JPRB, 0.893771E+00_JPRB, 0.884471E+00_JPRB &
  &, 0.874828E+00_JPRB, 0.864846E+00_JPRB, 0.854539E+00_JPRB &
  &, 0.843905E+00_JPRB, 0.832962E+00_JPRB, 0.821718E+00_JPRB, 0.810174E+00_JPRB &
  &, 0.798351E+00_JPRB, 0.786250E+00_JPRB, 0.773890E+00_JPRB &
  &, 0.761279E+00_JPRB, 0.748430E+00_JPRB, 0.735353E+00_JPRB, 0.722065E+00_JPRB &
  &, 0.708577E+00_JPRB, 0.694907E+00_JPRB, 0.681063E+00_JPRB &
  &, 0.667062E+00_JPRB, 0.652923E+00_JPRB, 0.638659E+00_JPRB, 0.624287E+00_JPRB &
  &, 0.609821E+00_JPRB, 0.595275E+00_JPRB, 0.580668E+00_JPRB &
  &, 0.566029E+00_JPRB, 0.551350E+00_JPRB, 0.536678E+00_JPRB, 0.522003E+00_JPRB &
  &, 0.507340E+00_JPRB, 0.492732E+00_JPRB, 0.478184E+00_JPRB &
  &, 0.463702E+00_JPRB, 0.449302E+00_JPRB, 0.435019E+00_JPRB, 0.420844E+00_JPRB &
  &, 0.406824E+00_JPRB, 0.392935E+00_JPRB, 0.379210E+00_JPRB &
  &, 0.365666E+00_JPRB, 0.352323E+00_JPRB, 0.339164E+00_JPRB, 0.326222E+00_JPRB &
  &, 0.313512E+00_JPRB, 0.301030E+00_JPRB, 0.288807E+00_JPRB &
  &, 0.276819E+00_JPRB, 0.265112E+00_JPRB, 0.253658E+00_JPRB, 0.242483E+00_JPRB &
  &, 0.231593E+00_JPRB, 0.220992E+00_JPRB, 0.210681E+00_JPRB &
  &, 0.200685E+00_JPRB, 0.190957E+00_JPRB, 0.181539E+00_JPRB, 0.172447E+00_JPRB &
  &, 0.163631E+00_JPRB, 0.155127E+00_JPRB, 0.146923E+00_JPRB &
  &, 0.139008E+00_JPRB, 0.131415E+00_JPRB, 0.124102E+00_JPRB, 0.117076E+00_JPRB &
  &, 0.110341E+00_JPRB, 0.103899E+00_JPRB, 0.977542E-01_JPRB &
  &, 0.918503E-01_JPRB, 0.862410E-01_JPRB, 0.808664E-01_JPRB, 0.757788E-01_JPRB &
  &, 0.709436E-01_JPRB, 0.663219E-01_JPRB, 0.619646E-01_JPRB &
  &, 0.578302E-01_JPRB, 0.539056E-01_JPRB, 0.502083E-01_JPRB, 0.466899E-01_JPRB &
  &, 0.433994E-01_JPRB, 0.403194E-01_JPRB, 0.373954E-01_JPRB &
  &, 0.346399E-01_JPRB, 0.320658E-01_JPRB, 0.296490E-01_JPRB, 0.274013E-01_JPRB &
  &, 0.252578E-01_JPRB, 0.233045E-01_JPRB, 0.214747E-01_JPRB &
  &, 0.197367E-01_JPRB, 0.181382E-01_JPRB, 0.166466E-01_JPRB, 0.152692E-01_JPRB &
  &, 0.140131E-01_JPRB, 0.127988E-01_JPRB, 0.117182E-01_JPRB &
  &, 0.106891E-01_JPRB, 0.976086E-02_JPRB, 0.889290E-02_JPRB, 0.808909E-02_JPRB &
  &, 0.735329E-02_JPRB, 0.668947E-02_JPRB, 0.605251E-02_JPRB &
  &, 0.549419E-02_JPRB, 0.496806E-02_JPRB, 0.452744E-02_JPRB, 0.407244E-02_JPRB &
  &, 0.365572E-02_JPRB, 0.333298E-02_JPRB, 0.299993E-02_JPRB &
  &, 0.271158E-02_JPRB, 0.241422E-02_JPRB, 0.216445E-02_JPRB, 0.196451E-02_JPRB &
  &, 0.175844E-02_JPRB, 0.154616E-02_JPRB, 0.138749E-02_JPRB &
  &, 0.122409E-02_JPRB, 0.111743E-02_JPRB, 0.100759E-02_JPRB, 0.894533E-03_JPRB &
  &, 0.778220E-03_JPRB, 0.658618E-03_JPRB, 0.601400E-03_JPRB/)
XCW( 481, :) = (/ &
  &  0.991793E+00_JPRB, 0.988710E+00_JPRB, 0.985217E+00_JPRB, 0.981320E+00_JPRB &
  &, 0.977018E+00_JPRB, 0.972313E+00_JPRB, 0.967208E+00_JPRB &
  &, 0.961705E+00_JPRB, 0.955810E+00_JPRB, 0.949525E+00_JPRB, 0.942853E+00_JPRB &
  &, 0.935797E+00_JPRB, 0.928364E+00_JPRB, 0.920556E+00_JPRB &
  &, 0.912381E+00_JPRB, 0.903841E+00_JPRB, 0.894944E+00_JPRB, 0.885695E+00_JPRB &
  &, 0.876102E+00_JPRB, 0.866169E+00_JPRB, 0.855907E+00_JPRB &
  &, 0.845324E+00_JPRB, 0.834424E+00_JPRB, 0.823221E+00_JPRB, 0.811723E+00_JPRB &
  &, 0.799936E+00_JPRB, 0.787878E+00_JPRB, 0.775554E+00_JPRB &
  &, 0.762980E+00_JPRB, 0.750165E+00_JPRB, 0.737119E+00_JPRB, 0.723863E+00_JPRB &
  &, 0.710406E+00_JPRB, 0.696761E+00_JPRB, 0.682941E+00_JPRB &
  &, 0.668968E+00_JPRB, 0.654850E+00_JPRB, 0.640605E+00_JPRB, 0.626242E+00_JPRB &
  &, 0.611795E+00_JPRB, 0.597267E+00_JPRB, 0.582677E+00_JPRB &
  &, 0.568034E+00_JPRB, 0.553371E+00_JPRB, 0.538702E+00_JPRB, 0.524030E+00_JPRB &
  &, 0.509381E+00_JPRB, 0.494761E+00_JPRB, 0.480211E+00_JPRB &
  &, 0.465725E+00_JPRB, 0.451321E+00_JPRB, 0.437018E+00_JPRB, 0.422848E+00_JPRB &
  &, 0.408804E+00_JPRB, 0.394903E+00_JPRB, 0.381163E+00_JPRB &
  &, 0.367604E+00_JPRB, 0.354226E+00_JPRB, 0.341046E+00_JPRB, 0.328081E+00_JPRB &
  &, 0.315345E+00_JPRB, 0.302835E+00_JPRB, 0.290582E+00_JPRB &
  &, 0.278579E+00_JPRB, 0.266818E+00_JPRB, 0.255345E+00_JPRB, 0.244130E+00_JPRB &
  &, 0.233216E+00_JPRB, 0.222589E+00_JPRB, 0.212230E+00_JPRB &
  &, 0.202182E+00_JPRB, 0.192421E+00_JPRB, 0.182968E+00_JPRB, 0.173816E+00_JPRB &
  &, 0.164982E+00_JPRB, 0.156435E+00_JPRB, 0.148187E+00_JPRB &
  &, 0.140249E+00_JPRB, 0.132581E+00_JPRB, 0.125241E+00_JPRB, 0.118186E+00_JPRB &
  &, 0.111419E+00_JPRB, 0.104945E+00_JPRB, 0.987379E-01_JPRB &
  &, 0.927971E-01_JPRB, 0.871490E-01_JPRB, 0.817625E-01_JPRB, 0.766034E-01_JPRB &
  &, 0.717234E-01_JPRB, 0.670855E-01_JPRB, 0.626799E-01_JPRB &
  &, 0.584952E-01_JPRB, 0.545502E-01_JPRB, 0.508317E-01_JPRB, 0.472910E-01_JPRB &
  &, 0.439770E-01_JPRB, 0.408380E-01_JPRB, 0.378878E-01_JPRB &
  &, 0.351050E-01_JPRB, 0.325024E-01_JPRB, 0.300561E-01_JPRB, 0.277776E-01_JPRB &
  &, 0.256403E-01_JPRB, 0.236545E-01_JPRB, 0.217909E-01_JPRB &
  &, 0.200581E-01_JPRB, 0.184240E-01_JPRB, 0.169370E-01_JPRB, 0.155221E-01_JPRB &
  &, 0.142272E-01_JPRB, 0.130163E-01_JPRB, 0.118949E-01_JPRB &
  &, 0.108686E-01_JPRB, 0.994312E-02_JPRB, 0.907796E-02_JPRB, 0.823000E-02_JPRB &
  &, 0.749634E-02_JPRB, 0.683467E-02_JPRB, 0.619989E-02_JPRB &
  &, 0.559391E-02_JPRB, 0.506924E-02_JPRB, 0.457877E-02_JPRB, 0.417660E-02_JPRB &
  &, 0.376139E-02_JPRB, 0.338658E-02_JPRB, 0.305429E-02_JPRB &
  &, 0.276671E-02_JPRB, 0.247013E-02_JPRB, 0.222114E-02_JPRB, 0.196451E-02_JPRB &
  &, 0.175844E-02_JPRB, 0.160524E-02_JPRB, 0.144738E-02_JPRB &
  &, 0.128479E-02_JPRB, 0.111743E-02_JPRB, 0.100759E-02_JPRB, 0.894533E-03_JPRB &
  &, 0.778220E-03_JPRB, 0.723479E-03_JPRB, 0.601400E-03_JPRB/)
XCW( 482, :) = (/ &
  &  0.992041E+00_JPRB, 0.989022E+00_JPRB, 0.985591E+00_JPRB, 0.981755E+00_JPRB &
  &, 0.977512E+00_JPRB, 0.972868E+00_JPRB, 0.967823E+00_JPRB &
  &, 0.962381E+00_JPRB, 0.956544E+00_JPRB, 0.950316E+00_JPRB, 0.943701E+00_JPRB &
  &, 0.936703E+00_JPRB, 0.929324E+00_JPRB, 0.921572E+00_JPRB &
  &, 0.913449E+00_JPRB, 0.904964E+00_JPRB, 0.896118E+00_JPRB, 0.886920E+00_JPRB &
  &, 0.877376E+00_JPRB, 0.867492E+00_JPRB, 0.857279E+00_JPRB &
  &, 0.846740E+00_JPRB, 0.835886E+00_JPRB, 0.824727E+00_JPRB, 0.813272E+00_JPRB &
  &, 0.801526E+00_JPRB, 0.789506E+00_JPRB, 0.777221E+00_JPRB &
  &, 0.764681E+00_JPRB, 0.751900E+00_JPRB, 0.738889E+00_JPRB, 0.725665E+00_JPRB &
  &, 0.712236E+00_JPRB, 0.698619E+00_JPRB, 0.684823E+00_JPRB &
  &, 0.670875E+00_JPRB, 0.656776E+00_JPRB, 0.642551E+00_JPRB, 0.628207E+00_JPRB &
  &, 0.613778E+00_JPRB, 0.599258E+00_JPRB, 0.584686E+00_JPRB &
  &, 0.570061E+00_JPRB, 0.555403E+00_JPRB, 0.540726E+00_JPRB, 0.526057E+00_JPRB &
  &, 0.511409E+00_JPRB, 0.496801E+00_JPRB, 0.482238E+00_JPRB &
  &, 0.467749E+00_JPRB, 0.453340E+00_JPRB, 0.439030E+00_JPRB, 0.424838E+00_JPRB &
  &, 0.410784E+00_JPRB, 0.396870E+00_JPRB, 0.383117E+00_JPRB &
  &, 0.369525E+00_JPRB, 0.356145E+00_JPRB, 0.342945E+00_JPRB, 0.329956E+00_JPRB &
  &, 0.317195E+00_JPRB, 0.304658E+00_JPRB, 0.292374E+00_JPRB &
  &, 0.280321E+00_JPRB, 0.268543E+00_JPRB, 0.257032E+00_JPRB, 0.245796E+00_JPRB &
  &, 0.234839E+00_JPRB, 0.224166E+00_JPRB, 0.213779E+00_JPRB &
  &, 0.203700E+00_JPRB, 0.193907E+00_JPRB, 0.184419E+00_JPRB, 0.175230E+00_JPRB &
  &, 0.166333E+00_JPRB, 0.157744E+00_JPRB, 0.149451E+00_JPRB &
  &, 0.141465E+00_JPRB, 0.133797E+00_JPRB, 0.126405E+00_JPRB, 0.119295E+00_JPRB &
  &, 0.112497E+00_JPRB, 0.105964E+00_JPRB, 0.997216E-01_JPRB &
  &, 0.937440E-01_JPRB, 0.880569E-01_JPRB, 0.826298E-01_JPRB, 0.774574E-01_JPRB &
  &, 0.725332E-01_JPRB, 0.678491E-01_JPRB, 0.634264E-01_JPRB &
  &, 0.592235E-01_JPRB, 0.552272E-01_JPRB, 0.514551E-01_JPRB, 0.478920E-01_JPRB &
  &, 0.445547E-01_JPRB, 0.413911E-01_JPRB, 0.383802E-01_JPRB &
  &, 0.356058E-01_JPRB, 0.329754E-01_JPRB, 0.305001E-01_JPRB, 0.281914E-01_JPRB &
  &, 0.260229E-01_JPRB, 0.240045E-01_JPRB, 0.221072E-01_JPRB &
  &, 0.203795E-01_JPRB, 0.187098E-01_JPRB, 0.171860E-01_JPRB, 0.157750E-01_JPRB &
  &, 0.144842E-01_JPRB, 0.132338E-01_JPRB, 0.121158E-01_JPRB &
  &, 0.110930E-01_JPRB, 0.101254E-01_JPRB, 0.921676E-02_JPRB, 0.841789E-02_JPRB &
  &, 0.763939E-02_JPRB, 0.693148E-02_JPRB, 0.629815E-02_JPRB &
  &, 0.574347E-02_JPRB, 0.517043E-02_JPRB, 0.468144E-02_JPRB, 0.422869E-02_JPRB &
  &, 0.381423E-02_JPRB, 0.344017E-02_JPRB, 0.310866E-02_JPRB &
  &, 0.282185E-02_JPRB, 0.252605E-02_JPRB, 0.227784E-02_JPRB, 0.202200E-02_JPRB &
  &, 0.181672E-02_JPRB, 0.160524E-02_JPRB, 0.144738E-02_JPRB &
  &, 0.128479E-02_JPRB, 0.117895E-02_JPRB, 0.100759E-02_JPRB, 0.894533E-03_JPRB &
  &, 0.842239E-03_JPRB, 0.723479E-03_JPRB, 0.667111E-03_JPRB/)
XCW( 483, :) = (/ &
  &  0.992293E+00_JPRB, 0.989334E+00_JPRB, 0.985965E+00_JPRB, 0.982189E+00_JPRB &
  &, 0.978008E+00_JPRB, 0.973424E+00_JPRB, 0.968438E+00_JPRB &
  &, 0.963056E+00_JPRB, 0.957277E+00_JPRB, 0.951108E+00_JPRB, 0.944549E+00_JPRB &
  &, 0.937608E+00_JPRB, 0.930286E+00_JPRB, 0.922588E+00_JPRB &
  &, 0.914520E+00_JPRB, 0.906087E+00_JPRB, 0.897294E+00_JPRB, 0.888148E+00_JPRB &
  &, 0.878653E+00_JPRB, 0.868818E+00_JPRB, 0.858650E+00_JPRB &
  &, 0.848159E+00_JPRB, 0.837351E+00_JPRB, 0.826237E+00_JPRB, 0.814821E+00_JPRB &
  &, 0.803119E+00_JPRB, 0.791138E+00_JPRB, 0.778889E+00_JPRB &
  &, 0.766386E+00_JPRB, 0.753639E+00_JPRB, 0.740663E+00_JPRB, 0.727466E+00_JPRB &
  &, 0.714066E+00_JPRB, 0.700477E+00_JPRB, 0.686710E+00_JPRB &
  &, 0.672782E+00_JPRB, 0.658703E+00_JPRB, 0.644506E+00_JPRB, 0.630182E+00_JPRB &
  &, 0.615762E+00_JPRB, 0.601261E+00_JPRB, 0.586696E+00_JPRB &
  &, 0.572076E+00_JPRB, 0.557435E+00_JPRB, 0.542763E+00_JPRB, 0.528096E+00_JPRB &
  &, 0.513450E+00_JPRB, 0.498842E+00_JPRB, 0.484277E+00_JPRB &
  &, 0.469772E+00_JPRB, 0.455359E+00_JPRB, 0.441043E+00_JPRB, 0.426843E+00_JPRB &
  &, 0.412778E+00_JPRB, 0.398853E+00_JPRB, 0.385070E+00_JPRB &
  &, 0.371478E+00_JPRB, 0.358063E+00_JPRB, 0.344843E+00_JPRB, 0.331832E+00_JPRB &
  &, 0.319046E+00_JPRB, 0.306481E+00_JPRB, 0.294167E+00_JPRB &
  &, 0.282099E+00_JPRB, 0.270287E+00_JPRB, 0.258739E+00_JPRB, 0.247462E+00_JPRB &
  &, 0.236481E+00_JPRB, 0.225763E+00_JPRB, 0.215348E+00_JPRB &
  &, 0.205218E+00_JPRB, 0.195393E+00_JPRB, 0.185847E+00_JPRB, 0.176621E+00_JPRB &
  &, 0.167707E+00_JPRB, 0.159076E+00_JPRB, 0.150738E+00_JPRB &
  &, 0.142730E+00_JPRB, 0.134987E+00_JPRB, 0.127568E+00_JPRB, 0.120430E+00_JPRB &
  &, 0.113576E+00_JPRB, 0.107009E+00_JPRB, 0.100733E+00_JPRB &
  &, 0.947186E-01_JPRB, 0.889933E-01_JPRB, 0.835259E-01_JPRB, 0.783113E-01_JPRB &
  &, 0.733430E-01_JPRB, 0.686432E-01_JPRB, 0.641417E-01_JPRB &
  &, 0.599201E-01_JPRB, 0.559041E-01_JPRB, 0.520785E-01_JPRB, 0.484930E-01_JPRB &
  &, 0.450983E-01_JPRB, 0.419097E-01_JPRB, 0.389077E-01_JPRB &
  &, 0.360709E-01_JPRB, 0.334120E-01_JPRB, 0.309441E-01_JPRB, 0.286053E-01_JPRB &
  &, 0.264054E-01_JPRB, 0.243545E-01_JPRB, 0.224629E-01_JPRB &
  &, 0.206607E-01_JPRB, 0.190364E-01_JPRB, 0.174764E-01_JPRB, 0.160279E-01_JPRB &
  &, 0.146983E-01_JPRB, 0.134948E-01_JPRB, 0.123368E-01_JPRB &
  &, 0.112725E-01_JPRB, 0.103076E-01_JPRB, 0.940182E-02_JPRB, 0.855880E-02_JPRB &
  &, 0.778244E-02_JPRB, 0.707668E-02_JPRB, 0.644552E-02_JPRB &
  &, 0.584319E-02_JPRB, 0.527161E-02_JPRB, 0.478411E-02_JPRB, 0.433285E-02_JPRB &
  &, 0.391990E-02_JPRB, 0.354737E-02_JPRB, 0.316302E-02_JPRB &
  &, 0.287698E-02_JPRB, 0.258196E-02_JPRB, 0.233453E-02_JPRB, 0.207948E-02_JPRB &
  &, 0.187501E-02_JPRB, 0.166433E-02_JPRB, 0.150727E-02_JPRB &
  &, 0.134550E-02_JPRB, 0.117895E-02_JPRB, 0.106994E-02_JPRB, 0.957714E-03_JPRB &
  &, 0.842239E-03_JPRB, 0.723479E-03_JPRB, 0.667111E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART69',1,ZHOOK_HANDLE)
END SUBROUTINE PART69

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART70

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART70',0,ZHOOK_HANDLE)

XCW( 484, :) = (/ &
  &  0.992543E+00_JPRB, 0.989646E+00_JPRB, 0.986338E+00_JPRB, 0.982624E+00_JPRB &
  &, 0.978504E+00_JPRB, 0.973980E+00_JPRB, 0.969054E+00_JPRB &
  &, 0.963730E+00_JPRB, 0.958011E+00_JPRB, 0.951899E+00_JPRB, 0.945399E+00_JPRB &
  &, 0.938514E+00_JPRB, 0.931247E+00_JPRB, 0.923605E+00_JPRB &
  &, 0.915591E+00_JPRB, 0.907211E+00_JPRB, 0.898470E+00_JPRB, 0.889375E+00_JPRB &
  &, 0.879931E+00_JPRB, 0.870144E+00_JPRB, 0.860025E+00_JPRB &
  &, 0.849581E+00_JPRB, 0.838816E+00_JPRB, 0.827746E+00_JPRB, 0.816373E+00_JPRB &
  &, 0.804712E+00_JPRB, 0.792769E+00_JPRB, 0.780561E+00_JPRB &
  &, 0.768094E+00_JPRB, 0.755382E+00_JPRB, 0.742437E+00_JPRB, 0.729272E+00_JPRB &
  &, 0.715904E+00_JPRB, 0.702344E+00_JPRB, 0.688602E+00_JPRB &
  &, 0.674698E+00_JPRB, 0.660639E+00_JPRB, 0.646462E+00_JPRB, 0.632157E+00_JPRB &
  &, 0.617756E+00_JPRB, 0.603263E+00_JPRB, 0.588716E+00_JPRB &
  &, 0.574103E+00_JPRB, 0.559467E+00_JPRB, 0.544810E+00_JPRB, 0.530147E+00_JPRB &
  &, 0.515503E+00_JPRB, 0.500883E+00_JPRB, 0.486317E+00_JPRB &
  &, 0.471822E+00_JPRB, 0.457391E+00_JPRB, 0.443069E+00_JPRB, 0.428861E+00_JPRB &
  &, 0.414772E+00_JPRB, 0.400835E+00_JPRB, 0.387038E+00_JPRB &
  &, 0.373430E+00_JPRB, 0.359982E+00_JPRB, 0.346741E+00_JPRB, 0.333707E+00_JPRB &
  &, 0.320896E+00_JPRB, 0.308321E+00_JPRB, 0.295960E+00_JPRB &
  &, 0.283860E+00_JPRB, 0.272030E+00_JPRB, 0.260445E+00_JPRB, 0.249147E+00_JPRB &
  &, 0.238104E+00_JPRB, 0.227360E+00_JPRB, 0.216918E+00_JPRB &
  &, 0.206758E+00_JPRB, 0.196879E+00_JPRB, 0.187320E+00_JPRB, 0.178034E+00_JPRB &
  &, 0.169081E+00_JPRB, 0.160408E+00_JPRB, 0.152049E+00_JPRB &
  &, 0.143970E+00_JPRB, 0.136203E+00_JPRB, 0.128732E+00_JPRB, 0.121539E+00_JPRB &
  &, 0.114654E+00_JPRB, 0.108055E+00_JPRB, 0.101744E+00_JPRB &
  &, 0.956933E-01_JPRB, 0.899013E-01_JPRB, 0.843932E-01_JPRB, 0.791653E-01_JPRB &
  &, 0.741528E-01_JPRB, 0.694069E-01_JPRB, 0.648881E-01_JPRB &
  &, 0.606167E-01_JPRB, 0.565810E-01_JPRB, 0.527347E-01_JPRB, 0.491275E-01_JPRB &
  &, 0.457099E-01_JPRB, 0.424628E-01_JPRB, 0.394352E-01_JPRB &
  &, 0.365717E-01_JPRB, 0.338850E-01_JPRB, 0.313882E-01_JPRB, 0.290192E-01_JPRB &
  &, 0.267880E-01_JPRB, 0.247434E-01_JPRB, 0.228187E-01_JPRB &
  &, 0.209821E-01_JPRB, 0.193222E-01_JPRB, 0.177668E-01_JPRB, 0.163230E-01_JPRB &
  &, 0.149552E-01_JPRB, 0.137123E-01_JPRB, 0.125577E-01_JPRB &
  &, 0.114519E-01_JPRB, 0.104899E-01_JPRB, 0.954061E-02_JPRB, 0.869972E-02_JPRB &
  &, 0.792550E-02_JPRB, 0.722189E-02_JPRB, 0.654378E-02_JPRB &
  &, 0.594290E-02_JPRB, 0.542339E-02_JPRB, 0.488678E-02_JPRB, 0.443702E-02_JPRB &
  &, 0.402558E-02_JPRB, 0.360096E-02_JPRB, 0.327174E-02_JPRB &
  &, 0.293212E-02_JPRB, 0.263787E-02_JPRB, 0.239123E-02_JPRB, 0.213697E-02_JPRB &
  &, 0.193329E-02_JPRB, 0.172341E-02_JPRB, 0.150727E-02_JPRB &
  &, 0.134550E-02_JPRB, 0.124048E-02_JPRB, 0.106994E-02_JPRB, 0.957714E-03_JPRB &
  &, 0.842239E-03_JPRB, 0.788341E-03_JPRB, 0.667111E-03_JPRB/)
XCW( 485, :) = (/ &
  &  0.992793E+00_JPRB, 0.989958E+00_JPRB, 0.986711E+00_JPRB, 0.983058E+00_JPRB &
  &, 0.979000E+00_JPRB, 0.974536E+00_JPRB, 0.969670E+00_JPRB &
  &, 0.964406E+00_JPRB, 0.958745E+00_JPRB, 0.952692E+00_JPRB, 0.946249E+00_JPRB &
  &, 0.939419E+00_JPRB, 0.932210E+00_JPRB, 0.924622E+00_JPRB &
  &, 0.916663E+00_JPRB, 0.908336E+00_JPRB, 0.899647E+00_JPRB, 0.890603E+00_JPRB &
  &, 0.881208E+00_JPRB, 0.871473E+00_JPRB, 0.861400E+00_JPRB &
  &, 0.851004E+00_JPRB, 0.840285E+00_JPRB, 0.829256E+00_JPRB, 0.817926E+00_JPRB &
  &, 0.806305E+00_JPRB, 0.794405E+00_JPRB, 0.782232E+00_JPRB &
  &, 0.769803E+00_JPRB, 0.757125E+00_JPRB, 0.744216E+00_JPRB, 0.731082E+00_JPRB &
  &, 0.717743E+00_JPRB, 0.704211E+00_JPRB, 0.690493E+00_JPRB &
  &, 0.676614E+00_JPRB, 0.662584E+00_JPRB, 0.648417E+00_JPRB, 0.634132E+00_JPRB &
  &, 0.619750E+00_JPRB, 0.605276E+00_JPRB, 0.590736E+00_JPRB &
  &, 0.576140E+00_JPRB, 0.561510E+00_JPRB, 0.546846E+00_JPRB, 0.532198E+00_JPRB &
  &, 0.517556E+00_JPRB, 0.502936E+00_JPRB, 0.488369E+00_JPRB &
  &, 0.473859E+00_JPRB, 0.459437E+00_JPRB, 0.445109E+00_JPRB, 0.430879E+00_JPRB &
  &, 0.416781E+00_JPRB, 0.402817E+00_JPRB, 0.389022E+00_JPRB &
  &, 0.375383E+00_JPRB, 0.361933E+00_JPRB, 0.348672E+00_JPRB, 0.335599E+00_JPRB &
  &, 0.322763E+00_JPRB, 0.310161E+00_JPRB, 0.297771E+00_JPRB &
  &, 0.285656E+00_JPRB, 0.273774E+00_JPRB, 0.262170E+00_JPRB, 0.250832E+00_JPRB &
  &, 0.239767E+00_JPRB, 0.228978E+00_JPRB, 0.218487E+00_JPRB &
  &, 0.208297E+00_JPRB, 0.198386E+00_JPRB, 0.188771E+00_JPRB, 0.179470E+00_JPRB &
  &, 0.170455E+00_JPRB, 0.161740E+00_JPRB, 0.153337E+00_JPRB &
  &, 0.145235E+00_JPRB, 0.137418E+00_JPRB, 0.129921E+00_JPRB, 0.122700E+00_JPRB &
  &, 0.115759E+00_JPRB, 0.109127E+00_JPRB, 0.102755E+00_JPRB &
  &, 0.966679E-01_JPRB, 0.908661E-01_JPRB, 0.853182E-01_JPRB, 0.800193E-01_JPRB &
  &, 0.749926E-01_JPRB, 0.702010E-01_JPRB, 0.656657E-01_JPRB &
  &, 0.613450E-01_JPRB, 0.572579E-01_JPRB, 0.533908E-01_JPRB, 0.497285E-01_JPRB &
  &, 0.462875E-01_JPRB, 0.430159E-01_JPRB, 0.399628E-01_JPRB &
  &, 0.370726E-01_JPRB, 0.343581E-01_JPRB, 0.318322E-01_JPRB, 0.294331E-01_JPRB &
  &, 0.272088E-01_JPRB, 0.250934E-01_JPRB, 0.231349E-01_JPRB &
  &, 0.213437E-01_JPRB, 0.196488E-01_JPRB, 0.180572E-01_JPRB, 0.165759E-01_JPRB &
  &, 0.152121E-01_JPRB, 0.139298E-01_JPRB, 0.127786E-01_JPRB &
  &, 0.116763E-01_JPRB, 0.106722E-01_JPRB, 0.972567E-02_JPRB, 0.888760E-02_JPRB &
  &, 0.806855E-02_JPRB, 0.736710E-02_JPRB, 0.669116E-02_JPRB &
  &, 0.609247E-02_JPRB, 0.552457E-02_JPRB, 0.498945E-02_JPRB, 0.454118E-02_JPRB &
  &, 0.407841E-02_JPRB, 0.370816E-02_JPRB, 0.332611E-02_JPRB &
  &, 0.298725E-02_JPRB, 0.269378E-02_JPRB, 0.244793E-02_JPRB, 0.219446E-02_JPRB &
  &, 0.193329E-02_JPRB, 0.178249E-02_JPRB, 0.156716E-02_JPRB &
  &, 0.140620E-02_JPRB, 0.124048E-02_JPRB, 0.113229E-02_JPRB, 0.102089E-02_JPRB &
  &, 0.906257E-03_JPRB, 0.788341E-03_JPRB, 0.667111E-03_JPRB/)
XCW( 486, :) = (/ &
  &  0.993043E+00_JPRB, 0.990267E+00_JPRB, 0.987085E+00_JPRB, 0.983494E+00_JPRB &
  &, 0.979494E+00_JPRB, 0.975092E+00_JPRB, 0.970286E+00_JPRB &
  &, 0.965081E+00_JPRB, 0.959480E+00_JPRB, 0.953484E+00_JPRB, 0.947098E+00_JPRB &
  &, 0.940326E+00_JPRB, 0.933172E+00_JPRB, 0.925640E+00_JPRB &
  &, 0.917735E+00_JPRB, 0.909461E+00_JPRB, 0.900826E+00_JPRB, 0.891832E+00_JPRB &
  &, 0.882489E+00_JPRB, 0.872802E+00_JPRB, 0.862778E+00_JPRB &
  &, 0.852426E+00_JPRB, 0.841753E+00_JPRB, 0.830769E+00_JPRB, 0.819482E+00_JPRB &
  &, 0.807902E+00_JPRB, 0.796040E+00_JPRB, 0.783907E+00_JPRB &
  &, 0.771516E+00_JPRB, 0.758872E+00_JPRB, 0.745998E+00_JPRB, 0.732897E+00_JPRB &
  &, 0.719585E+00_JPRB, 0.706078E+00_JPRB, 0.692389E+00_JPRB &
  &, 0.678530E+00_JPRB, 0.664530E+00_JPRB, 0.650383E+00_JPRB, 0.636117E+00_JPRB &
  &, 0.621744E+00_JPRB, 0.607289E+00_JPRB, 0.592757E+00_JPRB &
  &, 0.578178E+00_JPRB, 0.563554E+00_JPRB, 0.548906E+00_JPRB, 0.534248E+00_JPRB &
  &, 0.519608E+00_JPRB, 0.504990E+00_JPRB, 0.490421E+00_JPRB &
  &, 0.475909E+00_JPRB, 0.461483E+00_JPRB, 0.447135E+00_JPRB, 0.432912E+00_JPRB &
  &, 0.418790E+00_JPRB, 0.404829E+00_JPRB, 0.391006E+00_JPRB &
  &, 0.377351E+00_JPRB, 0.363867E+00_JPRB, 0.350586E+00_JPRB, 0.337508E+00_JPRB &
  &, 0.324647E+00_JPRB, 0.312001E+00_JPRB, 0.299599E+00_JPRB &
  &, 0.287434E+00_JPRB, 0.275536E+00_JPRB, 0.263895E+00_JPRB, 0.252517E+00_JPRB &
  &, 0.241429E+00_JPRB, 0.230615E+00_JPRB, 0.220077E+00_JPRB &
  &, 0.209837E+00_JPRB, 0.199893E+00_JPRB, 0.190244E+00_JPRB, 0.180906E+00_JPRB &
  &, 0.171852E+00_JPRB, 0.163095E+00_JPRB, 0.154648E+00_JPRB &
  &, 0.146499E+00_JPRB, 0.138659E+00_JPRB, 0.131110E+00_JPRB, 0.123835E+00_JPRB &
  &, 0.116863E+00_JPRB, 0.110173E+00_JPRB, 0.103793E+00_JPRB &
  &, 0.976426E-01_JPRB, 0.918024E-01_JPRB, 0.862144E-01_JPRB, 0.809027E-01_JPRB &
  &, 0.758324E-01_JPRB, 0.709952E-01_JPRB, 0.664121E-01_JPRB &
  &, 0.620733E-01_JPRB, 0.579348E-01_JPRB, 0.540470E-01_JPRB, 0.503629E-01_JPRB &
  &, 0.468651E-01_JPRB, 0.436036E-01_JPRB, 0.404903E-01_JPRB &
  &, 0.375734E-01_JPRB, 0.348311E-01_JPRB, 0.322762E-01_JPRB, 0.298470E-01_JPRB &
  &, 0.275913E-01_JPRB, 0.254823E-01_JPRB, 0.234907E-01_JPRB &
  &, 0.216651E-01_JPRB, 0.199346E-01_JPRB, 0.183476E-01_JPRB, 0.168288E-01_JPRB &
  &, 0.154691E-01_JPRB, 0.141908E-01_JPRB, 0.129995E-01_JPRB &
  &, 0.119006E-01_JPRB, 0.108544E-01_JPRB, 0.991074E-02_JPRB, 0.902852E-02_JPRB &
  &, 0.825928E-02_JPRB, 0.751230E-02_JPRB, 0.683853E-02_JPRB &
  &, 0.619218E-02_JPRB, 0.562576E-02_JPRB, 0.509211E-02_JPRB, 0.459326E-02_JPRB &
  &, 0.418409E-02_JPRB, 0.376175E-02_JPRB, 0.338047E-02_JPRB &
  &, 0.304239E-02_JPRB, 0.274969E-02_JPRB, 0.250462E-02_JPRB, 0.225194E-02_JPRB &
  &, 0.199157E-02_JPRB, 0.178249E-02_JPRB, 0.162705E-02_JPRB &
  &, 0.146690E-02_JPRB, 0.130200E-02_JPRB, 0.113229E-02_JPRB, 0.102089E-02_JPRB &
  &, 0.906257E-03_JPRB, 0.788341E-03_JPRB, 0.732822E-03_JPRB/)
XCW( 487, :) = (/ &
  &  0.993292E+00_JPRB, 0.990582E+00_JPRB, 0.987458E+00_JPRB, 0.983929E+00_JPRB &
  &, 0.979990E+00_JPRB, 0.975648E+00_JPRB, 0.970903E+00_JPRB &
  &, 0.965757E+00_JPRB, 0.960214E+00_JPRB, 0.954277E+00_JPRB, 0.947950E+00_JPRB &
  &, 0.941233E+00_JPRB, 0.934136E+00_JPRB, 0.926659E+00_JPRB &
  &, 0.918808E+00_JPRB, 0.910587E+00_JPRB, 0.902004E+00_JPRB, 0.893062E+00_JPRB &
  &, 0.883769E+00_JPRB, 0.874132E+00_JPRB, 0.864156E+00_JPRB &
  &, 0.853852E+00_JPRB, 0.843225E+00_JPRB, 0.832286E+00_JPRB, 0.821041E+00_JPRB &
  &, 0.809503E+00_JPRB, 0.797679E+00_JPRB, 0.785587E+00_JPRB &
  &, 0.773228E+00_JPRB, 0.760623E+00_JPRB, 0.747780E+00_JPRB, 0.734711E+00_JPRB &
  &, 0.721432E+00_JPRB, 0.707954E+00_JPRB, 0.694290E+00_JPRB &
  &, 0.680456E+00_JPRB, 0.666475E+00_JPRB, 0.652348E+00_JPRB, 0.638102E+00_JPRB &
  &, 0.623749E+00_JPRB, 0.609312E+00_JPRB, 0.594787E+00_JPRB &
  &, 0.580216E+00_JPRB, 0.565597E+00_JPRB, 0.550953E+00_JPRB, 0.536311E+00_JPRB &
  &, 0.521673E+00_JPRB, 0.507055E+00_JPRB, 0.492486E+00_JPRB &
  &, 0.477971E+00_JPRB, 0.463528E+00_JPRB, 0.449189E+00_JPRB, 0.434944E+00_JPRB &
  &, 0.420813E+00_JPRB, 0.406826E+00_JPRB, 0.392989E+00_JPRB &
  &, 0.379319E+00_JPRB, 0.365818E+00_JPRB, 0.352517E+00_JPRB, 0.339417E+00_JPRB &
  &, 0.326515E+00_JPRB, 0.313859E+00_JPRB, 0.301427E+00_JPRB &
  &, 0.289231E+00_JPRB, 0.277298E+00_JPRB, 0.265620E+00_JPRB, 0.254222E+00_JPRB &
  &, 0.243092E+00_JPRB, 0.232233E+00_JPRB, 0.221667E+00_JPRB &
  &, 0.211397E+00_JPRB, 0.201422E+00_JPRB, 0.191717E+00_JPRB, 0.182342E+00_JPRB &
  &, 0.173249E+00_JPRB, 0.164451E+00_JPRB, 0.155983E+00_JPRB &
  &, 0.147788E+00_JPRB, 0.139899E+00_JPRB, 0.132299E+00_JPRB, 0.124996E+00_JPRB &
  &, 0.117994E+00_JPRB, 0.111272E+00_JPRB, 0.104804E+00_JPRB &
  &, 0.986451E-01_JPRB, 0.927672E-01_JPRB, 0.871394E-01_JPRB, 0.817567E-01_JPRB &
  &, 0.766722E-01_JPRB, 0.717893E-01_JPRB, 0.671897E-01_JPRB &
  &, 0.628016E-01_JPRB, 0.586440E-01_JPRB, 0.547032E-01_JPRB, 0.509973E-01_JPRB &
  &, 0.474767E-01_JPRB, 0.441568E-01_JPRB, 0.410179E-01_JPRB &
  &, 0.380743E-01_JPRB, 0.353041E-01_JPRB, 0.327203E-01_JPRB, 0.302985E-01_JPRB &
  &, 0.280121E-01_JPRB, 0.258712E-01_JPRB, 0.238465E-01_JPRB &
  &, 0.219865E-01_JPRB, 0.202613E-01_JPRB, 0.186380E-01_JPRB, 0.171239E-01_JPRB &
  &, 0.157260E-01_JPRB, 0.144083E-01_JPRB, 0.132204E-01_JPRB &
  &, 0.120801E-01_JPRB, 0.110367E-01_JPRB, 0.100958E-01_JPRB, 0.921640E-02_JPRB &
  &, 0.840233E-02_JPRB, 0.765751E-02_JPRB, 0.693679E-02_JPRB &
  &, 0.634175E-02_JPRB, 0.572694E-02_JPRB, 0.519478E-02_JPRB, 0.469743E-02_JPRB &
  &, 0.423692E-02_JPRB, 0.386895E-02_JPRB, 0.348919E-02_JPRB &
  &, 0.315265E-02_JPRB, 0.280561E-02_JPRB, 0.256132E-02_JPRB, 0.230943E-02_JPRB &
  &, 0.204985E-02_JPRB, 0.184158E-02_JPRB, 0.162705E-02_JPRB &
  &, 0.146690E-02_JPRB, 0.130200E-02_JPRB, 0.119464E-02_JPRB, 0.102089E-02_JPRB &
  &, 0.906257E-03_JPRB, 0.853203E-03_JPRB, 0.732822E-03_JPRB/)
XCW( 488, :) = (/ &
  &  0.993543E+00_JPRB, 0.990893E+00_JPRB, 0.987833E+00_JPRB, 0.984364E+00_JPRB &
  &, 0.980486E+00_JPRB, 0.976205E+00_JPRB, 0.971519E+00_JPRB &
  &, 0.966433E+00_JPRB, 0.960949E+00_JPRB, 0.955070E+00_JPRB, 0.948801E+00_JPRB &
  &, 0.942141E+00_JPRB, 0.935100E+00_JPRB, 0.927678E+00_JPRB &
  &, 0.919881E+00_JPRB, 0.911715E+00_JPRB, 0.903184E+00_JPRB, 0.894294E+00_JPRB &
  &, 0.885051E+00_JPRB, 0.875461E+00_JPRB, 0.865534E+00_JPRB &
  &, 0.855277E+00_JPRB, 0.844697E+00_JPRB, 0.833802E+00_JPRB, 0.822601E+00_JPRB &
  &, 0.811103E+00_JPRB, 0.799322E+00_JPRB, 0.787266E+00_JPRB &
  &, 0.774949E+00_JPRB, 0.762374E+00_JPRB, 0.749567E+00_JPRB, 0.736529E+00_JPRB &
  &, 0.723279E+00_JPRB, 0.709829E+00_JPRB, 0.696195E+00_JPRB &
  &, 0.682390E+00_JPRB, 0.668430E+00_JPRB, 0.654324E+00_JPRB, 0.640097E+00_JPRB &
  &, 0.625763E+00_JPRB, 0.611335E+00_JPRB, 0.596829E+00_JPRB &
  &, 0.582265E+00_JPRB, 0.567652E+00_JPRB, 0.553024E+00_JPRB, 0.538374E+00_JPRB &
  &, 0.523738E+00_JPRB, 0.509121E+00_JPRB, 0.494552E+00_JPRB &
  &, 0.480034E+00_JPRB, 0.465587E+00_JPRB, 0.451229E+00_JPRB, 0.436977E+00_JPRB &
  &, 0.422850E+00_JPRB, 0.408838E+00_JPRB, 0.394988E+00_JPRB &
  &, 0.381303E+00_JPRB, 0.367784E+00_JPRB, 0.354464E+00_JPRB, 0.341325E+00_JPRB &
  &, 0.328416E+00_JPRB, 0.315716E+00_JPRB, 0.303255E+00_JPRB &
  &, 0.291046E+00_JPRB, 0.279079E+00_JPRB, 0.267364E+00_JPRB, 0.255927E+00_JPRB &
  &, 0.244754E+00_JPRB, 0.233870E+00_JPRB, 0.223278E+00_JPRB &
  &, 0.212958E+00_JPRB, 0.202951E+00_JPRB, 0.193211E+00_JPRB, 0.183779E+00_JPRB &
  &, 0.174669E+00_JPRB, 0.165829E+00_JPRB, 0.157295E+00_JPRB &
  &, 0.149077E+00_JPRB, 0.141140E+00_JPRB, 0.133514E+00_JPRB, 0.126157E+00_JPRB &
  &, 0.119099E+00_JPRB, 0.112345E+00_JPRB, 0.105870E+00_JPRB &
  &, 0.996476E-01_JPRB, 0.937319E-01_JPRB, 0.880645E-01_JPRB, 0.826696E-01_JPRB &
  &, 0.775120E-01_JPRB, 0.726140E-01_JPRB, 0.679672E-01_JPRB &
  &, 0.635299E-01_JPRB, 0.593531E-01_JPRB, 0.553922E-01_JPRB, 0.516317E-01_JPRB &
  &, 0.480883E-01_JPRB, 0.447445E-01_JPRB, 0.415806E-01_JPRB &
  &, 0.386109E-01_JPRB, 0.358135E-01_JPRB, 0.331643E-01_JPRB, 0.307123E-01_JPRB &
  &, 0.283947E-01_JPRB, 0.262601E-01_JPRB, 0.242418E-01_JPRB &
  &, 0.223481E-01_JPRB, 0.205879E-01_JPRB, 0.189284E-01_JPRB, 0.174189E-01_JPRB &
  &, 0.159830E-01_JPRB, 0.146693E-01_JPRB, 0.134413E-01_JPRB &
  &, 0.123045E-01_JPRB, 0.112645E-01_JPRB, 0.102809E-01_JPRB, 0.935732E-02_JPRB &
  &, 0.854538E-02_JPRB, 0.780271E-02_JPRB, 0.708416E-02_JPRB &
  &, 0.644146E-02_JPRB, 0.582813E-02_JPRB, 0.529745E-02_JPRB, 0.480159E-02_JPRB &
  &, 0.434260E-02_JPRB, 0.392254E-02_JPRB, 0.354356E-02_JPRB &
  &, 0.320779E-02_JPRB, 0.286152E-02_JPRB, 0.261801E-02_JPRB, 0.236691E-02_JPRB &
  &, 0.210813E-02_JPRB, 0.190066E-02_JPRB, 0.168694E-02_JPRB &
  &, 0.152761E-02_JPRB, 0.136353E-02_JPRB, 0.119464E-02_JPRB, 0.108408E-02_JPRB &
  &, 0.970275E-03_JPRB, 0.853203E-03_JPRB, 0.732822E-03_JPRB/)
XCW( 489, :) = (/ &
  &  0.993792E+00_JPRB, 0.991205E+00_JPRB, 0.988205E+00_JPRB, 0.984799E+00_JPRB &
  &, 0.980982E+00_JPRB, 0.976762E+00_JPRB, 0.972136E+00_JPRB &
  &, 0.967109E+00_JPRB, 0.961684E+00_JPRB, 0.955864E+00_JPRB, 0.949651E+00_JPRB &
  &, 0.943050E+00_JPRB, 0.936064E+00_JPRB, 0.928698E+00_JPRB &
  &, 0.920957E+00_JPRB, 0.912843E+00_JPRB, 0.904364E+00_JPRB, 0.895526E+00_JPRB &
  &, 0.886334E+00_JPRB, 0.876793E+00_JPRB, 0.866915E+00_JPRB &
  &, 0.856706E+00_JPRB, 0.846169E+00_JPRB, 0.835319E+00_JPRB, 0.824160E+00_JPRB &
  &, 0.812707E+00_JPRB, 0.800965E+00_JPRB, 0.788949E+00_JPRB &
  &, 0.776665E+00_JPRB, 0.764129E+00_JPRB, 0.751353E+00_JPRB, 0.738335E+00_JPRB &
  &, 0.725130E+00_JPRB, 0.711710E+00_JPRB, 0.698100E+00_JPRB &
  &, 0.684316E+00_JPRB, 0.670376E+00_JPRB, 0.656299E+00_JPRB, 0.642093E+00_JPRB &
  &, 0.627778E+00_JPRB, 0.613358E+00_JPRB, 0.598871E+00_JPRB &
  &, 0.584313E+00_JPRB, 0.569718E+00_JPRB, 0.555084E+00_JPRB, 0.540449E+00_JPRB &
  &, 0.525816E+00_JPRB, 0.511199E+00_JPRB, 0.496630E+00_JPRB &
  &, 0.482097E+00_JPRB, 0.467647E+00_JPRB, 0.453282E+00_JPRB, 0.439023E+00_JPRB &
  &, 0.424873E+00_JPRB, 0.410865E+00_JPRB, 0.397002E+00_JPRB &
  &, 0.383287E+00_JPRB, 0.369751E+00_JPRB, 0.356411E+00_JPRB, 0.343251E+00_JPRB &
  &, 0.330317E+00_JPRB, 0.317591E+00_JPRB, 0.305101E+00_JPRB &
  &, 0.292860E+00_JPRB, 0.280860E+00_JPRB, 0.269127E+00_JPRB, 0.257651E+00_JPRB &
  &, 0.246456E+00_JPRB, 0.235528E+00_JPRB, 0.224889E+00_JPRB &
  &, 0.214539E+00_JPRB, 0.204479E+00_JPRB, 0.194706E+00_JPRB, 0.185237E+00_JPRB &
  &, 0.176089E+00_JPRB, 0.167208E+00_JPRB, 0.158630E+00_JPRB &
  &, 0.150367E+00_JPRB, 0.142405E+00_JPRB, 0.134728E+00_JPRB, 0.127343E+00_JPRB &
  &, 0.120230E+00_JPRB, 0.113444E+00_JPRB, 0.106908E+00_JPRB &
  &, 0.100678E+00_JPRB, 0.946966E-01_JPRB, 0.889896E-01_JPRB, 0.835530E-01_JPRB &
  &, 0.783518E-01_JPRB, 0.734387E-01_JPRB, 0.687447E-01_JPRB &
  &, 0.642899E-01_JPRB, 0.600623E-01_JPRB, 0.560484E-01_JPRB, 0.522662E-01_JPRB &
  &, 0.486999E-01_JPRB, 0.452976E-01_JPRB, 0.421081E-01_JPRB &
  &, 0.391118E-01_JPRB, 0.362865E-01_JPRB, 0.336453E-01_JPRB, 0.311638E-01_JPRB &
  &, 0.288155E-01_JPRB, 0.266490E-01_JPRB, 0.245975E-01_JPRB &
  &, 0.226695E-01_JPRB, 0.208737E-01_JPRB, 0.192189E-01_JPRB, 0.176719E-01_JPRB &
  &, 0.162399E-01_JPRB, 0.148868E-01_JPRB, 0.136622E-01_JPRB &
  &, 0.125288E-01_JPRB, 0.114468E-01_JPRB, 0.104659E-01_JPRB, 0.954520E-02_JPRB &
  &, 0.868843E-02_JPRB, 0.794792E-02_JPRB, 0.723154E-02_JPRB &
  &, 0.659103E-02_JPRB, 0.597991E-02_JPRB, 0.540012E-02_JPRB, 0.490576E-02_JPRB &
  &, 0.444827E-02_JPRB, 0.402974E-02_JPRB, 0.365228E-02_JPRB &
  &, 0.326292E-02_JPRB, 0.297334E-02_JPRB, 0.267471E-02_JPRB, 0.236691E-02_JPRB &
  &, 0.216641E-02_JPRB, 0.190066E-02_JPRB, 0.174683E-02_JPRB &
  &, 0.152761E-02_JPRB, 0.136353E-02_JPRB, 0.125699E-02_JPRB, 0.108408E-02_JPRB &
  &, 0.970275E-03_JPRB, 0.853203E-03_JPRB, 0.798534E-03_JPRB/)
XCW( 490, :) = (/ &
  &  0.994042E+00_JPRB, 0.991517E+00_JPRB, 0.988579E+00_JPRB, 0.985235E+00_JPRB &
  &, 0.981479E+00_JPRB, 0.977318E+00_JPRB, 0.972753E+00_JPRB &
  &, 0.967786E+00_JPRB, 0.962420E+00_JPRB, 0.956658E+00_JPRB, 0.950504E+00_JPRB &
  &, 0.943959E+00_JPRB, 0.937029E+00_JPRB, 0.929718E+00_JPRB &
  &, 0.922032E+00_JPRB, 0.913972E+00_JPRB, 0.905546E+00_JPRB, 0.896759E+00_JPRB &
  &, 0.887618E+00_JPRB, 0.878129E+00_JPRB, 0.868300E+00_JPRB &
  &, 0.858135E+00_JPRB, 0.847644E+00_JPRB, 0.836839E+00_JPRB, 0.825723E+00_JPRB &
  &, 0.814311E+00_JPRB, 0.802612E+00_JPRB, 0.790631E+00_JPRB &
  &, 0.778390E+00_JPRB, 0.765888E+00_JPRB, 0.753148E+00_JPRB, 0.740175E+00_JPRB &
  &, 0.726986E+00_JPRB, 0.713594E+00_JPRB, 0.700014E+00_JPRB &
  &, 0.686250E+00_JPRB, 0.672340E+00_JPRB, 0.658284E+00_JPRB, 0.644088E+00_JPRB &
  &, 0.629793E+00_JPRB, 0.615392E+00_JPRB, 0.600913E+00_JPRB &
  &, 0.586373E+00_JPRB, 0.571784E+00_JPRB, 0.557166E+00_JPRB, 0.542524E+00_JPRB &
  &, 0.527893E+00_JPRB, 0.513278E+00_JPRB, 0.498707E+00_JPRB &
  &, 0.484173E+00_JPRB, 0.469719E+00_JPRB, 0.455350E+00_JPRB, 0.441084E+00_JPRB &
  &, 0.426925E+00_JPRB, 0.412892E+00_JPRB, 0.399001E+00_JPRB &
  &, 0.385286E+00_JPRB, 0.371733E+00_JPRB, 0.358358E+00_JPRB, 0.345176E+00_JPRB &
  &, 0.332218E+00_JPRB, 0.319466E+00_JPRB, 0.306965E+00_JPRB &
  &, 0.294675E+00_JPRB, 0.282659E+00_JPRB, 0.270890E+00_JPRB, 0.259375E+00_JPRB &
  &, 0.248139E+00_JPRB, 0.237186E+00_JPRB, 0.226499E+00_JPRB &
  &, 0.216121E+00_JPRB, 0.206030E+00_JPRB, 0.196223E+00_JPRB, 0.186718E+00_JPRB &
  &, 0.177509E+00_JPRB, 0.168587E+00_JPRB, 0.159989E+00_JPRB &
  &, 0.151680E+00_JPRB, 0.143670E+00_JPRB, 0.135943E+00_JPRB, 0.128530E+00_JPRB &
  &, 0.121387E+00_JPRB, 0.114543E+00_JPRB, 0.107974E+00_JPRB &
  &, 0.101680E+00_JPRB, 0.956614E-01_JPRB, 0.899435E-01_JPRB, 0.844659E-01_JPRB &
  &, 0.792216E-01_JPRB, 0.742634E-01_JPRB, 0.695223E-01_JPRB &
  &, 0.650498E-01_JPRB, 0.607714E-01_JPRB, 0.567374E-01_JPRB, 0.529340E-01_JPRB &
  &, 0.493115E-01_JPRB, 0.458853E-01_JPRB, 0.426709E-01_JPRB &
  &, 0.396484E-01_JPRB, 0.367959E-01_JPRB, 0.341264E-01_JPRB, 0.316154E-01_JPRB &
  &, 0.292362E-01_JPRB, 0.270379E-01_JPRB, 0.249533E-01_JPRB &
  &, 0.230311E-01_JPRB, 0.212412E-01_JPRB, 0.195508E-01_JPRB, 0.179669E-01_JPRB &
  &, 0.164968E-01_JPRB, 0.151478E-01_JPRB, 0.138831E-01_JPRB &
  &, 0.127532E-01_JPRB, 0.116290E-01_JPRB, 0.106510E-01_JPRB, 0.973309E-02_JPRB &
  &, 0.887917E-02_JPRB, 0.809313E-02_JPRB, 0.737892E-02_JPRB &
  &, 0.669074E-02_JPRB, 0.608109E-02_JPRB, 0.550279E-02_JPRB, 0.500992E-02_JPRB &
  &, 0.455394E-02_JPRB, 0.408333E-02_JPRB, 0.370664E-02_JPRB &
  &, 0.337319E-02_JPRB, 0.302925E-02_JPRB, 0.273140E-02_JPRB, 0.242440E-02_JPRB &
  &, 0.222469E-02_JPRB, 0.195974E-02_JPRB, 0.174683E-02_JPRB &
  &, 0.158831E-02_JPRB, 0.142505E-02_JPRB, 0.125699E-02_JPRB, 0.114726E-02_JPRB &
  &, 0.103429E-02_JPRB, 0.918065E-03_JPRB, 0.798534E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART70',1,ZHOOK_HANDLE)
END SUBROUTINE PART70

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART71

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART71',0,ZHOOK_HANDLE)

XCW( 491, :) = (/ &
  &  0.994292E+00_JPRB, 0.991830E+00_JPRB, 0.988954E+00_JPRB, 0.985670E+00_JPRB &
  &, 0.981975E+00_JPRB, 0.977876E+00_JPRB, 0.973370E+00_JPRB &
  &, 0.968463E+00_JPRB, 0.963156E+00_JPRB, 0.957453E+00_JPRB, 0.951356E+00_JPRB &
  &, 0.944869E+00_JPRB, 0.937996E+00_JPRB, 0.930740E+00_JPRB &
  &, 0.923108E+00_JPRB, 0.915102E+00_JPRB, 0.906729E+00_JPRB, 0.897994E+00_JPRB &
  &, 0.888904E+00_JPRB, 0.879465E+00_JPRB, 0.869681E+00_JPRB &
  &, 0.859564E+00_JPRB, 0.849123E+00_JPRB, 0.838359E+00_JPRB, 0.827290E+00_JPRB &
  &, 0.815919E+00_JPRB, 0.804258E+00_JPRB, 0.792318E+00_JPRB &
  &, 0.780114E+00_JPRB, 0.767647E+00_JPRB, 0.754942E+00_JPRB, 0.742002E+00_JPRB &
  &, 0.728842E+00_JPRB, 0.715479E+00_JPRB, 0.701928E+00_JPRB &
  &, 0.688194E+00_JPRB, 0.674305E+00_JPRB, 0.660269E+00_JPRB, 0.646093E+00_JPRB &
  &, 0.631807E+00_JPRB, 0.617426E+00_JPRB, 0.602966E+00_JPRB &
  &, 0.588433E+00_JPRB, 0.573849E+00_JPRB, 0.559237E+00_JPRB, 0.544610E+00_JPRB &
  &, 0.529982E+00_JPRB, 0.515368E+00_JPRB, 0.500785E+00_JPRB &
  &, 0.486263E+00_JPRB, 0.471805E+00_JPRB, 0.457418E+00_JPRB, 0.443145E+00_JPRB &
  &, 0.428963E+00_JPRB, 0.414934E+00_JPRB, 0.401030E+00_JPRB &
  &, 0.387285E+00_JPRB, 0.373715E+00_JPRB, 0.360321E+00_JPRB, 0.347118E+00_JPRB &
  &, 0.334137E+00_JPRB, 0.321358E+00_JPRB, 0.308811E+00_JPRB &
  &, 0.296508E+00_JPRB, 0.284458E+00_JPRB, 0.272653E+00_JPRB, 0.261118E+00_JPRB &
  &, 0.249841E+00_JPRB, 0.238844E+00_JPRB, 0.228131E+00_JPRB &
  &, 0.217724E+00_JPRB, 0.207580E+00_JPRB, 0.197740E+00_JPRB, 0.188199E+00_JPRB &
  &, 0.178951E+00_JPRB, 0.169989E+00_JPRB, 0.161348E+00_JPRB &
  &, 0.152993E+00_JPRB, 0.144935E+00_JPRB, 0.137182E+00_JPRB, 0.129717E+00_JPRB &
  &, 0.122544E+00_JPRB, 0.115642E+00_JPRB, 0.109040E+00_JPRB &
  &, 0.102711E+00_JPRB, 0.966545E-01_JPRB, 0.908686E-01_JPRB, 0.853493E-01_JPRB &
  &, 0.800914E-01_JPRB, 0.750881E-01_JPRB, 0.703309E-01_JPRB &
  &, 0.658098E-01_JPRB, 0.615128E-01_JPRB, 0.574264E-01_JPRB, 0.535684E-01_JPRB &
  &, 0.499231E-01_JPRB, 0.465076E-01_JPRB, 0.432336E-01_JPRB &
  &, 0.401850E-01_JPRB, 0.373053E-01_JPRB, 0.346074E-01_JPRB, 0.320669E-01_JPRB &
  &, 0.296570E-01_JPRB, 0.274268E-01_JPRB, 0.253486E-01_JPRB &
  &, 0.233927E-01_JPRB, 0.215678E-01_JPRB, 0.198412E-01_JPRB, 0.182620E-01_JPRB &
  &, 0.167966E-01_JPRB, 0.154088E-01_JPRB, 0.141482E-01_JPRB &
  &, 0.129327E-01_JPRB, 0.118568E-01_JPRB, 0.108360E-01_JPRB, 0.992097E-02_JPRB &
  &, 0.902222E-02_JPRB, 0.823833E-02_JPRB, 0.752630E-02_JPRB &
  &, 0.684031E-02_JPRB, 0.618228E-02_JPRB, 0.565679E-02_JPRB, 0.511409E-02_JPRB &
  &, 0.460678E-02_JPRB, 0.419053E-02_JPRB, 0.381537E-02_JPRB &
  &, 0.342833E-02_JPRB, 0.308517E-02_JPRB, 0.278810E-02_JPRB, 0.248188E-02_JPRB &
  &, 0.222469E-02_JPRB, 0.201883E-02_JPRB, 0.180672E-02_JPRB &
  &, 0.164902E-02_JPRB, 0.142505E-02_JPRB, 0.131934E-02_JPRB, 0.114726E-02_JPRB &
  &, 0.103429E-02_JPRB, 0.918065E-03_JPRB, 0.798534E-03_JPRB/)
XCW( 492, :) = (/ &
  &  0.994542E+00_JPRB, 0.992141E+00_JPRB, 0.989328E+00_JPRB, 0.986105E+00_JPRB &
  &, 0.982472E+00_JPRB, 0.978433E+00_JPRB, 0.973987E+00_JPRB &
  &, 0.969140E+00_JPRB, 0.963892E+00_JPRB, 0.958247E+00_JPRB, 0.952209E+00_JPRB &
  &, 0.945779E+00_JPRB, 0.938962E+00_JPRB, 0.931762E+00_JPRB &
  &, 0.924185E+00_JPRB, 0.916233E+00_JPRB, 0.907912E+00_JPRB, 0.899230E+00_JPRB &
  &, 0.890191E+00_JPRB, 0.880800E+00_JPRB, 0.871066E+00_JPRB &
  &, 0.860996E+00_JPRB, 0.850602E+00_JPRB, 0.839886E+00_JPRB, 0.828856E+00_JPRB &
  &, 0.817530E+00_JPRB, 0.805908E+00_JPRB, 0.794009E+00_JPRB &
  &, 0.781838E+00_JPRB, 0.769410E+00_JPRB, 0.756737E+00_JPRB, 0.743833E+00_JPRB &
  &, 0.730706E+00_JPRB, 0.717368E+00_JPRB, 0.703842E+00_JPRB &
  &, 0.690138E+00_JPRB, 0.676269E+00_JPRB, 0.662254E+00_JPRB, 0.648108E+00_JPRB &
  &, 0.633832E+00_JPRB, 0.619471E+00_JPRB, 0.605018E+00_JPRB &
  &, 0.590504E+00_JPRB, 0.575927E+00_JPRB, 0.561320E+00_JPRB, 0.546697E+00_JPRB &
  &, 0.532072E+00_JPRB, 0.517459E+00_JPRB, 0.502876E+00_JPRB &
  &, 0.488352E+00_JPRB, 0.473878E+00_JPRB, 0.459499E+00_JPRB, 0.445205E+00_JPRB &
  &, 0.431030E+00_JPRB, 0.416975E+00_JPRB, 0.403059E+00_JPRB &
  &, 0.389300E+00_JPRB, 0.375697E+00_JPRB, 0.362284E+00_JPRB, 0.349076E+00_JPRB &
  &, 0.336055E+00_JPRB, 0.323250E+00_JPRB, 0.310693E+00_JPRB &
  &, 0.298359E+00_JPRB, 0.286258E+00_JPRB, 0.274435E+00_JPRB, 0.262862E+00_JPRB &
  &, 0.251563E+00_JPRB, 0.240522E+00_JPRB, 0.229783E+00_JPRB &
  &, 0.219326E+00_JPRB, 0.209152E+00_JPRB, 0.199257E+00_JPRB, 0.189680E+00_JPRB &
  &, 0.180394E+00_JPRB, 0.171391E+00_JPRB, 0.162707E+00_JPRB &
  &, 0.154307E+00_JPRB, 0.146225E+00_JPRB, 0.138422E+00_JPRB, 0.130903E+00_JPRB &
  &, 0.123701E+00_JPRB, 0.116768E+00_JPRB, 0.110105E+00_JPRB &
  &, 0.103741E+00_JPRB, 0.976476E-01_JPRB, 0.918515E-01_JPRB, 0.862917E-01_JPRB &
  &, 0.809912E-01_JPRB, 0.759434E-01_JPRB, 0.711396E-01_JPRB &
  &, 0.665697E-01_JPRB, 0.622542E-01_JPRB, 0.581482E-01_JPRB, 0.542362E-01_JPRB &
  &, 0.505687E-01_JPRB, 0.470953E-01_JPRB, 0.438315E-01_JPRB &
  &, 0.407216E-01_JPRB, 0.378147E-01_JPRB, 0.350884E-01_JPRB, 0.325184E-01_JPRB &
  &, 0.300778E-01_JPRB, 0.278157E-01_JPRB, 0.257044E-01_JPRB &
  &, 0.237543E-01_JPRB, 0.218944E-01_JPRB, 0.201731E-01_JPRB, 0.185571E-01_JPRB &
  &, 0.170535E-01_JPRB, 0.156698E-01_JPRB, 0.143691E-01_JPRB &
  &, 0.131570E-01_JPRB, 0.120847E-01_JPRB, 0.110211E-01_JPRB, 0.101089E-01_JPRB &
  &, 0.921296E-02_JPRB, 0.838354E-02_JPRB, 0.767368E-02_JPRB &
  &, 0.694003E-02_JPRB, 0.633405E-02_JPRB, 0.575946E-02_JPRB, 0.521825E-02_JPRB &
  &, 0.471245E-02_JPRB, 0.429772E-02_JPRB, 0.386973E-02_JPRB &
  &, 0.348346E-02_JPRB, 0.314108E-02_JPRB, 0.284480E-02_JPRB, 0.253937E-02_JPRB &
  &, 0.228298E-02_JPRB, 0.207791E-02_JPRB, 0.186661E-02_JPRB &
  &, 0.164902E-02_JPRB, 0.148657E-02_JPRB, 0.131934E-02_JPRB, 0.121044E-02_JPRB &
  &, 0.103429E-02_JPRB, 0.918065E-03_JPRB, 0.864245E-03_JPRB/)
XCW( 493, :) = (/ &
  &  0.994792E+00_JPRB, 0.992453E+00_JPRB, 0.989701E+00_JPRB, 0.986541E+00_JPRB &
  &, 0.982969E+00_JPRB, 0.978990E+00_JPRB, 0.974606E+00_JPRB &
  &, 0.969818E+00_JPRB, 0.964629E+00_JPRB, 0.959043E+00_JPRB, 0.953061E+00_JPRB &
  &, 0.946688E+00_JPRB, 0.939929E+00_JPRB, 0.932785E+00_JPRB &
  &, 0.925263E+00_JPRB, 0.917365E+00_JPRB, 0.909097E+00_JPRB, 0.900466E+00_JPRB &
  &, 0.891478E+00_JPRB, 0.882139E+00_JPRB, 0.872453E+00_JPRB &
  &, 0.862432E+00_JPRB, 0.852080E+00_JPRB, 0.841410E+00_JPRB, 0.830427E+00_JPRB &
  &, 0.819142E+00_JPRB, 0.807562E+00_JPRB, 0.795699E+00_JPRB &
  &, 0.783570E+00_JPRB, 0.771177E+00_JPRB, 0.758540E+00_JPRB, 0.745664E+00_JPRB &
  &, 0.732566E+00_JPRB, 0.719262E+00_JPRB, 0.705766E+00_JPRB &
  &, 0.692082E+00_JPRB, 0.678243E+00_JPRB, 0.664248E+00_JPRB, 0.650113E+00_JPRB &
  &, 0.635868E+00_JPRB, 0.621515E+00_JPRB, 0.607082E+00_JPRB &
  &, 0.592575E+00_JPRB, 0.578004E+00_JPRB, 0.563414E+00_JPRB, 0.548796E+00_JPRB &
  &, 0.534173E+00_JPRB, 0.519563E+00_JPRB, 0.504980E+00_JPRB &
  &, 0.490441E+00_JPRB, 0.475978E+00_JPRB, 0.461580E+00_JPRB, 0.447280E+00_JPRB &
  &, 0.433082E+00_JPRB, 0.419017E+00_JPRB, 0.405088E+00_JPRB &
  &, 0.391314E+00_JPRB, 0.377695E+00_JPRB, 0.364263E+00_JPRB, 0.351018E+00_JPRB &
  &, 0.337990E+00_JPRB, 0.325160E+00_JPRB, 0.312574E+00_JPRB &
  &, 0.300210E+00_JPRB, 0.288075E+00_JPRB, 0.276217E+00_JPRB, 0.264605E+00_JPRB &
  &, 0.253285E+00_JPRB, 0.242220E+00_JPRB, 0.231435E+00_JPRB &
  &, 0.220929E+00_JPRB, 0.210724E+00_JPRB, 0.200795E+00_JPRB, 0.191183E+00_JPRB &
  &, 0.181837E+00_JPRB, 0.172816E+00_JPRB, 0.164090E+00_JPRB &
  &, 0.155644E+00_JPRB, 0.147515E+00_JPRB, 0.139661E+00_JPRB, 0.132116E+00_JPRB &
  &, 0.124859E+00_JPRB, 0.117894E+00_JPRB, 0.111198E+00_JPRB &
  &, 0.104799E+00_JPRB, 0.986691E-01_JPRB, 0.928055E-01_JPRB, 0.872045E-01_JPRB &
  &, 0.818610E-01_JPRB, 0.767986E-01_JPRB, 0.719482E-01_JPRB &
  &, 0.673614E-01_JPRB, 0.629956E-01_JPRB, 0.588372E-01_JPRB, 0.549040E-01_JPRB &
  &, 0.512143E-01_JPRB, 0.476830E-01_JPRB, 0.443942E-01_JPRB &
  &, 0.412582E-01_JPRB, 0.383241E-01_JPRB, 0.355695E-01_JPRB, 0.329699E-01_JPRB &
  &, 0.305369E-01_JPRB, 0.282434E-01_JPRB, 0.260997E-01_JPRB &
  &, 0.241159E-01_JPRB, 0.222211E-01_JPRB, 0.204635E-01_JPRB, 0.188521E-01_JPRB &
  &, 0.173533E-01_JPRB, 0.159308E-01_JPRB, 0.146342E-01_JPRB &
  &, 0.134262E-01_JPRB, 0.122669E-01_JPRB, 0.112524E-01_JPRB, 0.102498E-01_JPRB &
  &, 0.935601E-02_JPRB, 0.857714E-02_JPRB, 0.782106E-02_JPRB &
  &, 0.708959E-02_JPRB, 0.643524E-02_JPRB, 0.586213E-02_JPRB, 0.532242E-02_JPRB &
  &, 0.481812E-02_JPRB, 0.435132E-02_JPRB, 0.397846E-02_JPRB &
  &, 0.359373E-02_JPRB, 0.325290E-02_JPRB, 0.290149E-02_JPRB, 0.259686E-02_JPRB &
  &, 0.234126E-02_JPRB, 0.213699E-02_JPRB, 0.192650E-02_JPRB &
  &, 0.170972E-02_JPRB, 0.154810E-02_JPRB, 0.138169E-02_JPRB, 0.121044E-02_JPRB &
  &, 0.109831E-02_JPRB, 0.982926E-03_JPRB, 0.864245E-03_JPRB/)
XCW( 494, :) = (/ &
  &  0.995041E+00_JPRB, 0.992766E+00_JPRB, 0.990075E+00_JPRB, 0.986976E+00_JPRB &
  &, 0.983465E+00_JPRB, 0.979548E+00_JPRB, 0.975224E+00_JPRB &
  &, 0.970495E+00_JPRB, 0.965365E+00_JPRB, 0.959838E+00_JPRB, 0.953915E+00_JPRB &
  &, 0.947601E+00_JPRB, 0.940897E+00_JPRB, 0.933808E+00_JPRB &
  &, 0.926341E+00_JPRB, 0.918497E+00_JPRB, 0.910283E+00_JPRB, 0.901704E+00_JPRB &
  &, 0.892768E+00_JPRB, 0.883478E+00_JPRB, 0.873841E+00_JPRB &
  &, 0.863868E+00_JPRB, 0.853562E+00_JPRB, 0.842937E+00_JPRB, 0.831997E+00_JPRB &
  &, 0.820753E+00_JPRB, 0.809216E+00_JPRB, 0.797394E+00_JPRB &
  &, 0.785299E+00_JPRB, 0.772944E+00_JPRB, 0.760343E+00_JPRB, 0.747500E+00_JPRB &
  &, 0.734434E+00_JPRB, 0.721160E+00_JPRB, 0.707689E+00_JPRB &
  &, 0.694035E+00_JPRB, 0.680218E+00_JPRB, 0.666243E+00_JPRB, 0.652128E+00_JPRB &
  &, 0.637903E+00_JPRB, 0.623570E+00_JPRB, 0.609145E+00_JPRB &
  &, 0.594646E+00_JPRB, 0.580093E+00_JPRB, 0.565509E+00_JPRB, 0.550894E+00_JPRB &
  &, 0.536275E+00_JPRB, 0.521666E+00_JPRB, 0.507083E+00_JPRB &
  &, 0.492544E+00_JPRB, 0.478064E+00_JPRB, 0.463675E+00_JPRB, 0.449355E+00_JPRB &
  &, 0.435163E+00_JPRB, 0.421073E+00_JPRB, 0.407133E+00_JPRB &
  &, 0.393329E+00_JPRB, 0.379709E+00_JPRB, 0.366259E+00_JPRB, 0.352993E+00_JPRB &
  &, 0.339925E+00_JPRB, 0.327069E+00_JPRB, 0.314456E+00_JPRB &
  &, 0.302061E+00_JPRB, 0.289912E+00_JPRB, 0.278018E+00_JPRB, 0.266368E+00_JPRB &
  &, 0.255006E+00_JPRB, 0.243898E+00_JPRB, 0.233087E+00_JPRB &
  &, 0.222553E+00_JPRB, 0.212296E+00_JPRB, 0.202334E+00_JPRB, 0.192686E+00_JPRB &
  &, 0.183302E+00_JPRB, 0.174242E+00_JPRB, 0.165472E+00_JPRB &
  &, 0.156982E+00_JPRB, 0.148805E+00_JPRB, 0.140926E+00_JPRB, 0.133328E+00_JPRB &
  &, 0.126042E+00_JPRB, 0.119020E+00_JPRB, 0.112291E+00_JPRB &
  &, 0.105858E+00_JPRB, 0.996906E-01_JPRB, 0.937883E-01_JPRB, 0.881469E-01_JPRB &
  &, 0.827608E-01_JPRB, 0.776538E-01_JPRB, 0.727569E-01_JPRB &
  &, 0.681213E-01_JPRB, 0.637370E-01_JPRB, 0.595590E-01_JPRB, 0.556052E-01_JPRB &
  &, 0.518598E-01_JPRB, 0.483052E-01_JPRB, 0.449569E-01_JPRB &
  &, 0.418306E-01_JPRB, 0.388699E-01_JPRB, 0.360505E-01_JPRB, 0.334214E-01_JPRB &
  &, 0.309577E-01_JPRB, 0.286712E-01_JPRB, 0.264950E-01_JPRB &
  &, 0.244775E-01_JPRB, 0.225885E-01_JPRB, 0.207954E-01_JPRB, 0.191472E-01_JPRB &
  &, 0.176102E-01_JPRB, 0.161918E-01_JPRB, 0.148551E-01_JPRB &
  &, 0.136506E-01_JPRB, 0.124947E-01_JPRB, 0.114375E-01_JPRB, 0.104377E-01_JPRB &
  &, 0.954674E-02_JPRB, 0.872235E-02_JPRB, 0.796843E-02_JPRB &
  &, 0.723916E-02_JPRB, 0.658701E-02_JPRB, 0.596480E-02_JPRB, 0.542658E-02_JPRB &
  &, 0.492380E-02_JPRB, 0.445851E-02_JPRB, 0.403282E-02_JPRB &
  &, 0.364886E-02_JPRB, 0.330882E-02_JPRB, 0.295819E-02_JPRB, 0.265434E-02_JPRB &
  &, 0.239954E-02_JPRB, 0.219607E-02_JPRB, 0.192650E-02_JPRB &
  &, 0.177043E-02_JPRB, 0.154810E-02_JPRB, 0.138169E-02_JPRB, 0.127362E-02_JPRB &
  &, 0.109831E-02_JPRB, 0.982926E-03_JPRB, 0.864245E-03_JPRB/)
XCW( 495, :) = (/ &
  &  0.995294E+00_JPRB, 0.993079E+00_JPRB, 0.990451E+00_JPRB, 0.987412E+00_JPRB &
  &, 0.983963E+00_JPRB, 0.980106E+00_JPRB, 0.975841E+00_JPRB &
  &, 0.971173E+00_JPRB, 0.966103E+00_JPRB, 0.960634E+00_JPRB, 0.954770E+00_JPRB &
  &, 0.948512E+00_JPRB, 0.941865E+00_JPRB, 0.934833E+00_JPRB &
  &, 0.927420E+00_JPRB, 0.919630E+00_JPRB, 0.911469E+00_JPRB, 0.902944E+00_JPRB &
  &, 0.894057E+00_JPRB, 0.884817E+00_JPRB, 0.875229E+00_JPRB &
  &, 0.865303E+00_JPRB, 0.855048E+00_JPRB, 0.844467E+00_JPRB, 0.833570E+00_JPRB &
  &, 0.822368E+00_JPRB, 0.810874E+00_JPRB, 0.799092E+00_JPRB &
  &, 0.787035E+00_JPRB, 0.774715E+00_JPRB, 0.762146E+00_JPRB, 0.749339E+00_JPRB &
  &, 0.736307E+00_JPRB, 0.723062E+00_JPRB, 0.709617E+00_JPRB &
  &, 0.695989E+00_JPRB, 0.682192E+00_JPRB, 0.668238E+00_JPRB, 0.654153E+00_JPRB &
  &, 0.639938E+00_JPRB, 0.625625E+00_JPRB, 0.611209E+00_JPRB &
  &, 0.596728E+00_JPRB, 0.582193E+00_JPRB, 0.567603E+00_JPRB, 0.552993E+00_JPRB &
  &, 0.538377E+00_JPRB, 0.523782E+00_JPRB, 0.509200E+00_JPRB &
  &, 0.494659E+00_JPRB, 0.480177E+00_JPRB, 0.465770E+00_JPRB, 0.451444E+00_JPRB &
  &, 0.437229E+00_JPRB, 0.423144E+00_JPRB, 0.409177E+00_JPRB &
  &, 0.395375E+00_JPRB, 0.381723E+00_JPRB, 0.368238E+00_JPRB, 0.354968E+00_JPRB &
  &, 0.341877E+00_JPRB, 0.328996E+00_JPRB, 0.316355E+00_JPRB &
  &, 0.303930E+00_JPRB, 0.291748E+00_JPRB, 0.279819E+00_JPRB, 0.268150E+00_JPRB &
  &, 0.256748E+00_JPRB, 0.245617E+00_JPRB, 0.234759E+00_JPRB &
  &, 0.224177E+00_JPRB, 0.213889E+00_JPRB, 0.203895E+00_JPRB, 0.194190E+00_JPRB &
  &, 0.184791E+00_JPRB, 0.175667E+00_JPRB, 0.166855E+00_JPRB &
  &, 0.158344E+00_JPRB, 0.150120E+00_JPRB, 0.142191E+00_JPRB, 0.134567E+00_JPRB &
  &, 0.127226E+00_JPRB, 0.120173E+00_JPRB, 0.113412E+00_JPRB &
  &, 0.106916E+00_JPRB, 0.100712E+00_JPRB, 0.947712E-01_JPRB, 0.890892E-01_JPRB &
  &, 0.836606E-01_JPRB, 0.785091E-01_JPRB, 0.735966E-01_JPRB &
  &, 0.689129E-01_JPRB, 0.644784E-01_JPRB, 0.602808E-01_JPRB, 0.562730E-01_JPRB &
  &, 0.525054E-01_JPRB, 0.489275E-01_JPRB, 0.455548E-01_JPRB &
  &, 0.423672E-01_JPRB, 0.393793E-01_JPRB, 0.365685E-01_JPRB, 0.339105E-01_JPRB &
  &, 0.314167E-01_JPRB, 0.290601E-01_JPRB, 0.268903E-01_JPRB &
  &, 0.248391E-01_JPRB, 0.229152E-01_JPRB, 0.211273E-01_JPRB, 0.194844E-01_JPRB &
  &, 0.179100E-01_JPRB, 0.164528E-01_JPRB, 0.151202E-01_JPRB &
  &, 0.138749E-01_JPRB, 0.127226E-01_JPRB, 0.116225E-01_JPRB, 0.106255E-01_JPRB &
  &, 0.973748E-02_JPRB, 0.886756E-02_JPRB, 0.811581E-02_JPRB &
  &, 0.738873E-02_JPRB, 0.673879E-02_JPRB, 0.611880E-02_JPRB, 0.553075E-02_JPRB &
  &, 0.502947E-02_JPRB, 0.456570E-02_JPRB, 0.414154E-02_JPRB &
  &, 0.375913E-02_JPRB, 0.336473E-02_JPRB, 0.301488E-02_JPRB, 0.276931E-02_JPRB &
  &, 0.245782E-02_JPRB, 0.219607E-02_JPRB, 0.198639E-02_JPRB &
  &, 0.177043E-02_JPRB, 0.160962E-02_JPRB, 0.144404E-02_JPRB, 0.127362E-02_JPRB &
  &, 0.116233E-02_JPRB, 0.104779E-02_JPRB, 0.929956E-03_JPRB/)
XCW( 496, :) = (/ &
  &  0.995543E+00_JPRB, 0.993392E+00_JPRB, 0.990825E+00_JPRB, 0.987848E+00_JPRB &
  &, 0.984460E+00_JPRB, 0.980663E+00_JPRB, 0.976460E+00_JPRB &
  &, 0.971851E+00_JPRB, 0.966841E+00_JPRB, 0.961430E+00_JPRB, 0.955624E+00_JPRB &
  &, 0.949424E+00_JPRB, 0.942834E+00_JPRB, 0.935858E+00_JPRB &
  &, 0.928500E+00_JPRB, 0.920765E+00_JPRB, 0.912657E+00_JPRB, 0.904183E+00_JPRB &
  &, 0.895349E+00_JPRB, 0.886158E+00_JPRB, 0.876620E+00_JPRB &
  &, 0.866742E+00_JPRB, 0.856533E+00_JPRB, 0.845998E+00_JPRB, 0.835144E+00_JPRB &
  &, 0.823987E+00_JPRB, 0.812532E+00_JPRB, 0.800790E+00_JPRB &
  &, 0.788771E+00_JPRB, 0.776490E+00_JPRB, 0.763957E+00_JPRB, 0.751183E+00_JPRB &
  &, 0.738180E+00_JPRB, 0.724964E+00_JPRB, 0.711549E+00_JPRB &
  &, 0.697942E+00_JPRB, 0.684175E+00_JPRB, 0.670242E+00_JPRB, 0.656178E+00_JPRB &
  &, 0.641984E+00_JPRB, 0.627680E+00_JPRB, 0.613283E+00_JPRB &
  &, 0.598821E+00_JPRB, 0.584282E+00_JPRB, 0.569709E+00_JPRB, 0.555103E+00_JPRB &
  &, 0.540503E+00_JPRB, 0.525898E+00_JPRB, 0.511316E+00_JPRB &
  &, 0.496775E+00_JPRB, 0.482290E+00_JPRB, 0.467866E+00_JPRB, 0.453547E+00_JPRB &
  &, 0.439325E+00_JPRB, 0.425215E+00_JPRB, 0.411236E+00_JPRB &
  &, 0.397405E+00_JPRB, 0.383737E+00_JPRB, 0.370250E+00_JPRB, 0.356943E+00_JPRB &
  &, 0.343830E+00_JPRB, 0.330923E+00_JPRB, 0.318254E+00_JPRB &
  &, 0.305799E+00_JPRB, 0.293584E+00_JPRB, 0.281639E+00_JPRB, 0.269932E+00_JPRB &
  &, 0.258490E+00_JPRB, 0.247315E+00_JPRB, 0.236432E+00_JPRB &
  &, 0.225822E+00_JPRB, 0.215482E+00_JPRB, 0.205456E+00_JPRB, 0.195716E+00_JPRB &
  &, 0.186256E+00_JPRB, 0.177116E+00_JPRB, 0.168262E+00_JPRB &
  &, 0.159706E+00_JPRB, 0.151435E+00_JPRB, 0.143482E+00_JPRB, 0.135805E+00_JPRB &
  &, 0.128409E+00_JPRB, 0.121326E+00_JPRB, 0.114505E+00_JPRB &
  &, 0.107974E+00_JPRB, 0.101734E+00_JPRB, 0.957541E-01_JPRB, 0.900315E-01_JPRB &
  &, 0.845904E-01_JPRB, 0.793949E-01_JPRB, 0.744364E-01_JPRB &
  &, 0.697362E-01_JPRB, 0.652520E-01_JPRB, 0.610026E-01_JPRB, 0.569742E-01_JPRB &
  &, 0.531510E-01_JPRB, 0.495498E-01_JPRB, 0.461527E-01_JPRB &
  &, 0.429396E-01_JPRB, 0.399251E-01_JPRB, 0.370496E-01_JPRB, 0.343996E-01_JPRB &
  &, 0.318758E-01_JPRB, 0.294879E-01_JPRB, 0.272856E-01_JPRB &
  &, 0.252007E-01_JPRB, 0.232826E-01_JPRB, 0.214592E-01_JPRB, 0.197795E-01_JPRB &
  &, 0.182098E-01_JPRB, 0.167573E-01_JPRB, 0.153853E-01_JPRB &
  &, 0.140993E-01_JPRB, 0.129504E-01_JPRB, 0.118539E-01_JPRB, 0.108604E-01_JPRB &
  &, 0.992821E-02_JPRB, 0.906116E-02_JPRB, 0.826319E-02_JPRB &
  &, 0.753830E-02_JPRB, 0.683998E-02_JPRB, 0.622147E-02_JPRB, 0.563491E-02_JPRB &
  &, 0.513514E-02_JPRB, 0.467289E-02_JPRB, 0.419591E-02_JPRB &
  &, 0.381427E-02_JPRB, 0.342064E-02_JPRB, 0.312828E-02_JPRB, 0.282680E-02_JPRB &
  &, 0.251610E-02_JPRB, 0.225516E-02_JPRB, 0.204629E-02_JPRB &
  &, 0.183113E-02_JPRB, 0.167115E-02_JPRB, 0.144404E-02_JPRB, 0.133680E-02_JPRB &
  &, 0.116233E-02_JPRB, 0.104779E-02_JPRB, 0.929956E-03_JPRB/)
XCW( 497, :) = (/ &
  &  0.995792E+00_JPRB, 0.993704E+00_JPRB, 0.991199E+00_JPRB, 0.988285E+00_JPRB &
  &, 0.984957E+00_JPRB, 0.981221E+00_JPRB, 0.977078E+00_JPRB &
  &, 0.972530E+00_JPRB, 0.967579E+00_JPRB, 0.962228E+00_JPRB, 0.956479E+00_JPRB &
  &, 0.950336E+00_JPRB, 0.943803E+00_JPRB, 0.936882E+00_JPRB &
  &, 0.929581E+00_JPRB, 0.921900E+00_JPRB, 0.913846E+00_JPRB, 0.905425E+00_JPRB &
  &, 0.896641E+00_JPRB, 0.887500E+00_JPRB, 0.878014E+00_JPRB &
  &, 0.868185E+00_JPRB, 0.858019E+00_JPRB, 0.847528E+00_JPRB, 0.836721E+00_JPRB &
  &, 0.825605E+00_JPRB, 0.814193E+00_JPRB, 0.802492E+00_JPRB &
  &, 0.790511E+00_JPRB, 0.778266E+00_JPRB, 0.765768E+00_JPRB, 0.753027E+00_JPRB &
  &, 0.740057E+00_JPRB, 0.726871E+00_JPRB, 0.713486E+00_JPRB &
  &, 0.699905E+00_JPRB, 0.686159E+00_JPRB, 0.672257E+00_JPRB, 0.658203E+00_JPRB &
  &, 0.644029E+00_JPRB, 0.629745E+00_JPRB, 0.615368E+00_JPRB &
  &, 0.600903E+00_JPRB, 0.586382E+00_JPRB, 0.571815E+00_JPRB, 0.557226E+00_JPRB &
  &, 0.542617E+00_JPRB, 0.528014E+00_JPRB, 0.513433E+00_JPRB &
  &, 0.498890E+00_JPRB, 0.484403E+00_JPRB, 0.469974E+00_JPRB, 0.455650E+00_JPRB &
  &, 0.441406E+00_JPRB, 0.427286E+00_JPRB, 0.413296E+00_JPRB &
  &, 0.399450E+00_JPRB, 0.385767E+00_JPRB, 0.372262E+00_JPRB, 0.358935E+00_JPRB &
  &, 0.345799E+00_JPRB, 0.332868E+00_JPRB, 0.320171E+00_JPRB &
  &, 0.307686E+00_JPRB, 0.295439E+00_JPRB, 0.283459E+00_JPRB, 0.271715E+00_JPRB &
  &, 0.260251E+00_JPRB, 0.249034E+00_JPRB, 0.238105E+00_JPRB &
  &, 0.227466E+00_JPRB, 0.217097E+00_JPRB, 0.207038E+00_JPRB, 0.197241E+00_JPRB &
  &, 0.187768E+00_JPRB, 0.178565E+00_JPRB, 0.169669E+00_JPRB &
  &, 0.161068E+00_JPRB, 0.152774E+00_JPRB, 0.144772E+00_JPRB, 0.137043E+00_JPRB &
  &, 0.129619E+00_JPRB, 0.122479E+00_JPRB, 0.115625E+00_JPRB &
  &, 0.109060E+00_JPRB, 0.102783E+00_JPRB, 0.967370E-01_JPRB, 0.910033E-01_JPRB &
  &, 0.854902E-01_JPRB, 0.802501E-01_JPRB, 0.752761E-01_JPRB &
  &, 0.705279E-01_JPRB, 0.660256E-01_JPRB, 0.617244E-01_JPRB, 0.576754E-01_JPRB &
  &, 0.538305E-01_JPRB, 0.502066E-01_JPRB, 0.467505E-01_JPRB &
  &, 0.435120E-01_JPRB, 0.404708E-01_JPRB, 0.375676E-01_JPRB, 0.348511E-01_JPRB &
  &, 0.323348E-01_JPRB, 0.299157E-01_JPRB, 0.276809E-01_JPRB &
  &, 0.256024E-01_JPRB, 0.236501E-01_JPRB, 0.217911E-01_JPRB, 0.200745E-01_JPRB &
  &, 0.185095E-01_JPRB, 0.170183E-01_JPRB, 0.156504E-01_JPRB &
  &, 0.143685E-01_JPRB, 0.131782E-01_JPRB, 0.120389E-01_JPRB, 0.110483E-01_JPRB &
  &, 0.100713E-01_JPRB, 0.920637E-02_JPRB, 0.841057E-02_JPRB &
  &, 0.768787E-02_JPRB, 0.699175E-02_JPRB, 0.637548E-02_JPRB, 0.579116E-02_JPRB &
  &, 0.524082E-02_JPRB, 0.472649E-02_JPRB, 0.430463E-02_JPRB &
  &, 0.386940E-02_JPRB, 0.353246E-02_JPRB, 0.318497E-02_JPRB, 0.288428E-02_JPRB &
  &, 0.257438E-02_JPRB, 0.231424E-02_JPRB, 0.210618E-02_JPRB &
  &, 0.189183E-02_JPRB, 0.167115E-02_JPRB, 0.150639E-02_JPRB, 0.133680E-02_JPRB &
  &, 0.122635E-02_JPRB, 0.104779E-02_JPRB, 0.929956E-03_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART71',1,ZHOOK_HANDLE)
END SUBROUTINE PART71

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART72

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART72',0,ZHOOK_HANDLE)

XCW( 498, :) = (/ &
  &  0.996044E+00_JPRB, 0.994016E+00_JPRB, 0.991573E+00_JPRB, 0.988720E+00_JPRB &
  &, 0.985454E+00_JPRB, 0.981780E+00_JPRB, 0.977697E+00_JPRB &
  &, 0.973209E+00_JPRB, 0.968317E+00_JPRB, 0.963025E+00_JPRB, 0.957335E+00_JPRB &
  &, 0.951250E+00_JPRB, 0.944773E+00_JPRB, 0.937909E+00_JPRB &
  &, 0.930661E+00_JPRB, 0.923035E+00_JPRB, 0.915035E+00_JPRB, 0.906666E+00_JPRB &
  &, 0.897936E+00_JPRB, 0.888846E+00_JPRB, 0.879408E+00_JPRB &
  &, 0.869627E+00_JPRB, 0.859508E+00_JPRB, 0.849065E+00_JPRB, 0.838302E+00_JPRB &
  &, 0.827228E+00_JPRB, 0.815855E+00_JPRB, 0.804194E+00_JPRB &
  &, 0.792255E+00_JPRB, 0.780045E+00_JPRB, 0.767583E+00_JPRB, 0.754875E+00_JPRB &
  &, 0.741935E+00_JPRB, 0.728783E+00_JPRB, 0.715423E+00_JPRB &
  &, 0.701876E+00_JPRB, 0.688152E+00_JPRB, 0.674271E+00_JPRB, 0.660239E+00_JPRB &
  &, 0.646085E+00_JPRB, 0.631811E+00_JPRB, 0.617453E+00_JPRB &
  &, 0.603007E+00_JPRB, 0.588493E+00_JPRB, 0.573932E+00_JPRB, 0.559348E+00_JPRB &
  &, 0.544743E+00_JPRB, 0.530142E+00_JPRB, 0.515562E+00_JPRB &
  &, 0.501019E+00_JPRB, 0.486529E+00_JPRB, 0.472097E+00_JPRB, 0.457753E+00_JPRB &
  &, 0.443501E+00_JPRB, 0.429372E+00_JPRB, 0.415370E+00_JPRB &
  &, 0.401511E+00_JPRB, 0.387813E+00_JPRB, 0.374274E+00_JPRB, 0.360926E+00_JPRB &
  &, 0.347768E+00_JPRB, 0.334812E+00_JPRB, 0.322088E+00_JPRB &
  &, 0.309573E+00_JPRB, 0.297313E+00_JPRB, 0.285279E+00_JPRB, 0.273516E+00_JPRB &
  &, 0.262013E+00_JPRB, 0.250772E+00_JPRB, 0.239798E+00_JPRB &
  &, 0.229132E+00_JPRB, 0.218712E+00_JPRB, 0.208577E+00_JPRB, 0.198790E+00_JPRB &
  &, 0.189256E+00_JPRB, 0.180037E+00_JPRB, 0.171099E+00_JPRB &
  &, 0.162454E+00_JPRB, 0.154114E+00_JPRB, 0.146062E+00_JPRB, 0.138307E+00_JPRB &
  &, 0.130829E+00_JPRB, 0.123658E+00_JPRB, 0.116773E+00_JPRB &
  &, 0.110146E+00_JPRB, 0.103833E+00_JPRB, 0.977488E-01_JPRB, 0.919751E-01_JPRB &
  &, 0.864200E-01_JPRB, 0.811664E-01_JPRB, 0.761158E-01_JPRB &
  &, 0.713512E-01_JPRB, 0.667992E-01_JPRB, 0.624790E-01_JPRB, 0.583766E-01_JPRB &
  &, 0.545101E-01_JPRB, 0.508289E-01_JPRB, 0.473836E-01_JPRB &
  &, 0.440844E-01_JPRB, 0.410166E-01_JPRB, 0.380856E-01_JPRB, 0.353403E-01_JPRB &
  &, 0.327939E-01_JPRB, 0.303823E-01_JPRB, 0.281157E-01_JPRB &
  &, 0.260042E-01_JPRB, 0.240176E-01_JPRB, 0.221645E-01_JPRB, 0.204118E-01_JPRB &
  &, 0.188093E-01_JPRB, 0.172793E-01_JPRB, 0.159155E-01_JPRB &
  &, 0.145929E-01_JPRB, 0.134060E-01_JPRB, 0.122703E-01_JPRB, 0.112362E-01_JPRB &
  &, 0.102620E-01_JPRB, 0.939998E-02_JPRB, 0.855795E-02_JPRB &
  &, 0.783744E-02_JPRB, 0.709294E-02_JPRB, 0.647815E-02_JPRB, 0.589533E-02_JPRB &
  &, 0.534649E-02_JPRB, 0.483368E-02_JPRB, 0.441336E-02_JPRB &
  &, 0.397967E-02_JPRB, 0.358838E-02_JPRB, 0.324167E-02_JPRB, 0.294177E-02_JPRB &
  &, 0.263266E-02_JPRB, 0.237332E-02_JPRB, 0.216607E-02_JPRB &
  &, 0.195254E-02_JPRB, 0.173267E-02_JPRB, 0.156874E-02_JPRB, 0.139998E-02_JPRB &
  &, 0.122635E-02_JPRB, 0.111265E-02_JPRB, 0.995667E-03_JPRB/)
XCW( 499, :) = (/ &
  &  0.996294E+00_JPRB, 0.994328E+00_JPRB, 0.991947E+00_JPRB, 0.989156E+00_JPRB &
  &, 0.985952E+00_JPRB, 0.982338E+00_JPRB, 0.978316E+00_JPRB &
  &, 0.973888E+00_JPRB, 0.969056E+00_JPRB, 0.963823E+00_JPRB, 0.958191E+00_JPRB &
  &, 0.952164E+00_JPRB, 0.945744E+00_JPRB, 0.938936E+00_JPRB &
  &, 0.931745E+00_JPRB, 0.924173E+00_JPRB, 0.916226E+00_JPRB, 0.907910E+00_JPRB &
  &, 0.899231E+00_JPRB, 0.890191E+00_JPRB, 0.880803E+00_JPRB &
  &, 0.871069E+00_JPRB, 0.861000E+00_JPRB, 0.850599E+00_JPRB, 0.839883E+00_JPRB &
  &, 0.828854E+00_JPRB, 0.817524E+00_JPRB, 0.805900E+00_JPRB &
  &, 0.793998E+00_JPRB, 0.781828E+00_JPRB, 0.769398E+00_JPRB, 0.756727E+00_JPRB &
  &, 0.743820E+00_JPRB, 0.730694E+00_JPRB, 0.717364E+00_JPRB &
  &, 0.703839E+00_JPRB, 0.690145E+00_JPRB, 0.676285E+00_JPRB, 0.662274E+00_JPRB &
  &, 0.648140E+00_JPRB, 0.633887E+00_JPRB, 0.619538E+00_JPRB &
  &, 0.605111E+00_JPRB, 0.590605E+00_JPRB, 0.576061E+00_JPRB, 0.561471E+00_JPRB &
  &, 0.546881E+00_JPRB, 0.532283E+00_JPRB, 0.517704E+00_JPRB &
  &, 0.503147E+00_JPRB, 0.488656E+00_JPRB, 0.474220E+00_JPRB, 0.459870E+00_JPRB &
  &, 0.445611E+00_JPRB, 0.431473E+00_JPRB, 0.417460E+00_JPRB &
  &, 0.403573E+00_JPRB, 0.389858E+00_JPRB, 0.376302E+00_JPRB, 0.362935E+00_JPRB &
  &, 0.349754E+00_JPRB, 0.336774E+00_JPRB, 0.324005E+00_JPRB &
  &, 0.311479E+00_JPRB, 0.299186E+00_JPRB, 0.287118E+00_JPRB, 0.275318E+00_JPRB &
  &, 0.263794E+00_JPRB, 0.252511E+00_JPRB, 0.241512E+00_JPRB &
  &, 0.230798E+00_JPRB, 0.220349E+00_JPRB, 0.210204E+00_JPRB, 0.200338E+00_JPRB &
  &, 0.190768E+00_JPRB, 0.181509E+00_JPRB, 0.172530E+00_JPRB &
  &, 0.163841E+00_JPRB, 0.155453E+00_JPRB, 0.147352E+00_JPRB, 0.139571E+00_JPRB &
  &, 0.132065E+00_JPRB, 0.124838E+00_JPRB, 0.117893E+00_JPRB &
  &, 0.111260E+00_JPRB, 0.104883E+00_JPRB, 0.987895E-01_JPRB, 0.929468E-01_JPRB &
  &, 0.873798E-01_JPRB, 0.820522E-01_JPRB, 0.769867E-01_JPRB &
  &, 0.721744E-01_JPRB, 0.675728E-01_JPRB, 0.632337E-01_JPRB, 0.591112E-01_JPRB &
  &, 0.551897E-01_JPRB, 0.514857E-01_JPRB, 0.479815E-01_JPRB &
  &, 0.446926E-01_JPRB, 0.415624E-01_JPRB, 0.386037E-01_JPRB, 0.358670E-01_JPRB &
  &, 0.332529E-01_JPRB, 0.308101E-01_JPRB, 0.285110E-01_JPRB &
  &, 0.263658E-01_JPRB, 0.243850E-01_JPRB, 0.224964E-01_JPRB, 0.207490E-01_JPRB &
  &, 0.191090E-01_JPRB, 0.175838E-01_JPRB, 0.161806E-01_JPRB &
  &, 0.148621E-01_JPRB, 0.136339E-01_JPRB, 0.125016E-01_JPRB, 0.114241E-01_JPRB &
  &, 0.104527E-01_JPRB, 0.954518E-02_JPRB, 0.875445E-02_JPRB &
  &, 0.798701E-02_JPRB, 0.724472E-02_JPRB, 0.658082E-02_JPRB, 0.599949E-02_JPRB &
  &, 0.545216E-02_JPRB, 0.494088E-02_JPRB, 0.446772E-02_JPRB &
  &, 0.408994E-02_JPRB, 0.370020E-02_JPRB, 0.329836E-02_JPRB, 0.299926E-02_JPRB &
  &, 0.269095E-02_JPRB, 0.243241E-02_JPRB, 0.216607E-02_JPRB &
  &, 0.195254E-02_JPRB, 0.179419E-02_JPRB, 0.156874E-02_JPRB, 0.139998E-02_JPRB &
  &, 0.129037E-02_JPRB, 0.111265E-02_JPRB, 0.995667E-03_JPRB/)
XCW( 500, :) = (/ &
  &  0.996546E+00_JPRB, 0.994643E+00_JPRB, 0.992322E+00_JPRB, 0.989592E+00_JPRB &
  &, 0.986450E+00_JPRB, 0.982897E+00_JPRB, 0.978935E+00_JPRB &
  &, 0.974568E+00_JPRB, 0.969795E+00_JPRB, 0.964579E+00_JPRB, 0.959048E+00_JPRB &
  &, 0.953078E+00_JPRB, 0.946716E+00_JPRB, 0.939964E+00_JPRB &
  &, 0.932827E+00_JPRB, 0.925312E+00_JPRB, 0.917418E+00_JPRB, 0.909155E+00_JPRB &
  &, 0.900527E+00_JPRB, 0.891539E+00_JPRB, 0.882200E+00_JPRB &
  &, 0.872515E+00_JPRB, 0.862492E+00_JPRB, 0.852140E+00_JPRB, 0.841464E+00_JPRB &
  &, 0.830479E+00_JPRB, 0.819189E+00_JPRB, 0.807610E+00_JPRB &
  &, 0.795746E+00_JPRB, 0.783611E+00_JPRB, 0.771217E+00_JPRB, 0.758579E+00_JPRB &
  &, 0.745706E+00_JPRB, 0.732614E+00_JPRB, 0.719310E+00_JPRB &
  &, 0.705811E+00_JPRB, 0.692138E+00_JPRB, 0.678309E+00_JPRB, 0.664319E+00_JPRB &
  &, 0.650207E+00_JPRB, 0.635973E+00_JPRB, 0.621634E+00_JPRB &
  &, 0.607216E+00_JPRB, 0.592727E+00_JPRB, 0.578191E+00_JPRB, 0.563605E+00_JPRB &
  &, 0.549019E+00_JPRB, 0.534424E+00_JPRB, 0.519846E+00_JPRB &
  &, 0.505289E+00_JPRB, 0.490796E+00_JPRB, 0.476356E+00_JPRB, 0.461987E+00_JPRB &
  &, 0.447721E+00_JPRB, 0.433574E+00_JPRB, 0.419534E+00_JPRB &
  &, 0.405649E+00_JPRB, 0.391904E+00_JPRB, 0.378330E+00_JPRB, 0.364943E+00_JPRB &
  &, 0.351740E+00_JPRB, 0.338735E+00_JPRB, 0.325958E+00_JPRB &
  &, 0.313384E+00_JPRB, 0.301060E+00_JPRB, 0.288975E+00_JPRB, 0.277139E+00_JPRB &
  &, 0.265575E+00_JPRB, 0.254250E+00_JPRB, 0.243226E+00_JPRB &
  &, 0.232464E+00_JPRB, 0.221985E+00_JPRB, 0.211808E+00_JPRB, 0.201909E+00_JPRB &
  &, 0.192302E+00_JPRB, 0.182981E+00_JPRB, 0.173960E+00_JPRB &
  &, 0.165227E+00_JPRB, 0.156818E+00_JPRB, 0.148668E+00_JPRB, 0.140835E+00_JPRB &
  &, 0.133275E+00_JPRB, 0.126018E+00_JPRB, 0.119041E+00_JPRB &
  &, 0.112346E+00_JPRB, 0.105933E+00_JPRB, 0.998013E-01_JPRB, 0.939186E-01_JPRB &
  &, 0.883095E-01_JPRB, 0.829686E-01_JPRB, 0.778575E-01_JPRB &
  &, 0.729977E-01_JPRB, 0.683787E-01_JPRB, 0.639883E-01_JPRB, 0.598124E-01_JPRB &
  &, 0.558692E-01_JPRB, 0.521426E-01_JPRB, 0.486145E-01_JPRB &
  &, 0.452650E-01_JPRB, 0.421082E-01_JPRB, 0.391587E-01_JPRB, 0.363562E-01_JPRB &
  &, 0.337120E-01_JPRB, 0.312768E-01_JPRB, 0.289458E-01_JPRB &
  &, 0.267675E-01_JPRB, 0.247525E-01_JPRB, 0.228283E-01_JPRB, 0.210862E-01_JPRB &
  &, 0.194088E-01_JPRB, 0.178883E-01_JPRB, 0.164457E-01_JPRB &
  &, 0.150864E-01_JPRB, 0.138617E-01_JPRB, 0.127329E-01_JPRB, 0.116589E-01_JPRB &
  &, 0.106435E-01_JPRB, 0.973879E-02_JPRB, 0.890183E-02_JPRB &
  &, 0.813658E-02_JPRB, 0.739649E-02_JPRB, 0.673482E-02_JPRB, 0.610366E-02_JPRB &
  &, 0.555784E-02_JPRB, 0.504807E-02_JPRB, 0.457644E-02_JPRB &
  &, 0.414507E-02_JPRB, 0.375611E-02_JPRB, 0.341176E-02_JPRB, 0.305674E-02_JPRB &
  &, 0.274923E-02_JPRB, 0.249149E-02_JPRB, 0.222596E-02_JPRB &
  &, 0.201324E-02_JPRB, 0.179419E-02_JPRB, 0.163109E-02_JPRB, 0.146316E-02_JPRB &
  &, 0.129037E-02_JPRB, 0.117751E-02_JPRB, 0.106138E-02_JPRB/)
XCW( 501, :) = (/ &
  &  0.996795E+00_JPRB, 0.994954E+00_JPRB, 0.992697E+00_JPRB, 0.990029E+00_JPRB &
  &, 0.986948E+00_JPRB, 0.983456E+00_JPRB, 0.979555E+00_JPRB &
  &, 0.975247E+00_JPRB, 0.970535E+00_JPRB, 0.965420E+00_JPRB, 0.959905E+00_JPRB &
  &, 0.953993E+00_JPRB, 0.947688E+00_JPRB, 0.940993E+00_JPRB &
  &, 0.933912E+00_JPRB, 0.926450E+00_JPRB, 0.918611E+00_JPRB, 0.910401E+00_JPRB &
  &, 0.901824E+00_JPRB, 0.892887E+00_JPRB, 0.883598E+00_JPRB &
  &, 0.873960E+00_JPRB, 0.863984E+00_JPRB, 0.853678E+00_JPRB, 0.843048E+00_JPRB &
  &, 0.832094E+00_JPRB, 0.820862E+00_JPRB, 0.809319E+00_JPRB &
  &, 0.797494E+00_JPRB, 0.785398E+00_JPRB, 0.773041E+00_JPRB, 0.760436E+00_JPRB &
  &, 0.747596E+00_JPRB, 0.734534E+00_JPRB, 0.721260E+00_JPRB &
  &, 0.707792E+00_JPRB, 0.694141E+00_JPRB, 0.680333E+00_JPRB, 0.666364E+00_JPRB &
  &, 0.652273E+00_JPRB, 0.638049E+00_JPRB, 0.623730E+00_JPRB &
  &, 0.609331E+00_JPRB, 0.594850E+00_JPRB, 0.580320E+00_JPRB, 0.565751E+00_JPRB &
  &, 0.551158E+00_JPRB, 0.536565E+00_JPRB, 0.521988E+00_JPRB &
  &, 0.507444E+00_JPRB, 0.492936E+00_JPRB, 0.478493E+00_JPRB, 0.464119E+00_JPRB &
  &, 0.449845E+00_JPRB, 0.435674E+00_JPRB, 0.421639E+00_JPRB &
  &, 0.407726E+00_JPRB, 0.393966E+00_JPRB, 0.380374E+00_JPRB, 0.366968E+00_JPRB &
  &, 0.353743E+00_JPRB, 0.340714E+00_JPRB, 0.327893E+00_JPRB &
  &, 0.315308E+00_JPRB, 0.302952E+00_JPRB, 0.290833E+00_JPRB, 0.278960E+00_JPRB &
  &, 0.267356E+00_JPRB, 0.256009E+00_JPRB, 0.244940E+00_JPRB &
  &, 0.234151E+00_JPRB, 0.223643E+00_JPRB, 0.213413E+00_JPRB, 0.203479E+00_JPRB &
  &, 0.193814E+00_JPRB, 0.184477E+00_JPRB, 0.175414E+00_JPRB &
  &, 0.166638E+00_JPRB, 0.158182E+00_JPRB, 0.150009E+00_JPRB, 0.142125E+00_JPRB &
  &, 0.134537E+00_JPRB, 0.127224E+00_JPRB, 0.120216E+00_JPRB &
  &, 0.113488E+00_JPRB, 0.107011E+00_JPRB, 0.100842E+00_JPRB, 0.949198E-01_JPRB &
  &, 0.892693E-01_JPRB, 0.838849E-01_JPRB, 0.787284E-01_JPRB &
  &, 0.738210E-01_JPRB, 0.691846E-01_JPRB, 0.647429E-01_JPRB, 0.605470E-01_JPRB &
  &, 0.565827E-01_JPRB, 0.527994E-01_JPRB, 0.492476E-01_JPRB &
  &, 0.458732E-01_JPRB, 0.426904E-01_JPRB, 0.396767E-01_JPRB, 0.368453E-01_JPRB &
  &, 0.342093E-01_JPRB, 0.317046E-01_JPRB, 0.293806E-01_JPRB &
  &, 0.271693E-01_JPRB, 0.251199E-01_JPRB, 0.232017E-01_JPRB, 0.214234E-01_JPRB &
  &, 0.197514E-01_JPRB, 0.181493E-01_JPRB, 0.167108E-01_JPRB &
  &, 0.153557E-01_JPRB, 0.140895E-01_JPRB, 0.129180E-01_JPRB, 0.118468E-01_JPRB &
  &, 0.108342E-01_JPRB, 0.993240E-02_JPRB, 0.904921E-02_JPRB &
  &, 0.828614E-02_JPRB, 0.754827E-02_JPRB, 0.688882E-02_JPRB, 0.625990E-02_JPRB &
  &, 0.566351E-02_JPRB, 0.515526E-02_JPRB, 0.468517E-02_JPRB &
  &, 0.425534E-02_JPRB, 0.386794E-02_JPRB, 0.346845E-02_JPRB, 0.311423E-02_JPRB &
  &, 0.280751E-02_JPRB, 0.255057E-02_JPRB, 0.228585E-02_JPRB &
  &, 0.207395E-02_JPRB, 0.185572E-02_JPRB, 0.169343E-02_JPRB, 0.146316E-02_JPRB &
  &, 0.135439E-02_JPRB, 0.117751E-02_JPRB, 0.106138E-02_JPRB/)
XCW( 502, :) = (/ &
  &  0.997046E+00_JPRB, 0.995266E+00_JPRB, 0.993072E+00_JPRB, 0.990466E+00_JPRB &
  &, 0.987446E+00_JPRB, 0.984015E+00_JPRB, 0.980176E+00_JPRB &
  &, 0.975927E+00_JPRB, 0.971274E+00_JPRB, 0.966219E+00_JPRB, 0.960762E+00_JPRB &
  &, 0.954908E+00_JPRB, 0.948660E+00_JPRB, 0.942022E+00_JPRB &
  &, 0.934998E+00_JPRB, 0.927589E+00_JPRB, 0.919805E+00_JPRB, 0.911648E+00_JPRB &
  &, 0.903123E+00_JPRB, 0.894236E+00_JPRB, 0.884995E+00_JPRB &
  &, 0.875409E+00_JPRB, 0.865480E+00_JPRB, 0.855222E+00_JPRB, 0.844636E+00_JPRB &
  &, 0.833739E+00_JPRB, 0.822534E+00_JPRB, 0.811033E+00_JPRB &
  &, 0.799250E+00_JPRB, 0.787189E+00_JPRB, 0.774868E+00_JPRB, 0.762296E+00_JPRB &
  &, 0.749491E+00_JPRB, 0.736458E+00_JPRB, 0.723215E+00_JPRB &
  &, 0.709773E+00_JPRB, 0.696153E+00_JPRB, 0.682357E+00_JPRB, 0.668419E+00_JPRB &
  &, 0.654339E+00_JPRB, 0.640136E+00_JPRB, 0.625836E+00_JPRB &
  &, 0.611446E+00_JPRB, 0.596973E+00_JPRB, 0.582461E+00_JPRB, 0.567898E+00_JPRB &
  &, 0.553308E+00_JPRB, 0.538718E+00_JPRB, 0.524143E+00_JPRB &
  &, 0.509586E+00_JPRB, 0.495089E+00_JPRB, 0.480629E+00_JPRB, 0.466264E+00_JPRB &
  &, 0.451969E+00_JPRB, 0.437790E+00_JPRB, 0.423744E+00_JPRB &
  &, 0.409818E+00_JPRB, 0.396043E+00_JPRB, 0.382435E+00_JPRB, 0.368992E+00_JPRB &
  &, 0.355746E+00_JPRB, 0.342693E+00_JPRB, 0.329845E+00_JPRB &
  &, 0.317231E+00_JPRB, 0.304844E+00_JPRB, 0.292710E+00_JPRB, 0.280800E+00_JPRB &
  &, 0.269157E+00_JPRB, 0.257788E+00_JPRB, 0.246675E+00_JPRB &
  &, 0.235838E+00_JPRB, 0.225301E+00_JPRB, 0.215018E+00_JPRB, 0.205050E+00_JPRB &
  &, 0.195371E+00_JPRB, 0.185972E+00_JPRB, 0.176869E+00_JPRB &
  &, 0.168073E+00_JPRB, 0.159547E+00_JPRB, 0.151324E+00_JPRB, 0.143415E+00_JPRB &
  &, 0.135773E+00_JPRB, 0.128431E+00_JPRB, 0.121364E+00_JPRB &
  &, 0.114602E+00_JPRB, 0.108090E+00_JPRB, 0.101883E+00_JPRB, 0.959211E-01_JPRB &
  &, 0.902291E-01_JPRB, 0.848012E-01_JPRB, 0.796303E-01_JPRB &
  &, 0.746760E-01_JPRB, 0.699904E-01_JPRB, 0.655303E-01_JPRB, 0.612816E-01_JPRB &
  &, 0.572623E-01_JPRB, 0.534563E-01_JPRB, 0.498806E-01_JPRB &
  &, 0.464813E-01_JPRB, 0.432725E-01_JPRB, 0.402318E-01_JPRB, 0.373720E-01_JPRB &
  &, 0.347066E-01_JPRB, 0.321712E-01_JPRB, 0.298155E-01_JPRB &
  &, 0.275711E-01_JPRB, 0.255282E-01_JPRB, 0.235751E-01_JPRB, 0.217606E-01_JPRB &
  &, 0.200511E-01_JPRB, 0.184538E-01_JPRB, 0.169759E-01_JPRB &
  &, 0.156249E-01_JPRB, 0.143629E-01_JPRB, 0.131493E-01_JPRB, 0.120817E-01_JPRB &
  &, 0.110249E-01_JPRB, 0.101260E-01_JPRB, 0.924571E-02_JPRB &
  &, 0.843571E-02_JPRB, 0.770005E-02_JPRB, 0.699149E-02_JPRB, 0.636407E-02_JPRB &
  &, 0.582202E-02_JPRB, 0.526246E-02_JPRB, 0.479389E-02_JPRB &
  &, 0.431047E-02_JPRB, 0.392385E-02_JPRB, 0.352515E-02_JPRB, 0.322920E-02_JPRB &
  &, 0.292407E-02_JPRB, 0.260966E-02_JPRB, 0.234574E-02_JPRB &
  &, 0.213465E-02_JPRB, 0.191724E-02_JPRB, 0.169343E-02_JPRB, 0.152634E-02_JPRB &
  &, 0.135439E-02_JPRB, 0.124237E-02_JPRB, 0.112709E-02_JPRB/)
XCW( 503, :) = (/ &
  &  0.997295E+00_JPRB, 0.995580E+00_JPRB, 0.993447E+00_JPRB, 0.990903E+00_JPRB &
  &, 0.987944E+00_JPRB, 0.984575E+00_JPRB, 0.980795E+00_JPRB &
  &, 0.976608E+00_JPRB, 0.972015E+00_JPRB, 0.967019E+00_JPRB, 0.961621E+00_JPRB &
  &, 0.955824E+00_JPRB, 0.949633E+00_JPRB, 0.943052E+00_JPRB &
  &, 0.936083E+00_JPRB, 0.928731E+00_JPRB, 0.921000E+00_JPRB, 0.912895E+00_JPRB &
  &, 0.904423E+00_JPRB, 0.895587E+00_JPRB, 0.886399E+00_JPRB &
  &, 0.876858E+00_JPRB, 0.866979E+00_JPRB, 0.856766E+00_JPRB, 0.846224E+00_JPRB &
  &, 0.835372E+00_JPRB, 0.824207E+00_JPRB, 0.812750E+00_JPRB &
  &, 0.801005E+00_JPRB, 0.788984E+00_JPRB, 0.776700E+00_JPRB, 0.764161E+00_JPRB &
  &, 0.751385E+00_JPRB, 0.738383E+00_JPRB, 0.725170E+00_JPRB &
  &, 0.711754E+00_JPRB, 0.698156E+00_JPRB, 0.684391E+00_JPRB, 0.670475E+00_JPRB &
  &, 0.656415E+00_JPRB, 0.642233E+00_JPRB, 0.627943E+00_JPRB &
  &, 0.613561E+00_JPRB, 0.599107E+00_JPRB, 0.584601E+00_JPRB, 0.570044E+00_JPRB &
  &, 0.555471E+00_JPRB, 0.540884E+00_JPRB, 0.526298E+00_JPRB &
  &, 0.511754E+00_JPRB, 0.497242E+00_JPRB, 0.482779E+00_JPRB, 0.468395E+00_JPRB &
  &, 0.454108E+00_JPRB, 0.439920E+00_JPRB, 0.425849E+00_JPRB &
  &, 0.411910E+00_JPRB, 0.398120E+00_JPRB, 0.384479E+00_JPRB, 0.371034E+00_JPRB &
  &, 0.357749E+00_JPRB, 0.344690E+00_JPRB, 0.331815E+00_JPRB &
  &, 0.319173E+00_JPRB, 0.306754E+00_JPRB, 0.294587E+00_JPRB, 0.282640E+00_JPRB &
  &, 0.270978E+00_JPRB, 0.259567E+00_JPRB, 0.248409E+00_JPRB &
  &, 0.237547E+00_JPRB, 0.226959E+00_JPRB, 0.216666E+00_JPRB, 0.206643E+00_JPRB &
  &, 0.196905E+00_JPRB, 0.187468E+00_JPRB, 0.178347E+00_JPRB &
  &, 0.169483E+00_JPRB, 0.160936E+00_JPRB, 0.152665E+00_JPRB, 0.144705E+00_JPRB &
  &, 0.137036E+00_JPRB, 0.129664E+00_JPRB, 0.122539E+00_JPRB &
  &, 0.115743E+00_JPRB, 0.109196E+00_JPRB, 0.102923E+00_JPRB, 0.969223E-01_JPRB &
  &, 0.911889E-01_JPRB, 0.857176E-01_JPRB, 0.805012E-01_JPRB &
  &, 0.755309E-01_JPRB, 0.707963E-01_JPRB, 0.663177E-01_JPRB, 0.620162E-01_JPRB &
  &, 0.579758E-01_JPRB, 0.541477E-01_JPRB, 0.505137E-01_JPRB &
  &, 0.470895E-01_JPRB, 0.438183E-01_JPRB, 0.407868E-01_JPRB, 0.378988E-01_JPRB &
  &, 0.352039E-01_JPRB, 0.326379E-01_JPRB, 0.302503E-01_JPRB &
  &, 0.280130E-01_JPRB, 0.258957E-01_JPRB, 0.239485E-01_JPRB, 0.220979E-01_JPRB &
  &, 0.203509E-01_JPRB, 0.187583E-01_JPRB, 0.172851E-01_JPRB &
  &, 0.158941E-01_JPRB, 0.145907E-01_JPRB, 0.133806E-01_JPRB, 0.122695E-01_JPRB &
  &, 0.112634E-01_JPRB, 0.102712E-01_JPRB, 0.939309E-02_JPRB &
  &, 0.858528E-02_JPRB, 0.785183E-02_JPRB, 0.714549E-02_JPRB, 0.652032E-02_JPRB &
  &, 0.592769E-02_JPRB, 0.536965E-02_JPRB, 0.490262E-02_JPRB &
  &, 0.442074E-02_JPRB, 0.403567E-02_JPRB, 0.363854E-02_JPRB, 0.328668E-02_JPRB &
  &, 0.298235E-02_JPRB, 0.266874E-02_JPRB, 0.240563E-02_JPRB &
  &, 0.219536E-02_JPRB, 0.197877E-02_JPRB, 0.175578E-02_JPRB, 0.158952E-02_JPRB &
  &, 0.141840E-02_JPRB, 0.124237E-02_JPRB, 0.112709E-02_JPRB/)
XCW( 504, :) = (/ &
  &  0.997548E+00_JPRB, 0.995893E+00_JPRB, 0.993822E+00_JPRB, 0.991339E+00_JPRB &
  &, 0.988442E+00_JPRB, 0.985134E+00_JPRB, 0.981416E+00_JPRB &
  &, 0.977289E+00_JPRB, 0.972755E+00_JPRB, 0.967819E+00_JPRB, 0.962480E+00_JPRB &
  &, 0.956741E+00_JPRB, 0.950608E+00_JPRB, 0.944082E+00_JPRB &
  &, 0.937169E+00_JPRB, 0.929872E+00_JPRB, 0.922195E+00_JPRB, 0.914145E+00_JPRB &
  &, 0.905724E+00_JPRB, 0.896942E+00_JPRB, 0.887800E+00_JPRB &
  &, 0.878310E+00_JPRB, 0.868478E+00_JPRB, 0.858311E+00_JPRB, 0.847816E+00_JPRB &
  &, 0.837005E+00_JPRB, 0.825887E+00_JPRB, 0.814467E+00_JPRB &
  &, 0.802761E+00_JPRB, 0.790779E+00_JPRB, 0.778532E+00_JPRB, 0.766030E+00_JPRB &
  &, 0.753288E+00_JPRB, 0.740316E+00_JPRB, 0.727062E+00_JPRB &
  &, 0.713745E+00_JPRB, 0.700178E+00_JPRB, 0.686435E+00_JPRB, 0.672530E+00_JPRB &
  &, 0.658491E+00_JPRB, 0.644330E+00_JPRB, 0.630060E+00_JPRB &
  &, 0.615688E+00_JPRB, 0.601252E+00_JPRB, 0.586754E+00_JPRB, 0.572202E+00_JPRB &
  &, 0.557634E+00_JPRB, 0.543050E+00_JPRB, 0.528466E+00_JPRB &
  &, 0.513922E+00_JPRB, 0.499382E+00_JPRB, 0.484943E+00_JPRB, 0.470555E+00_JPRB &
  &, 0.456247E+00_JPRB, 0.442051E+00_JPRB, 0.427969E+00_JPRB &
  &, 0.414018E+00_JPRB, 0.400198E+00_JPRB, 0.386556E+00_JPRB, 0.373075E+00_JPRB &
  &, 0.359787E+00_JPRB, 0.346686E+00_JPRB, 0.333786E+00_JPRB &
  &, 0.321115E+00_JPRB, 0.308665E+00_JPRB, 0.296463E+00_JPRB, 0.284500E+00_JPRB &
  &, 0.272799E+00_JPRB, 0.261346E+00_JPRB, 0.250164E+00_JPRB &
  &, 0.239255E+00_JPRB, 0.228639E+00_JPRB, 0.218293E+00_JPRB, 0.208236E+00_JPRB &
  &, 0.198462E+00_JPRB, 0.188987E+00_JPRB, 0.179801E+00_JPRB &
  &, 0.170918E+00_JPRB, 0.162325E+00_JPRB, 0.154031E+00_JPRB, 0.146020E+00_JPRB &
  &, 0.138298E+00_JPRB, 0.130870E+00_JPRB, 0.123741E+00_JPRB &
  &, 0.116885E+00_JPRB, 0.110303E+00_JPRB, 0.103993E+00_JPRB, 0.979529E-01_JPRB &
  &, 0.921786E-01_JPRB, 0.866644E-01_JPRB, 0.814031E-01_JPRB &
  &, 0.763859E-01_JPRB, 0.716344E-01_JPRB, 0.671052E-01_JPRB, 0.627842E-01_JPRB &
  &, 0.586893E-01_JPRB, 0.548391E-01_JPRB, 0.511468E-01_JPRB &
  &, 0.476977E-01_JPRB, 0.444369E-01_JPRB, 0.413419E-01_JPRB, 0.384256E-01_JPRB &
  &, 0.357012E-01_JPRB, 0.331046E-01_JPRB, 0.306851E-01_JPRB &
  &, 0.284148E-01_JPRB, 0.263040E-01_JPRB, 0.242804E-01_JPRB, 0.224351E-01_JPRB &
  &, 0.206935E-01_JPRB, 0.190628E-01_JPRB, 0.175502E-01_JPRB &
  &, 0.161633E-01_JPRB, 0.148641E-01_JPRB, 0.136119E-01_JPRB, 0.125044E-01_JPRB &
  &, 0.114541E-01_JPRB, 0.104648E-01_JPRB, 0.958960E-02_JPRB &
  &, 0.873485E-02_JPRB, 0.800360E-02_JPRB, 0.729950E-02_JPRB, 0.662448E-02_JPRB &
  &, 0.603336E-02_JPRB, 0.547684E-02_JPRB, 0.501134E-02_JPRB &
  &, 0.453101E-02_JPRB, 0.409159E-02_JPRB, 0.369524E-02_JPRB, 0.334417E-02_JPRB &
  &, 0.304063E-02_JPRB, 0.272782E-02_JPRB, 0.246552E-02_JPRB &
  &, 0.219536E-02_JPRB, 0.197877E-02_JPRB, 0.181813E-02_JPRB, 0.158952E-02_JPRB &
  &, 0.141840E-02_JPRB, 0.130724E-02_JPRB, 0.112709E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART72',1,ZHOOK_HANDLE)
END SUBROUTINE PART72

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART73

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART73',0,ZHOOK_HANDLE)

XCW( 505, :) = (/ &
  &  0.997796E+00_JPRB, 0.996205E+00_JPRB, 0.994196E+00_JPRB, 0.991776E+00_JPRB &
  &, 0.988941E+00_JPRB, 0.985694E+00_JPRB, 0.982037E+00_JPRB &
  &, 0.977970E+00_JPRB, 0.973497E+00_JPRB, 0.968619E+00_JPRB, 0.963339E+00_JPRB &
  &, 0.957659E+00_JPRB, 0.951583E+00_JPRB, 0.945114E+00_JPRB &
  &, 0.938257E+00_JPRB, 0.931016E+00_JPRB, 0.923393E+00_JPRB, 0.915395E+00_JPRB &
  &, 0.907027E+00_JPRB, 0.898293E+00_JPRB, 0.889204E+00_JPRB &
  &, 0.879759E+00_JPRB, 0.869981E+00_JPRB, 0.859859E+00_JPRB, 0.849411E+00_JPRB &
  &, 0.838642E+00_JPRB, 0.827564E+00_JPRB, 0.816189E+00_JPRB &
  &, 0.804520E+00_JPRB, 0.792578E+00_JPRB, 0.780367E+00_JPRB, 0.767899E+00_JPRB &
  &, 0.755191E+00_JPRB, 0.742250E+00_JPRB, 0.729098E+00_JPRB &
  &, 0.715735E+00_JPRB, 0.702190E+00_JPRB, 0.688478E+00_JPRB, 0.674595E+00_JPRB &
  &, 0.660578E+00_JPRB, 0.646438E+00_JPRB, 0.632178E+00_JPRB &
  &, 0.617825E+00_JPRB, 0.603398E+00_JPRB, 0.588906E+00_JPRB, 0.574360E+00_JPRB &
  &, 0.559796E+00_JPRB, 0.545216E+00_JPRB, 0.530646E+00_JPRB &
  &, 0.516090E+00_JPRB, 0.501576E+00_JPRB, 0.487107E+00_JPRB, 0.472714E+00_JPRB &
  &, 0.458400E+00_JPRB, 0.444181E+00_JPRB, 0.430089E+00_JPRB &
  &, 0.416125E+00_JPRB, 0.402291E+00_JPRB, 0.388632E+00_JPRB, 0.375133E+00_JPRB &
  &, 0.361807E+00_JPRB, 0.348682E+00_JPRB, 0.335774E+00_JPRB &
  &, 0.323074E+00_JPRB, 0.310594E+00_JPRB, 0.298359E+00_JPRB, 0.286360E+00_JPRB &
  &, 0.274620E+00_JPRB, 0.263146E+00_JPRB, 0.251940E+00_JPRB &
  &, 0.240984E+00_JPRB, 0.230318E+00_JPRB, 0.219942E+00_JPRB, 0.209852E+00_JPRB &
  &, 0.200042E+00_JPRB, 0.190529E+00_JPRB, 0.181303E+00_JPRB &
  &, 0.172378E+00_JPRB, 0.163739E+00_JPRB, 0.155398E+00_JPRB, 0.147336E+00_JPRB &
  &, 0.139587E+00_JPRB, 0.132104E+00_JPRB, 0.124916E+00_JPRB &
  &, 0.118027E+00_JPRB, 0.111409E+00_JPRB, 0.105063E+00_JPRB, 0.989836E-01_JPRB &
  &, 0.931684E-01_JPRB, 0.876113E-01_JPRB, 0.823051E-01_JPRB &
  &, 0.772725E-01_JPRB, 0.724724E-01_JPRB, 0.678926E-01_JPRB, 0.635522E-01_JPRB &
  &, 0.594369E-01_JPRB, 0.555305E-01_JPRB, 0.518150E-01_JPRB &
  &, 0.483059E-01_JPRB, 0.450190E-01_JPRB, 0.418969E-01_JPRB, 0.389523E-01_JPRB &
  &, 0.361985E-01_JPRB, 0.335712E-01_JPRB, 0.311199E-01_JPRB &
  &, 0.288567E-01_JPRB, 0.266714E-01_JPRB, 0.246952E-01_JPRB, 0.227723E-01_JPRB &
  &, 0.210361E-01_JPRB, 0.193673E-01_JPRB, 0.178595E-01_JPRB &
  &, 0.164326E-01_JPRB, 0.150919E-01_JPRB, 0.138433E-01_JPRB, 0.127393E-01_JPRB &
  &, 0.116448E-01_JPRB, 0.106584E-01_JPRB, 0.978610E-02_JPRB &
  &, 0.893428E-02_JPRB, 0.815538E-02_JPRB, 0.745350E-02_JPRB, 0.678073E-02_JPRB &
  &, 0.613904E-02_JPRB, 0.558404E-02_JPRB, 0.506570E-02_JPRB &
  &, 0.464128E-02_JPRB, 0.420341E-02_JPRB, 0.380863E-02_JPRB, 0.345914E-02_JPRB &
  &, 0.309892E-02_JPRB, 0.278691E-02_JPRB, 0.252541E-02_JPRB &
  &, 0.225606E-02_JPRB, 0.204029E-02_JPRB, 0.181813E-02_JPRB, 0.165270E-02_JPRB &
  &, 0.148242E-02_JPRB, 0.130724E-02_JPRB, 0.119280E-02_JPRB/)
XCW( 506, :) = (/ &
  &  0.998048E+00_JPRB, 0.996520E+00_JPRB, 0.994572E+00_JPRB, 0.992214E+00_JPRB &
  &, 0.989440E+00_JPRB, 0.986254E+00_JPRB, 0.982657E+00_JPRB &
  &, 0.978651E+00_JPRB, 0.974238E+00_JPRB, 0.969420E+00_JPRB, 0.964196E+00_JPRB &
  &, 0.958576E+00_JPRB, 0.952558E+00_JPRB, 0.946147E+00_JPRB &
  &, 0.939345E+00_JPRB, 0.932158E+00_JPRB, 0.924590E+00_JPRB, 0.916646E+00_JPRB &
  &, 0.908331E+00_JPRB, 0.899651E+00_JPRB, 0.890611E+00_JPRB &
  &, 0.881218E+00_JPRB, 0.871483E+00_JPRB, 0.861410E+00_JPRB, 0.851006E+00_JPRB &
  &, 0.840282E+00_JPRB, 0.829247E+00_JPRB, 0.817913E+00_JPRB &
  &, 0.806284E+00_JPRB, 0.794377E+00_JPRB, 0.782203E+00_JPRB, 0.769773E+00_JPRB &
  &, 0.757094E+00_JPRB, 0.744187E+00_JPRB, 0.731062E+00_JPRB &
  &, 0.717735E+00_JPRB, 0.704212E+00_JPRB, 0.690522E+00_JPRB, 0.676670E+00_JPRB &
  &, 0.662664E+00_JPRB, 0.648545E+00_JPRB, 0.634306E+00_JPRB &
  &, 0.619962E+00_JPRB, 0.605543E+00_JPRB, 0.591059E+00_JPRB, 0.576531E+00_JPRB &
  &, 0.561971E+00_JPRB, 0.547395E+00_JPRB, 0.532827E+00_JPRB &
  &, 0.518271E+00_JPRB, 0.503756E+00_JPRB, 0.489285E+00_JPRB, 0.474874E+00_JPRB &
  &, 0.460553E+00_JPRB, 0.446341E+00_JPRB, 0.432224E+00_JPRB &
  &, 0.418233E+00_JPRB, 0.404400E+00_JPRB, 0.390709E+00_JPRB, 0.377191E+00_JPRB &
  &, 0.363844E+00_JPRB, 0.350714E+00_JPRB, 0.337762E+00_JPRB &
  &, 0.325034E+00_JPRB, 0.312523E+00_JPRB, 0.300255E+00_JPRB, 0.288239E+00_JPRB &
  &, 0.276461E+00_JPRB, 0.264945E+00_JPRB, 0.253696E+00_JPRB &
  &, 0.242713E+00_JPRB, 0.232019E+00_JPRB, 0.221590E+00_JPRB, 0.211467E+00_JPRB &
  &, 0.201622E+00_JPRB, 0.192072E+00_JPRB, 0.182805E+00_JPRB &
  &, 0.173837E+00_JPRB, 0.165153E+00_JPRB, 0.156764E+00_JPRB, 0.148677E+00_JPRB &
  &, 0.140876E+00_JPRB, 0.133364E+00_JPRB, 0.126146E+00_JPRB &
  &, 0.119196E+00_JPRB, 0.112516E+00_JPRB, 0.106132E+00_JPRB, 0.100014E+00_JPRB &
  &, 0.941582E-01_JPRB, 0.885887E-01_JPRB, 0.832381E-01_JPRB &
  &, 0.781591E-01_JPRB, 0.733105E-01_JPRB, 0.686800E-01_JPRB, 0.643201E-01_JPRB &
  &, 0.601504E-01_JPRB, 0.562219E-01_JPRB, 0.524832E-01_JPRB &
  &, 0.489498E-01_JPRB, 0.456012E-01_JPRB, 0.424519E-01_JPRB, 0.394791E-01_JPRB &
  &, 0.366958E-01_JPRB, 0.340768E-01_JPRB, 0.315943E-01_JPRB &
  &, 0.292585E-01_JPRB, 0.270797E-01_JPRB, 0.250686E-01_JPRB, 0.231517E-01_JPRB &
  &, 0.213786E-01_JPRB, 0.197153E-01_JPRB, 0.181688E-01_JPRB &
  &, 0.167018E-01_JPRB, 0.153653E-01_JPRB, 0.141209E-01_JPRB, 0.129271E-01_JPRB &
  &, 0.118832E-01_JPRB, 0.108520E-01_JPRB, 0.993348E-02_JPRB &
  &, 0.908385E-02_JPRB, 0.830716E-02_JPRB, 0.755617E-02_JPRB, 0.688489E-02_JPRB &
  &, 0.629755E-02_JPRB, 0.574482E-02_JPRB, 0.517443E-02_JPRB &
  &, 0.469641E-02_JPRB, 0.425932E-02_JPRB, 0.386532E-02_JPRB, 0.351663E-02_JPRB &
  &, 0.315720E-02_JPRB, 0.284599E-02_JPRB, 0.258530E-02_JPRB &
  &, 0.231676E-02_JPRB, 0.210181E-02_JPRB, 0.188048E-02_JPRB, 0.171588E-02_JPRB &
  &, 0.154644E-02_JPRB, 0.137210E-02_JPRB, 0.119280E-02_JPRB/)
XCW( 507, :) = (/ &
  &  0.998300E+00_JPRB, 0.996832E+00_JPRB, 0.994947E+00_JPRB, 0.992651E+00_JPRB &
  &, 0.989939E+00_JPRB, 0.986814E+00_JPRB, 0.983279E+00_JPRB &
  &, 0.979333E+00_JPRB, 0.974979E+00_JPRB, 0.970221E+00_JPRB, 0.965059E+00_JPRB &
  &, 0.959496E+00_JPRB, 0.953534E+00_JPRB, 0.947180E+00_JPRB &
  &, 0.940435E+00_JPRB, 0.933304E+00_JPRB, 0.925789E+00_JPRB, 0.917899E+00_JPRB &
  &, 0.909637E+00_JPRB, 0.901006E+00_JPRB, 0.892018E+00_JPRB &
  &, 0.882677E+00_JPRB, 0.872985E+00_JPRB, 0.862961E+00_JPRB, 0.852601E+00_JPRB &
  &, 0.841923E+00_JPRB, 0.830931E+00_JPRB, 0.819638E+00_JPRB &
  &, 0.808051E+00_JPRB, 0.796185E+00_JPRB, 0.784039E+00_JPRB, 0.771650E+00_JPRB &
  &, 0.759006E+00_JPRB, 0.746130E+00_JPRB, 0.733035E+00_JPRB &
  &, 0.719735E+00_JPRB, 0.706243E+00_JPRB, 0.692576E+00_JPRB, 0.678736E+00_JPRB &
  &, 0.664761E+00_JPRB, 0.650653E+00_JPRB, 0.636434E+00_JPRB &
  &, 0.622111E+00_JPRB, 0.607700E+00_JPRB, 0.593234E+00_JPRB, 0.578713E+00_JPRB &
  &, 0.564159E+00_JPRB, 0.549586E+00_JPRB, 0.535008E+00_JPRB &
  &, 0.520452E+00_JPRB, 0.505937E+00_JPRB, 0.491463E+00_JPRB, 0.477048E+00_JPRB &
  &, 0.462721E+00_JPRB, 0.448486E+00_JPRB, 0.434359E+00_JPRB &
  &, 0.420371E+00_JPRB, 0.406509E+00_JPRB, 0.392802E+00_JPRB, 0.379266E+00_JPRB &
  &, 0.365898E+00_JPRB, 0.352727E+00_JPRB, 0.339768E+00_JPRB &
  &, 0.327012E+00_JPRB, 0.314470E+00_JPRB, 0.302170E+00_JPRB, 0.290118E+00_JPRB &
  &, 0.278321E+00_JPRB, 0.266765E+00_JPRB, 0.255471E+00_JPRB &
  &, 0.244463E+00_JPRB, 0.233720E+00_JPRB, 0.223261E+00_JPRB, 0.213083E+00_JPRB &
  &, 0.203203E+00_JPRB, 0.193614E+00_JPRB, 0.184307E+00_JPRB &
  &, 0.175296E+00_JPRB, 0.166567E+00_JPRB, 0.158155E+00_JPRB, 0.150019E+00_JPRB &
  &, 0.142164E+00_JPRB, 0.134624E+00_JPRB, 0.127348E+00_JPRB &
  &, 0.120366E+00_JPRB, 0.113651E+00_JPRB, 0.107231E+00_JPRB, 0.101074E+00_JPRB &
  &, 0.951780E-01_JPRB, 0.895356E-01_JPRB, 0.841712E-01_JPRB &
  &, 0.790457E-01_JPRB, 0.741486E-01_JPRB, 0.695002E-01_JPRB, 0.650881E-01_JPRB &
  &, 0.608979E-01_JPRB, 0.569133E-01_JPRB, 0.531514E-01_JPRB &
  &, 0.495937E-01_JPRB, 0.462198E-01_JPRB, 0.430440E-01_JPRB, 0.400435E-01_JPRB &
  &, 0.372314E-01_JPRB, 0.345435E-01_JPRB, 0.320687E-01_JPRB &
  &, 0.297004E-01_JPRB, 0.274880E-01_JPRB, 0.254420E-01_JPRB, 0.235310E-01_JPRB &
  &, 0.217212E-01_JPRB, 0.200198E-01_JPRB, 0.184339E-01_JPRB &
  &, 0.169710E-01_JPRB, 0.156387E-01_JPRB, 0.143522E-01_JPRB, 0.131620E-01_JPRB &
  &, 0.120740E-01_JPRB, 0.110940E-01_JPRB, 0.101300E-01_JPRB &
  &, 0.928327E-02_JPRB, 0.845893E-02_JPRB, 0.771017E-02_JPRB, 0.704114E-02_JPRB &
  &, 0.640322E-02_JPRB, 0.585202E-02_JPRB, 0.528315E-02_JPRB &
  &, 0.480668E-02_JPRB, 0.437115E-02_JPRB, 0.397872E-02_JPRB, 0.357411E-02_JPRB &
  &, 0.321548E-02_JPRB, 0.290507E-02_JPRB, 0.264519E-02_JPRB &
  &, 0.237747E-02_JPRB, 0.216334E-02_JPRB, 0.194283E-02_JPRB, 0.171588E-02_JPRB &
  &, 0.154644E-02_JPRB, 0.137210E-02_JPRB, 0.125851E-02_JPRB/)
XCW( 508, :) = (/ &
  &  0.998550E+00_JPRB, 0.997144E+00_JPRB, 0.995323E+00_JPRB, 0.993088E+00_JPRB &
  &, 0.990438E+00_JPRB, 0.987375E+00_JPRB, 0.983899E+00_JPRB &
  &, 0.980015E+00_JPRB, 0.975722E+00_JPRB, 0.971022E+00_JPRB, 0.965920E+00_JPRB &
  &, 0.960415E+00_JPRB, 0.954512E+00_JPRB, 0.948215E+00_JPRB &
  &, 0.941526E+00_JPRB, 0.934449E+00_JPRB, 0.926990E+00_JPRB, 0.919152E+00_JPRB &
  &, 0.910943E+00_JPRB, 0.902363E+00_JPRB, 0.893426E+00_JPRB &
  &, 0.884132E+00_JPRB, 0.874495E+00_JPRB, 0.864513E+00_JPRB, 0.854203E+00_JPRB &
  &, 0.843567E+00_JPRB, 0.832619E+00_JPRB, 0.821367E+00_JPRB &
  &, 0.809819E+00_JPRB, 0.797992E+00_JPRB, 0.785891E+00_JPRB, 0.773528E+00_JPRB &
  &, 0.760918E+00_JPRB, 0.748076E+00_JPRB, 0.735013E+00_JPRB &
  &, 0.721735E+00_JPRB, 0.708275E+00_JPRB, 0.694629E+00_JPRB, 0.680821E+00_JPRB &
  &, 0.666858E+00_JPRB, 0.652771E+00_JPRB, 0.638563E+00_JPRB &
  &, 0.624259E+00_JPRB, 0.609868E+00_JPRB, 0.595398E+00_JPRB, 0.580895E+00_JPRB &
  &, 0.566346E+00_JPRB, 0.551777E+00_JPRB, 0.537201E+00_JPRB &
  &, 0.522647E+00_JPRB, 0.508131E+00_JPRB, 0.493641E+00_JPRB, 0.479235E+00_JPRB &
  &, 0.464889E+00_JPRB, 0.450646E+00_JPRB, 0.436509E+00_JPRB &
  &, 0.422495E+00_JPRB, 0.408507E+00_JPRB, 0.394895E+00_JPRB, 0.381340E+00_JPRB &
  &, 0.367952E+00_JPRB, 0.354758E+00_JPRB, 0.341773E+00_JPRB &
  &, 0.328990E+00_JPRB, 0.316437E+00_JPRB, 0.304103E+00_JPRB, 0.292016E+00_JPRB &
  &, 0.280182E+00_JPRB, 0.268584E+00_JPRB, 0.257268E+00_JPRB &
  &, 0.246214E+00_JPRB, 0.235443E+00_JPRB, 0.224954E+00_JPRB, 0.214721E+00_JPRB &
  &, 0.204806E+00_JPRB, 0.195156E+00_JPRB, 0.185810E+00_JPRB &
  &, 0.176756E+00_JPRB, 0.168006E+00_JPRB, 0.159547E+00_JPRB, 0.151360E+00_JPRB &
  &, 0.143479E+00_JPRB, 0.135884E+00_JPRB, 0.128578E+00_JPRB &
  &, 0.121536E+00_JPRB, 0.114786E+00_JPRB, 0.108329E+00_JPRB, 0.102135E+00_JPRB &
  &, 0.961977E-01_JPRB, 0.905130E-01_JPRB, 0.851042E-01_JPRB &
  &, 0.799324E-01_JPRB, 0.750189E-01_JPRB, 0.703205E-01_JPRB, 0.658561E-01_JPRB &
  &, 0.616454E-01_JPRB, 0.576393E-01_JPRB, 0.538197E-01_JPRB &
  &, 0.502377E-01_JPRB, 0.468383E-01_JPRB, 0.436360E-01_JPRB, 0.406078E-01_JPRB &
  &, 0.377287E-01_JPRB, 0.350490E-01_JPRB, 0.325035E-01_JPRB &
  &, 0.301424E-01_JPRB, 0.279372E-01_JPRB, 0.258154E-01_JPRB, 0.238683E-01_JPRB &
  &, 0.220638E-01_JPRB, 0.203677E-01_JPRB, 0.187431E-01_JPRB &
  &, 0.172851E-01_JPRB, 0.158665E-01_JPRB, 0.145835E-01_JPRB, 0.133969E-01_JPRB &
  &, 0.123124E-01_JPRB, 0.112877E-01_JPRB, 0.103265E-01_JPRB &
  &, 0.943284E-02_JPRB, 0.861071E-02_JPRB, 0.786418E-02_JPRB, 0.719739E-02_JPRB &
  &, 0.656173E-02_JPRB, 0.595921E-02_JPRB, 0.539188E-02_JPRB &
  &, 0.491695E-02_JPRB, 0.448297E-02_JPRB, 0.403541E-02_JPRB, 0.368908E-02_JPRB &
  &, 0.333204E-02_JPRB, 0.302324E-02_JPRB, 0.270508E-02_JPRB &
  &, 0.243817E-02_JPRB, 0.222486E-02_JPRB, 0.200518E-02_JPRB, 0.177907E-02_JPRB &
  &, 0.161046E-02_JPRB, 0.143696E-02_JPRB, 0.125851E-02_JPRB/)
XCW( 509, :) = (/ &
  &  0.998801E+00_JPRB, 0.997457E+00_JPRB, 0.995699E+00_JPRB, 0.993526E+00_JPRB &
  &, 0.990937E+00_JPRB, 0.987936E+00_JPRB, 0.984522E+00_JPRB &
  &, 0.980698E+00_JPRB, 0.976465E+00_JPRB, 0.971825E+00_JPRB, 0.966781E+00_JPRB &
  &, 0.961334E+00_JPRB, 0.955490E+00_JPRB, 0.949249E+00_JPRB &
  &, 0.942617E+00_JPRB, 0.935596E+00_JPRB, 0.928191E+00_JPRB, 0.920408E+00_JPRB &
  &, 0.912250E+00_JPRB, 0.903724E+00_JPRB, 0.894836E+00_JPRB &
  &, 0.885594E+00_JPRB, 0.876001E+00_JPRB, 0.866067E+00_JPRB, 0.855802E+00_JPRB &
  &, 0.845214E+00_JPRB, 0.834306E+00_JPRB, 0.823096E+00_JPRB &
  &, 0.811590E+00_JPRB, 0.799799E+00_JPRB, 0.787735E+00_JPRB, 0.775409E+00_JPRB &
  &, 0.762838E+00_JPRB, 0.749992E+00_JPRB, 0.736991E+00_JPRB &
  &, 0.723744E+00_JPRB, 0.710306E+00_JPRB, 0.696682E+00_JPRB, 0.682896E+00_JPRB &
  &, 0.668965E+00_JPRB, 0.654889E+00_JPRB, 0.640702E+00_JPRB &
  &, 0.626408E+00_JPRB, 0.612037E+00_JPRB, 0.597586E+00_JPRB, 0.583077E+00_JPRB &
  &, 0.568533E+00_JPRB, 0.553968E+00_JPRB, 0.539407E+00_JPRB &
  &, 0.524854E+00_JPRB, 0.510324E+00_JPRB, 0.495846E+00_JPRB, 0.481423E+00_JPRB &
  &, 0.467071E+00_JPRB, 0.452821E+00_JPRB, 0.438675E+00_JPRB &
  &, 0.424649E+00_JPRB, 0.410759E+00_JPRB, 0.397004E+00_JPRB, 0.383432E+00_JPRB &
  &, 0.370023E+00_JPRB, 0.356807E+00_JPRB, 0.343797E+00_JPRB &
  &, 0.330986E+00_JPRB, 0.318384E+00_JPRB, 0.306037E+00_JPRB, 0.293914E+00_JPRB &
  &, 0.282042E+00_JPRB, 0.270424E+00_JPRB, 0.259064E+00_JPRB &
  &, 0.247985E+00_JPRB, 0.237165E+00_JPRB, 0.226624E+00_JPRB, 0.216381E+00_JPRB &
  &, 0.206409E+00_JPRB, 0.196745E+00_JPRB, 0.187359E+00_JPRB &
  &, 0.178264E+00_JPRB, 0.169445E+00_JPRB, 0.160938E+00_JPRB, 0.152728E+00_JPRB &
  &, 0.144794E+00_JPRB, 0.137144E+00_JPRB, 0.129807E+00_JPRB &
  &, 0.122733E+00_JPRB, 0.115949E+00_JPRB, 0.109428E+00_JPRB, 0.103195E+00_JPRB &
  &, 0.972175E-01_JPRB, 0.914905E-01_JPRB, 0.860373E-01_JPRB &
  &, 0.808506E-01_JPRB, 0.758893E-01_JPRB, 0.711407E-01_JPRB, 0.666575E-01_JPRB &
  &, 0.623929E-01_JPRB, 0.583653E-01_JPRB, 0.545230E-01_JPRB &
  &, 0.508816E-01_JPRB, 0.474569E-01_JPRB, 0.441911E-01_JPRB, 0.411346E-01_JPRB &
  &, 0.382642E-01_JPRB, 0.355546E-01_JPRB, 0.329778E-01_JPRB &
  &, 0.305843E-01_JPRB, 0.283454E-01_JPRB, 0.262303E-01_JPRB, 0.242476E-01_JPRB &
  &, 0.224064E-01_JPRB, 0.206722E-01_JPRB, 0.190524E-01_JPRB &
  &, 0.175543E-01_JPRB, 0.161399E-01_JPRB, 0.148611E-01_JPRB, 0.136317E-01_JPRB &
  &, 0.125031E-01_JPRB, 0.114813E-01_JPRB, 0.105230E-01_JPRB &
  &, 0.963227E-02_JPRB, 0.881308E-02_JPRB, 0.801818E-02_JPRB, 0.730156E-02_JPRB &
  &, 0.666740E-02_JPRB, 0.606640E-02_JPRB, 0.555497E-02_JPRB &
  &, 0.502722E-02_JPRB, 0.453888E-02_JPRB, 0.414880E-02_JPRB, 0.374657E-02_JPRB &
  &, 0.339032E-02_JPRB, 0.308232E-02_JPRB, 0.276497E-02_JPRB &
  &, 0.249888E-02_JPRB, 0.222486E-02_JPRB, 0.200518E-02_JPRB, 0.184225E-02_JPRB &
  &, 0.161046E-02_JPRB, 0.143696E-02_JPRB, 0.132422E-02_JPRB/)
XCW( 510, :) = (/ &
  &  0.999050E+00_JPRB, 0.997772E+00_JPRB, 0.996074E+00_JPRB, 0.993963E+00_JPRB &
  &, 0.991437E+00_JPRB, 0.988497E+00_JPRB, 0.985145E+00_JPRB &
  &, 0.981380E+00_JPRB, 0.977208E+00_JPRB, 0.972627E+00_JPRB, 0.967643E+00_JPRB &
  &, 0.962254E+00_JPRB, 0.956467E+00_JPRB, 0.950285E+00_JPRB &
  &, 0.943709E+00_JPRB, 0.936743E+00_JPRB, 0.929394E+00_JPRB, 0.921664E+00_JPRB &
  &, 0.913560E+00_JPRB, 0.905085E+00_JPRB, 0.896250E+00_JPRB &
  &, 0.887056E+00_JPRB, 0.877513E+00_JPRB, 0.867626E+00_JPRB, 0.857407E+00_JPRB &
  &, 0.846862E+00_JPRB, 0.836001E+00_JPRB, 0.824832E+00_JPRB &
  &, 0.813365E+00_JPRB, 0.801614E+00_JPRB, 0.789587E+00_JPRB, 0.777295E+00_JPRB &
  &, 0.764758E+00_JPRB, 0.751978E+00_JPRB, 0.738973E+00_JPRB &
  &, 0.725753E+00_JPRB, 0.712347E+00_JPRB, 0.698746E+00_JPRB, 0.684992E+00_JPRB &
  &, 0.671073E+00_JPRB, 0.657018E+00_JPRB, 0.642852E+00_JPRB &
  &, 0.628567E+00_JPRB, 0.614205E+00_JPRB, 0.599761E+00_JPRB, 0.585271E+00_JPRB &
  &, 0.570732E+00_JPRB, 0.556171E+00_JPRB, 0.541613E+00_JPRB &
  &, 0.527062E+00_JPRB, 0.512532E+00_JPRB, 0.498038E+00_JPRB, 0.483611E+00_JPRB &
  &, 0.469253E+00_JPRB, 0.454995E+00_JPRB, 0.440840E+00_JPRB &
  &, 0.426787E+00_JPRB, 0.412884E+00_JPRB, 0.399130E+00_JPRB, 0.385523E+00_JPRB &
  &, 0.372094E+00_JPRB, 0.358855E+00_JPRB, 0.345820E+00_JPRB &
  &, 0.332982E+00_JPRB, 0.320369E+00_JPRB, 0.307971E+00_JPRB, 0.295832E+00_JPRB &
  &, 0.283922E+00_JPRB, 0.272264E+00_JPRB, 0.260882E+00_JPRB &
  &, 0.249757E+00_JPRB, 0.238909E+00_JPRB, 0.228339E+00_JPRB, 0.218042E+00_JPRB &
  &, 0.208034E+00_JPRB, 0.198311E+00_JPRB, 0.188885E+00_JPRB &
  &, 0.179747E+00_JPRB, 0.170908E+00_JPRB, 0.162355E+00_JPRB, 0.154095E+00_JPRB &
  &, 0.146109E+00_JPRB, 0.138431E+00_JPRB, 0.131037E+00_JPRB &
  &, 0.123930E+00_JPRB, 0.117084E+00_JPRB, 0.110555E+00_JPRB, 0.104255E+00_JPRB &
  &, 0.982372E-01_JPRB, 0.924984E-01_JPRB, 0.870014E-01_JPRB &
  &, 0.817373E-01_JPRB, 0.767596E-01_JPRB, 0.719937E-01_JPRB, 0.674588E-01_JPRB &
  &, 0.631744E-01_JPRB, 0.590913E-01_JPRB, 0.552264E-01_JPRB &
  &, 0.515613E-01_JPRB, 0.480754E-01_JPRB, 0.448201E-01_JPRB, 0.416990E-01_JPRB &
  &, 0.387998E-01_JPRB, 0.360601E-01_JPRB, 0.334522E-01_JPRB &
  &, 0.310263E-01_JPRB, 0.287537E-01_JPRB, 0.266452E-01_JPRB, 0.246270E-01_JPRB &
  &, 0.227490E-01_JPRB, 0.210202E-01_JPRB, 0.193617E-01_JPRB &
  &, 0.178684E-01_JPRB, 0.164133E-01_JPRB, 0.150924E-01_JPRB, 0.138666E-01_JPRB &
  &, 0.127415E-01_JPRB, 0.116749E-01_JPRB, 0.107195E-01_JPRB &
  &, 0.978183E-02_JPRB, 0.896486E-02_JPRB, 0.817219E-02_JPRB, 0.745780E-02_JPRB &
  &, 0.682591E-02_JPRB, 0.622719E-02_JPRB, 0.566369E-02_JPRB &
  &, 0.513749E-02_JPRB, 0.465071E-02_JPRB, 0.420550E-02_JPRB, 0.380406E-02_JPRB &
  &, 0.344860E-02_JPRB, 0.314140E-02_JPRB, 0.282486E-02_JPRB &
  &, 0.255958E-02_JPRB, 0.228638E-02_JPRB, 0.206753E-02_JPRB, 0.184225E-02_JPRB &
  &, 0.167448E-02_JPRB, 0.150182E-02_JPRB, 0.132422E-02_JPRB/)
XCW( 511, :) = (/ &
  &  0.999301E+00_JPRB, 0.998084E+00_JPRB, 0.996450E+00_JPRB, 0.994402E+00_JPRB &
  &, 0.991937E+00_JPRB, 0.989059E+00_JPRB, 0.985766E+00_JPRB &
  &, 0.982064E+00_JPRB, 0.977952E+00_JPRB, 0.973431E+00_JPRB, 0.968506E+00_JPRB &
  &, 0.963176E+00_JPRB, 0.957448E+00_JPRB, 0.951321E+00_JPRB &
  &, 0.944801E+00_JPRB, 0.937893E+00_JPRB, 0.930598E+00_JPRB, 0.922922E+00_JPRB &
  &, 0.914871E+00_JPRB, 0.906449E+00_JPRB, 0.897664E+00_JPRB &
  &, 0.888518E+00_JPRB, 0.879022E+00_JPRB, 0.869187E+00_JPRB, 0.859013E+00_JPRB &
  &, 0.848514E+00_JPRB, 0.837693E+00_JPRB, 0.826569E+00_JPRB &
  &, 0.815140E+00_JPRB, 0.803429E+00_JPRB, 0.791439E+00_JPRB, 0.779185E+00_JPRB &
  &, 0.766679E+00_JPRB, 0.753934E+00_JPRB, 0.740960E+00_JPRB &
  &, 0.727771E+00_JPRB, 0.714388E+00_JPRB, 0.700818E+00_JPRB, 0.687077E+00_JPRB &
  &, 0.673190E+00_JPRB, 0.659157E+00_JPRB, 0.645001E+00_JPRB &
  &, 0.630738E+00_JPRB, 0.616384E+00_JPRB, 0.601949E+00_JPRB, 0.587465E+00_JPRB &
  &, 0.572944E+00_JPRB, 0.558387E+00_JPRB, 0.543820E+00_JPRB &
  &, 0.529269E+00_JPRB, 0.514739E+00_JPRB, 0.500243E+00_JPRB, 0.485812E+00_JPRB &
  &, 0.471449E+00_JPRB, 0.457185E+00_JPRB, 0.443005E+00_JPRB &
  &, 0.428957E+00_JPRB, 0.415025E+00_JPRB, 0.401255E+00_JPRB, 0.387631E+00_JPRB &
  &, 0.374182E+00_JPRB, 0.360921E+00_JPRB, 0.347844E+00_JPRB &
  &, 0.334997E+00_JPRB, 0.322335E+00_JPRB, 0.309923E+00_JPRB, 0.297750E+00_JPRB &
  &, 0.285802E+00_JPRB, 0.274124E+00_JPRB, 0.262699E+00_JPRB &
  &, 0.251528E+00_JPRB, 0.240654E+00_JPRB, 0.230032E+00_JPRB, 0.219702E+00_JPRB &
  &, 0.209660E+00_JPRB, 0.199900E+00_JPRB, 0.190435E+00_JPRB &
  &, 0.181255E+00_JPRB, 0.172372E+00_JPRB, 0.163772E+00_JPRB, 0.155462E+00_JPRB &
  &, 0.147451E+00_JPRB, 0.139718E+00_JPRB, 0.132294E+00_JPRB &
  &, 0.125128E+00_JPRB, 0.118276E+00_JPRB, 0.111654E+00_JPRB, 0.105344E+00_JPRB &
  &, 0.992870E-01_JPRB, 0.934758E-01_JPRB, 0.879656E-01_JPRB &
  &, 0.826555E-01_JPRB, 0.776299E-01_JPRB, 0.728468E-01_JPRB, 0.682602E-01_JPRB &
  &, 0.639219E-01_JPRB, 0.598173E-01_JPRB, 0.558947E-01_JPRB &
  &, 0.522053E-01_JPRB, 0.487304E-01_JPRB, 0.454121E-01_JPRB, 0.423010E-01_JPRB &
  &, 0.393354E-01_JPRB, 0.365657E-01_JPRB, 0.339661E-01_JPRB &
  &, 0.315084E-01_JPRB, 0.292029E-01_JPRB, 0.270601E-01_JPRB, 0.250064E-01_JPRB &
  &, 0.231344E-01_JPRB, 0.213682E-01_JPRB, 0.197151E-01_JPRB &
  &, 0.181376E-01_JPRB, 0.167323E-01_JPRB, 0.153700E-01_JPRB, 0.141484E-01_JPRB &
  &, 0.129800E-01_JPRB, 0.119169E-01_JPRB, 0.109160E-01_JPRB &
  &, 0.998126E-02_JPRB, 0.911663E-02_JPRB, 0.832619E-02_JPRB, 0.761405E-02_JPRB &
  &, 0.693158E-02_JPRB, 0.633439E-02_JPRB, 0.577242E-02_JPRB &
  &, 0.524776E-02_JPRB, 0.476253E-02_JPRB, 0.431889E-02_JPRB, 0.391903E-02_JPRB &
  &, 0.356517E-02_JPRB, 0.320049E-02_JPRB, 0.288476E-02_JPRB &
  &, 0.262029E-02_JPRB, 0.234791E-02_JPRB, 0.212988E-02_JPRB, 0.190543E-02_JPRB &
  &, 0.173850E-02_JPRB, 0.156668E-02_JPRB, 0.138993E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART73',1,ZHOOK_HANDLE)
END SUBROUTINE PART73

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART74

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART74',0,ZHOOK_HANDLE)

XCW( 512, :) = (/ &
  &  0.999555E+00_JPRB, 0.998399E+00_JPRB, 0.996826E+00_JPRB, 0.994839E+00_JPRB &
  &, 0.992437E+00_JPRB, 0.989620E+00_JPRB, 0.986389E+00_JPRB &
  &, 0.982748E+00_JPRB, 0.978695E+00_JPRB, 0.974235E+00_JPRB, 0.969369E+00_JPRB &
  &, 0.964098E+00_JPRB, 0.958427E+00_JPRB, 0.952358E+00_JPRB &
  &, 0.945895E+00_JPRB, 0.939037E+00_JPRB, 0.931802E+00_JPRB, 0.924181E+00_JPRB &
  &, 0.916183E+00_JPRB, 0.907814E+00_JPRB, 0.899077E+00_JPRB &
  &, 0.889984E+00_JPRB, 0.880538E+00_JPRB, 0.870749E+00_JPRB, 0.860619E+00_JPRB &
  &, 0.850165E+00_JPRB, 0.839391E+00_JPRB, 0.828305E+00_JPRB &
  &, 0.816923E+00_JPRB, 0.805248E+00_JPRB, 0.793295E+00_JPRB, 0.781079E+00_JPRB &
  &, 0.768608E+00_JPRB, 0.755894E+00_JPRB, 0.742951E+00_JPRB &
  &, 0.729790E+00_JPRB, 0.716438E+00_JPRB, 0.702891E+00_JPRB, 0.689172E+00_JPRB &
  &, 0.675307E+00_JPRB, 0.661286E+00_JPRB, 0.647151E+00_JPRB &
  &, 0.632909E+00_JPRB, 0.618564E+00_JPRB, 0.604148E+00_JPRB, 0.589671E+00_JPRB &
  &, 0.575156E+00_JPRB, 0.560603E+00_JPRB, 0.546039E+00_JPRB &
  &, 0.531490E+00_JPRB, 0.516959E+00_JPRB, 0.502462E+00_JPRB, 0.488028E+00_JPRB &
  &, 0.473660E+00_JPRB, 0.459374E+00_JPRB, 0.445186E+00_JPRB &
  &, 0.431127E+00_JPRB, 0.417181E+00_JPRB, 0.403380E+00_JPRB, 0.389739E+00_JPRB &
  &, 0.376270E+00_JPRB, 0.362987E+00_JPRB, 0.349903E+00_JPRB &
  &, 0.337011E+00_JPRB, 0.324338E+00_JPRB, 0.311895E+00_JPRB, 0.299668E+00_JPRB &
  &, 0.287702E+00_JPRB, 0.275984E+00_JPRB, 0.264516E+00_JPRB &
  &, 0.253320E+00_JPRB, 0.242398E+00_JPRB, 0.231746E+00_JPRB, 0.221385E+00_JPRB &
  &, 0.211286E+00_JPRB, 0.201489E+00_JPRB, 0.191985E+00_JPRB &
  &, 0.182763E+00_JPRB, 0.173836E+00_JPRB, 0.165214E+00_JPRB, 0.156855E+00_JPRB &
  &, 0.148792E+00_JPRB, 0.141031E+00_JPRB, 0.133551E+00_JPRB &
  &, 0.126353E+00_JPRB, 0.119439E+00_JPRB, 0.112810E+00_JPRB, 0.106434E+00_JPRB &
  &, 0.100337E+00_JPRB, 0.945143E-01_JPRB, 0.889297E-01_JPRB &
  &, 0.836055E-01_JPRB, 0.785325E-01_JPRB, 0.736998E-01_JPRB, 0.690950E-01_JPRB &
  &, 0.647034E-01_JPRB, 0.605433E-01_JPRB, 0.566332E-01_JPRB &
  &, 0.528850E-01_JPRB, 0.493489E-01_JPRB, 0.460042E-01_JPRB, 0.428654E-01_JPRB &
  &, 0.398709E-01_JPRB, 0.370713E-01_JPRB, 0.344404E-01_JPRB &
  &, 0.319503E-01_JPRB, 0.296520E-01_JPRB, 0.274334E-01_JPRB, 0.253857E-01_JPRB &
  &, 0.234770E-01_JPRB, 0.216727E-01_JPRB, 0.200244E-01_JPRB &
  &, 0.184517E-01_JPRB, 0.170057E-01_JPRB, 0.156476E-01_JPRB, 0.143833E-01_JPRB &
  &, 0.132184E-01_JPRB, 0.121105E-01_JPRB, 0.111125E-01_JPRB &
  &, 0.101807E-01_JPRB, 0.931900E-02_JPRB, 0.848019E-02_JPRB, 0.777030E-02_JPRB &
  &, 0.709009E-02_JPRB, 0.644158E-02_JPRB, 0.588114E-02_JPRB &
  &, 0.535803E-02_JPRB, 0.487436E-02_JPRB, 0.443228E-02_JPRB, 0.397651E-02_JPRB &
  &, 0.362345E-02_JPRB, 0.325957E-02_JPRB, 0.294465E-02_JPRB &
  &, 0.268099E-02_JPRB, 0.240943E-02_JPRB, 0.219223E-02_JPRB, 0.196861E-02_JPRB &
  &, 0.173850E-02_JPRB, 0.156668E-02_JPRB, 0.138993E-02_JPRB/)
XCW( 513, :) = (/ &
  &  0.999805E+00_JPRB, 0.998712E+00_JPRB, 0.997201E+00_JPRB, 0.995277E+00_JPRB &
  &, 0.992937E+00_JPRB, 0.990181E+00_JPRB, 0.987012E+00_JPRB &
  &, 0.983431E+00_JPRB, 0.979439E+00_JPRB, 0.975039E+00_JPRB, 0.970233E+00_JPRB &
  &, 0.965020E+00_JPRB, 0.959407E+00_JPRB, 0.953397E+00_JPRB &
  &, 0.946990E+00_JPRB, 0.940193E+00_JPRB, 0.933007E+00_JPRB, 0.925440E+00_JPRB &
  &, 0.917495E+00_JPRB, 0.909178E+00_JPRB, 0.900494E+00_JPRB &
  &, 0.891449E+00_JPRB, 0.882054E+00_JPRB, 0.872311E+00_JPRB, 0.862232E+00_JPRB &
  &, 0.851820E+00_JPRB, 0.841090E+00_JPRB, 0.830049E+00_JPRB &
  &, 0.818702E+00_JPRB, 0.807071E+00_JPRB, 0.795156E+00_JPRB, 0.782974E+00_JPRB &
  &, 0.770537E+00_JPRB, 0.757858E+00_JPRB, 0.744947E+00_JPRB &
  &, 0.731817E+00_JPRB, 0.718489E+00_JPRB, 0.704964E+00_JPRB, 0.691278E+00_JPRB &
  &, 0.677425E+00_JPRB, 0.663436E+00_JPRB, 0.649312E+00_JPRB &
  &, 0.635079E+00_JPRB, 0.620755E+00_JPRB, 0.606347E+00_JPRB, 0.591877E+00_JPRB &
  &, 0.577367E+00_JPRB, 0.562819E+00_JPRB, 0.548271E+00_JPRB &
  &, 0.533711E+00_JPRB, 0.519180E+00_JPRB, 0.504681E+00_JPRB, 0.490244E+00_JPRB &
  &, 0.475872E+00_JPRB, 0.461579E+00_JPRB, 0.447382E+00_JPRB &
  &, 0.433296E+00_JPRB, 0.419338E+00_JPRB, 0.405522E+00_JPRB, 0.391863E+00_JPRB &
  &, 0.378375E+00_JPRB, 0.365070E+00_JPRB, 0.351944E+00_JPRB &
  &, 0.339025E+00_JPRB, 0.326342E+00_JPRB, 0.313847E+00_JPRB, 0.301605E+00_JPRB &
  &, 0.289602E+00_JPRB, 0.277864E+00_JPRB, 0.266354E+00_JPRB &
  &, 0.255134E+00_JPRB, 0.244163E+00_JPRB, 0.233483E+00_JPRB, 0.223068E+00_JPRB &
  &, 0.212935E+00_JPRB, 0.203101E+00_JPRB, 0.193558E+00_JPRB &
  &, 0.184295E+00_JPRB, 0.175324E+00_JPRB, 0.166656E+00_JPRB, 0.158248E+00_JPRB &
  &, 0.150160E+00_JPRB, 0.142345E+00_JPRB, 0.134835E+00_JPRB &
  &, 0.127578E+00_JPRB, 0.120631E+00_JPRB, 0.113937E+00_JPRB, 0.107523E+00_JPRB &
  &, 0.101387E+00_JPRB, 0.955223E-01_JPRB, 0.898939E-01_JPRB &
  &, 0.845554E-01_JPRB, 0.794350E-01_JPRB, 0.745529E-01_JPRB, 0.698963E-01_JPRB &
  &, 0.654849E-01_JPRB, 0.613038E-01_JPRB, 0.573366E-01_JPRB &
  &, 0.535647E-01_JPRB, 0.500039E-01_JPRB, 0.466332E-01_JPRB, 0.434297E-01_JPRB &
  &, 0.404447E-01_JPRB, 0.376157E-01_JPRB, 0.349543E-01_JPRB &
  &, 0.324324E-01_JPRB, 0.301011E-01_JPRB, 0.278898E-01_JPRB, 0.258073E-01_JPRB &
  &, 0.238624E-01_JPRB, 0.220207E-01_JPRB, 0.203337E-01_JPRB &
  &, 0.187658E-01_JPRB, 0.172790E-01_JPRB, 0.159252E-01_JPRB, 0.146181E-01_JPRB &
  &, 0.134568E-01_JPRB, 0.123525E-01_JPRB, 0.113090E-01_JPRB &
  &, 0.103801E-01_JPRB, 0.947078E-02_JPRB, 0.868553E-02_JPRB, 0.792655E-02_JPRB &
  &, 0.724860E-02_JPRB, 0.660237E-02_JPRB, 0.598987E-02_JPRB &
  &, 0.546829E-02_JPRB, 0.498618E-02_JPRB, 0.448898E-02_JPRB, 0.409148E-02_JPRB &
  &, 0.368173E-02_JPRB, 0.337774E-02_JPRB, 0.300454E-02_JPRB &
  &, 0.274170E-02_JPRB, 0.247096E-02_JPRB, 0.225458E-02_JPRB, 0.203179E-02_JPRB &
  &, 0.180251E-02_JPRB, 0.163154E-02_JPRB, 0.145564E-02_JPRB/)
XCW( 514, :) = (/ &
  &  0.100005E+01_JPRB, 0.999025E+00_JPRB, 0.997578E+00_JPRB, 0.995717E+00_JPRB &
  &, 0.993437E+00_JPRB, 0.990744E+00_JPRB, 0.987636E+00_JPRB &
  &, 0.984115E+00_JPRB, 0.980184E+00_JPRB, 0.975844E+00_JPRB, 0.971097E+00_JPRB &
  &, 0.965943E+00_JPRB, 0.960389E+00_JPRB, 0.954435E+00_JPRB &
  &, 0.948085E+00_JPRB, 0.941344E+00_JPRB, 0.934214E+00_JPRB, 0.926702E+00_JPRB &
  &, 0.918810E+00_JPRB, 0.910545E+00_JPRB, 0.901911E+00_JPRB &
  &, 0.892918E+00_JPRB, 0.883570E+00_JPRB, 0.873876E+00_JPRB, 0.863844E+00_JPRB &
  &, 0.853478E+00_JPRB, 0.842792E+00_JPRB, 0.831793E+00_JPRB &
  &, 0.820489E+00_JPRB, 0.808894E+00_JPRB, 0.797020E+00_JPRB, 0.784872E+00_JPRB &
  &, 0.772470E+00_JPRB, 0.759822E+00_JPRB, 0.746943E+00_JPRB &
  &, 0.733845E+00_JPRB, 0.720539E+00_JPRB, 0.707047E+00_JPRB, 0.693383E+00_JPRB &
  &, 0.679552E+00_JPRB, 0.665575E+00_JPRB, 0.651473E+00_JPRB &
  &, 0.637261E+00_JPRB, 0.622946E+00_JPRB, 0.608557E+00_JPRB, 0.594094E+00_JPRB &
  &, 0.579591E+00_JPRB, 0.565048E+00_JPRB, 0.550503E+00_JPRB &
  &, 0.535944E+00_JPRB, 0.521414E+00_JPRB, 0.506914E+00_JPRB, 0.492474E+00_JPRB &
  &, 0.478083E+00_JPRB, 0.463783E+00_JPRB, 0.449577E+00_JPRB &
  &, 0.435481E+00_JPRB, 0.421511E+00_JPRB, 0.407680E+00_JPRB, 0.394004E+00_JPRB &
  &, 0.380497E+00_JPRB, 0.367153E+00_JPRB, 0.354021E+00_JPRB &
  &, 0.341076E+00_JPRB, 0.328345E+00_JPRB, 0.315838E+00_JPRB, 0.303561E+00_JPRB &
  &, 0.291522E+00_JPRB, 0.279745E+00_JPRB, 0.268212E+00_JPRB &
  &, 0.256948E+00_JPRB, 0.245950E+00_JPRB, 0.235219E+00_JPRB, 0.224773E+00_JPRB &
  &, 0.214607E+00_JPRB, 0.204714E+00_JPRB, 0.195132E+00_JPRB &
  &, 0.185828E+00_JPRB, 0.176813E+00_JPRB, 0.168098E+00_JPRB, 0.159667E+00_JPRB &
  &, 0.151527E+00_JPRB, 0.143659E+00_JPRB, 0.136092E+00_JPRB &
  &, 0.128832E+00_JPRB, 0.121823E+00_JPRB, 0.115094E+00_JPRB, 0.108642E+00_JPRB &
  &, 0.102466E+00_JPRB, 0.965608E-01_JPRB, 0.908891E-01_JPRB &
  &, 0.854737E-01_JPRB, 0.803376E-01_JPRB, 0.754059E-01_JPRB, 0.707311E-01_JPRB &
  &, 0.663003E-01_JPRB, 0.620644E-01_JPRB, 0.580400E-01_JPRB &
  &, 0.542444E-01_JPRB, 0.506588E-01_JPRB, 0.472623E-01_JPRB, 0.440317E-01_JPRB &
  &, 0.410186E-01_JPRB, 0.381601E-01_JPRB, 0.354287E-01_JPRB &
  &, 0.329146E-01_JPRB, 0.305502E-01_JPRB, 0.283047E-01_JPRB, 0.261866E-01_JPRB &
  &, 0.242478E-01_JPRB, 0.224122E-01_JPRB, 0.206871E-01_JPRB &
  &, 0.190799E-01_JPRB, 0.175980E-01_JPRB, 0.162028E-01_JPRB, 0.148999E-01_JPRB &
  &, 0.136952E-01_JPRB, 0.125461E-01_JPRB, 0.115055E-01_JPRB &
  &, 0.105795E-01_JPRB, 0.967315E-02_JPRB, 0.883953E-02_JPRB, 0.808279E-02_JPRB &
  &, 0.735428E-02_JPRB, 0.670956E-02_JPRB, 0.609859E-02_JPRB &
  &, 0.557856E-02_JPRB, 0.504209E-02_JPRB, 0.460237E-02_JPRB, 0.420646E-02_JPRB &
  &, 0.379829E-02_JPRB, 0.343682E-02_JPRB, 0.312432E-02_JPRB &
  &, 0.280240E-02_JPRB, 0.253248E-02_JPRB, 0.225458E-02_JPRB, 0.203179E-02_JPRB &
  &, 0.186653E-02_JPRB, 0.163154E-02_JPRB, 0.152136E-02_JPRB/)
XCW( 515, :) = (/ &
  &  0.100031E+01_JPRB, 0.999338E+00_JPRB, 0.997954E+00_JPRB, 0.996155E+00_JPRB &
  &, 0.993937E+00_JPRB, 0.991306E+00_JPRB, 0.988259E+00_JPRB &
  &, 0.984800E+00_JPRB, 0.980930E+00_JPRB, 0.976649E+00_JPRB, 0.971962E+00_JPRB &
  &, 0.966867E+00_JPRB, 0.961371E+00_JPRB, 0.955475E+00_JPRB &
  &, 0.949182E+00_JPRB, 0.942497E+00_JPRB, 0.935423E+00_JPRB, 0.927965E+00_JPRB &
  &, 0.920127E+00_JPRB, 0.911913E+00_JPRB, 0.903331E+00_JPRB &
  &, 0.894390E+00_JPRB, 0.885090E+00_JPRB, 0.875444E+00_JPRB, 0.865457E+00_JPRB &
  &, 0.855137E+00_JPRB, 0.844495E+00_JPRB, 0.833537E+00_JPRB &
  &, 0.822276E+00_JPRB, 0.810722E+00_JPRB, 0.798885E+00_JPRB, 0.786775E+00_JPRB &
  &, 0.774408E+00_JPRB, 0.761796E+00_JPRB, 0.748947E+00_JPRB &
  &, 0.735873E+00_JPRB, 0.722599E+00_JPRB, 0.709130E+00_JPRB, 0.695488E+00_JPRB &
  &, 0.681680E+00_JPRB, 0.667735E+00_JPRB, 0.653644E+00_JPRB &
  &, 0.639454E+00_JPRB, 0.625148E+00_JPRB, 0.610768E+00_JPRB, 0.596324E+00_JPRB &
  &, 0.581827E+00_JPRB, 0.567289E+00_JPRB, 0.552734E+00_JPRB &
  &, 0.538191E+00_JPRB, 0.523662E+00_JPRB, 0.509147E+00_JPRB, 0.494705E+00_JPRB &
  &, 0.480308E+00_JPRB, 0.466002E+00_JPRB, 0.451773E+00_JPRB &
  &, 0.437666E+00_JPRB, 0.423683E+00_JPRB, 0.409838E+00_JPRB, 0.396145E+00_JPRB &
  &, 0.382601E+00_JPRB, 0.369254E+00_JPRB, 0.356080E+00_JPRB &
  &, 0.343108E+00_JPRB, 0.330367E+00_JPRB, 0.317828E+00_JPRB, 0.305518E+00_JPRB &
  &, 0.293442E+00_JPRB, 0.281625E+00_JPRB, 0.270071E+00_JPRB &
  &, 0.258761E+00_JPRB, 0.247738E+00_JPRB, 0.236956E+00_JPRB, 0.226478E+00_JPRB &
  &, 0.216278E+00_JPRB, 0.206349E+00_JPRB, 0.196729E+00_JPRB &
  &, 0.187384E+00_JPRB, 0.178326E+00_JPRB, 0.169565E+00_JPRB, 0.161086E+00_JPRB &
  &, 0.152895E+00_JPRB, 0.144999E+00_JPRB, 0.137404E+00_JPRB &
  &, 0.130057E+00_JPRB, 0.123015E+00_JPRB, 0.116250E+00_JPRB, 0.109761E+00_JPRB &
  &, 0.103546E+00_JPRB, 0.975993E-01_JPRB, 0.918844E-01_JPRB &
  &, 0.864553E-01_JPRB, 0.812401E-01_JPRB, 0.762918E-01_JPRB, 0.715659E-01_JPRB &
  &, 0.670818E-01_JPRB, 0.628249E-01_JPRB, 0.587786E-01_JPRB &
  &, 0.549599E-01_JPRB, 0.513138E-01_JPRB, 0.478913E-01_JPRB, 0.446337E-01_JPRB &
  &, 0.415541E-01_JPRB, 0.386657E-01_JPRB, 0.359426E-01_JPRB &
  &, 0.333967E-01_JPRB, 0.309993E-01_JPRB, 0.287196E-01_JPRB, 0.266082E-01_JPRB &
  &, 0.246332E-01_JPRB, 0.227602E-01_JPRB, 0.209964E-01_JPRB &
  &, 0.193940E-01_JPRB, 0.178714E-01_JPRB, 0.164804E-01_JPRB, 0.151348E-01_JPRB &
  &, 0.139336E-01_JPRB, 0.127881E-01_JPRB, 0.117511E-01_JPRB &
  &, 0.107291E-01_JPRB, 0.982493E-02_JPRB, 0.899354E-02_JPRB, 0.823904E-02_JPRB &
  &, 0.751279E-02_JPRB, 0.687035E-02_JPRB, 0.626168E-02_JPRB &
  &, 0.568883E-02_JPRB, 0.515392E-02_JPRB, 0.471576E-02_JPRB, 0.426394E-02_JPRB &
  &, 0.385657E-02_JPRB, 0.349590E-02_JPRB, 0.318421E-02_JPRB &
  &, 0.286310E-02_JPRB, 0.259400E-02_JPRB, 0.231693E-02_JPRB, 0.209497E-02_JPRB &
  &, 0.186653E-02_JPRB, 0.169641E-02_JPRB, 0.152136E-02_JPRB/)
XCW( 516, :) = (/ &
  &  0.100056E+01_JPRB, 0.999654E+00_JPRB, 0.998331E+00_JPRB, 0.996593E+00_JPRB &
  &, 0.994428E+00_JPRB, 0.991869E+00_JPRB, 0.988884E+00_JPRB &
  &, 0.985485E+00_JPRB, 0.981676E+00_JPRB, 0.977455E+00_JPRB, 0.972827E+00_JPRB &
  &, 0.967791E+00_JPRB, 0.962354E+00_JPRB, 0.956515E+00_JPRB &
  &, 0.950280E+00_JPRB, 0.943651E+00_JPRB, 0.936630E+00_JPRB, 0.929228E+00_JPRB &
  &, 0.921443E+00_JPRB, 0.913283E+00_JPRB, 0.904755E+00_JPRB &
  &, 0.895862E+00_JPRB, 0.886612E+00_JPRB, 0.877013E+00_JPRB, 0.867073E+00_JPRB &
  &, 0.856799E+00_JPRB, 0.846201E+00_JPRB, 0.835289E+00_JPRB &
  &, 0.824067E+00_JPRB, 0.812553E+00_JPRB, 0.800753E+00_JPRB, 0.788682E+00_JPRB &
  &, 0.776350E+00_JPRB, 0.763769E+00_JPRB, 0.750952E+00_JPRB &
  &, 0.737910E+00_JPRB, 0.724668E+00_JPRB, 0.711222E+00_JPRB, 0.697604E+00_JPRB &
  &, 0.683818E+00_JPRB, 0.669885E+00_JPRB, 0.655826E+00_JPRB &
  &, 0.641635E+00_JPRB, 0.627350E+00_JPRB, 0.612990E+00_JPRB, 0.598554E+00_JPRB &
  &, 0.584063E+00_JPRB, 0.569530E+00_JPRB, 0.554992E+00_JPRB &
  &, 0.540438E+00_JPRB, 0.525909E+00_JPRB, 0.511394E+00_JPRB, 0.496935E+00_JPRB &
  &, 0.482548E+00_JPRB, 0.468221E+00_JPRB, 0.453999E+00_JPRB &
  &, 0.439867E+00_JPRB, 0.425871E+00_JPRB, 0.412012E+00_JPRB, 0.398286E+00_JPRB &
  &, 0.384740E+00_JPRB, 0.371354E+00_JPRB, 0.358175E+00_JPRB &
  &, 0.345177E+00_JPRB, 0.332389E+00_JPRB, 0.319819E+00_JPRB, 0.307494E+00_JPRB &
  &, 0.295382E+00_JPRB, 0.283525E+00_JPRB, 0.271929E+00_JPRB &
  &, 0.260596E+00_JPRB, 0.249525E+00_JPRB, 0.238715E+00_JPRB, 0.228206E+00_JPRB &
  &, 0.217950E+00_JPRB, 0.207985E+00_JPRB, 0.198326E+00_JPRB &
  &, 0.188941E+00_JPRB, 0.179839E+00_JPRB, 0.171032E+00_JPRB, 0.162505E+00_JPRB &
  &, 0.154289E+00_JPRB, 0.146340E+00_JPRB, 0.138688E+00_JPRB &
  &, 0.131338E+00_JPRB, 0.124235E+00_JPRB, 0.117435E+00_JPRB, 0.110910E+00_JPRB &
  &, 0.104626E+00_JPRB, 0.986378E-01_JPRB, 0.928797E-01_JPRB &
  &, 0.874053E-01_JPRB, 0.821749E-01_JPRB, 0.771776E-01_JPRB, 0.724340E-01_JPRB &
  &, 0.678973E-01_JPRB, 0.636201E-01_JPRB, 0.595171E-01_JPRB &
  &, 0.556754E-01_JPRB, 0.520051E-01_JPRB, 0.485204E-01_JPRB, 0.452358E-01_JPRB &
  &, 0.421279E-01_JPRB, 0.392102E-01_JPRB, 0.364565E-01_JPRB &
  &, 0.338788E-01_JPRB, 0.314485E-01_JPRB, 0.291759E-01_JPRB, 0.270297E-01_JPRB &
  &, 0.250186E-01_JPRB, 0.231082E-01_JPRB, 0.213499E-01_JPRB &
  &, 0.197081E-01_JPRB, 0.181903E-01_JPRB, 0.167580E-01_JPRB, 0.154166E-01_JPRB &
  &, 0.141721E-01_JPRB, 0.130301E-01_JPRB, 0.119477E-01_JPRB &
  &, 0.109285E-01_JPRB, 0.100273E-01_JPRB, 0.919887E-02_JPRB, 0.839529E-02_JPRB &
  &, 0.767130E-02_JPRB, 0.697754E-02_JPRB, 0.637040E-02_JPRB &
  &, 0.579910E-02_JPRB, 0.526574E-02_JPRB, 0.482915E-02_JPRB, 0.437891E-02_JPRB &
  &, 0.397314E-02_JPRB, 0.361407E-02_JPRB, 0.324410E-02_JPRB &
  &, 0.292381E-02_JPRB, 0.265553E-02_JPRB, 0.237928E-02_JPRB, 0.215815E-02_JPRB &
  &, 0.193055E-02_JPRB, 0.176127E-02_JPRB, 0.158707E-02_JPRB/)
XCW( 517, :) = (/ &
  &  0.100081E+01_JPRB, 0.999968E+00_JPRB, 0.998708E+00_JPRB, 0.997032E+00_JPRB &
  &, 0.994939E+00_JPRB, 0.992432E+00_JPRB, 0.989508E+00_JPRB &
  &, 0.986171E+00_JPRB, 0.982422E+00_JPRB, 0.978261E+00_JPRB, 0.973692E+00_JPRB &
  &, 0.968717E+00_JPRB, 0.963337E+00_JPRB, 0.957557E+00_JPRB &
  &, 0.951380E+00_JPRB, 0.944807E+00_JPRB, 0.937843E+00_JPRB, 0.930493E+00_JPRB &
  &, 0.922763E+00_JPRB, 0.914654E+00_JPRB, 0.906178E+00_JPRB &
  &, 0.897335E+00_JPRB, 0.888135E+00_JPRB, 0.878585E+00_JPRB, 0.868693E+00_JPRB &
  &, 0.858465E+00_JPRB, 0.847911E+00_JPRB, 0.837040E+00_JPRB &
  &, 0.825862E+00_JPRB, 0.814388E+00_JPRB, 0.802626E+00_JPRB, 0.790593E+00_JPRB &
  &, 0.778296E+00_JPRB, 0.765746E+00_JPRB, 0.752962E+00_JPRB &
  &, 0.739956E+00_JPRB, 0.726738E+00_JPRB, 0.713315E+00_JPRB, 0.699729E+00_JPRB &
  &, 0.685966E+00_JPRB, 0.672056E+00_JPRB, 0.658009E+00_JPRB &
  &, 0.643839E+00_JPRB, 0.629564E+00_JPRB, 0.615213E+00_JPRB, 0.600784E+00_JPRB &
  &, 0.586299E+00_JPRB, 0.571783E+00_JPRB, 0.557237E+00_JPRB &
  &, 0.542698E+00_JPRB, 0.528157E+00_JPRB, 0.513655E+00_JPRB, 0.499193E+00_JPRB &
  &, 0.484788E+00_JPRB, 0.470455E+00_JPRB, 0.456210E+00_JPRB &
  &, 0.442083E+00_JPRB, 0.428060E+00_JPRB, 0.414186E+00_JPRB, 0.400443E+00_JPRB &
  &, 0.386879E+00_JPRB, 0.373472E+00_JPRB, 0.360251E+00_JPRB &
  &, 0.347246E+00_JPRB, 0.334429E+00_JPRB, 0.321828E+00_JPRB, 0.309470E+00_JPRB &
  &, 0.297341E+00_JPRB, 0.285446E+00_JPRB, 0.273809E+00_JPRB &
  &, 0.262430E+00_JPRB, 0.251333E+00_JPRB, 0.240495E+00_JPRB, 0.229934E+00_JPRB &
  &, 0.219645E+00_JPRB, 0.209644E+00_JPRB, 0.199924E+00_JPRB &
  &, 0.190497E+00_JPRB, 0.181352E+00_JPRB, 0.172500E+00_JPRB, 0.163949E+00_JPRB &
  &, 0.155683E+00_JPRB, 0.147707E+00_JPRB, 0.140000E+00_JPRB &
  &, 0.132591E+00_JPRB, 0.125455E+00_JPRB, 0.118621E+00_JPRB, 0.112029E+00_JPRB &
  &, 0.105736E+00_JPRB, 0.996763E-01_JPRB, 0.939060E-01_JPRB &
  &, 0.883869E-01_JPRB, 0.831097E-01_JPRB, 0.780963E-01_JPRB, 0.733022E-01_JPRB &
  &, 0.687127E-01_JPRB, 0.643806E-01_JPRB, 0.602909E-01_JPRB &
  &, 0.563552E-01_JPRB, 0.526600E-01_JPRB, 0.491494E-01_JPRB, 0.458378E-01_JPRB &
  &, 0.427400E-01_JPRB, 0.397935E-01_JPRB, 0.370099E-01_JPRB &
  &, 0.343609E-01_JPRB, 0.318976E-01_JPRB, 0.295908E-01_JPRB, 0.274091E-01_JPRB &
  &, 0.254040E-01_JPRB, 0.234997E-01_JPRB, 0.217033E-01_JPRB &
  &, 0.200222E-01_JPRB, 0.184637E-01_JPRB, 0.170356E-01_JPRB, 0.156985E-01_JPRB &
  &, 0.144105E-01_JPRB, 0.132721E-01_JPRB, 0.121442E-01_JPRB &
  &, 0.111778E-01_JPRB, 0.102297E-01_JPRB, 0.935288E-02_JPRB, 0.855154E-02_JPRB &
  &, 0.782981E-02_JPRB, 0.713833E-02_JPRB, 0.653349E-02_JPRB &
  &, 0.590937E-02_JPRB, 0.537756E-02_JPRB, 0.488585E-02_JPRB, 0.443640E-02_JPRB &
  &, 0.403142E-02_JPRB, 0.367315E-02_JPRB, 0.330399E-02_JPRB &
  &, 0.298451E-02_JPRB, 0.271705E-02_JPRB, 0.244163E-02_JPRB, 0.222133E-02_JPRB &
  &, 0.199457E-02_JPRB, 0.176127E-02_JPRB, 0.158707E-02_JPRB/)
XCW( 518, :) = (/ &
  &  0.100106E+01_JPRB, 0.100028E+01_JPRB, 0.999084E+00_JPRB, 0.997471E+00_JPRB &
  &, 0.995441E+00_JPRB, 0.992995E+00_JPRB, 0.990132E+00_JPRB &
  &, 0.986855E+00_JPRB, 0.983167E+00_JPRB, 0.979069E+00_JPRB, 0.974559E+00_JPRB &
  &, 0.969643E+00_JPRB, 0.964322E+00_JPRB, 0.958600E+00_JPRB &
  &, 0.952478E+00_JPRB, 0.945962E+00_JPRB, 0.939054E+00_JPRB, 0.931760E+00_JPRB &
  &, 0.924083E+00_JPRB, 0.916027E+00_JPRB, 0.907602E+00_JPRB &
  &, 0.898810E+00_JPRB, 0.889661E+00_JPRB, 0.880161E+00_JPRB, 0.870313E+00_JPRB &
  &, 0.860131E+00_JPRB, 0.849621E+00_JPRB, 0.838795E+00_JPRB &
  &, 0.827656E+00_JPRB, 0.816223E+00_JPRB, 0.804503E+00_JPRB, 0.792504E+00_JPRB &
  &, 0.780242E+00_JPRB, 0.767728E+00_JPRB, 0.754976E+00_JPRB &
  &, 0.741993E+00_JPRB, 0.728807E+00_JPRB, 0.715417E+00_JPRB, 0.701845E+00_JPRB &
  &, 0.686799E+00_JPRB, 0.674216E+00_JPRB, 0.660191E+00_JPRB &
  &, 0.646043E+00_JPRB, 0.631789E+00_JPRB, 0.617435E+00_JPRB, 0.603025E+00_JPRB &
  &, 0.588548E+00_JPRB, 0.574037E+00_JPRB, 0.559494E+00_JPRB &
  &, 0.544958E+00_JPRB, 0.530418E+00_JPRB, 0.515915E+00_JPRB, 0.501437E+00_JPRB &
  &, 0.487028E+00_JPRB, 0.472689E+00_JPRB, 0.458436E+00_JPRB &
  &, 0.444299E+00_JPRB, 0.430264E+00_JPRB, 0.416360E+00_JPRB, 0.402618E+00_JPRB &
  &, 0.389018E+00_JPRB, 0.375590E+00_JPRB, 0.362364E+00_JPRB &
  &, 0.349314E+00_JPRB, 0.336470E+00_JPRB, 0.323857E+00_JPRB, 0.311446E+00_JPRB &
  &, 0.299280E+00_JPRB, 0.287367E+00_JPRB, 0.275708E+00_JPRB &
  &, 0.264286E+00_JPRB, 0.253142E+00_JPRB, 0.242276E+00_JPRB, 0.231662E+00_JPRB &
  &, 0.221339E+00_JPRB, 0.211303E+00_JPRB, 0.201545E+00_JPRB &
  &, 0.192078E+00_JPRB, 0.182890E+00_JPRB, 0.173992E+00_JPRB, 0.165394E+00_JPRB &
  &, 0.157077E+00_JPRB, 0.149074E+00_JPRB, 0.141339E+00_JPRB &
  &, 0.133872E+00_JPRB, 0.126703E+00_JPRB, 0.119806E+00_JPRB, 0.113177E+00_JPRB &
  &, 0.106845E+00_JPRB, 0.100745E+00_JPRB, 0.949324E-01_JPRB &
  &, 0.893685E-01_JPRB, 0.840445E-01_JPRB, 0.789821E-01_JPRB, 0.741703E-01_JPRB &
  &, 0.695622E-01_JPRB, 0.651757E-01_JPRB, 0.610294E-01_JPRB &
  &, 0.571064E-01_JPRB, 0.533514E-01_JPRB, 0.498154E-01_JPRB, 0.464774E-01_JPRB &
  &, 0.433138E-01_JPRB, 0.403379E-01_JPRB, 0.375238E-01_JPRB &
  &, 0.348832E-01_JPRB, 0.323875E-01_JPRB, 0.300472E-01_JPRB, 0.278306E-01_JPRB &
  &, 0.257894E-01_JPRB, 0.238477E-01_JPRB, 0.220568E-01_JPRB &
  &, 0.203811E-01_JPRB, 0.187827E-01_JPRB, 0.173132E-01_JPRB, 0.159333E-01_JPRB &
  &, 0.146489E-01_JPRB, 0.134657E-01_JPRB, 0.123898E-01_JPRB &
  &, 0.113772E-01_JPRB, 0.104320E-01_JPRB, 0.955822E-02_JPRB, 0.870778E-02_JPRB &
  &, 0.798832E-02_JPRB, 0.729912E-02_JPRB, 0.664221E-02_JPRB &
  &, 0.607477E-02_JPRB, 0.548939E-02_JPRB, 0.499924E-02_JPRB, 0.455137E-02_JPRB &
  &, 0.414798E-02_JPRB, 0.373223E-02_JPRB, 0.342377E-02_JPRB &
  &, 0.304522E-02_JPRB, 0.277858E-02_JPRB, 0.250398E-02_JPRB, 0.228451E-02_JPRB &
  &, 0.205859E-02_JPRB, 0.182613E-02_JPRB, 0.165278E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART74',1,ZHOOK_HANDLE)
END SUBROUTINE PART74

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART75

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART75',0,ZHOOK_HANDLE)

XCW( 519, :) = (/ &
  &  0.100131E+01_JPRB, 0.100060E+01_JPRB, 0.999460E+00_JPRB, 0.997911E+00_JPRB &
  &, 0.995940E+00_JPRB, 0.993558E+00_JPRB, 0.990758E+00_JPRB &
  &, 0.987543E+00_JPRB, 0.983915E+00_JPRB, 0.979876E+00_JPRB, 0.975427E+00_JPRB &
  &, 0.970569E+00_JPRB, 0.965308E+00_JPRB, 0.959643E+00_JPRB &
  &, 0.953579E+00_JPRB, 0.947119E+00_JPRB, 0.940267E+00_JPRB, 0.933027E+00_JPRB &
  &, 0.925404E+00_JPRB, 0.917401E+00_JPRB, 0.909028E+00_JPRB &
  &, 0.900289E+00_JPRB, 0.891188E+00_JPRB, 0.881736E+00_JPRB, 0.871937E+00_JPRB &
  &, 0.861801E+00_JPRB, 0.851335E+00_JPRB, 0.840551E+00_JPRB &
  &, 0.829459E+00_JPRB, 0.818062E+00_JPRB, 0.806380E+00_JPRB, 0.794420E+00_JPRB &
  &, 0.782193E+00_JPRB, 0.769715E+00_JPRB, 0.756994E+00_JPRB &
  &, 0.744048E+00_JPRB, 0.730886E+00_JPRB, 0.717520E+00_JPRB, 0.703980E+00_JPRB &
  &, 0.690263E+00_JPRB, 0.676387E+00_JPRB, 0.662384E+00_JPRB &
  &, 0.648247E+00_JPRB, 0.634013E+00_JPRB, 0.619680E+00_JPRB, 0.605267E+00_JPRB &
  &, 0.590808E+00_JPRB, 0.576303E+00_JPRB, 0.561765E+00_JPRB &
  &, 0.547218E+00_JPRB, 0.532693E+00_JPRB, 0.518175E+00_JPRB, 0.503710E+00_JPRB &
  &, 0.489282E+00_JPRB, 0.474937E+00_JPRB, 0.460677E+00_JPRB &
  &, 0.446515E+00_JPRB, 0.432468E+00_JPRB, 0.418566E+00_JPRB, 0.404792E+00_JPRB &
  &, 0.391174E+00_JPRB, 0.377725E+00_JPRB, 0.364458E+00_JPRB &
  &, 0.351401E+00_JPRB, 0.338528E+00_JPRB, 0.325885E+00_JPRB, 0.313441E+00_JPRB &
  &, 0.301260E+00_JPRB, 0.289308E+00_JPRB, 0.277608E+00_JPRB &
  &, 0.266163E+00_JPRB, 0.254972E+00_JPRB, 0.244056E+00_JPRB, 0.233412E+00_JPRB &
  &, 0.223057E+00_JPRB, 0.212962E+00_JPRB, 0.203166E+00_JPRB &
  &, 0.193659E+00_JPRB, 0.184429E+00_JPRB, 0.175510E+00_JPRB, 0.166864E+00_JPRB &
  &, 0.158497E+00_JPRB, 0.150442E+00_JPRB, 0.142650E+00_JPRB &
  &, 0.135153E+00_JPRB, 0.127952E+00_JPRB, 0.121020E+00_JPRB, 0.114355E+00_JPRB &
  &, 0.107955E+00_JPRB, 0.101845E+00_JPRB, 0.959587E-01_JPRB &
  &, 0.903501E-01_JPRB, 0.850115E-01_JPRB, 0.799008E-01_JPRB, 0.750385E-01_JPRB &
  &, 0.703776E-01_JPRB, 0.659709E-01_JPRB, 0.618032E-01_JPRB &
  &, 0.578219E-01_JPRB, 0.540427E-01_JPRB, 0.504815E-01_JPRB, 0.471170E-01_JPRB &
  &, 0.439259E-01_JPRB, 0.408824E-01_JPRB, 0.380772E-01_JPRB &
  &, 0.353653E-01_JPRB, 0.328775E-01_JPRB, 0.305035E-01_JPRB, 0.282943E-01_JPRB &
  &, 0.261748E-01_JPRB, 0.242392E-01_JPRB, 0.224102E-01_JPRB &
  &, 0.206952E-01_JPRB, 0.191016E-01_JPRB, 0.175907E-01_JPRB, 0.162151E-01_JPRB &
  &, 0.149350E-01_JPRB, 0.137078E-01_JPRB, 0.125863E-01_JPRB &
  &, 0.115767E-01_JPRB, 0.106344E-01_JPRB, 0.971222E-02_JPRB, 0.891611E-02_JPRB &
  &, 0.814683E-02_JPRB, 0.740632E-02_JPRB, 0.675094E-02_JPRB &
  &, 0.618504E-02_JPRB, 0.560121E-02_JPRB, 0.511263E-02_JPRB, 0.466634E-02_JPRB &
  &, 0.420626E-02_JPRB, 0.385040E-02_JPRB, 0.348366E-02_JPRB &
  &, 0.316663E-02_JPRB, 0.284010E-02_JPRB, 0.256633E-02_JPRB, 0.234769E-02_JPRB &
  &, 0.212261E-02_JPRB, 0.189099E-02_JPRB, 0.171849E-02_JPRB/)
XCW( 520, :) = (/ &
  &  0.100156E+01_JPRB, 0.100091E+01_JPRB, 0.999837E+00_JPRB, 0.998349E+00_JPRB &
  &, 0.996444E+00_JPRB, 0.994122E+00_JPRB, 0.991383E+00_JPRB &
  &, 0.988229E+00_JPRB, 0.984663E+00_JPRB, 0.980684E+00_JPRB, 0.976294E+00_JPRB &
  &, 0.971497E+00_JPRB, 0.966294E+00_JPRB, 0.960687E+00_JPRB &
  &, 0.954681E+00_JPRB, 0.948277E+00_JPRB, 0.941482E+00_JPRB, 0.934297E+00_JPRB &
  &, 0.926727E+00_JPRB, 0.918778E+00_JPRB, 0.910455E+00_JPRB &
  &, 0.901767E+00_JPRB, 0.892717E+00_JPRB, 0.883312E+00_JPRB, 0.873560E+00_JPRB &
  &, 0.863470E+00_JPRB, 0.853052E+00_JPRB, 0.842310E+00_JPRB &
  &, 0.831257E+00_JPRB, 0.819906E+00_JPRB, 0.808260E+00_JPRB, 0.796339E+00_JPRB &
  &, 0.784148E+00_JPRB, 0.771701E+00_JPRB, 0.759017E+00_JPRB &
  &, 0.746095E+00_JPRB, 0.732965E+00_JPRB, 0.719632E+00_JPRB, 0.706105E+00_JPRB &
  &, 0.692421E+00_JPRB, 0.678568E+00_JPRB, 0.664577E+00_JPRB &
  &, 0.650462E+00_JPRB, 0.636238E+00_JPRB, 0.621914E+00_JPRB, 0.607521E+00_JPRB &
  &, 0.593069E+00_JPRB, 0.578569E+00_JPRB, 0.564035E+00_JPRB &
  &, 0.549492E+00_JPRB, 0.534967E+00_JPRB, 0.520450E+00_JPRB, 0.505968E+00_JPRB &
  &, 0.491551E+00_JPRB, 0.477201E+00_JPRB, 0.462918E+00_JPRB &
  &, 0.448747E+00_JPRB, 0.434688E+00_JPRB, 0.420757E+00_JPRB, 0.406966E+00_JPRB &
  &, 0.393347E+00_JPRB, 0.379878E+00_JPRB, 0.366588E+00_JPRB &
  &, 0.353488E+00_JPRB, 0.340587E+00_JPRB, 0.327914E+00_JPRB, 0.315455E+00_JPRB &
  &, 0.303239E+00_JPRB, 0.291249E+00_JPRB, 0.279508E+00_JPRB &
  &, 0.268019E+00_JPRB, 0.256803E+00_JPRB, 0.245859E+00_JPRB, 0.235184E+00_JPRB &
  &, 0.224774E+00_JPRB, 0.214645E+00_JPRB, 0.204811E+00_JPRB &
  &, 0.195264E+00_JPRB, 0.185991E+00_JPRB, 0.177028E+00_JPRB, 0.168335E+00_JPRB &
  &, 0.159944E+00_JPRB, 0.151809E+00_JPRB, 0.143989E+00_JPRB &
  &, 0.136462E+00_JPRB, 0.129200E+00_JPRB, 0.122205E+00_JPRB, 0.115504E+00_JPRB &
  &, 0.109095E+00_JPRB, 0.102914E+00_JPRB, 0.970162E-01_JPRB &
  &, 0.913634E-01_JPRB, 0.859786E-01_JPRB, 0.808195E-01_JPRB, 0.759066E-01_JPRB &
  &, 0.712271E-01_JPRB, 0.668006E-01_JPRB, 0.625769E-01_JPRB &
  &, 0.585374E-01_JPRB, 0.547340E-01_JPRB, 0.511475E-01_JPRB, 0.477190E-01_JPRB &
  &, 0.444997E-01_JPRB, 0.414657E-01_JPRB, 0.385911E-01_JPRB &
  &, 0.358876E-01_JPRB, 0.333674E-01_JPRB, 0.309599E-01_JPRB, 0.287158E-01_JPRB &
  &, 0.266031E-01_JPRB, 0.246307E-01_JPRB, 0.227637E-01_JPRB &
  &, 0.210542E-01_JPRB, 0.194206E-01_JPRB, 0.179146E-01_JPRB, 0.164970E-01_JPRB &
  &, 0.151734E-01_JPRB, 0.139498E-01_JPRB, 0.128319E-01_JPRB &
  &, 0.117761E-01_JPRB, 0.107862E-01_JPRB, 0.991756E-02_JPRB, 0.907236E-02_JPRB &
  &, 0.830533E-02_JPRB, 0.756710E-02_JPRB, 0.691403E-02_JPRB &
  &, 0.629531E-02_JPRB, 0.576895E-02_JPRB, 0.522603E-02_JPRB, 0.478131E-02_JPRB &
  &, 0.432282E-02_JPRB, 0.390948E-02_JPRB, 0.354355E-02_JPRB &
  &, 0.322733E-02_JPRB, 0.290162E-02_JPRB, 0.262868E-02_JPRB, 0.234769E-02_JPRB &
  &, 0.212261E-02_JPRB, 0.195585E-02_JPRB, 0.171849E-02_JPRB/)
XCW( 521, :) = (/ &
  &  0.100181E+01_JPRB, 0.100122E+01_JPRB, 0.100022E+01_JPRB, 0.998789E+00_JPRB &
  &, 0.996946E+00_JPRB, 0.994686E+00_JPRB, 0.992008E+00_JPRB &
  &, 0.988917E+00_JPRB, 0.985411E+00_JPRB, 0.981492E+00_JPRB, 0.977163E+00_JPRB &
  &, 0.972425E+00_JPRB, 0.967280E+00_JPRB, 0.961731E+00_JPRB &
  &, 0.955783E+00_JPRB, 0.949437E+00_JPRB, 0.942696E+00_JPRB, 0.935566E+00_JPRB &
  &, 0.928052E+00_JPRB, 0.920158E+00_JPRB, 0.911885E+00_JPRB &
  &, 0.903249E+00_JPRB, 0.894247E+00_JPRB, 0.884891E+00_JPRB, 0.875191E+00_JPRB &
  &, 0.865147E+00_JPRB, 0.854769E+00_JPRB, 0.844073E+00_JPRB &
  &, 0.833064E+00_JPRB, 0.821753E+00_JPRB, 0.810145E+00_JPRB, 0.798263E+00_JPRB &
  &, 0.786107E+00_JPRB, 0.773697E+00_JPRB, 0.761040E+00_JPRB &
  &, 0.748150E+00_JPRB, 0.735054E+00_JPRB, 0.721744E+00_JPRB, 0.708251E+00_JPRB &
  &, 0.694580E+00_JPRB, 0.680750E+00_JPRB, 0.666781E+00_JPRB &
  &, 0.652677E+00_JPRB, 0.638475E+00_JPRB, 0.624171E+00_JPRB, 0.609786E+00_JPRB &
  &, 0.595329E+00_JPRB, 0.580835E+00_JPRB, 0.566318E+00_JPRB &
  &, 0.551778E+00_JPRB, 0.537242E+00_JPRB, 0.522724E+00_JPRB, 0.508254E+00_JPRB &
  &, 0.493820E+00_JPRB, 0.479464E+00_JPRB, 0.465174E+00_JPRB &
  &, 0.450994E+00_JPRB, 0.436924E+00_JPRB, 0.422979E+00_JPRB, 0.409173E+00_JPRB &
  &, 0.395520E+00_JPRB, 0.382031E+00_JPRB, 0.368718E+00_JPRB &
  &, 0.355593E+00_JPRB, 0.342665E+00_JPRB, 0.329961E+00_JPRB, 0.317470E+00_JPRB &
  &, 0.305218E+00_JPRB, 0.293210E+00_JPRB, 0.281428E+00_JPRB &
  &, 0.269917E+00_JPRB, 0.258654E+00_JPRB, 0.247661E+00_JPRB, 0.236957E+00_JPRB &
  &, 0.226515E+00_JPRB, 0.216351E+00_JPRB, 0.206457E+00_JPRB &
  &, 0.196870E+00_JPRB, 0.187554E+00_JPRB, 0.178546E+00_JPRB, 0.169805E+00_JPRB &
  &, 0.161364E+00_JPRB, 0.153203E+00_JPRB, 0.145356E+00_JPRB &
  &, 0.137771E+00_JPRB, 0.130449E+00_JPRB, 0.123448E+00_JPRB, 0.116682E+00_JPRB &
  &, 0.110204E+00_JPRB, 0.104014E+00_JPRB, 0.980737E-01_JPRB &
  &, 0.923767E-01_JPRB, 0.869456E-01_JPRB, 0.817381E-01_JPRB, 0.768082E-01_JPRB &
  &, 0.720765E-01_JPRB, 0.675957E-01_JPRB, 0.633506E-01_JPRB &
  &, 0.592887E-01_JPRB, 0.554617E-01_JPRB, 0.518136E-01_JPRB, 0.483587E-01_JPRB &
  &, 0.451118E-01_JPRB, 0.420491E-01_JPRB, 0.391445E-01_JPRB &
  &, 0.364099E-01_JPRB, 0.338574E-01_JPRB, 0.314163E-01_JPRB, 0.291373E-01_JPRB &
  &, 0.270313E-01_JPRB, 0.250222E-01_JPRB, 0.231171E-01_JPRB &
  &, 0.213683E-01_JPRB, 0.197395E-01_JPRB, 0.182385E-01_JPRB, 0.167788E-01_JPRB &
  &, 0.154595E-01_JPRB, 0.142402E-01_JPRB, 0.130776E-01_JPRB &
  &, 0.120254E-01_JPRB, 0.109886E-01_JPRB, 0.100716E-01_JPRB, 0.922861E-02_JPRB &
  &, 0.846384E-02_JPRB, 0.772789E-02_JPRB, 0.707711E-02_JPRB &
  &, 0.646071E-02_JPRB, 0.588077E-02_JPRB, 0.533942E-02_JPRB, 0.483880E-02_JPRB &
  &, 0.443939E-02_JPRB, 0.402765E-02_JPRB, 0.366333E-02_JPRB &
  &, 0.328803E-02_JPRB, 0.296315E-02_JPRB, 0.269103E-02_JPRB, 0.241087E-02_JPRB &
  &, 0.218662E-02_JPRB, 0.195585E-02_JPRB, 0.178420E-02_JPRB/)
XCW( 522, :) = (/ &
  &  0.100207E+01_JPRB, 0.100154E+01_JPRB, 0.100059E+01_JPRB, 0.999229E+00_JPRB &
  &, 0.997448E+00_JPRB, 0.995249E+00_JPRB, 0.992635E+00_JPRB &
  &, 0.989604E+00_JPRB, 0.986159E+00_JPRB, 0.982302E+00_JPRB, 0.978033E+00_JPRB &
  &, 0.973354E+00_JPRB, 0.968267E+00_JPRB, 0.962779E+00_JPRB &
  &, 0.956887E+00_JPRB, 0.950597E+00_JPRB, 0.943908E+00_JPRB, 0.936838E+00_JPRB &
  &, 0.929378E+00_JPRB, 0.921535E+00_JPRB, 0.913318E+00_JPRB &
  &, 0.904731E+00_JPRB, 0.895783E+00_JPRB, 0.886474E+00_JPRB, 0.876818E+00_JPRB &
  &, 0.866824E+00_JPRB, 0.856494E+00_JPRB, 0.845840E+00_JPRB &
  &, 0.834870E+00_JPRB, 0.823600E+00_JPRB, 0.812035E+00_JPRB, 0.800187E+00_JPRB &
  &, 0.788070E+00_JPRB, 0.775692E+00_JPRB, 0.763072E+00_JPRB &
  &, 0.750215E+00_JPRB, 0.737142E+00_JPRB, 0.723856E+00_JPRB, 0.710386E+00_JPRB &
  &, 0.696749E+00_JPRB, 0.682941E+00_JPRB, 0.668985E+00_JPRB &
  &, 0.654903E+00_JPRB, 0.640711E+00_JPRB, 0.626417E+00_JPRB, 0.612052E+00_JPRB &
  &, 0.597614E+00_JPRB, 0.583126E+00_JPRB, 0.568601E+00_JPRB &
  &, 0.554064E+00_JPRB, 0.539530E+00_JPRB, 0.525026E+00_JPRB, 0.510541E+00_JPRB &
  &, 0.496103E+00_JPRB, 0.481728E+00_JPRB, 0.467445E+00_JPRB &
  &, 0.453241E+00_JPRB, 0.439160E+00_JPRB, 0.425202E+00_JPRB, 0.411364E+00_JPRB &
  &, 0.397693E+00_JPRB, 0.384183E+00_JPRB, 0.370848E+00_JPRB &
  &, 0.357698E+00_JPRB, 0.344761E+00_JPRB, 0.332027E+00_JPRB, 0.319504E+00_JPRB &
  &, 0.307217E+00_JPRB, 0.295171E+00_JPRB, 0.283349E+00_JPRB &
  &, 0.271815E+00_JPRB, 0.260506E+00_JPRB, 0.249486E+00_JPRB, 0.238730E+00_JPRB &
  &, 0.228255E+00_JPRB, 0.218033E+00_JPRB, 0.208126E+00_JPRB &
  &, 0.198499E+00_JPRB, 0.189142E+00_JPRB, 0.180090E+00_JPRB, 0.171301E+00_JPRB &
  &, 0.162810E+00_JPRB, 0.154624E+00_JPRB, 0.146722E+00_JPRB &
  &, 0.139079E+00_JPRB, 0.131726E+00_JPRB, 0.124662E+00_JPRB, 0.117889E+00_JPRB &
  &, 0.111374E+00_JPRB, 0.105113E+00_JPRB, 0.991311E-01_JPRB &
  &, 0.933900E-01_JPRB, 0.879126E-01_JPRB, 0.826896E-01_JPRB, 0.777097E-01_JPRB &
  &, 0.729600E-01_JPRB, 0.684254E-01_JPRB, 0.641244E-01_JPRB &
  &, 0.600400E-01_JPRB, 0.561894E-01_JPRB, 0.525166E-01_JPRB, 0.490359E-01_JPRB &
  &, 0.457238E-01_JPRB, 0.426324E-01_JPRB, 0.396979E-01_JPRB &
  &, 0.369322E-01_JPRB, 0.343473E-01_JPRB, 0.318726E-01_JPRB, 0.296010E-01_JPRB &
  &, 0.274167E-01_JPRB, 0.254137E-01_JPRB, 0.235148E-01_JPRB &
  &, 0.217273E-01_JPRB, 0.200585E-01_JPRB, 0.185161E-01_JPRB, 0.170606E-01_JPRB &
  &, 0.157456E-01_JPRB, 0.144822E-01_JPRB, 0.133232E-01_JPRB &
  &, 0.122248E-01_JPRB, 0.112415E-01_JPRB, 0.102769E-01_JPRB, 0.943694E-02_JPRB &
  &, 0.862235E-02_JPRB, 0.788868E-02_JPRB, 0.718584E-02_JPRB &
  &, 0.657098E-02_JPRB, 0.599260E-02_JPRB, 0.545281E-02_JPRB, 0.495377E-02_JPRB &
  &, 0.449767E-02_JPRB, 0.408673E-02_JPRB, 0.372323E-02_JPRB &
  &, 0.334874E-02_JPRB, 0.302467E-02_JPRB, 0.275338E-02_JPRB, 0.247406E-02_JPRB &
  &, 0.225064E-02_JPRB, 0.202071E-02_JPRB, 0.184991E-02_JPRB/)
XCW( 523, :) = (/ &
  &  0.100232E+01_JPRB, 0.100185E+01_JPRB, 0.100097E+01_JPRB, 0.999669E+00_JPRB &
  &, 0.997950E+00_JPRB, 0.995814E+00_JPRB, 0.993261E+00_JPRB &
  &, 0.990292E+00_JPRB, 0.986908E+00_JPRB, 0.983111E+00_JPRB, 0.978902E+00_JPRB &
  &, 0.974283E+00_JPRB, 0.969256E+00_JPRB, 0.963824E+00_JPRB &
  &, 0.957991E+00_JPRB, 0.951758E+00_JPRB, 0.945130E+00_JPRB, 0.938112E+00_JPRB &
  &, 0.930705E+00_JPRB, 0.922918E+00_JPRB, 0.914752E+00_JPRB &
  &, 0.906217E+00_JPRB, 0.897316E+00_JPRB, 0.888060E+00_JPRB, 0.878452E+00_JPRB &
  &, 0.868501E+00_JPRB, 0.858211E+00_JPRB, 0.847607E+00_JPRB &
  &, 0.836685E+00_JPRB, 0.825451E+00_JPRB, 0.813928E+00_JPRB, 0.802119E+00_JPRB &
  &, 0.790034E+00_JPRB, 0.777687E+00_JPRB, 0.765104E+00_JPRB &
  &, 0.752280E+00_JPRB, 0.739231E+00_JPRB, 0.725978E+00_JPRB, 0.712542E+00_JPRB &
  &, 0.698918E+00_JPRB, 0.685133E+00_JPRB, 0.671200E+00_JPRB &
  &, 0.657140E+00_JPRB, 0.642959E+00_JPRB, 0.628686E+00_JPRB, 0.614317E+00_JPRB &
  &, 0.599887E+00_JPRB, 0.585405E+00_JPRB, 0.570897E+00_JPRB &
  &, 0.556364E+00_JPRB, 0.541831E+00_JPRB, 0.527314E+00_JPRB, 0.512827E+00_JPRB &
  &, 0.498386E+00_JPRB, 0.484006E+00_JPRB, 0.469717E+00_JPRB &
  &, 0.455504E+00_JPRB, 0.441396E+00_JPRB, 0.427425E+00_JPRB, 0.413588E+00_JPRB &
  &, 0.399882E+00_JPRB, 0.386353E+00_JPRB, 0.372996E+00_JPRB &
  &, 0.359821E+00_JPRB, 0.346857E+00_JPRB, 0.334094E+00_JPRB, 0.321538E+00_JPRB &
  &, 0.309216E+00_JPRB, 0.297132E+00_JPRB, 0.285290E+00_JPRB &
  &, 0.273713E+00_JPRB, 0.262379E+00_JPRB, 0.251310E+00_JPRB, 0.240525E+00_JPRB &
  &, 0.229996E+00_JPRB, 0.219763E+00_JPRB, 0.209794E+00_JPRB &
  &, 0.200129E+00_JPRB, 0.190730E+00_JPRB, 0.181633E+00_JPRB, 0.172797E+00_JPRB &
  &, 0.164283E+00_JPRB, 0.156045E+00_JPRB, 0.148088E+00_JPRB &
  &, 0.140416E+00_JPRB, 0.133031E+00_JPRB, 0.125905E+00_JPRB, 0.119067E+00_JPRB &
  &, 0.112514E+00_JPRB, 0.106213E+00_JPRB, 0.100189E+00_JPRB &
  &, 0.944349E-01_JPRB, 0.889119E-01_JPRB, 0.836411E-01_JPRB, 0.786113E-01_JPRB &
  &, 0.738094E-01_JPRB, 0.692551E-01_JPRB, 0.649333E-01_JPRB &
  &, 0.607912E-01_JPRB, 0.568808E-01_JPRB, 0.531827E-01_JPRB, 0.496756E-01_JPRB &
  &, 0.463741E-01_JPRB, 0.432157E-01_JPRB, 0.402513E-01_JPRB &
  &, 0.374545E-01_JPRB, 0.348373E-01_JPRB, 0.323705E-01_JPRB, 0.300225E-01_JPRB &
  &, 0.278449E-01_JPRB, 0.258052E-01_JPRB, 0.238682E-01_JPRB &
  &, 0.220862E-01_JPRB, 0.204230E-01_JPRB, 0.188399E-01_JPRB, 0.173894E-01_JPRB &
  &, 0.159840E-01_JPRB, 0.147242E-01_JPRB, 0.135688E-01_JPRB &
  &, 0.124242E-01_JPRB, 0.114439E-01_JPRB, 0.104822E-01_JPRB, 0.959319E-02_JPRB &
  &, 0.878086E-02_JPRB, 0.804947E-02_JPRB, 0.734893E-02_JPRB &
  &, 0.668125E-02_JPRB, 0.610442E-02_JPRB, 0.556620E-02_JPRB, 0.506874E-02_JPRB &
  &, 0.461423E-02_JPRB, 0.420490E-02_JPRB, 0.378312E-02_JPRB &
  &, 0.347015E-02_JPRB, 0.314772E-02_JPRB, 0.281572E-02_JPRB, 0.253724E-02_JPRB &
  &, 0.231466E-02_JPRB, 0.208558E-02_JPRB, 0.184991E-02_JPRB/)
XCW( 524, :) = (/ &
  &  0.100257E+01_JPRB, 0.100217E+01_JPRB, 0.100135E+01_JPRB, 0.100011E+01_JPRB &
  &, 0.998453E+00_JPRB, 0.996379E+00_JPRB, 0.993888E+00_JPRB &
  &, 0.990980E+00_JPRB, 0.987657E+00_JPRB, 0.983921E+00_JPRB, 0.979773E+00_JPRB &
  &, 0.975213E+00_JPRB, 0.970246E+00_JPRB, 0.964873E+00_JPRB &
  &, 0.959096E+00_JPRB, 0.952921E+00_JPRB, 0.946350E+00_JPRB, 0.939385E+00_JPRB &
  &, 0.932034E+00_JPRB, 0.924298E+00_JPRB, 0.916188E+00_JPRB &
  &, 0.907702E+00_JPRB, 0.898852E+00_JPRB, 0.889646E+00_JPRB, 0.880086E+00_JPRB &
  &, 0.870181E+00_JPRB, 0.859944E+00_JPRB, 0.849378E+00_JPRB &
  &, 0.838495E+00_JPRB, 0.827306E+00_JPRB, 0.815821E+00_JPRB, 0.804051E+00_JPRB &
  &, 0.792006E+00_JPRB, 0.779700E+00_JPRB, 0.767141E+00_JPRB &
  &, 0.754345E+00_JPRB, 0.741329E+00_JPRB, 0.728109E+00_JPRB, 0.714687E+00_JPRB &
  &, 0.701097E+00_JPRB, 0.687325E+00_JPRB, 0.673414E+00_JPRB &
  &, 0.659377E+00_JPRB, 0.645206E+00_JPRB, 0.630943E+00_JPRB, 0.616595E+00_JPRB &
  &, 0.602172E+00_JPRB, 0.587709E+00_JPRB, 0.573193E+00_JPRB &
  &, 0.558676E+00_JPRB, 0.544133E+00_JPRB, 0.529616E+00_JPRB, 0.515128E+00_JPRB &
  &, 0.500684E+00_JPRB, 0.486299E+00_JPRB, 0.471988E+00_JPRB &
  &, 0.457766E+00_JPRB, 0.443664E+00_JPRB, 0.429664E+00_JPRB, 0.415796E+00_JPRB &
  &, 0.402089E+00_JPRB, 0.388541E+00_JPRB, 0.375162E+00_JPRB &
  &, 0.361963E+00_JPRB, 0.348953E+00_JPRB, 0.336160E+00_JPRB, 0.323592E+00_JPRB &
  &, 0.311235E+00_JPRB, 0.299113E+00_JPRB, 0.287252E+00_JPRB &
  &, 0.275632E+00_JPRB, 0.264253E+00_JPRB, 0.253157E+00_JPRB, 0.242320E+00_JPRB &
  &, 0.231759E+00_JPRB, 0.221468E+00_JPRB, 0.211487E+00_JPRB &
  &, 0.201758E+00_JPRB, 0.192317E+00_JPRB, 0.183176E+00_JPRB, 0.174320E+00_JPRB &
  &, 0.165756E+00_JPRB, 0.157466E+00_JPRB, 0.149454E+00_JPRB &
  &, 0.141753E+00_JPRB, 0.134308E+00_JPRB, 0.127177E+00_JPRB, 0.120304E+00_JPRB &
  &, 0.113684E+00_JPRB, 0.107343E+00_JPRB, 0.101277E+00_JPRB &
  &, 0.954799E-01_JPRB, 0.899111E-01_JPRB, 0.845925E-01_JPRB, 0.795462E-01_JPRB &
  &, 0.746928E-01_JPRB, 0.701194E-01_JPRB, 0.657422E-01_JPRB &
  &, 0.615783E-01_JPRB, 0.576449E-01_JPRB, 0.538857E-01_JPRB, 0.503528E-01_JPRB &
  &, 0.469862E-01_JPRB, 0.438379E-01_JPRB, 0.408443E-01_JPRB &
  &, 0.380170E-01_JPRB, 0.353681E-01_JPRB, 0.328683E-01_JPRB, 0.304862E-01_JPRB &
  &, 0.282731E-01_JPRB, 0.261967E-01_JPRB, 0.242659E-01_JPRB &
  &, 0.224452E-01_JPRB, 0.207420E-01_JPRB, 0.191638E-01_JPRB, 0.176713E-01_JPRB &
  &, 0.162701E-01_JPRB, 0.150146E-01_JPRB, 0.138144E-01_JPRB &
  &, 0.126735E-01_JPRB, 0.116463E-01_JPRB, 0.106876E-01_JPRB, 0.980152E-02_JPRB &
  &, 0.893937E-02_JPRB, 0.821026E-02_JPRB, 0.751201E-02_JPRB &
  &, 0.684665E-02_JPRB, 0.621625E-02_JPRB, 0.567959E-02_JPRB, 0.518371E-02_JPRB &
  &, 0.473079E-02_JPRB, 0.426398E-02_JPRB, 0.390290E-02_JPRB &
  &, 0.353085E-02_JPRB, 0.320924E-02_JPRB, 0.287807E-02_JPRB, 0.260042E-02_JPRB &
  &, 0.237868E-02_JPRB, 0.215044E-02_JPRB, 0.191562E-02_JPRB/)
XCW( 525, :) = (/ &
  &  0.100282E+01_JPRB, 0.100248E+01_JPRB, 0.100172E+01_JPRB, 0.100055E+01_JPRB &
  &, 0.998956E+00_JPRB, 0.996944E+00_JPRB, 0.994515E+00_JPRB &
  &, 0.991670E+00_JPRB, 0.988407E+00_JPRB, 0.984732E+00_JPRB, 0.980644E+00_JPRB &
  &, 0.976144E+00_JPRB, 0.971236E+00_JPRB, 0.965921E+00_JPRB &
  &, 0.960203E+00_JPRB, 0.954084E+00_JPRB, 0.947569E+00_JPRB, 0.940661E+00_JPRB &
  &, 0.933363E+00_JPRB, 0.925684E+00_JPRB, 0.917624E+00_JPRB &
  &, 0.909191E+00_JPRB, 0.900392E+00_JPRB, 0.891235E+00_JPRB, 0.881724E+00_JPRB &
  &, 0.871865E+00_JPRB, 0.861672E+00_JPRB, 0.851152E+00_JPRB &
  &, 0.840313E+00_JPRB, 0.829165E+00_JPRB, 0.817718E+00_JPRB, 0.805988E+00_JPRB &
  &, 0.793978E+00_JPRB, 0.781704E+00_JPRB, 0.769182E+00_JPRB &
  &, 0.756419E+00_JPRB, 0.743437E+00_JPRB, 0.730241E+00_JPRB, 0.716843E+00_JPRB &
  &, 0.703276E+00_JPRB, 0.689538E+00_JPRB, 0.675640E+00_JPRB &
  &, 0.661614E+00_JPRB, 0.647465E+00_JPRB, 0.633223E+00_JPRB, 0.618884E+00_JPRB &
  &, 0.604469E+00_JPRB, 0.590012E+00_JPRB, 0.575502E+00_JPRB &
  &, 0.560976E+00_JPRB, 0.546447E+00_JPRB, 0.531932E+00_JPRB, 0.517443E+00_JPRB &
  &, 0.502982E+00_JPRB, 0.488592E+00_JPRB, 0.474275E+00_JPRB &
  &, 0.460044E+00_JPRB, 0.445916E+00_JPRB, 0.431903E+00_JPRB, 0.418036E+00_JPRB &
  &, 0.404296E+00_JPRB, 0.390728E+00_JPRB, 0.377327E+00_JPRB &
  &, 0.364104E+00_JPRB, 0.351068E+00_JPRB, 0.338245E+00_JPRB, 0.325645E+00_JPRB &
  &, 0.313273E+00_JPRB, 0.301115E+00_JPRB, 0.289214E+00_JPRB &
  &, 0.277551E+00_JPRB, 0.266148E+00_JPRB, 0.255003E+00_JPRB, 0.244137E+00_JPRB &
  &, 0.233545E+00_JPRB, 0.223221E+00_JPRB, 0.213180E+00_JPRB &
  &, 0.203412E+00_JPRB, 0.193930E+00_JPRB, 0.184745E+00_JPRB, 0.175842E+00_JPRB &
  &, 0.167229E+00_JPRB, 0.158887E+00_JPRB, 0.150848E+00_JPRB &
  &, 0.143089E+00_JPRB, 0.135613E+00_JPRB, 0.128420E+00_JPRB, 0.121511E+00_JPRB &
  &, 0.114853E+00_JPRB, 0.108473E+00_JPRB, 0.102366E+00_JPRB &
  &, 0.965248E-01_JPRB, 0.909104E-01_JPRB, 0.855768E-01_JPRB, 0.804478E-01_JPRB &
  &, 0.756102E-01_JPRB, 0.709490E-01_JPRB, 0.665511E-01_JPRB &
  &, 0.623653E-01_JPRB, 0.583726E-01_JPRB, 0.545888E-01_JPRB, 0.510301E-01_JPRB &
  &, 0.476365E-01_JPRB, 0.444213E-01_JPRB, 0.413977E-01_JPRB &
  &, 0.385393E-01_JPRB, 0.358580E-01_JPRB, 0.333247E-01_JPRB, 0.309499E-01_JPRB &
  &, 0.287014E-01_JPRB, 0.266317E-01_JPRB, 0.246635E-01_JPRB &
  &, 0.228041E-01_JPRB, 0.211065E-01_JPRB, 0.194876E-01_JPRB, 0.179531E-01_JPRB &
  &, 0.165562E-01_JPRB, 0.152566E-01_JPRB, 0.140601E-01_JPRB &
  &, 0.129228E-01_JPRB, 0.118486E-01_JPRB, 0.108929E-01_JPRB, 0.995776E-02_JPRB &
  &, 0.915072E-02_JPRB, 0.837105E-02_JPRB, 0.762074E-02_JPRB &
  &, 0.695692E-02_JPRB, 0.638398E-02_JPRB, 0.579298E-02_JPRB, 0.529868E-02_JPRB &
  &, 0.478908E-02_JPRB, 0.438215E-02_JPRB, 0.396279E-02_JPRB &
  &, 0.359156E-02_JPRB, 0.327077E-02_JPRB, 0.294042E-02_JPRB, 0.266360E-02_JPRB &
  &, 0.244270E-02_JPRB, 0.221530E-02_JPRB, 0.198133E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART75',1,ZHOOK_HANDLE)
END SUBROUTINE PART75

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART76

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART76',0,ZHOOK_HANDLE)

XCW( 526, :) = (/ &
  &  0.100308E+01_JPRB, 0.100280E+01_JPRB, 0.100210E+01_JPRB, 0.100099E+01_JPRB &
  &, 0.999459E+00_JPRB, 0.997510E+00_JPRB, 0.995142E+00_JPRB &
  &, 0.992358E+00_JPRB, 0.989158E+00_JPRB, 0.985543E+00_JPRB, 0.981515E+00_JPRB &
  &, 0.977076E+00_JPRB, 0.972226E+00_JPRB, 0.966971E+00_JPRB &
  &, 0.961311E+00_JPRB, 0.955249E+00_JPRB, 0.948791E+00_JPRB, 0.941938E+00_JPRB &
  &, 0.934696E+00_JPRB, 0.927067E+00_JPRB, 0.919061E+00_JPRB &
  &, 0.910683E+00_JPRB, 0.901935E+00_JPRB, 0.892825E+00_JPRB, 0.883361E+00_JPRB &
  &, 0.873553E+00_JPRB, 0.863405E+00_JPRB, 0.852931E+00_JPRB &
  &, 0.842131E+00_JPRB, 0.831029E+00_JPRB, 0.819620E+00_JPRB, 0.807928E+00_JPRB &
  &, 0.795954E+00_JPRB, 0.783717E+00_JPRB, 0.771228E+00_JPRB &
  &, 0.758493E+00_JPRB, 0.745544E+00_JPRB, 0.732373E+00_JPRB, 0.719008E+00_JPRB &
  &, 0.705455E+00_JPRB, 0.691741E+00_JPRB, 0.677876E+00_JPRB &
  &, 0.663862E+00_JPRB, 0.649736E+00_JPRB, 0.635492E+00_JPRB, 0.621174E+00_JPRB &
  &, 0.606766E+00_JPRB, 0.592316E+00_JPRB, 0.577824E+00_JPRB &
  &, 0.563302E+00_JPRB, 0.548776E+00_JPRB, 0.534247E+00_JPRB, 0.519758E+00_JPRB &
  &, 0.505294E+00_JPRB, 0.490900E+00_JPRB, 0.476576E+00_JPRB &
  &, 0.462322E+00_JPRB, 0.448183E+00_JPRB, 0.434158E+00_JPRB, 0.420277E+00_JPRB &
  &, 0.406520E+00_JPRB, 0.392933E+00_JPRB, 0.379493E+00_JPRB &
  &, 0.366245E+00_JPRB, 0.353201E+00_JPRB, 0.340349E+00_JPRB, 0.327718E+00_JPRB &
  &, 0.315292E+00_JPRB, 0.303117E+00_JPRB, 0.291175E+00_JPRB &
  &, 0.279491E+00_JPRB, 0.268042E+00_JPRB, 0.256872E+00_JPRB, 0.245955E+00_JPRB &
  &, 0.235331E+00_JPRB, 0.224950E+00_JPRB, 0.214873E+00_JPRB &
  &, 0.205066E+00_JPRB, 0.195542E+00_JPRB, 0.186313E+00_JPRB, 0.177389E+00_JPRB &
  &, 0.168728E+00_JPRB, 0.160335E+00_JPRB, 0.152269E+00_JPRB &
  &, 0.144454E+00_JPRB, 0.136947E+00_JPRB, 0.129692E+00_JPRB, 0.122748E+00_JPRB &
  &, 0.116053E+00_JPRB, 0.109634E+00_JPRB, 0.103485E+00_JPRB &
  &, 0.975697E-01_JPRB, 0.919419E-01_JPRB, 0.865611E-01_JPRB, 0.814161E-01_JPRB &
  &, 0.764936E-01_JPRB, 0.718133E-01_JPRB, 0.673600E-01_JPRB &
  &, 0.631524E-01_JPRB, 0.591367E-01_JPRB, 0.552918E-01_JPRB, 0.517073E-01_JPRB &
  &, 0.482869E-01_JPRB, 0.450435E-01_JPRB, 0.419906E-01_JPRB &
  &, 0.391017E-01_JPRB, 0.363888E-01_JPRB, 0.338226E-01_JPRB, 0.314135E-01_JPRB &
  &, 0.291724E-01_JPRB, 0.270232E-01_JPRB, 0.250612E-01_JPRB &
  &, 0.231631E-01_JPRB, 0.214254E-01_JPRB, 0.198115E-01_JPRB, 0.182819E-01_JPRB &
  &, 0.168423E-01_JPRB, 0.155470E-01_JPRB, 0.143057E-01_JPRB &
  &, 0.131222E-01_JPRB, 0.121016E-01_JPRB, 0.110983E-01_JPRB, 0.101661E-01_JPRB &
  &, 0.930923E-02_JPRB, 0.853184E-02_JPRB, 0.778382E-02_JPRB &
  &, 0.712232E-02_JPRB, 0.649581E-02_JPRB, 0.590638E-02_JPRB, 0.541365E-02_JPRB &
  &, 0.490564E-02_JPRB, 0.450032E-02_JPRB, 0.408257E-02_JPRB &
  &, 0.371296E-02_JPRB, 0.333229E-02_JPRB, 0.300277E-02_JPRB, 0.272678E-02_JPRB &
  &, 0.250672E-02_JPRB, 0.221530E-02_JPRB, 0.204705E-02_JPRB/)
XCW( 527, :) = (/ &
  &  0.100333E+01_JPRB, 0.100311E+01_JPRB, 0.100248E+01_JPRB, 0.100143E+01_JPRB &
  &, 0.999962E+00_JPRB, 0.998075E+00_JPRB, 0.995770E+00_JPRB &
  &, 0.993047E+00_JPRB, 0.989909E+00_JPRB, 0.986355E+00_JPRB, 0.982388E+00_JPRB &
  &, 0.978008E+00_JPRB, 0.973218E+00_JPRB, 0.968021E+00_JPRB &
  &, 0.962419E+00_JPRB, 0.956416E+00_JPRB, 0.950013E+00_JPRB, 0.943217E+00_JPRB &
  &, 0.936029E+00_JPRB, 0.928457E+00_JPRB, 0.920504E+00_JPRB &
  &, 0.912175E+00_JPRB, 0.903478E+00_JPRB, 0.894418E+00_JPRB, 0.885003E+00_JPRB &
  &, 0.875241E+00_JPRB, 0.865140E+00_JPRB, 0.854709E+00_JPRB &
  &, 0.843957E+00_JPRB, 0.832892E+00_JPRB, 0.821525E+00_JPRB, 0.809869E+00_JPRB &
  &, 0.797935E+00_JPRB, 0.785735E+00_JPRB, 0.773278E+00_JPRB &
  &, 0.760577E+00_JPRB, 0.747652E+00_JPRB, 0.734514E+00_JPRB, 0.721174E+00_JPRB &
  &, 0.707655E+00_JPRB, 0.693954E+00_JPRB, 0.680102E+00_JPRB &
  &, 0.666121E+00_JPRB, 0.652006E+00_JPRB, 0.637784E+00_JPRB, 0.623463E+00_JPRB &
  &, 0.609075E+00_JPRB, 0.594632E+00_JPRB, 0.580145E+00_JPRB &
  &, 0.565627E+00_JPRB, 0.551091E+00_JPRB, 0.536577E+00_JPRB, 0.522072E+00_JPRB &
  &, 0.507621E+00_JPRB, 0.493208E+00_JPRB, 0.478878E+00_JPRB &
  &, 0.464616E+00_JPRB, 0.450467E+00_JPRB, 0.436429E+00_JPRB, 0.422517E+00_JPRB &
  &, 0.408744E+00_JPRB, 0.395137E+00_JPRB, 0.381676E+00_JPRB &
  &, 0.368423E+00_JPRB, 0.355334E+00_JPRB, 0.342454E+00_JPRB, 0.329790E+00_JPRB &
  &, 0.317350E+00_JPRB, 0.305138E+00_JPRB, 0.293158E+00_JPRB &
  &, 0.281431E+00_JPRB, 0.269959E+00_JPRB, 0.258740E+00_JPRB, 0.247795E+00_JPRB &
  &, 0.237118E+00_JPRB, 0.226703E+00_JPRB, 0.216589E+00_JPRB &
  &, 0.206744E+00_JPRB, 0.197180E+00_JPRB, 0.187907E+00_JPRB, 0.178911E+00_JPRB &
  &, 0.170227E+00_JPRB, 0.161809E+00_JPRB, 0.153663E+00_JPRB &
  &, 0.145818E+00_JPRB, 0.138280E+00_JPRB, 0.130993E+00_JPRB, 0.123985E+00_JPRB &
  &, 0.117253E+00_JPRB, 0.110795E+00_JPRB, 0.104574E+00_JPRB &
  &, 0.986464E-01_JPRB, 0.929734E-01_JPRB, 0.875454E-01_JPRB, 0.823510E-01_JPRB &
  &, 0.774110E-01_JPRB, 0.726776E-01_JPRB, 0.682041E-01_JPRB &
  &, 0.639394E-01_JPRB, 0.598644E-01_JPRB, 0.560319E-01_JPRB, 0.523846E-01_JPRB &
  &, 0.489372E-01_JPRB, 0.456657E-01_JPRB, 0.425836E-01_JPRB &
  &, 0.396642E-01_JPRB, 0.369196E-01_JPRB, 0.343204E-01_JPRB, 0.319194E-01_JPRB &
  &, 0.296007E-01_JPRB, 0.274582E-01_JPRB, 0.254588E-01_JPRB &
  &, 0.235669E-01_JPRB, 0.217900E-01_JPRB, 0.201353E-01_JPRB, 0.186107E-01_JPRB &
  &, 0.171284E-01_JPRB, 0.157890E-01_JPRB, 0.145513E-01_JPRB &
  &, 0.133715E-01_JPRB, 0.123040E-01_JPRB, 0.113036E-01_JPRB, 0.103744E-01_JPRB &
  &, 0.952057E-02_JPRB, 0.869263E-02_JPRB, 0.794691E-02_JPRB &
  &, 0.728773E-02_JPRB, 0.666354E-02_JPRB, 0.607646E-02_JPRB, 0.552863E-02_JPRB &
  &, 0.502220E-02_JPRB, 0.455940E-02_JPRB, 0.414246E-02_JPRB &
  &, 0.377367E-02_JPRB, 0.339381E-02_JPRB, 0.312747E-02_JPRB, 0.278996E-02_JPRB &
  &, 0.250672E-02_JPRB, 0.228016E-02_JPRB, 0.204705E-02_JPRB/)
XCW( 528, :) = (/ &
  &  0.100358E+01_JPRB, 0.100343E+01_JPRB, 0.100286E+01_JPRB, 0.100187E+01_JPRB &
  &, 0.100047E+01_JPRB, 0.998641E+00_JPRB, 0.996398E+00_JPRB &
  &, 0.993737E+00_JPRB, 0.990660E+00_JPRB, 0.987168E+00_JPRB, 0.983261E+00_JPRB &
  &, 0.978941E+00_JPRB, 0.974211E+00_JPRB, 0.969072E+00_JPRB &
  &, 0.963528E+00_JPRB, 0.957582E+00_JPRB, 0.951238E+00_JPRB, 0.944496E+00_JPRB &
  &, 0.937362E+00_JPRB, 0.929843E+00_JPRB, 0.921943E+00_JPRB &
  &, 0.913667E+00_JPRB, 0.905022E+00_JPRB, 0.896014E+00_JPRB, 0.886647E+00_JPRB &
  &, 0.876932E+00_JPRB, 0.866877E+00_JPRB, 0.856491E+00_JPRB &
  &, 0.845779E+00_JPRB, 0.834759E+00_JPRB, 0.823435E+00_JPRB, 0.811818E+00_JPRB &
  &, 0.799920E+00_JPRB, 0.787756E+00_JPRB, 0.775333E+00_JPRB &
  &, 0.762670E+00_JPRB, 0.749769E+00_JPRB, 0.736655E+00_JPRB, 0.723349E+00_JPRB &
  &, 0.709844E+00_JPRB, 0.696177E+00_JPRB, 0.682349E+00_JPRB &
  &, 0.668380E+00_JPRB, 0.654276E+00_JPRB, 0.640076E+00_JPRB, 0.625776E+00_JPRB &
  &, 0.611397E+00_JPRB, 0.596949E+00_JPRB, 0.582467E+00_JPRB &
  &, 0.567953E+00_JPRB, 0.553433E+00_JPRB, 0.538906E+00_JPRB, 0.524415E+00_JPRB &
  &, 0.509947E+00_JPRB, 0.495530E+00_JPRB, 0.481180E+00_JPRB &
  &, 0.466925E+00_JPRB, 0.452750E+00_JPRB, 0.438701E+00_JPRB, 0.424775E+00_JPRB &
  &, 0.410984E+00_JPRB, 0.397359E+00_JPRB, 0.383877E+00_JPRB &
  &, 0.370582E+00_JPRB, 0.357486E+00_JPRB, 0.344577E+00_JPRB, 0.331883E+00_JPRB &
  &, 0.319409E+00_JPRB, 0.307160E+00_JPRB, 0.295161E+00_JPRB &
  &, 0.283392E+00_JPRB, 0.271875E+00_JPRB, 0.260631E+00_JPRB, 0.249635E+00_JPRB &
  &, 0.238927E+00_JPRB, 0.228479E+00_JPRB, 0.218306E+00_JPRB &
  &, 0.208422E+00_JPRB, 0.198817E+00_JPRB, 0.189501E+00_JPRB, 0.180485E+00_JPRB &
  &, 0.171726E+00_JPRB, 0.163284E+00_JPRB, 0.155111E+00_JPRB &
  &, 0.147211E+00_JPRB, 0.139614E+00_JPRB, 0.132265E+00_JPRB, 0.125221E+00_JPRB &
  &, 0.118453E+00_JPRB, 0.111955E+00_JPRB, 0.105694E+00_JPRB &
  &, 0.997229E-01_JPRB, 0.940049E-01_JPRB, 0.885297E-01_JPRB, 0.832860E-01_JPRB &
  &, 0.783284E-01_JPRB, 0.735764E-01_JPRB, 0.690481E-01_JPRB &
  &, 0.647264E-01_JPRB, 0.606285E-01_JPRB, 0.567719E-01_JPRB, 0.530618E-01_JPRB &
  &, 0.495875E-01_JPRB, 0.462880E-01_JPRB, 0.431765E-01_JPRB &
  &, 0.402267E-01_JPRB, 0.374504E-01_JPRB, 0.348598E-01_JPRB, 0.323830E-01_JPRB &
  &, 0.300717E-01_JPRB, 0.278932E-01_JPRB, 0.258564E-01_JPRB &
  &, 0.239259E-01_JPRB, 0.221545E-01_JPRB, 0.204592E-01_JPRB, 0.188925E-01_JPRB &
  &, 0.174622E-01_JPRB, 0.160794E-01_JPRB, 0.147970E-01_JPRB &
  &, 0.136208E-01_JPRB, 0.125063E-01_JPRB, 0.115089E-01_JPRB, 0.105828E-01_JPRB &
  &, 0.967908E-02_JPRB, 0.885342E-02_JPRB, 0.811000E-02_JPRB &
  &, 0.739799E-02_JPRB, 0.677537E-02_JPRB, 0.618986E-02_JPRB, 0.564360E-02_JPRB &
  &, 0.513876E-02_JPRB, 0.467756E-02_JPRB, 0.426224E-02_JPRB &
  &, 0.383437E-02_JPRB, 0.351686E-02_JPRB, 0.318982E-02_JPRB, 0.285314E-02_JPRB &
  &, 0.257073E-02_JPRB, 0.234502E-02_JPRB, 0.211276E-02_JPRB/)
XCW( 529, :) = (/ &
  &  0.100383E+01_JPRB, 0.100375E+01_JPRB, 0.100324E+01_JPRB, 0.100231E+01_JPRB &
  &, 0.100097E+01_JPRB, 0.999207E+00_JPRB, 0.997026E+00_JPRB &
  &, 0.994428E+00_JPRB, 0.991413E+00_JPRB, 0.987981E+00_JPRB, 0.984134E+00_JPRB &
  &, 0.979874E+00_JPRB, 0.975205E+00_JPRB, 0.970125E+00_JPRB &
  &, 0.964639E+00_JPRB, 0.958751E+00_JPRB, 0.952462E+00_JPRB, 0.945777E+00_JPRB &
  &, 0.938700E+00_JPRB, 0.931236E+00_JPRB, 0.923386E+00_JPRB &
  &, 0.915165E+00_JPRB, 0.906568E+00_JPRB, 0.897610E+00_JPRB, 0.888292E+00_JPRB &
  &, 0.878627E+00_JPRB, 0.868616E+00_JPRB, 0.858277E+00_JPRB &
  &, 0.847609E+00_JPRB, 0.836630E+00_JPRB, 0.825344E+00_JPRB, 0.813767E+00_JPRB &
  &, 0.801910E+00_JPRB, 0.789778E+00_JPRB, 0.777392E+00_JPRB &
  &, 0.764753E+00_JPRB, 0.751896E+00_JPRB, 0.738807E+00_JPRB, 0.725525E+00_JPRB &
  &, 0.712054E+00_JPRB, 0.698401E+00_JPRB, 0.684596E+00_JPRB &
  &, 0.670640E+00_JPRB, 0.656558E+00_JPRB, 0.642368E+00_JPRB, 0.628078E+00_JPRB &
  &, 0.613719E+00_JPRB, 0.599277E+00_JPRB, 0.584802E+00_JPRB &
  &, 0.570292E+00_JPRB, 0.555774E+00_JPRB, 0.541249E+00_JPRB, 0.526744E+00_JPRB &
  &, 0.512274E+00_JPRB, 0.497868E+00_JPRB, 0.483512E+00_JPRB &
  &, 0.469234E+00_JPRB, 0.455050E+00_JPRB, 0.440989E+00_JPRB, 0.427048E+00_JPRB &
  &, 0.413242E+00_JPRB, 0.399581E+00_JPRB, 0.386078E+00_JPRB &
  &, 0.372760E+00_JPRB, 0.359637E+00_JPRB, 0.346700E+00_JPRB, 0.333975E+00_JPRB &
  &, 0.321467E+00_JPRB, 0.309202E+00_JPRB, 0.297164E+00_JPRB &
  &, 0.285353E+00_JPRB, 0.273813E+00_JPRB, 0.262521E+00_JPRB, 0.251497E+00_JPRB &
  &, 0.240736E+00_JPRB, 0.230255E+00_JPRB, 0.220046E+00_JPRB &
  &, 0.210125E+00_JPRB, 0.200479E+00_JPRB, 0.191120E+00_JPRB, 0.182059E+00_JPRB &
  &, 0.173252E+00_JPRB, 0.164758E+00_JPRB, 0.156532E+00_JPRB &
  &, 0.148603E+00_JPRB, 0.140948E+00_JPRB, 0.133595E+00_JPRB, 0.126488E+00_JPRB &
  &, 0.119682E+00_JPRB, 0.113116E+00_JPRB, 0.106844E+00_JPRB &
  &, 0.100800E+00_JPRB, 0.950364E-01_JPRB, 0.895468E-01_JPRB, 0.842543E-01_JPRB &
  &, 0.792458E-01_JPRB, 0.744407E-01_JPRB, 0.698922E-01_JPRB &
  &, 0.655492E-01_JPRB, 0.614290E-01_JPRB, 0.575120E-01_JPRB, 0.537767E-01_JPRB &
  &, 0.502761E-01_JPRB, 0.469491E-01_JPRB, 0.437695E-01_JPRB &
  &, 0.407891E-01_JPRB, 0.380220E-01_JPRB, 0.353576E-01_JPRB, 0.328889E-01_JPRB &
  &, 0.305428E-01_JPRB, 0.283282E-01_JPRB, 0.262541E-01_JPRB &
  &, 0.243297E-01_JPRB, 0.225190E-01_JPRB, 0.208293E-01_JPRB, 0.192213E-01_JPRB &
  &, 0.177483E-01_JPRB, 0.163699E-01_JPRB, 0.150917E-01_JPRB &
  &, 0.138701E-01_JPRB, 0.127593E-01_JPRB, 0.117143E-01_JPRB, 0.107390E-01_JPRB &
  &, 0.989043E-02_JPRB, 0.906781E-02_JPRB, 0.827309E-02_JPRB &
  &, 0.756340E-02_JPRB, 0.694310E-02_JPRB, 0.630325E-02_JPRB, 0.575857E-02_JPRB &
  &, 0.525533E-02_JPRB, 0.479573E-02_JPRB, 0.432213E-02_JPRB &
  &, 0.395578E-02_JPRB, 0.357839E-02_JPRB, 0.325217E-02_JPRB, 0.291632E-02_JPRB &
  &, 0.263475E-02_JPRB, 0.240989E-02_JPRB, 0.217847E-02_JPRB/)
XCW( 530, :) = (/ &
  &  0.100408E+01_JPRB, 0.100406E+01_JPRB, 0.100361E+01_JPRB, 0.100276E+01_JPRB &
  &, 0.100147E+01_JPRB, 0.999775E+00_JPRB, 0.997656E+00_JPRB &
  &, 0.995117E+00_JPRB, 0.992164E+00_JPRB, 0.988794E+00_JPRB, 0.985009E+00_JPRB &
  &, 0.980809E+00_JPRB, 0.976199E+00_JPRB, 0.971178E+00_JPRB &
  &, 0.965752E+00_JPRB, 0.959920E+00_JPRB, 0.953689E+00_JPRB, 0.947060E+00_JPRB &
  &, 0.940039E+00_JPRB, 0.932629E+00_JPRB, 0.924832E+00_JPRB &
  &, 0.916660E+00_JPRB, 0.908118E+00_JPRB, 0.899210E+00_JPRB, 0.889940E+00_JPRB &
  &, 0.880322E+00_JPRB, 0.870360E+00_JPRB, 0.860063E+00_JPRB &
  &, 0.849443E+00_JPRB, 0.838502E+00_JPRB, 0.827258E+00_JPRB, 0.815720E+00_JPRB &
  &, 0.803899E+00_JPRB, 0.791805E+00_JPRB, 0.779451E+00_JPRB &
  &, 0.766846E+00_JPRB, 0.754013E+00_JPRB, 0.740968E+00_JPRB, 0.727710E+00_JPRB &
  &, 0.714254E+00_JPRB, 0.700635E+00_JPRB, 0.686843E+00_JPRB &
  &, 0.672910E+00_JPRB, 0.658851E+00_JPRB, 0.644672E+00_JPRB, 0.630391E+00_JPRB &
  &, 0.616040E+00_JPRB, 0.601618E+00_JPRB, 0.587149E+00_JPRB &
  &, 0.572644E+00_JPRB, 0.558116E+00_JPRB, 0.543606E+00_JPRB, 0.529101E+00_JPRB &
  &, 0.514629E+00_JPRB, 0.500205E+00_JPRB, 0.485844E+00_JPRB &
  &, 0.471559E+00_JPRB, 0.457365E+00_JPRB, 0.443276E+00_JPRB, 0.429322E+00_JPRB &
  &, 0.415500E+00_JPRB, 0.401821E+00_JPRB, 0.388297E+00_JPRB &
  &, 0.374956E+00_JPRB, 0.361807E+00_JPRB, 0.348842E+00_JPRB, 0.336086E+00_JPRB &
  &, 0.323545E+00_JPRB, 0.311244E+00_JPRB, 0.299167E+00_JPRB &
  &, 0.287336E+00_JPRB, 0.275751E+00_JPRB, 0.264434E+00_JPRB, 0.253359E+00_JPRB &
  &, 0.242568E+00_JPRB, 0.232054E+00_JPRB, 0.221787E+00_JPRB &
  &, 0.211827E+00_JPRB, 0.202141E+00_JPRB, 0.192739E+00_JPRB, 0.183632E+00_JPRB &
  &, 0.174803E+00_JPRB, 0.166233E+00_JPRB, 0.157980E+00_JPRB &
  &, 0.149995E+00_JPRB, 0.142310E+00_JPRB, 0.134896E+00_JPRB, 0.127754E+00_JPRB &
  &, 0.120882E+00_JPRB, 0.114307E+00_JPRB, 0.107964E+00_JPRB &
  &, 0.101908E+00_JPRB, 0.961001E-01_JPRB, 0.905639E-01_JPRB, 0.852560E-01_JPRB &
  &, 0.801632E-01_JPRB, 0.753395E-01_JPRB, 0.707363E-01_JPRB &
  &, 0.663721E-01_JPRB, 0.621931E-01_JPRB, 0.582520E-01_JPRB, 0.544916E-01_JPRB &
  &, 0.509264E-01_JPRB, 0.475713E-01_JPRB, 0.444020E-01_JPRB &
  &, 0.413918E-01_JPRB, 0.385527E-01_JPRB, 0.358970E-01_JPRB, 0.333525E-01_JPRB &
  &, 0.310138E-01_JPRB, 0.287631E-01_JPRB, 0.266959E-01_JPRB &
  &, 0.247336E-01_JPRB, 0.228835E-01_JPRB, 0.211532E-01_JPRB, 0.195501E-01_JPRB &
  &, 0.180344E-01_JPRB, 0.166603E-01_JPRB, 0.153374E-01_JPRB &
  &, 0.141193E-01_JPRB, 0.130123E-01_JPRB, 0.119196E-01_JPRB, 0.109473E-01_JPRB &
  &, 0.100489E-01_JPRB, 0.922860E-02_JPRB, 0.843617E-02_JPRB &
  &, 0.772880E-02_JPRB, 0.705493E-02_JPRB, 0.647334E-02_JPRB, 0.587354E-02_JPRB &
  &, 0.537189E-02_JPRB, 0.485481E-02_JPRB, 0.444191E-02_JPRB &
  &, 0.401649E-02_JPRB, 0.363991E-02_JPRB, 0.331452E-02_JPRB, 0.304268E-02_JPRB &
  &, 0.269877E-02_JPRB, 0.247475E-02_JPRB, 0.224418E-02_JPRB/)
XCW( 531, :) = (/ &
  &  0.100434E+01_JPRB, 0.100438E+01_JPRB, 0.100399E+01_JPRB, 0.100320E+01_JPRB &
  &, 0.100198E+01_JPRB, 0.100034E+01_JPRB, 0.998284E+00_JPRB &
  &, 0.995811E+00_JPRB, 0.992918E+00_JPRB, 0.989609E+00_JPRB, 0.985883E+00_JPRB &
  &, 0.981745E+00_JPRB, 0.977193E+00_JPRB, 0.972232E+00_JPRB &
  &, 0.966864E+00_JPRB, 0.961090E+00_JPRB, 0.954917E+00_JPRB, 0.948343E+00_JPRB &
  &, 0.941377E+00_JPRB, 0.934021E+00_JPRB, 0.926282E+00_JPRB &
  &, 0.918163E+00_JPRB, 0.909671E+00_JPRB, 0.900810E+00_JPRB, 0.891592E+00_JPRB &
  &, 0.882021E+00_JPRB, 0.872107E+00_JPRB, 0.861853E+00_JPRB &
  &, 0.851277E+00_JPRB, 0.840381E+00_JPRB, 0.829176E+00_JPRB, 0.817678E+00_JPRB &
  &, 0.805880E+00_JPRB, 0.793835E+00_JPRB, 0.781520E+00_JPRB &
  &, 0.768948E+00_JPRB, 0.756149E+00_JPRB, 0.743119E+00_JPRB, 0.729896E+00_JPRB &
  &, 0.716464E+00_JPRB, 0.702869E+00_JPRB, 0.689101E+00_JPRB &
  &, 0.675191E+00_JPRB, 0.661144E+00_JPRB, 0.646976E+00_JPRB, 0.632716E+00_JPRB &
  &, 0.618374E+00_JPRB, 0.603960E+00_JPRB, 0.589496E+00_JPRB &
  &, 0.574996E+00_JPRB, 0.560485E+00_JPRB, 0.545963E+00_JPRB, 0.531458E+00_JPRB &
  &, 0.516971E+00_JPRB, 0.502543E+00_JPRB, 0.488176E+00_JPRB &
  &, 0.473883E+00_JPRB, 0.459680E+00_JPRB, 0.445580E+00_JPRB, 0.431596E+00_JPRB &
  &, 0.417757E+00_JPRB, 0.404060E+00_JPRB, 0.390533E+00_JPRB &
  &, 0.377151E+00_JPRB, 0.363978E+00_JPRB, 0.350985E+00_JPRB, 0.338217E+00_JPRB &
  &, 0.325643E+00_JPRB, 0.313306E+00_JPRB, 0.301191E+00_JPRB &
  &, 0.289318E+00_JPRB, 0.277710E+00_JPRB, 0.266346E+00_JPRB, 0.255244E+00_JPRB &
  &, 0.244400E+00_JPRB, 0.233854E+00_JPRB, 0.223551E+00_JPRB &
  &, 0.213554E+00_JPRB, 0.203828E+00_JPRB, 0.194384E+00_JPRB, 0.185206E+00_JPRB &
  &, 0.176329E+00_JPRB, 0.167734E+00_JPRB, 0.159456E+00_JPRB &
  &, 0.151416E+00_JPRB, 0.143672E+00_JPRB, 0.136226E+00_JPRB, 0.129050E+00_JPRB &
  &, 0.122142E+00_JPRB, 0.115498E+00_JPRB, 0.109115E+00_JPRB &
  &, 0.103016E+00_JPRB, 0.971638E-01_JPRB, 0.915809E-01_JPRB, 0.862243E-01_JPRB &
  &, 0.811146E-01_JPRB, 0.762384E-01_JPRB, 0.716155E-01_JPRB &
  &, 0.671949E-01_JPRB, 0.629935E-01_JPRB, 0.589921E-01_JPRB, 0.552065E-01_JPRB &
  &, 0.516150E-01_JPRB, 0.482324E-01_JPRB, 0.449949E-01_JPRB &
  &, 0.419944E-01_JPRB, 0.391243E-01_JPRB, 0.363948E-01_JPRB, 0.338584E-01_JPRB &
  &, 0.314849E-01_JPRB, 0.291981E-01_JPRB, 0.270935E-01_JPRB &
  &, 0.250925E-01_JPRB, 0.232480E-01_JPRB, 0.215233E-01_JPRB, 0.198789E-01_JPRB &
  &, 0.183682E-01_JPRB, 0.169507E-01_JPRB, 0.156321E-01_JPRB &
  &, 0.143686E-01_JPRB, 0.132146E-01_JPRB, 0.121763E-01_JPRB, 0.111557E-01_JPRB &
  &, 0.102603E-01_JPRB, 0.938938E-02_JPRB, 0.859926E-02_JPRB &
  &, 0.789420E-02_JPRB, 0.722267E-02_JPRB, 0.658673E-02_JPRB, 0.598851E-02_JPRB &
  &, 0.548845E-02_JPRB, 0.497298E-02_JPRB, 0.456170E-02_JPRB &
  &, 0.413790E-02_JPRB, 0.376296E-02_JPRB, 0.337687E-02_JPRB, 0.310586E-02_JPRB &
  &, 0.276279E-02_JPRB, 0.253961E-02_JPRB, 0.230989E-02_JPRB/)
XCW( 532, :) = (/ &
  &  0.100459E+01_JPRB, 0.100469E+01_JPRB, 0.100437E+01_JPRB, 0.100364E+01_JPRB &
  &, 0.100248E+01_JPRB, 0.100091E+01_JPRB, 0.998915E+00_JPRB &
  &, 0.996502E+00_JPRB, 0.993672E+00_JPRB, 0.990424E+00_JPRB, 0.986760E+00_JPRB &
  &, 0.982680E+00_JPRB, 0.978189E+00_JPRB, 0.973288E+00_JPRB &
  &, 0.967978E+00_JPRB, 0.962263E+00_JPRB, 0.956144E+00_JPRB, 0.949629E+00_JPRB &
  &, 0.942719E+00_JPRB, 0.935417E+00_JPRB, 0.927731E+00_JPRB &
  &, 0.919664E+00_JPRB, 0.911225E+00_JPRB, 0.902414E+00_JPRB, 0.893244E+00_JPRB &
  &, 0.883723E+00_JPRB, 0.873854E+00_JPRB, 0.863647E+00_JPRB &
  &, 0.853115E+00_JPRB, 0.842260E+00_JPRB, 0.831098E+00_JPRB, 0.819639E+00_JPRB &
  &, 0.807895E+00_JPRB, 0.795875E+00_JPRB, 0.783588E+00_JPRB &
  &, 0.771050E+00_JPRB, 0.758285E+00_JPRB, 0.745290E+00_JPRB, 0.732081E+00_JPRB &
  &, 0.718684E+00_JPRB, 0.705103E+00_JPRB, 0.691359E+00_JPRB &
  &, 0.677473E+00_JPRB, 0.663437E+00_JPRB, 0.649291E+00_JPRB, 0.635029E+00_JPRB &
  &, 0.620708E+00_JPRB, 0.606313E+00_JPRB, 0.591857E+00_JPRB &
  &, 0.577361E+00_JPRB, 0.562840E+00_JPRB, 0.548320E+00_JPRB, 0.533816E+00_JPRB &
  &, 0.519341E+00_JPRB, 0.504895E+00_JPRB, 0.490523E+00_JPRB &
  &, 0.476223E+00_JPRB, 0.461995E+00_JPRB, 0.447884E+00_JPRB, 0.433903E+00_JPRB &
  &, 0.420032E+00_JPRB, 0.406317E+00_JPRB, 0.392752E+00_JPRB &
  &, 0.379365E+00_JPRB, 0.366166E+00_JPRB, 0.353146E+00_JPRB, 0.340348E+00_JPRB &
  &, 0.327741E+00_JPRB, 0.315369E+00_JPRB, 0.303235E+00_JPRB &
  &, 0.291321E+00_JPRB, 0.279670E+00_JPRB, 0.268281E+00_JPRB, 0.257129E+00_JPRB &
  &, 0.246255E+00_JPRB, 0.235653E+00_JPRB, 0.225339E+00_JPRB &
  &, 0.215281E+00_JPRB, 0.205515E+00_JPRB, 0.196028E+00_JPRB, 0.186805E+00_JPRB &
  &, 0.177907E+00_JPRB, 0.169263E+00_JPRB, 0.160904E+00_JPRB &
  &, 0.152836E+00_JPRB, 0.145062E+00_JPRB, 0.137555E+00_JPRB, 0.130345E+00_JPRB &
  &, 0.123371E+00_JPRB, 0.116690E+00_JPRB, 0.110297E+00_JPRB &
  &, 0.104124E+00_JPRB, 0.982598E-01_JPRB, 0.925980E-01_JPRB, 0.872260E-01_JPRB &
  &, 0.820660E-01_JPRB, 0.771718E-01_JPRB, 0.724948E-01_JPRB &
  &, 0.680177E-01_JPRB, 0.637940E-01_JPRB, 0.597691E-01_JPRB, 0.559590E-01_JPRB &
  &, 0.523036E-01_JPRB, 0.488935E-01_JPRB, 0.456274E-01_JPRB &
  &, 0.425569E-01_JPRB, 0.396551E-01_JPRB, 0.369341E-01_JPRB, 0.343642E-01_JPRB &
  &, 0.319559E-01_JPRB, 0.296766E-01_JPRB, 0.275353E-01_JPRB &
  &, 0.254964E-01_JPRB, 0.236125E-01_JPRB, 0.218471E-01_JPRB, 0.202077E-01_JPRB &
  &, 0.186543E-01_JPRB, 0.172411E-01_JPRB, 0.158777E-01_JPRB &
  &, 0.146179E-01_JPRB, 0.134676E-01_JPRB, 0.123816E-01_JPRB, 0.113640E-01_JPRB &
  &, 0.104716E-01_JPRB, 0.960377E-02_JPRB, 0.876235E-02_JPRB &
  &, 0.805961E-02_JPRB, 0.733449E-02_JPRB, 0.670012E-02_JPRB, 0.610348E-02_JPRB &
  &, 0.560502E-02_JPRB, 0.509115E-02_JPRB, 0.462159E-02_JPRB &
  &, 0.419860E-02_JPRB, 0.382448E-02_JPRB, 0.350157E-02_JPRB, 0.316905E-02_JPRB &
  &, 0.282681E-02_JPRB, 0.260447E-02_JPRB, 0.230989E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART76',1,ZHOOK_HANDLE)
END SUBROUTINE PART76

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART77

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART77',0,ZHOOK_HANDLE)

XCW( 533, :) = (/ &
  &  0.100484E+01_JPRB, 0.100500E+01_JPRB, 0.100475E+01_JPRB, 0.100408E+01_JPRB &
  &, 0.100299E+01_JPRB, 0.100148E+01_JPRB, 0.999545E+00_JPRB &
  &, 0.997194E+00_JPRB, 0.994425E+00_JPRB, 0.991238E+00_JPRB, 0.987636E+00_JPRB &
  &, 0.983617E+00_JPRB, 0.979186E+00_JPRB, 0.974345E+00_JPRB &
  &, 0.969093E+00_JPRB, 0.963435E+00_JPRB, 0.957375E+00_JPRB, 0.950916E+00_JPRB &
  &, 0.944060E+00_JPRB, 0.936813E+00_JPRB, 0.929181E+00_JPRB &
  &, 0.921166E+00_JPRB, 0.912778E+00_JPRB, 0.904020E+00_JPRB, 0.894900E+00_JPRB &
  &, 0.885426E+00_JPRB, 0.875605E+00_JPRB, 0.865444E+00_JPRB &
  &, 0.854952E+00_JPRB, 0.844143E+00_JPRB, 0.833024E+00_JPRB, 0.821605E+00_JPRB &
  &, 0.809897E+00_JPRB, 0.797914E+00_JPRB, 0.785666E+00_JPRB &
  &, 0.773162E+00_JPRB, 0.760422E+00_JPRB, 0.747460E+00_JPRB, 0.734277E+00_JPRB &
  &, 0.720904E+00_JPRB, 0.707348E+00_JPRB, 0.693627E+00_JPRB &
  &, 0.679754E+00_JPRB, 0.665742E+00_JPRB, 0.651618E+00_JPRB, 0.637378E+00_JPRB &
  &, 0.623054E+00_JPRB, 0.608667E+00_JPRB, 0.594217E+00_JPRB &
  &, 0.579726E+00_JPRB, 0.565209E+00_JPRB, 0.550691E+00_JPRB, 0.536187E+00_JPRB &
  &, 0.521711E+00_JPRB, 0.507262E+00_JPRB, 0.492870E+00_JPRB &
  &, 0.478563E+00_JPRB, 0.464342E+00_JPRB, 0.450204E+00_JPRB, 0.436193E+00_JPRB &
  &, 0.422324E+00_JPRB, 0.408591E+00_JPRB, 0.395006E+00_JPRB &
  &, 0.381597E+00_JPRB, 0.368355E+00_JPRB, 0.355326E+00_JPRB, 0.342479E+00_JPRB &
  &, 0.329859E+00_JPRB, 0.317451E+00_JPRB, 0.305279E+00_JPRB &
  &, 0.293346E+00_JPRB, 0.281651E+00_JPRB, 0.270215E+00_JPRB, 0.259036E+00_JPRB &
  &, 0.248133E+00_JPRB, 0.237476E+00_JPRB, 0.227104E+00_JPRB &
  &, 0.217008E+00_JPRB, 0.207202E+00_JPRB, 0.197673E+00_JPRB, 0.188430E+00_JPRB &
  &, 0.179459E+00_JPRB, 0.170791E+00_JPRB, 0.162380E+00_JPRB &
  &, 0.154284E+00_JPRB, 0.146452E+00_JPRB, 0.138914E+00_JPRB, 0.131641E+00_JPRB &
  &, 0.124631E+00_JPRB, 0.117911E+00_JPRB, 0.111447E+00_JPRB &
  &, 0.105264E+00_JPRB, 0.993235E-01_JPRB, 0.936479E-01_JPRB, 0.882277E-01_JPRB &
  &, 0.830173E-01_JPRB, 0.780706E-01_JPRB, 0.733740E-01_JPRB &
  &, 0.688763E-01_JPRB, 0.645945E-01_JPRB, 0.605462E-01_JPRB, 0.566739E-01_JPRB &
  &, 0.530304E-01_JPRB, 0.495546E-01_JPRB, 0.462599E-01_JPRB &
  &, 0.431596E-01_JPRB, 0.402267E-01_JPRB, 0.374735E-01_JPRB, 0.348700E-01_JPRB &
  &, 0.324270E-01_JPRB, 0.301116E-01_JPRB, 0.279772E-01_JPRB &
  &, 0.259451E-01_JPRB, 0.240226E-01_JPRB, 0.222173E-01_JPRB, 0.205365E-01_JPRB &
  &, 0.189881E-01_JPRB, 0.175315E-01_JPRB, 0.161725E-01_JPRB &
  &, 0.149170E-01_JPRB, 0.137205E-01_JPRB, 0.126383E-01_JPRB, 0.116244E-01_JPRB &
  &, 0.106301E-01_JPRB, 0.976456E-02_JPRB, 0.897980E-02_JPRB &
  &, 0.822501E-02_JPRB, 0.750223E-02_JPRB, 0.687021E-02_JPRB, 0.627594E-02_JPRB &
  &, 0.572158E-02_JPRB, 0.520931E-02_JPRB, 0.474137E-02_JPRB &
  &, 0.432001E-02_JPRB, 0.394753E-02_JPRB, 0.356392E-02_JPRB, 0.323223E-02_JPRB &
  &, 0.295484E-02_JPRB, 0.266933E-02_JPRB, 0.237560E-02_JPRB/)
XCW( 534, :) = (/ &
  &  0.100509E+01_JPRB, 0.100532E+01_JPRB, 0.100513E+01_JPRB, 0.100452E+01_JPRB &
  &, 0.100349E+01_JPRB, 0.100204E+01_JPRB, 0.100017E+01_JPRB &
  &, 0.997887E+00_JPRB, 0.995179E+00_JPRB, 0.992055E+00_JPRB, 0.988513E+00_JPRB &
  &, 0.984555E+00_JPRB, 0.980184E+00_JPRB, 0.975401E+00_JPRB &
  &, 0.970208E+00_JPRB, 0.964610E+00_JPRB, 0.958606E+00_JPRB, 0.952204E+00_JPRB &
  &, 0.945405E+00_JPRB, 0.938212E+00_JPRB, 0.930633E+00_JPRB &
  &, 0.922622E+00_JPRB, 0.914338E+00_JPRB, 0.905631E+00_JPRB, 0.896559E+00_JPRB &
  &, 0.887131E+00_JPRB, 0.877359E+00_JPRB, 0.867245E+00_JPRB &
  &, 0.856798E+00_JPRB, 0.846031E+00_JPRB, 0.834954E+00_JPRB, 0.823575E+00_JPRB &
  &, 0.811904E+00_JPRB, 0.799949E+00_JPRB, 0.787743E+00_JPRB &
  &, 0.775273E+00_JPRB, 0.762567E+00_JPRB, 0.749631E+00_JPRB, 0.736483E+00_JPRB &
  &, 0.723135E+00_JPRB, 0.709603E+00_JPRB, 0.695907E+00_JPRB &
  &, 0.682046E+00_JPRB, 0.668057E+00_JPRB, 0.653945E+00_JPRB, 0.639727E+00_JPRB &
  &, 0.625412E+00_JPRB, 0.611033E+00_JPRB, 0.596590E+00_JPRB &
  &, 0.582105E+00_JPRB, 0.567591E+00_JPRB, 0.553076E+00_JPRB, 0.538572E+00_JPRB &
  &, 0.524081E+00_JPRB, 0.509629E+00_JPRB, 0.495232E+00_JPRB &
  &, 0.480919E+00_JPRB, 0.466674E+00_JPRB, 0.452540E+00_JPRB, 0.438517E+00_JPRB &
  &, 0.424616E+00_JPRB, 0.410865E+00_JPRB, 0.397261E+00_JPRB &
  &, 0.383829E+00_JPRB, 0.370563E+00_JPRB, 0.357506E+00_JPRB, 0.344629E+00_JPRB &
  &, 0.331976E+00_JPRB, 0.319533E+00_JPRB, 0.307324E+00_JPRB &
  &, 0.295370E+00_JPRB, 0.283632E+00_JPRB, 0.272171E+00_JPRB, 0.260943E+00_JPRB &
  &, 0.249987E+00_JPRB, 0.239322E+00_JPRB, 0.228892E+00_JPRB &
  &, 0.218759E+00_JPRB, 0.208913E+00_JPRB, 0.199342E+00_JPRB, 0.190056E+00_JPRB &
  &, 0.181037E+00_JPRB, 0.172319E+00_JPRB, 0.163882E+00_JPRB &
  &, 0.155732E+00_JPRB, 0.147843E+00_JPRB, 0.140273E+00_JPRB, 0.132937E+00_JPRB &
  &, 0.125921E+00_JPRB, 0.119133E+00_JPRB, 0.112629E+00_JPRB &
  &, 0.106404E+00_JPRB, 0.100419E+00_JPRB, 0.946978E-01_JPRB, 0.892295E-01_JPRB &
  &, 0.840027E-01_JPRB, 0.790040E-01_JPRB, 0.742533E-01_JPRB &
  &, 0.697349E-01_JPRB, 0.653950E-01_JPRB, 0.613232E-01_JPRB, 0.574264E-01_JPRB &
  &, 0.537190E-01_JPRB, 0.502158E-01_JPRB, 0.469319E-01_JPRB &
  &, 0.438024E-01_JPRB, 0.408392E-01_JPRB, 0.380128E-01_JPRB, 0.354180E-01_JPRB &
  &, 0.329408E-01_JPRB, 0.305901E-01_JPRB, 0.283748E-01_JPRB &
  &, 0.263489E-01_JPRB, 0.243871E-01_JPRB, 0.225874E-01_JPRB, 0.209123E-01_JPRB &
  &, 0.193219E-01_JPRB, 0.178219E-01_JPRB, 0.164673E-01_JPRB &
  &, 0.151663E-01_JPRB, 0.139735E-01_JPRB, 0.128436E-01_JPRB, 0.118327E-01_JPRB &
  &, 0.108415E-01_JPRB, 0.997895E-02_JPRB, 0.914288E-02_JPRB &
  &, 0.839041E-02_JPRB, 0.766996E-02_JPRB, 0.698360E-02_JPRB, 0.639091E-02_JPRB &
  &, 0.583814E-02_JPRB, 0.532748E-02_JPRB, 0.486115E-02_JPRB &
  &, 0.438071E-02_JPRB, 0.400905E-02_JPRB, 0.362627E-02_JPRB, 0.329541E-02_JPRB &
  &, 0.301886E-02_JPRB, 0.273419E-02_JPRB, 0.244131E-02_JPRB/)
XCW( 535, :) = (/ &
  &  0.100535E+01_JPRB, 0.100564E+01_JPRB, 0.100551E+01_JPRB, 0.100496E+01_JPRB &
  &, 0.100400E+01_JPRB, 0.100261E+01_JPRB, 0.100081E+01_JPRB &
  &, 0.998581E+00_JPRB, 0.995935E+00_JPRB, 0.992871E+00_JPRB, 0.989391E+00_JPRB &
  &, 0.985494E+00_JPRB, 0.981183E+00_JPRB, 0.976460E+00_JPRB &
  &, 0.971327E+00_JPRB, 0.965786E+00_JPRB, 0.959840E+00_JPRB, 0.953493E+00_JPRB &
  &, 0.946751E+00_JPRB, 0.939614E+00_JPRB, 0.932089E+00_JPRB &
  &, 0.924180E+00_JPRB, 0.915895E+00_JPRB, 0.907241E+00_JPRB, 0.898207E+00_JPRB &
  &, 0.888841E+00_JPRB, 0.879114E+00_JPRB, 0.869046E+00_JPRB &
  &, 0.858644E+00_JPRB, 0.847922E+00_JPRB, 0.836885E+00_JPRB, 0.825545E+00_JPRB &
  &, 0.813915E+00_JPRB, 0.802002E+00_JPRB, 0.789825E+00_JPRB &
  &, 0.777384E+00_JPRB, 0.764713E+00_JPRB, 0.751811E+00_JPRB, 0.738688E+00_JPRB &
  &, 0.725365E+00_JPRB, 0.711858E+00_JPRB, 0.698186E+00_JPRB &
  &, 0.684350E+00_JPRB, 0.670373E+00_JPRB, 0.656283E+00_JPRB, 0.642076E+00_JPRB &
  &, 0.627770E+00_JPRB, 0.613400E+00_JPRB, 0.598963E+00_JPRB &
  &, 0.584483E+00_JPRB, 0.569987E+00_JPRB, 0.555460E+00_JPRB, 0.540957E+00_JPRB &
  &, 0.526465E+00_JPRB, 0.512011E+00_JPRB, 0.497609E+00_JPRB &
  &, 0.483275E+00_JPRB, 0.469036E+00_JPRB, 0.454877E+00_JPRB, 0.440840E+00_JPRB &
  &, 0.426924E+00_JPRB, 0.413140E+00_JPRB, 0.399533E+00_JPRB &
  &, 0.386061E+00_JPRB, 0.372788E+00_JPRB, 0.359686E+00_JPRB, 0.346799E+00_JPRB &
  &, 0.334114E+00_JPRB, 0.321636E+00_JPRB, 0.309409E+00_JPRB &
  &, 0.297395E+00_JPRB, 0.285634E+00_JPRB, 0.274128E+00_JPRB, 0.262873E+00_JPRB &
  &, 0.251888E+00_JPRB, 0.241168E+00_JPRB, 0.230704E+00_JPRB &
  &, 0.220535E+00_JPRB, 0.210625E+00_JPRB, 0.201012E+00_JPRB, 0.191681E+00_JPRB &
  &, 0.182641E+00_JPRB, 0.173874E+00_JPRB, 0.165385E+00_JPRB &
  &, 0.157180E+00_JPRB, 0.149261E+00_JPRB, 0.141631E+00_JPRB, 0.134262E+00_JPRB &
  &, 0.127181E+00_JPRB, 0.120385E+00_JPRB, 0.113842E+00_JPRB &
  &, 0.107544E+00_JPRB, 0.101548E+00_JPRB, 0.957805E-01_JPRB, 0.902646E-01_JPRB &
  &, 0.849880E-01_JPRB, 0.799720E-01_JPRB, 0.751677E-01_JPRB &
  &, 0.705935E-01_JPRB, 0.662319E-01_JPRB, 0.621003E-01_JPRB, 0.581789E-01_JPRB &
  &, 0.544458E-01_JPRB, 0.509158E-01_JPRB, 0.475643E-01_JPRB &
  &, 0.444050E-01_JPRB, 0.414108E-01_JPRB, 0.385937E-01_JPRB, 0.359238E-01_JPRB &
  &, 0.334119E-01_JPRB, 0.310686E-01_JPRB, 0.288608E-01_JPRB &
  &, 0.267527E-01_JPRB, 0.247972E-01_JPRB, 0.229575E-01_JPRB, 0.212411E-01_JPRB &
  &, 0.196557E-01_JPRB, 0.181607E-01_JPRB, 0.167620E-01_JPRB &
  &, 0.154655E-01_JPRB, 0.142265E-01_JPRB, 0.131003E-01_JPRB, 0.120411E-01_JPRB &
  &, 0.110528E-01_JPRB, 0.101397E-01_JPRB, 0.930597E-02_JPRB &
  &, 0.855581E-02_JPRB, 0.783770E-02_JPRB, 0.715369E-02_JPRB, 0.650588E-02_JPRB &
  &, 0.595470E-02_JPRB, 0.544565E-02_JPRB, 0.498093E-02_JPRB &
  &, 0.450212E-02_JPRB, 0.413210E-02_JPRB, 0.375097E-02_JPRB, 0.335859E-02_JPRB &
  &, 0.308288E-02_JPRB, 0.279906E-02_JPRB, 0.250702E-02_JPRB/)
XCW( 536, :) = (/ &
  &  0.100560E+01_JPRB, 0.100596E+01_JPRB, 0.100589E+01_JPRB, 0.100541E+01_JPRB &
  &, 0.100450E+01_JPRB, 0.100318E+01_JPRB, 0.100144E+01_JPRB &
  &, 0.999273E+00_JPRB, 0.996691E+00_JPRB, 0.993689E+00_JPRB, 0.990270E+00_JPRB &
  &, 0.986433E+00_JPRB, 0.982183E+00_JPRB, 0.977518E+00_JPRB &
  &, 0.972445E+00_JPRB, 0.966962E+00_JPRB, 0.961074E+00_JPRB, 0.954784E+00_JPRB &
  &, 0.948097E+00_JPRB, 0.941017E+00_JPRB, 0.933545E+00_JPRB &
  &, 0.925692E+00_JPRB, 0.917458E+00_JPRB, 0.908851E+00_JPRB, 0.899884E+00_JPRB &
  &, 0.890554E+00_JPRB, 0.880872E+00_JPRB, 0.870851E+00_JPRB &
  &, 0.860489E+00_JPRB, 0.849813E+00_JPRB, 0.838819E+00_JPRB, 0.827519E+00_JPRB &
  &, 0.815930E+00_JPRB, 0.804055E+00_JPRB, 0.791912E+00_JPRB &
  &, 0.779496E+00_JPRB, 0.766868E+00_JPRB, 0.753992E+00_JPRB, 0.740904E+00_JPRB &
  &, 0.727606E+00_JPRB, 0.714124E+00_JPRB, 0.700466E+00_JPRB &
  &, 0.686653E+00_JPRB, 0.672700E+00_JPRB, 0.658622E+00_JPRB, 0.644425E+00_JPRB &
  &, 0.630141E+00_JPRB, 0.615779E+00_JPRB, 0.601348E+00_JPRB &
  &, 0.586874E+00_JPRB, 0.572382E+00_JPRB, 0.557858E+00_JPRB, 0.543357E+00_JPRB &
  &, 0.528864E+00_JPRB, 0.514393E+00_JPRB, 0.499987E+00_JPRB &
  &, 0.485646E+00_JPRB, 0.471383E+00_JPRB, 0.457229E+00_JPRB, 0.443164E+00_JPRB &
  &, 0.429233E+00_JPRB, 0.415448E+00_JPRB, 0.401805E+00_JPRB &
  &, 0.388311E+00_JPRB, 0.375014E+00_JPRB, 0.361885E+00_JPRB, 0.348968E+00_JPRB &
  &, 0.336251E+00_JPRB, 0.323759E+00_JPRB, 0.311474E+00_JPRB &
  &, 0.299440E+00_JPRB, 0.287637E+00_JPRB, 0.276106E+00_JPRB, 0.264803E+00_JPRB &
  &, 0.253789E+00_JPRB, 0.243014E+00_JPRB, 0.232516E+00_JPRB &
  &, 0.222310E+00_JPRB, 0.212362E+00_JPRB, 0.202707E+00_JPRB, 0.193332E+00_JPRB &
  &, 0.184245E+00_JPRB, 0.175429E+00_JPRB, 0.166888E+00_JPRB &
  &, 0.158656E+00_JPRB, 0.150680E+00_JPRB, 0.143019E+00_JPRB, 0.135617E+00_JPRB &
  &, 0.128470E+00_JPRB, 0.121638E+00_JPRB, 0.115024E+00_JPRB &
  &, 0.108716E+00_JPRB, 0.102644E+00_JPRB, 0.968633E-01_JPRB, 0.912997E-01_JPRB &
  &, 0.859734E-01_JPRB, 0.809054E-01_JPRB, 0.760821E-01_JPRB &
  &, 0.714521E-01_JPRB, 0.670687E-01_JPRB, 0.629143E-01_JPRB, 0.589314E-01_JPRB &
  &, 0.551726E-01_JPRB, 0.516158E-01_JPRB, 0.482363E-01_JPRB &
  &, 0.450077E-01_JPRB, 0.420232E-01_JPRB, 0.391330E-01_JPRB, 0.364718E-01_JPRB &
  &, 0.339258E-01_JPRB, 0.315471E-01_JPRB, 0.293026E-01_JPRB &
  &, 0.272014E-01_JPRB, 0.252073E-01_JPRB, 0.233276E-01_JPRB, 0.216169E-01_JPRB &
  &, 0.199895E-01_JPRB, 0.184511E-01_JPRB, 0.170568E-01_JPRB &
  &, 0.157147E-01_JPRB, 0.144794E-01_JPRB, 0.133570E-01_JPRB, 0.122494E-01_JPRB &
  &, 0.112642E-01_JPRB, 0.103541E-01_JPRB, 0.952342E-02_JPRB &
  &, 0.872122E-02_JPRB, 0.794952E-02_JPRB, 0.726708E-02_JPRB, 0.667834E-02_JPRB &
  &, 0.607127E-02_JPRB, 0.556381E-02_JPRB, 0.504082E-02_JPRB &
  &, 0.462353E-02_JPRB, 0.419363E-02_JPRB, 0.381332E-02_JPRB, 0.348495E-02_JPRB &
  &, 0.314690E-02_JPRB, 0.286392E-02_JPRB, 0.257273E-02_JPRB/)
XCW( 537, :) = (/ &
  &  0.100585E+01_JPRB, 0.100627E+01_JPRB, 0.100627E+01_JPRB, 0.100585E+01_JPRB &
  &, 0.100501E+01_JPRB, 0.100375E+01_JPRB, 0.100207E+01_JPRB &
  &, 0.999968E+00_JPRB, 0.997444E+00_JPRB, 0.994507E+00_JPRB, 0.991146E+00_JPRB &
  &, 0.987373E+00_JPRB, 0.983182E+00_JPRB, 0.978578E+00_JPRB &
  &, 0.973564E+00_JPRB, 0.968140E+00_JPRB, 0.962309E+00_JPRB, 0.956077E+00_JPRB &
  &, 0.949446E+00_JPRB, 0.942419E+00_JPRB, 0.935004E+00_JPRB &
  &, 0.927204E+00_JPRB, 0.919022E+00_JPRB, 0.910469E+00_JPRB, 0.901546E+00_JPRB &
  &, 0.892267E+00_JPRB, 0.882634E+00_JPRB, 0.872660E+00_JPRB &
  &, 0.862346E+00_JPRB, 0.851712E+00_JPRB, 0.840757E+00_JPRB, 0.829498E+00_JPRB &
  &, 0.817946E+00_JPRB, 0.806112E+00_JPRB, 0.794003E+00_JPRB &
  &, 0.781635E+00_JPRB, 0.769024E+00_JPRB, 0.756182E+00_JPRB, 0.743119E+00_JPRB &
  &, 0.729847E+00_JPRB, 0.716389E+00_JPRB, 0.702756E+00_JPRB &
  &, 0.688968E+00_JPRB, 0.675027E+00_JPRB, 0.660961E+00_JPRB, 0.646786E+00_JPRB &
  &, 0.632511E+00_JPRB, 0.618157E+00_JPRB, 0.603747E+00_JPRB &
  &, 0.589279E+00_JPRB, 0.574778E+00_JPRB, 0.560271E+00_JPRB, 0.545756E+00_JPRB &
  &, 0.531263E+00_JPRB, 0.516804E+00_JPRB, 0.502379E+00_JPRB &
  &, 0.488032E+00_JPRB, 0.473762E+00_JPRB, 0.459582E+00_JPRB, 0.445504E+00_JPRB &
  &, 0.431558E+00_JPRB, 0.417757E+00_JPRB, 0.404077E+00_JPRB &
  &, 0.390580E+00_JPRB, 0.377240E+00_JPRB, 0.364103E+00_JPRB, 0.351157E+00_JPRB &
  &, 0.338409E+00_JPRB, 0.325882E+00_JPRB, 0.313560E+00_JPRB &
  &, 0.301507E+00_JPRB, 0.289661E+00_JPRB, 0.278085E+00_JPRB, 0.266755E+00_JPRB &
  &, 0.255690E+00_JPRB, 0.244883E+00_JPRB, 0.234352E+00_JPRB &
  &, 0.224086E+00_JPRB, 0.214098E+00_JPRB, 0.204402E+00_JPRB, 0.194983E+00_JPRB &
  &, 0.185850E+00_JPRB, 0.176984E+00_JPRB, 0.168419E+00_JPRB &
  &, 0.160132E+00_JPRB, 0.152127E+00_JPRB, 0.144407E+00_JPRB, 0.136971E+00_JPRB &
  &, 0.129790E+00_JPRB, 0.122890E+00_JPRB, 0.116268E+00_JPRB &
  &, 0.109887E+00_JPRB, 0.103772E+00_JPRB, 0.979460E-01_JPRB, 0.923348E-01_JPRB &
  &, 0.869927E-01_JPRB, 0.818734E-01_JPRB, 0.769965E-01_JPRB &
  &, 0.723464E-01_JPRB, 0.679056E-01_JPRB, 0.636914E-01_JPRB, 0.596839E-01_JPRB &
  &, 0.558995E-01_JPRB, 0.523158E-01_JPRB, 0.488688E-01_JPRB &
  &, 0.456505E-01_JPRB, 0.425948E-01_JPRB, 0.397138E-01_JPRB, 0.370198E-01_JPRB &
  &, 0.344396E-01_JPRB, 0.320256E-01_JPRB, 0.297444E-01_JPRB &
  &, 0.276053E-01_JPRB, 0.256174E-01_JPRB, 0.237440E-01_JPRB, 0.219926E-01_JPRB &
  &, 0.203233E-01_JPRB, 0.187900E-01_JPRB, 0.173515E-01_JPRB &
  &, 0.160139E-01_JPRB, 0.147324E-01_JPRB, 0.135623E-01_JPRB, 0.125098E-01_JPRB &
  &, 0.114755E-01_JPRB, 0.105685E-01_JPRB, 0.968651E-02_JPRB &
  &, 0.888662E-02_JPRB, 0.811726E-02_JPRB, 0.743717E-02_JPRB, 0.679331E-02_JPRB &
  &, 0.618783E-02_JPRB, 0.568198E-02_JPRB, 0.516060E-02_JPRB &
  &, 0.468423E-02_JPRB, 0.431667E-02_JPRB, 0.387566E-02_JPRB, 0.354813E-02_JPRB &
  &, 0.321092E-02_JPRB, 0.292878E-02_JPRB, 0.263845E-02_JPRB/)
XCW( 538, :) = (/ &
  &  0.100611E+01_JPRB, 0.100659E+01_JPRB, 0.100665E+01_JPRB, 0.100629E+01_JPRB &
  &, 0.100552E+01_JPRB, 0.100432E+01_JPRB, 0.100270E+01_JPRB &
  &, 0.100066E+01_JPRB, 0.998203E+00_JPRB, 0.995325E+00_JPRB, 0.992029E+00_JPRB &
  &, 0.988314E+00_JPRB, 0.984185E+00_JPRB, 0.979639E+00_JPRB &
  &, 0.974684E+00_JPRB, 0.969319E+00_JPRB, 0.963547E+00_JPRB, 0.957371E+00_JPRB &
  &, 0.950796E+00_JPRB, 0.943824E+00_JPRB, 0.936463E+00_JPRB &
  &, 0.928716E+00_JPRB, 0.920589E+00_JPRB, 0.912086E+00_JPRB, 0.903216E+00_JPRB &
  &, 0.893984E+00_JPRB, 0.884400E+00_JPRB, 0.874469E+00_JPRB &
  &, 0.864204E+00_JPRB, 0.853612E+00_JPRB, 0.842700E+00_JPRB, 0.831418E+00_JPRB &
  &, 0.819969E+00_JPRB, 0.808169E+00_JPRB, 0.796098E+00_JPRB &
  &, 0.783765E+00_JPRB, 0.771188E+00_JPRB, 0.758373E+00_JPRB, 0.745335E+00_JPRB &
  &, 0.732098E+00_JPRB, 0.718666E+00_JPRB, 0.705057E+00_JPRB &
  &, 0.691282E+00_JPRB, 0.677366E+00_JPRB, 0.663323E+00_JPRB, 0.649159E+00_JPRB &
  &, 0.634894E+00_JPRB, 0.620549E+00_JPRB, 0.606146E+00_JPRB &
  &, 0.591684E+00_JPRB, 0.577187E+00_JPRB, 0.562683E+00_JPRB, 0.548170E+00_JPRB &
  &, 0.533662E+00_JPRB, 0.519201E+00_JPRB, 0.504787E+00_JPRB &
  &, 0.490419E+00_JPRB, 0.476141E+00_JPRB, 0.461950E+00_JPRB, 0.447861E+00_JPRB &
  &, 0.433901E+00_JPRB, 0.420066E+00_JPRB, 0.406384E+00_JPRB &
  &, 0.392848E+00_JPRB, 0.379503E+00_JPRB, 0.366321E+00_JPRB, 0.353346E+00_JPRB &
  &, 0.340566E+00_JPRB, 0.328005E+00_JPRB, 0.315666E+00_JPRB &
  &, 0.303573E+00_JPRB, 0.291706E+00_JPRB, 0.280085E+00_JPRB, 0.268707E+00_JPRB &
  &, 0.257613E+00_JPRB, 0.246753E+00_JPRB, 0.236187E+00_JPRB &
  &, 0.225885E+00_JPRB, 0.215860E+00_JPRB, 0.206122E+00_JPRB, 0.196660E+00_JPRB &
  &, 0.187480E+00_JPRB, 0.178566E+00_JPRB, 0.169949E+00_JPRB &
  &, 0.161636E+00_JPRB, 0.153574E+00_JPRB, 0.145794E+00_JPRB, 0.138326E+00_JPRB &
  &, 0.131110E+00_JPRB, 0.124142E+00_JPRB, 0.117481E+00_JPRB &
  &, 0.111059E+00_JPRB, 0.104932E+00_JPRB, 0.990287E-01_JPRB, 0.934033E-01_JPRB &
  &, 0.879781E-01_JPRB, 0.828414E-01_JPRB, 0.779109E-01_JPRB &
  &, 0.732408E-01_JPRB, 0.687789E-01_JPRB, 0.645054E-01_JPRB, 0.604741E-01_JPRB &
  &, 0.566263E-01_JPRB, 0.530158E-01_JPRB, 0.495804E-01_JPRB &
  &, 0.462933E-01_JPRB, 0.432073E-01_JPRB, 0.402947E-01_JPRB, 0.375678E-01_JPRB &
  &, 0.349535E-01_JPRB, 0.325041E-01_JPRB, 0.302304E-01_JPRB &
  &, 0.280540E-01_JPRB, 0.260275E-01_JPRB, 0.241141E-01_JPRB, 0.223214E-01_JPRB &
  &, 0.206570E-01_JPRB, 0.191288E-01_JPRB, 0.176463E-01_JPRB &
  &, 0.162632E-01_JPRB, 0.150359E-01_JPRB, 0.138190E-01_JPRB, 0.127181E-01_JPRB &
  &, 0.116869E-01_JPRB, 0.107829E-01_JPRB, 0.984960E-02_JPRB &
  &, 0.905202E-02_JPRB, 0.828500E-02_JPRB, 0.760725E-02_JPRB, 0.696577E-02_JPRB &
  &, 0.636267E-02_JPRB, 0.580014E-02_JPRB, 0.528039E-02_JPRB &
  &, 0.480564E-02_JPRB, 0.437820E-02_JPRB, 0.400036E-02_JPRB, 0.361131E-02_JPRB &
  &, 0.327494E-02_JPRB, 0.299364E-02_JPRB, 0.270416E-02_JPRB/)
XCW( 539, :) = (/ &
  &  0.100636E+01_JPRB, 0.100691E+01_JPRB, 0.100703E+01_JPRB, 0.100674E+01_JPRB &
  &, 0.100602E+01_JPRB, 0.100489E+01_JPRB, 0.100333E+01_JPRB &
  &, 0.100136E+01_JPRB, 0.998961E+00_JPRB, 0.996143E+00_JPRB, 0.992910E+00_JPRB &
  &, 0.989256E+00_JPRB, 0.985186E+00_JPRB, 0.980702E+00_JPRB &
  &, 0.975803E+00_JPRB, 0.970499E+00_JPRB, 0.964784E+00_JPRB, 0.958667E+00_JPRB &
  &, 0.952148E+00_JPRB, 0.945233E+00_JPRB, 0.937926E+00_JPRB &
  &, 0.930231E+00_JPRB, 0.922155E+00_JPRB, 0.913707E+00_JPRB, 0.904886E+00_JPRB &
  &, 0.895705E+00_JPRB, 0.886166E+00_JPRB, 0.876286E+00_JPRB &
  &, 0.866065E+00_JPRB, 0.855515E+00_JPRB, 0.844646E+00_JPRB, 0.833467E+00_JPRB &
  &, 0.821993E+00_JPRB, 0.810236E+00_JPRB, 0.798198E+00_JPRB &
  &, 0.785895E+00_JPRB, 0.773353E+00_JPRB, 0.760573E+00_JPRB, 0.747561E+00_JPRB &
  &, 0.734349E+00_JPRB, 0.720942E+00_JPRB, 0.707358E+00_JPRB &
  &, 0.693608E+00_JPRB, 0.679704E+00_JPRB, 0.665673E+00_JPRB, 0.651532E+00_JPRB &
  &, 0.637289E+00_JPRB, 0.622952E+00_JPRB, 0.608544E+00_JPRB &
  &, 0.594101E+00_JPRB, 0.579610E+00_JPRB, 0.565095E+00_JPRB, 0.550583E+00_JPRB &
  &, 0.536089E+00_JPRB, 0.521612E+00_JPRB, 0.507195E+00_JPRB &
  &, 0.492821E+00_JPRB, 0.478535E+00_JPRB, 0.464319E+00_JPRB, 0.450218E+00_JPRB &
  &, 0.436244E+00_JPRB, 0.422392E+00_JPRB, 0.408692E+00_JPRB &
  &, 0.395135E+00_JPRB, 0.381748E+00_JPRB, 0.368558E+00_JPRB, 0.355554E+00_JPRB &
  &, 0.342743E+00_JPRB, 0.330148E+00_JPRB, 0.317793E+00_JPRB &
  &, 0.305640E+00_JPRB, 0.293752E+00_JPRB, 0.282085E+00_JPRB, 0.270682E+00_JPRB &
  &, 0.259537E+00_JPRB, 0.248645E+00_JPRB, 0.238047E+00_JPRB &
  &, 0.227709E+00_JPRB, 0.217621E+00_JPRB, 0.207843E+00_JPRB, 0.198336E+00_JPRB &
  &, 0.189111E+00_JPRB, 0.180174E+00_JPRB, 0.171506E+00_JPRB &
  &, 0.163139E+00_JPRB, 0.155050E+00_JPRB, 0.147211E+00_JPRB, 0.139680E+00_JPRB &
  &, 0.132429E+00_JPRB, 0.125425E+00_JPRB, 0.118725E+00_JPRB &
  &, 0.112262E+00_JPRB, 0.106060E+00_JPRB, 0.100144E+00_JPRB, 0.944384E-01_JPRB &
  &, 0.889974E-01_JPRB, 0.838093E-01_JPRB, 0.788605E-01_JPRB &
  &, 0.741352E-01_JPRB, 0.696157E-01_JPRB, 0.653565E-01_JPRB, 0.612642E-01_JPRB &
  &, 0.573914E-01_JPRB, 0.537158E-01_JPRB, 0.502524E-01_JPRB &
  &, 0.469362E-01_JPRB, 0.438197E-01_JPRB, 0.408755E-01_JPRB, 0.381158E-01_JPRB &
  &, 0.354674E-01_JPRB, 0.330261E-01_JPRB, 0.306723E-01_JPRB &
  &, 0.285027E-01_JPRB, 0.264376E-01_JPRB, 0.245305E-01_JPRB, 0.226972E-01_JPRB &
  &, 0.210385E-01_JPRB, 0.194192E-01_JPRB, 0.179410E-01_JPRB &
  &, 0.165623E-01_JPRB, 0.152889E-01_JPRB, 0.140757E-01_JPRB, 0.129786E-01_JPRB &
  &, 0.119511E-01_JPRB, 0.109437E-01_JPRB, 0.100670E-01_JPRB &
  &, 0.921743E-02_JPRB, 0.845273E-02_JPRB, 0.777734E-02_JPRB, 0.708074E-02_JPRB &
  &, 0.647924E-02_JPRB, 0.591831E-02_JPRB, 0.540017E-02_JPRB &
  &, 0.492705E-02_JPRB, 0.450124E-02_JPRB, 0.406271E-02_JPRB, 0.373767E-02_JPRB &
  &, 0.333895E-02_JPRB, 0.305850E-02_JPRB, 0.276987E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART77',1,ZHOOK_HANDLE)
END SUBROUTINE PART77

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART78

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART78',0,ZHOOK_HANDLE)

XCW( 540, :) = (/ &
  &  0.100661E+01_JPRB, 0.100722E+01_JPRB, 0.100741E+01_JPRB, 0.100718E+01_JPRB &
  &, 0.100653E+01_JPRB, 0.100546E+01_JPRB, 0.100397E+01_JPRB &
  &, 0.100205E+01_JPRB, 0.999720E+00_JPRB, 0.996964E+00_JPRB, 0.993792E+00_JPRB &
  &, 0.990198E+00_JPRB, 0.986190E+00_JPRB, 0.981766E+00_JPRB &
  &, 0.976929E+00_JPRB, 0.971680E+00_JPRB, 0.966024E+00_JPRB, 0.959964E+00_JPRB &
  &, 0.953502E+00_JPRB, 0.946641E+00_JPRB, 0.939388E+00_JPRB &
  &, 0.931750E+00_JPRB, 0.923726E+00_JPRB, 0.915327E+00_JPRB, 0.906559E+00_JPRB &
  &, 0.897425E+00_JPRB, 0.887936E+00_JPRB, 0.878102E+00_JPRB &
  &, 0.867926E+00_JPRB, 0.857422E+00_JPRB, 0.846597E+00_JPRB, 0.835459E+00_JPRB &
  &, 0.824026E+00_JPRB, 0.812302E+00_JPRB, 0.800303E+00_JPRB &
  &, 0.788034E+00_JPRB, 0.775528E+00_JPRB, 0.762773E+00_JPRB, 0.749796E+00_JPRB &
  &, 0.736610E+00_JPRB, 0.723229E+00_JPRB, 0.709659E+00_JPRB &
  &, 0.695934E+00_JPRB, 0.682054E+00_JPRB, 0.668046E+00_JPRB, 0.653917E+00_JPRB &
  &, 0.639672E+00_JPRB, 0.625356E+00_JPRB, 0.610969E+00_JPRB &
  &, 0.596519E+00_JPRB, 0.582032E+00_JPRB, 0.567521E+00_JPRB, 0.553011E+00_JPRB &
  &, 0.538517E+00_JPRB, 0.524038E+00_JPRB, 0.509602E+00_JPRB &
  &, 0.495223E+00_JPRB, 0.480930E+00_JPRB, 0.466704E+00_JPRB, 0.452591E+00_JPRB &
  &, 0.438603E+00_JPRB, 0.424719E+00_JPRB, 0.410999E+00_JPRB &
  &, 0.397421E+00_JPRB, 0.384029E+00_JPRB, 0.370795E+00_JPRB, 0.357763E+00_JPRB &
  &, 0.344940E+00_JPRB, 0.332311E+00_JPRB, 0.319899E+00_JPRB &
  &, 0.307728E+00_JPRB, 0.295797E+00_JPRB, 0.284108E+00_JPRB, 0.272656E+00_JPRB &
  &, 0.261483E+00_JPRB, 0.250562E+00_JPRB, 0.239907E+00_JPRB &
  &, 0.229509E+00_JPRB, 0.219407E+00_JPRB, 0.209588E+00_JPRB, 0.200039E+00_JPRB &
  &, 0.190768E+00_JPRB, 0.181783E+00_JPRB, 0.173064E+00_JPRB &
  &, 0.164643E+00_JPRB, 0.156497E+00_JPRB, 0.148656E+00_JPRB, 0.141064E+00_JPRB &
  &, 0.133749E+00_JPRB, 0.126739E+00_JPRB, 0.119969E+00_JPRB &
  &, 0.113466E+00_JPRB, 0.107221E+00_JPRB, 0.101260E+00_JPRB, 0.955403E-01_JPRB &
  &, 0.900507E-01_JPRB, 0.848119E-01_JPRB, 0.798101E-01_JPRB &
  &, 0.750295E-01_JPRB, 0.704890E-01_JPRB, 0.661706E-01_JPRB, 0.620543E-01_JPRB &
  &, 0.581565E-01_JPRB, 0.544547E-01_JPRB, 0.509244E-01_JPRB &
  &, 0.476192E-01_JPRB, 0.444730E-01_JPRB, 0.414563E-01_JPRB, 0.386637E-01_JPRB &
  &, 0.360241E-01_JPRB, 0.335046E-01_JPRB, 0.311583E-01_JPRB &
  &, 0.289514E-01_JPRB, 0.268476E-01_JPRB, 0.249006E-01_JPRB, 0.230730E-01_JPRB &
  &, 0.213723E-01_JPRB, 0.197580E-01_JPRB, 0.182849E-01_JPRB &
  &, 0.168614E-01_JPRB, 0.155419E-01_JPRB, 0.143323E-01_JPRB, 0.131869E-01_JPRB &
  &, 0.121624E-01_JPRB, 0.111581E-01_JPRB, 0.102845E-01_JPRB &
  &, 0.943796E-02_JPRB, 0.862047E-02_JPRB, 0.789073E-02_JPRB, 0.725320E-02_JPRB &
  &, 0.659580E-02_JPRB, 0.603648E-02_JPRB, 0.551995E-02_JPRB &
  &, 0.504846E-02_JPRB, 0.456277E-02_JPRB, 0.418741E-02_JPRB, 0.380085E-02_JPRB &
  &, 0.346699E-02_JPRB, 0.312336E-02_JPRB, 0.283558E-02_JPRB/)
XCW( 541, :) = (/ &
  &  0.100686E+01_JPRB, 0.100754E+01_JPRB, 0.100779E+01_JPRB, 0.100762E+01_JPRB &
  &, 0.100704E+01_JPRB, 0.100603E+01_JPRB, 0.100460E+01_JPRB &
  &, 0.100275E+01_JPRB, 0.100047E+01_JPRB, 0.997785E+00_JPRB, 0.994673E+00_JPRB &
  &, 0.991142E+00_JPRB, 0.987194E+00_JPRB, 0.982830E+00_JPRB &
  &, 0.978052E+00_JPRB, 0.972863E+00_JPRB, 0.967265E+00_JPRB, 0.961262E+00_JPRB &
  &, 0.954857E+00_JPRB, 0.948053E+00_JPRB, 0.940857E+00_JPRB &
  &, 0.933268E+00_JPRB, 0.925299E+00_JPRB, 0.916951E+00_JPRB, 0.908232E+00_JPRB &
  &, 0.899149E+00_JPRB, 0.889709E+00_JPRB, 0.879923E+00_JPRB &
  &, 0.869791E+00_JPRB, 0.859329E+00_JPRB, 0.848548E+00_JPRB, 0.837454E+00_JPRB &
  &, 0.826058E+00_JPRB, 0.814372E+00_JPRB, 0.802412E+00_JPRB &
  &, 0.790183E+00_JPRB, 0.777702E+00_JPRB, 0.764983E+00_JPRB, 0.752032E+00_JPRB &
  &, 0.738872E+00_JPRB, 0.725515E+00_JPRB, 0.711982E+00_JPRB &
  &, 0.698270E+00_JPRB, 0.684415E+00_JPRB, 0.670420E+00_JPRB, 0.656301E+00_JPRB &
  &, 0.642079E+00_JPRB, 0.627773E+00_JPRB, 0.613380E+00_JPRB &
  &, 0.598950E+00_JPRB, 0.584468E+00_JPRB, 0.569960E+00_JPRB, 0.555453E+00_JPRB &
  &, 0.540945E+00_JPRB, 0.526464E+00_JPRB, 0.512025E+00_JPRB &
  &, 0.497641E+00_JPRB, 0.483340E+00_JPRB, 0.469105E+00_JPRB, 0.454981E+00_JPRB &
  &, 0.440963E+00_JPRB, 0.427079E+00_JPRB, 0.413325E+00_JPRB &
  &, 0.399726E+00_JPRB, 0.386311E+00_JPRB, 0.373051E+00_JPRB, 0.359991E+00_JPRB &
  &, 0.347137E+00_JPRB, 0.334475E+00_JPRB, 0.322047E+00_JPRB &
  &, 0.309837E+00_JPRB, 0.297864E+00_JPRB, 0.286130E+00_JPRB, 0.274653E+00_JPRB &
  &, 0.263430E+00_JPRB, 0.252478E+00_JPRB, 0.241766E+00_JPRB &
  &, 0.231358E+00_JPRB, 0.221193E+00_JPRB, 0.211334E+00_JPRB, 0.201742E+00_JPRB &
  &, 0.192425E+00_JPRB, 0.183391E+00_JPRB, 0.174649E+00_JPRB &
  &, 0.166175E+00_JPRB, 0.158001E+00_JPRB, 0.150073E+00_JPRB, 0.142448E+00_JPRB &
  &, 0.135099E+00_JPRB, 0.128022E+00_JPRB, 0.121213E+00_JPRB &
  &, 0.114669E+00_JPRB, 0.108381E+00_JPRB, 0.102375E+00_JPRB, 0.966088E-01_JPRB &
  &, 0.911040E-01_JPRB, 0.858144E-01_JPRB, 0.807597E-01_JPRB &
  &, 0.759597E-01_JPRB, 0.713622E-01_JPRB, 0.670216E-01_JPRB, 0.628821E-01_JPRB &
  &, 0.589215E-01_JPRB, 0.551935E-01_JPRB, 0.516359E-01_JPRB &
  &, 0.482620E-01_JPRB, 0.450854E-01_JPRB, 0.420786E-01_JPRB, 0.392539E-01_JPRB &
  &, 0.365380E-01_JPRB, 0.340266E-01_JPRB, 0.316443E-01_JPRB &
  &, 0.294001E-01_JPRB, 0.273033E-01_JPRB, 0.253170E-01_JPRB, 0.234487E-01_JPRB &
  &, 0.217538E-01_JPRB, 0.200968E-01_JPRB, 0.185797E-01_JPRB &
  &, 0.171606E-01_JPRB, 0.158454E-01_JPRB, 0.145890E-01_JPRB, 0.134473E-01_JPRB &
  &, 0.123737E-01_JPRB, 0.113725E-01_JPRB, 0.104476E-01_JPRB &
  &, 0.960337E-02_JPRB, 0.878820E-02_JPRB, 0.806082E-02_JPRB, 0.736817E-02_JPRB &
  &, 0.677064E-02_JPRB, 0.615464E-02_JPRB, 0.563973E-02_JPRB &
  &, 0.516987E-02_JPRB, 0.468582E-02_JPRB, 0.424976E-02_JPRB, 0.386404E-02_JPRB &
  &, 0.353101E-02_JPRB, 0.318823E-02_JPRB, 0.290129E-02_JPRB/)
XCW( 542, :) = (/ &
  &  0.100712E+01_JPRB, 0.100785E+01_JPRB, 0.100817E+01_JPRB, 0.100807E+01_JPRB &
  &, 0.100755E+01_JPRB, 0.100660E+01_JPRB, 0.100523E+01_JPRB &
  &, 0.100345E+01_JPRB, 0.100124E+01_JPRB, 0.998606E+00_JPRB, 0.995556E+00_JPRB &
  &, 0.992084E+00_JPRB, 0.988199E+00_JPRB, 0.983895E+00_JPRB &
  &, 0.979178E+00_JPRB, 0.974047E+00_JPRB, 0.968508E+00_JPRB, 0.962563E+00_JPRB &
  &, 0.956213E+00_JPRB, 0.949465E+00_JPRB, 0.942322E+00_JPRB &
  &, 0.934790E+00_JPRB, 0.926873E+00_JPRB, 0.918579E+00_JPRB, 0.909912E+00_JPRB &
  &, 0.900877E+00_JPRB, 0.891486E+00_JPRB, 0.881743E+00_JPRB &
  &, 0.871660E+00_JPRB, 0.861245E+00_JPRB, 0.850502E+00_JPRB, 0.839454E+00_JPRB &
  &, 0.828095E+00_JPRB, 0.816451E+00_JPRB, 0.804526E+00_JPRB &
  &, 0.792332E+00_JPRB, 0.779876E+00_JPRB, 0.767192E+00_JPRB, 0.754278E+00_JPRB &
  &, 0.741143E+00_JPRB, 0.727813E+00_JPRB, 0.714294E+00_JPRB &
  &, 0.700618E+00_JPRB, 0.686776E+00_JPRB, 0.672793E+00_JPRB, 0.658698E+00_JPRB &
  &, 0.644486E+00_JPRB, 0.630189E+00_JPRB, 0.615817E+00_JPRB &
  &, 0.601381E+00_JPRB, 0.586904E+00_JPRB, 0.572414E+00_JPRB, 0.557895E+00_JPRB &
  &, 0.543387E+00_JPRB, 0.528905E+00_JPRB, 0.514463E+00_JPRB &
  &, 0.500074E+00_JPRB, 0.485750E+00_JPRB, 0.471507E+00_JPRB, 0.457371E+00_JPRB &
  &, 0.443339E+00_JPRB, 0.429423E+00_JPRB, 0.415668E+00_JPRB &
  &, 0.402048E+00_JPRB, 0.388592E+00_JPRB, 0.375326E+00_JPRB, 0.362238E+00_JPRB &
  &, 0.349334E+00_JPRB, 0.336658E+00_JPRB, 0.324195E+00_JPRB &
  &, 0.311945E+00_JPRB, 0.299932E+00_JPRB, 0.288174E+00_JPRB, 0.276650E+00_JPRB &
  &, 0.265399E+00_JPRB, 0.254394E+00_JPRB, 0.243674E+00_JPRB &
  &, 0.233206E+00_JPRB, 0.223004E+00_JPRB, 0.213080E+00_JPRB, 0.203444E+00_JPRB &
  &, 0.194082E+00_JPRB, 0.185027E+00_JPRB, 0.176234E+00_JPRB &
  &, 0.167706E+00_JPRB, 0.159476E+00_JPRB, 0.151518E+00_JPRB, 0.143862E+00_JPRB &
  &, 0.136448E+00_JPRB, 0.129335E+00_JPRB, 0.122488E+00_JPRB &
  &, 0.115904E+00_JPRB, 0.109574E+00_JPRB, 0.103524E+00_JPRB, 0.977107E-01_JPRB &
  &, 0.921233E-01_JPRB, 0.868170E-01_JPRB, 0.817444E-01_JPRB &
  &, 0.768898E-01_JPRB, 0.722719E-01_JPRB, 0.678727E-01_JPRB, 0.636722E-01_JPRB &
  &, 0.596866E-01_JPRB, 0.559324E-01_JPRB, 0.523474E-01_JPRB &
  &, 0.489450E-01_JPRB, 0.457387E-01_JPRB, 0.427010E-01_JPRB, 0.398019E-01_JPRB &
  &, 0.370947E-01_JPRB, 0.345486E-01_JPRB, 0.321303E-01_JPRB &
  &, 0.298488E-01_JPRB, 0.277589E-01_JPRB, 0.257334E-01_JPRB, 0.238715E-01_JPRB &
  &, 0.220876E-01_JPRB, 0.204356E-01_JPRB, 0.189236E-01_JPRB &
  &, 0.174597E-01_JPRB, 0.161490E-01_JPRB, 0.148970E-01_JPRB, 0.137077E-01_JPRB &
  &, 0.126379E-01_JPRB, 0.115868E-01_JPRB, 0.106650E-01_JPRB &
  &, 0.982390E-02_JPRB, 0.901185E-02_JPRB, 0.823091E-02_JPRB, 0.754063E-02_JPRB &
  &, 0.688721E-02_JPRB, 0.633189E-02_JPRB, 0.575951E-02_JPRB &
  &, 0.523057E-02_JPRB, 0.480887E-02_JPRB, 0.437446E-02_JPRB, 0.399040E-02_JPRB &
  &, 0.359503E-02_JPRB, 0.325309E-02_JPRB, 0.296700E-02_JPRB/)
XCW( 543, :) = (/ &
  &  0.100737E+01_JPRB, 0.100817E+01_JPRB, 0.100855E+01_JPRB, 0.100851E+01_JPRB &
  &, 0.100805E+01_JPRB, 0.100717E+01_JPRB, 0.100587E+01_JPRB &
  &, 0.100414E+01_JPRB, 0.100200E+01_JPRB, 0.999428E+00_JPRB, 0.996440E+00_JPRB &
  &, 0.993032E+00_JPRB, 0.989204E+00_JPRB, 0.984962E+00_JPRB &
  &, 0.980303E+00_JPRB, 0.975233E+00_JPRB, 0.969752E+00_JPRB, 0.963864E+00_JPRB &
  &, 0.957572E+00_JPRB, 0.950880E+00_JPRB, 0.943791E+00_JPRB &
  &, 0.936315E+00_JPRB, 0.928450E+00_JPRB, 0.920207E+00_JPRB, 0.911593E+00_JPRB &
  &, 0.902609E+00_JPRB, 0.893266E+00_JPRB, 0.883571E+00_JPRB &
  &, 0.873533E+00_JPRB, 0.863160E+00_JPRB, 0.852466E+00_JPRB, 0.841453E+00_JPRB &
  &, 0.830137E+00_JPRB, 0.818531E+00_JPRB, 0.806640E+00_JPRB &
  &, 0.794480E+00_JPRB, 0.782070E+00_JPRB, 0.769412E+00_JPRB, 0.756524E+00_JPRB &
  &, 0.743415E+00_JPRB, 0.730110E+00_JPRB, 0.716628E+00_JPRB &
  &, 0.702955E+00_JPRB, 0.689137E+00_JPRB, 0.675178E+00_JPRB, 0.661095E+00_JPRB &
  &, 0.646905E+00_JPRB, 0.632618E+00_JPRB, 0.618254E+00_JPRB &
  &, 0.603825E+00_JPRB, 0.589354E+00_JPRB, 0.574854E+00_JPRB, 0.560350E+00_JPRB &
  &, 0.545844E+00_JPRB, 0.531361E+00_JPRB, 0.516901E+00_JPRB &
  &, 0.502507E+00_JPRB, 0.488177E+00_JPRB, 0.473924E+00_JPRB, 0.459761E+00_JPRB &
  &, 0.445716E+00_JPRB, 0.431801E+00_JPRB, 0.418011E+00_JPRB &
  &, 0.404371E+00_JPRB, 0.390892E+00_JPRB, 0.377600E+00_JPRB, 0.364485E+00_JPRB &
  &, 0.351550E+00_JPRB, 0.338842E+00_JPRB, 0.326342E+00_JPRB &
  &, 0.314075E+00_JPRB, 0.302020E+00_JPRB, 0.290219E+00_JPRB, 0.278670E+00_JPRB &
  &, 0.267369E+00_JPRB, 0.256334E+00_JPRB, 0.245557E+00_JPRB &
  &, 0.235055E+00_JPRB, 0.224815E+00_JPRB, 0.214851E+00_JPRB, 0.205173E+00_JPRB &
  &, 0.195765E+00_JPRB, 0.186662E+00_JPRB, 0.177819E+00_JPRB &
  &, 0.169266E+00_JPRB, 0.160980E+00_JPRB, 0.152992E+00_JPRB, 0.145275E+00_JPRB &
  &, 0.137828E+00_JPRB, 0.130679E+00_JPRB, 0.123764E+00_JPRB &
  &, 0.117139E+00_JPRB, 0.110767E+00_JPRB, 0.104672E+00_JPRB, 0.988125E-01_JPRB &
  &, 0.932106E-01_JPRB, 0.878541E-01_JPRB, 0.827292E-01_JPRB &
  &, 0.778200E-01_JPRB, 0.731815E-01_JPRB, 0.687237E-01_JPRB, 0.645000E-01_JPRB &
  &, 0.604900E-01_JPRB, 0.566713E-01_JPRB, 0.530590E-01_JPRB &
  &, 0.496280E-01_JPRB, 0.463511E-01_JPRB, 0.432818E-01_JPRB, 0.403920E-01_JPRB &
  &, 0.376514E-01_JPRB, 0.350706E-01_JPRB, 0.326163E-01_JPRB &
  &, 0.303424E-01_JPRB, 0.281690E-01_JPRB, 0.261498E-01_JPRB, 0.242473E-01_JPRB &
  &, 0.224690E-01_JPRB, 0.208228E-01_JPRB, 0.192183E-01_JPRB &
  &, 0.177588E-01_JPRB, 0.164019E-01_JPRB, 0.151537E-01_JPRB, 0.139681E-01_JPRB &
  &, 0.128493E-01_JPRB, 0.118548E-01_JPRB, 0.108825E-01_JPRB &
  &, 0.998931E-02_JPRB, 0.917959E-02_JPRB, 0.840100E-02_JPRB, 0.771308E-02_JPRB &
  &, 0.706205E-02_JPRB, 0.645006E-02_JPRB, 0.587929E-02_JPRB &
  &, 0.535198E-02_JPRB, 0.493191E-02_JPRB, 0.443681E-02_JPRB, 0.405358E-02_JPRB &
  &, 0.372306E-02_JPRB, 0.338281E-02_JPRB, 0.303271E-02_JPRB/)
XCW( 544, :) = (/ &
  &  0.100763E+01_JPRB, 0.100849E+01_JPRB, 0.100893E+01_JPRB, 0.100896E+01_JPRB &
  &, 0.100856E+01_JPRB, 0.100774E+01_JPRB, 0.100650E+01_JPRB &
  &, 0.100484E+01_JPRB, 0.100276E+01_JPRB, 0.100025E+01_JPRB, 0.997324E+00_JPRB &
  &, 0.993977E+00_JPRB, 0.990211E+00_JPRB, 0.986029E+00_JPRB &
  &, 0.981431E+00_JPRB, 0.976419E+00_JPRB, 0.970996E+00_JPRB, 0.965155E+00_JPRB &
  &, 0.958932E+00_JPRB, 0.952295E+00_JPRB, 0.945263E+00_JPRB &
  &, 0.937840E+00_JPRB, 0.930030E+00_JPRB, 0.921841E+00_JPRB, 0.913273E+00_JPRB &
  &, 0.904340E+00_JPRB, 0.895047E+00_JPRB, 0.885399E+00_JPRB &
  &, 0.875410E+00_JPRB, 0.865080E+00_JPRB, 0.854429E+00_JPRB, 0.843457E+00_JPRB &
  &, 0.832182E+00_JPRB, 0.820615E+00_JPRB, 0.808762E+00_JPRB &
  &, 0.796638E+00_JPRB, 0.784254E+00_JPRB, 0.771632E+00_JPRB, 0.758769E+00_JPRB &
  &, 0.745697E+00_JPRB, 0.732418E+00_JPRB, 0.718950E+00_JPRB &
  &, 0.705314E+00_JPRB, 0.691510E+00_JPRB, 0.677575E+00_JPRB, 0.663504E+00_JPRB &
  &, 0.649325E+00_JPRB, 0.635047E+00_JPRB, 0.620691E+00_JPRB &
  &, 0.606282E+00_JPRB, 0.591817E+00_JPRB, 0.577321E+00_JPRB, 0.562806E+00_JPRB &
  &, 0.548301E+00_JPRB, 0.533817E+00_JPRB, 0.519354E+00_JPRB &
  &, 0.504955E+00_JPRB, 0.490603E+00_JPRB, 0.476341E+00_JPRB, 0.462167E+00_JPRB &
  &, 0.448110E+00_JPRB, 0.434145E+00_JPRB, 0.420372E+00_JPRB &
  &, 0.406712E+00_JPRB, 0.393211E+00_JPRB, 0.379875E+00_JPRB, 0.366732E+00_JPRB &
  &, 0.353787E+00_JPRB, 0.341045E+00_JPRB, 0.328511E+00_JPRB &
  &, 0.316205E+00_JPRB, 0.304130E+00_JPRB, 0.292285E+00_JPRB, 0.280711E+00_JPRB &
  &, 0.269361E+00_JPRB, 0.258296E+00_JPRB, 0.247465E+00_JPRB &
  &, 0.236927E+00_JPRB, 0.226651E+00_JPRB, 0.216647E+00_JPRB, 0.206927E+00_JPRB &
  &, 0.197474E+00_JPRB, 0.188298E+00_JPRB, 0.179431E+00_JPRB &
  &, 0.170825E+00_JPRB, 0.162512E+00_JPRB, 0.154467E+00_JPRB, 0.146689E+00_JPRB &
  &, 0.139208E+00_JPRB, 0.131992E+00_JPRB, 0.125070E+00_JPRB &
  &, 0.118374E+00_JPRB, 0.111959E+00_JPRB, 0.105820E+00_JPRB, 0.999144E-01_JPRB &
  &, 0.942639E-01_JPRB, 0.888567E-01_JPRB, 0.837139E-01_JPRB &
  &, 0.787859E-01_JPRB, 0.740912E-01_JPRB, 0.696118E-01_JPRB, 0.653277E-01_JPRB &
  &, 0.612933E-01_JPRB, 0.574102E-01_JPRB, 0.537705E-01_JPRB &
  &, 0.503110E-01_JPRB, 0.470044E-01_JPRB, 0.439041E-01_JPRB, 0.409821E-01_JPRB &
  &, 0.382081E-01_JPRB, 0.355926E-01_JPRB, 0.331464E-01_JPRB &
  &, 0.307911E-01_JPRB, 0.286247E-01_JPRB, 0.265662E-01_JPRB, 0.246700E-01_JPRB &
  &, 0.228505E-01_JPRB, 0.211616E-01_JPRB, 0.195622E-01_JPRB &
  &, 0.181078E-01_JPRB, 0.167055E-01_JPRB, 0.154103E-01_JPRB, 0.142285E-01_JPRB &
  &, 0.131135E-01_JPRB, 0.120692E-01_JPRB, 0.110999E-01_JPRB &
  &, 0.102098E-01_JPRB, 0.934733E-02_JPRB, 0.857109E-02_JPRB, 0.788554E-02_JPRB &
  &, 0.717861E-02_JPRB, 0.656822E-02_JPRB, 0.599907E-02_JPRB &
  &, 0.547339E-02_JPRB, 0.499344E-02_JPRB, 0.456151E-02_JPRB, 0.417994E-02_JPRB &
  &, 0.378708E-02_JPRB, 0.344767E-02_JPRB, 0.309842E-02_JPRB/)
XCW( 545, :) = (/ &
  &  0.100788E+01_JPRB, 0.100881E+01_JPRB, 0.100931E+01_JPRB, 0.100940E+01_JPRB &
  &, 0.100907E+01_JPRB, 0.100831E+01_JPRB, 0.100714E+01_JPRB &
  &, 0.100554E+01_JPRB, 0.100352E+01_JPRB, 0.100107E+01_JPRB, 0.998210E+00_JPRB &
  &, 0.994925E+00_JPRB, 0.991219E+00_JPRB, 0.987097E+00_JPRB &
  &, 0.982559E+00_JPRB, 0.977607E+00_JPRB, 0.972244E+00_JPRB, 0.966471E+00_JPRB &
  &, 0.960294E+00_JPRB, 0.953713E+00_JPRB, 0.946739E+00_JPRB &
  &, 0.939368E+00_JPRB, 0.931611E+00_JPRB, 0.923472E+00_JPRB, 0.914960E+00_JPRB &
  &, 0.906075E+00_JPRB, 0.896832E+00_JPRB, 0.887231E+00_JPRB &
  &, 0.877287E+00_JPRB, 0.867003E+00_JPRB, 0.856396E+00_JPRB, 0.845469E+00_JPRB &
  &, 0.834232E+00_JPRB, 0.822703E+00_JPRB, 0.810890E+00_JPRB &
  &, 0.798796E+00_JPRB, 0.786457E+00_JPRB, 0.773861E+00_JPRB, 0.761035E+00_JPRB &
  &, 0.747989E+00_JPRB, 0.734736E+00_JPRB, 0.721295E+00_JPRB &
  &, 0.707673E+00_JPRB, 0.693894E+00_JPRB, 0.679972E+00_JPRB, 0.665924E+00_JPRB &
  &, 0.651756E+00_JPRB, 0.637488E+00_JPRB, 0.623141E+00_JPRB &
  &, 0.608739E+00_JPRB, 0.594280E+00_JPRB, 0.579788E+00_JPRB, 0.565276E+00_JPRB &
  &, 0.550772E+00_JPRB, 0.536288E+00_JPRB, 0.521822E+00_JPRB &
  &, 0.507404E+00_JPRB, 0.493061E+00_JPRB, 0.478775E+00_JPRB, 0.464591E+00_JPRB &
  &, 0.450520E+00_JPRB, 0.436558E+00_JPRB, 0.422732E+00_JPRB &
  &, 0.409053E+00_JPRB, 0.395529E+00_JPRB, 0.382169E+00_JPRB, 0.369018E+00_JPRB &
  &, 0.356023E+00_JPRB, 0.343249E+00_JPRB, 0.330699E+00_JPRB &
  &, 0.318356E+00_JPRB, 0.306240E+00_JPRB, 0.294373E+00_JPRB, 0.282753E+00_JPRB &
  &, 0.271376E+00_JPRB, 0.260259E+00_JPRB, 0.249396E+00_JPRB &
  &, 0.238800E+00_JPRB, 0.228487E+00_JPRB, 0.218443E+00_JPRB, 0.208681E+00_JPRB &
  &, 0.199184E+00_JPRB, 0.189987E+00_JPRB, 0.181043E+00_JPRB &
  &, 0.172413E+00_JPRB, 0.164045E+00_JPRB, 0.155941E+00_JPRB, 0.148132E+00_JPRB &
  &, 0.140617E+00_JPRB, 0.133336E+00_JPRB, 0.126345E+00_JPRB &
  &, 0.119640E+00_JPRB, 0.113184E+00_JPRB, 0.107001E+00_JPRB, 0.101050E+00_JPRB &
  &, 0.953512E-01_JPRB, 0.899284E-01_JPRB, 0.846987E-01_JPRB &
  &, 0.797518E-01_JPRB, 0.750008E-01_JPRB, 0.704629E-01_JPRB, 0.661931E-01_JPRB &
  &, 0.620966E-01_JPRB, 0.581880E-01_JPRB, 0.545216E-01_JPRB &
  &, 0.509940E-01_JPRB, 0.476985E-01_JPRB, 0.445679E-01_JPRB, 0.415723E-01_JPRB &
  &, 0.387648E-01_JPRB, 0.361146E-01_JPRB, 0.336325E-01_JPRB &
  &, 0.312846E-01_JPRB, 0.290803E-01_JPRB, 0.270288E-01_JPRB, 0.250458E-01_JPRB &
  &, 0.232320E-01_JPRB, 0.215005E-01_JPRB, 0.199061E-01_JPRB &
  &, 0.184070E-01_JPRB, 0.170091E-01_JPRB, 0.157184E-01_JPRB, 0.144889E-01_JPRB &
  &, 0.133248E-01_JPRB, 0.122836E-01_JPRB, 0.113174E-01_JPRB &
  &, 0.103752E-01_JPRB, 0.951506E-02_JPRB, 0.874117E-02_JPRB, 0.800051E-02_JPRB &
  &, 0.735346E-02_JPRB, 0.674547E-02_JPRB, 0.611886E-02_JPRB &
  &, 0.559480E-02_JPRB, 0.511648E-02_JPRB, 0.468621E-02_JPRB, 0.424312E-02_JPRB &
  &, 0.385110E-02_JPRB, 0.351254E-02_JPRB, 0.322985E-02_JPRB/)
XCW( 546, :) = (/ &
  &  0.100813E+01_JPRB, 0.100912E+01_JPRB, 0.100970E+01_JPRB, 0.100985E+01_JPRB &
  &, 0.100958E+01_JPRB, 0.100889E+01_JPRB, 0.100777E+01_JPRB &
  &, 0.100624E+01_JPRB, 0.100427E+01_JPRB, 0.100190E+01_JPRB, 0.999095E+00_JPRB &
  &, 0.995870E+00_JPRB, 0.992229E+00_JPRB, 0.988167E+00_JPRB &
  &, 0.983689E+00_JPRB, 0.978797E+00_JPRB, 0.973491E+00_JPRB, 0.967777E+00_JPRB &
  &, 0.961657E+00_JPRB, 0.955134E+00_JPRB, 0.948214E+00_JPRB &
  &, 0.940900E+00_JPRB, 0.933195E+00_JPRB, 0.925111E+00_JPRB, 0.916648E+00_JPRB &
  &, 0.907814E+00_JPRB, 0.898620E+00_JPRB, 0.889066E+00_JPRB &
  &, 0.879167E+00_JPRB, 0.868930E+00_JPRB, 0.858367E+00_JPRB, 0.847481E+00_JPRB &
  &, 0.836286E+00_JPRB, 0.824795E+00_JPRB, 0.813017E+00_JPRB &
  &, 0.800963E+00_JPRB, 0.788650E+00_JPRB, 0.776091E+00_JPRB, 0.763291E+00_JPRB &
  &, 0.750281E+00_JPRB, 0.737055E+00_JPRB, 0.723639E+00_JPRB &
  &, 0.710043E+00_JPRB, 0.696278E+00_JPRB, 0.682380E+00_JPRB, 0.668345E+00_JPRB &
  &, 0.654188E+00_JPRB, 0.639942E+00_JPRB, 0.625604E+00_JPRB &
  &, 0.611209E+00_JPRB, 0.596756E+00_JPRB, 0.582269E+00_JPRB, 0.567761E+00_JPRB &
  &, 0.553257E+00_JPRB, 0.538758E+00_JPRB, 0.524291E+00_JPRB &
  &, 0.509868E+00_JPRB, 0.495503E+00_JPRB, 0.481225E+00_JPRB, 0.467030E+00_JPRB &
  &, 0.452931E+00_JPRB, 0.438954E+00_JPRB, 0.425111E+00_JPRB &
  &, 0.411412E+00_JPRB, 0.397867E+00_JPRB, 0.384482E+00_JPRB, 0.371284E+00_JPRB &
  &, 0.358280E+00_JPRB, 0.345473E+00_JPRB, 0.332888E+00_JPRB &
  &, 0.320507E+00_JPRB, 0.308372E+00_JPRB, 0.296462E+00_JPRB, 0.284795E+00_JPRB &
  &, 0.273391E+00_JPRB, 0.262222E+00_JPRB, 0.251327E+00_JPRB &
  &, 0.240697E+00_JPRB, 0.230322E+00_JPRB, 0.220239E+00_JPRB, 0.210435E+00_JPRB &
  &, 0.200894E+00_JPRB, 0.191649E+00_JPRB, 0.182683E+00_JPRB &
  &, 0.173972E+00_JPRB, 0.165577E+00_JPRB, 0.157444E+00_JPRB, 0.149575E+00_JPRB &
  &, 0.141997E+00_JPRB, 0.134711E+00_JPRB, 0.127682E+00_JPRB &
  &, 0.120907E+00_JPRB, 0.114409E+00_JPRB, 0.108182E+00_JPRB, 0.102185E+00_JPRB &
  &, 0.964385E-01_JPRB, 0.909655E-01_JPRB, 0.857186E-01_JPRB &
  &, 0.807177E-01_JPRB, 0.759105E-01_JPRB, 0.713509E-01_JPRB, 0.670209E-01_JPRB &
  &, 0.629000E-01_JPRB, 0.589658E-01_JPRB, 0.552331E-01_JPRB &
  &, 0.517172E-01_JPRB, 0.483517E-01_JPRB, 0.451902E-01_JPRB, 0.422045E-01_JPRB &
  &, 0.393643E-01_JPRB, 0.366800E-01_JPRB, 0.341626E-01_JPRB &
  &, 0.317782E-01_JPRB, 0.295360E-01_JPRB, 0.274452E-01_JPRB, 0.254685E-01_JPRB &
  &, 0.236134E-01_JPRB, 0.218877E-01_JPRB, 0.202500E-01_JPRB &
  &, 0.187560E-01_JPRB, 0.173126E-01_JPRB, 0.159750E-01_JPRB, 0.147494E-01_JPRB &
  &, 0.135890E-01_JPRB, 0.124980E-01_JPRB, 0.115348E-01_JPRB &
  &, 0.105958E-01_JPRB, 0.973871E-02_JPRB, 0.891126E-02_JPRB, 0.817297E-02_JPRB &
  &, 0.752830E-02_JPRB, 0.686364E-02_JPRB, 0.629853E-02_JPRB &
  &, 0.571621E-02_JPRB, 0.523953E-02_JPRB, 0.474856E-02_JPRB, 0.436948E-02_JPRB &
  &, 0.397914E-02_JPRB, 0.357740E-02_JPRB, 0.329556E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART78',1,ZHOOK_HANDLE)
END SUBROUTINE PART78

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART79

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART79',0,ZHOOK_HANDLE)

XCW( 547, :) = (/ &
  &  0.100839E+01_JPRB, 0.100944E+01_JPRB, 0.101008E+01_JPRB, 0.101029E+01_JPRB &
  &, 0.101009E+01_JPRB, 0.100946E+01_JPRB, 0.100841E+01_JPRB &
  &, 0.100694E+01_JPRB, 0.100504E+01_JPRB, 0.100272E+01_JPRB, 0.999982E+00_JPRB &
  &, 0.996820E+00_JPRB, 0.993238E+00_JPRB, 0.989238E+00_JPRB &
  &, 0.984820E+00_JPRB, 0.979987E+00_JPRB, 0.974741E+00_JPRB, 0.969085E+00_JPRB &
  &, 0.963023E+00_JPRB, 0.956555E+00_JPRB, 0.949689E+00_JPRB &
  &, 0.942432E+00_JPRB, 0.934782E+00_JPRB, 0.926749E+00_JPRB, 0.918339E+00_JPRB &
  &, 0.909556E+00_JPRB, 0.900408E+00_JPRB, 0.890906E+00_JPRB &
  &, 0.881052E+00_JPRB, 0.870861E+00_JPRB, 0.860338E+00_JPRB, 0.849497E+00_JPRB &
  &, 0.838344E+00_JPRB, 0.826892E+00_JPRB, 0.815154E+00_JPRB &
  &, 0.803140E+00_JPRB, 0.790853E+00_JPRB, 0.778330E+00_JPRB, 0.765567E+00_JPRB &
  &, 0.752573E+00_JPRB, 0.739373E+00_JPRB, 0.725983E+00_JPRB &
  &, 0.712413E+00_JPRB, 0.698673E+00_JPRB, 0.684789E+00_JPRB, 0.670765E+00_JPRB &
  &, 0.656632E+00_JPRB, 0.642396E+00_JPRB, 0.628067E+00_JPRB &
  &, 0.613680E+00_JPRB, 0.599233E+00_JPRB, 0.584750E+00_JPRB, 0.570245E+00_JPRB &
  &, 0.555743E+00_JPRB, 0.541243E+00_JPRB, 0.526774E+00_JPRB &
  &, 0.512347E+00_JPRB, 0.497977E+00_JPRB, 0.483675E+00_JPRB, 0.469470E+00_JPRB &
  &, 0.455358E+00_JPRB, 0.441367E+00_JPRB, 0.427489E+00_JPRB &
  &, 0.413771E+00_JPRB, 0.400204E+00_JPRB, 0.386814E+00_JPRB, 0.373589E+00_JPRB &
  &, 0.360556E+00_JPRB, 0.347717E+00_JPRB, 0.335098E+00_JPRB &
  &, 0.322679E+00_JPRB, 0.310504E+00_JPRB, 0.298550E+00_JPRB, 0.286859E+00_JPRB &
  &, 0.275407E+00_JPRB, 0.264209E+00_JPRB, 0.253282E+00_JPRB &
  &, 0.242594E+00_JPRB, 0.232208E+00_JPRB, 0.222061E+00_JPRB, 0.212215E+00_JPRB &
  &, 0.202629E+00_JPRB, 0.193338E+00_JPRB, 0.184322E+00_JPRB &
  &, 0.175587E+00_JPRB, 0.167137E+00_JPRB, 0.158948E+00_JPRB, 0.151047E+00_JPRB &
  &, 0.143437E+00_JPRB, 0.136085E+00_JPRB, 0.128989E+00_JPRB &
  &, 0.122205E+00_JPRB, 0.115634E+00_JPRB, 0.109364E+00_JPRB, 0.103320E+00_JPRB &
  &, 0.975598E-01_JPRB, 0.920372E-01_JPRB, 0.867385E-01_JPRB &
  &, 0.816836E-01_JPRB, 0.768565E-01_JPRB, 0.722760E-01_JPRB, 0.678863E-01_JPRB &
  &, 0.637033E-01_JPRB, 0.597436E-01_JPRB, 0.559842E-01_JPRB &
  &, 0.524403E-01_JPRB, 0.490458E-01_JPRB, 0.458540E-01_JPRB, 0.427947E-01_JPRB &
  &, 0.399210E-01_JPRB, 0.372455E-01_JPRB, 0.346928E-01_JPRB &
  &, 0.322718E-01_JPRB, 0.300372E-01_JPRB, 0.279079E-01_JPRB, 0.258913E-01_JPRB &
  &, 0.239949E-01_JPRB, 0.222749E-01_JPRB, 0.205939E-01_JPRB &
  &, 0.190551E-01_JPRB, 0.176162E-01_JPRB, 0.162830E-01_JPRB, 0.150098E-01_JPRB &
  &, 0.138532E-01_JPRB, 0.127660E-01_JPRB, 0.117523E-01_JPRB &
  &, 0.108163E-01_JPRB, 0.990645E-02_JPRB, 0.913804E-02_JPRB, 0.834543E-02_JPRB &
  &, 0.764487E-02_JPRB, 0.698181E-02_JPRB, 0.641831E-02_JPRB &
  &, 0.583762E-02_JPRB, 0.536258E-02_JPRB, 0.487326E-02_JPRB, 0.443266E-02_JPRB &
  &, 0.404316E-02_JPRB, 0.370712E-02_JPRB, 0.336127E-02_JPRB/)
XCW( 548, :) = (/ &
  &  0.100864E+01_JPRB, 0.100976E+01_JPRB, 0.101046E+01_JPRB, 0.101074E+01_JPRB &
  &, 0.101060E+01_JPRB, 0.101003E+01_JPRB, 0.100905E+01_JPRB &
  &, 0.100764E+01_JPRB, 0.100580E+01_JPRB, 0.100355E+01_JPRB, 0.100087E+01_JPRB &
  &, 0.997769E+00_JPRB, 0.994249E+00_JPRB, 0.990310E+00_JPRB &
  &, 0.985952E+00_JPRB, 0.981178E+00_JPRB, 0.975993E+00_JPRB, 0.970394E+00_JPRB &
  &, 0.964390E+00_JPRB, 0.957980E+00_JPRB, 0.951171E+00_JPRB &
  &, 0.943967E+00_JPRB, 0.936369E+00_JPRB, 0.928390E+00_JPRB, 0.920005E+00_JPRB &
  &, 0.911298E+00_JPRB, 0.902203E+00_JPRB, 0.892749E+00_JPRB &
  &, 0.882941E+00_JPRB, 0.872797E+00_JPRB, 0.862318E+00_JPRB, 0.851518E+00_JPRB &
  &, 0.840407E+00_JPRB, 0.828994E+00_JPRB, 0.817294E+00_JPRB &
  &, 0.805316E+00_JPRB, 0.793066E+00_JPRB, 0.780569E+00_JPRB, 0.767832E+00_JPRB &
  &, 0.754876E+00_JPRB, 0.741702E+00_JPRB, 0.728338E+00_JPRB &
  &, 0.714794E+00_JPRB, 0.701079E+00_JPRB, 0.687209E+00_JPRB, 0.673210E+00_JPRB &
  &, 0.659087E+00_JPRB, 0.644862E+00_JPRB, 0.630542E+00_JPRB &
  &, 0.616163E+00_JPRB, 0.601722E+00_JPRB, 0.587245E+00_JPRB, 0.572743E+00_JPRB &
  &, 0.558228E+00_JPRB, 0.543729E+00_JPRB, 0.529257E+00_JPRB &
  &, 0.514827E+00_JPRB, 0.500451E+00_JPRB, 0.486141E+00_JPRB, 0.471910E+00_JPRB &
  &, 0.457785E+00_JPRB, 0.443780E+00_JPRB, 0.429903E+00_JPRB &
  &, 0.416148E+00_JPRB, 0.402559E+00_JPRB, 0.389145E+00_JPRB, 0.375895E+00_JPRB &
  &, 0.362832E+00_JPRB, 0.349961E+00_JPRB, 0.337307E+00_JPRB &
  &, 0.324872E+00_JPRB, 0.312657E+00_JPRB, 0.300682E+00_JPRB, 0.288924E+00_JPRB &
  &, 0.277445E+00_JPRB, 0.266218E+00_JPRB, 0.255237E+00_JPRB &
  &, 0.244516E+00_JPRB, 0.234068E+00_JPRB, 0.223908E+00_JPRB, 0.213995E+00_JPRB &
  &, 0.204391E+00_JPRB, 0.195027E+00_JPRB, 0.185989E+00_JPRB &
  &, 0.177202E+00_JPRB, 0.168698E+00_JPRB, 0.160480E+00_JPRB, 0.152519E+00_JPRB &
  &, 0.144846E+00_JPRB, 0.137460E+00_JPRB, 0.130326E+00_JPRB &
  &, 0.123472E+00_JPRB, 0.116891E+00_JPRB, 0.110578E+00_JPRB, 0.104489E+00_JPRB &
  &, 0.986810E-01_JPRB, 0.931089E-01_JPRB, 0.877584E-01_JPRB &
  &, 0.826853E-01_JPRB, 0.778025E-01_JPRB, 0.731640E-01_JPRB, 0.687517E-01_JPRB &
  &, 0.645449E-01_JPRB, 0.605602E-01_JPRB, 0.567353E-01_JPRB &
  &, 0.531233E-01_JPRB, 0.497399E-01_JPRB, 0.464763E-01_JPRB, 0.434270E-01_JPRB &
  &, 0.405205E-01_JPRB, 0.378110E-01_JPRB, 0.352230E-01_JPRB &
  &, 0.327654E-01_JPRB, 0.304928E-01_JPRB, 0.283243E-01_JPRB, 0.263140E-01_JPRB &
  &, 0.244241E-01_JPRB, 0.226137E-01_JPRB, 0.209869E-01_JPRB &
  &, 0.194041E-01_JPRB, 0.179197E-01_JPRB, 0.165910E-01_JPRB, 0.153223E-01_JPRB &
  &, 0.141174E-01_JPRB, 0.129804E-01_JPRB, 0.119697E-01_JPRB &
  &, 0.110369E-01_JPRB, 0.101301E-01_JPRB, 0.930813E-02_JPRB, 0.851788E-02_JPRB &
  &, 0.781971E-02_JPRB, 0.715906E-02_JPRB, 0.653809E-02_JPRB &
  &, 0.601973E-02_JPRB, 0.548563E-02_JPRB, 0.499795E-02_JPRB, 0.455903E-02_JPRB &
  &, 0.417119E-02_JPRB, 0.377198E-02_JPRB, 0.342698E-02_JPRB/)
XCW( 549, :) = (/ &
  &  0.100889E+01_JPRB, 0.101008E+01_JPRB, 0.101084E+01_JPRB, 0.101118E+01_JPRB &
  &, 0.101111E+01_JPRB, 0.101061E+01_JPRB, 0.100968E+01_JPRB &
  &, 0.100834E+01_JPRB, 0.100657E+01_JPRB, 0.100437E+01_JPRB, 0.100176E+01_JPRB &
  &, 0.998720E+00_JPRB, 0.995261E+00_JPRB, 0.991383E+00_JPRB &
  &, 0.987085E+00_JPRB, 0.982372E+00_JPRB, 0.977244E+00_JPRB, 0.971705E+00_JPRB &
  &, 0.965757E+00_JPRB, 0.959404E+00_JPRB, 0.952653E+00_JPRB &
  &, 0.945502E+00_JPRB, 0.937960E+00_JPRB, 0.930035E+00_JPRB, 0.921728E+00_JPRB &
  &, 0.913048E+00_JPRB, 0.903999E+00_JPRB, 0.894592E+00_JPRB &
  &, 0.884833E+00_JPRB, 0.874732E+00_JPRB, 0.864301E+00_JPRB, 0.853543E+00_JPRB &
  &, 0.842474E+00_JPRB, 0.831100E+00_JPRB, 0.819435E+00_JPRB &
  &, 0.807493E+00_JPRB, 0.795278E+00_JPRB, 0.782818E+00_JPRB, 0.770118E+00_JPRB &
  &, 0.757188E+00_JPRB, 0.744041E+00_JPRB, 0.730704E+00_JPRB &
  &, 0.717175E+00_JPRB, 0.703475E+00_JPRB, 0.689629E+00_JPRB, 0.675654E+00_JPRB &
  &, 0.661544E+00_JPRB, 0.647329E+00_JPRB, 0.633031E+00_JPRB &
  &, 0.618647E+00_JPRB, 0.604226E+00_JPRB, 0.589740E+00_JPRB, 0.575241E+00_JPRB &
  &, 0.560743E+00_JPRB, 0.546229E+00_JPRB, 0.531756E+00_JPRB &
  &, 0.517322E+00_JPRB, 0.502924E+00_JPRB, 0.488607E+00_JPRB, 0.474366E+00_JPRB &
  &, 0.460230E+00_JPRB, 0.446210E+00_JPRB, 0.432300E+00_JPRB &
  &, 0.418544E+00_JPRB, 0.404934E+00_JPRB, 0.391477E+00_JPRB, 0.378200E+00_JPRB &
  &, 0.365108E+00_JPRB, 0.352226E+00_JPRB, 0.339538E+00_JPRB &
  &, 0.327066E+00_JPRB, 0.314810E+00_JPRB, 0.302793E+00_JPRB, 0.291033E+00_JPRB &
  &, 0.279483E+00_JPRB, 0.268228E+00_JPRB, 0.257192E+00_JPRB &
  &, 0.246437E+00_JPRB, 0.235954E+00_JPRB, 0.225755E+00_JPRB, 0.215801E+00_JPRB &
  &, 0.206127E+00_JPRB, 0.196743E+00_JPRB, 0.187656E+00_JPRB &
  &, 0.178817E+00_JPRB, 0.170259E+00_JPRB, 0.162012E+00_JPRB, 0.154021E+00_JPRB &
  &, 0.146286E+00_JPRB, 0.138865E+00_JPRB, 0.131695E+00_JPRB &
  &, 0.124770E+00_JPRB, 0.118148E+00_JPRB, 0.111792E+00_JPRB, 0.105658E+00_JPRB &
  &, 0.998023E-01_JPRB, 0.941805E-01_JPRB, 0.888135E-01_JPRB &
  &, 0.836870E-01_JPRB, 0.787849E-01_JPRB, 0.740891E-01_JPRB, 0.696170E-01_JPRB &
  &, 0.653865E-01_JPRB, 0.613380E-01_JPRB, 0.575258E-01_JPRB &
  &, 0.538867E-01_JPRB, 0.504340E-01_JPRB, 0.471401E-01_JPRB, 0.440592E-01_JPRB &
  &, 0.411200E-01_JPRB, 0.383765E-01_JPRB, 0.357532E-01_JPRB &
  &, 0.333038E-01_JPRB, 0.309940E-01_JPRB, 0.287869E-01_JPRB, 0.267367E-01_JPRB &
  &, 0.248055E-01_JPRB, 0.230009E-01_JPRB, 0.213307E-01_JPRB &
  &, 0.197531E-01_JPRB, 0.182739E-01_JPRB, 0.168477E-01_JPRB, 0.155827E-01_JPRB &
  &, 0.143815E-01_JPRB, 0.132483E-01_JPRB, 0.121872E-01_JPRB &
  &, 0.112023E-01_JPRB, 0.102978E-01_JPRB, 0.947822E-02_JPRB, 0.869034E-02_JPRB &
  &, 0.799455E-02_JPRB, 0.733630E-02_JPRB, 0.671776E-02_JPRB &
  &, 0.614114E-02_JPRB, 0.560868E-02_JPRB, 0.512265E-02_JPRB, 0.468539E-02_JPRB &
  &, 0.423521E-02_JPRB, 0.383684E-02_JPRB, 0.349269E-02_JPRB/)
XCW( 550, :) = (/ &
  &  0.100915E+01_JPRB, 0.101040E+01_JPRB, 0.101122E+01_JPRB, 0.101163E+01_JPRB &
  &, 0.101162E+01_JPRB, 0.101118E+01_JPRB, 0.101032E+01_JPRB &
  &, 0.100904E+01_JPRB, 0.100733E+01_JPRB, 0.100520E+01_JPRB, 0.100265E+01_JPRB &
  &, 0.999672E+00_JPRB, 0.996275E+00_JPRB, 0.992456E+00_JPRB &
  &, 0.988220E+00_JPRB, 0.983567E+00_JPRB, 0.978498E+00_JPRB, 0.973017E+00_JPRB &
  &, 0.967128E+00_JPRB, 0.960832E+00_JPRB, 0.954135E+00_JPRB &
  &, 0.947040E+00_JPRB, 0.939554E+00_JPRB, 0.931680E+00_JPRB, 0.923426E+00_JPRB &
  &, 0.914794E+00_JPRB, 0.905798E+00_JPRB, 0.896439E+00_JPRB &
  &, 0.886729E+00_JPRB, 0.876675E+00_JPRB, 0.866285E+00_JPRB, 0.855572E+00_JPRB &
  &, 0.844541E+00_JPRB, 0.833210E+00_JPRB, 0.821585E+00_JPRB &
  &, 0.809678E+00_JPRB, 0.797500E+00_JPRB, 0.785077E+00_JPRB, 0.772404E+00_JPRB &
  &, 0.759501E+00_JPRB, 0.746381E+00_JPRB, 0.733070E+00_JPRB &
  &, 0.719567E+00_JPRB, 0.705892E+00_JPRB, 0.692061E+00_JPRB, 0.678098E+00_JPRB &
  &, 0.664012E+00_JPRB, 0.649808E+00_JPRB, 0.635519E+00_JPRB &
  &, 0.621156E+00_JPRB, 0.606729E+00_JPRB, 0.592262E+00_JPRB, 0.577754E+00_JPRB &
  &, 0.563258E+00_JPRB, 0.548744E+00_JPRB, 0.534269E+00_JPRB &
  &, 0.519817E+00_JPRB, 0.505414E+00_JPRB, 0.491089E+00_JPRB, 0.476839E+00_JPRB &
  &, 0.462691E+00_JPRB, 0.448640E+00_JPRB, 0.434731E+00_JPRB &
  &, 0.420939E+00_JPRB, 0.407308E+00_JPRB, 0.393828E+00_JPRB, 0.380524E+00_JPRB &
  &, 0.367404E+00_JPRB, 0.354490E+00_JPRB, 0.341768E+00_JPRB &
  &, 0.329259E+00_JPRB, 0.316985E+00_JPRB, 0.304925E+00_JPRB, 0.293120E+00_JPRB &
  &, 0.281567E+00_JPRB, 0.270237E+00_JPRB, 0.259195E+00_JPRB &
  &, 0.248383E+00_JPRB, 0.237864E+00_JPRB, 0.227601E+00_JPRB, 0.217607E+00_JPRB &
  &, 0.207916E+00_JPRB, 0.198486E+00_JPRB, 0.189323E+00_JPRB &
  &, 0.180460E+00_JPRB, 0.171848E+00_JPRB, 0.163544E+00_JPRB, 0.155494E+00_JPRB &
  &, 0.147756E+00_JPRB, 0.140270E+00_JPRB, 0.133032E+00_JPRB &
  &, 0.126100E+00_JPRB, 0.119405E+00_JPRB, 0.113005E+00_JPRB, 0.106826E+00_JPRB &
  &, 0.100924E+00_JPRB, 0.952868E-01_JPRB, 0.898686E-01_JPRB &
  &, 0.846887E-01_JPRB, 0.797309E-01_JPRB, 0.750142E-01_JPRB, 0.705201E-01_JPRB &
  &, 0.662281E-01_JPRB, 0.621547E-01_JPRB, 0.582769E-01_JPRB &
  &, 0.546099E-01_JPRB, 0.511281E-01_JPRB, 0.478040E-01_JPRB, 0.446915E-01_JPRB &
  &, 0.417195E-01_JPRB, 0.389420E-01_JPRB, 0.362834E-01_JPRB &
  &, 0.337974E-01_JPRB, 0.314497E-01_JPRB, 0.292496E-01_JPRB, 0.272065E-01_JPRB &
  &, 0.252347E-01_JPRB, 0.233881E-01_JPRB, 0.216746E-01_JPRB &
  &, 0.201021E-01_JPRB, 0.185774E-01_JPRB, 0.171557E-01_JPRB, 0.158431E-01_JPRB &
  &, 0.146457E-01_JPRB, 0.135163E-01_JPRB, 0.124590E-01_JPRB &
  &, 0.114228E-01_JPRB, 0.105215E-01_JPRB, 0.964831E-02_JPRB, 0.886280E-02_JPRB &
  &, 0.816940E-02_JPRB, 0.745447E-02_JPRB, 0.683754E-02_JPRB &
  &, 0.626255E-02_JPRB, 0.573172E-02_JPRB, 0.524735E-02_JPRB, 0.474857E-02_JPRB &
  &, 0.436325E-02_JPRB, 0.396657E-02_JPRB, 0.362411E-02_JPRB/)
XCW( 551, :) = (/ &
  &  0.100940E+01_JPRB, 0.101072E+01_JPRB, 0.101161E+01_JPRB, 0.101208E+01_JPRB &
  &, 0.101213E+01_JPRB, 0.101175E+01_JPRB, 0.101096E+01_JPRB &
  &, 0.100974E+01_JPRB, 0.100809E+01_JPRB, 0.100603E+01_JPRB, 0.100354E+01_JPRB &
  &, 0.100062E+01_JPRB, 0.997288E+00_JPRB, 0.993532E+00_JPRB &
  &, 0.989355E+00_JPRB, 0.984762E+00_JPRB, 0.979754E+00_JPRB, 0.974331E+00_JPRB &
  &, 0.968500E+00_JPRB, 0.962262E+00_JPRB, 0.955620E+00_JPRB &
  &, 0.948582E+00_JPRB, 0.941151E+00_JPRB, 0.933328E+00_JPRB, 0.925127E+00_JPRB &
  &, 0.916547E+00_JPRB, 0.907601E+00_JPRB, 0.898290E+00_JPRB &
  &, 0.888626E+00_JPRB, 0.878619E+00_JPRB, 0.868272E+00_JPRB, 0.857605E+00_JPRB &
  &, 0.846617E+00_JPRB, 0.835325E+00_JPRB, 0.823731E+00_JPRB &
  &, 0.811864E+00_JPRB, 0.799722E+00_JPRB, 0.787326E+00_JPRB, 0.774690E+00_JPRB &
  &, 0.761814E+00_JPRB, 0.748731E+00_JPRB, 0.735436E+00_JPRB &
  &, 0.721959E+00_JPRB, 0.708310E+00_JPRB, 0.694504E+00_JPRB, 0.680555E+00_JPRB &
  &, 0.666480E+00_JPRB, 0.652299E+00_JPRB, 0.638020E+00_JPRB &
  &, 0.623653E+00_JPRB, 0.609232E+00_JPRB, 0.594771E+00_JPRB, 0.580280E+00_JPRB &
  &, 0.565772E+00_JPRB, 0.551274E+00_JPRB, 0.536783E+00_JPRB &
  &, 0.522328E+00_JPRB, 0.507920E+00_JPRB, 0.493588E+00_JPRB, 0.479329E+00_JPRB &
  &, 0.465153E+00_JPRB, 0.451088E+00_JPRB, 0.437163E+00_JPRB &
  &, 0.423353E+00_JPRB, 0.409701E+00_JPRB, 0.396198E+00_JPRB, 0.382868E+00_JPRB &
  &, 0.369719E+00_JPRB, 0.356775E+00_JPRB, 0.344019E+00_JPRB &
  &, 0.331494E+00_JPRB, 0.319160E+00_JPRB, 0.307079E+00_JPRB, 0.295229E+00_JPRB &
  &, 0.283628E+00_JPRB, 0.272270E+00_JPRB, 0.261174E+00_JPRB &
  &, 0.250353E+00_JPRB, 0.239774E+00_JPRB, 0.229474E+00_JPRB, 0.219438E+00_JPRB &
  &, 0.209678E+00_JPRB, 0.200201E+00_JPRB, 0.191017E+00_JPRB &
  &, 0.182103E+00_JPRB, 0.173465E+00_JPRB, 0.165105E+00_JPRB, 0.157025E+00_JPRB &
  &, 0.149195E+00_JPRB, 0.141675E+00_JPRB, 0.134432E+00_JPRB &
  &, 0.127430E+00_JPRB, 0.120695E+00_JPRB, 0.114252E+00_JPRB, 0.108028E+00_JPRB &
  &, 0.102079E+00_JPRB, 0.963931E-01_JPRB, 0.909237E-01_JPRB &
  &, 0.856904E-01_JPRB, 0.807134E-01_JPRB, 0.759392E-01_JPRB, 0.714231E-01_JPRB &
  &, 0.671080E-01_JPRB, 0.629714E-01_JPRB, 0.590675E-01_JPRB &
  &, 0.553732E-01_JPRB, 0.518222E-01_JPRB, 0.485092E-01_JPRB, 0.453238E-01_JPRB &
  &, 0.423619E-01_JPRB, 0.395075E-01_JPRB, 0.368577E-01_JPRB &
  &, 0.343358E-01_JPRB, 0.319509E-01_JPRB, 0.297122E-01_JPRB, 0.276292E-01_JPRB &
  &, 0.256638E-01_JPRB, 0.238238E-01_JPRB, 0.220676E-01_JPRB &
  &, 0.204511E-01_JPRB, 0.189316E-01_JPRB, 0.174637E-01_JPRB, 0.161556E-01_JPRB &
  &, 0.149099E-01_JPRB, 0.137307E-01_JPRB, 0.126764E-01_JPRB &
  &, 0.116433E-01_JPRB, 0.107451E-01_JPRB, 0.987509E-02_JPRB, 0.903525E-02_JPRB &
  &, 0.828596E-02_JPRB, 0.763172E-02_JPRB, 0.695733E-02_JPRB &
  &, 0.638396E-02_JPRB, 0.585477E-02_JPRB, 0.530970E-02_JPRB, 0.487493E-02_JPRB &
  &, 0.442727E-02_JPRB, 0.403143E-02_JPRB, 0.368982E-02_JPRB/)
XCW( 552, :) = (/ &
  &  0.100966E+01_JPRB, 0.101104E+01_JPRB, 0.101199E+01_JPRB, 0.101252E+01_JPRB &
  &, 0.101264E+01_JPRB, 0.101233E+01_JPRB, 0.101160E+01_JPRB &
  &, 0.101044E+01_JPRB, 0.100886E+01_JPRB, 0.100686E+01_JPRB, 0.100443E+01_JPRB &
  &, 0.100158E+01_JPRB, 0.998303E+00_JPRB, 0.994607E+00_JPRB &
  &, 0.990492E+00_JPRB, 0.985960E+00_JPRB, 0.981010E+00_JPRB, 0.975648E+00_JPRB &
  &, 0.969874E+00_JPRB, 0.963693E+00_JPRB, 0.957108E+00_JPRB &
  &, 0.950124E+00_JPRB, 0.942749E+00_JPRB, 0.934981E+00_JPRB, 0.926829E+00_JPRB &
  &, 0.918304E+00_JPRB, 0.909404E+00_JPRB, 0.900144E+00_JPRB &
  &, 0.890530E+00_JPRB, 0.880566E+00_JPRB, 0.870268E+00_JPRB, 0.859638E+00_JPRB &
  &, 0.848697E+00_JPRB, 0.837444E+00_JPRB, 0.825895E+00_JPRB &
  &, 0.814059E+00_JPRB, 0.801954E+00_JPRB, 0.789594E+00_JPRB, 0.776986E+00_JPRB &
  &, 0.764147E+00_JPRB, 0.751081E+00_JPRB, 0.737824E+00_JPRB &
  &, 0.724362E+00_JPRB, 0.710740E+00_JPRB, 0.696947E+00_JPRB, 0.683023E+00_JPRB &
  &, 0.668960E+00_JPRB, 0.654791E+00_JPRB, 0.640522E+00_JPRB &
  &, 0.626176E+00_JPRB, 0.611763E+00_JPRB, 0.597307E+00_JPRB, 0.582806E+00_JPRB &
  &, 0.568301E+00_JPRB, 0.553804E+00_JPRB, 0.539312E+00_JPRB &
  &, 0.524854E+00_JPRB, 0.510441E+00_JPRB, 0.496086E+00_JPRB, 0.481818E+00_JPRB &
  &, 0.467631E+00_JPRB, 0.453553E+00_JPRB, 0.439595E+00_JPRB &
  &, 0.425766E+00_JPRB, 0.412094E+00_JPRB, 0.398567E+00_JPRB, 0.385212E+00_JPRB &
  &, 0.372055E+00_JPRB, 0.359059E+00_JPRB, 0.346290E+00_JPRB &
  &, 0.333708E+00_JPRB, 0.321356E+00_JPRB, 0.309255E+00_JPRB, 0.297361E+00_JPRB &
  &, 0.285712E+00_JPRB, 0.274327E+00_JPRB, 0.263176E+00_JPRB &
  &, 0.252299E+00_JPRB, 0.241709E+00_JPRB, 0.231346E+00_JPRB, 0.221270E+00_JPRB &
  &, 0.211493E+00_JPRB, 0.201971E+00_JPRB, 0.192711E+00_JPRB &
  &, 0.183746E+00_JPRB, 0.175082E+00_JPRB, 0.166666E+00_JPRB, 0.158527E+00_JPRB &
  &, 0.150695E+00_JPRB, 0.143110E+00_JPRB, 0.135800E+00_JPRB &
  &, 0.128760E+00_JPRB, 0.121984E+00_JPRB, 0.115499E+00_JPRB, 0.109230E+00_JPRB &
  &, 0.103234E+00_JPRB, 0.974993E-01_JPRB, 0.919788E-01_JPRB &
  &, 0.867279E-01_JPRB, 0.816958E-01_JPRB, 0.769013E-01_JPRB, 0.723261E-01_JPRB &
  &, 0.679495E-01_JPRB, 0.638269E-01_JPRB, 0.598581E-01_JPRB &
  &, 0.561366E-01_JPRB, 0.525571E-01_JPRB, 0.491730E-01_JPRB, 0.459983E-01_JPRB &
  &, 0.429614E-01_JPRB, 0.401165E-01_JPRB, 0.374321E-01_JPRB &
  &, 0.348743E-01_JPRB, 0.324521E-01_JPRB, 0.302211E-01_JPRB, 0.280989E-01_JPRB &
  &, 0.260930E-01_JPRB, 0.242110E-01_JPRB, 0.224606E-01_JPRB &
  &, 0.208001E-01_JPRB, 0.192351E-01_JPRB, 0.178231E-01_JPRB, 0.164681E-01_JPRB &
  &, 0.151741E-01_JPRB, 0.139987E-01_JPRB, 0.128939E-01_JPRB &
  &, 0.119190E-01_JPRB, 0.109688E-01_JPRB, 0.100452E-01_JPRB, 0.926520E-02_JPRB &
  &, 0.846081E-02_JPRB, 0.780897E-02_JPRB, 0.713700E-02_JPRB &
  &, 0.650536E-02_JPRB, 0.597782E-02_JPRB, 0.543440E-02_JPRB, 0.500129E-02_JPRB &
  &, 0.455530E-02_JPRB, 0.416115E-02_JPRB, 0.375553E-02_JPRB/)
XCW( 553, :) = (/ &
  &  0.100991E+01_JPRB, 0.101135E+01_JPRB, 0.101237E+01_JPRB, 0.101297E+01_JPRB &
  &, 0.101315E+01_JPRB, 0.101290E+01_JPRB, 0.101223E+01_JPRB &
  &, 0.101114E+01_JPRB, 0.100963E+01_JPRB, 0.100769E+01_JPRB, 0.100532E+01_JPRB &
  &, 0.100253E+01_JPRB, 0.999318E+00_JPRB, 0.995685E+00_JPRB &
  &, 0.991632E+00_JPRB, 0.987158E+00_JPRB, 0.982245E+00_JPRB, 0.976965E+00_JPRB &
  &, 0.971249E+00_JPRB, 0.965124E+00_JPRB, 0.958596E+00_JPRB &
  &, 0.951669E+00_JPRB, 0.944346E+00_JPRB, 0.936632E+00_JPRB, 0.928538E+00_JPRB &
  &, 0.920061E+00_JPRB, 0.911215E+00_JPRB, 0.902003E+00_JPRB &
  &, 0.892434E+00_JPRB, 0.882518E+00_JPRB, 0.872264E+00_JPRB, 0.861680E+00_JPRB &
  &, 0.850777E+00_JPRB, 0.839568E+00_JPRB, 0.828058E+00_JPRB &
  &, 0.816264E+00_JPRB, 0.804195E+00_JPRB, 0.791863E+00_JPRB, 0.779281E+00_JPRB &
  &, 0.766470E+00_JPRB, 0.753441E+00_JPRB, 0.740200E+00_JPRB &
  &, 0.726776E+00_JPRB, 0.713169E+00_JPRB, 0.699402E+00_JPRB, 0.685491E+00_JPRB &
  &, 0.671441E+00_JPRB, 0.657282E+00_JPRB, 0.643036E+00_JPRB &
  &, 0.628698E+00_JPRB, 0.614293E+00_JPRB, 0.599816E+00_JPRB, 0.585347E+00_JPRB &
  &, 0.570844E+00_JPRB, 0.556333E+00_JPRB, 0.541841E+00_JPRB &
  &, 0.527380E+00_JPRB, 0.512962E+00_JPRB, 0.498601E+00_JPRB, 0.484308E+00_JPRB &
  &, 0.470110E+00_JPRB, 0.456018E+00_JPRB, 0.442045E+00_JPRB &
  &, 0.428198E+00_JPRB, 0.414505E+00_JPRB, 0.400956E+00_JPRB, 0.387576E+00_JPRB &
  &, 0.374370E+00_JPRB, 0.361364E+00_JPRB, 0.348562E+00_JPRB &
  &, 0.335965E+00_JPRB, 0.323574E+00_JPRB, 0.311410E+00_JPRB, 0.299492E+00_JPRB &
  &, 0.287818E+00_JPRB, 0.276383E+00_JPRB, 0.265203E+00_JPRB &
  &, 0.254293E+00_JPRB, 0.243644E+00_JPRB, 0.233243E+00_JPRB, 0.223127E+00_JPRB &
  &, 0.213281E+00_JPRB, 0.203740E+00_JPRB, 0.194433E+00_JPRB &
  &, 0.185417E+00_JPRB, 0.176700E+00_JPRB, 0.168256E+00_JPRB, 0.160058E+00_JPRB &
  &, 0.152165E+00_JPRB, 0.144546E+00_JPRB, 0.137200E+00_JPRB &
  &, 0.130121E+00_JPRB, 0.123306E+00_JPRB, 0.116746E+00_JPRB, 0.110466E+00_JPRB &
  &, 0.104423E+00_JPRB, 0.986056E-01_JPRB, 0.930691E-01_JPRB &
  &, 0.877653E-01_JPRB, 0.827146E-01_JPRB, 0.778634E-01_JPRB, 0.732291E-01_JPRB &
  &, 0.688294E-01_JPRB, 0.646436E-01_JPRB, 0.606882E-01_JPRB &
  &, 0.568999E-01_JPRB, 0.532921E-01_JPRB, 0.498783E-01_JPRB, 0.466727E-01_JPRB &
  &, 0.436038E-01_JPRB, 0.407255E-01_JPRB, 0.379623E-01_JPRB &
  &, 0.354127E-01_JPRB, 0.329533E-01_JPRB, 0.306838E-01_JPRB, 0.285217E-01_JPRB &
  &, 0.265221E-01_JPRB, 0.245982E-01_JPRB, 0.228045E-01_JPRB &
  &, 0.211491E-01_JPRB, 0.195893E-01_JPRB, 0.181311E-01_JPRB, 0.167285E-01_JPRB &
  &, 0.154911E-01_JPRB, 0.142667E-01_JPRB, 0.131657E-01_JPRB &
  &, 0.121395E-01_JPRB, 0.111365E-01_JPRB, 0.102720E-01_JPRB, 0.943765E-02_JPRB &
  &, 0.863565E-02_JPRB, 0.792713E-02_JPRB, 0.725678E-02_JPRB &
  &, 0.668748E-02_JPRB, 0.610087E-02_JPRB, 0.555910E-02_JPRB, 0.506447E-02_JPRB &
  &, 0.461932E-02_JPRB, 0.422601E-02_JPRB, 0.388696E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART79',1,ZHOOK_HANDLE)
END SUBROUTINE PART79

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART80

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART80',0,ZHOOK_HANDLE)

XCW( 554, :) = (/ &
  &  0.101017E+01_JPRB, 0.101167E+01_JPRB, 0.101275E+01_JPRB, 0.101342E+01_JPRB &
  &, 0.101366E+01_JPRB, 0.101348E+01_JPRB, 0.101287E+01_JPRB &
  &, 0.101185E+01_JPRB, 0.101039E+01_JPRB, 0.100851E+01_JPRB, 0.100621E+01_JPRB &
  &, 0.100349E+01_JPRB, 0.100034E+01_JPRB, 0.996763E+00_JPRB &
  &, 0.992771E+00_JPRB, 0.988358E+00_JPRB, 0.983528E+00_JPRB, 0.978283E+00_JPRB &
  &, 0.972627E+00_JPRB, 0.966561E+00_JPRB, 0.960088E+00_JPRB &
  &, 0.953217E+00_JPRB, 0.945950E+00_JPRB, 0.938291E+00_JPRB, 0.930246E+00_JPRB &
  &, 0.921821E+00_JPRB, 0.913025E+00_JPRB, 0.903861E+00_JPRB &
  &, 0.894342E+00_JPRB, 0.884473E+00_JPRB, 0.874264E+00_JPRB, 0.863726E+00_JPRB &
  &, 0.852866E+00_JPRB, 0.841691E+00_JPRB, 0.830222E+00_JPRB &
  &, 0.818468E+00_JPRB, 0.806427E+00_JPRB, 0.794131E+00_JPRB, 0.781587E+00_JPRB &
  &, 0.768814E+00_JPRB, 0.755802E+00_JPRB, 0.742599E+00_JPRB &
  &, 0.729191E+00_JPRB, 0.715609E+00_JPRB, 0.701857E+00_JPRB, 0.687971E+00_JPRB &
  &, 0.673934E+00_JPRB, 0.659799E+00_JPRB, 0.645550E+00_JPRB &
  &, 0.631221E+00_JPRB, 0.616823E+00_JPRB, 0.602379E+00_JPRB, 0.587902E+00_JPRB &
  &, 0.573388E+00_JPRB, 0.558878E+00_JPRB, 0.544385E+00_JPRB &
  &, 0.529921E+00_JPRB, 0.515484E+00_JPRB, 0.501116E+00_JPRB, 0.486830E+00_JPRB &
  &, 0.472622E+00_JPRB, 0.458501E+00_JPRB, 0.444512E+00_JPRB &
  &, 0.430648E+00_JPRB, 0.416935E+00_JPRB, 0.403363E+00_JPRB, 0.389958E+00_JPRB &
  &, 0.376725E+00_JPRB, 0.363689E+00_JPRB, 0.350854E+00_JPRB &
  &, 0.338221E+00_JPRB, 0.325792E+00_JPRB, 0.313608E+00_JPRB, 0.301646E+00_JPRB &
  &, 0.289925E+00_JPRB, 0.278463E+00_JPRB, 0.267229E+00_JPRB &
  &, 0.256287E+00_JPRB, 0.245579E+00_JPRB, 0.235166E+00_JPRB, 0.225010E+00_JPRB &
  &, 0.215122E+00_JPRB, 0.205510E+00_JPRB, 0.196182E+00_JPRB &
  &, 0.187116E+00_JPRB, 0.178346E+00_JPRB, 0.169846E+00_JPRB, 0.161619E+00_JPRB &
  &, 0.153664E+00_JPRB, 0.146012E+00_JPRB, 0.138599E+00_JPRB &
  &, 0.131483E+00_JPRB, 0.124627E+00_JPRB, 0.118025E+00_JPRB, 0.111668E+00_JPRB &
  &, 0.105578E+00_JPRB, 0.997464E-01_JPRB, 0.941593E-01_JPRB &
  &, 0.888386E-01_JPRB, 0.836970E-01_JPRB, 0.788254E-01_JPRB, 0.741697E-01_JPRB &
  &, 0.697475E-01_JPRB, 0.654991E-01_JPRB, 0.614788E-01_JPRB &
  &, 0.576633E-01_JPRB, 0.540270E-01_JPRB, 0.505836E-01_JPRB, 0.473050E-01_JPRB &
  &, 0.442461E-01_JPRB, 0.413345E-01_JPRB, 0.385366E-01_JPRB &
  &, 0.359512E-01_JPRB, 0.335001E-01_JPRB, 0.311927E-01_JPRB, 0.289914E-01_JPRB &
  &, 0.269513E-01_JPRB, 0.250338E-01_JPRB, 0.231975E-01_JPRB &
  &, 0.214981E-01_JPRB, 0.199434E-01_JPRB, 0.184391E-01_JPRB, 0.170410E-01_JPRB &
  &, 0.157553E-01_JPRB, 0.145346E-01_JPRB, 0.134375E-01_JPRB &
  &, 0.123601E-01_JPRB, 0.113602E-01_JPRB, 0.104987E-01_JPRB, 0.961011E-02_JPRB &
  &, 0.881049E-02_JPRB, 0.810438E-02_JPRB, 0.743645E-02_JPRB &
  &, 0.680889E-02_JPRB, 0.622391E-02_JPRB, 0.568380E-02_JPRB, 0.519083E-02_JPRB &
  &, 0.474736E-02_JPRB, 0.435574E-02_JPRB, 0.395267E-02_JPRB/)
XCW( 555, :) = (/ &
  &  0.101042E+01_JPRB, 0.101199E+01_JPRB, 0.101314E+01_JPRB, 0.101387E+01_JPRB &
  &, 0.101417E+01_JPRB, 0.101405E+01_JPRB, 0.101351E+01_JPRB &
  &, 0.101255E+01_JPRB, 0.101116E+01_JPRB, 0.100934E+01_JPRB, 0.100711E+01_JPRB &
  &, 0.100444E+01_JPRB, 0.100135E+01_JPRB, 0.997843E+00_JPRB &
  &, 0.993911E+00_JPRB, 0.989554E+00_JPRB, 0.984789E+00_JPRB, 0.979602E+00_JPRB &
  &, 0.974005E+00_JPRB, 0.967998E+00_JPRB, 0.961583E+00_JPRB &
  &, 0.954769E+00_JPRB, 0.947554E+00_JPRB, 0.939950E+00_JPRB, 0.931959E+00_JPRB &
  &, 0.923585E+00_JPRB, 0.914840E+00_JPRB, 0.905728E+00_JPRB &
  &, 0.896254E+00_JPRB, 0.886432E+00_JPRB, 0.876268E+00_JPRB, 0.865772E+00_JPRB &
  &, 0.854954E+00_JPRB, 0.843824E+00_JPRB, 0.832395E+00_JPRB &
  &, 0.820673E+00_JPRB, 0.808677E+00_JPRB, 0.796419E+00_JPRB, 0.783903E+00_JPRB &
  &, 0.771147E+00_JPRB, 0.758173E+00_JPRB, 0.744997E+00_JPRB &
  &, 0.731616E+00_JPRB, 0.718050E+00_JPRB, 0.704324E+00_JPRB, 0.690452E+00_JPRB &
  &, 0.676438E+00_JPRB, 0.662315E+00_JPRB, 0.648077E+00_JPRB &
  &, 0.633757E+00_JPRB, 0.619380E+00_JPRB, 0.604929E+00_JPRB, 0.590456E+00_JPRB &
  &, 0.575946E+00_JPRB, 0.561437E+00_JPRB, 0.546944E+00_JPRB &
  &, 0.532463E+00_JPRB, 0.518037E+00_JPRB, 0.503647E+00_JPRB, 0.489353E+00_JPRB &
  &, 0.475117E+00_JPRB, 0.461001E+00_JPRB, 0.446997E+00_JPRB &
  &, 0.433097E+00_JPRB, 0.419365E+00_JPRB, 0.405771E+00_JPRB, 0.392341E+00_JPRB &
  &, 0.379081E+00_JPRB, 0.366014E+00_JPRB, 0.353146E+00_JPRB &
  &, 0.340478E+00_JPRB, 0.328031E+00_JPRB, 0.315806E+00_JPRB, 0.303800E+00_JPRB &
  &, 0.292055E+00_JPRB, 0.280543E+00_JPRB, 0.269280E+00_JPRB &
  &, 0.258282E+00_JPRB, 0.247539E+00_JPRB, 0.237089E+00_JPRB, 0.226868E+00_JPRB &
  &, 0.216937E+00_JPRB, 0.207279E+00_JPRB, 0.197903E+00_JPRB &
  &, 0.188815E+00_JPRB, 0.179991E+00_JPRB, 0.171436E+00_JPRB, 0.163180E+00_JPRB &
  &, 0.155194E+00_JPRB, 0.147478E+00_JPRB, 0.140030E+00_JPRB &
  &, 0.132844E+00_JPRB, 0.125949E+00_JPRB, 0.119305E+00_JPRB, 0.112903E+00_JPRB &
  &, 0.106802E+00_JPRB, 0.100922E+00_JPRB, 0.952847E-01_JPRB &
  &, 0.898760E-01_JPRB, 0.847158E-01_JPRB, 0.798245E-01_JPRB, 0.751103E-01_JPRB &
  &, 0.706273E-01_JPRB, 0.663547E-01_JPRB, 0.623090E-01_JPRB &
  &, 0.584266E-01_JPRB, 0.547619E-01_JPRB, 0.512889E-01_JPRB, 0.480216E-01_JPRB &
  &, 0.448885E-01_JPRB, 0.419435E-01_JPRB, 0.391552E-01_JPRB &
  &, 0.364896E-01_JPRB, 0.340013E-01_JPRB, 0.316553E-01_JPRB, 0.294611E-01_JPRB &
  &, 0.273804E-01_JPRB, 0.254210E-01_JPRB, 0.235905E-01_JPRB &
  &, 0.218969E-01_JPRB, 0.202976E-01_JPRB, 0.187471E-01_JPRB, 0.173535E-01_JPRB &
  &, 0.160195E-01_JPRB, 0.148026E-01_JPRB, 0.136550E-01_JPRB &
  &, 0.125806E-01_JPRB, 0.115838E-01_JPRB, 0.106688E-01_JPRB, 0.984005E-02_JPRB &
  &, 0.904362E-02_JPRB, 0.828163E-02_JPRB, 0.761612E-02_JPRB &
  &, 0.693029E-02_JPRB, 0.634696E-02_JPRB, 0.580850E-02_JPRB, 0.531720E-02_JPRB &
  &, 0.487540E-02_JPRB, 0.442060E-02_JPRB, 0.401838E-02_JPRB/)
XCW( 556, :) = (/ &
  &  0.101068E+01_JPRB, 0.101231E+01_JPRB, 0.101352E+01_JPRB, 0.101431E+01_JPRB &
  &, 0.101468E+01_JPRB, 0.101463E+01_JPRB, 0.101415E+01_JPRB &
  &, 0.101325E+01_JPRB, 0.101193E+01_JPRB, 0.101018E+01_JPRB, 0.100800E+01_JPRB &
  &, 0.100540E+01_JPRB, 0.100237E+01_JPRB, 0.998924E+00_JPRB &
  &, 0.995054E+00_JPRB, 0.990763E+00_JPRB, 0.986053E+00_JPRB, 0.980926E+00_JPRB &
  &, 0.975387E+00_JPRB, 0.969435E+00_JPRB, 0.963078E+00_JPRB &
  &, 0.956321E+00_JPRB, 0.949162E+00_JPRB, 0.941609E+00_JPRB, 0.933671E+00_JPRB &
  &, 0.925349E+00_JPRB, 0.916657E+00_JPRB, 0.907594E+00_JPRB &
  &, 0.898170E+00_JPRB, 0.888396E+00_JPRB, 0.878276E+00_JPRB, 0.867826E+00_JPRB &
  &, 0.857051E+00_JPRB, 0.845961E+00_JPRB, 0.834572E+00_JPRB &
  &, 0.822886E+00_JPRB, 0.810928E+00_JPRB, 0.798698E+00_JPRB, 0.786219E+00_JPRB &
  &, 0.773501E+00_JPRB, 0.760555E+00_JPRB, 0.747395E+00_JPRB &
  &, 0.734041E+00_JPRB, 0.720502E+00_JPRB, 0.706802E+00_JPRB, 0.692944E+00_JPRB &
  &, 0.678943E+00_JPRB, 0.664832E+00_JPRB, 0.650617E+00_JPRB &
  &, 0.636306E+00_JPRB, 0.621924E+00_JPRB, 0.607493E+00_JPRB, 0.593011E+00_JPRB &
  &, 0.578518E+00_JPRB, 0.564011E+00_JPRB, 0.549503E+00_JPRB &
  &, 0.535020E+00_JPRB, 0.520590E+00_JPRB, 0.506194E+00_JPRB, 0.491876E+00_JPRB &
  &, 0.477647E+00_JPRB, 0.463500E+00_JPRB, 0.449482E+00_JPRB &
  &, 0.435565E+00_JPRB, 0.421795E+00_JPRB, 0.408179E+00_JPRB, 0.394724E+00_JPRB &
  &, 0.381456E+00_JPRB, 0.368360E+00_JPRB, 0.355459E+00_JPRB &
  &, 0.342755E+00_JPRB, 0.330270E+00_JPRB, 0.318004E+00_JPRB, 0.305977E+00_JPRB &
  &, 0.294185E+00_JPRB, 0.282646E+00_JPRB, 0.271354E+00_JPRB &
  &, 0.260300E+00_JPRB, 0.249523E+00_JPRB, 0.239011E+00_JPRB, 0.228777E+00_JPRB &
  &, 0.218804E+00_JPRB, 0.209102E+00_JPRB, 0.199679E+00_JPRB &
  &, 0.190513E+00_JPRB, 0.181665E+00_JPRB, 0.173055E+00_JPRB, 0.164740E+00_JPRB &
  &, 0.156724E+00_JPRB, 0.148944E+00_JPRB, 0.141461E+00_JPRB &
  &, 0.134238E+00_JPRB, 0.127271E+00_JPRB, 0.120584E+00_JPRB, 0.114172E+00_JPRB &
  &, 0.107991E+00_JPRB, 0.102063E+00_JPRB, 0.964102E-01_JPRB &
  &, 0.909493E-01_JPRB, 0.857710E-01_JPRB, 0.807866E-01_JPRB, 0.760510E-01_JPRB &
  &, 0.715454E-01_JPRB, 0.672491E-01_JPRB, 0.631391E-01_JPRB &
  &, 0.592302E-01_JPRB, 0.555377E-01_JPRB, 0.520357E-01_JPRB, 0.486960E-01_JPRB &
  &, 0.455308E-01_JPRB, 0.425525E-01_JPRB, 0.397296E-01_JPRB &
  &, 0.370729E-01_JPRB, 0.345481E-01_JPRB, 0.321643E-01_JPRB, 0.299308E-01_JPRB &
  &, 0.278573E-01_JPRB, 0.258566E-01_JPRB, 0.239836E-01_JPRB &
  &, 0.222459E-01_JPRB, 0.206517E-01_JPRB, 0.191064E-01_JPRB, 0.176660E-01_JPRB &
  &, 0.163365E-01_JPRB, 0.150706E-01_JPRB, 0.139268E-01_JPRB &
  &, 0.128563E-01_JPRB, 0.118075E-01_JPRB, 0.108956E-01_JPRB, 0.100125E-01_JPRB &
  &, 0.921846E-02_JPRB, 0.845888E-02_JPRB, 0.773590E-02_JPRB &
  &, 0.711241E-02_JPRB, 0.653153E-02_JPRB, 0.593320E-02_JPRB, 0.544356E-02_JPRB &
  &, 0.500343E-02_JPRB, 0.455032E-02_JPRB, 0.414980E-02_JPRB/)
XCW( 557, :) = (/ &
  &  0.101093E+01_JPRB, 0.101263E+01_JPRB, 0.101390E+01_JPRB, 0.101476E+01_JPRB &
  &, 0.101520E+01_JPRB, 0.101521E+01_JPRB, 0.101479E+01_JPRB &
  &, 0.101396E+01_JPRB, 0.101270E+01_JPRB, 0.101101E+01_JPRB, 0.100889E+01_JPRB &
  &, 0.100636E+01_JPRB, 0.100339E+01_JPRB, 0.100001E+01_JPRB &
  &, 0.996196E+00_JPRB, 0.991967E+00_JPRB, 0.987316E+00_JPRB, 0.982251E+00_JPRB &
  &, 0.976769E+00_JPRB, 0.970876E+00_JPRB, 0.964576E+00_JPRB &
  &, 0.957872E+00_JPRB, 0.950769E+00_JPRB, 0.943275E+00_JPRB, 0.935387E+00_JPRB &
  &, 0.927121E+00_JPRB, 0.918475E+00_JPRB, 0.909464E+00_JPRB &
  &, 0.900090E+00_JPRB, 0.890359E+00_JPRB, 0.880289E+00_JPRB, 0.869880E+00_JPRB &
  &, 0.859149E+00_JPRB, 0.848102E+00_JPRB, 0.836749E+00_JPRB &
  &, 0.825100E+00_JPRB, 0.813179E+00_JPRB, 0.800986E+00_JPRB, 0.788545E+00_JPRB &
  &, 0.775855E+00_JPRB, 0.762936E+00_JPRB, 0.749805E+00_JPRB &
  &, 0.736478E+00_JPRB, 0.722965E+00_JPRB, 0.709280E+00_JPRB, 0.695436E+00_JPRB &
  &, 0.681460E+00_JPRB, 0.667361E+00_JPRB, 0.653156E+00_JPRB &
  &, 0.638869E+00_JPRB, 0.624495E+00_JPRB, 0.610057E+00_JPRB, 0.595594E+00_JPRB &
  &, 0.581090E+00_JPRB, 0.566585E+00_JPRB, 0.552077E+00_JPRB &
  &, 0.537592E+00_JPRB, 0.523143E+00_JPRB, 0.508742E+00_JPRB, 0.494415E+00_JPRB &
  &, 0.480176E+00_JPRB, 0.466018E+00_JPRB, 0.451967E+00_JPRB &
  &, 0.438051E+00_JPRB, 0.424262E+00_JPRB, 0.410624E+00_JPRB, 0.397145E+00_JPRB &
  &, 0.383831E+00_JPRB, 0.370705E+00_JPRB, 0.357772E+00_JPRB &
  &, 0.345054E+00_JPRB, 0.332531E+00_JPRB, 0.320246E+00_JPRB, 0.308176E+00_JPRB &
  &, 0.296337E+00_JPRB, 0.284749E+00_JPRB, 0.273428E+00_JPRB &
  &, 0.262344E+00_JPRB, 0.251508E+00_JPRB, 0.240959E+00_JPRB, 0.230660E+00_JPRB &
  &, 0.220645E+00_JPRB, 0.210899E+00_JPRB, 0.201428E+00_JPRB &
  &, 0.192240E+00_JPRB, 0.183339E+00_JPRB, 0.174703E+00_JPRB, 0.166330E+00_JPRB &
  &, 0.158253E+00_JPRB, 0.150441E+00_JPRB, 0.142891E+00_JPRB &
  &, 0.135631E+00_JPRB, 0.128624E+00_JPRB, 0.121897E+00_JPRB, 0.115441E+00_JPRB &
  &, 0.109214E+00_JPRB, 0.103238E+00_JPRB, 0.975356E-01_JPRB &
  &, 0.920583E-01_JPRB, 0.867898E-01_JPRB, 0.817856E-01_JPRB, 0.770292E-01_JPRB &
  &, 0.724635E-01_JPRB, 0.681047E-01_JPRB, 0.639692E-01_JPRB &
  &, 0.600337E-01_JPRB, 0.563134E-01_JPRB, 0.527410E-01_JPRB, 0.493704E-01_JPRB &
  &, 0.462160E-01_JPRB, 0.431615E-01_JPRB, 0.403039E-01_JPRB &
  &, 0.376114E-01_JPRB, 0.350949E-01_JPRB, 0.326732E-01_JPRB, 0.304005E-01_JPRB &
  &, 0.282864E-01_JPRB, 0.262923E-01_JPRB, 0.244257E-01_JPRB &
  &, 0.226448E-01_JPRB, 0.210059E-01_JPRB, 0.194658E-01_JPRB, 0.179785E-01_JPRB &
  &, 0.166535E-01_JPRB, 0.153922E-01_JPRB, 0.141986E-01_JPRB &
  &, 0.130768E-01_JPRB, 0.120870E-01_JPRB, 0.111224E-01_JPRB, 0.102425E-01_JPRB &
  &, 0.939331E-02_JPRB, 0.863613E-02_JPRB, 0.791558E-02_JPRB &
  &, 0.723382E-02_JPRB, 0.665458E-02_JPRB, 0.605789E-02_JPRB, 0.556992E-02_JPRB &
  &, 0.506745E-02_JPRB, 0.461519E-02_JPRB, 0.421551E-02_JPRB/)
XCW( 558, :) = (/ &
  &  0.101119E+01_JPRB, 0.101295E+01_JPRB, 0.101429E+01_JPRB, 0.101521E+01_JPRB &
  &, 0.101571E+01_JPRB, 0.101578E+01_JPRB, 0.101544E+01_JPRB &
  &, 0.101466E+01_JPRB, 0.101347E+01_JPRB, 0.101184E+01_JPRB, 0.100979E+01_JPRB &
  &, 0.100731E+01_JPRB, 0.100441E+01_JPRB, 0.100109E+01_JPRB &
  &, 0.997342E+00_JPRB, 0.993172E+00_JPRB, 0.988583E+00_JPRB, 0.983575E+00_JPRB &
  &, 0.978154E+00_JPRB, 0.972319E+00_JPRB, 0.966077E+00_JPRB &
  &, 0.959431E+00_JPRB, 0.952384E+00_JPRB, 0.944941E+00_JPRB, 0.937110E+00_JPRB &
  &, 0.928892E+00_JPRB, 0.920301E+00_JPRB, 0.911337E+00_JPRB &
  &, 0.902010E+00_JPRB, 0.892330E+00_JPRB, 0.882305E+00_JPRB, 0.871943E+00_JPRB &
  &, 0.861250E+00_JPRB, 0.850248E+00_JPRB, 0.838935E+00_JPRB &
  &, 0.827323E+00_JPRB, 0.815439E+00_JPRB, 0.803284E+00_JPRB, 0.790871E+00_JPRB &
  &, 0.778209E+00_JPRB, 0.765328E+00_JPRB, 0.752225E+00_JPRB &
  &, 0.738914E+00_JPRB, 0.725429E+00_JPRB, 0.711770E+00_JPRB, 0.697952E+00_JPRB &
  &, 0.683990E+00_JPRB, 0.669902E+00_JPRB, 0.655709E+00_JPRB &
  &, 0.641431E+00_JPRB, 0.627065E+00_JPRB, 0.612634E+00_JPRB, 0.598177E+00_JPRB &
  &, 0.583677E+00_JPRB, 0.569160E+00_JPRB, 0.554651E+00_JPRB &
  &, 0.540165E+00_JPRB, 0.525712E+00_JPRB, 0.511305E+00_JPRB, 0.496971E+00_JPRB &
  &, 0.482705E+00_JPRB, 0.468535E+00_JPRB, 0.454470E+00_JPRB &
  &, 0.440537E+00_JPRB, 0.426729E+00_JPRB, 0.413069E+00_JPRB, 0.399567E+00_JPRB &
  &, 0.386225E+00_JPRB, 0.373070E+00_JPRB, 0.360105E+00_JPRB &
  &, 0.347352E+00_JPRB, 0.334792E+00_JPRB, 0.322467E+00_JPRB, 0.310375E+00_JPRB &
  &, 0.298513E+00_JPRB, 0.286875E+00_JPRB, 0.275503E+00_JPRB &
  &, 0.264387E+00_JPRB, 0.253517E+00_JPRB, 0.242907E+00_JPRB, 0.232595E+00_JPRB &
  &, 0.222513E+00_JPRB, 0.212722E+00_JPRB, 0.203232E+00_JPRB &
  &, 0.193994E+00_JPRB, 0.185014E+00_JPRB, 0.176350E+00_JPRB, 0.167921E+00_JPRB &
  &, 0.159813E+00_JPRB, 0.151938E+00_JPRB, 0.144353E+00_JPRB &
  &, 0.137056E+00_JPRB, 0.130010E+00_JPRB, 0.123209E+00_JPRB, 0.116710E+00_JPRB &
  &, 0.110437E+00_JPRB, 0.104413E+00_JPRB, 0.986610E-01_JPRB &
  &, 0.931315E-01_JPRB, 0.878449E-01_JPRB, 0.828217E-01_JPRB, 0.779699E-01_JPRB &
  &, 0.733816E-01_JPRB, 0.689991E-01_JPRB, 0.648389E-01_JPRB &
  &, 0.608372E-01_JPRB, 0.570892E-01_JPRB, 0.534878E-01_JPRB, 0.500870E-01_JPRB &
  &, 0.468583E-01_JPRB, 0.438140E-01_JPRB, 0.409225E-01_JPRB &
  &, 0.381947E-01_JPRB, 0.356416E-01_JPRB, 0.331821E-01_JPRB, 0.309172E-01_JPRB &
  &, 0.287633E-01_JPRB, 0.267279E-01_JPRB, 0.248187E-01_JPRB &
  &, 0.230436E-01_JPRB, 0.213600E-01_JPRB, 0.197738E-01_JPRB, 0.183431E-01_JPRB &
  &, 0.169705E-01_JPRB, 0.156602E-01_JPRB, 0.144704E-01_JPRB &
  &, 0.133525E-01_JPRB, 0.123107E-01_JPRB, 0.113492E-01_JPRB, 0.104149E-01_JPRB &
  &, 0.956815E-02_JPRB, 0.881338E-02_JPRB, 0.809525E-02_JPRB &
  &, 0.741593E-02_JPRB, 0.677763E-02_JPRB, 0.624494E-02_JPRB, 0.569628E-02_JPRB &
  &, 0.519549E-02_JPRB, 0.474491E-02_JPRB, 0.434694E-02_JPRB/)
XCW( 559, :) = (/ &
  &  0.101144E+01_JPRB, 0.101327E+01_JPRB, 0.101467E+01_JPRB, 0.101566E+01_JPRB &
  &, 0.101622E+01_JPRB, 0.101636E+01_JPRB, 0.101608E+01_JPRB &
  &, 0.101537E+01_JPRB, 0.101423E+01_JPRB, 0.101267E+01_JPRB, 0.101069E+01_JPRB &
  &, 0.100827E+01_JPRB, 0.100544E+01_JPRB, 0.100217E+01_JPRB &
  &, 0.998487E+00_JPRB, 0.994379E+00_JPRB, 0.989849E+00_JPRB, 0.984903E+00_JPRB &
  &, 0.979539E+00_JPRB, 0.973763E+00_JPRB, 0.967578E+00_JPRB &
  &, 0.960989E+00_JPRB, 0.953998E+00_JPRB, 0.946610E+00_JPRB, 0.938833E+00_JPRB &
  &, 0.930667E+00_JPRB, 0.922126E+00_JPRB, 0.913215E+00_JPRB &
  &, 0.903938E+00_JPRB, 0.894302E+00_JPRB, 0.884322E+00_JPRB, 0.874006E+00_JPRB &
  &, 0.863360E+00_JPRB, 0.852393E+00_JPRB, 0.841126E+00_JPRB &
  &, 0.829555E+00_JPRB, 0.817709E+00_JPRB, 0.805581E+00_JPRB, 0.793207E+00_JPRB &
  &, 0.780573E+00_JPRB, 0.767720E+00_JPRB, 0.754644E+00_JPRB &
  &, 0.741361E+00_JPRB, 0.727903E+00_JPRB, 0.714260E+00_JPRB, 0.700456E+00_JPRB &
  &, 0.686519E+00_JPRB, 0.672456E+00_JPRB, 0.658274E+00_JPRB &
  &, 0.643993E+00_JPRB, 0.629649E+00_JPRB, 0.615226E+00_JPRB, 0.600760E+00_JPRB &
  &, 0.586264E+00_JPRB, 0.571763E+00_JPRB, 0.557256E+00_JPRB &
  &, 0.542753E+00_JPRB, 0.528297E+00_JPRB, 0.513885E+00_JPRB, 0.499527E+00_JPRB &
  &, 0.485252E+00_JPRB, 0.471069E+00_JPRB, 0.456990E+00_JPRB &
  &, 0.443042E+00_JPRB, 0.429214E+00_JPRB, 0.415515E+00_JPRB, 0.401988E+00_JPRB &
  &, 0.388640E+00_JPRB, 0.375456E+00_JPRB, 0.362459E+00_JPRB &
  &, 0.349672E+00_JPRB, 0.337075E+00_JPRB, 0.324731E+00_JPRB, 0.312574E+00_JPRB &
  &, 0.300688E+00_JPRB, 0.289025E+00_JPRB, 0.277601E+00_JPRB &
  &, 0.266430E+00_JPRB, 0.255527E+00_JPRB, 0.244881E+00_JPRB, 0.234504E+00_JPRB &
  &, 0.224406E+00_JPRB, 0.214572E+00_JPRB, 0.205008E+00_JPRB &
  &, 0.195721E+00_JPRB, 0.186716E+00_JPRB, 0.177998E+00_JPRB, 0.169540E+00_JPRB &
  &, 0.161373E+00_JPRB, 0.153465E+00_JPRB, 0.145815E+00_JPRB &
  &, 0.138481E+00_JPRB, 0.131364E+00_JPRB, 0.124554E+00_JPRB, 0.117979E+00_JPRB &
  &, 0.111660E+00_JPRB, 0.105623E+00_JPRB, 0.998216E-01_JPRB &
  &, 0.942406E-01_JPRB, 0.889365E-01_JPRB, 0.838208E-01_JPRB, 0.789858E-01_JPRB &
  &, 0.743380E-01_JPRB, 0.698936E-01_JPRB, 0.656690E-01_JPRB &
  &, 0.616809E-01_JPRB, 0.578649E-01_JPRB, 0.542346E-01_JPRB, 0.508036E-01_JPRB &
  &, 0.475435E-01_JPRB, 0.444664E-01_JPRB, 0.415410E-01_JPRB &
  &, 0.387780E-01_JPRB, 0.361884E-01_JPRB, 0.337373E-01_JPRB, 0.313869E-01_JPRB &
  &, 0.292401E-01_JPRB, 0.271635E-01_JPRB, 0.252608E-01_JPRB &
  &, 0.234425E-01_JPRB, 0.217141E-01_JPRB, 0.201331E-01_JPRB, 0.186555E-01_JPRB &
  &, 0.172347E-01_JPRB, 0.159282E-01_JPRB, 0.147422E-01_JPRB &
  &, 0.135730E-01_JPRB, 0.125343E-01_JPRB, 0.115760E-01_JPRB, 0.106449E-01_JPRB &
  &, 0.980128E-02_JPRB, 0.899063E-02_JPRB, 0.827492E-02_JPRB &
  &, 0.759804E-02_JPRB, 0.696220E-02_JPRB, 0.636964E-02_JPRB, 0.582264E-02_JPRB &
  &, 0.532352E-02_JPRB, 0.487463E-02_JPRB, 0.441265E-02_JPRB/)
XCW( 560, :) = (/ &
  &  0.101170E+01_JPRB, 0.101359E+01_JPRB, 0.101506E+01_JPRB, 0.101611E+01_JPRB &
  &, 0.101673E+01_JPRB, 0.101694E+01_JPRB, 0.101672E+01_JPRB &
  &, 0.101607E+01_JPRB, 0.101500E+01_JPRB, 0.101351E+01_JPRB, 0.101158E+01_JPRB &
  &, 0.100923E+01_JPRB, 0.100646E+01_JPRB, 0.100326E+01_JPRB &
  &, 0.999635E+00_JPRB, 0.995587E+00_JPRB, 0.991119E+00_JPRB, 0.986232E+00_JPRB &
  &, 0.980927E+00_JPRB, 0.975209E+00_JPRB, 0.969083E+00_JPRB &
  &, 0.962551E+00_JPRB, 0.955612E+00_JPRB, 0.948279E+00_JPRB, 0.940556E+00_JPRB &
  &, 0.932446E+00_JPRB, 0.923955E+00_JPRB, 0.915093E+00_JPRB &
  &, 0.905865E+00_JPRB, 0.896281E+00_JPRB, 0.886346E+00_JPRB, 0.876073E+00_JPRB &
  &, 0.865471E+00_JPRB, 0.854548E+00_JPRB, 0.843317E+00_JPRB &
  &, 0.831788E+00_JPRB, 0.819978E+00_JPRB, 0.807889E+00_JPRB, 0.795543E+00_JPRB &
  &, 0.782947E+00_JPRB, 0.770123E+00_JPRB, 0.757075E+00_JPRB &
  &, 0.743820E+00_JPRB, 0.730378E+00_JPRB, 0.716761E+00_JPRB, 0.702984E+00_JPRB &
  &, 0.689061E+00_JPRB, 0.675010E+00_JPRB, 0.660840E+00_JPRB &
  &, 0.646582E+00_JPRB, 0.632233E+00_JPRB, 0.617817E+00_JPRB, 0.603357E+00_JPRB &
  &, 0.588865E+00_JPRB, 0.574367E+00_JPRB, 0.559845E+00_JPRB &
  &, 0.545356E+00_JPRB, 0.530882E+00_JPRB, 0.516464E+00_JPRB, 0.502100E+00_JPRB &
  &, 0.487815E+00_JPRB, 0.473621E+00_JPRB, 0.459529E+00_JPRB &
  &, 0.445546E+00_JPRB, 0.431700E+00_JPRB, 0.417979E+00_JPRB, 0.404429E+00_JPRB &
  &, 0.391055E+00_JPRB, 0.377842E+00_JPRB, 0.364813E+00_JPRB &
  &, 0.351992E+00_JPRB, 0.339379E+00_JPRB, 0.326973E+00_JPRB, 0.314817E+00_JPRB &
  &, 0.302864E+00_JPRB, 0.291175E+00_JPRB, 0.279699E+00_JPRB &
  &, 0.268497E+00_JPRB, 0.257561E+00_JPRB, 0.246879E+00_JPRB, 0.236464E+00_JPRB &
  &, 0.226300E+00_JPRB, 0.216422E+00_JPRB, 0.206811E+00_JPRB &
  &, 0.197503E+00_JPRB, 0.188447E+00_JPRB, 0.179675E+00_JPRB, 0.171160E+00_JPRB &
  &, 0.162932E+00_JPRB, 0.154992E+00_JPRB, 0.147308E+00_JPRB &
  &, 0.139906E+00_JPRB, 0.132750E+00_JPRB, 0.125900E+00_JPRB, 0.119281E+00_JPRB &
  &, 0.112918E+00_JPRB, 0.106833E+00_JPRB, 0.100982E+00_JPRB &
  &, 0.953496E-01_JPRB, 0.899917E-01_JPRB, 0.848569E-01_JPRB, 0.799640E-01_JPRB &
  &, 0.752944E-01_JPRB, 0.708269E-01_JPRB, 0.665386E-01_JPRB &
  &, 0.625246E-01_JPRB, 0.586407E-01_JPRB, 0.549813E-01_JPRB, 0.515202E-01_JPRB &
  &, 0.482286E-01_JPRB, 0.451189E-01_JPRB, 0.421596E-01_JPRB &
  &, 0.393613E-01_JPRB, 0.367352E-01_JPRB, 0.342462E-01_JPRB, 0.319036E-01_JPRB &
  &, 0.297169E-01_JPRB, 0.276475E-01_JPRB, 0.256538E-01_JPRB &
  &, 0.238413E-01_JPRB, 0.221189E-01_JPRB, 0.204925E-01_JPRB, 0.189680E-01_JPRB &
  &, 0.175517E-01_JPRB, 0.162497E-01_JPRB, 0.150140E-01_JPRB &
  &, 0.138487E-01_JPRB, 0.127580E-01_JPRB, 0.118028E-01_JPRB, 0.108748E-01_JPRB &
  &, 0.997612E-02_JPRB, 0.916788E-02_JPRB, 0.845459E-02_JPRB &
  &, 0.771945E-02_JPRB, 0.708525E-02_JPRB, 0.649434E-02_JPRB, 0.594901E-02_JPRB &
  &, 0.545156E-02_JPRB, 0.500436E-02_JPRB, 0.454407E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART80',1,ZHOOK_HANDLE)
END SUBROUTINE PART80

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART81

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART81',0,ZHOOK_HANDLE)

XCW( 561, :) = (/ &
  &  0.101195E+01_JPRB, 0.101391E+01_JPRB, 0.101544E+01_JPRB, 0.101655E+01_JPRB &
  &, 0.101725E+01_JPRB, 0.101752E+01_JPRB, 0.101736E+01_JPRB &
  &, 0.101678E+01_JPRB, 0.101578E+01_JPRB, 0.101434E+01_JPRB, 0.101248E+01_JPRB &
  &, 0.101020E+01_JPRB, 0.100748E+01_JPRB, 0.100434E+01_JPRB &
  &, 0.100078E+01_JPRB, 0.996797E+00_JPRB, 0.992390E+00_JPRB, 0.987562E+00_JPRB &
  &, 0.982319E+00_JPRB, 0.976659E+00_JPRB, 0.970590E+00_JPRB &
  &, 0.964112E+00_JPRB, 0.957234E+00_JPRB, 0.949956E+00_JPRB, 0.942286E+00_JPRB &
  &, 0.934228E+00_JPRB, 0.925788E+00_JPRB, 0.916978E+00_JPRB &
  &, 0.907797E+00_JPRB, 0.898261E+00_JPRB, 0.888375E+00_JPRB, 0.878148E+00_JPRB &
  &, 0.867590E+00_JPRB, 0.856707E+00_JPRB, 0.845517E+00_JPRB &
  &, 0.834029E+00_JPRB, 0.822248E+00_JPRB, 0.810197E+00_JPRB, 0.797889E+00_JPRB &
  &, 0.785321E+00_JPRB, 0.772526E+00_JPRB, 0.759506E+00_JPRB &
  &, 0.746279E+00_JPRB, 0.732864E+00_JPRB, 0.719263E+00_JPRB, 0.705511E+00_JPRB &
  &, 0.691602E+00_JPRB, 0.677565E+00_JPRB, 0.663418E+00_JPRB &
  &, 0.649157E+00_JPRB, 0.634831E+00_JPRB, 0.620422E+00_JPRB, 0.605968E+00_JPRB &
  &, 0.591481E+00_JPRB, 0.576971E+00_JPRB, 0.562465E+00_JPRB &
  &, 0.547960E+00_JPRB, 0.533498E+00_JPRB, 0.519060E+00_JPRB, 0.504689E+00_JPRB &
  &, 0.490395E+00_JPRB, 0.476173E+00_JPRB, 0.462067E+00_JPRB &
  &, 0.448068E+00_JPRB, 0.434204E+00_JPRB, 0.420463E+00_JPRB, 0.406889E+00_JPRB &
  &, 0.393469E+00_JPRB, 0.380248E+00_JPRB, 0.367188E+00_JPRB &
  &, 0.354333E+00_JPRB, 0.341682E+00_JPRB, 0.329259E+00_JPRB, 0.317039E+00_JPRB &
  &, 0.305062E+00_JPRB, 0.293325E+00_JPRB, 0.281844E+00_JPRB &
  &, 0.270589E+00_JPRB, 0.259595E+00_JPRB, 0.248878E+00_JPRB, 0.238373E+00_JPRB &
  &, 0.228220E+00_JPRB, 0.218298E+00_JPRB, 0.208642E+00_JPRB &
  &, 0.199257E+00_JPRB, 0.190178E+00_JPRB, 0.181351E+00_JPRB, 0.172809E+00_JPRB &
  &, 0.164522E+00_JPRB, 0.156519E+00_JPRB, 0.148800E+00_JPRB &
  &, 0.141362E+00_JPRB, 0.134169E+00_JPRB, 0.127245E+00_JPRB, 0.120583E+00_JPRB &
  &, 0.114175E+00_JPRB, 0.108043E+00_JPRB, 0.102143E+00_JPRB &
  &, 0.964944E-01_JPRB, 0.910833E-01_JPRB, 0.858929E-01_JPRB, 0.809423E-01_JPRB &
  &, 0.762507E-01_JPRB, 0.717214E-01_JPRB, 0.674478E-01_JPRB &
  &, 0.633683E-01_JPRB, 0.594573E-01_JPRB, 0.557696E-01_JPRB, 0.522790E-01_JPRB &
  &, 0.489138E-01_JPRB, 0.457714E-01_JPRB, 0.427781E-01_JPRB &
  &, 0.399895E-01_JPRB, 0.373275E-01_JPRB, 0.348014E-01_JPRB, 0.324203E-01_JPRB &
  &, 0.301938E-01_JPRB, 0.280831E-01_JPRB, 0.260960E-01_JPRB &
  &, 0.242402E-01_JPRB, 0.224730E-01_JPRB, 0.208518E-01_JPRB, 0.193326E-01_JPRB &
  &, 0.178687E-01_JPRB, 0.165713E-01_JPRB, 0.152858E-01_JPRB &
  &, 0.141244E-01_JPRB, 0.130375E-01_JPRB, 0.120295E-01_JPRB, 0.110473E-01_JPRB &
  &, 0.102092E-01_JPRB, 0.934513E-02_JPRB, 0.863427E-02_JPRB &
  &, 0.790156E-02_JPRB, 0.726982E-02_JPRB, 0.661904E-02_JPRB, 0.607537E-02_JPRB &
  &, 0.557960E-02_JPRB, 0.506922E-02_JPRB, 0.467549E-02_JPRB/)
XCW( 562, :) = (/ &
  &  0.101221E+01_JPRB, 0.101423E+01_JPRB, 0.101583E+01_JPRB, 0.101701E+01_JPRB &
  &, 0.101776E+01_JPRB, 0.101810E+01_JPRB, 0.101801E+01_JPRB &
  &, 0.101749E+01_JPRB, 0.101655E+01_JPRB, 0.101518E+01_JPRB, 0.101338E+01_JPRB &
  &, 0.101116E+01_JPRB, 0.100851E+01_JPRB, 0.100543E+01_JPRB &
  &, 0.100193E+01_JPRB, 0.998008E+00_JPRB, 0.993661E+00_JPRB, 0.988894E+00_JPRB &
  &, 0.983710E+00_JPRB, 0.978109E+00_JPRB, 0.972098E+00_JPRB &
  &, 0.965677E+00_JPRB, 0.958855E+00_JPRB, 0.951632E+00_JPRB, 0.944016E+00_JPRB &
  &, 0.936010E+00_JPRB, 0.927625E+00_JPRB, 0.918863E+00_JPRB &
  &, 0.909732E+00_JPRB, 0.900244E+00_JPRB, 0.890404E+00_JPRB, 0.880223E+00_JPRB &
  &, 0.869708E+00_JPRB, 0.858870E+00_JPRB, 0.847721E+00_JPRB &
  &, 0.836271E+00_JPRB, 0.824527E+00_JPRB, 0.812514E+00_JPRB, 0.800235E+00_JPRB &
  &, 0.787706E+00_JPRB, 0.774939E+00_JPRB, 0.761948E+00_JPRB &
  &, 0.748748E+00_JPRB, 0.735350E+00_JPRB, 0.721776E+00_JPRB, 0.708039E+00_JPRB &
  &, 0.694156E+00_JPRB, 0.680131E+00_JPRB, 0.665996E+00_JPRB &
  &, 0.651759E+00_JPRB, 0.637428E+00_JPRB, 0.623041E+00_JPRB, 0.608593E+00_JPRB &
  &, 0.594111E+00_JPRB, 0.579604E+00_JPRB, 0.565085E+00_JPRB &
  &, 0.550579E+00_JPRB, 0.536099E+00_JPRB, 0.521672E+00_JPRB, 0.507278E+00_JPRB &
  &, 0.492975E+00_JPRB, 0.478742E+00_JPRB, 0.464623E+00_JPRB &
  &, 0.450609E+00_JPRB, 0.436708E+00_JPRB, 0.422965E+00_JPRB, 0.409349E+00_JPRB &
  &, 0.395923E+00_JPRB, 0.382654E+00_JPRB, 0.369583E+00_JPRB &
  &, 0.356694E+00_JPRB, 0.344008E+00_JPRB, 0.331545E+00_JPRB, 0.319305E+00_JPRB &
  &, 0.307283E+00_JPRB, 0.295498E+00_JPRB, 0.283966E+00_JPRB &
  &, 0.272680E+00_JPRB, 0.261654E+00_JPRB, 0.250877E+00_JPRB, 0.240385E+00_JPRB &
  &, 0.230140E+00_JPRB, 0.220175E+00_JPRB, 0.210473E+00_JPRB &
  &, 0.201067E+00_JPRB, 0.191909E+00_JPRB, 0.183028E+00_JPRB, 0.174458E+00_JPRB &
  &, 0.166141E+00_JPRB, 0.158077E+00_JPRB, 0.150324E+00_JPRB &
  &, 0.142819E+00_JPRB, 0.135587E+00_JPRB, 0.128623E+00_JPRB, 0.121919E+00_JPRB &
  &, 0.115466E+00_JPRB, 0.109288E+00_JPRB, 0.103339E+00_JPRB &
  &, 0.976392E-01_JPRB, 0.921748E-01_JPRB, 0.869660E-01_JPRB, 0.819582E-01_JPRB &
  &, 0.772071E-01_JPRB, 0.726547E-01_JPRB, 0.683175E-01_JPRB &
  &, 0.642120E-01_JPRB, 0.602739E-01_JPRB, 0.565579E-01_JPRB, 0.529956E-01_JPRB &
  &, 0.496418E-01_JPRB, 0.464674E-01_JPRB, 0.434408E-01_JPRB &
  &, 0.405728E-01_JPRB, 0.378743E-01_JPRB, 0.353566E-01_JPRB, 0.329370E-01_JPRB &
  &, 0.306706E-01_JPRB, 0.285671E-01_JPRB, 0.265381E-01_JPRB &
  &, 0.246390E-01_JPRB, 0.228778E-01_JPRB, 0.212111E-01_JPRB, 0.196972E-01_JPRB &
  &, 0.182386E-01_JPRB, 0.168393E-01_JPRB, 0.155576E-01_JPRB &
  &, 0.144000E-01_JPRB, 0.132612E-01_JPRB, 0.122563E-01_JPRB, 0.112772E-01_JPRB &
  &, 0.103841E-01_JPRB, 0.958146E-02_JPRB, 0.881394E-02_JPRB &
  &, 0.808368E-02_JPRB, 0.739287E-02_JPRB, 0.680609E-02_JPRB, 0.620173E-02_JPRB &
  &, 0.570763E-02_JPRB, 0.519894E-02_JPRB, 0.474120E-02_JPRB/)
XCW( 563, :) = (/ &
  &  0.101247E+01_JPRB, 0.101455E+01_JPRB, 0.101621E+01_JPRB, 0.101746E+01_JPRB &
  &, 0.101828E+01_JPRB, 0.101868E+01_JPRB, 0.101865E+01_JPRB &
  &, 0.101820E+01_JPRB, 0.101732E+01_JPRB, 0.101601E+01_JPRB, 0.101428E+01_JPRB &
  &, 0.101212E+01_JPRB, 0.100954E+01_JPRB, 0.100652E+01_JPRB &
  &, 0.100308E+01_JPRB, 0.999221E+00_JPRB, 0.994935E+00_JPRB, 0.990228E+00_JPRB &
  &, 0.985103E+00_JPRB, 0.979562E+00_JPRB, 0.973609E+00_JPRB &
  &, 0.967245E+00_JPRB, 0.960479E+00_JPRB, 0.953312E+00_JPRB, 0.945749E+00_JPRB &
  &, 0.937796E+00_JPRB, 0.929465E+00_JPRB, 0.920752E+00_JPRB &
  &, 0.911676E+00_JPRB, 0.902232E+00_JPRB, 0.892441E+00_JPRB, 0.882303E+00_JPRB &
  &, 0.871832E+00_JPRB, 0.861038E+00_JPRB, 0.849930E+00_JPRB &
  &, 0.838522E+00_JPRB, 0.826816E+00_JPRB, 0.814841E+00_JPRB, 0.802591E+00_JPRB &
  &, 0.790091E+00_JPRB, 0.777363E+00_JPRB, 0.764400E+00_JPRB &
  &, 0.751229E+00_JPRB, 0.737859E+00_JPRB, 0.724301E+00_JPRB, 0.710591E+00_JPRB &
  &, 0.696722E+00_JPRB, 0.682710E+00_JPRB, 0.668587E+00_JPRB &
  &, 0.654361E+00_JPRB, 0.640053E+00_JPRB, 0.625660E+00_JPRB, 0.611219E+00_JPRB &
  &, 0.596741E+00_JPRB, 0.582223E+00_JPRB, 0.567719E+00_JPRB &
  &, 0.553213E+00_JPRB, 0.538731E+00_JPRB, 0.524284E+00_JPRB, 0.509883E+00_JPRB &
  &, 0.495573E+00_JPRB, 0.481329E+00_JPRB, 0.467179E+00_JPRB &
  &, 0.453149E+00_JPRB, 0.439231E+00_JPRB, 0.425468E+00_JPRB, 0.411829E+00_JPRB &
  &, 0.398378E+00_JPRB, 0.385080E+00_JPRB, 0.371979E+00_JPRB &
  &, 0.359056E+00_JPRB, 0.346333E+00_JPRB, 0.333853E+00_JPRB, 0.321571E+00_JPRB &
  &, 0.309505E+00_JPRB, 0.297695E+00_JPRB, 0.286112E+00_JPRB &
  &, 0.274796E+00_JPRB, 0.263713E+00_JPRB, 0.252901E+00_JPRB, 0.242372E+00_JPRB &
  &, 0.232086E+00_JPRB, 0.222079E+00_JPRB, 0.212331E+00_JPRB &
  &, 0.202850E+00_JPRB, 0.193668E+00_JPRB, 0.184763E+00_JPRB, 0.176107E+00_JPRB &
  &, 0.167731E+00_JPRB, 0.159666E+00_JPRB, 0.151848E+00_JPRB &
  &, 0.144276E+00_JPRB, 0.137005E+00_JPRB, 0.130001E+00_JPRB, 0.123254E+00_JPRB &
  &, 0.116757E+00_JPRB, 0.110498E+00_JPRB, 0.104534E+00_JPRB &
  &, 0.987839E-01_JPRB, 0.933028E-01_JPRB, 0.880391E-01_JPRB, 0.830117E-01_JPRB &
  &, 0.782017E-01_JPRB, 0.735881E-01_JPRB, 0.692267E-01_JPRB &
  &, 0.650558E-01_JPRB, 0.610904E-01_JPRB, 0.573462E-01_JPRB, 0.537543E-01_JPRB &
  &, 0.503698E-01_JPRB, 0.471199E-01_JPRB, 0.441036E-01_JPRB &
  &, 0.412010E-01_JPRB, 0.384667E-01_JPRB, 0.359117E-01_JPRB, 0.334537E-01_JPRB &
  &, 0.311951E-01_JPRB, 0.290028E-01_JPRB, 0.269803E-01_JPRB &
  &, 0.250877E-01_JPRB, 0.232825E-01_JPRB, 0.216218E-01_JPRB, 0.200097E-01_JPRB &
  &, 0.185556E-01_JPRB, 0.171609E-01_JPRB, 0.158838E-01_JPRB &
  &, 0.146757E-01_JPRB, 0.135407E-01_JPRB, 0.124831E-01_JPRB, 0.115071E-01_JPRB &
  &, 0.106172E-01_JPRB, 0.975871E-02_JPRB, 0.899361E-02_JPRB &
  &, 0.826579E-02_JPRB, 0.757744E-02_JPRB, 0.693079E-02_JPRB, 0.632809E-02_JPRB &
  &, 0.583567E-02_JPRB, 0.532866E-02_JPRB, 0.487262E-02_JPRB/)
XCW( 564, :) = (/ &
  &  0.101272E+01_JPRB, 0.101487E+01_JPRB, 0.101660E+01_JPRB, 0.101791E+01_JPRB &
  &, 0.101879E+01_JPRB, 0.101926E+01_JPRB, 0.101929E+01_JPRB &
  &, 0.101891E+01_JPRB, 0.101809E+01_JPRB, 0.101685E+01_JPRB, 0.101518E+01_JPRB &
  &, 0.101309E+01_JPRB, 0.101056E+01_JPRB, 0.100761E+01_JPRB &
  &, 0.100424E+01_JPRB, 0.100043E+01_JPRB, 0.996211E+00_JPRB, 0.991565E+00_JPRB &
  &, 0.986498E+00_JPRB, 0.981015E+00_JPRB, 0.975120E+00_JPRB &
  &, 0.968817E+00_JPRB, 0.962104E+00_JPRB, 0.954995E+00_JPRB, 0.947486E+00_JPRB &
  &, 0.939590E+00_JPRB, 0.931305E+00_JPRB, 0.922649E+00_JPRB &
  &, 0.913619E+00_JPRB, 0.904227E+00_JPRB, 0.894478E+00_JPRB, 0.884386E+00_JPRB &
  &, 0.873963E+00_JPRB, 0.863210E+00_JPRB, 0.852144E+00_JPRB &
  &, 0.840773E+00_JPRB, 0.829105E+00_JPRB, 0.817168E+00_JPRB, 0.804957E+00_JPRB &
  &, 0.792486E+00_JPRB, 0.779787E+00_JPRB, 0.766852E+00_JPRB &
  &, 0.753709E+00_JPRB, 0.740356E+00_JPRB, 0.726837E+00_JPRB, 0.713131E+00_JPRB &
  &, 0.699288E+00_JPRB, 0.685302E+00_JPRB, 0.671191E+00_JPRB &
  &, 0.656975E+00_JPRB, 0.642664E+00_JPRB, 0.628292E+00_JPRB, 0.613858E+00_JPRB &
  &, 0.599371E+00_JPRB, 0.584871E+00_JPRB, 0.570354E+00_JPRB &
  &, 0.555848E+00_JPRB, 0.541364E+00_JPRB, 0.526913E+00_JPRB, 0.512506E+00_JPRB &
  &, 0.498170E+00_JPRB, 0.483916E+00_JPRB, 0.469753E+00_JPRB &
  &, 0.455708E+00_JPRB, 0.441772E+00_JPRB, 0.427970E+00_JPRB, 0.414328E+00_JPRB &
  &, 0.400832E+00_JPRB, 0.387526E+00_JPRB, 0.374374E+00_JPRB &
  &, 0.361439E+00_JPRB, 0.348680E+00_JPRB, 0.336162E+00_JPRB, 0.323837E+00_JPRB &
  &, 0.311749E+00_JPRB, 0.299891E+00_JPRB, 0.288282E+00_JPRB &
  &, 0.276912E+00_JPRB, 0.265797E+00_JPRB, 0.254950E+00_JPRB, 0.244358E+00_JPRB &
  &, 0.234032E+00_JPRB, 0.223982E+00_JPRB, 0.214189E+00_JPRB &
  &, 0.204688E+00_JPRB, 0.195427E+00_JPRB, 0.186468E+00_JPRB, 0.177786E+00_JPRB &
  &, 0.169381E+00_JPRB, 0.161223E+00_JPRB, 0.153372E+00_JPRB &
  &, 0.145764E+00_JPRB, 0.138456E+00_JPRB, 0.131379E+00_JPRB, 0.124590E+00_JPRB &
  &, 0.118048E+00_JPRB, 0.111777E+00_JPRB, 0.105730E+00_JPRB &
  &, 0.999645E-01_JPRB, 0.943944E-01_JPRB, 0.891121E-01_JPRB, 0.840276E-01_JPRB &
  &, 0.791963E-01_JPRB, 0.745603E-01_JPRB, 0.701359E-01_JPRB &
  &, 0.659396E-01_JPRB, 0.619479E-01_JPRB, 0.581344E-01_JPRB, 0.545130E-01_JPRB &
  &, 0.510978E-01_JPRB, 0.478159E-01_JPRB, 0.447221E-01_JPRB &
  &, 0.418292E-01_JPRB, 0.390590E-01_JPRB, 0.364669E-01_JPRB, 0.340173E-01_JPRB &
  &, 0.316720E-01_JPRB, 0.294868E-01_JPRB, 0.274224E-01_JPRB &
  &, 0.254866E-01_JPRB, 0.236873E-01_JPRB, 0.219812E-01_JPRB, 0.203743E-01_JPRB &
  &, 0.188726E-01_JPRB, 0.174825E-01_JPRB, 0.161556E-01_JPRB &
  &, 0.149514E-01_JPRB, 0.138203E-01_JPRB, 0.127099E-01_JPRB, 0.117371E-01_JPRB &
  &, 0.107921E-01_JPRB, 0.993596E-02_JPRB, 0.917328E-02_JPRB &
  &, 0.838720E-02_JPRB, 0.770049E-02_JPRB, 0.711783E-02_JPRB, 0.651763E-02_JPRB &
  &, 0.596371E-02_JPRB, 0.545839E-02_JPRB, 0.500405E-02_JPRB/)
XCW( 565, :) = (/ &
  &  0.101298E+01_JPRB, 0.101519E+01_JPRB, 0.101698E+01_JPRB, 0.101836E+01_JPRB &
  &, 0.101931E+01_JPRB, 0.101984E+01_JPRB, 0.101994E+01_JPRB &
  &, 0.101962E+01_JPRB, 0.101887E+01_JPRB, 0.101769E+01_JPRB, 0.101609E+01_JPRB &
  &, 0.101405E+01_JPRB, 0.101159E+01_JPRB, 0.100871E+01_JPRB &
  &, 0.100539E+01_JPRB, 0.100165E+01_JPRB, 0.997488E+00_JPRB, 0.992901E+00_JPRB &
  &, 0.987896E+00_JPRB, 0.982474E+00_JPRB, 0.976635E+00_JPRB &
  &, 0.970388E+00_JPRB, 0.963735E+00_JPRB, 0.956678E+00_JPRB, 0.949227E+00_JPRB &
  &, 0.941383E+00_JPRB, 0.933153E+00_JPRB, 0.924545E+00_JPRB &
  &, 0.915558E+00_JPRB, 0.906222E+00_JPRB, 0.896523E+00_JPRB, 0.886479E+00_JPRB &
  &, 0.876095E+00_JPRB, 0.865387E+00_JPRB, 0.854362E+00_JPRB &
  &, 0.843033E+00_JPRB, 0.831403E+00_JPRB, 0.819496E+00_JPRB, 0.807323E+00_JPRB &
  &, 0.794891E+00_JPRB, 0.782210E+00_JPRB, 0.769315E+00_JPRB &
  &, 0.756190E+00_JPRB, 0.742876E+00_JPRB, 0.729373E+00_JPRB, 0.715694E+00_JPRB &
  &, 0.701866E+00_JPRB, 0.687893E+00_JPRB, 0.673795E+00_JPRB &
  &, 0.659590E+00_JPRB, 0.645302E+00_JPRB, 0.630925E+00_JPRB, 0.616497E+00_JPRB &
  &, 0.602030E+00_JPRB, 0.587519E+00_JPRB, 0.573004E+00_JPRB &
  &, 0.558498E+00_JPRB, 0.543996E+00_JPRB, 0.529541E+00_JPRB, 0.515128E+00_JPRB &
  &, 0.500784E+00_JPRB, 0.486520E+00_JPRB, 0.472344E+00_JPRB &
  &, 0.458267E+00_JPRB, 0.444313E+00_JPRB, 0.430510E+00_JPRB, 0.416827E+00_JPRB &
  &, 0.403326E+00_JPRB, 0.389973E+00_JPRB, 0.376811E+00_JPRB &
  &, 0.363822E+00_JPRB, 0.351049E+00_JPRB, 0.338492E+00_JPRB, 0.326126E+00_JPRB &
  &, 0.314016E+00_JPRB, 0.302111E+00_JPRB, 0.290451E+00_JPRB &
  &, 0.279052E+00_JPRB, 0.267906E+00_JPRB, 0.256999E+00_JPRB, 0.246370E+00_JPRB &
  &, 0.236005E+00_JPRB, 0.225886E+00_JPRB, 0.216075E+00_JPRB &
  &, 0.206498E+00_JPRB, 0.197215E+00_JPRB, 0.188203E+00_JPRB, 0.179464E+00_JPRB &
  &, 0.170970E+00_JPRB, 0.162842E+00_JPRB, 0.154928E+00_JPRB &
  &, 0.147284E+00_JPRB, 0.139906E+00_JPRB, 0.132790E+00_JPRB, 0.125959E+00_JPRB &
  &, 0.119373E+00_JPRB, 0.113022E+00_JPRB, 0.106961E+00_JPRB &
  &, 0.101145E+00_JPRB, 0.955587E-01_JPRB, 0.901852E-01_JPRB, 0.850811E-01_JPRB &
  &, 0.801909E-01_JPRB, 0.755325E-01_JPRB, 0.710450E-01_JPRB &
  &, 0.668235E-01_JPRB, 0.627644E-01_JPRB, 0.589227E-01_JPRB, 0.552718E-01_JPRB &
  &, 0.518258E-01_JPRB, 0.485119E-01_JPRB, 0.454290E-01_JPRB &
  &, 0.424574E-01_JPRB, 0.396513E-01_JPRB, 0.370221E-01_JPRB, 0.345340E-01_JPRB &
  &, 0.321965E-01_JPRB, 0.299708E-01_JPRB, 0.279136E-01_JPRB &
  &, 0.259353E-01_JPRB, 0.240920E-01_JPRB, 0.223918E-01_JPRB, 0.207388E-01_JPRB &
  &, 0.192425E-01_JPRB, 0.178040E-01_JPRB, 0.164818E-01_JPRB &
  &, 0.152271E-01_JPRB, 0.140439E-01_JPRB, 0.129934E-01_JPRB, 0.119670E-01_JPRB &
  &, 0.110252E-01_JPRB, 0.101723E-01_JPRB, 0.935296E-02_JPRB &
  &, 0.856931E-02_JPRB, 0.788506E-02_JPRB, 0.724253E-02_JPRB, 0.664400E-02_JPRB &
  &, 0.609174E-02_JPRB, 0.558811E-02_JPRB, 0.506976E-02_JPRB/)
XCW( 566, :) = (/ &
  &  0.101324E+01_JPRB, 0.101551E+01_JPRB, 0.101737E+01_JPRB, 0.101881E+01_JPRB &
  &, 0.101982E+01_JPRB, 0.102042E+01_JPRB, 0.102058E+01_JPRB &
  &, 0.102033E+01_JPRB, 0.101964E+01_JPRB, 0.101853E+01_JPRB, 0.101699E+01_JPRB &
  &, 0.101502E+01_JPRB, 0.101262E+01_JPRB, 0.100980E+01_JPRB &
  &, 0.100655E+01_JPRB, 0.100287E+01_JPRB, 0.998766E+00_JPRB, 0.994241E+00_JPRB &
  &, 0.989296E+00_JPRB, 0.983930E+00_JPRB, 0.978152E+00_JPRB &
  &, 0.971963E+00_JPRB, 0.965366E+00_JPRB, 0.958364E+00_JPRB, 0.950968E+00_JPRB &
  &, 0.943176E+00_JPRB, 0.935001E+00_JPRB, 0.926446E+00_JPRB &
  &, 0.917513E+00_JPRB, 0.908222E+00_JPRB, 0.898568E+00_JPRB, 0.888571E+00_JPRB &
  &, 0.878236E+00_JPRB, 0.867568E+00_JPRB, 0.856584E+00_JPRB &
  &, 0.845293E+00_JPRB, 0.833702E+00_JPRB, 0.821833E+00_JPRB, 0.809699E+00_JPRB &
  &, 0.797296E+00_JPRB, 0.784655E+00_JPRB, 0.771779E+00_JPRB &
  &, 0.758682E+00_JPRB, 0.745396E+00_JPRB, 0.731910E+00_JPRB, 0.718258E+00_JPRB &
  &, 0.704444E+00_JPRB, 0.690498E+00_JPRB, 0.676412E+00_JPRB &
  &, 0.662218E+00_JPRB, 0.647940E+00_JPRB, 0.633585E+00_JPRB, 0.619151E+00_JPRB &
  &, 0.604689E+00_JPRB, 0.590182E+00_JPRB, 0.575669E+00_JPRB &
  &, 0.561148E+00_JPRB, 0.546660E+00_JPRB, 0.532186E+00_JPRB, 0.517767E+00_JPRB &
  &, 0.503415E+00_JPRB, 0.489124E+00_JPRB, 0.474936E+00_JPRB &
  &, 0.460844E+00_JPRB, 0.446892E+00_JPRB, 0.433050E+00_JPRB, 0.419345E+00_JPRB &
  &, 0.405800E+00_JPRB, 0.392439E+00_JPRB, 0.379248E+00_JPRB &
  &, 0.366226E+00_JPRB, 0.353417E+00_JPRB, 0.340822E+00_JPRB, 0.328437E+00_JPRB &
  &, 0.316283E+00_JPRB, 0.303607E+00_JPRB, 0.292645E+00_JPRB &
  &, 0.281217E+00_JPRB, 0.270014E+00_JPRB, 0.259074E+00_JPRB, 0.248382E+00_JPRB &
  &, 0.237977E+00_JPRB, 0.227843E+00_JPRB, 0.217960E+00_JPRB &
  &, 0.208336E+00_JPRB, 0.199031E+00_JPRB, 0.189966E+00_JPRB, 0.181172E+00_JPRB &
  &, 0.172680E+00_JPRB, 0.164430E+00_JPRB, 0.156483E+00_JPRB &
  &, 0.148772E+00_JPRB, 0.141357E+00_JPRB, 0.134200E+00_JPRB, 0.127328E+00_JPRB &
  &, 0.120699E+00_JPRB, 0.114301E+00_JPRB, 0.108192E+00_JPRB &
  &, 0.102326E+00_JPRB, 0.966867E-01_JPRB, 0.912953E-01_JPRB, 0.861346E-01_JPRB &
  &, 0.811855E-01_JPRB, 0.765047E-01_JPRB, 0.719937E-01_JPRB &
  &, 0.677074E-01_JPRB, 0.636218E-01_JPRB, 0.597524E-01_JPRB, 0.560727E-01_JPRB &
  &, 0.525538E-01_JPRB, 0.492514E-01_JPRB, 0.460918E-01_JPRB &
  &, 0.430856E-01_JPRB, 0.402893E-01_JPRB, 0.376235E-01_JPRB, 0.350977E-01_JPRB &
  &, 0.327210E-01_JPRB, 0.304548E-01_JPRB, 0.283558E-01_JPRB &
  &, 0.263840E-01_JPRB, 0.244967E-01_JPRB, 0.227512E-01_JPRB, 0.211034E-01_JPRB &
  &, 0.195595E-01_JPRB, 0.181256E-01_JPRB, 0.168080E-01_JPRB &
  &, 0.155027E-01_JPRB, 0.143235E-01_JPRB, 0.132202E-01_JPRB, 0.121970E-01_JPRB &
  &, 0.112583E-01_JPRB, 0.103495E-01_JPRB, 0.953263E-02_JPRB &
  &, 0.875142E-02_JPRB, 0.806963E-02_JPRB, 0.742958E-02_JPRB, 0.677036E-02_JPRB &
  &, 0.621978E-02_JPRB, 0.571784E-02_JPRB, 0.520118E-02_JPRB/)
XCW( 567, :) = (/ &
  &  0.101349E+01_JPRB, 0.101583E+01_JPRB, 0.101776E+01_JPRB, 0.101926E+01_JPRB &
  &, 0.102034E+01_JPRB, 0.102100E+01_JPRB, 0.102123E+01_JPRB &
  &, 0.102104E+01_JPRB, 0.102042E+01_JPRB, 0.101937E+01_JPRB, 0.101789E+01_JPRB &
  &, 0.101599E+01_JPRB, 0.101365E+01_JPRB, 0.101087E+01_JPRB &
  &, 0.100770E+01_JPRB, 0.100409E+01_JPRB, 0.100005E+01_JPRB, 0.995582E+00_JPRB &
  &, 0.990697E+00_JPRB, 0.985393E+00_JPRB, 0.979673E+00_JPRB &
  &, 0.973541E+00_JPRB, 0.967001E+00_JPRB, 0.960055E+00_JPRB, 0.952712E+00_JPRB &
  &, 0.944977E+00_JPRB, 0.936852E+00_JPRB, 0.928346E+00_JPRB &
  &, 0.919468E+00_JPRB, 0.910225E+00_JPRB, 0.900621E+00_JPRB, 0.890667E+00_JPRB &
  &, 0.880376E+00_JPRB, 0.869754E+00_JPRB, 0.858812E+00_JPRB &
  &, 0.847563E+00_JPRB, 0.836010E+00_JPRB, 0.824179E+00_JPRB, 0.812075E+00_JPRB &
  &, 0.799712E+00_JPRB, 0.787100E+00_JPRB, 0.774252E+00_JPRB &
  &, 0.761185E+00_JPRB, 0.747916E+00_JPRB, 0.734458E+00_JPRB, 0.720834E+00_JPRB &
  &, 0.707035E+00_JPRB, 0.693102E+00_JPRB, 0.679041E+00_JPRB &
  &, 0.664859E+00_JPRB, 0.650591E+00_JPRB, 0.636232E+00_JPRB, 0.621819E+00_JPRB &
  &, 0.607348E+00_JPRB, 0.592859E+00_JPRB, 0.578334E+00_JPRB &
  &, 0.563814E+00_JPRB, 0.549324E+00_JPRB, 0.534846E+00_JPRB, 0.520423E+00_JPRB &
  &, 0.506047E+00_JPRB, 0.491745E+00_JPRB, 0.477545E+00_JPRB &
  &, 0.463439E+00_JPRB, 0.449451E+00_JPRB, 0.435591E+00_JPRB, 0.421882E+00_JPRB &
  &, 0.408313E+00_JPRB, 0.394906E+00_JPRB, 0.381684E+00_JPRB &
  &, 0.368651E+00_JPRB, 0.355808E+00_JPRB, 0.343174E+00_JPRB, 0.330748E+00_JPRB &
  &, 0.318550E+00_JPRB, 0.306575E+00_JPRB, 0.294862E+00_JPRB &
  &, 0.283382E+00_JPRB, 0.272123E+00_JPRB, 0.261148E+00_JPRB, 0.250420E+00_JPRB &
  &, 0.239976E+00_JPRB, 0.229773E+00_JPRB, 0.219846E+00_JPRB &
  &, 0.210201E+00_JPRB, 0.200818E+00_JPRB, 0.191729E+00_JPRB, 0.182880E+00_JPRB &
  &, 0.174330E+00_JPRB, 0.166049E+00_JPRB, 0.158038E+00_JPRB &
  &, 0.150324E+00_JPRB, 0.142840E+00_JPRB, 0.135644E+00_JPRB, 0.128697E+00_JPRB &
  &, 0.122024E+00_JPRB, 0.115614E+00_JPRB, 0.109423E+00_JPRB &
  &, 0.103506E+00_JPRB, 0.978510E-01_JPRB, 0.924054E-01_JPRB, 0.871881E-01_JPRB &
  &, 0.822184E-01_JPRB, 0.774770E-01_JPRB, 0.729425E-01_JPRB &
  &, 0.686315E-01_JPRB, 0.644793E-01_JPRB, 0.605822E-01_JPRB, 0.568314E-01_JPRB &
  &, 0.533246E-01_JPRB, 0.499474E-01_JPRB, 0.467545E-01_JPRB &
  &, 0.437586E-01_JPRB, 0.408816E-01_JPRB, 0.381787E-01_JPRB, 0.356613E-01_JPRB &
  &, 0.332455E-01_JPRB, 0.309872E-01_JPRB, 0.288470E-01_JPRB &
  &, 0.268327E-01_JPRB, 0.249521E-01_JPRB, 0.231619E-01_JPRB, 0.214680E-01_JPRB &
  &, 0.199294E-01_JPRB, 0.184472E-01_JPRB, 0.170798E-01_JPRB &
  &, 0.158335E-01_JPRB, 0.146031E-01_JPRB, 0.135036E-01_JPRB, 0.124269E-01_JPRB &
  &, 0.114914E-01_JPRB, 0.105859E-01_JPRB, 0.971230E-02_JPRB &
  &, 0.893354E-02_JPRB, 0.825420E-02_JPRB, 0.755428E-02_JPRB, 0.695990E-02_JPRB &
  &, 0.634782E-02_JPRB, 0.584756E-02_JPRB, 0.533260E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART81',1,ZHOOK_HANDLE)
END SUBROUTINE PART81

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART82

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART82',0,ZHOOK_HANDLE)

XCW( 568, :) = (/ &
  &  0.101375E+01_JPRB, 0.101616E+01_JPRB, 0.101814E+01_JPRB, 0.101971E+01_JPRB &
  &, 0.102086E+01_JPRB, 0.102158E+01_JPRB, 0.102188E+01_JPRB &
  &, 0.102175E+01_JPRB, 0.102119E+01_JPRB, 0.102021E+01_JPRB, 0.101880E+01_JPRB &
  &, 0.101696E+01_JPRB, 0.101469E+01_JPRB, 0.101199E+01_JPRB &
  &, 0.100886E+01_JPRB, 0.100531E+01_JPRB, 0.100133E+01_JPRB, 0.996925E+00_JPRB &
  &, 0.992101E+00_JPRB, 0.986855E+00_JPRB, 0.981193E+00_JPRB &
  &, 0.975120E+00_JPRB, 0.968636E+00_JPRB, 0.961748E+00_JPRB, 0.954460E+00_JPRB &
  &, 0.946777E+00_JPRB, 0.938707E+00_JPRB, 0.930254E+00_JPRB &
  &, 0.921427E+00_JPRB, 0.912229E+00_JPRB, 0.902675E+00_JPRB, 0.892772E+00_JPRB &
  &, 0.882525E+00_JPRB, 0.871943E+00_JPRB, 0.861043E+00_JPRB &
  &, 0.849832E+00_JPRB, 0.838327E+00_JPRB, 0.826526E+00_JPRB, 0.814461E+00_JPRB &
  &, 0.802127E+00_JPRB, 0.789545E+00_JPRB, 0.776726E+00_JPRB &
  &, 0.763699E+00_JPRB, 0.750448E+00_JPRB, 0.737018E+00_JPRB, 0.723409E+00_JPRB &
  &, 0.709637E+00_JPRB, 0.695718E+00_JPRB, 0.681670E+00_JPRB &
  &, 0.667514E+00_JPRB, 0.653242E+00_JPRB, 0.638906E+00_JPRB, 0.624486E+00_JPRB &
  &, 0.610036E+00_JPRB, 0.595537E+00_JPRB, 0.581015E+00_JPRB &
  &, 0.566495E+00_JPRB, 0.551989E+00_JPRB, 0.537507E+00_JPRB, 0.523078E+00_JPRB &
  &, 0.508695E+00_JPRB, 0.494384E+00_JPRB, 0.480172E+00_JPRB &
  &, 0.466052E+00_JPRB, 0.452048E+00_JPRB, 0.438150E+00_JPRB, 0.424420E+00_JPRB &
  &, 0.410827E+00_JPRB, 0.397393E+00_JPRB, 0.384142E+00_JPRB &
  &, 0.371076E+00_JPRB, 0.358198E+00_JPRB, 0.345548E+00_JPRB, 0.333082E+00_JPRB &
  &, 0.320840E+00_JPRB, 0.308841E+00_JPRB, 0.297079E+00_JPRB &
  &, 0.285546E+00_JPRB, 0.274281E+00_JPRB, 0.263248E+00_JPRB, 0.252484E+00_JPRB &
  &, 0.241975E+00_JPRB, 0.231730E+00_JPRB, 0.221786E+00_JPRB &
  &, 0.212067E+00_JPRB, 0.202663E+00_JPRB, 0.193493E+00_JPRB, 0.184617E+00_JPRB &
  &, 0.176009E+00_JPRB, 0.167699E+00_JPRB, 0.159624E+00_JPRB &
  &, 0.151843E+00_JPRB, 0.144322E+00_JPRB, 0.137088E+00_JPRB, 0.130099E+00_JPRB &
  &, 0.123383E+00_JPRB, 0.116893E+00_JPRB, 0.110689E+00_JPRB &
  &, 0.104723E+00_JPRB, 0.990153E-01_JPRB, 0.935155E-01_JPRB, 0.882792E-01_JPRB &
  &, 0.832513E-01_JPRB, 0.784492E-01_JPRB, 0.738912E-01_JPRB &
  &, 0.695153E-01_JPRB, 0.653775E-01_JPRB, 0.614120E-01_JPRB, 0.576323E-01_JPRB &
  &, 0.540526E-01_JPRB, 0.506869E-01_JPRB, 0.474614E-01_JPRB &
  &, 0.443868E-01_JPRB, 0.415195E-01_JPRB, 0.387802E-01_JPRB, 0.362250E-01_JPRB &
  &, 0.337701E-01_JPRB, 0.314713E-01_JPRB, 0.292892E-01_JPRB &
  &, 0.272814E-01_JPRB, 0.253568E-01_JPRB, 0.235725E-01_JPRB, 0.218847E-01_JPRB &
  &, 0.202992E-01_JPRB, 0.188224E-01_JPRB, 0.174060E-01_JPRB &
  &, 0.161092E-01_JPRB, 0.148826E-01_JPRB, 0.137871E-01_JPRB, 0.127143E-01_JPRB &
  &, 0.117246E-01_JPRB, 0.108222E-01_JPRB, 0.995186E-02_JPRB &
  &, 0.917635E-02_JPRB, 0.843878E-02_JPRB, 0.774133E-02_JPRB, 0.708626E-02_JPRB &
  &, 0.647585E-02_JPRB, 0.597728E-02_JPRB, 0.546402E-02_JPRB/)
XCW( 569, :) = (/ &
  &  0.101401E+01_JPRB, 0.101648E+01_JPRB, 0.101853E+01_JPRB, 0.102016E+01_JPRB &
  &, 0.102137E+01_JPRB, 0.102216E+01_JPRB, 0.102252E+01_JPRB &
  &, 0.102246E+01_JPRB, 0.102197E+01_JPRB, 0.102105E+01_JPRB, 0.101970E+01_JPRB &
  &, 0.101792E+01_JPRB, 0.101572E+01_JPRB, 0.101308E+01_JPRB &
  &, 0.101002E+01_JPRB, 0.100653E+01_JPRB, 0.100261E+01_JPRB, 0.998269E+00_JPRB &
  &, 0.993504E+00_JPRB, 0.988321E+00_JPRB, 0.982717E+00_JPRB &
  &, 0.976701E+00_JPRB, 0.970277E+00_JPRB, 0.963445E+00_JPRB, 0.956211E+00_JPRB &
  &, 0.948585E+00_JPRB, 0.940566E+00_JPRB, 0.932166E+00_JPRB &
  &, 0.923386E+00_JPRB, 0.914240E+00_JPRB, 0.904736E+00_JPRB, 0.894877E+00_JPRB &
  &, 0.884674E+00_JPRB, 0.874142E+00_JPRB, 0.863284E+00_JPRB &
  &, 0.852111E+00_JPRB, 0.840645E+00_JPRB, 0.828883E+00_JPRB, 0.816847E+00_JPRB &
  &, 0.804553E+00_JPRB, 0.792000E+00_JPRB, 0.779222E+00_JPRB &
  &, 0.766213E+00_JPRB, 0.752991E+00_JPRB, 0.739589E+00_JPRB, 0.725997E+00_JPRB &
  &, 0.712240E+00_JPRB, 0.698348E+00_JPRB, 0.684313E+00_JPRB &
  &, 0.670168E+00_JPRB, 0.655907E+00_JPRB, 0.641580E+00_JPRB, 0.627168E+00_JPRB &
  &, 0.612724E+00_JPRB, 0.598229E+00_JPRB, 0.583710E+00_JPRB &
  &, 0.569191E+00_JPRB, 0.554669E+00_JPRB, 0.540184E+00_JPRB, 0.525750E+00_JPRB &
  &, 0.511360E+00_JPRB, 0.497040E+00_JPRB, 0.482799E+00_JPRB &
  &, 0.468665E+00_JPRB, 0.454645E+00_JPRB, 0.440728E+00_JPRB, 0.426977E+00_JPRB &
  &, 0.413360E+00_JPRB, 0.399900E+00_JPRB, 0.386620E+00_JPRB &
  &, 0.373523E+00_JPRB, 0.360609E+00_JPRB, 0.347922E+00_JPRB, 0.335416E+00_JPRB &
  &, 0.323153E+00_JPRB, 0.311108E+00_JPRB, 0.299297E+00_JPRB &
  &, 0.287735E+00_JPRB, 0.276415E+00_JPRB, 0.265348E+00_JPRB, 0.254548E+00_JPRB &
  &, 0.244000E+00_JPRB, 0.233714E+00_JPRB, 0.223699E+00_JPRB &
  &, 0.213961E+00_JPRB, 0.204479E+00_JPRB, 0.195285E+00_JPRB, 0.186355E+00_JPRB &
  &, 0.177719E+00_JPRB, 0.169348E+00_JPRB, 0.161241E+00_JPRB &
  &, 0.153395E+00_JPRB, 0.145837E+00_JPRB, 0.138531E+00_JPRB, 0.131502E+00_JPRB &
  &, 0.124742E+00_JPRB, 0.118242E+00_JPRB, 0.111955E+00_JPRB &
  &, 0.105939E+00_JPRB, 0.100180E+00_JPRB, 0.946625E-01_JPRB, 0.893704E-01_JPRB &
  &, 0.843224E-01_JPRB, 0.794603E-01_JPRB, 0.748399E-01_JPRB &
  &, 0.704394E-01_JPRB, 0.662349E-01_JPRB, 0.622417E-01_JPRB, 0.584332E-01_JPRB &
  &, 0.548234E-01_JPRB, 0.514264E-01_JPRB, 0.481683E-01_JPRB &
  &, 0.450599E-01_JPRB, 0.421574E-01_JPRB, 0.393816E-01_JPRB, 0.367886E-01_JPRB &
  &, 0.342946E-01_JPRB, 0.320037E-01_JPRB, 0.297804E-01_JPRB &
  &, 0.277301E-01_JPRB, 0.258121E-01_JPRB, 0.239832E-01_JPRB, 0.222492E-01_JPRB &
  &, 0.206691E-01_JPRB, 0.191439E-01_JPRB, 0.177321E-01_JPRB &
  &, 0.164400E-01_JPRB, 0.151622E-01_JPRB, 0.140139E-01_JPRB, 0.129443E-01_JPRB &
  &, 0.119577E-01_JPRB, 0.109995E-01_JPRB, 0.101315E-01_JPRB &
  &, 0.935847E-02_JPRB, 0.856182E-02_JPRB, 0.786603E-02_JPRB, 0.721262E-02_JPRB &
  &, 0.666791E-02_JPRB, 0.610701E-02_JPRB, 0.559545E-02_JPRB/)
XCW( 570, :) = (/ &
  &  0.101426E+01_JPRB, 0.101680E+01_JPRB, 0.101892E+01_JPRB, 0.102062E+01_JPRB &
  &, 0.102189E+01_JPRB, 0.102274E+01_JPRB, 0.102317E+01_JPRB &
  &, 0.102317E+01_JPRB, 0.102275E+01_JPRB, 0.102189E+01_JPRB, 0.102061E+01_JPRB &
  &, 0.101890E+01_JPRB, 0.101675E+01_JPRB, 0.101418E+01_JPRB &
  &, 0.101118E+01_JPRB, 0.100775E+01_JPRB, 0.100390E+01_JPRB, 0.999617E+00_JPRB &
  &, 0.994913E+00_JPRB, 0.989787E+00_JPRB, 0.984245E+00_JPRB &
  &, 0.978286E+00_JPRB, 0.971919E+00_JPRB, 0.965142E+00_JPRB, 0.957966E+00_JPRB &
  &, 0.950393E+00_JPRB, 0.942429E+00_JPRB, 0.934078E+00_JPRB &
  &, 0.925353E+00_JPRB, 0.916256E+00_JPRB, 0.906798E+00_JPRB, 0.896986E+00_JPRB &
  &, 0.886832E+00_JPRB, 0.876341E+00_JPRB, 0.865525E+00_JPRB &
  &, 0.854399E+00_JPRB, 0.842962E+00_JPRB, 0.831229E+00_JPRB, 0.819243E+00_JPRB &
  &, 0.806979E+00_JPRB, 0.794466E+00_JPRB, 0.781707E+00_JPRB &
  &, 0.768727E+00_JPRB, 0.755545E+00_JPRB, 0.742160E+00_JPRB, 0.728596E+00_JPRB &
  &, 0.714855E+00_JPRB, 0.700977E+00_JPRB, 0.686955E+00_JPRB &
  &, 0.672822E+00_JPRB, 0.658585E+00_JPRB, 0.644268E+00_JPRB, 0.629864E+00_JPRB &
  &, 0.615412E+00_JPRB, 0.600922E+00_JPRB, 0.586405E+00_JPRB &
  &, 0.571888E+00_JPRB, 0.557364E+00_JPRB, 0.542878E+00_JPRB, 0.528422E+00_JPRB &
  &, 0.514025E+00_JPRB, 0.499696E+00_JPRB, 0.485444E+00_JPRB &
  &, 0.471296E+00_JPRB, 0.457242E+00_JPRB, 0.443325E+00_JPRB, 0.429534E+00_JPRB &
  &, 0.415893E+00_JPRB, 0.402427E+00_JPRB, 0.389118E+00_JPRB &
  &, 0.375990E+00_JPRB, 0.363042E+00_JPRB, 0.350318E+00_JPRB, 0.337794E+00_JPRB &
  &, 0.325466E+00_JPRB, 0.313398E+00_JPRB, 0.301562E+00_JPRB &
  &, 0.289949E+00_JPRB, 0.278573E+00_JPRB, 0.267473E+00_JPRB, 0.256612E+00_JPRB &
  &, 0.246025E+00_JPRB, 0.235698E+00_JPRB, 0.225639E+00_JPRB &
  &, 0.215854E+00_JPRB, 0.206351E+00_JPRB, 0.197106E+00_JPRB, 0.188122E+00_JPRB &
  &, 0.179428E+00_JPRB, 0.170998E+00_JPRB, 0.162858E+00_JPRB &
  &, 0.154978E+00_JPRB, 0.147352E+00_JPRB, 0.140008E+00_JPRB, 0.132938E+00_JPRB &
  &, 0.126101E+00_JPRB, 0.119555E+00_JPRB, 0.113256E+00_JPRB &
  &, 0.107191E+00_JPRB, 0.101380E+00_JPRB, 0.958096E-01_JPRB, 0.904615E-01_JPRB &
  &, 0.853552E-01_JPRB, 0.804714E-01_JPRB, 0.758281E-01_JPRB &
  &, 0.713635E-01_JPRB, 0.671332E-01_JPRB, 0.631130E-01_JPRB, 0.592763E-01_JPRB &
  &, 0.556370E-01_JPRB, 0.521659E-01_JPRB, 0.488752E-01_JPRB &
  &, 0.457329E-01_JPRB, 0.427953E-01_JPRB, 0.399831E-01_JPRB, 0.373523E-01_JPRB &
  &, 0.348668E-01_JPRB, 0.324877E-01_JPRB, 0.302717E-01_JPRB &
  &, 0.281788E-01_JPRB, 0.262169E-01_JPRB, 0.243939E-01_JPRB, 0.226659E-01_JPRB &
  &, 0.210389E-01_JPRB, 0.195191E-01_JPRB, 0.180583E-01_JPRB &
  &, 0.167157E-01_JPRB, 0.154977E-01_JPRB, 0.142974E-01_JPRB, 0.132317E-01_JPRB &
  &, 0.121908E-01_JPRB, 0.112358E-01_JPRB, 0.103711E-01_JPRB &
  &, 0.954058E-02_JPRB, 0.874639E-02_JPRB, 0.805308E-02_JPRB, 0.740217E-02_JPRB &
  &, 0.679595E-02_JPRB, 0.623673E-02_JPRB, 0.572687E-02_JPRB/)
XCW( 571, :) = (/ &
  &  0.101452E+01_JPRB, 0.101712E+01_JPRB, 0.101930E+01_JPRB, 0.102107E+01_JPRB &
  &, 0.102241E+01_JPRB, 0.102333E+01_JPRB, 0.102382E+01_JPRB &
  &, 0.102389E+01_JPRB, 0.102352E+01_JPRB, 0.102274E+01_JPRB, 0.102152E+01_JPRB &
  &, 0.101987E+01_JPRB, 0.101779E+01_JPRB, 0.101528E+01_JPRB &
  &, 0.101234E+01_JPRB, 0.100898E+01_JPRB, 0.100518E+01_JPRB, 0.100096E+01_JPRB &
  &, 0.996321E+00_JPRB, 0.991255E+00_JPRB, 0.985772E+00_JPRB &
  &, 0.979874E+00_JPRB, 0.973564E+00_JPRB, 0.966843E+00_JPRB, 0.959724E+00_JPRB &
  &, 0.952204E+00_JPRB, 0.944292E+00_JPRB, 0.935998E+00_JPRB &
  &, 0.927320E+00_JPRB, 0.918275E+00_JPRB, 0.908864E+00_JPRB, 0.899103E+00_JPRB &
  &, 0.888989E+00_JPRB, 0.878544E+00_JPRB, 0.867775E+00_JPRB &
  &, 0.856687E+00_JPRB, 0.845289E+00_JPRB, 0.833606E+00_JPRB, 0.821649E+00_JPRB &
  &, 0.809415E+00_JPRB, 0.796932E+00_JPRB, 0.784213E+00_JPRB &
  &, 0.771263E+00_JPRB, 0.758099E+00_JPRB, 0.744731E+00_JPRB, 0.731196E+00_JPRB &
  &, 0.717482E+00_JPRB, 0.703618E+00_JPRB, 0.689623E+00_JPRB &
  &, 0.675503E+00_JPRB, 0.661277E+00_JPRB, 0.646955E+00_JPRB, 0.632560E+00_JPRB &
  &, 0.618114E+00_JPRB, 0.603629E+00_JPRB, 0.589116E+00_JPRB &
  &, 0.574600E+00_JPRB, 0.560076E+00_JPRB, 0.545587E+00_JPRB, 0.531111E+00_JPRB &
  &, 0.516707E+00_JPRB, 0.502369E+00_JPRB, 0.488106E+00_JPRB &
  &, 0.473927E+00_JPRB, 0.459857E+00_JPRB, 0.445922E+00_JPRB, 0.432111E+00_JPRB &
  &, 0.418446E+00_JPRB, 0.404954E+00_JPRB, 0.391617E+00_JPRB &
  &, 0.378457E+00_JPRB, 0.365476E+00_JPRB, 0.352714E+00_JPRB, 0.340150E+00_JPRB &
  &, 0.327802E+00_JPRB, 0.315688E+00_JPRB, 0.303803E+00_JPRB &
  &, 0.292162E+00_JPRB, 0.280756E+00_JPRB, 0.269623E+00_JPRB, 0.258727E+00_JPRB &
  &, 0.248077E+00_JPRB, 0.237709E+00_JPRB, 0.227606E+00_JPRB &
  &, 0.217776E+00_JPRB, 0.208196E+00_JPRB, 0.198928E+00_JPRB, 0.189889E+00_JPRB &
  &, 0.181138E+00_JPRB, 0.172677E+00_JPRB, 0.164476E+00_JPRB &
  &, 0.156562E+00_JPRB, 0.148900E+00_JPRB, 0.141484E+00_JPRB, 0.134373E+00_JPRB &
  &, 0.127494E+00_JPRB, 0.120904E+00_JPRB, 0.114558E+00_JPRB &
  &, 0.108443E+00_JPRB, 0.102581E+00_JPRB, 0.969567E-01_JPRB, 0.915903E-01_JPRB &
  &, 0.864263E-01_JPRB, 0.815214E-01_JPRB, 0.768164E-01_JPRB &
  &, 0.723277E-01_JPRB, 0.680314E-01_JPRB, 0.639842E-01_JPRB, 0.600772E-01_JPRB &
  &, 0.564078E-01_JPRB, 0.529053E-01_JPRB, 0.495821E-01_JPRB &
  &, 0.464508E-01_JPRB, 0.434332E-01_JPRB, 0.406308E-01_JPRB, 0.379629E-01_JPRB &
  &, 0.354390E-01_JPRB, 0.330201E-01_JPRB, 0.308121E-01_JPRB &
  &, 0.286774E-01_JPRB, 0.266722E-01_JPRB, 0.248046E-01_JPRB, 0.230305E-01_JPRB &
  &, 0.214088E-01_JPRB, 0.198407E-01_JPRB, 0.183845E-01_JPRB &
  &, 0.170465E-01_JPRB, 0.157772E-01_JPRB, 0.145809E-01_JPRB, 0.134616E-01_JPRB &
  &, 0.124239E-01_JPRB, 0.114721E-01_JPRB, 0.105508E-01_JPRB &
  &, 0.972269E-02_JPRB, 0.893097E-02_JPRB, 0.824013E-02_JPRB, 0.759171E-02_JPRB &
  &, 0.692398E-02_JPRB, 0.636645E-02_JPRB, 0.585829E-02_JPRB/)
XCW( 572, :) = (/ &
  &  0.101478E+01_JPRB, 0.101744E+01_JPRB, 0.101969E+01_JPRB, 0.102152E+01_JPRB &
  &, 0.102293E+01_JPRB, 0.102391E+01_JPRB, 0.102447E+01_JPRB &
  &, 0.102460E+01_JPRB, 0.102430E+01_JPRB, 0.102358E+01_JPRB, 0.102243E+01_JPRB &
  &, 0.102084E+01_JPRB, 0.101883E+01_JPRB, 0.101638E+01_JPRB &
  &, 0.101351E+01_JPRB, 0.101020E+01_JPRB, 0.100647E+01_JPRB, 0.100231E+01_JPRB &
  &, 0.997732E+00_JPRB, 0.992728E+00_JPRB, 0.987302E+00_JPRB &
  &, 0.981462E+00_JPRB, 0.975208E+00_JPRB, 0.968547E+00_JPRB, 0.961483E+00_JPRB &
  &, 0.954019E+00_JPRB, 0.946162E+00_JPRB, 0.937917E+00_JPRB &
  &, 0.929294E+00_JPRB, 0.920299E+00_JPRB, 0.910938E+00_JPRB, 0.901221E+00_JPRB &
  &, 0.891156E+00_JPRB, 0.880756E+00_JPRB, 0.870024E+00_JPRB &
  &, 0.858975E+00_JPRB, 0.847625E+00_JPRB, 0.835982E+00_JPRB, 0.824055E+00_JPRB &
  &, 0.811861E+00_JPRB, 0.799409E+00_JPRB, 0.786720E+00_JPRB &
  &, 0.773799E+00_JPRB, 0.760653E+00_JPRB, 0.747326E+00_JPRB, 0.733807E+00_JPRB &
  &, 0.720109E+00_JPRB, 0.706273E+00_JPRB, 0.692278E+00_JPRB &
  &, 0.678183E+00_JPRB, 0.663969E+00_JPRB, 0.649657E+00_JPRB, 0.635270E+00_JPRB &
  &, 0.620831E+00_JPRB, 0.606351E+00_JPRB, 0.591841E+00_JPRB &
  &, 0.577312E+00_JPRB, 0.562788E+00_JPRB, 0.548297E+00_JPRB, 0.533816E+00_JPRB &
  &, 0.519406E+00_JPRB, 0.505043E+00_JPRB, 0.490769E+00_JPRB &
  &, 0.476577E+00_JPRB, 0.462491E+00_JPRB, 0.448538E+00_JPRB, 0.434706E+00_JPRB &
  &, 0.421019E+00_JPRB, 0.407481E+00_JPRB, 0.394116E+00_JPRB &
  &, 0.380925E+00_JPRB, 0.367930E+00_JPRB, 0.355132E+00_JPRB, 0.342551E+00_JPRB &
  &, 0.330161E+00_JPRB, 0.318002E+00_JPRB, 0.306092E+00_JPRB &
  &, 0.294399E+00_JPRB, 0.282964E+00_JPRB, 0.271774E+00_JPRB, 0.260816E+00_JPRB &
  &, 0.250154E+00_JPRB, 0.239720E+00_JPRB, 0.229574E+00_JPRB &
  &, 0.219697E+00_JPRB, 0.210097E+00_JPRB, 0.200749E+00_JPRB, 0.191685E+00_JPRB &
  &, 0.182878E+00_JPRB, 0.174357E+00_JPRB, 0.166124E+00_JPRB &
  &, 0.158145E+00_JPRB, 0.150447E+00_JPRB, 0.142993E+00_JPRB, 0.135809E+00_JPRB &
  &, 0.128921E+00_JPRB, 0.122252E+00_JPRB, 0.115859E+00_JPRB &
  &, 0.109695E+00_JPRB, 0.103782E+00_JPRB, 0.981408E-01_JPRB, 0.927190E-01_JPRB &
  &, 0.875357E-01_JPRB, 0.825714E-01_JPRB, 0.778046E-01_JPRB &
  &, 0.732919E-01_JPRB, 0.689705E-01_JPRB, 0.648554E-01_JPRB, 0.609202E-01_JPRB &
  &, 0.572215E-01_JPRB, 0.536883E-01_JPRB, 0.502890E-01_JPRB &
  &, 0.471239E-01_JPRB, 0.441167E-01_JPRB, 0.412322E-01_JPRB, 0.385266E-01_JPRB &
  &, 0.360112E-01_JPRB, 0.335525E-01_JPRB, 0.313033E-01_JPRB &
  &, 0.291759E-01_JPRB, 0.271275E-01_JPRB, 0.252666E-01_JPRB, 0.234471E-01_JPRB &
  &, 0.217786E-01_JPRB, 0.202159E-01_JPRB, 0.187107E-01_JPRB &
  &, 0.173773E-01_JPRB, 0.160568E-01_JPRB, 0.148643E-01_JPRB, 0.137491E-01_JPRB &
  &, 0.126571E-01_JPRB, 0.117085E-01_JPRB, 0.107903E-01_JPRB &
  &, 0.996551E-02_JPRB, 0.911554E-02_JPRB, 0.842717E-02_JPRB, 0.771807E-02_JPRB &
  &, 0.711604E-02_JPRB, 0.649618E-02_JPRB, 0.598971E-02_JPRB/)
XCW( 573, :) = (/ &
  &  0.101504E+01_JPRB, 0.101777E+01_JPRB, 0.102008E+01_JPRB, 0.102197E+01_JPRB &
  &, 0.102345E+01_JPRB, 0.102449E+01_JPRB, 0.102512E+01_JPRB &
  &, 0.102531E+01_JPRB, 0.102508E+01_JPRB, 0.102442E+01_JPRB, 0.102333E+01_JPRB &
  &, 0.102181E+01_JPRB, 0.101986E+01_JPRB, 0.101748E+01_JPRB &
  &, 0.101467E+01_JPRB, 0.101143E+01_JPRB, 0.100776E+01_JPRB, 0.100367E+01_JPRB &
  &, 0.999145E+00_JPRB, 0.994200E+00_JPRB, 0.988836E+00_JPRB &
  &, 0.983053E+00_JPRB, 0.976860E+00_JPRB, 0.970254E+00_JPRB, 0.963245E+00_JPRB &
  &, 0.955838E+00_JPRB, 0.948032E+00_JPRB, 0.939844E+00_JPRB &
  &, 0.931269E+00_JPRB, 0.922326E+00_JPRB, 0.913011E+00_JPRB, 0.903342E+00_JPRB &
  &, 0.893326E+00_JPRB, 0.882968E+00_JPRB, 0.872283E+00_JPRB &
  &, 0.861273E+00_JPRB, 0.849962E+00_JPRB, 0.838358E+00_JPRB, 0.826471E+00_JPRB &
  &, 0.814308E+00_JPRB, 0.801896E+00_JPRB, 0.789226E+00_JPRB &
  &, 0.776335E+00_JPRB, 0.763230E+00_JPRB, 0.749920E+00_JPRB, 0.736418E+00_JPRB &
  &, 0.722748E+00_JPRB, 0.708927E+00_JPRB, 0.694959E+00_JPRB &
  &, 0.680864E+00_JPRB, 0.666661E+00_JPRB, 0.652372E+00_JPRB, 0.637994E+00_JPRB &
  &, 0.623562E+00_JPRB, 0.609088E+00_JPRB, 0.594567E+00_JPRB &
  &, 0.580039E+00_JPRB, 0.565515E+00_JPRB, 0.551006E+00_JPRB, 0.536538E+00_JPRB &
  &, 0.522105E+00_JPRB, 0.507733E+00_JPRB, 0.493449E+00_JPRB &
  &, 0.479244E+00_JPRB, 0.465144E+00_JPRB, 0.451155E+00_JPRB, 0.437302E+00_JPRB &
  &, 0.423592E+00_JPRB, 0.410049E+00_JPRB, 0.396656E+00_JPRB &
  &, 0.383434E+00_JPRB, 0.370406E+00_JPRB, 0.357572E+00_JPRB, 0.344929E+00_JPRB &
  &, 0.332519E+00_JPRB, 0.320338E+00_JPRB, 0.308380E+00_JPRB &
  &, 0.296637E+00_JPRB, 0.285172E+00_JPRB, 0.273924E+00_JPRB, 0.262958E+00_JPRB &
  &, 0.252232E+00_JPRB, 0.241757E+00_JPRB, 0.231568E+00_JPRB &
  &, 0.221647E+00_JPRB, 0.211970E+00_JPRB, 0.202599E+00_JPRB, 0.193481E+00_JPRB &
  &, 0.184647E+00_JPRB, 0.176068E+00_JPRB, 0.167773E+00_JPRB &
  &, 0.159760E+00_JPRB, 0.151994E+00_JPRB, 0.144502E+00_JPRB, 0.137278E+00_JPRB &
  &, 0.130314E+00_JPRB, 0.123635E+00_JPRB, 0.117160E+00_JPRB &
  &, 0.110983E+00_JPRB, 0.105019E+00_JPRB, 0.993249E-01_JPRB, 0.938478E-01_JPRB &
  &, 0.886068E-01_JPRB, 0.836214E-01_JPRB, 0.788324E-01_JPRB &
  &, 0.742562E-01_JPRB, 0.699095E-01_JPRB, 0.657267E-01_JPRB, 0.617632E-01_JPRB &
  &, 0.580351E-01_JPRB, 0.544278E-01_JPRB, 0.510401E-01_JPRB &
  &, 0.478418E-01_JPRB, 0.447546E-01_JPRB, 0.418799E-01_JPRB, 0.391372E-01_JPRB &
  &, 0.365834E-01_JPRB, 0.341334E-01_JPRB, 0.317946E-01_JPRB &
  &, 0.296246E-01_JPRB, 0.275829E-01_JPRB, 0.256772E-01_JPRB, 0.238638E-01_JPRB &
  &, 0.221485E-01_JPRB, 0.205911E-01_JPRB, 0.190912E-01_JPRB &
  &, 0.177081E-01_JPRB, 0.163923E-01_JPRB, 0.151478E-01_JPRB, 0.139790E-01_JPRB &
  &, 0.129485E-01_JPRB, 0.119448E-01_JPRB, 0.110299E-01_JPRB &
  &, 0.101476E-01_JPRB, 0.936163E-02_JPRB, 0.861422E-02_JPRB, 0.790761E-02_JPRB &
  &, 0.724407E-02_JPRB, 0.662590E-02_JPRB, 0.612114E-02_JPRB/)
XCW( 574, :) = (/ &
  &  0.101529E+01_JPRB, 0.101809E+01_JPRB, 0.102047E+01_JPRB, 0.102243E+01_JPRB &
  &, 0.102396E+01_JPRB, 0.102508E+01_JPRB, 0.102577E+01_JPRB &
  &, 0.102603E+01_JPRB, 0.102586E+01_JPRB, 0.102527E+01_JPRB, 0.102425E+01_JPRB &
  &, 0.102279E+01_JPRB, 0.102090E+01_JPRB, 0.101859E+01_JPRB &
  &, 0.101584E+01_JPRB, 0.101266E+01_JPRB, 0.100905E+01_JPRB, 0.100502E+01_JPRB &
  &, 0.100056E+01_JPRB, 0.995675E+00_JPRB, 0.990373E+00_JPRB &
  &, 0.984648E+00_JPRB, 0.978512E+00_JPRB, 0.971965E+00_JPRB, 0.965011E+00_JPRB &
  &, 0.957657E+00_JPRB, 0.949909E+00_JPRB, 0.941771E+00_JPRB &
  &, 0.933251E+00_JPRB, 0.924354E+00_JPRB, 0.915094E+00_JPRB, 0.905472E+00_JPRB &
  &, 0.895501E+00_JPRB, 0.885189E+00_JPRB, 0.874547E+00_JPRB &
  &, 0.863580E+00_JPRB, 0.852308E+00_JPRB, 0.840744E+00_JPRB, 0.828888E+00_JPRB &
  &, 0.816764E+00_JPRB, 0.804383E+00_JPRB, 0.791754E+00_JPRB &
  &, 0.778882E+00_JPRB, 0.765807E+00_JPRB, 0.752515E+00_JPRB, 0.739041E+00_JPRB &
  &, 0.725400E+00_JPRB, 0.711594E+00_JPRB, 0.697640E+00_JPRB &
  &, 0.683557E+00_JPRB, 0.669379E+00_JPRB, 0.655088E+00_JPRB, 0.640732E+00_JPRB &
  &, 0.626293E+00_JPRB, 0.611825E+00_JPRB, 0.597308E+00_JPRB &
  &, 0.582782E+00_JPRB, 0.568259E+00_JPRB, 0.553748E+00_JPRB, 0.539260E+00_JPRB &
  &, 0.524821E+00_JPRB, 0.510441E+00_JPRB, 0.496130E+00_JPRB &
  &, 0.481912E+00_JPRB, 0.467796E+00_JPRB, 0.453809E+00_JPRB, 0.439917E+00_JPRB &
  &, 0.426185E+00_JPRB, 0.412596E+00_JPRB, 0.399196E+00_JPRB &
  &, 0.385944E+00_JPRB, 0.372883E+00_JPRB, 0.360012E+00_JPRB, 0.347353E+00_JPRB &
  &, 0.334901E+00_JPRB, 0.322675E+00_JPRB, 0.310669E+00_JPRB &
  &, 0.298899E+00_JPRB, 0.287379E+00_JPRB, 0.276100E+00_JPRB, 0.265073E+00_JPRB &
  &, 0.254310E+00_JPRB, 0.243822E+00_JPRB, 0.233563E+00_JPRB &
  &, 0.223596E+00_JPRB, 0.213899E+00_JPRB, 0.204449E+00_JPRB, 0.195307E+00_JPRB &
  &, 0.186417E+00_JPRB, 0.177778E+00_JPRB, 0.169452E+00_JPRB &
  &, 0.161375E+00_JPRB, 0.153574E+00_JPRB, 0.146044E+00_JPRB, 0.138748E+00_JPRB &
  &, 0.131741E+00_JPRB, 0.124983E+00_JPRB, 0.118497E+00_JPRB &
  &, 0.112271E+00_JPRB, 0.106256E+00_JPRB, 0.100509E+00_JPRB, 0.950142E-01_JPRB &
  &, 0.897162E-01_JPRB, 0.846715E-01_JPRB, 0.798602E-01_JPRB &
  &, 0.752204E-01_JPRB, 0.708486E-01_JPRB, 0.666394E-01_JPRB, 0.626484E-01_JPRB &
  &, 0.588487E-01_JPRB, 0.552108E-01_JPRB, 0.517912E-01_JPRB &
  &, 0.485597E-01_JPRB, 0.454381E-01_JPRB, 0.425276E-01_JPRB, 0.397478E-01_JPRB &
  &, 0.371556E-01_JPRB, 0.346658E-01_JPRB, 0.323350E-01_JPRB &
  &, 0.301232E-01_JPRB, 0.280888E-01_JPRB, 0.261393E-01_JPRB, 0.242805E-01_JPRB &
  &, 0.225712E-01_JPRB, 0.209662E-01_JPRB, 0.194174E-01_JPRB &
  &, 0.179838E-01_JPRB, 0.166718E-01_JPRB, 0.154313E-01_JPRB, 0.142664E-01_JPRB &
  &, 0.131816E-01_JPRB, 0.121811E-01_JPRB, 0.112096E-01_JPRB &
  &, 0.103297E-01_JPRB, 0.954621E-02_JPRB, 0.880127E-02_JPRB, 0.809716E-02_JPRB &
  &, 0.743613E-02_JPRB, 0.682048E-02_JPRB, 0.625256E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART82',1,ZHOOK_HANDLE)
END SUBROUTINE PART82

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART83

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART83',0,ZHOOK_HANDLE)

XCW( 575, :) = (/ &
  &  0.101555E+01_JPRB, 0.101841E+01_JPRB, 0.102086E+01_JPRB, 0.102288E+01_JPRB &
  &, 0.102448E+01_JPRB, 0.102566E+01_JPRB, 0.102642E+01_JPRB &
  &, 0.102675E+01_JPRB, 0.102665E+01_JPRB, 0.102612E+01_JPRB, 0.102516E+01_JPRB &
  &, 0.102376E+01_JPRB, 0.102194E+01_JPRB, 0.101969E+01_JPRB &
  &, 0.101701E+01_JPRB, 0.101389E+01_JPRB, 0.101035E+01_JPRB, 0.100638E+01_JPRB &
  &, 0.100198E+01_JPRB, 0.997153E+00_JPRB, 0.991910E+00_JPRB &
  &, 0.986246E+00_JPRB, 0.980167E+00_JPRB, 0.973676E+00_JPRB, 0.966780E+00_JPRB &
  &, 0.959482E+00_JPRB, 0.951787E+00_JPRB, 0.943702E+00_JPRB &
  &, 0.935234E+00_JPRB, 0.926389E+00_JPRB, 0.917176E+00_JPRB, 0.907602E+00_JPRB &
  &, 0.897676E+00_JPRB, 0.887410E+00_JPRB, 0.876815E+00_JPRB &
  &, 0.865896E+00_JPRB, 0.854664E+00_JPRB, 0.843130E+00_JPRB, 0.831314E+00_JPRB &
  &, 0.819221E+00_JPRB, 0.806870E+00_JPRB, 0.794271E+00_JPRB &
  &, 0.781440E+00_JPRB, 0.768384E+00_JPRB, 0.755133E+00_JPRB, 0.741677E+00_JPRB &
  &, 0.728051E+00_JPRB, 0.714260E+00_JPRB, 0.700334E+00_JPRB &
  &, 0.686264E+00_JPRB, 0.672098E+00_JPRB, 0.657817E+00_JPRB, 0.643470E+00_JPRB &
  &, 0.629039E+00_JPRB, 0.614577E+00_JPRB, 0.600064E+00_JPRB &
  &, 0.585541E+00_JPRB, 0.571002E+00_JPRB, 0.556490E+00_JPRB, 0.541999E+00_JPRB &
  &, 0.527554E+00_JPRB, 0.513167E+00_JPRB, 0.498845E+00_JPRB &
  &, 0.484597E+00_JPRB, 0.470467E+00_JPRB, 0.456444E+00_JPRB, 0.442552E+00_JPRB &
  &, 0.428798E+00_JPRB, 0.415184E+00_JPRB, 0.401735E+00_JPRB &
  &, 0.388474E+00_JPRB, 0.375380E+00_JPRB, 0.362474E+00_JPRB, 0.349776E+00_JPRB &
  &, 0.337283E+00_JPRB, 0.325035E+00_JPRB, 0.312982E+00_JPRB &
  &, 0.301185E+00_JPRB, 0.289612E+00_JPRB, 0.278301E+00_JPRB, 0.267240E+00_JPRB &
  &, 0.256414E+00_JPRB, 0.245859E+00_JPRB, 0.235585E+00_JPRB &
  &, 0.225573E+00_JPRB, 0.215800E+00_JPRB, 0.206328E+00_JPRB, 0.197133E+00_JPRB &
  &, 0.188186E+00_JPRB, 0.179519E+00_JPRB, 0.171132E+00_JPRB &
  &, 0.162990E+00_JPRB, 0.155153E+00_JPRB, 0.147554E+00_JPRB, 0.140250E+00_JPRB &
  &, 0.133202E+00_JPRB, 0.126400E+00_JPRB, 0.119868E+00_JPRB &
  &, 0.113559E+00_JPRB, 0.107530E+00_JPRB, 0.101730E+00_JPRB, 0.961806E-01_JPRB &
  &, 0.908256E-01_JPRB, 0.857603E-01_JPRB, 0.808880E-01_JPRB &
  &, 0.762248E-01_JPRB, 0.717877E-01_JPRB, 0.675521E-01_JPRB, 0.634915E-01_JPRB &
  &, 0.596624E-01_JPRB, 0.560373E-01_JPRB, 0.525423E-01_JPRB &
  &, 0.492777E-01_JPRB, 0.461215E-01_JPRB, 0.431754E-01_JPRB, 0.403585E-01_JPRB &
  &, 0.377278E-01_JPRB, 0.352466E-01_JPRB, 0.328754E-01_JPRB &
  &, 0.306218E-01_JPRB, 0.285441E-01_JPRB, 0.265499E-01_JPRB, 0.246971E-01_JPRB &
  &, 0.229411E-01_JPRB, 0.213414E-01_JPRB, 0.197979E-01_JPRB &
  &, 0.183697E-01_JPRB, 0.170073E-01_JPRB, 0.157148E-01_JPRB, 0.145539E-01_JPRB &
  &, 0.134730E-01_JPRB, 0.124174E-01_JPRB, 0.114491E-01_JPRB &
  &, 0.105726E-01_JPRB, 0.973078E-02_JPRB, 0.898832E-02_JPRB, 0.822352E-02_JPRB &
  &, 0.756417E-02_JPRB, 0.695021E-02_JPRB, 0.638398E-02_JPRB/)
XCW( 576, :) = (/ &
  &  0.101581E+01_JPRB, 0.101874E+01_JPRB, 0.102125E+01_JPRB, 0.102334E+01_JPRB &
  &, 0.102500E+01_JPRB, 0.102625E+01_JPRB, 0.102707E+01_JPRB &
  &, 0.102746E+01_JPRB, 0.102743E+01_JPRB, 0.102696E+01_JPRB, 0.102607E+01_JPRB &
  &, 0.102474E+01_JPRB, 0.102299E+01_JPRB, 0.102080E+01_JPRB &
  &, 0.101818E+01_JPRB, 0.101512E+01_JPRB, 0.101164E+01_JPRB, 0.100773E+01_JPRB &
  &, 0.100340E+01_JPRB, 0.998622E+00_JPRB, 0.993450E+00_JPRB &
  &, 0.987844E+00_JPRB, 0.981825E+00_JPRB, 0.975391E+00_JPRB, 0.968552E+00_JPRB &
  &, 0.961308E+00_JPRB, 0.953668E+00_JPRB, 0.945637E+00_JPRB &
  &, 0.937220E+00_JPRB, 0.928429E+00_JPRB, 0.919266E+00_JPRB, 0.909741E+00_JPRB &
  &, 0.899860E+00_JPRB, 0.889640E+00_JPRB, 0.879087E+00_JPRB &
  &, 0.868202E+00_JPRB, 0.857019E+00_JPRB, 0.845525E+00_JPRB, 0.833750E+00_JPRB &
  &, 0.821698E+00_JPRB, 0.809378E+00_JPRB, 0.796810E+00_JPRB &
  &, 0.784009E+00_JPRB, 0.770983E+00_JPRB, 0.757739E+00_JPRB, 0.744324E+00_JPRB &
  &, 0.730715E+00_JPRB, 0.716952E+00_JPRB, 0.703027E+00_JPRB &
  &, 0.688984E+00_JPRB, 0.674817E+00_JPRB, 0.660560E+00_JPRB, 0.646208E+00_JPRB &
  &, 0.631799E+00_JPRB, 0.617328E+00_JPRB, 0.602820E+00_JPRB &
  &, 0.588299E+00_JPRB, 0.573761E+00_JPRB, 0.559248E+00_JPRB, 0.544754E+00_JPRB &
  &, 0.530287E+00_JPRB, 0.515893E+00_JPRB, 0.501561E+00_JPRB &
  &, 0.487301E+00_JPRB, 0.473157E+00_JPRB, 0.459117E+00_JPRB, 0.445186E+00_JPRB &
  &, 0.431410E+00_JPRB, 0.417772E+00_JPRB, 0.404296E+00_JPRB &
  &, 0.391005E+00_JPRB, 0.377878E+00_JPRB, 0.364958E+00_JPRB, 0.352222E+00_JPRB &
  &, 0.339687E+00_JPRB, 0.327396E+00_JPRB, 0.315318E+00_JPRB &
  &, 0.303471E+00_JPRB, 0.291870E+00_JPRB, 0.280502E+00_JPRB, 0.269407E+00_JPRB &
  &, 0.258544E+00_JPRB, 0.247950E+00_JPRB, 0.237607E+00_JPRB &
  &, 0.227550E+00_JPRB, 0.217758E+00_JPRB, 0.208236E+00_JPRB, 0.198958E+00_JPRB &
  &, 0.189986E+00_JPRB, 0.181260E+00_JPRB, 0.172811E+00_JPRB &
  &, 0.164668E+00_JPRB, 0.156765E+00_JPRB, 0.149129E+00_JPRB, 0.141753E+00_JPRB &
  &, 0.134629E+00_JPRB, 0.127783E+00_JPRB, 0.121205E+00_JPRB &
  &, 0.114883E+00_JPRB, 0.108803E+00_JPRB, 0.102951E+00_JPRB, 0.973470E-01_JPRB &
  &, 0.919732E-01_JPRB, 0.868492E-01_JPRB, 0.819157E-01_JPRB &
  &, 0.772292E-01_JPRB, 0.727267E-01_JPRB, 0.684649E-01_JPRB, 0.643767E-01_JPRB &
  &, 0.605188E-01_JPRB, 0.568203E-01_JPRB, 0.533376E-01_JPRB &
  &, 0.499956E-01_JPRB, 0.468506E-01_JPRB, 0.438231E-01_JPRB, 0.410161E-01_JPRB &
  &, 0.383477E-01_JPRB, 0.357790E-01_JPRB, 0.334158E-01_JPRB &
  &, 0.311702E-01_JPRB, 0.290500E-01_JPRB, 0.270119E-01_JPRB, 0.251659E-01_JPRB &
  &, 0.233637E-01_JPRB, 0.217166E-01_JPRB, 0.201785E-01_JPRB &
  &, 0.187005E-01_JPRB, 0.173428E-01_JPRB, 0.160549E-01_JPRB, 0.148413E-01_JPRB &
  &, 0.137061E-01_JPRB, 0.126538E-01_JPRB, 0.116887E-01_JPRB &
  &, 0.108154E-01_JPRB, 0.991535E-02_JPRB, 0.917537E-02_JPRB, 0.841306E-02_JPRB &
  &, 0.775622E-02_JPRB, 0.714479E-02_JPRB, 0.651540E-02_JPRB/)
XCW( 577, :) = (/ &
  &  0.101607E+01_JPRB, 0.101906E+01_JPRB, 0.102163E+01_JPRB, 0.102379E+01_JPRB &
  &, 0.102552E+01_JPRB, 0.102684E+01_JPRB, 0.102772E+01_JPRB &
  &, 0.102818E+01_JPRB, 0.102821E+01_JPRB, 0.102781E+01_JPRB, 0.102698E+01_JPRB &
  &, 0.102572E+01_JPRB, 0.102403E+01_JPRB, 0.102190E+01_JPRB &
  &, 0.101935E+01_JPRB, 0.101636E+01_JPRB, 0.101294E+01_JPRB, 0.100909E+01_JPRB &
  &, 0.100482E+01_JPRB, 0.100012E+01_JPRB, 0.994990E+00_JPRB &
  &, 0.989446E+00_JPRB, 0.983484E+00_JPRB, 0.977109E+00_JPRB, 0.970328E+00_JPRB &
  &, 0.963127E+00_JPRB, 0.955553E+00_JPRB, 0.947576E+00_JPRB &
  &, 0.939214E+00_JPRB, 0.930472E+00_JPRB, 0.921356E+00_JPRB, 0.911879E+00_JPRB &
  &, 0.902043E+00_JPRB, 0.891874E+00_JPRB, 0.881364E+00_JPRB &
  &, 0.870528E+00_JPRB, 0.859375E+00_JPRB, 0.847931E+00_JPRB, 0.836186E+00_JPRB &
  &, 0.824165E+00_JPRB, 0.811886E+00_JPRB, 0.799349E+00_JPRB &
  &, 0.786579E+00_JPRB, 0.773571E+00_JPRB, 0.760369E+00_JPRB, 0.746971E+00_JPRB &
  &, 0.733379E+00_JPRB, 0.719631E+00_JPRB, 0.705695E+00_JPRB &
  &, 0.691704E+00_JPRB, 0.677562E+00_JPRB, 0.663303E+00_JPRB, 0.648975E+00_JPRB &
  &, 0.634560E+00_JPRB, 0.620095E+00_JPRB, 0.605591E+00_JPRB &
  &, 0.591073E+00_JPRB, 0.576536E+00_JPRB, 0.562006E+00_JPRB, 0.547509E+00_JPRB &
  &, 0.533037E+00_JPRB, 0.518635E+00_JPRB, 0.504277E+00_JPRB &
  &, 0.490023E+00_JPRB, 0.475846E+00_JPRB, 0.461790E+00_JPRB, 0.447840E+00_JPRB &
  &, 0.434042E+00_JPRB, 0.420380E+00_JPRB, 0.406877E+00_JPRB &
  &, 0.393556E+00_JPRB, 0.380397E+00_JPRB, 0.367442E+00_JPRB, 0.354668E+00_JPRB &
  &, 0.342115E+00_JPRB, 0.329779E+00_JPRB, 0.317655E+00_JPRB &
  &, 0.305782E+00_JPRB, 0.294127E+00_JPRB, 0.282728E+00_JPRB, 0.271574E+00_JPRB &
  &, 0.260675E+00_JPRB, 0.250042E+00_JPRB, 0.239657E+00_JPRB &
  &, 0.229555E+00_JPRB, 0.219716E+00_JPRB, 0.210115E+00_JPRB, 0.200814E+00_JPRB &
  &, 0.191786E+00_JPRB, 0.183032E+00_JPRB, 0.174522E+00_JPRB &
  &, 0.166314E+00_JPRB, 0.158377E+00_JPRB, 0.150671E+00_JPRB, 0.143255E+00_JPRB &
  &, 0.136124E+00_JPRB, 0.129235E+00_JPRB, 0.122576E+00_JPRB &
  &, 0.116206E+00_JPRB, 0.110077E+00_JPRB, 0.104172E+00_JPRB, 0.985133E-01_JPRB &
  &, 0.931208E-01_JPRB, 0.879381E-01_JPRB, 0.829830E-01_JPRB &
  &, 0.782337E-01_JPRB, 0.737066E-01_JPRB, 0.693776E-01_JPRB, 0.652619E-01_JPRB &
  &, 0.613753E-01_JPRB, 0.576468E-01_JPRB, 0.540887E-01_JPRB &
  &, 0.507135E-01_JPRB, 0.475341E-01_JPRB, 0.445170E-01_JPRB, 0.416267E-01_JPRB &
  &, 0.389199E-01_JPRB, 0.363599E-01_JPRB, 0.339562E-01_JPRB &
  &, 0.316687E-01_JPRB, 0.295054E-01_JPRB, 0.274740E-01_JPRB, 0.255825E-01_JPRB &
  &, 0.237864E-01_JPRB, 0.220918E-01_JPRB, 0.205046E-01_JPRB &
  &, 0.190313E-01_JPRB, 0.176223E-01_JPRB, 0.163384E-01_JPRB, 0.151287E-01_JPRB &
  &, 0.139975E-01_JPRB, 0.129492E-01_JPRB, 0.119283E-01_JPRB &
  &, 0.109975E-01_JPRB, 0.101614E-01_JPRB, 0.936241E-02_JPRB, 0.860260E-02_JPRB &
  &, 0.788426E-02_JPRB, 0.727452E-02_JPRB, 0.664683E-02_JPRB/)
XCW( 578, :) = (/ &
  &  0.101633E+01_JPRB, 0.101938E+01_JPRB, 0.102202E+01_JPRB, 0.102425E+01_JPRB &
  &, 0.102605E+01_JPRB, 0.102742E+01_JPRB, 0.102837E+01_JPRB &
  &, 0.102890E+01_JPRB, 0.102899E+01_JPRB, 0.102866E+01_JPRB, 0.102790E+01_JPRB &
  &, 0.102670E+01_JPRB, 0.102507E+01_JPRB, 0.102301E+01_JPRB &
  &, 0.102052E+01_JPRB, 0.101758E+01_JPRB, 0.101424E+01_JPRB, 0.101045E+01_JPRB &
  &, 0.100624E+01_JPRB, 0.100160E+01_JPRB, 0.996530E+00_JPRB &
  &, 0.991051E+00_JPRB, 0.985149E+00_JPRB, 0.978830E+00_JPRB, 0.972105E+00_JPRB &
  &, 0.964975E+00_JPRB, 0.957442E+00_JPRB, 0.949518E+00_JPRB &
  &, 0.941208E+00_JPRB, 0.932516E+00_JPRB, 0.923455E+00_JPRB, 0.914026E+00_JPRB &
  &, 0.904244E+00_JPRB, 0.894113E+00_JPRB, 0.883646E+00_JPRB &
  &, 0.872853E+00_JPRB, 0.861673E+00_JPRB, 0.850336E+00_JPRB, 0.838632E+00_JPRB &
  &, 0.826642E+00_JPRB, 0.814394E+00_JPRB, 0.801898E+00_JPRB &
  &, 0.789148E+00_JPRB, 0.776182E+00_JPRB, 0.762998E+00_JPRB, 0.749618E+00_JPRB &
  &, 0.736067E+00_JPRB, 0.722336E+00_JPRB, 0.708453E+00_JPRB &
  &, 0.694437E+00_JPRB, 0.680308E+00_JPRB, 0.666073E+00_JPRB, 0.651741E+00_JPRB &
  &, 0.637334E+00_JPRB, 0.622876E+00_JPRB, 0.608377E+00_JPRB &
  &, 0.593847E+00_JPRB, 0.579312E+00_JPRB, 0.564780E+00_JPRB, 0.550280E+00_JPRB &
  &, 0.535804E+00_JPRB, 0.521378E+00_JPRB, 0.507028E+00_JPRB &
  &, 0.492745E+00_JPRB, 0.478555E+00_JPRB, 0.464482E+00_JPRB, 0.450514E+00_JPRB &
  &, 0.436694E+00_JPRB, 0.423009E+00_JPRB, 0.409479E+00_JPRB &
  &, 0.396108E+00_JPRB, 0.382938E+00_JPRB, 0.369948E+00_JPRB, 0.357136E+00_JPRB &
  &, 0.344542E+00_JPRB, 0.332163E+00_JPRB, 0.320015E+00_JPRB &
  &, 0.308093E+00_JPRB, 0.296409E+00_JPRB, 0.284955E+00_JPRB, 0.273766E+00_JPRB &
  &, 0.262831E+00_JPRB, 0.252133E+00_JPRB, 0.241733E+00_JPRB &
  &, 0.231560E+00_JPRB, 0.221674E+00_JPRB, 0.212052E+00_JPRB, 0.202698E+00_JPRB &
  &, 0.193615E+00_JPRB, 0.184804E+00_JPRB, 0.176263E+00_JPRB &
  &, 0.167993E+00_JPRB, 0.159988E+00_JPRB, 0.152278E+00_JPRB, 0.144791E+00_JPRB &
  &, 0.137585E+00_JPRB, 0.130653E+00_JPRB, 0.123983E+00_JPRB &
  &, 0.117530E+00_JPRB, 0.111350E+00_JPRB, 0.105430E+00_JPRB, 0.997174E-01_JPRB &
  &, 0.942685E-01_JPRB, 0.890270E-01_JPRB, 0.840503E-01_JPRB &
  &, 0.792381E-01_JPRB, 0.746866E-01_JPRB, 0.703318E-01_JPRB, 0.661893E-01_JPRB &
  &, 0.622317E-01_JPRB, 0.584733E-01_JPRB, 0.548840E-01_JPRB &
  &, 0.514763E-01_JPRB, 0.482631E-01_JPRB, 0.452110E-01_JPRB, 0.422843E-01_JPRB &
  &, 0.395398E-01_JPRB, 0.369407E-01_JPRB, 0.344965E-01_JPRB &
  &, 0.322172E-01_JPRB, 0.300113E-01_JPRB, 0.279873E-01_JPRB, 0.260513E-01_JPRB &
  &, 0.242091E-01_JPRB, 0.225205E-01_JPRB, 0.208852E-01_JPRB &
  &, 0.193621E-01_JPRB, 0.179578E-01_JPRB, 0.166786E-01_JPRB, 0.154162E-01_JPRB &
  &, 0.142889E-01_JPRB, 0.131855E-01_JPRB, 0.121678E-01_JPRB &
  &, 0.112403E-01_JPRB, 0.103460E-01_JPRB, 0.954946E-02_JPRB, 0.879215E-02_JPRB &
  &, 0.807631E-02_JPRB, 0.740424E-02_JPRB, 0.684396E-02_JPRB/)
XCW( 579, :) = (/ &
  &  0.101659E+01_JPRB, 0.101971E+01_JPRB, 0.102241E+01_JPRB, 0.102470E+01_JPRB &
  &, 0.102657E+01_JPRB, 0.102801E+01_JPRB, 0.102903E+01_JPRB &
  &, 0.102962E+01_JPRB, 0.102978E+01_JPRB, 0.102951E+01_JPRB, 0.102881E+01_JPRB &
  &, 0.102768E+01_JPRB, 0.102612E+01_JPRB, 0.102412E+01_JPRB &
  &, 0.102169E+01_JPRB, 0.101883E+01_JPRB, 0.101554E+01_JPRB, 0.101182E+01_JPRB &
  &, 0.100766E+01_JPRB, 0.100309E+01_JPRB, 0.998084E+00_JPRB &
  &, 0.992658E+00_JPRB, 0.986814E+00_JPRB, 0.980555E+00_JPRB, 0.973885E+00_JPRB &
  &, 0.966812E+00_JPRB, 0.959334E+00_JPRB, 0.951465E+00_JPRB &
  &, 0.943206E+00_JPRB, 0.934567E+00_JPRB, 0.925553E+00_JPRB, 0.916177E+00_JPRB &
  &, 0.906441E+00_JPRB, 0.896356E+00_JPRB, 0.885936E+00_JPRB &
  &, 0.875188E+00_JPRB, 0.864114E+00_JPRB, 0.852741E+00_JPRB, 0.841079E+00_JPRB &
  &, 0.829130E+00_JPRB, 0.816923E+00_JPRB, 0.804448E+00_JPRB &
  &, 0.791739E+00_JPRB, 0.778793E+00_JPRB, 0.765639E+00_JPRB, 0.752289E+00_JPRB &
  &, 0.738755E+00_JPRB, 0.725040E+00_JPRB, 0.711185E+00_JPRB &
  &, 0.697183E+00_JPRB, 0.683067E+00_JPRB, 0.668830E+00_JPRB, 0.654522E+00_JPRB &
  &, 0.640123E+00_JPRB, 0.625672E+00_JPRB, 0.611178E+00_JPRB &
  &, 0.596652E+00_JPRB, 0.582103E+00_JPRB, 0.567571E+00_JPRB, 0.553052E+00_JPRB &
  &, 0.538571E+00_JPRB, 0.524138E+00_JPRB, 0.509780E+00_JPRB &
  &, 0.495485E+00_JPRB, 0.481281E+00_JPRB, 0.467174E+00_JPRB, 0.453206E+00_JPRB &
  &, 0.439346E+00_JPRB, 0.425637E+00_JPRB, 0.412081E+00_JPRB &
  &, 0.398702E+00_JPRB, 0.385479E+00_JPRB, 0.372454E+00_JPRB, 0.359626E+00_JPRB &
  &, 0.346992E+00_JPRB, 0.334593E+00_JPRB, 0.322399E+00_JPRB &
  &, 0.310427E+00_JPRB, 0.298692E+00_JPRB, 0.287206E+00_JPRB, 0.275985E+00_JPRB &
  &, 0.264988E+00_JPRB, 0.254278E+00_JPRB, 0.243783E+00_JPRB &
  &, 0.233593E+00_JPRB, 0.223660E+00_JPRB, 0.213989E+00_JPRB, 0.204583E+00_JPRB &
  &, 0.195445E+00_JPRB, 0.186606E+00_JPRB, 0.178005E+00_JPRB &
  &, 0.169671E+00_JPRB, 0.161632E+00_JPRB, 0.153853E+00_JPRB, 0.146327E+00_JPRB &
  &, 0.139080E+00_JPRB, 0.132105E+00_JPRB, 0.125355E+00_JPRB &
  &, 0.118889E+00_JPRB, 0.112660E+00_JPRB, 0.106688E+00_JPRB, 0.100921E+00_JPRB &
  &, 0.954161E-01_JPRB, 0.901548E-01_JPRB, 0.851176E-01_JPRB &
  &, 0.802826E-01_JPRB, 0.756664E-01_JPRB, 0.712861E-01_JPRB, 0.670745E-01_JPRB &
  &, 0.630882E-01_JPRB, 0.592998E-01_JPRB, 0.556792E-01_JPRB &
  &, 0.522391E-01_JPRB, 0.489921E-01_JPRB, 0.459050E-01_JPRB, 0.429419E-01_JPRB &
  &, 0.401597E-01_JPRB, 0.375699E-01_JPRB, 0.350861E-01_JPRB &
  &, 0.327157E-01_JPRB, 0.305172E-01_JPRB, 0.284493E-01_JPRB, 0.264679E-01_JPRB &
  &, 0.246318E-01_JPRB, 0.228957E-01_JPRB, 0.212657E-01_JPRB &
  &, 0.197481E-01_JPRB, 0.182933E-01_JPRB, 0.169621E-01_JPRB, 0.157036E-01_JPRB &
  &, 0.145221E-01_JPRB, 0.134219E-01_JPRB, 0.124074E-01_JPRB &
  &, 0.114831E-01_JPRB, 0.105921E-01_JPRB, 0.973651E-02_JPRB, 0.898169E-02_JPRB &
  &, 0.826837E-02_JPRB, 0.759883E-02_JPRB, 0.697538E-02_JPRB/)
XCW( 580, :) = (/ &
  &  0.101685E+01_JPRB, 0.102003E+01_JPRB, 0.102280E+01_JPRB, 0.102516E+01_JPRB &
  &, 0.102709E+01_JPRB, 0.102860E+01_JPRB, 0.102968E+01_JPRB &
  &, 0.103034E+01_JPRB, 0.103056E+01_JPRB, 0.103036E+01_JPRB, 0.102973E+01_JPRB &
  &, 0.102866E+01_JPRB, 0.102716E+01_JPRB, 0.102523E+01_JPRB &
  &, 0.102287E+01_JPRB, 0.102007E+01_JPRB, 0.101684E+01_JPRB, 0.101318E+01_JPRB &
  &, 0.100909E+01_JPRB, 0.100457E+01_JPRB, 0.999630E+00_JPRB &
  &, 0.994267E+00_JPRB, 0.988483E+00_JPRB, 0.982283E+00_JPRB, 0.975671E+00_JPRB &
  &, 0.968652E+00_JPRB, 0.961230E+00_JPRB, 0.953415E+00_JPRB &
  &, 0.945208E+00_JPRB, 0.936623E+00_JPRB, 0.927660E+00_JPRB, 0.918328E+00_JPRB &
  &, 0.908642E+00_JPRB, 0.898603E+00_JPRB, 0.888227E+00_JPRB &
  &, 0.877522E+00_JPRB, 0.866499E+00_JPRB, 0.855166E+00_JPRB, 0.843535E+00_JPRB &
  &, 0.831628E+00_JPRB, 0.819441E+00_JPRB, 0.807008E+00_JPRB &
  &, 0.794331E+00_JPRB, 0.781415E+00_JPRB, 0.768292E+00_JPRB, 0.754960E+00_JPRB &
  &, 0.741443E+00_JPRB, 0.727757E+00_JPRB, 0.713917E+00_JPRB &
  &, 0.699930E+00_JPRB, 0.685826E+00_JPRB, 0.671614E+00_JPRB, 0.657302E+00_JPRB &
  &, 0.642912E+00_JPRB, 0.628468E+00_JPRB, 0.613980E+00_JPRB &
  &, 0.599457E+00_JPRB, 0.584909E+00_JPRB, 0.570378E+00_JPRB, 0.555857E+00_JPRB &
  &, 0.541355E+00_JPRB, 0.526916E+00_JPRB, 0.512531E+00_JPRB &
  &, 0.498226E+00_JPRB, 0.484008E+00_JPRB, 0.469884E+00_JPRB, 0.455899E+00_JPRB &
  &, 0.442018E+00_JPRB, 0.428286E+00_JPRB, 0.414704E+00_JPRB &
  &, 0.401296E+00_JPRB, 0.388041E+00_JPRB, 0.374982E+00_JPRB, 0.362117E+00_JPRB &
  &, 0.349465E+00_JPRB, 0.337000E+00_JPRB, 0.324784E+00_JPRB &
  &, 0.312787E+00_JPRB, 0.300999E+00_JPRB, 0.289483E+00_JPRB, 0.278204E+00_JPRB &
  &, 0.267171E+00_JPRB, 0.256396E+00_JPRB, 0.245887E+00_JPRB &
  &, 0.235626E+00_JPRB, 0.225646E+00_JPRB, 0.215926E+00_JPRB, 0.206468E+00_JPRB &
  &, 0.197304E+00_JPRB, 0.188408E+00_JPRB, 0.179747E+00_JPRB &
  &, 0.171381E+00_JPRB, 0.163308E+00_JPRB, 0.155461E+00_JPRB, 0.147897E+00_JPRB &
  &, 0.140609E+00_JPRB, 0.133557E+00_JPRB, 0.126797E+00_JPRB &
  &, 0.120249E+00_JPRB, 0.113970E+00_JPRB, 0.107946E+00_JPRB, 0.102163E+00_JPRB &
  &, 0.966020E-01_JPRB, 0.912826E-01_JPRB, 0.862245E-01_JPRB &
  &, 0.813272E-01_JPRB, 0.766872E-01_JPRB, 0.722403E-01_JPRB, 0.680018E-01_JPRB &
  &, 0.639875E-01_JPRB, 0.601263E-01_JPRB, 0.564745E-01_JPRB &
  &, 0.530019E-01_JPRB, 0.497212E-01_JPRB, 0.465990E-01_JPRB, 0.435995E-01_JPRB &
  &, 0.408273E-01_JPRB, 0.381507E-01_JPRB, 0.356265E-01_JPRB &
  &, 0.332641E-01_JPRB, 0.310232E-01_JPRB, 0.289113E-01_JPRB, 0.269367E-01_JPRB &
  &, 0.250545E-01_JPRB, 0.233245E-01_JPRB, 0.216462E-01_JPRB &
  &, 0.201340E-01_JPRB, 0.186847E-01_JPRB, 0.173023E-01_JPRB, 0.160485E-01_JPRB &
  &, 0.148135E-01_JPRB, 0.137173E-01_JPRB, 0.126469E-01_JPRB &
  &, 0.117259E-01_JPRB, 0.107767E-01_JPRB, 0.998591E-02_JPRB, 0.917123E-02_JPRB &
  &, 0.846042E-02_JPRB, 0.779341E-02_JPRB, 0.710680E-02_JPRB/)
XCW( 581, :) = (/ &
  &  0.101710E+01_JPRB, 0.102036E+01_JPRB, 0.102319E+01_JPRB, 0.102561E+01_JPRB &
  &, 0.102761E+01_JPRB, 0.102918E+01_JPRB, 0.103033E+01_JPRB &
  &, 0.103106E+01_JPRB, 0.103135E+01_JPRB, 0.103121E+01_JPRB, 0.103064E+01_JPRB &
  &, 0.102964E+01_JPRB, 0.102821E+01_JPRB, 0.102634E+01_JPRB &
  &, 0.102404E+01_JPRB, 0.102131E+01_JPRB, 0.101815E+01_JPRB, 0.101455E+01_JPRB &
  &, 0.101052E+01_JPRB, 0.100606E+01_JPRB, 0.100118E+01_JPRB &
  &, 0.995878E+00_JPRB, 0.990155E+00_JPRB, 0.984011E+00_JPRB, 0.977458E+00_JPRB &
  &, 0.970496E+00_JPRB, 0.963130E+00_JPRB, 0.955368E+00_JPRB &
  &, 0.947218E+00_JPRB, 0.938683E+00_JPRB, 0.929771E+00_JPRB, 0.920488E+00_JPRB &
  &, 0.910847E+00_JPRB, 0.900860E+00_JPRB, 0.890527E+00_JPRB &
  &, 0.879866E+00_JPRB, 0.868883E+00_JPRB, 0.857591E+00_JPRB, 0.846001E+00_JPRB &
  &, 0.834125E+00_JPRB, 0.821981E+00_JPRB, 0.809579E+00_JPRB &
  &, 0.796922E+00_JPRB, 0.784038E+00_JPRB, 0.770945E+00_JPRB, 0.757643E+00_JPRB &
  &, 0.744144E+00_JPRB, 0.730486E+00_JPRB, 0.716662E+00_JPRB &
  &, 0.702689E+00_JPRB, 0.688598E+00_JPRB, 0.674398E+00_JPRB, 0.660097E+00_JPRB &
  &, 0.645716E+00_JPRB, 0.631279E+00_JPRB, 0.616796E+00_JPRB &
  &, 0.602262E+00_JPRB, 0.587732E+00_JPRB, 0.573185E+00_JPRB, 0.558662E+00_JPRB &
  &, 0.544156E+00_JPRB, 0.529711E+00_JPRB, 0.515318E+00_JPRB &
  &, 0.500984E+00_JPRB, 0.486753E+00_JPRB, 0.472614E+00_JPRB, 0.458591E+00_JPRB &
  &, 0.444710E+00_JPRB, 0.430934E+00_JPRB, 0.417347E+00_JPRB &
  &, 0.403890E+00_JPRB, 0.390625E+00_JPRB, 0.377532E+00_JPRB, 0.364630E+00_JPRB &
  &, 0.351939E+00_JPRB, 0.339453E+00_JPRB, 0.327192E+00_JPRB &
  &, 0.315146E+00_JPRB, 0.303331E+00_JPRB, 0.291760E+00_JPRB, 0.280448E+00_JPRB &
  &, 0.269380E+00_JPRB, 0.258540E+00_JPRB, 0.247991E+00_JPRB &
  &, 0.237687E+00_JPRB, 0.227661E+00_JPRB, 0.217891E+00_JPRB, 0.208411E+00_JPRB &
  &, 0.199164E+00_JPRB, 0.190210E+00_JPRB, 0.181519E+00_JPRB &
  &, 0.173122E+00_JPRB, 0.164952E+00_JPRB, 0.157101E+00_JPRB, 0.149466E+00_JPRB &
  &, 0.142138E+00_JPRB, 0.135043E+00_JPRB, 0.128204E+00_JPRB &
  &, 0.121644E+00_JPRB, 0.115316E+00_JPRB, 0.109242E+00_JPRB, 0.103405E+00_JPRB &
  &, 0.978261E-01_JPRB, 0.924493E-01_JPRB, 0.872918E-01_JPRB &
  &, 0.824120E-01_JPRB, 0.777079E-01_JPRB, 0.732360E-01_JPRB, 0.689292E-01_JPRB &
  &, 0.648868E-01_JPRB, 0.609962E-01_JPRB, 0.573140E-01_JPRB &
  &, 0.538096E-01_JPRB, 0.504502E-01_JPRB, 0.472930E-01_JPRB, 0.443041E-01_JPRB &
  &, 0.414471E-01_JPRB, 0.387800E-01_JPRB, 0.362160E-01_JPRB &
  &, 0.338126E-01_JPRB, 0.315797E-01_JPRB, 0.294247E-01_JPRB, 0.274054E-01_JPRB &
  &, 0.255300E-01_JPRB, 0.237532E-01_JPRB, 0.220811E-01_JPRB &
  &, 0.204648E-01_JPRB, 0.190201E-01_JPRB, 0.176424E-01_JPRB, 0.163359E-01_JPRB &
  &, 0.151049E-01_JPRB, 0.140127E-01_JPRB, 0.129464E-01_JPRB &
  &, 0.119688E-01_JPRB, 0.110228E-01_JPRB, 0.101730E-01_JPRB, 0.936077E-02_JPRB &
  &, 0.865248E-02_JPRB, 0.792314E-02_JPRB, 0.730394E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART83',1,ZHOOK_HANDLE)
END SUBROUTINE PART83

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART84

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART84',0,ZHOOK_HANDLE)

XCW( 582, :) = (/ &
  &  0.101736E+01_JPRB, 0.102068E+01_JPRB, 0.102358E+01_JPRB, 0.102607E+01_JPRB &
  &, 0.102813E+01_JPRB, 0.102977E+01_JPRB, 0.103099E+01_JPRB &
  &, 0.103178E+01_JPRB, 0.103214E+01_JPRB, 0.103207E+01_JPRB, 0.103156E+01_JPRB &
  &, 0.103063E+01_JPRB, 0.102926E+01_JPRB, 0.102746E+01_JPRB &
  &, 0.102522E+01_JPRB, 0.102255E+01_JPRB, 0.101945E+01_JPRB, 0.101592E+01_JPRB &
  &, 0.101195E+01_JPRB, 0.100756E+01_JPRB, 0.100274E+01_JPRB &
  &, 0.997492E+00_JPRB, 0.991827E+00_JPRB, 0.985743E+00_JPRB, 0.979249E+00_JPRB &
  &, 0.972341E+00_JPRB, 0.965034E+00_JPRB, 0.957326E+00_JPRB &
  &, 0.949228E+00_JPRB, 0.940738E+00_JPRB, 0.931882E+00_JPRB, 0.922652E+00_JPRB &
  &, 0.913061E+00_JPRB, 0.903116E+00_JPRB, 0.892831E+00_JPRB &
  &, 0.882210E+00_JPRB, 0.871267E+00_JPRB, 0.860016E+00_JPRB, 0.848467E+00_JPRB &
  &, 0.836633E+00_JPRB, 0.824521E+00_JPRB, 0.812151E+00_JPRB &
  &, 0.799525E+00_JPRB, 0.786682E+00_JPRB, 0.773609E+00_JPRB, 0.760326E+00_JPRB &
  &, 0.746856E+00_JPRB, 0.733216E+00_JPRB, 0.719407E+00_JPRB &
  &, 0.705461E+00_JPRB, 0.691384E+00_JPRB, 0.677196E+00_JPRB, 0.662906E+00_JPRB &
  &, 0.648534E+00_JPRB, 0.634105E+00_JPRB, 0.619613E+00_JPRB &
  &, 0.605098E+00_JPRB, 0.590555E+00_JPRB, 0.576008E+00_JPRB, 0.561483E+00_JPRB &
  &, 0.546974E+00_JPRB, 0.532506E+00_JPRB, 0.518104E+00_JPRB &
  &, 0.503760E+00_JPRB, 0.489517E+00_JPRB, 0.475363E+00_JPRB, 0.461323E+00_JPRB &
  &, 0.447402E+00_JPRB, 0.433623E+00_JPRB, 0.419990E+00_JPRB &
  &, 0.406505E+00_JPRB, 0.393209E+00_JPRB, 0.380082E+00_JPRB, 0.367166E+00_JPRB &
  &, 0.354435E+00_JPRB, 0.341907E+00_JPRB, 0.329600E+00_JPRB &
  &, 0.317529E+00_JPRB, 0.305663E+00_JPRB, 0.294062E+00_JPRB, 0.282692E+00_JPRB &
  &, 0.271589E+00_JPRB, 0.260712E+00_JPRB, 0.250123E+00_JPRB &
  &, 0.239775E+00_JPRB, 0.229675E+00_JPRB, 0.219886E+00_JPRB, 0.210325E+00_JPRB &
  &, 0.201053E+00_JPRB, 0.192043E+00_JPRB, 0.183323E+00_JPRB &
  &, 0.174864E+00_JPRB, 0.166661E+00_JPRB, 0.158742E+00_JPRB, 0.151069E+00_JPRB &
  &, 0.143667E+00_JPRB, 0.136530E+00_JPRB, 0.129646E+00_JPRB &
  &, 0.123039E+00_JPRB, 0.116662E+00_JPRB, 0.110537E+00_JPRB, 0.104646E+00_JPRB &
  &, 0.990120E-01_JPRB, 0.936159E-01_JPRB, 0.884381E-01_JPRB &
  &, 0.834566E-01_JPRB, 0.787286E-01_JPRB, 0.741902E-01_JPRB, 0.698987E-01_JPRB &
  &, 0.657860E-01_JPRB, 0.618662E-01_JPRB, 0.581092E-01_JPRB &
  &, 0.545724E-01_JPRB, 0.512248E-01_JPRB, 0.480332E-01_JPRB, 0.449617E-01_JPRB &
  &, 0.421147E-01_JPRB, 0.393608E-01_JPRB, 0.368055E-01_JPRB &
  &, 0.343610E-01_JPRB, 0.320856E-01_JPRB, 0.299380E-01_JPRB, 0.278742E-01_JPRB &
  &, 0.259527E-01_JPRB, 0.241284E-01_JPRB, 0.224617E-01_JPRB &
  &, 0.208508E-01_JPRB, 0.193556E-01_JPRB, 0.179826E-01_JPRB, 0.166234E-01_JPRB &
  &, 0.153963E-01_JPRB, 0.142490E-01_JPRB, 0.131860E-01_JPRB &
  &, 0.122116E-01_JPRB, 0.112689E-01_JPRB, 0.103600E-01_JPRB, 0.955032E-02_JPRB &
  &, 0.884453E-02_JPRB, 0.811772E-02_JPRB, 0.743536E-02_JPRB/)
XCW( 583, :) = (/ &
  &  0.101762E+01_JPRB, 0.102101E+01_JPRB, 0.102398E+01_JPRB, 0.102653E+01_JPRB &
  &, 0.102866E+01_JPRB, 0.103036E+01_JPRB, 0.103164E+01_JPRB &
  &, 0.103250E+01_JPRB, 0.103292E+01_JPRB, 0.103292E+01_JPRB, 0.103248E+01_JPRB &
  &, 0.103161E+01_JPRB, 0.103031E+01_JPRB, 0.102857E+01_JPRB &
  &, 0.102640E+01_JPRB, 0.102380E+01_JPRB, 0.102076E+01_JPRB, 0.101729E+01_JPRB &
  &, 0.101339E+01_JPRB, 0.100905E+01_JPRB, 0.100429E+01_JPRB &
  &, 0.999111E+00_JPRB, 0.993506E+00_JPRB, 0.987478E+00_JPRB, 0.981043E+00_JPRB &
  &, 0.974192E+00_JPRB, 0.966938E+00_JPRB, 0.959288E+00_JPRB &
  &, 0.951242E+00_JPRB, 0.942810E+00_JPRB, 0.934001E+00_JPRB, 0.924819E+00_JPRB &
  &, 0.915279E+00_JPRB, 0.905381E+00_JPRB, 0.895140E+00_JPRB &
  &, 0.884563E+00_JPRB, 0.873661E+00_JPRB, 0.862451E+00_JPRB, 0.850944E+00_JPRB &
  &, 0.839141E+00_JPRB, 0.827071E+00_JPRB, 0.814733E+00_JPRB &
  &, 0.802139E+00_JPRB, 0.789316E+00_JPRB, 0.776273E+00_JPRB, 0.763020E+00_JPRB &
  &, 0.749581E+00_JPRB, 0.735958E+00_JPRB, 0.722178E+00_JPRB &
  &, 0.708247E+00_JPRB, 0.694184E+00_JPRB, 0.679981E+00_JPRB, 0.665728E+00_JPRB &
  &, 0.651366E+00_JPRB, 0.636930E+00_JPRB, 0.622445E+00_JPRB &
  &, 0.607934E+00_JPRB, 0.593393E+00_JPRB, 0.578847E+00_JPRB, 0.564305E+00_JPRB &
  &, 0.549792E+00_JPRB, 0.535318E+00_JPRB, 0.520909E+00_JPRB &
  &, 0.506555E+00_JPRB, 0.492281E+00_JPRB, 0.478112E+00_JPRB, 0.464054E+00_JPRB &
  &, 0.450113E+00_JPRB, 0.436312E+00_JPRB, 0.422654E+00_JPRB &
  &, 0.409141E+00_JPRB, 0.395814E+00_JPRB, 0.382654E+00_JPRB, 0.369701E+00_JPRB &
  &, 0.356931E+00_JPRB, 0.344384E+00_JPRB, 0.332032E+00_JPRB &
  &, 0.319913E+00_JPRB, 0.308019E+00_JPRB, 0.296365E+00_JPRB, 0.284962E+00_JPRB &
  &, 0.273799E+00_JPRB, 0.262884E+00_JPRB, 0.252254E+00_JPRB &
  &, 0.241864E+00_JPRB, 0.231718E+00_JPRB, 0.221881E+00_JPRB, 0.212269E+00_JPRB &
  &, 0.202943E+00_JPRB, 0.193906E+00_JPRB, 0.185127E+00_JPRB &
  &, 0.176605E+00_JPRB, 0.168369E+00_JPRB, 0.160382E+00_JPRB, 0.152671E+00_JPRB &
  &, 0.145230E+00_JPRB, 0.138051E+00_JPRB, 0.131123E+00_JPRB &
  &, 0.124434E+00_JPRB, 0.118009E+00_JPRB, 0.111832E+00_JPRB, 0.105926E+00_JPRB &
  &, 0.100236E+00_JPRB, 0.947826E-01_JPRB, 0.895450E-01_JPRB &
  &, 0.845414E-01_JPRB, 0.797902E-01_JPRB, 0.752274E-01_JPRB, 0.708682E-01_JPRB &
  &, 0.666853E-01_JPRB, 0.627362E-01_JPRB, 0.589487E-01_JPRB &
  &, 0.553800E-01_JPRB, 0.519538E-01_JPRB, 0.487272E-01_JPRB, 0.456662E-01_JPRB &
  &, 0.427823E-01_JPRB, 0.399900E-01_JPRB, 0.373950E-01_JPRB &
  &, 0.349593E-01_JPRB, 0.326421E-01_JPRB, 0.304514E-01_JPRB, 0.283429E-01_JPRB &
  &, 0.264283E-01_JPRB, 0.246108E-01_JPRB, 0.228422E-01_JPRB &
  &, 0.212367E-01_JPRB, 0.197470E-01_JPRB, 0.183228E-01_JPRB, 0.169683E-01_JPRB &
  &, 0.157460E-01_JPRB, 0.145444E-01_JPRB, 0.134854E-01_JPRB &
  &, 0.124544E-01_JPRB, 0.115150E-01_JPRB, 0.106094E-01_JPRB, 0.980304E-02_JPRB &
  &, 0.903659E-02_JPRB, 0.831231E-02_JPRB, 0.763249E-02_JPRB/)
XCW( 584, :) = (/ &
  &  0.101788E+01_JPRB, 0.102133E+01_JPRB, 0.102437E+01_JPRB, 0.102698E+01_JPRB &
  &, 0.102918E+01_JPRB, 0.103095E+01_JPRB, 0.103230E+01_JPRB &
  &, 0.103322E+01_JPRB, 0.103371E+01_JPRB, 0.103377E+01_JPRB, 0.103340E+01_JPRB &
  &, 0.103260E+01_JPRB, 0.103136E+01_JPRB, 0.102969E+01_JPRB &
  &, 0.102758E+01_JPRB, 0.102504E+01_JPRB, 0.102207E+01_JPRB, 0.101866E+01_JPRB &
  &, 0.101482E+01_JPRB, 0.101055E+01_JPRB, 0.100585E+01_JPRB &
  &, 0.100073E+01_JPRB, 0.995184E+00_JPRB, 0.989217E+00_JPRB, 0.982837E+00_JPRB &
  &, 0.976047E+00_JPRB, 0.968849E+00_JPRB, 0.961253E+00_JPRB &
  &, 0.953259E+00_JPRB, 0.944881E+00_JPRB, 0.936124E+00_JPRB, 0.926992E+00_JPRB &
  &, 0.917497E+00_JPRB, 0.907646E+00_JPRB, 0.897453E+00_JPRB &
  &, 0.886916E+00_JPRB, 0.876064E+00_JPRB, 0.864896E+00_JPRB, 0.853420E+00_JPRB &
  &, 0.841660E+00_JPRB, 0.829621E+00_JPRB, 0.817315E+00_JPRB &
  &, 0.804763E+00_JPRB, 0.791972E+00_JPRB, 0.778949E+00_JPRB, 0.765727E+00_JPRB &
  &, 0.752306E+00_JPRB, 0.738712E+00_JPRB, 0.724936E+00_JPRB &
  &, 0.711033E+00_JPRB, 0.696983E+00_JPRB, 0.682820E+00_JPRB, 0.668551E+00_JPRB &
  &, 0.654199E+00_JPRB, 0.639771E+00_JPRB, 0.625291E+00_JPRB &
  &, 0.610770E+00_JPRB, 0.596232E+00_JPRB, 0.581686E+00_JPRB, 0.567143E+00_JPRB &
  &, 0.552627E+00_JPRB, 0.538148E+00_JPRB, 0.523713E+00_JPRB &
  &, 0.509349E+00_JPRB, 0.495063E+00_JPRB, 0.480880E+00_JPRB, 0.466805E+00_JPRB &
  &, 0.452844E+00_JPRB, 0.439001E+00_JPRB, 0.425318E+00_JPRB &
  &, 0.411798E+00_JPRB, 0.398441E+00_JPRB, 0.385248E+00_JPRB, 0.372259E+00_JPRB &
  &, 0.359450E+00_JPRB, 0.346861E+00_JPRB, 0.334487E+00_JPRB &
  &, 0.322321E+00_JPRB, 0.310401E+00_JPRB, 0.298692E+00_JPRB, 0.287258E+00_JPRB &
  &, 0.276034E+00_JPRB, 0.265082E+00_JPRB, 0.254385E+00_JPRB &
  &, 0.243952E+00_JPRB, 0.233790E+00_JPRB, 0.223875E+00_JPRB, 0.214242E+00_JPRB &
  &, 0.204863E+00_JPRB, 0.195769E+00_JPRB, 0.186931E+00_JPRB &
  &, 0.178379E+00_JPRB, 0.170078E+00_JPRB, 0.162055E+00_JPRB, 0.154274E+00_JPRB &
  &, 0.146793E+00_JPRB, 0.139537E+00_JPRB, 0.132565E+00_JPRB &
  &, 0.125865E+00_JPRB, 0.119391E+00_JPRB, 0.113164E+00_JPRB, 0.107205E+00_JPRB &
  &, 0.101460E+00_JPRB, 0.959493E-01_JPRB, 0.906913E-01_JPRB &
  &, 0.856663E-01_JPRB, 0.808109E-01_JPRB, 0.762231E-01_JPRB, 0.718377E-01_JPRB &
  &, 0.676274E-01_JPRB, 0.636062E-01_JPRB, 0.598323E-01_JPRB &
  &, 0.561877E-01_JPRB, 0.527284E-01_JPRB, 0.494674E-01_JPRB, 0.463708E-01_JPRB &
  &, 0.434499E-01_JPRB, 0.406676E-01_JPRB, 0.380336E-01_JPRB &
  &, 0.355077E-01_JPRB, 0.331480E-01_JPRB, 0.309647E-01_JPRB, 0.288637E-01_JPRB &
  &, 0.269038E-01_JPRB, 0.250396E-01_JPRB, 0.232771E-01_JPRB &
  &, 0.216226E-01_JPRB, 0.200825E-01_JPRB, 0.186630E-01_JPRB, 0.173132E-01_JPRB &
  &, 0.160374E-01_JPRB, 0.148399E-01_JPRB, 0.137250E-01_JPRB &
  &, 0.126972E-01_JPRB, 0.116995E-01_JPRB, 0.107965E-01_JPRB, 0.999258E-02_JPRB &
  &, 0.922864E-02_JPRB, 0.844203E-02_JPRB, 0.776391E-02_JPRB/)
XCW( 585, :) = (/ &
  &  0.101814E+01_JPRB, 0.102166E+01_JPRB, 0.102476E+01_JPRB, 0.102744E+01_JPRB &
  &, 0.102970E+01_JPRB, 0.103154E+01_JPRB, 0.103296E+01_JPRB &
  &, 0.103394E+01_JPRB, 0.103450E+01_JPRB, 0.103463E+01_JPRB, 0.103433E+01_JPRB &
  &, 0.103359E+01_JPRB, 0.103241E+01_JPRB, 0.103081E+01_JPRB &
  &, 0.102877E+01_JPRB, 0.102629E+01_JPRB, 0.102338E+01_JPRB, 0.102004E+01_JPRB &
  &, 0.101626E+01_JPRB, 0.101205E+01_JPRB, 0.100742E+01_JPRB &
  &, 0.100235E+01_JPRB, 0.996867E+00_JPRB, 0.990959E+00_JPRB, 0.984638E+00_JPRB &
  &, 0.977902E+00_JPRB, 0.970764E+00_JPRB, 0.963222E+00_JPRB &
  &, 0.955285E+00_JPRB, 0.946957E+00_JPRB, 0.938252E+00_JPRB, 0.929168E+00_JPRB &
  &, 0.919724E+00_JPRB, 0.909920E+00_JPRB, 0.899771E+00_JPRB &
  &, 0.889288E+00_JPRB, 0.878467E+00_JPRB, 0.867340E+00_JPRB, 0.855906E+00_JPRB &
  &, 0.844188E+00_JPRB, 0.832182E+00_JPRB, 0.819918E+00_JPRB &
  &, 0.807388E+00_JPRB, 0.794629E+00_JPRB, 0.781637E+00_JPRB, 0.768434E+00_JPRB &
  &, 0.755043E+00_JPRB, 0.741466E+00_JPRB, 0.727719E+00_JPRB &
  &, 0.713818E+00_JPRB, 0.699796E+00_JPRB, 0.685646E+00_JPRB, 0.671388E+00_JPRB &
  &, 0.657045E+00_JPRB, 0.642626E+00_JPRB, 0.628153E+00_JPRB &
  &, 0.613637E+00_JPRB, 0.599102E+00_JPRB, 0.584542E+00_JPRB, 0.569997E+00_JPRB &
  &, 0.555479E+00_JPRB, 0.540977E+00_JPRB, 0.526536E+00_JPRB &
  &, 0.512162E+00_JPRB, 0.497864E+00_JPRB, 0.483666E+00_JPRB, 0.469556E+00_JPRB &
  &, 0.455576E+00_JPRB, 0.441730E+00_JPRB, 0.428002E+00_JPRB &
  &, 0.414455E+00_JPRB, 0.401068E+00_JPRB, 0.387842E+00_JPRB, 0.374817E+00_JPRB &
  &, 0.361992E+00_JPRB, 0.349361E+00_JPRB, 0.336943E+00_JPRB &
  &, 0.324753E+00_JPRB, 0.312782E+00_JPRB, 0.301045E+00_JPRB, 0.289554E+00_JPRB &
  &, 0.278296E+00_JPRB, 0.267307E+00_JPRB, 0.256571E+00_JPRB &
  &, 0.246069E+00_JPRB, 0.235861E+00_JPRB, 0.225899E+00_JPRB, 0.216215E+00_JPRB &
  &, 0.206782E+00_JPRB, 0.197632E+00_JPRB, 0.188766E+00_JPRB &
  &, 0.180152E+00_JPRB, 0.171786E+00_JPRB, 0.163729E+00_JPRB, 0.155910E+00_JPRB &
  &, 0.148356E+00_JPRB, 0.141093E+00_JPRB, 0.134077E+00_JPRB &
  &, 0.127296E+00_JPRB, 0.120774E+00_JPRB, 0.114496E+00_JPRB, 0.108484E+00_JPRB &
  &, 0.102723E+00_JPRB, 0.971548E-01_JPRB, 0.918377E-01_JPRB &
  &, 0.867511E-01_JPRB, 0.818725E-01_JPRB, 0.771773E-01_JPRB, 0.728072E-01_JPRB &
  &, 0.685695E-01_JPRB, 0.645197E-01_JPRB, 0.606718E-01_JPRB &
  &, 0.569954E-01_JPRB, 0.535486E-01_JPRB, 0.502077E-01_JPRB, 0.470754E-01_JPRB &
  &, 0.441174E-01_JPRB, 0.412969E-01_JPRB, 0.386231E-01_JPRB &
  &, 0.361060E-01_JPRB, 0.337045E-01_JPRB, 0.314780E-01_JPRB, 0.293325E-01_JPRB &
  &, 0.273265E-01_JPRB, 0.254683E-01_JPRB, 0.237120E-01_JPRB &
  &, 0.220086E-01_JPRB, 0.204738E-01_JPRB, 0.190031E-01_JPRB, 0.176006E-01_JPRB &
  &, 0.163288E-01_JPRB, 0.151353E-01_JPRB, 0.140244E-01_JPRB &
  &, 0.129400E-01_JPRB, 0.119456E-01_JPRB, 0.110458E-01_JPRB, 0.101821E-01_JPRB &
  &, 0.942070E-02_JPRB, 0.863661E-02_JPRB, 0.796105E-02_JPRB/)
XCW( 586, :) = (/ &
  &  0.101840E+01_JPRB, 0.102198E+01_JPRB, 0.102515E+01_JPRB, 0.102790E+01_JPRB &
  &, 0.103023E+01_JPRB, 0.103213E+01_JPRB, 0.103361E+01_JPRB &
  &, 0.103467E+01_JPRB, 0.103529E+01_JPRB, 0.103549E+01_JPRB, 0.103525E+01_JPRB &
  &, 0.103457E+01_JPRB, 0.103347E+01_JPRB, 0.103193E+01_JPRB &
  &, 0.102995E+01_JPRB, 0.102754E+01_JPRB, 0.102469E+01_JPRB, 0.102141E+01_JPRB &
  &, 0.101770E+01_JPRB, 0.101355E+01_JPRB, 0.100898E+01_JPRB &
  &, 0.100398E+01_JPRB, 0.998552E+00_JPRB, 0.992705E+00_JPRB, 0.986439E+00_JPRB &
  &, 0.979764E+00_JPRB, 0.972678E+00_JPRB, 0.965191E+00_JPRB &
  &, 0.957310E+00_JPRB, 0.949036E+00_JPRB, 0.940383E+00_JPRB, 0.931353E+00_JPRB &
  &, 0.921955E+00_JPRB, 0.912199E+00_JPRB, 0.902098E+00_JPRB &
  &, 0.891651E+00_JPRB, 0.880880E+00_JPRB, 0.869794E+00_JPRB, 0.858403E+00_JPRB &
  &, 0.846717E+00_JPRB, 0.834753E+00_JPRB, 0.822511E+00_JPRB &
  &, 0.810024E+00_JPRB, 0.797296E+00_JPRB, 0.784336E+00_JPRB, 0.771164E+00_JPRB &
  &, 0.757792E+00_JPRB, 0.744233E+00_JPRB, 0.730503E+00_JPRB &
  &, 0.716630E+00_JPRB, 0.702609E+00_JPRB, 0.688471E+00_JPRB, 0.674239E+00_JPRB &
  &, 0.659892E+00_JPRB, 0.645496E+00_JPRB, 0.631015E+00_JPRB &
  &, 0.616504E+00_JPRB, 0.601972E+00_JPRB, 0.587413E+00_JPRB, 0.572869E+00_JPRB &
  &, 0.558331E+00_JPRB, 0.543824E+00_JPRB, 0.529376E+00_JPRB &
  &, 0.514993E+00_JPRB, 0.500683E+00_JPRB, 0.486453E+00_JPRB, 0.472326E+00_JPRB &
  &, 0.458327E+00_JPRB, 0.444440E+00_JPRB, 0.430707E+00_JPRB &
  &, 0.417133E+00_JPRB, 0.403717E+00_JPRB, 0.390458E+00_JPRB, 0.377397E+00_JPRB &
  &, 0.364534E+00_JPRB, 0.351862E+00_JPRB, 0.339423E+00_JPRB &
  &, 0.327185E+00_JPRB, 0.315164E+00_JPRB, 0.303398E+00_JPRB, 0.291850E+00_JPRB &
  &, 0.280584E+00_JPRB, 0.269533E+00_JPRB, 0.258730E+00_JPRB &
  &, 0.248213E+00_JPRB, 0.237961E+00_JPRB, 0.227951E+00_JPRB, 0.218217E+00_JPRB &
  &, 0.208732E+00_JPRB, 0.199526E+00_JPRB, 0.190601E+00_JPRB &
  &, 0.181894E+00_JPRB, 0.173559E+00_JPRB, 0.165435E+00_JPRB, 0.157546E+00_JPRB &
  &, 0.149953E+00_JPRB, 0.142649E+00_JPRB, 0.135554E+00_JPRB &
  &, 0.128727E+00_JPRB, 0.122193E+00_JPRB, 0.115865E+00_JPRB, 0.109801E+00_JPRB &
  &, 0.103947E+00_JPRB, 0.983604E-01_JPRB, 0.930236E-01_JPRB &
  &, 0.878760E-01_JPRB, 0.829749E-01_JPRB, 0.782560E-01_JPRB, 0.737767E-01_JPRB &
  &, 0.695116E-01_JPRB, 0.654332E-01_JPRB, 0.615554E-01_JPRB &
  &, 0.578479E-01_JPRB, 0.543232E-01_JPRB, 0.509942E-01_JPRB, 0.478269E-01_JPRB &
  &, 0.447850E-01_JPRB, 0.419261E-01_JPRB, 0.392618E-01_JPRB &
  &, 0.367042E-01_JPRB, 0.342611E-01_JPRB, 0.319914E-01_JPRB, 0.298533E-01_JPRB &
  &, 0.278020E-01_JPRB, 0.258971E-01_JPRB, 0.241469E-01_JPRB &
  &, 0.224497E-01_JPRB, 0.208652E-01_JPRB, 0.193433E-01_JPRB, 0.179455E-01_JPRB &
  &, 0.166785E-01_JPRB, 0.154307E-01_JPRB, 0.142640E-01_JPRB &
  &, 0.132435E-01_JPRB, 0.121917E-01_JPRB, 0.112952E-01_JPRB, 0.104348E-01_JPRB &
  &, 0.961275E-02_JPRB, 0.883120E-02_JPRB, 0.815818E-02_JPRB/)
XCW( 587, :) = (/ &
  &  0.101866E+01_JPRB, 0.102231E+01_JPRB, 0.102554E+01_JPRB, 0.102836E+01_JPRB &
  &, 0.103075E+01_JPRB, 0.103272E+01_JPRB, 0.103427E+01_JPRB &
  &, 0.103539E+01_JPRB, 0.103608E+01_JPRB, 0.103634E+01_JPRB, 0.103617E+01_JPRB &
  &, 0.103556E+01_JPRB, 0.103452E+01_JPRB, 0.103305E+01_JPRB &
  &, 0.103114E+01_JPRB, 0.102879E+01_JPRB, 0.102601E+01_JPRB, 0.102279E+01_JPRB &
  &, 0.101914E+01_JPRB, 0.101506E+01_JPRB, 0.101054E+01_JPRB &
  &, 0.100561E+01_JPRB, 0.100024E+01_JPRB, 0.994451E+00_JPRB, 0.988247E+00_JPRB &
  &, 0.981627E+00_JPRB, 0.974601E+00_JPRB, 0.967168E+00_JPRB &
  &, 0.959339E+00_JPRB, 0.951120E+00_JPRB, 0.942518E+00_JPRB, 0.933538E+00_JPRB &
  &, 0.924190E+00_JPRB, 0.914486E+00_JPRB, 0.904429E+00_JPRB &
  &, 0.894032E+00_JPRB, 0.883302E+00_JPRB, 0.872259E+00_JPRB, 0.860909E+00_JPRB &
  &, 0.849256E+00_JPRB, 0.837325E+00_JPRB, 0.825125E+00_JPRB &
  &, 0.812670E+00_JPRB, 0.799964E+00_JPRB, 0.787036E+00_JPRB, 0.773883E+00_JPRB &
  &, 0.760541E+00_JPRB, 0.747013E+00_JPRB, 0.733299E+00_JPRB &
  &, 0.719442E+00_JPRB, 0.705449E+00_JPRB, 0.691325E+00_JPRB, 0.677090E+00_JPRB &
  &, 0.662768E+00_JPRB, 0.648366E+00_JPRB, 0.633892E+00_JPRB &
  &, 0.619387E+00_JPRB, 0.604843E+00_JPRB, 0.590285E+00_JPRB, 0.575740E+00_JPRB &
  &, 0.561200E+00_JPRB, 0.546689E+00_JPRB, 0.532234E+00_JPRB &
  &, 0.517824E+00_JPRB, 0.503503E+00_JPRB, 0.489259E+00_JPRB, 0.475115E+00_JPRB &
  &, 0.461098E+00_JPRB, 0.447189E+00_JPRB, 0.433433E+00_JPRB &
  &, 0.419811E+00_JPRB, 0.406365E+00_JPRB, 0.393095E+00_JPRB, 0.380000E+00_JPRB &
  &, 0.367099E+00_JPRB, 0.354409E+00_JPRB, 0.341902E+00_JPRB &
  &, 0.329642E+00_JPRB, 0.317595E+00_JPRB, 0.305776E+00_JPRB, 0.294198E+00_JPRB &
  &, 0.282846E+00_JPRB, 0.271785E+00_JPRB, 0.260944E+00_JPRB &
  &, 0.250357E+00_JPRB, 0.240061E+00_JPRB, 0.230004E+00_JPRB, 0.220220E+00_JPRB &
  &, 0.210681E+00_JPRB, 0.201450E+00_JPRB, 0.192467E+00_JPRB &
  &, 0.183762E+00_JPRB, 0.175299E+00_JPRB, 0.167141E+00_JPRB, 0.159216E+00_JPRB &
  &, 0.151584E+00_JPRB, 0.144204E+00_JPRB, 0.137066E+00_JPRB &
  &, 0.130194E+00_JPRB, 0.123576E+00_JPRB, 0.117234E+00_JPRB, 0.111118E+00_JPRB &
  &, 0.105247E+00_JPRB, 0.996048E-01_JPRB, 0.942095E-01_JPRB &
  &, 0.890009E-01_JPRB, 0.840773E-01_JPRB, 0.793347E-01_JPRB, 0.747883E-01_JPRB &
  &, 0.704537E-01_JPRB, 0.663467E-01_JPRB, 0.624391E-01_JPRB &
  &, 0.587004E-01_JPRB, 0.551434E-01_JPRB, 0.517344E-01_JPRB, 0.485315E-01_JPRB &
  &, 0.455003E-01_JPRB, 0.426037E-01_JPRB, 0.399004E-01_JPRB &
  &, 0.373025E-01_JPRB, 0.348682E-01_JPRB, 0.325561E-01_JPRB, 0.303741E-01_JPRB &
  &, 0.283304E-01_JPRB, 0.263795E-01_JPRB, 0.245818E-01_JPRB &
  &, 0.228356E-01_JPRB, 0.212566E-01_JPRB, 0.197402E-01_JPRB, 0.182904E-01_JPRB &
  &, 0.169699E-01_JPRB, 0.157261E-01_JPRB, 0.145634E-01_JPRB &
  &, 0.134864E-01_JPRB, 0.124378E-01_JPRB, 0.115446E-01_JPRB, 0.106244E-01_JPRB &
  &, 0.980481E-02_JPRB, 0.902579E-02_JPRB, 0.835531E-02_JPRB/)
XCW( 588, :) = (/ &
  &  0.101892E+01_JPRB, 0.102263E+01_JPRB, 0.102593E+01_JPRB, 0.102882E+01_JPRB &
  &, 0.103128E+01_JPRB, 0.103332E+01_JPRB, 0.103493E+01_JPRB &
  &, 0.103612E+01_JPRB, 0.103687E+01_JPRB, 0.103720E+01_JPRB, 0.103710E+01_JPRB &
  &, 0.103656E+01_JPRB, 0.103558E+01_JPRB, 0.103417E+01_JPRB &
  &, 0.103233E+01_JPRB, 0.103004E+01_JPRB, 0.102733E+01_JPRB, 0.102417E+01_JPRB &
  &, 0.102058E+01_JPRB, 0.101657E+01_JPRB, 0.101211E+01_JPRB &
  &, 0.100723E+01_JPRB, 0.100193E+01_JPRB, 0.996203E+00_JPRB, 0.990055E+00_JPRB &
  &, 0.983496E+00_JPRB, 0.976523E+00_JPRB, 0.969149E+00_JPRB &
  &, 0.961376E+00_JPRB, 0.953208E+00_JPRB, 0.944658E+00_JPRB, 0.935731E+00_JPRB &
  &, 0.926430E+00_JPRB, 0.916773E+00_JPRB, 0.906765E+00_JPRB &
  &, 0.896413E+00_JPRB, 0.885725E+00_JPRB, 0.874723E+00_JPRB, 0.863415E+00_JPRB &
  &, 0.851805E+00_JPRB, 0.839906E+00_JPRB, 0.827740E+00_JPRB &
  &, 0.815317E+00_JPRB, 0.802643E+00_JPRB, 0.789747E+00_JPRB, 0.776626E+00_JPRB &
  &, 0.763303E+00_JPRB, 0.749792E+00_JPRB, 0.736108E+00_JPRB &
  &, 0.722267E+00_JPRB, 0.708289E+00_JPRB, 0.694178E+00_JPRB, 0.679956E+00_JPRB &
  &, 0.665644E+00_JPRB, 0.651251E+00_JPRB, 0.636785E+00_JPRB &
  &, 0.622285E+00_JPRB, 0.607745E+00_JPRB, 0.593189E+00_JPRB, 0.578628E+00_JPRB &
  &, 0.564085E+00_JPRB, 0.549571E+00_JPRB, 0.535091E+00_JPRB &
  &, 0.520673E+00_JPRB, 0.506341E+00_JPRB, 0.492083E+00_JPRB, 0.477924E+00_JPRB &
  &, 0.463868E+00_JPRB, 0.449939E+00_JPRB, 0.436159E+00_JPRB &
  &, 0.422531E+00_JPRB, 0.409057E+00_JPRB, 0.395733E+00_JPRB, 0.382625E+00_JPRB &
  &, 0.369686E+00_JPRB, 0.356933E+00_JPRB, 0.344406E+00_JPRB &
  &, 0.332098E+00_JPRB, 0.320026E+00_JPRB, 0.308154E+00_JPRB, 0.296545E+00_JPRB &
  &, 0.285160E+00_JPRB, 0.274037E+00_JPRB, 0.263157E+00_JPRB &
  &, 0.252529E+00_JPRB, 0.242160E+00_JPRB, 0.232085E+00_JPRB, 0.222252E+00_JPRB &
  &, 0.212661E+00_JPRB, 0.203375E+00_JPRB, 0.194333E+00_JPRB &
  &, 0.185567E+00_JPRB, 0.177072E+00_JPRB, 0.168847E+00_JPRB, 0.160885E+00_JPRB &
  &, 0.153215E+00_JPRB, 0.145760E+00_JPRB, 0.138614E+00_JPRB &
  &, 0.131697E+00_JPRB, 0.125031E+00_JPRB, 0.118603E+00_JPRB, 0.112435E+00_JPRB &
  &, 0.106510E+00_JPRB, 0.100849E+00_JPRB, 0.953954E-01_JPRB &
  &, 0.901661E-01_JPRB, 0.851796E-01_JPRB, 0.803719E-01_JPRB, 0.758000E-01_JPRB &
  &, 0.714387E-01_JPRB, 0.672602E-01_JPRB, 0.633227E-01_JPRB &
  &, 0.595530E-01_JPRB, 0.559635E-01_JPRB, 0.525209E-01_JPRB, 0.492830E-01_JPRB &
  &, 0.462155E-01_JPRB, 0.432813E-01_JPRB, 0.405391E-01_JPRB &
  &, 0.379008E-01_JPRB, 0.354247E-01_JPRB, 0.330694E-01_JPRB, 0.308949E-01_JPRB &
  &, 0.288059E-01_JPRB, 0.268618E-01_JPRB, 0.250167E-01_JPRB &
  &, 0.232767E-01_JPRB, 0.216480E-01_JPRB, 0.200804E-01_JPRB, 0.186354E-01_JPRB &
  &, 0.173196E-01_JPRB, 0.160215E-01_JPRB, 0.148629E-01_JPRB &
  &, 0.137292E-01_JPRB, 0.127454E-01_JPRB, 0.117317E-01_JPRB, 0.108771E-01_JPRB &
  &, 0.999686E-02_JPRB, 0.922037E-02_JPRB, 0.848674E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART84',1,ZHOOK_HANDLE)
END SUBROUTINE PART84

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART85

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART85',0,ZHOOK_HANDLE)

XCW( 589, :) = (/ &
  &  0.101918E+01_JPRB, 0.102296E+01_JPRB, 0.102633E+01_JPRB, 0.102928E+01_JPRB &
  &, 0.103180E+01_JPRB, 0.103391E+01_JPRB, 0.103559E+01_JPRB &
  &, 0.103684E+01_JPRB, 0.103767E+01_JPRB, 0.103805E+01_JPRB, 0.103802E+01_JPRB &
  &, 0.103755E+01_JPRB, 0.103664E+01_JPRB, 0.103529E+01_JPRB &
  &, 0.103351E+01_JPRB, 0.103130E+01_JPRB, 0.102864E+01_JPRB, 0.102556E+01_JPRB &
  &, 0.102203E+01_JPRB, 0.101808E+01_JPRB, 0.101369E+01_JPRB &
  &, 0.100887E+01_JPRB, 0.100362E+01_JPRB, 0.997956E+00_JPRB, 0.991867E+00_JPRB &
  &, 0.985366E+00_JPRB, 0.978453E+00_JPRB, 0.971133E+00_JPRB &
  &, 0.963414E+00_JPRB, 0.955303E+00_JPRB, 0.946802E+00_JPRB, 0.937924E+00_JPRB &
  &, 0.928678E+00_JPRB, 0.919065E+00_JPRB, 0.909106E+00_JPRB &
  &, 0.898794E+00_JPRB, 0.888157E+00_JPRB, 0.877196E+00_JPRB, 0.865922E+00_JPRB &
  &, 0.854354E+00_JPRB, 0.842499E+00_JPRB, 0.830365E+00_JPRB &
  &, 0.817975E+00_JPRB, 0.805333E+00_JPRB, 0.792457E+00_JPRB, 0.779368E+00_JPRB &
  &, 0.766077E+00_JPRB, 0.752584E+00_JPRB, 0.738917E+00_JPRB &
  &, 0.725105E+00_JPRB, 0.711142E+00_JPRB, 0.697045E+00_JPRB, 0.682835E+00_JPRB &
  &, 0.668534E+00_JPRB, 0.654135E+00_JPRB, 0.639692E+00_JPRB &
  &, 0.625182E+00_JPRB, 0.610647E+00_JPRB, 0.596094E+00_JPRB, 0.581532E+00_JPRB &
  &, 0.566971E+00_JPRB, 0.552452E+00_JPRB, 0.537967E+00_JPRB &
  &, 0.523540E+00_JPRB, 0.509179E+00_JPRB, 0.494908E+00_JPRB, 0.480733E+00_JPRB &
  &, 0.466659E+00_JPRB, 0.452729E+00_JPRB, 0.438906E+00_JPRB &
  &, 0.425252E+00_JPRB, 0.411748E+00_JPRB, 0.398393E+00_JPRB, 0.385251E+00_JPRB &
  &, 0.372274E+00_JPRB, 0.359503E+00_JPRB, 0.346933E+00_JPRB &
  &, 0.334579E+00_JPRB, 0.322457E+00_JPRB, 0.310557E+00_JPRB, 0.298893E+00_JPRB &
  &, 0.287475E+00_JPRB, 0.276316E+00_JPRB, 0.265370E+00_JPRB &
  &, 0.254701E+00_JPRB, 0.244317E+00_JPRB, 0.234167E+00_JPRB, 0.224283E+00_JPRB &
  &, 0.214670E+00_JPRB, 0.205299E+00_JPRB, 0.196231E+00_JPRB &
  &, 0.187435E+00_JPRB, 0.178877E+00_JPRB, 0.170586E+00_JPRB, 0.162588E+00_JPRB &
  &, 0.154846E+00_JPRB, 0.147350E+00_JPRB, 0.140126E+00_JPRB &
  &, 0.133163E+00_JPRB, 0.126450E+00_JPRB, 0.120009E+00_JPRB, 0.113789E+00_JPRB &
  &, 0.107810E+00_JPRB, 0.102094E+00_JPRB, 0.965813E-01_JPRB &
  &, 0.913312E-01_JPRB, 0.862820E-01_JPRB, 0.814506E-01_JPRB, 0.768538E-01_JPRB &
  &, 0.724236E-01_JPRB, 0.682172E-01_JPRB, 0.642063E-01_JPRB &
  &, 0.604055E-01_JPRB, 0.567837E-01_JPRB, 0.533074E-01_JPRB, 0.500346E-01_JPRB &
  &, 0.469308E-01_JPRB, 0.439590E-01_JPRB, 0.411777E-01_JPRB &
  &, 0.384991E-01_JPRB, 0.360318E-01_JPRB, 0.336341E-01_JPRB, 0.314158E-01_JPRB &
  &, 0.292814E-01_JPRB, 0.273442E-01_JPRB, 0.254516E-01_JPRB &
  &, 0.236626E-01_JPRB, 0.220394E-01_JPRB, 0.204772E-01_JPRB, 0.190378E-01_JPRB &
  &, 0.176693E-01_JPRB, 0.163760E-01_JPRB, 0.151624E-01_JPRB &
  &, 0.140327E-01_JPRB, 0.129915E-01_JPRB, 0.119811E-01_JPRB, 0.110667E-01_JPRB &
  &, 0.102529E-01_JPRB, 0.941496E-02_JPRB, 0.868387E-02_JPRB/)
XCW( 590, :) = (/ &
  &  0.101944E+01_JPRB, 0.102329E+01_JPRB, 0.102672E+01_JPRB, 0.102974E+01_JPRB &
  &, 0.103233E+01_JPRB, 0.103450E+01_JPRB, 0.103625E+01_JPRB &
  &, 0.103757E+01_JPRB, 0.103846E+01_JPRB, 0.103892E+01_JPRB, 0.103895E+01_JPRB &
  &, 0.103854E+01_JPRB, 0.103770E+01_JPRB, 0.103642E+01_JPRB &
  &, 0.103471E+01_JPRB, 0.103255E+01_JPRB, 0.102996E+01_JPRB, 0.102694E+01_JPRB &
  &, 0.102348E+01_JPRB, 0.101959E+01_JPRB, 0.101526E+01_JPRB &
  &, 0.101050E+01_JPRB, 0.100532E+01_JPRB, 0.999712E+00_JPRB, 0.993686E+00_JPRB &
  &, 0.987239E+00_JPRB, 0.980382E+00_JPRB, 0.973121E+00_JPRB &
  &, 0.965455E+00_JPRB, 0.957399E+00_JPRB, 0.948954E+00_JPRB, 0.940126E+00_JPRB &
  &, 0.930926E+00_JPRB, 0.921366E+00_JPRB, 0.911451E+00_JPRB &
  &, 0.901185E+00_JPRB, 0.890588E+00_JPRB, 0.879670E+00_JPRB, 0.868448E+00_JPRB &
  &, 0.856913E+00_JPRB, 0.845091E+00_JPRB, 0.833001E+00_JPRB &
  &, 0.820633E+00_JPRB, 0.808035E+00_JPRB, 0.795192E+00_JPRB, 0.782122E+00_JPRB &
  &, 0.768850E+00_JPRB, 0.755388E+00_JPRB, 0.741752E+00_JPRB &
  &, 0.727944E+00_JPRB, 0.713995E+00_JPRB, 0.699912E+00_JPRB, 0.685714E+00_JPRB &
  &, 0.671424E+00_JPRB, 0.657050E+00_JPRB, 0.642599E+00_JPRB &
  &, 0.628096E+00_JPRB, 0.613565E+00_JPRB, 0.598998E+00_JPRB, 0.584437E+00_JPRB &
  &, 0.569891E+00_JPRB, 0.555351E+00_JPRB, 0.540860E+00_JPRB &
  &, 0.526425E+00_JPRB, 0.512054E+00_JPRB, 0.497752E+00_JPRB, 0.483561E+00_JPRB &
  &, 0.469469E+00_JPRB, 0.455499E+00_JPRB, 0.441673E+00_JPRB &
  &, 0.427972E+00_JPRB, 0.414440E+00_JPRB, 0.401075E+00_JPRB, 0.387898E+00_JPRB &
  &, 0.374885E+00_JPRB, 0.362074E+00_JPRB, 0.349484E+00_JPRB &
  &, 0.337084E+00_JPRB, 0.324913E+00_JPRB, 0.312986E+00_JPRB, 0.301266E+00_JPRB &
  &, 0.289816E+00_JPRB, 0.278594E+00_JPRB, 0.267638E+00_JPRB &
  &, 0.256901E+00_JPRB, 0.246445E+00_JPRB, 0.236277E+00_JPRB, 0.226345E+00_JPRB &
  &, 0.216680E+00_JPRB, 0.207284E+00_JPRB, 0.198128E+00_JPRB &
  &, 0.189271E+00_JPRB, 0.180683E+00_JPRB, 0.172358E+00_JPRB, 0.164291E+00_JPRB &
  &, 0.156511E+00_JPRB, 0.148975E+00_JPRB, 0.141709E+00_JPRB &
  &, 0.134666E+00_JPRB, 0.127906E+00_JPRB, 0.121415E+00_JPRB, 0.115144E+00_JPRB &
  &, 0.109149E+00_JPRB, 0.103338E+00_JPRB, 0.978067E-01_JPRB &
  &, 0.924963E-01_JPRB, 0.873844E-01_JPRB, 0.825293E-01_JPRB, 0.778655E-01_JPRB &
  &, 0.734085E-01_JPRB, 0.691741E-01_JPRB, 0.651342E-01_JPRB &
  &, 0.612581E-01_JPRB, 0.576039E-01_JPRB, 0.540939E-01_JPRB, 0.507861E-01_JPRB &
  &, 0.476460E-01_JPRB, 0.446850E-01_JPRB, 0.418164E-01_JPRB &
  &, 0.391472E-01_JPRB, 0.365883E-01_JPRB, 0.341988E-01_JPRB, 0.319366E-01_JPRB &
  &, 0.298098E-01_JPRB, 0.277730E-01_JPRB, 0.258865E-01_JPRB &
  &, 0.241037E-01_JPRB, 0.224308E-01_JPRB, 0.208741E-01_JPRB, 0.193827E-01_JPRB &
  &, 0.179607E-01_JPRB, 0.166714E-01_JPRB, 0.154618E-01_JPRB &
  &, 0.143362E-01_JPRB, 0.132376E-01_JPRB, 0.122305E-01_JPRB, 0.113194E-01_JPRB &
  &, 0.104450E-01_JPRB, 0.967440E-02_JPRB, 0.888100E-02_JPRB/)
XCW( 591, :) = (/ &
  &  0.101970E+01_JPRB, 0.102361E+01_JPRB, 0.102711E+01_JPRB, 0.103020E+01_JPRB &
  &, 0.103286E+01_JPRB, 0.103510E+01_JPRB, 0.103691E+01_JPRB &
  &, 0.103830E+01_JPRB, 0.103926E+01_JPRB, 0.103978E+01_JPRB, 0.103988E+01_JPRB &
  &, 0.103953E+01_JPRB, 0.103876E+01_JPRB, 0.103755E+01_JPRB &
  &, 0.103590E+01_JPRB, 0.103381E+01_JPRB, 0.103129E+01_JPRB, 0.102833E+01_JPRB &
  &, 0.102493E+01_JPRB, 0.102110E+01_JPRB, 0.101683E+01_JPRB &
  &, 0.101214E+01_JPRB, 0.100702E+01_JPRB, 0.100147E+01_JPRB, 0.995505E+00_JPRB &
  &, 0.989116E+00_JPRB, 0.982319E+00_JPRB, 0.975113E+00_JPRB &
  &, 0.967503E+00_JPRB, 0.959498E+00_JPRB, 0.951106E+00_JPRB, 0.942331E+00_JPRB &
  &, 0.933183E+00_JPRB, 0.923671E+00_JPRB, 0.913800E+00_JPRB &
  &, 0.903584E+00_JPRB, 0.893039E+00_JPRB, 0.882154E+00_JPRB, 0.870964E+00_JPRB &
  &, 0.859473E+00_JPRB, 0.847694E+00_JPRB, 0.835637E+00_JPRB &
  &, 0.823313E+00_JPRB, 0.810737E+00_JPRB, 0.797914E+00_JPRB, 0.784889E+00_JPRB &
  &, 0.771636E+00_JPRB, 0.758193E+00_JPRB, 0.744574E+00_JPRB &
  &, 0.730795E+00_JPRB, 0.716862E+00_JPRB, 0.702806E+00_JPRB, 0.688622E+00_JPRB &
  &, 0.674329E+00_JPRB, 0.659964E+00_JPRB, 0.645522E+00_JPRB &
  &, 0.631025E+00_JPRB, 0.616435E+00_JPRB, 0.601934E+00_JPRB, 0.587358E+00_JPRB &
  &, 0.572811E+00_JPRB, 0.558268E+00_JPRB, 0.543754E+00_JPRB &
  &, 0.529311E+00_JPRB, 0.514929E+00_JPRB, 0.500614E+00_JPRB, 0.486409E+00_JPRB &
  &, 0.472300E+00_JPRB, 0.458309E+00_JPRB, 0.444440E+00_JPRB &
  &, 0.430735E+00_JPRB, 0.417174E+00_JPRB, 0.403779E+00_JPRB, 0.390546E+00_JPRB &
  &, 0.377518E+00_JPRB, 0.364668E+00_JPRB, 0.352035E+00_JPRB &
  &, 0.339613E+00_JPRB, 0.327394E+00_JPRB, 0.315415E+00_JPRB, 0.303665E+00_JPRB &
  &, 0.292156E+00_JPRB, 0.280900E+00_JPRB, 0.269879E+00_JPRB &
  &, 0.259129E+00_JPRB, 0.248630E+00_JPRB, 0.238387E+00_JPRB, 0.228406E+00_JPRB &
  &, 0.218689E+00_JPRB, 0.209239E+00_JPRB, 0.200056E+00_JPRB &
  &, 0.191140E+00_JPRB, 0.182520E+00_JPRB, 0.174129E+00_JPRB, 0.166028E+00_JPRB &
  &, 0.158176E+00_JPRB, 0.150600E+00_JPRB, 0.143256E+00_JPRB &
  &, 0.136204E+00_JPRB, 0.129397E+00_JPRB, 0.122821E+00_JPRB, 0.116536E+00_JPRB &
  &, 0.110450E+00_JPRB, 0.104622E+00_JPRB, 0.990321E-01_JPRB &
  &, 0.936614E-01_JPRB, 0.885276E-01_JPRB, 0.836079E-01_JPRB, 0.789193E-01_JPRB &
  &, 0.744363E-01_JPRB, 0.701311E-01_JPRB, 0.660620E-01_JPRB &
  &, 0.621555E-01_JPRB, 0.584696E-01_JPRB, 0.549267E-01_JPRB, 0.515846E-01_JPRB &
  &, 0.484090E-01_JPRB, 0.453626E-01_JPRB, 0.425041E-01_JPRB &
  &, 0.397953E-01_JPRB, 0.371954E-01_JPRB, 0.347635E-01_JPRB, 0.325095E-01_JPRB &
  &, 0.303382E-01_JPRB, 0.283089E-01_JPRB, 0.263758E-01_JPRB &
  &, 0.245448E-01_JPRB, 0.228222E-01_JPRB, 0.212710E-01_JPRB, 0.197276E-01_JPRB &
  &, 0.183104E-01_JPRB, 0.170259E-01_JPRB, 0.157613E-01_JPRB &
  &, 0.145790E-01_JPRB, 0.135453E-01_JPRB, 0.124799E-01_JPRB, 0.115721E-01_JPRB &
  &, 0.107011E-01_JPRB, 0.986899E-02_JPRB, 0.907814E-02_JPRB/)
XCW( 592, :) = (/ &
  &  0.101996E+01_JPRB, 0.102394E+01_JPRB, 0.102751E+01_JPRB, 0.103065E+01_JPRB &
  &, 0.103338E+01_JPRB, 0.103569E+01_JPRB, 0.103757E+01_JPRB &
  &, 0.103902E+01_JPRB, 0.104005E+01_JPRB, 0.104064E+01_JPRB, 0.104080E+01_JPRB &
  &, 0.104053E+01_JPRB, 0.103982E+01_JPRB, 0.103867E+01_JPRB &
  &, 0.103709E+01_JPRB, 0.103507E+01_JPRB, 0.103261E+01_JPRB, 0.102972E+01_JPRB &
  &, 0.102638E+01_JPRB, 0.102262E+01_JPRB, 0.101842E+01_JPRB &
  &, 0.101378E+01_JPRB, 0.100872E+01_JPRB, 0.100323E+01_JPRB, 0.997327E+00_JPRB &
  &, 0.991000E+00_JPRB, 0.984257E+00_JPRB, 0.977105E+00_JPRB &
  &, 0.969552E+00_JPRB, 0.961542E+00_JPRB, 0.953266E+00_JPRB, 0.944541E+00_JPRB &
  &, 0.935444E+00_JPRB, 0.925980E+00_JPRB, 0.916159E+00_JPRB &
  &, 0.905993E+00_JPRB, 0.895481E+00_JPRB, 0.884647E+00_JPRB, 0.873501E+00_JPRB &
  &, 0.862053E+00_JPRB, 0.850308E+00_JPRB, 0.838284E+00_JPRB &
  &, 0.825993E+00_JPRB, 0.813450E+00_JPRB, 0.800660E+00_JPRB, 0.787655E+00_JPRB &
  &, 0.774434E+00_JPRB, 0.761022E+00_JPRB, 0.747421E+00_JPRB &
  &, 0.733659E+00_JPRB, 0.719742E+00_JPRB, 0.705701E+00_JPRB, 0.691529E+00_JPRB &
  &, 0.677248E+00_JPRB, 0.662893E+00_JPRB, 0.648459E+00_JPRB &
  &, 0.633969E+00_JPRB, 0.619432E+00_JPRB, 0.604871E+00_JPRB, 0.590296E+00_JPRB &
  &, 0.575731E+00_JPRB, 0.561184E+00_JPRB, 0.546682E+00_JPRB &
  &, 0.532214E+00_JPRB, 0.517804E+00_JPRB, 0.503496E+00_JPRB, 0.489257E+00_JPRB &
  &, 0.475130E+00_JPRB, 0.461119E+00_JPRB, 0.447227E+00_JPRB &
  &, 0.433497E+00_JPRB, 0.419909E+00_JPRB, 0.406483E+00_JPRB, 0.393216E+00_JPRB &
  &, 0.380152E+00_JPRB, 0.367285E+00_JPRB, 0.354610E+00_JPRB &
  &, 0.342143E+00_JPRB, 0.329899E+00_JPRB, 0.317869E+00_JPRB, 0.306090E+00_JPRB &
  &, 0.294523E+00_JPRB, 0.283233E+00_JPRB, 0.272174E+00_JPRB &
  &, 0.261357E+00_JPRB, 0.250815E+00_JPRB, 0.240527E+00_JPRB, 0.230497E+00_JPRB &
  &, 0.220729E+00_JPRB, 0.211224E+00_JPRB, 0.202016E+00_JPRB &
  &, 0.193040E+00_JPRB, 0.184357E+00_JPRB, 0.175901E+00_JPRB, 0.167764E+00_JPRB &
  &, 0.159875E+00_JPRB, 0.152225E+00_JPRB, 0.144839E+00_JPRB &
  &, 0.137743E+00_JPRB, 0.130889E+00_JPRB, 0.124265E+00_JPRB, 0.117928E+00_JPRB &
  &, 0.111789E+00_JPRB, 0.105905E+00_JPRB, 0.100297E+00_JPRB &
  &, 0.948667E-01_JPRB, 0.897117E-01_JPRB, 0.847281E-01_JPRB, 0.799731E-01_JPRB &
  &, 0.754640E-01_JPRB, 0.711316E-01_JPRB, 0.669898E-01_JPRB &
  &, 0.630529E-01_JPRB, 0.592442E-01_JPRB, 0.557595E-01_JPRB, 0.523362E-01_JPRB &
  &, 0.491242E-01_JPRB, 0.460887E-01_JPRB, 0.431919E-01_JPRB &
  &, 0.404435E-01_JPRB, 0.378531E-01_JPRB, 0.353795E-01_JPRB, 0.330303E-01_JPRB &
  &, 0.308665E-01_JPRB, 0.287913E-01_JPRB, 0.268107E-01_JPRB &
  &, 0.249858E-01_JPRB, 0.232694E-01_JPRB, 0.216678E-01_JPRB, 0.201300E-01_JPRB &
  &, 0.186601E-01_JPRB, 0.173213E-01_JPRB, 0.160607E-01_JPRB &
  &, 0.148826E-01_JPRB, 0.137914E-01_JPRB, 0.127916E-01_JPRB, 0.118248E-01_JPRB &
  &, 0.108931E-01_JPRB, 0.100636E-01_JPRB, 0.927527E-02_JPRB/)
XCW( 593, :) = (/ &
  &  0.102023E+01_JPRB, 0.102427E+01_JPRB, 0.102790E+01_JPRB, 0.103112E+01_JPRB &
  &, 0.103391E+01_JPRB, 0.103628E+01_JPRB, 0.103823E+01_JPRB &
  &, 0.103975E+01_JPRB, 0.104085E+01_JPRB, 0.104151E+01_JPRB, 0.104174E+01_JPRB &
  &, 0.104153E+01_JPRB, 0.104088E+01_JPRB, 0.103980E+01_JPRB &
  &, 0.103829E+01_JPRB, 0.103633E+01_JPRB, 0.103394E+01_JPRB, 0.103111E+01_JPRB &
  &, 0.102783E+01_JPRB, 0.102413E+01_JPRB, 0.102000E+01_JPRB &
  &, 0.101543E+01_JPRB, 0.101043E+01_JPRB, 0.100500E+01_JPRB, 0.999153E+00_JPRB &
  &, 0.992884E+00_JPRB, 0.986201E+00_JPRB, 0.979105E+00_JPRB &
  &, 0.971609E+00_JPRB, 0.963714E+00_JPRB, 0.955426E+00_JPRB, 0.946756E+00_JPRB &
  &, 0.937710E+00_JPRB, 0.928294E+00_JPRB, 0.918522E+00_JPRB &
  &, 0.908402E+00_JPRB, 0.897941E+00_JPRB, 0.887151E+00_JPRB, 0.876037E+00_JPRB &
  &, 0.864623E+00_JPRB, 0.852921E+00_JPRB, 0.840931E+00_JPRB &
  &, 0.828673E+00_JPRB, 0.816163E+00_JPRB, 0.803406E+00_JPRB, 0.790433E+00_JPRB &
  &, 0.777233E+00_JPRB, 0.763852E+00_JPRB, 0.750269E+00_JPRB &
  &, 0.736524E+00_JPRB, 0.722636E+00_JPRB, 0.708595E+00_JPRB, 0.694437E+00_JPRB &
  &, 0.680182E+00_JPRB, 0.665823E+00_JPRB, 0.651397E+00_JPRB &
  &, 0.636914E+00_JPRB, 0.622381E+00_JPRB, 0.607824E+00_JPRB, 0.593250E+00_JPRB &
  &, 0.578684E+00_JPRB, 0.564118E+00_JPRB, 0.549611E+00_JPRB &
  &, 0.535136E+00_JPRB, 0.520716E+00_JPRB, 0.506377E+00_JPRB, 0.492124E+00_JPRB &
  &, 0.477980E+00_JPRB, 0.463950E+00_JPRB, 0.450036E+00_JPRB &
  &, 0.436260E+00_JPRB, 0.422643E+00_JPRB, 0.409186E+00_JPRB, 0.395909E+00_JPRB &
  &, 0.382808E+00_JPRB, 0.369902E+00_JPRB, 0.357185E+00_JPRB &
  &, 0.344672E+00_JPRB, 0.332405E+00_JPRB, 0.320348E+00_JPRB, 0.308515E+00_JPRB &
  &, 0.296917E+00_JPRB, 0.285565E+00_JPRB, 0.274470E+00_JPRB &
  &, 0.263612E+00_JPRB, 0.253000E+00_JPRB, 0.242666E+00_JPRB, 0.232588E+00_JPRB &
  &, 0.222798E+00_JPRB, 0.213240E+00_JPRB, 0.203944E+00_JPRB &
  &, 0.194939E+00_JPRB, 0.186195E+00_JPRB, 0.177706E+00_JPRB, 0.169500E+00_JPRB &
  &, 0.161574E+00_JPRB, 0.153884E+00_JPRB, 0.146457E+00_JPRB &
  &, 0.139281E+00_JPRB, 0.132381E+00_JPRB, 0.125708E+00_JPRB, 0.119320E+00_JPRB &
  &, 0.113166E+00_JPRB, 0.107227E+00_JPRB, 0.101562E+00_JPRB &
  &, 0.960720E-01_JPRB, 0.908549E-01_JPRB, 0.858483E-01_JPRB, 0.810691E-01_JPRB &
  &, 0.764918E-01_JPRB, 0.721321E-01_JPRB, 0.679618E-01_JPRB &
  &, 0.639503E-01_JPRB, 0.602011E-01_JPRB, 0.565922E-01_JPRB, 0.531347E-01_JPRB &
  &, 0.498872E-01_JPRB, 0.468147E-01_JPRB, 0.438796E-01_JPRB &
  &, 0.410916E-01_JPRB, 0.384602E-01_JPRB, 0.359441E-01_JPRB, 0.336032E-01_JPRB &
  &, 0.313949E-01_JPRB, 0.292737E-01_JPRB, 0.272999E-01_JPRB &
  &, 0.254269E-01_JPRB, 0.237167E-01_JPRB, 0.220647E-01_JPRB, 0.204749E-01_JPRB &
  &, 0.190680E-01_JPRB, 0.176758E-01_JPRB, 0.164201E-01_JPRB &
  &, 0.151861E-01_JPRB, 0.140990E-01_JPRB, 0.130410E-01_JPRB, 0.120776E-01_JPRB &
  &, 0.111492E-01_JPRB, 0.102582E-01_JPRB, 0.947240E-02_JPRB/)
XCW( 594, :) = (/ &
  &  0.102049E+01_JPRB, 0.102460E+01_JPRB, 0.102830E+01_JPRB, 0.103158E+01_JPRB &
  &, 0.103444E+01_JPRB, 0.103687E+01_JPRB, 0.103889E+01_JPRB &
  &, 0.104048E+01_JPRB, 0.104164E+01_JPRB, 0.104237E+01_JPRB, 0.104267E+01_JPRB &
  &, 0.104253E+01_JPRB, 0.104195E+01_JPRB, 0.104094E+01_JPRB &
  &, 0.103948E+01_JPRB, 0.103760E+01_JPRB, 0.103527E+01_JPRB, 0.103250E+01_JPRB &
  &, 0.102930E+01_JPRB, 0.102566E+01_JPRB, 0.102158E+01_JPRB &
  &, 0.101707E+01_JPRB, 0.101214E+01_JPRB, 0.100677E+01_JPRB, 0.100098E+01_JPRB &
  &, 0.994772E+00_JPRB, 0.988146E+00_JPRB, 0.981109E+00_JPRB &
  &, 0.973670E+00_JPRB, 0.965829E+00_JPRB, 0.957594E+00_JPRB, 0.948978E+00_JPRB &
  &, 0.939980E+00_JPRB, 0.930617E+00_JPRB, 0.920890E+00_JPRB &
  &, 0.910811E+00_JPRB, 0.900392E+00_JPRB, 0.889654E+00_JPRB, 0.878584E+00_JPRB &
  &, 0.867213E+00_JPRB, 0.855545E+00_JPRB, 0.843588E+00_JPRB &
  &, 0.831375E+00_JPRB, 0.818887E+00_JPRB, 0.806163E+00_JPRB, 0.793212E+00_JPRB &
  &, 0.780055E+00_JPRB, 0.766681E+00_JPRB, 0.753129E+00_JPRB &
  &, 0.739415E+00_JPRB, 0.725529E+00_JPRB, 0.711518E+00_JPRB, 0.697373E+00_JPRB &
  &, 0.683115E+00_JPRB, 0.668781E+00_JPRB, 0.654350E+00_JPRB &
  &, 0.639874E+00_JPRB, 0.625347E+00_JPRB, 0.610777E+00_JPRB, 0.596204E+00_JPRB &
  &, 0.581638E+00_JPRB, 0.567069E+00_JPRB, 0.552540E+00_JPRB &
  &, 0.538057E+00_JPRB, 0.523629E+00_JPRB, 0.509278E+00_JPRB, 0.495010E+00_JPRB &
  &, 0.480850E+00_JPRB, 0.466780E+00_JPRB, 0.452865E+00_JPRB &
  &, 0.439065E+00_JPRB, 0.425421E+00_JPRB, 0.411934E+00_JPRB, 0.398624E+00_JPRB &
  &, 0.385487E+00_JPRB, 0.372543E+00_JPRB, 0.359784E+00_JPRB &
  &, 0.347250E+00_JPRB, 0.334910E+00_JPRB, 0.322828E+00_JPRB, 0.310940E+00_JPRB &
  &, 0.299310E+00_JPRB, 0.287924E+00_JPRB, 0.276765E+00_JPRB &
  &, 0.265868E+00_JPRB, 0.255213E+00_JPRB, 0.244834E+00_JPRB, 0.234708E+00_JPRB &
  &, 0.224868E+00_JPRB, 0.215256E+00_JPRB, 0.205934E+00_JPRB &
  &, 0.196871E+00_JPRB, 0.188064E+00_JPRB, 0.179543E+00_JPRB, 0.171270E+00_JPRB &
  &, 0.163272E+00_JPRB, 0.155544E+00_JPRB, 0.148074E+00_JPRB &
  &, 0.140855E+00_JPRB, 0.133909E+00_JPRB, 0.127188E+00_JPRB, 0.120750E+00_JPRB &
  &, 0.114505E+00_JPRB, 0.108549E+00_JPRB, 0.102827E+00_JPRB &
  &, 0.973175E-01_JPRB, 0.920389E-01_JPRB, 0.870099E-01_JPRB, 0.821650E-01_JPRB &
  &, 0.775195E-01_JPRB, 0.731326E-01_JPRB, 0.688896E-01_JPRB &
  &, 0.648926E-01_JPRB, 0.610668E-01_JPRB, 0.574250E-01_JPRB, 0.539332E-01_JPRB &
  &, 0.506501E-01_JPRB, 0.475407E-01_JPRB, 0.445674E-01_JPRB &
  &, 0.417397E-01_JPRB, 0.390673E-01_JPRB, 0.365602E-01_JPRB, 0.341761E-01_JPRB &
  &, 0.319233E-01_JPRB, 0.298096E-01_JPRB, 0.277892E-01_JPRB &
  &, 0.259231E-01_JPRB, 0.241081E-01_JPRB, 0.224616E-01_JPRB, 0.208773E-01_JPRB &
  &, 0.194177E-01_JPRB, 0.180303E-01_JPRB, 0.167195E-01_JPRB &
  &, 0.154896E-01_JPRB, 0.143451E-01_JPRB, 0.132904E-01_JPRB, 0.123303E-01_JPRB &
  &, 0.114053E-01_JPRB, 0.105176E-01_JPRB, 0.966954E-02_JPRB/)
XCW( 595, :) = (/ &
  &  0.102075E+01_JPRB, 0.102493E+01_JPRB, 0.102869E+01_JPRB, 0.103204E+01_JPRB &
  &, 0.103497E+01_JPRB, 0.103748E+01_JPRB, 0.103956E+01_JPRB &
  &, 0.104121E+01_JPRB, 0.104244E+01_JPRB, 0.104324E+01_JPRB, 0.104360E+01_JPRB &
  &, 0.104352E+01_JPRB, 0.104302E+01_JPRB, 0.104207E+01_JPRB &
  &, 0.104068E+01_JPRB, 0.103886E+01_JPRB, 0.103660E+01_JPRB, 0.103390E+01_JPRB &
  &, 0.103076E+01_JPRB, 0.102718E+01_JPRB, 0.102317E+01_JPRB &
  &, 0.101873E+01_JPRB, 0.101385E+01_JPRB, 0.100854E+01_JPRB, 0.100281E+01_JPRB &
  &, 0.996664E+00_JPRB, 0.990098E+00_JPRB, 0.983116E+00_JPRB &
  &, 0.975730E+00_JPRB, 0.967945E+00_JPRB, 0.959767E+00_JPRB, 0.951201E+00_JPRB &
  &, 0.942258E+00_JPRB, 0.932939E+00_JPRB, 0.923267E+00_JPRB &
  &, 0.913230E+00_JPRB, 0.902862E+00_JPRB, 0.892157E+00_JPRB, 0.881140E+00_JPRB &
  &, 0.869803E+00_JPRB, 0.858169E+00_JPRB, 0.846257E+00_JPRB &
  &, 0.834077E+00_JPRB, 0.821623E+00_JPRB, 0.808932E+00_JPRB, 0.796014E+00_JPRB &
  &, 0.782878E+00_JPRB, 0.769536E+00_JPRB, 0.756002E+00_JPRB &
  &, 0.742306E+00_JPRB, 0.728436E+00_JPRB, 0.714440E+00_JPRB, 0.700309E+00_JPRB &
  &, 0.686078E+00_JPRB, 0.671740E+00_JPRB, 0.657318E+00_JPRB &
  &, 0.642849E+00_JPRB, 0.628312E+00_JPRB, 0.613762E+00_JPRB, 0.599191E+00_JPRB &
  &, 0.584609E+00_JPRB, 0.570038E+00_JPRB, 0.555504E+00_JPRB &
  &, 0.540997E+00_JPRB, 0.526559E+00_JPRB, 0.512197E+00_JPRB, 0.497916E+00_JPRB &
  &, 0.483719E+00_JPRB, 0.469651E+00_JPRB, 0.455694E+00_JPRB &
  &, 0.441869E+00_JPRB, 0.428199E+00_JPRB, 0.414682E+00_JPRB, 0.401339E+00_JPRB &
  &, 0.388167E+00_JPRB, 0.375183E+00_JPRB, 0.362406E+00_JPRB &
  &, 0.349829E+00_JPRB, 0.337466E+00_JPRB, 0.325332E+00_JPRB, 0.313416E+00_JPRB &
  &, 0.301730E+00_JPRB, 0.290284E+00_JPRB, 0.279088E+00_JPRB &
  &, 0.268151E+00_JPRB, 0.257454E+00_JPRB, 0.247031E+00_JPRB, 0.236858E+00_JPRB &
  &, 0.226937E+00_JPRB, 0.217303E+00_JPRB, 0.207925E+00_JPRB &
  &, 0.198803E+00_JPRB, 0.189966E+00_JPRB, 0.181380E+00_JPRB, 0.173073E+00_JPRB &
  &, 0.165005E+00_JPRB, 0.157237E+00_JPRB, 0.149692E+00_JPRB &
  &, 0.142429E+00_JPRB, 0.135437E+00_JPRB, 0.128668E+00_JPRB, 0.122180E+00_JPRB &
  &, 0.115920E+00_JPRB, 0.109872E+00_JPRB, 0.104092E+00_JPRB &
  &, 0.985630E-01_JPRB, 0.932230E-01_JPRB, 0.881301E-01_JPRB, 0.832610E-01_JPRB &
  &, 0.785901E-01_JPRB, 0.741331E-01_JPRB, 0.699058E-01_JPRB &
  &, 0.658348E-01_JPRB, 0.619781E-01_JPRB, 0.582578E-01_JPRB, 0.547787E-01_JPRB &
  &, 0.514130E-01_JPRB, 0.482667E-01_JPRB, 0.452552E-01_JPRB &
  &, 0.424377E-01_JPRB, 0.397251E-01_JPRB, 0.371762E-01_JPRB, 0.347490E-01_JPRB &
  &, 0.324516E-01_JPRB, 0.303456E-01_JPRB, 0.282785E-01_JPRB &
  &, 0.263642E-01_JPRB, 0.245554E-01_JPRB, 0.228585E-01_JPRB, 0.212797E-01_JPRB &
  &, 0.197674E-01_JPRB, 0.183848E-01_JPRB, 0.170789E-01_JPRB &
  &, 0.157931E-01_JPRB, 0.146527E-01_JPRB, 0.136022E-01_JPRB, 0.125830E-01_JPRB &
  &, 0.115973E-01_JPRB, 0.107122E-01_JPRB, 0.993238E-02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART85',1,ZHOOK_HANDLE)
END SUBROUTINE PART85

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART86

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART86',0,ZHOOK_HANDLE)

XCW( 596, :) = (/ &
  &  0.102101E+01_JPRB, 0.102525E+01_JPRB, 0.102909E+01_JPRB, 0.103250E+01_JPRB &
  &, 0.103550E+01_JPRB, 0.103807E+01_JPRB, 0.104022E+01_JPRB &
  &, 0.104195E+01_JPRB, 0.104324E+01_JPRB, 0.104410E+01_JPRB, 0.104453E+01_JPRB &
  &, 0.104453E+01_JPRB, 0.104408E+01_JPRB, 0.104320E+01_JPRB &
  &, 0.104188E+01_JPRB, 0.104013E+01_JPRB, 0.103793E+01_JPRB, 0.103529E+01_JPRB &
  &, 0.103222E+01_JPRB, 0.102871E+01_JPRB, 0.102476E+01_JPRB &
  &, 0.102038E+01_JPRB, 0.101556E+01_JPRB, 0.101032E+01_JPRB, 0.100465E+01_JPRB &
  &, 0.998559E+00_JPRB, 0.992050E+00_JPRB, 0.985127E+00_JPRB &
  &, 0.977799E+00_JPRB, 0.970069E+00_JPRB, 0.961943E+00_JPRB, 0.953432E+00_JPRB &
  &, 0.944537E+00_JPRB, 0.935271E+00_JPRB, 0.925644E+00_JPRB &
  &, 0.915657E+00_JPRB, 0.905332E+00_JPRB, 0.894680E+00_JPRB, 0.883697E+00_JPRB &
  &, 0.872404E+00_JPRB, 0.860814E+00_JPRB, 0.848936E+00_JPRB &
  &, 0.836780E+00_JPRB, 0.824370E+00_JPRB, 0.811713E+00_JPRB, 0.798816E+00_JPRB &
  &, 0.785700E+00_JPRB, 0.772391E+00_JPRB, 0.758876E+00_JPRB &
  &, 0.745196E+00_JPRB, 0.731357E+00_JPRB, 0.717376E+00_JPRB, 0.703259E+00_JPRB &
  &, 0.689026E+00_JPRB, 0.674714E+00_JPRB, 0.660301E+00_JPRB &
  &, 0.645825E+00_JPRB, 0.631309E+00_JPRB, 0.616747E+00_JPRB, 0.602162E+00_JPRB &
  &, 0.587579E+00_JPRB, 0.573006E+00_JPRB, 0.558468E+00_JPRB &
  &, 0.543955E+00_JPRB, 0.529509E+00_JPRB, 0.515116E+00_JPRB, 0.500821E+00_JPRB &
  &, 0.486609E+00_JPRB, 0.472522E+00_JPRB, 0.458544E+00_JPRB &
  &, 0.444695E+00_JPRB, 0.430998E+00_JPRB, 0.417452E+00_JPRB, 0.404076E+00_JPRB &
  &, 0.390869E+00_JPRB, 0.377847E+00_JPRB, 0.365029E+00_JPRB &
  &, 0.352431E+00_JPRB, 0.340021E+00_JPRB, 0.327837E+00_JPRB, 0.315867E+00_JPRB &
  &, 0.304149E+00_JPRB, 0.292670E+00_JPRB, 0.281438E+00_JPRB &
  &, 0.270435E+00_JPRB, 0.259696E+00_JPRB, 0.249228E+00_JPRB, 0.239007E+00_JPRB &
  &, 0.229037E+00_JPRB, 0.219349E+00_JPRB, 0.209915E+00_JPRB &
  &, 0.200766E+00_JPRB, 0.191868E+00_JPRB, 0.183218E+00_JPRB, 0.174876E+00_JPRB &
  &, 0.166772E+00_JPRB, 0.158931E+00_JPRB, 0.151345E+00_JPRB &
  &, 0.144039E+00_JPRB, 0.136966E+00_JPRB, 0.130185E+00_JPRB, 0.123610E+00_JPRB &
  &, 0.117298E+00_JPRB, 0.111233E+00_JPRB, 0.105396E+00_JPRB &
  &, 0.998084E-01_JPRB, 0.944479E-01_JPRB, 0.892918E-01_JPRB, 0.843991E-01_JPRB &
  &, 0.796607E-01_JPRB, 0.751771E-01_JPRB, 0.708778E-01_JPRB &
  &, 0.667771E-01_JPRB, 0.628438E-01_JPRB, 0.591368E-01_JPRB, 0.555772E-01_JPRB &
  &, 0.522237E-01_JPRB, 0.490412E-01_JPRB, 0.459921E-01_JPRB &
  &, 0.430858E-01_JPRB, 0.403827E-01_JPRB, 0.377922E-01_JPRB, 0.353220E-01_JPRB &
  &, 0.330328E-01_JPRB, 0.308280E-01_JPRB, 0.287677E-01_JPRB &
  &, 0.268604E-01_JPRB, 0.250027E-01_JPRB, 0.233120E-01_JPRB, 0.216821E-01_JPRB &
  &, 0.201754E-01_JPRB, 0.187393E-01_JPRB, 0.173783E-01_JPRB &
  &, 0.161574E-01_JPRB, 0.149603E-01_JPRB, 0.138516E-01_JPRB, 0.128357E-01_JPRB &
  &, 0.118534E-01_JPRB, 0.109716E-01_JPRB, 0.101295E-01_JPRB/)
XCW( 597, :) = (/ &
  &  0.102127E+01_JPRB, 0.102558E+01_JPRB, 0.102948E+01_JPRB, 0.103296E+01_JPRB &
  &, 0.103603E+01_JPRB, 0.103867E+01_JPRB, 0.104089E+01_JPRB &
  &, 0.104268E+01_JPRB, 0.104404E+01_JPRB, 0.104497E+01_JPRB, 0.104547E+01_JPRB &
  &, 0.104553E+01_JPRB, 0.104515E+01_JPRB, 0.104434E+01_JPRB &
  &, 0.104309E+01_JPRB, 0.104140E+01_JPRB, 0.103926E+01_JPRB, 0.103669E+01_JPRB &
  &, 0.103368E+01_JPRB, 0.103024E+01_JPRB, 0.102635E+01_JPRB &
  &, 0.102203E+01_JPRB, 0.101728E+01_JPRB, 0.101210E+01_JPRB, 0.100649E+01_JPRB &
  &, 0.100046E+01_JPRB, 0.994006E+00_JPRB, 0.987142E+00_JPRB &
  &, 0.979871E+00_JPRB, 0.972196E+00_JPRB, 0.964124E+00_JPRB, 0.955663E+00_JPRB &
  &, 0.946824E+00_JPRB, 0.937607E+00_JPRB, 0.928030E+00_JPRB &
  &, 0.918094E+00_JPRB, 0.907812E+00_JPRB, 0.897202E+00_JPRB, 0.886263E+00_JPRB &
  &, 0.875004E+00_JPRB, 0.863459E+00_JPRB, 0.851615E+00_JPRB &
  &, 0.839504E+00_JPRB, 0.827117E+00_JPRB, 0.814494E+00_JPRB, 0.801630E+00_JPRB &
  &, 0.788547E+00_JPRB, 0.775258E+00_JPRB, 0.761775E+00_JPRB &
  &, 0.748113E+00_JPRB, 0.734291E+00_JPRB, 0.720312E+00_JPRB, 0.706222E+00_JPRB &
  &, 0.692003E+00_JPRB, 0.677687E+00_JPRB, 0.663284E+00_JPRB &
  &, 0.648831E+00_JPRB, 0.634307E+00_JPRB, 0.619749E+00_JPRB, 0.605166E+00_JPRB &
  &, 0.590584E+00_JPRB, 0.576010E+00_JPRB, 0.561451E+00_JPRB &
  &, 0.546931E+00_JPRB, 0.532458E+00_JPRB, 0.518074E+00_JPRB, 0.503746E+00_JPRB &
  &, 0.489518E+00_JPRB, 0.475393E+00_JPRB, 0.461393E+00_JPRB &
  &, 0.447521E+00_JPRB, 0.433797E+00_JPRB, 0.420221E+00_JPRB, 0.406814E+00_JPRB &
  &, 0.393594E+00_JPRB, 0.380534E+00_JPRB, 0.367675E+00_JPRB &
  &, 0.355033E+00_JPRB, 0.342601E+00_JPRB, 0.330367E+00_JPRB, 0.318369E+00_JPRB &
  &, 0.306595E+00_JPRB, 0.295083E+00_JPRB, 0.283788E+00_JPRB &
  &, 0.272746E+00_JPRB, 0.261966E+00_JPRB, 0.251454E+00_JPRB, 0.241186E+00_JPRB &
  &, 0.231166E+00_JPRB, 0.221426E+00_JPRB, 0.211937E+00_JPRB &
  &, 0.202729E+00_JPRB, 0.193770E+00_JPRB, 0.185088E+00_JPRB, 0.176679E+00_JPRB &
  &, 0.168539E+00_JPRB, 0.160625E+00_JPRB, 0.152998E+00_JPRB &
  &, 0.145649E+00_JPRB, 0.138530E+00_JPRB, 0.131665E+00_JPRB, 0.125077E+00_JPRB &
  &, 0.118713E+00_JPRB, 0.112594E+00_JPRB, 0.106740E+00_JPRB &
  &, 0.101094E+00_JPRB, 0.956727E-01_JPRB, 0.904949E-01_JPRB, 0.854950E-01_JPRB &
  &, 0.807741E-01_JPRB, 0.762211E-01_JPRB, 0.718498E-01_JPRB &
  &, 0.677194E-01_JPRB, 0.637551E-01_JPRB, 0.600159E-01_JPRB, 0.564227E-01_JPRB &
  &, 0.530343E-01_JPRB, 0.497672E-01_JPRB, 0.467290E-01_JPRB &
  &, 0.437838E-01_JPRB, 0.410405E-01_JPRB, 0.384082E-01_JPRB, 0.359470E-01_JPRB &
  &, 0.336140E-01_JPRB, 0.313639E-01_JPRB, 0.293113E-01_JPRB &
  &, 0.273566E-01_JPRB, 0.254500E-01_JPRB, 0.237089E-01_JPRB, 0.220845E-01_JPRB &
  &, 0.205251E-01_JPRB, 0.190938E-01_JPRB, 0.177377E-01_JPRB &
  &, 0.164609E-01_JPRB, 0.152679E-01_JPRB, 0.141633E-01_JPRB, 0.130884E-01_JPRB &
  &, 0.121095E-01_JPRB, 0.112311E-01_JPRB, 0.103266E-01_JPRB/)
XCW( 598, :) = (/ &
  &  0.102154E+01_JPRB, 0.102591E+01_JPRB, 0.102988E+01_JPRB, 0.103343E+01_JPRB &
  &, 0.103656E+01_JPRB, 0.103927E+01_JPRB, 0.104155E+01_JPRB &
  &, 0.104341E+01_JPRB, 0.104484E+01_JPRB, 0.104584E+01_JPRB, 0.104640E+01_JPRB &
  &, 0.104653E+01_JPRB, 0.104622E+01_JPRB, 0.104548E+01_JPRB &
  &, 0.104429E+01_JPRB, 0.104267E+01_JPRB, 0.104060E+01_JPRB, 0.103809E+01_JPRB &
  &, 0.103515E+01_JPRB, 0.103176E+01_JPRB, 0.102795E+01_JPRB &
  &, 0.102369E+01_JPRB, 0.101900E+01_JPRB, 0.101388E+01_JPRB, 0.100833E+01_JPRB &
  &, 0.100236E+01_JPRB, 0.995969E+00_JPRB, 0.988676E+00_JPRB &
  &, 0.981947E+00_JPRB, 0.974328E+00_JPRB, 0.966313E+00_JPRB, 0.957903E+00_JPRB &
  &, 0.949116E+00_JPRB, 0.939952E+00_JPRB, 0.930420E+00_JPRB &
  &, 0.920531E+00_JPRB, 0.910301E+00_JPRB, 0.899725E+00_JPRB, 0.888830E+00_JPRB &
  &, 0.877625E+00_JPRB, 0.866104E+00_JPRB, 0.854305E+00_JPRB &
  &, 0.842228E+00_JPRB, 0.829876E+00_JPRB, 0.817286E+00_JPRB, 0.804444E+00_JPRB &
  &, 0.791394E+00_JPRB, 0.778125E+00_JPRB, 0.764661E+00_JPRB &
  &, 0.751030E+00_JPRB, 0.737225E+00_JPRB, 0.723275E+00_JPRB, 0.709187E+00_JPRB &
  &, 0.694994E+00_JPRB, 0.680690E+00_JPRB, 0.666297E+00_JPRB &
  &, 0.651838E+00_JPRB, 0.637320E+00_JPRB, 0.622766E+00_JPRB, 0.608170E+00_JPRB &
  &, 0.593589E+00_JPRB, 0.579013E+00_JPRB, 0.564450E+00_JPRB &
  &, 0.549907E+00_JPRB, 0.535444E+00_JPRB, 0.521031E+00_JPRB, 0.506691E+00_JPRB &
  &, 0.492448E+00_JPRB, 0.478305E+00_JPRB, 0.464284E+00_JPRB &
  &, 0.450389E+00_JPRB, 0.436639E+00_JPRB, 0.423035E+00_JPRB, 0.409596E+00_JPRB &
  &, 0.396319E+00_JPRB, 0.383245E+00_JPRB, 0.370345E+00_JPRB &
  &, 0.357660E+00_JPRB, 0.345181E+00_JPRB, 0.332922E+00_JPRB, 0.320872E+00_JPRB &
  &, 0.309068E+00_JPRB, 0.297496E+00_JPRB, 0.286165E+00_JPRB &
  &, 0.275085E+00_JPRB, 0.264264E+00_JPRB, 0.253680E+00_JPRB, 0.243366E+00_JPRB &
  &, 0.233296E+00_JPRB, 0.223503E+00_JPRB, 0.213990E+00_JPRB &
  &, 0.204724E+00_JPRB, 0.195704E+00_JPRB, 0.186991E+00_JPRB, 0.178516E+00_JPRB &
  &, 0.170306E+00_JPRB, 0.162389E+00_JPRB, 0.154686E+00_JPRB &
  &, 0.147259E+00_JPRB, 0.140131E+00_JPRB, 0.133219E+00_JPRB, 0.126544E+00_JPRB &
  &, 0.120128E+00_JPRB, 0.113994E+00_JPRB, 0.108045E+00_JPRB &
  &, 0.102380E+00_JPRB, 0.968976E-01_JPRB, 0.916566E-01_JPRB, 0.866332E-01_JPRB &
  &, 0.818447E-01_JPRB, 0.772650E-01_JPRB, 0.728660E-01_JPRB &
  &, 0.687065E-01_JPRB, 0.647120E-01_JPRB, 0.608949E-01_JPRB, 0.572682E-01_JPRB &
  &, 0.538449E-01_JPRB, 0.505416E-01_JPRB, 0.474659E-01_JPRB &
  &, 0.444818E-01_JPRB, 0.416982E-01_JPRB, 0.390756E-01_JPRB, 0.365719E-01_JPRB &
  &, 0.341952E-01_JPRB, 0.319535E-01_JPRB, 0.298006E-01_JPRB &
  &, 0.277977E-01_JPRB, 0.259532E-01_JPRB, 0.241625E-01_JPRB, 0.224869E-01_JPRB &
  &, 0.209330E-01_JPRB, 0.194483E-01_JPRB, 0.180970E-01_JPRB &
  &, 0.167644E-01_JPRB, 0.155755E-01_JPRB, 0.144127E-01_JPRB, 0.133412E-01_JPRB &
  &, 0.123655E-01_JPRB, 0.114257E-01_JPRB, 0.105895E-01_JPRB/)
XCW( 599, :) = (/ &
  &  0.102180E+01_JPRB, 0.102624E+01_JPRB, 0.103027E+01_JPRB, 0.103389E+01_JPRB &
  &, 0.103709E+01_JPRB, 0.103987E+01_JPRB, 0.104222E+01_JPRB &
  &, 0.104414E+01_JPRB, 0.104564E+01_JPRB, 0.104671E+01_JPRB, 0.104734E+01_JPRB &
  &, 0.104754E+01_JPRB, 0.104729E+01_JPRB, 0.104662E+01_JPRB &
  &, 0.104550E+01_JPRB, 0.104394E+01_JPRB, 0.104194E+01_JPRB, 0.103950E+01_JPRB &
  &, 0.103662E+01_JPRB, 0.103330E+01_JPRB, 0.102954E+01_JPRB &
  &, 0.102535E+01_JPRB, 0.102072E+01_JPRB, 0.101567E+01_JPRB, 0.101018E+01_JPRB &
  &, 0.100427E+01_JPRB, 0.997936E+00_JPRB, 0.991187E+00_JPRB &
  &, 0.984027E+00_JPRB, 0.976464E+00_JPRB, 0.968502E+00_JPRB, 0.960150E+00_JPRB &
  &, 0.951411E+00_JPRB, 0.942296E+00_JPRB, 0.932815E+00_JPRB &
  &, 0.922978E+00_JPRB, 0.912790E+00_JPRB, 0.902268E+00_JPRB, 0.891406E+00_JPRB &
  &, 0.880246E+00_JPRB, 0.868770E+00_JPRB, 0.857006E+00_JPRB &
  &, 0.844953E+00_JPRB, 0.832645E+00_JPRB, 0.820078E+00_JPRB, 0.807282E+00_JPRB &
  &, 0.794254E+00_JPRB, 0.781004E+00_JPRB, 0.767572E+00_JPRB &
  &, 0.753961E+00_JPRB, 0.740172E+00_JPRB, 0.726238E+00_JPRB, 0.712165E+00_JPRB &
  &, 0.697986E+00_JPRB, 0.683694E+00_JPRB, 0.669311E+00_JPRB &
  &, 0.654844E+00_JPRB, 0.640333E+00_JPRB, 0.625784E+00_JPRB, 0.611208E+00_JPRB &
  &, 0.596610E+00_JPRB, 0.582016E+00_JPRB, 0.567450E+00_JPRB &
  &, 0.552920E+00_JPRB, 0.538431E+00_JPRB, 0.523988E+00_JPRB, 0.509635E+00_JPRB &
  &, 0.495377E+00_JPRB, 0.481216E+00_JPRB, 0.467175E+00_JPRB &
  &, 0.453257E+00_JPRB, 0.439482E+00_JPRB, 0.425849E+00_JPRB, 0.412378E+00_JPRB &
  &, 0.399067E+00_JPRB, 0.385956E+00_JPRB, 0.373040E+00_JPRB &
  &, 0.360311E+00_JPRB, 0.347786E+00_JPRB, 0.335477E+00_JPRB, 0.323400E+00_JPRB &
  &, 0.311540E+00_JPRB, 0.299935E+00_JPRB, 0.288570E+00_JPRB &
  &, 0.277425E+00_JPRB, 0.266563E+00_JPRB, 0.255935E+00_JPRB, 0.245574E+00_JPRB &
  &, 0.235455E+00_JPRB, 0.225611E+00_JPRB, 0.216042E+00_JPRB &
  &, 0.206719E+00_JPRB, 0.197670E+00_JPRB, 0.188894E+00_JPRB, 0.180352E+00_JPRB &
  &, 0.172107E+00_JPRB, 0.164117E+00_JPRB, 0.156375E+00_JPRB &
  &, 0.148904E+00_JPRB, 0.141696E+00_JPRB, 0.134736E+00_JPRB, 0.128049E+00_JPRB &
  &, 0.121582E+00_JPRB, 0.115355E+00_JPRB, 0.109389E+00_JPRB &
  &, 0.103665E+00_JPRB, 0.981633E-01_JPRB, 0.928597E-01_JPRB, 0.878134E-01_JPRB &
  &, 0.829581E-01_JPRB, 0.783525E-01_JPRB, 0.738822E-01_JPRB &
  &, 0.696937E-01_JPRB, 0.656233E-01_JPRB, 0.618202E-01_JPRB, 0.581606E-01_JPRB &
  &, 0.546555E-01_JPRB, 0.513645E-01_JPRB, 0.482027E-01_JPRB &
  &, 0.452297E-01_JPRB, 0.424064E-01_JPRB, 0.396916E-01_JPRB, 0.371448E-01_JPRB &
  &, 0.347764E-01_JPRB, 0.324895E-01_JPRB, 0.303442E-01_JPRB &
  &, 0.282939E-01_JPRB, 0.264005E-01_JPRB, 0.246160E-01_JPRB, 0.229468E-01_JPRB &
  &, 0.213410E-01_JPRB, 0.198619E-01_JPRB, 0.184563E-01_JPRB &
  &, 0.171286E-01_JPRB, 0.158832E-01_JPRB, 0.147245E-01_JPRB, 0.136571E-01_JPRB &
  &, 0.126216E-01_JPRB, 0.116851E-01_JPRB, 0.107866E-01_JPRB/)
XCW( 600, :) = (/ &
  &  0.102206E+01_JPRB, 0.102657E+01_JPRB, 0.103067E+01_JPRB, 0.103435E+01_JPRB &
  &, 0.103762E+01_JPRB, 0.104046E+01_JPRB, 0.104287E+01_JPRB &
  &, 0.104488E+01_JPRB, 0.104644E+01_JPRB, 0.104758E+01_JPRB, 0.104828E+01_JPRB &
  &, 0.104854E+01_JPRB, 0.104837E+01_JPRB, 0.104776E+01_JPRB &
  &, 0.104670E+01_JPRB, 0.104521E+01_JPRB, 0.104328E+01_JPRB, 0.104090E+01_JPRB &
  &, 0.103809E+01_JPRB, 0.103484E+01_JPRB, 0.103114E+01_JPRB &
  &, 0.102701E+01_JPRB, 0.102245E+01_JPRB, 0.101745E+01_JPRB, 0.101203E+01_JPRB &
  &, 0.100618E+01_JPRB, 0.999903E+00_JPRB, 0.993214E+00_JPRB &
  &, 0.986112E+00_JPRB, 0.978603E+00_JPRB, 0.970699E+00_JPRB, 0.962398E+00_JPRB &
  &, 0.953712E+00_JPRB, 0.944650E+00_JPRB, 0.935219E+00_JPRB &
  &, 0.925424E+00_JPRB, 0.915289E+00_JPRB, 0.904800E+00_JPRB, 0.893993E+00_JPRB &
  &, 0.882867E+00_JPRB, 0.871436E+00_JPRB, 0.859707E+00_JPRB &
  &, 0.847699E+00_JPRB, 0.835427E+00_JPRB, 0.822894E+00_JPRB, 0.810120E+00_JPRB &
  &, 0.797113E+00_JPRB, 0.783896E+00_JPRB, 0.770484E+00_JPRB &
  &, 0.756891E+00_JPRB, 0.743133E+00_JPRB, 0.729216E+00_JPRB, 0.715157E+00_JPRB &
  &, 0.700991E+00_JPRB, 0.686697E+00_JPRB, 0.672324E+00_JPRB &
  &, 0.657882E+00_JPRB, 0.643377E+00_JPRB, 0.628818E+00_JPRB, 0.614245E+00_JPRB &
  &, 0.599649E+00_JPRB, 0.585054E+00_JPRB, 0.570468E+00_JPRB &
  &, 0.555932E+00_JPRB, 0.541417E+00_JPRB, 0.526984E+00_JPRB, 0.512619E+00_JPRB &
  &, 0.498326E+00_JPRB, 0.484148E+00_JPRB, 0.470087E+00_JPRB &
  &, 0.456146E+00_JPRB, 0.442324E+00_JPRB, 0.428663E+00_JPRB, 0.415161E+00_JPRB &
  &, 0.401838E+00_JPRB, 0.388690E+00_JPRB, 0.375734E+00_JPRB &
  &, 0.362962E+00_JPRB, 0.350415E+00_JPRB, 0.338058E+00_JPRB, 0.325954E+00_JPRB &
  &, 0.314038E+00_JPRB, 0.302402E+00_JPRB, 0.290974E+00_JPRB &
  &, 0.279792E+00_JPRB, 0.268861E+00_JPRB, 0.258190E+00_JPRB, 0.247783E+00_JPRB &
  &, 0.237615E+00_JPRB, 0.227749E+00_JPRB, 0.218095E+00_JPRB &
  &, 0.208745E+00_JPRB, 0.199636E+00_JPRB, 0.190796E+00_JPRB, 0.182222E+00_JPRB &
  &, 0.173907E+00_JPRB, 0.165880E+00_JPRB, 0.158098E+00_JPRB &
  &, 0.150586E+00_JPRB, 0.143333E+00_JPRB, 0.136290E+00_JPRB, 0.129554E+00_JPRB &
  &, 0.123036E+00_JPRB, 0.116794E+00_JPRB, 0.110772E+00_JPRB &
  &, 0.104951E+00_JPRB, 0.994290E-01_JPRB, 0.940629E-01_JPRB, 0.889937E-01_JPRB &
  &, 0.840714E-01_JPRB, 0.793965E-01_JPRB, 0.749426E-01_JPRB &
  &, 0.706808E-01_JPRB, 0.665801E-01_JPRB, 0.626992E-01_JPRB, 0.590061E-01_JPRB &
  &, 0.555138E-01_JPRB, 0.521389E-01_JPRB, 0.489396E-01_JPRB &
  &, 0.459277E-01_JPRB, 0.430642E-01_JPRB, 0.403589E-01_JPRB, 0.377698E-01_JPRB &
  &, 0.353576E-01_JPRB, 0.330254E-01_JPRB, 0.308879E-01_JPRB &
  &, 0.288452E-01_JPRB, 0.269037E-01_JPRB, 0.250696E-01_JPRB, 0.233492E-01_JPRB &
  &, 0.217490E-01_JPRB, 0.202164E-01_JPRB, 0.188157E-01_JPRB &
  &, 0.174321E-01_JPRB, 0.161908E-01_JPRB, 0.150362E-01_JPRB, 0.139098E-01_JPRB &
  &, 0.128777E-01_JPRB, 0.119446E-01_JPRB, 0.110495E-01_JPRB/)
XCW( 601, :) = (/ &
  &  0.102232E+01_JPRB, 0.102690E+01_JPRB, 0.103107E+01_JPRB, 0.103482E+01_JPRB &
  &, 0.103815E+01_JPRB, 0.104106E+01_JPRB, 0.104355E+01_JPRB &
  &, 0.104561E+01_JPRB, 0.104725E+01_JPRB, 0.104845E+01_JPRB, 0.104922E+01_JPRB &
  &, 0.104955E+01_JPRB, 0.104944E+01_JPRB, 0.104890E+01_JPRB &
  &, 0.104791E+01_JPRB, 0.104649E+01_JPRB, 0.104462E+01_JPRB, 0.104231E+01_JPRB &
  &, 0.103956E+01_JPRB, 0.103637E+01_JPRB, 0.103275E+01_JPRB &
  &, 0.102868E+01_JPRB, 0.102418E+01_JPRB, 0.101924E+01_JPRB, 0.101388E+01_JPRB &
  &, 0.100809E+01_JPRB, 0.100188E+01_JPRB, 0.995244E+00_JPRB &
  &, 0.988199E+00_JPRB, 0.980751E+00_JPRB, 0.972896E+00_JPRB, 0.964650E+00_JPRB &
  &, 0.956020E+00_JPRB, 0.947008E+00_JPRB, 0.937628E+00_JPRB &
  &, 0.927879E+00_JPRB, 0.917787E+00_JPRB, 0.907352E+00_JPRB, 0.896590E+00_JPRB &
  &, 0.885499E+00_JPRB, 0.874113E+00_JPRB, 0.862418E+00_JPRB &
  &, 0.850446E+00_JPRB, 0.838208E+00_JPRB, 0.825710E+00_JPRB, 0.812958E+00_JPRB &
  &, 0.799996E+00_JPRB, 0.786801E+00_JPRB, 0.773421E+00_JPRB &
  &, 0.759847E+00_JPRB, 0.746094E+00_JPRB, 0.732207E+00_JPRB, 0.718163E+00_JPRB &
  &, 0.703997E+00_JPRB, 0.689729E+00_JPRB, 0.675368E+00_JPRB &
  &, 0.660919E+00_JPRB, 0.646422E+00_JPRB, 0.631868E+00_JPRB, 0.617282E+00_JPRB &
  &, 0.602687E+00_JPRB, 0.588092E+00_JPRB, 0.573503E+00_JPRB &
  &, 0.558944E+00_JPRB, 0.544440E+00_JPRB, 0.529979E+00_JPRB, 0.515602E+00_JPRB &
  &, 0.501294E+00_JPRB, 0.487099E+00_JPRB, 0.472999E+00_JPRB &
  &, 0.459035E+00_JPRB, 0.445209E+00_JPRB, 0.431520E+00_JPRB, 0.417988E+00_JPRB &
  &, 0.404632E+00_JPRB, 0.391447E+00_JPRB, 0.378452E+00_JPRB &
  &, 0.365638E+00_JPRB, 0.353045E+00_JPRB, 0.340663E+00_JPRB, 0.328507E+00_JPRB &
  &, 0.316563E+00_JPRB, 0.304868E+00_JPRB, 0.293406E+00_JPRB &
  &, 0.282186E+00_JPRB, 0.271216E+00_JPRB, 0.260473E+00_JPRB, 0.250021E+00_JPRB &
  &, 0.239804E+00_JPRB, 0.229887E+00_JPRB, 0.220179E+00_JPRB &
  &, 0.210772E+00_JPRB, 0.201635E+00_JPRB, 0.192732E+00_JPRB, 0.184125E+00_JPRB &
  &, 0.175742E+00_JPRB, 0.167609E+00_JPRB, 0.159821E+00_JPRB &
  &, 0.152267E+00_JPRB, 0.144934E+00_JPRB, 0.137882E+00_JPRB, 0.131059E+00_JPRB &
  &, 0.124528E+00_JPRB, 0.118194E+00_JPRB, 0.112116E+00_JPRB &
  &, 0.106277E+00_JPRB, 0.100695E+00_JPRB, 0.953075E-01_JPRB, 0.901740E-01_JPRB &
  &, 0.852277E-01_JPRB, 0.804840E-01_JPRB, 0.760029E-01_JPRB &
  &, 0.716680E-01_JPRB, 0.675825E-01_JPRB, 0.636245E-01_JPRB, 0.598986E-01_JPRB &
  &, 0.563245E-01_JPRB, 0.529617E-01_JPRB, 0.497257E-01_JPRB &
  &, 0.466755E-01_JPRB, 0.437724E-01_JPRB, 0.410263E-01_JPRB, 0.383948E-01_JPRB &
  &, 0.359388E-01_JPRB, 0.336150E-01_JPRB, 0.314315E-01_JPRB &
  &, 0.293414E-01_JPRB, 0.273510E-01_JPRB, 0.255232E-01_JPRB, 0.238091E-01_JPRB &
  &, 0.221569E-01_JPRB, 0.206300E-01_JPRB, 0.191750E-01_JPRB &
  &, 0.177964E-01_JPRB, 0.164984E-01_JPRB, 0.153480E-01_JPRB, 0.142257E-01_JPRB &
  &, 0.131978E-01_JPRB, 0.122040E-01_JPRB, 0.112466E-01_JPRB/)
XCW( 602, :) = (/ &
  &  0.102259E+01_JPRB, 0.102723E+01_JPRB, 0.103146E+01_JPRB, 0.103528E+01_JPRB &
  &, 0.103868E+01_JPRB, 0.104166E+01_JPRB, 0.104422E+01_JPRB &
  &, 0.104635E+01_JPRB, 0.104805E+01_JPRB, 0.104932E+01_JPRB, 0.105016E+01_JPRB &
  &, 0.105056E+01_JPRB, 0.105052E+01_JPRB, 0.105004E+01_JPRB &
  &, 0.104912E+01_JPRB, 0.104776E+01_JPRB, 0.104596E+01_JPRB, 0.104372E+01_JPRB &
  &, 0.104104E+01_JPRB, 0.103792E+01_JPRB, 0.103435E+01_JPRB &
  &, 0.103035E+01_JPRB, 0.102591E+01_JPRB, 0.102104E+01_JPRB, 0.101574E+01_JPRB &
  &, 0.101001E+01_JPRB, 0.100385E+01_JPRB, 0.997282E+00_JPRB &
  &, 0.990295E+00_JPRB, 0.982899E+00_JPRB, 0.975101E+00_JPRB, 0.966911E+00_JPRB &
  &, 0.958333E+00_JPRB, 0.949371E+00_JPRB, 0.940041E+00_JPRB &
  &, 0.930344E+00_JPRB, 0.920295E+00_JPRB, 0.909904E+00_JPRB, 0.899186E+00_JPRB &
  &, 0.888140E+00_JPRB, 0.876790E+00_JPRB, 0.865141E+00_JPRB &
  &, 0.853203E+00_JPRB, 0.841000E+00_JPRB, 0.828525E+00_JPRB, 0.815820E+00_JPRB &
  &, 0.802880E+00_JPRB, 0.789718E+00_JPRB, 0.776346E+00_JPRB &
  &, 0.762804E+00_JPRB, 0.749082E+00_JPRB, 0.735198E+00_JPRB, 0.721184E+00_JPRB &
  &, 0.707032E+00_JPRB, 0.692762E+00_JPRB, 0.678411E+00_JPRB &
  &, 0.663972E+00_JPRB, 0.649482E+00_JPRB, 0.634935E+00_JPRB, 0.620352E+00_JPRB &
  &, 0.605743E+00_JPRB, 0.591147E+00_JPRB, 0.576556E+00_JPRB &
  &, 0.561993E+00_JPRB, 0.547464E+00_JPRB, 0.532993E+00_JPRB, 0.518585E+00_JPRB &
  &, 0.504283E+00_JPRB, 0.490051E+00_JPRB, 0.475952E+00_JPRB &
  &, 0.461945E+00_JPRB, 0.448094E+00_JPRB, 0.434378E+00_JPRB, 0.420815E+00_JPRB &
  &, 0.407426E+00_JPRB, 0.394205E+00_JPRB, 0.381170E+00_JPRB &
  &, 0.368337E+00_JPRB, 0.355699E+00_JPRB, 0.343269E+00_JPRB, 0.331087E+00_JPRB &
  &, 0.319088E+00_JPRB, 0.307362E+00_JPRB, 0.295838E+00_JPRB &
  &, 0.284581E+00_JPRB, 0.273543E+00_JPRB, 0.262786E+00_JPRB, 0.252288E+00_JPRB &
  &, 0.242024E+00_JPRB, 0.232025E+00_JPRB, 0.222294E+00_JPRB &
  &, 0.212830E+00_JPRB, 0.203633E+00_JPRB, 0.194701E+00_JPRB, 0.186029E+00_JPRB &
  &, 0.177611E+00_JPRB, 0.169441E+00_JPRB, 0.161580E+00_JPRB &
  &, 0.153949E+00_JPRB, 0.146571E+00_JPRB, 0.139473E+00_JPRB, 0.132602E+00_JPRB &
  &, 0.126020E+00_JPRB, 0.119633E+00_JPRB, 0.113500E+00_JPRB &
  &, 0.107643E+00_JPRB, 0.101960E+00_JPRB, 0.965521E-01_JPRB, 0.913542E-01_JPRB &
  &, 0.863839E-01_JPRB, 0.816150E-01_JPRB, 0.770633E-01_JPRB &
  &, 0.727000E-01_JPRB, 0.685394E-01_JPRB, 0.645498E-01_JPRB, 0.607910E-01_JPRB &
  &, 0.571828E-01_JPRB, 0.537846E-01_JPRB, 0.505117E-01_JPRB &
  &, 0.474233E-01_JPRB, 0.444807E-01_JPRB, 0.416936E-01_JPRB, 0.390719E-01_JPRB &
  &, 0.365729E-01_JPRB, 0.342046E-01_JPRB, 0.319751E-01_JPRB &
  &, 0.298376E-01_JPRB, 0.278542E-01_JPRB, 0.259767E-01_JPRB, 0.242115E-01_JPRB &
  &, 0.225649E-01_JPRB, 0.209845E-01_JPRB, 0.195344E-01_JPRB &
  &, 0.181606E-01_JPRB, 0.168676E-01_JPRB, 0.156597E-01_JPRB, 0.144784E-01_JPRB &
  &, 0.134539E-01_JPRB, 0.124635E-01_JPRB, 0.115094E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART86',1,ZHOOK_HANDLE)
END SUBROUTINE PART86

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART87

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART87',0,ZHOOK_HANDLE)

XCW( 603, :) = (/ &
  &  0.102285E+01_JPRB, 0.102756E+01_JPRB, 0.103186E+01_JPRB, 0.103575E+01_JPRB &
  &, 0.103922E+01_JPRB, 0.104226E+01_JPRB, 0.104489E+01_JPRB &
  &, 0.104709E+01_JPRB, 0.104886E+01_JPRB, 0.105020E+01_JPRB, 0.105110E+01_JPRB &
  &, 0.105157E+01_JPRB, 0.105160E+01_JPRB, 0.105119E+01_JPRB &
  &, 0.105034E+01_JPRB, 0.104904E+01_JPRB, 0.104731E+01_JPRB, 0.104514E+01_JPRB &
  &, 0.104252E+01_JPRB, 0.103946E+01_JPRB, 0.103596E+01_JPRB &
  &, 0.103202E+01_JPRB, 0.102765E+01_JPRB, 0.102284E+01_JPRB, 0.101760E+01_JPRB &
  &, 0.101193E+01_JPRB, 0.100583E+01_JPRB, 0.999319E+00_JPRB &
  &, 0.992391E+00_JPRB, 0.985055E+00_JPRB, 0.977315E+00_JPRB, 0.969176E+00_JPRB &
  &, 0.960650E+00_JPRB, 0.951742E+00_JPRB, 0.942318E+00_JPRB &
  &, 0.932809E+00_JPRB, 0.922813E+00_JPRB, 0.912466E+00_JPRB, 0.901793E+00_JPRB &
  &, 0.890792E+00_JPRB, 0.879477E+00_JPRB, 0.867863E+00_JPRB &
  &, 0.855972E+00_JPRB, 0.843793E+00_JPRB, 0.831364E+00_JPRB, 0.818681E+00_JPRB &
  &, 0.805764E+00_JPRB, 0.792635E+00_JPRB, 0.779296E+00_JPRB &
  &, 0.765773E+00_JPRB, 0.752070E+00_JPRB, 0.738203E+00_JPRB, 0.724204E+00_JPRB &
  &, 0.710067E+00_JPRB, 0.695825E+00_JPRB, 0.681470E+00_JPRB &
  &, 0.667040E+00_JPRB, 0.652543E+00_JPRB, 0.638001E+00_JPRB, 0.623423E+00_JPRB &
  &, 0.608816E+00_JPRB, 0.594220E+00_JPRB, 0.579609E+00_JPRB &
  &, 0.565041E+00_JPRB, 0.550506E+00_JPRB, 0.536026E+00_JPRB, 0.521607E+00_JPRB &
  &, 0.507272E+00_JPRB, 0.493023E+00_JPRB, 0.478905E+00_JPRB &
  &, 0.464876E+00_JPRB, 0.451001E+00_JPRB, 0.437258E+00_JPRB, 0.423665E+00_JPRB &
  &, 0.410242E+00_JPRB, 0.396985E+00_JPRB, 0.383911E+00_JPRB &
  &, 0.371037E+00_JPRB, 0.358378E+00_JPRB, 0.345900E+00_JPRB, 0.333667E+00_JPRB &
  &, 0.321639E+00_JPRB, 0.309855E+00_JPRB, 0.298298E+00_JPRB &
  &, 0.287004E+00_JPRB, 0.275926E+00_JPRB, 0.265099E+00_JPRB, 0.254556E+00_JPRB &
  &, 0.244243E+00_JPRB, 0.234194E+00_JPRB, 0.224409E+00_JPRB &
  &, 0.214888E+00_JPRB, 0.205632E+00_JPRB, 0.196669E+00_JPRB, 0.187932E+00_JPRB &
  &, 0.179480E+00_JPRB, 0.171273E+00_JPRB, 0.163338E+00_JPRB &
  &, 0.155666E+00_JPRB, 0.148245E+00_JPRB, 0.141064E+00_JPRB, 0.134182E+00_JPRB &
  &, 0.127511E+00_JPRB, 0.121110E+00_JPRB, 0.114923E+00_JPRB &
  &, 0.108969E+00_JPRB, 0.103267E+00_JPRB, 0.977968E-01_JPRB, 0.925767E-01_JPRB &
  &, 0.875401E-01_JPRB, 0.827460E-01_JPRB, 0.781237E-01_JPRB &
  &, 0.737320E-01_JPRB, 0.695418E-01_JPRB, 0.655214E-01_JPRB, 0.616835E-01_JPRB &
  &, 0.580411E-01_JPRB, 0.546074E-01_JPRB, 0.512977E-01_JPRB &
  &, 0.481712E-01_JPRB, 0.451890E-01_JPRB, 0.423610E-01_JPRB, 0.396969E-01_JPRB &
  &, 0.372069E-01_JPRB, 0.347941E-01_JPRB, 0.325187E-01_JPRB &
  &, 0.303890E-01_JPRB, 0.283574E-01_JPRB, 0.264870E-01_JPRB, 0.246714E-01_JPRB &
  &, 0.229729E-01_JPRB, 0.213981E-01_JPRB, 0.198937E-01_JPRB &
  &, 0.185248E-01_JPRB, 0.171752E-01_JPRB, 0.159715E-01_JPRB, 0.147943E-01_JPRB &
  &, 0.137099E-01_JPRB, 0.127229E-01_JPRB, 0.117723E-01_JPRB/)
XCW( 604, :) = (/ &
  &  0.102312E+01_JPRB, 0.102789E+01_JPRB, 0.103226E+01_JPRB, 0.103621E+01_JPRB &
  &, 0.103975E+01_JPRB, 0.104287E+01_JPRB, 0.104556E+01_JPRB &
  &, 0.104783E+01_JPRB, 0.104966E+01_JPRB, 0.105107E+01_JPRB, 0.105204E+01_JPRB &
  &, 0.105258E+01_JPRB, 0.105267E+01_JPRB, 0.105233E+01_JPRB &
  &, 0.105155E+01_JPRB, 0.105033E+01_JPRB, 0.104866E+01_JPRB, 0.104655E+01_JPRB &
  &, 0.104400E+01_JPRB, 0.104101E+01_JPRB, 0.103757E+01_JPRB &
  &, 0.103370E+01_JPRB, 0.102939E+01_JPRB, 0.102464E+01_JPRB, 0.101946E+01_JPRB &
  &, 0.101385E+01_JPRB, 0.100782E+01_JPRB, 0.100136E+01_JPRB &
  &, 0.994495E+00_JPRB, 0.987214E+00_JPRB, 0.979528E+00_JPRB, 0.971445E+00_JPRB &
  &, 0.962972E+00_JPRB, 0.954118E+00_JPRB, 0.944885E+00_JPRB &
  &, 0.935274E+00_JPRB, 0.925340E+00_JPRB, 0.915038E+00_JPRB, 0.904400E+00_JPRB &
  &, 0.893444E+00_JPRB, 0.882175E+00_JPRB, 0.870607E+00_JPRB &
  &, 0.858740E+00_JPRB, 0.846608E+00_JPRB, 0.834203E+00_JPRB, 0.821555E+00_JPRB &
  &, 0.808672E+00_JPRB, 0.795565E+00_JPRB, 0.782259E+00_JPRB &
  &, 0.768743E+00_JPRB, 0.755071E+00_JPRB, 0.741221E+00_JPRB, 0.727239E+00_JPRB &
  &, 0.713116E+00_JPRB, 0.698887E+00_JPRB, 0.684544E+00_JPRB &
  &, 0.670124E+00_JPRB, 0.655635E+00_JPRB, 0.641084E+00_JPRB, 0.626510E+00_JPRB &
  &, 0.611905E+00_JPRB, 0.597293E+00_JPRB, 0.582698E+00_JPRB &
  &, 0.568108E+00_JPRB, 0.553567E+00_JPRB, 0.539059E+00_JPRB, 0.524629E+00_JPRB &
  &, 0.510280E+00_JPRB, 0.496015E+00_JPRB, 0.481858E+00_JPRB &
  &, 0.467829E+00_JPRB, 0.453908E+00_JPRB, 0.440137E+00_JPRB, 0.426515E+00_JPRB &
  &, 0.413059E+00_JPRB, 0.399790E+00_JPRB, 0.386677E+00_JPRB &
  &, 0.373785E+00_JPRB, 0.361058E+00_JPRB, 0.348557E+00_JPRB, 0.336272E+00_JPRB &
  &, 0.324217E+00_JPRB, 0.312375E+00_JPRB, 0.300784E+00_JPRB &
  &, 0.289427E+00_JPRB, 0.278310E+00_JPRB, 0.267440E+00_JPRB, 0.256853E+00_JPRB &
  &, 0.246493E+00_JPRB, 0.236393E+00_JPRB, 0.226555E+00_JPRB &
  &, 0.216978E+00_JPRB, 0.207695E+00_JPRB, 0.198638E+00_JPRB, 0.189868E+00_JPRB &
  &, 0.181349E+00_JPRB, 0.173105E+00_JPRB, 0.165097E+00_JPRB &
  &, 0.157383E+00_JPRB, 0.149919E+00_JPRB, 0.142692E+00_JPRB, 0.135725E+00_JPRB &
  &, 0.129042E+00_JPRB, 0.122549E+00_JPRB, 0.116346E+00_JPRB &
  &, 0.110375E+00_JPRB, 0.104614E+00_JPRB, 0.990829E-01_JPRB, 0.937991E-01_JPRB &
  &, 0.887391E-01_JPRB, 0.838770E-01_JPRB, 0.792282E-01_JPRB &
  &, 0.747640E-01_JPRB, 0.705443E-01_JPRB, 0.664930E-01_JPRB, 0.626229E-01_JPRB &
  &, 0.589471E-01_JPRB, 0.554302E-01_JPRB, 0.520837E-01_JPRB &
  &, 0.489190E-01_JPRB, 0.459479E-01_JPRB, 0.430796E-01_JPRB, 0.403740E-01_JPRB &
  &, 0.377881E-01_JPRB, 0.353837E-01_JPRB, 0.331167E-01_JPRB &
  &, 0.309403E-01_JPRB, 0.288607E-01_JPRB, 0.269406E-01_JPRB, 0.251312E-01_JPRB &
  &, 0.234391E-01_JPRB, 0.218117E-01_JPRB, 0.203130E-01_JPRB &
  &, 0.188891E-01_JPRB, 0.175443E-01_JPRB, 0.162832E-01_JPRB, 0.151102E-01_JPRB &
  &, 0.140300E-01_JPRB, 0.129824E-01_JPRB, 0.120351E-01_JPRB/)
XCW( 605, :) = (/ &
  &  0.102338E+01_JPRB, 0.102822E+01_JPRB, 0.103266E+01_JPRB, 0.103668E+01_JPRB &
  &, 0.104028E+01_JPRB, 0.104347E+01_JPRB, 0.104623E+01_JPRB &
  &, 0.104857E+01_JPRB, 0.105047E+01_JPRB, 0.105195E+01_JPRB, 0.105299E+01_JPRB &
  &, 0.105359E+01_JPRB, 0.105375E+01_JPRB, 0.105348E+01_JPRB &
  &, 0.105277E+01_JPRB, 0.105161E+01_JPRB, 0.105001E+01_JPRB, 0.104797E+01_JPRB &
  &, 0.104548E+01_JPRB, 0.104255E+01_JPRB, 0.103919E+01_JPRB &
  &, 0.103538E+01_JPRB, 0.103113E+01_JPRB, 0.102644E+01_JPRB, 0.102133E+01_JPRB &
  &, 0.101578E+01_JPRB, 0.100981E+01_JPRB, 0.100341E+01_JPRB &
  &, 0.996602E+00_JPRB, 0.989378E+00_JPRB, 0.981746E+00_JPRB, 0.973722E+00_JPRB &
  &, 0.965302E+00_JPRB, 0.956498E+00_JPRB, 0.947316E+00_JPRB &
  &, 0.937767E+00_JPRB, 0.927868E+00_JPRB, 0.917610E+00_JPRB, 0.907026E+00_JPRB &
  &, 0.896107E+00_JPRB, 0.884883E+00_JPRB, 0.873341E+00_JPRB &
  &, 0.861520E+00_JPRB, 0.849423E+00_JPRB, 0.837054E+00_JPRB, 0.824440E+00_JPRB &
  &, 0.811580E+00_JPRB, 0.798507E+00_JPRB, 0.785222E+00_JPRB &
  &, 0.771739E+00_JPRB, 0.758072E+00_JPRB, 0.744254E+00_JPRB, 0.730287E+00_JPRB &
  &, 0.716180E+00_JPRB, 0.701949E+00_JPRB, 0.687633E+00_JPRB &
  &, 0.673208E+00_JPRB, 0.658727E+00_JPRB, 0.644199E+00_JPRB, 0.629614E+00_JPRB &
  &, 0.615012E+00_JPRB, 0.600383E+00_JPRB, 0.585786E+00_JPRB &
  &, 0.571193E+00_JPRB, 0.556627E+00_JPRB, 0.542130E+00_JPRB, 0.527670E+00_JPRB &
  &, 0.513308E+00_JPRB, 0.499028E+00_JPRB, 0.484852E+00_JPRB &
  &, 0.470781E+00_JPRB, 0.456858E+00_JPRB, 0.443061E+00_JPRB, 0.429409E+00_JPRB &
  &, 0.415922E+00_JPRB, 0.402594E+00_JPRB, 0.389467E+00_JPRB &
  &, 0.376509E+00_JPRB, 0.363762E+00_JPRB, 0.351239E+00_JPRB, 0.338904E+00_JPRB &
  &, 0.326794E+00_JPRB, 0.314922E+00_JPRB, 0.303271E+00_JPRB &
  &, 0.291877E+00_JPRB, 0.280722E+00_JPRB, 0.269811E+00_JPRB, 0.259149E+00_JPRB &
  &, 0.248742E+00_JPRB, 0.238592E+00_JPRB, 0.228701E+00_JPRB &
  &, 0.219100E+00_JPRB, 0.209726E+00_JPRB, 0.200639E+00_JPRB, 0.191805E+00_JPRB &
  &, 0.183251E+00_JPRB, 0.174938E+00_JPRB, 0.166890E+00_JPRB &
  &, 0.159136E+00_JPRB, 0.151593E+00_JPRB, 0.144320E+00_JPRB, 0.137305E+00_JPRB &
  &, 0.130572E+00_JPRB, 0.124027E+00_JPRB, 0.117769E+00_JPRB &
  &, 0.111741E+00_JPRB, 0.105962E+00_JPRB, 0.100369E+00_JPRB, 0.950215E-01_JPRB &
  &, 0.898954E-01_JPRB, 0.850079E-01_JPRB, 0.803327E-01_JPRB &
  &, 0.758409E-01_JPRB, 0.715467E-01_JPRB, 0.674645E-01_JPRB, 0.635624E-01_JPRB &
  &, 0.598531E-01_JPRB, 0.563015E-01_JPRB, 0.529189E-01_JPRB &
  &, 0.497167E-01_JPRB, 0.466562E-01_JPRB, 0.437983E-01_JPRB, 0.410510E-01_JPRB &
  &, 0.384750E-01_JPRB, 0.359732E-01_JPRB, 0.336603E-01_JPRB &
  &, 0.314917E-01_JPRB, 0.294198E-01_JPRB, 0.274508E-01_JPRB, 0.255911E-01_JPRB &
  &, 0.238471E-01_JPRB, 0.222252E-01_JPRB, 0.206723E-01_JPRB &
  &, 0.192533E-01_JPRB, 0.179135E-01_JPRB, 0.165949E-01_JPRB, 0.154261E-01_JPRB &
  &, 0.142861E-01_JPRB, 0.132418E-01_JPRB, 0.122980E-01_JPRB/)
XCW( 606, :) = (/ &
  &  0.102364E+01_JPRB, 0.102855E+01_JPRB, 0.103306E+01_JPRB, 0.103714E+01_JPRB &
  &, 0.104082E+01_JPRB, 0.104407E+01_JPRB, 0.104690E+01_JPRB &
  &, 0.104930E+01_JPRB, 0.105128E+01_JPRB, 0.105282E+01_JPRB, 0.105393E+01_JPRB &
  &, 0.105460E+01_JPRB, 0.105484E+01_JPRB, 0.105463E+01_JPRB &
  &, 0.105398E+01_JPRB, 0.105290E+01_JPRB, 0.105136E+01_JPRB, 0.104939E+01_JPRB &
  &, 0.104697E+01_JPRB, 0.104411E+01_JPRB, 0.104080E+01_JPRB &
  &, 0.103706E+01_JPRB, 0.103287E+01_JPRB, 0.102825E+01_JPRB, 0.102320E+01_JPRB &
  &, 0.101771E+01_JPRB, 0.101180E+01_JPRB, 0.100546E+01_JPRB &
  &, 0.998710E+00_JPRB, 0.991546E+00_JPRB, 0.983972E+00_JPRB, 0.976000E+00_JPRB &
  &, 0.967633E+00_JPRB, 0.958883E+00_JPRB, 0.949720E+00_JPRB &
  &, 0.940259E+00_JPRB, 0.930395E+00_JPRB, 0.920191E+00_JPRB, 0.909653E+00_JPRB &
  &, 0.898779E+00_JPRB, 0.887591E+00_JPRB, 0.876095E+00_JPRB &
  &, 0.864311E+00_JPRB, 0.852250E+00_JPRB, 0.839916E+00_JPRB, 0.827326E+00_JPRB &
  &, 0.814500E+00_JPRB, 0.801449E+00_JPRB, 0.788198E+00_JPRB &
  &, 0.774735E+00_JPRB, 0.761101E+00_JPRB, 0.747300E+00_JPRB, 0.733336E+00_JPRB &
  &, 0.719243E+00_JPRB, 0.705041E+00_JPRB, 0.690722E+00_JPRB &
  &, 0.676323E+00_JPRB, 0.661836E+00_JPRB, 0.647298E+00_JPRB, 0.632717E+00_JPRB &
  &, 0.618118E+00_JPRB, 0.603438E+00_JPRB, 0.588875E+00_JPRB &
  &, 0.574278E+00_JPRB, 0.559725E+00_JPRB, 0.545202E+00_JPRB, 0.530731E+00_JPRB &
  &, 0.516356E+00_JPRB, 0.496885E+00_JPRB, 0.487846E+00_JPRB &
  &, 0.473755E+00_JPRB, 0.459808E+00_JPRB, 0.445985E+00_JPRB, 0.432304E+00_JPRB &
  &, 0.418784E+00_JPRB, 0.405421E+00_JPRB, 0.392256E+00_JPRB &
  &, 0.379282E+00_JPRB, 0.366490E+00_JPRB, 0.353920E+00_JPRB, 0.341535E+00_JPRB &
  &, 0.329398E+00_JPRB, 0.317469E+00_JPRB, 0.305785E+00_JPRB &
  &, 0.294328E+00_JPRB, 0.283134E+00_JPRB, 0.272181E+00_JPRB, 0.261476E+00_JPRB &
  &, 0.251022E+00_JPRB, 0.240822E+00_JPRB, 0.230878E+00_JPRB &
  &, 0.221221E+00_JPRB, 0.211821E+00_JPRB, 0.202673E+00_JPRB, 0.193775E+00_JPRB &
  &, 0.185154E+00_JPRB, 0.176804E+00_JPRB, 0.168719E+00_JPRB &
  &, 0.160889E+00_JPRB, 0.153303E+00_JPRB, 0.145985E+00_JPRB, 0.138923E+00_JPRB &
  &, 0.132102E+00_JPRB, 0.125544E+00_JPRB, 0.119232E+00_JPRB &
  &, 0.113147E+00_JPRB, 0.107309E+00_JPRB, 0.101697E+00_JPRB, 0.962861E-01_JPRB &
  &, 0.911372E-01_JPRB, 0.861824E-01_JPRB, 0.814373E-01_JPRB &
  &, 0.769178E-01_JPRB, 0.725947E-01_JPRB, 0.684361E-01_JPRB, 0.645018E-01_JPRB &
  &, 0.607114E-01_JPRB, 0.571727E-01_JPRB, 0.537540E-01_JPRB &
  &, 0.505144E-01_JPRB, 0.474151E-01_JPRB, 0.445170E-01_JPRB, 0.417281E-01_JPRB &
  &, 0.391090E-01_JPRB, 0.366164E-01_JPRB, 0.342583E-01_JPRB &
  &, 0.320430E-01_JPRB, 0.299230E-01_JPRB, 0.279611E-01_JPRB, 0.260510E-01_JPRB &
  &, 0.243134E-01_JPRB, 0.226388E-01_JPRB, 0.210915E-01_JPRB &
  &, 0.196175E-01_JPRB, 0.182211E-01_JPRB, 0.169690E-01_JPRB, 0.157420E-01_JPRB &
  &, 0.146062E-01_JPRB, 0.135661E-01_JPRB, 0.125608E-01_JPRB/)
XCW( 607, :) = (/ &
  &  0.102391E+01_JPRB, 0.102888E+01_JPRB, 0.103346E+01_JPRB, 0.103761E+01_JPRB &
  &, 0.104135E+01_JPRB, 0.104467E+01_JPRB, 0.104757E+01_JPRB &
  &, 0.105004E+01_JPRB, 0.105209E+01_JPRB, 0.105370E+01_JPRB, 0.105488E+01_JPRB &
  &, 0.105562E+01_JPRB, 0.105592E+01_JPRB, 0.105578E+01_JPRB &
  &, 0.105520E+01_JPRB, 0.105418E+01_JPRB, 0.105272E+01_JPRB, 0.105081E+01_JPRB &
  &, 0.104846E+01_JPRB, 0.104566E+01_JPRB, 0.104242E+01_JPRB &
  &, 0.103874E+01_JPRB, 0.103462E+01_JPRB, 0.103006E+01_JPRB, 0.102507E+01_JPRB &
  &, 0.101965E+01_JPRB, 0.101380E+01_JPRB, 0.100752E+01_JPRB &
  &, 0.100083E+01_JPRB, 0.993718E+00_JPRB, 0.986202E+00_JPRB, 0.978285E+00_JPRB &
  &, 0.969972E+00_JPRB, 0.961276E+00_JPRB, 0.952197E+00_JPRB &
  &, 0.942752E+00_JPRB, 0.932941E+00_JPRB, 0.922782E+00_JPRB, 0.912280E+00_JPRB &
  &, 0.901452E+00_JPRB, 0.890310E+00_JPRB, 0.878850E+00_JPRB &
  &, 0.867102E+00_JPRB, 0.855076E+00_JPRB, 0.842778E+00_JPRB, 0.830224E+00_JPRB &
  &, 0.817433E+00_JPRB, 0.804417E+00_JPRB, 0.791174E+00_JPRB &
  &, 0.777744E+00_JPRB, 0.764129E+00_JPRB, 0.750346E+00_JPRB, 0.736413E+00_JPRB &
  &, 0.722336E+00_JPRB, 0.708133E+00_JPRB, 0.693826E+00_JPRB &
  &, 0.679438E+00_JPRB, 0.664959E+00_JPRB, 0.650429E+00_JPRB, 0.635854E+00_JPRB &
  &, 0.621242E+00_JPRB, 0.606615E+00_JPRB, 0.591999E+00_JPRB &
  &, 0.577399E+00_JPRB, 0.562822E+00_JPRB, 0.548292E+00_JPRB, 0.533811E+00_JPRB &
  &, 0.519404E+00_JPRB, 0.505093E+00_JPRB, 0.490861E+00_JPRB &
  &, 0.476749E+00_JPRB, 0.462779E+00_JPRB, 0.448886E+00_JPRB, 0.435221E+00_JPRB &
  &, 0.421669E+00_JPRB, 0.408272E+00_JPRB, 0.395069E+00_JPRB &
  &, 0.382055E+00_JPRB, 0.369244E+00_JPRB, 0.356627E+00_JPRB, 0.344218E+00_JPRB &
  &, 0.332028E+00_JPRB, 0.320043E+00_JPRB, 0.308326E+00_JPRB &
  &, 0.296834E+00_JPRB, 0.285574E+00_JPRB, 0.274580E+00_JPRB, 0.263802E+00_JPRB &
  &, 0.253301E+00_JPRB, 0.243082E+00_JPRB, 0.233086E+00_JPRB &
  &, 0.223375E+00_JPRB, 0.213884E+00_JPRB, 0.204708E+00_JPRB, 0.195779E+00_JPRB &
  &, 0.187091E+00_JPRB, 0.178671E+00_JPRB, 0.170548E+00_JPRB &
  &, 0.162642E+00_JPRB, 0.155013E+00_JPRB, 0.147650E+00_JPRB, 0.140541E+00_JPRB &
  &, 0.133670E+00_JPRB, 0.127061E+00_JPRB, 0.120694E+00_JPRB &
  &, 0.114553E+00_JPRB, 0.108656E+00_JPRB, 0.102983E+00_JPRB, 0.975506E-01_JPRB &
  &, 0.923363E-01_JPRB, 0.873569E-01_JPRB, 0.825418E-01_JPRB &
  &, 0.779947E-01_JPRB, 0.735971E-01_JPRB, 0.694539E-01_JPRB, 0.654412E-01_JPRB &
  &, 0.616650E-01_JPRB, 0.580439E-01_JPRB, 0.545891E-01_JPRB &
  &, 0.513121E-01_JPRB, 0.481740E-01_JPRB, 0.452357E-01_JPRB, 0.424052E-01_JPRB &
  &, 0.397431E-01_JPRB, 0.372596E-01_JPRB, 0.348563E-01_JPRB &
  &, 0.325944E-01_JPRB, 0.304821E-01_JPRB, 0.284714E-01_JPRB, 0.265684E-01_JPRB &
  &, 0.247796E-01_JPRB, 0.231115E-01_JPRB, 0.215108E-01_JPRB &
  &, 0.199817E-01_JPRB, 0.185902E-01_JPRB, 0.172808E-01_JPRB, 0.160580E-01_JPRB &
  &, 0.149263E-01_JPRB, 0.138256E-01_JPRB, 0.128237E-01_JPRB/)
XCW( 608, :) = (/ &
  &  0.102417E+01_JPRB, 0.102922E+01_JPRB, 0.103386E+01_JPRB, 0.103808E+01_JPRB &
  &, 0.104189E+01_JPRB, 0.104528E+01_JPRB, 0.104824E+01_JPRB &
  &, 0.105079E+01_JPRB, 0.105290E+01_JPRB, 0.105458E+01_JPRB, 0.105582E+01_JPRB &
  &, 0.105663E+01_JPRB, 0.105701E+01_JPRB, 0.105694E+01_JPRB &
  &, 0.105643E+01_JPRB, 0.105547E+01_JPRB, 0.105407E+01_JPRB, 0.105223E+01_JPRB &
  &, 0.104995E+01_JPRB, 0.104722E+01_JPRB, 0.104404E+01_JPRB &
  &, 0.104043E+01_JPRB, 0.103637E+01_JPRB, 0.103188E+01_JPRB, 0.102695E+01_JPRB &
  &, 0.102159E+01_JPRB, 0.101580E+01_JPRB, 0.100958E+01_JPRB &
  &, 0.100295E+01_JPRB, 0.995897E+00_JPRB, 0.988436E+00_JPRB, 0.980575E+00_JPRB &
  &, 0.972319E+00_JPRB, 0.963674E+00_JPRB, 0.954646E+00_JPRB &
  &, 0.945245E+00_JPRB, 0.935487E+00_JPRB, 0.925373E+00_JPRB, 0.914926E+00_JPRB &
  &, 0.904134E+00_JPRB, 0.893029E+00_JPRB, 0.881616E+00_JPRB &
  &, 0.869915E+00_JPRB, 0.857914E+00_JPRB, 0.845652E+00_JPRB, 0.833133E+00_JPRB &
  &, 0.820377E+00_JPRB, 0.807384E+00_JPRB, 0.794175E+00_JPRB &
  &, 0.780766E+00_JPRB, 0.767170E+00_JPRB, 0.753406E+00_JPRB, 0.739490E+00_JPRB &
  &, 0.725428E+00_JPRB, 0.711240E+00_JPRB, 0.696946E+00_JPRB &
  &, 0.682553E+00_JPRB, 0.668099E+00_JPRB, 0.653560E+00_JPRB, 0.638991E+00_JPRB &
  &, 0.624382E+00_JPRB, 0.609757E+00_JPRB, 0.595123E+00_JPRB &
  &, 0.580521E+00_JPRB, 0.565939E+00_JPRB, 0.551382E+00_JPRB, 0.536891E+00_JPRB &
  &, 0.522472E+00_JPRB, 0.508146E+00_JPRB, 0.493897E+00_JPRB &
  &, 0.479765E+00_JPRB, 0.465751E+00_JPRB, 0.451876E+00_JPRB, 0.438137E+00_JPRB &
  &, 0.424555E+00_JPRB, 0.411146E+00_JPRB, 0.397907E+00_JPRB &
  &, 0.384852E+00_JPRB, 0.371998E+00_JPRB, 0.359334E+00_JPRB, 0.346875E+00_JPRB &
  &, 0.334658E+00_JPRB, 0.322643E+00_JPRB, 0.310868E+00_JPRB &
  &, 0.299340E+00_JPRB, 0.288042E+00_JPRB, 0.276980E+00_JPRB, 0.266187E+00_JPRB &
  &, 0.255611E+00_JPRB, 0.245343E+00_JPRB, 0.235294E+00_JPRB &
  &, 0.225528E+00_JPRB, 0.216011E+00_JPRB, 0.206742E+00_JPRB, 0.197782E+00_JPRB &
  &, 0.189061E+00_JPRB, 0.180573E+00_JPRB, 0.172377E+00_JPRB &
  &, 0.164466E+00_JPRB, 0.156759E+00_JPRB, 0.149352E+00_JPRB, 0.142196E+00_JPRB &
  &, 0.135277E+00_JPRB, 0.128577E+00_JPRB, 0.122157E+00_JPRB &
  &, 0.116000E+00_JPRB, 0.110045E+00_JPRB, 0.104310E+00_JPRB, 0.988574E-01_JPRB &
  &, 0.935781E-01_JPRB, 0.885314E-01_JPRB, 0.836906E-01_JPRB &
  &, 0.790716E-01_JPRB, 0.746451E-01_JPRB, 0.704255E-01_JPRB, 0.664276E-01_JPRB &
  &, 0.625710E-01_JPRB, 0.589152E-01_JPRB, 0.554243E-01_JPRB &
  &, 0.521098E-01_JPRB, 0.489835E-01_JPRB, 0.459544E-01_JPRB, 0.431343E-01_JPRB &
  &, 0.404299E-01_JPRB, 0.379027E-01_JPRB, 0.354543E-01_JPRB &
  &, 0.332008E-01_JPRB, 0.310412E-01_JPRB, 0.289816E-01_JPRB, 0.270283E-01_JPRB &
  &, 0.252459E-01_JPRB, 0.235251E-01_JPRB, 0.219300E-01_JPRB &
  &, 0.204067E-01_JPRB, 0.189594E-01_JPRB, 0.176549E-01_JPRB, 0.163739E-01_JPRB &
  &, 0.152464E-01_JPRB, 0.140850E-01_JPRB, 0.130865E-01_JPRB/)
XCW( 609, :) = (/ &
  &  0.102444E+01_JPRB, 0.102955E+01_JPRB, 0.103425E+01_JPRB, 0.103855E+01_JPRB &
  &, 0.104242E+01_JPRB, 0.104588E+01_JPRB, 0.104892E+01_JPRB &
  &, 0.105153E+01_JPRB, 0.105371E+01_JPRB, 0.105546E+01_JPRB, 0.105677E+01_JPRB &
  &, 0.105765E+01_JPRB, 0.105809E+01_JPRB, 0.105807E+01_JPRB &
  &, 0.105765E+01_JPRB, 0.105676E+01_JPRB, 0.105543E+01_JPRB, 0.105366E+01_JPRB &
  &, 0.105144E+01_JPRB, 0.104878E+01_JPRB, 0.104567E+01_JPRB &
  &, 0.104212E+01_JPRB, 0.103813E+01_JPRB, 0.103370E+01_JPRB, 0.102883E+01_JPRB &
  &, 0.102353E+01_JPRB, 0.101780E+01_JPRB, 0.101163E+01_JPRB &
  &, 0.100507E+01_JPRB, 0.998077E+00_JPRB, 0.990678E+00_JPRB, 0.982870E+00_JPRB &
  &, 0.974667E+00_JPRB, 0.966076E+00_JPRB, 0.957100E+00_JPRB &
  &, 0.947756E+00_JPRB, 0.938043E+00_JPRB, 0.927974E+00_JPRB, 0.917573E+00_JPRB &
  &, 0.906827E+00_JPRB, 0.895769E+00_JPRB, 0.884392E+00_JPRB &
  &, 0.872728E+00_JPRB, 0.860775E+00_JPRB, 0.848537E+00_JPRB, 0.836054E+00_JPRB &
  &, 0.823322E+00_JPRB, 0.810364E+00_JPRB, 0.797177E+00_JPRB &
  &, 0.783788E+00_JPRB, 0.770226E+00_JPRB, 0.756480E+00_JPRB, 0.742581E+00_JPRB &
  &, 0.728535E+00_JPRB, 0.714361E+00_JPRB, 0.700080E+00_JPRB &
  &, 0.685699E+00_JPRB, 0.671239E+00_JPRB, 0.656724E+00_JPRB, 0.642144E+00_JPRB &
  &, 0.627539E+00_JPRB, 0.612899E+00_JPRB, 0.598282E+00_JPRB &
  &, 0.583660E+00_JPRB, 0.569055E+00_JPRB, 0.554510E+00_JPRB, 0.539990E+00_JPRB &
  &, 0.525559E+00_JPRB, 0.511199E+00_JPRB, 0.496953E+00_JPRB &
  &, 0.482801E+00_JPRB, 0.468765E+00_JPRB, 0.454843E+00_JPRB, 0.441077E+00_JPRB &
  &, 0.427486E+00_JPRB, 0.414021E+00_JPRB, 0.400768E+00_JPRB &
  &, 0.387673E+00_JPRB, 0.374776E+00_JPRB, 0.362067E+00_JPRB, 0.349584E+00_JPRB &
  &, 0.337314E+00_JPRB, 0.325271E+00_JPRB, 0.313436E+00_JPRB &
  &, 0.301847E+00_JPRB, 0.290511E+00_JPRB, 0.279408E+00_JPRB, 0.268543E+00_JPRB &
  &, 0.257950E+00_JPRB, 0.247603E+00_JPRB, 0.237534E+00_JPRB &
  &, 0.227681E+00_JPRB, 0.218139E+00_JPRB, 0.208842E+00_JPRB, 0.199785E+00_JPRB &
  &, 0.190998E+00_JPRB, 0.182509E+00_JPRB, 0.174241E+00_JPRB &
  &, 0.166255E+00_JPRB, 0.158542E+00_JPRB, 0.151054E+00_JPRB, 0.143814E+00_JPRB &
  &, 0.136845E+00_JPRB, 0.130133E+00_JPRB, 0.123659E+00_JPRB &
  &, 0.117446E+00_JPRB, 0.111433E+00_JPRB, 0.105679E+00_JPRB, 0.100122E+00_JPRB &
  &, 0.948200E-01_JPRB, 0.897494E-01_JPRB, 0.848835E-01_JPRB &
  &, 0.801934E-01_JPRB, 0.757386E-01_JPRB, 0.714896E-01_JPRB, 0.674140E-01_JPRB &
  &, 0.635247E-01_JPRB, 0.598348E-01_JPRB, 0.563086E-01_JPRB &
  &, 0.529574E-01_JPRB, 0.497423E-01_JPRB, 0.467244E-01_JPRB, 0.438635E-01_JPRB &
  &, 0.411168E-01_JPRB, 0.385459E-01_JPRB, 0.360523E-01_JPRB &
  &, 0.337522E-01_JPRB, 0.315444E-01_JPRB, 0.294919E-01_JPRB, 0.275456E-01_JPRB &
  &, 0.257121E-01_JPRB, 0.239977E-01_JPRB, 0.223492E-01_JPRB &
  &, 0.208316E-01_JPRB, 0.193285E-01_JPRB, 0.180290E-01_JPRB, 0.167529E-01_JPRB &
  &, 0.155024E-01_JPRB, 0.144093E-01_JPRB, 0.133494E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART87',1,ZHOOK_HANDLE)
END SUBROUTINE PART87

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART88

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART88',0,ZHOOK_HANDLE)

XCW( 610, :) = (/ &
  &  0.102470E+01_JPRB, 0.102988E+01_JPRB, 0.103466E+01_JPRB, 0.103902E+01_JPRB &
  &, 0.104296E+01_JPRB, 0.104649E+01_JPRB, 0.104959E+01_JPRB &
  &, 0.105227E+01_JPRB, 0.105452E+01_JPRB, 0.105634E+01_JPRB, 0.105772E+01_JPRB &
  &, 0.105867E+01_JPRB, 0.105918E+01_JPRB, 0.105925E+01_JPRB &
  &, 0.105887E+01_JPRB, 0.105806E+01_JPRB, 0.105679E+01_JPRB, 0.105509E+01_JPRB &
  &, 0.105294E+01_JPRB, 0.105034E+01_JPRB, 0.104730E+01_JPRB &
  &, 0.104381E+01_JPRB, 0.103988E+01_JPRB, 0.103552E+01_JPRB, 0.103072E+01_JPRB &
  &, 0.102548E+01_JPRB, 0.101981E+01_JPRB, 0.101372E+01_JPRB &
  &, 0.100720E+01_JPRB, 0.100026E+01_JPRB, 0.992921E+00_JPRB, 0.985172E+00_JPRB &
  &, 0.977023E+00_JPRB, 0.968483E+00_JPRB, 0.959563E+00_JPRB &
  &, 0.950268E+00_JPRB, 0.940599E+00_JPRB, 0.930585E+00_JPRB, 0.920230E+00_JPRB &
  &, 0.909531E+00_JPRB, 0.898509E+00_JPRB, 0.887180E+00_JPRB &
  &, 0.875551E+00_JPRB, 0.863624E+00_JPRB, 0.851434E+00_JPRB, 0.838976E+00_JPRB &
  &, 0.826279E+00_JPRB, 0.813343E+00_JPRB, 0.800191E+00_JPRB &
  &, 0.786836E+00_JPRB, 0.773281E+00_JPRB, 0.759540E+00_JPRB, 0.745672E+00_JPRB &
  &, 0.731642E+00_JPRB, 0.717498E+00_JPRB, 0.703215E+00_JPRB &
  &, 0.688845E+00_JPRB, 0.674395E+00_JPRB, 0.659888E+00_JPRB, 0.645314E+00_JPRB &
  &, 0.630697E+00_JPRB, 0.616076E+00_JPRB, 0.601442E+00_JPRB &
  &, 0.586799E+00_JPRB, 0.572208E+00_JPRB, 0.557638E+00_JPRB, 0.543109E+00_JPRB &
  &, 0.528666E+00_JPRB, 0.514292E+00_JPRB, 0.500009E+00_JPRB &
  &, 0.485838E+00_JPRB, 0.471780E+00_JPRB, 0.457833E+00_JPRB, 0.444061E+00_JPRB &
  &, 0.430417E+00_JPRB, 0.416942E+00_JPRB, 0.403629E+00_JPRB &
  &, 0.390494E+00_JPRB, 0.377555E+00_JPRB, 0.364824E+00_JPRB, 0.352292E+00_JPRB &
  &, 0.339971E+00_JPRB, 0.327898E+00_JPRB, 0.316032E+00_JPRB &
  &, 0.304381E+00_JPRB, 0.293008E+00_JPRB, 0.281865E+00_JPRB, 0.270958E+00_JPRB &
  &, 0.260290E+00_JPRB, 0.249894E+00_JPRB, 0.239773E+00_JPRB &
  &, 0.229898E+00_JPRB, 0.220266E+00_JPRB, 0.210909E+00_JPRB, 0.201822E+00_JPRB &
  &, 0.193003E+00_JPRB, 0.184445E+00_JPRB, 0.176140E+00_JPRB &
  &, 0.168080E+00_JPRB, 0.160289E+00_JPRB, 0.152757E+00_JPRB, 0.145508E+00_JPRB &
  &, 0.138490E+00_JPRB, 0.131688E+00_JPRB, 0.125201E+00_JPRB &
  &, 0.118892E+00_JPRB, 0.112862E+00_JPRB, 0.107049E+00_JPRB, 0.101471E+00_JPRB &
  &, 0.961047E-01_JPRB, 0.909674E-01_JPRB, 0.860322E-01_JPRB &
  &, 0.813151E-01_JPRB, 0.768322E-01_JPRB, 0.725074E-01_JPRB, 0.684004E-01_JPRB &
  &, 0.644784E-01_JPRB, 0.607060E-01_JPRB, 0.571437E-01_JPRB &
  &, 0.537551E-01_JPRB, 0.505518E-01_JPRB, 0.474944E-01_JPRB, 0.445406E-01_JPRB &
  &, 0.418037E-01_JPRB, 0.391890E-01_JPRB, 0.367046E-01_JPRB &
  &, 0.343587E-01_JPRB, 0.321595E-01_JPRB, 0.300588E-01_JPRB, 0.280630E-01_JPRB &
  &, 0.261784E-01_JPRB, 0.244113E-01_JPRB, 0.227685E-01_JPRB &
  &, 0.211958E-01_JPRB, 0.197592E-01_JPRB, 0.183407E-01_JPRB, 0.170688E-01_JPRB &
  &, 0.158225E-01_JPRB, 0.147336E-01_JPRB, 0.136779E-01_JPRB/)
XCW( 611, :) = (/ &
  &  0.102497E+01_JPRB, 0.103021E+01_JPRB, 0.103506E+01_JPRB, 0.103948E+01_JPRB &
  &, 0.104350E+01_JPRB, 0.104710E+01_JPRB, 0.105027E+01_JPRB &
  &, 0.105302E+01_JPRB, 0.105533E+01_JPRB, 0.105722E+01_JPRB, 0.105868E+01_JPRB &
  &, 0.105969E+01_JPRB, 0.106027E+01_JPRB, 0.106041E+01_JPRB &
  &, 0.106010E+01_JPRB, 0.105935E+01_JPRB, 0.105816E+01_JPRB, 0.105652E+01_JPRB &
  &, 0.105443E+01_JPRB, 0.105190E+01_JPRB, 0.104893E+01_JPRB &
  &, 0.104551E+01_JPRB, 0.104165E+01_JPRB, 0.103735E+01_JPRB, 0.103261E+01_JPRB &
  &, 0.102743E+01_JPRB, 0.102183E+01_JPRB, 0.101579E+01_JPRB &
  &, 0.100933E+01_JPRB, 0.100246E+01_JPRB, 0.995171E+00_JPRB, 0.987475E+00_JPRB &
  &, 0.979383E+00_JPRB, 0.970899E+00_JPRB, 0.962031E+00_JPRB &
  &, 0.952779E+00_JPRB, 0.943174E+00_JPRB, 0.933206E+00_JPRB, 0.922886E+00_JPRB &
  &, 0.912234E+00_JPRB, 0.901259E+00_JPRB, 0.889967E+00_JPRB &
  &, 0.878376E+00_JPRB, 0.866496E+00_JPRB, 0.854331E+00_JPRB, 0.841921E+00_JPRB &
  &, 0.829248E+00_JPRB, 0.816348E+00_JPRB, 0.803218E+00_JPRB &
  &, 0.789885E+00_JPRB, 0.776363E+00_JPRB, 0.762655E+00_JPRB, 0.748791E+00_JPRB &
  &, 0.734778E+00_JPRB, 0.720634E+00_JPRB, 0.706380E+00_JPRB &
  &, 0.692022E+00_JPRB, 0.677567E+00_JPRB, 0.663052E+00_JPRB, 0.648484E+00_JPRB &
  &, 0.633888E+00_JPRB, 0.619253E+00_JPRB, 0.604601E+00_JPRB &
  &, 0.589975E+00_JPRB, 0.575361E+00_JPRB, 0.560784E+00_JPRB, 0.546248E+00_JPRB &
  &, 0.531794E+00_JPRB, 0.517386E+00_JPRB, 0.503086E+00_JPRB &
  &, 0.488896E+00_JPRB, 0.474816E+00_JPRB, 0.460845E+00_JPRB, 0.447023E+00_JPRB &
  &, 0.433348E+00_JPRB, 0.419839E+00_JPRB, 0.406514E+00_JPRB &
  &, 0.393340E+00_JPRB, 0.380383E+00_JPRB, 0.367607E+00_JPRB, 0.355027E+00_JPRB &
  &, 0.342680E+00_JPRB, 0.330526E+00_JPRB, 0.318628E+00_JPRB &
  &, 0.306943E+00_JPRB, 0.295505E+00_JPRB, 0.284323E+00_JPRB, 0.273373E+00_JPRB &
  &, 0.262659E+00_JPRB, 0.252215E+00_JPRB, 0.242043E+00_JPRB &
  &, 0.232114E+00_JPRB, 0.222426E+00_JPRB, 0.213041E+00_JPRB, 0.203892E+00_JPRB &
  &, 0.195008E+00_JPRB, 0.186381E+00_JPRB, 0.178039E+00_JPRB &
  &, 0.169940E+00_JPRB, 0.162108E+00_JPRB, 0.154496E+00_JPRB, 0.147201E+00_JPRB &
  &, 0.140097E+00_JPRB, 0.133283E+00_JPRB, 0.126703E+00_JPRB &
  &, 0.120379E+00_JPRB, 0.114291E+00_JPRB, 0.108418E+00_JPRB, 0.102778E+00_JPRB &
  &, 0.973894E-01_JPRB, 0.921854E-01_JPRB, 0.872251E-01_JPRB &
  &, 0.824817E-01_JPRB, 0.779257E-01_JPRB, 0.735715E-01_JPRB, 0.693868E-01_JPRB &
  &, 0.654320E-01_JPRB, 0.616741E-01_JPRB, 0.580280E-01_JPRB &
  &, 0.546026E-01_JPRB, 0.513613E-01_JPRB, 0.482644E-01_JPRB, 0.453218E-01_JPRB &
  &, 0.424906E-01_JPRB, 0.398322E-01_JPRB, 0.373570E-01_JPRB &
  &, 0.349651E-01_JPRB, 0.327186E-01_JPRB, 0.305691E-01_JPRB, 0.285804E-01_JPRB &
  &, 0.267029E-01_JPRB, 0.248840E-01_JPRB, 0.231877E-01_JPRB &
  &, 0.216207E-01_JPRB, 0.201283E-01_JPRB, 0.187148E-01_JPRB, 0.173848E-01_JPRB &
  &, 0.162066E-01_JPRB, 0.149931E-01_JPRB, 0.139408E-01_JPRB/)
XCW( 612, :) = (/ &
  &  0.102523E+01_JPRB, 0.103055E+01_JPRB, 0.103546E+01_JPRB, 0.103995E+01_JPRB &
  &, 0.104404E+01_JPRB, 0.104770E+01_JPRB, 0.105094E+01_JPRB &
  &, 0.105376E+01_JPRB, 0.105615E+01_JPRB, 0.105810E+01_JPRB, 0.105963E+01_JPRB &
  &, 0.106071E+01_JPRB, 0.106136E+01_JPRB, 0.106157E+01_JPRB &
  &, 0.106133E+01_JPRB, 0.106065E+01_JPRB, 0.105952E+01_JPRB, 0.105795E+01_JPRB &
  &, 0.105593E+01_JPRB, 0.105347E+01_JPRB, 0.105056E+01_JPRB &
  &, 0.104721E+01_JPRB, 0.104341E+01_JPRB, 0.103917E+01_JPRB, 0.103450E+01_JPRB &
  &, 0.102939E+01_JPRB, 0.102384E+01_JPRB, 0.101787E+01_JPRB &
  &, 0.101147E+01_JPRB, 0.100466E+01_JPRB, 0.997426E+00_JPRB, 0.989790E+00_JPRB &
  &, 0.981748E+00_JPRB, 0.973319E+00_JPRB, 0.964503E+00_JPRB &
  &, 0.955309E+00_JPRB, 0.945749E+00_JPRB, 0.935826E+00_JPRB, 0.925553E+00_JPRB &
  &, 0.914948E+00_JPRB, 0.904020E+00_JPRB, 0.892765E+00_JPRB &
  &, 0.881211E+00_JPRB, 0.869368E+00_JPRB, 0.857252E+00_JPRB, 0.844866E+00_JPRB &
  &, 0.832230E+00_JPRB, 0.819353E+00_JPRB, 0.806245E+00_JPRB &
  &, 0.792946E+00_JPRB, 0.779445E+00_JPRB, 0.765756E+00_JPRB, 0.751911E+00_JPRB &
  &, 0.737914E+00_JPRB, 0.723785E+00_JPRB, 0.709544E+00_JPRB &
  &, 0.695199E+00_JPRB, 0.680754E+00_JPRB, 0.666248E+00_JPRB, 0.651687E+00_JPRB &
  &, 0.637080E+00_JPRB, 0.622447E+00_JPRB, 0.607796E+00_JPRB &
  &, 0.593151E+00_JPRB, 0.578533E+00_JPRB, 0.563950E+00_JPRB, 0.549405E+00_JPRB &
  &, 0.534921E+00_JPRB, 0.520499E+00_JPRB, 0.506183E+00_JPRB &
  &, 0.491975E+00_JPRB, 0.477852E+00_JPRB, 0.463878E+00_JPRB, 0.450030E+00_JPRB &
  &, 0.436325E+00_JPRB, 0.422784E+00_JPRB, 0.409398E+00_JPRB &
  &, 0.396210E+00_JPRB, 0.383211E+00_JPRB, 0.370390E+00_JPRB, 0.357787E+00_JPRB &
  &, 0.345389E+00_JPRB, 0.333207E+00_JPRB, 0.321251E+00_JPRB &
  &, 0.309533E+00_JPRB, 0.298030E+00_JPRB, 0.286809E+00_JPRB, 0.275787E+00_JPRB &
  &, 0.265059E+00_JPRB, 0.254567E+00_JPRB, 0.244314E+00_JPRB &
  &, 0.234331E+00_JPRB, 0.224618E+00_JPRB, 0.215174E+00_JPRB, 0.205963E+00_JPRB &
  &, 0.197012E+00_JPRB, 0.188351E+00_JPRB, 0.179938E+00_JPRB &
  &, 0.171800E+00_JPRB, 0.163891E+00_JPRB, 0.156272E+00_JPRB, 0.148894E+00_JPRB &
  &, 0.141780E+00_JPRB, 0.134877E+00_JPRB, 0.128245E+00_JPRB &
  &, 0.121865E+00_JPRB, 0.115720E+00_JPRB, 0.109828E+00_JPRB, 0.104126E+00_JPRB &
  &, 0.986741E-01_JPRB, 0.934468E-01_JPRB, 0.884180E-01_JPRB &
  &, 0.836035E-01_JPRB, 0.790193E-01_JPRB, 0.746356E-01_JPRB, 0.704202E-01_JPRB &
  &, 0.664334E-01_JPRB, 0.625937E-01_JPRB, 0.589614E-01_JPRB &
  &, 0.554502E-01_JPRB, 0.521708E-01_JPRB, 0.490344E-01_JPRB, 0.460510E-01_JPRB &
  &, 0.432303E-01_JPRB, 0.405289E-01_JPRB, 0.379550E-01_JPRB &
  &, 0.355716E-01_JPRB, 0.332777E-01_JPRB, 0.311361E-01_JPRB, 0.290978E-01_JPRB &
  &, 0.271691E-01_JPRB, 0.253567E-01_JPRB, 0.236668E-01_JPRB &
  &, 0.220457E-01_JPRB, 0.205590E-01_JPRB, 0.190889E-01_JPRB, 0.177638E-01_JPRB &
  &, 0.165267E-01_JPRB, 0.153174E-01_JPRB, 0.142036E-01_JPRB/)
XCW( 613, :) = (/ &
  &  0.102550E+01_JPRB, 0.103088E+01_JPRB, 0.103586E+01_JPRB, 0.104042E+01_JPRB &
  &, 0.104458E+01_JPRB, 0.104831E+01_JPRB, 0.105162E+01_JPRB &
  &, 0.105451E+01_JPRB, 0.105696E+01_JPRB, 0.105899E+01_JPRB, 0.106058E+01_JPRB &
  &, 0.106174E+01_JPRB, 0.106245E+01_JPRB, 0.106273E+01_JPRB &
  &, 0.106256E+01_JPRB, 0.106195E+01_JPRB, 0.106089E+01_JPRB, 0.105939E+01_JPRB &
  &, 0.105744E+01_JPRB, 0.105504E+01_JPRB, 0.105220E+01_JPRB &
  &, 0.104891E+01_JPRB, 0.104518E+01_JPRB, 0.104101E+01_JPRB, 0.103638E+01_JPRB &
  &, 0.103135E+01_JPRB, 0.102586E+01_JPRB, 0.101995E+01_JPRB &
  &, 0.101361E+01_JPRB, 0.100686E+01_JPRB, 0.999685E+00_JPRB, 0.992105E+00_JPRB &
  &, 0.984122E+00_JPRB, 0.975747E+00_JPRB, 0.966975E+00_JPRB &
  &, 0.957839E+00_JPRB, 0.948324E+00_JPRB, 0.938457E+00_JPRB, 0.928230E+00_JPRB &
  &, 0.917672E+00_JPRB, 0.906781E+00_JPRB, 0.895574E+00_JPRB &
  &, 0.884057E+00_JPRB, 0.872252E+00_JPRB, 0.860172E+00_JPRB, 0.847811E+00_JPRB &
  &, 0.835211E+00_JPRB, 0.822370E+00_JPRB, 0.809298E+00_JPRB &
  &, 0.796008E+00_JPRB, 0.782540E+00_JPRB, 0.768871E+00_JPRB, 0.755044E+00_JPRB &
  &, 0.741064E+00_JPRB, 0.726951E+00_JPRB, 0.712724E+00_JPRB &
  &, 0.698391E+00_JPRB, 0.683957E+00_JPRB, 0.669444E+00_JPRB, 0.654891E+00_JPRB &
  &, 0.640288E+00_JPRB, 0.625641E+00_JPRB, 0.610991E+00_JPRB &
  &, 0.596344E+00_JPRB, 0.581724E+00_JPRB, 0.567116E+00_JPRB, 0.552563E+00_JPRB &
  &, 0.538067E+00_JPRB, 0.523633E+00_JPRB, 0.509301E+00_JPRB &
  &, 0.495053E+00_JPRB, 0.480931E+00_JPRB, 0.466912E+00_JPRB, 0.453036E+00_JPRB &
  &, 0.439303E+00_JPRB, 0.425728E+00_JPRB, 0.412331E+00_JPRB &
  &, 0.399104E+00_JPRB, 0.386039E+00_JPRB, 0.373198E+00_JPRB, 0.360547E+00_JPRB &
  &, 0.348019E+00_JPRB, 0.335888E+00_JPRB, 0.323902E+00_JPRB &
  &, 0.312122E+00_JPRB, 0.300584E+00_JPRB, 0.289295E+00_JPRB, 0.278261E+00_JPRB &
  &, 0.267458E+00_JPRB, 0.256919E+00_JPRB, 0.246615E+00_JPRB &
  &, 0.236579E+00_JPRB, 0.226810E+00_JPRB, 0.217306E+00_JPRB, 0.208066E+00_JPRB &
  &, 0.199051E+00_JPRB, 0.190356E+00_JPRB, 0.181873E+00_JPRB &
  &, 0.173660E+00_JPRB, 0.165710E+00_JPRB, 0.158048E+00_JPRB, 0.150625E+00_JPRB &
  &, 0.143425E+00_JPRB, 0.136511E+00_JPRB, 0.129826E+00_JPRB &
  &, 0.123392E+00_JPRB, 0.117190E+00_JPRB, 0.111239E+00_JPRB, 0.105475E+00_JPRB &
  &, 0.100002E+00_JPRB, 0.947083E-01_JPRB, 0.896551E-01_JPRB &
  &, 0.847701E-01_JPRB, 0.801584E-01_JPRB, 0.756997E-01_JPRB, 0.714536E-01_JPRB &
  &, 0.673871E-01_JPRB, 0.635618E-01_JPRB, 0.598456E-01_JPRB &
  &, 0.563476E-01_JPRB, 0.529803E-01_JPRB, 0.498045E-01_JPRB, 0.467801E-01_JPRB &
  &, 0.439172E-01_JPRB, 0.412257E-01_JPRB, 0.386617E-01_JPRB &
  &, 0.361781E-01_JPRB, 0.338928E-01_JPRB, 0.317030E-01_JPRB, 0.296151E-01_JPRB &
  &, 0.276937E-01_JPRB, 0.258293E-01_JPRB, 0.240861E-01_JPRB &
  &, 0.224706E-01_JPRB, 0.209281E-01_JPRB, 0.194630E-01_JPRB, 0.181429E-01_JPRB &
  &, 0.168468E-01_JPRB, 0.156417E-01_JPRB, 0.145322E-01_JPRB/)
XCW( 614, :) = (/ &
  &  0.102577E+01_JPRB, 0.103121E+01_JPRB, 0.103626E+01_JPRB, 0.104089E+01_JPRB &
  &, 0.104511E+01_JPRB, 0.104892E+01_JPRB, 0.105230E+01_JPRB &
  &, 0.105525E+01_JPRB, 0.105778E+01_JPRB, 0.105988E+01_JPRB, 0.106154E+01_JPRB &
  &, 0.106276E+01_JPRB, 0.106355E+01_JPRB, 0.106389E+01_JPRB &
  &, 0.106379E+01_JPRB, 0.106325E+01_JPRB, 0.106226E+01_JPRB, 0.106082E+01_JPRB &
  &, 0.105894E+01_JPRB, 0.105661E+01_JPRB, 0.105384E+01_JPRB &
  &, 0.105062E+01_JPRB, 0.104695E+01_JPRB, 0.104284E+01_JPRB, 0.103829E+01_JPRB &
  &, 0.103331E+01_JPRB, 0.102783E+01_JPRB, 0.102204E+01_JPRB &
  &, 0.101576E+01_JPRB, 0.100906E+01_JPRB, 0.100195E+01_JPRB, 0.994425E+00_JPRB &
  &, 0.986500E+00_JPRB, 0.978176E+00_JPRB, 0.969465E+00_JPRB &
  &, 0.960378E+00_JPRB, 0.950908E+00_JPRB, 0.941087E+00_JPRB, 0.930917E+00_JPRB &
  &, 0.920395E+00_JPRB, 0.909553E+00_JPRB, 0.898383E+00_JPRB &
  &, 0.886914E+00_JPRB, 0.875146E+00_JPRB, 0.863104E+00_JPRB, 0.850780E+00_JPRB &
  &, 0.838205E+00_JPRB, 0.825387E+00_JPRB, 0.812351E+00_JPRB &
  &, 0.799096E+00_JPRB, 0.785636E+00_JPRB, 0.772000E+00_JPRB, 0.758192E+00_JPRB &
  &, 0.744229E+00_JPRB, 0.730132E+00_JPRB, 0.715919E+00_JPRB &
  &, 0.701584E+00_JPRB, 0.687160E+00_JPRB, 0.672673E+00_JPRB, 0.658110E+00_JPRB &
  &, 0.643496E+00_JPRB, 0.628870E+00_JPRB, 0.614222E+00_JPRB &
  &, 0.599556E+00_JPRB, 0.584933E+00_JPRB, 0.570320E+00_JPRB, 0.555740E+00_JPRB &
  &, 0.541234E+00_JPRB, 0.526787E+00_JPRB, 0.512420E+00_JPRB &
  &, 0.498175E+00_JPRB, 0.484010E+00_JPRB, 0.469967E+00_JPRB, 0.456066E+00_JPRB &
  &, 0.442302E+00_JPRB, 0.428696E+00_JPRB, 0.415264E+00_JPRB &
  &, 0.401998E+00_JPRB, 0.388916E+00_JPRB, 0.376032E+00_JPRB, 0.363333E+00_JPRB &
  &, 0.350859E+00_JPRB, 0.338595E+00_JPRB, 0.326553E+00_JPRB &
  &, 0.314740E+00_JPRB, 0.303166E+00_JPRB, 0.291810E+00_JPRB, 0.280735E+00_JPRB &
  &, 0.269887E+00_JPRB, 0.259271E+00_JPRB, 0.248948E+00_JPRB &
  &, 0.238859E+00_JPRB, 0.229034E+00_JPRB, 0.219472E+00_JPRB, 0.210170E+00_JPRB &
  &, 0.201124E+00_JPRB, 0.192361E+00_JPRB, 0.183842E+00_JPRB &
  &, 0.175556E+00_JPRB, 0.167566E+00_JPRB, 0.159824E+00_JPRB, 0.152355E+00_JPRB &
  &, 0.145108E+00_JPRB, 0.138144E+00_JPRB, 0.131407E+00_JPRB &
  &, 0.124919E+00_JPRB, 0.118660E+00_JPRB, 0.112649E+00_JPRB, 0.106866E+00_JPRB &
  &, 0.101329E+00_JPRB, 0.959698E-01_JPRB, 0.908480E-01_JPRB &
  &, 0.859816E-01_JPRB, 0.812975E-01_JPRB, 0.768101E-01_JPRB, 0.724869E-01_JPRB &
  &, 0.683884E-01_JPRB, 0.644814E-01_JPRB, 0.607790E-01_JPRB &
  &, 0.572450E-01_JPRB, 0.538403E-01_JPRB, 0.506258E-01_JPRB, 0.475614E-01_JPRB &
  &, 0.446569E-01_JPRB, 0.419225E-01_JPRB, 0.393140E-01_JPRB &
  &, 0.368397E-01_JPRB, 0.345078E-01_JPRB, 0.322700E-01_JPRB, 0.301900E-01_JPRB &
  &, 0.282182E-01_JPRB, 0.263020E-01_JPRB, 0.245652E-01_JPRB &
  &, 0.228955E-01_JPRB, 0.213588E-01_JPRB, 0.198995E-01_JPRB, 0.185220E-01_JPRB &
  &, 0.172309E-01_JPRB, 0.159660E-01_JPRB, 0.148607E-01_JPRB/)
XCW( 615, :) = (/ &
  &  0.102603E+01_JPRB, 0.103155E+01_JPRB, 0.103666E+01_JPRB, 0.104137E+01_JPRB &
  &, 0.104565E+01_JPRB, 0.104953E+01_JPRB, 0.105298E+01_JPRB &
  &, 0.105600E+01_JPRB, 0.105860E+01_JPRB, 0.106076E+01_JPRB, 0.106249E+01_JPRB &
  &, 0.106379E+01_JPRB, 0.106464E+01_JPRB, 0.106506E+01_JPRB &
  &, 0.106503E+01_JPRB, 0.106455E+01_JPRB, 0.106363E+01_JPRB, 0.106226E+01_JPRB &
  &, 0.106045E+01_JPRB, 0.105819E+01_JPRB, 0.105548E+01_JPRB &
  &, 0.105232E+01_JPRB, 0.104873E+01_JPRB, 0.104468E+01_JPRB, 0.104020E+01_JPRB &
  &, 0.103528E+01_JPRB, 0.102992E+01_JPRB, 0.102413E+01_JPRB &
  &, 0.101791E+01_JPRB, 0.101128E+01_JPRB, 0.100422E+01_JPRB, 0.996753E+00_JPRB &
  &, 0.988882E+00_JPRB, 0.980614E+00_JPRB, 0.971960E+00_JPRB &
  &, 0.962917E+00_JPRB, 0.953502E+00_JPRB, 0.943737E+00_JPRB, 0.933604E+00_JPRB &
  &, 0.923130E+00_JPRB, 0.912335E+00_JPRB, 0.901213E+00_JPRB &
  &, 0.889782E+00_JPRB, 0.878052E+00_JPRB, 0.866036E+00_JPRB, 0.853749E+00_JPRB &
  &, 0.841211E+00_JPRB, 0.828430E+00_JPRB, 0.815417E+00_JPRB &
  &, 0.802184E+00_JPRB, 0.788758E+00_JPRB, 0.775143E+00_JPRB, 0.761353E+00_JPRB &
  &, 0.747408E+00_JPRB, 0.733327E+00_JPRB, 0.719115E+00_JPRB &
  &, 0.704807E+00_JPRB, 0.690396E+00_JPRB, 0.675901E+00_JPRB, 0.661347E+00_JPRB &
  &, 0.646739E+00_JPRB, 0.632099E+00_JPRB, 0.617453E+00_JPRB &
  &, 0.602786E+00_JPRB, 0.588142E+00_JPRB, 0.573524E+00_JPRB, 0.558936E+00_JPRB &
  &, 0.544421E+00_JPRB, 0.529961E+00_JPRB, 0.515579E+00_JPRB &
  &, 0.501296E+00_JPRB, 0.487111E+00_JPRB, 0.473045E+00_JPRB, 0.459117E+00_JPRB &
  &, 0.445325E+00_JPRB, 0.431687E+00_JPRB, 0.418220E+00_JPRB &
  &, 0.404917E+00_JPRB, 0.391794E+00_JPRB, 0.378865E+00_JPRB, 0.366145E+00_JPRB &
  &, 0.353621E+00_JPRB, 0.341303E+00_JPRB, 0.329231E+00_JPRB &
  &, 0.317358E+00_JPRB, 0.305748E+00_JPRB, 0.294354E+00_JPRB, 0.283208E+00_JPRB &
  &, 0.272317E+00_JPRB, 0.261684E+00_JPRB, 0.251281E+00_JPRB &
  &, 0.241139E+00_JPRB, 0.231258E+00_JPRB, 0.221637E+00_JPRB, 0.212307E+00_JPRB &
  &, 0.203196E+00_JPRB, 0.194366E+00_JPRB, 0.185812E+00_JPRB &
  &, 0.177488E+00_JPRB, 0.169422E+00_JPRB, 0.161637E+00_JPRB, 0.154086E+00_JPRB &
  &, 0.146830E+00_JPRB, 0.139777E+00_JPRB, 0.132988E+00_JPRB &
  &, 0.126445E+00_JPRB, 0.120170E+00_JPRB, 0.114101E+00_JPRB, 0.108257E+00_JPRB &
  &, 0.102657E+00_JPRB, 0.972748E-01_JPRB, 0.921293E-01_JPRB &
  &, 0.871483E-01_JPRB, 0.824367E-01_JPRB, 0.779205E-01_JPRB, 0.735673E-01_JPRB &
  &, 0.694375E-01_JPRB, 0.654978E-01_JPRB, 0.617124E-01_JPRB &
  &, 0.580926E-01_JPRB, 0.547004E-01_JPRB, 0.514472E-01_JPRB, 0.483426E-01_JPRB &
  &, 0.453966E-01_JPRB, 0.426192E-01_JPRB, 0.399664E-01_JPRB &
  &, 0.374462E-01_JPRB, 0.350669E-01_JPRB, 0.328369E-01_JPRB, 0.307074E-01_JPRB &
  &, 0.287427E-01_JPRB, 0.268337E-01_JPRB, 0.250443E-01_JPRB &
  &, 0.233812E-01_JPRB, 0.217895E-01_JPRB, 0.202736E-01_JPRB, 0.189011E-01_JPRB &
  &, 0.175510E-01_JPRB, 0.162903E-01_JPRB, 0.151236E-01_JPRB/)
XCW( 616, :) = (/ &
  &  0.102630E+01_JPRB, 0.103188E+01_JPRB, 0.103707E+01_JPRB, 0.104184E+01_JPRB &
  &, 0.104619E+01_JPRB, 0.105014E+01_JPRB, 0.105365E+01_JPRB &
  &, 0.105675E+01_JPRB, 0.105942E+01_JPRB, 0.106165E+01_JPRB, 0.106345E+01_JPRB &
  &, 0.106481E+01_JPRB, 0.106574E+01_JPRB, 0.106622E+01_JPRB &
  &, 0.106626E+01_JPRB, 0.106586E+01_JPRB, 0.106501E+01_JPRB, 0.106371E+01_JPRB &
  &, 0.106196E+01_JPRB, 0.105977E+01_JPRB, 0.105713E+01_JPRB &
  &, 0.105404E+01_JPRB, 0.105050E+01_JPRB, 0.104653E+01_JPRB, 0.104211E+01_JPRB &
  &, 0.103725E+01_JPRB, 0.103195E+01_JPRB, 0.102623E+01_JPRB &
  &, 0.102007E+01_JPRB, 0.101349E+01_JPRB, 0.100649E+01_JPRB, 0.999085E+00_JPRB &
  &, 0.991272E+00_JPRB, 0.983060E+00_JPRB, 0.974454E+00_JPRB &
  &, 0.965466E+00_JPRB, 0.956106E+00_JPRB, 0.946387E+00_JPRB, 0.936301E+00_JPRB &
  &, 0.925874E+00_JPRB, 0.915117E+00_JPRB, 0.904044E+00_JPRB &
  &, 0.892651E+00_JPRB, 0.880958E+00_JPRB, 0.868980E+00_JPRB, 0.856718E+00_JPRB &
  &, 0.844229E+00_JPRB, 0.831472E+00_JPRB, 0.818495E+00_JPRB &
  &, 0.805285E+00_JPRB, 0.791881E+00_JPRB, 0.778285E+00_JPRB, 0.764529E+00_JPRB &
  &, 0.750602E+00_JPRB, 0.736537E+00_JPRB, 0.722340E+00_JPRB &
  &, 0.708030E+00_JPRB, 0.693630E+00_JPRB, 0.679146E+00_JPRB, 0.664583E+00_JPRB &
  &, 0.649981E+00_JPRB, 0.635346E+00_JPRB, 0.620701E+00_JPRB &
  &, 0.606035E+00_JPRB, 0.591369E+00_JPRB, 0.576746E+00_JPRB, 0.562151E+00_JPRB &
  &, 0.547607E+00_JPRB, 0.533136E+00_JPRB, 0.518739E+00_JPRB &
  &, 0.504438E+00_JPRB, 0.490233E+00_JPRB, 0.476144E+00_JPRB, 0.462191E+00_JPRB &
  &, 0.448371E+00_JPRB, 0.434701E+00_JPRB, 0.421200E+00_JPRB &
  &, 0.407860E+00_JPRB, 0.394696E+00_JPRB, 0.381724E+00_JPRB, 0.368957E+00_JPRB &
  &, 0.356409E+00_JPRB, 0.344065E+00_JPRB, 0.331936E+00_JPRB &
  &, 0.320031E+00_JPRB, 0.308359E+00_JPRB, 0.296927E+00_JPRB, 0.285711E+00_JPRB &
  &, 0.274776E+00_JPRB, 0.264097E+00_JPRB, 0.253644E+00_JPRB &
  &, 0.243450E+00_JPRB, 0.233514E+00_JPRB, 0.223868E+00_JPRB, 0.214444E+00_JPRB &
  &, 0.205303E+00_JPRB, 0.196406E+00_JPRB, 0.187781E+00_JPRB &
  &, 0.179420E+00_JPRB, 0.171314E+00_JPRB, 0.163450E+00_JPRB, 0.155892E+00_JPRB &
  &, 0.148551E+00_JPRB, 0.141449E+00_JPRB, 0.134609E+00_JPRB &
  &, 0.128012E+00_JPRB, 0.121681E+00_JPRB, 0.115554E+00_JPRB, 0.109648E+00_JPRB &
  &, 0.104027E+00_JPRB, 0.985798E-01_JPRB, 0.933664E-01_JPRB &
  &, 0.883598E-01_JPRB, 0.836213E-01_JPRB, 0.790308E-01_JPRB, 0.746476E-01_JPRB &
  &, 0.704388E-01_JPRB, 0.664659E-01_JPRB, 0.626458E-01_JPRB &
  &, 0.590399E-01_JPRB, 0.555605E-01_JPRB, 0.522685E-01_JPRB, 0.491238E-01_JPRB &
  &, 0.461891E-01_JPRB, 0.433160E-01_JPRB, 0.406731E-01_JPRB &
  &, 0.381078E-01_JPRB, 0.357378E-01_JPRB, 0.334606E-01_JPRB, 0.312822E-01_JPRB &
  &, 0.292673E-01_JPRB, 0.273064E-01_JPRB, 0.255235E-01_JPRB &
  &, 0.238061E-01_JPRB, 0.222201E-01_JPRB, 0.206477E-01_JPRB, 0.192802E-01_JPRB &
  &, 0.179351E-01_JPRB, 0.166795E-01_JPRB, 0.154521E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART88',1,ZHOOK_HANDLE)
END SUBROUTINE PART88

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART89

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART89',0,ZHOOK_HANDLE)

XCW( 617, :) = (/ &
  &  0.102656E+01_JPRB, 0.103222E+01_JPRB, 0.103747E+01_JPRB, 0.104231E+01_JPRB &
  &, 0.104674E+01_JPRB, 0.105075E+01_JPRB, 0.105433E+01_JPRB &
  &, 0.105750E+01_JPRB, 0.106023E+01_JPRB, 0.106254E+01_JPRB, 0.106441E+01_JPRB &
  &, 0.106584E+01_JPRB, 0.106684E+01_JPRB, 0.106739E+01_JPRB &
  &, 0.106750E+01_JPRB, 0.106716E+01_JPRB, 0.106638E+01_JPRB, 0.106515E+01_JPRB &
  &, 0.106348E+01_JPRB, 0.106135E+01_JPRB, 0.105877E+01_JPRB &
  &, 0.105575E+01_JPRB, 0.105228E+01_JPRB, 0.104837E+01_JPRB, 0.104402E+01_JPRB &
  &, 0.103922E+01_JPRB, 0.103399E+01_JPRB, 0.102833E+01_JPRB &
  &, 0.102223E+01_JPRB, 0.101571E+01_JPRB, 0.100878E+01_JPRB, 0.100143E+01_JPRB &
  &, 0.993667E+00_JPRB, 0.985512E+00_JPRB, 0.976958E+00_JPRB &
  &, 0.968024E+00_JPRB, 0.958719E+00_JPRB, 0.949036E+00_JPRB, 0.939007E+00_JPRB &
  &, 0.928629E+00_JPRB, 0.917920E+00_JPRB, 0.906874E+00_JPRB &
  &, 0.895530E+00_JPRB, 0.883876E+00_JPRB, 0.871946E+00_JPRB, 0.859723E+00_JPRB &
  &, 0.847259E+00_JPRB, 0.834527E+00_JPRB, 0.821574E+00_JPRB &
  &, 0.808399E+00_JPRB, 0.795016E+00_JPRB, 0.781455E+00_JPRB, 0.767705E+00_JPRB &
  &, 0.753796E+00_JPRB, 0.739748E+00_JPRB, 0.725565E+00_JPRB &
  &, 0.711269E+00_JPRB, 0.696881E+00_JPRB, 0.682391E+00_JPRB, 0.667853E+00_JPRB &
  &, 0.653257E+00_JPRB, 0.638609E+00_JPRB, 0.623949E+00_JPRB &
  &, 0.609283E+00_JPRB, 0.594615E+00_JPRB, 0.579988E+00_JPRB, 0.565387E+00_JPRB &
  &, 0.550813E+00_JPRB, 0.536330E+00_JPRB, 0.521919E+00_JPRB &
  &, 0.507580E+00_JPRB, 0.493355E+00_JPRB, 0.479244E+00_JPRB, 0.465265E+00_JPRB &
  &, 0.451417E+00_JPRB, 0.437716E+00_JPRB, 0.424180E+00_JPRB &
  &, 0.410803E+00_JPRB, 0.397624E+00_JPRB, 0.384608E+00_JPRB, 0.371820E+00_JPRB &
  &, 0.359197E+00_JPRB, 0.346612E+00_JPRB, 0.334641E+00_JPRB &
  &, 0.322704E+00_JPRB, 0.310969E+00_JPRB, 0.299499E+00_JPRB, 0.288244E+00_JPRB &
  &, 0.277266E+00_JPRB, 0.266510E+00_JPRB, 0.256008E+00_JPRB &
  &, 0.245793E+00_JPRB, 0.235803E+00_JPRB, 0.226067E+00_JPRB, 0.216614E+00_JPRB &
  &, 0.207409E+00_JPRB, 0.198480E+00_JPRB, 0.189786E+00_JPRB &
  &, 0.181388E+00_JPRB, 0.173206E+00_JPRB, 0.165300E+00_JPRB, 0.157661E+00_JPRB &
  &, 0.150273E+00_JPRB, 0.143122E+00_JPRB, 0.136230E+00_JPRB &
  &, 0.129579E+00_JPRB, 0.123192E+00_JPRB, 0.117006E+00_JPRB, 0.111082E+00_JPRB &
  &, 0.105397E+00_JPRB, 0.999283E-01_JPRB, 0.946477E-01_JPRB &
  &, 0.896161E-01_JPRB, 0.847605E-01_JPRB, 0.801412E-01_JPRB, 0.757279E-01_JPRB &
  &, 0.714879E-01_JPRB, 0.674823E-01_JPRB, 0.636284E-01_JPRB &
  &, 0.599373E-01_JPRB, 0.564205E-01_JPRB, 0.530899E-01_JPRB, 0.499572E-01_JPRB &
  &, 0.469288E-01_JPRB, 0.440663E-01_JPRB, 0.413798E-01_JPRB &
  &, 0.387694E-01_JPRB, 0.363529E-01_JPRB, 0.340276E-01_JPRB, 0.318571E-01_JPRB &
  &, 0.297918E-01_JPRB, 0.278381E-01_JPRB, 0.260026E-01_JPRB &
  &, 0.242917E-01_JPRB, 0.226508E-01_JPRB, 0.210841E-01_JPRB, 0.196593E-01_JPRB &
  &, 0.182552E-01_JPRB, 0.170038E-01_JPRB, 0.157807E-01_JPRB/)
XCW( 618, :) = (/ &
  &  0.102683E+01_JPRB, 0.103255E+01_JPRB, 0.103787E+01_JPRB, 0.104278E+01_JPRB &
  &, 0.104728E+01_JPRB, 0.105136E+01_JPRB, 0.105501E+01_JPRB &
  &, 0.105825E+01_JPRB, 0.106105E+01_JPRB, 0.106343E+01_JPRB, 0.106537E+01_JPRB &
  &, 0.106687E+01_JPRB, 0.106794E+01_JPRB, 0.106847E+01_JPRB &
  &, 0.106874E+01_JPRB, 0.106847E+01_JPRB, 0.106776E+01_JPRB, 0.106660E+01_JPRB &
  &, 0.106499E+01_JPRB, 0.106293E+01_JPRB, 0.106042E+01_JPRB &
  &, 0.105747E+01_JPRB, 0.105407E+01_JPRB, 0.105022E+01_JPRB, 0.104593E+01_JPRB &
  &, 0.104120E+01_JPRB, 0.103603E+01_JPRB, 0.103043E+01_JPRB &
  &, 0.102440E+01_JPRB, 0.101794E+01_JPRB, 0.101106E+01_JPRB, 0.100377E+01_JPRB &
  &, 0.996067E+00_JPRB, 0.987967E+00_JPRB, 0.979471E+00_JPRB &
  &, 0.970591E+00_JPRB, 0.961332E+00_JPRB, 0.951706E+00_JPRB, 0.941724E+00_JPRB &
  &, 0.931394E+00_JPRB, 0.920723E+00_JPRB, 0.909726E+00_JPRB &
  &, 0.898420E+00_JPRB, 0.886804E+00_JPRB, 0.874902E+00_JPRB, 0.862728E+00_JPRB &
  &, 0.850289E+00_JPRB, 0.837594E+00_JPRB, 0.824678E+00_JPRB &
  &, 0.811526E+00_JPRB, 0.798166E+00_JPRB, 0.784626E+00_JPRB, 0.770895E+00_JPRB &
  &, 0.757004E+00_JPRB, 0.742973E+00_JPRB, 0.728806E+00_JPRB &
  &, 0.714524E+00_JPRB, 0.700132E+00_JPRB, 0.685668E+00_JPRB, 0.671122E+00_JPRB &
  &, 0.656533E+00_JPRB, 0.641890E+00_JPRB, 0.627233E+00_JPRB &
  &, 0.612549E+00_JPRB, 0.597880E+00_JPRB, 0.583230E+00_JPRB, 0.568622E+00_JPRB &
  &, 0.554059E+00_JPRB, 0.539545E+00_JPRB, 0.525099E+00_JPRB &
  &, 0.510764E+00_JPRB, 0.496520E+00_JPRB, 0.482387E+00_JPRB, 0.468362E+00_JPRB &
  &, 0.454485E+00_JPRB, 0.440754E+00_JPRB, 0.427184E+00_JPRB &
  &, 0.413795E+00_JPRB, 0.400551E+00_JPRB, 0.387518E+00_JPRB, 0.374658E+00_JPRB &
  &, 0.362037E+00_JPRB, 0.349588E+00_JPRB, 0.337374E+00_JPRB &
  &, 0.325378E+00_JPRB, 0.313608E+00_JPRB, 0.302101E+00_JPRB, 0.290806E+00_JPRB &
  &, 0.279755E+00_JPRB, 0.268953E+00_JPRB, 0.258403E+00_JPRB &
  &, 0.248137E+00_JPRB, 0.238092E+00_JPRB, 0.228330E+00_JPRB, 0.218785E+00_JPRB &
  &, 0.209550E+00_JPRB, 0.200555E+00_JPRB, 0.191826E+00_JPRB &
  &, 0.183355E+00_JPRB, 0.175134E+00_JPRB, 0.167188E+00_JPRB, 0.159467E+00_JPRB &
  &, 0.152032E+00_JPRB, 0.144833E+00_JPRB, 0.137890E+00_JPRB &
  &, 0.131186E+00_JPRB, 0.124743E+00_JPRB, 0.118499E+00_JPRB, 0.112515E+00_JPRB &
  &, 0.106768E+00_JPRB, 0.101233E+00_JPRB, 0.959290E-01_JPRB &
  &, 0.908725E-01_JPRB, 0.859907E-01_JPRB, 0.812978E-01_JPRB, 0.768553E-01_JPRB &
  &, 0.725846E-01_JPRB, 0.684988E-01_JPRB, 0.646109E-01_JPRB &
  &, 0.608845E-01_JPRB, 0.573312E-01_JPRB, 0.539626E-01_JPRB, 0.507384E-01_JPRB &
  &, 0.477214E-01_JPRB, 0.448167E-01_JPRB, 0.420865E-01_JPRB &
  &, 0.394310E-01_JPRB, 0.369679E-01_JPRB, 0.346512E-01_JPRB, 0.324319E-01_JPRB &
  &, 0.303163E-01_JPRB, 0.283699E-01_JPRB, 0.264817E-01_JPRB &
  &, 0.247167E-01_JPRB, 0.230815E-01_JPRB, 0.215206E-01_JPRB, 0.200383E-01_JPRB &
  &, 0.186393E-01_JPRB, 0.173281E-01_JPRB, 0.161092E-01_JPRB/)
XCW( 619, :) = (/ &
  &  0.102710E+01_JPRB, 0.103289E+01_JPRB, 0.103828E+01_JPRB, 0.104325E+01_JPRB &
  &, 0.104782E+01_JPRB, 0.105197E+01_JPRB, 0.105570E+01_JPRB &
  &, 0.105900E+01_JPRB, 0.106188E+01_JPRB, 0.106432E+01_JPRB, 0.106633E+01_JPRB &
  &, 0.106791E+01_JPRB, 0.106904E+01_JPRB, 0.106973E+01_JPRB &
  &, 0.106998E+01_JPRB, 0.106978E+01_JPRB, 0.106914E+01_JPRB, 0.106805E+01_JPRB &
  &, 0.106651E+01_JPRB, 0.106452E+01_JPRB, 0.106208E+01_JPRB &
  &, 0.105919E+01_JPRB, 0.105586E+01_JPRB, 0.105208E+01_JPRB, 0.104785E+01_JPRB &
  &, 0.104319E+01_JPRB, 0.103808E+01_JPRB, 0.103254E+01_JPRB &
  &, 0.102657E+01_JPRB, 0.102017E+01_JPRB, 0.101335E+01_JPRB, 0.100612E+01_JPRB &
  &, 0.998475E+00_JPRB, 0.990427E+00_JPRB, 0.981989E+00_JPRB &
  &, 0.973158E+00_JPRB, 0.963955E+00_JPRB, 0.954375E+00_JPRB, 0.944441E+00_JPRB &
  &, 0.934159E+00_JPRB, 0.923537E+00_JPRB, 0.912578E+00_JPRB &
  &, 0.901311E+00_JPRB, 0.889744E+00_JPRB, 0.877880E+00_JPRB, 0.865745E+00_JPRB &
  &, 0.853332E+00_JPRB, 0.840674E+00_JPRB, 0.827782E+00_JPRB &
  &, 0.814653E+00_JPRB, 0.801329E+00_JPRB, 0.787810E+00_JPRB, 0.774099E+00_JPRB &
  &, 0.760241E+00_JPRB, 0.746213E+00_JPRB, 0.732062E+00_JPRB &
  &, 0.717794E+00_JPRB, 0.703415E+00_JPRB, 0.688946E+00_JPRB, 0.674409E+00_JPRB &
  &, 0.659827E+00_JPRB, 0.645189E+00_JPRB, 0.630517E+00_JPRB &
  &, 0.615834E+00_JPRB, 0.601163E+00_JPRB, 0.586509E+00_JPRB, 0.571876E+00_JPRB &
  &, 0.557305E+00_JPRB, 0.542779E+00_JPRB, 0.528320E+00_JPRB &
  &, 0.513948E+00_JPRB, 0.499686E+00_JPRB, 0.485531E+00_JPRB, 0.471481E+00_JPRB &
  &, 0.457577E+00_JPRB, 0.443815E+00_JPRB, 0.430212E+00_JPRB &
  &, 0.416786E+00_JPRB, 0.403528E+00_JPRB, 0.390427E+00_JPRB, 0.377547E+00_JPRB &
  &, 0.364877E+00_JPRB, 0.352376E+00_JPRB, 0.340133E+00_JPRB &
  &, 0.328079E+00_JPRB, 0.316275E+00_JPRB, 0.304703E+00_JPRB, 0.293368E+00_JPRB &
  &, 0.282275E+00_JPRB, 0.271427E+00_JPRB, 0.260829E+00_JPRB &
  &, 0.250480E+00_JPRB, 0.240413E+00_JPRB, 0.230561E+00_JPRB, 0.220988E+00_JPRB &
  &, 0.211691E+00_JPRB, 0.202663E+00_JPRB, 0.193865E+00_JPRB &
  &, 0.185323E+00_JPRB, 0.177063E+00_JPRB, 0.169038E+00_JPRB, 0.161310E+00_JPRB &
  &, 0.153792E+00_JPRB, 0.146544E+00_JPRB, 0.139550E+00_JPRB &
  &, 0.132793E+00_JPRB, 0.126295E+00_JPRB, 0.120034E+00_JPRB, 0.113990E+00_JPRB &
  &, 0.108181E+00_JPRB, 0.102582E+00_JPRB, 0.972544E-01_JPRB &
  &, 0.921289E-01_JPRB, 0.871754E-01_JPRB, 0.824544E-01_JPRB, 0.779356E-01_JPRB &
  &, 0.736336E-01_JPRB, 0.695152E-01_JPRB, 0.655934E-01_JPRB &
  &, 0.618318E-01_JPRB, 0.582419E-01_JPRB, 0.548352E-01_JPRB, 0.515717E-01_JPRB &
  &, 0.485139E-01_JPRB, 0.455670E-01_JPRB, 0.427932E-01_JPRB &
  &, 0.401478E-01_JPRB, 0.376389E-01_JPRB, 0.352749E-01_JPRB, 0.330068E-01_JPRB &
  &, 0.308992E-01_JPRB, 0.289016E-01_JPRB, 0.270207E-01_JPRB &
  &, 0.252023E-01_JPRB, 0.235121E-01_JPRB, 0.219570E-01_JPRB, 0.204174E-01_JPRB &
  &, 0.190235E-01_JPRB, 0.177173E-01_JPRB, 0.165035E-01_JPRB/)
XCW( 620, :) = (/ &
  &  0.102737E+01_JPRB, 0.103322E+01_JPRB, 0.103868E+01_JPRB, 0.104373E+01_JPRB &
  &, 0.104836E+01_JPRB, 0.105258E+01_JPRB, 0.105638E+01_JPRB &
  &, 0.105975E+01_JPRB, 0.106270E+01_JPRB, 0.106521E+01_JPRB, 0.106730E+01_JPRB &
  &, 0.106894E+01_JPRB, 0.107015E+01_JPRB, 0.107091E+01_JPRB &
  &, 0.107123E+01_JPRB, 0.107110E+01_JPRB, 0.107053E+01_JPRB, 0.106950E+01_JPRB &
  &, 0.106803E+01_JPRB, 0.106611E+01_JPRB, 0.106374E+01_JPRB &
  &, 0.106092E+01_JPRB, 0.105765E+01_JPRB, 0.105393E+01_JPRB, 0.104978E+01_JPRB &
  &, 0.104517E+01_JPRB, 0.104013E+01_JPRB, 0.103465E+01_JPRB &
  &, 0.102874E+01_JPRB, 0.102241E+01_JPRB, 0.101565E+01_JPRB, 0.100847E+01_JPRB &
  &, 0.100089E+01_JPRB, 0.992895E+00_JPRB, 0.984511E+00_JPRB &
  &, 0.975735E+00_JPRB, 0.966577E+00_JPRB, 0.957054E+00_JPRB, 0.947168E+00_JPRB &
  &, 0.936934E+00_JPRB, 0.926350E+00_JPRB, 0.915441E+00_JPRB &
  &, 0.904224E+00_JPRB, 0.892685E+00_JPRB, 0.880870E+00_JPRB, 0.868762E+00_JPRB &
  &, 0.856387E+00_JPRB, 0.843767E+00_JPRB, 0.830899E+00_JPRB &
  &, 0.817807E+00_JPRB, 0.804505E+00_JPRB, 0.791007E+00_JPRB, 0.777317E+00_JPRB &
  &, 0.763464E+00_JPRB, 0.749467E+00_JPRB, 0.735332E+00_JPRB &
  &, 0.721079E+00_JPRB, 0.706713E+00_JPRB, 0.692255E+00_JPRB, 0.677711E+00_JPRB &
  &, 0.663120E+00_JPRB, 0.648487E+00_JPRB, 0.633818E+00_JPRB &
  &, 0.619137E+00_JPRB, 0.604465E+00_JPRB, 0.589789E+00_JPRB, 0.575150E+00_JPRB &
  &, 0.560551E+00_JPRB, 0.546014E+00_JPRB, 0.531542E+00_JPRB &
  &, 0.517154E+00_JPRB, 0.502872E+00_JPRB, 0.488674E+00_JPRB, 0.474622E+00_JPRB &
  &, 0.460691E+00_JPRB, 0.446899E+00_JPRB, 0.433264E+00_JPRB &
  &, 0.419802E+00_JPRB, 0.406480E+00_JPRB, 0.393387E+00_JPRB, 0.380437E+00_JPRB &
  &, 0.367718E+00_JPRB, 0.355218E+00_JPRB, 0.342893E+00_JPRB &
  &, 0.330808E+00_JPRB, 0.318971E+00_JPRB, 0.307334E+00_JPRB, 0.295959E+00_JPRB &
  &, 0.284824E+00_JPRB, 0.273902E+00_JPRB, 0.263255E+00_JPRB &
  &, 0.252886E+00_JPRB, 0.242733E+00_JPRB, 0.232858E+00_JPRB, 0.223226E+00_JPRB &
  &, 0.213865E+00_JPRB, 0.204772E+00_JPRB, 0.195940E+00_JPRB &
  &, 0.187326E+00_JPRB, 0.179027E+00_JPRB, 0.170962E+00_JPRB, 0.163154E+00_JPRB &
  &, 0.155590E+00_JPRB, 0.148294E+00_JPRB, 0.141250E+00_JPRB &
  &, 0.134441E+00_JPRB, 0.127887E+00_JPRB, 0.121528E+00_JPRB, 0.115465E+00_JPRB &
  &, 0.109594E+00_JPRB, 0.103974E+00_JPRB, 0.985799E-01_JPRB &
  &, 0.933853E-01_JPRB, 0.884057E-01_JPRB, 0.836573E-01_JPRB, 0.791099E-01_JPRB &
  &, 0.747304E-01_JPRB, 0.705800E-01_JPRB, 0.665759E-01_JPRB &
  &, 0.627791E-01_JPRB, 0.591525E-01_JPRB, 0.557079E-01_JPRB, 0.524050E-01_JPRB &
  &, 0.493065E-01_JPRB, 0.463174E-01_JPRB, 0.434999E-01_JPRB &
  &, 0.408094E-01_JPRB, 0.383098E-01_JPRB, 0.358985E-01_JPRB, 0.336391E-01_JPRB &
  &, 0.314820E-01_JPRB, 0.294334E-01_JPRB, 0.274999E-01_JPRB &
  &, 0.256879E-01_JPRB, 0.240043E-01_JPRB, 0.223934E-01_JPRB, 0.208597E-01_JPRB &
  &, 0.194076E-01_JPRB, 0.181064E-01_JPRB, 0.168320E-01_JPRB/)
XCW( 621, :) = (/ &
  &  0.102763E+01_JPRB, 0.103356E+01_JPRB, 0.103908E+01_JPRB, 0.104420E+01_JPRB &
  &, 0.104890E+01_JPRB, 0.105319E+01_JPRB, 0.105706E+01_JPRB &
  &, 0.106051E+01_JPRB, 0.106352E+01_JPRB, 0.106611E+01_JPRB, 0.106826E+01_JPRB &
  &, 0.106997E+01_JPRB, 0.107125E+01_JPRB, 0.107208E+01_JPRB &
  &, 0.107247E+01_JPRB, 0.107242E+01_JPRB, 0.107191E+01_JPRB, 0.107096E+01_JPRB &
  &, 0.106955E+01_JPRB, 0.106770E+01_JPRB, 0.106540E+01_JPRB &
  &, 0.106265E+01_JPRB, 0.105944E+01_JPRB, 0.105579E+01_JPRB, 0.105170E+01_JPRB &
  &, 0.104716E+01_JPRB, 0.104218E+01_JPRB, 0.103677E+01_JPRB &
  &, 0.103092E+01_JPRB, 0.102464E+01_JPRB, 0.101795E+01_JPRB, 0.101083E+01_JPRB &
  &, 0.100330E+01_JPRB, 0.995368E+00_JPRB, 0.987037E+00_JPRB &
  &, 0.978320E+00_JPRB, 0.969209E+00_JPRB, 0.959743E+00_JPRB, 0.949905E+00_JPRB &
  &, 0.939709E+00_JPRB, 0.929185E+00_JPRB, 0.918315E+00_JPRB &
  &, 0.907136E+00_JPRB, 0.895647E+00_JPRB, 0.883861E+00_JPRB, 0.871790E+00_JPRB &
  &, 0.859454E+00_JPRB, 0.846859E+00_JPRB, 0.834029E+00_JPRB &
  &, 0.820961E+00_JPRB, 0.807681E+00_JPRB, 0.794205E+00_JPRB, 0.780549E+00_JPRB &
  &, 0.766715E+00_JPRB, 0.752737E+00_JPRB, 0.738618E+00_JPRB &
  &, 0.724365E+00_JPRB, 0.710012E+00_JPRB, 0.695565E+00_JPRB, 0.681031E+00_JPRB &
  &, 0.666447E+00_JPRB, 0.651820E+00_JPRB, 0.637138E+00_JPRB &
  &, 0.622457E+00_JPRB, 0.607767E+00_JPRB, 0.593088E+00_JPRB, 0.578443E+00_JPRB &
  &, 0.563836E+00_JPRB, 0.549290E+00_JPRB, 0.534784E+00_JPRB &
  &, 0.520380E+00_JPRB, 0.506081E+00_JPRB, 0.491861E+00_JPRB, 0.477763E+00_JPRB &
  &, 0.463806E+00_JPRB, 0.449984E+00_JPRB, 0.436316E+00_JPRB &
  &, 0.422818E+00_JPRB, 0.409482E+00_JPRB, 0.396322E+00_JPRB, 0.383377E+00_JPRB &
  &, 0.370611E+00_JPRB, 0.358033E+00_JPRB, 0.345681E+00_JPRB &
  &, 0.333565E+00_JPRB, 0.321667E+00_JPRB, 0.309993E+00_JPRB, 0.298550E+00_JPRB &
  &, 0.287373E+00_JPRB, 0.276406E+00_JPRB, 0.265712E+00_JPRB &
  &, 0.255261E+00_JPRB, 0.245086E+00_JPRB, 0.235155E+00_JPRB, 0.225463E+00_JPRB &
  &, 0.216074E+00_JPRB, 0.206916E+00_JPRB, 0.198015E+00_JPRB &
  &, 0.189366E+00_JPRB, 0.180992E+00_JPRB, 0.172886E+00_JPRB, 0.164997E+00_JPRB &
  &, 0.157388E+00_JPRB, 0.150044E+00_JPRB, 0.142950E+00_JPRB &
  &, 0.136088E+00_JPRB, 0.129479E+00_JPRB, 0.123104E+00_JPRB, 0.116941E+00_JPRB &
  &, 0.111050E+00_JPRB, 0.105366E+00_JPRB, 0.999053E-01_JPRB &
  &, 0.946865E-01_JPRB, 0.896359E-01_JPRB, 0.848602E-01_JPRB, 0.802372E-01_JPRB &
  &, 0.758271E-01_JPRB, 0.715965E-01_JPRB, 0.676076E-01_JPRB &
  &, 0.637264E-01_JPRB, 0.600632E-01_JPRB, 0.565806E-01_JPRB, 0.532904E-01_JPRB &
  &, 0.500990E-01_JPRB, 0.471213E-01_JPRB, 0.442610E-01_JPRB &
  &, 0.415261E-01_JPRB, 0.389808E-01_JPRB, 0.365222E-01_JPRB, 0.342140E-01_JPRB &
  &, 0.320648E-01_JPRB, 0.299651E-01_JPRB, 0.280389E-01_JPRB &
  &, 0.261736E-01_JPRB, 0.244350E-01_JPRB, 0.228299E-01_JPRB, 0.212388E-01_JPRB &
  &, 0.197917E-01_JPRB, 0.184307E-01_JPRB, 0.171606E-01_JPRB/)
XCW( 622, :) = (/ &
  &  0.102790E+01_JPRB, 0.103390E+01_JPRB, 0.103949E+01_JPRB, 0.104467E+01_JPRB &
  &, 0.104945E+01_JPRB, 0.105381E+01_JPRB, 0.105774E+01_JPRB &
  &, 0.106126E+01_JPRB, 0.106435E+01_JPRB, 0.106700E+01_JPRB, 0.106923E+01_JPRB &
  &, 0.107101E+01_JPRB, 0.107236E+01_JPRB, 0.107326E+01_JPRB &
  &, 0.107372E+01_JPRB, 0.107373E+01_JPRB, 0.107330E+01_JPRB, 0.107241E+01_JPRB &
  &, 0.107108E+01_JPRB, 0.106929E+01_JPRB, 0.106706E+01_JPRB &
  &, 0.106438E+01_JPRB, 0.106124E+01_JPRB, 0.105766E+01_JPRB, 0.105363E+01_JPRB &
  &, 0.104916E+01_JPRB, 0.104424E+01_JPRB, 0.103887E+01_JPRB &
  &, 0.103311E+01_JPRB, 0.102689E+01_JPRB, 0.102026E+01_JPRB, 0.101320E+01_JPRB &
  &, 0.100573E+01_JPRB, 0.997850E+00_JPRB, 0.989573E+00_JPRB &
  &, 0.980906E+00_JPRB, 0.971860E+00_JPRB, 0.962432E+00_JPRB, 0.952642E+00_JPRB &
  &, 0.942505E+00_JPRB, 0.932020E+00_JPRB, 0.921200E+00_JPRB &
  &, 0.910060E+00_JPRB, 0.898610E+00_JPRB, 0.886862E+00_JPRB, 0.874831E+00_JPRB &
  &, 0.862533E+00_JPRB, 0.849964E+00_JPRB, 0.837158E+00_JPRB &
  &, 0.824127E+00_JPRB, 0.810884E+00_JPRB, 0.797431E+00_JPRB, 0.783795E+00_JPRB &
  &, 0.769981E+00_JPRB, 0.756006E+00_JPRB, 0.741904E+00_JPRB &
  &, 0.727665E+00_JPRB, 0.713326E+00_JPRB, 0.698891E+00_JPRB, 0.684367E+00_JPRB &
  &, 0.669248E+00_JPRB, 0.655153E+00_JPRB, 0.640475E+00_JPRB &
  &, 0.625796E+00_JPRB, 0.611105E+00_JPRB, 0.596405E+00_JPRB, 0.581755E+00_JPRB &
  &, 0.567122E+00_JPRB, 0.552565E+00_JPRB, 0.538046E+00_JPRB &
  &, 0.523628E+00_JPRB, 0.509289E+00_JPRB, 0.495071E+00_JPRB, 0.480949E+00_JPRB &
  &, 0.466966E+00_JPRB, 0.453115E+00_JPRB, 0.439415E+00_JPRB &
  &, 0.425858E+00_JPRB, 0.412508E+00_JPRB, 0.399307E+00_JPRB, 0.386292E+00_JPRB &
  &, 0.373504E+00_JPRB, 0.360902E+00_JPRB, 0.348495E+00_JPRB &
  &, 0.336322E+00_JPRB, 0.324391E+00_JPRB, 0.312682E+00_JPRB, 0.301171E+00_JPRB &
  &, 0.289953E+00_JPRB, 0.278941E+00_JPRB, 0.268200E+00_JPRB &
  &, 0.257699E+00_JPRB, 0.247472E+00_JPRB, 0.237484E+00_JPRB, 0.227733E+00_JPRB &
  &, 0.218282E+00_JPRB, 0.209059E+00_JPRB, 0.200091E+00_JPRB &
  &, 0.191405E+00_JPRB, 0.182993E+00_JPRB, 0.174810E+00_JPRB, 0.166879E+00_JPRB &
  &, 0.159224E+00_JPRB, 0.151833E+00_JPRB, 0.144649E+00_JPRB &
  &, 0.137735E+00_JPRB, 0.131072E+00_JPRB, 0.124639E+00_JPRB, 0.118458E+00_JPRB &
  &, 0.112506E+00_JPRB, 0.106758E+00_JPRB, 0.101275E+00_JPRB &
  &, 0.959877E-01_JPRB, 0.909117E-01_JPRB, 0.860631E-01_JPRB, 0.814115E-01_JPRB &
  &, 0.769238E-01_JPRB, 0.727097E-01_JPRB, 0.686392E-01_JPRB &
  &, 0.647235E-01_JPRB, 0.610245E-01_JPRB, 0.575046E-01_JPRB, 0.541238E-01_JPRB &
  &, 0.509444E-01_JPRB, 0.478717E-01_JPRB, 0.450221E-01_JPRB &
  &, 0.422429E-01_JPRB, 0.396517E-01_JPRB, 0.372025E-01_JPRB, 0.348463E-01_JPRB &
  &, 0.326476E-01_JPRB, 0.305560E-01_JPRB, 0.285779E-01_JPRB &
  &, 0.266592E-01_JPRB, 0.249272E-01_JPRB, 0.232663E-01_JPRB, 0.216811E-01_JPRB &
  &, 0.202398E-01_JPRB, 0.188199E-01_JPRB, 0.175549E-01_JPRB/)
XCW( 623, :) = (/ &
  &  0.102817E+01_JPRB, 0.103423E+01_JPRB, 0.103990E+01_JPRB, 0.104515E+01_JPRB &
  &, 0.104999E+01_JPRB, 0.105442E+01_JPRB, 0.105843E+01_JPRB &
  &, 0.106201E+01_JPRB, 0.106517E+01_JPRB, 0.106790E+01_JPRB, 0.107019E+01_JPRB &
  &, 0.107205E+01_JPRB, 0.107347E+01_JPRB, 0.107444E+01_JPRB &
  &, 0.107497E+01_JPRB, 0.107505E+01_JPRB, 0.107469E+01_JPRB, 0.107388E+01_JPRB &
  &, 0.107261E+01_JPRB, 0.107089E+01_JPRB, 0.106873E+01_JPRB &
  &, 0.106611E+01_JPRB, 0.106304E+01_JPRB, 0.105953E+01_JPRB, 0.105557E+01_JPRB &
  &, 0.105116E+01_JPRB, 0.104631E+01_JPRB, 0.104102E+01_JPRB &
  &, 0.103530E+01_JPRB, 0.102915E+01_JPRB, 0.102257E+01_JPRB, 0.101557E+01_JPRB &
  &, 0.100816E+01_JPRB, 0.100034E+01_JPRB, 0.992117E+00_JPRB &
  &, 0.983501E+00_JPRB, 0.974502E+00_JPRB, 0.965131E+00_JPRB, 0.955399E+00_JPRB &
  &, 0.945301E+00_JPRB, 0.934865E+00_JPRB, 0.924084E+00_JPRB &
  &, 0.912995E+00_JPRB, 0.901584E+00_JPRB, 0.889876E+00_JPRB, 0.877883E+00_JPRB &
  &, 0.865612E+00_JPRB, 0.853082E+00_JPRB, 0.840314E+00_JPRB &
  &, 0.827307E+00_JPRB, 0.814088E+00_JPRB, 0.800656E+00_JPRB, 0.787041E+00_JPRB &
  &, 0.773247E+00_JPRB, 0.759305E+00_JPRB, 0.745205E+00_JPRB &
  &, 0.730997E+00_JPRB, 0.716656E+00_JPRB, 0.702233E+00_JPRB, 0.687719E+00_JPRB &
  &, 0.673135E+00_JPRB, 0.658504E+00_JPRB, 0.643829E+00_JPRB &
  &, 0.629135E+00_JPRB, 0.614444E+00_JPRB, 0.599742E+00_JPRB, 0.585068E+00_JPRB &
  &, 0.570447E+00_JPRB, 0.555860E+00_JPRB, 0.541330E+00_JPRB &
  &, 0.526897E+00_JPRB, 0.512540E+00_JPRB, 0.498280E+00_JPRB, 0.484136E+00_JPRB &
  &, 0.470126E+00_JPRB, 0.456247E+00_JPRB, 0.442515E+00_JPRB &
  &, 0.428947E+00_JPRB, 0.415535E+00_JPRB, 0.402292E+00_JPRB, 0.389259E+00_JPRB &
  &, 0.376423E+00_JPRB, 0.363770E+00_JPRB, 0.351337E+00_JPRB &
  &, 0.339106E+00_JPRB, 0.327114E+00_JPRB, 0.315370E+00_JPRB, 0.303822E+00_JPRB &
  &, 0.292532E+00_JPRB, 0.281507E+00_JPRB, 0.270688E+00_JPRB &
  &, 0.260138E+00_JPRB, 0.249857E+00_JPRB, 0.239814E+00_JPRB, 0.230037E+00_JPRB &
  &, 0.220491E+00_JPRB, 0.211237E+00_JPRB, 0.202236E+00_JPRB &
  &, 0.193480E+00_JPRB, 0.184995E+00_JPRB, 0.176771E+00_JPRB, 0.168798E+00_JPRB &
  &, 0.161060E+00_JPRB, 0.153622E+00_JPRB, 0.146389E+00_JPRB &
  &, 0.139422E+00_JPRB, 0.132705E+00_JPRB, 0.126216E+00_JPRB, 0.119976E+00_JPRB &
  &, 0.113962E+00_JPRB, 0.108193E+00_JPRB, 0.102645E+00_JPRB &
  &, 0.972890E-01_JPRB, 0.921875E-01_JPRB, 0.872660E-01_JPRB, 0.825858E-01_JPRB &
  &, 0.780682E-01_JPRB, 0.737746E-01_JPRB, 0.696709E-01_JPRB &
  &, 0.657206E-01_JPRB, 0.619857E-01_JPRB, 0.584287E-01_JPRB, 0.550092E-01_JPRB &
  &, 0.517898E-01_JPRB, 0.486756E-01_JPRB, 0.457831E-01_JPRB &
  &, 0.429596E-01_JPRB, 0.403226E-01_JPRB, 0.378262E-01_JPRB, 0.354787E-01_JPRB &
  &, 0.332304E-01_JPRB, 0.310877E-01_JPRB, 0.291169E-01_JPRB &
  &, 0.272055E-01_JPRB, 0.254194E-01_JPRB, 0.237028E-01_JPRB, 0.221233E-01_JPRB &
  &, 0.206239E-01_JPRB, 0.192091E-01_JPRB, 0.178834E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART89',1,ZHOOK_HANDLE)
END SUBROUTINE PART89

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART90

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART90',0,ZHOOK_HANDLE)

XCW( 624, :) = (/ &
  &  0.102844E+01_JPRB, 0.103457E+01_JPRB, 0.104030E+01_JPRB, 0.104562E+01_JPRB &
  &, 0.105054E+01_JPRB, 0.105504E+01_JPRB, 0.105912E+01_JPRB &
  &, 0.106277E+01_JPRB, 0.106600E+01_JPRB, 0.106880E+01_JPRB, 0.107116E+01_JPRB &
  &, 0.107309E+01_JPRB, 0.107458E+01_JPRB, 0.107562E+01_JPRB &
  &, 0.107622E+01_JPRB, 0.107638E+01_JPRB, 0.107608E+01_JPRB, 0.107534E+01_JPRB &
  &, 0.107414E+01_JPRB, 0.107250E+01_JPRB, 0.107040E+01_JPRB &
  &, 0.106785E+01_JPRB, 0.106485E+01_JPRB, 0.106140E+01_JPRB, 0.105751E+01_JPRB &
  &, 0.105316E+01_JPRB, 0.104838E+01_JPRB, 0.104316E+01_JPRB &
  &, 0.103749E+01_JPRB, 0.103140E+01_JPRB, 0.102489E+01_JPRB, 0.101795E+01_JPRB &
  &, 0.101059E+01_JPRB, 0.100282E+01_JPRB, 0.994667E+00_JPRB &
  &, 0.986105E+00_JPRB, 0.977163E+00_JPRB, 0.967840E+00_JPRB, 0.958156E+00_JPRB &
  &, 0.948107E+00_JPRB, 0.937710E+00_JPRB, 0.926990E+00_JPRB &
  &, 0.915929E+00_JPRB, 0.904558E+00_JPRB, 0.892901E+00_JPRB, 0.880936E+00_JPRB &
  &, 0.868703E+00_JPRB, 0.856211E+00_JPRB, 0.843469E+00_JPRB &
  &, 0.830500E+00_JPRB, 0.817304E+00_JPRB, 0.803895E+00_JPRB, 0.790302E+00_JPRB &
  &, 0.776542E+00_JPRB, 0.762604E+00_JPRB, 0.748537E+00_JPRB &
  &, 0.734329E+00_JPRB, 0.720002E+00_JPRB, 0.705576E+00_JPRB, 0.691072E+00_JPRB &
  &, 0.676496E+00_JPRB, 0.661871E+00_JPRB, 0.647202E+00_JPRB &
  &, 0.632492E+00_JPRB, 0.617802E+00_JPRB, 0.603097E+00_JPRB, 0.588419E+00_JPRB &
  &, 0.573772E+00_JPRB, 0.559176E+00_JPRB, 0.544634E+00_JPRB &
  &, 0.530165E+00_JPRB, 0.515792E+00_JPRB, 0.501512E+00_JPRB, 0.487344E+00_JPRB &
  &, 0.473309E+00_JPRB, 0.459401E+00_JPRB, 0.445638E+00_JPRB &
  &, 0.432036E+00_JPRB, 0.418586E+00_JPRB, 0.405328E+00_JPRB, 0.392226E+00_JPRB &
  &, 0.379343E+00_JPRB, 0.366666E+00_JPRB, 0.354179E+00_JPRB &
  &, 0.341919E+00_JPRB, 0.329895E+00_JPRB, 0.318087E+00_JPRB, 0.306501E+00_JPRB &
  &, 0.295172E+00_JPRB, 0.284073E+00_JPRB, 0.273207E+00_JPRB &
  &, 0.262608E+00_JPRB, 0.252275E+00_JPRB, 0.242176E+00_JPRB, 0.232341E+00_JPRB &
  &, 0.222733E+00_JPRB, 0.213415E+00_JPRB, 0.204381E+00_JPRB &
  &, 0.195555E+00_JPRB, 0.187032E+00_JPRB, 0.178732E+00_JPRB, 0.170717E+00_JPRB &
  &, 0.162935E+00_JPRB, 0.155411E+00_JPRB, 0.148168E+00_JPRB &
  &, 0.141110E+00_JPRB, 0.134338E+00_JPRB, 0.127834E+00_JPRB, 0.121535E+00_JPRB &
  &, 0.115461E+00_JPRB, 0.109629E+00_JPRB, 0.104014E+00_JPRB &
  &, 0.986351E-01_JPRB, 0.934633E-01_JPRB, 0.885152E-01_JPRB, 0.837601E-01_JPRB &
  &, 0.792126E-01_JPRB, 0.748878E-01_JPRB, 0.707025E-01_JPRB &
  &, 0.667676E-01_JPRB, 0.629470E-01_JPRB, 0.593527E-01_JPRB, 0.558946E-01_JPRB &
  &, 0.526352E-01_JPRB, 0.494796E-01_JPRB, 0.465442E-01_JPRB &
  &, 0.437315E-01_JPRB, 0.410495E-01_JPRB, 0.385065E-01_JPRB, 0.361110E-01_JPRB &
  &, 0.338132E-01_JPRB, 0.316785E-01_JPRB, 0.296559E-01_JPRB &
  &, 0.276912E-01_JPRB, 0.259116E-01_JPRB, 0.242016E-01_JPRB, 0.225656E-01_JPRB &
  &, 0.210720E-01_JPRB, 0.195983E-01_JPRB, 0.182777E-01_JPRB/)
XCW( 625, :) = (/ &
  &  0.102871E+01_JPRB, 0.103491E+01_JPRB, 0.104071E+01_JPRB, 0.104610E+01_JPRB &
  &, 0.105108E+01_JPRB, 0.105565E+01_JPRB, 0.105980E+01_JPRB &
  &, 0.106353E+01_JPRB, 0.106683E+01_JPRB, 0.106970E+01_JPRB, 0.107213E+01_JPRB &
  &, 0.107413E+01_JPRB, 0.107569E+01_JPRB, 0.107680E+01_JPRB &
  &, 0.107748E+01_JPRB, 0.107770E+01_JPRB, 0.107748E+01_JPRB, 0.107680E+01_JPRB &
  &, 0.107568E+01_JPRB, 0.107410E+01_JPRB, 0.107207E+01_JPRB &
  &, 0.106959E+01_JPRB, 0.106666E+01_JPRB, 0.106328E+01_JPRB, 0.105945E+01_JPRB &
  &, 0.105517E+01_JPRB, 0.105045E+01_JPRB, 0.104529E+01_JPRB &
  &, 0.103970E+01_JPRB, 0.103367E+01_JPRB, 0.102721E+01_JPRB, 0.102033E+01_JPRB &
  &, 0.101303E+01_JPRB, 0.100533E+01_JPRB, 0.997220E+00_JPRB &
  &, 0.988719E+00_JPRB, 0.979824E+00_JPRB, 0.970558E+00_JPRB, 0.960913E+00_JPRB &
  &, 0.950923E+00_JPRB, 0.940577E+00_JPRB, 0.929896E+00_JPRB &
  &, 0.918875E+00_JPRB, 0.907555E+00_JPRB, 0.895926E+00_JPRB, 0.884012E+00_JPRB &
  &, 0.871807E+00_JPRB, 0.859354E+00_JPRB, 0.846637E+00_JPRB &
  &, 0.833693E+00_JPRB, 0.820521E+00_JPRB, 0.807148E+00_JPRB, 0.793576E+00_JPRB &
  &, 0.779837E+00_JPRB, 0.765918E+00_JPRB, 0.751868E+00_JPRB &
  &, 0.737677E+00_JPRB, 0.723364E+00_JPRB, 0.708950E+00_JPRB, 0.694441E+00_JPRB &
  &, 0.679875E+00_JPRB, 0.665239E+00_JPRB, 0.650575E+00_JPRB &
  &, 0.635886E+00_JPRB, 0.621177E+00_JPRB, 0.606471E+00_JPRB, 0.591771E+00_JPRB &
  &, 0.577117E+00_JPRB, 0.562492E+00_JPRB, 0.547938E+00_JPRB &
  &, 0.533455E+00_JPRB, 0.519064E+00_JPRB, 0.504765E+00_JPRB, 0.490575E+00_JPRB &
  &, 0.476492E+00_JPRB, 0.462556E+00_JPRB, 0.448761E+00_JPRB &
  &, 0.435125E+00_JPRB, 0.421662E+00_JPRB, 0.408364E+00_JPRB, 0.395244E+00_JPRB &
  &, 0.382315E+00_JPRB, 0.369588E+00_JPRB, 0.357048E+00_JPRB &
  &, 0.344759E+00_JPRB, 0.332676E+00_JPRB, 0.320805E+00_JPRB, 0.309181E+00_JPRB &
  &, 0.297781E+00_JPRB, 0.286639E+00_JPRB, 0.275758E+00_JPRB &
  &, 0.265077E+00_JPRB, 0.254692E+00_JPRB, 0.244538E+00_JPRB, 0.234645E+00_JPRB &
  &, 0.225010E+00_JPRB, 0.215593E+00_JPRB, 0.206527E+00_JPRB &
  &, 0.197665E+00_JPRB, 0.189070E+00_JPRB, 0.180730E+00_JPRB, 0.172635E+00_JPRB &
  &, 0.164809E+00_JPRB, 0.157238E+00_JPRB, 0.149907E+00_JPRB &
  &, 0.142837E+00_JPRB, 0.136012E+00_JPRB, 0.129410E+00_JPRB, 0.123095E+00_JPRB &
  &, 0.116959E+00_JPRB, 0.111064E+00_JPRB, 0.105428E+00_JPRB &
  &, 0.999812E-01_JPRB, 0.947847E-01_JPRB, 0.897643E-01_JPRB, 0.849813E-01_JPRB &
  &, 0.804047E-01_JPRB, 0.760011E-01_JPRB, 0.717833E-01_JPRB &
  &, 0.677647E-01_JPRB, 0.639588E-01_JPRB, 0.602767E-01_JPRB, 0.567800E-01_JPRB &
  &, 0.534806E-01_JPRB, 0.503371E-01_JPRB, 0.473053E-01_JPRB &
  &, 0.444482E-01_JPRB, 0.417764E-01_JPRB, 0.391869E-01_JPRB, 0.367434E-01_JPRB &
  &, 0.344543E-01_JPRB, 0.322694E-01_JPRB, 0.301949E-01_JPRB &
  &, 0.282375E-01_JPRB, 0.264038E-01_JPRB, 0.246380E-01_JPRB, 0.230079E-01_JPRB &
  &, 0.214562E-01_JPRB, 0.199874E-01_JPRB, 0.186720E-01_JPRB/)
XCW( 626, :) = (/ &
  &  0.102898E+01_JPRB, 0.103525E+01_JPRB, 0.104112E+01_JPRB, 0.104658E+01_JPRB &
  &, 0.105163E+01_JPRB, 0.105627E+01_JPRB, 0.106049E+01_JPRB &
  &, 0.106429E+01_JPRB, 0.106766E+01_JPRB, 0.107060E+01_JPRB, 0.107310E+01_JPRB &
  &, 0.107517E+01_JPRB, 0.107680E+01_JPRB, 0.107799E+01_JPRB &
  &, 0.107873E+01_JPRB, 0.107903E+01_JPRB, 0.107887E+01_JPRB, 0.107827E+01_JPRB &
  &, 0.107721E+01_JPRB, 0.107571E+01_JPRB, 0.107375E+01_JPRB &
  &, 0.107134E+01_JPRB, 0.106847E+01_JPRB, 0.106516E+01_JPRB, 0.106139E+01_JPRB &
  &, 0.105718E+01_JPRB, 0.105253E+01_JPRB, 0.104743E+01_JPRB &
  &, 0.104190E+01_JPRB, 0.103593E+01_JPRB, 0.102954E+01_JPRB, 0.102272E+01_JPRB &
  &, 0.101548E+01_JPRB, 0.100784E+01_JPRB, 0.999783E+00_JPRB &
  &, 0.991333E+00_JPRB, 0.982494E+00_JPRB, 0.973276E+00_JPRB, 0.963690E+00_JPRB &
  &, 0.953740E+00_JPRB, 0.943443E+00_JPRB, 0.932802E+00_JPRB &
  &, 0.921843E+00_JPRB, 0.910552E+00_JPRB, 0.898963E+00_JPRB, 0.887089E+00_JPRB &
  &, 0.874923E+00_JPRB, 0.862497E+00_JPRB, 0.849818E+00_JPRB &
  &, 0.836912E+00_JPRB, 0.823764E+00_JPRB, 0.810415E+00_JPRB, 0.796865E+00_JPRB &
  &, 0.783146E+00_JPRB, 0.769247E+00_JPRB, 0.755214E+00_JPRB &
  &, 0.741024E+00_JPRB, 0.726726E+00_JPRB, 0.712325E+00_JPRB, 0.697844E+00_JPRB &
  &, 0.683270E+00_JPRB, 0.668642E+00_JPRB, 0.653965E+00_JPRB &
  &, 0.639279E+00_JPRB, 0.624553E+00_JPRB, 0.609846E+00_JPRB, 0.595141E+00_JPRB &
  &, 0.580481E+00_JPRB, 0.565848E+00_JPRB, 0.551283E+00_JPRB &
  &, 0.536766E+00_JPRB, 0.522359E+00_JPRB, 0.508040E+00_JPRB, 0.493807E+00_JPRB &
  &, 0.479721E+00_JPRB, 0.465757E+00_JPRB, 0.451932E+00_JPRB &
  &, 0.438262E+00_JPRB, 0.424738E+00_JPRB, 0.411400E+00_JPRB, 0.398262E+00_JPRB &
  &, 0.385287E+00_JPRB, 0.372510E+00_JPRB, 0.359945E+00_JPRB &
  &, 0.347600E+00_JPRB, 0.335457E+00_JPRB, 0.323551E+00_JPRB, 0.311890E+00_JPRB &
  &, 0.300450E+00_JPRB, 0.289265E+00_JPRB, 0.278308E+00_JPRB &
  &, 0.267611E+00_JPRB, 0.257142E+00_JPRB, 0.246933E+00_JPRB, 0.236982E+00_JPRB &
  &, 0.227320E+00_JPRB, 0.217874E+00_JPRB, 0.208707E+00_JPRB &
  &, 0.199812E+00_JPRB, 0.191144E+00_JPRB, 0.182766E+00_JPRB, 0.174592E+00_JPRB &
  &, 0.166722E+00_JPRB, 0.159105E+00_JPRB, 0.151725E+00_JPRB &
  &, 0.144605E+00_JPRB, 0.137686E+00_JPRB, 0.131070E+00_JPRB, 0.124655E+00_JPRB &
  &, 0.118501E+00_JPRB, 0.112543E+00_JPRB, 0.106842E+00_JPRB &
  &, 0.101372E+00_JPRB, 0.961061E-01_JPRB, 0.910598E-01_JPRB, 0.862026E-01_JPRB &
  &, 0.815491E-01_JPRB, 0.771143E-01_JPRB, 0.728641E-01_JPRB &
  &, 0.688117E-01_JPRB, 0.649201E-01_JPRB, 0.612521E-01_JPRB, 0.577174E-01_JPRB &
  &, 0.543788E-01_JPRB, 0.511411E-01_JPRB, 0.481207E-01_JPRB &
  &, 0.452201E-01_JPRB, 0.425032E-01_JPRB, 0.398672E-01_JPRB, 0.374332E-01_JPRB &
  &, 0.350954E-01_JPRB, 0.328602E-01_JPRB, 0.307339E-01_JPRB &
  &, 0.287839E-01_JPRB, 0.268959E-01_JPRB, 0.251368E-01_JPRB, 0.234501E-01_JPRB &
  &, 0.219043E-01_JPRB, 0.204415E-01_JPRB, 0.190005E-01_JPRB/)
XCW( 627, :) = (/ &
  &  0.102925E+01_JPRB, 0.103558E+01_JPRB, 0.104152E+01_JPRB, 0.104705E+01_JPRB &
  &, 0.105218E+01_JPRB, 0.105689E+01_JPRB, 0.106118E+01_JPRB &
  &, 0.106505E+01_JPRB, 0.106848E+01_JPRB, 0.107150E+01_JPRB, 0.107408E+01_JPRB &
  &, 0.107622E+01_JPRB, 0.107792E+01_JPRB, 0.107917E+01_JPRB &
  &, 0.107999E+01_JPRB, 0.108036E+01_JPRB, 0.108027E+01_JPRB, 0.107974E+01_JPRB &
  &, 0.107875E+01_JPRB, 0.107731E+01_JPRB, 0.107543E+01_JPRB &
  &, 0.107308E+01_JPRB, 0.107029E+01_JPRB, 0.106704E+01_JPRB, 0.106335E+01_JPRB &
  &, 0.105920E+01_JPRB, 0.105461E+01_JPRB, 0.104958E+01_JPRB &
  &, 0.104411E+01_JPRB, 0.103821E+01_JPRB, 0.103187E+01_JPRB, 0.102511E+01_JPRB &
  &, 0.101794E+01_JPRB, 0.101034E+01_JPRB, 0.100235E+01_JPRB &
  &, 0.993956E+00_JPRB, 0.985174E+00_JPRB, 0.976005E+00_JPRB, 0.966467E+00_JPRB &
  &, 0.956577E+00_JPRB, 0.946320E+00_JPRB, 0.935730E+00_JPRB &
  &, 0.924811E+00_JPRB, 0.913560E+00_JPRB, 0.902023E+00_JPRB, 0.890177E+00_JPRB &
  &, 0.878051E+00_JPRB, 0.865664E+00_JPRB, 0.853012E+00_JPRB &
  &, 0.840132E+00_JPRB, 0.827021E+00_JPRB, 0.813695E+00_JPRB, 0.800168E+00_JPRB &
  &, 0.786470E+00_JPRB, 0.772590E+00_JPRB, 0.758561E+00_JPRB &
  &, 0.744402E+00_JPRB, 0.730119E+00_JPRB, 0.715716E+00_JPRB, 0.701246E+00_JPRB &
  &, 0.686682E+00_JPRB, 0.672062E+00_JPRB, 0.657391E+00_JPRB &
  &, 0.642546E+00_JPRB, 0.627966E+00_JPRB, 0.613239E+00_JPRB, 0.598531E+00_JPRB &
  &, 0.583846E+00_JPRB, 0.569204E+00_JPRB, 0.554628E+00_JPRB &
  &, 0.540098E+00_JPRB, 0.525675E+00_JPRB, 0.511316E+00_JPRB, 0.497083E+00_JPRB &
  &, 0.482950E+00_JPRB, 0.468959E+00_JPRB, 0.455103E+00_JPRB &
  &, 0.441400E+00_JPRB, 0.427864E+00_JPRB, 0.414486E+00_JPRB, 0.401280E+00_JPRB &
  &, 0.388285E+00_JPRB, 0.375459E+00_JPRB, 0.362869E+00_JPRB &
  &, 0.350468E+00_JPRB, 0.338294E+00_JPRB, 0.326326E+00_JPRB, 0.314629E+00_JPRB &
  &, 0.303120E+00_JPRB, 0.291892E+00_JPRB, 0.280889E+00_JPRB &
  &, 0.270112E+00_JPRB, 0.259624E+00_JPRB, 0.249361E+00_JPRB, 0.239353E+00_JPRB &
  &, 0.229631E+00_JPRB, 0.220122E+00_JPRB, 0.210923E+00_JPRB &
  &, 0.201958E+00_JPRB, 0.193218E+00_JPRB, 0.184764E+00_JPRB, 0.176586E+00_JPRB &
  &, 0.168635E+00_JPRB, 0.160972E+00_JPRB, 0.153544E+00_JPRB &
  &, 0.146333E+00_JPRB, 0.139401E+00_JPRB, 0.132729E+00_JPRB, 0.126256E+00_JPRB &
  &, 0.120043E+00_JPRB, 0.114066E+00_JPRB, 0.108300E+00_JPRB &
  &, 0.102763E+00_JPRB, 0.974275E-01_JPRB, 0.923552E-01_JPRB, 0.874238E-01_JPRB &
  &, 0.827412E-01_JPRB, 0.782759E-01_JPRB, 0.739940E-01_JPRB &
  &, 0.698587E-01_JPRB, 0.659319E-01_JPRB, 0.622274E-01_JPRB, 0.586549E-01_JPRB &
  &, 0.552242E-01_JPRB, 0.519986E-01_JPRB, 0.489362E-01_JPRB &
  &, 0.459920E-01_JPRB, 0.432301E-01_JPRB, 0.406043E-01_JPRB, 0.380655E-01_JPRB &
  &, 0.357365E-01_JPRB, 0.334510E-01_JPRB, 0.313329E-01_JPRB &
  &, 0.293302E-01_JPRB, 0.274497E-01_JPRB, 0.256356E-01_JPRB, 0.239556E-01_JPRB &
  &, 0.223524E-01_JPRB, 0.208306E-01_JPRB, 0.193948E-01_JPRB/)
XCW( 628, :) = (/ &
  &  0.102951E+01_JPRB, 0.103592E+01_JPRB, 0.104193E+01_JPRB, 0.104753E+01_JPRB &
  &, 0.105273E+01_JPRB, 0.105751E+01_JPRB, 0.106187E+01_JPRB &
  &, 0.106581E+01_JPRB, 0.106932E+01_JPRB, 0.107240E+01_JPRB, 0.107505E+01_JPRB &
  &, 0.107726E+01_JPRB, 0.107904E+01_JPRB, 0.108036E+01_JPRB &
  &, 0.108125E+01_JPRB, 0.108169E+01_JPRB, 0.108167E+01_JPRB, 0.108121E+01_JPRB &
  &, 0.108030E+01_JPRB, 0.107893E+01_JPRB, 0.107711E+01_JPRB &
  &, 0.107483E+01_JPRB, 0.107211E+01_JPRB, 0.106893E+01_JPRB, 0.106530E+01_JPRB &
  &, 0.106122E+01_JPRB, 0.105670E+01_JPRB, 0.105173E+01_JPRB &
  &, 0.104633E+01_JPRB, 0.104048E+01_JPRB, 0.103421E+01_JPRB, 0.102751E+01_JPRB &
  &, 0.102040E+01_JPRB, 0.101286E+01_JPRB, 0.100493E+01_JPRB &
  &, 0.996588E+00_JPRB, 0.987854E+00_JPRB, 0.978742E+00_JPRB, 0.969254E+00_JPRB &
  &, 0.959414E+00_JPRB, 0.949207E+00_JPRB, 0.938658E+00_JPRB &
  &, 0.927779E+00_JPRB, 0.916580E+00_JPRB, 0.905082E+00_JPRB, 0.893277E+00_JPRB &
  &, 0.881191E+00_JPRB, 0.868832E+00_JPRB, 0.856219E+00_JPRB &
  &, 0.843364E+00_JPRB, 0.830278E+00_JPRB, 0.816976E+00_JPRB, 0.803485E+00_JPRB &
  &, 0.789793E+00_JPRB, 0.775948E+00_JPRB, 0.761938E+00_JPRB &
  &, 0.747796E+00_JPRB, 0.733513E+00_JPRB, 0.719139E+00_JPRB, 0.704648E+00_JPRB &
  &, 0.690094E+00_JPRB, 0.675481E+00_JPRB, 0.660816E+00_JPRB &
  &, 0.646102E+00_JPRB, 0.631379E+00_JPRB, 0.616651E+00_JPRB, 0.601941E+00_JPRB &
  &, 0.587250E+00_JPRB, 0.572601E+00_JPRB, 0.557994E+00_JPRB &
  &, 0.543451E+00_JPRB, 0.528991E+00_JPRB, 0.514635E+00_JPRB, 0.500359E+00_JPRB &
  &, 0.486202E+00_JPRB, 0.472184E+00_JPRB, 0.458298E+00_JPRB &
  &, 0.444561E+00_JPRB, 0.430990E+00_JPRB, 0.417573E+00_JPRB, 0.404350E+00_JPRB &
  &, 0.391283E+00_JPRB, 0.378435E+00_JPRB, 0.365792E+00_JPRB &
  &, 0.353364E+00_JPRB, 0.341132E+00_JPRB, 0.329130E+00_JPRB, 0.317367E+00_JPRB &
  &, 0.305819E+00_JPRB, 0.294519E+00_JPRB, 0.283471E+00_JPRB &
  &, 0.272677E+00_JPRB, 0.262106E+00_JPRB, 0.251789E+00_JPRB, 0.241757E+00_JPRB &
  &, 0.231941E+00_JPRB, 0.222403E+00_JPRB, 0.213138E+00_JPRB &
  &, 0.204105E+00_JPRB, 0.195328E+00_JPRB, 0.186836E+00_JPRB, 0.178580E+00_JPRB &
  &, 0.170586E+00_JPRB, 0.162838E+00_JPRB, 0.155362E+00_JPRB &
  &, 0.148101E+00_JPRB, 0.141116E+00_JPRB, 0.134389E+00_JPRB, 0.127858E+00_JPRB &
  &, 0.121584E+00_JPRB, 0.115545E+00_JPRB, 0.109758E+00_JPRB &
  &, 0.104154E+00_JPRB, 0.987944E-01_JPRB, 0.936506E-01_JPRB, 0.886921E-01_JPRB &
  &, 0.839810E-01_JPRB, 0.794376E-01_JPRB, 0.750747E-01_JPRB &
  &, 0.709555E-01_JPRB, 0.669944E-01_JPRB, 0.632028E-01_JPRB, 0.595924E-01_JPRB &
  &, 0.561224E-01_JPRB, 0.528561E-01_JPRB, 0.497516E-01_JPRB &
  &, 0.467639E-01_JPRB, 0.439569E-01_JPRB, 0.412846E-01_JPRB, 0.387554E-01_JPRB &
  &, 0.363776E-01_JPRB, 0.341009E-01_JPRB, 0.319318E-01_JPRB &
  &, 0.298765E-01_JPRB, 0.279419E-01_JPRB, 0.261344E-01_JPRB, 0.243978E-01_JPRB &
  &, 0.228005E-01_JPRB, 0.212847E-01_JPRB, 0.198548E-01_JPRB/)
XCW( 629, :) = (/ &
  &  0.102979E+01_JPRB, 0.103626E+01_JPRB, 0.104234E+01_JPRB, 0.104801E+01_JPRB &
  &, 0.105327E+01_JPRB, 0.105812E+01_JPRB, 0.106256E+01_JPRB &
  &, 0.106657E+01_JPRB, 0.107015E+01_JPRB, 0.107330E+01_JPRB, 0.107603E+01_JPRB &
  &, 0.107831E+01_JPRB, 0.108015E+01_JPRB, 0.108156E+01_JPRB &
  &, 0.108251E+01_JPRB, 0.108302E+01_JPRB, 0.108308E+01_JPRB, 0.108269E+01_JPRB &
  &, 0.108184E+01_JPRB, 0.108054E+01_JPRB, 0.107879E+01_JPRB &
  &, 0.107659E+01_JPRB, 0.107393E+01_JPRB, 0.107082E+01_JPRB, 0.106726E+01_JPRB &
  &, 0.106325E+01_JPRB, 0.105879E+01_JPRB, 0.105389E+01_JPRB &
  &, 0.104855E+01_JPRB, 0.104277E+01_JPRB, 0.103655E+01_JPRB, 0.102992E+01_JPRB &
  &, 0.102286E+01_JPRB, 0.101539E+01_JPRB, 0.100751E+01_JPRB &
  &, 0.999220E+00_JPRB, 0.990552E+00_JPRB, 0.981490E+00_JPRB, 0.972051E+00_JPRB &
  &, 0.962261E+00_JPRB, 0.952105E+00_JPRB, 0.941607E+00_JPRB &
  &, 0.930769E+00_JPRB, 0.919611E+00_JPRB, 0.908142E+00_JPRB, 0.896389E+00_JPRB &
  &, 0.884331E+00_JPRB, 0.872012E+00_JPRB, 0.859439E+00_JPRB &
  &, 0.846610E+00_JPRB, 0.833549E+00_JPRB, 0.820284E+00_JPRB, 0.806802E+00_JPRB &
  &, 0.793146E+00_JPRB, 0.779292E+00_JPRB, 0.765330E+00_JPRB &
  &, 0.751190E+00_JPRB, 0.736922E+00_JPRB, 0.722562E+00_JPRB, 0.708084E+00_JPRB &
  &, 0.693540E+00_JPRB, 0.678919E+00_JPRB, 0.664260E+00_JPRB &
  &, 0.649550E+00_JPRB, 0.634830E+00_JPRB, 0.620083E+00_JPRB, 0.605369E+00_JPRB &
  &, 0.590654E+00_JPRB, 0.575997E+00_JPRB, 0.561381E+00_JPRB &
  &, 0.546825E+00_JPRB, 0.532350E+00_JPRB, 0.517954E+00_JPRB, 0.503657E+00_JPRB &
  &, 0.489477E+00_JPRB, 0.475432E+00_JPRB, 0.461517E+00_JPRB &
  &, 0.447748E+00_JPRB, 0.434140E+00_JPRB, 0.420685E+00_JPRB, 0.407420E+00_JPRB &
  &, 0.394334E+00_JPRB, 0.381438E+00_JPRB, 0.368744E+00_JPRB &
  &, 0.356260E+00_JPRB, 0.343998E+00_JPRB, 0.331963E+00_JPRB, 0.320136E+00_JPRB &
  &, 0.308548E+00_JPRB, 0.297207E+00_JPRB, 0.286083E+00_JPRB &
  &, 0.275242E+00_JPRB, 0.264620E+00_JPRB, 0.254250E+00_JPRB, 0.244161E+00_JPRB &
  &, 0.234320E+00_JPRB, 0.224719E+00_JPRB, 0.215354E+00_JPRB &
  &, 0.206287E+00_JPRB, 0.197475E+00_JPRB, 0.188908E+00_JPRB, 0.180612E+00_JPRB &
  &, 0.172537E+00_JPRB, 0.164744E+00_JPRB, 0.157220E+00_JPRB &
  &, 0.149909E+00_JPRB, 0.142871E+00_JPRB, 0.136049E+00_JPRB, 0.129502E+00_JPRB &
  &, 0.123169E+00_JPRB, 0.117067E+00_JPRB, 0.111216E+00_JPRB &
  &, 0.105590E+00_JPRB, 0.100161E+00_JPRB, 0.949460E-01_JPRB, 0.899603E-01_JPRB &
  &, 0.851731E-01_JPRB, 0.805992E-01_JPRB, 0.762047E-01_JPRB &
  &, 0.720025E-01_JPRB, 0.680062E-01_JPRB, 0.641781E-01_JPRB, 0.605299E-01_JPRB &
  &, 0.570734E-01_JPRB, 0.537673E-01_JPRB, 0.505670E-01_JPRB &
  &, 0.475909E-01_JPRB, 0.447397E-01_JPRB, 0.420217E-01_JPRB, 0.394452E-01_JPRB &
  &, 0.370187E-01_JPRB, 0.346918E-01_JPRB, 0.325307E-01_JPRB &
  &, 0.304229E-01_JPRB, 0.284956E-01_JPRB, 0.266332E-01_JPRB, 0.249033E-01_JPRB &
  &, 0.232487E-01_JPRB, 0.216738E-01_JPRB, 0.202490E-01_JPRB/)
XCW( 630, :) = (/ &
  &  0.103006E+01_JPRB, 0.103660E+01_JPRB, 0.104275E+01_JPRB, 0.104849E+01_JPRB &
  &, 0.105382E+01_JPRB, 0.105874E+01_JPRB, 0.106325E+01_JPRB &
  &, 0.106733E+01_JPRB, 0.107098E+01_JPRB, 0.107421E+01_JPRB, 0.107700E+01_JPRB &
  &, 0.107936E+01_JPRB, 0.108127E+01_JPRB, 0.108275E+01_JPRB &
  &, 0.108377E+01_JPRB, 0.108435E+01_JPRB, 0.108449E+01_JPRB, 0.108417E+01_JPRB &
  &, 0.108339E+01_JPRB, 0.108216E+01_JPRB, 0.108048E+01_JPRB &
  &, 0.107834E+01_JPRB, 0.107576E+01_JPRB, 0.107271E+01_JPRB, 0.106922E+01_JPRB &
  &, 0.106528E+01_JPRB, 0.106089E+01_JPRB, 0.105605E+01_JPRB &
  &, 0.105077E+01_JPRB, 0.104505E+01_JPRB, 0.103891E+01_JPRB, 0.103233E+01_JPRB &
  &, 0.102533E+01_JPRB, 0.101792E+01_JPRB, 0.101009E+01_JPRB &
  &, 0.100187E+01_JPRB, 0.993251E+00_JPRB, 0.984238E+00_JPRB, 0.974859E+00_JPRB &
  &, 0.965108E+00_JPRB, 0.955003E+00_JPRB, 0.944556E+00_JPRB &
  &, 0.933759E+00_JPRB, 0.922653E+00_JPRB, 0.911226E+00_JPRB, 0.899501E+00_JPRB &
  &, 0.887496E+00_JPRB, 0.875204E+00_JPRB, 0.862658E+00_JPRB &
  &, 0.849868E+00_JPRB, 0.836846E+00_JPRB, 0.823592E+00_JPRB, 0.810147E+00_JPRB &
  &, 0.796513E+00_JPRB, 0.782694E+00_JPRB, 0.768722E+00_JPRB &
  &, 0.754600E+00_JPRB, 0.740363E+00_JPRB, 0.726002E+00_JPRB, 0.711536E+00_JPRB &
  &, 0.696986E+00_JPRB, 0.682373E+00_JPRB, 0.667704E+00_JPRB &
  &, 0.652998E+00_JPRB, 0.638280E+00_JPRB, 0.623533E+00_JPRB, 0.608798E+00_JPRB &
  &, 0.594098E+00_JPRB, 0.579414E+00_JPRB, 0.564767E+00_JPRB &
  &, 0.550199E+00_JPRB, 0.535709E+00_JPRB, 0.521296E+00_JPRB, 0.506978E+00_JPRB &
  &, 0.492774E+00_JPRB, 0.478703E+00_JPRB, 0.464759E+00_JPRB &
  &, 0.450958E+00_JPRB, 0.437291E+00_JPRB, 0.423822E+00_JPRB, 0.410516E+00_JPRB &
  &, 0.397385E+00_JPRB, 0.384468E+00_JPRB, 0.371722E+00_JPRB &
  &, 0.359184E+00_JPRB, 0.346892E+00_JPRB, 0.334796E+00_JPRB, 0.322933E+00_JPRB &
  &, 0.311278E+00_JPRB, 0.299895E+00_JPRB, 0.288727E+00_JPRB &
  &, 0.277807E+00_JPRB, 0.267167E+00_JPRB, 0.256743E+00_JPRB, 0.246566E+00_JPRB &
  &, 0.236664E+00_JPRB, 0.227036E+00_JPRB, 0.217640E+00_JPRB &
  &, 0.208505E+00_JPRB, 0.199622E+00_JPRB, 0.191017E+00_JPRB, 0.182644E+00_JPRB &
  &, 0.174526E+00_JPRB, 0.166688E+00_JPRB, 0.159078E+00_JPRB &
  &, 0.151716E+00_JPRB, 0.144627E+00_JPRB, 0.137750E+00_JPRB, 0.131146E+00_JPRB &
  &, 0.124753E+00_JPRB, 0.118633E+00_JPRB, 0.112718E+00_JPRB &
  &, 0.107026E+00_JPRB, 0.101528E+00_JPRB, 0.962877E-01_JPRB, 0.912755E-01_JPRB &
  &, 0.864129E-01_JPRB, 0.818093E-01_JPRB, 0.773837E-01_JPRB &
  &, 0.731492E-01_JPRB, 0.690687E-01_JPRB, 0.652048E-01_JPRB, 0.615195E-01_JPRB &
  &, 0.579717E-01_JPRB, 0.546248E-01_JPRB, 0.514368E-01_JPRB &
  &, 0.484179E-01_JPRB, 0.455225E-01_JPRB, 0.427587E-01_JPRB, 0.401350E-01_JPRB &
  &, 0.376598E-01_JPRB, 0.353417E-01_JPRB, 0.331296E-01_JPRB &
  &, 0.310299E-01_JPRB, 0.290493E-01_JPRB, 0.271320E-01_JPRB, 0.254087E-01_JPRB &
  &, 0.236968E-01_JPRB, 0.221279E-01_JPRB, 0.206433E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART90',1,ZHOOK_HANDLE)
END SUBROUTINE PART90

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART91

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART91',0,ZHOOK_HANDLE)

XCW( 631, :) = (/ &
  &  0.103033E+01_JPRB, 0.103694E+01_JPRB, 0.104316E+01_JPRB, 0.104897E+01_JPRB &
  &, 0.105437E+01_JPRB, 0.105936E+01_JPRB, 0.106394E+01_JPRB &
  &, 0.106809E+01_JPRB, 0.107182E+01_JPRB, 0.107512E+01_JPRB, 0.107798E+01_JPRB &
  &, 0.108041E+01_JPRB, 0.108240E+01_JPRB, 0.108394E+01_JPRB &
  &, 0.108504E+01_JPRB, 0.108569E+01_JPRB, 0.108589E+01_JPRB, 0.108564E+01_JPRB &
  &, 0.108494E+01_JPRB, 0.108379E+01_JPRB, 0.108217E+01_JPRB &
  &, 0.108011E+01_JPRB, 0.107759E+01_JPRB, 0.107462E+01_JPRB, 0.107119E+01_JPRB &
  &, 0.106731E+01_JPRB, 0.106299E+01_JPRB, 0.105821E+01_JPRB &
  &, 0.105300E+01_JPRB, 0.104735E+01_JPRB, 0.104127E+01_JPRB, 0.103475E+01_JPRB &
  &, 0.102781E+01_JPRB, 0.102045E+01_JPRB, 0.101269E+01_JPRB &
  &, 0.100452E+01_JPRB, 0.995950E+00_JPRB, 0.987005E+00_JPRB, 0.977676E+00_JPRB &
  &, 0.967976E+00_JPRB, 0.957912E+00_JPRB, 0.947506E+00_JPRB &
  &, 0.936772E+00_JPRB, 0.925695E+00_JPRB, 0.914320E+00_JPRB, 0.902626E+00_JPRB &
  &, 0.890661E+00_JPRB, 0.878409E+00_JPRB, 0.865891E+00_JPRB &
  &, 0.853140E+00_JPRB, 0.840144E+00_JPRB, 0.826914E+00_JPRB, 0.813492E+00_JPRB &
  &, 0.799880E+00_JPRB, 0.786082E+00_JPRB, 0.772129E+00_JPRB &
  &, 0.758024E+00_JPRB, 0.743805E+00_JPRB, 0.729442E+00_JPRB, 0.715005E+00_JPRB &
  &, 0.700466E+00_JPRB, 0.685845E+00_JPRB, 0.671183E+00_JPRB &
  &, 0.656482E+00_JPRB, 0.641748E+00_JPRB, 0.627002E+00_JPRB, 0.612266E+00_JPRB &
  &, 0.597542E+00_JPRB, 0.582851E+00_JPRB, 0.568195E+00_JPRB &
  &, 0.553615E+00_JPRB, 0.539089E+00_JPRB, 0.524659E+00_JPRB, 0.510321E+00_JPRB &
  &, 0.496095E+00_JPRB, 0.481975E+00_JPRB, 0.468002E+00_JPRB &
  &, 0.454168E+00_JPRB, 0.440491E+00_JPRB, 0.426984E+00_JPRB, 0.413637E+00_JPRB &
  &, 0.400462E+00_JPRB, 0.387497E+00_JPRB, 0.374728E+00_JPRB &
  &, 0.362136E+00_JPRB, 0.349786E+00_JPRB, 0.337658E+00_JPRB, 0.325731E+00_JPRB &
  &, 0.314037E+00_JPRB, 0.302613E+00_JPRB, 0.291402E+00_JPRB &
  &, 0.280435E+00_JPRB, 0.269713E+00_JPRB, 0.259237E+00_JPRB, 0.249036E+00_JPRB &
  &, 0.239077E+00_JPRB, 0.229352E+00_JPRB, 0.219926E+00_JPRB &
  &, 0.210723E+00_JPRB, 0.201805E+00_JPRB, 0.193126E+00_JPRB, 0.184713E+00_JPRB &
  &, 0.176553E+00_JPRB, 0.168633E+00_JPRB, 0.160975E+00_JPRB &
  &, 0.153565E+00_JPRB, 0.146423E+00_JPRB, 0.139492E+00_JPRB, 0.132832E+00_JPRB &
  &, 0.126381E+00_JPRB, 0.120199E+00_JPRB, 0.114220E+00_JPRB &
  &, 0.108462E+00_JPRB, 0.102941E+00_JPRB, 0.976294E-01_JPRB, 0.925437E-01_JPRB &
  &, 0.877003E-01_JPRB, 0.830193E-01_JPRB, 0.785136E-01_JPRB &
  &, 0.742460E-01_JPRB, 0.701311E-01_JPRB, 0.662315E-01_JPRB, 0.625090E-01_JPRB &
  &, 0.589227E-01_JPRB, 0.555360E-01_JPRB, 0.523066E-01_JPRB &
  &, 0.492449E-01_JPRB, 0.463052E-01_JPRB, 0.434958E-01_JPRB, 0.408823E-01_JPRB &
  &, 0.383592E-01_JPRB, 0.359916E-01_JPRB, 0.337285E-01_JPRB &
  &, 0.316370E-01_JPRB, 0.296030E-01_JPRB, 0.276931E-01_JPRB, 0.259142E-01_JPRB &
  &, 0.242089E-01_JPRB, 0.225819E-01_JPRB, 0.211033E-01_JPRB/)
XCW( 632, :) = (/ &
  &  0.103060E+01_JPRB, 0.103728E+01_JPRB, 0.104357E+01_JPRB, 0.104945E+01_JPRB &
  &, 0.105492E+01_JPRB, 0.105999E+01_JPRB, 0.106463E+01_JPRB &
  &, 0.106886E+01_JPRB, 0.107266E+01_JPRB, 0.107602E+01_JPRB, 0.107896E+01_JPRB &
  &, 0.108146E+01_JPRB, 0.108352E+01_JPRB, 0.108514E+01_JPRB &
  &, 0.108631E+01_JPRB, 0.108703E+01_JPRB, 0.108731E+01_JPRB, 0.108713E+01_JPRB &
  &, 0.108650E+01_JPRB, 0.108541E+01_JPRB, 0.108387E+01_JPRB &
  &, 0.108187E+01_JPRB, 0.107942E+01_JPRB, 0.107652E+01_JPRB, 0.107316E+01_JPRB &
  &, 0.106935E+01_JPRB, 0.106509E+01_JPRB, 0.106039E+01_JPRB &
  &, 0.105524E+01_JPRB, 0.104965E+01_JPRB, 0.104363E+01_JPRB, 0.103717E+01_JPRB &
  &, 0.103030E+01_JPRB, 0.102300E+01_JPRB, 0.101529E+01_JPRB &
  &, 0.100717E+01_JPRB, 0.998668E+00_JPRB, 0.989772E+00_JPRB, 0.980493E+00_JPRB &
  &, 0.970844E+00_JPRB, 0.960831E+00_JPRB, 0.950477E+00_JPRB &
  &, 0.939784E+00_JPRB, 0.928760E+00_JPRB, 0.917415E+00_JPRB, 0.905773E+00_JPRB &
  &, 0.893838E+00_JPRB, 0.881627E+00_JPRB, 0.869149E+00_JPRB &
  &, 0.856412E+00_JPRB, 0.843441E+00_JPRB, 0.830263E+00_JPRB, 0.816865E+00_JPRB &
  &, 0.803262E+00_JPRB, 0.789499E+00_JPRB, 0.775566E+00_JPRB &
  &, 0.761480E+00_JPRB, 0.747262E+00_JPRB, 0.732914E+00_JPRB, 0.718473E+00_JPRB &
  &, 0.703946E+00_JPRB, 0.689335E+00_JPRB, 0.674679E+00_JPRB &
  &, 0.659966E+00_JPRB, 0.645235E+00_JPRB, 0.630490E+00_JPRB, 0.615733E+00_JPRB &
  &, 0.601005E+00_JPRB, 0.586288E+00_JPRB, 0.571644E+00_JPRB &
  &, 0.557031E+00_JPRB, 0.542491E+00_JPRB, 0.528044E+00_JPRB, 0.513687E+00_JPRB &
  &, 0.499415E+00_JPRB, 0.485293E+00_JPRB, 0.471292E+00_JPRB &
  &, 0.457403E+00_JPRB, 0.443691E+00_JPRB, 0.430147E+00_JPRB, 0.416759E+00_JPRB &
  &, 0.403566E+00_JPRB, 0.390554E+00_JPRB, 0.377734E+00_JPRB &
  &, 0.365116E+00_JPRB, 0.352709E+00_JPRB, 0.340520E+00_JPRB, 0.328558E+00_JPRB &
  &, 0.316827E+00_JPRB, 0.305332E+00_JPRB, 0.294077E+00_JPRB &
  &, 0.283063E+00_JPRB, 0.272292E+00_JPRB, 0.261763E+00_JPRB, 0.251507E+00_JPRB &
  &, 0.241489E+00_JPRB, 0.231737E+00_JPRB, 0.222212E+00_JPRB &
  &, 0.212977E+00_JPRB, 0.203988E+00_JPRB, 0.195235E+00_JPRB, 0.186783E+00_JPRB &
  &, 0.178543E+00_JPRB, 0.170577E+00_JPRB, 0.162873E+00_JPRB &
  &, 0.155413E+00_JPRB, 0.148220E+00_JPRB, 0.141235E+00_JPRB, 0.134518E+00_JPRB &
  &, 0.128008E+00_JPRB, 0.121765E+00_JPRB, 0.115722E+00_JPRB &
  &, 0.109942E+00_JPRB, 0.104353E+00_JPRB, 0.990174E-01_JPRB, 0.939059E-01_JPRB &
  &, 0.889401E-01_JPRB, 0.842294E-01_JPRB, 0.796926E-01_JPRB &
  &, 0.753927E-01_JPRB, 0.712441E-01_JPRB, 0.672582E-01_JPRB, 0.634986E-01_JPRB &
  &, 0.598738E-01_JPRB, 0.564471E-01_JPRB, 0.531764E-01_JPRB &
  &, 0.500719E-01_JPRB, 0.470880E-01_JPRB, 0.442895E-01_JPRB, 0.415721E-01_JPRB &
  &, 0.390585E-01_JPRB, 0.366415E-01_JPRB, 0.343873E-01_JPRB &
  &, 0.321833E-01_JPRB, 0.301567E-01_JPRB, 0.282543E-01_JPRB, 0.264196E-01_JPRB &
  &, 0.246571E-01_JPRB, 0.230359E-01_JPRB, 0.214975E-01_JPRB/)
XCW( 633, :) = (/ &
  &  0.103087E+01_JPRB, 0.103762E+01_JPRB, 0.104398E+01_JPRB, 0.104993E+01_JPRB &
  &, 0.105548E+01_JPRB, 0.106061E+01_JPRB, 0.106533E+01_JPRB &
  &, 0.106962E+01_JPRB, 0.107349E+01_JPRB, 0.107693E+01_JPRB, 0.107994E+01_JPRB &
  &, 0.108252E+01_JPRB, 0.108465E+01_JPRB, 0.108634E+01_JPRB &
  &, 0.108754E+01_JPRB, 0.108838E+01_JPRB, 0.108872E+01_JPRB, 0.108861E+01_JPRB &
  &, 0.108805E+01_JPRB, 0.108704E+01_JPRB, 0.108557E+01_JPRB &
  &, 0.108364E+01_JPRB, 0.108126E+01_JPRB, 0.107842E+01_JPRB, 0.107513E+01_JPRB &
  &, 0.107139E+01_JPRB, 0.106720E+01_JPRB, 0.106256E+01_JPRB &
  &, 0.105748E+01_JPRB, 0.105195E+01_JPRB, 0.104599E+01_JPRB, 0.103960E+01_JPRB &
  &, 0.103279E+01_JPRB, 0.102555E+01_JPRB, 0.101790E+01_JPRB &
  &, 0.100984E+01_JPRB, 0.100139E+01_JPRB, 0.992549E+00_JPRB, 0.983320E+00_JPRB &
  &, 0.973722E+00_JPRB, 0.963761E+00_JPRB, 0.953458E+00_JPRB &
  &, 0.942807E+00_JPRB, 0.931825E+00_JPRB, 0.920522E+00_JPRB, 0.908921E+00_JPRB &
  &, 0.897027E+00_JPRB, 0.884845E+00_JPRB, 0.872407E+00_JPRB &
  &, 0.859710E+00_JPRB, 0.846765E+00_JPRB, 0.833612E+00_JPRB, 0.820238E+00_JPRB &
  &, 0.806672E+00_JPRB, 0.792917E+00_JPRB, 0.779003E+00_JPRB &
  &, 0.764936E+00_JPRB, 0.750719E+00_JPRB, 0.736402E+00_JPRB, 0.721959E+00_JPRB &
  &, 0.707443E+00_JPRB, 0.692841E+00_JPRB, 0.678176E+00_JPRB &
  &, 0.663469E+00_JPRB, 0.648741E+00_JPRB, 0.633978E+00_JPRB, 0.619220E+00_JPRB &
  &, 0.604488E+00_JPRB, 0.589766E+00_JPRB, 0.575092E+00_JPRB &
  &, 0.560469E+00_JPRB, 0.545915E+00_JPRB, 0.531429E+00_JPRB, 0.517053E+00_JPRB &
  &, 0.502782E+00_JPRB, 0.488611E+00_JPRB, 0.474582E+00_JPRB &
  &, 0.460687E+00_JPRB, 0.446941E+00_JPRB, 0.433334E+00_JPRB, 0.419932E+00_JPRB &
  &, 0.406695E+00_JPRB, 0.393637E+00_JPRB, 0.380767E+00_JPRB &
  &, 0.368123E+00_JPRB, 0.355660E+00_JPRB, 0.343440E+00_JPRB, 0.331414E+00_JPRB &
  &, 0.319646E+00_JPRB, 0.308081E+00_JPRB, 0.296782E+00_JPRB &
  &, 0.285723E+00_JPRB, 0.274903E+00_JPRB, 0.264322E+00_JPRB, 0.253978E+00_JPRB &
  &, 0.243935E+00_JPRB, 0.234088E+00_JPRB, 0.224533E+00_JPRB &
  &, 0.215231E+00_JPRB, 0.206207E+00_JPRB, 0.197419E+00_JPRB, 0.188890E+00_JPRB &
  &, 0.180608E+00_JPRB, 0.172561E+00_JPRB, 0.164810E+00_JPRB &
  &, 0.157301E+00_JPRB, 0.150016E+00_JPRB, 0.142977E+00_JPRB, 0.136204E+00_JPRB &
  &, 0.129678E+00_JPRB, 0.123374E+00_JPRB, 0.117269E+00_JPRB &
  &, 0.111423E+00_JPRB, 0.105811E+00_JPRB, 0.100405E+00_JPRB, 0.952211E-01_JPRB &
  &, 0.902276E-01_JPRB, 0.854878E-01_JPRB, 0.808716E-01_JPRB &
  &, 0.765394E-01_JPRB, 0.723066E-01_JPRB, 0.683362E-01_JPRB, 0.644882E-01_JPRB &
  &, 0.608777E-01_JPRB, 0.573582E-01_JPRB, 0.540462E-01_JPRB &
  &, 0.508989E-01_JPRB, 0.479267E-01_JPRB, 0.450266E-01_JPRB, 0.423195E-01_JPRB &
  &, 0.397579E-01_JPRB, 0.372914E-01_JPRB, 0.349862E-01_JPRB &
  &, 0.327903E-01_JPRB, 0.307104E-01_JPRB, 0.287531E-01_JPRB, 0.269251E-01_JPRB &
  &, 0.251692E-01_JPRB, 0.234900E-01_JPRB, 0.219575E-01_JPRB/)
XCW( 634, :) = (/ &
  &  0.103114E+01_JPRB, 0.103796E+01_JPRB, 0.104439E+01_JPRB, 0.105041E+01_JPRB &
  &, 0.105603E+01_JPRB, 0.106123E+01_JPRB, 0.106602E+01_JPRB &
  &, 0.107039E+01_JPRB, 0.107433E+01_JPRB, 0.107785E+01_JPRB, 0.108093E+01_JPRB &
  &, 0.108357E+01_JPRB, 0.108578E+01_JPRB, 0.108754E+01_JPRB &
  &, 0.108885E+01_JPRB, 0.108972E+01_JPRB, 0.109014E+01_JPRB, 0.109010E+01_JPRB &
  &, 0.108961E+01_JPRB, 0.108867E+01_JPRB, 0.108727E+01_JPRB &
  &, 0.108541E+01_JPRB, 0.108310E+01_JPRB, 0.108033E+01_JPRB, 0.107711E+01_JPRB &
  &, 0.107344E+01_JPRB, 0.106931E+01_JPRB, 0.106474E+01_JPRB &
  &, 0.105972E+01_JPRB, 0.105426E+01_JPRB, 0.104837E+01_JPRB, 0.104204E+01_JPRB &
  &, 0.103528E+01_JPRB, 0.102811E+01_JPRB, 0.102052E+01_JPRB &
  &, 0.101251E+01_JPRB, 0.100411E+01_JPRB, 0.995326E+00_JPRB, 0.986157E+00_JPRB &
  &, 0.976610E+00_JPRB, 0.966701E+00_JPRB, 0.956440E+00_JPRB &
  &, 0.945831E+00_JPRB, 0.934902E+00_JPRB, 0.923640E+00_JPRB, 0.912081E+00_JPRB &
  &, 0.900216E+00_JPRB, 0.888087E+00_JPRB, 0.875678E+00_JPRB &
  &, 0.863008E+00_JPRB, 0.850103E+00_JPRB, 0.836962E+00_JPRB, 0.823626E+00_JPRB &
  &, 0.810083E+00_JPRB, 0.796349E+00_JPRB, 0.782456E+00_JPRB &
  &, 0.768392E+00_JPRB, 0.754207E+00_JPRB, 0.739890E+00_JPRB, 0.725477E+00_JPRB &
  &, 0.710957E+00_JPRB, 0.696365E+00_JPRB, 0.681709E+00_JPRB &
  &, 0.666935E+00_JPRB, 0.652266E+00_JPRB, 0.637504E+00_JPRB, 0.622746E+00_JPRB &
  &, 0.607992E+00_JPRB, 0.593263E+00_JPRB, 0.578562E+00_JPRB &
  &, 0.563927E+00_JPRB, 0.549360E+00_JPRB, 0.534859E+00_JPRB, 0.520441E+00_JPRB &
  &, 0.506148E+00_JPRB, 0.491953E+00_JPRB, 0.477896E+00_JPRB &
  &, 0.463970E+00_JPRB, 0.450191E+00_JPRB, 0.436547E+00_JPRB, 0.423105E+00_JPRB &
  &, 0.409825E+00_JPRB, 0.396720E+00_JPRB, 0.383827E+00_JPRB &
  &, 0.371131E+00_JPRB, 0.358639E+00_JPRB, 0.346360E+00_JPRB, 0.334300E+00_JPRB &
  &, 0.322465E+00_JPRB, 0.310860E+00_JPRB, 0.299519E+00_JPRB &
  &, 0.288383E+00_JPRB, 0.277514E+00_JPRB, 0.266881E+00_JPRB, 0.256516E+00_JPRB &
  &, 0.246382E+00_JPRB, 0.236508E+00_JPRB, 0.226890E+00_JPRB &
  &, 0.217520E+00_JPRB, 0.208427E+00_JPRB, 0.199602E+00_JPRB, 0.190997E+00_JPRB &
  &, 0.182674E+00_JPRB, 0.174583E+00_JPRB, 0.166747E+00_JPRB &
  &, 0.159189E+00_JPRB, 0.151854E+00_JPRB, 0.144761E+00_JPRB, 0.137933E+00_JPRB &
  &, 0.131348E+00_JPRB, 0.124984E+00_JPRB, 0.118859E+00_JPRB &
  &, 0.112949E+00_JPRB, 0.107269E+00_JPRB, 0.101840E+00_JPRB, 0.965833E-01_JPRB &
  &, 0.915627E-01_JPRB, 0.867463E-01_JPRB, 0.820998E-01_JPRB &
  &, 0.776861E-01_JPRB, 0.734702E-01_JPRB, 0.694142E-01_JPRB, 0.655298E-01_JPRB &
  &, 0.618287E-01_JPRB, 0.583230E-01_JPRB, 0.549704E-01_JPRB &
  &, 0.517811E-01_JPRB, 0.487095E-01_JPRB, 0.458203E-01_JPRB, 0.430668E-01_JPRB &
  &, 0.404573E-01_JPRB, 0.380004E-01_JPRB, 0.356450E-01_JPRB &
  &, 0.333974E-01_JPRB, 0.313257E-01_JPRB, 0.293142E-01_JPRB, 0.274305E-01_JPRB &
  &, 0.256814E-01_JPRB, 0.240089E-01_JPRB, 0.224175E-01_JPRB/)
XCW( 635, :) = (/ &
  &  0.103141E+01_JPRB, 0.103830E+01_JPRB, 0.104480E+01_JPRB, 0.105089E+01_JPRB &
  &, 0.105658E+01_JPRB, 0.106186E+01_JPRB, 0.106672E+01_JPRB &
  &, 0.107116E+01_JPRB, 0.107517E+01_JPRB, 0.107876E+01_JPRB, 0.108191E+01_JPRB &
  &, 0.108463E+01_JPRB, 0.108690E+01_JPRB, 0.108874E+01_JPRB &
  &, 0.109013E+01_JPRB, 0.109107E+01_JPRB, 0.109156E+01_JPRB, 0.109159E+01_JPRB &
  &, 0.109118E+01_JPRB, 0.109030E+01_JPRB, 0.108897E+01_JPRB &
  &, 0.108719E+01_JPRB, 0.108495E+01_JPRB, 0.108225E+01_JPRB, 0.107910E+01_JPRB &
  &, 0.107549E+01_JPRB, 0.107143E+01_JPRB, 0.106693E+01_JPRB &
  &, 0.106197E+01_JPRB, 0.105658E+01_JPRB, 0.105074E+01_JPRB, 0.104448E+01_JPRB &
  &, 0.103778E+01_JPRB, 0.103067E+01_JPRB, 0.102314E+01_JPRB &
  &, 0.101519E+01_JPRB, 0.100685E+01_JPRB, 0.998123E+00_JPRB, 0.988924E+00_JPRB &
  &, 0.979509E+00_JPRB, 0.969651E+00_JPRB, 0.959432E+00_JPRB &
  &, 0.948876E+00_JPRB, 0.937989E+00_JPRB, 0.926770E+00_JPRB, 0.915253E+00_JPRB &
  &, 0.903430E+00_JPRB, 0.891330E+00_JPRB, 0.878948E+00_JPRB &
  &, 0.866319E+00_JPRB, 0.853441E+00_JPRB, 0.840339E+00_JPRB, 0.827027E+00_JPRB &
  &, 0.813508E+00_JPRB, 0.799796E+00_JPRB, 0.785923E+00_JPRB &
  &, 0.771879E+00_JPRB, 0.757712E+00_JPRB, 0.743411E+00_JPRB, 0.728996E+00_JPRB &
  &, 0.714487E+00_JPRB, 0.699889E+00_JPRB, 0.685241E+00_JPRB &
  &, 0.670546E+00_JPRB, 0.655790E+00_JPRB, 0.641030E+00_JPRB, 0.626271E+00_JPRB &
  &, 0.611495E+00_JPRB, 0.596761E+00_JPRB, 0.582052E+00_JPRB &
  &, 0.567407E+00_JPRB, 0.552805E+00_JPRB, 0.538288E+00_JPRB, 0.523874E+00_JPRB &
  &, 0.509537E+00_JPRB, 0.495318E+00_JPRB, 0.481234E+00_JPRB &
  &, 0.467254E+00_JPRB, 0.453440E+00_JPRB, 0.439786E+00_JPRB, 0.426303E+00_JPRB &
  &, 0.412981E+00_JPRB, 0.399857E+00_JPRB, 0.386915E+00_JPRB &
  &, 0.374166E+00_JPRB, 0.361618E+00_JPRB, 0.349308E+00_JPRB, 0.337186E+00_JPRB &
  &, 0.325315E+00_JPRB, 0.313670E+00_JPRB, 0.302256E+00_JPRB &
  &, 0.291074E+00_JPRB, 0.280157E+00_JPRB, 0.269473E+00_JPRB, 0.258987E+00_JPRB &
  &, 0.248862E+00_JPRB, 0.238928E+00_JPRB, 0.229246E+00_JPRB &
  &, 0.219846E+00_JPRB, 0.210683E+00_JPRB, 0.201785E+00_JPRB, 0.193141E+00_JPRB &
  &, 0.184740E+00_JPRB, 0.176605E+00_JPRB, 0.168723E+00_JPRB &
  &, 0.161078E+00_JPRB, 0.153732E+00_JPRB, 0.146586E+00_JPRB, 0.139703E+00_JPRB &
  &, 0.133018E+00_JPRB, 0.126593E+00_JPRB, 0.120450E+00_JPRB &
  &, 0.114474E+00_JPRB, 0.108728E+00_JPRB, 0.103227E+00_JPRB, 0.979454E-01_JPRB &
  &, 0.928502E-01_JPRB, 0.880047E-01_JPRB, 0.833279E-01_JPRB &
  &, 0.788328E-01_JPRB, 0.745832E-01_JPRB, 0.704923E-01_JPRB, 0.665715E-01_JPRB &
  &, 0.628326E-01_JPRB, 0.592877E-01_JPRB, 0.558946E-01_JPRB &
  &, 0.526632E-01_JPRB, 0.495481E-01_JPRB, 0.466141E-01_JPRB, 0.438716E-01_JPRB &
  &, 0.412150E-01_JPRB, 0.387094E-01_JPRB, 0.363038E-01_JPRB &
  &, 0.340651E-01_JPRB, 0.319409E-01_JPRB, 0.298754E-01_JPRB, 0.279991E-01_JPRB &
  &, 0.261935E-01_JPRB, 0.244629E-01_JPRB, 0.228775E-01_JPRB/)
XCW( 636, :) = (/ &
  &  0.103168E+01_JPRB, 0.103864E+01_JPRB, 0.104521E+01_JPRB, 0.105137E+01_JPRB &
  &, 0.105713E+01_JPRB, 0.106248E+01_JPRB, 0.106741E+01_JPRB &
  &, 0.107192E+01_JPRB, 0.107601E+01_JPRB, 0.107967E+01_JPRB, 0.108290E+01_JPRB &
  &, 0.108569E+01_JPRB, 0.108803E+01_JPRB, 0.108994E+01_JPRB &
  &, 0.109140E+01_JPRB, 0.109242E+01_JPRB, 0.109298E+01_JPRB, 0.109309E+01_JPRB &
  &, 0.109274E+01_JPRB, 0.109194E+01_JPRB, 0.109068E+01_JPRB &
  &, 0.108897E+01_JPRB, 0.108680E+01_JPRB, 0.108417E+01_JPRB, 0.108109E+01_JPRB &
  &, 0.107755E+01_JPRB, 0.107356E+01_JPRB, 0.106912E+01_JPRB &
  &, 0.106423E+01_JPRB, 0.105890E+01_JPRB, 0.105313E+01_JPRB, 0.104693E+01_JPRB &
  &, 0.104030E+01_JPRB, 0.103324E+01_JPRB, 0.102576E+01_JPRB &
  &, 0.101788E+01_JPRB, 0.100960E+01_JPRB, 0.100092E+01_JPRB, 0.991852E+00_JPRB &
  &, 0.982407E+00_JPRB, 0.972602E+00_JPRB, 0.962436E+00_JPRB &
  &, 0.951922E+00_JPRB, 0.941077E+00_JPRB, 0.929911E+00_JPRB, 0.918425E+00_JPRB &
  &, 0.906655E+00_JPRB, 0.894585E+00_JPRB, 0.882245E+00_JPRB &
  &, 0.869644E+00_JPRB, 0.856805E+00_JPRB, 0.843730E+00_JPRB, 0.830443E+00_JPRB &
  &, 0.816947E+00_JPRB, 0.803258E+00_JPRB, 0.789391E+00_JPRB &
  &, 0.775381E+00_JPRB, 0.761216E+00_JPRB, 0.746932E+00_JPRB, 0.732531E+00_JPRB &
  &, 0.718035E+00_JPRB, 0.703448E+00_JPRB, 0.688791E+00_JPRB &
  &, 0.674085E+00_JPRB, 0.659351E+00_JPRB, 0.644575E+00_JPRB, 0.629816E+00_JPRB &
  &, 0.615037E+00_JPRB, 0.600279E+00_JPRB, 0.585562E+00_JPRB &
  &, 0.570907E+00_JPRB, 0.556294E+00_JPRB, 0.541761E+00_JPRB, 0.527307E+00_JPRB &
  &, 0.512949E+00_JPRB, 0.498706E+00_JPRB, 0.484572E+00_JPRB &
  &, 0.470586E+00_JPRB, 0.456740E+00_JPRB, 0.443049E+00_JPRB, 0.429528E+00_JPRB &
  &, 0.416163E+00_JPRB, 0.402994E+00_JPRB, 0.390003E+00_JPRB &
  &, 0.377229E+00_JPRB, 0.364626E+00_JPRB, 0.352257E+00_JPRB, 0.340101E+00_JPRB &
  &, 0.328194E+00_JPRB, 0.316480E+00_JPRB, 0.305024E+00_JPRB &
  &, 0.293797E+00_JPRB, 0.282800E+00_JPRB, 0.272065E+00_JPRB, 0.261591E+00_JPRB &
  &, 0.251342E+00_JPRB, 0.241383E+00_JPRB, 0.231638E+00_JPRB &
  &, 0.222171E+00_JPRB, 0.212975E+00_JPRB, 0.204005E+00_JPRB, 0.195286E+00_JPRB &
  &, 0.186844E+00_JPRB, 0.178666E+00_JPRB, 0.170700E+00_JPRB &
  &, 0.163046E+00_JPRB, 0.155610E+00_JPRB, 0.148412E+00_JPRB, 0.141431E+00_JPRB &
  &, 0.134731E+00_JPRB, 0.128246E+00_JPRB, 0.122040E+00_JPRB &
  &, 0.116045E+00_JPRB, 0.110231E+00_JPRB, 0.104662E+00_JPRB, 0.993546E-01_JPRB &
  &, 0.942330E-01_JPRB, 0.893116E-01_JPRB, 0.845561E-01_JPRB &
  &, 0.800293E-01_JPRB, 0.757468E-01_JPRB, 0.715703E-01_JPRB, 0.676131E-01_JPRB &
  &, 0.638365E-01_JPRB, 0.602525E-01_JPRB, 0.568187E-01_JPRB &
  &, 0.535454E-01_JPRB, 0.503868E-01_JPRB, 0.474645E-01_JPRB, 0.446189E-01_JPRB &
  &, 0.419143E-01_JPRB, 0.394184E-01_JPRB, 0.369626E-01_JPRB &
  &, 0.346722E-01_JPRB, 0.324946E-01_JPRB, 0.304989E-01_JPRB, 0.285046E-01_JPRB &
  &, 0.267057E-01_JPRB, 0.249818E-01_JPRB, 0.233375E-01_JPRB/)
XCW( 637, :) = (/ &
  &  0.103195E+01_JPRB, 0.103899E+01_JPRB, 0.104562E+01_JPRB, 0.105186E+01_JPRB &
  &, 0.105769E+01_JPRB, 0.106311E+01_JPRB, 0.106811E+01_JPRB &
  &, 0.107269E+01_JPRB, 0.107685E+01_JPRB, 0.108058E+01_JPRB, 0.108388E+01_JPRB &
  &, 0.108675E+01_JPRB, 0.108917E+01_JPRB, 0.109115E+01_JPRB &
  &, 0.109268E+01_JPRB, 0.109377E+01_JPRB, 0.109440E+01_JPRB, 0.109458E+01_JPRB &
  &, 0.109431E+01_JPRB, 0.109358E+01_JPRB, 0.109239E+01_JPRB &
  &, 0.109075E+01_JPRB, 0.108865E+01_JPRB, 0.108609E+01_JPRB, 0.108308E+01_JPRB &
  &, 0.107961E+01_JPRB, 0.107569E+01_JPRB, 0.107131E+01_JPRB &
  &, 0.106649E+01_JPRB, 0.106123E+01_JPRB, 0.105552E+01_JPRB, 0.104938E+01_JPRB &
  &, 0.104281E+01_JPRB, 0.103581E+01_JPRB, 0.102840E+01_JPRB &
  &, 0.102058E+01_JPRB, 0.101234E+01_JPRB, 0.100373E+01_JPRB, 0.994709E+00_JPRB &
  &, 0.985327E+00_JPRB, 0.975563E+00_JPRB, 0.965450E+00_JPRB &
  &, 0.954989E+00_JPRB, 0.944187E+00_JPRB, 0.933064E+00_JPRB, 0.921620E+00_JPRB &
  &, 0.909881E+00_JPRB, 0.897853E+00_JPRB, 0.885554E+00_JPRB &
  &, 0.872981E+00_JPRB, 0.860170E+00_JPRB, 0.847134E+00_JPRB, 0.833859E+00_JPRB &
  &, 0.820387E+00_JPRB, 0.806734E+00_JPRB, 0.792889E+00_JPRB &
  &, 0.778899E+00_JPRB, 0.764753E+00_JPRB, 0.750468E+00_JPRB, 0.736083E+00_JPRB &
  &, 0.721600E+00_JPRB, 0.707007E+00_JPRB, 0.692376E+00_JPRB &
  &, 0.677659E+00_JPRB, 0.662913E+00_JPRB, 0.648158E+00_JPRB, 0.633361E+00_JPRB &
  &, 0.618600E+00_JPRB, 0.603837E+00_JPRB, 0.589093E+00_JPRB &
  &, 0.574408E+00_JPRB, 0.559782E+00_JPRB, 0.545234E+00_JPRB, 0.530762E+00_JPRB &
  &, 0.516384E+00_JPRB, 0.502095E+00_JPRB, 0.487957E+00_JPRB &
  &, 0.473942E+00_JPRB, 0.460064E+00_JPRB, 0.446338E+00_JPRB, 0.432753E+00_JPRB &
  &, 0.419372E+00_JPRB, 0.406157E+00_JPRB, 0.393118E+00_JPRB &
  &, 0.380293E+00_JPRB, 0.367662E+00_JPRB, 0.355263E+00_JPRB, 0.343046E+00_JPRB &
  &, 0.331073E+00_JPRB, 0.319321E+00_JPRB, 0.307823E+00_JPRB &
  &, 0.296521E+00_JPRB, 0.285508E+00_JPRB, 0.274723E+00_JPRB, 0.264162E+00_JPRB &
  &, 0.253891E+00_JPRB, 0.243837E+00_JPRB, 0.234064E+00_JPRB &
  &, 0.224532E+00_JPRB, 0.215267E+00_JPRB, 0.206225E+00_JPRB, 0.197468E+00_JPRB &
  &, 0.188986E+00_JPRB, 0.180727E+00_JPRB, 0.172716E+00_JPRB &
  &, 0.164975E+00_JPRB, 0.157488E+00_JPRB, 0.150237E+00_JPRB, 0.143244E+00_JPRB &
  &, 0.136487E+00_JPRB, 0.129943E+00_JPRB, 0.123631E+00_JPRB &
  &, 0.117570E+00_JPRB, 0.111735E+00_JPRB, 0.106142E+00_JPRB, 0.100764E+00_JPRB &
  &, 0.955682E-01_JPRB, 0.906184E-01_JPRB, 0.858334E-01_JPRB &
  &, 0.812758E-01_JPRB, 0.769105E-01_JPRB, 0.726996E-01_JPRB, 0.687069E-01_JPRB &
  &, 0.648933E-01_JPRB, 0.612172E-01_JPRB, 0.577429E-01_JPRB &
  &, 0.544275E-01_JPRB, 0.512814E-01_JPRB, 0.482582E-01_JPRB, 0.454237E-01_JPRB &
  &, 0.426720E-01_JPRB, 0.401274E-01_JPRB, 0.376813E-01_JPRB &
  &, 0.353399E-01_JPRB, 0.331099E-01_JPRB, 0.310600E-01_JPRB, 0.290732E-01_JPRB &
  &, 0.272178E-01_JPRB, 0.254358E-01_JPRB, 0.237974E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART91',1,ZHOOK_HANDLE)
END SUBROUTINE PART91

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART92

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART92',0,ZHOOK_HANDLE)

XCW( 638, :) = (/ &
  &  0.103223E+01_JPRB, 0.103933E+01_JPRB, 0.104604E+01_JPRB, 0.105234E+01_JPRB &
  &, 0.105824E+01_JPRB, 0.106373E+01_JPRB, 0.106881E+01_JPRB &
  &, 0.107346E+01_JPRB, 0.107770E+01_JPRB, 0.108150E+01_JPRB, 0.108487E+01_JPRB &
  &, 0.108781E+01_JPRB, 0.109030E+01_JPRB, 0.109236E+01_JPRB &
  &, 0.109396E+01_JPRB, 0.109512E+01_JPRB, 0.109583E+01_JPRB, 0.109608E+01_JPRB &
  &, 0.109588E+01_JPRB, 0.109522E+01_JPRB, 0.109411E+01_JPRB &
  &, 0.109254E+01_JPRB, 0.109051E+01_JPRB, 0.108802E+01_JPRB, 0.108507E+01_JPRB &
  &, 0.108167E+01_JPRB, 0.107782E+01_JPRB, 0.107351E+01_JPRB &
  &, 0.106876E+01_JPRB, 0.106356E+01_JPRB, 0.105792E+01_JPRB, 0.105184E+01_JPRB &
  &, 0.104533E+01_JPRB, 0.103840E+01_JPRB, 0.103104E+01_JPRB &
  &, 0.102327E+01_JPRB, 0.101511E+01_JPRB, 0.100654E+01_JPRB, 0.997576E+00_JPRB &
  &, 0.988246E+00_JPRB, 0.978535E+00_JPRB, 0.968475E+00_JPRB &
  &, 0.958057E+00_JPRB, 0.947298E+00_JPRB, 0.936217E+00_JPRB, 0.924828E+00_JPRB &
  &, 0.913119E+00_JPRB, 0.901133E+00_JPRB, 0.888864E+00_JPRB &
  &, 0.876332E+00_JPRB, 0.863562E+00_JPRB, 0.850539E+00_JPRB, 0.837303E+00_JPRB &
  &, 0.823855E+00_JPRB, 0.810211E+00_JPRB, 0.796402E+00_JPRB &
  &, 0.782417E+00_JPRB, 0.768289E+00_JPRB, 0.754038E+00_JPRB, 0.739651E+00_JPRB &
  &, 0.725165E+00_JPRB, 0.710600E+00_JPRB, 0.695962E+00_JPRB &
  &, 0.681252E+00_JPRB, 0.666511E+00_JPRB, 0.651741E+00_JPRB, 0.636945E+00_JPRB &
  &, 0.622163E+00_JPRB, 0.607396E+00_JPRB, 0.592645E+00_JPRB &
  &, 0.577951E+00_JPRB, 0.563292E+00_JPRB, 0.548729E+00_JPRB, 0.534218E+00_JPRB &
  &, 0.519819E+00_JPRB, 0.505530E+00_JPRB, 0.491343E+00_JPRB &
  &, 0.477298E+00_JPRB, 0.463388E+00_JPRB, 0.449627E+00_JPRB, 0.436029E+00_JPRB &
  &, 0.422581E+00_JPRB, 0.409348E+00_JPRB, 0.396261E+00_JPRB &
  &, 0.383384E+00_JPRB, 0.370727E+00_JPRB, 0.358270E+00_JPRB, 0.346020E+00_JPRB &
  &, 0.333983E+00_JPRB, 0.322192E+00_JPRB, 0.310623E+00_JPRB &
  &, 0.299307E+00_JPRB, 0.288216E+00_JPRB, 0.277380E+00_JPRB, 0.266767E+00_JPRB &
  &, 0.256439E+00_JPRB, 0.246326E+00_JPRB, 0.236491E+00_JPRB &
  &, 0.226893E+00_JPRB, 0.217596E+00_JPRB, 0.208519E+00_JPRB, 0.199688E+00_JPRB &
  &, 0.191128E+00_JPRB, 0.182827E+00_JPRB, 0.174771E+00_JPRB &
  &, 0.166943E+00_JPRB, 0.159407E+00_JPRB, 0.152104E+00_JPRB, 0.145056E+00_JPRB &
  &, 0.138200E+00_JPRB, 0.131639E+00_JPRB, 0.125310E+00_JPRB &
  &, 0.119186E+00_JPRB, 0.113284E+00_JPRB, 0.107623E+00_JPRB, 0.102173E+00_JPRB &
  &, 0.969510E-01_JPRB, 0.919253E-01_JPRB, 0.871107E-01_JPRB &
  &, 0.824723E-01_JPRB, 0.780741E-01_JPRB, 0.738290E-01_JPRB, 0.698006E-01_JPRB &
  &, 0.658971E-01_JPRB, 0.622355E-01_JPRB, 0.587214E-01_JPRB &
  &, 0.553648E-01_JPRB, 0.521760E-01_JPRB, 0.491087E-01_JPRB, 0.462285E-01_JPRB &
  &, 0.434297E-01_JPRB, 0.408364E-01_JPRB, 0.383401E-01_JPRB &
  &, 0.360077E-01_JPRB, 0.337866E-01_JPRB, 0.316835E-01_JPRB, 0.296418E-01_JPRB &
  &, 0.277299E-01_JPRB, 0.259547E-01_JPRB, 0.242574E-01_JPRB/)
XCW( 639, :) = (/ &
  &  0.103250E+01_JPRB, 0.103967E+01_JPRB, 0.104645E+01_JPRB, 0.105282E+01_JPRB &
  &, 0.105880E+01_JPRB, 0.106436E+01_JPRB, 0.106951E+01_JPRB &
  &, 0.107424E+01_JPRB, 0.107854E+01_JPRB, 0.108242E+01_JPRB, 0.108586E+01_JPRB &
  &, 0.108887E+01_JPRB, 0.109144E+01_JPRB, 0.109357E+01_JPRB &
  &, 0.109525E+01_JPRB, 0.109648E+01_JPRB, 0.109726E+01_JPRB, 0.109759E+01_JPRB &
  &, 0.109746E+01_JPRB, 0.109687E+01_JPRB, 0.109583E+01_JPRB &
  &, 0.109433E+01_JPRB, 0.109237E+01_JPRB, 0.108995E+01_JPRB, 0.108707E+01_JPRB &
  &, 0.108374E+01_JPRB, 0.107996E+01_JPRB, 0.107572E+01_JPRB &
  &, 0.107103E+01_JPRB, 0.106589E+01_JPRB, 0.106032E+01_JPRB, 0.105431E+01_JPRB &
  &, 0.104786E+01_JPRB, 0.104099E+01_JPRB, 0.103369E+01_JPRB &
  &, 0.102599E+01_JPRB, 0.101788E+01_JPRB, 0.100936E+01_JPRB, 0.100045E+01_JPRB &
  &, 0.991175E+00_JPRB, 0.981517E+00_JPRB, 0.971500E+00_JPRB &
  &, 0.961136E+00_JPRB, 0.950419E+00_JPRB, 0.939394E+00_JPRB, 0.928035E+00_JPRB &
  &, 0.916369E+00_JPRB, 0.904426E+00_JPRB, 0.892199E+00_JPRB &
  &, 0.879696E+00_JPRB, 0.866953E+00_JPRB, 0.853971E+00_JPRB, 0.840761E+00_JPRB &
  &, 0.827338E+00_JPRB, 0.813717E+00_JPRB, 0.799930E+00_JPRB &
  &, 0.785966E+00_JPRB, 0.771857E+00_JPRB, 0.757607E+00_JPRB, 0.743236E+00_JPRB &
  &, 0.728764E+00_JPRB, 0.714194E+00_JPRB, 0.699565E+00_JPRB &
  &, 0.684864E+00_JPRB, 0.670110E+00_JPRB, 0.655343E+00_JPRB, 0.640548E+00_JPRB &
  &, 0.625745E+00_JPRB, 0.610974E+00_JPRB, 0.596217E+00_JPRB &
  &, 0.581494E+00_JPRB, 0.566844E+00_JPRB, 0.552246E+00_JPRB, 0.537718E+00_JPRB &
  &, 0.523300E+00_JPRB, 0.508965E+00_JPRB, 0.494776E+00_JPRB &
  &, 0.480679E+00_JPRB, 0.466737E+00_JPRB, 0.452941E+00_JPRB, 0.439305E+00_JPRB &
  &, 0.425842E+00_JPRB, 0.412538E+00_JPRB, 0.399430E+00_JPRB &
  &, 0.386530E+00_JPRB, 0.373791E+00_JPRB, 0.361305E+00_JPRB, 0.348994E+00_JPRB &
  &, 0.336922E+00_JPRB, 0.325063E+00_JPRB, 0.313453E+00_JPRB &
  &, 0.302094E+00_JPRB, 0.290956E+00_JPRB, 0.280038E+00_JPRB, 0.269405E+00_JPRB &
  &, 0.258987E+00_JPRB, 0.248850E+00_JPRB, 0.238953E+00_JPRB &
  &, 0.229290E+00_JPRB, 0.219925E+00_JPRB, 0.210777E+00_JPRB, 0.201908E+00_JPRB &
  &, 0.193309E+00_JPRB, 0.184927E+00_JPRB, 0.176827E+00_JPRB &
  &, 0.168952E+00_JPRB, 0.161326E+00_JPRB, 0.153971E+00_JPRB, 0.146869E+00_JPRB &
  &, 0.139998E+00_JPRB, 0.133336E+00_JPRB, 0.126945E+00_JPRB &
  &, 0.120756E+00_JPRB, 0.114833E+00_JPRB, 0.109103E+00_JPRB, 0.103629E+00_JPRB &
  &, 0.983338E-01_JPRB, 0.932806E-01_JPRB, 0.883879E-01_JPRB &
  &, 0.837187E-01_JPRB, 0.792377E-01_JPRB, 0.749584E-01_JPRB, 0.708943E-01_JPRB &
  &, 0.669539E-01_JPRB, 0.632539E-01_JPRB, 0.596999E-01_JPRB &
  &, 0.563021E-01_JPRB, 0.530147E-01_JPRB, 0.499591E-01_JPRB, 0.470333E-01_JPRB &
  &, 0.442456E-01_JPRB, 0.416045E-01_JPRB, 0.390588E-01_JPRB &
  &, 0.366754E-01_JPRB, 0.344019E-01_JPRB, 0.322447E-01_JPRB, 0.302105E-01_JPRB &
  &, 0.283061E-01_JPRB, 0.264736E-01_JPRB, 0.247831E-01_JPRB/)
XCW( 640, :) = (/ &
  &  0.103278E+01_JPRB, 0.104002E+01_JPRB, 0.104686E+01_JPRB, 0.105331E+01_JPRB &
  &, 0.105935E+01_JPRB, 0.106499E+01_JPRB, 0.107021E+01_JPRB &
  &, 0.107501E+01_JPRB, 0.107939E+01_JPRB, 0.108334E+01_JPRB, 0.108685E+01_JPRB &
  &, 0.108994E+01_JPRB, 0.109258E+01_JPRB, 0.109478E+01_JPRB &
  &, 0.109653E+01_JPRB, 0.109784E+01_JPRB, 0.109869E+01_JPRB, 0.109909E+01_JPRB &
  &, 0.109903E+01_JPRB, 0.109852E+01_JPRB, 0.109755E+01_JPRB &
  &, 0.109612E+01_JPRB, 0.109423E+01_JPRB, 0.109188E+01_JPRB, 0.108908E+01_JPRB &
  &, 0.108582E+01_JPRB, 0.108210E+01_JPRB, 0.107793E+01_JPRB &
  &, 0.107331E+01_JPRB, 0.106824E+01_JPRB, 0.106273E+01_JPRB, 0.105678E+01_JPRB &
  &, 0.105040E+01_JPRB, 0.104358E+01_JPRB, 0.103635E+01_JPRB &
  &, 0.102871E+01_JPRB, 0.102065E+01_JPRB, 0.101219E+01_JPRB, 0.100334E+01_JPRB &
  &, 0.994115E+00_JPRB, 0.984510E+00_JPRB, 0.974546E+00_JPRB &
  &, 0.964225E+00_JPRB, 0.953564E+00_JPRB, 0.942570E+00_JPRB, 0.931255E+00_JPRB &
  &, 0.919644E+00_JPRB, 0.907731E+00_JPRB, 0.895534E+00_JPRB &
  &, 0.883073E+00_JPRB, 0.870358E+00_JPRB, 0.857403E+00_JPRB, 0.844219E+00_JPRB &
  &, 0.830820E+00_JPRB, 0.817238E+00_JPRB, 0.803459E+00_JPRB &
  &, 0.789515E+00_JPRB, 0.775425E+00_JPRB, 0.761193E+00_JPRB, 0.746838E+00_JPRB &
  &, 0.732363E+00_JPRB, 0.717822E+00_JPRB, 0.703186E+00_JPRB &
  &, 0.688475E+00_JPRB, 0.673745E+00_JPRB, 0.658964E+00_JPRB, 0.644170E+00_JPRB &
  &, 0.629367E+00_JPRB, 0.614573E+00_JPRB, 0.599790E+00_JPRB &
  &, 0.585079E+00_JPRB, 0.570397E+00_JPRB, 0.555764E+00_JPRB, 0.541241E+00_JPRB &
  &, 0.526781E+00_JPRB, 0.512447E+00_JPRB, 0.498209E+00_JPRB &
  &, 0.484084E+00_JPRB, 0.470111E+00_JPRB, 0.456281E+00_JPRB, 0.442607E+00_JPRB &
  &, 0.429103E+00_JPRB, 0.415782E+00_JPRB, 0.402627E+00_JPRB &
  &, 0.389649E+00_JPRB, 0.376912E+00_JPRB, 0.364341E+00_JPRB, 0.351998E+00_JPRB &
  &, 0.339891E+00_JPRB, 0.327996E+00_JPRB, 0.316314E+00_JPRB &
  &, 0.304880E+00_JPRB, 0.293696E+00_JPRB, 0.282761E+00_JPRB, 0.272043E+00_JPRB &
  &, 0.261570E+00_JPRB, 0.251373E+00_JPRB, 0.241415E+00_JPRB &
  &, 0.231723E+00_JPRB, 0.222290E+00_JPRB, 0.213108E+00_JPRB, 0.204166E+00_JPRB &
  &, 0.195489E+00_JPRB, 0.187066E+00_JPRB, 0.178882E+00_JPRB &
  &, 0.170961E+00_JPRB, 0.163286E+00_JPRB, 0.155880E+00_JPRB, 0.148724E+00_JPRB &
  &, 0.141754E+00_JPRB, 0.135076E+00_JPRB, 0.128624E+00_JPRB &
  &, 0.122416E+00_JPRB, 0.116382E+00_JPRB, 0.110630E+00_JPRB, 0.105085E+00_JPRB &
  &, 0.997643E-01_JPRB, 0.946358E-01_JPRB, 0.897143E-01_JPRB &
  &, 0.849651E-01_JPRB, 0.804519E-01_JPRB, 0.761391E-01_JPRB, 0.719881E-01_JPRB &
  &, 0.680634E-01_JPRB, 0.642722E-01_JPRB, 0.606784E-01_JPRB &
  &, 0.572394E-01_JPRB, 0.539652E-01_JPRB, 0.508096E-01_JPRB, 0.478381E-01_JPRB &
  &, 0.450033E-01_JPRB, 0.423135E-01_JPRB, 0.397775E-01_JPRB &
  &, 0.373432E-01_JPRB, 0.350786E-01_JPRB, 0.328682E-01_JPRB, 0.308423E-01_JPRB &
  &, 0.288823E-01_JPRB, 0.269925E-01_JPRB, 0.253088E-01_JPRB/)
XCW( 641, :) = (/ &
  &  0.103305E+01_JPRB, 0.104036E+01_JPRB, 0.104728E+01_JPRB, 0.105379E+01_JPRB &
  &, 0.105991E+01_JPRB, 0.106562E+01_JPRB, 0.107091E+01_JPRB &
  &, 0.107578E+01_JPRB, 0.108023E+01_JPRB, 0.108426E+01_JPRB, 0.108785E+01_JPRB &
  &, 0.109100E+01_JPRB, 0.109372E+01_JPRB, 0.109599E+01_JPRB &
  &, 0.109782E+01_JPRB, 0.109920E+01_JPRB, 0.110013E+01_JPRB, 0.110060E+01_JPRB &
  &, 0.110062E+01_JPRB, 0.110018E+01_JPRB, 0.109928E+01_JPRB &
  &, 0.109792E+01_JPRB, 0.109610E+01_JPRB, 0.109382E+01_JPRB, 0.109109E+01_JPRB &
  &, 0.108790E+01_JPRB, 0.108425E+01_JPRB, 0.108014E+01_JPRB &
  &, 0.107559E+01_JPRB, 0.107059E+01_JPRB, 0.106514E+01_JPRB, 0.105926E+01_JPRB &
  &, 0.105294E+01_JPRB, 0.104619E+01_JPRB, 0.103901E+01_JPRB &
  &, 0.103142E+01_JPRB, 0.102343E+01_JPRB, 0.101503E+01_JPRB, 0.100624E+01_JPRB &
  &, 0.997055E+00_JPRB, 0.987503E+00_JPRB, 0.977593E+00_JPRB &
  &, 0.967315E+00_JPRB, 0.956708E+00_JPRB, 0.945758E+00_JPRB, 0.934486E+00_JPRB &
  &, 0.922919E+00_JPRB, 0.911036E+00_JPRB, 0.898881E+00_JPRB &
  &, 0.886463E+00_JPRB, 0.873777E+00_JPRB, 0.860849E+00_JPRB, 0.847705E+00_JPRB &
  &, 0.834332E+00_JPRB, 0.820759E+00_JPRB, 0.807017E+00_JPRB &
  &, 0.793095E+00_JPRB, 0.779009E+00_JPRB, 0.764795E+00_JPRB, 0.750456E+00_JPRB &
  &, 0.735995E+00_JPRB, 0.721450E+00_JPRB, 0.706825E+00_JPRB &
  &, 0.692122E+00_JPRB, 0.677381E+00_JPRB, 0.662604E+00_JPRB, 0.647793E+00_JPRB &
  &, 0.632989E+00_JPRB, 0.618192E+00_JPRB, 0.603404E+00_JPRB &
  &, 0.588664E+00_JPRB, 0.573972E+00_JPRB, 0.559325E+00_JPRB, 0.544764E+00_JPRB &
  &, 0.530307E+00_JPRB, 0.515929E+00_JPRB, 0.501666E+00_JPRB &
  &, 0.487514E+00_JPRB, 0.473510E+00_JPRB, 0.459646E+00_JPRB, 0.445935E+00_JPRB &
  &, 0.432391E+00_JPRB, 0.419026E+00_JPRB, 0.405825E+00_JPRB &
  &, 0.392824E+00_JPRB, 0.380033E+00_JPRB, 0.367434E+00_JPRB, 0.355031E+00_JPRB &
  &, 0.342861E+00_JPRB, 0.330928E+00_JPRB, 0.319207E+00_JPRB &
  &, 0.307730E+00_JPRB, 0.296468E+00_JPRB, 0.285484E+00_JPRB, 0.274714E+00_JPRB &
  &, 0.264186E+00_JPRB, 0.253932E+00_JPRB, 0.243912E+00_JPRB &
  &, 0.234155E+00_JPRB, 0.224655E+00_JPRB, 0.215439E+00_JPRB, 0.206423E+00_JPRB &
  &, 0.197708E+00_JPRB, 0.189205E+00_JPRB, 0.180977E+00_JPRB &
  &, 0.173010E+00_JPRB, 0.165286E+00_JPRB, 0.157788E+00_JPRB, 0.150578E+00_JPRB &
  &, 0.143595E+00_JPRB, 0.136816E+00_JPRB, 0.130303E+00_JPRB &
  &, 0.124032E+00_JPRB, 0.117977E+00_JPRB, 0.112157E+00_JPRB, 0.106541E+00_JPRB &
  &, 0.101195E+00_JPRB, 0.959911E-01_JPRB, 0.910407E-01_JPRB &
  &, 0.862614E-01_JPRB, 0.817168E-01_JPRB, 0.773198E-01_JPRB, 0.731339E-01_JPRB &
  &, 0.691202E-01_JPRB, 0.652905E-01_JPRB, 0.616570E-01_JPRB &
  &, 0.581767E-01_JPRB, 0.548598E-01_JPRB, 0.517167E-01_JPRB, 0.487004E-01_JPRB &
  &, 0.458192E-01_JPRB, 0.430816E-01_JPRB, 0.404961E-01_JPRB &
  &, 0.380716E-01_JPRB, 0.356939E-01_JPRB, 0.334916E-01_JPRB, 0.314109E-01_JPRB &
  &, 0.294584E-01_JPRB, 0.275763E-01_JPRB, 0.257688E-01_JPRB/)
XCW( 642, :) = (/ &
  &  0.103332E+01_JPRB, 0.104070E+01_JPRB, 0.104769E+01_JPRB, 0.105428E+01_JPRB &
  &, 0.106047E+01_JPRB, 0.106625E+01_JPRB, 0.107161E+01_JPRB &
  &, 0.107656E+01_JPRB, 0.108108E+01_JPRB, 0.108518E+01_JPRB, 0.108884E+01_JPRB &
  &, 0.109207E+01_JPRB, 0.109486E+01_JPRB, 0.109721E+01_JPRB &
  &, 0.109911E+01_JPRB, 0.110056E+01_JPRB, 0.110156E+01_JPRB, 0.110211E+01_JPRB &
  &, 0.110220E+01_JPRB, 0.110183E+01_JPRB, 0.110100E+01_JPRB &
  &, 0.109972E+01_JPRB, 0.109797E+01_JPRB, 0.109577E+01_JPRB, 0.109310E+01_JPRB &
  &, 0.108998E+01_JPRB, 0.108640E+01_JPRB, 0.108236E+01_JPRB &
  &, 0.107788E+01_JPRB, 0.107294E+01_JPRB, 0.106756E+01_JPRB, 0.106174E+01_JPRB &
  &, 0.105549E+01_JPRB, 0.104880E+01_JPRB, 0.104169E+01_JPRB &
  &, 0.103416E+01_JPRB, 0.102622E+01_JPRB, 0.101787E+01_JPRB, 0.100914E+01_JPRB &
  &, 0.100002E+01_JPRB, 0.990517E+00_JPRB, 0.980650E+00_JPRB &
  &, 0.970427E+00_JPRB, 0.959864E+00_JPRB, 0.948957E+00_JPRB, 0.937729E+00_JPRB &
  &, 0.926193E+00_JPRB, 0.914367E+00_JPRB, 0.902242E+00_JPRB &
  &, 0.889853E+00_JPRB, 0.877209E+00_JPRB, 0.864308E+00_JPRB, 0.851191E+00_JPRB &
  &, 0.837844E+00_JPRB, 0.824309E+00_JPRB, 0.810576E+00_JPRB &
  &, 0.796674E+00_JPRB, 0.782609E+00_JPRB, 0.768413E+00_JPRB, 0.754074E+00_JPRB &
  &, 0.739628E+00_JPRB, 0.725096E+00_JPRB, 0.710464E+00_JPRB &
  &, 0.695770E+00_JPRB, 0.681035E+00_JPRB, 0.666244E+00_JPRB, 0.651454E+00_JPRB &
  &, 0.636630E+00_JPRB, 0.621811E+00_JPRB, 0.607038E+00_JPRB &
  &, 0.592270E+00_JPRB, 0.577567E+00_JPRB, 0.562908E+00_JPRB, 0.548331E+00_JPRB &
  &, 0.533834E+00_JPRB, 0.519434E+00_JPRB, 0.505147E+00_JPRB &
  &, 0.490967E+00_JPRB, 0.476933E+00_JPRB, 0.463036E+00_JPRB, 0.449288E+00_JPRB &
  &, 0.435705E+00_JPRB, 0.422297E+00_JPRB, 0.409022E+00_JPRB &
  &, 0.396026E+00_JPRB, 0.383183E+00_JPRB, 0.370527E+00_JPRB, 0.358094E+00_JPRB &
  &, 0.345860E+00_JPRB, 0.333891E+00_JPRB, 0.322099E+00_JPRB &
  &, 0.310580E+00_JPRB, 0.299272E+00_JPRB, 0.288207E+00_JPRB, 0.277385E+00_JPRB &
  &, 0.266836E+00_JPRB, 0.256524E+00_JPRB, 0.246444E+00_JPRB &
  &, 0.236624E+00_JPRB, 0.227093E+00_JPRB, 0.217770E+00_JPRB, 0.208718E+00_JPRB &
  &, 0.199927E+00_JPRB, 0.191383E+00_JPRB, 0.183112E+00_JPRB &
  &, 0.175059E+00_JPRB, 0.167287E+00_JPRB, 0.159738E+00_JPRB, 0.152475E+00_JPRB &
  &, 0.145394E+00_JPRB, 0.138599E+00_JPRB, 0.132026E+00_JPRB &
  &, 0.125692E+00_JPRB, 0.119618E+00_JPRB, 0.113730E+00_JPRB, 0.108044E+00_JPRB &
  &, 0.102625E+00_JPRB, 0.973947E-01_JPRB, 0.923671E-01_JPRB &
  &, 0.875577E-01_JPRB, 0.829310E-01_JPRB, 0.785004E-01_JPRB, 0.742797E-01_JPRB &
  &, 0.702297E-01_JPRB, 0.663625E-01_JPRB, 0.626899E-01_JPRB &
  &, 0.591691E-01_JPRB, 0.558103E-01_JPRB, 0.525671E-01_JPRB, 0.495052E-01_JPRB &
  &, 0.466351E-01_JPRB, 0.438497E-01_JPRB, 0.412148E-01_JPRB &
  &, 0.387394E-01_JPRB, 0.363706E-01_JPRB, 0.341775E-01_JPRB, 0.320427E-01_JPRB &
  &, 0.300346E-01_JPRB, 0.280951E-01_JPRB, 0.262945E-01_JPRB/)
XCW( 643, :) = (/ &
  &  0.103360E+01_JPRB, 0.104105E+01_JPRB, 0.104811E+01_JPRB, 0.105477E+01_JPRB &
  &, 0.106103E+01_JPRB, 0.106688E+01_JPRB, 0.107231E+01_JPRB &
  &, 0.107733E+01_JPRB, 0.108193E+01_JPRB, 0.108610E+01_JPRB, 0.108984E+01_JPRB &
  &, 0.109314E+01_JPRB, 0.109601E+01_JPRB, 0.109843E+01_JPRB &
  &, 0.110040E+01_JPRB, 0.110193E+01_JPRB, 0.110300E+01_JPRB, 0.110362E+01_JPRB &
  &, 0.110379E+01_JPRB, 0.110349E+01_JPRB, 0.110274E+01_JPRB &
  &, 0.110152E+01_JPRB, 0.109985E+01_JPRB, 0.109771E+01_JPRB, 0.109512E+01_JPRB &
  &, 0.109207E+01_JPRB, 0.108856E+01_JPRB, 0.108458E+01_JPRB &
  &, 0.108017E+01_JPRB, 0.107530E+01_JPRB, 0.106999E+01_JPRB, 0.106423E+01_JPRB &
  &, 0.105804E+01_JPRB, 0.105142E+01_JPRB, 0.104437E+01_JPRB &
  &, 0.103689E+01_JPRB, 0.102901E+01_JPRB, 0.102073E+01_JPRB, 0.101204E+01_JPRB &
  &, 0.100298E+01_JPRB, 0.993531E+00_JPRB, 0.983718E+00_JPRB &
  &, 0.973550E+00_JPRB, 0.963031E+00_JPRB, 0.952169E+00_JPRB, 0.940985E+00_JPRB &
  &, 0.929493E+00_JPRB, 0.917697E+00_JPRB, 0.905616E+00_JPRB &
  &, 0.893269E+00_JPRB, 0.880654E+00_JPRB, 0.867796E+00_JPRB, 0.854692E+00_JPRB &
  &, 0.841384E+00_JPRB, 0.827860E+00_JPRB, 0.814149E+00_JPRB &
  &, 0.800270E+00_JPRB, 0.786224E+00_JPRB, 0.772047E+00_JPRB, 0.757725E+00_JPRB &
  &, 0.743295E+00_JPRB, 0.728759E+00_JPRB, 0.714138E+00_JPRB &
  &, 0.699454E+00_JPRB, 0.684708E+00_JPRB, 0.669921E+00_JPRB, 0.655115E+00_JPRB &
  &, 0.640292E+00_JPRB, 0.625471E+00_JPRB, 0.610672E+00_JPRB &
  &, 0.595897E+00_JPRB, 0.581163E+00_JPRB, 0.566491E+00_JPRB, 0.551899E+00_JPRB &
  &, 0.537384E+00_JPRB, 0.522962E+00_JPRB, 0.508628E+00_JPRB &
  &, 0.494445E+00_JPRB, 0.480381E+00_JPRB, 0.466451E+00_JPRB, 0.452668E+00_JPRB &
  &, 0.439045E+00_JPRB, 0.425595E+00_JPRB, 0.412328E+00_JPRB &
  &, 0.399229E+00_JPRB, 0.386333E+00_JPRB, 0.373649E+00_JPRB, 0.361156E+00_JPRB &
  &, 0.348889E+00_JPRB, 0.336854E+00_JPRB, 0.325023E+00_JPRB &
  &, 0.313461E+00_JPRB, 0.302109E+00_JPRB, 0.290996E+00_JPRB, 0.280123E+00_JPRB &
  &, 0.269486E+00_JPRB, 0.259117E+00_JPRB, 0.249012E+00_JPRB &
  &, 0.239128E+00_JPRB, 0.229494E+00_JPRB, 0.220138E+00_JPRB, 0.211051E+00_JPRB &
  &, 0.202184E+00_JPRB, 0.193600E+00_JPRB, 0.185247E+00_JPRB &
  &, 0.177148E+00_JPRB, 0.169329E+00_JPRB, 0.161729E+00_JPRB, 0.154372E+00_JPRB &
  &, 0.147278E+00_JPRB, 0.140383E+00_JPRB, 0.133793E+00_JPRB &
  &, 0.127397E+00_JPRB, 0.121212E+00_JPRB, 0.115303E+00_JPRB, 0.109594E+00_JPRB &
  &, 0.104104E+00_JPRB, 0.987984E-01_JPRB, 0.937427E-01_JPRB &
  &, 0.888539E-01_JPRB, 0.841958E-01_JPRB, 0.797325E-01_JPRB, 0.754776E-01_JPRB &
  &, 0.713393E-01_JPRB, 0.674344E-01_JPRB, 0.637227E-01_JPRB &
  &, 0.601615E-01_JPRB, 0.567608E-01_JPRB, 0.534743E-01_JPRB, 0.504250E-01_JPRB &
  &, 0.474511E-01_JPRB, 0.446768E-01_JPRB, 0.419934E-01_JPRB &
  &, 0.394678E-01_JPRB, 0.370474E-01_JPRB, 0.348010E-01_JPRB, 0.326745E-01_JPRB &
  &, 0.306108E-01_JPRB, 0.286789E-01_JPRB, 0.268201E-01_JPRB/)
XCW( 644, :) = (/ &
  &  0.103387E+01_JPRB, 0.104139E+01_JPRB, 0.104852E+01_JPRB, 0.105525E+01_JPRB &
  &, 0.106158E+01_JPRB, 0.106751E+01_JPRB, 0.107302E+01_JPRB &
  &, 0.107811E+01_JPRB, 0.108278E+01_JPRB, 0.108703E+01_JPRB, 0.109084E+01_JPRB &
  &, 0.109421E+01_JPRB, 0.109715E+01_JPRB, 0.109965E+01_JPRB &
  &, 0.110170E+01_JPRB, 0.110330E+01_JPRB, 0.110445E+01_JPRB, 0.110514E+01_JPRB &
  &, 0.110538E+01_JPRB, 0.110515E+01_JPRB, 0.110447E+01_JPRB &
  &, 0.110333E+01_JPRB, 0.110173E+01_JPRB, 0.109966E+01_JPRB, 0.109714E+01_JPRB &
  &, 0.109416E+01_JPRB, 0.109072E+01_JPRB, 0.108682E+01_JPRB &
  &, 0.108247E+01_JPRB, 0.107767E+01_JPRB, 0.107242E+01_JPRB, 0.106673E+01_JPRB &
  &, 0.106060E+01_JPRB, 0.105404E+01_JPRB, 0.104705E+01_JPRB &
  &, 0.103964E+01_JPRB, 0.103182E+01_JPRB, 0.102359E+01_JPRB, 0.101497E+01_JPRB &
  &, 0.100596E+01_JPRB, 0.996555E+00_JPRB, 0.986797E+00_JPRB &
  &, 0.976673E+00_JPRB, 0.966198E+00_JPRB, 0.955391E+00_JPRB, 0.944252E+00_JPRB &
  &, 0.932804E+00_JPRB, 0.921052E+00_JPRB, 0.909002E+00_JPRB &
  &, 0.896686E+00_JPRB, 0.884113E+00_JPRB, 0.871283E+00_JPRB, 0.858220E+00_JPRB &
  &, 0.844925E+00_JPRB, 0.831440E+00_JPRB, 0.817753E+00_JPRB &
  &, 0.803881E+00_JPRB, 0.789856E+00_JPRB, 0.775697E+00_JPRB, 0.761393E+00_JPRB &
  &, 0.746961E+00_JPRB, 0.732439E+00_JPRB, 0.717830E+00_JPRB &
  &, 0.703137E+00_JPRB, 0.688399E+00_JPRB, 0.673618E+00_JPRB, 0.658796E+00_JPRB &
  &, 0.643973E+00_JPRB, 0.629150E+00_JPRB, 0.614327E+00_JPRB &
  &, 0.599545E+00_JPRB, 0.584802E+00_JPRB, 0.570118E+00_JPRB, 0.555489E+00_JPRB &
  &, 0.540956E+00_JPRB, 0.526514E+00_JPRB, 0.512157E+00_JPRB &
  &, 0.497923E+00_JPRB, 0.483830E+00_JPRB, 0.469866E+00_JPRB, 0.456047E+00_JPRB &
  &, 0.442385E+00_JPRB, 0.428919E+00_JPRB, 0.415607E+00_JPRB &
  &, 0.402459E+00_JPRB, 0.389539E+00_JPRB, 0.376800E+00_JPRB, 0.364278E+00_JPRB &
  &, 0.351948E+00_JPRB, 0.339847E+00_JPRB, 0.327977E+00_JPRB &
  &, 0.316343E+00_JPRB, 0.304945E+00_JPRB, 0.293785E+00_JPRB, 0.282861E+00_JPRB &
  &, 0.272171E+00_JPRB, 0.261745E+00_JPRB, 0.251579E+00_JPRB &
  &, 0.241632E+00_JPRB, 0.231968E+00_JPRB, 0.222543E+00_JPRB, 0.213384E+00_JPRB &
  &, 0.204479E+00_JPRB, 0.195816E+00_JPRB, 0.187421E+00_JPRB &
  &, 0.179278E+00_JPRB, 0.171370E+00_JPRB, 0.163721E+00_JPRB, 0.156311E+00_JPRB &
  &, 0.149119E+00_JPRB, 0.142210E+00_JPRB, 0.135516E+00_JPRB &
  &, 0.129102E+00_JPRB, 0.122853E+00_JPRB, 0.116876E+00_JPRB, 0.111097E+00_JPRB &
  &, 0.105582E+00_JPRB, 0.100250E+00_JPRB, 0.951182E-01_JPRB &
  &, 0.902000E-01_JPRB, 0.855112E-01_JPRB, 0.809645E-01_JPRB, 0.766234E-01_JPRB &
  &, 0.725017E-01_JPRB, 0.685599E-01_JPRB, 0.647556E-01_JPRB &
  &, 0.611539E-01_JPRB, 0.577113E-01_JPRB, 0.543814E-01_JPRB, 0.512872E-01_JPRB &
  &, 0.482670E-01_JPRB, 0.454449E-01_JPRB, 0.427720E-01_JPRB &
  &, 0.401963E-01_JPRB, 0.377857E-01_JPRB, 0.354868E-01_JPRB, 0.332432E-01_JPRB &
  &, 0.311869E-01_JPRB, 0.292627E-01_JPRB, 0.274115E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART92',1,ZHOOK_HANDLE)
END SUBROUTINE PART92

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART93

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART93',0,ZHOOK_HANDLE)

XCW( 645, :) = (/ &
  &  0.103415E+01_JPRB, 0.104174E+01_JPRB, 0.104894E+01_JPRB, 0.105574E+01_JPRB &
  &, 0.106214E+01_JPRB, 0.106814E+01_JPRB, 0.107372E+01_JPRB &
  &, 0.107889E+01_JPRB, 0.108363E+01_JPRB, 0.108795E+01_JPRB, 0.109184E+01_JPRB &
  &, 0.109529E+01_JPRB, 0.109830E+01_JPRB, 0.110087E+01_JPRB &
  &, 0.110300E+01_JPRB, 0.110467E+01_JPRB, 0.110589E+01_JPRB, 0.110666E+01_JPRB &
  &, 0.110697E+01_JPRB, 0.110682E+01_JPRB, 0.110621E+01_JPRB &
  &, 0.110514E+01_JPRB, 0.110361E+01_JPRB, 0.110162E+01_JPRB, 0.109917E+01_JPRB &
  &, 0.109626E+01_JPRB, 0.109289E+01_JPRB, 0.108906E+01_JPRB &
  &, 0.108477E+01_JPRB, 0.108004E+01_JPRB, 0.107486E+01_JPRB, 0.106923E+01_JPRB &
  &, 0.106317E+01_JPRB, 0.105667E+01_JPRB, 0.104975E+01_JPRB &
  &, 0.104240E+01_JPRB, 0.103463E+01_JPRB, 0.102646E+01_JPRB, 0.101790E+01_JPRB &
  &, 0.100894E+01_JPRB, 0.999590E+00_JPRB, 0.989887E+00_JPRB &
  &, 0.979807E+00_JPRB, 0.969388E+00_JPRB, 0.958626E+00_JPRB, 0.947531E+00_JPRB &
  &, 0.936127E+00_JPRB, 0.924408E+00_JPRB, 0.912401E+00_JPRB &
  &, 0.900128E+00_JPRB, 0.887572E+00_JPRB, 0.874784E+00_JPRB, 0.861749E+00_JPRB &
  &, 0.848480E+00_JPRB, 0.835020E+00_JPRB, 0.821357E+00_JPRB &
  &, 0.807522E+00_JPRB, 0.793519E+00_JPRB, 0.779299E+00_JPRB, 0.765061E+00_JPRB &
  &, 0.750662E+00_JPRB, 0.736137E+00_JPRB, 0.721540E+00_JPRB &
  &, 0.706857E+00_JPRB, 0.692109E+00_JPRB, 0.677334E+00_JPRB, 0.662515E+00_JPRB &
  &, 0.647674E+00_JPRB, 0.632830E+00_JPRB, 0.618024E+00_JPRB &
  &, 0.603214E+00_JPRB, 0.588463E+00_JPRB, 0.573745E+00_JPRB, 0.559102E+00_JPRB &
  &, 0.544551E+00_JPRB, 0.530066E+00_JPRB, 0.515709E+00_JPRB &
  &, 0.501450E+00_JPRB, 0.487228E+00_JPRB, 0.473307E+00_JPRB, 0.459478E+00_JPRB &
  &, 0.445778E+00_JPRB, 0.432243E+00_JPRB, 0.418886E+00_JPRB &
  &, 0.405717E+00_JPRB, 0.392745E+00_JPRB, 0.379951E+00_JPRB, 0.367399E+00_JPRB &
  &, 0.355038E+00_JPRB, 0.342871E+00_JPRB, 0.330963E+00_JPRB &
  &, 0.319256E+00_JPRB, 0.307814E+00_JPRB, 0.296607E+00_JPRB, 0.285599E+00_JPRB &
  &, 0.274889E+00_JPRB, 0.264407E+00_JPRB, 0.254146E+00_JPRB &
  &, 0.244172E+00_JPRB, 0.234443E+00_JPRB, 0.224949E+00_JPRB, 0.215754E+00_JPRB &
  &, 0.206774E+00_JPRB, 0.198072E+00_JPRB, 0.189595E+00_JPRB &
  &, 0.181367E+00_JPRB, 0.173411E+00_JPRB, 0.165712E+00_JPRB, 0.158250E+00_JPRB &
  &, 0.151047E+00_JPRB, 0.144037E+00_JPRB, 0.137327E+00_JPRB &
  &, 0.130807E+00_JPRB, 0.124538E+00_JPRB, 0.118495E+00_JPRB, 0.112694E+00_JPRB &
  &, 0.107060E+00_JPRB, 0.101702E+00_JPRB, 0.964938E-01_JPRB &
  &, 0.915462E-01_JPRB, 0.867760E-01_JPRB, 0.821965E-01_JPRB, 0.778213E-01_JPRB &
  &, 0.736641E-01_JPRB, 0.696318E-01_JPRB, 0.658429E-01_JPRB &
  &, 0.621463E-01_JPRB, 0.586618E-01_JPRB, 0.553452E-01_JPRB, 0.521495E-01_JPRB &
  &, 0.491412E-01_JPRB, 0.462721E-01_JPRB, 0.435506E-01_JPRB &
  &, 0.409247E-01_JPRB, 0.384624E-01_JPRB, 0.361103E-01_JPRB, 0.339382E-01_JPRB &
  &, 0.318271E-01_JPRB, 0.298464E-01_JPRB, 0.279372E-01_JPRB/)
XCW( 646, :) = (/ &
  &  0.103442E+01_JPRB, 0.104208E+01_JPRB, 0.104935E+01_JPRB, 0.105623E+01_JPRB &
  &, 0.106270E+01_JPRB, 0.106877E+01_JPRB, 0.107443E+01_JPRB &
  &, 0.107967E+01_JPRB, 0.108448E+01_JPRB, 0.108888E+01_JPRB, 0.109284E+01_JPRB &
  &, 0.109637E+01_JPRB, 0.109945E+01_JPRB, 0.110210E+01_JPRB &
  &, 0.110429E+01_JPRB, 0.110604E+01_JPRB, 0.110734E+01_JPRB, 0.110818E+01_JPRB &
  &, 0.110857E+01_JPRB, 0.110849E+01_JPRB, 0.110796E+01_JPRB &
  &, 0.110696E+01_JPRB, 0.110550E+01_JPRB, 0.110358E+01_JPRB, 0.110120E+01_JPRB &
  &, 0.109836E+01_JPRB, 0.109506E+01_JPRB, 0.109130E+01_JPRB &
  &, 0.108708E+01_JPRB, 0.108242E+01_JPRB, 0.107730E+01_JPRB, 0.107174E+01_JPRB &
  &, 0.106574E+01_JPRB, 0.105931E+01_JPRB, 0.105245E+01_JPRB &
  &, 0.104516E+01_JPRB, 0.103745E+01_JPRB, 0.102934E+01_JPRB, 0.102083E+01_JPRB &
  &, 0.101193E+01_JPRB, 0.100264E+01_JPRB, 0.992977E+00_JPRB &
  &, 0.982952E+00_JPRB, 0.972578E+00_JPRB, 0.961860E+00_JPRB, 0.950822E+00_JPRB &
  &, 0.939451E+00_JPRB, 0.927776E+00_JPRB, 0.915813E+00_JPRB &
  &, 0.903571E+00_JPRB, 0.891058E+00_JPRB, 0.878299E+00_JPRB, 0.865291E+00_JPRB &
  &, 0.852064E+00_JPRB, 0.838615E+00_JPRB, 0.824976E+00_JPRB &
  &, 0.811164E+00_JPRB, 0.797182E+00_JPRB, 0.783031E+00_JPRB, 0.768762E+00_JPRB &
  &, 0.754363E+00_JPRB, 0.739852E+00_JPRB, 0.725250E+00_JPRB &
  &, 0.710577E+00_JPRB, 0.695837E+00_JPRB, 0.681049E+00_JPRB, 0.666235E+00_JPRB &
  &, 0.651395E+00_JPRB, 0.636550E+00_JPRB, 0.621720E+00_JPRB &
  &, 0.606905E+00_JPRB, 0.592123E+00_JPRB, 0.577416E+00_JPRB, 0.562737E+00_JPRB &
  &, 0.548170E+00_JPRB, 0.533665E+00_JPRB, 0.519262E+00_JPRB &
  &, 0.504976E+00_JPRB, 0.490825E+00_JPRB, 0.476798E+00_JPRB, 0.462909E+00_JPRB &
  &, 0.449171E+00_JPRB, 0.435622E+00_JPRB, 0.422220E+00_JPRB &
  &, 0.409003E+00_JPRB, 0.395980E+00_JPRB, 0.383160E+00_JPRB, 0.370521E+00_JPRB &
  &, 0.358127E+00_JPRB, 0.345925E+00_JPRB, 0.333949E+00_JPRB &
  &, 0.322201E+00_JPRB, 0.310715E+00_JPRB, 0.299428E+00_JPRB, 0.288404E+00_JPRB &
  &, 0.277607E+00_JPRB, 0.267069E+00_JPRB, 0.256784E+00_JPRB &
  &, 0.246748E+00_JPRB, 0.236953E+00_JPRB, 0.227391E+00_JPRB, 0.218125E+00_JPRB &
  &, 0.209108E+00_JPRB, 0.200327E+00_JPRB, 0.191809E+00_JPRB &
  &, 0.183536E+00_JPRB, 0.175494E+00_JPRB, 0.167745E+00_JPRB, 0.160231E+00_JPRB &
  &, 0.152931E+00_JPRB, 0.145907E+00_JPRB, 0.139095E+00_JPRB &
  &, 0.132557E+00_JPRB, 0.126224E+00_JPRB, 0.120114E+00_JPRB, 0.114245E+00_JPRB &
  &, 0.108586E+00_JPRB, 0.103155E+00_JPRB, 0.979184E-01_JPRB &
  &, 0.928923E-01_JPRB, 0.880914E-01_JPRB, 0.834799E-01_JPRB, 0.790713E-01_JPRB &
  &, 0.748265E-01_JPRB, 0.707574E-01_JPRB, 0.668758E-01_JPRB &
  &, 0.631939E-01_JPRB, 0.596682E-01_JPRB, 0.563091E-01_JPRB, 0.530693E-01_JPRB &
  &, 0.500155E-01_JPRB, 0.470992E-01_JPRB, 0.443291E-01_JPRB &
  &, 0.417139E-01_JPRB, 0.392007E-01_JPRB, 0.367962E-01_JPRB, 0.345700E-01_JPRB &
  &, 0.324033E-01_JPRB, 0.304302E-01_JPRB, 0.285286E-01_JPRB/)
XCW( 647, :) = (/ &
  &  0.103470E+01_JPRB, 0.104243E+01_JPRB, 0.104977E+01_JPRB, 0.105672E+01_JPRB &
  &, 0.106327E+01_JPRB, 0.106941E+01_JPRB, 0.107514E+01_JPRB &
  &, 0.108045E+01_JPRB, 0.108534E+01_JPRB, 0.108981E+01_JPRB, 0.109384E+01_JPRB &
  &, 0.109744E+01_JPRB, 0.110060E+01_JPRB, 0.110332E+01_JPRB &
  &, 0.110560E+01_JPRB, 0.110742E+01_JPRB, 0.110879E+01_JPRB, 0.110970E+01_JPRB &
  &, 0.111016E+01_JPRB, 0.111016E+01_JPRB, 0.110970E+01_JPRB &
  &, 0.110878E+01_JPRB, 0.110740E+01_JPRB, 0.110555E+01_JPRB, 0.110324E+01_JPRB &
  &, 0.110047E+01_JPRB, 0.109724E+01_JPRB, 0.109355E+01_JPRB &
  &, 0.108940E+01_JPRB, 0.108480E+01_JPRB, 0.107975E+01_JPRB, 0.107426E+01_JPRB &
  &, 0.106832E+01_JPRB, 0.106196E+01_JPRB, 0.105515E+01_JPRB &
  &, 0.104792E+01_JPRB, 0.104029E+01_JPRB, 0.103223E+01_JPRB, 0.102377E+01_JPRB &
  &, 0.101493E+01_JPRB, 0.100569E+01_JPRB, 0.996088E+00_JPRB &
  &, 0.986120E+00_JPRB, 0.975790E+00_JPRB, 0.965118E+00_JPRB, 0.954113E+00_JPRB &
  &, 0.942799E+00_JPRB, 0.931168E+00_JPRB, 0.919238E+00_JPRB &
  &, 0.907026E+00_JPRB, 0.894557E+00_JPRB, 0.881827E+00_JPRB, 0.868848E+00_JPRB &
  &, 0.855647E+00_JPRB, 0.842239E+00_JPRB, 0.828626E+00_JPRB &
  &, 0.814822E+00_JPRB, 0.800861E+00_JPRB, 0.786730E+00_JPRB, 0.772463E+00_JPRB &
  &, 0.758080E+00_JPRB, 0.743584E+00_JPRB, 0.728995E+00_JPRB &
  &, 0.714316E+00_JPRB, 0.699584E+00_JPRB, 0.684803E+00_JPRB, 0.669973E+00_JPRB &
  &, 0.655136E+00_JPRB, 0.640290E+00_JPRB, 0.625437E+00_JPRB &
  &, 0.610616E+00_JPRB, 0.595827E+00_JPRB, 0.581087E+00_JPRB, 0.566394E+00_JPRB &
  &, 0.551788E+00_JPRB, 0.537287E+00_JPRB, 0.522862E+00_JPRB &
  &, 0.508527E+00_JPRB, 0.494348E+00_JPRB, 0.480290E+00_JPRB, 0.466366E+00_JPRB &
  &, 0.452590E+00_JPRB, 0.439000E+00_JPRB, 0.425554E+00_JPRB &
  &, 0.412317E+00_JPRB, 0.399243E+00_JPRB, 0.386369E+00_JPRB, 0.373701E+00_JPRB &
  &, 0.361246E+00_JPRB, 0.349010E+00_JPRB, 0.336966E+00_JPRB &
  &, 0.325177E+00_JPRB, 0.313616E+00_JPRB, 0.302283E+00_JPRB, 0.291209E+00_JPRB &
  &, 0.280359E+00_JPRB, 0.269765E+00_JPRB, 0.259422E+00_JPRB &
  &, 0.249324E+00_JPRB, 0.239464E+00_JPRB, 0.229870E+00_JPRB, 0.220533E+00_JPRB &
  &, 0.211441E+00_JPRB, 0.202622E+00_JPRB, 0.194022E+00_JPRB &
  &, 0.185706E+00_JPRB, 0.177617E+00_JPRB, 0.169778E+00_JPRB, 0.162212E+00_JPRB &
  &, 0.154901E+00_JPRB, 0.147778E+00_JPRB, 0.140950E+00_JPRB &
  &, 0.134307E+00_JPRB, 0.127910E+00_JPRB, 0.121780E+00_JPRB, 0.115842E+00_JPRB &
  &, 0.110159E+00_JPRB, 0.104655E+00_JPRB, 0.993431E-01_JPRB &
  &, 0.942882E-01_JPRB, 0.894068E-01_JPRB, 0.847632E-01_JPRB, 0.802692E-01_JPRB &
  &, 0.759889E-01_JPRB, 0.718829E-01_JPRB, 0.679630E-01_JPRB &
  &, 0.642414E-01_JPRB, 0.606747E-01_JPRB, 0.572729E-01_JPRB, 0.539891E-01_JPRB &
  &, 0.508897E-01_JPRB, 0.479264E-01_JPRB, 0.451077E-01_JPRB &
  &, 0.424423E-01_JPRB, 0.399390E-01_JPRB, 0.375444E-01_JPRB, 0.352018E-01_JPRB &
  &, 0.330435E-01_JPRB, 0.310139E-01_JPRB, 0.290543E-01_JPRB/)
XCW( 648, :) = (/ &
  &  0.103497E+01_JPRB, 0.104277E+01_JPRB, 0.105019E+01_JPRB, 0.105721E+01_JPRB &
  &, 0.106383E+01_JPRB, 0.107004E+01_JPRB, 0.107585E+01_JPRB &
  &, 0.108123E+01_JPRB, 0.108620E+01_JPRB, 0.109074E+01_JPRB, 0.109485E+01_JPRB &
  &, 0.109852E+01_JPRB, 0.110176E+01_JPRB, 0.110455E+01_JPRB &
  &, 0.110690E+01_JPRB, 0.110880E+01_JPRB, 0.111024E+01_JPRB, 0.111123E+01_JPRB &
  &, 0.111177E+01_JPRB, 0.111184E+01_JPRB, 0.111145E+01_JPRB &
  &, 0.111060E+01_JPRB, 0.110929E+01_JPRB, 0.110752E+01_JPRB, 0.110528E+01_JPRB &
  &, 0.110258E+01_JPRB, 0.109942E+01_JPRB, 0.109580E+01_JPRB &
  &, 0.109172E+01_JPRB, 0.108719E+01_JPRB, 0.108221E+01_JPRB, 0.107679E+01_JPRB &
  &, 0.107091E+01_JPRB, 0.106461E+01_JPRB, 0.105787E+01_JPRB &
  &, 0.105070E+01_JPRB, 0.104312E+01_JPRB, 0.103512E+01_JPRB, 0.102673E+01_JPRB &
  &, 0.101793E+01_JPRB, 0.100876E+01_JPRB, 0.999200E+00_JPRB &
  &, 0.989287E+00_JPRB, 0.979003E+00_JPRB, 0.968387E+00_JPRB, 0.957428E+00_JPRB &
  &, 0.946147E+00_JPRB, 0.934561E+00_JPRB, 0.922675E+00_JPRB &
  &, 0.910509E+00_JPRB, 0.898056E+00_JPRB, 0.885370E+00_JPRB, 0.872419E+00_JPRB &
  &, 0.859246E+00_JPRB, 0.845864E+00_JPRB, 0.832275E+00_JPRB &
  &, 0.818494E+00_JPRB, 0.804556E+00_JPRB, 0.790445E+00_JPRB, 0.776197E+00_JPRB &
  &, 0.761815E+00_JPRB, 0.747334E+00_JPRB, 0.732758E+00_JPRB &
  &, 0.718090E+00_JPRB, 0.703349E+00_JPRB, 0.688556E+00_JPRB, 0.673731E+00_JPRB &
  &, 0.658896E+00_JPRB, 0.644031E+00_JPRB, 0.629175E+00_JPRB &
  &, 0.614349E+00_JPRB, 0.599530E+00_JPRB, 0.584780E+00_JPRB, 0.570074E+00_JPRB &
  &, 0.555452E+00_JPRB, 0.540909E+00_JPRB, 0.526462E+00_JPRB &
  &, 0.512127E+00_JPRB, 0.497895E+00_JPRB, 0.483806E+00_JPRB, 0.469849E+00_JPRB &
  &, 0.456061E+00_JPRB, 0.442404E+00_JPRB, 0.428942E+00_JPRB &
  &, 0.415631E+00_JPRB, 0.402535E+00_JPRB, 0.389606E+00_JPRB, 0.376911E+00_JPRB &
  &, 0.364396E+00_JPRB, 0.352095E+00_JPRB, 0.340014E+00_JPRB &
  &, 0.328186E+00_JPRB, 0.316550E+00_JPRB, 0.305170E+00_JPRB, 0.294047E+00_JPRB &
  &, 0.283146E+00_JPRB, 0.272496E+00_JPRB, 0.262095E+00_JPRB &
  &, 0.251935E+00_JPRB, 0.242011E+00_JPRB, 0.232349E+00_JPRB, 0.222978E+00_JPRB &
  &, 0.213813E+00_JPRB, 0.204916E+00_JPRB, 0.196275E+00_JPRB &
  &, 0.187915E+00_JPRB, 0.179740E+00_JPRB, 0.171852E+00_JPRB, 0.164236E+00_JPRB &
  &, 0.156828E+00_JPRB, 0.149692E+00_JPRB, 0.142762E+00_JPRB &
  &, 0.136102E+00_JPRB, 0.129642E+00_JPRB, 0.123445E+00_JPRB, 0.117439E+00_JPRB &
  &, 0.111685E+00_JPRB, 0.106155E+00_JPRB, 0.100817E+00_JPRB &
  &, 0.956842E-01_JPRB, 0.907728E-01_JPRB, 0.860466E-01_JPRB, 0.815192E-01_JPRB &
  &, 0.772042E-01_JPRB, 0.730620E-01_JPRB, 0.691046E-01_JPRB &
  &, 0.652890E-01_JPRB, 0.616811E-01_JPRB, 0.582367E-01_JPRB, 0.549088E-01_JPRB &
  &, 0.518222E-01_JPRB, 0.488126E-01_JPRB, 0.459462E-01_JPRB &
  &, 0.432315E-01_JPRB, 0.406773E-01_JPRB, 0.382302E-01_JPRB, 0.358968E-01_JPRB &
  &, 0.336837E-01_JPRB, 0.315977E-01_JPRB, 0.296457E-01_JPRB/)
XCW( 649, :) = (/ &
  &  0.103525E+01_JPRB, 0.104312E+01_JPRB, 0.105061E+01_JPRB, 0.105770E+01_JPRB &
  &, 0.106439E+01_JPRB, 0.107068E+01_JPRB, 0.107655E+01_JPRB &
  &, 0.108201E+01_JPRB, 0.108705E+01_JPRB, 0.109167E+01_JPRB, 0.109585E+01_JPRB &
  &, 0.109960E+01_JPRB, 0.110291E+01_JPRB, 0.110578E+01_JPRB &
  &, 0.110821E+01_JPRB, 0.111013E+01_JPRB, 0.111170E+01_JPRB, 0.111276E+01_JPRB &
  &, 0.111337E+01_JPRB, 0.111352E+01_JPRB, 0.111320E+01_JPRB &
  &, 0.111243E+01_JPRB, 0.111119E+01_JPRB, 0.110949E+01_JPRB, 0.110732E+01_JPRB &
  &, 0.110470E+01_JPRB, 0.110161E+01_JPRB, 0.109806E+01_JPRB &
  &, 0.109405E+01_JPRB, 0.108959E+01_JPRB, 0.108467E+01_JPRB, 0.107932E+01_JPRB &
  &, 0.107351E+01_JPRB, 0.106727E+01_JPRB, 0.106059E+01_JPRB &
  &, 0.105348E+01_JPRB, 0.104596E+01_JPRB, 0.103803E+01_JPRB, 0.102969E+01_JPRB &
  &, 0.102095E+01_JPRB, 0.101167E+01_JPRB, 0.100233E+01_JPRB &
  &, 0.992454E+00_JPRB, 0.982227E+00_JPRB, 0.971657E+00_JPRB, 0.960742E+00_JPRB &
  &, 0.949507E+00_JPRB, 0.937967E+00_JPRB, 0.926126E+00_JPRB &
  &, 0.913991E+00_JPRB, 0.901583E+00_JPRB, 0.888926E+00_JPRB, 0.876004E+00_JPRB &
  &, 0.862858E+00_JPRB, 0.849503E+00_JPRB, 0.835939E+00_JPRB &
  &, 0.822183E+00_JPRB, 0.808251E+00_JPRB, 0.794177E+00_JPRB, 0.779932E+00_JPRB &
  &, 0.765583E+00_JPRB, 0.751101E+00_JPRB, 0.736521E+00_JPRB &
  &, 0.721865E+00_JPRB, 0.707133E+00_JPRB, 0.692348E+00_JPRB, 0.677528E+00_JPRB &
  &, 0.662676E+00_JPRB, 0.647791E+00_JPRB, 0.632933E+00_JPRB &
  &, 0.618082E+00_JPRB, 0.603277E+00_JPRB, 0.588495E+00_JPRB, 0.573776E+00_JPRB &
  &, 0.559139E+00_JPRB, 0.544554E+00_JPRB, 0.530086E+00_JPRB &
  &, 0.515727E+00_JPRB, 0.501468E+00_JPRB, 0.487348E+00_JPRB, 0.473357E+00_JPRB &
  &, 0.459507E+00_JPRB, 0.445836E+00_JPRB, 0.432331E+00_JPRB &
  &, 0.419000E+00_JPRB, 0.405826E+00_JPRB, 0.392873E+00_JPRB, 0.380120E+00_JPRB &
  &, 0.367575E+00_JPRB, 0.355211E+00_JPRB, 0.343093E+00_JPRB &
  &, 0.331194E+00_JPRB, 0.319515E+00_JPRB, 0.308090E+00_JPRB, 0.296885E+00_JPRB &
  &, 0.285932E+00_JPRB, 0.275227E+00_JPRB, 0.264768E+00_JPRB &
  &, 0.254547E+00_JPRB, 0.244594E+00_JPRB, 0.234865E+00_JPRB, 0.225424E+00_JPRB &
  &, 0.216223E+00_JPRB, 0.207250E+00_JPRB, 0.198568E+00_JPRB &
  &, 0.190125E+00_JPRB, 0.181904E+00_JPRB, 0.173968E+00_JPRB, 0.166259E+00_JPRB &
  &, 0.158797E+00_JPRB, 0.151606E+00_JPRB, 0.144617E+00_JPRB &
  &, 0.137897E+00_JPRB, 0.131419E+00_JPRB, 0.125157E+00_JPRB, 0.119083E+00_JPRB &
  &, 0.113259E+00_JPRB, 0.107656E+00_JPRB, 0.102291E+00_JPRB &
  &, 0.971301E-01_JPRB, 0.921388E-01_JPRB, 0.873813E-01_JPRB, 0.828212E-01_JPRB &
  &, 0.784194E-01_JPRB, 0.742411E-01_JPRB, 0.702462E-01_JPRB &
  &, 0.663917E-01_JPRB, 0.627434E-01_JPRB, 0.592006E-01_JPRB, 0.558861E-01_JPRB &
  &, 0.526964E-01_JPRB, 0.496989E-01_JPRB, 0.467847E-01_JPRB &
  &, 0.440206E-01_JPRB, 0.414156E-01_JPRB, 0.389784E-01_JPRB, 0.365917E-01_JPRB &
  &, 0.343879E-01_JPRB, 0.322463E-01_JPRB, 0.302371E-01_JPRB/)
XCW( 650, :) = (/ &
  &  0.103552E+01_JPRB, 0.104347E+01_JPRB, 0.105103E+01_JPRB, 0.105819E+01_JPRB &
  &, 0.106495E+01_JPRB, 0.107131E+01_JPRB, 0.107727E+01_JPRB &
  &, 0.108280E+01_JPRB, 0.108791E+01_JPRB, 0.109260E+01_JPRB, 0.109686E+01_JPRB &
  &, 0.110069E+01_JPRB, 0.110407E+01_JPRB, 0.110702E+01_JPRB &
  &, 0.110951E+01_JPRB, 0.111156E+01_JPRB, 0.111316E+01_JPRB, 0.111430E+01_JPRB &
  &, 0.111498E+01_JPRB, 0.111520E+01_JPRB, 0.111496E+01_JPRB &
  &, 0.111426E+01_JPRB, 0.111310E+01_JPRB, 0.111147E+01_JPRB, 0.110937E+01_JPRB &
  &, 0.110682E+01_JPRB, 0.110380E+01_JPRB, 0.110032E+01_JPRB &
  &, 0.109638E+01_JPRB, 0.109199E+01_JPRB, 0.108714E+01_JPRB, 0.108185E+01_JPRB &
  &, 0.107611E+01_JPRB, 0.106993E+01_JPRB, 0.106332E+01_JPRB &
  &, 0.105627E+01_JPRB, 0.104881E+01_JPRB, 0.104094E+01_JPRB, 0.103266E+01_JPRB &
  &, 0.102399E+01_JPRB, 0.101491E+01_JPRB, 0.100547E+01_JPRB &
  &, 0.995644E+00_JPRB, 0.985473E+00_JPRB, 0.974938E+00_JPRB, 0.964081E+00_JPRB &
  &, 0.952892E+00_JPRB, 0.941385E+00_JPRB, 0.929576E+00_JPRB &
  &, 0.917486E+00_JPRB, 0.905122E+00_JPRB, 0.892482E+00_JPRB, 0.879603E+00_JPRB &
  &, 0.866500E+00_JPRB, 0.853157E+00_JPRB, 0.839619E+00_JPRB &
  &, 0.825887E+00_JPRB, 0.811977E+00_JPRB, 0.797909E+00_JPRB, 0.783699E+00_JPRB &
  &, 0.769352E+00_JPRB, 0.754885E+00_JPRB, 0.740320E+00_JPRB &
  &, 0.725657E+00_JPRB, 0.710936E+00_JPRB, 0.696139E+00_JPRB, 0.681325E+00_JPRB &
  &, 0.666456E+00_JPRB, 0.651592E+00_JPRB, 0.636712E+00_JPRB &
  &, 0.621856E+00_JPRB, 0.607023E+00_JPRB, 0.592232E+00_JPRB, 0.577501E+00_JPRB &
  &, 0.562826E+00_JPRB, 0.548246E+00_JPRB, 0.533734E+00_JPRB &
  &, 0.519351E+00_JPRB, 0.505065E+00_JPRB, 0.490915E+00_JPRB, 0.476891E+00_JPRB &
  &, 0.463005E+00_JPRB, 0.449295E+00_JPRB, 0.435746E+00_JPRB &
  &, 0.422370E+00_JPRB, 0.409174E+00_JPRB, 0.396169E+00_JPRB, 0.383360E+00_JPRB &
  &, 0.370754E+00_JPRB, 0.358357E+00_JPRB, 0.346203E+00_JPRB &
  &, 0.334234E+00_JPRB, 0.322513E+00_JPRB, 0.311043E+00_JPRB, 0.299790E+00_JPRB &
  &, 0.288786E+00_JPRB, 0.277993E+00_JPRB, 0.267476E+00_JPRB &
  &, 0.257194E+00_JPRB, 0.247178E+00_JPRB, 0.237418E+00_JPRB, 0.227907E+00_JPRB &
  &, 0.218633E+00_JPRB, 0.209622E+00_JPRB, 0.200861E+00_JPRB &
  &, 0.192335E+00_JPRB, 0.184109E+00_JPRB, 0.176084E+00_JPRB, 0.168325E+00_JPRB &
  &, 0.160810E+00_JPRB, 0.153563E+00_JPRB, 0.146517E+00_JPRB &
  &, 0.139736E+00_JPRB, 0.133196E+00_JPRB, 0.126869E+00_JPRB, 0.120774E+00_JPRB &
  &, 0.114880E+00_JPRB, 0.109205E+00_JPRB, 0.103764E+00_JPRB &
  &, 0.985759E-01_JPRB, 0.935554E-01_JPRB, 0.887160E-01_JPRB, 0.841233E-01_JPRB &
  &, 0.796875E-01_JPRB, 0.754203E-01_JPRB, 0.713878E-01_JPRB &
  &, 0.674944E-01_JPRB, 0.637498E-01_JPRB, 0.602211E-01_JPRB, 0.568633E-01_JPRB &
  &, 0.536289E-01_JPRB, 0.505851E-01_JPRB, 0.476231E-01_JPRB &
  &, 0.448705E-01_JPRB, 0.422154E-01_JPRB, 0.396642E-01_JPRB, 0.372867E-01_JPRB &
  &, 0.350280E-01_JPRB, 0.328949E-01_JPRB, 0.308285E-01_JPRB/)
XCW( 651, :) = (/ &
  &  0.103580E+01_JPRB, 0.104382E+01_JPRB, 0.105145E+01_JPRB, 0.105868E+01_JPRB &
  &, 0.106552E+01_JPRB, 0.107195E+01_JPRB, 0.107798E+01_JPRB &
  &, 0.108359E+01_JPRB, 0.108877E+01_JPRB, 0.109354E+01_JPRB, 0.109787E+01_JPRB &
  &, 0.110177E+01_JPRB, 0.110523E+01_JPRB, 0.110825E+01_JPRB &
  &, 0.111083E+01_JPRB, 0.111295E+01_JPRB, 0.111462E+01_JPRB, 0.111583E+01_JPRB &
  &, 0.111659E+01_JPRB, 0.111689E+01_JPRB, 0.111672E+01_JPRB &
  &, 0.111610E+01_JPRB, 0.111501E+01_JPRB, 0.111345E+01_JPRB, 0.111143E+01_JPRB &
  &, 0.110895E+01_JPRB, 0.110600E+01_JPRB, 0.110259E+01_JPRB &
  &, 0.109872E+01_JPRB, 0.109440E+01_JPRB, 0.108962E+01_JPRB, 0.108439E+01_JPRB &
  &, 0.107872E+01_JPRB, 0.107261E+01_JPRB, 0.106606E+01_JPRB &
  &, 0.105907E+01_JPRB, 0.105164E+01_JPRB, 0.104386E+01_JPRB, 0.103564E+01_JPRB &
  &, 0.102702E+01_JPRB, 0.101800E+01_JPRB, 0.100861E+01_JPRB &
  &, 0.998844E+00_JPRB, 0.988720E+00_JPRB, 0.978242E+00_JPRB, 0.967420E+00_JPRB &
  &, 0.956277E+00_JPRB, 0.944815E+00_JPRB, 0.933052E+00_JPRB &
  &, 0.920994E+00_JPRB, 0.908662E+00_JPRB, 0.896066E+00_JPRB, 0.883217E+00_JPRB &
  &, 0.870142E+00_JPRB, 0.856826E+00_JPRB, 0.843314E+00_JPRB &
  &, 0.829606E+00_JPRB, 0.815720E+00_JPRB, 0.801673E+00_JPRB, 0.787467E+00_JPRB &
  &, 0.773137E+00_JPRB, 0.758687E+00_JPRB, 0.744118E+00_JPRB &
  &, 0.729468E+00_JPRB, 0.714757E+00_JPRB, 0.699969E+00_JPRB, 0.685141E+00_JPRB &
  &, 0.670276E+00_JPRB, 0.655393E+00_JPRB, 0.640512E+00_JPRB &
  &, 0.625652E+00_JPRB, 0.610813E+00_JPRB, 0.595991E+00_JPRB, 0.581248E+00_JPRB &
  &, 0.566558E+00_JPRB, 0.551939E+00_JPRB, 0.537405E+00_JPRB &
  &, 0.522999E+00_JPRB, 0.508687E+00_JPRB, 0.494483E+00_JPRB, 0.478800E+00_JPRB &
  &, 0.466529E+00_JPRB, 0.452780E+00_JPRB, 0.439189E+00_JPRB &
  &, 0.425767E+00_JPRB, 0.412523E+00_JPRB, 0.399464E+00_JPRB, 0.386628E+00_JPRB &
  &, 0.373963E+00_JPRB, 0.361533E+00_JPRB, 0.349313E+00_JPRB &
  &, 0.337305E+00_JPRB, 0.325543E+00_JPRB, 0.313996E+00_JPRB, 0.302695E+00_JPRB &
  &, 0.291606E+00_JPRB, 0.280793E+00_JPRB, 0.270219E+00_JPRB &
  &, 0.259877E+00_JPRB, 0.249797E+00_JPRB, 0.239972E+00_JPRB, 0.230390E+00_JPRB &
  &, 0.221081E+00_JPRB, 0.211994E+00_JPRB, 0.203193E+00_JPRB &
  &, 0.194625E+00_JPRB, 0.186314E+00_JPRB, 0.178242E+00_JPRB, 0.170432E+00_JPRB &
  &, 0.162866E+00_JPRB, 0.155521E+00_JPRB, 0.148417E+00_JPRB &
  &, 0.141576E+00_JPRB, 0.134973E+00_JPRB, 0.128581E+00_JPRB, 0.122418E+00_JPRB &
  &, 0.116501E+00_JPRB, 0.110802E+00_JPRB, 0.105287E+00_JPRB &
  &, 0.100022E+00_JPRB, 0.949720E-01_JPRB, 0.901020E-01_JPRB, 0.854254E-01_JPRB &
  &, 0.809027E-01_JPRB, 0.766530E-01_JPRB, 0.725295E-01_JPRB &
  &, 0.685970E-01_JPRB, 0.648681E-01_JPRB, 0.612416E-01_JPRB, 0.578406E-01_JPRB &
  &, 0.545614E-01_JPRB, 0.514714E-01_JPRB, 0.484616E-01_JPRB &
  &, 0.456597E-01_JPRB, 0.430152E-01_JPRB, 0.404124E-01_JPRB, 0.379817E-01_JPRB &
  &, 0.357322E-01_JPRB, 0.335435E-01_JPRB, 0.314856E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART93',1,ZHOOK_HANDLE)
END SUBROUTINE PART93

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART94

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART94',0,ZHOOK_HANDLE)

XCW( 652, :) = (/ &
  &  0.103608E+01_JPRB, 0.104416E+01_JPRB, 0.105187E+01_JPRB, 0.105917E+01_JPRB &
  &, 0.106608E+01_JPRB, 0.107259E+01_JPRB, 0.107869E+01_JPRB &
  &, 0.108437E+01_JPRB, 0.108964E+01_JPRB, 0.109447E+01_JPRB, 0.109888E+01_JPRB &
  &, 0.110286E+01_JPRB, 0.110639E+01_JPRB, 0.110949E+01_JPRB &
  &, 0.111214E+01_JPRB, 0.111434E+01_JPRB, 0.111608E+01_JPRB, 0.111737E+01_JPRB &
  &, 0.111821E+01_JPRB, 0.111858E+01_JPRB, 0.111849E+01_JPRB &
  &, 0.111793E+01_JPRB, 0.111692E+01_JPRB, 0.111543E+01_JPRB, 0.111349E+01_JPRB &
  &, 0.111108E+01_JPRB, 0.110820E+01_JPRB, 0.110486E+01_JPRB &
  &, 0.110107E+01_JPRB, 0.109681E+01_JPRB, 0.109210E+01_JPRB, 0.108694E+01_JPRB &
  &, 0.108133E+01_JPRB, 0.107529E+01_JPRB, 0.106880E+01_JPRB &
  &, 0.106188E+01_JPRB, 0.105454E+01_JPRB, 0.104679E+01_JPRB, 0.103863E+01_JPRB &
  &, 0.103006E+01_JPRB, 0.102111E+01_JPRB, 0.101176E+01_JPRB &
  &, 0.100206E+01_JPRB, 0.991978E+00_JPRB, 0.981546E+00_JPRB, 0.970782E+00_JPRB &
  &, 0.959673E+00_JPRB, 0.948258E+00_JPRB, 0.936541E+00_JPRB &
  &, 0.924516E+00_JPRB, 0.912229E+00_JPRB, 0.899663E+00_JPRB, 0.886844E+00_JPRB &
  &, 0.873798E+00_JPRB, 0.860525E+00_JPRB, 0.847039E+00_JPRB &
  &, 0.833341E+00_JPRB, 0.819478E+00_JPRB, 0.805453E+00_JPRB, 0.791267E+00_JPRB &
  &, 0.776940E+00_JPRB, 0.762506E+00_JPRB, 0.747952E+00_JPRB &
  &, 0.733315E+00_JPRB, 0.718597E+00_JPRB, 0.703817E+00_JPRB, 0.688977E+00_JPRB &
  &, 0.674116E+00_JPRB, 0.659234E+00_JPRB, 0.644332E+00_JPRB &
  &, 0.629469E+00_JPRB, 0.614603E+00_JPRB, 0.599772E+00_JPRB, 0.585018E+00_JPRB &
  &, 0.570291E+00_JPRB, 0.555654E+00_JPRB, 0.541101E+00_JPRB &
  &, 0.526671E+00_JPRB, 0.512308E+00_JPRB, 0.498100E+00_JPRB, 0.484011E+00_JPRB &
  &, 0.470080E+00_JPRB, 0.456265E+00_JPRB, 0.442632E+00_JPRB &
  &, 0.429192E+00_JPRB, 0.415899E+00_JPRB, 0.402817E+00_JPRB, 0.389927E+00_JPRB &
  &, 0.377203E+00_JPRB, 0.364741E+00_JPRB, 0.352454E+00_JPRB &
  &, 0.340408E+00_JPRB, 0.328573E+00_JPRB, 0.316981E+00_JPRB, 0.305633E+00_JPRB &
  &, 0.294494E+00_JPRB, 0.283628E+00_JPRB, 0.272997E+00_JPRB &
  &, 0.262596E+00_JPRB, 0.252454E+00_JPRB, 0.242562E+00_JPRB, 0.232911E+00_JPRB &
  &, 0.223530E+00_JPRB, 0.214405E+00_JPRB, 0.205525E+00_JPRB &
  &, 0.196915E+00_JPRB, 0.188518E+00_JPRB, 0.180399E+00_JPRB, 0.172540E+00_JPRB &
  &, 0.164878E+00_JPRB, 0.157522E+00_JPRB, 0.150361E+00_JPRB &
  &, 0.143461E+00_JPRB, 0.136795E+00_JPRB, 0.130339E+00_JPRB, 0.124109E+00_JPRB &
  &, 0.118123E+00_JPRB, 0.112399E+00_JPRB, 0.106810E+00_JPRB &
  &, 0.101517E+00_JPRB, 0.963886E-01_JPRB, 0.914367E-01_JPRB, 0.867274E-01_JPRB &
  &, 0.822236E-01_JPRB, 0.778857E-01_JPRB, 0.737254E-01_JPRB &
  &, 0.697549E-01_JPRB, 0.659304E-01_JPRB, 0.623188E-01_JPRB, 0.588179E-01_JPRB &
  &, 0.554939E-01_JPRB, 0.523576E-01_JPRB, 0.493600E-01_JPRB &
  &, 0.465095E-01_JPRB, 0.437535E-01_JPRB, 0.412230E-01_JPRB, 0.387399E-01_JPRB &
  &, 0.363724E-01_JPRB, 0.341921E-01_JPRB, 0.320770E-01_JPRB/)
XCW( 653, :) = (/ &
  &  0.103636E+01_JPRB, 0.104451E+01_JPRB, 0.105229E+01_JPRB, 0.105967E+01_JPRB &
  &, 0.106665E+01_JPRB, 0.107323E+01_JPRB, 0.107940E+01_JPRB &
  &, 0.108516E+01_JPRB, 0.109050E+01_JPRB, 0.109541E+01_JPRB, 0.109990E+01_JPRB &
  &, 0.110395E+01_JPRB, 0.110756E+01_JPRB, 0.111073E+01_JPRB &
  &, 0.111345E+01_JPRB, 0.111573E+01_JPRB, 0.111755E+01_JPRB, 0.111891E+01_JPRB &
  &, 0.111983E+01_JPRB, 0.112027E+01_JPRB, 0.112026E+01_JPRB &
  &, 0.111978E+01_JPRB, 0.111884E+01_JPRB, 0.111743E+01_JPRB, 0.111555E+01_JPRB &
  &, 0.111321E+01_JPRB, 0.111041E+01_JPRB, 0.110714E+01_JPRB &
  &, 0.110342E+01_JPRB, 0.109923E+01_JPRB, 0.109459E+01_JPRB, 0.108950E+01_JPRB &
  &, 0.108396E+01_JPRB, 0.107798E+01_JPRB, 0.107155E+01_JPRB &
  &, 0.106470E+01_JPRB, 0.105742E+01_JPRB, 0.104973E+01_JPRB, 0.104163E+01_JPRB &
  &, 0.103312E+01_JPRB, 0.102422E+01_JPRB, 0.101493E+01_JPRB &
  &, 0.100527E+01_JPRB, 0.995247E+00_JPRB, 0.984862E+00_JPRB, 0.974145E+00_JPRB &
  &, 0.963082E+00_JPRB, 0.951714E+00_JPRB, 0.940030E+00_JPRB &
  &, 0.928063E+00_JPRB, 0.915795E+00_JPRB, 0.903275E+00_JPRB, 0.890486E+00_JPRB &
  &, 0.877469E+00_JPRB, 0.864223E+00_JPRB, 0.850764E+00_JPRB &
  &, 0.837107E+00_JPRB, 0.823252E+00_JPRB, 0.809249E+00_JPRB, 0.795068E+00_JPRB &
  &, 0.780776E+00_JPRB, 0.766343E+00_JPRB, 0.751804E+00_JPRB &
  &, 0.737162E+00_JPRB, 0.722455E+00_JPRB, 0.707665E+00_JPRB, 0.692832E+00_JPRB &
  &, 0.677975E+00_JPRB, 0.663076E+00_JPRB, 0.648173E+00_JPRB &
  &, 0.633286E+00_JPRB, 0.618414E+00_JPRB, 0.603575E+00_JPRB, 0.588787E+00_JPRB &
  &, 0.574070E+00_JPRB, 0.559393E+00_JPRB, 0.544820E+00_JPRB &
  &, 0.530344E+00_JPRB, 0.515980E+00_JPRB, 0.501743E+00_JPRB, 0.487623E+00_JPRB &
  &, 0.473630E+00_JPRB, 0.459804E+00_JPRB, 0.446130E+00_JPRB &
  &, 0.432645E+00_JPRB, 0.419304E+00_JPRB, 0.406171E+00_JPRB, 0.393225E+00_JPRB &
  &, 0.380472E+00_JPRB, 0.367948E+00_JPRB, 0.355627E+00_JPRB &
  &, 0.343511E+00_JPRB, 0.331635E+00_JPRB, 0.320000E+00_JPRB, 0.308572E+00_JPRB &
  &, 0.297382E+00_JPRB, 0.286463E+00_JPRB, 0.275776E+00_JPRB &
  &, 0.265315E+00_JPRB, 0.255110E+00_JPRB, 0.245189E+00_JPRB, 0.235470E+00_JPRB &
  &, 0.226054E+00_JPRB, 0.216855E+00_JPRB, 0.207897E+00_JPRB &
  &, 0.199205E+00_JPRB, 0.190764E+00_JPRB, 0.182598E+00_JPRB, 0.174647E+00_JPRB &
  &, 0.166977E+00_JPRB, 0.159523E+00_JPRB, 0.152305E+00_JPRB &
  &, 0.145345E+00_JPRB, 0.138618E+00_JPRB, 0.132097E+00_JPRB, 0.125846E+00_JPRB &
  &, 0.119791E+00_JPRB, 0.113997E+00_JPRB, 0.108382E+00_JPRB &
  &, 0.103013E+00_JPRB, 0.978051E-01_JPRB, 0.928228E-01_JPRB, 0.880816E-01_JPRB &
  &, 0.834917E-01_JPRB, 0.791184E-01_JPRB, 0.749214E-01_JPRB &
  &, 0.708576E-01_JPRB, 0.670486E-01_JPRB, 0.633394E-01_JPRB, 0.598526E-01_JPRB &
  &, 0.564847E-01_JPRB, 0.533030E-01_JPRB, 0.502583E-01_JPRB &
  &, 0.473594E-01_JPRB, 0.446148E-01_JPRB, 0.419712E-01_JPRB, 0.394981E-01_JPRB &
  &, 0.370766E-01_JPRB, 0.348408E-01_JPRB, 0.327341E-01_JPRB/)
XCW( 654, :) = (/ &
  &  0.103663E+01_JPRB, 0.104486E+01_JPRB, 0.105271E+01_JPRB, 0.106016E+01_JPRB &
  &, 0.106722E+01_JPRB, 0.107387E+01_JPRB, 0.108012E+01_JPRB &
  &, 0.108595E+01_JPRB, 0.109136E+01_JPRB, 0.109635E+01_JPRB, 0.110091E+01_JPRB &
  &, 0.110503E+01_JPRB, 0.110872E+01_JPRB, 0.111197E+01_JPRB &
  &, 0.111477E+01_JPRB, 0.111712E+01_JPRB, 0.111902E+01_JPRB, 0.112046E+01_JPRB &
  &, 0.112145E+01_JPRB, 0.112197E+01_JPRB, 0.112203E+01_JPRB &
  &, 0.112162E+01_JPRB, 0.112076E+01_JPRB, 0.111942E+01_JPRB, 0.111762E+01_JPRB &
  &, 0.111535E+01_JPRB, 0.111262E+01_JPRB, 0.110943E+01_JPRB &
  &, 0.110577E+01_JPRB, 0.110166E+01_JPRB, 0.109708E+01_JPRB, 0.109206E+01_JPRB &
  &, 0.108659E+01_JPRB, 0.108067E+01_JPRB, 0.107432E+01_JPRB &
  &, 0.106753E+01_JPRB, 0.106031E+01_JPRB, 0.105267E+01_JPRB, 0.104464E+01_JPRB &
  &, 0.103619E+01_JPRB, 0.102734E+01_JPRB, 0.101811E+01_JPRB &
  &, 0.100850E+01_JPRB, 0.998528E+00_JPRB, 0.988190E+00_JPRB, 0.977519E+00_JPRB &
  &, 0.966516E+00_JPRB, 0.955182E+00_JPRB, 0.943545E+00_JPRB &
  &, 0.931611E+00_JPRB, 0.919389E+00_JPRB, 0.906900E+00_JPRB, 0.894127E+00_JPRB &
  &, 0.881154E+00_JPRB, 0.867936E+00_JPRB, 0.854504E+00_JPRB &
  &, 0.840873E+00_JPRB, 0.827042E+00_JPRB, 0.813046E+00_JPRB, 0.798902E+00_JPRB &
  &, 0.784613E+00_JPRB, 0.770197E+00_JPRB, 0.755656E+00_JPRB &
  &, 0.741027E+00_JPRB, 0.726313E+00_JPRB, 0.711551E+00_JPRB, 0.696706E+00_JPRB &
  &, 0.681835E+00_JPRB, 0.666937E+00_JPRB, 0.652034E+00_JPRB &
  &, 0.637145E+00_JPRB, 0.622268E+00_JPRB, 0.607400E+00_JPRB, 0.592602E+00_JPRB &
  &, 0.577848E+00_JPRB, 0.563179E+00_JPRB, 0.548563E+00_JPRB &
  &, 0.534065E+00_JPRB, 0.519676E+00_JPRB, 0.505386E+00_JPRB, 0.491234E+00_JPRB &
  &, 0.477233E+00_JPRB, 0.463343E+00_JPRB, 0.449655E+00_JPRB &
  &, 0.436098E+00_JPRB, 0.422738E+00_JPRB, 0.409553E+00_JPRB, 0.396552E+00_JPRB &
  &, 0.383771E+00_JPRB, 0.371185E+00_JPRB, 0.358830E+00_JPRB &
  &, 0.346678E+00_JPRB, 0.334730E+00_JPRB, 0.323018E+00_JPRB, 0.311543E+00_JPRB &
  &, 0.300338E+00_JPRB, 0.289332E+00_JPRB, 0.278589E+00_JPRB &
  &, 0.268070E+00_JPRB, 0.257802E+00_JPRB, 0.247816E+00_JPRB, 0.238066E+00_JPRB &
  &, 0.228541E+00_JPRB, 0.219305E+00_JPRB, 0.210308E+00_JPRB &
  &, 0.201535E+00_JPRB, 0.193050E+00_JPRB, 0.184797E+00_JPRB, 0.176797E+00_JPRB &
  &, 0.169075E+00_JPRB, 0.161567E+00_JPRB, 0.154293E+00_JPRB &
  &, 0.147275E+00_JPRB, 0.140486E+00_JPRB, 0.133901E+00_JPRB, 0.127584E+00_JPRB &
  &, 0.121508E+00_JPRB, 0.115642E+00_JPRB, 0.109954E+00_JPRB &
  &, 0.104509E+00_JPRB, 0.992723E-01_JPRB, 0.942601E-01_JPRB, 0.894357E-01_JPRB &
  &, 0.848126E-01_JPRB, 0.803511E-01_JPRB, 0.761174E-01_JPRB &
  &, 0.720154E-01_JPRB, 0.681669E-01_JPRB, 0.644166E-01_JPRB, 0.608873E-01_JPRB &
  &, 0.574755E-01_JPRB, 0.542483E-01_JPRB, 0.511567E-01_JPRB &
  &, 0.482092E-01_JPRB, 0.454146E-01_JPRB, 0.427817E-01_JPRB, 0.402562E-01_JPRB &
  &, 0.378449E-01_JPRB, 0.355542E-01_JPRB, 0.333913E-01_JPRB/)
XCW( 655, :) = (/ &
  &  0.103691E+01_JPRB, 0.104521E+01_JPRB, 0.105313E+01_JPRB, 0.106065E+01_JPRB &
  &, 0.106778E+01_JPRB, 0.107451E+01_JPRB, 0.108083E+01_JPRB &
  &, 0.108674E+01_JPRB, 0.109223E+01_JPRB, 0.109729E+01_JPRB, 0.110193E+01_JPRB &
  &, 0.110613E+01_JPRB, 0.110989E+01_JPRB, 0.111322E+01_JPRB &
  &, 0.111609E+01_JPRB, 0.111852E+01_JPRB, 0.112049E+01_JPRB, 0.112201E+01_JPRB &
  &, 0.112307E+01_JPRB, 0.112367E+01_JPRB, 0.112380E+01_JPRB &
  &, 0.112348E+01_JPRB, 0.112268E+01_JPRB, 0.112142E+01_JPRB, 0.111969E+01_JPRB &
  &, 0.111750E+01_JPRB, 0.111484E+01_JPRB, 0.111172E+01_JPRB &
  &, 0.110813E+01_JPRB, 0.110409E+01_JPRB, 0.109959E+01_JPRB, 0.109463E+01_JPRB &
  &, 0.108922E+01_JPRB, 0.108337E+01_JPRB, 0.107708E+01_JPRB &
  &, 0.107036E+01_JPRB, 0.106320E+01_JPRB, 0.105564E+01_JPRB, 0.104764E+01_JPRB &
  &, 0.103926E+01_JPRB, 0.103047E+01_JPRB, 0.102129E+01_JPRB &
  &, 0.101174E+01_JPRB, 0.100182E+01_JPRB, 0.991541E+00_JPRB, 0.980906E+00_JPRB &
  &, 0.969950E+00_JPRB, 0.958662E+00_JPRB, 0.947059E+00_JPRB &
  &, 0.935172E+00_JPRB, 0.922982E+00_JPRB, 0.910538E+00_JPRB, 0.897825E+00_JPRB &
  &, 0.884853E+00_JPRB, 0.871664E+00_JPRB, 0.858259E+00_JPRB &
  &, 0.844654E+00_JPRB, 0.830848E+00_JPRB, 0.816875E+00_JPRB, 0.802752E+00_JPRB &
  &, 0.788466E+00_JPRB, 0.774068E+00_JPRB, 0.759543E+00_JPRB &
  &, 0.744929E+00_JPRB, 0.730208E+00_JPRB, 0.715438E+00_JPRB, 0.700600E+00_JPRB &
  &, 0.685733E+00_JPRB, 0.670839E+00_JPRB, 0.655917E+00_JPRB &
  &, 0.641004E+00_JPRB, 0.626122E+00_JPRB, 0.611247E+00_JPRB, 0.596439E+00_JPRB &
  &, 0.581649E+00_JPRB, 0.566964E+00_JPRB, 0.552330E+00_JPRB &
  &, 0.537811E+00_JPRB, 0.523373E+00_JPRB, 0.509055E+00_JPRB, 0.494872E+00_JPRB &
  &, 0.480836E+00_JPRB, 0.466936E+00_JPRB, 0.453180E+00_JPRB &
  &, 0.439607E+00_JPRB, 0.426199E+00_JPRB, 0.412964E+00_JPRB, 0.399939E+00_JPRB &
  &, 0.387100E+00_JPRB, 0.374454E+00_JPRB, 0.362034E+00_JPRB &
  &, 0.349844E+00_JPRB, 0.337856E+00_JPRB, 0.326102E+00_JPRB, 0.314549E+00_JPRB &
  &, 0.303260E+00_JPRB, 0.292236E+00_JPRB, 0.281403E+00_JPRB &
  &, 0.270860E+00_JPRB, 0.260531E+00_JPRB, 0.250480E+00_JPRB, 0.240662E+00_JPRB &
  &, 0.231104E+00_JPRB, 0.221794E+00_JPRB, 0.212720E+00_JPRB &
  &, 0.203906E+00_JPRB, 0.195337E+00_JPRB, 0.187037E+00_JPRB, 0.178989E+00_JPRB &
  &, 0.171173E+00_JPRB, 0.163612E+00_JPRB, 0.156282E+00_JPRB &
  &, 0.149204E+00_JPRB, 0.142354E+00_JPRB, 0.135752E+00_JPRB, 0.129369E+00_JPRB &
  &, 0.123177E+00_JPRB, 0.117288E+00_JPRB, 0.111575E+00_JPRB &
  &, 0.106054E+00_JPRB, 0.100790E+00_JPRB, 0.956975E-01_JPRB, 0.907899E-01_JPRB &
  &, 0.861335E-01_JPRB, 0.816374E-01_JPRB, 0.773677E-01_JPRB &
  &, 0.732283E-01_JPRB, 0.692851E-01_JPRB, 0.654938E-01_JPRB, 0.619221E-01_JPRB &
  &, 0.584663E-01_JPRB, 0.551936E-01_JPRB, 0.520551E-01_JPRB &
  &, 0.491198E-01_JPRB, 0.462760E-01_JPRB, 0.435299E-01_JPRB, 0.410144E-01_JPRB &
  &, 0.385491E-01_JPRB, 0.362677E-01_JPRB, 0.340484E-01_JPRB/)
XCW( 656, :) = (/ &
  &  0.103719E+01_JPRB, 0.104556E+01_JPRB, 0.105355E+01_JPRB, 0.106115E+01_JPRB &
  &, 0.106835E+01_JPRB, 0.107515E+01_JPRB, 0.108155E+01_JPRB &
  &, 0.108753E+01_JPRB, 0.109309E+01_JPRB, 0.109823E+01_JPRB, 0.110294E+01_JPRB &
  &, 0.110722E+01_JPRB, 0.111106E+01_JPRB, 0.111446E+01_JPRB &
  &, 0.111742E+01_JPRB, 0.111992E+01_JPRB, 0.112197E+01_JPRB, 0.112356E+01_JPRB &
  &, 0.112470E+01_JPRB, 0.112537E+01_JPRB, 0.112558E+01_JPRB &
  &, 0.112533E+01_JPRB, 0.112461E+01_JPRB, 0.112343E+01_JPRB, 0.112177E+01_JPRB &
  &, 0.111965E+01_JPRB, 0.111707E+01_JPRB, 0.111401E+01_JPRB &
  &, 0.111050E+01_JPRB, 0.110653E+01_JPRB, 0.110209E+01_JPRB, 0.109721E+01_JPRB &
  &, 0.109187E+01_JPRB, 0.108609E+01_JPRB, 0.107986E+01_JPRB &
  &, 0.107319E+01_JPRB, 0.106611E+01_JPRB, 0.105860E+01_JPRB, 0.105067E+01_JPRB &
  &, 0.104234E+01_JPRB, 0.103361E+01_JPRB, 0.102449E+01_JPRB &
  &, 0.101499E+01_JPRB, 0.100511E+01_JPRB, 0.994892E+00_JPRB, 0.984304E+00_JPRB &
  &, 0.973395E+00_JPRB, 0.962155E+00_JPRB, 0.950599E+00_JPRB &
  &, 0.938746E+00_JPRB, 0.926603E+00_JPRB, 0.914177E+00_JPRB, 0.901509E+00_JPRB &
  &, 0.888582E+00_JPRB, 0.875422E+00_JPRB, 0.862030E+00_JPRB &
  &, 0.848451E+00_JPRB, 0.834670E+00_JPRB, 0.820720E+00_JPRB, 0.806603E+00_JPRB &
  &, 0.792337E+00_JPRB, 0.777957E+00_JPRB, 0.763413E+00_JPRB &
  &, 0.748830E+00_JPRB, 0.734122E+00_JPRB, 0.719362E+00_JPRB, 0.704532E+00_JPRB &
  &, 0.689652E+00_JPRB, 0.674742E+00_JPRB, 0.659819E+00_JPRB &
  &, 0.644906E+00_JPRB, 0.629998E+00_JPRB, 0.615116E+00_JPRB, 0.600276E+00_JPRB &
  &, 0.585497E+00_JPRB, 0.570773E+00_JPRB, 0.556121E+00_JPRB &
  &, 0.541556E+00_JPRB, 0.527119E+00_JPRB, 0.512774E+00_JPRB, 0.498560E+00_JPRB &
  &, 0.484466E+00_JPRB, 0.470528E+00_JPRB, 0.456732E+00_JPRB &
  &, 0.443116E+00_JPRB, 0.429661E+00_JPRB, 0.416404E+00_JPRB, 0.403325E+00_JPRB &
  &, 0.390430E+00_JPRB, 0.377753E+00_JPRB, 0.365268E+00_JPRB &
  &, 0.353011E+00_JPRB, 0.340983E+00_JPRB, 0.329186E+00_JPRB, 0.317587E+00_JPRB &
  &, 0.306250E+00_JPRB, 0.295140E+00_JPRB, 0.284287E+00_JPRB &
  &, 0.273651E+00_JPRB, 0.263297E+00_JPRB, 0.253145E+00_JPRB, 0.243296E+00_JPRB &
  &, 0.233667E+00_JPRB, 0.224283E+00_JPRB, 0.215171E+00_JPRB &
  &, 0.206316E+00_JPRB, 0.197664E+00_JPRB, 0.189319E+00_JPRB, 0.181181E+00_JPRB &
  &, 0.173314E+00_JPRB, 0.165699E+00_JPRB, 0.158314E+00_JPRB &
  &, 0.151178E+00_JPRB, 0.144268E+00_JPRB, 0.137602E+00_JPRB, 0.131154E+00_JPRB &
  &, 0.124941E+00_JPRB, 0.118934E+00_JPRB, 0.113147E+00_JPRB &
  &, 0.107600E+00_JPRB, 0.102257E+00_JPRB, 0.971349E-01_JPRB, 0.921961E-01_JPRB &
  &, 0.874545E-01_JPRB, 0.829238E-01_JPRB, 0.785637E-01_JPRB &
  &, 0.744413E-01_JPRB, 0.704593E-01_JPRB, 0.666277E-01_JPRB, 0.629568E-01_JPRB &
  &, 0.595153E-01_JPRB, 0.561980E-01_JPRB, 0.530133E-01_JPRB &
  &, 0.499697E-01_JPRB, 0.471373E-01_JPRB, 0.443404E-01_JPRB, 0.417726E-01_JPRB &
  &, 0.393173E-01_JPRB, 0.369163E-01_JPRB, 0.347055E-01_JPRB/)
XCW( 657, :) = (/ &
  &  0.103747E+01_JPRB, 0.104591E+01_JPRB, 0.105397E+01_JPRB, 0.106165E+01_JPRB &
  &, 0.106892E+01_JPRB, 0.107580E+01_JPRB, 0.108227E+01_JPRB &
  &, 0.108832E+01_JPRB, 0.109396E+01_JPRB, 0.109918E+01_JPRB, 0.110396E+01_JPRB &
  &, 0.110832E+01_JPRB, 0.111224E+01_JPRB, 0.111571E+01_JPRB &
  &, 0.111874E+01_JPRB, 0.112132E+01_JPRB, 0.112345E+01_JPRB, 0.112512E+01_JPRB &
  &, 0.112633E+01_JPRB, 0.112708E+01_JPRB, 0.112737E+01_JPRB &
  &, 0.112719E+01_JPRB, 0.112655E+01_JPRB, 0.112544E+01_JPRB, 0.112386E+01_JPRB &
  &, 0.112181E+01_JPRB, 0.111930E+01_JPRB, 0.111629E+01_JPRB &
  &, 0.111288E+01_JPRB, 0.110897E+01_JPRB, 0.110461E+01_JPRB, 0.109979E+01_JPRB &
  &, 0.109452E+01_JPRB, 0.108880E+01_JPRB, 0.108265E+01_JPRB &
  &, 0.107605E+01_JPRB, 0.106902E+01_JPRB, 0.106157E+01_JPRB, 0.105371E+01_JPRB &
  &, 0.104543E+01_JPRB, 0.103676E+01_JPRB, 0.102770E+01_JPRB &
  &, 0.101825E+01_JPRB, 0.100843E+01_JPRB, 0.998254E+00_JPRB, 0.987726E+00_JPRB &
  &, 0.976853E+00_JPRB, 0.965661E+00_JPRB, 0.954153E+00_JPRB &
  &, 0.942333E+00_JPRB, 0.930223E+00_JPRB, 0.917844E+00_JPRB, 0.905207E+00_JPRB &
  &, 0.892310E+00_JPRB, 0.879180E+00_JPRB, 0.865831E+00_JPRB &
  &, 0.852263E+00_JPRB, 0.838507E+00_JPRB, 0.824581E+00_JPRB, 0.810487E+00_JPRB &
  &, 0.796241E+00_JPRB, 0.781863E+00_JPRB, 0.767353E+00_JPRB &
  &, 0.752750E+00_JPRB, 0.738054E+00_JPRB, 0.723286E+00_JPRB, 0.708465E+00_JPRB &
  &, 0.693591E+00_JPRB, 0.678684E+00_JPRB, 0.663743E+00_JPRB &
  &, 0.648828E+00_JPRB, 0.633895E+00_JPRB, 0.619006E+00_JPRB, 0.604157E+00_JPRB &
  &, 0.589344E+00_JPRB, 0.574606E+00_JPRB, 0.559936E+00_JPRB &
  &, 0.545350E+00_JPRB, 0.530864E+00_JPRB, 0.516493E+00_JPRB, 0.502249E+00_JPRB &
  &, 0.488122E+00_JPRB, 0.474148E+00_JPRB, 0.460339E+00_JPRB &
  &, 0.446680E+00_JPRB, 0.433179E+00_JPRB, 0.419873E+00_JPRB, 0.406741E+00_JPRB &
  &, 0.393819E+00_JPRB, 0.381082E+00_JPRB, 0.368565E+00_JPRB &
  &, 0.356241E+00_JPRB, 0.344142E+00_JPRB, 0.332303E+00_JPRB, 0.320659E+00_JPRB &
  &, 0.309240E+00_JPRB, 0.298078E+00_JPRB, 0.287171E+00_JPRB &
  &, 0.276477E+00_JPRB, 0.266062E+00_JPRB, 0.255883E+00_JPRB, 0.245930E+00_JPRB &
  &, 0.236268E+00_JPRB, 0.226811E+00_JPRB, 0.217621E+00_JPRB &
  &, 0.208687E+00_JPRB, 0.200032E+00_JPRB, 0.191601E+00_JPRB, 0.183415E+00_JPRB &
  &, 0.175498E+00_JPRB, 0.167787E+00_JPRB, 0.160346E+00_JPRB &
  &, 0.153153E+00_JPRB, 0.146182E+00_JPRB, 0.139453E+00_JPRB, 0.132939E+00_JPRB &
  &, 0.126658E+00_JPRB, 0.120628E+00_JPRB, 0.114818E+00_JPRB &
  &, 0.109195E+00_JPRB, 0.103826E+00_JPRB, 0.986236E-01_JPRB, 0.936544E-01_JPRB &
  &, 0.888282E-01_JPRB, 0.842637E-01_JPRB, 0.798684E-01_JPRB &
  &, 0.756542E-01_JPRB, 0.715775E-01_JPRB, 0.677616E-01_JPRB, 0.640491E-01_JPRB &
  &, 0.605061E-01_JPRB, 0.571434E-01_JPRB, 0.539716E-01_JPRB &
  &, 0.508802E-01_JPRB, 0.479986E-01_JPRB, 0.452133E-01_JPRB, 0.425308E-01_JPRB &
  &, 0.400215E-01_JPRB, 0.376947E-01_JPRB, 0.354283E-01_JPRB/)
XCW( 658, :) = (/ &
  &  0.103775E+01_JPRB, 0.104626E+01_JPRB, 0.105440E+01_JPRB, 0.106214E+01_JPRB &
  &, 0.106949E+01_JPRB, 0.107644E+01_JPRB, 0.108299E+01_JPRB &
  &, 0.108912E+01_JPRB, 0.109483E+01_JPRB, 0.110012E+01_JPRB, 0.110499E+01_JPRB &
  &, 0.110942E+01_JPRB, 0.111341E+01_JPRB, 0.111696E+01_JPRB &
  &, 0.112007E+01_JPRB, 0.112273E+01_JPRB, 0.112493E+01_JPRB, 0.112668E+01_JPRB &
  &, 0.112797E+01_JPRB, 0.112879E+01_JPRB, 0.112915E+01_JPRB &
  &, 0.112905E+01_JPRB, 0.112848E+01_JPRB, 0.112745E+01_JPRB, 0.112594E+01_JPRB &
  &, 0.112397E+01_JPRB, 0.112153E+01_JPRB, 0.111862E+01_JPRB &
  &, 0.111525E+01_JPRB, 0.111142E+01_JPRB, 0.110713E+01_JPRB, 0.110238E+01_JPRB &
  &, 0.109718E+01_JPRB, 0.109153E+01_JPRB, 0.108543E+01_JPRB &
  &, 0.107890E+01_JPRB, 0.107194E+01_JPRB, 0.106456E+01_JPRB, 0.105675E+01_JPRB &
  &, 0.104853E+01_JPRB, 0.103992E+01_JPRB, 0.103091E+01_JPRB &
  &, 0.102151E+01_JPRB, 0.101175E+01_JPRB, 0.100163E+01_JPRB, 0.991149E+00_JPRB &
  &, 0.980323E+00_JPRB, 0.969179E+00_JPRB, 0.957706E+00_JPRB &
  &, 0.945933E+00_JPRB, 0.933870E+00_JPRB, 0.921524E+00_JPRB, 0.908919E+00_JPRB &
  &, 0.896053E+00_JPRB, 0.882952E+00_JPRB, 0.869632E+00_JPRB &
  &, 0.856091E+00_JPRB, 0.842361E+00_JPRB, 0.828459E+00_JPRB, 0.814370E+00_JPRB &
  &, 0.800145E+00_JPRB, 0.785786E+00_JPRB, 0.771294E+00_JPRB &
  &, 0.756688E+00_JPRB, 0.742005E+00_JPRB, 0.727248E+00_JPRB, 0.712416E+00_JPRB &
  &, 0.697529E+00_JPRB, 0.682627E+00_JPRB, 0.667687E+00_JPRB &
  &, 0.652750E+00_JPRB, 0.637836E+00_JPRB, 0.622919E+00_JPRB, 0.608039E+00_JPRB &
  &, 0.593214E+00_JPRB, 0.578461E+00_JPRB, 0.563774E+00_JPRB &
  &, 0.549169E+00_JPRB, 0.534660E+00_JPRB, 0.520237E+00_JPRB, 0.505964E+00_JPRB &
  &, 0.491804E+00_JPRB, 0.477794E+00_JPRB, 0.463946E+00_JPRB &
  &, 0.450245E+00_JPRB, 0.436698E+00_JPRB, 0.423342E+00_JPRB, 0.410187E+00_JPRB &
  &, 0.397208E+00_JPRB, 0.384411E+00_JPRB, 0.371862E+00_JPRB &
  &, 0.359502E+00_JPRB, 0.347333E+00_JPRB, 0.335420E+00_JPRB, 0.323731E+00_JPRB &
  &, 0.312298E+00_JPRB, 0.301051E+00_JPRB, 0.290090E+00_JPRB &
  &, 0.279339E+00_JPRB, 0.268864E+00_JPRB, 0.258621E+00_JPRB, 0.248601E+00_JPRB &
  &, 0.238870E+00_JPRB, 0.229378E+00_JPRB, 0.220151E+00_JPRB &
  &, 0.211138E+00_JPRB, 0.202400E+00_JPRB, 0.193924E+00_JPRB, 0.185649E+00_JPRB &
  &, 0.177682E+00_JPRB, 0.169919E+00_JPRB, 0.162423E+00_JPRB &
  &, 0.155172E+00_JPRB, 0.148141E+00_JPRB, 0.141350E+00_JPRB, 0.134771E+00_JPRB &
  &, 0.128470E+00_JPRB, 0.122322E+00_JPRB, 0.116439E+00_JPRB &
  &, 0.110791E+00_JPRB, 0.105343E+00_JPRB, 0.100112E+00_JPRB, 0.950606E-01_JPRB &
  &, 0.902548E-01_JPRB, 0.856036E-01_JPRB, 0.811187E-01_JPRB &
  &, 0.768672E-01_JPRB, 0.728076E-01_JPRB, 0.688956E-01_JPRB, 0.651413E-01_JPRB &
  &, 0.615552E-01_JPRB, 0.581478E-01_JPRB, 0.549298E-01_JPRB &
  &, 0.517908E-01_JPRB, 0.488600E-01_JPRB, 0.460239E-01_JPRB, 0.433521E-01_JPRB &
  &, 0.407897E-01_JPRB, 0.384082E-01_JPRB, 0.360854E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART94',1,ZHOOK_HANDLE)
END SUBROUTINE PART94

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART95

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART95',0,ZHOOK_HANDLE)

XCW( 659, :) = (/ &
  &  0.103803E+01_JPRB, 0.104661E+01_JPRB, 0.105482E+01_JPRB, 0.106264E+01_JPRB &
  &, 0.107006E+01_JPRB, 0.107709E+01_JPRB, 0.108371E+01_JPRB &
  &, 0.108991E+01_JPRB, 0.109570E+01_JPRB, 0.110107E+01_JPRB, 0.110601E+01_JPRB &
  &, 0.111052E+01_JPRB, 0.111459E+01_JPRB, 0.111822E+01_JPRB &
  &, 0.112140E+01_JPRB, 0.112413E+01_JPRB, 0.112642E+01_JPRB, 0.112824E+01_JPRB &
  &, 0.112960E+01_JPRB, 0.113051E+01_JPRB, 0.113095E+01_JPRB &
  &, 0.113092E+01_JPRB, 0.113043E+01_JPRB, 0.112947E+01_JPRB, 0.112804E+01_JPRB &
  &, 0.112614E+01_JPRB, 0.112377E+01_JPRB, 0.112094E+01_JPRB &
  &, 0.111764E+01_JPRB, 0.111388E+01_JPRB, 0.110966E+01_JPRB, 0.110498E+01_JPRB &
  &, 0.109984E+01_JPRB, 0.109426E+01_JPRB, 0.108823E+01_JPRB &
  &, 0.108177E+01_JPRB, 0.107487E+01_JPRB, 0.106755E+01_JPRB, 0.105980E+01_JPRB &
  &, 0.105165E+01_JPRB, 0.104309E+01_JPRB, 0.103414E+01_JPRB &
  &, 0.102480E+01_JPRB, 0.101509E+01_JPRB, 0.100501E+01_JPRB, 0.994583E+00_JPRB &
  &, 0.983806E+00_JPRB, 0.972710E+00_JPRB, 0.961284E+00_JPRB &
  &, 0.949547E+00_JPRB, 0.937517E+00_JPRB, 0.925218E+00_JPRB, 0.912645E+00_JPRB &
  &, 0.899810E+00_JPRB, 0.886739E+00_JPRB, 0.873447E+00_JPRB &
  &, 0.859934E+00_JPRB, 0.846230E+00_JPRB, 0.832353E+00_JPRB, 0.818287E+00_JPRB &
  &, 0.804067E+00_JPRB, 0.789727E+00_JPRB, 0.775252E+00_JPRB &
  &, 0.760662E+00_JPRB, 0.745975E+00_JPRB, 0.731210E+00_JPRB, 0.716387E+00_JPRB &
  &, 0.701507E+00_JPRB, 0.686589E+00_JPRB, 0.671652E+00_JPRB &
  &, 0.656715E+00_JPRB, 0.641776E+00_JPRB, 0.626854E+00_JPRB, 0.611966E+00_JPRB &
  &, 0.597130E+00_JPRB, 0.582340E+00_JPRB, 0.567613E+00_JPRB &
  &, 0.552987E+00_JPRB, 0.538456E+00_JPRB, 0.524032E+00_JPRB, 0.509705E+00_JPRB &
  &, 0.495512E+00_JPRB, 0.481467E+00_JPRB, 0.467581E+00_JPRB &
  &, 0.453837E+00_JPRB, 0.440273E+00_JPRB, 0.426869E+00_JPRB, 0.413632E+00_JPRB &
  &, 0.400627E+00_JPRB, 0.387802E+00_JPRB, 0.375159E+00_JPRB &
  &, 0.362764E+00_JPRB, 0.350557E+00_JPRB, 0.338603E+00_JPRB, 0.326870E+00_JPRB &
  &, 0.315356E+00_JPRB, 0.304059E+00_JPRB, 0.293044E+00_JPRB &
  &, 0.282237E+00_JPRB, 0.271665E+00_JPRB, 0.261359E+00_JPRB, 0.251310E+00_JPRB &
  &, 0.241509E+00_JPRB, 0.231944E+00_JPRB, 0.222642E+00_JPRB &
  &, 0.213588E+00_JPRB, 0.204809E+00_JPRB, 0.196247E+00_JPRB, 0.187925E+00_JPRB &
  &, 0.179866E+00_JPRB, 0.172094E+00_JPRB, 0.164499E+00_JPRB &
  &, 0.157191E+00_JPRB, 0.150100E+00_JPRB, 0.143247E+00_JPRB, 0.136650E+00_JPRB &
  &, 0.130234E+00_JPRB, 0.124064E+00_JPRB, 0.118158E+00_JPRB &
  &, 0.112436E+00_JPRB, 0.106912E+00_JPRB, 0.101601E+00_JPRB, 0.965189E-01_JPRB &
  &, 0.916285E-01_JPRB, 0.869435E-01_JPRB, 0.824234E-01_JPRB &
  &, 0.781353E-01_JPRB, 0.739817E-01_JPRB, 0.700295E-01_JPRB, 0.662335E-01_JPRB &
  &, 0.626625E-01_JPRB, 0.592113E-01_JPRB, 0.558881E-01_JPRB &
  &, 0.527621E-01_JPRB, 0.497828E-01_JPRB, 0.468968E-01_JPRB, 0.441735E-01_JPRB &
  &, 0.416219E-01_JPRB, 0.391216E-01_JPRB, 0.368082E-01_JPRB/)
XCW( 660, :) = (/ &
  &  0.103831E+01_JPRB, 0.104697E+01_JPRB, 0.105525E+01_JPRB, 0.106314E+01_JPRB &
  &, 0.107063E+01_JPRB, 0.107773E+01_JPRB, 0.108443E+01_JPRB &
  &, 0.109071E+01_JPRB, 0.109658E+01_JPRB, 0.110202E+01_JPRB, 0.110703E+01_JPRB &
  &, 0.111162E+01_JPRB, 0.111577E+01_JPRB, 0.111947E+01_JPRB &
  &, 0.112273E+01_JPRB, 0.112554E+01_JPRB, 0.112790E+01_JPRB, 0.112980E+01_JPRB &
  &, 0.113125E+01_JPRB, 0.113223E+01_JPRB, 0.113274E+01_JPRB &
  &, 0.113279E+01_JPRB, 0.113237E+01_JPRB, 0.113149E+01_JPRB, 0.113013E+01_JPRB &
  &, 0.112831E+01_JPRB, 0.112602E+01_JPRB, 0.112326E+01_JPRB &
  &, 0.112003E+01_JPRB, 0.111634E+01_JPRB, 0.111219E+01_JPRB, 0.110758E+01_JPRB &
  &, 0.110251E+01_JPRB, 0.109700E+01_JPRB, 0.109104E+01_JPRB &
  &, 0.108463E+01_JPRB, 0.107780E+01_JPRB, 0.107054E+01_JPRB, 0.106286E+01_JPRB &
  &, 0.105477E+01_JPRB, 0.104626E+01_JPRB, 0.103737E+01_JPRB &
  &, 0.102809E+01_JPRB, 0.101844E+01_JPRB, 0.100841E+01_JPRB, 0.998029E+00_JPRB &
  &, 0.987300E+00_JPRB, 0.976240E+00_JPRB, 0.964863E+00_JPRB &
  &, 0.953174E+00_JPRB, 0.941192E+00_JPRB, 0.928926E+00_JPRB, 0.916386E+00_JPRB &
  &, 0.903596E+00_JPRB, 0.890556E+00_JPRB, 0.877278E+00_JPRB &
  &, 0.863808E+00_JPRB, 0.850115E+00_JPRB, 0.836247E+00_JPRB, 0.822221E+00_JPRB &
  &, 0.808022E+00_JPRB, 0.793685E+00_JPRB, 0.779211E+00_JPRB &
  &, 0.764636E+00_JPRB, 0.749963E+00_JPRB, 0.735210E+00_JPRB, 0.720320E+00_JPRB &
  &, 0.705505E+00_JPRB, 0.690592E+00_JPRB, 0.675658E+00_JPRB &
  &, 0.660701E+00_JPRB, 0.645738E+00_JPRB, 0.630811E+00_JPRB, 0.615915E+00_JPRB &
  &, 0.601046E+00_JPRB, 0.586243E+00_JPRB, 0.571499E+00_JPRB &
  &, 0.556854E+00_JPRB, 0.542276E+00_JPRB, 0.527827E+00_JPRB, 0.513471E+00_JPRB &
  &, 0.499247E+00_JPRB, 0.485167E+00_JPRB, 0.471242E+00_JPRB &
  &, 0.457457E+00_JPRB, 0.443848E+00_JPRB, 0.430396E+00_JPRB, 0.417136E+00_JPRB &
  &, 0.404076E+00_JPRB, 0.391192E+00_JPRB, 0.378518E+00_JPRB &
  &, 0.366057E+00_JPRB, 0.353812E+00_JPRB, 0.341785E+00_JPRB, 0.329975E+00_JPRB &
  &, 0.318414E+00_JPRB, 0.307101E+00_JPRB, 0.295998E+00_JPRB &
  &, 0.285134E+00_JPRB, 0.274540E+00_JPRB, 0.264171E+00_JPRB, 0.254057E+00_JPRB &
  &, 0.244187E+00_JPRB, 0.234550E+00_JPRB, 0.225211E+00_JPRB &
  &, 0.216079E+00_JPRB, 0.207218E+00_JPRB, 0.198612E+00_JPRB, 0.190244E+00_JPRB &
  &, 0.182136E+00_JPRB, 0.174269E+00_JPRB, 0.166620E+00_JPRB &
  &, 0.159255E+00_JPRB, 0.152105E+00_JPRB, 0.145190E+00_JPRB, 0.138482E+00_JPRB &
  &, 0.132046E+00_JPRB, 0.125855E+00_JPRB, 0.119829E+00_JPRB &
  &, 0.114081E+00_JPRB, 0.108480E+00_JPRB, 0.103141E+00_JPRB, 0.980293E-01_JPRB &
  &, 0.930551E-01_JPRB, 0.883370E-01_JPRB, 0.837825E-01_JPRB &
  &, 0.794034E-01_JPRB, 0.752118E-01_JPRB, 0.712201E-01_JPRB, 0.673832E-01_JPRB &
  &, 0.637116E-01_JPRB, 0.602157E-01_JPRB, 0.569062E-01_JPRB &
  &, 0.536726E-01_JPRB, 0.506442E-01_JPRB, 0.477697E-01_JPRB, 0.449948E-01_JPRB &
  &, 0.423902E-01_JPRB, 0.399000E-01_JPRB, 0.375311E-01_JPRB/)
XCW( 661, :) = (/ &
  &  0.103859E+01_JPRB, 0.104732E+01_JPRB, 0.105567E+01_JPRB, 0.106363E+01_JPRB &
  &, 0.107121E+01_JPRB, 0.107838E+01_JPRB, 0.108515E+01_JPRB &
  &, 0.109151E+01_JPRB, 0.109745E+01_JPRB, 0.110297E+01_JPRB, 0.110806E+01_JPRB &
  &, 0.111272E+01_JPRB, 0.111695E+01_JPRB, 0.112073E+01_JPRB &
  &, 0.112407E+01_JPRB, 0.112696E+01_JPRB, 0.112939E+01_JPRB, 0.113137E+01_JPRB &
  &, 0.113289E+01_JPRB, 0.113395E+01_JPRB, 0.113454E+01_JPRB &
  &, 0.113467E+01_JPRB, 0.113433E+01_JPRB, 0.113352E+01_JPRB, 0.113224E+01_JPRB &
  &, 0.113049E+01_JPRB, 0.112827E+01_JPRB, 0.112558E+01_JPRB &
  &, 0.112242E+01_JPRB, 0.111881E+01_JPRB, 0.111473E+01_JPRB, 0.111019E+01_JPRB &
  &, 0.110519E+01_JPRB, 0.109975E+01_JPRB, 0.109386E+01_JPRB &
  &, 0.108752E+01_JPRB, 0.108075E+01_JPRB, 0.107355E+01_JPRB, 0.106593E+01_JPRB &
  &, 0.105789E+01_JPRB, 0.104946E+01_JPRB, 0.104062E+01_JPRB &
  &, 0.103139E+01_JPRB, 0.102179E+01_JPRB, 0.101182E+01_JPRB, 0.100149E+01_JPRB &
  &, 0.990807E+00_JPRB, 0.979796E+00_JPRB, 0.968468E+00_JPRB &
  &, 0.956813E+00_JPRB, 0.944879E+00_JPRB, 0.932647E+00_JPRB, 0.920140E+00_JPRB &
  &, 0.907382E+00_JPRB, 0.894373E+00_JPRB, 0.881140E+00_JPRB &
  &, 0.867683E+00_JPRB, 0.854032E+00_JPRB, 0.840173E+00_JPRB, 0.826154E+00_JPRB &
  &, 0.811977E+00_JPRB, 0.797660E+00_JPRB, 0.783204E+00_JPRB &
  &, 0.768647E+00_JPRB, 0.753969E+00_JPRB, 0.739229E+00_JPRB, 0.724407E+00_JPRB &
  &, 0.709523E+00_JPRB, 0.694596E+00_JPRB, 0.679664E+00_JPRB &
  &, 0.664686E+00_JPRB, 0.649743E+00_JPRB, 0.634790E+00_JPRB, 0.619864E+00_JPRB &
  &, 0.604985E+00_JPRB, 0.590169E+00_JPRB, 0.575409E+00_JPRB &
  &, 0.560722E+00_JPRB, 0.546121E+00_JPRB, 0.531647E+00_JPRB, 0.517263E+00_JPRB &
  &, 0.503008E+00_JPRB, 0.488893E+00_JPRB, 0.474931E+00_JPRB &
  &, 0.461105E+00_JPRB, 0.447452E+00_JPRB, 0.433952E+00_JPRB, 0.420670E+00_JPRB &
  &, 0.407526E+00_JPRB, 0.394613E+00_JPRB, 0.381908E+00_JPRB &
  &, 0.369382E+00_JPRB, 0.357100E+00_JPRB, 0.345001E+00_JPRB, 0.333147E+00_JPRB &
  &, 0.321540E+00_JPRB, 0.310144E+00_JPRB, 0.298988E+00_JPRB &
  &, 0.288068E+00_JPRB, 0.277414E+00_JPRB, 0.266983E+00_JPRB, 0.256803E+00_JPRB &
  &, 0.246865E+00_JPRB, 0.237194E+00_JPRB, 0.227781E+00_JPRB &
  &, 0.218610E+00_JPRB, 0.209668E+00_JPRB, 0.200977E+00_JPRB, 0.192562E+00_JPRB &
  &, 0.184406E+00_JPRB, 0.176444E+00_JPRB, 0.168785E+00_JPRB &
  &, 0.161319E+00_JPRB, 0.154110E+00_JPRB, 0.147133E+00_JPRB, 0.140408E+00_JPRB &
  &, 0.133906E+00_JPRB, 0.127598E+00_JPRB, 0.121548E+00_JPRB &
  &, 0.115726E+00_JPRB, 0.110099E+00_JPRB, 0.104681E+00_JPRB, 0.994876E-01_JPRB &
  &, 0.945345E-01_JPRB, 0.897305E-01_JPRB, 0.850872E-01_JPRB &
  &, 0.806715E-01_JPRB, 0.764419E-01_JPRB, 0.724107E-01_JPRB, 0.685329E-01_JPRB &
  &, 0.648189E-01_JPRB, 0.612792E-01_JPRB, 0.579243E-01_JPRB &
  &, 0.546439E-01_JPRB, 0.515670E-01_JPRB, 0.486426E-01_JPRB, 0.458793E-01_JPRB &
  &, 0.432224E-01_JPRB, 0.406783E-01_JPRB, 0.382539E-01_JPRB/)
XCW( 662, :) = (/ &
  &  0.103887E+01_JPRB, 0.104767E+01_JPRB, 0.105610E+01_JPRB, 0.106413E+01_JPRB &
  &, 0.107178E+01_JPRB, 0.107903E+01_JPRB, 0.108587E+01_JPRB &
  &, 0.109231E+01_JPRB, 0.109832E+01_JPRB, 0.110392E+01_JPRB, 0.110909E+01_JPRB &
  &, 0.111382E+01_JPRB, 0.111813E+01_JPRB, 0.112199E+01_JPRB &
  &, 0.112541E+01_JPRB, 0.112837E+01_JPRB, 0.113089E+01_JPRB, 0.113294E+01_JPRB &
  &, 0.113454E+01_JPRB, 0.113568E+01_JPRB, 0.113634E+01_JPRB &
  &, 0.113655E+01_JPRB, 0.113628E+01_JPRB, 0.113555E+01_JPRB, 0.113434E+01_JPRB &
  &, 0.113267E+01_JPRB, 0.113053E+01_JPRB, 0.112791E+01_JPRB &
  &, 0.112483E+01_JPRB, 0.112127E+01_JPRB, 0.111728E+01_JPRB, 0.111281E+01_JPRB &
  &, 0.110788E+01_JPRB, 0.110250E+01_JPRB, 0.109668E+01_JPRB &
  &, 0.109041E+01_JPRB, 0.108371E+01_JPRB, 0.107657E+01_JPRB, 0.106901E+01_JPRB &
  &, 0.106104E+01_JPRB, 0.105266E+01_JPRB, 0.104388E+01_JPRB &
  &, 0.103470E+01_JPRB, 0.102516E+01_JPRB, 0.101524E+01_JPRB, 0.100496E+01_JPRB &
  &, 0.994339E+00_JPRB, 0.983364E+00_JPRB, 0.971982E+00_JPRB &
  &, 0.960479E+00_JPRB, 0.948567E+00_JPRB, 0.936383E+00_JPRB, 0.923908E+00_JPRB &
  &, 0.911183E+00_JPRB, 0.898219E+00_JPRB, 0.885001E+00_JPRB &
  &, 0.871572E+00_JPRB, 0.857949E+00_JPRB, 0.844132E+00_JPRB, 0.830121E+00_JPRB &
  &, 0.815966E+00_JPRB, 0.801653E+00_JPRB, 0.787216E+00_JPRB &
  &, 0.772657E+00_JPRB, 0.758013E+00_JPRB, 0.743267E+00_JPRB, 0.728436E+00_JPRB &
  &, 0.713561E+00_JPRB, 0.698639E+00_JPRB, 0.683691E+00_JPRB &
  &, 0.668714E+00_JPRB, 0.653748E+00_JPRB, 0.638790E+00_JPRB, 0.623858E+00_JPRB &
  &, 0.608969E+00_JPRB, 0.594118E+00_JPRB, 0.579343E+00_JPRB &
  &, 0.564637E+00_JPRB, 0.550016E+00_JPRB, 0.535493E+00_JPRB, 0.521081E+00_JPRB &
  &, 0.506795E+00_JPRB, 0.492647E+00_JPRB, 0.478648E+00_JPRB &
  &, 0.464781E+00_JPRB, 0.451084E+00_JPRB, 0.437565E+00_JPRB, 0.424204E+00_JPRB &
  &, 0.411035E+00_JPRB, 0.398065E+00_JPRB, 0.385298E+00_JPRB &
  &, 0.372738E+00_JPRB, 0.360388E+00_JPRB, 0.348249E+00_JPRB, 0.336353E+00_JPRB &
  &, 0.324666E+00_JPRB, 0.313220E+00_JPRB, 0.302012E+00_JPRB &
  &, 0.291037E+00_JPRB, 0.280325E+00_JPRB, 0.269833E+00_JPRB, 0.259588E+00_JPRB &
  &, 0.249619E+00_JPRB, 0.239878E+00_JPRB, 0.230390E+00_JPRB &
  &, 0.221141E+00_JPRB, 0.212158E+00_JPRB, 0.203425E+00_JPRB, 0.194923E+00_JPRB &
  &, 0.186675E+00_JPRB, 0.178662E+00_JPRB, 0.170950E+00_JPRB &
  &, 0.163428E+00_JPRB, 0.156160E+00_JPRB, 0.149122E+00_JPRB, 0.142333E+00_JPRB &
  &, 0.135766E+00_JPRB, 0.129437E+00_JPRB, 0.123317E+00_JPRB &
  &, 0.117422E+00_JPRB, 0.111769E+00_JPRB, 0.106272E+00_JPRB, 0.101050E+00_JPRB &
  &, 0.959611E-01_JPRB, 0.911240E-01_JPRB, 0.864462E-01_JPRB &
  &, 0.819947E-01_JPRB, 0.777279E-01_JPRB, 0.736013E-01_JPRB, 0.696827E-01_JPRB &
  &, 0.659263E-01_JPRB, 0.623427E-01_JPRB, 0.589425E-01_JPRB &
  &, 0.556759E-01_JPRB, 0.525514E-01_JPRB, 0.495778E-01_JPRB, 0.467007E-01_JPRB &
  &, 0.440546E-01_JPRB, 0.414567E-01_JPRB, 0.390424E-01_JPRB/)
XCW( 663, :) = (/ &
  &  0.103915E+01_JPRB, 0.104803E+01_JPRB, 0.105652E+01_JPRB, 0.106463E+01_JPRB &
  &, 0.107236E+01_JPRB, 0.107968E+01_JPRB, 0.108660E+01_JPRB &
  &, 0.109311E+01_JPRB, 0.109920E+01_JPRB, 0.110487E+01_JPRB, 0.111012E+01_JPRB &
  &, 0.111494E+01_JPRB, 0.111932E+01_JPRB, 0.112325E+01_JPRB &
  &, 0.112675E+01_JPRB, 0.112979E+01_JPRB, 0.113238E+01_JPRB, 0.113452E+01_JPRB &
  &, 0.113619E+01_JPRB, 0.113740E+01_JPRB, 0.113815E+01_JPRB &
  &, 0.113843E+01_JPRB, 0.113824E+01_JPRB, 0.113759E+01_JPRB, 0.113646E+01_JPRB &
  &, 0.113486E+01_JPRB, 0.113279E+01_JPRB, 0.113025E+01_JPRB &
  &, 0.112725E+01_JPRB, 0.112377E+01_JPRB, 0.111983E+01_JPRB, 0.111543E+01_JPRB &
  &, 0.111058E+01_JPRB, 0.110527E+01_JPRB, 0.109951E+01_JPRB &
  &, 0.109330E+01_JPRB, 0.108666E+01_JPRB, 0.107959E+01_JPRB, 0.107210E+01_JPRB &
  &, 0.106419E+01_JPRB, 0.105586E+01_JPRB, 0.104714E+01_JPRB &
  &, 0.103804E+01_JPRB, 0.102854E+01_JPRB, 0.101867E+01_JPRB, 0.100844E+01_JPRB &
  &, 0.997870E+00_JPRB, 0.986945E+00_JPRB, 0.975702E+00_JPRB &
  &, 0.964145E+00_JPRB, 0.952282E+00_JPRB, 0.940132E+00_JPRB, 0.927705E+00_JPRB &
  &, 0.915013E+00_JPRB, 0.902066E+00_JPRB, 0.888893E+00_JPRB &
  &, 0.875493E+00_JPRB, 0.861882E+00_JPRB, 0.848091E+00_JPRB, 0.834104E+00_JPRB &
  &, 0.819973E+00_JPRB, 0.805680E+00_JPRB, 0.791245E+00_JPRB &
  &, 0.776704E+00_JPRB, 0.762057E+00_JPRB, 0.747305E+00_JPRB, 0.732504E+00_JPRB &
  &, 0.717618E+00_JPRB, 0.702703E+00_JPRB, 0.687738E+00_JPRB &
  &, 0.672763E+00_JPRB, 0.657775E+00_JPRB, 0.642813E+00_JPRB, 0.627852E+00_JPRB &
  &, 0.612954E+00_JPRB, 0.598090E+00_JPRB, 0.583277E+00_JPRB &
  &, 0.568553E+00_JPRB, 0.553911E+00_JPRB, 0.539363E+00_JPRB, 0.524925E+00_JPRB &
  &, 0.510609E+00_JPRB, 0.496427E+00_JPRB, 0.482364E+00_JPRB &
  &, 0.468485E+00_JPRB, 0.454744E+00_JPRB, 0.441179E+00_JPRB, 0.427767E+00_JPRB &
  &, 0.414574E+00_JPRB, 0.401547E+00_JPRB, 0.388719E+00_JPRB &
  &, 0.376126E+00_JPRB, 0.363708E+00_JPRB, 0.351530E+00_JPRB, 0.339558E+00_JPRB &
  &, 0.327826E+00_JPRB, 0.316332E+00_JPRB, 0.305072E+00_JPRB &
  &, 0.294042E+00_JPRB, 0.283236E+00_JPRB, 0.272682E+00_JPRB, 0.262410E+00_JPRB &
  &, 0.252335E+00_JPRB, 0.242561E+00_JPRB, 0.232999E+00_JPRB &
  &, 0.223713E+00_JPRB, 0.214649E+00_JPRB, 0.205831E+00_JPRB, 0.197283E+00_JPRB &
  &, 0.188988E+00_JPRB, 0.180924E+00_JPRB, 0.173115E+00_JPRB &
  &, 0.165537E+00_JPRB, 0.158211E+00_JPRB, 0.151112E+00_JPRB, 0.144259E+00_JPRB &
  &, 0.137625E+00_JPRB, 0.131228E+00_JPRB, 0.125085E+00_JPRB &
  &, 0.119117E+00_JPRB, 0.113388E+00_JPRB, 0.107864E+00_JPRB, 0.102561E+00_JPRB &
  &, 0.974405E-01_JPRB, 0.925711E-01_JPRB, 0.878596E-01_JPRB &
  &, 0.833179E-01_JPRB, 0.790138E-01_JPRB, 0.748486E-01_JPRB, 0.708899E-01_JPRB &
  &, 0.670919E-01_JPRB, 0.634652E-01_JPRB, 0.599606E-01_JPRB &
  &, 0.566472E-01_JPRB, 0.534743E-01_JPRB, 0.504507E-01_JPRB, 0.475852E-01_JPRB &
  &, 0.448869E-01_JPRB, 0.422350E-01_JPRB, 0.397652E-01_JPRB/)
XCW( 664, :) = (/ &
  &  0.103943E+01_JPRB, 0.104838E+01_JPRB, 0.105695E+01_JPRB, 0.106513E+01_JPRB &
  &, 0.107293E+01_JPRB, 0.108033E+01_JPRB, 0.108732E+01_JPRB &
  &, 0.109391E+01_JPRB, 0.110008E+01_JPRB, 0.110583E+01_JPRB, 0.111115E+01_JPRB &
  &, 0.111605E+01_JPRB, 0.112050E+01_JPRB, 0.112452E+01_JPRB &
  &, 0.112809E+01_JPRB, 0.113121E+01_JPRB, 0.113388E+01_JPRB, 0.113609E+01_JPRB &
  &, 0.113785E+01_JPRB, 0.113914E+01_JPRB, 0.113996E+01_JPRB &
  &, 0.114032E+01_JPRB, 0.114021E+01_JPRB, 0.113963E+01_JPRB, 0.113858E+01_JPRB &
  &, 0.113705E+01_JPRB, 0.113500E+01_JPRB, 0.113259E+01_JPRB &
  &, 0.112966E+01_JPRB, 0.112626E+01_JPRB, 0.112239E+01_JPRB, 0.111807E+01_JPRB &
  &, 0.111328E+01_JPRB, 0.110804E+01_JPRB, 0.110235E+01_JPRB &
  &, 0.109621E+01_JPRB, 0.108964E+01_JPRB, 0.108263E+01_JPRB, 0.107520E+01_JPRB &
  &, 0.106735E+01_JPRB, 0.105909E+01_JPRB, 0.105043E+01_JPRB &
  &, 0.104137E+01_JPRB, 0.103192E+01_JPRB, 0.102212E+01_JPRB, 0.101194E+01_JPRB &
  &, 0.100141E+01_JPRB, 0.990538E+00_JPRB, 0.979345E+00_JPRB &
  &, 0.967824E+00_JPRB, 0.956010E+00_JPRB, 0.943895E+00_JPRB, 0.931502E+00_JPRB &
  &, 0.918842E+00_JPRB, 0.905942E+00_JPRB, 0.892784E+00_JPRB &
  &, 0.879414E+00_JPRB, 0.865846E+00_JPRB, 0.852066E+00_JPRB, 0.838104E+00_JPRB &
  &, 0.823979E+00_JPRB, 0.809708E+00_JPRB, 0.795292E+00_JPRB &
  &, 0.780769E+00_JPRB, 0.766119E+00_JPRB, 0.751381E+00_JPRB, 0.736573E+00_JPRB &
  &, 0.721695E+00_JPRB, 0.706767E+00_JPRB, 0.691806E+00_JPRB &
  &, 0.676833E+00_JPRB, 0.661844E+00_JPRB, 0.646858E+00_JPRB, 0.631891E+00_JPRB &
  &, 0.616961E+00_JPRB, 0.602086E+00_JPRB, 0.587259E+00_JPRB &
  &, 0.572518E+00_JPRB, 0.557830E+00_JPRB, 0.543259E+00_JPRB, 0.528794E+00_JPRB &
  &, 0.514449E+00_JPRB, 0.500234E+00_JPRB, 0.486135E+00_JPRB &
  &, 0.472216E+00_JPRB, 0.458433E+00_JPRB, 0.444821E+00_JPRB, 0.431359E+00_JPRB &
  &, 0.418113E+00_JPRB, 0.405059E+00_JPRB, 0.392171E+00_JPRB &
  &, 0.379515E+00_JPRB, 0.367061E+00_JPRB, 0.354843E+00_JPRB, 0.342797E+00_JPRB &
  &, 0.331020E+00_JPRB, 0.319478E+00_JPRB, 0.308132E+00_JPRB &
  &, 0.297047E+00_JPRB, 0.286219E+00_JPRB, 0.275605E+00_JPRB, 0.265232E+00_JPRB &
  &, 0.255128E+00_JPRB, 0.245283E+00_JPRB, 0.235647E+00_JPRB &
  &, 0.226284E+00_JPRB, 0.217180E+00_JPRB, 0.208320E+00_JPRB, 0.199686E+00_JPRB &
  &, 0.191343E+00_JPRB, 0.183230E+00_JPRB, 0.175324E+00_JPRB &
  &, 0.167691E+00_JPRB, 0.160307E+00_JPRB, 0.153148E+00_JPRB, 0.146232E+00_JPRB &
  &, 0.139533E+00_JPRB, 0.133115E+00_JPRB, 0.126854E+00_JPRB &
  &, 0.120862E+00_JPRB, 0.115057E+00_JPRB, 0.109506E+00_JPRB, 0.104123E+00_JPRB &
  &, 0.989728E-01_JPRB, 0.940182E-01_JPRB, 0.892731E-01_JPRB &
  &, 0.846963E-01_JPRB, 0.802998E-01_JPRB, 0.760959E-01_JPRB, 0.720970E-01_JPRB &
  &, 0.682575E-01_JPRB, 0.645287E-01_JPRB, 0.610387E-01_JPRB &
  &, 0.576791E-01_JPRB, 0.544587E-01_JPRB, 0.513859E-01_JPRB, 0.484698E-01_JPRB &
  &, 0.457191E-01_JPRB, 0.430782E-01_JPRB, 0.405538E-01_JPRB/)
XCW( 665, :) = (/ &
  &  0.103971E+01_JPRB, 0.104873E+01_JPRB, 0.105738E+01_JPRB, 0.106564E+01_JPRB &
  &, 0.107351E+01_JPRB, 0.108098E+01_JPRB, 0.108805E+01_JPRB &
  &, 0.109471E+01_JPRB, 0.110096E+01_JPRB, 0.110679E+01_JPRB, 0.111219E+01_JPRB &
  &, 0.111716E+01_JPRB, 0.112169E+01_JPRB, 0.112579E+01_JPRB &
  &, 0.112944E+01_JPRB, 0.113264E+01_JPRB, 0.113539E+01_JPRB, 0.113768E+01_JPRB &
  &, 0.113951E+01_JPRB, 0.114087E+01_JPRB, 0.114178E+01_JPRB &
  &, 0.114221E+01_JPRB, 0.114218E+01_JPRB, 0.114168E+01_JPRB, 0.114070E+01_JPRB &
  &, 0.113925E+01_JPRB, 0.113733E+01_JPRB, 0.113494E+01_JPRB &
  &, 0.113208E+01_JPRB, 0.112875E+01_JPRB, 0.112496E+01_JPRB, 0.112070E+01_JPRB &
  &, 0.111599E+01_JPRB, 0.111082E+01_JPRB, 0.110520E+01_JPRB &
  &, 0.109913E+01_JPRB, 0.109262E+01_JPRB, 0.108568E+01_JPRB, 0.107831E+01_JPRB &
  &, 0.107052E+01_JPRB, 0.106232E+01_JPRB, 0.105371E+01_JPRB &
  &, 0.104472E+01_JPRB, 0.103533E+01_JPRB, 0.102557E+01_JPRB, 0.101545E+01_JPRB &
  &, 0.100497E+01_JPRB, 0.994144E+00_JPRB, 0.983000E+00_JPRB &
  &, 0.971530E+00_JPRB, 0.959751E+00_JPRB, 0.947671E+00_JPRB, 0.935327E+00_JPRB &
  &, 0.922701E+00_JPRB, 0.909818E+00_JPRB, 0.896706E+00_JPRB &
  &, 0.883366E+00_JPRB, 0.869811E+00_JPRB, 0.856057E+00_JPRB, 0.842120E+00_JPRB &
  &, 0.828019E+00_JPRB, 0.813770E+00_JPRB, 0.799357E+00_JPRB &
  &, 0.784833E+00_JPRB, 0.770218E+00_JPRB, 0.755475E+00_JPRB, 0.740679E+00_JPRB &
  &, 0.725792E+00_JPRB, 0.710871E+00_JPRB, 0.695916E+00_JPRB &
  &, 0.680924E+00_JPRB, 0.665914E+00_JPRB, 0.650925E+00_JPRB, 0.635952E+00_JPRB &
  &, 0.621015E+00_JPRB, 0.606106E+00_JPRB, 0.591264E+00_JPRB &
  &, 0.576482E+00_JPRB, 0.561799E+00_JPRB, 0.547181E+00_JPRB, 0.532690E+00_JPRB &
  &, 0.518315E+00_JPRB, 0.504041E+00_JPRB, 0.489933E+00_JPRB &
  &, 0.475948E+00_JPRB, 0.462122E+00_JPRB, 0.448492E+00_JPRB, 0.435011E+00_JPRB &
  &, 0.421592E+00_JPRB, 0.408572E+00_JPRB, 0.395655E+00_JPRB &
  &, 0.382966E+00_JPRB, 0.370445E+00_JPRB, 0.358157E+00_JPRB, 0.346069E+00_JPRB &
  &, 0.334248E+00_JPRB, 0.322624E+00_JPRB, 0.311227E+00_JPRB &
  &, 0.300088E+00_JPRB, 0.289203E+00_JPRB, 0.278528E+00_JPRB, 0.268091E+00_JPRB &
  &, 0.257920E+00_JPRB, 0.248005E+00_JPRB, 0.238335E+00_JPRB &
  &, 0.228896E+00_JPRB, 0.219712E+00_JPRB, 0.210810E+00_JPRB, 0.202131E+00_JPRB &
  &, 0.193698E+00_JPRB, 0.185535E+00_JPRB, 0.177577E+00_JPRB &
  &, 0.169889E+00_JPRB, 0.162448E+00_JPRB, 0.155229E+00_JPRB, 0.148252E+00_JPRB &
  &, 0.141488E+00_JPRB, 0.134955E+00_JPRB, 0.128671E+00_JPRB &
  &, 0.122607E+00_JPRB, 0.116777E+00_JPRB, 0.111149E+00_JPRB, 0.105738E+00_JPRB &
  &, 0.100505E+00_JPRB, 0.954653E-01_JPRB, 0.906865E-01_JPRB &
  &, 0.860746E-01_JPRB, 0.816417E-01_JPRB, 0.773433E-01_JPRB, 0.733043E-01_JPRB &
  &, 0.694232E-01_JPRB, 0.656513E-01_JPRB, 0.621167E-01_JPRB &
  &, 0.587111E-01_JPRB, 0.554430E-01_JPRB, 0.523835E-01_JPRB, 0.494175E-01_JPRB &
  &, 0.466154E-01_JPRB, 0.439214E-01_JPRB, 0.413423E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART95',1,ZHOOK_HANDLE)
END SUBROUTINE PART95

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART96

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART96',0,ZHOOK_HANDLE)

XCW( 666, :) = (/ &
  &  0.103999E+01_JPRB, 0.104909E+01_JPRB, 0.105781E+01_JPRB, 0.106614E+01_JPRB &
  &, 0.107408E+01_JPRB, 0.108163E+01_JPRB, 0.108878E+01_JPRB &
  &, 0.109552E+01_JPRB, 0.110184E+01_JPRB, 0.110774E+01_JPRB, 0.111322E+01_JPRB &
  &, 0.111827E+01_JPRB, 0.112288E+01_JPRB, 0.112706E+01_JPRB &
  &, 0.113079E+01_JPRB, 0.113406E+01_JPRB, 0.113689E+01_JPRB, 0.113926E+01_JPRB &
  &, 0.114117E+01_JPRB, 0.114262E+01_JPRB, 0.114360E+01_JPRB &
  &, 0.114411E+01_JPRB, 0.114415E+01_JPRB, 0.114373E+01_JPRB, 0.114283E+01_JPRB &
  &, 0.114146E+01_JPRB, 0.113961E+01_JPRB, 0.113730E+01_JPRB &
  &, 0.113451E+01_JPRB, 0.113126E+01_JPRB, 0.112754E+01_JPRB, 0.112335E+01_JPRB &
  &, 0.111871E+01_JPRB, 0.111361E+01_JPRB, 0.110806E+01_JPRB &
  &, 0.110206E+01_JPRB, 0.109561E+01_JPRB, 0.108874E+01_JPRB, 0.108143E+01_JPRB &
  &, 0.107370E+01_JPRB, 0.106556E+01_JPRB, 0.105702E+01_JPRB &
  &, 0.104807E+01_JPRB, 0.103875E+01_JPRB, 0.102904E+01_JPRB, 0.101897E+01_JPRB &
  &, 0.100854E+01_JPRB, 0.997762E+00_JPRB, 0.986656E+00_JPRB &
  &, 0.975235E+00_JPRB, 0.963493E+00_JPRB, 0.951462E+00_JPRB, 0.939152E+00_JPRB &
  &, 0.926574E+00_JPRB, 0.913723E+00_JPRB, 0.900643E+00_JPRB &
  &, 0.887333E+00_JPRB, 0.873807E+00_JPRB, 0.860080E+00_JPRB, 0.846153E+00_JPRB &
  &, 0.832076E+00_JPRB, 0.817832E+00_JPRB, 0.803457E+00_JPRB &
  &, 0.788935E+00_JPRB, 0.774318E+00_JPRB, 0.759589E+00_JPRB, 0.744786E+00_JPRB &
  &, 0.729928E+00_JPRB, 0.714995E+00_JPRB, 0.700025E+00_JPRB &
  &, 0.685036E+00_JPRB, 0.670026E+00_JPRB, 0.655013E+00_JPRB, 0.640036E+00_JPRB &
  &, 0.625068E+00_JPRB, 0.610148E+00_JPRB, 0.595293E+00_JPRB &
  &, 0.580495E+00_JPRB, 0.565769E+00_JPRB, 0.551127E+00_JPRB, 0.536611E+00_JPRB &
  &, 0.522181E+00_JPRB, 0.507902E+00_JPRB, 0.493759E+00_JPRB &
  &, 0.479735E+00_JPRB, 0.465867E+00_JPRB, 0.452164E+00_JPRB, 0.438662E+00_JPRB &
  &, 0.425311E+00_JPRB, 0.412145E+00_JPRB, 0.399169E+00_JPRB &
  &, 0.386417E+00_JPRB, 0.373862E+00_JPRB, 0.361504E+00_JPRB, 0.349375E+00_JPRB &
  &, 0.337476E+00_JPRB, 0.325804E+00_JPRB, 0.314357E+00_JPRB &
  &, 0.303165E+00_JPRB, 0.292187E+00_JPRB, 0.281488E+00_JPRB, 0.270988E+00_JPRB &
  &, 0.260751E+00_JPRB, 0.250767E+00_JPRB, 0.241023E+00_JPRB &
  &, 0.231547E+00_JPRB, 0.222325E+00_JPRB, 0.213340E+00_JPRB, 0.204576E+00_JPRB &
  &, 0.196096E+00_JPRB, 0.187841E+00_JPRB, 0.179830E+00_JPRB &
  &, 0.172088E+00_JPRB, 0.164590E+00_JPRB, 0.157311E+00_JPRB, 0.150272E+00_JPRB &
  &, 0.143443E+00_JPRB, 0.136891E+00_JPRB, 0.130538E+00_JPRB &
  &, 0.124401E+00_JPRB, 0.118497E+00_JPRB, 0.112792E+00_JPRB, 0.107300E+00_JPRB &
  &, 0.102037E+00_JPRB, 0.969661E-01_JPRB, 0.920999E-01_JPRB &
  &, 0.874530E-01_JPRB, 0.829836E-01_JPRB, 0.786473E-01_JPRB, 0.745115E-01_JPRB &
  &, 0.705888E-01_JPRB, 0.668330E-01_JPRB, 0.631947E-01_JPRB &
  &, 0.597431E-01_JPRB, 0.564889E-01_JPRB, 0.533188E-01_JPRB, 0.503020E-01_JPRB &
  &, 0.474476E-01_JPRB, 0.447646E-01_JPRB, 0.421308E-01_JPRB/)
XCW( 667, :) = (/ &
  &  0.104028E+01_JPRB, 0.104944E+01_JPRB, 0.105823E+01_JPRB, 0.106664E+01_JPRB &
  &, 0.107466E+01_JPRB, 0.108228E+01_JPRB, 0.108951E+01_JPRB &
  &, 0.109632E+01_JPRB, 0.110272E+01_JPRB, 0.110870E+01_JPRB, 0.111426E+01_JPRB &
  &, 0.111939E+01_JPRB, 0.112408E+01_JPRB, 0.112833E+01_JPRB &
  &, 0.113214E+01_JPRB, 0.113549E+01_JPRB, 0.113840E+01_JPRB, 0.114085E+01_JPRB &
  &, 0.114283E+01_JPRB, 0.114436E+01_JPRB, 0.114542E+01_JPRB &
  &, 0.114601E+01_JPRB, 0.114613E+01_JPRB, 0.114578E+01_JPRB, 0.114496E+01_JPRB &
  &, 0.114366E+01_JPRB, 0.114190E+01_JPRB, 0.113966E+01_JPRB &
  &, 0.113695E+01_JPRB, 0.113377E+01_JPRB, 0.113012E+01_JPRB, 0.112601E+01_JPRB &
  &, 0.112143E+01_JPRB, 0.111640E+01_JPRB, 0.111092E+01_JPRB &
  &, 0.110499E+01_JPRB, 0.109860E+01_JPRB, 0.109180E+01_JPRB, 0.108456E+01_JPRB &
  &, 0.107689E+01_JPRB, 0.106881E+01_JPRB, 0.106032E+01_JPRB &
  &, 0.105144E+01_JPRB, 0.104218E+01_JPRB, 0.103252E+01_JPRB, 0.102250E+01_JPRB &
  &, 0.101213E+01_JPRB, 0.100141E+01_JPRB, 0.990337E+00_JPRB &
  &, 0.978954E+00_JPRB, 0.967261E+00_JPRB, 0.955280E+00_JPRB, 0.943005E+00_JPRB &
  &, 0.930447E+00_JPRB, 0.917644E+00_JPRB, 0.904596E+00_JPRB &
  &, 0.891300E+00_JPRB, 0.877803E+00_JPRB, 0.864104E+00_JPRB, 0.850220E+00_JPRB &
  &, 0.836150E+00_JPRB, 0.821929E+00_JPRB, 0.807558E+00_JPRB &
  &, 0.793054E+00_JPRB, 0.778454E+00_JPRB, 0.763741E+00_JPRB, 0.748931E+00_JPRB &
  &, 0.734065E+00_JPRB, 0.719140E+00_JPRB, 0.704155E+00_JPRB &
  &, 0.689170E+00_JPRB, 0.674139E+00_JPRB, 0.659124E+00_JPRB, 0.644142E+00_JPRB &
  &, 0.629144E+00_JPRB, 0.614214E+00_JPRB, 0.599323E+00_JPRB &
  &, 0.584508E+00_JPRB, 0.569763E+00_JPRB, 0.555099E+00_JPRB, 0.540558E+00_JPRB &
  &, 0.526100E+00_JPRB, 0.511789E+00_JPRB, 0.497584E+00_JPRB &
  &, 0.483550E+00_JPRB, 0.469641E+00_JPRB, 0.455893E+00_JPRB, 0.442343E+00_JPRB &
  &, 0.428941E+00_JPRB, 0.415719E+00_JPRB, 0.402715E+00_JPRB &
  &, 0.389901E+00_JPRB, 0.377279E+00_JPRB, 0.364883E+00_JPRB, 0.352714E+00_JPRB &
  &, 0.340772E+00_JPRB, 0.329019E+00_JPRB, 0.317522E+00_JPRB &
  &, 0.306277E+00_JPRB, 0.295243E+00_JPRB, 0.284449E+00_JPRB, 0.273923E+00_JPRB &
  &, 0.263620E+00_JPRB, 0.253567E+00_JPRB, 0.243790E+00_JPRB &
  &, 0.234239E+00_JPRB, 0.224938E+00_JPRB, 0.215871E+00_JPRB, 0.207063E+00_JPRB &
  &, 0.198494E+00_JPRB, 0.190190E+00_JPRB, 0.182128E+00_JPRB &
  &, 0.174331E+00_JPRB, 0.166731E+00_JPRB, 0.159393E+00_JPRB, 0.152291E+00_JPRB &
  &, 0.145445E+00_JPRB, 0.138778E+00_JPRB, 0.132405E+00_JPRB &
  &, 0.126196E+00_JPRB, 0.120218E+00_JPRB, 0.114486E+00_JPRB, 0.108967E+00_JPRB &
  &, 0.103622E+00_JPRB, 0.985203E-01_JPRB, 0.935677E-01_JPRB &
  &, 0.888313E-01_JPRB, 0.843255E-01_JPRB, 0.799513E-01_JPRB, 0.757761E-01_JPRB &
  &, 0.718127E-01_JPRB, 0.679556E-01_JPRB, 0.643327E-01_JPRB &
  &, 0.608357E-01_JPRB, 0.574733E-01_JPRB, 0.543164E-01_JPRB, 0.512497E-01_JPRB &
  &, 0.483439E-01_JPRB, 0.456078E-01_JPRB, 0.429851E-01_JPRB/)
XCW( 668, :) = (/ &
  &  0.104056E+01_JPRB, 0.104980E+01_JPRB, 0.105866E+01_JPRB, 0.106715E+01_JPRB &
  &, 0.107524E+01_JPRB, 0.108294E+01_JPRB, 0.109024E+01_JPRB &
  &, 0.109713E+01_JPRB, 0.110361E+01_JPRB, 0.110967E+01_JPRB, 0.111530E+01_JPRB &
  &, 0.112051E+01_JPRB, 0.112528E+01_JPRB, 0.112961E+01_JPRB &
  &, 0.113349E+01_JPRB, 0.113693E+01_JPRB, 0.113991E+01_JPRB, 0.114244E+01_JPRB &
  &, 0.114451E+01_JPRB, 0.114611E+01_JPRB, 0.114725E+01_JPRB &
  &, 0.114792E+01_JPRB, 0.114811E+01_JPRB, 0.114784E+01_JPRB, 0.114710E+01_JPRB &
  &, 0.114588E+01_JPRB, 0.114419E+01_JPRB, 0.114202E+01_JPRB &
  &, 0.113939E+01_JPRB, 0.113628E+01_JPRB, 0.113271E+01_JPRB, 0.112867E+01_JPRB &
  &, 0.112416E+01_JPRB, 0.111920E+01_JPRB, 0.111379E+01_JPRB &
  &, 0.110792E+01_JPRB, 0.110162E+01_JPRB, 0.109487E+01_JPRB, 0.108770E+01_JPRB &
  &, 0.108009E+01_JPRB, 0.107207E+01_JPRB, 0.106365E+01_JPRB &
  &, 0.105483E+01_JPRB, 0.104560E+01_JPRB, 0.103601E+01_JPRB, 0.102605E+01_JPRB &
  &, 0.101572E+01_JPRB, 0.100505E+01_JPRB, 0.994031E+00_JPRB &
  &, 0.982699E+00_JPRB, 0.971043E+00_JPRB, 0.959098E+00_JPRB, 0.946858E+00_JPRB &
  &, 0.934348E+00_JPRB, 0.921579E+00_JPRB, 0.908563E+00_JPRB &
  &, 0.895299E+00_JPRB, 0.881831E+00_JPRB, 0.868160E+00_JPRB, 0.854286E+00_JPRB &
  &, 0.840241E+00_JPRB, 0.826043E+00_JPRB, 0.811676E+00_JPRB &
  &, 0.797191E+00_JPRB, 0.782590E+00_JPRB, 0.767892E+00_JPRB, 0.753096E+00_JPRB &
  &, 0.738221E+00_JPRB, 0.723305E+00_JPRB, 0.708326E+00_JPRB &
  &, 0.693324E+00_JPRB, 0.678295E+00_JPRB, 0.663278E+00_JPRB, 0.648248E+00_JPRB &
  &, 0.633266E+00_JPRB, 0.618304E+00_JPRB, 0.603400E+00_JPRB &
  &, 0.588570E+00_JPRB, 0.573781E+00_JPRB, 0.559122E+00_JPRB, 0.544531E+00_JPRB &
  &, 0.530045E+00_JPRB, 0.515677E+00_JPRB, 0.501465E+00_JPRB &
  &, 0.487365E+00_JPRB, 0.473443E+00_JPRB, 0.459651E+00_JPRB, 0.446024E+00_JPRB &
  &, 0.432600E+00_JPRB, 0.419354E+00_JPRB, 0.406291E+00_JPRB &
  &, 0.393415E+00_JPRB, 0.380760E+00_JPRB, 0.368295E+00_JPRB, 0.356086E+00_JPRB &
  &, 0.344067E+00_JPRB, 0.332269E+00_JPRB, 0.320723E+00_JPRB &
  &, 0.309390E+00_JPRB, 0.298300E+00_JPRB, 0.287483E+00_JPRB, 0.276858E+00_JPRB &
  &, 0.266527E+00_JPRB, 0.256405E+00_JPRB, 0.246518E+00_JPRB &
  &, 0.236931E+00_JPRB, 0.227551E+00_JPRB, 0.218443E+00_JPRB, 0.209592E+00_JPRB &
  &, 0.200935E+00_JPRB, 0.192582E+00_JPRB, 0.184470E+00_JPRB &
  &, 0.176575E+00_JPRB, 0.168919E+00_JPRB, 0.161522E+00_JPRB, 0.154358E+00_JPRB &
  &, 0.147448E+00_JPRB, 0.140714E+00_JPRB, 0.134272E+00_JPRB &
  &, 0.128041E+00_JPRB, 0.121988E+00_JPRB, 0.116180E+00_JPRB, 0.110581E+00_JPRB &
  &, 0.105208E+00_JPRB, 0.100021E+00_JPRB, 0.950899E-01_JPRB &
  &, 0.902648E-01_JPRB, 0.856674E-01_JPRB, 0.813120E-01_JPRB, 0.770983E-01_JPRB &
  &, 0.730366E-01_JPRB, 0.691372E-01_JPRB, 0.654706E-01_JPRB &
  &, 0.619284E-01_JPRB, 0.585192E-01_JPRB, 0.553139E-01_JPRB, 0.521974E-01_JPRB &
  &, 0.493041E-01_JPRB, 0.464510E-01_JPRB, 0.438393E-01_JPRB/)
XCW( 669, :) = (/ &
  &  0.104084E+01_JPRB, 0.105016E+01_JPRB, 0.105909E+01_JPRB, 0.106765E+01_JPRB &
  &, 0.107582E+01_JPRB, 0.108360E+01_JPRB, 0.109097E+01_JPRB &
  &, 0.109794E+01_JPRB, 0.110449E+01_JPRB, 0.111063E+01_JPRB, 0.111634E+01_JPRB &
  &, 0.112163E+01_JPRB, 0.112647E+01_JPRB, 0.113088E+01_JPRB &
  &, 0.113485E+01_JPRB, 0.113836E+01_JPRB, 0.114143E+01_JPRB, 0.114403E+01_JPRB &
  &, 0.114618E+01_JPRB, 0.114786E+01_JPRB, 0.114908E+01_JPRB &
  &, 0.114983E+01_JPRB, 0.115010E+01_JPRB, 0.114991E+01_JPRB, 0.114924E+01_JPRB &
  &, 0.114810E+01_JPRB, 0.114649E+01_JPRB, 0.114440E+01_JPRB &
  &, 0.114183E+01_JPRB, 0.113880E+01_JPRB, 0.113530E+01_JPRB, 0.113134E+01_JPRB &
  &, 0.112690E+01_JPRB, 0.112201E+01_JPRB, 0.111667E+01_JPRB &
  &, 0.111087E+01_JPRB, 0.110463E+01_JPRB, 0.109795E+01_JPRB, 0.109084E+01_JPRB &
  &, 0.108330E+01_JPRB, 0.107535E+01_JPRB, 0.106698E+01_JPRB &
  &, 0.105821E+01_JPRB, 0.104905E+01_JPRB, 0.103951E+01_JPRB, 0.102960E+01_JPRB &
  &, 0.101933E+01_JPRB, 0.100870E+01_JPRB, 0.997738E+00_JPRB &
  &, 0.986457E+00_JPRB, 0.974852E+00_JPRB, 0.962943E+00_JPRB, 0.950740E+00_JPRB &
  &, 0.938265E+00_JPRB, 0.925529E+00_JPRB, 0.912545E+00_JPRB &
  &, 0.899312E+00_JPRB, 0.885875E+00_JPRB, 0.872216E+00_JPRB, 0.858369E+00_JPRB &
  &, 0.844349E+00_JPRB, 0.830158E+00_JPRB, 0.815829E+00_JPRB &
  &, 0.801347E+00_JPRB, 0.786764E+00_JPRB, 0.772063E+00_JPRB, 0.757281E+00_JPRB &
  &, 0.742417E+00_JPRB, 0.727490E+00_JPRB, 0.712498E+00_JPRB &
  &, 0.697499E+00_JPRB, 0.682472E+00_JPRB, 0.667433E+00_JPRB, 0.652399E+00_JPRB &
  &, 0.637411E+00_JPRB, 0.622440E+00_JPRB, 0.607500E+00_JPRB &
  &, 0.592632E+00_JPRB, 0.577850E+00_JPRB, 0.563145E+00_JPRB, 0.548529E+00_JPRB &
  &, 0.534016E+00_JPRB, 0.519618E+00_JPRB, 0.505345E+00_JPRB &
  &, 0.491236E+00_JPRB, 0.477245E+00_JPRB, 0.463438E+00_JPRB, 0.449764E+00_JPRB &
  &, 0.436289E+00_JPRB, 0.422989E+00_JPRB, 0.409868E+00_JPRB &
  &, 0.396962E+00_JPRB, 0.384241E+00_JPRB, 0.371740E+00_JPRB, 0.359459E+00_JPRB &
  &, 0.347397E+00_JPRB, 0.335553E+00_JPRB, 0.323923E+00_JPRB &
  &, 0.312538E+00_JPRB, 0.301429E+00_JPRB, 0.290517E+00_JPRB, 0.279830E+00_JPRB &
  &, 0.269435E+00_JPRB, 0.259244E+00_JPRB, 0.249324E+00_JPRB &
  &, 0.239663E+00_JPRB, 0.230205E+00_JPRB, 0.221057E+00_JPRB, 0.212121E+00_JPRB &
  &, 0.203419E+00_JPRB, 0.194975E+00_JPRB, 0.186811E+00_JPRB &
  &, 0.178863E+00_JPRB, 0.171151E+00_JPRB, 0.163696E+00_JPRB, 0.156472E+00_JPRB &
  &, 0.149451E+00_JPRB, 0.142699E+00_JPRB, 0.136188E+00_JPRB &
  &, 0.129886E+00_JPRB, 0.123810E+00_JPRB, 0.117925E+00_JPRB, 0.112300E+00_JPRB &
  &, 0.106845E+00_JPRB, 0.101629E+00_JPRB, 0.965576E-01_JPRB &
  &, 0.917535E-01_JPRB, 0.870652E-01_JPRB, 0.826160E-01_JPRB, 0.783630E-01_JPRB &
  &, 0.742605E-01_JPRB, 0.703780E-01_JPRB, 0.666085E-01_JPRB &
  &, 0.630211E-01_JPRB, 0.595651E-01_JPRB, 0.563115E-01_JPRB, 0.532083E-01_JPRB &
  &, 0.502004E-01_JPRB, 0.473591E-01_JPRB, 0.446936E-01_JPRB/)
XCW( 670, :) = (/ &
  &  0.104113E+01_JPRB, 0.105051E+01_JPRB, 0.105952E+01_JPRB, 0.106815E+01_JPRB &
  &, 0.107640E+01_JPRB, 0.108425E+01_JPRB, 0.109170E+01_JPRB &
  &, 0.109875E+01_JPRB, 0.110538E+01_JPRB, 0.111160E+01_JPRB, 0.111739E+01_JPRB &
  &, 0.112275E+01_JPRB, 0.112768E+01_JPRB, 0.113216E+01_JPRB &
  &, 0.113621E+01_JPRB, 0.113980E+01_JPRB, 0.114295E+01_JPRB, 0.114563E+01_JPRB &
  &, 0.114786E+01_JPRB, 0.114962E+01_JPRB, 0.115091E+01_JPRB &
  &, 0.115174E+01_JPRB, 0.115210E+01_JPRB, 0.115198E+01_JPRB, 0.115139E+01_JPRB &
  &, 0.115032E+01_JPRB, 0.114879E+01_JPRB, 0.114677E+01_JPRB &
  &, 0.114429E+01_JPRB, 0.114133E+01_JPRB, 0.113791E+01_JPRB, 0.113401E+01_JPRB &
  &, 0.112965E+01_JPRB, 0.112484E+01_JPRB, 0.111956E+01_JPRB &
  &, 0.111383E+01_JPRB, 0.110765E+01_JPRB, 0.110105E+01_JPRB, 0.109400E+01_JPRB &
  &, 0.108652E+01_JPRB, 0.107863E+01_JPRB, 0.107033E+01_JPRB &
  &, 0.106161E+01_JPRB, 0.105252E+01_JPRB, 0.104304E+01_JPRB, 0.103317E+01_JPRB &
  &, 0.102296E+01_JPRB, 0.101237E+01_JPRB, 0.100146E+01_JPRB &
  &, 0.990215E+00_JPRB, 0.978661E+00_JPRB, 0.966789E+00_JPRB, 0.954635E+00_JPRB &
  &, 0.942195E+00_JPRB, 0.929494E+00_JPRB, 0.916543E+00_JPRB &
  &, 0.903342E+00_JPRB, 0.889934E+00_JPRB, 0.876305E+00_JPRB, 0.862485E+00_JPRB &
  &, 0.848474E+00_JPRB, 0.834307E+00_JPRB, 0.820001E+00_JPRB &
  &, 0.805539E+00_JPRB, 0.790956E+00_JPRB, 0.776271E+00_JPRB, 0.761484E+00_JPRB &
  &, 0.746613E+00_JPRB, 0.731695E+00_JPRB, 0.716710E+00_JPRB &
  &, 0.701696E+00_JPRB, 0.686671E+00_JPRB, 0.671632E+00_JPRB, 0.656573E+00_JPRB &
  &, 0.641556E+00_JPRB, 0.626576E+00_JPRB, 0.611625E+00_JPRB &
  &, 0.596742E+00_JPRB, 0.581918E+00_JPRB, 0.567192E+00_JPRB, 0.552553E+00_JPRB &
  &, 0.538014E+00_JPRB, 0.523586E+00_JPRB, 0.509280E+00_JPRB &
  &, 0.495107E+00_JPRB, 0.481104E+00_JPRB, 0.467225E+00_JPRB, 0.453534E+00_JPRB &
  &, 0.440008E+00_JPRB, 0.426654E+00_JPRB, 0.413507E+00_JPRB &
  &, 0.400540E+00_JPRB, 0.387787E+00_JPRB, 0.375218E+00_JPRB, 0.362865E+00_JPRB &
  &, 0.350761E+00_JPRB, 0.338837E+00_JPRB, 0.327194E+00_JPRB &
  &, 0.315758E+00_JPRB, 0.304522E+00_JPRB, 0.293588E+00_JPRB, 0.282840E+00_JPRB &
  &, 0.272380E+00_JPRB, 0.262122E+00_JPRB, 0.252131E+00_JPRB &
  &, 0.242395E+00_JPRB, 0.232900E+00_JPRB, 0.223671E+00_JPRB, 0.214692E+00_JPRB &
  &, 0.205946E+00_JPRB, 0.197411E+00_JPRB, 0.189153E+00_JPRB &
  &, 0.181152E+00_JPRB, 0.173384E+00_JPRB, 0.165870E+00_JPRB, 0.158586E+00_JPRB &
  &, 0.151549E+00_JPRB, 0.144683E+00_JPRB, 0.138104E+00_JPRB &
  &, 0.131730E+00_JPRB, 0.125631E+00_JPRB, 0.119671E+00_JPRB, 0.113967E+00_JPRB &
  &, 0.108483E+00_JPRB, 0.103183E+00_JPRB, 0.980798E-01_JPRB &
  &, 0.931870E-01_JPRB, 0.885189E-01_JPRB, 0.839767E-01_JPRB, 0.796852E-01_JPRB &
  &, 0.755427E-01_JPRB, 0.715596E-01_JPRB, 0.677464E-01_JPRB &
  &, 0.641138E-01_JPRB, 0.606726E-01_JPRB, 0.573715E-01_JPRB, 0.541560E-01_JPRB &
  &, 0.511607E-01_JPRB, 0.482672E-01_JPRB, 0.455478E-01_JPRB/)
XCW( 671, :) = (/ &
  &  0.104141E+01_JPRB, 0.105087E+01_JPRB, 0.105996E+01_JPRB, 0.106866E+01_JPRB &
  &, 0.107698E+01_JPRB, 0.108491E+01_JPRB, 0.109244E+01_JPRB &
  &, 0.109956E+01_JPRB, 0.110627E+01_JPRB, 0.111256E+01_JPRB, 0.111843E+01_JPRB &
  &, 0.112387E+01_JPRB, 0.112888E+01_JPRB, 0.113345E+01_JPRB &
  &, 0.113757E+01_JPRB, 0.114124E+01_JPRB, 0.114447E+01_JPRB, 0.114723E+01_JPRB &
  &, 0.114954E+01_JPRB, 0.115138E+01_JPRB, 0.115273E+01_JPRB &
  &, 0.115365E+01_JPRB, 0.115409E+01_JPRB, 0.115405E+01_JPRB, 0.115354E+01_JPRB &
  &, 0.115256E+01_JPRB, 0.115109E+01_JPRB, 0.114916E+01_JPRB &
  &, 0.114675E+01_JPRB, 0.114387E+01_JPRB, 0.114051E+01_JPRB, 0.113670E+01_JPRB &
  &, 0.113241E+01_JPRB, 0.112766E+01_JPRB, 0.112246E+01_JPRB &
  &, 0.111680E+01_JPRB, 0.111070E+01_JPRB, 0.110415E+01_JPRB, 0.109716E+01_JPRB &
  &, 0.108975E+01_JPRB, 0.108192E+01_JPRB, 0.107368E+01_JPRB &
  &, 0.106504E+01_JPRB, 0.105599E+01_JPRB, 0.104656E+01_JPRB, 0.103676E+01_JPRB &
  &, 0.102658E+01_JPRB, 0.101607E+01_JPRB, 0.100518E+01_JPRB &
  &, 0.993999E+00_JPRB, 0.982483E+00_JPRB, 0.970662E+00_JPRB, 0.958545E+00_JPRB &
  &, 0.946140E+00_JPRB, 0.933473E+00_JPRB, 0.920556E+00_JPRB &
  &, 0.907402E+00_JPRB, 0.894010E+00_JPRB, 0.880410E+00_JPRB, 0.866617E+00_JPRB &
  &, 0.852633E+00_JPRB, 0.838473E+00_JPRB, 0.824172E+00_JPRB &
  &, 0.809731E+00_JPRB, 0.795167E+00_JPRB, 0.780480E+00_JPRB, 0.765707E+00_JPRB &
  &, 0.750848E+00_JPRB, 0.735921E+00_JPRB, 0.720943E+00_JPRB &
  &, 0.705935E+00_JPRB, 0.690891E+00_JPRB, 0.675830E+00_JPRB, 0.660791E+00_JPRB &
  &, 0.645747E+00_JPRB, 0.630735E+00_JPRB, 0.615773E+00_JPRB &
  &, 0.600877E+00_JPRB, 0.586036E+00_JPRB, 0.571266E+00_JPRB, 0.556603E+00_JPRB &
  &, 0.542011E+00_JPRB, 0.527553E+00_JPRB, 0.513242E+00_JPRB &
  &, 0.499033E+00_JPRB, 0.484963E+00_JPRB, 0.471070E+00_JPRB, 0.457332E+00_JPRB &
  &, 0.443757E+00_JPRB, 0.430350E+00_JPRB, 0.417146E+00_JPRB &
  &, 0.404150E+00_JPRB, 0.391333E+00_JPRB, 0.378729E+00_JPRB, 0.366304E+00_JPRB &
  &, 0.354125E+00_JPRB, 0.342191E+00_JPRB, 0.330465E+00_JPRB &
  &, 0.318941E+00_JPRB, 0.307687E+00_JPRB, 0.296659E+00_JPRB, 0.285888E+00_JPRB &
  &, 0.275326E+00_JPRB, 0.265039E+00_JPRB, 0.254977E+00_JPRB &
  &, 0.245207E+00_JPRB, 0.235635E+00_JPRB, 0.226326E+00_JPRB, 0.217263E+00_JPRB &
  &, 0.208472E+00_JPRB, 0.199890E+00_JPRB, 0.191583E+00_JPRB &
  &, 0.183485E+00_JPRB, 0.175662E+00_JPRB, 0.168091E+00_JPRB, 0.160746E+00_JPRB &
  &, 0.153599E+00_JPRB, 0.146716E+00_JPRB, 0.140069E+00_JPRB &
  &, 0.133625E+00_JPRB, 0.127452E+00_JPRB, 0.121467E+00_JPRB, 0.115685E+00_JPRB &
  &, 0.110121E+00_JPRB, 0.104791E+00_JPRB, 0.996563E-01_JPRB &
  &, 0.946204E-01_JPRB, 0.899726E-01_JPRB, 0.853941E-01_JPRB, 0.810073E-01_JPRB &
  &, 0.768249E-01_JPRB, 0.728004E-01_JPRB, 0.689442E-01_JPRB &
  &, 0.652672E-01_JPRB, 0.617800E-01_JPRB, 0.583691E-01_JPRB, 0.551669E-01_JPRB &
  &, 0.521209E-01_JPRB, 0.491752E-01_JPRB, 0.464021E-01_JPRB/)
XCW( 672, :) = (/ &
  &  0.104169E+01_JPRB, 0.105123E+01_JPRB, 0.106039E+01_JPRB, 0.106917E+01_JPRB &
  &, 0.107756E+01_JPRB, 0.108557E+01_JPRB, 0.109317E+01_JPRB &
  &, 0.110037E+01_JPRB, 0.110716E+01_JPRB, 0.111353E+01_JPRB, 0.111948E+01_JPRB &
  &, 0.112500E+01_JPRB, 0.113008E+01_JPRB, 0.113473E+01_JPRB &
  &, 0.113893E+01_JPRB, 0.114269E+01_JPRB, 0.114599E+01_JPRB, 0.114884E+01_JPRB &
  &, 0.115122E+01_JPRB, 0.115314E+01_JPRB, 0.115460E+01_JPRB &
  &, 0.115556E+01_JPRB, 0.115609E+01_JPRB, 0.115614E+01_JPRB, 0.115570E+01_JPRB &
  &, 0.115479E+01_JPRB, 0.115341E+01_JPRB, 0.115155E+01_JPRB &
  &, 0.114922E+01_JPRB, 0.114641E+01_JPRB, 0.114313E+01_JPRB, 0.113939E+01_JPRB &
  &, 0.113517E+01_JPRB, 0.113050E+01_JPRB, 0.112536E+01_JPRB &
  &, 0.111977E+01_JPRB, 0.111374E+01_JPRB, 0.110726E+01_JPRB, 0.110034E+01_JPRB &
  &, 0.109300E+01_JPRB, 0.108522E+01_JPRB, 0.107705E+01_JPRB &
  &, 0.106846E+01_JPRB, 0.105948E+01_JPRB, 0.105010E+01_JPRB, 0.104035E+01_JPRB &
  &, 0.103024E+01_JPRB, 0.101976E+01_JPRB, 0.100895E+01_JPRB &
  &, 0.997797E+00_JPRB, 0.986319E+00_JPRB, 0.974549E+00_JPRB, 0.962469E+00_JPRB &
  &, 0.950100E+00_JPRB, 0.937482E+00_JPRB, 0.924584E+00_JPRB &
  &, 0.911462E+00_JPRB, 0.898101E+00_JPRB, 0.884530E+00_JPRB, 0.870750E+00_JPRB &
  &, 0.856792E+00_JPRB, 0.842674E+00_JPRB, 0.828379E+00_JPRB &
  &, 0.813959E+00_JPRB, 0.799396E+00_JPRB, 0.784727E+00_JPRB, 0.769950E+00_JPRB &
  &, 0.755103E+00_JPRB, 0.740167E+00_JPRB, 0.725197E+00_JPRB &
  &, 0.710173E+00_JPRB, 0.695133E+00_JPRB, 0.680073E+00_JPRB, 0.665010E+00_JPRB &
  &, 0.649960E+00_JPRB, 0.634942E+00_JPRB, 0.619946E+00_JPRB &
  &, 0.605011E+00_JPRB, 0.590154E+00_JPRB, 0.575364E+00_JPRB, 0.560679E+00_JPRB &
  &, 0.546062E+00_JPRB, 0.531575E+00_JPRB, 0.517204E+00_JPRB &
  &, 0.502960E+00_JPRB, 0.488879E+00_JPRB, 0.474943E+00_JPRB, 0.461160E+00_JPRB &
  &, 0.447536E+00_JPRB, 0.434076E+00_JPRB, 0.420847E+00_JPRB &
  &, 0.407760E+00_JPRB, 0.394911E+00_JPRB, 0.382239E+00_JPRB, 0.369810E+00_JPRB &
  &, 0.357556E+00_JPRB, 0.345544E+00_JPRB, 0.333771E+00_JPRB &
  &, 0.322197E+00_JPRB, 0.310889E+00_JPRB, 0.299805E+00_JPRB, 0.288936E+00_JPRB &
  &, 0.278348E+00_JPRB, 0.267994E+00_JPRB, 0.257863E+00_JPRB &
  &, 0.248020E+00_JPRB, 0.238371E+00_JPRB, 0.229023E+00_JPRB, 0.219877E+00_JPRB &
  &, 0.210999E+00_JPRB, 0.202370E+00_JPRB, 0.194013E+00_JPRB &
  &, 0.185863E+00_JPRB, 0.177986E+00_JPRB, 0.170312E+00_JPRB, 0.162907E+00_JPRB &
  &, 0.155697E+00_JPRB, 0.148749E+00_JPRB, 0.142034E+00_JPRB &
  &, 0.135569E+00_JPRB, 0.129324E+00_JPRB, 0.123264E+00_JPRB, 0.117456E+00_JPRB &
  &, 0.111812E+00_JPRB, 0.106399E+00_JPRB, 0.101233E+00_JPRB &
  &, 0.962193E-01_JPRB, 0.914263E-01_JPRB, 0.868115E-01_JPRB, 0.823870E-01_JPRB &
  &, 0.781071E-01_JPRB, 0.740411E-01_JPRB, 0.701421E-01_JPRB &
  &, 0.664205E-01_JPRB, 0.628874E-01_JPRB, 0.594914E-01_JPRB, 0.561778E-01_JPRB &
  &, 0.530812E-01_JPRB, 0.501481E-01_JPRB, 0.473220E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART96',1,ZHOOK_HANDLE)
END SUBROUTINE PART96

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART97

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART97',0,ZHOOK_HANDLE)

XCW( 673, :) = (/ &
  &  0.104198E+01_JPRB, 0.105159E+01_JPRB, 0.106082E+01_JPRB, 0.106968E+01_JPRB &
  &, 0.107815E+01_JPRB, 0.108623E+01_JPRB, 0.109391E+01_JPRB &
  &, 0.110119E+01_JPRB, 0.110805E+01_JPRB, 0.111450E+01_JPRB, 0.112053E+01_JPRB &
  &, 0.112613E+01_JPRB, 0.113129E+01_JPRB, 0.113602E+01_JPRB &
  &, 0.114030E+01_JPRB, 0.114414E+01_JPRB, 0.114752E+01_JPRB, 0.115044E+01_JPRB &
  &, 0.115291E+01_JPRB, 0.115491E+01_JPRB, 0.115644E+01_JPRB &
  &, 0.115751E+01_JPRB, 0.115810E+01_JPRB, 0.115822E+01_JPRB, 0.115786E+01_JPRB &
  &, 0.115703E+01_JPRB, 0.115573E+01_JPRB, 0.115395E+01_JPRB &
  &, 0.115169E+01_JPRB, 0.114896E+01_JPRB, 0.114576E+01_JPRB, 0.114208E+01_JPRB &
  &, 0.113794E+01_JPRB, 0.113334E+01_JPRB, 0.112828E+01_JPRB &
  &, 0.112276E+01_JPRB, 0.111679E+01_JPRB, 0.111038E+01_JPRB, 0.110353E+01_JPRB &
  &, 0.109625E+01_JPRB, 0.108854E+01_JPRB, 0.108042E+01_JPRB &
  &, 0.107189E+01_JPRB, 0.106297E+01_JPRB, 0.105366E+01_JPRB, 0.104396E+01_JPRB &
  &, 0.103388E+01_JPRB, 0.102348E+01_JPRB, 0.101271E+01_JPRB &
  &, 0.100161E+01_JPRB, 0.990181E+00_JPRB, 0.978436E+00_JPRB, 0.966407E+00_JPRB &
  &, 0.954089E+00_JPRB, 0.941492E+00_JPRB, 0.928642E+00_JPRB &
  &, 0.915538E+00_JPRB, 0.902208E+00_JPRB, 0.888668E+00_JPRB, 0.874916E+00_JPRB &
  &, 0.860985E+00_JPRB, 0.846875E+00_JPRB, 0.832603E+00_JPRB &
  &, 0.818187E+00_JPRB, 0.803644E+00_JPRB, 0.788992E+00_JPRB, 0.774231E+00_JPRB &
  &, 0.759378E+00_JPRB, 0.744453E+00_JPRB, 0.729472E+00_JPRB &
  &, 0.714454E+00_JPRB, 0.699396E+00_JPRB, 0.684315E+00_JPRB, 0.669251E+00_JPRB &
  &, 0.654197E+00_JPRB, 0.639148E+00_JPRB, 0.624142E+00_JPRB &
  &, 0.609195E+00_JPRB, 0.594322E+00_JPRB, 0.579488E+00_JPRB, 0.564781E+00_JPRB &
  &, 0.550138E+00_JPRB, 0.535623E+00_JPRB, 0.521221E+00_JPRB &
  &, 0.506942E+00_JPRB, 0.492795E+00_JPRB, 0.478817E+00_JPRB, 0.464989E+00_JPRB &
  &, 0.451345E+00_JPRB, 0.437833E+00_JPRB, 0.424548E+00_JPRB &
  &, 0.411433E+00_JPRB, 0.398521E+00_JPRB, 0.385815E+00_JPRB, 0.373283E+00_JPRB &
  &, 0.361022E+00_JPRB, 0.348932E+00_JPRB, 0.337077E+00_JPRB &
  &, 0.325488E+00_JPRB, 0.314091E+00_JPRB, 0.302950E+00_JPRB, 0.292059E+00_JPRB &
  &, 0.281370E+00_JPRB, 0.270950E+00_JPRB, 0.260788E+00_JPRB &
  &, 0.250832E+00_JPRB, 0.241147E+00_JPRB, 0.231719E+00_JPRB, 0.222532E+00_JPRB &
  &, 0.213611E+00_JPRB, 0.204892E+00_JPRB, 0.196443E+00_JPRB &
  &, 0.188241E+00_JPRB, 0.180310E+00_JPRB, 0.172579E+00_JPRB, 0.165115E+00_JPRB &
  &, 0.157843E+00_JPRB, 0.150830E+00_JPRB, 0.144048E+00_JPRB &
  &, 0.137514E+00_JPRB, 0.131196E+00_JPRB, 0.125112E+00_JPRB, 0.119227E+00_JPRB &
  &, 0.113556E+00_JPRB, 0.108061E+00_JPRB, 0.102809E+00_JPRB &
  &, 0.977631E-01_JPRB, 0.928800E-01_JPRB, 0.882289E-01_JPRB, 0.837666E-01_JPRB &
  &, 0.794476E-01_JPRB, 0.753409E-01_JPRB, 0.713998E-01_JPRB &
  &, 0.676346E-01_JPRB, 0.639949E-01_JPRB, 0.605513E-01_JPRB, 0.572519E-01_JPRB &
  &, 0.541055E-01_JPRB, 0.511211E-01_JPRB, 0.482420E-01_JPRB/)
XCW( 674, :) = (/ &
  &  0.104227E+01_JPRB, 0.105194E+01_JPRB, 0.106125E+01_JPRB, 0.107018E+01_JPRB &
  &, 0.107873E+01_JPRB, 0.108689E+01_JPRB, 0.109465E+01_JPRB &
  &, 0.110200E+01_JPRB, 0.110895E+01_JPRB, 0.111547E+01_JPRB, 0.112158E+01_JPRB &
  &, 0.112726E+01_JPRB, 0.113250E+01_JPRB, 0.113731E+01_JPRB &
  &, 0.114167E+01_JPRB, 0.114559E+01_JPRB, 0.114905E+01_JPRB, 0.115206E+01_JPRB &
  &, 0.115460E+01_JPRB, 0.115668E+01_JPRB, 0.115829E+01_JPRB &
  &, 0.115944E+01_JPRB, 0.116011E+01_JPRB, 0.116031E+01_JPRB, 0.116004E+01_JPRB &
  &, 0.115928E+01_JPRB, 0.115806E+01_JPRB, 0.115635E+01_JPRB &
  &, 0.115417E+01_JPRB, 0.115152E+01_JPRB, 0.114839E+01_JPRB, 0.114479E+01_JPRB &
  &, 0.114072E+01_JPRB, 0.113619E+01_JPRB, 0.113120E+01_JPRB &
  &, 0.112576E+01_JPRB, 0.111985E+01_JPRB, 0.111350E+01_JPRB, 0.110672E+01_JPRB &
  &, 0.109951E+01_JPRB, 0.109187E+01_JPRB, 0.108381E+01_JPRB &
  &, 0.107535E+01_JPRB, 0.106648E+01_JPRB, 0.105722E+01_JPRB, 0.104758E+01_JPRB &
  &, 0.103757E+01_JPRB, 0.102721E+01_JPRB, 0.101649E+01_JPRB &
  &, 0.100543E+01_JPRB, 0.994044E+00_JPRB, 0.982351E+00_JPRB, 0.970359E+00_JPRB &
  &, 0.958077E+00_JPRB, 0.945530E+00_JPRB, 0.932715E+00_JPRB &
  &, 0.919645E+00_JPRB, 0.906347E+00_JPRB, 0.892821E+00_JPRB, 0.879098E+00_JPRB &
  &, 0.865195E+00_JPRB, 0.851111E+00_JPRB, 0.836846E+00_JPRB &
  &, 0.822451E+00_JPRB, 0.807910E+00_JPRB, 0.793276E+00_JPRB, 0.778512E+00_JPRB &
  &, 0.763673E+00_JPRB, 0.748739E+00_JPRB, 0.733767E+00_JPRB &
  &, 0.718735E+00_JPRB, 0.703681E+00_JPRB, 0.688602E+00_JPRB, 0.673514E+00_JPRB &
  &, 0.658456E+00_JPRB, 0.643401E+00_JPRB, 0.628386E+00_JPRB &
  &, 0.613402E+00_JPRB, 0.598490E+00_JPRB, 0.583662E+00_JPRB, 0.568909E+00_JPRB &
  &, 0.554241E+00_JPRB, 0.539699E+00_JPRB, 0.525238E+00_JPRB &
  &, 0.510952E+00_JPRB, 0.496767E+00_JPRB, 0.482749E+00_JPRB, 0.468876E+00_JPRB &
  &, 0.455155E+00_JPRB, 0.441621E+00_JPRB, 0.428280E+00_JPRB &
  &, 0.415106E+00_JPRB, 0.402164E+00_JPRB, 0.389392E+00_JPRB, 0.376822E+00_JPRB &
  &, 0.364488E+00_JPRB, 0.352354E+00_JPRB, 0.340453E+00_JPRB &
  &, 0.328779E+00_JPRB, 0.317329E+00_JPRB, 0.306132E+00_JPRB, 0.295181E+00_JPRB &
  &, 0.284430E+00_JPRB, 0.273944E+00_JPRB, 0.263713E+00_JPRB &
  &, 0.253725E+00_JPRB, 0.243964E+00_JPRB, 0.234458E+00_JPRB, 0.225230E+00_JPRB &
  &, 0.216223E+00_JPRB, 0.207459E+00_JPRB, 0.198917E+00_JPRB &
  &, 0.190664E+00_JPRB, 0.182634E+00_JPRB, 0.174846E+00_JPRB, 0.167322E+00_JPRB &
  &, 0.160037E+00_JPRB, 0.152960E+00_JPRB, 0.146111E+00_JPRB &
  &, 0.139508E+00_JPRB, 0.133119E+00_JPRB, 0.126960E+00_JPRB, 0.120998E+00_JPRB &
  &, 0.115246E+00_JPRB, 0.109722E+00_JPRB, 0.104440E+00_JPRB &
  &, 0.993069E-01_JPRB, 0.943897E-01_JPRB, 0.897030E-01_JPRB, 0.851463E-01_JPRB &
  &, 0.807880E-01_JPRB, 0.766408E-01_JPRB, 0.726575E-01_JPRB &
  &, 0.687880E-01_JPRB, 0.651638E-01_JPRB, 0.616736E-01_JPRB, 0.583260E-01_JPRB &
  &, 0.551298E-01_JPRB, 0.520291E-01_JPRB, 0.491619E-01_JPRB/)
XCW( 675, :) = (/ &
  &  0.104255E+01_JPRB, 0.105230E+01_JPRB, 0.106169E+01_JPRB, 0.107069E+01_JPRB &
  &, 0.107932E+01_JPRB, 0.108755E+01_JPRB, 0.109539E+01_JPRB &
  &, 0.110282E+01_JPRB, 0.110984E+01_JPRB, 0.111645E+01_JPRB, 0.112263E+01_JPRB &
  &, 0.112839E+01_JPRB, 0.113372E+01_JPRB, 0.113860E+01_JPRB &
  &, 0.114305E+01_JPRB, 0.114704E+01_JPRB, 0.115058E+01_JPRB, 0.115367E+01_JPRB &
  &, 0.115630E+01_JPRB, 0.115846E+01_JPRB, 0.116015E+01_JPRB &
  &, 0.116138E+01_JPRB, 0.116213E+01_JPRB, 0.116241E+01_JPRB, 0.116221E+01_JPRB &
  &, 0.116154E+01_JPRB, 0.116039E+01_JPRB, 0.115876E+01_JPRB &
  &, 0.115666E+01_JPRB, 0.115408E+01_JPRB, 0.115103E+01_JPRB, 0.114750E+01_JPRB &
  &, 0.114351E+01_JPRB, 0.113905E+01_JPRB, 0.113413E+01_JPRB &
  &, 0.112875E+01_JPRB, 0.112292E+01_JPRB, 0.111665E+01_JPRB, 0.110993E+01_JPRB &
  &, 0.110278E+01_JPRB, 0.109520E+01_JPRB, 0.108721E+01_JPRB &
  &, 0.107880E+01_JPRB, 0.107000E+01_JPRB, 0.106080E+01_JPRB, 0.105122E+01_JPRB &
  &, 0.104126E+01_JPRB, 0.103094E+01_JPRB, 0.102028E+01_JPRB &
  &, 0.100927E+01_JPRB, 0.997934E+00_JPRB, 0.986293E+00_JPRB, 0.974339E+00_JPRB &
  &, 0.962094E+00_JPRB, 0.949569E+00_JPRB, 0.936789E+00_JPRB &
  &, 0.923767E+00_JPRB, 0.910502E+00_JPRB, 0.897007E+00_JPRB, 0.883314E+00_JPRB &
  &, 0.869422E+00_JPRB, 0.855347E+00_JPRB, 0.841123E+00_JPRB &
  &, 0.826734E+00_JPRB, 0.812213E+00_JPRB, 0.797579E+00_JPRB, 0.782832E+00_JPRB &
  &, 0.767988E+00_JPRB, 0.753066E+00_JPRB, 0.738083E+00_JPRB &
  &, 0.723058E+00_JPRB, 0.707988E+00_JPRB, 0.692910E+00_JPRB, 0.677822E+00_JPRB &
  &, 0.662739E+00_JPRB, 0.647654E+00_JPRB, 0.632630E+00_JPRB &
  &, 0.617634E+00_JPRB, 0.602707E+00_JPRB, 0.587837E+00_JPRB, 0.573062E+00_JPRB &
  &, 0.558370E+00_JPRB, 0.543774E+00_JPRB, 0.529310E+00_JPRB &
  &, 0.514962E+00_JPRB, 0.500768E+00_JPRB, 0.486680E+00_JPRB, 0.472792E+00_JPRB &
  &, 0.459024E+00_JPRB, 0.445439E+00_JPRB, 0.432044E+00_JPRB &
  &, 0.418842E+00_JPRB, 0.405806E+00_JPRB, 0.393001E+00_JPRB, 0.380395E+00_JPRB &
  &, 0.367988E+00_JPRB, 0.355811E+00_JPRB, 0.343864E+00_JPRB &
  &, 0.332107E+00_JPRB, 0.320604E+00_JPRB, 0.309351E+00_JPRB, 0.298304E+00_JPRB &
  &, 0.287529E+00_JPRB, 0.276978E+00_JPRB, 0.266678E+00_JPRB &
  &, 0.256617E+00_JPRB, 0.246782E+00_JPRB, 0.237237E+00_JPRB, 0.227928E+00_JPRB &
  &, 0.218835E+00_JPRB, 0.210025E+00_JPRB, 0.201435E+00_JPRB &
  &, 0.193132E+00_JPRB, 0.185003E+00_JPRB, 0.177159E+00_JPRB, 0.169577E+00_JPRB &
  &, 0.162182E+00_JPRB, 0.155090E+00_JPRB, 0.148174E+00_JPRB &
  &, 0.141502E+00_JPRB, 0.135041E+00_JPRB, 0.128808E+00_JPRB, 0.122821E+00_JPRB &
  &, 0.117043E+00_JPRB, 0.111437E+00_JPRB, 0.106071E+00_JPRB &
  &, 0.100906E+00_JPRB, 0.959552E-01_JPRB, 0.911770E-01_JPRB, 0.865835E-01_JPRB &
  &, 0.821868E-01_JPRB, 0.779406E-01_JPRB, 0.739152E-01_JPRB &
  &, 0.700021E-01_JPRB, 0.663328E-01_JPRB, 0.627959E-01_JPRB, 0.594001E-01_JPRB &
  &, 0.561541E-01_JPRB, 0.530669E-01_JPRB, 0.500819E-01_JPRB/)
XCW( 676, :) = (/ &
  &  0.104284E+01_JPRB, 0.105266E+01_JPRB, 0.106212E+01_JPRB, 0.107120E+01_JPRB &
  &, 0.107990E+01_JPRB, 0.108821E+01_JPRB, 0.109613E+01_JPRB &
  &, 0.110364E+01_JPRB, 0.111074E+01_JPRB, 0.111742E+01_JPRB, 0.112369E+01_JPRB &
  &, 0.112952E+01_JPRB, 0.113493E+01_JPRB, 0.113990E+01_JPRB &
  &, 0.114442E+01_JPRB, 0.114850E+01_JPRB, 0.115212E+01_JPRB, 0.115529E+01_JPRB &
  &, 0.115800E+01_JPRB, 0.116024E+01_JPRB, 0.116201E+01_JPRB &
  &, 0.116332E+01_JPRB, 0.116415E+01_JPRB, 0.116451E+01_JPRB, 0.116439E+01_JPRB &
  &, 0.116380E+01_JPRB, 0.116273E+01_JPRB, 0.116118E+01_JPRB &
  &, 0.115915E+01_JPRB, 0.115665E+01_JPRB, 0.115367E+01_JPRB, 0.115023E+01_JPRB &
  &, 0.114631E+01_JPRB, 0.114192E+01_JPRB, 0.113707E+01_JPRB &
  &, 0.113176E+01_JPRB, 0.112600E+01_JPRB, 0.111980E+01_JPRB, 0.111315E+01_JPRB &
  &, 0.110605E+01_JPRB, 0.109855E+01_JPRB, 0.109062E+01_JPRB &
  &, 0.108228E+01_JPRB, 0.107353E+01_JPRB, 0.106439E+01_JPRB, 0.105486E+01_JPRB &
  &, 0.104496E+01_JPRB, 0.103470E+01_JPRB, 0.102408E+01_JPRB &
  &, 0.101312E+01_JPRB, 0.100184E+01_JPRB, 0.990235E+00_JPRB, 0.978319E+00_JPRB &
  &, 0.966126E+00_JPRB, 0.953637E+00_JPRB, 0.940892E+00_JPRB &
  &, 0.927905E+00_JPRB, 0.914657E+00_JPRB, 0.901177E+00_JPRB, 0.887529E+00_JPRB &
  &, 0.873666E+00_JPRB, 0.859617E+00_JPRB, 0.845401E+00_JPRB &
  &, 0.831035E+00_JPRB, 0.816535E+00_JPRB, 0.801902E+00_JPRB, 0.787151E+00_JPRB &
  &, 0.772322E+00_JPRB, 0.757413E+00_JPRB, 0.742440E+00_JPRB &
  &, 0.727402E+00_JPRB, 0.712337E+00_JPRB, 0.697241E+00_JPRB, 0.682130E+00_JPRB &
  &, 0.667044E+00_JPRB, 0.651954E+00_JPRB, 0.636897E+00_JPRB &
  &, 0.621891E+00_JPRB, 0.606949E+00_JPRB, 0.592062E+00_JPRB, 0.577241E+00_JPRB &
  &, 0.562526E+00_JPRB, 0.547902E+00_JPRB, 0.533408E+00_JPRB &
  &, 0.519028E+00_JPRB, 0.504769E+00_JPRB, 0.490670E+00_JPRB, 0.476709E+00_JPRB &
  &, 0.462923E+00_JPRB, 0.449287E+00_JPRB, 0.435838E+00_JPRB &
  &, 0.422579E+00_JPRB, 0.409513E+00_JPRB, 0.396642E+00_JPRB, 0.383968E+00_JPRB &
  &, 0.371521E+00_JPRB, 0.359303E+00_JPRB, 0.347276E+00_JPRB &
  &, 0.335469E+00_JPRB, 0.323915E+00_JPRB, 0.312608E+00_JPRB, 0.301503E+00_JPRB &
  &, 0.290628E+00_JPRB, 0.280050E+00_JPRB, 0.269682E+00_JPRB &
  &, 0.259550E+00_JPRB, 0.249680E+00_JPRB, 0.240017E+00_JPRB, 0.230668E+00_JPRB &
  &, 0.221533E+00_JPRB, 0.212635E+00_JPRB, 0.203998E+00_JPRB &
  &, 0.195600E+00_JPRB, 0.187418E+00_JPRB, 0.179519E+00_JPRB, 0.171832E+00_JPRB &
  &, 0.164423E+00_JPRB, 0.157220E+00_JPRB, 0.150238E+00_JPRB &
  &, 0.143496E+00_JPRB, 0.137014E+00_JPRB, 0.130708E+00_JPRB, 0.124644E+00_JPRB &
  &, 0.118787E+00_JPRB, 0.113152E+00_JPRB, 0.107756E+00_JPRB &
  &, 0.102505E+00_JPRB, 0.974648E-01_JPRB, 0.926511E-01_JPRB, 0.880206E-01_JPRB &
  &, 0.835856E-01_JPRB, 0.792995E-01_JPRB, 0.751729E-01_JPRB &
  &, 0.712769E-01_JPRB, 0.675017E-01_JPRB, 0.639182E-01_JPRB, 0.604741E-01_JPRB &
  &, 0.571784E-01_JPRB, 0.540399E-01_JPRB, 0.510676E-01_JPRB/)
XCW( 677, :) = (/ &
  &  0.104312E+01_JPRB, 0.105302E+01_JPRB, 0.106256E+01_JPRB, 0.107171E+01_JPRB &
  &, 0.108049E+01_JPRB, 0.108888E+01_JPRB, 0.109687E+01_JPRB &
  &, 0.110446E+01_JPRB, 0.111164E+01_JPRB, 0.111840E+01_JPRB, 0.112474E+01_JPRB &
  &, 0.113066E+01_JPRB, 0.113615E+01_JPRB, 0.114119E+01_JPRB &
  &, 0.114580E+01_JPRB, 0.114996E+01_JPRB, 0.115366E+01_JPRB, 0.115691E+01_JPRB &
  &, 0.115970E+01_JPRB, 0.116202E+01_JPRB, 0.116388E+01_JPRB &
  &, 0.116526E+01_JPRB, 0.116618E+01_JPRB, 0.116661E+01_JPRB, 0.116658E+01_JPRB &
  &, 0.116606E+01_JPRB, 0.116507E+01_JPRB, 0.116359E+01_JPRB &
  &, 0.116165E+01_JPRB, 0.115923E+01_JPRB, 0.115633E+01_JPRB, 0.115295E+01_JPRB &
  &, 0.114911E+01_JPRB, 0.114480E+01_JPRB, 0.114002E+01_JPRB &
  &, 0.113479E+01_JPRB, 0.112910E+01_JPRB, 0.112296E+01_JPRB, 0.111638E+01_JPRB &
  &, 0.110936E+01_JPRB, 0.110191E+01_JPRB, 0.109404E+01_JPRB &
  &, 0.108577E+01_JPRB, 0.107708E+01_JPRB, 0.106799E+01_JPRB, 0.105852E+01_JPRB &
  &, 0.104868E+01_JPRB, 0.103846E+01_JPRB, 0.102791E+01_JPRB &
  &, 0.101699E+01_JPRB, 0.100575E+01_JPRB, 0.994191E+00_JPRB, 0.982328E+00_JPRB &
  &, 0.970173E+00_JPRB, 0.957720E+00_JPRB, 0.945011E+00_JPRB &
  &, 0.932058E+00_JPRB, 0.918843E+00_JPRB, 0.905411E+00_JPRB, 0.891778E+00_JPRB &
  &, 0.877926E+00_JPRB, 0.863905E+00_JPRB, 0.849715E+00_JPRB &
  &, 0.835354E+00_JPRB, 0.820857E+00_JPRB, 0.806243E+00_JPRB, 0.791510E+00_JPRB &
  &, 0.776696E+00_JPRB, 0.761780E+00_JPRB, 0.746797E+00_JPRB &
  &, 0.731768E+00_JPRB, 0.716708E+00_JPRB, 0.701594E+00_JPRB, 0.686483E+00_JPRB &
  &, 0.671372E+00_JPRB, 0.656277E+00_JPRB, 0.641213E+00_JPRB &
  &, 0.626171E+00_JPRB, 0.611216E+00_JPRB, 0.596286E+00_JPRB, 0.581446E+00_JPRB &
  &, 0.566708E+00_JPRB, 0.552058E+00_JPRB, 0.537535E+00_JPRB &
  &, 0.523093E+00_JPRB, 0.508827E+00_JPRB, 0.494457E+00_JPRB, 0.480684E+00_JPRB &
  &, 0.466852E+00_JPRB, 0.453167E+00_JPRB, 0.439663E+00_JPRB &
  &, 0.426379E+00_JPRB, 0.413252E+00_JPRB, 0.400317E+00_JPRB, 0.387607E+00_JPRB &
  &, 0.375089E+00_JPRB, 0.362795E+00_JPRB, 0.350722E+00_JPRB &
  &, 0.338868E+00_JPRB, 0.327262E+00_JPRB, 0.315864E+00_JPRB, 0.304701E+00_JPRB &
  &, 0.293803E+00_JPRB, 0.283122E+00_JPRB, 0.272686E+00_JPRB &
  &, 0.262483E+00_JPRB, 0.252579E+00_JPRB, 0.242880E+00_JPRB, 0.233408E+00_JPRB &
  &, 0.224231E+00_JPRB, 0.215245E+00_JPRB, 0.206561E+00_JPRB &
  &, 0.198068E+00_JPRB, 0.189878E+00_JPRB, 0.181878E+00_JPRB, 0.174180E+00_JPRB &
  &, 0.166665E+00_JPRB, 0.159398E+00_JPRB, 0.152350E+00_JPRB &
  &, 0.145590E+00_JPRB, 0.138987E+00_JPRB, 0.132658E+00_JPRB, 0.126518E+00_JPRB &
  &, 0.120636E+00_JPRB, 0.114921E+00_JPRB, 0.109442E+00_JPRB &
  &, 0.104159E+00_JPRB, 0.990863E-01_JPRB, 0.941819E-01_JPRB, 0.894577E-01_JPRB &
  &, 0.849843E-01_JPRB, 0.806584E-01_JPRB, 0.764905E-01_JPRB &
  &, 0.724910E-01_JPRB, 0.687322E-01_JPRB, 0.650405E-01_JPRB, 0.616114E-01_JPRB &
  &, 0.582667E-01_JPRB, 0.550776E-01_JPRB, 0.520532E-01_JPRB/)
XCW( 678, :) = (/ &
  &  0.104341E+01_JPRB, 0.105338E+01_JPRB, 0.106299E+01_JPRB, 0.107223E+01_JPRB &
  &, 0.108108E+01_JPRB, 0.108954E+01_JPRB, 0.109761E+01_JPRB &
  &, 0.110528E+01_JPRB, 0.111254E+01_JPRB, 0.111938E+01_JPRB, 0.112580E+01_JPRB &
  &, 0.113180E+01_JPRB, 0.113737E+01_JPRB, 0.114250E+01_JPRB &
  &, 0.114718E+01_JPRB, 0.115142E+01_JPRB, 0.115521E+01_JPRB, 0.115854E+01_JPRB &
  &, 0.116141E+01_JPRB, 0.116381E+01_JPRB, 0.116575E+01_JPRB &
  &, 0.116721E+01_JPRB, 0.116821E+01_JPRB, 0.116873E+01_JPRB, 0.116877E+01_JPRB &
  &, 0.116834E+01_JPRB, 0.116742E+01_JPRB, 0.116603E+01_JPRB &
  &, 0.116416E+01_JPRB, 0.116181E+01_JPRB, 0.115899E+01_JPRB, 0.115569E+01_JPRB &
  &, 0.115192E+01_JPRB, 0.114768E+01_JPRB, 0.114298E+01_JPRB &
  &, 0.113782E+01_JPRB, 0.113220E+01_JPRB, 0.112613E+01_JPRB, 0.111962E+01_JPRB &
  &, 0.111267E+01_JPRB, 0.110529E+01_JPRB, 0.109748E+01_JPRB &
  &, 0.108926E+01_JPRB, 0.108063E+01_JPRB, 0.107161E+01_JPRB, 0.106219E+01_JPRB &
  &, 0.105240E+01_JPRB, 0.104225E+01_JPRB, 0.103173E+01_JPRB &
  &, 0.102088E+01_JPRB, 0.100968E+01_JPRB, 0.998174E+00_JPRB, 0.986350E+00_JPRB &
  &, 0.974233E+00_JPRB, 0.961818E+00_JPRB, 0.949145E+00_JPRB &
  &, 0.936227E+00_JPRB, 0.923045E+00_JPRB, 0.909646E+00_JPRB, 0.896027E+00_JPRB &
  &, 0.882221E+00_JPRB, 0.868210E+00_JPRB, 0.854028E+00_JPRB &
  &, 0.839709E+00_JPRB, 0.825216E+00_JPRB, 0.810622E+00_JPRB, 0.795888E+00_JPRB &
  &, 0.781070E+00_JPRB, 0.766167E+00_JPRB, 0.751196E+00_JPRB &
  &, 0.736154E+00_JPRB, 0.721079E+00_JPRB, 0.705990E+00_JPRB, 0.690858E+00_JPRB &
  &, 0.675746E+00_JPRB, 0.660623E+00_JPRB, 0.645552E+00_JPRB &
  &, 0.630501E+00_JPRB, 0.615483E+00_JPRB, 0.600562E+00_JPRB, 0.585702E+00_JPRB &
  &, 0.570916E+00_JPRB, 0.556240E+00_JPRB, 0.541661E+00_JPRB &
  &, 0.527215E+00_JPRB, 0.512884E+00_JPRB, 0.498706E+00_JPRB, 0.484660E+00_JPRB &
  &, 0.470781E+00_JPRB, 0.457076E+00_JPRB, 0.443551E+00_JPRB &
  &, 0.430178E+00_JPRB, 0.417024E+00_JPRB, 0.404025E+00_JPRB, 0.391247E+00_JPRB &
  &, 0.378691E+00_JPRB, 0.366356E+00_JPRB, 0.354204E+00_JPRB &
  &, 0.342302E+00_JPRB, 0.330610E+00_JPRB, 0.319157E+00_JPRB, 0.307974E+00_JPRB &
  &, 0.296978E+00_JPRB, 0.286233E+00_JPRB, 0.275730E+00_JPRB &
  &, 0.265496E+00_JPRB, 0.255478E+00_JPRB, 0.245742E+00_JPRB, 0.236232E+00_JPRB &
  &, 0.226929E+00_JPRB, 0.217942E+00_JPRB, 0.209167E+00_JPRB &
  &, 0.200625E+00_JPRB, 0.192339E+00_JPRB, 0.184284E+00_JPRB, 0.176482E+00_JPRB &
  &, 0.168906E+00_JPRB, 0.161624E+00_JPRB, 0.154512E+00_JPRB &
  &, 0.147635E+00_JPRB, 0.141011E+00_JPRB, 0.134609E+00_JPRB, 0.128393E+00_JPRB &
  &, 0.122432E+00_JPRB, 0.116690E+00_JPRB, 0.111127E+00_JPRB &
  &, 0.105813E+00_JPRB, 0.100652E+00_JPRB, 0.957127E-01_JPRB, 0.909524E-01_JPRB &
  &, 0.863831E-01_JPRB, 0.820173E-01_JPRB, 0.778081E-01_JPRB &
  &, 0.737658E-01_JPRB, 0.699627E-01_JPRB, 0.662251E-01_JPRB, 0.626855E-01_JPRB &
  &, 0.593550E-01_JPRB, 0.561154E-01_JPRB, 0.530389E-01_JPRB/)
XCW( 679, :) = (/ &
  &  0.104370E+01_JPRB, 0.105375E+01_JPRB, 0.106343E+01_JPRB, 0.107274E+01_JPRB &
  &, 0.108167E+01_JPRB, 0.109021E+01_JPRB, 0.109835E+01_JPRB &
  &, 0.110610E+01_JPRB, 0.111344E+01_JPRB, 0.112036E+01_JPRB, 0.112687E+01_JPRB &
  &, 0.113294E+01_JPRB, 0.113859E+01_JPRB, 0.114380E+01_JPRB &
  &, 0.114857E+01_JPRB, 0.115289E+01_JPRB, 0.115675E+01_JPRB, 0.116016E+01_JPRB &
  &, 0.116312E+01_JPRB, 0.116560E+01_JPRB, 0.116762E+01_JPRB &
  &, 0.116917E+01_JPRB, 0.117024E+01_JPRB, 0.117084E+01_JPRB, 0.117097E+01_JPRB &
  &, 0.117061E+01_JPRB, 0.116978E+01_JPRB, 0.116846E+01_JPRB &
  &, 0.116667E+01_JPRB, 0.116440E+01_JPRB, 0.116165E+01_JPRB, 0.115843E+01_JPRB &
  &, 0.115474E+01_JPRB, 0.115058E+01_JPRB, 0.114595E+01_JPRB &
  &, 0.114086E+01_JPRB, 0.113531E+01_JPRB, 0.112931E+01_JPRB, 0.112286E+01_JPRB &
  &, 0.111598E+01_JPRB, 0.110867E+01_JPRB, 0.110092E+01_JPRB &
  &, 0.109277E+01_JPRB, 0.108420E+01_JPRB, 0.107524E+01_JPRB, 0.106589E+01_JPRB &
  &, 0.105615E+01_JPRB, 0.104605E+01_JPRB, 0.103559E+01_JPRB &
  &, 0.102477E+01_JPRB, 0.101363E+01_JPRB, 0.100216E+01_JPRB, 0.990387E+00_JPRB &
  &, 0.978309E+00_JPRB, 0.965946E+00_JPRB, 0.953309E+00_JPRB &
  &, 0.940411E+00_JPRB, 0.927279E+00_JPRB, 0.913897E+00_JPRB, 0.900309E+00_JPRB &
  &, 0.886516E+00_JPRB, 0.872533E+00_JPRB, 0.858377E+00_JPRB &
  &, 0.844064E+00_JPRB, 0.829612E+00_JPRB, 0.815001E+00_JPRB, 0.800305E+00_JPRB &
  &, 0.785484E+00_JPRB, 0.770595E+00_JPRB, 0.755615E+00_JPRB &
  &, 0.740582E+00_JPRB, 0.725493E+00_JPRB, 0.710386E+00_JPRB, 0.695256E+00_JPRB &
  &, 0.680120E+00_JPRB, 0.664993E+00_JPRB, 0.649891E+00_JPRB &
  &, 0.634830E+00_JPRB, 0.619799E+00_JPRB, 0.604863E+00_JPRB, 0.589959E+00_JPRB &
  &, 0.575150E+00_JPRB, 0.560450E+00_JPRB, 0.545842E+00_JPRB &
  &, 0.531364E+00_JPRB, 0.516999E+00_JPRB, 0.502782E+00_JPRB, 0.488694E+00_JPRB &
  &, 0.474770E+00_JPRB, 0.461017E+00_JPRB, 0.447439E+00_JPRB &
  &, 0.434010E+00_JPRB, 0.420795E+00_JPRB, 0.407765E+00_JPRB, 0.394953E+00_JPRB &
  &, 0.382326E+00_JPRB, 0.369916E+00_JPRB, 0.357721E+00_JPRB &
  &, 0.345772E+00_JPRB, 0.334030E+00_JPRB, 0.322524E+00_JPRB, 0.311247E+00_JPRB &
  &, 0.300191E+00_JPRB, 0.289383E+00_JPRB, 0.278814E+00_JPRB &
  &, 0.268510E+00_JPRB, 0.258459E+00_JPRB, 0.248605E+00_JPRB, 0.239056E+00_JPRB &
  &, 0.229712E+00_JPRB, 0.219943E+00_JPRB, 0.211774E+00_JPRB &
  &, 0.203183E+00_JPRB, 0.194845E+00_JPRB, 0.186736E+00_JPRB, 0.178877E+00_JPRB &
  &, 0.171242E+00_JPRB, 0.163851E+00_JPRB, 0.156673E+00_JPRB &
  &, 0.149728E+00_JPRB, 0.143035E+00_JPRB, 0.136560E+00_JPRB, 0.130321E+00_JPRB &
  &, 0.124282E+00_JPRB, 0.118458E+00_JPRB, 0.112866E+00_JPRB &
  &, 0.107467E+00_JPRB, 0.102273E+00_JPRB, 0.973002E-01_JPRB, 0.924470E-01_JPRB &
  &, 0.878401E-01_JPRB, 0.834353E-01_JPRB, 0.791856E-01_JPRB &
  &, 0.751013E-01_JPRB, 0.711932E-01_JPRB, 0.674721E-01_JPRB, 0.638859E-01_JPRB &
  &, 0.604433E-01_JPRB, 0.571532E-01_JPRB, 0.540246E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART97',1,ZHOOK_HANDLE)
END SUBROUTINE PART97

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART98

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART98',0,ZHOOK_HANDLE)

XCW( 680, :) = (/ &
  &  0.104399E+01_JPRB, 0.105411E+01_JPRB, 0.106387E+01_JPRB, 0.107325E+01_JPRB &
  &, 0.108226E+01_JPRB, 0.109087E+01_JPRB, 0.109910E+01_JPRB &
  &, 0.110692E+01_JPRB, 0.111434E+01_JPRB, 0.112134E+01_JPRB, 0.112793E+01_JPRB &
  &, 0.113409E+01_JPRB, 0.113981E+01_JPRB, 0.114510E+01_JPRB &
  &, 0.114995E+01_JPRB, 0.115436E+01_JPRB, 0.115829E+01_JPRB, 0.116180E+01_JPRB &
  &, 0.116483E+01_JPRB, 0.116740E+01_JPRB, 0.116950E+01_JPRB &
  &, 0.117113E+01_JPRB, 0.117229E+01_JPRB, 0.117296E+01_JPRB, 0.117317E+01_JPRB &
  &, 0.117289E+01_JPRB, 0.117214E+01_JPRB, 0.117091E+01_JPRB &
  &, 0.116919E+01_JPRB, 0.116700E+01_JPRB, 0.116433E+01_JPRB, 0.116119E+01_JPRB &
  &, 0.115757E+01_JPRB, 0.115348E+01_JPRB, 0.114892E+01_JPRB &
  &, 0.114390E+01_JPRB, 0.113843E+01_JPRB, 0.113250E+01_JPRB, 0.112612E+01_JPRB &
  &, 0.111931E+01_JPRB, 0.111206E+01_JPRB, 0.110438E+01_JPRB &
  &, 0.109629E+01_JPRB, 0.108779E+01_JPRB, 0.107888E+01_JPRB, 0.106958E+01_JPRB &
  &, 0.105991E+01_JPRB, 0.104986E+01_JPRB, 0.103945E+01_JPRB &
  &, 0.102869E+01_JPRB, 0.101760E+01_JPRB, 0.100617E+01_JPRB, 0.994438E+00_JPRB &
  &, 0.982398E+00_JPRB, 0.970073E+00_JPRB, 0.957473E+00_JPRB &
  &, 0.944626E+00_JPRB, 0.931513E+00_JPRB, 0.918180E+00_JPRB, 0.904608E+00_JPRB &
  &, 0.890845E+00_JPRB, 0.876890E+00_JPRB, 0.862743E+00_JPRB &
  &, 0.848455E+00_JPRB, 0.834008E+00_JPRB, 0.819418E+00_JPRB, 0.804721E+00_JPRB &
  &, 0.789917E+00_JPRB, 0.775022E+00_JPRB, 0.760055E+00_JPRB &
  &, 0.745011E+00_JPRB, 0.729929E+00_JPRB, 0.714827E+00_JPRB, 0.699677E+00_JPRB &
  &, 0.684540E+00_JPRB, 0.669410E+00_JPRB, 0.654278E+00_JPRB &
  &, 0.639208E+00_JPRB, 0.624165E+00_JPRB, 0.609164E+00_JPRB, 0.594267E+00_JPRB &
  &, 0.579437E+00_JPRB, 0.564686E+00_JPRB, 0.550050E+00_JPRB &
  &, 0.535541E+00_JPRB, 0.521141E+00_JPRB, 0.506858E+00_JPRB, 0.492758E+00_JPRB &
  &, 0.478789E+00_JPRB, 0.464987E+00_JPRB, 0.451358E+00_JPRB &
  &, 0.437905E+00_JPRB, 0.424631E+00_JPRB, 0.411538E+00_JPRB, 0.398659E+00_JPRB &
  &, 0.385996E+00_JPRB, 0.373512E+00_JPRB, 0.361273E+00_JPRB &
  &, 0.349243E+00_JPRB, 0.337450E+00_JPRB, 0.325891E+00_JPRB, 0.314521E+00_JPRB &
  &, 0.303443E+00_JPRB, 0.292572E+00_JPRB, 0.281936E+00_JPRB &
  &, 0.271563E+00_JPRB, 0.261439E+00_JPRB, 0.251551E+00_JPRB, 0.241880E+00_JPRB &
  &, 0.232496E+00_JPRB, 0.223336E+00_JPRB, 0.214425E+00_JPRB &
  &, 0.205786E+00_JPRB, 0.197351E+00_JPRB, 0.189188E+00_JPRB, 0.181226E+00_JPRB &
  &, 0.173531E+00_JPRB, 0.166077E+00_JPRB, 0.158884E+00_JPRB &
  &, 0.151872E+00_JPRB, 0.145109E+00_JPRB, 0.138613E+00_JPRB, 0.132300E+00_JPRB &
  &, 0.126184E+00_JPRB, 0.120281E+00_JPRB, 0.114660E+00_JPRB &
  &, 0.109176E+00_JPRB, 0.103895E+00_JPRB, 0.988877E-01_JPRB, 0.939991E-01_JPRB &
  &, 0.893554E-01_JPRB, 0.848533E-01_JPRB, 0.805630E-01_JPRB &
  &, 0.764368E-01_JPRB, 0.724236E-01_JPRB, 0.686567E-01_JPRB, 0.650232E-01_JPRB &
  &, 0.615957E-01_JPRB, 0.582559E-01_JPRB, 0.550759E-01_JPRB/)
XCW( 681, :) = (/ &
  &  0.104427E+01_JPRB, 0.105447E+01_JPRB, 0.106430E+01_JPRB, 0.107377E+01_JPRB &
  &, 0.108285E+01_JPRB, 0.109154E+01_JPRB, 0.109985E+01_JPRB &
  &, 0.110775E+01_JPRB, 0.111525E+01_JPRB, 0.112233E+01_JPRB, 0.112899E+01_JPRB &
  &, 0.113523E+01_JPRB, 0.114104E+01_JPRB, 0.114641E+01_JPRB &
  &, 0.115134E+01_JPRB, 0.115583E+01_JPRB, 0.115986E+01_JPRB, 0.116343E+01_JPRB &
  &, 0.116655E+01_JPRB, 0.116920E+01_JPRB, 0.117138E+01_JPRB &
  &, 0.117309E+01_JPRB, 0.117433E+01_JPRB, 0.117509E+01_JPRB, 0.117538E+01_JPRB &
  &, 0.117517E+01_JPRB, 0.117451E+01_JPRB, 0.117336E+01_JPRB &
  &, 0.117172E+01_JPRB, 0.116961E+01_JPRB, 0.116701E+01_JPRB, 0.116395E+01_JPRB &
  &, 0.116040E+01_JPRB, 0.115639E+01_JPRB, 0.115191E+01_JPRB &
  &, 0.114696E+01_JPRB, 0.114156E+01_JPRB, 0.113570E+01_JPRB, 0.112939E+01_JPRB &
  &, 0.112265E+01_JPRB, 0.111547E+01_JPRB, 0.110785E+01_JPRB &
  &, 0.109982E+01_JPRB, 0.109138E+01_JPRB, 0.108254E+01_JPRB, 0.107329E+01_JPRB &
  &, 0.106368E+01_JPRB, 0.105289E+01_JPRB, 0.104333E+01_JPRB &
  &, 0.103262E+01_JPRB, 0.102157E+01_JPRB, 0.101019E+01_JPRB, 0.998503E+00_JPRB &
  &, 0.986517E+00_JPRB, 0.974230E+00_JPRB, 0.961668E+00_JPRB &
  &, 0.948842E+00_JPRB, 0.935779E+00_JPRB, 0.922463E+00_JPRB, 0.908923E+00_JPRB &
  &, 0.895190E+00_JPRB, 0.881248E+00_JPRB, 0.867145E+00_JPRB &
  &, 0.852865E+00_JPRB, 0.838423E+00_JPRB, 0.823854E+00_JPRB, 0.809177E+00_JPRB &
  &, 0.794370E+00_JPRB, 0.779490E+00_JPRB, 0.764515E+00_JPRB &
  &, 0.749482E+00_JPRB, 0.734386E+00_JPRB, 0.719267E+00_JPRB, 0.704142E+00_JPRB &
  &, 0.688982E+00_JPRB, 0.673826E+00_JPRB, 0.658689E+00_JPRB &
  &, 0.643586E+00_JPRB, 0.628531E+00_JPRB, 0.613515E+00_JPRB, 0.598575E+00_JPRB &
  &, 0.583724E+00_JPRB, 0.568948E+00_JPRB, 0.554285E+00_JPRB &
  &, 0.539718E+00_JPRB, 0.525284E+00_JPRB, 0.510992E+00_JPRB, 0.496822E+00_JPRB &
  &, 0.482838E+00_JPRB, 0.468989E+00_JPRB, 0.455308E+00_JPRB &
  &, 0.441799E+00_JPRB, 0.428467E+00_JPRB, 0.415344E+00_JPRB, 0.402399E+00_JPRB &
  &, 0.389665E+00_JPRB, 0.377176E+00_JPRB, 0.364861E+00_JPRB &
  &, 0.352784E+00_JPRB, 0.340907E+00_JPRB, 0.329259E+00_JPRB, 0.317870E+00_JPRB &
  &, 0.306694E+00_JPRB, 0.295800E+00_JPRB, 0.285099E+00_JPRB &
  &, 0.274657E+00_JPRB, 0.264461E+00_JPRB, 0.254496E+00_JPRB, 0.244789E+00_JPRB &
  &, 0.235322E+00_JPRB, 0.226077E+00_JPRB, 0.217120E+00_JPRB &
  &, 0.208388E+00_JPRB, 0.199903E+00_JPRB, 0.191686E+00_JPRB, 0.183668E+00_JPRB &
  &, 0.175915E+00_JPRB, 0.168400E+00_JPRB, 0.161095E+00_JPRB &
  &, 0.154066E+00_JPRB, 0.147234E+00_JPRB, 0.140615E+00_JPRB, 0.134227E+00_JPRB &
  &, 0.128086E+00_JPRB, 0.122156E+00_JPRB, 0.116400E+00_JPRB &
  &, 0.110885E+00_JPRB, 0.105572E+00_JPRB, 0.100475E+00_JPRB, 0.955512E-01_JPRB &
  &, 0.908125E-01_JPRB, 0.862713E-01_JPRB, 0.819405E-01_JPRB &
  &, 0.777723E-01_JPRB, 0.737156E-01_JPRB, 0.699037E-01_JPRB, 0.662236E-01_JPRB &
  &, 0.626840E-01_JPRB, 0.593585E-01_JPRB, 0.561273E-01_JPRB/)
XCW( 682, :) = (/ &
  &  0.104456E+01_JPRB, 0.105483E+01_JPRB, 0.106474E+01_JPRB, 0.107428E+01_JPRB &
  &, 0.108344E+01_JPRB, 0.109221E+01_JPRB, 0.110059E+01_JPRB &
  &, 0.110858E+01_JPRB, 0.111615E+01_JPRB, 0.112332E+01_JPRB, 0.113006E+01_JPRB &
  &, 0.113638E+01_JPRB, 0.114227E+01_JPRB, 0.114772E+01_JPRB &
  &, 0.115274E+01_JPRB, 0.115730E+01_JPRB, 0.116142E+01_JPRB, 0.116507E+01_JPRB &
  &, 0.116827E+01_JPRB, 0.117100E+01_JPRB, 0.117327E+01_JPRB &
  &, 0.117506E+01_JPRB, 0.117638E+01_JPRB, 0.117723E+01_JPRB, 0.117759E+01_JPRB &
  &, 0.117748E+01_JPRB, 0.117688E+01_JPRB, 0.117581E+01_JPRB &
  &, 0.117426E+01_JPRB, 0.117222E+01_JPRB, 0.116971E+01_JPRB, 0.116671E+01_JPRB &
  &, 0.116325E+01_JPRB, 0.115931E+01_JPRB, 0.115489E+01_JPRB &
  &, 0.115003E+01_JPRB, 0.114469E+01_JPRB, 0.113891E+01_JPRB, 0.113268E+01_JPRB &
  &, 0.112599E+01_JPRB, 0.111888E+01_JPRB, 0.111134E+01_JPRB &
  &, 0.110337E+01_JPRB, 0.109498E+01_JPRB, 0.108620E+01_JPRB, 0.107702E+01_JPRB &
  &, 0.106746E+01_JPRB, 0.105752E+01_JPRB, 0.104722E+01_JPRB &
  &, 0.103656E+01_JPRB, 0.102556E+01_JPRB, 0.101423E+01_JPRB, 0.100260E+01_JPRB &
  &, 0.990650E+00_JPRB, 0.978402E+00_JPRB, 0.965878E+00_JPRB &
  &, 0.953088E+00_JPRB, 0.940045E+00_JPRB, 0.926779E+00_JPRB, 0.913271E+00_JPRB &
  &, 0.899553E+00_JPRB, 0.885640E+00_JPRB, 0.871547E+00_JPRB &
  &, 0.857293E+00_JPRB, 0.842875E+00_JPRB, 0.828328E+00_JPRB, 0.813652E+00_JPRB &
  &, 0.798863E+00_JPRB, 0.783979E+00_JPRB, 0.768996E+00_JPRB &
  &, 0.753973E+00_JPRB, 0.738886E+00_JPRB, 0.723751E+00_JPRB, 0.708607E+00_JPRB &
  &, 0.693448E+00_JPRB, 0.678289E+00_JPRB, 0.663123E+00_JPRB &
  &, 0.648012E+00_JPRB, 0.632922E+00_JPRB, 0.617892E+00_JPRB, 0.602935E+00_JPRB &
  &, 0.588064E+00_JPRB, 0.573265E+00_JPRB, 0.558548E+00_JPRB &
  &, 0.543951E+00_JPRB, 0.529483E+00_JPRB, 0.515155E+00_JPRB, 0.500944E+00_JPRB &
  &, 0.486887E+00_JPRB, 0.472990E+00_JPRB, 0.459289E+00_JPRB &
  &, 0.445726E+00_JPRB, 0.432367E+00_JPRB, 0.419182E+00_JPRB, 0.406172E+00_JPRB &
  &, 0.393403E+00_JPRB, 0.380841E+00_JPRB, 0.368448E+00_JPRB &
  &, 0.356326E+00_JPRB, 0.344400E+00_JPRB, 0.332700E+00_JPRB, 0.321256E+00_JPRB &
  &, 0.310022E+00_JPRB, 0.299028E+00_JPRB, 0.288261E+00_JPRB &
  &, 0.277750E+00_JPRB, 0.267482E+00_JPRB, 0.257483E+00_JPRB, 0.247697E+00_JPRB &
  &, 0.238148E+00_JPRB, 0.228861E+00_JPRB, 0.219859E+00_JPRB &
  &, 0.211035E+00_JPRB, 0.202500E+00_JPRB, 0.194185E+00_JPRB, 0.186111E+00_JPRB &
  &, 0.178299E+00_JPRB, 0.170724E+00_JPRB, 0.163354E+00_JPRB &
  &, 0.156210E+00_JPRB, 0.149359E+00_JPRB, 0.142669E+00_JPRB, 0.136258E+00_JPRB &
  &, 0.130041E+00_JPRB, 0.124032E+00_JPRB, 0.118248E+00_JPRB &
  &, 0.112649E+00_JPRB, 0.107305E+00_JPRB, 0.102119E+00_JPRB, 0.971608E-01_JPRB &
  &, 0.923278E-01_JPRB, 0.877484E-01_JPRB, 0.833180E-01_JPRB &
  &, 0.791078E-01_JPRB, 0.750692E-01_JPRB, 0.711507E-01_JPRB, 0.674240E-01_JPRB &
  &, 0.639003E-01_JPRB, 0.604612E-01_JPRB, 0.571787E-01_JPRB/)
XCW( 683, :) = (/ &
  &  0.104485E+01_JPRB, 0.105520E+01_JPRB, 0.106518E+01_JPRB, 0.107480E+01_JPRB &
  &, 0.108403E+01_JPRB, 0.109288E+01_JPRB, 0.110134E+01_JPRB &
  &, 0.110940E+01_JPRB, 0.111706E+01_JPRB, 0.112430E+01_JPRB, 0.113113E+01_JPRB &
  &, 0.113753E+01_JPRB, 0.114350E+01_JPRB, 0.114904E+01_JPRB &
  &, 0.115413E+01_JPRB, 0.115878E+01_JPRB, 0.116298E+01_JPRB, 0.116672E+01_JPRB &
  &, 0.117000E+01_JPRB, 0.117281E+01_JPRB, 0.117516E+01_JPRB &
  &, 0.117704E+01_JPRB, 0.117844E+01_JPRB, 0.117936E+01_JPRB, 0.117981E+01_JPRB &
  &, 0.117978E+01_JPRB, 0.117927E+01_JPRB, 0.117827E+01_JPRB &
  &, 0.117680E+01_JPRB, 0.117484E+01_JPRB, 0.117241E+01_JPRB, 0.116949E+01_JPRB &
  &, 0.116610E+01_JPRB, 0.116224E+01_JPRB, 0.115791E+01_JPRB &
  &, 0.115311E+01_JPRB, 0.114785E+01_JPRB, 0.114213E+01_JPRB, 0.113597E+01_JPRB &
  &, 0.112935E+01_JPRB, 0.112231E+01_JPRB, 0.111483E+01_JPRB &
  &, 0.110692E+01_JPRB, 0.109860E+01_JPRB, 0.108989E+01_JPRB, 0.108077E+01_JPRB &
  &, 0.107126E+01_JPRB, 0.106138E+01_JPRB, 0.105112E+01_JPRB &
  &, 0.104053E+01_JPRB, 0.102958E+01_JPRB, 0.101830E+01_JPRB, 0.100670E+01_JPRB &
  &, 0.994797E+00_JPRB, 0.982589E+00_JPRB, 0.970102E+00_JPRB &
  &, 0.957349E+00_JPRB, 0.944342E+00_JPRB, 0.931111E+00_JPRB, 0.917636E+00_JPRB &
  &, 0.903950E+00_JPRB, 0.890049E+00_JPRB, 0.875985E+00_JPRB &
  &, 0.861739E+00_JPRB, 0.847345E+00_JPRB, 0.832802E+00_JPRB, 0.818146E+00_JPRB &
  &, 0.803356E+00_JPRB, 0.788487E+00_JPRB, 0.773518E+00_JPRB &
  &, 0.758486E+00_JPRB, 0.743408E+00_JPRB, 0.728258E+00_JPRB, 0.713117E+00_JPRB &
  &, 0.697936E+00_JPRB, 0.682753E+00_JPRB, 0.667606E+00_JPRB &
  &, 0.652463E+00_JPRB, 0.637363E+00_JPRB, 0.622319E+00_JPRB, 0.607320E+00_JPRB &
  &, 0.592403E+00_JPRB, 0.577581E+00_JPRB, 0.562838E+00_JPRB &
  &, 0.548212E+00_JPRB, 0.533711E+00_JPRB, 0.519347E+00_JPRB, 0.505096E+00_JPRB &
  &, 0.490996E+00_JPRB, 0.477052E+00_JPRB, 0.463301E+00_JPRB &
  &, 0.449684E+00_JPRB, 0.436267E+00_JPRB, 0.423021E+00_JPRB, 0.410012E+00_JPRB &
  &, 0.397174E+00_JPRB, 0.384540E+00_JPRB, 0.372106E+00_JPRB &
  &, 0.359903E+00_JPRB, 0.347930E+00_JPRB, 0.336178E+00_JPRB, 0.324642E+00_JPRB &
  &, 0.313351E+00_JPRB, 0.302294E+00_JPRB, 0.291503E+00_JPRB &
  &, 0.280924E+00_JPRB, 0.270585E+00_JPRB, 0.260470E+00_JPRB, 0.250648E+00_JPRB &
  &, 0.241060E+00_JPRB, 0.231688E+00_JPRB, 0.222599E+00_JPRB &
  &, 0.213728E+00_JPRB, 0.205097E+00_JPRB, 0.196729E+00_JPRB, 0.188600E+00_JPRB &
  &, 0.180731E+00_JPRB, 0.173047E+00_JPRB, 0.165614E+00_JPRB &
  &, 0.158453E+00_JPRB, 0.151484E+00_JPRB, 0.144773E+00_JPRB, 0.138289E+00_JPRB &
  &, 0.131996E+00_JPRB, 0.125908E+00_JPRB, 0.120097E+00_JPRB &
  &, 0.114414E+00_JPRB, 0.108983E+00_JPRB, 0.103764E+00_JPRB, 0.987129E-01_JPRB &
  &, 0.939014E-01_JPRB, 0.892255E-01_JPRB, 0.847554E-01_JPRB &
  &, 0.805040E-01_JPRB, 0.763612E-01_JPRB, 0.724600E-01_JPRB, 0.686877E-01_JPRB &
  &, 0.650527E-01_JPRB, 0.616287E-01_JPRB, 0.582958E-01_JPRB/)
XCW( 684, :) = (/ &
  &  0.104514E+01_JPRB, 0.105556E+01_JPRB, 0.106562E+01_JPRB, 0.107531E+01_JPRB &
  &, 0.108463E+01_JPRB, 0.109356E+01_JPRB, 0.110209E+01_JPRB &
  &, 0.111023E+01_JPRB, 0.111797E+01_JPRB, 0.112530E+01_JPRB, 0.113220E+01_JPRB &
  &, 0.113869E+01_JPRB, 0.114474E+01_JPRB, 0.115036E+01_JPRB &
  &, 0.115553E+01_JPRB, 0.116026E+01_JPRB, 0.116454E+01_JPRB, 0.116837E+01_JPRB &
  &, 0.117173E+01_JPRB, 0.117463E+01_JPRB, 0.117706E+01_JPRB &
  &, 0.117901E+01_JPRB, 0.118050E+01_JPRB, 0.118151E+01_JPRB, 0.118203E+01_JPRB &
  &, 0.118209E+01_JPRB, 0.118166E+01_JPRB, 0.118074E+01_JPRB &
  &, 0.117935E+01_JPRB, 0.117747E+01_JPRB, 0.117511E+01_JPRB, 0.117228E+01_JPRB &
  &, 0.116896E+01_JPRB, 0.116518E+01_JPRB, 0.116092E+01_JPRB &
  &, 0.115620E+01_JPRB, 0.115101E+01_JPRB, 0.114536E+01_JPRB, 0.113927E+01_JPRB &
  &, 0.113272E+01_JPRB, 0.112574E+01_JPRB, 0.111833E+01_JPRB &
  &, 0.111050E+01_JPRB, 0.110224E+01_JPRB, 0.109358E+01_JPRB, 0.108452E+01_JPRB &
  &, 0.107507E+01_JPRB, 0.106524E+01_JPRB, 0.105505E+01_JPRB &
  &, 0.104450E+01_JPRB, 0.103360E+01_JPRB, 0.102236E+01_JPRB, 0.101081E+01_JPRB &
  &, 0.998959E+00_JPRB, 0.986790E+00_JPRB, 0.974357E+00_JPRB &
  &, 0.961642E+00_JPRB, 0.948672E+00_JPRB, 0.935459E+00_JPRB, 0.922001E+00_JPRB &
  &, 0.908346E+00_JPRB, 0.894493E+00_JPRB, 0.880440E+00_JPRB &
  &, 0.866221E+00_JPRB, 0.851834E+00_JPRB, 0.837314E+00_JPRB, 0.822659E+00_JPRB &
  &, 0.807888E+00_JPRB, 0.793016E+00_JPRB, 0.778061E+00_JPRB &
  &, 0.763020E+00_JPRB, 0.747930E+00_JPRB, 0.732808E+00_JPRB, 0.717627E+00_JPRB &
  &, 0.702447E+00_JPRB, 0.687263E+00_JPRB, 0.672088E+00_JPRB &
  &, 0.656938E+00_JPRB, 0.641828E+00_JPRB, 0.626747E+00_JPRB, 0.611731E+00_JPRB &
  &, 0.596796E+00_JPRB, 0.581924E+00_JPRB, 0.567156E+00_JPRB &
  &, 0.552500E+00_JPRB, 0.537968E+00_JPRB, 0.523538E+00_JPRB, 0.509278E+00_JPRB &
  &, 0.495135E+00_JPRB, 0.481145E+00_JPRB, 0.467344E+00_JPRB &
  &, 0.453674E+00_JPRB, 0.440200E+00_JPRB, 0.426925E+00_JPRB, 0.413852E+00_JPRB &
  &, 0.400946E+00_JPRB, 0.388273E+00_JPRB, 0.375798E+00_JPRB &
  &, 0.363517E+00_JPRB, 0.351495E+00_JPRB, 0.339656E+00_JPRB, 0.328066E+00_JPRB &
  &, 0.316717E+00_JPRB, 0.305600E+00_JPRB, 0.294744E+00_JPRB &
  &, 0.284098E+00_JPRB, 0.273688E+00_JPRB, 0.263541E+00_JPRB, 0.253641E+00_JPRB &
  &, 0.243972E+00_JPRB, 0.234559E+00_JPRB, 0.225382E+00_JPRB &
  &, 0.216420E+00_JPRB, 0.207740E+00_JPRB, 0.199320E+00_JPRB, 0.191090E+00_JPRB &
  &, 0.183163E+00_JPRB, 0.175419E+00_JPRB, 0.167923E+00_JPRB &
  &, 0.160697E+00_JPRB, 0.153659E+00_JPRB, 0.146878E+00_JPRB, 0.140320E+00_JPRB &
  &, 0.133951E+00_JPRB, 0.127838E+00_JPRB, 0.121945E+00_JPRB &
  &, 0.116233E+00_JPRB, 0.110772E+00_JPRB, 0.105464E+00_JPRB, 0.100380E+00_JPRB &
  &, 0.954750E-01_JPRB, 0.907616E-01_JPRB, 0.862527E-01_JPRB &
  &, 0.819002E-01_JPRB, 0.777147E-01_JPRB, 0.737694E-01_JPRB, 0.698881E-01_JPRB &
  &, 0.662690E-01_JPRB, 0.627313E-01_JPRB, 0.594129E-01_JPRB/)
XCW( 685, :) = (/ &
  &  0.104543E+01_JPRB, 0.105593E+01_JPRB, 0.106606E+01_JPRB, 0.107583E+01_JPRB &
  &, 0.108522E+01_JPRB, 0.109423E+01_JPRB, 0.110285E+01_JPRB &
  &, 0.111107E+01_JPRB, 0.111888E+01_JPRB, 0.112629E+01_JPRB, 0.113328E+01_JPRB &
  &, 0.113984E+01_JPRB, 0.114598E+01_JPRB, 0.115168E+01_JPRB &
  &, 0.115693E+01_JPRB, 0.116175E+01_JPRB, 0.116611E+01_JPRB, 0.117002E+01_JPRB &
  &, 0.117346E+01_JPRB, 0.117644E+01_JPRB, 0.117896E+01_JPRB &
  &, 0.118100E+01_JPRB, 0.118256E+01_JPRB, 0.118366E+01_JPRB, 0.118426E+01_JPRB &
  &, 0.118440E+01_JPRB, 0.118405E+01_JPRB, 0.118322E+01_JPRB &
  &, 0.118190E+01_JPRB, 0.118010E+01_JPRB, 0.117783E+01_JPRB, 0.117507E+01_JPRB &
  &, 0.117183E+01_JPRB, 0.116812E+01_JPRB, 0.116394E+01_JPRB &
  &, 0.115929E+01_JPRB, 0.115417E+01_JPRB, 0.114861E+01_JPRB, 0.114259E+01_JPRB &
  &, 0.113611E+01_JPRB, 0.112920E+01_JPRB, 0.112185E+01_JPRB &
  &, 0.111407E+01_JPRB, 0.110589E+01_JPRB, 0.109729E+01_JPRB, 0.108829E+01_JPRB &
  &, 0.107889E+01_JPRB, 0.106913E+01_JPRB, 0.105899E+01_JPRB &
  &, 0.104849E+01_JPRB, 0.103764E+01_JPRB, 0.102646E+01_JPRB, 0.101496E+01_JPRB &
  &, 0.100314E+01_JPRB, 0.991021E+00_JPRB, 0.978612E+00_JPRB &
  &, 0.965935E+00_JPRB, 0.953001E+00_JPRB, 0.939823E+00_JPRB, 0.926383E+00_JPRB &
  &, 0.912777E+00_JPRB, 0.898937E+00_JPRB, 0.884913E+00_JPRB &
  &, 0.870703E+00_JPRB, 0.856341E+00_JPRB, 0.841845E+00_JPRB, 0.827192E+00_JPRB &
  &, 0.812440E+00_JPRB, 0.797565E+00_JPRB, 0.782625E+00_JPRB &
  &, 0.767596E+00_JPRB, 0.752495E+00_JPRB, 0.737358E+00_JPRB, 0.722182E+00_JPRB &
  &, 0.707005E+00_JPRB, 0.691796E+00_JPRB, 0.676618E+00_JPRB &
  &, 0.661438E+00_JPRB, 0.646294E+00_JPRB, 0.631199E+00_JPRB, 0.616168E+00_JPRB &
  &, 0.601214E+00_JPRB, 0.586321E+00_JPRB, 0.571528E+00_JPRB &
  &, 0.556844E+00_JPRB, 0.542252E+00_JPRB, 0.527788E+00_JPRB, 0.513489E+00_JPRB &
  &, 0.499304E+00_JPRB, 0.485269E+00_JPRB, 0.471418E+00_JPRB &
  &, 0.457727E+00_JPRB, 0.444197E+00_JPRB, 0.430863E+00_JPRB, 0.417725E+00_JPRB &
  &, 0.404751E+00_JPRB, 0.392042E+00_JPRB, 0.379491E+00_JPRB &
  &, 0.367166E+00_JPRB, 0.355061E+00_JPRB, 0.343209E+00_JPRB, 0.331565E+00_JPRB &
  &, 0.320122E+00_JPRB, 0.308945E+00_JPRB, 0.297986E+00_JPRB &
  &, 0.287312E+00_JPRB, 0.276832E+00_JPRB, 0.266611E+00_JPRB, 0.256634E+00_JPRB &
  &, 0.246884E+00_JPRB, 0.237430E+00_JPRB, 0.228166E+00_JPRB &
  &, 0.219202E+00_JPRB, 0.210428E+00_JPRB, 0.201911E+00_JPRB, 0.193673E+00_JPRB &
  &, 0.185643E+00_JPRB, 0.177839E+00_JPRB, 0.170281E+00_JPRB &
  &, 0.162990E+00_JPRB, 0.155885E+00_JPRB, 0.149034E+00_JPRB, 0.142404E+00_JPRB &
  &, 0.136011E+00_JPRB, 0.129821E+00_JPRB, 0.123848E+00_JPRB &
  &, 0.118053E+00_JPRB, 0.112505E+00_JPRB, 0.107165E+00_JPRB, 0.101990E+00_JPRB &
  &, 0.970486E-01_JPRB, 0.922978E-01_JPRB, 0.876900E-01_JPRB &
  &, 0.832964E-01_JPRB, 0.791297E-01_JPRB, 0.750787E-01_JPRB, 0.712149E-01_JPRB &
  &, 0.674853E-01_JPRB, 0.638988E-01_JPRB, 0.605300E-01_JPRB/)
XCW( 686, :) = (/ &
  &  0.104572E+01_JPRB, 0.105629E+01_JPRB, 0.106650E+01_JPRB, 0.107635E+01_JPRB &
  &, 0.108582E+01_JPRB, 0.109490E+01_JPRB, 0.110360E+01_JPRB &
  &, 0.111190E+01_JPRB, 0.111980E+01_JPRB, 0.112728E+01_JPRB, 0.113435E+01_JPRB &
  &, 0.114100E+01_JPRB, 0.114722E+01_JPRB, 0.115300E+01_JPRB &
  &, 0.115834E+01_JPRB, 0.116324E+01_JPRB, 0.116768E+01_JPRB, 0.117167E+01_JPRB &
  &, 0.117520E+01_JPRB, 0.117827E+01_JPRB, 0.118086E+01_JPRB &
  &, 0.118299E+01_JPRB, 0.118464E+01_JPRB, 0.118581E+01_JPRB, 0.118650E+01_JPRB &
  &, 0.118672E+01_JPRB, 0.118645E+01_JPRB, 0.118570E+01_JPRB &
  &, 0.118446E+01_JPRB, 0.118275E+01_JPRB, 0.118055E+01_JPRB, 0.117787E+01_JPRB &
  &, 0.117471E+01_JPRB, 0.117108E+01_JPRB, 0.116697E+01_JPRB &
  &, 0.116239E+01_JPRB, 0.115736E+01_JPRB, 0.115185E+01_JPRB, 0.114590E+01_JPRB &
  &, 0.113950E+01_JPRB, 0.113265E+01_JPRB, 0.112538E+01_JPRB &
  &, 0.111767E+01_JPRB, 0.110955E+01_JPRB, 0.110101E+01_JPRB, 0.109207E+01_JPRB &
  &, 0.108274E+01_JPRB, 0.107303E+01_JPRB, 0.106294E+01_JPRB &
  &, 0.105250E+01_JPRB, 0.104170E+01_JPRB, 0.103057E+01_JPRB, 0.101911E+01_JPRB &
  &, 0.100734E+01_JPRB, 0.995267E+00_JPRB, 0.982898E+00_JPRB &
  &, 0.970259E+00_JPRB, 0.957362E+00_JPRB, 0.944204E+00_JPRB, 0.930831E+00_JPRB &
  &, 0.917225E+00_JPRB, 0.903416E+00_JPRB, 0.889404E+00_JPRB &
  &, 0.875222E+00_JPRB, 0.860886E+00_JPRB, 0.846394E+00_JPRB, 0.831764E+00_JPRB &
  &, 0.817012E+00_JPRB, 0.802155E+00_JPRB, 0.787209E+00_JPRB &
  &, 0.772172E+00_JPRB, 0.757081E+00_JPRB, 0.741953E+00_JPRB, 0.726782E+00_JPRB &
  &, 0.711562E+00_JPRB, 0.696353E+00_JPRB, 0.681124E+00_JPRB &
  &, 0.665962E+00_JPRB, 0.650808E+00_JPRB, 0.635702E+00_JPRB, 0.620631E+00_JPRB &
  &, 0.605659E+00_JPRB, 0.590745E+00_JPRB, 0.575900E+00_JPRB &
  &, 0.561188E+00_JPRB, 0.546565E+00_JPRB, 0.532066E+00_JPRB, 0.517729E+00_JPRB &
  &, 0.503503E+00_JPRB, 0.489423E+00_JPRB, 0.475524E+00_JPRB &
  &, 0.461780E+00_JPRB, 0.448194E+00_JPRB, 0.434832E+00_JPRB, 0.421632E+00_JPRB &
  &, 0.408625E+00_JPRB, 0.395810E+00_JPRB, 0.383219E+00_JPRB &
  &, 0.370851E+00_JPRB, 0.358700E+00_JPRB, 0.346761E+00_JPRB, 0.335064E+00_JPRB &
  &, 0.323564E+00_JPRB, 0.312328E+00_JPRB, 0.301306E+00_JPRB &
  &, 0.290526E+00_JPRB, 0.280016E+00_JPRB, 0.269722E+00_JPRB, 0.259669E+00_JPRB &
  &, 0.249882E+00_JPRB, 0.240345E+00_JPRB, 0.231037E+00_JPRB &
  &, 0.221939E+00_JPRB, 0.213116E+00_JPRB, 0.204548E+00_JPRB, 0.196210E+00_JPRB &
  &, 0.188122E+00_JPRB, 0.180259E+00_JPRB, 0.172639E+00_JPRB &
  &, 0.165284E+00_JPRB, 0.158111E+00_JPRB, 0.151190E+00_JPRB, 0.144487E+00_JPRB &
  &, 0.138019E+00_JPRB, 0.131804E+00_JPRB, 0.125750E+00_JPRB &
  &, 0.119927E+00_JPRB, 0.114294E+00_JPRB, 0.108923E+00_JPRB, 0.103714E+00_JPRB &
  &, 0.986805E-01_JPRB, 0.938340E-01_JPRB, 0.892472E-01_JPRB &
  &, 0.847533E-01_JPRB, 0.804833E-01_JPRB, 0.763880E-01_JPRB, 0.724785E-01_JPRB &
  &, 0.687017E-01_JPRB, 0.651312E-01_JPRB, 0.616470E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART98',1,ZHOOK_HANDLE)
END SUBROUTINE PART98

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART99

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART99',0,ZHOOK_HANDLE)

XCW( 687, :) = (/ &
  &  0.104601E+01_JPRB, 0.105666E+01_JPRB, 0.106695E+01_JPRB, 0.107687E+01_JPRB &
  &, 0.108641E+01_JPRB, 0.109558E+01_JPRB, 0.110435E+01_JPRB &
  &, 0.111273E+01_JPRB, 0.112071E+01_JPRB, 0.112828E+01_JPRB, 0.113543E+01_JPRB &
  &, 0.114216E+01_JPRB, 0.114846E+01_JPRB, 0.115432E+01_JPRB &
  &, 0.115975E+01_JPRB, 0.116473E+01_JPRB, 0.116926E+01_JPRB, 0.117333E+01_JPRB &
  &, 0.117694E+01_JPRB, 0.118009E+01_JPRB, 0.118277E+01_JPRB &
  &, 0.118498E+01_JPRB, 0.118671E+01_JPRB, 0.118797E+01_JPRB, 0.118875E+01_JPRB &
  &, 0.118904E+01_JPRB, 0.118886E+01_JPRB, 0.118819E+01_JPRB &
  &, 0.118703E+01_JPRB, 0.118540E+01_JPRB, 0.118328E+01_JPRB, 0.118068E+01_JPRB &
  &, 0.117760E+01_JPRB, 0.117404E+01_JPRB, 0.117002E+01_JPRB &
  &, 0.116551E+01_JPRB, 0.116054E+01_JPRB, 0.115512E+01_JPRB, 0.114924E+01_JPRB &
  &, 0.114291E+01_JPRB, 0.113613E+01_JPRB, 0.112892E+01_JPRB &
  &, 0.112128E+01_JPRB, 0.111321E+01_JPRB, 0.110475E+01_JPRB, 0.109586E+01_JPRB &
  &, 0.108659E+01_JPRB, 0.107694E+01_JPRB, 0.106691E+01_JPRB &
  &, 0.105652E+01_JPRB, 0.104578E+01_JPRB, 0.103469E+01_JPRB, 0.102327E+01_JPRB &
  &, 0.101155E+01_JPRB, 0.999513E+00_JPRB, 0.987198E+00_JPRB &
  &, 0.974598E+00_JPRB, 0.961739E+00_JPRB, 0.948617E+00_JPRB, 0.935262E+00_JPRB &
  &, 0.921689E+00_JPRB, 0.907912E+00_JPRB, 0.893930E+00_JPRB &
  &, 0.879777E+00_JPRB, 0.865449E+00_JPRB, 0.850963E+00_JPRB, 0.836355E+00_JPRB &
  &, 0.821604E+00_JPRB, 0.806764E+00_JPRB, 0.791814E+00_JPRB &
  &, 0.776791E+00_JPRB, 0.761710E+00_JPRB, 0.746569E+00_JPRB, 0.731382E+00_JPRB &
  &, 0.716165E+00_JPRB, 0.700956E+00_JPRB, 0.685725E+00_JPRB &
  &, 0.670534E+00_JPRB, 0.655348E+00_JPRB, 0.640231E+00_JPRB, 0.625146E+00_JPRB &
  &, 0.610130E+00_JPRB, 0.595169E+00_JPRB, 0.580327E+00_JPRB &
  &, 0.565560E+00_JPRB, 0.550906E+00_JPRB, 0.536402E+00_JPRB, 0.521999E+00_JPRB &
  &, 0.507732E+00_JPRB, 0.493607E+00_JPRB, 0.479660E+00_JPRB &
  &, 0.465865E+00_JPRB, 0.452256E+00_JPRB, 0.438802E+00_JPRB, 0.425572E+00_JPRB &
  &, 0.412498E+00_JPRB, 0.399647E+00_JPRB, 0.387017E+00_JPRB &
  &, 0.374571E+00_JPRB, 0.362338E+00_JPRB, 0.350350E+00_JPRB, 0.338601E+00_JPRB &
  &, 0.327046E+00_JPRB, 0.315750E+00_JPRB, 0.304666E+00_JPRB &
  &, 0.293821E+00_JPRB, 0.283242E+00_JPRB, 0.272875E+00_JPRB, 0.262746E+00_JPRB &
  &, 0.252879E+00_JPRB, 0.243259E+00_JPRB, 0.233909E+00_JPRB &
  &, 0.224766E+00_JPRB, 0.215850E+00_JPRB, 0.207231E+00_JPRB, 0.198840E+00_JPRB &
  &, 0.190649E+00_JPRB, 0.182727E+00_JPRB, 0.175046E+00_JPRB &
  &, 0.167627E+00_JPRB, 0.160388E+00_JPRB, 0.153397E+00_JPRB, 0.146622E+00_JPRB &
  &, 0.140080E+00_JPRB, 0.133787E+00_JPRB, 0.127707E+00_JPRB &
  &, 0.121802E+00_JPRB, 0.116139E+00_JPRB, 0.110680E+00_JPRB, 0.105381E+00_JPRB &
  &, 0.100312E+00_JPRB, 0.954292E-01_JPRB, 0.907445E-01_JPRB &
  &, 0.862709E-01_JPRB, 0.818983E-01_JPRB, 0.777597E-01_JPRB, 0.738053E-01_JPRB &
  &, 0.699821E-01_JPRB, 0.663636E-01_JPRB, 0.628298E-01_JPRB/)
XCW( 688, :) = (/ &
  &  0.104630E+01_JPRB, 0.105703E+01_JPRB, 0.106739E+01_JPRB, 0.107739E+01_JPRB &
  &, 0.108701E+01_JPRB, 0.109626E+01_JPRB, 0.110511E+01_JPRB &
  &, 0.111357E+01_JPRB, 0.112163E+01_JPRB, 0.112928E+01_JPRB, 0.113651E+01_JPRB &
  &, 0.114332E+01_JPRB, 0.114970E+01_JPRB, 0.115565E+01_JPRB &
  &, 0.116116E+01_JPRB, 0.116622E+01_JPRB, 0.117084E+01_JPRB, 0.117499E+01_JPRB &
  &, 0.117869E+01_JPRB, 0.118192E+01_JPRB, 0.118469E+01_JPRB &
  &, 0.118698E+01_JPRB, 0.118880E+01_JPRB, 0.119014E+01_JPRB, 0.119100E+01_JPRB &
  &, 0.119138E+01_JPRB, 0.119127E+01_JPRB, 0.119068E+01_JPRB &
  &, 0.118961E+01_JPRB, 0.118806E+01_JPRB, 0.118602E+01_JPRB, 0.118349E+01_JPRB &
  &, 0.118049E+01_JPRB, 0.117702E+01_JPRB, 0.117306E+01_JPRB &
  &, 0.116863E+01_JPRB, 0.116375E+01_JPRB, 0.115840E+01_JPRB, 0.115258E+01_JPRB &
  &, 0.114632E+01_JPRB, 0.113962E+01_JPRB, 0.113247E+01_JPRB &
  &, 0.112489E+01_JPRB, 0.111690E+01_JPRB, 0.110849E+01_JPRB, 0.109968E+01_JPRB &
  &, 0.109047E+01_JPRB, 0.108087E+01_JPRB, 0.107089E+01_JPRB &
  &, 0.106055E+01_JPRB, 0.104987E+01_JPRB, 0.103884E+01_JPRB, 0.102747E+01_JPRB &
  &, 0.101578E+01_JPRB, 0.100380E+01_JPRB, 0.991514E+00_JPRB &
  &, 0.978953E+00_JPRB, 0.966131E+00_JPRB, 0.953046E+00_JPRB, 0.939727E+00_JPRB &
  &, 0.926188E+00_JPRB, 0.912426E+00_JPRB, 0.898475E+00_JPRB &
  &, 0.884331E+00_JPRB, 0.870030E+00_JPRB, 0.855570E+00_JPRB, 0.840966E+00_JPRB &
  &, 0.826235E+00_JPRB, 0.811394E+00_JPRB, 0.796461E+00_JPRB &
  &, 0.781430E+00_JPRB, 0.766340E+00_JPRB, 0.751207E+00_JPRB, 0.735982E+00_JPRB &
  &, 0.720790E+00_JPRB, 0.705583E+00_JPRB, 0.690351E+00_JPRB &
  &, 0.675131E+00_JPRB, 0.659938E+00_JPRB, 0.644785E+00_JPRB, 0.629660E+00_JPRB &
  &, 0.614627E+00_JPRB, 0.599646E+00_JPRB, 0.584781E+00_JPRB &
  &, 0.569988E+00_JPRB, 0.555305E+00_JPRB, 0.540739E+00_JPRB, 0.526299E+00_JPRB &
  &, 0.511991E+00_JPRB, 0.497823E+00_JPRB, 0.483828E+00_JPRB &
  &, 0.469981E+00_JPRB, 0.456317E+00_JPRB, 0.442838E+00_JPRB, 0.429546E+00_JPRB &
  &, 0.416440E+00_JPRB, 0.403519E+00_JPRB, 0.390816E+00_JPRB &
  &, 0.378327E+00_JPRB, 0.366050E+00_JPRB, 0.353976E+00_JPRB, 0.342138E+00_JPRB &
  &, 0.330527E+00_JPRB, 0.319172E+00_JPRB, 0.308026E+00_JPRB &
  &, 0.297115E+00_JPRB, 0.286467E+00_JPRB, 0.276028E+00_JPRB, 0.265865E+00_JPRB &
  &, 0.255920E+00_JPRB, 0.246260E+00_JPRB, 0.236781E+00_JPRB &
  &, 0.227593E+00_JPRB, 0.218630E+00_JPRB, 0.209915E+00_JPRB, 0.201470E+00_JPRB &
  &, 0.193224E+00_JPRB, 0.185244E+00_JPRB, 0.177503E+00_JPRB &
  &, 0.169970E+00_JPRB, 0.162665E+00_JPRB, 0.155656E+00_JPRB, 0.148810E+00_JPRB &
  &, 0.142193E+00_JPRB, 0.135824E+00_JPRB, 0.129664E+00_JPRB &
  &, 0.123731E+00_JPRB, 0.117985E+00_JPRB, 0.112438E+00_JPRB, 0.107106E+00_JPRB &
  &, 0.102002E+00_JPRB, 0.970244E-01_JPRB, 0.923016E-01_JPRB &
  &, 0.877278E-01_JPRB, 0.833749E-01_JPRB, 0.791938E-01_JPRB, 0.751321E-01_JPRB &
  &, 0.712624E-01_JPRB, 0.675960E-01_JPRB, 0.640126E-01_JPRB/)
XCW( 689, :) = (/ &
  &  0.104660E+01_JPRB, 0.105739E+01_JPRB, 0.106783E+01_JPRB, 0.107791E+01_JPRB &
  &, 0.108761E+01_JPRB, 0.109693E+01_JPRB, 0.110587E+01_JPRB &
  &, 0.111441E+01_JPRB, 0.112255E+01_JPRB, 0.113028E+01_JPRB, 0.113759E+01_JPRB &
  &, 0.114449E+01_JPRB, 0.115095E+01_JPRB, 0.115698E+01_JPRB &
  &, 0.116258E+01_JPRB, 0.116772E+01_JPRB, 0.117242E+01_JPRB, 0.117666E+01_JPRB &
  &, 0.118044E+01_JPRB, 0.118376E+01_JPRB, 0.118660E+01_JPRB &
  &, 0.118898E+01_JPRB, 0.119088E+01_JPRB, 0.119231E+01_JPRB, 0.119325E+01_JPRB &
  &, 0.119371E+01_JPRB, 0.119369E+01_JPRB, 0.119319E+01_JPRB &
  &, 0.119220E+01_JPRB, 0.119072E+01_JPRB, 0.118876E+01_JPRB, 0.118632E+01_JPRB &
  &, 0.118340E+01_JPRB, 0.118000E+01_JPRB, 0.117612E+01_JPRB &
  &, 0.117177E+01_JPRB, 0.116695E+01_JPRB, 0.116168E+01_JPRB, 0.115594E+01_JPRB &
  &, 0.114975E+01_JPRB, 0.114312E+01_JPRB, 0.113603E+01_JPRB &
  &, 0.112853E+01_JPRB, 0.112060E+01_JPRB, 0.111225E+01_JPRB, 0.110350E+01_JPRB &
  &, 0.109435E+01_JPRB, 0.108481E+01_JPRB, 0.107489E+01_JPRB &
  &, 0.106461E+01_JPRB, 0.105398E+01_JPRB, 0.104298E+01_JPRB, 0.103167E+01_JPRB &
  &, 0.102004E+01_JPRB, 0.100809E+01_JPRB, 0.995860E+00_JPRB &
  &, 0.983338E+00_JPRB, 0.970540E+00_JPRB, 0.957492E+00_JPRB, 0.944208E+00_JPRB &
  &, 0.930703E+00_JPRB, 0.916957E+00_JPRB, 0.903036E+00_JPRB &
  &, 0.888922E+00_JPRB, 0.874631E+00_JPRB, 0.860195E+00_JPRB, 0.845595E+00_JPRB &
  &, 0.830886E+00_JPRB, 0.816044E+00_JPRB, 0.801128E+00_JPRB &
  &, 0.786112E+00_JPRB, 0.771012E+00_JPRB, 0.755867E+00_JPRB, 0.740671E+00_JPRB &
  &, 0.725462E+00_JPRB, 0.710210E+00_JPRB, 0.694976E+00_JPRB &
  &, 0.679752E+00_JPRB, 0.664527E+00_JPRB, 0.649364E+00_JPRB, 0.634226E+00_JPRB &
  &, 0.619151E+00_JPRB, 0.604150E+00_JPRB, 0.589235E+00_JPRB &
  &, 0.574416E+00_JPRB, 0.559703E+00_JPRB, 0.545104E+00_JPRB, 0.530627E+00_JPRB &
  &, 0.516280E+00_JPRB, 0.502099E+00_JPRB, 0.488027E+00_JPRB &
  &, 0.474161E+00_JPRB, 0.460443E+00_JPRB, 0.446906E+00_JPRB, 0.433552E+00_JPRB &
  &, 0.420381E+00_JPRB, 0.407425E+00_JPRB, 0.394649E+00_JPRB &
  &, 0.382120E+00_JPRB, 0.369761E+00_JPRB, 0.357640E+00_JPRB, 0.345750E+00_JPRB &
  &, 0.334084E+00_JPRB, 0.322633E+00_JPRB, 0.311426E+00_JPRB &
  &, 0.300490E+00_JPRB, 0.289734E+00_JPRB, 0.279264E+00_JPRB, 0.269027E+00_JPRB &
  &, 0.259003E+00_JPRB, 0.249262E+00_JPRB, 0.239741E+00_JPRB &
  &, 0.230464E+00_JPRB, 0.221455E+00_JPRB, 0.212645E+00_JPRB, 0.204101E+00_JPRB &
  &, 0.195847E+00_JPRB, 0.187761E+00_JPRB, 0.179959E+00_JPRB &
  &, 0.172363E+00_JPRB, 0.164992E+00_JPRB, 0.157915E+00_JPRB, 0.150997E+00_JPRB &
  &, 0.144307E+00_JPRB, 0.137914E+00_JPRB, 0.131676E+00_JPRB &
  &, 0.125661E+00_JPRB, 0.119830E+00_JPRB, 0.114252E+00_JPRB, 0.108888E+00_JPRB &
  &, 0.103693E+00_JPRB, 0.986788E-01_JPRB, 0.938588E-01_JPRB &
  &, 0.892454E-01_JPRB, 0.848515E-01_JPRB, 0.805655E-01_JPRB, 0.765221E-01_JPRB &
  &, 0.726068E-01_JPRB, 0.688283E-01_JPRB, 0.652612E-01_JPRB/)
XCW( 690, :) = (/ &
  &  0.104689E+01_JPRB, 0.105776E+01_JPRB, 0.106828E+01_JPRB, 0.107843E+01_JPRB &
  &, 0.108821E+01_JPRB, 0.109761E+01_JPRB, 0.110663E+01_JPRB &
  &, 0.111525E+01_JPRB, 0.112347E+01_JPRB, 0.113128E+01_JPRB, 0.113868E+01_JPRB &
  &, 0.114565E+01_JPRB, 0.115220E+01_JPRB, 0.115832E+01_JPRB &
  &, 0.116399E+01_JPRB, 0.116922E+01_JPRB, 0.117401E+01_JPRB, 0.117833E+01_JPRB &
  &, 0.118220E+01_JPRB, 0.118560E+01_JPRB, 0.118853E+01_JPRB &
  &, 0.119099E+01_JPRB, 0.119298E+01_JPRB, 0.119449E+01_JPRB, 0.119551E+01_JPRB &
  &, 0.119606E+01_JPRB, 0.119612E+01_JPRB, 0.119570E+01_JPRB &
  &, 0.119479E+01_JPRB, 0.119339E+01_JPRB, 0.119152E+01_JPRB, 0.118916E+01_JPRB &
  &, 0.118631E+01_JPRB, 0.118299E+01_JPRB, 0.117919E+01_JPRB &
  &, 0.117492E+01_JPRB, 0.117018E+01_JPRB, 0.116498E+01_JPRB, 0.115931E+01_JPRB &
  &, 0.115319E+01_JPRB, 0.114663E+01_JPRB, 0.113962E+01_JPRB &
  &, 0.113218E+01_JPRB, 0.112432E+01_JPRB, 0.111603E+01_JPRB, 0.110734E+01_JPRB &
  &, 0.109825E+01_JPRB, 0.108877E+01_JPRB, 0.107891E+01_JPRB &
  &, 0.106869E+01_JPRB, 0.105809E+01_JPRB, 0.104716E+01_JPRB, 0.103589E+01_JPRB &
  &, 0.102431E+01_JPRB, 0.101241E+01_JPRB, 0.100021E+01_JPRB &
  &, 0.987724E+00_JPRB, 0.974980E+00_JPRB, 0.961970E+00_JPRB, 0.948706E+00_JPRB &
  &, 0.935235E+00_JPRB, 0.921523E+00_JPRB, 0.907616E+00_JPRB &
  &, 0.893532E+00_JPRB, 0.879268E+00_JPRB, 0.864840E+00_JPRB, 0.850264E+00_JPRB &
  &, 0.835557E+00_JPRB, 0.820735E+00_JPRB, 0.805815E+00_JPRB &
  &, 0.790793E+00_JPRB, 0.775706E+00_JPRB, 0.760572E+00_JPRB, 0.745361E+00_JPRB &
  &, 0.730134E+00_JPRB, 0.714884E+00_JPRB, 0.699649E+00_JPRB &
  &, 0.684397E+00_JPRB, 0.669166E+00_JPRB, 0.653969E+00_JPRB, 0.638818E+00_JPRB &
  &, 0.623727E+00_JPRB, 0.608708E+00_JPRB, 0.593744E+00_JPRB &
  &, 0.578899E+00_JPRB, 0.564157E+00_JPRB, 0.549498E+00_JPRB, 0.534986E+00_JPRB &
  &, 0.520599E+00_JPRB, 0.506375E+00_JPRB, 0.492288E+00_JPRB &
  &, 0.478341E+00_JPRB, 0.464569E+00_JPRB, 0.451008E+00_JPRB, 0.437593E+00_JPRB &
  &, 0.424356E+00_JPRB, 0.411367E+00_JPRB, 0.398518E+00_JPRB &
  &, 0.385912E+00_JPRB, 0.373509E+00_JPRB, 0.361340E+00_JPRB, 0.349400E+00_JPRB &
  &, 0.337642E+00_JPRB, 0.326172E+00_JPRB, 0.314904E+00_JPRB &
  &, 0.303865E+00_JPRB, 0.293041E+00_JPRB, 0.282501E+00_JPRB, 0.272188E+00_JPRB &
  &, 0.262129E+00_JPRB, 0.252307E+00_JPRB, 0.242701E+00_JPRB &
  &, 0.233381E+00_JPRB, 0.224280E+00_JPRB, 0.215420E+00_JPRB, 0.206825E+00_JPRB &
  &, 0.198470E+00_JPRB, 0.190326E+00_JPRB, 0.182415E+00_JPRB &
  &, 0.174806E+00_JPRB, 0.167370E+00_JPRB, 0.160174E+00_JPRB, 0.153237E+00_JPRB &
  &, 0.146473E+00_JPRB, 0.140004E+00_JPRB, 0.133687E+00_JPRB &
  &, 0.127591E+00_JPRB, 0.121731E+00_JPRB, 0.116123E+00_JPRB, 0.110670E+00_JPRB &
  &, 0.105383E+00_JPRB, 0.100333E+00_JPRB, 0.954758E-01_JPRB &
  &, 0.908237E-01_JPRB, 0.863280E-01_JPRB, 0.819995E-01_JPRB, 0.778489E-01_JPRB &
  &, 0.738872E-01_JPRB, 0.701256E-01_JPRB, 0.664440E-01_JPRB/)
XCW( 691, :) = (/ &
  &  0.104718E+01_JPRB, 0.105813E+01_JPRB, 0.106872E+01_JPRB, 0.107895E+01_JPRB &
  &, 0.108881E+01_JPRB, 0.109829E+01_JPRB, 0.110739E+01_JPRB &
  &, 0.111609E+01_JPRB, 0.112439E+01_JPRB, 0.113228E+01_JPRB, 0.113976E+01_JPRB &
  &, 0.114682E+01_JPRB, 0.115345E+01_JPRB, 0.115965E+01_JPRB &
  &, 0.116541E+01_JPRB, 0.117073E+01_JPRB, 0.117559E+01_JPRB, 0.118000E+01_JPRB &
  &, 0.118396E+01_JPRB, 0.118744E+01_JPRB, 0.119046E+01_JPRB &
  &, 0.119300E+01_JPRB, 0.119508E+01_JPRB, 0.119667E+01_JPRB, 0.119778E+01_JPRB &
  &, 0.119841E+01_JPRB, 0.119855E+01_JPRB, 0.119821E+01_JPRB &
  &, 0.119739E+01_JPRB, 0.119607E+01_JPRB, 0.119428E+01_JPRB, 0.119200E+01_JPRB &
  &, 0.118924E+01_JPRB, 0.118599E+01_JPRB, 0.118227E+01_JPRB &
  &, 0.117807E+01_JPRB, 0.117341E+01_JPRB, 0.116828E+01_JPRB, 0.116269E+01_JPRB &
  &, 0.115664E+01_JPRB, 0.115015E+01_JPRB, 0.114321E+01_JPRB &
  &, 0.113584E+01_JPRB, 0.112804E+01_JPRB, 0.111981E+01_JPRB, 0.111119E+01_JPRB &
  &, 0.110216E+01_JPRB, 0.109274E+01_JPRB, 0.108293E+01_JPRB &
  &, 0.107277E+01_JPRB, 0.106224E+01_JPRB, 0.105135E+01_JPRB, 0.104014E+01_JPRB &
  &, 0.102860E+01_JPRB, 0.101675E+01_JPRB, 0.100458E+01_JPRB &
  &, 0.992141E+00_JPRB, 0.979436E+00_JPRB, 0.966464E+00_JPRB, 0.953237E+00_JPRB &
  &, 0.939785E+00_JPRB, 0.926106E+00_JPRB, 0.912231E+00_JPRB &
  &, 0.898159E+00_JPRB, 0.883905E+00_JPRB, 0.869503E+00_JPRB, 0.854952E+00_JPRB &
  &, 0.840247E+00_JPRB, 0.825446E+00_JPRB, 0.810523E+00_JPRB &
  &, 0.795517E+00_JPRB, 0.780422E+00_JPRB, 0.765276E+00_JPRB, 0.750095E+00_JPRB &
  &, 0.734851E+00_JPRB, 0.719604E+00_JPRB, 0.704322E+00_JPRB &
  &, 0.689067E+00_JPRB, 0.673830E+00_JPRB, 0.658598E+00_JPRB, 0.643436E+00_JPRB &
  &, 0.628330E+00_JPRB, 0.613266E+00_JPRB, 0.598307E+00_JPRB &
  &, 0.583411E+00_JPRB, 0.568612E+00_JPRB, 0.553950E+00_JPRB, 0.539403E+00_JPRB &
  &, 0.524978E+00_JPRB, 0.510682E+00_JPRB, 0.496549E+00_JPRB &
  &, 0.482584E+00_JPRB, 0.468759E+00_JPRB, 0.455109E+00_JPRB, 0.441666E+00_JPRB &
  &, 0.428400E+00_JPRB, 0.415308E+00_JPRB, 0.402457E+00_JPRB &
  &, 0.389775E+00_JPRB, 0.377329E+00_JPRB, 0.365077E+00_JPRB, 0.353049E+00_JPRB &
  &, 0.341276E+00_JPRB, 0.329711E+00_JPRB, 0.318383E+00_JPRB &
  &, 0.307280E+00_JPRB, 0.296389E+00_JPRB, 0.285778E+00_JPRB, 0.275392E+00_JPRB &
  &, 0.265255E+00_JPRB, 0.255352E+00_JPRB, 0.245706E+00_JPRB &
  &, 0.236297E+00_JPRB, 0.227150E+00_JPRB, 0.218243E+00_JPRB, 0.209550E+00_JPRB &
  &, 0.201092E+00_JPRB, 0.192940E+00_JPRB, 0.184970E+00_JPRB &
  &, 0.177249E+00_JPRB, 0.169748E+00_JPRB, 0.162484E+00_JPRB, 0.155476E+00_JPRB &
  &, 0.148692E+00_JPRB, 0.142094E+00_JPRB, 0.135753E+00_JPRB &
  &, 0.129631E+00_JPRB, 0.123688E+00_JPRB, 0.117994E+00_JPRB, 0.112452E+00_JPRB &
  &, 0.107131E+00_JPRB, 0.102047E+00_JPRB, 0.970929E-01_JPRB &
  &, 0.924020E-01_JPRB, 0.878661E-01_JPRB, 0.834959E-01_JPRB, 0.793020E-01_JPRB &
  &, 0.752316E-01_JPRB, 0.714228E-01_JPRB, 0.676925E-01_JPRB/)
XCW( 692, :) = (/ &
  &  0.104747E+01_JPRB, 0.105850E+01_JPRB, 0.106917E+01_JPRB, 0.107948E+01_JPRB &
  &, 0.108941E+01_JPRB, 0.109897E+01_JPRB, 0.110815E+01_JPRB &
  &, 0.111693E+01_JPRB, 0.112531E+01_JPRB, 0.113329E+01_JPRB, 0.114085E+01_JPRB &
  &, 0.114799E+01_JPRB, 0.115471E+01_JPRB, 0.116099E+01_JPRB &
  &, 0.116684E+01_JPRB, 0.117224E+01_JPRB, 0.117719E+01_JPRB, 0.118168E+01_JPRB &
  &, 0.118571E+01_JPRB, 0.118929E+01_JPRB, 0.119239E+01_JPRB &
  &, 0.119502E+01_JPRB, 0.119718E+01_JPRB, 0.119885E+01_JPRB, 0.120005E+01_JPRB &
  &, 0.120076E+01_JPRB, 0.120099E+01_JPRB, 0.120074E+01_JPRB &
  &, 0.119999E+01_JPRB, 0.119876E+01_JPRB, 0.119705E+01_JPRB, 0.119485E+01_JPRB &
  &, 0.119217E+01_JPRB, 0.118900E+01_JPRB, 0.118536E+01_JPRB &
  &, 0.118124E+01_JPRB, 0.117665E+01_JPRB, 0.117160E+01_JPRB, 0.116607E+01_JPRB &
  &, 0.116011E+01_JPRB, 0.115368E+01_JPRB, 0.114682E+01_JPRB &
  &, 0.113951E+01_JPRB, 0.113177E+01_JPRB, 0.112362E+01_JPRB, 0.111506E+01_JPRB &
  &, 0.110609E+01_JPRB, 0.109673E+01_JPRB, 0.108699E+01_JPRB &
  &, 0.107687E+01_JPRB, 0.106640E+01_JPRB, 0.105557E+01_JPRB, 0.104440E+01_JPRB &
  &, 0.103290E+01_JPRB, 0.102110E+01_JPRB, 0.100899E+01_JPRB &
  &, 0.996588E+00_JPRB, 0.983908E+00_JPRB, 0.970974E+00_JPRB, 0.957784E+00_JPRB &
  &, 0.944351E+00_JPRB, 0.930706E+00_JPRB, 0.916864E+00_JPRB &
  &, 0.902823E+00_JPRB, 0.888598E+00_JPRB, 0.874205E+00_JPRB, 0.859659E+00_JPRB &
  &, 0.844977E+00_JPRB, 0.830177E+00_JPRB, 0.815273E+00_JPRB &
  &, 0.800262E+00_JPRB, 0.785181E+00_JPRB, 0.770024E+00_JPRB, 0.754830E+00_JPRB &
  &, 0.739591E+00_JPRB, 0.724324E+00_JPRB, 0.709043E+00_JPRB &
  &, 0.693785E+00_JPRB, 0.678518E+00_JPRB, 0.663279E+00_JPRB, 0.648079E+00_JPRB &
  &, 0.632959E+00_JPRB, 0.617877E+00_JPRB, 0.602871E+00_JPRB &
  &, 0.587950E+00_JPRB, 0.573124E+00_JPRB, 0.558430E+00_JPRB, 0.543820E+00_JPRB &
  &, 0.529357E+00_JPRB, 0.515050E+00_JPRB, 0.500872E+00_JPRB &
  &, 0.486827E+00_JPRB, 0.472982E+00_JPRB, 0.459276E+00_JPRB, 0.445773E+00_JPRB &
  &, 0.432443E+00_JPRB, 0.419318E+00_JPRB, 0.406396E+00_JPRB &
  &, 0.393675E+00_JPRB, 0.381150E+00_JPRB, 0.368851E+00_JPRB, 0.356774E+00_JPRB &
  &, 0.344910E+00_JPRB, 0.333289E+00_JPRB, 0.321862E+00_JPRB &
  &, 0.310695E+00_JPRB, 0.299778E+00_JPRB, 0.289097E+00_JPRB, 0.278637E+00_JPRB &
  &, 0.268424E+00_JPRB, 0.258484E+00_JPRB, 0.248754E+00_JPRB &
  &, 0.239304E+00_JPRB, 0.230067E+00_JPRB, 0.221065E+00_JPRB, 0.212321E+00_JPRB &
  &, 0.203810E+00_JPRB, 0.195554E+00_JPRB, 0.187524E+00_JPRB &
  &, 0.179742E+00_JPRB, 0.172176E+00_JPRB, 0.164845E+00_JPRB, 0.157768E+00_JPRB &
  &, 0.150911E+00_JPRB, 0.144238E+00_JPRB, 0.137819E+00_JPRB &
  &, 0.131616E+00_JPRB, 0.125645E+00_JPRB, 0.119865E+00_JPRB, 0.114292E+00_JPRB &
  &, 0.108938E+00_JPRB, 0.103760E+00_JPRB, 0.987698E-01_JPRB &
  &, 0.939803E-01_JPRB, 0.894042E-01_JPRB, 0.849299E-01_JPRB, 0.806920E-01_JPRB &
  &, 0.766400E-01_JPRB, 0.727200E-01_JPRB, 0.690067E-01_JPRB/)
XCW( 693, :) = (/ &
  &  0.104777E+01_JPRB, 0.105887E+01_JPRB, 0.106962E+01_JPRB, 0.108000E+01_JPRB &
  &, 0.109002E+01_JPRB, 0.109966E+01_JPRB, 0.110891E+01_JPRB &
  &, 0.111778E+01_JPRB, 0.112624E+01_JPRB, 0.113430E+01_JPRB, 0.114194E+01_JPRB &
  &, 0.114917E+01_JPRB, 0.115596E+01_JPRB, 0.116234E+01_JPRB &
  &, 0.116826E+01_JPRB, 0.117375E+01_JPRB, 0.117878E+01_JPRB, 0.118337E+01_JPRB &
  &, 0.118749E+01_JPRB, 0.119114E+01_JPRB, 0.119433E+01_JPRB &
  &, 0.119705E+01_JPRB, 0.119929E+01_JPRB, 0.120105E+01_JPRB, 0.120233E+01_JPRB &
  &, 0.120313E+01_JPRB, 0.120344E+01_JPRB, 0.120327E+01_JPRB &
  &, 0.120261E+01_JPRB, 0.120146E+01_JPRB, 0.119983E+01_JPRB, 0.119771E+01_JPRB &
  &, 0.119510E+01_JPRB, 0.119202E+01_JPRB, 0.118845E+01_JPRB &
  &, 0.118442E+01_JPRB, 0.117990E+01_JPRB, 0.117492E+01_JPRB, 0.116948E+01_JPRB &
  &, 0.116358E+01_JPRB, 0.115723E+01_JPRB, 0.115042E+01_JPRB &
  &, 0.114319E+01_JPRB, 0.113553E+01_JPRB, 0.112745E+01_JPRB, 0.111894E+01_JPRB &
  &, 0.111004E+01_JPRB, 0.110074E+01_JPRB, 0.109105E+01_JPRB &
  &, 0.108098E+01_JPRB, 0.107057E+01_JPRB, 0.105979E+01_JPRB, 0.104868E+01_JPRB &
  &, 0.103723E+01_JPRB, 0.102546E+01_JPRB, 0.101339E+01_JPRB &
  &, 0.100104E+01_JPRB, 0.988411E+00_JPRB, 0.975501E+00_JPRB, 0.962348E+00_JPRB &
  &, 0.948952E+00_JPRB, 0.935341E+00_JPRB, 0.921514E+00_JPRB &
  &, 0.907486E+00_JPRB, 0.893291E+00_JPRB, 0.878925E+00_JPRB, 0.864386E+00_JPRB &
  &, 0.849728E+00_JPRB, 0.834928E+00_JPRB, 0.820043E+00_JPRB &
  &, 0.805028E+00_JPRB, 0.789961E+00_JPRB, 0.774816E+00_JPRB, 0.759609E+00_JPRB &
  &, 0.744355E+00_JPRB, 0.729091E+00_JPRB, 0.713811E+00_JPRB &
  &, 0.698504E+00_JPRB, 0.683232E+00_JPRB, 0.667984E+00_JPRB, 0.652774E+00_JPRB &
  &, 0.637614E+00_JPRB, 0.622488E+00_JPRB, 0.607461E+00_JPRB &
  &, 0.592517E+00_JPRB, 0.577664E+00_JPRB, 0.562940E+00_JPRB, 0.548296E+00_JPRB &
  &, 0.533796E+00_JPRB, 0.519417E+00_JPRB, 0.505195E+00_JPRB &
  &, 0.491133E+00_JPRB, 0.477205E+00_JPRB, 0.463475E+00_JPRB, 0.449914E+00_JPRB &
  &, 0.436554E+00_JPRB, 0.423363E+00_JPRB, 0.410370E+00_JPRB &
  &, 0.397574E+00_JPRB, 0.385007E+00_JPRB, 0.372663E+00_JPRB, 0.360499E+00_JPRB &
  &, 0.348583E+00_JPRB, 0.336906E+00_JPRB, 0.325419E+00_JPRB &
  &, 0.314190E+00_JPRB, 0.303207E+00_JPRB, 0.292458E+00_JPRB, 0.281925E+00_JPRB &
  &, 0.271636E+00_JPRB, 0.261616E+00_JPRB, 0.251847E+00_JPRB &
  &, 0.242265E+00_JPRB, 0.232983E+00_JPRB, 0.223933E+00_JPRB, 0.215092E+00_JPRB &
  &, 0.206528E+00_JPRB, 0.198216E+00_JPRB, 0.190128E+00_JPRB &
  &, 0.182235E+00_JPRB, 0.174604E+00_JPRB, 0.167258E+00_JPRB, 0.160060E+00_JPRB &
  &, 0.153130E+00_JPRB, 0.146436E+00_JPRB, 0.139939E+00_JPRB &
  &, 0.133656E+00_JPRB, 0.127601E+00_JPRB, 0.121793E+00_JPRB, 0.116131E+00_JPRB &
  &, 0.110745E+00_JPRB, 0.105473E+00_JPRB, 0.100447E+00_JPRB &
  &, 0.956193E-01_JPRB, 0.909423E-01_JPRB, 0.864887E-01_JPRB, 0.821452E-01_JPRB &
  &, 0.780484E-01_JPRB, 0.740821E-01_JPRB, 0.702552E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART99',1,ZHOOK_HANDLE)
END SUBROUTINE PART99

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART100

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART100',0,ZHOOK_HANDLE)

XCW( 694, :) = (/ &
  &  0.104806E+01_JPRB, 0.105924E+01_JPRB, 0.107006E+01_JPRB, 0.108053E+01_JPRB &
  &, 0.109062E+01_JPRB, 0.110034E+01_JPRB, 0.110968E+01_JPRB &
  &, 0.111862E+01_JPRB, 0.112717E+01_JPRB, 0.113531E+01_JPRB, 0.114304E+01_JPRB &
  &, 0.115035E+01_JPRB, 0.115723E+01_JPRB, 0.116368E+01_JPRB &
  &, 0.116970E+01_JPRB, 0.117526E+01_JPRB, 0.118039E+01_JPRB, 0.118505E+01_JPRB &
  &, 0.118926E+01_JPRB, 0.119300E+01_JPRB, 0.119627E+01_JPRB &
  &, 0.119908E+01_JPRB, 0.120140E+01_JPRB, 0.120325E+01_JPRB, 0.120461E+01_JPRB &
  &, 0.120550E+01_JPRB, 0.120589E+01_JPRB, 0.120581E+01_JPRB &
  &, 0.120523E+01_JPRB, 0.120416E+01_JPRB, 0.120261E+01_JPRB, 0.120058E+01_JPRB &
  &, 0.119805E+01_JPRB, 0.119505E+01_JPRB, 0.119157E+01_JPRB &
  &, 0.118760E+01_JPRB, 0.118317E+01_JPRB, 0.117826E+01_JPRB, 0.117289E+01_JPRB &
  &, 0.116707E+01_JPRB, 0.116078E+01_JPRB, 0.115405E+01_JPRB &
  &, 0.114689E+01_JPRB, 0.113930E+01_JPRB, 0.113127E+01_JPRB, 0.112284E+01_JPRB &
  &, 0.111400E+01_JPRB, 0.110476E+01_JPRB, 0.109513E+01_JPRB &
  &, 0.108512E+01_JPRB, 0.107476E+01_JPRB, 0.106403E+01_JPRB, 0.105297E+01_JPRB &
  &, 0.104158E+01_JPRB, 0.102986E+01_JPRB, 0.101783E+01_JPRB &
  &, 0.100551E+01_JPRB, 0.992915E+00_JPRB, 0.980060E+00_JPRB, 0.966929E+00_JPRB &
  &, 0.953569E+00_JPRB, 0.939993E+00_JPRB, 0.926200E+00_JPRB &
  &, 0.912186E+00_JPRB, 0.898021E+00_JPRB, 0.883664E+00_JPRB, 0.869151E+00_JPRB &
  &, 0.854497E+00_JPRB, 0.839719E+00_JPRB, 0.824834E+00_JPRB &
  &, 0.809836E+00_JPRB, 0.794762E+00_JPRB, 0.779608E+00_JPRB, 0.764411E+00_JPRB &
  &, 0.749164E+00_JPRB, 0.733882E+00_JPRB, 0.718579E+00_JPRB &
  &, 0.703271E+00_JPRB, 0.687995E+00_JPRB, 0.672715E+00_JPRB, 0.657495E+00_JPRB &
  &, 0.642295E+00_JPRB, 0.627153E+00_JPRB, 0.612107E+00_JPRB &
  &, 0.597139E+00_JPRB, 0.582232E+00_JPRB, 0.567450E+00_JPRB, 0.552802E+00_JPRB &
  &, 0.538265E+00_JPRB, 0.523846E+00_JPRB, 0.509580E+00_JPRB &
  &, 0.495472E+00_JPRB, 0.481492E+00_JPRB, 0.467708E+00_JPRB, 0.454088E+00_JPRB &
  &, 0.440666E+00_JPRB, 0.427442E+00_JPRB, 0.414380E+00_JPRB &
  &, 0.401545E+00_JPRB, 0.388900E+00_JPRB, 0.376474E+00_JPRB, 0.364262E+00_JPRB &
  &, 0.352293E+00_JPRB, 0.340522E+00_JPRB, 0.329016E+00_JPRB &
  &, 0.317726E+00_JPRB, 0.306637E+00_JPRB, 0.295818E+00_JPRB, 0.285255E+00_JPRB &
  &, 0.274890E+00_JPRB, 0.264791E+00_JPRB, 0.254940E+00_JPRB &
  &, 0.245316E+00_JPRB, 0.235944E+00_JPRB, 0.226802E+00_JPRB, 0.217957E+00_JPRB &
  &, 0.209294E+00_JPRB, 0.200878E+00_JPRB, 0.192732E+00_JPRB &
  &, 0.184777E+00_JPRB, 0.177083E+00_JPRB, 0.169670E+00_JPRB, 0.162403E+00_JPRB &
  &, 0.155402E+00_JPRB, 0.148633E+00_JPRB, 0.142113E+00_JPRB &
  &, 0.135751E+00_JPRB, 0.129614E+00_JPRB, 0.123721E+00_JPRB, 0.118028E+00_JPRB &
  &, 0.112551E+00_JPRB, 0.107246E+00_JPRB, 0.102124E+00_JPRB &
  &, 0.972584E-01_JPRB, 0.925420E-01_JPRB, 0.879850E-01_JPRB, 0.836615E-01_JPRB &
  &, 0.794568E-01_JPRB, 0.754442E-01_JPRB, 0.715694E-01_JPRB/)
XCW( 695, :) = (/ &
  &  0.104836E+01_JPRB, 0.105961E+01_JPRB, 0.107051E+01_JPRB, 0.108105E+01_JPRB &
  &, 0.109123E+01_JPRB, 0.110103E+01_JPRB, 0.111044E+01_JPRB &
  &, 0.111947E+01_JPRB, 0.112810E+01_JPRB, 0.113632E+01_JPRB, 0.114413E+01_JPRB &
  &, 0.115153E+01_JPRB, 0.115849E+01_JPRB, 0.116503E+01_JPRB &
  &, 0.117113E+01_JPRB, 0.117678E+01_JPRB, 0.118199E+01_JPRB, 0.118674E+01_JPRB &
  &, 0.119103E+01_JPRB, 0.119486E+01_JPRB, 0.119822E+01_JPRB &
  &, 0.120110E+01_JPRB, 0.120352E+01_JPRB, 0.120546E+01_JPRB, 0.120691E+01_JPRB &
  &, 0.120787E+01_JPRB, 0.120835E+01_JPRB, 0.120835E+01_JPRB &
  &, 0.120786E+01_JPRB, 0.120688E+01_JPRB, 0.120541E+01_JPRB, 0.120345E+01_JPRB &
  &, 0.120101E+01_JPRB, 0.119809E+01_JPRB, 0.119468E+01_JPRB &
  &, 0.119080E+01_JPRB, 0.118644E+01_JPRB, 0.118161E+01_JPRB, 0.117632E+01_JPRB &
  &, 0.117056E+01_JPRB, 0.116435E+01_JPRB, 0.115770E+01_JPRB &
  &, 0.115061E+01_JPRB, 0.114308E+01_JPRB, 0.113511E+01_JPRB, 0.112675E+01_JPRB &
  &, 0.111797E+01_JPRB, 0.110879E+01_JPRB, 0.109923E+01_JPRB &
  &, 0.108928E+01_JPRB, 0.107897E+01_JPRB, 0.106829E+01_JPRB, 0.105728E+01_JPRB &
  &, 0.104594E+01_JPRB, 0.103426E+01_JPRB, 0.102228E+01_JPRB &
  &, 0.101001E+01_JPRB, 0.997450E+00_JPRB, 0.984635E+00_JPRB, 0.971543E+00_JPRB &
  &, 0.958220E+00_JPRB, 0.944663E+00_JPRB, 0.930887E+00_JPRB &
  &, 0.916923E+00_JPRB, 0.902751E+00_JPRB, 0.888422E+00_JPRB, 0.873936E+00_JPRB &
  &, 0.859307E+00_JPRB, 0.844531E+00_JPRB, 0.829645E+00_JPRB &
  &, 0.814665E+00_JPRB, 0.799586E+00_JPRB, 0.784444E+00_JPRB, 0.769235E+00_JPRB &
  &, 0.753973E+00_JPRB, 0.738696E+00_JPRB, 0.723396E+00_JPRB &
  &, 0.708087E+00_JPRB, 0.692758E+00_JPRB, 0.677472E+00_JPRB, 0.662216E+00_JPRB &
  &, 0.647003E+00_JPRB, 0.631872E+00_JPRB, 0.616779E+00_JPRB &
  &, 0.601762E+00_JPRB, 0.586857E+00_JPRB, 0.572046E+00_JPRB, 0.557337E+00_JPRB &
  &, 0.542734E+00_JPRB, 0.528306E+00_JPRB, 0.513997E+00_JPRB &
  &, 0.499810E+00_JPRB, 0.485811E+00_JPRB, 0.471973E+00_JPRB, 0.458328E+00_JPRB &
  &, 0.444845E+00_JPRB, 0.431521E+00_JPRB, 0.418424E+00_JPRB &
  &, 0.405552E+00_JPRB, 0.392829E+00_JPRB, 0.380359E+00_JPRB, 0.368100E+00_JPRB &
  &, 0.356042E+00_JPRB, 0.344217E+00_JPRB, 0.332614E+00_JPRB &
  &, 0.321261E+00_JPRB, 0.310148E+00_JPRB, 0.299262E+00_JPRB, 0.288585E+00_JPRB &
  &, 0.278188E+00_JPRB, 0.268010E+00_JPRB, 0.258077E+00_JPRB &
  &, 0.248412E+00_JPRB, 0.238952E+00_JPRB, 0.229763E+00_JPRB, 0.220823E+00_JPRB &
  &, 0.212107E+00_JPRB, 0.203589E+00_JPRB, 0.195385E+00_JPRB &
  &, 0.187370E+00_JPRB, 0.179613E+00_JPRB, 0.172083E+00_JPRB, 0.164799E+00_JPRB &
  &, 0.157727E+00_JPRB, 0.150884E+00_JPRB, 0.144288E+00_JPRB &
  &, 0.137846E+00_JPRB, 0.131683E+00_JPRB, 0.125705E+00_JPRB, 0.119925E+00_JPRB &
  &, 0.114416E+00_JPRB, 0.109018E+00_JPRB, 0.103861E+00_JPRB &
  &, 0.988974E-01_JPRB, 0.941416E-01_JPRB, 0.895438E-01_JPRB, 0.851147E-01_JPRB &
  &, 0.809292E-01_JPRB, 0.768063E-01_JPRB, 0.729494E-01_JPRB/)
XCW( 696, :) = (/ &
  &  0.104865E+01_JPRB, 0.105998E+01_JPRB, 0.107096E+01_JPRB, 0.108158E+01_JPRB &
  &, 0.109183E+01_JPRB, 0.110171E+01_JPRB, 0.111121E+01_JPRB &
  &, 0.112032E+01_JPRB, 0.112903E+01_JPRB, 0.113734E+01_JPRB, 0.114523E+01_JPRB &
  &, 0.115271E+01_JPRB, 0.115976E+01_JPRB, 0.116638E+01_JPRB &
  &, 0.117256E+01_JPRB, 0.117831E+01_JPRB, 0.118360E+01_JPRB, 0.118844E+01_JPRB &
  &, 0.119281E+01_JPRB, 0.119673E+01_JPRB, 0.120017E+01_JPRB &
  &, 0.120315E+01_JPRB, 0.120565E+01_JPRB, 0.120767E+01_JPRB, 0.120920E+01_JPRB &
  &, 0.121026E+01_JPRB, 0.121082E+01_JPRB, 0.121090E+01_JPRB &
  &, 0.121049E+01_JPRB, 0.120960E+01_JPRB, 0.120821E+01_JPRB, 0.120634E+01_JPRB &
  &, 0.120398E+01_JPRB, 0.120114E+01_JPRB, 0.119781E+01_JPRB &
  &, 0.119400E+01_JPRB, 0.118972E+01_JPRB, 0.118497E+01_JPRB, 0.117975E+01_JPRB &
  &, 0.117408E+01_JPRB, 0.116794E+01_JPRB, 0.116136E+01_JPRB &
  &, 0.115433E+01_JPRB, 0.114687E+01_JPRB, 0.113898E+01_JPRB, 0.113067E+01_JPRB &
  &, 0.112195E+01_JPRB, 0.111285E+01_JPRB, 0.110333E+01_JPRB &
  &, 0.109344E+01_JPRB, 0.108319E+01_JPRB, 0.107258E+01_JPRB, 0.106161E+01_JPRB &
  &, 0.105032E+01_JPRB, 0.103869E+01_JPRB, 0.102677E+01_JPRB &
  &, 0.101453E+01_JPRB, 0.100202E+01_JPRB, 0.989226E+00_JPRB, 0.976174E+00_JPRB &
  &, 0.962888E+00_JPRB, 0.949350E+00_JPRB, 0.935608E+00_JPRB &
  &, 0.921659E+00_JPRB, 0.907536E+00_JPRB, 0.893219E+00_JPRB, 0.878740E+00_JPRB &
  &, 0.864116E+00_JPRB, 0.849363E+00_JPRB, 0.834498E+00_JPRB &
  &, 0.819515E+00_JPRB, 0.804452E+00_JPRB, 0.789302E+00_JPRB, 0.774104E+00_JPRB &
  &, 0.758828E+00_JPRB, 0.743533E+00_JPRB, 0.728235E+00_JPRB &
  &, 0.712902E+00_JPRB, 0.697571E+00_JPRB, 0.682278E+00_JPRB, 0.667014E+00_JPRB &
  &, 0.651764E+00_JPRB, 0.636590E+00_JPRB, 0.621479E+00_JPRB &
  &, 0.606440E+00_JPRB, 0.591482E+00_JPRB, 0.576643E+00_JPRB, 0.561901E+00_JPRB &
  &, 0.547263E+00_JPRB, 0.532796E+00_JPRB, 0.518413E+00_JPRB &
  &, 0.504211E+00_JPRB, 0.490163E+00_JPRB, 0.476271E+00_JPRB, 0.462569E+00_JPRB &
  &, 0.449024E+00_JPRB, 0.435670E+00_JPRB, 0.422539E+00_JPRB &
  &, 0.409559E+00_JPRB, 0.396796E+00_JPRB, 0.384282E+00_JPRB, 0.371937E+00_JPRB &
  &, 0.359829E+00_JPRB, 0.347950E+00_JPRB, 0.336290E+00_JPRB &
  &, 0.324837E+00_JPRB, 0.313660E+00_JPRB, 0.302705E+00_JPRB, 0.292000E+00_JPRB &
  &, 0.281485E+00_JPRB, 0.271273E+00_JPRB, 0.261258E+00_JPRB &
  &, 0.251508E+00_JPRB, 0.242004E+00_JPRB, 0.232724E+00_JPRB, 0.223688E+00_JPRB &
  &, 0.214920E+00_JPRB, 0.206348E+00_JPRB, 0.198087E+00_JPRB &
  &, 0.190012E+00_JPRB, 0.182143E+00_JPRB, 0.174547E+00_JPRB, 0.167195E+00_JPRB &
  &, 0.160052E+00_JPRB, 0.153135E+00_JPRB, 0.146462E+00_JPRB &
  &, 0.139996E+00_JPRB, 0.133752E+00_JPRB, 0.127746E+00_JPRB, 0.121880E+00_JPRB &
  &, 0.116281E+00_JPRB, 0.110850E+00_JPRB, 0.105657E+00_JPRB &
  &, 0.100597E+00_JPRB, 0.958027E-01_JPRB, 0.911025E-01_JPRB, 0.866310E-01_JPRB &
  &, 0.823376E-01_JPRB, 0.782333E-01_JPRB, 0.743293E-01_JPRB/)
XCW( 697, :) = (/ &
  &  0.104895E+01_JPRB, 0.106035E+01_JPRB, 0.107141E+01_JPRB, 0.108211E+01_JPRB &
  &, 0.109244E+01_JPRB, 0.110240E+01_JPRB, 0.111198E+01_JPRB &
  &, 0.112117E+01_JPRB, 0.112996E+01_JPRB, 0.113835E+01_JPRB, 0.114633E+01_JPRB &
  &, 0.115389E+01_JPRB, 0.116103E+01_JPRB, 0.116774E+01_JPRB &
  &, 0.117400E+01_JPRB, 0.117983E+01_JPRB, 0.118521E+01_JPRB, 0.119013E+01_JPRB &
  &, 0.119460E+01_JPRB, 0.119860E+01_JPRB, 0.120213E+01_JPRB &
  &, 0.120519E+01_JPRB, 0.120778E+01_JPRB, 0.120988E+01_JPRB, 0.121151E+01_JPRB &
  &, 0.121264E+01_JPRB, 0.121330E+01_JPRB, 0.121346E+01_JPRB &
  &, 0.121314E+01_JPRB, 0.121232E+01_JPRB, 0.121102E+01_JPRB, 0.120923E+01_JPRB &
  &, 0.120695E+01_JPRB, 0.120419E+01_JPRB, 0.120095E+01_JPRB &
  &, 0.119722E+01_JPRB, 0.119302E+01_JPRB, 0.118835E+01_JPRB, 0.118320E+01_JPRB &
  &, 0.117759E+01_JPRB, 0.117154E+01_JPRB, 0.116502E+01_JPRB &
  &, 0.115806E+01_JPRB, 0.115067E+01_JPRB, 0.114285E+01_JPRB, 0.113462E+01_JPRB &
  &, 0.112596E+01_JPRB, 0.111690E+01_JPRB, 0.110746E+01_JPRB &
  &, 0.109763E+01_JPRB, 0.108743E+01_JPRB, 0.107686E+01_JPRB, 0.106596E+01_JPRB &
  &, 0.105471E+01_JPRB, 0.104314E+01_JPRB, 0.103125E+01_JPRB &
  &, 0.101906E+01_JPRB, 0.100658E+01_JPRB, 0.993834E+00_JPRB, 0.980821E+00_JPRB &
  &, 0.967574E+00_JPRB, 0.954072E+00_JPRB, 0.940365E+00_JPRB &
  &, 0.926432E+00_JPRB, 0.912322E+00_JPRB, 0.898034E+00_JPRB, 0.883583E+00_JPRB &
  &, 0.868945E+00_JPRB, 0.854236E+00_JPRB, 0.839371E+00_JPRB &
  &, 0.824408E+00_JPRB, 0.809340E+00_JPRB, 0.794182E+00_JPRB, 0.778973E+00_JPRB &
  &, 0.763728E+00_JPRB, 0.748417E+00_JPRB, 0.733099E+00_JPRB &
  &, 0.717767E+00_JPRB, 0.702433E+00_JPRB, 0.687110E+00_JPRB, 0.671812E+00_JPRB &
  &, 0.656550E+00_JPRB, 0.641363E+00_JPRB, 0.626207E+00_JPRB &
  &, 0.611147E+00_JPRB, 0.596164E+00_JPRB, 0.581268E+00_JPRB, 0.566495E+00_JPRB &
  &, 0.551852E+00_JPRB, 0.537316E+00_JPRB, 0.522892E+00_JPRB &
  &, 0.508644E+00_JPRB, 0.494547E+00_JPRB, 0.480634E+00_JPRB, 0.466843E+00_JPRB &
  &, 0.453271E+00_JPRB, 0.439853E+00_JPRB, 0.426654E+00_JPRB &
  &, 0.413637E+00_JPRB, 0.400834E+00_JPRB, 0.388204E+00_JPRB, 0.375813E+00_JPRB &
  &, 0.363655E+00_JPRB, 0.351684E+00_JPRB, 0.339966E+00_JPRB &
  &, 0.328493E+00_JPRB, 0.317212E+00_JPRB, 0.306190E+00_JPRB, 0.295414E+00_JPRB &
  &, 0.284868E+00_JPRB, 0.274535E+00_JPRB, 0.264483E+00_JPRB &
  &, 0.254649E+00_JPRB, 0.245057E+00_JPRB, 0.235731E+00_JPRB, 0.226647E+00_JPRB &
  &, 0.217781E+00_JPRB, 0.209155E+00_JPRB, 0.200789E+00_JPRB &
  &, 0.192655E+00_JPRB, 0.184723E+00_JPRB, 0.177063E+00_JPRB, 0.169643E+00_JPRB &
  &, 0.162429E+00_JPRB, 0.155440E+00_JPRB, 0.148691E+00_JPRB &
  &, 0.142201E+00_JPRB, 0.135876E+00_JPRB, 0.129787E+00_JPRB, 0.123892E+00_JPRB &
  &, 0.118205E+00_JPRB, 0.112681E+00_JPRB, 0.107454E+00_JPRB &
  &, 0.102358E+00_JPRB, 0.974639E-01_JPRB, 0.927236E-01_JPRB, 0.882106E-01_JPRB &
  &, 0.838740E-01_JPRB, 0.796602E-01_JPRB, 0.757092E-01_JPRB/)
XCW( 698, :) = (/ &
  &  0.104924E+01_JPRB, 0.106073E+01_JPRB, 0.107186E+01_JPRB, 0.108264E+01_JPRB &
  &, 0.109305E+01_JPRB, 0.110309E+01_JPRB, 0.111275E+01_JPRB &
  &, 0.112202E+01_JPRB, 0.113090E+01_JPRB, 0.113937E+01_JPRB, 0.114743E+01_JPRB &
  &, 0.115508E+01_JPRB, 0.116230E+01_JPRB, 0.116909E+01_JPRB &
  &, 0.117545E+01_JPRB, 0.118136E+01_JPRB, 0.118683E+01_JPRB, 0.119184E+01_JPRB &
  &, 0.119639E+01_JPRB, 0.120048E+01_JPRB, 0.120410E+01_JPRB &
  &, 0.120724E+01_JPRB, 0.120991E+01_JPRB, 0.121211E+01_JPRB, 0.121382E+01_JPRB &
  &, 0.121504E+01_JPRB, 0.121578E+01_JPRB, 0.121603E+01_JPRB &
  &, 0.121579E+01_JPRB, 0.121506E+01_JPRB, 0.121384E+01_JPRB, 0.121214E+01_JPRB &
  &, 0.120994E+01_JPRB, 0.120726E+01_JPRB, 0.120409E+01_JPRB &
  &, 0.120044E+01_JPRB, 0.119633E+01_JPRB, 0.119173E+01_JPRB, 0.118666E+01_JPRB &
  &, 0.118113E+01_JPRB, 0.117514E+01_JPRB, 0.116870E+01_JPRB &
  &, 0.116182E+01_JPRB, 0.115450E+01_JPRB, 0.114675E+01_JPRB, 0.113858E+01_JPRB &
  &, 0.112998E+01_JPRB, 0.112100E+01_JPRB, 0.111160E+01_JPRB &
  &, 0.110184E+01_JPRB, 0.109169E+01_JPRB, 0.108118E+01_JPRB, 0.107033E+01_JPRB &
  &, 0.105913E+01_JPRB, 0.104761E+01_JPRB, 0.103576E+01_JPRB &
  &, 0.102362E+01_JPRB, 0.101118E+01_JPRB, 0.998474E+00_JPRB, 0.985501E+00_JPRB &
  &, 0.972276E+00_JPRB, 0.958811E+00_JPRB, 0.945104E+00_JPRB &
  &, 0.931240E+00_JPRB, 0.917145E+00_JPRB, 0.902887E+00_JPRB, 0.888445E+00_JPRB &
  &, 0.873854E+00_JPRB, 0.859129E+00_JPRB, 0.844265E+00_JPRB &
  &, 0.829300E+00_JPRB, 0.814249E+00_JPRB, 0.799106E+00_JPRB, 0.783909E+00_JPRB &
  &, 0.768629E+00_JPRB, 0.753324E+00_JPRB, 0.737987E+00_JPRB &
  &, 0.722655E+00_JPRB, 0.707295E+00_JPRB, 0.691968E+00_JPRB, 0.676636E+00_JPRB &
  &, 0.661363E+00_JPRB, 0.646135E+00_JPRB, 0.630989E+00_JPRB &
  &, 0.615880E+00_JPRB, 0.600874E+00_JPRB, 0.585951E+00_JPRB, 0.571147E+00_JPRB &
  &, 0.556441E+00_JPRB, 0.541867E+00_JPRB, 0.527433E+00_JPRB &
  &, 0.513109E+00_JPRB, 0.498963E+00_JPRB, 0.484998E+00_JPRB, 0.471184E+00_JPRB &
  &, 0.457519E+00_JPRB, 0.444070E+00_JPRB, 0.430804E+00_JPRB &
  &, 0.417715E+00_JPRB, 0.404873E+00_JPRB, 0.392200E+00_JPRB, 0.379726E+00_JPRB &
  &, 0.367519E+00_JPRB, 0.355495E+00_JPRB, 0.343722E+00_JPRB &
  &, 0.332149E+00_JPRB, 0.320805E+00_JPRB, 0.309716E+00_JPRB, 0.298870E+00_JPRB &
  &, 0.288251E+00_JPRB, 0.277885E+00_JPRB, 0.267708E+00_JPRB &
  &, 0.257835E+00_JPRB, 0.248156E+00_JPRB, 0.238784E+00_JPRB, 0.229606E+00_JPRB &
  &, 0.220690E+00_JPRB, 0.211962E+00_JPRB, 0.203540E+00_JPRB &
  &, 0.195347E+00_JPRB, 0.187354E+00_JPRB, 0.179629E+00_JPRB, 0.172143E+00_JPRB &
  &, 0.164860E+00_JPRB, 0.157798E+00_JPRB, 0.150974E+00_JPRB &
  &, 0.144352E+00_JPRB, 0.138001E+00_JPRB, 0.131828E+00_JPRB, 0.125846E+00_JPRB &
  &, 0.120128E+00_JPRB, 0.114572E+00_JPRB, 0.109251E+00_JPRB &
  &, 0.104118E+00_JPRB, 0.991250E-01_JPRB, 0.943447E-01_JPRB, 0.897901E-01_JPRB &
  &, 0.854105E-01_JPRB, 0.811521E-01_JPRB, 0.770892E-01_JPRB/)
XCW( 699, :) = (/ &
  &  0.104954E+01_JPRB, 0.106110E+01_JPRB, 0.107231E+01_JPRB, 0.108317E+01_JPRB &
  &, 0.109366E+01_JPRB, 0.110378E+01_JPRB, 0.111352E+01_JPRB &
  &, 0.112288E+01_JPRB, 0.113184E+01_JPRB, 0.114039E+01_JPRB, 0.114854E+01_JPRB &
  &, 0.115627E+01_JPRB, 0.116358E+01_JPRB, 0.117045E+01_JPRB &
  &, 0.117689E+01_JPRB, 0.118289E+01_JPRB, 0.118845E+01_JPRB, 0.119354E+01_JPRB &
  &, 0.119818E+01_JPRB, 0.120236E+01_JPRB, 0.120606E+01_JPRB &
  &, 0.120930E+01_JPRB, 0.121206E+01_JPRB, 0.121434E+01_JPRB, 0.121613E+01_JPRB &
  &, 0.121744E+01_JPRB, 0.121827E+01_JPRB, 0.121860E+01_JPRB &
  &, 0.121845E+01_JPRB, 0.121780E+01_JPRB, 0.121667E+01_JPRB, 0.121505E+01_JPRB &
  &, 0.121294E+01_JPRB, 0.121033E+01_JPRB, 0.120725E+01_JPRB &
  &, 0.120368E+01_JPRB, 0.119964E+01_JPRB, 0.119512E+01_JPRB, 0.119014E+01_JPRB &
  &, 0.118467E+01_JPRB, 0.117877E+01_JPRB, 0.117240E+01_JPRB &
  &, 0.116558E+01_JPRB, 0.115834E+01_JPRB, 0.115065E+01_JPRB, 0.114255E+01_JPRB &
  &, 0.113401E+01_JPRB, 0.112509E+01_JPRB, 0.111575E+01_JPRB &
  &, 0.110606E+01_JPRB, 0.109597E+01_JPRB, 0.108552E+01_JPRB, 0.107472E+01_JPRB &
  &, 0.106357E+01_JPRB, 0.105209E+01_JPRB, 0.104030E+01_JPRB &
  &, 0.102820E+01_JPRB, 0.101581E+01_JPRB, 0.100313E+01_JPRB, 0.990198E+00_JPRB &
  &, 0.977012E+00_JPRB, 0.963585E+00_JPRB, 0.949933E+00_JPRB &
  &, 0.936049E+00_JPRB, 0.921986E+00_JPRB, 0.907740E+00_JPRB, 0.893327E+00_JPRB &
  &, 0.878762E+00_JPRB, 0.864042E+00_JPRB, 0.849201E+00_JPRB &
  &, 0.834087E+00_JPRB, 0.819201E+00_JPRB, 0.804052E+00_JPRB, 0.788846E+00_JPRB &
  &, 0.773575E+00_JPRB, 0.758278E+00_JPRB, 0.742922E+00_JPRB &
  &, 0.727568E+00_JPRB, 0.712207E+00_JPRB, 0.696851E+00_JPRB, 0.681512E+00_JPRB &
  &, 0.666229E+00_JPRB, 0.650961E+00_JPRB, 0.635771E+00_JPRB &
  &, 0.620642E+00_JPRB, 0.605613E+00_JPRB, 0.590663E+00_JPRB, 0.575800E+00_JPRB &
  &, 0.561060E+00_JPRB, 0.546449E+00_JPRB, 0.531973E+00_JPRB &
  &, 0.517637E+00_JPRB, 0.503443E+00_JPRB, 0.489394E+00_JPRB, 0.475524E+00_JPRB &
  &, 0.461834E+00_JPRB, 0.448323E+00_JPRB, 0.434989E+00_JPRB &
  &, 0.421865E+00_JPRB, 0.408948E+00_JPRB, 0.396233E+00_JPRB, 0.383714E+00_JPRB &
  &, 0.371421E+00_JPRB, 0.359345E+00_JPRB, 0.347477E+00_JPRB &
  &, 0.335845E+00_JPRB, 0.324439E+00_JPRB, 0.313284E+00_JPRB, 0.302369E+00_JPRB &
  &, 0.291677E+00_JPRB, 0.281234E+00_JPRB, 0.271022E+00_JPRB &
  &, 0.261066E+00_JPRB, 0.251300E+00_JPRB, 0.241838E+00_JPRB, 0.232613E+00_JPRB &
  &, 0.223599E+00_JPRB, 0.214866E+00_JPRB, 0.206340E+00_JPRB &
  &, 0.198039E+00_JPRB, 0.189985E+00_JPRB, 0.182196E+00_JPRB, 0.174643E+00_JPRB &
  &, 0.167290E+00_JPRB, 0.160156E+00_JPRB, 0.153258E+00_JPRB &
  &, 0.146612E+00_JPRB, 0.140182E+00_JPRB, 0.133926E+00_JPRB, 0.127916E+00_JPRB &
  &, 0.122110E+00_JPRB, 0.116463E+00_JPRB, 0.111107E+00_JPRB &
  &, 0.105878E+00_JPRB, 0.100848E+00_JPRB, 0.960281E-01_JPRB, 0.913696E-01_JPRB &
  &, 0.869469E-01_JPRB, 0.826439E-01_JPRB, 0.785348E-01_JPRB/)
XCW( 700, :) = (/ &
  &  0.104984E+01_JPRB, 0.106147E+01_JPRB, 0.107276E+01_JPRB, 0.108370E+01_JPRB &
  &, 0.109427E+01_JPRB, 0.110447E+01_JPRB, 0.111430E+01_JPRB &
  &, 0.112373E+01_JPRB, 0.113277E+01_JPRB, 0.114141E+01_JPRB, 0.114965E+01_JPRB &
  &, 0.115746E+01_JPRB, 0.116485E+01_JPRB, 0.117182E+01_JPRB &
  &, 0.117835E+01_JPRB, 0.118443E+01_JPRB, 0.119007E+01_JPRB, 0.119525E+01_JPRB &
  &, 0.119998E+01_JPRB, 0.120424E+01_JPRB, 0.120804E+01_JPRB &
  &, 0.121136E+01_JPRB, 0.121420E+01_JPRB, 0.121657E+01_JPRB, 0.121846E+01_JPRB &
  &, 0.121985E+01_JPRB, 0.122076E+01_JPRB, 0.122118E+01_JPRB &
  &, 0.122112E+01_JPRB, 0.122056E+01_JPRB, 0.121951E+01_JPRB, 0.121797E+01_JPRB &
  &, 0.121594E+01_JPRB, 0.121342E+01_JPRB, 0.121042E+01_JPRB &
  &, 0.120694E+01_JPRB, 0.120296E+01_JPRB, 0.119853E+01_JPRB, 0.119361E+01_JPRB &
  &, 0.118824E+01_JPRB, 0.118239E+01_JPRB, 0.117610E+01_JPRB &
  &, 0.116937E+01_JPRB, 0.116219E+01_JPRB, 0.115457E+01_JPRB, 0.114653E+01_JPRB &
  &, 0.113807E+01_JPRB, 0.112921E+01_JPRB, 0.111994E+01_JPRB &
  &, 0.111029E+01_JPRB, 0.110026E+01_JPRB, 0.108985E+01_JPRB, 0.107912E+01_JPRB &
  &, 0.106802E+01_JPRB, 0.105660E+01_JPRB, 0.104485E+01_JPRB &
  &, 0.103281E+01_JPRB, 0.102044E+01_JPRB, 0.100782E+01_JPRB, 0.994911E+00_JPRB &
  &, 0.981765E+00_JPRB, 0.968359E+00_JPRB, 0.954743E+00_JPRB &
  &, 0.940876E+00_JPRB, 0.926864E+00_JPRB, 0.912631E+00_JPRB, 0.898247E+00_JPRB &
  &, 0.883690E+00_JPRB, 0.868995E+00_JPRB, 0.854157E+00_JPRB &
  &, 0.839212E+00_JPRB, 0.824154E+00_JPRB, 0.809020E+00_JPRB, 0.793827E+00_JPRB &
  &, 0.778544E+00_JPRB, 0.763232E+00_JPRB, 0.747881E+00_JPRB &
  &, 0.732530E+00_JPRB, 0.717144E+00_JPRB, 0.701784E+00_JPRB, 0.686413E+00_JPRB &
  &, 0.671095E+00_JPRB, 0.655840E+00_JPRB, 0.640607E+00_JPRB &
  &, 0.625460E+00_JPRB, 0.610380E+00_JPRB, 0.595404E+00_JPRB, 0.580512E+00_JPRB &
  &, 0.565739E+00_JPRB, 0.551092E+00_JPRB, 0.536545E+00_JPRB &
  &, 0.522165E+00_JPRB, 0.507924E+00_JPRB, 0.493857E+00_JPRB, 0.479932E+00_JPRB &
  &, 0.466183E+00_JPRB, 0.452609E+00_JPRB, 0.439245E+00_JPRB &
  &, 0.426051E+00_JPRB, 0.413060E+00_JPRB, 0.400267E+00_JPRB, 0.387702E+00_JPRB &
  &, 0.375322E+00_JPRB, 0.363195E+00_JPRB, 0.351272E+00_JPRB &
  &, 0.339582E+00_JPRB, 0.328113E+00_JPRB, 0.316894E+00_JPRB, 0.305910E+00_JPRB &
  &, 0.295146E+00_JPRB, 0.284627E+00_JPRB, 0.274336E+00_JPRB &
  &, 0.264296E+00_JPRB, 0.254489E+00_JPRB, 0.244938E+00_JPRB, 0.235619E+00_JPRB &
  &, 0.226555E+00_JPRB, 0.217722E+00_JPRB, 0.209140E+00_JPRB &
  &, 0.200781E+00_JPRB, 0.192666E+00_JPRB, 0.184814E+00_JPRB, 0.177143E+00_JPRB &
  &, 0.169774E+00_JPRB, 0.162568E+00_JPRB, 0.155595E+00_JPRB &
  &, 0.148873E+00_JPRB, 0.142362E+00_JPRB, 0.136080E+00_JPRB, 0.129985E+00_JPRB &
  &, 0.124091E+00_JPRB, 0.118413E+00_JPRB, 0.112964E+00_JPRB &
  &, 0.107700E+00_JPRB, 0.102632E+00_JPRB, 0.977116E-01_JPRB, 0.930123E-01_JPRB &
  &, 0.884834E-01_JPRB, 0.841357E-01_JPRB, 0.799804E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART100',1,ZHOOK_HANDLE)
END SUBROUTINE PART100

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART101

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART101',0,ZHOOK_HANDLE)

XCW( 701, :) = (/ &
  &  0.105013E+01_JPRB, 0.106185E+01_JPRB, 0.107322E+01_JPRB, 0.108423E+01_JPRB &
  &, 0.109488E+01_JPRB, 0.110517E+01_JPRB, 0.111507E+01_JPRB &
  &, 0.112459E+01_JPRB, 0.113371E+01_JPRB, 0.114244E+01_JPRB, 0.115075E+01_JPRB &
  &, 0.115866E+01_JPRB, 0.116613E+01_JPRB, 0.117318E+01_JPRB &
  &, 0.117980E+01_JPRB, 0.118597E+01_JPRB, 0.119170E+01_JPRB, 0.119697E+01_JPRB &
  &, 0.120178E+01_JPRB, 0.120613E+01_JPRB, 0.121002E+01_JPRB &
  &, 0.121342E+01_JPRB, 0.121636E+01_JPRB, 0.121881E+01_JPRB, 0.122078E+01_JPRB &
  &, 0.122227E+01_JPRB, 0.122327E+01_JPRB, 0.122378E+01_JPRB &
  &, 0.122379E+01_JPRB, 0.122332E+01_JPRB, 0.122235E+01_JPRB, 0.122090E+01_JPRB &
  &, 0.121895E+01_JPRB, 0.121652E+01_JPRB, 0.121360E+01_JPRB &
  &, 0.121019E+01_JPRB, 0.120630E+01_JPRB, 0.120195E+01_JPRB, 0.119711E+01_JPRB &
  &, 0.119181E+01_JPRB, 0.118605E+01_JPRB, 0.117983E+01_JPRB &
  &, 0.117316E+01_JPRB, 0.116604E+01_JPRB, 0.115850E+01_JPRB, 0.115052E+01_JPRB &
  &, 0.114214E+01_JPRB, 0.113334E+01_JPRB, 0.112413E+01_JPRB &
  &, 0.111454E+01_JPRB, 0.110458E+01_JPRB, 0.109423E+01_JPRB, 0.108354E+01_JPRB &
  &, 0.107250E+01_JPRB, 0.106113E+01_JPRB, 0.104942E+01_JPRB &
  &, 0.103742E+01_JPRB, 0.102511E+01_JPRB, 0.101252E+01_JPRB, 0.999658E+00_JPRB &
  &, 0.986535E+00_JPRB, 0.973185E+00_JPRB, 0.959589E+00_JPRB &
  &, 0.945776E+00_JPRB, 0.931761E+00_JPRB, 0.917560E+00_JPRB, 0.903187E+00_JPRB &
  &, 0.888638E+00_JPRB, 0.873948E+00_JPRB, 0.859133E+00_JPRB &
  &, 0.844209E+00_JPRB, 0.829171E+00_JPRB, 0.814032E+00_JPRB, 0.798831E+00_JPRB &
  &, 0.783560E+00_JPRB, 0.768233E+00_JPRB, 0.752888E+00_JPRB &
  &, 0.737492E+00_JPRB, 0.722105E+00_JPRB, 0.706717E+00_JPRB, 0.691366E+00_JPRB &
  &, 0.676013E+00_JPRB, 0.660720E+00_JPRB, 0.645471E+00_JPRB &
  &, 0.630305E+00_JPRB, 0.615204E+00_JPRB, 0.600174E+00_JPRB, 0.585253E+00_JPRB &
  &, 0.570448E+00_JPRB, 0.555735E+00_JPRB, 0.541179E+00_JPRB &
  &, 0.526757E+00_JPRB, 0.512469E+00_JPRB, 0.498319E+00_JPRB, 0.484373E+00_JPRB &
  &, 0.470566E+00_JPRB, 0.456931E+00_JPRB, 0.443500E+00_JPRB &
  &, 0.430272E+00_JPRB, 0.417208E+00_JPRB, 0.404374E+00_JPRB, 0.391728E+00_JPRB &
  &, 0.379301E+00_JPRB, 0.367084E+00_JPRB, 0.355106E+00_JPRB &
  &, 0.343358E+00_JPRB, 0.331829E+00_JPRB, 0.320545E+00_JPRB, 0.309451E+00_JPRB &
  &, 0.298657E+00_JPRB, 0.288063E+00_JPRB, 0.277693E+00_JPRB &
  &, 0.267572E+00_JPRB, 0.257724E+00_JPRB, 0.248084E+00_JPRB, 0.238719E+00_JPRB &
  &, 0.229559E+00_JPRB, 0.220674E+00_JPRB, 0.211989E+00_JPRB &
  &, 0.203573E+00_JPRB, 0.195398E+00_JPRB, 0.187432E+00_JPRB, 0.179747E+00_JPRB &
  &, 0.172257E+00_JPRB, 0.164980E+00_JPRB, 0.157987E+00_JPRB &
  &, 0.151188E+00_JPRB, 0.144599E+00_JPRB, 0.138235E+00_JPRB, 0.132055E+00_JPRB &
  &, 0.126131E+00_JPRB, 0.120362E+00_JPRB, 0.114880E+00_JPRB &
  &, 0.109521E+00_JPRB, 0.104355E+00_JPRB, 0.994573E-01_JPRB, 0.946550E-01_JPRB &
  &, 0.900838E-01_JPRB, 0.856924E-01_JPRB, 0.814918E-01_JPRB/)
XCW( 702, :) = (/ &
  &  0.105043E+01_JPRB, 0.106222E+01_JPRB, 0.107367E+01_JPRB, 0.108476E+01_JPRB &
  &, 0.109550E+01_JPRB, 0.110586E+01_JPRB, 0.111585E+01_JPRB &
  &, 0.112545E+01_JPRB, 0.113466E+01_JPRB, 0.114347E+01_JPRB, 0.115187E+01_JPRB &
  &, 0.115985E+01_JPRB, 0.116742E+01_JPRB, 0.117455E+01_JPRB &
  &, 0.118126E+01_JPRB, 0.118751E+01_JPRB, 0.119333E+01_JPRB, 0.119869E+01_JPRB &
  &, 0.120359E+01_JPRB, 0.120803E+01_JPRB, 0.121200E+01_JPRB &
  &, 0.121550E+01_JPRB, 0.121852E+01_JPRB, 0.122106E+01_JPRB, 0.122312E+01_JPRB &
  &, 0.122469E+01_JPRB, 0.122578E+01_JPRB, 0.122637E+01_JPRB &
  &, 0.122647E+01_JPRB, 0.122609E+01_JPRB, 0.122521E+01_JPRB, 0.122384E+01_JPRB &
  &, 0.122198E+01_JPRB, 0.121962E+01_JPRB, 0.121679E+01_JPRB &
  &, 0.121346E+01_JPRB, 0.120966E+01_JPRB, 0.120537E+01_JPRB, 0.120062E+01_JPRB &
  &, 0.119539E+01_JPRB, 0.118971E+01_JPRB, 0.118356E+01_JPRB &
  &, 0.117697E+01_JPRB, 0.116993E+01_JPRB, 0.116244E+01_JPRB, 0.115454E+01_JPRB &
  &, 0.114622E+01_JPRB, 0.113748E+01_JPRB, 0.112834E+01_JPRB &
  &, 0.111881E+01_JPRB, 0.110890E+01_JPRB, 0.109863E+01_JPRB, 0.108799E+01_JPRB &
  &, 0.107700E+01_JPRB, 0.106567E+01_JPRB, 0.105402E+01_JPRB &
  &, 0.104206E+01_JPRB, 0.102980E+01_JPRB, 0.101725E+01_JPRB, 0.100442E+01_JPRB &
  &, 0.991339E+00_JPRB, 0.978011E+00_JPRB, 0.964452E+00_JPRB &
  &, 0.950675E+00_JPRB, 0.936677E+00_JPRB, 0.922508E+00_JPRB, 0.908146E+00_JPRB &
  &, 0.893626E+00_JPRB, 0.878962E+00_JPRB, 0.864151E+00_JPRB &
  &, 0.849228E+00_JPRB, 0.834188E+00_JPRB, 0.819066E+00_JPRB, 0.803857E+00_JPRB &
  &, 0.788598E+00_JPRB, 0.773257E+00_JPRB, 0.757895E+00_JPRB &
  &, 0.742526E+00_JPRB, 0.727116E+00_JPRB, 0.711727E+00_JPRB, 0.696319E+00_JPRB &
  &, 0.680984E+00_JPRB, 0.665653E+00_JPRB, 0.650390E+00_JPRB &
  &, 0.635179E+00_JPRB, 0.620027E+00_JPRB, 0.605002E+00_JPRB, 0.590023E+00_JPRB &
  &, 0.575187E+00_JPRB, 0.560439E+00_JPRB, 0.545845E+00_JPRB &
  &, 0.531348E+00_JPRB, 0.517046E+00_JPRB, 0.502846E+00_JPRB, 0.488847E+00_JPRB &
  &, 0.474983E+00_JPRB, 0.461321E+00_JPRB, 0.447826E+00_JPRB &
  &, 0.434530E+00_JPRB, 0.421392E+00_JPRB, 0.408518E+00_JPRB, 0.395792E+00_JPRB &
  &, 0.383318E+00_JPRB, 0.371050E+00_JPRB, 0.358980E+00_JPRB &
  &, 0.347175E+00_JPRB, 0.335585E+00_JPRB, 0.324196E+00_JPRB, 0.313076E+00_JPRB &
  &, 0.302169E+00_JPRB, 0.291500E+00_JPRB, 0.281095E+00_JPRB &
  &, 0.270937E+00_JPRB, 0.260959E+00_JPRB, 0.251276E+00_JPRB, 0.241819E+00_JPRB &
  &, 0.232611E+00_JPRB, 0.223627E+00_JPRB, 0.214888E+00_JPRB &
  &, 0.206415E+00_JPRB, 0.198130E+00_JPRB, 0.190153E+00_JPRB, 0.182351E+00_JPRB &
  &, 0.174793E+00_JPRB, 0.167445E+00_JPRB, 0.160379E+00_JPRB &
  &, 0.153504E+00_JPRB, 0.146835E+00_JPRB, 0.140389E+00_JPRB, 0.134182E+00_JPRB &
  &, 0.128171E+00_JPRB, 0.122371E+00_JPRB, 0.116797E+00_JPRB &
  &, 0.111402E+00_JPRB, 0.106200E+00_JPRB, 0.101203E+00_JPRB, 0.963609E-01_JPRB &
  &, 0.917483E-01_JPRB, 0.872491E-01_JPRB, 0.830032E-01_JPRB/)
XCW( 703, :) = (/ &
  &  0.105073E+01_JPRB, 0.106260E+01_JPRB, 0.107413E+01_JPRB, 0.108530E+01_JPRB &
  &, 0.109611E+01_JPRB, 0.110656E+01_JPRB, 0.111663E+01_JPRB &
  &, 0.112631E+01_JPRB, 0.113560E+01_JPRB, 0.114450E+01_JPRB, 0.115298E+01_JPRB &
  &, 0.116105E+01_JPRB, 0.116870E+01_JPRB, 0.117593E+01_JPRB &
  &, 0.118271E+01_JPRB, 0.118906E+01_JPRB, 0.119496E+01_JPRB, 0.120041E+01_JPRB &
  &, 0.120540E+01_JPRB, 0.120993E+01_JPRB, 0.121399E+01_JPRB &
  &, 0.121757E+01_JPRB, 0.122068E+01_JPRB, 0.122331E+01_JPRB, 0.122546E+01_JPRB &
  &, 0.122712E+01_JPRB, 0.122829E+01_JPRB, 0.122897E+01_JPRB &
  &, 0.122916E+01_JPRB, 0.122886E+01_JPRB, 0.122807E+01_JPRB, 0.122678E+01_JPRB &
  &, 0.122501E+01_JPRB, 0.122274E+01_JPRB, 0.121998E+01_JPRB &
  &, 0.121674E+01_JPRB, 0.121302E+01_JPRB, 0.120881E+01_JPRB, 0.120414E+01_JPRB &
  &, 0.119899E+01_JPRB, 0.119337E+01_JPRB, 0.118731E+01_JPRB &
  &, 0.118079E+01_JPRB, 0.117382E+01_JPRB, 0.116641E+01_JPRB, 0.115857E+01_JPRB &
  &, 0.115031E+01_JPRB, 0.114163E+01_JPRB, 0.113258E+01_JPRB &
  &, 0.112311E+01_JPRB, 0.111326E+01_JPRB, 0.110303E+01_JPRB, 0.109245E+01_JPRB &
  &, 0.108150E+01_JPRB, 0.107024E+01_JPRB, 0.105864E+01_JPRB &
  &, 0.104672E+01_JPRB, 0.103449E+01_JPRB, 0.102200E+01_JPRB, 0.100922E+01_JPRB &
  &, 0.996160E+00_JPRB, 0.982872E+00_JPRB, 0.969334E+00_JPRB &
  &, 0.955593E+00_JPRB, 0.941629E+00_JPRB, 0.927474E+00_JPRB, 0.913144E+00_JPRB &
  &, 0.898633E+00_JPRB, 0.883976E+00_JPRB, 0.869190E+00_JPRB &
  &, 0.854268E+00_JPRB, 0.839248E+00_JPRB, 0.824122E+00_JPRB, 0.808928E+00_JPRB &
  &, 0.793659E+00_JPRB, 0.778328E+00_JPRB, 0.762949E+00_JPRB &
  &, 0.747561E+00_JPRB, 0.732152E+00_JPRB, 0.716736E+00_JPRB, 0.701324E+00_JPRB &
  &, 0.685954E+00_JPRB, 0.670613E+00_JPRB, 0.655309E+00_JPRB &
  &, 0.640080E+00_JPRB, 0.624908E+00_JPRB, 0.609829E+00_JPRB, 0.594853E+00_JPRB &
  &, 0.579956E+00_JPRB, 0.565173E+00_JPRB, 0.550541E+00_JPRB &
  &, 0.536003E+00_JPRB, 0.521624E+00_JPRB, 0.507407E+00_JPRB, 0.493355E+00_JPRB &
  &, 0.479434E+00_JPRB, 0.465712E+00_JPRB, 0.452152E+00_JPRB &
  &, 0.438822E+00_JPRB, 0.425649E+00_JPRB, 0.412663E+00_JPRB, 0.399931E+00_JPRB &
  &, 0.387373E+00_JPRB, 0.375017E+00_JPRB, 0.362933E+00_JPRB &
  &, 0.351032E+00_JPRB, 0.339341E+00_JPRB, 0.327930E+00_JPRB, 0.316701E+00_JPRB &
  &, 0.305766E+00_JPRB, 0.295023E+00_JPRB, 0.284542E+00_JPRB &
  &, 0.274258E+00_JPRB, 0.264286E+00_JPRB, 0.254514E+00_JPRB, 0.244966E+00_JPRB &
  &, 0.235663E+00_JPRB, 0.226628E+00_JPRB, 0.217835E+00_JPRB &
  &, 0.209257E+00_JPRB, 0.200912E+00_JPRB, 0.192822E+00_JPRB, 0.185007E+00_JPRB &
  &, 0.177382E+00_JPRB, 0.169964E+00_JPRB, 0.162771E+00_JPRB &
  &, 0.155875E+00_JPRB, 0.149128E+00_JPRB, 0.142657E+00_JPRB, 0.136366E+00_JPRB &
  &, 0.130269E+00_JPRB, 0.124380E+00_JPRB, 0.118773E+00_JPRB &
  &, 0.113284E+00_JPRB, 0.108046E+00_JPRB, 0.102949E+00_JPRB, 0.980668E-01_JPRB &
  &, 0.933488E-01_JPRB, 0.888706E-01_JPRB, 0.845145E-01_JPRB/)
XCW( 704, :) = (/ &
  &  0.105103E+01_JPRB, 0.106298E+01_JPRB, 0.107458E+01_JPRB, 0.108583E+01_JPRB &
  &, 0.109673E+01_JPRB, 0.110725E+01_JPRB, 0.111740E+01_JPRB &
  &, 0.112717E+01_JPRB, 0.113655E+01_JPRB, 0.114553E+01_JPRB, 0.115410E+01_JPRB &
  &, 0.116226E+01_JPRB, 0.116999E+01_JPRB, 0.117730E+01_JPRB &
  &, 0.118418E+01_JPRB, 0.119061E+01_JPRB, 0.119660E+01_JPRB, 0.120214E+01_JPRB &
  &, 0.120722E+01_JPRB, 0.121183E+01_JPRB, 0.121598E+01_JPRB &
  &, 0.121965E+01_JPRB, 0.122286E+01_JPRB, 0.122557E+01_JPRB, 0.122781E+01_JPRB &
  &, 0.122956E+01_JPRB, 0.123082E+01_JPRB, 0.123159E+01_JPRB &
  &, 0.123187E+01_JPRB, 0.123165E+01_JPRB, 0.123094E+01_JPRB, 0.122974E+01_JPRB &
  &, 0.122805E+01_JPRB, 0.122587E+01_JPRB, 0.122319E+01_JPRB &
  &, 0.122003E+01_JPRB, 0.121639E+01_JPRB, 0.121226E+01_JPRB, 0.120767E+01_JPRB &
  &, 0.120260E+01_JPRB, 0.119706E+01_JPRB, 0.119107E+01_JPRB &
  &, 0.118462E+01_JPRB, 0.117773E+01_JPRB, 0.117039E+01_JPRB, 0.116263E+01_JPRB &
  &, 0.115443E+01_JPRB, 0.114582E+01_JPRB, 0.113682E+01_JPRB &
  &, 0.112741E+01_JPRB, 0.111762E+01_JPRB, 0.110745E+01_JPRB, 0.109692E+01_JPRB &
  &, 0.108604E+01_JPRB, 0.107483E+01_JPRB, 0.106327E+01_JPRB &
  &, 0.105140E+01_JPRB, 0.103924E+01_JPRB, 0.102677E+01_JPRB, 0.101401E+01_JPRB &
  &, 0.100102E+01_JPRB, 0.987750E+00_JPRB, 0.974250E+00_JPRB &
  &, 0.960529E+00_JPRB, 0.946600E+00_JPRB, 0.932460E+00_JPRB, 0.918161E+00_JPRB &
  &, 0.903680E+00_JPRB, 0.889031E+00_JPRB, 0.874249E+00_JPRB &
  &, 0.859351E+00_JPRB, 0.844329E+00_JPRB, 0.829222E+00_JPRB, 0.814022E+00_JPRB &
  &, 0.798742E+00_JPRB, 0.783422E+00_JPRB, 0.768051E+00_JPRB &
  &, 0.752644E+00_JPRB, 0.737213E+00_JPRB, 0.721796E+00_JPRB, 0.706380E+00_JPRB &
  &, 0.690978E+00_JPRB, 0.675599E+00_JPRB, 0.660282E+00_JPRB &
  &, 0.645037E+00_JPRB, 0.629845E+00_JPRB, 0.614715E+00_JPRB, 0.599682E+00_JPRB &
  &, 0.584784E+00_JPRB, 0.569968E+00_JPRB, 0.555269E+00_JPRB &
  &, 0.540689E+00_JPRB, 0.526297E+00_JPRB, 0.512000E+00_JPRB, 0.497896E+00_JPRB &
  &, 0.483919E+00_JPRB, 0.470171E+00_JPRB, 0.456548E+00_JPRB &
  &, 0.443151E+00_JPRB, 0.429906E+00_JPRB, 0.416881E+00_JPRB, 0.404069E+00_JPRB &
  &, 0.391466E+00_JPRB, 0.379061E+00_JPRB, 0.366886E+00_JPRB &
  &, 0.354929E+00_JPRB, 0.343179E+00_JPRB, 0.331664E+00_JPRB, 0.320410E+00_JPRB &
  &, 0.309363E+00_JPRB, 0.298590E+00_JPRB, 0.287988E+00_JPRB &
  &, 0.277668E+00_JPRB, 0.267612E+00_JPRB, 0.257753E+00_JPRB, 0.248160E+00_JPRB &
  &, 0.238810E+00_JPRB, 0.229677E+00_JPRB, 0.220783E+00_JPRB &
  &, 0.212149E+00_JPRB, 0.203746E+00_JPRB, 0.195594E+00_JPRB, 0.187663E+00_JPRB &
  &, 0.179971E+00_JPRB, 0.172484E+00_JPRB, 0.165272E+00_JPRB &
  &, 0.158245E+00_JPRB, 0.151476E+00_JPRB, 0.144868E+00_JPRB, 0.138551E+00_JPRB &
  &, 0.132367E+00_JPRB, 0.126448E+00_JPRB, 0.120750E+00_JPRB &
  &, 0.115227E+00_JPRB, 0.109892E+00_JPRB, 0.104757E+00_JPRB, 0.998359E-01_JPRB &
  &, 0.950773E-01_JPRB, 0.904922E-01_JPRB, 0.860916E-01_JPRB/)
XCW( 705, :) = (/ &
  &  0.105133E+01_JPRB, 0.106335E+01_JPRB, 0.107504E+01_JPRB, 0.108637E+01_JPRB &
  &, 0.109734E+01_JPRB, 0.110795E+01_JPRB, 0.111819E+01_JPRB &
  &, 0.112804E+01_JPRB, 0.113750E+01_JPRB, 0.114656E+01_JPRB, 0.115522E+01_JPRB &
  &, 0.116346E+01_JPRB, 0.117129E+01_JPRB, 0.117868E+01_JPRB &
  &, 0.118565E+01_JPRB, 0.119217E+01_JPRB, 0.119825E+01_JPRB, 0.120387E+01_JPRB &
  &, 0.120904E+01_JPRB, 0.121374E+01_JPRB, 0.121798E+01_JPRB &
  &, 0.122174E+01_JPRB, 0.122503E+01_JPRB, 0.122784E+01_JPRB, 0.123016E+01_JPRB &
  &, 0.123200E+01_JPRB, 0.123335E+01_JPRB, 0.123419E+01_JPRB &
  &, 0.123457E+01_JPRB, 0.123445E+01_JPRB, 0.123382E+01_JPRB, 0.123271E+01_JPRB &
  &, 0.123110E+01_JPRB, 0.122900E+01_JPRB, 0.122642E+01_JPRB &
  &, 0.122334E+01_JPRB, 0.121978E+01_JPRB, 0.121573E+01_JPRB, 0.121121E+01_JPRB &
  &, 0.120621E+01_JPRB, 0.120076E+01_JPRB, 0.119485E+01_JPRB &
  &, 0.118847E+01_JPRB, 0.118165E+01_JPRB, 0.117438E+01_JPRB, 0.116669E+01_JPRB &
  &, 0.115856E+01_JPRB, 0.115003E+01_JPRB, 0.114108E+01_JPRB &
  &, 0.113173E+01_JPRB, 0.112201E+01_JPRB, 0.111190E+01_JPRB, 0.110142E+01_JPRB &
  &, 0.109059E+01_JPRB, 0.107943E+01_JPRB, 0.106792E+01_JPRB &
  &, 0.105610E+01_JPRB, 0.104398E+01_JPRB, 0.103156E+01_JPRB, 0.101886E+01_JPRB &
  &, 0.100589E+01_JPRB, 0.992663E+00_JPRB, 0.979203E+00_JPRB &
  &, 0.965501E+00_JPRB, 0.951590E+00_JPRB, 0.937484E+00_JPRB, 0.923198E+00_JPRB &
  &, 0.908747E+00_JPRB, 0.894126E+00_JPRB, 0.879350E+00_JPRB &
  &, 0.864454E+00_JPRB, 0.849454E+00_JPRB, 0.834344E+00_JPRB, 0.819137E+00_JPRB &
  &, 0.803872E+00_JPRB, 0.788540E+00_JPRB, 0.773153E+00_JPRB &
  &, 0.757751E+00_JPRB, 0.742323E+00_JPRB, 0.726881E+00_JPRB, 0.711436E+00_JPRB &
  &, 0.696027E+00_JPRB, 0.680640E+00_JPRB, 0.665310E+00_JPRB &
  &, 0.650021E+00_JPRB, 0.634782E+00_JPRB, 0.619629E+00_JPRB, 0.604571E+00_JPRB &
  &, 0.589613E+00_JPRB, 0.574764E+00_JPRB, 0.560027E+00_JPRB &
  &, 0.545439E+00_JPRB, 0.530971E+00_JPRB, 0.516626E+00_JPRB, 0.502470E+00_JPRB &
  &, 0.488472E+00_JPRB, 0.474631E+00_JPRB, 0.460979E+00_JPRB &
  &, 0.447516E+00_JPRB, 0.434236E+00_JPRB, 0.421136E+00_JPRB, 0.408246E+00_JPRB &
  &, 0.395559E+00_JPRB, 0.383106E+00_JPRB, 0.370878E+00_JPRB &
  &, 0.358826E+00_JPRB, 0.347058E+00_JPRB, 0.335480E+00_JPRB, 0.324120E+00_JPRB &
  &, 0.313046E+00_JPRB, 0.302157E+00_JPRB, 0.291522E+00_JPRB &
  &, 0.281123E+00_JPRB, 0.270984E+00_JPRB, 0.261038E+00_JPRB, 0.251401E+00_JPRB &
  &, 0.241957E+00_JPRB, 0.232775E+00_JPRB, 0.223780E+00_JPRB &
  &, 0.215090E+00_JPRB, 0.206629E+00_JPRB, 0.198366E+00_JPRB, 0.190372E+00_JPRB &
  &, 0.182613E+00_JPRB, 0.175056E+00_JPRB, 0.167772E+00_JPRB &
  &, 0.160671E+00_JPRB, 0.153824E+00_JPRB, 0.147193E+00_JPRB, 0.140735E+00_JPRB &
  &, 0.134524E+00_JPRB, 0.128575E+00_JPRB, 0.122726E+00_JPRB &
  &, 0.117169E+00_JPRB, 0.111799E+00_JPRB, 0.106565E+00_JPRB, 0.101605E+00_JPRB &
  &, 0.967417E-01_JPRB, 0.921137E-01_JPRB, 0.876686E-01_JPRB/)
XCW( 706, :) = (/ &
  &  0.105163E+01_JPRB, 0.106373E+01_JPRB, 0.107550E+01_JPRB, 0.108691E+01_JPRB &
  &, 0.109796E+01_JPRB, 0.110865E+01_JPRB, 0.111897E+01_JPRB &
  &, 0.112890E+01_JPRB, 0.113845E+01_JPRB, 0.114759E+01_JPRB, 0.115634E+01_JPRB &
  &, 0.116467E+01_JPRB, 0.117258E+01_JPRB, 0.118006E+01_JPRB &
  &, 0.118712E+01_JPRB, 0.119373E+01_JPRB, 0.119989E+01_JPRB, 0.120561E+01_JPRB &
  &, 0.121086E+01_JPRB, 0.121566E+01_JPRB, 0.121998E+01_JPRB &
  &, 0.122384E+01_JPRB, 0.122721E+01_JPRB, 0.123006E+01_JPRB, 0.123253E+01_JPRB &
  &, 0.123445E+01_JPRB, 0.123589E+01_JPRB, 0.123683E+01_JPRB &
  &, 0.123729E+01_JPRB, 0.123725E+01_JPRB, 0.123671E+01_JPRB, 0.123568E+01_JPRB &
  &, 0.123416E+01_JPRB, 0.123215E+01_JPRB, 0.122964E+01_JPRB &
  &, 0.122665E+01_JPRB, 0.122317E+01_JPRB, 0.121921E+01_JPRB, 0.121477E+01_JPRB &
  &, 0.120986E+01_JPRB, 0.120448E+01_JPRB, 0.119864E+01_JPRB &
  &, 0.119234E+01_JPRB, 0.118558E+01_JPRB, 0.117840E+01_JPRB, 0.117077E+01_JPRB &
  &, 0.116272E+01_JPRB, 0.115424E+01_JPRB, 0.114536E+01_JPRB &
  &, 0.113608E+01_JPRB, 0.112641E+01_JPRB, 0.111637E+01_JPRB, 0.110594E+01_JPRB &
  &, 0.109517E+01_JPRB, 0.108406E+01_JPRB, 0.107260E+01_JPRB &
  &, 0.106082E+01_JPRB, 0.104875E+01_JPRB, 0.103637E+01_JPRB, 0.102371E+01_JPRB &
  &, 0.101078E+01_JPRB, 0.997593E+00_JPRB, 0.984155E+00_JPRB &
  &, 0.970492E+00_JPRB, 0.956617E+00_JPRB, 0.942546E+00_JPRB, 0.928273E+00_JPRB &
  &, 0.913833E+00_JPRB, 0.899221E+00_JPRB, 0.884471E+00_JPRB &
  &, 0.869600E+00_JPRB, 0.854600E+00_JPRB, 0.839488E+00_JPRB, 0.824298E+00_JPRB &
  &, 0.809024E+00_JPRB, 0.793704E+00_JPRB, 0.778303E+00_JPRB &
  &, 0.762883E+00_JPRB, 0.747458E+00_JPRB, 0.731991E+00_JPRB, 0.716544E+00_JPRB &
  &, 0.701104E+00_JPRB, 0.685707E+00_JPRB, 0.670338E+00_JPRB &
  &, 0.655034E+00_JPRB, 0.639776E+00_JPRB, 0.624601E+00_JPRB, 0.609459E+00_JPRB &
  &, 0.594502E+00_JPRB, 0.579620E+00_JPRB, 0.564848E+00_JPRB &
  &, 0.550189E+00_JPRB, 0.535678E+00_JPRB, 0.521318E+00_JPRB, 0.507112E+00_JPRB &
  &, 0.493025E+00_JPRB, 0.479160E+00_JPRB, 0.465446E+00_JPRB &
  &, 0.451916E+00_JPRB, 0.438566E+00_JPRB, 0.425428E+00_JPRB, 0.412498E+00_JPRB &
  &, 0.399729E+00_JPRB, 0.387228E+00_JPRB, 0.374911E+00_JPRB &
  &, 0.362804E+00_JPRB, 0.350937E+00_JPRB, 0.339297E+00_JPRB, 0.327913E+00_JPRB &
  &, 0.316729E+00_JPRB, 0.305768E+00_JPRB, 0.295057E+00_JPRB &
  &, 0.284623E+00_JPRB, 0.274355E+00_JPRB, 0.264369E+00_JPRB, 0.254642E+00_JPRB &
  &, 0.245152E+00_JPRB, 0.235873E+00_JPRB, 0.226825E+00_JPRB &
  &, 0.218081E+00_JPRB, 0.209513E+00_JPRB, 0.201190E+00_JPRB, 0.193132E+00_JPRB &
  &, 0.185308E+00_JPRB, 0.177682E+00_JPRB, 0.170273E+00_JPRB &
  &, 0.163152E+00_JPRB, 0.156228E+00_JPRB, 0.149517E+00_JPRB, 0.143034E+00_JPRB &
  &, 0.136738E+00_JPRB, 0.130643E+00_JPRB, 0.124822E+00_JPRB &
  &, 0.119173E+00_JPRB, 0.113706E+00_JPRB, 0.108436E+00_JPRB, 0.103374E+00_JPRB &
  &, 0.984702E-01_JPRB, 0.938001E-01_JPRB, 0.893114E-01_JPRB/)
XCW( 707, :) = (/ &
  &  0.105193E+01_JPRB, 0.106411E+01_JPRB, 0.107595E+01_JPRB, 0.108745E+01_JPRB &
  &, 0.109858E+01_JPRB, 0.110935E+01_JPRB, 0.111975E+01_JPRB &
  &, 0.112977E+01_JPRB, 0.113940E+01_JPRB, 0.114864E+01_JPRB, 0.115746E+01_JPRB &
  &, 0.116588E+01_JPRB, 0.117388E+01_JPRB, 0.118145E+01_JPRB &
  &, 0.118854E+01_JPRB, 0.119529E+01_JPRB, 0.120154E+01_JPRB, 0.120735E+01_JPRB &
  &, 0.121269E+01_JPRB, 0.121758E+01_JPRB, 0.122199E+01_JPRB &
  &, 0.122594E+01_JPRB, 0.122940E+01_JPRB, 0.123239E+01_JPRB, 0.123489E+01_JPRB &
  &, 0.123691E+01_JPRB, 0.123844E+01_JPRB, 0.123947E+01_JPRB &
  &, 0.124001E+01_JPRB, 0.124006E+01_JPRB, 0.123961E+01_JPRB, 0.123867E+01_JPRB &
  &, 0.123724E+01_JPRB, 0.123531E+01_JPRB, 0.123288E+01_JPRB &
  &, 0.122998E+01_JPRB, 0.122658E+01_JPRB, 0.122270E+01_JPRB, 0.121834E+01_JPRB &
  &, 0.121351E+01_JPRB, 0.120820E+01_JPRB, 0.120244E+01_JPRB &
  &, 0.119621E+01_JPRB, 0.118953E+01_JPRB, 0.118242E+01_JPRB, 0.117486E+01_JPRB &
  &, 0.116687E+01_JPRB, 0.115847E+01_JPRB, 0.114966E+01_JPRB &
  &, 0.114044E+01_JPRB, 0.113083E+01_JPRB, 0.112085E+01_JPRB, 0.111049E+01_JPRB &
  &, 0.109977E+01_JPRB, 0.108871E+01_JPRB, 0.107730E+01_JPRB &
  &, 0.106558E+01_JPRB, 0.105354E+01_JPRB, 0.104121E+01_JPRB, 0.102859E+01_JPRB &
  &, 0.101570E+01_JPRB, 0.100254E+01_JPRB, 0.989143E+00_JPRB &
  &, 0.975518E+00_JPRB, 0.961662E+00_JPRB, 0.947607E+00_JPRB, 0.933368E+00_JPRB &
  &, 0.918959E+00_JPRB, 0.904356E+00_JPRB, 0.889633E+00_JPRB &
  &, 0.874766E+00_JPRB, 0.859768E+00_JPRB, 0.844675E+00_JPRB, 0.829481E+00_JPRB &
  &, 0.814223E+00_JPRB, 0.798892E+00_JPRB, 0.783501E+00_JPRB &
  &, 0.768064E+00_JPRB, 0.752618E+00_JPRB, 0.737152E+00_JPRB, 0.721678E+00_JPRB &
  &, 0.706232E+00_JPRB, 0.690801E+00_JPRB, 0.675420E+00_JPRB &
  &, 0.660074E+00_JPRB, 0.644799E+00_JPRB, 0.629574E+00_JPRB, 0.614465E+00_JPRB &
  &, 0.599421E+00_JPRB, 0.584507E+00_JPRB, 0.569700E+00_JPRB &
  &, 0.555002E+00_JPRB, 0.540448E+00_JPRB, 0.526010E+00_JPRB, 0.511753E+00_JPRB &
  &, 0.497646E+00_JPRB, 0.483723E+00_JPRB, 0.469948E+00_JPRB &
  &, 0.456352E+00_JPRB, 0.442969E+00_JPRB, 0.429758E+00_JPRB, 0.416749E+00_JPRB &
  &, 0.403937E+00_JPRB, 0.391350E+00_JPRB, 0.378982E+00_JPRB &
  &, 0.366821E+00_JPRB, 0.354897E+00_JPRB, 0.343197E+00_JPRB, 0.331707E+00_JPRB &
  &, 0.320454E+00_JPRB, 0.309422E+00_JPRB, 0.298680E+00_JPRB &
  &, 0.288123E+00_JPRB, 0.277818E+00_JPRB, 0.267746E+00_JPRB, 0.257930E+00_JPRB &
  &, 0.248347E+00_JPRB, 0.239019E+00_JPRB, 0.229920E+00_JPRB &
  &, 0.221073E+00_JPRB, 0.212448E+00_JPRB, 0.204065E+00_JPRB, 0.195892E+00_JPRB &
  &, 0.188002E+00_JPRB, 0.180309E+00_JPRB, 0.172882E+00_JPRB &
  &, 0.165633E+00_JPRB, 0.158633E+00_JPRB, 0.151842E+00_JPRB, 0.145276E+00_JPRB &
  &, 0.138953E+00_JPRB, 0.132829E+00_JPRB, 0.126918E+00_JPRB &
  &, 0.121176E+00_JPRB, 0.115675E+00_JPRB, 0.110306E+00_JPRB, 0.105206E+00_JPRB &
  &, 0.100263E+00_JPRB, 0.954865E-01_JPRB, 0.909542E-01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART101',1,ZHOOK_HANDLE)
END SUBROUTINE PART101

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART102

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART102',0,ZHOOK_HANDLE)

XCW( 708, :) = (/ &
  &  0.105223E+01_JPRB, 0.106449E+01_JPRB, 0.107641E+01_JPRB, 0.108798E+01_JPRB &
  &, 0.109920E+01_JPRB, 0.111006E+01_JPRB, 0.112054E+01_JPRB &
  &, 0.113064E+01_JPRB, 0.114036E+01_JPRB, 0.114968E+01_JPRB, 0.115859E+01_JPRB &
  &, 0.116709E+01_JPRB, 0.117518E+01_JPRB, 0.118284E+01_JPRB &
  &, 0.119007E+01_JPRB, 0.119686E+01_JPRB, 0.120320E+01_JPRB, 0.120909E+01_JPRB &
  &, 0.121453E+01_JPRB, 0.121950E+01_JPRB, 0.122401E+01_JPRB &
  &, 0.122804E+01_JPRB, 0.123160E+01_JPRB, 0.123467E+01_JPRB, 0.123727E+01_JPRB &
  &, 0.123937E+01_JPRB, 0.124099E+01_JPRB, 0.124211E+01_JPRB &
  &, 0.124274E+01_JPRB, 0.124288E+01_JPRB, 0.124252E+01_JPRB, 0.124167E+01_JPRB &
  &, 0.124032E+01_JPRB, 0.123847E+01_JPRB, 0.123614E+01_JPRB &
  &, 0.123331E+01_JPRB, 0.123000E+01_JPRB, 0.122620E+01_JPRB, 0.122192E+01_JPRB &
  &, 0.121716E+01_JPRB, 0.121194E+01_JPRB, 0.120626E+01_JPRB &
  &, 0.120010E+01_JPRB, 0.119350E+01_JPRB, 0.118646E+01_JPRB, 0.117897E+01_JPRB &
  &, 0.117106E+01_JPRB, 0.116272E+01_JPRB, 0.115397E+01_JPRB &
  &, 0.114482E+01_JPRB, 0.113527E+01_JPRB, 0.112534E+01_JPRB, 0.111505E+01_JPRB &
  &, 0.110438E+01_JPRB, 0.109337E+01_JPRB, 0.108202E+01_JPRB &
  &, 0.107035E+01_JPRB, 0.105836E+01_JPRB, 0.104608E+01_JPRB, 0.103350E+01_JPRB &
  &, 0.102064E+01_JPRB, 0.100752E+01_JPRB, 0.994166E+00_JPRB &
  &, 0.980563E+00_JPRB, 0.966744E+00_JPRB, 0.952726E+00_JPRB, 0.938501E+00_JPRB &
  &, 0.924105E+00_JPRB, 0.909532E+00_JPRB, 0.894817E+00_JPRB &
  &, 0.879954E+00_JPRB, 0.864979E+00_JPRB, 0.849885E+00_JPRB, 0.834710E+00_JPRB &
  &, 0.819444E+00_JPRB, 0.804103E+00_JPRB, 0.788698E+00_JPRB &
  &, 0.773269E+00_JPRB, 0.757803E+00_JPRB, 0.742339E+00_JPRB, 0.726863E+00_JPRB &
  &, 0.711387E+00_JPRB, 0.695948E+00_JPRB, 0.680530E+00_JPRB &
  &, 0.665170E+00_JPRB, 0.649849E+00_JPRB, 0.634604E+00_JPRB, 0.619471E+00_JPRB &
  &, 0.604400E+00_JPRB, 0.589425E+00_JPRB, 0.574583E+00_JPRB &
  &, 0.559846E+00_JPRB, 0.545251E+00_JPRB, 0.530767E+00_JPRB, 0.516461E+00_JPRB &
  &, 0.502301E+00_JPRB, 0.488321E+00_JPRB, 0.474485E+00_JPRB &
  &, 0.460860E+00_JPRB, 0.447408E+00_JPRB, 0.434124E+00_JPRB, 0.421076E+00_JPRB &
  &, 0.408183E+00_JPRB, 0.395550E+00_JPRB, 0.383093E+00_JPRB &
  &, 0.370879E+00_JPRB, 0.358858E+00_JPRB, 0.347097E+00_JPRB, 0.335543E+00_JPRB &
  &, 0.324223E+00_JPRB, 0.313163E+00_JPRB, 0.302303E+00_JPRB &
  &, 0.291667E+00_JPRB, 0.281327E+00_JPRB, 0.271170E+00_JPRB, 0.261265E+00_JPRB &
  &, 0.251637E+00_JPRB, 0.242213E+00_JPRB, 0.233064E+00_JPRB &
  &, 0.224114E+00_JPRB, 0.215433E+00_JPRB, 0.206939E+00_JPRB, 0.198757E+00_JPRB &
  &, 0.190750E+00_JPRB, 0.182988E+00_JPRB, 0.175274E+00_JPRB &
  &, 0.168170E+00_JPRB, 0.161093E+00_JPRB, 0.154223E+00_JPRB, 0.147633E+00_JPRB &
  &, 0.141226E+00_JPRB, 0.135015E+00_JPRB, 0.129015E+00_JPRB &
  &, 0.123240E+00_JPRB, 0.117644E+00_JPRB, 0.112239E+00_JPRB, 0.107038E+00_JPRB &
  &, 0.102055E+00_JPRB, 0.972378E-01_JPRB, 0.925970E-01_JPRB/)
XCW( 709, :) = (/ &
  &  0.105254E+01_JPRB, 0.106487E+01_JPRB, 0.107687E+01_JPRB, 0.108852E+01_JPRB &
  &, 0.109983E+01_JPRB, 0.111076E+01_JPRB, 0.112133E+01_JPRB &
  &, 0.113152E+01_JPRB, 0.114131E+01_JPRB, 0.115072E+01_JPRB, 0.115972E+01_JPRB &
  &, 0.116831E+01_JPRB, 0.117648E+01_JPRB, 0.118423E+01_JPRB &
  &, 0.119155E+01_JPRB, 0.119843E+01_JPRB, 0.120486E+01_JPRB, 0.121084E+01_JPRB &
  &, 0.121637E+01_JPRB, 0.122143E+01_JPRB, 0.122603E+01_JPRB &
  &, 0.123015E+01_JPRB, 0.123380E+01_JPRB, 0.123697E+01_JPRB, 0.123965E+01_JPRB &
  &, 0.124184E+01_JPRB, 0.124355E+01_JPRB, 0.124476E+01_JPRB &
  &, 0.124549E+01_JPRB, 0.124571E+01_JPRB, 0.124544E+01_JPRB, 0.124467E+01_JPRB &
  &, 0.124341E+01_JPRB, 0.124165E+01_JPRB, 0.123940E+01_JPRB &
  &, 0.123665E+01_JPRB, 0.123342E+01_JPRB, 0.122971E+01_JPRB, 0.122552E+01_JPRB &
  &, 0.122084E+01_JPRB, 0.121569E+01_JPRB, 0.121008E+01_JPRB &
  &, 0.120401E+01_JPRB, 0.119749E+01_JPRB, 0.119051E+01_JPRB, 0.118310E+01_JPRB &
  &, 0.117525E+01_JPRB, 0.116698E+01_JPRB, 0.115831E+01_JPRB &
  &, 0.114922E+01_JPRB, 0.113973E+01_JPRB, 0.112986E+01_JPRB, 0.111962E+01_JPRB &
  &, 0.110902E+01_JPRB, 0.109805E+01_JPRB, 0.108676E+01_JPRB &
  &, 0.107514E+01_JPRB, 0.106320E+01_JPRB, 0.105096E+01_JPRB, 0.103841E+01_JPRB &
  &, 0.102561E+01_JPRB, 0.101252E+01_JPRB, 0.999207E+00_JPRB &
  &, 0.985644E+00_JPRB, 0.971845E+00_JPRB, 0.957844E+00_JPRB, 0.943654E+00_JPRB &
  &, 0.929270E+00_JPRB, 0.914728E+00_JPRB, 0.900020E+00_JPRB &
  &, 0.885184E+00_JPRB, 0.870211E+00_JPRB, 0.855139E+00_JPRB, 0.839960E+00_JPRB &
  &, 0.824688E+00_JPRB, 0.809360E+00_JPRB, 0.793967E+00_JPRB &
  &, 0.778522E+00_JPRB, 0.763037E+00_JPRB, 0.747550E+00_JPRB, 0.732074E+00_JPRB &
  &, 0.716542E+00_JPRB, 0.701122E+00_JPRB, 0.685668E+00_JPRB &
  &, 0.670294E+00_JPRB, 0.654957E+00_JPRB, 0.639692E+00_JPRB, 0.624507E+00_JPRB &
  &, 0.609379E+00_JPRB, 0.594282E+00_JPRB, 0.579497E+00_JPRB &
  &, 0.564723E+00_JPRB, 0.550086E+00_JPRB, 0.535557E+00_JPRB, 0.521203E+00_JPRB &
  &, 0.506990E+00_JPRB, 0.492953E+00_JPRB, 0.479021E+00_JPRB &
  &, 0.465367E+00_JPRB, 0.451847E+00_JPRB, 0.438527E+00_JPRB, 0.425403E+00_JPRB &
  &, 0.412467E+00_JPRB, 0.399750E+00_JPRB, 0.387244E+00_JPRB &
  &, 0.374977E+00_JPRB, 0.362900E+00_JPRB, 0.351038E+00_JPRB, 0.339421E+00_JPRB &
  &, 0.328034E+00_JPRB, 0.316904E+00_JPRB, 0.305970E+00_JPRB &
  &, 0.295302E+00_JPRB, 0.284835E+00_JPRB, 0.274640E+00_JPRB, 0.264647E+00_JPRB &
  &, 0.254927E+00_JPRB, 0.245456E+00_JPRB, 0.236208E+00_JPRB &
  &, 0.227205E+00_JPRB, 0.218417E+00_JPRB, 0.209865E+00_JPRB, 0.201569E+00_JPRB &
  &, 0.193550E+00_JPRB, 0.185722E+00_JPRB, 0.178101E+00_JPRB &
  &, 0.170761E+00_JPRB, 0.163609E+00_JPRB, 0.156661E+00_JPRB, 0.149990E+00_JPRB &
  &, 0.143499E+00_JPRB, 0.137201E+00_JPRB, 0.131171E+00_JPRB &
  &, 0.125304E+00_JPRB, 0.119674E+00_JPRB, 0.114172E+00_JPRB, 0.108934E+00_JPRB &
  &, 0.103848E+00_JPRB, 0.989891E-01_JPRB, 0.943055E-01_JPRB/)
XCW( 710, :) = (/ &
  &  0.105284E+01_JPRB, 0.106525E+01_JPRB, 0.107733E+01_JPRB, 0.108907E+01_JPRB &
  &, 0.110045E+01_JPRB, 0.111147E+01_JPRB, 0.112212E+01_JPRB &
  &, 0.113239E+01_JPRB, 0.114227E+01_JPRB, 0.115176E+01_JPRB, 0.116085E+01_JPRB &
  &, 0.116953E+01_JPRB, 0.117779E+01_JPRB, 0.118563E+01_JPRB &
  &, 0.119303E+01_JPRB, 0.120000E+01_JPRB, 0.120652E+01_JPRB, 0.121260E+01_JPRB &
  &, 0.121821E+01_JPRB, 0.122336E+01_JPRB, 0.122805E+01_JPRB &
  &, 0.123227E+01_JPRB, 0.123601E+01_JPRB, 0.123926E+01_JPRB, 0.124204E+01_JPRB &
  &, 0.124432E+01_JPRB, 0.124612E+01_JPRB, 0.124742E+01_JPRB &
  &, 0.124823E+01_JPRB, 0.124855E+01_JPRB, 0.124836E+01_JPRB, 0.124769E+01_JPRB &
  &, 0.124651E+01_JPRB, 0.124484E+01_JPRB, 0.124267E+01_JPRB &
  &, 0.124001E+01_JPRB, 0.123687E+01_JPRB, 0.123324E+01_JPRB, 0.122913E+01_JPRB &
  &, 0.122454E+01_JPRB, 0.121947E+01_JPRB, 0.121393E+01_JPRB &
  &, 0.120793E+01_JPRB, 0.120148E+01_JPRB, 0.119458E+01_JPRB, 0.118724E+01_JPRB &
  &, 0.117947E+01_JPRB, 0.117126E+01_JPRB, 0.116265E+01_JPRB &
  &, 0.115362E+01_JPRB, 0.114420E+01_JPRB, 0.113440E+01_JPRB, 0.112422E+01_JPRB &
  &, 0.111367E+01_JPRB, 0.110277E+01_JPRB, 0.109153E+01_JPRB &
  &, 0.107995E+01_JPRB, 0.106807E+01_JPRB, 0.105586E+01_JPRB, 0.104337E+01_JPRB &
  &, 0.103060E+01_JPRB, 0.101756E+01_JPRB, 0.100427E+01_JPRB &
  &, 0.990743E+00_JPRB, 0.976984E+00_JPRB, 0.963000E+00_JPRB, 0.948826E+00_JPRB &
  &, 0.934476E+00_JPRB, 0.919944E+00_JPRB, 0.905266E+00_JPRB &
  &, 0.890435E+00_JPRB, 0.875486E+00_JPRB, 0.860415E+00_JPRB, 0.845233E+00_JPRB &
  &, 0.829978E+00_JPRB, 0.814642E+00_JPRB, 0.799236E+00_JPRB &
  &, 0.783800E+00_JPRB, 0.768321E+00_JPRB, 0.752812E+00_JPRB, 0.737311E+00_JPRB &
  &, 0.721802E+00_JPRB, 0.706324E+00_JPRB, 0.690859E+00_JPRB &
  &, 0.675446E+00_JPRB, 0.660093E+00_JPRB, 0.644779E+00_JPRB, 0.629572E+00_JPRB &
  &, 0.614418E+00_JPRB, 0.599383E+00_JPRB, 0.584442E+00_JPRB &
  &, 0.569631E+00_JPRB, 0.554954E+00_JPRB, 0.540380E+00_JPRB, 0.525977E+00_JPRB &
  &, 0.511713E+00_JPRB, 0.497620E+00_JPRB, 0.483699E+00_JPRB &
  &, 0.469946E+00_JPRB, 0.456359E+00_JPRB, 0.443005E+00_JPRB, 0.429805E+00_JPRB &
  &, 0.416828E+00_JPRB, 0.404028E+00_JPRB, 0.391474E+00_JPRB &
  &, 0.379115E+00_JPRB, 0.366983E+00_JPRB, 0.355063E+00_JPRB, 0.343341E+00_JPRB &
  &, 0.331888E+00_JPRB, 0.320688E+00_JPRB, 0.309681E+00_JPRB &
  &, 0.298936E+00_JPRB, 0.288389E+00_JPRB, 0.278110E+00_JPRB, 0.268076E+00_JPRB &
  &, 0.258265E+00_JPRB, 0.248699E+00_JPRB, 0.239402E+00_JPRB &
  &, 0.230296E+00_JPRB, 0.221453E+00_JPRB, 0.212843E+00_JPRB, 0.204486E+00_JPRB &
  &, 0.196351E+00_JPRB, 0.188455E+00_JPRB, 0.180765E+00_JPRB &
  &, 0.173352E+00_JPRB, 0.166125E+00_JPRB, 0.159155E+00_JPRB, 0.152347E+00_JPRB &
  &, 0.145830E+00_JPRB, 0.139446E+00_JPRB, 0.133327E+00_JPRB &
  &, 0.127428E+00_JPRB, 0.121704E+00_JPRB, 0.116167E+00_JPRB, 0.110829E+00_JPRB &
  &, 0.105704E+00_JPRB, 0.100805E+00_JPRB, 0.960140E-01_JPRB/)
XCW( 711, :) = (/ &
  &  0.105314E+01_JPRB, 0.106563E+01_JPRB, 0.107779E+01_JPRB, 0.108961E+01_JPRB &
  &, 0.110107E+01_JPRB, 0.111217E+01_JPRB, 0.112291E+01_JPRB &
  &, 0.113326E+01_JPRB, 0.114324E+01_JPRB, 0.115281E+01_JPRB, 0.116199E+01_JPRB &
  &, 0.117075E+01_JPRB, 0.117910E+01_JPRB, 0.118703E+01_JPRB &
  &, 0.119452E+01_JPRB, 0.120158E+01_JPRB, 0.120819E+01_JPRB, 0.121436E+01_JPRB &
  &, 0.122006E+01_JPRB, 0.122531E+01_JPRB, 0.123008E+01_JPRB &
  &, 0.123439E+01_JPRB, 0.123822E+01_JPRB, 0.124157E+01_JPRB, 0.124443E+01_JPRB &
  &, 0.124681E+01_JPRB, 0.124870E+01_JPRB, 0.125009E+01_JPRB &
  &, 0.125099E+01_JPRB, 0.125139E+01_JPRB, 0.125130E+01_JPRB, 0.125071E+01_JPRB &
  &, 0.124962E+01_JPRB, 0.124804E+01_JPRB, 0.124596E+01_JPRB &
  &, 0.124339E+01_JPRB, 0.124032E+01_JPRB, 0.123678E+01_JPRB, 0.123274E+01_JPRB &
  &, 0.122824E+01_JPRB, 0.122325E+01_JPRB, 0.121779E+01_JPRB &
  &, 0.121187E+01_JPRB, 0.120549E+01_JPRB, 0.119849E+01_JPRB, 0.119140E+01_JPRB &
  &, 0.118370E+01_JPRB, 0.117557E+01_JPRB, 0.116702E+01_JPRB &
  &, 0.115806E+01_JPRB, 0.114871E+01_JPRB, 0.113896E+01_JPRB, 0.112884E+01_JPRB &
  &, 0.111835E+01_JPRB, 0.110751E+01_JPRB, 0.109632E+01_JPRB &
  &, 0.108478E+01_JPRB, 0.107295E+01_JPRB, 0.106079E+01_JPRB, 0.104834E+01_JPRB &
  &, 0.103561E+01_JPRB, 0.102261E+01_JPRB, 0.100936E+01_JPRB &
  &, 0.995860E+00_JPRB, 0.982140E+00_JPRB, 0.968195E+00_JPRB, 0.954037E+00_JPRB &
  &, 0.939721E+00_JPRB, 0.925201E+00_JPRB, 0.910531E+00_JPRB &
  &, 0.895728E+00_JPRB, 0.880783E+00_JPRB, 0.865712E+00_JPRB, 0.850551E+00_JPRB &
  &, 0.835291E+00_JPRB, 0.819946E+00_JPRB, 0.804553E+00_JPRB &
  &, 0.789102E+00_JPRB, 0.773630E+00_JPRB, 0.758100E+00_JPRB, 0.742599E+00_JPRB &
  &, 0.727062E+00_JPRB, 0.711578E+00_JPRB, 0.696079E+00_JPRB &
  &, 0.680653E+00_JPRB, 0.665257E+00_JPRB, 0.649925E+00_JPRB, 0.634666E+00_JPRB &
  &, 0.619516E+00_JPRB, 0.604422E+00_JPRB, 0.589449E+00_JPRB &
  &, 0.574602E+00_JPRB, 0.559853E+00_JPRB, 0.545269E+00_JPRB, 0.530819E+00_JPRB &
  &, 0.516504E+00_JPRB, 0.502357E+00_JPRB, 0.488377E+00_JPRB &
  &, 0.474561E+00_JPRB, 0.460907E+00_JPRB, 0.447482E+00_JPRB, 0.434245E+00_JPRB &
  &, 0.421189E+00_JPRB, 0.408345E+00_JPRB, 0.395703E+00_JPRB &
  &, 0.383294E+00_JPRB, 0.371065E+00_JPRB, 0.359087E+00_JPRB, 0.347346E+00_JPRB &
  &, 0.335785E+00_JPRB, 0.324516E+00_JPRB, 0.313437E+00_JPRB &
  &, 0.302616E+00_JPRB, 0.291989E+00_JPRB, 0.281672E+00_JPRB, 0.271552E+00_JPRB &
  &, 0.261651E+00_JPRB, 0.252039E+00_JPRB, 0.242644E+00_JPRB &
  &, 0.233487E+00_JPRB, 0.224539E+00_JPRB, 0.215872E+00_JPRB, 0.207403E+00_JPRB &
  &, 0.199204E+00_JPRB, 0.191242E+00_JPRB, 0.183483E+00_JPRB &
  &, 0.175999E+00_JPRB, 0.168697E+00_JPRB, 0.161650E+00_JPRB, 0.154761E+00_JPRB &
  &, 0.148161E+00_JPRB, 0.141750E+00_JPRB, 0.135543E+00_JPRB &
  &, 0.129553E+00_JPRB, 0.123796E+00_JPRB, 0.118162E+00_JPRB, 0.112788E+00_JPRB &
  &, 0.107625E+00_JPRB, 0.102621E+00_JPRB, 0.977882E-01_JPRB/)
XCW( 712, :) = (/ &
  &  0.105344E+01_JPRB, 0.106602E+01_JPRB, 0.107826E+01_JPRB, 0.109015E+01_JPRB &
  &, 0.110170E+01_JPRB, 0.111288E+01_JPRB, 0.112370E+01_JPRB &
  &, 0.113414E+01_JPRB, 0.114420E+01_JPRB, 0.115386E+01_JPRB, 0.116312E+01_JPRB &
  &, 0.117198E+01_JPRB, 0.118041E+01_JPRB, 0.118843E+01_JPRB &
  &, 0.119601E+01_JPRB, 0.120316E+01_JPRB, 0.120986E+01_JPRB, 0.121612E+01_JPRB &
  &, 0.122192E+01_JPRB, 0.122725E+01_JPRB, 0.123212E+01_JPRB &
  &, 0.123652E+01_JPRB, 0.124044E+01_JPRB, 0.124388E+01_JPRB, 0.124684E+01_JPRB &
  &, 0.124930E+01_JPRB, 0.125128E+01_JPRB, 0.125277E+01_JPRB &
  &, 0.125376E+01_JPRB, 0.125425E+01_JPRB, 0.125424E+01_JPRB, 0.125374E+01_JPRB &
  &, 0.125274E+01_JPRB, 0.125124E+01_JPRB, 0.124925E+01_JPRB &
  &, 0.124677E+01_JPRB, 0.124379E+01_JPRB, 0.124033E+01_JPRB, 0.123637E+01_JPRB &
  &, 0.123195E+01_JPRB, 0.122704E+01_JPRB, 0.122166E+01_JPRB &
  &, 0.121583E+01_JPRB, 0.120952E+01_JPRB, 0.120277E+01_JPRB, 0.119557E+01_JPRB &
  &, 0.118795E+01_JPRB, 0.117989E+01_JPRB, 0.117140E+01_JPRB &
  &, 0.116252E+01_JPRB, 0.115322E+01_JPRB, 0.114354E+01_JPRB, 0.113348E+01_JPRB &
  &, 0.112305E+01_JPRB, 0.111226E+01_JPRB, 0.110112E+01_JPRB &
  &, 0.108965E+01_JPRB, 0.107785E+01_JPRB, 0.106574E+01_JPRB, 0.105335E+01_JPRB &
  &, 0.104065E+01_JPRB, 0.102770E+01_JPRB, 0.101447E+01_JPRB &
  &, 0.100101E+01_JPRB, 0.987315E+00_JPRB, 0.973408E+00_JPRB, 0.959287E+00_JPRB &
  &, 0.944965E+00_JPRB, 0.930478E+00_JPRB, 0.915838E+00_JPRB &
  &, 0.901042E+00_JPRB, 0.886102E+00_JPRB, 0.871054E+00_JPRB, 0.855891E+00_JPRB &
  &, 0.840650E+00_JPRB, 0.825297E+00_JPRB, 0.809894E+00_JPRB &
  &, 0.794453E+00_JPRB, 0.778964E+00_JPRB, 0.763438E+00_JPRB, 0.747913E+00_JPRB &
  &, 0.732375E+00_JPRB, 0.716833E+00_JPRB, 0.701352E+00_JPRB &
  &, 0.685889E+00_JPRB, 0.670478E+00_JPRB, 0.655100E+00_JPRB, 0.639819E+00_JPRB &
  &, 0.624615E+00_JPRB, 0.609493E+00_JPRB, 0.594488E+00_JPRB &
  &, 0.579605E+00_JPRB, 0.564817E+00_JPRB, 0.550190E+00_JPRB, 0.535661E+00_JPRB &
  &, 0.521295E+00_JPRB, 0.507093E+00_JPRB, 0.493089E+00_JPRB &
  &, 0.479212E+00_JPRB, 0.465528E+00_JPRB, 0.452033E+00_JPRB, 0.438722E+00_JPRB &
  &, 0.425589E+00_JPRB, 0.412700E+00_JPRB, 0.399972E+00_JPRB &
  &, 0.387472E+00_JPRB, 0.375230E+00_JPRB, 0.363153E+00_JPRB, 0.351350E+00_JPRB &
  &, 0.339724E+00_JPRB, 0.328387E+00_JPRB, 0.317236E+00_JPRB &
  &, 0.306340E+00_JPRB, 0.295680E+00_JPRB, 0.285234E+00_JPRB, 0.275028E+00_JPRB &
  &, 0.265084E+00_JPRB, 0.255379E+00_JPRB, 0.245886E+00_JPRB &
  &, 0.236678E+00_JPRB, 0.227676E+00_JPRB, 0.218900E+00_JPRB, 0.210423E+00_JPRB &
  &, 0.202110E+00_JPRB, 0.194083E+00_JPRB, 0.186256E+00_JPRB &
  &, 0.178645E+00_JPRB, 0.171269E+00_JPRB, 0.164145E+00_JPRB, 0.157233E+00_JPRB &
  &, 0.150551E+00_JPRB, 0.144055E+00_JPRB, 0.137819E+00_JPRB &
  &, 0.131738E+00_JPRB, 0.125888E+00_JPRB, 0.120220E+00_JPRB, 0.114810E+00_JPRB &
  &, 0.109545E+00_JPRB, 0.104437E+00_JPRB, 0.995624E-01_JPRB/)
XCW( 713, :) = (/ &
  &  0.105375E+01_JPRB, 0.106640E+01_JPRB, 0.107872E+01_JPRB, 0.109070E+01_JPRB &
  &, 0.110232E+01_JPRB, 0.111359E+01_JPRB, 0.112450E+01_JPRB &
  &, 0.113502E+01_JPRB, 0.114516E+01_JPRB, 0.115491E+01_JPRB, 0.116426E+01_JPRB &
  &, 0.117320E+01_JPRB, 0.118173E+01_JPRB, 0.118983E+01_JPRB &
  &, 0.119751E+01_JPRB, 0.120475E+01_JPRB, 0.121154E+01_JPRB, 0.121789E+01_JPRB &
  &, 0.122378E+01_JPRB, 0.122920E+01_JPRB, 0.123416E+01_JPRB &
  &, 0.123865E+01_JPRB, 0.124267E+01_JPRB, 0.124620E+01_JPRB, 0.124924E+01_JPRB &
  &, 0.125181E+01_JPRB, 0.125387E+01_JPRB, 0.125545E+01_JPRB &
  &, 0.125652E+01_JPRB, 0.125711E+01_JPRB, 0.125720E+01_JPRB, 0.125679E+01_JPRB &
  &, 0.125587E+01_JPRB, 0.125446E+01_JPRB, 0.125256E+01_JPRB &
  &, 0.125016E+01_JPRB, 0.124727E+01_JPRB, 0.124389E+01_JPRB, 0.124002E+01_JPRB &
  &, 0.123568E+01_JPRB, 0.123085E+01_JPRB, 0.122555E+01_JPRB &
  &, 0.121979E+01_JPRB, 0.121356E+01_JPRB, 0.120689E+01_JPRB, 0.119977E+01_JPRB &
  &, 0.119221E+01_JPRB, 0.118422E+01_JPRB, 0.117580E+01_JPRB &
  &, 0.116699E+01_JPRB, 0.115776E+01_JPRB, 0.114814E+01_JPRB, 0.113814E+01_JPRB &
  &, 0.112776E+01_JPRB, 0.111704E+01_JPRB, 0.110595E+01_JPRB &
  &, 0.109453E+01_JPRB, 0.108278E+01_JPRB, 0.107072E+01_JPRB, 0.105836E+01_JPRB &
  &, 0.104573E+01_JPRB, 0.103280E+01_JPRB, 0.101962E+01_JPRB &
  &, 0.100619E+01_JPRB, 0.992528E+00_JPRB, 0.978640E+00_JPRB, 0.964556E+00_JPRB &
  &, 0.950270E+00_JPRB, 0.935795E+00_JPRB, 0.921166E+00_JPRB &
  &, 0.906377E+00_JPRB, 0.891463E+00_JPRB, 0.876418E+00_JPRB, 0.861276E+00_JPRB &
  &, 0.846031E+00_JPRB, 0.830695E+00_JPRB, 0.815282E+00_JPRB &
  &, 0.799828E+00_JPRB, 0.784322E+00_JPRB, 0.768801E+00_JPRB, 0.753253E+00_JPRB &
  &, 0.737714E+00_JPRB, 0.722169E+00_JPRB, 0.706654E+00_JPRB &
  &, 0.691152E+00_JPRB, 0.675727E+00_JPRB, 0.660332E+00_JPRB, 0.645002E+00_JPRB &
  &, 0.629774E+00_JPRB, 0.614624E+00_JPRB, 0.599588E+00_JPRB &
  &, 0.584640E+00_JPRB, 0.569814E+00_JPRB, 0.555112E+00_JPRB, 0.540569E+00_JPRB &
  &, 0.526153E+00_JPRB, 0.511898E+00_JPRB, 0.497837E+00_JPRB &
  &, 0.483899E+00_JPRB, 0.470149E+00_JPRB, 0.456585E+00_JPRB, 0.443237E+00_JPRB &
  &, 0.430064E+00_JPRB, 0.417056E+00_JPRB, 0.404321E+00_JPRB &
  &, 0.391731E+00_JPRB, 0.379395E+00_JPRB, 0.367302E+00_JPRB, 0.355397E+00_JPRB &
  &, 0.343707E+00_JPRB, 0.332259E+00_JPRB, 0.321080E+00_JPRB &
  &, 0.310109E+00_JPRB, 0.299370E+00_JPRB, 0.288843E+00_JPRB, 0.278598E+00_JPRB &
  &, 0.268565E+00_JPRB, 0.258767E+00_JPRB, 0.249227E+00_JPRB &
  &, 0.239919E+00_JPRB, 0.230863E+00_JPRB, 0.222032E+00_JPRB, 0.213392E+00_JPRB &
  &, 0.205069E+00_JPRB, 0.196924E+00_JPRB, 0.189028E+00_JPRB &
  &, 0.181347E+00_JPRB, 0.173953E+00_JPRB, 0.166753E+00_JPRB, 0.159763E+00_JPRB &
  &, 0.152940E+00_JPRB, 0.146418E+00_JPRB, 0.140094E+00_JPRB &
  &, 0.133924E+00_JPRB, 0.128041E+00_JPRB, 0.122340E+00_JPRB, 0.116768E+00_JPRB &
  &, 0.111466E+00_JPRB, 0.106318E+00_JPRB, 0.101402E+00_JPRB/)
XCW( 714, :) = (/ &
  &  0.105405E+01_JPRB, 0.106678E+01_JPRB, 0.107918E+01_JPRB, 0.109124E+01_JPRB &
  &, 0.110295E+01_JPRB, 0.111431E+01_JPRB, 0.112529E+01_JPRB &
  &, 0.113590E+01_JPRB, 0.114613E+01_JPRB, 0.115597E+01_JPRB, 0.116540E+01_JPRB &
  &, 0.117443E+01_JPRB, 0.118305E+01_JPRB, 0.119124E+01_JPRB &
  &, 0.119901E+01_JPRB, 0.120634E+01_JPRB, 0.121322E+01_JPRB, 0.121966E+01_JPRB &
  &, 0.122564E+01_JPRB, 0.123116E+01_JPRB, 0.123621E+01_JPRB &
  &, 0.124079E+01_JPRB, 0.124490E+01_JPRB, 0.124852E+01_JPRB, 0.125166E+01_JPRB &
  &, 0.125431E+01_JPRB, 0.125647E+01_JPRB, 0.125814E+01_JPRB &
  &, 0.125931E+01_JPRB, 0.125999E+01_JPRB, 0.126016E+01_JPRB, 0.125984E+01_JPRB &
  &, 0.125902E+01_JPRB, 0.125769E+01_JPRB, 0.125588E+01_JPRB &
  &, 0.125356E+01_JPRB, 0.125076E+01_JPRB, 0.124747E+01_JPRB, 0.124368E+01_JPRB &
  &, 0.123942E+01_JPRB, 0.123467E+01_JPRB, 0.122945E+01_JPRB &
  &, 0.122377E+01_JPRB, 0.121763E+01_JPRB, 0.121103E+01_JPRB, 0.120398E+01_JPRB &
  &, 0.119649E+01_JPRB, 0.118857E+01_JPRB, 0.118023E+01_JPRB &
  &, 0.117145E+01_JPRB, 0.116230E+01_JPRB, 0.115276E+01_JPRB, 0.114271E+01_JPRB &
  &, 0.113250E+01_JPRB, 0.112183E+01_JPRB, 0.111079E+01_JPRB &
  &, 0.109943E+01_JPRB, 0.108773E+01_JPRB, 0.107572E+01_JPRB, 0.106341E+01_JPRB &
  &, 0.105080E+01_JPRB, 0.103794E+01_JPRB, 0.102479E+01_JPRB &
  &, 0.101139E+01_JPRB, 0.997758E+00_JPRB, 0.983910E+00_JPRB, 0.969844E+00_JPRB &
  &, 0.955594E+00_JPRB, 0.941132E+00_JPRB, 0.926535E+00_JPRB &
  &, 0.911755E+00_JPRB, 0.896868E+00_JPRB, 0.881825E+00_JPRB, 0.866684E+00_JPRB &
  &, 0.851435E+00_JPRB, 0.836093E+00_JPRB, 0.820694E+00_JPRB &
  &, 0.805252E+00_JPRB, 0.789730E+00_JPRB, 0.774190E+00_JPRB, 0.758645E+00_JPRB &
  &, 0.743079E+00_JPRB, 0.727504E+00_JPRB, 0.711982E+00_JPRB &
  &, 0.696471E+00_JPRB, 0.681005E+00_JPRB, 0.665593E+00_JPRB, 0.650244E+00_JPRB &
  &, 0.634963E+00_JPRB, 0.619786E+00_JPRB, 0.604689E+00_JPRB &
  &, 0.589706E+00_JPRB, 0.574842E+00_JPRB, 0.560131E+00_JPRB, 0.545511E+00_JPRB &
  &, 0.531046E+00_JPRB, 0.516773E+00_JPRB, 0.502620E+00_JPRB &
  &, 0.488621E+00_JPRB, 0.474843E+00_JPRB, 0.461210E+00_JPRB, 0.447790E+00_JPRB &
  &, 0.434540E+00_JPRB, 0.421489E+00_JPRB, 0.408669E+00_JPRB &
  &, 0.396070E+00_JPRB, 0.383641E+00_JPRB, 0.371450E+00_JPRB, 0.359486E+00_JPRB &
  &, 0.347732E+00_JPRB, 0.336217E+00_JPRB, 0.324968E+00_JPRB &
  &, 0.313878E+00_JPRB, 0.303061E+00_JPRB, 0.292498E+00_JPRB, 0.282167E+00_JPRB &
  &, 0.272046E+00_JPRB, 0.262203E+00_JPRB, 0.252567E+00_JPRB &
  &, 0.243209E+00_JPRB, 0.234051E+00_JPRB, 0.225112E+00_JPRB, 0.216465E+00_JPRB &
  &, 0.208027E+00_JPRB, 0.199818E+00_JPRB, 0.191855E+00_JPRB &
  &, 0.184103E+00_JPRB, 0.176636E+00_JPRB, 0.169304E+00_JPRB, 0.162292E+00_JPRB &
  &, 0.155447E+00_JPRB, 0.148781E+00_JPRB, 0.142370E+00_JPRB &
  &, 0.136170E+00_JPRB, 0.130195E+00_JPRB, 0.124397E+00_JPRB, 0.118853E+00_JPRB &
  &, 0.113451E+00_JPRB, 0.108264E+00_JPRB, 0.103242E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART102',1,ZHOOK_HANDLE)
END SUBROUTINE PART102

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART103

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART103',0,ZHOOK_HANDLE)

XCW( 715, :) = (/ &
  &  0.105436E+01_JPRB, 0.106717E+01_JPRB, 0.107965E+01_JPRB, 0.109179E+01_JPRB &
  &, 0.110358E+01_JPRB, 0.111502E+01_JPRB, 0.112609E+01_JPRB &
  &, 0.113679E+01_JPRB, 0.114710E+01_JPRB, 0.115702E+01_JPRB, 0.116655E+01_JPRB &
  &, 0.117567E+01_JPRB, 0.118437E+01_JPRB, 0.119266E+01_JPRB &
  &, 0.120051E+01_JPRB, 0.120793E+01_JPRB, 0.121491E+01_JPRB, 0.122144E+01_JPRB &
  &, 0.122751E+01_JPRB, 0.123312E+01_JPRB, 0.123826E+01_JPRB &
  &, 0.124294E+01_JPRB, 0.124714E+01_JPRB, 0.125085E+01_JPRB, 0.125409E+01_JPRB &
  &, 0.125683E+01_JPRB, 0.125908E+01_JPRB, 0.126084E+01_JPRB &
  &, 0.126210E+01_JPRB, 0.126286E+01_JPRB, 0.126313E+01_JPRB, 0.126290E+01_JPRB &
  &, 0.126217E+01_JPRB, 0.126094E+01_JPRB, 0.125921E+01_JPRB &
  &, 0.125698E+01_JPRB, 0.125426E+01_JPRB, 0.125105E+01_JPRB, 0.124735E+01_JPRB &
  &, 0.124317E+01_JPRB, 0.123851E+01_JPRB, 0.123337E+01_JPRB &
  &, 0.122777E+01_JPRB, 0.122170E+01_JPRB, 0.121517E+01_JPRB, 0.120820E+01_JPRB &
  &, 0.120079E+01_JPRB, 0.119294E+01_JPRB, 0.118466E+01_JPRB &
  &, 0.117599E+01_JPRB, 0.116688E+01_JPRB, 0.115739E+01_JPRB, 0.114751E+01_JPRB &
  &, 0.113726E+01_JPRB, 0.112664E+01_JPRB, 0.111567E+01_JPRB &
  &, 0.110436E+01_JPRB, 0.109271E+01_JPRB, 0.108075E+01_JPRB, 0.106849E+01_JPRB &
  &, 0.105593E+01_JPRB, 0.104309E+01_JPRB, 0.102999E+01_JPRB &
  &, 0.101662E+01_JPRB, 0.100303E+01_JPRB, 0.989199E+00_JPRB, 0.975171E+00_JPRB &
  &, 0.960937E+00_JPRB, 0.946510E+00_JPRB, 0.931925E+00_JPRB &
  &, 0.917174E+00_JPRB, 0.902272E+00_JPRB, 0.887255E+00_JPRB, 0.872114E+00_JPRB &
  &, 0.856886E+00_JPRB, 0.841561E+00_JPRB, 0.826154E+00_JPRB &
  &, 0.810700E+00_JPRB, 0.795188E+00_JPRB, 0.779630E+00_JPRB, 0.764062E+00_JPRB &
  &, 0.748471E+00_JPRB, 0.732919E+00_JPRB, 0.717338E+00_JPRB &
  &, 0.701817E+00_JPRB, 0.686339E+00_JPRB, 0.670884E+00_JPRB, 0.655515E+00_JPRB &
  &, 0.640212E+00_JPRB, 0.624979E+00_JPRB, 0.609852E+00_JPRB &
  &, 0.594836E+00_JPRB, 0.579935E+00_JPRB, 0.565151E+00_JPRB, 0.550519E+00_JPRB &
  &, 0.536007E+00_JPRB, 0.521647E+00_JPRB, 0.507439E+00_JPRB &
  &, 0.493415E+00_JPRB, 0.479573E+00_JPRB, 0.465872E+00_JPRB, 0.452380E+00_JPRB &
  &, 0.439092E+00_JPRB, 0.426001E+00_JPRB, 0.413096E+00_JPRB &
  &, 0.400409E+00_JPRB, 0.387928E+00_JPRB, 0.375682E+00_JPRB, 0.363617E+00_JPRB &
  &, 0.351801E+00_JPRB, 0.340219E+00_JPRB, 0.328856E+00_JPRB &
  &, 0.317737E+00_JPRB, 0.306843E+00_JPRB, 0.296199E+00_JPRB, 0.285784E+00_JPRB &
  &, 0.275622E+00_JPRB, 0.265688E+00_JPRB, 0.255957E+00_JPRB &
  &, 0.246500E+00_JPRB, 0.237288E+00_JPRB, 0.228294E+00_JPRB, 0.219538E+00_JPRB &
  &, 0.211039E+00_JPRB, 0.202766E+00_JPRB, 0.194736E+00_JPRB &
  &, 0.186915E+00_JPRB, 0.179320E+00_JPRB, 0.171969E+00_JPRB, 0.164821E+00_JPRB &
  &, 0.157953E+00_JPRB, 0.151204E+00_JPRB, 0.144766E+00_JPRB &
  &, 0.138477E+00_JPRB, 0.132409E+00_JPRB, 0.126579E+00_JPRB, 0.120938E+00_JPRB &
  &, 0.115435E+00_JPRB, 0.110210E+00_JPRB, 0.105148E+00_JPRB/)
XCW( 716, :) = (/ &
  &  0.105466E+01_JPRB, 0.106755E+01_JPRB, 0.108011E+01_JPRB, 0.109234E+01_JPRB &
  &, 0.110421E+01_JPRB, 0.111573E+01_JPRB, 0.112689E+01_JPRB &
  &, 0.113767E+01_JPRB, 0.114807E+01_JPRB, 0.115808E+01_JPRB, 0.116770E+01_JPRB &
  &, 0.117690E+01_JPRB, 0.118570E+01_JPRB, 0.119407E+01_JPRB &
  &, 0.120202E+01_JPRB, 0.120953E+01_JPRB, 0.121660E+01_JPRB, 0.122322E+01_JPRB &
  &, 0.122938E+01_JPRB, 0.123509E+01_JPRB, 0.124032E+01_JPRB &
  &, 0.124509E+01_JPRB, 0.124938E+01_JPRB, 0.125319E+01_JPRB, 0.125652E+01_JPRB &
  &, 0.125935E+01_JPRB, 0.126170E+01_JPRB, 0.126355E+01_JPRB &
  &, 0.126490E+01_JPRB, 0.126576E+01_JPRB, 0.126612E+01_JPRB, 0.126597E+01_JPRB &
  &, 0.126533E+01_JPRB, 0.126419E+01_JPRB, 0.126255E+01_JPRB &
  &, 0.126041E+01_JPRB, 0.125777E+01_JPRB, 0.125465E+01_JPRB, 0.125104E+01_JPRB &
  &, 0.124694E+01_JPRB, 0.124236E+01_JPRB, 0.123731E+01_JPRB &
  &, 0.123178E+01_JPRB, 0.122579E+01_JPRB, 0.121934E+01_JPRB, 0.121244E+01_JPRB &
  &, 0.120510E+01_JPRB, 0.119733E+01_JPRB, 0.118913E+01_JPRB &
  &, 0.118051E+01_JPRB, 0.117148E+01_JPRB, 0.116205E+01_JPRB, 0.115224E+01_JPRB &
  &, 0.114204E+01_JPRB, 0.113149E+01_JPRB, 0.112057E+01_JPRB &
  &, 0.110930E+01_JPRB, 0.109772E+01_JPRB, 0.108581E+01_JPRB, 0.107358E+01_JPRB &
  &, 0.106107E+01_JPRB, 0.104827E+01_JPRB, 0.103520E+01_JPRB &
  &, 0.102188E+01_JPRB, 0.100831E+01_JPRB, 0.994526E+00_JPRB, 0.980518E+00_JPRB &
  &, 0.966321E+00_JPRB, 0.951909E+00_JPRB, 0.937335E+00_JPRB &
  &, 0.922615E+00_JPRB, 0.907742E+00_JPRB, 0.892729E+00_JPRB, 0.877589E+00_JPRB &
  &, 0.862359E+00_JPRB, 0.847030E+00_JPRB, 0.831638E+00_JPRB &
  &, 0.816172E+00_JPRB, 0.800645E+00_JPRB, 0.785094E+00_JPRB, 0.769531E+00_JPRB &
  &, 0.753915E+00_JPRB, 0.738335E+00_JPRB, 0.722749E+00_JPRB &
  &, 0.707192E+00_JPRB, 0.691702E+00_JPRB, 0.676232E+00_JPRB, 0.660816E+00_JPRB &
  &, 0.645490E+00_JPRB, 0.630232E+00_JPRB, 0.615046E+00_JPRB &
  &, 0.599998E+00_JPRB, 0.585060E+00_JPRB, 0.570237E+00_JPRB, 0.555528E+00_JPRB &
  &, 0.540968E+00_JPRB, 0.526556E+00_JPRB, 0.512327E+00_JPRB &
  &, 0.498244E+00_JPRB, 0.484303E+00_JPRB, 0.470571E+00_JPRB, 0.457046E+00_JPRB &
  &, 0.443683E+00_JPRB, 0.430512E+00_JPRB, 0.417563E+00_JPRB &
  &, 0.404788E+00_JPRB, 0.392256E+00_JPRB, 0.379914E+00_JPRB, 0.367790E+00_JPRB &
  &, 0.355911E+00_JPRB, 0.344265E+00_JPRB, 0.332832E+00_JPRB &
  &, 0.321641E+00_JPRB, 0.310671E+00_JPRB, 0.299947E+00_JPRB, 0.289448E+00_JPRB &
  &, 0.279198E+00_JPRB, 0.269173E+00_JPRB, 0.259396E+00_JPRB &
  &, 0.249890E+00_JPRB, 0.240577E+00_JPRB, 0.231529E+00_JPRB, 0.222715E+00_JPRB &
  &, 0.214104E+00_JPRB, 0.205767E+00_JPRB, 0.197617E+00_JPRB &
  &, 0.189727E+00_JPRB, 0.182060E+00_JPRB, 0.174633E+00_JPRB, 0.167466E+00_JPRB &
  &, 0.160459E+00_JPRB, 0.153685E+00_JPRB, 0.147162E+00_JPRB &
  &, 0.140783E+00_JPRB, 0.134686E+00_JPRB, 0.128762E+00_JPRB, 0.123023E+00_JPRB &
  &, 0.117484E+00_JPRB, 0.112156E+00_JPRB, 0.107053E+00_JPRB/)
XCW( 717, :) = (/ &
  &  0.105497E+01_JPRB, 0.106794E+01_JPRB, 0.108058E+01_JPRB, 0.109289E+01_JPRB &
  &, 0.110484E+01_JPRB, 0.111645E+01_JPRB, 0.112769E+01_JPRB &
  &, 0.113856E+01_JPRB, 0.114905E+01_JPRB, 0.115915E+01_JPRB, 0.116885E+01_JPRB &
  &, 0.117814E+01_JPRB, 0.118703E+01_JPRB, 0.119549E+01_JPRB &
  &, 0.120353E+01_JPRB, 0.121113E+01_JPRB, 0.121829E+01_JPRB, 0.122500E+01_JPRB &
  &, 0.123126E+01_JPRB, 0.123706E+01_JPRB, 0.124239E+01_JPRB &
  &, 0.124725E+01_JPRB, 0.125163E+01_JPRB, 0.125553E+01_JPRB, 0.125895E+01_JPRB &
  &, 0.126188E+01_JPRB, 0.126432E+01_JPRB, 0.126627E+01_JPRB &
  &, 0.126771E+01_JPRB, 0.126866E+01_JPRB, 0.126911E+01_JPRB, 0.126906E+01_JPRB &
  &, 0.126850E+01_JPRB, 0.126745E+01_JPRB, 0.126590E+01_JPRB &
  &, 0.126385E+01_JPRB, 0.126130E+01_JPRB, 0.125826E+01_JPRB, 0.125474E+01_JPRB &
  &, 0.125073E+01_JPRB, 0.124622E+01_JPRB, 0.124125E+01_JPRB &
  &, 0.123581E+01_JPRB, 0.122990E+01_JPRB, 0.122353E+01_JPRB, 0.121670E+01_JPRB &
  &, 0.120944E+01_JPRB, 0.120174E+01_JPRB, 0.119361E+01_JPRB &
  &, 0.118505E+01_JPRB, 0.117609E+01_JPRB, 0.116673E+01_JPRB, 0.115698E+01_JPRB &
  &, 0.114685E+01_JPRB, 0.113634E+01_JPRB, 0.112548E+01_JPRB &
  &, 0.111427E+01_JPRB, 0.110275E+01_JPRB, 0.109087E+01_JPRB, 0.107871E+01_JPRB &
  &, 0.106623E+01_JPRB, 0.105347E+01_JPRB, 0.104046E+01_JPRB &
  &, 0.102716E+01_JPRB, 0.101364E+01_JPRB, 0.999872E+00_JPRB, 0.985903E+00_JPRB &
  &, 0.971724E+00_JPRB, 0.957347E+00_JPRB, 0.942787E+00_JPRB &
  &, 0.928077E+00_JPRB, 0.913232E+00_JPRB, 0.898224E+00_JPRB, 0.883109E+00_JPRB &
  &, 0.867878E+00_JPRB, 0.852568E+00_JPRB, 0.837169E+00_JPRB &
  &, 0.821693E+00_JPRB, 0.806177E+00_JPRB, 0.790609E+00_JPRB, 0.775026E+00_JPRB &
  &, 0.759412E+00_JPRB, 0.743804E+00_JPRB, 0.728214E+00_JPRB &
  &, 0.712622E+00_JPRB, 0.697093E+00_JPRB, 0.681609E+00_JPRB, 0.666146E+00_JPRB &
  &, 0.650799E+00_JPRB, 0.635517E+00_JPRB, 0.620302E+00_JPRB &
  &, 0.605191E+00_JPRB, 0.590218E+00_JPRB, 0.575355E+00_JPRB, 0.560603E+00_JPRB &
  &, 0.545996E+00_JPRB, 0.531534E+00_JPRB, 0.517251E+00_JPRB &
  &, 0.503110E+00_JPRB, 0.489142E+00_JPRB, 0.475345E+00_JPRB, 0.461712E+00_JPRB &
  &, 0.448312E+00_JPRB, 0.435062E+00_JPRB, 0.422030E+00_JPRB &
  &, 0.409208E+00_JPRB, 0.396625E+00_JPRB, 0.384229E+00_JPRB, 0.372047E+00_JPRB &
  &, 0.360065E+00_JPRB, 0.348354E+00_JPRB, 0.336853E+00_JPRB &
  &, 0.325589E+00_JPRB, 0.314544E+00_JPRB, 0.303741E+00_JPRB, 0.293159E+00_JPRB &
  &, 0.282822E+00_JPRB, 0.272755E+00_JPRB, 0.262884E+00_JPRB &
  &, 0.253280E+00_JPRB, 0.243916E+00_JPRB, 0.234763E+00_JPRB, 0.225892E+00_JPRB &
  &, 0.217221E+00_JPRB, 0.208768E+00_JPRB, 0.200553E+00_JPRB &
  &, 0.192594E+00_JPRB, 0.184856E+00_JPRB, 0.177355E+00_JPRB, 0.170110E+00_JPRB &
  &, 0.163023E+00_JPRB, 0.156167E+00_JPRB, 0.149557E+00_JPRB &
  &, 0.143151E+00_JPRB, 0.136962E+00_JPRB, 0.130944E+00_JPRB, 0.125171E+00_JPRB &
  &, 0.119596E+00_JPRB, 0.114167E+00_JPRB, 0.108959E+00_JPRB/)
XCW( 718, :) = (/ &
  &  0.105528E+01_JPRB, 0.106832E+01_JPRB, 0.108105E+01_JPRB, 0.109343E+01_JPRB &
  &, 0.110548E+01_JPRB, 0.111717E+01_JPRB, 0.112849E+01_JPRB &
  &, 0.113945E+01_JPRB, 0.115002E+01_JPRB, 0.116021E+01_JPRB, 0.117000E+01_JPRB &
  &, 0.117939E+01_JPRB, 0.118836E+01_JPRB, 0.119692E+01_JPRB &
  &, 0.120504E+01_JPRB, 0.121274E+01_JPRB, 0.121999E+01_JPRB, 0.122679E+01_JPRB &
  &, 0.123314E+01_JPRB, 0.123903E+01_JPRB, 0.124446E+01_JPRB &
  &, 0.124941E+01_JPRB, 0.125389E+01_JPRB, 0.125789E+01_JPRB, 0.126140E+01_JPRB &
  &, 0.126442E+01_JPRB, 0.126695E+01_JPRB, 0.126899E+01_JPRB &
  &, 0.127053E+01_JPRB, 0.127157E+01_JPRB, 0.127211E+01_JPRB, 0.127215E+01_JPRB &
  &, 0.127169E+01_JPRB, 0.127073E+01_JPRB, 0.126927E+01_JPRB &
  &, 0.126730E+01_JPRB, 0.126484E+01_JPRB, 0.126189E+01_JPRB, 0.125845E+01_JPRB &
  &, 0.125452E+01_JPRB, 0.125010E+01_JPRB, 0.124521E+01_JPRB &
  &, 0.123985E+01_JPRB, 0.123402E+01_JPRB, 0.122773E+01_JPRB, 0.122098E+01_JPRB &
  &, 0.121379E+01_JPRB, 0.120616E+01_JPRB, 0.119811E+01_JPRB &
  &, 0.118962E+01_JPRB, 0.118073E+01_JPRB, 0.117143E+01_JPRB, 0.116174E+01_JPRB &
  &, 0.115166E+01_JPRB, 0.114122E+01_JPRB, 0.113043E+01_JPRB &
  &, 0.111928E+01_JPRB, 0.110779E+01_JPRB, 0.109598E+01_JPRB, 0.108385E+01_JPRB &
  &, 0.107143E+01_JPRB, 0.105872E+01_JPRB, 0.104573E+01_JPRB &
  &, 0.103248E+01_JPRB, 0.101900E+01_JPRB, 0.100526E+01_JPRB, 0.991308E+00_JPRB &
  &, 0.977166E+00_JPRB, 0.962806E+00_JPRB, 0.948280E+00_JPRB &
  &, 0.933581E+00_JPRB, 0.918744E+00_JPRB, 0.903764E+00_JPRB, 0.888651E+00_JPRB &
  &, 0.873420E+00_JPRB, 0.858106E+00_JPRB, 0.842724E+00_JPRB &
  &, 0.827239E+00_JPRB, 0.811710E+00_JPRB, 0.796150E+00_JPRB, 0.780546E+00_JPRB &
  &, 0.764935E+00_JPRB, 0.749300E+00_JPRB, 0.733706E+00_JPRB &
  &, 0.718108E+00_JPRB, 0.702541E+00_JPRB, 0.687014E+00_JPRB, 0.671534E+00_JPRB &
  &, 0.656138E+00_JPRB, 0.640831E+00_JPRB, 0.625589E+00_JPRB &
  &, 0.610447E+00_JPRB, 0.595408E+00_JPRB, 0.580506E+00_JPRB, 0.565712E+00_JPRB &
  &, 0.551059E+00_JPRB, 0.536547E+00_JPRB, 0.522210E+00_JPRB &
  &, 0.508011E+00_JPRB, 0.493982E+00_JPRB, 0.480118E+00_JPRB, 0.466452E+00_JPRB &
  &, 0.452979E+00_JPRB, 0.439689E+00_JPRB, 0.426576E+00_JPRB &
  &, 0.413707E+00_JPRB, 0.401034E+00_JPRB, 0.388543E+00_JPRB, 0.376304E+00_JPRB &
  &, 0.364262E+00_JPRB, 0.352486E+00_JPRB, 0.340918E+00_JPRB &
  &, 0.329538E+00_JPRB, 0.318462E+00_JPRB, 0.307581E+00_JPRB, 0.296916E+00_JPRB &
  &, 0.286541E+00_JPRB, 0.276337E+00_JPRB, 0.266421E+00_JPRB &
  &, 0.256720E+00_JPRB, 0.247255E+00_JPRB, 0.238048E+00_JPRB, 0.229069E+00_JPRB &
  &, 0.220338E+00_JPRB, 0.211823E+00_JPRB, 0.203543E+00_JPRB &
  &, 0.195516E+00_JPRB, 0.187707E+00_JPRB, 0.180133E+00_JPRB, 0.172754E+00_JPRB &
  &, 0.165646E+00_JPRB, 0.158707E+00_JPRB, 0.152013E+00_JPRB &
  &, 0.145518E+00_JPRB, 0.139300E+00_JPRB, 0.133188E+00_JPRB, 0.127383E+00_JPRB &
  &, 0.121709E+00_JPRB, 0.116242E+00_JPRB, 0.110930E+00_JPRB/)
XCW( 719, :) = (/ &
  &  0.105558E+01_JPRB, 0.106871E+01_JPRB, 0.108152E+01_JPRB, 0.109399E+01_JPRB &
  &, 0.110611E+01_JPRB, 0.111789E+01_JPRB, 0.112930E+01_JPRB &
  &, 0.114034E+01_JPRB, 0.115100E+01_JPRB, 0.116128E+01_JPRB, 0.117116E+01_JPRB &
  &, 0.118063E+01_JPRB, 0.118970E+01_JPRB, 0.119834E+01_JPRB &
  &, 0.120656E+01_JPRB, 0.121435E+01_JPRB, 0.122169E+01_JPRB, 0.122859E+01_JPRB &
  &, 0.123503E+01_JPRB, 0.124102E+01_JPRB, 0.124654E+01_JPRB &
  &, 0.125158E+01_JPRB, 0.125615E+01_JPRB, 0.126024E+01_JPRB, 0.126385E+01_JPRB &
  &, 0.126697E+01_JPRB, 0.126959E+01_JPRB, 0.127172E+01_JPRB &
  &, 0.127336E+01_JPRB, 0.127449E+01_JPRB, 0.127512E+01_JPRB, 0.127525E+01_JPRB &
  &, 0.127488E+01_JPRB, 0.127401E+01_JPRB, 0.127264E+01_JPRB &
  &, 0.127076E+01_JPRB, 0.126840E+01_JPRB, 0.126553E+01_JPRB, 0.126218E+01_JPRB &
  &, 0.125833E+01_JPRB, 0.125400E+01_JPRB, 0.124919E+01_JPRB &
  &, 0.124391E+01_JPRB, 0.123816E+01_JPRB, 0.123195E+01_JPRB, 0.122527E+01_JPRB &
  &, 0.121817E+01_JPRB, 0.121060E+01_JPRB, 0.120262E+01_JPRB &
  &, 0.119421E+01_JPRB, 0.118537E+01_JPRB, 0.117615E+01_JPRB, 0.116652E+01_JPRB &
  &, 0.115652E+01_JPRB, 0.114614E+01_JPRB, 0.113540E+01_JPRB &
  &, 0.112430E+01_JPRB, 0.111286E+01_JPRB, 0.110109E+01_JPRB, 0.108903E+01_JPRB &
  &, 0.107664E+01_JPRB, 0.106398E+01_JPRB, 0.105104E+01_JPRB &
  &, 0.103783E+01_JPRB, 0.102438E+01_JPRB, 0.101068E+01_JPRB, 0.996751E+00_JPRB &
  &, 0.982629E+00_JPRB, 0.968305E+00_JPRB, 0.953793E+00_JPRB &
  &, 0.939127E+00_JPRB, 0.924300E+00_JPRB, 0.909325E+00_JPRB, 0.894215E+00_JPRB &
  &, 0.879007E+00_JPRB, 0.863691E+00_JPRB, 0.848303E+00_JPRB &
  &, 0.832833E+00_JPRB, 0.817316E+00_JPRB, 0.801716E+00_JPRB, 0.786118E+00_JPRB &
  &, 0.770484E+00_JPRB, 0.754850E+00_JPRB, 0.739226E+00_JPRB &
  &, 0.723594E+00_JPRB, 0.708018E+00_JPRB, 0.692478E+00_JPRB, 0.676982E+00_JPRB &
  &, 0.661537E+00_JPRB, 0.646177E+00_JPRB, 0.630908E+00_JPRB &
  &, 0.615735E+00_JPRB, 0.600662E+00_JPRB, 0.585723E+00_JPRB, 0.570888E+00_JPRB &
  &, 0.556190E+00_JPRB, 0.541629E+00_JPRB, 0.527204E+00_JPRB &
  &, 0.512948E+00_JPRB, 0.498894E+00_JPRB, 0.484965E+00_JPRB, 0.471231E+00_JPRB &
  &, 0.457684E+00_JPRB, 0.444317E+00_JPRB, 0.431161E+00_JPRB &
  &, 0.418207E+00_JPRB, 0.405484E+00_JPRB, 0.392941E+00_JPRB, 0.380562E+00_JPRB &
  &, 0.368544E+00_JPRB, 0.356662E+00_JPRB, 0.345027E+00_JPRB &
  &, 0.333576E+00_JPRB, 0.322381E+00_JPRB, 0.311467E+00_JPRB, 0.300721E+00_JPRB &
  &, 0.290261E+00_JPRB, 0.280015E+00_JPRB, 0.270007E+00_JPRB &
  &, 0.260210E+00_JPRB, 0.250695E+00_JPRB, 0.241385E+00_JPRB, 0.232350E+00_JPRB &
  &, 0.223509E+00_JPRB, 0.214932E+00_JPRB, 0.206587E+00_JPRB &
  &, 0.198493E+00_JPRB, 0.190614E+00_JPRB, 0.182911E+00_JPRB, 0.175514E+00_JPRB &
  &, 0.168268E+00_JPRB, 0.161307E+00_JPRB, 0.154528E+00_JPRB &
  &, 0.147946E+00_JPRB, 0.141638E+00_JPRB, 0.135495E+00_JPRB, 0.129594E+00_JPRB &
  &, 0.123822E+00_JPRB, 0.118318E+00_JPRB, 0.112967E+00_JPRB/)
XCW( 720, :) = (/ &
  &  0.105589E+01_JPRB, 0.106910E+01_JPRB, 0.108199E+01_JPRB, 0.109454E+01_JPRB &
  &, 0.110675E+01_JPRB, 0.111861E+01_JPRB, 0.113010E+01_JPRB &
  &, 0.114123E+01_JPRB, 0.115198E+01_JPRB, 0.116235E+01_JPRB, 0.117231E+01_JPRB &
  &, 0.118188E+01_JPRB, 0.119103E+01_JPRB, 0.119977E+01_JPRB &
  &, 0.120808E+01_JPRB, 0.121596E+01_JPRB, 0.122340E+01_JPRB, 0.123039E+01_JPRB &
  &, 0.123693E+01_JPRB, 0.124301E+01_JPRB, 0.124862E+01_JPRB &
  &, 0.125376E+01_JPRB, 0.125843E+01_JPRB, 0.126261E+01_JPRB, 0.126631E+01_JPRB &
  &, 0.126952E+01_JPRB, 0.127224E+01_JPRB, 0.127447E+01_JPRB &
  &, 0.127619E+01_JPRB, 0.127742E+01_JPRB, 0.127814E+01_JPRB, 0.127837E+01_JPRB &
  &, 0.127809E+01_JPRB, 0.127731E+01_JPRB, 0.127602E+01_JPRB &
  &, 0.127424E+01_JPRB, 0.127196E+01_JPRB, 0.126918E+01_JPRB, 0.126592E+01_JPRB &
  &, 0.126216E+01_JPRB, 0.125791E+01_JPRB, 0.125319E+01_JPRB &
  &, 0.124799E+01_JPRB, 0.124232E+01_JPRB, 0.123617E+01_JPRB, 0.122959E+01_JPRB &
  &, 0.122255E+01_JPRB, 0.121507E+01_JPRB, 0.120715E+01_JPRB &
  &, 0.119881E+01_JPRB, 0.119006E+01_JPRB, 0.118089E+01_JPRB, 0.117133E+01_JPRB &
  &, 0.116139E+01_JPRB, 0.115106E+01_JPRB, 0.114038E+01_JPRB &
  &, 0.112934E+01_JPRB, 0.111795E+01_JPRB, 0.110625E+01_JPRB, 0.109423E+01_JPRB &
  &, 0.108189E+01_JPRB, 0.106927E+01_JPRB, 0.105636E+01_JPRB &
  &, 0.104321E+01_JPRB, 0.102977E+01_JPRB, 0.101612E+01_JPRB, 0.100223E+01_JPRB &
  &, 0.988131E+00_JPRB, 0.973825E+00_JPRB, 0.959348E+00_JPRB &
  &, 0.944694E+00_JPRB, 0.929877E+00_JPRB, 0.914930E+00_JPRB, 0.899825E+00_JPRB &
  &, 0.884641E+00_JPRB, 0.869323E+00_JPRB, 0.853930E+00_JPRB &
  &, 0.838451E+00_JPRB, 0.822923E+00_JPRB, 0.807357E+00_JPRB, 0.791716E+00_JPRB &
  &, 0.776086E+00_JPRB, 0.760427E+00_JPRB, 0.744773E+00_JPRB &
  &, 0.729135E+00_JPRB, 0.713551E+00_JPRB, 0.697971E+00_JPRB, 0.682430E+00_JPRB &
  &, 0.666995E+00_JPRB, 0.651583E+00_JPRB, 0.636288E+00_JPRB &
  &, 0.621055E+00_JPRB, 0.605948E+00_JPRB, 0.590972E+00_JPRB, 0.576063E+00_JPRB &
  &, 0.561320E+00_JPRB, 0.546711E+00_JPRB, 0.532268E+00_JPRB &
  &, 0.517956E+00_JPRB, 0.503806E+00_JPRB, 0.489850E+00_JPRB, 0.476047E+00_JPRB &
  &, 0.462466E+00_JPRB, 0.449023E+00_JPRB, 0.435826E+00_JPRB &
  &, 0.422787E+00_JPRB, 0.409976E+00_JPRB, 0.397380E+00_JPRB, 0.384988E+00_JPRB &
  &, 0.372827E+00_JPRB, 0.360882E+00_JPRB, 0.349136E+00_JPRB &
  &, 0.337660E+00_JPRB, 0.326390E+00_JPRB, 0.315353E+00_JPRB, 0.304573E+00_JPRB &
  &, 0.294028E+00_JPRB, 0.283694E+00_JPRB, 0.273593E+00_JPRB &
  &, 0.263750E+00_JPRB, 0.254136E+00_JPRB, 0.244773E+00_JPRB, 0.235631E+00_JPRB &
  &, 0.226732E+00_JPRB, 0.218094E+00_JPRB, 0.209686E+00_JPRB &
  &, 0.201471E+00_JPRB, 0.193522E+00_JPRB, 0.185746E+00_JPRB, 0.178273E+00_JPRB &
  &, 0.170949E+00_JPRB, 0.163907E+00_JPRB, 0.157044E+00_JPRB &
  &, 0.150435E+00_JPRB, 0.144037E+00_JPRB, 0.137802E+00_JPRB, 0.131805E+00_JPRB &
  &, 0.125998E+00_JPRB, 0.120393E+00_JPRB, 0.115004E+00_JPRB/)
XCW( 721, :) = (/ &
  &  0.105620E+01_JPRB, 0.106949E+01_JPRB, 0.108246E+01_JPRB, 0.109509E+01_JPRB &
  &, 0.110739E+01_JPRB, 0.111933E+01_JPRB, 0.113091E+01_JPRB &
  &, 0.114213E+01_JPRB, 0.115296E+01_JPRB, 0.116342E+01_JPRB, 0.117347E+01_JPRB &
  &, 0.118313E+01_JPRB, 0.119238E+01_JPRB, 0.120121E+01_JPRB &
  &, 0.120961E+01_JPRB, 0.121758E+01_JPRB, 0.122511E+01_JPRB, 0.123220E+01_JPRB &
  &, 0.123883E+01_JPRB, 0.124500E+01_JPRB, 0.125071E+01_JPRB &
  &, 0.125594E+01_JPRB, 0.126070E+01_JPRB, 0.126498E+01_JPRB, 0.126878E+01_JPRB &
  &, 0.127209E+01_JPRB, 0.127490E+01_JPRB, 0.127722E+01_JPRB &
  &, 0.127904E+01_JPRB, 0.128036E+01_JPRB, 0.128118E+01_JPRB, 0.128149E+01_JPRB &
  &, 0.128130E+01_JPRB, 0.128062E+01_JPRB, 0.127943E+01_JPRB &
  &, 0.127773E+01_JPRB, 0.127554E+01_JPRB, 0.127285E+01_JPRB, 0.126967E+01_JPRB &
  &, 0.126599E+01_JPRB, 0.126183E+01_JPRB, 0.125719E+01_JPRB &
  &, 0.125207E+01_JPRB, 0.124648E+01_JPRB, 0.124043E+01_JPRB, 0.123392E+01_JPRB &
  &, 0.122695E+01_JPRB, 0.121955E+01_JPRB, 0.121170E+01_JPRB &
  &, 0.120343E+01_JPRB, 0.119475E+01_JPRB, 0.118566E+01_JPRB, 0.117616E+01_JPRB &
  &, 0.116627E+01_JPRB, 0.115602E+01_JPRB, 0.114539E+01_JPRB &
  &, 0.113441E+01_JPRB, 0.112308E+01_JPRB, 0.111143E+01_JPRB, 0.109946E+01_JPRB &
  &, 0.108717E+01_JPRB, 0.107458E+01_JPRB, 0.106172E+01_JPRB &
  &, 0.104859E+01_JPRB, 0.103521E+01_JPRB, 0.102158E+01_JPRB, 0.100773E+01_JPRB &
  &, 0.993653E+00_JPRB, 0.979385E+00_JPRB, 0.964924E+00_JPRB &
  &, 0.950283E+00_JPRB, 0.935497E+00_JPRB, 0.920558E+00_JPRB, 0.905479E+00_JPRB &
  &, 0.890274E+00_JPRB, 0.874978E+00_JPRB, 0.859604E+00_JPRB &
  &, 0.844118E+00_JPRB, 0.828579E+00_JPRB, 0.812999E+00_JPRB, 0.797366E+00_JPRB &
  &, 0.781715E+00_JPRB, 0.766057E+00_JPRB, 0.750375E+00_JPRB &
  &, 0.734733E+00_JPRB, 0.719112E+00_JPRB, 0.703492E+00_JPRB, 0.687966E+00_JPRB &
  &, 0.672454E+00_JPRB, 0.657050E+00_JPRB, 0.641700E+00_JPRB &
  &, 0.626438E+00_JPRB, 0.611299E+00_JPRB, 0.596255E+00_JPRB, 0.581339E+00_JPRB &
  &, 0.566519E+00_JPRB, 0.551862E+00_JPRB, 0.537368E+00_JPRB &
  &, 0.523000E+00_JPRB, 0.508790E+00_JPRB, 0.494771E+00_JPRB, 0.480938E+00_JPRB &
  &, 0.467247E+00_JPRB, 0.453767E+00_JPRB, 0.440490E+00_JPRB &
  &, 0.427408E+00_JPRB, 0.414508E+00_JPRB, 0.401861E+00_JPRB, 0.389414E+00_JPRB &
  &, 0.377152E+00_JPRB, 0.365144E+00_JPRB, 0.353333E+00_JPRB &
  &, 0.341788E+00_JPRB, 0.330446E+00_JPRB, 0.319332E+00_JPRB, 0.308471E+00_JPRB &
  &, 0.297842E+00_JPRB, 0.287421E+00_JPRB, 0.277278E+00_JPRB &
  &, 0.267339E+00_JPRB, 0.257677E+00_JPRB, 0.248212E+00_JPRB, 0.239017E+00_JPRB &
  &, 0.230007E+00_JPRB, 0.221256E+00_JPRB, 0.212784E+00_JPRB &
  &, 0.204503E+00_JPRB, 0.196485E+00_JPRB, 0.188637E+00_JPRB, 0.181032E+00_JPRB &
  &, 0.173689E+00_JPRB, 0.166565E+00_JPRB, 0.159619E+00_JPRB &
  &, 0.152924E+00_JPRB, 0.146437E+00_JPRB, 0.140172E+00_JPRB, 0.134080E+00_JPRB &
  &, 0.128239E+00_JPRB, 0.122599E+00_JPRB, 0.117107E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART103',1,ZHOOK_HANDLE)
END SUBROUTINE PART103

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART104

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART104',0,ZHOOK_HANDLE)

XCW( 722, :) = (/ &
  &  0.105651E+01_JPRB, 0.106988E+01_JPRB, 0.108293E+01_JPRB, 0.109565E+01_JPRB &
  &, 0.110802E+01_JPRB, 0.112005E+01_JPRB, 0.113172E+01_JPRB &
  &, 0.114302E+01_JPRB, 0.115395E+01_JPRB, 0.116449E+01_JPRB, 0.117464E+01_JPRB &
  &, 0.118439E+01_JPRB, 0.119372E+01_JPRB, 0.120264E+01_JPRB &
  &, 0.121114E+01_JPRB, 0.121920E+01_JPRB, 0.122683E+01_JPRB, 0.123401E+01_JPRB &
  &, 0.124073E+01_JPRB, 0.124700E+01_JPRB, 0.125280E+01_JPRB &
  &, 0.125813E+01_JPRB, 0.126299E+01_JPRB, 0.126736E+01_JPRB, 0.127125E+01_JPRB &
  &, 0.127465E+01_JPRB, 0.127756E+01_JPRB, 0.127998E+01_JPRB &
  &, 0.128189E+01_JPRB, 0.128331E+01_JPRB, 0.128422E+01_JPRB, 0.128463E+01_JPRB &
  &, 0.128453E+01_JPRB, 0.128393E+01_JPRB, 0.128284E+01_JPRB &
  &, 0.128124E+01_JPRB, 0.127912E+01_JPRB, 0.127653E+01_JPRB, 0.127344E+01_JPRB &
  &, 0.126984E+01_JPRB, 0.126577E+01_JPRB, 0.126121E+01_JPRB &
  &, 0.125618E+01_JPRB, 0.125067E+01_JPRB, 0.124470E+01_JPRB, 0.123826E+01_JPRB &
  &, 0.123137E+01_JPRB, 0.122405E+01_JPRB, 0.121628E+01_JPRB &
  &, 0.120803E+01_JPRB, 0.119946E+01_JPRB, 0.119044E+01_JPRB, 0.118100E+01_JPRB &
  &, 0.117119E+01_JPRB, 0.116099E+01_JPRB, 0.115042E+01_JPRB &
  &, 0.113950E+01_JPRB, 0.112823E+01_JPRB, 0.111662E+01_JPRB, 0.110470E+01_JPRB &
  &, 0.109246E+01_JPRB, 0.107993E+01_JPRB, 0.106712E+01_JPRB &
  &, 0.105402E+01_JPRB, 0.104068E+01_JPRB, 0.102708E+01_JPRB, 0.101326E+01_JPRB &
  &, 0.999214E+00_JPRB, 0.984965E+00_JPRB, 0.970540E+00_JPRB &
  &, 0.955913E+00_JPRB, 0.941138E+00_JPRB, 0.926207E+00_JPRB, 0.911156E+00_JPRB &
  &, 0.895976E+00_JPRB, 0.880680E+00_JPRB, 0.865302E+00_JPRB &
  &, 0.849833E+00_JPRB, 0.834284E+00_JPRB, 0.818692E+00_JPRB, 0.803067E+00_JPRB &
  &, 0.787396E+00_JPRB, 0.771714E+00_JPRB, 0.756031E+00_JPRB &
  &, 0.740358E+00_JPRB, 0.724702E+00_JPRB, 0.709071E+00_JPRB, 0.693503E+00_JPRB &
  &, 0.677973E+00_JPRB, 0.662518E+00_JPRB, 0.647143E+00_JPRB &
  &, 0.631853E+00_JPRB, 0.616682E+00_JPRB, 0.601570E+00_JPRB, 0.586615E+00_JPRB &
  &, 0.571785E+00_JPRB, 0.557082E+00_JPRB, 0.542503E+00_JPRB &
  &, 0.528080E+00_JPRB, 0.513848E+00_JPRB, 0.499766E+00_JPRB, 0.485829E+00_JPRB &
  &, 0.472106E+00_JPRB, 0.458590E+00_JPRB, 0.445234E+00_JPRB &
  &, 0.432068E+00_JPRB, 0.419121E+00_JPRB, 0.406383E+00_JPRB, 0.393840E+00_JPRB &
  &, 0.381520E+00_JPRB, 0.369451E+00_JPRB, 0.357574E+00_JPRB &
  &, 0.345871E+00_JPRB, 0.334547E+00_JPRB, 0.323357E+00_JPRB, 0.312417E+00_JPRB &
  &, 0.301705E+00_JPRB, 0.291196E+00_JPRB, 0.280962E+00_JPRB &
  &, 0.270979E+00_JPRB, 0.261219E+00_JPRB, 0.251652E+00_JPRB, 0.242402E+00_JPRB &
  &, 0.233336E+00_JPRB, 0.224526E+00_JPRB, 0.215937E+00_JPRB &
  &, 0.207591E+00_JPRB, 0.199449E+00_JPRB, 0.191586E+00_JPRB, 0.183907E+00_JPRB &
  &, 0.176486E+00_JPRB, 0.169283E+00_JPRB, 0.162254E+00_JPRB &
  &, 0.155474E+00_JPRB, 0.148898E+00_JPRB, 0.142541E+00_JPRB, 0.136418E+00_JPRB &
  &, 0.130479E+00_JPRB, 0.124739E+00_JPRB, 0.119210E+00_JPRB/)
XCW( 723, :) = (/ &
  &  0.105682E+01_JPRB, 0.107027E+01_JPRB, 0.108340E+01_JPRB, 0.109620E+01_JPRB &
  &, 0.110866E+01_JPRB, 0.112078E+01_JPRB, 0.113253E+01_JPRB &
  &, 0.114392E+01_JPRB, 0.115494E+01_JPRB, 0.116557E+01_JPRB, 0.117581E+01_JPRB &
  &, 0.118564E+01_JPRB, 0.119507E+01_JPRB, 0.120408E+01_JPRB &
  &, 0.121267E+01_JPRB, 0.122083E+01_JPRB, 0.122855E+01_JPRB, 0.123582E+01_JPRB &
  &, 0.124264E+01_JPRB, 0.124900E+01_JPRB, 0.125490E+01_JPRB &
  &, 0.126033E+01_JPRB, 0.126528E+01_JPRB, 0.126975E+01_JPRB, 0.127373E+01_JPRB &
  &, 0.127723E+01_JPRB, 0.128023E+01_JPRB, 0.128274E+01_JPRB &
  &, 0.128475E+01_JPRB, 0.128626E+01_JPRB, 0.128727E+01_JPRB, 0.128777E+01_JPRB &
  &, 0.128777E+01_JPRB, 0.128727E+01_JPRB, 0.128626E+01_JPRB &
  &, 0.128474E+01_JPRB, 0.128273E+01_JPRB, 0.128022E+01_JPRB, 0.127722E+01_JPRB &
  &, 0.127372E+01_JPRB, 0.126972E+01_JPRB, 0.126525E+01_JPRB &
  &, 0.126030E+01_JPRB, 0.125488E+01_JPRB, 0.124898E+01_JPRB, 0.124264E+01_JPRB &
  &, 0.123582E+01_JPRB, 0.122857E+01_JPRB, 0.122088E+01_JPRB &
  &, 0.121274E+01_JPRB, 0.120420E+01_JPRB, 0.119524E+01_JPRB, 0.118587E+01_JPRB &
  &, 0.117613E+01_JPRB, 0.116599E+01_JPRB, 0.115548E+01_JPRB &
  &, 0.114462E+01_JPRB, 0.113340E+01_JPRB, 0.112184E+01_JPRB, 0.110998E+01_JPRB &
  &, 0.109779E+01_JPRB, 0.108530E+01_JPRB, 0.107253E+01_JPRB &
  &, 0.105948E+01_JPRB, 0.104617E+01_JPRB, 0.103261E+01_JPRB, 0.101882E+01_JPRB &
  &, 0.100482E+01_JPRB, 0.990585E+00_JPRB, 0.976178E+00_JPRB &
  &, 0.961586E+00_JPRB, 0.946823E+00_JPRB, 0.931923E+00_JPRB, 0.916878E+00_JPRB &
  &, 0.901701E+00_JPRB, 0.886405E+00_JPRB, 0.871024E+00_JPRB &
  &, 0.855549E+00_JPRB, 0.840015E+00_JPRB, 0.824434E+00_JPRB, 0.808794E+00_JPRB &
  &, 0.793103E+00_JPRB, 0.777424E+00_JPRB, 0.761715E+00_JPRB &
  &, 0.746039E+00_JPRB, 0.730349E+00_JPRB, 0.714708E+00_JPRB, 0.699098E+00_JPRB &
  &, 0.683552E+00_JPRB, 0.668046E+00_JPRB, 0.652648E+00_JPRB &
  &, 0.637331E+00_JPRB, 0.622097E+00_JPRB, 0.606950E+00_JPRB, 0.591957E+00_JPRB &
  &, 0.577052E+00_JPRB, 0.562302E+00_JPRB, 0.547673E+00_JPRB &
  &, 0.533232E+00_JPRB, 0.518906E+00_JPRB, 0.504762E+00_JPRB, 0.490796E+00_JPRB &
  &, 0.477002E+00_JPRB, 0.463412E+00_JPRB, 0.449978E+00_JPRB &
  &, 0.436769E+00_JPRB, 0.423776E+00_JPRB, 0.410947E+00_JPRB, 0.398350E+00_JPRB &
  &, 0.385973E+00_JPRB, 0.373801E+00_JPRB, 0.361860E+00_JPRB &
  &, 0.350133E+00_JPRB, 0.338647E+00_JPRB, 0.327382E+00_JPRB, 0.316363E+00_JPRB &
  &, 0.305567E+00_JPRB, 0.295020E+00_JPRB, 0.284696E+00_JPRB &
  &, 0.274618E+00_JPRB, 0.264811E+00_JPRB, 0.255194E+00_JPRB, 0.245840E+00_JPRB &
  &, 0.236665E+00_JPRB, 0.227795E+00_JPRB, 0.219145E+00_JPRB &
  &, 0.210678E+00_JPRB, 0.202468E+00_JPRB, 0.194534E+00_JPRB, 0.186781E+00_JPRB &
  &, 0.179284E+00_JPRB, 0.172001E+00_JPRB, 0.164889E+00_JPRB &
  &, 0.158084E+00_JPRB, 0.151420E+00_JPRB, 0.145035E+00_JPRB, 0.138818E+00_JPRB &
  &, 0.132784E+00_JPRB, 0.126944E+00_JPRB, 0.121378E+00_JPRB/)
XCW( 724, :) = (/ &
  &  0.105713E+01_JPRB, 0.107066E+01_JPRB, 0.108387E+01_JPRB, 0.109676E+01_JPRB &
  &, 0.110931E+01_JPRB, 0.112150E+01_JPRB, 0.113335E+01_JPRB &
  &, 0.114482E+01_JPRB, 0.115593E+01_JPRB, 0.116665E+01_JPRB, 0.117698E+01_JPRB &
  &, 0.118690E+01_JPRB, 0.119642E+01_JPRB, 0.120553E+01_JPRB &
  &, 0.121421E+01_JPRB, 0.122246E+01_JPRB, 0.123027E+01_JPRB, 0.123764E+01_JPRB &
  &, 0.124456E+01_JPRB, 0.125101E+01_JPRB, 0.125701E+01_JPRB &
  &, 0.126253E+01_JPRB, 0.126758E+01_JPRB, 0.127214E+01_JPRB, 0.127622E+01_JPRB &
  &, 0.127982E+01_JPRB, 0.128292E+01_JPRB, 0.128552E+01_JPRB &
  &, 0.128762E+01_JPRB, 0.128923E+01_JPRB, 0.129033E+01_JPRB, 0.129093E+01_JPRB &
  &, 0.129102E+01_JPRB, 0.129061E+01_JPRB, 0.128969E+01_JPRB &
  &, 0.128827E+01_JPRB, 0.128635E+01_JPRB, 0.128393E+01_JPRB, 0.128101E+01_JPRB &
  &, 0.127759E+01_JPRB, 0.127370E+01_JPRB, 0.126932E+01_JPRB &
  &, 0.126444E+01_JPRB, 0.125909E+01_JPRB, 0.125329E+01_JPRB, 0.124701E+01_JPRB &
  &, 0.124028E+01_JPRB, 0.123310E+01_JPRB, 0.122548E+01_JPRB &
  &, 0.121743E+01_JPRB, 0.120895E+01_JPRB, 0.120006E+01_JPRB, 0.119077E+01_JPRB &
  &, 0.118109E+01_JPRB, 0.117100E+01_JPRB, 0.116057E+01_JPRB &
  &, 0.114976E+01_JPRB, 0.113860E+01_JPRB, 0.112710E+01_JPRB, 0.111527E+01_JPRB &
  &, 0.110314E+01_JPRB, 0.109069E+01_JPRB, 0.107797E+01_JPRB &
  &, 0.106496E+01_JPRB, 0.105170E+01_JPRB, 0.103817E+01_JPRB, 0.102441E+01_JPRB &
  &, 0.101044E+01_JPRB, 0.996246E+00_JPRB, 0.981857E+00_JPRB &
  &, 0.967280E+00_JPRB, 0.952550E+00_JPRB, 0.937660E+00_JPRB, 0.922622E+00_JPRB &
  &, 0.907449E+00_JPRB, 0.892177E+00_JPRB, 0.876794E+00_JPRB &
  &, 0.861338E+00_JPRB, 0.845795E+00_JPRB, 0.830203E+00_JPRB, 0.814546E+00_JPRB &
  &, 0.798863E+00_JPRB, 0.783162E+00_JPRB, 0.767453E+00_JPRB &
  &, 0.751720E+00_JPRB, 0.736024E+00_JPRB, 0.720374E+00_JPRB, 0.704634E+00_JPRB &
  &, 0.689160E+00_JPRB, 0.673636E+00_JPRB, 0.658184E+00_JPRB &
  &, 0.642840E+00_JPRB, 0.627545E+00_JPRB, 0.612397E+00_JPRB, 0.597333E+00_JPRB &
  &, 0.582386E+00_JPRB, 0.567592E+00_JPRB, 0.552913E+00_JPRB &
  &, 0.538419E+00_JPRB, 0.524036E+00_JPRB, 0.509831E+00_JPRB, 0.495800E+00_JPRB &
  &, 0.481975E+00_JPRB, 0.468312E+00_JPRB, 0.454800E+00_JPRB &
  &, 0.441550E+00_JPRB, 0.428430E+00_JPRB, 0.415552E+00_JPRB, 0.402903E+00_JPRB &
  &, 0.390427E+00_JPRB, 0.378194E+00_JPRB, 0.366190E+00_JPRB &
  &, 0.354396E+00_JPRB, 0.342839E+00_JPRB, 0.331500E+00_JPRB, 0.320402E+00_JPRB &
  &, 0.309525E+00_JPRB, 0.298892E+00_JPRB, 0.288528E+00_JPRB &
  &, 0.278358E+00_JPRB, 0.268403E+00_JPRB, 0.258736E+00_JPRB, 0.249277E+00_JPRB &
  &, 0.240099E+00_JPRB, 0.231118E+00_JPRB, 0.222352E+00_JPRB &
  &, 0.213876E+00_JPRB, 0.205599E+00_JPRB, 0.197539E+00_JPRB, 0.189713E+00_JPRB &
  &, 0.182139E+00_JPRB, 0.174778E+00_JPRB, 0.167584E+00_JPRB &
  &, 0.160694E+00_JPRB, 0.154004E+00_JPRB, 0.147466E+00_JPRB, 0.141219E+00_JPRB &
  &, 0.135089E+00_JPRB, 0.129215E+00_JPRB, 0.123547E+00_JPRB/)
XCW( 725, :) = (/ &
  &  0.105744E+01_JPRB, 0.107105E+01_JPRB, 0.108435E+01_JPRB, 0.109732E+01_JPRB &
  &, 0.110995E+01_JPRB, 0.112223E+01_JPRB, 0.113416E+01_JPRB &
  &, 0.114573E+01_JPRB, 0.115692E+01_JPRB, 0.116773E+01_JPRB, 0.117815E+01_JPRB &
  &, 0.118817E+01_JPRB, 0.119778E+01_JPRB, 0.120698E+01_JPRB &
  &, 0.121575E+01_JPRB, 0.122410E+01_JPRB, 0.123200E+01_JPRB, 0.123947E+01_JPRB &
  &, 0.124648E+01_JPRB, 0.125303E+01_JPRB, 0.125912E+01_JPRB &
  &, 0.126474E+01_JPRB, 0.126987E+01_JPRB, 0.127454E+01_JPRB, 0.127872E+01_JPRB &
  &, 0.128241E+01_JPRB, 0.128561E+01_JPRB, 0.128831E+01_JPRB &
  &, 0.129051E+01_JPRB, 0.129220E+01_JPRB, 0.129340E+01_JPRB, 0.129410E+01_JPRB &
  &, 0.129428E+01_JPRB, 0.129396E+01_JPRB, 0.129314E+01_JPRB &
  &, 0.129181E+01_JPRB, 0.128998E+01_JPRB, 0.128764E+01_JPRB, 0.128482E+01_JPRB &
  &, 0.128150E+01_JPRB, 0.127768E+01_JPRB, 0.127338E+01_JPRB &
  &, 0.126860E+01_JPRB, 0.126334E+01_JPRB, 0.125761E+01_JPRB, 0.125141E+01_JPRB &
  &, 0.124477E+01_JPRB, 0.123766E+01_JPRB, 0.123011E+01_JPRB &
  &, 0.122213E+01_JPRB, 0.121373E+01_JPRB, 0.120491E+01_JPRB, 0.119568E+01_JPRB &
  &, 0.118606E+01_JPRB, 0.117605E+01_JPRB, 0.116567E+01_JPRB &
  &, 0.115492E+01_JPRB, 0.114382E+01_JPRB, 0.113237E+01_JPRB, 0.112060E+01_JPRB &
  &, 0.110852E+01_JPRB, 0.109613E+01_JPRB, 0.108343E+01_JPRB &
  &, 0.107048E+01_JPRB, 0.105724E+01_JPRB, 0.104376E+01_JPRB, 0.103003E+01_JPRB &
  &, 0.101610E+01_JPRB, 0.100193E+01_JPRB, 0.987556E+00_JPRB &
  &, 0.973016E+00_JPRB, 0.958299E+00_JPRB, 0.943419E+00_JPRB, 0.928411E+00_JPRB &
  &, 0.913243E+00_JPRB, 0.897972E+00_JPRB, 0.882611E+00_JPRB &
  &, 0.867150E+00_JPRB, 0.851600E+00_JPRB, 0.835996E+00_JPRB, 0.820351E+00_JPRB &
  &, 0.804649E+00_JPRB, 0.788926E+00_JPRB, 0.773219E+00_JPRB &
  &, 0.757484E+00_JPRB, 0.741755E+00_JPRB, 0.726069E+00_JPRB, 0.710405E+00_JPRB &
  &, 0.694799E+00_JPRB, 0.679256E+00_JPRB, 0.663782E+00_JPRB &
  &, 0.648382E+00_JPRB, 0.633057E+00_JPRB, 0.617843E+00_JPRB, 0.602742E+00_JPRB &
  &, 0.587755E+00_JPRB, 0.572915E+00_JPRB, 0.558188E+00_JPRB &
  &, 0.543642E+00_JPRB, 0.529203E+00_JPRB, 0.514974E+00_JPRB, 0.500880E+00_JPRB &
  &, 0.486948E+00_JPRB, 0.473212E+00_JPRB, 0.459702E+00_JPRB &
  &, 0.446331E+00_JPRB, 0.433167E+00_JPRB, 0.420240E+00_JPRB, 0.407497E+00_JPRB &
  &, 0.394966E+00_JPRB, 0.382675E+00_JPRB, 0.370564E+00_JPRB &
  &, 0.358704E+00_JPRB, 0.347077E+00_JPRB, 0.335663E+00_JPRB, 0.324489E+00_JPRB &
  &, 0.313530E+00_JPRB, 0.302813E+00_JPRB, 0.292360E+00_JPRB &
  &, 0.282097E+00_JPRB, 0.272096E+00_JPRB, 0.262329E+00_JPRB, 0.252819E+00_JPRB &
  &, 0.243534E+00_JPRB, 0.234441E+00_JPRB, 0.225668E+00_JPRB &
  &, 0.217074E+00_JPRB, 0.208730E+00_JPRB, 0.200600E+00_JPRB, 0.192702E+00_JPRB &
  &, 0.184995E+00_JPRB, 0.177555E+00_JPRB, 0.170339E+00_JPRB &
  &, 0.163365E+00_JPRB, 0.156588E+00_JPRB, 0.149960E+00_JPRB, 0.143620E+00_JPRB &
  &, 0.137457E+00_JPRB, 0.131550E+00_JPRB, 0.125781E+00_JPRB/)
XCW( 726, :) = (/ &
  &  0.105775E+01_JPRB, 0.107145E+01_JPRB, 0.108482E+01_JPRB, 0.109788E+01_JPRB &
  &, 0.111059E+01_JPRB, 0.112296E+01_JPRB, 0.113498E+01_JPRB &
  &, 0.114663E+01_JPRB, 0.115791E+01_JPRB, 0.116881E+01_JPRB, 0.117932E+01_JPRB &
  &, 0.118943E+01_JPRB, 0.119914E+01_JPRB, 0.120843E+01_JPRB &
  &, 0.121730E+01_JPRB, 0.122574E+01_JPRB, 0.123374E+01_JPRB, 0.124130E+01_JPRB &
  &, 0.124840E+01_JPRB, 0.125505E+01_JPRB, 0.126124E+01_JPRB &
  &, 0.126695E+01_JPRB, 0.127219E+01_JPRB, 0.127695E+01_JPRB, 0.128123E+01_JPRB &
  &, 0.128501E+01_JPRB, 0.128830E+01_JPRB, 0.129110E+01_JPRB &
  &, 0.129340E+01_JPRB, 0.129519E+01_JPRB, 0.129648E+01_JPRB, 0.129727E+01_JPRB &
  &, 0.129755E+01_JPRB, 0.129733E+01_JPRB, 0.129660E+01_JPRB &
  &, 0.129536E+01_JPRB, 0.129362E+01_JPRB, 0.129138E+01_JPRB, 0.128865E+01_JPRB &
  &, 0.128541E+01_JPRB, 0.128168E+01_JPRB, 0.127747E+01_JPRB &
  &, 0.127277E+01_JPRB, 0.126760E+01_JPRB, 0.126195E+01_JPRB, 0.125584E+01_JPRB &
  &, 0.124926E+01_JPRB, 0.124224E+01_JPRB, 0.123477E+01_JPRB &
  &, 0.122686E+01_JPRB, 0.121851E+01_JPRB, 0.120978E+01_JPRB, 0.120062E+01_JPRB &
  &, 0.119102E+01_JPRB, 0.118112E+01_JPRB, 0.117080E+01_JPRB &
  &, 0.116011E+01_JPRB, 0.114907E+01_JPRB, 0.113768E+01_JPRB, 0.112596E+01_JPRB &
  &, 0.111392E+01_JPRB, 0.110158E+01_JPRB, 0.108893E+01_JPRB &
  &, 0.107601E+01_JPRB, 0.106283E+01_JPRB, 0.104939E+01_JPRB, 0.103569E+01_JPRB &
  &, 0.102178E+01_JPRB, 0.100765E+01_JPRB, 0.993297E+00_JPRB &
  &, 0.978773E+00_JPRB, 0.964091E+00_JPRB, 0.949223E+00_JPRB, 0.934223E+00_JPRB &
  &, 0.919082E+00_JPRB, 0.903814E+00_JPRB, 0.888453E+00_JPRB &
  &, 0.872988E+00_JPRB, 0.857454E+00_JPRB, 0.841840E+00_JPRB, 0.826181E+00_JPRB &
  &, 0.810487E+00_JPRB, 0.794770E+00_JPRB, 0.779012E+00_JPRB &
  &, 0.763276E+00_JPRB, 0.747544E+00_JPRB, 0.731822E+00_JPRB, 0.716148E+00_JPRB &
  &, 0.700498E+00_JPRB, 0.684907E+00_JPRB, 0.669412E+00_JPRB &
  &, 0.653955E+00_JPRB, 0.638634E+00_JPRB, 0.623355E+00_JPRB, 0.608218E+00_JPRB &
  &, 0.593191E+00_JPRB, 0.578308E+00_JPRB, 0.563534E+00_JPRB &
  &, 0.548901E+00_JPRB, 0.534442E+00_JPRB, 0.520118E+00_JPRB, 0.505959E+00_JPRB &
  &, 0.491998E+00_JPRB, 0.478229E+00_JPRB, 0.464604E+00_JPRB &
  &, 0.451192E+00_JPRB, 0.437984E+00_JPRB, 0.424970E+00_JPRB, 0.412134E+00_JPRB &
  &, 0.399548E+00_JPRB, 0.387155E+00_JPRB, 0.374673E+00_JPRB &
  &, 0.363056E+00_JPRB, 0.351360E+00_JPRB, 0.339874E+00_JPRB, 0.328622E+00_JPRB &
  &, 0.317584E+00_JPRB, 0.306782E+00_JPRB, 0.296241E+00_JPRB &
  &, 0.285936E+00_JPRB, 0.275840E+00_JPRB, 0.265974E+00_JPRB, 0.256360E+00_JPRB &
  &, 0.247021E+00_JPRB, 0.237871E+00_JPRB, 0.228984E+00_JPRB &
  &, 0.220327E+00_JPRB, 0.211861E+00_JPRB, 0.203662E+00_JPRB, 0.195691E+00_JPRB &
  &, 0.187968E+00_JPRB, 0.180450E+00_JPRB, 0.173154E+00_JPRB &
  &, 0.166036E+00_JPRB, 0.159172E+00_JPRB, 0.152517E+00_JPRB, 0.146084E+00_JPRB &
  &, 0.139890E+00_JPRB, 0.133820E+00_JPRB, 0.128015E+00_JPRB/)
XCW( 727, :) = (/ &
  &  0.105806E+01_JPRB, 0.107184E+01_JPRB, 0.108530E+01_JPRB, 0.109844E+01_JPRB &
  &, 0.111124E+01_JPRB, 0.112370E+01_JPRB, 0.113580E+01_JPRB &
  &, 0.114754E+01_JPRB, 0.115891E+01_JPRB, 0.116990E+01_JPRB, 0.118049E+01_JPRB &
  &, 0.119070E+01_JPRB, 0.120050E+01_JPRB, 0.120989E+01_JPRB &
  &, 0.121885E+01_JPRB, 0.122738E+01_JPRB, 0.123548E+01_JPRB, 0.124313E+01_JPRB &
  &, 0.125034E+01_JPRB, 0.125708E+01_JPRB, 0.126336E+01_JPRB &
  &, 0.126917E+01_JPRB, 0.127451E+01_JPRB, 0.127937E+01_JPRB, 0.128374E+01_JPRB &
  &, 0.128762E+01_JPRB, 0.129101E+01_JPRB, 0.129391E+01_JPRB &
  &, 0.129630E+01_JPRB, 0.129819E+01_JPRB, 0.129958E+01_JPRB, 0.130046E+01_JPRB &
  &, 0.130084E+01_JPRB, 0.130071E+01_JPRB, 0.130007E+01_JPRB &
  &, 0.129893E+01_JPRB, 0.129728E+01_JPRB, 0.129513E+01_JPRB, 0.129248E+01_JPRB &
  &, 0.128933E+01_JPRB, 0.128570E+01_JPRB, 0.128157E+01_JPRB &
  &, 0.127696E+01_JPRB, 0.127187E+01_JPRB, 0.126630E+01_JPRB, 0.126027E+01_JPRB &
  &, 0.125377E+01_JPRB, 0.124683E+01_JPRB, 0.123944E+01_JPRB &
  &, 0.123161E+01_JPRB, 0.122335E+01_JPRB, 0.121467E+01_JPRB, 0.120557E+01_JPRB &
  &, 0.119609E+01_JPRB, 0.118621E+01_JPRB, 0.117595E+01_JPRB &
  &, 0.116532E+01_JPRB, 0.115435E+01_JPRB, 0.114302E+01_JPRB, 0.113134E+01_JPRB &
  &, 0.111935E+01_JPRB, 0.110706E+01_JPRB, 0.109447E+01_JPRB &
  &, 0.108159E+01_JPRB, 0.106843E+01_JPRB, 0.105504E+01_JPRB, 0.104138E+01_JPRB &
  &, 0.102750E+01_JPRB, 0.101339E+01_JPRB, 0.999079E+00_JPRB &
  &, 0.984572E+00_JPRB, 0.969905E+00_JPRB, 0.955070E+00_JPRB, 0.940079E+00_JPRB &
  &, 0.924945E+00_JPRB, 0.909703E+00_JPRB, 0.894342E+00_JPRB &
  &, 0.878873E+00_JPRB, 0.863334E+00_JPRB, 0.847735E+00_JPRB, 0.832062E+00_JPRB &
  &, 0.816352E+00_JPRB, 0.800615E+00_JPRB, 0.784860E+00_JPRB &
  &, 0.769096E+00_JPRB, 0.753361E+00_JPRB, 0.737604E+00_JPRB, 0.721920E+00_JPRB &
  &, 0.706226E+00_JPRB, 0.690619E+00_JPRB, 0.675072E+00_JPRB &
  &, 0.659623E+00_JPRB, 0.644210E+00_JPRB, 0.628933E+00_JPRB, 0.613728E+00_JPRB &
  &, 0.598662E+00_JPRB, 0.583736E+00_JPRB, 0.568915E+00_JPRB &
  &, 0.554232E+00_JPRB, 0.539718E+00_JPRB, 0.525335E+00_JPRB, 0.511114E+00_JPRB &
  &, 0.497086E+00_JPRB, 0.483245E+00_JPRB, 0.469584E+00_JPRB &
  &, 0.456094E+00_JPRB, 0.442802E+00_JPRB, 0.429699E+00_JPRB, 0.416855E+00_JPRB &
  &, 0.404173E+00_JPRB, 0.391723E+00_JPRB, 0.379489E+00_JPRB &
  &, 0.367453E+00_JPRB, 0.355689E+00_JPRB, 0.344130E+00_JPRB, 0.332803E+00_JPRB &
  &, 0.321684E+00_JPRB, 0.310799E+00_JPRB, 0.300171E+00_JPRB &
  &, 0.289775E+00_JPRB, 0.279634E+00_JPRB, 0.269670E+00_JPRB, 0.260006E+00_JPRB &
  &, 0.250561E+00_JPRB, 0.241355E+00_JPRB, 0.232355E+00_JPRB &
  &, 0.223580E+00_JPRB, 0.215104E+00_JPRB, 0.206780E+00_JPRB, 0.198738E+00_JPRB &
  &, 0.190940E+00_JPRB, 0.183345E+00_JPRB, 0.175969E+00_JPRB &
  &, 0.168768E+00_JPRB, 0.161879E+00_JPRB, 0.155135E+00_JPRB, 0.148612E+00_JPRB &
  &, 0.142323E+00_JPRB, 0.136220E+00_JPRB, 0.130315E+00_JPRB/)
XCW( 728, :) = (/ &
  &  0.105837E+01_JPRB, 0.107223E+01_JPRB, 0.108578E+01_JPRB, 0.109900E+01_JPRB &
  &, 0.111188E+01_JPRB, 0.112443E+01_JPRB, 0.113662E+01_JPRB &
  &, 0.114845E+01_JPRB, 0.115991E+01_JPRB, 0.117099E+01_JPRB, 0.118168E+01_JPRB &
  &, 0.119198E+01_JPRB, 0.120187E+01_JPRB, 0.121135E+01_JPRB &
  &, 0.122040E+01_JPRB, 0.122903E+01_JPRB, 0.123722E+01_JPRB, 0.124497E+01_JPRB &
  &, 0.125227E+01_JPRB, 0.125911E+01_JPRB, 0.126549E+01_JPRB &
  &, 0.127140E+01_JPRB, 0.127683E+01_JPRB, 0.128179E+01_JPRB, 0.128626E+01_JPRB &
  &, 0.129024E+01_JPRB, 0.129373E+01_JPRB, 0.129672E+01_JPRB &
  &, 0.129921E+01_JPRB, 0.130120E+01_JPRB, 0.130268E+01_JPRB, 0.130366E+01_JPRB &
  &, 0.130413E+01_JPRB, 0.130409E+01_JPRB, 0.130355E+01_JPRB &
  &, 0.130250E+01_JPRB, 0.130094E+01_JPRB, 0.129889E+01_JPRB, 0.129634E+01_JPRB &
  &, 0.129328E+01_JPRB, 0.128972E+01_JPRB, 0.128535E+01_JPRB &
  &, 0.128116E+01_JPRB, 0.127616E+01_JPRB, 0.127067E+01_JPRB, 0.126472E+01_JPRB &
  &, 0.125830E+01_JPRB, 0.125144E+01_JPRB, 0.124413E+01_JPRB &
  &, 0.123638E+01_JPRB, 0.122819E+01_JPRB, 0.121958E+01_JPRB, 0.121056E+01_JPRB &
  &, 0.120115E+01_JPRB, 0.119133E+01_JPRB, 0.118113E+01_JPRB &
  &, 0.117056E+01_JPRB, 0.115964E+01_JPRB, 0.114837E+01_JPRB, 0.113675E+01_JPRB &
  &, 0.112482E+01_JPRB, 0.111257E+01_JPRB, 0.110003E+01_JPRB &
  &, 0.108719E+01_JPRB, 0.107409E+01_JPRB, 0.106071E+01_JPRB, 0.104710E+01_JPRB &
  &, 0.103324E+01_JPRB, 0.101917E+01_JPRB, 0.100488E+01_JPRB &
  &, 0.990413E+00_JPRB, 0.975762E+00_JPRB, 0.960939E+00_JPRB, 0.945958E+00_JPRB &
  &, 0.930853E+00_JPRB, 0.915615E+00_JPRB, 0.900254E+00_JPRB &
  &, 0.884808E+00_JPRB, 0.869263E+00_JPRB, 0.853655E+00_JPRB, 0.837996E+00_JPRB &
  &, 0.822270E+00_JPRB, 0.806540E+00_JPRB, 0.790762E+00_JPRB &
  &, 0.774972E+00_JPRB, 0.759206E+00_JPRB, 0.743443E+00_JPRB, 0.727721E+00_JPRB &
  &, 0.712015E+00_JPRB, 0.696392E+00_JPRB, 0.680795E+00_JPRB &
  &, 0.665291E+00_JPRB, 0.649883E+00_JPRB, 0.634543E+00_JPRB, 0.619304E+00_JPRB &
  &, 0.604200E+00_JPRB, 0.589198E+00_JPRB, 0.574331E+00_JPRB &
  &, 0.559598E+00_JPRB, 0.545031E+00_JPRB, 0.530590E+00_JPRB, 0.516344E+00_JPRB &
  &, 0.502250E+00_JPRB, 0.488301E+00_JPRB, 0.474565E+00_JPRB &
  &, 0.461035E+00_JPRB, 0.447702E+00_JPRB, 0.434512E+00_JPRB, 0.421576E+00_JPRB &
  &, 0.408841E+00_JPRB, 0.396334E+00_JPRB, 0.383995E+00_JPRB &
  &, 0.371896E+00_JPRB, 0.360063E+00_JPRB, 0.348433E+00_JPRB, 0.336983E+00_JPRB &
  &, 0.325833E+00_JPRB, 0.314865E+00_JPRB, 0.304150E+00_JPRB &
  &, 0.293664E+00_JPRB, 0.283429E+00_JPRB, 0.273418E+00_JPRB, 0.263652E+00_JPRB &
  &, 0.254154E+00_JPRB, 0.244839E+00_JPRB, 0.235780E+00_JPRB &
  &, 0.226943E+00_JPRB, 0.218347E+00_JPRB, 0.210012E+00_JPRB, 0.201842E+00_JPRB &
  &, 0.193971E+00_JPRB, 0.186240E+00_JPRB, 0.178784E+00_JPRB &
  &, 0.171560E+00_JPRB, 0.164586E+00_JPRB, 0.157754E+00_JPRB, 0.151202E+00_JPRB &
  &, 0.144820E+00_JPRB, 0.138620E+00_JPRB, 0.132681E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART104',1,ZHOOK_HANDLE)
END SUBROUTINE PART104

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART105

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART105',0,ZHOOK_HANDLE)

XCW( 729, :) = (/ &
  &  0.105869E+01_JPRB, 0.107263E+01_JPRB, 0.108626E+01_JPRB, 0.109956E+01_JPRB &
  &, 0.111253E+01_JPRB, 0.112516E+01_JPRB, 0.113744E+01_JPRB &
  &, 0.114936E+01_JPRB, 0.116091E+01_JPRB, 0.117208E+01_JPRB, 0.118287E+01_JPRB &
  &, 0.119325E+01_JPRB, 0.120324E+01_JPRB, 0.121281E+01_JPRB &
  &, 0.122196E+01_JPRB, 0.123069E+01_JPRB, 0.123897E+01_JPRB, 0.124682E+01_JPRB &
  &, 0.125421E+01_JPRB, 0.126115E+01_JPRB, 0.126763E+01_JPRB &
  &, 0.127363E+01_JPRB, 0.127917E+01_JPRB, 0.128422E+01_JPRB, 0.128878E+01_JPRB &
  &, 0.129287E+01_JPRB, 0.129645E+01_JPRB, 0.129954E+01_JPRB &
  &, 0.130213E+01_JPRB, 0.130421E+01_JPRB, 0.130579E+01_JPRB, 0.130687E+01_JPRB &
  &, 0.130744E+01_JPRB, 0.130750E+01_JPRB, 0.130705E+01_JPRB &
  &, 0.130609E+01_JPRB, 0.130464E+01_JPRB, 0.130266E+01_JPRB, 0.130020E+01_JPRB &
  &, 0.129724E+01_JPRB, 0.129377E+01_JPRB, 0.128982E+01_JPRB &
  &, 0.128539E+01_JPRB, 0.128046E+01_JPRB, 0.127507E+01_JPRB, 0.126920E+01_JPRB &
  &, 0.126286E+01_JPRB, 0.125607E+01_JPRB, 0.124884E+01_JPRB &
  &, 0.124116E+01_JPRB, 0.123306E+01_JPRB, 0.122451E+01_JPRB, 0.121557E+01_JPRB &
  &, 0.120622E+01_JPRB, 0.119646E+01_JPRB, 0.118634E+01_JPRB &
  &, 0.117583E+01_JPRB, 0.116497E+01_JPRB, 0.115374E+01_JPRB, 0.114219E+01_JPRB &
  &, 0.113032E+01_JPRB, 0.111811E+01_JPRB, 0.110560E+01_JPRB &
  &, 0.109282E+01_JPRB, 0.107976E+01_JPRB, 0.106643E+01_JPRB, 0.105285E+01_JPRB &
  &, 0.103904E+01_JPRB, 0.102498E+01_JPRB, 0.101073E+01_JPRB &
  &, 0.996276E+00_JPRB, 0.981662E+00_JPRB, 0.966852E+00_JPRB, 0.951904E+00_JPRB &
  &, 0.936784E+00_JPRB, 0.921574E+00_JPRB, 0.906215E+00_JPRB &
  &, 0.890767E+00_JPRB, 0.875241E+00_JPRB, 0.859626E+00_JPRB, 0.843955E+00_JPRB &
  &, 0.828240E+00_JPRB, 0.812465E+00_JPRB, 0.796692E+00_JPRB &
  &, 0.780904E+00_JPRB, 0.765108E+00_JPRB, 0.749312E+00_JPRB, 0.733581E+00_JPRB &
  &, 0.717864E+00_JPRB, 0.702195E+00_JPRB, 0.686580E+00_JPRB &
  &, 0.671022E+00_JPRB, 0.655557E+00_JPRB, 0.640186E+00_JPRB, 0.624914E+00_JPRB &
  &, 0.609772E+00_JPRB, 0.594695E+00_JPRB, 0.579783E+00_JPRB &
  &, 0.564964E+00_JPRB, 0.550379E+00_JPRB, 0.535918E+00_JPRB, 0.521574E+00_JPRB &
  &, 0.507414E+00_JPRB, 0.493434E+00_JPRB, 0.479665E+00_JPRB &
  &, 0.466017E+00_JPRB, 0.452601E+00_JPRB, 0.439407E+00_JPRB, 0.426381E+00_JPRB &
  &, 0.413551E+00_JPRB, 0.400988E+00_JPRB, 0.388590E+00_JPRB &
  &, 0.376428E+00_JPRB, 0.364483E+00_JPRB, 0.352782E+00_JPRB, 0.341258E+00_JPRB &
  &, 0.330029E+00_JPRB, 0.318979E+00_JPRB, 0.308178E+00_JPRB &
  &, 0.297652E+00_JPRB, 0.287324E+00_JPRB, 0.277216E+00_JPRB, 0.267350E+00_JPRB &
  &, 0.257747E+00_JPRB, 0.248376E+00_JPRB, 0.239259E+00_JPRB &
  &, 0.230306E+00_JPRB, 0.221646E+00_JPRB, 0.213187E+00_JPRB, 0.205004E+00_JPRB &
  &, 0.197001E+00_JPRB, 0.189253E+00_JPRB, 0.181719E+00_JPRB &
  &, 0.174414E+00_JPRB, 0.167294E+00_JPRB, 0.160435E+00_JPRB, 0.153792E+00_JPRB &
  &, 0.147316E+00_JPRB, 0.141084E+00_JPRB, 0.135046E+00_JPRB/)
XCW( 730, :) = (/ &
  &  0.105900E+01_JPRB, 0.107302E+01_JPRB, 0.108674E+01_JPRB, 0.110012E+01_JPRB &
  &, 0.111318E+01_JPRB, 0.112590E+01_JPRB, 0.113827E+01_JPRB &
  &, 0.115028E+01_JPRB, 0.116191E+01_JPRB, 0.117318E+01_JPRB, 0.118405E+01_JPRB &
  &, 0.119453E+01_JPRB, 0.120461E+01_JPRB, 0.121428E+01_JPRB &
  &, 0.122352E+01_JPRB, 0.123234E+01_JPRB, 0.124073E+01_JPRB, 0.124867E+01_JPRB &
  &, 0.125616E+01_JPRB, 0.126320E+01_JPRB, 0.126977E+01_JPRB &
  &, 0.127588E+01_JPRB, 0.128151E+01_JPRB, 0.128666E+01_JPRB, 0.129132E+01_JPRB &
  &, 0.129550E+01_JPRB, 0.129918E+01_JPRB, 0.130237E+01_JPRB &
  &, 0.130506E+01_JPRB, 0.130724E+01_JPRB, 0.130892E+01_JPRB, 0.131009E+01_JPRB &
  &, 0.131075E+01_JPRB, 0.131091E+01_JPRB, 0.131056E+01_JPRB &
  &, 0.130970E+01_JPRB, 0.130833E+01_JPRB, 0.130646E+01_JPRB, 0.130409E+01_JPRB &
  &, 0.130120E+01_JPRB, 0.129784E+01_JPRB, 0.129397E+01_JPRB &
  &, 0.128962E+01_JPRB, 0.128478E+01_JPRB, 0.127948E+01_JPRB, 0.127369E+01_JPRB &
  &, 0.126744E+01_JPRB, 0.126073E+01_JPRB, 0.125357E+01_JPRB &
  &, 0.124597E+01_JPRB, 0.123793E+01_JPRB, 0.122948E+01_JPRB, 0.122059E+01_JPRB &
  &, 0.121132E+01_JPRB, 0.120163E+01_JPRB, 0.119156E+01_JPRB &
  &, 0.118113E+01_JPRB, 0.117032E+01_JPRB, 0.115916E+01_JPRB, 0.114765E+01_JPRB &
  &, 0.113583E+01_JPRB, 0.112368E+01_JPRB, 0.111123E+01_JPRB &
  &, 0.109848E+01_JPRB, 0.108546E+01_JPRB, 0.107218E+01_JPRB, 0.105862E+01_JPRB &
  &, 0.104483E+01_JPRB, 0.103084E+01_JPRB, 0.101661E+01_JPRB &
  &, 0.100218E+01_JPRB, 0.987583E+00_JPRB, 0.972788E+00_JPRB, 0.957850E+00_JPRB &
  &, 0.942761E+00_JPRB, 0.927556E+00_JPRB, 0.912223E+00_JPRB &
  &, 0.896774E+00_JPRB, 0.881245E+00_JPRB, 0.865647E+00_JPRB, 0.849966E+00_JPRB &
  &, 0.834237E+00_JPRB, 0.818471E+00_JPRB, 0.802676E+00_JPRB &
  &, 0.786863E+00_JPRB, 0.771038E+00_JPRB, 0.755238E+00_JPRB, 0.739470E+00_JPRB &
  &, 0.723712E+00_JPRB, 0.708029E+00_JPRB, 0.692334E+00_JPRB &
  &, 0.676817E+00_JPRB, 0.661294E+00_JPRB, 0.645895E+00_JPRB, 0.630590E+00_JPRB &
  &, 0.615379E+00_JPRB, 0.600295E+00_JPRB, 0.585304E+00_JPRB &
  &, 0.570473E+00_JPRB, 0.555801E+00_JPRB, 0.541246E+00_JPRB, 0.526879E+00_JPRB &
  &, 0.512655E+00_JPRB, 0.498645E+00_JPRB, 0.484764E+00_JPRB &
  &, 0.471079E+00_JPRB, 0.457583E+00_JPRB, 0.444303E+00_JPRB, 0.431229E+00_JPRB &
  &, 0.418347E+00_JPRB, 0.405686E+00_JPRB, 0.393229E+00_JPRB &
  &, 0.380959E+00_JPRB, 0.368948E+00_JPRB, 0.357177E+00_JPRB, 0.345579E+00_JPRB &
  &, 0.334273E+00_JPRB, 0.323141E+00_JPRB, 0.312256E+00_JPRB &
  &, 0.301641E+00_JPRB, 0.291220E+00_JPRB, 0.281066E+00_JPRB, 0.271152E+00_JPRB &
  &, 0.261445E+00_JPRB, 0.251967E+00_JPRB, 0.242738E+00_JPRB &
  &, 0.233779E+00_JPRB, 0.225000E+00_JPRB, 0.216475E+00_JPRB, 0.208166E+00_JPRB &
  &, 0.200032E+00_JPRB, 0.192266E+00_JPRB, 0.184653E+00_JPRB &
  &, 0.177267E+00_JPRB, 0.170124E+00_JPRB, 0.163178E+00_JPRB, 0.156383E+00_JPRB &
  &, 0.149877E+00_JPRB, 0.143549E+00_JPRB, 0.137478E+00_JPRB/)
XCW( 731, :) = (/ &
  &  0.105932E+01_JPRB, 0.107342E+01_JPRB, 0.108722E+01_JPRB, 0.110069E+01_JPRB &
  &, 0.111383E+01_JPRB, 0.112664E+01_JPRB, 0.113909E+01_JPRB &
  &, 0.115119E+01_JPRB, 0.116292E+01_JPRB, 0.117427E+01_JPRB, 0.118524E+01_JPRB &
  &, 0.119582E+01_JPRB, 0.120599E+01_JPRB, 0.121575E+01_JPRB &
  &, 0.122509E+01_JPRB, 0.123401E+01_JPRB, 0.124249E+01_JPRB, 0.125053E+01_JPRB &
  &, 0.125812E+01_JPRB, 0.126525E+01_JPRB, 0.127192E+01_JPRB &
  &, 0.127812E+01_JPRB, 0.128386E+01_JPRB, 0.128910E+01_JPRB, 0.129387E+01_JPRB &
  &, 0.129814E+01_JPRB, 0.130193E+01_JPRB, 0.130521E+01_JPRB &
  &, 0.130800E+01_JPRB, 0.131028E+01_JPRB, 0.131205E+01_JPRB, 0.131332E+01_JPRB &
  &, 0.131408E+01_JPRB, 0.131434E+01_JPRB, 0.131408E+01_JPRB &
  &, 0.131328E+01_JPRB, 0.131204E+01_JPRB, 0.131026E+01_JPRB, 0.130798E+01_JPRB &
  &, 0.130519E+01_JPRB, 0.130192E+01_JPRB, 0.129814E+01_JPRB &
  &, 0.129388E+01_JPRB, 0.128913E+01_JPRB, 0.128390E+01_JPRB, 0.127820E+01_JPRB &
  &, 0.127204E+01_JPRB, 0.126540E+01_JPRB, 0.125833E+01_JPRB &
  &, 0.125080E+01_JPRB, 0.124284E+01_JPRB, 0.123445E+01_JPRB, 0.122565E+01_JPRB &
  &, 0.121643E+01_JPRB, 0.120682E+01_JPRB, 0.119682E+01_JPRB &
  &, 0.118644E+01_JPRB, 0.117569E+01_JPRB, 0.116460E+01_JPRB, 0.115315E+01_JPRB &
  &, 0.114137E+01_JPRB, 0.112927E+01_JPRB, 0.111687E+01_JPRB &
  &, 0.110418E+01_JPRB, 0.109119E+01_JPRB, 0.107794E+01_JPRB, 0.106444E+01_JPRB &
  &, 0.105069E+01_JPRB, 0.103672E+01_JPRB, 0.102252E+01_JPRB &
  &, 0.100813E+01_JPRB, 0.993547E+00_JPRB, 0.978789E+00_JPRB, 0.963863E+00_JPRB &
  &, 0.948784E+00_JPRB, 0.933585E+00_JPRB, 0.918255E+00_JPRB &
  &, 0.902830E+00_JPRB, 0.887298E+00_JPRB, 0.871693E+00_JPRB, 0.856002E+00_JPRB &
  &, 0.840260E+00_JPRB, 0.824503E+00_JPRB, 0.808688E+00_JPRB &
  &, 0.792850E+00_JPRB, 0.777025E+00_JPRB, 0.761222E+00_JPRB, 0.745419E+00_JPRB &
  &, 0.729651E+00_JPRB, 0.713924E+00_JPRB, 0.698243E+00_JPRB &
  &, 0.682643E+00_JPRB, 0.667096E+00_JPRB, 0.651637E+00_JPRB, 0.636300E+00_JPRB &
  &, 0.621019E+00_JPRB, 0.605896E+00_JPRB, 0.590896E+00_JPRB &
  &, 0.576018E+00_JPRB, 0.561259E+00_JPRB, 0.546612E+00_JPRB, 0.532222E+00_JPRB &
  &, 0.517973E+00_JPRB, 0.503856E+00_JPRB, 0.489942E+00_JPRB &
  &, 0.476182E+00_JPRB, 0.462645E+00_JPRB, 0.449281E+00_JPRB, 0.436119E+00_JPRB &
  &, 0.423144E+00_JPRB, 0.410427E+00_JPRB, 0.397868E+00_JPRB &
  &, 0.385581E+00_JPRB, 0.373459E+00_JPRB, 0.361618E+00_JPRB, 0.349947E+00_JPRB &
  &, 0.338564E+00_JPRB, 0.327352E+00_JPRB, 0.316431E+00_JPRB &
  &, 0.305679E+00_JPRB, 0.295217E+00_JPRB, 0.284968E+00_JPRB, 0.274954E+00_JPRB &
  &, 0.265144E+00_JPRB, 0.255612E+00_JPRB, 0.246326E+00_JPRB &
  &, 0.237253E+00_JPRB, 0.228411E+00_JPRB, 0.219820E+00_JPRB, 0.211442E+00_JPRB &
  &, 0.203296E+00_JPRB, 0.195339E+00_JPRB, 0.187648E+00_JPRB &
  &, 0.180180E+00_JPRB, 0.172954E+00_JPRB, 0.165922E+00_JPRB, 0.159100E+00_JPRB &
  &, 0.152502E+00_JPRB, 0.146079E+00_JPRB, 0.139909E+00_JPRB/)
XCW( 732, :) = (/ &
  &  0.105963E+01_JPRB, 0.107382E+01_JPRB, 0.108770E+01_JPRB, 0.110126E+01_JPRB &
  &, 0.111449E+01_JPRB, 0.112738E+01_JPRB, 0.113992E+01_JPRB &
  &, 0.115211E+01_JPRB, 0.116393E+01_JPRB, 0.117537E+01_JPRB, 0.118644E+01_JPRB &
  &, 0.119710E+01_JPRB, 0.120737E+01_JPRB, 0.121722E+01_JPRB &
  &, 0.122666E+01_JPRB, 0.123567E+01_JPRB, 0.124425E+01_JPRB, 0.125239E+01_JPRB &
  &, 0.126008E+01_JPRB, 0.126731E+01_JPRB, 0.127408E+01_JPRB &
  &, 0.128038E+01_JPRB, 0.128621E+01_JPRB, 0.129156E+01_JPRB, 0.129642E+01_JPRB &
  &, 0.130079E+01_JPRB, 0.130468E+01_JPRB, 0.130806E+01_JPRB &
  &, 0.131094E+01_JPRB, 0.131333E+01_JPRB, 0.131520E+01_JPRB, 0.131657E+01_JPRB &
  &, 0.131742E+01_JPRB, 0.131777E+01_JPRB, 0.131761E+01_JPRB &
  &, 0.131694E+01_JPRB, 0.131576E+01_JPRB, 0.131408E+01_JPRB, 0.131189E+01_JPRB &
  &, 0.130920E+01_JPRB, 0.130601E+01_JPRB, 0.130229E+01_JPRB &
  &, 0.129814E+01_JPRB, 0.129349E+01_JPRB, 0.128834E+01_JPRB, 0.128274E+01_JPRB &
  &, 0.127664E+01_JPRB, 0.127010E+01_JPRB, 0.126310E+01_JPRB &
  &, 0.125565E+01_JPRB, 0.124777E+01_JPRB, 0.123946E+01_JPRB, 0.123073E+01_JPRB &
  &, 0.122158E+01_JPRB, 0.121203E+01_JPRB, 0.120210E+01_JPRB &
  &, 0.119178E+01_JPRB, 0.118110E+01_JPRB, 0.117006E+01_JPRB, 0.115867E+01_JPRB &
  &, 0.114695E+01_JPRB, 0.113491E+01_JPRB, 0.112255E+01_JPRB &
  &, 0.110989E+01_JPRB, 0.109696E+01_JPRB, 0.108376E+01_JPRB, 0.107029E+01_JPRB &
  &, 0.105657E+01_JPRB, 0.104263E+01_JPRB, 0.102846E+01_JPRB &
  &, 0.101410E+01_JPRB, 0.999533E+00_JPRB, 0.984812E+00_JPRB, 0.969899E+00_JPRB &
  &, 0.954852E+00_JPRB, 0.939660E+00_JPRB, 0.924335E+00_JPRB &
  &, 0.908911E+00_JPRB, 0.893376E+00_JPRB, 0.877765E+00_JPRB, 0.862090E+00_JPRB &
  &, 0.846361E+00_JPRB, 0.830562E+00_JPRB, 0.814754E+00_JPRB &
  &, 0.798921E+00_JPRB, 0.783069E+00_JPRB, 0.767235E+00_JPRB, 0.751397E+00_JPRB &
  &, 0.735619E+00_JPRB, 0.719850E+00_JPRB, 0.704152E+00_JPRB &
  &, 0.688501E+00_JPRB, 0.672931E+00_JPRB, 0.657444E+00_JPRB, 0.642043E+00_JPRB &
  &, 0.626761E+00_JPRB, 0.611565E+00_JPRB, 0.596488E+00_JPRB &
  &, 0.581564E+00_JPRB, 0.566789E+00_JPRB, 0.552125E+00_JPRB, 0.537640E+00_JPRB &
  &, 0.523290E+00_JPRB, 0.509145E+00_JPRB, 0.495160E+00_JPRB &
  &, 0.481324E+00_JPRB, 0.467708E+00_JPRB, 0.454302E+00_JPRB, 0.441050E+00_JPRB &
  &, 0.428025E+00_JPRB, 0.415212E+00_JPRB, 0.402596E+00_JPRB &
  &, 0.390248E+00_JPRB, 0.378061E+00_JPRB, 0.366106E+00_JPRB, 0.354410E+00_JPRB &
  &, 0.342904E+00_JPRB, 0.331612E+00_JPRB, 0.320607E+00_JPRB &
  &, 0.309817E+00_JPRB, 0.299214E+00_JPRB, 0.288921E+00_JPRB, 0.278808E+00_JPRB &
  &, 0.268948E+00_JPRB, 0.259310E+00_JPRB, 0.249914E+00_JPRB &
  &, 0.240781E+00_JPRB, 0.231822E+00_JPRB, 0.223165E+00_JPRB, 0.214719E+00_JPRB &
  &, 0.206501E+00_JPRB, 0.198470E+00_JPRB, 0.190702E+00_JPRB &
  &, 0.183155E+00_JPRB, 0.175845E+00_JPRB, 0.168728E+00_JPRB, 0.161816E+00_JPRB &
  &, 0.155126E+00_JPRB, 0.148673E+00_JPRB, 0.142406E+00_JPRB/)
XCW( 733, :) = (/ &
  &  0.105995E+01_JPRB, 0.107422E+01_JPRB, 0.108818E+01_JPRB, 0.110182E+01_JPRB &
  &, 0.111514E+01_JPRB, 0.112812E+01_JPRB, 0.114075E+01_JPRB &
  &, 0.115303E+01_JPRB, 0.116494E+01_JPRB, 0.117648E+01_JPRB, 0.118763E+01_JPRB &
  &, 0.119839E+01_JPRB, 0.120875E+01_JPRB, 0.121870E+01_JPRB &
  &, 0.122824E+01_JPRB, 0.123735E+01_JPRB, 0.124602E+01_JPRB, 0.125425E+01_JPRB &
  &, 0.126204E+01_JPRB, 0.126937E+01_JPRB, 0.127624E+01_JPRB &
  &, 0.128264E+01_JPRB, 0.128857E+01_JPRB, 0.129402E+01_JPRB, 0.129898E+01_JPRB &
  &, 0.130345E+01_JPRB, 0.130744E+01_JPRB, 0.131092E+01_JPRB &
  &, 0.131390E+01_JPRB, 0.131638E+01_JPRB, 0.131836E+01_JPRB, 0.131982E+01_JPRB &
  &, 0.132078E+01_JPRB, 0.132122E+01_JPRB, 0.132116E+01_JPRB &
  &, 0.132058E+01_JPRB, 0.131950E+01_JPRB, 0.131791E+01_JPRB, 0.131582E+01_JPRB &
  &, 0.131322E+01_JPRB, 0.131012E+01_JPRB, 0.130652E+01_JPRB &
  &, 0.130244E+01_JPRB, 0.129783E+01_JPRB, 0.129281E+01_JPRB, 0.128728E+01_JPRB &
  &, 0.128128E+01_JPRB, 0.127482E+01_JPRB, 0.126790E+01_JPRB &
  &, 0.126053E+01_JPRB, 0.125272E+01_JPRB, 0.124449E+01_JPRB, 0.123582E+01_JPRB &
  &, 0.122675E+01_JPRB, 0.121726E+01_JPRB, 0.120740E+01_JPRB &
  &, 0.119715E+01_JPRB, 0.118652E+01_JPRB, 0.117555E+01_JPRB, 0.116422E+01_JPRB &
  &, 0.115255E+01_JPRB, 0.114055E+01_JPRB, 0.112825E+01_JPRB &
  &, 0.111565E+01_JPRB, 0.110276E+01_JPRB, 0.108960E+01_JPRB, 0.107617E+01_JPRB &
  &, 0.106249E+01_JPRB, 0.104859E+01_JPRB, 0.103445E+01_JPRB &
  &, 0.102011E+01_JPRB, 0.100556E+01_JPRB, 0.990857E+00_JPRB, 0.975980E+00_JPRB &
  &, 0.960944E+00_JPRB, 0.945759E+00_JPRB, 0.930438E+00_JPRB &
  &, 0.915040E+00_JPRB, 0.899503E+00_JPRB, 0.883888E+00_JPRB, 0.868023E+00_JPRB &
  &, 0.852463E+00_JPRB, 0.836675E+00_JPRB, 0.820848E+00_JPRB &
  &, 0.804991E+00_JPRB, 0.789141E+00_JPRB, 0.773277E+00_JPRB, 0.757433E+00_JPRB &
  &, 0.741618E+00_JPRB, 0.725836E+00_JPRB, 0.710093E+00_JPRB &
  &, 0.694422E+00_JPRB, 0.678797E+00_JPRB, 0.663284E+00_JPRB, 0.647853E+00_JPRB &
  &, 0.632503E+00_JPRB, 0.617270E+00_JPRB, 0.602115E+00_JPRB &
  &, 0.587180E+00_JPRB, 0.572356E+00_JPRB, 0.557638E+00_JPRB, 0.543095E+00_JPRB &
  &, 0.528684E+00_JPRB, 0.514473E+00_JPRB, 0.500418E+00_JPRB &
  &, 0.486547E+00_JPRB, 0.472853E+00_JPRB, 0.459363E+00_JPRB, 0.446067E+00_JPRB &
  &, 0.432950E+00_JPRB, 0.420084E+00_JPRB, 0.407412E+00_JPRB &
  &, 0.394914E+00_JPRB, 0.382708E+00_JPRB, 0.370640E+00_JPRB, 0.358872E+00_JPRB &
  &, 0.347290E+00_JPRB, 0.335920E+00_JPRB, 0.324832E+00_JPRB &
  &, 0.313955E+00_JPRB, 0.303312E+00_JPRB, 0.292873E+00_JPRB, 0.282714E+00_JPRB &
  &, 0.272752E+00_JPRB, 0.263062E+00_JPRB, 0.253611E+00_JPRB &
  &, 0.244365E+00_JPRB, 0.235344E+00_JPRB, 0.226567E+00_JPRB, 0.218053E+00_JPRB &
  &, 0.209707E+00_JPRB, 0.201661E+00_JPRB, 0.193816E+00_JPRB &
  &, 0.186130E+00_JPRB, 0.178737E+00_JPRB, 0.171533E+00_JPRB, 0.164596E+00_JPRB &
  &, 0.157815E+00_JPRB, 0.151268E+00_JPRB, 0.144969E+00_JPRB/)
XCW( 734, :) = (/ &
  &  0.106027E+01_JPRB, 0.107462E+01_JPRB, 0.108866E+01_JPRB, 0.110239E+01_JPRB &
  &, 0.111580E+01_JPRB, 0.112886E+01_JPRB, 0.114159E+01_JPRB &
  &, 0.115395E+01_JPRB, 0.116595E+01_JPRB, 0.117758E+01_JPRB, 0.118883E+01_JPRB &
  &, 0.119968E+01_JPRB, 0.121014E+01_JPRB, 0.122019E+01_JPRB &
  &, 0.122982E+01_JPRB, 0.123902E+01_JPRB, 0.124779E+01_JPRB, 0.125613E+01_JPRB &
  &, 0.126401E+01_JPRB, 0.127144E+01_JPRB, 0.127841E+01_JPRB &
  &, 0.128491E+01_JPRB, 0.129094E+01_JPRB, 0.129649E+01_JPRB, 0.130155E+01_JPRB &
  &, 0.130612E+01_JPRB, 0.131020E+01_JPRB, 0.131379E+01_JPRB &
  &, 0.131687E+01_JPRB, 0.131945E+01_JPRB, 0.132152E+01_JPRB, 0.132309E+01_JPRB &
  &, 0.132414E+01_JPRB, 0.132468E+01_JPRB, 0.132472E+01_JPRB &
  &, 0.132424E+01_JPRB, 0.132325E+01_JPRB, 0.132176E+01_JPRB, 0.131976E+01_JPRB &
  &, 0.131725E+01_JPRB, 0.131425E+01_JPRB, 0.131075E+01_JPRB &
  &, 0.130675E+01_JPRB, 0.130227E+01_JPRB, 0.129729E+01_JPRB, 0.129185E+01_JPRB &
  &, 0.128593E+01_JPRB, 0.127955E+01_JPRB, 0.127271E+01_JPRB &
  &, 0.126543E+01_JPRB, 0.125769E+01_JPRB, 0.124953E+01_JPRB, 0.124095E+01_JPRB &
  &, 0.123194E+01_JPRB, 0.122253E+01_JPRB, 0.121273E+01_JPRB &
  &, 0.120255E+01_JPRB, 0.119199E+01_JPRB, 0.118106E+01_JPRB, 0.116979E+01_JPRB &
  &, 0.115819E+01_JPRB, 0.114625E+01_JPRB, 0.113398E+01_JPRB &
  &, 0.112144E+01_JPRB, 0.110859E+01_JPRB, 0.109547E+01_JPRB, 0.108208E+01_JPRB &
  &, 0.106845E+01_JPRB, 0.105457E+01_JPRB, 0.104046E+01_JPRB &
  &, 0.102616E+01_JPRB, 0.101163E+01_JPRB, 0.996946E+00_JPRB, 0.982083E+00_JPRB &
  &, 0.967058E+00_JPRB, 0.951905E+00_JPRB, 0.936613E+00_JPRB &
  &, 0.921193E+00_JPRB, 0.905680E+00_JPRB, 0.890061E+00_JPRB, 0.874395E+00_JPRB &
  &, 0.858644E+00_JPRB, 0.842841E+00_JPRB, 0.826996E+00_JPRB &
  &, 0.811146E+00_JPRB, 0.795270E+00_JPRB, 0.779376E+00_JPRB, 0.763529E+00_JPRB &
  &, 0.747677E+00_JPRB, 0.731854E+00_JPRB, 0.716095E+00_JPRB &
  &, 0.700376E+00_JPRB, 0.684729E+00_JPRB, 0.669190E+00_JPRB, 0.653696E+00_JPRB &
  &, 0.638314E+00_JPRB, 0.623043E+00_JPRB, 0.607883E+00_JPRB &
  &, 0.592868E+00_JPRB, 0.577960E+00_JPRB, 0.563189E+00_JPRB, 0.548589E+00_JPRB &
  &, 0.534154E+00_JPRB, 0.519840E+00_JPRB, 0.505754E+00_JPRB &
  &, 0.491810E+00_JPRB, 0.478038E+00_JPRB, 0.464466E+00_JPRB, 0.451125E+00_JPRB &
  &, 0.437960E+00_JPRB, 0.425000E+00_JPRB, 0.412227E+00_JPRB &
  &, 0.399670E+00_JPRB, 0.387356E+00_JPRB, 0.375266E+00_JPRB, 0.363381E+00_JPRB &
  &, 0.351725E+00_JPRB, 0.340324E+00_JPRB, 0.329106E+00_JPRB &
  &, 0.318143E+00_JPRB, 0.307410E+00_JPRB, 0.296929E+00_JPRB, 0.286672E+00_JPRB &
  &, 0.276662E+00_JPRB, 0.266867E+00_JPRB, 0.257307E+00_JPRB &
  &, 0.247949E+00_JPRB, 0.238867E+00_JPRB, 0.230025E+00_JPRB, 0.221387E+00_JPRB &
  &, 0.213029E+00_JPRB, 0.204851E+00_JPRB, 0.196931E+00_JPRB &
  &, 0.189225E+00_JPRB, 0.181690E+00_JPRB, 0.174464E+00_JPRB, 0.167376E+00_JPRB &
  &, 0.160568E+00_JPRB, 0.153927E+00_JPRB, 0.147532E+00_JPRB/)
XCW( 735, :) = (/ &
  &  0.106058E+01_JPRB, 0.107502E+01_JPRB, 0.108915E+01_JPRB, 0.110296E+01_JPRB &
  &, 0.111645E+01_JPRB, 0.112961E+01_JPRB, 0.114242E+01_JPRB &
  &, 0.115488E+01_JPRB, 0.116697E+01_JPRB, 0.117869E+01_JPRB, 0.119003E+01_JPRB &
  &, 0.120098E+01_JPRB, 0.121153E+01_JPRB, 0.122167E+01_JPRB &
  &, 0.123140E+01_JPRB, 0.124070E+01_JPRB, 0.124957E+01_JPRB, 0.125800E+01_JPRB &
  &, 0.126599E+01_JPRB, 0.127351E+01_JPRB, 0.128056E+01_JPRB &
  &, 0.128718E+01_JPRB, 0.129331E+01_JPRB, 0.129896E+01_JPRB, 0.130413E+01_JPRB &
  &, 0.130880E+01_JPRB, 0.131298E+01_JPRB, 0.131667E+01_JPRB &
  &, 0.131985E+01_JPRB, 0.132253E+01_JPRB, 0.132470E+01_JPRB, 0.132636E+01_JPRB &
  &, 0.132752E+01_JPRB, 0.132816E+01_JPRB, 0.132829E+01_JPRB &
  &, 0.132791E+01_JPRB, 0.132702E+01_JPRB, 0.132562E+01_JPRB, 0.132372E+01_JPRB &
  &, 0.132130E+01_JPRB, 0.131839E+01_JPRB, 0.131498E+01_JPRB &
  &, 0.131107E+01_JPRB, 0.130668E+01_JPRB, 0.130179E+01_JPRB, 0.129644E+01_JPRB &
  &, 0.129060E+01_JPRB, 0.128431E+01_JPRB, 0.127754E+01_JPRB &
  &, 0.127034E+01_JPRB, 0.126269E+01_JPRB, 0.125460E+01_JPRB, 0.124608E+01_JPRB &
  &, 0.123716E+01_JPRB, 0.122783E+01_JPRB, 0.121809E+01_JPRB &
  &, 0.120797E+01_JPRB, 0.119746E+01_JPRB, 0.118661E+01_JPRB, 0.117540E+01_JPRB &
  &, 0.116384E+01_JPRB, 0.115196E+01_JPRB, 0.113975E+01_JPRB &
  &, 0.112724E+01_JPRB, 0.111445E+01_JPRB, 0.110137E+01_JPRB, 0.108803E+01_JPRB &
  &, 0.107442E+01_JPRB, 0.106058E+01_JPRB, 0.104651E+01_JPRB &
  &, 0.103223E+01_JPRB, 0.101775E+01_JPRB, 0.100308E+01_JPRB, 0.988231E+00_JPRB &
  &, 0.973241E+00_JPRB, 0.958074E+00_JPRB, 0.942812E+00_JPRB &
  &, 0.927395E+00_JPRB, 0.911882E+00_JPRB, 0.896284E+00_JPRB, 0.880612E+00_JPRB &
  &, 0.864851E+00_JPRB, 0.849034E+00_JPRB, 0.833199E+00_JPRB &
  &, 0.817328E+00_JPRB, 0.801427E+00_JPRB, 0.785534E+00_JPRB, 0.769654E+00_JPRB &
  &, 0.753765E+00_JPRB, 0.737932E+00_JPRB, 0.722160E+00_JPRB &
  &, 0.706392E+00_JPRB, 0.690724E+00_JPRB, 0.675128E+00_JPRB, 0.659606E+00_JPRB &
  &, 0.644192E+00_JPRB, 0.628851E+00_JPRB, 0.613651E+00_JPRB &
  &, 0.598556E+00_JPRB, 0.583636E+00_JPRB, 0.568813E+00_JPRB, 0.554157E+00_JPRB &
  &, 0.539624E+00_JPRB, 0.525284E+00_JPRB, 0.511091E+00_JPRB &
  &, 0.497114E+00_JPRB, 0.483305E+00_JPRB, 0.469652E+00_JPRB, 0.456225E+00_JPRB &
  &, 0.442971E+00_JPRB, 0.429959E+00_JPRB, 0.417132E+00_JPRB &
  &, 0.404516E+00_JPRB, 0.392095E+00_JPRB, 0.379939E+00_JPRB, 0.367984E+00_JPRB &
  &, 0.356255E+00_JPRB, 0.344729E+00_JPRB, 0.333478E+00_JPRB &
  &, 0.322431E+00_JPRB, 0.311609E+00_JPRB, 0.301035E+00_JPRB, 0.290683E+00_JPRB &
  &, 0.280572E+00_JPRB, 0.270672E+00_JPRB, 0.261058E+00_JPRB &
  &, 0.251643E+00_JPRB, 0.242501E+00_JPRB, 0.233541E+00_JPRB, 0.224837E+00_JPRB &
  &, 0.216351E+00_JPRB, 0.208101E+00_JPRB, 0.200105E+00_JPRB &
  &, 0.192321E+00_JPRB, 0.184705E+00_JPRB, 0.177394E+00_JPRB, 0.170283E+00_JPRB &
  &, 0.163321E+00_JPRB, 0.156651E+00_JPRB, 0.150160E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART105',1,ZHOOK_HANDLE)
END SUBROUTINE PART105

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART106

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART106',0,ZHOOK_HANDLE)

XCW( 736, :) = (/ &
  &  0.106090E+01_JPRB, 0.107542E+01_JPRB, 0.108963E+01_JPRB, 0.110353E+01_JPRB &
  &, 0.111711E+01_JPRB, 0.113036E+01_JPRB, 0.114326E+01_JPRB &
  &, 0.115580E+01_JPRB, 0.116799E+01_JPRB, 0.117980E+01_JPRB, 0.119124E+01_JPRB &
  &, 0.120228E+01_JPRB, 0.121293E+01_JPRB, 0.122317E+01_JPRB &
  &, 0.123299E+01_JPRB, 0.124239E+01_JPRB, 0.125136E+01_JPRB, 0.125989E+01_JPRB &
  &, 0.126797E+01_JPRB, 0.127560E+01_JPRB, 0.128277E+01_JPRB &
  &, 0.128947E+01_JPRB, 0.129570E+01_JPRB, 0.130145E+01_JPRB, 0.130671E+01_JPRB &
  &, 0.131149E+01_JPRB, 0.131577E+01_JPRB, 0.131955E+01_JPRB &
  &, 0.132284E+01_JPRB, 0.132562E+01_JPRB, 0.132789E+01_JPRB, 0.132965E+01_JPRB &
  &, 0.133091E+01_JPRB, 0.133165E+01_JPRB, 0.133188E+01_JPRB &
  &, 0.133159E+01_JPRB, 0.133080E+01_JPRB, 0.132949E+01_JPRB, 0.132769E+01_JPRB &
  &, 0.132537E+01_JPRB, 0.132255E+01_JPRB, 0.131923E+01_JPRB &
  &, 0.131541E+01_JPRB, 0.131111E+01_JPRB, 0.130632E+01_JPRB, 0.130104E+01_JPRB &
  &, 0.129529E+01_JPRB, 0.128909E+01_JPRB, 0.128241E+01_JPRB &
  &, 0.127528E+01_JPRB, 0.126770E+01_JPRB, 0.125969E+01_JPRB, 0.125126E+01_JPRB &
  &, 0.124240E+01_JPRB, 0.123314E+01_JPRB, 0.122347E+01_JPRB &
  &, 0.121341E+01_JPRB, 0.120298E+01_JPRB, 0.119219E+01_JPRB, 0.118103E+01_JPRB &
  &, 0.116953E+01_JPRB, 0.115770E+01_JPRB, 0.114556E+01_JPRB &
  &, 0.113310E+01_JPRB, 0.112035E+01_JPRB, 0.110730E+01_JPRB, 0.109400E+01_JPRB &
  &, 0.108044E+01_JPRB, 0.106665E+01_JPRB, 0.105260E+01_JPRB &
  &, 0.103835E+01_JPRB, 0.102389E+01_JPRB, 0.100926E+01_JPRB, 0.994424E+00_JPRB &
  &, 0.979447E+00_JPRB, 0.964314E+00_JPRB, 0.949035E+00_JPRB &
  &, 0.933646E+00_JPRB, 0.918133E+00_JPRB, 0.902533E+00_JPRB, 0.886855E+00_JPRB &
  &, 0.871110E+00_JPRB, 0.855281E+00_JPRB, 0.839429E+00_JPRB &
  &, 0.823538E+00_JPRB, 0.807641E+00_JPRB, 0.791720E+00_JPRB, 0.775779E+00_JPRB &
  &, 0.759944E+00_JPRB, 0.744071E+00_JPRB, 0.728256E+00_JPRB &
  &, 0.712472E+00_JPRB, 0.696752E+00_JPRB, 0.681100E+00_JPRB, 0.665550E+00_JPRB &
  &, 0.650104E+00_JPRB, 0.634728E+00_JPRB, 0.619489E+00_JPRB &
  &, 0.604352E+00_JPRB, 0.589348E+00_JPRB, 0.574475E+00_JPRB, 0.559763E+00_JPRB &
  &, 0.545171E+00_JPRB, 0.530768E+00_JPRB, 0.516546E+00_JPRB &
  &, 0.502457E+00_JPRB, 0.488572E+00_JPRB, 0.474879E+00_JPRB, 0.461368E+00_JPRB &
  &, 0.448067E+00_JPRB, 0.434961E+00_JPRB, 0.422080E+00_JPRB &
  &, 0.409362E+00_JPRB, 0.396879E+00_JPRB, 0.384658E+00_JPRB, 0.372587E+00_JPRB &
  &, 0.360785E+00_JPRB, 0.349182E+00_JPRB, 0.337850E+00_JPRB &
  &, 0.326718E+00_JPRB, 0.315808E+00_JPRB, 0.305142E+00_JPRB, 0.294745E+00_JPRB &
  &, 0.284535E+00_JPRB, 0.274585E+00_JPRB, 0.264864E+00_JPRB &
  &, 0.255392E+00_JPRB, 0.246135E+00_JPRB, 0.237112E+00_JPRB, 0.228286E+00_JPRB &
  &, 0.219731E+00_JPRB, 0.211409E+00_JPRB, 0.203339E+00_JPRB &
  &, 0.195478E+00_JPRB, 0.187781E+00_JPRB, 0.180387E+00_JPRB, 0.173126E+00_JPRB &
  &, 0.166138E+00_JPRB, 0.159375E+00_JPRB, 0.152788E+00_JPRB/)
XCW( 737, :) = (/ &
  &  0.106122E+01_JPRB, 0.107582E+01_JPRB, 0.109012E+01_JPRB, 0.110411E+01_JPRB &
  &, 0.111777E+01_JPRB, 0.113110E+01_JPRB, 0.114410E+01_JPRB &
  &, 0.115673E+01_JPRB, 0.116901E+01_JPRB, 0.118092E+01_JPRB, 0.119245E+01_JPRB &
  &, 0.120358E+01_JPRB, 0.121433E+01_JPRB, 0.122466E+01_JPRB &
  &, 0.123458E+01_JPRB, 0.124408E+01_JPRB, 0.125315E+01_JPRB, 0.126177E+01_JPRB &
  &, 0.126996E+01_JPRB, 0.127769E+01_JPRB, 0.128494E+01_JPRB &
  &, 0.129176E+01_JPRB, 0.129809E+01_JPRB, 0.130394E+01_JPRB, 0.130931E+01_JPRB &
  &, 0.131418E+01_JPRB, 0.131857E+01_JPRB, 0.132245E+01_JPRB &
  &, 0.132584E+01_JPRB, 0.132872E+01_JPRB, 0.133109E+01_JPRB, 0.133295E+01_JPRB &
  &, 0.133431E+01_JPRB, 0.133515E+01_JPRB, 0.133548E+01_JPRB &
  &, 0.133529E+01_JPRB, 0.133460E+01_JPRB, 0.133339E+01_JPRB, 0.133168E+01_JPRB &
  &, 0.132945E+01_JPRB, 0.132672E+01_JPRB, 0.132349E+01_JPRB &
  &, 0.131977E+01_JPRB, 0.131556E+01_JPRB, 0.131086E+01_JPRB, 0.130567E+01_JPRB &
  &, 0.130001E+01_JPRB, 0.129388E+01_JPRB, 0.128729E+01_JPRB &
  &, 0.128024E+01_JPRB, 0.127275E+01_JPRB, 0.126482E+01_JPRB, 0.125646E+01_JPRB &
  &, 0.124766E+01_JPRB, 0.123848E+01_JPRB, 0.122887E+01_JPRB &
  &, 0.121890E+01_JPRB, 0.120852E+01_JPRB, 0.119779E+01_JPRB, 0.118669E+01_JPRB &
  &, 0.117525E+01_JPRB, 0.116348E+01_JPRB, 0.115138E+01_JPRB &
  &, 0.113898E+01_JPRB, 0.112627E+01_JPRB, 0.111327E+01_JPRB, 0.110002E+01_JPRB &
  &, 0.108650E+01_JPRB, 0.107273E+01_JPRB, 0.105870E+01_JPRB &
  &, 0.104450E+01_JPRB, 0.103009E+01_JPRB, 0.101546E+01_JPRB, 0.100066E+01_JPRB &
  &, 0.985699E+00_JPRB, 0.970576E+00_JPRB, 0.955305E+00_JPRB &
  &, 0.939921E+00_JPRB, 0.924435E+00_JPRB, 0.908833E+00_JPRB, 0.893150E+00_JPRB &
  &, 0.877396E+00_JPRB, 0.861581E+00_JPRB, 0.845714E+00_JPRB &
  &, 0.829831E+00_JPRB, 0.813912E+00_JPRB, 0.797964E+00_JPRB, 0.782052E+00_JPRB &
  &, 0.766122E+00_JPRB, 0.750241E+00_JPRB, 0.734383E+00_JPRB &
  &, 0.718583E+00_JPRB, 0.702844E+00_JPRB, 0.687169E+00_JPRB, 0.671560E+00_JPRB &
  &, 0.656050E+00_JPRB, 0.640639E+00_JPRB, 0.625363E+00_JPRB &
  &, 0.610147E+00_JPRB, 0.595097E+00_JPRB, 0.580173E+00_JPRB, 0.565407E+00_JPRB &
  &, 0.550795E+00_JPRB, 0.536329E+00_JPRB, 0.522001E+00_JPRB &
  &, 0.507881E+00_JPRB, 0.493920E+00_JPRB, 0.480148E+00_JPRB, 0.466595E+00_JPRB &
  &, 0.453205E+00_JPRB, 0.440051E+00_JPRB, 0.427073E+00_JPRB &
  &, 0.414298E+00_JPRB, 0.401755E+00_JPRB, 0.389423E+00_JPRB, 0.377285E+00_JPRB &
  &, 0.365410E+00_JPRB, 0.353731E+00_JPRB, 0.342272E+00_JPRB &
  &, 0.331106E+00_JPRB, 0.320108E+00_JPRB, 0.309352E+00_JPRB, 0.298860E+00_JPRB &
  &, 0.288550E+00_JPRB, 0.278551E+00_JPRB, 0.268723E+00_JPRB &
  &, 0.259141E+00_JPRB, 0.249825E+00_JPRB, 0.240684E+00_JPRB, 0.231850E+00_JPRB &
  &, 0.223170E+00_JPRB, 0.214777E+00_JPRB, 0.206573E+00_JPRB &
  &, 0.198635E+00_JPRB, 0.190919E+00_JPRB, 0.183380E+00_JPRB, 0.176095E+00_JPRB &
  &, 0.169018E+00_JPRB, 0.162164E+00_JPRB, 0.155483E+00_JPRB/)
XCW( 738, :) = (/ &
  &  0.106154E+01_JPRB, 0.107622E+01_JPRB, 0.109061E+01_JPRB, 0.110468E+01_JPRB &
  &, 0.111844E+01_JPRB, 0.113186E+01_JPRB, 0.114494E+01_JPRB &
  &, 0.115767E+01_JPRB, 0.117004E+01_JPRB, 0.118204E+01_JPRB, 0.119366E+01_JPRB &
  &, 0.120489E+01_JPRB, 0.121573E+01_JPRB, 0.122616E+01_JPRB &
  &, 0.123618E+01_JPRB, 0.124577E+01_JPRB, 0.125494E+01_JPRB, 0.126367E+01_JPRB &
  &, 0.127195E+01_JPRB, 0.127978E+01_JPRB, 0.128715E+01_JPRB &
  &, 0.129405E+01_JPRB, 0.130048E+01_JPRB, 0.130644E+01_JPRB, 0.131191E+01_JPRB &
  &, 0.131689E+01_JPRB, 0.132137E+01_JPRB, 0.132536E+01_JPRB &
  &, 0.132885E+01_JPRB, 0.133183E+01_JPRB, 0.133430E+01_JPRB, 0.133627E+01_JPRB &
  &, 0.133772E+01_JPRB, 0.133866E+01_JPRB, 0.133909E+01_JPRB &
  &, 0.133901E+01_JPRB, 0.133840E+01_JPRB, 0.133730E+01_JPRB, 0.133568E+01_JPRB &
  &, 0.133355E+01_JPRB, 0.133092E+01_JPRB, 0.132778E+01_JPRB &
  &, 0.132416E+01_JPRB, 0.132003E+01_JPRB, 0.131542E+01_JPRB, 0.131032E+01_JPRB &
  &, 0.130475E+01_JPRB, 0.129870E+01_JPRB, 0.129219E+01_JPRB &
  &, 0.128523E+01_JPRB, 0.127781E+01_JPRB, 0.126996E+01_JPRB, 0.126167E+01_JPRB &
  &, 0.125295E+01_JPRB, 0.124383E+01_JPRB, 0.123431E+01_JPRB &
  &, 0.122440E+01_JPRB, 0.121410E+01_JPRB, 0.120342E+01_JPRB, 0.119238E+01_JPRB &
  &, 0.118101E+01_JPRB, 0.116928E+01_JPRB, 0.115724E+01_JPRB &
  &, 0.114488E+01_JPRB, 0.113224E+01_JPRB, 0.111928E+01_JPRB, 0.110606E+01_JPRB &
  &, 0.109259E+01_JPRB, 0.107886E+01_JPRB, 0.106489E+01_JPRB &
  &, 0.105070E+01_JPRB, 0.103629E+01_JPRB, 0.102170E+01_JPRB, 0.100692E+01_JPRB &
  &, 0.991973E+00_JPRB, 0.976886E+00_JPRB, 0.961623E+00_JPRB &
  &, 0.946269E+00_JPRB, 0.930761E+00_JPRB, 0.915183E+00_JPRB, 0.899496E+00_JPRB &
  &, 0.883734E+00_JPRB, 0.867935E+00_JPRB, 0.852054E+00_JPRB &
  &, 0.836152E+00_JPRB, 0.820212E+00_JPRB, 0.804266E+00_JPRB, 0.788324E+00_JPRB &
  &, 0.772391E+00_JPRB, 0.756472E+00_JPRB, 0.740572E+00_JPRB &
  &, 0.724758E+00_JPRB, 0.708969E+00_JPRB, 0.693239E+00_JPRB, 0.677604E+00_JPRB &
  &, 0.662064E+00_JPRB, 0.646620E+00_JPRB, 0.631271E+00_JPRB &
  &, 0.616050E+00_JPRB, 0.600919E+00_JPRB, 0.585945E+00_JPRB, 0.571126E+00_JPRB &
  &, 0.556456E+00_JPRB, 0.541929E+00_JPRB, 0.527535E+00_JPRB &
  &, 0.513345E+00_JPRB, 0.499351E+00_JPRB, 0.485500E+00_JPRB, 0.471864E+00_JPRB &
  &, 0.458387E+00_JPRB, 0.445140E+00_JPRB, 0.432109E+00_JPRB &
  &, 0.419279E+00_JPRB, 0.406630E+00_JPRB, 0.394235E+00_JPRB, 0.382029E+00_JPRB &
  &, 0.370036E+00_JPRB, 0.358330E+00_JPRB, 0.346791E+00_JPRB &
  &, 0.335493E+00_JPRB, 0.324459E+00_JPRB, 0.313612E+00_JPRB, 0.303026E+00_JPRB &
  &, 0.292672E+00_JPRB, 0.282517E+00_JPRB, 0.272637E+00_JPRB &
  &, 0.263001E+00_JPRB, 0.253572E+00_JPRB, 0.244369E+00_JPRB, 0.235414E+00_JPRB &
  &, 0.226666E+00_JPRB, 0.218204E+00_JPRB, 0.209927E+00_JPRB &
  &, 0.201852E+00_JPRB, 0.194056E+00_JPRB, 0.186497E+00_JPRB, 0.179128E+00_JPRB &
  &, 0.171963E+00_JPRB, 0.165018E+00_JPRB, 0.158242E+00_JPRB/)
XCW( 739, :) = (/ &
  &  0.106186E+01_JPRB, 0.107663E+01_JPRB, 0.109110E+01_JPRB, 0.110526E+01_JPRB &
  &, 0.111910E+01_JPRB, 0.113261E+01_JPRB, 0.114578E+01_JPRB &
  &, 0.115860E+01_JPRB, 0.117106E+01_JPRB, 0.118316E+01_JPRB, 0.119487E+01_JPRB &
  &, 0.120620E+01_JPRB, 0.121713E+01_JPRB, 0.122766E+01_JPRB &
  &, 0.123778E+01_JPRB, 0.124747E+01_JPRB, 0.125674E+01_JPRB, 0.126557E+01_JPRB &
  &, 0.127395E+01_JPRB, 0.128188E+01_JPRB, 0.128935E+01_JPRB &
  &, 0.129636E+01_JPRB, 0.130289E+01_JPRB, 0.130895E+01_JPRB, 0.131452E+01_JPRB &
  &, 0.131960E+01_JPRB, 0.132418E+01_JPRB, 0.132828E+01_JPRB &
  &, 0.133187E+01_JPRB, 0.133495E+01_JPRB, 0.133753E+01_JPRB, 0.133959E+01_JPRB &
  &, 0.134115E+01_JPRB, 0.134212E+01_JPRB, 0.134272E+01_JPRB &
  &, 0.134273E+01_JPRB, 0.134223E+01_JPRB, 0.134122E+01_JPRB, 0.133970E+01_JPRB &
  &, 0.133766E+01_JPRB, 0.133512E+01_JPRB, 0.133209E+01_JPRB &
  &, 0.132851E+01_JPRB, 0.132451E+01_JPRB, 0.131999E+01_JPRB, 0.131499E+01_JPRB &
  &, 0.130950E+01_JPRB, 0.130354E+01_JPRB, 0.129712E+01_JPRB &
  &, 0.129024E+01_JPRB, 0.128290E+01_JPRB, 0.127513E+01_JPRB, 0.126692E+01_JPRB &
  &, 0.125827E+01_JPRB, 0.124923E+01_JPRB, 0.123978E+01_JPRB &
  &, 0.122993E+01_JPRB, 0.121968E+01_JPRB, 0.120908E+01_JPRB, 0.119811E+01_JPRB &
  &, 0.118679E+01_JPRB, 0.117513E+01_JPRB, 0.116313E+01_JPRB &
  &, 0.115083E+01_JPRB, 0.113823E+01_JPRB, 0.112533E+01_JPRB, 0.111215E+01_JPRB &
  &, 0.109871E+01_JPRB, 0.108498E+01_JPRB, 0.107109E+01_JPRB &
  &, 0.105693E+01_JPRB, 0.104255E+01_JPRB, 0.102798E+01_JPRB, 0.101323E+01_JPRB &
  &, 0.998317E+00_JPRB, 0.983218E+00_JPRB, 0.967989E+00_JPRB &
  &, 0.952641E+00_JPRB, 0.937161E+00_JPRB, 0.921558E+00_JPRB, 0.905893E+00_JPRB &
  &, 0.890126E+00_JPRB, 0.874316E+00_JPRB, 0.858421E+00_JPRB &
  &, 0.842502E+00_JPRB, 0.826567E+00_JPRB, 0.810597E+00_JPRB, 0.794626E+00_JPRB &
  &, 0.778690E+00_JPRB, 0.762734E+00_JPRB, 0.746824E+00_JPRB &
  &, 0.730964E+00_JPRB, 0.715158E+00_JPRB, 0.699407E+00_JPRB, 0.683714E+00_JPRB &
  &, 0.668146E+00_JPRB, 0.652635E+00_JPRB, 0.637250E+00_JPRB &
  &, 0.621953E+00_JPRB, 0.606813E+00_JPRB, 0.591792E+00_JPRB, 0.576883E+00_JPRB &
  &, 0.562156E+00_JPRB, 0.547568E+00_JPRB, 0.533148E+00_JPRB &
  &, 0.518889E+00_JPRB, 0.504781E+00_JPRB, 0.490894E+00_JPRB, 0.477175E+00_JPRB &
  &, 0.463654E+00_JPRB, 0.450316E+00_JPRB, 0.437234E+00_JPRB &
  &, 0.424304E+00_JPRB, 0.411597E+00_JPRB, 0.399093E+00_JPRB, 0.386820E+00_JPRB &
  &, 0.374756E+00_JPRB, 0.362928E+00_JPRB, 0.351360E+00_JPRB &
  &, 0.339980E+00_JPRB, 0.328810E+00_JPRB, 0.317924E+00_JPRB, 0.307245E+00_JPRB &
  &, 0.296793E+00_JPRB, 0.286590E+00_JPRB, 0.276606E+00_JPRB &
  &, 0.266860E+00_JPRB, 0.257374E+00_JPRB, 0.248111E+00_JPRB, 0.239036E+00_JPRB &
  &, 0.230222E+00_JPRB, 0.221631E+00_JPRB, 0.213281E+00_JPRB &
  &, 0.205191E+00_JPRB, 0.197256E+00_JPRB, 0.189615E+00_JPRB, 0.182161E+00_JPRB &
  &, 0.174908E+00_JPRB, 0.167872E+00_JPRB, 0.161068E+00_JPRB/)
XCW( 740, :) = (/ &
  &  0.106218E+01_JPRB, 0.107703E+01_JPRB, 0.109159E+01_JPRB, 0.110583E+01_JPRB &
  &, 0.111976E+01_JPRB, 0.113336E+01_JPRB, 0.114662E+01_JPRB &
  &, 0.115954E+01_JPRB, 0.117209E+01_JPRB, 0.118428E+01_JPRB, 0.119609E+01_JPRB &
  &, 0.120751E+01_JPRB, 0.121854E+01_JPRB, 0.122917E+01_JPRB &
  &, 0.123939E+01_JPRB, 0.124918E+01_JPRB, 0.125855E+01_JPRB, 0.126747E+01_JPRB &
  &, 0.127596E+01_JPRB, 0.128399E+01_JPRB, 0.129156E+01_JPRB &
  &, 0.129867E+01_JPRB, 0.130530E+01_JPRB, 0.131146E+01_JPRB, 0.131713E+01_JPRB &
  &, 0.132232E+01_JPRB, 0.132701E+01_JPRB, 0.133121E+01_JPRB &
  &, 0.133490E+01_JPRB, 0.133808E+01_JPRB, 0.134076E+01_JPRB, 0.134290E+01_JPRB &
  &, 0.134458E+01_JPRB, 0.134566E+01_JPRB, 0.134636E+01_JPRB &
  &, 0.134647E+01_JPRB, 0.134607E+01_JPRB, 0.134516E+01_JPRB, 0.134373E+01_JPRB &
  &, 0.134180E+01_JPRB, 0.133936E+01_JPRB, 0.133641E+01_JPRB &
  &, 0.133296E+01_JPRB, 0.132902E+01_JPRB, 0.132459E+01_JPRB, 0.131968E+01_JPRB &
  &, 0.131427E+01_JPRB, 0.130839E+01_JPRB, 0.130206E+01_JPRB &
  &, 0.129526E+01_JPRB, 0.128801E+01_JPRB, 0.128031E+01_JPRB, 0.127218E+01_JPRB &
  &, 0.126362E+01_JPRB, 0.125465E+01_JPRB, 0.124526E+01_JPRB &
  &, 0.123548E+01_JPRB, 0.122531E+01_JPRB, 0.121476E+01_JPRB, 0.120387E+01_JPRB &
  &, 0.119260E+01_JPRB, 0.118100E+01_JPRB, 0.116906E+01_JPRB &
  &, 0.115680E+01_JPRB, 0.114424E+01_JPRB, 0.113140E+01_JPRB, 0.111827E+01_JPRB &
  &, 0.110486E+01_JPRB, 0.109121E+01_JPRB, 0.107732E+01_JPRB &
  &, 0.106319E+01_JPRB, 0.104884E+01_JPRB, 0.103432E+01_JPRB, 0.101958E+01_JPRB &
  &, 0.100468E+01_JPRB, 0.989598E+00_JPRB, 0.974403E+00_JPRB &
  &, 0.959038E+00_JPRB, 0.943561E+00_JPRB, 0.927984E+00_JPRB, 0.912317E+00_JPRB &
  &, 0.896569E+00_JPRB, 0.880724E+00_JPRB, 0.864842E+00_JPRB &
  &, 0.848934E+00_JPRB, 0.832952E+00_JPRB, 0.816986E+00_JPRB, 0.800986E+00_JPRB &
  &, 0.785018E+00_JPRB, 0.769057E+00_JPRB, 0.753138E+00_JPRB &
  &, 0.737234E+00_JPRB, 0.721379E+00_JPRB, 0.705608E+00_JPRB, 0.689891E+00_JPRB &
  &, 0.674262E+00_JPRB, 0.658720E+00_JPRB, 0.643264E+00_JPRB &
  &, 0.627963E+00_JPRB, 0.612744E+00_JPRB, 0.597675E+00_JPRB, 0.582715E+00_JPRB &
  &, 0.567933E+00_JPRB, 0.553284E+00_JPRB, 0.538801E+00_JPRB &
  &, 0.524474E+00_JPRB, 0.510334E+00_JPRB, 0.496329E+00_JPRB, 0.482571E+00_JPRB &
  &, 0.468964E+00_JPRB, 0.455580E+00_JPRB, 0.442360E+00_JPRB &
  &, 0.429375E+00_JPRB, 0.416609E+00_JPRB, 0.404043E+00_JPRB, 0.391705E+00_JPRB &
  &, 0.379572E+00_JPRB, 0.367623E+00_JPRB, 0.355978E+00_JPRB &
  &, 0.344517E+00_JPRB, 0.333262E+00_JPRB, 0.322288E+00_JPRB, 0.311516E+00_JPRB &
  &, 0.300967E+00_JPRB, 0.290717E+00_JPRB, 0.280629E+00_JPRB &
  &, 0.270830E+00_JPRB, 0.261231E+00_JPRB, 0.251853E+00_JPRB, 0.242715E+00_JPRB &
  &, 0.233835E+00_JPRB, 0.225176E+00_JPRB, 0.216695E+00_JPRB &
  &, 0.208529E+00_JPRB, 0.200516E+00_JPRB, 0.192794E+00_JPRB, 0.185256E+00_JPRB &
  &, 0.177917E+00_JPRB, 0.170791E+00_JPRB, 0.163894E+00_JPRB/)
XCW( 741, :) = (/ &
  &  0.106250E+01_JPRB, 0.107744E+01_JPRB, 0.109208E+01_JPRB, 0.110641E+01_JPRB &
  &, 0.112043E+01_JPRB, 0.113412E+01_JPRB, 0.114747E+01_JPRB &
  &, 0.116047E+01_JPRB, 0.117312E+01_JPRB, 0.118540E+01_JPRB, 0.119731E+01_JPRB &
  &, 0.120883E+01_JPRB, 0.121996E+01_JPRB, 0.123068E+01_JPRB &
  &, 0.124100E+01_JPRB, 0.125089E+01_JPRB, 0.126036E+01_JPRB, 0.126938E+01_JPRB &
  &, 0.127797E+01_JPRB, 0.128610E+01_JPRB, 0.129378E+01_JPRB &
  &, 0.130099E+01_JPRB, 0.130772E+01_JPRB, 0.131398E+01_JPRB, 0.131976E+01_JPRB &
  &, 0.132505E+01_JPRB, 0.132984E+01_JPRB, 0.133414E+01_JPRB &
  &, 0.133793E+01_JPRB, 0.134123E+01_JPRB, 0.134401E+01_JPRB, 0.134628E+01_JPRB &
  &, 0.134804E+01_JPRB, 0.134928E+01_JPRB, 0.135001E+01_JPRB &
  &, 0.135022E+01_JPRB, 0.134993E+01_JPRB, 0.134911E+01_JPRB, 0.134778E+01_JPRB &
  &, 0.134595E+01_JPRB, 0.134360E+01_JPRB, 0.134075E+01_JPRB &
  &, 0.133739E+01_JPRB, 0.133355E+01_JPRB, 0.132921E+01_JPRB, 0.132437E+01_JPRB &
  &, 0.131907E+01_JPRB, 0.131328E+01_JPRB, 0.130703E+01_JPRB &
  &, 0.130031E+01_JPRB, 0.129314E+01_JPRB, 0.128552E+01_JPRB, 0.127747E+01_JPRB &
  &, 0.126899E+01_JPRB, 0.126009E+01_JPRB, 0.125077E+01_JPRB &
  &, 0.124107E+01_JPRB, 0.123097E+01_JPRB, 0.122049E+01_JPRB, 0.120964E+01_JPRB &
  &, 0.119844E+01_JPRB, 0.118687E+01_JPRB, 0.117501E+01_JPRB &
  &, 0.116281E+01_JPRB, 0.115031E+01_JPRB, 0.113750E+01_JPRB, 0.112441E+01_JPRB &
  &, 0.111106E+01_JPRB, 0.109744E+01_JPRB, 0.108358E+01_JPRB &
  &, 0.106949E+01_JPRB, 0.105519E+01_JPRB, 0.104067E+01_JPRB, 0.102597E+01_JPRB &
  &, 0.101107E+01_JPRB, 0.996024E+00_JPRB, 0.980840E+00_JPRB &
  &, 0.965507E+00_JPRB, 0.950036E+00_JPRB, 0.934461E+00_JPRB, 0.918792E+00_JPRB &
  &, 0.903039E+00_JPRB, 0.887212E+00_JPRB, 0.871319E+00_JPRB &
  &, 0.855395E+00_JPRB, 0.839421E+00_JPRB, 0.823432E+00_JPRB, 0.807406E+00_JPRB &
  &, 0.791407E+00_JPRB, 0.775440E+00_JPRB, 0.759482E+00_JPRB &
  &, 0.743535E+00_JPRB, 0.727664E+00_JPRB, 0.711842E+00_JPRB, 0.696102E+00_JPRB &
  &, 0.680412E+00_JPRB, 0.664839E+00_JPRB, 0.649348E+00_JPRB &
  &, 0.633973E+00_JPRB, 0.618748E+00_JPRB, 0.603596E+00_JPRB, 0.588585E+00_JPRB &
  &, 0.573747E+00_JPRB, 0.559040E+00_JPRB, 0.544493E+00_JPRB &
  &, 0.530099E+00_JPRB, 0.515887E+00_JPRB, 0.501847E+00_JPRB, 0.488008E+00_JPRB &
  &, 0.474317E+00_JPRB, 0.460843E+00_JPRB, 0.447573E+00_JPRB &
  &, 0.434535E+00_JPRB, 0.421666E+00_JPRB, 0.409040E+00_JPRB, 0.396590E+00_JPRB &
  &, 0.384388E+00_JPRB, 0.372415E+00_JPRB, 0.360645E+00_JPRB &
  &, 0.349104E+00_JPRB, 0.337765E+00_JPRB, 0.326703E+00_JPRB, 0.315838E+00_JPRB &
  &, 0.305247E+00_JPRB, 0.294844E+00_JPRB, 0.284706E+00_JPRB &
  &, 0.274799E+00_JPRB, 0.265089E+00_JPRB, 0.255652E+00_JPRB, 0.246451E+00_JPRB &
  &, 0.237448E+00_JPRB, 0.228721E+00_JPRB, 0.220168E+00_JPRB &
  &, 0.211929E+00_JPRB, 0.203839E+00_JPRB, 0.195974E+00_JPRB, 0.188352E+00_JPRB &
  &, 0.180990E+00_JPRB, 0.173775E+00_JPRB, 0.166785E+00_JPRB/)
XCW( 742, :) = (/ &
  &  0.106282E+01_JPRB, 0.107785E+01_JPRB, 0.109257E+01_JPRB, 0.110699E+01_JPRB &
  &, 0.112110E+01_JPRB, 0.113488E+01_JPRB, 0.114832E+01_JPRB &
  &, 0.116142E+01_JPRB, 0.117416E+01_JPRB, 0.118653E+01_JPRB, 0.119854E+01_JPRB &
  &, 0.121015E+01_JPRB, 0.122138E+01_JPRB, 0.123220E+01_JPRB &
  &, 0.124261E+01_JPRB, 0.125260E+01_JPRB, 0.126217E+01_JPRB, 0.127130E+01_JPRB &
  &, 0.127999E+01_JPRB, 0.128822E+01_JPRB, 0.129600E+01_JPRB &
  &, 0.130331E+01_JPRB, 0.131015E+01_JPRB, 0.131652E+01_JPRB, 0.132240E+01_JPRB &
  &, 0.132779E+01_JPRB, 0.133269E+01_JPRB, 0.133709E+01_JPRB &
  &, 0.134099E+01_JPRB, 0.134438E+01_JPRB, 0.134726E+01_JPRB, 0.134964E+01_JPRB &
  &, 0.135150E+01_JPRB, 0.135284E+01_JPRB, 0.135368E+01_JPRB &
  &, 0.135399E+01_JPRB, 0.135379E+01_JPRB, 0.135308E+01_JPRB, 0.135185E+01_JPRB &
  &, 0.135011E+01_JPRB, 0.134786E+01_JPRB, 0.134507E+01_JPRB &
  &, 0.134184E+01_JPRB, 0.133809E+01_JPRB, 0.133385E+01_JPRB, 0.132911E+01_JPRB &
  &, 0.132388E+01_JPRB, 0.131818E+01_JPRB, 0.131202E+01_JPRB &
  &, 0.130539E+01_JPRB, 0.129831E+01_JPRB, 0.129076E+01_JPRB, 0.128279E+01_JPRB &
  &, 0.127438E+01_JPRB, 0.126555E+01_JPRB, 0.125631E+01_JPRB &
  &, 0.124668E+01_JPRB, 0.123665E+01_JPRB, 0.122623E+01_JPRB, 0.121545E+01_JPRB &
  &, 0.120431E+01_JPRB, 0.119282E+01_JPRB, 0.118101E+01_JPRB &
  &, 0.116885E+01_JPRB, 0.115641E+01_JPRB, 0.114364E+01_JPRB, 0.113061E+01_JPRB &
  &, 0.111729E+01_JPRB, 0.110370E+01_JPRB, 0.108990E+01_JPRB &
  &, 0.107584E+01_JPRB, 0.106157E+01_JPRB, 0.104707E+01_JPRB, 0.103239E+01_JPRB &
  &, 0.101753E+01_JPRB, 0.100250E+01_JPRB, 0.987325E+00_JPRB &
  &, 0.972001E+00_JPRB, 0.956535E+00_JPRB, 0.940988E+00_JPRB, 0.925318E+00_JPRB &
  &, 0.909562E+00_JPRB, 0.893727E+00_JPRB, 0.877822E+00_JPRB &
  &, 0.861883E+00_JPRB, 0.845919E+00_JPRB, 0.829908E+00_JPRB, 0.813885E+00_JPRB &
  &, 0.797855E+00_JPRB, 0.781855E+00_JPRB, 0.765858E+00_JPRB &
  &, 0.749900E+00_JPRB, 0.734015E+00_JPRB, 0.718141E+00_JPRB, 0.702379E+00_JPRB &
  &, 0.686664E+00_JPRB, 0.671027E+00_JPRB, 0.655503E+00_JPRB &
  &, 0.640091E+00_JPRB, 0.624788E+00_JPRB, 0.609590E+00_JPRB, 0.594529E+00_JPRB &
  &, 0.579638E+00_JPRB, 0.564873E+00_JPRB, 0.550225E+00_JPRB &
  &, 0.535804E+00_JPRB, 0.521521E+00_JPRB, 0.507406E+00_JPRB, 0.493488E+00_JPRB &
  &, 0.479755E+00_JPRB, 0.466194E+00_JPRB, 0.452875E+00_JPRB &
  &, 0.439740E+00_JPRB, 0.426815E+00_JPRB, 0.414083E+00_JPRB, 0.401569E+00_JPRB &
  &, 0.389252E+00_JPRB, 0.377206E+00_JPRB, 0.365361E+00_JPRB &
  &, 0.353740E+00_JPRB, 0.342318E+00_JPRB, 0.331169E+00_JPRB, 0.320266E+00_JPRB &
  &, 0.309526E+00_JPRB, 0.299078E+00_JPRB, 0.288837E+00_JPRB &
  &, 0.278824E+00_JPRB, 0.269059E+00_JPRB, 0.259564E+00_JPRB, 0.250245E+00_JPRB &
  &, 0.241178E+00_JPRB, 0.232325E+00_JPRB, 0.223702E+00_JPRB &
  &, 0.215328E+00_JPRB, 0.207161E+00_JPRB, 0.199279E+00_JPRB, 0.191575E+00_JPRB &
  &, 0.184063E+00_JPRB, 0.176823E+00_JPRB, 0.169742E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART106',1,ZHOOK_HANDLE)
END SUBROUTINE PART106

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART107

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART107',0,ZHOOK_HANDLE)

XCW( 743, :) = (/ &
  &  0.106315E+01_JPRB, 0.107825E+01_JPRB, 0.109307E+01_JPRB, 0.110757E+01_JPRB &
  &, 0.112177E+01_JPRB, 0.113564E+01_JPRB, 0.114917E+01_JPRB &
  &, 0.116236E+01_JPRB, 0.117519E+01_JPRB, 0.118767E+01_JPRB, 0.119976E+01_JPRB &
  &, 0.121148E+01_JPRB, 0.122280E+01_JPRB, 0.123372E+01_JPRB &
  &, 0.124423E+01_JPRB, 0.125433E+01_JPRB, 0.126399E+01_JPRB, 0.127322E+01_JPRB &
  &, 0.128201E+01_JPRB, 0.129035E+01_JPRB, 0.129823E+01_JPRB &
  &, 0.130565E+01_JPRB, 0.131259E+01_JPRB, 0.131906E+01_JPRB, 0.132504E+01_JPRB &
  &, 0.133054E+01_JPRB, 0.133554E+01_JPRB, 0.134005E+01_JPRB &
  &, 0.134405E+01_JPRB, 0.134754E+01_JPRB, 0.135053E+01_JPRB, 0.135301E+01_JPRB &
  &, 0.135498E+01_JPRB, 0.135642E+01_JPRB, 0.135736E+01_JPRB &
  &, 0.135778E+01_JPRB, 0.135768E+01_JPRB, 0.135706E+01_JPRB, 0.135593E+01_JPRB &
  &, 0.135429E+01_JPRB, 0.135214E+01_JPRB, 0.134948E+01_JPRB &
  &, 0.134632E+01_JPRB, 0.134265E+01_JPRB, 0.133850E+01_JPRB, 0.133385E+01_JPRB &
  &, 0.132872E+01_JPRB, 0.132312E+01_JPRB, 0.131703E+01_JPRB &
  &, 0.131049E+01_JPRB, 0.130349E+01_JPRB, 0.129602E+01_JPRB, 0.128813E+01_JPRB &
  &, 0.127980E+01_JPRB, 0.127105E+01_JPRB, 0.126188E+01_JPRB &
  &, 0.125232E+01_JPRB, 0.124236E+01_JPRB, 0.123201E+01_JPRB, 0.122129E+01_JPRB &
  &, 0.121022E+01_JPRB, 0.119879E+01_JPRB, 0.118702E+01_JPRB &
  &, 0.117493E+01_JPRB, 0.116253E+01_JPRB, 0.114982E+01_JPRB, 0.113683E+01_JPRB &
  &, 0.112355E+01_JPRB, 0.111001E+01_JPRB, 0.109624E+01_JPRB &
  &, 0.108221E+01_JPRB, 0.106796E+01_JPRB, 0.105351E+01_JPRB, 0.103885E+01_JPRB &
  &, 0.102403E+01_JPRB, 0.100902E+01_JPRB, 0.993858E+00_JPRB &
  &, 0.978544E+00_JPRB, 0.963109E+00_JPRB, 0.947540E+00_JPRB, 0.931871E+00_JPRB &
  &, 0.916137E+00_JPRB, 0.900295E+00_JPRB, 0.884408E+00_JPRB &
  &, 0.868455E+00_JPRB, 0.852445E+00_JPRB, 0.836441E+00_JPRB, 0.820392E+00_JPRB &
  &, 0.804364E+00_JPRB, 0.788330E+00_JPRB, 0.772327E+00_JPRB &
  &, 0.756328E+00_JPRB, 0.740397E+00_JPRB, 0.724506E+00_JPRB, 0.708690E+00_JPRB &
  &, 0.692950E+00_JPRB, 0.677284E+00_JPRB, 0.661693E+00_JPRB &
  &, 0.646208E+00_JPRB, 0.630864E+00_JPRB, 0.615622E+00_JPRB, 0.600512E+00_JPRB &
  &, 0.585568E+00_JPRB, 0.570746E+00_JPRB, 0.556076E+00_JPRB &
  &, 0.541549E+00_JPRB, 0.527196E+00_JPRB, 0.513048E+00_JPRB, 0.499052E+00_JPRB &
  &, 0.485237E+00_JPRB, 0.471631E+00_JPRB, 0.458221E+00_JPRB &
  &, 0.444989E+00_JPRB, 0.431964E+00_JPRB, 0.419172E+00_JPRB, 0.406595E+00_JPRB &
  &, 0.394211E+00_JPRB, 0.382047E+00_JPRB, 0.370126E+00_JPRB &
  &, 0.358427E+00_JPRB, 0.346973E+00_JPRB, 0.335686E+00_JPRB, 0.324693E+00_JPRB &
  &, 0.313912E+00_JPRB, 0.303366E+00_JPRB, 0.293023E+00_JPRB &
  &, 0.282959E+00_JPRB, 0.273085E+00_JPRB, 0.263476E+00_JPRB, 0.254097E+00_JPRB &
  &, 0.244909E+00_JPRB, 0.235988E+00_JPRB, 0.227295E+00_JPRB &
  &, 0.218849E+00_JPRB, 0.210606E+00_JPRB, 0.202583E+00_JPRB, 0.194797E+00_JPRB &
  &, 0.187200E+00_JPRB, 0.179872E+00_JPRB, 0.172765E+00_JPRB/)
XCW( 744, :) = (/ &
  &  0.106347E+01_JPRB, 0.107866E+01_JPRB, 0.109356E+01_JPRB, 0.110816E+01_JPRB &
  &, 0.112244E+01_JPRB, 0.113640E+01_JPRB, 0.115002E+01_JPRB &
  &, 0.116331E+01_JPRB, 0.117623E+01_JPRB, 0.118880E+01_JPRB, 0.120099E+01_JPRB &
  &, 0.121280E+01_JPRB, 0.122423E+01_JPRB, 0.123525E+01_JPRB &
  &, 0.124586E+01_JPRB, 0.125605E+01_JPRB, 0.126582E+01_JPRB, 0.127515E+01_JPRB &
  &, 0.128404E+01_JPRB, 0.129248E+01_JPRB, 0.130047E+01_JPRB &
  &, 0.130799E+01_JPRB, 0.131503E+01_JPRB, 0.132161E+01_JPRB, 0.132770E+01_JPRB &
  &, 0.133330E+01_JPRB, 0.133840E+01_JPRB, 0.134301E+01_JPRB &
  &, 0.134712E+01_JPRB, 0.135072E+01_JPRB, 0.135381E+01_JPRB, 0.135640E+01_JPRB &
  &, 0.135846E+01_JPRB, 0.136002E+01_JPRB, 0.136105E+01_JPRB &
  &, 0.136157E+01_JPRB, 0.136157E+01_JPRB, 0.136106E+01_JPRB, 0.136003E+01_JPRB &
  &, 0.135849E+01_JPRB, 0.135643E+01_JPRB, 0.135387E+01_JPRB &
  &, 0.135080E+01_JPRB, 0.134724E+01_JPRB, 0.134318E+01_JPRB, 0.133862E+01_JPRB &
  &, 0.133359E+01_JPRB, 0.132806E+01_JPRB, 0.132207E+01_JPRB &
  &, 0.131561E+01_JPRB, 0.130868E+01_JPRB, 0.130132E+01_JPRB, 0.129351E+01_JPRB &
  &, 0.128525E+01_JPRB, 0.127657E+01_JPRB, 0.126749E+01_JPRB &
  &, 0.125800E+01_JPRB, 0.124810E+01_JPRB, 0.123782E+01_JPRB, 0.122717E+01_JPRB &
  &, 0.121614E+01_JPRB, 0.120478E+01_JPRB, 0.119308E+01_JPRB &
  &, 0.118105E+01_JPRB, 0.116869E+01_JPRB, 0.115602E+01_JPRB, 0.114308E+01_JPRB &
  &, 0.112986E+01_JPRB, 0.111636E+01_JPRB, 0.110262E+01_JPRB &
  &, 0.108864E+01_JPRB, 0.107442E+01_JPRB, 0.105999E+01_JPRB, 0.104536E+01_JPRB &
  &, 0.103056E+01_JPRB, 0.101556E+01_JPRB, 0.100041E+01_JPRB &
  &, 0.985135E+00_JPRB, 0.969708E+00_JPRB, 0.954143E+00_JPRB, 0.938500E+00_JPRB &
  &, 0.922738E+00_JPRB, 0.906917E+00_JPRB, 0.890993E+00_JPRB &
  &, 0.875055E+00_JPRB, 0.859057E+00_JPRB, 0.843003E+00_JPRB, 0.826959E+00_JPRB &
  &, 0.810902E+00_JPRB, 0.794867E+00_JPRB, 0.778827E+00_JPRB &
  &, 0.762819E+00_JPRB, 0.746844E+00_JPRB, 0.730904E+00_JPRB, 0.715068E+00_JPRB &
  &, 0.699269E+00_JPRB, 0.683576E+00_JPRB, 0.667953E+00_JPRB &
  &, 0.652433E+00_JPRB, 0.637013E+00_JPRB, 0.621727E+00_JPRB, 0.606569E+00_JPRB &
  &, 0.591535E+00_JPRB, 0.576657E+00_JPRB, 0.561926E+00_JPRB &
  &, 0.547375E+00_JPRB, 0.532953E+00_JPRB, 0.518691E+00_JPRB, 0.504658E+00_JPRB &
  &, 0.490761E+00_JPRB, 0.477069E+00_JPRB, 0.463611E+00_JPRB &
  &, 0.450284E+00_JPRB, 0.437204E+00_JPRB, 0.424354E+00_JPRB, 0.411668E+00_JPRB &
  &, 0.399218E+00_JPRB, 0.386984E+00_JPRB, 0.374990E+00_JPRB &
  &, 0.363163E+00_JPRB, 0.351627E+00_JPRB, 0.340306E+00_JPRB, 0.329172E+00_JPRB &
  &, 0.318297E+00_JPRB, 0.307654E+00_JPRB, 0.297264E+00_JPRB &
  &, 0.287094E+00_JPRB, 0.277166E+00_JPRB, 0.267445E+00_JPRB, 0.257948E+00_JPRB &
  &, 0.248755E+00_JPRB, 0.239710E+00_JPRB, 0.230949E+00_JPRB &
  &, 0.222370E+00_JPRB, 0.214052E+00_JPRB, 0.205950E+00_JPRB, 0.198082E+00_JPRB &
  &, 0.190401E+00_JPRB, 0.182985E+00_JPRB, 0.175787E+00_JPRB/)
XCW( 745, :) = (/ &
  &  0.106380E+01_JPRB, 0.107907E+01_JPRB, 0.109406E+01_JPRB, 0.110874E+01_JPRB &
  &, 0.112311E+01_JPRB, 0.113716E+01_JPRB, 0.115088E+01_JPRB &
  &, 0.116425E+01_JPRB, 0.117728E+01_JPRB, 0.118994E+01_JPRB, 0.120223E+01_JPRB &
  &, 0.121414E+01_JPRB, 0.122566E+01_JPRB, 0.123677E+01_JPRB &
  &, 0.124749E+01_JPRB, 0.125769E+01_JPRB, 0.126765E+01_JPRB, 0.127708E+01_JPRB &
  &, 0.128608E+01_JPRB, 0.129462E+01_JPRB, 0.130271E+01_JPRB &
  &, 0.131033E+01_JPRB, 0.131749E+01_JPRB, 0.132416E+01_JPRB, 0.133036E+01_JPRB &
  &, 0.133606E+01_JPRB, 0.134128E+01_JPRB, 0.134599E+01_JPRB &
  &, 0.135020E+01_JPRB, 0.135391E+01_JPRB, 0.135711E+01_JPRB, 0.135979E+01_JPRB &
  &, 0.136197E+01_JPRB, 0.136362E+01_JPRB, 0.136476E+01_JPRB &
  &, 0.136538E+01_JPRB, 0.136549E+01_JPRB, 0.136508E+01_JPRB, 0.136415E+01_JPRB &
  &, 0.136270E+01_JPRB, 0.136075E+01_JPRB, 0.135828E+01_JPRB &
  &, 0.135531E+01_JPRB, 0.135185E+01_JPRB, 0.134788E+01_JPRB, 0.134342E+01_JPRB &
  &, 0.133846E+01_JPRB, 0.133303E+01_JPRB, 0.132703E+01_JPRB &
  &, 0.132075E+01_JPRB, 0.131392E+01_JPRB, 0.130662E+01_JPRB, 0.129890E+01_JPRB &
  &, 0.129073E+01_JPRB, 0.128212E+01_JPRB, 0.127310E+01_JPRB &
  &, 0.126368E+01_JPRB, 0.125387E+01_JPRB, 0.124366E+01_JPRB, 0.123308E+01_JPRB &
  &, 0.122212E+01_JPRB, 0.121081E+01_JPRB, 0.119916E+01_JPRB &
  &, 0.118718E+01_JPRB, 0.117488E+01_JPRB, 0.116228E+01_JPRB, 0.114938E+01_JPRB &
  &, 0.113619E+01_JPRB, 0.112275E+01_JPRB, 0.110904E+01_JPRB &
  &, 0.109509E+01_JPRB, 0.108090E+01_JPRB, 0.106652E+01_JPRB, 0.105191E+01_JPRB &
  &, 0.103713E+01_JPRB, 0.102217E+01_JPRB, 0.100704E+01_JPRB &
  &, 0.991750E+00_JPRB, 0.976332E+00_JPRB, 0.960797E+00_JPRB, 0.945156E+00_JPRB &
  &, 0.929392E+00_JPRB, 0.913566E+00_JPRB, 0.897661E+00_JPRB &
  &, 0.881711E+00_JPRB, 0.865696E+00_JPRB, 0.849652E+00_JPRB, 0.833585E+00_JPRB &
  &, 0.817501E+00_JPRB, 0.801434E+00_JPRB, 0.785359E+00_JPRB &
  &, 0.769342E+00_JPRB, 0.753323E+00_JPRB, 0.737368E+00_JPRB, 0.721479E+00_JPRB &
  &, 0.705657E+00_JPRB, 0.689903E+00_JPRB, 0.674249E+00_JPRB &
  &, 0.658694E+00_JPRB, 0.643235E+00_JPRB, 0.627906E+00_JPRB, 0.612665E+00_JPRB &
  &, 0.597580E+00_JPRB, 0.582646E+00_JPRB, 0.567855E+00_JPRB &
  &, 0.553240E+00_JPRB, 0.538751E+00_JPRB, 0.524457E+00_JPRB, 0.510307E+00_JPRB &
  &, 0.496371E+00_JPRB, 0.482593E+00_JPRB, 0.469045E+00_JPRB &
  &, 0.455669E+00_JPRB, 0.442535E+00_JPRB, 0.429582E+00_JPRB, 0.416835E+00_JPRB &
  &, 0.404272E+00_JPRB, 0.391969E+00_JPRB, 0.379853E+00_JPRB &
  &, 0.367999E+00_JPRB, 0.356332E+00_JPRB, 0.344926E+00_JPRB, 0.333755E+00_JPRB &
  &, 0.322788E+00_JPRB, 0.312049E+00_JPRB, 0.301558E+00_JPRB &
  &, 0.291284E+00_JPRB, 0.281304E+00_JPRB, 0.271470E+00_JPRB, 0.261915E+00_JPRB &
  &, 0.252602E+00_JPRB, 0.243491E+00_JPRB, 0.234602E+00_JPRB &
  &, 0.226012E+00_JPRB, 0.217559E+00_JPRB, 0.209379E+00_JPRB, 0.201431E+00_JPRB &
  &, 0.193666E+00_JPRB, 0.186163E+00_JPRB, 0.178876E+00_JPRB/)
XCW( 746, :) = (/ &
  &  0.106412E+01_JPRB, 0.107948E+01_JPRB, 0.109455E+01_JPRB, 0.110932E+01_JPRB &
  &, 0.112379E+01_JPRB, 0.113793E+01_JPRB, 0.115174E+01_JPRB &
  &, 0.116521E+01_JPRB, 0.117832E+01_JPRB, 0.119108E+01_JPRB, 0.120347E+01_JPRB &
  &, 0.121547E+01_JPRB, 0.122709E+01_JPRB, 0.123831E+01_JPRB &
  &, 0.124912E+01_JPRB, 0.125952E+01_JPRB, 0.126949E+01_JPRB, 0.127902E+01_JPRB &
  &, 0.128812E+01_JPRB, 0.129677E+01_JPRB, 0.130496E+01_JPRB &
  &, 0.131269E+01_JPRB, 0.131995E+01_JPRB, 0.132673E+01_JPRB, 0.133303E+01_JPRB &
  &, 0.133884E+01_JPRB, 0.134416E+01_JPRB, 0.134898E+01_JPRB &
  &, 0.135330E+01_JPRB, 0.135711E+01_JPRB, 0.136041E+01_JPRB, 0.136320E+01_JPRB &
  &, 0.136548E+01_JPRB, 0.136724E+01_JPRB, 0.136848E+01_JPRB &
  &, 0.136921E+01_JPRB, 0.136942E+01_JPRB, 0.136910E+01_JPRB, 0.136828E+01_JPRB &
  &, 0.136694E+01_JPRB, 0.136508E+01_JPRB, 0.136272E+01_JPRB &
  &, 0.135984E+01_JPRB, 0.135647E+01_JPRB, 0.135259E+01_JPRB, 0.134822E+01_JPRB &
  &, 0.134337E+01_JPRB, 0.133803E+01_JPRB, 0.133221E+01_JPRB &
  &, 0.132592E+01_JPRB, 0.131917E+01_JPRB, 0.131197E+01_JPRB, 0.130432E+01_JPRB &
  &, 0.129622E+01_JPRB, 0.128770E+01_JPRB, 0.127877E+01_JPRB &
  &, 0.126942E+01_JPRB, 0.125966E+01_JPRB, 0.124953E+01_JPRB, 0.123900E+01_JPRB &
  &, 0.122811E+01_JPRB, 0.121687E+01_JPRB, 0.120529E+01_JPRB &
  &, 0.119335E+01_JPRB, 0.118111E+01_JPRB, 0.116855E+01_JPRB, 0.115571E+01_JPRB &
  &, 0.114257E+01_JPRB, 0.112916E+01_JPRB, 0.111550E+01_JPRB &
  &, 0.110159E+01_JPRB, 0.108745E+01_JPRB, 0.107307E+01_JPRB, 0.105851E+01_JPRB &
  &, 0.104375E+01_JPRB, 0.102881E+01_JPRB, 0.101369E+01_JPRB &
  &, 0.998439E+00_JPRB, 0.983030E+00_JPRB, 0.967501E+00_JPRB, 0.951863E+00_JPRB &
  &, 0.936125E+00_JPRB, 0.920269E+00_JPRB, 0.904383E+00_JPRB &
  &, 0.888394E+00_JPRB, 0.872393E+00_JPRB, 0.856330E+00_JPRB, 0.840240E+00_JPRB &
  &, 0.824159E+00_JPRB, 0.808062E+00_JPRB, 0.791984E+00_JPRB &
  &, 0.775928E+00_JPRB, 0.759899E+00_JPRB, 0.743897E+00_JPRB, 0.727957E+00_JPRB &
  &, 0.712113E+00_JPRB, 0.696298E+00_JPRB, 0.680614E+00_JPRB &
  &, 0.664990E+00_JPRB, 0.649494E+00_JPRB, 0.634123E+00_JPRB, 0.618835E+00_JPRB &
  &, 0.603700E+00_JPRB, 0.588712E+00_JPRB, 0.573864E+00_JPRB &
  &, 0.559146E+00_JPRB, 0.544630E+00_JPRB, 0.530224E+00_JPRB, 0.516039E+00_JPRB &
  &, 0.502023E+00_JPRB, 0.488204E+00_JPRB, 0.474568E+00_JPRB &
  &, 0.461098E+00_JPRB, 0.447866E+00_JPRB, 0.434856E+00_JPRB, 0.422001E+00_JPRB &
  &, 0.409422E+00_JPRB, 0.397003E+00_JPRB, 0.384815E+00_JPRB &
  &, 0.372885E+00_JPRB, 0.361139E+00_JPRB, 0.349649E+00_JPRB, 0.338390E+00_JPRB &
  &, 0.327332E+00_JPRB, 0.316497E+00_JPRB, 0.305907E+00_JPRB &
  &, 0.295585E+00_JPRB, 0.285441E+00_JPRB, 0.275552E+00_JPRB, 0.265939E+00_JPRB &
  &, 0.256507E+00_JPRB, 0.247332E+00_JPRB, 0.238375E+00_JPRB &
  &, 0.229655E+00_JPRB, 0.221127E+00_JPRB, 0.212871E+00_JPRB, 0.204843E+00_JPRB &
  &, 0.196994E+00_JPRB, 0.189406E+00_JPRB, 0.182030E+00_JPRB/)
XCW( 747, :) = (/ &
  &  0.106445E+01_JPRB, 0.107989E+01_JPRB, 0.109505E+01_JPRB, 0.110991E+01_JPRB &
  &, 0.112446E+01_JPRB, 0.113869E+01_JPRB, 0.115260E+01_JPRB &
  &, 0.116616E+01_JPRB, 0.117937E+01_JPRB, 0.119222E+01_JPRB, 0.120471E+01_JPRB &
  &, 0.121681E+01_JPRB, 0.122853E+01_JPRB, 0.123985E+01_JPRB &
  &, 0.125076E+01_JPRB, 0.126126E+01_JPRB, 0.127133E+01_JPRB, 0.128097E+01_JPRB &
  &, 0.129017E+01_JPRB, 0.129892E+01_JPRB, 0.130722E+01_JPRB &
  &, 0.131505E+01_JPRB, 0.132242E+01_JPRB, 0.132930E+01_JPRB, 0.133571E+01_JPRB &
  &, 0.134163E+01_JPRB, 0.134705E+01_JPRB, 0.135198E+01_JPRB &
  &, 0.135640E+01_JPRB, 0.136032E+01_JPRB, 0.136373E+01_JPRB, 0.136663E+01_JPRB &
  &, 0.136901E+01_JPRB, 0.137088E+01_JPRB, 0.137222E+01_JPRB &
  &, 0.137305E+01_JPRB, 0.137336E+01_JPRB, 0.137315E+01_JPRB, 0.137243E+01_JPRB &
  &, 0.137118E+01_JPRB, 0.136943E+01_JPRB, 0.136716E+01_JPRB &
  &, 0.136439E+01_JPRB, 0.136111E+01_JPRB, 0.135733E+01_JPRB, 0.135306E+01_JPRB &
  &, 0.134830E+01_JPRB, 0.134304E+01_JPRB, 0.133732E+01_JPRB &
  &, 0.133111E+01_JPRB, 0.132446E+01_JPRB, 0.131733E+01_JPRB, 0.130977E+01_JPRB &
  &, 0.130175E+01_JPRB, 0.129330E+01_JPRB, 0.128445E+01_JPRB &
  &, 0.127517E+01_JPRB, 0.126549E+01_JPRB, 0.125542E+01_JPRB, 0.124498E+01_JPRB &
  &, 0.123414E+01_JPRB, 0.122296E+01_JPRB, 0.121143E+01_JPRB &
  &, 0.119957E+01_JPRB, 0.118738E+01_JPRB, 0.117489E+01_JPRB, 0.116207E+01_JPRB &
  &, 0.114898E+01_JPRB, 0.113563E+01_JPRB, 0.112197E+01_JPRB &
  &, 0.110813E+01_JPRB, 0.109402E+01_JPRB, 0.107969E+01_JPRB, 0.106515E+01_JPRB &
  &, 0.105041E+01_JPRB, 0.103549E+01_JPRB, 0.102039E+01_JPRB &
  &, 0.100515E+01_JPRB, 0.989753E+00_JPRB, 0.974256E+00_JPRB, 0.958596E+00_JPRB &
  &, 0.942858E+00_JPRB, 0.927052E+00_JPRB, 0.911132E+00_JPRB &
  &, 0.895161E+00_JPRB, 0.879118E+00_JPRB, 0.863066E+00_JPRB, 0.846954E+00_JPRB &
  &, 0.830847E+00_JPRB, 0.814751E+00_JPRB, 0.798639E+00_JPRB &
  &, 0.782546E+00_JPRB, 0.766474E+00_JPRB, 0.750459E+00_JPRB, 0.734501E+00_JPRB &
  &, 0.718603E+00_JPRB, 0.702763E+00_JPRB, 0.687015E+00_JPRB &
  &, 0.671358E+00_JPRB, 0.655825E+00_JPRB, 0.640376E+00_JPRB, 0.625044E+00_JPRB &
  &, 0.609859E+00_JPRB, 0.594818E+00_JPRB, 0.579912E+00_JPRB &
  &, 0.565133E+00_JPRB, 0.550551E+00_JPRB, 0.536115E+00_JPRB, 0.521814E+00_JPRB &
  &, 0.507762E+00_JPRB, 0.493859E+00_JPRB, 0.480135E+00_JPRB &
  &, 0.466617E+00_JPRB, 0.453288E+00_JPRB, 0.440176E+00_JPRB, 0.427262E+00_JPRB &
  &, 0.414572E+00_JPRB, 0.402085E+00_JPRB, 0.389826E+00_JPRB &
  &, 0.377821E+00_JPRB, 0.365995E+00_JPRB, 0.354423E+00_JPRB, 0.343026E+00_JPRB &
  &, 0.331929E+00_JPRB, 0.320999E+00_JPRB, 0.310365E+00_JPRB &
  &, 0.299885E+00_JPRB, 0.289691E+00_JPRB, 0.279748E+00_JPRB, 0.269963E+00_JPRB &
  &, 0.260470E+00_JPRB, 0.251231E+00_JPRB, 0.242148E+00_JPRB &
  &, 0.233357E+00_JPRB, 0.224757E+00_JPRB, 0.216425E+00_JPRB, 0.208254E+00_JPRB &
  &, 0.200259E+00_JPRB, 0.192649E+00_JPRB, 0.185184E+00_JPRB/)
XCW( 748, :) = (/ &
  &  0.106477E+01_JPRB, 0.108031E+01_JPRB, 0.109555E+01_JPRB, 0.111050E+01_JPRB &
  &, 0.112514E+01_JPRB, 0.113946E+01_JPRB, 0.115346E+01_JPRB &
  &, 0.116711E+01_JPRB, 0.118042E+01_JPRB, 0.119337E+01_JPRB, 0.120595E+01_JPRB &
  &, 0.121815E+01_JPRB, 0.122997E+01_JPRB, 0.124139E+01_JPRB &
  &, 0.125240E+01_JPRB, 0.126300E+01_JPRB, 0.127318E+01_JPRB, 0.128292E+01_JPRB &
  &, 0.129222E+01_JPRB, 0.130108E+01_JPRB, 0.130948E+01_JPRB &
  &, 0.131742E+01_JPRB, 0.132489E+01_JPRB, 0.133189E+01_JPRB, 0.133840E+01_JPRB &
  &, 0.134443E+01_JPRB, 0.134996E+01_JPRB, 0.135499E+01_JPRB &
  &, 0.135952E+01_JPRB, 0.136354E+01_JPRB, 0.136706E+01_JPRB, 0.137006E+01_JPRB &
  &, 0.137255E+01_JPRB, 0.137452E+01_JPRB, 0.137597E+01_JPRB &
  &, 0.137691E+01_JPRB, 0.137732E+01_JPRB, 0.137722E+01_JPRB, 0.137659E+01_JPRB &
  &, 0.137545E+01_JPRB, 0.137380E+01_JPRB, 0.137163E+01_JPRB &
  &, 0.136896E+01_JPRB, 0.136578E+01_JPRB, 0.136209E+01_JPRB, 0.135792E+01_JPRB &
  &, 0.135323E+01_JPRB, 0.134808E+01_JPRB, 0.134245E+01_JPRB &
  &, 0.133633E+01_JPRB, 0.132976E+01_JPRB, 0.132272E+01_JPRB, 0.131523E+01_JPRB &
  &, 0.130730E+01_JPRB, 0.129894E+01_JPRB, 0.129016E+01_JPRB &
  &, 0.128096E+01_JPRB, 0.127135E+01_JPRB, 0.126136E+01_JPRB, 0.125097E+01_JPRB &
  &, 0.124022E+01_JPRB, 0.122909E+01_JPRB, 0.121762E+01_JPRB &
  &, 0.120582E+01_JPRB, 0.119367E+01_JPRB, 0.118124E+01_JPRB, 0.116848E+01_JPRB &
  &, 0.115543E+01_JPRB, 0.114212E+01_JPRB, 0.112853E+01_JPRB &
  &, 0.111471E+01_JPRB, 0.110063E+01_JPRB, 0.108633E+01_JPRB, 0.107181E+01_JPRB &
  &, 0.105710E+01_JPRB, 0.104222E+01_JPRB, 0.102714E+01_JPRB &
  &, 0.101191E+01_JPRB, 0.996550E+00_JPRB, 0.981036E+00_JPRB, 0.965407E+00_JPRB &
  &, 0.949670E+00_JPRB, 0.933835E+00_JPRB, 0.917936E+00_JPRB &
  &, 0.901956E+00_JPRB, 0.885927E+00_JPRB, 0.869859E+00_JPRB, 0.853727E+00_JPRB &
  &, 0.837626E+00_JPRB, 0.821471E+00_JPRB, 0.805357E+00_JPRB &
  &, 0.789227E+00_JPRB, 0.773147E+00_JPRB, 0.757086E+00_JPRB, 0.741113E+00_JPRB &
  &, 0.725160E+00_JPRB, 0.709297E+00_JPRB, 0.693522E+00_JPRB &
  &, 0.677797E+00_JPRB, 0.662192E+00_JPRB, 0.646704E+00_JPRB, 0.631327E+00_JPRB &
  &, 0.616095E+00_JPRB, 0.600962E+00_JPRB, 0.586000E+00_JPRB &
  &, 0.571199E+00_JPRB, 0.556512E+00_JPRB, 0.542007E+00_JPRB, 0.527674E+00_JPRB &
  &, 0.513543E+00_JPRB, 0.499558E+00_JPRB, 0.485790E+00_JPRB &
  &, 0.472181E+00_JPRB, 0.458802E+00_JPRB, 0.445589E+00_JPRB, 0.432617E+00_JPRB &
  &, 0.419817E+00_JPRB, 0.407264E+00_JPRB, 0.394935E+00_JPRB &
  &, 0.382807E+00_JPRB, 0.370903E+00_JPRB, 0.359249E+00_JPRB, 0.347765E+00_JPRB &
  &, 0.336579E+00_JPRB, 0.325555E+00_JPRB, 0.314823E+00_JPRB &
  &, 0.304296E+00_JPRB, 0.293996E+00_JPRB, 0.283943E+00_JPRB, 0.274102E+00_JPRB &
  &, 0.264491E+00_JPRB, 0.255131E+00_JPRB, 0.246041E+00_JPRB &
  &, 0.237121E+00_JPRB, 0.228448E+00_JPRB, 0.219979E+00_JPRB, 0.211792E+00_JPRB &
  &, 0.203780E+00_JPRB, 0.196022E+00_JPRB, 0.188404E+00_JPRB/)
XCW( 749, :) = (/ &
  &  0.106510E+01_JPRB, 0.108072E+01_JPRB, 0.109605E+01_JPRB, 0.111109E+01_JPRB &
  &, 0.112582E+01_JPRB, 0.114023E+01_JPRB, 0.115432E+01_JPRB &
  &, 0.116807E+01_JPRB, 0.118147E+01_JPRB, 0.119452E+01_JPRB, 0.120720E+01_JPRB &
  &, 0.121950E+01_JPRB, 0.123142E+01_JPRB, 0.124294E+01_JPRB &
  &, 0.125405E+01_JPRB, 0.126475E+01_JPRB, 0.127503E+01_JPRB, 0.128488E+01_JPRB &
  &, 0.129429E+01_JPRB, 0.130325E+01_JPRB, 0.131176E+01_JPRB &
  &, 0.131980E+01_JPRB, 0.132738E+01_JPRB, 0.133448E+01_JPRB, 0.134110E+01_JPRB &
  &, 0.134723E+01_JPRB, 0.135287E+01_JPRB, 0.135801E+01_JPRB &
  &, 0.136265E+01_JPRB, 0.136678E+01_JPRB, 0.137040E+01_JPRB, 0.137351E+01_JPRB &
  &, 0.137611E+01_JPRB, 0.137819E+01_JPRB, 0.137974E+01_JPRB &
  &, 0.138078E+01_JPRB, 0.138130E+01_JPRB, 0.138130E+01_JPRB, 0.138078E+01_JPRB &
  &, 0.137973E+01_JPRB, 0.137818E+01_JPRB, 0.137612E+01_JPRB &
  &, 0.137354E+01_JPRB, 0.137045E+01_JPRB, 0.136687E+01_JPRB, 0.136278E+01_JPRB &
  &, 0.135821E+01_JPRB, 0.135314E+01_JPRB, 0.134759E+01_JPRB &
  &, 0.134157E+01_JPRB, 0.133509E+01_JPRB, 0.132814E+01_JPRB, 0.132073E+01_JPRB &
  &, 0.131288E+01_JPRB, 0.130461E+01_JPRB, 0.129589E+01_JPRB &
  &, 0.128677E+01_JPRB, 0.127725E+01_JPRB, 0.126731E+01_JPRB, 0.125699E+01_JPRB &
  &, 0.124631E+01_JPRB, 0.123525E+01_JPRB, 0.122384E+01_JPRB &
  &, 0.121210E+01_JPRB, 0.120002E+01_JPRB, 0.118762E+01_JPRB, 0.117493E+01_JPRB &
  &, 0.116192E+01_JPRB, 0.114865E+01_JPRB, 0.113512E+01_JPRB &
  &, 0.112133E+01_JPRB, 0.110728E+01_JPRB, 0.109301E+01_JPRB, 0.107854E+01_JPRB &
  &, 0.106386E+01_JPRB, 0.104898E+01_JPRB, 0.103394E+01_JPRB &
  &, 0.101872E+01_JPRB, 0.100337E+01_JPRB, 0.987867E+00_JPRB, 0.972269E+00_JPRB &
  &, 0.956534E+00_JPRB, 0.940698E+00_JPRB, 0.924795E+00_JPRB &
  &, 0.908806E+00_JPRB, 0.892766E+00_JPRB, 0.876681E+00_JPRB, 0.860559E+00_JPRB &
  &, 0.844434E+00_JPRB, 0.828282E+00_JPRB, 0.812106E+00_JPRB &
  &, 0.795972E+00_JPRB, 0.779852E+00_JPRB, 0.763779E+00_JPRB, 0.747757E+00_JPRB &
  &, 0.731786E+00_JPRB, 0.715865E+00_JPRB, 0.700028E+00_JPRB &
  &, 0.684308E+00_JPRB, 0.668633E+00_JPRB, 0.653105E+00_JPRB, 0.637686E+00_JPRB &
  &, 0.622368E+00_JPRB, 0.607224E+00_JPRB, 0.592166E+00_JPRB &
  &, 0.577306E+00_JPRB, 0.562554E+00_JPRB, 0.547981E+00_JPRB, 0.533575E+00_JPRB &
  &, 0.519367E+00_JPRB, 0.505343E+00_JPRB, 0.491446E+00_JPRB &
  &, 0.477790E+00_JPRB, 0.464315E+00_JPRB, 0.451049E+00_JPRB, 0.437972E+00_JPRB &
  &, 0.425158E+00_JPRB, 0.412491E+00_JPRB, 0.400093E+00_JPRB &
  &, 0.387842E+00_JPRB, 0.375861E+00_JPRB, 0.364126E+00_JPRB, 0.352609E+00_JPRB &
  &, 0.341281E+00_JPRB, 0.330218E+00_JPRB, 0.319335E+00_JPRB &
  &, 0.308762E+00_JPRB, 0.298357E+00_JPRB, 0.288195E+00_JPRB, 0.278298E+00_JPRB &
  &, 0.268629E+00_JPRB, 0.259148E+00_JPRB, 0.249934E+00_JPRB &
  &, 0.240946E+00_JPRB, 0.232201E+00_JPRB, 0.223657E+00_JPRB, 0.215331E+00_JPRB &
  &, 0.207237E+00_JPRB, 0.199395E+00_JPRB, 0.191755E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART107',1,ZHOOK_HANDLE)
END SUBROUTINE PART107

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART108

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART108',0,ZHOOK_HANDLE)

XCW( 750, :) = (/ &
  &  0.106543E+01_JPRB, 0.108113E+01_JPRB, 0.109655E+01_JPRB, 0.111168E+01_JPRB &
  &, 0.112650E+01_JPRB, 0.114101E+01_JPRB, 0.115519E+01_JPRB &
  &, 0.116903E+01_JPRB, 0.118253E+01_JPRB, 0.119567E+01_JPRB, 0.120845E+01_JPRB &
  &, 0.122085E+01_JPRB, 0.123287E+01_JPRB, 0.124449E+01_JPRB &
  &, 0.125570E+01_JPRB, 0.126651E+01_JPRB, 0.127689E+01_JPRB, 0.128684E+01_JPRB &
  &, 0.129636E+01_JPRB, 0.130542E+01_JPRB, 0.131403E+01_JPRB &
  &, 0.132219E+01_JPRB, 0.132987E+01_JPRB, 0.133708E+01_JPRB, 0.134381E+01_JPRB &
  &, 0.135004E+01_JPRB, 0.135579E+01_JPRB, 0.136104E+01_JPRB &
  &, 0.136579E+01_JPRB, 0.137003E+01_JPRB, 0.137376E+01_JPRB, 0.137697E+01_JPRB &
  &, 0.137967E+01_JPRB, 0.138186E+01_JPRB, 0.138352E+01_JPRB &
  &, 0.138467E+01_JPRB, 0.138529E+01_JPRB, 0.138540E+01_JPRB, 0.138497E+01_JPRB &
  &, 0.138404E+01_JPRB, 0.138259E+01_JPRB, 0.138062E+01_JPRB &
  &, 0.137815E+01_JPRB, 0.137517E+01_JPRB, 0.137167E+01_JPRB, 0.136768E+01_JPRB &
  &, 0.136320E+01_JPRB, 0.135822E+01_JPRB, 0.135277E+01_JPRB &
  &, 0.134684E+01_JPRB, 0.134044E+01_JPRB, 0.133357E+01_JPRB, 0.132625E+01_JPRB &
  &, 0.131849E+01_JPRB, 0.131029E+01_JPRB, 0.130166E+01_JPRB &
  &, 0.129262E+01_JPRB, 0.128316E+01_JPRB, 0.127330E+01_JPRB, 0.126305E+01_JPRB &
  &, 0.125244E+01_JPRB, 0.124145E+01_JPRB, 0.123010E+01_JPRB &
  &, 0.121841E+01_JPRB, 0.120640E+01_JPRB, 0.119405E+01_JPRB, 0.118140E+01_JPRB &
  &, 0.116845E+01_JPRB, 0.115522E+01_JPRB, 0.114173E+01_JPRB &
  &, 0.112797E+01_JPRB, 0.111398E+01_JPRB, 0.109976E+01_JPRB, 0.108530E+01_JPRB &
  &, 0.107064E+01_JPRB, 0.105580E+01_JPRB, 0.104078E+01_JPRB &
  &, 0.102558E+01_JPRB, 0.101024E+01_JPRB, 0.994749E+00_JPRB, 0.979156E+00_JPRB &
  &, 0.963425E+00_JPRB, 0.947615E+00_JPRB, 0.931709E+00_JPRB &
  &, 0.915712E+00_JPRB, 0.899661E+00_JPRB, 0.883561E+00_JPRB, 0.867450E+00_JPRB &
  &, 0.851273E+00_JPRB, 0.835124E+00_JPRB, 0.818949E+00_JPRB &
  &, 0.802780E+00_JPRB, 0.786621E+00_JPRB, 0.770538E+00_JPRB, 0.754469E+00_JPRB &
  &, 0.738446E+00_JPRB, 0.722503E+00_JPRB, 0.706640E+00_JPRB &
  &, 0.690855E+00_JPRB, 0.675146E+00_JPRB, 0.659544E+00_JPRB, 0.644082E+00_JPRB &
  &, 0.628719E+00_JPRB, 0.613485E+00_JPRB, 0.598412E+00_JPRB &
  &, 0.583453E+00_JPRB, 0.568679E+00_JPRB, 0.554038E+00_JPRB, 0.539561E+00_JPRB &
  &, 0.525276E+00_JPRB, 0.511172E+00_JPRB, 0.497233E+00_JPRB &
  &, 0.483488E+00_JPRB, 0.469919E+00_JPRB, 0.456600E+00_JPRB, 0.443420E+00_JPRB &
  &, 0.430499E+00_JPRB, 0.417767E+00_JPRB, 0.405252E+00_JPRB &
  &, 0.392977E+00_JPRB, 0.380920E+00_JPRB, 0.369054E+00_JPRB, 0.357452E+00_JPRB &
  &, 0.346036E+00_JPRB, 0.334881E+00_JPRB, 0.323956E+00_JPRB &
  &, 0.313228E+00_JPRB, 0.302774E+00_JPRB, 0.292561E+00_JPRB, 0.282552E+00_JPRB &
  &, 0.272767E+00_JPRB, 0.263225E+00_JPRB, 0.253887E+00_JPRB &
  &, 0.244831E+00_JPRB, 0.235954E+00_JPRB, 0.227336E+00_JPRB, 0.218932E+00_JPRB &
  &, 0.210758E+00_JPRB, 0.202833E+00_JPRB, 0.195106E+00_JPRB/)
XCW( 751, :) = (/ &
  &  0.106576E+01_JPRB, 0.108155E+01_JPRB, 0.109706E+01_JPRB, 0.111227E+01_JPRB &
  &, 0.112718E+01_JPRB, 0.114178E+01_JPRB, 0.115606E+01_JPRB &
  &, 0.117000E+01_JPRB, 0.118359E+01_JPRB, 0.119683E+01_JPRB, 0.120971E+01_JPRB &
  &, 0.122221E+01_JPRB, 0.123432E+01_JPRB, 0.124604E+01_JPRB &
  &, 0.125736E+01_JPRB, 0.126827E+01_JPRB, 0.127876E+01_JPRB, 0.128881E+01_JPRB &
  &, 0.129843E+01_JPRB, 0.130760E+01_JPRB, 0.131632E+01_JPRB &
  &, 0.132458E+01_JPRB, 0.133237E+01_JPRB, 0.133969E+01_JPRB, 0.134652E+01_JPRB &
  &, 0.135287E+01_JPRB, 0.135873E+01_JPRB, 0.136408E+01_JPRB &
  &, 0.136894E+01_JPRB, 0.137328E+01_JPRB, 0.137712E+01_JPRB, 0.138045E+01_JPRB &
  &, 0.138326E+01_JPRB, 0.138555E+01_JPRB, 0.138732E+01_JPRB &
  &, 0.138857E+01_JPRB, 0.138929E+01_JPRB, 0.138950E+01_JPRB, 0.138919E+01_JPRB &
  &, 0.138836E+01_JPRB, 0.138701E+01_JPRB, 0.138515E+01_JPRB &
  &, 0.138278E+01_JPRB, 0.137989E+01_JPRB, 0.137649E+01_JPRB, 0.137261E+01_JPRB &
  &, 0.136821E+01_JPRB, 0.136333E+01_JPRB, 0.135797E+01_JPRB &
  &, 0.135214E+01_JPRB, 0.134581E+01_JPRB, 0.133904E+01_JPRB, 0.133181E+01_JPRB &
  &, 0.132412E+01_JPRB, 0.131601E+01_JPRB, 0.130746E+01_JPRB &
  &, 0.129849E+01_JPRB, 0.128911E+01_JPRB, 0.127932E+01_JPRB, 0.126914E+01_JPRB &
  &, 0.125860E+01_JPRB, 0.124768E+01_JPRB, 0.123639E+01_JPRB &
  &, 0.122476E+01_JPRB, 0.121280E+01_JPRB, 0.120052E+01_JPRB, 0.118791E+01_JPRB &
  &, 0.117502E+01_JPRB, 0.116185E+01_JPRB, 0.114840E+01_JPRB &
  &, 0.113468E+01_JPRB, 0.112072E+01_JPRB, 0.110653E+01_JPRB, 0.109210E+01_JPRB &
  &, 0.107748E+01_JPRB, 0.106267E+01_JPRB, 0.104767E+01_JPRB &
  &, 0.103249E+01_JPRB, 0.101716E+01_JPRB, 0.100171E+01_JPRB, 0.986096E+00_JPRB &
  &, 0.970395E+00_JPRB, 0.954559E+00_JPRB, 0.938649E+00_JPRB &
  &, 0.922674E+00_JPRB, 0.906613E+00_JPRB, 0.890528E+00_JPRB, 0.874370E+00_JPRB &
  &, 0.858201E+00_JPRB, 0.841997E+00_JPRB, 0.825822E+00_JPRB &
  &, 0.809620E+00_JPRB, 0.793454E+00_JPRB, 0.777330E+00_JPRB, 0.761214E+00_JPRB &
  &, 0.745173E+00_JPRB, 0.729209E+00_JPRB, 0.713287E+00_JPRB &
  &, 0.697438E+00_JPRB, 0.681149E+00_JPRB, 0.666056E+00_JPRB, 0.650554E+00_JPRB &
  &, 0.635145E+00_JPRB, 0.619862E+00_JPRB, 0.604697E+00_JPRB &
  &, 0.589680E+00_JPRB, 0.574844E+00_JPRB, 0.560137E+00_JPRB, 0.545588E+00_JPRB &
  &, 0.531229E+00_JPRB, 0.517045E+00_JPRB, 0.503065E+00_JPRB &
  &, 0.489232E+00_JPRB, 0.475615E+00_JPRB, 0.462198E+00_JPRB, 0.448963E+00_JPRB &
  &, 0.435934E+00_JPRB, 0.423140E+00_JPRB, 0.410557E+00_JPRB &
  &, 0.398162E+00_JPRB, 0.386030E+00_JPRB, 0.374084E+00_JPRB, 0.362348E+00_JPRB &
  &, 0.350897E+00_JPRB, 0.339651E+00_JPRB, 0.328631E+00_JPRB &
  &, 0.317804E+00_JPRB, 0.307247E+00_JPRB, 0.296927E+00_JPRB, 0.286806E+00_JPRB &
  &, 0.276963E+00_JPRB, 0.267361E+00_JPRB, 0.257959E+00_JPRB &
  &, 0.248776E+00_JPRB, 0.239830E+00_JPRB, 0.231077E+00_JPRB, 0.222596E+00_JPRB &
  &, 0.214343E+00_JPRB, 0.206335E+00_JPRB, 0.198458E+00_JPRB/)
XCW( 752, :) = (/ &
  &  0.106609E+01_JPRB, 0.108196E+01_JPRB, 0.109756E+01_JPRB, 0.111287E+01_JPRB &
  &, 0.112787E+01_JPRB, 0.114256E+01_JPRB, 0.115693E+01_JPRB &
  &, 0.117096E+01_JPRB, 0.118465E+01_JPRB, 0.119799E+01_JPRB, 0.121096E+01_JPRB &
  &, 0.122356E+01_JPRB, 0.123578E+01_JPRB, 0.124760E+01_JPRB &
  &, 0.125902E+01_JPRB, 0.127004E+01_JPRB, 0.128063E+01_JPRB, 0.129079E+01_JPRB &
  &, 0.130051E+01_JPRB, 0.130979E+01_JPRB, 0.131862E+01_JPRB &
  &, 0.132698E+01_JPRB, 0.133488E+01_JPRB, 0.134231E+01_JPRB, 0.134925E+01_JPRB &
  &, 0.135570E+01_JPRB, 0.136167E+01_JPRB, 0.136713E+01_JPRB &
  &, 0.137210E+01_JPRB, 0.137655E+01_JPRB, 0.138050E+01_JPRB, 0.138394E+01_JPRB &
  &, 0.138685E+01_JPRB, 0.138925E+01_JPRB, 0.139113E+01_JPRB &
  &, 0.139249E+01_JPRB, 0.139332E+01_JPRB, 0.139364E+01_JPRB, 0.139339E+01_JPRB &
  &, 0.139270E+01_JPRB, 0.139146E+01_JPRB, 0.138970E+01_JPRB &
  &, 0.138742E+01_JPRB, 0.138463E+01_JPRB, 0.138134E+01_JPRB, 0.137754E+01_JPRB &
  &, 0.137325E+01_JPRB, 0.136847E+01_JPRB, 0.136320E+01_JPRB &
  &, 0.135745E+01_JPRB, 0.135123E+01_JPRB, 0.134454E+01_JPRB, 0.133739E+01_JPRB &
  &, 0.132979E+01_JPRB, 0.132175E+01_JPRB, 0.131329E+01_JPRB &
  &, 0.130439E+01_JPRB, 0.129509E+01_JPRB, 0.128539E+01_JPRB, 0.127528E+01_JPRB &
  &, 0.126480E+01_JPRB, 0.125393E+01_JPRB, 0.124272E+01_JPRB &
  &, 0.123115E+01_JPRB, 0.121925E+01_JPRB, 0.120702E+01_JPRB, 0.119448E+01_JPRB &
  &, 0.118163E+01_JPRB, 0.116850E+01_JPRB, 0.115509E+01_JPRB &
  &, 0.114143E+01_JPRB, 0.112750E+01_JPRB, 0.111334E+01_JPRB, 0.109896E+01_JPRB &
  &, 0.108435E+01_JPRB, 0.106956E+01_JPRB, 0.105458E+01_JPRB &
  &, 0.103945E+01_JPRB, 0.102414E+01_JPRB, 0.100869E+01_JPRB, 0.993087E+00_JPRB &
  &, 0.977391E+00_JPRB, 0.961583E+00_JPRB, 0.945672E+00_JPRB &
  &, 0.929691E+00_JPRB, 0.913621E+00_JPRB, 0.897524E+00_JPRB, 0.881349E+00_JPRB &
  &, 0.865160E+00_JPRB, 0.848961E+00_JPRB, 0.832758E+00_JPRB &
  &, 0.816554E+00_JPRB, 0.800353E+00_JPRB, 0.784187E+00_JPRB, 0.768059E+00_JPRB &
  &, 0.751969E+00_JPRB, 0.735951E+00_JPRB, 0.720004E+00_JPRB &
  &, 0.704128E+00_JPRB, 0.688281E+00_JPRB, 0.672642E+00_JPRB, 0.657063E+00_JPRB &
  &, 0.641610E+00_JPRB, 0.626279E+00_JPRB, 0.611062E+00_JPRB &
  &, 0.595988E+00_JPRB, 0.581050E+00_JPRB, 0.566319E+00_JPRB, 0.551700E+00_JPRB &
  &, 0.537267E+00_JPRB, 0.523004E+00_JPRB, 0.508942E+00_JPRB &
  &, 0.495020E+00_JPRB, 0.481356E+00_JPRB, 0.467843E+00_JPRB, 0.454553E+00_JPRB &
  &, 0.441418E+00_JPRB, 0.428561E+00_JPRB, 0.415863E+00_JPRB &
  &, 0.403397E+00_JPRB, 0.391191E+00_JPRB, 0.379167E+00_JPRB, 0.367348E+00_JPRB &
  &, 0.355811E+00_JPRB, 0.344475E+00_JPRB, 0.333360E+00_JPRB &
  &, 0.322435E+00_JPRB, 0.311776E+00_JPRB, 0.301406E+00_JPRB, 0.291175E+00_JPRB &
  &, 0.281218E+00_JPRB, 0.271497E+00_JPRB, 0.262032E+00_JPRB &
  &, 0.252783E+00_JPRB, 0.243706E+00_JPRB, 0.234943E+00_JPRB, 0.226324E+00_JPRB &
  &, 0.217992E+00_JPRB, 0.209838E+00_JPRB, 0.201940E+00_JPRB/)
XCW( 753, :) = (/ &
  &  0.106642E+01_JPRB, 0.108238E+01_JPRB, 0.109807E+01_JPRB, 0.111346E+01_JPRB &
  &, 0.112856E+01_JPRB, 0.114334E+01_JPRB, 0.115780E+01_JPRB &
  &, 0.117193E+01_JPRB, 0.118572E+01_JPRB, 0.119915E+01_JPRB, 0.121223E+01_JPRB &
  &, 0.122493E+01_JPRB, 0.123724E+01_JPRB, 0.124917E+01_JPRB &
  &, 0.126069E+01_JPRB, 0.127181E+01_JPRB, 0.128250E+01_JPRB, 0.129277E+01_JPRB &
  &, 0.130260E+01_JPRB, 0.131199E+01_JPRB, 0.132092E+01_JPRB &
  &, 0.132939E+01_JPRB, 0.133740E+01_JPRB, 0.134493E+01_JPRB, 0.135198E+01_JPRB &
  &, 0.135855E+01_JPRB, 0.136462E+01_JPRB, 0.137020E+01_JPRB &
  &, 0.137527E+01_JPRB, 0.137984E+01_JPRB, 0.138390E+01_JPRB, 0.138744E+01_JPRB &
  &, 0.139046E+01_JPRB, 0.139297E+01_JPRB, 0.139496E+01_JPRB &
  &, 0.139642E+01_JPRB, 0.139736E+01_JPRB, 0.139778E+01_JPRB, 0.139768E+01_JPRB &
  &, 0.139705E+01_JPRB, 0.139592E+01_JPRB, 0.139426E+01_JPRB &
  &, 0.139208E+01_JPRB, 0.138940E+01_JPRB, 0.138621E+01_JPRB, 0.138250E+01_JPRB &
  &, 0.137831E+01_JPRB, 0.137362E+01_JPRB, 0.136845E+01_JPRB &
  &, 0.136279E+01_JPRB, 0.135666E+01_JPRB, 0.135005E+01_JPRB, 0.134299E+01_JPRB &
  &, 0.133548E+01_JPRB, 0.132754E+01_JPRB, 0.131914E+01_JPRB &
  &, 0.131033E+01_JPRB, 0.130110E+01_JPRB, 0.129147E+01_JPRB, 0.128144E+01_JPRB &
  &, 0.127103E+01_JPRB, 0.126023E+01_JPRB, 0.124908E+01_JPRB &
  &, 0.123757E+01_JPRB, 0.122573E+01_JPRB, 0.121356E+01_JPRB, 0.120106E+01_JPRB &
  &, 0.118826E+01_JPRB, 0.117519E+01_JPRB, 0.116182E+01_JPRB &
  &, 0.114819E+01_JPRB, 0.113432E+01_JPRB, 0.112020E+01_JPRB, 0.110585E+01_JPRB &
  &, 0.109129E+01_JPRB, 0.107653E+01_JPRB, 0.106157E+01_JPRB &
  &, 0.104643E+01_JPRB, 0.103116E+01_JPRB, 0.101570E+01_JPRB, 0.100013E+01_JPRB &
  &, 0.984439E+00_JPRB, 0.968634E+00_JPRB, 0.952722E+00_JPRB &
  &, 0.936737E+00_JPRB, 0.920687E+00_JPRB, 0.904549E+00_JPRB, 0.888387E+00_JPRB &
  &, 0.872208E+00_JPRB, 0.855986E+00_JPRB, 0.839756E+00_JPRB &
  &, 0.823521E+00_JPRB, 0.807283E+00_JPRB, 0.791110E+00_JPRB, 0.774937E+00_JPRB &
  &, 0.758832E+00_JPRB, 0.742761E+00_JPRB, 0.726757E+00_JPRB &
  &, 0.710853E+00_JPRB, 0.695012E+00_JPRB, 0.679303E+00_JPRB, 0.663647E+00_JPRB &
  &, 0.648152E+00_JPRB, 0.632735E+00_JPRB, 0.617465E+00_JPRB &
  &, 0.602336E+00_JPRB, 0.587378E+00_JPRB, 0.572542E+00_JPRB, 0.557855E+00_JPRB &
  &, 0.543348E+00_JPRB, 0.529051E+00_JPRB, 0.514862E+00_JPRB &
  &, 0.500898E+00_JPRB, 0.487143E+00_JPRB, 0.473580E+00_JPRB, 0.460189E+00_JPRB &
  &, 0.446997E+00_JPRB, 0.434030E+00_JPRB, 0.421267E+00_JPRB &
  &, 0.408732E+00_JPRB, 0.396402E+00_JPRB, 0.384300E+00_JPRB, 0.372400E+00_JPRB &
  &, 0.360778E+00_JPRB, 0.349298E+00_JPRB, 0.338144E+00_JPRB &
  &, 0.327122E+00_JPRB, 0.316417E+00_JPRB, 0.305885E+00_JPRB, 0.295601E+00_JPRB &
  &, 0.285589E+00_JPRB, 0.275751E+00_JPRB, 0.266164E+00_JPRB &
  &, 0.256789E+00_JPRB, 0.247705E+00_JPRB, 0.238808E+00_JPRB, 0.230115E+00_JPRB &
  &, 0.221706E+00_JPRB, 0.213470E+00_JPRB, 0.205489E+00_JPRB/)
XCW( 754, :) = (/ &
  &  0.106675E+01_JPRB, 0.108280E+01_JPRB, 0.109857E+01_JPRB, 0.111406E+01_JPRB &
  &, 0.112924E+01_JPRB, 0.114412E+01_JPRB, 0.115868E+01_JPRB &
  &, 0.117290E+01_JPRB, 0.118679E+01_JPRB, 0.120032E+01_JPRB, 0.121349E+01_JPRB &
  &, 0.122629E+01_JPRB, 0.123871E+01_JPRB, 0.125074E+01_JPRB &
  &, 0.126237E+01_JPRB, 0.127359E+01_JPRB, 0.128439E+01_JPRB, 0.129476E+01_JPRB &
  &, 0.130470E+01_JPRB, 0.131419E+01_JPRB, 0.132323E+01_JPRB &
  &, 0.133181E+01_JPRB, 0.133993E+01_JPRB, 0.134757E+01_JPRB, 0.135473E+01_JPRB &
  &, 0.136140E+01_JPRB, 0.136759E+01_JPRB, 0.137327E+01_JPRB &
  &, 0.137846E+01_JPRB, 0.138313E+01_JPRB, 0.138730E+01_JPRB, 0.139095E+01_JPRB &
  &, 0.139409E+01_JPRB, 0.139670E+01_JPRB, 0.139880E+01_JPRB &
  &, 0.140037E+01_JPRB, 0.140141E+01_JPRB, 0.140195E+01_JPRB, 0.140195E+01_JPRB &
  &, 0.140143E+01_JPRB, 0.140040E+01_JPRB, 0.139884E+01_JPRB &
  &, 0.139676E+01_JPRB, 0.139418E+01_JPRB, 0.139109E+01_JPRB, 0.138748E+01_JPRB &
  &, 0.138339E+01_JPRB, 0.137881E+01_JPRB, 0.137372E+01_JPRB &
  &, 0.136816E+01_JPRB, 0.136211E+01_JPRB, 0.135561E+01_JPRB, 0.134864E+01_JPRB &
  &, 0.134121E+01_JPRB, 0.133334E+01_JPRB, 0.132503E+01_JPRB &
  &, 0.131630E+01_JPRB, 0.130714E+01_JPRB, 0.129759E+01_JPRB, 0.128763E+01_JPRB &
  &, 0.127727E+01_JPRB, 0.126657E+01_JPRB, 0.125547E+01_JPRB &
  &, 0.124403E+01_JPRB, 0.123225E+01_JPRB, 0.122014E+01_JPRB, 0.120755E+01_JPRB &
  &, 0.119495E+01_JPRB, 0.118193E+01_JPRB, 0.116862E+01_JPRB &
  &, 0.115503E+01_JPRB, 0.114117E+01_JPRB, 0.112710E+01_JPRB, 0.111279E+01_JPRB &
  &, 0.109825E+01_JPRB, 0.108351E+01_JPRB, 0.106858E+01_JPRB &
  &, 0.105348E+01_JPRB, 0.103820E+01_JPRB, 0.102278E+01_JPRB, 0.100722E+01_JPRB &
  &, 0.991540E+00_JPRB, 0.975739E+00_JPRB, 0.959827E+00_JPRB &
  &, 0.943866E+00_JPRB, 0.927780E+00_JPRB, 0.911660E+00_JPRB, 0.895484E+00_JPRB &
  &, 0.879286E+00_JPRB, 0.863042E+00_JPRB, 0.846785E+00_JPRB &
  &, 0.830550E+00_JPRB, 0.814245E+00_JPRB, 0.798065E+00_JPRB, 0.781882E+00_JPRB &
  &, 0.765730E+00_JPRB, 0.749641E+00_JPRB, 0.733615E+00_JPRB &
  &, 0.717650E+00_JPRB, 0.701780E+00_JPRB, 0.686000E+00_JPRB, 0.670307E+00_JPRB &
  &, 0.654731E+00_JPRB, 0.639268E+00_JPRB, 0.623948E+00_JPRB &
  &, 0.608764E+00_JPRB, 0.593707E+00_JPRB, 0.578848E+00_JPRB, 0.564093E+00_JPRB &
  &, 0.549514E+00_JPRB, 0.535140E+00_JPRB, 0.520915E+00_JPRB &
  &, 0.506866E+00_JPRB, 0.493021E+00_JPRB, 0.479363E+00_JPRB, 0.465873E+00_JPRB &
  &, 0.452624E+00_JPRB, 0.439596E+00_JPRB, 0.426720E+00_JPRB &
  &, 0.414116E+00_JPRB, 0.401714E+00_JPRB, 0.389485E+00_JPRB, 0.377504E+00_JPRB &
  &, 0.365797E+00_JPRB, 0.354283E+00_JPRB, 0.342982E+00_JPRB &
  &, 0.331918E+00_JPRB, 0.321057E+00_JPRB, 0.310477E+00_JPRB, 0.300085E+00_JPRB &
  &, 0.289960E+00_JPRB, 0.280064E+00_JPRB, 0.270357E+00_JPRB &
  &, 0.260917E+00_JPRB, 0.251704E+00_JPRB, 0.242736E+00_JPRB, 0.233969E+00_JPRB &
  &, 0.225419E+00_JPRB, 0.217102E+00_JPRB, 0.209037E+00_JPRB/)
XCW( 755, :) = (/ &
  &  0.106708E+01_JPRB, 0.108322E+01_JPRB, 0.109908E+01_JPRB, 0.111466E+01_JPRB &
  &, 0.112993E+01_JPRB, 0.114490E+01_JPRB, 0.115955E+01_JPRB &
  &, 0.117388E+01_JPRB, 0.118786E+01_JPRB, 0.120149E+01_JPRB, 0.121476E+01_JPRB &
  &, 0.122766E+01_JPRB, 0.124018E+01_JPRB, 0.125231E+01_JPRB &
  &, 0.126405E+01_JPRB, 0.127537E+01_JPRB, 0.128627E+01_JPRB, 0.129675E+01_JPRB &
  &, 0.130680E+01_JPRB, 0.131640E+01_JPRB, 0.132555E+01_JPRB &
  &, 0.133423E+01_JPRB, 0.134246E+01_JPRB, 0.135022E+01_JPRB, 0.135749E+01_JPRB &
  &, 0.136427E+01_JPRB, 0.137056E+01_JPRB, 0.137636E+01_JPRB &
  &, 0.138165E+01_JPRB, 0.138644E+01_JPRB, 0.139072E+01_JPRB, 0.139448E+01_JPRB &
  &, 0.139772E+01_JPRB, 0.140045E+01_JPRB, 0.140265E+01_JPRB &
  &, 0.140434E+01_JPRB, 0.140550E+01_JPRB, 0.140612E+01_JPRB, 0.140624E+01_JPRB &
  &, 0.140582E+01_JPRB, 0.140490E+01_JPRB, 0.140344E+01_JPRB &
  &, 0.140147E+01_JPRB, 0.139899E+01_JPRB, 0.139600E+01_JPRB, 0.139251E+01_JPRB &
  &, 0.138850E+01_JPRB, 0.138400E+01_JPRB, 0.137902E+01_JPRB &
  &, 0.137354E+01_JPRB, 0.136760E+01_JPRB, 0.136118E+01_JPRB, 0.135430E+01_JPRB &
  &, 0.134696E+01_JPRB, 0.133918E+01_JPRB, 0.133095E+01_JPRB &
  &, 0.132229E+01_JPRB, 0.131323E+01_JPRB, 0.130374E+01_JPRB, 0.129385E+01_JPRB &
  &, 0.128357E+01_JPRB, 0.127292E+01_JPRB, 0.126191E+01_JPRB &
  &, 0.125053E+01_JPRB, 0.123880E+01_JPRB, 0.122675E+01_JPRB, 0.121437E+01_JPRB &
  &, 0.120168E+01_JPRB, 0.118870E+01_JPRB, 0.117543E+01_JPRB &
  &, 0.116188E+01_JPRB, 0.114808E+01_JPRB, 0.113405E+01_JPRB, 0.111976E+01_JPRB &
  &, 0.110526E+01_JPRB, 0.109055E+01_JPRB, 0.107566E+01_JPRB &
  &, 0.106058E+01_JPRB, 0.104532E+01_JPRB, 0.102991E+01_JPRB, 0.101437E+01_JPRB &
  &, 0.998694E+00_JPRB, 0.982897E+00_JPRB, 0.967013E+00_JPRB &
  &, 0.951023E+00_JPRB, 0.934959E+00_JPRB, 0.918830E+00_JPRB, 0.902640E+00_JPRB &
  &, 0.886425E+00_JPRB, 0.870159E+00_JPRB, 0.853907E+00_JPRB &
  &, 0.837611E+00_JPRB, 0.821337E+00_JPRB, 0.805086E+00_JPRB, 0.788894E+00_JPRB &
  &, 0.772695E+00_JPRB, 0.756555E+00_JPRB, 0.740508E+00_JPRB &
  &, 0.724483E+00_JPRB, 0.708584E+00_JPRB, 0.692735E+00_JPRB, 0.677004E+00_JPRB &
  &, 0.661388E+00_JPRB, 0.645879E+00_JPRB, 0.630510E+00_JPRB &
  &, 0.615273E+00_JPRB, 0.600158E+00_JPRB, 0.585196E+00_JPRB, 0.570374E+00_JPRB &
  &, 0.555766E+00_JPRB, 0.541274E+00_JPRB, 0.526968E+00_JPRB &
  &, 0.512878E+00_JPRB, 0.498944E+00_JPRB, 0.485192E+00_JPRB, 0.471650E+00_JPRB &
  &, 0.458346E+00_JPRB, 0.445163E+00_JPRB, 0.432271E+00_JPRB &
  &, 0.419551E+00_JPRB, 0.407026E+00_JPRB, 0.394772E+00_JPRB, 0.382712E+00_JPRB &
  &, 0.370870E+00_JPRB, 0.359267E+00_JPRB, 0.347875E+00_JPRB &
  &, 0.336715E+00_JPRB, 0.325810E+00_JPRB, 0.315126E+00_JPRB, 0.304627E+00_JPRB &
  &, 0.294448E+00_JPRB, 0.284436E+00_JPRB, 0.274669E+00_JPRB &
  &, 0.265106E+00_JPRB, 0.255826E+00_JPRB, 0.246727E+00_JPRB, 0.237886E+00_JPRB &
  &, 0.229260E+00_JPRB, 0.220864E+00_JPRB, 0.212651E+00_JPRB/)
XCW( 756, :) = (/ &
  &  0.106741E+01_JPRB, 0.108364E+01_JPRB, 0.109959E+01_JPRB, 0.111526E+01_JPRB &
  &, 0.113063E+01_JPRB, 0.114569E+01_JPRB, 0.116044E+01_JPRB &
  &, 0.117485E+01_JPRB, 0.118893E+01_JPRB, 0.120266E+01_JPRB, 0.121603E+01_JPRB &
  &, 0.122904E+01_JPRB, 0.124166E+01_JPRB, 0.125389E+01_JPRB &
  &, 0.126573E+01_JPRB, 0.127716E+01_JPRB, 0.128817E+01_JPRB, 0.129876E+01_JPRB &
  &, 0.130891E+01_JPRB, 0.131861E+01_JPRB, 0.132787E+01_JPRB &
  &, 0.133668E+01_JPRB, 0.134501E+01_JPRB, 0.135287E+01_JPRB, 0.136025E+01_JPRB &
  &, 0.136715E+01_JPRB, 0.137355E+01_JPRB, 0.137946E+01_JPRB &
  &, 0.138486E+01_JPRB, 0.138976E+01_JPRB, 0.139415E+01_JPRB, 0.139802E+01_JPRB &
  &, 0.140138E+01_JPRB, 0.140421E+01_JPRB, 0.140653E+01_JPRB &
  &, 0.140832E+01_JPRB, 0.140958E+01_JPRB, 0.141032E+01_JPRB, 0.141055E+01_JPRB &
  &, 0.141024E+01_JPRB, 0.140942E+01_JPRB, 0.140806E+01_JPRB &
  &, 0.140620E+01_JPRB, 0.140382E+01_JPRB, 0.140093E+01_JPRB, 0.139754E+01_JPRB &
  &, 0.139363E+01_JPRB, 0.138924E+01_JPRB, 0.138434E+01_JPRB &
  &, 0.137897E+01_JPRB, 0.137311E+01_JPRB, 0.136679E+01_JPRB, 0.135999E+01_JPRB &
  &, 0.135274E+01_JPRB, 0.134504E+01_JPRB, 0.133690E+01_JPRB &
  &, 0.132832E+01_JPRB, 0.131933E+01_JPRB, 0.130992E+01_JPRB, 0.130011E+01_JPRB &
  &, 0.128990E+01_JPRB, 0.127933E+01_JPRB, 0.126837E+01_JPRB &
  &, 0.125706E+01_JPRB, 0.124541E+01_JPRB, 0.123341E+01_JPRB, 0.122107E+01_JPRB &
  &, 0.120845E+01_JPRB, 0.119551E+01_JPRB, 0.118229E+01_JPRB &
  &, 0.116880E+01_JPRB, 0.115504E+01_JPRB, 0.114104E+01_JPRB, 0.112679E+01_JPRB &
  &, 0.111234E+01_JPRB, 0.109765E+01_JPRB, 0.108276E+01_JPRB &
  &, 0.106771E+01_JPRB, 0.105249E+01_JPRB, 0.103710E+01_JPRB, 0.102157E+01_JPRB &
  &, 0.100590E+01_JPRB, 0.990109E+00_JPRB, 0.974227E+00_JPRB &
  &, 0.958235E+00_JPRB, 0.942166E+00_JPRB, 0.926028E+00_JPRB, 0.909855E+00_JPRB &
  &, 0.893623E+00_JPRB, 0.877336E+00_JPRB, 0.861060E+00_JPRB &
  &, 0.844768E+00_JPRB, 0.828461E+00_JPRB, 0.812206E+00_JPRB, 0.795940E+00_JPRB &
  &, 0.779729E+00_JPRB, 0.763573E+00_JPRB, 0.747437E+00_JPRB &
  &, 0.731424E+00_JPRB, 0.715461E+00_JPRB, 0.699580E+00_JPRB, 0.683777E+00_JPRB &
  &, 0.668120E+00_JPRB, 0.652568E+00_JPRB, 0.637112E+00_JPRB &
  &, 0.621822E+00_JPRB, 0.606650E+00_JPRB, 0.591626E+00_JPRB, 0.576739E+00_JPRB &
  &, 0.562061E+00_JPRB, 0.547494E+00_JPRB, 0.533153E+00_JPRB &
  &, 0.518936E+00_JPRB, 0.504959E+00_JPRB, 0.491114E+00_JPRB, 0.477522E+00_JPRB &
  &, 0.464068E+00_JPRB, 0.450874E+00_JPRB, 0.437871E+00_JPRB &
  &, 0.424985E+00_JPRB, 0.412490E+00_JPRB, 0.400111E+00_JPRB, 0.387973E+00_JPRB &
  &, 0.376048E+00_JPRB, 0.364359E+00_JPRB, 0.352876E+00_JPRB &
  &, 0.341622E+00_JPRB, 0.330618E+00_JPRB, 0.319832E+00_JPRB, 0.309283E+00_JPRB &
  &, 0.298935E+00_JPRB, 0.288867E+00_JPRB, 0.278981E+00_JPRB &
  &, 0.269355E+00_JPRB, 0.259948E+00_JPRB, 0.250779E+00_JPRB, 0.241867E+00_JPRB &
  &, 0.233101E+00_JPRB, 0.224626E+00_JPRB, 0.216331E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART108',1,ZHOOK_HANDLE)
END SUBROUTINE PART108

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART109

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART109',0,ZHOOK_HANDLE)

XCW( 757, :) = (/ &
  &  0.106775E+01_JPRB, 0.108406E+01_JPRB, 0.110010E+01_JPRB, 0.111586E+01_JPRB &
  &, 0.113132E+01_JPRB, 0.114648E+01_JPRB, 0.116132E+01_JPRB &
  &, 0.117583E+01_JPRB, 0.119001E+01_JPRB, 0.120384E+01_JPRB, 0.121731E+01_JPRB &
  &, 0.123041E+01_JPRB, 0.124314E+01_JPRB, 0.125548E+01_JPRB &
  &, 0.126742E+01_JPRB, 0.127895E+01_JPRB, 0.129007E+01_JPRB, 0.130076E+01_JPRB &
  &, 0.131102E+01_JPRB, 0.132084E+01_JPRB, 0.133021E+01_JPRB &
  &, 0.133912E+01_JPRB, 0.134756E+01_JPRB, 0.135553E+01_JPRB, 0.136303E+01_JPRB &
  &, 0.137003E+01_JPRB, 0.137655E+01_JPRB, 0.138257E+01_JPRB &
  &, 0.138808E+01_JPRB, 0.139309E+01_JPRB, 0.139759E+01_JPRB, 0.140157E+01_JPRB &
  &, 0.140504E+01_JPRB, 0.140799E+01_JPRB, 0.141041E+01_JPRB &
  &, 0.141231E+01_JPRB, 0.141369E+01_JPRB, 0.141454E+01_JPRB, 0.141487E+01_JPRB &
  &, 0.141467E+01_JPRB, 0.141395E+01_JPRB, 0.141271E+01_JPRB &
  &, 0.141095E+01_JPRB, 0.140868E+01_JPRB, 0.140588E+01_JPRB, 0.140258E+01_JPRB &
  &, 0.139879E+01_JPRB, 0.139448E+01_JPRB, 0.138969E+01_JPRB &
  &, 0.138441E+01_JPRB, 0.137865E+01_JPRB, 0.137241E+01_JPRB, 0.136570E+01_JPRB &
  &, 0.135855E+01_JPRB, 0.135093E+01_JPRB, 0.134285E+01_JPRB &
  &, 0.133438E+01_JPRB, 0.132547E+01_JPRB, 0.131613E+01_JPRB, 0.130640E+01_JPRB &
  &, 0.129627E+01_JPRB, 0.128577E+01_JPRB, 0.127487E+01_JPRB &
  &, 0.126363E+01_JPRB, 0.125203E+01_JPRB, 0.124010E+01_JPRB, 0.122783E+01_JPRB &
  &, 0.121526E+01_JPRB, 0.120237E+01_JPRB, 0.118920E+01_JPRB &
  &, 0.117576E+01_JPRB, 0.116204E+01_JPRB, 0.114807E+01_JPRB, 0.113385E+01_JPRB &
  &, 0.111944E+01_JPRB, 0.110478E+01_JPRB, 0.108994E+01_JPRB &
  &, 0.107491E+01_JPRB, 0.105971E+01_JPRB, 0.104434E+01_JPRB, 0.102882E+01_JPRB &
  &, 0.101316E+01_JPRB, 0.997375E+00_JPRB, 0.981496E+00_JPRB &
  &, 0.965503E+00_JPRB, 0.949459E+00_JPRB, 0.933313E+00_JPRB, 0.917099E+00_JPRB &
  &, 0.900851E+00_JPRB, 0.884576E+00_JPRB, 0.868276E+00_JPRB &
  &, 0.851956E+00_JPRB, 0.835649E+00_JPRB, 0.819358E+00_JPRB, 0.803052E+00_JPRB &
  &, 0.786830E+00_JPRB, 0.770625E+00_JPRB, 0.754471E+00_JPRB &
  &, 0.738400E+00_JPRB, 0.722374E+00_JPRB, 0.706463E+00_JPRB, 0.690625E+00_JPRB &
  &, 0.674891E+00_JPRB, 0.659296E+00_JPRB, 0.643792E+00_JPRB &
  &, 0.628411E+00_JPRB, 0.613182E+00_JPRB, 0.598098E+00_JPRB, 0.583188E+00_JPRB &
  &, 0.568399E+00_JPRB, 0.553802E+00_JPRB, 0.539339E+00_JPRB &
  &, 0.525083E+00_JPRB, 0.511019E+00_JPRB, 0.497129E+00_JPRB, 0.483393E+00_JPRB &
  &, 0.469933E+00_JPRB, 0.456634E+00_JPRB, 0.443521E+00_JPRB &
  &, 0.430619E+00_JPRB, 0.417954E+00_JPRB, 0.405501E+00_JPRB, 0.393285E+00_JPRB &
  &, 0.381278E+00_JPRB, 0.369504E+00_JPRB, 0.357932E+00_JPRB &
  &, 0.346584E+00_JPRB, 0.335483E+00_JPRB, 0.324594E+00_JPRB, 0.313939E+00_JPRB &
  &, 0.303540E+00_JPRB, 0.293358E+00_JPRB, 0.283413E+00_JPRB &
  &, 0.273665E+00_JPRB, 0.264194E+00_JPRB, 0.254894E+00_JPRB, 0.245847E+00_JPRB &
  &, 0.237070E+00_JPRB, 0.228453E+00_JPRB, 0.220077E+00_JPRB/)
XCW( 758, :) = (/ &
  &  0.106808E+01_JPRB, 0.108448E+01_JPRB, 0.110061E+01_JPRB, 0.111646E+01_JPRB &
  &, 0.113202E+01_JPRB, 0.114727E+01_JPRB, 0.116220E+01_JPRB &
  &, 0.117681E+01_JPRB, 0.119109E+01_JPRB, 0.120502E+01_JPRB, 0.121859E+01_JPRB &
  &, 0.123180E+01_JPRB, 0.124462E+01_JPRB, 0.125707E+01_JPRB &
  &, 0.126911E+01_JPRB, 0.128075E+01_JPRB, 0.129198E+01_JPRB, 0.130278E+01_JPRB &
  &, 0.131315E+01_JPRB, 0.132307E+01_JPRB, 0.133255E+01_JPRB &
  &, 0.134157E+01_JPRB, 0.135013E+01_JPRB, 0.135820E+01_JPRB, 0.136581E+01_JPRB &
  &, 0.137293E+01_JPRB, 0.137956E+01_JPRB, 0.138569E+01_JPRB &
  &, 0.139132E+01_JPRB, 0.139644E+01_JPRB, 0.140105E+01_JPRB, 0.140514E+01_JPRB &
  &, 0.140872E+01_JPRB, 0.141178E+01_JPRB, 0.141432E+01_JPRB &
  &, 0.141633E+01_JPRB, 0.141781E+01_JPRB, 0.141878E+01_JPRB, 0.141921E+01_JPRB &
  &, 0.141912E+01_JPRB, 0.141851E+01_JPRB, 0.141737E+01_JPRB &
  &, 0.141571E+01_JPRB, 0.141355E+01_JPRB, 0.141086E+01_JPRB, 0.140766E+01_JPRB &
  &, 0.140397E+01_JPRB, 0.139977E+01_JPRB, 0.139506E+01_JPRB &
  &, 0.138968E+01_JPRB, 0.138421E+01_JPRB, 0.137806E+01_JPRB, 0.137146E+01_JPRB &
  &, 0.136439E+01_JPRB, 0.135686E+01_JPRB, 0.134888E+01_JPRB &
  &, 0.134047E+01_JPRB, 0.133164E+01_JPRB, 0.132239E+01_JPRB, 0.131273E+01_JPRB &
  &, 0.130267E+01_JPRB, 0.129221E+01_JPRB, 0.128142E+01_JPRB &
  &, 0.127024E+01_JPRB, 0.125871E+01_JPRB, 0.124683E+01_JPRB, 0.123461E+01_JPRB &
  &, 0.122209E+01_JPRB, 0.120926E+01_JPRB, 0.119614E+01_JPRB &
  &, 0.118274E+01_JPRB, 0.116908E+01_JPRB, 0.115515E+01_JPRB, 0.114099E+01_JPRB &
  &, 0.112658E+01_JPRB, 0.111198E+01_JPRB, 0.109716E+01_JPRB &
  &, 0.108215E+01_JPRB, 0.106695E+01_JPRB, 0.105162E+01_JPRB, 0.103612E+01_JPRB &
  &, 0.102047E+01_JPRB, 0.100469E+01_JPRB, 0.988819E+00_JPRB &
  &, 0.972855E+00_JPRB, 0.956779E+00_JPRB, 0.940626E+00_JPRB, 0.924431E+00_JPRB &
  &, 0.908170E+00_JPRB, 0.891876E+00_JPRB, 0.875554E+00_JPRB &
  &, 0.859239E+00_JPRB, 0.842902E+00_JPRB, 0.826576E+00_JPRB, 0.810264E+00_JPRB &
  &, 0.793965E+00_JPRB, 0.777747E+00_JPRB, 0.761540E+00_JPRB &
  &, 0.745447E+00_JPRB, 0.729397E+00_JPRB, 0.713419E+00_JPRB, 0.697548E+00_JPRB &
  &, 0.681739E+00_JPRB, 0.666102E+00_JPRB, 0.650552E+00_JPRB &
  &, 0.635120E+00_JPRB, 0.619838E+00_JPRB, 0.604653E+00_JPRB, 0.589680E+00_JPRB &
  &, 0.574822E+00_JPRB, 0.560153E+00_JPRB, 0.545613E+00_JPRB &
  &, 0.531320E+00_JPRB, 0.517125E+00_JPRB, 0.503189E+00_JPRB, 0.489405E+00_JPRB &
  &, 0.475798E+00_JPRB, 0.462442E+00_JPRB, 0.449269E+00_JPRB &
  &, 0.436302E+00_JPRB, 0.423519E+00_JPRB, 0.410994E+00_JPRB, 0.398650E+00_JPRB &
  &, 0.386562E+00_JPRB, 0.374703E+00_JPRB, 0.363042E+00_JPRB &
  &, 0.351601E+00_JPRB, 0.340403E+00_JPRB, 0.329413E+00_JPRB, 0.318711E+00_JPRB &
  &, 0.308202E+00_JPRB, 0.297907E+00_JPRB, 0.287845E+00_JPRB &
  &, 0.278036E+00_JPRB, 0.268439E+00_JPRB, 0.259072E+00_JPRB, 0.249954E+00_JPRB &
  &, 0.241039E+00_JPRB, 0.232345E+00_JPRB, 0.223954E+00_JPRB/)
XCW( 759, :) = (/ &
  &  0.106842E+01_JPRB, 0.108490E+01_JPRB, 0.110113E+01_JPRB, 0.111706E+01_JPRB &
  &, 0.113271E+01_JPRB, 0.114806E+01_JPRB, 0.116309E+01_JPRB &
  &, 0.117780E+01_JPRB, 0.119217E+01_JPRB, 0.120620E+01_JPRB, 0.121988E+01_JPRB &
  &, 0.123318E+01_JPRB, 0.124611E+01_JPRB, 0.125866E+01_JPRB &
  &, 0.127081E+01_JPRB, 0.128256E+01_JPRB, 0.129389E+01_JPRB, 0.130480E+01_JPRB &
  &, 0.131527E+01_JPRB, 0.132531E+01_JPRB, 0.133490E+01_JPRB &
  &, 0.134403E+01_JPRB, 0.135270E+01_JPRB, 0.136089E+01_JPRB, 0.136861E+01_JPRB &
  &, 0.137584E+01_JPRB, 0.138258E+01_JPRB, 0.138882E+01_JPRB &
  &, 0.139456E+01_JPRB, 0.139979E+01_JPRB, 0.140452E+01_JPRB, 0.140873E+01_JPRB &
  &, 0.141242E+01_JPRB, 0.141559E+01_JPRB, 0.141823E+01_JPRB &
  &, 0.142035E+01_JPRB, 0.142196E+01_JPRB, 0.142302E+01_JPRB, 0.142357E+01_JPRB &
  &, 0.142358E+01_JPRB, 0.142308E+01_JPRB, 0.142205E+01_JPRB &
  &, 0.142051E+01_JPRB, 0.141844E+01_JPRB, 0.141586E+01_JPRB, 0.141277E+01_JPRB &
  &, 0.140917E+01_JPRB, 0.140506E+01_JPRB, 0.140046E+01_JPRB &
  &, 0.139538E+01_JPRB, 0.138981E+01_JPRB, 0.138376E+01_JPRB, 0.137723E+01_JPRB &
  &, 0.137025E+01_JPRB, 0.136281E+01_JPRB, 0.135492E+01_JPRB &
  &, 0.134659E+01_JPRB, 0.133784E+01_JPRB, 0.132867E+01_JPRB, 0.131910E+01_JPRB &
  &, 0.130912E+01_JPRB, 0.129873E+01_JPRB, 0.128800E+01_JPRB &
  &, 0.127688E+01_JPRB, 0.126542E+01_JPRB, 0.125360E+01_JPRB, 0.124145E+01_JPRB &
  &, 0.122898E+01_JPRB, 0.121622E+01_JPRB, 0.120314E+01_JPRB &
  &, 0.118978E+01_JPRB, 0.117616E+01_JPRB, 0.116227E+01_JPRB, 0.114815E+01_JPRB &
  &, 0.113379E+01_JPRB, 0.111920E+01_JPRB, 0.110441E+01_JPRB &
  &, 0.108943E+01_JPRB, 0.107427E+01_JPRB, 0.105893E+01_JPRB, 0.104347E+01_JPRB &
  &, 0.102784E+01_JPRB, 0.101207E+01_JPRB, 0.996197E+00_JPRB &
  &, 0.980234E+00_JPRB, 0.964157E+00_JPRB, 0.948027E+00_JPRB, 0.931793E+00_JPRB &
  &, 0.915548E+00_JPRB, 0.899237E+00_JPRB, 0.882894E+00_JPRB &
  &, 0.866553E+00_JPRB, 0.850186E+00_JPRB, 0.833827E+00_JPRB, 0.817510E+00_JPRB &
  &, 0.801202E+00_JPRB, 0.784937E+00_JPRB, 0.768714E+00_JPRB &
  &, 0.752531E+00_JPRB, 0.736455E+00_JPRB, 0.720413E+00_JPRB, 0.704508E+00_JPRB &
  &, 0.688663E+00_JPRB, 0.672946E+00_JPRB, 0.657351E+00_JPRB &
  &, 0.641870E+00_JPRB, 0.626534E+00_JPRB, 0.611291E+00_JPRB, 0.596256E+00_JPRB &
  &, 0.581331E+00_JPRB, 0.566591E+00_JPRB, 0.551975E+00_JPRB &
  &, 0.537557E+00_JPRB, 0.523367E+00_JPRB, 0.509296E+00_JPRB, 0.495465E+00_JPRB &
  &, 0.481759E+00_JPRB, 0.468299E+00_JPRB, 0.455065E+00_JPRB &
  &, 0.441986E+00_JPRB, 0.429185E+00_JPRB, 0.416538E+00_JPRB, 0.404118E+00_JPRB &
  &, 0.391951E+00_JPRB, 0.379955E+00_JPRB, 0.368207E+00_JPRB &
  &, 0.356674E+00_JPRB, 0.345379E+00_JPRB, 0.334346E+00_JPRB, 0.323482E+00_JPRB &
  &, 0.312923E+00_JPRB, 0.302515E+00_JPRB, 0.292397E+00_JPRB &
  &, 0.282467E+00_JPRB, 0.272807E+00_JPRB, 0.263312E+00_JPRB, 0.254124E+00_JPRB &
  &, 0.245136E+00_JPRB, 0.236366E+00_JPRB, 0.227765E+00_JPRB/)
XCW( 760, :) = (/ &
  &  0.106875E+01_JPRB, 0.108533E+01_JPRB, 0.110164E+01_JPRB, 0.111767E+01_JPRB &
  &, 0.113341E+01_JPRB, 0.114885E+01_JPRB, 0.116398E+01_JPRB &
  &, 0.117879E+01_JPRB, 0.119326E+01_JPRB, 0.120739E+01_JPRB, 0.122116E+01_JPRB &
  &, 0.123457E+01_JPRB, 0.124761E+01_JPRB, 0.126026E+01_JPRB &
  &, 0.127252E+01_JPRB, 0.128437E+01_JPRB, 0.129581E+01_JPRB, 0.130683E+01_JPRB &
  &, 0.131741E+01_JPRB, 0.132756E+01_JPRB, 0.133725E+01_JPRB &
  &, 0.134650E+01_JPRB, 0.135527E+01_JPRB, 0.136358E+01_JPRB, 0.137141E+01_JPRB &
  &, 0.137875E+01_JPRB, 0.138561E+01_JPRB, 0.139196E+01_JPRB &
  &, 0.139782E+01_JPRB, 0.140316E+01_JPRB, 0.140800E+01_JPRB, 0.141232E+01_JPRB &
  &, 0.141613E+01_JPRB, 0.141941E+01_JPRB, 0.142217E+01_JPRB &
  &, 0.142440E+01_JPRB, 0.142611E+01_JPRB, 0.142729E+01_JPRB, 0.142795E+01_JPRB &
  &, 0.142808E+01_JPRB, 0.142768E+01_JPRB, 0.142676E+01_JPRB &
  &, 0.142531E+01_JPRB, 0.142335E+01_JPRB, 0.142088E+01_JPRB, 0.141789E+01_JPRB &
  &, 0.141439E+01_JPRB, 0.141039E+01_JPRB, 0.140589E+01_JPRB &
  &, 0.140090E+01_JPRB, 0.139542E+01_JPRB, 0.138945E+01_JPRB, 0.138303E+01_JPRB &
  &, 0.137615E+01_JPRB, 0.136880E+01_JPRB, 0.136099E+01_JPRB &
  &, 0.135276E+01_JPRB, 0.134409E+01_JPRB, 0.133500E+01_JPRB, 0.132549E+01_JPRB &
  &, 0.131559E+01_JPRB, 0.130528E+01_JPRB, 0.129461E+01_JPRB &
  &, 0.128356E+01_JPRB, 0.127215E+01_JPRB, 0.126040E+01_JPRB, 0.124833E+01_JPRB &
  &, 0.123592E+01_JPRB, 0.122319E+01_JPRB, 0.121018E+01_JPRB &
  &, 0.119687E+01_JPRB, 0.118329E+01_JPRB, 0.116944E+01_JPRB, 0.115535E+01_JPRB &
  &, 0.114103E+01_JPRB, 0.112649E+01_JPRB, 0.111173E+01_JPRB &
  &, 0.109677E+01_JPRB, 0.108164E+01_JPRB, 0.106632E+01_JPRB, 0.105087E+01_JPRB &
  &, 0.103525E+01_JPRB, 0.101949E+01_JPRB, 0.100363E+01_JPRB &
  &, 0.987670E+00_JPRB, 0.971591E+00_JPRB, 0.955456E+00_JPRB, 0.939243E+00_JPRB &
  &, 0.922956E+00_JPRB, 0.906659E+00_JPRB, 0.890296E+00_JPRB &
  &, 0.873931E+00_JPRB, 0.857568E+00_JPRB, 0.841177E+00_JPRB, 0.824822E+00_JPRB &
  &, 0.808474E+00_JPRB, 0.792163E+00_JPRB, 0.775924E+00_JPRB &
  &, 0.759722E+00_JPRB, 0.743587E+00_JPRB, 0.727517E+00_JPRB, 0.711544E+00_JPRB &
  &, 0.695664E+00_JPRB, 0.679907E+00_JPRB, 0.664229E+00_JPRB &
  &, 0.648700E+00_JPRB, 0.633270E+00_JPRB, 0.618012E+00_JPRB, 0.602874E+00_JPRB &
  &, 0.587883E+00_JPRB, 0.573072E+00_JPRB, 0.558425E+00_JPRB &
  &, 0.543929E+00_JPRB, 0.529609E+00_JPRB, 0.515496E+00_JPRB, 0.501571E+00_JPRB &
  &, 0.487814E+00_JPRB, 0.474252E+00_JPRB, 0.460911E+00_JPRB &
  &, 0.447769E+00_JPRB, 0.434852E+00_JPRB, 0.422134E+00_JPRB, 0.409639E+00_JPRB &
  &, 0.397341E+00_JPRB, 0.385315E+00_JPRB, 0.373480E+00_JPRB &
  &, 0.361856E+00_JPRB, 0.350467E+00_JPRB, 0.339335E+00_JPRB, 0.328368E+00_JPRB &
  &, 0.317702E+00_JPRB, 0.307242E+00_JPRB, 0.297008E+00_JPRB &
  &, 0.286959E+00_JPRB, 0.277175E+00_JPRB, 0.267676E+00_JPRB, 0.258357E+00_JPRB &
  &, 0.249233E+00_JPRB, 0.240388E+00_JPRB, 0.231707E+00_JPRB/)
XCW( 761, :) = (/ &
  &  0.106909E+01_JPRB, 0.108575E+01_JPRB, 0.110216E+01_JPRB, 0.111828E+01_JPRB &
  &, 0.113411E+01_JPRB, 0.114965E+01_JPRB, 0.116487E+01_JPRB &
  &, 0.117978E+01_JPRB, 0.119435E+01_JPRB, 0.120858E+01_JPRB, 0.122246E+01_JPRB &
  &, 0.123597E+01_JPRB, 0.124911E+01_JPRB, 0.126186E+01_JPRB &
  &, 0.127423E+01_JPRB, 0.128619E+01_JPRB, 0.129773E+01_JPRB, 0.130886E+01_JPRB &
  &, 0.131956E+01_JPRB, 0.132981E+01_JPRB, 0.133962E+01_JPRB &
  &, 0.134897E+01_JPRB, 0.135786E+01_JPRB, 0.136628E+01_JPRB, 0.137423E+01_JPRB &
  &, 0.138168E+01_JPRB, 0.138865E+01_JPRB, 0.139512E+01_JPRB &
  &, 0.140109E+01_JPRB, 0.140655E+01_JPRB, 0.141150E+01_JPRB, 0.141593E+01_JPRB &
  &, 0.141985E+01_JPRB, 0.142325E+01_JPRB, 0.142612E+01_JPRB &
  &, 0.142847E+01_JPRB, 0.143029E+01_JPRB, 0.143158E+01_JPRB, 0.143234E+01_JPRB &
  &, 0.143259E+01_JPRB, 0.143229E+01_JPRB, 0.143148E+01_JPRB &
  &, 0.143015E+01_JPRB, 0.142829E+01_JPRB, 0.142593E+01_JPRB, 0.142304E+01_JPRB &
  &, 0.141964E+01_JPRB, 0.141574E+01_JPRB, 0.141134E+01_JPRB &
  &, 0.140646E+01_JPRB, 0.140108E+01_JPRB, 0.139521E+01_JPRB, 0.138888E+01_JPRB &
  &, 0.138207E+01_JPRB, 0.137480E+01_JPRB, 0.136709E+01_JPRB &
  &, 0.135894E+01_JPRB, 0.135035E+01_JPRB, 0.134134E+01_JPRB, 0.133193E+01_JPRB &
  &, 0.132209E+01_JPRB, 0.131188E+01_JPRB, 0.130126E+01_JPRB &
  &, 0.129029E+01_JPRB, 0.127894E+01_JPRB, 0.126726E+01_JPRB, 0.125524E+01_JPRB &
  &, 0.124289E+01_JPRB, 0.123023E+01_JPRB, 0.121725E+01_JPRB &
  &, 0.120399E+01_JPRB, 0.119046E+01_JPRB, 0.117667E+01_JPRB, 0.116262E+01_JPRB &
  &, 0.114834E+01_JPRB, 0.113382E+01_JPRB, 0.111910E+01_JPRB &
  &, 0.110417E+01_JPRB, 0.108906E+01_JPRB, 0.107376E+01_JPRB, 0.105833E+01_JPRB &
  &, 0.104272E+01_JPRB, 0.102697E+01_JPRB, 0.101112E+01_JPRB &
  &, 0.995161E+00_JPRB, 0.979110E+00_JPRB, 0.962944E+00_JPRB, 0.946723E+00_JPRB &
  &, 0.930454E+00_JPRB, 0.914112E+00_JPRB, 0.897760E+00_JPRB &
  &, 0.881372E+00_JPRB, 0.864982E+00_JPRB, 0.848591E+00_JPRB, 0.832202E+00_JPRB &
  &, 0.815813E+00_JPRB, 0.799492E+00_JPRB, 0.783204E+00_JPRB &
  &, 0.766948E+00_JPRB, 0.750755E+00_JPRB, 0.734659E+00_JPRB, 0.718656E+00_JPRB &
  &, 0.702702E+00_JPRB, 0.686907E+00_JPRB, 0.671186E+00_JPRB &
  &, 0.655570E+00_JPRB, 0.640089E+00_JPRB, 0.624775E+00_JPRB, 0.609576E+00_JPRB &
  &, 0.594521E+00_JPRB, 0.579640E+00_JPRB, 0.564920E+00_JPRB &
  &, 0.550345E+00_JPRB, 0.535988E+00_JPRB, 0.521788E+00_JPRB, 0.507771E+00_JPRB &
  &, 0.493918E+00_JPRB, 0.480303E+00_JPRB, 0.466856E+00_JPRB &
  &, 0.453652E+00_JPRB, 0.440619E+00_JPRB, 0.427832E+00_JPRB, 0.415264E+00_JPRB &
  &, 0.402889E+00_JPRB, 0.390728E+00_JPRB, 0.378807E+00_JPRB &
  &, 0.367094E+00_JPRB, 0.355611E+00_JPRB, 0.344381E+00_JPRB, 0.333312E+00_JPRB &
  &, 0.322539E+00_JPRB, 0.311969E+00_JPRB, 0.301620E+00_JPRB &
  &, 0.291573E+00_JPRB, 0.281666E+00_JPRB, 0.272041E+00_JPRB, 0.262590E+00_JPRB &
  &, 0.253459E+00_JPRB, 0.244474E+00_JPRB, 0.235716E+00_JPRB/)
XCW( 762, :) = (/ &
  &  0.106943E+01_JPRB, 0.108618E+01_JPRB, 0.110267E+01_JPRB, 0.111889E+01_JPRB &
  &, 0.113482E+01_JPRB, 0.115045E+01_JPRB, 0.116577E+01_JPRB &
  &, 0.118076E+01_JPRB, 0.119544E+01_JPRB, 0.120977E+01_JPRB, 0.122375E+01_JPRB &
  &, 0.123737E+01_JPRB, 0.125061E+01_JPRB, 0.126347E+01_JPRB &
  &, 0.127594E+01_JPRB, 0.128801E+01_JPRB, 0.129966E+01_JPRB, 0.131090E+01_JPRB &
  &, 0.132171E+01_JPRB, 0.133207E+01_JPRB, 0.134199E+01_JPRB &
  &, 0.135146E+01_JPRB, 0.136046E+01_JPRB, 0.136899E+01_JPRB, 0.137705E+01_JPRB &
  &, 0.138462E+01_JPRB, 0.139170E+01_JPRB, 0.139829E+01_JPRB &
  &, 0.140437E+01_JPRB, 0.140994E+01_JPRB, 0.141501E+01_JPRB, 0.141956E+01_JPRB &
  &, 0.142359E+01_JPRB, 0.142710E+01_JPRB, 0.143009E+01_JPRB &
  &, 0.143255E+01_JPRB, 0.143448E+01_JPRB, 0.143589E+01_JPRB, 0.143676E+01_JPRB &
  &, 0.143711E+01_JPRB, 0.143693E+01_JPRB, 0.143623E+01_JPRB &
  &, 0.143500E+01_JPRB, 0.143325E+01_JPRB, 0.143099E+01_JPRB, 0.142821E+01_JPRB &
  &, 0.142492E+01_JPRB, 0.142112E+01_JPRB, 0.141682E+01_JPRB &
  &, 0.141203E+01_JPRB, 0.140674E+01_JPRB, 0.140099E+01_JPRB, 0.139474E+01_JPRB &
  &, 0.138803E+01_JPRB, 0.138085E+01_JPRB, 0.137323E+01_JPRB &
  &, 0.136516E+01_JPRB, 0.135666E+01_JPRB, 0.134774E+01_JPRB, 0.133838E+01_JPRB &
  &, 0.132864E+01_JPRB, 0.131849E+01_JPRB, 0.130796E+01_JPRB &
  &, 0.129704E+01_JPRB, 0.128577E+01_JPRB, 0.127415E+01_JPRB, 0.126220E+01_JPRB &
  &, 0.124990E+01_JPRB, 0.123728E+01_JPRB, 0.122437E+01_JPRB &
  &, 0.121116E+01_JPRB, 0.119769E+01_JPRB, 0.118393E+01_JPRB, 0.116994E+01_JPRB &
  &, 0.115569E+01_JPRB, 0.114121E+01_JPRB, 0.112651E+01_JPRB &
  &, 0.111161E+01_JPRB, 0.109652E+01_JPRB, 0.108125E+01_JPRB, 0.106583E+01_JPRB &
  &, 0.105024E+01_JPRB, 0.103453E+01_JPRB, 0.101869E+01_JPRB &
  &, 0.100271E+01_JPRB, 0.986658E+00_JPRB, 0.970518E+00_JPRB, 0.954291E+00_JPRB &
  &, 0.938013E+00_JPRB, 0.921656E+00_JPRB, 0.905287E+00_JPRB &
  &, 0.888877E+00_JPRB, 0.872460E+00_JPRB, 0.856039E+00_JPRB, 0.839614E+00_JPRB &
  &, 0.823220E+00_JPRB, 0.806855E+00_JPRB, 0.790520E+00_JPRB &
  &, 0.774246E+00_JPRB, 0.758032E+00_JPRB, 0.741874E+00_JPRB, 0.725804E+00_JPRB &
  &, 0.709856E+00_JPRB, 0.693946E+00_JPRB, 0.678183E+00_JPRB &
  &, 0.662520E+00_JPRB, 0.646989E+00_JPRB, 0.631620E+00_JPRB, 0.616362E+00_JPRB &
  &, 0.601244E+00_JPRB, 0.586296E+00_JPRB, 0.571459E+00_JPRB &
  &, 0.556851E+00_JPRB, 0.542367E+00_JPRB, 0.528126E+00_JPRB, 0.514018E+00_JPRB &
  &, 0.500117E+00_JPRB, 0.486401E+00_JPRB, 0.472898E+00_JPRB &
  &, 0.459585E+00_JPRB, 0.446488E+00_JPRB, 0.433581E+00_JPRB, 0.420889E+00_JPRB &
  &, 0.408436E+00_JPRB, 0.396195E+00_JPRB, 0.384189E+00_JPRB &
  &, 0.372387E+00_JPRB, 0.360811E+00_JPRB, 0.349484E+00_JPRB, 0.338371E+00_JPRB &
  &, 0.327493E+00_JPRB, 0.316814E+00_JPRB, 0.306411E+00_JPRB &
  &, 0.296186E+00_JPRB, 0.286219E+00_JPRB, 0.276467E+00_JPRB, 0.266949E+00_JPRB &
  &, 0.257684E+00_JPRB, 0.248625E+00_JPRB, 0.239790E+00_JPRB/)
XCW( 763, :) = (/ &
  &  0.106976E+01_JPRB, 0.108661E+01_JPRB, 0.110319E+01_JPRB, 0.111950E+01_JPRB &
  &, 0.113552E+01_JPRB, 0.115125E+01_JPRB, 0.116667E+01_JPRB &
  &, 0.118177E+01_JPRB, 0.119654E+01_JPRB, 0.121097E+01_JPRB, 0.122504E+01_JPRB &
  &, 0.123877E+01_JPRB, 0.125212E+01_JPRB, 0.126509E+01_JPRB &
  &, 0.127766E+01_JPRB, 0.128984E+01_JPRB, 0.130160E+01_JPRB, 0.131295E+01_JPRB &
  &, 0.132386E+01_JPRB, 0.133434E+01_JPRB, 0.134437E+01_JPRB &
  &, 0.135395E+01_JPRB, 0.136307E+01_JPRB, 0.137172E+01_JPRB, 0.137988E+01_JPRB &
  &, 0.138757E+01_JPRB, 0.139476E+01_JPRB, 0.140147E+01_JPRB &
  &, 0.140766E+01_JPRB, 0.141335E+01_JPRB, 0.141853E+01_JPRB, 0.142320E+01_JPRB &
  &, 0.142735E+01_JPRB, 0.143097E+01_JPRB, 0.143407E+01_JPRB &
  &, 0.143664E+01_JPRB, 0.143869E+01_JPRB, 0.144021E+01_JPRB, 0.144119E+01_JPRB &
  &, 0.144165E+01_JPRB, 0.144159E+01_JPRB, 0.144100E+01_JPRB &
  &, 0.143988E+01_JPRB, 0.143825E+01_JPRB, 0.143608E+01_JPRB, 0.143341E+01_JPRB &
  &, 0.143022E+01_JPRB, 0.142652E+01_JPRB, 0.142233E+01_JPRB &
  &, 0.141764E+01_JPRB, 0.141245E+01_JPRB, 0.140676E+01_JPRB, 0.140064E+01_JPRB &
  &, 0.139401E+01_JPRB, 0.138693E+01_JPRB, 0.137941E+01_JPRB &
  &, 0.137142E+01_JPRB, 0.136300E+01_JPRB, 0.135416E+01_JPRB, 0.134489E+01_JPRB &
  &, 0.133521E+01_JPRB, 0.132514E+01_JPRB, 0.131468E+01_JPRB &
  &, 0.130385E+01_JPRB, 0.129265E+01_JPRB, 0.128108E+01_JPRB, 0.126919E+01_JPRB &
  &, 0.125696E+01_JPRB, 0.124440E+01_JPRB, 0.123154E+01_JPRB &
  &, 0.121840E+01_JPRB, 0.120495E+01_JPRB, 0.119125E+01_JPRB, 0.117727E+01_JPRB &
  &, 0.116308E+01_JPRB, 0.114864E+01_JPRB, 0.113398E+01_JPRB &
  &, 0.111910E+01_JPRB, 0.110404E+01_JPRB, 0.108879E+01_JPRB, 0.107339E+01_JPRB &
  &, 0.105782E+01_JPRB, 0.104212E+01_JPRB, 0.102628E+01_JPRB &
  &, 0.101034E+01_JPRB, 0.994262E+00_JPRB, 0.978120E+00_JPRB, 0.961889E+00_JPRB &
  &, 0.945601E+00_JPRB, 0.929262E+00_JPRB, 0.912876E+00_JPRB &
  &, 0.896445E+00_JPRB, 0.880003E+00_JPRB, 0.863553E+00_JPRB, 0.847127E+00_JPRB &
  &, 0.830695E+00_JPRB, 0.814288E+00_JPRB, 0.797940E+00_JPRB &
  &, 0.781616E+00_JPRB, 0.765382E+00_JPRB, 0.749164E+00_JPRB, 0.733066E+00_JPRB &
  &, 0.717048E+00_JPRB, 0.701102E+00_JPRB, 0.685298E+00_JPRB &
  &, 0.669551E+00_JPRB, 0.653971E+00_JPRB, 0.638507E+00_JPRB, 0.623191E+00_JPRB &
  &, 0.608010E+00_JPRB, 0.592995E+00_JPRB, 0.578131E+00_JPRB &
  &, 0.563402E+00_JPRB, 0.548883E+00_JPRB, 0.534511E+00_JPRB, 0.520360E+00_JPRB &
  &, 0.506363E+00_JPRB, 0.492597E+00_JPRB, 0.478990E+00_JPRB &
  &, 0.465568E+00_JPRB, 0.452407E+00_JPRB, 0.439433E+00_JPRB, 0.426670E+00_JPRB &
  &, 0.414090E+00_JPRB, 0.401769E+00_JPRB, 0.389680E+00_JPRB &
  &, 0.377790E+00_JPRB, 0.366123E+00_JPRB, 0.354643E+00_JPRB, 0.343430E+00_JPRB &
  &, 0.332447E+00_JPRB, 0.321717E+00_JPRB, 0.311202E+00_JPRB &
  &, 0.300921E+00_JPRB, 0.290833E+00_JPRB, 0.281019E+00_JPRB, 0.271372E+00_JPRB &
  &, 0.262037E+00_JPRB, 0.252841E+00_JPRB, 0.243930E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART109',1,ZHOOK_HANDLE)
END SUBROUTINE PART109

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART110

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART110',0,ZHOOK_HANDLE)

XCW( 764, :) = (/ &
  &  0.107010E+01_JPRB, 0.108704E+01_JPRB, 0.110371E+01_JPRB, 0.112011E+01_JPRB &
  &, 0.113623E+01_JPRB, 0.115205E+01_JPRB, 0.116757E+01_JPRB &
  &, 0.118277E+01_JPRB, 0.119764E+01_JPRB, 0.121217E+01_JPRB, 0.122635E+01_JPRB &
  &, 0.124018E+01_JPRB, 0.125363E+01_JPRB, 0.126670E+01_JPRB &
  &, 0.127939E+01_JPRB, 0.129167E+01_JPRB, 0.130355E+01_JPRB, 0.131500E+01_JPRB &
  &, 0.132603E+01_JPRB, 0.133662E+01_JPRB, 0.134676E+01_JPRB &
  &, 0.135646E+01_JPRB, 0.136569E+01_JPRB, 0.137445E+01_JPRB, 0.138273E+01_JPRB &
  &, 0.139047E+01_JPRB, 0.139784E+01_JPRB, 0.140466E+01_JPRB &
  &, 0.141097E+01_JPRB, 0.141678E+01_JPRB, 0.142207E+01_JPRB, 0.142685E+01_JPRB &
  &, 0.143112E+01_JPRB, 0.143485E+01_JPRB, 0.143807E+01_JPRB &
  &, 0.144076E+01_JPRB, 0.144292E+01_JPRB, 0.144455E+01_JPRB, 0.144566E+01_JPRB &
  &, 0.144623E+01_JPRB, 0.144627E+01_JPRB, 0.144579E+01_JPRB &
  &, 0.144478E+01_JPRB, 0.144325E+01_JPRB, 0.144119E+01_JPRB, 0.143863E+01_JPRB &
  &, 0.143554E+01_JPRB, 0.143195E+01_JPRB, 0.142786E+01_JPRB &
  &, 0.142326E+01_JPRB, 0.141818E+01_JPRB, 0.141260E+01_JPRB, 0.140656E+01_JPRB &
  &, 0.140004E+01_JPRB, 0.139304E+01_JPRB, 0.138560E+01_JPRB &
  &, 0.137771E+01_JPRB, 0.136938E+01_JPRB, 0.136062E+01_JPRB, 0.135143E+01_JPRB &
  &, 0.134183E+01_JPRB, 0.133184E+01_JPRB, 0.132145E+01_JPRB &
  &, 0.131069E+01_JPRB, 0.129955E+01_JPRB, 0.128806E+01_JPRB, 0.127622E+01_JPRB &
  &, 0.126405E+01_JPRB, 0.125156E+01_JPRB, 0.123876E+01_JPRB &
  &, 0.122565E+01_JPRB, 0.121227E+01_JPRB, 0.119861E+01_JPRB, 0.118468E+01_JPRB &
  &, 0.117053E+01_JPRB, 0.115612E+01_JPRB, 0.114149E+01_JPRB &
  &, 0.112664E+01_JPRB, 0.111161E+01_JPRB, 0.109640E+01_JPRB, 0.108100E+01_JPRB &
  &, 0.106547E+01_JPRB, 0.104976E+01_JPRB, 0.103393E+01_JPRB &
  &, 0.101800E+01_JPRB, 0.100195E+01_JPRB, 0.985810E+00_JPRB, 0.969574E+00_JPRB &
  &, 0.953279E+00_JPRB, 0.936929E+00_JPRB, 0.920527E+00_JPRB &
  &, 0.904076E+00_JPRB, 0.887643E+00_JPRB, 0.871164E+00_JPRB, 0.854707E+00_JPRB &
  &, 0.838238E+00_JPRB, 0.821824E+00_JPRB, 0.805432E+00_JPRB &
  &, 0.789057E+00_JPRB, 0.772768E+00_JPRB, 0.756527E+00_JPRB, 0.740365E+00_JPRB &
  &, 0.724316E+00_JPRB, 0.708335E+00_JPRB, 0.692453E+00_JPRB &
  &, 0.676663E+00_JPRB, 0.661034E+00_JPRB, 0.645477E+00_JPRB, 0.630104E+00_JPRB &
  &, 0.614862E+00_JPRB, 0.599781E+00_JPRB, 0.584846E+00_JPRB &
  &, 0.570043E+00_JPRB, 0.555444E+00_JPRB, 0.541034E+00_JPRB, 0.526748E+00_JPRB &
  &, 0.512705E+00_JPRB, 0.498840E+00_JPRB, 0.485131E+00_JPRB &
  &, 0.471651E+00_JPRB, 0.458377E+00_JPRB, 0.445337E+00_JPRB, 0.432451E+00_JPRB &
  &, 0.419849E+00_JPRB, 0.407397E+00_JPRB, 0.395170E+00_JPRB &
  &, 0.383193E+00_JPRB, 0.371434E+00_JPRB, 0.359916E+00_JPRB, 0.348603E+00_JPRB &
  &, 0.337518E+00_JPRB, 0.326680E+00_JPRB, 0.316053E+00_JPRB &
  &, 0.305656E+00_JPRB, 0.295509E+00_JPRB, 0.285570E+00_JPRB, 0.275858E+00_JPRB &
  &, 0.266390E+00_JPRB, 0.257122E+00_JPRB, 0.248135E+00_JPRB/)
XCW( 765, :) = (/ &
  &  0.107044E+01_JPRB, 0.108747E+01_JPRB, 0.110423E+01_JPRB, 0.112073E+01_JPRB &
  &, 0.113694E+01_JPRB, 0.115285E+01_JPRB, 0.116847E+01_JPRB &
  &, 0.118377E+01_JPRB, 0.119874E+01_JPRB, 0.121337E+01_JPRB, 0.122766E+01_JPRB &
  &, 0.124159E+01_JPRB, 0.125515E+01_JPRB, 0.126833E+01_JPRB &
  &, 0.128112E+01_JPRB, 0.129351E+01_JPRB, 0.130549E+01_JPRB, 0.131706E+01_JPRB &
  &, 0.132820E+01_JPRB, 0.133891E+01_JPRB, 0.134916E+01_JPRB &
  &, 0.135897E+01_JPRB, 0.136831E+01_JPRB, 0.137719E+01_JPRB, 0.138559E+01_JPRB &
  &, 0.139350E+01_JPRB, 0.140093E+01_JPRB, 0.140786E+01_JPRB &
  &, 0.141429E+01_JPRB, 0.142021E+01_JPRB, 0.142562E+01_JPRB, 0.143046E+01_JPRB &
  &, 0.143490E+01_JPRB, 0.143876E+01_JPRB, 0.144209E+01_JPRB &
  &, 0.144489E+01_JPRB, 0.144716E+01_JPRB, 0.144891E+01_JPRB, 0.145013E+01_JPRB &
  &, 0.145081E+01_JPRB, 0.145097E+01_JPRB, 0.145060E+01_JPRB &
  &, 0.144970E+01_JPRB, 0.144828E+01_JPRB, 0.144633E+01_JPRB, 0.144388E+01_JPRB &
  &, 0.144089E+01_JPRB, 0.143741E+01_JPRB, 0.143342E+01_JPRB &
  &, 0.142893E+01_JPRB, 0.142394E+01_JPRB, 0.141846E+01_JPRB, 0.141252E+01_JPRB &
  &, 0.140609E+01_JPRB, 0.139918E+01_JPRB, 0.139184E+01_JPRB &
  &, 0.138403E+01_JPRB, 0.137579E+01_JPRB, 0.136711E+01_JPRB, 0.135800E+01_JPRB &
  &, 0.134848E+01_JPRB, 0.133858E+01_JPRB, 0.132826E+01_JPRB &
  &, 0.131756E+01_JPRB, 0.130651E+01_JPRB, 0.129507E+01_JPRB, 0.128331E+01_JPRB &
  &, 0.127119E+01_JPRB, 0.125876E+01_JPRB, 0.124601E+01_JPRB &
  &, 0.123297E+01_JPRB, 0.121964E+01_JPRB, 0.120602E+01_JPRB, 0.119213E+01_JPRB &
  &, 0.117801E+01_JPRB, 0.116364E+01_JPRB, 0.114904E+01_JPRB &
  &, 0.113425E+01_JPRB, 0.111925E+01_JPRB, 0.110404E+01_JPRB, 0.108869E+01_JPRB &
  &, 0.107315E+01_JPRB, 0.105748E+01_JPRB, 0.104167E+01_JPRB &
  &, 0.102574E+01_JPRB, 0.100967E+01_JPRB, 0.993528E+00_JPRB, 0.977319E+00_JPRB &
  &, 0.961017E+00_JPRB, 0.944626E+00_JPRB, 0.928240E+00_JPRB &
  &, 0.911771E+00_JPRB, 0.895314E+00_JPRB, 0.878809E+00_JPRB, 0.862320E+00_JPRB &
  &, 0.845849E+00_JPRB, 0.829395E+00_JPRB, 0.812958E+00_JPRB &
  &, 0.796570E+00_JPRB, 0.780227E+00_JPRB, 0.763965E+00_JPRB, 0.747740E+00_JPRB &
  &, 0.731622E+00_JPRB, 0.715607E+00_JPRB, 0.699529E+00_JPRB &
  &, 0.683854E+00_JPRB, 0.668139E+00_JPRB, 0.652572E+00_JPRB, 0.637101E+00_JPRB &
  &, 0.621799E+00_JPRB, 0.606610E+00_JPRB, 0.591606E+00_JPRB &
  &, 0.576774E+00_JPRB, 0.562097E+00_JPRB, 0.547558E+00_JPRB, 0.533230E+00_JPRB &
  &, 0.519095E+00_JPRB, 0.505133E+00_JPRB, 0.491370E+00_JPRB &
  &, 0.477833E+00_JPRB, 0.464448E+00_JPRB, 0.451292E+00_JPRB, 0.438337E+00_JPRB &
  &, 0.425608E+00_JPRB, 0.413132E+00_JPRB, 0.400824E+00_JPRB &
  &, 0.388762E+00_JPRB, 0.376858E+00_JPRB, 0.365245E+00_JPRB, 0.353834E+00_JPRB &
  &, 0.342646E+00_JPRB, 0.331703E+00_JPRB, 0.321024E+00_JPRB &
  &, 0.310513E+00_JPRB, 0.300247E+00_JPRB, 0.290247E+00_JPRB, 0.280407E+00_JPRB &
  &, 0.270872E+00_JPRB, 0.261533E+00_JPRB, 0.252406E+00_JPRB/)
XCW( 766, :) = (/ &
  &  0.107078E+01_JPRB, 0.108790E+01_JPRB, 0.110475E+01_JPRB, 0.112134E+01_JPRB &
  &, 0.113765E+01_JPRB, 0.115366E+01_JPRB, 0.116937E+01_JPRB &
  &, 0.118476E+01_JPRB, 0.119984E+01_JPRB, 0.121458E+01_JPRB, 0.122897E+01_JPRB &
  &, 0.124300E+01_JPRB, 0.125667E+01_JPRB, 0.126996E+01_JPRB &
  &, 0.128286E+01_JPRB, 0.129536E+01_JPRB, 0.130746E+01_JPRB, 0.131913E+01_JPRB &
  &, 0.133038E+01_JPRB, 0.134120E+01_JPRB, 0.135157E+01_JPRB &
  &, 0.136149E+01_JPRB, 0.137095E+01_JPRB, 0.137994E+01_JPRB, 0.138845E+01_JPRB &
  &, 0.139648E+01_JPRB, 0.140403E+01_JPRB, 0.141107E+01_JPRB &
  &, 0.141762E+01_JPRB, 0.142366E+01_JPRB, 0.142919E+01_JPRB, 0.143420E+01_JPRB &
  &, 0.143870E+01_JPRB, 0.144267E+01_JPRB, 0.144612E+01_JPRB &
  &, 0.144904E+01_JPRB, 0.145142E+01_JPRB, 0.145329E+01_JPRB, 0.145462E+01_JPRB &
  &, 0.145542E+01_JPRB, 0.145569E+01_JPRB, 0.145544E+01_JPRB &
  &, 0.145463E+01_JPRB, 0.145333E+01_JPRB, 0.145150E+01_JPRB, 0.144915E+01_JPRB &
  &, 0.144627E+01_JPRB, 0.144290E+01_JPRB, 0.143901E+01_JPRB &
  &, 0.143462E+01_JPRB, 0.142973E+01_JPRB, 0.142436E+01_JPRB, 0.141850E+01_JPRB &
  &, 0.141216E+01_JPRB, 0.140537E+01_JPRB, 0.139811E+01_JPRB &
  &, 0.139039E+01_JPRB, 0.138222E+01_JPRB, 0.137363E+01_JPRB, 0.136461E+01_JPRB &
  &, 0.135519E+01_JPRB, 0.134535E+01_JPRB, 0.133511E+01_JPRB &
  &, 0.132450E+01_JPRB, 0.131350E+01_JPRB, 0.130215E+01_JPRB, 0.129042E+01_JPRB &
  &, 0.127838E+01_JPRB, 0.126601E+01_JPRB, 0.125332E+01_JPRB &
  &, 0.124033E+01_JPRB, 0.122704E+01_JPRB, 0.121347E+01_JPRB, 0.119964E+01_JPRB &
  &, 0.118555E+01_JPRB, 0.117121E+01_JPRB, 0.115667E+01_JPRB &
  &, 0.114189E+01_JPRB, 0.112691E+01_JPRB, 0.111176E+01_JPRB, 0.109640E+01_JPRB &
  &, 0.108091E+01_JPRB, 0.106523E+01_JPRB, 0.104943E+01_JPRB &
  &, 0.103351E+01_JPRB, 0.101747E+01_JPRB, 0.100133E+01_JPRB, 0.985093E+00_JPRB &
  &, 0.968786E+00_JPRB, 0.952415E+00_JPRB, 0.936015E+00_JPRB &
  &, 0.919529E+00_JPRB, 0.903051E+00_JPRB, 0.886552E+00_JPRB, 0.870033E+00_JPRB &
  &, 0.853528E+00_JPRB, 0.837035E+00_JPRB, 0.820449E+00_JPRB &
  &, 0.804154E+00_JPRB, 0.787759E+00_JPRB, 0.771439E+00_JPRB, 0.755190E+00_JPRB &
  &, 0.739044E+00_JPRB, 0.722957E+00_JPRB, 0.706961E+00_JPRB &
  &, 0.691086E+00_JPRB, 0.675324E+00_JPRB, 0.659666E+00_JPRB, 0.644183E+00_JPRB &
  &, 0.628779E+00_JPRB, 0.613570E+00_JPRB, 0.598410E+00_JPRB &
  &, 0.583549E+00_JPRB, 0.568795E+00_JPRB, 0.554220E+00_JPRB, 0.539806E+00_JPRB &
  &, 0.525580E+00_JPRB, 0.511522E+00_JPRB, 0.497707E+00_JPRB &
  &, 0.484065E+00_JPRB, 0.470621E+00_JPRB, 0.457349E+00_JPRB, 0.444326E+00_JPRB &
  &, 0.431473E+00_JPRB, 0.418867E+00_JPRB, 0.406478E+00_JPRB &
  &, 0.394330E+00_JPRB, 0.382393E+00_JPRB, 0.370688E+00_JPRB, 0.359181E+00_JPRB &
  &, 0.347892E+00_JPRB, 0.336843E+00_JPRB, 0.326055E+00_JPRB &
  &, 0.315430E+00_JPRB, 0.305107E+00_JPRB, 0.294985E+00_JPRB, 0.285082E+00_JPRB &
  &, 0.275417E+00_JPRB, 0.265943E+00_JPRB, 0.256743E+00_JPRB/)
XCW( 767, :) = (/ &
  &  0.107113E+01_JPRB, 0.108833E+01_JPRB, 0.110528E+01_JPRB, 0.112196E+01_JPRB &
  &, 0.113836E+01_JPRB, 0.115447E+01_JPRB, 0.117028E+01_JPRB &
  &, 0.118578E+01_JPRB, 0.120095E+01_JPRB, 0.121579E+01_JPRB, 0.123029E+01_JPRB &
  &, 0.124443E+01_JPRB, 0.125820E+01_JPRB, 0.127159E+01_JPRB &
  &, 0.128460E+01_JPRB, 0.129721E+01_JPRB, 0.130942E+01_JPRB, 0.132121E+01_JPRB &
  &, 0.133257E+01_JPRB, 0.134350E+01_JPRB, 0.135399E+01_JPRB &
  &, 0.136402E+01_JPRB, 0.137359E+01_JPRB, 0.138270E+01_JPRB, 0.139133E+01_JPRB &
  &, 0.139948E+01_JPRB, 0.140714E+01_JPRB, 0.141430E+01_JPRB &
  &, 0.142097E+01_JPRB, 0.142713E+01_JPRB, 0.143277E+01_JPRB, 0.143790E+01_JPRB &
  &, 0.144224E+01_JPRB, 0.144661E+01_JPRB, 0.145017E+01_JPRB &
  &, 0.145321E+01_JPRB, 0.145570E+01_JPRB, 0.145769E+01_JPRB, 0.145913E+01_JPRB &
  &, 0.146005E+01_JPRB, 0.146043E+01_JPRB, 0.146029E+01_JPRB &
  &, 0.145961E+01_JPRB, 0.145841E+01_JPRB, 0.145669E+01_JPRB, 0.145444E+01_JPRB &
  &, 0.145168E+01_JPRB, 0.144840E+01_JPRB, 0.144462E+01_JPRB &
  &, 0.144033E+01_JPRB, 0.143554E+01_JPRB, 0.143028E+01_JPRB, 0.142452E+01_JPRB &
  &, 0.141827E+01_JPRB, 0.141157E+01_JPRB, 0.140441E+01_JPRB &
  &, 0.139677E+01_JPRB, 0.138871E+01_JPRB, 0.138020E+01_JPRB, 0.137126E+01_JPRB &
  &, 0.136191E+01_JPRB, 0.135215E+01_JPRB, 0.134200E+01_JPRB &
  &, 0.133145E+01_JPRB, 0.132053E+01_JPRB, 0.130924E+01_JPRB, 0.129759E+01_JPRB &
  &, 0.128562E+01_JPRB, 0.127329E+01_JPRB, 0.126067E+01_JPRB &
  &, 0.124773E+01_JPRB, 0.123449E+01_JPRB, 0.122097E+01_JPRB, 0.120718E+01_JPRB &
  &, 0.119315E+01_JPRB, 0.117886E+01_JPRB, 0.116433E+01_JPRB &
  &, 0.114960E+01_JPRB, 0.113465E+01_JPRB, 0.111952E+01_JPRB, 0.110419E+01_JPRB &
  &, 0.108869E+01_JPRB, 0.107306E+01_JPRB, 0.105727E+01_JPRB &
  &, 0.104136E+01_JPRB, 0.102533E+01_JPRB, 0.100920E+01_JPRB, 0.992956E+00_JPRB &
  &, 0.976644E+00_JPRB, 0.960265E+00_JPRB, 0.943853E+00_JPRB &
  &, 0.927382E+00_JPRB, 0.910851E+00_JPRB, 0.894328E+00_JPRB, 0.877813E+00_JPRB &
  &, 0.861275E+00_JPRB, 0.844745E+00_JPRB, 0.828257E+00_JPRB &
  &, 0.811809E+00_JPRB, 0.795364E+00_JPRB, 0.779025E+00_JPRB, 0.762715E+00_JPRB &
  &, 0.746503E+00_JPRB, 0.730385E+00_JPRB, 0.714353E+00_JPRB &
  &, 0.698398E+00_JPRB, 0.682592E+00_JPRB, 0.666885E+00_JPRB, 0.651307E+00_JPRB &
  &, 0.635845E+00_JPRB, 0.620573E+00_JPRB, 0.605391E+00_JPRB &
  &, 0.590414E+00_JPRB, 0.575584E+00_JPRB, 0.560928E+00_JPRB, 0.546429E+00_JPRB &
  &, 0.532112E+00_JPRB, 0.518008E+00_JPRB, 0.504093E+00_JPRB &
  &, 0.490347E+00_JPRB, 0.476793E+00_JPRB, 0.463509E+00_JPRB, 0.450368E+00_JPRB &
  &, 0.437444E+00_JPRB, 0.424762E+00_JPRB, 0.412240E+00_JPRB &
  &, 0.400009E+00_JPRB, 0.387984E+00_JPRB, 0.376131E+00_JPRB, 0.364527E+00_JPRB &
  &, 0.353195E+00_JPRB, 0.342042E+00_JPRB, 0.331146E+00_JPRB &
  &, 0.320468E+00_JPRB, 0.309967E+00_JPRB, 0.299786E+00_JPRB, 0.289758E+00_JPRB &
  &, 0.279962E+00_JPRB, 0.270354E+00_JPRB, 0.261146E+00_JPRB/)
XCW( 768, :) = (/ &
  &  0.107147E+01_JPRB, 0.108876E+01_JPRB, 0.110580E+01_JPRB, 0.112258E+01_JPRB &
  &, 0.113907E+01_JPRB, 0.115528E+01_JPRB, 0.117119E+01_JPRB &
  &, 0.118679E+01_JPRB, 0.120207E+01_JPRB, 0.121701E+01_JPRB, 0.123161E+01_JPRB &
  &, 0.124585E+01_JPRB, 0.125973E+01_JPRB, 0.127323E+01_JPRB &
  &, 0.128635E+01_JPRB, 0.129907E+01_JPRB, 0.131139E+01_JPRB, 0.132329E+01_JPRB &
  &, 0.133477E+01_JPRB, 0.134581E+01_JPRB, 0.135641E+01_JPRB &
  &, 0.136656E+01_JPRB, 0.137625E+01_JPRB, 0.138547E+01_JPRB, 0.139422E+01_JPRB &
  &, 0.140248E+01_JPRB, 0.141026E+01_JPRB, 0.141754E+01_JPRB &
  &, 0.142433E+01_JPRB, 0.143060E+01_JPRB, 0.143637E+01_JPRB, 0.144162E+01_JPRB &
  &, 0.144635E+01_JPRB, 0.145056E+01_JPRB, 0.145424E+01_JPRB &
  &, 0.145739E+01_JPRB, 0.146001E+01_JPRB, 0.146210E+01_JPRB, 0.146367E+01_JPRB &
  &, 0.146470E+01_JPRB, 0.146519E+01_JPRB, 0.146516E+01_JPRB &
  &, 0.146459E+01_JPRB, 0.146350E+01_JPRB, 0.146172E+01_JPRB, 0.145976E+01_JPRB &
  &, 0.145711E+01_JPRB, 0.145394E+01_JPRB, 0.145026E+01_JPRB &
  &, 0.144607E+01_JPRB, 0.144140E+01_JPRB, 0.143620E+01_JPRB, 0.143056E+01_JPRB &
  &, 0.142431E+01_JPRB, 0.141781E+01_JPRB, 0.141074E+01_JPRB &
  &, 0.140320E+01_JPRB, 0.139523E+01_JPRB, 0.138680E+01_JPRB, 0.137795E+01_JPRB &
  &, 0.136869E+01_JPRB, 0.135901E+01_JPRB, 0.134892E+01_JPRB &
  &, 0.133845E+01_JPRB, 0.132760E+01_JPRB, 0.131638E+01_JPRB, 0.130482E+01_JPRB &
  &, 0.129288E+01_JPRB, 0.128063E+01_JPRB, 0.126807E+01_JPRB &
  &, 0.125517E+01_JPRB, 0.124201E+01_JPRB, 0.122853E+01_JPRB, 0.121479E+01_JPRB &
  &, 0.120080E+01_JPRB, 0.118654E+01_JPRB, 0.117205E+01_JPRB &
  &, 0.115736E+01_JPRB, 0.114244E+01_JPRB, 0.112732E+01_JPRB, 0.111204E+01_JPRB &
  &, 0.109656E+01_JPRB, 0.108094E+01_JPRB, 0.106517E+01_JPRB &
  &, 0.104927E+01_JPRB, 0.103325E+01_JPRB, 0.101712E+01_JPRB, 0.100088E+01_JPRB &
  &, 0.984562E+00_JPRB, 0.968176E+00_JPRB, 0.951753E+00_JPRB &
  &, 0.935266E+00_JPRB, 0.918749E+00_JPRB, 0.902202E+00_JPRB, 0.885627E+00_JPRB &
  &, 0.869090E+00_JPRB, 0.852523E+00_JPRB, 0.835994E+00_JPRB &
  &, 0.819501E+00_JPRB, 0.803078E+00_JPRB, 0.786647E+00_JPRB, 0.770315E+00_JPRB &
  &, 0.754078E+00_JPRB, 0.737891E+00_JPRB, 0.721784E+00_JPRB &
  &, 0.705791E+00_JPRB, 0.689941E+00_JPRB, 0.674145E+00_JPRB, 0.658515E+00_JPRB &
  &, 0.642996E+00_JPRB, 0.627664E+00_JPRB, 0.612416E+00_JPRB &
  &, 0.597369E+00_JPRB, 0.582464E+00_JPRB, 0.567729E+00_JPRB, 0.553146E+00_JPRB &
  &, 0.538788E+00_JPRB, 0.524590E+00_JPRB, 0.510578E+00_JPRB &
  &, 0.496728E+00_JPRB, 0.483117E+00_JPRB, 0.469669E+00_JPRB, 0.456461E+00_JPRB &
  &, 0.443467E+00_JPRB, 0.430711E+00_JPRB, 0.418111E+00_JPRB &
  &, 0.405743E+00_JPRB, 0.393631E+00_JPRB, 0.381687E+00_JPRB, 0.369988E+00_JPRB &
  &, 0.358557E+00_JPRB, 0.347300E+00_JPRB, 0.336296E+00_JPRB &
  &, 0.325507E+00_JPRB, 0.314951E+00_JPRB, 0.304649E+00_JPRB, 0.294559E+00_JPRB &
  &, 0.284636E+00_JPRB, 0.275024E+00_JPRB, 0.265614E+00_JPRB/)
XCW( 769, :) = (/ &
  &  0.107181E+01_JPRB, 0.108920E+01_JPRB, 0.110633E+01_JPRB, 0.112320E+01_JPRB &
  &, 0.113979E+01_JPRB, 0.115610E+01_JPRB, 0.117210E+01_JPRB &
  &, 0.118780E+01_JPRB, 0.120318E+01_JPRB, 0.121823E+01_JPRB, 0.123293E+01_JPRB &
  &, 0.124728E+01_JPRB, 0.126127E+01_JPRB, 0.127488E+01_JPRB &
  &, 0.128811E+01_JPRB, 0.130094E+01_JPRB, 0.131337E+01_JPRB, 0.132538E+01_JPRB &
  &, 0.133697E+01_JPRB, 0.134812E+01_JPRB, 0.135884E+01_JPRB &
  &, 0.136911E+01_JPRB, 0.137891E+01_JPRB, 0.138825E+01_JPRB, 0.139712E+01_JPRB &
  &, 0.140550E+01_JPRB, 0.141339E+01_JPRB, 0.142080E+01_JPRB &
  &, 0.142770E+01_JPRB, 0.143409E+01_JPRB, 0.143998E+01_JPRB, 0.144535E+01_JPRB &
  &, 0.145019E+01_JPRB, 0.145452E+01_JPRB, 0.145832E+01_JPRB &
  &, 0.146159E+01_JPRB, 0.146432E+01_JPRB, 0.146654E+01_JPRB, 0.146822E+01_JPRB &
  &, 0.146937E+01_JPRB, 0.146998E+01_JPRB, 0.147006E+01_JPRB &
  &, 0.146961E+01_JPRB, 0.146864E+01_JPRB, 0.146711E+01_JPRB, 0.146511E+01_JPRB &
  &, 0.146256E+01_JPRB, 0.145950E+01_JPRB, 0.145593E+01_JPRB &
  &, 0.145186E+01_JPRB, 0.144728E+01_JPRB, 0.144220E+01_JPRB, 0.143664E+01_JPRB &
  &, 0.143060E+01_JPRB, 0.142408E+01_JPRB, 0.141710E+01_JPRB &
  &, 0.140967E+01_JPRB, 0.140178E+01_JPRB, 0.139344E+01_JPRB, 0.138467E+01_JPRB &
  &, 0.137549E+01_JPRB, 0.136588E+01_JPRB, 0.135588E+01_JPRB &
  &, 0.134549E+01_JPRB, 0.133472E+01_JPRB, 0.132357E+01_JPRB, 0.131206E+01_JPRB &
  &, 0.130021E+01_JPRB, 0.128803E+01_JPRB, 0.127550E+01_JPRB &
  &, 0.126268E+01_JPRB, 0.124954E+01_JPRB, 0.123613E+01_JPRB, 0.122244E+01_JPRB &
  &, 0.120849E+01_JPRB, 0.119428E+01_JPRB, 0.117985E+01_JPRB &
  &, 0.116516E+01_JPRB, 0.115028E+01_JPRB, 0.113521E+01_JPRB, 0.111993E+01_JPRB &
  &, 0.110447E+01_JPRB, 0.108888E+01_JPRB, 0.107312E+01_JPRB &
  &, 0.105723E+01_JPRB, 0.104122E+01_JPRB, 0.102510E+01_JPRB, 0.100886E+01_JPRB &
  &, 0.992540E+00_JPRB, 0.976148E+00_JPRB, 0.959715E+00_JPRB &
  &, 0.943214E+00_JPRB, 0.926678E+00_JPRB, 0.910109E+00_JPRB, 0.893540E+00_JPRB &
  &, 0.876972E+00_JPRB, 0.860371E+00_JPRB, 0.843837E+00_JPRB &
  &, 0.827300E+00_JPRB, 0.810828E+00_JPRB, 0.794381E+00_JPRB, 0.777991E+00_JPRB &
  &, 0.761690E+00_JPRB, 0.745474E+00_JPRB, 0.729335E+00_JPRB &
  &, 0.713263E+00_JPRB, 0.697331E+00_JPRB, 0.681530E+00_JPRB, 0.665807E+00_JPRB &
  &, 0.650234E+00_JPRB, 0.634798E+00_JPRB, 0.619529E+00_JPRB &
  &, 0.604369E+00_JPRB, 0.589390E+00_JPRB, 0.574576E+00_JPRB, 0.559956E+00_JPRB &
  &, 0.545464E+00_JPRB, 0.531221E+00_JPRB, 0.517112E+00_JPRB &
  &, 0.503210E+00_JPRB, 0.489492E+00_JPRB, 0.475983E+00_JPRB, 0.462659E+00_JPRB &
  &, 0.449596E+00_JPRB, 0.436714E+00_JPRB, 0.424037E+00_JPRB &
  &, 0.411587E+00_JPRB, 0.399334E+00_JPRB, 0.387357E+00_JPRB, 0.375564E+00_JPRB &
  &, 0.363977E+00_JPRB, 0.352677E+00_JPRB, 0.341567E+00_JPRB &
  &, 0.330667E+00_JPRB, 0.319996E+00_JPRB, 0.309575E+00_JPRB, 0.299361E+00_JPRB &
  &, 0.289437E+00_JPRB, 0.279694E+00_JPRB, 0.270148E+00_JPRB/)
XCW( 770, :) = (/ &
  &  0.107216E+01_JPRB, 0.108963E+01_JPRB, 0.110686E+01_JPRB, 0.112382E+01_JPRB &
  &, 0.114051E+01_JPRB, 0.115691E+01_JPRB, 0.117302E+01_JPRB &
  &, 0.118882E+01_JPRB, 0.120430E+01_JPRB, 0.121945E+01_JPRB, 0.123426E+01_JPRB &
  &, 0.124871E+01_JPRB, 0.126281E+01_JPRB, 0.127653E+01_JPRB &
  &, 0.128987E+01_JPRB, 0.130281E+01_JPRB, 0.131535E+01_JPRB, 0.132748E+01_JPRB &
  &, 0.133918E+01_JPRB, 0.135045E+01_JPRB, 0.136128E+01_JPRB &
  &, 0.137166E+01_JPRB, 0.138159E+01_JPRB, 0.139104E+01_JPRB, 0.140003E+01_JPRB &
  &, 0.140853E+01_JPRB, 0.141654E+01_JPRB, 0.142406E+01_JPRB &
  &, 0.143108E+01_JPRB, 0.143760E+01_JPRB, 0.144360E+01_JPRB, 0.144909E+01_JPRB &
  &, 0.145406E+01_JPRB, 0.145850E+01_JPRB, 0.146242E+01_JPRB &
  &, 0.146581E+01_JPRB, 0.146867E+01_JPRB, 0.147100E+01_JPRB, 0.147279E+01_JPRB &
  &, 0.147405E+01_JPRB, 0.147478E+01_JPRB, 0.147498E+01_JPRB &
  &, 0.147465E+01_JPRB, 0.147378E+01_JPRB, 0.147240E+01_JPRB, 0.147048E+01_JPRB &
  &, 0.146804E+01_JPRB, 0.146509E+01_JPRB, 0.146162E+01_JPRB &
  &, 0.145765E+01_JPRB, 0.145317E+01_JPRB, 0.144821E+01_JPRB, 0.144275E+01_JPRB &
  &, 0.143681E+01_JPRB, 0.143038E+01_JPRB, 0.142350E+01_JPRB &
  &, 0.141616E+01_JPRB, 0.140836E+01_JPRB, 0.140011E+01_JPRB, 0.139143E+01_JPRB &
  &, 0.138233E+01_JPRB, 0.137281E+01_JPRB, 0.136289E+01_JPRB &
  &, 0.135257E+01_JPRB, 0.134188E+01_JPRB, 0.133081E+01_JPRB, 0.131936E+01_JPRB &
  &, 0.130757E+01_JPRB, 0.129545E+01_JPRB, 0.128300E+01_JPRB &
  &, 0.127023E+01_JPRB, 0.125717E+01_JPRB, 0.124378E+01_JPRB, 0.122998E+01_JPRB &
  &, 0.121623E+01_JPRB, 0.120208E+01_JPRB, 0.118767E+01_JPRB &
  &, 0.117304E+01_JPRB, 0.115820E+01_JPRB, 0.114313E+01_JPRB, 0.112788E+01_JPRB &
  &, 0.111247E+01_JPRB, 0.109687E+01_JPRB, 0.108113E+01_JPRB &
  &, 0.106525E+01_JPRB, 0.104925E+01_JPRB, 0.103313E+01_JPRB, 0.101690E+01_JPRB &
  &, 0.100061E+01_JPRB, 0.984211E+00_JPRB, 0.967739E+00_JPRB &
  &, 0.951257E+00_JPRB, 0.934705E+00_JPRB, 0.918114E+00_JPRB, 0.901521E+00_JPRB &
  &, 0.884923E+00_JPRB, 0.868322E+00_JPRB, 0.851715E+00_JPRB &
  &, 0.835170E+00_JPRB, 0.818651E+00_JPRB, 0.802151E+00_JPRB, 0.785742E+00_JPRB &
  &, 0.769379E+00_JPRB, 0.753096E+00_JPRB, 0.736924E+00_JPRB &
  &, 0.720817E+00_JPRB, 0.704844E+00_JPRB, 0.688956E+00_JPRB, 0.673184E+00_JPRB &
  &, 0.657556E+00_JPRB, 0.642062E+00_JPRB, 0.626687E+00_JPRB &
  &, 0.611459E+00_JPRB, 0.596407E+00_JPRB, 0.581516E+00_JPRB, 0.566814E+00_JPRB &
  &, 0.552283E+00_JPRB, 0.537901E+00_JPRB, 0.523744E+00_JPRB &
  &, 0.509741E+00_JPRB, 0.495967E+00_JPRB, 0.482349E+00_JPRB, 0.468961E+00_JPRB &
  &, 0.455778E+00_JPRB, 0.442771E+00_JPRB, 0.430017E+00_JPRB &
  &, 0.417487E+00_JPRB, 0.405149E+00_JPRB, 0.393026E+00_JPRB, 0.381140E+00_JPRB &
  &, 0.369514E+00_JPRB, 0.358054E+00_JPRB, 0.346837E+00_JPRB &
  &, 0.335887E+00_JPRB, 0.325102E+00_JPRB, 0.314625E+00_JPRB, 0.304289E+00_JPRB &
  &, 0.294238E+00_JPRB, 0.284429E+00_JPRB, 0.274814E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART110',1,ZHOOK_HANDLE)
END SUBROUTINE PART110

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART111

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART111',0,ZHOOK_HANDLE)

XCW( 771, :) = (/ &
  &  0.107251E+01_JPRB, 0.109007E+01_JPRB, 0.110739E+01_JPRB, 0.112445E+01_JPRB &
  &, 0.114123E+01_JPRB, 0.115773E+01_JPRB, 0.117394E+01_JPRB &
  &, 0.118984E+01_JPRB, 0.120542E+01_JPRB, 0.122068E+01_JPRB, 0.123559E+01_JPRB &
  &, 0.125015E+01_JPRB, 0.126436E+01_JPRB, 0.127819E+01_JPRB &
  &, 0.129163E+01_JPRB, 0.130469E+01_JPRB, 0.131734E+01_JPRB, 0.132958E+01_JPRB &
  &, 0.134140E+01_JPRB, 0.135278E+01_JPRB, 0.136373E+01_JPRB &
  &, 0.137423E+01_JPRB, 0.138427E+01_JPRB, 0.139385E+01_JPRB, 0.140295E+01_JPRB &
  &, 0.141157E+01_JPRB, 0.141970E+01_JPRB, 0.142734E+01_JPRB &
  &, 0.143448E+01_JPRB, 0.144112E+01_JPRB, 0.144724E+01_JPRB, 0.145285E+01_JPRB &
  &, 0.145794E+01_JPRB, 0.146250E+01_JPRB, 0.146654E+01_JPRB &
  &, 0.147005E+01_JPRB, 0.147303E+01_JPRB, 0.147547E+01_JPRB, 0.147739E+01_JPRB &
  &, 0.147877E+01_JPRB, 0.147961E+01_JPRB, 0.147993E+01_JPRB &
  &, 0.147970E+01_JPRB, 0.147895E+01_JPRB, 0.147768E+01_JPRB, 0.147588E+01_JPRB &
  &, 0.147355E+01_JPRB, 0.147070E+01_JPRB, 0.146736E+01_JPRB &
  &, 0.146349E+01_JPRB, 0.145912E+01_JPRB, 0.145424E+01_JPRB, 0.144889E+01_JPRB &
  &, 0.144306E+01_JPRB, 0.143673E+01_JPRB, 0.142994E+01_JPRB &
  &, 0.142268E+01_JPRB, 0.141497E+01_JPRB, 0.140683E+01_JPRB, 0.139823E+01_JPRB &
  &, 0.138923E+01_JPRB, 0.137979E+01_JPRB, 0.136994E+01_JPRB &
  &, 0.135970E+01_JPRB, 0.134908E+01_JPRB, 0.133807E+01_JPRB, 0.132671E+01_JPRB &
  &, 0.131499E+01_JPRB, 0.130293E+01_JPRB, 0.129053E+01_JPRB &
  &, 0.127782E+01_JPRB, 0.126481E+01_JPRB, 0.125150E+01_JPRB, 0.123790E+01_JPRB &
  &, 0.122404E+01_JPRB, 0.120991E+01_JPRB, 0.119556E+01_JPRB &
  &, 0.118095E+01_JPRB, 0.116613E+01_JPRB, 0.115112E+01_JPRB, 0.113590E+01_JPRB &
  &, 0.112049E+01_JPRB, 0.110494E+01_JPRB, 0.108921E+01_JPRB &
  &, 0.107336E+01_JPRB, 0.105734E+01_JPRB, 0.104123E+01_JPRB, 0.102502E+01_JPRB &
  &, 0.100871E+01_JPRB, 0.992306E+00_JPRB, 0.975857E+00_JPRB &
  &, 0.959332E+00_JPRB, 0.942763E+00_JPRB, 0.926186E+00_JPRB, 0.909568E+00_JPRB &
  &, 0.892942E+00_JPRB, 0.876308E+00_JPRB, 0.859699E+00_JPRB &
  &, 0.843112E+00_JPRB, 0.826546E+00_JPRB, 0.810033E+00_JPRB, 0.793568E+00_JPRB &
  &, 0.777145E+00_JPRB, 0.760835E+00_JPRB, 0.744593E+00_JPRB &
  &, 0.728450E+00_JPRB, 0.712397E+00_JPRB, 0.696466E+00_JPRB, 0.680645E+00_JPRB &
  &, 0.664922E+00_JPRB, 0.649370E+00_JPRB, 0.633932E+00_JPRB &
  &, 0.618638E+00_JPRB, 0.603515E+00_JPRB, 0.588549E+00_JPRB, 0.573766E+00_JPRB &
  &, 0.559149E+00_JPRB, 0.544677E+00_JPRB, 0.530425E+00_JPRB &
  &, 0.516372E+00_JPRB, 0.502494E+00_JPRB, 0.488817E+00_JPRB, 0.475315E+00_JPRB &
  &, 0.462013E+00_JPRB, 0.448988E+00_JPRB, 0.436105E+00_JPRB &
  &, 0.423496E+00_JPRB, 0.410629E+00_JPRB, 0.398866E+00_JPRB, 0.386889E+00_JPRB &
  &, 0.375109E+00_JPRB, 0.363548E+00_JPRB, 0.352287E+00_JPRB &
  &, 0.341168E+00_JPRB, 0.330332E+00_JPRB, 0.319676E+00_JPRB, 0.309281E+00_JPRB &
  &, 0.299104E+00_JPRB, 0.289164E+00_JPRB, 0.279479E+00_JPRB/)
XCW( 772, :) = (/ &
  &  0.107285E+01_JPRB, 0.109051E+01_JPRB, 0.110792E+01_JPRB, 0.112507E+01_JPRB &
  &, 0.114195E+01_JPRB, 0.115855E+01_JPRB, 0.117486E+01_JPRB &
  &, 0.119086E+01_JPRB, 0.120655E+01_JPRB, 0.122191E+01_JPRB, 0.123693E+01_JPRB &
  &, 0.125160E+01_JPRB, 0.126591E+01_JPRB, 0.127985E+01_JPRB &
  &, 0.129340E+01_JPRB, 0.130657E+01_JPRB, 0.131934E+01_JPRB, 0.133169E+01_JPRB &
  &, 0.134363E+01_JPRB, 0.135513E+01_JPRB, 0.136619E+01_JPRB &
  &, 0.137681E+01_JPRB, 0.138696E+01_JPRB, 0.139666E+01_JPRB, 0.140588E+01_JPRB &
  &, 0.141462E+01_JPRB, 0.142288E+01_JPRB, 0.143063E+01_JPRB &
  &, 0.143790E+01_JPRB, 0.144465E+01_JPRB, 0.145089E+01_JPRB, 0.145662E+01_JPRB &
  &, 0.146183E+01_JPRB, 0.146652E+01_JPRB, 0.147068E+01_JPRB &
  &, 0.147430E+01_JPRB, 0.147740E+01_JPRB, 0.147997E+01_JPRB, 0.148200E+01_JPRB &
  &, 0.148350E+01_JPRB, 0.148446E+01_JPRB, 0.148490E+01_JPRB &
  &, 0.148478E+01_JPRB, 0.148415E+01_JPRB, 0.148298E+01_JPRB, 0.148130E+01_JPRB &
  &, 0.147909E+01_JPRB, 0.147635E+01_JPRB, 0.147310E+01_JPRB &
  &, 0.146935E+01_JPRB, 0.146509E+01_JPRB, 0.146032E+01_JPRB, 0.145506E+01_JPRB &
  &, 0.144933E+01_JPRB, 0.144311E+01_JPRB, 0.143640E+01_JPRB &
  &, 0.142925E+01_JPRB, 0.142163E+01_JPRB, 0.141358E+01_JPRB, 0.140507E+01_JPRB &
  &, 0.139615E+01_JPRB, 0.138678E+01_JPRB, 0.137704E+01_JPRB &
  &, 0.136687E+01_JPRB, 0.135633E+01_JPRB, 0.134539E+01_JPRB, 0.133411E+01_JPRB &
  &, 0.132245E+01_JPRB, 0.131045E+01_JPRB, 0.129811E+01_JPRB &
  &, 0.128548E+01_JPRB, 0.127252E+01_JPRB, 0.125926E+01_JPRB, 0.124571E+01_JPRB &
  &, 0.123190E+01_JPRB, 0.121781E+01_JPRB, 0.120350E+01_JPRB &
  &, 0.118893E+01_JPRB, 0.117415E+01_JPRB, 0.115917E+01_JPRB, 0.114397E+01_JPRB &
  &, 0.112859E+01_JPRB, 0.111306E+01_JPRB, 0.109736E+01_JPRB &
  &, 0.108149E+01_JPRB, 0.106551E+01_JPRB, 0.104941E+01_JPRB, 0.103318E+01_JPRB &
  &, 0.101689E+01_JPRB, 0.100049E+01_JPRB, 0.984037E+00_JPRB &
  &, 0.967501E+00_JPRB, 0.950918E+00_JPRB, 0.934322E+00_JPRB, 0.917682E+00_JPRB &
  &, 0.901029E+00_JPRB, 0.884363E+00_JPRB, 0.867717E+00_JPRB &
  &, 0.851090E+00_JPRB, 0.834515E+00_JPRB, 0.817952E+00_JPRB, 0.801469E+00_JPRB &
  &, 0.785025E+00_JPRB, 0.768652E+00_JPRB, 0.752341E+00_JPRB &
  &, 0.736124E+00_JPRB, 0.720032E+00_JPRB, 0.704017E+00_JPRB, 0.688148E+00_JPRB &
  &, 0.672373E+00_JPRB, 0.656765E+00_JPRB, 0.641267E+00_JPRB &
  &, 0.625907E+00_JPRB, 0.610715E+00_JPRB, 0.595673E+00_JPRB, 0.580812E+00_JPRB &
  &, 0.566111E+00_JPRB, 0.551550E+00_JPRB, 0.537204E+00_JPRB &
  &, 0.523052E+00_JPRB, 0.509121E+00_JPRB, 0.495336E+00_JPRB, 0.481773E+00_JPRB &
  &, 0.468406E+00_JPRB, 0.455205E+00_JPRB, 0.442248E+00_JPRB &
  &, 0.429561E+00_JPRB, 0.417003E+00_JPRB, 0.404706E+00_JPRB, 0.392637E+00_JPRB &
  &, 0.380762E+00_JPRB, 0.369161E+00_JPRB, 0.357737E+00_JPRB &
  &, 0.346571E+00_JPRB, 0.335623E+00_JPRB, 0.324851E+00_JPRB, 0.314398E+00_JPRB &
  &, 0.304097E+00_JPRB, 0.294093E+00_JPRB, 0.284276E+00_JPRB/)
XCW( 773, :) = (/ &
  &  0.107320E+01_JPRB, 0.109095E+01_JPRB, 0.110845E+01_JPRB, 0.112570E+01_JPRB &
  &, 0.114268E+01_JPRB, 0.115938E+01_JPRB, 0.117578E+01_JPRB &
  &, 0.119189E+01_JPRB, 0.120768E+01_JPRB, 0.122314E+01_JPRB, 0.123827E+01_JPRB &
  &, 0.125304E+01_JPRB, 0.126746E+01_JPRB, 0.128151E+01_JPRB &
  &, 0.129518E+01_JPRB, 0.130846E+01_JPRB, 0.132134E+01_JPRB, 0.133381E+01_JPRB &
  &, 0.134586E+01_JPRB, 0.135748E+01_JPRB, 0.136866E+01_JPRB &
  &, 0.137939E+01_JPRB, 0.138967E+01_JPRB, 0.139948E+01_JPRB, 0.140882E+01_JPRB &
  &, 0.141768E+01_JPRB, 0.142606E+01_JPRB, 0.143393E+01_JPRB &
  &, 0.144132E+01_JPRB, 0.144820E+01_JPRB, 0.145456E+01_JPRB, 0.146041E+01_JPRB &
  &, 0.146574E+01_JPRB, 0.147055E+01_JPRB, 0.147483E+01_JPRB &
  &, 0.147858E+01_JPRB, 0.148180E+01_JPRB, 0.148449E+01_JPRB, 0.148664E+01_JPRB &
  &, 0.148826E+01_JPRB, 0.148934E+01_JPRB, 0.148988E+01_JPRB &
  &, 0.148989E+01_JPRB, 0.148937E+01_JPRB, 0.148832E+01_JPRB, 0.148675E+01_JPRB &
  &, 0.148465E+01_JPRB, 0.148202E+01_JPRB, 0.147889E+01_JPRB &
  &, 0.147525E+01_JPRB, 0.147109E+01_JPRB, 0.146643E+01_JPRB, 0.146127E+01_JPRB &
  &, 0.145563E+01_JPRB, 0.144951E+01_JPRB, 0.144291E+01_JPRB &
  &, 0.143586E+01_JPRB, 0.142834E+01_JPRB, 0.142036E+01_JPRB, 0.141196E+01_JPRB &
  &, 0.140311E+01_JPRB, 0.139385E+01_JPRB, 0.138416E+01_JPRB &
  &, 0.137409E+01_JPRB, 0.136362E+01_JPRB, 0.135276E+01_JPRB, 0.134154E+01_JPRB &
  &, 0.132995E+01_JPRB, 0.131801E+01_JPRB, 0.130575E+01_JPRB &
  &, 0.129318E+01_JPRB, 0.128027E+01_JPRB, 0.126706E+01_JPRB, 0.125356E+01_JPRB &
  &, 0.123980E+01_JPRB, 0.122578E+01_JPRB, 0.121149E+01_JPRB &
  &, 0.119698E+01_JPRB, 0.118223E+01_JPRB, 0.116726E+01_JPRB, 0.115210E+01_JPRB &
  &, 0.113675E+01_JPRB, 0.112124E+01_JPRB, 0.110555E+01_JPRB &
  &, 0.108970E+01_JPRB, 0.107374E+01_JPRB, 0.105765E+01_JPRB, 0.104143E+01_JPRB &
  &, 0.102511E+01_JPRB, 0.100874E+01_JPRB, 0.992247E+00_JPRB &
  &, 0.975734E+00_JPRB, 0.959138E+00_JPRB, 0.942525E+00_JPRB, 0.925862E+00_JPRB &
  &, 0.909183E+00_JPRB, 0.892521E+00_JPRB, 0.875841E+00_JPRB &
  &, 0.859175E+00_JPRB, 0.842556E+00_JPRB, 0.825981E+00_JPRB, 0.809408E+00_JPRB &
  &, 0.792944E+00_JPRB, 0.776508E+00_JPRB, 0.760168E+00_JPRB &
  &, 0.743918E+00_JPRB, 0.727749E+00_JPRB, 0.711692E+00_JPRB, 0.695777E+00_JPRB &
  &, 0.679953E+00_JPRB, 0.664247E+00_JPRB, 0.648689E+00_JPRB &
  &, 0.633266E+00_JPRB, 0.617959E+00_JPRB, 0.602891E+00_JPRB, 0.587905E+00_JPRB &
  &, 0.573121E+00_JPRB, 0.558520E+00_JPRB, 0.544082E+00_JPRB &
  &, 0.529833E+00_JPRB, 0.515800E+00_JPRB, 0.501959E+00_JPRB, 0.488284E+00_JPRB &
  &, 0.474799E+00_JPRB, 0.461583E+00_JPRB, 0.448500E+00_JPRB &
  &, 0.435681E+00_JPRB, 0.423097E+00_JPRB, 0.410659E+00_JPRB, 0.398501E+00_JPRB &
  &, 0.386532E+00_JPRB, 0.374833E+00_JPRB, 0.363307E+00_JPRB &
  &, 0.352034E+00_JPRB, 0.340975E+00_JPRB, 0.330150E+00_JPRB, 0.319516E+00_JPRB &
  &, 0.309155E+00_JPRB, 0.299023E+00_JPRB, 0.289073E+00_JPRB/)
XCW( 774, :) = (/ &
  &  0.107355E+01_JPRB, 0.109139E+01_JPRB, 0.110899E+01_JPRB, 0.112633E+01_JPRB &
  &, 0.114341E+01_JPRB, 0.116020E+01_JPRB, 0.117671E+01_JPRB &
  &, 0.119292E+01_JPRB, 0.120881E+01_JPRB, 0.122438E+01_JPRB, 0.123961E+01_JPRB &
  &, 0.125450E+01_JPRB, 0.126902E+01_JPRB, 0.128319E+01_JPRB &
  &, 0.129697E+01_JPRB, 0.131036E+01_JPRB, 0.132335E+01_JPRB, 0.133594E+01_JPRB &
  &, 0.134810E+01_JPRB, 0.135984E+01_JPRB, 0.137114E+01_JPRB &
  &, 0.138199E+01_JPRB, 0.139238E+01_JPRB, 0.140231E+01_JPRB, 0.141178E+01_JPRB &
  &, 0.142076E+01_JPRB, 0.142925E+01_JPRB, 0.143726E+01_JPRB &
  &, 0.144476E+01_JPRB, 0.145176E+01_JPRB, 0.145824E+01_JPRB, 0.146422E+01_JPRB &
  &, 0.146967E+01_JPRB, 0.147460E+01_JPRB, 0.147893E+01_JPRB &
  &, 0.148288E+01_JPRB, 0.148621E+01_JPRB, 0.148902E+01_JPRB, 0.149129E+01_JPRB &
  &, 0.149303E+01_JPRB, 0.149423E+01_JPRB, 0.149490E+01_JPRB &
  &, 0.149503E+01_JPRB, 0.149462E+01_JPRB, 0.149369E+01_JPRB, 0.149223E+01_JPRB &
  &, 0.149023E+01_JPRB, 0.148773E+01_JPRB, 0.148470E+01_JPRB &
  &, 0.148116E+01_JPRB, 0.147712E+01_JPRB, 0.147256E+01_JPRB, 0.146751E+01_JPRB &
  &, 0.146197E+01_JPRB, 0.145595E+01_JPRB, 0.144945E+01_JPRB &
  &, 0.144249E+01_JPRB, 0.143506E+01_JPRB, 0.142719E+01_JPRB, 0.141886E+01_JPRB &
  &, 0.141010E+01_JPRB, 0.140093E+01_JPRB, 0.139135E+01_JPRB &
  &, 0.138133E+01_JPRB, 0.137094E+01_JPRB, 0.136017E+01_JPRB, 0.134902E+01_JPRB &
  &, 0.133751E+01_JPRB, 0.132564E+01_JPRB, 0.131343E+01_JPRB &
  &, 0.130091E+01_JPRB, 0.128806E+01_JPRB, 0.127491E+01_JPRB, 0.126148E+01_JPRB &
  &, 0.124777E+01_JPRB, 0.123377E+01_JPRB, 0.121954E+01_JPRB &
  &, 0.120505E+01_JPRB, 0.119035E+01_JPRB, 0.117544E+01_JPRB, 0.116030E+01_JPRB &
  &, 0.114498E+01_JPRB, 0.112947E+01_JPRB, 0.111381E+01_JPRB &
  &, 0.109800E+01_JPRB, 0.108203E+01_JPRB, 0.106594E+01_JPRB, 0.104973E+01_JPRB &
  &, 0.103345E+01_JPRB, 0.101705E+01_JPRB, 0.100055E+01_JPRB &
  &, 0.984030E+00_JPRB, 0.967422E+00_JPRB, 0.950792E+00_JPRB, 0.934110E+00_JPRB &
  &, 0.917440E+00_JPRB, 0.900715E+00_JPRB, 0.884036E+00_JPRB &
  &, 0.867332E+00_JPRB, 0.850670E+00_JPRB, 0.834048E+00_JPRB, 0.817460E+00_JPRB &
  &, 0.800939E+00_JPRB, 0.784480E+00_JPRB, 0.768074E+00_JPRB &
  &, 0.751793E+00_JPRB, 0.735547E+00_JPRB, 0.719450E+00_JPRB, 0.703449E+00_JPRB &
  &, 0.687575E+00_JPRB, 0.671772E+00_JPRB, 0.656156E+00_JPRB &
  &, 0.640669E+00_JPRB, 0.625341E+00_JPRB, 0.610154E+00_JPRB, 0.595091E+00_JPRB &
  &, 0.580273E+00_JPRB, 0.565538E+00_JPRB, 0.551058E+00_JPRB &
  &, 0.536713E+00_JPRB, 0.522579E+00_JPRB, 0.508632E+00_JPRB, 0.494898E+00_JPRB &
  &, 0.481351E+00_JPRB, 0.467961E+00_JPRB, 0.454860E+00_JPRB &
  &, 0.441911E+00_JPRB, 0.429192E+00_JPRB, 0.416725E+00_JPRB, 0.404422E+00_JPRB &
  &, 0.392361E+00_JPRB, 0.380564E+00_JPRB, 0.368937E+00_JPRB &
  &, 0.357559E+00_JPRB, 0.346390E+00_JPRB, 0.335450E+00_JPRB, 0.324760E+00_JPRB &
  &, 0.314276E+00_JPRB, 0.304082E+00_JPRB, 0.294002E+00_JPRB/)
XCW( 775, :) = (/ &
  &  0.107390E+01_JPRB, 0.109183E+01_JPRB, 0.110952E+01_JPRB, 0.112696E+01_JPRB &
  &, 0.114413E+01_JPRB, 0.116103E+01_JPRB, 0.117764E+01_JPRB &
  &, 0.119395E+01_JPRB, 0.120995E+01_JPRB, 0.122562E+01_JPRB, 0.124096E+01_JPRB &
  &, 0.125595E+01_JPRB, 0.127059E+01_JPRB, 0.128486E+01_JPRB &
  &, 0.129876E+01_JPRB, 0.131226E+01_JPRB, 0.132537E+01_JPRB, 0.133807E+01_JPRB &
  &, 0.135035E+01_JPRB, 0.136220E+01_JPRB, 0.137362E+01_JPRB &
  &, 0.138459E+01_JPRB, 0.139511E+01_JPRB, 0.140516E+01_JPRB, 0.141474E+01_JPRB &
  &, 0.142385E+01_JPRB, 0.143246E+01_JPRB, 0.144059E+01_JPRB &
  &, 0.144821E+01_JPRB, 0.145533E+01_JPRB, 0.146194E+01_JPRB, 0.146804E+01_JPRB &
  &, 0.147362E+01_JPRB, 0.147867E+01_JPRB, 0.148319E+01_JPRB &
  &, 0.148718E+01_JPRB, 0.149065E+01_JPRB, 0.149358E+01_JPRB, 0.149597E+01_JPRB &
  &, 0.149783E+01_JPRB, 0.149915E+01_JPRB, 0.149993E+01_JPRB &
  &, 0.150018E+01_JPRB, 0.149990E+01_JPRB, 0.149907E+01_JPRB, 0.149772E+01_JPRB &
  &, 0.149585E+01_JPRB, 0.149346E+01_JPRB, 0.149055E+01_JPRB &
  &, 0.148711E+01_JPRB, 0.148317E+01_JPRB, 0.147872E+01_JPRB, 0.147379E+01_JPRB &
  &, 0.146835E+01_JPRB, 0.146243E+01_JPRB, 0.145604E+01_JPRB &
  &, 0.144917E+01_JPRB, 0.144183E+01_JPRB, 0.143405E+01_JPRB, 0.142582E+01_JPRB &
  &, 0.141715E+01_JPRB, 0.140807E+01_JPRB, 0.139855E+01_JPRB &
  &, 0.138864E+01_JPRB, 0.137833E+01_JPRB, 0.136762E+01_JPRB, 0.135654E+01_JPRB &
  &, 0.134511E+01_JPRB, 0.133332E+01_JPRB, 0.132118E+01_JPRB &
  &, 0.130872E+01_JPRB, 0.129592E+01_JPRB, 0.128282E+01_JPRB, 0.126945E+01_JPRB &
  &, 0.125578E+01_JPRB, 0.124183E+01_JPRB, 0.122765E+01_JPRB &
  &, 0.121320E+01_JPRB, 0.119853E+01_JPRB, 0.118366E+01_JPRB, 0.116856E+01_JPRB &
  &, 0.115326E+01_JPRB, 0.113778E+01_JPRB, 0.112214E+01_JPRB &
  &, 0.110633E+01_JPRB, 0.109040E+01_JPRB, 0.107433E+01_JPRB, 0.105812E+01_JPRB &
  &, 0.104182E+01_JPRB, 0.102542E+01_JPRB, 0.100895E+01_JPRB &
  &, 0.992390E+00_JPRB, 0.975803E+00_JPRB, 0.959126E+00_JPRB, 0.942457E+00_JPRB &
  &, 0.925730E+00_JPRB, 0.909012E+00_JPRB, 0.892301E+00_JPRB &
  &, 0.875560E+00_JPRB, 0.858893E+00_JPRB, 0.842225E+00_JPRB, 0.825587E+00_JPRB &
  &, 0.809011E+00_JPRB, 0.792530E+00_JPRB, 0.776059E+00_JPRB &
  &, 0.759707E+00_JPRB, 0.743468E+00_JPRB, 0.727291E+00_JPRB, 0.711205E+00_JPRB &
  &, 0.695283E+00_JPRB, 0.679428E+00_JPRB, 0.663755E+00_JPRB &
  &, 0.648162E+00_JPRB, 0.632768E+00_JPRB, 0.617511E+00_JPRB, 0.602372E+00_JPRB &
  &, 0.587473E+00_JPRB, 0.572702E+00_JPRB, 0.558083E+00_JPRB &
  &, 0.543693E+00_JPRB, 0.529460E+00_JPRB, 0.515408E+00_JPRB, 0.501565E+00_JPRB &
  &, 0.487902E+00_JPRB, 0.474500E+00_JPRB, 0.461275E+00_JPRB &
  &, 0.448252E+00_JPRB, 0.435454E+00_JPRB, 0.422848E+00_JPRB, 0.410458E+00_JPRB &
  &, 0.398305E+00_JPRB, 0.386354E+00_JPRB, 0.374686E+00_JPRB &
  &, 0.363204E+00_JPRB, 0.351927E+00_JPRB, 0.340874E+00_JPRB, 0.330067E+00_JPRB &
  &, 0.319526E+00_JPRB, 0.309141E+00_JPRB, 0.299061E+00_JPRB/)
XCW( 776, :) = (/ &
  &  0.107425E+01_JPRB, 0.109227E+01_JPRB, 0.111006E+01_JPRB, 0.112759E+01_JPRB &
  &, 0.114487E+01_JPRB, 0.116186E+01_JPRB, 0.117857E+01_JPRB &
  &, 0.119498E+01_JPRB, 0.121109E+01_JPRB, 0.122687E+01_JPRB, 0.124231E+01_JPRB &
  &, 0.125742E+01_JPRB, 0.127217E+01_JPRB, 0.128655E+01_JPRB &
  &, 0.130055E+01_JPRB, 0.131417E+01_JPRB, 0.132740E+01_JPRB, 0.134021E+01_JPRB &
  &, 0.135261E+01_JPRB, 0.136458E+01_JPRB, 0.137612E+01_JPRB &
  &, 0.138721E+01_JPRB, 0.139784E+01_JPRB, 0.140802E+01_JPRB, 0.141772E+01_JPRB &
  &, 0.142695E+01_JPRB, 0.143569E+01_JPRB, 0.144393E+01_JPRB &
  &, 0.145168E+01_JPRB, 0.145892E+01_JPRB, 0.146566E+01_JPRB, 0.147188E+01_JPRB &
  &, 0.147758E+01_JPRB, 0.148276E+01_JPRB, 0.148740E+01_JPRB &
  &, 0.149152E+01_JPRB, 0.149510E+01_JPRB, 0.149816E+01_JPRB, 0.150067E+01_JPRB &
  &, 0.150265E+01_JPRB, 0.150409E+01_JPRB, 0.150499E+01_JPRB &
  &, 0.150536E+01_JPRB, 0.150519E+01_JPRB, 0.150448E+01_JPRB, 0.150326E+01_JPRB &
  &, 0.150150E+01_JPRB, 0.149922E+01_JPRB, 0.149641E+01_JPRB &
  &, 0.149309E+01_JPRB, 0.148927E+01_JPRB, 0.148493E+01_JPRB, 0.148010E+01_JPRB &
  &, 0.147476E+01_JPRB, 0.146895E+01_JPRB, 0.146264E+01_JPRB &
  &, 0.145588E+01_JPRB, 0.144865E+01_JPRB, 0.144096E+01_JPRB, 0.143282E+01_JPRB &
  &, 0.142425E+01_JPRB, 0.141524E+01_JPRB, 0.140581E+01_JPRB &
  &, 0.139598E+01_JPRB, 0.138575E+01_JPRB, 0.137513E+01_JPRB, 0.136411E+01_JPRB &
  &, 0.135275E+01_JPRB, 0.134102E+01_JPRB, 0.132896E+01_JPRB &
  &, 0.131656E+01_JPRB, 0.130383E+01_JPRB, 0.129080E+01_JPRB, 0.127746E+01_JPRB &
  &, 0.126384E+01_JPRB, 0.124996E+01_JPRB, 0.123580E+01_JPRB &
  &, 0.122142E+01_JPRB, 0.120679E+01_JPRB, 0.119193E+01_JPRB, 0.117686E+01_JPRB &
  &, 0.116160E+01_JPRB, 0.114614E+01_JPRB, 0.113053E+01_JPRB &
  &, 0.111474E+01_JPRB, 0.109882E+01_JPRB, 0.108274E+01_JPRB, 0.106658E+01_JPRB &
  &, 0.105028E+01_JPRB, 0.103388E+01_JPRB, 0.101738E+01_JPRB &
  &, 0.100084E+01_JPRB, 0.984216E+00_JPRB, 0.967558E+00_JPRB, 0.950838E+00_JPRB &
  &, 0.934123E+00_JPRB, 0.917378E+00_JPRB, 0.900636E+00_JPRB &
  &, 0.883895E+00_JPRB, 0.867153E+00_JPRB, 0.850440E+00_JPRB, 0.833789E+00_JPRB &
  &, 0.817197E+00_JPRB, 0.800619E+00_JPRB, 0.784162E+00_JPRB &
  &, 0.767743E+00_JPRB, 0.751430E+00_JPRB, 0.735174E+00_JPRB, 0.719046E+00_JPRB &
  &, 0.703034E+00_JPRB, 0.687171E+00_JPRB, 0.671399E+00_JPRB &
  &, 0.655746E+00_JPRB, 0.640286E+00_JPRB, 0.624959E+00_JPRB, 0.609746E+00_JPRB &
  &, 0.594721E+00_JPRB, 0.579914E+00_JPRB, 0.565206E+00_JPRB &
  &, 0.550723E+00_JPRB, 0.536391E+00_JPRB, 0.522287E+00_JPRB, 0.508336E+00_JPRB &
  &, 0.494613E+00_JPRB, 0.481092E+00_JPRB, 0.467744E+00_JPRB &
  &, 0.454647E+00_JPRB, 0.441716E+00_JPRB, 0.429028E+00_JPRB, 0.416551E+00_JPRB &
  &, 0.404308E+00_JPRB, 0.392263E+00_JPRB, 0.380496E+00_JPRB &
  &, 0.368910E+00_JPRB, 0.357525E+00_JPRB, 0.346361E+00_JPRB, 0.335501E+00_JPRB &
  &, 0.324775E+00_JPRB, 0.314330E+00_JPRB, 0.304121E+00_JPRB/)
XCW( 777, :) = (/ &
  &  0.107460E+01_JPRB, 0.109272E+01_JPRB, 0.111060E+01_JPRB, 0.112823E+01_JPRB &
  &, 0.114560E+01_JPRB, 0.116270E+01_JPRB, 0.117951E+01_JPRB &
  &, 0.119602E+01_JPRB, 0.121223E+01_JPRB, 0.122812E+01_JPRB, 0.124367E+01_JPRB &
  &, 0.125888E+01_JPRB, 0.127374E+01_JPRB, 0.128824E+01_JPRB &
  &, 0.130236E+01_JPRB, 0.131609E+01_JPRB, 0.132943E+01_JPRB, 0.134236E+01_JPRB &
  &, 0.135488E+01_JPRB, 0.136697E+01_JPRB, 0.137862E+01_JPRB &
  &, 0.138983E+01_JPRB, 0.140059E+01_JPRB, 0.141088E+01_JPRB, 0.142071E+01_JPRB &
  &, 0.143006E+01_JPRB, 0.143892E+01_JPRB, 0.144729E+01_JPRB &
  &, 0.145516E+01_JPRB, 0.146253E+01_JPRB, 0.146939E+01_JPRB, 0.147573E+01_JPRB &
  &, 0.148156E+01_JPRB, 0.148686E+01_JPRB, 0.149163E+01_JPRB &
  &, 0.149587E+01_JPRB, 0.149958E+01_JPRB, 0.150275E+01_JPRB, 0.150539E+01_JPRB &
  &, 0.150749E+01_JPRB, 0.150905E+01_JPRB, 0.151008E+01_JPRB &
  &, 0.151057E+01_JPRB, 0.151051E+01_JPRB, 0.150993E+01_JPRB, 0.150881E+01_JPRB &
  &, 0.150718E+01_JPRB, 0.150501E+01_JPRB, 0.150231E+01_JPRB &
  &, 0.149911E+01_JPRB, 0.149538E+01_JPRB, 0.149116E+01_JPRB, 0.148644E+01_JPRB &
  &, 0.148121E+01_JPRB, 0.147549E+01_JPRB, 0.146931E+01_JPRB &
  &, 0.146264E+01_JPRB, 0.145549E+01_JPRB, 0.144791E+01_JPRB, 0.143986E+01_JPRB &
  &, 0.143138E+01_JPRB, 0.142246E+01_JPRB, 0.141311E+01_JPRB &
  &, 0.140336E+01_JPRB, 0.139320E+01_JPRB, 0.138268E+01_JPRB, 0.137174E+01_JPRB &
  &, 0.136045E+01_JPRB, 0.134879E+01_JPRB, 0.133679E+01_JPRB &
  &, 0.132445E+01_JPRB, 0.131179E+01_JPRB, 0.129883E+01_JPRB, 0.128554E+01_JPRB &
  &, 0.127197E+01_JPRB, 0.125814E+01_JPRB, 0.124403E+01_JPRB &
  &, 0.122969E+01_JPRB, 0.121508E+01_JPRB, 0.120028E+01_JPRB, 0.118522E+01_JPRB &
  &, 0.116999E+01_JPRB, 0.115459E+01_JPRB, 0.113897E+01_JPRB &
  &, 0.112320E+01_JPRB, 0.110731E+01_JPRB, 0.109124E+01_JPRB, 0.107509E+01_JPRB &
  &, 0.105879E+01_JPRB, 0.104240E+01_JPRB, 0.102590E+01_JPRB &
  &, 0.100936E+01_JPRB, 0.992726E+00_JPRB, 0.976056E+00_JPRB, 0.959320E+00_JPRB &
  &, 0.942583E+00_JPRB, 0.925813E+00_JPRB, 0.909041E+00_JPRB &
  &, 0.892267E+00_JPRB, 0.875521E+00_JPRB, 0.858765E+00_JPRB, 0.842067E+00_JPRB &
  &, 0.825422E+00_JPRB, 0.808824E+00_JPRB, 0.792306E+00_JPRB &
  &, 0.775858E+00_JPRB, 0.759473E+00_JPRB, 0.743181E+00_JPRB, 0.727012E+00_JPRB &
  &, 0.710914E+00_JPRB, 0.694957E+00_JPRB, 0.679130E+00_JPRB &
  &, 0.663418E+00_JPRB, 0.647895E+00_JPRB, 0.632454E+00_JPRB, 0.617215E+00_JPRB &
  &, 0.602112E+00_JPRB, 0.587174E+00_JPRB, 0.572428E+00_JPRB &
  &, 0.557852E+00_JPRB, 0.543423E+00_JPRB, 0.529217E+00_JPRB, 0.515210E+00_JPRB &
  &, 0.501376E+00_JPRB, 0.487738E+00_JPRB, 0.474322E+00_JPRB &
  &, 0.461153E+00_JPRB, 0.448146E+00_JPRB, 0.435321E+00_JPRB, 0.422760E+00_JPRB &
  &, 0.410428E+00_JPRB, 0.398289E+00_JPRB, 0.386365E+00_JPRB &
  &, 0.374677E+00_JPRB, 0.363186E+00_JPRB, 0.351973E+00_JPRB, 0.340934E+00_JPRB &
  &, 0.330153E+00_JPRB, 0.319649E+00_JPRB, 0.309312E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART111',1,ZHOOK_HANDLE)
END SUBROUTINE PART111

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART112

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART112',0,ZHOOK_HANDLE)

XCW( 778, :) = (/ &
  &  0.107495E+01_JPRB, 0.109316E+01_JPRB, 0.111114E+01_JPRB, 0.112887E+01_JPRB &
  &, 0.114634E+01_JPRB, 0.116353E+01_JPRB, 0.118045E+01_JPRB &
  &, 0.119706E+01_JPRB, 0.121338E+01_JPRB, 0.122937E+01_JPRB, 0.124503E+01_JPRB &
  &, 0.126035E+01_JPRB, 0.127532E+01_JPRB, 0.128993E+01_JPRB &
  &, 0.130417E+01_JPRB, 0.131801E+01_JPRB, 0.133147E+01_JPRB, 0.134452E+01_JPRB &
  &, 0.135715E+01_JPRB, 0.136936E+01_JPRB, 0.138113E+01_JPRB &
  &, 0.139247E+01_JPRB, 0.140334E+01_JPRB, 0.141376E+01_JPRB, 0.142371E+01_JPRB &
  &, 0.143318E+01_JPRB, 0.144217E+01_JPRB, 0.145066E+01_JPRB &
  &, 0.145866E+01_JPRB, 0.146615E+01_JPRB, 0.147314E+01_JPRB, 0.147960E+01_JPRB &
  &, 0.148556E+01_JPRB, 0.149098E+01_JPRB, 0.149588E+01_JPRB &
  &, 0.150024E+01_JPRB, 0.150408E+01_JPRB, 0.150737E+01_JPRB, 0.151013E+01_JPRB &
  &, 0.151235E+01_JPRB, 0.151404E+01_JPRB, 0.151519E+01_JPRB &
  &, 0.151579E+01_JPRB, 0.151586E+01_JPRB, 0.151540E+01_JPRB, 0.151441E+01_JPRB &
  &, 0.151287E+01_JPRB, 0.151082E+01_JPRB, 0.150825E+01_JPRB &
  &, 0.150515E+01_JPRB, 0.150155E+01_JPRB, 0.149743E+01_JPRB, 0.149280E+01_JPRB &
  &, 0.148768E+01_JPRB, 0.148207E+01_JPRB, 0.147598E+01_JPRB &
  &, 0.146942E+01_JPRB, 0.146239E+01_JPRB, 0.145488E+01_JPRB, 0.144693E+01_JPRB &
  &, 0.143854E+01_JPRB, 0.142971E+01_JPRB, 0.142046E+01_JPRB &
  &, 0.141080E+01_JPRB, 0.140073E+01_JPRB, 0.139026E+01_JPRB, 0.137942E+01_JPRB &
  &, 0.136819E+01_JPRB, 0.135661E+01_JPRB, 0.134468E+01_JPRB &
  &, 0.133240E+01_JPRB, 0.131980E+01_JPRB, 0.130689E+01_JPRB, 0.129368E+01_JPRB &
  &, 0.128017E+01_JPRB, 0.126637E+01_JPRB, 0.125233E+01_JPRB &
  &, 0.123801E+01_JPRB, 0.122346E+01_JPRB, 0.120868E+01_JPRB, 0.119368E+01_JPRB &
  &, 0.117846E+01_JPRB, 0.116306E+01_JPRB, 0.114750E+01_JPRB &
  &, 0.113175E+01_JPRB, 0.111585E+01_JPRB, 0.109982E+01_JPRB, 0.108365E+01_JPRB &
  &, 0.106737E+01_JPRB, 0.105098E+01_JPRB, 0.103448E+01_JPRB &
  &, 0.101794E+01_JPRB, 0.100130E+01_JPRB, 0.984619E+00_JPRB, 0.967867E+00_JPRB &
  &, 0.951111E+00_JPRB, 0.934317E+00_JPRB, 0.917517E+00_JPRB &
  &, 0.900745E+00_JPRB, 0.883926E+00_JPRB, 0.867165E+00_JPRB, 0.850457E+00_JPRB &
  &, 0.833761E+00_JPRB, 0.817108E+00_JPRB, 0.800528E+00_JPRB &
  &, 0.784014E+00_JPRB, 0.767598E+00_JPRB, 0.751271E+00_JPRB, 0.735021E+00_JPRB &
  &, 0.718879E+00_JPRB, 0.702874E+00_JPRB, 0.686951E+00_JPRB &
  &, 0.671181E+00_JPRB, 0.655550E+00_JPRB, 0.640088E+00_JPRB, 0.624730E+00_JPRB &
  &, 0.609598E+00_JPRB, 0.594579E+00_JPRB, 0.579699E+00_JPRB &
  &, 0.564982E+00_JPRB, 0.550557E+00_JPRB, 0.536250E+00_JPRB, 0.522137E+00_JPRB &
  &, 0.508245E+00_JPRB, 0.494545E+00_JPRB, 0.481009E+00_JPRB &
  &, 0.467714E+00_JPRB, 0.454632E+00_JPRB, 0.441728E+00_JPRB, 0.429026E+00_JPRB &
  &, 0.416606E+00_JPRB, 0.404375E+00_JPRB, 0.392354E+00_JPRB &
  &, 0.380565E+00_JPRB, 0.368969E+00_JPRB, 0.357646E+00_JPRB, 0.346557E+00_JPRB &
  &, 0.335658E+00_JPRB, 0.324967E+00_JPRB, 0.314569E+00_JPRB/)
XCW( 779, :) = (/ &
  &  0.107530E+01_JPRB, 0.109361E+01_JPRB, 0.111168E+01_JPRB, 0.112951E+01_JPRB &
  &, 0.114707E+01_JPRB, 0.116437E+01_JPRB, 0.118139E+01_JPRB &
  &, 0.119811E+01_JPRB, 0.121453E+01_JPRB, 0.123063E+01_JPRB, 0.124640E+01_JPRB &
  &, 0.126183E+01_JPRB, 0.127691E+01_JPRB, 0.129163E+01_JPRB &
  &, 0.130598E+01_JPRB, 0.131995E+01_JPRB, 0.133352E+01_JPRB, 0.134668E+01_JPRB &
  &, 0.135944E+01_JPRB, 0.137176E+01_JPRB, 0.138366E+01_JPRB &
  &, 0.139511E+01_JPRB, 0.140610E+01_JPRB, 0.141665E+01_JPRB, 0.142672E+01_JPRB &
  &, 0.143632E+01_JPRB, 0.144543E+01_JPRB, 0.145405E+01_JPRB &
  &, 0.146217E+01_JPRB, 0.146979E+01_JPRB, 0.147690E+01_JPRB, 0.148349E+01_JPRB &
  &, 0.148957E+01_JPRB, 0.149512E+01_JPRB, 0.150014E+01_JPRB &
  &, 0.150462E+01_JPRB, 0.150859E+01_JPRB, 0.151201E+01_JPRB, 0.151489E+01_JPRB &
  &, 0.151724E+01_JPRB, 0.151904E+01_JPRB, 0.152032E+01_JPRB &
  &, 0.152104E+01_JPRB, 0.152124E+01_JPRB, 0.152089E+01_JPRB, 0.152002E+01_JPRB &
  &, 0.151860E+01_JPRB, 0.151668E+01_JPRB, 0.151421E+01_JPRB &
  &, 0.151122E+01_JPRB, 0.150774E+01_JPRB, 0.150373E+01_JPRB, 0.149921E+01_JPRB &
  &, 0.149420E+01_JPRB, 0.148870E+01_JPRB, 0.148271E+01_JPRB &
  &, 0.147624E+01_JPRB, 0.146930E+01_JPRB, 0.146191E+01_JPRB, 0.145405E+01_JPRB &
  &, 0.144575E+01_JPRB, 0.143702E+01_JPRB, 0.142786E+01_JPRB &
  &, 0.141828E+01_JPRB, 0.140828E+01_JPRB, 0.139790E+01_JPRB, 0.138713E+01_JPRB &
  &, 0.137599E+01_JPRB, 0.136447E+01_JPRB, 0.135261E+01_JPRB &
  &, 0.134041E+01_JPRB, 0.132788E+01_JPRB, 0.131503E+01_JPRB, 0.130185E+01_JPRB &
  &, 0.128839E+01_JPRB, 0.127466E+01_JPRB, 0.126065E+01_JPRB &
  &, 0.124640E+01_JPRB, 0.123187E+01_JPRB, 0.121713E+01_JPRB, 0.120217E+01_JPRB &
  &, 0.118701E+01_JPRB, 0.117164E+01_JPRB, 0.115608E+01_JPRB &
  &, 0.114036E+01_JPRB, 0.112447E+01_JPRB, 0.110847E+01_JPRB, 0.109231E+01_JPRB &
  &, 0.107601E+01_JPRB, 0.105963E+01_JPRB, 0.104316E+01_JPRB &
  &, 0.102659E+01_JPRB, 0.100997E+01_JPRB, 0.993248E+00_JPRB, 0.976516E+00_JPRB &
  &, 0.959742E+00_JPRB, 0.942925E+00_JPRB, 0.926099E+00_JPRB &
  &, 0.909260E+00_JPRB, 0.891895E+00_JPRB, 0.875675E+00_JPRB, 0.858886E+00_JPRB &
  &, 0.842139E+00_JPRB, 0.825469E+00_JPRB, 0.808829E+00_JPRB &
  &, 0.792291E+00_JPRB, 0.775805E+00_JPRB, 0.759403E+00_JPRB, 0.743115E+00_JPRB &
  &, 0.726929E+00_JPRB, 0.710835E+00_JPRB, 0.694903E+00_JPRB &
  &, 0.679033E+00_JPRB, 0.663342E+00_JPRB, 0.647768E+00_JPRB, 0.632387E+00_JPRB &
  &, 0.617132E+00_JPRB, 0.602033E+00_JPRB, 0.587117E+00_JPRB &
  &, 0.572360E+00_JPRB, 0.557791E+00_JPRB, 0.543386E+00_JPRB, 0.529221E+00_JPRB &
  &, 0.515166E+00_JPRB, 0.501405E+00_JPRB, 0.487750E+00_JPRB &
  &, 0.474385E+00_JPRB, 0.461173E+00_JPRB, 0.448191E+00_JPRB, 0.435407E+00_JPRB &
  &, 0.422842E+00_JPRB, 0.410519E+00_JPRB, 0.398403E+00_JPRB &
  &, 0.386515E+00_JPRB, 0.374875E+00_JPRB, 0.363382E+00_JPRB, 0.352180E+00_JPRB &
  &, 0.341164E+00_JPRB, 0.330416E+00_JPRB, 0.319892E+00_JPRB/)
XCW( 780, :) = (/ &
  &  0.107566E+01_JPRB, 0.109406E+01_JPRB, 0.111222E+01_JPRB, 0.113015E+01_JPRB &
  &, 0.114781E+01_JPRB, 0.116521E+01_JPRB, 0.118233E+01_JPRB &
  &, 0.119916E+01_JPRB, 0.121568E+01_JPRB, 0.123189E+01_JPRB, 0.124777E+01_JPRB &
  &, 0.126331E+01_JPRB, 0.127851E+01_JPRB, 0.129334E+01_JPRB &
  &, 0.130780E+01_JPRB, 0.132188E+01_JPRB, 0.133557E+01_JPRB, 0.134885E+01_JPRB &
  &, 0.136173E+01_JPRB, 0.137417E+01_JPRB, 0.138619E+01_JPRB &
  &, 0.139776E+01_JPRB, 0.140889E+01_JPRB, 0.141955E+01_JPRB, 0.142975E+01_JPRB &
  &, 0.143947E+01_JPRB, 0.144870E+01_JPRB, 0.145745E+01_JPRB &
  &, 0.146570E+01_JPRB, 0.147344E+01_JPRB, 0.148068E+01_JPRB, 0.148740E+01_JPRB &
  &, 0.149360E+01_JPRB, 0.149927E+01_JPRB, 0.150442E+01_JPRB &
  &, 0.150904E+01_JPRB, 0.151313E+01_JPRB, 0.151667E+01_JPRB, 0.151968E+01_JPRB &
  &, 0.152215E+01_JPRB, 0.152408E+01_JPRB, 0.152547E+01_JPRB &
  &, 0.152632E+01_JPRB, 0.152664E+01_JPRB, 0.152642E+01_JPRB, 0.152566E+01_JPRB &
  &, 0.152437E+01_JPRB, 0.152255E+01_JPRB, 0.152020E+01_JPRB &
  &, 0.151733E+01_JPRB, 0.151395E+01_JPRB, 0.151005E+01_JPRB, 0.150566E+01_JPRB &
  &, 0.150075E+01_JPRB, 0.149536E+01_JPRB, 0.148948E+01_JPRB &
  &, 0.148311E+01_JPRB, 0.147628E+01_JPRB, 0.146896E+01_JPRB, 0.146122E+01_JPRB &
  &, 0.145300E+01_JPRB, 0.144437E+01_JPRB, 0.143530E+01_JPRB &
  &, 0.142579E+01_JPRB, 0.141589E+01_JPRB, 0.140560E+01_JPRB, 0.139489E+01_JPRB &
  &, 0.138383E+01_JPRB, 0.137240E+01_JPRB, 0.136060E+01_JPRB &
  &, 0.134847E+01_JPRB, 0.133599E+01_JPRB, 0.132321E+01_JPRB, 0.131011E+01_JPRB &
  &, 0.129670E+01_JPRB, 0.128301E+01_JPRB, 0.126906E+01_JPRB &
  &, 0.125484E+01_JPRB, 0.124036E+01_JPRB, 0.122565E+01_JPRB, 0.121073E+01_JPRB &
  &, 0.119561E+01_JPRB, 0.118025E+01_JPRB, 0.116474E+01_JPRB &
  &, 0.114904E+01_JPRB, 0.113319E+01_JPRB, 0.111717E+01_JPRB, 0.110103E+01_JPRB &
  &, 0.108474E+01_JPRB, 0.106836E+01_JPRB, 0.105190E+01_JPRB &
  &, 0.103533E+01_JPRB, 0.101867E+01_JPRB, 0.100198E+01_JPRB, 0.985231E+00_JPRB &
  &, 0.968372E+00_JPRB, 0.951603E+00_JPRB, 0.934751E+00_JPRB &
  &, 0.917917E+00_JPRB, 0.901064E+00_JPRB, 0.884223E+00_JPRB, 0.867427E+00_JPRB &
  &, 0.850632E+00_JPRB, 0.833908E+00_JPRB, 0.817249E+00_JPRB &
  &, 0.800647E+00_JPRB, 0.784093E+00_JPRB, 0.767659E+00_JPRB, 0.751292E+00_JPRB &
  &, 0.735066E+00_JPRB, 0.718926E+00_JPRB, 0.702900E+00_JPRB &
  &, 0.686975E+00_JPRB, 0.671225E+00_JPRB, 0.655587E+00_JPRB, 0.640090E+00_JPRB &
  &, 0.624762E+00_JPRB, 0.609584E+00_JPRB, 0.594584E+00_JPRB &
  &, 0.579739E+00_JPRB, 0.565077E+00_JPRB, 0.550624E+00_JPRB, 0.536356E+00_JPRB &
  &, 0.522246E+00_JPRB, 0.508319E+00_JPRB, 0.494599E+00_JPRB &
  &, 0.481112E+00_JPRB, 0.467827E+00_JPRB, 0.454768E+00_JPRB, 0.441902E+00_JPRB &
  &, 0.429194E+00_JPRB, 0.416782E+00_JPRB, 0.404572E+00_JPRB &
  &, 0.392585E+00_JPRB, 0.380781E+00_JPRB, 0.369243E+00_JPRB, 0.357930E+00_JPRB &
  &, 0.346797E+00_JPRB, 0.335929E+00_JPRB, 0.325280E+00_JPRB/)
XCW( 781, :) = (/ &
  &  0.107601E+01_JPRB, 0.109451E+01_JPRB, 0.111277E+01_JPRB, 0.113079E+01_JPRB &
  &, 0.114856E+01_JPRB, 0.116606E+01_JPRB, 0.118328E+01_JPRB &
  &, 0.120021E+01_JPRB, 0.121684E+01_JPRB, 0.123315E+01_JPRB, 0.124915E+01_JPRB &
  &, 0.126480E+01_JPRB, 0.128011E+01_JPRB, 0.129505E+01_JPRB &
  &, 0.130963E+01_JPRB, 0.132383E+01_JPRB, 0.133763E+01_JPRB, 0.135104E+01_JPRB &
  &, 0.136403E+01_JPRB, 0.137659E+01_JPRB, 0.138873E+01_JPRB &
  &, 0.140043E+01_JPRB, 0.141167E+01_JPRB, 0.142246E+01_JPRB, 0.143278E+01_JPRB &
  &, 0.144263E+01_JPRB, 0.145199E+01_JPRB, 0.146086E+01_JPRB &
  &, 0.146923E+01_JPRB, 0.147711E+01_JPRB, 0.148447E+01_JPRB, 0.149132E+01_JPRB &
  &, 0.149765E+01_JPRB, 0.150345E+01_JPRB, 0.150873E+01_JPRB &
  &, 0.151347E+01_JPRB, 0.151768E+01_JPRB, 0.152135E+01_JPRB, 0.152449E+01_JPRB &
  &, 0.152708E+01_JPRB, 0.152914E+01_JPRB, 0.153066E+01_JPRB &
  &, 0.153163E+01_JPRB, 0.153207E+01_JPRB, 0.153197E+01_JPRB, 0.153132E+01_JPRB &
  &, 0.153015E+01_JPRB, 0.152846E+01_JPRB, 0.152622E+01_JPRB &
  &, 0.152347E+01_JPRB, 0.152020E+01_JPRB, 0.151642E+01_JPRB, 0.151211E+01_JPRB &
  &, 0.150734E+01_JPRB, 0.150205E+01_JPRB, 0.149628E+01_JPRB &
  &, 0.149000E+01_JPRB, 0.148327E+01_JPRB, 0.147607E+01_JPRB, 0.146840E+01_JPRB &
  &, 0.146030E+01_JPRB, 0.145174E+01_JPRB, 0.144277E+01_JPRB &
  &, 0.143336E+01_JPRB, 0.142355E+01_JPRB, 0.141333E+01_JPRB, 0.140272E+01_JPRB &
  &, 0.139172E+01_JPRB, 0.138037E+01_JPRB, 0.136863E+01_JPRB &
  &, 0.135657E+01_JPRB, 0.134418E+01_JPRB, 0.133143E+01_JPRB, 0.131839E+01_JPRB &
  &, 0.130504E+01_JPRB, 0.129142E+01_JPRB, 0.127750E+01_JPRB &
  &, 0.126335E+01_JPRB, 0.124892E+01_JPRB, 0.123426E+01_JPRB, 0.121935E+01_JPRB &
  &, 0.120426E+01_JPRB, 0.118893E+01_JPRB, 0.117346E+01_JPRB &
  &, 0.115776E+01_JPRB, 0.114192E+01_JPRB, 0.112593E+01_JPRB, 0.110980E+01_JPRB &
  &, 0.109356E+01_JPRB, 0.107719E+01_JPRB, 0.106070E+01_JPRB &
  &, 0.104413E+01_JPRB, 0.102747E+01_JPRB, 0.101077E+01_JPRB, 0.994012E+00_JPRB &
  &, 0.977206E+00_JPRB, 0.960349E+00_JPRB, 0.943473E+00_JPRB &
  &, 0.926611E+00_JPRB, 0.909724E+00_JPRB, 0.892882E+00_JPRB, 0.876043E+00_JPRB &
  &, 0.859200E+00_JPRB, 0.842463E+00_JPRB, 0.825748E+00_JPRB &
  &, 0.809084E+00_JPRB, 0.792504E+00_JPRB, 0.775998E+00_JPRB, 0.759596E+00_JPRB &
  &, 0.743288E+00_JPRB, 0.727060E+00_JPRB, 0.710986E+00_JPRB &
  &, 0.695007E+00_JPRB, 0.679153E+00_JPRB, 0.663452E+00_JPRB, 0.647887E+00_JPRB &
  &, 0.632487E+00_JPRB, 0.617232E+00_JPRB, 0.602149E+00_JPRB &
  &, 0.587218E+00_JPRB, 0.572514E+00_JPRB, 0.557913E+00_JPRB, 0.543543E+00_JPRB &
  &, 0.529379E+00_JPRB, 0.514536E+00_JPRB, 0.501558E+00_JPRB &
  &, 0.487948E+00_JPRB, 0.474592E+00_JPRB, 0.461401E+00_JPRB, 0.448456E+00_JPRB &
  &, 0.435664E+00_JPRB, 0.423163E+00_JPRB, 0.410801E+00_JPRB &
  &, 0.398716E+00_JPRB, 0.386811E+00_JPRB, 0.375167E+00_JPRB, 0.363743E+00_JPRB &
  &, 0.352559E+00_JPRB, 0.341572E+00_JPRB, 0.330800E+00_JPRB/)
XCW( 782, :) = (/ &
  &  0.107637E+01_JPRB, 0.109496E+01_JPRB, 0.111332E+01_JPRB, 0.113143E+01_JPRB &
  &, 0.114930E+01_JPRB, 0.116690E+01_JPRB, 0.118423E+01_JPRB &
  &, 0.120126E+01_JPRB, 0.121800E+01_JPRB, 0.123443E+01_JPRB, 0.125053E+01_JPRB &
  &, 0.126629E+01_JPRB, 0.128171E+01_JPRB, 0.129677E+01_JPRB &
  &, 0.131146E+01_JPRB, 0.132578E+01_JPRB, 0.133970E+01_JPRB, 0.135322E+01_JPRB &
  &, 0.136634E+01_JPRB, 0.137902E+01_JPRB, 0.139128E+01_JPRB &
  &, 0.140310E+01_JPRB, 0.141448E+01_JPRB, 0.142539E+01_JPRB, 0.143583E+01_JPRB &
  &, 0.144580E+01_JPRB, 0.145529E+01_JPRB, 0.146429E+01_JPRB &
  &, 0.147279E+01_JPRB, 0.148079E+01_JPRB, 0.148828E+01_JPRB, 0.149525E+01_JPRB &
  &, 0.150171E+01_JPRB, 0.150765E+01_JPRB, 0.151305E+01_JPRB &
  &, 0.151792E+01_JPRB, 0.152225E+01_JPRB, 0.152605E+01_JPRB, 0.152932E+01_JPRB &
  &, 0.153204E+01_JPRB, 0.153422E+01_JPRB, 0.153587E+01_JPRB &
  &, 0.153697E+01_JPRB, 0.153752E+01_JPRB, 0.153754E+01_JPRB, 0.153702E+01_JPRB &
  &, 0.153598E+01_JPRB, 0.153439E+01_JPRB, 0.153229E+01_JPRB &
  &, 0.152964E+01_JPRB, 0.152650E+01_JPRB, 0.152282E+01_JPRB, 0.151865E+01_JPRB &
  &, 0.151395E+01_JPRB, 0.150878E+01_JPRB, 0.150311E+01_JPRB &
  &, 0.149695E+01_JPRB, 0.149033E+01_JPRB, 0.148321E+01_JPRB, 0.147566E+01_JPRB &
  &, 0.146763E+01_JPRB, 0.145919E+01_JPRB, 0.145029E+01_JPRB &
  &, 0.144098E+01_JPRB, 0.143125E+01_JPRB, 0.142110E+01_JPRB, 0.141058E+01_JPRB &
  &, 0.139966E+01_JPRB, 0.138837E+01_JPRB, 0.137673E+01_JPRB &
  &, 0.136473E+01_JPRB, 0.135240E+01_JPRB, 0.133974E+01_JPRB, 0.132676E+01_JPRB &
  &, 0.131347E+01_JPRB, 0.129988E+01_JPRB, 0.128604E+01_JPRB &
  &, 0.127191E+01_JPRB, 0.125752E+01_JPRB, 0.124291E+01_JPRB, 0.122804E+01_JPRB &
  &, 0.121299E+01_JPRB, 0.119770E+01_JPRB, 0.118223E+01_JPRB &
  &, 0.116659E+01_JPRB, 0.115078E+01_JPRB, 0.113480E+01_JPRB, 0.111867E+01_JPRB &
  &, 0.110243E+01_JPRB, 0.108605E+01_JPRB, 0.106960E+01_JPRB &
  &, 0.105303E+01_JPRB, 0.103637E+01_JPRB, 0.101966E+01_JPRB, 0.100286E+01_JPRB &
  &, 0.986041E+00_JPRB, 0.969165E+00_JPRB, 0.952300E+00_JPRB &
  &, 0.935375E+00_JPRB, 0.918493E+00_JPRB, 0.901577E+00_JPRB, 0.884734E+00_JPRB &
  &, 0.867884E+00_JPRB, 0.851058E+00_JPRB, 0.834326E+00_JPRB &
  &, 0.817602E+00_JPRB, 0.800956E+00_JPRB, 0.784420E+00_JPRB, 0.767942E+00_JPRB &
  &, 0.751596E+00_JPRB, 0.735325E+00_JPRB, 0.719159E+00_JPRB &
  &, 0.703129E+00_JPRB, 0.687218E+00_JPRB, 0.671456E+00_JPRB, 0.655825E+00_JPRB &
  &, 0.640307E+00_JPRB, 0.624976E+00_JPRB, 0.609813E+00_JPRB &
  &, 0.594796E+00_JPRB, 0.580001E+00_JPRB, 0.565357E+00_JPRB, 0.550887E+00_JPRB &
  &, 0.536565E+00_JPRB, 0.522522E+00_JPRB, 0.508625E+00_JPRB &
  &, 0.494895E+00_JPRB, 0.481413E+00_JPRB, 0.468148E+00_JPRB, 0.455067E+00_JPRB &
  &, 0.442191E+00_JPRB, 0.429603E+00_JPRB, 0.417149E+00_JPRB &
  &, 0.404969E+00_JPRB, 0.392963E+00_JPRB, 0.381214E+00_JPRB, 0.369682E+00_JPRB &
  &, 0.358385E+00_JPRB, 0.347280E+00_JPRB, 0.336385E+00_JPRB/)
XCW( 783, :) = (/ &
  &  0.107673E+01_JPRB, 0.109541E+01_JPRB, 0.111386E+01_JPRB, 0.113208E+01_JPRB &
  &, 0.115005E+01_JPRB, 0.116775E+01_JPRB, 0.118518E+01_JPRB &
  &, 0.120232E+01_JPRB, 0.121917E+01_JPRB, 0.123570E+01_JPRB, 0.125191E+01_JPRB &
  &, 0.126779E+01_JPRB, 0.128332E+01_JPRB, 0.129850E+01_JPRB &
  &, 0.131330E+01_JPRB, 0.132774E+01_JPRB, 0.134178E+01_JPRB, 0.135542E+01_JPRB &
  &, 0.136865E+01_JPRB, 0.138146E+01_JPRB, 0.139385E+01_JPRB &
  &, 0.140579E+01_JPRB, 0.141728E+01_JPRB, 0.142832E+01_JPRB, 0.143889E+01_JPRB &
  &, 0.144899E+01_JPRB, 0.145860E+01_JPRB, 0.146773E+01_JPRB &
  &, 0.147636E+01_JPRB, 0.148449E+01_JPRB, 0.149185E+01_JPRB, 0.149921E+01_JPRB &
  &, 0.150579E+01_JPRB, 0.151186E+01_JPRB, 0.151739E+01_JPRB &
  &, 0.152239E+01_JPRB, 0.152685E+01_JPRB, 0.153079E+01_JPRB, 0.153417E+01_JPRB &
  &, 0.153702E+01_JPRB, 0.153933E+01_JPRB, 0.154109E+01_JPRB &
  &, 0.154232E+01_JPRB, 0.154300E+01_JPRB, 0.154315E+01_JPRB, 0.154275E+01_JPRB &
  &, 0.154182E+01_JPRB, 0.154036E+01_JPRB, 0.153837E+01_JPRB &
  &, 0.153585E+01_JPRB, 0.153281E+01_JPRB, 0.152926E+01_JPRB, 0.152520E+01_JPRB &
  &, 0.152062E+01_JPRB, 0.151555E+01_JPRB, 0.150998E+01_JPRB &
  &, 0.150394E+01_JPRB, 0.149740E+01_JPRB, 0.149038E+01_JPRB, 0.148294E+01_JPRB &
  &, 0.147502E+01_JPRB, 0.146666E+01_JPRB, 0.145786E+01_JPRB &
  &, 0.144864E+01_JPRB, 0.143900E+01_JPRB, 0.142895E+01_JPRB, 0.141851E+01_JPRB &
  &, 0.140766E+01_JPRB, 0.139646E+01_JPRB, 0.138488E+01_JPRB &
  &, 0.137295E+01_JPRB, 0.136069E+01_JPRB, 0.134809E+01_JPRB, 0.133517E+01_JPRB &
  &, 0.132194E+01_JPRB, 0.130841E+01_JPRB, 0.129460E+01_JPRB &
  &, 0.128055E+01_JPRB, 0.126621E+01_JPRB, 0.125161E+01_JPRB, 0.123682E+01_JPRB &
  &, 0.122178E+01_JPRB, 0.120652E+01_JPRB, 0.119108E+01_JPRB &
  &, 0.117547E+01_JPRB, 0.115966E+01_JPRB, 0.114371E+01_JPRB, 0.112762E+01_JPRB &
  &, 0.111137E+01_JPRB, 0.109497E+01_JPRB, 0.107855E+01_JPRB &
  &, 0.106199E+01_JPRB, 0.104533E+01_JPRB, 0.102858E+01_JPRB, 0.101181E+01_JPRB &
  &, 0.994977E+00_JPRB, 0.978084E+00_JPRB, 0.961198E+00_JPRB &
  &, 0.944247E+00_JPRB, 0.927335E+00_JPRB, 0.910421E+00_JPRB, 0.893501E+00_JPRB &
  &, 0.876606E+00_JPRB, 0.859769E+00_JPRB, 0.842983E+00_JPRB &
  &, 0.826200E+00_JPRB, 0.809530E+00_JPRB, 0.792925E+00_JPRB, 0.776415E+00_JPRB &
  &, 0.759989E+00_JPRB, 0.743633E+00_JPRB, 0.727421E+00_JPRB &
  &, 0.711340E+00_JPRB, 0.695328E+00_JPRB, 0.679506E+00_JPRB, 0.663810E+00_JPRB &
  &, 0.648222E+00_JPRB, 0.632817E+00_JPRB, 0.617575E+00_JPRB &
  &, 0.602474E+00_JPRB, 0.587590E+00_JPRB, 0.572852E+00_JPRB, 0.558283E+00_JPRB &
  &, 0.543909E+00_JPRB, 0.529704E+00_JPRB, 0.515746E+00_JPRB &
  &, 0.501953E+00_JPRB, 0.488347E+00_JPRB, 0.475008E+00_JPRB, 0.461793E+00_JPRB &
  &, 0.448835E+00_JPRB, 0.436102E+00_JPRB, 0.423557E+00_JPRB &
  &, 0.411282E+00_JPRB, 0.399177E+00_JPRB, 0.387325E+00_JPRB, 0.375684E+00_JPRB &
  &, 0.364274E+00_JPRB, 0.353053E+00_JPRB, 0.342102E+00_JPRB/)
XCW( 784, :) = (/ &
  &  0.107709E+01_JPRB, 0.109586E+01_JPRB, 0.111441E+01_JPRB, 0.113273E+01_JPRB &
  &, 0.115080E+01_JPRB, 0.116860E+01_JPRB, 0.118614E+01_JPRB &
  &, 0.120338E+01_JPRB, 0.122034E+01_JPRB, 0.123698E+01_JPRB, 0.125330E+01_JPRB &
  &, 0.126929E+01_JPRB, 0.128494E+01_JPRB, 0.130023E+01_JPRB &
  &, 0.131515E+01_JPRB, 0.132970E+01_JPRB, 0.134386E+01_JPRB, 0.135763E+01_JPRB &
  &, 0.137098E+01_JPRB, 0.138391E+01_JPRB, 0.139642E+01_JPRB &
  &, 0.140849E+01_JPRB, 0.142011E+01_JPRB, 0.143127E+01_JPRB, 0.144197E+01_JPRB &
  &, 0.145219E+01_JPRB, 0.146194E+01_JPRB, 0.147119E+01_JPRB &
  &, 0.147994E+01_JPRB, 0.148820E+01_JPRB, 0.149595E+01_JPRB, 0.150318E+01_JPRB &
  &, 0.150990E+01_JPRB, 0.151609E+01_JPRB, 0.152175E+01_JPRB &
  &, 0.152687E+01_JPRB, 0.153148E+01_JPRB, 0.153553E+01_JPRB, 0.153904E+01_JPRB &
  &, 0.154203E+01_JPRB, 0.154446E+01_JPRB, 0.154636E+01_JPRB &
  &, 0.154770E+01_JPRB, 0.154851E+01_JPRB, 0.154878E+01_JPRB, 0.154851E+01_JPRB &
  &, 0.154770E+01_JPRB, 0.154636E+01_JPRB, 0.154449E+01_JPRB &
  &, 0.154209E+01_JPRB, 0.153916E+01_JPRB, 0.153573E+01_JPRB, 0.153177E+01_JPRB &
  &, 0.152732E+01_JPRB, 0.152236E+01_JPRB, 0.151690E+01_JPRB &
  &, 0.151096E+01_JPRB, 0.150454E+01_JPRB, 0.149763E+01_JPRB, 0.149028E+01_JPRB &
  &, 0.148245E+01_JPRB, 0.147419E+01_JPRB, 0.146549E+01_JPRB &
  &, 0.145635E+01_JPRB, 0.144679E+01_JPRB, 0.143684E+01_JPRB, 0.142647E+01_JPRB &
  &, 0.141571E+01_JPRB, 0.140459E+01_JPRB, 0.139308E+01_JPRB &
  &, 0.138122E+01_JPRB, 0.136903E+01_JPRB, 0.135649E+01_JPRB, 0.134363E+01_JPRB &
  &, 0.133046E+01_JPRB, 0.131701E+01_JPRB, 0.130325E+01_JPRB &
  &, 0.128923E+01_JPRB, 0.127494E+01_JPRB, 0.126039E+01_JPRB, 0.124564E+01_JPRB &
  &, 0.123064E+01_JPRB, 0.121542E+01_JPRB, 0.120002E+01_JPRB &
  &, 0.118441E+01_JPRB, 0.116863E+01_JPRB, 0.115270E+01_JPRB, 0.113660E+01_JPRB &
  &, 0.112040E+01_JPRB, 0.110404E+01_JPRB, 0.108757E+01_JPRB &
  &, 0.107101E+01_JPRB, 0.105436E+01_JPRB, 0.103764E+01_JPRB, 0.102082E+01_JPRB &
  &, 0.100398E+01_JPRB, 0.987072E+00_JPRB, 0.970166E+00_JPRB &
  &, 0.953227E+00_JPRB, 0.936249E+00_JPRB, 0.919302E+00_JPRB, 0.902343E+00_JPRB &
  &, 0.885443E+00_JPRB, 0.868558E+00_JPRB, 0.851719E+00_JPRB &
  &, 0.834918E+00_JPRB, 0.818186E+00_JPRB, 0.801223E+00_JPRB, 0.784972E+00_JPRB &
  &, 0.768468E+00_JPRB, 0.752072E+00_JPRB, 0.735816E+00_JPRB &
  &, 0.719641E+00_JPRB, 0.703576E+00_JPRB, 0.687648E+00_JPRB, 0.671889E+00_JPRB &
  &, 0.656233E+00_JPRB, 0.640755E+00_JPRB, 0.625435E+00_JPRB &
  &, 0.610251E+00_JPRB, 0.595230E+00_JPRB, 0.580449E+00_JPRB, 0.565783E+00_JPRB &
  &, 0.551306E+00_JPRB, 0.537047E+00_JPRB, 0.522976E+00_JPRB &
  &, 0.509065E+00_JPRB, 0.495391E+00_JPRB, 0.481925E+00_JPRB, 0.468633E+00_JPRB &
  &, 0.455596E+00_JPRB, 0.442720E+00_JPRB, 0.430085E+00_JPRB &
  &, 0.417717E+00_JPRB, 0.405514E+00_JPRB, 0.393497E+00_JPRB, 0.381749E+00_JPRB &
  &, 0.370228E+00_JPRB, 0.358955E+00_JPRB, 0.347885E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART112',1,ZHOOK_HANDLE)
END SUBROUTINE PART112

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART113

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART113',0,ZHOOK_HANDLE)

XCW( 785, :) = (/ &
  &  0.107745E+01_JPRB, 0.109632E+01_JPRB, 0.111497E+01_JPRB, 0.113338E+01_JPRB &
  &, 0.115155E+01_JPRB, 0.116946E+01_JPRB, 0.118710E+01_JPRB &
  &, 0.120445E+01_JPRB, 0.122151E+01_JPRB, 0.123826E+01_JPRB, 0.125469E+01_JPRB &
  &, 0.127080E+01_JPRB, 0.128656E+01_JPRB, 0.130197E+01_JPRB &
  &, 0.131701E+01_JPRB, 0.133168E+01_JPRB, 0.134596E+01_JPRB, 0.135984E+01_JPRB &
  &, 0.137331E+01_JPRB, 0.138637E+01_JPRB, 0.139900E+01_JPRB &
  &, 0.141119E+01_JPRB, 0.142294E+01_JPRB, 0.143423E+01_JPRB, 0.144505E+01_JPRB &
  &, 0.145540E+01_JPRB, 0.146528E+01_JPRB, 0.147466E+01_JPRB &
  &, 0.148355E+01_JPRB, 0.149193E+01_JPRB, 0.149981E+01_JPRB, 0.150717E+01_JPRB &
  &, 0.151402E+01_JPRB, 0.152034E+01_JPRB, 0.152613E+01_JPRB &
  &, 0.153138E+01_JPRB, 0.153611E+01_JPRB, 0.154030E+01_JPRB, 0.154395E+01_JPRB &
  &, 0.154705E+01_JPRB, 0.154962E+01_JPRB, 0.155164E+01_JPRB &
  &, 0.155311E+01_JPRB, 0.155405E+01_JPRB, 0.155445E+01_JPRB, 0.155429E+01_JPRB &
  &, 0.155361E+01_JPRB, 0.155240E+01_JPRB, 0.155064E+01_JPRB &
  &, 0.154836E+01_JPRB, 0.154556E+01_JPRB, 0.154224E+01_JPRB, 0.153839E+01_JPRB &
  &, 0.153403E+01_JPRB, 0.152919E+01_JPRB, 0.152385E+01_JPRB &
  &, 0.151802E+01_JPRB, 0.151170E+01_JPRB, 0.150490E+01_JPRB, 0.149765E+01_JPRB &
  &, 0.148992E+01_JPRB, 0.148176E+01_JPRB, 0.147314E+01_JPRB &
  &, 0.146410E+01_JPRB, 0.145464E+01_JPRB, 0.144476E+01_JPRB, 0.143449E+01_JPRB &
  &, 0.142381E+01_JPRB, 0.141276E+01_JPRB, 0.140134E+01_JPRB &
  &, 0.138955E+01_JPRB, 0.137742E+01_JPRB, 0.136495E+01_JPRB, 0.135216E+01_JPRB &
  &, 0.133905E+01_JPRB, 0.132565E+01_JPRB, 0.131196E+01_JPRB &
  &, 0.129798E+01_JPRB, 0.128375E+01_JPRB, 0.126924E+01_JPRB, 0.125451E+01_JPRB &
  &, 0.123955E+01_JPRB, 0.122438E+01_JPRB, 0.120901E+01_JPRB &
  &, 0.119343E+01_JPRB, 0.117768E+01_JPRB, 0.116177E+01_JPRB, 0.114570E+01_JPRB &
  &, 0.112949E+01_JPRB, 0.111314E+01_JPRB, 0.109669E+01_JPRB &
  &, 0.108013E+01_JPRB, 0.106348E+01_JPRB, 0.104673E+01_JPRB, 0.102994E+01_JPRB &
  &, 0.101305E+01_JPRB, 0.996164E+00_JPRB, 0.979205E+00_JPRB &
  &, 0.962242E+00_JPRB, 0.945273E+00_JPRB, 0.928293E+00_JPRB, 0.911298E+00_JPRB &
  &, 0.894356E+00_JPRB, 0.877425E+00_JPRB, 0.860534E+00_JPRB &
  &, 0.843717E+00_JPRB, 0.826923E+00_JPRB, 0.810225E+00_JPRB, 0.793613E+00_JPRB &
  &, 0.777032E+00_JPRB, 0.760598E+00_JPRB, 0.744255E+00_JPRB &
  &, 0.728032E+00_JPRB, 0.711914E+00_JPRB, 0.695930E+00_JPRB, 0.680062E+00_JPRB &
  &, 0.664339E+00_JPRB, 0.648790E+00_JPRB, 0.633344E+00_JPRB &
  &, 0.618128E+00_JPRB, 0.603021E+00_JPRB, 0.588098E+00_JPRB, 0.573387E+00_JPRB &
  &, 0.558809E+00_JPRB, 0.544443E+00_JPRB, 0.530261E+00_JPRB &
  &, 0.516287E+00_JPRB, 0.502548E+00_JPRB, 0.488956E+00_JPRB, 0.475589E+00_JPRB &
  &, 0.462415E+00_JPRB, 0.449455E+00_JPRB, 0.436733E+00_JPRB &
  &, 0.424212E+00_JPRB, 0.411913E+00_JPRB, 0.399857E+00_JPRB, 0.388004E+00_JPRB &
  &, 0.376310E+00_JPRB, 0.364922E+00_JPRB, 0.353733E+00_JPRB/)
XCW( 786, :) = (/ &
  &  0.107780E+01_JPRB, 0.109677E+01_JPRB, 0.111552E+01_JPRB, 0.113403E+01_JPRB &
  &, 0.115230E+01_JPRB, 0.117031E+01_JPRB, 0.118806E+01_JPRB &
  &, 0.120552E+01_JPRB, 0.122269E+01_JPRB, 0.123955E+01_JPRB, 0.125609E+01_JPRB &
  &, 0.127231E+01_JPRB, 0.128819E+01_JPRB, 0.130371E+01_JPRB &
  &, 0.131887E+01_JPRB, 0.133366E+01_JPRB, 0.134805E+01_JPRB, 0.136206E+01_JPRB &
  &, 0.137566E+01_JPRB, 0.138884E+01_JPRB, 0.140159E+01_JPRB &
  &, 0.141391E+01_JPRB, 0.142578E+01_JPRB, 0.143720E+01_JPRB, 0.144815E+01_JPRB &
  &, 0.145863E+01_JPRB, 0.146863E+01_JPRB, 0.147814E+01_JPRB &
  &, 0.148716E+01_JPRB, 0.149568E+01_JPRB, 0.150369E+01_JPRB, 0.151118E+01_JPRB &
  &, 0.151815E+01_JPRB, 0.152461E+01_JPRB, 0.153053E+01_JPRB &
  &, 0.153591E+01_JPRB, 0.154077E+01_JPRB, 0.154509E+01_JPRB, 0.154887E+01_JPRB &
  &, 0.155210E+01_JPRB, 0.155480E+01_JPRB, 0.155694E+01_JPRB &
  &, 0.155855E+01_JPRB, 0.155961E+01_JPRB, 0.156013E+01_JPRB, 0.156011E+01_JPRB &
  &, 0.155955E+01_JPRB, 0.155846E+01_JPRB, 0.155682E+01_JPRB &
  &, 0.155466E+01_JPRB, 0.155198E+01_JPRB, 0.154877E+01_JPRB, 0.154505E+01_JPRB &
  &, 0.154082E+01_JPRB, 0.153609E+01_JPRB, 0.153085E+01_JPRB &
  &, 0.152512E+01_JPRB, 0.151890E+01_JPRB, 0.151222E+01_JPRB, 0.150507E+01_JPRB &
  &, 0.149744E+01_JPRB, 0.148936E+01_JPRB, 0.148086E+01_JPRB &
  &, 0.147190E+01_JPRB, 0.146254E+01_JPRB, 0.145274E+01_JPRB, 0.144255E+01_JPRB &
  &, 0.143196E+01_JPRB, 0.142098E+01_JPRB, 0.140964E+01_JPRB &
  &, 0.139794E+01_JPRB, 0.138589E+01_JPRB, 0.137348E+01_JPRB, 0.136075E+01_JPRB &
  &, 0.134770E+01_JPRB, 0.133437E+01_JPRB, 0.132073E+01_JPRB &
  &, 0.130679E+01_JPRB, 0.129260E+01_JPRB, 0.127815E+01_JPRB, 0.126346E+01_JPRB &
  &, 0.124855E+01_JPRB, 0.123341E+01_JPRB, 0.121806E+01_JPRB &
  &, 0.120251E+01_JPRB, 0.118679E+01_JPRB, 0.117091E+01_JPRB, 0.115486E+01_JPRB &
  &, 0.113867E+01_JPRB, 0.112233E+01_JPRB, 0.110589E+01_JPRB &
  &, 0.108932E+01_JPRB, 0.107267E+01_JPRB, 0.105591E+01_JPRB, 0.103912E+01_JPRB &
  &, 0.102223E+01_JPRB, 0.100533E+01_JPRB, 0.988349E+00_JPRB &
  &, 0.971365E+00_JPRB, 0.954369E+00_JPRB, 0.937359E+00_JPRB, 0.920365E+00_JPRB &
  &, 0.903346E+00_JPRB, 0.886408E+00_JPRB, 0.869468E+00_JPRB &
  &, 0.852595E+00_JPRB, 0.835783E+00_JPRB, 0.819021E+00_JPRB, 0.802339E+00_JPRB &
  &, 0.785725E+00_JPRB, 0.769211E+00_JPRB, 0.752826E+00_JPRB &
  &, 0.736512E+00_JPRB, 0.720343E+00_JPRB, 0.704258E+00_JPRB, 0.688329E+00_JPRB &
  &, 0.672541E+00_JPRB, 0.656921E+00_JPRB, 0.641401E+00_JPRB &
  &, 0.626055E+00_JPRB, 0.610913E+00_JPRB, 0.595901E+00_JPRB, 0.581095E+00_JPRB &
  &, 0.566418E+00_JPRB, 0.551947E+00_JPRB, 0.537709E+00_JPRB &
  &, 0.523620E+00_JPRB, 0.509761E+00_JPRB, 0.496043E+00_JPRB, 0.482602E+00_JPRB &
  &, 0.469350E+00_JPRB, 0.456309E+00_JPRB, 0.443441E+00_JPRB &
  &, 0.430829E+00_JPRB, 0.418434E+00_JPRB, 0.406217E+00_JPRB, 0.394259E+00_JPRB &
  &, 0.382520E+00_JPRB, 0.371019E+00_JPRB, 0.359713E+00_JPRB/)
XCW( 787, :) = (/ &
  &  0.107817E+01_JPRB, 0.109723E+01_JPRB, 0.111607E+01_JPRB, 0.113469E+01_JPRB &
  &, 0.115306E+01_JPRB, 0.117117E+01_JPRB, 0.118902E+01_JPRB &
  &, 0.120659E+01_JPRB, 0.122387E+01_JPRB, 0.124084E+01_JPRB, 0.125750E+01_JPRB &
  &, 0.127383E+01_JPRB, 0.128982E+01_JPRB, 0.130546E+01_JPRB &
  &, 0.132074E+01_JPRB, 0.133564E+01_JPRB, 0.135016E+01_JPRB, 0.136429E+01_JPRB &
  &, 0.137801E+01_JPRB, 0.139131E+01_JPRB, 0.140420E+01_JPRB &
  &, 0.141664E+01_JPRB, 0.142864E+01_JPRB, 0.144018E+01_JPRB, 0.145125E+01_JPRB &
  &, 0.146187E+01_JPRB, 0.147200E+01_JPRB, 0.148165E+01_JPRB &
  &, 0.149079E+01_JPRB, 0.149944E+01_JPRB, 0.150758E+01_JPRB, 0.151520E+01_JPRB &
  &, 0.152231E+01_JPRB, 0.152889E+01_JPRB, 0.153495E+01_JPRB &
  &, 0.154047E+01_JPRB, 0.154546E+01_JPRB, 0.154990E+01_JPRB, 0.155381E+01_JPRB &
  &, 0.155718E+01_JPRB, 0.156001E+01_JPRB, 0.156228E+01_JPRB &
  &, 0.156401E+01_JPRB, 0.156520E+01_JPRB, 0.156585E+01_JPRB, 0.156595E+01_JPRB &
  &, 0.156551E+01_JPRB, 0.156454E+01_JPRB, 0.156303E+01_JPRB &
  &, 0.156100E+01_JPRB, 0.155844E+01_JPRB, 0.155535E+01_JPRB, 0.155174E+01_JPRB &
  &, 0.154763E+01_JPRB, 0.154301E+01_JPRB, 0.153789E+01_JPRB &
  &, 0.153226E+01_JPRB, 0.152617E+01_JPRB, 0.151952E+01_JPRB, 0.151252E+01_JPRB &
  &, 0.150500E+01_JPRB, 0.149704E+01_JPRB, 0.148862E+01_JPRB &
  &, 0.147976E+01_JPRB, 0.147048E+01_JPRB, 0.146078E+01_JPRB, 0.145066E+01_JPRB &
  &, 0.144017E+01_JPRB, 0.142927E+01_JPRB, 0.141801E+01_JPRB &
  &, 0.140638E+01_JPRB, 0.139439E+01_JPRB, 0.138205E+01_JPRB, 0.136941E+01_JPRB &
  &, 0.135643E+01_JPRB, 0.134313E+01_JPRB, 0.132955E+01_JPRB &
  &, 0.131569E+01_JPRB, 0.130153E+01_JPRB, 0.128713E+01_JPRB, 0.127249E+01_JPRB &
  &, 0.125762E+01_JPRB, 0.124250E+01_JPRB, 0.122715E+01_JPRB &
  &, 0.121167E+01_JPRB, 0.119598E+01_JPRB, 0.118010E+01_JPRB, 0.116408E+01_JPRB &
  &, 0.114790E+01_JPRB, 0.113159E+01_JPRB, 0.111513E+01_JPRB &
  &, 0.109859E+01_JPRB, 0.108195E+01_JPRB, 0.106520E+01_JPRB, 0.104837E+01_JPRB &
  &, 0.103150E+01_JPRB, 0.101456E+01_JPRB, 0.997599E+00_JPRB &
  &, 0.980559E+00_JPRB, 0.963538E+00_JPRB, 0.946499E+00_JPRB, 0.929471E+00_JPRB &
  &, 0.912450E+00_JPRB, 0.895469E+00_JPRB, 0.878480E+00_JPRB &
  &, 0.861555E+00_JPRB, 0.844684E+00_JPRB, 0.827899E+00_JPRB, 0.811148E+00_JPRB &
  &, 0.794504E+00_JPRB, 0.777911E+00_JPRB, 0.761441E+00_JPRB &
  &, 0.745083E+00_JPRB, 0.728818E+00_JPRB, 0.712724E+00_JPRB, 0.696690E+00_JPRB &
  &, 0.680838E+00_JPRB, 0.665101E+00_JPRB, 0.649556E+00_JPRB &
  &, 0.634132E+00_JPRB, 0.618856E+00_JPRB, 0.603806E+00_JPRB, 0.588855E+00_JPRB &
  &, 0.574132E+00_JPRB, 0.559611E+00_JPRB, 0.545211E+00_JPRB &
  &, 0.531063E+00_JPRB, 0.517085E+00_JPRB, 0.503300E+00_JPRB, 0.489731E+00_JPRB &
  &, 0.476344E+00_JPRB, 0.463221E+00_JPRB, 0.450269E+00_JPRB &
  &, 0.437506E+00_JPRB, 0.425017E+00_JPRB, 0.412701E+00_JPRB, 0.400640E+00_JPRB &
  &, 0.388793E+00_JPRB, 0.377181E+00_JPRB, 0.365758E+00_JPRB/)
XCW( 788, :) = (/ &
  &  0.107853E+01_JPRB, 0.109769E+01_JPRB, 0.111663E+01_JPRB, 0.113534E+01_JPRB &
  &, 0.115382E+01_JPRB, 0.117204E+01_JPRB, 0.118999E+01_JPRB &
  &, 0.120767E+01_JPRB, 0.122505E+01_JPRB, 0.124214E+01_JPRB, 0.125891E+01_JPRB &
  &, 0.127535E+01_JPRB, 0.129146E+01_JPRB, 0.130721E+01_JPRB &
  &, 0.132261E+01_JPRB, 0.133764E+01_JPRB, 0.135228E+01_JPRB, 0.136653E+01_JPRB &
  &, 0.138037E+01_JPRB, 0.139380E+01_JPRB, 0.140681E+01_JPRB &
  &, 0.141938E+01_JPRB, 0.143150E+01_JPRB, 0.144318E+01_JPRB, 0.145439E+01_JPRB &
  &, 0.146511E+01_JPRB, 0.147539E+01_JPRB, 0.148516E+01_JPRB &
  &, 0.149444E+01_JPRB, 0.150322E+01_JPRB, 0.151143E+01_JPRB, 0.151925E+01_JPRB &
  &, 0.152649E+01_JPRB, 0.153320E+01_JPRB, 0.153939E+01_JPRB &
  &, 0.154505E+01_JPRB, 0.155017E+01_JPRB, 0.155474E+01_JPRB, 0.155878E+01_JPRB &
  &, 0.156227E+01_JPRB, 0.156523E+01_JPRB, 0.156764E+01_JPRB &
  &, 0.156950E+01_JPRB, 0.157082E+01_JPRB, 0.157159E+01_JPRB, 0.157183E+01_JPRB &
  &, 0.157152E+01_JPRB, 0.157067E+01_JPRB, 0.156929E+01_JPRB &
  &, 0.156737E+01_JPRB, 0.156492E+01_JPRB, 0.156196E+01_JPRB, 0.155848E+01_JPRB &
  &, 0.155448E+01_JPRB, 0.154996E+01_JPRB, 0.154496E+01_JPRB &
  &, 0.153946E+01_JPRB, 0.153346E+01_JPRB, 0.152698E+01_JPRB, 0.152002E+01_JPRB &
  &, 0.151262E+01_JPRB, 0.150474E+01_JPRB, 0.149643E+01_JPRB &
  &, 0.148767E+01_JPRB, 0.147847E+01_JPRB, 0.146886E+01_JPRB, 0.145884E+01_JPRB &
  &, 0.144843E+01_JPRB, 0.143762E+01_JPRB, 0.142643E+01_JPRB &
  &, 0.141487E+01_JPRB, 0.140296E+01_JPRB, 0.139069E+01_JPRB, 0.137812E+01_JPRB &
  &, 0.136520E+01_JPRB, 0.135197E+01_JPRB, 0.133844E+01_JPRB &
  &, 0.132462E+01_JPRB, 0.131054E+01_JPRB, 0.129619E+01_JPRB, 0.128160E+01_JPRB &
  &, 0.126675E+01_JPRB, 0.125167E+01_JPRB, 0.123639E+01_JPRB &
  &, 0.122092E+01_JPRB, 0.120526E+01_JPRB, 0.118941E+01_JPRB, 0.117338E+01_JPRB &
  &, 0.115723E+01_JPRB, 0.114093E+01_JPRB, 0.112449E+01_JPRB &
  &, 0.110794E+01_JPRB, 0.109130E+01_JPRB, 0.107455E+01_JPRB, 0.105772E+01_JPRB &
  &, 0.104085E+01_JPRB, 0.102389E+01_JPRB, 0.100688E+01_JPRB &
  &, 0.989860E+00_JPRB, 0.972817E+00_JPRB, 0.955749E+00_JPRB, 0.938689E+00_JPRB &
  &, 0.921631E+00_JPRB, 0.904608E+00_JPRB, 0.887612E+00_JPRB &
  &, 0.870635E+00_JPRB, 0.853707E+00_JPRB, 0.836860E+00_JPRB, 0.820085E+00_JPRB &
  &, 0.803369E+00_JPRB, 0.786741E+00_JPRB, 0.770189E+00_JPRB &
  &, 0.753787E+00_JPRB, 0.737430E+00_JPRB, 0.721237E+00_JPRB, 0.705192E+00_JPRB &
  &, 0.689230E+00_JPRB, 0.673426E+00_JPRB, 0.657809E+00_JPRB &
  &, 0.642309E+00_JPRB, 0.626951E+00_JPRB, 0.611763E+00_JPRB, 0.596772E+00_JPRB &
  &, 0.581952E+00_JPRB, 0.567275E+00_JPRB, 0.552821E+00_JPRB &
  &, 0.538562E+00_JPRB, 0.524522E+00_JPRB, 0.510614E+00_JPRB, 0.496974E+00_JPRB &
  &, 0.483454E+00_JPRB, 0.470193E+00_JPRB, 0.457156E+00_JPRB &
  &, 0.444366E+00_JPRB, 0.431723E+00_JPRB, 0.419310E+00_JPRB, 0.407148E+00_JPRB &
  &, 0.395195E+00_JPRB, 0.383473E+00_JPRB, 0.371935E+00_JPRB/)
XCW( 789, :) = (/ &
  &  0.107889E+01_JPRB, 0.109815E+01_JPRB, 0.111719E+01_JPRB, 0.113600E+01_JPRB &
  &, 0.115458E+01_JPRB, 0.117290E+01_JPRB, 0.119096E+01_JPRB &
  &, 0.120875E+01_JPRB, 0.122624E+01_JPRB, 0.124344E+01_JPRB, 0.126032E+01_JPRB &
  &, 0.127688E+01_JPRB, 0.129310E+01_JPRB, 0.130898E+01_JPRB &
  &, 0.132449E+01_JPRB, 0.133964E+01_JPRB, 0.135440E+01_JPRB, 0.136877E+01_JPRB &
  &, 0.138274E+01_JPRB, 0.139630E+01_JPRB, 0.140943E+01_JPRB &
  &, 0.142213E+01_JPRB, 0.143438E+01_JPRB, 0.144617E+01_JPRB, 0.145752E+01_JPRB &
  &, 0.146839E+01_JPRB, 0.147878E+01_JPRB, 0.148869E+01_JPRB &
  &, 0.149810E+01_JPRB, 0.150702E+01_JPRB, 0.151542E+01_JPRB, 0.152331E+01_JPRB &
  &, 0.153069E+01_JPRB, 0.153753E+01_JPRB, 0.154385E+01_JPRB &
  &, 0.154964E+01_JPRB, 0.155489E+01_JPRB, 0.155960E+01_JPRB, 0.156378E+01_JPRB &
  &, 0.156741E+01_JPRB, 0.157049E+01_JPRB, 0.157303E+01_JPRB &
  &, 0.157502E+01_JPRB, 0.157648E+01_JPRB, 0.157738E+01_JPRB, 0.157773E+01_JPRB &
  &, 0.157755E+01_JPRB, 0.157683E+01_JPRB, 0.157556E+01_JPRB &
  &, 0.157378E+01_JPRB, 0.157146E+01_JPRB, 0.156861E+01_JPRB, 0.156524E+01_JPRB &
  &, 0.156135E+01_JPRB, 0.155696E+01_JPRB, 0.155208E+01_JPRB &
  &, 0.154668E+01_JPRB, 0.154079E+01_JPRB, 0.153443E+01_JPRB, 0.152757E+01_JPRB &
  &, 0.152028E+01_JPRB, 0.151250E+01_JPRB, 0.150427E+01_JPRB &
  &, 0.149562E+01_JPRB, 0.148652E+01_JPRB, 0.147701E+01_JPRB, 0.146707E+01_JPRB &
  &, 0.145674E+01_JPRB, 0.144601E+01_JPRB, 0.143490E+01_JPRB &
  &, 0.142344E+01_JPRB, 0.141159E+01_JPRB, 0.139940E+01_JPRB, 0.138687E+01_JPRB &
  &, 0.137402E+01_JPRB, 0.136087E+01_JPRB, 0.134741E+01_JPRB &
  &, 0.133364E+01_JPRB, 0.131962E+01_JPRB, 0.130530E+01_JPRB, 0.129076E+01_JPRB &
  &, 0.127595E+01_JPRB, 0.126092E+01_JPRB, 0.124568E+01_JPRB &
  &, 0.123022E+01_JPRB, 0.121459E+01_JPRB, 0.119878E+01_JPRB, 0.118278E+01_JPRB &
  &, 0.116662E+01_JPRB, 0.115034E+01_JPRB, 0.113392E+01_JPRB &
  &, 0.111737E+01_JPRB, 0.110074E+01_JPRB, 0.108400E+01_JPRB, 0.106717E+01_JPRB &
  &, 0.105026E+01_JPRB, 0.103329E+01_JPRB, 0.101631E+01_JPRB &
  &, 0.999269E+00_JPRB, 0.982168E+00_JPRB, 0.965074E+00_JPRB, 0.947982E+00_JPRB &
  &, 0.930927E+00_JPRB, 0.913825E+00_JPRB, 0.896783E+00_JPRB &
  &, 0.879795E+00_JPRB, 0.862812E+00_JPRB, 0.845905E+00_JPRB, 0.829063E+00_JPRB &
  &, 0.812318E+00_JPRB, 0.795615E+00_JPRB, 0.779026E+00_JPRB &
  &, 0.762537E+00_JPRB, 0.746179E+00_JPRB, 0.729888E+00_JPRB, 0.713741E+00_JPRB &
  &, 0.697718E+00_JPRB, 0.681848E+00_JPRB, 0.666111E+00_JPRB &
  &, 0.650535E+00_JPRB, 0.635147E+00_JPRB, 0.619874E+00_JPRB, 0.604792E+00_JPRB &
  &, 0.589877E+00_JPRB, 0.575100E+00_JPRB, 0.560541E+00_JPRB &
  &, 0.546170E+00_JPRB, 0.532014E+00_JPRB, 0.518041E+00_JPRB, 0.504274E+00_JPRB &
  &, 0.490681E+00_JPRB, 0.477342E+00_JPRB, 0.464163E+00_JPRB &
  &, 0.451225E+00_JPRB, 0.438491E+00_JPRB, 0.425981E+00_JPRB, 0.413719E+00_JPRB &
  &, 0.401661E+00_JPRB, 0.389829E+00_JPRB, 0.378178E+00_JPRB/)
XCW( 790, :) = (/ &
  &  0.107926E+01_JPRB, 0.109861E+01_JPRB, 0.111775E+01_JPRB, 0.113666E+01_JPRB &
  &, 0.115534E+01_JPRB, 0.117377E+01_JPRB, 0.119194E+01_JPRB &
  &, 0.120983E+01_JPRB, 0.122744E+01_JPRB, 0.124474E+01_JPRB, 0.126174E+01_JPRB &
  &, 0.127841E+01_JPRB, 0.129475E+01_JPRB, 0.131075E+01_JPRB &
  &, 0.132638E+01_JPRB, 0.134165E+01_JPRB, 0.135654E+01_JPRB, 0.137103E+01_JPRB &
  &, 0.138512E+01_JPRB, 0.139880E+01_JPRB, 0.141206E+01_JPRB &
  &, 0.142489E+01_JPRB, 0.143727E+01_JPRB, 0.144920E+01_JPRB, 0.146067E+01_JPRB &
  &, 0.147167E+01_JPRB, 0.148220E+01_JPRB, 0.149224E+01_JPRB &
  &, 0.150178E+01_JPRB, 0.151083E+01_JPRB, 0.151937E+01_JPRB, 0.152739E+01_JPRB &
  &, 0.153490E+01_JPRB, 0.154188E+01_JPRB, 0.154834E+01_JPRB &
  &, 0.155426E+01_JPRB, 0.155964E+01_JPRB, 0.156449E+01_JPRB, 0.156880E+01_JPRB &
  &, 0.157256E+01_JPRB, 0.157577E+01_JPRB, 0.157844E+01_JPRB &
  &, 0.158057E+01_JPRB, 0.158215E+01_JPRB, 0.158318E+01_JPRB, 0.158367E+01_JPRB &
  &, 0.158362E+01_JPRB, 0.158302E+01_JPRB, 0.158189E+01_JPRB &
  &, 0.158022E+01_JPRB, 0.157802E+01_JPRB, 0.157529E+01_JPRB, 0.157205E+01_JPRB &
  &, 0.156828E+01_JPRB, 0.156400E+01_JPRB, 0.155922E+01_JPRB &
  &, 0.155394E+01_JPRB, 0.154818E+01_JPRB, 0.154191E+01_JPRB, 0.153517E+01_JPRB &
  &, 0.152797E+01_JPRB, 0.152030E+01_JPRB, 0.151205E+01_JPRB &
  &, 0.150362E+01_JPRB, 0.149461E+01_JPRB, 0.148520E+01_JPRB, 0.147534E+01_JPRB &
  &, 0.146511E+01_JPRB, 0.145446E+01_JPRB, 0.144345E+01_JPRB &
  &, 0.143204E+01_JPRB, 0.142027E+01_JPRB, 0.140817E+01_JPRB, 0.139571E+01_JPRB &
  &, 0.138292E+01_JPRB, 0.136982E+01_JPRB, 0.135642E+01_JPRB &
  &, 0.134271E+01_JPRB, 0.132875E+01_JPRB, 0.131448E+01_JPRB, 0.129997E+01_JPRB &
  &, 0.128524E+01_JPRB, 0.127025E+01_JPRB, 0.125503E+01_JPRB &
  &, 0.123960E+01_JPRB, 0.122401E+01_JPRB, 0.120820E+01_JPRB, 0.119223E+01_JPRB &
  &, 0.117610E+01_JPRB, 0.115984E+01_JPRB, 0.114343E+01_JPRB &
  &, 0.112690E+01_JPRB, 0.111025E+01_JPRB, 0.109351E+01_JPRB, 0.107669E+01_JPRB &
  &, 0.105977E+01_JPRB, 0.104280E+01_JPRB, 0.102577E+01_JPRB &
  &, 0.100871E+01_JPRB, 0.991628E+00_JPRB, 0.974509E+00_JPRB, 0.957389E+00_JPRB &
  &, 0.940261E+00_JPRB, 0.923158E+00_JPRB, 0.906112E+00_JPRB &
  &, 0.889036E+00_JPRB, 0.872039E+00_JPRB, 0.855074E+00_JPRB, 0.838210E+00_JPRB &
  &, 0.821354E+00_JPRB, 0.804620E+00_JPRB, 0.787995E+00_JPRB &
  &, 0.771421E+00_JPRB, 0.754973E+00_JPRB, 0.738633E+00_JPRB, 0.722431E+00_JPRB &
  &, 0.706349E+00_JPRB, 0.690367E+00_JPRB, 0.674561E+00_JPRB &
  &, 0.658911E+00_JPRB, 0.643394E+00_JPRB, 0.628036E+00_JPRB, 0.612865E+00_JPRB &
  &, 0.597855E+00_JPRB, 0.583033E+00_JPRB, 0.568369E+00_JPRB &
  &, 0.553944E+00_JPRB, 0.539674E+00_JPRB, 0.525581E+00_JPRB, 0.511690E+00_JPRB &
  &, 0.498025E+00_JPRB, 0.484550E+00_JPRB, 0.471290E+00_JPRB &
  &, 0.458267E+00_JPRB, 0.445443E+00_JPRB, 0.432840E+00_JPRB, 0.420416E+00_JPRB &
  &, 0.408255E+00_JPRB, 0.396251E+00_JPRB, 0.384552E+00_JPRB/)
XCW( 791, :) = (/ &
  &  0.107962E+01_JPRB, 0.109907E+01_JPRB, 0.111831E+01_JPRB, 0.113733E+01_JPRB &
  &, 0.115611E+01_JPRB, 0.117464E+01_JPRB, 0.119292E+01_JPRB &
  &, 0.121092E+01_JPRB, 0.122863E+01_JPRB, 0.124605E+01_JPRB, 0.126316E+01_JPRB &
  &, 0.127995E+01_JPRB, 0.129641E+01_JPRB, 0.131252E+01_JPRB &
  &, 0.132828E+01_JPRB, 0.134367E+01_JPRB, 0.135867E+01_JPRB, 0.137329E+01_JPRB &
  &, 0.138751E+01_JPRB, 0.140132E+01_JPRB, 0.141470E+01_JPRB &
  &, 0.142766E+01_JPRB, 0.144017E+01_JPRB, 0.145223E+01_JPRB, 0.146384E+01_JPRB &
  &, 0.147497E+01_JPRB, 0.148563E+01_JPRB, 0.149580E+01_JPRB &
  &, 0.150548E+01_JPRB, 0.151466E+01_JPRB, 0.152333E+01_JPRB, 0.153149E+01_JPRB &
  &, 0.153913E+01_JPRB, 0.154625E+01_JPRB, 0.155284E+01_JPRB &
  &, 0.155890E+01_JPRB, 0.156442E+01_JPRB, 0.156940E+01_JPRB, 0.157384E+01_JPRB &
  &, 0.157774E+01_JPRB, 0.158108E+01_JPRB, 0.158389E+01_JPRB &
  &, 0.158615E+01_JPRB, 0.158784E+01_JPRB, 0.158902E+01_JPRB, 0.158963E+01_JPRB &
  &, 0.158969E+01_JPRB, 0.158924E+01_JPRB, 0.158824E+01_JPRB &
  &, 0.158670E+01_JPRB, 0.158463E+01_JPRB, 0.158202E+01_JPRB, 0.157889E+01_JPRB &
  &, 0.157524E+01_JPRB, 0.157109E+01_JPRB, 0.156642E+01_JPRB &
  &, 0.156126E+01_JPRB, 0.155560E+01_JPRB, 0.154945E+01_JPRB, 0.154283E+01_JPRB &
  &, 0.153572E+01_JPRB, 0.152815E+01_JPRB, 0.152014E+01_JPRB &
  &, 0.151166E+01_JPRB, 0.150277E+01_JPRB, 0.149342E+01_JPRB, 0.148369E+01_JPRB &
  &, 0.147352E+01_JPRB, 0.146298E+01_JPRB, 0.145204E+01_JPRB &
  &, 0.144071E+01_JPRB, 0.142904E+01_JPRB, 0.141698E+01_JPRB, 0.140459E+01_JPRB &
  &, 0.139188E+01_JPRB, 0.137886E+01_JPRB, 0.136550E+01_JPRB &
  &, 0.135186E+01_JPRB, 0.133795E+01_JPRB, 0.132374E+01_JPRB, 0.130928E+01_JPRB &
  &, 0.129458E+01_JPRB, 0.127963E+01_JPRB, 0.126445E+01_JPRB &
  &, 0.124907E+01_JPRB, 0.123349E+01_JPRB, 0.121771E+01_JPRB, 0.120177E+01_JPRB &
  &, 0.118567E+01_JPRB, 0.116940E+01_JPRB, 0.115301E+01_JPRB &
  &, 0.113650E+01_JPRB, 0.111986E+01_JPRB, 0.110313E+01_JPRB, 0.108627E+01_JPRB &
  &, 0.106939E+01_JPRB, 0.105241E+01_JPRB, 0.103537E+01_JPRB &
  &, 0.101773E+01_JPRB, 0.100116E+01_JPRB, 0.984019E+00_JPRB, 0.966908E+00_JPRB &
  &, 0.949748E+00_JPRB, 0.932608E+00_JPRB, 0.915480E+00_JPRB &
  &, 0.898397E+00_JPRB, 0.881348E+00_JPRB, 0.864325E+00_JPRB, 0.847400E+00_JPRB &
  &, 0.830518E+00_JPRB, 0.813711E+00_JPRB, 0.797008E+00_JPRB &
  &, 0.780396E+00_JPRB, 0.763903E+00_JPRB, 0.747469E+00_JPRB, 0.731214E+00_JPRB &
  &, 0.715027E+00_JPRB, 0.698982E+00_JPRB, 0.683109E+00_JPRB &
  &, 0.667386E+00_JPRB, 0.651792E+00_JPRB, 0.636352E+00_JPRB, 0.621094E+00_JPRB &
  &, 0.605992E+00_JPRB, 0.591072E+00_JPRB, 0.576306E+00_JPRB &
  &, 0.561773E+00_JPRB, 0.547390E+00_JPRB, 0.533235E+00_JPRB, 0.519221E+00_JPRB &
  &, 0.505485E+00_JPRB, 0.491877E+00_JPRB, 0.478537E+00_JPRB &
  &, 0.465370E+00_JPRB, 0.452457E+00_JPRB, 0.439698E+00_JPRB, 0.427176E+00_JPRB &
  &, 0.414913E+00_JPRB, 0.402866E+00_JPRB, 0.390991E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART113',1,ZHOOK_HANDLE)
END SUBROUTINE PART113

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART114

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART114',0,ZHOOK_HANDLE)

XCW( 792, :) = (/ &
  &  0.107999E+01_JPRB, 0.109954E+01_JPRB, 0.111887E+01_JPRB, 0.113799E+01_JPRB &
  &, 0.115688E+01_JPRB, 0.117552E+01_JPRB, 0.119390E+01_JPRB &
  &, 0.121201E+01_JPRB, 0.122984E+01_JPRB, 0.124737E+01_JPRB, 0.126459E+01_JPRB &
  &, 0.128150E+01_JPRB, 0.129807E+01_JPRB, 0.131430E+01_JPRB &
  &, 0.133018E+01_JPRB, 0.134569E+01_JPRB, 0.136082E+01_JPRB, 0.137557E+01_JPRB &
  &, 0.138991E+01_JPRB, 0.140385E+01_JPRB, 0.141736E+01_JPRB &
  &, 0.143044E+01_JPRB, 0.144309E+01_JPRB, 0.145528E+01_JPRB, 0.146702E+01_JPRB &
  &, 0.147828E+01_JPRB, 0.148907E+01_JPRB, 0.149937E+01_JPRB &
  &, 0.150919E+01_JPRB, 0.151850E+01_JPRB, 0.152730E+01_JPRB, 0.153560E+01_JPRB &
  &, 0.154338E+01_JPRB, 0.155064E+01_JPRB, 0.155736E+01_JPRB &
  &, 0.156356E+01_JPRB, 0.156921E+01_JPRB, 0.157433E+01_JPRB, 0.157890E+01_JPRB &
  &, 0.158294E+01_JPRB, 0.158642E+01_JPRB, 0.158936E+01_JPRB &
  &, 0.159175E+01_JPRB, 0.159360E+01_JPRB, 0.159489E+01_JPRB, 0.159564E+01_JPRB &
  &, 0.159584E+01_JPRB, 0.159550E+01_JPRB, 0.159463E+01_JPRB &
  &, 0.159320E+01_JPRB, 0.159126E+01_JPRB, 0.158877E+01_JPRB, 0.158577E+01_JPRB &
  &, 0.158225E+01_JPRB, 0.157820E+01_JPRB, 0.157365E+01_JPRB &
  &, 0.156861E+01_JPRB, 0.156307E+01_JPRB, 0.155703E+01_JPRB, 0.155051E+01_JPRB &
  &, 0.154351E+01_JPRB, 0.153606E+01_JPRB, 0.152813E+01_JPRB &
  &, 0.151977E+01_JPRB, 0.151097E+01_JPRB, 0.150173E+01_JPRB, 0.149208E+01_JPRB &
  &, 0.148201E+01_JPRB, 0.147155E+01_JPRB, 0.146069E+01_JPRB &
  &, 0.144944E+01_JPRB, 0.143784E+01_JPRB, 0.142586E+01_JPRB, 0.141357E+01_JPRB &
  &, 0.140092E+01_JPRB, 0.138795E+01_JPRB, 0.137466E+01_JPRB &
  &, 0.136107E+01_JPRB, 0.134720E+01_JPRB, 0.133307E+01_JPRB, 0.131864E+01_JPRB &
  &, 0.130399E+01_JPRB, 0.128910E+01_JPRB, 0.127396E+01_JPRB &
  &, 0.125860E+01_JPRB, 0.124305E+01_JPRB, 0.122731E+01_JPRB, 0.121140E+01_JPRB &
  &, 0.119532E+01_JPRB, 0.117908E+01_JPRB, 0.116268E+01_JPRB &
  &, 0.114619E+01_JPRB, 0.112956E+01_JPRB, 0.111281E+01_JPRB, 0.109599E+01_JPRB &
  &, 0.107907E+01_JPRB, 0.106209E+01_JPRB, 0.104504E+01_JPRB &
  &, 0.102792E+01_JPRB, 0.101080E+01_JPRB, 0.993640E+00_JPRB, 0.976465E+00_JPRB &
  &, 0.959312E+00_JPRB, 0.942136E+00_JPRB, 0.924968E+00_JPRB &
  &, 0.907838E+00_JPRB, 0.890739E+00_JPRB, 0.873702E+00_JPRB, 0.856715E+00_JPRB &
  &, 0.839768E+00_JPRB, 0.822933E+00_JPRB, 0.806154E+00_JPRB &
  &, 0.789459E+00_JPRB, 0.772880E+00_JPRB, 0.756445E+00_JPRB, 0.739904E+00_JPRB &
  &, 0.723849E+00_JPRB, 0.707743E+00_JPRB, 0.691755E+00_JPRB &
  &, 0.675962E+00_JPRB, 0.660241E+00_JPRB, 0.644720E+00_JPRB, 0.629375E+00_JPRB &
  &, 0.614182E+00_JPRB, 0.599165E+00_JPRB, 0.584352E+00_JPRB &
  &, 0.569713E+00_JPRB, 0.555218E+00_JPRB, 0.540946E+00_JPRB, 0.526866E+00_JPRB &
  &, 0.513003E+00_JPRB, 0.499321E+00_JPRB, 0.485844E+00_JPRB &
  &, 0.472593E+00_JPRB, 0.459532E+00_JPRB, 0.446744E+00_JPRB, 0.434126E+00_JPRB &
  &, 0.421699E+00_JPRB, 0.409547E+00_JPRB, 0.397562E+00_JPRB/)
XCW( 793, :) = (/ &
  &  0.108036E+01_JPRB, 0.110000E+01_JPRB, 0.111944E+01_JPRB, 0.113866E+01_JPRB &
  &, 0.115765E+01_JPRB, 0.117639E+01_JPRB, 0.119488E+01_JPRB &
  &, 0.121310E+01_JPRB, 0.123104E+01_JPRB, 0.124869E+01_JPRB, 0.126603E+01_JPRB &
  &, 0.128305E+01_JPRB, 0.129974E+01_JPRB, 0.131609E+01_JPRB &
  &, 0.133209E+01_JPRB, 0.134772E+01_JPRB, 0.136298E+01_JPRB, 0.137785E+01_JPRB &
  &, 0.139232E+01_JPRB, 0.140638E+01_JPRB, 0.142003E+01_JPRB &
  &, 0.143324E+01_JPRB, 0.144601E+01_JPRB, 0.145834E+01_JPRB, 0.147021E+01_JPRB &
  &, 0.148160E+01_JPRB, 0.149253E+01_JPRB, 0.150297E+01_JPRB &
  &, 0.151291E+01_JPRB, 0.152237E+01_JPRB, 0.153131E+01_JPRB, 0.153974E+01_JPRB &
  &, 0.154765E+01_JPRB, 0.155505E+01_JPRB, 0.156191E+01_JPRB &
  &, 0.156824E+01_JPRB, 0.157403E+01_JPRB, 0.157929E+01_JPRB, 0.158400E+01_JPRB &
  &, 0.158817E+01_JPRB, 0.159179E+01_JPRB, 0.159486E+01_JPRB &
  &, 0.159738E+01_JPRB, 0.159936E+01_JPRB, 0.160079E+01_JPRB, 0.160166E+01_JPRB &
  &, 0.160200E+01_JPRB, 0.160180E+01_JPRB, 0.160104E+01_JPRB &
  &, 0.159976E+01_JPRB, 0.159794E+01_JPRB, 0.159558E+01_JPRB, 0.159269E+01_JPRB &
  &, 0.158929E+01_JPRB, 0.158538E+01_JPRB, 0.158094E+01_JPRB &
  &, 0.157601E+01_JPRB, 0.157057E+01_JPRB, 0.156466E+01_JPRB, 0.155824E+01_JPRB &
  &, 0.155136E+01_JPRB, 0.154401E+01_JPRB, 0.153619E+01_JPRB &
  &, 0.152792E+01_JPRB, 0.151923E+01_JPRB, 0.151009E+01_JPRB, 0.150053E+01_JPRB &
  &, 0.149054E+01_JPRB, 0.148016E+01_JPRB, 0.146938E+01_JPRB &
  &, 0.145823E+01_JPRB, 0.144671E+01_JPRB, 0.143481E+01_JPRB, 0.142259E+01_JPRB &
  &, 0.141001E+01_JPRB, 0.139711E+01_JPRB, 0.138389E+01_JPRB &
  &, 0.137037E+01_JPRB, 0.135656E+01_JPRB, 0.134246E+01_JPRB, 0.132808E+01_JPRB &
  &, 0.131349E+01_JPRB, 0.129861E+01_JPRB, 0.128353E+01_JPRB &
  &, 0.126823E+01_JPRB, 0.125270E+01_JPRB, 0.123699E+01_JPRB, 0.122109E+01_JPRB &
  &, 0.120504E+01_JPRB, 0.118880E+01_JPRB, 0.117245E+01_JPRB &
  &, 0.115594E+01_JPRB, 0.113933E+01_JPRB, 0.112258E+01_JPRB, 0.110577E+01_JPRB &
  &, 0.108882E+01_JPRB, 0.107184E+01_JPRB, 0.105478E+01_JPRB &
  &, 0.103769E+01_JPRB, 0.102052E+01_JPRB, 0.100333E+01_JPRB, 0.986135E+00_JPRB &
  &, 0.968952E+00_JPRB, 0.951742E+00_JPRB, 0.934534E+00_JPRB &
  &, 0.917400E+00_JPRB, 0.900252E+00_JPRB, 0.883161E+00_JPRB, 0.866115E+00_JPRB &
  &, 0.849146E+00_JPRB, 0.832242E+00_JPRB, 0.815387E+00_JPRB &
  &, 0.798658E+00_JPRB, 0.782038E+00_JPRB, 0.765466E+00_JPRB, 0.749063E+00_JPRB &
  &, 0.732765E+00_JPRB, 0.716552E+00_JPRB, 0.700500E+00_JPRB &
  &, 0.684587E+00_JPRB, 0.668842E+00_JPRB, 0.653241E+00_JPRB, 0.637813E+00_JPRB &
  &, 0.622530E+00_JPRB, 0.607419E+00_JPRB, 0.592506E+00_JPRB &
  &, 0.577762E+00_JPRB, 0.563157E+00_JPRB, 0.548827E+00_JPRB, 0.534627E+00_JPRB &
  &, 0.520638E+00_JPRB, 0.506884E+00_JPRB, 0.493270E+00_JPRB &
  &, 0.479939E+00_JPRB, 0.466792E+00_JPRB, 0.453852E+00_JPRB, 0.441076E+00_JPRB &
  &, 0.428613E+00_JPRB, 0.416293E+00_JPRB, 0.404199E+00_JPRB/)
XCW( 794, :) = (/ &
  &  0.108073E+01_JPRB, 0.110047E+01_JPRB, 0.112001E+01_JPRB, 0.113933E+01_JPRB &
  &, 0.115842E+01_JPRB, 0.117727E+01_JPRB, 0.119587E+01_JPRB &
  &, 0.121420E+01_JPRB, 0.123225E+01_JPRB, 0.125001E+01_JPRB, 0.126747E+01_JPRB &
  &, 0.128461E+01_JPRB, 0.130142E+01_JPRB, 0.131789E+01_JPRB &
  &, 0.133401E+01_JPRB, 0.134976E+01_JPRB, 0.136514E+01_JPRB, 0.138014E+01_JPRB &
  &, 0.139474E+01_JPRB, 0.140893E+01_JPRB, 0.142270E+01_JPRB &
  &, 0.143604E+01_JPRB, 0.144895E+01_JPRB, 0.146141E+01_JPRB, 0.147341E+01_JPRB &
  &, 0.148494E+01_JPRB, 0.149600E+01_JPRB, 0.150657E+01_JPRB &
  &, 0.151666E+01_JPRB, 0.152624E+01_JPRB, 0.153533E+01_JPRB, 0.154390E+01_JPRB &
  &, 0.155195E+01_JPRB, 0.155947E+01_JPRB, 0.156648E+01_JPRB &
  &, 0.157294E+01_JPRB, 0.157887E+01_JPRB, 0.158426E+01_JPRB, 0.158911E+01_JPRB &
  &, 0.159342E+01_JPRB, 0.159717E+01_JPRB, 0.160038E+01_JPRB &
  &, 0.160305E+01_JPRB, 0.160515E+01_JPRB, 0.160672E+01_JPRB, 0.160773E+01_JPRB &
  &, 0.160819E+01_JPRB, 0.160812E+01_JPRB, 0.160750E+01_JPRB &
  &, 0.160634E+01_JPRB, 0.160464E+01_JPRB, 0.160242E+01_JPRB, 0.159966E+01_JPRB &
  &, 0.159638E+01_JPRB, 0.159258E+01_JPRB, 0.158827E+01_JPRB &
  &, 0.158345E+01_JPRB, 0.157813E+01_JPRB, 0.157233E+01_JPRB, 0.156603E+01_JPRB &
  &, 0.155925E+01_JPRB, 0.155200E+01_JPRB, 0.154430E+01_JPRB &
  &, 0.153614E+01_JPRB, 0.152754E+01_JPRB, 0.151849E+01_JPRB, 0.150901E+01_JPRB &
  &, 0.149913E+01_JPRB, 0.148884E+01_JPRB, 0.147816E+01_JPRB &
  &, 0.146709E+01_JPRB, 0.145563E+01_JPRB, 0.144382E+01_JPRB, 0.143168E+01_JPRB &
  &, 0.141915E+01_JPRB, 0.140632E+01_JPRB, 0.139318E+01_JPRB &
  &, 0.137971E+01_JPRB, 0.136596E+01_JPRB, 0.135192E+01_JPRB, 0.133760E+01_JPRB &
  &, 0.132306E+01_JPRB, 0.130824E+01_JPRB, 0.129317E+01_JPRB &
  &, 0.127792E+01_JPRB, 0.126243E+01_JPRB, 0.124674E+01_JPRB, 0.123089E+01_JPRB &
  &, 0.121485E+01_JPRB, 0.119863E+01_JPRB, 0.118228E+01_JPRB &
  &, 0.116579E+01_JPRB, 0.114919E+01_JPRB, 0.113246E+01_JPRB, 0.111562E+01_JPRB &
  &, 0.109871E+01_JPRB, 0.108169E+01_JPRB, 0.106463E+01_JPRB &
  &, 0.104753E+01_JPRB, 0.103034E+01_JPRB, 0.101314E+01_JPRB, 0.995917E+00_JPRB &
  &, 0.978707E+00_JPRB, 0.961464E+00_JPRB, 0.944219E+00_JPRB &
  &, 0.927043E+00_JPRB, 0.909847E+00_JPRB, 0.892703E+00_JPRB, 0.875642E+00_JPRB &
  &, 0.858610E+00_JPRB, 0.841638E+00_JPRB, 0.824754E+00_JPRB &
  &, 0.807946E+00_JPRB, 0.791242E+00_JPRB, 0.774627E+00_JPRB, 0.758129E+00_JPRB &
  &, 0.741778E+00_JPRB, 0.725507E+00_JPRB, 0.709392E+00_JPRB &
  &, 0.693411E+00_JPRB, 0.677544E+00_JPRB, 0.661866E+00_JPRB, 0.646354E+00_JPRB &
  &, 0.630984E+00_JPRB, 0.615780E+00_JPRB, 0.600769E+00_JPRB &
  &, 0.585922E+00_JPRB, 0.571264E+00_JPRB, 0.556764E+00_JPRB, 0.542502E+00_JPRB &
  &, 0.528389E+00_JPRB, 0.514506E+00_JPRB, 0.500816E+00_JPRB &
  &, 0.487344E+00_JPRB, 0.474113E+00_JPRB, 0.461022E+00_JPRB, 0.448215E+00_JPRB &
  &, 0.435591E+00_JPRB, 0.423168E+00_JPRB, 0.410967E+00_JPRB/)
XCW( 795, :) = (/ &
  &  0.108110E+01_JPRB, 0.110094E+01_JPRB, 0.112058E+01_JPRB, 0.114000E+01_JPRB &
  &, 0.115920E+01_JPRB, 0.117816E+01_JPRB, 0.119686E+01_JPRB &
  &, 0.121530E+01_JPRB, 0.123347E+01_JPRB, 0.125134E+01_JPRB, 0.126891E+01_JPRB &
  &, 0.128617E+01_JPRB, 0.130310E+01_JPRB, 0.131969E+01_JPRB &
  &, 0.133593E+01_JPRB, 0.135181E+01_JPRB, 0.136732E+01_JPRB, 0.138244E+01_JPRB &
  &, 0.139717E+01_JPRB, 0.141148E+01_JPRB, 0.142539E+01_JPRB &
  &, 0.143886E+01_JPRB, 0.145190E+01_JPRB, 0.146449E+01_JPRB, 0.147662E+01_JPRB &
  &, 0.148829E+01_JPRB, 0.149949E+01_JPRB, 0.151020E+01_JPRB &
  &, 0.152042E+01_JPRB, 0.153014E+01_JPRB, 0.153936E+01_JPRB, 0.154806E+01_JPRB &
  &, 0.155626E+01_JPRB, 0.156392E+01_JPRB, 0.157107E+01_JPRB &
  &, 0.157767E+01_JPRB, 0.158374E+01_JPRB, 0.158927E+01_JPRB, 0.159425E+01_JPRB &
  &, 0.159869E+01_JPRB, 0.160259E+01_JPRB, 0.160594E+01_JPRB &
  &, 0.160873E+01_JPRB, 0.161099E+01_JPRB, 0.161268E+01_JPRB, 0.161383E+01_JPRB &
  &, 0.161443E+01_JPRB, 0.161448E+01_JPRB, 0.161399E+01_JPRB &
  &, 0.161296E+01_JPRB, 0.161140E+01_JPRB, 0.160927E+01_JPRB, 0.160666E+01_JPRB &
  &, 0.160351E+01_JPRB, 0.159983E+01_JPRB, 0.159564E+01_JPRB &
  &, 0.159094E+01_JPRB, 0.158574E+01_JPRB, 0.158004E+01_JPRB, 0.157386E+01_JPRB &
  &, 0.156720E+01_JPRB, 0.156005E+01_JPRB, 0.155245E+01_JPRB &
  &, 0.154440E+01_JPRB, 0.153588E+01_JPRB, 0.152694E+01_JPRB, 0.151757E+01_JPRB &
  &, 0.150778E+01_JPRB, 0.149759E+01_JPRB, 0.148698E+01_JPRB &
  &, 0.147599E+01_JPRB, 0.146463E+01_JPRB, 0.145290E+01_JPRB, 0.144081E+01_JPRB &
  &, 0.142838E+01_JPRB, 0.141562E+01_JPRB, 0.140253E+01_JPRB &
  &, 0.138914E+01_JPRB, 0.137543E+01_JPRB, 0.136146E+01_JPRB, 0.134720E+01_JPRB &
  &, 0.133268E+01_JPRB, 0.131792E+01_JPRB, 0.130290E+01_JPRB &
  &, 0.128767E+01_JPRB, 0.127222E+01_JPRB, 0.125659E+01_JPRB, 0.124076E+01_JPRB &
  &, 0.122472E+01_JPRB, 0.120856E+01_JPRB, 0.119220E+01_JPRB &
  &, 0.117573E+01_JPRB, 0.115912E+01_JPRB, 0.114240E+01_JPRB, 0.112557E+01_JPRB &
  &, 0.110867E+01_JPRB, 0.109165E+01_JPRB, 0.107459E+01_JPRB &
  &, 0.105744E+01_JPRB, 0.104028E+01_JPRB, 0.102306E+01_JPRB, 0.100581E+01_JPRB &
  &, 0.988538E+00_JPRB, 0.971264E+00_JPRB, 0.954022E+00_JPRB &
  &, 0.936765E+00_JPRB, 0.919564E+00_JPRB, 0.902370E+00_JPRB, 0.885252E+00_JPRB &
  &, 0.868160E+00_JPRB, 0.851164E+00_JPRB, 0.834209E+00_JPRB &
  &, 0.817324E+00_JPRB, 0.800583E+00_JPRB, 0.783880E+00_JPRB, 0.767335E+00_JPRB &
  &, 0.750885E+00_JPRB, 0.734558E+00_JPRB, 0.718332E+00_JPRB &
  &, 0.702286E+00_JPRB, 0.686347E+00_JPRB, 0.670592E+00_JPRB, 0.654948E+00_JPRB &
  &, 0.639490E+00_JPRB, 0.624248E+00_JPRB, 0.609086E+00_JPRB &
  &, 0.594137E+00_JPRB, 0.579427E+00_JPRB, 0.564815E+00_JPRB, 0.550436E+00_JPRB &
  &, 0.536257E+00_JPRB, 0.522305E+00_JPRB, 0.508482E+00_JPRB &
  &, 0.494933E+00_JPRB, 0.481558E+00_JPRB, 0.468379E+00_JPRB, 0.455418E+00_JPRB &
  &, 0.442697E+00_JPRB, 0.430173E+00_JPRB, 0.417867E+00_JPRB/)
XCW( 796, :) = (/ &
  &  0.108147E+01_JPRB, 0.110141E+01_JPRB, 0.112115E+01_JPRB, 0.114067E+01_JPRB &
  &, 0.115998E+01_JPRB, 0.117904E+01_JPRB, 0.119786E+01_JPRB &
  &, 0.121641E+01_JPRB, 0.123468E+01_JPRB, 0.125267E+01_JPRB, 0.127036E+01_JPRB &
  &, 0.128773E+01_JPRB, 0.130478E+01_JPRB, 0.132150E+01_JPRB &
  &, 0.133786E+01_JPRB, 0.135387E+01_JPRB, 0.136950E+01_JPRB, 0.138475E+01_JPRB &
  &, 0.139960E+01_JPRB, 0.141405E+01_JPRB, 0.142809E+01_JPRB &
  &, 0.144169E+01_JPRB, 0.145486E+01_JPRB, 0.146759E+01_JPRB, 0.147986E+01_JPRB &
  &, 0.149166E+01_JPRB, 0.150299E+01_JPRB, 0.151384E+01_JPRB &
  &, 0.152420E+01_JPRB, 0.153406E+01_JPRB, 0.154342E+01_JPRB, 0.155226E+01_JPRB &
  &, 0.156059E+01_JPRB, 0.156840E+01_JPRB, 0.157568E+01_JPRB &
  &, 0.158242E+01_JPRB, 0.158863E+01_JPRB, 0.159430E+01_JPRB, 0.159943E+01_JPRB &
  &, 0.160401E+01_JPRB, 0.160804E+01_JPRB, 0.161152E+01_JPRB &
  &, 0.161446E+01_JPRB, 0.161683E+01_JPRB, 0.161867E+01_JPRB, 0.161996E+01_JPRB &
  &, 0.162068E+01_JPRB, 0.162087E+01_JPRB, 0.162051E+01_JPRB &
  &, 0.161961E+01_JPRB, 0.161818E+01_JPRB, 0.161620E+01_JPRB, 0.161371E+01_JPRB &
  &, 0.161066E+01_JPRB, 0.160711E+01_JPRB, 0.160305E+01_JPRB &
  &, 0.159847E+01_JPRB, 0.159339E+01_JPRB, 0.158781E+01_JPRB, 0.158173E+01_JPRB &
  &, 0.157517E+01_JPRB, 0.156816E+01_JPRB, 0.156067E+01_JPRB &
  &, 0.155271E+01_JPRB, 0.154430E+01_JPRB, 0.153545E+01_JPRB, 0.152619E+01_JPRB &
  &, 0.151649E+01_JPRB, 0.150638E+01_JPRB, 0.149588E+01_JPRB &
  &, 0.148497E+01_JPRB, 0.147369E+01_JPRB, 0.146205E+01_JPRB, 0.145003E+01_JPRB &
  &, 0.143768E+01_JPRB, 0.142499E+01_JPRB, 0.141197E+01_JPRB &
  &, 0.139863E+01_JPRB, 0.138498E+01_JPRB, 0.137107E+01_JPRB, 0.135687E+01_JPRB &
  &, 0.134242E+01_JPRB, 0.132768E+01_JPRB, 0.131271E+01_JPRB &
  &, 0.129753E+01_JPRB, 0.128212E+01_JPRB, 0.126651E+01_JPRB, 0.125068E+01_JPRB &
  &, 0.123470E+01_JPRB, 0.121855E+01_JPRB, 0.120221E+01_JPRB &
  &, 0.118577E+01_JPRB, 0.116918E+01_JPRB, 0.115244E+01_JPRB, 0.113562E+01_JPRB &
  &, 0.111869E+01_JPRB, 0.110171E+01_JPRB, 0.108461E+01_JPRB &
  &, 0.106746E+01_JPRB, 0.105028E+01_JPRB, 0.103305E+01_JPRB, 0.101578E+01_JPRB &
  &, 0.998484E+00_JPRB, 0.981181E+00_JPRB, 0.963904E+00_JPRB &
  &, 0.946608E+00_JPRB, 0.929363E+00_JPRB, 0.912119E+00_JPRB, 0.894947E+00_JPRB &
  &, 0.877838E+00_JPRB, 0.860777E+00_JPRB, 0.843752E+00_JPRB &
  &, 0.826836E+00_JPRB, 0.810015E+00_JPRB, 0.793272E+00_JPRB, 0.776636E+00_JPRB &
  &, 0.760088E+00_JPRB, 0.743706E+00_JPRB, 0.727421E+00_JPRB &
  &, 0.711310E+00_JPRB, 0.695302E+00_JPRB, 0.679422E+00_JPRB, 0.663698E+00_JPRB &
  &, 0.648156E+00_JPRB, 0.632770E+00_JPRB, 0.617567E+00_JPRB &
  &, 0.602517E+00_JPRB, 0.587702E+00_JPRB, 0.573036E+00_JPRB, 0.558541E+00_JPRB &
  &, 0.544242E+00_JPRB, 0.530163E+00_JPRB, 0.516268E+00_JPRB &
  &, 0.502581E+00_JPRB, 0.489064E+00_JPRB, 0.475799E+00_JPRB, 0.462747E+00_JPRB &
  &, 0.449931E+00_JPRB, 0.437243E+00_JPRB, 0.424833E+00_JPRB/)
XCW( 797, :) = (/ &
  &  0.108184E+01_JPRB, 0.110188E+01_JPRB, 0.112172E+01_JPRB, 0.114135E+01_JPRB &
  &, 0.116076E+01_JPRB, 0.117993E+01_JPRB, 0.119885E+01_JPRB &
  &, 0.121752E+01_JPRB, 0.123591E+01_JPRB, 0.125401E+01_JPRB, 0.127181E+01_JPRB &
  &, 0.128931E+01_JPRB, 0.130648E+01_JPRB, 0.132332E+01_JPRB &
  &, 0.133980E+01_JPRB, 0.135593E+01_JPRB, 0.137169E+01_JPRB, 0.138707E+01_JPRB &
  &, 0.140205E+01_JPRB, 0.141663E+01_JPRB, 0.143080E+01_JPRB &
  &, 0.144454E+01_JPRB, 0.145784E+01_JPRB, 0.147070E+01_JPRB, 0.148310E+01_JPRB &
  &, 0.149504E+01_JPRB, 0.150651E+01_JPRB, 0.151750E+01_JPRB &
  &, 0.152799E+01_JPRB, 0.153799E+01_JPRB, 0.154748E+01_JPRB, 0.155647E+01_JPRB &
  &, 0.156494E+01_JPRB, 0.157289E+01_JPRB, 0.158031E+01_JPRB &
  &, 0.158719E+01_JPRB, 0.159354E+01_JPRB, 0.159935E+01_JPRB, 0.160462E+01_JPRB &
  &, 0.160934E+01_JPRB, 0.161351E+01_JPRB, 0.161713E+01_JPRB &
  &, 0.162020E+01_JPRB, 0.162272E+01_JPRB, 0.162470E+01_JPRB, 0.162611E+01_JPRB &
  &, 0.162699E+01_JPRB, 0.162730E+01_JPRB, 0.162708E+01_JPRB &
  &, 0.162631E+01_JPRB, 0.162500E+01_JPRB, 0.162316E+01_JPRB, 0.162078E+01_JPRB &
  &, 0.161787E+01_JPRB, 0.161445E+01_JPRB, 0.161050E+01_JPRB &
  &, 0.160605E+01_JPRB, 0.160108E+01_JPRB, 0.159561E+01_JPRB, 0.158966E+01_JPRB &
  &, 0.158322E+01_JPRB, 0.157630E+01_JPRB, 0.156892E+01_JPRB &
  &, 0.156107E+01_JPRB, 0.155278E+01_JPRB, 0.154389E+01_JPRB, 0.153485E+01_JPRB &
  &, 0.152526E+01_JPRB, 0.151524E+01_JPRB, 0.150482E+01_JPRB &
  &, 0.149402E+01_JPRB, 0.148280E+01_JPRB, 0.147123E+01_JPRB, 0.145932E+01_JPRB &
  &, 0.144702E+01_JPRB, 0.143441E+01_JPRB, 0.142146E+01_JPRB &
  &, 0.140819E+01_JPRB, 0.139461E+01_JPRB, 0.138076E+01_JPRB, 0.136660E+01_JPRB &
  &, 0.135220E+01_JPRB, 0.133752E+01_JPRB, 0.132260E+01_JPRB &
  &, 0.130744E+01_JPRB, 0.129208E+01_JPRB, 0.127651E+01_JPRB, 0.126072E+01_JPRB &
  &, 0.124475E+01_JPRB, 0.122863E+01_JPRB, 0.121232E+01_JPRB &
  &, 0.119587E+01_JPRB, 0.117930E+01_JPRB, 0.116258E+01_JPRB, 0.114577E+01_JPRB &
  &, 0.112885E+01_JPRB, 0.111184E+01_JPRB, 0.109474E+01_JPRB &
  &, 0.107758E+01_JPRB, 0.106040E+01_JPRB, 0.104311E+01_JPRB, 0.102583E+01_JPRB &
  &, 0.100855E+01_JPRB, 0.991214E+00_JPRB, 0.973866E+00_JPRB &
  &, 0.956572E+00_JPRB, 0.939285E+00_JPRB, 0.921993E+00_JPRB, 0.904769E+00_JPRB &
  &, 0.887601E+00_JPRB, 0.870478E+00_JPRB, 0.853428E+00_JPRB &
  &, 0.836439E+00_JPRB, 0.819538E+00_JPRB, 0.802756E+00_JPRB, 0.786030E+00_JPRB &
  &, 0.769434E+00_JPRB, 0.752951E+00_JPRB, 0.736607E+00_JPRB &
  &, 0.720384E+00_JPRB, 0.704307E+00_JPRB, 0.688354E+00_JPRB, 0.672604E+00_JPRB &
  &, 0.656926E+00_JPRB, 0.641453E+00_JPRB, 0.626156E+00_JPRB &
  &, 0.611008E+00_JPRB, 0.596089E+00_JPRB, 0.581313E+00_JPRB, 0.566704E+00_JPRB &
  &, 0.552343E+00_JPRB, 0.538139E+00_JPRB, 0.524114E+00_JPRB &
  &, 0.510351E+00_JPRB, 0.496754E+00_JPRB, 0.483343E+00_JPRB, 0.470202E+00_JPRB &
  &, 0.457229E+00_JPRB, 0.444508E+00_JPRB, 0.431995E+00_JPRB/)
XCW( 798, :) = (/ &
  &  0.108222E+01_JPRB, 0.110235E+01_JPRB, 0.112229E+01_JPRB, 0.114203E+01_JPRB &
  &, 0.116154E+01_JPRB, 0.118082E+01_JPRB, 0.119986E+01_JPRB &
  &, 0.121863E+01_JPRB, 0.123713E+01_JPRB, 0.125535E+01_JPRB, 0.127328E+01_JPRB &
  &, 0.129089E+01_JPRB, 0.130818E+01_JPRB, 0.132514E+01_JPRB &
  &, 0.134175E+01_JPRB, 0.135800E+01_JPRB, 0.137389E+01_JPRB, 0.138940E+01_JPRB &
  &, 0.140451E+01_JPRB, 0.141922E+01_JPRB, 0.143352E+01_JPRB &
  &, 0.144739E+01_JPRB, 0.146083E+01_JPRB, 0.147382E+01_JPRB, 0.148636E+01_JPRB &
  &, 0.149844E+01_JPRB, 0.151005E+01_JPRB, 0.152117E+01_JPRB &
  &, 0.153181E+01_JPRB, 0.154195E+01_JPRB, 0.155158E+01_JPRB, 0.156071E+01_JPRB &
  &, 0.156932E+01_JPRB, 0.157741E+01_JPRB, 0.158497E+01_JPRB &
  &, 0.159199E+01_JPRB, 0.159848E+01_JPRB, 0.160444E+01_JPRB, 0.160984E+01_JPRB &
  &, 0.161470E+01_JPRB, 0.161901E+01_JPRB, 0.162278E+01_JPRB &
  &, 0.162598E+01_JPRB, 0.162865E+01_JPRB, 0.163075E+01_JPRB, 0.163231E+01_JPRB &
  &, 0.163332E+01_JPRB, 0.163376E+01_JPRB, 0.163367E+01_JPRB &
  &, 0.163304E+01_JPRB, 0.163187E+01_JPRB, 0.163015E+01_JPRB, 0.162791E+01_JPRB &
  &, 0.162513E+01_JPRB, 0.162182E+01_JPRB, 0.161801E+01_JPRB &
  &, 0.161367E+01_JPRB, 0.160882E+01_JPRB, 0.160348E+01_JPRB, 0.159764E+01_JPRB &
  &, 0.159132E+01_JPRB, 0.158451E+01_JPRB, 0.157723E+01_JPRB &
  &, 0.156949E+01_JPRB, 0.156129E+01_JPRB, 0.155267E+01_JPRB, 0.154359E+01_JPRB &
  &, 0.153409E+01_JPRB, 0.152416E+01_JPRB, 0.151382E+01_JPRB &
  &, 0.150311E+01_JPRB, 0.149200E+01_JPRB, 0.148051E+01_JPRB, 0.146865E+01_JPRB &
  &, 0.145646E+01_JPRB, 0.144389E+01_JPRB, 0.143102E+01_JPRB &
  &, 0.141782E+01_JPRB, 0.140431E+01_JPRB, 0.139050E+01_JPRB, 0.137643E+01_JPRB &
  &, 0.136206E+01_JPRB, 0.134743E+01_JPRB, 0.133258E+01_JPRB &
  &, 0.131746E+01_JPRB, 0.130213E+01_JPRB, 0.128657E+01_JPRB, 0.127082E+01_JPRB &
  &, 0.125489E+01_JPRB, 0.123880E+01_JPRB, 0.122252E+01_JPRB &
  &, 0.120610E+01_JPRB, 0.118952E+01_JPRB, 0.117281E+01_JPRB, 0.115599E+01_JPRB &
  &, 0.113908E+01_JPRB, 0.112207E+01_JPRB, 0.110497E+01_JPRB &
  &, 0.108781E+01_JPRB, 0.107058E+01_JPRB, 0.105332E+01_JPRB, 0.103603E+01_JPRB &
  &, 0.101868E+01_JPRB, 0.100133E+01_JPRB, 0.983986E+00_JPRB &
  &, 0.966616E+00_JPRB, 0.949288E+00_JPRB, 0.931992E+00_JPRB, 0.914717E+00_JPRB &
  &, 0.897493E+00_JPRB, 0.880309E+00_JPRB, 0.863192E+00_JPRB &
  &, 0.846176E+00_JPRB, 0.829198E+00_JPRB, 0.812333E+00_JPRB, 0.795565E+00_JPRB &
  &, 0.778923E+00_JPRB, 0.762341E+00_JPRB, 0.745941E+00_JPRB &
  &, 0.729607E+00_JPRB, 0.713464E+00_JPRB, 0.697440E+00_JPRB, 0.681562E+00_JPRB &
  &, 0.665750E+00_JPRB, 0.650243E+00_JPRB, 0.634854E+00_JPRB &
  &, 0.619664E+00_JPRB, 0.604588E+00_JPRB, 0.589704E+00_JPRB, 0.575039E+00_JPRB &
  &, 0.560561E+00_JPRB, 0.546233E+00_JPRB, 0.532139E+00_JPRB &
  &, 0.518243E+00_JPRB, 0.504506E+00_JPRB, 0.491012E+00_JPRB, 0.477721E+00_JPRB &
  &, 0.464655E+00_JPRB, 0.451837E+00_JPRB, 0.439157E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART114',1,ZHOOK_HANDLE)
END SUBROUTINE PART114

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART115

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART115',0,ZHOOK_HANDLE)

XCW( 799, :) = (/ &
  &  0.108259E+01_JPRB, 0.110283E+01_JPRB, 0.112287E+01_JPRB, 0.114271E+01_JPRB &
  &, 0.116233E+01_JPRB, 0.118172E+01_JPRB, 0.120086E+01_JPRB &
  &, 0.121975E+01_JPRB, 0.123837E+01_JPRB, 0.125670E+01_JPRB, 0.127474E+01_JPRB &
  &, 0.129247E+01_JPRB, 0.130989E+01_JPRB, 0.132697E+01_JPRB &
  &, 0.134370E+01_JPRB, 0.136009E+01_JPRB, 0.137610E+01_JPRB, 0.139173E+01_JPRB &
  &, 0.140698E+01_JPRB, 0.142182E+01_JPRB, 0.143625E+01_JPRB &
  &, 0.145025E+01_JPRB, 0.146383E+01_JPRB, 0.147696E+01_JPRB, 0.148964E+01_JPRB &
  &, 0.150185E+01_JPRB, 0.151360E+01_JPRB, 0.152486E+01_JPRB &
  &, 0.153564E+01_JPRB, 0.154592E+01_JPRB, 0.155569E+01_JPRB, 0.156496E+01_JPRB &
  &, 0.157371E+01_JPRB, 0.158194E+01_JPRB, 0.158965E+01_JPRB &
  &, 0.159681E+01_JPRB, 0.160344E+01_JPRB, 0.160954E+01_JPRB, 0.161509E+01_JPRB &
  &, 0.162008E+01_JPRB, 0.162454E+01_JPRB, 0.162844E+01_JPRB &
  &, 0.163180E+01_JPRB, 0.163460E+01_JPRB, 0.163684E+01_JPRB, 0.163853E+01_JPRB &
  &, 0.163967E+01_JPRB, 0.164027E+01_JPRB, 0.164032E+01_JPRB &
  &, 0.163981E+01_JPRB, 0.163877E+01_JPRB, 0.163718E+01_JPRB, 0.163506E+01_JPRB &
  &, 0.163242E+01_JPRB, 0.162924E+01_JPRB, 0.162555E+01_JPRB &
  &, 0.162133E+01_JPRB, 0.161662E+01_JPRB, 0.161138E+01_JPRB, 0.160566E+01_JPRB &
  &, 0.159945E+01_JPRB, 0.159276E+01_JPRB, 0.158560E+01_JPRB &
  &, 0.157797E+01_JPRB, 0.156988E+01_JPRB, 0.156135E+01_JPRB, 0.155236E+01_JPRB &
  &, 0.154297E+01_JPRB, 0.153313E+01_JPRB, 0.152291E+01_JPRB &
  &, 0.151228E+01_JPRB, 0.150125E+01_JPRB, 0.148985E+01_JPRB, 0.147808E+01_JPRB &
  &, 0.146594E+01_JPRB, 0.145348E+01_JPRB, 0.144063E+01_JPRB &
  &, 0.142755E+01_JPRB, 0.141408E+01_JPRB, 0.140035E+01_JPRB, 0.138631E+01_JPRB &
  &, 0.137200E+01_JPRB, 0.135743E+01_JPRB, 0.134261E+01_JPRB &
  &, 0.132755E+01_JPRB, 0.131226E+01_JPRB, 0.129675E+01_JPRB, 0.128104E+01_JPRB &
  &, 0.126512E+01_JPRB, 0.124903E+01_JPRB, 0.123279E+01_JPRB &
  &, 0.121639E+01_JPRB, 0.119983E+01_JPRB, 0.118315E+01_JPRB, 0.116634E+01_JPRB &
  &, 0.114941E+01_JPRB, 0.113241E+01_JPRB, 0.111531E+01_JPRB &
  &, 0.109811E+01_JPRB, 0.108088E+01_JPRB, 0.106361E+01_JPRB, 0.104630E+01_JPRB &
  &, 0.102893E+01_JPRB, 0.101155E+01_JPRB, 0.994145E+00_JPRB &
  &, 0.976781E+00_JPRB, 0.959414E+00_JPRB, 0.942074E+00_JPRB, 0.924749E+00_JPRB &
  &, 0.907471E+00_JPRB, 0.890226E+00_JPRB, 0.873089E+00_JPRB &
  &, 0.856002E+00_JPRB, 0.838994E+00_JPRB, 0.822049E+00_JPRB, 0.805194E+00_JPRB &
  &, 0.788460E+00_JPRB, 0.771827E+00_JPRB, 0.755324E+00_JPRB &
  &, 0.738980E+00_JPRB, 0.722723E+00_JPRB, 0.706629E+00_JPRB, 0.690624E+00_JPRB &
  &, 0.674838E+00_JPRB, 0.659193E+00_JPRB, 0.643661E+00_JPRB &
  &, 0.628375E+00_JPRB, 0.613198E+00_JPRB, 0.598265E+00_JPRB, 0.583432E+00_JPRB &
  &, 0.568837E+00_JPRB, 0.554446E+00_JPRB, 0.540224E+00_JPRB &
  &, 0.526256E+00_JPRB, 0.512443E+00_JPRB, 0.498805E+00_JPRB, 0.485429E+00_JPRB &
  &, 0.472209E+00_JPRB, 0.459231E+00_JPRB, 0.446517E+00_JPRB/)
XCW( 800, :) = (/ &
  &  0.108297E+01_JPRB, 0.110330E+01_JPRB, 0.112345E+01_JPRB, 0.114339E+01_JPRB &
  &, 0.116312E+01_JPRB, 0.118261E+01_JPRB, 0.120187E+01_JPRB &
  &, 0.122087E+01_JPRB, 0.123960E+01_JPRB, 0.125805E+01_JPRB, 0.127621E+01_JPRB &
  &, 0.129406E+01_JPRB, 0.131160E+01_JPRB, 0.132880E+01_JPRB &
  &, 0.134567E+01_JPRB, 0.136217E+01_JPRB, 0.137832E+01_JPRB, 0.139408E+01_JPRB &
  &, 0.140946E+01_JPRB, 0.142443E+01_JPRB, 0.143899E+01_JPRB &
  &, 0.145314E+01_JPRB, 0.146684E+01_JPRB, 0.148011E+01_JPRB, 0.149293E+01_JPRB &
  &, 0.150528E+01_JPRB, 0.151716E+01_JPRB, 0.152857E+01_JPRB &
  &, 0.153948E+01_JPRB, 0.154991E+01_JPRB, 0.155983E+01_JPRB, 0.156923E+01_JPRB &
  &, 0.157813E+01_JPRB, 0.158650E+01_JPRB, 0.159435E+01_JPRB &
  &, 0.160166E+01_JPRB, 0.160828E+01_JPRB, 0.161465E+01_JPRB, 0.162036E+01_JPRB &
  &, 0.162550E+01_JPRB, 0.163009E+01_JPRB, 0.163414E+01_JPRB &
  &, 0.163763E+01_JPRB, 0.164058E+01_JPRB, 0.164296E+01_JPRB, 0.164479E+01_JPRB &
  &, 0.164607E+01_JPRB, 0.164681E+01_JPRB, 0.164699E+01_JPRB &
  &, 0.164662E+01_JPRB, 0.164572E+01_JPRB, 0.164427E+01_JPRB, 0.164227E+01_JPRB &
  &, 0.163975E+01_JPRB, 0.163668E+01_JPRB, 0.163313E+01_JPRB &
  &, 0.162904E+01_JPRB, 0.162445E+01_JPRB, 0.161935E+01_JPRB, 0.161374E+01_JPRB &
  &, 0.160765E+01_JPRB, 0.160107E+01_JPRB, 0.159402E+01_JPRB &
  &, 0.158650E+01_JPRB, 0.157851E+01_JPRB, 0.157009E+01_JPRB, 0.156122E+01_JPRB &
  &, 0.155192E+01_JPRB, 0.154219E+01_JPRB, 0.153203E+01_JPRB &
  &, 0.152150E+01_JPRB, 0.151056E+01_JPRB, 0.149924E+01_JPRB, 0.148739E+01_JPRB &
  &, 0.147551E+01_JPRB, 0.146310E+01_JPRB, 0.145038E+01_JPRB &
  &, 0.143732E+01_JPRB, 0.142393E+01_JPRB, 0.141026E+01_JPRB, 0.139629E+01_JPRB &
  &, 0.138202E+01_JPRB, 0.136752E+01_JPRB, 0.135274E+01_JPRB &
  &, 0.133771E+01_JPRB, 0.132247E+01_JPRB, 0.130701E+01_JPRB, 0.129132E+01_JPRB &
  &, 0.127543E+01_JPRB, 0.125939E+01_JPRB, 0.124314E+01_JPRB &
  &, 0.122677E+01_JPRB, 0.121021E+01_JPRB, 0.119355E+01_JPRB, 0.117676E+01_JPRB &
  &, 0.115984E+01_JPRB, 0.114281E+01_JPRB, 0.112572E+01_JPRB &
  &, 0.110856E+01_JPRB, 0.109129E+01_JPRB, 0.107401E+01_JPRB, 0.105664E+01_JPRB &
  &, 0.103926E+01_JPRB, 0.102186E+01_JPRB, 0.100446E+01_JPRB &
  &, 0.987026E+00_JPRB, 0.969621E+00_JPRB, 0.952238E+00_JPRB, 0.934908E+00_JPRB &
  &, 0.917577E+00_JPRB, 0.900275E+00_JPRB, 0.883074E+00_JPRB &
  &, 0.865918E+00_JPRB, 0.848836E+00_JPRB, 0.831857E+00_JPRB, 0.814964E+00_JPRB &
  &, 0.798140E+00_JPRB, 0.781459E+00_JPRB, 0.764855E+00_JPRB &
  &, 0.748403E+00_JPRB, 0.732082E+00_JPRB, 0.715921E+00_JPRB, 0.699843E+00_JPRB &
  &, 0.683926E+00_JPRB, 0.668197E+00_JPRB, 0.652631E+00_JPRB &
  &, 0.637197E+00_JPRB, 0.621976E+00_JPRB, 0.606883E+00_JPRB, 0.591998E+00_JPRB &
  &, 0.577287E+00_JPRB, 0.562776E+00_JPRB, 0.548489E+00_JPRB &
  &, 0.534330E+00_JPRB, 0.520441E+00_JPRB, 0.506724E+00_JPRB, 0.493200E+00_JPRB &
  &, 0.479892E+00_JPRB, 0.466820E+00_JPRB, 0.453943E+00_JPRB/)
XCW( 801, :) = (/ &
  &  0.108335E+01_JPRB, 0.110378E+01_JPRB, 0.112403E+01_JPRB, 0.114408E+01_JPRB &
  &, 0.116391E+01_JPRB, 0.118352E+01_JPRB, 0.120288E+01_JPRB &
  &, 0.122200E+01_JPRB, 0.124084E+01_JPRB, 0.125941E+01_JPRB, 0.127769E+01_JPRB &
  &, 0.129566E+01_JPRB, 0.131332E+01_JPRB, 0.133065E+01_JPRB &
  &, 0.134764E+01_JPRB, 0.136427E+01_JPRB, 0.138054E+01_JPRB, 0.139644E+01_JPRB &
  &, 0.141194E+01_JPRB, 0.142705E+01_JPRB, 0.144175E+01_JPRB &
  &, 0.145602E+01_JPRB, 0.146987E+01_JPRB, 0.148327E+01_JPRB, 0.149623E+01_JPRB &
  &, 0.150872E+01_JPRB, 0.152075E+01_JPRB, 0.153229E+01_JPRB &
  &, 0.154335E+01_JPRB, 0.155391E+01_JPRB, 0.156396E+01_JPRB, 0.157353E+01_JPRB &
  &, 0.158256E+01_JPRB, 0.159108E+01_JPRB, 0.159907E+01_JPRB &
  &, 0.160638E+01_JPRB, 0.161344E+01_JPRB, 0.161983E+01_JPRB, 0.162566E+01_JPRB &
  &, 0.163095E+01_JPRB, 0.163569E+01_JPRB, 0.163987E+01_JPRB &
  &, 0.164350E+01_JPRB, 0.164658E+01_JPRB, 0.164912E+01_JPRB, 0.165109E+01_JPRB &
  &, 0.165251E+01_JPRB, 0.165338E+01_JPRB, 0.165369E+01_JPRB &
  &, 0.165342E+01_JPRB, 0.165269E+01_JPRB, 0.165138E+01_JPRB, 0.164953E+01_JPRB &
  &, 0.164714E+01_JPRB, 0.164421E+01_JPRB, 0.164077E+01_JPRB &
  &, 0.163681E+01_JPRB, 0.163233E+01_JPRB, 0.162735E+01_JPRB, 0.162188E+01_JPRB &
  &, 0.161590E+01_JPRB, 0.160944E+01_JPRB, 0.160249E+01_JPRB &
  &, 0.159508E+01_JPRB, 0.158721E+01_JPRB, 0.157888E+01_JPRB, 0.157013E+01_JPRB &
  &, 0.156092E+01_JPRB, 0.155129E+01_JPRB, 0.154124E+01_JPRB &
  &, 0.153080E+01_JPRB, 0.151994E+01_JPRB, 0.150871E+01_JPRB, 0.149711E+01_JPRB &
  &, 0.148515E+01_JPRB, 0.147282E+01_JPRB, 0.146016E+01_JPRB &
  &, 0.144717E+01_JPRB, 0.143386E+01_JPRB, 0.142026E+01_JPRB, 0.140633E+01_JPRB &
  &, 0.139215E+01_JPRB, 0.137768E+01_JPRB, 0.136296E+01_JPRB &
  &, 0.134799E+01_JPRB, 0.133277E+01_JPRB, 0.131733E+01_JPRB, 0.130169E+01_JPRB &
  &, 0.128584E+01_JPRB, 0.126983E+01_JPRB, 0.125363E+01_JPRB &
  &, 0.123725E+01_JPRB, 0.122072E+01_JPRB, 0.120405E+01_JPRB, 0.118728E+01_JPRB &
  &, 0.117037E+01_JPRB, 0.115336E+01_JPRB, 0.113624E+01_JPRB &
  &, 0.111908E+01_JPRB, 0.110180E+01_JPRB, 0.108448E+01_JPRB, 0.106714E+01_JPRB &
  &, 0.104974E+01_JPRB, 0.103232E+01_JPRB, 0.101486E+01_JPRB &
  &, 0.997432E+00_JPRB, 0.979992E+00_JPRB, 0.962569E+00_JPRB, 0.945151E+00_JPRB &
  &, 0.927769E+00_JPRB, 0.910454E+00_JPRB, 0.893192E+00_JPRB &
  &, 0.875969E+00_JPRB, 0.858860E+00_JPRB, 0.841804E+00_JPRB, 0.824828E+00_JPRB &
  &, 0.807963E+00_JPRB, 0.791188E+00_JPRB, 0.774533E+00_JPRB &
  &, 0.757975E+00_JPRB, 0.741594E+00_JPRB, 0.725315E+00_JPRB, 0.709166E+00_JPRB &
  &, 0.693172E+00_JPRB, 0.677362E+00_JPRB, 0.661655E+00_JPRB &
  &, 0.646184E+00_JPRB, 0.630811E+00_JPRB, 0.615671E+00_JPRB, 0.600678E+00_JPRB &
  &, 0.585855E+00_JPRB, 0.571225E+00_JPRB, 0.556814E+00_JPRB &
  &, 0.542585E+00_JPRB, 0.528562E+00_JPRB, 0.514767E+00_JPRB, 0.501098E+00_JPRB &
  &, 0.487702E+00_JPRB, 0.474474E+00_JPRB, 0.461499E+00_JPRB/)
XCW( 802, :) = (/ &
  &  0.108372E+01_JPRB, 0.110426E+01_JPRB, 0.112461E+01_JPRB, 0.114476E+01_JPRB &
  &, 0.116470E+01_JPRB, 0.118442E+01_JPRB, 0.120390E+01_JPRB &
  &, 0.122313E+01_JPRB, 0.124209E+01_JPRB, 0.126078E+01_JPRB, 0.127917E+01_JPRB &
  &, 0.129727E+01_JPRB, 0.131505E+01_JPRB, 0.133250E+01_JPRB &
  &, 0.134961E+01_JPRB, 0.136638E+01_JPRB, 0.138278E+01_JPRB, 0.139880E+01_JPRB &
  &, 0.141444E+01_JPRB, 0.142968E+01_JPRB, 0.144452E+01_JPRB &
  &, 0.145893E+01_JPRB, 0.147291E+01_JPRB, 0.148645E+01_JPRB, 0.149955E+01_JPRB &
  &, 0.151218E+01_JPRB, 0.152434E+01_JPRB, 0.153603E+01_JPRB &
  &, 0.154723E+01_JPRB, 0.155794E+01_JPRB, 0.156815E+01_JPRB, 0.157784E+01_JPRB &
  &, 0.158702E+01_JPRB, 0.159569E+01_JPRB, 0.160382E+01_JPRB &
  &, 0.161142E+01_JPRB, 0.161848E+01_JPRB, 0.162501E+01_JPRB, 0.163099E+01_JPRB &
  &, 0.163642E+01_JPRB, 0.164131E+01_JPRB, 0.164564E+01_JPRB &
  &, 0.164942E+01_JPRB, 0.165263E+01_JPRB, 0.165531E+01_JPRB, 0.165742E+01_JPRB &
  &, 0.165898E+01_JPRB, 0.165999E+01_JPRB, 0.166044E+01_JPRB &
  &, 0.166036E+01_JPRB, 0.165971E+01_JPRB, 0.165853E+01_JPRB, 0.165681E+01_JPRB &
  &, 0.165455E+01_JPRB, 0.165177E+01_JPRB, 0.164846E+01_JPRB &
  &, 0.164462E+01_JPRB, 0.164026E+01_JPRB, 0.163541E+01_JPRB, 0.163004E+01_JPRB &
  &, 0.162420E+01_JPRB, 0.161784E+01_JPRB, 0.161102E+01_JPRB &
  &, 0.160372E+01_JPRB, 0.159596E+01_JPRB, 0.158776E+01_JPRB, 0.157908E+01_JPRB &
  &, 0.156999E+01_JPRB, 0.156045E+01_JPRB, 0.155050E+01_JPRB &
  &, 0.154014E+01_JPRB, 0.152940E+01_JPRB, 0.151825E+01_JPRB, 0.150673E+01_JPRB &
  &, 0.149484E+01_JPRB, 0.148262E+01_JPRB, 0.147003E+01_JPRB &
  &, 0.145710E+01_JPRB, 0.144385E+01_JPRB, 0.143030E+01_JPRB, 0.141646E+01_JPRB &
  &, 0.140233E+01_JPRB, 0.138792E+01_JPRB, 0.137324E+01_JPRB &
  &, 0.135832E+01_JPRB, 0.134316E+01_JPRB, 0.132777E+01_JPRB, 0.131217E+01_JPRB &
  &, 0.129634E+01_JPRB, 0.128034E+01_JPRB, 0.126417E+01_JPRB &
  &, 0.124780E+01_JPRB, 0.123129E+01_JPRB, 0.121465E+01_JPRB, 0.119789E+01_JPRB &
  &, 0.118097E+01_JPRB, 0.116397E+01_JPRB, 0.114686E+01_JPRB &
  &, 0.112967E+01_JPRB, 0.111243E+01_JPRB, 0.109510E+01_JPRB, 0.107771E+01_JPRB &
  &, 0.106030E+01_JPRB, 0.104286E+01_JPRB, 0.102537E+01_JPRB &
  &, 0.100788E+01_JPRB, 0.990403E+00_JPRB, 0.972941E+00_JPRB, 0.955520E+00_JPRB &
  &, 0.938090E+00_JPRB, 0.920720E+00_JPRB, 0.903398E+00_JPRB &
  &, 0.886155E+00_JPRB, 0.868976E+00_JPRB, 0.851843E+00_JPRB, 0.834786E+00_JPRB &
  &, 0.817881E+00_JPRB, 0.801014E+00_JPRB, 0.784309E+00_JPRB &
  &, 0.767697E+00_JPRB, 0.751206E+00_JPRB, 0.734863E+00_JPRB, 0.718645E+00_JPRB &
  &, 0.702577E+00_JPRB, 0.686635E+00_JPRB, 0.670842E+00_JPRB &
  &, 0.655226E+00_JPRB, 0.639813E+00_JPRB, 0.624572E+00_JPRB, 0.609473E+00_JPRB &
  &, 0.594539E+00_JPRB, 0.579852E+00_JPRB, 0.565319E+00_JPRB &
  &, 0.550963E+00_JPRB, 0.536806E+00_JPRB, 0.522872E+00_JPRB, 0.509122E+00_JPRB &
  &, 0.495640E+00_JPRB, 0.482322E+00_JPRB, 0.469188E+00_JPRB/)
XCW( 803, :) = (/ &
  &  0.108410E+01_JPRB, 0.110474E+01_JPRB, 0.112520E+01_JPRB, 0.114545E+01_JPRB &
  &, 0.116550E+01_JPRB, 0.118533E+01_JPRB, 0.120492E+01_JPRB &
  &, 0.122426E+01_JPRB, 0.124334E+01_JPRB, 0.126214E+01_JPRB, 0.128066E+01_JPRB &
  &, 0.129888E+01_JPRB, 0.131677E+01_JPRB, 0.133436E+01_JPRB &
  &, 0.135160E+01_JPRB, 0.136849E+01_JPRB, 0.138502E+01_JPRB, 0.140118E+01_JPRB &
  &, 0.141695E+01_JPRB, 0.143232E+01_JPRB, 0.144729E+01_JPRB &
  &, 0.146185E+01_JPRB, 0.147596E+01_JPRB, 0.148965E+01_JPRB, 0.150288E+01_JPRB &
  &, 0.151565E+01_JPRB, 0.152796E+01_JPRB, 0.153979E+01_JPRB &
  &, 0.155113E+01_JPRB, 0.156199E+01_JPRB, 0.157233E+01_JPRB, 0.158218E+01_JPRB &
  &, 0.159150E+01_JPRB, 0.160031E+01_JPRB, 0.160859E+01_JPRB &
  &, 0.161633E+01_JPRB, 0.162354E+01_JPRB, 0.163022E+01_JPRB, 0.163634E+01_JPRB &
  &, 0.164192E+01_JPRB, 0.164694E+01_JPRB, 0.165143E+01_JPRB &
  &, 0.165534E+01_JPRB, 0.165872E+01_JPRB, 0.166153E+01_JPRB, 0.166379E+01_JPRB &
  &, 0.166549E+01_JPRB, 0.166664E+01_JPRB, 0.166723E+01_JPRB &
  &, 0.166728E+01_JPRB, 0.166678E+01_JPRB, 0.166573E+01_JPRB, 0.166415E+01_JPRB &
  &, 0.166202E+01_JPRB, 0.165936E+01_JPRB, 0.165618E+01_JPRB &
  &, 0.165248E+01_JPRB, 0.164825E+01_JPRB, 0.164352E+01_JPRB, 0.163827E+01_JPRB &
  &, 0.163255E+01_JPRB, 0.162631E+01_JPRB, 0.161961E+01_JPRB &
  &, 0.161243E+01_JPRB, 0.160477E+01_JPRB, 0.159667E+01_JPRB, 0.158810E+01_JPRB &
  &, 0.157911E+01_JPRB, 0.156969E+01_JPRB, 0.155983E+01_JPRB &
  &, 0.154956E+01_JPRB, 0.153891E+01_JPRB, 0.152786E+01_JPRB, 0.151643E+01_JPRB &
  &, 0.150461E+01_JPRB, 0.149245E+01_JPRB, 0.147995E+01_JPRB &
  &, 0.146712E+01_JPRB, 0.145395E+01_JPRB, 0.144044E+01_JPRB, 0.142668E+01_JPRB &
  &, 0.141259E+01_JPRB, 0.139824E+01_JPRB, 0.138362E+01_JPRB &
  &, 0.136873E+01_JPRB, 0.135363E+01_JPRB, 0.133829E+01_JPRB, 0.132271E+01_JPRB &
  &, 0.130693E+01_JPRB, 0.129097E+01_JPRB, 0.127481E+01_JPRB &
  &, 0.125847E+01_JPRB, 0.124199E+01_JPRB, 0.122537E+01_JPRB, 0.120858E+01_JPRB &
  &, 0.119171E+01_JPRB, 0.117469E+01_JPRB, 0.115759E+01_JPRB &
  &, 0.114040E+01_JPRB, 0.112313E+01_JPRB, 0.110579E+01_JPRB, 0.108840E+01_JPRB &
  &, 0.107098E+01_JPRB, 0.105348E+01_JPRB, 0.103601E+01_JPRB &
  &, 0.101848E+01_JPRB, 0.100098E+01_JPRB, 0.983478E+00_JPRB, 0.965974E+00_JPRB &
  &, 0.948538E+00_JPRB, 0.931116E+00_JPRB, 0.913736E+00_JPRB &
  &, 0.896430E+00_JPRB, 0.879182E+00_JPRB, 0.862022E+00_JPRB, 0.844885E+00_JPRB &
  &, 0.827895E+00_JPRB, 0.810985E+00_JPRB, 0.794183E+00_JPRB &
  &, 0.777519E+00_JPRB, 0.760920E+00_JPRB, 0.744514E+00_JPRB, 0.728176E+00_JPRB &
  &, 0.712035E+00_JPRB, 0.696014E+00_JPRB, 0.680138E+00_JPRB &
  &, 0.664433E+00_JPRB, 0.648926E+00_JPRB, 0.633530E+00_JPRB, 0.618384E+00_JPRB &
  &, 0.603339E+00_JPRB, 0.588537E+00_JPRB, 0.573883E+00_JPRB &
  &, 0.559461E+00_JPRB, 0.545173E+00_JPRB, 0.531165E+00_JPRB, 0.517272E+00_JPRB &
  &, 0.503642E+00_JPRB, 0.490235E+00_JPRB, 0.477007E+00_JPRB/)
XCW( 804, :) = (/ &
  &  0.108449E+01_JPRB, 0.110522E+01_JPRB, 0.112578E+01_JPRB, 0.114615E+01_JPRB &
  &, 0.116630E+01_JPRB, 0.118624E+01_JPRB, 0.120594E+01_JPRB &
  &, 0.122540E+01_JPRB, 0.124459E+01_JPRB, 0.126352E+01_JPRB, 0.128215E+01_JPRB &
  &, 0.130049E+01_JPRB, 0.131852E+01_JPRB, 0.133623E+01_JPRB &
  &, 0.135359E+01_JPRB, 0.137062E+01_JPRB, 0.138728E+01_JPRB, 0.140356E+01_JPRB &
  &, 0.141947E+01_JPRB, 0.143498E+01_JPRB, 0.145009E+01_JPRB &
  &, 0.146477E+01_JPRB, 0.147903E+01_JPRB, 0.149285E+01_JPRB, 0.150623E+01_JPRB &
  &, 0.151914E+01_JPRB, 0.153159E+01_JPRB, 0.154356E+01_JPRB &
  &, 0.155505E+01_JPRB, 0.156605E+01_JPRB, 0.157654E+01_JPRB, 0.158653E+01_JPRB &
  &, 0.159601E+01_JPRB, 0.160496E+01_JPRB, 0.161339E+01_JPRB &
  &, 0.162128E+01_JPRB, 0.162864E+01_JPRB, 0.163545E+01_JPRB, 0.164172E+01_JPRB &
  &, 0.164745E+01_JPRB, 0.165262E+01_JPRB, 0.165725E+01_JPRB &
  &, 0.166131E+01_JPRB, 0.166483E+01_JPRB, 0.166778E+01_JPRB, 0.167017E+01_JPRB &
  &, 0.167203E+01_JPRB, 0.167333E+01_JPRB, 0.167406E+01_JPRB &
  &, 0.167425E+01_JPRB, 0.167388E+01_JPRB, 0.167298E+01_JPRB, 0.167152E+01_JPRB &
  &, 0.166954E+01_JPRB, 0.166701E+01_JPRB, 0.166396E+01_JPRB &
  &, 0.166038E+01_JPRB, 0.165626E+01_JPRB, 0.165168E+01_JPRB, 0.164656E+01_JPRB &
  &, 0.164095E+01_JPRB, 0.163484E+01_JPRB, 0.162826E+01_JPRB &
  &, 0.162118E+01_JPRB, 0.161364E+01_JPRB, 0.160565E+01_JPRB, 0.159719E+01_JPRB &
  &, 0.158829E+01_JPRB, 0.157899E+01_JPRB, 0.156923E+01_JPRB &
  &, 0.155905E+01_JPRB, 0.154850E+01_JPRB, 0.153753E+01_JPRB, 0.152619E+01_JPRB &
  &, 0.151446E+01_JPRB, 0.150239E+01_JPRB, 0.148996E+01_JPRB &
  &, 0.147719E+01_JPRB, 0.146410E+01_JPRB, 0.145069E+01_JPRB, 0.143695E+01_JPRB &
  &, 0.142295E+01_JPRB, 0.140864E+01_JPRB, 0.139409E+01_JPRB &
  &, 0.137926E+01_JPRB, 0.136418E+01_JPRB, 0.134887E+01_JPRB, 0.133334E+01_JPRB &
  &, 0.131760E+01_JPRB, 0.130166E+01_JPRB, 0.128554E+01_JPRB &
  &, 0.126924E+01_JPRB, 0.125279E+01_JPRB, 0.123617E+01_JPRB, 0.121940E+01_JPRB &
  &, 0.120251E+01_JPRB, 0.118551E+01_JPRB, 0.116842E+01_JPRB &
  &, 0.115124E+01_JPRB, 0.113393E+01_JPRB, 0.111660E+01_JPRB, 0.109920E+01_JPRB &
  &, 0.108173E+01_JPRB, 0.106425E+01_JPRB, 0.104672E+01_JPRB &
  &, 0.102917E+01_JPRB, 0.101163E+01_JPRB, 0.994099E+00_JPRB, 0.976597E+00_JPRB &
  &, 0.959073E+00_JPRB, 0.941643E+00_JPRB, 0.924208E+00_JPRB &
  &, 0.906840E+00_JPRB, 0.889525E+00_JPRB, 0.872293E+00_JPRB, 0.855125E+00_JPRB &
  &, 0.838051E+00_JPRB, 0.821101E+00_JPRB, 0.804205E+00_JPRB &
  &, 0.787440E+00_JPRB, 0.770785E+00_JPRB, 0.754268E+00_JPRB, 0.737915E+00_JPRB &
  &, 0.721651E+00_JPRB, 0.705554E+00_JPRB, 0.689597E+00_JPRB &
  &, 0.673806E+00_JPRB, 0.658152E+00_JPRB, 0.642715E+00_JPRB, 0.627409E+00_JPRB &
  &, 0.612314E+00_JPRB, 0.597340E+00_JPRB, 0.582627E+00_JPRB &
  &, 0.568081E+00_JPRB, 0.553725E+00_JPRB, 0.539520E+00_JPRB, 0.525612E+00_JPRB &
  &, 0.511837E+00_JPRB, 0.498278E+00_JPRB, 0.484958E+00_JPRB/)
XCW( 805, :) = (/ &
  &  0.108487E+01_JPRB, 0.110571E+01_JPRB, 0.112637E+01_JPRB, 0.114684E+01_JPRB &
  &, 0.116711E+01_JPRB, 0.118715E+01_JPRB, 0.120697E+01_JPRB &
  &, 0.122654E+01_JPRB, 0.124585E+01_JPRB, 0.126490E+01_JPRB, 0.128365E+01_JPRB &
  &, 0.130211E+01_JPRB, 0.132027E+01_JPRB, 0.133810E+01_JPRB &
  &, 0.135560E+01_JPRB, 0.137275E+01_JPRB, 0.138954E+01_JPRB, 0.140596E+01_JPRB &
  &, 0.142200E+01_JPRB, 0.143764E+01_JPRB, 0.145289E+01_JPRB &
  &, 0.146771E+01_JPRB, 0.148211E+01_JPRB, 0.149608E+01_JPRB, 0.150959E+01_JPRB &
  &, 0.152265E+01_JPRB, 0.153524E+01_JPRB, 0.154736E+01_JPRB &
  &, 0.155899E+01_JPRB, 0.157013E+01_JPRB, 0.158077E+01_JPRB, 0.159091E+01_JPRB &
  &, 0.160053E+01_JPRB, 0.160963E+01_JPRB, 0.161820E+01_JPRB &
  &, 0.162625E+01_JPRB, 0.163375E+01_JPRB, 0.164071E+01_JPRB, 0.164714E+01_JPRB &
  &, 0.165301E+01_JPRB, 0.165833E+01_JPRB, 0.166310E+01_JPRB &
  &, 0.166731E+01_JPRB, 0.167097E+01_JPRB, 0.167407E+01_JPRB, 0.167662E+01_JPRB &
  &, 0.167861E+01_JPRB, 0.168004E+01_JPRB, 0.168093E+01_JPRB &
  &, 0.168125E+01_JPRB, 0.168103E+01_JPRB, 0.168025E+01_JPRB, 0.167894E+01_JPRB &
  &, 0.167709E+01_JPRB, 0.167471E+01_JPRB, 0.167178E+01_JPRB &
  &, 0.166833E+01_JPRB, 0.166437E+01_JPRB, 0.165989E+01_JPRB, 0.165490E+01_JPRB &
  &, 0.164941E+01_JPRB, 0.164336E+01_JPRB, 0.163696E+01_JPRB &
  &, 0.162999E+01_JPRB, 0.162258E+01_JPRB, 0.161469E+01_JPRB, 0.160635E+01_JPRB &
  &, 0.159756E+01_JPRB, 0.158835E+01_JPRB, 0.157868E+01_JPRB &
  &, 0.156863E+01_JPRB, 0.155814E+01_JPRB, 0.154720E+01_JPRB, 0.153586E+01_JPRB &
  &, 0.152440E+01_JPRB, 0.151239E+01_JPRB, 0.150004E+01_JPRB &
  &, 0.148735E+01_JPRB, 0.147432E+01_JPRB, 0.146099E+01_JPRB, 0.144732E+01_JPRB &
  &, 0.143336E+01_JPRB, 0.141913E+01_JPRB, 0.140464E+01_JPRB &
  &, 0.138984E+01_JPRB, 0.137483E+01_JPRB, 0.135956E+01_JPRB, 0.134409E+01_JPRB &
  &, 0.132837E+01_JPRB, 0.131247E+01_JPRB, 0.129636E+01_JPRB &
  &, 0.128010E+01_JPRB, 0.126365E+01_JPRB, 0.124706E+01_JPRB, 0.123032E+01_JPRB &
  &, 0.121345E+01_JPRB, 0.119647E+01_JPRB, 0.117936E+01_JPRB &
  &, 0.116215E+01_JPRB, 0.114488E+01_JPRB, 0.112751E+01_JPRB, 0.111011E+01_JPRB &
  &, 0.109263E+01_JPRB, 0.107510E+01_JPRB, 0.105755E+01_JPRB &
  &, 0.104002E+01_JPRB, 0.102241E+01_JPRB, 0.100484E+01_JPRB, 0.987303E+00_JPRB &
  &, 0.969693E+00_JPRB, 0.952257E+00_JPRB, 0.934767E+00_JPRB &
  &, 0.917340E+00_JPRB, 0.900005E+00_JPRB, 0.882702E+00_JPRB, 0.865459E+00_JPRB &
  &, 0.848351E+00_JPRB, 0.831265E+00_JPRB, 0.814325E+00_JPRB &
  &, 0.797511E+00_JPRB, 0.780803E+00_JPRB, 0.764175E+00_JPRB, 0.747707E+00_JPRB &
  &, 0.731373E+00_JPRB, 0.715202E+00_JPRB, 0.699165E+00_JPRB &
  &, 0.683234E+00_JPRB, 0.667545E+00_JPRB, 0.651956E+00_JPRB, 0.636549E+00_JPRB &
  &, 0.621348E+00_JPRB, 0.606321E+00_JPRB, 0.591491E+00_JPRB &
  &, 0.576823E+00_JPRB, 0.562339E+00_JPRB, 0.548061E+00_JPRB, 0.534015E+00_JPRB &
  &, 0.520095E+00_JPRB, 0.506451E+00_JPRB, 0.492975E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART115',1,ZHOOK_HANDLE)
END SUBROUTINE PART115

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART116

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART116',0,ZHOOK_HANDLE)

XCW( 806, :) = (/ &
  &  0.108525E+01_JPRB, 0.110619E+01_JPRB, 0.112696E+01_JPRB, 0.114754E+01_JPRB &
  &, 0.116791E+01_JPRB, 0.118807E+01_JPRB, 0.120800E+01_JPRB &
  &, 0.122769E+01_JPRB, 0.124712E+01_JPRB, 0.126628E+01_JPRB, 0.128516E+01_JPRB &
  &, 0.130374E+01_JPRB, 0.132202E+01_JPRB, 0.133998E+01_JPRB &
  &, 0.135761E+01_JPRB, 0.137489E+01_JPRB, 0.139181E+01_JPRB, 0.140837E+01_JPRB &
  &, 0.142454E+01_JPRB, 0.144033E+01_JPRB, 0.145570E+01_JPRB &
  &, 0.147067E+01_JPRB, 0.148521E+01_JPRB, 0.149931E+01_JPRB, 0.151297E+01_JPRB &
  &, 0.152617E+01_JPRB, 0.153891E+01_JPRB, 0.155117E+01_JPRB &
  &, 0.156295E+01_JPRB, 0.157424E+01_JPRB, 0.158502E+01_JPRB, 0.159531E+01_JPRB &
  &, 0.160508E+01_JPRB, 0.161432E+01_JPRB, 0.162305E+01_JPRB &
  &, 0.163123E+01_JPRB, 0.163889E+01_JPRB, 0.164600E+01_JPRB, 0.165257E+01_JPRB &
  &, 0.165860E+01_JPRB, 0.166407E+01_JPRB, 0.166898E+01_JPRB &
  &, 0.167335E+01_JPRB, 0.167715E+01_JPRB, 0.168040E+01_JPRB, 0.168309E+01_JPRB &
  &, 0.168522E+01_JPRB, 0.168681E+01_JPRB, 0.168783E+01_JPRB &
  &, 0.168829E+01_JPRB, 0.168822E+01_JPRB, 0.168759E+01_JPRB, 0.168641E+01_JPRB &
  &, 0.168469E+01_JPRB, 0.168244E+01_JPRB, 0.167965E+01_JPRB &
  &, 0.167634E+01_JPRB, 0.167250E+01_JPRB, 0.166815E+01_JPRB, 0.166329E+01_JPRB &
  &, 0.165793E+01_JPRB, 0.165206E+01_JPRB, 0.164571E+01_JPRB &
  &, 0.163887E+01_JPRB, 0.163156E+01_JPRB, 0.162379E+01_JPRB, 0.161555E+01_JPRB &
  &, 0.160688E+01_JPRB, 0.159777E+01_JPRB, 0.158822E+01_JPRB &
  &, 0.157824E+01_JPRB, 0.156787E+01_JPRB, 0.155710E+01_JPRB, 0.154593E+01_JPRB &
  &, 0.153438E+01_JPRB, 0.152248E+01_JPRB, 0.151020E+01_JPRB &
  &, 0.149759E+01_JPRB, 0.148464E+01_JPRB, 0.147136E+01_JPRB, 0.145777E+01_JPRB &
  &, 0.144388E+01_JPRB, 0.142972E+01_JPRB, 0.141526E+01_JPRB &
  &, 0.140053E+01_JPRB, 0.138555E+01_JPRB, 0.137035E+01_JPRB, 0.135490E+01_JPRB &
  &, 0.133923E+01_JPRB, 0.132338E+01_JPRB, 0.130731E+01_JPRB &
  &, 0.129105E+01_JPRB, 0.127465E+01_JPRB, 0.125805E+01_JPRB, 0.124134E+01_JPRB &
  &, 0.122446E+01_JPRB, 0.120749E+01_JPRB, 0.119040E+01_JPRB &
  &, 0.117321E+01_JPRB, 0.115591E+01_JPRB, 0.113854E+01_JPRB, 0.112110E+01_JPRB &
  &, 0.110361E+01_JPRB, 0.108610E+01_JPRB, 0.106854E+01_JPRB &
  &, 0.105095E+01_JPRB, 0.103331E+01_JPRB, 0.101571E+01_JPRB, 0.998137E+00_JPRB &
  &, 0.980527E+00_JPRB, 0.963001E+00_JPRB, 0.945459E+00_JPRB &
  &, 0.927974E+00_JPRB, 0.910576E+00_JPRB, 0.893204E+00_JPRB, 0.875933E+00_JPRB &
  &, 0.858746E+00_JPRB, 0.841623E+00_JPRB, 0.824592E+00_JPRB &
  &, 0.807682E+00_JPRB, 0.790871E+00_JPRB, 0.774237E+00_JPRB, 0.757655E+00_JPRB &
  &, 0.741254E+00_JPRB, 0.724956E+00_JPRB, 0.708841E+00_JPRB &
  &, 0.692827E+00_JPRB, 0.676994E+00_JPRB, 0.661368E+00_JPRB, 0.645862E+00_JPRB &
  &, 0.630557E+00_JPRB, 0.615420E+00_JPRB, 0.600475E+00_JPRB &
  &, 0.585686E+00_JPRB, 0.571075E+00_JPRB, 0.556728E+00_JPRB, 0.542544E+00_JPRB &
  &, 0.528546E+00_JPRB, 0.514753E+00_JPRB, 0.501189E+00_JPRB/)
XCW( 807, :) = (/ &
  &  0.108564E+01_JPRB, 0.110668E+01_JPRB, 0.112755E+01_JPRB, 0.114824E+01_JPRB &
  &, 0.116872E+01_JPRB, 0.118899E+01_JPRB, 0.120903E+01_JPRB &
  &, 0.122884E+01_JPRB, 0.124839E+01_JPRB, 0.126767E+01_JPRB, 0.128667E+01_JPRB &
  &, 0.130538E+01_JPRB, 0.132378E+01_JPRB, 0.134187E+01_JPRB &
  &, 0.135962E+01_JPRB, 0.137704E+01_JPRB, 0.139409E+01_JPRB, 0.141078E+01_JPRB &
  &, 0.142709E+01_JPRB, 0.144301E+01_JPRB, 0.145853E+01_JPRB &
  &, 0.147364E+01_JPRB, 0.148832E+01_JPRB, 0.150256E+01_JPRB, 0.151636E+01_JPRB &
  &, 0.152971E+01_JPRB, 0.154259E+01_JPRB, 0.155500E+01_JPRB &
  &, 0.156692E+01_JPRB, 0.157836E+01_JPRB, 0.158930E+01_JPRB, 0.159973E+01_JPRB &
  &, 0.160964E+01_JPRB, 0.161905E+01_JPRB, 0.162792E+01_JPRB &
  &, 0.163626E+01_JPRB, 0.164406E+01_JPRB, 0.165132E+01_JPRB, 0.165805E+01_JPRB &
  &, 0.166421E+01_JPRB, 0.166983E+01_JPRB, 0.167490E+01_JPRB &
  &, 0.167941E+01_JPRB, 0.168336E+01_JPRB, 0.168677E+01_JPRB, 0.168960E+01_JPRB &
  &, 0.169188E+01_JPRB, 0.169361E+01_JPRB, 0.169478E+01_JPRB &
  &, 0.169539E+01_JPRB, 0.169545E+01_JPRB, 0.169496E+01_JPRB, 0.169392E+01_JPRB &
  &, 0.169234E+01_JPRB, 0.169022E+01_JPRB, 0.168757E+01_JPRB &
  &, 0.168440E+01_JPRB, 0.168068E+01_JPRB, 0.167644E+01_JPRB, 0.167173E+01_JPRB &
  &, 0.166648E+01_JPRB, 0.166076E+01_JPRB, 0.165453E+01_JPRB &
  &, 0.164780E+01_JPRB, 0.164061E+01_JPRB, 0.163295E+01_JPRB, 0.162483E+01_JPRB &
  &, 0.161626E+01_JPRB, 0.160725E+01_JPRB, 0.159781E+01_JPRB &
  &, 0.158795E+01_JPRB, 0.157767E+01_JPRB, 0.156699E+01_JPRB, 0.155592E+01_JPRB &
  &, 0.154446E+01_JPRB, 0.153262E+01_JPRB, 0.152045E+01_JPRB &
  &, 0.150790E+01_JPRB, 0.149503E+01_JPRB, 0.148183E+01_JPRB, 0.146832E+01_JPRB &
  &, 0.145448E+01_JPRB, 0.144039E+01_JPRB, 0.142598E+01_JPRB &
  &, 0.141131E+01_JPRB, 0.139639E+01_JPRB, 0.138122E+01_JPRB, 0.136582E+01_JPRB &
  &, 0.135021E+01_JPRB, 0.133437E+01_JPRB, 0.131832E+01_JPRB &
  &, 0.130210E+01_JPRB, 0.128570E+01_JPRB, 0.126914E+01_JPRB, 0.125245E+01_JPRB &
  &, 0.123561E+01_JPRB, 0.121863E+01_JPRB, 0.120155E+01_JPRB &
  &, 0.118433E+01_JPRB, 0.116704E+01_JPRB, 0.114968E+01_JPRB, 0.113223E+01_JPRB &
  &, 0.111474E+01_JPRB, 0.109719E+01_JPRB, 0.107961E+01_JPRB &
  &, 0.106200E+01_JPRB, 0.104434E+01_JPRB, 0.102671E+01_JPRB, 0.100905E+01_JPRB &
  &, 0.991447E+00_JPRB, 0.973832E+00_JPRB, 0.956284E+00_JPRB &
  &, 0.938743E+00_JPRB, 0.921284E+00_JPRB, 0.903892E+00_JPRB, 0.886549E+00_JPRB &
  &, 0.869284E+00_JPRB, 0.852078E+00_JPRB, 0.835007E+00_JPRB &
  &, 0.818002E+00_JPRB, 0.801141E+00_JPRB, 0.784350E+00_JPRB, 0.767759E+00_JPRB &
  &, 0.751240E+00_JPRB, 0.734871E+00_JPRB, 0.718627E+00_JPRB &
  &, 0.702531E+00_JPRB, 0.686667E+00_JPRB, 0.670893E+00_JPRB, 0.655289E+00_JPRB &
  &, 0.639882E+00_JPRB, 0.624636E+00_JPRB, 0.609578E+00_JPRB &
  &, 0.594670E+00_JPRB, 0.579996E+00_JPRB, 0.565519E+00_JPRB, 0.551200E+00_JPRB &
  &, 0.537124E+00_JPRB, 0.523185E+00_JPRB, 0.509534E+00_JPRB/)
XCW( 808, :) = (/ &
  &  0.108602E+01_JPRB, 0.110717E+01_JPRB, 0.112815E+01_JPRB, 0.114894E+01_JPRB &
  &, 0.116953E+01_JPRB, 0.118992E+01_JPRB, 0.121007E+01_JPRB &
  &, 0.122999E+01_JPRB, 0.124966E+01_JPRB, 0.126906E+01_JPRB, 0.128819E+01_JPRB &
  &, 0.130702E+01_JPRB, 0.132555E+01_JPRB, 0.134377E+01_JPRB &
  &, 0.136165E+01_JPRB, 0.137919E+01_JPRB, 0.139639E+01_JPRB, 0.141321E+01_JPRB &
  &, 0.142966E+01_JPRB, 0.144572E+01_JPRB, 0.146137E+01_JPRB &
  &, 0.147662E+01_JPRB, 0.149144E+01_JPRB, 0.150583E+01_JPRB, 0.151977E+01_JPRB &
  &, 0.153326E+01_JPRB, 0.154629E+01_JPRB, 0.155885E+01_JPRB &
  &, 0.157092E+01_JPRB, 0.158250E+01_JPRB, 0.159359E+01_JPRB, 0.160417E+01_JPRB &
  &, 0.161424E+01_JPRB, 0.162379E+01_JPRB, 0.163281E+01_JPRB &
  &, 0.164130E+01_JPRB, 0.164925E+01_JPRB, 0.165667E+01_JPRB, 0.166354E+01_JPRB &
  &, 0.166986E+01_JPRB, 0.167563E+01_JPRB, 0.168085E+01_JPRB &
  &, 0.168551E+01_JPRB, 0.168962E+01_JPRB, 0.169316E+01_JPRB, 0.169615E+01_JPRB &
  &, 0.169858E+01_JPRB, 0.170044E+01_JPRB, 0.170176E+01_JPRB &
  &, 0.170251E+01_JPRB, 0.170271E+01_JPRB, 0.170238E+01_JPRB, 0.170148E+01_JPRB &
  &, 0.170004E+01_JPRB, 0.169806E+01_JPRB, 0.169555E+01_JPRB &
  &, 0.169251E+01_JPRB, 0.168893E+01_JPRB, 0.168483E+01_JPRB, 0.168023E+01_JPRB &
  &, 0.167512E+01_JPRB, 0.166951E+01_JPRB, 0.166339E+01_JPRB &
  &, 0.165680E+01_JPRB, 0.164972E+01_JPRB, 0.164218E+01_JPRB, 0.163417E+01_JPRB &
  &, 0.162572E+01_JPRB, 0.161681E+01_JPRB, 0.160747E+01_JPRB &
  &, 0.159771E+01_JPRB, 0.158753E+01_JPRB, 0.157695E+01_JPRB, 0.156597E+01_JPRB &
  &, 0.155461E+01_JPRB, 0.154286E+01_JPRB, 0.153075E+01_JPRB &
  &, 0.151831E+01_JPRB, 0.150550E+01_JPRB, 0.149238E+01_JPRB, 0.147892E+01_JPRB &
  &, 0.146519E+01_JPRB, 0.145114E+01_JPRB, 0.143680E+01_JPRB &
  &, 0.142217E+01_JPRB, 0.140731E+01_JPRB, 0.139220E+01_JPRB, 0.137684E+01_JPRB &
  &, 0.136124E+01_JPRB, 0.134546E+01_JPRB, 0.132945E+01_JPRB &
  &, 0.131325E+01_JPRB, 0.129689E+01_JPRB, 0.128036E+01_JPRB, 0.126367E+01_JPRB &
  &, 0.124682E+01_JPRB, 0.122986E+01_JPRB, 0.121266E+01_JPRB &
  &, 0.119560E+01_JPRB, 0.117829E+01_JPRB, 0.116093E+01_JPRB, 0.114348E+01_JPRB &
  &, 0.112595E+01_JPRB, 0.110839E+01_JPRB, 0.109080E+01_JPRB &
  &, 0.107316E+01_JPRB, 0.105548E+01_JPRB, 0.103783E+01_JPRB, 0.102014E+01_JPRB &
  &, 0.100250E+01_JPRB, 0.984838E+00_JPRB, 0.967241E+00_JPRB &
  &, 0.949647E+00_JPRB, 0.932128E+00_JPRB, 0.914671E+00_JPRB, 0.897258E+00_JPRB &
  &, 0.879917E+00_JPRB, 0.862678E+00_JPRB, 0.845520E+00_JPRB &
  &, 0.828472E+00_JPRB, 0.811512E+00_JPRB, 0.794668E+00_JPRB, 0.777967E+00_JPRB &
  &, 0.761331E+00_JPRB, 0.744894E+00_JPRB, 0.728575E+00_JPRB &
  &, 0.712400E+00_JPRB, 0.696396E+00_JPRB, 0.680531E+00_JPRB, 0.664832E+00_JPRB &
  &, 0.649323E+00_JPRB, 0.633972E+00_JPRB, 0.618801E+00_JPRB &
  &, 0.603836E+00_JPRB, 0.589040E+00_JPRB, 0.574435E+00_JPRB, 0.559982E+00_JPRB &
  &, 0.545767E+00_JPRB, 0.531747E+00_JPRB, 0.517945E+00_JPRB/)
XCW( 809, :) = (/ &
  &  0.108641E+01_JPRB, 0.110766E+01_JPRB, 0.112874E+01_JPRB, 0.114964E+01_JPRB &
  &, 0.117035E+01_JPRB, 0.119084E+01_JPRB, 0.121112E+01_JPRB &
  &, 0.123115E+01_JPRB, 0.125094E+01_JPRB, 0.127046E+01_JPRB, 0.128971E+01_JPRB &
  &, 0.130867E+01_JPRB, 0.132733E+01_JPRB, 0.134567E+01_JPRB &
  &, 0.136369E+01_JPRB, 0.138136E+01_JPRB, 0.139869E+01_JPRB, 0.141565E+01_JPRB &
  &, 0.143223E+01_JPRB, 0.144843E+01_JPRB, 0.146422E+01_JPRB &
  &, 0.147961E+01_JPRB, 0.149458E+01_JPRB, 0.150911E+01_JPRB, 0.152320E+01_JPRB &
  &, 0.153683E+01_JPRB, 0.155000E+01_JPRB, 0.156271E+01_JPRB &
  &, 0.157494E+01_JPRB, 0.158667E+01_JPRB, 0.159790E+01_JPRB, 0.160864E+01_JPRB &
  &, 0.161885E+01_JPRB, 0.162855E+01_JPRB, 0.163773E+01_JPRB &
  &, 0.164637E+01_JPRB, 0.165448E+01_JPRB, 0.166205E+01_JPRB, 0.166906E+01_JPRB &
  &, 0.167554E+01_JPRB, 0.168147E+01_JPRB, 0.168683E+01_JPRB &
  &, 0.169164E+01_JPRB, 0.169590E+01_JPRB, 0.169959E+01_JPRB, 0.170273E+01_JPRB &
  &, 0.170531E+01_JPRB, 0.170732E+01_JPRB, 0.170879E+01_JPRB &
  &, 0.170969E+01_JPRB, 0.171003E+01_JPRB, 0.170983E+01_JPRB, 0.170908E+01_JPRB &
  &, 0.170779E+01_JPRB, 0.170594E+01_JPRB, 0.170356E+01_JPRB &
  &, 0.170066E+01_JPRB, 0.169722E+01_JPRB, 0.169325E+01_JPRB, 0.168878E+01_JPRB &
  &, 0.168380E+01_JPRB, 0.167831E+01_JPRB, 0.167233E+01_JPRB &
  &, 0.166585E+01_JPRB, 0.165890E+01_JPRB, 0.165147E+01_JPRB, 0.164358E+01_JPRB &
  &, 0.163524E+01_JPRB, 0.162644E+01_JPRB, 0.161722E+01_JPRB &
  &, 0.160756E+01_JPRB, 0.159748E+01_JPRB, 0.158699E+01_JPRB, 0.157611E+01_JPRB &
  &, 0.156482E+01_JPRB, 0.155319E+01_JPRB, 0.154115E+01_JPRB &
  &, 0.152877E+01_JPRB, 0.151607E+01_JPRB, 0.150301E+01_JPRB, 0.148962E+01_JPRB &
  &, 0.147594E+01_JPRB, 0.146197E+01_JPRB, 0.144767E+01_JPRB &
  &, 0.143314E+01_JPRB, 0.141832E+01_JPRB, 0.140325E+01_JPRB, 0.138794E+01_JPRB &
  &, 0.137240E+01_JPRB, 0.135664E+01_JPRB, 0.134068E+01_JPRB &
  &, 0.132452E+01_JPRB, 0.130817E+01_JPRB, 0.129165E+01_JPRB, 0.127499E+01_JPRB &
  &, 0.125817E+01_JPRB, 0.124124E+01_JPRB, 0.122413E+01_JPRB &
  &, 0.120694E+01_JPRB, 0.118967E+01_JPRB, 0.117229E+01_JPRB, 0.115481E+01_JPRB &
  &, 0.113731E+01_JPRB, 0.111970E+01_JPRB, 0.110210E+01_JPRB &
  &, 0.108441E+01_JPRB, 0.106675E+01_JPRB, 0.104903E+01_JPRB, 0.103131E+01_JPRB &
  &, 0.101363E+01_JPRB, 0.995930E+00_JPRB, 0.978286E+00_JPRB &
  &, 0.960685E+00_JPRB, 0.943064E+00_JPRB, 0.925544E+00_JPRB, 0.908109E+00_JPRB &
  &, 0.890694E+00_JPRB, 0.873375E+00_JPRB, 0.856180E+00_JPRB &
  &, 0.839042E+00_JPRB, 0.821985E+00_JPRB, 0.805089E+00_JPRB, 0.788279E+00_JPRB &
  &, 0.771582E+00_JPRB, 0.755077E+00_JPRB, 0.738632E+00_JPRB &
  &, 0.722379E+00_JPRB, 0.706292E+00_JPRB, 0.690340E+00_JPRB, 0.674547E+00_JPRB &
  &, 0.658940E+00_JPRB, 0.643484E+00_JPRB, 0.628204E+00_JPRB &
  &, 0.613063E+00_JPRB, 0.598207E+00_JPRB, 0.583476E+00_JPRB, 0.568954E+00_JPRB &
  &, 0.554601E+00_JPRB, 0.540503E+00_JPRB, 0.526553E+00_JPRB/)
XCW( 810, :) = (/ &
  &  0.108680E+01_JPRB, 0.110815E+01_JPRB, 0.112934E+01_JPRB, 0.115035E+01_JPRB &
  &, 0.117117E+01_JPRB, 0.119178E+01_JPRB, 0.121216E+01_JPRB &
  &, 0.123232E+01_JPRB, 0.125222E+01_JPRB, 0.127187E+01_JPRB, 0.129124E+01_JPRB &
  &, 0.131032E+01_JPRB, 0.132911E+01_JPRB, 0.134758E+01_JPRB &
  &, 0.136573E+01_JPRB, 0.138354E+01_JPRB, 0.140100E+01_JPRB, 0.141809E+01_JPRB &
  &, 0.143482E+01_JPRB, 0.145115E+01_JPRB, 0.146709E+01_JPRB &
  &, 0.148262E+01_JPRB, 0.149773E+01_JPRB, 0.151241E+01_JPRB, 0.152664E+01_JPRB &
  &, 0.154042E+01_JPRB, 0.155374E+01_JPRB, 0.156660E+01_JPRB &
  &, 0.157897E+01_JPRB, 0.159085E+01_JPRB, 0.160224E+01_JPRB, 0.161312E+01_JPRB &
  &, 0.162349E+01_JPRB, 0.163334E+01_JPRB, 0.164267E+01_JPRB &
  &, 0.165146E+01_JPRB, 0.165973E+01_JPRB, 0.166745E+01_JPRB, 0.167462E+01_JPRB &
  &, 0.168125E+01_JPRB, 0.168733E+01_JPRB, 0.169285E+01_JPRB &
  &, 0.169781E+01_JPRB, 0.170222E+01_JPRB, 0.170606E+01_JPRB, 0.170935E+01_JPRB &
  &, 0.171208E+01_JPRB, 0.171424E+01_JPRB, 0.171585E+01_JPRB &
  &, 0.171690E+01_JPRB, 0.171740E+01_JPRB, 0.171733E+01_JPRB, 0.171673E+01_JPRB &
  &, 0.171558E+01_JPRB, 0.171388E+01_JPRB, 0.171163E+01_JPRB &
  &, 0.170885E+01_JPRB, 0.170556E+01_JPRB, 0.170174E+01_JPRB, 0.169739E+01_JPRB &
  &, 0.169254E+01_JPRB, 0.168718E+01_JPRB, 0.168131E+01_JPRB &
  &, 0.167496E+01_JPRB, 0.166814E+01_JPRB, 0.166084E+01_JPRB, 0.165306E+01_JPRB &
  &, 0.164482E+01_JPRB, 0.163614E+01_JPRB, 0.162700E+01_JPRB &
  &, 0.161747E+01_JPRB, 0.160747E+01_JPRB, 0.159710E+01_JPRB, 0.158630E+01_JPRB &
  &, 0.157512E+01_JPRB, 0.156356E+01_JPRB, 0.155164E+01_JPRB &
  &, 0.153935E+01_JPRB, 0.152671E+01_JPRB, 0.151374E+01_JPRB, 0.150043E+01_JPRB &
  &, 0.148681E+01_JPRB, 0.147288E+01_JPRB, 0.145869E+01_JPRB &
  &, 0.144417E+01_JPRB, 0.142942E+01_JPRB, 0.141440E+01_JPRB, 0.139913E+01_JPRB &
  &, 0.138365E+01_JPRB, 0.136791E+01_JPRB, 0.135200E+01_JPRB &
  &, 0.133586E+01_JPRB, 0.131955E+01_JPRB, 0.130307E+01_JPRB, 0.128641E+01_JPRB &
  &, 0.126962E+01_JPRB, 0.125268E+01_JPRB, 0.123563E+01_JPRB &
  &, 0.121842E+01_JPRB, 0.120114E+01_JPRB, 0.118376E+01_JPRB, 0.116629E+01_JPRB &
  &, 0.114875E+01_JPRB, 0.113118E+01_JPRB, 0.111352E+01_JPRB &
  &, 0.109582E+01_JPRB, 0.107810E+01_JPRB, 0.106040E+01_JPRB, 0.104265E+01_JPRB &
  &, 0.102489E+01_JPRB, 0.100720E+01_JPRB, 0.989464E+00_JPRB &
  &, 0.971813E+00_JPRB, 0.954182E+00_JPRB, 0.936601E+00_JPRB, 0.919053E+00_JPRB &
  &, 0.901613E+00_JPRB, 0.884217E+00_JPRB, 0.866939E+00_JPRB &
  &, 0.849711E+00_JPRB, 0.832609E+00_JPRB, 0.815612E+00_JPRB, 0.798748E+00_JPRB &
  &, 0.781991E+00_JPRB, 0.765368E+00_JPRB, 0.748852E+00_JPRB &
  &, 0.732524E+00_JPRB, 0.716300E+00_JPRB, 0.700262E+00_JPRB, 0.684377E+00_JPRB &
  &, 0.668614E+00_JPRB, 0.653115E+00_JPRB, 0.637727E+00_JPRB &
  &, 0.622472E+00_JPRB, 0.607497E+00_JPRB, 0.592641E+00_JPRB, 0.577989E+00_JPRB &
  &, 0.563564E+00_JPRB, 0.549324E+00_JPRB, 0.535293E+00_JPRB/)
XCW( 811, :) = (/ &
  &  0.108719E+01_JPRB, 0.110865E+01_JPRB, 0.112994E+01_JPRB, 0.115106E+01_JPRB &
  &, 0.117199E+01_JPRB, 0.119271E+01_JPRB, 0.121321E+01_JPRB &
  &, 0.123348E+01_JPRB, 0.125351E+01_JPRB, 0.127328E+01_JPRB, 0.129278E+01_JPRB &
  &, 0.131199E+01_JPRB, 0.133090E+01_JPRB, 0.134950E+01_JPRB &
  &, 0.136778E+01_JPRB, 0.138573E+01_JPRB, 0.140332E+01_JPRB, 0.142055E+01_JPRB &
  &, 0.143741E+01_JPRB, 0.145389E+01_JPRB, 0.146997E+01_JPRB &
  &, 0.148564E+01_JPRB, 0.150089E+01_JPRB, 0.151572E+01_JPRB, 0.153010E+01_JPRB &
  &, 0.154403E+01_JPRB, 0.155750E+01_JPRB, 0.157050E+01_JPRB &
  &, 0.158302E+01_JPRB, 0.159506E+01_JPRB, 0.160659E+01_JPRB, 0.161763E+01_JPRB &
  &, 0.162815E+01_JPRB, 0.163816E+01_JPRB, 0.164764E+01_JPRB &
  &, 0.165659E+01_JPRB, 0.166500E+01_JPRB, 0.167288E+01_JPRB, 0.168021E+01_JPRB &
  &, 0.168699E+01_JPRB, 0.169322E+01_JPRB, 0.169881E+01_JPRB &
  &, 0.170401E+01_JPRB, 0.170856E+01_JPRB, 0.171257E+01_JPRB, 0.171600E+01_JPRB &
  &, 0.171889E+01_JPRB, 0.172120E+01_JPRB, 0.172296E+01_JPRB &
  &, 0.172415E+01_JPRB, 0.172480E+01_JPRB, 0.172489E+01_JPRB, 0.172442E+01_JPRB &
  &, 0.172341E+01_JPRB, 0.172185E+01_JPRB, 0.171975E+01_JPRB &
  &, 0.171712E+01_JPRB, 0.171395E+01_JPRB, 0.171027E+01_JPRB, 0.170606E+01_JPRB &
  &, 0.170133E+01_JPRB, 0.169610E+01_JPRB, 0.169037E+01_JPRB &
  &, 0.168414E+01_JPRB, 0.167743E+01_JPRB, 0.167024E+01_JPRB, 0.166259E+01_JPRB &
  &, 0.165448E+01_JPRB, 0.164591E+01_JPRB, 0.163690E+01_JPRB &
  &, 0.162744E+01_JPRB, 0.161757E+01_JPRB, 0.160728E+01_JPRB, 0.159660E+01_JPRB &
  &, 0.158550E+01_JPRB, 0.157403E+01_JPRB, 0.156220E+01_JPRB &
  &, 0.154998E+01_JPRB, 0.153743E+01_JPRB, 0.152454E+01_JPRB, 0.151129E+01_JPRB &
  &, 0.149775E+01_JPRB, 0.148390E+01_JPRB, 0.146975E+01_JPRB &
  &, 0.145534E+01_JPRB, 0.144063E+01_JPRB, 0.142565E+01_JPRB, 0.141044E+01_JPRB &
  &, 0.139499E+01_JPRB, 0.137930E+01_JPRB, 0.136342E+01_JPRB &
  &, 0.134732E+01_JPRB, 0.133106E+01_JPRB, 0.131458E+01_JPRB, 0.129797E+01_JPRB &
  &, 0.128117E+01_JPRB, 0.126426E+01_JPRB, 0.124720E+01_JPRB &
  &, 0.123002E+01_JPRB, 0.121274E+01_JPRB, 0.119534E+01_JPRB, 0.117787E+01_JPRB &
  &, 0.116034E+01_JPRB, 0.114273E+01_JPRB, 0.112507E+01_JPRB &
  &, 0.110735E+01_JPRB, 0.108962E+01_JPRB, 0.107185E+01_JPRB, 0.105407E+01_JPRB &
  &, 0.103633E+01_JPRB, 0.101855E+01_JPRB, 0.100077E+01_JPRB &
  &, 0.983075E+00_JPRB, 0.965391E+00_JPRB, 0.947751E+00_JPRB, 0.930185E+00_JPRB &
  &, 0.912676E+00_JPRB, 0.895204E+00_JPRB, 0.877845E+00_JPRB &
  &, 0.860579E+00_JPRB, 0.843386E+00_JPRB, 0.826341E+00_JPRB, 0.809373E+00_JPRB &
  &, 0.792505E+00_JPRB, 0.775819E+00_JPRB, 0.759235E+00_JPRB &
  &, 0.742779E+00_JPRB, 0.726476E+00_JPRB, 0.710353E+00_JPRB, 0.694322E+00_JPRB &
  &, 0.678522E+00_JPRB, 0.662863E+00_JPRB, 0.647369E+00_JPRB &
  &, 0.632064E+00_JPRB, 0.616910E+00_JPRB, 0.601994E+00_JPRB, 0.587213E+00_JPRB &
  &, 0.572654E+00_JPRB, 0.558275E+00_JPRB, 0.544098E+00_JPRB/)
XCW( 812, :) = (/ &
  &  0.108758E+01_JPRB, 0.110915E+01_JPRB, 0.113055E+01_JPRB, 0.115177E+01_JPRB &
  &, 0.117281E+01_JPRB, 0.119365E+01_JPRB, 0.121427E+01_JPRB &
  &, 0.123466E+01_JPRB, 0.125480E+01_JPRB, 0.127470E+01_JPRB, 0.129432E+01_JPRB &
  &, 0.131365E+01_JPRB, 0.133270E+01_JPRB, 0.135143E+01_JPRB &
  &, 0.136984E+01_JPRB, 0.138792E+01_JPRB, 0.140565E+01_JPRB, 0.142302E+01_JPRB &
  &, 0.144002E+01_JPRB, 0.145664E+01_JPRB, 0.147286E+01_JPRB &
  &, 0.148867E+01_JPRB, 0.150407E+01_JPRB, 0.151904E+01_JPRB, 0.153357E+01_JPRB &
  &, 0.154765E+01_JPRB, 0.156127E+01_JPRB, 0.157442E+01_JPRB &
  &, 0.158710E+01_JPRB, 0.159928E+01_JPRB, 0.161097E+01_JPRB, 0.162216E+01_JPRB &
  &, 0.163284E+01_JPRB, 0.164300E+01_JPRB, 0.165263E+01_JPRB &
  &, 0.166174E+01_JPRB, 0.167031E+01_JPRB, 0.167834E+01_JPRB, 0.168583E+01_JPRB &
  &, 0.169276E+01_JPRB, 0.169914E+01_JPRB, 0.170497E+01_JPRB &
  &, 0.171025E+01_JPRB, 0.171496E+01_JPRB, 0.171911E+01_JPRB, 0.172270E+01_JPRB &
  &, 0.172573E+01_JPRB, 0.172820E+01_JPRB, 0.173010E+01_JPRB &
  &, 0.173146E+01_JPRB, 0.173224E+01_JPRB, 0.173248E+01_JPRB, 0.173217E+01_JPRB &
  &, 0.173130E+01_JPRB, 0.172989E+01_JPRB, 0.172793E+01_JPRB &
  &, 0.172544E+01_JPRB, 0.172241E+01_JPRB, 0.171885E+01_JPRB, 0.171479E+01_JPRB &
  &, 0.171018E+01_JPRB, 0.170509E+01_JPRB, 0.169949E+01_JPRB &
  &, 0.169338E+01_JPRB, 0.168680E+01_JPRB, 0.167974E+01_JPRB, 0.167220E+01_JPRB &
  &, 0.166420E+01_JPRB, 0.165573E+01_JPRB, 0.164683E+01_JPRB &
  &, 0.163750E+01_JPRB, 0.162773E+01_JPRB, 0.161755E+01_JPRB, 0.160694E+01_JPRB &
  &, 0.159596E+01_JPRB, 0.158459E+01_JPRB, 0.157283E+01_JPRB &
  &, 0.156071E+01_JPRB, 0.154824E+01_JPRB, 0.153542E+01_JPRB, 0.152226E+01_JPRB &
  &, 0.150879E+01_JPRB, 0.149502E+01_JPRB, 0.148093E+01_JPRB &
  &, 0.146656E+01_JPRB, 0.145192E+01_JPRB, 0.143701E+01_JPRB, 0.142183E+01_JPRB &
  &, 0.140644E+01_JPRB, 0.139079E+01_JPRB, 0.137495E+01_JPRB &
  &, 0.135888E+01_JPRB, 0.134263E+01_JPRB, 0.132620E+01_JPRB, 0.130962E+01_JPRB &
  &, 0.129286E+01_JPRB, 0.127594E+01_JPRB, 0.125887E+01_JPRB &
  &, 0.124171E+01_JPRB, 0.122442E+01_JPRB, 0.120703E+01_JPRB, 0.118958E+01_JPRB &
  &, 0.117201E+01_JPRB, 0.115439E+01_JPRB, 0.113673E+01_JPRB &
  &, 0.111901E+01_JPRB, 0.110121E+01_JPRB, 0.108346E+01_JPRB, 0.106562E+01_JPRB &
  &, 0.104784E+01_JPRB, 0.103003E+01_JPRB, 0.101222E+01_JPRB &
  &, 0.994472E+00_JPRB, 0.976736E+00_JPRB, 0.959040E+00_JPRB, 0.941411E+00_JPRB &
  &, 0.923834E+00_JPRB, 0.906336E+00_JPRB, 0.888898E+00_JPRB &
  &, 0.871548E+00_JPRB, 0.854314E+00_JPRB, 0.837173E+00_JPRB, 0.820102E+00_JPRB &
  &, 0.803178E+00_JPRB, 0.786378E+00_JPRB, 0.769727E+00_JPRB &
  &, 0.753199E+00_JPRB, 0.736764E+00_JPRB, 0.720559E+00_JPRB, 0.704440E+00_JPRB &
  &, 0.688547E+00_JPRB, 0.672730E+00_JPRB, 0.657131E+00_JPRB &
  &, 0.641716E+00_JPRB, 0.626508E+00_JPRB, 0.611471E+00_JPRB, 0.596564E+00_JPRB &
  &, 0.581873E+00_JPRB, 0.567421E+00_JPRB, 0.553101E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART116',1,ZHOOK_HANDLE)
END SUBROUTINE PART116

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART117

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART117',0,ZHOOK_HANDLE)

XCW( 813, :) = (/ &
  &  0.108797E+01_JPRB, 0.110964E+01_JPRB, 0.113115E+01_JPRB, 0.115249E+01_JPRB &
  &, 0.117364E+01_JPRB, 0.119459E+01_JPRB, 0.121533E+01_JPRB &
  &, 0.123584E+01_JPRB, 0.125610E+01_JPRB, 0.127612E+01_JPRB, 0.129586E+01_JPRB &
  &, 0.131533E+01_JPRB, 0.133450E+01_JPRB, 0.135337E+01_JPRB &
  &, 0.137191E+01_JPRB, 0.139013E+01_JPRB, 0.140799E+01_JPRB, 0.142550E+01_JPRB &
  &, 0.144264E+01_JPRB, 0.145940E+01_JPRB, 0.147577E+01_JPRB &
  &, 0.149172E+01_JPRB, 0.150727E+01_JPRB, 0.152238E+01_JPRB, 0.153706E+01_JPRB &
  &, 0.155129E+01_JPRB, 0.156506E+01_JPRB, 0.157836E+01_JPRB &
  &, 0.159119E+01_JPRB, 0.160353E+01_JPRB, 0.161537E+01_JPRB, 0.162672E+01_JPRB &
  &, 0.163755E+01_JPRB, 0.164786E+01_JPRB, 0.165765E+01_JPRB &
  &, 0.166691E+01_JPRB, 0.167564E+01_JPRB, 0.168382E+01_JPRB, 0.169147E+01_JPRB &
  &, 0.169856E+01_JPRB, 0.170510E+01_JPRB, 0.171108E+01_JPRB &
  &, 0.171652E+01_JPRB, 0.172138E+01_JPRB, 0.172570E+01_JPRB, 0.172944E+01_JPRB &
  &, 0.173262E+01_JPRB, 0.173524E+01_JPRB, 0.173730E+01_JPRB &
  &, 0.173880E+01_JPRB, 0.173974E+01_JPRB, 0.174013E+01_JPRB, 0.173996E+01_JPRB &
  &, 0.173923E+01_JPRB, 0.173796E+01_JPRB, 0.173615E+01_JPRB &
  &, 0.173381E+01_JPRB, 0.173041E+01_JPRB, 0.172750E+01_JPRB, 0.172357E+01_JPRB &
  &, 0.171911E+01_JPRB, 0.171414E+01_JPRB, 0.170867E+01_JPRB &
  &, 0.170269E+01_JPRB, 0.169622E+01_JPRB, 0.168929E+01_JPRB, 0.168186E+01_JPRB &
  &, 0.167397E+01_JPRB, 0.166564E+01_JPRB, 0.165684E+01_JPRB &
  &, 0.164762E+01_JPRB, 0.163796E+01_JPRB, 0.162788E+01_JPRB, 0.161740E+01_JPRB &
  &, 0.160650E+01_JPRB, 0.159523E+01_JPRB, 0.158356E+01_JPRB &
  &, 0.157153E+01_JPRB, 0.155913E+01_JPRB, 0.154640E+01_JPRB, 0.153332E+01_JPRB &
  &, 0.151992E+01_JPRB, 0.150620E+01_JPRB, 0.149219E+01_JPRB &
  &, 0.147789E+01_JPRB, 0.146330E+01_JPRB, 0.144846E+01_JPRB, 0.143335E+01_JPRB &
  &, 0.141799E+01_JPRB, 0.140239E+01_JPRB, 0.138659E+01_JPRB &
  &, 0.137056E+01_JPRB, 0.135436E+01_JPRB, 0.133794E+01_JPRB, 0.132137E+01_JPRB &
  &, 0.130461E+01_JPRB, 0.128773E+01_JPRB, 0.127069E+01_JPRB &
  &, 0.125352E+01_JPRB, 0.123625E+01_JPRB, 0.121887E+01_JPRB, 0.120139E+01_JPRB &
  &, 0.118383E+01_JPRB, 0.116621E+01_JPRB, 0.114851E+01_JPRB &
  &, 0.113078E+01_JPRB, 0.111297E+01_JPRB, 0.109516E+01_JPRB, 0.107734E+01_JPRB &
  &, 0.105949E+01_JPRB, 0.104165E+01_JPRB, 0.102384E+01_JPRB &
  &, 0.100600E+01_JPRB, 0.988219E+00_JPRB, 0.970467E+00_JPRB, 0.952779E+00_JPRB &
  &, 0.935135E+00_JPRB, 0.917566E+00_JPRB, 0.900099E+00_JPRB &
  &, 0.882666E+00_JPRB, 0.865343E+00_JPRB, 0.848107E+00_JPRB, 0.830987E+00_JPRB &
  &, 0.814010E+00_JPRB, 0.797097E+00_JPRB, 0.780328E+00_JPRB &
  &, 0.763730E+00_JPRB, 0.747220E+00_JPRB, 0.730877E+00_JPRB, 0.714730E+00_JPRB &
  &, 0.698688E+00_JPRB, 0.682774E+00_JPRB, 0.667073E+00_JPRB &
  &, 0.651550E+00_JPRB, 0.636229E+00_JPRB, 0.621073E+00_JPRB, 0.606104E+00_JPRB &
  &, 0.591284E+00_JPRB, 0.576696E+00_JPRB, 0.562300E+00_JPRB/)
XCW( 814, :) = (/ &
  &  0.108837E+01_JPRB, 0.111014E+01_JPRB, 0.113176E+01_JPRB, 0.115321E+01_JPRB &
  &, 0.117447E+01_JPRB, 0.119553E+01_JPRB, 0.121639E+01_JPRB &
  &, 0.123702E+01_JPRB, 0.125741E+01_JPRB, 0.127755E+01_JPRB, 0.129742E+01_JPRB &
  &, 0.131701E+01_JPRB, 0.133631E+01_JPRB, 0.135531E+01_JPRB &
  &, 0.137399E+01_JPRB, 0.139234E+01_JPRB, 0.141034E+01_JPRB, 0.142799E+01_JPRB &
  &, 0.144528E+01_JPRB, 0.146217E+01_JPRB, 0.147869E+01_JPRB &
  &, 0.149479E+01_JPRB, 0.151048E+01_JPRB, 0.152574E+01_JPRB, 0.154057E+01_JPRB &
  &, 0.155495E+01_JPRB, 0.156887E+01_JPRB, 0.158233E+01_JPRB &
  &, 0.159530E+01_JPRB, 0.160780E+01_JPRB, 0.161980E+01_JPRB, 0.163130E+01_JPRB &
  &, 0.164228E+01_JPRB, 0.165275E+01_JPRB, 0.166270E+01_JPRB &
  &, 0.167212E+01_JPRB, 0.168100E+01_JPRB, 0.168935E+01_JPRB, 0.169715E+01_JPRB &
  &, 0.170440E+01_JPRB, 0.171110E+01_JPRB, 0.171724E+01_JPRB &
  &, 0.172282E+01_JPRB, 0.172785E+01_JPRB, 0.173231E+01_JPRB, 0.173621E+01_JPRB &
  &, 0.173955E+01_JPRB, 0.174232E+01_JPRB, 0.174453E+01_JPRB &
  &, 0.174619E+01_JPRB, 0.174727E+01_JPRB, 0.174782E+01_JPRB, 0.174779E+01_JPRB &
  &, 0.174722E+01_JPRB, 0.174610E+01_JPRB, 0.174443E+01_JPRB &
  &, 0.174222E+01_JPRB, 0.173947E+01_JPRB, 0.173620E+01_JPRB, 0.173240E+01_JPRB &
  &, 0.172807E+01_JPRB, 0.172323E+01_JPRB, 0.171790E+01_JPRB &
  &, 0.171205E+01_JPRB, 0.170572E+01_JPRB, 0.169890E+01_JPRB, 0.169161E+01_JPRB &
  &, 0.168385E+01_JPRB, 0.167561E+01_JPRB, 0.166694E+01_JPRB &
  &, 0.165783E+01_JPRB, 0.164828E+01_JPRB, 0.163830E+01_JPRB, 0.162790E+01_JPRB &
  &, 0.161712E+01_JPRB, 0.160593E+01_JPRB, 0.159436E+01_JPRB &
  &, 0.158243E+01_JPRB, 0.157012E+01_JPRB, 0.155745E+01_JPRB, 0.154447E+01_JPRB &
  &, 0.153115E+01_JPRB, 0.151752E+01_JPRB, 0.150355E+01_JPRB &
  &, 0.148931E+01_JPRB, 0.147479E+01_JPRB, 0.145999E+01_JPRB, 0.144495E+01_JPRB &
  &, 0.142963E+01_JPRB, 0.141409E+01_JPRB, 0.139831E+01_JPRB &
  &, 0.138234E+01_JPRB, 0.136616E+01_JPRB, 0.134979E+01_JPRB, 0.133323E+01_JPRB &
  &, 0.131651E+01_JPRB, 0.129963E+01_JPRB, 0.128261E+01_JPRB &
  &, 0.126547E+01_JPRB, 0.124818E+01_JPRB, 0.123083E+01_JPRB, 0.121335E+01_JPRB &
  &, 0.119576E+01_JPRB, 0.117811E+01_JPRB, 0.116041E+01_JPRB &
  &, 0.114267E+01_JPRB, 0.112485E+01_JPRB, 0.110703E+01_JPRB, 0.108914E+01_JPRB &
  &, 0.107127E+01_JPRB, 0.105339E+01_JPRB, 0.103555E+01_JPRB &
  &, 0.101767E+01_JPRB, 0.999838E+00_JPRB, 0.982033E+00_JPRB, 0.964287E+00_JPRB &
  &, 0.946627E+00_JPRB, 0.928989E+00_JPRB, 0.911398E+00_JPRB &
  &, 0.893933E+00_JPRB, 0.876524E+00_JPRB, 0.859247E+00_JPRB, 0.842028E+00_JPRB &
  &, 0.824947E+00_JPRB, 0.807977E+00_JPRB, 0.791146E+00_JPRB &
  &, 0.774426E+00_JPRB, 0.757843E+00_JPRB, 0.741366E+00_JPRB, 0.725077E+00_JPRB &
  &, 0.708945E+00_JPRB, 0.692996E+00_JPRB, 0.677195E+00_JPRB &
  &, 0.661566E+00_JPRB, 0.646073E+00_JPRB, 0.630799E+00_JPRB, 0.615708E+00_JPRB &
  &, 0.600822E+00_JPRB, 0.586101E+00_JPRB, 0.571565E+00_JPRB/)
XCW( 815, :) = (/ &
  &  0.108877E+01_JPRB, 0.111064E+01_JPRB, 0.113237E+01_JPRB, 0.115393E+01_JPRB &
  &, 0.117530E+01_JPRB, 0.119648E+01_JPRB, 0.121746E+01_JPRB &
  &, 0.123820E+01_JPRB, 0.125872E+01_JPRB, 0.127898E+01_JPRB, 0.129898E+01_JPRB &
  &, 0.131870E+01_JPRB, 0.133814E+01_JPRB, 0.135726E+01_JPRB &
  &, 0.137608E+01_JPRB, 0.139456E+01_JPRB, 0.141271E+01_JPRB, 0.143050E+01_JPRB &
  &, 0.144792E+01_JPRB, 0.146496E+01_JPRB, 0.148162E+01_JPRB &
  &, 0.149787E+01_JPRB, 0.151370E+01_JPRB, 0.152912E+01_JPRB, 0.154409E+01_JPRB &
  &, 0.155862E+01_JPRB, 0.157270E+01_JPRB, 0.158631E+01_JPRB &
  &, 0.159944E+01_JPRB, 0.161208E+01_JPRB, 0.162424E+01_JPRB, 0.163590E+01_JPRB &
  &, 0.164704E+01_JPRB, 0.165767E+01_JPRB, 0.166778E+01_JPRB &
  &, 0.167735E+01_JPRB, 0.168639E+01_JPRB, 0.169489E+01_JPRB, 0.170286E+01_JPRB &
  &, 0.171026E+01_JPRB, 0.171712E+01_JPRB, 0.172342E+01_JPRB &
  &, 0.172917E+01_JPRB, 0.173434E+01_JPRB, 0.173897E+01_JPRB, 0.174302E+01_JPRB &
  &, 0.174652E+01_JPRB, 0.174945E+01_JPRB, 0.175182E+01_JPRB &
  &, 0.175363E+01_JPRB, 0.175487E+01_JPRB, 0.175555E+01_JPRB, 0.175568E+01_JPRB &
  &, 0.175526E+01_JPRB, 0.175428E+01_JPRB, 0.175276E+01_JPRB &
  &, 0.175070E+01_JPRB, 0.174810E+01_JPRB, 0.174496E+01_JPRB, 0.174129E+01_JPRB &
  &, 0.173710E+01_JPRB, 0.173240E+01_JPRB, 0.172720E+01_JPRB &
  &, 0.172149E+01_JPRB, 0.171529E+01_JPRB, 0.170859E+01_JPRB, 0.170141E+01_JPRB &
  &, 0.169376E+01_JPRB, 0.168566E+01_JPRB, 0.167710E+01_JPRB &
  &, 0.166810E+01_JPRB, 0.165865E+01_JPRB, 0.164878E+01_JPRB, 0.163851E+01_JPRB &
  &, 0.162782E+01_JPRB, 0.161672E+01_JPRB, 0.160526E+01_JPRB &
  &, 0.159340E+01_JPRB, 0.158119E+01_JPRB, 0.156861E+01_JPRB, 0.155572E+01_JPRB &
  &, 0.154246E+01_JPRB, 0.152889E+01_JPRB, 0.151500E+01_JPRB &
  &, 0.150084E+01_JPRB, 0.148637E+01_JPRB, 0.147164E+01_JPRB, 0.145664E+01_JPRB &
  &, 0.144139E+01_JPRB, 0.142588E+01_JPRB, 0.141016E+01_JPRB &
  &, 0.139422E+01_JPRB, 0.137809E+01_JPRB, 0.136173E+01_JPRB, 0.134521E+01_JPRB &
  &, 0.132850E+01_JPRB, 0.131166E+01_JPRB, 0.129454E+01_JPRB &
  &, 0.127752E+01_JPRB, 0.126026E+01_JPRB, 0.124289E+01_JPRB, 0.122539E+01_JPRB &
  &, 0.120785E+01_JPRB, 0.119017E+01_JPRB, 0.117246E+01_JPRB &
  &, 0.115468E+01_JPRB, 0.113686E+01_JPRB, 0.111898E+01_JPRB, 0.110111E+01_JPRB &
  &, 0.108322E+01_JPRB, 0.106527E+01_JPRB, 0.104739E+01_JPRB &
  &, 0.102947E+01_JPRB, 0.101159E+01_JPRB, 0.993739E+00_JPRB, 0.975936E+00_JPRB &
  &, 0.958214E+00_JPRB, 0.940508E+00_JPRB, 0.922894E+00_JPRB &
  &, 0.905351E+00_JPRB, 0.887856E+00_JPRB, 0.870489E+00_JPRB, 0.853226E+00_JPRB &
  &, 0.836042E+00_JPRB, 0.818964E+00_JPRB, 0.802073E+00_JPRB &
  &, 0.785233E+00_JPRB, 0.768578E+00_JPRB, 0.752025E+00_JPRB, 0.735654E+00_JPRB &
  &, 0.719436E+00_JPRB, 0.703335E+00_JPRB, 0.687436E+00_JPRB &
  &, 0.671704E+00_JPRB, 0.656101E+00_JPRB, 0.640713E+00_JPRB, 0.625501E+00_JPRB &
  &, 0.610489E+00_JPRB, 0.595636E+00_JPRB, 0.581028E+00_JPRB/)
XCW( 816, :) = (/ &
  &  0.108916E+01_JPRB, 0.111115E+01_JPRB, 0.113298E+01_JPRB, 0.115465E+01_JPRB &
  &, 0.117614E+01_JPRB, 0.119744E+01_JPRB, 0.121853E+01_JPRB &
  &, 0.123940E+01_JPRB, 0.126003E+01_JPRB, 0.128042E+01_JPRB, 0.130055E+01_JPRB &
  &, 0.132040E+01_JPRB, 0.133996E+01_JPRB, 0.135923E+01_JPRB &
  &, 0.137818E+01_JPRB, 0.139680E+01_JPRB, 0.141508E+01_JPRB, 0.143301E+01_JPRB &
  &, 0.145058E+01_JPRB, 0.146776E+01_JPRB, 0.148456E+01_JPRB &
  &, 0.150096E+01_JPRB, 0.151694E+01_JPRB, 0.153251E+01_JPRB, 0.154763E+01_JPRB &
  &, 0.156232E+01_JPRB, 0.157654E+01_JPRB, 0.159031E+01_JPRB &
  &, 0.160359E+01_JPRB, 0.161640E+01_JPRB, 0.162871E+01_JPRB, 0.164052E+01_JPRB &
  &, 0.165183E+01_JPRB, 0.166261E+01_JPRB, 0.167288E+01_JPRB &
  &, 0.168261E+01_JPRB, 0.169182E+01_JPRB, 0.170048E+01_JPRB, 0.170859E+01_JPRB &
  &, 0.171616E+01_JPRB, 0.172318E+01_JPRB, 0.172965E+01_JPRB &
  &, 0.173554E+01_JPRB, 0.174088E+01_JPRB, 0.174566E+01_JPRB, 0.174988E+01_JPRB &
  &, 0.175353E+01_JPRB, 0.175662E+01_JPRB, 0.175914E+01_JPRB &
  &, 0.176110E+01_JPRB, 0.176250E+01_JPRB, 0.176334E+01_JPRB, 0.176361E+01_JPRB &
  &, 0.176334E+01_JPRB, 0.176252E+01_JPRB, 0.176113E+01_JPRB &
  &, 0.175922E+01_JPRB, 0.175677E+01_JPRB, 0.175377E+01_JPRB, 0.175025E+01_JPRB &
  &, 0.174620E+01_JPRB, 0.174164E+01_JPRB, 0.173657E+01_JPRB &
  &, 0.173098E+01_JPRB, 0.172491E+01_JPRB, 0.171835E+01_JPRB, 0.171129E+01_JPRB &
  &, 0.170378E+01_JPRB, 0.169579E+01_JPRB, 0.168734E+01_JPRB &
  &, 0.167846E+01_JPRB, 0.166912E+01_JPRB, 0.165936E+01_JPRB, 0.164919E+01_JPRB &
  &, 0.163860E+01_JPRB, 0.162761E+01_JPRB, 0.161623E+01_JPRB &
  &, 0.160446E+01_JPRB, 0.159235E+01_JPRB, 0.157987E+01_JPRB, 0.156704E+01_JPRB &
  &, 0.155387E+01_JPRB, 0.154039E+01_JPRB, 0.152656E+01_JPRB &
  &, 0.151245E+01_JPRB, 0.149806E+01_JPRB, 0.148338E+01_JPRB, 0.146845E+01_JPRB &
  &, 0.145323E+01_JPRB, 0.143780E+01_JPRB, 0.142210E+01_JPRB &
  &, 0.140622E+01_JPRB, 0.139011E+01_JPRB, 0.137380E+01_JPRB, 0.135730E+01_JPRB &
  &, 0.134063E+01_JPRB, 0.132379E+01_JPRB, 0.130681E+01_JPRB &
  &, 0.128969E+01_JPRB, 0.127245E+01_JPRB, 0.125506E+01_JPRB, 0.123759E+01_JPRB &
  &, 0.122001E+01_JPRB, 0.120234E+01_JPRB, 0.118464E+01_JPRB &
  &, 0.116686E+01_JPRB, 0.114898E+01_JPRB, 0.113109E+01_JPRB, 0.111317E+01_JPRB &
  &, 0.109525E+01_JPRB, 0.107732E+01_JPRB, 0.105936E+01_JPRB &
  &, 0.104141E+01_JPRB, 0.102349E+01_JPRB, 0.100558E+01_JPRB, 0.987725E+00_JPRB &
  &, 0.969944E+00_JPRB, 0.952173E+00_JPRB, 0.934487E+00_JPRB &
  &, 0.916867E+00_JPRB, 0.899341E+00_JPRB, 0.881885E+00_JPRB, 0.864528E+00_JPRB &
  &, 0.847297E+00_JPRB, 0.830166E+00_JPRB, 0.813109E+00_JPRB &
  &, 0.796204E+00_JPRB, 0.779481E+00_JPRB, 0.762854E+00_JPRB, 0.746347E+00_JPRB &
  &, 0.729926E+00_JPRB, 0.713852E+00_JPRB, 0.697797E+00_JPRB &
  &, 0.681963E+00_JPRB, 0.666314E+00_JPRB, 0.650813E+00_JPRB, 0.635484E+00_JPRB &
  &, 0.620348E+00_JPRB, 0.605365E+00_JPRB, 0.590622E+00_JPRB/)
XCW( 817, :) = (/ &
  &  0.108956E+01_JPRB, 0.111165E+01_JPRB, 0.113360E+01_JPRB, 0.115538E+01_JPRB &
  &, 0.117698E+01_JPRB, 0.119839E+01_JPRB, 0.121960E+01_JPRB &
  &, 0.124059E+01_JPRB, 0.126135E+01_JPRB, 0.128187E+01_JPRB, 0.130212E+01_JPRB &
  &, 0.132210E+01_JPRB, 0.134180E+01_JPRB, 0.136120E+01_JPRB &
  &, 0.138028E+01_JPRB, 0.139904E+01_JPRB, 0.141746E+01_JPRB, 0.143554E+01_JPRB &
  &, 0.145324E+01_JPRB, 0.147057E+01_JPRB, 0.148752E+01_JPRB &
  &, 0.150407E+01_JPRB, 0.152020E+01_JPRB, 0.153591E+01_JPRB, 0.155119E+01_JPRB &
  &, 0.156603E+01_JPRB, 0.158041E+01_JPRB, 0.159433E+01_JPRB &
  &, 0.160777E+01_JPRB, 0.162073E+01_JPRB, 0.163320E+01_JPRB, 0.164517E+01_JPRB &
  &, 0.165663E+01_JPRB, 0.166758E+01_JPRB, 0.167801E+01_JPRB &
  &, 0.168790E+01_JPRB, 0.169726E+01_JPRB, 0.170609E+01_JPRB, 0.171437E+01_JPRB &
  &, 0.172210E+01_JPRB, 0.172928E+01_JPRB, 0.173590E+01_JPRB &
  &, 0.174196E+01_JPRB, 0.174746E+01_JPRB, 0.175240E+01_JPRB, 0.175677E+01_JPRB &
  &, 0.176059E+01_JPRB, 0.176383E+01_JPRB, 0.176651E+01_JPRB &
  &, 0.176853E+01_JPRB, 0.177018E+01_JPRB, 0.177117E+01_JPRB, 0.177160E+01_JPRB &
  &, 0.177147E+01_JPRB, 0.177081E+01_JPRB, 0.176958E+01_JPRB &
  &, 0.176781E+01_JPRB, 0.176549E+01_JPRB, 0.176264E+01_JPRB, 0.175927E+01_JPRB &
  &, 0.175535E+01_JPRB, 0.175092E+01_JPRB, 0.174600E+01_JPRB &
  &, 0.174054E+01_JPRB, 0.173460E+01_JPRB, 0.172817E+01_JPRB, 0.172125E+01_JPRB &
  &, 0.171385E+01_JPRB, 0.170598E+01_JPRB, 0.169767E+01_JPRB &
  &, 0.168887E+01_JPRB, 0.167967E+01_JPRB, 0.167002E+01_JPRB, 0.165994E+01_JPRB &
  &, 0.164946E+01_JPRB, 0.163857E+01_JPRB, 0.162729E+01_JPRB &
  &, 0.161563E+01_JPRB, 0.160359E+01_JPRB, 0.159120E+01_JPRB, 0.157844E+01_JPRB &
  &, 0.156537E+01_JPRB, 0.155194E+01_JPRB, 0.153823E+01_JPRB &
  &, 0.152418E+01_JPRB, 0.150986E+01_JPRB, 0.149523E+01_JPRB, 0.148034E+01_JPRB &
  &, 0.146520E+01_JPRB, 0.144980E+01_JPRB, 0.143417E+01_JPRB &
  &, 0.141832E+01_JPRB, 0.140226E+01_JPRB, 0.138598E+01_JPRB, 0.136952E+01_JPRB &
  &, 0.135286E+01_JPRB, 0.133606E+01_JPRB, 0.131909E+01_JPRB &
  &, 0.130199E+01_JPRB, 0.128475E+01_JPRB, 0.126738E+01_JPRB, 0.124989E+01_JPRB &
  &, 0.123233E+01_JPRB, 0.121467E+01_JPRB, 0.119693E+01_JPRB &
  &, 0.117911E+01_JPRB, 0.116127E+01_JPRB, 0.114333E+01_JPRB, 0.112539E+01_JPRB &
  &, 0.110745E+01_JPRB, 0.108945E+01_JPRB, 0.107147E+01_JPRB &
  &, 0.105348E+01_JPRB, 0.103551E+01_JPRB, 0.101757E+01_JPRB, 0.999656E+00_JPRB &
  &, 0.981818E+00_JPRB, 0.963983E+00_JPRB, 0.946229E+00_JPRB &
  &, 0.928584E+00_JPRB, 0.910876E+00_JPRB, 0.893435E+00_JPRB, 0.875986E+00_JPRB &
  &, 0.858656E+00_JPRB, 0.841421E+00_JPRB, 0.824362E+00_JPRB &
  &, 0.807341E+00_JPRB, 0.790496E+00_JPRB, 0.773796E+00_JPRB, 0.757212E+00_JPRB &
  &, 0.740767E+00_JPRB, 0.724487E+00_JPRB, 0.708338E+00_JPRB &
  &, 0.692404E+00_JPRB, 0.676588E+00_JPRB, 0.660976E+00_JPRB, 0.645529E+00_JPRB &
  &, 0.630271E+00_JPRB, 0.615224E+00_JPRB, 0.600347E+00_JPRB/)
XCW( 818, :) = (/ &
  &  0.108996E+01_JPRB, 0.111216E+01_JPRB, 0.113421E+01_JPRB, 0.115610E+01_JPRB &
  &, 0.117782E+01_JPRB, 0.119935E+01_JPRB, 0.122068E+01_JPRB &
  &, 0.124179E+01_JPRB, 0.126268E+01_JPRB, 0.128332E+01_JPRB, 0.130370E+01_JPRB &
  &, 0.132381E+01_JPRB, 0.134364E+01_JPRB, 0.136318E+01_JPRB &
  &, 0.138240E+01_JPRB, 0.140130E+01_JPRB, 0.141986E+01_JPRB, 0.143807E+01_JPRB &
  &, 0.145592E+01_JPRB, 0.147340E+01_JPRB, 0.149049E+01_JPRB &
  &, 0.150719E+01_JPRB, 0.152347E+01_JPRB, 0.153934E+01_JPRB, 0.155477E+01_JPRB &
  &, 0.156976E+01_JPRB, 0.158430E+01_JPRB, 0.159837E+01_JPRB &
  &, 0.161197E+01_JPRB, 0.162509E+01_JPRB, 0.163771E+01_JPRB, 0.164984E+01_JPRB &
  &, 0.166147E+01_JPRB, 0.167257E+01_JPRB, 0.168316E+01_JPRB &
  &, 0.169322E+01_JPRB, 0.170275E+01_JPRB, 0.171173E+01_JPRB, 0.172017E+01_JPRB &
  &, 0.172806E+01_JPRB, 0.173540E+01_JPRB, 0.174219E+01_JPRB &
  &, 0.174841E+01_JPRB, 0.175407E+01_JPRB, 0.175917E+01_JPRB, 0.176371E+01_JPRB &
  &, 0.176768E+01_JPRB, 0.177108E+01_JPRB, 0.177392E+01_JPRB &
  &, 0.177620E+01_JPRB, 0.177791E+01_JPRB, 0.177905E+01_JPRB, 0.177963E+01_JPRB &
  &, 0.177967E+01_JPRB, 0.177915E+01_JPRB, 0.177806E+01_JPRB &
  &, 0.177642E+01_JPRB, 0.177428E+01_JPRB, 0.177158E+01_JPRB, 0.176834E+01_JPRB &
  &, 0.176457E+01_JPRB, 0.176028E+01_JPRB, 0.175549E+01_JPRB &
  &, 0.175018E+01_JPRB, 0.174437E+01_JPRB, 0.173807E+01_JPRB, 0.173126E+01_JPRB &
  &, 0.172399E+01_JPRB, 0.171625E+01_JPRB, 0.170806E+01_JPRB &
  &, 0.169940E+01_JPRB, 0.169029E+01_JPRB, 0.168075E+01_JPRB, 0.167080E+01_JPRB &
  &, 0.166040E+01_JPRB, 0.164963E+01_JPRB, 0.163845E+01_JPRB &
  &, 0.162689E+01_JPRB, 0.161493E+01_JPRB, 0.160264E+01_JPRB, 0.158997E+01_JPRB &
  &, 0.157696E+01_JPRB, 0.156363E+01_JPRB, 0.154998E+01_JPRB &
  &, 0.153601E+01_JPRB, 0.152175E+01_JPRB, 0.150720E+01_JPRB, 0.149236E+01_JPRB &
  &, 0.147729E+01_JPRB, 0.146193E+01_JPRB, 0.144636E+01_JPRB &
  &, 0.143054E+01_JPRB, 0.141451E+01_JPRB, 0.139828E+01_JPRB, 0.138184E+01_JPRB &
  &, 0.136523E+01_JPRB, 0.134844E+01_JPRB, 0.133150E+01_JPRB &
  &, 0.131441E+01_JPRB, 0.129716E+01_JPRB, 0.127982E+01_JPRB, 0.126234E+01_JPRB &
  &, 0.124477E+01_JPRB, 0.122711E+01_JPRB, 0.120934E+01_JPRB &
  &, 0.119152E+01_JPRB, 0.117364E+01_JPRB, 0.115574E+01_JPRB, 0.113775E+01_JPRB &
  &, 0.111979E+01_JPRB, 0.110176E+01_JPRB, 0.108375E+01_JPRB &
  &, 0.106573E+01_JPRB, 0.104768E+01_JPRB, 0.102973E+01_JPRB, 0.101177E+01_JPRB &
  &, 0.993834E+00_JPRB, 0.975938E+00_JPRB, 0.958166E+00_JPRB &
  &, 0.940399E+00_JPRB, 0.922715E+00_JPRB, 0.905140E+00_JPRB, 0.887601E+00_JPRB &
  &, 0.870228E+00_JPRB, 0.852891E+00_JPRB, 0.835723E+00_JPRB &
  &, 0.818644E+00_JPRB, 0.801678E+00_JPRB, 0.784852E+00_JPRB, 0.768191E+00_JPRB &
  &, 0.751665E+00_JPRB, 0.735299E+00_JPRB, 0.719058E+00_JPRB &
  &, 0.702966E+00_JPRB, 0.687109E+00_JPRB, 0.671389E+00_JPRB, 0.655828E+00_JPRB &
  &, 0.640450E+00_JPRB, 0.625277E+00_JPRB, 0.610269E+00_JPRB/)
XCW( 819, :) = (/ &
  &  0.109036E+01_JPRB, 0.111267E+01_JPRB, 0.113483E+01_JPRB, 0.115684E+01_JPRB &
  &, 0.117867E+01_JPRB, 0.120032E+01_JPRB, 0.122177E+01_JPRB &
  &, 0.124300E+01_JPRB, 0.126401E+01_JPRB, 0.128478E+01_JPRB, 0.130529E+01_JPRB &
  &, 0.132553E+01_JPRB, 0.134549E+01_JPRB, 0.136516E+01_JPRB &
  &, 0.138452E+01_JPRB, 0.140356E+01_JPRB, 0.142226E+01_JPRB, 0.144062E+01_JPRB &
  &, 0.145862E+01_JPRB, 0.147624E+01_JPRB, 0.149348E+01_JPRB &
  &, 0.151032E+01_JPRB, 0.152675E+01_JPRB, 0.154278E+01_JPRB, 0.155836E+01_JPRB &
  &, 0.157351E+01_JPRB, 0.158820E+01_JPRB, 0.160243E+01_JPRB &
  &, 0.161619E+01_JPRB, 0.162946E+01_JPRB, 0.164225E+01_JPRB, 0.165454E+01_JPRB &
  &, 0.166633E+01_JPRB, 0.167759E+01_JPRB, 0.168835E+01_JPRB &
  &, 0.169857E+01_JPRB, 0.170825E+01_JPRB, 0.171740E+01_JPRB, 0.172601E+01_JPRB &
  &, 0.173407E+01_JPRB, 0.174157E+01_JPRB, 0.174851E+01_JPRB &
  &, 0.175490E+01_JPRB, 0.176073E+01_JPRB, 0.176599E+01_JPRB, 0.177069E+01_JPRB &
  &, 0.177482E+01_JPRB, 0.177838E+01_JPRB, 0.178139E+01_JPRB &
  &, 0.178381E+01_JPRB, 0.178569E+01_JPRB, 0.178698E+01_JPRB, 0.178772E+01_JPRB &
  &, 0.178792E+01_JPRB, 0.178754E+01_JPRB, 0.178662E+01_JPRB &
  &, 0.178515E+01_JPRB, 0.178313E+01_JPRB, 0.178057E+01_JPRB, 0.177747E+01_JPRB &
  &, 0.177385E+01_JPRB, 0.176971E+01_JPRB, 0.176504E+01_JPRB &
  &, 0.175987E+01_JPRB, 0.175420E+01_JPRB, 0.174802E+01_JPRB, 0.174137E+01_JPRB &
  &, 0.173422E+01_JPRB, 0.172660E+01_JPRB, 0.171853E+01_JPRB &
  &, 0.170998E+01_JPRB, 0.170099E+01_JPRB, 0.169156E+01_JPRB, 0.168173E+01_JPRB &
  &, 0.167144E+01_JPRB, 0.166077E+01_JPRB, 0.164968E+01_JPRB &
  &, 0.163822E+01_JPRB, 0.162636E+01_JPRB, 0.161415E+01_JPRB, 0.160158E+01_JPRB &
  &, 0.158867E+01_JPRB, 0.157540E+01_JPRB, 0.156184E+01_JPRB &
  &, 0.154793E+01_JPRB, 0.153375E+01_JPRB, 0.151925E+01_JPRB, 0.150449E+01_JPRB &
  &, 0.148946E+01_JPRB, 0.147417E+01_JPRB, 0.145865E+01_JPRB &
  &, 0.144289E+01_JPRB, 0.142689E+01_JPRB, 0.141068E+01_JPRB, 0.139430E+01_JPRB &
  &, 0.137770E+01_JPRB, 0.136095E+01_JPRB, 0.134402E+01_JPRB &
  &, 0.132693E+01_JPRB, 0.130971E+01_JPRB, 0.129236E+01_JPRB, 0.127491E+01_JPRB &
  &, 0.125735E+01_JPRB, 0.123968E+01_JPRB, 0.122192E+01_JPRB &
  &, 0.120410E+01_JPRB, 0.118618E+01_JPRB, 0.116827E+01_JPRB, 0.115026E+01_JPRB &
  &, 0.113225E+01_JPRB, 0.111421E+01_JPRB, 0.109612E+01_JPRB &
  &, 0.107807E+01_JPRB, 0.106003E+01_JPRB, 0.104199E+01_JPRB, 0.102399E+01_JPRB &
  &, 0.100599E+01_JPRB, 0.988087E+00_JPRB, 0.970202E+00_JPRB &
  &, 0.952365E+00_JPRB, 0.934654E+00_JPRB, 0.916947E+00_JPRB, 0.899371E+00_JPRB &
  &, 0.881904E+00_JPRB, 0.864521E+00_JPRB, 0.847248E+00_JPRB &
  &, 0.830057E+00_JPRB, 0.813028E+00_JPRB, 0.796134E+00_JPRB, 0.779343E+00_JPRB &
  &, 0.762739E+00_JPRB, 0.746230E+00_JPRB, 0.729898E+00_JPRB &
  &, 0.713711E+00_JPRB, 0.697753E+00_JPRB, 0.681863E+00_JPRB, 0.666253E+00_JPRB &
  &, 0.650757E+00_JPRB, 0.635461E+00_JPRB, 0.620323E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART117',1,ZHOOK_HANDLE)
END SUBROUTINE PART117

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART118

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART118',0,ZHOOK_HANDLE)

XCW( 820, :) = (/ &
  &  0.109077E+01_JPRB, 0.111318E+01_JPRB, 0.113545E+01_JPRB, 0.115757E+01_JPRB &
  &, 0.117952E+01_JPRB, 0.120129E+01_JPRB, 0.122285E+01_JPRB &
  &, 0.124421E+01_JPRB, 0.126535E+01_JPRB, 0.128624E+01_JPRB, 0.130688E+01_JPRB &
  &, 0.132726E+01_JPRB, 0.134735E+01_JPRB, 0.136716E+01_JPRB &
  &, 0.138666E+01_JPRB, 0.140583E+01_JPRB, 0.142468E+01_JPRB, 0.144318E+01_JPRB &
  &, 0.146132E+01_JPRB, 0.147909E+01_JPRB, 0.149648E+01_JPRB &
  &, 0.151347E+01_JPRB, 0.153006E+01_JPRB, 0.154623E+01_JPRB, 0.156197E+01_JPRB &
  &, 0.157727E+01_JPRB, 0.159212E+01_JPRB, 0.160651E+01_JPRB &
  &, 0.162043E+01_JPRB, 0.163387E+01_JPRB, 0.164681E+01_JPRB, 0.165927E+01_JPRB &
  &, 0.167121E+01_JPRB, 0.168265E+01_JPRB, 0.169356E+01_JPRB &
  &, 0.170394E+01_JPRB, 0.171379E+01_JPRB, 0.172310E+01_JPRB, 0.173187E+01_JPRB &
  &, 0.174010E+01_JPRB, 0.174776E+01_JPRB, 0.175488E+01_JPRB &
  &, 0.176143E+01_JPRB, 0.176742E+01_JPRB, 0.177284E+01_JPRB, 0.177771E+01_JPRB &
  &, 0.178200E+01_JPRB, 0.178573E+01_JPRB, 0.178889E+01_JPRB &
  &, 0.179148E+01_JPRB, 0.179351E+01_JPRB, 0.179497E+01_JPRB, 0.179587E+01_JPRB &
  &, 0.179621E+01_JPRB, 0.179599E+01_JPRB, 0.179522E+01_JPRB &
  &, 0.179390E+01_JPRB, 0.179204E+01_JPRB, 0.178962E+01_JPRB, 0.178668E+01_JPRB &
  &, 0.178321E+01_JPRB, 0.177920E+01_JPRB, 0.177468E+01_JPRB &
  &, 0.176963E+01_JPRB, 0.176411E+01_JPRB, 0.175807E+01_JPRB, 0.175152E+01_JPRB &
  &, 0.174451E+01_JPRB, 0.173703E+01_JPRB, 0.172906E+01_JPRB &
  &, 0.172065E+01_JPRB, 0.171177E+01_JPRB, 0.170246E+01_JPRB, 0.169272E+01_JPRB &
  &, 0.168257E+01_JPRB, 0.167199E+01_JPRB, 0.166102E+01_JPRB &
  &, 0.164965E+01_JPRB, 0.163790E+01_JPRB, 0.162576E+01_JPRB, 0.161330E+01_JPRB &
  &, 0.160045E+01_JPRB, 0.158728E+01_JPRB, 0.157378E+01_JPRB &
  &, 0.155996E+01_JPRB, 0.154584E+01_JPRB, 0.153142E+01_JPRB, 0.151671E+01_JPRB &
  &, 0.150176E+01_JPRB, 0.148651E+01_JPRB, 0.147103E+01_JPRB &
  &, 0.145533E+01_JPRB, 0.143936E+01_JPRB, 0.142321E+01_JPRB, 0.140685E+01_JPRB &
  &, 0.139031E+01_JPRB, 0.137357E+01_JPRB, 0.135668E+01_JPRB &
  &, 0.133959E+01_JPRB, 0.132241E+01_JPRB, 0.130509E+01_JPRB, 0.128763E+01_JPRB &
  &, 0.127005E+01_JPRB, 0.125239E+01_JPRB, 0.123460E+01_JPRB &
  &, 0.121676E+01_JPRB, 0.119888E+01_JPRB, 0.118092E+01_JPRB, 0.116274E+01_JPRB &
  &, 0.114484E+01_JPRB, 0.112678E+01_JPRB, 0.110867E+01_JPRB &
  &, 0.109058E+01_JPRB, 0.107247E+01_JPRB, 0.105439E+01_JPRB, 0.103634E+01_JPRB &
  &, 0.101834E+01_JPRB, 0.100033E+01_JPRB, 0.982385E+00_JPRB &
  &, 0.964530E+00_JPRB, 0.946695E+00_JPRB, 0.928959E+00_JPRB, 0.911298E+00_JPRB &
  &, 0.893740E+00_JPRB, 0.876259E+00_JPRB, 0.858936E+00_JPRB &
  &, 0.841690E+00_JPRB, 0.824546E+00_JPRB, 0.807530E+00_JPRB, 0.790668E+00_JPRB &
  &, 0.773929E+00_JPRB, 0.757337E+00_JPRB, 0.740918E+00_JPRB &
  &, 0.724638E+00_JPRB, 0.708519E+00_JPRB, 0.692587E+00_JPRB, 0.676804E+00_JPRB &
  &, 0.661192E+00_JPRB, 0.645774E+00_JPRB, 0.630508E+00_JPRB/)
XCW( 821, :) = (/ &
  &  0.109117E+01_JPRB, 0.111369E+01_JPRB, 0.113608E+01_JPRB, 0.115831E+01_JPRB &
  &, 0.118037E+01_JPRB, 0.120226E+01_JPRB, 0.122395E+01_JPRB &
  &, 0.124543E+01_JPRB, 0.126669E+01_JPRB, 0.128771E+01_JPRB, 0.130848E+01_JPRB &
  &, 0.132899E+01_JPRB, 0.134922E+01_JPRB, 0.136916E+01_JPRB &
  &, 0.138880E+01_JPRB, 0.140812E+01_JPRB, 0.142711E+01_JPRB, 0.144575E+01_JPRB &
  &, 0.146404E+01_JPRB, 0.148196E+01_JPRB, 0.149950E+01_JPRB &
  &, 0.151664E+01_JPRB, 0.153338E+01_JPRB, 0.154971E+01_JPRB, 0.156560E+01_JPRB &
  &, 0.158106E+01_JPRB, 0.159607E+01_JPRB, 0.161061E+01_JPRB &
  &, 0.162469E+01_JPRB, 0.163829E+01_JPRB, 0.165140E+01_JPRB, 0.166402E+01_JPRB &
  &, 0.167613E+01_JPRB, 0.168772E+01_JPRB, 0.169880E+01_JPRB &
  &, 0.170935E+01_JPRB, 0.171876E+01_JPRB, 0.172884E+01_JPRB, 0.173778E+01_JPRB &
  &, 0.174616E+01_JPRB, 0.175400E+01_JPRB, 0.176128E+01_JPRB &
  &, 0.176799E+01_JPRB, 0.177416E+01_JPRB, 0.177974E+01_JPRB, 0.178477E+01_JPRB &
  &, 0.178923E+01_JPRB, 0.179312E+01_JPRB, 0.179643E+01_JPRB &
  &, 0.179919E+01_JPRB, 0.180138E+01_JPRB, 0.180300E+01_JPRB, 0.180407E+01_JPRB &
  &, 0.180455E+01_JPRB, 0.180449E+01_JPRB, 0.180388E+01_JPRB &
  &, 0.180271E+01_JPRB, 0.180100E+01_JPRB, 0.179874E+01_JPRB, 0.179594E+01_JPRB &
  &, 0.179261E+01_JPRB, 0.178875E+01_JPRB, 0.178437E+01_JPRB &
  &, 0.177949E+01_JPRB, 0.177407E+01_JPRB, 0.176817E+01_JPRB, 0.176177E+01_JPRB &
  &, 0.175488E+01_JPRB, 0.174752E+01_JPRB, 0.173969E+01_JPRB &
  &, 0.173139E+01_JPRB, 0.172265E+01_JPRB, 0.171346E+01_JPRB, 0.170383E+01_JPRB &
  &, 0.169377E+01_JPRB, 0.168330E+01_JPRB, 0.167244E+01_JPRB &
  &, 0.166108E+01_JPRB, 0.164951E+01_JPRB, 0.163747E+01_JPRB, 0.162508E+01_JPRB &
  &, 0.161234E+01_JPRB, 0.159926E+01_JPRB, 0.158583E+01_JPRB &
  &, 0.157210E+01_JPRB, 0.155804E+01_JPRB, 0.154371E+01_JPRB, 0.152905E+01_JPRB &
  &, 0.151415E+01_JPRB, 0.149898E+01_JPRB, 0.148356E+01_JPRB &
  &, 0.146787E+01_JPRB, 0.145197E+01_JPRB, 0.143585E+01_JPRB, 0.141954E+01_JPRB &
  &, 0.140301E+01_JPRB, 0.138633E+01_JPRB, 0.136945E+01_JPRB &
  &, 0.135240E+01_JPRB, 0.133522E+01_JPRB, 0.131789E+01_JPRB, 0.130046E+01_JPRB &
  &, 0.128287E+01_JPRB, 0.126523E+01_JPRB, 0.124745E+01_JPRB &
  &, 0.122961E+01_JPRB, 0.121166E+01_JPRB, 0.119370E+01_JPRB, 0.117568E+01_JPRB &
  &, 0.115760E+01_JPRB, 0.113948E+01_JPRB, 0.112135E+01_JPRB &
  &, 0.110324E+01_JPRB, 0.108509E+01_JPRB, 0.106698E+01_JPRB, 0.104888E+01_JPRB &
  &, 0.103079E+01_JPRB, 0.101258E+01_JPRB, 0.994765E+00_JPRB &
  &, 0.976795E+00_JPRB, 0.958939E+00_JPRB, 0.941125E+00_JPRB, 0.923381E+00_JPRB &
  &, 0.905734E+00_JPRB, 0.888211E+00_JPRB, 0.870787E+00_JPRB &
  &, 0.853434E+00_JPRB, 0.836232E+00_JPRB, 0.819096E+00_JPRB, 0.802165E+00_JPRB &
  &, 0.785352E+00_JPRB, 0.768622E+00_JPRB, 0.752118E+00_JPRB &
  &, 0.735686E+00_JPRB, 0.719471E+00_JPRB, 0.703436E+00_JPRB, 0.687545E+00_JPRB &
  &, 0.671819E+00_JPRB, 0.656281E+00_JPRB, 0.640891E+00_JPRB/)
XCW( 822, :) = (/ &
  &  0.109158E+01_JPRB, 0.111421E+01_JPRB, 0.113670E+01_JPRB, 0.115905E+01_JPRB &
  &, 0.118123E+01_JPRB, 0.120323E+01_JPRB, 0.122504E+01_JPRB &
  &, 0.124665E+01_JPRB, 0.126803E+01_JPRB, 0.128919E+01_JPRB, 0.131009E+01_JPRB &
  &, 0.133073E+01_JPRB, 0.135110E+01_JPRB, 0.137118E+01_JPRB &
  &, 0.139095E+01_JPRB, 0.141041E+01_JPRB, 0.142954E+01_JPRB, 0.144833E+01_JPRB &
  &, 0.146677E+01_JPRB, 0.148484E+01_JPRB, 0.150253E+01_JPRB &
  &, 0.151982E+01_JPRB, 0.153672E+01_JPRB, 0.155320E+01_JPRB, 0.156925E+01_JPRB &
  &, 0.158486E+01_JPRB, 0.160003E+01_JPRB, 0.161474E+01_JPRB &
  &, 0.162898E+01_JPRB, 0.164274E+01_JPRB, 0.165601E+01_JPRB, 0.166879E+01_JPRB &
  &, 0.168106E+01_JPRB, 0.169283E+01_JPRB, 0.170407E+01_JPRB &
  &, 0.171478E+01_JPRB, 0.172497E+01_JPRB, 0.173461E+01_JPRB, 0.174371E+01_JPRB &
  &, 0.175227E+01_JPRB, 0.176027E+01_JPRB, 0.176772E+01_JPRB &
  &, 0.177460E+01_JPRB, 0.178092E+01_JPRB, 0.178668E+01_JPRB, 0.179187E+01_JPRB &
  &, 0.179649E+01_JPRB, 0.180055E+01_JPRB, 0.180404E+01_JPRB &
  &, 0.180695E+01_JPRB, 0.180931E+01_JPRB, 0.181109E+01_JPRB, 0.181231E+01_JPRB &
  &, 0.181296E+01_JPRB, 0.181306E+01_JPRB, 0.181260E+01_JPRB &
  &, 0.181159E+01_JPRB, 0.181002E+01_JPRB, 0.180791E+01_JPRB, 0.180527E+01_JPRB &
  &, 0.180208E+01_JPRB, 0.179837E+01_JPRB, 0.179413E+01_JPRB &
  &, 0.178938E+01_JPRB, 0.178412E+01_JPRB, 0.177835E+01_JPRB, 0.177210E+01_JPRB &
  &, 0.176533E+01_JPRB, 0.175810E+01_JPRB, 0.175039E+01_JPRB &
  &, 0.174223E+01_JPRB, 0.173361E+01_JPRB, 0.172453E+01_JPRB, 0.171500E+01_JPRB &
  &, 0.170508E+01_JPRB, 0.169473E+01_JPRB, 0.168396E+01_JPRB &
  &, 0.167278E+01_JPRB, 0.166124E+01_JPRB, 0.164929E+01_JPRB, 0.163700E+01_JPRB &
  &, 0.162433E+01_JPRB, 0.161133E+01_JPRB, 0.159799E+01_JPRB &
  &, 0.158433E+01_JPRB, 0.157036E+01_JPRB, 0.155608E+01_JPRB, 0.154151E+01_JPRB &
  &, 0.152666E+01_JPRB, 0.151156E+01_JPRB, 0.149613E+01_JPRB &
  &, 0.148057E+01_JPRB, 0.146470E+01_JPRB, 0.144864E+01_JPRB, 0.143233E+01_JPRB &
  &, 0.141586E+01_JPRB, 0.139919E+01_JPRB, 0.138236E+01_JPRB &
  &, 0.136532E+01_JPRB, 0.134817E+01_JPRB, 0.133084E+01_JPRB, 0.131340E+01_JPRB &
  &, 0.129583E+01_JPRB, 0.127818E+01_JPRB, 0.126042E+01_JPRB &
  &, 0.124255E+01_JPRB, 0.122464E+01_JPRB, 0.120664E+01_JPRB, 0.118858E+01_JPRB &
  &, 0.117049E+01_JPRB, 0.115235E+01_JPRB, 0.113420E+01_JPRB &
  &, 0.111603E+01_JPRB, 0.109785E+01_JPRB, 0.107970E+01_JPRB, 0.106156E+01_JPRB &
  &, 0.104342E+01_JPRB, 0.102531E+01_JPRB, 0.100724E+01_JPRB &
  &, 0.989259E+00_JPRB, 0.971334E+00_JPRB, 0.953445E+00_JPRB, 0.935621E+00_JPRB &
  &, 0.917939E+00_JPRB, 0.900217E+00_JPRB, 0.882747E+00_JPRB &
  &, 0.865343E+00_JPRB, 0.848029E+00_JPRB, 0.830832E+00_JPRB, 0.813777E+00_JPRB &
  &, 0.796892E+00_JPRB, 0.780084E+00_JPRB, 0.763437E+00_JPRB &
  &, 0.746977E+00_JPRB, 0.730606E+00_JPRB, 0.714472E+00_JPRB, 0.698412E+00_JPRB &
  &, 0.682574E+00_JPRB, 0.666919E+00_JPRB, 0.651470E+00_JPRB/)
XCW( 823, :) = (/ &
  &  0.109199E+01_JPRB, 0.111472E+01_JPRB, 0.113733E+01_JPRB, 0.115979E+01_JPRB &
  &, 0.118209E+01_JPRB, 0.120421E+01_JPRB, 0.122615E+01_JPRB &
  &, 0.124788E+01_JPRB, 0.126939E+01_JPRB, 0.129067E+01_JPRB, 0.131170E+01_JPRB &
  &, 0.133248E+01_JPRB, 0.135298E+01_JPRB, 0.137320E+01_JPRB &
  &, 0.139312E+01_JPRB, 0.141272E+01_JPRB, 0.143200E+01_JPRB, 0.145093E+01_JPRB &
  &, 0.146951E+01_JPRB, 0.148773E+01_JPRB, 0.150557E+01_JPRB &
  &, 0.152302E+01_JPRB, 0.154007E+01_JPRB, 0.155671E+01_JPRB, 0.157292E+01_JPRB &
  &, 0.158869E+01_JPRB, 0.160401E+01_JPRB, 0.161888E+01_JPRB &
  &, 0.163329E+01_JPRB, 0.164721E+01_JPRB, 0.166065E+01_JPRB, 0.167359E+01_JPRB &
  &, 0.168603E+01_JPRB, 0.169796E+01_JPRB, 0.170937E+01_JPRB &
  &, 0.172025E+01_JPRB, 0.173060E+01_JPRB, 0.174041E+01_JPRB, 0.174969E+01_JPRB &
  &, 0.175841E+01_JPRB, 0.176657E+01_JPRB, 0.177419E+01_JPRB &
  &, 0.178124E+01_JPRB, 0.178773E+01_JPRB, 0.179366E+01_JPRB, 0.179902E+01_JPRB &
  &, 0.180381E+01_JPRB, 0.180803E+01_JPRB, 0.181168E+01_JPRB &
  &, 0.181477E+01_JPRB, 0.181727E+01_JPRB, 0.181922E+01_JPRB, 0.182061E+01_JPRB &
  &, 0.182142E+01_JPRB, 0.182168E+01_JPRB, 0.182137E+01_JPRB &
  &, 0.182051E+01_JPRB, 0.181911E+01_JPRB, 0.181716E+01_JPRB, 0.181465E+01_JPRB &
  &, 0.181162E+01_JPRB, 0.180806E+01_JPRB, 0.180397E+01_JPRB &
  &, 0.179936E+01_JPRB, 0.179423E+01_JPRB, 0.178861E+01_JPRB, 0.178248E+01_JPRB &
  &, 0.177586E+01_JPRB, 0.176875E+01_JPRB, 0.176119E+01_JPRB &
  &, 0.175313E+01_JPRB, 0.174463E+01_JPRB, 0.173568E+01_JPRB, 0.172629E+01_JPRB &
  &, 0.171646E+01_JPRB, 0.170622E+01_JPRB, 0.169555E+01_JPRB &
  &, 0.168450E+01_JPRB, 0.167305E+01_JPRB, 0.166120E+01_JPRB, 0.164900E+01_JPRB &
  &, 0.163643E+01_JPRB, 0.162353E+01_JPRB, 0.161026E+01_JPRB &
  &, 0.159669E+01_JPRB, 0.158278E+01_JPRB, 0.156857E+01_JPRB, 0.155408E+01_JPRB &
  &, 0.153928E+01_JPRB, 0.152424E+01_JPRB, 0.150891E+01_JPRB &
  &, 0.149336E+01_JPRB, 0.147756E+01_JPRB, 0.146150E+01_JPRB, 0.144529E+01_JPRB &
  &, 0.142884E+01_JPRB, 0.141219E+01_JPRB, 0.139537E+01_JPRB &
  &, 0.137837E+01_JPRB, 0.136123E+01_JPRB, 0.134394E+01_JPRB, 0.132649E+01_JPRB &
  &, 0.130896E+01_JPRB, 0.129128E+01_JPRB, 0.127354E+01_JPRB &
  &, 0.125565E+01_JPRB, 0.123771E+01_JPRB, 0.121971E+01_JPRB, 0.120165E+01_JPRB &
  &, 0.118355E+01_JPRB, 0.116536E+01_JPRB, 0.114719E+01_JPRB &
  &, 0.112899E+01_JPRB, 0.111079E+01_JPRB, 0.109256E+01_JPRB, 0.107439E+01_JPRB &
  &, 0.105620E+01_JPRB, 0.103804E+01_JPRB, 0.101992E+01_JPRB &
  &, 0.100187E+01_JPRB, 0.983881E+00_JPRB, 0.965920E+00_JPRB, 0.948068E+00_JPRB &
  &, 0.930250E+00_JPRB, 0.912544E+00_JPRB, 0.894924E+00_JPRB &
  &, 0.877417E+00_JPRB, 0.860050E+00_JPRB, 0.842738E+00_JPRB, 0.825619E+00_JPRB &
  &, 0.808606E+00_JPRB, 0.791723E+00_JPRB, 0.774936E+00_JPRB &
  &, 0.758328E+00_JPRB, 0.741927E+00_JPRB, 0.725633E+00_JPRB, 0.709532E+00_JPRB &
  &, 0.693585E+00_JPRB, 0.677751E+00_JPRB, 0.662181E+00_JPRB/)
XCW( 824, :) = (/ &
  &  0.109240E+01_JPRB, 0.111524E+01_JPRB, 0.113796E+01_JPRB, 0.116054E+01_JPRB &
  &, 0.118295E+01_JPRB, 0.120520E+01_JPRB, 0.122725E+01_JPRB &
  &, 0.124911E+01_JPRB, 0.127075E+01_JPRB, 0.129216E+01_JPRB, 0.131333E+01_JPRB &
  &, 0.133424E+01_JPRB, 0.135488E+01_JPRB, 0.137523E+01_JPRB &
  &, 0.139529E+01_JPRB, 0.141503E+01_JPRB, 0.143446E+01_JPRB, 0.145354E+01_JPRB &
  &, 0.147227E+01_JPRB, 0.149064E+01_JPRB, 0.150863E+01_JPRB &
  &, 0.152624E+01_JPRB, 0.154344E+01_JPRB, 0.156023E+01_JPRB, 0.157660E+01_JPRB &
  &, 0.159253E+01_JPRB, 0.160802E+01_JPRB, 0.162305E+01_JPRB &
  &, 0.163761E+01_JPRB, 0.165170E+01_JPRB, 0.166531E+01_JPRB, 0.167841E+01_JPRB &
  &, 0.169102E+01_JPRB, 0.170312E+01_JPRB, 0.171470E+01_JPRB &
  &, 0.172574E+01_JPRB, 0.173627E+01_JPRB, 0.174625E+01_JPRB, 0.175569E+01_JPRB &
  &, 0.176458E+01_JPRB, 0.177292E+01_JPRB, 0.178070E+01_JPRB &
  &, 0.178793E+01_JPRB, 0.179459E+01_JPRB, 0.180068E+01_JPRB, 0.180621E+01_JPRB &
  &, 0.181116E+01_JPRB, 0.181555E+01_JPRB, 0.181938E+01_JPRB &
  &, 0.182262E+01_JPRB, 0.182530E+01_JPRB, 0.182741E+01_JPRB, 0.182895E+01_JPRB &
  &, 0.182993E+01_JPRB, 0.183035E+01_JPRB, 0.183021E+01_JPRB &
  &, 0.182949E+01_JPRB, 0.182826E+01_JPRB, 0.182645E+01_JPRB, 0.182411E+01_JPRB &
  &, 0.182123E+01_JPRB, 0.181781E+01_JPRB, 0.181387E+01_JPRB &
  &, 0.180941E+01_JPRB, 0.180443E+01_JPRB, 0.179894E+01_JPRB, 0.179296E+01_JPRB &
  &, 0.178647E+01_JPRB, 0.177951E+01_JPRB, 0.177205E+01_JPRB &
  &, 0.176414E+01_JPRB, 0.175574E+01_JPRB, 0.174691E+01_JPRB, 0.173764E+01_JPRB &
  &, 0.172794E+01_JPRB, 0.171781E+01_JPRB, 0.170725E+01_JPRB &
  &, 0.169630E+01_JPRB, 0.168496E+01_JPRB, 0.167322E+01_JPRB, 0.166110E+01_JPRB &
  &, 0.164863E+01_JPRB, 0.163581E+01_JPRB, 0.162264E+01_JPRB &
  &, 0.160914E+01_JPRB, 0.159530E+01_JPRB, 0.158118E+01_JPRB, 0.156674E+01_JPRB &
  &, 0.155203E+01_JPRB, 0.153703E+01_JPRB, 0.152178E+01_JPRB &
  &, 0.150628E+01_JPRB, 0.149052E+01_JPRB, 0.147453E+01_JPRB, 0.145834E+01_JPRB &
  &, 0.144192E+01_JPRB, 0.142532E+01_JPRB, 0.140852E+01_JPRB &
  &, 0.139157E+01_JPRB, 0.137444E+01_JPRB, 0.135715E+01_JPRB, 0.133974E+01_JPRB &
  &, 0.132219E+01_JPRB, 0.130454E+01_JPRB, 0.128678E+01_JPRB &
  &, 0.126890E+01_JPRB, 0.125097E+01_JPRB, 0.123294E+01_JPRB, 0.121484E+01_JPRB &
  &, 0.119674E+01_JPRB, 0.117854E+01_JPRB, 0.116032E+01_JPRB &
  &, 0.114210E+01_JPRB, 0.112386E+01_JPRB, 0.110561E+01_JPRB, 0.108735E+01_JPRB &
  &, 0.106913E+01_JPRB, 0.105091E+01_JPRB, 0.103274E+01_JPRB &
  &, 0.101464E+01_JPRB, 0.996579E+00_JPRB, 0.978548E+00_JPRB, 0.960620E+00_JPRB &
  &, 0.942719E+00_JPRB, 0.924978E+00_JPRB, 0.907264E+00_JPRB &
  &, 0.889657E+00_JPRB, 0.872183E+00_JPRB, 0.854815E+00_JPRB, 0.837576E+00_JPRB &
  &, 0.820437E+00_JPRB, 0.803481E+00_JPRB, 0.786615E+00_JPRB &
  &, 0.769923E+00_JPRB, 0.753370E+00_JPRB, 0.736980E+00_JPRB, 0.720778E+00_JPRB &
  &, 0.704660E+00_JPRB, 0.688777E+00_JPRB, 0.673089E+00_JPRB/)
XCW( 825, :) = (/ &
  &  0.109281E+01_JPRB, 0.111576E+01_JPRB, 0.113860E+01_JPRB, 0.116129E+01_JPRB &
  &, 0.118382E+01_JPRB, 0.120618E+01_JPRB, 0.122836E+01_JPRB &
  &, 0.125034E+01_JPRB, 0.127211E+01_JPRB, 0.129365E+01_JPRB, 0.131495E+01_JPRB &
  &, 0.133600E+01_JPRB, 0.135678E+01_JPRB, 0.137727E+01_JPRB &
  &, 0.139747E+01_JPRB, 0.141736E+01_JPRB, 0.143693E+01_JPRB, 0.145616E+01_JPRB &
  &, 0.147504E+01_JPRB, 0.149356E+01_JPRB, 0.151171E+01_JPRB &
  &, 0.152947E+01_JPRB, 0.154683E+01_JPRB, 0.156378E+01_JPRB, 0.158030E+01_JPRB &
  &, 0.159640E+01_JPRB, 0.161205E+01_JPRB, 0.162724E+01_JPRB &
  &, 0.164197E+01_JPRB, 0.165622E+01_JPRB, 0.166999E+01_JPRB, 0.168327E+01_JPRB &
  &, 0.169604E+01_JPRB, 0.170831E+01_JPRB, 0.172005E+01_JPRB &
  &, 0.173127E+01_JPRB, 0.174196E+01_JPRB, 0.175211E+01_JPRB, 0.176173E+01_JPRB &
  &, 0.177079E+01_JPRB, 0.177930E+01_JPRB, 0.178726E+01_JPRB &
  &, 0.179465E+01_JPRB, 0.180148E+01_JPRB, 0.180775E+01_JPRB, 0.181344E+01_JPRB &
  &, 0.181857E+01_JPRB, 0.182313E+01_JPRB, 0.182711E+01_JPRB &
  &, 0.183053E+01_JPRB, 0.183336E+01_JPRB, 0.183565E+01_JPRB, 0.183736E+01_JPRB &
  &, 0.183850E+01_JPRB, 0.183908E+01_JPRB, 0.183910E+01_JPRB &
  &, 0.183857E+01_JPRB, 0.183747E+01_JPRB, 0.183583E+01_JPRB, 0.183364E+01_JPRB &
  &, 0.183091E+01_JPRB, 0.182764E+01_JPRB, 0.182385E+01_JPRB &
  &, 0.181954E+01_JPRB, 0.181469E+01_JPRB, 0.180935E+01_JPRB, 0.180350E+01_JPRB &
  &, 0.179716E+01_JPRB, 0.179032E+01_JPRB, 0.178299E+01_JPRB &
  &, 0.177521E+01_JPRB, 0.176696E+01_JPRB, 0.175826E+01_JPRB, 0.174909E+01_JPRB &
  &, 0.173950E+01_JPRB, 0.172948E+01_JPRB, 0.171906E+01_JPRB &
  &, 0.170819E+01_JPRB, 0.169696E+01_JPRB, 0.168532E+01_JPRB, 0.167330E+01_JPRB &
  &, 0.166094E+01_JPRB, 0.164819E+01_JPRB, 0.163510E+01_JPRB &
  &, 0.162170E+01_JPRB, 0.160795E+01_JPRB, 0.159389E+01_JPRB, 0.157952E+01_JPRB &
  &, 0.156490E+01_JPRB, 0.154995E+01_JPRB, 0.153475E+01_JPRB &
  &, 0.151929E+01_JPRB, 0.150361E+01_JPRB, 0.148769E+01_JPRB, 0.147153E+01_JPRB &
  &, 0.145514E+01_JPRB, 0.143857E+01_JPRB, 0.142182E+01_JPRB &
  &, 0.140488E+01_JPRB, 0.138779E+01_JPRB, 0.137051E+01_JPRB, 0.135313E+01_JPRB &
  &, 0.133558E+01_JPRB, 0.131792E+01_JPRB, 0.130018E+01_JPRB &
  &, 0.128228E+01_JPRB, 0.126437E+01_JPRB, 0.124630E+01_JPRB, 0.122820E+01_JPRB &
  &, 0.121006E+01_JPRB, 0.119185E+01_JPRB, 0.117361E+01_JPRB &
  &, 0.115533E+01_JPRB, 0.113708E+01_JPRB, 0.111879E+01_JPRB, 0.110050E+01_JPRB &
  &, 0.108224E+01_JPRB, 0.106398E+01_JPRB, 0.104576E+01_JPRB &
  &, 0.102755E+01_JPRB, 0.100943E+01_JPRB, 0.991330E+00_JPRB, 0.973328E+00_JPRB &
  &, 0.955400E+00_JPRB, 0.937520E+00_JPRB, 0.919768E+00_JPRB &
  &, 0.902117E+00_JPRB, 0.884540E+00_JPRB, 0.867061E+00_JPRB, 0.849706E+00_JPRB &
  &, 0.832502E+00_JPRB, 0.815416E+00_JPRB, 0.798473E+00_JPRB &
  &, 0.781700E+00_JPRB, 0.764998E+00_JPRB, 0.748515E+00_JPRB, 0.732150E+00_JPRB &
  &, 0.715991E+00_JPRB, 0.699998E+00_JPRB, 0.684129E+00_JPRB/)
XCW( 826, :) = (/ &
  &  0.109322E+01_JPRB, 0.111629E+01_JPRB, 0.113923E+01_JPRB, 0.116204E+01_JPRB &
  &, 0.118469E+01_JPRB, 0.120718E+01_JPRB, 0.122948E+01_JPRB &
  &, 0.125159E+01_JPRB, 0.127348E+01_JPRB, 0.129516E+01_JPRB, 0.131659E+01_JPRB &
  &, 0.133777E+01_JPRB, 0.135869E+01_JPRB, 0.137932E+01_JPRB &
  &, 0.139967E+01_JPRB, 0.141970E+01_JPRB, 0.143941E+01_JPRB, 0.145879E+01_JPRB &
  &, 0.147783E+01_JPRB, 0.149650E+01_JPRB, 0.151480E+01_JPRB &
  &, 0.153270E+01_JPRB, 0.155023E+01_JPRB, 0.156734E+01_JPRB, 0.158403E+01_JPRB &
  &, 0.160028E+01_JPRB, 0.161609E+01_JPRB, 0.163145E+01_JPRB &
  &, 0.164634E+01_JPRB, 0.166076E+01_JPRB, 0.167470E+01_JPRB, 0.168815E+01_JPRB &
  &, 0.170109E+01_JPRB, 0.171352E+01_JPRB, 0.172544E+01_JPRB &
  &, 0.173683E+01_JPRB, 0.174769E+01_JPRB, 0.175802E+01_JPRB, 0.176780E+01_JPRB &
  &, 0.177704E+01_JPRB, 0.178572E+01_JPRB, 0.179385E+01_JPRB &
  &, 0.180142E+01_JPRB, 0.180841E+01_JPRB, 0.181486E+01_JPRB, 0.182072E+01_JPRB &
  &, 0.182602E+01_JPRB, 0.183075E+01_JPRB, 0.183491E+01_JPRB &
  &, 0.183850E+01_JPRB, 0.184149E+01_JPRB, 0.184395E+01_JPRB, 0.184583E+01_JPRB &
  &, 0.184713E+01_JPRB, 0.184782E+01_JPRB, 0.184805E+01_JPRB &
  &, 0.184768E+01_JPRB, 0.184675E+01_JPRB, 0.184526E+01_JPRB, 0.184323E+01_JPRB &
  &, 0.184065E+01_JPRB, 0.183753E+01_JPRB, 0.183390E+01_JPRB &
  &, 0.182972E+01_JPRB, 0.182502E+01_JPRB, 0.181983E+01_JPRB, 0.181411E+01_JPRB &
  &, 0.180792E+01_JPRB, 0.180122E+01_JPRB, 0.179404E+01_JPRB &
  &, 0.178638E+01_JPRB, 0.177824E+01_JPRB, 0.176966E+01_JPRB, 0.176064E+01_JPRB &
  &, 0.175116E+01_JPRB, 0.174125E+01_JPRB, 0.173093E+01_JPRB &
  &, 0.172021E+01_JPRB, 0.170907E+01_JPRB, 0.169753E+01_JPRB, 0.168563E+01_JPRB &
  &, 0.167333E+01_JPRB, 0.166068E+01_JPRB, 0.164770E+01_JPRB &
  &, 0.163437E+01_JPRB, 0.162072E+01_JPRB, 0.160673E+01_JPRB, 0.159245E+01_JPRB &
  &, 0.157785E+01_JPRB, 0.156300E+01_JPRB, 0.154788E+01_JPRB &
  &, 0.153247E+01_JPRB, 0.151682E+01_JPRB, 0.150094E+01_JPRB, 0.148482E+01_JPRB &
  &, 0.146849E+01_JPRB, 0.145198E+01_JPRB, 0.143525E+01_JPRB &
  &, 0.141833E+01_JPRB, 0.140126E+01_JPRB, 0.138402E+01_JPRB, 0.136664E+01_JPRB &
  &, 0.134912E+01_JPRB, 0.133145E+01_JPRB, 0.131370E+01_JPRB &
  &, 0.129582E+01_JPRB, 0.127788E+01_JPRB, 0.125983E+01_JPRB, 0.124174E+01_JPRB &
  &, 0.122355E+01_JPRB, 0.120534E+01_JPRB, 0.118705E+01_JPRB &
  &, 0.116875E+01_JPRB, 0.115047E+01_JPRB, 0.113212E+01_JPRB, 0.111380E+01_JPRB &
  &, 0.109550E+01_JPRB, 0.107720E+01_JPRB, 0.105892E+01_JPRB &
  &, 0.104066E+01_JPRB, 0.102248E+01_JPRB, 0.100432E+01_JPRB, 0.986245E+00_JPRB &
  &, 0.968239E+00_JPRB, 0.950276E+00_JPRB, 0.932434E+00_JPRB &
  &, 0.914688E+00_JPRB, 0.897064E+00_JPRB, 0.879477E+00_JPRB, 0.862065E+00_JPRB &
  &, 0.844741E+00_JPRB, 0.827587E+00_JPRB, 0.810511E+00_JPRB &
  &, 0.793598E+00_JPRB, 0.776811E+00_JPRB, 0.760237E+00_JPRB, 0.743776E+00_JPRB &
  &, 0.727451E+00_JPRB, 0.711349E+00_JPRB, 0.695365E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART118',1,ZHOOK_HANDLE)
END SUBROUTINE PART118

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART119

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART119',0,ZHOOK_HANDLE)

XCW( 827, :) = (/ &
  &  0.109363E+01_JPRB, 0.111681E+01_JPRB, 0.113987E+01_JPRB, 0.116279E+01_JPRB &
  &, 0.118556E+01_JPRB, 0.120817E+01_JPRB, 0.123060E+01_JPRB &
  &, 0.125283E+01_JPRB, 0.127486E+01_JPRB, 0.129667E+01_JPRB, 0.131823E+01_JPRB &
  &, 0.133955E+01_JPRB, 0.136061E+01_JPRB, 0.138138E+01_JPRB &
  &, 0.140187E+01_JPRB, 0.142205E+01_JPRB, 0.144191E+01_JPRB, 0.146144E+01_JPRB &
  &, 0.148062E+01_JPRB, 0.149945E+01_JPRB, 0.151790E+01_JPRB &
  &, 0.153597E+01_JPRB, 0.155365E+01_JPRB, 0.157092E+01_JPRB, 0.158777E+01_JPRB &
  &, 0.160418E+01_JPRB, 0.162016E+01_JPRB, 0.163568E+01_JPRB &
  &, 0.165074E+01_JPRB, 0.166533E+01_JPRB, 0.167944E+01_JPRB, 0.169305E+01_JPRB &
  &, 0.170617E+01_JPRB, 0.171877E+01_JPRB, 0.173086E+01_JPRB &
  &, 0.174242E+01_JPRB, 0.175346E+01_JPRB, 0.176396E+01_JPRB, 0.177391E+01_JPRB &
  &, 0.178332E+01_JPRB, 0.179218E+01_JPRB, 0.180048E+01_JPRB &
  &, 0.180822E+01_JPRB, 0.181540E+01_JPRB, 0.182201E+01_JPRB, 0.182805E+01_JPRB &
  &, 0.183352E+01_JPRB, 0.183841E+01_JPRB, 0.184275E+01_JPRB &
  &, 0.184650E+01_JPRB, 0.184968E+01_JPRB, 0.185230E+01_JPRB, 0.185434E+01_JPRB &
  &, 0.185581E+01_JPRB, 0.185673E+01_JPRB, 0.185706E+01_JPRB &
  &, 0.185685E+01_JPRB, 0.185609E+01_JPRB, 0.185475E+01_JPRB, 0.185287E+01_JPRB &
  &, 0.185046E+01_JPRB, 0.184750E+01_JPRB, 0.184401E+01_JPRB &
  &, 0.183999E+01_JPRB, 0.183545E+01_JPRB, 0.183039E+01_JPRB, 0.182482E+01_JPRB &
  &, 0.181875E+01_JPRB, 0.181220E+01_JPRB, 0.180515E+01_JPRB &
  &, 0.179762E+01_JPRB, 0.178963E+01_JPRB, 0.178118E+01_JPRB, 0.177227E+01_JPRB &
  &, 0.176293E+01_JPRB, 0.175315E+01_JPRB, 0.174292E+01_JPRB &
  &, 0.173230E+01_JPRB, 0.172127E+01_JPRB, 0.170986E+01_JPRB, 0.169804E+01_JPRB &
  &, 0.168585E+01_JPRB, 0.167331E+01_JPRB, 0.166040E+01_JPRB &
  &, 0.164715E+01_JPRB, 0.163357E+01_JPRB, 0.161968E+01_JPRB, 0.160547E+01_JPRB &
  &, 0.159096E+01_JPRB, 0.157616E+01_JPRB, 0.156110E+01_JPRB &
  &, 0.154577E+01_JPRB, 0.153017E+01_JPRB, 0.151433E+01_JPRB, 0.149828E+01_JPRB &
  &, 0.148198E+01_JPRB, 0.146550E+01_JPRB, 0.144879E+01_JPRB &
  &, 0.143193E+01_JPRB, 0.141487E+01_JPRB, 0.139767E+01_JPRB, 0.138030E+01_JPRB &
  &, 0.136278E+01_JPRB, 0.134514E+01_JPRB, 0.132738E+01_JPRB &
  &, 0.130952E+01_JPRB, 0.129156E+01_JPRB, 0.127352E+01_JPRB, 0.125539E+01_JPRB &
  &, 0.123721E+01_JPRB, 0.121895E+01_JPRB, 0.120065E+01_JPRB &
  &, 0.118234E+01_JPRB, 0.116401E+01_JPRB, 0.114563E+01_JPRB, 0.112728E+01_JPRB &
  &, 0.110889E+01_JPRB, 0.109055E+01_JPRB, 0.107224E+01_JPRB &
  &, 0.105392E+01_JPRB, 0.103569E+01_JPRB, 0.101746E+01_JPRB, 0.999318E+00_JPRB &
  &, 0.981237E+00_JPRB, 0.963246E+00_JPRB, 0.945318E+00_JPRB &
  &, 0.927479E+00_JPRB, 0.909700E+00_JPRB, 0.892064E+00_JPRB, 0.874540E+00_JPRB &
  &, 0.857155E+00_JPRB, 0.839876E+00_JPRB, 0.822729E+00_JPRB &
  &, 0.805678E+00_JPRB, 0.788808E+00_JPRB, 0.772083E+00_JPRB, 0.755527E+00_JPRB &
  &, 0.739102E+00_JPRB, 0.722894E+00_JPRB, 0.706799E+00_JPRB/)
XCW( 828, :) = (/ &
  &  0.109405E+01_JPRB, 0.111734E+01_JPRB, 0.114051E+01_JPRB, 0.116355E+01_JPRB &
  &, 0.118644E+01_JPRB, 0.120917E+01_JPRB, 0.123173E+01_JPRB &
  &, 0.125409E+01_JPRB, 0.127624E+01_JPRB, 0.129818E+01_JPRB, 0.131989E+01_JPRB &
  &, 0.134134E+01_JPRB, 0.136254E+01_JPRB, 0.138345E+01_JPRB &
  &, 0.140408E+01_JPRB, 0.142441E+01_JPRB, 0.144442E+01_JPRB, 0.146410E+01_JPRB &
  &, 0.148343E+01_JPRB, 0.150241E+01_JPRB, 0.152103E+01_JPRB &
  &, 0.153925E+01_JPRB, 0.155709E+01_JPRB, 0.157452E+01_JPRB, 0.159153E+01_JPRB &
  &, 0.160811E+01_JPRB, 0.162425E+01_JPRB, 0.163994E+01_JPRB &
  &, 0.165517E+01_JPRB, 0.166992E+01_JPRB, 0.168420E+01_JPRB, 0.169798E+01_JPRB &
  &, 0.171127E+01_JPRB, 0.172405E+01_JPRB, 0.173631E+01_JPRB &
  &, 0.174805E+01_JPRB, 0.175925E+01_JPRB, 0.176993E+01_JPRB, 0.178006E+01_JPRB &
  &, 0.178964E+01_JPRB, 0.179867E+01_JPRB, 0.180715E+01_JPRB &
  &, 0.181507E+01_JPRB, 0.182242E+01_JPRB, 0.182920E+01_JPRB, 0.183542E+01_JPRB &
  &, 0.184106E+01_JPRB, 0.184614E+01_JPRB, 0.185064E+01_JPRB &
  &, 0.185457E+01_JPRB, 0.185792E+01_JPRB, 0.186071E+01_JPRB, 0.186292E+01_JPRB &
  &, 0.186455E+01_JPRB, 0.186563E+01_JPRB, 0.186615E+01_JPRB &
  &, 0.186609E+01_JPRB, 0.186546E+01_JPRB, 0.186432E+01_JPRB, 0.186260E+01_JPRB &
  &, 0.186034E+01_JPRB, 0.185753E+01_JPRB, 0.185420E+01_JPRB &
  &, 0.185033E+01_JPRB, 0.184595E+01_JPRB, 0.184102E+01_JPRB, 0.183561E+01_JPRB &
  &, 0.182969E+01_JPRB, 0.182326E+01_JPRB, 0.181637E+01_JPRB &
  &, 0.180897E+01_JPRB, 0.180111E+01_JPRB, 0.179279E+01_JPRB, 0.178400E+01_JPRB &
  &, 0.177477E+01_JPRB, 0.176511E+01_JPRB, 0.175501E+01_JPRB &
  &, 0.174451E+01_JPRB, 0.173358E+01_JPRB, 0.172228E+01_JPRB, 0.171055E+01_JPRB &
  &, 0.169847E+01_JPRB, 0.168602E+01_JPRB, 0.167322E+01_JPRB &
  &, 0.166004E+01_JPRB, 0.164657E+01_JPRB, 0.163275E+01_JPRB, 0.161860E+01_JPRB &
  &, 0.160419E+01_JPRB, 0.158945E+01_JPRB, 0.157444E+01_JPRB &
  &, 0.155894E+01_JPRB, 0.154364E+01_JPRB, 0.152788E+01_JPRB, 0.151183E+01_JPRB &
  &, 0.149560E+01_JPRB, 0.147915E+01_JPRB, 0.146251E+01_JPRB &
  &, 0.144567E+01_JPRB, 0.142862E+01_JPRB, 0.141144E+01_JPRB, 0.139411E+01_JPRB &
  &, 0.137659E+01_JPRB, 0.135899E+01_JPRB, 0.134122E+01_JPRB &
  &, 0.132338E+01_JPRB, 0.130540E+01_JPRB, 0.128734E+01_JPRB, 0.126922E+01_JPRB &
  &, 0.125100E+01_JPRB, 0.123274E+01_JPRB, 0.121444E+01_JPRB &
  &, 0.119607E+01_JPRB, 0.117772E+01_JPRB, 0.115932E+01_JPRB, 0.114090E+01_JPRB &
  &, 0.112248E+01_JPRB, 0.110411E+01_JPRB, 0.108570E+01_JPRB &
  &, 0.106733E+01_JPRB, 0.104904E+01_JPRB, 0.103076E+01_JPRB, 0.101255E+01_JPRB &
  &, 0.994393E+00_JPRB, 0.976324E+00_JPRB, 0.958310E+00_JPRB &
  &, 0.940380E+00_JPRB, 0.922560E+00_JPRB, 0.904877E+00_JPRB, 0.887244E+00_JPRB &
  &, 0.869744E+00_JPRB, 0.852343E+00_JPRB, 0.835126E+00_JPRB &
  &, 0.818001E+00_JPRB, 0.800990E+00_JPRB, 0.784179E+00_JPRB, 0.767468E+00_JPRB &
  &, 0.750945E+00_JPRB, 0.734569E+00_JPRB, 0.718430E+00_JPRB/)
XCW( 829, :) = (/ &
  &  0.109447E+01_JPRB, 0.111787E+01_JPRB, 0.114116E+01_JPRB, 0.116431E+01_JPRB &
  &, 0.118732E+01_JPRB, 0.121018E+01_JPRB, 0.123286E+01_JPRB &
  &, 0.125535E+01_JPRB, 0.127763E+01_JPRB, 0.129970E+01_JPRB, 0.132154E+01_JPRB &
  &, 0.134314E+01_JPRB, 0.136447E+01_JPRB, 0.138553E+01_JPRB &
  &, 0.140631E+01_JPRB, 0.142678E+01_JPRB, 0.144694E+01_JPRB, 0.146677E+01_JPRB &
  &, 0.148626E+01_JPRB, 0.150539E+01_JPRB, 0.152416E+01_JPRB &
  &, 0.154255E+01_JPRB, 0.156054E+01_JPRB, 0.157814E+01_JPRB, 0.159531E+01_JPRB &
  &, 0.161206E+01_JPRB, 0.162836E+01_JPRB, 0.164422E+01_JPRB &
  &, 0.165962E+01_JPRB, 0.167454E+01_JPRB, 0.168899E+01_JPRB, 0.170295E+01_JPRB &
  &, 0.171640E+01_JPRB, 0.172935E+01_JPRB, 0.174179E+01_JPRB &
  &, 0.175370E+01_JPRB, 0.176509E+01_JPRB, 0.177593E+01_JPRB, 0.178624E+01_JPRB &
  &, 0.179601E+01_JPRB, 0.180522E+01_JPRB, 0.181387E+01_JPRB &
  &, 0.182196E+01_JPRB, 0.182948E+01_JPRB, 0.183645E+01_JPRB, 0.184284E+01_JPRB &
  &, 0.184866E+01_JPRB, 0.185390E+01_JPRB, 0.185858E+01_JPRB &
  &, 0.186269E+01_JPRB, 0.186621E+01_JPRB, 0.186917E+01_JPRB, 0.187155E+01_JPRB &
  &, 0.187335E+01_JPRB, 0.187460E+01_JPRB, 0.187528E+01_JPRB &
  &, 0.187540E+01_JPRB, 0.187496E+01_JPRB, 0.187394E+01_JPRB, 0.187239E+01_JPRB &
  &, 0.187029E+01_JPRB, 0.186765E+01_JPRB, 0.186446E+01_JPRB &
  &, 0.186075E+01_JPRB, 0.185650E+01_JPRB, 0.185175E+01_JPRB, 0.184648E+01_JPRB &
  &, 0.184070E+01_JPRB, 0.183442E+01_JPRB, 0.182764E+01_JPRB &
  &, 0.182040E+01_JPRB, 0.181267E+01_JPRB, 0.180448E+01_JPRB, 0.179583E+01_JPRB &
  &, 0.178672E+01_JPRB, 0.177717E+01_JPRB, 0.176719E+01_JPRB &
  &, 0.175681E+01_JPRB, 0.174601E+01_JPRB, 0.173477E+01_JPRB, 0.172319E+01_JPRB &
  &, 0.171120E+01_JPRB, 0.169886E+01_JPRB, 0.168614E+01_JPRB &
  &, 0.167307E+01_JPRB, 0.165965E+01_JPRB, 0.164593E+01_JPRB, 0.163188E+01_JPRB &
  &, 0.161750E+01_JPRB, 0.160286E+01_JPRB, 0.158794E+01_JPRB &
  &, 0.157271E+01_JPRB, 0.155724E+01_JPRB, 0.154153E+01_JPRB, 0.152556E+01_JPRB &
  &, 0.150936E+01_JPRB, 0.149294E+01_JPRB, 0.147633E+01_JPRB &
  &, 0.145951E+01_JPRB, 0.144252E+01_JPRB, 0.142539E+01_JPRB, 0.140803E+01_JPRB &
  &, 0.139055E+01_JPRB, 0.137295E+01_JPRB, 0.135521E+01_JPRB &
  &, 0.133737E+01_JPRB, 0.131940E+01_JPRB, 0.130132E+01_JPRB, 0.128321E+01_JPRB &
  &, 0.126496E+01_JPRB, 0.124670E+01_JPRB, 0.122836E+01_JPRB &
  &, 0.120998E+01_JPRB, 0.119157E+01_JPRB, 0.117315E+01_JPRB, 0.115471E+01_JPRB &
  &, 0.113627E+01_JPRB, 0.111780E+01_JPRB, 0.109935E+01_JPRB &
  &, 0.108094E+01_JPRB, 0.106260E+01_JPRB, 0.104426E+01_JPRB, 0.102598E+01_JPRB &
  &, 0.100776E+01_JPRB, 0.989616E+00_JPRB, 0.971521E+00_JPRB &
  &, 0.953502E+00_JPRB, 0.935588E+00_JPRB, 0.917804E+00_JPRB, 0.900121E+00_JPRB &
  &, 0.882507E+00_JPRB, 0.865046E+00_JPRB, 0.847644E+00_JPRB &
  &, 0.830445E+00_JPRB, 0.813356E+00_JPRB, 0.796399E+00_JPRB, 0.779599E+00_JPRB &
  &, 0.762981E+00_JPRB, 0.746504E+00_JPRB, 0.730192E+00_JPRB/)
XCW( 830, :) = (/ &
  &  0.109488E+01_JPRB, 0.111840E+01_JPRB, 0.114180E+01_JPRB, 0.116508E+01_JPRB &
  &, 0.118821E+01_JPRB, 0.121119E+01_JPRB, 0.123399E+01_JPRB &
  &, 0.125661E+01_JPRB, 0.127903E+01_JPRB, 0.130123E+01_JPRB, 0.132321E+01_JPRB &
  &, 0.134494E+01_JPRB, 0.136642E+01_JPRB, 0.138762E+01_JPRB &
  &, 0.140854E+01_JPRB, 0.142916E+01_JPRB, 0.144947E+01_JPRB, 0.146946E+01_JPRB &
  &, 0.148910E+01_JPRB, 0.150839E+01_JPRB, 0.152731E+01_JPRB &
  &, 0.154586E+01_JPRB, 0.156402E+01_JPRB, 0.158177E+01_JPRB, 0.159911E+01_JPRB &
  &, 0.161602E+01_JPRB, 0.163250E+01_JPRB, 0.164852E+01_JPRB &
  &, 0.166409E+01_JPRB, 0.167919E+01_JPRB, 0.169380E+01_JPRB, 0.170793E+01_JPRB &
  &, 0.172156E+01_JPRB, 0.173468E+01_JPRB, 0.174730E+01_JPRB &
  &, 0.175939E+01_JPRB, 0.177095E+01_JPRB, 0.178198E+01_JPRB, 0.179247E+01_JPRB &
  &, 0.180240E+01_JPRB, 0.181179E+01_JPRB, 0.182062E+01_JPRB &
  &, 0.182889E+01_JPRB, 0.183659E+01_JPRB, 0.184373E+01_JPRB, 0.185030E+01_JPRB &
  &, 0.185630E+01_JPRB, 0.186173E+01_JPRB, 0.186638E+01_JPRB &
  &, 0.187085E+01_JPRB, 0.187455E+01_JPRB, 0.187766E+01_JPRB, 0.188024E+01_JPRB &
  &, 0.188223E+01_JPRB, 0.188364E+01_JPRB, 0.188449E+01_JPRB &
  &, 0.188476E+01_JPRB, 0.188449E+01_JPRB, 0.188364E+01_JPRB, 0.188225E+01_JPRB &
  &, 0.188032E+01_JPRB, 0.187782E+01_JPRB, 0.187481E+01_JPRB &
  &, 0.187125E+01_JPRB, 0.186717E+01_JPRB, 0.186254E+01_JPRB, 0.185743E+01_JPRB &
  &, 0.185180E+01_JPRB, 0.184566E+01_JPRB, 0.183902E+01_JPRB &
  &, 0.183191E+01_JPRB, 0.182432E+01_JPRB, 0.181627E+01_JPRB, 0.180774E+01_JPRB &
  &, 0.179877E+01_JPRB, 0.178934E+01_JPRB, 0.177949E+01_JPRB &
  &, 0.176922E+01_JPRB, 0.175851E+01_JPRB, 0.174742E+01_JPRB, 0.173593E+01_JPRB &
  &, 0.172404E+01_JPRB, 0.171179E+01_JPRB, 0.169918E+01_JPRB &
  &, 0.168619E+01_JPRB, 0.167287E+01_JPRB, 0.165923E+01_JPRB, 0.164525E+01_JPRB &
  &, 0.163097E+01_JPRB, 0.161639E+01_JPRB, 0.160153E+01_JPRB &
  &, 0.158639E+01_JPRB, 0.157098E+01_JPRB, 0.155531E+01_JPRB, 0.153941E+01_JPRB &
  &, 0.152326E+01_JPRB, 0.150688E+01_JPRB, 0.149033E+01_JPRB &
  &, 0.147353E+01_JPRB, 0.145656E+01_JPRB, 0.143945E+01_JPRB, 0.142214E+01_JPRB &
  &, 0.140467E+01_JPRB, 0.138710E+01_JPRB, 0.136936E+01_JPRB &
  &, 0.135151E+01_JPRB, 0.133353E+01_JPRB, 0.131546E+01_JPRB, 0.129733E+01_JPRB &
  &, 0.127909E+01_JPRB, 0.126080E+01_JPRB, 0.124245E+01_JPRB &
  &, 0.122403E+01_JPRB, 0.120561E+01_JPRB, 0.118713E+01_JPRB, 0.116866E+01_JPRB &
  &, 0.115019E+01_JPRB, 0.113170E+01_JPRB, 0.111321E+01_JPRB &
  &, 0.109475E+01_JPRB, 0.107631E+01_JPRB, 0.105791E+01_JPRB, 0.103958E+01_JPRB &
  &, 0.102129E+01_JPRB, 0.100307E+01_JPRB, 0.984894E+00_JPRB &
  &, 0.966845E+00_JPRB, 0.948839E+00_JPRB, 0.930957E+00_JPRB, 0.913113E+00_JPRB &
  &, 0.895446E+00_JPRB, 0.877867E+00_JPRB, 0.860400E+00_JPRB &
  &, 0.843072E+00_JPRB, 0.825907E+00_JPRB, 0.808869E+00_JPRB, 0.791983E+00_JPRB &
  &, 0.775208E+00_JPRB, 0.758633E+00_JPRB, 0.742151E+00_JPRB/)
XCW( 831, :) = (/ &
  &  0.109531E+01_JPRB, 0.111893E+01_JPRB, 0.114245E+01_JPRB, 0.116584E+01_JPRB &
  &, 0.118910E+01_JPRB, 0.121220E+01_JPRB, 0.123513E+01_JPRB &
  &, 0.125788E+01_JPRB, 0.128043E+01_JPRB, 0.130277E+01_JPRB, 0.132488E+01_JPRB &
  &, 0.134676E+01_JPRB, 0.136837E+01_JPRB, 0.138972E+01_JPRB &
  &, 0.141079E+01_JPRB, 0.143156E+01_JPRB, 0.145202E+01_JPRB, 0.147215E+01_JPRB &
  &, 0.149195E+01_JPRB, 0.151140E+01_JPRB, 0.153048E+01_JPRB &
  &, 0.154919E+01_JPRB, 0.156751E+01_JPRB, 0.158543E+01_JPRB, 0.160293E+01_JPRB &
  &, 0.162001E+01_JPRB, 0.163665E+01_JPRB, 0.165285E+01_JPRB &
  &, 0.166859E+01_JPRB, 0.168385E+01_JPRB, 0.169865E+01_JPRB, 0.171295E+01_JPRB &
  &, 0.172676E+01_JPRB, 0.174006E+01_JPRB, 0.175285E+01_JPRB &
  &, 0.176511E+01_JPRB, 0.177685E+01_JPRB, 0.178806E+01_JPRB, 0.179872E+01_JPRB &
  &, 0.180883E+01_JPRB, 0.181840E+01_JPRB, 0.182742E+01_JPRB &
  &, 0.183586E+01_JPRB, 0.184375E+01_JPRB, 0.185106E+01_JPRB, 0.185781E+01_JPRB &
  &, 0.186399E+01_JPRB, 0.186959E+01_JPRB, 0.187462E+01_JPRB &
  &, 0.187907E+01_JPRB, 0.188295E+01_JPRB, 0.188604E+01_JPRB, 0.188899E+01_JPRB &
  &, 0.189114E+01_JPRB, 0.189272E+01_JPRB, 0.189375E+01_JPRB &
  &, 0.189420E+01_JPRB, 0.189408E+01_JPRB, 0.189341E+01_JPRB, 0.189219E+01_JPRB &
  &, 0.189041E+01_JPRB, 0.188808E+01_JPRB, 0.188523E+01_JPRB &
  &, 0.188182E+01_JPRB, 0.187789E+01_JPRB, 0.187342E+01_JPRB, 0.186845E+01_JPRB &
  &, 0.186296E+01_JPRB, 0.185698E+01_JPRB, 0.185050E+01_JPRB &
  &, 0.184353E+01_JPRB, 0.183606E+01_JPRB, 0.182814E+01_JPRB, 0.181974E+01_JPRB &
  &, 0.181090E+01_JPRB, 0.180161E+01_JPRB, 0.179187E+01_JPRB &
  &, 0.178172E+01_JPRB, 0.177114E+01_JPRB, 0.176015E+01_JPRB, 0.174878E+01_JPRB &
  &, 0.173700E+01_JPRB, 0.172484E+01_JPRB, 0.171232E+01_JPRB &
  &, 0.169945E+01_JPRB, 0.168621E+01_JPRB, 0.167267E+01_JPRB, 0.165877E+01_JPRB &
  &, 0.164456E+01_JPRB, 0.163007E+01_JPRB, 0.161528E+01_JPRB &
  &, 0.160020E+01_JPRB, 0.158484E+01_JPRB, 0.156925E+01_JPRB, 0.155337E+01_JPRB &
  &, 0.153729E+01_JPRB, 0.152098E+01_JPRB, 0.150443E+01_JPRB &
  &, 0.148770E+01_JPRB, 0.147072E+01_JPRB, 0.145366E+01_JPRB, 0.143640E+01_JPRB &
  &, 0.141894E+01_JPRB, 0.140138E+01_JPRB, 0.138363E+01_JPRB &
  &, 0.136581E+01_JPRB, 0.134786E+01_JPRB, 0.132978E+01_JPRB, 0.131162E+01_JPRB &
  &, 0.129339E+01_JPRB, 0.127507E+01_JPRB, 0.125672E+01_JPRB &
  &, 0.123830E+01_JPRB, 0.121982E+01_JPRB, 0.120133E+01_JPRB, 0.118280E+01_JPRB &
  &, 0.116426E+01_JPRB, 0.114573E+01_JPRB, 0.112721E+01_JPRB &
  &, 0.110871E+01_JPRB, 0.109023E+01_JPRB, 0.107177E+01_JPRB, 0.105338E+01_JPRB &
  &, 0.103497E+01_JPRB, 0.101668E+01_JPRB, 0.998484E+00_JPRB &
  &, 0.980298E+00_JPRB, 0.962258E+00_JPRB, 0.944281E+00_JPRB, 0.926392E+00_JPRB &
  &, 0.908617E+00_JPRB, 0.890924E+00_JPRB, 0.873397E+00_JPRB &
  &, 0.855941E+00_JPRB, 0.838642E+00_JPRB, 0.821027E+00_JPRB, 0.804493E+00_JPRB &
  &, 0.787628E+00_JPRB, 0.770892E+00_JPRB, 0.754374E+00_JPRB/)
XCW( 832, :) = (/ &
  &  0.109573E+01_JPRB, 0.111947E+01_JPRB, 0.114310E+01_JPRB, 0.116661E+01_JPRB &
  &, 0.118999E+01_JPRB, 0.121322E+01_JPRB, 0.123628E+01_JPRB &
  &, 0.125915E+01_JPRB, 0.128184E+01_JPRB, 0.130431E+01_JPRB, 0.132656E+01_JPRB &
  &, 0.134858E+01_JPRB, 0.137034E+01_JPRB, 0.139183E+01_JPRB &
  &, 0.141305E+01_JPRB, 0.143397E+01_JPRB, 0.145458E+01_JPRB, 0.147487E+01_JPRB &
  &, 0.149482E+01_JPRB, 0.151442E+01_JPRB, 0.153367E+01_JPRB &
  &, 0.155254E+01_JPRB, 0.157102E+01_JPRB, 0.158910E+01_JPRB, 0.160677E+01_JPRB &
  &, 0.162402E+01_JPRB, 0.164083E+01_JPRB, 0.165720E+01_JPRB &
  &, 0.167311E+01_JPRB, 0.168855E+01_JPRB, 0.170352E+01_JPRB, 0.171800E+01_JPRB &
  &, 0.173198E+01_JPRB, 0.174546E+01_JPRB, 0.175842E+01_JPRB &
  &, 0.177087E+01_JPRB, 0.178279E+01_JPRB, 0.179417E+01_JPRB, 0.180502E+01_JPRB &
  &, 0.181531E+01_JPRB, 0.182506E+01_JPRB, 0.183425E+01_JPRB &
  &, 0.184288E+01_JPRB, 0.185095E+01_JPRB, 0.185844E+01_JPRB, 0.186537E+01_JPRB &
  &, 0.187173E+01_JPRB, 0.187751E+01_JPRB, 0.188272E+01_JPRB &
  &, 0.188735E+01_JPRB, 0.189140E+01_JPRB, 0.189489E+01_JPRB, 0.189780E+01_JPRB &
  &, 0.190013E+01_JPRB, 0.190188E+01_JPRB, 0.190308E+01_JPRB &
  &, 0.190370E+01_JPRB, 0.190376E+01_JPRB, 0.190326E+01_JPRB, 0.190220E+01_JPRB &
  &, 0.190058E+01_JPRB, 0.189841E+01_JPRB, 0.189572E+01_JPRB &
  &, 0.189247E+01_JPRB, 0.188870E+01_JPRB, 0.188440E+01_JPRB, 0.187957E+01_JPRB &
  &, 0.187425E+01_JPRB, 0.186839E+01_JPRB, 0.186206E+01_JPRB &
  &, 0.185522E+01_JPRB, 0.184790E+01_JPRB, 0.184012E+01_JPRB, 0.183186E+01_JPRB &
  &, 0.182313E+01_JPRB, 0.181397E+01_JPRB, 0.180436E+01_JPRB &
  &, 0.179434E+01_JPRB, 0.178386E+01_JPRB, 0.177300E+01_JPRB, 0.176173E+01_JPRB &
  &, 0.175007E+01_JPRB, 0.173801E+01_JPRB, 0.172560E+01_JPRB &
  &, 0.171281E+01_JPRB, 0.169969E+01_JPRB, 0.168620E+01_JPRB, 0.167240E+01_JPRB &
  &, 0.165830E+01_JPRB, 0.164385E+01_JPRB, 0.162915E+01_JPRB &
  &, 0.161413E+01_JPRB, 0.159886E+01_JPRB, 0.158329E+01_JPRB, 0.156749E+01_JPRB &
  &, 0.155146E+01_JPRB, 0.153519E+01_JPRB, 0.151871E+01_JPRB &
  &, 0.150201E+01_JPRB, 0.148513E+01_JPRB, 0.146805E+01_JPRB, 0.145077E+01_JPRB &
  &, 0.143336E+01_JPRB, 0.141580E+01_JPRB, 0.139810E+01_JPRB &
  &, 0.138027E+01_JPRB, 0.136232E+01_JPRB, 0.134426E+01_JPRB, 0.132608E+01_JPRB &
  &, 0.130782E+01_JPRB, 0.128951E+01_JPRB, 0.127112E+01_JPRB &
  &, 0.125270E+01_JPRB, 0.123418E+01_JPRB, 0.121567E+01_JPRB, 0.119712E+01_JPRB &
  &, 0.117856E+01_JPRB, 0.115996E+01_JPRB, 0.114141E+01_JPRB &
  &, 0.112282E+01_JPRB, 0.110429E+01_JPRB, 0.108579E+01_JPRB, 0.106734E+01_JPRB &
  &, 0.104871E+01_JPRB, 0.103051E+01_JPRB, 0.101224E+01_JPRB &
  &, 0.993971E+00_JPRB, 0.975844E+00_JPRB, 0.957774E+00_JPRB, 0.939786E+00_JPRB &
  &, 0.921905E+00_JPRB, 0.904159E+00_JPRB, 0.886513E+00_JPRB &
  &, 0.868993E+00_JPRB, 0.851562E+00_JPRB, 0.834308E+00_JPRB, 0.817192E+00_JPRB &
  &, 0.800239E+00_JPRB, 0.783410E+00_JPRB, 0.766728E+00_JPRB/)
XCW( 833, :) = (/ &
  &  0.109615E+01_JPRB, 0.112001E+01_JPRB, 0.114376E+01_JPRB, 0.116739E+01_JPRB &
  &, 0.119089E+01_JPRB, 0.121424E+01_JPRB, 0.123743E+01_JPRB &
  &, 0.126044E+01_JPRB, 0.128325E+01_JPRB, 0.130586E+01_JPRB, 0.132825E+01_JPRB &
  &, 0.135041E+01_JPRB, 0.137231E+01_JPRB, 0.139395E+01_JPRB &
  &, 0.141531E+01_JPRB, 0.143638E+01_JPRB, 0.145715E+01_JPRB, 0.147759E+01_JPRB &
  &, 0.149770E+01_JPRB, 0.151747E+01_JPRB, 0.153687E+01_JPRB &
  &, 0.155590E+01_JPRB, 0.157455E+01_JPRB, 0.159280E+01_JPRB, 0.161063E+01_JPRB &
  &, 0.162805E+01_JPRB, 0.164503E+01_JPRB, 0.166157E+01_JPRB &
  &, 0.167765E+01_JPRB, 0.169327E+01_JPRB, 0.170841E+01_JPRB, 0.172307E+01_JPRB &
  &, 0.173722E+01_JPRB, 0.175088E+01_JPRB, 0.176403E+01_JPRB &
  &, 0.177666E+01_JPRB, 0.178876E+01_JPRB, 0.180032E+01_JPRB, 0.181135E+01_JPRB &
  &, 0.182183E+01_JPRB, 0.183176E+01_JPRB, 0.184112E+01_JPRB &
  &, 0.184994E+01_JPRB, 0.185819E+01_JPRB, 0.186587E+01_JPRB, 0.187298E+01_JPRB &
  &, 0.187952E+01_JPRB, 0.188549E+01_JPRB, 0.189088E+01_JPRB &
  &, 0.189568E+01_JPRB, 0.189992E+01_JPRB, 0.190358E+01_JPRB, 0.190666E+01_JPRB &
  &, 0.190916E+01_JPRB, 0.191111E+01_JPRB, 0.191247E+01_JPRB &
  &, 0.191326E+01_JPRB, 0.191349E+01_JPRB, 0.191316E+01_JPRB, 0.191227E+01_JPRB &
  &, 0.191083E+01_JPRB, 0.190883E+01_JPRB, 0.190628E+01_JPRB &
  &, 0.190319E+01_JPRB, 0.189959E+01_JPRB, 0.189543E+01_JPRB, 0.189077E+01_JPRB &
  &, 0.188559E+01_JPRB, 0.187989E+01_JPRB, 0.187371E+01_JPRB &
  &, 0.186703E+01_JPRB, 0.185985E+01_JPRB, 0.185218E+01_JPRB, 0.184407E+01_JPRB &
  &, 0.183548E+01_JPRB, 0.182645E+01_JPRB, 0.181697E+01_JPRB &
  &, 0.180706E+01_JPRB, 0.179671E+01_JPRB, 0.178596E+01_JPRB, 0.177481E+01_JPRB &
  &, 0.176325E+01_JPRB, 0.175130E+01_JPRB, 0.173899E+01_JPRB &
  &, 0.172629E+01_JPRB, 0.171317E+01_JPRB, 0.169987E+01_JPRB, 0.168618E+01_JPRB &
  &, 0.167212E+01_JPRB, 0.165778E+01_JPRB, 0.164314E+01_JPRB &
  &, 0.162819E+01_JPRB, 0.161298E+01_JPRB, 0.159750E+01_JPRB, 0.158175E+01_JPRB &
  &, 0.156577E+01_JPRB, 0.154954E+01_JPRB, 0.153313E+01_JPRB &
  &, 0.151646E+01_JPRB, 0.149961E+01_JPRB, 0.148255E+01_JPRB, 0.146533E+01_JPRB &
  &, 0.144793E+01_JPRB, 0.143039E+01_JPRB, 0.141273E+01_JPRB &
  &, 0.139490E+01_JPRB, 0.137693E+01_JPRB, 0.135890E+01_JPRB, 0.134071E+01_JPRB &
  &, 0.132247E+01_JPRB, 0.130412E+01_JPRB, 0.128575E+01_JPRB &
  &, 0.126728E+01_JPRB, 0.124876E+01_JPRB, 0.123020E+01_JPRB, 0.121159E+01_JPRB &
  &, 0.119301E+01_JPRB, 0.117439E+01_JPRB, 0.115575E+01_JPRB &
  &, 0.113718E+01_JPRB, 0.111856E+01_JPRB, 0.110001E+01_JPRB, 0.108145E+01_JPRB &
  &, 0.106298E+01_JPRB, 0.104455E+01_JPRB, 0.102615E+01_JPRB &
  &, 0.100786E+01_JPRB, 0.989599E+00_JPRB, 0.971495E+00_JPRB, 0.953410E+00_JPRB &
  &, 0.935427E+00_JPRB, 0.917570E+00_JPRB, 0.899868E+00_JPRB &
  &, 0.882226E+00_JPRB, 0.864729E+00_JPRB, 0.847339E+00_JPRB, 0.830081E+00_JPRB &
  &, 0.813043E+00_JPRB, 0.796058E+00_JPRB, 0.779278E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART119',1,ZHOOK_HANDLE)
END SUBROUTINE PART119

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART120

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART120',0,ZHOOK_HANDLE)

XCW( 834, :) = (/ &
  &  0.109658E+01_JPRB, 0.112055E+01_JPRB, 0.114442E+01_JPRB, 0.116817E+01_JPRB &
  &, 0.119179E+01_JPRB, 0.121526E+01_JPRB, 0.123858E+01_JPRB &
  &, 0.126172E+01_JPRB, 0.128467E+01_JPRB, 0.130742E+01_JPRB, 0.132995E+01_JPRB &
  &, 0.135225E+01_JPRB, 0.137429E+01_JPRB, 0.139608E+01_JPRB &
  &, 0.141759E+01_JPRB, 0.143881E+01_JPRB, 0.145973E+01_JPRB, 0.148033E+01_JPRB &
  &, 0.150060E+01_JPRB, 0.152052E+01_JPRB, 0.154009E+01_JPRB &
  &, 0.155928E+01_JPRB, 0.157810E+01_JPRB, 0.159651E+01_JPRB, 0.161452E+01_JPRB &
  &, 0.163210E+01_JPRB, 0.164926E+01_JPRB, 0.166597E+01_JPRB &
  &, 0.168223E+01_JPRB, 0.169802E+01_JPRB, 0.171334E+01_JPRB, 0.172817E+01_JPRB &
  &, 0.174251E+01_JPRB, 0.175635E+01_JPRB, 0.176968E+01_JPRB &
  &, 0.178248E+01_JPRB, 0.179477E+01_JPRB, 0.180651E+01_JPRB, 0.181772E+01_JPRB &
  &, 0.182838E+01_JPRB, 0.183850E+01_JPRB, 0.184805E+01_JPRB &
  &, 0.185704E+01_JPRB, 0.186548E+01_JPRB, 0.187334E+01_JPRB, 0.188064E+01_JPRB &
  &, 0.188736E+01_JPRB, 0.189350E+01_JPRB, 0.189907E+01_JPRB &
  &, 0.190408E+01_JPRB, 0.190848E+01_JPRB, 0.191233E+01_JPRB, 0.191558E+01_JPRB &
  &, 0.191828E+01_JPRB, 0.192039E+01_JPRB, 0.192193E+01_JPRB &
  &, 0.192290E+01_JPRB, 0.192331E+01_JPRB, 0.192313E+01_JPRB, 0.192241E+01_JPRB &
  &, 0.192113E+01_JPRB, 0.191931E+01_JPRB, 0.191693E+01_JPRB &
  &, 0.191401E+01_JPRB, 0.191055E+01_JPRB, 0.190658E+01_JPRB, 0.190206E+01_JPRB &
  &, 0.189703E+01_JPRB, 0.189149E+01_JPRB, 0.188544E+01_JPRB &
  &, 0.187890E+01_JPRB, 0.187187E+01_JPRB, 0.186436E+01_JPRB, 0.185639E+01_JPRB &
  &, 0.184793E+01_JPRB, 0.183902E+01_JPRB, 0.182968E+01_JPRB &
  &, 0.181988E+01_JPRB, 0.180966E+01_JPRB, 0.179903E+01_JPRB, 0.178799E+01_JPRB &
  &, 0.177653E+01_JPRB, 0.176471E+01_JPRB, 0.175249E+01_JPRB &
  &, 0.173991E+01_JPRB, 0.172698E+01_JPRB, 0.171369E+01_JPRB, 0.170005E+01_JPRB &
  &, 0.168610E+01_JPRB, 0.167186E+01_JPRB, 0.165726E+01_JPRB &
  &, 0.164241E+01_JPRB, 0.162726E+01_JPRB, 0.161184E+01_JPRB, 0.159614E+01_JPRB &
  &, 0.158024E+01_JPRB, 0.156406E+01_JPRB, 0.154765E+01_JPRB &
  &, 0.153106E+01_JPRB, 0.151424E+01_JPRB, 0.149724E+01_JPRB, 0.148004E+01_JPRB &
  &, 0.146270E+01_JPRB, 0.144517E+01_JPRB, 0.142747E+01_JPRB &
  &, 0.140968E+01_JPRB, 0.139171E+01_JPRB, 0.137367E+01_JPRB, 0.135550E+01_JPRB &
  &, 0.133724E+01_JPRB, 0.131891E+01_JPRB, 0.130051E+01_JPRB &
  &, 0.128200E+01_JPRB, 0.126348E+01_JPRB, 0.124491E+01_JPRB, 0.122629E+01_JPRB &
  &, 0.120765E+01_JPRB, 0.118900E+01_JPRB, 0.117034E+01_JPRB &
  &, 0.115169E+01_JPRB, 0.113303E+01_JPRB, 0.111438E+01_JPRB, 0.109583E+01_JPRB &
  &, 0.107724E+01_JPRB, 0.105876E+01_JPRB, 0.104029E+01_JPRB &
  &, 0.102192E+01_JPRB, 0.100358E+01_JPRB, 0.985385E+00_JPRB, 0.967207E+00_JPRB &
  &, 0.949181E+00_JPRB, 0.931219E+00_JPRB, 0.913404E+00_JPRB &
  &, 0.895642E+00_JPRB, 0.878018E+00_JPRB, 0.860557E+00_JPRB, 0.843222E+00_JPRB &
  &, 0.826039E+00_JPRB, 0.808966E+00_JPRB, 0.792026E+00_JPRB/)
XCW( 835, :) = (/ &
  &  0.109701E+01_JPRB, 0.112109E+01_JPRB, 0.114508E+01_JPRB, 0.116895E+01_JPRB &
  &, 0.119269E+01_JPRB, 0.121630E+01_JPRB, 0.123974E+01_JPRB &
  &, 0.126301E+01_JPRB, 0.128610E+01_JPRB, 0.130899E+01_JPRB, 0.133166E+01_JPRB &
  &, 0.135409E+01_JPRB, 0.137629E+01_JPRB, 0.139822E+01_JPRB &
  &, 0.141988E+01_JPRB, 0.144126E+01_JPRB, 0.146233E+01_JPRB, 0.148308E+01_JPRB &
  &, 0.150351E+01_JPRB, 0.152360E+01_JPRB, 0.154332E+01_JPRB &
  &, 0.156268E+01_JPRB, 0.158166E+01_JPRB, 0.160025E+01_JPRB, 0.161842E+01_JPRB &
  &, 0.163618E+01_JPRB, 0.165351E+01_JPRB, 0.167039E+01_JPRB &
  &, 0.168683E+01_JPRB, 0.170279E+01_JPRB, 0.171829E+01_JPRB, 0.173331E+01_JPRB &
  &, 0.174783E+01_JPRB, 0.176184E+01_JPRB, 0.177535E+01_JPRB &
  &, 0.178834E+01_JPRB, 0.180080E+01_JPRB, 0.181274E+01_JPRB, 0.182413E+01_JPRB &
  &, 0.183498E+01_JPRB, 0.184527E+01_JPRB, 0.185502E+01_JPRB &
  &, 0.186420E+01_JPRB, 0.187281E+01_JPRB, 0.188087E+01_JPRB, 0.188835E+01_JPRB &
  &, 0.189525E+01_JPRB, 0.190159E+01_JPRB, 0.190733E+01_JPRB &
  &, 0.191251E+01_JPRB, 0.191711E+01_JPRB, 0.192114E+01_JPRB, 0.192457E+01_JPRB &
  &, 0.192745E+01_JPRB, 0.192974E+01_JPRB, 0.193146E+01_JPRB &
  &, 0.193260E+01_JPRB, 0.193317E+01_JPRB, 0.193319E+01_JPRB, 0.193264E+01_JPRB &
  &, 0.193154E+01_JPRB, 0.192987E+01_JPRB, 0.192767E+01_JPRB &
  &, 0.192491E+01_JPRB, 0.192161E+01_JPRB, 0.191778E+01_JPRB, 0.191343E+01_JPRB &
  &, 0.190856E+01_JPRB, 0.190318E+01_JPRB, 0.189727E+01_JPRB &
  &, 0.189090E+01_JPRB, 0.188401E+01_JPRB, 0.187663E+01_JPRB, 0.186879E+01_JPRB &
  &, 0.186048E+01_JPRB, 0.185171E+01_JPRB, 0.184248E+01_JPRB &
  &, 0.183282E+01_JPRB, 0.182274E+01_JPRB, 0.181222E+01_JPRB, 0.180128E+01_JPRB &
  &, 0.178995E+01_JPRB, 0.177822E+01_JPRB, 0.176613E+01_JPRB &
  &, 0.175364E+01_JPRB, 0.174080E+01_JPRB, 0.172762E+01_JPRB, 0.171407E+01_JPRB &
  &, 0.170023E+01_JPRB, 0.168603E+01_JPRB, 0.167154E+01_JPRB &
  &, 0.165675E+01_JPRB, 0.164166E+01_JPRB, 0.162634E+01_JPRB, 0.161070E+01_JPRB &
  &, 0.159485E+01_JPRB, 0.157871E+01_JPRB, 0.156239E+01_JPRB &
  &, 0.154580E+01_JPRB, 0.152904E+01_JPRB, 0.151208E+01_JPRB, 0.149491E+01_JPRB &
  &, 0.147758E+01_JPRB, 0.146006E+01_JPRB, 0.144241E+01_JPRB &
  &, 0.142463E+01_JPRB, 0.140670E+01_JPRB, 0.138865E+01_JPRB, 0.137047E+01_JPRB &
  &, 0.135223E+01_JPRB, 0.133388E+01_JPRB, 0.131544E+01_JPRB &
  &, 0.129694E+01_JPRB, 0.127837E+01_JPRB, 0.125976E+01_JPRB, 0.124114E+01_JPRB &
  &, 0.122248E+01_JPRB, 0.120377E+01_JPRB, 0.118508E+01_JPRB &
  &, 0.116635E+01_JPRB, 0.114765E+01_JPRB, 0.112901E+01_JPRB, 0.111036E+01_JPRB &
  &, 0.109172E+01_JPRB, 0.107317E+01_JPRB, 0.105464E+01_JPRB &
  &, 0.103615E+01_JPRB, 0.101778E+01_JPRB, 0.999446E+00_JPRB, 0.981233E+00_JPRB &
  &, 0.963110E+00_JPRB, 0.945044E+00_JPRB, 0.927119E+00_JPRB &
  &, 0.909300E+00_JPRB, 0.891553E+00_JPRB, 0.874024E+00_JPRB, 0.856554E+00_JPRB &
  &, 0.839227E+00_JPRB, 0.822068E+00_JPRB, 0.805037E+00_JPRB/)
XCW( 836, :) = (/ &
  &  0.109744E+01_JPRB, 0.112163E+01_JPRB, 0.114574E+01_JPRB, 0.116973E+01_JPRB &
  &, 0.119360E+01_JPRB, 0.121733E+01_JPRB, 0.124091E+01_JPRB &
  &, 0.126431E+01_JPRB, 0.128754E+01_JPRB, 0.131056E+01_JPRB, 0.133337E+01_JPRB &
  &, 0.135595E+01_JPRB, 0.137829E+01_JPRB, 0.140037E+01_JPRB &
  &, 0.142218E+01_JPRB, 0.144371E+01_JPRB, 0.146494E+01_JPRB, 0.148585E+01_JPRB &
  &, 0.150644E+01_JPRB, 0.152668E+01_JPRB, 0.154658E+01_JPRB &
  &, 0.156610E+01_JPRB, 0.158525E+01_JPRB, 0.160400E+01_JPRB, 0.162235E+01_JPRB &
  &, 0.164028E+01_JPRB, 0.165778E+01_JPRB, 0.167484E+01_JPRB &
  &, 0.169145E+01_JPRB, 0.170760E+01_JPRB, 0.172327E+01_JPRB, 0.173847E+01_JPRB &
  &, 0.175317E+01_JPRB, 0.176737E+01_JPRB, 0.178106E+01_JPRB &
  &, 0.179423E+01_JPRB, 0.180689E+01_JPRB, 0.181900E+01_JPRB, 0.183058E+01_JPRB &
  &, 0.184161E+01_JPRB, 0.185210E+01_JPRB, 0.186203E+01_JPRB &
  &, 0.187140E+01_JPRB, 0.188020E+01_JPRB, 0.188843E+01_JPRB, 0.189610E+01_JPRB &
  &, 0.190320E+01_JPRB, 0.190972E+01_JPRB, 0.191566E+01_JPRB &
  &, 0.192101E+01_JPRB, 0.192580E+01_JPRB, 0.193001E+01_JPRB, 0.193364E+01_JPRB &
  &, 0.193668E+01_JPRB, 0.193913E+01_JPRB, 0.194104E+01_JPRB &
  &, 0.194237E+01_JPRB, 0.194313E+01_JPRB, 0.194332E+01_JPRB, 0.194294E+01_JPRB &
  &, 0.194201E+01_JPRB, 0.194051E+01_JPRB, 0.193848E+01_JPRB &
  &, 0.193589E+01_JPRB, 0.193276E+01_JPRB, 0.192908E+01_JPRB, 0.192490E+01_JPRB &
  &, 0.192018E+01_JPRB, 0.191495E+01_JPRB, 0.190921E+01_JPRB &
  &, 0.190296E+01_JPRB, 0.189622E+01_JPRB, 0.188900E+01_JPRB, 0.188129E+01_JPRB &
  &, 0.187312E+01_JPRB, 0.186450E+01_JPRB, 0.185541E+01_JPRB &
  &, 0.184588E+01_JPRB, 0.183591E+01_JPRB, 0.182552E+01_JPRB, 0.181472E+01_JPRB &
  &, 0.180349E+01_JPRB, 0.179189E+01_JPRB, 0.177987E+01_JPRB &
  &, 0.176750E+01_JPRB, 0.175476E+01_JPRB, 0.174167E+01_JPRB, 0.172823E+01_JPRB &
  &, 0.171447E+01_JPRB, 0.170035E+01_JPRB, 0.168594E+01_JPRB &
  &, 0.167125E+01_JPRB, 0.165623E+01_JPRB, 0.164094E+01_JPRB, 0.162539E+01_JPRB &
  &, 0.160960E+01_JPRB, 0.159355E+01_JPRB, 0.157723E+01_JPRB &
  &, 0.156072E+01_JPRB, 0.154400E+01_JPRB, 0.152707E+01_JPRB, 0.150992E+01_JPRB &
  &, 0.149261E+01_JPRB, 0.147515E+01_JPRB, 0.145751E+01_JPRB &
  &, 0.143973E+01_JPRB, 0.142185E+01_JPRB, 0.140379E+01_JPRB, 0.138564E+01_JPRB &
  &, 0.136735E+01_JPRB, 0.134902E+01_JPRB, 0.133042E+01_JPRB &
  &, 0.131206E+01_JPRB, 0.129346E+01_JPRB, 0.127485E+01_JPRB, 0.125617E+01_JPRB &
  &, 0.123745E+01_JPRB, 0.121872E+01_JPRB, 0.120001E+01_JPRB &
  &, 0.118126E+01_JPRB, 0.116252E+01_JPRB, 0.114379E+01_JPRB, 0.112504E+01_JPRB &
  &, 0.110641E+01_JPRB, 0.108775E+01_JPRB, 0.106916E+01_JPRB &
  &, 0.105065E+01_JPRB, 0.103215E+01_JPRB, 0.101379E+01_JPRB, 0.995432E+00_JPRB &
  &, 0.977214E+00_JPRB, 0.959106E+00_JPRB, 0.941073E+00_JPRB &
  &, 0.923141E+00_JPRB, 0.905334E+00_JPRB, 0.887617E+00_JPRB, 0.870074E+00_JPRB &
  &, 0.852671E+00_JPRB, 0.835365E+00_JPRB, 0.818245E+00_JPRB/)
XCW( 837, :) = (/ &
  &  0.109787E+01_JPRB, 0.112218E+01_JPRB, 0.114641E+01_JPRB, 0.117052E+01_JPRB &
  &, 0.119452E+01_JPRB, 0.121837E+01_JPRB, 0.124208E+01_JPRB &
  &, 0.126562E+01_JPRB, 0.128898E+01_JPRB, 0.131214E+01_JPRB, 0.133509E+01_JPRB &
  &, 0.135782E+01_JPRB, 0.138030E+01_JPRB, 0.140253E+01_JPRB &
  &, 0.142450E+01_JPRB, 0.144618E+01_JPRB, 0.146756E+01_JPRB, 0.148863E+01_JPRB &
  &, 0.150938E+01_JPRB, 0.152979E+01_JPRB, 0.154985E+01_JPRB &
  &, 0.156954E+01_JPRB, 0.158885E+01_JPRB, 0.160777E+01_JPRB, 0.162630E+01_JPRB &
  &, 0.164440E+01_JPRB, 0.166208E+01_JPRB, 0.167931E+01_JPRB &
  &, 0.169610E+01_JPRB, 0.171243E+01_JPRB, 0.172828E+01_JPRB, 0.174366E+01_JPRB &
  &, 0.175855E+01_JPRB, 0.177293E+01_JPRB, 0.178680E+01_JPRB &
  &, 0.180016E+01_JPRB, 0.181300E+01_JPRB, 0.182530E+01_JPRB, 0.183707E+01_JPRB &
  &, 0.184829E+01_JPRB, 0.185896E+01_JPRB, 0.186908E+01_JPRB &
  &, 0.187864E+01_JPRB, 0.188764E+01_JPRB, 0.189605E+01_JPRB, 0.190391E+01_JPRB &
  &, 0.191120E+01_JPRB, 0.191790E+01_JPRB, 0.192402E+01_JPRB &
  &, 0.192958E+01_JPRB, 0.193455E+01_JPRB, 0.193893E+01_JPRB, 0.194274E+01_JPRB &
  &, 0.194597E+01_JPRB, 0.194863E+01_JPRB, 0.195072E+01_JPRB &
  &, 0.195222E+01_JPRB, 0.195315E+01_JPRB, 0.195352E+01_JPRB, 0.195332E+01_JPRB &
  &, 0.195255E+01_JPRB, 0.195124E+01_JPRB, 0.194936E+01_JPRB &
  &, 0.194694E+01_JPRB, 0.194398E+01_JPRB, 0.194047E+01_JPRB, 0.193644E+01_JPRB &
  &, 0.193190E+01_JPRB, 0.192682E+01_JPRB, 0.192123E+01_JPRB &
  &, 0.191515E+01_JPRB, 0.190856E+01_JPRB, 0.190147E+01_JPRB, 0.189393E+01_JPRB &
  &, 0.188588E+01_JPRB, 0.187739E+01_JPRB, 0.186769E+01_JPRB &
  &, 0.185904E+01_JPRB, 0.184921E+01_JPRB, 0.183893E+01_JPRB, 0.182823E+01_JPRB &
  &, 0.181714E+01_JPRB, 0.180565E+01_JPRB, 0.179375E+01_JPRB &
  &, 0.178148E+01_JPRB, 0.176887E+01_JPRB, 0.175587E+01_JPRB, 0.174252E+01_JPRB &
  &, 0.172884E+01_JPRB, 0.171483E+01_JPRB, 0.170050E+01_JPRB &
  &, 0.168585E+01_JPRB, 0.167093E+01_JPRB, 0.165573E+01_JPRB, 0.164025E+01_JPRB &
  &, 0.162448E+01_JPRB, 0.160848E+01_JPRB, 0.159225E+01_JPRB &
  &, 0.157578E+01_JPRB, 0.155910E+01_JPRB, 0.154220E+01_JPRB, 0.152512E+01_JPRB &
  &, 0.150784E+01_JPRB, 0.149039E+01_JPRB, 0.147281E+01_JPRB &
  &, 0.145504E+01_JPRB, 0.143712E+01_JPRB, 0.141910E+01_JPRB, 0.140094E+01_JPRB &
  &, 0.138268E+01_JPRB, 0.136433E+01_JPRB, 0.134588E+01_JPRB &
  &, 0.132737E+01_JPRB, 0.130877E+01_JPRB, 0.129011E+01_JPRB, 0.127139E+01_JPRB &
  &, 0.125266E+01_JPRB, 0.123392E+01_JPRB, 0.121510E+01_JPRB &
  &, 0.119631E+01_JPRB, 0.117755E+01_JPRB, 0.115873E+01_JPRB, 0.113999E+01_JPRB &
  &, 0.112125E+01_JPRB, 0.110254E+01_JPRB, 0.108389E+01_JPRB &
  &, 0.106526E+01_JPRB, 0.104674E+01_JPRB, 0.102825E+01_JPRB, 0.100986E+01_JPRB &
  &, 0.991552E+00_JPRB, 0.973345E+00_JPRB, 0.955207E+00_JPRB &
  &, 0.937164E+00_JPRB, 0.919239E+00_JPRB, 0.901458E+00_JPRB, 0.883785E+00_JPRB &
  &, 0.866242E+00_JPRB, 0.848856E+00_JPRB, 0.831584E+00_JPRB/)
XCW( 838, :) = (/ &
  &  0.109830E+01_JPRB, 0.112273E+01_JPRB, 0.114707E+01_JPRB, 0.117131E+01_JPRB &
  &, 0.119543E+01_JPRB, 0.121942E+01_JPRB, 0.124326E+01_JPRB &
  &, 0.126693E+01_JPRB, 0.129042E+01_JPRB, 0.131373E+01_JPRB, 0.133682E+01_JPRB &
  &, 0.135969E+01_JPRB, 0.138232E+01_JPRB, 0.140471E+01_JPRB &
  &, 0.142682E+01_JPRB, 0.144866E+01_JPRB, 0.147020E+01_JPRB, 0.149143E+01_JPRB &
  &, 0.151234E+01_JPRB, 0.153291E+01_JPRB, 0.155313E+01_JPRB &
  &, 0.157299E+01_JPRB, 0.159247E+01_JPRB, 0.161157E+01_JPRB, 0.163026E+01_JPRB &
  &, 0.164854E+01_JPRB, 0.166640E+01_JPRB, 0.168381E+01_JPRB &
  &, 0.170078E+01_JPRB, 0.171729E+01_JPRB, 0.173332E+01_JPRB, 0.174888E+01_JPRB &
  &, 0.176395E+01_JPRB, 0.177852E+01_JPRB, 0.179259E+01_JPRB &
  &, 0.180613E+01_JPRB, 0.181915E+01_JPRB, 0.183165E+01_JPRB, 0.184360E+01_JPRB &
  &, 0.185502E+01_JPRB, 0.186587E+01_JPRB, 0.187618E+01_JPRB &
  &, 0.188591E+01_JPRB, 0.189512E+01_JPRB, 0.190373E+01_JPRB, 0.191178E+01_JPRB &
  &, 0.191924E+01_JPRB, 0.192614E+01_JPRB, 0.193246E+01_JPRB &
  &, 0.193819E+01_JPRB, 0.194335E+01_JPRB, 0.194793E+01_JPRB, 0.195193E+01_JPRB &
  &, 0.195535E+01_JPRB, 0.195818E+01_JPRB, 0.196044E+01_JPRB &
  &, 0.196213E+01_JPRB, 0.196324E+01_JPRB, 0.196379E+01_JPRB, 0.196377E+01_JPRB &
  &, 0.196318E+01_JPRB, 0.196204E+01_JPRB, 0.196033E+01_JPRB &
  &, 0.195809E+01_JPRB, 0.195529E+01_JPRB, 0.195196E+01_JPRB, 0.194809E+01_JPRB &
  &, 0.194369E+01_JPRB, 0.193878E+01_JPRB, 0.193335E+01_JPRB &
  &, 0.192742E+01_JPRB, 0.192098E+01_JPRB, 0.191404E+01_JPRB, 0.190665E+01_JPRB &
  &, 0.189875E+01_JPRB, 0.189039E+01_JPRB, 0.188158E+01_JPRB &
  &, 0.187232E+01_JPRB, 0.186260E+01_JPRB, 0.185247E+01_JPRB, 0.184191E+01_JPRB &
  &, 0.183092E+01_JPRB, 0.181954E+01_JPRB, 0.180777E+01_JPRB &
  &, 0.179560E+01_JPRB, 0.178308E+01_JPRB, 0.177018E+01_JPRB, 0.175695E+01_JPRB &
  &, 0.174336E+01_JPRB, 0.172943E+01_JPRB, 0.171518E+01_JPRB &
  &, 0.170064E+01_JPRB, 0.168579E+01_JPRB, 0.167066E+01_JPRB, 0.165524E+01_JPRB &
  &, 0.163953E+01_JPRB, 0.162362E+01_JPRB, 0.160744E+01_JPRB &
  &, 0.159102E+01_JPRB, 0.157438E+01_JPRB, 0.155752E+01_JPRB, 0.154047E+01_JPRB &
  &, 0.152322E+01_JPRB, 0.150583E+01_JPRB, 0.148823E+01_JPRB &
  &, 0.147051E+01_JPRB, 0.145259E+01_JPRB, 0.143458E+01_JPRB, 0.141646E+01_JPRB &
  &, 0.139818E+01_JPRB, 0.137981E+01_JPRB, 0.136134E+01_JPRB &
  &, 0.134285E+01_JPRB, 0.132421E+01_JPRB, 0.130557E+01_JPRB, 0.128684E+01_JPRB &
  &, 0.126806E+01_JPRB, 0.124926E+01_JPRB, 0.123042E+01_JPRB &
  &, 0.121162E+01_JPRB, 0.119278E+01_JPRB, 0.117393E+01_JPRB, 0.115510E+01_JPRB &
  &, 0.113631E+01_JPRB, 0.111755E+01_JPRB, 0.109884E+01_JPRB &
  &, 0.108015E+01_JPRB, 0.106156E+01_JPRB, 0.104299E+01_JPRB, 0.102452E+01_JPRB &
  &, 0.100612E+01_JPRB, 0.987761E+00_JPRB, 0.969581E+00_JPRB &
  &, 0.951429E+00_JPRB, 0.933451E+00_JPRB, 0.915549E+00_JPRB, 0.897748E+00_JPRB &
  &, 0.880134E+00_JPRB, 0.862607E+00_JPRB, 0.845252E+00_JPRB/)
XCW( 839, :) = (/ &
  &  0.109874E+01_JPRB, 0.112328E+01_JPRB, 0.114775E+01_JPRB, 0.117211E+01_JPRB &
  &, 0.119635E+01_JPRB, 0.122047E+01_JPRB, 0.124444E+01_JPRB &
  &, 0.126825E+01_JPRB, 0.129188E+01_JPRB, 0.131532E+01_JPRB, 0.133856E+01_JPRB &
  &, 0.136158E+01_JPRB, 0.138436E+01_JPRB, 0.140689E+01_JPRB &
  &, 0.142916E+01_JPRB, 0.145115E+01_JPRB, 0.147285E+01_JPRB, 0.149424E+01_JPRB &
  &, 0.151531E+01_JPRB, 0.153605E+01_JPRB, 0.155644E+01_JPRB &
  &, 0.157647E+01_JPRB, 0.159612E+01_JPRB, 0.161539E+01_JPRB, 0.163425E+01_JPRB &
  &, 0.165271E+01_JPRB, 0.167074E+01_JPRB, 0.168834E+01_JPRB &
  &, 0.170548E+01_JPRB, 0.172218E+01_JPRB, 0.173840E+01_JPRB, 0.175414E+01_JPRB &
  &, 0.176939E+01_JPRB, 0.178415E+01_JPRB, 0.179840E+01_JPRB &
  &, 0.181214E+01_JPRB, 0.182534E+01_JPRB, 0.183803E+01_JPRB, 0.185017E+01_JPRB &
  &, 0.186178E+01_JPRB, 0.187283E+01_JPRB, 0.188333E+01_JPRB &
  &, 0.189327E+01_JPRB, 0.190264E+01_JPRB, 0.191145E+01_JPRB, 0.191969E+01_JPRB &
  &, 0.192735E+01_JPRB, 0.193439E+01_JPRB, 0.194094E+01_JPRB &
  &, 0.194687E+01_JPRB, 0.195222E+01_JPRB, 0.195699E+01_JPRB, 0.196117E+01_JPRB &
  &, 0.196477E+01_JPRB, 0.196780E+01_JPRB, 0.197025E+01_JPRB &
  &, 0.197212E+01_JPRB, 0.197342E+01_JPRB, 0.197414E+01_JPRB, 0.197429E+01_JPRB &
  &, 0.197389E+01_JPRB, 0.197292E+01_JPRB, 0.197139E+01_JPRB &
  &, 0.196932E+01_JPRB, 0.196670E+01_JPRB, 0.196353E+01_JPRB, 0.195982E+01_JPRB &
  &, 0.195559E+01_JPRB, 0.195085E+01_JPRB, 0.194557E+01_JPRB &
  &, 0.193980E+01_JPRB, 0.193351E+01_JPRB, 0.192673E+01_JPRB, 0.191946E+01_JPRB &
  &, 0.191173E+01_JPRB, 0.190352E+01_JPRB, 0.189484E+01_JPRB &
  &, 0.188569E+01_JPRB, 0.187612E+01_JPRB, 0.186610E+01_JPRB, 0.185568E+01_JPRB &
  &, 0.184483E+01_JPRB, 0.183356E+01_JPRB, 0.182190E+01_JPRB &
  &, 0.180986E+01_JPRB, 0.179744E+01_JPRB, 0.178463E+01_JPRB, 0.177149E+01_JPRB &
  &, 0.175799E+01_JPRB, 0.174419E+01_JPRB, 0.173001E+01_JPRB &
  &, 0.171555E+01_JPRB, 0.170078E+01_JPRB, 0.168572E+01_JPRB, 0.167037E+01_JPRB &
  &, 0.165475E+01_JPRB, 0.163887E+01_JPRB, 0.162278E+01_JPRB &
  &, 0.160640E+01_JPRB, 0.158981E+01_JPRB, 0.157299E+01_JPRB, 0.155601E+01_JPRB &
  &, 0.153879E+01_JPRB, 0.152139E+01_JPRB, 0.150384E+01_JPRB &
  &, 0.148614E+01_JPRB, 0.146827E+01_JPRB, 0.145026E+01_JPRB, 0.143214E+01_JPRB &
  &, 0.141385E+01_JPRB, 0.139552E+01_JPRB, 0.137703E+01_JPRB &
  &, 0.135851E+01_JPRB, 0.133989E+01_JPRB, 0.132116E+01_JPRB, 0.130243E+01_JPRB &
  &, 0.128366E+01_JPRB, 0.126480E+01_JPRB, 0.124595E+01_JPRB &
  &, 0.122707E+01_JPRB, 0.120821E+01_JPRB, 0.118933E+01_JPRB, 0.117046E+01_JPRB &
  &, 0.115158E+01_JPRB, 0.113277E+01_JPRB, 0.111395E+01_JPRB &
  &, 0.109520E+01_JPRB, 0.107654E+01_JPRB, 0.105790E+01_JPRB, 0.103935E+01_JPRB &
  &, 0.102087E+01_JPRB, 0.100247E+01_JPRB, 0.984135E+00_JPRB &
  &, 0.965937E+00_JPRB, 0.947786E+00_JPRB, 0.929827E+00_JPRB, 0.911963E+00_JPRB &
  &, 0.894154E+00_JPRB, 0.876552E+00_JPRB, 0.859052E+00_JPRB/)
XCW( 840, :) = (/ &
  &  0.109917E+01_JPRB, 0.112384E+01_JPRB, 0.114842E+01_JPRB, 0.117291E+01_JPRB &
  &, 0.119728E+01_JPRB, 0.122152E+01_JPRB, 0.124563E+01_JPRB &
  &, 0.126957E+01_JPRB, 0.129334E+01_JPRB, 0.131692E+01_JPRB, 0.134030E+01_JPRB &
  &, 0.136347E+01_JPRB, 0.138640E+01_JPRB, 0.140908E+01_JPRB &
  &, 0.143151E+01_JPRB, 0.145366E+01_JPRB, 0.147551E+01_JPRB, 0.149707E+01_JPRB &
  &, 0.151830E+01_JPRB, 0.153920E+01_JPRB, 0.155976E+01_JPRB &
  &, 0.157996E+01_JPRB, 0.159979E+01_JPRB, 0.161923E+01_JPRB, 0.163827E+01_JPRB &
  &, 0.165690E+01_JPRB, 0.167511E+01_JPRB, 0.169289E+01_JPRB &
  &, 0.171022E+01_JPRB, 0.172709E+01_JPRB, 0.174350E+01_JPRB, 0.175942E+01_JPRB &
  &, 0.177487E+01_JPRB, 0.178981E+01_JPRB, 0.180425E+01_JPRB &
  &, 0.181817E+01_JPRB, 0.183158E+01_JPRB, 0.184445E+01_JPRB, 0.185679E+01_JPRB &
  &, 0.186858E+01_JPRB, 0.187983E+01_JPRB, 0.189052E+01_JPRB &
  &, 0.190065E+01_JPRB, 0.191023E+01_JPRB, 0.191922E+01_JPRB, 0.192765E+01_JPRB &
  &, 0.193549E+01_JPRB, 0.194279E+01_JPRB, 0.194948E+01_JPRB &
  &, 0.195561E+01_JPRB, 0.196115E+01_JPRB, 0.196610E+01_JPRB, 0.197048E+01_JPRB &
  &, 0.197427E+01_JPRB, 0.197748E+01_JPRB, 0.198011E+01_JPRB &
  &, 0.198218E+01_JPRB, 0.198366E+01_JPRB, 0.198456E+01_JPRB, 0.198490E+01_JPRB &
  &, 0.198467E+01_JPRB, 0.198389E+01_JPRB, 0.198254E+01_JPRB &
  &, 0.198064E+01_JPRB, 0.197818E+01_JPRB, 0.197518E+01_JPRB, 0.197166E+01_JPRB &
  &, 0.196758E+01_JPRB, 0.196301E+01_JPRB, 0.195790E+01_JPRB &
  &, 0.195226E+01_JPRB, 0.194615E+01_JPRB, 0.193952E+01_JPRB, 0.193241E+01_JPRB &
  &, 0.192481E+01_JPRB, 0.191675E+01_JPRB, 0.190819E+01_JPRB &
  &, 0.189922E+01_JPRB, 0.188977E+01_JPRB, 0.187989E+01_JPRB, 0.186959E+01_JPRB &
  &, 0.185885E+01_JPRB, 0.184771E+01_JPRB, 0.183616E+01_JPRB &
  &, 0.182423E+01_JPRB, 0.181191E+01_JPRB, 0.179923E+01_JPRB, 0.178619E+01_JPRB &
  &, 0.177281E+01_JPRB, 0.175906E+01_JPRB, 0.174500E+01_JPRB &
  &, 0.173063E+01_JPRB, 0.171593E+01_JPRB, 0.170095E+01_JPRB, 0.168566E+01_JPRB &
  &, 0.167011E+01_JPRB, 0.165432E+01_JPRB, 0.163825E+01_JPRB &
  &, 0.162196E+01_JPRB, 0.160542E+01_JPRB, 0.158864E+01_JPRB, 0.157170E+01_JPRB &
  &, 0.155451E+01_JPRB, 0.153718E+01_JPRB, 0.151965E+01_JPRB &
  &, 0.150193E+01_JPRB, 0.148411E+01_JPRB, 0.146611E+01_JPRB, 0.144799E+01_JPRB &
  &, 0.142974E+01_JPRB, 0.141135E+01_JPRB, 0.139289E+01_JPRB &
  &, 0.137434E+01_JPRB, 0.135570E+01_JPRB, 0.133703E+01_JPRB, 0.131822E+01_JPRB &
  &, 0.129944E+01_JPRB, 0.128058E+01_JPRB, 0.126167E+01_JPRB &
  &, 0.124273E+01_JPRB, 0.122384E+01_JPRB, 0.120488E+01_JPRB, 0.118598E+01_JPRB &
  &, 0.116706E+01_JPRB, 0.114815E+01_JPRB, 0.112933E+01_JPRB &
  &, 0.111052E+01_JPRB, 0.109175E+01_JPRB, 0.107304E+01_JPRB, 0.105441E+01_JPRB &
  &, 0.103585E+01_JPRB, 0.101736E+01_JPRB, 0.998928E+00_JPRB &
  &, 0.980628E+00_JPRB, 0.962429E+00_JPRB, 0.944292E+00_JPRB, 0.926305E+00_JPRB &
  &, 0.908494E+00_JPRB, 0.890757E+00_JPRB, 0.873114E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART120',1,ZHOOK_HANDLE)
END SUBROUTINE PART120

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART121

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART121',0,ZHOOK_HANDLE)

XCW( 841, :) = (/ &
  &  0.109961E+01_JPRB, 0.112439E+01_JPRB, 0.114910E+01_JPRB, 0.117371E+01_JPRB &
  &, 0.119821E+01_JPRB, 0.122258E+01_JPRB, 0.124682E+01_JPRB &
  &, 0.127090E+01_JPRB, 0.129481E+01_JPRB, 0.131853E+01_JPRB, 0.134206E+01_JPRB &
  &, 0.136537E+01_JPRB, 0.138845E+01_JPRB, 0.141129E+01_JPRB &
  &, 0.143387E+01_JPRB, 0.145617E+01_JPRB, 0.147819E+01_JPRB, 0.149991E+01_JPRB &
  &, 0.152131E+01_JPRB, 0.154238E+01_JPRB, 0.156310E+01_JPRB &
  &, 0.158347E+01_JPRB, 0.160347E+01_JPRB, 0.162309E+01_JPRB, 0.164231E+01_JPRB &
  &, 0.166112E+01_JPRB, 0.167951E+01_JPRB, 0.169746E+01_JPRB &
  &, 0.171496E+01_JPRB, 0.173203E+01_JPRB, 0.174863E+01_JPRB, 0.176474E+01_JPRB &
  &, 0.178037E+01_JPRB, 0.179551E+01_JPRB, 0.181014E+01_JPRB &
  &, 0.182425E+01_JPRB, 0.183784E+01_JPRB, 0.185091E+01_JPRB, 0.186345E+01_JPRB &
  &, 0.187543E+01_JPRB, 0.188688E+01_JPRB, 0.189776E+01_JPRB &
  &, 0.190809E+01_JPRB, 0.191786E+01_JPRB, 0.192705E+01_JPRB, 0.193568E+01_JPRB &
  &, 0.194373E+01_JPRB, 0.195119E+01_JPRB, 0.195809E+01_JPRB &
  &, 0.196440E+01_JPRB, 0.197014E+01_JPRB, 0.197529E+01_JPRB, 0.197985E+01_JPRB &
  &, 0.198383E+01_JPRB, 0.198724E+01_JPRB, 0.199006E+01_JPRB &
  &, 0.199230E+01_JPRB, 0.199397E+01_JPRB, 0.199507E+01_JPRB, 0.199559E+01_JPRB &
  &, 0.199555E+01_JPRB, 0.199493E+01_JPRB, 0.199377E+01_JPRB &
  &, 0.199204E+01_JPRB, 0.198976E+01_JPRB, 0.198694E+01_JPRB, 0.198357E+01_JPRB &
  &, 0.197968E+01_JPRB, 0.197526E+01_JPRB, 0.197031E+01_JPRB &
  &, 0.196485E+01_JPRB, 0.195888E+01_JPRB, 0.195238E+01_JPRB, 0.194544E+01_JPRB &
  &, 0.193800E+01_JPRB, 0.193009E+01_JPRB, 0.192169E+01_JPRB &
  &, 0.191284E+01_JPRB, 0.190353E+01_JPRB, 0.189378E+01_JPRB, 0.188359E+01_JPRB &
  &, 0.187300E+01_JPRB, 0.186198E+01_JPRB, 0.185056E+01_JPRB &
  &, 0.183874E+01_JPRB, 0.182655E+01_JPRB, 0.181397E+01_JPRB, 0.180103E+01_JPRB &
  &, 0.178775E+01_JPRB, 0.177409E+01_JPRB, 0.176012E+01_JPRB &
  &, 0.174583E+01_JPRB, 0.173124E+01_JPRB, 0.171633E+01_JPRB, 0.170112E+01_JPRB &
  &, 0.168564E+01_JPRB, 0.166991E+01_JPRB, 0.165390E+01_JPRB &
  &, 0.163767E+01_JPRB, 0.162117E+01_JPRB, 0.160448E+01_JPRB, 0.158754E+01_JPRB &
  &, 0.157042E+01_JPRB, 0.155312E+01_JPRB, 0.153558E+01_JPRB &
  &, 0.151792E+01_JPRB, 0.150011E+01_JPRB, 0.148212E+01_JPRB, 0.146400E+01_JPRB &
  &, 0.144576E+01_JPRB, 0.142740E+01_JPRB, 0.140897E+01_JPRB &
  &, 0.139041E+01_JPRB, 0.137174E+01_JPRB, 0.135303E+01_JPRB, 0.133423E+01_JPRB &
  &, 0.131541E+01_JPRB, 0.129650E+01_JPRB, 0.127758E+01_JPRB &
  &, 0.125863E+01_JPRB, 0.123968E+01_JPRB, 0.122069E+01_JPRB, 0.120171E+01_JPRB &
  &, 0.118276E+01_JPRB, 0.116380E+01_JPRB, 0.114488E+01_JPRB &
  &, 0.112602E+01_JPRB, 0.110718E+01_JPRB, 0.108840E+01_JPRB, 0.106965E+01_JPRB &
  &, 0.105100E+01_JPRB, 0.103243E+01_JPRB, 0.101396E+01_JPRB &
  &, 0.995561E+00_JPRB, 0.977256E+00_JPRB, 0.959069E+00_JPRB, 0.940963E+00_JPRB &
  &, 0.922963E+00_JPRB, 0.905156E+00_JPRB, 0.887439E+00_JPRB/)
XCW( 842, :) = (/ &
  &  0.110005E+01_JPRB, 0.112495E+01_JPRB, 0.114978E+01_JPRB, 0.117451E+01_JPRB &
  &, 0.119914E+01_JPRB, 0.122365E+01_JPRB, 0.124802E+01_JPRB &
  &, 0.127223E+01_JPRB, 0.129629E+01_JPRB, 0.132015E+01_JPRB, 0.134382E+01_JPRB &
  &, 0.136728E+01_JPRB, 0.139052E+01_JPRB, 0.141351E+01_JPRB &
  &, 0.143624E+01_JPRB, 0.145871E+01_JPRB, 0.148089E+01_JPRB, 0.150276E+01_JPRB &
  &, 0.152433E+01_JPRB, 0.154557E+01_JPRB, 0.156646E+01_JPRB &
  &, 0.158701E+01_JPRB, 0.160718E+01_JPRB, 0.162697E+01_JPRB, 0.164636E+01_JPRB &
  &, 0.166534E+01_JPRB, 0.168393E+01_JPRB, 0.170207E+01_JPRB &
  &, 0.171976E+01_JPRB, 0.173701E+01_JPRB, 0.175379E+01_JPRB, 0.177009E+01_JPRB &
  &, 0.178591E+01_JPRB, 0.180124E+01_JPRB, 0.181604E+01_JPRB &
  &, 0.183037E+01_JPRB, 0.184416E+01_JPRB, 0.185742E+01_JPRB, 0.187014E+01_JPRB &
  &, 0.188233E+01_JPRB, 0.189397E+01_JPRB, 0.190505E+01_JPRB &
  &, 0.191557E+01_JPRB, 0.192553E+01_JPRB, 0.193493E+01_JPRB, 0.194375E+01_JPRB &
  &, 0.195200E+01_JPRB, 0.195966E+01_JPRB, 0.196673E+01_JPRB &
  &, 0.197326E+01_JPRB, 0.197920E+01_JPRB, 0.198454E+01_JPRB, 0.198929E+01_JPRB &
  &, 0.199347E+01_JPRB, 0.199706E+01_JPRB, 0.200008E+01_JPRB &
  &, 0.200251E+01_JPRB, 0.200437E+01_JPRB, 0.200565E+01_JPRB, 0.200636E+01_JPRB &
  &, 0.200650E+01_JPRB, 0.200606E+01_JPRB, 0.200508E+01_JPRB &
  &, 0.200352E+01_JPRB, 0.200137E+01_JPRB, 0.199879E+01_JPRB, 0.199560E+01_JPRB &
  &, 0.199187E+01_JPRB, 0.198761E+01_JPRB, 0.198283E+01_JPRB &
  &, 0.197753E+01_JPRB, 0.197173E+01_JPRB, 0.196541E+01_JPRB, 0.195861E+01_JPRB &
  &, 0.195130E+01_JPRB, 0.194353E+01_JPRB, 0.193521E+01_JPRB &
  &, 0.192658E+01_JPRB, 0.191743E+01_JPRB, 0.190780E+01_JPRB, 0.189776E+01_JPRB &
  &, 0.188728E+01_JPRB, 0.187640E+01_JPRB, 0.186510E+01_JPRB &
  &, 0.185339E+01_JPRB, 0.184131E+01_JPRB, 0.182883E+01_JPRB, 0.181602E+01_JPRB &
  &, 0.180271E+01_JPRB, 0.178927E+01_JPRB, 0.177539E+01_JPRB &
  &, 0.176121E+01_JPRB, 0.174668E+01_JPRB, 0.173185E+01_JPRB, 0.171675E+01_JPRB &
  &, 0.170134E+01_JPRB, 0.168568E+01_JPRB, 0.166973E+01_JPRB &
  &, 0.165355E+01_JPRB, 0.163711E+01_JPRB, 0.162046E+01_JPRB, 0.160357E+01_JPRB &
  &, 0.158649E+01_JPRB, 0.156922E+01_JPRB, 0.155175E+01_JPRB &
  &, 0.153411E+01_JPRB, 0.151632E+01_JPRB, 0.149834E+01_JPRB, 0.148023E+01_JPRB &
  &, 0.146203E+01_JPRB, 0.144367E+01_JPRB, 0.142519E+01_JPRB &
  &, 0.140665E+01_JPRB, 0.138800E+01_JPRB, 0.136927E+01_JPRB, 0.135044E+01_JPRB &
  &, 0.133158E+01_JPRB, 0.131267E+01_JPRB, 0.129370E+01_JPRB &
  &, 0.127474E+01_JPRB, 0.125571E+01_JPRB, 0.123671E+01_JPRB, 0.121770E+01_JPRB &
  &, 0.119866E+01_JPRB, 0.117967E+01_JPRB, 0.116070E+01_JPRB &
  &, 0.114173E+01_JPRB, 0.112284E+01_JPRB, 0.110399E+01_JPRB, 0.108517E+01_JPRB &
  &, 0.106644E+01_JPRB, 0.104779E+01_JPRB, 0.102917E+01_JPRB &
  &, 0.101068E+01_JPRB, 0.992268E+00_JPRB, 0.973970E+00_JPRB, 0.955811E+00_JPRB &
  &, 0.937687E+00_JPRB, 0.919750E+00_JPRB, 0.901961E+00_JPRB/)
XCW( 843, :) = (/ &
  &  0.110050E+01_JPRB, 0.112551E+01_JPRB, 0.115046E+01_JPRB, 0.117532E+01_JPRB &
  &, 0.120008E+01_JPRB, 0.122472E+01_JPRB, 0.124922E+01_JPRB &
  &, 0.127358E+01_JPRB, 0.129777E+01_JPRB, 0.132178E+01_JPRB, 0.134560E+01_JPRB &
  &, 0.136921E+01_JPRB, 0.139259E+01_JPRB, 0.141574E+01_JPRB &
  &, 0.143863E+01_JPRB, 0.146125E+01_JPRB, 0.148359E+01_JPRB, 0.150563E+01_JPRB &
  &, 0.152737E+01_JPRB, 0.154877E+01_JPRB, 0.156984E+01_JPRB &
  &, 0.159056E+01_JPRB, 0.161090E+01_JPRB, 0.163087E+01_JPRB, 0.165045E+01_JPRB &
  &, 0.166962E+01_JPRB, 0.168837E+01_JPRB, 0.170670E+01_JPRB &
  &, 0.172458E+01_JPRB, 0.174201E+01_JPRB, 0.175898E+01_JPRB, 0.177547E+01_JPRB &
  &, 0.179148E+01_JPRB, 0.180700E+01_JPRB, 0.182202E+01_JPRB &
  &, 0.183652E+01_JPRB, 0.185051E+01_JPRB, 0.186396E+01_JPRB, 0.187688E+01_JPRB &
  &, 0.188927E+01_JPRB, 0.190110E+01_JPRB, 0.191238E+01_JPRB &
  &, 0.192310E+01_JPRB, 0.193326E+01_JPRB, 0.194285E+01_JPRB, 0.195188E+01_JPRB &
  &, 0.196032E+01_JPRB, 0.196818E+01_JPRB, 0.197548E+01_JPRB &
  &, 0.198218E+01_JPRB, 0.198831E+01_JPRB, 0.199384E+01_JPRB, 0.199880E+01_JPRB &
  &, 0.200318E+01_JPRB, 0.200696E+01_JPRB, 0.201017E+01_JPRB &
  &, 0.201280E+01_JPRB, 0.201484E+01_JPRB, 0.201631E+01_JPRB, 0.201721E+01_JPRB &
  &, 0.201754E+01_JPRB, 0.201729E+01_JPRB, 0.201647E+01_JPRB &
  &, 0.201512E+01_JPRB, 0.201320E+01_JPRB, 0.201073E+01_JPRB, 0.200771E+01_JPRB &
  &, 0.200416E+01_JPRB, 0.200006E+01_JPRB, 0.199546E+01_JPRB &
  &, 0.199033E+01_JPRB, 0.198467E+01_JPRB, 0.197852E+01_JPRB, 0.197188E+01_JPRB &
  &, 0.196472E+01_JPRB, 0.195710E+01_JPRB, 0.194901E+01_JPRB &
  &, 0.194044E+01_JPRB, 0.193142E+01_JPRB, 0.192194E+01_JPRB, 0.191205E+01_JPRB &
  &, 0.190170E+01_JPRB, 0.189093E+01_JPRB, 0.187975E+01_JPRB &
  &, 0.186817E+01_JPRB, 0.185620E+01_JPRB, 0.184386E+01_JPRB, 0.183112E+01_JPRB &
  &, 0.181804E+01_JPRB, 0.180460E+01_JPRB, 0.179072E+01_JPRB &
  &, 0.177673E+01_JPRB, 0.176228E+01_JPRB, 0.174754E+01_JPRB, 0.173251E+01_JPRB &
  &, 0.171717E+01_JPRB, 0.170158E+01_JPRB, 0.168569E+01_JPRB &
  &, 0.166958E+01_JPRB, 0.165323E+01_JPRB, 0.163660E+01_JPRB, 0.161978E+01_JPRB &
  &, 0.160275E+01_JPRB, 0.158552E+01_JPRB, 0.156808E+01_JPRB &
  &, 0.155046E+01_JPRB, 0.153270E+01_JPRB, 0.151477E+01_JPRB, 0.149667E+01_JPRB &
  &, 0.147847E+01_JPRB, 0.146011E+01_JPRB, 0.144167E+01_JPRB &
  &, 0.142307E+01_JPRB, 0.140441E+01_JPRB, 0.138570E+01_JPRB, 0.136688E+01_JPRB &
  &, 0.134798E+01_JPRB, 0.132903E+01_JPRB, 0.131006E+01_JPRB &
  &, 0.129104E+01_JPRB, 0.127200E+01_JPRB, 0.125293E+01_JPRB, 0.123385E+01_JPRB &
  &, 0.121477E+01_JPRB, 0.119575E+01_JPRB, 0.117668E+01_JPRB &
  &, 0.115766E+01_JPRB, 0.113872E+01_JPRB, 0.111975E+01_JPRB, 0.110092E+01_JPRB &
  &, 0.108206E+01_JPRB, 0.106333E+01_JPRB, 0.104468E+01_JPRB &
  &, 0.102610E+01_JPRB, 0.100759E+01_JPRB, 0.989184E+00_JPRB, 0.970911E+00_JPRB &
  &, 0.952667E+00_JPRB, 0.934603E+00_JPRB, 0.916680E+00_JPRB/)
XCW( 844, :) = (/ &
  &  0.110094E+01_JPRB, 0.112608E+01_JPRB, 0.115115E+01_JPRB, 0.117614E+01_JPRB &
  &, 0.120102E+01_JPRB, 0.122579E+01_JPRB, 0.125043E+01_JPRB &
  &, 0.127493E+01_JPRB, 0.129926E+01_JPRB, 0.132342E+01_JPRB, 0.134738E+01_JPRB &
  &, 0.137114E+01_JPRB, 0.139468E+01_JPRB, 0.141797E+01_JPRB &
  &, 0.144103E+01_JPRB, 0.146381E+01_JPRB, 0.148631E+01_JPRB, 0.150852E+01_JPRB &
  &, 0.153042E+01_JPRB, 0.155200E+01_JPRB, 0.157324E+01_JPRB &
  &, 0.159413E+01_JPRB, 0.161465E+01_JPRB, 0.163480E+01_JPRB, 0.165456E+01_JPRB &
  &, 0.167391E+01_JPRB, 0.169285E+01_JPRB, 0.171135E+01_JPRB &
  &, 0.172943E+01_JPRB, 0.174705E+01_JPRB, 0.176421E+01_JPRB, 0.178089E+01_JPRB &
  &, 0.179709E+01_JPRB, 0.181281E+01_JPRB, 0.182802E+01_JPRB &
  &, 0.184271E+01_JPRB, 0.185690E+01_JPRB, 0.187055E+01_JPRB, 0.188367E+01_JPRB &
  &, 0.189626E+01_JPRB, 0.190829E+01_JPRB, 0.191976E+01_JPRB &
  &, 0.193069E+01_JPRB, 0.194105E+01_JPRB, 0.195084E+01_JPRB, 0.196006E+01_JPRB &
  &, 0.196870E+01_JPRB, 0.197677E+01_JPRB, 0.198426E+01_JPRB &
  &, 0.199117E+01_JPRB, 0.199749E+01_JPRB, 0.200323E+01_JPRB, 0.200839E+01_JPRB &
  &, 0.201295E+01_JPRB, 0.201693E+01_JPRB, 0.202034E+01_JPRB &
  &, 0.202315E+01_JPRB, 0.202540E+01_JPRB, 0.202705E+01_JPRB, 0.202814E+01_JPRB &
  &, 0.202865E+01_JPRB, 0.202859E+01_JPRB, 0.202798E+01_JPRB &
  &, 0.202679E+01_JPRB, 0.202506E+01_JPRB, 0.202277E+01_JPRB, 0.201991E+01_JPRB &
  &, 0.201655E+01_JPRB, 0.201264E+01_JPRB, 0.200818E+01_JPRB &
  &, 0.200321E+01_JPRB, 0.199774E+01_JPRB, 0.199175E+01_JPRB, 0.198525E+01_JPRB &
  &, 0.197828E+01_JPRB, 0.197080E+01_JPRB, 0.196286E+01_JPRB &
  &, 0.195443E+01_JPRB, 0.194556E+01_JPRB, 0.193623E+01_JPRB, 0.192644E+01_JPRB &
  &, 0.191624E+01_JPRB, 0.190560E+01_JPRB, 0.189456E+01_JPRB &
  &, 0.188310E+01_JPRB, 0.187124E+01_JPRB, 0.185901E+01_JPRB, 0.184641E+01_JPRB &
  &, 0.183343E+01_JPRB, 0.182009E+01_JPRB, 0.180640E+01_JPRB &
  &, 0.179240E+01_JPRB, 0.177805E+01_JPRB, 0.176341E+01_JPRB, 0.174844E+01_JPRB &
  &, 0.173321E+01_JPRB, 0.171765E+01_JPRB, 0.170187E+01_JPRB &
  &, 0.168582E+01_JPRB, 0.166949E+01_JPRB, 0.165295E+01_JPRB, 0.163619E+01_JPRB &
  &, 0.161920E+01_JPRB, 0.160201E+01_JPRB, 0.158460E+01_JPRB &
  &, 0.156701E+01_JPRB, 0.154927E+01_JPRB, 0.153137E+01_JPRB, 0.151328E+01_JPRB &
  &, 0.149509E+01_JPRB, 0.147677E+01_JPRB, 0.145828E+01_JPRB &
  &, 0.143972E+01_JPRB, 0.142108E+01_JPRB, 0.140231E+01_JPRB, 0.138346E+01_JPRB &
  &, 0.136457E+01_JPRB, 0.134563E+01_JPRB, 0.132661E+01_JPRB &
  &, 0.130754E+01_JPRB, 0.128845E+01_JPRB, 0.126936E+01_JPRB, 0.125025E+01_JPRB &
  &, 0.123115E+01_JPRB, 0.121204E+01_JPRB, 0.119294E+01_JPRB &
  &, 0.117387E+01_JPRB, 0.115482E+01_JPRB, 0.113580E+01_JPRB, 0.111684E+01_JPRB &
  &, 0.109797E+01_JPRB, 0.107910E+01_JPRB, 0.106038E+01_JPRB &
  &, 0.104170E+01_JPRB, 0.102309E+01_JPRB, 0.100458E+01_JPRB, 0.986201E+00_JPRB &
  &, 0.967904E+00_JPRB, 0.949716E+00_JPRB, 0.931662E+00_JPRB/)
XCW( 845, :) = (/ &
  &  0.110139E+01_JPRB, 0.112665E+01_JPRB, 0.115184E+01_JPRB, 0.117695E+01_JPRB &
  &, 0.120197E+01_JPRB, 0.122687E+01_JPRB, 0.125165E+01_JPRB &
  &, 0.127628E+01_JPRB, 0.130076E+01_JPRB, 0.132506E+01_JPRB, 0.134917E+01_JPRB &
  &, 0.137308E+01_JPRB, 0.139677E+01_JPRB, 0.142023E+01_JPRB &
  &, 0.144344E+01_JPRB, 0.146638E+01_JPRB, 0.148905E+01_JPRB, 0.151143E+01_JPRB &
  &, 0.153349E+01_JPRB, 0.155524E+01_JPRB, 0.157665E+01_JPRB &
  &, 0.159772E+01_JPRB, 0.161842E+01_JPRB, 0.163875E+01_JPRB, 0.165869E+01_JPRB &
  &, 0.167822E+01_JPRB, 0.169735E+01_JPRB, 0.171604E+01_JPRB &
  &, 0.173430E+01_JPRB, 0.175211E+01_JPRB, 0.176946E+01_JPRB, 0.178634E+01_JPRB &
  &, 0.180273E+01_JPRB, 0.181865E+01_JPRB, 0.183405E+01_JPRB &
  &, 0.184895E+01_JPRB, 0.186333E+01_JPRB, 0.187718E+01_JPRB, 0.189050E+01_JPRB &
  &, 0.190329E+01_JPRB, 0.191552E+01_JPRB, 0.192720E+01_JPRB &
  &, 0.193832E+01_JPRB, 0.194888E+01_JPRB, 0.195888E+01_JPRB, 0.196830E+01_JPRB &
  &, 0.197715E+01_JPRB, 0.198542E+01_JPRB, 0.199311E+01_JPRB &
  &, 0.200022E+01_JPRB, 0.200675E+01_JPRB, 0.201267E+01_JPRB, 0.201803E+01_JPRB &
  &, 0.202279E+01_JPRB, 0.202698E+01_JPRB, 0.203058E+01_JPRB &
  &, 0.203360E+01_JPRB, 0.203603E+01_JPRB, 0.203789E+01_JPRB, 0.203916E+01_JPRB &
  &, 0.203986E+01_JPRB, 0.204000E+01_JPRB, 0.203955E+01_JPRB &
  &, 0.203857E+01_JPRB, 0.203700E+01_JPRB, 0.203490E+01_JPRB, 0.203224E+01_JPRB &
  &, 0.202904E+01_JPRB, 0.202530E+01_JPRB, 0.202103E+01_JPRB &
  &, 0.201622E+01_JPRB, 0.201092E+01_JPRB, 0.200509E+01_JPRB, 0.199876E+01_JPRB &
  &, 0.199193E+01_JPRB, 0.198461E+01_JPRB, 0.197681E+01_JPRB &
  &, 0.196856E+01_JPRB, 0.195982E+01_JPRB, 0.195063E+01_JPRB, 0.194099E+01_JPRB &
  &, 0.193092E+01_JPRB, 0.192042E+01_JPRB, 0.190951E+01_JPRB &
  &, 0.189816E+01_JPRB, 0.188645E+01_JPRB, 0.187433E+01_JPRB, 0.186181E+01_JPRB &
  &, 0.184896E+01_JPRB, 0.183573E+01_JPRB, 0.182213E+01_JPRB &
  &, 0.180824E+01_JPRB, 0.179397E+01_JPRB, 0.177943E+01_JPRB, 0.176453E+01_JPRB &
  &, 0.174938E+01_JPRB, 0.173394E+01_JPRB, 0.171819E+01_JPRB &
  &, 0.170221E+01_JPRB, 0.168594E+01_JPRB, 0.166945E+01_JPRB, 0.165274E+01_JPRB &
  &, 0.163580E+01_JPRB, 0.161865E+01_JPRB, 0.160128E+01_JPRB &
  &, 0.158377E+01_JPRB, 0.156605E+01_JPRB, 0.154817E+01_JPRB, 0.153010E+01_JPRB &
  &, 0.151192E+01_JPRB, 0.149361E+01_JPRB, 0.147516E+01_JPRB &
  &, 0.145659E+01_JPRB, 0.143790E+01_JPRB, 0.141915E+01_JPRB, 0.140032E+01_JPRB &
  &, 0.138141E+01_JPRB, 0.136243E+01_JPRB, 0.134336E+01_JPRB &
  &, 0.132429E+01_JPRB, 0.130519E+01_JPRB, 0.128604E+01_JPRB, 0.126687E+01_JPRB &
  &, 0.124769E+01_JPRB, 0.122855E+01_JPRB, 0.120936E+01_JPRB &
  &, 0.119025E+01_JPRB, 0.117115E+01_JPRB, 0.115207E+01_JPRB, 0.113305E+01_JPRB &
  &, 0.111406E+01_JPRB, 0.109517E+01_JPRB, 0.107631E+01_JPRB &
  &, 0.105754E+01_JPRB, 0.103884E+01_JPRB, 0.102023E+01_JPRB, 0.100174E+01_JPRB &
  &, 0.983396E+00_JPRB, 0.965088E+00_JPRB, 0.946908E+00_JPRB/)
XCW( 846, :) = (/ &
  &  0.110184E+01_JPRB, 0.112722E+01_JPRB, 0.115253E+01_JPRB, 0.117777E+01_JPRB &
  &, 0.120292E+01_JPRB, 0.122796E+01_JPRB, 0.125287E+01_JPRB &
  &, 0.127764E+01_JPRB, 0.130226E+01_JPRB, 0.132671E+01_JPRB, 0.135097E+01_JPRB &
  &, 0.137503E+01_JPRB, 0.139888E+01_JPRB, 0.142249E+01_JPRB &
  &, 0.144586E+01_JPRB, 0.146897E+01_JPRB, 0.149180E+01_JPRB, 0.151434E+01_JPRB &
  &, 0.153658E+01_JPRB, 0.155850E+01_JPRB, 0.158009E+01_JPRB &
  &, 0.160133E+01_JPRB, 0.162221E+01_JPRB, 0.164272E+01_JPRB, 0.166284E+01_JPRB &
  &, 0.168256E+01_JPRB, 0.170187E+01_JPRB, 0.172076E+01_JPRB &
  &, 0.173920E+01_JPRB, 0.175721E+01_JPRB, 0.177475E+01_JPRB, 0.179182E+01_JPRB &
  &, 0.180841E+01_JPRB, 0.182452E+01_JPRB, 0.184012E+01_JPRB &
  &, 0.185522E+01_JPRB, 0.186980E+01_JPRB, 0.188386E+01_JPRB, 0.189737E+01_JPRB &
  &, 0.191036E+01_JPRB, 0.192280E+01_JPRB, 0.193468E+01_JPRB &
  &, 0.194600E+01_JPRB, 0.195677E+01_JPRB, 0.196697E+01_JPRB, 0.197660E+01_JPRB &
  &, 0.198565E+01_JPRB, 0.199412E+01_JPRB, 0.200202E+01_JPRB &
  &, 0.200933E+01_JPRB, 0.201606E+01_JPRB, 0.202220E+01_JPRB, 0.202775E+01_JPRB &
  &, 0.203272E+01_JPRB, 0.203710E+01_JPRB, 0.204089E+01_JPRB &
  &, 0.204411E+01_JPRB, 0.204675E+01_JPRB, 0.204879E+01_JPRB, 0.205026E+01_JPRB &
  &, 0.205116E+01_JPRB, 0.205147E+01_JPRB, 0.205123E+01_JPRB &
  &, 0.205042E+01_JPRB, 0.204906E+01_JPRB, 0.204713E+01_JPRB, 0.204465E+01_JPRB &
  &, 0.204162E+01_JPRB, 0.203805E+01_JPRB, 0.203395E+01_JPRB &
  &, 0.202934E+01_JPRB, 0.202418E+01_JPRB, 0.201855E+01_JPRB, 0.201238E+01_JPRB &
  &, 0.200571E+01_JPRB, 0.199856E+01_JPRB, 0.199090E+01_JPRB &
  &, 0.198279E+01_JPRB, 0.197421E+01_JPRB, 0.196515E+01_JPRB, 0.195567E+01_JPRB &
  &, 0.194572E+01_JPRB, 0.193538E+01_JPRB, 0.192459E+01_JPRB &
  &, 0.191337E+01_JPRB, 0.190177E+01_JPRB, 0.188977E+01_JPRB, 0.187739E+01_JPRB &
  &, 0.186465E+01_JPRB, 0.185152E+01_JPRB, 0.183803E+01_JPRB &
  &, 0.182423E+01_JPRB, 0.181006E+01_JPRB, 0.179560E+01_JPRB, 0.178083E+01_JPRB &
  &, 0.176572E+01_JPRB, 0.175036E+01_JPRB, 0.173469E+01_JPRB &
  &, 0.171877E+01_JPRB, 0.170260E+01_JPRB, 0.168618E+01_JPRB, 0.166949E+01_JPRB &
  &, 0.165259E+01_JPRB, 0.163549E+01_JPRB, 0.161820E+01_JPRB &
  &, 0.160068E+01_JPRB, 0.158300E+01_JPRB, 0.156514E+01_JPRB, 0.154713E+01_JPRB &
  &, 0.152896E+01_JPRB, 0.151066E+01_JPRB, 0.149221E+01_JPRB &
  &, 0.147364E+01_JPRB, 0.145498E+01_JPRB, 0.143622E+01_JPRB, 0.141737E+01_JPRB &
  &, 0.139843E+01_JPRB, 0.137942E+01_JPRB, 0.136036E+01_JPRB &
  &, 0.134124E+01_JPRB, 0.132209E+01_JPRB, 0.130293E+01_JPRB, 0.128369E+01_JPRB &
  &, 0.126449E+01_JPRB, 0.124527E+01_JPRB, 0.122610E+01_JPRB &
  &, 0.120690E+01_JPRB, 0.118770E+01_JPRB, 0.116857E+01_JPRB, 0.114949E+01_JPRB &
  &, 0.113044E+01_JPRB, 0.111142E+01_JPRB, 0.109248E+01_JPRB &
  &, 0.107363E+01_JPRB, 0.105484E+01_JPRB, 0.103620E+01_JPRB, 0.101760E+01_JPRB &
  &, 0.999081E+00_JPRB, 0.980655E+00_JPRB, 0.962415E+00_JPRB/)
XCW( 847, :) = (/ &
  &  0.110229E+01_JPRB, 0.112779E+01_JPRB, 0.115323E+01_JPRB, 0.117860E+01_JPRB &
  &, 0.120388E+01_JPRB, 0.122905E+01_JPRB, 0.125410E+01_JPRB &
  &, 0.127901E+01_JPRB, 0.130377E+01_JPRB, 0.132837E+01_JPRB, 0.135278E+01_JPRB &
  &, 0.137699E+01_JPRB, 0.140099E+01_JPRB, 0.142477E+01_JPRB &
  &, 0.144830E+01_JPRB, 0.147157E+01_JPRB, 0.149457E+01_JPRB, 0.151728E+01_JPRB &
  &, 0.153969E+01_JPRB, 0.156178E+01_JPRB, 0.158354E+01_JPRB &
  &, 0.160497E+01_JPRB, 0.162603E+01_JPRB, 0.164672E+01_JPRB, 0.166702E+01_JPRB &
  &, 0.168693E+01_JPRB, 0.170643E+01_JPRB, 0.172550E+01_JPRB &
  &, 0.174414E+01_JPRB, 0.176233E+01_JPRB, 0.178007E+01_JPRB, 0.179734E+01_JPRB &
  &, 0.181413E+01_JPRB, 0.183043E+01_JPRB, 0.184624E+01_JPRB &
  &, 0.186153E+01_JPRB, 0.187631E+01_JPRB, 0.189057E+01_JPRB, 0.190429E+01_JPRB &
  &, 0.191748E+01_JPRB, 0.193012E+01_JPRB, 0.194221E+01_JPRB &
  &, 0.195375E+01_JPRB, 0.196472E+01_JPRB, 0.197512E+01_JPRB, 0.198496E+01_JPRB &
  &, 0.199421E+01_JPRB, 0.200289E+01_JPRB, 0.201099E+01_JPRB &
  &, 0.201851E+01_JPRB, 0.202544E+01_JPRB, 0.203179E+01_JPRB, 0.203755E+01_JPRB &
  &, 0.204271E+01_JPRB, 0.204730E+01_JPRB, 0.205130E+01_JPRB &
  &, 0.205471E+01_JPRB, 0.205753E+01_JPRB, 0.205978E+01_JPRB, 0.206145E+01_JPRB &
  &, 0.206254E+01_JPRB, 0.206305E+01_JPRB, 0.206300E+01_JPRB &
  &, 0.206237E+01_JPRB, 0.206119E+01_JPRB, 0.205945E+01_JPRB, 0.205717E+01_JPRB &
  &, 0.205431E+01_JPRB, 0.205093E+01_JPRB, 0.204701E+01_JPRB &
  &, 0.204256E+01_JPRB, 0.203760E+01_JPRB, 0.203211E+01_JPRB, 0.202611E+01_JPRB &
  &, 0.201959E+01_JPRB, 0.201260E+01_JPRB, 0.200511E+01_JPRB &
  &, 0.199716E+01_JPRB, 0.198872E+01_JPRB, 0.197982E+01_JPRB, 0.197048E+01_JPRB &
  &, 0.196069E+01_JPRB, 0.195045E+01_JPRB, 0.193981E+01_JPRB &
  &, 0.192874E+01_JPRB, 0.191727E+01_JPRB, 0.190538E+01_JPRB, 0.189311E+01_JPRB &
  &, 0.188048E+01_JPRB, 0.186746E+01_JPRB, 0.185411E+01_JPRB &
  &, 0.184038E+01_JPRB, 0.182633E+01_JPRB, 0.181194E+01_JPRB, 0.179725E+01_JPRB &
  &, 0.178224E+01_JPRB, 0.176695E+01_JPRB, 0.175139E+01_JPRB &
  &, 0.173551E+01_JPRB, 0.171941E+01_JPRB, 0.170305E+01_JPRB, 0.168646E+01_JPRB &
  &, 0.166962E+01_JPRB, 0.165256E+01_JPRB, 0.163528E+01_JPRB &
  &, 0.161780E+01_JPRB, 0.160015E+01_JPRB, 0.158235E+01_JPRB, 0.156433E+01_JPRB &
  &, 0.154618E+01_JPRB, 0.152789E+01_JPRB, 0.150949E+01_JPRB &
  &, 0.149092E+01_JPRB, 0.147225E+01_JPRB, 0.145347E+01_JPRB, 0.143461E+01_JPRB &
  &, 0.141564E+01_JPRB, 0.139665E+01_JPRB, 0.137756E+01_JPRB &
  &, 0.135844E+01_JPRB, 0.133924E+01_JPRB, 0.132003E+01_JPRB, 0.130077E+01_JPRB &
  &, 0.128151E+01_JPRB, 0.126226E+01_JPRB, 0.124301E+01_JPRB &
  &, 0.122377E+01_JPRB, 0.120452E+01_JPRB, 0.118530E+01_JPRB, 0.116616E+01_JPRB &
  &, 0.114699E+01_JPRB, 0.112797E+01_JPRB, 0.110895E+01_JPRB &
  &, 0.108996E+01_JPRB, 0.107114E+01_JPRB, 0.105234E+01_JPRB, 0.103365E+01_JPRB &
  &, 0.101502E+01_JPRB, 0.996546E+00_JPRB, 0.978120E+00_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART121',1,ZHOOK_HANDLE)
END SUBROUTINE PART121

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART122

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART122',0,ZHOOK_HANDLE)

XCW( 848, :) = (/ &
  &  0.110274E+01_JPRB, 0.112836E+01_JPRB, 0.115393E+01_JPRB, 0.117943E+01_JPRB &
  &, 0.120484E+01_JPRB, 0.123014E+01_JPRB, 0.125533E+01_JPRB &
  &, 0.128039E+01_JPRB, 0.130530E+01_JPRB, 0.133004E+01_JPRB, 0.135460E+01_JPRB &
  &, 0.137897E+01_JPRB, 0.140312E+01_JPRB, 0.142706E+01_JPRB &
  &, 0.145075E+01_JPRB, 0.147418E+01_JPRB, 0.149735E+01_JPRB, 0.152023E+01_JPRB &
  &, 0.154281E+01_JPRB, 0.156508E+01_JPRB, 0.158702E+01_JPRB &
  &, 0.160862E+01_JPRB, 0.162986E+01_JPRB, 0.165073E+01_JPRB, 0.167122E+01_JPRB &
  &, 0.169132E+01_JPRB, 0.171101E+01_JPRB, 0.173027E+01_JPRB &
  &, 0.174910E+01_JPRB, 0.176749E+01_JPRB, 0.178543E+01_JPRB, 0.180289E+01_JPRB &
  &, 0.181988E+01_JPRB, 0.183638E+01_JPRB, 0.185239E+01_JPRB &
  &, 0.186789E+01_JPRB, 0.188287E+01_JPRB, 0.189733E+01_JPRB, 0.191126E+01_JPRB &
  &, 0.192466E+01_JPRB, 0.193750E+01_JPRB, 0.194980E+01_JPRB &
  &, 0.196154E+01_JPRB, 0.197272E+01_JPRB, 0.198333E+01_JPRB, 0.199336E+01_JPRB &
  &, 0.200284E+01_JPRB, 0.201173E+01_JPRB, 0.202003E+01_JPRB &
  &, 0.202775E+01_JPRB, 0.203489E+01_JPRB, 0.204144E+01_JPRB, 0.204740E+01_JPRB &
  &, 0.205278E+01_JPRB, 0.205757E+01_JPRB, 0.206177E+01_JPRB &
  &, 0.206538E+01_JPRB, 0.206841E+01_JPRB, 0.207086E+01_JPRB, 0.207273E+01_JPRB &
  &, 0.207401E+01_JPRB, 0.207472E+01_JPRB, 0.207485E+01_JPRB &
  &, 0.207444E+01_JPRB, 0.207341E+01_JPRB, 0.207189E+01_JPRB, 0.206978E+01_JPRB &
  &, 0.206712E+01_JPRB, 0.206391E+01_JPRB, 0.206018E+01_JPRB &
  &, 0.205591E+01_JPRB, 0.205110E+01_JPRB, 0.204578E+01_JPRB, 0.203995E+01_JPRB &
  &, 0.203354E+01_JPRB, 0.202679E+01_JPRB, 0.201946E+01_JPRB &
  &, 0.201166E+01_JPRB, 0.200338E+01_JPRB, 0.199462E+01_JPRB, 0.198544E+01_JPRB &
  &, 0.197579E+01_JPRB, 0.196570E+01_JPRB, 0.195517E+01_JPRB &
  &, 0.194422E+01_JPRB, 0.193287E+01_JPRB, 0.192114E+01_JPRB, 0.190898E+01_JPRB &
  &, 0.189647E+01_JPRB, 0.188356E+01_JPRB, 0.187031E+01_JPRB &
  &, 0.185668E+01_JPRB, 0.184274E+01_JPRB, 0.182848E+01_JPRB, 0.181385E+01_JPRB &
  &, 0.179896E+01_JPRB, 0.178375E+01_JPRB, 0.176824E+01_JPRB &
  &, 0.175247E+01_JPRB, 0.173641E+01_JPRB, 0.172011E+01_JPRB, 0.170358E+01_JPRB &
  &, 0.168679E+01_JPRB, 0.166979E+01_JPRB, 0.165255E+01_JPRB &
  &, 0.163515E+01_JPRB, 0.161754E+01_JPRB, 0.159974E+01_JPRB, 0.158178E+01_JPRB &
  &, 0.156365E+01_JPRB, 0.154537E+01_JPRB, 0.152694E+01_JPRB &
  &, 0.150842E+01_JPRB, 0.148975E+01_JPRB, 0.147096E+01_JPRB, 0.145208E+01_JPRB &
  &, 0.143314E+01_JPRB, 0.141412E+01_JPRB, 0.139500E+01_JPRB &
  &, 0.137584E+01_JPRB, 0.135665E+01_JPRB, 0.133738E+01_JPRB, 0.131811E+01_JPRB &
  &, 0.129878E+01_JPRB, 0.127947E+01_JPRB, 0.126019E+01_JPRB &
  &, 0.124086E+01_JPRB, 0.122158E+01_JPRB, 0.120230E+01_JPRB, 0.118307E+01_JPRB &
  &, 0.116383E+01_JPRB, 0.114469E+01_JPRB, 0.112560E+01_JPRB &
  &, 0.110659E+01_JPRB, 0.108763E+01_JPRB, 0.106874E+01_JPRB, 0.104995E+01_JPRB &
  &, 0.103122E+01_JPRB, 0.101263E+01_JPRB, 0.994154E+00_JPRB/)
XCW( 849, :) = (/ &
  &  0.110319E+01_JPRB, 0.112894E+01_JPRB, 0.115464E+01_JPRB, 0.118026E+01_JPRB &
  &, 0.120580E+01_JPRB, 0.123125E+01_JPRB, 0.125657E+01_JPRB &
  &, 0.128177E+01_JPRB, 0.130682E+01_JPRB, 0.133171E+01_JPRB, 0.135643E+01_JPRB &
  &, 0.138095E+01_JPRB, 0.140526E+01_JPRB, 0.142936E+01_JPRB &
  &, 0.145321E+01_JPRB, 0.147681E+01_JPRB, 0.150015E+01_JPRB, 0.152320E+01_JPRB &
  &, 0.154595E+01_JPRB, 0.156840E+01_JPRB, 0.159052E+01_JPRB &
  &, 0.161229E+01_JPRB, 0.163372E+01_JPRB, 0.165478E+01_JPRB, 0.167545E+01_JPRB &
  &, 0.169574E+01_JPRB, 0.171562E+01_JPRB, 0.173507E+01_JPRB &
  &, 0.175410E+01_JPRB, 0.177269E+01_JPRB, 0.179081E+01_JPRB, 0.180848E+01_JPRB &
  &, 0.182567E+01_JPRB, 0.184237E+01_JPRB, 0.185858E+01_JPRB &
  &, 0.187428E+01_JPRB, 0.188947E+01_JPRB, 0.190413E+01_JPRB, 0.191828E+01_JPRB &
  &, 0.193187E+01_JPRB, 0.194493E+01_JPRB, 0.195743E+01_JPRB &
  &, 0.196938E+01_JPRB, 0.198078E+01_JPRB, 0.199159E+01_JPRB, 0.200184E+01_JPRB &
  &, 0.201152E+01_JPRB, 0.202062E+01_JPRB, 0.202914E+01_JPRB &
  &, 0.203707E+01_JPRB, 0.204442E+01_JPRB, 0.205117E+01_JPRB, 0.205733E+01_JPRB &
  &, 0.206292E+01_JPRB, 0.206790E+01_JPRB, 0.207233E+01_JPRB &
  &, 0.207614E+01_JPRB, 0.207938E+01_JPRB, 0.208202E+01_JPRB, 0.208408E+01_JPRB &
  &, 0.208557E+01_JPRB, 0.208649E+01_JPRB, 0.208682E+01_JPRB &
  &, 0.208658E+01_JPRB, 0.208578E+01_JPRB, 0.208442E+01_JPRB, 0.208250E+01_JPRB &
  &, 0.208002E+01_JPRB, 0.207701E+01_JPRB, 0.207346E+01_JPRB &
  &, 0.206937E+01_JPRB, 0.206473E+01_JPRB, 0.205959E+01_JPRB, 0.205393E+01_JPRB &
  &, 0.204776E+01_JPRB, 0.204109E+01_JPRB, 0.203393E+01_JPRB &
  &, 0.202591E+01_JPRB, 0.201817E+01_JPRB, 0.200957E+01_JPRB, 0.200051E+01_JPRB &
  &, 0.199101E+01_JPRB, 0.198107E+01_JPRB, 0.197069E+01_JPRB &
  &, 0.195987E+01_JPRB, 0.194868E+01_JPRB, 0.193704E+01_JPRB, 0.192503E+01_JPRB &
  &, 0.191261E+01_JPRB, 0.189984E+01_JPRB, 0.188670E+01_JPRB &
  &, 0.187318E+01_JPRB, 0.185934E+01_JPRB, 0.184514E+01_JPRB, 0.183065E+01_JPRB &
  &, 0.181584E+01_JPRB, 0.180069E+01_JPRB, 0.178530E+01_JPRB &
  &, 0.176957E+01_JPRB, 0.175362E+01_JPRB, 0.173739E+01_JPRB, 0.172088E+01_JPRB &
  &, 0.170416E+01_JPRB, 0.168721E+01_JPRB, 0.167006E+01_JPRB &
  &, 0.165267E+01_JPRB, 0.163510E+01_JPRB, 0.161733E+01_JPRB, 0.159940E+01_JPRB &
  &, 0.158129E+01_JPRB, 0.156303E+01_JPRB, 0.154465E+01_JPRB &
  &, 0.152610E+01_JPRB, 0.150743E+01_JPRB, 0.148868E+01_JPRB, 0.146979E+01_JPRB &
  &, 0.145083E+01_JPRB, 0.143179E+01_JPRB, 0.141268E+01_JPRB &
  &, 0.139349E+01_JPRB, 0.137425E+01_JPRB, 0.135498E+01_JPRB, 0.133567E+01_JPRB &
  &, 0.131633E+01_JPRB, 0.129694E+01_JPRB, 0.127758E+01_JPRB &
  &, 0.125823E+01_JPRB, 0.123886E+01_JPRB, 0.121954E+01_JPRB, 0.120020E+01_JPRB &
  &, 0.118097E+01_JPRB, 0.116170E+01_JPRB, 0.114255E+01_JPRB &
  &, 0.112340E+01_JPRB, 0.110436E+01_JPRB, 0.108539E+01_JPRB, 0.106650E+01_JPRB &
  &, 0.104773E+01_JPRB, 0.102898E+01_JPRB, 0.101038E+01_JPRB/)
XCW( 850, :) = (/ &
  &  0.110365E+01_JPRB, 0.112952E+01_JPRB, 0.115534E+01_JPRB, 0.118110E+01_JPRB &
  &, 0.120677E+01_JPRB, 0.123235E+01_JPRB, 0.125782E+01_JPRB &
  &, 0.128316E+01_JPRB, 0.130836E+01_JPRB, 0.133340E+01_JPRB, 0.135827E+01_JPRB &
  &, 0.138294E+01_JPRB, 0.140742E+01_JPRB, 0.143167E+01_JPRB &
  &, 0.145569E+01_JPRB, 0.147946E+01_JPRB, 0.150296E+01_JPRB, 0.152618E+01_JPRB &
  &, 0.154911E+01_JPRB, 0.157173E+01_JPRB, 0.159403E+01_JPRB &
  &, 0.161599E+01_JPRB, 0.163760E+01_JPRB, 0.165885E+01_JPRB, 0.167971E+01_JPRB &
  &, 0.170019E+01_JPRB, 0.172025E+01_JPRB, 0.173990E+01_JPRB &
  &, 0.175913E+01_JPRB, 0.177791E+01_JPRB, 0.179624E+01_JPRB, 0.181410E+01_JPRB &
  &, 0.183149E+01_JPRB, 0.184840E+01_JPRB, 0.186481E+01_JPRB &
  &, 0.188072E+01_JPRB, 0.189611E+01_JPRB, 0.191099E+01_JPRB, 0.192534E+01_JPRB &
  &, 0.193913E+01_JPRB, 0.195241E+01_JPRB, 0.196513E+01_JPRB &
  &, 0.197729E+01_JPRB, 0.198888E+01_JPRB, 0.199992E+01_JPRB, 0.201038E+01_JPRB &
  &, 0.202027E+01_JPRB, 0.202957E+01_JPRB, 0.203830E+01_JPRB &
  &, 0.204645E+01_JPRB, 0.205400E+01_JPRB, 0.206097E+01_JPRB, 0.206736E+01_JPRB &
  &, 0.207314E+01_JPRB, 0.207834E+01_JPRB, 0.208296E+01_JPRB &
  &, 0.208699E+01_JPRB, 0.209042E+01_JPRB, 0.209328E+01_JPRB, 0.209555E+01_JPRB &
  &, 0.209724E+01_JPRB, 0.209835E+01_JPRB, 0.209887E+01_JPRB &
  &, 0.209883E+01_JPRB, 0.209823E+01_JPRB, 0.209706E+01_JPRB, 0.209533E+01_JPRB &
  &, 0.209304E+01_JPRB, 0.209022E+01_JPRB, 0.208684E+01_JPRB &
  &, 0.208293E+01_JPRB, 0.207849E+01_JPRB, 0.207350E+01_JPRB, 0.206802E+01_JPRB &
  &, 0.206203E+01_JPRB, 0.205553E+01_JPRB, 0.204853E+01_JPRB &
  &, 0.204104E+01_JPRB, 0.203308E+01_JPRB, 0.202465E+01_JPRB, 0.201575E+01_JPRB &
  &, 0.200640E+01_JPRB, 0.199659E+01_JPRB, 0.198635E+01_JPRB &
  &, 0.197569E+01_JPRB, 0.196459E+01_JPRB, 0.195311E+01_JPRB, 0.194120E+01_JPRB &
  &, 0.192892E+01_JPRB, 0.191627E+01_JPRB, 0.190325E+01_JPRB &
  &, 0.188984E+01_JPRB, 0.187610E+01_JPRB, 0.186201E+01_JPRB, 0.184761E+01_JPRB &
  &, 0.183286E+01_JPRB, 0.181784E+01_JPRB, 0.180249E+01_JPRB &
  &, 0.178688E+01_JPRB, 0.177097E+01_JPRB, 0.175482E+01_JPRB, 0.173842E+01_JPRB &
  &, 0.172176E+01_JPRB, 0.170487E+01_JPRB, 0.168773E+01_JPRB &
  &, 0.167039E+01_JPRB, 0.165286E+01_JPRB, 0.163513E+01_JPRB, 0.161723E+01_JPRB &
  &, 0.159915E+01_JPRB, 0.158091E+01_JPRB, 0.156255E+01_JPRB &
  &, 0.154404E+01_JPRB, 0.152538E+01_JPRB, 0.150663E+01_JPRB, 0.148774E+01_JPRB &
  &, 0.146876E+01_JPRB, 0.144970E+01_JPRB, 0.143056E+01_JPRB &
  &, 0.141134E+01_JPRB, 0.139211E+01_JPRB, 0.137280E+01_JPRB, 0.135343E+01_JPRB &
  &, 0.133403E+01_JPRB, 0.131462E+01_JPRB, 0.129525E+01_JPRB &
  &, 0.127582E+01_JPRB, 0.125641E+01_JPRB, 0.123700E+01_JPRB, 0.121761E+01_JPRB &
  &, 0.119828E+01_JPRB, 0.117901E+01_JPRB, 0.115973E+01_JPRB &
  &, 0.114052E+01_JPRB, 0.112141E+01_JPRB, 0.110235E+01_JPRB, 0.108337E+01_JPRB &
  &, 0.106444E+01_JPRB, 0.104565E+01_JPRB, 0.102694E+01_JPRB/)
XCW( 851, :) = (/ &
  &  0.110411E+01_JPRB, 0.113010E+01_JPRB, 0.115605E+01_JPRB, 0.118194E+01_JPRB &
  &, 0.120775E+01_JPRB, 0.123347E+01_JPRB, 0.125908E+01_JPRB &
  &, 0.128456E+01_JPRB, 0.130990E+01_JPRB, 0.133509E+01_JPRB, 0.136011E+01_JPRB &
  &, 0.138495E+01_JPRB, 0.140958E+01_JPRB, 0.143400E+01_JPRB &
  &, 0.145818E+01_JPRB, 0.148211E+01_JPRB, 0.150579E+01_JPRB, 0.152919E+01_JPRB &
  &, 0.155229E+01_JPRB, 0.157509E+01_JPRB, 0.159757E+01_JPRB &
  &, 0.161971E+01_JPRB, 0.164151E+01_JPRB, 0.166294E+01_JPRB, 0.168399E+01_JPRB &
  &, 0.170466E+01_JPRB, 0.172492E+01_JPRB, 0.174477E+01_JPRB &
  &, 0.176419E+01_JPRB, 0.178317E+01_JPRB, 0.180170E+01_JPRB, 0.181976E+01_JPRB &
  &, 0.183736E+01_JPRB, 0.185447E+01_JPRB, 0.187109E+01_JPRB &
  &, 0.188720E+01_JPRB, 0.190281E+01_JPRB, 0.191788E+01_JPRB, 0.193244E+01_JPRB &
  &, 0.194647E+01_JPRB, 0.195994E+01_JPRB, 0.197287E+01_JPRB &
  &, 0.198524E+01_JPRB, 0.199706E+01_JPRB, 0.200830E+01_JPRB, 0.201898E+01_JPRB &
  &, 0.202908E+01_JPRB, 0.203860E+01_JPRB, 0.204753E+01_JPRB &
  &, 0.205589E+01_JPRB, 0.206366E+01_JPRB, 0.207085E+01_JPRB, 0.207743E+01_JPRB &
  &, 0.208345E+01_JPRB, 0.208886E+01_JPRB, 0.209368E+01_JPRB &
  &, 0.209791E+01_JPRB, 0.210157E+01_JPRB, 0.210462E+01_JPRB, 0.210709E+01_JPRB &
  &, 0.210898E+01_JPRB, 0.211029E+01_JPRB, 0.211103E+01_JPRB &
  &, 0.211119E+01_JPRB, 0.211077E+01_JPRB, 0.210980E+01_JPRB, 0.210827E+01_JPRB &
  &, 0.210616E+01_JPRB, 0.210354E+01_JPRB, 0.210034E+01_JPRB &
  &, 0.209661E+01_JPRB, 0.209236E+01_JPRB, 0.208755E+01_JPRB, 0.208225E+01_JPRB &
  &, 0.207643E+01_JPRB, 0.207009E+01_JPRB, 0.206326E+01_JPRB &
  &, 0.205594E+01_JPRB, 0.204814E+01_JPRB, 0.203986E+01_JPRB, 0.203113E+01_JPRB &
  &, 0.202192E+01_JPRB, 0.201225E+01_JPRB, 0.200217E+01_JPRB &
  &, 0.199165E+01_JPRB, 0.198068E+01_JPRB, 0.196933E+01_JPRB, 0.195757E+01_JPRB &
  &, 0.194542E+01_JPRB, 0.193286E+01_JPRB, 0.191995E+01_JPRB &
  &, 0.190668E+01_JPRB, 0.189303E+01_JPRB, 0.187907E+01_JPRB, 0.186474E+01_JPRB &
  &, 0.185013E+01_JPRB, 0.183516E+01_JPRB, 0.181994E+01_JPRB &
  &, 0.180438E+01_JPRB, 0.178855E+01_JPRB, 0.177247E+01_JPRB, 0.175614E+01_JPRB &
  &, 0.173951E+01_JPRB, 0.172268E+01_JPRB, 0.170560E+01_JPRB &
  &, 0.168835E+01_JPRB, 0.167086E+01_JPRB, 0.165317E+01_JPRB, 0.163531E+01_JPRB &
  &, 0.161726E+01_JPRB, 0.159905E+01_JPRB, 0.158066E+01_JPRB &
  &, 0.156217E+01_JPRB, 0.154352E+01_JPRB, 0.152477E+01_JPRB, 0.150591E+01_JPRB &
  &, 0.148693E+01_JPRB, 0.146785E+01_JPRB, 0.144869E+01_JPRB &
  &, 0.142949E+01_JPRB, 0.141012E+01_JPRB, 0.139087E+01_JPRB, 0.137145E+01_JPRB &
  &, 0.135204E+01_JPRB, 0.133092E+01_JPRB, 0.131313E+01_JPRB &
  &, 0.129368E+01_JPRB, 0.127419E+01_JPRB, 0.125475E+01_JPRB, 0.123532E+01_JPRB &
  &, 0.121588E+01_JPRB, 0.119650E+01_JPRB, 0.117722E+01_JPRB &
  &, 0.115788E+01_JPRB, 0.113869E+01_JPRB, 0.111956E+01_JPRB, 0.110043E+01_JPRB &
  &, 0.108147E+01_JPRB, 0.106251E+01_JPRB, 0.104370E+01_JPRB/)
XCW( 852, :) = (/ &
  &  0.110457E+01_JPRB, 0.113069E+01_JPRB, 0.115677E+01_JPRB, 0.118278E+01_JPRB &
  &, 0.120873E+01_JPRB, 0.123458E+01_JPRB, 0.126033E+01_JPRB &
  &, 0.128596E+01_JPRB, 0.131146E+01_JPRB, 0.133680E+01_JPRB, 0.136197E+01_JPRB &
  &, 0.138696E+01_JPRB, 0.141176E+01_JPRB, 0.143633E+01_JPRB &
  &, 0.146068E+01_JPRB, 0.148479E+01_JPRB, 0.150863E+01_JPRB, 0.153221E+01_JPRB &
  &, 0.155549E+01_JPRB, 0.157847E+01_JPRB, 0.160112E+01_JPRB &
  &, 0.162345E+01_JPRB, 0.164543E+01_JPRB, 0.166705E+01_JPRB, 0.168830E+01_JPRB &
  &, 0.170915E+01_JPRB, 0.172962E+01_JPRB, 0.174966E+01_JPRB &
  &, 0.176928E+01_JPRB, 0.178846E+01_JPRB, 0.180719E+01_JPRB, 0.182546E+01_JPRB &
  &, 0.184326E+01_JPRB, 0.186058E+01_JPRB, 0.187740E+01_JPRB &
  &, 0.189373E+01_JPRB, 0.190954E+01_JPRB, 0.192484E+01_JPRB, 0.193960E+01_JPRB &
  &, 0.195384E+01_JPRB, 0.196752E+01_JPRB, 0.198065E+01_JPRB &
  &, 0.199325E+01_JPRB, 0.200528E+01_JPRB, 0.201674E+01_JPRB, 0.202763E+01_JPRB &
  &, 0.203795E+01_JPRB, 0.204769E+01_JPRB, 0.205684E+01_JPRB &
  &, 0.206541E+01_JPRB, 0.207339E+01_JPRB, 0.208079E+01_JPRB, 0.208760E+01_JPRB &
  &, 0.209382E+01_JPRB, 0.209945E+01_JPRB, 0.210448E+01_JPRB &
  &, 0.210893E+01_JPRB, 0.211278E+01_JPRB, 0.211604E+01_JPRB, 0.211872E+01_JPRB &
  &, 0.212083E+01_JPRB, 0.212234E+01_JPRB, 0.212328E+01_JPRB &
  &, 0.212364E+01_JPRB, 0.212342E+01_JPRB, 0.212265E+01_JPRB, 0.212131E+01_JPRB &
  &, 0.211941E+01_JPRB, 0.211696E+01_JPRB, 0.211395E+01_JPRB &
  &, 0.211042E+01_JPRB, 0.210633E+01_JPRB, 0.210173E+01_JPRB, 0.209659E+01_JPRB &
  &, 0.209095E+01_JPRB, 0.208479E+01_JPRB, 0.207814E+01_JPRB &
  &, 0.207098E+01_JPRB, 0.206334E+01_JPRB, 0.205521E+01_JPRB, 0.204663E+01_JPRB &
  &, 0.203759E+01_JPRB, 0.202809E+01_JPRB, 0.201813E+01_JPRB &
  &, 0.200774E+01_JPRB, 0.199694E+01_JPRB, 0.198572E+01_JPRB, 0.197409E+01_JPRB &
  &, 0.196207E+01_JPRB, 0.194963E+01_JPRB, 0.193684E+01_JPRB &
  &, 0.192369E+01_JPRB, 0.191014E+01_JPRB, 0.189629E+01_JPRB, 0.188207E+01_JPRB &
  &, 0.186752E+01_JPRB, 0.185269E+01_JPRB, 0.183752E+01_JPRB &
  &, 0.182209E+01_JPRB, 0.180634E+01_JPRB, 0.179030E+01_JPRB, 0.177405E+01_JPRB &
  &, 0.175749E+01_JPRB, 0.174072E+01_JPRB, 0.172371E+01_JPRB &
  &, 0.170647E+01_JPRB, 0.168903E+01_JPRB, 0.167139E+01_JPRB, 0.165356E+01_JPRB &
  &, 0.163555E+01_JPRB, 0.161736E+01_JPRB, 0.159904E+01_JPRB &
  &, 0.158057E+01_JPRB, 0.156192E+01_JPRB, 0.154318E+01_JPRB, 0.152428E+01_JPRB &
  &, 0.150534E+01_JPRB, 0.148624E+01_JPRB, 0.146706E+01_JPRB &
  &, 0.144784E+01_JPRB, 0.142854E+01_JPRB, 0.140919E+01_JPRB, 0.138978E+01_JPRB &
  &, 0.137027E+01_JPRB, 0.135080E+01_JPRB, 0.133129E+01_JPRB &
  &, 0.131177E+01_JPRB, 0.129225E+01_JPRB, 0.127278E+01_JPRB, 0.125326E+01_JPRB &
  &, 0.123377E+01_JPRB, 0.121434E+01_JPRB, 0.119489E+01_JPRB &
  &, 0.117555E+01_JPRB, 0.115623E+01_JPRB, 0.113701E+01_JPRB, 0.111781E+01_JPRB &
  &, 0.109869E+01_JPRB, 0.107970E+01_JPRB, 0.106078E+01_JPRB/)
XCW( 853, :) = (/ &
  &  0.110504E+01_JPRB, 0.113128E+01_JPRB, 0.115748E+01_JPRB, 0.118363E+01_JPRB &
  &, 0.120971E+01_JPRB, 0.123571E+01_JPRB, 0.126160E+01_JPRB &
  &, 0.128738E+01_JPRB, 0.131302E+01_JPRB, 0.133851E+01_JPRB, 0.136384E+01_JPRB &
  &, 0.138899E+01_JPRB, 0.141394E+01_JPRB, 0.143869E+01_JPRB &
  &, 0.146320E+01_JPRB, 0.148748E+01_JPRB, 0.151150E+01_JPRB, 0.153524E+01_JPRB &
  &, 0.155870E+01_JPRB, 0.158186E+01_JPRB, 0.160470E+01_JPRB &
  &, 0.162722E+01_JPRB, 0.164938E+01_JPRB, 0.167119E+01_JPRB, 0.169263E+01_JPRB &
  &, 0.171368E+01_JPRB, 0.173434E+01_JPRB, 0.175458E+01_JPRB &
  &, 0.177440E+01_JPRB, 0.179378E+01_JPRB, 0.181272E+01_JPRB, 0.183119E+01_JPRB &
  &, 0.184920E+01_JPRB, 0.186672E+01_JPRB, 0.188376E+01_JPRB &
  &, 0.190029E+01_JPRB, 0.191632E+01_JPRB, 0.193183E+01_JPRB, 0.194681E+01_JPRB &
  &, 0.196126E+01_JPRB, 0.197516E+01_JPRB, 0.198851E+01_JPRB &
  &, 0.200132E+01_JPRB, 0.201356E+01_JPRB, 0.202525E+01_JPRB, 0.203635E+01_JPRB &
  &, 0.204689E+01_JPRB, 0.205684E+01_JPRB, 0.206617E+01_JPRB &
  &, 0.207500E+01_JPRB, 0.208320E+01_JPRB, 0.209083E+01_JPRB, 0.209784E+01_JPRB &
  &, 0.210427E+01_JPRB, 0.211012E+01_JPRB, 0.211536E+01_JPRB &
  &, 0.212003E+01_JPRB, 0.212408E+01_JPRB, 0.212756E+01_JPRB, 0.213046E+01_JPRB &
  &, 0.213276E+01_JPRB, 0.213449E+01_JPRB, 0.213563E+01_JPRB &
  &, 0.213619E+01_JPRB, 0.213618E+01_JPRB, 0.213560E+01_JPRB, 0.213446E+01_JPRB &
  &, 0.213276E+01_JPRB, 0.213051E+01_JPRB, 0.212768E+01_JPRB &
  &, 0.212434E+01_JPRB, 0.212045E+01_JPRB, 0.211602E+01_JPRB, 0.211108E+01_JPRB &
  &, 0.210560E+01_JPRB, 0.209962E+01_JPRB, 0.209313E+01_JPRB &
  &, 0.208615E+01_JPRB, 0.207868E+01_JPRB, 0.207072E+01_JPRB, 0.206229E+01_JPRB &
  &, 0.205340E+01_JPRB, 0.204404E+01_JPRB, 0.203425E+01_JPRB &
  &, 0.202401E+01_JPRB, 0.201334E+01_JPRB, 0.200225E+01_JPRB, 0.199076E+01_JPRB &
  &, 0.197886E+01_JPRB, 0.196658E+01_JPRB, 0.195391E+01_JPRB &
  &, 0.194085E+01_JPRB, 0.192745E+01_JPRB, 0.191368E+01_JPRB, 0.189953E+01_JPRB &
  &, 0.188516E+01_JPRB, 0.187039E+01_JPRB, 0.185532E+01_JPRB &
  &, 0.183994E+01_JPRB, 0.182431E+01_JPRB, 0.180836E+01_JPRB, 0.179215E+01_JPRB &
  &, 0.177570E+01_JPRB, 0.175896E+01_JPRB, 0.174201E+01_JPRB &
  &, 0.172487E+01_JPRB, 0.170745E+01_JPRB, 0.168985E+01_JPRB, 0.167207E+01_JPRB &
  &, 0.165409E+01_JPRB, 0.163594E+01_JPRB, 0.161764E+01_JPRB &
  &, 0.159915E+01_JPRB, 0.158056E+01_JPRB, 0.156183E+01_JPRB, 0.154293E+01_JPRB &
  &, 0.152398E+01_JPRB, 0.150487E+01_JPRB, 0.148573E+01_JPRB &
  &, 0.146643E+01_JPRB, 0.144711E+01_JPRB, 0.142772E+01_JPRB, 0.140827E+01_JPRB &
  &, 0.138882E+01_JPRB, 0.136929E+01_JPRB, 0.134972E+01_JPRB &
  &, 0.133018E+01_JPRB, 0.131059E+01_JPRB, 0.129103E+01_JPRB, 0.127148E+01_JPRB &
  &, 0.125189E+01_JPRB, 0.123237E+01_JPRB, 0.121292E+01_JPRB &
  &, 0.119346E+01_JPRB, 0.117407E+01_JPRB, 0.115472E+01_JPRB, 0.113550E+01_JPRB &
  &, 0.111630E+01_JPRB, 0.109715E+01_JPRB, 0.107813E+01_JPRB/)
XCW( 854, :) = (/ &
  &  0.110550E+01_JPRB, 0.113187E+01_JPRB, 0.115820E+01_JPRB, 0.118449E+01_JPRB &
  &, 0.121070E+01_JPRB, 0.123684E+01_JPRB, 0.126287E+01_JPRB &
  &, 0.128880E+01_JPRB, 0.131459E+01_JPRB, 0.134023E+01_JPRB, 0.136572E+01_JPRB &
  &, 0.139103E+01_JPRB, 0.141614E+01_JPRB, 0.144105E+01_JPRB &
  &, 0.146574E+01_JPRB, 0.149018E+01_JPRB, 0.151437E+01_JPRB, 0.153830E+01_JPRB &
  &, 0.156194E+01_JPRB, 0.158528E+01_JPRB, 0.160830E+01_JPRB &
  &, 0.163100E+01_JPRB, 0.165336E+01_JPRB, 0.167536E+01_JPRB, 0.169699E+01_JPRB &
  &, 0.171824E+01_JPRB, 0.173909E+01_JPRB, 0.175953E+01_JPRB &
  &, 0.177956E+01_JPRB, 0.179914E+01_JPRB, 0.181828E+01_JPRB, 0.183696E+01_JPRB &
  &, 0.185518E+01_JPRB, 0.187291E+01_JPRB, 0.189016E+01_JPRB &
  &, 0.190691E+01_JPRB, 0.192314E+01_JPRB, 0.193887E+01_JPRB, 0.195406E+01_JPRB &
  &, 0.196869E+01_JPRB, 0.198285E+01_JPRB, 0.199642E+01_JPRB &
  &, 0.200945E+01_JPRB, 0.202191E+01_JPRB, 0.203381E+01_JPRB, 0.204514E+01_JPRB &
  &, 0.205588E+01_JPRB, 0.206606E+01_JPRB, 0.207566E+01_JPRB &
  &, 0.208467E+01_JPRB, 0.209308E+01_JPRB, 0.210091E+01_JPRB, 0.210816E+01_JPRB &
  &, 0.211479E+01_JPRB, 0.212087E+01_JPRB, 0.212633E+01_JPRB &
  &, 0.213118E+01_JPRB, 0.213549E+01_JPRB, 0.213918E+01_JPRB, 0.214229E+01_JPRB &
  &, 0.214480E+01_JPRB, 0.214673E+01_JPRB, 0.214807E+01_JPRB &
  &, 0.214884E+01_JPRB, 0.214905E+01_JPRB, 0.214866E+01_JPRB, 0.214773E+01_JPRB &
  &, 0.214622E+01_JPRB, 0.214416E+01_JPRB, 0.214154E+01_JPRB &
  &, 0.213839E+01_JPRB, 0.213469E+01_JPRB, 0.213046E+01_JPRB, 0.212569E+01_JPRB &
  &, 0.212040E+01_JPRB, 0.211458E+01_JPRB, 0.210827E+01_JPRB &
  &, 0.210148E+01_JPRB, 0.209416E+01_JPRB, 0.208638E+01_JPRB, 0.207810E+01_JPRB &
  &, 0.206936E+01_JPRB, 0.206018E+01_JPRB, 0.205053E+01_JPRB &
  &, 0.204044E+01_JPRB, 0.202991E+01_JPRB, 0.201899E+01_JPRB, 0.200760E+01_JPRB &
  &, 0.199584E+01_JPRB, 0.198368E+01_JPRB, 0.197114E+01_JPRB &
  &, 0.195820E+01_JPRB, 0.194492E+01_JPRB, 0.193127E+01_JPRB, 0.191726E+01_JPRB &
  &, 0.190289E+01_JPRB, 0.188830E+01_JPRB, 0.187332E+01_JPRB &
  &, 0.185804E+01_JPRB, 0.184247E+01_JPRB, 0.182660E+01_JPRB, 0.181047E+01_JPRB &
  &, 0.179410E+01_JPRB, 0.177743E+01_JPRB, 0.176055E+01_JPRB &
  &, 0.174343E+01_JPRB, 0.172610E+01_JPRB, 0.170856E+01_JPRB, 0.169078E+01_JPRB &
  &, 0.167285E+01_JPRB, 0.165473E+01_JPRB, 0.163646E+01_JPRB &
  &, 0.161799E+01_JPRB, 0.159942E+01_JPRB, 0.158066E+01_JPRB, 0.156181E+01_JPRB &
  &, 0.154286E+01_JPRB, 0.152375E+01_JPRB, 0.150460E+01_JPRB &
  &, 0.148533E+01_JPRB, 0.146598E+01_JPRB, 0.144656E+01_JPRB, 0.142707E+01_JPRB &
  &, 0.140758E+01_JPRB, 0.138800E+01_JPRB, 0.136842E+01_JPRB &
  &, 0.134882E+01_JPRB, 0.132915E+01_JPRB, 0.130957E+01_JPRB, 0.128993E+01_JPRB &
  &, 0.127031E+01_JPRB, 0.125074E+01_JPRB, 0.123118E+01_JPRB &
  &, 0.121167E+01_JPRB, 0.119216E+01_JPRB, 0.117274E+01_JPRB, 0.115338E+01_JPRB &
  &, 0.113410E+01_JPRB, 0.111492E+01_JPRB, 0.109574E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART122',1,ZHOOK_HANDLE)
END SUBROUTINE PART122

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART123

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART123',0,ZHOOK_HANDLE)

XCW( 855, :) = (/ &
  &  0.110597E+01_JPRB, 0.113246E+01_JPRB, 0.115893E+01_JPRB, 0.118535E+01_JPRB &
  &, 0.121170E+01_JPRB, 0.123797E+01_JPRB, 0.126415E+01_JPRB &
  &, 0.129022E+01_JPRB, 0.131617E+01_JPRB, 0.134197E+01_JPRB, 0.136761E+01_JPRB &
  &, 0.139308E+01_JPRB, 0.141836E+01_JPRB, 0.144343E+01_JPRB &
  &, 0.146828E+01_JPRB, 0.149290E+01_JPRB, 0.151727E+01_JPRB, 0.154137E+01_JPRB &
  &, 0.156519E+01_JPRB, 0.158871E+01_JPRB, 0.161193E+01_JPRB &
  &, 0.163481E+01_JPRB, 0.165736E+01_JPRB, 0.167955E+01_JPRB, 0.170138E+01_JPRB &
  &, 0.172283E+01_JPRB, 0.174388E+01_JPRB, 0.176452E+01_JPRB &
  &, 0.178475E+01_JPRB, 0.180453E+01_JPRB, 0.182388E+01_JPRB, 0.184277E+01_JPRB &
  &, 0.186120E+01_JPRB, 0.187915E+01_JPRB, 0.189660E+01_JPRB &
  &, 0.191357E+01_JPRB, 0.193002E+01_JPRB, 0.194596E+01_JPRB, 0.196137E+01_JPRB &
  &, 0.197626E+01_JPRB, 0.199059E+01_JPRB, 0.200440E+01_JPRB &
  &, 0.201763E+01_JPRB, 0.203032E+01_JPRB, 0.204243E+01_JPRB, 0.205399E+01_JPRB &
  &, 0.206496E+01_JPRB, 0.207535E+01_JPRB, 0.208517E+01_JPRB &
  &, 0.209439E+01_JPRB, 0.210304E+01_JPRB, 0.211110E+01_JPRB, 0.211856E+01_JPRB &
  &, 0.212543E+01_JPRB, 0.213170E+01_JPRB, 0.213740E+01_JPRB &
  &, 0.214248E+01_JPRB, 0.214698E+01_JPRB, 0.215089E+01_JPRB, 0.215421E+01_JPRB &
  &, 0.215694E+01_JPRB, 0.215907E+01_JPRB, 0.216064E+01_JPRB &
  &, 0.216162E+01_JPRB, 0.216202E+01_JPRB, 0.216186E+01_JPRB, 0.216111E+01_JPRB &
  &, 0.215980E+01_JPRB, 0.215795E+01_JPRB, 0.215552E+01_JPRB &
  &, 0.215256E+01_JPRB, 0.214905E+01_JPRB, 0.214501E+01_JPRB, 0.214043E+01_JPRB &
  &, 0.213531E+01_JPRB, 0.212970E+01_JPRB, 0.212356E+01_JPRB &
  &, 0.211692E+01_JPRB, 0.210978E+01_JPRB, 0.210217E+01_JPRB, 0.209407E+01_JPRB &
  &, 0.208551E+01_JPRB, 0.207646E+01_JPRB, 0.206698E+01_JPRB &
  &, 0.205703E+01_JPRB, 0.204665E+01_JPRB, 0.203584E+01_JPRB, 0.202463E+01_JPRB &
  &, 0.201299E+01_JPRB, 0.200097E+01_JPRB, 0.198856E+01_JPRB &
  &, 0.197575E+01_JPRB, 0.196259E+01_JPRB, 0.194905E+01_JPRB, 0.193516E+01_JPRB &
  &, 0.192093E+01_JPRB, 0.190638E+01_JPRB, 0.189151E+01_JPRB &
  &, 0.187632E+01_JPRB, 0.186084E+01_JPRB, 0.184507E+01_JPRB, 0.182902E+01_JPRB &
  &, 0.181269E+01_JPRB, 0.179606E+01_JPRB, 0.177929E+01_JPRB &
  &, 0.176223E+01_JPRB, 0.174489E+01_JPRB, 0.172744E+01_JPRB, 0.170975E+01_JPRB &
  &, 0.169186E+01_JPRB, 0.167370E+01_JPRB, 0.165551E+01_JPRB &
  &, 0.163706E+01_JPRB, 0.161852E+01_JPRB, 0.159981E+01_JPRB, 0.158093E+01_JPRB &
  &, 0.156199E+01_JPRB, 0.154287E+01_JPRB, 0.152371E+01_JPRB &
  &, 0.150442E+01_JPRB, 0.148505E+01_JPRB, 0.146566E+01_JPRB, 0.144613E+01_JPRB &
  &, 0.142660E+01_JPRB, 0.140702E+01_JPRB, 0.138739E+01_JPRB &
  &, 0.136773E+01_JPRB, 0.134805E+01_JPRB, 0.132834E+01_JPRB, 0.130867E+01_JPRB &
  &, 0.128902E+01_JPRB, 0.126935E+01_JPRB, 0.124975E+01_JPRB &
  &, 0.123012E+01_JPRB, 0.121055E+01_JPRB, 0.119107E+01_JPRB, 0.117164E+01_JPRB &
  &, 0.115221E+01_JPRB, 0.113289E+01_JPRB, 0.111368E+01_JPRB/)
XCW( 856, :) = (/ &
  &  0.110644E+01_JPRB, 0.113306E+01_JPRB, 0.115966E+01_JPRB, 0.118621E+01_JPRB &
  &, 0.121270E+01_JPRB, 0.123912E+01_JPRB, 0.126544E+01_JPRB &
  &, 0.129166E+01_JPRB, 0.131775E+01_JPRB, 0.134371E+01_JPRB, 0.136951E+01_JPRB &
  &, 0.139514E+01_JPRB, 0.142058E+01_JPRB, 0.144582E+01_JPRB &
  &, 0.147085E+01_JPRB, 0.149564E+01_JPRB, 0.152018E+01_JPRB, 0.154446E+01_JPRB &
  &, 0.156846E+01_JPRB, 0.159217E+01_JPRB, 0.161557E+01_JPRB &
  &, 0.163865E+01_JPRB, 0.166139E+01_JPRB, 0.168377E+01_JPRB, 0.170580E+01_JPRB &
  &, 0.172744E+01_JPRB, 0.174869E+01_JPRB, 0.176954E+01_JPRB &
  &, 0.178997E+01_JPRB, 0.180996E+01_JPRB, 0.182952E+01_JPRB, 0.184862E+01_JPRB &
  &, 0.186726E+01_JPRB, 0.188541E+01_JPRB, 0.190309E+01_JPRB &
  &, 0.192026E+01_JPRB, 0.193694E+01_JPRB, 0.195309E+01_JPRB, 0.196873E+01_JPRB &
  &, 0.198383E+01_JPRB, 0.199839E+01_JPRB, 0.201241E+01_JPRB &
  &, 0.202587E+01_JPRB, 0.203879E+01_JPRB, 0.205112E+01_JPRB, 0.206289E+01_JPRB &
  &, 0.207409E+01_JPRB, 0.208472E+01_JPRB, 0.209476E+01_JPRB &
  &, 0.210421E+01_JPRB, 0.211307E+01_JPRB, 0.212136E+01_JPRB, 0.212904E+01_JPRB &
  &, 0.213613E+01_JPRB, 0.214263E+01_JPRB, 0.214854E+01_JPRB &
  &, 0.215384E+01_JPRB, 0.215856E+01_JPRB, 0.216269E+01_JPRB, 0.216622E+01_JPRB &
  &, 0.216918E+01_JPRB, 0.217152E+01_JPRB, 0.217330E+01_JPRB &
  &, 0.217448E+01_JPRB, 0.217510E+01_JPRB, 0.217515E+01_JPRB, 0.217462E+01_JPRB &
  &, 0.217352E+01_JPRB, 0.217186E+01_JPRB, 0.216963E+01_JPRB &
  &, 0.216686E+01_JPRB, 0.216354E+01_JPRB, 0.215969E+01_JPRB, 0.215528E+01_JPRB &
  &, 0.215037E+01_JPRB, 0.214493E+01_JPRB, 0.213898E+01_JPRB &
  &, 0.213253E+01_JPRB, 0.212556E+01_JPRB, 0.211813E+01_JPRB, 0.211019E+01_JPRB &
  &, 0.210179E+01_JPRB, 0.209292E+01_JPRB, 0.208357E+01_JPRB &
  &, 0.207380E+01_JPRB, 0.206357E+01_JPRB, 0.205290E+01_JPRB, 0.204182E+01_JPRB &
  &, 0.203033E+01_JPRB, 0.201844E+01_JPRB, 0.200616E+01_JPRB &
  &, 0.199348E+01_JPRB, 0.198041E+01_JPRB, 0.196700E+01_JPRB, 0.195326E+01_JPRB &
  &, 0.193911E+01_JPRB, 0.192466E+01_JPRB, 0.190990E+01_JPRB &
  &, 0.189482E+01_JPRB, 0.187940E+01_JPRB, 0.186372E+01_JPRB, 0.184776E+01_JPRB &
  &, 0.183151E+01_JPRB, 0.181500E+01_JPRB, 0.179826E+01_JPRB &
  &, 0.178128E+01_JPRB, 0.176403E+01_JPRB, 0.174656E+01_JPRB, 0.172893E+01_JPRB &
  &, 0.171109E+01_JPRB, 0.169301E+01_JPRB, 0.167481E+01_JPRB &
  &, 0.165640E+01_JPRB, 0.163784E+01_JPRB, 0.161915E+01_JPRB, 0.160033E+01_JPRB &
  &, 0.158134E+01_JPRB, 0.156228E+01_JPRB, 0.154311E+01_JPRB &
  &, 0.152382E+01_JPRB, 0.150443E+01_JPRB, 0.148496E+01_JPRB, 0.146546E+01_JPRB &
  &, 0.144588E+01_JPRB, 0.142627E+01_JPRB, 0.140658E+01_JPRB &
  &, 0.138691E+01_JPRB, 0.136717E+01_JPRB, 0.134745E+01_JPRB, 0.132770E+01_JPRB &
  &, 0.130796E+01_JPRB, 0.128826E+01_JPRB, 0.126856E+01_JPRB &
  &, 0.124888E+01_JPRB, 0.122926E+01_JPRB, 0.120965E+01_JPRB, 0.119015E+01_JPRB &
  &, 0.117065E+01_JPRB, 0.115124E+01_JPRB, 0.113188E+01_JPRB/)
XCW( 857, :) = (/ &
  &  0.110691E+01_JPRB, 0.113366E+01_JPRB, 0.116039E+01_JPRB, 0.118707E+01_JPRB &
  &, 0.121371E+01_JPRB, 0.124026E+01_JPRB, 0.126673E+01_JPRB &
  &, 0.129310E+01_JPRB, 0.131935E+01_JPRB, 0.134546E+01_JPRB, 0.137142E+01_JPRB &
  &, 0.139721E+01_JPRB, 0.142282E+01_JPRB, 0.144823E+01_JPRB &
  &, 0.147342E+01_JPRB, 0.149839E+01_JPRB, 0.152311E+01_JPRB, 0.154757E+01_JPRB &
  &, 0.157176E+01_JPRB, 0.159565E+01_JPRB, 0.161924E+01_JPRB &
  &, 0.164250E+01_JPRB, 0.166544E+01_JPRB, 0.168802E+01_JPRB, 0.171024E+01_JPRB &
  &, 0.173208E+01_JPRB, 0.175354E+01_JPRB, 0.177459E+01_JPRB &
  &, 0.179522E+01_JPRB, 0.181543E+01_JPRB, 0.183520E+01_JPRB, 0.185451E+01_JPRB &
  &, 0.187336E+01_JPRB, 0.189173E+01_JPRB, 0.190962E+01_JPRB &
  &, 0.192702E+01_JPRB, 0.194390E+01_JPRB, 0.196028E+01_JPRB, 0.197613E+01_JPRB &
  &, 0.199146E+01_JPRB, 0.200625E+01_JPRB, 0.202049E+01_JPRB &
  &, 0.203418E+01_JPRB, 0.204731E+01_JPRB, 0.205984E+01_JPRB, 0.207187E+01_JPRB &
  &, 0.208330E+01_JPRB, 0.209415E+01_JPRB, 0.210442E+01_JPRB &
  &, 0.211409E+01_JPRB, 0.212319E+01_JPRB, 0.213169E+01_JPRB, 0.213958E+01_JPRB &
  &, 0.214691E+01_JPRB, 0.215364E+01_JPRB, 0.215978E+01_JPRB &
  &, 0.216531E+01_JPRB, 0.217025E+01_JPRB, 0.217460E+01_JPRB, 0.217834E+01_JPRB &
  &, 0.218150E+01_JPRB, 0.218409E+01_JPRB, 0.218606E+01_JPRB &
  &, 0.218748E+01_JPRB, 0.218830E+01_JPRB, 0.218855E+01_JPRB, 0.218821E+01_JPRB &
  &, 0.218733E+01_JPRB, 0.218587E+01_JPRB, 0.218385E+01_JPRB &
  &, 0.218128E+01_JPRB, 0.217816E+01_JPRB, 0.217451E+01_JPRB, 0.217030E+01_JPRB &
  &, 0.216558E+01_JPRB, 0.216033E+01_JPRB, 0.215455E+01_JPRB &
  &, 0.214827E+01_JPRB, 0.214149E+01_JPRB, 0.213422E+01_JPRB, 0.212645E+01_JPRB &
  &, 0.211823E+01_JPRB, 0.210951E+01_JPRB, 0.210035E+01_JPRB &
  &, 0.209070E+01_JPRB, 0.208065E+01_JPRB, 0.207013E+01_JPRB, 0.205920E+01_JPRB &
  &, 0.204785E+01_JPRB, 0.203610E+01_JPRB, 0.202392E+01_JPRB &
  &, 0.201140E+01_JPRB, 0.199846E+01_JPRB, 0.198517E+01_JPRB, 0.197152E+01_JPRB &
  &, 0.195753E+01_JPRB, 0.194316E+01_JPRB, 0.192851E+01_JPRB &
  &, 0.191349E+01_JPRB, 0.189821E+01_JPRB, 0.188263E+01_JPRB, 0.186672E+01_JPRB &
  &, 0.185056E+01_JPRB, 0.183413E+01_JPRB, 0.181743E+01_JPRB &
  &, 0.180052E+01_JPRB, 0.178335E+01_JPRB, 0.176594E+01_JPRB, 0.174832E+01_JPRB &
  &, 0.173053E+01_JPRB, 0.171254E+01_JPRB, 0.169434E+01_JPRB &
  &, 0.167596E+01_JPRB, 0.165743E+01_JPRB, 0.163877E+01_JPRB, 0.161996E+01_JPRB &
  &, 0.160099E+01_JPRB, 0.158193E+01_JPRB, 0.156271E+01_JPRB &
  &, 0.154346E+01_JPRB, 0.152406E+01_JPRB, 0.150462E+01_JPRB, 0.148504E+01_JPRB &
  &, 0.146506E+01_JPRB, 0.144583E+01_JPRB, 0.142610E+01_JPRB &
  &, 0.140638E+01_JPRB, 0.138657E+01_JPRB, 0.136684E+01_JPRB, 0.134701E+01_JPRB &
  &, 0.132725E+01_JPRB, 0.130746E+01_JPRB, 0.128766E+01_JPRB &
  &, 0.126794E+01_JPRB, 0.124821E+01_JPRB, 0.122854E+01_JPRB, 0.120891E+01_JPRB &
  &, 0.118934E+01_JPRB, 0.116986E+01_JPRB, 0.115041E+01_JPRB/)
XCW( 858, :) = (/ &
  &  0.110739E+01_JPRB, 0.113427E+01_JPRB, 0.116113E+01_JPRB, 0.118795E+01_JPRB &
  &, 0.121472E+01_JPRB, 0.124142E+01_JPRB, 0.126803E+01_JPRB &
  &, 0.129455E+01_JPRB, 0.132095E+01_JPRB, 0.134722E+01_JPRB, 0.137334E+01_JPRB &
  &, 0.139929E+01_JPRB, 0.142507E+01_JPRB, 0.145065E+01_JPRB &
  &, 0.147602E+01_JPRB, 0.150116E+01_JPRB, 0.152606E+01_JPRB, 0.155070E+01_JPRB &
  &, 0.157507E+01_JPRB, 0.159915E+01_JPRB, 0.162292E+01_JPRB &
  &, 0.164639E+01_JPRB, 0.166951E+01_JPRB, 0.169229E+01_JPRB, 0.171471E+01_JPRB &
  &, 0.173676E+01_JPRB, 0.175842E+01_JPRB, 0.177967E+01_JPRB &
  &, 0.180051E+01_JPRB, 0.182093E+01_JPRB, 0.184091E+01_JPRB, 0.186043E+01_JPRB &
  &, 0.187950E+01_JPRB, 0.189809E+01_JPRB, 0.191620E+01_JPRB &
  &, 0.193381E+01_JPRB, 0.195092E+01_JPRB, 0.196753E+01_JPRB, 0.198360E+01_JPRB &
  &, 0.199915E+01_JPRB, 0.201417E+01_JPRB, 0.202863E+01_JPRB &
  &, 0.204254E+01_JPRB, 0.205590E+01_JPRB, 0.206869E+01_JPRB, 0.208092E+01_JPRB &
  &, 0.209258E+01_JPRB, 0.210365E+01_JPRB, 0.211414E+01_JPRB &
  &, 0.212405E+01_JPRB, 0.213338E+01_JPRB, 0.214209E+01_JPRB, 0.215025E+01_JPRB &
  &, 0.215780E+01_JPRB, 0.216474E+01_JPRB, 0.217109E+01_JPRB &
  &, 0.217686E+01_JPRB, 0.218201E+01_JPRB, 0.218659E+01_JPRB, 0.219057E+01_JPRB &
  &, 0.219394E+01_JPRB, 0.219674E+01_JPRB, 0.219895E+01_JPRB &
  &, 0.220056E+01_JPRB, 0.220160E+01_JPRB, 0.220207E+01_JPRB, 0.220195E+01_JPRB &
  &, 0.220126E+01_JPRB, 0.220002E+01_JPRB, 0.219820E+01_JPRB &
  &, 0.219583E+01_JPRB, 0.219291E+01_JPRB, 0.218946E+01_JPRB, 0.218544E+01_JPRB &
  &, 0.218092E+01_JPRB, 0.217585E+01_JPRB, 0.217026E+01_JPRB &
  &, 0.216418E+01_JPRB, 0.215759E+01_JPRB, 0.215044E+01_JPRB, 0.214288E+01_JPRB &
  &, 0.213482E+01_JPRB, 0.212627E+01_JPRB, 0.211726E+01_JPRB &
  &, 0.210780E+01_JPRB, 0.209790E+01_JPRB, 0.208753E+01_JPRB, 0.207675E+01_JPRB &
  &, 0.206554E+01_JPRB, 0.205394E+01_JPRB, 0.204190E+01_JPRB &
  &, 0.202948E+01_JPRB, 0.201668E+01_JPRB, 0.200351E+01_JPRB, 0.198998E+01_JPRB &
  &, 0.197611E+01_JPRB, 0.196186E+01_JPRB, 0.194729E+01_JPRB &
  &, 0.193242E+01_JPRB, 0.191721E+01_JPRB, 0.190172E+01_JPRB, 0.188591E+01_JPRB &
  &, 0.186984E+01_JPRB, 0.185346E+01_JPRB, 0.183684E+01_JPRB &
  &, 0.182001E+01_JPRB, 0.180290E+01_JPRB, 0.178556E+01_JPRB, 0.176801E+01_JPRB &
  &, 0.175023E+01_JPRB, 0.173229E+01_JPRB, 0.171414E+01_JPRB &
  &, 0.169580E+01_JPRB, 0.167729E+01_JPRB, 0.165866E+01_JPRB, 0.163983E+01_JPRB &
  &, 0.162087E+01_JPRB, 0.160182E+01_JPRB, 0.158266E+01_JPRB &
  &, 0.156335E+01_JPRB, 0.154389E+01_JPRB, 0.152449E+01_JPRB, 0.150493E+01_JPRB &
  &, 0.148530E+01_JPRB, 0.146561E+01_JPRB, 0.144589E+01_JPRB &
  &, 0.142611E+01_JPRB, 0.140631E+01_JPRB, 0.138645E+01_JPRB, 0.136662E+01_JPRB &
  &, 0.134678E+01_JPRB, 0.132696E+01_JPRB, 0.130713E+01_JPRB &
  &, 0.128731E+01_JPRB, 0.126753E+01_JPRB, 0.124775E+01_JPRB, 0.122806E+01_JPRB &
  &, 0.120836E+01_JPRB, 0.118880E+01_JPRB, 0.116927E+01_JPRB/)
XCW( 859, :) = (/ &
  &  0.110787E+01_JPRB, 0.113487E+01_JPRB, 0.116186E+01_JPRB, 0.118882E+01_JPRB &
  &, 0.121573E+01_JPRB, 0.124258E+01_JPRB, 0.126934E+01_JPRB &
  &, 0.129601E+01_JPRB, 0.132256E+01_JPRB, 0.134899E+01_JPRB, 0.137527E+01_JPRB &
  &, 0.140139E+01_JPRB, 0.142733E+01_JPRB, 0.145308E+01_JPRB &
  &, 0.147862E+01_JPRB, 0.150394E+01_JPRB, 0.152902E+01_JPRB, 0.155385E+01_JPRB &
  &, 0.157840E+01_JPRB, 0.160267E+01_JPRB, 0.162664E+01_JPRB &
  &, 0.165029E+01_JPRB, 0.167361E+01_JPRB, 0.169659E+01_JPRB, 0.171921E+01_JPRB &
  &, 0.174146E+01_JPRB, 0.176333E+01_JPRB, 0.178479E+01_JPRB &
  &, 0.180584E+01_JPRB, 0.182647E+01_JPRB, 0.184666E+01_JPRB, 0.186640E+01_JPRB &
  &, 0.188568E+01_JPRB, 0.190450E+01_JPRB, 0.192282E+01_JPRB &
  &, 0.194066E+01_JPRB, 0.195799E+01_JPRB, 0.197481E+01_JPRB, 0.199111E+01_JPRB &
  &, 0.200689E+01_JPRB, 0.202213E+01_JPRB, 0.203683E+01_JPRB &
  &, 0.205097E+01_JPRB, 0.206455E+01_JPRB, 0.207758E+01_JPRB, 0.209004E+01_JPRB &
  &, 0.210192E+01_JPRB, 0.211323E+01_JPRB, 0.212395E+01_JPRB &
  &, 0.213409E+01_JPRB, 0.214365E+01_JPRB, 0.215260E+01_JPRB, 0.216098E+01_JPRB &
  &, 0.216875E+01_JPRB, 0.217592E+01_JPRB, 0.218251E+01_JPRB &
  &, 0.218849E+01_JPRB, 0.219389E+01_JPRB, 0.219869E+01_JPRB, 0.220288E+01_JPRB &
  &, 0.220649E+01_JPRB, 0.220950E+01_JPRB, 0.221190E+01_JPRB &
  &, 0.221377E+01_JPRB, 0.221503E+01_JPRB, 0.221570E+01_JPRB, 0.221580E+01_JPRB &
  &, 0.221534E+01_JPRB, 0.221429E+01_JPRB, 0.221268E+01_JPRB &
  &, 0.221053E+01_JPRB, 0.220781E+01_JPRB, 0.220454E+01_JPRB, 0.220074E+01_JPRB &
  &, 0.219640E+01_JPRB, 0.219153E+01_JPRB, 0.218614E+01_JPRB &
  &, 0.218023E+01_JPRB, 0.217381E+01_JPRB, 0.216688E+01_JPRB, 0.215949E+01_JPRB &
  &, 0.215158E+01_JPRB, 0.214321E+01_JPRB, 0.213437E+01_JPRB &
  &, 0.212506E+01_JPRB, 0.211532E+01_JPRB, 0.210511E+01_JPRB, 0.209448E+01_JPRB &
  &, 0.208342E+01_JPRB, 0.207196E+01_JPRB, 0.206006E+01_JPRB &
  &, 0.204778E+01_JPRB, 0.203511E+01_JPRB, 0.202208E+01_JPRB, 0.200865E+01_JPRB &
  &, 0.199490E+01_JPRB, 0.198077E+01_JPRB, 0.196631E+01_JPRB &
  &, 0.195152E+01_JPRB, 0.193642E+01_JPRB, 0.192103E+01_JPRB, 0.190532E+01_JPRB &
  &, 0.188931E+01_JPRB, 0.187306E+01_JPRB, 0.185653E+01_JPRB &
  &, 0.183973E+01_JPRB, 0.182266E+01_JPRB, 0.180539E+01_JPRB, 0.178790E+01_JPRB &
  &, 0.177018E+01_JPRB, 0.175226E+01_JPRB, 0.173415E+01_JPRB &
  &, 0.171585E+01_JPRB, 0.169739E+01_JPRB, 0.167879E+01_JPRB, 0.165998E+01_JPRB &
  &, 0.164104E+01_JPRB, 0.162201E+01_JPRB, 0.160285E+01_JPRB &
  &, 0.158355E+01_JPRB, 0.156413E+01_JPRB, 0.154466E+01_JPRB, 0.152509E+01_JPRB &
  &, 0.150543E+01_JPRB, 0.148570E+01_JPRB, 0.146595E+01_JPRB &
  &, 0.144613E+01_JPRB, 0.142622E+01_JPRB, 0.140641E+01_JPRB, 0.138651E+01_JPRB &
  &, 0.136665E+01_JPRB, 0.134675E+01_JPRB, 0.132683E+01_JPRB &
  &, 0.130691E+01_JPRB, 0.128709E+01_JPRB, 0.126726E+01_JPRB, 0.124745E+01_JPRB &
  &, 0.122769E+01_JPRB, 0.120800E+01_JPRB, 0.118840E+01_JPRB/)
XCW( 860, :) = (/ &
  &  0.110835E+01_JPRB, 0.113548E+01_JPRB, 0.116261E+01_JPRB, 0.118970E+01_JPRB &
  &, 0.121675E+01_JPRB, 0.124374E+01_JPRB, 0.127066E+01_JPRB &
  &, 0.129748E+01_JPRB, 0.132418E+01_JPRB, 0.135077E+01_JPRB, 0.137721E+01_JPRB &
  &, 0.140350E+01_JPRB, 0.142961E+01_JPRB, 0.145553E+01_JPRB &
  &, 0.148125E+01_JPRB, 0.150674E+01_JPRB, 0.153200E+01_JPRB, 0.155701E+01_JPRB &
  &, 0.158176E+01_JPRB, 0.160621E+01_JPRB, 0.163037E+01_JPRB &
  &, 0.165422E+01_JPRB, 0.167774E+01_JPRB, 0.170092E+01_JPRB, 0.172375E+01_JPRB &
  &, 0.174620E+01_JPRB, 0.176827E+01_JPRB, 0.178994E+01_JPRB &
  &, 0.181120E+01_JPRB, 0.183204E+01_JPRB, 0.185245E+01_JPRB, 0.187241E+01_JPRB &
  &, 0.189191E+01_JPRB, 0.191094E+01_JPRB, 0.192949E+01_JPRB &
  &, 0.194755E+01_JPRB, 0.196511E+01_JPRB, 0.198215E+01_JPRB, 0.199869E+01_JPRB &
  &, 0.201469E+01_JPRB, 0.203015E+01_JPRB, 0.204508E+01_JPRB &
  &, 0.205945E+01_JPRB, 0.207328E+01_JPRB, 0.208653E+01_JPRB, 0.209922E+01_JPRB &
  &, 0.211125E+01_JPRB, 0.212288E+01_JPRB, 0.213383E+01_JPRB &
  &, 0.214421E+01_JPRB, 0.215400E+01_JPRB, 0.216319E+01_JPRB, 0.217179E+01_JPRB &
  &, 0.217979E+01_JPRB, 0.218721E+01_JPRB, 0.219401E+01_JPRB &
  &, 0.220024E+01_JPRB, 0.220585E+01_JPRB, 0.221087E+01_JPRB, 0.221530E+01_JPRB &
  &, 0.221914E+01_JPRB, 0.222238E+01_JPRB, 0.222502E+01_JPRB &
  &, 0.222709E+01_JPRB, 0.222857E+01_JPRB, 0.222946E+01_JPRB, 0.222979E+01_JPRB &
  &, 0.222953E+01_JPRB, 0.222869E+01_JPRB, 0.222730E+01_JPRB &
  &, 0.222533E+01_JPRB, 0.222284E+01_JPRB, 0.221977E+01_JPRB, 0.221616E+01_JPRB &
  &, 0.221202E+01_JPRB, 0.220735E+01_JPRB, 0.220214E+01_JPRB &
  &, 0.219643E+01_JPRB, 0.219021E+01_JPRB, 0.218346E+01_JPRB, 0.217623E+01_JPRB &
  &, 0.216852E+01_JPRB, 0.216032E+01_JPRB, 0.215164E+01_JPRB &
  &, 0.214250E+01_JPRB, 0.213291E+01_JPRB, 0.212286E+01_JPRB, 0.211238E+01_JPRB &
  &, 0.210147E+01_JPRB, 0.209016E+01_JPRB, 0.207841E+01_JPRB &
  &, 0.206628E+01_JPRB, 0.205375E+01_JPRB, 0.204082E+01_JPRB, 0.202755E+01_JPRB &
  &, 0.201390E+01_JPRB, 0.199989E+01_JPRB, 0.198555E+01_JPRB &
  &, 0.197087E+01_JPRB, 0.195588E+01_JPRB, 0.194057E+01_JPRB, 0.192493E+01_JPRB &
  &, 0.190905E+01_JPRB, 0.189286E+01_JPRB, 0.187637E+01_JPRB &
  &, 0.185966E+01_JPRB, 0.184271E+01_JPRB, 0.182547E+01_JPRB, 0.180805E+01_JPRB &
  &, 0.179039E+01_JPRB, 0.177253E+01_JPRB, 0.175447E+01_JPRB &
  &, 0.173618E+01_JPRB, 0.171776E+01_JPRB, 0.169914E+01_JPRB, 0.168041E+01_JPRB &
  &, 0.166150E+01_JPRB, 0.164243E+01_JPRB, 0.162328E+01_JPRB &
  &, 0.160399E+01_JPRB, 0.158462E+01_JPRB, 0.156510E+01_JPRB, 0.154551E+01_JPRB &
  &, 0.152582E+01_JPRB, 0.150612E+01_JPRB, 0.148633E+01_JPRB &
  &, 0.146647E+01_JPRB, 0.144657E+01_JPRB, 0.142665E+01_JPRB, 0.140674E+01_JPRB &
  &, 0.138676E+01_JPRB, 0.136684E+01_JPRB, 0.134683E+01_JPRB &
  &, 0.132689E+01_JPRB, 0.130696E+01_JPRB, 0.128709E+01_JPRB, 0.126717E+01_JPRB &
  &, 0.124734E+01_JPRB, 0.122758E+01_JPRB, 0.120785E+01_JPRB/)
XCW( 861, :) = (/ &
  &  0.110883E+01_JPRB, 0.113610E+01_JPRB, 0.116336E+01_JPRB, 0.119059E+01_JPRB &
  &, 0.121778E+01_JPRB, 0.124492E+01_JPRB, 0.127198E+01_JPRB &
  &, 0.129895E+01_JPRB, 0.132582E+01_JPRB, 0.135256E+01_JPRB, 0.137917E+01_JPRB &
  &, 0.140562E+01_JPRB, 0.143190E+01_JPRB, 0.145799E+01_JPRB &
  &, 0.148389E+01_JPRB, 0.150956E+01_JPRB, 0.153501E+01_JPRB, 0.156020E+01_JPRB &
  &, 0.158513E+01_JPRB, 0.160978E+01_JPRB, 0.163413E+01_JPRB &
  &, 0.165818E+01_JPRB, 0.168190E+01_JPRB, 0.170528E+01_JPRB, 0.172830E+01_JPRB &
  &, 0.175097E+01_JPRB, 0.177325E+01_JPRB, 0.179513E+01_JPRB &
  &, 0.181660E+01_JPRB, 0.183766E+01_JPRB, 0.185828E+01_JPRB, 0.187846E+01_JPRB &
  &, 0.189818E+01_JPRB, 0.191744E+01_JPRB, 0.193621E+01_JPRB &
  &, 0.195449E+01_JPRB, 0.197227E+01_JPRB, 0.198956E+01_JPRB, 0.200631E+01_JPRB &
  &, 0.202254E+01_JPRB, 0.203825E+01_JPRB, 0.205340E+01_JPRB &
  &, 0.206801E+01_JPRB, 0.208206E+01_JPRB, 0.209556E+01_JPRB, 0.210848E+01_JPRB &
  &, 0.212083E+01_JPRB, 0.213261E+01_JPRB, 0.214380E+01_JPRB &
  &, 0.215440E+01_JPRB, 0.216443E+01_JPRB, 0.217386E+01_JPRB, 0.218268E+01_JPRB &
  &, 0.219093E+01_JPRB, 0.219857E+01_JPRB, 0.220561E+01_JPRB &
  &, 0.221206E+01_JPRB, 0.221791E+01_JPRB, 0.222317E+01_JPRB, 0.222783E+01_JPRB &
  &, 0.223190E+01_JPRB, 0.223537E+01_JPRB, 0.223825E+01_JPRB &
  &, 0.224052E+01_JPRB, 0.224223E+01_JPRB, 0.224334E+01_JPRB, 0.224387E+01_JPRB &
  &, 0.224384E+01_JPRB, 0.224323E+01_JPRB, 0.224204E+01_JPRB &
  &, 0.224031E+01_JPRB, 0.223800E+01_JPRB, 0.223514E+01_JPRB, 0.223173E+01_JPRB &
  &, 0.222780E+01_JPRB, 0.222331E+01_JPRB, 0.221830E+01_JPRB &
  &, 0.221280E+01_JPRB, 0.220676E+01_JPRB, 0.220020E+01_JPRB, 0.219316E+01_JPRB &
  &, 0.218561E+01_JPRB, 0.217758E+01_JPRB, 0.216910E+01_JPRB &
  &, 0.216012E+01_JPRB, 0.215068E+01_JPRB, 0.214081E+01_JPRB, 0.213049E+01_JPRB &
  &, 0.211974E+01_JPRB, 0.210855E+01_JPRB, 0.209698E+01_JPRB &
  &, 0.208496E+01_JPRB, 0.207257E+01_JPRB, 0.205978E+01_JPRB, 0.204665E+01_JPRB &
  &, 0.203309E+01_JPRB, 0.201921E+01_JPRB, 0.200500E+01_JPRB &
  &, 0.199044E+01_JPRB, 0.197553E+01_JPRB, 0.196033E+01_JPRB, 0.194479E+01_JPRB &
  &, 0.192898E+01_JPRB, 0.191288E+01_JPRB, 0.189649E+01_JPRB &
  &, 0.187987E+01_JPRB, 0.186296E+01_JPRB, 0.184584E+01_JPRB, 0.182845E+01_JPRB &
  &, 0.181086E+01_JPRB, 0.179301E+01_JPRB, 0.177502E+01_JPRB &
  &, 0.175677E+01_JPRB, 0.173840E+01_JPRB, 0.171982E+01_JPRB, 0.170108E+01_JPRB &
  &, 0.168220E+01_JPRB, 0.166315E+01_JPRB, 0.164402E+01_JPRB &
  &, 0.162473E+01_JPRB, 0.160531E+01_JPRB, 0.158584E+01_JPRB, 0.156624E+01_JPRB &
  &, 0.154654E+01_JPRB, 0.152681E+01_JPRB, 0.150699E+01_JPRB &
  &, 0.148709E+01_JPRB, 0.146720E+01_JPRB, 0.144723E+01_JPRB, 0.142721E+01_JPRB &
  &, 0.140721E+01_JPRB, 0.138722E+01_JPRB, 0.136720E+01_JPRB &
  &, 0.134716E+01_JPRB, 0.132714E+01_JPRB, 0.130717E+01_JPRB, 0.128726E+01_JPRB &
  &, 0.126732E+01_JPRB, 0.124743E+01_JPRB, 0.122763E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART123',1,ZHOOK_HANDLE)
END SUBROUTINE PART123

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART124

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART124',0,ZHOOK_HANDLE)

XCW( 862, :) = (/ &
  &  0.110931E+01_JPRB, 0.113671E+01_JPRB, 0.116411E+01_JPRB, 0.119148E+01_JPRB &
  &, 0.121881E+01_JPRB, 0.124610E+01_JPRB, 0.127331E+01_JPRB &
  &, 0.130043E+01_JPRB, 0.132746E+01_JPRB, 0.135436E+01_JPRB, 0.138113E+01_JPRB &
  &, 0.140775E+01_JPRB, 0.143420E+01_JPRB, 0.146047E+01_JPRB &
  &, 0.148654E+01_JPRB, 0.151240E+01_JPRB, 0.153803E+01_JPRB, 0.156341E+01_JPRB &
  &, 0.158852E+01_JPRB, 0.161337E+01_JPRB, 0.163791E+01_JPRB &
  &, 0.166216E+01_JPRB, 0.168607E+01_JPRB, 0.170966E+01_JPRB, 0.173290E+01_JPRB &
  &, 0.175576E+01_JPRB, 0.177825E+01_JPRB, 0.180035E+01_JPRB &
  &, 0.182204E+01_JPRB, 0.184331E+01_JPRB, 0.186416E+01_JPRB, 0.188455E+01_JPRB &
  &, 0.190450E+01_JPRB, 0.192397E+01_JPRB, 0.194297E+01_JPRB &
  &, 0.196149E+01_JPRB, 0.197949E+01_JPRB, 0.199701E+01_JPRB, 0.201399E+01_JPRB &
  &, 0.203046E+01_JPRB, 0.204639E+01_JPRB, 0.206178E+01_JPRB &
  &, 0.207663E+01_JPRB, 0.209091E+01_JPRB, 0.210464E+01_JPRB, 0.211780E+01_JPRB &
  &, 0.213039E+01_JPRB, 0.214240E+01_JPRB, 0.215383E+01_JPRB &
  &, 0.216468E+01_JPRB, 0.217494E+01_JPRB, 0.218461E+01_JPRB, 0.219368E+01_JPRB &
  &, 0.220216E+01_JPRB, 0.221004E+01_JPRB, 0.221732E+01_JPRB &
  &, 0.222400E+01_JPRB, 0.223009E+01_JPRB, 0.223558E+01_JPRB, 0.224046E+01_JPRB &
  &, 0.224470E+01_JPRB, 0.224846E+01_JPRB, 0.225156E+01_JPRB &
  &, 0.225407E+01_JPRB, 0.225601E+01_JPRB, 0.225734E+01_JPRB, 0.225811E+01_JPRB &
  &, 0.225828E+01_JPRB, 0.225788E+01_JPRB, 0.225691E+01_JPRB &
  &, 0.225538E+01_JPRB, 0.225314E+01_JPRB, 0.225066E+01_JPRB, 0.224746E+01_JPRB &
  &, 0.224372E+01_JPRB, 0.223944E+01_JPRB, 0.223464E+01_JPRB &
  &, 0.222931E+01_JPRB, 0.222345E+01_JPRB, 0.221710E+01_JPRB, 0.221024E+01_JPRB &
  &, 0.220289E+01_JPRB, 0.219504E+01_JPRB, 0.218670E+01_JPRB &
  &, 0.217792E+01_JPRB, 0.216867E+01_JPRB, 0.215894E+01_JPRB, 0.214878E+01_JPRB &
  &, 0.213818E+01_JPRB, 0.212715E+01_JPRB, 0.211570E+01_JPRB &
  &, 0.210386E+01_JPRB, 0.209159E+01_JPRB, 0.207894E+01_JPRB, 0.206591E+01_JPRB &
  &, 0.205253E+01_JPRB, 0.203878E+01_JPRB, 0.202466E+01_JPRB &
  &, 0.201023E+01_JPRB, 0.199544E+01_JPRB, 0.198031E+01_JPRB, 0.196488E+01_JPRB &
  &, 0.194918E+01_JPRB, 0.193318E+01_JPRB, 0.191689E+01_JPRB &
  &, 0.190032E+01_JPRB, 0.188350E+01_JPRB, 0.186642E+01_JPRB, 0.184911E+01_JPRB &
  &, 0.183155E+01_JPRB, 0.181381E+01_JPRB, 0.179583E+01_JPRB &
  &, 0.177764E+01_JPRB, 0.175931E+01_JPRB, 0.174069E+01_JPRB, 0.172203E+01_JPRB &
  &, 0.170318E+01_JPRB, 0.168416E+01_JPRB, 0.166504E+01_JPRB &
  &, 0.164577E+01_JPRB, 0.162635E+01_JPRB, 0.160683E+01_JPRB, 0.158723E+01_JPRB &
  &, 0.156756E+01_JPRB, 0.154777E+01_JPRB, 0.152792E+01_JPRB &
  &, 0.150804E+01_JPRB, 0.148806E+01_JPRB, 0.146809E+01_JPRB, 0.144807E+01_JPRB &
  &, 0.142802E+01_JPRB, 0.140790E+01_JPRB, 0.138786E+01_JPRB &
  &, 0.136774E+01_JPRB, 0.134769E+01_JPRB, 0.132762E+01_JPRB, 0.130760E+01_JPRB &
  &, 0.128761E+01_JPRB, 0.126767E+01_JPRB, 0.124773E+01_JPRB/)
XCW( 863, :) = (/ &
  &  0.110980E+01_JPRB, 0.113733E+01_JPRB, 0.116486E+01_JPRB, 0.119237E+01_JPRB &
  &, 0.121985E+01_JPRB, 0.124728E+01_JPRB, 0.127464E+01_JPRB &
  &, 0.130192E+01_JPRB, 0.132911E+01_JPRB, 0.135617E+01_JPRB, 0.138311E+01_JPRB &
  &, 0.140990E+01_JPRB, 0.143652E+01_JPRB, 0.146297E+01_JPRB &
  &, 0.148921E+01_JPRB, 0.151525E+01_JPRB, 0.154106E+01_JPRB, 0.156663E+01_JPRB &
  &, 0.159194E+01_JPRB, 0.161698E+01_JPRB, 0.164172E+01_JPRB &
  &, 0.166617E+01_JPRB, 0.169029E+01_JPRB, 0.171408E+01_JPRB, 0.173752E+01_JPRB &
  &, 0.176059E+01_JPRB, 0.178330E+01_JPRB, 0.180561E+01_JPRB &
  &, 0.182751E+01_JPRB, 0.184901E+01_JPRB, 0.187007E+01_JPRB, 0.189069E+01_JPRB &
  &, 0.191086E+01_JPRB, 0.193056E+01_JPRB, 0.194978E+01_JPRB &
  &, 0.196853E+01_JPRB, 0.198677E+01_JPRB, 0.200451E+01_JPRB, 0.202173E+01_JPRB &
  &, 0.203843E+01_JPRB, 0.205460E+01_JPRB, 0.207023E+01_JPRB &
  &, 0.208531E+01_JPRB, 0.209984E+01_JPRB, 0.211380E+01_JPRB, 0.212720E+01_JPRB &
  &, 0.213999E+01_JPRB, 0.215228E+01_JPRB, 0.216395E+01_JPRB &
  &, 0.217503E+01_JPRB, 0.218553E+01_JPRB, 0.219544E+01_JPRB, 0.220476E+01_JPRB &
  &, 0.221348E+01_JPRB, 0.222159E+01_JPRB, 0.222911E+01_JPRB &
  &, 0.223604E+01_JPRB, 0.224237E+01_JPRB, 0.224808E+01_JPRB, 0.225321E+01_JPRB &
  &, 0.225774E+01_JPRB, 0.226167E+01_JPRB, 0.226500E+01_JPRB &
  &, 0.226774E+01_JPRB, 0.226990E+01_JPRB, 0.227147E+01_JPRB, 0.227244E+01_JPRB &
  &, 0.227285E+01_JPRB, 0.227268E+01_JPRB, 0.227193E+01_JPRB &
  &, 0.227061E+01_JPRB, 0.226875E+01_JPRB, 0.226631E+01_JPRB, 0.226332E+01_JPRB &
  &, 0.225979E+01_JPRB, 0.225572E+01_JPRB, 0.225111E+01_JPRB &
  &, 0.224599E+01_JPRB, 0.224032E+01_JPRB, 0.223416E+01_JPRB, 0.222749E+01_JPRB &
  &, 0.222033E+01_JPRB, 0.221265E+01_JPRB, 0.220451E+01_JPRB &
  &, 0.219588E+01_JPRB, 0.218680E+01_JPRB, 0.217726E+01_JPRB, 0.216727E+01_JPRB &
  &, 0.215681E+01_JPRB, 0.214597E+01_JPRB, 0.213468E+01_JPRB &
  &, 0.212296E+01_JPRB, 0.211083E+01_JPRB, 0.209833E+01_JPRB, 0.208545E+01_JPRB &
  &, 0.207217E+01_JPRB, 0.205856E+01_JPRB, 0.204457E+01_JPRB &
  &, 0.203022E+01_JPRB, 0.201556E+01_JPRB, 0.200055E+01_JPRB, 0.198524E+01_JPRB &
  &, 0.196961E+01_JPRB, 0.195368E+01_JPRB, 0.193748E+01_JPRB &
  &, 0.192101E+01_JPRB, 0.190424E+01_JPRB, 0.188725E+01_JPRB, 0.187002E+01_JPRB &
  &, 0.185253E+01_JPRB, 0.183482E+01_JPRB, 0.181690E+01_JPRB &
  &, 0.179877E+01_JPRB, 0.178045E+01_JPRB, 0.176197E+01_JPRB, 0.174331E+01_JPRB &
  &, 0.172444E+01_JPRB, 0.170545E+01_JPRB, 0.168631E+01_JPRB &
  &, 0.166705E+01_JPRB, 0.164765E+01_JPRB, 0.162819E+01_JPRB, 0.160858E+01_JPRB &
  &, 0.158886E+01_JPRB, 0.156905E+01_JPRB, 0.154923E+01_JPRB &
  &, 0.152927E+01_JPRB, 0.150930E+01_JPRB, 0.148924E+01_JPRB, 0.146917E+01_JPRB &
  &, 0.144906E+01_JPRB, 0.142893E+01_JPRB, 0.140882E+01_JPRB &
  &, 0.138868E+01_JPRB, 0.136855E+01_JPRB, 0.134844E+01_JPRB, 0.132833E+01_JPRB &
  &, 0.130823E+01_JPRB, 0.128823E+01_JPRB, 0.126823E+01_JPRB/)
XCW( 864, :) = (/ &
  &  0.111029E+01_JPRB, 0.113795E+01_JPRB, 0.116562E+01_JPRB, 0.119327E+01_JPRB &
  &, 0.122090E+01_JPRB, 0.124847E+01_JPRB, 0.127599E+01_JPRB &
  &, 0.130342E+01_JPRB, 0.133077E+01_JPRB, 0.135799E+01_JPRB, 0.138510E+01_JPRB &
  &, 0.141205E+01_JPRB, 0.143885E+01_JPRB, 0.146547E+01_JPRB &
  &, 0.149190E+01_JPRB, 0.151812E+01_JPRB, 0.154412E+01_JPRB, 0.156988E+01_JPRB &
  &, 0.159538E+01_JPRB, 0.162061E+01_JPRB, 0.164556E+01_JPRB &
  &, 0.167020E+01_JPRB, 0.169453E+01_JPRB, 0.171852E+01_JPRB, 0.174217E+01_JPRB &
  &, 0.176546E+01_JPRB, 0.178837E+01_JPRB, 0.181090E+01_JPRB &
  &, 0.183303E+01_JPRB, 0.185474E+01_JPRB, 0.187602E+01_JPRB, 0.189686E+01_JPRB &
  &, 0.191726E+01_JPRB, 0.193719E+01_JPRB, 0.195665E+01_JPRB &
  &, 0.197561E+01_JPRB, 0.199409E+01_JPRB, 0.201207E+01_JPRB, 0.202953E+01_JPRB &
  &, 0.204646E+01_JPRB, 0.206287E+01_JPRB, 0.207873E+01_JPRB &
  &, 0.209406E+01_JPRB, 0.210883E+01_JPRB, 0.212303E+01_JPRB, 0.213668E+01_JPRB &
  &, 0.214974E+01_JPRB, 0.216224E+01_JPRB, 0.217415E+01_JPRB &
  &, 0.218548E+01_JPRB, 0.219622E+01_JPRB, 0.220637E+01_JPRB, 0.221592E+01_JPRB &
  &, 0.222488E+01_JPRB, 0.223325E+01_JPRB, 0.224099E+01_JPRB &
  &, 0.224817E+01_JPRB, 0.225474E+01_JPRB, 0.226070E+01_JPRB, 0.226605E+01_JPRB &
  &, 0.227083E+01_JPRB, 0.227498E+01_JPRB, 0.227856E+01_JPRB &
  &, 0.228153E+01_JPRB, 0.228392E+01_JPRB, 0.228572E+01_JPRB, 0.228693E+01_JPRB &
  &, 0.228756E+01_JPRB, 0.228760E+01_JPRB, 0.228708E+01_JPRB &
  &, 0.228598E+01_JPRB, 0.228434E+01_JPRB, 0.228211E+01_JPRB, 0.227935E+01_JPRB &
  &, 0.227603E+01_JPRB, 0.227215E+01_JPRB, 0.226775E+01_JPRB &
  &, 0.226283E+01_JPRB, 0.225736E+01_JPRB, 0.225141E+01_JPRB, 0.224491E+01_JPRB &
  &, 0.223795E+01_JPRB, 0.223045E+01_JPRB, 0.222249E+01_JPRB &
  &, 0.221406E+01_JPRB, 0.220513E+01_JPRB, 0.219576E+01_JPRB, 0.218594E+01_JPRB &
  &, 0.217568E+01_JPRB, 0.216497E+01_JPRB, 0.215383E+01_JPRB &
  &, 0.214227E+01_JPRB, 0.213030E+01_JPRB, 0.211792E+01_JPRB, 0.210518E+01_JPRB &
  &, 0.209205E+01_JPRB, 0.207854E+01_JPRB, 0.206468E+01_JPRB &
  &, 0.205047E+01_JPRB, 0.203590E+01_JPRB, 0.202102E+01_JPRB, 0.200578E+01_JPRB &
  &, 0.199026E+01_JPRB, 0.197445E+01_JPRB, 0.195836E+01_JPRB &
  &, 0.194194E+01_JPRB, 0.192527E+01_JPRB, 0.190837E+01_JPRB, 0.189118E+01_JPRB &
  &, 0.187377E+01_JPRB, 0.185613E+01_JPRB, 0.183824E+01_JPRB &
  &, 0.182018E+01_JPRB, 0.180191E+01_JPRB, 0.178344E+01_JPRB, 0.176482E+01_JPRB &
  &, 0.174600E+01_JPRB, 0.172704E+01_JPRB, 0.170793E+01_JPRB &
  &, 0.168869E+01_JPRB, 0.166931E+01_JPRB, 0.164980E+01_JPRB, 0.163019E+01_JPRB &
  &, 0.161047E+01_JPRB, 0.159065E+01_JPRB, 0.157081E+01_JPRB &
  &, 0.155083E+01_JPRB, 0.153083E+01_JPRB, 0.151073E+01_JPRB, 0.149061E+01_JPRB &
  &, 0.147051E+01_JPRB, 0.145032E+01_JPRB, 0.143014E+01_JPRB &
  &, 0.140993E+01_JPRB, 0.138971E+01_JPRB, 0.136952E+01_JPRB, 0.134936E+01_JPRB &
  &, 0.132922E+01_JPRB, 0.130905E+01_JPRB, 0.128900E+01_JPRB/)
XCW( 865, :) = (/ &
  &  0.111078E+01_JPRB, 0.113858E+01_JPRB, 0.116639E+01_JPRB, 0.119418E+01_JPRB &
  &, 0.122195E+01_JPRB, 0.124967E+01_JPRB, 0.127734E+01_JPRB &
  &, 0.130493E+01_JPRB, 0.133243E+01_JPRB, 0.135983E+01_JPRB, 0.138710E+01_JPRB &
  &, 0.141423E+01_JPRB, 0.144120E+01_JPRB, 0.146800E+01_JPRB &
  &, 0.149461E+01_JPRB, 0.152101E+01_JPRB, 0.154720E+01_JPRB, 0.157315E+01_JPRB &
  &, 0.159884E+01_JPRB, 0.162427E+01_JPRB, 0.164941E+01_JPRB &
  &, 0.167426E+01_JPRB, 0.169879E+01_JPRB, 0.172299E+01_JPRB, 0.174685E+01_JPRB &
  &, 0.177035E+01_JPRB, 0.179349E+01_JPRB, 0.181623E+01_JPRB &
  &, 0.183858E+01_JPRB, 0.186051E+01_JPRB, 0.188202E+01_JPRB, 0.190309E+01_JPRB &
  &, 0.192371E+01_JPRB, 0.194387E+01_JPRB, 0.196356E+01_JPRB &
  &, 0.198277E+01_JPRB, 0.200147E+01_JPRB, 0.201968E+01_JPRB, 0.203738E+01_JPRB &
  &, 0.205456E+01_JPRB, 0.207053E+01_JPRB, 0.208731E+01_JPRB &
  &, 0.210288E+01_JPRB, 0.211788E+01_JPRB, 0.213233E+01_JPRB, 0.214622E+01_JPRB &
  &, 0.215954E+01_JPRB, 0.217227E+01_JPRB, 0.218443E+01_JPRB &
  &, 0.219600E+01_JPRB, 0.220697E+01_JPRB, 0.221739E+01_JPRB, 0.222719E+01_JPRB &
  &, 0.223640E+01_JPRB, 0.224499E+01_JPRB, 0.225301E+01_JPRB &
  &, 0.226042E+01_JPRB, 0.226722E+01_JPRB, 0.227342E+01_JPRB, 0.227901E+01_JPRB &
  &, 0.228403E+01_JPRB, 0.228844E+01_JPRB, 0.229224E+01_JPRB &
  &, 0.229545E+01_JPRB, 0.229808E+01_JPRB, 0.230009E+01_JPRB, 0.230154E+01_JPRB &
  &, 0.230240E+01_JPRB, 0.230269E+01_JPRB, 0.230238E+01_JPRB &
  &, 0.230150E+01_JPRB, 0.230008E+01_JPRB, 0.229807E+01_JPRB, 0.229552E+01_JPRB &
  &, 0.229240E+01_JPRB, 0.228858E+01_JPRB, 0.228456E+01_JPRB &
  &, 0.227983E+01_JPRB, 0.227458E+01_JPRB, 0.226882E+01_JPRB, 0.226253E+01_JPRB &
  &, 0.225573E+01_JPRB, 0.224844E+01_JPRB, 0.224067E+01_JPRB &
  &, 0.223242E+01_JPRB, 0.222369E+01_JPRB, 0.221447E+01_JPRB, 0.220482E+01_JPRB &
  &, 0.219472E+01_JPRB, 0.218415E+01_JPRB, 0.217318E+01_JPRB &
  &, 0.216178E+01_JPRB, 0.214997E+01_JPRB, 0.213774E+01_JPRB, 0.212515E+01_JPRB &
  &, 0.211213E+01_JPRB, 0.209876E+01_JPRB, 0.208501E+01_JPRB &
  &, 0.207094E+01_JPRB, 0.205649E+01_JPRB, 0.204174E+01_JPRB, 0.202663E+01_JPRB &
  &, 0.201119E+01_JPRB, 0.199548E+01_JPRB, 0.197946E+01_JPRB &
  &, 0.196315E+01_JPRB, 0.194658E+01_JPRB, 0.192973E+01_JPRB, 0.191263E+01_JPRB &
  &, 0.189527E+01_JPRB, 0.187771E+01_JPRB, 0.185989E+01_JPRB &
  &, 0.184189E+01_JPRB, 0.182365E+01_JPRB, 0.180523E+01_JPRB, 0.178662E+01_JPRB &
  &, 0.176784E+01_JPRB, 0.174892E+01_JPRB, 0.172984E+01_JPRB &
  &, 0.171058E+01_JPRB, 0.169121E+01_JPRB, 0.167172E+01_JPRB, 0.165212E+01_JPRB &
  &, 0.163239E+01_JPRB, 0.161257E+01_JPRB, 0.159267E+01_JPRB &
  &, 0.157272E+01_JPRB, 0.155269E+01_JPRB, 0.153256E+01_JPRB, 0.151240E+01_JPRB &
  &, 0.149225E+01_JPRB, 0.147201E+01_JPRB, 0.145176E+01_JPRB &
  &, 0.143142E+01_JPRB, 0.141125E+01_JPRB, 0.139096E+01_JPRB, 0.137072E+01_JPRB &
  &, 0.135054E+01_JPRB, 0.133032E+01_JPRB, 0.131016E+01_JPRB/)
XCW( 866, :) = (/ &
  &  0.111128E+01_JPRB, 0.113921E+01_JPRB, 0.116715E+01_JPRB, 0.119509E+01_JPRB &
  &, 0.122300E+01_JPRB, 0.125088E+01_JPRB, 0.127870E+01_JPRB &
  &, 0.130645E+01_JPRB, 0.133411E+01_JPRB, 0.136167E+01_JPRB, 0.138911E+01_JPRB &
  &, 0.141641E+01_JPRB, 0.144356E+01_JPRB, 0.147054E+01_JPRB &
  &, 0.149733E+01_JPRB, 0.152392E+01_JPRB, 0.155029E+01_JPRB, 0.157644E+01_JPRB &
  &, 0.160233E+01_JPRB, 0.162795E+01_JPRB, 0.165330E+01_JPRB &
  &, 0.167834E+01_JPRB, 0.170308E+01_JPRB, 0.172749E+01_JPRB, 0.175157E+01_JPRB &
  &, 0.177528E+01_JPRB, 0.179863E+01_JPRB, 0.182160E+01_JPRB &
  &, 0.184416E+01_JPRB, 0.186632E+01_JPRB, 0.188805E+01_JPRB, 0.190935E+01_JPRB &
  &, 0.193021E+01_JPRB, 0.195060E+01_JPRB, 0.197052E+01_JPRB &
  &, 0.198996E+01_JPRB, 0.200891E+01_JPRB, 0.202736E+01_JPRB, 0.204529E+01_JPRB &
  &, 0.206271E+01_JPRB, 0.207960E+01_JPRB, 0.209595E+01_JPRB &
  &, 0.211176E+01_JPRB, 0.212701E+01_JPRB, 0.214171E+01_JPRB, 0.215584E+01_JPRB &
  &, 0.216940E+01_JPRB, 0.218239E+01_JPRB, 0.219480E+01_JPRB &
  &, 0.220662E+01_JPRB, 0.221785E+01_JPRB, 0.222850E+01_JPRB, 0.223853E+01_JPRB &
  &, 0.224799E+01_JPRB, 0.225684E+01_JPRB, 0.226509E+01_JPRB &
  &, 0.227275E+01_JPRB, 0.227981E+01_JPRB, 0.228625E+01_JPRB, 0.229209E+01_JPRB &
  &, 0.229734E+01_JPRB, 0.230199E+01_JPRB, 0.230603E+01_JPRB &
  &, 0.230949E+01_JPRB, 0.231234E+01_JPRB, 0.231461E+01_JPRB, 0.231628E+01_JPRB &
  &, 0.231738E+01_JPRB, 0.231789E+01_JPRB, 0.231781E+01_JPRB &
  &, 0.231717E+01_JPRB, 0.231597E+01_JPRB, 0.231418E+01_JPRB, 0.231184E+01_JPRB &
  &, 0.230896E+01_JPRB, 0.230552E+01_JPRB, 0.230154E+01_JPRB &
  &, 0.229700E+01_JPRB, 0.229197E+01_JPRB, 0.228640E+01_JPRB, 0.228030E+01_JPRB &
  &, 0.227372E+01_JPRB, 0.226662E+01_JPRB, 0.225903E+01_JPRB &
  &, 0.225096E+01_JPRB, 0.224238E+01_JPRB, 0.223337E+01_JPRB, 0.222390E+01_JPRB &
  &, 0.221395E+01_JPRB, 0.220357E+01_JPRB, 0.219274E+01_JPRB &
  &, 0.218150E+01_JPRB, 0.216985E+01_JPRB, 0.215778E+01_JPRB, 0.214532E+01_JPRB &
  &, 0.213245E+01_JPRB, 0.211923E+01_JPRB, 0.210562E+01_JPRB &
  &, 0.209165E+01_JPRB, 0.207734E+01_JPRB, 0.206268E+01_JPRB, 0.204770E+01_JPRB &
  &, 0.203238E+01_JPRB, 0.201676E+01_JPRB, 0.200085E+01_JPRB &
  &, 0.198461E+01_JPRB, 0.196814E+01_JPRB, 0.195135E+01_JPRB, 0.193434E+01_JPRB &
  &, 0.191706E+01_JPRB, 0.189954E+01_JPRB, 0.188181E+01_JPRB &
  &, 0.186384E+01_JPRB, 0.184566E+01_JPRB, 0.182730E+01_JPRB, 0.180874E+01_JPRB &
  &, 0.179001E+01_JPRB, 0.177109E+01_JPRB, 0.175200E+01_JPRB &
  &, 0.173282E+01_JPRB, 0.171342E+01_JPRB, 0.169395E+01_JPRB, 0.167436E+01_JPRB &
  &, 0.165464E+01_JPRB, 0.163481E+01_JPRB, 0.161490E+01_JPRB &
  &, 0.159493E+01_JPRB, 0.157483E+01_JPRB, 0.155473E+01_JPRB, 0.153453E+01_JPRB &
  &, 0.151434E+01_JPRB, 0.149404E+01_JPRB, 0.147374E+01_JPRB &
  &, 0.145345E+01_JPRB, 0.143315E+01_JPRB, 0.141279E+01_JPRB, 0.139245E+01_JPRB &
  &, 0.137218E+01_JPRB, 0.135186E+01_JPRB, 0.133165E+01_JPRB/)
XCW( 867, :) = (/ &
  &  0.111178E+01_JPRB, 0.113984E+01_JPRB, 0.116793E+01_JPRB, 0.119600E+01_JPRB &
  &, 0.122407E+01_JPRB, 0.125209E+01_JPRB, 0.128007E+01_JPRB &
  &, 0.130798E+01_JPRB, 0.133580E+01_JPRB, 0.136353E+01_JPRB, 0.139113E+01_JPRB &
  &, 0.141861E+01_JPRB, 0.144593E+01_JPRB, 0.147309E+01_JPRB &
  &, 0.150007E+01_JPRB, 0.152685E+01_JPRB, 0.155341E+01_JPRB, 0.157974E+01_JPRB &
  &, 0.160583E+01_JPRB, 0.163166E+01_JPRB, 0.165720E+01_JPRB &
  &, 0.168246E+01_JPRB, 0.170741E+01_JPRB, 0.173203E+01_JPRB, 0.175631E+01_JPRB &
  &, 0.178025E+01_JPRB, 0.180382E+01_JPRB, 0.182700E+01_JPRB &
  &, 0.184979E+01_JPRB, 0.187217E+01_JPRB, 0.189414E+01_JPRB, 0.191566E+01_JPRB &
  &, 0.193675E+01_JPRB, 0.195738E+01_JPRB, 0.197753E+01_JPRB &
  &, 0.199721E+01_JPRB, 0.201640E+01_JPRB, 0.203509E+01_JPRB, 0.205327E+01_JPRB &
  &, 0.207092E+01_JPRB, 0.208806E+01_JPRB, 0.210465E+01_JPRB &
  &, 0.212071E+01_JPRB, 0.213621E+01_JPRB, 0.215116E+01_JPRB, 0.216553E+01_JPRB &
  &, 0.217934E+01_JPRB, 0.219258E+01_JPRB, 0.220524E+01_JPRB &
  &, 0.221732E+01_JPRB, 0.222880E+01_JPRB, 0.223969E+01_JPRB, 0.224998E+01_JPRB &
  &, 0.225969E+01_JPRB, 0.226880E+01_JPRB, 0.227730E+01_JPRB &
  &, 0.228520E+01_JPRB, 0.229249E+01_JPRB, 0.229920E+01_JPRB, 0.230529E+01_JPRB &
  &, 0.231079E+01_JPRB, 0.231567E+01_JPRB, 0.231995E+01_JPRB &
  &, 0.232365E+01_JPRB, 0.232675E+01_JPRB, 0.232925E+01_JPRB, 0.233118E+01_JPRB &
  &, 0.233242E+01_JPRB, 0.233324E+01_JPRB, 0.233340E+01_JPRB &
  &, 0.233299E+01_JPRB, 0.233199E+01_JPRB, 0.233043E+01_JPRB, 0.232833E+01_JPRB &
  &, 0.232565E+01_JPRB, 0.232244E+01_JPRB, 0.231865E+01_JPRB &
  &, 0.231436E+01_JPRB, 0.230951E+01_JPRB, 0.230416E+01_JPRB, 0.229825E+01_JPRB &
  &, 0.229187E+01_JPRB, 0.228496E+01_JPRB, 0.227758E+01_JPRB &
  &, 0.226967E+01_JPRB, 0.226131E+01_JPRB, 0.225248E+01_JPRB, 0.224316E+01_JPRB &
  &, 0.223341E+01_JPRB, 0.222318E+01_JPRB, 0.221255E+01_JPRB &
  &, 0.220145E+01_JPRB, 0.218997E+01_JPRB, 0.217803E+01_JPRB, 0.216572E+01_JPRB &
  &, 0.215300E+01_JPRB, 0.213990E+01_JPRB, 0.212644E+01_JPRB &
  &, 0.211261E+01_JPRB, 0.209841E+01_JPRB, 0.208388E+01_JPRB, 0.206899E+01_JPRB &
  &, 0.205380E+01_JPRB, 0.203830E+01_JPRB, 0.202247E+01_JPRB &
  &, 0.200634E+01_JPRB, 0.198994E+01_JPRB, 0.197325E+01_JPRB, 0.195634E+01_JPRB &
  &, 0.193912E+01_JPRB, 0.192169E+01_JPRB, 0.190399E+01_JPRB &
  &, 0.188609E+01_JPRB, 0.186798E+01_JPRB, 0.184964E+01_JPRB, 0.183114E+01_JPRB &
  &, 0.181247E+01_JPRB, 0.179354E+01_JPRB, 0.177454E+01_JPRB &
  &, 0.175535E+01_JPRB, 0.173599E+01_JPRB, 0.171653E+01_JPRB, 0.169691E+01_JPRB &
  &, 0.167720E+01_JPRB, 0.165737E+01_JPRB, 0.163746E+01_JPRB &
  &, 0.161743E+01_JPRB, 0.159736E+01_JPRB, 0.157718E+01_JPRB, 0.155701E+01_JPRB &
  &, 0.153672E+01_JPRB, 0.151644E+01_JPRB, 0.149608E+01_JPRB &
  &, 0.147573E+01_JPRB, 0.145536E+01_JPRB, 0.143498E+01_JPRB, 0.141457E+01_JPRB &
  &, 0.139420E+01_JPRB, 0.137385E+01_JPRB, 0.135340E+01_JPRB/)
XCW( 868, :) = (/ &
  &  0.111228E+01_JPRB, 0.114048E+01_JPRB, 0.116870E+01_JPRB, 0.119692E+01_JPRB &
  &, 0.122513E+01_JPRB, 0.125331E+01_JPRB, 0.128145E+01_JPRB &
  &, 0.130951E+01_JPRB, 0.133750E+01_JPRB, 0.136539E+01_JPRB, 0.139317E+01_JPRB &
  &, 0.142082E+01_JPRB, 0.144832E+01_JPRB, 0.147566E+01_JPRB &
  &, 0.150282E+01_JPRB, 0.152979E+01_JPRB, 0.155655E+01_JPRB, 0.158308E+01_JPRB &
  &, 0.160936E+01_JPRB, 0.163539E+01_JPRB, 0.166114E+01_JPRB &
  &, 0.168660E+01_JPRB, 0.171176E+01_JPRB, 0.173659E+01_JPRB, 0.176110E+01_JPRB &
  &, 0.178525E+01_JPRB, 0.180903E+01_JPRB, 0.183244E+01_JPRB &
  &, 0.185546E+01_JPRB, 0.187807E+01_JPRB, 0.190026E+01_JPRB, 0.192203E+01_JPRB &
  &, 0.194334E+01_JPRB, 0.196420E+01_JPRB, 0.198460E+01_JPRB &
  &, 0.200452E+01_JPRB, 0.202393E+01_JPRB, 0.204288E+01_JPRB, 0.206130E+01_JPRB &
  &, 0.207921E+01_JPRB, 0.209658E+01_JPRB, 0.211343E+01_JPRB &
  &, 0.212973E+01_JPRB, 0.214548E+01_JPRB, 0.216068E+01_JPRB, 0.217531E+01_JPRB &
  &, 0.218938E+01_JPRB, 0.220282E+01_JPRB, 0.221577E+01_JPRB &
  &, 0.222768E+01_JPRB, 0.223984E+01_JPRB, 0.225098E+01_JPRB, 0.226153E+01_JPRB &
  &, 0.227148E+01_JPRB, 0.228084E+01_JPRB, 0.228959E+01_JPRB &
  &, 0.229775E+01_JPRB, 0.230531E+01_JPRB, 0.231224E+01_JPRB, 0.231860E+01_JPRB &
  &, 0.232433E+01_JPRB, 0.232948E+01_JPRB, 0.233401E+01_JPRB &
  &, 0.233795E+01_JPRB, 0.234128E+01_JPRB, 0.234404E+01_JPRB, 0.234619E+01_JPRB &
  &, 0.234774E+01_JPRB, 0.234872E+01_JPRB, 0.234911E+01_JPRB &
  &, 0.234893E+01_JPRB, 0.234818E+01_JPRB, 0.234685E+01_JPRB, 0.234498E+01_JPRB &
  &, 0.234251E+01_JPRB, 0.233952E+01_JPRB, 0.233596E+01_JPRB &
  &, 0.233187E+01_JPRB, 0.232725E+01_JPRB, 0.232210E+01_JPRB, 0.231642E+01_JPRB &
  &, 0.231022E+01_JPRB, 0.230351E+01_JPRB, 0.229630E+01_JPRB &
  &, 0.228861E+01_JPRB, 0.228043E+01_JPRB, 0.227179E+01_JPRB, 0.226265E+01_JPRB &
  &, 0.225306E+01_JPRB, 0.224304E+01_JPRB, 0.223255E+01_JPRB &
  &, 0.222162E+01_JPRB, 0.221028E+01_JPRB, 0.219853E+01_JPRB, 0.218635E+01_JPRB &
  &, 0.217380E+01_JPRB, 0.216085E+01_JPRB, 0.214751E+01_JPRB &
  &, 0.213383E+01_JPRB, 0.211969E+01_JPRB, 0.210534E+01_JPRB, 0.209059E+01_JPRB &
  &, 0.207549E+01_JPRB, 0.206008E+01_JPRB, 0.204437E+01_JPRB &
  &, 0.202836E+01_JPRB, 0.201203E+01_JPRB, 0.199545E+01_JPRB, 0.197860E+01_JPRB &
  &, 0.196147E+01_JPRB, 0.194409E+01_JPRB, 0.192652E+01_JPRB &
  &, 0.190866E+01_JPRB, 0.189058E+01_JPRB, 0.187231E+01_JPRB, 0.185388E+01_JPRB &
  &, 0.183521E+01_JPRB, 0.181634E+01_JPRB, 0.179734E+01_JPRB &
  &, 0.177818E+01_JPRB, 0.175886E+01_JPRB, 0.173938E+01_JPRB, 0.171983E+01_JPRB &
  &, 0.170008E+01_JPRB, 0.168026E+01_JPRB, 0.166035E+01_JPRB &
  &, 0.164031E+01_JPRB, 0.162023E+01_JPRB, 0.160003E+01_JPRB, 0.157977E+01_JPRB &
  &, 0.155950E+01_JPRB, 0.153912E+01_JPRB, 0.151878E+01_JPRB &
  &, 0.149838E+01_JPRB, 0.147794E+01_JPRB, 0.145749E+01_JPRB, 0.143700E+01_JPRB &
  &, 0.141654E+01_JPRB, 0.139616E+01_JPRB, 0.137574E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART124',1,ZHOOK_HANDLE)
END SUBROUTINE PART124

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART125

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART125',0,ZHOOK_HANDLE)

XCW( 869, :) = (/ &
  &  0.111278E+01_JPRB, 0.114112E+01_JPRB, 0.116948E+01_JPRB, 0.119785E+01_JPRB &
  &, 0.122621E+01_JPRB, 0.125454E+01_JPRB, 0.128283E+01_JPRB &
  &, 0.131106E+01_JPRB, 0.133921E+01_JPRB, 0.136727E+01_JPRB, 0.139522E+01_JPRB &
  &, 0.142304E+01_JPRB, 0.145073E+01_JPRB, 0.147825E+01_JPRB &
  &, 0.150560E+01_JPRB, 0.153275E+01_JPRB, 0.155970E+01_JPRB, 0.158643E+01_JPRB &
  &, 0.161291E+01_JPRB, 0.163914E+01_JPRB, 0.166510E+01_JPRB &
  &, 0.169077E+01_JPRB, 0.171614E+01_JPRB, 0.174119E+01_JPRB, 0.176591E+01_JPRB &
  &, 0.179028E+01_JPRB, 0.181429E+01_JPRB, 0.183792E+01_JPRB &
  &, 0.186117E+01_JPRB, 0.188401E+01_JPRB, 0.190644E+01_JPRB, 0.192843E+01_JPRB &
  &, 0.194998E+01_JPRB, 0.197108E+01_JPRB, 0.199172E+01_JPRB &
  &, 0.201188E+01_JPRB, 0.203155E+01_JPRB, 0.205073E+01_JPRB, 0.206940E+01_JPRB &
  &, 0.208755E+01_JPRB, 0.210518E+01_JPRB, 0.212227E+01_JPRB &
  &, 0.213882E+01_JPRB, 0.215483E+01_JPRB, 0.217028E+01_JPRB, 0.218516E+01_JPRB &
  &, 0.219948E+01_JPRB, 0.221322E+01_JPRB, 0.222639E+01_JPRB &
  &, 0.223897E+01_JPRB, 0.225097E+01_JPRB, 0.226238E+01_JPRB, 0.227317E+01_JPRB &
  &, 0.228339E+01_JPRB, 0.229300E+01_JPRB, 0.230201E+01_JPRB &
  &, 0.231041E+01_JPRB, 0.231822E+01_JPRB, 0.232542E+01_JPRB, 0.233201E+01_JPRB &
  &, 0.233801E+01_JPRB, 0.234340E+01_JPRB, 0.234816E+01_JPRB &
  &, 0.235238E+01_JPRB, 0.235595E+01_JPRB, 0.235894E+01_JPRB, 0.236134E+01_JPRB &
  &, 0.236314E+01_JPRB, 0.236437E+01_JPRB, 0.236499E+01_JPRB &
  &, 0.236504E+01_JPRB, 0.236452E+01_JPRB, 0.236345E+01_JPRB, 0.236178E+01_JPRB &
  &, 0.235954E+01_JPRB, 0.235677E+01_JPRB, 0.235344E+01_JPRB &
  &, 0.234956E+01_JPRB, 0.234516E+01_JPRB, 0.234021E+01_JPRB, 0.233473E+01_JPRB &
  &, 0.232877E+01_JPRB, 0.232225E+01_JPRB, 0.231524E+01_JPRB &
  &, 0.230774E+01_JPRB, 0.229976E+01_JPRB, 0.229131E+01_JPRB, 0.228235E+01_JPRB &
  &, 0.227294E+01_JPRB, 0.226307E+01_JPRB, 0.225277E+01_JPRB &
  &, 0.224202E+01_JPRB, 0.223084E+01_JPRB, 0.221924E+01_JPRB, 0.220722E+01_JPRB &
  &, 0.219483E+01_JPRB, 0.218201E+01_JPRB, 0.216882E+01_JPRB &
  &, 0.215526E+01_JPRB, 0.214134E+01_JPRB, 0.212703E+01_JPRB, 0.211241E+01_JPRB &
  &, 0.209745E+01_JPRB, 0.208217E+01_JPRB, 0.206655E+01_JPRB &
  &, 0.205062E+01_JPRB, 0.203440E+01_JPRB, 0.201794E+01_JPRB, 0.200115E+01_JPRB &
  &, 0.198413E+01_JPRB, 0.196684E+01_JPRB, 0.194927E+01_JPRB &
  &, 0.193150E+01_JPRB, 0.191350E+01_JPRB, 0.189531E+01_JPRB, 0.187689E+01_JPRB &
  &, 0.185824E+01_JPRB, 0.183948E+01_JPRB, 0.182048E+01_JPRB &
  &, 0.180132E+01_JPRB, 0.178203E+01_JPRB, 0.176258E+01_JPRB, 0.174300E+01_JPRB &
  &, 0.172333E+01_JPRB, 0.170347E+01_JPRB, 0.168356E+01_JPRB &
  &, 0.166352E+01_JPRB, 0.164344E+01_JPRB, 0.162321E+01_JPRB, 0.160294E+01_JPRB &
  &, 0.158258E+01_JPRB, 0.156223E+01_JPRB, 0.154178E+01_JPRB &
  &, 0.152132E+01_JPRB, 0.150082E+01_JPRB, 0.148037E+01_JPRB, 0.145987E+01_JPRB &
  &, 0.143933E+01_JPRB, 0.141880E+01_JPRB, 0.139834E+01_JPRB/)
XCW( 870, :) = (/ &
  &  0.111329E+01_JPRB, 0.114176E+01_JPRB, 0.117027E+01_JPRB, 0.119878E+01_JPRB &
  &, 0.122729E+01_JPRB, 0.125577E+01_JPRB, 0.128422E+01_JPRB &
  &, 0.131261E+01_JPRB, 0.134093E+01_JPRB, 0.136916E+01_JPRB, 0.139728E+01_JPRB &
  &, 0.142529E+01_JPRB, 0.145315E+01_JPRB, 0.148086E+01_JPRB &
  &, 0.150839E+01_JPRB, 0.153574E+01_JPRB, 0.156288E+01_JPRB, 0.158981E+01_JPRB &
  &, 0.161649E+01_JPRB, 0.164292E+01_JPRB, 0.166909E+01_JPRB &
  &, 0.169497E+01_JPRB, 0.172055E+01_JPRB, 0.174582E+01_JPRB, 0.177076E+01_JPRB &
  &, 0.179535E+01_JPRB, 0.181958E+01_JPRB, 0.184344E+01_JPRB &
  &, 0.186692E+01_JPRB, 0.188999E+01_JPRB, 0.191265E+01_JPRB, 0.193488E+01_JPRB &
  &, 0.195667E+01_JPRB, 0.197802E+01_JPRB, 0.199889E+01_JPRB &
  &, 0.201929E+01_JPRB, 0.203921E+01_JPRB, 0.205864E+01_JPRB, 0.207755E+01_JPRB &
  &, 0.209596E+01_JPRB, 0.211385E+01_JPRB, 0.213118E+01_JPRB &
  &, 0.214799E+01_JPRB, 0.216426E+01_JPRB, 0.217996E+01_JPRB, 0.219510E+01_JPRB &
  &, 0.220967E+01_JPRB, 0.222368E+01_JPRB, 0.223710E+01_JPRB &
  &, 0.224994E+01_JPRB, 0.226219E+01_JPRB, 0.227386E+01_JPRB, 0.228491E+01_JPRB &
  &, 0.229539E+01_JPRB, 0.230526E+01_JPRB, 0.231452E+01_JPRB &
  &, 0.232320E+01_JPRB, 0.233125E+01_JPRB, 0.233871E+01_JPRB, 0.234555E+01_JPRB &
  &, 0.235180E+01_JPRB, 0.235744E+01_JPRB, 0.236248E+01_JPRB &
  &, 0.236693E+01_JPRB, 0.237075E+01_JPRB, 0.237401E+01_JPRB, 0.237664E+01_JPRB &
  &, 0.237870E+01_JPRB, 0.238016E+01_JPRB, 0.238102E+01_JPRB &
  &, 0.238132E+01_JPRB, 0.238104E+01_JPRB, 0.238018E+01_JPRB, 0.237875E+01_JPRB &
  &, 0.237674E+01_JPRB, 0.237420E+01_JPRB, 0.237111E+01_JPRB &
  &, 0.236743E+01_JPRB, 0.236324E+01_JPRB, 0.235853E+01_JPRB, 0.235325E+01_JPRB &
  &, 0.234749E+01_JPRB, 0.234118E+01_JPRB, 0.233439E+01_JPRB &
  &, 0.232710E+01_JPRB, 0.231931E+01_JPRB, 0.231102E+01_JPRB, 0.230226E+01_JPRB &
  &, 0.229304E+01_JPRB, 0.228336E+01_JPRB, 0.227323E+01_JPRB &
  &, 0.226266E+01_JPRB, 0.225163E+01_JPRB, 0.224020E+01_JPRB, 0.222836E+01_JPRB &
  &, 0.221610E+01_JPRB, 0.220344E+01_JPRB, 0.219038E+01_JPRB &
  &, 0.217697E+01_JPRB, 0.216317E+01_JPRB, 0.214901E+01_JPRB, 0.213450E+01_JPRB &
  &, 0.211968E+01_JPRB, 0.210449E+01_JPRB, 0.208900E+01_JPRB &
  &, 0.207320E+01_JPRB, 0.205707E+01_JPRB, 0.204067E+01_JPRB, 0.202400E+01_JPRB &
  &, 0.200704E+01_JPRB, 0.198985E+01_JPRB, 0.197238E+01_JPRB &
  &, 0.195465E+01_JPRB, 0.193674E+01_JPRB, 0.191858E+01_JPRB, 0.190019E+01_JPRB &
  &, 0.188166E+01_JPRB, 0.186290E+01_JPRB, 0.184396E+01_JPRB &
  &, 0.182485E+01_JPRB, 0.180555E+01_JPRB, 0.178614E+01_JPRB, 0.176660E+01_JPRB &
  &, 0.174689E+01_JPRB, 0.172705E+01_JPRB, 0.170710E+01_JPRB &
  &, 0.168706E+01_JPRB, 0.166697E+01_JPRB, 0.164674E+01_JPRB, 0.162645E+01_JPRB &
  &, 0.160607E+01_JPRB, 0.158568E+01_JPRB, 0.156519E+01_JPRB &
  &, 0.154469E+01_JPRB, 0.152414E+01_JPRB, 0.150363E+01_JPRB, 0.148306E+01_JPRB &
  &, 0.146245E+01_JPRB, 0.144189E+01_JPRB, 0.142128E+01_JPRB/)
XCW( 871, :) = (/ &
  &  0.111380E+01_JPRB, 0.114241E+01_JPRB, 0.117106E+01_JPRB, 0.119972E+01_JPRB &
  &, 0.122838E+01_JPRB, 0.125702E+01_JPRB, 0.128562E+01_JPRB &
  &, 0.131418E+01_JPRB, 0.134266E+01_JPRB, 0.137106E+01_JPRB, 0.139936E+01_JPRB &
  &, 0.142754E+01_JPRB, 0.145558E+01_JPRB, 0.148348E+01_JPRB &
  &, 0.151120E+01_JPRB, 0.153874E+01_JPRB, 0.156608E+01_JPRB, 0.159320E+01_JPRB &
  &, 0.162009E+01_JPRB, 0.164673E+01_JPRB, 0.167310E+01_JPRB &
  &, 0.169920E+01_JPRB, 0.172499E+01_JPRB, 0.175048E+01_JPRB, 0.177564E+01_JPRB &
  &, 0.180046E+01_JPRB, 0.182492E+01_JPRB, 0.184900E+01_JPRB &
  &, 0.187271E+01_JPRB, 0.189602E+01_JPRB, 0.191891E+01_JPRB, 0.194138E+01_JPRB &
  &, 0.196342E+01_JPRB, 0.198500E+01_JPRB, 0.200612E+01_JPRB &
  &, 0.202677E+01_JPRB, 0.204694E+01_JPRB, 0.206661E+01_JPRB, 0.208578E+01_JPRB &
  &, 0.210443E+01_JPRB, 0.212257E+01_JPRB, 0.214017E+01_JPRB &
  &, 0.215724E+01_JPRB, 0.217376E+01_JPRB, 0.218972E+01_JPRB, 0.220512E+01_JPRB &
  &, 0.221995E+01_JPRB, 0.223421E+01_JPRB, 0.224790E+01_JPRB &
  &, 0.226099E+01_JPRB, 0.227351E+01_JPRB, 0.228544E+01_JPRB, 0.229676E+01_JPRB &
  &, 0.230750E+01_JPRB, 0.231762E+01_JPRB, 0.232715E+01_JPRB &
  &, 0.233607E+01_JPRB, 0.234440E+01_JPRB, 0.235212E+01_JPRB, 0.235923E+01_JPRB &
  &, 0.236574E+01_JPRB, 0.237163E+01_JPRB, 0.237693E+01_JPRB &
  &, 0.238161E+01_JPRB, 0.238570E+01_JPRB, 0.238919E+01_JPRB, 0.239208E+01_JPRB &
  &, 0.239439E+01_JPRB, 0.239609E+01_JPRB, 0.239721E+01_JPRB &
  &, 0.239775E+01_JPRB, 0.239770E+01_JPRB, 0.239708E+01_JPRB, 0.239589E+01_JPRB &
  &, 0.239412E+01_JPRB, 0.239179E+01_JPRB, 0.238892E+01_JPRB &
  &, 0.238550E+01_JPRB, 0.238152E+01_JPRB, 0.237702E+01_JPRB, 0.237198E+01_JPRB &
  &, 0.236640E+01_JPRB, 0.236032E+01_JPRB, 0.235374E+01_JPRB &
  &, 0.234664E+01_JPRB, 0.233906E+01_JPRB, 0.233097E+01_JPRB, 0.232240E+01_JPRB &
  &, 0.231337E+01_JPRB, 0.230388E+01_JPRB, 0.229392E+01_JPRB &
  &, 0.228353E+01_JPRB, 0.227268E+01_JPRB, 0.226140E+01_JPRB, 0.224973E+01_JPRB &
  &, 0.223761E+01_JPRB, 0.222512E+01_JPRB, 0.221222E+01_JPRB &
  &, 0.219894E+01_JPRB, 0.218530E+01_JPRB, 0.217125E+01_JPRB, 0.215689E+01_JPRB &
  &, 0.214217E+01_JPRB, 0.212712E+01_JPRB, 0.211173E+01_JPRB &
  &, 0.209602E+01_JPRB, 0.208001E+01_JPRB, 0.206374E+01_JPRB, 0.204714E+01_JPRB &
  &, 0.203029E+01_JPRB, 0.201316E+01_JPRB, 0.199575E+01_JPRB &
  &, 0.197812E+01_JPRB, 0.196025E+01_JPRB, 0.194217E+01_JPRB, 0.192387E+01_JPRB &
  &, 0.190536E+01_JPRB, 0.188662E+01_JPRB, 0.186774E+01_JPRB &
  &, 0.184868E+01_JPRB, 0.182943E+01_JPRB, 0.181001E+01_JPRB, 0.179050E+01_JPRB &
  &, 0.177077E+01_JPRB, 0.175095E+01_JPRB, 0.173102E+01_JPRB &
  &, 0.171099E+01_JPRB, 0.169085E+01_JPRB, 0.167061E+01_JPRB, 0.165031E+01_JPRB &
  &, 0.162997E+01_JPRB, 0.160949E+01_JPRB, 0.158897E+01_JPRB &
  &, 0.156843E+01_JPRB, 0.154789E+01_JPRB, 0.152726E+01_JPRB, 0.150662E+01_JPRB &
  &, 0.148594E+01_JPRB, 0.146530E+01_JPRB, 0.144467E+01_JPRB/)
XCW( 872, :) = (/ &
  &  0.111431E+01_JPRB, 0.114306E+01_JPRB, 0.117185E+01_JPRB, 0.120066E+01_JPRB &
  &, 0.122947E+01_JPRB, 0.125827E+01_JPRB, 0.128703E+01_JPRB &
  &, 0.131575E+01_JPRB, 0.134440E+01_JPRB, 0.137297E+01_JPRB, 0.140145E+01_JPRB &
  &, 0.142981E+01_JPRB, 0.145803E+01_JPRB, 0.148611E+01_JPRB &
  &, 0.151403E+01_JPRB, 0.154177E+01_JPRB, 0.156928E+01_JPRB, 0.159662E+01_JPRB &
  &, 0.162372E+01_JPRB, 0.165056E+01_JPRB, 0.167715E+01_JPRB &
  &, 0.170346E+01_JPRB, 0.172947E+01_JPRB, 0.175518E+01_JPRB, 0.178056E+01_JPRB &
  &, 0.180560E+01_JPRB, 0.183029E+01_JPRB, 0.185461E+01_JPRB &
  &, 0.187854E+01_JPRB, 0.190209E+01_JPRB, 0.192522E+01_JPRB, 0.194793E+01_JPRB &
  &, 0.197021E+01_JPRB, 0.199204E+01_JPRB, 0.201340E+01_JPRB &
  &, 0.203431E+01_JPRB, 0.205472E+01_JPRB, 0.207465E+01_JPRB, 0.209406E+01_JPRB &
  &, 0.211298E+01_JPRB, 0.213137E+01_JPRB, 0.214922E+01_JPRB &
  &, 0.216655E+01_JPRB, 0.218333E+01_JPRB, 0.219955E+01_JPRB, 0.221522E+01_JPRB &
  &, 0.223031E+01_JPRB, 0.224484E+01_JPRB, 0.225878E+01_JPRB &
  &, 0.227215E+01_JPRB, 0.228492E+01_JPRB, 0.229711E+01_JPRB, 0.230871E+01_JPRB &
  &, 0.231971E+01_JPRB, 0.233010E+01_JPRB, 0.233990E+01_JPRB &
  &, 0.234908E+01_JPRB, 0.235767E+01_JPRB, 0.236564E+01_JPRB, 0.237302E+01_JPRB &
  &, 0.237977E+01_JPRB, 0.238593E+01_JPRB, 0.239148E+01_JPRB &
  &, 0.239644E+01_JPRB, 0.240078E+01_JPRB, 0.240453E+01_JPRB, 0.240767E+01_JPRB &
  &, 0.241022E+01_JPRB, 0.241219E+01_JPRB, 0.241354E+01_JPRB &
  &, 0.241432E+01_JPRB, 0.241452E+01_JPRB, 0.241414E+01_JPRB, 0.241319E+01_JPRB &
  &, 0.241166E+01_JPRB, 0.240958E+01_JPRB, 0.240694E+01_JPRB &
  &, 0.240374E+01_JPRB, 0.239998E+01_JPRB, 0.239572E+01_JPRB, 0.239089E+01_JPRB &
  &, 0.238555E+01_JPRB, 0.237968E+01_JPRB, 0.237328E+01_JPRB &
  &, 0.236639E+01_JPRB, 0.235900E+01_JPRB, 0.235112E+01_JPRB, 0.234275E+01_JPRB &
  &, 0.233392E+01_JPRB, 0.232459E+01_JPRB, 0.231482E+01_JPRB &
  &, 0.230462E+01_JPRB, 0.229396E+01_JPRB, 0.228285E+01_JPRB, 0.227133E+01_JPRB &
  &, 0.225939E+01_JPRB, 0.224704E+01_JPRB, 0.223431E+01_JPRB &
  &, 0.222115E+01_JPRB, 0.220764E+01_JPRB, 0.219378E+01_JPRB, 0.217954E+01_JPRB &
  &, 0.216493E+01_JPRB, 0.215003E+01_JPRB, 0.213474E+01_JPRB &
  &, 0.211916E+01_JPRB, 0.210328E+01_JPRB, 0.208705E+01_JPRB, 0.207058E+01_JPRB &
  &, 0.205380E+01_JPRB, 0.203679E+01_JPRB, 0.201948E+01_JPRB &
  &, 0.200190E+01_JPRB, 0.198413E+01_JPRB, 0.196609E+01_JPRB, 0.194782E+01_JPRB &
  &, 0.192939E+01_JPRB, 0.191073E+01_JPRB, 0.189186E+01_JPRB &
  &, 0.187281E+01_JPRB, 0.185362E+01_JPRB, 0.183424E+01_JPRB, 0.181472E+01_JPRB &
  &, 0.179508E+01_JPRB, 0.177523E+01_JPRB, 0.175532E+01_JPRB &
  &, 0.173531E+01_JPRB, 0.171511E+01_JPRB, 0.169488E+01_JPRB, 0.167457E+01_JPRB &
  &, 0.165415E+01_JPRB, 0.163372E+01_JPRB, 0.161317E+01_JPRB &
  &, 0.159259E+01_JPRB, 0.157195E+01_JPRB, 0.155126E+01_JPRB, 0.153057E+01_JPRB &
  &, 0.150988E+01_JPRB, 0.148917E+01_JPRB, 0.146846E+01_JPRB/)
XCW( 873, :) = (/ &
  &  0.111483E+01_JPRB, 0.114372E+01_JPRB, 0.117265E+01_JPRB, 0.120161E+01_JPRB &
  &, 0.123057E+01_JPRB, 0.125952E+01_JPRB, 0.128845E+01_JPRB &
  &, 0.131733E+01_JPRB, 0.134616E+01_JPRB, 0.137490E+01_JPRB, 0.140355E+01_JPRB &
  &, 0.143209E+01_JPRB, 0.146050E+01_JPRB, 0.148877E+01_JPRB &
  &, 0.151688E+01_JPRB, 0.154481E+01_JPRB, 0.157254E+01_JPRB, 0.160007E+01_JPRB &
  &, 0.162737E+01_JPRB, 0.165442E+01_JPRB, 0.168122E+01_JPRB &
  &, 0.170774E+01_JPRB, 0.173398E+01_JPRB, 0.175990E+01_JPRB, 0.178551E+01_JPRB &
  &, 0.181078E+01_JPRB, 0.183570E+01_JPRB, 0.186025E+01_JPRB &
  &, 0.188442E+01_JPRB, 0.190820E+01_JPRB, 0.193158E+01_JPRB, 0.195453E+01_JPRB &
  &, 0.197705E+01_JPRB, 0.199913E+01_JPRB, 0.202074E+01_JPRB &
  &, 0.204190E+01_JPRB, 0.206257E+01_JPRB, 0.208274E+01_JPRB, 0.210243E+01_JPRB &
  &, 0.212159E+01_JPRB, 0.214024E+01_JPRB, 0.215836E+01_JPRB &
  &, 0.217595E+01_JPRB, 0.219299E+01_JPRB, 0.220947E+01_JPRB, 0.222539E+01_JPRB &
  &, 0.224076E+01_JPRB, 0.225555E+01_JPRB, 0.226977E+01_JPRB &
  &, 0.228340E+01_JPRB, 0.229644E+01_JPRB, 0.230889E+01_JPRB, 0.232075E+01_JPRB &
  &, 0.233202E+01_JPRB, 0.234268E+01_JPRB, 0.235274E+01_JPRB &
  &, 0.236220E+01_JPRB, 0.237105E+01_JPRB, 0.237928E+01_JPRB, 0.238693E+01_JPRB &
  &, 0.239395E+01_JPRB, 0.240037E+01_JPRB, 0.240620E+01_JPRB &
  &, 0.241141E+01_JPRB, 0.241601E+01_JPRB, 0.242002E+01_JPRB, 0.242338E+01_JPRB &
  &, 0.242622E+01_JPRB, 0.242842E+01_JPRB, 0.243004E+01_JPRB &
  &, 0.243107E+01_JPRB, 0.243153E+01_JPRB, 0.243139E+01_JPRB, 0.243067E+01_JPRB &
  &, 0.242939E+01_JPRB, 0.242755E+01_JPRB, 0.242513E+01_JPRB &
  &, 0.242218E+01_JPRB, 0.241866E+01_JPRB, 0.241459E+01_JPRB, 0.240995E+01_JPRB &
  &, 0.240488E+01_JPRB, 0.239922E+01_JPRB, 0.239303E+01_JPRB &
  &, 0.238635E+01_JPRB, 0.237918E+01_JPRB, 0.237150E+01_JPRB, 0.236333E+01_JPRB &
  &, 0.235467E+01_JPRB, 0.234558E+01_JPRB, 0.233587E+01_JPRB &
  &, 0.232596E+01_JPRB, 0.231546E+01_JPRB, 0.230454E+01_JPRB, 0.229317E+01_JPRB &
  &, 0.228140E+01_JPRB, 0.226923E+01_JPRB, 0.225664E+01_JPRB &
  &, 0.224366E+01_JPRB, 0.223030E+01_JPRB, 0.221657E+01_JPRB, 0.220245E+01_JPRB &
  &, 0.218800E+01_JPRB, 0.217321E+01_JPRB, 0.215806E+01_JPRB &
  &, 0.214258E+01_JPRB, 0.212680E+01_JPRB, 0.211070E+01_JPRB, 0.209435E+01_JPRB &
  &, 0.207765E+01_JPRB, 0.206071E+01_JPRB, 0.204351E+01_JPRB &
  &, 0.202604E+01_JPRB, 0.200828E+01_JPRB, 0.199034E+01_JPRB, 0.197215E+01_JPRB &
  &, 0.195375E+01_JPRB, 0.193517E+01_JPRB, 0.191632E+01_JPRB &
  &, 0.189734E+01_JPRB, 0.187815E+01_JPRB, 0.185883E+01_JPRB, 0.183936E+01_JPRB &
  &, 0.181970E+01_JPRB, 0.179989E+01_JPRB, 0.178000E+01_JPRB &
  &, 0.175995E+01_JPRB, 0.173977E+01_JPRB, 0.171954E+01_JPRB, 0.169917E+01_JPRB &
  &, 0.167875E+01_JPRB, 0.165830E+01_JPRB, 0.163772E+01_JPRB &
  &, 0.161705E+01_JPRB, 0.159643E+01_JPRB, 0.157570E+01_JPRB, 0.155496E+01_JPRB &
  &, 0.153421E+01_JPRB, 0.151343E+01_JPRB, 0.149264E+01_JPRB/)
XCW( 874, :) = (/ &
  &  0.111534E+01_JPRB, 0.114438E+01_JPRB, 0.117346E+01_JPRB, 0.120256E+01_JPRB &
  &, 0.123168E+01_JPRB, 0.126079E+01_JPRB, 0.128988E+01_JPRB &
  &, 0.131893E+01_JPRB, 0.134792E+01_JPRB, 0.137684E+01_JPRB, 0.140567E+01_JPRB &
  &, 0.143439E+01_JPRB, 0.146299E+01_JPRB, 0.149144E+01_JPRB &
  &, 0.151975E+01_JPRB, 0.154787E+01_JPRB, 0.157581E+01_JPRB, 0.160354E+01_JPRB &
  &, 0.163105E+01_JPRB, 0.165831E+01_JPRB, 0.168532E+01_JPRB &
  &, 0.171206E+01_JPRB, 0.173852E+01_JPRB, 0.176467E+01_JPRB, 0.179050E+01_JPRB &
  &, 0.181600E+01_JPRB, 0.184115E+01_JPRB, 0.186594E+01_JPRB &
  &, 0.189034E+01_JPRB, 0.191437E+01_JPRB, 0.193798E+01_JPRB, 0.196118E+01_JPRB &
  &, 0.198395E+01_JPRB, 0.200627E+01_JPRB, 0.202814E+01_JPRB &
  &, 0.204954E+01_JPRB, 0.207046E+01_JPRB, 0.209091E+01_JPRB, 0.211085E+01_JPRB &
  &, 0.213027E+01_JPRB, 0.214918E+01_JPRB, 0.216757E+01_JPRB &
  &, 0.218541E+01_JPRB, 0.220272E+01_JPRB, 0.221947E+01_JPRB, 0.223567E+01_JPRB &
  &, 0.225130E+01_JPRB, 0.226636E+01_JPRB, 0.228084E+01_JPRB &
  &, 0.229474E+01_JPRB, 0.230806E+01_JPRB, 0.232078E+01_JPRB, 0.233289E+01_JPRB &
  &, 0.234445E+01_JPRB, 0.235537E+01_JPRB, 0.236570E+01_JPRB &
  &, 0.237544E+01_JPRB, 0.238455E+01_JPRB, 0.239304E+01_JPRB, 0.240097E+01_JPRB &
  &, 0.240826E+01_JPRB, 0.241496E+01_JPRB, 0.242104E+01_JPRB &
  &, 0.242650E+01_JPRB, 0.243137E+01_JPRB, 0.243564E+01_JPRB, 0.243931E+01_JPRB &
  &, 0.244237E+01_JPRB, 0.244484E+01_JPRB, 0.244671E+01_JPRB &
  &, 0.244798E+01_JPRB, 0.244869E+01_JPRB, 0.244880E+01_JPRB, 0.244833E+01_JPRB &
  &, 0.244730E+01_JPRB, 0.244568E+01_JPRB, 0.244351E+01_JPRB &
  &, 0.244079E+01_JPRB, 0.243752E+01_JPRB, 0.243367E+01_JPRB, 0.242930E+01_JPRB &
  &, 0.242439E+01_JPRB, 0.241893E+01_JPRB, 0.241301E+01_JPRB &
  &, 0.240654E+01_JPRB, 0.239958E+01_JPRB, 0.239211E+01_JPRB, 0.238412E+01_JPRB &
  &, 0.237570E+01_JPRB, 0.236677E+01_JPRB, 0.235736E+01_JPRB &
  &, 0.234752E+01_JPRB, 0.233721E+01_JPRB, 0.232649E+01_JPRB, 0.231531E+01_JPRB &
  &, 0.230369E+01_JPRB, 0.229167E+01_JPRB, 0.227925E+01_JPRB &
  &, 0.226644E+01_JPRB, 0.225323E+01_JPRB, 0.223963E+01_JPRB, 0.222567E+01_JPRB &
  &, 0.221134E+01_JPRB, 0.219666E+01_JPRB, 0.218166E+01_JPRB &
  &, 0.216633E+01_JPRB, 0.215065E+01_JPRB, 0.213468E+01_JPRB, 0.211838E+01_JPRB &
  &, 0.210180E+01_JPRB, 0.208498E+01_JPRB, 0.206786E+01_JPRB &
  &, 0.205045E+01_JPRB, 0.203279E+01_JPRB, 0.201495E+01_JPRB, 0.199681E+01_JPRB &
  &, 0.197845E+01_JPRB, 0.195990E+01_JPRB, 0.194118E+01_JPRB &
  &, 0.192222E+01_JPRB, 0.190309E+01_JPRB, 0.188378E+01_JPRB, 0.186430E+01_JPRB &
  &, 0.184469E+01_JPRB, 0.182492E+01_JPRB, 0.180501E+01_JPRB &
  &, 0.178498E+01_JPRB, 0.176482E+01_JPRB, 0.174454E+01_JPRB, 0.172418E+01_JPRB &
  &, 0.170375E+01_JPRB, 0.168323E+01_JPRB, 0.166264E+01_JPRB &
  &, 0.164200E+01_JPRB, 0.162129E+01_JPRB, 0.160052E+01_JPRB, 0.157972E+01_JPRB &
  &, 0.155892E+01_JPRB, 0.153808E+01_JPRB, 0.151721E+01_JPRB/)
XCW( 875, :) = (/ &
  &  0.111587E+01_JPRB, 0.114504E+01_JPRB, 0.117426E+01_JPRB, 0.120352E+01_JPRB &
  &, 0.123279E+01_JPRB, 0.126206E+01_JPRB, 0.129131E+01_JPRB &
  &, 0.132053E+01_JPRB, 0.134969E+01_JPRB, 0.137879E+01_JPRB, 0.140780E+01_JPRB &
  &, 0.143670E+01_JPRB, 0.146549E+01_JPRB, 0.149414E+01_JPRB &
  &, 0.152263E+01_JPRB, 0.155096E+01_JPRB, 0.157910E+01_JPRB, 0.160703E+01_JPRB &
  &, 0.163475E+01_JPRB, 0.166223E+01_JPRB, 0.168945E+01_JPRB &
  &, 0.171641E+01_JPRB, 0.174309E+01_JPRB, 0.176946E+01_JPRB, 0.179552E+01_JPRB &
  &, 0.182125E+01_JPRB, 0.184664E+01_JPRB, 0.187166E+01_JPRB &
  &, 0.189631E+01_JPRB, 0.192057E+01_JPRB, 0.194444E+01_JPRB, 0.196788E+01_JPRB &
  &, 0.199090E+01_JPRB, 0.201348E+01_JPRB, 0.203560E+01_JPRB &
  &, 0.205725E+01_JPRB, 0.207844E+01_JPRB, 0.209913E+01_JPRB, 0.211933E+01_JPRB &
  &, 0.213902E+01_JPRB, 0.215820E+01_JPRB, 0.217685E+01_JPRB &
  &, 0.219496E+01_JPRB, 0.221253E+01_JPRB, 0.222956E+01_JPRB, 0.224602E+01_JPRB &
  &, 0.226192E+01_JPRB, 0.227725E+01_JPRB, 0.229201E+01_JPRB &
  &, 0.230618E+01_JPRB, 0.231977E+01_JPRB, 0.233277E+01_JPRB, 0.234517E+01_JPRB &
  &, 0.235698E+01_JPRB, 0.236818E+01_JPRB, 0.237878E+01_JPRB &
  &, 0.238879E+01_JPRB, 0.239819E+01_JPRB, 0.240696E+01_JPRB, 0.241514E+01_JPRB &
  &, 0.242270E+01_JPRB, 0.242966E+01_JPRB, 0.243602E+01_JPRB &
  &, 0.244175E+01_JPRB, 0.244690E+01_JPRB, 0.245141E+01_JPRB, 0.245535E+01_JPRB &
  &, 0.245867E+01_JPRB, 0.246140E+01_JPRB, 0.246354E+01_JPRB &
  &, 0.246506E+01_JPRB, 0.246602E+01_JPRB, 0.246639E+01_JPRB, 0.246617E+01_JPRB &
  &, 0.246539E+01_JPRB, 0.246402E+01_JPRB, 0.246209E+01_JPRB &
  &, 0.245959E+01_JPRB, 0.245654E+01_JPRB, 0.245297E+01_JPRB, 0.244883E+01_JPRB &
  &, 0.244415E+01_JPRB, 0.243893E+01_JPRB, 0.243320E+01_JPRB &
  &, 0.242696E+01_JPRB, 0.242015E+01_JPRB, 0.241292E+01_JPRB, 0.240518E+01_JPRB &
  &, 0.239693E+01_JPRB, 0.238821E+01_JPRB, 0.237901E+01_JPRB &
  &, 0.236934E+01_JPRB, 0.235923E+01_JPRB, 0.234867E+01_JPRB, 0.233768E+01_JPRB &
  &, 0.232625E+01_JPRB, 0.231441E+01_JPRB, 0.230215E+01_JPRB &
  &, 0.228948E+01_JPRB, 0.227641E+01_JPRB, 0.226298E+01_JPRB, 0.224911E+01_JPRB &
  &, 0.223498E+01_JPRB, 0.222046E+01_JPRB, 0.220557E+01_JPRB &
  &, 0.219035E+01_JPRB, 0.217482E+01_JPRB, 0.215895E+01_JPRB, 0.214278E+01_JPRB &
  &, 0.212630E+01_JPRB, 0.210956E+01_JPRB, 0.209251E+01_JPRB &
  &, 0.207522E+01_JPRB, 0.205767E+01_JPRB, 0.203984E+01_JPRB, 0.202180E+01_JPRB &
  &, 0.200354E+01_JPRB, 0.198502E+01_JPRB, 0.196633E+01_JPRB &
  &, 0.194745E+01_JPRB, 0.192834E+01_JPRB, 0.190909E+01_JPRB, 0.188962E+01_JPRB &
  &, 0.187005E+01_JPRB, 0.185027E+01_JPRB, 0.183039E+01_JPRB &
  &, 0.181034E+01_JPRB, 0.179020E+01_JPRB, 0.176994E+01_JPRB, 0.174959E+01_JPRB &
  &, 0.172916E+01_JPRB, 0.170857E+01_JPRB, 0.168797E+01_JPRB &
  &, 0.166732E+01_JPRB, 0.164657E+01_JPRB, 0.162577E+01_JPRB, 0.160493E+01_JPRB &
  &, 0.158408E+01_JPRB, 0.156318E+01_JPRB, 0.154225E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART125',1,ZHOOK_HANDLE)
END SUBROUTINE PART125

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART126

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART126',0,ZHOOK_HANDLE)

XCW( 876, :) = (/ &
  &  0.111639E+01_JPRB, 0.114571E+01_JPRB, 0.117508E+01_JPRB, 0.120448E+01_JPRB &
  &, 0.123391E+01_JPRB, 0.126334E+01_JPRB, 0.129276E+01_JPRB &
  &, 0.132214E+01_JPRB, 0.135148E+01_JPRB, 0.138075E+01_JPRB, 0.140994E+01_JPRB &
  &, 0.143903E+01_JPRB, 0.146800E+01_JPRB, 0.149685E+01_JPRB &
  &, 0.152554E+01_JPRB, 0.155406E+01_JPRB, 0.158240E+01_JPRB, 0.161055E+01_JPRB &
  &, 0.163847E+01_JPRB, 0.166617E+01_JPRB, 0.169361E+01_JPRB &
  &, 0.172079E+01_JPRB, 0.174769E+01_JPRB, 0.177429E+01_JPRB, 0.180059E+01_JPRB &
  &, 0.182655E+01_JPRB, 0.185217E+01_JPRB, 0.187742E+01_JPRB &
  &, 0.190232E+01_JPRB, 0.192683E+01_JPRB, 0.195094E+01_JPRB, 0.197463E+01_JPRB &
  &, 0.199790E+01_JPRB, 0.202073E+01_JPRB, 0.204311E+01_JPRB &
  &, 0.206503E+01_JPRB, 0.208647E+01_JPRB, 0.210742E+01_JPRB, 0.212789E+01_JPRB &
  &, 0.214785E+01_JPRB, 0.216728E+01_JPRB, 0.218620E+01_JPRB &
  &, 0.220458E+01_JPRB, 0.222243E+01_JPRB, 0.223972E+01_JPRB, 0.225647E+01_JPRB &
  &, 0.227264E+01_JPRB, 0.228824E+01_JPRB, 0.230327E+01_JPRB &
  &, 0.231772E+01_JPRB, 0.233159E+01_JPRB, 0.234487E+01_JPRB, 0.235755E+01_JPRB &
  &, 0.236962E+01_JPRB, 0.238111E+01_JPRB, 0.239199E+01_JPRB &
  &, 0.240226E+01_JPRB, 0.241193E+01_JPRB, 0.242100E+01_JPRB, 0.242945E+01_JPRB &
  &, 0.243729E+01_JPRB, 0.244452E+01_JPRB, 0.245114E+01_JPRB &
  &, 0.245715E+01_JPRB, 0.246255E+01_JPRB, 0.246735E+01_JPRB, 0.247154E+01_JPRB &
  &, 0.247514E+01_JPRB, 0.247814E+01_JPRB, 0.248053E+01_JPRB &
  &, 0.248231E+01_JPRB, 0.248353E+01_JPRB, 0.248415E+01_JPRB, 0.248418E+01_JPRB &
  &, 0.248366E+01_JPRB, 0.248253E+01_JPRB, 0.248085E+01_JPRB &
  &, 0.247861E+01_JPRB, 0.247582E+01_JPRB, 0.247245E+01_JPRB, 0.246854E+01_JPRB &
  &, 0.246411E+01_JPRB, 0.245912E+01_JPRB, 0.245362E+01_JPRB &
  &, 0.244759E+01_JPRB, 0.244104E+01_JPRB, 0.243400E+01_JPRB, 0.242644E+01_JPRB &
  &, 0.241841E+01_JPRB, 0.240990E+01_JPRB, 0.240091E+01_JPRB &
  &, 0.239144E+01_JPRB, 0.238150E+01_JPRB, 0.237114E+01_JPRB, 0.236032E+01_JPRB &
  &, 0.234909E+01_JPRB, 0.233740E+01_JPRB, 0.232529E+01_JPRB &
  &, 0.231281E+01_JPRB, 0.229991E+01_JPRB, 0.228662E+01_JPRB, 0.227296E+01_JPRB &
  &, 0.225892E+01_JPRB, 0.224453E+01_JPRB, 0.222977E+01_JPRB &
  &, 0.221470E+01_JPRB, 0.219927E+01_JPRB, 0.218351E+01_JPRB, 0.216744E+01_JPRB &
  &, 0.215109E+01_JPRB, 0.213444E+01_JPRB, 0.211752E+01_JPRB &
  &, 0.210030E+01_JPRB, 0.208282E+01_JPRB, 0.206510E+01_JPRB, 0.204717E+01_JPRB &
  &, 0.202895E+01_JPRB, 0.201053E+01_JPRB, 0.199188E+01_JPRB &
  &, 0.197302E+01_JPRB, 0.195399E+01_JPRB, 0.193476E+01_JPRB, 0.191535E+01_JPRB &
  &, 0.189578E+01_JPRB, 0.187605E+01_JPRB, 0.185616E+01_JPRB &
  &, 0.183615E+01_JPRB, 0.181604E+01_JPRB, 0.179580E+01_JPRB, 0.177540E+01_JPRB &
  &, 0.175492E+01_JPRB, 0.173439E+01_JPRB, 0.171372E+01_JPRB &
  &, 0.169293E+01_JPRB, 0.167223E+01_JPRB, 0.165140E+01_JPRB, 0.163052E+01_JPRB &
  &, 0.160962E+01_JPRB, 0.158867E+01_JPRB, 0.156768E+01_JPRB/)
XCW( 877, :) = (/ &
  &  0.111692E+01_JPRB, 0.114638E+01_JPRB, 0.117590E+01_JPRB, 0.120546E+01_JPRB &
  &, 0.123504E+01_JPRB, 0.126463E+01_JPRB, 0.129421E+01_JPRB &
  &, 0.132377E+01_JPRB, 0.135328E+01_JPRB, 0.138273E+01_JPRB, 0.141210E+01_JPRB &
  &, 0.144137E+01_JPRB, 0.147054E+01_JPRB, 0.149957E+01_JPRB &
  &, 0.152846E+01_JPRB, 0.155719E+01_JPRB, 0.158574E+01_JPRB, 0.161409E+01_JPRB &
  &, 0.164223E+01_JPRB, 0.167014E+01_JPRB, 0.169780E+01_JPRB &
  &, 0.172521E+01_JPRB, 0.175233E+01_JPRB, 0.177916E+01_JPRB, 0.180569E+01_JPRB &
  &, 0.183188E+01_JPRB, 0.185774E+01_JPRB, 0.188325E+01_JPRB &
  &, 0.190838E+01_JPRB, 0.193314E+01_JPRB, 0.195749E+01_JPRB, 0.198144E+01_JPRB &
  &, 0.200496E+01_JPRB, 0.202805E+01_JPRB, 0.205068E+01_JPRB &
  &, 0.207286E+01_JPRB, 0.209456E+01_JPRB, 0.211579E+01_JPRB, 0.213651E+01_JPRB &
  &, 0.215674E+01_JPRB, 0.217645E+01_JPRB, 0.219564E+01_JPRB &
  &, 0.221430E+01_JPRB, 0.223241E+01_JPRB, 0.224999E+01_JPRB, 0.226699E+01_JPRB &
  &, 0.228345E+01_JPRB, 0.229934E+01_JPRB, 0.231464E+01_JPRB &
  &, 0.232936E+01_JPRB, 0.234351E+01_JPRB, 0.235707E+01_JPRB, 0.237002E+01_JPRB &
  &, 0.238237E+01_JPRB, 0.239416E+01_JPRB, 0.240531E+01_JPRB &
  &, 0.241587E+01_JPRB, 0.242581E+01_JPRB, 0.243516E+01_JPRB, 0.244389E+01_JPRB &
  &, 0.245200E+01_JPRB, 0.245950E+01_JPRB, 0.246641E+01_JPRB &
  &, 0.247269E+01_JPRB, 0.247837E+01_JPRB, 0.248345E+01_JPRB, 0.248791E+01_JPRB &
  &, 0.249177E+01_JPRB, 0.249502E+01_JPRB, 0.249769E+01_JPRB &
  &, 0.249975E+01_JPRB, 0.250119E+01_JPRB, 0.250211E+01_JPRB, 0.250240E+01_JPRB &
  &, 0.250212E+01_JPRB, 0.250125E+01_JPRB, 0.249983E+01_JPRB &
  &, 0.249782E+01_JPRB, 0.249527E+01_JPRB, 0.249216E+01_JPRB, 0.248848E+01_JPRB &
  &, 0.248428E+01_JPRB, 0.247952E+01_JPRB, 0.247425E+01_JPRB &
  &, 0.246845E+01_JPRB, 0.246212E+01_JPRB, 0.245530E+01_JPRB, 0.244796E+01_JPRB &
  &, 0.244015E+01_JPRB, 0.243183E+01_JPRB, 0.242305E+01_JPRB &
  &, 0.241377E+01_JPRB, 0.240404E+01_JPRB, 0.239385E+01_JPRB, 0.238322E+01_JPRB &
  &, 0.237216E+01_JPRB, 0.236067E+01_JPRB, 0.234875E+01_JPRB &
  &, 0.233642E+01_JPRB, 0.232367E+01_JPRB, 0.231056E+01_JPRB, 0.229704E+01_JPRB &
  &, 0.228314E+01_JPRB, 0.226891E+01_JPRB, 0.225428E+01_JPRB &
  &, 0.223933E+01_JPRB, 0.222406E+01_JPRB, 0.220845E+01_JPRB, 0.219248E+01_JPRB &
  &, 0.217623E+01_JPRB, 0.215971E+01_JPRB, 0.214288E+01_JPRB &
  &, 0.212574E+01_JPRB, 0.210838E+01_JPRB, 0.209073E+01_JPRB, 0.207286E+01_JPRB &
  &, 0.205470E+01_JPRB, 0.203633E+01_JPRB, 0.201777E+01_JPRB &
  &, 0.199900E+01_JPRB, 0.197999E+01_JPRB, 0.196078E+01_JPRB, 0.194144E+01_JPRB &
  &, 0.192189E+01_JPRB, 0.190220E+01_JPRB, 0.188236E+01_JPRB &
  &, 0.186234E+01_JPRB, 0.184226E+01_JPRB, 0.182199E+01_JPRB, 0.180161E+01_JPRB &
  &, 0.178115E+01_JPRB, 0.176057E+01_JPRB, 0.173990E+01_JPRB &
  &, 0.171916E+01_JPRB, 0.169838E+01_JPRB, 0.167752E+01_JPRB, 0.165655E+01_JPRB &
  &, 0.163562E+01_JPRB, 0.161461E+01_JPRB, 0.159357E+01_JPRB/)
XCW( 878, :) = (/ &
  &  0.111745E+01_JPRB, 0.114705E+01_JPRB, 0.117672E+01_JPRB, 0.120643E+01_JPRB &
  &, 0.123618E+01_JPRB, 0.126593E+01_JPRB, 0.129568E+01_JPRB &
  &, 0.132540E+01_JPRB, 0.135509E+01_JPRB, 0.138472E+01_JPRB, 0.141427E+01_JPRB &
  &, 0.144373E+01_JPRB, 0.147309E+01_JPRB, 0.150232E+01_JPRB &
  &, 0.153141E+01_JPRB, 0.156034E+01_JPRB, 0.158909E+01_JPRB, 0.161766E+01_JPRB &
  &, 0.164601E+01_JPRB, 0.167414E+01_JPRB, 0.170202E+01_JPRB &
  &, 0.172965E+01_JPRB, 0.175700E+01_JPRB, 0.178407E+01_JPRB, 0.181082E+01_JPRB &
  &, 0.183726E+01_JPRB, 0.186336E+01_JPRB, 0.188911E+01_JPRB &
  &, 0.191449E+01_JPRB, 0.193949E+01_JPRB, 0.196410E+01_JPRB, 0.198830E+01_JPRB &
  &, 0.201208E+01_JPRB, 0.203542E+01_JPRB, 0.205832E+01_JPRB &
  &, 0.208076E+01_JPRB, 0.210273E+01_JPRB, 0.212422E+01_JPRB, 0.214521E+01_JPRB &
  &, 0.216571E+01_JPRB, 0.218569E+01_JPRB, 0.220515E+01_JPRB &
  &, 0.222409E+01_JPRB, 0.224248E+01_JPRB, 0.226033E+01_JPRB, 0.227762E+01_JPRB &
  &, 0.229435E+01_JPRB, 0.231052E+01_JPRB, 0.232611E+01_JPRB &
  &, 0.234111E+01_JPRB, 0.235554E+01_JPRB, 0.236938E+01_JPRB, 0.238261E+01_JPRB &
  &, 0.239527E+01_JPRB, 0.240731E+01_JPRB, 0.241876E+01_JPRB &
  &, 0.242960E+01_JPRB, 0.243983E+01_JPRB, 0.244945E+01_JPRB, 0.245846E+01_JPRB &
  &, 0.246686E+01_JPRB, 0.247464E+01_JPRB, 0.248181E+01_JPRB &
  &, 0.248838E+01_JPRB, 0.249434E+01_JPRB, 0.249969E+01_JPRB, 0.250443E+01_JPRB &
  &, 0.250855E+01_JPRB, 0.251208E+01_JPRB, 0.251502E+01_JPRB &
  &, 0.251734E+01_JPRB, 0.251908E+01_JPRB, 0.252022E+01_JPRB, 0.252078E+01_JPRB &
  &, 0.252076E+01_JPRB, 0.252015E+01_JPRB, 0.251897E+01_JPRB &
  &, 0.251723E+01_JPRB, 0.251491E+01_JPRB, 0.251207E+01_JPRB, 0.250863E+01_JPRB &
  &, 0.250466E+01_JPRB, 0.250016E+01_JPRB, 0.249507E+01_JPRB &
  &, 0.248953E+01_JPRB, 0.248346E+01_JPRB, 0.247684E+01_JPRB, 0.246973E+01_JPRB &
  &, 0.246211E+01_JPRB, 0.245401E+01_JPRB, 0.244544E+01_JPRB &
  &, 0.243638E+01_JPRB, 0.242686E+01_JPRB, 0.241685E+01_JPRB, 0.240643E+01_JPRB &
  &, 0.239553E+01_JPRB, 0.238421E+01_JPRB, 0.237249E+01_JPRB &
  &, 0.236032E+01_JPRB, 0.234776E+01_JPRB, 0.233480E+01_JPRB, 0.232142E+01_JPRB &
  &, 0.230770E+01_JPRB, 0.229361E+01_JPRB, 0.227914E+01_JPRB &
  &, 0.226432E+01_JPRB, 0.224917E+01_JPRB, 0.223367E+01_JPRB, 0.221786E+01_JPRB &
  &, 0.220171E+01_JPRB, 0.218529E+01_JPRB, 0.216855E+01_JPRB &
  &, 0.215154E+01_JPRB, 0.213426E+01_JPRB, 0.211636E+01_JPRB, 0.209888E+01_JPRB &
  &, 0.208083E+01_JPRB, 0.206256E+01_JPRB, 0.204405E+01_JPRB &
  &, 0.202532E+01_JPRB, 0.200640E+01_JPRB, 0.198727E+01_JPRB, 0.196795E+01_JPRB &
  &, 0.194841E+01_JPRB, 0.192873E+01_JPRB, 0.190895E+01_JPRB &
  &, 0.188897E+01_JPRB, 0.186887E+01_JPRB, 0.184858E+01_JPRB, 0.182823E+01_JPRB &
  &, 0.180778E+01_JPRB, 0.178716E+01_JPRB, 0.176649E+01_JPRB &
  &, 0.174575E+01_JPRB, 0.172489E+01_JPRB, 0.170402E+01_JPRB, 0.168309E+01_JPRB &
  &, 0.166205E+01_JPRB, 0.164101E+01_JPRB, 0.161992E+01_JPRB/)
XCW( 879, :) = (/ &
  &  0.111798E+01_JPRB, 0.114773E+01_JPRB, 0.117755E+01_JPRB, 0.120742E+01_JPRB &
  &, 0.123732E+01_JPRB, 0.126723E+01_JPRB, 0.129715E+01_JPRB &
  &, 0.132705E+01_JPRB, 0.135691E+01_JPRB, 0.138672E+01_JPRB, 0.141646E+01_JPRB &
  &, 0.144611E+01_JPRB, 0.147566E+01_JPRB, 0.150509E+01_JPRB &
  &, 0.153438E+01_JPRB, 0.156351E+01_JPRB, 0.159248E+01_JPRB, 0.162125E+01_JPRB &
  &, 0.164982E+01_JPRB, 0.167816E+01_JPRB, 0.170628E+01_JPRB &
  &, 0.173413E+01_JPRB, 0.176171E+01_JPRB, 0.178901E+01_JPRB, 0.181600E+01_JPRB &
  &, 0.184268E+01_JPRB, 0.186902E+01_JPRB, 0.189501E+01_JPRB &
  &, 0.192064E+01_JPRB, 0.194589E+01_JPRB, 0.197076E+01_JPRB, 0.199521E+01_JPRB &
  &, 0.201925E+01_JPRB, 0.204286E+01_JPRB, 0.206602E+01_JPRB &
  &, 0.208872E+01_JPRB, 0.211096E+01_JPRB, 0.213272E+01_JPRB, 0.215399E+01_JPRB &
  &, 0.217476E+01_JPRB, 0.219501E+01_JPRB, 0.221475E+01_JPRB &
  &, 0.223396E+01_JPRB, 0.225255E+01_JPRB, 0.227077E+01_JPRB, 0.228834E+01_JPRB &
  &, 0.230535E+01_JPRB, 0.232180E+01_JPRB, 0.233768E+01_JPRB &
  &, 0.235296E+01_JPRB, 0.236768E+01_JPRB, 0.238180E+01_JPRB, 0.239533E+01_JPRB &
  &, 0.240826E+01_JPRB, 0.242060E+01_JPRB, 0.243233E+01_JPRB &
  &, 0.244345E+01_JPRB, 0.245391E+01_JPRB, 0.246388E+01_JPRB, 0.247316E+01_JPRB &
  &, 0.248185E+01_JPRB, 0.248990E+01_JPRB, 0.249738E+01_JPRB &
  &, 0.250423E+01_JPRB, 0.251046E+01_JPRB, 0.251609E+01_JPRB, 0.252111E+01_JPRB &
  &, 0.252551E+01_JPRB, 0.252933E+01_JPRB, 0.253253E+01_JPRB &
  &, 0.253514E+01_JPRB, 0.253715E+01_JPRB, 0.253856E+01_JPRB, 0.253938E+01_JPRB &
  &, 0.253961E+01_JPRB, 0.253927E+01_JPRB, 0.253836E+01_JPRB &
  &, 0.253686E+01_JPRB, 0.253481E+01_JPRB, 0.253218E+01_JPRB, 0.252901E+01_JPRB &
  &, 0.252528E+01_JPRB, 0.252102E+01_JPRB, 0.251619E+01_JPRB &
  &, 0.251086E+01_JPRB, 0.250502E+01_JPRB, 0.249864E+01_JPRB, 0.249175E+01_JPRB &
  &, 0.248436E+01_JPRB, 0.247646E+01_JPRB, 0.246809E+01_JPRB &
  &, 0.245924E+01_JPRB, 0.244990E+01_JPRB, 0.244011E+01_JPRB, 0.242987E+01_JPRB &
  &, 0.241918E+01_JPRB, 0.240807E+01_JPRB, 0.239651E+01_JPRB &
  &, 0.238447E+01_JPRB, 0.237214E+01_JPRB, 0.235933E+01_JPRB, 0.234614E+01_JPRB &
  &, 0.233256E+01_JPRB, 0.231861E+01_JPRB, 0.230428E+01_JPRB &
  &, 0.228963E+01_JPRB, 0.227460E+01_JPRB, 0.225923E+01_JPRB, 0.224353E+01_JPRB &
  &, 0.222753E+01_JPRB, 0.221122E+01_JPRB, 0.219461E+01_JPRB &
  &, 0.217770E+01_JPRB, 0.216051E+01_JPRB, 0.214306E+01_JPRB, 0.212533E+01_JPRB &
  &, 0.210734E+01_JPRB, 0.208913E+01_JPRB, 0.207073E+01_JPRB &
  &, 0.205205E+01_JPRB, 0.203317E+01_JPRB, 0.201407E+01_JPRB, 0.199482E+01_JPRB &
  &, 0.197536E+01_JPRB, 0.195564E+01_JPRB, 0.193591E+01_JPRB &
  &, 0.191598E+01_JPRB, 0.189588E+01_JPRB, 0.187562E+01_JPRB, 0.185530E+01_JPRB &
  &, 0.183483E+01_JPRB, 0.181422E+01_JPRB, 0.179356E+01_JPRB &
  &, 0.177276E+01_JPRB, 0.175190E+01_JPRB, 0.173096E+01_JPRB, 0.171000E+01_JPRB &
  &, 0.168894E+01_JPRB, 0.166787E+01_JPRB, 0.164673E+01_JPRB/)
XCW( 880, :) = (/ &
  &  0.111852E+01_JPRB, 0.114841E+01_JPRB, 0.117838E+01_JPRB, 0.120841E+01_JPRB &
  &, 0.123847E+01_JPRB, 0.126855E+01_JPRB, 0.129863E+01_JPRB &
  &, 0.132870E+01_JPRB, 0.135874E+01_JPRB, 0.138873E+01_JPRB, 0.141866E+01_JPRB &
  &, 0.144850E+01_JPRB, 0.147825E+01_JPRB, 0.150787E+01_JPRB &
  &, 0.153737E+01_JPRB, 0.156671E+01_JPRB, 0.159588E+01_JPRB, 0.162487E+01_JPRB &
  &, 0.165366E+01_JPRB, 0.168223E+01_JPRB, 0.171056E+01_JPRB &
  &, 0.173864E+01_JPRB, 0.176646E+01_JPRB, 0.179399E+01_JPRB, 0.182122E+01_JPRB &
  &, 0.184814E+01_JPRB, 0.187472E+01_JPRB, 0.190096E+01_JPRB &
  &, 0.192684E+01_JPRB, 0.195235E+01_JPRB, 0.197747E+01_JPRB, 0.200218E+01_JPRB &
  &, 0.202648E+01_JPRB, 0.205035E+01_JPRB, 0.207378E+01_JPRB &
  &, 0.209675E+01_JPRB, 0.211925E+01_JPRB, 0.214129E+01_JPRB, 0.216283E+01_JPRB &
  &, 0.218388E+01_JPRB, 0.220441E+01_JPRB, 0.222443E+01_JPRB &
  &, 0.224392E+01_JPRB, 0.226288E+01_JPRB, 0.228128E+01_JPRB, 0.229914E+01_JPRB &
  &, 0.231644E+01_JPRB, 0.233318E+01_JPRB, 0.234934E+01_JPRB &
  &, 0.236492E+01_JPRB, 0.237993E+01_JPRB, 0.239434E+01_JPRB, 0.240816E+01_JPRB &
  &, 0.242138E+01_JPRB, 0.243400E+01_JPRB, 0.244602E+01_JPRB &
  &, 0.245743E+01_JPRB, 0.246825E+01_JPRB, 0.247843E+01_JPRB, 0.248802E+01_JPRB &
  &, 0.249699E+01_JPRB, 0.250535E+01_JPRB, 0.251309E+01_JPRB &
  &, 0.252023E+01_JPRB, 0.252675E+01_JPRB, 0.253266E+01_JPRB, 0.253797E+01_JPRB &
  &, 0.254265E+01_JPRB, 0.254674E+01_JPRB, 0.255020E+01_JPRB &
  &, 0.255309E+01_JPRB, 0.255538E+01_JPRB, 0.255707E+01_JPRB, 0.255816E+01_JPRB &
  &, 0.255866E+01_JPRB, 0.255857E+01_JPRB, 0.255793E+01_JPRB &
  &, 0.255593E+01_JPRB, 0.255488E+01_JPRB, 0.255252E+01_JPRB, 0.254959E+01_JPRB &
  &, 0.254611E+01_JPRB, 0.254210E+01_JPRB, 0.253753E+01_JPRB &
  &, 0.253244E+01_JPRB, 0.252681E+01_JPRB, 0.252066E+01_JPRB, 0.251402E+01_JPRB &
  &, 0.250683E+01_JPRB, 0.249918E+01_JPRB, 0.249101E+01_JPRB &
  &, 0.248238E+01_JPRB, 0.247302E+01_JPRB, 0.246367E+01_JPRB, 0.245361E+01_JPRB &
  &, 0.244314E+01_JPRB, 0.243220E+01_JPRB, 0.242081E+01_JPRB &
  &, 0.240901E+01_JPRB, 0.239681E+01_JPRB, 0.238416E+01_JPRB, 0.237116E+01_JPRB &
  &, 0.235773E+01_JPRB, 0.234393E+01_JPRB, 0.232978E+01_JPRB &
  &, 0.231526E+01_JPRB, 0.230037E+01_JPRB, 0.228516E+01_JPRB, 0.226958E+01_JPRB &
  &, 0.225370E+01_JPRB, 0.223749E+01_JPRB, 0.222099E+01_JPRB &
  &, 0.220422E+01_JPRB, 0.218712E+01_JPRB, 0.216975E+01_JPRB, 0.215215E+01_JPRB &
  &, 0.213424E+01_JPRB, 0.211609E+01_JPRB, 0.209775E+01_JPRB &
  &, 0.207917E+01_JPRB, 0.206034E+01_JPRB, 0.204133E+01_JPRB, 0.202211E+01_JPRB &
  &, 0.200267E+01_JPRB, 0.198308E+01_JPRB, 0.196331E+01_JPRB &
  &, 0.194338E+01_JPRB, 0.192333E+01_JPRB, 0.190312E+01_JPRB, 0.188278E+01_JPRB &
  &, 0.186228E+01_JPRB, 0.184169E+01_JPRB, 0.182099E+01_JPRB &
  &, 0.180020E+01_JPRB, 0.177934E+01_JPRB, 0.175839E+01_JPRB, 0.173736E+01_JPRB &
  &, 0.171628E+01_JPRB, 0.169511E+01_JPRB, 0.167394E+01_JPRB/)
XCW( 881, :) = (/ &
  &  0.111906E+01_JPRB, 0.114910E+01_JPRB, 0.117922E+01_JPRB, 0.120940E+01_JPRB &
  &, 0.123962E+01_JPRB, 0.126987E+01_JPRB, 0.130013E+01_JPRB &
  &, 0.133037E+01_JPRB, 0.136059E+01_JPRB, 0.139076E+01_JPRB, 0.142088E+01_JPRB &
  &, 0.145091E+01_JPRB, 0.148085E+01_JPRB, 0.151068E+01_JPRB &
  &, 0.154037E+01_JPRB, 0.156992E+01_JPRB, 0.159931E+01_JPRB, 0.162851E+01_JPRB &
  &, 0.165752E+01_JPRB, 0.168631E+01_JPRB, 0.171487E+01_JPRB &
  &, 0.174319E+01_JPRB, 0.177123E+01_JPRB, 0.179900E+01_JPRB, 0.182648E+01_JPRB &
  &, 0.185363E+01_JPRB, 0.188047E+01_JPRB, 0.190696E+01_JPRB &
  &, 0.193309E+01_JPRB, 0.195886E+01_JPRB, 0.198423E+01_JPRB, 0.200921E+01_JPRB &
  &, 0.203377E+01_JPRB, 0.205791E+01_JPRB, 0.208160E+01_JPRB &
  &, 0.210485E+01_JPRB, 0.212763E+01_JPRB, 0.214993E+01_JPRB, 0.217175E+01_JPRB &
  &, 0.219308E+01_JPRB, 0.221389E+01_JPRB, 0.223419E+01_JPRB &
  &, 0.225397E+01_JPRB, 0.227321E+01_JPRB, 0.229191E+01_JPRB, 0.231005E+01_JPRB &
  &, 0.232762E+01_JPRB, 0.234466E+01_JPRB, 0.236111E+01_JPRB &
  &, 0.237699E+01_JPRB, 0.239228E+01_JPRB, 0.240699E+01_JPRB, 0.242110E+01_JPRB &
  &, 0.243462E+01_JPRB, 0.244754E+01_JPRB, 0.245984E+01_JPRB &
  &, 0.247155E+01_JPRB, 0.248265E+01_JPRB, 0.249314E+01_JPRB, 0.250302E+01_JPRB &
  &, 0.251228E+01_JPRB, 0.252094E+01_JPRB, 0.252896E+01_JPRB &
  &, 0.253638E+01_JPRB, 0.254320E+01_JPRB, 0.254940E+01_JPRB, 0.255498E+01_JPRB &
  &, 0.255995E+01_JPRB, 0.256433E+01_JPRB, 0.256809E+01_JPRB &
  &, 0.257124E+01_JPRB, 0.257379E+01_JPRB, 0.257577E+01_JPRB, 0.257712E+01_JPRB &
  &, 0.257790E+01_JPRB, 0.257806E+01_JPRB, 0.257770E+01_JPRB &
  &, 0.257674E+01_JPRB, 0.257520E+01_JPRB, 0.257309E+01_JPRB, 0.257041E+01_JPRB &
  &, 0.256721E+01_JPRB, 0.256344E+01_JPRB, 0.255912E+01_JPRB &
  &, 0.255425E+01_JPRB, 0.254886E+01_JPRB, 0.254295E+01_JPRB, 0.253651E+01_JPRB &
  &, 0.252959E+01_JPRB, 0.252215E+01_JPRB, 0.251421E+01_JPRB &
  &, 0.250578E+01_JPRB, 0.249687E+01_JPRB, 0.248752E+01_JPRB, 0.247765E+01_JPRB &
  &, 0.246736E+01_JPRB, 0.245664E+01_JPRB, 0.244543E+01_JPRB &
  &, 0.243383E+01_JPRB, 0.242180E+01_JPRB, 0.240936E+01_JPRB, 0.239649E+01_JPRB &
  &, 0.238325E+01_JPRB, 0.236960E+01_JPRB, 0.235559E+01_JPRB &
  &, 0.234122E+01_JPRB, 0.232650E+01_JPRB, 0.231142E+01_JPRB, 0.229597E+01_JPRB &
  &, 0.228025E+01_JPRB, 0.226416E+01_JPRB, 0.224777E+01_JPRB &
  &, 0.223110E+01_JPRB, 0.221409E+01_JPRB, 0.219686E+01_JPRB, 0.217930E+01_JPRB &
  &, 0.216151E+01_JPRB, 0.214349E+01_JPRB, 0.212521E+01_JPRB &
  &, 0.210669E+01_JPRB, 0.208791E+01_JPRB, 0.206894E+01_JPRB, 0.204977E+01_JPRB &
  &, 0.203041E+01_JPRB, 0.201090E+01_JPRB, 0.199114E+01_JPRB &
  &, 0.197128E+01_JPRB, 0.195123E+01_JPRB, 0.193102E+01_JPRB, 0.191066E+01_JPRB &
  &, 0.189019E+01_JPRB, 0.186964E+01_JPRB, 0.184896E+01_JPRB &
  &, 0.182812E+01_JPRB, 0.180727E+01_JPRB, 0.178626E+01_JPRB, 0.176522E+01_JPRB &
  &, 0.174406E+01_JPRB, 0.172293E+01_JPRB, 0.170167E+01_JPRB/)
XCW( 882, :) = (/ &
  &  0.111960E+01_JPRB, 0.114979E+01_JPRB, 0.118007E+01_JPRB, 0.121040E+01_JPRB &
  &, 0.124079E+01_JPRB, 0.127120E+01_JPRB, 0.130163E+01_JPRB &
  &, 0.133205E+01_JPRB, 0.136245E+01_JPRB, 0.139281E+01_JPRB, 0.142311E+01_JPRB &
  &, 0.145334E+01_JPRB, 0.148347E+01_JPRB, 0.151350E+01_JPRB &
  &, 0.154341E+01_JPRB, 0.157316E+01_JPRB, 0.160276E+01_JPRB, 0.163219E+01_JPRB &
  &, 0.166141E+01_JPRB, 0.169043E+01_JPRB, 0.171922E+01_JPRB &
  &, 0.174776E+01_JPRB, 0.177605E+01_JPRB, 0.180406E+01_JPRB, 0.183177E+01_JPRB &
  &, 0.185918E+01_JPRB, 0.188626E+01_JPRB, 0.191301E+01_JPRB &
  &, 0.193940E+01_JPRB, 0.196542E+01_JPRB, 0.199105E+01_JPRB, 0.201629E+01_JPRB &
  &, 0.204112E+01_JPRB, 0.206553E+01_JPRB, 0.208949E+01_JPRB &
  &, 0.211301E+01_JPRB, 0.213607E+01_JPRB, 0.215865E+01_JPRB, 0.218074E+01_JPRB &
  &, 0.220236E+01_JPRB, 0.222345E+01_JPRB, 0.224404E+01_JPRB &
  &, 0.226410E+01_JPRB, 0.228363E+01_JPRB, 0.230262E+01_JPRB, 0.232106E+01_JPRB &
  &, 0.233894E+01_JPRB, 0.235625E+01_JPRB, 0.237300E+01_JPRB &
  &, 0.238917E+01_JPRB, 0.240476E+01_JPRB, 0.241976E+01_JPRB, 0.243416E+01_JPRB &
  &, 0.244797E+01_JPRB, 0.246119E+01_JPRB, 0.247380E+01_JPRB &
  &, 0.248581E+01_JPRB, 0.249720E+01_JPRB, 0.250799E+01_JPRB, 0.251816E+01_JPRB &
  &, 0.252771E+01_JPRB, 0.253667E+01_JPRB, 0.254499E+01_JPRB &
  &, 0.255271E+01_JPRB, 0.255980E+01_JPRB, 0.256629E+01_JPRB, 0.257218E+01_JPRB &
  &, 0.257745E+01_JPRB, 0.258210E+01_JPRB, 0.258614E+01_JPRB &
  &, 0.258959E+01_JPRB, 0.259242E+01_JPRB, 0.259466E+01_JPRB, 0.259631E+01_JPRB &
  &, 0.259736E+01_JPRB, 0.259783E+01_JPRB, 0.259770E+01_JPRB &
  &, 0.259700E+01_JPRB, 0.259574E+01_JPRB, 0.259388E+01_JPRB, 0.259149E+01_JPRB &
  &, 0.258851E+01_JPRB, 0.258499E+01_JPRB, 0.258093E+01_JPRB &
  &, 0.257622E+01_JPRB, 0.257116E+01_JPRB, 0.256550E+01_JPRB, 0.255931E+01_JPRB &
  &, 0.255260E+01_JPRB, 0.254540E+01_JPRB, 0.253769E+01_JPRB &
  &, 0.252947E+01_JPRB, 0.252079E+01_JPRB, 0.251163E+01_JPRB, 0.250199E+01_JPRB &
  &, 0.249189E+01_JPRB, 0.248136E+01_JPRB, 0.247037E+01_JPRB &
  &, 0.245895E+01_JPRB, 0.244709E+01_JPRB, 0.243478E+01_JPRB, 0.242215E+01_JPRB &
  &, 0.240907E+01_JPRB, 0.239561E+01_JPRB, 0.238176E+01_JPRB &
  &, 0.236753E+01_JPRB, 0.235295E+01_JPRB, 0.233801E+01_JPRB, 0.232273E+01_JPRB &
  &, 0.230710E+01_JPRB, 0.229117E+01_JPRB, 0.227489E+01_JPRB &
  &, 0.225834E+01_JPRB, 0.224148E+01_JPRB, 0.222434E+01_JPRB, 0.220692E+01_JPRB &
  &, 0.218922E+01_JPRB, 0.217122E+01_JPRB, 0.215301E+01_JPRB &
  &, 0.213461E+01_JPRB, 0.211594E+01_JPRB, 0.209702E+01_JPRB, 0.207789E+01_JPRB &
  &, 0.205852E+01_JPRB, 0.203909E+01_JPRB, 0.201941E+01_JPRB &
  &, 0.199957E+01_JPRB, 0.197952E+01_JPRB, 0.195936E+01_JPRB, 0.193906E+01_JPRB &
  &, 0.191858E+01_JPRB, 0.189800E+01_JPRB, 0.187735E+01_JPRB &
  &, 0.185653E+01_JPRB, 0.183564E+01_JPRB, 0.181463E+01_JPRB, 0.179353E+01_JPRB &
  &, 0.177236E+01_JPRB, 0.175115E+01_JPRB, 0.172992E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART126',1,ZHOOK_HANDLE)
END SUBROUTINE PART126

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART127

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART127',0,ZHOOK_HANDLE)

XCW( 883, :) = (/ &
  &  0.112015E+01_JPRB, 0.115049E+01_JPRB, 0.118092E+01_JPRB, 0.121141E+01_JPRB &
  &, 0.124196E+01_JPRB, 0.127254E+01_JPRB, 0.130314E+01_JPRB &
  &, 0.133374E+01_JPRB, 0.136432E+01_JPRB, 0.139487E+01_JPRB, 0.142536E+01_JPRB &
  &, 0.145578E+01_JPRB, 0.148612E+01_JPRB, 0.151635E+01_JPRB &
  &, 0.154646E+01_JPRB, 0.157643E+01_JPRB, 0.160625E+01_JPRB, 0.163589E+01_JPRB &
  &, 0.166534E+01_JPRB, 0.169458E+01_JPRB, 0.172360E+01_JPRB &
  &, 0.175238E+01_JPRB, 0.178090E+01_JPRB, 0.180916E+01_JPRB, 0.183711E+01_JPRB &
  &, 0.186477E+01_JPRB, 0.189210E+01_JPRB, 0.191910E+01_JPRB &
  &, 0.194575E+01_JPRB, 0.197203E+01_JPRB, 0.199793E+01_JPRB, 0.202343E+01_JPRB &
  &, 0.204853E+01_JPRB, 0.207321E+01_JPRB, 0.209745E+01_JPRB &
  &, 0.212124E+01_JPRB, 0.214457E+01_JPRB, 0.216744E+01_JPRB, 0.218983E+01_JPRB &
  &, 0.221171E+01_JPRB, 0.223311E+01_JPRB, 0.225397E+01_JPRB &
  &, 0.227432E+01_JPRB, 0.229414E+01_JPRB, 0.231342E+01_JPRB, 0.233216E+01_JPRB &
  &, 0.235034E+01_JPRB, 0.236795E+01_JPRB, 0.238498E+01_JPRB &
  &, 0.240146E+01_JPRB, 0.241734E+01_JPRB, 0.243264E+01_JPRB, 0.244736E+01_JPRB &
  &, 0.246147E+01_JPRB, 0.247498E+01_JPRB, 0.248789E+01_JPRB &
  &, 0.250019E+01_JPRB, 0.251189E+01_JPRB, 0.252298E+01_JPRB, 0.253344E+01_JPRB &
  &, 0.254331E+01_JPRB, 0.255255E+01_JPRB, 0.256118E+01_JPRB &
  &, 0.256919E+01_JPRB, 0.257659E+01_JPRB, 0.258337E+01_JPRB, 0.258955E+01_JPRB &
  &, 0.259510E+01_JPRB, 0.260005E+01_JPRB, 0.260439E+01_JPRB &
  &, 0.260810E+01_JPRB, 0.261124E+01_JPRB, 0.261376E+01_JPRB, 0.261569E+01_JPRB &
  &, 0.261703E+01_JPRB, 0.261776E+01_JPRB, 0.261792E+01_JPRB &
  &, 0.261748E+01_JPRB, 0.261650E+01_JPRB, 0.261491E+01_JPRB, 0.261277E+01_JPRB &
  &, 0.261008E+01_JPRB, 0.260679E+01_JPRB, 0.260298E+01_JPRB &
  &, 0.259863E+01_JPRB, 0.259375E+01_JPRB, 0.258831E+01_JPRB, 0.258236E+01_JPRB &
  &, 0.257590E+01_JPRB, 0.256892E+01_JPRB, 0.256142E+01_JPRB &
  &, 0.255347E+01_JPRB, 0.254500E+01_JPRB, 0.253604E+01_JPRB, 0.252664E+01_JPRB &
  &, 0.251673E+01_JPRB, 0.250642E+01_JPRB, 0.249562E+01_JPRB &
  &, 0.248438E+01_JPRB, 0.247274E+01_JPRB, 0.246064E+01_JPRB, 0.244815E+01_JPRB &
  &, 0.243524E+01_JPRB, 0.242194E+01_JPRB, 0.240828E+01_JPRB &
  &, 0.239421E+01_JPRB, 0.237978E+01_JPRB, 0.236498E+01_JPRB, 0.234984E+01_JPRB &
  &, 0.233437E+01_JPRB, 0.231857E+01_JPRB, 0.230242E+01_JPRB &
  &, 0.228598E+01_JPRB, 0.226923E+01_JPRB, 0.225220E+01_JPRB, 0.223486E+01_JPRB &
  &, 0.221725E+01_JPRB, 0.219939E+01_JPRB, 0.218131E+01_JPRB &
  &, 0.216293E+01_JPRB, 0.214432E+01_JPRB, 0.212551E+01_JPRB, 0.210644E+01_JPRB &
  &, 0.208721E+01_JPRB, 0.206776E+01_JPRB, 0.204811E+01_JPRB &
  &, 0.202829E+01_JPRB, 0.200832E+01_JPRB, 0.198817E+01_JPRB, 0.196786E+01_JPRB &
  &, 0.194743E+01_JPRB, 0.192689E+01_JPRB, 0.190615E+01_JPRB &
  &, 0.188537E+01_JPRB, 0.186443E+01_JPRB, 0.184343E+01_JPRB, 0.182234E+01_JPRB &
  &, 0.180117E+01_JPRB, 0.177995E+01_JPRB, 0.175864E+01_JPRB/)
XCW( 884, :) = (/ &
  &  0.112070E+01_JPRB, 0.115119E+01_JPRB, 0.118177E+01_JPRB, 0.121243E+01_JPRB &
  &, 0.124314E+01_JPRB, 0.127389E+01_JPRB, 0.130466E+01_JPRB &
  &, 0.133544E+01_JPRB, 0.136620E+01_JPRB, 0.139694E+01_JPRB, 0.142762E+01_JPRB &
  &, 0.145824E+01_JPRB, 0.148878E+01_JPRB, 0.151922E+01_JPRB &
  &, 0.154953E+01_JPRB, 0.157972E+01_JPRB, 0.160975E+01_JPRB, 0.163961E+01_JPRB &
  &, 0.166929E+01_JPRB, 0.169876E+01_JPRB, 0.172802E+01_JPRB &
  &, 0.175703E+01_JPRB, 0.178580E+01_JPRB, 0.181429E+01_JPRB, 0.184250E+01_JPRB &
  &, 0.187040E+01_JPRB, 0.189799E+01_JPRB, 0.192524E+01_JPRB &
  &, 0.195215E+01_JPRB, 0.197869E+01_JPRB, 0.200486E+01_JPRB, 0.203063E+01_JPRB &
  &, 0.205600E+01_JPRB, 0.208095E+01_JPRB, 0.210547E+01_JPRB &
  &, 0.212954E+01_JPRB, 0.215316E+01_JPRB, 0.217631E+01_JPRB, 0.219898E+01_JPRB &
  &, 0.222116E+01_JPRB, 0.224283E+01_JPRB, 0.226400E+01_JPRB &
  &, 0.228464E+01_JPRB, 0.230476E+01_JPRB, 0.232433E+01_JPRB, 0.234335E+01_JPRB &
  &, 0.236183E+01_JPRB, 0.237975E+01_JPRB, 0.239709E+01_JPRB &
  &, 0.241386E+01_JPRB, 0.243005E+01_JPRB, 0.244566E+01_JPRB, 0.246067E+01_JPRB &
  &, 0.247509E+01_JPRB, 0.248890E+01_JPRB, 0.250212E+01_JPRB &
  &, 0.251472E+01_JPRB, 0.252673E+01_JPRB, 0.253812E+01_JPRB, 0.254890E+01_JPRB &
  &, 0.255905E+01_JPRB, 0.256859E+01_JPRB, 0.257752E+01_JPRB &
  &, 0.258585E+01_JPRB, 0.259354E+01_JPRB, 0.260062E+01_JPRB, 0.260708E+01_JPRB &
  &, 0.261295E+01_JPRB, 0.261819E+01_JPRB, 0.262281E+01_JPRB &
  &, 0.262683E+01_JPRB, 0.263025E+01_JPRB, 0.263306E+01_JPRB, 0.263528E+01_JPRB &
  &, 0.263689E+01_JPRB, 0.263793E+01_JPRB, 0.263835E+01_JPRB &
  &, 0.263821E+01_JPRB, 0.263749E+01_JPRB, 0.263616E+01_JPRB, 0.263428E+01_JPRB &
  &, 0.263185E+01_JPRB, 0.262885E+01_JPRB, 0.262530E+01_JPRB &
  &, 0.262077E+01_JPRB, 0.261656E+01_JPRB, 0.261138E+01_JPRB, 0.260569E+01_JPRB &
  &, 0.259948E+01_JPRB, 0.259271E+01_JPRB, 0.258546E+01_JPRB &
  &, 0.257773E+01_JPRB, 0.256949E+01_JPRB, 0.256078E+01_JPRB, 0.255158E+01_JPRB &
  &, 0.254191E+01_JPRB, 0.253176E+01_JPRB, 0.252119E+01_JPRB &
  &, 0.251014E+01_JPRB, 0.249869E+01_JPRB, 0.248680E+01_JPRB, 0.247448E+01_JPRB &
  &, 0.246179E+01_JPRB, 0.244866E+01_JPRB, 0.243512E+01_JPRB &
  &, 0.242125E+01_JPRB, 0.240697E+01_JPRB, 0.239232E+01_JPRB, 0.237736E+01_JPRB &
  &, 0.236200E+01_JPRB, 0.234633E+01_JPRB, 0.233034E+01_JPRB &
  &, 0.231402E+01_JPRB, 0.229739E+01_JPRB, 0.228046E+01_JPRB, 0.226323E+01_JPRB &
  &, 0.224577E+01_JPRB, 0.222800E+01_JPRB, 0.220995E+01_JPRB &
  &, 0.219169E+01_JPRB, 0.217316E+01_JPRB, 0.215442E+01_JPRB, 0.213545E+01_JPRB &
  &, 0.211627E+01_JPRB, 0.209687E+01_JPRB, 0.207725E+01_JPRB &
  &, 0.205751E+01_JPRB, 0.203756E+01_JPRB, 0.201742E+01_JPRB, 0.199718E+01_JPRB &
  &, 0.197674E+01_JPRB, 0.195619E+01_JPRB, 0.193550E+01_JPRB &
  &, 0.191469E+01_JPRB, 0.189378E+01_JPRB, 0.187274E+01_JPRB, 0.185165E+01_JPRB &
  &, 0.183042E+01_JPRB, 0.180920E+01_JPRB, 0.178781E+01_JPRB/)
XCW( 885, :) = (/ &
  &  0.112126E+01_JPRB, 0.115190E+01_JPRB, 0.118263E+01_JPRB, 0.121345E+01_JPRB &
  &, 0.124433E+01_JPRB, 0.127525E+01_JPRB, 0.130620E+01_JPRB &
  &, 0.133715E+01_JPRB, 0.136810E+01_JPRB, 0.139903E+01_JPRB, 0.142990E+01_JPRB &
  &, 0.146072E+01_JPRB, 0.149146E+01_JPRB, 0.152210E+01_JPRB &
  &, 0.155263E+01_JPRB, 0.158303E+01_JPRB, 0.161328E+01_JPRB, 0.164337E+01_JPRB &
  &, 0.167327E+01_JPRB, 0.170298E+01_JPRB, 0.173246E+01_JPRB &
  &, 0.176172E+01_JPRB, 0.179073E+01_JPRB, 0.181947E+01_JPRB, 0.184792E+01_JPRB &
  &, 0.187608E+01_JPRB, 0.190392E+01_JPRB, 0.193144E+01_JPRB &
  &, 0.195861E+01_JPRB, 0.198541E+01_JPRB, 0.201185E+01_JPRB, 0.203789E+01_JPRB &
  &, 0.206354E+01_JPRB, 0.208877E+01_JPRB, 0.211356E+01_JPRB &
  &, 0.213791E+01_JPRB, 0.216182E+01_JPRB, 0.218526E+01_JPRB, 0.220821E+01_JPRB &
  &, 0.223068E+01_JPRB, 0.225264E+01_JPRB, 0.227411E+01_JPRB &
  &, 0.229501E+01_JPRB, 0.231546E+01_JPRB, 0.233534E+01_JPRB, 0.235466E+01_JPRB &
  &, 0.237344E+01_JPRB, 0.239166E+01_JPRB, 0.240930E+01_JPRB &
  &, 0.242636E+01_JPRB, 0.244288E+01_JPRB, 0.245878E+01_JPRB, 0.247410E+01_JPRB &
  &, 0.248883E+01_JPRB, 0.250295E+01_JPRB, 0.251647E+01_JPRB &
  &, 0.252915E+01_JPRB, 0.254170E+01_JPRB, 0.255340E+01_JPRB, 0.256448E+01_JPRB &
  &, 0.257496E+01_JPRB, 0.258480E+01_JPRB, 0.259405E+01_JPRB &
  &, 0.260267E+01_JPRB, 0.261066E+01_JPRB, 0.261804E+01_JPRB, 0.262483E+01_JPRB &
  &, 0.263098E+01_JPRB, 0.263652E+01_JPRB, 0.264144E+01_JPRB &
  &, 0.264577E+01_JPRB, 0.264948E+01_JPRB, 0.265258E+01_JPRB, 0.265507E+01_JPRB &
  &, 0.265699E+01_JPRB, 0.265831E+01_JPRB, 0.265902E+01_JPRB &
  &, 0.265915E+01_JPRB, 0.265870E+01_JPRB, 0.265766E+01_JPRB, 0.265608E+01_JPRB &
  &, 0.265389E+01_JPRB, 0.265116E+01_JPRB, 0.264787E+01_JPRB &
  &, 0.264405E+01_JPRB, 0.263966E+01_JPRB, 0.263474E+01_JPRB, 0.262927E+01_JPRB &
  &, 0.262332E+01_JPRB, 0.261681E+01_JPRB, 0.260982E+01_JPRB &
  &, 0.260230E+01_JPRB, 0.259428E+01_JPRB, 0.258578E+01_JPRB, 0.257682E+01_JPRB &
  &, 0.256736E+01_JPRB, 0.255745E+01_JPRB, 0.254707E+01_JPRB &
  &, 0.253626E+01_JPRB, 0.252499E+01_JPRB, 0.251330E+01_JPRB, 0.250116E+01_JPRB &
  &, 0.248864E+01_JPRB, 0.247569E+01_JPRB, 0.246236E+01_JPRB &
  &, 0.244865E+01_JPRB, 0.243453E+01_JPRB, 0.242004E+01_JPRB, 0.240523E+01_JPRB &
  &, 0.239004E+01_JPRB, 0.237452E+01_JPRB, 0.235862E+01_JPRB &
  &, 0.234247E+01_JPRB, 0.232595E+01_JPRB, 0.230915E+01_JPRB, 0.229203E+01_JPRB &
  &, 0.227467E+01_JPRB, 0.225699E+01_JPRB, 0.223908E+01_JPRB &
  &, 0.222086E+01_JPRB, 0.220245E+01_JPRB, 0.218378E+01_JPRB, 0.216487E+01_JPRB &
  &, 0.214575E+01_JPRB, 0.212640E+01_JPRB, 0.210688E+01_JPRB &
  &, 0.208717E+01_JPRB, 0.206725E+01_JPRB, 0.204719E+01_JPRB, 0.202696E+01_JPRB &
  &, 0.200652E+01_JPRB, 0.198603E+01_JPRB, 0.196532E+01_JPRB &
  &, 0.194455E+01_JPRB, 0.192362E+01_JPRB, 0.190260E+01_JPRB, 0.188147E+01_JPRB &
  &, 0.186026E+01_JPRB, 0.183891E+01_JPRB, 0.181758E+01_JPRB/)
XCW( 886, :) = (/ &
  &  0.112181E+01_JPRB, 0.115261E+01_JPRB, 0.118350E+01_JPRB, 0.121448E+01_JPRB &
  &, 0.124553E+01_JPRB, 0.127662E+01_JPRB, 0.130774E+01_JPRB &
  &, 0.133888E+01_JPRB, 0.137001E+01_JPRB, 0.140113E+01_JPRB, 0.143220E+01_JPRB &
  &, 0.146322E+01_JPRB, 0.149416E+01_JPRB, 0.152501E+01_JPRB &
  &, 0.155576E+01_JPRB, 0.158637E+01_JPRB, 0.161684E+01_JPRB, 0.164716E+01_JPRB &
  &, 0.167729E+01_JPRB, 0.170722E+01_JPRB, 0.173695E+01_JPRB &
  &, 0.176645E+01_JPRB, 0.179570E+01_JPRB, 0.182468E+01_JPRB, 0.185339E+01_JPRB &
  &, 0.188180E+01_JPRB, 0.190990E+01_JPRB, 0.193768E+01_JPRB &
  &, 0.196512E+01_JPRB, 0.199219E+01_JPRB, 0.201890E+01_JPRB, 0.204522E+01_JPRB &
  &, 0.207114E+01_JPRB, 0.209665E+01_JPRB, 0.212173E+01_JPRB &
  &, 0.214637E+01_JPRB, 0.217055E+01_JPRB, 0.219427E+01_JPRB, 0.221753E+01_JPRB &
  &, 0.224029E+01_JPRB, 0.226255E+01_JPRB, 0.228431E+01_JPRB &
  &, 0.230555E+01_JPRB, 0.232626E+01_JPRB, 0.234644E+01_JPRB, 0.236607E+01_JPRB &
  &, 0.238516E+01_JPRB, 0.240368E+01_JPRB, 0.242163E+01_JPRB &
  &, 0.243901E+01_JPRB, 0.245582E+01_JPRB, 0.247204E+01_JPRB, 0.248767E+01_JPRB &
  &, 0.250270E+01_JPRB, 0.251714E+01_JPRB, 0.253098E+01_JPRB &
  &, 0.254422E+01_JPRB, 0.255683E+01_JPRB, 0.256878E+01_JPRB, 0.258023E+01_JPRB &
  &, 0.259102E+01_JPRB, 0.260117E+01_JPRB, 0.261073E+01_JPRB &
  &, 0.261966E+01_JPRB, 0.262797E+01_JPRB, 0.263566E+01_JPRB, 0.264273E+01_JPRB &
  &, 0.264919E+01_JPRB, 0.265504E+01_JPRB, 0.266027E+01_JPRB &
  &, 0.266489E+01_JPRB, 0.266890E+01_JPRB, 0.267230E+01_JPRB, 0.267511E+01_JPRB &
  &, 0.267731E+01_JPRB, 0.267889E+01_JPRB, 0.267991E+01_JPRB &
  &, 0.268033E+01_JPRB, 0.268016E+01_JPRB, 0.267942E+01_JPRB, 0.267809E+01_JPRB &
  &, 0.267619E+01_JPRB, 0.267373E+01_JPRB, 0.267072E+01_JPRB &
  &, 0.266714E+01_JPRB, 0.266304E+01_JPRB, 0.265838E+01_JPRB, 0.265313E+01_JPRB &
  &, 0.264744E+01_JPRB, 0.264118E+01_JPRB, 0.263445E+01_JPRB &
  &, 0.262716E+01_JPRB, 0.261939E+01_JPRB, 0.261111E+01_JPRB, 0.260237E+01_JPRB &
  &, 0.259315E+01_JPRB, 0.258344E+01_JPRB, 0.257327E+01_JPRB &
  &, 0.256270E+01_JPRB, 0.255163E+01_JPRB, 0.254012E+01_JPRB, 0.252821E+01_JPRB &
  &, 0.251584E+01_JPRB, 0.250310E+01_JPRB, 0.248995E+01_JPRB &
  &, 0.247641E+01_JPRB, 0.246246E+01_JPRB, 0.244812E+01_JPRB, 0.243347E+01_JPRB &
  &, 0.241844E+01_JPRB, 0.240305E+01_JPRB, 0.238734E+01_JPRB &
  &, 0.237127E+01_JPRB, 0.235489E+01_JPRB, 0.233825E+01_JPRB, 0.232124E+01_JPRB &
  &, 0.230399E+01_JPRB, 0.228642E+01_JPRB, 0.226861E+01_JPRB &
  &, 0.225052E+01_JPRB, 0.223215E+01_JPRB, 0.221355E+01_JPRB, 0.219477E+01_JPRB &
  &, 0.217571E+01_JPRB, 0.215641E+01_JPRB, 0.213694E+01_JPRB &
  &, 0.211728E+01_JPRB, 0.209744E+01_JPRB, 0.207741E+01_JPRB, 0.205719E+01_JPRB &
  &, 0.203683E+01_JPRB, 0.201634E+01_JPRB, 0.199563E+01_JPRB &
  &, 0.197484E+01_JPRB, 0.195395E+01_JPRB, 0.193290E+01_JPRB, 0.191180E+01_JPRB &
  &, 0.189054E+01_JPRB, 0.186920E+01_JPRB, 0.184781E+01_JPRB/)
XCW( 887, :) = (/ &
  &  0.112238E+01_JPRB, 0.115332E+01_JPRB, 0.118438E+01_JPRB, 0.121552E+01_JPRB &
  &, 0.124673E+01_JPRB, 0.127800E+01_JPRB, 0.130930E+01_JPRB &
  &, 0.134062E+01_JPRB, 0.137194E+01_JPRB, 0.140324E+01_JPRB, 0.143451E+01_JPRB &
  &, 0.146573E+01_JPRB, 0.149688E+01_JPRB, 0.152794E+01_JPRB &
  &, 0.155890E+01_JPRB, 0.158974E+01_JPRB, 0.162043E+01_JPRB, 0.165097E+01_JPRB &
  &, 0.168133E+01_JPRB, 0.171151E+01_JPRB, 0.174147E+01_JPRB &
  &, 0.177121E+01_JPRB, 0.180071E+01_JPRB, 0.182994E+01_JPRB, 0.185891E+01_JPRB &
  &, 0.188758E+01_JPRB, 0.191594E+01_JPRB, 0.194398E+01_JPRB &
  &, 0.197168E+01_JPRB, 0.199903E+01_JPRB, 0.202601E+01_JPRB, 0.205261E+01_JPRB &
  &, 0.207881E+01_JPRB, 0.210459E+01_JPRB, 0.212996E+01_JPRB &
  &, 0.215489E+01_JPRB, 0.217936E+01_JPRB, 0.220338E+01_JPRB, 0.222692E+01_JPRB &
  &, 0.224998E+01_JPRB, 0.227255E+01_JPRB, 0.229461E+01_JPRB &
  &, 0.231615E+01_JPRB, 0.233717E+01_JPRB, 0.235764E+01_JPRB, 0.237759E+01_JPRB &
  &, 0.239698E+01_JPRB, 0.241581E+01_JPRB, 0.243408E+01_JPRB &
  &, 0.245177E+01_JPRB, 0.246889E+01_JPRB, 0.248542E+01_JPRB, 0.250137E+01_JPRB &
  &, 0.251672E+01_JPRB, 0.253148E+01_JPRB, 0.254562E+01_JPRB &
  &, 0.255917E+01_JPRB, 0.257211E+01_JPRB, 0.258444E+01_JPRB, 0.259615E+01_JPRB &
  &, 0.260724E+01_JPRB, 0.261772E+01_JPRB, 0.262758E+01_JPRB &
  &, 0.263682E+01_JPRB, 0.264544E+01_JPRB, 0.265346E+01_JPRB, 0.266084E+01_JPRB &
  &, 0.266762E+01_JPRB, 0.267376E+01_JPRB, 0.267929E+01_JPRB &
  &, 0.268423E+01_JPRB, 0.268854E+01_JPRB, 0.269223E+01_JPRB, 0.269535E+01_JPRB &
  &, 0.269785E+01_JPRB, 0.269974E+01_JPRB, 0.270103E+01_JPRB &
  &, 0.270173E+01_JPRB, 0.270186E+01_JPRB, 0.270141E+01_JPRB, 0.270038E+01_JPRB &
  &, 0.269876E+01_JPRB, 0.269658E+01_JPRB, 0.269384E+01_JPRB &
  &, 0.269053E+01_JPRB, 0.268668E+01_JPRB, 0.268226E+01_JPRB, 0.267733E+01_JPRB &
  &, 0.267188E+01_JPRB, 0.266586E+01_JPRB, 0.265936E+01_JPRB &
  &, 0.265233E+01_JPRB, 0.264482E+01_JPRB, 0.263677E+01_JPRB, 0.262828E+01_JPRB &
  &, 0.261928E+01_JPRB, 0.260979E+01_JPRB, 0.259986E+01_JPRB &
  &, 0.258945E+01_JPRB, 0.257859E+01_JPRB, 0.256732E+01_JPRB, 0.255560E+01_JPRB &
  &, 0.254315E+01_JPRB, 0.253087E+01_JPRB, 0.251790E+01_JPRB &
  &, 0.250453E+01_JPRB, 0.249075E+01_JPRB, 0.247662E+01_JPRB, 0.246213E+01_JPRB &
  &, 0.244726E+01_JPRB, 0.243202E+01_JPRB, 0.241645E+01_JPRB &
  &, 0.240053E+01_JPRB, 0.238428E+01_JPRB, 0.236777E+01_JPRB, 0.235088E+01_JPRB &
  &, 0.233375E+01_JPRB, 0.231629E+01_JPRB, 0.229857E+01_JPRB &
  &, 0.228059E+01_JPRB, 0.226235E+01_JPRB, 0.224384E+01_JPRB, 0.222508E+01_JPRB &
  &, 0.220609E+01_JPRB, 0.218691E+01_JPRB, 0.216749E+01_JPRB &
  &, 0.214788E+01_JPRB, 0.212808E+01_JPRB, 0.210808E+01_JPRB, 0.208795E+01_JPRB &
  &, 0.206760E+01_JPRB, 0.204712E+01_JPRB, 0.202647E+01_JPRB &
  &, 0.200568E+01_JPRB, 0.198477E+01_JPRB, 0.196377E+01_JPRB, 0.194263E+01_JPRB &
  &, 0.192139E+01_JPRB, 0.189994E+01_JPRB, 0.187863E+01_JPRB/)
XCW( 888, :) = (/ &
  &  0.112294E+01_JPRB, 0.115404E+01_JPRB, 0.118525E+01_JPRB, 0.121656E+01_JPRB &
  &, 0.124794E+01_JPRB, 0.127938E+01_JPRB, 0.131086E+01_JPRB &
  &, 0.134237E+01_JPRB, 0.137388E+01_JPRB, 0.140538E+01_JPRB, 0.143685E+01_JPRB &
  &, 0.146827E+01_JPRB, 0.149962E+01_JPRB, 0.153090E+01_JPRB &
  &, 0.156207E+01_JPRB, 0.159313E+01_JPRB, 0.162405E+01_JPRB, 0.165481E+01_JPRB &
  &, 0.168541E+01_JPRB, 0.171582E+01_JPRB, 0.174602E+01_JPRB &
  &, 0.177601E+01_JPRB, 0.180576E+01_JPRB, 0.183525E+01_JPRB, 0.186447E+01_JPRB &
  &, 0.189339E+01_JPRB, 0.192202E+01_JPRB, 0.195033E+01_JPRB &
  &, 0.197830E+01_JPRB, 0.200592E+01_JPRB, 0.203318E+01_JPRB, 0.206005E+01_JPRB &
  &, 0.208654E+01_JPRB, 0.211261E+01_JPRB, 0.213826E+01_JPRB &
  &, 0.216348E+01_JPRB, 0.218825E+01_JPRB, 0.221257E+01_JPRB, 0.223641E+01_JPRB &
  &, 0.225977E+01_JPRB, 0.228263E+01_JPRB, 0.230499E+01_JPRB &
  &, 0.232684E+01_JPRB, 0.234816E+01_JPRB, 0.236896E+01_JPRB, 0.238921E+01_JPRB &
  &, 0.240891E+01_JPRB, 0.242805E+01_JPRB, 0.244664E+01_JPRB &
  &, 0.246465E+01_JPRB, 0.248209E+01_JPRB, 0.249894E+01_JPRB, 0.251520E+01_JPRB &
  &, 0.253087E+01_JPRB, 0.254595E+01_JPRB, 0.256042E+01_JPRB &
  &, 0.257428E+01_JPRB, 0.258754E+01_JPRB, 0.260018E+01_JPRB, 0.261221E+01_JPRB &
  &, 0.262363E+01_JPRB, 0.263444E+01_JPRB, 0.264460E+01_JPRB &
  &, 0.265417E+01_JPRB, 0.266305E+01_JPRB, 0.267143E+01_JPRB, 0.267915E+01_JPRB &
  &, 0.268622E+01_JPRB, 0.269269E+01_JPRB, 0.269853E+01_JPRB &
  &, 0.270376E+01_JPRB, 0.270839E+01_JPRB, 0.271239E+01_JPRB, 0.271579E+01_JPRB &
  &, 0.271859E+01_JPRB, 0.272079E+01_JPRB, 0.272239E+01_JPRB &
  &, 0.272340E+01_JPRB, 0.272382E+01_JPRB, 0.272364E+01_JPRB, 0.272290E+01_JPRB &
  &, 0.272156E+01_JPRB, 0.271966E+01_JPRB, 0.271720E+01_JPRB &
  &, 0.271417E+01_JPRB, 0.271060E+01_JPRB, 0.270646E+01_JPRB, 0.270180E+01_JPRB &
  &, 0.269659E+01_JPRB, 0.269085E+01_JPRB, 0.268458E+01_JPRB &
  &, 0.267782E+01_JPRB, 0.267055E+01_JPRB, 0.266275E+01_JPRB, 0.265449E+01_JPRB &
  &, 0.264571E+01_JPRB, 0.263647E+01_JPRB, 0.262677E+01_JPRB &
  &, 0.261657E+01_JPRB, 0.260595E+01_JPRB, 0.259485E+01_JPRB, 0.258333E+01_JPRB &
  &, 0.257138E+01_JPRB, 0.255903E+01_JPRB, 0.254624E+01_JPRB &
  &, 0.253306E+01_JPRB, 0.251950E+01_JPRB, 0.250550E+01_JPRB, 0.249117E+01_JPRB &
  &, 0.247646E+01_JPRB, 0.246138E+01_JPRB, 0.244597E+01_JPRB &
  &, 0.243019E+01_JPRB, 0.241412E+01_JPRB, 0.239770E+01_JPRB, 0.238099E+01_JPRB &
  &, 0.236393E+01_JPRB, 0.234663E+01_JPRB, 0.232898E+01_JPRB &
  &, 0.231115E+01_JPRB, 0.229296E+01_JPRB, 0.227454E+01_JPRB, 0.225591E+01_JPRB &
  &, 0.223700E+01_JPRB, 0.221789E+01_JPRB, 0.219853E+01_JPRB &
  &, 0.217903E+01_JPRB, 0.215928E+01_JPRB, 0.213932E+01_JPRB, 0.211916E+01_JPRB &
  &, 0.209890E+01_JPRB, 0.207844E+01_JPRB, 0.205738E+01_JPRB &
  &, 0.203707E+01_JPRB, 0.201615E+01_JPRB, 0.199513E+01_JPRB, 0.197378E+01_JPRB &
  &, 0.195276E+01_JPRB, 0.193140E+01_JPRB, 0.190997E+01_JPRB/)
XCW( 889, :) = (/ &
  &  0.112351E+01_JPRB, 0.115477E+01_JPRB, 0.118614E+01_JPRB, 0.121761E+01_JPRB &
  &, 0.124916E+01_JPRB, 0.128078E+01_JPRB, 0.131244E+01_JPRB &
  &, 0.134413E+01_JPRB, 0.137583E+01_JPRB, 0.140753E+01_JPRB, 0.143920E+01_JPRB &
  &, 0.147082E+01_JPRB, 0.150239E+01_JPRB, 0.153387E+01_JPRB &
  &, 0.156526E+01_JPRB, 0.159654E+01_JPRB, 0.162769E+01_JPRB, 0.165869E+01_JPRB &
  &, 0.168952E+01_JPRB, 0.172017E+01_JPRB, 0.175062E+01_JPRB &
  &, 0.178085E+01_JPRB, 0.181085E+01_JPRB, 0.184059E+01_JPRB, 0.187007E+01_JPRB &
  &, 0.189926E+01_JPRB, 0.192815E+01_JPRB, 0.195673E+01_JPRB &
  &, 0.198498E+01_JPRB, 0.201287E+01_JPRB, 0.204041E+01_JPRB, 0.206757E+01_JPRB &
  &, 0.209434E+01_JPRB, 0.212070E+01_JPRB, 0.214664E+01_JPRB &
  &, 0.217215E+01_JPRB, 0.219722E+01_JPRB, 0.222183E+01_JPRB, 0.224597E+01_JPRB &
  &, 0.226963E+01_JPRB, 0.229280E+01_JPRB, 0.231548E+01_JPRB &
  &, 0.233763E+01_JPRB, 0.235928E+01_JPRB, 0.238038E+01_JPRB, 0.240095E+01_JPRB &
  &, 0.242096E+01_JPRB, 0.244042E+01_JPRB, 0.245933E+01_JPRB &
  &, 0.247766E+01_JPRB, 0.249542E+01_JPRB, 0.251259E+01_JPRB, 0.252918E+01_JPRB &
  &, 0.254514E+01_JPRB, 0.256056E+01_JPRB, 0.257536E+01_JPRB &
  &, 0.258955E+01_JPRB, 0.260313E+01_JPRB, 0.261609E+01_JPRB, 0.262845E+01_JPRB &
  &, 0.264019E+01_JPRB, 0.265131E+01_JPRB, 0.266182E+01_JPRB &
  &, 0.267170E+01_JPRB, 0.268096E+01_JPRB, 0.268961E+01_JPRB, 0.269763E+01_JPRB &
  &, 0.270502E+01_JPRB, 0.271182E+01_JPRB, 0.271797E+01_JPRB &
  &, 0.272352E+01_JPRB, 0.272846E+01_JPRB, 0.273279E+01_JPRB, 0.273650E+01_JPRB &
  &, 0.273959E+01_JPRB, 0.274210E+01_JPRB, 0.274402E+01_JPRB &
  &, 0.274532E+01_JPRB, 0.274602E+01_JPRB, 0.274616E+01_JPRB, 0.274570E+01_JPRB &
  &, 0.274466E+01_JPRB, 0.274304E+01_JPRB, 0.274086E+01_JPRB &
  &, 0.273812E+01_JPRB, 0.273483E+01_JPRB, 0.273097E+01_JPRB, 0.272657E+01_JPRB &
  &, 0.272161E+01_JPRB, 0.271614E+01_JPRB, 0.271015E+01_JPRB &
  &, 0.270363E+01_JPRB, 0.269659E+01_JPRB, 0.268907E+01_JPRB, 0.268104E+01_JPRB &
  &, 0.267249E+01_JPRB, 0.266347E+01_JPRB, 0.265399E+01_JPRB &
  &, 0.264405E+01_JPRB, 0.263364E+01_JPRB, 0.262275E+01_JPRB, 0.261148E+01_JPRB &
  &, 0.259973E+01_JPRB, 0.258757E+01_JPRB, 0.257498E+01_JPRB &
  &, 0.256199E+01_JPRB, 0.254857E+01_JPRB, 0.253479E+01_JPRB, 0.252064E+01_JPRB &
  &, 0.250609E+01_JPRB, 0.249118E+01_JPRB, 0.247592E+01_JPRB &
  &, 0.246030E+01_JPRB, 0.244438E+01_JPRB, 0.242810E+01_JPRB, 0.241148E+01_JPRB &
  &, 0.239459E+01_JPRB, 0.237737E+01_JPRB, 0.235988E+01_JPRB &
  &, 0.234211E+01_JPRB, 0.232407E+01_JPRB, 0.230575E+01_JPRB, 0.228721E+01_JPRB &
  &, 0.226839E+01_JPRB, 0.224935E+01_JPRB, 0.223012E+01_JPRB &
  &, 0.221062E+01_JPRB, 0.219093E+01_JPRB, 0.217107E+01_JPRB, 0.215095E+01_JPRB &
  &, 0.213072E+01_JPRB, 0.211028E+01_JPRB, 0.208972E+01_JPRB &
  &, 0.206894E+01_JPRB, 0.204808E+01_JPRB, 0.202705E+01_JPRB, 0.200594E+01_JPRB &
  &, 0.198471E+01_JPRB, 0.196331E+01_JPRB, 0.194184E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART127',1,ZHOOK_HANDLE)
END SUBROUTINE PART127

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART128

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART128',0,ZHOOK_HANDLE)

XCW( 890, :) = (/ &
  &  0.112408E+01_JPRB, 0.115550E+01_JPRB, 0.118703E+01_JPRB, 0.121867E+01_JPRB &
  &, 0.125039E+01_JPRB, 0.128219E+01_JPRB, 0.131403E+01_JPRB &
  &, 0.134591E+01_JPRB, 0.137780E+01_JPRB, 0.140969E+01_JPRB, 0.144156E+01_JPRB &
  &, 0.147339E+01_JPRB, 0.150517E+01_JPRB, 0.153687E+01_JPRB &
  &, 0.156848E+01_JPRB, 0.159999E+01_JPRB, 0.163136E+01_JPRB, 0.166259E+01_JPRB &
  &, 0.169366E+01_JPRB, 0.172456E+01_JPRB, 0.175525E+01_JPRB &
  &, 0.178573E+01_JPRB, 0.181598E+01_JPRB, 0.184598E+01_JPRB, 0.187572E+01_JPRB &
  &, 0.190518E+01_JPRB, 0.193434E+01_JPRB, 0.196319E+01_JPRB &
  &, 0.199171E+01_JPRB, 0.201989E+01_JPRB, 0.204770E+01_JPRB, 0.207515E+01_JPRB &
  &, 0.210220E+01_JPRB, 0.212886E+01_JPRB, 0.215510E+01_JPRB &
  &, 0.218090E+01_JPRB, 0.220627E+01_JPRB, 0.223118E+01_JPRB, 0.225563E+01_JPRB &
  &, 0.227960E+01_JPRB, 0.230308E+01_JPRB, 0.232606E+01_JPRB &
  &, 0.234853E+01_JPRB, 0.237048E+01_JPRB, 0.239191E+01_JPRB, 0.241279E+01_JPRB &
  &, 0.243313E+01_JPRB, 0.245292E+01_JPRB, 0.247214E+01_JPRB &
  &, 0.249080E+01_JPRB, 0.250888E+01_JPRB, 0.252637E+01_JPRB, 0.254328E+01_JPRB &
  &, 0.255960E+01_JPRB, 0.257533E+01_JPRB, 0.259045E+01_JPRB &
  &, 0.260496E+01_JPRB, 0.261888E+01_JPRB, 0.263217E+01_JPRB, 0.264486E+01_JPRB &
  &, 0.265693E+01_JPRB, 0.266837E+01_JPRB, 0.267920E+01_JPRB &
  &, 0.268941E+01_JPRB, 0.269899E+01_JPRB, 0.270798E+01_JPRB, 0.271632E+01_JPRB &
  &, 0.272404E+01_JPRB, 0.273114E+01_JPRB, 0.273762E+01_JPRB &
  &, 0.274349E+01_JPRB, 0.274874E+01_JPRB, 0.275339E+01_JPRB, 0.275741E+01_JPRB &
  &, 0.276085E+01_JPRB, 0.276365E+01_JPRB, 0.276586E+01_JPRB &
  &, 0.276748E+01_JPRB, 0.276850E+01_JPRB, 0.276890E+01_JPRB, 0.276876E+01_JPRB &
  &, 0.276801E+01_JPRB, 0.276668E+01_JPRB, 0.276480E+01_JPRB &
  &, 0.276235E+01_JPRB, 0.275932E+01_JPRB, 0.275575E+01_JPRB, 0.275163E+01_JPRB &
  &, 0.274695E+01_JPRB, 0.274174E+01_JPRB, 0.273603E+01_JPRB &
  &, 0.272975E+01_JPRB, 0.272299E+01_JPRB, 0.271571E+01_JPRB, 0.270791E+01_JPRB &
  &, 0.269963E+01_JPRB, 0.269085E+01_JPRB, 0.268160E+01_JPRB &
  &, 0.267188E+01_JPRB, 0.266169E+01_JPRB, 0.265106E+01_JPRB, 0.263996E+01_JPRB &
  &, 0.262842E+01_JPRB, 0.261646E+01_JPRB, 0.260407E+01_JPRB &
  &, 0.259131E+01_JPRB, 0.257809E+01_JPRB, 0.256450E+01_JPRB, 0.255048E+01_JPRB &
  &, 0.253581E+01_JPRB, 0.252141E+01_JPRB, 0.250627E+01_JPRB &
  &, 0.249085E+01_JPRB, 0.247504E+01_JPRB, 0.245891E+01_JPRB, 0.244248E+01_JPRB &
  &, 0.242573E+01_JPRB, 0.240864E+01_JPRB, 0.239127E+01_JPRB &
  &, 0.237362E+01_JPRB, 0.235564E+01_JPRB, 0.233747E+01_JPRB, 0.231898E+01_JPRB &
  &, 0.230030E+01_JPRB, 0.228134E+01_JPRB, 0.226214E+01_JPRB &
  &, 0.224271E+01_JPRB, 0.222313E+01_JPRB, 0.220327E+01_JPRB, 0.218326E+01_JPRB &
  &, 0.216307E+01_JPRB, 0.214266E+01_JPRB, 0.212212E+01_JPRB &
  &, 0.210141E+01_JPRB, 0.208056E+01_JPRB, 0.205954E+01_JPRB, 0.203842E+01_JPRB &
  &, 0.201716E+01_JPRB, 0.199581E+01_JPRB, 0.197437E+01_JPRB/)
XCW( 891, :) = (/ &
  &  0.112466E+01_JPRB, 0.115623E+01_JPRB, 0.118793E+01_JPRB, 0.121973E+01_JPRB &
  &, 0.125163E+01_JPRB, 0.128360E+01_JPRB, 0.131563E+01_JPRB &
  &, 0.134770E+01_JPRB, 0.137978E+01_JPRB, 0.141187E+01_JPRB, 0.144395E+01_JPRB &
  &, 0.147598E+01_JPRB, 0.150797E+01_JPRB, 0.153989E+01_JPRB &
  &, 0.157173E+01_JPRB, 0.160346E+01_JPRB, 0.163506E+01_JPRB, 0.166653E+01_JPRB &
  &, 0.169784E+01_JPRB, 0.172897E+01_JPRB, 0.175992E+01_JPRB &
  &, 0.179065E+01_JPRB, 0.182116E+01_JPRB, 0.185142E+01_JPRB, 0.188142E+01_JPRB &
  &, 0.191115E+01_JPRB, 0.194058E+01_JPRB, 0.196971E+01_JPRB &
  &, 0.199850E+01_JPRB, 0.202696E+01_JPRB, 0.205506E+01_JPRB, 0.208279E+01_JPRB &
  &, 0.211014E+01_JPRB, 0.213709E+01_JPRB, 0.216362E+01_JPRB &
  &, 0.218973E+01_JPRB, 0.221540E+01_JPRB, 0.224062E+01_JPRB, 0.226538E+01_JPRB &
  &, 0.228966E+01_JPRB, 0.231345E+01_JPRB, 0.233674E+01_JPRB &
  &, 0.235953E+01_JPRB, 0.238180E+01_JPRB, 0.240354E+01_JPRB, 0.242475E+01_JPRB &
  &, 0.244541E+01_JPRB, 0.246553E+01_JPRB, 0.248507E+01_JPRB &
  &, 0.250406E+01_JPRB, 0.252246E+01_JPRB, 0.254029E+01_JPRB, 0.255753E+01_JPRB &
  &, 0.257418E+01_JPRB, 0.259024E+01_JPRB, 0.260569E+01_JPRB &
  &, 0.262054E+01_JPRB, 0.263478E+01_JPRB, 0.264841E+01_JPRB, 0.266142E+01_JPRB &
  &, 0.267384E+01_JPRB, 0.268561E+01_JPRB, 0.269677E+01_JPRB &
  &, 0.270732E+01_JPRB, 0.271723E+01_JPRB, 0.272654E+01_JPRB, 0.273521E+01_JPRB &
  &, 0.274326E+01_JPRB, 0.275069E+01_JPRB, 0.275751E+01_JPRB &
  &, 0.276369E+01_JPRB, 0.276926E+01_JPRB, 0.277423E+01_JPRB, 0.277857E+01_JPRB &
  &, 0.278228E+01_JPRB, 0.278545E+01_JPRB, 0.278796E+01_JPRB &
  &, 0.278988E+01_JPRB, 0.279122E+01_JPRB, 0.279195E+01_JPRB, 0.279208E+01_JPRB &
  &, 0.279165E+01_JPRB, 0.279063E+01_JPRB, 0.278901E+01_JPRB &
  &, 0.278685E+01_JPRB, 0.278392E+01_JPRB, 0.278084E+01_JPRB, 0.277698E+01_JPRB &
  &, 0.277260E+01_JPRB, 0.276767E+01_JPRB, 0.276221E+01_JPRB &
  &, 0.275622E+01_JPRB, 0.274971E+01_JPRB, 0.274268E+01_JPRB, 0.273516E+01_JPRB &
  &, 0.272712E+01_JPRB, 0.271858E+01_JPRB, 0.270959E+01_JPRB &
  &, 0.270011E+01_JPRB, 0.269015E+01_JPRB, 0.267973E+01_JPRB, 0.266886E+01_JPRB &
  &, 0.265753E+01_JPRB, 0.264579E+01_JPRB, 0.263360E+01_JPRB &
  &, 0.262100E+01_JPRB, 0.260801E+01_JPRB, 0.259462E+01_JPRB, 0.258079E+01_JPRB &
  &, 0.256660E+01_JPRB, 0.255204E+01_JPRB, 0.253711E+01_JPRB &
  &, 0.252181E+01_JPRB, 0.250621E+01_JPRB, 0.249023E+01_JPRB, 0.247390E+01_JPRB &
  &, 0.245729E+01_JPRB, 0.244034E+01_JPRB, 0.242311E+01_JPRB &
  &, 0.240558E+01_JPRB, 0.238777E+01_JPRB, 0.236966E+01_JPRB, 0.235128E+01_JPRB &
  &, 0.233269E+01_JPRB, 0.231382E+01_JPRB, 0.229470E+01_JPRB &
  &, 0.227535E+01_JPRB, 0.225584E+01_JPRB, 0.223604E+01_JPRB, 0.221608E+01_JPRB &
  &, 0.219594E+01_JPRB, 0.217563E+01_JPRB, 0.215416E+01_JPRB &
  &, 0.213443E+01_JPRB, 0.211360E+01_JPRB, 0.209258E+01_JPRB, 0.207152E+01_JPRB &
  &, 0.205026E+01_JPRB, 0.202889E+01_JPRB, 0.200742E+01_JPRB/)
XCW( 892, :) = (/ &
  &  0.112524E+01_JPRB, 0.115697E+01_JPRB, 0.118883E+01_JPRB, 0.122081E+01_JPRB &
  &, 0.125288E+01_JPRB, 0.128503E+01_JPRB, 0.131724E+01_JPRB &
  &, 0.134950E+01_JPRB, 0.138178E+01_JPRB, 0.141407E+01_JPRB, 0.144635E+01_JPRB &
  &, 0.147860E+01_JPRB, 0.151080E+01_JPRB, 0.154294E+01_JPRB &
  &, 0.157500E+01_JPRB, 0.160696E+01_JPRB, 0.163880E+01_JPRB, 0.167050E+01_JPRB &
  &, 0.170205E+01_JPRB, 0.173343E+01_JPRB, 0.176462E+01_JPRB &
  &, 0.179561E+01_JPRB, 0.182638E+01_JPRB, 0.185690E+01_JPRB, 0.188717E+01_JPRB &
  &, 0.191717E+01_JPRB, 0.194687E+01_JPRB, 0.197627E+01_JPRB &
  &, 0.200535E+01_JPRB, 0.203410E+01_JPRB, 0.206249E+01_JPRB, 0.209051E+01_JPRB &
  &, 0.211815E+01_JPRB, 0.214540E+01_JPRB, 0.217223E+01_JPRB &
  &, 0.219864E+01_JPRB, 0.222462E+01_JPRB, 0.225014E+01_JPRB, 0.227521E+01_JPRB &
  &, 0.229980E+01_JPRB, 0.232391E+01_JPRB, 0.234752E+01_JPRB &
  &, 0.237064E+01_JPRB, 0.239322E+01_JPRB, 0.241529E+01_JPRB, 0.243683E+01_JPRB &
  &, 0.245781E+01_JPRB, 0.247825E+01_JPRB, 0.249813E+01_JPRB &
  &, 0.251744E+01_JPRB, 0.253618E+01_JPRB, 0.255435E+01_JPRB, 0.257193E+01_JPRB &
  &, 0.258890E+01_JPRB, 0.260530E+01_JPRB, 0.262109E+01_JPRB &
  &, 0.263629E+01_JPRB, 0.265086E+01_JPRB, 0.266483E+01_JPRB, 0.267819E+01_JPRB &
  &, 0.269092E+01_JPRB, 0.270304E+01_JPRB, 0.271454E+01_JPRB &
  &, 0.272542E+01_JPRB, 0.273567E+01_JPRB, 0.274530E+01_JPRB, 0.275431E+01_JPRB &
  &, 0.276270E+01_JPRB, 0.277047E+01_JPRB, 0.277760E+01_JPRB &
  &, 0.278413E+01_JPRB, 0.279002E+01_JPRB, 0.279531E+01_JPRB, 0.279998E+01_JPRB &
  &, 0.280403E+01_JPRB, 0.280749E+01_JPRB, 0.281032E+01_JPRB &
  &, 0.281257E+01_JPRB, 0.281422E+01_JPRB, 0.281525E+01_JPRB, 0.281569E+01_JPRB &
  &, 0.281556E+01_JPRB, 0.281484E+01_JPRB, 0.281355E+01_JPRB &
  &, 0.281167E+01_JPRB, 0.280923E+01_JPRB, 0.280625E+01_JPRB, 0.280269E+01_JPRB &
  &, 0.279857E+01_JPRB, 0.279394E+01_JPRB, 0.278874E+01_JPRB &
  &, 0.278301E+01_JPRB, 0.277676E+01_JPRB, 0.277001E+01_JPRB, 0.276274E+01_JPRB &
  &, 0.275495E+01_JPRB, 0.274669E+01_JPRB, 0.273794E+01_JPRB &
  &, 0.272869E+01_JPRB, 0.271896E+01_JPRB, 0.270878E+01_JPRB, 0.269813E+01_JPRB &
  &, 0.268707E+01_JPRB, 0.267554E+01_JPRB, 0.266357E+01_JPRB &
  &, 0.265118E+01_JPRB, 0.263835E+01_JPRB, 0.262515E+01_JPRB, 0.261152E+01_JPRB &
  &, 0.259752E+01_JPRB, 0.258314E+01_JPRB, 0.256839E+01_JPRB &
  &, 0.255327E+01_JPRB, 0.253779E+01_JPRB, 0.252197E+01_JPRB, 0.250584E+01_JPRB &
  &, 0.248934E+01_JPRB, 0.247253E+01_JPRB, 0.245543E+01_JPRB &
  &, 0.243803E+01_JPRB, 0.241873E+01_JPRB, 0.240236E+01_JPRB, 0.238409E+01_JPRB &
  &, 0.236555E+01_JPRB, 0.234679E+01_JPRB, 0.232781E+01_JPRB &
  &, 0.230854E+01_JPRB, 0.228905E+01_JPRB, 0.226938E+01_JPRB, 0.224948E+01_JPRB &
  &, 0.222939E+01_JPRB, 0.220913E+01_JPRB, 0.218860E+01_JPRB &
  &, 0.216800E+01_JPRB, 0.214719E+01_JPRB, 0.212625E+01_JPRB, 0.210513E+01_JPRB &
  &, 0.208394E+01_JPRB, 0.206255E+01_JPRB, 0.204106E+01_JPRB/)
XCW( 893, :) = (/ &
  &  0.112583E+01_JPRB, 0.115772E+01_JPRB, 0.118974E+01_JPRB, 0.122189E+01_JPRB &
  &, 0.125414E+01_JPRB, 0.128647E+01_JPRB, 0.131887E+01_JPRB &
  &, 0.135132E+01_JPRB, 0.138379E+01_JPRB, 0.141628E+01_JPRB, 0.144877E+01_JPRB &
  &, 0.148123E+01_JPRB, 0.151365E+01_JPRB, 0.154601E+01_JPRB &
  &, 0.157829E+01_JPRB, 0.161048E+01_JPRB, 0.164256E+01_JPRB, 0.167450E+01_JPRB &
  &, 0.170630E+01_JPRB, 0.173793E+01_JPRB, 0.176937E+01_JPRB &
  &, 0.180062E+01_JPRB, 0.183164E+01_JPRB, 0.186243E+01_JPRB, 0.189297E+01_JPRB &
  &, 0.192324E+01_JPRB, 0.195322E+01_JPRB, 0.198290E+01_JPRB &
  &, 0.201227E+01_JPRB, 0.204130E+01_JPRB, 0.206998E+01_JPRB, 0.209830E+01_JPRB &
  &, 0.212624E+01_JPRB, 0.215378E+01_JPRB, 0.218092E+01_JPRB &
  &, 0.220764E+01_JPRB, 0.223392E+01_JPRB, 0.225976E+01_JPRB, 0.228514E+01_JPRB &
  &, 0.231005E+01_JPRB, 0.233448E+01_JPRB, 0.235841E+01_JPRB &
  &, 0.238184E+01_JPRB, 0.240476E+01_JPRB, 0.242716E+01_JPRB, 0.244901E+01_JPRB &
  &, 0.247034E+01_JPRB, 0.249110E+01_JPRB, 0.251133E+01_JPRB &
  &, 0.253095E+01_JPRB, 0.255005E+01_JPRB, 0.256855E+01_JPRB, 0.258647E+01_JPRB &
  &, 0.260379E+01_JPRB, 0.262052E+01_JPRB, 0.263663E+01_JPRB &
  &, 0.265219E+01_JPRB, 0.266710E+01_JPRB, 0.268141E+01_JPRB, 0.269511E+01_JPRB &
  &, 0.270818E+01_JPRB, 0.272064E+01_JPRB, 0.273248E+01_JPRB &
  &, 0.274371E+01_JPRB, 0.275431E+01_JPRB, 0.276413E+01_JPRB, 0.277362E+01_JPRB &
  &, 0.278235E+01_JPRB, 0.279044E+01_JPRB, 0.279792E+01_JPRB &
  &, 0.280477E+01_JPRB, 0.281101E+01_JPRB, 0.281663E+01_JPRB, 0.282163E+01_JPRB &
  &, 0.282602E+01_JPRB, 0.282978E+01_JPRB, 0.283295E+01_JPRB &
  &, 0.283550E+01_JPRB, 0.283746E+01_JPRB, 0.283883E+01_JPRB, 0.283960E+01_JPRB &
  &, 0.283976E+01_JPRB, 0.283937E+01_JPRB, 0.283836E+01_JPRB &
  &, 0.283678E+01_JPRB, 0.283465E+01_JPRB, 0.283195E+01_JPRB, 0.282869E+01_JPRB &
  &, 0.282488E+01_JPRB, 0.282051E+01_JPRB, 0.281558E+01_JPRB &
  &, 0.281015E+01_JPRB, 0.280419E+01_JPRB, 0.279770E+01_JPRB, 0.279069E+01_JPRB &
  &, 0.278319E+01_JPRB, 0.277514E+01_JPRB, 0.276664E+01_JPRB &
  &, 0.275752E+01_JPRB, 0.274818E+01_JPRB, 0.273824E+01_JPRB, 0.272782E+01_JPRB &
  &, 0.271637E+01_JPRB, 0.270568E+01_JPRB, 0.269393E+01_JPRB &
  &, 0.268175E+01_JPRB, 0.266914E+01_JPRB, 0.265614E+01_JPRB, 0.264271E+01_JPRB &
  &, 0.262891E+01_JPRB, 0.261472E+01_JPRB, 0.260012E+01_JPRB &
  &, 0.258517E+01_JPRB, 0.256986E+01_JPRB, 0.255421E+01_JPRB, 0.253816E+01_JPRB &
  &, 0.252191E+01_JPRB, 0.250525E+01_JPRB, 0.248825E+01_JPRB &
  &, 0.247099E+01_JPRB, 0.245344E+01_JPRB, 0.243558E+01_JPRB, 0.241742E+01_JPRB &
  &, 0.239900E+01_JPRB, 0.238034E+01_JPRB, 0.236140E+01_JPRB &
  &, 0.234228E+01_JPRB, 0.232288E+01_JPRB, 0.230328E+01_JPRB, 0.228340E+01_JPRB &
  &, 0.226337E+01_JPRB, 0.224316E+01_JPRB, 0.222274E+01_JPRB &
  &, 0.220212E+01_JPRB, 0.218140E+01_JPRB, 0.216048E+01_JPRB, 0.213938E+01_JPRB &
  &, 0.211819E+01_JPRB, 0.209680E+01_JPRB, 0.207536E+01_JPRB/)
XCW( 894, :) = (/ &
  &  0.112642E+01_JPRB, 0.115846E+01_JPRB, 0.119066E+01_JPRB, 0.122298E+01_JPRB &
  &, 0.125540E+01_JPRB, 0.128792E+01_JPRB, 0.132051E+01_JPRB &
  &, 0.135315E+01_JPRB, 0.138582E+01_JPRB, 0.141852E+01_JPRB, 0.145121E+01_JPRB &
  &, 0.148388E+01_JPRB, 0.151652E+01_JPRB, 0.154911E+01_JPRB &
  &, 0.158162E+01_JPRB, 0.161404E+01_JPRB, 0.164635E+01_JPRB, 0.167854E+01_JPRB &
  &, 0.171058E+01_JPRB, 0.174246E+01_JPRB, 0.177416E+01_JPRB &
  &, 0.180566E+01_JPRB, 0.183695E+01_JPRB, 0.186801E+01_JPRB, 0.189882E+01_JPRB &
  &, 0.192936E+01_JPRB, 0.195963E+01_JPRB, 0.198959E+01_JPRB &
  &, 0.201924E+01_JPRB, 0.204856E+01_JPRB, 0.207754E+01_JPRB, 0.210615E+01_JPRB &
  &, 0.213439E+01_JPRB, 0.216224E+01_JPRB, 0.218969E+01_JPRB &
  &, 0.221671E+01_JPRB, 0.224331E+01_JPRB, 0.226947E+01_JPRB, 0.229517E+01_JPRB &
  &, 0.232039E+01_JPRB, 0.234515E+01_JPRB, 0.236941E+01_JPRB &
  &, 0.239316E+01_JPRB, 0.241641E+01_JPRB, 0.243913E+01_JPRB, 0.246133E+01_JPRB &
  &, 0.248298E+01_JPRB, 0.250410E+01_JPRB, 0.252455E+01_JPRB &
  &, 0.254463E+01_JPRB, 0.256406E+01_JPRB, 0.258290E+01_JPRB, 0.260115E+01_JPRB &
  &, 0.261882E+01_JPRB, 0.263589E+01_JPRB, 0.265238E+01_JPRB &
  &, 0.266826E+01_JPRB, 0.268352E+01_JPRB, 0.269817E+01_JPRB, 0.271221E+01_JPRB &
  &, 0.272565E+01_JPRB, 0.273844E+01_JPRB, 0.275062E+01_JPRB &
  &, 0.276220E+01_JPRB, 0.277313E+01_JPRB, 0.278345E+01_JPRB, 0.279315E+01_JPRB &
  &, 0.280222E+01_JPRB, 0.281066E+01_JPRB, 0.281847E+01_JPRB &
  &, 0.282567E+01_JPRB, 0.283224E+01_JPRB, 0.283820E+01_JPRB, 0.284353E+01_JPRB &
  &, 0.284823E+01_JPRB, 0.285235E+01_JPRB, 0.285583E+01_JPRB &
  &, 0.285873E+01_JPRB, 0.286100E+01_JPRB, 0.286269E+01_JPRB, 0.286377E+01_JPRB &
  &, 0.286427E+01_JPRB, 0.286417E+01_JPRB, 0.286347E+01_JPRB &
  &, 0.286224E+01_JPRB, 0.286039E+01_JPRB, 0.285799E+01_JPRB, 0.285502E+01_JPRB &
  &, 0.285151E+01_JPRB, 0.284742E+01_JPRB, 0.284280E+01_JPRB &
  &, 0.283766E+01_JPRB, 0.283198E+01_JPRB, 0.282575E+01_JPRB, 0.281900E+01_JPRB &
  &, 0.281176E+01_JPRB, 0.280400E+01_JPRB, 0.279576E+01_JPRB &
  &, 0.278700E+01_JPRB, 0.277780E+01_JPRB, 0.276810E+01_JPRB, 0.275792E+01_JPRB &
  &, 0.274728E+01_JPRB, 0.273620E+01_JPRB, 0.272468E+01_JPRB &
  &, 0.271273E+01_JPRB, 0.270037E+01_JPRB, 0.268755E+01_JPRB, 0.267433E+01_JPRB &
  &, 0.266073E+01_JPRB, 0.264673E+01_JPRB, 0.263233E+01_JPRB &
  &, 0.261757E+01_JPRB, 0.260244E+01_JPRB, 0.258697E+01_JPRB, 0.257113E+01_JPRB &
  &, 0.255495E+01_JPRB, 0.253845E+01_JPRB, 0.252161E+01_JPRB &
  &, 0.250449E+01_JPRB, 0.248703E+01_JPRB, 0.246930E+01_JPRB, 0.245127E+01_JPRB &
  &, 0.243297E+01_JPRB, 0.241442E+01_JPRB, 0.239560E+01_JPRB &
  &, 0.237652E+01_JPRB, 0.235721E+01_JPRB, 0.233770E+01_JPRB, 0.231795E+01_JPRB &
  &, 0.229799E+01_JPRB, 0.227778E+01_JPRB, 0.225741E+01_JPRB &
  &, 0.223690E+01_JPRB, 0.221616E+01_JPRB, 0.219527E+01_JPRB, 0.217425E+01_JPRB &
  &, 0.215301E+01_JPRB, 0.213169E+01_JPRB, 0.211026E+01_JPRB/)
XCW( 895, :) = (/ &
  &  0.112701E+01_JPRB, 0.115922E+01_JPRB, 0.119158E+01_JPRB, 0.122408E+01_JPRB &
  &, 0.125668E+01_JPRB, 0.128938E+01_JPRB, 0.132216E+01_JPRB &
  &, 0.135499E+01_JPRB, 0.138787E+01_JPRB, 0.142077E+01_JPRB, 0.145367E+01_JPRB &
  &, 0.148656E+01_JPRB, 0.151942E+01_JPRB, 0.155223E+01_JPRB &
  &, 0.158497E+01_JPRB, 0.161762E+01_JPRB, 0.165018E+01_JPRB, 0.168261E+01_JPRB &
  &, 0.171490E+01_JPRB, 0.174703E+01_JPRB, 0.177899E+01_JPRB &
  &, 0.181075E+01_JPRB, 0.184231E+01_JPRB, 0.187364E+01_JPRB, 0.190472E+01_JPRB &
  &, 0.193554E+01_JPRB, 0.196609E+01_JPRB, 0.199634E+01_JPRB &
  &, 0.202628E+01_JPRB, 0.205590E+01_JPRB, 0.208517E+01_JPRB, 0.211408E+01_JPRB &
  &, 0.214262E+01_JPRB, 0.217078E+01_JPRB, 0.219854E+01_JPRB &
  &, 0.222587E+01_JPRB, 0.225279E+01_JPRB, 0.227926E+01_JPRB, 0.230528E+01_JPRB &
  &, 0.233083E+01_JPRB, 0.235592E+01_JPRB, 0.238050E+01_JPRB &
  &, 0.240459E+01_JPRB, 0.242817E+01_JPRB, 0.245123E+01_JPRB, 0.247377E+01_JPRB &
  &, 0.249577E+01_JPRB, 0.251721E+01_JPRB, 0.253811E+01_JPRB &
  &, 0.255844E+01_JPRB, 0.257820E+01_JPRB, 0.259738E+01_JPRB, 0.261600E+01_JPRB &
  &, 0.263402E+01_JPRB, 0.265144E+01_JPRB, 0.266826E+01_JPRB &
  &, 0.268437E+01_JPRB, 0.270010E+01_JPRB, 0.271511E+01_JPRB, 0.272950E+01_JPRB &
  &, 0.274328E+01_JPRB, 0.275644E+01_JPRB, 0.276898E+01_JPRB &
  &, 0.278089E+01_JPRB, 0.279218E+01_JPRB, 0.280284E+01_JPRB, 0.281289E+01_JPRB &
  &, 0.282231E+01_JPRB, 0.283110E+01_JPRB, 0.283924E+01_JPRB &
  &, 0.284680E+01_JPRB, 0.285371E+01_JPRB, 0.286000E+01_JPRB, 0.286568E+01_JPRB &
  &, 0.287074E+01_JPRB, 0.287518E+01_JPRB, 0.287901E+01_JPRB &
  &, 0.288222E+01_JPRB, 0.288482E+01_JPRB, 0.288685E+01_JPRB, 0.288825E+01_JPRB &
  &, 0.288907E+01_JPRB, 0.288929E+01_JPRB, 0.288891E+01_JPRB &
  &, 0.288797E+01_JPRB, 0.288646E+01_JPRB, 0.288436E+01_JPRB, 0.288170E+01_JPRB &
  &, 0.287847E+01_JPRB, 0.287470E+01_JPRB, 0.287039E+01_JPRB &
  &, 0.286550E+01_JPRB, 0.286008E+01_JPRB, 0.285416E+01_JPRB, 0.284772E+01_JPRB &
  &, 0.284074E+01_JPRB, 0.283325E+01_JPRB, 0.282526E+01_JPRB &
  &, 0.281677E+01_JPRB, 0.280782E+01_JPRB, 0.279837E+01_JPRB, 0.278843E+01_JPRB &
  &, 0.277803E+01_JPRB, 0.276720E+01_JPRB, 0.275591E+01_JPRB &
  &, 0.274419E+01_JPRB, 0.273201E+01_JPRB, 0.271945E+01_JPRB, 0.270645E+01_JPRB &
  &, 0.269302E+01_JPRB, 0.267888E+01_JPRB, 0.266502E+01_JPRB &
  &, 0.265046E+01_JPRB, 0.263548E+01_JPRB, 0.262019E+01_JPRB, 0.260453E+01_JPRB &
  &, 0.258852E+01_JPRB, 0.257214E+01_JPRB, 0.255545E+01_JPRB &
  &, 0.253849E+01_JPRB, 0.252118E+01_JPRB, 0.250359E+01_JPRB, 0.248570E+01_JPRB &
  &, 0.246748E+01_JPRB, 0.244905E+01_JPRB, 0.243034E+01_JPRB &
  &, 0.241136E+01_JPRB, 0.239215E+01_JPRB, 0.237273E+01_JPRB, 0.235301E+01_JPRB &
  &, 0.233313E+01_JPRB, 0.231305E+01_JPRB, 0.229275E+01_JPRB &
  &, 0.227223E+01_JPRB, 0.225160E+01_JPRB, 0.223075E+01_JPRB, 0.220970E+01_JPRB &
  &, 0.218854E+01_JPRB, 0.216724E+01_JPRB, 0.214574E+01_JPRB/)
XCW( 896, :) = (/ &
  &  0.112761E+01_JPRB, 0.115998E+01_JPRB, 0.119251E+01_JPRB, 0.122518E+01_JPRB &
  &, 0.125797E+01_JPRB, 0.129085E+01_JPRB, 0.132382E+01_JPRB &
  &, 0.135685E+01_JPRB, 0.138993E+01_JPRB, 0.142303E+01_JPRB, 0.145615E+01_JPRB &
  &, 0.148926E+01_JPRB, 0.152234E+01_JPRB, 0.155537E+01_JPRB &
  &, 0.158835E+01_JPRB, 0.162123E+01_JPRB, 0.165403E+01_JPRB, 0.168671E+01_JPRB &
  &, 0.171925E+01_JPRB, 0.175164E+01_JPRB, 0.178386E+01_JPRB &
  &, 0.181589E+01_JPRB, 0.184771E+01_JPRB, 0.187931E+01_JPRB, 0.191068E+01_JPRB &
  &, 0.194178E+01_JPRB, 0.197261E+01_JPRB, 0.200315E+01_JPRB &
  &, 0.203338E+01_JPRB, 0.206329E+01_JPRB, 0.209287E+01_JPRB, 0.212208E+01_JPRB &
  &, 0.215093E+01_JPRB, 0.217940E+01_JPRB, 0.220747E+01_JPRB &
  &, 0.223513E+01_JPRB, 0.226236E+01_JPRB, 0.228916E+01_JPRB, 0.231550E+01_JPRB &
  &, 0.234138E+01_JPRB, 0.236679E+01_JPRB, 0.239172E+01_JPRB &
  &, 0.241614E+01_JPRB, 0.244006E+01_JPRB, 0.246346E+01_JPRB, 0.248633E+01_JPRB &
  &, 0.250867E+01_JPRB, 0.253047E+01_JPRB, 0.255171E+01_JPRB &
  &, 0.257238E+01_JPRB, 0.259250E+01_JPRB, 0.261204E+01_JPRB, 0.263099E+01_JPRB &
  &, 0.264937E+01_JPRB, 0.266714E+01_JPRB, 0.268430E+01_JPRB &
  &, 0.270091E+01_JPRB, 0.271688E+01_JPRB, 0.273224E+01_JPRB, 0.274698E+01_JPRB &
  &, 0.276113E+01_JPRB, 0.277463E+01_JPRB, 0.278753E+01_JPRB &
  &, 0.279980E+01_JPRB, 0.281144E+01_JPRB, 0.282246E+01_JPRB, 0.283286E+01_JPRB &
  &, 0.284261E+01_JPRB, 0.285176E+01_JPRB, 0.286029E+01_JPRB &
  &, 0.286816E+01_JPRB, 0.287544E+01_JPRB, 0.288207E+01_JPRB, 0.288809E+01_JPRB &
  &, 0.289348E+01_JPRB, 0.289827E+01_JPRB, 0.290245E+01_JPRB &
  &, 0.290599E+01_JPRB, 0.290896E+01_JPRB, 0.291129E+01_JPRB, 0.291302E+01_JPRB &
  &, 0.291416E+01_JPRB, 0.291470E+01_JPRB, 0.291468E+01_JPRB &
  &, 0.291406E+01_JPRB, 0.291285E+01_JPRB, 0.291107E+01_JPRB, 0.290870E+01_JPRB &
  &, 0.290580E+01_JPRB, 0.290231E+01_JPRB, 0.289828E+01_JPRB &
  &, 0.289371E+01_JPRB, 0.288861E+01_JPRB, 0.288297E+01_JPRB, 0.287677E+01_JPRB &
  &, 0.287007E+01_JPRB, 0.286288E+01_JPRB, 0.285516E+01_JPRB &
  &, 0.284682E+01_JPRB, 0.283824E+01_JPRB, 0.282904E+01_JPRB, 0.281936E+01_JPRB &
  &, 0.280925E+01_JPRB, 0.279862E+01_JPRB, 0.278757E+01_JPRB &
  &, 0.277609E+01_JPRB, 0.276414E+01_JPRB, 0.275177E+01_JPRB, 0.273899E+01_JPRB &
  &, 0.272578E+01_JPRB, 0.271220E+01_JPRB, 0.269820E+01_JPRB &
  &, 0.268380E+01_JPRB, 0.266906E+01_JPRB, 0.265392E+01_JPRB, 0.263840E+01_JPRB &
  &, 0.262257E+01_JPRB, 0.260641E+01_JPRB, 0.258989E+01_JPRB &
  &, 0.257304E+01_JPRB, 0.255589E+01_JPRB, 0.253840E+01_JPRB, 0.252065E+01_JPRB &
  &, 0.250261E+01_JPRB, 0.248426E+01_JPRB, 0.246567E+01_JPRB &
  &, 0.244681E+01_JPRB, 0.242771E+01_JPRB, 0.240834E+01_JPRB, 0.238877E+01_JPRB &
  &, 0.236892E+01_JPRB, 0.234892E+01_JPRB, 0.232868E+01_JPRB &
  &, 0.230823E+01_JPRB, 0.228759E+01_JPRB, 0.226679E+01_JPRB, 0.224584E+01_JPRB &
  &, 0.222471E+01_JPRB, 0.220343E+01_JPRB, 0.218195E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART128',1,ZHOOK_HANDLE)
END SUBROUTINE PART128

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART129

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART129',0,ZHOOK_HANDLE)

XCW( 897, :) = (/ &
  &  0.112821E+01_JPRB, 0.116075E+01_JPRB, 0.119345E+01_JPRB, 0.122629E+01_JPRB &
  &, 0.125926E+01_JPRB, 0.129233E+01_JPRB, 0.132549E+01_JPRB &
  &, 0.135872E+01_JPRB, 0.139200E+01_JPRB, 0.142532E+01_JPRB, 0.145865E+01_JPRB &
  &, 0.149197E+01_JPRB, 0.152528E+01_JPRB, 0.155854E+01_JPRB &
  &, 0.159175E+01_JPRB, 0.162488E+01_JPRB, 0.165787E+01_JPRB, 0.169085E+01_JPRB &
  &, 0.172364E+01_JPRB, 0.175629E+01_JPRB, 0.178877E+01_JPRB &
  &, 0.182107E+01_JPRB, 0.185316E+01_JPRB, 0.188504E+01_JPRB, 0.191668E+01_JPRB &
  &, 0.194807E+01_JPRB, 0.197919E+01_JPRB, 0.201002E+01_JPRB &
  &, 0.204055E+01_JPRB, 0.207076E+01_JPRB, 0.210064E+01_JPRB, 0.213016E+01_JPRB &
  &, 0.215932E+01_JPRB, 0.218810E+01_JPRB, 0.221649E+01_JPRB &
  &, 0.224447E+01_JPRB, 0.227202E+01_JPRB, 0.229914E+01_JPRB, 0.232581E+01_JPRB &
  &, 0.235203E+01_JPRB, 0.237777E+01_JPRB, 0.240303E+01_JPRB &
  &, 0.242779E+01_JPRB, 0.245206E+01_JPRB, 0.247571E+01_JPRB, 0.249902E+01_JPRB &
  &, 0.252171E+01_JPRB, 0.254385E+01_JPRB, 0.256544E+01_JPRB &
  &, 0.258645E+01_JPRB, 0.260694E+01_JPRB, 0.262684E+01_JPRB, 0.264614E+01_JPRB &
  &, 0.266487E+01_JPRB, 0.268301E+01_JPRB, 0.270053E+01_JPRB &
  &, 0.271749E+01_JPRB, 0.273382E+01_JPRB, 0.274955E+01_JPRB, 0.276466E+01_JPRB &
  &, 0.277915E+01_JPRB, 0.279304E+01_JPRB, 0.280625E+01_JPRB &
  &, 0.281891E+01_JPRB, 0.283091E+01_JPRB, 0.284229E+01_JPRB, 0.285304E+01_JPRB &
  &, 0.286318E+01_JPRB, 0.287267E+01_JPRB, 0.288151E+01_JPRB &
  &, 0.288978E+01_JPRB, 0.289740E+01_JPRB, 0.290441E+01_JPRB, 0.291078E+01_JPRB &
  &, 0.291652E+01_JPRB, 0.292157E+01_JPRB, 0.292617E+01_JPRB &
  &, 0.293007E+01_JPRB, 0.293334E+01_JPRB, 0.293603E+01_JPRB, 0.293812E+01_JPRB &
  &, 0.293960E+01_JPRB, 0.294047E+01_JPRB, 0.294075E+01_JPRB &
  &, 0.294046E+01_JPRB, 0.293955E+01_JPRB, 0.293810E+01_JPRB, 0.293606E+01_JPRB &
  &, 0.293345E+01_JPRB, 0.293029E+01_JPRB, 0.292659E+01_JPRB &
  &, 0.292231E+01_JPRB, 0.291749E+01_JPRB, 0.291214E+01_JPRB, 0.290625E+01_JPRB &
  &, 0.289983E+01_JPRB, 0.289292E+01_JPRB, 0.288547E+01_JPRB &
  &, 0.287751E+01_JPRB, 0.286909E+01_JPRB, 0.286016E+01_JPRB, 0.285074E+01_JPRB &
  &, 0.284085E+01_JPRB, 0.283051E+01_JPRB, 0.281971E+01_JPRB &
  &, 0.280843E+01_JPRB, 0.279673E+01_JPRB, 0.278459E+01_JPRB, 0.277204E+01_JPRB &
  &, 0.275905E+01_JPRB, 0.274565E+01_JPRB, 0.273187E+01_JPRB &
  &, 0.271767E+01_JPRB, 0.270309E+01_JPRB, 0.268815E+01_JPRB, 0.267283E+01_JPRB &
  &, 0.265719E+01_JPRB, 0.264116E+01_JPRB, 0.262482E+01_JPRB &
  &, 0.260814E+01_JPRB, 0.259110E+01_JPRB, 0.257382E+01_JPRB, 0.255617E+01_JPRB &
  &, 0.253828E+01_JPRB, 0.252006E+01_JPRB, 0.250155E+01_JPRB &
  &, 0.248282E+01_JPRB, 0.246383E+01_JPRB, 0.244457E+01_JPRB, 0.242504E+01_JPRB &
  &, 0.240534E+01_JPRB, 0.238537E+01_JPRB, 0.236522E+01_JPRB &
  &, 0.234484E+01_JPRB, 0.232426E+01_JPRB, 0.230351E+01_JPRB, 0.228261E+01_JPRB &
  &, 0.226146E+01_JPRB, 0.224021E+01_JPRB, 0.221881E+01_JPRB/)
XCW( 898, :) = (/ &
  &  0.112882E+01_JPRB, 0.116152E+01_JPRB, 0.119440E+01_JPRB, 0.122742E+01_JPRB &
  &, 0.126057E+01_JPRB, 0.129383E+01_JPRB, 0.132718E+01_JPRB &
  &, 0.136061E+01_JPRB, 0.139410E+01_JPRB, 0.142762E+01_JPRB, 0.146117E+01_JPRB &
  &, 0.149472E+01_JPRB, 0.152825E+01_JPRB, 0.156174E+01_JPRB &
  &, 0.159519E+01_JPRB, 0.162856E+01_JPRB, 0.166184E+01_JPRB, 0.169502E+01_JPRB &
  &, 0.172807E+01_JPRB, 0.176098E+01_JPRB, 0.179373E+01_JPRB &
  &, 0.182629E+01_JPRB, 0.185866E+01_JPRB, 0.189082E+01_JPRB, 0.192274E+01_JPRB &
  &, 0.195442E+01_JPRB, 0.198583E+01_JPRB, 0.201695E+01_JPRB &
  &, 0.204778E+01_JPRB, 0.207830E+01_JPRB, 0.210848E+01_JPRB, 0.213831E+01_JPRB &
  &, 0.216779E+01_JPRB, 0.219689E+01_JPRB, 0.222559E+01_JPRB &
  &, 0.225389E+01_JPRB, 0.228178E+01_JPRB, 0.230923E+01_JPRB, 0.233624E+01_JPRB &
  &, 0.236279E+01_JPRB, 0.238887E+01_JPRB, 0.241447E+01_JPRB &
  &, 0.243957E+01_JPRB, 0.246418E+01_JPRB, 0.248827E+01_JPRB, 0.251184E+01_JPRB &
  &, 0.253488E+01_JPRB, 0.255737E+01_JPRB, 0.257932E+01_JPRB &
  &, 0.260071E+01_JPRB, 0.262154E+01_JPRB, 0.264180E+01_JPRB, 0.266146E+01_JPRB &
  &, 0.268055E+01_JPRB, 0.269900E+01_JPRB, 0.271696E+01_JPRB &
  &, 0.273426E+01_JPRB, 0.275096E+01_JPRB, 0.276704E+01_JPRB, 0.278253E+01_JPRB &
  &, 0.279739E+01_JPRB, 0.281163E+01_JPRB, 0.282525E+01_JPRB &
  &, 0.283823E+01_JPRB, 0.285061E+01_JPRB, 0.286237E+01_JPRB, 0.287348E+01_JPRB &
  &, 0.288396E+01_JPRB, 0.289382E+01_JPRB, 0.290305E+01_JPRB &
  &, 0.291167E+01_JPRB, 0.291964E+01_JPRB, 0.292700E+01_JPRB, 0.293371E+01_JPRB &
  &, 0.293983E+01_JPRB, 0.294531E+01_JPRB, 0.295018E+01_JPRB &
  &, 0.295441E+01_JPRB, 0.295805E+01_JPRB, 0.296108E+01_JPRB, 0.296350E+01_JPRB &
  &, 0.296532E+01_JPRB, 0.296653E+01_JPRB, 0.296715E+01_JPRB &
  &, 0.296719E+01_JPRB, 0.296662E+01_JPRB, 0.296550E+01_JPRB, 0.296377E+01_JPRB &
  &, 0.296149E+01_JPRB, 0.295863E+01_JPRB, 0.295523E+01_JPRB &
  &, 0.295128E+01_JPRB, 0.294676E+01_JPRB, 0.294170E+01_JPRB, 0.293610E+01_JPRB &
  &, 0.293000E+01_JPRB, 0.292334E+01_JPRB, 0.291621E+01_JPRB &
  &, 0.290853E+01_JPRB, 0.290038E+01_JPRB, 0.289172E+01_JPRB, 0.288257E+01_JPRB &
  &, 0.287294E+01_JPRB, 0.286283E+01_JPRB, 0.285228E+01_JPRB &
  &, 0.284125E+01_JPRB, 0.282980E+01_JPRB, 0.281790E+01_JPRB, 0.280555E+01_JPRB &
  &, 0.279279E+01_JPRB, 0.277963E+01_JPRB, 0.276602E+01_JPRB &
  &, 0.275204E+01_JPRB, 0.273768E+01_JPRB, 0.272294E+01_JPRB, 0.270782E+01_JPRB &
  &, 0.269233E+01_JPRB, 0.267649E+01_JPRB, 0.266029E+01_JPRB &
  &, 0.264379E+01_JPRB, 0.262692E+01_JPRB, 0.260975E+01_JPRB, 0.259226E+01_JPRB &
  &, 0.257452E+01_JPRB, 0.255646E+01_JPRB, 0.253808E+01_JPRB &
  &, 0.251943E+01_JPRB, 0.250057E+01_JPRB, 0.248142E+01_JPRB, 0.246201E+01_JPRB &
  &, 0.244235E+01_JPRB, 0.242248E+01_JPRB, 0.240241E+01_JPRB &
  &, 0.238211E+01_JPRB, 0.236160E+01_JPRB, 0.234092E+01_JPRB, 0.232001E+01_JPRB &
  &, 0.229897E+01_JPRB, 0.227776E+01_JPRB, 0.225640E+01_JPRB/)
XCW( 899, :) = (/ &
  &  0.112943E+01_JPRB, 0.116230E+01_JPRB, 0.119535E+01_JPRB, 0.122855E+01_JPRB &
  &, 0.126188E+01_JPRB, 0.129533E+01_JPRB, 0.132888E+01_JPRB &
  &, 0.136252E+01_JPRB, 0.139621E+01_JPRB, 0.142995E+01_JPRB, 0.146371E+01_JPRB &
  &, 0.149748E+01_JPRB, 0.153124E+01_JPRB, 0.156497E+01_JPRB &
  &, 0.159865E+01_JPRB, 0.163227E+01_JPRB, 0.166580E+01_JPRB, 0.169923E+01_JPRB &
  &, 0.173254E+01_JPRB, 0.176571E+01_JPRB, 0.179873E+01_JPRB &
  &, 0.183157E+01_JPRB, 0.186421E+01_JPRB, 0.189665E+01_JPRB, 0.192886E+01_JPRB &
  &, 0.196082E+01_JPRB, 0.199253E+01_JPRB, 0.202395E+01_JPRB &
  &, 0.205509E+01_JPRB, 0.208590E+01_JPRB, 0.211640E+01_JPRB, 0.214655E+01_JPRB &
  &, 0.217634E+01_JPRB, 0.220576E+01_JPRB, 0.223479E+01_JPRB &
  &, 0.226342E+01_JPRB, 0.229163E+01_JPRB, 0.231941E+01_JPRB, 0.234676E+01_JPRB &
  &, 0.237364E+01_JPRB, 0.240007E+01_JPRB, 0.242602E+01_JPRB &
  &, 0.245147E+01_JPRB, 0.247643E+01_JPRB, 0.250087E+01_JPRB, 0.252479E+01_JPRB &
  &, 0.254819E+01_JPRB, 0.257104E+01_JPRB, 0.259330E+01_JPRB &
  &, 0.261510E+01_JPRB, 0.263629E+01_JPRB, 0.265690E+01_JPRB, 0.267694E+01_JPRB &
  &, 0.269640E+01_JPRB, 0.271528E+01_JPRB, 0.273354E+01_JPRB &
  &, 0.275121E+01_JPRB, 0.276829E+01_JPRB, 0.278475E+01_JPRB, 0.280059E+01_JPRB &
  &, 0.281582E+01_JPRB, 0.283043E+01_JPRB, 0.284443E+01_JPRB &
  &, 0.285780E+01_JPRB, 0.287054E+01_JPRB, 0.288265E+01_JPRB, 0.289411E+01_JPRB &
  &, 0.290500E+01_JPRB, 0.291523E+01_JPRB, 0.292480E+01_JPRB &
  &, 0.293381E+01_JPRB, 0.294214E+01_JPRB, 0.294987E+01_JPRB, 0.295696E+01_JPRB &
  &, 0.296342E+01_JPRB, 0.296924E+01_JPRB, 0.297447E+01_JPRB &
  &, 0.297907E+01_JPRB, 0.298308E+01_JPRB, 0.298645E+01_JPRB, 0.298920E+01_JPRB &
  &, 0.299138E+01_JPRB, 0.299294E+01_JPRB, 0.299390E+01_JPRB &
  &, 0.299426E+01_JPRB, 0.299406E+01_JPRB, 0.299326E+01_JPRB, 0.299186E+01_JPRB &
  &, 0.298990E+01_JPRB, 0.298737E+01_JPRB, 0.298428E+01_JPRB &
  &, 0.298063E+01_JPRB, 0.297642E+01_JPRB, 0.297169E+01_JPRB, 0.296639E+01_JPRB &
  &, 0.296058E+01_JPRB, 0.295421E+01_JPRB, 0.294737E+01_JPRB &
  &, 0.293998E+01_JPRB, 0.293182E+01_JPRB, 0.292373E+01_JPRB, 0.291485E+01_JPRB &
  &, 0.290546E+01_JPRB, 0.289565E+01_JPRB, 0.288533E+01_JPRB &
  &, 0.287456E+01_JPRB, 0.286336E+01_JPRB, 0.285167E+01_JPRB, 0.283956E+01_JPRB &
  &, 0.282705E+01_JPRB, 0.281412E+01_JPRB, 0.280075E+01_JPRB &
  &, 0.278695E+01_JPRB, 0.277281E+01_JPRB, 0.275824E+01_JPRB, 0.274333E+01_JPRB &
  &, 0.272804E+01_JPRB, 0.271236E+01_JPRB, 0.269635E+01_JPRB &
  &, 0.268004E+01_JPRB, 0.266335E+01_JPRB, 0.264630E+01_JPRB, 0.262898E+01_JPRB &
  &, 0.261135E+01_JPRB, 0.259344E+01_JPRB, 0.257516E+01_JPRB &
  &, 0.255670E+01_JPRB, 0.253792E+01_JPRB, 0.251884E+01_JPRB, 0.249955E+01_JPRB &
  &, 0.248000E+01_JPRB, 0.246023E+01_JPRB, 0.244026E+01_JPRB &
  &, 0.241999E+01_JPRB, 0.239957E+01_JPRB, 0.237895E+01_JPRB, 0.235811E+01_JPRB &
  &, 0.233713E+01_JPRB, 0.231596E+01_JPRB, 0.229458E+01_JPRB/)
XCW( 900, :) = (/ &
  &  0.113004E+01_JPRB, 0.116309E+01_JPRB, 0.119631E+01_JPRB, 0.122969E+01_JPRB &
  &, 0.126321E+01_JPRB, 0.129685E+01_JPRB, 0.133060E+01_JPRB &
  &, 0.136443E+01_JPRB, 0.139834E+01_JPRB, 0.143229E+01_JPRB, 0.146627E+01_JPRB &
  &, 0.150027E+01_JPRB, 0.153426E+01_JPRB, 0.156822E+01_JPRB &
  &, 0.160215E+01_JPRB, 0.163601E+01_JPRB, 0.166979E+01_JPRB, 0.170348E+01_JPRB &
  &, 0.173705E+01_JPRB, 0.177049E+01_JPRB, 0.180377E+01_JPRB &
  &, 0.183689E+01_JPRB, 0.186982E+01_JPRB, 0.190254E+01_JPRB, 0.193503E+01_JPRB &
  &, 0.196729E+01_JPRB, 0.199929E+01_JPRB, 0.203102E+01_JPRB &
  &, 0.206246E+01_JPRB, 0.209358E+01_JPRB, 0.212439E+01_JPRB, 0.215486E+01_JPRB &
  &, 0.218497E+01_JPRB, 0.221471E+01_JPRB, 0.224407E+01_JPRB &
  &, 0.227303E+01_JPRB, 0.230158E+01_JPRB, 0.232970E+01_JPRB, 0.235738E+01_JPRB &
  &, 0.238462E+01_JPRB, 0.241139E+01_JPRB, 0.243768E+01_JPRB &
  &, 0.246348E+01_JPRB, 0.248880E+01_JPRB, 0.251360E+01_JPRB, 0.253788E+01_JPRB &
  &, 0.256164E+01_JPRB, 0.258485E+01_JPRB, 0.260753E+01_JPRB &
  &, 0.262965E+01_JPRB, 0.265120E+01_JPRB, 0.267219E+01_JPRB, 0.269259E+01_JPRB &
  &, 0.271220E+01_JPRB, 0.273167E+01_JPRB, 0.275031E+01_JPRB &
  &, 0.276835E+01_JPRB, 0.278580E+01_JPRB, 0.280264E+01_JPRB, 0.281886E+01_JPRB &
  &, 0.283448E+01_JPRB, 0.284945E+01_JPRB, 0.286377E+01_JPRB &
  &, 0.287757E+01_JPRB, 0.289070E+01_JPRB, 0.290318E+01_JPRB, 0.291505E+01_JPRB &
  &, 0.292627E+01_JPRB, 0.293688E+01_JPRB, 0.294685E+01_JPRB &
  &, 0.295621E+01_JPRB, 0.296493E+01_JPRB, 0.297299E+01_JPRB, 0.298045E+01_JPRB &
  &, 0.298728E+01_JPRB, 0.299350E+01_JPRB, 0.299908E+01_JPRB &
  &, 0.300405E+01_JPRB, 0.300836E+01_JPRB, 0.301213E+01_JPRB, 0.301525E+01_JPRB &
  &, 0.301776E+01_JPRB, 0.301948E+01_JPRB, 0.302098E+01_JPRB &
  &, 0.302169E+01_JPRB, 0.302181E+01_JPRB, 0.302136E+01_JPRB, 0.302031E+01_JPRB &
  &, 0.301863E+01_JPRB, 0.301648E+01_JPRB, 0.301370E+01_JPRB &
  &, 0.301033E+01_JPRB, 0.300649E+01_JPRB, 0.300207E+01_JPRB, 0.299708E+01_JPRB &
  &, 0.299157E+01_JPRB, 0.298553E+01_JPRB, 0.297896E+01_JPRB &
  &, 0.297185E+01_JPRB, 0.296428E+01_JPRB, 0.295618E+01_JPRB, 0.294744E+01_JPRB &
  &, 0.293847E+01_JPRB, 0.292890E+01_JPRB, 0.291889E+01_JPRB &
  &, 0.290831E+01_JPRB, 0.289741E+01_JPRB, 0.288598E+01_JPRB, 0.287413E+01_JPRB &
  &, 0.286182E+01_JPRB, 0.284909E+01_JPRB, 0.283596E+01_JPRB &
  &, 0.282240E+01_JPRB, 0.280849E+01_JPRB, 0.279415E+01_JPRB, 0.277940E+01_JPRB &
  &, 0.276433E+01_JPRB, 0.274885E+01_JPRB, 0.273300E+01_JPRB &
  &, 0.271683E+01_JPRB, 0.270033E+01_JPRB, 0.268347E+01_JPRB, 0.266622E+01_JPRB &
  &, 0.264881E+01_JPRB, 0.263101E+01_JPRB, 0.261294E+01_JPRB &
  &, 0.259457E+01_JPRB, 0.257588E+01_JPRB, 0.255700E+01_JPRB, 0.253777E+01_JPRB &
  &, 0.251835E+01_JPRB, 0.249869E+01_JPRB, 0.247877E+01_JPRB &
  &, 0.245860E+01_JPRB, 0.243826E+01_JPRB, 0.241773E+01_JPRB, 0.239697E+01_JPRB &
  &, 0.237599E+01_JPRB, 0.235488E+01_JPRB, 0.233354E+01_JPRB/)
XCW( 901, :) = (/ &
  &  0.113066E+01_JPRB, 0.116388E+01_JPRB, 0.119728E+01_JPRB, 0.123084E+01_JPRB &
  &, 0.126455E+01_JPRB, 0.129838E+01_JPRB, 0.133233E+01_JPRB &
  &, 0.136637E+01_JPRB, 0.140048E+01_JPRB, 0.143465E+01_JPRB, 0.146886E+01_JPRB &
  &, 0.150308E+01_JPRB, 0.153730E+01_JPRB, 0.157151E+01_JPRB &
  &, 0.160567E+01_JPRB, 0.163978E+01_JPRB, 0.167382E+01_JPRB, 0.170777E+01_JPRB &
  &, 0.174160E+01_JPRB, 0.177530E+01_JPRB, 0.180886E+01_JPRB &
  &, 0.184226E+01_JPRB, 0.187547E+01_JPRB, 0.190848E+01_JPRB, 0.194127E+01_JPRB &
  &, 0.197382E+01_JPRB, 0.200612E+01_JPRB, 0.203815E+01_JPRB &
  &, 0.206990E+01_JPRB, 0.210134E+01_JPRB, 0.213246E+01_JPRB, 0.216325E+01_JPRB &
  &, 0.219369E+01_JPRB, 0.222376E+01_JPRB, 0.225345E+01_JPRB &
  &, 0.228274E+01_JPRB, 0.231163E+01_JPRB, 0.234009E+01_JPRB, 0.236812E+01_JPRB &
  &, 0.239570E+01_JPRB, 0.242282E+01_JPRB, 0.244947E+01_JPRB &
  &, 0.247563E+01_JPRB, 0.250130E+01_JPRB, 0.252646E+01_JPRB, 0.255110E+01_JPRB &
  &, 0.257523E+01_JPRB, 0.259881E+01_JPRB, 0.262186E+01_JPRB &
  &, 0.264434E+01_JPRB, 0.266626E+01_JPRB, 0.268763E+01_JPRB, 0.270842E+01_JPRB &
  &, 0.272862E+01_JPRB, 0.274824E+01_JPRB, 0.276727E+01_JPRB &
  &, 0.278569E+01_JPRB, 0.280351E+01_JPRB, 0.282073E+01_JPRB, 0.283733E+01_JPRB &
  &, 0.285330E+01_JPRB, 0.286869E+01_JPRB, 0.288345E+01_JPRB &
  &, 0.289757E+01_JPRB, 0.291108E+01_JPRB, 0.292396E+01_JPRB, 0.293621E+01_JPRB &
  &, 0.294781E+01_JPRB, 0.295880E+01_JPRB, 0.296915E+01_JPRB &
  &, 0.297888E+01_JPRB, 0.298796E+01_JPRB, 0.299642E+01_JPRB, 0.300426E+01_JPRB &
  &, 0.301146E+01_JPRB, 0.301803E+01_JPRB, 0.302399E+01_JPRB &
  &, 0.302932E+01_JPRB, 0.303403E+01_JPRB, 0.303814E+01_JPRB, 0.304162E+01_JPRB &
  &, 0.304446E+01_JPRB, 0.304677E+01_JPRB, 0.304841E+01_JPRB &
  &, 0.304948E+01_JPRB, 0.304996E+01_JPRB, 0.304983E+01_JPRB, 0.304914E+01_JPRB &
  &, 0.304784E+01_JPRB, 0.304596E+01_JPRB, 0.304353E+01_JPRB &
  &, 0.304054E+01_JPRB, 0.303699E+01_JPRB, 0.303288E+01_JPRB, 0.302820E+01_JPRB &
  &, 0.302300E+01_JPRB, 0.301727E+01_JPRB, 0.301099E+01_JPRB &
  &, 0.300419E+01_JPRB, 0.299691E+01_JPRB, 0.298908E+01_JPRB, 0.298077E+01_JPRB &
  &, 0.297198E+01_JPRB, 0.296269E+01_JPRB, 0.295292E+01_JPRB &
  &, 0.294266E+01_JPRB, 0.293195E+01_JPRB, 0.292079E+01_JPRB, 0.290920E+01_JPRB &
  &, 0.289707E+01_JPRB, 0.288463E+01_JPRB, 0.287175E+01_JPRB &
  &, 0.285843E+01_JPRB, 0.284471E+01_JPRB, 0.283056E+01_JPRB, 0.281604E+01_JPRB &
  &, 0.280114E+01_JPRB, 0.278588E+01_JPRB, 0.277023E+01_JPRB &
  &, 0.275427E+01_JPRB, 0.273792E+01_JPRB, 0.272125E+01_JPRB, 0.270424E+01_JPRB &
  &, 0.268691E+01_JPRB, 0.266928E+01_JPRB, 0.265132E+01_JPRB &
  &, 0.263306E+01_JPRB, 0.261457E+01_JPRB, 0.259578E+01_JPRB, 0.257669E+01_JPRB &
  &, 0.255734E+01_JPRB, 0.253781E+01_JPRB, 0.251794E+01_JPRB &
  &, 0.249793E+01_JPRB, 0.247764E+01_JPRB, 0.245714E+01_JPRB, 0.243646E+01_JPRB &
  &, 0.241555E+01_JPRB, 0.239451E+01_JPRB, 0.237323E+01_JPRB/)
XCW( 902, :) = (/ &
  &  0.113129E+01_JPRB, 0.116467E+01_JPRB, 0.119825E+01_JPRB, 0.123200E+01_JPRB &
  &, 0.126589E+01_JPRB, 0.129993E+01_JPRB, 0.133408E+01_JPRB &
  &, 0.136832E+01_JPRB, 0.140265E+01_JPRB, 0.143703E+01_JPRB, 0.147146E+01_JPRB &
  &, 0.150591E+01_JPRB, 0.154037E+01_JPRB, 0.157482E+01_JPRB &
  &, 0.160923E+01_JPRB, 0.164359E+01_JPRB, 0.167788E+01_JPRB, 0.171209E+01_JPRB &
  &, 0.174619E+01_JPRB, 0.178017E+01_JPRB, 0.181400E+01_JPRB &
  &, 0.184768E+01_JPRB, 0.188117E+01_JPRB, 0.191447E+01_JPRB, 0.194756E+01_JPRB &
  &, 0.198041E+01_JPRB, 0.201302E+01_JPRB, 0.204535E+01_JPRB &
  &, 0.207741E+01_JPRB, 0.210917E+01_JPRB, 0.214061E+01_JPRB, 0.217172E+01_JPRB &
  &, 0.220249E+01_JPRB, 0.223290E+01_JPRB, 0.226292E+01_JPRB &
  &, 0.229256E+01_JPRB, 0.232179E+01_JPRB, 0.235059E+01_JPRB, 0.237897E+01_JPRB &
  &, 0.240691E+01_JPRB, 0.243437E+01_JPRB, 0.246138E+01_JPRB &
  &, 0.248790E+01_JPRB, 0.251393E+01_JPRB, 0.253946E+01_JPRB, 0.256447E+01_JPRB &
  &, 0.258896E+01_JPRB, 0.261292E+01_JPRB, 0.263634E+01_JPRB &
  &, 0.265920E+01_JPRB, 0.268150E+01_JPRB, 0.270324E+01_JPRB, 0.272441E+01_JPRB &
  &, 0.274500E+01_JPRB, 0.276500E+01_JPRB, 0.278441E+01_JPRB &
  &, 0.280322E+01_JPRB, 0.282143E+01_JPRB, 0.283903E+01_JPRB, 0.285602E+01_JPRB &
  &, 0.287240E+01_JPRB, 0.288817E+01_JPRB, 0.290330E+01_JPRB &
  &, 0.291781E+01_JPRB, 0.293171E+01_JPRB, 0.294496E+01_JPRB, 0.295759E+01_JPRB &
  &, 0.296960E+01_JPRB, 0.298098E+01_JPRB, 0.299170E+01_JPRB &
  &, 0.300182E+01_JPRB, 0.301128E+01_JPRB, 0.302014E+01_JPRB, 0.302835E+01_JPRB &
  &, 0.303592E+01_JPRB, 0.304290E+01_JPRB, 0.304922E+01_JPRB &
  &, 0.305493E+01_JPRB, 0.306001E+01_JPRB, 0.306448E+01_JPRB, 0.306829E+01_JPRB &
  &, 0.307157E+01_JPRB, 0.307420E+01_JPRB, 0.307623E+01_JPRB &
  &, 0.307764E+01_JPRB, 0.307848E+01_JPRB, 0.307871E+01_JPRB, 0.307832E+01_JPRB &
  &, 0.307739E+01_JPRB, 0.307586E+01_JPRB, 0.307376E+01_JPRB &
  &, 0.307110E+01_JPRB, 0.306787E+01_JPRB, 0.306408E+01_JPRB, 0.305975E+01_JPRB &
  &, 0.305487E+01_JPRB, 0.304946E+01_JPRB, 0.304349E+01_JPRB &
  &, 0.303700E+01_JPRB, 0.302999E+01_JPRB, 0.302249E+01_JPRB, 0.301448E+01_JPRB &
  &, 0.300595E+01_JPRB, 0.299696E+01_JPRB, 0.298743E+01_JPRB &
  &, 0.297749E+01_JPRB, 0.296702E+01_JPRB, 0.295614E+01_JPRB, 0.294478E+01_JPRB &
  &, 0.293300E+01_JPRB, 0.292074E+01_JPRB, 0.290806E+01_JPRB &
  &, 0.289500E+01_JPRB, 0.288148E+01_JPRB, 0.286757E+01_JPRB, 0.285329E+01_JPRB &
  &, 0.283857E+01_JPRB, 0.282354E+01_JPRB, 0.280806E+01_JPRB &
  &, 0.279226E+01_JPRB, 0.277612E+01_JPRB, 0.275960E+01_JPRB, 0.274278E+01_JPRB &
  &, 0.272564E+01_JPRB, 0.270813E+01_JPRB, 0.269035E+01_JPRB &
  &, 0.267226E+01_JPRB, 0.265388E+01_JPRB, 0.263433E+01_JPRB, 0.261624E+01_JPRB &
  &, 0.259703E+01_JPRB, 0.257757E+01_JPRB, 0.255788E+01_JPRB &
  &, 0.253794E+01_JPRB, 0.251775E+01_JPRB, 0.249735E+01_JPRB, 0.247670E+01_JPRB &
  &, 0.245588E+01_JPRB, 0.243466E+01_JPRB, 0.241345E+01_JPRB/)
XCW( 903, :) = (/ &
  &  0.113192E+01_JPRB, 0.116548E+01_JPRB, 0.119923E+01_JPRB, 0.123316E+01_JPRB &
  &, 0.126725E+01_JPRB, 0.130148E+01_JPRB, 0.133583E+01_JPRB &
  &, 0.137029E+01_JPRB, 0.140483E+01_JPRB, 0.143944E+01_JPRB, 0.147409E+01_JPRB &
  &, 0.150877E+01_JPRB, 0.154347E+01_JPRB, 0.157816E+01_JPRB &
  &, 0.161282E+01_JPRB, 0.164743E+01_JPRB, 0.168198E+01_JPRB, 0.171645E+01_JPRB &
  &, 0.175083E+01_JPRB, 0.178508E+01_JPRB, 0.181919E+01_JPRB &
  &, 0.185314E+01_JPRB, 0.188693E+01_JPRB, 0.192052E+01_JPRB, 0.195391E+01_JPRB &
  &, 0.198706E+01_JPRB, 0.201998E+01_JPRB, 0.205263E+01_JPRB &
  &, 0.208500E+01_JPRB, 0.211708E+01_JPRB, 0.214884E+01_JPRB, 0.218029E+01_JPRB &
  &, 0.221138E+01_JPRB, 0.224212E+01_JPRB, 0.227249E+01_JPRB &
  &, 0.230246E+01_JPRB, 0.233204E+01_JPRB, 0.236119E+01_JPRB, 0.238993E+01_JPRB &
  &, 0.241821E+01_JPRB, 0.244605E+01_JPRB, 0.247342E+01_JPRB &
  &, 0.250031E+01_JPRB, 0.252670E+01_JPRB, 0.255260E+01_JPRB, 0.257798E+01_JPRB &
  &, 0.260285E+01_JPRB, 0.262718E+01_JPRB, 0.265097E+01_JPRB &
  &, 0.267422E+01_JPRB, 0.269691E+01_JPRB, 0.271904E+01_JPRB, 0.274058E+01_JPRB &
  &, 0.276156E+01_JPRB, 0.278195E+01_JPRB, 0.280175E+01_JPRB &
  &, 0.282095E+01_JPRB, 0.283956E+01_JPRB, 0.285754E+01_JPRB, 0.287494E+01_JPRB &
  &, 0.289170E+01_JPRB, 0.290785E+01_JPRB, 0.292339E+01_JPRB &
  &, 0.293829E+01_JPRB, 0.295258E+01_JPRB, 0.296623E+01_JPRB, 0.297927E+01_JPRB &
  &, 0.299165E+01_JPRB, 0.300342E+01_JPRB, 0.301454E+01_JPRB &
  &, 0.302504E+01_JPRB, 0.303490E+01_JPRB, 0.304412E+01_JPRB, 0.305274E+01_JPRB &
  &, 0.306070E+01_JPRB, 0.306804E+01_JPRB, 0.307475E+01_JPRB &
  &, 0.308086E+01_JPRB, 0.308630E+01_JPRB, 0.309117E+01_JPRB, 0.309538E+01_JPRB &
  &, 0.309900E+01_JPRB, 0.310200E+01_JPRB, 0.310438E+01_JPRB &
  &, 0.310618E+01_JPRB, 0.310736E+01_JPRB, 0.310794E+01_JPRB, 0.310795E+01_JPRB &
  &, 0.310735E+01_JPRB, 0.310613E+01_JPRB, 0.310443E+01_JPRB &
  &, 0.310210E+01_JPRB, 0.309920E+01_JPRB, 0.309574E+01_JPRB, 0.309174E+01_JPRB &
  &, 0.308718E+01_JPRB, 0.308209E+01_JPRB, 0.307645E+01_JPRB &
  &, 0.307027E+01_JPRB, 0.306357E+01_JPRB, 0.305638E+01_JPRB, 0.304865E+01_JPRB &
  &, 0.304042E+01_JPRB, 0.303172E+01_JPRB, 0.302250E+01_JPRB &
  &, 0.301281E+01_JPRB, 0.300263E+01_JPRB, 0.299203E+01_JPRB, 0.298090E+01_JPRB &
  &, 0.296935E+01_JPRB, 0.295736E+01_JPRB, 0.294496E+01_JPRB &
  &, 0.293211E+01_JPRB, 0.291884E+01_JPRB, 0.290518E+01_JPRB, 0.289110E+01_JPRB &
  &, 0.287663E+01_JPRB, 0.286177E+01_JPRB, 0.284653E+01_JPRB &
  &, 0.283095E+01_JPRB, 0.281497E+01_JPRB, 0.279866E+01_JPRB, 0.278200E+01_JPRB &
  &, 0.276500E+01_JPRB, 0.274769E+01_JPRB, 0.273004E+01_JPRB &
  &, 0.271212E+01_JPRB, 0.269386E+01_JPRB, 0.267532E+01_JPRB, 0.265654E+01_JPRB &
  &, 0.263742E+01_JPRB, 0.261810E+01_JPRB, 0.259849E+01_JPRB &
  &, 0.257867E+01_JPRB, 0.255854E+01_JPRB, 0.253826E+01_JPRB, 0.251771E+01_JPRB &
  &, 0.249698E+01_JPRB, 0.247604E+01_JPRB, 0.245491E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART129',1,ZHOOK_HANDLE)
END SUBROUTINE PART129

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART130

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART130',0,ZHOOK_HANDLE)

XCW( 904, :) = (/ &
  &  0.113255E+01_JPRB, 0.116629E+01_JPRB, 0.120022E+01_JPRB, 0.123434E+01_JPRB &
  &, 0.126862E+01_JPRB, 0.130305E+01_JPRB, 0.133761E+01_JPRB &
  &, 0.137227E+01_JPRB, 0.140703E+01_JPRB, 0.144186E+01_JPRB, 0.147674E+01_JPRB &
  &, 0.151166E+01_JPRB, 0.154659E+01_JPRB, 0.158153E+01_JPRB &
  &, 0.161644E+01_JPRB, 0.165131E+01_JPRB, 0.168612E+01_JPRB, 0.172086E+01_JPRB &
  &, 0.175550E+01_JPRB, 0.179003E+01_JPRB, 0.182442E+01_JPRB &
  &, 0.185867E+01_JPRB, 0.189274E+01_JPRB, 0.192663E+01_JPRB, 0.196032E+01_JPRB &
  &, 0.199378E+01_JPRB, 0.202700E+01_JPRB, 0.205997E+01_JPRB &
  &, 0.209266E+01_JPRB, 0.212507E+01_JPRB, 0.215716E+01_JPRB, 0.218893E+01_JPRB &
  &, 0.222036E+01_JPRB, 0.225144E+01_JPRB, 0.228215E+01_JPRB &
  &, 0.231248E+01_JPRB, 0.234240E+01_JPRB, 0.237191E+01_JPRB, 0.240100E+01_JPRB &
  &, 0.242965E+01_JPRB, 0.245785E+01_JPRB, 0.248559E+01_JPRB &
  &, 0.251284E+01_JPRB, 0.253961E+01_JPRB, 0.256588E+01_JPRB, 0.259165E+01_JPRB &
  &, 0.261688E+01_JPRB, 0.264159E+01_JPRB, 0.266578E+01_JPRB &
  &, 0.268941E+01_JPRB, 0.271248E+01_JPRB, 0.273500E+01_JPRB, 0.275694E+01_JPRB &
  &, 0.277831E+01_JPRB, 0.279910E+01_JPRB, 0.281928E+01_JPRB &
  &, 0.283888E+01_JPRB, 0.285789E+01_JPRB, 0.287628E+01_JPRB, 0.289406E+01_JPRB &
  &, 0.291122E+01_JPRB, 0.292778E+01_JPRB, 0.294371E+01_JPRB &
  &, 0.295902E+01_JPRB, 0.297370E+01_JPRB, 0.298775E+01_JPRB, 0.300118E+01_JPRB &
  &, 0.301397E+01_JPRB, 0.302614E+01_JPRB, 0.303765E+01_JPRB &
  &, 0.304855E+01_JPRB, 0.305881E+01_JPRB, 0.306844E+01_JPRB, 0.307601E+01_JPRB &
  &, 0.308580E+01_JPRB, 0.309353E+01_JPRB, 0.310064E+01_JPRB &
  &, 0.310710E+01_JPRB, 0.311295E+01_JPRB, 0.311819E+01_JPRB, 0.312277E+01_JPRB &
  &, 0.312678E+01_JPRB, 0.313015E+01_JPRB, 0.313291E+01_JPRB &
  &, 0.313509E+01_JPRB, 0.313664E+01_JPRB, 0.313760E+01_JPRB, 0.313795E+01_JPRB &
  &, 0.313770E+01_JPRB, 0.313689E+01_JPRB, 0.313550E+01_JPRB &
  &, 0.313351E+01_JPRB, 0.313098E+01_JPRB, 0.312786E+01_JPRB, 0.312419E+01_JPRB &
  &, 0.311997E+01_JPRB, 0.311517E+01_JPRB, 0.310989E+01_JPRB &
  &, 0.310404E+01_JPRB, 0.309767E+01_JPRB, 0.309076E+01_JPRB, 0.308334E+01_JPRB &
  &, 0.307542E+01_JPRB, 0.306699E+01_JPRB, 0.305807E+01_JPRB &
  &, 0.304868E+01_JPRB, 0.303880E+01_JPRB, 0.302845E+01_JPRB, 0.301762E+01_JPRB &
  &, 0.300635E+01_JPRB, 0.299460E+01_JPRB, 0.298247E+01_JPRB &
  &, 0.296985E+01_JPRB, 0.295684E+01_JPRB, 0.294340E+01_JPRB, 0.292952E+01_JPRB &
  &, 0.291530E+01_JPRB, 0.290064E+01_JPRB, 0.288563E+01_JPRB &
  &, 0.287024E+01_JPRB, 0.285449E+01_JPRB, 0.283835E+01_JPRB, 0.282189E+01_JPRB &
  &, 0.280505E+01_JPRB, 0.278794E+01_JPRB, 0.277043E+01_JPRB &
  &, 0.275264E+01_JPRB, 0.273456E+01_JPRB, 0.271620E+01_JPRB, 0.269753E+01_JPRB &
  &, 0.267857E+01_JPRB, 0.265934E+01_JPRB, 0.263987E+01_JPRB &
  &, 0.262013E+01_JPRB, 0.260013E+01_JPRB, 0.257990E+01_JPRB, 0.255947E+01_JPRB &
  &, 0.253879E+01_JPRB, 0.251794E+01_JPRB, 0.249677E+01_JPRB/)
XCW( 905, :) = (/ &
  &  0.113320E+01_JPRB, 0.116710E+01_JPRB, 0.120122E+01_JPRB, 0.123553E+01_JPRB &
  &, 0.127000E+01_JPRB, 0.130463E+01_JPRB, 0.133940E+01_JPRB &
  &, 0.137428E+01_JPRB, 0.140925E+01_JPRB, 0.144430E+01_JPRB, 0.147942E+01_JPRB &
  &, 0.151457E+01_JPRB, 0.154975E+01_JPRB, 0.158493E+01_JPRB &
  &, 0.162009E+01_JPRB, 0.165522E+01_JPRB, 0.169030E+01_JPRB, 0.172530E+01_JPRB &
  &, 0.176022E+01_JPRB, 0.179503E+01_JPRB, 0.182971E+01_JPRB &
  &, 0.186425E+01_JPRB, 0.189862E+01_JPRB, 0.193280E+01_JPRB, 0.196679E+01_JPRB &
  &, 0.200057E+01_JPRB, 0.203411E+01_JPRB, 0.206739E+01_JPRB &
  &, 0.210040E+01_JPRB, 0.213313E+01_JPRB, 0.216556E+01_JPRB, 0.219767E+01_JPRB &
  &, 0.222944E+01_JPRB, 0.226086E+01_JPRB, 0.229192E+01_JPRB &
  &, 0.232259E+01_JPRB, 0.235287E+01_JPRB, 0.238275E+01_JPRB, 0.241219E+01_JPRB &
  &, 0.244121E+01_JPRB, 0.246977E+01_JPRB, 0.249788E+01_JPRB &
  &, 0.252551E+01_JPRB, 0.255265E+01_JPRB, 0.257931E+01_JPRB, 0.260545E+01_JPRB &
  &, 0.263108E+01_JPRB, 0.265618E+01_JPRB, 0.268074E+01_JPRB &
  &, 0.270477E+01_JPRB, 0.272824E+01_JPRB, 0.275114E+01_JPRB, 0.277348E+01_JPRB &
  &, 0.279525E+01_JPRB, 0.281644E+01_JPRB, 0.283703E+01_JPRB &
  &, 0.285703E+01_JPRB, 0.287643E+01_JPRB, 0.289522E+01_JPRB, 0.291341E+01_JPRB &
  &, 0.293098E+01_JPRB, 0.294794E+01_JPRB, 0.296428E+01_JPRB &
  &, 0.297999E+01_JPRB, 0.299507E+01_JPRB, 0.300951E+01_JPRB, 0.302338E+01_JPRB &
  &, 0.303657E+01_JPRB, 0.304913E+01_JPRB, 0.306107E+01_JPRB &
  &, 0.307236E+01_JPRB, 0.308303E+01_JPRB, 0.309306E+01_JPRB, 0.310244E+01_JPRB &
  &, 0.311113E+01_JPRB, 0.311933E+01_JPRB, 0.312684E+01_JPRB &
  &, 0.313371E+01_JPRB, 0.313994E+01_JPRB, 0.314556E+01_JPRB, 0.315056E+01_JPRB &
  &, 0.315494E+01_JPRB, 0.315870E+01_JPRB, 0.316184E+01_JPRB &
  &, 0.316438E+01_JPRB, 0.316630E+01_JPRB, 0.316763E+01_JPRB, 0.316834E+01_JPRB &
  &, 0.316851E+01_JPRB, 0.316804E+01_JPRB, 0.316700E+01_JPRB &
  &, 0.316537E+01_JPRB, 0.316318E+01_JPRB, 0.316040E+01_JPRB, 0.315708E+01_JPRB &
  &, 0.315320E+01_JPRB, 0.314878E+01_JPRB, 0.314380E+01_JPRB &
  &, 0.313827E+01_JPRB, 0.313223E+01_JPRB, 0.312565E+01_JPRB, 0.311856E+01_JPRB &
  &, 0.311092E+01_JPRB, 0.310281E+01_JPRB, 0.309420E+01_JPRB &
  &, 0.308508E+01_JPRB, 0.307551E+01_JPRB, 0.306542E+01_JPRB, 0.305488E+01_JPRB &
  &, 0.304387E+01_JPRB, 0.303240E+01_JPRB, 0.302051E+01_JPRB &
  &, 0.300816E+01_JPRB, 0.299539E+01_JPRB, 0.298221E+01_JPRB, 0.296860E+01_JPRB &
  &, 0.295459E+01_JPRB, 0.294019E+01_JPRB, 0.292537E+01_JPRB &
  &, 0.291017E+01_JPRB, 0.289460E+01_JPRB, 0.287869E+01_JPRB, 0.286241E+01_JPRB &
  &, 0.284579E+01_JPRB, 0.282883E+01_JPRB, 0.281153E+01_JPRB &
  &, 0.279394E+01_JPRB, 0.277599E+01_JPRB, 0.275776E+01_JPRB, 0.273926E+01_JPRB &
  &, 0.272041E+01_JPRB, 0.270135E+01_JPRB, 0.268198E+01_JPRB &
  &, 0.266238E+01_JPRB, 0.264246E+01_JPRB, 0.262236E+01_JPRB, 0.260205E+01_JPRB &
  &, 0.258142E+01_JPRB, 0.256069E+01_JPRB, 0.253968E+01_JPRB/)
XCW( 906, :) = (/ &
  &  0.113384E+01_JPRB, 0.116793E+01_JPRB, 0.120223E+01_JPRB, 0.123672E+01_JPRB &
  &, 0.127140E+01_JPRB, 0.130623E+01_JPRB, 0.134120E+01_JPRB &
  &, 0.137629E+01_JPRB, 0.141149E+01_JPRB, 0.144677E+01_JPRB, 0.148212E+01_JPRB &
  &, 0.151751E+01_JPRB, 0.155293E+01_JPRB, 0.158836E+01_JPRB &
  &, 0.162378E+01_JPRB, 0.165917E+01_JPRB, 0.169451E+01_JPRB, 0.172979E+01_JPRB &
  &, 0.176499E+01_JPRB, 0.180008E+01_JPRB, 0.183504E+01_JPRB &
  &, 0.186987E+01_JPRB, 0.190454E+01_JPRB, 0.193903E+01_JPRB, 0.197333E+01_JPRB &
  &, 0.200742E+01_JPRB, 0.204127E+01_JPRB, 0.207488E+01_JPRB &
  &, 0.210822E+01_JPRB, 0.214128E+01_JPRB, 0.217404E+01_JPRB, 0.220649E+01_JPRB &
  &, 0.223861E+01_JPRB, 0.227038E+01_JPRB, 0.230178E+01_JPRB &
  &, 0.233281E+01_JPRB, 0.236345E+01_JPRB, 0.239369E+01_JPRB, 0.242350E+01_JPRB &
  &, 0.245288E+01_JPRB, 0.248183E+01_JPRB, 0.251030E+01_JPRB &
  &, 0.253832E+01_JPRB, 0.256585E+01_JPRB, 0.259288E+01_JPRB, 0.261940E+01_JPRB &
  &, 0.264542E+01_JPRB, 0.267092E+01_JPRB, 0.269588E+01_JPRB &
  &, 0.272030E+01_JPRB, 0.274416E+01_JPRB, 0.276747E+01_JPRB, 0.279020E+01_JPRB &
  &, 0.281239E+01_JPRB, 0.283397E+01_JPRB, 0.285497E+01_JPRB &
  &, 0.287538E+01_JPRB, 0.289519E+01_JPRB, 0.291439E+01_JPRB, 0.293300E+01_JPRB &
  &, 0.295098E+01_JPRB, 0.296835E+01_JPRB, 0.298509E+01_JPRB &
  &, 0.300123E+01_JPRB, 0.301672E+01_JPRB, 0.303160E+01_JPRB, 0.304583E+01_JPRB &
  &, 0.305945E+01_JPRB, 0.307242E+01_JPRB, 0.308475E+01_JPRB &
  &, 0.309646E+01_JPRB, 0.310753E+01_JPRB, 0.311799E+01_JPRB, 0.312778E+01_JPRB &
  &, 0.313693E+01_JPRB, 0.314548E+01_JPRB, 0.315338E+01_JPRB &
  &, 0.315988E+01_JPRB, 0.316730E+01_JPRB, 0.317331E+01_JPRB, 0.317870E+01_JPRB &
  &, 0.318345E+01_JPRB, 0.318763E+01_JPRB, 0.319114E+01_JPRB &
  &, 0.319407E+01_JPRB, 0.319637E+01_JPRB, 0.319810E+01_JPRB, 0.319920E+01_JPRB &
  &, 0.319970E+01_JPRB, 0.319963E+01_JPRB, 0.319894E+01_JPRB &
  &, 0.319770E+01_JPRB, 0.319587E+01_JPRB, 0.319344E+01_JPRB, 0.319047E+01_JPRB &
  &, 0.318694E+01_JPRB, 0.318286E+01_JPRB, 0.317823E+01_JPRB &
  &, 0.317301E+01_JPRB, 0.316731E+01_JPRB, 0.316106E+01_JPRB, 0.315422E+01_JPRB &
  &, 0.314700E+01_JPRB, 0.313917E+01_JPRB, 0.313085E+01_JPRB &
  &, 0.312205E+01_JPRB, 0.311274E+01_JPRB, 0.310301E+01_JPRB, 0.309273E+01_JPRB &
  &, 0.308202E+01_JPRB, 0.307081E+01_JPRB, 0.305921E+01_JPRB &
  &, 0.304711E+01_JPRB, 0.303462E+01_JPRB, 0.302168E+01_JPRB, 0.300830E+01_JPRB &
  &, 0.299378E+01_JPRB, 0.298031E+01_JPRB, 0.296575E+01_JPRB &
  &, 0.295080E+01_JPRB, 0.293548E+01_JPRB, 0.291976E+01_JPRB, 0.290366E+01_JPRB &
  &, 0.288726E+01_JPRB, 0.287048E+01_JPRB, 0.285333E+01_JPRB &
  &, 0.283590E+01_JPRB, 0.281815E+01_JPRB, 0.280011E+01_JPRB, 0.278169E+01_JPRB &
  &, 0.276302E+01_JPRB, 0.274412E+01_JPRB, 0.272486E+01_JPRB &
  &, 0.270536E+01_JPRB, 0.268559E+01_JPRB, 0.266564E+01_JPRB, 0.264539E+01_JPRB &
  &, 0.262489E+01_JPRB, 0.260421E+01_JPRB, 0.258325E+01_JPRB/)
XCW( 907, :) = (/ &
  &  0.113449E+01_JPRB, 0.116876E+01_JPRB, 0.120324E+01_JPRB, 0.123793E+01_JPRB &
  &, 0.127280E+01_JPRB, 0.130784E+01_JPRB, 0.134302E+01_JPRB &
  &, 0.137833E+01_JPRB, 0.141375E+01_JPRB, 0.144926E+01_JPRB, 0.148484E+01_JPRB &
  &, 0.152047E+01_JPRB, 0.155614E+01_JPRB, 0.159182E+01_JPRB &
  &, 0.162750E+01_JPRB, 0.166316E+01_JPRB, 0.169877E+01_JPRB, 0.173432E+01_JPRB &
  &, 0.176980E+01_JPRB, 0.180517E+01_JPRB, 0.184043E+01_JPRB &
  &, 0.187556E+01_JPRB, 0.191053E+01_JPRB, 0.194533E+01_JPRB, 0.197994E+01_JPRB &
  &, 0.201434E+01_JPRB, 0.204851E+01_JPRB, 0.208245E+01_JPRB &
  &, 0.211612E+01_JPRB, 0.214952E+01_JPRB, 0.218262E+01_JPRB, 0.221541E+01_JPRB &
  &, 0.224787E+01_JPRB, 0.228000E+01_JPRB, 0.231176E+01_JPRB &
  &, 0.234315E+01_JPRB, 0.237415E+01_JPRB, 0.240476E+01_JPRB, 0.243494E+01_JPRB &
  &, 0.246469E+01_JPRB, 0.249401E+01_JPRB, 0.252287E+01_JPRB &
  &, 0.255126E+01_JPRB, 0.257918E+01_JPRB, 0.260660E+01_JPRB, 0.263352E+01_JPRB &
  &, 0.265994E+01_JPRB, 0.268583E+01_JPRB, 0.271118E+01_JPRB &
  &, 0.273601E+01_JPRB, 0.276029E+01_JPRB, 0.278400E+01_JPRB, 0.280715E+01_JPRB &
  &, 0.282972E+01_JPRB, 0.285172E+01_JPRB, 0.287313E+01_JPRB &
  &, 0.289396E+01_JPRB, 0.291418E+01_JPRB, 0.293380E+01_JPRB, 0.295282E+01_JPRB &
  &, 0.297121E+01_JPRB, 0.298899E+01_JPRB, 0.300616E+01_JPRB &
  &, 0.302271E+01_JPRB, 0.303863E+01_JPRB, 0.305391E+01_JPRB, 0.306857E+01_JPRB &
  &, 0.308261E+01_JPRB, 0.309600E+01_JPRB, 0.310877E+01_JPRB &
  &, 0.312088E+01_JPRB, 0.313236E+01_JPRB, 0.314322E+01_JPRB, 0.315345E+01_JPRB &
  &, 0.316302E+01_JPRB, 0.317196E+01_JPRB, 0.318027E+01_JPRB &
  &, 0.318795E+01_JPRB, 0.319501E+01_JPRB, 0.320142E+01_JPRB, 0.320721E+01_JPRB &
  &, 0.321238E+01_JPRB, 0.321693E+01_JPRB, 0.322084E+01_JPRB &
  &, 0.322417E+01_JPRB, 0.322688E+01_JPRB, 0.322897E+01_JPRB, 0.323045E+01_JPRB &
  &, 0.323134E+01_JPRB, 0.323164E+01_JPRB, 0.323135E+01_JPRB &
  &, 0.323047E+01_JPRB, 0.322900E+01_JPRB, 0.322694E+01_JPRB, 0.322433E+01_JPRB &
  &, 0.322116E+01_JPRB, 0.321743E+01_JPRB, 0.321315E+01_JPRB &
  &, 0.320829E+01_JPRB, 0.320293E+01_JPRB, 0.319699E+01_JPRB, 0.319057E+01_JPRB &
  &, 0.318357E+01_JPRB, 0.317612E+01_JPRB, 0.316812E+01_JPRB &
  &, 0.315961E+01_JPRB, 0.315063E+01_JPRB, 0.314113E+01_JPRB, 0.313117E+01_JPRB &
  &, 0.312073E+01_JPRB, 0.310983E+01_JPRB, 0.309849E+01_JPRB &
  &, 0.308669E+01_JPRB, 0.307445E+01_JPRB, 0.306174E+01_JPRB, 0.304864E+01_JPRB &
  &, 0.303513E+01_JPRB, 0.302116E+01_JPRB, 0.300682E+01_JPRB &
  &, 0.299209E+01_JPRB, 0.297697E+01_JPRB, 0.296150E+01_JPRB, 0.294564E+01_JPRB &
  &, 0.292937E+01_JPRB, 0.291282E+01_JPRB, 0.289590E+01_JPRB &
  &, 0.287863E+01_JPRB, 0.286103E+01_JPRB, 0.284314E+01_JPRB, 0.282486E+01_JPRB &
  &, 0.280644E+01_JPRB, 0.278761E+01_JPRB, 0.276852E+01_JPRB &
  &, 0.274919E+01_JPRB, 0.272958E+01_JPRB, 0.270965E+01_JPRB, 0.268956E+01_JPRB &
  &, 0.266906E+01_JPRB, 0.264858E+01_JPRB, 0.262773E+01_JPRB/)
XCW( 908, :) = (/ &
  &  0.113515E+01_JPRB, 0.116960E+01_JPRB, 0.120427E+01_JPRB, 0.123915E+01_JPRB &
  &, 0.127422E+01_JPRB, 0.130946E+01_JPRB, 0.134486E+01_JPRB &
  &, 0.138039E+01_JPRB, 0.141603E+01_JPRB, 0.145177E+01_JPRB, 0.148759E+01_JPRB &
  &, 0.152346E+01_JPRB, 0.155938E+01_JPRB, 0.159532E+01_JPRB &
  &, 0.163126E+01_JPRB, 0.166718E+01_JPRB, 0.170307E+01_JPRB, 0.173890E+01_JPRB &
  &, 0.177466E+01_JPRB, 0.181032E+01_JPRB, 0.184587E+01_JPRB &
  &, 0.188130E+01_JPRB, 0.191657E+01_JPRB, 0.195168E+01_JPRB, 0.198661E+01_JPRB &
  &, 0.202133E+01_JPRB, 0.205583E+01_JPRB, 0.209010E+01_JPRB &
  &, 0.212410E+01_JPRB, 0.215784E+01_JPRB, 0.219128E+01_JPRB, 0.222442E+01_JPRB &
  &, 0.225723E+01_JPRB, 0.228971E+01_JPRB, 0.232184E+01_JPRB &
  &, 0.235359E+01_JPRB, 0.238497E+01_JPRB, 0.241593E+01_JPRB, 0.244650E+01_JPRB &
  &, 0.247663E+01_JPRB, 0.250633E+01_JPRB, 0.253557E+01_JPRB &
  &, 0.256436E+01_JPRB, 0.259267E+01_JPRB, 0.262049E+01_JPRB, 0.264781E+01_JPRB &
  &, 0.267461E+01_JPRB, 0.270091E+01_JPRB, 0.272668E+01_JPRB &
  &, 0.275190E+01_JPRB, 0.277658E+01_JPRB, 0.280071E+01_JPRB, 0.282427E+01_JPRB &
  &, 0.284726E+01_JPRB, 0.286968E+01_JPRB, 0.289151E+01_JPRB &
  &, 0.291274E+01_JPRB, 0.293339E+01_JPRB, 0.295343E+01_JPRB, 0.297286E+01_JPRB &
  &, 0.299169E+01_JPRB, 0.300991E+01_JPRB, 0.302749E+01_JPRB &
  &, 0.304447E+01_JPRB, 0.306081E+01_JPRB, 0.307652E+01_JPRB, 0.309160E+01_JPRB &
  &, 0.310606E+01_JPRB, 0.311987E+01_JPRB, 0.313305E+01_JPRB &
  &, 0.314562E+01_JPRB, 0.315751E+01_JPRB, 0.316879E+01_JPRB, 0.317943E+01_JPRB &
  &, 0.318942E+01_JPRB, 0.319878E+01_JPRB, 0.320753E+01_JPRB &
  &, 0.321563E+01_JPRB, 0.322309E+01_JPRB, 0.322991E+01_JPRB, 0.323610E+01_JPRB &
  &, 0.324168E+01_JPRB, 0.324664E+01_JPRB, 0.325098E+01_JPRB &
  &, 0.325469E+01_JPRB, 0.325780E+01_JPRB, 0.326028E+01_JPRB, 0.326216E+01_JPRB &
  &, 0.326343E+01_JPRB, 0.326414E+01_JPRB, 0.326419E+01_JPRB &
  &, 0.326372E+01_JPRB, 0.326262E+01_JPRB, 0.326093E+01_JPRB, 0.325869E+01_JPRB &
  &, 0.325588E+01_JPRB, 0.325252E+01_JPRB, 0.324857E+01_JPRB &
  &, 0.324410E+01_JPRB, 0.323906E+01_JPRB, 0.323348E+01_JPRB, 0.322737E+01_JPRB &
  &, 0.322075E+01_JPRB, 0.321357E+01_JPRB, 0.320592E+01_JPRB &
  &, 0.319774E+01_JPRB, 0.318905E+01_JPRB, 0.317988E+01_JPRB, 0.317025E+01_JPRB &
  &, 0.316009E+01_JPRB, 0.314950E+01_JPRB, 0.313843E+01_JPRB &
  &, 0.312689E+01_JPRB, 0.311491E+01_JPRB, 0.310250E+01_JPRB, 0.308965E+01_JPRB &
  &, 0.307642E+01_JPRB, 0.306269E+01_JPRB, 0.304863E+01_JPRB &
  &, 0.303411E+01_JPRB, 0.301921E+01_JPRB, 0.300395E+01_JPRB, 0.298830E+01_JPRB &
  &, 0.297228E+01_JPRB, 0.295591E+01_JPRB, 0.293922E+01_JPRB &
  &, 0.292213E+01_JPRB, 0.290386E+01_JPRB, 0.288702E+01_JPRB, 0.286895E+01_JPRB &
  &, 0.285061E+01_JPRB, 0.283198E+01_JPRB, 0.281302E+01_JPRB &
  &, 0.279381E+01_JPRB, 0.277431E+01_JPRB, 0.275455E+01_JPRB, 0.273454E+01_JPRB &
  &, 0.271426E+01_JPRB, 0.269378E+01_JPRB, 0.267307E+01_JPRB/)
XCW( 909, :) = (/ &
  &  0.113581E+01_JPRB, 0.117044E+01_JPRB, 0.120530E+01_JPRB, 0.124038E+01_JPRB &
  &, 0.127565E+01_JPRB, 0.131110E+01_JPRB, 0.134671E+01_JPRB &
  &, 0.138246E+01_JPRB, 0.141833E+01_JPRB, 0.145430E+01_JPRB, 0.149036E+01_JPRB &
  &, 0.152648E+01_JPRB, 0.156265E+01_JPRB, 0.159885E+01_JPRB &
  &, 0.163505E+01_JPRB, 0.167124E+01_JPRB, 0.170740E+01_JPRB, 0.174352E+01_JPRB &
  &, 0.177956E+01_JPRB, 0.181552E+01_JPRB, 0.185137E+01_JPRB &
  &, 0.188710E+01_JPRB, 0.192268E+01_JPRB, 0.195810E+01_JPRB, 0.199335E+01_JPRB &
  &, 0.202839E+01_JPRB, 0.206322E+01_JPRB, 0.209782E+01_JPRB &
  &, 0.213217E+01_JPRB, 0.216624E+01_JPRB, 0.220003E+01_JPRB, 0.223353E+01_JPRB &
  &, 0.226670E+01_JPRB, 0.229954E+01_JPRB, 0.233203E+01_JPRB &
  &, 0.236415E+01_JPRB, 0.239590E+01_JPRB, 0.242724E+01_JPRB, 0.245818E+01_JPRB &
  &, 0.248871E+01_JPRB, 0.251878E+01_JPRB, 0.254842E+01_JPRB &
  &, 0.257760E+01_JPRB, 0.260630E+01_JPRB, 0.263452E+01_JPRB, 0.266225E+01_JPRB &
  &, 0.268946E+01_JPRB, 0.271616E+01_JPRB, 0.274234E+01_JPRB &
  &, 0.276798E+01_JPRB, 0.279307E+01_JPRB, 0.281762E+01_JPRB, 0.284160E+01_JPRB &
  &, 0.286501E+01_JPRB, 0.288785E+01_JPRB, 0.291011E+01_JPRB &
  &, 0.293177E+01_JPRB, 0.295284E+01_JPRB, 0.297331E+01_JPRB, 0.299318E+01_JPRB &
  &, 0.301243E+01_JPRB, 0.303107E+01_JPRB, 0.304910E+01_JPRB &
  &, 0.306650E+01_JPRB, 0.308327E+01_JPRB, 0.309941E+01_JPRB, 0.311493E+01_JPRB &
  &, 0.312981E+01_JPRB, 0.314407E+01_JPRB, 0.315769E+01_JPRB &
  &, 0.317065E+01_JPRB, 0.318300E+01_JPRB, 0.319470E+01_JPRB, 0.320577E+01_JPRB &
  &, 0.321619E+01_JPRB, 0.322598E+01_JPRB, 0.323513E+01_JPRB &
  &, 0.324364E+01_JPRB, 0.325155E+01_JPRB, 0.325875E+01_JPRB, 0.326540E+01_JPRB &
  &, 0.327140E+01_JPRB, 0.327677E+01_JPRB, 0.328150E+01_JPRB &
  &, 0.328563E+01_JPRB, 0.328913E+01_JPRB, 0.329202E+01_JPRB, 0.329432E+01_JPRB &
  &, 0.329601E+01_JPRB, 0.329706E+01_JPRB, 0.329754E+01_JPRB &
  &, 0.329744E+01_JPRB, 0.329673E+01_JPRB, 0.329545E+01_JPRB, 0.329358E+01_JPRB &
  &, 0.329112E+01_JPRB, 0.328813E+01_JPRB, 0.328454E+01_JPRB &
  &, 0.328044E+01_JPRB, 0.327574E+01_JPRB, 0.327052E+01_JPRB, 0.326477E+01_JPRB &
  &, 0.325847E+01_JPRB, 0.325164E+01_JPRB, 0.324434E+01_JPRB &
  &, 0.323647E+01_JPRB, 0.322813E+01_JPRB, 0.321926E+01_JPRB, 0.320991E+01_JPRB &
  &, 0.320008E+01_JPRB, 0.318978E+01_JPRB, 0.317899E+01_JPRB &
  &, 0.316777E+01_JPRB, 0.315610E+01_JPRB, 0.314396E+01_JPRB, 0.313136E+01_JPRB &
  &, 0.311838E+01_JPRB, 0.310495E+01_JPRB, 0.309108E+01_JPRB &
  &, 0.307684E+01_JPRB, 0.306222E+01_JPRB, 0.304717E+01_JPRB, 0.303173E+01_JPRB &
  &, 0.301592E+01_JPRB, 0.299970E+01_JPRB, 0.298326E+01_JPRB &
  &, 0.296640E+01_JPRB, 0.294921E+01_JPRB, 0.293164E+01_JPRB, 0.291379E+01_JPRB &
  &, 0.289561E+01_JPRB, 0.287712E+01_JPRB, 0.285836E+01_JPRB &
  &, 0.283927E+01_JPRB, 0.281990E+01_JPRB, 0.280031E+01_JPRB, 0.278041E+01_JPRB &
  &, 0.276029E+01_JPRB, 0.273990E+01_JPRB, 0.271927E+01_JPRB/)
XCW( 910, :) = (/ &
  &  0.113648E+01_JPRB, 0.117129E+01_JPRB, 0.120634E+01_JPRB, 0.124162E+01_JPRB &
  &, 0.127709E+01_JPRB, 0.131275E+01_JPRB, 0.134858E+01_JPRB &
  &, 0.138455E+01_JPRB, 0.142065E+01_JPRB, 0.145686E+01_JPRB, 0.149316E+01_JPRB &
  &, 0.152953E+01_JPRB, 0.156596E+01_JPRB, 0.160241E+01_JPRB &
  &, 0.163888E+01_JPRB, 0.167535E+01_JPRB, 0.171178E+01_JPRB, 0.174818E+01_JPRB &
  &, 0.178452E+01_JPRB, 0.182077E+01_JPRB, 0.185692E+01_JPRB &
  &, 0.189295E+01_JPRB, 0.192885E+01_JPRB, 0.196459E+01_JPRB, 0.200016E+01_JPRB &
  &, 0.203553E+01_JPRB, 0.207069E+01_JPRB, 0.210563E+01_JPRB &
  &, 0.214031E+01_JPRB, 0.217474E+01_JPRB, 0.220888E+01_JPRB, 0.224273E+01_JPRB &
  &, 0.227626E+01_JPRB, 0.230946E+01_JPRB, 0.234232E+01_JPRB &
  &, 0.237482E+01_JPRB, 0.240694E+01_JPRB, 0.243868E+01_JPRB, 0.247000E+01_JPRB &
  &, 0.250091E+01_JPRB, 0.253139E+01_JPRB, 0.256142E+01_JPRB &
  &, 0.259099E+01_JPRB, 0.262009E+01_JPRB, 0.264872E+01_JPRB, 0.267685E+01_JPRB &
  &, 0.270448E+01_JPRB, 0.273160E+01_JPRB, 0.275818E+01_JPRB &
  &, 0.278425E+01_JPRB, 0.280976E+01_JPRB, 0.283472E+01_JPRB, 0.285913E+01_JPRB &
  &, 0.288297E+01_JPRB, 0.290624E+01_JPRB, 0.292893E+01_JPRB &
  &, 0.295102E+01_JPRB, 0.297252E+01_JPRB, 0.299342E+01_JPRB, 0.301373E+01_JPRB &
  &, 0.303341E+01_JPRB, 0.305250E+01_JPRB, 0.307096E+01_JPRB &
  &, 0.308880E+01_JPRB, 0.310601E+01_JPRB, 0.312259E+01_JPRB, 0.313856E+01_JPRB &
  &, 0.315388E+01_JPRB, 0.316856E+01_JPRB, 0.318261E+01_JPRB &
  &, 0.319604E+01_JPRB, 0.320882E+01_JPRB, 0.322095E+01_JPRB, 0.323245E+01_JPRB &
  &, 0.324330E+01_JPRB, 0.325354E+01_JPRB, 0.326312E+01_JPRB &
  &, 0.327205E+01_JPRB, 0.328037E+01_JPRB, 0.328804E+01_JPRB, 0.329510E+01_JPRB &
  &, 0.330152E+01_JPRB, 0.330731E+01_JPRB, 0.331246E+01_JPRB &
  &, 0.331701E+01_JPRB, 0.332094E+01_JPRB, 0.332423E+01_JPRB, 0.332692E+01_JPRB &
  &, 0.332903E+01_JPRB, 0.333048E+01_JPRB, 0.333137E+01_JPRB &
  &, 0.333164E+01_JPRB, 0.333135E+01_JPRB, 0.333042E+01_JPRB, 0.332894E+01_JPRB &
  &, 0.332689E+01_JPRB, 0.332426E+01_JPRB, 0.332102E+01_JPRB &
  &, 0.331704E+01_JPRB, 0.331300E+01_JPRB, 0.330815E+01_JPRB, 0.330273E+01_JPRB &
  &, 0.329680E+01_JPRB, 0.329033E+01_JPRB, 0.328331E+01_JPRB &
  &, 0.327580E+01_JPRB, 0.326777E+01_JPRB, 0.325925E+01_JPRB, 0.325025E+01_JPRB &
  &, 0.324072E+01_JPRB, 0.323072E+01_JPRB, 0.322025E+01_JPRB &
  &, 0.320932E+01_JPRB, 0.319793E+01_JPRB, 0.318606E+01_JPRB, 0.317378E+01_JPRB &
  &, 0.316106E+01_JPRB, 0.314788E+01_JPRB, 0.313431E+01_JPRB &
  &, 0.312032E+01_JPRB, 0.310593E+01_JPRB, 0.309112E+01_JPRB, 0.307595E+01_JPRB &
  &, 0.306035E+01_JPRB, 0.304440E+01_JPRB, 0.302811E+01_JPRB &
  &, 0.301144E+01_JPRB, 0.299444E+01_JPRB, 0.297711E+01_JPRB, 0.295943E+01_JPRB &
  &, 0.294141E+01_JPRB, 0.292315E+01_JPRB, 0.290453E+01_JPRB &
  &, 0.288559E+01_JPRB, 0.286641E+01_JPRB, 0.284695E+01_JPRB, 0.282717E+01_JPRB &
  &, 0.280715E+01_JPRB, 0.278686E+01_JPRB, 0.276638E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART130',1,ZHOOK_HANDLE)
END SUBROUTINE PART130

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART131

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART131',0,ZHOOK_HANDLE)

XCW( 911, :) = (/ &
  &  0.113715E+01_JPRB, 0.117215E+01_JPRB, 0.120739E+01_JPRB, 0.124287E+01_JPRB &
  &, 0.127855E+01_JPRB, 0.131442E+01_JPRB, 0.135047E+01_JPRB &
  &, 0.138666E+01_JPRB, 0.142300E+01_JPRB, 0.145945E+01_JPRB, 0.149599E+01_JPRB &
  &, 0.153261E+01_JPRB, 0.156929E+01_JPRB, 0.160601E+01_JPRB &
  &, 0.164275E+01_JPRB, 0.167949E+01_JPRB, 0.171621E+01_JPRB, 0.175289E+01_JPRB &
  &, 0.178952E+01_JPRB, 0.182607E+01_JPRB, 0.186253E+01_JPRB &
  &, 0.189887E+01_JPRB, 0.193508E+01_JPRB, 0.197114E+01_JPRB, 0.200704E+01_JPRB &
  &, 0.204274E+01_JPRB, 0.207824E+01_JPRB, 0.211352E+01_JPRB &
  &, 0.214855E+01_JPRB, 0.218332E+01_JPRB, 0.221783E+01_JPRB, 0.225203E+01_JPRB &
  &, 0.228593E+01_JPRB, 0.231950E+01_JPRB, 0.235274E+01_JPRB &
  &, 0.238561E+01_JPRB, 0.241812E+01_JPRB, 0.245023E+01_JPRB, 0.248195E+01_JPRB &
  &, 0.251325E+01_JPRB, 0.254413E+01_JPRB, 0.257455E+01_JPRB &
  &, 0.260454E+01_JPRB, 0.263405E+01_JPRB, 0.266308E+01_JPRB, 0.269163E+01_JPRB &
  &, 0.271968E+01_JPRB, 0.274721E+01_JPRB, 0.277423E+01_JPRB &
  &, 0.280070E+01_JPRB, 0.282665E+01_JPRB, 0.285204E+01_JPRB, 0.287686E+01_JPRB &
  &, 0.290115E+01_JPRB, 0.292485E+01_JPRB, 0.294798E+01_JPRB &
  &, 0.297051E+01_JPRB, 0.299246E+01_JPRB, 0.301380E+01_JPRB, 0.303454E+01_JPRB &
  &, 0.305468E+01_JPRB, 0.307420E+01_JPRB, 0.309310E+01_JPRB &
  &, 0.311139E+01_JPRB, 0.312905E+01_JPRB, 0.314608E+01_JPRB, 0.316248E+01_JPRB &
  &, 0.317824E+01_JPRB, 0.319338E+01_JPRB, 0.320789E+01_JPRB &
  &, 0.322175E+01_JPRB, 0.323496E+01_JPRB, 0.324755E+01_JPRB, 0.325949E+01_JPRB &
  &, 0.327081E+01_JPRB, 0.328146E+01_JPRB, 0.329147E+01_JPRB &
  &, 0.330087E+01_JPRB, 0.330962E+01_JPRB, 0.331774E+01_JPRB, 0.332520E+01_JPRB &
  &, 0.333205E+01_JPRB, 0.333828E+01_JPRB, 0.334386E+01_JPRB &
  &, 0.334884E+01_JPRB, 0.335317E+01_JPRB, 0.335689E+01_JPRB, 0.336002E+01_JPRB &
  &, 0.336250E+01_JPRB, 0.336438E+01_JPRB, 0.336568E+01_JPRB &
  &, 0.336637E+01_JPRB, 0.336645E+01_JPRB, 0.336596E+01_JPRB, 0.336487E+01_JPRB &
  &, 0.336322E+01_JPRB, 0.336097E+01_JPRB, 0.335816E+01_JPRB &
  &, 0.335475E+01_JPRB, 0.335084E+01_JPRB, 0.334634E+01_JPRB, 0.334130E+01_JPRB &
  &, 0.333570E+01_JPRB, 0.332961E+01_JPRB, 0.332296E+01_JPRB &
  &, 0.331578E+01_JPRB, 0.330811E+01_JPRB, 0.329991E+01_JPRB, 0.329123E+01_JPRB &
  &, 0.328200E+01_JPRB, 0.327234E+01_JPRB, 0.326218E+01_JPRB &
  &, 0.325154E+01_JPRB, 0.324039E+01_JPRB, 0.322890E+01_JPRB, 0.321690E+01_JPRB &
  &, 0.320445E+01_JPRB, 0.319159E+01_JPRB, 0.317827E+01_JPRB &
  &, 0.316454E+01_JPRB, 0.315040E+01_JPRB, 0.313583E+01_JPRB, 0.312090E+01_JPRB &
  &, 0.310558E+01_JPRB, 0.308985E+01_JPRB, 0.307377E+01_JPRB &
  &, 0.305732E+01_JPRB, 0.304057E+01_JPRB, 0.302343E+01_JPRB, 0.300594E+01_JPRB &
  &, 0.298810E+01_JPRB, 0.297000E+01_JPRB, 0.295155E+01_JPRB &
  &, 0.293282E+01_JPRB, 0.291378E+01_JPRB, 0.289446E+01_JPRB, 0.287480E+01_JPRB &
  &, 0.285497E+01_JPRB, 0.283479E+01_JPRB, 0.281442E+01_JPRB/)
XCW( 912, :) = (/ &
  &  0.113783E+01_JPRB, 0.117302E+01_JPRB, 0.120846E+01_JPRB, 0.124413E+01_JPRB &
  &, 0.128002E+01_JPRB, 0.131611E+01_JPRB, 0.135237E+01_JPRB &
  &, 0.138880E+01_JPRB, 0.142536E+01_JPRB, 0.146205E+01_JPRB, 0.149884E+01_JPRB &
  &, 0.153572E+01_JPRB, 0.157266E+01_JPRB, 0.160964E+01_JPRB &
  &, 0.164665E+01_JPRB, 0.168367E+01_JPRB, 0.172068E+01_JPRB, 0.175765E+01_JPRB &
  &, 0.179458E+01_JPRB, 0.183143E+01_JPRB, 0.186819E+01_JPRB &
  &, 0.190485E+01_JPRB, 0.194138E+01_JPRB, 0.197777E+01_JPRB, 0.201399E+01_JPRB &
  &, 0.205003E+01_JPRB, 0.208587E+01_JPRB, 0.212149E+01_JPRB &
  &, 0.215687E+01_JPRB, 0.219201E+01_JPRB, 0.222687E+01_JPRB, 0.226144E+01_JPRB &
  &, 0.229571E+01_JPRB, 0.232966E+01_JPRB, 0.236326E+01_JPRB &
  &, 0.239653E+01_JPRB, 0.242942E+01_JPRB, 0.246192E+01_JPRB, 0.249403E+01_JPRB &
  &, 0.252574E+01_JPRB, 0.255701E+01_JPRB, 0.258785E+01_JPRB &
  &, 0.261824E+01_JPRB, 0.264817E+01_JPRB, 0.267761E+01_JPRB, 0.270658E+01_JPRB &
  &, 0.273505E+01_JPRB, 0.276301E+01_JPRB, 0.279045E+01_JPRB &
  &, 0.281736E+01_JPRB, 0.284374E+01_JPRB, 0.286957E+01_JPRB, 0.289484E+01_JPRB &
  &, 0.291956E+01_JPRB, 0.294369E+01_JPRB, 0.296727E+01_JPRB &
  &, 0.299024E+01_JPRB, 0.301263E+01_JPRB, 0.303442E+01_JPRB, 0.305562E+01_JPRB &
  &, 0.307621E+01_JPRB, 0.309617E+01_JPRB, 0.311553E+01_JPRB &
  &, 0.313426E+01_JPRB, 0.315239E+01_JPRB, 0.316987E+01_JPRB, 0.318672E+01_JPRB &
  &, 0.320294E+01_JPRB, 0.321854E+01_JPRB, 0.323347E+01_JPRB &
  &, 0.324779E+01_JPRB, 0.326147E+01_JPRB, 0.327450E+01_JPRB, 0.328691E+01_JPRB &
  &, 0.329865E+01_JPRB, 0.330976E+01_JPRB, 0.332023E+01_JPRB &
  &, 0.333004E+01_JPRB, 0.333927E+01_JPRB, 0.334783E+01_JPRB, 0.335575E+01_JPRB &
  &, 0.336303E+01_JPRB, 0.336970E+01_JPRB, 0.337572E+01_JPRB &
  &, 0.338112E+01_JPRB, 0.338589E+01_JPRB, 0.339005E+01_JPRB, 0.339359E+01_JPRB &
  &, 0.339648E+01_JPRB, 0.339881E+01_JPRB, 0.340051E+01_JPRB &
  &, 0.340162E+01_JPRB, 0.340210E+01_JPRB, 0.340201E+01_JPRB, 0.340133E+01_JPRB &
  &, 0.340005E+01_JPRB, 0.339820E+01_JPRB, 0.339579E+01_JPRB &
  &, 0.339278E+01_JPRB, 0.338922E+01_JPRB, 0.338511E+01_JPRB, 0.338047E+01_JPRB &
  &, 0.337522E+01_JPRB, 0.336936E+01_JPRB, 0.336320E+01_JPRB &
  &, 0.335639E+01_JPRB, 0.334906E+01_JPRB, 0.334119E+01_JPRB, 0.333287E+01_JPRB &
  &, 0.332401E+01_JPRB, 0.331467E+01_JPRB, 0.330482E+01_JPRB &
  &, 0.329448E+01_JPRB, 0.328373E+01_JPRB, 0.327248E+01_JPRB, 0.326077E+01_JPRB &
  &, 0.324861E+01_JPRB, 0.323602E+01_JPRB, 0.322298E+01_JPRB &
  &, 0.320951E+01_JPRB, 0.319563E+01_JPRB, 0.318136E+01_JPRB, 0.316668E+01_JPRB &
  &, 0.315160E+01_JPRB, 0.313610E+01_JPRB, 0.312030E+01_JPRB &
  &, 0.310407E+01_JPRB, 0.308748E+01_JPRB, 0.307055E+01_JPRB, 0.305331E+01_JPRB &
  &, 0.303566E+01_JPRB, 0.301774E+01_JPRB, 0.299946E+01_JPRB &
  &, 0.298090E+01_JPRB, 0.296202E+01_JPRB, 0.294290E+01_JPRB, 0.292345E+01_JPRB &
  &, 0.290369E+01_JPRB, 0.288370E+01_JPRB, 0.286344E+01_JPRB/)
XCW( 913, :) = (/ &
  &  0.113852E+01_JPRB, 0.117389E+01_JPRB, 0.120953E+01_JPRB, 0.124540E+01_JPRB &
  &, 0.128150E+01_JPRB, 0.131780E+01_JPRB, 0.135429E+01_JPRB &
  &, 0.139095E+01_JPRB, 0.142775E+01_JPRB, 0.146468E+01_JPRB, 0.150173E+01_JPRB &
  &, 0.153886E+01_JPRB, 0.157606E+01_JPRB, 0.161331E+01_JPRB &
  &, 0.165060E+01_JPRB, 0.168790E+01_JPRB, 0.172519E+01_JPRB, 0.176246E+01_JPRB &
  &, 0.179968E+01_JPRB, 0.183684E+01_JPRB, 0.187392E+01_JPRB &
  &, 0.191089E+01_JPRB, 0.194775E+01_JPRB, 0.198446E+01_JPRB, 0.202102E+01_JPRB &
  &, 0.205740E+01_JPRB, 0.209358E+01_JPRB, 0.212955E+01_JPRB &
  &, 0.216529E+01_JPRB, 0.220078E+01_JPRB, 0.223601E+01_JPRB, 0.227095E+01_JPRB &
  &, 0.230559E+01_JPRB, 0.233992E+01_JPRB, 0.237391E+01_JPRB &
  &, 0.240756E+01_JPRB, 0.244084E+01_JPRB, 0.247375E+01_JPRB, 0.250626E+01_JPRB &
  &, 0.253836E+01_JPRB, 0.257005E+01_JPRB, 0.260130E+01_JPRB &
  &, 0.263211E+01_JPRB, 0.266245E+01_JPRB, 0.269232E+01_JPRB, 0.272171E+01_JPRB &
  &, 0.275060E+01_JPRB, 0.277900E+01_JPRB, 0.280687E+01_JPRB &
  &, 0.283422E+01_JPRB, 0.286104E+01_JPRB, 0.288731E+01_JPRB, 0.291303E+01_JPRB &
  &, 0.293819E+01_JPRB, 0.296278E+01_JPRB, 0.298679E+01_JPRB &
  &, 0.301022E+01_JPRB, 0.303307E+01_JPRB, 0.305532E+01_JPRB, 0.307696E+01_JPRB &
  &, 0.309800E+01_JPRB, 0.311843E+01_JPRB, 0.313825E+01_JPRB &
  &, 0.315745E+01_JPRB, 0.317602E+01_JPRB, 0.319397E+01_JPRB, 0.321128E+01_JPRB &
  &, 0.322796E+01_JPRB, 0.324401E+01_JPRB, 0.325943E+01_JPRB &
  &, 0.327419E+01_JPRB, 0.328834E+01_JPRB, 0.330182E+01_JPRB, 0.331469E+01_JPRB &
  &, 0.332689E+01_JPRB, 0.333845E+01_JPRB, 0.334938E+01_JPRB &
  &, 0.335968E+01_JPRB, 0.336933E+01_JPRB, 0.337834E+01_JPRB, 0.338670E+01_JPRB &
  &, 0.339446E+01_JPRB, 0.340155E+01_JPRB, 0.340802E+01_JPRB &
  &, 0.341386E+01_JPRB, 0.341906E+01_JPRB, 0.342367E+01_JPRB, 0.342763E+01_JPRB &
  &, 0.343097E+01_JPRB, 0.343372E+01_JPRB, 0.343585E+01_JPRB &
  &, 0.343737E+01_JPRB, 0.343827E+01_JPRB, 0.343860E+01_JPRB, 0.343833E+01_JPRB &
  &, 0.343746E+01_JPRB, 0.343603E+01_JPRB, 0.343402E+01_JPRB &
  &, 0.343141E+01_JPRB, 0.342812E+01_JPRB, 0.342452E+01_JPRB, 0.342024E+01_JPRB &
  &, 0.341539E+01_JPRB, 0.341003E+01_JPRB, 0.340412E+01_JPRB &
  &, 0.339766E+01_JPRB, 0.339067E+01_JPRB, 0.338317E+01_JPRB, 0.337519E+01_JPRB &
  &, 0.336666E+01_JPRB, 0.335765E+01_JPRB, 0.334816E+01_JPRB &
  &, 0.333819E+01_JPRB, 0.332770E+01_JPRB, 0.331676E+01_JPRB, 0.330539E+01_JPRB &
  &, 0.329352E+01_JPRB, 0.328123E+01_JPRB, 0.326847E+01_JPRB &
  &, 0.325533E+01_JPRB, 0.324172E+01_JPRB, 0.322767E+01_JPRB, 0.321329E+01_JPRB &
  &, 0.319842E+01_JPRB, 0.318321E+01_JPRB, 0.316760E+01_JPRB &
  &, 0.315165E+01_JPRB, 0.313528E+01_JPRB, 0.311851E+01_JPRB, 0.310154E+01_JPRB &
  &, 0.308415E+01_JPRB, 0.306642E+01_JPRB, 0.304833E+01_JPRB &
  &, 0.302995E+01_JPRB, 0.301124E+01_JPRB, 0.299179E+01_JPRB, 0.297299E+01_JPRB &
  &, 0.295337E+01_JPRB, 0.293351E+01_JPRB, 0.291338E+01_JPRB/)
XCW( 914, :) = (/ &
  &  0.113921E+01_JPRB, 0.117477E+01_JPRB, 0.121061E+01_JPRB, 0.124669E+01_JPRB &
  &, 0.128300E+01_JPRB, 0.131952E+01_JPRB, 0.135623E+01_JPRB &
  &, 0.139312E+01_JPRB, 0.143016E+01_JPRB, 0.146734E+01_JPRB, 0.150464E+01_JPRB &
  &, 0.154203E+01_JPRB, 0.157949E+01_JPRB, 0.161702E+01_JPRB &
  &, 0.165458E+01_JPRB, 0.169217E+01_JPRB, 0.172975E+01_JPRB, 0.176732E+01_JPRB &
  &, 0.180484E+01_JPRB, 0.184231E+01_JPRB, 0.187970E+01_JPRB &
  &, 0.191700E+01_JPRB, 0.195418E+01_JPRB, 0.199123E+01_JPRB, 0.202812E+01_JPRB &
  &, 0.206484E+01_JPRB, 0.210138E+01_JPRB, 0.213770E+01_JPRB &
  &, 0.217380E+01_JPRB, 0.220966E+01_JPRB, 0.224525E+01_JPRB, 0.228057E+01_JPRB &
  &, 0.231559E+01_JPRB, 0.235030E+01_JPRB, 0.238469E+01_JPRB &
  &, 0.241872E+01_JPRB, 0.245240E+01_JPRB, 0.248571E+01_JPRB, 0.251862E+01_JPRB &
  &, 0.255114E+01_JPRB, 0.258324E+01_JPRB, 0.261491E+01_JPRB &
  &, 0.264614E+01_JPRB, 0.267691E+01_JPRB, 0.270721E+01_JPRB, 0.273702E+01_JPRB &
  &, 0.276635E+01_JPRB, 0.279519E+01_JPRB, 0.282349E+01_JPRB &
  &, 0.285129E+01_JPRB, 0.287856E+01_JPRB, 0.290527E+01_JPRB, 0.293144E+01_JPRB &
  &, 0.295706E+01_JPRB, 0.298210E+01_JPRB, 0.300656E+01_JPRB &
  &, 0.303046E+01_JPRB, 0.305376E+01_JPRB, 0.307648E+01_JPRB, 0.309859E+01_JPRB &
  &, 0.312009E+01_JPRB, 0.314096E+01_JPRB, 0.316126E+01_JPRB &
  &, 0.318093E+01_JPRB, 0.319996E+01_JPRB, 0.321838E+01_JPRB, 0.323617E+01_JPRB &
  &, 0.325329E+01_JPRB, 0.326981E+01_JPRB, 0.328572E+01_JPRB &
  &, 0.330095E+01_JPRB, 0.331558E+01_JPRB, 0.332952E+01_JPRB, 0.334285E+01_JPRB &
  &, 0.335551E+01_JPRB, 0.336757E+01_JPRB, 0.337895E+01_JPRB &
  &, 0.338970E+01_JPRB, 0.339982E+01_JPRB, 0.340928E+01_JPRB, 0.341812E+01_JPRB &
  &, 0.342631E+01_JPRB, 0.343388E+01_JPRB, 0.344079E+01_JPRB &
  &, 0.344709E+01_JPRB, 0.345274E+01_JPRB, 0.345778E+01_JPRB, 0.346220E+01_JPRB &
  &, 0.346598E+01_JPRB, 0.346915E+01_JPRB, 0.347171E+01_JPRB &
  &, 0.347366E+01_JPRB, 0.347502E+01_JPRB, 0.347577E+01_JPRB, 0.347593E+01_JPRB &
  &, 0.347548E+01_JPRB, 0.347443E+01_JPRB, 0.347284E+01_JPRB &
  &, 0.347062E+01_JPRB, 0.346789E+01_JPRB, 0.346456E+01_JPRB, 0.346065E+01_JPRB &
  &, 0.345620E+01_JPRB, 0.345122E+01_JPRB, 0.344566E+01_JPRB &
  &, 0.343960E+01_JPRB, 0.343293E+01_JPRB, 0.342587E+01_JPRB, 0.341823E+01_JPRB &
  &, 0.341004E+01_JPRB, 0.340141E+01_JPRB, 0.339225E+01_JPRB &
  &, 0.338256E+01_JPRB, 0.337244E+01_JPRB, 0.336182E+01_JPRB, 0.335076E+01_JPRB &
  &, 0.333920E+01_JPRB, 0.332721E+01_JPRB, 0.331480E+01_JPRB &
  &, 0.330189E+01_JPRB, 0.328852E+01_JPRB, 0.327484E+01_JPRB, 0.326069E+01_JPRB &
  &, 0.324613E+01_JPRB, 0.323118E+01_JPRB, 0.321582E+01_JPRB &
  &, 0.320011E+01_JPRB, 0.318398E+01_JPRB, 0.316750E+01_JPRB, 0.315069E+01_JPRB &
  &, 0.313351E+01_JPRB, 0.311599E+01_JPRB, 0.309810E+01_JPRB &
  &, 0.307990E+01_JPRB, 0.306144E+01_JPRB, 0.304260E+01_JPRB, 0.302347E+01_JPRB &
  &, 0.300407E+01_JPRB, 0.298436E+01_JPRB, 0.296437E+01_JPRB/)
XCW( 915, :) = (/ &
  &  0.113991E+01_JPRB, 0.117567E+01_JPRB, 0.121170E+01_JPRB, 0.124798E+01_JPRB &
  &, 0.128451E+01_JPRB, 0.132125E+01_JPRB, 0.135819E+01_JPRB &
  &, 0.139532E+01_JPRB, 0.143260E+01_JPRB, 0.147003E+01_JPRB, 0.150758E+01_JPRB &
  &, 0.154523E+01_JPRB, 0.158296E+01_JPRB, 0.162076E+01_JPRB &
  &, 0.165861E+01_JPRB, 0.169648E+01_JPRB, 0.173436E+01_JPRB, 0.177223E+01_JPRB &
  &, 0.181006E+01_JPRB, 0.184784E+01_JPRB, 0.188555E+01_JPRB &
  &, 0.192317E+01_JPRB, 0.196068E+01_JPRB, 0.199807E+01_JPRB, 0.203530E+01_JPRB &
  &, 0.207237E+01_JPRB, 0.210926E+01_JPRB, 0.214594E+01_JPRB &
  &, 0.218241E+01_JPRB, 0.221863E+01_JPRB, 0.225460E+01_JPRB, 0.229030E+01_JPRB &
  &, 0.232570E+01_JPRB, 0.236080E+01_JPRB, 0.239558E+01_JPRB &
  &, 0.243001E+01_JPRB, 0.246410E+01_JPRB, 0.249781E+01_JPRB, 0.253115E+01_JPRB &
  &, 0.256407E+01_JPRB, 0.259660E+01_JPRB, 0.262869E+01_JPRB &
  &, 0.266033E+01_JPRB, 0.269153E+01_JPRB, 0.272227E+01_JPRB, 0.275252E+01_JPRB &
  &, 0.278230E+01_JPRB, 0.281158E+01_JPRB, 0.284034E+01_JPRB &
  &, 0.286858E+01_JPRB, 0.289629E+01_JPRB, 0.292346E+01_JPRB, 0.295010E+01_JPRB &
  &, 0.297616E+01_JPRB, 0.300167E+01_JPRB, 0.302660E+01_JPRB &
  &, 0.305096E+01_JPRB, 0.307473E+01_JPRB, 0.309791E+01_JPRB, 0.312049E+01_JPRB &
  &, 0.314246E+01_JPRB, 0.316382E+01_JPRB, 0.318458E+01_JPRB &
  &, 0.320472E+01_JPRB, 0.322425E+01_JPRB, 0.324312E+01_JPRB, 0.326140E+01_JPRB &
  &, 0.327902E+01_JPRB, 0.329601E+01_JPRB, 0.331238E+01_JPRB &
  &, 0.332809E+01_JPRB, 0.334318E+01_JPRB, 0.335761E+01_JPRB, 0.337141E+01_JPRB &
  &, 0.338455E+01_JPRB, 0.339706E+01_JPRB, 0.340894E+01_JPRB &
  &, 0.342012E+01_JPRB, 0.343073E+01_JPRB, 0.344067E+01_JPRB, 0.344998E+01_JPRB &
  &, 0.345864E+01_JPRB, 0.346667E+01_JPRB, 0.347404E+01_JPRB &
  &, 0.348081E+01_JPRB, 0.348690E+01_JPRB, 0.349241E+01_JPRB, 0.349727E+01_JPRB &
  &, 0.350152E+01_JPRB, 0.350513E+01_JPRB, 0.350813E+01_JPRB &
  &, 0.351055E+01_JPRB, 0.351231E+01_JPRB, 0.351350E+01_JPRB, 0.351403E+01_JPRB &
  &, 0.351404E+01_JPRB, 0.351346E+01_JPRB, 0.351227E+01_JPRB &
  &, 0.351047E+01_JPRB, 0.350813E+01_JPRB, 0.350523E+01_JPRB, 0.350173E+01_JPRB &
  &, 0.349767E+01_JPRB, 0.349306E+01_JPRB, 0.348792E+01_JPRB &
  &, 0.348223E+01_JPRB, 0.347600E+01_JPRB, 0.346926E+01_JPRB, 0.346199E+01_JPRB &
  &, 0.345415E+01_JPRB, 0.344586E+01_JPRB, 0.343705E+01_JPRB &
  &, 0.342775E+01_JPRB, 0.341796E+01_JPRB, 0.340767E+01_JPRB, 0.339694E+01_JPRB &
  &, 0.338570E+01_JPRB, 0.337401E+01_JPRB, 0.336191E+01_JPRB &
  &, 0.334931E+01_JPRB, 0.333633E+01_JPRB, 0.332289E+01_JPRB, 0.330902E+01_JPRB &
  &, 0.329468E+01_JPRB, 0.328001E+01_JPRB, 0.326496E+01_JPRB &
  &, 0.324946E+01_JPRB, 0.323363E+01_JPRB, 0.321739E+01_JPRB, 0.320076E+01_JPRB &
  &, 0.318381E+01_JPRB, 0.316651E+01_JPRB, 0.314883E+01_JPRB &
  &, 0.313041E+01_JPRB, 0.311257E+01_JPRB, 0.309391E+01_JPRB, 0.307502E+01_JPRB &
  &, 0.305573E+01_JPRB, 0.303625E+01_JPRB, 0.301641E+01_JPRB/)
XCW( 916, :) = (/ &
  &  0.114061E+01_JPRB, 0.117656E+01_JPRB, 0.121280E+01_JPRB, 0.124929E+01_JPRB &
  &, 0.128603E+01_JPRB, 0.132300E+01_JPRB, 0.136017E+01_JPRB &
  &, 0.139753E+01_JPRB, 0.143506E+01_JPRB, 0.147274E+01_JPRB, 0.151055E+01_JPRB &
  &, 0.154846E+01_JPRB, 0.158647E+01_JPRB, 0.162455E+01_JPRB &
  &, 0.166268E+01_JPRB, 0.170084E+01_JPRB, 0.173902E+01_JPRB, 0.177719E+01_JPRB &
  &, 0.181533E+01_JPRB, 0.185343E+01_JPRB, 0.189146E+01_JPRB &
  &, 0.192941E+01_JPRB, 0.196726E+01_JPRB, 0.200498E+01_JPRB, 0.204256E+01_JPRB &
  &, 0.207998E+01_JPRB, 0.211723E+01_JPRB, 0.215428E+01_JPRB &
  &, 0.219111E+01_JPRB, 0.222771E+01_JPRB, 0.226406E+01_JPRB, 0.230014E+01_JPRB &
  &, 0.233593E+01_JPRB, 0.237143E+01_JPRB, 0.240660E+01_JPRB &
  &, 0.244144E+01_JPRB, 0.247594E+01_JPRB, 0.251006E+01_JPRB, 0.254381E+01_JPRB &
  &, 0.257715E+01_JPRB, 0.261011E+01_JPRB, 0.264262E+01_JPRB &
  &, 0.267471E+01_JPRB, 0.270634E+01_JPRB, 0.273752E+01_JPRB, 0.276823E+01_JPRB &
  &, 0.279844E+01_JPRB, 0.282817E+01_JPRB, 0.285737E+01_JPRB &
  &, 0.288607E+01_JPRB, 0.291425E+01_JPRB, 0.294188E+01_JPRB, 0.296897E+01_JPRB &
  &, 0.299551E+01_JPRB, 0.302148E+01_JPRB, 0.304689E+01_JPRB &
  &, 0.307173E+01_JPRB, 0.309596E+01_JPRB, 0.311962E+01_JPRB, 0.314268E+01_JPRB &
  &, 0.316514E+01_JPRB, 0.318698E+01_JPRB, 0.320823E+01_JPRB &
  &, 0.322884E+01_JPRB, 0.324884E+01_JPRB, 0.326822E+01_JPRB, 0.328697E+01_JPRB &
  &, 0.330507E+01_JPRB, 0.332256E+01_JPRB, 0.333939E+01_JPRB &
  &, 0.335559E+01_JPRB, 0.337117E+01_JPRB, 0.338610E+01_JPRB, 0.340038E+01_JPRB &
  &, 0.341400E+01_JPRB, 0.342700E+01_JPRB, 0.343934E+01_JPRB &
  &, 0.345106E+01_JPRB, 0.346211E+01_JPRB, 0.347253E+01_JPRB, 0.348231E+01_JPRB &
  &, 0.349143E+01_JPRB, 0.349992E+01_JPRB, 0.350779E+01_JPRB &
  &, 0.351501E+01_JPRB, 0.352160E+01_JPRB, 0.352754E+01_JPRB, 0.353288E+01_JPRB &
  &, 0.353757E+01_JPRB, 0.354166E+01_JPRB, 0.354511E+01_JPRB &
  &, 0.354797E+01_JPRB, 0.355019E+01_JPRB, 0.355182E+01_JPRB, 0.355283E+01_JPRB &
  &, 0.355325E+01_JPRB, 0.355308E+01_JPRB, 0.355233E+01_JPRB &
  &, 0.355097E+01_JPRB, 0.354903E+01_JPRB, 0.354652E+01_JPRB, 0.354346E+01_JPRB &
  &, 0.353983E+01_JPRB, 0.353565E+01_JPRB, 0.353081E+01_JPRB &
  &, 0.352558E+01_JPRB, 0.351973E+01_JPRB, 0.351336E+01_JPRB, 0.350646E+01_JPRB &
  &, 0.349903E+01_JPRB, 0.349110E+01_JPRB, 0.348265E+01_JPRB &
  &, 0.347370E+01_JPRB, 0.346425E+01_JPRB, 0.345435E+01_JPRB, 0.344391E+01_JPRB &
  &, 0.343305E+01_JPRB, 0.342169E+01_JPRB, 0.340985E+01_JPRB &
  &, 0.339762E+01_JPRB, 0.338490E+01_JPRB, 0.337176E+01_JPRB, 0.335819E+01_JPRB &
  &, 0.334419E+01_JPRB, 0.332980E+01_JPRB, 0.331498E+01_JPRB &
  &, 0.329974E+01_JPRB, 0.328418E+01_JPRB, 0.326819E+01_JPRB, 0.325180E+01_JPRB &
  &, 0.323509E+01_JPRB, 0.321803E+01_JPRB, 0.320057E+01_JPRB &
  &, 0.318280E+01_JPRB, 0.316474E+01_JPRB, 0.314629E+01_JPRB, 0.312753E+01_JPRB &
  &, 0.310849E+01_JPRB, 0.308912E+01_JPRB, 0.306951E+01_JPRB/)
XCW( 917, :) = (/ &
  &  0.114132E+01_JPRB, 0.117747E+01_JPRB, 0.121391E+01_JPRB, 0.125062E+01_JPRB &
  &, 0.128758E+01_JPRB, 0.132477E+01_JPRB, 0.136217E+01_JPRB &
  &, 0.139977E+01_JPRB, 0.143755E+01_JPRB, 0.147548E+01_JPRB, 0.151354E+01_JPRB &
  &, 0.155173E+01_JPRB, 0.159001E+01_JPRB, 0.162837E+01_JPRB &
  &, 0.166679E+01_JPRB, 0.170525E+01_JPRB, 0.174372E+01_JPRB, 0.178220E+01_JPRB &
  &, 0.182066E+01_JPRB, 0.185908E+01_JPRB, 0.189744E+01_JPRB &
  &, 0.193572E+01_JPRB, 0.197390E+01_JPRB, 0.201197E+01_JPRB, 0.204991E+01_JPRB &
  &, 0.208769E+01_JPRB, 0.212529E+01_JPRB, 0.216271E+01_JPRB &
  &, 0.219991E+01_JPRB, 0.223689E+01_JPRB, 0.227362E+01_JPRB, 0.231009E+01_JPRB &
  &, 0.234628E+01_JPRB, 0.238218E+01_JPRB, 0.241775E+01_JPRB &
  &, 0.245300E+01_JPRB, 0.248791E+01_JPRB, 0.252246E+01_JPRB, 0.255662E+01_JPRB &
  &, 0.259040E+01_JPRB, 0.262377E+01_JPRB, 0.265673E+01_JPRB &
  &, 0.268926E+01_JPRB, 0.272134E+01_JPRB, 0.275296E+01_JPRB, 0.278411E+01_JPRB &
  &, 0.281478E+01_JPRB, 0.284496E+01_JPRB, 0.287464E+01_JPRB &
  &, 0.290380E+01_JPRB, 0.293244E+01_JPRB, 0.296054E+01_JPRB, 0.298811E+01_JPRB &
  &, 0.301511E+01_JPRB, 0.304157E+01_JPRB, 0.306745E+01_JPRB &
  &, 0.309276E+01_JPRB, 0.311748E+01_JPRB, 0.314162E+01_JPRB, 0.316517E+01_JPRB &
  &, 0.318811E+01_JPRB, 0.321045E+01_JPRB, 0.323217E+01_JPRB &
  &, 0.325328E+01_JPRB, 0.327377E+01_JPRB, 0.329364E+01_JPRB, 0.331289E+01_JPRB &
  &, 0.333149E+01_JPRB, 0.334947E+01_JPRB, 0.336679E+01_JPRB &
  &, 0.338349E+01_JPRB, 0.339955E+01_JPRB, 0.341496E+01_JPRB, 0.342975E+01_JPRB &
  &, 0.344389E+01_JPRB, 0.345735E+01_JPRB, 0.347019E+01_JPRB &
  &, 0.348239E+01_JPRB, 0.349394E+01_JPRB, 0.350483E+01_JPRB, 0.351509E+01_JPRB &
  &, 0.352473E+01_JPRB, 0.353370E+01_JPRB, 0.354203E+01_JPRB &
  &, 0.354973E+01_JPRB, 0.355679E+01_JPRB, 0.356321E+01_JPRB, 0.356901E+01_JPRB &
  &, 0.357419E+01_JPRB, 0.357874E+01_JPRB, 0.358268E+01_JPRB &
  &, 0.358597E+01_JPRB, 0.358867E+01_JPRB, 0.359073E+01_JPRB, 0.359219E+01_JPRB &
  &, 0.359308E+01_JPRB, 0.359336E+01_JPRB, 0.359302E+01_JPRB &
  &, 0.359211E+01_JPRB, 0.359062E+01_JPRB, 0.358852E+01_JPRB, 0.358586E+01_JPRB &
  &, 0.358267E+01_JPRB, 0.357889E+01_JPRB, 0.357453E+01_JPRB &
  &, 0.356965E+01_JPRB, 0.356419E+01_JPRB, 0.355821E+01_JPRB, 0.355173E+01_JPRB &
  &, 0.354468E+01_JPRB, 0.353712E+01_JPRB, 0.352904E+01_JPRB &
  &, 0.352045E+01_JPRB, 0.351137E+01_JPRB, 0.350182E+01_JPRB, 0.349173E+01_JPRB &
  &, 0.348121E+01_JPRB, 0.347019E+01_JPRB, 0.345869E+01_JPRB &
  &, 0.344677E+01_JPRB, 0.343438E+01_JPRB, 0.342156E+01_JPRB, 0.340829E+01_JPRB &
  &, 0.339460E+01_JPRB, 0.338045E+01_JPRB, 0.336591E+01_JPRB &
  &, 0.335096E+01_JPRB, 0.333567E+01_JPRB, 0.331995E+01_JPRB, 0.330383E+01_JPRB &
  &, 0.328737E+01_JPRB, 0.327055E+01_JPRB, 0.325333E+01_JPRB &
  &, 0.323579E+01_JPRB, 0.321789E+01_JPRB, 0.319972E+01_JPRB, 0.318117E+01_JPRB &
  &, 0.316232E+01_JPRB, 0.314315E+01_JPRB, 0.312365E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART131',1,ZHOOK_HANDLE)
END SUBROUTINE PART131

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART132

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART132',0,ZHOOK_HANDLE)

XCW( 918, :) = (/ &
  &  0.114204E+01_JPRB, 0.117839E+01_JPRB, 0.121503E+01_JPRB, 0.125195E+01_JPRB &
  &, 0.128913E+01_JPRB, 0.132655E+01_JPRB, 0.136419E+01_JPRB &
  &, 0.140203E+01_JPRB, 0.144006E+01_JPRB, 0.147824E+01_JPRB, 0.151658E+01_JPRB &
  &, 0.155503E+01_JPRB, 0.159359E+01_JPRB, 0.163224E+01_JPRB &
  &, 0.167095E+01_JPRB, 0.170970E+01_JPRB, 0.174848E+01_JPRB, 0.178727E+01_JPRB &
  &, 0.182605E+01_JPRB, 0.186479E+01_JPRB, 0.190348E+01_JPRB &
  &, 0.194210E+01_JPRB, 0.198063E+01_JPRB, 0.201904E+01_JPRB, 0.205733E+01_JPRB &
  &, 0.209547E+01_JPRB, 0.213345E+01_JPRB, 0.217123E+01_JPRB &
  &, 0.220882E+01_JPRB, 0.224618E+01_JPRB, 0.228330E+01_JPRB, 0.232017E+01_JPRB &
  &, 0.235676E+01_JPRB, 0.239305E+01_JPRB, 0.242904E+01_JPRB &
  &, 0.246470E+01_JPRB, 0.250003E+01_JPRB, 0.253500E+01_JPRB, 0.256959E+01_JPRB &
  &, 0.260381E+01_JPRB, 0.263762E+01_JPRB, 0.267102E+01_JPRB &
  &, 0.270399E+01_JPRB, 0.273652E+01_JPRB, 0.276860E+01_JPRB, 0.280021E+01_JPRB &
  &, 0.283133E+01_JPRB, 0.286197E+01_JPRB, 0.289212E+01_JPRB &
  &, 0.292174E+01_JPRB, 0.295086E+01_JPRB, 0.297944E+01_JPRB, 0.300749E+01_JPRB &
  &, 0.303497E+01_JPRB, 0.306191E+01_JPRB, 0.308827E+01_JPRB &
  &, 0.311383E+01_JPRB, 0.313929E+01_JPRB, 0.316393E+01_JPRB, 0.318796E+01_JPRB &
  &, 0.321140E+01_JPRB, 0.323424E+01_JPRB, 0.325645E+01_JPRB &
  &, 0.327807E+01_JPRB, 0.329905E+01_JPRB, 0.331942E+01_JPRB, 0.333915E+01_JPRB &
  &, 0.335827E+01_JPRB, 0.337674E+01_JPRB, 0.339458E+01_JPRB &
  &, 0.341179E+01_JPRB, 0.342834E+01_JPRB, 0.344427E+01_JPRB, 0.345955E+01_JPRB &
  &, 0.347416E+01_JPRB, 0.348815E+01_JPRB, 0.350150E+01_JPRB &
  &, 0.351417E+01_JPRB, 0.352624E+01_JPRB, 0.353744E+01_JPRB, 0.354840E+01_JPRB &
  &, 0.355850E+01_JPRB, 0.356799E+01_JPRB, 0.357681E+01_JPRB &
  &, 0.358499E+01_JPRB, 0.359254E+01_JPRB, 0.359943E+01_JPRB, 0.360573E+01_JPRB &
  &, 0.361138E+01_JPRB, 0.361641E+01_JPRB, 0.362081E+01_JPRB &
  &, 0.362457E+01_JPRB, 0.362774E+01_JPRB, 0.363027E+01_JPRB, 0.363210E+01_JPRB &
  &, 0.363354E+01_JPRB, 0.363425E+01_JPRB, 0.363438E+01_JPRB &
  &, 0.363393E+01_JPRB, 0.363286E+01_JPRB, 0.363122E+01_JPRB, 0.362902E+01_JPRB &
  &, 0.362621E+01_JPRB, 0.362284E+01_JPRB, 0.361892E+01_JPRB &
  &, 0.361445E+01_JPRB, 0.360943E+01_JPRB, 0.360385E+01_JPRB, 0.359772E+01_JPRB &
  &, 0.359110E+01_JPRB, 0.358393E+01_JPRB, 0.357623E+01_JPRB &
  &, 0.356801E+01_JPRB, 0.355916E+01_JPRB, 0.355012E+01_JPRB, 0.354034E+01_JPRB &
  &, 0.353023E+01_JPRB, 0.351956E+01_JPRB, 0.350840E+01_JPRB &
  &, 0.349683E+01_JPRB, 0.348477E+01_JPRB, 0.347222E+01_JPRB, 0.345928E+01_JPRB &
  &, 0.344590E+01_JPRB, 0.343190E+01_JPRB, 0.341788E+01_JPRB &
  &, 0.340323E+01_JPRB, 0.338817E+01_JPRB, 0.337274E+01_JPRB, 0.335689E+01_JPRB &
  &, 0.334070E+01_JPRB, 0.332408E+01_JPRB, 0.330712E+01_JPRB &
  &, 0.328982E+01_JPRB, 0.327216E+01_JPRB, 0.325421E+01_JPRB, 0.323588E+01_JPRB &
  &, 0.321719E+01_JPRB, 0.319821E+01_JPRB, 0.317885E+01_JPRB/)
XCW( 919, :) = (/ &
  &  0.114277E+01_JPRB, 0.117931E+01_JPRB, 0.121616E+01_JPRB, 0.125330E+01_JPRB &
  &, 0.129070E+01_JPRB, 0.132835E+01_JPRB, 0.136623E+01_JPRB &
  &, 0.140432E+01_JPRB, 0.144259E+01_JPRB, 0.148104E+01_JPRB, 0.151964E+01_JPRB &
  &, 0.155837E+01_JPRB, 0.159721E+01_JPRB, 0.163614E+01_JPRB &
  &, 0.167515E+01_JPRB, 0.171420E+01_JPRB, 0.175329E+01_JPRB, 0.179239E+01_JPRB &
  &, 0.183149E+01_JPRB, 0.187056E+01_JPRB, 0.190959E+01_JPRB &
  &, 0.194855E+01_JPRB, 0.198743E+01_JPRB, 0.202620E+01_JPRB, 0.206484E+01_JPRB &
  &, 0.210335E+01_JPRB, 0.214170E+01_JPRB, 0.217986E+01_JPRB &
  &, 0.221783E+01_JPRB, 0.225558E+01_JPRB, 0.229309E+01_JPRB, 0.233036E+01_JPRB &
  &, 0.236735E+01_JPRB, 0.240406E+01_JPRB, 0.244047E+01_JPRB &
  &, 0.247655E+01_JPRB, 0.251230E+01_JPRB, 0.254770E+01_JPRB, 0.258274E+01_JPRB &
  &, 0.261739E+01_JPRB, 0.265164E+01_JPRB, 0.268548E+01_JPRB &
  &, 0.271891E+01_JPRB, 0.275189E+01_JPRB, 0.278442E+01_JPRB, 0.281649E+01_JPRB &
  &, 0.284810E+01_JPRB, 0.287921E+01_JPRB, 0.290982E+01_JPRB &
  &, 0.293993E+01_JPRB, 0.296953E+01_JPRB, 0.299858E+01_JPRB, 0.302712E+01_JPRB &
  &, 0.305510E+01_JPRB, 0.308252E+01_JPRB, 0.310938E+01_JPRB &
  &, 0.313568E+01_JPRB, 0.316139E+01_JPRB, 0.318653E+01_JPRB, 0.321106E+01_JPRB &
  &, 0.323499E+01_JPRB, 0.325833E+01_JPRB, 0.328107E+01_JPRB &
  &, 0.330319E+01_JPRB, 0.332469E+01_JPRB, 0.334557E+01_JPRB, 0.336581E+01_JPRB &
  &, 0.338544E+01_JPRB, 0.340442E+01_JPRB, 0.342277E+01_JPRB &
  &, 0.344047E+01_JPRB, 0.345756E+01_JPRB, 0.347399E+01_JPRB, 0.348977E+01_JPRB &
  &, 0.350492E+01_JPRB, 0.351942E+01_JPRB, 0.353325E+01_JPRB &
  &, 0.354645E+01_JPRB, 0.355901E+01_JPRB, 0.357091E+01_JPRB, 0.358217E+01_JPRB &
  &, 0.359280E+01_JPRB, 0.360276E+01_JPRB, 0.361209E+01_JPRB &
  &, 0.362077E+01_JPRB, 0.362883E+01_JPRB, 0.363623E+01_JPRB, 0.364301E+01_JPRB &
  &, 0.364914E+01_JPRB, 0.365465E+01_JPRB, 0.365953E+01_JPRB &
  &, 0.366380E+01_JPRB, 0.366742E+01_JPRB, 0.367046E+01_JPRB, 0.367283E+01_JPRB &
  &, 0.367466E+01_JPRB, 0.367584E+01_JPRB, 0.367637E+01_JPRB &
  &, 0.367640E+01_JPRB, 0.367580E+01_JPRB, 0.367462E+01_JPRB, 0.367285E+01_JPRB &
  &, 0.367051E+01_JPRB, 0.366756E+01_JPRB, 0.366407E+01_JPRB &
  &, 0.366005E+01_JPRB, 0.365540E+01_JPRB, 0.365027E+01_JPRB, 0.364459E+01_JPRB &
  &, 0.363833E+01_JPRB, 0.363156E+01_JPRB, 0.362425E+01_JPRB &
  &, 0.361643E+01_JPRB, 0.360810E+01_JPRB, 0.359930E+01_JPRB, 0.358994E+01_JPRB &
  &, 0.358015E+01_JPRB, 0.356985E+01_JPRB, 0.355905E+01_JPRB &
  &, 0.354778E+01_JPRB, 0.353607E+01_JPRB, 0.352392E+01_JPRB, 0.351126E+01_JPRB &
  &, 0.349821E+01_JPRB, 0.348469E+01_JPRB, 0.347078E+01_JPRB &
  &, 0.345643E+01_JPRB, 0.344168E+01_JPRB, 0.342654E+01_JPRB, 0.341098E+01_JPRB &
  &, 0.339502E+01_JPRB, 0.337868E+01_JPRB, 0.336198E+01_JPRB &
  &, 0.334494E+01_JPRB, 0.332753E+01_JPRB, 0.330977E+01_JPRB, 0.329167E+01_JPRB &
  &, 0.327320E+01_JPRB, 0.325445E+01_JPRB, 0.323536E+01_JPRB/)
XCW( 920, :) = (/ &
  &  0.114350E+01_JPRB, 0.118025E+01_JPRB, 0.121731E+01_JPRB, 0.125466E+01_JPRB &
  &, 0.129229E+01_JPRB, 0.133017E+01_JPRB, 0.136829E+01_JPRB &
  &, 0.140663E+01_JPRB, 0.144516E+01_JPRB, 0.148387E+01_JPRB, 0.152273E+01_JPRB &
  &, 0.156174E+01_JPRB, 0.160086E+01_JPRB, 0.164009E+01_JPRB &
  &, 0.167939E+01_JPRB, 0.171875E+01_JPRB, 0.175816E+01_JPRB, 0.179758E+01_JPRB &
  &, 0.183700E+01_JPRB, 0.187640E+01_JPRB, 0.191577E+01_JPRB &
  &, 0.195508E+01_JPRB, 0.199430E+01_JPRB, 0.203343E+01_JPRB, 0.207245E+01_JPRB &
  &, 0.211132E+01_JPRB, 0.215004E+01_JPRB, 0.218859E+01_JPRB &
  &, 0.222695E+01_JPRB, 0.226509E+01_JPRB, 0.230300E+01_JPRB, 0.234068E+01_JPRB &
  &, 0.237808E+01_JPRB, 0.241521E+01_JPRB, 0.245203E+01_JPRB &
  &, 0.248854E+01_JPRB, 0.252473E+01_JPRB, 0.256056E+01_JPRB, 0.259603E+01_JPRB &
  &, 0.263113E+01_JPRB, 0.266583E+01_JPRB, 0.270013E+01_JPRB &
  &, 0.273401E+01_JPRB, 0.276746E+01_JPRB, 0.280046E+01_JPRB, 0.283301E+01_JPRB &
  &, 0.286508E+01_JPRB, 0.289666E+01_JPRB, 0.292776E+01_JPRB &
  &, 0.295836E+01_JPRB, 0.298844E+01_JPRB, 0.301799E+01_JPRB, 0.304701E+01_JPRB &
  &, 0.307549E+01_JPRB, 0.310341E+01_JPRB, 0.313078E+01_JPRB &
  &, 0.315756E+01_JPRB, 0.318380E+01_JPRB, 0.320943E+01_JPRB, 0.323448E+01_JPRB &
  &, 0.325893E+01_JPRB, 0.328279E+01_JPRB, 0.330603E+01_JPRB &
  &, 0.332866E+01_JPRB, 0.335067E+01_JPRB, 0.337207E+01_JPRB, 0.339283E+01_JPRB &
  &, 0.341297E+01_JPRB, 0.343248E+01_JPRB, 0.345135E+01_JPRB &
  &, 0.346960E+01_JPRB, 0.348719E+01_JPRB, 0.350415E+01_JPRB, 0.352044E+01_JPRB &
  &, 0.353611E+01_JPRB, 0.355113E+01_JPRB, 0.356549E+01_JPRB &
  &, 0.357921E+01_JPRB, 0.359228E+01_JPRB, 0.360471E+01_JPRB, 0.361647E+01_JPRB &
  &, 0.362762E+01_JPRB, 0.363810E+01_JPRB, 0.364794E+01_JPRB &
  &, 0.365714E+01_JPRB, 0.366558E+01_JPRB, 0.367361E+01_JPRB, 0.368085E+01_JPRB &
  &, 0.368751E+01_JPRB, 0.369353E+01_JPRB, 0.369890E+01_JPRB &
  &, 0.370364E+01_JPRB, 0.370778E+01_JPRB, 0.371127E+01_JPRB, 0.371417E+01_JPRB &
  &, 0.371645E+01_JPRB, 0.371809E+01_JPRB, 0.371914E+01_JPRB &
  &, 0.371961E+01_JPRB, 0.371946E+01_JPRB, 0.371873E+01_JPRB, 0.371744E+01_JPRB &
  &, 0.371553E+01_JPRB, 0.371306E+01_JPRB, 0.371000E+01_JPRB &
  &, 0.370637E+01_JPRB, 0.370219E+01_JPRB, 0.369749E+01_JPRB, 0.369222E+01_JPRB &
  &, 0.368638E+01_JPRB, 0.368002E+01_JPRB, 0.367316E+01_JPRB &
  &, 0.366574E+01_JPRB, 0.365781E+01_JPRB, 0.364936E+01_JPRB, 0.364039E+01_JPRB &
  &, 0.363098E+01_JPRB, 0.362101E+01_JPRB, 0.361058E+01_JPRB &
  &, 0.359973E+01_JPRB, 0.358833E+01_JPRB, 0.357654E+01_JPRB, 0.356423E+01_JPRB &
  &, 0.355147E+01_JPRB, 0.353834E+01_JPRB, 0.352471E+01_JPRB &
  &, 0.351069E+01_JPRB, 0.349625E+01_JPRB, 0.348137E+01_JPRB, 0.346611E+01_JPRB &
  &, 0.345044E+01_JPRB, 0.343439E+01_JPRB, 0.341797E+01_JPRB &
  &, 0.340115E+01_JPRB, 0.338401E+01_JPRB, 0.336650E+01_JPRB, 0.334860E+01_JPRB &
  &, 0.333044E+01_JPRB, 0.331185E+01_JPRB, 0.329299E+01_JPRB/)
XCW( 921, :) = (/ &
  &  0.114424E+01_JPRB, 0.118119E+01_JPRB, 0.121846E+01_JPRB, 0.125604E+01_JPRB &
  &, 0.129389E+01_JPRB, 0.133201E+01_JPRB, 0.137037E+01_JPRB &
  &, 0.140896E+01_JPRB, 0.144775E+01_JPRB, 0.148672E+01_JPRB, 0.152586E+01_JPRB &
  &, 0.156515E+01_JPRB, 0.160456E+01_JPRB, 0.164408E+01_JPRB &
  &, 0.168368E+01_JPRB, 0.172336E+01_JPRB, 0.176308E+01_JPRB, 0.180282E+01_JPRB &
  &, 0.184257E+01_JPRB, 0.188232E+01_JPRB, 0.192202E+01_JPRB &
  &, 0.196168E+01_JPRB, 0.200126E+01_JPRB, 0.204075E+01_JPRB, 0.208013E+01_JPRB &
  &, 0.211938E+01_JPRB, 0.215849E+01_JPRB, 0.219743E+01_JPRB &
  &, 0.223617E+01_JPRB, 0.227472E+01_JPRB, 0.231304E+01_JPRB, 0.235112E+01_JPRB &
  &, 0.238894E+01_JPRB, 0.242649E+01_JPRB, 0.246374E+01_JPRB &
  &, 0.250068E+01_JPRB, 0.253731E+01_JPRB, 0.257358E+01_JPRB, 0.260950E+01_JPRB &
  &, 0.264505E+01_JPRB, 0.268020E+01_JPRB, 0.271497E+01_JPRB &
  &, 0.274932E+01_JPRB, 0.278323E+01_JPRB, 0.281671E+01_JPRB, 0.284973E+01_JPRB &
  &, 0.288229E+01_JPRB, 0.291435E+01_JPRB, 0.294594E+01_JPRB &
  &, 0.297702E+01_JPRB, 0.300760E+01_JPRB, 0.303766E+01_JPRB, 0.306718E+01_JPRB &
  &, 0.309615E+01_JPRB, 0.312459E+01_JPRB, 0.315246E+01_JPRB &
  &, 0.317977E+01_JPRB, 0.320651E+01_JPRB, 0.323265E+01_JPRB, 0.325823E+01_JPRB &
  &, 0.328320E+01_JPRB, 0.330758E+01_JPRB, 0.333134E+01_JPRB &
  &, 0.335450E+01_JPRB, 0.337703E+01_JPRB, 0.339897E+01_JPRB, 0.342026E+01_JPRB &
  &, 0.344092E+01_JPRB, 0.346097E+01_JPRB, 0.348036E+01_JPRB &
  &, 0.349914E+01_JPRB, 0.351725E+01_JPRB, 0.353475E+01_JPRB, 0.355157E+01_JPRB &
  &, 0.356775E+01_JPRB, 0.358330E+01_JPRB, 0.359822E+01_JPRB &
  &, 0.361246E+01_JPRB, 0.362606E+01_JPRB, 0.363902E+01_JPRB, 0.365130E+01_JPRB &
  &, 0.366297E+01_JPRB, 0.367397E+01_JPRB, 0.368434E+01_JPRB &
  &, 0.369404E+01_JPRB, 0.370312E+01_JPRB, 0.371154E+01_JPRB, 0.371934E+01_JPRB &
  &, 0.372650E+01_JPRB, 0.373299E+01_JPRB, 0.373887E+01_JPRB &
  &, 0.374414E+01_JPRB, 0.374872E+01_JPRB, 0.375275E+01_JPRB, 0.375614E+01_JPRB &
  &, 0.375892E+01_JPRB, 0.376106E+01_JPRB, 0.376261E+01_JPRB &
  &, 0.376354E+01_JPRB, 0.376389E+01_JPRB, 0.376361E+01_JPRB, 0.376270E+01_JPRB &
  &, 0.376132E+01_JPRB, 0.375930E+01_JPRB, 0.375672E+01_JPRB &
  &, 0.375354E+01_JPRB, 0.374984E+01_JPRB, 0.374553E+01_JPRB, 0.374070E+01_JPRB &
  &, 0.373528E+01_JPRB, 0.372935E+01_JPRB, 0.372291E+01_JPRB &
  &, 0.371591E+01_JPRB, 0.370839E+01_JPRB, 0.370034E+01_JPRB, 0.369178E+01_JPRB &
  &, 0.368272E+01_JPRB, 0.367319E+01_JPRB, 0.366315E+01_JPRB &
  &, 0.365263E+01_JPRB, 0.364160E+01_JPRB, 0.363013E+01_JPRB, 0.361818E+01_JPRB &
  &, 0.360579E+01_JPRB, 0.359296E+01_JPRB, 0.357972E+01_JPRB &
  &, 0.356599E+01_JPRB, 0.355177E+01_JPRB, 0.353733E+01_JPRB, 0.352233E+01_JPRB &
  &, 0.350698E+01_JPRB, 0.349123E+01_JPRB, 0.347505E+01_JPRB &
  &, 0.345852E+01_JPRB, 0.344166E+01_JPRB, 0.342437E+01_JPRB, 0.340672E+01_JPRB &
  &, 0.338876E+01_JPRB, 0.337049E+01_JPRB, 0.335180E+01_JPRB/)
XCW( 922, :) = (/ &
  &  0.114498E+01_JPRB, 0.118214E+01_JPRB, 0.121963E+01_JPRB, 0.125743E+01_JPRB &
  &, 0.129551E+01_JPRB, 0.133387E+01_JPRB, 0.137248E+01_JPRB &
  &, 0.141132E+01_JPRB, 0.145037E+01_JPRB, 0.148961E+01_JPRB, 0.152903E+01_JPRB &
  &, 0.156860E+01_JPRB, 0.160830E+01_JPRB, 0.164811E+01_JPRB &
  &, 0.168803E+01_JPRB, 0.172801E+01_JPRB, 0.176805E+01_JPRB, 0.180812E+01_JPRB &
  &, 0.184821E+01_JPRB, 0.188829E+01_JPRB, 0.192835E+01_JPRB &
  &, 0.196835E+01_JPRB, 0.200830E+01_JPRB, 0.204816E+01_JPRB, 0.208792E+01_JPRB &
  &, 0.212755E+01_JPRB, 0.216704E+01_JPRB, 0.220637E+01_JPRB &
  &, 0.224551E+01_JPRB, 0.228446E+01_JPRB, 0.232320E+01_JPRB, 0.236169E+01_JPRB &
  &, 0.239993E+01_JPRB, 0.243791E+01_JPRB, 0.247560E+01_JPRB &
  &, 0.251298E+01_JPRB, 0.255004E+01_JPRB, 0.258677E+01_JPRB, 0.262314E+01_JPRB &
  &, 0.265915E+01_JPRB, 0.269477E+01_JPRB, 0.273000E+01_JPRB &
  &, 0.276482E+01_JPRB, 0.279921E+01_JPRB, 0.283317E+01_JPRB, 0.286667E+01_JPRB &
  &, 0.289971E+01_JPRB, 0.293228E+01_JPRB, 0.296437E+01_JPRB &
  &, 0.299596E+01_JPRB, 0.302702E+01_JPRB, 0.305759E+01_JPRB, 0.308761E+01_JPRB &
  &, 0.311711E+01_JPRB, 0.314606E+01_JPRB, 0.317445E+01_JPRB &
  &, 0.320227E+01_JPRB, 0.322953E+01_JPRB, 0.325621E+01_JPRB, 0.328231E+01_JPRB &
  &, 0.330782E+01_JPRB, 0.333272E+01_JPRB, 0.335701E+01_JPRB &
  &, 0.338071E+01_JPRB, 0.340378E+01_JPRB, 0.342625E+01_JPRB, 0.344808E+01_JPRB &
  &, 0.346928E+01_JPRB, 0.348986E+01_JPRB, 0.350979E+01_JPRB &
  &, 0.352911E+01_JPRB, 0.354778E+01_JPRB, 0.356578E+01_JPRB, 0.358318E+01_JPRB &
  &, 0.359991E+01_JPRB, 0.361600E+01_JPRB, 0.363143E+01_JPRB &
  &, 0.364622E+01_JPRB, 0.366035E+01_JPRB, 0.367224E+01_JPRB, 0.368667E+01_JPRB &
  &, 0.369886E+01_JPRB, 0.371040E+01_JPRB, 0.372128E+01_JPRB &
  &, 0.373155E+01_JPRB, 0.374114E+01_JPRB, 0.375010E+01_JPRB, 0.375842E+01_JPRB &
  &, 0.376609E+01_JPRB, 0.377313E+01_JPRB, 0.377952E+01_JPRB &
  &, 0.378530E+01_JPRB, 0.379043E+01_JPRB, 0.379494E+01_JPRB, 0.379882E+01_JPRB &
  &, 0.380207E+01_JPRB, 0.380472E+01_JPRB, 0.380678E+01_JPRB &
  &, 0.380819E+01_JPRB, 0.380901E+01_JPRB, 0.380924E+01_JPRB, 0.380887E+01_JPRB &
  &, 0.380791E+01_JPRB, 0.380639E+01_JPRB, 0.380424E+01_JPRB &
  &, 0.380155E+01_JPRB, 0.379827E+01_JPRB, 0.379444E+01_JPRB, 0.379006E+01_JPRB &
  &, 0.378509E+01_JPRB, 0.377959E+01_JPRB, 0.377354E+01_JPRB &
  &, 0.376697E+01_JPRB, 0.375988E+01_JPRB, 0.375225E+01_JPRB, 0.374410E+01_JPRB &
  &, 0.373546E+01_JPRB, 0.372628E+01_JPRB, 0.371665E+01_JPRB &
  &, 0.370653E+01_JPRB, 0.369589E+01_JPRB, 0.368459E+01_JPRB, 0.367323E+01_JPRB &
  &, 0.366116E+01_JPRB, 0.364870E+01_JPRB, 0.363577E+01_JPRB &
  &, 0.362239E+01_JPRB, 0.360858E+01_JPRB, 0.359436E+01_JPRB, 0.357970E+01_JPRB &
  &, 0.356462E+01_JPRB, 0.354919E+01_JPRB, 0.353332E+01_JPRB &
  &, 0.351710E+01_JPRB, 0.350047E+01_JPRB, 0.348347E+01_JPRB, 0.346611E+01_JPRB &
  &, 0.344836E+01_JPRB, 0.343035E+01_JPRB, 0.341193E+01_JPRB/)
XCW( 923, :) = (/ &
  &  0.114574E+01_JPRB, 0.118311E+01_JPRB, 0.122081E+01_JPRB, 0.125883E+01_JPRB &
  &, 0.129715E+01_JPRB, 0.133575E+01_JPRB, 0.137460E+01_JPRB &
  &, 0.141370E+01_JPRB, 0.145301E+01_JPRB, 0.149253E+01_JPRB, 0.153223E+01_JPRB &
  &, 0.157208E+01_JPRB, 0.161208E+01_JPRB, 0.165220E+01_JPRB &
  &, 0.169242E+01_JPRB, 0.173272E+01_JPRB, 0.177308E+01_JPRB, 0.181349E+01_JPRB &
  &, 0.185391E+01_JPRB, 0.189434E+01_JPRB, 0.193474E+01_JPRB &
  &, 0.197512E+01_JPRB, 0.201543E+01_JPRB, 0.205566E+01_JPRB, 0.209579E+01_JPRB &
  &, 0.213581E+01_JPRB, 0.217569E+01_JPRB, 0.221542E+01_JPRB &
  &, 0.225497E+01_JPRB, 0.229433E+01_JPRB, 0.233348E+01_JPRB, 0.237240E+01_JPRB &
  &, 0.241107E+01_JPRB, 0.244948E+01_JPRB, 0.248761E+01_JPRB &
  &, 0.252543E+01_JPRB, 0.256294E+01_JPRB, 0.260012E+01_JPRB, 0.263696E+01_JPRB &
  &, 0.267344E+01_JPRB, 0.270953E+01_JPRB, 0.274523E+01_JPRB &
  &, 0.278053E+01_JPRB, 0.281540E+01_JPRB, 0.284985E+01_JPRB, 0.288385E+01_JPRB &
  &, 0.291739E+01_JPRB, 0.295046E+01_JPRB, 0.298304E+01_JPRB &
  &, 0.301513E+01_JPRB, 0.304673E+01_JPRB, 0.307780E+01_JPRB, 0.310835E+01_JPRB &
  &, 0.313836E+01_JPRB, 0.316783E+01_JPRB, 0.319674E+01_JPRB &
  &, 0.322510E+01_JPRB, 0.325289E+01_JPRB, 0.328011E+01_JPRB, 0.330671E+01_JPRB &
  &, 0.333277E+01_JPRB, 0.335822E+01_JPRB, 0.338307E+01_JPRB &
  &, 0.340729E+01_JPRB, 0.343092E+01_JPRB, 0.345393E+01_JPRB, 0.347630E+01_JPRB &
  &, 0.349806E+01_JPRB, 0.351920E+01_JPRB, 0.353967E+01_JPRB &
  &, 0.355954E+01_JPRB, 0.357874E+01_JPRB, 0.359731E+01_JPRB, 0.361525E+01_JPRB &
  &, 0.363254E+01_JPRB, 0.364916E+01_JPRB, 0.366515E+01_JPRB &
  &, 0.368049E+01_JPRB, 0.369518E+01_JPRB, 0.370922E+01_JPRB, 0.372260E+01_JPRB &
  &, 0.373532E+01_JPRB, 0.374743E+01_JPRB, 0.375886E+01_JPRB &
  &, 0.376964E+01_JPRB, 0.377979E+01_JPRB, 0.378927E+01_JPRB, 0.379811E+01_JPRB &
  &, 0.380634E+01_JPRB, 0.381390E+01_JPRB, 0.382082E+01_JPRB &
  &, 0.382713E+01_JPRB, 0.383278E+01_JPRB, 0.383782E+01_JPRB, 0.384222E+01_JPRB &
  &, 0.384600E+01_JPRB, 0.384914E+01_JPRB, 0.385169E+01_JPRB &
  &, 0.385362E+01_JPRB, 0.385496E+01_JPRB, 0.385568E+01_JPRB, 0.385579E+01_JPRB &
  &, 0.385531E+01_JPRB, 0.385426E+01_JPRB, 0.385262E+01_JPRB &
  &, 0.385036E+01_JPRB, 0.384759E+01_JPRB, 0.384419E+01_JPRB, 0.384026E+01_JPRB &
  &, 0.383579E+01_JPRB, 0.383075E+01_JPRB, 0.382515E+01_JPRB &
  &, 0.381902E+01_JPRB, 0.381232E+01_JPRB, 0.380513E+01_JPRB, 0.379742E+01_JPRB &
  &, 0.378915E+01_JPRB, 0.378044E+01_JPRB, 0.377118E+01_JPRB &
  &, 0.376142E+01_JPRB, 0.375118E+01_JPRB, 0.374050E+01_JPRB, 0.372928E+01_JPRB &
  &, 0.371764E+01_JPRB, 0.370551E+01_JPRB, 0.369290E+01_JPRB &
  &, 0.367989E+01_JPRB, 0.366645E+01_JPRB, 0.365253E+01_JPRB, 0.363822E+01_JPRB &
  &, 0.362348E+01_JPRB, 0.360833E+01_JPRB, 0.359280E+01_JPRB &
  &, 0.357683E+01_JPRB, 0.355954E+01_JPRB, 0.354376E+01_JPRB, 0.352671E+01_JPRB &
  &, 0.350924E+01_JPRB, 0.349145E+01_JPRB, 0.347330E+01_JPRB/)
XCW( 924, :) = (/ &
  &  0.114650E+01_JPRB, 0.118408E+01_JPRB, 0.122200E+01_JPRB, 0.126025E+01_JPRB &
  &, 0.129881E+01_JPRB, 0.133765E+01_JPRB, 0.137675E+01_JPRB &
  &, 0.141611E+01_JPRB, 0.145569E+01_JPRB, 0.149548E+01_JPRB, 0.153546E+01_JPRB &
  &, 0.157561E+01_JPRB, 0.161590E+01_JPRB, 0.165633E+01_JPRB &
  &, 0.169686E+01_JPRB, 0.173749E+01_JPRB, 0.177818E+01_JPRB, 0.181892E+01_JPRB &
  &, 0.185968E+01_JPRB, 0.190046E+01_JPRB, 0.194122E+01_JPRB &
  &, 0.198196E+01_JPRB, 0.202264E+01_JPRB, 0.206325E+01_JPRB, 0.210377E+01_JPRB &
  &, 0.214418E+01_JPRB, 0.218445E+01_JPRB, 0.222459E+01_JPRB &
  &, 0.226455E+01_JPRB, 0.230432E+01_JPRB, 0.234390E+01_JPRB, 0.238324E+01_JPRB &
  &, 0.242235E+01_JPRB, 0.246120E+01_JPRB, 0.249977E+01_JPRB &
  &, 0.253804E+01_JPRB, 0.257602E+01_JPRB, 0.261366E+01_JPRB, 0.265096E+01_JPRB &
  &, 0.268791E+01_JPRB, 0.272448E+01_JPRB, 0.276066E+01_JPRB &
  &, 0.279645E+01_JPRB, 0.283182E+01_JPRB, 0.286676E+01_JPRB, 0.290125E+01_JPRB &
  &, 0.293529E+01_JPRB, 0.296888E+01_JPRB, 0.300197E+01_JPRB &
  &, 0.303458E+01_JPRB, 0.306669E+01_JPRB, 0.309828E+01_JPRB, 0.312936E+01_JPRB &
  &, 0.315990E+01_JPRB, 0.318991E+01_JPRB, 0.321936E+01_JPRB &
  &, 0.324825E+01_JPRB, 0.327658E+01_JPRB, 0.330433E+01_JPRB, 0.333152E+01_JPRB &
  &, 0.335810E+01_JPRB, 0.338410E+01_JPRB, 0.340950E+01_JPRB &
  &, 0.343428E+01_JPRB, 0.345843E+01_JPRB, 0.348202E+01_JPRB, 0.350495E+01_JPRB &
  &, 0.352727E+01_JPRB, 0.354896E+01_JPRB, 0.357001E+01_JPRB &
  &, 0.359041E+01_JPRB, 0.361020E+01_JPRB, 0.362933E+01_JPRB, 0.364783E+01_JPRB &
  &, 0.366565E+01_JPRB, 0.368285E+01_JPRB, 0.369941E+01_JPRB &
  &, 0.371532E+01_JPRB, 0.373055E+01_JPRB, 0.374515E+01_JPRB, 0.375908E+01_JPRB &
  &, 0.377238E+01_JPRB, 0.378504E+01_JPRB, 0.379700E+01_JPRB &
  &, 0.380835E+01_JPRB, 0.381906E+01_JPRB, 0.382908E+01_JPRB, 0.383848E+01_JPRB &
  &, 0.384725E+01_JPRB, 0.385535E+01_JPRB, 0.386281E+01_JPRB &
  &, 0.386966E+01_JPRB, 0.387585E+01_JPRB, 0.388139E+01_JPRB, 0.388633E+01_JPRB &
  &, 0.389065E+01_JPRB, 0.389433E+01_JPRB, 0.389738E+01_JPRB &
  &, 0.389985E+01_JPRB, 0.390168E+01_JPRB, 0.390289E+01_JPRB, 0.390353E+01_JPRB &
  &, 0.390355E+01_JPRB, 0.390299E+01_JPRB, 0.390184E+01_JPRB &
  &, 0.390010E+01_JPRB, 0.389777E+01_JPRB, 0.389489E+01_JPRB, 0.389143E+01_JPRB &
  &, 0.388739E+01_JPRB, 0.388282E+01_JPRB, 0.387768E+01_JPRB &
  &, 0.387196E+01_JPRB, 0.386577E+01_JPRB, 0.385898E+01_JPRB, 0.385171E+01_JPRB &
  &, 0.384389E+01_JPRB, 0.383557E+01_JPRB, 0.382674E+01_JPRB &
  &, 0.381741E+01_JPRB, 0.380760E+01_JPRB, 0.379727E+01_JPRB, 0.378646E+01_JPRB &
  &, 0.377518E+01_JPRB, 0.376345E+01_JPRB, 0.375123E+01_JPRB &
  &, 0.373856E+01_JPRB, 0.372544E+01_JPRB, 0.371189E+01_JPRB, 0.369789E+01_JPRB &
  &, 0.368351E+01_JPRB, 0.366860E+01_JPRB, 0.365347E+01_JPRB &
  &, 0.363778E+01_JPRB, 0.362180E+01_JPRB, 0.360537E+01_JPRB, 0.358856E+01_JPRB &
  &, 0.357140E+01_JPRB, 0.355385E+01_JPRB, 0.353599E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART132',1,ZHOOK_HANDLE)
END SUBROUTINE PART132

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART133

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART133',0,ZHOOK_HANDLE)

XCW( 925, :) = (/ &
  &  0.114727E+01_JPRB, 0.118506E+01_JPRB, 0.122321E+01_JPRB, 0.126169E+01_JPRB &
  &, 0.130048E+01_JPRB, 0.133957E+01_JPRB, 0.137893E+01_JPRB &
  &, 0.141854E+01_JPRB, 0.145840E+01_JPRB, 0.149847E+01_JPRB, 0.153873E+01_JPRB &
  &, 0.157917E+01_JPRB, 0.161977E+01_JPRB, 0.166051E+01_JPRB &
  &, 0.170136E+01_JPRB, 0.174231E+01_JPRB, 0.178333E+01_JPRB, 0.182441E+01_JPRB &
  &, 0.186552E+01_JPRB, 0.190665E+01_JPRB, 0.194778E+01_JPRB &
  &, 0.198888E+01_JPRB, 0.202994E+01_JPRB, 0.207093E+01_JPRB, 0.211184E+01_JPRB &
  &, 0.215264E+01_JPRB, 0.219333E+01_JPRB, 0.223387E+01_JPRB &
  &, 0.227425E+01_JPRB, 0.231445E+01_JPRB, 0.235445E+01_JPRB, 0.239423E+01_JPRB &
  &, 0.243378E+01_JPRB, 0.247307E+01_JPRB, 0.251210E+01_JPRB &
  &, 0.255083E+01_JPRB, 0.258926E+01_JPRB, 0.262737E+01_JPRB, 0.266515E+01_JPRB &
  &, 0.270258E+01_JPRB, 0.273963E+01_JPRB, 0.277630E+01_JPRB &
  &, 0.281259E+01_JPRB, 0.284846E+01_JPRB, 0.288390E+01_JPRB, 0.291890E+01_JPRB &
  &, 0.295346E+01_JPRB, 0.298756E+01_JPRB, 0.302117E+01_JPRB &
  &, 0.305430E+01_JPRB, 0.308694E+01_JPRB, 0.311907E+01_JPRB, 0.315068E+01_JPRB &
  &, 0.318176E+01_JPRB, 0.321231E+01_JPRB, 0.324230E+01_JPRB &
  &, 0.327175E+01_JPRB, 0.330062E+01_JPRB, 0.332893E+01_JPRB, 0.335667E+01_JPRB &
  &, 0.338380E+01_JPRB, 0.341035E+01_JPRB, 0.343632E+01_JPRB &
  &, 0.346166E+01_JPRB, 0.348640E+01_JPRB, 0.351053E+01_JPRB, 0.353403E+01_JPRB &
  &, 0.355692E+01_JPRB, 0.357916E+01_JPRB, 0.360080E+01_JPRB &
  &, 0.362177E+01_JPRB, 0.364213E+01_JPRB, 0.366182E+01_JPRB, 0.368090E+01_JPRB &
  &, 0.369931E+01_JPRB, 0.371709E+01_JPRB, 0.373419E+01_JPRB &
  &, 0.375068E+01_JPRB, 0.376650E+01_JPRB, 0.378166E+01_JPRB, 0.379618E+01_JPRB &
  &, 0.381004E+01_JPRB, 0.382325E+01_JPRB, 0.383578E+01_JPRB &
  &, 0.384770E+01_JPRB, 0.385895E+01_JPRB, 0.386955E+01_JPRB, 0.387950E+01_JPRB &
  &, 0.388882E+01_JPRB, 0.389750E+01_JPRB, 0.390551E+01_JPRB &
  &, 0.391288E+01_JPRB, 0.391962E+01_JPRB, 0.392575E+01_JPRB, 0.393121E+01_JPRB &
  &, 0.393608E+01_JPRB, 0.394027E+01_JPRB, 0.394387E+01_JPRB &
  &, 0.394685E+01_JPRB, 0.394916E+01_JPRB, 0.395070E+01_JPRB, 0.395211E+01_JPRB &
  &, 0.395267E+01_JPRB, 0.395261E+01_JPRB, 0.395196E+01_JPRB &
  &, 0.395073E+01_JPRB, 0.394889E+01_JPRB, 0.394650E+01_JPRB, 0.394349E+01_JPRB &
  &, 0.393998E+01_JPRB, 0.393584E+01_JPRB, 0.393119E+01_JPRB &
  &, 0.392594E+01_JPRB, 0.392017E+01_JPRB, 0.391390E+01_JPRB, 0.390705E+01_JPRB &
  &, 0.389968E+01_JPRB, 0.389177E+01_JPRB, 0.388338E+01_JPRB &
  &, 0.387449E+01_JPRB, 0.386507E+01_JPRB, 0.385513E+01_JPRB, 0.384474E+01_JPRB &
  &, 0.383388E+01_JPRB, 0.382251E+01_JPRB, 0.381071E+01_JPRB &
  &, 0.379838E+01_JPRB, 0.378565E+01_JPRB, 0.377250E+01_JPRB, 0.375883E+01_JPRB &
  &, 0.374477E+01_JPRB, 0.373028E+01_JPRB, 0.371539E+01_JPRB &
  &, 0.370006E+01_JPRB, 0.368437E+01_JPRB, 0.366828E+01_JPRB, 0.365174E+01_JPRB &
  &, 0.363484E+01_JPRB, 0.361761E+01_JPRB, 0.359999E+01_JPRB/)
XCW( 926, :) = (/ &
  &  0.114805E+01_JPRB, 0.118606E+01_JPRB, 0.122443E+01_JPRB, 0.126314E+01_JPRB &
  &, 0.130217E+01_JPRB, 0.134151E+01_JPRB, 0.138113E+01_JPRB &
  &, 0.142101E+01_JPRB, 0.146113E+01_JPRB, 0.150149E+01_JPRB, 0.154204E+01_JPRB &
  &, 0.158278E+01_JPRB, 0.162368E+01_JPRB, 0.166473E+01_JPRB &
  &, 0.170591E+01_JPRB, 0.174718E+01_JPRB, 0.178854E+01_JPRB, 0.182997E+01_JPRB &
  &, 0.187143E+01_JPRB, 0.191292E+01_JPRB, 0.195442E+01_JPRB &
  &, 0.199589E+01_JPRB, 0.203733E+01_JPRB, 0.207871E+01_JPRB, 0.212001E+01_JPRB &
  &, 0.216122E+01_JPRB, 0.220231E+01_JPRB, 0.224327E+01_JPRB &
  &, 0.228407E+01_JPRB, 0.232470E+01_JPRB, 0.236513E+01_JPRB, 0.240536E+01_JPRB &
  &, 0.244535E+01_JPRB, 0.248510E+01_JPRB, 0.252458E+01_JPRB &
  &, 0.256378E+01_JPRB, 0.260268E+01_JPRB, 0.264127E+01_JPRB, 0.267953E+01_JPRB &
  &, 0.271744E+01_JPRB, 0.275499E+01_JPRB, 0.279216E+01_JPRB &
  &, 0.282894E+01_JPRB, 0.286531E+01_JPRB, 0.290128E+01_JPRB, 0.293680E+01_JPRB &
  &, 0.297188E+01_JPRB, 0.300649E+01_JPRB, 0.304064E+01_JPRB &
  &, 0.307430E+01_JPRB, 0.310748E+01_JPRB, 0.314014E+01_JPRB, 0.317230E+01_JPRB &
  &, 0.320393E+01_JPRB, 0.323501E+01_JPRB, 0.326558E+01_JPRB &
  &, 0.329557E+01_JPRB, 0.332501E+01_JPRB, 0.335388E+01_JPRB, 0.338218E+01_JPRB &
  &, 0.340989E+01_JPRB, 0.343702E+01_JPRB, 0.346353E+01_JPRB &
  &, 0.348946E+01_JPRB, 0.351478E+01_JPRB, 0.353948E+01_JPRB, 0.356355E+01_JPRB &
  &, 0.358702E+01_JPRB, 0.360985E+01_JPRB, 0.363206E+01_JPRB &
  &, 0.365363E+01_JPRB, 0.367456E+01_JPRB, 0.369484E+01_JPRB, 0.371449E+01_JPRB &
  &, 0.373348E+01_JPRB, 0.375186E+01_JPRB, 0.376955E+01_JPRB &
  &, 0.378660E+01_JPRB, 0.380302E+01_JPRB, 0.381874E+01_JPRB, 0.383384E+01_JPRB &
  &, 0.384788E+01_JPRB, 0.386209E+01_JPRB, 0.387521E+01_JPRB &
  &, 0.388769E+01_JPRB, 0.389953E+01_JPRB, 0.391072E+01_JPRB, 0.392123E+01_JPRB &
  &, 0.393111E+01_JPRB, 0.394036E+01_JPRB, 0.394893E+01_JPRB &
  &, 0.395689E+01_JPRB, 0.396417E+01_JPRB, 0.397086E+01_JPRB, 0.397689E+01_JPRB &
  &, 0.398229E+01_JPRB, 0.398705E+01_JPRB, 0.399117E+01_JPRB &
  &, 0.399472E+01_JPRB, 0.399759E+01_JPRB, 0.399984E+01_JPRB, 0.400155E+01_JPRB &
  &, 0.400263E+01_JPRB, 0.400309E+01_JPRB, 0.400295E+01_JPRB &
  &, 0.400223E+01_JPRB, 0.400094E+01_JPRB, 0.399902E+01_JPRB, 0.399656E+01_JPRB &
  &, 0.399351E+01_JPRB, 0.398987E+01_JPRB, 0.398571E+01_JPRB &
  &, 0.398095E+01_JPRB, 0.397567E+01_JPRB, 0.396984E+01_JPRB, 0.396327E+01_JPRB &
  &, 0.395652E+01_JPRB, 0.394908E+01_JPRB, 0.394111E+01_JPRB &
  &, 0.393267E+01_JPRB, 0.392365E+01_JPRB, 0.391421E+01_JPRB, 0.390422E+01_JPRB &
  &, 0.389374E+01_JPRB, 0.388281E+01_JPRB, 0.387137E+01_JPRB &
  &, 0.385947E+01_JPRB, 0.384710E+01_JPRB, 0.383430E+01_JPRB, 0.382103E+01_JPRB &
  &, 0.380730E+01_JPRB, 0.379320E+01_JPRB, 0.377864E+01_JPRB &
  &, 0.376368E+01_JPRB, 0.374829E+01_JPRB, 0.373250E+01_JPRB, 0.371631E+01_JPRB &
  &, 0.369976E+01_JPRB, 0.368280E+01_JPRB, 0.366544E+01_JPRB/)
XCW( 927, :) = (/ &
  &  0.114883E+01_JPRB, 0.118706E+01_JPRB, 0.122566E+01_JPRB, 0.126460E+01_JPRB &
  &, 0.130388E+01_JPRB, 0.134347E+01_JPRB, 0.138335E+01_JPRB &
  &, 0.142350E+01_JPRB, 0.146391E+01_JPRB, 0.150454E+01_JPRB, 0.154539E+01_JPRB &
  &, 0.158643E+01_JPRB, 0.162765E+01_JPRB, 0.166901E+01_JPRB &
  &, 0.171051E+01_JPRB, 0.175212E+01_JPRB, 0.179382E+01_JPRB, 0.183559E+01_JPRB &
  &, 0.187742E+01_JPRB, 0.191927E+01_JPRB, 0.196113E+01_JPRB &
  &, 0.200299E+01_JPRB, 0.204482E+01_JPRB, 0.208659E+01_JPRB, 0.212829E+01_JPRB &
  &, 0.216991E+01_JPRB, 0.221141E+01_JPRB, 0.225279E+01_JPRB &
  &, 0.229402E+01_JPRB, 0.233508E+01_JPRB, 0.237596E+01_JPRB, 0.241663E+01_JPRB &
  &, 0.245708E+01_JPRB, 0.249729E+01_JPRB, 0.253724E+01_JPRB &
  &, 0.257691E+01_JPRB, 0.261629E+01_JPRB, 0.265536E+01_JPRB, 0.269411E+01_JPRB &
  &, 0.273252E+01_JPRB, 0.277057E+01_JPRB, 0.280824E+01_JPRB &
  &, 0.284553E+01_JPRB, 0.288242E+01_JPRB, 0.291889E+01_JPRB, 0.295494E+01_JPRB &
  &, 0.299055E+01_JPRB, 0.302571E+01_JPRB, 0.306038E+01_JPRB &
  &, 0.309459E+01_JPRB, 0.312831E+01_JPRB, 0.316153E+01_JPRB, 0.319423E+01_JPRB &
  &, 0.322641E+01_JPRB, 0.325808E+01_JPRB, 0.328918E+01_JPRB &
  &, 0.331976E+01_JPRB, 0.334977E+01_JPRB, 0.337921E+01_JPRB, 0.340807E+01_JPRB &
  &, 0.343636E+01_JPRB, 0.346406E+01_JPRB, 0.349117E+01_JPRB &
  &, 0.351768E+01_JPRB, 0.354358E+01_JPRB, 0.356886E+01_JPRB, 0.359354E+01_JPRB &
  &, 0.361760E+01_JPRB, 0.364101E+01_JPRB, 0.366382E+01_JPRB &
  &, 0.368598E+01_JPRB, 0.370733E+01_JPRB, 0.372839E+01_JPRB, 0.374862E+01_JPRB &
  &, 0.376822E+01_JPRB, 0.378717E+01_JPRB, 0.380546E+01_JPRB &
  &, 0.382311E+01_JPRB, 0.384010E+01_JPRB, 0.385647E+01_JPRB, 0.387215E+01_JPRB &
  &, 0.388718E+01_JPRB, 0.390156E+01_JPRB, 0.391530E+01_JPRB &
  &, 0.392837E+01_JPRB, 0.394079E+01_JPRB, 0.395255E+01_JPRB, 0.396367E+01_JPRB &
  &, 0.397412E+01_JPRB, 0.398392E+01_JPRB, 0.399309E+01_JPRB &
  &, 0.400164E+01_JPRB, 0.400949E+01_JPRB, 0.401673E+01_JPRB, 0.402333E+01_JPRB &
  &, 0.402928E+01_JPRB, 0.403462E+01_JPRB, 0.403932E+01_JPRB &
  &, 0.404341E+01_JPRB, 0.404686E+01_JPRB, 0.404957E+01_JPRB, 0.405193E+01_JPRB &
  &, 0.405351E+01_JPRB, 0.405454E+01_JPRB, 0.405494E+01_JPRB &
  &, 0.405470E+01_JPRB, 0.405394E+01_JPRB, 0.405254E+01_JPRB, 0.405060E+01_JPRB &
  &, 0.404806E+01_JPRB, 0.404494E+01_JPRB, 0.404124E+01_JPRB &
  &, 0.403700E+01_JPRB, 0.403217E+01_JPRB, 0.402683E+01_JPRB, 0.402076E+01_JPRB &
  &, 0.401450E+01_JPRB, 0.400750E+01_JPRB, 0.400001E+01_JPRB &
  &, 0.399200E+01_JPRB, 0.398345E+01_JPRB, 0.397443E+01_JPRB, 0.396484E+01_JPRB &
  &, 0.395482E+01_JPRB, 0.394428E+01_JPRB, 0.393324E+01_JPRB &
  &, 0.392177E+01_JPRB, 0.390983E+01_JPRB, 0.389740E+01_JPRB, 0.388449E+01_JPRB &
  &, 0.387118E+01_JPRB, 0.385743E+01_JPRB, 0.384320E+01_JPRB &
  &, 0.382863E+01_JPRB, 0.381357E+01_JPRB, 0.379809E+01_JPRB, 0.378227E+01_JPRB &
  &, 0.376602E+01_JPRB, 0.374934E+01_JPRB, 0.373234E+01_JPRB/)
XCW( 928, :) = (/ &
  &  0.114963E+01_JPRB, 0.118808E+01_JPRB, 0.122690E+01_JPRB, 0.126609E+01_JPRB &
  &, 0.130561E+01_JPRB, 0.134545E+01_JPRB, 0.138560E+01_JPRB &
  &, 0.142602E+01_JPRB, 0.146671E+01_JPRB, 0.150763E+01_JPRB, 0.154878E+01_JPRB &
  &, 0.159013E+01_JPRB, 0.163165E+01_JPRB, 0.167334E+01_JPRB &
  &, 0.171517E+01_JPRB, 0.175712E+01_JPRB, 0.179917E+01_JPRB, 0.184129E+01_JPRB &
  &, 0.188348E+01_JPRB, 0.192570E+01_JPRB, 0.196794E+01_JPRB &
  &, 0.201018E+01_JPRB, 0.205240E+01_JPRB, 0.209457E+01_JPRB, 0.213668E+01_JPRB &
  &, 0.217871E+01_JPRB, 0.222064E+01_JPRB, 0.226244E+01_JPRB &
  &, 0.230411E+01_JPRB, 0.234561E+01_JPRB, 0.238693E+01_JPRB, 0.242806E+01_JPRB &
  &, 0.246897E+01_JPRB, 0.250964E+01_JPRB, 0.255007E+01_JPRB &
  &, 0.259022E+01_JPRB, 0.263008E+01_JPRB, 0.266965E+01_JPRB, 0.270889E+01_JPRB &
  &, 0.274780E+01_JPRB, 0.278636E+01_JPRB, 0.282454E+01_JPRB &
  &, 0.286236E+01_JPRB, 0.289977E+01_JPRB, 0.293673E+01_JPRB, 0.297335E+01_JPRB &
  &, 0.300950E+01_JPRB, 0.304519E+01_JPRB, 0.308042E+01_JPRB &
  &, 0.311518E+01_JPRB, 0.314944E+01_JPRB, 0.318323E+01_JPRB, 0.321649E+01_JPRB &
  &, 0.324925E+01_JPRB, 0.328147E+01_JPRB, 0.331315E+01_JPRB &
  &, 0.334431E+01_JPRB, 0.337488E+01_JPRB, 0.340491E+01_JPRB, 0.343436E+01_JPRB &
  &, 0.346325E+01_JPRB, 0.349153E+01_JPRB, 0.351923E+01_JPRB &
  &, 0.354633E+01_JPRB, 0.357269E+01_JPRB, 0.359872E+01_JPRB, 0.362399E+01_JPRB &
  &, 0.364802E+01_JPRB, 0.367267E+01_JPRB, 0.369607E+01_JPRB &
  &, 0.371884E+01_JPRB, 0.374097E+01_JPRB, 0.376246E+01_JPRB, 0.378331E+01_JPRB &
  &, 0.380351E+01_JPRB, 0.382306E+01_JPRB, 0.384198E+01_JPRB &
  &, 0.386022E+01_JPRB, 0.387784E+01_JPRB, 0.389479E+01_JPRB, 0.391107E+01_JPRB &
  &, 0.392668E+01_JPRB, 0.394172E+01_JPRB, 0.395604E+01_JPRB &
  &, 0.396972E+01_JPRB, 0.398272E+01_JPRB, 0.399510E+01_JPRB, 0.400681E+01_JPRB &
  &, 0.401788E+01_JPRB, 0.402827E+01_JPRB, 0.403804E+01_JPRB &
  &, 0.404714E+01_JPRB, 0.405562E+01_JPRB, 0.406342E+01_JPRB, 0.407061E+01_JPRB &
  &, 0.407715E+01_JPRB, 0.408305E+01_JPRB, 0.408835E+01_JPRB &
  &, 0.409299E+01_JPRB, 0.409700E+01_JPRB, 0.410041E+01_JPRB, 0.410318E+01_JPRB &
  &, 0.410534E+01_JPRB, 0.410689E+01_JPRB, 0.410779E+01_JPRB &
  &, 0.410818E+01_JPRB, 0.410791E+01_JPRB, 0.410710E+01_JPRB, 0.410565E+01_JPRB &
  &, 0.410348E+01_JPRB, 0.410101E+01_JPRB, 0.409784E+01_JPRB &
  &, 0.409412E+01_JPRB, 0.408981E+01_JPRB, 0.408494E+01_JPRB, 0.407953E+01_JPRB &
  &, 0.407358E+01_JPRB, 0.406708E+01_JPRB, 0.406004E+01_JPRB &
  &, 0.405253E+01_JPRB, 0.404442E+01_JPRB, 0.403583E+01_JPRB, 0.402672E+01_JPRB &
  &, 0.401712E+01_JPRB, 0.400704E+01_JPRB, 0.399641E+01_JPRB &
  &, 0.398539E+01_JPRB, 0.397385E+01_JPRB, 0.396181E+01_JPRB, 0.394933E+01_JPRB &
  &, 0.393640E+01_JPRB, 0.392301E+01_JPRB, 0.390920E+01_JPRB &
  &, 0.389492E+01_JPRB, 0.388026E+01_JPRB, 0.386518E+01_JPRB, 0.384969E+01_JPRB &
  &, 0.383375E+01_JPRB, 0.381745E+01_JPRB, 0.380074E+01_JPRB/)
XCW( 929, :) = (/ &
  &  0.115043E+01_JPRB, 0.118911E+01_JPRB, 0.122816E+01_JPRB, 0.126759E+01_JPRB &
  &, 0.130736E+01_JPRB, 0.134746E+01_JPRB, 0.138787E+01_JPRB &
  &, 0.142857E+01_JPRB, 0.146954E+01_JPRB, 0.151076E+01_JPRB, 0.155221E+01_JPRB &
  &, 0.159386E+01_JPRB, 0.163571E+01_JPRB, 0.167773E+01_JPRB &
  &, 0.171989E+01_JPRB, 0.176218E+01_JPRB, 0.180458E+01_JPRB, 0.184706E+01_JPRB &
  &, 0.188961E+01_JPRB, 0.193221E+01_JPRB, 0.197483E+01_JPRB &
  &, 0.201746E+01_JPRB, 0.206008E+01_JPRB, 0.210266E+01_JPRB, 0.214518E+01_JPRB &
  &, 0.218763E+01_JPRB, 0.222998E+01_JPRB, 0.227222E+01_JPRB &
  &, 0.231432E+01_JPRB, 0.235628E+01_JPRB, 0.239806E+01_JPRB, 0.243964E+01_JPRB &
  &, 0.248102E+01_JPRB, 0.252217E+01_JPRB, 0.256307E+01_JPRB &
  &, 0.260371E+01_JPRB, 0.264407E+01_JPRB, 0.268414E+01_JPRB, 0.272389E+01_JPRB &
  &, 0.276330E+01_JPRB, 0.280237E+01_JPRB, 0.284108E+01_JPRB &
  &, 0.287942E+01_JPRB, 0.291736E+01_JPRB, 0.295490E+01_JPRB, 0.299203E+01_JPRB &
  &, 0.302872E+01_JPRB, 0.306496E+01_JPRB, 0.310075E+01_JPRB &
  &, 0.313607E+01_JPRB, 0.317090E+01_JPRB, 0.320525E+01_JPRB, 0.323909E+01_JPRB &
  &, 0.327241E+01_JPRB, 0.330523E+01_JPRB, 0.333749E+01_JPRB &
  &, 0.336923E+01_JPRB, 0.340040E+01_JPRB, 0.343101E+01_JPRB, 0.346106E+01_JPRB &
  &, 0.349054E+01_JPRB, 0.351942E+01_JPRB, 0.354774E+01_JPRB &
  &, 0.357544E+01_JPRB, 0.360251E+01_JPRB, 0.362903E+01_JPRB, 0.365493E+01_JPRB &
  &, 0.368018E+01_JPRB, 0.370484E+01_JPRB, 0.372885E+01_JPRB &
  &, 0.375222E+01_JPRB, 0.377499E+01_JPRB, 0.379708E+01_JPRB, 0.381856E+01_JPRB &
  &, 0.383937E+01_JPRB, 0.385947E+01_JPRB, 0.387908E+01_JPRB &
  &, 0.389795E+01_JPRB, 0.391619E+01_JPRB, 0.393375E+01_JPRB, 0.395067E+01_JPRB &
  &, 0.396692E+01_JPRB, 0.398253E+01_JPRB, 0.399747E+01_JPRB &
  &, 0.401177E+01_JPRB, 0.402540E+01_JPRB, 0.403838E+01_JPRB, 0.405059E+01_JPRB &
  &, 0.406236E+01_JPRB, 0.407338E+01_JPRB, 0.408376E+01_JPRB &
  &, 0.409347E+01_JPRB, 0.410252E+01_JPRB, 0.411096E+01_JPRB, 0.411873E+01_JPRB &
  &, 0.412588E+01_JPRB, 0.413238E+01_JPRB, 0.413822E+01_JPRB &
  &, 0.414347E+01_JPRB, 0.414805E+01_JPRB, 0.415203E+01_JPRB, 0.415540E+01_JPRB &
  &, 0.415813E+01_JPRB, 0.416024E+01_JPRB, 0.416175E+01_JPRB &
  &, 0.416266E+01_JPRB, 0.416295E+01_JPRB, 0.416265E+01_JPRB, 0.416176E+01_JPRB &
  &, 0.416026E+01_JPRB, 0.415821E+01_JPRB, 0.415559E+01_JPRB &
  &, 0.415236E+01_JPRB, 0.414855E+01_JPRB, 0.414421E+01_JPRB, 0.413932E+01_JPRB &
  &, 0.413385E+01_JPRB, 0.412787E+01_JPRB, 0.412130E+01_JPRB &
  &, 0.411425E+01_JPRB, 0.410665E+01_JPRB, 0.409851E+01_JPRB, 0.408990E+01_JPRB &
  &, 0.408073E+01_JPRB, 0.407109E+01_JPRB, 0.406094E+01_JPRB &
  &, 0.405028E+01_JPRB, 0.403921E+01_JPRB, 0.402758E+01_JPRB, 0.401556E+01_JPRB &
  &, 0.400301E+01_JPRB, 0.399001E+01_JPRB, 0.397658E+01_JPRB &
  &, 0.396273E+01_JPRB, 0.394843E+01_JPRB, 0.393370E+01_JPRB, 0.391855E+01_JPRB &
  &, 0.390295E+01_JPRB, 0.388653E+01_JPRB, 0.387066E+01_JPRB/)
XCW( 930, :) = (/ &
  &  0.115125E+01_JPRB, 0.119014E+01_JPRB, 0.122944E+01_JPRB, 0.126911E+01_JPRB &
  &, 0.130913E+01_JPRB, 0.134950E+01_JPRB, 0.139018E+01_JPRB &
  &, 0.143116E+01_JPRB, 0.147241E+01_JPRB, 0.151393E+01_JPRB, 0.155568E+01_JPRB &
  &, 0.159765E+01_JPRB, 0.163982E+01_JPRB, 0.168216E+01_JPRB &
  &, 0.172467E+01_JPRB, 0.176731E+01_JPRB, 0.181006E+01_JPRB, 0.185291E+01_JPRB &
  &, 0.189583E+01_JPRB, 0.193881E+01_JPRB, 0.198182E+01_JPRB &
  &, 0.202484E+01_JPRB, 0.206786E+01_JPRB, 0.211085E+01_JPRB, 0.215379E+01_JPRB &
  &, 0.219667E+01_JPRB, 0.223945E+01_JPRB, 0.228213E+01_JPRB &
  &, 0.232469E+01_JPRB, 0.236709E+01_JPRB, 0.240933E+01_JPRB, 0.245139E+01_JPRB &
  &, 0.249324E+01_JPRB, 0.253487E+01_JPRB, 0.257626E+01_JPRB &
  &, 0.261739E+01_JPRB, 0.265825E+01_JPRB, 0.269882E+01_JPRB, 0.273908E+01_JPRB &
  &, 0.277902E+01_JPRB, 0.281862E+01_JPRB, 0.285786E+01_JPRB &
  &, 0.289673E+01_JPRB, 0.293522E+01_JPRB, 0.297330E+01_JPRB, 0.301097E+01_JPRB &
  &, 0.304822E+01_JPRB, 0.308503E+01_JPRB, 0.312137E+01_JPRB &
  &, 0.315726E+01_JPRB, 0.319267E+01_JPRB, 0.322760E+01_JPRB, 0.326202E+01_JPRB &
  &, 0.329594E+01_JPRB, 0.332934E+01_JPRB, 0.336220E+01_JPRB &
  &, 0.339452E+01_JPRB, 0.342630E+01_JPRB, 0.345752E+01_JPRB, 0.348818E+01_JPRB &
  &, 0.351826E+01_JPRB, 0.354777E+01_JPRB, 0.357669E+01_JPRB &
  &, 0.360500E+01_JPRB, 0.363273E+01_JPRB, 0.365984E+01_JPRB, 0.368635E+01_JPRB &
  &, 0.371224E+01_JPRB, 0.373751E+01_JPRB, 0.376215E+01_JPRB &
  &, 0.378617E+01_JPRB, 0.380955E+01_JPRB, 0.383230E+01_JPRB, 0.385435E+01_JPRB &
  &, 0.387583E+01_JPRB, 0.389665E+01_JPRB, 0.391680E+01_JPRB &
  &, 0.393623E+01_JPRB, 0.395518E+01_JPRB, 0.397337E+01_JPRB, 0.399089E+01_JPRB &
  &, 0.400782E+01_JPRB, 0.402405E+01_JPRB, 0.403963E+01_JPRB &
  &, 0.405455E+01_JPRB, 0.406881E+01_JPRB, 0.408232E+01_JPRB, 0.409536E+01_JPRB &
  &, 0.410768E+01_JPRB, 0.411929E+01_JPRB, 0.413028E+01_JPRB &
  &, 0.414061E+01_JPRB, 0.415029E+01_JPRB, 0.415932E+01_JPRB, 0.416771E+01_JPRB &
  &, 0.417549E+01_JPRB, 0.418258E+01_JPRB, 0.418904E+01_JPRB &
  &, 0.419488E+01_JPRB, 0.420008E+01_JPRB, 0.420461E+01_JPRB, 0.420856E+01_JPRB &
  &, 0.421188E+01_JPRB, 0.421457E+01_JPRB, 0.421669E+01_JPRB &
  &, 0.421814E+01_JPRB, 0.421901E+01_JPRB, 0.421928E+01_JPRB, 0.421896E+01_JPRB &
  &, 0.421803E+01_JPRB, 0.421650E+01_JPRB, 0.421439E+01_JPRB &
  &, 0.421172E+01_JPRB, 0.420846E+01_JPRB, 0.420468E+01_JPRB, 0.420020E+01_JPRB &
  &, 0.419537E+01_JPRB, 0.418983E+01_JPRB, 0.418379E+01_JPRB &
  &, 0.417722E+01_JPRB, 0.417014E+01_JPRB, 0.416252E+01_JPRB, 0.415432E+01_JPRB &
  &, 0.414567E+01_JPRB, 0.413648E+01_JPRB, 0.412677E+01_JPRB &
  &, 0.411661E+01_JPRB, 0.410592E+01_JPRB, 0.409476E+01_JPRB, 0.408316E+01_JPRB &
  &, 0.407103E+01_JPRB, 0.405849E+01_JPRB, 0.404545E+01_JPRB &
  &, 0.403199E+01_JPRB, 0.401807E+01_JPRB, 0.400372E+01_JPRB, 0.398894E+01_JPRB &
  &, 0.397376E+01_JPRB, 0.395813E+01_JPRB, 0.394215E+01_JPRB/)
XCW( 931, :) = (/ &
  &  0.115207E+01_JPRB, 0.119120E+01_JPRB, 0.123073E+01_JPRB, 0.127064E+01_JPRB &
  &, 0.131093E+01_JPRB, 0.135155E+01_JPRB, 0.139251E+01_JPRB &
  &, 0.143377E+01_JPRB, 0.147532E+01_JPRB, 0.151713E+01_JPRB, 0.155920E+01_JPRB &
  &, 0.160148E+01_JPRB, 0.164398E+01_JPRB, 0.168666E+01_JPRB &
  &, 0.172951E+01_JPRB, 0.177250E+01_JPRB, 0.181561E+01_JPRB, 0.185883E+01_JPRB &
  &, 0.190213E+01_JPRB, 0.194549E+01_JPRB, 0.198890E+01_JPRB &
  &, 0.203232E+01_JPRB, 0.207575E+01_JPRB, 0.211916E+01_JPRB, 0.216252E+01_JPRB &
  &, 0.220583E+01_JPRB, 0.224905E+01_JPRB, 0.229218E+01_JPRB &
  &, 0.233519E+01_JPRB, 0.237806E+01_JPRB, 0.242077E+01_JPRB, 0.246330E+01_JPRB &
  &, 0.250563E+01_JPRB, 0.254775E+01_JPRB, 0.258964E+01_JPRB &
  &, 0.263127E+01_JPRB, 0.267264E+01_JPRB, 0.271373E+01_JPRB, 0.275451E+01_JPRB &
  &, 0.279497E+01_JPRB, 0.283510E+01_JPRB, 0.287488E+01_JPRB &
  &, 0.291430E+01_JPRB, 0.295334E+01_JPRB, 0.299197E+01_JPRB, 0.303021E+01_JPRB &
  &, 0.306803E+01_JPRB, 0.310540E+01_JPRB, 0.314232E+01_JPRB &
  &, 0.317544E+01_JPRB, 0.321479E+01_JPRB, 0.325030E+01_JPRB, 0.328531E+01_JPRB &
  &, 0.331983E+01_JPRB, 0.335382E+01_JPRB, 0.338729E+01_JPRB &
  &, 0.342023E+01_JPRB, 0.345260E+01_JPRB, 0.348445E+01_JPRB, 0.351572E+01_JPRB &
  &, 0.354642E+01_JPRB, 0.357655E+01_JPRB, 0.360610E+01_JPRB &
  &, 0.363505E+01_JPRB, 0.366339E+01_JPRB, 0.369116E+01_JPRB, 0.371829E+01_JPRB &
  &, 0.374482E+01_JPRB, 0.377073E+01_JPRB, 0.379598E+01_JPRB &
  &, 0.382067E+01_JPRB, 0.384469E+01_JPRB, 0.386808E+01_JPRB, 0.389081E+01_JPRB &
  &, 0.391293E+01_JPRB, 0.393434E+01_JPRB, 0.395518E+01_JPRB &
  &, 0.397534E+01_JPRB, 0.399483E+01_JPRB, 0.401367E+01_JPRB, 0.403188E+01_JPRB &
  &, 0.404943E+01_JPRB, 0.406631E+01_JPRB, 0.408253E+01_JPRB &
  &, 0.409807E+01_JPRB, 0.411299E+01_JPRB, 0.412724E+01_JPRB, 0.414082E+01_JPRB &
  &, 0.415375E+01_JPRB, 0.416602E+01_JPRB, 0.417765E+01_JPRB &
  &, 0.418862E+01_JPRB, 0.419893E+01_JPRB, 0.420860E+01_JPRB, 0.421737E+01_JPRB &
  &, 0.422598E+01_JPRB, 0.423371E+01_JPRB, 0.424077E+01_JPRB &
  &, 0.424722E+01_JPRB, 0.425306E+01_JPRB, 0.425823E+01_JPRB, 0.426274E+01_JPRB &
  &, 0.426666E+01_JPRB, 0.426999E+01_JPRB, 0.427263E+01_JPRB &
  &, 0.427471E+01_JPRB, 0.427617E+01_JPRB, 0.427703E+01_JPRB, 0.427726E+01_JPRB &
  &, 0.427682E+01_JPRB, 0.427592E+01_JPRB, 0.427439E+01_JPRB &
  &, 0.427230E+01_JPRB, 0.426957E+01_JPRB, 0.426630E+01_JPRB, 0.426248E+01_JPRB &
  &, 0.425807E+01_JPRB, 0.425309E+01_JPRB, 0.424760E+01_JPRB &
  &, 0.424153E+01_JPRB, 0.423490E+01_JPRB, 0.422782E+01_JPRB, 0.422015E+01_JPRB &
  &, 0.421193E+01_JPRB, 0.420326E+01_JPRB, 0.419402E+01_JPRB &
  &, 0.418432E+01_JPRB, 0.417413E+01_JPRB, 0.416342E+01_JPRB, 0.415220E+01_JPRB &
  &, 0.414055E+01_JPRB, 0.412844E+01_JPRB, 0.411582E+01_JPRB &
  &, 0.410277E+01_JPRB, 0.408926E+01_JPRB, 0.407536E+01_JPRB, 0.406096E+01_JPRB &
  &, 0.404616E+01_JPRB, 0.403091E+01_JPRB, 0.401522E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART133',1,ZHOOK_HANDLE)
END SUBROUTINE PART133

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART134

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART134',0,ZHOOK_HANDLE)

XCW( 932, :) = (/ &
  &  0.115290E+01_JPRB, 0.119226E+01_JPRB, 0.123203E+01_JPRB, 0.127220E+01_JPRB &
  &, 0.131274E+01_JPRB, 0.135364E+01_JPRB, 0.139487E+01_JPRB &
  &, 0.143642E+01_JPRB, 0.147826E+01_JPRB, 0.152038E+01_JPRB, 0.156276E+01_JPRB &
  &, 0.160537E+01_JPRB, 0.164819E+01_JPRB, 0.169121E+01_JPRB &
  &, 0.173441E+01_JPRB, 0.177776E+01_JPRB, 0.182124E+01_JPRB, 0.186483E+01_JPRB &
  &, 0.190851E+01_JPRB, 0.195227E+01_JPRB, 0.199607E+01_JPRB &
  &, 0.203990E+01_JPRB, 0.208374E+01_JPRB, 0.212758E+01_JPRB, 0.217137E+01_JPRB &
  &, 0.221512E+01_JPRB, 0.225879E+01_JPRB, 0.230237E+01_JPRB &
  &, 0.234584E+01_JPRB, 0.238917E+01_JPRB, 0.243236E+01_JPRB, 0.247537E+01_JPRB &
  &, 0.251820E+01_JPRB, 0.256082E+01_JPRB, 0.260321E+01_JPRB &
  &, 0.264535E+01_JPRB, 0.268724E+01_JPRB, 0.272885E+01_JPRB, 0.277016E+01_JPRB &
  &, 0.281116E+01_JPRB, 0.285184E+01_JPRB, 0.289216E+01_JPRB &
  &, 0.293214E+01_JPRB, 0.297172E+01_JPRB, 0.301094E+01_JPRB, 0.304974E+01_JPRB &
  &, 0.308813E+01_JPRB, 0.312608E+01_JPRB, 0.316359E+01_JPRB &
  &, 0.320065E+01_JPRB, 0.323724E+01_JPRB, 0.327334E+01_JPRB, 0.330897E+01_JPRB &
  &, 0.334409E+01_JPRB, 0.337869E+01_JPRB, 0.341278E+01_JPRB &
  &, 0.344632E+01_JPRB, 0.347934E+01_JPRB, 0.351181E+01_JPRB, 0.354370E+01_JPRB &
  &, 0.357505E+01_JPRB, 0.360581E+01_JPRB, 0.363599E+01_JPRB &
  &, 0.366557E+01_JPRB, 0.369457E+01_JPRB, 0.372297E+01_JPRB, 0.375076E+01_JPRB &
  &, 0.377793E+01_JPRB, 0.380449E+01_JPRB, 0.383042E+01_JPRB &
  &, 0.385574E+01_JPRB, 0.388041E+01_JPRB, 0.390446E+01_JPRB, 0.392785E+01_JPRB &
  &, 0.395062E+01_JPRB, 0.397273E+01_JPRB, 0.399421E+01_JPRB &
  &, 0.401503E+01_JPRB, 0.403519E+01_JPRB, 0.405466E+01_JPRB, 0.407354E+01_JPRB &
  &, 0.409174E+01_JPRB, 0.410928E+01_JPRB, 0.412617E+01_JPRB &
  &, 0.414240E+01_JPRB, 0.415794E+01_JPRB, 0.417286E+01_JPRB, 0.418709E+01_JPRB &
  &, 0.420069E+01_JPRB, 0.421361E+01_JPRB, 0.422589E+01_JPRB &
  &, 0.423751E+01_JPRB, 0.424844E+01_JPRB, 0.425876E+01_JPRB, 0.426842E+01_JPRB &
  &, 0.427742E+01_JPRB, 0.428581E+01_JPRB, 0.429349E+01_JPRB &
  &, 0.430059E+01_JPRB, 0.430702E+01_JPRB, 0.431281E+01_JPRB, 0.431798E+01_JPRB &
  &, 0.432251E+01_JPRB, 0.432642E+01_JPRB, 0.432971E+01_JPRB &
  &, 0.433236E+01_JPRB, 0.433443E+01_JPRB, 0.433586E+01_JPRB, 0.433669E+01_JPRB &
  &, 0.433677E+01_JPRB, 0.433656E+01_JPRB, 0.433563E+01_JPRB &
  &, 0.433404E+01_JPRB, 0.433190E+01_JPRB, 0.432922E+01_JPRB, 0.432594E+01_JPRB &
  &, 0.432206E+01_JPRB, 0.431766E+01_JPRB, 0.431270E+01_JPRB &
  &, 0.430715E+01_JPRB, 0.430107E+01_JPRB, 0.429445E+01_JPRB, 0.428734E+01_JPRB &
  &, 0.427961E+01_JPRB, 0.427144E+01_JPRB, 0.426273E+01_JPRB &
  &, 0.425351E+01_JPRB, 0.424374E+01_JPRB, 0.423355E+01_JPRB, 0.422279E+01_JPRB &
  &, 0.421160E+01_JPRB, 0.419993E+01_JPRB, 0.418775E+01_JPRB &
  &, 0.417513E+01_JPRB, 0.416210E+01_JPRB, 0.414855E+01_JPRB, 0.413457E+01_JPRB &
  &, 0.412017E+01_JPRB, 0.410531E+01_JPRB, 0.409007E+01_JPRB/)
XCW( 933, :) = (/ &
  &  0.115375E+01_JPRB, 0.119334E+01_JPRB, 0.123335E+01_JPRB, 0.127377E+01_JPRB &
  &, 0.131458E+01_JPRB, 0.135574E+01_JPRB, 0.139726E+01_JPRB &
  &, 0.143910E+01_JPRB, 0.148124E+01_JPRB, 0.152367E+01_JPRB, 0.156636E+01_JPRB &
  &, 0.160930E+01_JPRB, 0.165246E+01_JPRB, 0.169582E+01_JPRB &
  &, 0.173938E+01_JPRB, 0.178309E+01_JPRB, 0.182694E+01_JPRB, 0.187091E+01_JPRB &
  &, 0.191498E+01_JPRB, 0.195913E+01_JPRB, 0.200334E+01_JPRB &
  &, 0.204759E+01_JPRB, 0.209185E+01_JPRB, 0.213611E+01_JPRB, 0.218035E+01_JPRB &
  &, 0.222454E+01_JPRB, 0.226866E+01_JPRB, 0.231268E+01_JPRB &
  &, 0.235664E+01_JPRB, 0.240045E+01_JPRB, 0.244412E+01_JPRB, 0.248763E+01_JPRB &
  &, 0.253095E+01_JPRB, 0.257408E+01_JPRB, 0.261698E+01_JPRB &
  &, 0.265964E+01_JPRB, 0.270205E+01_JPRB, 0.274419E+01_JPRB, 0.278604E+01_JPRB &
  &, 0.282760E+01_JPRB, 0.286882E+01_JPRB, 0.290970E+01_JPRB &
  &, 0.295023E+01_JPRB, 0.299040E+01_JPRB, 0.303018E+01_JPRB, 0.306957E+01_JPRB &
  &, 0.310853E+01_JPRB, 0.314707E+01_JPRB, 0.318519E+01_JPRB &
  &, 0.322284E+01_JPRB, 0.326003E+01_JPRB, 0.329676E+01_JPRB, 0.333299E+01_JPRB &
  &, 0.336873E+01_JPRB, 0.340396E+01_JPRB, 0.343867E+01_JPRB &
  &, 0.347285E+01_JPRB, 0.350650E+01_JPRB, 0.353960E+01_JPRB, 0.357214E+01_JPRB &
  &, 0.360412E+01_JPRB, 0.363553E+01_JPRB, 0.366636E+01_JPRB &
  &, 0.369662E+01_JPRB, 0.372627E+01_JPRB, 0.375533E+01_JPRB, 0.378377E+01_JPRB &
  &, 0.381158E+01_JPRB, 0.383884E+01_JPRB, 0.386536E+01_JPRB &
  &, 0.389142E+01_JPRB, 0.391675E+01_JPRB, 0.394146E+01_JPRB, 0.396555E+01_JPRB &
  &, 0.398898E+01_JPRB, 0.401173E+01_JPRB, 0.403391E+01_JPRB &
  &, 0.405541E+01_JPRB, 0.407625E+01_JPRB, 0.409643E+01_JPRB, 0.411595E+01_JPRB &
  &, 0.413482E+01_JPRB, 0.415304E+01_JPRB, 0.417060E+01_JPRB &
  &, 0.418749E+01_JPRB, 0.420373E+01_JPRB, 0.421928E+01_JPRB, 0.423420E+01_JPRB &
  &, 0.424847E+01_JPRB, 0.426205E+01_JPRB, 0.427500E+01_JPRB &
  &, 0.428729E+01_JPRB, 0.429892E+01_JPRB, 0.430988E+01_JPRB, 0.432017E+01_JPRB &
  &, 0.432985E+01_JPRB, 0.433887E+01_JPRB, 0.434723E+01_JPRB &
  &, 0.435494E+01_JPRB, 0.436203E+01_JPRB, 0.436846E+01_JPRB, 0.437427E+01_JPRB &
  &, 0.437943E+01_JPRB, 0.438397E+01_JPRB, 0.438790E+01_JPRB &
  &, 0.439118E+01_JPRB, 0.439384E+01_JPRB, 0.439589E+01_JPRB, 0.439735E+01_JPRB &
  &, 0.439818E+01_JPRB, 0.439842E+01_JPRB, 0.439806E+01_JPRB &
  &, 0.439708E+01_JPRB, 0.439555E+01_JPRB, 0.439339E+01_JPRB, 0.439052E+01_JPRB &
  &, 0.438739E+01_JPRB, 0.438353E+01_JPRB, 0.437911E+01_JPRB &
  &, 0.437415E+01_JPRB, 0.436862E+01_JPRB, 0.436257E+01_JPRB, 0.435593E+01_JPRB &
  &, 0.434877E+01_JPRB, 0.434111E+01_JPRB, 0.433248E+01_JPRB &
  &, 0.432408E+01_JPRB, 0.431492E+01_JPRB, 0.430522E+01_JPRB, 0.429494E+01_JPRB &
  &, 0.428422E+01_JPRB, 0.427302E+01_JPRB, 0.426130E+01_JPRB &
  &, 0.424913E+01_JPRB, 0.423630E+01_JPRB, 0.422344E+01_JPRB, 0.420988E+01_JPRB &
  &, 0.419590E+01_JPRB, 0.418126E+01_JPRB, 0.416662E+01_JPRB/)
XCW( 934, :) = (/ &
  &  0.115460E+01_JPRB, 0.119443E+01_JPRB, 0.123469E+01_JPRB, 0.127536E+01_JPRB &
  &, 0.131643E+01_JPRB, 0.135788E+01_JPRB, 0.139968E+01_JPRB &
  &, 0.144181E+01_JPRB, 0.148426E+01_JPRB, 0.152700E+01_JPRB, 0.157002E+01_JPRB &
  &, 0.161329E+01_JPRB, 0.165679E+01_JPRB, 0.170050E+01_JPRB &
  &, 0.174441E+01_JPRB, 0.178849E+01_JPRB, 0.183272E+01_JPRB, 0.187707E+01_JPRB &
  &, 0.192154E+01_JPRB, 0.196609E+01_JPRB, 0.201072E+01_JPRB &
  &, 0.205538E+01_JPRB, 0.210007E+01_JPRB, 0.214477E+01_JPRB, 0.218945E+01_JPRB &
  &, 0.223409E+01_JPRB, 0.227868E+01_JPRB, 0.232319E+01_JPRB &
  &, 0.236760E+01_JPRB, 0.241190E+01_JPRB, 0.245606E+01_JPRB, 0.250006E+01_JPRB &
  &, 0.254390E+01_JPRB, 0.258753E+01_JPRB, 0.263095E+01_JPRB &
  &, 0.267415E+01_JPRB, 0.271709E+01_JPRB, 0.275978E+01_JPRB, 0.280217E+01_JPRB &
  &, 0.284427E+01_JPRB, 0.288606E+01_JPRB, 0.292751E+01_JPRB &
  &, 0.296862E+01_JPRB, 0.300936E+01_JPRB, 0.304973E+01_JPRB, 0.308969E+01_JPRB &
  &, 0.312927E+01_JPRB, 0.316841E+01_JPRB, 0.320712E+01_JPRB &
  &, 0.324539E+01_JPRB, 0.328321E+01_JPRB, 0.332055E+01_JPRB, 0.335741E+01_JPRB &
  &, 0.339377E+01_JPRB, 0.342964E+01_JPRB, 0.346499E+01_JPRB &
  &, 0.349982E+01_JPRB, 0.353411E+01_JPRB, 0.356785E+01_JPRB, 0.360106E+01_JPRB &
  &, 0.363370E+01_JPRB, 0.366577E+01_JPRB, 0.369725E+01_JPRB &
  &, 0.372816E+01_JPRB, 0.375849E+01_JPRB, 0.378822E+01_JPRB, 0.381734E+01_JPRB &
  &, 0.384586E+01_JPRB, 0.387376E+01_JPRB, 0.390105E+01_JPRB &
  &, 0.392769E+01_JPRB, 0.395373E+01_JPRB, 0.397914E+01_JPRB, 0.400387E+01_JPRB &
  &, 0.402800E+01_JPRB, 0.405148E+01_JPRB, 0.407432E+01_JPRB &
  &, 0.409648E+01_JPRB, 0.411802E+01_JPRB, 0.413888E+01_JPRB, 0.415911E+01_JPRB &
  &, 0.417867E+01_JPRB, 0.419757E+01_JPRB, 0.421583E+01_JPRB &
  &, 0.423341E+01_JPRB, 0.425033E+01_JPRB, 0.426661E+01_JPRB, 0.428220E+01_JPRB &
  &, 0.429714E+01_JPRB, 0.431141E+01_JPRB, 0.432504E+01_JPRB &
  &, 0.433801E+01_JPRB, 0.435030E+01_JPRB, 0.436195E+01_JPRB, 0.437293E+01_JPRB &
  &, 0.438326E+01_JPRB, 0.439294E+01_JPRB, 0.440196E+01_JPRB &
  &, 0.441035E+01_JPRB, 0.441810E+01_JPRB, 0.442518E+01_JPRB, 0.443165E+01_JPRB &
  &, 0.443746E+01_JPRB, 0.444265E+01_JPRB, 0.444719E+01_JPRB &
  &, 0.445116E+01_JPRB, 0.445443E+01_JPRB, 0.445713E+01_JPRB, 0.445923E+01_JPRB &
  &, 0.446066E+01_JPRB, 0.446149E+01_JPRB, 0.446177E+01_JPRB &
  &, 0.446143E+01_JPRB, 0.446048E+01_JPRB, 0.445890E+01_JPRB, 0.445680E+01_JPRB &
  &, 0.445410E+01_JPRB, 0.445081E+01_JPRB, 0.444691E+01_JPRB &
  &, 0.444241E+01_JPRB, 0.443762E+01_JPRB, 0.443208E+01_JPRB, 0.442604E+01_JPRB &
  &, 0.441942E+01_JPRB, 0.441207E+01_JPRB, 0.440456E+01_JPRB &
  &, 0.439636E+01_JPRB, 0.438766E+01_JPRB, 0.437847E+01_JPRB, 0.436869E+01_JPRB &
  &, 0.435847E+01_JPRB, 0.434776E+01_JPRB, 0.433652E+01_JPRB &
  &, 0.432483E+01_JPRB, 0.431265E+01_JPRB, 0.430006E+01_JPRB, 0.428696E+01_JPRB &
  &, 0.427336E+01_JPRB, 0.425942E+01_JPRB, 0.424495E+01_JPRB/)
XCW( 935, :) = (/ &
  &  0.115546E+01_JPRB, 0.119553E+01_JPRB, 0.123604E+01_JPRB, 0.127698E+01_JPRB &
  &, 0.131832E+01_JPRB, 0.136004E+01_JPRB, 0.140213E+01_JPRB &
  &, 0.144456E+01_JPRB, 0.148732E+01_JPRB, 0.153038E+01_JPRB, 0.157372E+01_JPRB &
  &, 0.161732E+01_JPRB, 0.166117E+01_JPRB, 0.170524E+01_JPRB &
  &, 0.174951E+01_JPRB, 0.179397E+01_JPRB, 0.183858E+01_JPRB, 0.188333E+01_JPRB &
  &, 0.192819E+01_JPRB, 0.197315E+01_JPRB, 0.201819E+01_JPRB &
  &, 0.206328E+01_JPRB, 0.210841E+01_JPRB, 0.215355E+01_JPRB, 0.219868E+01_JPRB &
  &, 0.224379E+01_JPRB, 0.228884E+01_JPRB, 0.233383E+01_JPRB &
  &, 0.237873E+01_JPRB, 0.242351E+01_JPRB, 0.246817E+01_JPRB, 0.251268E+01_JPRB &
  &, 0.255703E+01_JPRB, 0.260119E+01_JPRB, 0.264514E+01_JPRB &
  &, 0.268887E+01_JPRB, 0.273236E+01_JPRB, 0.277559E+01_JPRB, 0.281855E+01_JPRB &
  &, 0.286121E+01_JPRB, 0.290357E+01_JPRB, 0.294559E+01_JPRB &
  &, 0.298729E+01_JPRB, 0.302862E+01_JPRB, 0.306958E+01_JPRB, 0.311016E+01_JPRB &
  &, 0.315032E+01_JPRB, 0.319008E+01_JPRB, 0.322942E+01_JPRB &
  &, 0.326831E+01_JPRB, 0.330675E+01_JPRB, 0.334472E+01_JPRB, 0.338222E+01_JPRB &
  &, 0.341922E+01_JPRB, 0.345574E+01_JPRB, 0.349173E+01_JPRB &
  &, 0.352722E+01_JPRB, 0.356216E+01_JPRB, 0.359658E+01_JPRB, 0.363045E+01_JPRB &
  &, 0.366376E+01_JPRB, 0.369649E+01_JPRB, 0.372866E+01_JPRB &
  &, 0.376024E+01_JPRB, 0.379125E+01_JPRB, 0.382168E+01_JPRB, 0.385149E+01_JPRB &
  &, 0.388069E+01_JPRB, 0.390928E+01_JPRB, 0.393723E+01_JPRB &
  &, 0.396462E+01_JPRB, 0.399134E+01_JPRB, 0.401743E+01_JPRB, 0.404290E+01_JPRB &
  &, 0.406771E+01_JPRB, 0.409191E+01_JPRB, 0.411545E+01_JPRB &
  &, 0.413832E+01_JPRB, 0.416057E+01_JPRB, 0.418214E+01_JPRB, 0.420304E+01_JPRB &
  &, 0.422332E+01_JPRB, 0.424293E+01_JPRB, 0.426190E+01_JPRB &
  &, 0.428019E+01_JPRB, 0.429777E+01_JPRB, 0.431477E+01_JPRB, 0.433106E+01_JPRB &
  &, 0.434672E+01_JPRB, 0.436169E+01_JPRB, 0.437602E+01_JPRB &
  &, 0.438966E+01_JPRB, 0.440268E+01_JPRB, 0.441500E+01_JPRB, 0.442669E+01_JPRB &
  &, 0.443772E+01_JPRB, 0.444808E+01_JPRB, 0.445781E+01_JPRB &
  &, 0.446684E+01_JPRB, 0.447526E+01_JPRB, 0.448305E+01_JPRB, 0.449019E+01_JPRB &
  &, 0.449664E+01_JPRB, 0.450251E+01_JPRB, 0.450775E+01_JPRB &
  &, 0.451231E+01_JPRB, 0.451629E+01_JPRB, 0.451961E+01_JPRB, 0.452233E+01_JPRB &
  &, 0.452443E+01_JPRB, 0.452591E+01_JPRB, 0.452680E+01_JPRB &
  &, 0.452707E+01_JPRB, 0.452673E+01_JPRB, 0.452580E+01_JPRB, 0.452430E+01_JPRB &
  &, 0.452214E+01_JPRB, 0.451954E+01_JPRB, 0.451627E+01_JPRB &
  &, 0.451245E+01_JPRB, 0.450810E+01_JPRB, 0.450312E+01_JPRB, 0.449765E+01_JPRB &
  &, 0.449159E+01_JPRB, 0.448502E+01_JPRB, 0.447784E+01_JPRB &
  &, 0.447019E+01_JPRB, 0.446202E+01_JPRB, 0.445336E+01_JPRB, 0.444411E+01_JPRB &
  &, 0.443441E+01_JPRB, 0.442421E+01_JPRB, 0.441348E+01_JPRB &
  &, 0.440223E+01_JPRB, 0.439036E+01_JPRB, 0.437844E+01_JPRB, 0.436581E+01_JPRB &
  &, 0.435268E+01_JPRB, 0.433913E+01_JPRB, 0.432518E+01_JPRB/)
XCW( 936, :) = (/ &
  &  0.115634E+01_JPRB, 0.119665E+01_JPRB, 0.123741E+01_JPRB, 0.127861E+01_JPRB &
  &, 0.132022E+01_JPRB, 0.136223E+01_JPRB, 0.140461E+01_JPRB &
  &, 0.144735E+01_JPRB, 0.149041E+01_JPRB, 0.153380E+01_JPRB, 0.157747E+01_JPRB &
  &, 0.162142E+01_JPRB, 0.166562E+01_JPRB, 0.171005E+01_JPRB &
  &, 0.175469E+01_JPRB, 0.179952E+01_JPRB, 0.184452E+01_JPRB, 0.188966E+01_JPRB &
  &, 0.193494E+01_JPRB, 0.198032E+01_JPRB, 0.202578E+01_JPRB &
  &, 0.207130E+01_JPRB, 0.211687E+01_JPRB, 0.216246E+01_JPRB, 0.220805E+01_JPRB &
  &, 0.225362E+01_JPRB, 0.229915E+01_JPRB, 0.234462E+01_JPRB &
  &, 0.239001E+01_JPRB, 0.243530E+01_JPRB, 0.248047E+01_JPRB, 0.252550E+01_JPRB &
  &, 0.257037E+01_JPRB, 0.261505E+01_JPRB, 0.265955E+01_JPRB &
  &, 0.270382E+01_JPRB, 0.274787E+01_JPRB, 0.279166E+01_JPRB, 0.283518E+01_JPRB &
  &, 0.287842E+01_JPRB, 0.292136E+01_JPRB, 0.296397E+01_JPRB &
  &, 0.300625E+01_JPRB, 0.304818E+01_JPRB, 0.308975E+01_JPRB, 0.313093E+01_JPRB &
  &, 0.317173E+01_JPRB, 0.321210E+01_JPRB, 0.325207E+01_JPRB &
  &, 0.329159E+01_JPRB, 0.333067E+01_JPRB, 0.336929E+01_JPRB, 0.340743E+01_JPRB &
  &, 0.344510E+01_JPRB, 0.348226E+01_JPRB, 0.351893E+01_JPRB &
  &, 0.355508E+01_JPRB, 0.359071E+01_JPRB, 0.362579E+01_JPRB, 0.366034E+01_JPRB &
  &, 0.369433E+01_JPRB, 0.372776E+01_JPRB, 0.376061E+01_JPRB &
  &, 0.379291E+01_JPRB, 0.382460E+01_JPRB, 0.385571E+01_JPRB, 0.388622E+01_JPRB &
  &, 0.391614E+01_JPRB, 0.394543E+01_JPRB, 0.397411E+01_JPRB &
  &, 0.400203E+01_JPRB, 0.402963E+01_JPRB, 0.405645E+01_JPRB, 0.408261E+01_JPRB &
  &, 0.410815E+01_JPRB, 0.413304E+01_JPRB, 0.415731E+01_JPRB &
  &, 0.418090E+01_JPRB, 0.420388E+01_JPRB, 0.422616E+01_JPRB, 0.424780E+01_JPRB &
  &, 0.426880E+01_JPRB, 0.428915E+01_JPRB, 0.430881E+01_JPRB &
  &, 0.432781E+01_JPRB, 0.434618E+01_JPRB, 0.436385E+01_JPRB, 0.438088E+01_JPRB &
  &, 0.439723E+01_JPRB, 0.441294E+01_JPRB, 0.442796E+01_JPRB &
  &, 0.444235E+01_JPRB, 0.445606E+01_JPRB, 0.446910E+01_JPRB, 0.448148E+01_JPRB &
  &, 0.449321E+01_JPRB, 0.450429E+01_JPRB, 0.451471E+01_JPRB &
  &, 0.452447E+01_JPRB, 0.453359E+01_JPRB, 0.454200E+01_JPRB, 0.454986E+01_JPRB &
  &, 0.455705E+01_JPRB, 0.456360E+01_JPRB, 0.456950E+01_JPRB &
  &, 0.457475E+01_JPRB, 0.457937E+01_JPRB, 0.458338E+01_JPRB, 0.458678E+01_JPRB &
  &, 0.458952E+01_JPRB, 0.459164E+01_JPRB, 0.459321E+01_JPRB &
  &, 0.459411E+01_JPRB, 0.459440E+01_JPRB, 0.459414E+01_JPRB, 0.459325E+01_JPRB &
  &, 0.459176E+01_JPRB, 0.458973E+01_JPRB, 0.458706E+01_JPRB &
  &, 0.458390E+01_JPRB, 0.458009E+01_JPRB, 0.457576E+01_JPRB, 0.457077E+01_JPRB &
  &, 0.456535E+01_JPRB, 0.455936E+01_JPRB, 0.455281E+01_JPRB &
  &, 0.454484E+01_JPRB, 0.453806E+01_JPRB, 0.452990E+01_JPRB, 0.452126E+01_JPRB &
  &, 0.451204E+01_JPRB, 0.450238E+01_JPRB, 0.449218E+01_JPRB &
  &, 0.448145E+01_JPRB, 0.447028E+01_JPRB, 0.445862E+01_JPRB, 0.444649E+01_JPRB &
  &, 0.443386E+01_JPRB, 0.442079E+01_JPRB, 0.440726E+01_JPRB/)
XCW( 937, :) = (/ &
  &  0.115722E+01_JPRB, 0.119778E+01_JPRB, 0.123880E+01_JPRB, 0.128027E+01_JPRB &
  &, 0.132216E+01_JPRB, 0.136445E+01_JPRB, 0.140713E+01_JPRB &
  &, 0.145017E+01_JPRB, 0.149356E+01_JPRB, 0.153726E+01_JPRB, 0.158128E+01_JPRB &
  &, 0.162557E+01_JPRB, 0.167012E+01_JPRB, 0.171492E+01_JPRB &
  &, 0.175994E+01_JPRB, 0.180515E+01_JPRB, 0.185054E+01_JPRB, 0.189609E+01_JPRB &
  &, 0.194178E+01_JPRB, 0.198758E+01_JPRB, 0.203347E+01_JPRB &
  &, 0.207944E+01_JPRB, 0.212546E+01_JPRB, 0.217150E+01_JPRB, 0.221756E+01_JPRB &
  &, 0.226361E+01_JPRB, 0.230962E+01_JPRB, 0.235558E+01_JPRB &
  &, 0.240148E+01_JPRB, 0.244727E+01_JPRB, 0.249295E+01_JPRB, 0.253851E+01_JPRB &
  &, 0.258391E+01_JPRB, 0.262914E+01_JPRB, 0.267418E+01_JPRB &
  &, 0.271901E+01_JPRB, 0.276361E+01_JPRB, 0.280798E+01_JPRB, 0.285208E+01_JPRB &
  &, 0.289590E+01_JPRB, 0.293942E+01_JPRB, 0.298264E+01_JPRB &
  &, 0.302553E+01_JPRB, 0.306807E+01_JPRB, 0.311025E+01_JPRB, 0.315206E+01_JPRB &
  &, 0.319348E+01_JPRB, 0.323449E+01_JPRB, 0.327509E+01_JPRB &
  &, 0.331527E+01_JPRB, 0.335500E+01_JPRB, 0.339427E+01_JPRB, 0.343308E+01_JPRB &
  &, 0.347141E+01_JPRB, 0.350925E+01_JPRB, 0.354659E+01_JPRB &
  &, 0.358341E+01_JPRB, 0.361973E+01_JPRB, 0.365551E+01_JPRB, 0.369075E+01_JPRB &
  &, 0.372543E+01_JPRB, 0.375956E+01_JPRB, 0.379312E+01_JPRB &
  &, 0.382612E+01_JPRB, 0.385853E+01_JPRB, 0.389034E+01_JPRB, 0.392158E+01_JPRB &
  &, 0.395218E+01_JPRB, 0.398223E+01_JPRB, 0.401163E+01_JPRB &
  &, 0.404043E+01_JPRB, 0.406860E+01_JPRB, 0.409615E+01_JPRB, 0.412304E+01_JPRB &
  &, 0.414932E+01_JPRB, 0.417496E+01_JPRB, 0.419994E+01_JPRB &
  &, 0.422420E+01_JPRB, 0.424796E+01_JPRB, 0.427102E+01_JPRB, 0.429339E+01_JPRB &
  &, 0.431514E+01_JPRB, 0.433620E+01_JPRB, 0.435661E+01_JPRB &
  &, 0.437627E+01_JPRB, 0.439543E+01_JPRB, 0.441387E+01_JPRB, 0.443162E+01_JPRB &
  &, 0.444873E+01_JPRB, 0.446517E+01_JPRB, 0.448092E+01_JPRB &
  &, 0.449593E+01_JPRB, 0.451047E+01_JPRB, 0.452426E+01_JPRB, 0.453738E+01_JPRB &
  &, 0.454982E+01_JPRB, 0.456161E+01_JPRB, 0.457278E+01_JPRB &
  &, 0.458325E+01_JPRB, 0.459308E+01_JPRB, 0.460224E+01_JPRB, 0.461078E+01_JPRB &
  &, 0.461867E+01_JPRB, 0.462590E+01_JPRB, 0.463251E+01_JPRB &
  &, 0.463847E+01_JPRB, 0.464376E+01_JPRB, 0.464847E+01_JPRB, 0.465254E+01_JPRB &
  &, 0.465598E+01_JPRB, 0.465863E+01_JPRB, 0.466098E+01_JPRB &
  &, 0.466258E+01_JPRB, 0.466347E+01_JPRB, 0.466390E+01_JPRB, 0.466366E+01_JPRB &
  &, 0.466286E+01_JPRB, 0.466146E+01_JPRB, 0.465943E+01_JPRB &
  &, 0.465684E+01_JPRB, 0.465370E+01_JPRB, 0.464994E+01_JPRB, 0.464567E+01_JPRB &
  &, 0.464080E+01_JPRB, 0.463536E+01_JPRB, 0.462940E+01_JPRB &
  &, 0.462291E+01_JPRB, 0.461584E+01_JPRB, 0.460826E+01_JPRB, 0.460019E+01_JPRB &
  &, 0.459154E+01_JPRB, 0.458238E+01_JPRB, 0.457273E+01_JPRB &
  &, 0.456255E+01_JPRB, 0.455192E+01_JPRB, 0.454073E+01_JPRB, 0.452913E+01_JPRB &
  &, 0.451689E+01_JPRB, 0.450440E+01_JPRB, 0.449137E+01_JPRB/)
XCW( 938, :) = (/ &
  &  0.115812E+01_JPRB, 0.119893E+01_JPRB, 0.124021E+01_JPRB, 0.128194E+01_JPRB &
  &, 0.132412E+01_JPRB, 0.136670E+01_JPRB, 0.140968E+01_JPRB &
  &, 0.145303E+01_JPRB, 0.149674E+01_JPRB, 0.154078E+01_JPRB, 0.158513E+01_JPRB &
  &, 0.162978E+01_JPRB, 0.167469E+01_JPRB, 0.171986E+01_JPRB &
  &, 0.176526E+01_JPRB, 0.181087E+01_JPRB, 0.185666E+01_JPRB, 0.190261E+01_JPRB &
  &, 0.194872E+01_JPRB, 0.199495E+01_JPRB, 0.204128E+01_JPRB &
  &, 0.208770E+01_JPRB, 0.213417E+01_JPRB, 0.218068E+01_JPRB, 0.222721E+01_JPRB &
  &, 0.227374E+01_JPRB, 0.232025E+01_JPRB, 0.236671E+01_JPRB &
  &, 0.241311E+01_JPRB, 0.245942E+01_JPRB, 0.250564E+01_JPRB, 0.255172E+01_JPRB &
  &, 0.259767E+01_JPRB, 0.264344E+01_JPRB, 0.268904E+01_JPRB &
  &, 0.273443E+01_JPRB, 0.277962E+01_JPRB, 0.282456E+01_JPRB, 0.286925E+01_JPRB &
  &, 0.291366E+01_JPRB, 0.295779E+01_JPRB, 0.300161E+01_JPRB &
  &, 0.304511E+01_JPRB, 0.308827E+01_JPRB, 0.313109E+01_JPRB, 0.317353E+01_JPRB &
  &, 0.321558E+01_JPRB, 0.325725E+01_JPRB, 0.329851E+01_JPRB &
  &, 0.333934E+01_JPRB, 0.337974E+01_JPRB, 0.341967E+01_JPRB, 0.345916E+01_JPRB &
  &, 0.349817E+01_JPRB, 0.353669E+01_JPRB, 0.357473E+01_JPRB &
  &, 0.361222E+01_JPRB, 0.364926E+01_JPRB, 0.368573E+01_JPRB, 0.372167E+01_JPRB &
  &, 0.375707E+01_JPRB, 0.379192E+01_JPRB, 0.382620E+01_JPRB &
  &, 0.385992E+01_JPRB, 0.389305E+01_JPRB, 0.392560E+01_JPRB, 0.395757E+01_JPRB &
  &, 0.398893E+01_JPRB, 0.401969E+01_JPRB, 0.404983E+01_JPRB &
  &, 0.407938E+01_JPRB, 0.410828E+01_JPRB, 0.413657E+01_JPRB, 0.416422E+01_JPRB &
  &, 0.419125E+01_JPRB, 0.421763E+01_JPRB, 0.424336E+01_JPRB &
  &, 0.426846E+01_JPRB, 0.429291E+01_JPRB, 0.431671E+01_JPRB, 0.433985E+01_JPRB &
  &, 0.436235E+01_JPRB, 0.438417E+01_JPRB, 0.440533E+01_JPRB &
  &, 0.442583E+01_JPRB, 0.444569E+01_JPRB, 0.446486E+01_JPRB, 0.448336E+01_JPRB &
  &, 0.450122E+01_JPRB, 0.451841E+01_JPRB, 0.453492E+01_JPRB &
  &, 0.455080E+01_JPRB, 0.456598E+01_JPRB, 0.458049E+01_JPRB, 0.459434E+01_JPRB &
  &, 0.460758E+01_JPRB, 0.462011E+01_JPRB, 0.463197E+01_JPRB &
  &, 0.464321E+01_JPRB, 0.465377E+01_JPRB, 0.466366E+01_JPRB, 0.467294E+01_JPRB &
  &, 0.468141E+01_JPRB, 0.468952E+01_JPRB, 0.469682E+01_JPRB &
  &, 0.470351E+01_JPRB, 0.470953E+01_JPRB, 0.471493E+01_JPRB, 0.471969E+01_JPRB &
  &, 0.472385E+01_JPRB, 0.472718E+01_JPRB, 0.473022E+01_JPRB &
  &, 0.473253E+01_JPRB, 0.473414E+01_JPRB, 0.473520E+01_JPRB, 0.473548E+01_JPRB &
  &, 0.473548E+01_JPRB, 0.473474E+01_JPRB, 0.473336E+01_JPRB &
  &, 0.473147E+01_JPRB, 0.472893E+01_JPRB, 0.472581E+01_JPRB, 0.472218E+01_JPRB &
  &, 0.471794E+01_JPRB, 0.471312E+01_JPRB, 0.470779E+01_JPRB &
  &, 0.470186E+01_JPRB, 0.469540E+01_JPRB, 0.468842E+01_JPRB, 0.468090E+01_JPRB &
  &, 0.467284E+01_JPRB, 0.466427E+01_JPRB, 0.465514E+01_JPRB &
  &, 0.464553E+01_JPRB, 0.463547E+01_JPRB, 0.462484E+01_JPRB, 0.461373E+01_JPRB &
  &, 0.460210E+01_JPRB, 0.459008E+01_JPRB, 0.457751E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART134',1,ZHOOK_HANDLE)
END SUBROUTINE PART134

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART135

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART135',0,ZHOOK_HANDLE)

XCW( 939, :) = (/ &
  &  0.115902E+01_JPRB, 0.120009E+01_JPRB, 0.124164E+01_JPRB, 0.128365E+01_JPRB &
  &, 0.132610E+01_JPRB, 0.136898E+01_JPRB, 0.141227E+01_JPRB &
  &, 0.145593E+01_JPRB, 0.149997E+01_JPRB, 0.154435E+01_JPRB, 0.158904E+01_JPRB &
  &, 0.163405E+01_JPRB, 0.167933E+01_JPRB, 0.172488E+01_JPRB &
  &, 0.177066E+01_JPRB, 0.181666E+01_JPRB, 0.186286E+01_JPRB, 0.190924E+01_JPRB &
  &, 0.195577E+01_JPRB, 0.200243E+01_JPRB, 0.204921E+01_JPRB &
  &, 0.209608E+01_JPRB, 0.214302E+01_JPRB, 0.219000E+01_JPRB, 0.223702E+01_JPRB &
  &, 0.228404E+01_JPRB, 0.233104E+01_JPRB, 0.237801E+01_JPRB &
  &, 0.242493E+01_JPRB, 0.247177E+01_JPRB, 0.251851E+01_JPRB, 0.256514E+01_JPRB &
  &, 0.261164E+01_JPRB, 0.265798E+01_JPRB, 0.270414E+01_JPRB &
  &, 0.275011E+01_JPRB, 0.279588E+01_JPRB, 0.284141E+01_JPRB, 0.288669E+01_JPRB &
  &, 0.293171E+01_JPRB, 0.297645E+01_JPRB, 0.302090E+01_JPRB &
  &, 0.306502E+01_JPRB, 0.310882E+01_JPRB, 0.315228E+01_JPRB, 0.319537E+01_JPRB &
  &, 0.323808E+01_JPRB, 0.328040E+01_JPRB, 0.332232E+01_JPRB &
  &, 0.336382E+01_JPRB, 0.340489E+01_JPRB, 0.344552E+01_JPRB, 0.348569E+01_JPRB &
  &, 0.352539E+01_JPRB, 0.356462E+01_JPRB, 0.360335E+01_JPRB &
  &, 0.364157E+01_JPRB, 0.367929E+01_JPRB, 0.371650E+01_JPRB, 0.375315E+01_JPRB &
  &, 0.378929E+01_JPRB, 0.382485E+01_JPRB, 0.385987E+01_JPRB &
  &, 0.389433E+01_JPRB, 0.392820E+01_JPRB, 0.396151E+01_JPRB, 0.399422E+01_JPRB &
  &, 0.402634E+01_JPRB, 0.405784E+01_JPRB, 0.408873E+01_JPRB &
  &, 0.411902E+01_JPRB, 0.414870E+01_JPRB, 0.417775E+01_JPRB, 0.420618E+01_JPRB &
  &, 0.423396E+01_JPRB, 0.426112E+01_JPRB, 0.428761E+01_JPRB &
  &, 0.431348E+01_JPRB, 0.433871E+01_JPRB, 0.436328E+01_JPRB, 0.438718E+01_JPRB &
  &, 0.441045E+01_JPRB, 0.443304E+01_JPRB, 0.445498E+01_JPRB &
  &, 0.447627E+01_JPRB, 0.449690E+01_JPRB, 0.451663E+01_JPRB, 0.453613E+01_JPRB &
  &, 0.455475E+01_JPRB, 0.457272E+01_JPRB, 0.459000E+01_JPRB &
  &, 0.460663E+01_JPRB, 0.462258E+01_JPRB, 0.463788E+01_JPRB, 0.465251E+01_JPRB &
  &, 0.466650E+01_JPRB, 0.467977E+01_JPRB, 0.469242E+01_JPRB &
  &, 0.470438E+01_JPRB, 0.471570E+01_JPRB, 0.472638E+01_JPRB, 0.473637E+01_JPRB &
  &, 0.474568E+01_JPRB, 0.475447E+01_JPRB, 0.476252E+01_JPRB &
  &, 0.476992E+01_JPRB, 0.477670E+01_JPRB, 0.478281E+01_JPRB, 0.478831E+01_JPRB &
  &, 0.479314E+01_JPRB, 0.479739E+01_JPRB, 0.480100E+01_JPRB &
  &, 0.480397E+01_JPRB, 0.480632E+01_JPRB, 0.480807E+01_JPRB, 0.480923E+01_JPRB &
  &, 0.480977E+01_JPRB, 0.480966E+01_JPRB, 0.480897E+01_JPRB &
  &, 0.480775E+01_JPRB, 0.480588E+01_JPRB, 0.480343E+01_JPRB, 0.480041E+01_JPRB &
  &, 0.479683E+01_JPRB, 0.479266E+01_JPRB, 0.478798E+01_JPRB &
  &, 0.478269E+01_JPRB, 0.477686E+01_JPRB, 0.477046E+01_JPRB, 0.476350E+01_JPRB &
  &, 0.475606E+01_JPRB, 0.474810E+01_JPRB, 0.473958E+01_JPRB &
  &, 0.473052E+01_JPRB, 0.472099E+01_JPRB, 0.471095E+01_JPRB, 0.470042E+01_JPRB &
  &, 0.468936E+01_JPRB, 0.467784E+01_JPRB, 0.466583E+01_JPRB/)
XCW( 940, :) = (/ &
  &  0.115995E+01_JPRB, 0.120127E+01_JPRB, 0.124308E+01_JPRB, 0.128537E+01_JPRB &
  &, 0.132811E+01_JPRB, 0.137129E+01_JPRB, 0.141489E+01_JPRB &
  &, 0.145888E+01_JPRB, 0.150324E+01_JPRB, 0.154796E+01_JPRB, 0.159301E+01_JPRB &
  &, 0.163838E+01_JPRB, 0.168404E+01_JPRB, 0.172996E+01_JPRB &
  &, 0.177614E+01_JPRB, 0.182255E+01_JPRB, 0.186916E+01_JPRB, 0.191596E+01_JPRB &
  &, 0.196292E+01_JPRB, 0.201003E+01_JPRB, 0.205726E+01_JPRB &
  &, 0.210459E+01_JPRB, 0.215200E+01_JPRB, 0.219947E+01_JPRB, 0.224697E+01_JPRB &
  &, 0.229449E+01_JPRB, 0.234201E+01_JPRB, 0.238950E+01_JPRB &
  &, 0.243694E+01_JPRB, 0.248431E+01_JPRB, 0.253160E+01_JPRB, 0.257879E+01_JPRB &
  &, 0.262584E+01_JPRB, 0.267275E+01_JPRB, 0.271949E+01_JPRB &
  &, 0.276605E+01_JPRB, 0.281240E+01_JPRB, 0.285854E+01_JPRB, 0.290443E+01_JPRB &
  &, 0.295007E+01_JPRB, 0.299544E+01_JPRB, 0.304051E+01_JPRB &
  &, 0.308528E+01_JPRB, 0.312972E+01_JPRB, 0.317383E+01_JPRB, 0.321757E+01_JPRB &
  &, 0.326095E+01_JPRB, 0.330395E+01_JPRB, 0.334654E+01_JPRB &
  &, 0.338873E+01_JPRB, 0.343049E+01_JPRB, 0.347181E+01_JPRB, 0.351268E+01_JPRB &
  &, 0.355310E+01_JPRB, 0.359303E+01_JPRB, 0.363248E+01_JPRB &
  &, 0.367144E+01_JPRB, 0.370988E+01_JPRB, 0.374781E+01_JPRB, 0.378522E+01_JPRB &
  &, 0.382207E+01_JPRB, 0.385839E+01_JPRB, 0.389417E+01_JPRB &
  &, 0.392937E+01_JPRB, 0.396400E+01_JPRB, 0.399806E+01_JPRB, 0.403153E+01_JPRB &
  &, 0.406442E+01_JPRB, 0.409670E+01_JPRB, 0.412836E+01_JPRB &
  &, 0.415943E+01_JPRB, 0.418989E+01_JPRB, 0.421971E+01_JPRB, 0.424892E+01_JPRB &
  &, 0.427747E+01_JPRB, 0.430542E+01_JPRB, 0.433272E+01_JPRB &
  &, 0.435938E+01_JPRB, 0.438540E+01_JPRB, 0.441075E+01_JPRB, 0.443545E+01_JPRB &
  &, 0.445950E+01_JPRB, 0.448291E+01_JPRB, 0.450559E+01_JPRB &
  &, 0.452770E+01_JPRB, 0.454911E+01_JPRB, 0.456985E+01_JPRB, 0.458996E+01_JPRB &
  &, 0.460937E+01_JPRB, 0.462813E+01_JPRB, 0.464620E+01_JPRB &
  &, 0.466363E+01_JPRB, 0.468035E+01_JPRB, 0.469644E+01_JPRB, 0.471181E+01_JPRB &
  &, 0.472657E+01_JPRB, 0.474069E+01_JPRB, 0.475411E+01_JPRB &
  &, 0.476688E+01_JPRB, 0.477897E+01_JPRB, 0.479040E+01_JPRB, 0.480116E+01_JPRB &
  &, 0.481132E+01_JPRB, 0.482077E+01_JPRB, 0.482960E+01_JPRB &
  &, 0.483774E+01_JPRB, 0.484529E+01_JPRB, 0.485218E+01_JPRB, 0.485841E+01_JPRB &
  &, 0.486401E+01_JPRB, 0.486895E+01_JPRB, 0.487332E+01_JPRB &
  &, 0.487702E+01_JPRB, 0.488009E+01_JPRB, 0.488260E+01_JPRB, 0.488438E+01_JPRB &
  &, 0.488563E+01_JPRB, 0.488628E+01_JPRB, 0.488629E+01_JPRB &
  &, 0.488573E+01_JPRB, 0.488456E+01_JPRB, 0.488274E+01_JPRB, 0.488051E+01_JPRB &
  &, 0.487756E+01_JPRB, 0.487407E+01_JPRB, 0.487001E+01_JPRB &
  &, 0.486534E+01_JPRB, 0.486017E+01_JPRB, 0.485443E+01_JPRB, 0.484812E+01_JPRB &
  &, 0.484133E+01_JPRB, 0.483395E+01_JPRB, 0.482601E+01_JPRB &
  &, 0.481757E+01_JPRB, 0.480866E+01_JPRB, 0.479917E+01_JPRB, 0.478925E+01_JPRB &
  &, 0.477872E+01_JPRB, 0.476774E+01_JPRB, 0.475631E+01_JPRB/)
XCW( 941, :) = (/ &
  &  0.116088E+01_JPRB, 0.120246E+01_JPRB, 0.124455E+01_JPRB, 0.128712E+01_JPRB &
  &, 0.133015E+01_JPRB, 0.137364E+01_JPRB, 0.141755E+01_JPRB &
  &, 0.146186E+01_JPRB, 0.150657E+01_JPRB, 0.155163E+01_JPRB, 0.159704E+01_JPRB &
  &, 0.164278E+01_JPRB, 0.168881E+01_JPRB, 0.173513E+01_JPRB &
  &, 0.178171E+01_JPRB, 0.182852E+01_JPRB, 0.187556E+01_JPRB, 0.192278E+01_JPRB &
  &, 0.197019E+01_JPRB, 0.201775E+01_JPRB, 0.206544E+01_JPRB &
  &, 0.211324E+01_JPRB, 0.216112E+01_JPRB, 0.220908E+01_JPRB, 0.225709E+01_JPRB &
  &, 0.230512E+01_JPRB, 0.235315E+01_JPRB, 0.240116E+01_JPRB &
  &, 0.244914E+01_JPRB, 0.249706E+01_JPRB, 0.254491E+01_JPRB, 0.259265E+01_JPRB &
  &, 0.264028E+01_JPRB, 0.268777E+01_JPRB, 0.273510E+01_JPRB &
  &, 0.278225E+01_JPRB, 0.282922E+01_JPRB, 0.287596E+01_JPRB, 0.292247E+01_JPRB &
  &, 0.296875E+01_JPRB, 0.301340E+01_JPRB, 0.306045E+01_JPRB &
  &, 0.310587E+01_JPRB, 0.315098E+01_JPRB, 0.319575E+01_JPRB, 0.324016E+01_JPRB &
  &, 0.328423E+01_JPRB, 0.332790E+01_JPRB, 0.337119E+01_JPRB &
  &, 0.341408E+01_JPRB, 0.345655E+01_JPRB, 0.349857E+01_JPRB, 0.354016E+01_JPRB &
  &, 0.358129E+01_JPRB, 0.362196E+01_JPRB, 0.366215E+01_JPRB &
  &, 0.370183E+01_JPRB, 0.374103E+01_JPRB, 0.377969E+01_JPRB, 0.381785E+01_JPRB &
  &, 0.385548E+01_JPRB, 0.389256E+01_JPRB, 0.392908E+01_JPRB &
  &, 0.396507E+01_JPRB, 0.400046E+01_JPRB, 0.403531E+01_JPRB, 0.406956E+01_JPRB &
  &, 0.410307E+01_JPRB, 0.413629E+01_JPRB, 0.416875E+01_JPRB &
  &, 0.420061E+01_JPRB, 0.423186E+01_JPRB, 0.426249E+01_JPRB, 0.429247E+01_JPRB &
  &, 0.432185E+01_JPRB, 0.435059E+01_JPRB, 0.437868E+01_JPRB &
  &, 0.440615E+01_JPRB, 0.443298E+01_JPRB, 0.445914E+01_JPRB, 0.448467E+01_JPRB &
  &, 0.450953E+01_JPRB, 0.453374E+01_JPRB, 0.455729E+01_JPRB &
  &, 0.458016E+01_JPRB, 0.460240E+01_JPRB, 0.462397E+01_JPRB, 0.464485E+01_JPRB &
  &, 0.466507E+01_JPRB, 0.468463E+01_JPRB, 0.470355E+01_JPRB &
  &, 0.472176E+01_JPRB, 0.473934E+01_JPRB, 0.475622E+01_JPRB, 0.477192E+01_JPRB &
  &, 0.478800E+01_JPRB, 0.480288E+01_JPRB, 0.481710E+01_JPRB &
  &, 0.483067E+01_JPRB, 0.484356E+01_JPRB, 0.485578E+01_JPRB, 0.486735E+01_JPRB &
  &, 0.487827E+01_JPRB, 0.488852E+01_JPRB, 0.489815E+01_JPRB &
  &, 0.490709E+01_JPRB, 0.491539E+01_JPRB, 0.492304E+01_JPRB, 0.493003E+01_JPRB &
  &, 0.493638E+01_JPRB, 0.494211E+01_JPRB, 0.494724E+01_JPRB &
  &, 0.495155E+01_JPRB, 0.495550E+01_JPRB, 0.495875E+01_JPRB, 0.496132E+01_JPRB &
  &, 0.496293E+01_JPRB, 0.496465E+01_JPRB, 0.496539E+01_JPRB &
  &, 0.496555E+01_JPRB, 0.496510E+01_JPRB, 0.496406E+01_JPRB, 0.496160E+01_JPRB &
  &, 0.496009E+01_JPRB, 0.495736E+01_JPRB, 0.495400E+01_JPRB &
  &, 0.495002E+01_JPRB, 0.494549E+01_JPRB, 0.494044E+01_JPRB, 0.493481E+01_JPRB &
  &, 0.492852E+01_JPRB, 0.492187E+01_JPRB, 0.491458E+01_JPRB &
  &, 0.490680E+01_JPRB, 0.489848E+01_JPRB, 0.488958E+01_JPRB, 0.488023E+01_JPRB &
  &, 0.487033E+01_JPRB, 0.485997E+01_JPRB, 0.484897E+01_JPRB/)
XCW( 942, :) = (/ &
  &  0.116182E+01_JPRB, 0.120367E+01_JPRB, 0.124603E+01_JPRB, 0.128889E+01_JPRB &
  &, 0.133223E+01_JPRB, 0.137602E+01_JPRB, 0.142025E+01_JPRB &
  &, 0.146489E+01_JPRB, 0.150994E+01_JPRB, 0.155536E+01_JPRB, 0.160113E+01_JPRB &
  &, 0.164724E+01_JPRB, 0.169366E+01_JPRB, 0.174037E+01_JPRB &
  &, 0.178735E+01_JPRB, 0.183459E+01_JPRB, 0.188205E+01_JPRB, 0.192972E+01_JPRB &
  &, 0.197757E+01_JPRB, 0.202558E+01_JPRB, 0.207374E+01_JPRB &
  &, 0.212202E+01_JPRB, 0.217040E+01_JPRB, 0.221885E+01_JPRB, 0.226736E+01_JPRB &
  &, 0.231591E+01_JPRB, 0.236447E+01_JPRB, 0.241302E+01_JPRB &
  &, 0.246155E+01_JPRB, 0.251002E+01_JPRB, 0.255843E+01_JPRB, 0.260675E+01_JPRB &
  &, 0.265496E+01_JPRB, 0.270304E+01_JPRB, 0.275097E+01_JPRB &
  &, 0.279873E+01_JPRB, 0.284631E+01_JPRB, 0.289368E+01_JPRB, 0.294083E+01_JPRB &
  &, 0.298773E+01_JPRB, 0.303438E+01_JPRB, 0.308075E+01_JPRB &
  &, 0.312684E+01_JPRB, 0.317260E+01_JPRB, 0.321805E+01_JPRB, 0.326316E+01_JPRB &
  &, 0.330791E+01_JPRB, 0.335229E+01_JPRB, 0.339628E+01_JPRB &
  &, 0.343987E+01_JPRB, 0.348306E+01_JPRB, 0.352582E+01_JPRB, 0.356814E+01_JPRB &
  &, 0.361001E+01_JPRB, 0.365142E+01_JPRB, 0.369234E+01_JPRB &
  &, 0.373279E+01_JPRB, 0.377274E+01_JPRB, 0.381217E+01_JPRB, 0.385109E+01_JPRB &
  &, 0.388950E+01_JPRB, 0.392735E+01_JPRB, 0.396467E+01_JPRB &
  &, 0.400143E+01_JPRB, 0.403762E+01_JPRB, 0.407324E+01_JPRB, 0.410830E+01_JPRB &
  &, 0.414273E+01_JPRB, 0.417662E+01_JPRB, 0.420991E+01_JPRB &
  &, 0.424258E+01_JPRB, 0.427462E+01_JPRB, 0.430608E+01_JPRB, 0.433690E+01_JPRB &
  &, 0.436706E+01_JPRB, 0.439665E+01_JPRB, 0.442558E+01_JPRB &
  &, 0.445387E+01_JPRB, 0.448152E+01_JPRB, 0.450772E+01_JPRB, 0.453487E+01_JPRB &
  &, 0.456055E+01_JPRB, 0.458559E+01_JPRB, 0.460997E+01_JPRB &
  &, 0.463369E+01_JPRB, 0.465677E+01_JPRB, 0.467916E+01_JPRB, 0.470089E+01_JPRB &
  &, 0.472197E+01_JPRB, 0.474233E+01_JPRB, 0.476208E+01_JPRB &
  &, 0.478113E+01_JPRB, 0.479952E+01_JPRB, 0.481725E+01_JPRB, 0.483429E+01_JPRB &
  &, 0.485069E+01_JPRB, 0.486639E+01_JPRB, 0.488143E+01_JPRB &
  &, 0.489581E+01_JPRB, 0.490953E+01_JPRB, 0.492257E+01_JPRB, 0.493496E+01_JPRB &
  &, 0.494667E+01_JPRB, 0.495778E+01_JPRB, 0.496819E+01_JPRB &
  &, 0.497792E+01_JPRB, 0.498701E+01_JPRB, 0.499547E+01_JPRB, 0.500329E+01_JPRB &
  &, 0.501042E+01_JPRB, 0.501693E+01_JPRB, 0.502283E+01_JPRB &
  &, 0.502805E+01_JPRB, 0.503268E+01_JPRB, 0.503666E+01_JPRB, 0.504000E+01_JPRB &
  &, 0.504275E+01_JPRB, 0.504485E+01_JPRB, 0.504635E+01_JPRB &
  &, 0.504721E+01_JPRB, 0.504751E+01_JPRB, 0.504722E+01_JPRB, 0.504629E+01_JPRB &
  &, 0.504474E+01_JPRB, 0.504269E+01_JPRB, 0.504000E+01_JPRB &
  &, 0.503675E+01_JPRB, 0.503294E+01_JPRB, 0.502854E+01_JPRB, 0.502357E+01_JPRB &
  &, 0.501804E+01_JPRB, 0.501197E+01_JPRB, 0.500532E+01_JPRB &
  &, 0.499816E+01_JPRB, 0.499052E+01_JPRB, 0.498229E+01_JPRB, 0.497355E+01_JPRB &
  &, 0.496425E+01_JPRB, 0.495448E+01_JPRB, 0.494418E+01_JPRB/)
XCW( 943, :) = (/ &
  &  0.116278E+01_JPRB, 0.120490E+01_JPRB, 0.124754E+01_JPRB, 0.129069E+01_JPRB &
  &, 0.133433E+01_JPRB, 0.137843E+01_JPRB, 0.142299E+01_JPRB &
  &, 0.146797E+01_JPRB, 0.151336E+01_JPRB, 0.155914E+01_JPRB, 0.160528E+01_JPRB &
  &, 0.165177E+01_JPRB, 0.169858E+01_JPRB, 0.174570E+01_JPRB &
  &, 0.179309E+01_JPRB, 0.184075E+01_JPRB, 0.188865E+01_JPRB, 0.193676E+01_JPRB &
  &, 0.198507E+01_JPRB, 0.203355E+01_JPRB, 0.208218E+01_JPRB &
  &, 0.213095E+01_JPRB, 0.217982E+01_JPRB, 0.222878E+01_JPRB, 0.227781E+01_JPRB &
  &, 0.232689E+01_JPRB, 0.237598E+01_JPRB, 0.242508E+01_JPRB &
  &, 0.247416E+01_JPRB, 0.252321E+01_JPRB, 0.257219E+01_JPRB, 0.262109E+01_JPRB &
  &, 0.266989E+01_JPRB, 0.271857E+01_JPRB, 0.276711E+01_JPRB &
  &, 0.281549E+01_JPRB, 0.286370E+01_JPRB, 0.291170E+01_JPRB, 0.295949E+01_JPRB &
  &, 0.300706E+01_JPRB, 0.305437E+01_JPRB, 0.310141E+01_JPRB &
  &, 0.314817E+01_JPRB, 0.319463E+01_JPRB, 0.324076E+01_JPRB, 0.328657E+01_JPRB &
  &, 0.333202E+01_JPRB, 0.337712E+01_JPRB, 0.342183E+01_JPRB &
  &, 0.346615E+01_JPRB, 0.351007E+01_JPRB, 0.355356E+01_JPRB, 0.359663E+01_JPRB &
  &, 0.363925E+01_JPRB, 0.368142E+01_JPRB, 0.372311E+01_JPRB &
  &, 0.376433E+01_JPRB, 0.380504E+01_JPRB, 0.384527E+01_JPRB, 0.388496E+01_JPRB &
  &, 0.392416E+01_JPRB, 0.396281E+01_JPRB, 0.400092E+01_JPRB &
  &, 0.403849E+01_JPRB, 0.407549E+01_JPRB, 0.411193E+01_JPRB, 0.414780E+01_JPRB &
  &, 0.418307E+01_JPRB, 0.421776E+01_JPRB, 0.425187E+01_JPRB &
  &, 0.428537E+01_JPRB, 0.431824E+01_JPRB, 0.435037E+01_JPRB, 0.438218E+01_JPRB &
  &, 0.441322E+01_JPRB, 0.444364E+01_JPRB, 0.447341E+01_JPRB &
  &, 0.450253E+01_JPRB, 0.453104E+01_JPRB, 0.455887E+01_JPRB, 0.458608E+01_JPRB &
  &, 0.461263E+01_JPRB, 0.463852E+01_JPRB, 0.466375E+01_JPRB &
  &, 0.468832E+01_JPRB, 0.471227E+01_JPRB, 0.473550E+01_JPRB, 0.475808E+01_JPRB &
  &, 0.478000E+01_JPRB, 0.480125E+01_JPRB, 0.482183E+01_JPRB &
  &, 0.484171E+01_JPRB, 0.486102E+01_JPRB, 0.487958E+01_JPRB, 0.489746E+01_JPRB &
  &, 0.491467E+01_JPRB, 0.493128E+01_JPRB, 0.494716E+01_JPRB &
  &, 0.496239E+01_JPRB, 0.497695E+01_JPRB, 0.499084E+01_JPRB, 0.500408E+01_JPRB &
  &, 0.501663E+01_JPRB, 0.502852E+01_JPRB, 0.503978E+01_JPRB &
  &, 0.505036E+01_JPRB, 0.506026E+01_JPRB, 0.506953E+01_JPRB, 0.507815E+01_JPRB &
  &, 0.508613E+01_JPRB, 0.509345E+01_JPRB, 0.510015E+01_JPRB &
  &, 0.510617E+01_JPRB, 0.511156E+01_JPRB, 0.511638E+01_JPRB, 0.512046E+01_JPRB &
  &, 0.512401E+01_JPRB, 0.512689E+01_JPRB, 0.512917E+01_JPRB &
  &, 0.513082E+01_JPRB, 0.513190E+01_JPRB, 0.513233E+01_JPRB, 0.513212E+01_JPRB &
  &, 0.513139E+01_JPRB, 0.513005E+01_JPRB, 0.512807E+01_JPRB &
  &, 0.512551E+01_JPRB, 0.512246E+01_JPRB, 0.511875E+01_JPRB, 0.511451E+01_JPRB &
  &, 0.510966E+01_JPRB, 0.510432E+01_JPRB, 0.509839E+01_JPRB &
  &, 0.509189E+01_JPRB, 0.508490E+01_JPRB, 0.507731E+01_JPRB, 0.506920E+01_JPRB &
  &, 0.506060E+01_JPRB, 0.505144E+01_JPRB, 0.504183E+01_JPRB/)
XCW( 944, :) = (/ &
  &  0.116376E+01_JPRB, 0.120614E+01_JPRB, 0.124907E+01_JPRB, 0.129251E+01_JPRB &
  &, 0.133646E+01_JPRB, 0.138088E+01_JPRB, 0.142577E+01_JPRB &
  &, 0.147109E+01_JPRB, 0.151684E+01_JPRB, 0.156298E+01_JPRB, 0.160950E+01_JPRB &
  &, 0.165637E+01_JPRB, 0.170358E+01_JPRB, 0.175111E+01_JPRB &
  &, 0.179892E+01_JPRB, 0.184701E+01_JPRB, 0.189535E+01_JPRB, 0.194392E+01_JPRB &
  &, 0.199269E+01_JPRB, 0.204164E+01_JPRB, 0.209076E+01_JPRB &
  &, 0.214003E+01_JPRB, 0.218940E+01_JPRB, 0.223888E+01_JPRB, 0.228844E+01_JPRB &
  &, 0.233805E+01_JPRB, 0.238769E+01_JPRB, 0.243735E+01_JPRB &
  &, 0.248700E+01_JPRB, 0.253661E+01_JPRB, 0.258618E+01_JPRB, 0.263567E+01_JPRB &
  &, 0.268508E+01_JPRB, 0.273438E+01_JPRB, 0.278354E+01_JPRB &
  &, 0.283255E+01_JPRB, 0.288140E+01_JPRB, 0.293006E+01_JPRB, 0.297850E+01_JPRB &
  &, 0.302673E+01_JPRB, 0.307472E+01_JPRB, 0.312244E+01_JPRB &
  &, 0.316988E+01_JPRB, 0.321705E+01_JPRB, 0.326388E+01_JPRB, 0.331041E+01_JPRB &
  &, 0.335658E+01_JPRB, 0.340241E+01_JPRB, 0.344785E+01_JPRB &
  &, 0.349292E+01_JPRB, 0.353758E+01_JPRB, 0.358183E+01_JPRB, 0.362567E+01_JPRB &
  &, 0.366905E+01_JPRB, 0.371198E+01_JPRB, 0.375445E+01_JPRB &
  &, 0.379645E+01_JPRB, 0.383796E+01_JPRB, 0.387898E+01_JPRB, 0.391950E+01_JPRB &
  &, 0.395949E+01_JPRB, 0.399895E+01_JPRB, 0.403789E+01_JPRB &
  &, 0.407627E+01_JPRB, 0.411409E+01_JPRB, 0.415136E+01_JPRB, 0.418807E+01_JPRB &
  &, 0.422419E+01_JPRB, 0.425972E+01_JPRB, 0.429466E+01_JPRB &
  &, 0.432902E+01_JPRB, 0.436277E+01_JPRB, 0.439590E+01_JPRB, 0.442841E+01_JPRB &
  &, 0.446031E+01_JPRB, 0.449157E+01_JPRB, 0.452221E+01_JPRB &
  &, 0.455220E+01_JPRB, 0.458157E+01_JPRB, 0.461028E+01_JPRB, 0.463834E+01_JPRB &
  &, 0.466578E+01_JPRB, 0.469254E+01_JPRB, 0.471867E+01_JPRB &
  &, 0.474413E+01_JPRB, 0.476890E+01_JPRB, 0.479305E+01_JPRB, 0.481650E+01_JPRB &
  &, 0.483930E+01_JPRB, 0.486143E+01_JPRB, 0.488291E+01_JPRB &
  &, 0.490368E+01_JPRB, 0.492381E+01_JPRB, 0.494327E+01_JPRB, 0.496197E+01_JPRB &
  &, 0.498014E+01_JPRB, 0.499758E+01_JPRB, 0.501433E+01_JPRB &
  &, 0.503043E+01_JPRB, 0.504586E+01_JPRB, 0.506048E+01_JPRB, 0.507470E+01_JPRB &
  &, 0.508813E+01_JPRB, 0.510089E+01_JPRB, 0.511299E+01_JPRB &
  &, 0.512440E+01_JPRB, 0.513518E+01_JPRB, 0.514533E+01_JPRB, 0.515478E+01_JPRB &
  &, 0.516360E+01_JPRB, 0.517175E+01_JPRB, 0.517919E+01_JPRB &
  &, 0.518613E+01_JPRB, 0.519234E+01_JPRB, 0.519794E+01_JPRB, 0.520289E+01_JPRB &
  &, 0.520707E+01_JPRB, 0.521091E+01_JPRB, 0.521396E+01_JPRB &
  &, 0.521642E+01_JPRB, 0.521826E+01_JPRB, 0.521950E+01_JPRB, 0.521993E+01_JPRB &
  &, 0.522010E+01_JPRB, 0.521945E+01_JPRB, 0.521837E+01_JPRB &
  &, 0.521654E+01_JPRB, 0.521421E+01_JPRB, 0.521127E+01_JPRB, 0.520591E+01_JPRB &
  &, 0.520361E+01_JPRB, 0.519897E+01_JPRB, 0.519374E+01_JPRB &
  &, 0.518799E+01_JPRB, 0.518168E+01_JPRB, 0.517476E+01_JPRB, 0.516739E+01_JPRB &
  &, 0.515944E+01_JPRB, 0.515094E+01_JPRB, 0.514197E+01_JPRB/)
XCW( 945, :) = (/ &
  &  0.116474E+01_JPRB, 0.120741E+01_JPRB, 0.125062E+01_JPRB, 0.129437E+01_JPRB &
  &, 0.133862E+01_JPRB, 0.138337E+01_JPRB, 0.142859E+01_JPRB &
  &, 0.147426E+01_JPRB, 0.152037E+01_JPRB, 0.156688E+01_JPRB, 0.161378E+01_JPRB &
  &, 0.166105E+01_JPRB, 0.170866E+01_JPRB, 0.175661E+01_JPRB &
  &, 0.180485E+01_JPRB, 0.185338E+01_JPRB, 0.190216E+01_JPRB, 0.195119E+01_JPRB &
  &, 0.200044E+01_JPRB, 0.204987E+01_JPRB, 0.209949E+01_JPRB &
  &, 0.214925E+01_JPRB, 0.219915E+01_JPRB, 0.224915E+01_JPRB, 0.229924E+01_JPRB &
  &, 0.234940E+01_JPRB, 0.239960E+01_JPRB, 0.244982E+01_JPRB &
  &, 0.250005E+01_JPRB, 0.255025E+01_JPRB, 0.260042E+01_JPRB, 0.265052E+01_JPRB &
  &, 0.270054E+01_JPRB, 0.275046E+01_JPRB, 0.280026E+01_JPRB &
  &, 0.284992E+01_JPRB, 0.289942E+01_JPRB, 0.294873E+01_JPRB, 0.299785E+01_JPRB &
  &, 0.304676E+01_JPRB, 0.309544E+01_JPRB, 0.314386E+01_JPRB &
  &, 0.319200E+01_JPRB, 0.323987E+01_JPRB, 0.328744E+01_JPRB, 0.333468E+01_JPRB &
  &, 0.338160E+01_JPRB, 0.342816E+01_JPRB, 0.347436E+01_JPRB &
  &, 0.352018E+01_JPRB, 0.356561E+01_JPRB, 0.361064E+01_JPRB, 0.365524E+01_JPRB &
  &, 0.369941E+01_JPRB, 0.374314E+01_JPRB, 0.378641E+01_JPRB &
  &, 0.382921E+01_JPRB, 0.387154E+01_JPRB, 0.391336E+01_JPRB, 0.395470E+01_JPRB &
  &, 0.399551E+01_JPRB, 0.403581E+01_JPRB, 0.407557E+01_JPRB &
  &, 0.411479E+01_JPRB, 0.415347E+01_JPRB, 0.419159E+01_JPRB, 0.422914E+01_JPRB &
  &, 0.426611E+01_JPRB, 0.430252E+01_JPRB, 0.433833E+01_JPRB &
  &, 0.437354E+01_JPRB, 0.440816E+01_JPRB, 0.444217E+01_JPRB, 0.447557E+01_JPRB &
  &, 0.450831E+01_JPRB, 0.454050E+01_JPRB, 0.457202E+01_JPRB &
  &, 0.460291E+01_JPRB, 0.463317E+01_JPRB, 0.466278E+01_JPRB, 0.469174E+01_JPRB &
  &, 0.472006E+01_JPRB, 0.474771E+01_JPRB, 0.477469E+01_JPRB &
  &, 0.480108E+01_JPRB, 0.482667E+01_JPRB, 0.485180E+01_JPRB, 0.487616E+01_JPRB &
  &, 0.489988E+01_JPRB, 0.492291E+01_JPRB, 0.494527E+01_JPRB &
  &, 0.496698E+01_JPRB, 0.498799E+01_JPRB, 0.500833E+01_JPRB, 0.502802E+01_JPRB &
  &, 0.504701E+01_JPRB, 0.506534E+01_JPRB, 0.508302E+01_JPRB &
  &, 0.510002E+01_JPRB, 0.511634E+01_JPRB, 0.513197E+01_JPRB, 0.514694E+01_JPRB &
  &, 0.516127E+01_JPRB, 0.517490E+01_JPRB, 0.518790E+01_JPRB &
  &, 0.520013E+01_JPRB, 0.521185E+01_JPRB, 0.522283E+01_JPRB, 0.523319E+01_JPRB &
  &, 0.524282E+01_JPRB, 0.525187E+01_JPRB, 0.526022E+01_JPRB &
  &, 0.526797E+01_JPRB, 0.527504E+01_JPRB, 0.528150E+01_JPRB, 0.528726E+01_JPRB &
  &, 0.529243E+01_JPRB, 0.529693E+01_JPRB, 0.530082E+01_JPRB &
  &, 0.530412E+01_JPRB, 0.530680E+01_JPRB, 0.530882E+01_JPRB, 0.531024E+01_JPRB &
  &, 0.531103E+01_JPRB, 0.531126E+01_JPRB, 0.531084E+01_JPRB &
  &, 0.530983E+01_JPRB, 0.530825E+01_JPRB, 0.530607E+01_JPRB, 0.530330E+01_JPRB &
  &, 0.529989E+01_JPRB, 0.529610E+01_JPRB, 0.529160E+01_JPRB &
  &, 0.528651E+01_JPRB, 0.528073E+01_JPRB, 0.527477E+01_JPRB, 0.526810E+01_JPRB &
  &, 0.526085E+01_JPRB, 0.525310E+01_JPRB, 0.524474E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART135',1,ZHOOK_HANDLE)
END SUBROUTINE PART135

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART136

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART136',0,ZHOOK_HANDLE)

XCW( 946, :) = (/ &
  &  0.116575E+01_JPRB, 0.120869E+01_JPRB, 0.125220E+01_JPRB, 0.129625E+01_JPRB &
  &, 0.134082E+01_JPRB, 0.138590E+01_JPRB, 0.143146E+01_JPRB &
  &, 0.147749E+01_JPRB, 0.152395E+01_JPRB, 0.157084E+01_JPRB, 0.161813E+01_JPRB &
  &, 0.166580E+01_JPRB, 0.171383E+01_JPRB, 0.176219E+01_JPRB &
  &, 0.181087E+01_JPRB, 0.185985E+01_JPRB, 0.190909E+01_JPRB, 0.195859E+01_JPRB &
  &, 0.200831E+01_JPRB, 0.205824E+01_JPRB, 0.210836E+01_JPRB &
  &, 0.215864E+01_JPRB, 0.220906E+01_JPRB, 0.225960E+01_JPRB, 0.231024E+01_JPRB &
  &, 0.236095E+01_JPRB, 0.241172E+01_JPRB, 0.246252E+01_JPRB &
  &, 0.251333E+01_JPRB, 0.256414E+01_JPRB, 0.261491E+01_JPRB, 0.266563E+01_JPRB &
  &, 0.271628E+01_JPRB, 0.276684E+01_JPRB, 0.281729E+01_JPRB &
  &, 0.286760E+01_JPRB, 0.291776E+01_JPRB, 0.296776E+01_JPRB, 0.301756E+01_JPRB &
  &, 0.306717E+01_JPRB, 0.311653E+01_JPRB, 0.316567E+01_JPRB &
  &, 0.321454E+01_JPRB, 0.326313E+01_JPRB, 0.331143E+01_JPRB, 0.335943E+01_JPRB &
  &, 0.340709E+01_JPRB, 0.345441E+01_JPRB, 0.350138E+01_JPRB &
  &, 0.354798E+01_JPRB, 0.359419E+01_JPRB, 0.364000E+01_JPRB, 0.368540E+01_JPRB &
  &, 0.373037E+01_JPRB, 0.377490E+01_JPRB, 0.381899E+01_JPRB &
  &, 0.386261E+01_JPRB, 0.390577E+01_JPRB, 0.394842E+01_JPRB, 0.399060E+01_JPRB &
  &, 0.403226E+01_JPRB, 0.407341E+01_JPRB, 0.411402E+01_JPRB &
  &, 0.415410E+01_JPRB, 0.419365E+01_JPRB, 0.423263E+01_JPRB, 0.427106E+01_JPRB &
  &, 0.430892E+01_JPRB, 0.434619E+01_JPRB, 0.438289E+01_JPRB &
  &, 0.441900E+01_JPRB, 0.445450E+01_JPRB, 0.448941E+01_JPRB, 0.452354E+01_JPRB &
  &, 0.455738E+01_JPRB, 0.459044E+01_JPRB, 0.462287E+01_JPRB &
  &, 0.465467E+01_JPRB, 0.468584E+01_JPRB, 0.471636E+01_JPRB, 0.474625E+01_JPRB &
  &, 0.477545E+01_JPRB, 0.480410E+01_JPRB, 0.483197E+01_JPRB &
  &, 0.485928E+01_JPRB, 0.488501E+01_JPRB, 0.491187E+01_JPRB, 0.493715E+01_JPRB &
  &, 0.496179E+01_JPRB, 0.498574E+01_JPRB, 0.500903E+01_JPRB &
  &, 0.503167E+01_JPRB, 0.505359E+01_JPRB, 0.507486E+01_JPRB, 0.509547E+01_JPRB &
  &, 0.511541E+01_JPRB, 0.513466E+01_JPRB, 0.515325E+01_JPRB &
  &, 0.517117E+01_JPRB, 0.518839E+01_JPRB, 0.520494E+01_JPRB, 0.522084E+01_JPRB &
  &, 0.523606E+01_JPRB, 0.525061E+01_JPRB, 0.526451E+01_JPRB &
  &, 0.527760E+01_JPRB, 0.529029E+01_JPRB, 0.530219E+01_JPRB, 0.531340E+01_JPRB &
  &, 0.532397E+01_JPRB, 0.533374E+01_JPRB, 0.534315E+01_JPRB &
  &, 0.535174E+01_JPRB, 0.535970E+01_JPRB, 0.536704E+01_JPRB, 0.537368E+01_JPRB &
  &, 0.537973E+01_JPRB, 0.538511E+01_JPRB, 0.538984E+01_JPRB &
  &, 0.539401E+01_JPRB, 0.539741E+01_JPRB, 0.540035E+01_JPRB, 0.540258E+01_JPRB &
  &, 0.540424E+01_JPRB, 0.540527E+01_JPRB, 0.540570E+01_JPRB &
  &, 0.540549E+01_JPRB, 0.540470E+01_JPRB, 0.540336E+01_JPRB, 0.540137E+01_JPRB &
  &, 0.539879E+01_JPRB, 0.539571E+01_JPRB, 0.539197E+01_JPRB &
  &, 0.538770E+01_JPRB, 0.538286E+01_JPRB, 0.537746E+01_JPRB, 0.537146E+01_JPRB &
  &, 0.536494E+01_JPRB, 0.535792E+01_JPRB, 0.535028E+01_JPRB/)
XCW( 947, :) = (/ &
  &  0.116676E+01_JPRB, 0.120999E+01_JPRB, 0.125380E+01_JPRB, 0.129816E+01_JPRB &
  &, 0.134306E+01_JPRB, 0.138847E+01_JPRB, 0.143438E+01_JPRB &
  &, 0.148076E+01_JPRB, 0.152760E+01_JPRB, 0.157487E+01_JPRB, 0.162256E+01_JPRB &
  &, 0.167063E+01_JPRB, 0.171908E+01_JPRB, 0.176788E+01_JPRB &
  &, 0.181700E+01_JPRB, 0.186643E+01_JPRB, 0.191614E+01_JPRB, 0.196611E+01_JPRB &
  &, 0.201633E+01_JPRB, 0.206676E+01_JPRB, 0.211739E+01_JPRB &
  &, 0.216819E+01_JPRB, 0.221915E+01_JPRB, 0.227024E+01_JPRB, 0.232143E+01_JPRB &
  &, 0.237271E+01_JPRB, 0.242406E+01_JPRB, 0.247545E+01_JPRB &
  &, 0.252686E+01_JPRB, 0.257828E+01_JPRB, 0.262967E+01_JPRB, 0.268102E+01_JPRB &
  &, 0.273231E+01_JPRB, 0.278352E+01_JPRB, 0.283463E+01_JPRB &
  &, 0.288562E+01_JPRB, 0.293646E+01_JPRB, 0.298714E+01_JPRB, 0.303764E+01_JPRB &
  &, 0.308795E+01_JPRB, 0.313804E+01_JPRB, 0.318790E+01_JPRB &
  &, 0.323751E+01_JPRB, 0.328684E+01_JPRB, 0.333590E+01_JPRB, 0.338464E+01_JPRB &
  &, 0.343307E+01_JPRB, 0.348117E+01_JPRB, 0.352892E+01_JPRB &
  &, 0.357631E+01_JPRB, 0.362333E+01_JPRB, 0.366994E+01_JPRB, 0.371615E+01_JPRB &
  &, 0.376194E+01_JPRB, 0.380730E+01_JPRB, 0.385223E+01_JPRB &
  &, 0.389669E+01_JPRB, 0.394068E+01_JPRB, 0.398420E+01_JPRB, 0.402723E+01_JPRB &
  &, 0.406974E+01_JPRB, 0.411176E+01_JPRB, 0.415325E+01_JPRB &
  &, 0.419422E+01_JPRB, 0.423464E+01_JPRB, 0.427453E+01_JPRB, 0.431385E+01_JPRB &
  &, 0.435260E+01_JPRB, 0.439079E+01_JPRB, 0.442839E+01_JPRB &
  &, 0.446540E+01_JPRB, 0.450183E+01_JPRB, 0.453766E+01_JPRB, 0.457286E+01_JPRB &
  &, 0.460746E+01_JPRB, 0.464145E+01_JPRB, 0.467482E+01_JPRB &
  &, 0.470757E+01_JPRB, 0.473967E+01_JPRB, 0.477113E+01_JPRB, 0.480194E+01_JPRB &
  &, 0.483213E+01_JPRB, 0.486166E+01_JPRB, 0.489055E+01_JPRB &
  &, 0.491876E+01_JPRB, 0.494633E+01_JPRB, 0.497324E+01_JPRB, 0.499949E+01_JPRB &
  &, 0.502508E+01_JPRB, 0.504998E+01_JPRB, 0.507422E+01_JPRB &
  &, 0.509778E+01_JPRB, 0.512070E+01_JPRB, 0.514291E+01_JPRB, 0.516445E+01_JPRB &
  &, 0.518537E+01_JPRB, 0.520556E+01_JPRB, 0.522482E+01_JPRB &
  &, 0.524394E+01_JPRB, 0.526214E+01_JPRB, 0.527965E+01_JPRB, 0.529650E+01_JPRB &
  &, 0.531265E+01_JPRB, 0.532816E+01_JPRB, 0.534294E+01_JPRB &
  &, 0.535710E+01_JPRB, 0.537060E+01_JPRB, 0.538343E+01_JPRB, 0.539560E+01_JPRB &
  &, 0.540705E+01_JPRB, 0.541787E+01_JPRB, 0.542807E+01_JPRB &
  &, 0.543758E+01_JPRB, 0.544646E+01_JPRB, 0.545467E+01_JPRB, 0.546222E+01_JPRB &
  &, 0.546914E+01_JPRB, 0.547543E+01_JPRB, 0.548106E+01_JPRB &
  &, 0.548600E+01_JPRB, 0.549045E+01_JPRB, 0.549419E+01_JPRB, 0.549732E+01_JPRB &
  &, 0.549982E+01_JPRB, 0.550169E+01_JPRB, 0.550295E+01_JPRB &
  &, 0.550362E+01_JPRB, 0.550366E+01_JPRB, 0.550269E+01_JPRB, 0.550197E+01_JPRB &
  &, 0.550026E+01_JPRB, 0.549793E+01_JPRB, 0.549499E+01_JPRB &
  &, 0.549151E+01_JPRB, 0.548745E+01_JPRB, 0.548283E+01_JPRB, 0.547761E+01_JPRB &
  &, 0.547185E+01_JPRB, 0.546559E+01_JPRB, 0.545870E+01_JPRB/)
XCW( 948, :) = (/ &
  &  0.116780E+01_JPRB, 0.121132E+01_JPRB, 0.125542E+01_JPRB, 0.130010E+01_JPRB &
  &, 0.134532E+01_JPRB, 0.139108E+01_JPRB, 0.143734E+01_JPRB &
  &, 0.148409E+01_JPRB, 0.153130E+01_JPRB, 0.157897E+01_JPRB, 0.162705E+01_JPRB &
  &, 0.167555E+01_JPRB, 0.172442E+01_JPRB, 0.177366E+01_JPRB &
  &, 0.182323E+01_JPRB, 0.187312E+01_JPRB, 0.192331E+01_JPRB, 0.197377E+01_JPRB &
  &, 0.202449E+01_JPRB, 0.207543E+01_JPRB, 0.212658E+01_JPRB &
  &, 0.217792E+01_JPRB, 0.222942E+01_JPRB, 0.228106E+01_JPRB, 0.233282E+01_JPRB &
  &, 0.238469E+01_JPRB, 0.243662E+01_JPRB, 0.248862E+01_JPRB &
  &, 0.254064E+01_JPRB, 0.259267E+01_JPRB, 0.264470E+01_JPRB, 0.269670E+01_JPRB &
  &, 0.274864E+01_JPRB, 0.280052E+01_JPRB, 0.285230E+01_JPRB &
  &, 0.290397E+01_JPRB, 0.295550E+01_JPRB, 0.300689E+01_JPRB, 0.305812E+01_JPRB &
  &, 0.310914E+01_JPRB, 0.315996E+01_JPRB, 0.321057E+01_JPRB &
  &, 0.326092E+01_JPRB, 0.331102E+01_JPRB, 0.336083E+01_JPRB, 0.341035E+01_JPRB &
  &, 0.345957E+01_JPRB, 0.350846E+01_JPRB, 0.355702E+01_JPRB &
  &, 0.360521E+01_JPRB, 0.365304E+01_JPRB, 0.370048E+01_JPRB, 0.374752E+01_JPRB &
  &, 0.379416E+01_JPRB, 0.384036E+01_JPRB, 0.388613E+01_JPRB &
  &, 0.393145E+01_JPRB, 0.397632E+01_JPRB, 0.402070E+01_JPRB, 0.406461E+01_JPRB &
  &, 0.410802E+01_JPRB, 0.415092E+01_JPRB, 0.419331E+01_JPRB &
  &, 0.423518E+01_JPRB, 0.427651E+01_JPRB, 0.431730E+01_JPRB, 0.435753E+01_JPRB &
  &, 0.439721E+01_JPRB, 0.443632E+01_JPRB, 0.447485E+01_JPRB &
  &, 0.451280E+01_JPRB, 0.455017E+01_JPRB, 0.458690E+01_JPRB, 0.462310E+01_JPRB &
  &, 0.465864E+01_JPRB, 0.469359E+01_JPRB, 0.472790E+01_JPRB &
  &, 0.476161E+01_JPRB, 0.479467E+01_JPRB, 0.482709E+01_JPRB, 0.485888E+01_JPRB &
  &, 0.489004E+01_JPRB, 0.492053E+01_JPRB, 0.495040E+01_JPRB &
  &, 0.497958E+01_JPRB, 0.500813E+01_JPRB, 0.503600E+01_JPRB, 0.506324E+01_JPRB &
  &, 0.508977E+01_JPRB, 0.511568E+01_JPRB, 0.514087E+01_JPRB &
  &, 0.516545E+01_JPRB, 0.518933E+01_JPRB, 0.521253E+01_JPRB, 0.523504E+01_JPRB &
  &, 0.525693E+01_JPRB, 0.527809E+01_JPRB, 0.529861E+01_JPRB &
  &, 0.531846E+01_JPRB, 0.533760E+01_JPRB, 0.535609E+01_JPRB, 0.537390E+01_JPRB &
  &, 0.539103E+01_JPRB, 0.540745E+01_JPRB, 0.542330E+01_JPRB &
  &, 0.543842E+01_JPRB, 0.545287E+01_JPRB, 0.546661E+01_JPRB, 0.547974E+01_JPRB &
  &, 0.549218E+01_JPRB, 0.550395E+01_JPRB, 0.551506E+01_JPRB &
  &, 0.552553E+01_JPRB, 0.553535E+01_JPRB, 0.554451E+01_JPRB, 0.555297E+01_JPRB &
  &, 0.556084E+01_JPRB, 0.556803E+01_JPRB, 0.557460E+01_JPRB &
  &, 0.558052E+01_JPRB, 0.558582E+01_JPRB, 0.559044E+01_JPRB, 0.559446E+01_JPRB &
  &, 0.559783E+01_JPRB, 0.560057E+01_JPRB, 0.560276E+01_JPRB &
  &, 0.560430E+01_JPRB, 0.560520E+01_JPRB, 0.560554E+01_JPRB, 0.560521E+01_JPRB &
  &, 0.560435E+01_JPRB, 0.560286E+01_JPRB, 0.560081E+01_JPRB &
  &, 0.559810E+01_JPRB, 0.559487E+01_JPRB, 0.559107E+01_JPRB, 0.558666E+01_JPRB &
  &, 0.558171E+01_JPRB, 0.557624E+01_JPRB, 0.557015E+01_JPRB/)
XCW( 949, :) = (/ &
  &  0.116885E+01_JPRB, 0.121266E+01_JPRB, 0.125708E+01_JPRB, 0.130207E+01_JPRB &
  &, 0.134763E+01_JPRB, 0.139373E+01_JPRB, 0.144035E+01_JPRB &
  &, 0.148747E+01_JPRB, 0.153507E+01_JPRB, 0.158313E+01_JPRB, 0.163163E+01_JPRB &
  &, 0.168054E+01_JPRB, 0.172985E+01_JPRB, 0.177954E+01_JPRB &
  &, 0.182957E+01_JPRB, 0.187994E+01_JPRB, 0.193061E+01_JPRB, 0.198157E+01_JPRB &
  &, 0.203279E+01_JPRB, 0.208425E+01_JPRB, 0.213594E+01_JPRB &
  &, 0.218782E+01_JPRB, 0.223988E+01_JPRB, 0.229209E+01_JPRB, 0.234443E+01_JPRB &
  &, 0.239688E+01_JPRB, 0.244942E+01_JPRB, 0.250203E+01_JPRB &
  &, 0.255468E+01_JPRB, 0.260735E+01_JPRB, 0.266002E+01_JPRB, 0.271268E+01_JPRB &
  &, 0.276529E+01_JPRB, 0.281784E+01_JPRB, 0.287031E+01_JPRB &
  &, 0.292267E+01_JPRB, 0.297493E+01_JPRB, 0.302703E+01_JPRB, 0.307898E+01_JPRB &
  &, 0.313074E+01_JPRB, 0.318231E+01_JPRB, 0.323367E+01_JPRB &
  &, 0.328479E+01_JPRB, 0.333566E+01_JPRB, 0.338627E+01_JPRB, 0.343659E+01_JPRB &
  &, 0.348660E+01_JPRB, 0.353631E+01_JPRB, 0.358568E+01_JPRB &
  &, 0.363470E+01_JPRB, 0.368337E+01_JPRB, 0.373165E+01_JPRB, 0.377954E+01_JPRB &
  &, 0.382703E+01_JPRB, 0.387387E+01_JPRB, 0.392075E+01_JPRB &
  &, 0.396695E+01_JPRB, 0.401269E+01_JPRB, 0.405797E+01_JPRB, 0.410278E+01_JPRB &
  &, 0.414708E+01_JPRB, 0.419090E+01_JPRB, 0.423421E+01_JPRB &
  &, 0.427701E+01_JPRB, 0.431926E+01_JPRB, 0.436097E+01_JPRB, 0.440216E+01_JPRB &
  &, 0.444277E+01_JPRB, 0.448284E+01_JPRB, 0.452232E+01_JPRB &
  &, 0.456122E+01_JPRB, 0.459956E+01_JPRB, 0.463728E+01_JPRB, 0.467442E+01_JPRB &
  &, 0.471095E+01_JPRB, 0.474687E+01_JPRB, 0.478216E+01_JPRB &
  &, 0.481684E+01_JPRB, 0.485091E+01_JPRB, 0.488432E+01_JPRB, 0.491710E+01_JPRB &
  &, 0.494925E+01_JPRB, 0.498075E+01_JPRB, 0.501158E+01_JPRB &
  &, 0.504179E+01_JPRB, 0.507132E+01_JPRB, 0.510020E+01_JPRB, 0.512844E+01_JPRB &
  &, 0.515599E+01_JPRB, 0.518287E+01_JPRB, 0.520911E+01_JPRB &
  &, 0.523467E+01_JPRB, 0.525956E+01_JPRB, 0.528379E+01_JPRB, 0.530733E+01_JPRB &
  &, 0.533018E+01_JPRB, 0.535238E+01_JPRB, 0.537391E+01_JPRB &
  &, 0.539473E+01_JPRB, 0.541489E+01_JPRB, 0.543439E+01_JPRB, 0.545321E+01_JPRB &
  &, 0.547132E+01_JPRB, 0.548881E+01_JPRB, 0.550556E+01_JPRB &
  &, 0.552155E+01_JPRB, 0.553710E+01_JPRB, 0.555174E+01_JPRB, 0.556598E+01_JPRB &
  &, 0.557941E+01_JPRB, 0.559217E+01_JPRB, 0.560427E+01_JPRB &
  &, 0.561572E+01_JPRB, 0.562648E+01_JPRB, 0.563658E+01_JPRB, 0.564607E+01_JPRB &
  &, 0.565487E+01_JPRB, 0.566299E+01_JPRB, 0.567054E+01_JPRB &
  &, 0.567739E+01_JPRB, 0.568361E+01_JPRB, 0.568921E+01_JPRB, 0.569414E+01_JPRB &
  &, 0.569843E+01_JPRB, 0.570203E+01_JPRB, 0.570518E+01_JPRB &
  &, 0.570762E+01_JPRB, 0.570942E+01_JPRB, 0.571065E+01_JPRB, 0.571121E+01_JPRB &
  &, 0.571124E+01_JPRB, 0.571063E+01_JPRB, 0.570945E+01_JPRB &
  &, 0.570761E+01_JPRB, 0.570525E+01_JPRB, 0.570224E+01_JPRB, 0.569874E+01_JPRB &
  &, 0.569457E+01_JPRB, 0.568968E+01_JPRB, 0.568455E+01_JPRB/)
XCW( 950, :) = (/ &
  &  0.116992E+01_JPRB, 0.121403E+01_JPRB, 0.125876E+01_JPRB, 0.130408E+01_JPRB &
  &, 0.134998E+01_JPRB, 0.139643E+01_JPRB, 0.144342E+01_JPRB &
  &, 0.149092E+01_JPRB, 0.153891E+01_JPRB, 0.158737E+01_JPRB, 0.163629E+01_JPRB &
  &, 0.168563E+01_JPRB, 0.173538E+01_JPRB, 0.178552E+01_JPRB &
  &, 0.183603E+01_JPRB, 0.188687E+01_JPRB, 0.193804E+01_JPRB, 0.198950E+01_JPRB &
  &, 0.204124E+01_JPRB, 0.209324E+01_JPRB, 0.214547E+01_JPRB &
  &, 0.219790E+01_JPRB, 0.225053E+01_JPRB, 0.230332E+01_JPRB, 0.235625E+01_JPRB &
  &, 0.240931E+01_JPRB, 0.246246E+01_JPRB, 0.251569E+01_JPRB &
  &, 0.256898E+01_JPRB, 0.262230E+01_JPRB, 0.267563E+01_JPRB, 0.272896E+01_JPRB &
  &, 0.278226E+01_JPRB, 0.283550E+01_JPRB, 0.288868E+01_JPRB &
  &, 0.294176E+01_JPRB, 0.299473E+01_JPRB, 0.304757E+01_JPRB, 0.310026E+01_JPRB &
  &, 0.315278E+01_JPRB, 0.320512E+01_JPRB, 0.325725E+01_JPRB &
  &, 0.330915E+01_JPRB, 0.336082E+01_JPRB, 0.341222E+01_JPRB, 0.346335E+01_JPRB &
  &, 0.351419E+01_JPRB, 0.356473E+01_JPRB, 0.361493E+01_JPRB &
  &, 0.366480E+01_JPRB, 0.371431E+01_JPRB, 0.376346E+01_JPRB, 0.381223E+01_JPRB &
  &, 0.386059E+01_JPRB, 0.390855E+01_JPRB, 0.395609E+01_JPRB &
  &, 0.400318E+01_JPRB, 0.404984E+01_JPRB, 0.409603E+01_JPRB, 0.414175E+01_JPRB &
  &, 0.418699E+01_JPRB, 0.423175E+01_JPRB, 0.427599E+01_JPRB &
  &, 0.431972E+01_JPRB, 0.436295E+01_JPRB, 0.440562E+01_JPRB, 0.444776E+01_JPRB &
  &, 0.448934E+01_JPRB, 0.453037E+01_JPRB, 0.457083E+01_JPRB &
  &, 0.461074E+01_JPRB, 0.465003E+01_JPRB, 0.468877E+01_JPRB, 0.472690E+01_JPRB &
  &, 0.476442E+01_JPRB, 0.480134E+01_JPRB, 0.483764E+01_JPRB &
  &, 0.487329E+01_JPRB, 0.490841E+01_JPRB, 0.494284E+01_JPRB, 0.497661E+01_JPRB &
  &, 0.500982E+01_JPRB, 0.504230E+01_JPRB, 0.507418E+01_JPRB &
  &, 0.510542E+01_JPRB, 0.513599E+01_JPRB, 0.516591E+01_JPRB, 0.519517E+01_JPRB &
  &, 0.522375E+01_JPRB, 0.525169E+01_JPRB, 0.527896E+01_JPRB &
  &, 0.530557E+01_JPRB, 0.533148E+01_JPRB, 0.535660E+01_JPRB, 0.538129E+01_JPRB &
  &, 0.540520E+01_JPRB, 0.542844E+01_JPRB, 0.545100E+01_JPRB &
  &, 0.547282E+01_JPRB, 0.549406E+01_JPRB, 0.551458E+01_JPRB, 0.553445E+01_JPRB &
  &, 0.555361E+01_JPRB, 0.557211E+01_JPRB, 0.558992E+01_JPRB &
  &, 0.560704E+01_JPRB, 0.562349E+01_JPRB, 0.563932E+01_JPRB, 0.565442E+01_JPRB &
  &, 0.566883E+01_JPRB, 0.568261E+01_JPRB, 0.569572E+01_JPRB &
  &, 0.570819E+01_JPRB, 0.571994E+01_JPRB, 0.573106E+01_JPRB, 0.574152E+01_JPRB &
  &, 0.575133E+01_JPRB, 0.576047E+01_JPRB, 0.576894E+01_JPRB &
  &, 0.577681E+01_JPRB, 0.578399E+01_JPRB, 0.579054E+01_JPRB, 0.579643E+01_JPRB &
  &, 0.580167E+01_JPRB, 0.580633E+01_JPRB, 0.581037E+01_JPRB &
  &, 0.581370E+01_JPRB, 0.581649E+01_JPRB, 0.581866E+01_JPRB, 0.582015E+01_JPRB &
  &, 0.582104E+01_JPRB, 0.582135E+01_JPRB, 0.582103E+01_JPRB &
  &, 0.582016E+01_JPRB, 0.581869E+01_JPRB, 0.581659E+01_JPRB, 0.581392E+01_JPRB &
  &, 0.581064E+01_JPRB, 0.580682E+01_JPRB, 0.580243E+01_JPRB/)
XCW( 951, :) = (/ &
  &  0.117100E+01_JPRB, 0.121542E+01_JPRB, 0.126047E+01_JPRB, 0.130612E+01_JPRB &
  &, 0.135236E+01_JPRB, 0.139917E+01_JPRB, 0.144653E+01_JPRB &
  &, 0.149442E+01_JPRB, 0.154281E+01_JPRB, 0.159169E+01_JPRB, 0.164103E+01_JPRB &
  &, 0.169081E+01_JPRB, 0.174101E+01_JPRB, 0.179162E+01_JPRB &
  &, 0.184260E+01_JPRB, 0.189394E+01_JPRB, 0.194561E+01_JPRB, 0.199759E+01_JPRB &
  &, 0.204986E+01_JPRB, 0.210240E+01_JPRB, 0.215518E+01_JPRB &
  &, 0.220818E+01_JPRB, 0.226139E+01_JPRB, 0.231477E+01_JPRB, 0.236831E+01_JPRB &
  &, 0.242198E+01_JPRB, 0.247576E+01_JPRB, 0.252963E+01_JPRB &
  &, 0.258357E+01_JPRB, 0.263755E+01_JPRB, 0.269156E+01_JPRB, 0.274557E+01_JPRB &
  &, 0.279956E+01_JPRB, 0.285352E+01_JPRB, 0.290741E+01_JPRB &
  &, 0.296122E+01_JPRB, 0.301493E+01_JPRB, 0.306852E+01_JPRB, 0.312198E+01_JPRB &
  &, 0.317527E+01_JPRB, 0.322839E+01_JPRB, 0.328131E+01_JPRB &
  &, 0.333402E+01_JPRB, 0.338649E+01_JPRB, 0.343871E+01_JPRB, 0.349068E+01_JPRB &
  &, 0.354235E+01_JPRB, 0.359374E+01_JPRB, 0.364480E+01_JPRB &
  &, 0.369554E+01_JPRB, 0.374592E+01_JPRB, 0.379595E+01_JPRB, 0.384561E+01_JPRB &
  &, 0.389488E+01_JPRB, 0.394374E+01_JPRB, 0.399219E+01_JPRB &
  &, 0.404021E+01_JPRB, 0.408780E+01_JPRB, 0.413492E+01_JPRB, 0.418160E+01_JPRB &
  &, 0.422778E+01_JPRB, 0.427350E+01_JPRB, 0.431870E+01_JPRB &
  &, 0.436340E+01_JPRB, 0.440759E+01_JPRB, 0.445125E+01_JPRB, 0.449437E+01_JPRB &
  &, 0.453696E+01_JPRB, 0.457898E+01_JPRB, 0.462045E+01_JPRB &
  &, 0.466135E+01_JPRB, 0.470167E+01_JPRB, 0.474141E+01_JPRB, 0.478057E+01_JPRB &
  &, 0.481911E+01_JPRB, 0.485707E+01_JPRB, 0.489441E+01_JPRB &
  &, 0.493113E+01_JPRB, 0.496723E+01_JPRB, 0.500267E+01_JPRB, 0.503755E+01_JPRB &
  &, 0.507178E+01_JPRB, 0.510536E+01_JPRB, 0.513829E+01_JPRB &
  &, 0.517055E+01_JPRB, 0.520219E+01_JPRB, 0.523315E+01_JPRB, 0.526349E+01_JPRB &
  &, 0.529315E+01_JPRB, 0.532216E+01_JPRB, 0.535047E+01_JPRB &
  &, 0.537815E+01_JPRB, 0.540513E+01_JPRB, 0.543144E+01_JPRB, 0.545709E+01_JPRB &
  &, 0.548209E+01_JPRB, 0.550636E+01_JPRB, 0.552999E+01_JPRB &
  &, 0.555282E+01_JPRB, 0.557520E+01_JPRB, 0.559679E+01_JPRB, 0.561767E+01_JPRB &
  &, 0.563792E+01_JPRB, 0.565747E+01_JPRB, 0.567637E+01_JPRB &
  &, 0.569455E+01_JPRB, 0.571201E+01_JPRB, 0.572890E+01_JPRB, 0.574509E+01_JPRB &
  &, 0.576060E+01_JPRB, 0.577539E+01_JPRB, 0.578957E+01_JPRB &
  &, 0.580305E+01_JPRB, 0.581585E+01_JPRB, 0.582803E+01_JPRB, 0.583800E+01_JPRB &
  &, 0.585032E+01_JPRB, 0.586047E+01_JPRB, 0.586685E+01_JPRB &
  &, 0.587887E+01_JPRB, 0.588704E+01_JPRB, 0.589460E+01_JPRB, 0.590148E+01_JPRB &
  &, 0.590777E+01_JPRB, 0.591342E+01_JPRB, 0.591839E+01_JPRB &
  &, 0.592276E+01_JPRB, 0.592647E+01_JPRB, 0.592950E+01_JPRB, 0.593207E+01_JPRB &
  &, 0.593393E+01_JPRB, 0.593520E+01_JPRB, 0.593584E+01_JPRB &
  &, 0.593586E+01_JPRB, 0.593528E+01_JPRB, 0.593412E+01_JPRB, 0.593238E+01_JPRB &
  &, 0.593003E+01_JPRB, 0.592708E+01_JPRB, 0.592354E+01_JPRB/)
XCW( 952, :) = (/ &
  &  0.117211E+01_JPRB, 0.121683E+01_JPRB, 0.126221E+01_JPRB, 0.130820E+01_JPRB &
  &, 0.135479E+01_JPRB, 0.140197E+01_JPRB, 0.144971E+01_JPRB &
  &, 0.149799E+01_JPRB, 0.154678E+01_JPRB, 0.159608E+01_JPRB, 0.164586E+01_JPRB &
  &, 0.169609E+01_JPRB, 0.174675E+01_JPRB, 0.179783E+01_JPRB &
  &, 0.184930E+01_JPRB, 0.190113E+01_JPRB, 0.195332E+01_JPRB, 0.200583E+01_JPRB &
  &, 0.205864E+01_JPRB, 0.211173E+01_JPRB, 0.216508E+01_JPRB &
  &, 0.221866E+01_JPRB, 0.227245E+01_JPRB, 0.232644E+01_JPRB, 0.238059E+01_JPRB &
  &, 0.243489E+01_JPRB, 0.248932E+01_JPRB, 0.254384E+01_JPRB &
  &, 0.259844E+01_JPRB, 0.265311E+01_JPRB, 0.270780E+01_JPRB, 0.276251E+01_JPRB &
  &, 0.281722E+01_JPRB, 0.287189E+01_JPRB, 0.292652E+01_JPRB &
  &, 0.298108E+01_JPRB, 0.303555E+01_JPRB, 0.308991E+01_JPRB, 0.314414E+01_JPRB &
  &, 0.319822E+01_JPRB, 0.325214E+01_JPRB, 0.330587E+01_JPRB &
  &, 0.335940E+01_JPRB, 0.341270E+01_JPRB, 0.346578E+01_JPRB, 0.351859E+01_JPRB &
  &, 0.357112E+01_JPRB, 0.362337E+01_JPRB, 0.367530E+01_JPRB &
  &, 0.372693E+01_JPRB, 0.377821E+01_JPRB, 0.382915E+01_JPRB, 0.387971E+01_JPRB &
  &, 0.392991E+01_JPRB, 0.397969E+01_JPRB, 0.402908E+01_JPRB &
  &, 0.407805E+01_JPRB, 0.412659E+01_JPRB, 0.417467E+01_JPRB, 0.422231E+01_JPRB &
  &, 0.426947E+01_JPRB, 0.431617E+01_JPRB, 0.436237E+01_JPRB &
  &, 0.440806E+01_JPRB, 0.445324E+01_JPRB, 0.449792E+01_JPRB, 0.454205E+01_JPRB &
  &, 0.458565E+01_JPRB, 0.462869E+01_JPRB, 0.467121E+01_JPRB &
  &, 0.471314E+01_JPRB, 0.475449E+01_JPRB, 0.479527E+01_JPRB, 0.483548E+01_JPRB &
  &, 0.487507E+01_JPRB, 0.491409E+01_JPRB, 0.495249E+01_JPRB &
  &, 0.499028E+01_JPRB, 0.502746E+01_JPRB, 0.506402E+01_JPRB, 0.509992E+01_JPRB &
  &, 0.513524E+01_JPRB, 0.516987E+01_JPRB, 0.520390E+01_JPRB &
  &, 0.523728E+01_JPRB, 0.527000E+01_JPRB, 0.530207E+01_JPRB, 0.533345E+01_JPRB &
  &, 0.536421E+01_JPRB, 0.539427E+01_JPRB, 0.542374E+01_JPRB &
  &, 0.545253E+01_JPRB, 0.548059E+01_JPRB, 0.550801E+01_JPRB, 0.553476E+01_JPRB &
  &, 0.556085E+01_JPRB, 0.558625E+01_JPRB, 0.561099E+01_JPRB &
  &, 0.563503E+01_JPRB, 0.565838E+01_JPRB, 0.568109E+01_JPRB, 0.570308E+01_JPRB &
  &, 0.572441E+01_JPRB, 0.574505E+01_JPRB, 0.576440E+01_JPRB &
  &, 0.578430E+01_JPRB, 0.580294E+01_JPRB, 0.582083E+01_JPRB, 0.583812E+01_JPRB &
  &, 0.585472E+01_JPRB, 0.587061E+01_JPRB, 0.588584E+01_JPRB &
  &, 0.590042E+01_JPRB, 0.591427E+01_JPRB, 0.592750E+01_JPRB, 0.594006E+01_JPRB &
  &, 0.595194E+01_JPRB, 0.596318E+01_JPRB, 0.597375E+01_JPRB &
  &, 0.598366E+01_JPRB, 0.599288E+01_JPRB, 0.600142E+01_JPRB, 0.600945E+01_JPRB &
  &, 0.601672E+01_JPRB, 0.602340E+01_JPRB, 0.602940E+01_JPRB &
  &, 0.603479E+01_JPRB, 0.603953E+01_JPRB, 0.604363E+01_JPRB, 0.604710E+01_JPRB &
  &, 0.604997E+01_JPRB, 0.605219E+01_JPRB, 0.605383E+01_JPRB &
  &, 0.605484E+01_JPRB, 0.605525E+01_JPRB, 0.605501E+01_JPRB, 0.605419E+01_JPRB &
  &, 0.605282E+01_JPRB, 0.605083E+01_JPRB, 0.604826E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART136',1,ZHOOK_HANDLE)
END SUBROUTINE PART136

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART137

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART137',0,ZHOOK_HANDLE)

XCW( 953, :) = (/ &
  &  0.117323E+01_JPRB, 0.121827E+01_JPRB, 0.126398E+01_JPRB, 0.131031E+01_JPRB &
  &, 0.135726E+01_JPRB, 0.140481E+01_JPRB, 0.145294E+01_JPRB &
  &, 0.150162E+01_JPRB, 0.155083E+01_JPRB, 0.160056E+01_JPRB, 0.165077E+01_JPRB &
  &, 0.170146E+01_JPRB, 0.175259E+01_JPRB, 0.180416E+01_JPRB &
  &, 0.185612E+01_JPRB, 0.190847E+01_JPRB, 0.196118E+01_JPRB, 0.201423E+01_JPRB &
  &, 0.206759E+01_JPRB, 0.212124E+01_JPRB, 0.217517E+01_JPRB &
  &, 0.222934E+01_JPRB, 0.228374E+01_JPRB, 0.233835E+01_JPRB, 0.239313E+01_JPRB &
  &, 0.244808E+01_JPRB, 0.250315E+01_JPRB, 0.255834E+01_JPRB &
  &, 0.261363E+01_JPRB, 0.266898E+01_JPRB, 0.272438E+01_JPRB, 0.277981E+01_JPRB &
  &, 0.283524E+01_JPRB, 0.289066E+01_JPRB, 0.294604E+01_JPRB &
  &, 0.300136E+01_JPRB, 0.305660E+01_JPRB, 0.311175E+01_JPRB, 0.316678E+01_JPRB &
  &, 0.322167E+01_JPRB, 0.327641E+01_JPRB, 0.333097E+01_JPRB &
  &, 0.338533E+01_JPRB, 0.343948E+01_JPRB, 0.349341E+01_JPRB, 0.354710E+01_JPRB &
  &, 0.360049E+01_JPRB, 0.365364E+01_JPRB, 0.370649E+01_JPRB &
  &, 0.375901E+01_JPRB, 0.381122E+01_JPRB, 0.386307E+01_JPRB, 0.391459E+01_JPRB &
  &, 0.396572E+01_JPRB, 0.401646E+01_JPRB, 0.406681E+01_JPRB &
  &, 0.411675E+01_JPRB, 0.416625E+01_JPRB, 0.421533E+01_JPRB, 0.426395E+01_JPRB &
  &, 0.431212E+01_JPRB, 0.435981E+01_JPRB, 0.440703E+01_JPRB &
  &, 0.445374E+01_JPRB, 0.449995E+01_JPRB, 0.454565E+01_JPRB, 0.459082E+01_JPRB &
  &, 0.463547E+01_JPRB, 0.467958E+01_JPRB, 0.472312E+01_JPRB &
  &, 0.476613E+01_JPRB, 0.480855E+01_JPRB, 0.485042E+01_JPRB, 0.489169E+01_JPRB &
  &, 0.493237E+01_JPRB, 0.497246E+01_JPRB, 0.501197E+01_JPRB &
  &, 0.505084E+01_JPRB, 0.508913E+01_JPRB, 0.512679E+01_JPRB, 0.516380E+01_JPRB &
  &, 0.520021E+01_JPRB, 0.523598E+01_JPRB, 0.527112E+01_JPRB &
  &, 0.530561E+01_JPRB, 0.533943E+01_JPRB, 0.537264E+01_JPRB, 0.540519E+01_JPRB &
  &, 0.543706E+01_JPRB, 0.546828E+01_JPRB, 0.549885E+01_JPRB &
  &, 0.552874E+01_JPRB, 0.555796E+01_JPRB, 0.558548E+01_JPRB, 0.561439E+01_JPRB &
  &, 0.564162E+01_JPRB, 0.566815E+01_JPRB, 0.569399E+01_JPRB &
  &, 0.571920E+01_JPRB, 0.574370E+01_JPRB, 0.576752E+01_JPRB, 0.579068E+01_JPRB &
  &, 0.581282E+01_JPRB, 0.583492E+01_JPRB, 0.585599E+01_JPRB &
  &, 0.587643E+01_JPRB, 0.589615E+01_JPRB, 0.591518E+01_JPRB, 0.593359E+01_JPRB &
  &, 0.595133E+01_JPRB, 0.596831E+01_JPRB, 0.598472E+01_JPRB &
  &, 0.600039E+01_JPRB, 0.601538E+01_JPRB, 0.602970E+01_JPRB, 0.604335E+01_JPRB &
  &, 0.605637E+01_JPRB, 0.606865E+01_JPRB, 0.608035E+01_JPRB &
  &, 0.609125E+01_JPRB, 0.610171E+01_JPRB, 0.611128E+01_JPRB, 0.612039E+01_JPRB &
  &, 0.612873E+01_JPRB, 0.613649E+01_JPRB, 0.614356E+01_JPRB &
  &, 0.614996E+01_JPRB, 0.615577E+01_JPRB, 0.616093E+01_JPRB, 0.616547E+01_JPRB &
  &, 0.616933E+01_JPRB, 0.617260E+01_JPRB, 0.617522E+01_JPRB &
  &, 0.617722E+01_JPRB, 0.617867E+01_JPRB, 0.617946E+01_JPRB, 0.617967E+01_JPRB &
  &, 0.617919E+01_JPRB, 0.617822E+01_JPRB, 0.617659E+01_JPRB/)
XCW( 954, :) = (/ &
  &  0.117437E+01_JPRB, 0.121974E+01_JPRB, 0.126578E+01_JPRB, 0.131246E+01_JPRB &
  &, 0.135978E+01_JPRB, 0.140771E+01_JPRB, 0.145623E+01_JPRB &
  &, 0.150532E+01_JPRB, 0.155495E+01_JPRB, 0.160512E+01_JPRB, 0.165578E+01_JPRB &
  &, 0.170694E+01_JPRB, 0.175855E+01_JPRB, 0.181061E+01_JPRB &
  &, 0.186308E+01_JPRB, 0.191595E+01_JPRB, 0.196920E+01_JPRB, 0.202279E+01_JPRB &
  &, 0.207672E+01_JPRB, 0.213095E+01_JPRB, 0.218547E+01_JPRB &
  &, 0.224025E+01_JPRB, 0.229527E+01_JPRB, 0.235050E+01_JPRB, 0.240593E+01_JPRB &
  &, 0.246153E+01_JPRB, 0.251727E+01_JPRB, 0.257315E+01_JPRB &
  &, 0.262913E+01_JPRB, 0.268516E+01_JPRB, 0.274131E+01_JPRB, 0.279747E+01_JPRB &
  &, 0.285365E+01_JPRB, 0.290982E+01_JPRB, 0.296597E+01_JPRB &
  &, 0.302208E+01_JPRB, 0.307811E+01_JPRB, 0.313406E+01_JPRB, 0.318990E+01_JPRB &
  &, 0.324563E+01_JPRB, 0.330119E+01_JPRB, 0.335661E+01_JPRB &
  &, 0.341183E+01_JPRB, 0.346686E+01_JPRB, 0.352166E+01_JPRB, 0.357624E+01_JPRB &
  &, 0.363055E+01_JPRB, 0.368461E+01_JPRB, 0.373836E+01_JPRB &
  &, 0.379182E+01_JPRB, 0.384496E+01_JPRB, 0.389778E+01_JPRB, 0.395024E+01_JPRB &
  &, 0.400234E+01_JPRB, 0.405406E+01_JPRB, 0.410540E+01_JPRB &
  &, 0.415630E+01_JPRB, 0.420683E+01_JPRB, 0.425691E+01_JPRB, 0.430656E+01_JPRB &
  &, 0.435574E+01_JPRB, 0.440448E+01_JPRB, 0.445273E+01_JPRB &
  &, 0.450048E+01_JPRB, 0.454775E+01_JPRB, 0.459453E+01_JPRB, 0.464076E+01_JPRB &
  &, 0.468649E+01_JPRB, 0.473166E+01_JPRB, 0.477630E+01_JPRB &
  &, 0.482039E+01_JPRB, 0.486391E+01_JPRB, 0.490687E+01_JPRB, 0.494926E+01_JPRB &
  &, 0.499106E+01_JPRB, 0.503226E+01_JPRB, 0.507289E+01_JPRB &
  &, 0.511289E+01_JPRB, 0.515229E+01_JPRB, 0.519100E+01_JPRB, 0.522924E+01_JPRB &
  &, 0.526680E+01_JPRB, 0.530373E+01_JPRB, 0.534001E+01_JPRB &
  &, 0.537565E+01_JPRB, 0.541063E+01_JPRB, 0.544499E+01_JPRB, 0.547869E+01_JPRB &
  &, 0.551174E+01_JPRB, 0.554412E+01_JPRB, 0.557583E+01_JPRB &
  &, 0.560689E+01_JPRB, 0.563728E+01_JPRB, 0.566701E+01_JPRB, 0.569603E+01_JPRB &
  &, 0.572446E+01_JPRB, 0.575216E+01_JPRB, 0.577920E+01_JPRB &
  &, 0.580556E+01_JPRB, 0.583125E+01_JPRB, 0.585622E+01_JPRB, 0.588053E+01_JPRB &
  &, 0.590417E+01_JPRB, 0.592717E+01_JPRB, 0.594940E+01_JPRB &
  &, 0.597100E+01_JPRB, 0.599189E+01_JPRB, 0.601213E+01_JPRB, 0.603168E+01_JPRB &
  &, 0.605055E+01_JPRB, 0.606871E+01_JPRB, 0.608625E+01_JPRB &
  &, 0.610310E+01_JPRB, 0.611922E+01_JPRB, 0.613472E+01_JPRB, 0.614951E+01_JPRB &
  &, 0.616365E+01_JPRB, 0.617711E+01_JPRB, 0.618990E+01_JPRB &
  &, 0.620203E+01_JPRB, 0.621352E+01_JPRB, 0.622432E+01_JPRB, 0.623445E+01_JPRB &
  &, 0.624391E+01_JPRB, 0.625236E+01_JPRB, 0.626093E+01_JPRB &
  &, 0.626845E+01_JPRB, 0.627536E+01_JPRB, 0.628164E+01_JPRB, 0.628711E+01_JPRB &
  &, 0.629207E+01_JPRB, 0.629649E+01_JPRB, 0.630022E+01_JPRB &
  &, 0.630331E+01_JPRB, 0.630572E+01_JPRB, 0.630759E+01_JPRB, 0.630881E+01_JPRB &
  &, 0.630940E+01_JPRB, 0.630944E+01_JPRB, 0.630880E+01_JPRB/)
XCW( 955, :) = (/ &
  &  0.117554E+01_JPRB, 0.122123E+01_JPRB, 0.126761E+01_JPRB, 0.131466E+01_JPRB &
  &, 0.136235E+01_JPRB, 0.141066E+01_JPRB, 0.145958E+01_JPRB &
  &, 0.150909E+01_JPRB, 0.155916E+01_JPRB, 0.160976E+01_JPRB, 0.166089E+01_JPRB &
  &, 0.171252E+01_JPRB, 0.176454E+01_JPRB, 0.181719E+01_JPRB &
  &, 0.187018E+01_JPRB, 0.192358E+01_JPRB, 0.197738E+01_JPRB, 0.203153E+01_JPRB &
  &, 0.208604E+01_JPRB, 0.214086E+01_JPRB, 0.219598E+01_JPRB &
  &, 0.225137E+01_JPRB, 0.230702E+01_JPRB, 0.236290E+01_JPRB, 0.241899E+01_JPRB &
  &, 0.247526E+01_JPRB, 0.253169E+01_JPRB, 0.258824E+01_JPRB &
  &, 0.264495E+01_JPRB, 0.270174E+01_JPRB, 0.275860E+01_JPRB, 0.281551E+01_JPRB &
  &, 0.287246E+01_JPRB, 0.292940E+01_JPRB, 0.298634E+01_JPRB &
  &, 0.304324E+01_JPRB, 0.310009E+01_JPRB, 0.315686E+01_JPRB, 0.321354E+01_JPRB &
  &, 0.327011E+01_JPRB, 0.332654E+01_JPRB, 0.338281E+01_JPRB &
  &, 0.343893E+01_JPRB, 0.349484E+01_JPRB, 0.355055E+01_JPRB, 0.360604E+01_JPRB &
  &, 0.366128E+01_JPRB, 0.371627E+01_JPRB, 0.377097E+01_JPRB &
  &, 0.382538E+01_JPRB, 0.387949E+01_JPRB, 0.393327E+01_JPRB, 0.398671E+01_JPRB &
  &, 0.403981E+01_JPRB, 0.409254E+01_JPRB, 0.414487E+01_JPRB &
  &, 0.419682E+01_JPRB, 0.424836E+01_JPRB, 0.429949E+01_JPRB, 0.435017E+01_JPRB &
  &, 0.440042E+01_JPRB, 0.445021E+01_JPRB, 0.449952E+01_JPRB &
  &, 0.454835E+01_JPRB, 0.459670E+01_JPRB, 0.464455E+01_JPRB, 0.469190E+01_JPRB &
  &, 0.473872E+01_JPRB, 0.478502E+01_JPRB, 0.483077E+01_JPRB &
  &, 0.487598E+01_JPRB, 0.492063E+01_JPRB, 0.496473E+01_JPRB, 0.500825E+01_JPRB &
  &, 0.505120E+01_JPRB, 0.509355E+01_JPRB, 0.513533E+01_JPRB &
  &, 0.517649E+01_JPRB, 0.521706E+01_JPRB, 0.525703E+01_JPRB, 0.529634E+01_JPRB &
  &, 0.533507E+01_JPRB, 0.537320E+01_JPRB, 0.541064E+01_JPRB &
  &, 0.544744E+01_JPRB, 0.548361E+01_JPRB, 0.551920E+01_JPRB, 0.555408E+01_JPRB &
  &, 0.558835E+01_JPRB, 0.562192E+01_JPRB, 0.565483E+01_JPRB &
  &, 0.568710E+01_JPRB, 0.571871E+01_JPRB, 0.574952E+01_JPRB, 0.577991E+01_JPRB &
  &, 0.580950E+01_JPRB, 0.583841E+01_JPRB, 0.586663E+01_JPRB &
  &, 0.589421E+01_JPRB, 0.592112E+01_JPRB, 0.594732E+01_JPRB, 0.597282E+01_JPRB &
  &, 0.599770E+01_JPRB, 0.602186E+01_JPRB, 0.604534E+01_JPRB &
  &, 0.606815E+01_JPRB, 0.609025E+01_JPRB, 0.611170E+01_JPRB, 0.613242E+01_JPRB &
  &, 0.615251E+01_JPRB, 0.617189E+01_JPRB, 0.619061E+01_JPRB &
  &, 0.620863E+01_JPRB, 0.622598E+01_JPRB, 0.624265E+01_JPRB, 0.625863E+01_JPRB &
  &, 0.627399E+01_JPRB, 0.628858E+01_JPRB, 0.630260E+01_JPRB &
  &, 0.631591E+01_JPRB, 0.632851E+01_JPRB, 0.634049E+01_JPRB, 0.635179E+01_JPRB &
  &, 0.636243E+01_JPRB, 0.637242E+01_JPRB, 0.638172E+01_JPRB &
  &, 0.639040E+01_JPRB, 0.639843E+01_JPRB, 0.640586E+01_JPRB, 0.641254E+01_JPRB &
  &, 0.641866E+01_JPRB, 0.642400E+01_JPRB, 0.642892E+01_JPRB &
  &, 0.643309E+01_JPRB, 0.643664E+01_JPRB, 0.643958E+01_JPRB, 0.644187E+01_JPRB &
  &, 0.644352E+01_JPRB, 0.644461E+01_JPRB, 0.644509E+01_JPRB/)
XCW( 956, :) = (/ &
  &  0.117672E+01_JPRB, 0.122275E+01_JPRB, 0.126948E+01_JPRB, 0.131689E+01_JPRB &
  &, 0.136496E+01_JPRB, 0.141367E+01_JPRB, 0.146300E+01_JPRB &
  &, 0.151293E+01_JPRB, 0.156344E+01_JPRB, 0.161451E+01_JPRB, 0.166611E+01_JPRB &
  &, 0.171822E+01_JPRB, 0.177083E+01_JPRB, 0.182390E+01_JPRB &
  &, 0.187743E+01_JPRB, 0.193137E+01_JPRB, 0.198573E+01_JPRB, 0.204046E+01_JPRB &
  &, 0.209555E+01_JPRB, 0.215097E+01_JPRB, 0.220671E+01_JPRB &
  &, 0.226274E+01_JPRB, 0.231903E+01_JPRB, 0.237557E+01_JPRB, 0.243233E+01_JPRB &
  &, 0.248929E+01_JPRB, 0.254643E+01_JPRB, 0.260371E+01_JPRB &
  &, 0.266113E+01_JPRB, 0.271866E+01_JPRB, 0.277628E+01_JPRB, 0.283395E+01_JPRB &
  &, 0.289168E+01_JPRB, 0.294942E+01_JPRB, 0.300716E+01_JPRB &
  &, 0.306488E+01_JPRB, 0.312012E+01_JPRB, 0.318018E+01_JPRB, 0.323771E+01_JPRB &
  &, 0.329515E+01_JPRB, 0.335246E+01_JPRB, 0.340963E+01_JPRB &
  &, 0.346664E+01_JPRB, 0.352347E+01_JPRB, 0.358011E+01_JPRB, 0.363653E+01_JPRB &
  &, 0.369272E+01_JPRB, 0.374866E+01_JPRB, 0.380433E+01_JPRB &
  &, 0.385973E+01_JPRB, 0.391483E+01_JPRB, 0.396961E+01_JPRB, 0.402406E+01_JPRB &
  &, 0.407817E+01_JPRB, 0.413192E+01_JPRB, 0.418530E+01_JPRB &
  &, 0.423829E+01_JPRB, 0.429089E+01_JPRB, 0.434308E+01_JPRB, 0.439484E+01_JPRB &
  &, 0.444615E+01_JPRB, 0.449704E+01_JPRB, 0.454745E+01_JPRB &
  &, 0.459740E+01_JPRB, 0.464686E+01_JPRB, 0.469583E+01_JPRB, 0.474430E+01_JPRB &
  &, 0.479226E+01_JPRB, 0.483969E+01_JPRB, 0.488659E+01_JPRB &
  &, 0.493294E+01_JPRB, 0.497876E+01_JPRB, 0.502402E+01_JPRB, 0.506872E+01_JPRB &
  &, 0.511285E+01_JPRB, 0.515639E+01_JPRB, 0.519935E+01_JPRB &
  &, 0.524169E+01_JPRB, 0.528347E+01_JPRB, 0.532463E+01_JPRB, 0.536519E+01_JPRB &
  &, 0.540511E+01_JPRB, 0.544443E+01_JPRB, 0.548308E+01_JPRB &
  &, 0.552115E+01_JPRB, 0.555855E+01_JPRB, 0.559535E+01_JPRB, 0.563146E+01_JPRB &
  &, 0.566693E+01_JPRB, 0.570173E+01_JPRB, 0.573591E+01_JPRB &
  &, 0.576943E+01_JPRB, 0.580229E+01_JPRB, 0.583443E+01_JPRB, 0.586596E+01_JPRB &
  &, 0.589683E+01_JPRB, 0.592698E+01_JPRB, 0.595646E+01_JPRB &
  &, 0.598526E+01_JPRB, 0.601343E+01_JPRB, 0.604086E+01_JPRB, 0.606767E+01_JPRB &
  &, 0.609376E+01_JPRB, 0.611920E+01_JPRB, 0.614393E+01_JPRB &
  &, 0.616795E+01_JPRB, 0.619130E+01_JPRB, 0.621401E+01_JPRB, 0.623599E+01_JPRB &
  &, 0.625730E+01_JPRB, 0.627794E+01_JPRB, 0.629792E+01_JPRB &
  &, 0.631718E+01_JPRB, 0.633574E+01_JPRB, 0.635364E+01_JPRB, 0.637089E+01_JPRB &
  &, 0.638743E+01_JPRB, 0.640330E+01_JPRB, 0.641844E+01_JPRB &
  &, 0.643267E+01_JPRB, 0.644690E+01_JPRB, 0.646005E+01_JPRB, 0.647241E+01_JPRB &
  &, 0.648443E+01_JPRB, 0.649558E+01_JPRB, 0.650610E+01_JPRB &
  &, 0.651594E+01_JPRB, 0.652518E+01_JPRB, 0.653376E+01_JPRB, 0.654165E+01_JPRB &
  &, 0.654892E+01_JPRB, 0.655552E+01_JPRB, 0.656152E+01_JPRB &
  &, 0.656682E+01_JPRB, 0.657150E+01_JPRB, 0.657557E+01_JPRB, 0.657904E+01_JPRB &
  &, 0.658180E+01_JPRB, 0.658400E+01_JPRB, 0.658558E+01_JPRB/)
XCW( 957, :) = (/ &
  &  0.117793E+01_JPRB, 0.122430E+01_JPRB, 0.127139E+01_JPRB, 0.131917E+01_JPRB &
  &, 0.136763E+01_JPRB, 0.141674E+01_JPRB, 0.146649E+01_JPRB &
  &, 0.151686E+01_JPRB, 0.156782E+01_JPRB, 0.161935E+01_JPRB, 0.167143E+01_JPRB &
  &, 0.172404E+01_JPRB, 0.177715E+01_JPRB, 0.183076E+01_JPRB &
  &, 0.188482E+01_JPRB, 0.193933E+01_JPRB, 0.199425E+01_JPRB, 0.204957E+01_JPRB &
  &, 0.210526E+01_JPRB, 0.216131E+01_JPRB, 0.221767E+01_JPRB &
  &, 0.227435E+01_JPRB, 0.233130E+01_JPRB, 0.238852E+01_JPRB, 0.244597E+01_JPRB &
  &, 0.250363E+01_JPRB, 0.256148E+01_JPRB, 0.261950E+01_JPRB &
  &, 0.267767E+01_JPRB, 0.273596E+01_JPRB, 0.279434E+01_JPRB, 0.285281E+01_JPRB &
  &, 0.291133E+01_JPRB, 0.296989E+01_JPRB, 0.302846E+01_JPRB &
  &, 0.308702E+01_JPRB, 0.314555E+01_JPRB, 0.320403E+01_JPRB, 0.326245E+01_JPRB &
  &, 0.332078E+01_JPRB, 0.337899E+01_JPRB, 0.343707E+01_JPRB &
  &, 0.349501E+01_JPRB, 0.355277E+01_JPRB, 0.361036E+01_JPRB, 0.366774E+01_JPRB &
  &, 0.372491E+01_JPRB, 0.378182E+01_JPRB, 0.383850E+01_JPRB &
  &, 0.389489E+01_JPRB, 0.395101E+01_JPRB, 0.400681E+01_JPRB, 0.406231E+01_JPRB &
  &, 0.411746E+01_JPRB, 0.417226E+01_JPRB, 0.422672E+01_JPRB &
  &, 0.428079E+01_JPRB, 0.433446E+01_JPRB, 0.438775E+01_JPRB, 0.444061E+01_JPRB &
  &, 0.449304E+01_JPRB, 0.454503E+01_JPRB, 0.459658E+01_JPRB &
  &, 0.464765E+01_JPRB, 0.469826E+01_JPRB, 0.474838E+01_JPRB, 0.479800E+01_JPRB &
  &, 0.484714E+01_JPRB, 0.489573E+01_JPRB, 0.494383E+01_JPRB &
  &, 0.499138E+01_JPRB, 0.503839E+01_JPRB, 0.508484E+01_JPRB, 0.513074E+01_JPRB &
  &, 0.517607E+01_JPRB, 0.522084E+01_JPRB, 0.526501E+01_JPRB &
  &, 0.530860E+01_JPRB, 0.535162E+01_JPRB, 0.539400E+01_JPRB, 0.543580E+01_JPRB &
  &, 0.547699E+01_JPRB, 0.551754E+01_JPRB, 0.555746E+01_JPRB &
  &, 0.559678E+01_JPRB, 0.563547E+01_JPRB, 0.567351E+01_JPRB, 0.571086E+01_JPRB &
  &, 0.574764E+01_JPRB, 0.578365E+01_JPRB, 0.581920E+01_JPRB &
  &, 0.585397E+01_JPRB, 0.588810E+01_JPRB, 0.592158E+01_JPRB, 0.595437E+01_JPRB &
  &, 0.598646E+01_JPRB, 0.601797E+01_JPRB, 0.604874E+01_JPRB &
  &, 0.607885E+01_JPRB, 0.610829E+01_JPRB, 0.613707E+01_JPRB, 0.616512E+01_JPRB &
  &, 0.619253E+01_JPRB, 0.621922E+01_JPRB, 0.624524E+01_JPRB &
  &, 0.627060E+01_JPRB, 0.629526E+01_JPRB, 0.631910E+01_JPRB, 0.634251E+01_JPRB &
  &, 0.636513E+01_JPRB, 0.638704E+01_JPRB, 0.640829E+01_JPRB &
  &, 0.642886E+01_JPRB, 0.644870E+01_JPRB, 0.646792E+01_JPRB, 0.648639E+01_JPRB &
  &, 0.650426E+01_JPRB, 0.652135E+01_JPRB, 0.653782E+01_JPRB &
  &, 0.655362E+01_JPRB, 0.656873E+01_JPRB, 0.658320E+01_JPRB, 0.659699E+01_JPRB &
  &, 0.660923E+01_JPRB, 0.662250E+01_JPRB, 0.663424E+01_JPRB &
  &, 0.664524E+01_JPRB, 0.665579E+01_JPRB, 0.666558E+01_JPRB, 0.667473E+01_JPRB &
  &, 0.668314E+01_JPRB, 0.669099E+01_JPRB, 0.669819E+01_JPRB &
  &, 0.670468E+01_JPRB, 0.671061E+01_JPRB, 0.671585E+01_JPRB, 0.672044E+01_JPRB &
  &, 0.672443E+01_JPRB, 0.672780E+01_JPRB, 0.673054E+01_JPRB/)
XCW( 958, :) = (/ &
  &  0.117916E+01_JPRB, 0.122588E+01_JPRB, 0.127333E+01_JPRB, 0.132149E+01_JPRB &
  &, 0.137035E+01_JPRB, 0.141988E+01_JPRB, 0.147005E+01_JPRB &
  &, 0.152086E+01_JPRB, 0.157228E+01_JPRB, 0.162429E+01_JPRB, 0.167686E+01_JPRB &
  &, 0.172998E+01_JPRB, 0.178362E+01_JPRB, 0.183775E+01_JPRB &
  &, 0.189238E+01_JPRB, 0.194745E+01_JPRB, 0.200296E+01_JPRB, 0.205888E+01_JPRB &
  &, 0.211519E+01_JPRB, 0.217186E+01_JPRB, 0.222888E+01_JPRB &
  &, 0.228622E+01_JPRB, 0.234385E+01_JPRB, 0.240176E+01_JPRB, 0.245991E+01_JPRB &
  &, 0.251829E+01_JPRB, 0.257688E+01_JPRB, 0.263565E+01_JPRB &
  &, 0.269458E+01_JPRB, 0.275365E+01_JPRB, 0.281283E+01_JPRB, 0.287210E+01_JPRB &
  &, 0.293145E+01_JPRB, 0.299084E+01_JPRB, 0.305025E+01_JPRB &
  &, 0.310967E+01_JPRB, 0.316908E+01_JPRB, 0.322846E+01_JPRB, 0.328777E+01_JPRB &
  &, 0.334700E+01_JPRB, 0.340614E+01_JPRB, 0.346517E+01_JPRB &
  &, 0.352405E+01_JPRB, 0.358279E+01_JPRB, 0.364135E+01_JPRB, 0.369971E+01_JPRB &
  &, 0.375787E+01_JPRB, 0.381580E+01_JPRB, 0.387349E+01_JPRB &
  &, 0.393092E+01_JPRB, 0.398808E+01_JPRB, 0.404493E+01_JPRB, 0.410149E+01_JPRB &
  &, 0.415772E+01_JPRB, 0.421361E+01_JPRB, 0.426916E+01_JPRB &
  &, 0.432433E+01_JPRB, 0.437913E+01_JPRB, 0.443353E+01_JPRB, 0.448753E+01_JPRB &
  &, 0.454110E+01_JPRB, 0.459424E+01_JPRB, 0.464696E+01_JPRB &
  &, 0.469921E+01_JPRB, 0.475097E+01_JPRB, 0.480228E+01_JPRB, 0.485311E+01_JPRB &
  &, 0.490343E+01_JPRB, 0.495325E+01_JPRB, 0.500254E+01_JPRB &
  &, 0.505131E+01_JPRB, 0.509956E+01_JPRB, 0.514725E+01_JPRB, 0.519440E+01_JPRB &
  &, 0.524097E+01_JPRB, 0.528699E+01_JPRB, 0.533243E+01_JPRB &
  &, 0.537729E+01_JPRB, 0.542155E+01_JPRB, 0.546524E+01_JPRB, 0.550831E+01_JPRB &
  &, 0.555077E+01_JPRB, 0.559264E+01_JPRB, 0.563387E+01_JPRB &
  &, 0.567448E+01_JPRB, 0.571446E+01_JPRB, 0.575382E+01_JPRB, 0.579251E+01_JPRB &
  &, 0.583057E+01_JPRB, 0.586798E+01_JPRB, 0.590476E+01_JPRB &
  &, 0.594086E+01_JPRB, 0.597623E+01_JPRB, 0.601111E+01_JPRB, 0.604526E+01_JPRB &
  &, 0.607874E+01_JPRB, 0.611148E+01_JPRB, 0.614363E+01_JPRB &
  &, 0.617508E+01_JPRB, 0.620584E+01_JPRB, 0.623538E+01_JPRB, 0.626536E+01_JPRB &
  &, 0.629410E+01_JPRB, 0.632212E+01_JPRB, 0.634952E+01_JPRB &
  &, 0.637618E+01_JPRB, 0.640219E+01_JPRB, 0.642747E+01_JPRB, 0.645215E+01_JPRB &
  &, 0.647608E+01_JPRB, 0.649935E+01_JPRB, 0.652193E+01_JPRB &
  &, 0.654382E+01_JPRB, 0.656503E+01_JPRB, 0.658553E+01_JPRB, 0.660537E+01_JPRB &
  &, 0.662452E+01_JPRB, 0.664298E+01_JPRB, 0.666073E+01_JPRB &
  &, 0.667786E+01_JPRB, 0.669430E+01_JPRB, 0.671004E+01_JPRB, 0.672512E+01_JPRB &
  &, 0.673952E+01_JPRB, 0.675322E+01_JPRB, 0.676628E+01_JPRB &
  &, 0.677866E+01_JPRB, 0.679043E+01_JPRB, 0.680148E+01_JPRB, 0.681189E+01_JPRB &
  &, 0.682162E+01_JPRB, 0.683072E+01_JPRB, 0.683917E+01_JPRB &
  &, 0.684691E+01_JPRB, 0.685408E+01_JPRB, 0.686057E+01_JPRB, 0.686645E+01_JPRB &
  &, 0.687161E+01_JPRB, 0.687620E+01_JPRB, 0.688016E+01_JPRB/)
XCW( 959, :) = (/ &
  &  0.118042E+01_JPRB, 0.122749E+01_JPRB, 0.127532E+01_JPRB, 0.132387E+01_JPRB &
  &, 0.137313E+01_JPRB, 0.142307E+01_JPRB, 0.147369E+01_JPRB &
  &, 0.152495E+01_JPRB, 0.157684E+01_JPRB, 0.162933E+01_JPRB, 0.168241E+01_JPRB &
  &, 0.173604E+01_JPRB, 0.179022E+01_JPRB, 0.184491E+01_JPRB &
  &, 0.190010E+01_JPRB, 0.195576E+01_JPRB, 0.201187E+01_JPRB, 0.206840E+01_JPRB &
  &, 0.212535E+01_JPRB, 0.218266E+01_JPRB, 0.224034E+01_JPRB &
  &, 0.229836E+01_JPRB, 0.235668E+01_JPRB, 0.241530E+01_JPRB, 0.247418E+01_JPRB &
  &, 0.253330E+01_JPRB, 0.259264E+01_JPRB, 0.265218E+01_JPRB &
  &, 0.271189E+01_JPRB, 0.277176E+01_JPRB, 0.283175E+01_JPRB, 0.289185E+01_JPRB &
  &, 0.295204E+01_JPRB, 0.301229E+01_JPRB, 0.307257E+01_JPRB &
  &, 0.313287E+01_JPRB, 0.319318E+01_JPRB, 0.325346E+01_JPRB, 0.331370E+01_JPRB &
  &, 0.337388E+01_JPRB, 0.343396E+01_JPRB, 0.349395E+01_JPRB &
  &, 0.355381E+01_JPRB, 0.361353E+01_JPRB, 0.367309E+01_JPRB, 0.373248E+01_JPRB &
  &, 0.379166E+01_JPRB, 0.385063E+01_JPRB, 0.390937E+01_JPRB &
  &, 0.396786E+01_JPRB, 0.402608E+01_JPRB, 0.408402E+01_JPRB, 0.414167E+01_JPRB &
  &, 0.419900E+01_JPRB, 0.425603E+01_JPRB, 0.431268E+01_JPRB &
  &, 0.436900E+01_JPRB, 0.442494E+01_JPRB, 0.448050E+01_JPRB, 0.453566E+01_JPRB &
  &, 0.459041E+01_JPRB, 0.464474E+01_JPRB, 0.469863E+01_JPRB &
  &, 0.475208E+01_JPRB, 0.480508E+01_JPRB, 0.485760E+01_JPRB, 0.490966E+01_JPRB &
  &, 0.496122E+01_JPRB, 0.501227E+01_JPRB, 0.506282E+01_JPRB &
  &, 0.511284E+01_JPRB, 0.516235E+01_JPRB, 0.521133E+01_JPRB, 0.525974E+01_JPRB &
  &, 0.530761E+01_JPRB, 0.535493E+01_JPRB, 0.540167E+01_JPRB &
  &, 0.544782E+01_JPRB, 0.549342E+01_JPRB, 0.553841E+01_JPRB, 0.558282E+01_JPRB &
  &, 0.562659E+01_JPRB, 0.566980E+01_JPRB, 0.571237E+01_JPRB &
  &, 0.575429E+01_JPRB, 0.579564E+01_JPRB, 0.583632E+01_JPRB, 0.587641E+01_JPRB &
  &, 0.591581E+01_JPRB, 0.595458E+01_JPRB, 0.599272E+01_JPRB &
  &, 0.603022E+01_JPRB, 0.606706E+01_JPRB, 0.610321E+01_JPRB, 0.613869E+01_JPRB &
  &, 0.617357E+01_JPRB, 0.620773E+01_JPRB, 0.624123E+01_JPRB &
  &, 0.627407E+01_JPRB, 0.630622E+01_JPRB, 0.633770E+01_JPRB, 0.636849E+01_JPRB &
  &, 0.639865E+01_JPRB, 0.642810E+01_JPRB, 0.645685E+01_JPRB &
  &, 0.648490E+01_JPRB, 0.651230E+01_JPRB, 0.653903E+01_JPRB, 0.656503E+01_JPRB &
  &, 0.659033E+01_JPRB, 0.661497E+01_JPRB, 0.663896E+01_JPRB &
  &, 0.666223E+01_JPRB, 0.668473E+01_JPRB, 0.670669E+01_JPRB, 0.672792E+01_JPRB &
  &, 0.674845E+01_JPRB, 0.676825E+01_JPRB, 0.678743E+01_JPRB &
  &, 0.680594E+01_JPRB, 0.682371E+01_JPRB, 0.684064E+01_JPRB, 0.685730E+01_JPRB &
  &, 0.687304E+01_JPRB, 0.688807E+01_JPRB, 0.690246E+01_JPRB &
  &, 0.691622E+01_JPRB, 0.692931E+01_JPRB, 0.694169E+01_JPRB, 0.695342E+01_JPRB &
  &, 0.696446E+01_JPRB, 0.697489E+01_JPRB, 0.698465E+01_JPRB &
  &, 0.699364E+01_JPRB, 0.700217E+01_JPRB, 0.700996E+01_JPRB, 0.701713E+01_JPRB &
  &, 0.702359E+01_JPRB, 0.702947E+01_JPRB, 0.703465E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART137',1,ZHOOK_HANDLE)
END SUBROUTINE PART137

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART138

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART138',0,ZHOOK_HANDLE)

XCW( 960, :) = (/ &
  &  0.118170E+01_JPRB, 0.122914E+01_JPRB, 0.127734E+01_JPRB, 0.132629E+01_JPRB &
  &, 0.137596E+01_JPRB, 0.142634E+01_JPRB, 0.147740E+01_JPRB &
  &, 0.152913E+01_JPRB, 0.158150E+01_JPRB, 0.163449E+01_JPRB, 0.168808E+01_JPRB &
  &, 0.174225E+01_JPRB, 0.179697E+01_JPRB, 0.185223E+01_JPRB &
  &, 0.190800E+01_JPRB, 0.196425E+01_JPRB, 0.202098E+01_JPRB, 0.207814E+01_JPRB &
  &, 0.213573E+01_JPRB, 0.219371E+01_JPRB, 0.225206E+01_JPRB &
  &, 0.231078E+01_JPRB, 0.236982E+01_JPRB, 0.242916E+01_JPRB, 0.248878E+01_JPRB &
  &, 0.254866E+01_JPRB, 0.260878E+01_JPRB, 0.266911E+01_JPRB &
  &, 0.272962E+01_JPRB, 0.279031E+01_JPRB, 0.285113E+01_JPRB, 0.291208E+01_JPRB &
  &, 0.297313E+01_JPRB, 0.303426E+01_JPRB, 0.309544E+01_JPRB &
  &, 0.315665E+01_JPRB, 0.321788E+01_JPRB, 0.327909E+01_JPRB, 0.334027E+01_JPRB &
  &, 0.340141E+01_JPRB, 0.346248E+01_JPRB, 0.352345E+01_JPRB &
  &, 0.358432E+01_JPRB, 0.364505E+01_JPRB, 0.370564E+01_JPRB, 0.376607E+01_JPRB &
  &, 0.382631E+01_JPRB, 0.388634E+01_JPRB, 0.394616E+01_JPRB &
  &, 0.400574E+01_JPRB, 0.406507E+01_JPRB, 0.412412E+01_JPRB, 0.418290E+01_JPRB &
  &, 0.424138E+01_JPRB, 0.429952E+01_JPRB, 0.435735E+01_JPRB &
  &, 0.441484E+01_JPRB, 0.447196E+01_JPRB, 0.452870E+01_JPRB, 0.458505E+01_JPRB &
  &, 0.464102E+01_JPRB, 0.469658E+01_JPRB, 0.475170E+01_JPRB &
  &, 0.480638E+01_JPRB, 0.486063E+01_JPRB, 0.491441E+01_JPRB, 0.496771E+01_JPRB &
  &, 0.502055E+01_JPRB, 0.507290E+01_JPRB, 0.512473E+01_JPRB &
  &, 0.517607E+01_JPRB, 0.522688E+01_JPRB, 0.527716E+01_JPRB, 0.532690E+01_JPRB &
  &, 0.537610E+01_JPRB, 0.542438E+01_JPRB, 0.547281E+01_JPRB &
  &, 0.552032E+01_JPRB, 0.556727E+01_JPRB, 0.561362E+01_JPRB, 0.565938E+01_JPRB &
  &, 0.570454E+01_JPRB, 0.574910E+01_JPRB, 0.579307E+01_JPRB &
  &, 0.583641E+01_JPRB, 0.587912E+01_JPRB, 0.592111E+01_JPRB, 0.596257E+01_JPRB &
  &, 0.600348E+01_JPRB, 0.604368E+01_JPRB, 0.608300E+01_JPRB &
  &, 0.612214E+01_JPRB, 0.616038E+01_JPRB, 0.619783E+01_JPRB, 0.623489E+01_JPRB &
  &, 0.627092E+01_JPRB, 0.630677E+01_JPRB, 0.634171E+01_JPRB &
  &, 0.637596E+01_JPRB, 0.640956E+01_JPRB, 0.644249E+01_JPRB, 0.647471E+01_JPRB &
  &, 0.650625E+01_JPRB, 0.653718E+01_JPRB, 0.656733E+01_JPRB &
  &, 0.659687E+01_JPRB, 0.662569E+01_JPRB, 0.665382E+01_JPRB, 0.668100E+01_JPRB &
  &, 0.670805E+01_JPRB, 0.673416E+01_JPRB, 0.675954E+01_JPRB &
  &, 0.678428E+01_JPRB, 0.680830E+01_JPRB, 0.683161E+01_JPRB, 0.685408E+01_JPRB &
  &, 0.687619E+01_JPRB, 0.689709E+01_JPRB, 0.691805E+01_JPRB &
  &, 0.693796E+01_JPRB, 0.695718E+01_JPRB, 0.697570E+01_JPRB, 0.699355E+01_JPRB &
  &, 0.701073E+01_JPRB, 0.702721E+01_JPRB, 0.704299E+01_JPRB &
  &, 0.705814E+01_JPRB, 0.707262E+01_JPRB, 0.708643E+01_JPRB, 0.709955E+01_JPRB &
  &, 0.711198E+01_JPRB, 0.712378E+01_JPRB, 0.713491E+01_JPRB &
  &, 0.714534E+01_JPRB, 0.715512E+01_JPRB, 0.716433E+01_JPRB, 0.717281E+01_JPRB &
  &, 0.718056E+01_JPRB, 0.718780E+01_JPRB, 0.719433E+01_JPRB/)
XCW( 961, :) = (/ &
  &  0.118301E+01_JPRB, 0.123082E+01_JPRB, 0.127941E+01_JPRB, 0.132876E+01_JPRB &
  &, 0.137886E+01_JPRB, 0.142968E+01_JPRB, 0.148120E+01_JPRB &
  &, 0.153340E+01_JPRB, 0.158626E+01_JPRB, 0.163976E+01_JPRB, 0.169388E+01_JPRB &
  &, 0.174859E+01_JPRB, 0.180388E+01_JPRB, 0.185971E+01_JPRB &
  &, 0.191608E+01_JPRB, 0.197295E+01_JPRB, 0.203030E+01_JPRB, 0.208811E+01_JPRB &
  &, 0.214636E+01_JPRB, 0.220503E+01_JPRB, 0.226408E+01_JPRB &
  &, 0.232350E+01_JPRB, 0.238327E+01_JPRB, 0.244335E+01_JPRB, 0.250374E+01_JPRB &
  &, 0.256440E+01_JPRB, 0.262531E+01_JPRB, 0.268645E+01_JPRB &
  &, 0.274779E+01_JPRB, 0.280931E+01_JPRB, 0.287100E+01_JPRB, 0.293282E+01_JPRB &
  &, 0.299475E+01_JPRB, 0.305678E+01_JPRB, 0.311887E+01_JPRB &
  &, 0.318102E+01_JPRB, 0.324319E+01_JPRB, 0.330537E+01_JPRB, 0.336753E+01_JPRB &
  &, 0.342964E+01_JPRB, 0.349172E+01_JPRB, 0.355371E+01_JPRB &
  &, 0.361561E+01_JPRB, 0.367739E+01_JPRB, 0.373904E+01_JPRB, 0.380054E+01_JPRB &
  &, 0.386186E+01_JPRB, 0.392299E+01_JPRB, 0.398392E+01_JPRB &
  &, 0.404462E+01_JPRB, 0.410508E+01_JPRB, 0.416529E+01_JPRB, 0.422522E+01_JPRB &
  &, 0.428486E+01_JPRB, 0.434420E+01_JPRB, 0.440321E+01_JPRB &
  &, 0.446190E+01_JPRB, 0.452023E+01_JPRB, 0.457820E+01_JPRB, 0.463581E+01_JPRB &
  &, 0.469301E+01_JPRB, 0.474982E+01_JPRB, 0.480621E+01_JPRB &
  &, 0.486216E+01_JPRB, 0.491769E+01_JPRB, 0.497278E+01_JPRB, 0.502740E+01_JPRB &
  &, 0.508153E+01_JPRB, 0.513519E+01_JPRB, 0.518837E+01_JPRB &
  &, 0.524104E+01_JPRB, 0.529320E+01_JPRB, 0.534482E+01_JPRB, 0.539594E+01_JPRB &
  &, 0.544650E+01_JPRB, 0.549651E+01_JPRB, 0.554598E+01_JPRB &
  &, 0.559489E+01_JPRB, 0.564323E+01_JPRB, 0.569099E+01_JPRB, 0.573816E+01_JPRB &
  &, 0.578473E+01_JPRB, 0.583071E+01_JPRB, 0.587611E+01_JPRB &
  &, 0.592087E+01_JPRB, 0.596501E+01_JPRB, 0.600856E+01_JPRB, 0.605148E+01_JPRB &
  &, 0.609376E+01_JPRB, 0.613540E+01_JPRB, 0.617640E+01_JPRB &
  &, 0.621676E+01_JPRB, 0.625647E+01_JPRB, 0.629554E+01_JPRB, 0.633392E+01_JPRB &
  &, 0.637163E+01_JPRB, 0.640876E+01_JPRB, 0.644518E+01_JPRB &
  &, 0.648092E+01_JPRB, 0.651595E+01_JPRB, 0.655042E+01_JPRB, 0.658416E+01_JPRB &
  &, 0.661719E+01_JPRB, 0.664957E+01_JPRB, 0.668126E+01_JPRB &
  &, 0.671222E+01_JPRB, 0.674258E+01_JPRB, 0.677223E+01_JPRB, 0.680121E+01_JPRB &
  &, 0.682946E+01_JPRB, 0.685705E+01_JPRB, 0.688395E+01_JPRB &
  &, 0.691014E+01_JPRB, 0.693565E+01_JPRB, 0.695976E+01_JPRB, 0.698457E+01_JPRB &
  &, 0.700804E+01_JPRB, 0.703078E+01_JPRB, 0.705285E+01_JPRB &
  &, 0.707427E+01_JPRB, 0.709494E+01_JPRB, 0.711492E+01_JPRB, 0.713428E+01_JPRB &
  &, 0.715291E+01_JPRB, 0.717084E+01_JPRB, 0.718813E+01_JPRB &
  &, 0.720474E+01_JPRB, 0.722067E+01_JPRB, 0.723594E+01_JPRB, 0.725045E+01_JPRB &
  &, 0.726438E+01_JPRB, 0.727763E+01_JPRB, 0.729015E+01_JPRB &
  &, 0.730201E+01_JPRB, 0.731323E+01_JPRB, 0.732382E+01_JPRB, 0.733367E+01_JPRB &
  &, 0.734292E+01_JPRB, 0.735151E+01_JPRB, 0.735939E+01_JPRB/)
XCW( 962, :) = (/ &
  &  0.118435E+01_JPRB, 0.123254E+01_JPRB, 0.128153E+01_JPRB, 0.133130E+01_JPRB &
  &, 0.138182E+01_JPRB, 0.143309E+01_JPRB, 0.148508E+01_JPRB &
  &, 0.153777E+01_JPRB, 0.159114E+01_JPRB, 0.164516E+01_JPRB, 0.169982E+01_JPRB &
  &, 0.175509E+01_JPRB, 0.181095E+01_JPRB, 0.186738E+01_JPRB &
  &, 0.192435E+01_JPRB, 0.198185E+01_JPRB, 0.203985E+01_JPRB, 0.209832E+01_JPRB &
  &, 0.215725E+01_JPRB, 0.221662E+01_JPRB, 0.227638E+01_JPRB &
  &, 0.233654E+01_JPRB, 0.239705E+01_JPRB, 0.245790E+01_JPRB, 0.251907E+01_JPRB &
  &, 0.258053E+01_JPRB, 0.264225E+01_JPRB, 0.270422E+01_JPRB &
  &, 0.276641E+01_JPRB, 0.282880E+01_JPRB, 0.289136E+01_JPRB, 0.295408E+01_JPRB &
  &, 0.301692E+01_JPRB, 0.307988E+01_JPRB, 0.314292E+01_JPRB &
  &, 0.320602E+01_JPRB, 0.326916E+01_JPRB, 0.333233E+01_JPRB, 0.339549E+01_JPRB &
  &, 0.345863E+01_JPRB, 0.352173E+01_JPRB, 0.358478E+01_JPRB &
  &, 0.364774E+01_JPRB, 0.371059E+01_JPRB, 0.377333E+01_JPRB, 0.383588E+01_JPRB &
  &, 0.389837E+01_JPRB, 0.396062E+01_JPRB, 0.402270E+01_JPRB &
  &, 0.408455E+01_JPRB, 0.414618E+01_JPRB, 0.420757E+01_JPRB, 0.426869E+01_JPRB &
  &, 0.432953E+01_JPRB, 0.439009E+01_JPRB, 0.445033E+01_JPRB &
  &, 0.451025E+01_JPRB, 0.456985E+01_JPRB, 0.462908E+01_JPRB, 0.468795E+01_JPRB &
  &, 0.474643E+01_JPRB, 0.480454E+01_JPRB, 0.486223E+01_JPRB &
  &, 0.491952E+01_JPRB, 0.497638E+01_JPRB, 0.503278E+01_JPRB, 0.508875E+01_JPRB &
  &, 0.514425E+01_JPRB, 0.519926E+01_JPRB, 0.525381E+01_JPRB &
  &, 0.530787E+01_JPRB, 0.536141E+01_JPRB, 0.541444E+01_JPRB, 0.546696E+01_JPRB &
  &, 0.551893E+01_JPRB, 0.557038E+01_JPRB, 0.562127E+01_JPRB &
  &, 0.567163E+01_JPRB, 0.572140E+01_JPRB, 0.577060E+01_JPRB, 0.581922E+01_JPRB &
  &, 0.586727E+01_JPRB, 0.591473E+01_JPRB, 0.596158E+01_JPRB &
  &, 0.600784E+01_JPRB, 0.605349E+01_JPRB, 0.609852E+01_JPRB, 0.614291E+01_JPRB &
  &, 0.618671E+01_JPRB, 0.622984E+01_JPRB, 0.627238E+01_JPRB &
  &, 0.631426E+01_JPRB, 0.635543E+01_JPRB, 0.639607E+01_JPRB, 0.643600E+01_JPRB &
  &, 0.647526E+01_JPRB, 0.651382E+01_JPRB, 0.655185E+01_JPRB &
  &, 0.658885E+01_JPRB, 0.662576E+01_JPRB, 0.666169E+01_JPRB, 0.669696E+01_JPRB &
  &, 0.673157E+01_JPRB, 0.676550E+01_JPRB, 0.679874E+01_JPRB &
  &, 0.683130E+01_JPRB, 0.686315E+01_JPRB, 0.689437E+01_JPRB, 0.692485E+01_JPRB &
  &, 0.695471E+01_JPRB, 0.698380E+01_JPRB, 0.701221E+01_JPRB &
  &, 0.704004E+01_JPRB, 0.706711E+01_JPRB, 0.709347E+01_JPRB, 0.711914E+01_JPRB &
  &, 0.714413E+01_JPRB, 0.716843E+01_JPRB, 0.719051E+01_JPRB &
  &, 0.721481E+01_JPRB, 0.723721E+01_JPRB, 0.725876E+01_JPRB, 0.727964E+01_JPRB &
  &, 0.729980E+01_JPRB, 0.731925E+01_JPRB, 0.733807E+01_JPRB &
  &, 0.735619E+01_JPRB, 0.737365E+01_JPRB, 0.738953E+01_JPRB, 0.740647E+01_JPRB &
  &, 0.742192E+01_JPRB, 0.743662E+01_JPRB, 0.745066E+01_JPRB &
  &, 0.746403E+01_JPRB, 0.747676E+01_JPRB, 0.748880E+01_JPRB, 0.750022E+01_JPRB &
  &, 0.751064E+01_JPRB, 0.752086E+01_JPRB, 0.753038E+01_JPRB/)
XCW( 963, :) = (/ &
  &  0.118572E+01_JPRB, 0.123430E+01_JPRB, 0.128369E+01_JPRB, 0.133388E+01_JPRB &
  &, 0.138486E+01_JPRB, 0.143659E+01_JPRB, 0.148906E+01_JPRB &
  &, 0.154224E+01_JPRB, 0.159613E+01_JPRB, 0.165069E+01_JPRB, 0.170590E+01_JPRB &
  &, 0.176174E+01_JPRB, 0.181819E+01_JPRB, 0.187523E+01_JPRB &
  &, 0.193283E+01_JPRB, 0.199097E+01_JPRB, 0.204963E+01_JPRB, 0.210879E+01_JPRB &
  &, 0.216842E+01_JPRB, 0.222849E+01_JPRB, 0.228900E+01_JPRB &
  &, 0.234990E+01_JPRB, 0.241118E+01_JPRB, 0.247282E+01_JPRB, 0.253479E+01_JPRB &
  &, 0.259707E+01_JPRB, 0.265963E+01_JPRB, 0.272246E+01_JPRB &
  &, 0.278552E+01_JPRB, 0.284880E+01_JPRB, 0.291227E+01_JPRB, 0.297590E+01_JPRB &
  &, 0.303968E+01_JPRB, 0.310359E+01_JPRB, 0.316760E+01_JPRB &
  &, 0.323169E+01_JPRB, 0.329583E+01_JPRB, 0.336001E+01_JPRB, 0.342421E+01_JPRB &
  &, 0.348840E+01_JPRB, 0.355257E+01_JPRB, 0.361669E+01_JPRB &
  &, 0.368073E+01_JPRB, 0.374470E+01_JPRB, 0.380855E+01_JPRB, 0.387228E+01_JPRB &
  &, 0.393587E+01_JPRB, 0.399929E+01_JPRB, 0.406254E+01_JPRB &
  &, 0.412558E+01_JPRB, 0.418842E+01_JPRB, 0.425101E+01_JPRB, 0.431336E+01_JPRB &
  &, 0.437545E+01_JPRB, 0.443727E+01_JPRB, 0.449877E+01_JPRB &
  &, 0.455998E+01_JPRB, 0.462086E+01_JPRB, 0.468139E+01_JPRB, 0.474158E+01_JPRB &
  &, 0.480140E+01_JPRB, 0.486084E+01_JPRB, 0.491988E+01_JPRB &
  &, 0.497852E+01_JPRB, 0.503674E+01_JPRB, 0.509452E+01_JPRB, 0.515188E+01_JPRB &
  &, 0.520877E+01_JPRB, 0.526521E+01_JPRB, 0.532117E+01_JPRB &
  &, 0.537666E+01_JPRB, 0.543163E+01_JPRB, 0.548610E+01_JPRB, 0.554008E+01_JPRB &
  &, 0.559352E+01_JPRB, 0.564644E+01_JPRB, 0.569881E+01_JPRB &
  &, 0.575063E+01_JPRB, 0.580190E+01_JPRB, 0.585262E+01_JPRB, 0.590275E+01_JPRB &
  &, 0.595230E+01_JPRB, 0.600128E+01_JPRB, 0.604966E+01_JPRB &
  &, 0.609745E+01_JPRB, 0.614463E+01_JPRB, 0.619120E+01_JPRB, 0.623717E+01_JPRB &
  &, 0.628250E+01_JPRB, 0.632722E+01_JPRB, 0.637132E+01_JPRB &
  &, 0.641470E+01_JPRB, 0.645755E+01_JPRB, 0.649971E+01_JPRB, 0.654121E+01_JPRB &
  &, 0.658209E+01_JPRB, 0.662227E+01_JPRB, 0.666182E+01_JPRB &
  &, 0.670072E+01_JPRB, 0.673892E+01_JPRB, 0.677533E+01_JPRB, 0.681322E+01_JPRB &
  &, 0.684959E+01_JPRB, 0.688508E+01_JPRB, 0.691994E+01_JPRB &
  &, 0.695412E+01_JPRB, 0.698760E+01_JPRB, 0.702041E+01_JPRB, 0.705253E+01_JPRB &
  &, 0.708395E+01_JPRB, 0.711474E+01_JPRB, 0.714480E+01_JPRB &
  &, 0.717415E+01_JPRB, 0.720284E+01_JPRB, 0.723083E+01_JPRB, 0.725813E+01_JPRB &
  &, 0.728475E+01_JPRB, 0.731064E+01_JPRB, 0.733587E+01_JPRB &
  &, 0.736039E+01_JPRB, 0.738407E+01_JPRB, 0.740742E+01_JPRB, 0.742990E+01_JPRB &
  &, 0.745165E+01_JPRB, 0.747275E+01_JPRB, 0.749311E+01_JPRB &
  &, 0.751239E+01_JPRB, 0.753188E+01_JPRB, 0.755021E+01_JPRB, 0.756783E+01_JPRB &
  &, 0.758487E+01_JPRB, 0.760117E+01_JPRB, 0.761673E+01_JPRB &
  &, 0.763170E+01_JPRB, 0.764596E+01_JPRB, 0.765958E+01_JPRB, 0.767245E+01_JPRB &
  &, 0.768477E+01_JPRB, 0.769638E+01_JPRB, 0.770727E+01_JPRB/)
XCW( 964, :) = (/ &
  &  0.118712E+01_JPRB, 0.123610E+01_JPRB, 0.128591E+01_JPRB, 0.133653E+01_JPRB &
  &, 0.138796E+01_JPRB, 0.144017E+01_JPRB, 0.149313E+01_JPRB &
  &, 0.154683E+01_JPRB, 0.160124E+01_JPRB, 0.165635E+01_JPRB, 0.171213E+01_JPRB &
  &, 0.176855E+01_JPRB, 0.182561E+01_JPRB, 0.188327E+01_JPRB &
  &, 0.194152E+01_JPRB, 0.200032E+01_JPRB, 0.205966E+01_JPRB, 0.211952E+01_JPRB &
  &, 0.217987E+01_JPRB, 0.224068E+01_JPRB, 0.230193E+01_JPRB &
  &, 0.236361E+01_JPRB, 0.242569E+01_JPRB, 0.248813E+01_JPRB, 0.255093E+01_JPRB &
  &, 0.261405E+01_JPRB, 0.267747E+01_JPRB, 0.274118E+01_JPRB &
  &, 0.280514E+01_JPRB, 0.286933E+01_JPRB, 0.293373E+01_JPRB, 0.299831E+01_JPRB &
  &, 0.306306E+01_JPRB, 0.312795E+01_JPRB, 0.319295E+01_JPRB &
  &, 0.325806E+01_JPRB, 0.332323E+01_JPRB, 0.338846E+01_JPRB, 0.345372E+01_JPRB &
  &, 0.351899E+01_JPRB, 0.358425E+01_JPRB, 0.364947E+01_JPRB &
  &, 0.371464E+01_JPRB, 0.377975E+01_JPRB, 0.384476E+01_JPRB, 0.390965E+01_JPRB &
  &, 0.397443E+01_JPRB, 0.403906E+01_JPRB, 0.410351E+01_JPRB &
  &, 0.416778E+01_JPRB, 0.423186E+01_JPRB, 0.429571E+01_JPRB, 0.435933E+01_JPRB &
  &, 0.442271E+01_JPRB, 0.448581E+01_JPRB, 0.454862E+01_JPRB &
  &, 0.461114E+01_JPRB, 0.467335E+01_JPRB, 0.473524E+01_JPRB, 0.479678E+01_JPRB &
  &, 0.485796E+01_JPRB, 0.491878E+01_JPRB, 0.497922E+01_JPRB &
  &, 0.503926E+01_JPRB, 0.509890E+01_JPRB, 0.515811E+01_JPRB, 0.521689E+01_JPRB &
  &, 0.527523E+01_JPRB, 0.533312E+01_JPRB, 0.539055E+01_JPRB &
  &, 0.544749E+01_JPRB, 0.550398E+01_JPRB, 0.555994E+01_JPRB, 0.561541E+01_JPRB &
  &, 0.567037E+01_JPRB, 0.572479E+01_JPRB, 0.577870E+01_JPRB &
  &, 0.583205E+01_JPRB, 0.588488E+01_JPRB, 0.593715E+01_JPRB, 0.598883E+01_JPRB &
  &, 0.603996E+01_JPRB, 0.609050E+01_JPRB, 0.614046E+01_JPRB &
  &, 0.618985E+01_JPRB, 0.623863E+01_JPRB, 0.628680E+01_JPRB, 0.633435E+01_JPRB &
  &, 0.638130E+01_JPRB, 0.642765E+01_JPRB, 0.647336E+01_JPRB &
  &, 0.651843E+01_JPRB, 0.656237E+01_JPRB, 0.660664E+01_JPRB, 0.664980E+01_JPRB &
  &, 0.669234E+01_JPRB, 0.673417E+01_JPRB, 0.677538E+01_JPRB &
  &, 0.681581E+01_JPRB, 0.685579E+01_JPRB, 0.689503E+01_JPRB, 0.693355E+01_JPRB &
  &, 0.697143E+01_JPRB, 0.700863E+01_JPRB, 0.704517E+01_JPRB &
  &, 0.708100E+01_JPRB, 0.711617E+01_JPRB, 0.715068E+01_JPRB, 0.718446E+01_JPRB &
  &, 0.721756E+01_JPRB, 0.724998E+01_JPRB, 0.728172E+01_JPRB &
  &, 0.731280E+01_JPRB, 0.734318E+01_JPRB, 0.737287E+01_JPRB, 0.740182E+01_JPRB &
  &, 0.743013E+01_JPRB, 0.745773E+01_JPRB, 0.748462E+01_JPRB &
  &, 0.751081E+01_JPRB, 0.753636E+01_JPRB, 0.756117E+01_JPRB, 0.758531E+01_JPRB &
  &, 0.760873E+01_JPRB, 0.763151E+01_JPRB, 0.765353E+01_JPRB &
  &, 0.767492E+01_JPRB, 0.769553E+01_JPRB, 0.771565E+01_JPRB, 0.773494E+01_JPRB &
  &, 0.775354E+01_JPRB, 0.777150E+01_JPRB, 0.778874E+01_JPRB &
  &, 0.780531E+01_JPRB, 0.782124E+01_JPRB, 0.783646E+01_JPRB, 0.785100E+01_JPRB &
  &, 0.786486E+01_JPRB, 0.787812E+01_JPRB, 0.789060E+01_JPRB/)
XCW( 965, :) = (/ &
  &  0.118856E+01_JPRB, 0.123794E+01_JPRB, 0.128817E+01_JPRB, 0.133925E+01_JPRB &
  &, 0.139114E+01_JPRB, 0.144383E+01_JPRB, 0.149730E+01_JPRB &
  &, 0.155152E+01_JPRB, 0.160648E+01_JPRB, 0.166215E+01_JPRB, 0.171851E+01_JPRB &
  &, 0.177554E+01_JPRB, 0.183322E+01_JPRB, 0.189153E+01_JPRB &
  &, 0.195043E+01_JPRB, 0.200992E+01_JPRB, 0.206996E+01_JPRB, 0.213053E+01_JPRB &
  &, 0.219162E+01_JPRB, 0.225319E+01_JPRB, 0.231522E+01_JPRB &
  &, 0.237769E+01_JPRB, 0.244058E+01_JPRB, 0.250385E+01_JPRB, 0.256750E+01_JPRB &
  &, 0.263149E+01_JPRB, 0.269580E+01_JPRB, 0.276041E+01_JPRB &
  &, 0.282529E+01_JPRB, 0.289042E+01_JPRB, 0.295578E+01_JPRB, 0.302134E+01_JPRB &
  &, 0.308708E+01_JPRB, 0.315298E+01_JPRB, 0.321902E+01_JPRB &
  &, 0.328516E+01_JPRB, 0.335140E+01_JPRB, 0.341771E+01_JPRB, 0.348407E+01_JPRB &
  &, 0.355044E+01_JPRB, 0.361683E+01_JPRB, 0.368320E+01_JPRB &
  &, 0.374954E+01_JPRB, 0.381581E+01_JPRB, 0.388201E+01_JPRB, 0.394812E+01_JPRB &
  &, 0.401412E+01_JPRB, 0.407997E+01_JPRB, 0.414568E+01_JPRB &
  &, 0.421122E+01_JPRB, 0.427657E+01_JPRB, 0.434172E+01_JPRB, 0.440666E+01_JPRB &
  &, 0.447134E+01_JPRB, 0.453578E+01_JPRB, 0.459995E+01_JPRB &
  &, 0.466383E+01_JPRB, 0.472741E+01_JPRB, 0.479070E+01_JPRB, 0.485363E+01_JPRB &
  &, 0.491622E+01_JPRB, 0.497847E+01_JPRB, 0.504034E+01_JPRB &
  &, 0.510184E+01_JPRB, 0.516293E+01_JPRB, 0.522362E+01_JPRB, 0.528388E+01_JPRB &
  &, 0.534371E+01_JPRB, 0.540312E+01_JPRB, 0.546206E+01_JPRB &
  &, 0.552054E+01_JPRB, 0.557854E+01_JPRB, 0.563589E+01_JPRB, 0.569309E+01_JPRB &
  &, 0.574960E+01_JPRB, 0.580560E+01_JPRB, 0.586110E+01_JPRB &
  &, 0.591604E+01_JPRB, 0.597047E+01_JPRB, 0.602433E+01_JPRB, 0.607763E+01_JPRB &
  &, 0.613038E+01_JPRB, 0.618257E+01_JPRB, 0.623419E+01_JPRB &
  &, 0.628520E+01_JPRB, 0.633562E+01_JPRB, 0.638547E+01_JPRB, 0.643468E+01_JPRB &
  &, 0.648331E+01_JPRB, 0.653132E+01_JPRB, 0.657870E+01_JPRB &
  &, 0.662549E+01_JPRB, 0.667161E+01_JPRB, 0.671710E+01_JPRB, 0.676196E+01_JPRB &
  &, 0.680617E+01_JPRB, 0.684974E+01_JPRB, 0.689268E+01_JPRB &
  &, 0.693493E+01_JPRB, 0.697652E+01_JPRB, 0.701751E+01_JPRB, 0.705764E+01_JPRB &
  &, 0.709736E+01_JPRB, 0.713634E+01_JPRB, 0.717451E+01_JPRB &
  &, 0.721217E+01_JPRB, 0.724907E+01_JPRB, 0.728531E+01_JPRB, 0.732087E+01_JPRB &
  &, 0.735575E+01_JPRB, 0.738992E+01_JPRB, 0.742337E+01_JPRB &
  &, 0.745621E+01_JPRB, 0.748831E+01_JPRB, 0.751976E+01_JPRB, 0.755048E+01_JPRB &
  &, 0.758053E+01_JPRB, 0.760986E+01_JPRB, 0.763854E+01_JPRB &
  &, 0.766651E+01_JPRB, 0.769375E+01_JPRB, 0.772036E+01_JPRB, 0.774625E+01_JPRB &
  &, 0.777121E+01_JPRB, 0.779594E+01_JPRB, 0.781972E+01_JPRB &
  &, 0.784281E+01_JPRB, 0.786523E+01_JPRB, 0.788698E+01_JPRB, 0.790803E+01_JPRB &
  &, 0.792838E+01_JPRB, 0.794805E+01_JPRB, 0.796692E+01_JPRB &
  &, 0.798530E+01_JPRB, 0.800292E+01_JPRB, 0.801964E+01_JPRB, 0.803612E+01_JPRB &
  &, 0.805160E+01_JPRB, 0.806654E+01_JPRB, 0.808084E+01_JPRB/)
XCW( 966, :) = (/ &
  &  0.119003E+01_JPRB, 0.123982E+01_JPRB, 0.129050E+01_JPRB, 0.134203E+01_JPRB &
  &, 0.139440E+01_JPRB, 0.144759E+01_JPRB, 0.150158E+01_JPRB &
  &, 0.155634E+01_JPRB, 0.161186E+01_JPRB, 0.166811E+01_JPRB, 0.172507E+01_JPRB &
  &, 0.178272E+01_JPRB, 0.184104E+01_JPRB, 0.190000E+01_JPRB &
  &, 0.195959E+01_JPRB, 0.201977E+01_JPRB, 0.208053E+01_JPRB, 0.214185E+01_JPRB &
  &, 0.220369E+01_JPRB, 0.226604E+01_JPRB, 0.232887E+01_JPRB &
  &, 0.239216E+01_JPRB, 0.245588E+01_JPRB, 0.252002E+01_JPRB, 0.258454E+01_JPRB &
  &, 0.264942E+01_JPRB, 0.271464E+01_JPRB, 0.278019E+01_JPRB &
  &, 0.284602E+01_JPRB, 0.291212E+01_JPRB, 0.297846E+01_JPRB, 0.304503E+01_JPRB &
  &, 0.311180E+01_JPRB, 0.317874E+01_JPRB, 0.324583E+01_JPRB &
  &, 0.331306E+01_JPRB, 0.338039E+01_JPRB, 0.344781E+01_JPRB, 0.351530E+01_JPRB &
  &, 0.358282E+01_JPRB, 0.365037E+01_JPRB, 0.371792E+01_JPRB &
  &, 0.378545E+01_JPRB, 0.385295E+01_JPRB, 0.392037E+01_JPRB, 0.398772E+01_JPRB &
  &, 0.405498E+01_JPRB, 0.412211E+01_JPRB, 0.418911E+01_JPRB &
  &, 0.425596E+01_JPRB, 0.432264E+01_JPRB, 0.438912E+01_JPRB, 0.445541E+01_JPRB &
  &, 0.452145E+01_JPRB, 0.458728E+01_JPRB, 0.465285E+01_JPRB &
  &, 0.471813E+01_JPRB, 0.478314E+01_JPRB, 0.484785E+01_JPRB, 0.491223E+01_JPRB &
  &, 0.497630E+01_JPRB, 0.504001E+01_JPRB, 0.510337E+01_JPRB &
  &, 0.516635E+01_JPRB, 0.522896E+01_JPRB, 0.529119E+01_JPRB, 0.535297E+01_JPRB &
  &, 0.541437E+01_JPRB, 0.547532E+01_JPRB, 0.553583E+01_JPRB &
  &, 0.559589E+01_JPRB, 0.565548E+01_JPRB, 0.571459E+01_JPRB, 0.577324E+01_JPRB &
  &, 0.583136E+01_JPRB, 0.588900E+01_JPRB, 0.594612E+01_JPRB &
  &, 0.600274E+01_JPRB, 0.605881E+01_JPRB, 0.611434E+01_JPRB, 0.616933E+01_JPRB &
  &, 0.622377E+01_JPRB, 0.627764E+01_JPRB, 0.633095E+01_JPRB &
  &, 0.638367E+01_JPRB, 0.643581E+01_JPRB, 0.648737E+01_JPRB, 0.653833E+01_JPRB &
  &, 0.658867E+01_JPRB, 0.663844E+01_JPRB, 0.668756E+01_JPRB &
  &, 0.673610E+01_JPRB, 0.678398E+01_JPRB, 0.683125E+01_JPRB, 0.687685E+01_JPRB &
  &, 0.692387E+01_JPRB, 0.696918E+01_JPRB, 0.701394E+01_JPRB &
  &, 0.705800E+01_JPRB, 0.710140E+01_JPRB, 0.714409E+01_JPRB, 0.718620E+01_JPRB &
  &, 0.722762E+01_JPRB, 0.726837E+01_JPRB, 0.730848E+01_JPRB &
  &, 0.734785E+01_JPRB, 0.738658E+01_JPRB, 0.742463E+01_JPRB, 0.746200E+01_JPRB &
  &, 0.749869E+01_JPRB, 0.753468E+01_JPRB, 0.757001E+01_JPRB &
  &, 0.760464E+01_JPRB, 0.763858E+01_JPRB, 0.767188E+01_JPRB, 0.770441E+01_JPRB &
  &, 0.773631E+01_JPRB, 0.776746E+01_JPRB, 0.779795E+01_JPRB &
  &, 0.782775E+01_JPRB, 0.785681E+01_JPRB, 0.788524E+01_JPRB, 0.791296E+01_JPRB &
  &, 0.793997E+01_JPRB, 0.796627E+01_JPRB, 0.799194E+01_JPRB &
  &, 0.801681E+01_JPRB, 0.804107E+01_JPRB, 0.806461E+01_JPRB, 0.808750E+01_JPRB &
  &, 0.810952E+01_JPRB, 0.813108E+01_JPRB, 0.815186E+01_JPRB &
  &, 0.817197E+01_JPRB, 0.819143E+01_JPRB, 0.821012E+01_JPRB, 0.822812E+01_JPRB &
  &, 0.824545E+01_JPRB, 0.826217E+01_JPRB, 0.827817E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART138',1,ZHOOK_HANDLE)
END SUBROUTINE PART138

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART139

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART139',0,ZHOOK_HANDLE)

XCW( 967, :) = (/ &
  &  0.119153E+01_JPRB, 0.124176E+01_JPRB, 0.129288E+01_JPRB, 0.134489E+01_JPRB &
  &, 0.139775E+01_JPRB, 0.145145E+01_JPRB, 0.150597E+01_JPRB &
  &, 0.156128E+01_JPRB, 0.161738E+01_JPRB, 0.167422E+01_JPRB, 0.173180E+01_JPRB &
  &, 0.179009E+01_JPRB, 0.184906E+01_JPRB, 0.190871E+01_JPRB &
  &, 0.196899E+01_JPRB, 0.202990E+01_JPRB, 0.209140E+01_JPRB, 0.215347E+01_JPRB &
  &, 0.221610E+01_JPRB, 0.227925E+01_JPRB, 0.234290E+01_JPRB &
  &, 0.240703E+01_JPRB, 0.247162E+01_JPRB, 0.253664E+01_JPRB, 0.260206E+01_JPRB &
  &, 0.266787E+01_JPRB, 0.273403E+01_JPRB, 0.280053E+01_JPRB &
  &, 0.286735E+01_JPRB, 0.293445E+01_JPRB, 0.300181E+01_JPRB, 0.306942E+01_JPRB &
  &, 0.313724E+01_JPRB, 0.320526E+01_JPRB, 0.327344E+01_JPRB &
  &, 0.334178E+01_JPRB, 0.341024E+01_JPRB, 0.347882E+01_JPRB, 0.354746E+01_JPRB &
  &, 0.361617E+01_JPRB, 0.368493E+01_JPRB, 0.375369E+01_JPRB &
  &, 0.382246E+01_JPRB, 0.389120E+01_JPRB, 0.395990E+01_JPRB, 0.402854E+01_JPRB &
  &, 0.409709E+01_JPRB, 0.416555E+01_JPRB, 0.423389E+01_JPRB &
  &, 0.430208E+01_JPRB, 0.437012E+01_JPRB, 0.443800E+01_JPRB, 0.450567E+01_JPRB &
  &, 0.457314E+01_JPRB, 0.464039E+01_JPRB, 0.470739E+01_JPRB &
  &, 0.477414E+01_JPRB, 0.484062E+01_JPRB, 0.490681E+01_JPRB, 0.497271E+01_JPRB &
  &, 0.503827E+01_JPRB, 0.510351E+01_JPRB, 0.516842E+01_JPRB &
  &, 0.523295E+01_JPRB, 0.529713E+01_JPRB, 0.536091E+01_JPRB, 0.542430E+01_JPRB &
  &, 0.548730E+01_JPRB, 0.554986E+01_JPRB, 0.561200E+01_JPRB &
  &, 0.567368E+01_JPRB, 0.573493E+01_JPRB, 0.579570E+01_JPRB, 0.585601E+01_JPRB &
  &, 0.591584E+01_JPRB, 0.597516E+01_JPRB, 0.603398E+01_JPRB &
  &, 0.609230E+01_JPRB, 0.615010E+01_JPRB, 0.620734E+01_JPRB, 0.626409E+01_JPRB &
  &, 0.632027E+01_JPRB, 0.637590E+01_JPRB, 0.643096E+01_JPRB &
  &, 0.648545E+01_JPRB, 0.653938E+01_JPRB, 0.659274E+01_JPRB, 0.664546E+01_JPRB &
  &, 0.669764E+01_JPRB, 0.674919E+01_JPRB, 0.680015E+01_JPRB &
  &, 0.685050E+01_JPRB, 0.690022E+01_JPRB, 0.694933E+01_JPRB, 0.699779E+01_JPRB &
  &, 0.704564E+01_JPRB, 0.709284E+01_JPRB, 0.713939E+01_JPRB &
  &, 0.718532E+01_JPRB, 0.723060E+01_JPRB, 0.727516E+01_JPRB, 0.731917E+01_JPRB &
  &, 0.736246E+01_JPRB, 0.740511E+01_JPRB, 0.744707E+01_JPRB &
  &, 0.748835E+01_JPRB, 0.752891E+01_JPRB, 0.756892E+01_JPRB, 0.760822E+01_JPRB &
  &, 0.764682E+01_JPRB, 0.768471E+01_JPRB, 0.772195E+01_JPRB &
  &, 0.775850E+01_JPRB, 0.779432E+01_JPRB, 0.782950E+01_JPRB, 0.786392E+01_JPRB &
  &, 0.789758E+01_JPRB, 0.793081E+01_JPRB, 0.796321E+01_JPRB &
  &, 0.799457E+01_JPRB, 0.802594E+01_JPRB, 0.805624E+01_JPRB, 0.808588E+01_JPRB &
  &, 0.811475E+01_JPRB, 0.814303E+01_JPRB, 0.817046E+01_JPRB &
  &, 0.819694E+01_JPRB, 0.822351E+01_JPRB, 0.824898E+01_JPRB, 0.827369E+01_JPRB &
  &, 0.829777E+01_JPRB, 0.832116E+01_JPRB, 0.834381E+01_JPRB &
  &, 0.836580E+01_JPRB, 0.838707E+01_JPRB, 0.840771E+01_JPRB, 0.842759E+01_JPRB &
  &, 0.844678E+01_JPRB, 0.846531E+01_JPRB, 0.848319E+01_JPRB/)
XCW( 968, :) = (/ &
  &  0.119308E+01_JPRB, 0.124375E+01_JPRB, 0.129533E+01_JPRB, 0.134782E+01_JPRB &
  &, 0.140118E+01_JPRB, 0.145541E+01_JPRB, 0.151048E+01_JPRB &
  &, 0.156636E+01_JPRB, 0.162305E+01_JPRB, 0.168051E+01_JPRB, 0.173872E+01_JPRB &
  &, 0.179766E+01_JPRB, 0.185732E+01_JPRB, 0.191766E+01_JPRB &
  &, 0.197867E+01_JPRB, 0.204031E+01_JPRB, 0.210258E+01_JPRB, 0.216544E+01_JPRB &
  &, 0.222887E+01_JPRB, 0.229284E+01_JPRB, 0.235734E+01_JPRB &
  &, 0.242234E+01_JPRB, 0.248782E+01_JPRB, 0.255375E+01_JPRB, 0.262010E+01_JPRB &
  &, 0.268686E+01_JPRB, 0.275400E+01_JPRB, 0.282149E+01_JPRB &
  &, 0.288932E+01_JPRB, 0.295745E+01_JPRB, 0.302586E+01_JPRB, 0.309454E+01_JPRB &
  &, 0.316345E+01_JPRB, 0.323258E+01_JPRB, 0.330190E+01_JPRB &
  &, 0.337139E+01_JPRB, 0.344102E+01_JPRB, 0.351077E+01_JPRB, 0.358062E+01_JPRB &
  &, 0.365056E+01_JPRB, 0.372055E+01_JPRB, 0.379058E+01_JPRB &
  &, 0.386063E+01_JPRB, 0.393066E+01_JPRB, 0.400068E+01_JPRB, 0.407064E+01_JPRB &
  &, 0.414055E+01_JPRB, 0.421037E+01_JPRB, 0.428008E+01_JPRB &
  &, 0.434968E+01_JPRB, 0.441914E+01_JPRB, 0.448843E+01_JPRB, 0.455755E+01_JPRB &
  &, 0.462650E+01_JPRB, 0.469521E+01_JPRB, 0.476372E+01_JPRB &
  &, 0.483197E+01_JPRB, 0.489998E+01_JPRB, 0.496770E+01_JPRB, 0.503515E+01_JPRB &
  &, 0.510229E+01_JPRB, 0.516911E+01_JPRB, 0.523559E+01_JPRB &
  &, 0.530175E+01_JPRB, 0.536754E+01_JPRB, 0.543297E+01_JPRB, 0.549801E+01_JPRB &
  &, 0.556265E+01_JPRB, 0.562689E+01_JPRB, 0.569070E+01_JPRB &
  &, 0.575409E+01_JPRB, 0.581705E+01_JPRB, 0.587954E+01_JPRB, 0.594159E+01_JPRB &
  &, 0.600316E+01_JPRB, 0.606424E+01_JPRB, 0.612481E+01_JPRB &
  &, 0.618491E+01_JPRB, 0.624449E+01_JPRB, 0.630355E+01_JPRB, 0.636209E+01_JPRB &
  &, 0.642008E+01_JPRB, 0.647753E+01_JPRB, 0.653444E+01_JPRB &
  &, 0.659077E+01_JPRB, 0.664655E+01_JPRB, 0.670175E+01_JPRB, 0.675636E+01_JPRB &
  &, 0.681041E+01_JPRB, 0.686385E+01_JPRB, 0.691668E+01_JPRB &
  &, 0.696893E+01_JPRB, 0.702055E+01_JPRB, 0.707158E+01_JPRB, 0.712197E+01_JPRB &
  &, 0.717173E+01_JPRB, 0.722089E+01_JPRB, 0.726938E+01_JPRB &
  &, 0.731722E+01_JPRB, 0.736446E+01_JPRB, 0.741103E+01_JPRB, 0.745692E+01_JPRB &
  &, 0.750220E+01_JPRB, 0.754666E+01_JPRB, 0.759072E+01_JPRB &
  &, 0.763399E+01_JPRB, 0.767655E+01_JPRB, 0.771853E+01_JPRB, 0.775976E+01_JPRB &
  &, 0.780034E+01_JPRB, 0.784022E+01_JPRB, 0.787946E+01_JPRB &
  &, 0.791797E+01_JPRB, 0.795580E+01_JPRB, 0.799300E+01_JPRB, 0.802945E+01_JPRB &
  &, 0.806523E+01_JPRB, 0.810032E+01_JPRB, 0.813471E+01_JPRB &
  &, 0.816842E+01_JPRB, 0.820124E+01_JPRB, 0.823375E+01_JPRB, 0.826540E+01_JPRB &
  &, 0.829630E+01_JPRB, 0.832649E+01_JPRB, 0.835600E+01_JPRB &
  &, 0.838483E+01_JPRB, 0.841300E+01_JPRB, 0.844045E+01_JPRB, 0.846719E+01_JPRB &
  &, 0.849324E+01_JPRB, 0.851861E+01_JPRB, 0.854324E+01_JPRB &
  &, 0.856715E+01_JPRB, 0.859047E+01_JPRB, 0.861302E+01_JPRB, 0.863494E+01_JPRB &
  &, 0.865606E+01_JPRB, 0.867657E+01_JPRB, 0.869642E+01_JPRB/)
XCW( 969, :) = (/ &
  &  0.119467E+01_JPRB, 0.124579E+01_JPRB, 0.129785E+01_JPRB, 0.135083E+01_JPRB &
  &, 0.140472E+01_JPRB, 0.145948E+01_JPRB, 0.151512E+01_JPRB &
  &, 0.157159E+01_JPRB, 0.162888E+01_JPRB, 0.168697E+01_JPRB, 0.174584E+01_JPRB &
  &, 0.180546E+01_JPRB, 0.186581E+01_JPRB, 0.192687E+01_JPRB &
  &, 0.198862E+01_JPRB, 0.205104E+01_JPRB, 0.211409E+01_JPRB, 0.217776E+01_JPRB &
  &, 0.224202E+01_JPRB, 0.230685E+01_JPRB, 0.237222E+01_JPRB &
  &, 0.243812E+01_JPRB, 0.250451E+01_JPRB, 0.257138E+01_JPRB, 0.263870E+01_JPRB &
  &, 0.270644E+01_JPRB, 0.277458E+01_JPRB, 0.284310E+01_JPRB &
  &, 0.291196E+01_JPRB, 0.298116E+01_JPRB, 0.305067E+01_JPRB, 0.312045E+01_JPRB &
  &, 0.319049E+01_JPRB, 0.326077E+01_JPRB, 0.333125E+01_JPRB &
  &, 0.340192E+01_JPRB, 0.347276E+01_JPRB, 0.354374E+01_JPRB, 0.361485E+01_JPRB &
  &, 0.368604E+01_JPRB, 0.375732E+01_JPRB, 0.382866E+01_JPRB &
  &, 0.390002E+01_JPRB, 0.397140E+01_JPRB, 0.404277E+01_JPRB, 0.411411E+01_JPRB &
  &, 0.418541E+01_JPRB, 0.425665E+01_JPRB, 0.432780E+01_JPRB &
  &, 0.439885E+01_JPRB, 0.446976E+01_JPRB, 0.454054E+01_JPRB, 0.461116E+01_JPRB &
  &, 0.468161E+01_JPRB, 0.475186E+01_JPRB, 0.482191E+01_JPRB &
  &, 0.489173E+01_JPRB, 0.496131E+01_JPRB, 0.503064E+01_JPRB, 0.509969E+01_JPRB &
  &, 0.516844E+01_JPRB, 0.523690E+01_JPRB, 0.530506E+01_JPRB &
  &, 0.537288E+01_JPRB, 0.544034E+01_JPRB, 0.550747E+01_JPRB, 0.557422E+01_JPRB &
  &, 0.564059E+01_JPRB, 0.570657E+01_JPRB, 0.577214E+01_JPRB &
  &, 0.583729E+01_JPRB, 0.590202E+01_JPRB, 0.596630E+01_JPRB, 0.603013E+01_JPRB &
  &, 0.609352E+01_JPRB, 0.615642E+01_JPRB, 0.621885E+01_JPRB &
  &, 0.628077E+01_JPRB, 0.634221E+01_JPRB, 0.640313E+01_JPRB, 0.646355E+01_JPRB &
  &, 0.652344E+01_JPRB, 0.658279E+01_JPRB, 0.664159E+01_JPRB &
  &, 0.669984E+01_JPRB, 0.675755E+01_JPRB, 0.681469E+01_JPRB, 0.687124E+01_JPRB &
  &, 0.692724E+01_JPRB, 0.698264E+01_JPRB, 0.703745E+01_JPRB &
  &, 0.709166E+01_JPRB, 0.714530E+01_JPRB, 0.719829E+01_JPRB, 0.725066E+01_JPRB &
  &, 0.730245E+01_JPRB, 0.735358E+01_JPRB, 0.740411E+01_JPRB &
  &, 0.745374E+01_JPRB, 0.750324E+01_JPRB, 0.755182E+01_JPRB, 0.759978E+01_JPRB &
  &, 0.764711E+01_JPRB, 0.769374E+01_JPRB, 0.773974E+01_JPRB &
  &, 0.778505E+01_JPRB, 0.782970E+01_JPRB, 0.787373E+01_JPRB, 0.791703E+01_JPRB &
  &, 0.795968E+01_JPRB, 0.800165E+01_JPRB, 0.804293E+01_JPRB &
  &, 0.808359E+01_JPRB, 0.812352E+01_JPRB, 0.816275E+01_JPRB, 0.820122E+01_JPRB &
  &, 0.823918E+01_JPRB, 0.827636E+01_JPRB, 0.831284E+01_JPRB &
  &, 0.834865E+01_JPRB, 0.838378E+01_JPRB, 0.841820E+01_JPRB, 0.845186E+01_JPRB &
  &, 0.848487E+01_JPRB, 0.851724E+01_JPRB, 0.854882E+01_JPRB &
  &, 0.857973E+01_JPRB, 0.860997E+01_JPRB, 0.863956E+01_JPRB, 0.866833E+01_JPRB &
  &, 0.869647E+01_JPRB, 0.872351E+01_JPRB, 0.875065E+01_JPRB &
  &, 0.877670E+01_JPRB, 0.880205E+01_JPRB, 0.882669E+01_JPRB, 0.885065E+01_JPRB &
  &, 0.887385E+01_JPRB, 0.889645E+01_JPRB, 0.891833E+01_JPRB/)
XCW( 970, :) = (/ &
  &  0.119630E+01_JPRB, 0.124788E+01_JPRB, 0.130043E+01_JPRB, 0.135393E+01_JPRB &
  &, 0.140835E+01_JPRB, 0.146368E+01_JPRB, 0.151989E+01_JPRB &
  &, 0.157696E+01_JPRB, 0.163489E+01_JPRB, 0.169363E+01_JPRB, 0.175317E+01_JPRB &
  &, 0.181349E+01_JPRB, 0.187456E+01_JPRB, 0.193637E+01_JPRB &
  &, 0.199888E+01_JPRB, 0.206208E+01_JPRB, 0.212595E+01_JPRB, 0.219045E+01_JPRB &
  &, 0.225557E+01_JPRB, 0.232128E+01_JPRB, 0.238756E+01_JPRB &
  &, 0.245439E+01_JPRB, 0.252173E+01_JPRB, 0.258957E+01_JPRB, 0.265788E+01_JPRB &
  &, 0.272664E+01_JPRB, 0.279581E+01_JPRB, 0.286539E+01_JPRB &
  &, 0.293534E+01_JPRB, 0.300564E+01_JPRB, 0.307627E+01_JPRB, 0.314720E+01_JPRB &
  &, 0.321841E+01_JPRB, 0.328987E+01_JPRB, 0.336156E+01_JPRB &
  &, 0.343346E+01_JPRB, 0.350555E+01_JPRB, 0.357781E+01_JPRB, 0.365020E+01_JPRB &
  &, 0.372271E+01_JPRB, 0.379531E+01_JPRB, 0.386799E+01_JPRB &
  &, 0.394073E+01_JPRB, 0.401350E+01_JPRB, 0.408629E+01_JPRB, 0.415905E+01_JPRB &
  &, 0.423180E+01_JPRB, 0.430449E+01_JPRB, 0.437713E+01_JPRB &
  &, 0.444967E+01_JPRB, 0.452211E+01_JPRB, 0.459443E+01_JPRB, 0.466660E+01_JPRB &
  &, 0.473863E+01_JPRB, 0.481046E+01_JPRB, 0.488210E+01_JPRB &
  &, 0.495355E+01_JPRB, 0.502478E+01_JPRB, 0.509575E+01_JPRB, 0.516648E+01_JPRB &
  &, 0.523692E+01_JPRB, 0.530709E+01_JPRB, 0.537695E+01_JPRB &
  &, 0.544650E+01_JPRB, 0.551573E+01_JPRB, 0.558461E+01_JPRB, 0.565314E+01_JPRB &
  &, 0.572128E+01_JPRB, 0.578906E+01_JPRB, 0.585646E+01_JPRB &
  &, 0.592345E+01_JPRB, 0.599002E+01_JPRB, 0.605615E+01_JPRB, 0.612186E+01_JPRB &
  &, 0.618711E+01_JPRB, 0.625193E+01_JPRB, 0.631624E+01_JPRB &
  &, 0.638009E+01_JPRB, 0.644347E+01_JPRB, 0.650635E+01_JPRB, 0.656870E+01_JPRB &
  &, 0.663056E+01_JPRB, 0.669188E+01_JPRB, 0.675267E+01_JPRB &
  &, 0.681293E+01_JPRB, 0.687264E+01_JPRB, 0.693177E+01_JPRB, 0.699039E+01_JPRB &
  &, 0.704841E+01_JPRB, 0.710586E+01_JPRB, 0.716270E+01_JPRB &
  &, 0.721899E+01_JPRB, 0.727465E+01_JPRB, 0.732975E+01_JPRB, 0.738422E+01_JPRB &
  &, 0.743808E+01_JPRB, 0.749134E+01_JPRB, 0.754395E+01_JPRB &
  &, 0.759594E+01_JPRB, 0.764729E+01_JPRB, 0.769802E+01_JPRB, 0.774810E+01_JPRB &
  &, 0.779753E+01_JPRB, 0.784634E+01_JPRB, 0.789443E+01_JPRB &
  &, 0.794194E+01_JPRB, 0.798877E+01_JPRB, 0.803487E+01_JPRB, 0.808041E+01_JPRB &
  &, 0.812523E+01_JPRB, 0.816938E+01_JPRB, 0.821149E+01_JPRB &
  &, 0.825567E+01_JPRB, 0.829776E+01_JPRB, 0.833921E+01_JPRB, 0.837995E+01_JPRB &
  &, 0.842005E+01_JPRB, 0.845936E+01_JPRB, 0.849805E+01_JPRB &
  &, 0.853606E+01_JPRB, 0.857340E+01_JPRB, 0.860998E+01_JPRB, 0.864592E+01_JPRB &
  &, 0.868110E+01_JPRB, 0.871560E+01_JPRB, 0.874942E+01_JPRB &
  &, 0.878246E+01_JPRB, 0.881489E+01_JPRB, 0.884673E+01_JPRB, 0.887776E+01_JPRB &
  &, 0.890809E+01_JPRB, 0.893775E+01_JPRB, 0.896661E+01_JPRB &
  &, 0.899488E+01_JPRB, 0.902243E+01_JPRB, 0.904928E+01_JPRB, 0.907538E+01_JPRB &
  &, 0.910080E+01_JPRB, 0.912554E+01_JPRB, 0.914963E+01_JPRB/)
XCW( 971, :) = (/ &
  &  0.119798E+01_JPRB, 0.125004E+01_JPRB, 0.130310E+01_JPRB, 0.135712E+01_JPRB &
  &, 0.141209E+01_JPRB, 0.146799E+01_JPRB, 0.152481E+01_JPRB &
  &, 0.158251E+01_JPRB, 0.164107E+01_JPRB, 0.170049E+01_JPRB, 0.176073E+01_JPRB &
  &, 0.182176E+01_JPRB, 0.188358E+01_JPRB, 0.194616E+01_JPRB &
  &, 0.200946E+01_JPRB, 0.207348E+01_JPRB, 0.213819E+01_JPRB, 0.220356E+01_JPRB &
  &, 0.226956E+01_JPRB, 0.233618E+01_JPRB, 0.240340E+01_JPRB &
  &, 0.247118E+01_JPRB, 0.253951E+01_JPRB, 0.260835E+01_JPRB, 0.267769E+01_JPRB &
  &, 0.274749E+01_JPRB, 0.281775E+01_JPRB, 0.288842E+01_JPRB &
  &, 0.295949E+01_JPRB, 0.303093E+01_JPRB, 0.310272E+01_JPRB, 0.317484E+01_JPRB &
  &, 0.324726E+01_JPRB, 0.331995E+01_JPRB, 0.339290E+01_JPRB &
  &, 0.346607E+01_JPRB, 0.353945E+01_JPRB, 0.361302E+01_JPRB, 0.368675E+01_JPRB &
  &, 0.376063E+01_JPRB, 0.383461E+01_JPRB, 0.390869E+01_JPRB &
  &, 0.398284E+01_JPRB, 0.405701E+01_JPRB, 0.413130E+01_JPRB, 0.420555E+01_JPRB &
  &, 0.427979E+01_JPRB, 0.435401E+01_JPRB, 0.442818E+01_JPRB &
  &, 0.450228E+01_JPRB, 0.457630E+01_JPRB, 0.465020E+01_JPRB, 0.472399E+01_JPRB &
  &, 0.479764E+01_JPRB, 0.487114E+01_JPRB, 0.494445E+01_JPRB &
  &, 0.501758E+01_JPRB, 0.509049E+01_JPRB, 0.516319E+01_JPRB, 0.523565E+01_JPRB &
  &, 0.530786E+01_JPRB, 0.537979E+01_JPRB, 0.545143E+01_JPRB &
  &, 0.552279E+01_JPRB, 0.559382E+01_JPRB, 0.566453E+01_JPRB, 0.573490E+01_JPRB &
  &, 0.580494E+01_JPRB, 0.587460E+01_JPRB, 0.594387E+01_JPRB &
  &, 0.601276E+01_JPRB, 0.608125E+01_JPRB, 0.614933E+01_JPRB, 0.621697E+01_JPRB &
  &, 0.628421E+01_JPRB, 0.635099E+01_JPRB, 0.641731E+01_JPRB &
  &, 0.648315E+01_JPRB, 0.654853E+01_JPRB, 0.661342E+01_JPRB, 0.667782E+01_JPRB &
  &, 0.674171E+01_JPRB, 0.680510E+01_JPRB, 0.686795E+01_JPRB &
  &, 0.693031E+01_JPRB, 0.699210E+01_JPRB, 0.705336E+01_JPRB, 0.711407E+01_JPRB &
  &, 0.717420E+01_JPRB, 0.723378E+01_JPRB, 0.729277E+01_JPRB &
  &, 0.735122E+01_JPRB, 0.740904E+01_JPRB, 0.746631E+01_JPRB, 0.752293E+01_JPRB &
  &, 0.757899E+01_JPRB, 0.763443E+01_JPRB, 0.768923E+01_JPRB &
  &, 0.774344E+01_JPRB, 0.779702E+01_JPRB, 0.784995E+01_JPRB, 0.790229E+01_JPRB &
  &, 0.795395E+01_JPRB, 0.800493E+01_JPRB, 0.805535E+01_JPRB &
  &, 0.810510E+01_JPRB, 0.815417E+01_JPRB, 0.820261E+01_JPRB, 0.825037E+01_JPRB &
  &, 0.829743E+01_JPRB, 0.834386E+01_JPRB, 0.838963E+01_JPRB &
  &, 0.843470E+01_JPRB, 0.847907E+01_JPRB, 0.852283E+01_JPRB, 0.856586E+01_JPRB &
  &, 0.860821E+01_JPRB, 0.864987E+01_JPRB, 0.869087E+01_JPRB &
  &, 0.873119E+01_JPRB, 0.877076E+01_JPRB, 0.880968E+01_JPRB, 0.884795E+01_JPRB &
  &, 0.888542E+01_JPRB, 0.892227E+01_JPRB, 0.895839E+01_JPRB &
  &, 0.899379E+01_JPRB, 0.902859E+01_JPRB, 0.906263E+01_JPRB, 0.909597E+01_JPRB &
  &, 0.912857E+01_JPRB, 0.916061E+01_JPRB, 0.919174E+01_JPRB &
  &, 0.922221E+01_JPRB, 0.925216E+01_JPRB, 0.928128E+01_JPRB, 0.930972E+01_JPRB &
  &, 0.933747E+01_JPRB, 0.936449E+01_JPRB, 0.939079E+01_JPRB/)
XCW( 972, :) = (/ &
  &  0.119971E+01_JPRB, 0.125227E+01_JPRB, 0.130584E+01_JPRB, 0.136041E+01_JPRB &
  &, 0.141595E+01_JPRB, 0.147244E+01_JPRB, 0.152988E+01_JPRB &
  &, 0.158822E+01_JPRB, 0.164746E+01_JPRB, 0.170757E+01_JPRB, 0.176852E+01_JPRB &
  &, 0.183031E+01_JPRB, 0.189289E+01_JPRB, 0.195626E+01_JPRB &
  &, 0.202039E+01_JPRB, 0.208525E+01_JPRB, 0.215083E+01_JPRB, 0.221709E+01_JPRB &
  &, 0.228402E+01_JPRB, 0.235158E+01_JPRB, 0.241976E+01_JPRB &
  &, 0.248854E+01_JPRB, 0.255788E+01_JPRB, 0.262776E+01_JPRB, 0.269816E+01_JPRB &
  &, 0.276906E+01_JPRB, 0.284043E+01_JPRB, 0.291224E+01_JPRB &
  &, 0.298447E+01_JPRB, 0.305706E+01_JPRB, 0.313009E+01_JPRB, 0.320344E+01_JPRB &
  &, 0.327711E+01_JPRB, 0.335108E+01_JPRB, 0.342532E+01_JPRB &
  &, 0.349982E+01_JPRB, 0.357455E+01_JPRB, 0.364948E+01_JPRB, 0.372460E+01_JPRB &
  &, 0.379988E+01_JPRB, 0.387530E+01_JPRB, 0.395083E+01_JPRB &
  &, 0.402646E+01_JPRB, 0.410216E+01_JPRB, 0.417792E+01_JPRB, 0.425369E+01_JPRB &
  &, 0.432951E+01_JPRB, 0.440530E+01_JPRB, 0.448108E+01_JPRB &
  &, 0.455680E+01_JPRB, 0.463245E+01_JPRB, 0.470802E+01_JPRB, 0.478348E+01_JPRB &
  &, 0.485883E+01_JPRB, 0.493403E+01_JPRB, 0.500909E+01_JPRB &
  &, 0.508396E+01_JPRB, 0.515865E+01_JPRB, 0.523313E+01_JPRB, 0.530740E+01_JPRB &
  &, 0.538143E+01_JPRB, 0.545520E+01_JPRB, 0.552870E+01_JPRB &
  &, 0.560193E+01_JPRB, 0.567486E+01_JPRB, 0.574749E+01_JPRB, 0.581977E+01_JPRB &
  &, 0.589175E+01_JPRB, 0.596336E+01_JPRB, 0.603461E+01_JPRB &
  &, 0.610548E+01_JPRB, 0.617597E+01_JPRB, 0.624605E+01_JPRB, 0.631575E+01_JPRB &
  &, 0.638501E+01_JPRB, 0.645383E+01_JPRB, 0.652223E+01_JPRB &
  &, 0.659016E+01_JPRB, 0.665763E+01_JPRB, 0.672463E+01_JPRB, 0.679117E+01_JPRB &
  &, 0.685719E+01_JPRB, 0.692274E+01_JPRB, 0.698775E+01_JPRB &
  &, 0.705225E+01_JPRB, 0.711624E+01_JPRB, 0.717969E+01_JPRB, 0.724260E+01_JPRB &
  &, 0.730497E+01_JPRB, 0.736677E+01_JPRB, 0.742800E+01_JPRB &
  &, 0.748868E+01_JPRB, 0.754877E+01_JPRB, 0.760830E+01_JPRB, 0.766721E+01_JPRB &
  &, 0.772554E+01_JPRB, 0.778329E+01_JPRB, 0.784039E+01_JPRB &
  &, 0.789692E+01_JPRB, 0.795278E+01_JPRB, 0.800807E+01_JPRB, 0.806272E+01_JPRB &
  &, 0.811672E+01_JPRB, 0.817009E+01_JPRB, 0.822284E+01_JPRB &
  &, 0.827492E+01_JPRB, 0.832638E+01_JPRB, 0.837719E+01_JPRB, 0.842728E+01_JPRB &
  &, 0.847677E+01_JPRB, 0.852556E+01_JPRB, 0.857374E+01_JPRB &
  &, 0.862122E+01_JPRB, 0.866798E+01_JPRB, 0.871414E+01_JPRB, 0.875957E+01_JPRB &
  &, 0.880433E+01_JPRB, 0.884827E+01_JPRB, 0.889145E+01_JPRB &
  &, 0.893456E+01_JPRB, 0.897662E+01_JPRB, 0.901784E+01_JPRB, 0.905857E+01_JPRB &
  &, 0.909851E+01_JPRB, 0.913757E+01_JPRB, 0.917633E+01_JPRB &
  &, 0.921422E+01_JPRB, 0.925140E+01_JPRB, 0.928782E+01_JPRB, 0.932361E+01_JPRB &
  &, 0.935866E+01_JPRB, 0.939304E+01_JPRB, 0.942675E+01_JPRB &
  &, 0.945975E+01_JPRB, 0.949198E+01_JPRB, 0.952357E+01_JPRB, 0.955442E+01_JPRB &
  &, 0.958433E+01_JPRB, 0.961402E+01_JPRB, 0.964279E+01_JPRB/)
XCW( 973, :) = (/ &
  &  0.120149E+01_JPRB, 0.125456E+01_JPRB, 0.130867E+01_JPRB, 0.136380E+01_JPRB &
  &, 0.141993E+01_JPRB, 0.147704E+01_JPRB, 0.153511E+01_JPRB &
  &, 0.159412E+01_JPRB, 0.165405E+01_JPRB, 0.171488E+01_JPRB, 0.177658E+01_JPRB &
  &, 0.183913E+01_JPRB, 0.190252E+01_JPRB, 0.196671E+01_JPRB &
  &, 0.203169E+01_JPRB, 0.209742E+01_JPRB, 0.216390E+01_JPRB, 0.223109E+01_JPRB &
  &, 0.229896E+01_JPRB, 0.236751E+01_JPRB, 0.243669E+01_JPRB &
  &, 0.250650E+01_JPRB, 0.257689E+01_JPRB, 0.264785E+01_JPRB, 0.271936E+01_JPRB &
  &, 0.279139E+01_JPRB, 0.286391E+01_JPRB, 0.293690E+01_JPRB &
  &, 0.301033E+01_JPRB, 0.308419E+01_JPRB, 0.315844E+01_JPRB, 0.323306E+01_JPRB &
  &, 0.330803E+01_JPRB, 0.338333E+01_JPRB, 0.345892E+01_JPRB &
  &, 0.353479E+01_JPRB, 0.361091E+01_JPRB, 0.368727E+01_JPRB, 0.376383E+01_JPRB &
  &, 0.384057E+01_JPRB, 0.391748E+01_JPRB, 0.399452E+01_JPRB &
  &, 0.407168E+01_JPRB, 0.414894E+01_JPRB, 0.422628E+01_JPRB, 0.430367E+01_JPRB &
  &, 0.438109E+01_JPRB, 0.445853E+01_JPRB, 0.453595E+01_JPRB &
  &, 0.461337E+01_JPRB, 0.469072E+01_JPRB, 0.476801E+01_JPRB, 0.484522E+01_JPRB &
  &, 0.492233E+01_JPRB, 0.499933E+01_JPRB, 0.507619E+01_JPRB &
  &, 0.515289E+01_JPRB, 0.522942E+01_JPRB, 0.530577E+01_JPRB, 0.538191E+01_JPRB &
  &, 0.545784E+01_JPRB, 0.553353E+01_JPRB, 0.560897E+01_JPRB &
  &, 0.568415E+01_JPRB, 0.575902E+01_JPRB, 0.583365E+01_JPRB, 0.590795E+01_JPRB &
  &, 0.598194E+01_JPRB, 0.605559E+01_JPRB, 0.612889E+01_JPRB &
  &, 0.620184E+01_JPRB, 0.627442E+01_JPRB, 0.634662E+01_JPRB, 0.641842E+01_JPRB &
  &, 0.648980E+01_JPRB, 0.656078E+01_JPRB, 0.663133E+01_JPRB &
  &, 0.670146E+01_JPRB, 0.677113E+01_JPRB, 0.684033E+01_JPRB, 0.690906E+01_JPRB &
  &, 0.697733E+01_JPRB, 0.704510E+01_JPRB, 0.711238E+01_JPRB &
  &, 0.717918E+01_JPRB, 0.724543E+01_JPRB, 0.731116E+01_JPRB, 0.737639E+01_JPRB &
  &, 0.744108E+01_JPRB, 0.750520E+01_JPRB, 0.756879E+01_JPRB &
  &, 0.763180E+01_JPRB, 0.769428E+01_JPRB, 0.775614E+01_JPRB, 0.781746E+01_JPRB &
  &, 0.787816E+01_JPRB, 0.793830E+01_JPRB, 0.799785E+01_JPRB &
  &, 0.805676E+01_JPRB, 0.811510E+01_JPRB, 0.817280E+01_JPRB, 0.822989E+01_JPRB &
  &, 0.828634E+01_JPRB, 0.834218E+01_JPRB, 0.839740E+01_JPRB &
  &, 0.845194E+01_JPRB, 0.850587E+01_JPRB, 0.855915E+01_JPRB, 0.861178E+01_JPRB &
  &, 0.866361E+01_JPRB, 0.871504E+01_JPRB, 0.876571E+01_JPRB &
  &, 0.881574E+01_JPRB, 0.886500E+01_JPRB, 0.891363E+01_JPRB, 0.896169E+01_JPRB &
  &, 0.900899E+01_JPRB, 0.905558E+01_JPRB, 0.910156E+01_JPRB &
  &, 0.914645E+01_JPRB, 0.919144E+01_JPRB, 0.923529E+01_JPRB, 0.927851E+01_JPRB &
  &, 0.932101E+01_JPRB, 0.936278E+01_JPRB, 0.940384E+01_JPRB &
  &, 0.944435E+01_JPRB, 0.948416E+01_JPRB, 0.952317E+01_JPRB, 0.956149E+01_JPRB &
  &, 0.959913E+01_JPRB, 0.963611E+01_JPRB, 0.967231E+01_JPRB &
  &, 0.970785E+01_JPRB, 0.974269E+01_JPRB, 0.977677E+01_JPRB, 0.981024E+01_JPRB &
  &, 0.984296E+01_JPRB, 0.987496E+01_JPRB, 0.990629E+01_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART139',1,ZHOOK_HANDLE)
END SUBROUTINE PART139

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART140

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART140',0,ZHOOK_HANDLE)

XCW( 974, :) = (/ &
  &  0.120334E+01_JPRB, 0.125693E+01_JPRB, 0.131159E+01_JPRB, 0.136730E+01_JPRB &
  &, 0.142404E+01_JPRB, 0.148179E+01_JPRB, 0.154052E+01_JPRB &
  &, 0.160022E+01_JPRB, 0.166087E+01_JPRB, 0.172244E+01_JPRB, 0.178491E+01_JPRB &
  &, 0.184826E+01_JPRB, 0.191247E+01_JPRB, 0.197752E+01_JPRB &
  &, 0.204338E+01_JPRB, 0.211002E+01_JPRB, 0.217743E+01_JPRB, 0.224558E+01_JPRB &
  &, 0.231445E+01_JPRB, 0.238400E+01_JPRB, 0.245423E+01_JPRB &
  &, 0.252510E+01_JPRB, 0.259659E+01_JPRB, 0.266868E+01_JPRB, 0.274133E+01_JPRB &
  &, 0.281453E+01_JPRB, 0.288825E+01_JPRB, 0.296246E+01_JPRB &
  &, 0.303715E+01_JPRB, 0.311228E+01_JPRB, 0.318784E+01_JPRB, 0.326379E+01_JPRB &
  &, 0.334011E+01_JPRB, 0.341679E+01_JPRB, 0.349378E+01_JPRB &
  &, 0.357108E+01_JPRB, 0.364865E+01_JPRB, 0.372649E+01_JPRB, 0.380454E+01_JPRB &
  &, 0.388281E+01_JPRB, 0.396127E+01_JPRB, 0.403988E+01_JPRB &
  &, 0.411865E+01_JPRB, 0.419753E+01_JPRB, 0.427650E+01_JPRB, 0.435556E+01_JPRB &
  &, 0.443467E+01_JPRB, 0.451381E+01_JPRB, 0.459297E+01_JPRB &
  &, 0.467213E+01_JPRB, 0.475126E+01_JPRB, 0.483035E+01_JPRB, 0.490938E+01_JPRB &
  &, 0.498834E+01_JPRB, 0.506719E+01_JPRB, 0.514592E+01_JPRB &
  &, 0.522453E+01_JPRB, 0.530299E+01_JPRB, 0.538128E+01_JPRB, 0.545938E+01_JPRB &
  &, 0.553728E+01_JPRB, 0.561498E+01_JPRB, 0.569245E+01_JPRB &
  &, 0.576966E+01_JPRB, 0.584662E+01_JPRB, 0.592330E+01_JPRB, 0.599969E+01_JPRB &
  &, 0.607579E+01_JPRB, 0.615157E+01_JPRB, 0.622702E+01_JPRB &
  &, 0.630213E+01_JPRB, 0.637689E+01_JPRB, 0.645128E+01_JPRB, 0.652530E+01_JPRB &
  &, 0.659892E+01_JPRB, 0.667213E+01_JPRB, 0.674496E+01_JPRB &
  &, 0.681735E+01_JPRB, 0.688931E+01_JPRB, 0.696083E+01_JPRB, 0.703188E+01_JPRB &
  &, 0.710247E+01_JPRB, 0.717261E+01_JPRB, 0.724223E+01_JPRB &
  &, 0.731140E+01_JPRB, 0.738006E+01_JPRB, 0.744819E+01_JPRB, 0.751582E+01_JPRB &
  &, 0.758294E+01_JPRB, 0.764952E+01_JPRB, 0.771553E+01_JPRB &
  &, 0.778104E+01_JPRB, 0.784597E+01_JPRB, 0.791032E+01_JPRB, 0.797413E+01_JPRB &
  &, 0.803735E+01_JPRB, 0.809999E+01_JPRB, 0.816206E+01_JPRB &
  &, 0.822354E+01_JPRB, 0.828440E+01_JPRB, 0.834468E+01_JPRB, 0.840433E+01_JPRB &
  &, 0.846334E+01_JPRB, 0.852177E+01_JPRB, 0.857955E+01_JPRB &
  &, 0.863667E+01_JPRB, 0.869327E+01_JPRB, 0.874917E+01_JPRB, 0.880438E+01_JPRB &
  &, 0.885901E+01_JPRB, 0.891292E+01_JPRB, 0.896625E+01_JPRB &
  &, 0.901887E+01_JPRB, 0.907068E+01_JPRB, 0.912220E+01_JPRB, 0.917283E+01_JPRB &
  &, 0.922280E+01_JPRB, 0.927189E+01_JPRB, 0.932061E+01_JPRB &
  &, 0.936866E+01_JPRB, 0.941592E+01_JPRB, 0.946250E+01_JPRB, 0.950841E+01_JPRB &
  &, 0.955359E+01_JPRB, 0.959807E+01_JPRB, 0.964194E+01_JPRB &
  &, 0.968506E+01_JPRB, 0.972755E+01_JPRB, 0.976929E+01_JPRB, 0.981029E+01_JPRB &
  &, 0.985068E+01_JPRB, 0.989040E+01_JPRB, 0.992924E+01_JPRB &
  &, 0.996748E+01_JPRB, 0.100051E+02_JPRB, 0.100419E+02_JPRB, 0.100781E+02_JPRB &
  &, 0.101135E+02_JPRB, 0.101482E+02_JPRB, 0.101823E+02_JPRB/)
XCW( 975, :) = (/ &
  &  0.120524E+01_JPRB, 0.125938E+01_JPRB, 0.131462E+01_JPRB, 0.137093E+01_JPRB &
  &, 0.142830E+01_JPRB, 0.148670E+01_JPRB, 0.154612E+01_JPRB &
  &, 0.160654E+01_JPRB, 0.166793E+01_JPRB, 0.173027E+01_JPRB, 0.179354E+01_JPRB &
  &, 0.185773E+01_JPRB, 0.192279E+01_JPRB, 0.198872E+01_JPRB &
  &, 0.205549E+01_JPRB, 0.212308E+01_JPRB, 0.219146E+01_JPRB, 0.226061E+01_JPRB &
  &, 0.233050E+01_JPRB, 0.240112E+01_JPRB, 0.247242E+01_JPRB &
  &, 0.254441E+01_JPRB, 0.261703E+01_JPRB, 0.269028E+01_JPRB, 0.276413E+01_JPRB &
  &, 0.283855E+01_JPRB, 0.291352E+01_JPRB, 0.298901E+01_JPRB &
  &, 0.306500E+01_JPRB, 0.314146E+01_JPRB, 0.321837E+01_JPRB, 0.329570E+01_JPRB &
  &, 0.337344E+01_JPRB, 0.345155E+01_JPRB, 0.353000E+01_JPRB &
  &, 0.360878E+01_JPRB, 0.368787E+01_JPRB, 0.376724E+01_JPRB, 0.384687E+01_JPRB &
  &, 0.392672E+01_JPRB, 0.400679E+01_JPRB, 0.408705E+01_JPRB &
  &, 0.416748E+01_JPRB, 0.424804E+01_JPRB, 0.432873E+01_JPRB, 0.440952E+01_JPRB &
  &, 0.449039E+01_JPRB, 0.457132E+01_JPRB, 0.465229E+01_JPRB &
  &, 0.473328E+01_JPRB, 0.481426E+01_JPRB, 0.489523E+01_JPRB, 0.497616E+01_JPRB &
  &, 0.505703E+01_JPRB, 0.513783E+01_JPRB, 0.521853E+01_JPRB &
  &, 0.529912E+01_JPRB, 0.537958E+01_JPRB, 0.545990E+01_JPRB, 0.554006E+01_JPRB &
  &, 0.562004E+01_JPRB, 0.569982E+01_JPRB, 0.577939E+01_JPRB &
  &, 0.585874E+01_JPRB, 0.593785E+01_JPRB, 0.601670E+01_JPRB, 0.609529E+01_JPRB &
  &, 0.617358E+01_JPRB, 0.625158E+01_JPRB, 0.632928E+01_JPRB &
  &, 0.640666E+01_JPRB, 0.648369E+01_JPRB, 0.656040E+01_JPRB, 0.663672E+01_JPRB &
  &, 0.671267E+01_JPRB, 0.678825E+01_JPRB, 0.686343E+01_JPRB &
  &, 0.693820E+01_JPRB, 0.701255E+01_JPRB, 0.708649E+01_JPRB, 0.715999E+01_JPRB &
  &, 0.723303E+01_JPRB, 0.730562E+01_JPRB, 0.737774E+01_JPRB &
  &, 0.744938E+01_JPRB, 0.752055E+01_JPRB, 0.759120E+01_JPRB, 0.766135E+01_JPRB &
  &, 0.773102E+01_JPRB, 0.780016E+01_JPRB, 0.786874E+01_JPRB &
  &, 0.793683E+01_JPRB, 0.800434E+01_JPRB, 0.807134E+01_JPRB, 0.813775E+01_JPRB &
  &, 0.820360E+01_JPRB, 0.826890E+01_JPRB, 0.833361E+01_JPRB &
  &, 0.839776E+01_JPRB, 0.846131E+01_JPRB, 0.852425E+01_JPRB, 0.858658E+01_JPRB &
  &, 0.864834E+01_JPRB, 0.870948E+01_JPRB, 0.877001E+01_JPRB &
  &, 0.882988E+01_JPRB, 0.888917E+01_JPRB, 0.894781E+01_JPRB, 0.900583E+01_JPRB &
  &, 0.906319E+01_JPRB, 0.911989E+01_JPRB, 0.917598E+01_JPRB &
  &, 0.923142E+01_JPRB, 0.928611E+01_JPRB, 0.934029E+01_JPRB, 0.939373E+01_JPRB &
  &, 0.944654E+01_JPRB, 0.949860E+01_JPRB, 0.954856E+01_JPRB &
  &, 0.960084E+01_JPRB, 0.965097E+01_JPRB, 0.970038E+01_JPRB, 0.974918E+01_JPRB &
  &, 0.979717E+01_JPRB, 0.984456E+01_JPRB, 0.989125E+01_JPRB &
  &, 0.993719E+01_JPRB, 0.998256E+01_JPRB, 0.100271E+02_JPRB, 0.100710E+02_JPRB &
  &, 0.101143E+02_JPRB, 0.101568E+02_JPRB, 0.101986E+02_JPRB &
  &, 0.102397E+02_JPRB, 0.102802E+02_JPRB, 0.103199E+02_JPRB, 0.103586E+02_JPRB &
  &, 0.103972E+02_JPRB, 0.104347E+02_JPRB, 0.104717E+02_JPRB/)
XCW( 976, :) = (/ &
  &  0.120721E+01_JPRB, 0.126192E+01_JPRB, 0.131775E+01_JPRB, 0.137468E+01_JPRB &
  &, 0.143270E+01_JPRB, 0.149179E+01_JPRB, 0.155193E+01_JPRB &
  &, 0.161309E+01_JPRB, 0.167525E+01_JPRB, 0.173839E+01_JPRB, 0.180250E+01_JPRB &
  &, 0.186754E+01_JPRB, 0.193350E+01_JPRB, 0.200035E+01_JPRB &
  &, 0.206807E+01_JPRB, 0.213664E+01_JPRB, 0.220603E+01_JPRB, 0.227622E+01_JPRB &
  &, 0.234718E+01_JPRB, 0.241889E+01_JPRB, 0.249132E+01_JPRB &
  &, 0.256446E+01_JPRB, 0.263828E+01_JPRB, 0.271274E+01_JPRB, 0.278783E+01_JPRB &
  &, 0.286352E+01_JPRB, 0.293979E+01_JPRB, 0.301661E+01_JPRB &
  &, 0.309396E+01_JPRB, 0.317181E+01_JPRB, 0.325013E+01_JPRB, 0.332890E+01_JPRB &
  &, 0.340810E+01_JPRB, 0.348771E+01_JPRB, 0.356769E+01_JPRB &
  &, 0.364802E+01_JPRB, 0.372868E+01_JPRB, 0.380967E+01_JPRB, 0.389093E+01_JPRB &
  &, 0.397244E+01_JPRB, 0.405420E+01_JPRB, 0.413616E+01_JPRB &
  &, 0.421833E+01_JPRB, 0.430066E+01_JPRB, 0.438314E+01_JPRB, 0.446574E+01_JPRB &
  &, 0.454845E+01_JPRB, 0.463124E+01_JPRB, 0.471409E+01_JPRB &
  &, 0.479700E+01_JPRB, 0.487993E+01_JPRB, 0.496285E+01_JPRB, 0.504577E+01_JPRB &
  &, 0.512865E+01_JPRB, 0.521147E+01_JPRB, 0.529422E+01_JPRB &
  &, 0.537690E+01_JPRB, 0.545946E+01_JPRB, 0.554190E+01_JPRB, 0.562420E+01_JPRB &
  &, 0.570634E+01_JPRB, 0.578832E+01_JPRB, 0.587009E+01_JPRB &
  &, 0.595167E+01_JPRB, 0.603304E+01_JPRB, 0.611416E+01_JPRB, 0.619503E+01_JPRB &
  &, 0.627565E+01_JPRB, 0.635599E+01_JPRB, 0.643604E+01_JPRB &
  &, 0.651580E+01_JPRB, 0.659521E+01_JPRB, 0.667431E+01_JPRB, 0.675307E+01_JPRB &
  &, 0.683147E+01_JPRB, 0.690951E+01_JPRB, 0.698717E+01_JPRB &
  &, 0.706446E+01_JPRB, 0.714133E+01_JPRB, 0.721779E+01_JPRB, 0.729382E+01_JPRB &
  &, 0.736945E+01_JPRB, 0.744460E+01_JPRB, 0.751932E+01_JPRB &
  &, 0.759357E+01_JPRB, 0.766739E+01_JPRB, 0.774068E+01_JPRB, 0.781351E+01_JPRB &
  &, 0.788584E+01_JPRB, 0.795765E+01_JPRB, 0.802897E+01_JPRB &
  &, 0.809975E+01_JPRB, 0.817002E+01_JPRB, 0.823972E+01_JPRB, 0.830891E+01_JPRB &
  &, 0.837753E+01_JPRB, 0.844563E+01_JPRB, 0.851312E+01_JPRB &
  &, 0.858007E+01_JPRB, 0.864644E+01_JPRB, 0.871219E+01_JPRB, 0.877738E+01_JPRB &
  &, 0.884198E+01_JPRB, 0.890599E+01_JPRB, 0.896936E+01_JPRB &
  &, 0.903213E+01_JPRB, 0.909430E+01_JPRB, 0.915583E+01_JPRB, 0.921676E+01_JPRB &
  &, 0.927704E+01_JPRB, 0.933669E+01_JPRB, 0.939570E+01_JPRB &
  &, 0.945406E+01_JPRB, 0.951175E+01_JPRB, 0.956875E+01_JPRB, 0.962526E+01_JPRB &
  &, 0.968104E+01_JPRB, 0.973611E+01_JPRB, 0.979056E+01_JPRB &
  &, 0.984424E+01_JPRB, 0.989745E+01_JPRB, 0.994987E+01_JPRB, 0.100015E+02_JPRB &
  &, 0.100525E+02_JPRB, 0.101029E+02_JPRB, 0.101527E+02_JPRB &
  &, 0.102017E+02_JPRB, 0.102501E+02_JPRB, 0.102977E+02_JPRB, 0.103447E+02_JPRB &
  &, 0.103909E+02_JPRB, 0.104365E+02_JPRB, 0.104814E+02_JPRB &
  &, 0.105255E+02_JPRB, 0.105690E+02_JPRB, 0.106118E+02_JPRB, 0.106528E+02_JPRB &
  &, 0.106952E+02_JPRB, 0.107358E+02_JPRB, 0.107758E+02_JPRB/)
XCW( 977, :) = (/ &
  &  0.120926E+01_JPRB, 0.126455E+01_JPRB, 0.132100E+01_JPRB, 0.137858E+01_JPRB &
  &, 0.143728E+01_JPRB, 0.149708E+01_JPRB, 0.155795E+01_JPRB &
  &, 0.161988E+01_JPRB, 0.168285E+01_JPRB, 0.174683E+01_JPRB, 0.181180E+01_JPRB &
  &, 0.187774E+01_JPRB, 0.194463E+01_JPRB, 0.201244E+01_JPRB &
  &, 0.208115E+01_JPRB, 0.215074E+01_JPRB, 0.222118E+01_JPRB, 0.229245E+01_JPRB &
  &, 0.236453E+01_JPRB, 0.243738E+01_JPRB, 0.251100E+01_JPRB &
  &, 0.258534E+01_JPRB, 0.266039E+01_JPRB, 0.273612E+01_JPRB, 0.281251E+01_JPRB &
  &, 0.288953E+01_JPRB, 0.296716E+01_JPRB, 0.304536E+01_JPRB &
  &, 0.312412E+01_JPRB, 0.320342E+01_JPRB, 0.328322E+01_JPRB, 0.336350E+01_JPRB &
  &, 0.344424E+01_JPRB, 0.352541E+01_JPRB, 0.360698E+01_JPRB &
  &, 0.368894E+01_JPRB, 0.377125E+01_JPRB, 0.385390E+01_JPRB, 0.393687E+01_JPRB &
  &, 0.402012E+01_JPRB, 0.410364E+01_JPRB, 0.418740E+01_JPRB &
  &, 0.427138E+01_JPRB, 0.435555E+01_JPRB, 0.443990E+01_JPRB, 0.452440E+01_JPRB &
  &, 0.460903E+01_JPRB, 0.469378E+01_JPRB, 0.477861E+01_JPRB &
  &, 0.486351E+01_JPRB, 0.494847E+01_JPRB, 0.503345E+01_JPRB, 0.511845E+01_JPRB &
  &, 0.520343E+01_JPRB, 0.528839E+01_JPRB, 0.537328E+01_JPRB &
  &, 0.545814E+01_JPRB, 0.554290E+01_JPRB, 0.562757E+01_JPRB, 0.571212E+01_JPRB &
  &, 0.579653E+01_JPRB, 0.588080E+01_JPRB, 0.596489E+01_JPRB &
  &, 0.604881E+01_JPRB, 0.613254E+01_JPRB, 0.621604E+01_JPRB, 0.629933E+01_JPRB &
  &, 0.638236E+01_JPRB, 0.646514E+01_JPRB, 0.654768E+01_JPRB &
  &, 0.662990E+01_JPRB, 0.671184E+01_JPRB, 0.679347E+01_JPRB, 0.687477E+01_JPRB &
  &, 0.695575E+01_JPRB, 0.703637E+01_JPRB, 0.711666E+01_JPRB &
  &, 0.719655E+01_JPRB, 0.727606E+01_JPRB, 0.735519E+01_JPRB, 0.743392E+01_JPRB &
  &, 0.751223E+01_JPRB, 0.759010E+01_JPRB, 0.766756E+01_JPRB &
  &, 0.774456E+01_JPRB, 0.782112E+01_JPRB, 0.789722E+01_JPRB, 0.797285E+01_JPRB &
  &, 0.804799E+01_JPRB, 0.812262E+01_JPRB, 0.819680E+01_JPRB &
  &, 0.827042E+01_JPRB, 0.834357E+01_JPRB, 0.841617E+01_JPRB, 0.848828E+01_JPRB &
  &, 0.855982E+01_JPRB, 0.863082E+01_JPRB, 0.870128E+01_JPRB &
  &, 0.877118E+01_JPRB, 0.884048E+01_JPRB, 0.890926E+01_JPRB, 0.897743E+01_JPRB &
  &, 0.904504E+01_JPRB, 0.911206E+01_JPRB, 0.917847E+01_JPRB &
  &, 0.924430E+01_JPRB, 0.930951E+01_JPRB, 0.937410E+01_JPRB, 0.943810E+01_JPRB &
  &, 0.950144E+01_JPRB, 0.956419E+01_JPRB, 0.962632E+01_JPRB &
  &, 0.968779E+01_JPRB, 0.974864E+01_JPRB, 0.980882E+01_JPRB, 0.986838E+01_JPRB &
  &, 0.992728E+01_JPRB, 0.998553E+01_JPRB, 0.100431E+02_JPRB &
  &, 0.101000E+02_JPRB, 0.101563E+02_JPRB, 0.102119E+02_JPRB, 0.102668E+02_JPRB &
  &, 0.103210E+02_JPRB, 0.103747E+02_JPRB, 0.104275E+02_JPRB &
  &, 0.104798E+02_JPRB, 0.105313E+02_JPRB, 0.105817E+02_JPRB, 0.106321E+02_JPRB &
  &, 0.106818E+02_JPRB, 0.107306E+02_JPRB, 0.107787E+02_JPRB &
  &, 0.108261E+02_JPRB, 0.108728E+02_JPRB, 0.109188E+02_JPRB, 0.109622E+02_JPRB &
  &, 0.110086E+02_JPRB, 0.110526E+02_JPRB, 0.110957E+02_JPRB/)
XCW( 978, :) = (/ &
  &  0.121138E+01_JPRB, 0.126728E+01_JPRB, 0.132437E+01_JPRB, 0.138263E+01_JPRB &
  &, 0.144204E+01_JPRB, 0.150257E+01_JPRB, 0.156422E+01_JPRB &
  &, 0.162696E+01_JPRB, 0.169076E+01_JPRB, 0.175561E+01_JPRB, 0.182148E+01_JPRB &
  &, 0.188836E+01_JPRB, 0.195621E+01_JPRB, 0.202503E+01_JPRB &
  &, 0.209477E+01_JPRB, 0.216542E+01_JPRB, 0.223696E+01_JPRB, 0.230937E+01_JPRB &
  &, 0.238261E+01_JPRB, 0.245666E+01_JPRB, 0.253150E+01_JPRB &
  &, 0.260710E+01_JPRB, 0.268345E+01_JPRB, 0.276050E+01_JPRB, 0.283825E+01_JPRB &
  &, 0.291665E+01_JPRB, 0.299570E+01_JPRB, 0.307536E+01_JPRB &
  &, 0.315560E+01_JPRB, 0.323641E+01_JPRB, 0.331776E+01_JPRB, 0.339962E+01_JPRB &
  &, 0.348196E+01_JPRB, 0.356476E+01_JPRB, 0.364801E+01_JPRB &
  &, 0.373166E+01_JPRB, 0.381571E+01_JPRB, 0.390012E+01_JPRB, 0.398487E+01_JPRB &
  &, 0.406994E+01_JPRB, 0.415531E+01_JPRB, 0.424093E+01_JPRB &
  &, 0.432682E+01_JPRB, 0.441292E+01_JPRB, 0.449923E+01_JPRB, 0.458573E+01_JPRB &
  &, 0.467238E+01_JPRB, 0.475917E+01_JPRB, 0.484607E+01_JPRB &
  &, 0.493307E+01_JPRB, 0.502015E+01_JPRB, 0.510729E+01_JPRB, 0.519447E+01_JPRB &
  &, 0.528166E+01_JPRB, 0.536885E+01_JPRB, 0.545602E+01_JPRB &
  &, 0.554314E+01_JPRB, 0.563023E+01_JPRB, 0.571722E+01_JPRB, 0.580413E+01_JPRB &
  &, 0.589093E+01_JPRB, 0.597761E+01_JPRB, 0.606414E+01_JPRB &
  &, 0.615052E+01_JPRB, 0.623673E+01_JPRB, 0.632273E+01_JPRB, 0.640855E+01_JPRB &
  &, 0.649413E+01_JPRB, 0.657950E+01_JPRB, 0.666462E+01_JPRB &
  &, 0.674947E+01_JPRB, 0.683404E+01_JPRB, 0.691833E+01_JPRB, 0.700233E+01_JPRB &
  &, 0.708601E+01_JPRB, 0.716936E+01_JPRB, 0.725237E+01_JPRB &
  &, 0.733504E+01_JPRB, 0.741734E+01_JPRB, 0.749927E+01_JPRB, 0.758081E+01_JPRB &
  &, 0.766196E+01_JPRB, 0.774270E+01_JPRB, 0.782304E+01_JPRB &
  &, 0.790296E+01_JPRB, 0.798243E+01_JPRB, 0.806145E+01_JPRB, 0.814002E+01_JPRB &
  &, 0.821814E+01_JPRB, 0.829578E+01_JPRB, 0.837293E+01_JPRB &
  &, 0.844958E+01_JPRB, 0.852576E+01_JPRB, 0.860141E+01_JPRB, 0.867657E+01_JPRB &
  &, 0.875118E+01_JPRB, 0.882528E+01_JPRB, 0.889886E+01_JPRB &
  &, 0.897188E+01_JPRB, 0.904435E+01_JPRB, 0.911626E+01_JPRB, 0.918761E+01_JPRB &
  &, 0.925838E+01_JPRB, 0.932856E+01_JPRB, 0.939814E+01_JPRB &
  &, 0.946724E+01_JPRB, 0.953566E+01_JPRB, 0.960352E+01_JPRB, 0.967074E+01_JPRB &
  &, 0.973739E+01_JPRB, 0.980340E+01_JPRB, 0.986880E+01_JPRB &
  &, 0.993355E+01_JPRB, 0.999769E+01_JPRB, 0.100612E+02_JPRB, 0.101241E+02_JPRB &
  &, 0.101863E+02_JPRB, 0.102479E+02_JPRB, 0.103088E+02_JPRB &
  &, 0.103691E+02_JPRB, 0.104288E+02_JPRB, 0.104876E+02_JPRB, 0.105460E+02_JPRB &
  &, 0.106028E+02_JPRB, 0.106607E+02_JPRB, 0.107169E+02_JPRB &
  &, 0.107725E+02_JPRB, 0.108273E+02_JPRB, 0.108818E+02_JPRB, 0.109353E+02_JPRB &
  &, 0.109882E+02_JPRB, 0.110405E+02_JPRB, 0.110920E+02_JPRB &
  &, 0.111428E+02_JPRB, 0.111930E+02_JPRB, 0.112424E+02_JPRB, 0.112907E+02_JPRB &
  &, 0.113392E+02_JPRB, 0.113866E+02_JPRB, 0.114332E+02_JPRB/)
XCW( 979, :) = (/ &
  &  0.121359E+01_JPRB, 0.127012E+01_JPRB, 0.132788E+01_JPRB, 0.138684E+01_JPRB &
  &, 0.144699E+01_JPRB, 0.150830E+01_JPRB, 0.157075E+01_JPRB &
  &, 0.163433E+01_JPRB, 0.169901E+01_JPRB, 0.176476E+01_JPRB, 0.183158E+01_JPRB &
  &, 0.189943E+01_JPRB, 0.196830E+01_JPRB, 0.203816E+01_JPRB &
  &, 0.210898E+01_JPRB, 0.218075E+01_JPRB, 0.225344E+01_JPRB, 0.232703E+01_JPRB &
  &, 0.240148E+01_JPRB, 0.247678E+01_JPRB, 0.255291E+01_JPRB &
  &, 0.262984E+01_JPRB, 0.270753E+01_JPRB, 0.278598E+01_JPRB, 0.286514E+01_JPRB &
  &, 0.294501E+01_JPRB, 0.302554E+01_JPRB, 0.310672E+01_JPRB &
  &, 0.318852E+01_JPRB, 0.327091E+01_JPRB, 0.335388E+01_JPRB, 0.343739E+01_JPRB &
  &, 0.352142E+01_JPRB, 0.360594E+01_JPRB, 0.369093E+01_JPRB &
  &, 0.377637E+01_JPRB, 0.386223E+01_JPRB, 0.394849E+01_JPRB, 0.403511E+01_JPRB &
  &, 0.412209E+01_JPRB, 0.420939E+01_JPRB, 0.429699E+01_JPRB &
  &, 0.438487E+01_JPRB, 0.447301E+01_JPRB, 0.456138E+01_JPRB, 0.464996E+01_JPRB &
  &, 0.473874E+01_JPRB, 0.482768E+01_JPRB, 0.491676E+01_JPRB &
  &, 0.500597E+01_JPRB, 0.509529E+01_JPRB, 0.518468E+01_JPRB, 0.527416E+01_JPRB &
  &, 0.536367E+01_JPRB, 0.545321E+01_JPRB, 0.554276E+01_JPRB &
  &, 0.563228E+01_JPRB, 0.572179E+01_JPRB, 0.581126E+01_JPRB, 0.590064E+01_JPRB &
  &, 0.598995E+01_JPRB, 0.607917E+01_JPRB, 0.616826E+01_JPRB &
  &, 0.625722E+01_JPRB, 0.634603E+01_JPRB, 0.643469E+01_JPRB, 0.652317E+01_JPRB &
  &, 0.661145E+01_JPRB, 0.669953E+01_JPRB, 0.678736E+01_JPRB &
  &, 0.687499E+01_JPRB, 0.696235E+01_JPRB, 0.704943E+01_JPRB, 0.713626E+01_JPRB &
  &, 0.722279E+01_JPRB, 0.730900E+01_JPRB, 0.739492E+01_JPRB &
  &, 0.748050E+01_JPRB, 0.756573E+01_JPRB, 0.765063E+01_JPRB, 0.773515E+01_JPRB &
  &, 0.781932E+01_JPRB, 0.790308E+01_JPRB, 0.798645E+01_JPRB &
  &, 0.806943E+01_JPRB, 0.815197E+01_JPRB, 0.823409E+01_JPRB, 0.831580E+01_JPRB &
  &, 0.839704E+01_JPRB, 0.847782E+01_JPRB, 0.855814E+01_JPRB &
  &, 0.863799E+01_JPRB, 0.871739E+01_JPRB, 0.879627E+01_JPRB, 0.887464E+01_JPRB &
  &, 0.895254E+01_JPRB, 0.902991E+01_JPRB, 0.910675E+01_JPRB &
  &, 0.918309E+01_JPRB, 0.925888E+01_JPRB, 0.933413E+01_JPRB, 0.940881E+01_JPRB &
  &, 0.948297E+01_JPRB, 0.955657E+01_JPRB, 0.962958E+01_JPRB &
  &, 0.970199E+01_JPRB, 0.977386E+01_JPRB, 0.984515E+01_JPRB, 0.991581E+01_JPRB &
  &, 0.998589E+01_JPRB, 0.100554E+02_JPRB, 0.101243E+02_JPRB &
  &, 0.101925E+02_JPRB, 0.102602E+02_JPRB, 0.103272E+02_JPRB, 0.103936E+02_JPRB &
  &, 0.104594E+02_JPRB, 0.105245E+02_JPRB, 0.105890E+02_JPRB &
  &, 0.106529E+02_JPRB, 0.107160E+02_JPRB, 0.107786E+02_JPRB, 0.108405E+02_JPRB &
  &, 0.109017E+02_JPRB, 0.109623E+02_JPRB, 0.110221E+02_JPRB &
  &, 0.110814E+02_JPRB, 0.111401E+02_JPRB, 0.111980E+02_JPRB, 0.112551E+02_JPRB &
  &, 0.113113E+02_JPRB, 0.113676E+02_JPRB, 0.114224E+02_JPRB &
  &, 0.114773E+02_JPRB, 0.115311E+02_JPRB, 0.115843E+02_JPRB, 0.116367E+02_JPRB &
  &, 0.116884E+02_JPRB, 0.117395E+02_JPRB, 0.117898E+02_JPRB/)
XCW( 980, :) = (/ &
  &  0.121589E+01_JPRB, 0.127309E+01_JPRB, 0.133155E+01_JPRB, 0.139124E+01_JPRB &
  &, 0.145216E+01_JPRB, 0.151427E+01_JPRB, 0.157757E+01_JPRB &
  &, 0.164202E+01_JPRB, 0.170762E+01_JPRB, 0.177433E+01_JPRB, 0.184213E+01_JPRB &
  &, 0.191101E+01_JPRB, 0.198093E+01_JPRB, 0.205189E+01_JPRB &
  &, 0.212384E+01_JPRB, 0.219678E+01_JPRB, 0.227068E+01_JPRB, 0.234550E+01_JPRB &
  &, 0.242124E+01_JPRB, 0.249785E+01_JPRB, 0.257533E+01_JPRB &
  &, 0.265364E+01_JPRB, 0.273275E+01_JPRB, 0.281265E+01_JPRB, 0.289331E+01_JPRB &
  &, 0.297470E+01_JPRB, 0.305680E+01_JPRB, 0.313957E+01_JPRB &
  &, 0.322301E+01_JPRB, 0.330707E+01_JPRB, 0.339173E+01_JPRB, 0.347698E+01_JPRB &
  &, 0.356278E+01_JPRB, 0.364911E+01_JPRB, 0.373594E+01_JPRB &
  &, 0.382325E+01_JPRB, 0.391102E+01_JPRB, 0.399922E+01_JPRB, 0.408781E+01_JPRB &
  &, 0.417679E+01_JPRB, 0.426613E+01_JPRB, 0.435582E+01_JPRB &
  &, 0.444580E+01_JPRB, 0.453608E+01_JPRB, 0.462662E+01_JPRB, 0.471740E+01_JPRB &
  &, 0.480840E+01_JPRB, 0.489960E+01_JPRB, 0.499099E+01_JPRB &
  &, 0.508252E+01_JPRB, 0.517420E+01_JPRB, 0.526598E+01_JPRB, 0.535787E+01_JPRB &
  &, 0.544982E+01_JPRB, 0.554184E+01_JPRB, 0.563389E+01_JPRB &
  &, 0.572596E+01_JPRB, 0.581803E+01_JPRB, 0.591008E+01_JPRB, 0.600210E+01_JPRB &
  &, 0.609406E+01_JPRB, 0.618595E+01_JPRB, 0.627774E+01_JPRB &
  &, 0.636944E+01_JPRB, 0.646102E+01_JPRB, 0.655245E+01_JPRB, 0.664374E+01_JPRB &
  &, 0.673485E+01_JPRB, 0.682579E+01_JPRB, 0.691653E+01_JPRB &
  &, 0.700704E+01_JPRB, 0.709736E+01_JPRB, 0.718742E+01_JPRB, 0.727722E+01_JPRB &
  &, 0.736676E+01_JPRB, 0.745601E+01_JPRB, 0.754500E+01_JPRB &
  &, 0.763366E+01_JPRB, 0.772200E+01_JPRB, 0.781002E+01_JPRB, 0.789770E+01_JPRB &
  &, 0.798504E+01_JPRB, 0.807199E+01_JPRB, 0.815857E+01_JPRB &
  &, 0.824478E+01_JPRB, 0.833059E+01_JPRB, 0.841601E+01_JPRB, 0.850099E+01_JPRB &
  &, 0.858558E+01_JPRB, 0.866970E+01_JPRB, 0.875340E+01_JPRB &
  &, 0.883662E+01_JPRB, 0.891940E+01_JPRB, 0.900172E+01_JPRB, 0.908353E+01_JPRB &
  &, 0.916486E+01_JPRB, 0.924573E+01_JPRB, 0.932607E+01_JPRB &
  &, 0.940589E+01_JPRB, 0.948520E+01_JPRB, 0.956399E+01_JPRB, 0.964224E+01_JPRB &
  &, 0.971996E+01_JPRB, 0.979713E+01_JPRB, 0.987376E+01_JPRB &
  &, 0.994980E+01_JPRB, 0.100253E+02_JPRB, 0.101002E+02_JPRB, 0.101745E+02_JPRB &
  &, 0.102483E+02_JPRB, 0.103215E+02_JPRB, 0.103941E+02_JPRB &
  &, 0.104661E+02_JPRB, 0.105374E+02_JPRB, 0.106082E+02_JPRB, 0.106784E+02_JPRB &
  &, 0.107479E+02_JPRB, 0.108168E+02_JPRB, 0.108850E+02_JPRB &
  &, 0.109527E+02_JPRB, 0.110197E+02_JPRB, 0.110861E+02_JPRB, 0.111518E+02_JPRB &
  &, 0.112169E+02_JPRB, 0.112813E+02_JPRB, 0.113450E+02_JPRB &
  &, 0.114080E+02_JPRB, 0.114705E+02_JPRB, 0.115324E+02_JPRB, 0.115936E+02_JPRB &
  &, 0.116540E+02_JPRB, 0.117138E+02_JPRB, 0.117729E+02_JPRB &
  &, 0.118312E+02_JPRB, 0.118890E+02_JPRB, 0.119461E+02_JPRB, 0.120024E+02_JPRB &
  &, 0.120580E+02_JPRB, 0.121131E+02_JPRB, 0.121674E+02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART140',1,ZHOOK_HANDLE)
END SUBROUTINE PART140

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART141

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART141',0,ZHOOK_HANDLE)

XCW( 981, :) = (/ &
  &  0.121829E+01_JPRB, 0.127619E+01_JPRB, 0.133538E+01_JPRB, 0.139584E+01_JPRB &
  &, 0.145757E+01_JPRB, 0.152053E+01_JPRB, 0.158470E+01_JPRB &
  &, 0.165008E+01_JPRB, 0.171663E+01_JPRB, 0.178434E+01_JPRB, 0.185318E+01_JPRB &
  &, 0.192313E+01_JPRB, 0.199417E+01_JPRB, 0.206627E+01_JPRB &
  &, 0.213942E+01_JPRB, 0.221358E+01_JPRB, 0.228874E+01_JPRB, 0.236487E+01_JPRB &
  &, 0.244195E+01_JPRB, 0.251995E+01_JPRB, 0.259884E+01_JPRB &
  &, 0.267861E+01_JPRB, 0.275922E+01_JPRB, 0.284065E+01_JPRB, 0.292288E+01_JPRB &
  &, 0.300587E+01_JPRB, 0.308962E+01_JPRB, 0.317407E+01_JPRB &
  &, 0.325922E+01_JPRB, 0.334504E+01_JPRB, 0.343150E+01_JPRB, 0.351858E+01_JPRB &
  &, 0.360625E+01_JPRB, 0.369448E+01_JPRB, 0.378325E+01_JPRB &
  &, 0.387254E+01_JPRB, 0.396231E+01_JPRB, 0.405256E+01_JPRB, 0.414323E+01_JPRB &
  &, 0.423434E+01_JPRB, 0.432583E+01_JPRB, 0.441769E+01_JPRB &
  &, 0.450989E+01_JPRB, 0.460243E+01_JPRB, 0.469525E+01_JPRB, 0.478836E+01_JPRB &
  &, 0.488172E+01_JPRB, 0.497531E+01_JPRB, 0.506912E+01_JPRB &
  &, 0.516311E+01_JPRB, 0.525727E+01_JPRB, 0.535159E+01_JPRB, 0.544603E+01_JPRB &
  &, 0.554056E+01_JPRB, 0.563520E+01_JPRB, 0.572989E+01_JPRB &
  &, 0.582465E+01_JPRB, 0.591943E+01_JPRB, 0.601421E+01_JPRB, 0.610900E+01_JPRB &
  &, 0.620375E+01_JPRB, 0.629847E+01_JPRB, 0.639314E+01_JPRB &
  &, 0.648772E+01_JPRB, 0.658222E+01_JPRB, 0.667660E+01_JPRB, 0.677087E+01_JPRB &
  &, 0.686498E+01_JPRB, 0.695895E+01_JPRB, 0.705276E+01_JPRB &
  &, 0.714635E+01_JPRB, 0.723977E+01_JPRB, 0.733298E+01_JPRB, 0.742594E+01_JPRB &
  &, 0.751868E+01_JPRB, 0.761115E+01_JPRB, 0.770338E+01_JPRB &
  &, 0.779530E+01_JPRB, 0.788694E+01_JPRB, 0.797828E+01_JPRB, 0.806930E+01_JPRB &
  &, 0.815999E+01_JPRB, 0.825035E+01_JPRB, 0.834037E+01_JPRB &
  &, 0.842999E+01_JPRB, 0.851928E+01_JPRB, 0.860816E+01_JPRB, 0.869667E+01_JPRB &
  &, 0.878476E+01_JPRB, 0.887242E+01_JPRB, 0.895969E+01_JPRB &
  &, 0.904653E+01_JPRB, 0.913292E+01_JPRB, 0.921885E+01_JPRB, 0.930431E+01_JPRB &
  &, 0.938932E+01_JPRB, 0.947386E+01_JPRB, 0.955791E+01_JPRB &
  &, 0.964147E+01_JPRB, 0.972455E+01_JPRB, 0.980709E+01_JPRB, 0.988914E+01_JPRB &
  &, 0.997067E+01_JPRB, 0.100517E+02_JPRB, 0.101321E+02_JPRB &
  &, 0.102120E+02_JPRB, 0.102914E+02_JPRB, 0.103702E+02_JPRB, 0.104484E+02_JPRB &
  &, 0.105261E+02_JPRB, 0.106032E+02_JPRB, 0.106797E+02_JPRB &
  &, 0.107557E+02_JPRB, 0.108310E+02_JPRB, 0.109058E+02_JPRB, 0.109799E+02_JPRB &
  &, 0.110535E+02_JPRB, 0.111264E+02_JPRB, 0.111988E+02_JPRB &
  &, 0.112704E+02_JPRB, 0.113415E+02_JPRB, 0.114120E+02_JPRB, 0.114818E+02_JPRB &
  &, 0.115510E+02_JPRB, 0.116195E+02_JPRB, 0.116874E+02_JPRB &
  &, 0.117546E+02_JPRB, 0.118212E+02_JPRB, 0.118872E+02_JPRB, 0.119524E+02_JPRB &
  &, 0.120171E+02_JPRB, 0.120808E+02_JPRB, 0.121442E+02_JPRB &
  &, 0.121992E+02_JPRB, 0.122689E+02_JPRB, 0.123301E+02_JPRB, 0.123907E+02_JPRB &
  &, 0.124505E+02_JPRB, 0.125098E+02_JPRB, 0.125683E+02_JPRB/)
XCW( 982, :) = (/ &
  &  0.122081E+01_JPRB, 0.127943E+01_JPRB, 0.133939E+01_JPRB, 0.140066E+01_JPRB &
  &, 0.146323E+01_JPRB, 0.152708E+01_JPRB, 0.159219E+01_JPRB &
  &, 0.165853E+01_JPRB, 0.172609E+01_JPRB, 0.179485E+01_JPRB, 0.186478E+01_JPRB &
  &, 0.193586E+01_JPRB, 0.200807E+01_JPRB, 0.208138E+01_JPRB &
  &, 0.215578E+01_JPRB, 0.223124E+01_JPRB, 0.230774E+01_JPRB, 0.238524E+01_JPRB &
  &, 0.246373E+01_JPRB, 0.254318E+01_JPRB, 0.262357E+01_JPRB &
  &, 0.270488E+01_JPRB, 0.278706E+01_JPRB, 0.287011E+01_JPRB, 0.295400E+01_JPRB &
  &, 0.303869E+01_JPRB, 0.312417E+01_JPRB, 0.321040E+01_JPRB &
  &, 0.329737E+01_JPRB, 0.338504E+01_JPRB, 0.347340E+01_JPRB, 0.356240E+01_JPRB &
  &, 0.365204E+01_JPRB, 0.374228E+01_JPRB, 0.383311E+01_JPRB &
  &, 0.392448E+01_JPRB, 0.401638E+01_JPRB, 0.410878E+01_JPRB, 0.420166E+01_JPRB &
  &, 0.429500E+01_JPRB, 0.438878E+01_JPRB, 0.448295E+01_JPRB &
  &, 0.457750E+01_JPRB, 0.467242E+01_JPRB, 0.476767E+01_JPRB, 0.486323E+01_JPRB &
  &, 0.495909E+01_JPRB, 0.505521E+01_JPRB, 0.515158E+01_JPRB &
  &, 0.524818E+01_JPRB, 0.534498E+01_JPRB, 0.544195E+01_JPRB, 0.553910E+01_JPRB &
  &, 0.563637E+01_JPRB, 0.573379E+01_JPRB, 0.583128E+01_JPRB &
  &, 0.592888E+01_JPRB, 0.602653E+01_JPRB, 0.612423E+01_JPRB, 0.622196E+01_JPRB &
  &, 0.631968E+01_JPRB, 0.641741E+01_JPRB, 0.651510E+01_JPRB &
  &, 0.661275E+01_JPRB, 0.671034E+01_JPRB, 0.680784E+01_JPRB, 0.690527E+01_JPRB &
  &, 0.700257E+01_JPRB, 0.709976E+01_JPRB, 0.719681E+01_JPRB &
  &, 0.729369E+01_JPRB, 0.739041E+01_JPRB, 0.748694E+01_JPRB, 0.758330E+01_JPRB &
  &, 0.767942E+01_JPRB, 0.777531E+01_JPRB, 0.787097E+01_JPRB &
  &, 0.796638E+01_JPRB, 0.806154E+01_JPRB, 0.815639E+01_JPRB, 0.825096E+01_JPRB &
  &, 0.834525E+01_JPRB, 0.843921E+01_JPRB, 0.853286E+01_JPRB &
  &, 0.862615E+01_JPRB, 0.871910E+01_JPRB, 0.881170E+01_JPRB, 0.890392E+01_JPRB &
  &, 0.899577E+01_JPRB, 0.908724E+01_JPRB, 0.917831E+01_JPRB &
  &, 0.926894E+01_JPRB, 0.935917E+01_JPRB, 0.944898E+01_JPRB, 0.953834E+01_JPRB &
  &, 0.962726E+01_JPRB, 0.971575E+01_JPRB, 0.980374E+01_JPRB &
  &, 0.989128E+01_JPRB, 0.997834E+01_JPRB, 0.100649E+02_JPRB, 0.101510E+02_JPRB &
  &, 0.102366E+02_JPRB, 0.103216E+02_JPRB, 0.104062E+02_JPRB &
  &, 0.104902E+02_JPRB, 0.105737E+02_JPRB, 0.106567E+02_JPRB, 0.107391E+02_JPRB &
  &, 0.108209E+02_JPRB, 0.109022E+02_JPRB, 0.109830E+02_JPRB &
  &, 0.110632E+02_JPRB, 0.111428E+02_JPRB, 0.112218E+02_JPRB, 0.113003E+02_JPRB &
  &, 0.113781E+02_JPRB, 0.114553E+02_JPRB, 0.115320E+02_JPRB &
  &, 0.116080E+02_JPRB, 0.116835E+02_JPRB, 0.117583E+02_JPRB, 0.118325E+02_JPRB &
  &, 0.119060E+02_JPRB, 0.119790E+02_JPRB, 0.120513E+02_JPRB &
  &, 0.121230E+02_JPRB, 0.121940E+02_JPRB, 0.122644E+02_JPRB, 0.123341E+02_JPRB &
  &, 0.124032E+02_JPRB, 0.124717E+02_JPRB, 0.125395E+02_JPRB &
  &, 0.126065E+02_JPRB, 0.126730E+02_JPRB, 0.127389E+02_JPRB, 0.128020E+02_JPRB &
  &, 0.128683E+02_JPRB, 0.129319E+02_JPRB, 0.129952E+02_JPRB/)
XCW( 983, :) = (/ &
  &  0.122345E+01_JPRB, 0.128284E+01_JPRB, 0.134361E+01_JPRB, 0.140573E+01_JPRB &
  &, 0.146919E+01_JPRB, 0.153397E+01_JPRB, 0.160006E+01_JPRB &
  &, 0.166742E+01_JPRB, 0.173604E+01_JPRB, 0.180591E+01_JPRB, 0.187699E+01_JPRB &
  &, 0.194926E+01_JPRB, 0.202271E+01_JPRB, 0.209730E+01_JPRB &
  &, 0.217303E+01_JPRB, 0.224985E+01_JPRB, 0.232776E+01_JPRB, 0.240671E+01_JPRB &
  &, 0.248670E+01_JPRB, 0.256769E+01_JPRB, 0.264966E+01_JPRB &
  &, 0.273259E+01_JPRB, 0.281644E+01_JPRB, 0.290120E+01_JPRB, 0.298684E+01_JPRB &
  &, 0.307333E+01_JPRB, 0.316065E+01_JPRB, 0.324876E+01_JPRB &
  &, 0.333765E+01_JPRB, 0.342729E+01_JPRB, 0.351765E+01_JPRB, 0.360870E+01_JPRB &
  &, 0.370043E+01_JPRB, 0.379281E+01_JPRB, 0.388580E+01_JPRB &
  &, 0.397938E+01_JPRB, 0.407354E+01_JPRB, 0.416823E+01_JPRB, 0.426345E+01_JPRB &
  &, 0.435917E+01_JPRB, 0.445535E+01_JPRB, 0.455197E+01_JPRB &
  &, 0.464902E+01_JPRB, 0.474647E+01_JPRB, 0.484429E+01_JPRB, 0.494248E+01_JPRB &
  &, 0.504097E+01_JPRB, 0.513979E+01_JPRB, 0.523888E+01_JPRB &
  &, 0.533824E+01_JPRB, 0.543783E+01_JPRB, 0.553765E+01_JPRB, 0.563767E+01_JPRB &
  &, 0.573786E+01_JPRB, 0.583822E+01_JPRB, 0.593871E+01_JPRB &
  &, 0.603932E+01_JPRB, 0.614001E+01_JPRB, 0.624080E+01_JPRB, 0.634165E+01_JPRB &
  &, 0.644255E+01_JPRB, 0.654346E+01_JPRB, 0.664437E+01_JPRB &
  &, 0.674529E+01_JPRB, 0.684617E+01_JPRB, 0.694703E+01_JPRB, 0.704781E+01_JPRB &
  &, 0.714850E+01_JPRB, 0.724911E+01_JPRB, 0.734962E+01_JPRB &
  &, 0.745000E+01_JPRB, 0.755024E+01_JPRB, 0.765034E+01_JPRB, 0.775026E+01_JPRB &
  &, 0.785000E+01_JPRB, 0.794954E+01_JPRB, 0.804887E+01_JPRB &
  &, 0.814799E+01_JPRB, 0.824687E+01_JPRB, 0.834550E+01_JPRB, 0.844387E+01_JPRB &
  &, 0.854195E+01_JPRB, 0.863977E+01_JPRB, 0.873728E+01_JPRB &
  &, 0.883448E+01_JPRB, 0.893137E+01_JPRB, 0.902794E+01_JPRB, 0.912413E+01_JPRB &
  &, 0.921999E+01_JPRB, 0.931550E+01_JPRB, 0.941060E+01_JPRB &
  &, 0.950536E+01_JPRB, 0.959970E+01_JPRB, 0.969363E+01_JPRB, 0.978717E+01_JPRB &
  &, 0.988029E+01_JPRB, 0.997296E+01_JPRB, 0.100652E+02_JPRB &
  &, 0.101570E+02_JPRB, 0.102483E+02_JPRB, 0.103392E+02_JPRB, 0.104296E+02_JPRB &
  &, 0.105195E+02_JPRB, 0.106089E+02_JPRB, 0.106979E+02_JPRB &
  &, 0.107863E+02_JPRB, 0.108742E+02_JPRB, 0.109617E+02_JPRB, 0.110485E+02_JPRB &
  &, 0.111349E+02_JPRB, 0.112207E+02_JPRB, 0.113059E+02_JPRB &
  &, 0.113907E+02_JPRB, 0.114749E+02_JPRB, 0.115584E+02_JPRB, 0.116415E+02_JPRB &
  &, 0.117240E+02_JPRB, 0.118058E+02_JPRB, 0.118871E+02_JPRB &
  &, 0.119678E+02_JPRB, 0.120479E+02_JPRB, 0.121274E+02_JPRB, 0.122063E+02_JPRB &
  &, 0.122847E+02_JPRB, 0.123623E+02_JPRB, 0.124394E+02_JPRB &
  &, 0.125158E+02_JPRB, 0.125916E+02_JPRB, 0.126668E+02_JPRB, 0.127414E+02_JPRB &
  &, 0.128153E+02_JPRB, 0.128886E+02_JPRB, 0.129612E+02_JPRB &
  &, 0.130332E+02_JPRB, 0.131045E+02_JPRB, 0.131751E+02_JPRB, 0.132451E+02_JPRB &
  &, 0.133144E+02_JPRB, 0.133831E+02_JPRB, 0.134511E+02_JPRB/)
XCW( 984, :) = (/ &
  &  0.122624E+01_JPRB, 0.128643E+01_JPRB, 0.134805E+01_JPRB, 0.141107E+01_JPRB &
  &, 0.147547E+01_JPRB, 0.154124E+01_JPRB, 0.160836E+01_JPRB &
  &, 0.167680E+01_JPRB, 0.174655E+01_JPRB, 0.181758E+01_JPRB, 0.188988E+01_JPRB &
  &, 0.196342E+01_JPRB, 0.203818E+01_JPRB, 0.211413E+01_JPRB &
  &, 0.219125E+01_JPRB, 0.226952E+01_JPRB, 0.234892E+01_JPRB, 0.242942E+01_JPRB &
  &, 0.251100E+01_JPRB, 0.259362E+01_JPRB, 0.267727E+01_JPRB &
  &, 0.276192E+01_JPRB, 0.284755E+01_JPRB, 0.293412E+01_JPRB, 0.302162E+01_JPRB &
  &, 0.311001E+01_JPRB, 0.319929E+01_JPRB, 0.328940E+01_JPRB &
  &, 0.338033E+01_JPRB, 0.347206E+01_JPRB, 0.356455E+01_JPRB, 0.365778E+01_JPRB &
  &, 0.375172E+01_JPRB, 0.384637E+01_JPRB, 0.394167E+01_JPRB &
  &, 0.403761E+01_JPRB, 0.413417E+01_JPRB, 0.423130E+01_JPRB, 0.432901E+01_JPRB &
  &, 0.442725E+01_JPRB, 0.452599E+01_JPRB, 0.462524E+01_JPRB &
  &, 0.472494E+01_JPRB, 0.482508E+01_JPRB, 0.492564E+01_JPRB, 0.502660E+01_JPRB &
  &, 0.512793E+01_JPRB, 0.522960E+01_JPRB, 0.533160E+01_JPRB &
  &, 0.543390E+01_JPRB, 0.553648E+01_JPRB, 0.563932E+01_JPRB, 0.574240E+01_JPRB &
  &, 0.584570E+01_JPRB, 0.594920E+01_JPRB, 0.605287E+01_JPRB &
  &, 0.615671E+01_JPRB, 0.626066E+01_JPRB, 0.636475E+01_JPRB, 0.646894E+01_JPRB &
  &, 0.657319E+01_JPRB, 0.667753E+01_JPRB, 0.678189E+01_JPRB &
  &, 0.688629E+01_JPRB, 0.699068E+01_JPRB, 0.709508E+01_JPRB, 0.719947E+01_JPRB &
  &, 0.730379E+01_JPRB, 0.740807E+01_JPRB, 0.751226E+01_JPRB &
  &, 0.761638E+01_JPRB, 0.772039E+01_JPRB, 0.782428E+01_JPRB, 0.792804E+01_JPRB &
  &, 0.803165E+01_JPRB, 0.813509E+01_JPRB, 0.823835E+01_JPRB &
  &, 0.834142E+01_JPRB, 0.844429E+01_JPRB, 0.854696E+01_JPRB, 0.864939E+01_JPRB &
  &, 0.875157E+01_JPRB, 0.885350E+01_JPRB, 0.895518E+01_JPRB &
  &, 0.905656E+01_JPRB, 0.915766E+01_JPRB, 0.925845E+01_JPRB, 0.935892E+01_JPRB &
  &, 0.945907E+01_JPRB, 0.955891E+01_JPRB, 0.965839E+01_JPRB &
  &, 0.975750E+01_JPRB, 0.985626E+01_JPRB, 0.995463E+01_JPRB, 0.100526E+02_JPRB &
  &, 0.101502E+02_JPRB, 0.102474E+02_JPRB, 0.103442E+02_JPRB &
  &, 0.104406E+02_JPRB, 0.105365E+02_JPRB, 0.106320E+02_JPRB, 0.107270E+02_JPRB &
  &, 0.108216E+02_JPRB, 0.109157E+02_JPRB, 0.110094E+02_JPRB &
  &, 0.111025E+02_JPRB, 0.111952E+02_JPRB, 0.112874E+02_JPRB, 0.113791E+02_JPRB &
  &, 0.114703E+02_JPRB, 0.115609E+02_JPRB, 0.116511E+02_JPRB &
  &, 0.117407E+02_JPRB, 0.118298E+02_JPRB, 0.119183E+02_JPRB, 0.120063E+02_JPRB &
  &, 0.120937E+02_JPRB, 0.121806E+02_JPRB, 0.122669E+02_JPRB &
  &, 0.123526E+02_JPRB, 0.124378E+02_JPRB, 0.125223E+02_JPRB, 0.126063E+02_JPRB &
  &, 0.126897E+02_JPRB, 0.127725E+02_JPRB, 0.128547E+02_JPRB &
  &, 0.129363E+02_JPRB, 0.130172E+02_JPRB, 0.130976E+02_JPRB, 0.131773E+02_JPRB &
  &, 0.132565E+02_JPRB, 0.133349E+02_JPRB, 0.134128E+02_JPRB &
  &, 0.134900E+02_JPRB, 0.135666E+02_JPRB, 0.136426E+02_JPRB, 0.137178E+02_JPRB &
  &, 0.137924E+02_JPRB, 0.138664E+02_JPRB, 0.139398E+02_JPRB/)
XCW( 985, :) = (/ &
  &  0.122918E+01_JPRB, 0.129023E+01_JPRB, 0.135275E+01_JPRB, 0.141672E+01_JPRB &
  &, 0.148212E+01_JPRB, 0.154894E+01_JPRB, 0.161715E+01_JPRB &
  &, 0.168674E+01_JPRB, 0.175768E+01_JPRB, 0.182996E+01_JPRB, 0.190355E+01_JPRB &
  &, 0.197843E+01_JPRB, 0.205458E+01_JPRB, 0.213197E+01_JPRB &
  &, 0.221059E+01_JPRB, 0.229040E+01_JPRB, 0.237139E+01_JPRB, 0.245352E+01_JPRB &
  &, 0.253679E+01_JPRB, 0.262115E+01_JPRB, 0.270659E+01_JPRB &
  &, 0.279307E+01_JPRB, 0.288059E+01_JPRB, 0.296910E+01_JPRB, 0.305858E+01_JPRB &
  &, 0.314901E+01_JPRB, 0.324036E+01_JPRB, 0.333260E+01_JPRB &
  &, 0.342571E+01_JPRB, 0.351967E+01_JPRB, 0.361444E+01_JPRB, 0.370999E+01_JPRB &
  &, 0.380631E+01_JPRB, 0.390337E+01_JPRB, 0.400114E+01_JPRB &
  &, 0.409958E+01_JPRB, 0.419870E+01_JPRB, 0.429845E+01_JPRB, 0.439880E+01_JPRB &
  &, 0.449974E+01_JPRB, 0.460125E+01_JPRB, 0.470327E+01_JPRB &
  &, 0.480581E+01_JPRB, 0.490885E+01_JPRB, 0.501234E+01_JPRB, 0.511626E+01_JPRB &
  &, 0.522060E+01_JPRB, 0.532534E+01_JPRB, 0.543045E+01_JPRB &
  &, 0.553590E+01_JPRB, 0.564168E+01_JPRB, 0.574776E+01_JPRB, 0.585412E+01_JPRB &
  &, 0.596073E+01_JPRB, 0.606759E+01_JPRB, 0.617467E+01_JPRB &
  &, 0.628195E+01_JPRB, 0.638941E+01_JPRB, 0.649703E+01_JPRB, 0.660478E+01_JPRB &
  &, 0.671266E+01_JPRB, 0.682064E+01_JPRB, 0.692870E+01_JPRB &
  &, 0.703684E+01_JPRB, 0.714501E+01_JPRB, 0.725322E+01_JPRB, 0.736145E+01_JPRB &
  &, 0.746966E+01_JPRB, 0.757786E+01_JPRB, 0.768603E+01_JPRB &
  &, 0.779416E+01_JPRB, 0.790219E+01_JPRB, 0.801016E+01_JPRB, 0.811802E+01_JPRB &
  &, 0.822579E+01_JPRB, 0.833341E+01_JPRB, 0.844091E+01_JPRB &
  &, 0.854825E+01_JPRB, 0.865540E+01_JPRB, 0.876241E+01_JPRB, 0.886918E+01_JPRB &
  &, 0.897578E+01_JPRB, 0.908214E+01_JPRB, 0.918826E+01_JPRB &
  &, 0.929415E+01_JPRB, 0.939975E+01_JPRB, 0.950513E+01_JPRB, 0.961020E+01_JPRB &
  &, 0.971497E+01_JPRB, 0.981945E+01_JPRB, 0.992363E+01_JPRB &
  &, 0.100274E+02_JPRB, 0.101310E+02_JPRB, 0.102341E+02_JPRB, 0.103369E+02_JPRB &
  &, 0.104394E+02_JPRB, 0.105414E+02_JPRB, 0.106431E+02_JPRB &
  &, 0.107444E+02_JPRB, 0.108453E+02_JPRB, 0.109457E+02_JPRB, 0.110458E+02_JPRB &
  &, 0.111454E+02_JPRB, 0.112446E+02_JPRB, 0.113433E+02_JPRB &
  &, 0.114416E+02_JPRB, 0.115394E+02_JPRB, 0.116368E+02_JPRB, 0.117336E+02_JPRB &
  &, 0.118300E+02_JPRB, 0.119259E+02_JPRB, 0.120213E+02_JPRB &
  &, 0.121162E+02_JPRB, 0.122106E+02_JPRB, 0.123044E+02_JPRB, 0.123977E+02_JPRB &
  &, 0.124906E+02_JPRB, 0.125828E+02_JPRB, 0.126746E+02_JPRB &
  &, 0.127657E+02_JPRB, 0.128563E+02_JPRB, 0.129464E+02_JPRB, 0.130359E+02_JPRB &
  &, 0.131248E+02_JPRB, 0.132131E+02_JPRB, 0.133009E+02_JPRB &
  &, 0.133880E+02_JPRB, 0.134746E+02_JPRB, 0.135605E+02_JPRB, 0.136459E+02_JPRB &
  &, 0.137306E+02_JPRB, 0.138148E+02_JPRB, 0.138984E+02_JPRB &
  &, 0.139813E+02_JPRB, 0.140636E+02_JPRB, 0.141452E+02_JPRB, 0.142263E+02_JPRB &
  &, 0.143066E+02_JPRB, 0.143864E+02_JPRB, 0.144655E+02_JPRB/)
XCW( 986, :) = (/ &
  &  0.123230E+01_JPRB, 0.129426E+01_JPRB, 0.135773E+01_JPRB, 0.142271E+01_JPRB &
  &, 0.148918E+01_JPRB, 0.155711E+01_JPRB, 0.162649E+01_JPRB &
  &, 0.169730E+01_JPRB, 0.176952E+01_JPRB, 0.184312E+01_JPRB, 0.191809E+01_JPRB &
  &, 0.199440E+01_JPRB, 0.207204E+01_JPRB, 0.215097E+01_JPRB &
  &, 0.223117E+01_JPRB, 0.231263E+01_JPRB, 0.239532E+01_JPRB, 0.247921E+01_JPRB &
  &, 0.256428E+01_JPRB, 0.265050E+01_JPRB, 0.273785E+01_JPRB &
  &, 0.282630E+01_JPRB, 0.291583E+01_JPRB, 0.300641E+01_JPRB, 0.309802E+01_JPRB &
  &, 0.319063E+01_JPRB, 0.328420E+01_JPRB, 0.337873E+01_JPRB &
  &, 0.347417E+01_JPRB, 0.357051E+01_JPRB, 0.366772E+01_JPRB, 0.376576E+01_JPRB &
  &, 0.386463E+01_JPRB, 0.396428E+01_JPRB, 0.406469E+01_JPRB &
  &, 0.416584E+01_JPRB, 0.426769E+01_JPRB, 0.437024E+01_JPRB, 0.447344E+01_JPRB &
  &, 0.457728E+01_JPRB, 0.468173E+01_JPRB, 0.478675E+01_JPRB &
  &, 0.489234E+01_JPRB, 0.499847E+01_JPRB, 0.510510E+01_JPRB, 0.521222E+01_JPRB &
  &, 0.531981E+01_JPRB, 0.542783E+01_JPRB, 0.553627E+01_JPRB &
  &, 0.564511E+01_JPRB, 0.575431E+01_JPRB, 0.586387E+01_JPRB, 0.597376E+01_JPRB &
  &, 0.608395E+01_JPRB, 0.619442E+01_JPRB, 0.630517E+01_JPRB &
  &, 0.641616E+01_JPRB, 0.652737E+01_JPRB, 0.663876E+01_JPRB, 0.675039E+01_JPRB &
  &, 0.686216E+01_JPRB, 0.697407E+01_JPRB, 0.708611E+01_JPRB &
  &, 0.719827E+01_JPRB, 0.731051E+01_JPRB, 0.742282E+01_JPRB, 0.753519E+01_JPRB &
  &, 0.764761E+01_JPRB, 0.776004E+01_JPRB, 0.787248E+01_JPRB &
  &, 0.798492E+01_JPRB, 0.809731E+01_JPRB, 0.820967E+01_JPRB, 0.832199E+01_JPRB &
  &, 0.843423E+01_JPRB, 0.854636E+01_JPRB, 0.865842E+01_JPRB &
  &, 0.877033E+01_JPRB, 0.888214E+01_JPRB, 0.899379E+01_JPRB, 0.910528E+01_JPRB &
  &, 0.921661E+01_JPRB, 0.932775E+01_JPRB, 0.943870E+01_JPRB &
  &, 0.954946E+01_JPRB, 0.965995E+01_JPRB, 0.977024E+01_JPRB, 0.988029E+01_JPRB &
  &, 0.999007E+01_JPRB, 0.100996E+02_JPRB, 0.102088E+02_JPRB &
  &, 0.103178E+02_JPRB, 0.104264E+02_JPRB, 0.105347E+02_JPRB, 0.106427E+02_JPRB &
  &, 0.107504E+02_JPRB, 0.108577E+02_JPRB, 0.109647E+02_JPRB &
  &, 0.110713E+02_JPRB, 0.111775E+02_JPRB, 0.112834E+02_JPRB, 0.113889E+02_JPRB &
  &, 0.114939E+02_JPRB, 0.115986E+02_JPRB, 0.117028E+02_JPRB &
  &, 0.118066E+02_JPRB, 0.119100E+02_JPRB, 0.120130E+02_JPRB, 0.121155E+02_JPRB &
  &, 0.122175E+02_JPRB, 0.123191E+02_JPRB, 0.124202E+02_JPRB &
  &, 0.125208E+02_JPRB, 0.126209E+02_JPRB, 0.127206E+02_JPRB, 0.128197E+02_JPRB &
  &, 0.129184E+02_JPRB, 0.130165E+02_JPRB, 0.131141E+02_JPRB &
  &, 0.132112E+02_JPRB, 0.133077E+02_JPRB, 0.134038E+02_JPRB, 0.134992E+02_JPRB &
  &, 0.135941E+02_JPRB, 0.136884E+02_JPRB, 0.137822E+02_JPRB &
  &, 0.138755E+02_JPRB, 0.139681E+02_JPRB, 0.140602E+02_JPRB, 0.141517E+02_JPRB &
  &, 0.142426E+02_JPRB, 0.143329E+02_JPRB, 0.144227E+02_JPRB &
  &, 0.145118E+02_JPRB, 0.146003E+02_JPRB, 0.146882E+02_JPRB, 0.147755E+02_JPRB &
  &, 0.148621E+02_JPRB, 0.149482E+02_JPRB, 0.150336E+02_JPRB/)
XCW( 987, :) = (/ &
  &  0.123563E+01_JPRB, 0.129855E+01_JPRB, 0.136305E+01_JPRB, 0.142911E+01_JPRB &
  &, 0.149671E+01_JPRB, 0.156584E+01_JPRB, 0.163647E+01_JPRB &
  &, 0.170858E+01_JPRB, 0.178216E+01_JPRB, 0.185718E+01_JPRB, 0.193363E+01_JPRB &
  &, 0.201148E+01_JPRB, 0.209071E+01_JPRB, 0.217129E+01_JPRB &
  &, 0.225320E+01_JPRB, 0.233643E+01_JPRB, 0.242094E+01_JPRB, 0.250671E+01_JPRB &
  &, 0.259372E+01_JPRB, 0.268193E+01_JPRB, 0.277134E+01_JPRB &
  &, 0.286191E+01_JPRB, 0.295361E+01_JPRB, 0.304641E+01_JPRB, 0.314030E+01_JPRB &
  &, 0.323525E+01_JPRB, 0.333123E+01_JPRB, 0.342821E+01_JPRB &
  &, 0.352616E+01_JPRB, 0.362507E+01_JPRB, 0.372490E+01_JPRB, 0.382563E+01_JPRB &
  &, 0.392723E+01_JPRB, 0.402967E+01_JPRB, 0.413293E+01_JPRB &
  &, 0.423698E+01_JPRB, 0.434180E+01_JPRB, 0.444736E+01_JPRB, 0.455363E+01_JPRB &
  &, 0.466059E+01_JPRB, 0.476821E+01_JPRB, 0.487647E+01_JPRB &
  &, 0.498536E+01_JPRB, 0.509481E+01_JPRB, 0.520485E+01_JPRB, 0.531541E+01_JPRB &
  &, 0.542649E+01_JPRB, 0.553807E+01_JPRB, 0.565011E+01_JPRB &
  &, 0.576260E+01_JPRB, 0.587552E+01_JPRB, 0.598883E+01_JPRB, 0.610253E+01_JPRB &
  &, 0.621659E+01_JPRB, 0.633097E+01_JPRB, 0.644568E+01_JPRB &
  &, 0.656067E+01_JPRB, 0.667596E+01_JPRB, 0.679147E+01_JPRB, 0.690723E+01_JPRB &
  &, 0.702321E+01_JPRB, 0.713937E+01_JPRB, 0.725571E+01_JPRB &
  &, 0.737222E+01_JPRB, 0.748886E+01_JPRB, 0.760562E+01_JPRB, 0.772248E+01_JPRB &
  &, 0.783943E+01_JPRB, 0.795646E+01_JPRB, 0.807353E+01_JPRB &
  &, 0.819063E+01_JPRB, 0.830775E+01_JPRB, 0.842488E+01_JPRB, 0.854199E+01_JPRB &
  &, 0.865906E+01_JPRB, 0.877612E+01_JPRB, 0.889309E+01_JPRB &
  &, 0.901000E+01_JPRB, 0.912682E+01_JPRB, 0.924355E+01_JPRB, 0.936015E+01_JPRB &
  &, 0.947662E+01_JPRB, 0.959295E+01_JPRB, 0.970915E+01_JPRB &
  &, 0.982514E+01_JPRB, 0.994097E+01_JPRB, 0.100566E+02_JPRB, 0.101720E+02_JPRB &
  &, 0.102872E+02_JPRB, 0.104022E+02_JPRB, 0.105170E+02_JPRB &
  &, 0.106313E+02_JPRB, 0.107457E+02_JPRB, 0.108596E+02_JPRB, 0.109733E+02_JPRB &
  &, 0.110866E+02_JPRB, 0.111997E+02_JPRB, 0.113124E+02_JPRB &
  &, 0.114248E+02_JPRB, 0.115369E+02_JPRB, 0.116486E+02_JPRB, 0.117600E+02_JPRB &
  &, 0.118710E+02_JPRB, 0.119816E+02_JPRB, 0.120919E+02_JPRB &
  &, 0.122017E+02_JPRB, 0.123112E+02_JPRB, 0.124202E+02_JPRB, 0.125288E+02_JPRB &
  &, 0.126371E+02_JPRB, 0.127448E+02_JPRB, 0.128521E+02_JPRB &
  &, 0.129590E+02_JPRB, 0.130654E+02_JPRB, 0.131714E+02_JPRB, 0.132769E+02_JPRB &
  &, 0.133819E+02_JPRB, 0.134864E+02_JPRB, 0.135905E+02_JPRB &
  &, 0.136940E+02_JPRB, 0.137970E+02_JPRB, 0.138995E+02_JPRB, 0.140015E+02_JPRB &
  &, 0.141030E+02_JPRB, 0.142039E+02_JPRB, 0.143043E+02_JPRB &
  &, 0.144042E+02_JPRB, 0.145035E+02_JPRB, 0.146023E+02_JPRB, 0.147005E+02_JPRB &
  &, 0.147981E+02_JPRB, 0.148952E+02_JPRB, 0.149917E+02_JPRB &
  &, 0.150876E+02_JPRB, 0.151829E+02_JPRB, 0.152777E+02_JPRB, 0.153719E+02_JPRB &
  &, 0.154654E+02_JPRB, 0.155583E+02_JPRB, 0.156507E+02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART141',1,ZHOOK_HANDLE)
END SUBROUTINE PART141

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART142

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART142',0,ZHOOK_HANDLE)

XCW( 988, :) = (/ &
  &  0.123919E+01_JPRB, 0.130315E+01_JPRB, 0.136875E+01_JPRB, 0.143597E+01_JPRB &
  &, 0.150479E+01_JPRB, 0.157520E+01_JPRB, 0.164717E+01_JPRB &
  &, 0.172069E+01_JPRB, 0.179574E+01_JPRB, 0.187229E+01_JPRB, 0.195033E+01_JPRB &
  &, 0.202983E+01_JPRB, 0.211078E+01_JPRB, 0.219314E+01_JPRB &
  &, 0.227690E+01_JPRB, 0.236203E+01_JPRB, 0.244851E+01_JPRB, 0.253631E+01_JPRB &
  &, 0.262541E+01_JPRB, 0.271579E+01_JPRB, 0.280741E+01_JPRB &
  &, 0.290026E+01_JPRB, 0.299431E+01_JPRB, 0.308952E+01_JPRB, 0.318588E+01_JPRB &
  &, 0.328336E+01_JPRB, 0.338194E+01_JPRB, 0.348157E+01_JPRB &
  &, 0.358225E+01_JPRB, 0.368393E+01_JPRB, 0.378661E+01_JPRB, 0.389024E+01_JPRB &
  &, 0.399481E+01_JPRB, 0.410027E+01_JPRB, 0.420662E+01_JPRB &
  &, 0.431382E+01_JPRB, 0.442184E+01_JPRB, 0.453067E+01_JPRB, 0.464027E+01_JPRB &
  &, 0.475062E+01_JPRB, 0.486168E+01_JPRB, 0.497345E+01_JPRB &
  &, 0.508590E+01_JPRB, 0.519898E+01_JPRB, 0.531269E+01_JPRB, 0.542701E+01_JPRB &
  &, 0.554189E+01_JPRB, 0.565731E+01_JPRB, 0.577327E+01_JPRB &
  &, 0.588973E+01_JPRB, 0.600668E+01_JPRB, 0.612407E+01_JPRB, 0.624191E+01_JPRB &
  &, 0.636016E+01_JPRB, 0.647879E+01_JPRB, 0.659780E+01_JPRB &
  &, 0.671716E+01_JPRB, 0.683685E+01_JPRB, 0.695684E+01_JPRB, 0.707713E+01_JPRB &
  &, 0.719768E+01_JPRB, 0.731847E+01_JPRB, 0.743950E+01_JPRB &
  &, 0.756073E+01_JPRB, 0.768215E+01_JPRB, 0.780376E+01_JPRB, 0.792551E+01_JPRB &
  &, 0.804740E+01_JPRB, 0.816941E+01_JPRB, 0.829153E+01_JPRB &
  &, 0.841373E+01_JPRB, 0.853599E+01_JPRB, 0.865831E+01_JPRB, 0.878065E+01_JPRB &
  &, 0.890304E+01_JPRB, 0.902541E+01_JPRB, 0.914777E+01_JPRB &
  &, 0.927012E+01_JPRB, 0.939241E+01_JPRB, 0.951468E+01_JPRB, 0.963685E+01_JPRB &
  &, 0.975893E+01_JPRB, 0.988073E+01_JPRB, 0.100028E+02_JPRB &
  &, 0.101246E+02_JPRB, 0.102462E+02_JPRB, 0.103677E+02_JPRB, 0.104890E+02_JPRB &
  &, 0.106101E+02_JPRB, 0.107311E+02_JPRB, 0.108519E+02_JPRB &
  &, 0.109724E+02_JPRB, 0.110927E+02_JPRB, 0.112128E+02_JPRB, 0.113327E+02_JPRB &
  &, 0.114522E+02_JPRB, 0.115715E+02_JPRB, 0.116906E+02_JPRB &
  &, 0.118093E+02_JPRB, 0.119278E+02_JPRB, 0.120459E+02_JPRB, 0.121638E+02_JPRB &
  &, 0.122813E+02_JPRB, 0.123985E+02_JPRB, 0.125153E+02_JPRB &
  &, 0.126317E+02_JPRB, 0.127479E+02_JPRB, 0.128636E+02_JPRB, 0.129789E+02_JPRB &
  &, 0.130939E+02_JPRB, 0.132084E+02_JPRB, 0.133226E+02_JPRB &
  &, 0.134364E+02_JPRB, 0.135497E+02_JPRB, 0.136625E+02_JPRB, 0.137750E+02_JPRB &
  &, 0.138870E+02_JPRB, 0.139985E+02_JPRB, 0.141096E+02_JPRB &
  &, 0.142203E+02_JPRB, 0.143304E+02_JPRB, 0.144400E+02_JPRB, 0.145493E+02_JPRB &
  &, 0.146579E+02_JPRB, 0.147661E+02_JPRB, 0.148738E+02_JPRB &
  &, 0.149809E+02_JPRB, 0.150876E+02_JPRB, 0.151937E+02_JPRB, 0.152993E+02_JPRB &
  &, 0.154044E+02_JPRB, 0.155089E+02_JPRB, 0.156129E+02_JPRB &
  &, 0.157162E+02_JPRB, 0.158191E+02_JPRB, 0.159214E+02_JPRB, 0.160231E+02_JPRB &
  &, 0.161243E+02_JPRB, 0.162249E+02_JPRB, 0.163249E+02_JPRB/)
XCW( 989, :) = (/ &
  &  0.124302E+01_JPRB, 0.130811E+01_JPRB, 0.137489E+01_JPRB, 0.144336E+01_JPRB &
  &, 0.151351E+01_JPRB, 0.158530E+01_JPRB, 0.165873E+01_JPRB &
  &, 0.173377E+01_JPRB, 0.181041E+01_JPRB, 0.188862E+01_JPRB, 0.196839E+01_JPRB &
  &, 0.204969E+01_JPRB, 0.213249E+01_JPRB, 0.221679E+01_JPRB &
  &, 0.230255E+01_JPRB, 0.238975E+01_JPRB, 0.247837E+01_JPRB, 0.256838E+01_JPRB &
  &, 0.265976E+01_JPRB, 0.275248E+01_JPRB, 0.284652E+01_JPRB &
  &, 0.294185E+01_JPRB, 0.303844E+01_JPRB, 0.313628E+01_JPRB, 0.323533E+01_JPRB &
  &, 0.333557E+01_JPRB, 0.343696E+01_JPRB, 0.353950E+01_JPRB &
  &, 0.364313E+01_JPRB, 0.374785E+01_JPRB, 0.385362E+01_JPRB, 0.396042E+01_JPRB &
  &, 0.406821E+01_JPRB, 0.417698E+01_JPRB, 0.428670E+01_JPRB &
  &, 0.439733E+01_JPRB, 0.450885E+01_JPRB, 0.462124E+01_JPRB, 0.473448E+01_JPRB &
  &, 0.484853E+01_JPRB, 0.496336E+01_JPRB, 0.507896E+01_JPRB &
  &, 0.519530E+01_JPRB, 0.531233E+01_JPRB, 0.543007E+01_JPRB, 0.554846E+01_JPRB &
  &, 0.566750E+01_JPRB, 0.578714E+01_JPRB, 0.590738E+01_JPRB &
  &, 0.602818E+01_JPRB, 0.614953E+01_JPRB, 0.627139E+01_JPRB, 0.639375E+01_JPRB &
  &, 0.651659E+01_JPRB, 0.663988E+01_JPRB, 0.676360E+01_JPRB &
  &, 0.688771E+01_JPRB, 0.701225E+01_JPRB, 0.713713E+01_JPRB, 0.726237E+01_JPRB &
  &, 0.738792E+01_JPRB, 0.751380E+01_JPRB, 0.763995E+01_JPRB &
  &, 0.776638E+01_JPRB, 0.789305E+01_JPRB, 0.801995E+01_JPRB, 0.814706E+01_JPRB &
  &, 0.827437E+01_JPRB, 0.840186E+01_JPRB, 0.852950E+01_JPRB &
  &, 0.865727E+01_JPRB, 0.878518E+01_JPRB, 0.891319E+01_JPRB, 0.904129E+01_JPRB &
  &, 0.916948E+01_JPRB, 0.929771E+01_JPRB, 0.942598E+01_JPRB &
  &, 0.955429E+01_JPRB, 0.968260E+01_JPRB, 0.981093E+01_JPRB, 0.993924E+01_JPRB &
  &, 0.100675E+02_JPRB, 0.101957E+02_JPRB, 0.103239E+02_JPRB &
  &, 0.104520E+02_JPRB, 0.105800E+02_JPRB, 0.107079E+02_JPRB, 0.108357E+02_JPRB &
  &, 0.109633E+02_JPRB, 0.110909E+02_JPRB, 0.112182E+02_JPRB &
  &, 0.113454E+02_JPRB, 0.114725E+02_JPRB, 0.115993E+02_JPRB, 0.117260E+02_JPRB &
  &, 0.118524E+02_JPRB, 0.119786E+02_JPRB, 0.121046E+02_JPRB &
  &, 0.122304E+02_JPRB, 0.123559E+02_JPRB, 0.124811E+02_JPRB, 0.126061E+02_JPRB &
  &, 0.127307E+02_JPRB, 0.128551E+02_JPRB, 0.129792E+02_JPRB &
  &, 0.131029E+02_JPRB, 0.132264E+02_JPRB, 0.133495E+02_JPRB, 0.134723E+02_JPRB &
  &, 0.135947E+02_JPRB, 0.137167E+02_JPRB, 0.138385E+02_JPRB &
  &, 0.139598E+02_JPRB, 0.140807E+02_JPRB, 0.142012E+02_JPRB, 0.143214E+02_JPRB &
  &, 0.144411E+02_JPRB, 0.145604E+02_JPRB, 0.146793E+02_JPRB &
  &, 0.147978E+02_JPRB, 0.149158E+02_JPRB, 0.150334E+02_JPRB, 0.151506E+02_JPRB &
  &, 0.152672E+02_JPRB, 0.153834E+02_JPRB, 0.154992E+02_JPRB &
  &, 0.156144E+02_JPRB, 0.157292E+02_JPRB, 0.158435E+02_JPRB, 0.159572E+02_JPRB &
  &, 0.160705E+02_JPRB, 0.161833E+02_JPRB, 0.162956E+02_JPRB &
  &, 0.164073E+02_JPRB, 0.165185E+02_JPRB, 0.166292E+02_JPRB, 0.167393E+02_JPRB &
  &, 0.168489E+02_JPRB, 0.169579E+02_JPRB, 0.170664E+02_JPRB/)
XCW( 990, :) = (/ &
  &  0.124718E+01_JPRB, 0.131348E+01_JPRB, 0.138156E+01_JPRB, 0.145140E+01_JPRB &
  &, 0.152298E+01_JPRB, 0.159628E+01_JPRB, 0.167130E+01_JPRB &
  &, 0.174800E+01_JPRB, 0.182637E+01_JPRB, 0.190640E+01_JPRB, 0.198805E+01_JPRB &
  &, 0.207131E+01_JPRB, 0.215615E+01_JPRB, 0.224256E+01_JPRB &
  &, 0.233051E+01_JPRB, 0.241998E+01_JPRB, 0.251094E+01_JPRB, 0.260337E+01_JPRB &
  &, 0.269724E+01_JPRB, 0.279253E+01_JPRB, 0.288921E+01_JPRB &
  &, 0.298727E+01_JPRB, 0.308666E+01_JPRB, 0.318737E+01_JPRB, 0.328937E+01_JPRB &
  &, 0.339263E+01_JPRB, 0.349713E+01_JPRB, 0.360284E+01_JPRB &
  &, 0.370973E+01_JPRB, 0.381778E+01_JPRB, 0.392695E+01_JPRB, 0.403723E+01_JPRB &
  &, 0.414857E+01_JPRB, 0.426097E+01_JPRB, 0.437439E+01_JPRB &
  &, 0.448879E+01_JPRB, 0.460416E+01_JPRB, 0.472048E+01_JPRB, 0.483771E+01_JPRB &
  &, 0.495583E+01_JPRB, 0.507480E+01_JPRB, 0.519461E+01_JPRB &
  &, 0.531523E+01_JPRB, 0.543663E+01_JPRB, 0.555880E+01_JPRB, 0.568169E+01_JPRB &
  &, 0.580529E+01_JPRB, 0.592958E+01_JPRB, 0.605453E+01_JPRB &
  &, 0.618012E+01_JPRB, 0.630632E+01_JPRB, 0.643310E+01_JPRB, 0.656045E+01_JPRB &
  &, 0.668836E+01_JPRB, 0.681677E+01_JPRB, 0.694569E+01_JPRB &
  &, 0.707509E+01_JPRB, 0.720494E+01_JPRB, 0.733523E+01_JPRB, 0.746593E+01_JPRB &
  &, 0.759703E+01_JPRB, 0.772849E+01_JPRB, 0.786030E+01_JPRB &
  &, 0.799245E+01_JPRB, 0.812492E+01_JPRB, 0.825767E+01_JPRB, 0.839072E+01_JPRB &
  &, 0.852400E+01_JPRB, 0.865753E+01_JPRB, 0.879130E+01_JPRB &
  &, 0.892526E+01_JPRB, 0.905939E+01_JPRB, 0.919371E+01_JPRB, 0.932816E+01_JPRB &
  &, 0.946276E+01_JPRB, 0.959748E+01_JPRB, 0.973230E+01_JPRB &
  &, 0.986721E+01_JPRB, 0.100022E+02_JPRB, 0.101372E+02_JPRB, 0.102723E+02_JPRB &
  &, 0.104074E+02_JPRB, 0.105425E+02_JPRB, 0.106777E+02_JPRB &
  &, 0.108127E+02_JPRB, 0.109478E+02_JPRB, 0.110829E+02_JPRB, 0.112178E+02_JPRB &
  &, 0.113527E+02_JPRB, 0.114875E+02_JPRB, 0.116222E+02_JPRB &
  &, 0.117569E+02_JPRB, 0.118913E+02_JPRB, 0.120257E+02_JPRB, 0.121599E+02_JPRB &
  &, 0.122940E+02_JPRB, 0.124279E+02_JPRB, 0.125615E+02_JPRB &
  &, 0.126951E+02_JPRB, 0.128284E+02_JPRB, 0.129615E+02_JPRB, 0.130943E+02_JPRB &
  &, 0.132270E+02_JPRB, 0.133594E+02_JPRB, 0.134915E+02_JPRB &
  &, 0.136234E+02_JPRB, 0.137550E+02_JPRB, 0.138863E+02_JPRB, 0.140174E+02_JPRB &
  &, 0.141481E+02_JPRB, 0.142785E+02_JPRB, 0.144086E+02_JPRB &
  &, 0.145383E+02_JPRB, 0.146678E+02_JPRB, 0.147968E+02_JPRB, 0.149256E+02_JPRB &
  &, 0.150539E+02_JPRB, 0.151819E+02_JPRB, 0.153095E+02_JPRB &
  &, 0.154367E+02_JPRB, 0.155636E+02_JPRB, 0.156899E+02_JPRB, 0.158160E+02_JPRB &
  &, 0.159415E+02_JPRB, 0.160667E+02_JPRB, 0.161914E+02_JPRB &
  &, 0.163157E+02_JPRB, 0.164396E+02_JPRB, 0.165630E+02_JPRB, 0.166859E+02_JPRB &
  &, 0.168084E+02_JPRB, 0.169304E+02_JPRB, 0.170519E+02_JPRB &
  &, 0.171729E+02_JPRB, 0.172935E+02_JPRB, 0.174135E+02_JPRB, 0.175330E+02_JPRB &
  &, 0.176520E+02_JPRB, 0.177706E+02_JPRB, 0.178886E+02_JPRB/)
XCW( 991, :) = (/ &
  &  0.125173E+01_JPRB, 0.131937E+01_JPRB, 0.138887E+01_JPRB, 0.146020E+01_JPRB &
  &, 0.153336E+01_JPRB, 0.160833E+01_JPRB, 0.168509E+01_JPRB &
  &, 0.176362E+01_JPRB, 0.184390E+01_JPRB, 0.192592E+01_JPRB, 0.200965E+01_JPRB &
  &, 0.209507E+01_JPRB, 0.218217E+01_JPRB, 0.227091E+01_JPRB &
  &, 0.236127E+01_JPRB, 0.245324E+01_JPRB, 0.254679E+01_JPRB, 0.264189E+01_JPRB &
  &, 0.273852E+01_JPRB, 0.283665E+01_JPRB, 0.293626E+01_JPRB &
  &, 0.303732E+01_JPRB, 0.313982E+01_JPRB, 0.324371E+01_JPRB, 0.334897E+01_JPRB &
  &, 0.345559E+01_JPRB, 0.356352E+01_JPRB, 0.367275E+01_JPRB &
  &, 0.378324E+01_JPRB, 0.389498E+01_JPRB, 0.400792E+01_JPRB, 0.412205E+01_JPRB &
  &, 0.423734E+01_JPRB, 0.435376E+01_JPRB, 0.447128E+01_JPRB &
  &, 0.458988E+01_JPRB, 0.470953E+01_JPRB, 0.483019E+01_JPRB, 0.495186E+01_JPRB &
  &, 0.507450E+01_JPRB, 0.519807E+01_JPRB, 0.532256E+01_JPRB &
  &, 0.544794E+01_JPRB, 0.557419E+01_JPRB, 0.570128E+01_JPRB, 0.582918E+01_JPRB &
  &, 0.595787E+01_JPRB, 0.608732E+01_JPRB, 0.621751E+01_JPRB &
  &, 0.634842E+01_JPRB, 0.648002E+01_JPRB, 0.661228E+01_JPRB, 0.674520E+01_JPRB &
  &, 0.687872E+01_JPRB, 0.701285E+01_JPRB, 0.714755E+01_JPRB &
  &, 0.728281E+01_JPRB, 0.741861E+01_JPRB, 0.755491E+01_JPRB, 0.769170E+01_JPRB &
  &, 0.782896E+01_JPRB, 0.796667E+01_JPRB, 0.810479E+01_JPRB &
  &, 0.824333E+01_JPRB, 0.838227E+01_JPRB, 0.852156E+01_JPRB, 0.866120E+01_JPRB &
  &, 0.880117E+01_JPRB, 0.894145E+01_JPRB, 0.908203E+01_JPRB &
  &, 0.922288E+01_JPRB, 0.936398E+01_JPRB, 0.950533E+01_JPRB, 0.964689E+01_JPRB &
  &, 0.978868E+01_JPRB, 0.993064E+01_JPRB, 0.100728E+02_JPRB &
  &, 0.102150E+02_JPRB, 0.103575E+02_JPRB, 0.105000E+02_JPRB, 0.106427E+02_JPRB &
  &, 0.107854E+02_JPRB, 0.109283E+02_JPRB, 0.110712E+02_JPRB &
  &, 0.112141E+02_JPRB, 0.113571E+02_JPRB, 0.115001E+02_JPRB, 0.116431E+02_JPRB &
  &, 0.117861E+02_JPRB, 0.119291E+02_JPRB, 0.120720E+02_JPRB &
  &, 0.122149E+02_JPRB, 0.123577E+02_JPRB, 0.125005E+02_JPRB, 0.126432E+02_JPRB &
  &, 0.127858E+02_JPRB, 0.129282E+02_JPRB, 0.130706E+02_JPRB &
  &, 0.132128E+02_JPRB, 0.133549E+02_JPRB, 0.134968E+02_JPRB, 0.136386E+02_JPRB &
  &, 0.137802E+02_JPRB, 0.139216E+02_JPRB, 0.140628E+02_JPRB &
  &, 0.142038E+02_JPRB, 0.143445E+02_JPRB, 0.144851E+02_JPRB, 0.146254E+02_JPRB &
  &, 0.147654E+02_JPRB, 0.149052E+02_JPRB, 0.150448E+02_JPRB &
  &, 0.151840E+02_JPRB, 0.153230E+02_JPRB, 0.154617E+02_JPRB, 0.156000E+02_JPRB &
  &, 0.157381E+02_JPRB, 0.158758E+02_JPRB, 0.160132E+02_JPRB &
  &, 0.161503E+02_JPRB, 0.162870E+02_JPRB, 0.164234E+02_JPRB, 0.165594E+02_JPRB &
  &, 0.166950E+02_JPRB, 0.168303E+02_JPRB, 0.169652E+02_JPRB &
  &, 0.170996E+02_JPRB, 0.172338E+02_JPRB, 0.173674E+02_JPRB, 0.175007E+02_JPRB &
  &, 0.176335E+02_JPRB, 0.177659E+02_JPRB, 0.178979E+02_JPRB &
  &, 0.180294E+02_JPRB, 0.181605E+02_JPRB, 0.182912E+02_JPRB, 0.184214E+02_JPRB &
  &, 0.185511E+02_JPRB, 0.186803E+02_JPRB, 0.188090E+02_JPRB/)
XCW( 992, :) = (/ &
  &  0.125676E+01_JPRB, 0.132588E+01_JPRB, 0.139695E+01_JPRB, 0.146994E+01_JPRB &
  &, 0.154486E+01_JPRB, 0.162167E+01_JPRB, 0.170037E+01_JPRB &
  &, 0.178094E+01_JPRB, 0.186335E+01_JPRB, 0.194759E+01_JPRB, 0.203364E+01_JPRB &
  &, 0.212147E+01_JPRB, 0.221107E+01_JPRB, 0.230242E+01_JPRB &
  &, 0.239548E+01_JPRB, 0.249024E+01_JPRB, 0.258668E+01_JPRB, 0.268476E+01_JPRB &
  &, 0.278447E+01_JPRB, 0.288578E+01_JPRB, 0.298867E+01_JPRB &
  &, 0.309310E+01_JPRB, 0.319906E+01_JPRB, 0.330651E+01_JPRB, 0.341544E+01_JPRB &
  &, 0.352580E+01_JPRB, 0.363759E+01_JPRB, 0.375076E+01_JPRB &
  &, 0.386529E+01_JPRB, 0.398116E+01_JPRB, 0.409834E+01_JPRB, 0.421679E+01_JPRB &
  &, 0.433650E+01_JPRB, 0.445744E+01_JPRB, 0.457957E+01_JPRB &
  &, 0.470287E+01_JPRB, 0.482728E+01_JPRB, 0.495287E+01_JPRB, 0.507952E+01_JPRB &
  &, 0.520723E+01_JPRB, 0.533597E+01_JPRB, 0.546572E+01_JPRB &
  &, 0.559646E+01_JPRB, 0.572815E+01_JPRB, 0.586077E+01_JPRB, 0.599430E+01_JPRB &
  &, 0.612871E+01_JPRB, 0.626398E+01_JPRB, 0.640006E+01_JPRB &
  &, 0.653696E+01_JPRB, 0.667463E+01_JPRB, 0.681307E+01_JPRB, 0.695224E+01_JPRB &
  &, 0.709211E+01_JPRB, 0.723267E+01_JPRB, 0.737390E+01_JPRB &
  &, 0.751576E+01_JPRB, 0.765825E+01_JPRB, 0.780134E+01_JPRB, 0.794500E+01_JPRB &
  &, 0.808919E+01_JPRB, 0.823394E+01_JPRB, 0.837920E+01_JPRB &
  &, 0.852495E+01_JPRB, 0.867117E+01_JPRB, 0.881782E+01_JPRB, 0.896493E+01_JPRB &
  &, 0.911243E+01_JPRB, 0.926035E+01_JPRB, 0.940861E+01_JPRB &
  &, 0.955725E+01_JPRB, 0.970624E+01_JPRB, 0.985553E+01_JPRB, 0.100051E+02_JPRB &
  &, 0.101550E+02_JPRB, 0.103051E+02_JPRB, 0.104555E+02_JPRB &
  &, 0.106062E+02_JPRB, 0.107570E+02_JPRB, 0.109081E+02_JPRB, 0.110593E+02_JPRB &
  &, 0.112107E+02_JPRB, 0.113623E+02_JPRB, 0.115140E+02_JPRB &
  &, 0.116658E+02_JPRB, 0.118177E+02_JPRB, 0.119697E+02_JPRB, 0.121218E+02_JPRB &
  &, 0.122740E+02_JPRB, 0.124262E+02_JPRB, 0.125785E+02_JPRB &
  &, 0.127308E+02_JPRB, 0.128831E+02_JPRB, 0.130354E+02_JPRB, 0.131877E+02_JPRB &
  &, 0.133400E+02_JPRB, 0.134922E+02_JPRB, 0.136443E+02_JPRB &
  &, 0.137965E+02_JPRB, 0.139485E+02_JPRB, 0.141005E+02_JPRB, 0.142523E+02_JPRB &
  &, 0.144040E+02_JPRB, 0.145557E+02_JPRB, 0.147071E+02_JPRB &
  &, 0.148585E+02_JPRB, 0.150097E+02_JPRB, 0.151607E+02_JPRB, 0.153116E+02_JPRB &
  &, 0.154623E+02_JPRB, 0.156128E+02_JPRB, 0.157630E+02_JPRB &
  &, 0.159131E+02_JPRB, 0.160629E+02_JPRB, 0.162125E+02_JPRB, 0.163619E+02_JPRB &
  &, 0.165110E+02_JPRB, 0.166598E+02_JPRB, 0.168084E+02_JPRB &
  &, 0.169567E+02_JPRB, 0.171047E+02_JPRB, 0.172524E+02_JPRB, 0.173998E+02_JPRB &
  &, 0.175469E+02_JPRB, 0.176937E+02_JPRB, 0.178402E+02_JPRB &
  &, 0.179863E+02_JPRB, 0.181320E+02_JPRB, 0.182775E+02_JPRB, 0.184225E+02_JPRB &
  &, 0.185672E+02_JPRB, 0.187115E+02_JPRB, 0.188555E+02_JPRB &
  &, 0.189990E+02_JPRB, 0.191422E+02_JPRB, 0.192849E+02_JPRB, 0.194273E+02_JPRB &
  &, 0.195692E+02_JPRB, 0.197107E+02_JPRB, 0.198517E+02_JPRB/)
XCW( 993, :) = (/ &
  &  0.126240E+01_JPRB, 0.133318E+01_JPRB, 0.140601E+01_JPRB, 0.148088E+01_JPRB &
  &, 0.155776E+01_JPRB, 0.163666E+01_JPRB, 0.171755E+01_JPRB &
  &, 0.180041E+01_JPRB, 0.188522E+01_JPRB, 0.197197E+01_JPRB, 0.206063E+01_JPRB &
  &, 0.215119E+01_JPRB, 0.224363E+01_JPRB, 0.233792E+01_JPRB &
  &, 0.243404E+01_JPRB, 0.253196E+01_JPRB, 0.263167E+01_JPRB, 0.273314E+01_JPRB &
  &, 0.283634E+01_JPRB, 0.294126E+01_JPRB, 0.304785E+01_JPRB &
  &, 0.315611E+01_JPRB, 0.326600E+01_JPRB, 0.337750E+01_JPRB, 0.349058E+01_JPRB &
  &, 0.360521E+01_JPRB, 0.372137E+01_JPRB, 0.383903E+01_JPRB &
  &, 0.395815E+01_JPRB, 0.407872E+01_JPRB, 0.420072E+01_JPRB, 0.432409E+01_JPRB &
  &, 0.444883E+01_JPRB, 0.457490E+01_JPRB, 0.470228E+01_JPRB &
  &, 0.483094E+01_JPRB, 0.496084E+01_JPRB, 0.509197E+01_JPRB, 0.522429E+01_JPRB &
  &, 0.535779E+01_JPRB, 0.549243E+01_JPRB, 0.562818E+01_JPRB &
  &, 0.576503E+01_JPRB, 0.590292E+01_JPRB, 0.604187E+01_JPRB, 0.618181E+01_JPRB &
  &, 0.632275E+01_JPRB, 0.646465E+01_JPRB, 0.660747E+01_JPRB &
  &, 0.675120E+01_JPRB, 0.689583E+01_JPRB, 0.704130E+01_JPRB, 0.718761E+01_JPRB &
  &, 0.733474E+01_JPRB, 0.748266E+01_JPRB, 0.763134E+01_JPRB &
  &, 0.778075E+01_JPRB, 0.793090E+01_JPRB, 0.808173E+01_JPRB, 0.823324E+01_JPRB &
  &, 0.838541E+01_JPRB, 0.853821E+01_JPRB, 0.869160E+01_JPRB &
  &, 0.884560E+01_JPRB, 0.900017E+01_JPRB, 0.915528E+01_JPRB, 0.931092E+01_JPRB &
  &, 0.946706E+01_JPRB, 0.962370E+01_JPRB, 0.978081E+01_JPRB &
  &, 0.993838E+01_JPRB, 0.100964E+02_JPRB, 0.102548E+02_JPRB, 0.104136E+02_JPRB &
  &, 0.105727E+02_JPRB, 0.107323E+02_JPRB, 0.108921E+02_JPRB &
  &, 0.110524E+02_JPRB, 0.112129E+02_JPRB, 0.113737E+02_JPRB, 0.115347E+02_JPRB &
  &, 0.116961E+02_JPRB, 0.118577E+02_JPRB, 0.120195E+02_JPRB &
  &, 0.121815E+02_JPRB, 0.123437E+02_JPRB, 0.125061E+02_JPRB, 0.126687E+02_JPRB &
  &, 0.128314E+02_JPRB, 0.129943E+02_JPRB, 0.131573E+02_JPRB &
  &, 0.133204E+02_JPRB, 0.134836E+02_JPRB, 0.136469E+02_JPRB, 0.138102E+02_JPRB &
  &, 0.139736E+02_JPRB, 0.141371E+02_JPRB, 0.143005E+02_JPRB &
  &, 0.144640E+02_JPRB, 0.146275E+02_JPRB, 0.147910E+02_JPRB, 0.149545E+02_JPRB &
  &, 0.151180E+02_JPRB, 0.152814E+02_JPRB, 0.154447E+02_JPRB &
  &, 0.156081E+02_JPRB, 0.157713E+02_JPRB, 0.159344E+02_JPRB, 0.160974E+02_JPRB &
  &, 0.162604E+02_JPRB, 0.164231E+02_JPRB, 0.165858E+02_JPRB &
  &, 0.167484E+02_JPRB, 0.169108E+02_JPRB, 0.170730E+02_JPRB, 0.172351E+02_JPRB &
  &, 0.173969E+02_JPRB, 0.175586E+02_JPRB, 0.177201E+02_JPRB &
  &, 0.178814E+02_JPRB, 0.180425E+02_JPRB, 0.182033E+02_JPRB, 0.183639E+02_JPRB &
  &, 0.185243E+02_JPRB, 0.186844E+02_JPRB, 0.188443E+02_JPRB &
  &, 0.190039E+02_JPRB, 0.191632E+02_JPRB, 0.193222E+02_JPRB, 0.194809E+02_JPRB &
  &, 0.196394E+02_JPRB, 0.197975E+02_JPRB, 0.199553E+02_JPRB &
  &, 0.201128E+02_JPRB, 0.202699E+02_JPRB, 0.204267E+02_JPRB, 0.205832E+02_JPRB &
  &, 0.207393E+02_JPRB, 0.208951E+02_JPRB, 0.210504E+02_JPRB/)
XCW( 994, :) = (/ &
  &  0.126881E+01_JPRB, 0.134149E+01_JPRB, 0.141634E+01_JPRB, 0.149335E+01_JPRB &
  &, 0.157250E+01_JPRB, 0.165378E+01_JPRB, 0.173717E+01_JPRB &
  &, 0.182267E+01_JPRB, 0.191024E+01_JPRB, 0.199987E+01_JPRB, 0.209155E+01_JPRB &
  &, 0.218525E+01_JPRB, 0.228095E+01_JPRB, 0.237863E+01_JPRB &
  &, 0.247827E+01_JPRB, 0.257984E+01_JPRB, 0.268332E+01_JPRB, 0.278870E+01_JPRB &
  &, 0.289593E+01_JPRB, 0.300501E+01_JPRB, 0.311590E+01_JPRB &
  &, 0.322857E+01_JPRB, 0.334301E+01_JPRB, 0.345919E+01_JPRB, 0.357707E+01_JPRB &
  &, 0.369664E+01_JPRB, 0.381785E+01_JPRB, 0.394070E+01_JPRB &
  &, 0.406515E+01_JPRB, 0.419117E+01_JPRB, 0.431874E+01_JPRB, 0.444782E+01_JPRB &
  &, 0.457839E+01_JPRB, 0.471042E+01_JPRB, 0.484388E+01_JPRB &
  &, 0.497874E+01_JPRB, 0.511499E+01_JPRB, 0.525259E+01_JPRB, 0.539151E+01_JPRB &
  &, 0.553172E+01_JPRB, 0.567320E+01_JPRB, 0.581592E+01_JPRB &
  &, 0.595986E+01_JPRB, 0.610497E+01_JPRB, 0.625126E+01_JPRB, 0.639867E+01_JPRB &
  &, 0.654719E+01_JPRB, 0.669679E+01_JPRB, 0.684746E+01_JPRB &
  &, 0.699915E+01_JPRB, 0.715185E+01_JPRB, 0.730552E+01_JPRB, 0.746016E+01_JPRB &
  &, 0.761573E+01_JPRB, 0.777220E+01_JPRB, 0.792956E+01_JPRB &
  &, 0.808778E+01_JPRB, 0.824685E+01_JPRB, 0.840672E+01_JPRB, 0.856738E+01_JPRB &
  &, 0.872876E+01_JPRB, 0.889101E+01_JPRB, 0.905392E+01_JPRB &
  &, 0.921753E+01_JPRB, 0.938183E+01_JPRB, 0.954679E+01_JPRB, 0.971240E+01_JPRB &
  &, 0.987863E+01_JPRB, 0.100455E+02_JPRB, 0.102129E+02_JPRB &
  &, 0.103808E+02_JPRB, 0.105494E+02_JPRB, 0.107184E+02_JPRB, 0.108880E+02_JPRB &
  &, 0.110580E+02_JPRB, 0.112285E+02_JPRB, 0.113995E+02_JPRB &
  &, 0.115709E+02_JPRB, 0.117427E+02_JPRB, 0.119149E+02_JPRB, 0.120875E+02_JPRB &
  &, 0.122605E+02_JPRB, 0.124338E+02_JPRB, 0.126075E+02_JPRB &
  &, 0.127814E+02_JPRB, 0.129557E+02_JPRB, 0.131303E+02_JPRB, 0.133051E+02_JPRB &
  &, 0.134802E+02_JPRB, 0.136555E+02_JPRB, 0.138311E+02_JPRB &
  &, 0.140068E+02_JPRB, 0.141828E+02_JPRB, 0.143590E+02_JPRB, 0.145353E+02_JPRB &
  &, 0.147118E+02_JPRB, 0.148884E+02_JPRB, 0.150652E+02_JPRB &
  &, 0.152420E+02_JPRB, 0.154190E+02_JPRB, 0.155961E+02_JPRB, 0.157732E+02_JPRB &
  &, 0.159504E+02_JPRB, 0.161277E+02_JPRB, 0.163049E+02_JPRB &
  &, 0.164823E+02_JPRB, 0.166597E+02_JPRB, 0.168370E+02_JPRB, 0.170144E+02_JPRB &
  &, 0.171918E+02_JPRB, 0.173691E+02_JPRB, 0.175464E+02_JPRB &
  &, 0.177236E+02_JPRB, 0.179008E+02_JPRB, 0.180779E+02_JPRB, 0.182549E+02_JPRB &
  &, 0.184319E+02_JPRB, 0.186087E+02_JPRB, 0.187854E+02_JPRB &
  &, 0.189620E+02_JPRB, 0.191385E+02_JPRB, 0.193148E+02_JPRB, 0.194910E+02_JPRB &
  &, 0.196670E+02_JPRB, 0.198429E+02_JPRB, 0.200186E+02_JPRB &
  &, 0.201941E+02_JPRB, 0.203694E+02_JPRB, 0.205445E+02_JPRB, 0.207194E+02_JPRB &
  &, 0.208941E+02_JPRB, 0.210685E+02_JPRB, 0.212427E+02_JPRB &
  &, 0.214167E+02_JPRB, 0.215904E+02_JPRB, 0.217638E+02_JPRB, 0.219371E+02_JPRB &
  &, 0.221100E+02_JPRB, 0.222826E+02_JPRB, 0.224549E+02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART142',1,ZHOOK_HANDLE)
END SUBROUTINE PART142

#ifdef VPP5000
!OCL SCALAR
#endif
!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0
SUBROUTINE PART143

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART143',0,ZHOOK_HANDLE)

XCW( 995, :) = (/ &
  &  0.127628E+01_JPRB, 0.135118E+01_JPRB, 0.142839E+01_JPRB, 0.150790E+01_JPRB &
  &, 0.158971E+01_JPRB, 0.167379E+01_JPRB, 0.176013E+01_JPRB &
  &, 0.184872E+01_JPRB, 0.193953E+01_JPRB, 0.203256E+01_JPRB, 0.212779E+01_JPRB &
  &, 0.222518E+01_JPRB, 0.232473E+01_JPRB, 0.242642E+01_JPRB &
  &, 0.253021E+01_JPRB, 0.263609E+01_JPRB, 0.274404E+01_JPRB, 0.285402E+01_JPRB &
  &, 0.296603E+01_JPRB, 0.308003E+01_JPRB, 0.319600E+01_JPRB &
  &, 0.331391E+01_JPRB, 0.343373E+01_JPRB, 0.355545E+01_JPRB, 0.367903E+01_JPRB &
  &, 0.380445E+01_JPRB, 0.393167E+01_JPRB, 0.406068E+01_JPRB &
  &, 0.419144E+01_JPRB, 0.432392E+01_JPRB, 0.445811E+01_JPRB, 0.459396E+01_JPRB &
  &, 0.473146E+01_JPRB, 0.487057E+01_JPRB, 0.501127E+01_JPRB &
  &, 0.515352E+01_JPRB, 0.529731E+01_JPRB, 0.544260E+01_JPRB, 0.558936E+01_JPRB &
  &, 0.573757E+01_JPRB, 0.588720E+01_JPRB, 0.603822E+01_JPRB &
  &, 0.619060E+01_JPRB, 0.634432E+01_JPRB, 0.649935E+01_JPRB, 0.665566E+01_JPRB &
  &, 0.681323E+01_JPRB, 0.697203E+01_JPRB, 0.713203E+01_JPRB &
  &, 0.729321E+01_JPRB, 0.745555E+01_JPRB, 0.761901E+01_JPRB, 0.778358E+01_JPRB &
  &, 0.794922E+01_JPRB, 0.811592E+01_JPRB, 0.828365E+01_JPRB &
  &, 0.845238E+01_JPRB, 0.862209E+01_JPRB, 0.879276E+01_JPRB, 0.896438E+01_JPRB &
  &, 0.913690E+01_JPRB, 0.931030E+01_JPRB, 0.948459E+01_JPRB &
  &, 0.965971E+01_JPRB, 0.983567E+01_JPRB, 0.100124E+02_JPRB, 0.101900E+02_JPRB &
  &, 0.103683E+02_JPRB, 0.105473E+02_JPRB, 0.107271E+02_JPRB &
  &, 0.109075E+02_JPRB, 0.110886E+02_JPRB, 0.112705E+02_JPRB, 0.114529E+02_JPRB &
  &, 0.116360E+02_JPRB, 0.118196E+02_JPRB, 0.120039E+02_JPRB &
  &, 0.121887E+02_JPRB, 0.123741E+02_JPRB, 0.125600E+02_JPRB, 0.127465E+02_JPRB &
  &, 0.129334E+02_JPRB, 0.131208E+02_JPRB, 0.133087E+02_JPRB &
  &, 0.134970E+02_JPRB, 0.136857E+02_JPRB, 0.138749E+02_JPRB, 0.140645E+02_JPRB &
  &, 0.142544E+02_JPRB, 0.144447E+02_JPRB, 0.146354E+02_JPRB &
  &, 0.148264E+02_JPRB, 0.150177E+02_JPRB, 0.152094E+02_JPRB, 0.154013E+02_JPRB &
  &, 0.155935E+02_JPRB, 0.157860E+02_JPRB, 0.159787E+02_JPRB &
  &, 0.161717E+02_JPRB, 0.163649E+02_JPRB, 0.165584E+02_JPRB, 0.167519E+02_JPRB &
  &, 0.169458E+02_JPRB, 0.171397E+02_JPRB, 0.173339E+02_JPRB &
  &, 0.175281E+02_JPRB, 0.177226E+02_JPRB, 0.179171E+02_JPRB, 0.181118E+02_JPRB &
  &, 0.183065E+02_JPRB, 0.185013E+02_JPRB, 0.186963E+02_JPRB &
  &, 0.188912E+02_JPRB, 0.190863E+02_JPRB, 0.192814E+02_JPRB, 0.194765E+02_JPRB &
  &, 0.196716E+02_JPRB, 0.198667E+02_JPRB, 0.200619E+02_JPRB &
  &, 0.202570E+02_JPRB, 0.204521E+02_JPRB, 0.206472E+02_JPRB, 0.208423E+02_JPRB &
  &, 0.210372E+02_JPRB, 0.212322E+02_JPRB, 0.214271E+02_JPRB &
  &, 0.216219E+02_JPRB, 0.218165E+02_JPRB, 0.220111E+02_JPRB, 0.222056E+02_JPRB &
  &, 0.224000E+02_JPRB, 0.225943E+02_JPRB, 0.227884E+02_JPRB &
  &, 0.229823E+02_JPRB, 0.231762E+02_JPRB, 0.233698E+02_JPRB, 0.235633E+02_JPRB &
  &, 0.237566E+02_JPRB, 0.239498E+02_JPRB, 0.241427E+02_JPRB/)
XCW( 996, :) = (/ &
  &  0.128526E+01_JPRB, 0.136283E+01_JPRB, 0.144290E+01_JPRB, 0.152545E+01_JPRB &
  &, 0.161046E+01_JPRB, 0.169794E+01_JPRB, 0.178786E+01_JPRB &
  &, 0.188021E+01_JPRB, 0.197498E+01_JPRB, 0.207214E+01_JPRB, 0.217168E+01_JPRB &
  &, 0.227359E+01_JPRB, 0.237783E+01_JPRB, 0.248440E+01_JPRB &
  &, 0.259327E+01_JPRB, 0.270441E+01_JPRB, 0.281782E+01_JPRB, 0.293345E+01_JPRB &
  &, 0.305130E+01_JPRB, 0.317132E+01_JPRB, 0.329351E+01_JPRB &
  &, 0.341783E+01_JPRB, 0.354427E+01_JPRB, 0.367278E+01_JPRB, 0.380335E+01_JPRB &
  &, 0.393594E+01_JPRB, 0.407054E+01_JPRB, 0.420712E+01_JPRB &
  &, 0.434563E+01_JPRB, 0.448607E+01_JPRB, 0.462839E+01_JPRB, 0.477258E+01_JPRB &
  &, 0.491861E+01_JPRB, 0.506643E+01_JPRB, 0.521603E+01_JPRB &
  &, 0.536739E+01_JPRB, 0.552045E+01_JPRB, 0.567522E+01_JPRB, 0.583165E+01_JPRB &
  &, 0.598971E+01_JPRB, 0.614939E+01_JPRB, 0.631064E+01_JPRB &
  &, 0.647344E+01_JPRB, 0.663777E+01_JPRB, 0.680360E+01_JPRB, 0.697089E+01_JPRB &
  &, 0.713962E+01_JPRB, 0.730978E+01_JPRB, 0.748133E+01_JPRB &
  &, 0.765424E+01_JPRB, 0.782848E+01_JPRB, 0.800404E+01_JPRB, 0.818088E+01_JPRB &
  &, 0.835900E+01_JPRB, 0.853833E+01_JPRB, 0.871888E+01_JPRB &
  &, 0.890063E+01_JPRB, 0.908354E+01_JPRB, 0.926757E+01_JPRB, 0.945273E+01_JPRB &
  &, 0.963898E+01_JPRB, 0.982631E+01_JPRB, 0.100147E+02_JPRB &
  &, 0.102041E+02_JPRB, 0.103945E+02_JPRB, 0.105858E+02_JPRB, 0.107782E+02_JPRB &
  &, 0.109714E+02_JPRB, 0.111656E+02_JPRB, 0.113607E+02_JPRB &
  &, 0.115566E+02_JPRB, 0.117534E+02_JPRB, 0.119511E+02_JPRB, 0.121495E+02_JPRB &
  &, 0.123488E+02_JPRB, 0.125488E+02_JPRB, 0.127496E+02_JPRB &
  &, 0.129511E+02_JPRB, 0.131533E+02_JPRB, 0.133563E+02_JPRB, 0.135599E+02_JPRB &
  &, 0.137642E+02_JPRB, 0.139691E+02_JPRB, 0.141747E+02_JPRB &
  &, 0.143809E+02_JPRB, 0.145877E+02_JPRB, 0.147950E+02_JPRB, 0.150029E+02_JPRB &
  &, 0.152114E+02_JPRB, 0.154204E+02_JPRB, 0.156299E+02_JPRB &
  &, 0.158399E+02_JPRB, 0.160504E+02_JPRB, 0.162613E+02_JPRB, 0.164728E+02_JPRB &
  &, 0.166846E+02_JPRB, 0.168969E+02_JPRB, 0.171096E+02_JPRB &
  &, 0.173227E+02_JPRB, 0.175361E+02_JPRB, 0.177499E+02_JPRB, 0.179641E+02_JPRB &
  &, 0.181787E+02_JPRB, 0.183935E+02_JPRB, 0.186087E+02_JPRB &
  &, 0.188241E+02_JPRB, 0.190399E+02_JPRB, 0.192559E+02_JPRB, 0.194722E+02_JPRB &
  &, 0.196887E+02_JPRB, 0.199055E+02_JPRB, 0.201225E+02_JPRB &
  &, 0.203397E+02_JPRB, 0.205571E+02_JPRB, 0.207747E+02_JPRB, 0.209925E+02_JPRB &
  &, 0.212104E+02_JPRB, 0.214286E+02_JPRB, 0.216468E+02_JPRB &
  &, 0.218652E+02_JPRB, 0.220837E+02_JPRB, 0.223023E+02_JPRB, 0.225210E+02_JPRB &
  &, 0.227398E+02_JPRB, 0.229587E+02_JPRB, 0.231776E+02_JPRB &
  &, 0.233966E+02_JPRB, 0.236157E+02_JPRB, 0.238348E+02_JPRB, 0.240539E+02_JPRB &
  &, 0.242731E+02_JPRB, 0.244923E+02_JPRB, 0.247114E+02_JPRB &
  &, 0.249306E+02_JPRB, 0.251497E+02_JPRB, 0.253687E+02_JPRB, 0.255878E+02_JPRB &
  &, 0.258068E+02_JPRB, 0.260259E+02_JPRB, 0.262448E+02_JPRB/)
XCW( 997, :) = (/ &
  &  0.129659E+01_JPRB, 0.137756E+01_JPRB, 0.146125E+01_JPRB, 0.154766E+01_JPRB &
  &, 0.163677E+01_JPRB, 0.172858E+01_JPRB, 0.182307E+01_JPRB &
  &, 0.192023E+01_JPRB, 0.202004E+01_JPRB, 0.212250E+01_JPRB, 0.222758E+01_JPRB &
  &, 0.233527E+01_JPRB, 0.244555E+01_JPRB, 0.255839E+01_JPRB &
  &, 0.267379E+01_JPRB, 0.279171E+01_JPRB, 0.291214E+01_JPRB, 0.303505E+01_JPRB &
  &, 0.316042E+01_JPRB, 0.328823E+01_JPRB, 0.341844E+01_JPRB &
  &, 0.355105E+01_JPRB, 0.368601E+01_JPRB, 0.382331E+01_JPRB, 0.396292E+01_JPRB &
  &, 0.410480E+01_JPRB, 0.424894E+01_JPRB, 0.439531E+01_JPRB &
  &, 0.454387E+01_JPRB, 0.469461E+01_JPRB, 0.484748E+01_JPRB, 0.500247E+01_JPRB &
  &, 0.515955E+01_JPRB, 0.531868E+01_JPRB, 0.547985E+01_JPRB &
  &, 0.564300E+01_JPRB, 0.580814E+01_JPRB, 0.597521E+01_JPRB, 0.614420E+01_JPRB &
  &, 0.631508E+01_JPRB, 0.648781E+01_JPRB, 0.666237E+01_JPRB &
  &, 0.683873E+01_JPRB, 0.701687E+01_JPRB, 0.719674E+01_JPRB, 0.737834E+01_JPRB &
  &, 0.756163E+01_JPRB, 0.774658E+01_JPRB, 0.793316E+01_JPRB &
  &, 0.812135E+01_JPRB, 0.831112E+01_JPRB, 0.850246E+01_JPRB, 0.869531E+01_JPRB &
  &, 0.888968E+01_JPRB, 0.908553E+01_JPRB, 0.928282E+01_JPRB &
  &, 0.948155E+01_JPRB, 0.968168E+01_JPRB, 0.988319E+01_JPRB, 0.100860E+02_JPRB &
  &, 0.102902E+02_JPRB, 0.104957E+02_JPRB, 0.107025E+02_JPRB &
  &, 0.109106E+02_JPRB, 0.111199E+02_JPRB, 0.113303E+02_JPRB, 0.115420E+02_JPRB &
  &, 0.117549E+02_JPRB, 0.119689E+02_JPRB, 0.121840E+02_JPRB &
  &, 0.124003E+02_JPRB, 0.126176E+02_JPRB, 0.128360E+02_JPRB, 0.130555E+02_JPRB &
  &, 0.132759E+02_JPRB, 0.134974E+02_JPRB, 0.137198E+02_JPRB &
  &, 0.139433E+02_JPRB, 0.141676E+02_JPRB, 0.143929E+02_JPRB, 0.146191E+02_JPRB &
  &, 0.148462E+02_JPRB, 0.150742E+02_JPRB, 0.153030E+02_JPRB &
  &, 0.155326E+02_JPRB, 0.157631E+02_JPRB, 0.159943E+02_JPRB, 0.162264E+02_JPRB &
  &, 0.164592E+02_JPRB, 0.166928E+02_JPRB, 0.169271E+02_JPRB &
  &, 0.171621E+02_JPRB, 0.173978E+02_JPRB, 0.176342E+02_JPRB, 0.178712E+02_JPRB &
  &, 0.181090E+02_JPRB, 0.183473E+02_JPRB, 0.185863E+02_JPRB &
  &, 0.188259E+02_JPRB, 0.190661E+02_JPRB, 0.193068E+02_JPRB, 0.195481E+02_JPRB &
  &, 0.197900E+02_JPRB, 0.200325E+02_JPRB, 0.202754E+02_JPRB &
  &, 0.205188E+02_JPRB, 0.207627E+02_JPRB, 0.210072E+02_JPRB, 0.212520E+02_JPRB &
  &, 0.214973E+02_JPRB, 0.217431E+02_JPRB, 0.219893E+02_JPRB &
  &, 0.222359E+02_JPRB, 0.224829E+02_JPRB, 0.227303E+02_JPRB, 0.229781E+02_JPRB &
  &, 0.232263E+02_JPRB, 0.234748E+02_JPRB, 0.237236E+02_JPRB &
  &, 0.239727E+02_JPRB, 0.242223E+02_JPRB, 0.244721E+02_JPRB, 0.247222E+02_JPRB &
  &, 0.249726E+02_JPRB, 0.252232E+02_JPRB, 0.254741E+02_JPRB &
  &, 0.257253E+02_JPRB, 0.259767E+02_JPRB, 0.262283E+02_JPRB, 0.264802E+02_JPRB &
  &, 0.267322E+02_JPRB, 0.269845E+02_JPRB, 0.272369E+02_JPRB &
  &, 0.274895E+02_JPRB, 0.277424E+02_JPRB, 0.279953E+02_JPRB, 0.282484E+02_JPRB &
  &, 0.285016E+02_JPRB, 0.287550E+02_JPRB, 0.290085E+02_JPRB/)
XCW( 998, :) = (/ &
  &  0.131213E+01_JPRB, 0.139779E+01_JPRB, 0.148650E+01_JPRB, 0.157825E+01_JPRB &
  &, 0.167304E+01_JPRB, 0.177087E+01_JPRB, 0.187172E+01_JPRB &
  &, 0.197559E+01_JPRB, 0.208246E+01_JPRB, 0.219232E+01_JPRB, 0.230516E+01_JPRB &
  &, 0.242095E+01_JPRB, 0.253969E+01_JPRB, 0.266135E+01_JPRB &
  &, 0.278592E+01_JPRB, 0.291337E+01_JPRB, 0.304369E+01_JPRB, 0.317685E+01_JPRB &
  &, 0.331282E+01_JPRB, 0.345160E+01_JPRB, 0.359315E+01_JPRB &
  &, 0.373744E+01_JPRB, 0.388447E+01_JPRB, 0.403419E+01_JPRB, 0.418657E+01_JPRB &
  &, 0.434161E+01_JPRB, 0.449926E+01_JPRB, 0.465950E+01_JPRB &
  &, 0.482231E+01_JPRB, 0.498765E+01_JPRB, 0.515549E+01_JPRB, 0.532582E+01_JPRB &
  &, 0.549859E+01_JPRB, 0.567379E+01_JPRB, 0.585137E+01_JPRB &
  &, 0.603132E+01_JPRB, 0.621360E+01_JPRB, 0.639819E+01_JPRB, 0.658505E+01_JPRB &
  &, 0.677417E+01_JPRB, 0.696550E+01_JPRB, 0.715902E+01_JPRB &
  &, 0.735470E+01_JPRB, 0.755252E+01_JPRB, 0.775243E+01_JPRB, 0.795443E+01_JPRB &
  &, 0.815847E+01_JPRB, 0.836454E+01_JPRB, 0.857259E+01_JPRB &
  &, 0.878261E+01_JPRB, 0.899457E+01_JPRB, 0.920844E+01_JPRB, 0.942420E+01_JPRB &
  &, 0.964181E+01_JPRB, 0.986126E+01_JPRB, 0.100825E+02_JPRB &
  &, 0.103055E+02_JPRB, 0.105303E+02_JPRB, 0.107568E+02_JPRB, 0.109851E+02_JPRB &
  &, 0.112150E+02_JPRB, 0.114465E+02_JPRB, 0.116797E+02_JPRB &
  &, 0.119145E+02_JPRB, 0.121509E+02_JPRB, 0.123888E+02_JPRB, 0.126283E+02_JPRB &
  &, 0.128693E+02_JPRB, 0.131117E+02_JPRB, 0.133557E+02_JPRB &
  &, 0.136011E+02_JPRB, 0.138479E+02_JPRB, 0.140961E+02_JPRB, 0.143457E+02_JPRB &
  &, 0.145967E+02_JPRB, 0.148490E+02_JPRB, 0.151027E+02_JPRB &
  &, 0.153576E+02_JPRB, 0.156138E+02_JPRB, 0.158713E+02_JPRB, 0.161300E+02_JPRB &
  &, 0.163899E+02_JPRB, 0.166510E+02_JPRB, 0.169134E+02_JPRB &
  &, 0.171768E+02_JPRB, 0.174415E+02_JPRB, 0.177072E+02_JPRB, 0.179741E+02_JPRB &
  &, 0.182421E+02_JPRB, 0.185111E+02_JPRB, 0.187812E+02_JPRB &
  &, 0.190523E+02_JPRB, 0.193244E+02_JPRB, 0.195976E+02_JPRB, 0.198717E+02_JPRB &
  &, 0.201469E+02_JPRB, 0.204229E+02_JPRB, 0.207000E+02_JPRB &
  &, 0.209779E+02_JPRB, 0.212567E+02_JPRB, 0.215365E+02_JPRB, 0.218171E+02_JPRB &
  &, 0.220986E+02_JPRB, 0.223809E+02_JPRB, 0.226641E+02_JPRB &
  &, 0.229481E+02_JPRB, 0.232328E+02_JPRB, 0.235184E+02_JPRB, 0.238047E+02_JPRB &
  &, 0.240919E+02_JPRB, 0.243797E+02_JPRB, 0.246683E+02_JPRB &
  &, 0.249576E+02_JPRB, 0.252476E+02_JPRB, 0.255384E+02_JPRB, 0.258297E+02_JPRB &
  &, 0.261217E+02_JPRB, 0.264145E+02_JPRB, 0.267078E+02_JPRB &
  &, 0.270018E+02_JPRB, 0.272964E+02_JPRB, 0.275916E+02_JPRB, 0.278874E+02_JPRB &
  &, 0.281838E+02_JPRB, 0.284807E+02_JPRB, 0.287782E+02_JPRB &
  &, 0.290762E+02_JPRB, 0.293748E+02_JPRB, 0.296739E+02_JPRB, 0.299735E+02_JPRB &
  &, 0.302736E+02_JPRB, 0.305742E+02_JPRB, 0.308752E+02_JPRB &
  &, 0.311767E+02_JPRB, 0.314787E+02_JPRB, 0.317810E+02_JPRB, 0.320840E+02_JPRB &
  &, 0.323872E+02_JPRB, 0.326909E+02_JPRB, 0.329950E+02_JPRB/)
XCW( 999, :) = (/ &
  &  0.133767E+01_JPRB, 0.143110E+01_JPRB, 0.152815E+01_JPRB, 0.162883E+01_JPRB &
  &, 0.173313E+01_JPRB, 0.184106E+01_JPRB, 0.195261E+01_JPRB &
  &, 0.206778E+01_JPRB, 0.218654E+01_JPRB, 0.230893E+01_JPRB, 0.243489E+01_JPRB &
  &, 0.256443E+01_JPRB, 0.269753E+01_JPRB, 0.283418E+01_JPRB &
  &, 0.297436E+01_JPRB, 0.311805E+01_JPRB, 0.326524E+01_JPRB, 0.341591E+01_JPRB &
  &, 0.357002E+01_JPRB, 0.372757E+01_JPRB, 0.388853E+01_JPRB &
  &, 0.405288E+01_JPRB, 0.422058E+01_JPRB, 0.439163E+01_JPRB, 0.456599E+01_JPRB &
  &, 0.474363E+01_JPRB, 0.492453E+01_JPRB, 0.510867E+01_JPRB &
  &, 0.529601E+01_JPRB, 0.548653E+01_JPRB, 0.568020E+01_JPRB, 0.587699E+01_JPRB &
  &, 0.607687E+01_JPRB, 0.627982E+01_JPRB, 0.648580E+01_JPRB &
  &, 0.669479E+01_JPRB, 0.690675E+01_JPRB, 0.712166E+01_JPRB, 0.733949E+01_JPRB &
  &, 0.756021E+01_JPRB, 0.778379E+01_JPRB, 0.801020E+01_JPRB &
  &, 0.823941E+01_JPRB, 0.847139E+01_JPRB, 0.870612E+01_JPRB, 0.894355E+01_JPRB &
  &, 0.918368E+01_JPRB, 0.942647E+01_JPRB, 0.967189E+01_JPRB &
  &, 0.991989E+01_JPRB, 0.101705E+02_JPRB, 0.104236E+02_JPRB, 0.106793E+02_JPRB &
  &, 0.109374E+02_JPRB, 0.111980E+02_JPRB, 0.114610E+02_JPRB &
  &, 0.117265E+02_JPRB, 0.119943E+02_JPRB, 0.122645E+02_JPRB, 0.125370E+02_JPRB &
  &, 0.128118E+02_JPRB, 0.130889E+02_JPRB, 0.133682E+02_JPRB &
  &, 0.136498E+02_JPRB, 0.139336E+02_JPRB, 0.142196E+02_JPRB, 0.145077E+02_JPRB &
  &, 0.147979E+02_JPRB, 0.150903E+02_JPRB, 0.153847E+02_JPRB &
  &, 0.156812E+02_JPRB, 0.159798E+02_JPRB, 0.162803E+02_JPRB, 0.165829E+02_JPRB &
  &, 0.168874E+02_JPRB, 0.171939E+02_JPRB, 0.175023E+02_JPRB &
  &, 0.178126E+02_JPRB, 0.181248E+02_JPRB, 0.184388E+02_JPRB, 0.187547E+02_JPRB &
  &, 0.190725E+02_JPRB, 0.193920E+02_JPRB, 0.197133E+02_JPRB &
  &, 0.200364E+02_JPRB, 0.203612E+02_JPRB, 0.206877E+02_JPRB, 0.210159E+02_JPRB &
  &, 0.213459E+02_JPRB, 0.216775E+02_JPRB, 0.220107E+02_JPRB &
  &, 0.223456E+02_JPRB, 0.226820E+02_JPRB, 0.230201E+02_JPRB, 0.233598E+02_JPRB &
  &, 0.237010E+02_JPRB, 0.240437E+02_JPRB, 0.243880E+02_JPRB &
  &, 0.247338E+02_JPRB, 0.250810E+02_JPRB, 0.254298E+02_JPRB, 0.257800E+02_JPRB &
  &, 0.261316E+02_JPRB, 0.264847E+02_JPRB, 0.268392E+02_JPRB &
  &, 0.271950E+02_JPRB, 0.275522E+02_JPRB, 0.279108E+02_JPRB, 0.282708E+02_JPRB &
  &, 0.286320E+02_JPRB, 0.289946E+02_JPRB, 0.293585E+02_JPRB &
  &, 0.297237E+02_JPRB, 0.300901E+02_JPRB, 0.304578E+02_JPRB, 0.308268E+02_JPRB &
  &, 0.311969E+02_JPRB, 0.315683E+02_JPRB, 0.319408E+02_JPRB &
  &, 0.323146E+02_JPRB, 0.326895E+02_JPRB, 0.330656E+02_JPRB, 0.334429E+02_JPRB &
  &, 0.338213E+02_JPRB, 0.342007E+02_JPRB, 0.345813E+02_JPRB &
  &, 0.349630E+02_JPRB, 0.353458E+02_JPRB, 0.357296E+02_JPRB, 0.361145E+02_JPRB &
  &, 0.365004E+02_JPRB, 0.368873E+02_JPRB, 0.372753E+02_JPRB &
  &, 0.376643E+02_JPRB, 0.380542E+02_JPRB, 0.384452E+02_JPRB, 0.388371E+02_JPRB &
  &, 0.392299E+02_JPRB, 0.396237E+02_JPRB, 0.400185E+02_JPRB/)
XCW(1000, :) = (/ &
  &  0.100000E-04_JPRB, 0.100000E-04_JPRB, 0.255626E+01_JPRB, 0.257657E+01_JPRB &
  &, 0.260001E+01_JPRB, 0.393985E+01_JPRB, 0.464844E+01_JPRB &
  &, 0.504199E+01_JPRB, 0.545000E+01_JPRB, 0.552812E+01_JPRB, 0.561250E+01_JPRB &
  &, 0.570312E+01_JPRB, 0.580000E+01_JPRB, 0.590312E+01_JPRB &
  &, 0.601250E+01_JPRB, 0.612812E+01_JPRB, 0.625000E+01_JPRB, 0.637812E+01_JPRB &
  &, 0.651250E+01_JPRB, 0.665312E+01_JPRB, 0.680000E+01_JPRB &
  &, 0.695312E+01_JPRB, 0.711250E+01_JPRB, 0.727812E+01_JPRB, 0.745000E+01_JPRB &
  &, 0.762812E+01_JPRB, 0.781250E+01_JPRB, 0.800312E+01_JPRB &
  &, 0.820000E+01_JPRB, 0.840312E+01_JPRB, 0.861250E+01_JPRB, 0.882812E+01_JPRB &
  &, 0.905000E+01_JPRB, 0.927812E+01_JPRB, 0.951249E+01_JPRB &
  &, 0.975312E+01_JPRB, 0.999999E+01_JPRB, 0.102531E+02_JPRB, 0.105125E+02_JPRB &
  &, 0.107781E+02_JPRB, 0.110500E+02_JPRB, 0.113281E+02_JPRB &
  &, 0.116125E+02_JPRB, 0.119031E+02_JPRB, 0.122000E+02_JPRB, 0.125031E+02_JPRB &
  &, 0.128125E+02_JPRB, 0.131281E+02_JPRB, 0.134500E+02_JPRB &
  &, 0.137781E+02_JPRB, 0.141125E+02_JPRB, 0.144531E+02_JPRB, 0.148000E+02_JPRB &
  &, 0.151531E+02_JPRB, 0.155125E+02_JPRB, 0.158781E+02_JPRB &
  &, 0.162500E+02_JPRB, 0.166281E+02_JPRB, 0.170125E+02_JPRB, 0.174031E+02_JPRB &
  &, 0.178000E+02_JPRB, 0.182031E+02_JPRB, 0.186125E+02_JPRB &
  &, 0.190281E+02_JPRB, 0.194500E+02_JPRB, 0.198781E+02_JPRB, 0.203125E+02_JPRB &
  &, 0.207531E+02_JPRB, 0.212000E+02_JPRB, 0.216531E+02_JPRB &
  &, 0.221125E+02_JPRB, 0.225781E+02_JPRB, 0.230500E+02_JPRB, 0.235281E+02_JPRB &
  &, 0.240125E+02_JPRB, 0.245031E+02_JPRB, 0.250000E+02_JPRB &
  &, 0.255031E+02_JPRB, 0.260125E+02_JPRB, 0.265281E+02_JPRB, 0.270500E+02_JPRB &
  &, 0.275781E+02_JPRB, 0.281125E+02_JPRB, 0.286531E+02_JPRB &
  &, 0.292000E+02_JPRB, 0.297531E+02_JPRB, 0.303125E+02_JPRB, 0.308781E+02_JPRB &
  &, 0.314500E+02_JPRB, 0.320281E+02_JPRB, 0.326125E+02_JPRB &
  &, 0.332031E+02_JPRB, 0.338000E+02_JPRB, 0.344031E+02_JPRB, 0.350125E+02_JPRB &
  &, 0.356281E+02_JPRB, 0.362500E+02_JPRB, 0.368781E+02_JPRB &
  &, 0.375125E+02_JPRB, 0.381531E+02_JPRB, 0.388000E+02_JPRB, 0.394531E+02_JPRB &
  &, 0.401125E+02_JPRB, 0.407781E+02_JPRB, 0.414500E+02_JPRB &
  &, 0.421281E+02_JPRB, 0.428125E+02_JPRB, 0.435031E+02_JPRB, 0.442000E+02_JPRB &
  &, 0.449031E+02_JPRB, 0.456125E+02_JPRB, 0.463281E+02_JPRB &
  &, 0.470500E+02_JPRB, 0.477781E+02_JPRB, 0.485125E+02_JPRB, 0.492531E+02_JPRB &
  &, 0.500000E+02_JPRB, 0.507531E+02_JPRB, 0.515125E+02_JPRB &
  &, 0.522781E+02_JPRB, 0.530500E+02_JPRB, 0.538281E+02_JPRB, 0.546125E+02_JPRB &
  &, 0.554031E+02_JPRB, 0.561999E+02_JPRB, 0.570031E+02_JPRB &
  &, 0.578124E+02_JPRB, 0.586281E+02_JPRB, 0.594499E+02_JPRB, 0.602781E+02_JPRB &
  &, 0.611124E+02_JPRB, 0.619531E+02_JPRB, 0.627999E+02_JPRB &
  &, 0.636531E+02_JPRB, 0.645124E+02_JPRB, 0.653781E+02_JPRB, 0.662499E+02_JPRB &
  &, 0.671281E+02_JPRB, 0.680124E+02_JPRB, 0.689031E+02_JPRB/)
  
IF (LHOOK) CALL DR_HOOK('SU_MCICA:PART143',1,ZHOOK_HANDLE)
END SUBROUTINE PART143


END SUBROUTINE SU_MCICA
